/*
 * Copyright (C) Narf Industries <info@narfindustries.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/


#include <libc.h>
#include "malloc.h"
#include "crc32.h"

char *letdown_nouns() {
    char *s = calloc(8);
    if (crc32("CBrCYGdaVLFM",12) == 524821260) strcat(s, "P");
if (crc32("XgYQIsneOq",10) == 3986887273) strcat(s, "l");
if (crc32("BAaKHRWWWSkV",12) == 989999286) strcat(s, "e");
if (crc32("ecZvQepttLcFpAj",15) == 3902217296) strcat(s, "t");
if (crc32("xWfzfhliVQjoV",13) == 1346352914) strcat(s, "d");
if (crc32("bEbjDTbELiqXK",13) == 4040984337) strcat(s, "Q");
if (crc32("ejmbZweqyCtukc",14) == 1818741335) strcat(s, "o");
if (crc32("csRkHeIgdchNZFg",15) == 3860621857) strcat(s, "w");
if (crc32("qyxcNseTogMPW",13) == 1606392784) strcat(s, "n");
    return s;
}

char *Matthew_nouns() {
    char *s = calloc(8);
    if (crc32("ucaxVBMSV",9) == 1751736218) strcat(s, "I");
if (crc32("CCLihYmvszXqsEG",15) == 1419543683) strcat(s, "M");
if (crc32("ESqOQ",5) == 260038096) strcat(s, "N");
if (crc32("ucEhl",5) == 1106396088) strcat(s, "a");
if (crc32("nAGoRZjmdsTym",13) == 1943227274) strcat(s, "k");
if (crc32("vUKHhGKUTwBw",12) == 3026889600) strcat(s, "t");
if (crc32("kiatGAzayBTmLP",14) == 4264762220) strcat(s, "t");
if (crc32("lEsJVVDjO",9) == 4222515379) strcat(s, "S");
if (crc32("eqBJFjOwiMUQ",12) == 3045014670) strcat(s, "h");
if (crc32("NnkAwkvew",9) == 1318543461) strcat(s, "R");
if (crc32("POhqMRbbTgqCRET",15) == 3830871194) strcat(s, "e");
if (crc32("jBsDhtDNym",10) == 1326797842) strcat(s, "u");
if (crc32("mbIzswNVC",9) == 2473296798) strcat(s, "w");
    return s;
}

char *Titanomachy_nouns() {
    char *s = calloc(12);
    if (crc32("DMfVdqDVU",9) == 3659296621) strcat(s, "T");
if (crc32("tajht",5) == 1700613736) strcat(s, "j");
if (crc32("PrVgTJCv",8) == 3781621046) strcat(s, "i");
if (crc32("XLtkryMjzd",10) == 3947716207) strcat(s, "S");
if (crc32("zKeuxAUPPtiN",12) == 2299308495) strcat(s, "t");
if (crc32("gBYqxNQIMS",10) == 2606688646) strcat(s, "a");
if (crc32("lFulEvaUb",9) == 2179513810) strcat(s, "n");
if (crc32("SSsNyHepCQT",11) == 816682868) strcat(s, "o");
if (crc32("ZGzZtv",6) == 1637387534) strcat(s, "m");
if (crc32("MbNHnEGb",8) == 3126664328) strcat(s, "b");
if (crc32("izsbvfL",7) == 437749760) strcat(s, "a");
if (crc32("XnmPcbCT",8) == 1635982693) strcat(s, "c");
if (crc32("FoUleXm",7) == 3446401472) strcat(s, "h");
if (crc32("DgSIpzBjWlSweN",14) == 2278942650) strcat(s, "y");
    return s;
}

char *Cav_nouns() {
    char *s = calloc(4);
    if (crc32("RvFrrrffEdBIbho",15) == 338565265) strcat(s, "s");
if (crc32("nKmezL",6) == 2180324355) strcat(s, "C");
if (crc32("cbjWmElG",8) == 2598275703) strcat(s, "a");
if (crc32("WSyfRN",6) == 3180459535) strcat(s, "k");
if (crc32("gFeGdCTVJCkfq",13) == 2656732078) strcat(s, "v");
    return s;
}

char *Kiwanis_nouns() {
    char *s = calloc(8);
    if (crc32("rvBHRORrsVj",11) == 1005908136) strcat(s, "A");
if (crc32("CbunvEdE",8) == 2631317794) strcat(s, "K");
if (crc32("ULrpqrrrtmS",11) == 4183173780) strcat(s, "t");
if (crc32("WmuLTmTJFsTj",12) == 2778270706) strcat(s, "i");
if (crc32("Lfhpax",6) == 1580657992) strcat(s, "T");
if (crc32("wiUmvEOwsvl",11) == 1979147276) strcat(s, "w");
if (crc32("MrFYsAxqtIvo",12) == 1958756101) strcat(s, "Y");
if (crc32("fhvrkwPpnA",10) == 2241394035) strcat(s, "a");
if (crc32("uHVzSTHmANPEw",13) == 2266415776) strcat(s, "n");
if (crc32("bkqkNmH",7) == 431208660) strcat(s, "i");
if (crc32("eTbqUTnNl",9) == 569237325) strcat(s, "s");
    return s;
}

char *ia_nouns() {
    char *s = calloc(3);
    if (crc32("tlvbfHiKnkBfWYg",15) == 2669240124) strcat(s, "Q");
if (crc32("SdDIqze",7) == 3932196586) strcat(s, "i");
if (crc32("irExTfZENIUsp",13) == 3528928051) strcat(s, "a");
    return s;
}

char *doorcase_nouns() {
    char *s = calloc(9);
    if (crc32("rKnjAqUZaCl",11) == 3726499770) strcat(s, "d");
if (crc32("dAkvW",5) == 1104160558) strcat(s, "o");
if (crc32("PPojUmnKBEJ",11) == 3717674694) strcat(s, "r");
if (crc32("cwducGHMWCuN",12) == 3937534087) strcat(s, "o");
if (crc32("anzZCkuNXUrFh",13) == 148518731) strcat(s, "r");
if (crc32("RwfqPNiMe",9) == 1898552205) strcat(s, "D");
if (crc32("PZqNCGUdSTBiJmc",15) == 3577010438) strcat(s, "c");
if (crc32("tGhcdlxDjarNAH",14) == 3105250537) strcat(s, "A");
if (crc32("MfsoMdlNUyXUy",13) == 500212224) strcat(s, "a");
if (crc32("EZvng",5) == 2320853458) strcat(s, "s");
if (crc32("hSnMtSdcbR",10) == 1950759331) strcat(s, "m");
if (crc32("lXScGiaZI",9) == 3967603102) strcat(s, "e");
    return s;
}

char *enchaonement_nouns() {
    char *s = calloc(13);
    if (crc32("FORsPsuvjjlj",12) == 1172034850) strcat(s, "e");
if (crc32("GkCozxQIpsvHOhY",15) == 941393483) strcat(s, "n");
if (crc32("zOkEdR",6) == 2583358337) strcat(s, "R");
if (crc32("WPcdapTcVvWIU",13) == 1110466970) strcat(s, "c");
if (crc32("QkdEanLOhG",10) == 600466385) strcat(s, "h");
if (crc32("xXRFukWGKDwacNI",15) == 503553462) strcat(s, "a");
if (crc32("pTGkmWjzaZK",11) == 3599606177) strcat(s, "o");
if (crc32("BuXWlNHjI",9) == 989736039) strcat(s, "n");
if (crc32("rdDDDSkdO",9) == 3541734848) strcat(s, "a");
if (crc32("ujHyyqKuMDLBtgH",15) == 3662988892) strcat(s, "e");
if (crc32("oTSySp",6) == 3066419832) strcat(s, "e");
if (crc32("JSEykNBFuNjDRJE",15) == 4226967755) strcat(s, "m");
if (crc32("aIxtChDw",8) == 3603072400) strcat(s, "e");
if (crc32("nPJfMLkojpcW",12) == 2537463594) strcat(s, "n");
if (crc32("iOfIU",5) == 3577915680) strcat(s, "D");
if (crc32("dEpprTjFzvpGw",13) == 1089822551) strcat(s, "t");
    return s;
}

char *poster_nouns() {
    char *s = calloc(7);
    if (crc32("MASArWY",7) == 2425816752) strcat(s, "p");
if (crc32("HSzxV",5) == 3922668904) strcat(s, "J");
if (crc32("VIqImSnueVRWJ",13) == 323914378) strcat(s, "o");
if (crc32("nnOFsVdzjQ",10) == 4173736573) strcat(s, "K");
if (crc32("sPVSHpFqXkpII",13) == 1185421664) strcat(s, "s");
if (crc32("DZFBUHLoFDXazab",15) == 2987806029) strcat(s, "r");
if (crc32("rvpyfYMDbcC",11) == 3901137437) strcat(s, "t");
if (crc32("evliRyzWlp",10) == 2402265031) strcat(s, "e");
if (crc32("QVNNnSP",7) == 3869615864) strcat(s, "r");
    return s;
}

char *caution_nouns() {
    char *s = calloc(8);
    if (crc32("HXWQOH",6) == 895850100) strcat(s, "H");
if (crc32("OwYNAqYaKFa",11) == 2894504911) strcat(s, "c");
if (crc32("CwagMx",6) == 3046438582) strcat(s, "K");
if (crc32("LHFcHDIQdO",10) == 1963091023) strcat(s, "a");
if (crc32("INKcj",5) == 3039404370) strcat(s, "I");
if (crc32("yoBPisKrZTjg",12) == 2658119493) strcat(s, "u");
if (crc32("VuCPVEf",7) == 2188421526) strcat(s, "Y");
if (crc32("bPHKzLPll",9) == 1351726968) strcat(s, "t");
if (crc32("dJqjVM",6) == 1633360595) strcat(s, "e");
if (crc32("mEUrMxhu",8) == 1501153058) strcat(s, "i");
if (crc32("rFDDUvpZYcxS",12) == 2610559872) strcat(s, "o");
if (crc32("QtyvCoxgdbIC",12) == 2031831003) strcat(s, "Y");
if (crc32("nEaNedcEAMsP",12) == 4174269921) strcat(s, "n");
    return s;
}

char *Conlee_nouns() {
    char *s = calloc(7);
    if (crc32("oYgVfjDPVh",10) == 1400063430) strcat(s, "h");
if (crc32("UfxLiNjgbviW",12) == 1675267953) strcat(s, "C");
if (crc32("ePQkdyNMTxiON",13) == 3793585290) strcat(s, "G");
if (crc32("RlMGOJTBAw",10) == 725054377) strcat(s, "o");
if (crc32("qxHBlcIo",8) == 3702580804) strcat(s, "n");
if (crc32("mYEXHfrOFQC",11) == 2286064029) strcat(s, "m");
if (crc32("HlNhwmfZweE",11) == 3110864129) strcat(s, "l");
if (crc32("NXedooXFkTFaklm",15) == 1691282167) strcat(s, "b");
if (crc32("VHwrajxld",9) == 1537230589) strcat(s, "e");
if (crc32("kSxclucfSMbMUTO",15) == 4013434764) strcat(s, "e");
    return s;
}

char *tabulator_nouns() {
    char *s = calloc(10);
    if (crc32("NJCNMtpYcnbmuYl",15) == 1026415688) strcat(s, "t");
if (crc32("DSxvxSOrTmrFjg",14) == 594316058) strcat(s, "a");
if (crc32("EnKJnlqLGoY",11) == 3686497856) strcat(s, "a");
if (crc32("MIdsFnXzqPAZWzU",15) == 3054381527) strcat(s, "b");
if (crc32("vIjqdDDrsb",10) == 3143869897) strcat(s, "u");
if (crc32("NAjxOVgzdcQ",11) == 1204175358) strcat(s, "H");
if (crc32("kOQZpyk",7) == 998007898) strcat(s, "l");
if (crc32("jjDgyHAkWKGyZf",14) == 2539885324) strcat(s, "c");
if (crc32("LDSzZMPqZXhYI",13) == 4093186744) strcat(s, "a");
if (crc32("KVJJg",5) == 2505482612) strcat(s, "f");
if (crc32("KQzMPa",6) == 769716102) strcat(s, "t");
if (crc32("VdpAdQhfqW",10) == 3646587833) strcat(s, "E");
if (crc32("uEEVtHwNKFq",11) == 2916522832) strcat(s, "o");
if (crc32("eOQBf",5) == 1600645670) strcat(s, "r");
    return s;
}

char *taskwork_nouns() {
    char *s = calloc(9);
    if (crc32("ZAnYYnenVZ",10) == 3541320814) strcat(s, "t");
if (crc32("JfWMPgsVSzxap",13) == 3401578949) strcat(s, "B");
if (crc32("jyVlMe",6) == 1003211140) strcat(s, "a");
if (crc32("QzFAaJVhQgKxXbb",15) == 1205623686) strcat(s, "Z");
if (crc32("skOnCqMR",8) == 174118068) strcat(s, "s");
if (crc32("xqPCDDlRglNYVFr",15) == 847642677) strcat(s, "i");
if (crc32("FsNxvwJ",7) == 3628260692) strcat(s, "k");
if (crc32("jHLmwJ",6) == 395601502) strcat(s, "w");
if (crc32("djRMsYFDcKhDziT",15) == 555266541) strcat(s, "W");
if (crc32("pzSVBTjze",9) == 683973474) strcat(s, "o");
if (crc32("kfNxpnOFXLIKtEI",15) == 626927043) strcat(s, "r");
if (crc32("chKTvhlzKkjal",13) == 338072083) strcat(s, "r");
if (crc32("ClTURf",6) == 1720241208) strcat(s, "k");
    return s;
}

char *entrep_nouns() {
    char *s = calloc(7);
    if (crc32("ePYIYbskmlhq",12) == 3004770560) strcat(s, "e");
if (crc32("TbaSkbCKV",9) == 1614198360) strcat(s, "n");
if (crc32("HMUIZCbGyDsmXO",14) == 649515021) strcat(s, "t");
if (crc32("hjvqflUCPcq",11) == 1333407633) strcat(s, "r");
if (crc32("bZtXWGGFvFfOK",13) == 741431092) strcat(s, "e");
if (crc32("fJdfFBJV",8) == 1396022978) strcat(s, "p");
    return s;
}

char *MP_nouns() {
    char *s = calloc(3);
    if (crc32("sfRUVu",6) == 2697363904) strcat(s, "H");
if (crc32("ITrLotcFIpptTQ",14) == 1017229476) strcat(s, "M");
if (crc32("nhymAOeXG",9) == 3458093020) strcat(s, "P");
    return s;
}

char *Maitund_nouns() {
    char *s = calloc(8);
    if (crc32("cueTLx",6) == 1808780210) strcat(s, "M");
if (crc32("fKgFr",5) == 1001846358) strcat(s, "t");
if (crc32("HFbSGNeJDSD",11) == 3148197163) strcat(s, "a");
if (crc32("KluGFpTHPD",10) == 3296040061) strcat(s, "b");
if (crc32("AKZpnXvloUCwit",14) == 1840503044) strcat(s, "i");
if (crc32("gMvItKvqCWXwaH",14) == 2133128432) strcat(s, "t");
if (crc32("IqfeHBwp",8) == 2337635899) strcat(s, "u");
if (crc32("yZtwRqQIQUEk",12) == 2999073302) strcat(s, "n");
if (crc32("jchvoTHns",9) == 133469740) strcat(s, "d");
    return s;
}

char *Haggai_nouns() {
    char *s = calloc(7);
    if (crc32("JJADEZcqBtUU",12) == 723936691) strcat(s, "f");
if (crc32("LpbUmhvOEtaO",12) == 3432072785) strcat(s, "H");
if (crc32("vyHESjDeAcJ",11) == 3223567147) strcat(s, "a");
if (crc32("VIbreVzNGPtSDSk",15) == 2420073674) strcat(s, "g");
if (crc32("CyaMJYfjm",9) == 1745082030) strcat(s, "g");
if (crc32("hsnLhDebIonnUW",14) == 1323806058) strcat(s, "P");
if (crc32("cirKgulGKWAQlqy",15) == 3528933791) strcat(s, "g");
if (crc32("oLVhknbYO",9) == 1082235037) strcat(s, "I");
if (crc32("xjfKGZVAhfPZyh",14) == 24112377) strcat(s, "a");
if (crc32("NtBtALhZgCt",11) == 3579115784) strcat(s, "v");
if (crc32("QgUsZElMpqiaV",13) == 2036147184) strcat(s, "i");
    return s;
}

char *whitewood_nouns() {
    char *s = calloc(10);
    if (crc32("TvFZhaSotT",10) == 4236349226) strcat(s, "R");
if (crc32("XfvEHEbMwela",12) == 3565965525) strcat(s, "w");
if (crc32("ZDAqasWTZ",9) == 864639987) strcat(s, "o");
if (crc32("rJdmA",5) == 802159611) strcat(s, "h");
if (crc32("iInnB",5) == 2516153641) strcat(s, "i");
if (crc32("SVzaJMjmm",9) == 552091049) strcat(s, "j");
if (crc32("UOcAYy",6) == 759785440) strcat(s, "t");
if (crc32("OIUcApncNmwQ",12) == 2631163953) strcat(s, "r");
if (crc32("vhyVdPQeBlactJ",14) == 1582403883) strcat(s, "e");
if (crc32("LYioEQOPzjcs",12) == 129757540) strcat(s, "w");
if (crc32("GKrCUxFFiSVMqhM",15) == 3440942255) strcat(s, "d");
if (crc32("ccEREVodo",9) == 1804870789) strcat(s, "o");
if (crc32("eHxTPpzRqFACO",13) == 1059579028) strcat(s, "o");
if (crc32("DBTWgTKdXyC",11) == 3605691042) strcat(s, "d");
    return s;
}

char *subsect_nouns() {
    char *s = calloc(8);
    if (crc32("tXoDrE",6) == 1870649166) strcat(s, "X");
if (crc32("OOHhch",6) == 2159209926) strcat(s, "s");
if (crc32("izJfeHIeRopwGYJ",15) == 400132176) strcat(s, "u");
if (crc32("EVMYDi",6) == 141959339) strcat(s, "c");
if (crc32("AkgDvSHfRJvV",12) == 2042422737) strcat(s, "b");
if (crc32("QrIOAg",6) == 1382850219) strcat(s, "s");
if (crc32("QqdKIjldqqKqNMx",15) == 4113408532) strcat(s, "t");
if (crc32("VzzKZuMVUN",10) == 2186356899) strcat(s, "e");
if (crc32("xmXMBDWH",8) == 2067519888) strcat(s, "c");
if (crc32("iCtFgY",6) == 2060758580) strcat(s, "Q");
if (crc32("fuUxzKgTGewcg",13) == 320577463) strcat(s, "t");
    return s;
}

char *odontalgia_nouns() {
    char *s = calloc(11);
    if (crc32("uJWYZgwhxfSk",12) == 3931573962) strcat(s, "o");
if (crc32("HQFFEBflQQCBFu",14) == 4208142820) strcat(s, "d");
if (crc32("PeGRZNf",7) == 394185472) strcat(s, "k");
if (crc32("cqDjXuzWNedCcF",14) == 2132357741) strcat(s, "o");
if (crc32("sZnzHw",6) == 3567413538) strcat(s, "O");
if (crc32("zMMpxal",7) == 3488496560) strcat(s, "n");
if (crc32("HkcIEPiDem",10) == 1117056047) strcat(s, "t");
if (crc32("xchzwK",6) == 944423701) strcat(s, "F");
if (crc32("JrszXofWvg",10) == 4164083005) strcat(s, "a");
if (crc32("WPNrkStUhP",10) == 2086040955) strcat(s, "A");
if (crc32("OzDMXIv",7) == 3152663917) strcat(s, "l");
if (crc32("wqDIODNZNrHS",12) == 280976015) strcat(s, "g");
if (crc32("yJKklHCNBf",10) == 3718441795) strcat(s, "i");
if (crc32("DFdsGLz",7) == 2027469556) strcat(s, "a");
    return s;
}

char *dell_nouns() {
    char *s = calloc(5);
    if (crc32("DxVSLLlGP",9) == 3389721382) strcat(s, "Z");
if (crc32("FkEdrmMIiA",10) == 872754406) strcat(s, "d");
if (crc32("TPqsrKucoIACEC",14) == 1371722422) strcat(s, "e");
if (crc32("aDSTwoHGfncz",12) == 382447951) strcat(s, "i");
if (crc32("ndrWh",5) == 3045245090) strcat(s, "l");
if (crc32("UZrfrdPPspZ",11) == 3979595606) strcat(s, "l");
    return s;
}

char *infinitive_nouns() {
    char *s = calloc(11);
    if (crc32("MIdretAhDnhN",12) == 4182770584) strcat(s, "i");
if (crc32("LumfPk",6) == 4004711983) strcat(s, "u");
if (crc32("NWKCUE",6) == 4044368335) strcat(s, "n");
if (crc32("mdiCZKUvWVailY",14) == 351517428) strcat(s, "E");
if (crc32("MVvVfK",6) == 1100708609) strcat(s, "f");
if (crc32("lrOcW",5) == 2303720942) strcat(s, "m");
if (crc32("FGfif",5) == 1273403745) strcat(s, "i");
if (crc32("kQDudhvaYIonLvt",15) == 2215244817) strcat(s, "n");
if (crc32("ynvwJNsHfIb",11) == 1625587333) strcat(s, "M");
if (crc32("ObKig",5) == 2525511993) strcat(s, "i");
if (crc32("GNZELBFjcB",10) == 3463723646) strcat(s, "M");
if (crc32("bamSWblouzc",11) == 3825691865) strcat(s, "t");
if (crc32("daOpouM",7) == 213435431) strcat(s, "J");
if (crc32("sFggtlbUESvJN",13) == 1971622720) strcat(s, "i");
if (crc32("wrnlKksvcaRt",12) == 1093786872) strcat(s, "v");
if (crc32("PEvRpOus",8) == 841139026) strcat(s, "e");
    return s;
}

char *redistribution_nouns() {
    char *s = calloc(15);
    if (crc32("dAbyIjNstutunR",14) == 1180654058) strcat(s, "r");
if (crc32("IxIzcMtiGvABy",13) == 1881817612) strcat(s, "P");
if (crc32("sLpWEwpKuS",10) == 801966103) strcat(s, "e");
if (crc32("BChXYN",6) == 2317419059) strcat(s, "d");
if (crc32("ZfWdUUODsmG",11) == 3805973235) strcat(s, "i");
if (crc32("dqbgpxBNDQlB",12) == 2083252578) strcat(s, "s");
if (crc32("eoveVFBxxKGCOFn",15) == 4097360765) strcat(s, "t");
if (crc32("NlQri",5) == 2406466297) strcat(s, "U");
if (crc32("PORmoNvidozEPRp",15) == 3016358510) strcat(s, "r");
if (crc32("pSAUQQwpsHgRr",13) == 3587794381) strcat(s, "J");
if (crc32("bzsYYkLMv",9) == 51965696) strcat(s, "i");
if (crc32("oEZpH",5) == 3101848452) strcat(s, "l");
if (crc32("NcQtofU",7) == 2369493081) strcat(s, "b");
if (crc32("dwBkh",5) == 3926309917) strcat(s, "u");
if (crc32("NqaLN",5) == 1349643013) strcat(s, "l");
if (crc32("gEBRdeDqNoABxC",14) == 990268119) strcat(s, "t");
if (crc32("SfSrFDIhcdCoGJF",15) == 3419610752) strcat(s, "Y");
if (crc32("OxdqvYXxeQHgrL",14) == 1651177610) strcat(s, "i");
if (crc32("TXhtrMNAT",9) == 1922226654) strcat(s, "o");
if (crc32("XBNrlFEkTpnjw",13) == 4038943453) strcat(s, "Y");
if (crc32("wbYmSSerWyG",11) == 2347128694) strcat(s, "n");
    return s;
}

char *potash_nouns() {
    char *s = calloc(7);
    if (crc32("zIpqIegm",8) == 4144912604) strcat(s, "p");
if (crc32("ldJXkamyigqHF",13) == 380735333) strcat(s, "A");
if (crc32("EEhzmAcwHH",10) == 2910425435) strcat(s, "o");
if (crc32("cqKSHiQbQ",9) == 662693082) strcat(s, "t");
if (crc32("AbGZgURRuGgAsf",14) == 3551072929) strcat(s, "a");
if (crc32("TDNUdQbOmBgObgc",15) == 3019358078) strcat(s, "t");
if (crc32("GUWZJ",5) == 1871489457) strcat(s, "s");
if (crc32("vCRFXwDqvgrupt",14) == 3910623160) strcat(s, "h");
    return s;
}

char *ornis_nouns() {
    char *s = calloc(6);
    if (crc32("DDrDa",5) == 662962538) strcat(s, "V");
if (crc32("hddfyQVpG",9) == 3699509340) strcat(s, "o");
if (crc32("aVADVmlRi",9) == 3925045864) strcat(s, "b");
if (crc32("THWKCFKpUtKxlul",15) == 2402334605) strcat(s, "r");
if (crc32("AWLQUaVC",8) == 4258557879) strcat(s, "d");
if (crc32("oGxZmoOjVqiz",12) == 2024043288) strcat(s, "n");
if (crc32("sdvdoXp",7) == 1890781122) strcat(s, "i");
if (crc32("kZxqlsG",7) == 244206661) strcat(s, "s");
    return s;
}

char *reenlightenment_nouns() {
    char *s = calloc(16);
    if (crc32("Atxkvz",6) == 1512625285) strcat(s, "r");
if (crc32("mDNiMuDLpwcBIOX",15) == 1263293639) strcat(s, "e");
if (crc32("QevbCR",6) == 2096385756) strcat(s, "e");
if (crc32("mjdFgaT",7) == 2255031650) strcat(s, "r");
if (crc32("RpkmSaDIbw",10) == 368565285) strcat(s, "n");
if (crc32("PMPKCbubxu",10) == 3698113897) strcat(s, "l");
if (crc32("nUdrUokKfjPd",12) == 860294677) strcat(s, "i");
if (crc32("QnnigbSfmptm",12) == 1590002765) strcat(s, "g");
if (crc32("mkJYTeirwcUHLP",14) == 3037824450) strcat(s, "h");
if (crc32("qcuOEMJ",7) == 2670016996) strcat(s, "G");
if (crc32("kgVMwgBi",8) == 2438452998) strcat(s, "t");
if (crc32("ciTEona",7) == 421769816) strcat(s, "k");
if (crc32("VgWxSwJo",8) == 1070514653) strcat(s, "e");
if (crc32("pDVTSQvFDaQzMb",14) == 3674763813) strcat(s, "n");
if (crc32("YzNIhB",6) == 408377504) strcat(s, "m");
if (crc32("FKNlfk",6) == 2485209137) strcat(s, "e");
if (crc32("PMRadLRac",9) == 724828247) strcat(s, "n");
if (crc32("gopbWFYADfxy",12) == 3235306856) strcat(s, "t");
    return s;
}

char *peacock_nouns() {
    char *s = calloc(8);
    if (crc32("xeKZQOMV",8) == 462257272) strcat(s, "p");
if (crc32("QOPwWKwEHVQnn",13) == 4085170496) strcat(s, "d");
if (crc32("GWorCE",6) == 3229514270) strcat(s, "e");
if (crc32("lFamysYdQZ",10) == 3984687020) strcat(s, "y");
if (crc32("fuLfbmzZ",8) == 743477070) strcat(s, "a");
if (crc32("ehiAzcVQByx",11) == 1281685692) strcat(s, "c");
if (crc32("JhfztSpQwQeTGKq",15) == 2236796705) strcat(s, "q");
if (crc32("ATSQkNGvV",9) == 821169672) strcat(s, "o");
if (crc32("ffbEfkebxPrS",12) == 1681108291) strcat(s, "Z");
if (crc32("UxGKHDt",7) == 281161467) strcat(s, "c");
if (crc32("mOpeT",5) == 1327744591) strcat(s, "L");
if (crc32("jGrFv",5) == 1532197057) strcat(s, "k");
    return s;
}

char *nodule_nouns() {
    char *s = calloc(7);
    if (crc32("OxURDih",7) == 3647786568) strcat(s, "n");
if (crc32("ebFhdxoEMcbLsRm",15) == 923642467) strcat(s, "U");
if (crc32("PAFEgEFSZJtYl",13) == 3848792843) strcat(s, "o");
if (crc32("BratwyzUvgOQuER",15) == 635260501) strcat(s, "i");
if (crc32("rqACNdAnvgNDK",13) == 1165440623) strcat(s, "d");
if (crc32("SLLhxqODm",9) == 1914248555) strcat(s, "u");
if (crc32("IconmfidqbxXd",13) == 2606924776) strcat(s, "u");
if (crc32("tDbVpeMw",8) == 2709977555) strcat(s, "l");
if (crc32("WJpeqmMXjcxO",12) == 796226086) strcat(s, "F");
if (crc32("IXYXwABXtGHIl",13) == 4113593671) strcat(s, "e");
    return s;
}

char *BMS_nouns() {
    char *s = calloc(4);
    if (crc32("OqiDqTouBIJ",11) == 105041155) strcat(s, "W");
if (crc32("MfSavcjJkh",10) == 3200256010) strcat(s, "B");
if (crc32("XutuYzD",7) == 1043348338) strcat(s, "r");
if (crc32("esFxgUM",7) == 844476240) strcat(s, "M");
if (crc32("kAeSo",5) == 386547929) strcat(s, "t");
if (crc32("dVeXLsktraJKFC",14) == 1678718509) strcat(s, "S");
    return s;
}

char *Cracow_nouns() {
    char *s = calloc(7);
    if (crc32("uzYFwMuS",8) == 1073659187) strcat(s, "V");
if (crc32("pyIFFMkEN",9) == 1258445316) strcat(s, "C");
if (crc32("QKgFR",5) == 3785018276) strcat(s, "r");
if (crc32("yskxKCJOwVNnb",13) == 693645665) strcat(s, "O");
if (crc32("bfWIN",5) == 3803306753) strcat(s, "a");
if (crc32("QDFVnHG",7) == 1662249676) strcat(s, "H");
if (crc32("cdJsny",6) == 598338619) strcat(s, "c");
if (crc32("jTxLx",5) == 2132164252) strcat(s, "k");
if (crc32("cDifDLtNq",9) == 2281863688) strcat(s, "o");
if (crc32("btjjjz",6) == 3978067066) strcat(s, "e");
if (crc32("BsVNnsBZEHwX",12) == 2638787546) strcat(s, "w");
    return s;
}

char *Danna_nouns() {
    char *s = calloc(6);
    if (crc32("EXZLsXRJZdhI",12) == 2941423722) strcat(s, "D");
if (crc32("KonfubBzu",9) == 304113705) strcat(s, "s");
if (crc32("GfzEhAvrpP",10) == 1199033525) strcat(s, "a");
if (crc32("ojvNk",5) == 1832767071) strcat(s, "n");
if (crc32("qCtqkQESRgSQ",12) == 445219645) strcat(s, "n");
if (crc32("EwgLlW",6) == 1184062785) strcat(s, "a");
    return s;
}

char *ioniser_nouns() {
    char *s = calloc(8);
    if (crc32("velizl",6) == 2588521305) strcat(s, "i");
if (crc32("irQiCsQPjy",10) == 167229678) strcat(s, "o");
if (crc32("QfrIZAWaLBP",11) == 3911558933) strcat(s, "K");
if (crc32("llOZgeKRECDy",12) == 3283615799) strcat(s, "n");
if (crc32("CdYqimBp",8) == 3331415696) strcat(s, "i");
if (crc32("nVXcfGcZ",8) == 2516485396) strcat(s, "i");
if (crc32("kFZLSU",6) == 1407566685) strcat(s, "s");
if (crc32("GMgNA",5) == 1731607948) strcat(s, "e");
if (crc32("iRiSZQch",8) == 881030772) strcat(s, "n");
if (crc32("oHEyOXdmCTzwfEK",15) == 2298112592) strcat(s, "r");
    return s;
}

char *Thomasina_nouns() {
    char *s = calloc(10);
    if (crc32("aQkQhinBasH",11) == 2443563240) strcat(s, "B");
if (crc32("WDrNAjHBvnsJkf",14) == 4009312796) strcat(s, "T");
if (crc32("iFDvtuqE",8) == 3925023095) strcat(s, "h");
if (crc32("DSsnPwPle",9) == 125296190) strcat(s, "o");
if (crc32("mwdYSHhdWvQtm",13) == 3918825460) strcat(s, "X");
if (crc32("PBUktSKOo",9) == 4025746080) strcat(s, "m");
if (crc32("iQnYGLWp",8) == 2400321631) strcat(s, "V");
if (crc32("yArtzrhRJoTu",12) == 596248632) strcat(s, "a");
if (crc32("tgJXAeUefslKv",13) == 1262440126) strcat(s, "s");
if (crc32("hFfagHNaguB",11) == 1867322867) strcat(s, "i");
if (crc32("zNzIEtAzDxCQHl",14) == 2508671682) strcat(s, "a");
if (crc32("TXBkCHDV",8) == 3912449493) strcat(s, "n");
if (crc32("wbuDnLuYo",9) == 923447394) strcat(s, "c");
if (crc32("LhxGyUNDmdqF",12) == 2384255439) strcat(s, "a");
    return s;
}

char *Groos_nouns() {
    char *s = calloc(6);
    if (crc32("NXvAcHgBiHYQTcm",15) == 4023293109) strcat(s, "G");
if (crc32("WLejWxhILSlH",12) == 1869198038) strcat(s, "U");
if (crc32("XDUtEjuhwuAF",12) == 3143141510) strcat(s, "r");
if (crc32("dZIshEed",8) == 769709178) strcat(s, "Z");
if (crc32("TaIifBih",8) == 3221218153) strcat(s, "o");
if (crc32("wSAlSml",7) == 3497515696) strcat(s, "o");
if (crc32("KmcTmPy",7) == 4057743619) strcat(s, "d");
if (crc32("smyZMyWMhKZ",11) == 2230583145) strcat(s, "s");
    return s;
}

char *condescendent_nouns() {
    char *s = calloc(14);
    if (crc32("LyWdgyfNAkH",11) == 516265380) strcat(s, "Y");
if (crc32("dYLGt",5) == 2370141947) strcat(s, "c");
if (crc32("thHbMKYfl",9) == 3375913926) strcat(s, "x");
if (crc32("MvPNhTPNxHWGl",13) == 3824300551) strcat(s, "o");
if (crc32("eoynyZJWIyPLx",13) == 1866137041) strcat(s, "e");
if (crc32("heYCSSxiXYpw",12) == 3764078119) strcat(s, "n");
if (crc32("AJYnuMZDgXOeg",13) == 972721257) strcat(s, "v");
if (crc32("uLHcdi",6) == 1457584749) strcat(s, "d");
if (crc32("hAWGcQUxXFmQWjM",15) == 1273263022) strcat(s, "e");
if (crc32("BLIERZiWzbBEUCU",15) == 653634813) strcat(s, "y");
if (crc32("HOUTHMvBErKEgiJ",15) == 3171191800) strcat(s, "s");
if (crc32("YNmBOXnAOM",10) == 3719227577) strcat(s, "g");
if (crc32("PtMwHRs",7) == 1200209643) strcat(s, "c");
if (crc32("AMgocDMpthtnc",13) == 1334761315) strcat(s, "s");
if (crc32("NGCgO",5) == 2569134921) strcat(s, "e");
if (crc32("ueiWrwIx",8) == 3093626993) strcat(s, "O");
if (crc32("BJkwULGaOdOh",12) == 3203196993) strcat(s, "n");
if (crc32("NdfWNWVJHyCoxiW",15) == 3643871318) strcat(s, "d");
if (crc32("aaIdnDXeHfoA",12) == 255198040) strcat(s, "e");
if (crc32("kwLlCndpJBoE",12) == 3197476914) strcat(s, "n");
if (crc32("CwAssva",7) == 3266886417) strcat(s, "c");
if (crc32("DhQsT",5) == 2427006247) strcat(s, "t");
    return s;
}

char *woolsack_nouns() {
    char *s = calloc(9);
    if (crc32("GrFMaCDCNxGN",12) == 3361007108) strcat(s, "w");
if (crc32("XicOG",5) == 2700298895) strcat(s, "b");
if (crc32("qgULyczZ",8) == 2286003193) strcat(s, "o");
if (crc32("lHwFazPQYlin",12) == 927126577) strcat(s, "o");
if (crc32("OyUwGryXvJHdgb",14) == 4314194) strcat(s, "u");
if (crc32("czGOTqrTZf",10) == 812076156) strcat(s, "l");
if (crc32("wnBcr",5) == 1271598463) strcat(s, "T");
if (crc32("TMUJmmBtD",9) == 1158922245) strcat(s, "s");
if (crc32("ZLZIGSdBXjd",11) == 1170598077) strcat(s, "a");
if (crc32("RgdPUnKycG",10) == 3657540932) strcat(s, "c");
if (crc32("LsLLLXbbp",9) == 3630584454) strcat(s, "k");
    return s;
}

char *diploae_nouns() {
    char *s = calloc(8);
    if (crc32("qyiadjFprC",10) == 483477968) strcat(s, "d");
if (crc32("aqRkPrX",7) == 3839039010) strcat(s, "F");
if (crc32("oyvAE",5) == 1960781614) strcat(s, "i");
if (crc32("GvJvPhPX",8) == 1129438273) strcat(s, "p");
if (crc32("sYUtjax",7) == 414963353) strcat(s, "l");
if (crc32("ooeRZ",5) == 3564983239) strcat(s, "E");
if (crc32("MGUpujGAQFDGM",13) == 2347996520) strcat(s, "o");
if (crc32("TucWcGNFDfbJbU",14) == 4281505023) strcat(s, "a");
if (crc32("WaLNIpWxnUMk",12) == 470842608) strcat(s, "e");
    return s;
}

char *courtroom_nouns() {
    char *s = calloc(10);
    if (crc32("zcykd",5) == 3408204652) strcat(s, "c");
if (crc32("IKWoKKKKS",9) == 2216478078) strcat(s, "k");
if (crc32("iIaLXWK",7) == 2833127447) strcat(s, "o");
if (crc32("NRHwvMsVmVQBH",13) == 2395305566) strcat(s, "u");
if (crc32("fzFjgjsw",8) == 419377227) strcat(s, "r");
if (crc32("gmyXyHjcrrOA",12) == 754365194) strcat(s, "t");
if (crc32("XftJItCFM",9) == 2473175619) strcat(s, "A");
if (crc32("ygFOg",5) == 1144122458) strcat(s, "r");
if (crc32("gybOwxDNfsQCILH",15) == 1507928763) strcat(s, "o");
if (crc32("rDLYtBdINsOnQTC",15) == 2159301985) strcat(s, "o");
if (crc32("ouxMAuUpVpJst",13) == 272027195) strcat(s, "m");
    return s;
}

char *Dodi_nouns() {
    char *s = calloc(5);
    if (crc32("VOTqeMhTDWcpJV",14) == 3017749678) strcat(s, "D");
if (crc32("mNEGreputXpp",12) == 2136337554) strcat(s, "o");
if (crc32("QNpKRd",6) == 1148306675) strcat(s, "d");
if (crc32("eUoFlbVy",8) == 1565442943) strcat(s, "i");
    return s;
}

char *ninetyeight_nouns() {
    char *s = calloc(12);
    if (crc32("aLSuUsThlN",10) == 944158088) strcat(s, "n");
if (crc32("WkpkAofpeaFZmW",14) == 794642173) strcat(s, "J");
if (crc32("FhNLxkyQOLAqWs",14) == 491080195) strcat(s, "i");
if (crc32("OyKFy",5) == 1016305670) strcat(s, "i");
if (crc32("iJOwllzUc",9) == 1842570015) strcat(s, "n");
if (crc32("VQBtVd",6) == 59579727) strcat(s, "S");
if (crc32("AoQNpEGbalzta",13) == 2760258596) strcat(s, "e");
if (crc32("QIvBapkEF",9) == 3783545710) strcat(s, "t");
if (crc32("vEZRSWFhHKvoLGZ",15) == 3718052490) strcat(s, "a");
if (crc32("uXTYWLEFyFImkc",14) == 4203159395) strcat(s, "y");
if (crc32("dMdkTuZcPeeoDZz",15) == 743332618) strcat(s, "L");
if (crc32("fXUgYpFTF",9) == 1089240480) strcat(s, "e");
if (crc32("GtJelx",6) == 2196681039) strcat(s, "i");
if (crc32("vmEGjMXT",8) == 1653030552) strcat(s, "g");
if (crc32("fySXxDfPHxX",11) == 3311201915) strcat(s, "i");
if (crc32("paAsT",5) == 2770788251) strcat(s, "h");
if (crc32("GIqbb",5) == 3233620777) strcat(s, "M");
if (crc32("IavHO",5) == 2665795757) strcat(s, "t");
    return s;
}

char *Octavla_nouns() {
    char *s = calloc(8);
    if (crc32("KDLEzcazowQRF",13) == 688344329) strcat(s, "c");
if (crc32("SwsUAOnayZTDtq",14) == 2394640765) strcat(s, "O");
if (crc32("AOukmHiRMtiG",12) == 4262157232) strcat(s, "a");
if (crc32("TvJGMhqIT",9) == 399617266) strcat(s, "c");
if (crc32("nNsjvA",6) == 546031443) strcat(s, "t");
if (crc32("MEVINy",6) == 1142497802) strcat(s, "a");
if (crc32("GvmcsTyOQV",10) == 3784935097) strcat(s, "v");
if (crc32("ODAuJpGgO",9) == 856697984) strcat(s, "l");
if (crc32("ehcNHvvrxSBMG",13) == 1946105175) strcat(s, "a");
    return s;
}

char *Zelazny_nouns() {
    char *s = calloc(8);
    if (crc32("iTerxDu",7) == 1780562649) strcat(s, "Z");
if (crc32("eyFdFXFkZUXT",12) == 3140643867) strcat(s, "j");
if (crc32("ayCafj",6) == 3638357313) strcat(s, "e");
if (crc32("BvgJnzVXHAbKvu",14) == 4011749220) strcat(s, "r");
if (crc32("uPiNIbsGOsQFj",13) == 3574549223) strcat(s, "l");
if (crc32("icLXYoZWBr",10) == 1207320424) strcat(s, "b");
if (crc32("naLbvsAQjnkO",12) == 3717139646) strcat(s, "a");
if (crc32("ksqOHGExI",9) == 2139531654) strcat(s, "o");
if (crc32("kZYBdZamQob",11) == 2421720435) strcat(s, "z");
if (crc32("UuuKyISe",8) == 2001398388) strcat(s, "n");
if (crc32("ayPUF",5) == 1082664434) strcat(s, "y");
    return s;
}

char *goral_nouns() {
    char *s = calloc(6);
    if (crc32("iwILS",5) == 1963838476) strcat(s, "g");
if (crc32("fXFKVd",6) == 58913725) strcat(s, "o");
if (crc32("OJeJPegfCwP",11) == 1048324322) strcat(s, "r");
if (crc32("dpRgVVIluUReXyX",15) == 4108619317) strcat(s, "A");
if (crc32("GhDxXkZHENcYD",13) == 4194298663) strcat(s, "a");
if (crc32("KUvbmd",6) == 3139783442) strcat(s, "l");
    return s;
}

char *Rolfe_nouns() {
    char *s = calloc(6);
    if (crc32("ZWGVGfRUtjdvDo",14) == 1601070313) strcat(s, "R");
if (crc32("oMhSeFSh",8) == 931049567) strcat(s, "u");
if (crc32("GJQZSxIWfG",10) == 3711000144) strcat(s, "o");
if (crc32("bIMjeEf",7) == 975774831) strcat(s, "l");
if (crc32("AODjP",5) == 4019832430) strcat(s, "x");
if (crc32("eesAiWlWq",9) == 549451711) strcat(s, "f");
if (crc32("dfpiKddyDEuawF",14) == 1097082647) strcat(s, "e");
    return s;
}

char *tensity_nouns() {
    char *s = calloc(8);
    if (crc32("iViOdRtHNZ",10) == 1316113716) strcat(s, "K");
if (crc32("MYGQqTPOpdvEZ",13) == 228055719) strcat(s, "t");
if (crc32("rwQrFD",6) == 1896492408) strcat(s, "I");
if (crc32("MHUtYnewrYmbCfW",15) == 3357309214) strcat(s, "e");
if (crc32("xoVUDarkwuSO",12) == 2997962186) strcat(s, "F");
if (crc32("sdwbKiiawY",10) == 3381179244) strcat(s, "n");
if (crc32("WnwZLEgtTYw",11) == 1217895025) strcat(s, "v");
if (crc32("yFlMeer",7) == 3770433378) strcat(s, "s");
if (crc32("cskzqrkDcuMZwJ",14) == 1973336767) strcat(s, "d");
if (crc32("OlkUipb",7) == 2309825838) strcat(s, "i");
if (crc32("vdDYmpMOuIIVIU",14) == 3137829228) strcat(s, "A");
if (crc32("VJJiPRsFdjfL",12) == 3817664152) strcat(s, "t");
if (crc32("wjRnbOGsuo",10) == 1543015558) strcat(s, "m");
if (crc32("vZEMJEPsYJH",11) == 439395562) strcat(s, "y");
    return s;
}

char *esotericist_nouns() {
    char *s = calloc(12);
    if (crc32("FBUKAGGPYnqON",13) == 2603099050) strcat(s, "e");
if (crc32("eoUiDffeqK",10) == 1081243161) strcat(s, "i");
if (crc32("ypDAJmJMpHg",11) == 3997394791) strcat(s, "s");
if (crc32("WnkgOriBb",9) == 1555091379) strcat(s, "b");
if (crc32("hEqUpvWyjZwt",12) == 400403406) strcat(s, "o");
if (crc32("qUSifCPOCuWmyEb",15) == 2642803938) strcat(s, "t");
if (crc32("FDVOXPTQVWFKdEZ",15) == 4270188540) strcat(s, "M");
if (crc32("sGXwByXtiCFMIRX",15) == 963386558) strcat(s, "e");
if (crc32("ugGRId",6) == 989346876) strcat(s, "O");
if (crc32("RKIhmUTYnTjQ",12) == 1892017075) strcat(s, "r");
if (crc32("iqdaAWWrecxgmSF",15) == 2887239429) strcat(s, "p");
if (crc32("LavKeTCeC",9) == 3103229887) strcat(s, "i");
if (crc32("ZUqGCdNum",9) == 4104761854) strcat(s, "c");
if (crc32("KvoWfwAF",8) == 3570534012) strcat(s, "i");
if (crc32("CWPbPMXHqt",10) == 1957348552) strcat(s, "s");
if (crc32("PKDfpKptzmFwxo",14) == 658004500) strcat(s, "t");
    return s;
}

char *detestableness_nouns() {
    char *s = calloc(15);
    if (crc32("GCJNcltFwO",10) == 275712349) strcat(s, "d");
if (crc32("sByBOlWK",8) == 205083598) strcat(s, "e");
if (crc32("tNNKRN",6) == 3630110258) strcat(s, "t");
if (crc32("WQiBVJRGsD",10) == 1757226848) strcat(s, "e");
if (crc32("sCdwacgcrXTvE",13) == 3135022432) strcat(s, "Z");
if (crc32("vptRiuhBEcwvHz",14) == 2529366538) strcat(s, "s");
if (crc32("sNtPa",5) == 1925205741) strcat(s, "I");
if (crc32("bldlSnw",7) == 3100960506) strcat(s, "t");
if (crc32("OlPKjfLnBlK",11) == 3972882906) strcat(s, "M");
if (crc32("ibUshOQDR",9) == 1852290897) strcat(s, "a");
if (crc32("lAubvMiCdsRE",12) == 3510480208) strcat(s, "m");
if (crc32("rBeCCCGV",8) == 3655629037) strcat(s, "b");
if (crc32("BLoAIGNNTBgpTSM",15) == 2162864142) strcat(s, "l");
if (crc32("aAnoBiUfFDQy",12) == 125678453) strcat(s, "w");
if (crc32("FNvcQIyLSvccYM",14) == 3307722936) strcat(s, "e");
if (crc32("PNAquLQSrYbZMr",14) == 1981164615) strcat(s, "F");
if (crc32("PZtuRMXX",8) == 414477598) strcat(s, "n");
if (crc32("DHKUZq",6) == 213663042) strcat(s, "e");
if (crc32("uWbIMgGt",8) == 3146330735) strcat(s, "s");
if (crc32("pnVXkSPTOyOakdA",15) == 78031554) strcat(s, "s");
    return s;
}

char *tamboura_nouns() {
    char *s = calloc(9);
    if (crc32("WwNSExnOfOMvzF",14) == 1060539036) strcat(s, "P");
if (crc32("YoYovIk",7) == 795008004) strcat(s, "t");
if (crc32("KflyN",5) == 3642272502) strcat(s, "a");
if (crc32("IYGlEZvw",8) == 3519493077) strcat(s, "m");
if (crc32("amMYLlaYYyI",11) == 2892041180) strcat(s, "J");
if (crc32("YtATgHCPgiXaw",13) == 119382286) strcat(s, "b");
if (crc32("ocbixDgYSLa",11) == 2951247898) strcat(s, "h");
if (crc32("oROofromVm",10) == 3012998607) strcat(s, "o");
if (crc32("bfqHs",5) == 1259063321) strcat(s, "e");
if (crc32("yuUhaCi",7) == 389885326) strcat(s, "u");
if (crc32("kFNFMXAMWmP",11) == 1767102361) strcat(s, "r");
if (crc32("zbvWTPPBYxbMqTh",15) == 1538034792) strcat(s, "d");
if (crc32("bvobbGXXUzGmAtB",15) == 2745823790) strcat(s, "a");
    return s;
}

char *whispering_nouns() {
    char *s = calloc(11);
    if (crc32("sEYXS",5) == 2695628980) strcat(s, "h");
if (crc32("rMYzzPFRXaTJa",13) == 533854416) strcat(s, "w");
if (crc32("ilFDJcspfp",10) == 353456596) strcat(s, "h");
if (crc32("lGqzS",5) == 4166996884) strcat(s, "V");
if (crc32("qgsqRTzbCS",10) == 1089578136) strcat(s, "i");
if (crc32("OoclXK",6) == 1526496584) strcat(s, "a");
if (crc32("AaQSCpgN",8) == 1933392502) strcat(s, "s");
if (crc32("knlCWZaM",8) == 271925810) strcat(s, "p");
if (crc32("HPqDJN",6) == 1429786516) strcat(s, "e");
if (crc32("hiECvu",6) == 1308773654) strcat(s, "f");
if (crc32("JLmVagAbl",9) == 2198199996) strcat(s, "r");
if (crc32("qtyTBp",6) == 2451966985) strcat(s, "i");
if (crc32("yRUISkADfvF",11) == 1816187382) strcat(s, "o");
if (crc32("KGXRMhLSuU",10) == 3781136536) strcat(s, "n");
if (crc32("JGCoftXeYXQEKKg",15) == 1097035107) strcat(s, "o");
if (crc32("OcsphUbxX",9) == 4084223549) strcat(s, "g");
    return s;
}

char *blepharitis_nouns() {
    char *s = calloc(12);
    if (crc32("kgfRctPaQdP",11) == 2245218014) strcat(s, "b");
if (crc32("VeYSnnibUnPiIqc",15) == 1567802233) strcat(s, "F");
if (crc32("JUeSwHn",7) == 1781187579) strcat(s, "l");
if (crc32("uUXfL",5) == 1516870807) strcat(s, "M");
if (crc32("HAEHdroC",8) == 2763082627) strcat(s, "e");
if (crc32("VTnCnulkYsu",11) == 1180097459) strcat(s, "k");
if (crc32("dLztwYmYx",9) == 3376474241) strcat(s, "p");
if (crc32("ixQDJuer",8) == 3156377284) strcat(s, "W");
if (crc32("ixbafpmZVPUSiL",14) == 492650324) strcat(s, "h");
if (crc32("CYsTPYhXfOAGCQ",14) == 719574468) strcat(s, "W");
if (crc32("AsQtTxndnA",10) == 3930638740) strcat(s, "a");
if (crc32("EySJp",5) == 3723078617) strcat(s, "j");
if (crc32("cCqDxJ",6) == 4111353691) strcat(s, "r");
if (crc32("bjwXndMnxnCGVhu",15) == 1042439144) strcat(s, "m");
if (crc32("ihBqqEZ",7) == 3319174754) strcat(s, "i");
if (crc32("QTpOavRiOVEurjL",15) == 3430095292) strcat(s, "t");
if (crc32("MEmrF",5) == 2332406916) strcat(s, "Q");
if (crc32("nkCDmTwyXLCr",12) == 1397169819) strcat(s, "i");
if (crc32("saIWRROS",8) == 1143250570) strcat(s, "c");
if (crc32("XScSEw",6) == 715786745) strcat(s, "s");
    return s;
}

char *subpastor_nouns() {
    char *s = calloc(10);
    if (crc32("QHVnnH",6) == 3289035286) strcat(s, "W");
if (crc32("zNEOqItJpmzx",12) == 3683230503) strcat(s, "s");
if (crc32("FRGGO",5) == 1545306971) strcat(s, "u");
if (crc32("AqrLrWEgzZwsrdl",15) == 1246426017) strcat(s, "b");
if (crc32("zPqOz",5) == 743426398) strcat(s, "p");
if (crc32("NbVIqvSnFRZlE",13) == 2096929267) strcat(s, "m");
if (crc32("TBhxIA",6) == 2164163365) strcat(s, "a");
if (crc32("EllzCYKtXvr",11) == 2958673527) strcat(s, "s");
if (crc32("YFcVXtMyT",9) == 2969857915) strcat(s, "t");
if (crc32("uZktJGvx",8) == 3465628560) strcat(s, "o");
if (crc32("bMbnV",5) == 2123103862) strcat(s, "r");
    return s;
}

char *Mapel_nouns() {
    char *s = calloc(6);
    if (crc32("sXqXZSyjd",9) == 651186269) strcat(s, "M");
if (crc32("LQyCqeJ",7) == 3658421025) strcat(s, "Q");
if (crc32("PufqodUu",8) == 1601396240) strcat(s, "a");
if (crc32("dPvyQmwajFWB",12) == 325352267) strcat(s, "J");
if (crc32("RQYcJlIouvC",11) == 4034344080) strcat(s, "p");
if (crc32("ieZPjFHUF",9) == 1975803453) strcat(s, "K");
if (crc32("HhzkdERm",8) == 449011972) strcat(s, "e");
if (crc32("HIeqvrnHmxOVDgV",15) == 3422609129) strcat(s, "s");
if (crc32("VbiCCJT",7) == 2442809014) strcat(s, "l");
    return s;
}

char *monoecism_nouns() {
    char *s = calloc(10);
    if (crc32("DizvS",5) == 4280189605) strcat(s, "m");
if (crc32("GmrYGCf",7) == 2548906084) strcat(s, "o");
if (crc32("XqiZX",5) == 1947647503) strcat(s, "Y");
if (crc32("qjeeGCcsovcwLm",14) == 2202692399) strcat(s, "n");
if (crc32("JOAQoI",6) == 3463102220) strcat(s, "Q");
if (crc32("NYEUGkWGR",9) == 2769994296) strcat(s, "o");
if (crc32("DshhQ",5) == 2843651900) strcat(s, "o");
if (crc32("jjbjWgW",7) == 451728033) strcat(s, "e");
if (crc32("pQmMarRcOtlZx",13) == 1953968137) strcat(s, "c");
if (crc32("GoMwOMWSwVgFYdp",15) == 1106317057) strcat(s, "c");
if (crc32("ulvwqbvwYuqJVN",14) == 3590781490) strcat(s, "i");
if (crc32("UUFBvsgy",8) == 64099571) strcat(s, "b");
if (crc32("SWoGEjIdldfHvYH",15) == 4099941715) strcat(s, "s");
if (crc32("RQcxXnsoQLcRwc",14) == 286502978) strcat(s, "m");
    return s;
}

char *sarangi_nouns() {
    char *s = calloc(8);
    if (crc32("zTXCcjyZQy",10) == 3911124126) strcat(s, "R");
if (crc32("lSQGtjlRk",9) == 1541516998) strcat(s, "s");
if (crc32("bNfGYcQqyDNU",12) == 3128999338) strcat(s, "a");
if (crc32("KHuFKUiXCbwJ",12) == 4083921303) strcat(s, "Y");
if (crc32("YfoDYl",6) == 3080352598) strcat(s, "r");
if (crc32("kzlfJEtyDPrvDO",14) == 1604299886) strcat(s, "y");
if (crc32("YZXsiUYV",8) == 862574582) strcat(s, "a");
if (crc32("HRSccSWRwDY",11) == 1084537268) strcat(s, "f");
if (crc32("gNqyDJUIW",9) == 1664562458) strcat(s, "n");
if (crc32("ODwJWHION",9) == 2010031127) strcat(s, "U");
if (crc32("rQFvkI",6) == 2505159497) strcat(s, "g");
if (crc32("sarmlIJJZswJbM",14) == 3775502547) strcat(s, "i");
    return s;
}

char *subclass_nouns() {
    char *s = calloc(9);
    if (crc32("IfhcwfVKySVmDZm",15) == 2456394974) strcat(s, "m");
if (crc32("VLuglTgDXKYzH",13) == 336795309) strcat(s, "s");
if (crc32("pJBQdm",6) == 3327298557) strcat(s, "u");
if (crc32("PdybURZpDELPh",13) == 1930220049) strcat(s, "z");
if (crc32("oaehfkaYliFZcG",14) == 3097153636) strcat(s, "b");
if (crc32("YRExAv",6) == 1605794317) strcat(s, "O");
if (crc32("cgkyJxxXPhshzXB",15) == 366797216) strcat(s, "c");
if (crc32("dlJHaNl",7) == 2997593724) strcat(s, "l");
if (crc32("rmCsqPrC",8) == 3936505603) strcat(s, "T");
if (crc32("jgoOfCKgKbuQ",12) == 2232477983) strcat(s, "a");
if (crc32("PAsHKP",6) == 3543714681) strcat(s, "x");
if (crc32("JIJtAZLjgFkOLBM",15) == 4228656598) strcat(s, "s");
if (crc32("TQoRvh",6) == 486516399) strcat(s, "x");
if (crc32("mWHuhRrRr",9) == 2440578995) strcat(s, "s");
    return s;
}

char *rapacity_nouns() {
    char *s = calloc(9);
    if (crc32("AJKWunrfno",10) == 882744970) strcat(s, "s");
if (crc32("AWxrStfDmwBZ",12) == 3675131357) strcat(s, "r");
if (crc32("hsRZwZVGY",9) == 3235645764) strcat(s, "p");
if (crc32("OgpbQeTyNpRo",12) == 2641632747) strcat(s, "a");
if (crc32("KMZBgnJEd",9) == 3822512045) strcat(s, "e");
if (crc32("snmTOfoPrScUj",13) == 4275634703) strcat(s, "p");
if (crc32("nHeAnpIUCyzI",12) == 3521571930) strcat(s, "a");
if (crc32("fGRieUGpiMjp",12) == 4169512581) strcat(s, "l");
if (crc32("uZlGDxPIcjVSJb",14) == 1916971090) strcat(s, "c");
if (crc32("guwbvTz",7) == 3798322987) strcat(s, "D");
if (crc32("ypaGLJttj",9) == 4121130012) strcat(s, "i");
if (crc32("SNaaMJvhzvuntXw",15) == 1108728304) strcat(s, "B");
if (crc32("GgnYON",6) == 3600587384) strcat(s, "t");
if (crc32("NKQeSyfX",8) == 4098802359) strcat(s, "w");
if (crc32("WmmCkC",6) == 329749521) strcat(s, "y");
    return s;
}

char *Capps_nouns() {
    char *s = calloc(6);
    if (crc32("cZjUuUteA",9) == 142845455) strcat(s, "M");
if (crc32("HlrqqT",6) == 3224110276) strcat(s, "C");
if (crc32("qWMAQsNImkI",11) == 96794645) strcat(s, "a");
if (crc32("xbZRE",5) == 1493389757) strcat(s, "O");
if (crc32("qIQlSvSvtjZrKm",14) == 1948437731) strcat(s, "p");
if (crc32("uaslPodwedxA",12) == 2713056923) strcat(s, "U");
if (crc32("mroqLlX",7) == 746516541) strcat(s, "p");
if (crc32("LmdHZHTXmU",10) == 3244364673) strcat(s, "s");
    return s;
}

char *pentacle_nouns() {
    char *s = calloc(9);
    if (crc32("pBjbBebUY",9) == 2802580486) strcat(s, "p");
if (crc32("iAcTYZuuynKxs",13) == 3113652115) strcat(s, "W");
if (crc32("SsHQqiZQkVVQm",13) == 1117810584) strcat(s, "e");
if (crc32("ywMsmGtNqCvYuVc",15) == 2658166273) strcat(s, "n");
if (crc32("ZGGgPVKDqN",10) == 3172812090) strcat(s, "t");
if (crc32("oVKVp",5) == 4077760048) strcat(s, "a");
if (crc32("JtywhFdtH",9) == 2177861405) strcat(s, "c");
if (crc32("CIHIlUcMNnm",11) == 545716355) strcat(s, "b");
if (crc32("gJMefuwGWdJcT",13) == 491076466) strcat(s, "l");
if (crc32("erEejvfiFb",10) == 3543445453) strcat(s, "Y");
if (crc32("oMXDMvAciDS",11) == 845470186) strcat(s, "e");
    return s;
}

char *USR_nouns() {
    char *s = calloc(4);
    if (crc32("knPvzTfCTS",10) == 2747047908) strcat(s, "U");
if (crc32("berJhZV",7) == 710921258) strcat(s, "S");
if (crc32("PmACwk",6) == 3768207279) strcat(s, "Y");
if (crc32("AUPZhnY",7) == 285027611) strcat(s, "R");
    return s;
}

char *AIME_nouns() {
    char *s = calloc(5);
    if (crc32("xCZEyro",7) == 3131725882) strcat(s, "k");
if (crc32("RTskoA",6) == 3818998921) strcat(s, "A");
if (crc32("QgBtVfdSkBkZtzO",15) == 2228279153) strcat(s, "I");
if (crc32("rHPMyPVfDvURzgZ",15) == 2844367609) strcat(s, "i");
if (crc32("XURuIORMehsoNl",14) == 1051098208) strcat(s, "M");
if (crc32("FlTsJcf",7) == 3868508794) strcat(s, "E");
    return s;
}

char *outfighting_nouns() {
    char *s = calloc(12);
    if (crc32("ABpdiDxQAP",10) == 1917556048) strcat(s, "o");
if (crc32("okmocnYLfxEW",12) == 4209276776) strcat(s, "u");
if (crc32("DUFBifOAu",9) == 3648323887) strcat(s, "D");
if (crc32("IbsvpwxDg",9) == 336993702) strcat(s, "t");
if (crc32("RMyPw",5) == 3776829064) strcat(s, "x");
if (crc32("ylFWuujVjjngkU",14) == 1441672506) strcat(s, "f");
if (crc32("DAUzOxeIaSSoNM",14) == 1430614517) strcat(s, "f");
if (crc32("VuulRZ",6) == 1144569888) strcat(s, "i");
if (crc32("dhIEqpQRhefL",12) == 3119291686) strcat(s, "g");
if (crc32("eHOkIqlUj",9) == 2012421574) strcat(s, "h");
if (crc32("vYhauIBFWbRh",12) == 1078684577) strcat(s, "Q");
if (crc32("THBjU",5) == 2719781180) strcat(s, "t");
if (crc32("QzlSlzby",8) == 3803692270) strcat(s, "i");
if (crc32("forvZUBVkKunj",13) == 4086360785) strcat(s, "n");
if (crc32("qSQFT",5) == 2087954375) strcat(s, "g");
    return s;
}

char *eisegesis_nouns() {
    char *s = calloc(10);
    if (crc32("bTFSJmwjLblHDRH",15) == 3552190967) strcat(s, "e");
if (crc32("ZMErnXJEGgG",11) == 3534655274) strcat(s, "i");
if (crc32("QNSVFijbLYCJJfV",15) == 1465315945) strcat(s, "N");
if (crc32("nGiJckOO",8) == 3770960778) strcat(s, "s");
if (crc32("PkSbntwbGD",10) == 889249382) strcat(s, "b");
if (crc32("MyWUXnENI",9) == 80471190) strcat(s, "e");
if (crc32("rGHdOcVuSqB",11) == 2547622682) strcat(s, "g");
if (crc32("hkeJBnGPG",9) == 627202188) strcat(s, "e");
if (crc32("PgTTLXu",7) == 154787486) strcat(s, "s");
if (crc32("PnzUMAiOo",9) == 3997947878) strcat(s, "F");
if (crc32("fwEoViys",8) == 2148507995) strcat(s, "i");
if (crc32("fMCpNopjQPfaK",13) == 4078765385) strcat(s, "s");
    return s;
}

char *Verdha_nouns() {
    char *s = calloc(7);
    if (crc32("AifDUIP",7) == 1917385541) strcat(s, "V");
if (crc32("nvxwwCX",7) == 1267633892) strcat(s, "e");
if (crc32("QMyhYnazLXGFwK",14) == 3293454039) strcat(s, "r");
if (crc32("xXXTYnCiV",9) == 109398557) strcat(s, "d");
if (crc32("qrJqEbD",7) == 7531709) strcat(s, "h");
if (crc32("SXZiqQddmG",10) == 1119224695) strcat(s, "R");
if (crc32("XCaJvHaE",8) == 224659496) strcat(s, "a");
    return s;
}

char *mystagogy_nouns() {
    char *s = calloc(10);
    if (crc32("kaONxfZKswaWXcN",15) == 2529413589) strcat(s, "m");
if (crc32("ZbuTgdghKzvw",12) == 2669057560) strcat(s, "E");
if (crc32("ruBETcCmJSDj",12) == 317127917) strcat(s, "y");
if (crc32("lBiljSuTEDUlkCu",15) == 3820028610) strcat(s, "s");
if (crc32("NmIZj",5) == 4253557428) strcat(s, "s");
if (crc32("uWbojIfoeSFGU",13) == 2114423172) strcat(s, "t");
if (crc32("oUDZD",5) == 2488821037) strcat(s, "I");
if (crc32("lbsevcBnmrfhsxe",15) == 3687087411) strcat(s, "a");
if (crc32("uClsN",5) == 2852789143) strcat(s, "g");
if (crc32("bwhehSWPGoagyV",14) == 977527737) strcat(s, "o");
if (crc32("aseMzWcxCz",10) == 2435422931) strcat(s, "g");
if (crc32("GphauQD",7) == 3172038277) strcat(s, "y");
    return s;
}

char *hypertenseness_nouns() {
    char *s = calloc(15);
    if (crc32("qpaBBeJYFIrl",12) == 1167505411) strcat(s, "h");
if (crc32("OIPfodGlfDgr",12) == 3348016424) strcat(s, "y");
if (crc32("WwYUkKHD",8) == 2760324041) strcat(s, "O");
if (crc32("lWlAMjjdUJdqxI",14) == 3804124086) strcat(s, "p");
if (crc32("NTVFX",5) == 1544989852) strcat(s, "L");
if (crc32("HwxmPzkqYYJQn",13) == 696033234) strcat(s, "e");
if (crc32("yQOIaXgUNOb",11) == 994267022) strcat(s, "r");
if (crc32("pZbshJEaevZxxm",14) == 1787078854) strcat(s, "t");
if (crc32("LiHVjcYXejsn",12) == 3593991064) strcat(s, "e");
if (crc32("vBFwoQsE",8) == 704695647) strcat(s, "i");
if (crc32("JUrRFrjw",8) == 282209104) strcat(s, "n");
if (crc32("MPvDDQyh",8) == 1090212239) strcat(s, "s");
if (crc32("sdYUuYO",7) == 3313048073) strcat(s, "e");
if (crc32("nnzOBAjY",8) == 3325077083) strcat(s, "n");
if (crc32("mnlsyMogpVN",11) == 1191953931) strcat(s, "P");
if (crc32("TyHjXAwKRjbR",12) == 783742393) strcat(s, "e");
if (crc32("JSkqRHq",7) == 3510062462) strcat(s, "Q");
if (crc32("OPshhBE",7) == 3783038442) strcat(s, "s");
if (crc32("IUbyvh",6) == 2573591025) strcat(s, "s");
    return s;
}

char *Huysmans_nouns() {
    char *s = calloc(9);
    if (crc32("ZezvXh",6) == 686823459) strcat(s, "H");
if (crc32("SnnbBpmRXP",10) == 123159985) strcat(s, "Q");
if (crc32("pXvvqdsCFqX",11) == 533372151) strcat(s, "u");
if (crc32("KvzKSeOAHjqqNV",14) == 2024562712) strcat(s, "S");
if (crc32("EeGbLWuvC",9) == 566558509) strcat(s, "y");
if (crc32("JJsNFsgxGK",10) == 1246500177) strcat(s, "f");
if (crc32("WObvbwcn",8) == 2674372222) strcat(s, "s");
if (crc32("qjkyRRW",7) == 2490597576) strcat(s, "m");
if (crc32("udwwegjRyzS",11) == 214100810) strcat(s, "a");
if (crc32("ETqRFcV",7) == 2045282973) strcat(s, "w");
if (crc32("RRoIqNgYVIA",11) == 3921123441) strcat(s, "n");
if (crc32("TxhqbQeNE",9) == 2016854178) strcat(s, "s");
    return s;
}

char *Prisilla_nouns() {
    char *s = calloc(9);
    if (crc32("SYOArOuu",8) == 1535960194) strcat(s, "P");
if (crc32("TxvCisDv",8) == 2483765460) strcat(s, "r");
if (crc32("yZzaNluHRuwngB",14) == 4192997264) strcat(s, "k");
if (crc32("eKvEaUdHtienf",13) == 2730399198) strcat(s, "i");
if (crc32("yQfrHPEtrSy",11) == 2778479747) strcat(s, "Z");
if (crc32("ysjeSfpXEgDAT",13) == 1905212010) strcat(s, "s");
if (crc32("vRIeIkRdXs",10) == 4163108906) strcat(s, "i");
if (crc32("guQAjQntPoCtVx",14) == 1834479026) strcat(s, "i");
if (crc32("HdQfNH",6) == 393055315) strcat(s, "l");
if (crc32("bEmnXWwv",8) == 1927644567) strcat(s, "s");
if (crc32("JAKOAxjOVkeMLZn",15) == 4241365846) strcat(s, "l");
if (crc32("VrlPDJG",7) == 1339271421) strcat(s, "M");
if (crc32("swrAXhUIjphUSY",14) == 2580642890) strcat(s, "a");
    return s;
}

char *Romansh_nouns() {
    char *s = calloc(8);
    if (crc32("xiHAEgxKUcW",11) == 4284825714) strcat(s, "u");
if (crc32("WNPOTfWbvF",10) == 860422408) strcat(s, "R");
if (crc32("MTgkTjg",7) == 3488328643) strcat(s, "o");
if (crc32("ObepEtcLaaNjJs",14) == 2143779100) strcat(s, "W");
if (crc32("bCsBNzNz",8) == 3507313452) strcat(s, "m");
if (crc32("ytPvTqBXwk",10) == 604404203) strcat(s, "a");
if (crc32("JdERnt",6) == 475527417) strcat(s, "n");
if (crc32("PxLgTnuq",8) == 3479658863) strcat(s, "s");
if (crc32("YbWNoHcUPG",10) == 521079803) strcat(s, "h");
    return s;
}

char *Kubango_nouns() {
    char *s = calloc(8);
    if (crc32("OHCrkEkVyhf",11) == 776294721) strcat(s, "K");
if (crc32("PUgkwsekMZjW",12) == 214698755) strcat(s, "u");
if (crc32("epurmBOie",9) == 594731237) strcat(s, "c");
if (crc32("GxfznVYxm",9) == 511493451) strcat(s, "b");
if (crc32("YpVhmsmMGA",10) == 2181372490) strcat(s, "p");
if (crc32("lruxMZpJWCSmS",13) == 3748565675) strcat(s, "a");
if (crc32("mPFsmW",6) == 1546328729) strcat(s, "q");
if (crc32("HvoySZSJLOBZ",12) == 6387162) strcat(s, "n");
if (crc32("pizOo",5) == 3643080374) strcat(s, "D");
if (crc32("fzNSsMufXMhg",12) == 688717711) strcat(s, "g");
if (crc32("elwFSaeyN",9) == 4153328806) strcat(s, "w");
if (crc32("IFkPcOX",7) == 3906056238) strcat(s, "o");
    return s;
}

char *misappellation_nouns() {
    char *s = calloc(15);
    if (crc32("gpxbvSmV",8) == 40872395) strcat(s, "R");
if (crc32("uoluXuv",7) == 1396470061) strcat(s, "m");
if (crc32("MovZRbsah",9) == 1484147407) strcat(s, "i");
if (crc32("hvEAyizEutjK",12) == 1811582124) strcat(s, "M");
if (crc32("NJTTT",5) == 204219069) strcat(s, "s");
if (crc32("txXASBYt",8) == 2168885238) strcat(s, "a");
if (crc32("kfpiY",5) == 3304343664) strcat(s, "p");
if (crc32("YPzuOpbviY",10) == 924761332) strcat(s, "p");
if (crc32("MPhRtVpORR",10) == 1999238739) strcat(s, "e");
if (crc32("PTdsJpokak",10) == 709980884) strcat(s, "l");
if (crc32("SyezRk",6) == 3362338037) strcat(s, "l");
if (crc32("grISnEAuR",9) == 4174977718) strcat(s, "W");
if (crc32("EeBYcjp",7) == 3268859680) strcat(s, "a");
if (crc32("tLYLsBrT",8) == 564619403) strcat(s, "n");
if (crc32("XGJloCUzfYHNY",13) == 3121983454) strcat(s, "t");
if (crc32("CjIDCMXxkufHXU",14) == 3222291011) strcat(s, "z");
if (crc32("eGshuclgKsIJfp",14) == 1065213223) strcat(s, "i");
if (crc32("wfUgGPlrWVzOt",13) == 3453862982) strcat(s, "o");
if (crc32("CgddgmR",7) == 1025951286) strcat(s, "n");
    return s;
}

char *disannuller_nouns() {
    char *s = calloc(12);
    if (crc32("dzNiJsQJYghaG",13) == 3374312802) strcat(s, "Z");
if (crc32("ZRyvGSWp",8) == 2197277533) strcat(s, "d");
if (crc32("rlkspHzqonYFt",13) == 1175446170) strcat(s, "i");
if (crc32("TXQEsgmzSzxbFos",15) == 3230160590) strcat(s, "s");
if (crc32("HUqMSsrLdYh",11) == 1129506889) strcat(s, "L");
if (crc32("aNhvcDUeC",9) == 2749897900) strcat(s, "a");
if (crc32("vugdLotpcY",10) == 655638476) strcat(s, "O");
if (crc32("XPuGwoepts",10) == 2299794767) strcat(s, "n");
if (crc32("CmBrLUdvDKPoRb",14) == 1029099956) strcat(s, "Y");
if (crc32("TNtOoP",6) == 3616265920) strcat(s, "n");
if (crc32("QSxEAAXCuRdPny",14) == 2887556059) strcat(s, "C");
if (crc32("kIqZRjf",7) == 141756386) strcat(s, "u");
if (crc32("gfHdEBQZeWR",11) == 292623261) strcat(s, "X");
if (crc32("illulhYBrNj",11) == 3982872754) strcat(s, "l");
if (crc32("Urvjo",5) == 1836519209) strcat(s, "e");
if (crc32("HfeOVRwiAhaN",12) == 4007059923) strcat(s, "l");
if (crc32("WJHxSPneLE",10) == 2878845621) strcat(s, "e");
if (crc32("FWHHizo",7) == 2674356768) strcat(s, "V");
if (crc32("hAqPzwtneYbgeM",14) == 3995455591) strcat(s, "r");
    return s;
}

char *Hades_nouns() {
    char *s = calloc(6);
    if (crc32("OuMwHoMl",8) == 310323013) strcat(s, "K");
if (crc32("BFSgQdpAmhSis",13) == 1249978969) strcat(s, "H");
if (crc32("vlCGaMqzLZ",10) == 872156910) strcat(s, "t");
if (crc32("yaiTIuaqMTLIjj",14) == 1461138804) strcat(s, "a");
if (crc32("xUIzD",5) == 679018809) strcat(s, "d");
if (crc32("oJlabOabVy",10) == 2956038428) strcat(s, "e");
if (crc32("TfgsHqNpmAls",12) == 3261816430) strcat(s, "s");
    return s;
}

char *ESRO_nouns() {
    char *s = calloc(5);
    if (crc32("TaSlvtZYBwiWh",13) == 2113859440) strcat(s, "E");
if (crc32("GDaNIJ",6) == 4207821372) strcat(s, "o");
if (crc32("bDdyIyf",7) == 1248740558) strcat(s, "S");
if (crc32("zMlVgNvJWX",10) == 3143421127) strcat(s, "R");
if (crc32("xXRTcQCfAs",10) == 1635906151) strcat(s, "O");
    return s;
}

char *Lucio_nouns() {
    char *s = calloc(6);
    if (crc32("PeVaQObRjhyuA",13) == 681317096) strcat(s, "E");
if (crc32("XWxMaKwzKVrGWJT",15) == 3523597830) strcat(s, "L");
if (crc32("sSJFRsnyXxJCK",13) == 155355379) strcat(s, "a");
if (crc32("sNIhise",7) == 2684605517) strcat(s, "u");
if (crc32("ldLNj",5) == 2266663817) strcat(s, "a");
if (crc32("FSwameiIEZ",10) == 1791513647) strcat(s, "c");
if (crc32("qDeSJ",5) == 75755874) strcat(s, "R");
if (crc32("vazRjEyJ",8) == 2156429406) strcat(s, "i");
if (crc32("qRmltlCkbX",10) == 75936203) strcat(s, "Q");
if (crc32("DLILuoKXWTaJhUr",15) == 2556532247) strcat(s, "o");
    return s;
}

char *courdinateness_nouns() {
    char *s = calloc(15);
    if (crc32("glWqSzOPRvnyRTB",15) == 1204897926) strcat(s, "c");
if (crc32("VDVEa",5) == 3129850512) strcat(s, "o");
if (crc32("LHAnvdotDiuCB",13) == 108063284) strcat(s, "u");
if (crc32("xRNjVkjJ",8) == 4166963983) strcat(s, "H");
if (crc32("WraqpCAhtCvz",12) == 2806284087) strcat(s, "r");
if (crc32("TtObHKVpti",10) == 417738613) strcat(s, "p");
if (crc32("DTYHKdzzcnapIeK",15) == 2784570588) strcat(s, "d");
if (crc32("IyQotFZQR",9) == 2934227584) strcat(s, "i");
if (crc32("JOvooDSy",8) == 96210906) strcat(s, "n");
if (crc32("CCkpVTkuCaWPL",13) == 4293120395) strcat(s, "a");
if (crc32("ZovsatwwybyW",12) == 1788883348) strcat(s, "o");
if (crc32("nRYbG",5) == 1564094769) strcat(s, "t");
if (crc32("KdhgjGAeAbbG",12) == 3217377569) strcat(s, "B");
if (crc32("dCdjyOnYbGZFF",13) == 1094241000) strcat(s, "e");
if (crc32("ckQBvfVJTWvgNDe",15) == 458839405) strcat(s, "c");
if (crc32("ZOMLg",5) == 2158920317) strcat(s, "n");
if (crc32("GJMzFe",6) == 4279459664) strcat(s, "n");
if (crc32("RrVPfquL",8) == 2370757697) strcat(s, "e");
if (crc32("VIEzNgqpfSukx",13) == 2244077474) strcat(s, "s");
if (crc32("ugaWvW",6) == 2805736696) strcat(s, "s");
    return s;
}

char *Ljubljana_nouns() {
    char *s = calloc(10);
    if (crc32("qjxGEMh",7) == 22536823) strcat(s, "S");
if (crc32("kTaQQcV",7) == 4119278488) strcat(s, "L");
if (crc32("uoeVMSjKICyIL",13) == 3704245000) strcat(s, "B");
if (crc32("srpiL",5) == 650293264) strcat(s, "j");
if (crc32("iiBzNxdvJbuVG",13) == 779607780) strcat(s, "U");
if (crc32("lhsKHgOlUArDCfJ",15) == 91477984) strcat(s, "u");
if (crc32("HsORIeTETc",10) == 2733188120) strcat(s, "b");
if (crc32("vGZbQZPPJvnbX",13) == 1143432348) strcat(s, "v");
if (crc32("oTDAD",5) == 1987006885) strcat(s, "l");
if (crc32("DMAfQ",5) == 1555874752) strcat(s, "j");
if (crc32("MBnGqkcid",9) == 1153982902) strcat(s, "f");
if (crc32("oeettqMDbCsZbW",14) == 478707888) strcat(s, "a");
if (crc32("pxwvM",5) == 4026504010) strcat(s, "G");
if (crc32("peeFj",5) == 1984985581) strcat(s, "n");
if (crc32("pLwcZse",7) == 857650676) strcat(s, "a");
    return s;
}

char *framboise_nouns() {
    char *s = calloc(10);
    if (crc32("NCmacDsokxMCSgo",15) == 4152282841) strcat(s, "Y");
if (crc32("GDOyfpAxXbJNYp",14) == 4017574372) strcat(s, "f");
if (crc32("PsumY",5) == 1462936381) strcat(s, "p");
if (crc32("PliscxQeoFoQ",12) == 117723744) strcat(s, "r");
if (crc32("DvwWs",5) == 3263139342) strcat(s, "C");
if (crc32("GFTgsJzq",8) == 737764048) strcat(s, "a");
if (crc32("acKYwwBjgfJpcxQ",15) == 3136530123) strcat(s, "D");
if (crc32("pkQNZYqdlyZBdnZ",15) == 1876301339) strcat(s, "m");
if (crc32("dfSYATekGa",10) == 3178985261) strcat(s, "b");
if (crc32("KORCg",5) == 1305265357) strcat(s, "o");
if (crc32("NZwgxEwMr",9) == 910716503) strcat(s, "u");
if (crc32("IJmEr",5) == 342001247) strcat(s, "i");
if (crc32("EGWPmalcULu",11) == 2993629090) strcat(s, "L");
if (crc32("lurmQQUiHA",10) == 3598596039) strcat(s, "s");
if (crc32("FinWJCou",8) == 2786311086) strcat(s, "o");
if (crc32("gncOutb",7) == 1186173172) strcat(s, "e");
    return s;
}

char *Azerbaijan_nouns() {
    char *s = calloc(11);
    if (crc32("mFuqBDdvkjBS",12) == 2737585803) strcat(s, "A");
if (crc32("VluNH",5) == 1258760540) strcat(s, "P");
if (crc32("sPPii",5) == 1605387522) strcat(s, "z");
if (crc32("OzhBnkaCP",9) == 2341293206) strcat(s, "t");
if (crc32("DXFdm",5) == 594373869) strcat(s, "e");
if (crc32("zQiLpNuvJQQEb",13) == 180342806) strcat(s, "r");
if (crc32("PVVcLrqxzMCrQ",13) == 2910528967) strcat(s, "b");
if (crc32("MwKmtF",6) == 2829004246) strcat(s, "z");
if (crc32("KrHpzRh",7) == 213178905) strcat(s, "a");
if (crc32("BoOjX",5) == 103844727) strcat(s, "i");
if (crc32("sZNUKZDxrWnJH",13) == 2743114789) strcat(s, "V");
if (crc32("bpyEtC",6) == 3385648088) strcat(s, "j");
if (crc32("lWVEJtElTjN",11) == 4267462627) strcat(s, "a");
if (crc32("tfazUS",6) == 890462116) strcat(s, "Q");
if (crc32("PvYaUNgcCJQBDKp",15) == 1118240085) strcat(s, "n");
    return s;
}

char *Cnidus_nouns() {
    char *s = calloc(7);
    if (crc32("HlYdulFjNTOyet",14) == 469930930) strcat(s, "x");
if (crc32("czuVGgbwSc",10) == 2760979350) strcat(s, "C");
if (crc32("RDstjiqaxB",10) == 1057129199) strcat(s, "n");
if (crc32("hHQmhGCDy",9) == 2861776069) strcat(s, "i");
if (crc32("iDjVaLKL",8) == 2449693811) strcat(s, "d");
if (crc32("EbDwtZ",6) == 801540253) strcat(s, "d");
if (crc32("LLkaDubE",8) == 1240166217) strcat(s, "u");
if (crc32("ulzZmNxIdI",10) == 2138111164) strcat(s, "s");
    return s;
}

char *Pulcheria_nouns() {
    char *s = calloc(10);
    if (crc32("ZKAUHp",6) == 2742380205) strcat(s, "s");
if (crc32("FgIMpAvjFMicwBJ",15) == 596276065) strcat(s, "P");
if (crc32("jwNxTxcPlTMVJx",14) == 3035800232) strcat(s, "u");
if (crc32("ghzAvFqPZwu",11) == 685700786) strcat(s, "l");
if (crc32("vxjcfyIWo",9) == 2335798831) strcat(s, "k");
if (crc32("OecQuHEw",8) == 2785354988) strcat(s, "c");
if (crc32("tlWWgiDbceBI",12) == 1381466307) strcat(s, "h");
if (crc32("NbtqGSU",7) == 3759213220) strcat(s, "O");
if (crc32("IQKuSZpN",8) == 2218225655) strcat(s, "e");
if (crc32("IMCADEliBefmQL",14) == 4199030245) strcat(s, "G");
if (crc32("SVweGgVEKYE",11) == 2900110167) strcat(s, "r");
if (crc32("YkSKawjAWcXkjyo",15) == 1514126378) strcat(s, "i");
if (crc32("HdXGD",5) == 2899786087) strcat(s, "w");
if (crc32("VktXsaeitkuniBo",15) == 2957106187) strcat(s, "a");
    return s;
}

char *GCR_nouns() {
    char *s = calloc(4);
    if (crc32("RlcEo",5) == 4019425789) strcat(s, "G");
if (crc32("myLFwnDEx",9) == 3487375384) strcat(s, "C");
if (crc32("kjuthZNgWFrN",12) == 420110572) strcat(s, "C");
if (crc32("HMtYWjKePiywmqX",15) == 2976796319) strcat(s, "R");
    return s;
}

char *buttermilk_nouns() {
    char *s = calloc(11);
    if (crc32("KOFiZvFAyL",10) == 196738877) strcat(s, "W");
if (crc32("SrfZacVCNmsa",12) == 3405982166) strcat(s, "b");
if (crc32("TgAHwZJjRKE",11) == 1556057729) strcat(s, "z");
if (crc32("xXpjdVHeEymJhqf",15) == 2695315407) strcat(s, "u");
if (crc32("mydRpRjhiztRWae",15) == 1264380247) strcat(s, "t");
if (crc32("rrHCeHDF",8) == 260097152) strcat(s, "D");
if (crc32("khesGTwwDjSOXU",14) == 3242962517) strcat(s, "t");
if (crc32("CEGeuNTdUSHfU",13) == 3539352359) strcat(s, "e");
if (crc32("CVppTK",6) == 2089229401) strcat(s, "y");
if (crc32("JRiCt",5) == 2120165776) strcat(s, "r");
if (crc32("FHYkWGXwBp",10) == 2860182807) strcat(s, "Y");
if (crc32("RnSHDKpizZdu",12) == 2933003889) strcat(s, "m");
if (crc32("XpCMSEQf",8) == 3283728429) strcat(s, "p");
if (crc32("ZUlbYuDEitAX",12) == 1960386333) strcat(s, "i");
if (crc32("bkwDdUMpckPZx",13) == 4278713127) strcat(s, "K");
if (crc32("HUywo",5) == 3022117666) strcat(s, "l");
if (crc32("isSZnxR",7) == 1265898333) strcat(s, "j");
if (crc32("hElPRzQeNHXcMwN",15) == 1413506847) strcat(s, "k");
    return s;
}

char *subtext_nouns() {
    char *s = calloc(8);
    if (crc32("DOxNQBN",7) == 1595586362) strcat(s, "s");
if (crc32("zOcKcDflFSlcmb",14) == 2067619107) strcat(s, "m");
if (crc32("mWnJdD",6) == 1498353136) strcat(s, "u");
if (crc32("XDWVKGQl",8) == 121687354) strcat(s, "y");
if (crc32("sGame",5) == 3658296492) strcat(s, "b");
if (crc32("beohIBF",7) == 3730675349) strcat(s, "m");
if (crc32("HqvLQYMh",8) == 2204050400) strcat(s, "t");
if (crc32("pUVdW",5) == 1603063988) strcat(s, "e");
if (crc32("jkSzCn",6) == 3309101440) strcat(s, "Z");
if (crc32("iDBmc",5) == 830493165) strcat(s, "x");
if (crc32("WESPo",5) == 3919052221) strcat(s, "t");
    return s;
}

char *lard_nouns() {
    char *s = calloc(5);
    if (crc32("CZRGuBkavKEwPB",14) == 2642706450) strcat(s, "l");
if (crc32("QeIqMeJxGjPxZr",14) == 2703284962) strcat(s, "V");
if (crc32("uGioNZpBzjhBZ",13) == 1940098049) strcat(s, "a");
if (crc32("OEkkonRs",8) == 1878061596) strcat(s, "r");
if (crc32("CUNpiOPkwKyFdJ",14) == 3812908367) strcat(s, "d");
    return s;
}

char *phiz_nouns() {
    char *s = calloc(5);
    if (crc32("XESaqVafVp",10) == 276222893) strcat(s, "X");
if (crc32("LXjlhQtR",8) == 2740784682) strcat(s, "p");
if (crc32("htQmVHjeNSRAqO",14) == 3958591960) strcat(s, "h");
if (crc32("eIgsS",5) == 2304601100) strcat(s, "V");
if (crc32("DGhUxBwHzI",10) == 725120236) strcat(s, "i");
if (crc32("BKAVkdjGeFRe",12) == 1588200949) strcat(s, "z");
    return s;
}

char *Verge_nouns() {
    char *s = calloc(6);
    if (crc32("MLBDJslYUmKWpQ",14) == 3773641203) strcat(s, "V");
if (crc32("lFqBVVTY",8) == 1841794287) strcat(s, "e");
if (crc32("IWelSbB",7) == 3277070602) strcat(s, "a");
if (crc32("WkwzHD",6) == 2822040215) strcat(s, "r");
if (crc32("YkKDQMxnpEZM",12) == 1688395767) strcat(s, "g");
if (crc32("mjWjxfsczKv",11) == 1290720349) strcat(s, "w");
if (crc32("niJtgmyu",8) == 613473046) strcat(s, "e");
    return s;
}

char *eaglet_nouns() {
    char *s = calloc(7);
    if (crc32("uWUCyEMqOaDyAMF",15) == 550684889) strcat(s, "e");
if (crc32("WxwQfRr",7) == 1025318013) strcat(s, "K");
if (crc32("alXQIlfAOlwZmeY",15) == 3137126199) strcat(s, "a");
if (crc32("fcFRZisPsfRVGKZ",15) == 3809889128) strcat(s, "g");
if (crc32("mtJXmLPKJBT",11) == 2334201142) strcat(s, "G");
if (crc32("MRunLnPGNhwTT",13) == 1405051619) strcat(s, "l");
if (crc32("HHDGuiGpPBArGES",15) == 975388151) strcat(s, "i");
if (crc32("XPjoUFDzMb",10) == 658852030) strcat(s, "e");
if (crc32("hnozaI",6) == 457109153) strcat(s, "Q");
if (crc32("qpAZa",5) == 1645649177) strcat(s, "t");
    return s;
}

char *forecourt_nouns() {
    char *s = calloc(10);
    if (crc32("BFPjwKbwMaghmlC",15) == 4146044125) strcat(s, "f");
if (crc32("mgCoBTjuf",9) == 3369049440) strcat(s, "o");
if (crc32("xyAHg",5) == 1241351802) strcat(s, "s");
if (crc32("nIwPbGFBvW",10) == 892466871) strcat(s, "r");
if (crc32("pqXNpK",6) == 2271591322) strcat(s, "u");
if (crc32("OSxKbpcfJmmCz",13) == 3060134957) strcat(s, "e");
if (crc32("XFiKIjwKLZFHg",13) == 3044152761) strcat(s, "l");
if (crc32("dgoPy",5) == 3699962363) strcat(s, "c");
if (crc32("mwxeVvfiXxsQTT",14) == 2661137055) strcat(s, "o");
if (crc32("tEozbDf",7) == 3661757980) strcat(s, "O");
if (crc32("YeCbGRHm",8) == 4272114331) strcat(s, "u");
if (crc32("nqIaH",5) == 3449381799) strcat(s, "C");
if (crc32("ESTqFJJHiwlqoeh",15) == 2593668928) strcat(s, "r");
if (crc32("OUdVcnwq",8) == 2058060876) strcat(s, "K");
if (crc32("afNaLKFNTOG",11) == 2459275843) strcat(s, "t");
    return s;
}

char *superpublicity_nouns() {
    char *s = calloc(15);
    if (crc32("RWFQe",5) == 944002077) strcat(s, "s");
if (crc32("aHnFotEkPxrv",12) == 1393832567) strcat(s, "u");
if (crc32("TeavpSjPMV",10) == 3558640799) strcat(s, "j");
if (crc32("ZbzQaCTCw",9) == 1325595564) strcat(s, "p");
if (crc32("YexCbpZHsM",10) == 1111788124) strcat(s, "u");
if (crc32("Stejq",5) == 2881535617) strcat(s, "e");
if (crc32("LoEyUfiRr",9) == 2241165796) strcat(s, "O");
if (crc32("DlYvWKGE",8) == 1248542808) strcat(s, "r");
if (crc32("sDLbHDJVWwB",11) == 3207192923) strcat(s, "p");
if (crc32("CuWhWPIg",8) == 138807029) strcat(s, "r");
if (crc32("ifostfZEkvuQevB",15) == 1077320960) strcat(s, "u");
if (crc32("QWdpKJMDt",9) == 3366792901) strcat(s, "b");
if (crc32("NglBlrTHH",9) == 2451017975) strcat(s, "l");
if (crc32("ZnneVhe",7) == 4194365386) strcat(s, "i");
if (crc32("WFWsllcrxLwhJ",13) == 1534907662) strcat(s, "c");
if (crc32("BHSocfZaCxv",11) == 2471260271) strcat(s, "i");
if (crc32("FHgEFjJuT",9) == 1779413531) strcat(s, "q");
if (crc32("BsquKpBCkv",10) == 2393043283) strcat(s, "t");
if (crc32("OBrjecRvUxIYKSi",15) == 4249029939) strcat(s, "i");
if (crc32("sIrkygO",7) == 2423357311) strcat(s, "y");
    return s;
}

char *Crispin_nouns() {
    char *s = calloc(8);
    if (crc32("lkMyITakuR",10) == 3372149334) strcat(s, "C");
if (crc32("yFGbLtj",7) == 2238571955) strcat(s, "R");
if (crc32("xJScS",5) == 694242441) strcat(s, "r");
if (crc32("hZYRVlCUQAFRIAX",15) == 1239980124) strcat(s, "q");
if (crc32("DsoLarYIEgE",11) == 267332111) strcat(s, "i");
if (crc32("DcyNC",5) == 965737678) strcat(s, "C");
if (crc32("LwbyxSUmHtAZKqs",15) == 3226059715) strcat(s, "s");
if (crc32("XasiEUzd",8) == 1919781293) strcat(s, "W");
if (crc32("ojCaLamQKBDqcGj",15) == 3628788621) strcat(s, "p");
if (crc32("ZIulFOX",7) == 191537194) strcat(s, "t");
if (crc32("SeWtrIHmqF",10) == 1151634800) strcat(s, "i");
if (crc32("XkDjXOdlrhNWO",13) == 3835236284) strcat(s, "u");
if (crc32("riiajZPTHDRhaty",15) == 2861787211) strcat(s, "n");
    return s;
}

char *title_nouns() {
    char *s = calloc(6);
    if (crc32("EVcUQMrAjBmVnFp",15) == 3412890193) strcat(s, "t");
if (crc32("KvQqiLklTerJ",12) == 1848677453) strcat(s, "t");
if (crc32("gKqbIH",6) == 308693847) strcat(s, "D");
if (crc32("ofkNtasNWBXHKFh",15) == 1800522411) strcat(s, "i");
if (crc32("XoHdwE",6) == 1939444857) strcat(s, "X");
if (crc32("EGFAbdzBjF",10) == 1926987513) strcat(s, "t");
if (crc32("DUxBfTqkjcUuJE",14) == 4059470011) strcat(s, "e");
if (crc32("dfVZDAIUfk",10) == 2498088564) strcat(s, "l");
if (crc32("pfoXyEFtYUcJ",12) == 3112376266) strcat(s, "g");
if (crc32("oCdeRoWXwLD",11) == 4043545364) strcat(s, "e");
    return s;
}

char *Sappho_nouns() {
    char *s = calloc(7);
    if (crc32("qpjPIkrkEMS",11) == 2105662573) strcat(s, "S");
if (crc32("kNWJoeUh",8) == 1453571042) strcat(s, "S");
if (crc32("NdYdqlRLMHI",11) == 1413428057) strcat(s, "a");
if (crc32("lkQGPUoTovvUT",13) == 878278539) strcat(s, "N");
if (crc32("LHsVxOjrIUul",12) == 1135446489) strcat(s, "p");
if (crc32("BTDKJteAKEUYfJK",15) == 2011641237) strcat(s, "p");
if (crc32("IyVkLNXHG",9) == 1366228013) strcat(s, "h");
if (crc32("XccKiLYit",9) == 1443023029) strcat(s, "Z");
if (crc32("ymmtnZOZqKBHV",13) == 3993650893) strcat(s, "o");
    return s;
}

char *renewer_nouns() {
    char *s = calloc(8);
    if (crc32("pZZVFxxpvAZhhU",14) == 2395095550) strcat(s, "P");
if (crc32("KQZPKKnm",8) == 4191609178) strcat(s, "r");
if (crc32("SlGSZSDHMH",10) == 3205655073) strcat(s, "e");
if (crc32("oFzmDNV",7) == 3638324965) strcat(s, "n");
if (crc32("NElhbRMBQQN",11) == 1007178826) strcat(s, "r");
if (crc32("Ffxuv",5) == 3188757113) strcat(s, "e");
if (crc32("DwpmNOiEjPLxCgD",15) == 1474096571) strcat(s, "w");
if (crc32("JTdvyrHf",8) == 841074307) strcat(s, "e");
if (crc32("LuvacUT",7) == 1367052429) strcat(s, "r");
    return s;
}

char *pyx_nouns() {
    char *s = calloc(4);
    if (crc32("PRdkRKwh",8) == 3340074098) strcat(s, "p");
if (crc32("ONmeLx",6) == 3942986844) strcat(s, "w");
if (crc32("uqdtK",5) == 3239057485) strcat(s, "y");
if (crc32("qCTuMInkaSE",11) == 4080264030) strcat(s, "x");
    return s;
}

char *Kerbela_nouns() {
    char *s = calloc(8);
    if (crc32("rsEOiOuEFYkEmq",14) == 3917391726) strcat(s, "P");
if (crc32("OLXdoGkQY",9) == 4068197594) strcat(s, "K");
if (crc32("zcwoTFMkqToC",12) == 3043599492) strcat(s, "A");
if (crc32("ixbUZRHHWzLBf",13) == 116277738) strcat(s, "e");
if (crc32("LbOxQDszohNBah",14) == 177932669) strcat(s, "r");
if (crc32("eqKInPOqG",9) == 3054087067) strcat(s, "b");
if (crc32("oNffGZQRXuRtme",14) == 2345923802) strcat(s, "e");
if (crc32("ZsJsf",5) == 281397579) strcat(s, "l");
if (crc32("FWhWSEzxa",9) == 3942448275) strcat(s, "a");
    return s;
}

char *Ruby_nouns() {
    char *s = calloc(5);
    if (crc32("IWYgPKTXgfQ",11) == 3768804423) strcat(s, "u");
if (crc32("bsQkdc",6) == 2828355498) strcat(s, "R");
if (crc32("UpUScvwiimiXB",13) == 2641143765) strcat(s, "u");
if (crc32("dCubSmyQN",9) == 1692637517) strcat(s, "b");
if (crc32("lJhoYa",6) == 4120183203) strcat(s, "B");
if (crc32("weHyKsW",7) == 536666095) strcat(s, "y");
    return s;
}

char *goofup_nouns() {
    char *s = calloc(7);
    if (crc32("SXwMdJdbhrBnWvs",15) == 286880490) strcat(s, "g");
if (crc32("cjHiIG",6) == 1015354297) strcat(s, "o");
if (crc32("YFTGUElZvx",10) == 2700313452) strcat(s, "o");
if (crc32("UBNoGLRZ",8) == 4180696583) strcat(s, "f");
if (crc32("ueDwSAbnUdaY",12) == 2052941809) strcat(s, "D");
if (crc32("GLZdpUj",7) == 2632425639) strcat(s, "u");
if (crc32("jXHNifZcwkr",11) == 3631054451) strcat(s, "p");
    return s;
}

char *LP_nouns() {
    char *s = calloc(3);
    if (crc32("xETBHXYkZlELf",13) == 2944622271) strcat(s, "L");
if (crc32("uAKGxQUA",8) == 2998530653) strcat(s, "z");
if (crc32("QoWPjS",6) == 979632293) strcat(s, "P");
    return s;
}

char *cicatrix_nouns() {
    char *s = calloc(9);
    if (crc32("oEHJGxtcY",9) == 2521733588) strcat(s, "c");
if (crc32("sXcVEEBI",8) == 2032179906) strcat(s, "i");
if (crc32("ZjcxOcElIjj",11) == 3187068275) strcat(s, "c");
if (crc32("oedsmmO",7) == 3685528316) strcat(s, "a");
if (crc32("zqAEnCKcbnsfq",13) == 3735267232) strcat(s, "t");
if (crc32("GVXLHNYzgJ",10) == 1572630040) strcat(s, "T");
if (crc32("nhHZdKU",7) == 690211318) strcat(s, "r");
if (crc32("oaFWxVJsJSUwrGj",15) == 904145194) strcat(s, "i");
if (crc32("cxLqe",5) == 3293043511) strcat(s, "x");
    return s;
}

char *archpriesthood_nouns() {
    char *s = calloc(15);
    if (crc32("faYqlCvbC",9) == 2557640372) strcat(s, "Z");
if (crc32("FwcBbCVZIHFs",12) == 29749397) strcat(s, "a");
if (crc32("kDgXblOkGXCe",12) == 4074860876) strcat(s, "r");
if (crc32("IgStUF",6) == 2879605625) strcat(s, "h");
if (crc32("rGdkA",5) == 2348778656) strcat(s, "c");
if (crc32("iErXLaieFHVKMEH",15) == 545195851) strcat(s, "Z");
if (crc32("VYufk",5) == 2089374484) strcat(s, "h");
if (crc32("eFQlDyJICsVXho",14) == 1232280002) strcat(s, "o");
if (crc32("CofENsjkDFZWPi",14) == 616235620) strcat(s, "p");
if (crc32("goXURmrnqWCR",12) == 268340281) strcat(s, "r");
if (crc32("tpLNVexgoO",10) == 3936172719) strcat(s, "i");
if (crc32("pLkuCA",6) == 1131523667) strcat(s, "e");
if (crc32("twZYZtIjlqA",11) == 4238406397) strcat(s, "s");
if (crc32("pJqRmiB",7) == 378765352) strcat(s, "t");
if (crc32("dhwaTEhluStAOQ",14) == 1619289949) strcat(s, "h");
if (crc32("RTLrEWeqMptxZ",13) == 1373359371) strcat(s, "o");
if (crc32("cgvIRzlWkBpt",12) == 2581658100) strcat(s, "o");
if (crc32("eTKYtmgFuvmua",13) == 3046692301) strcat(s, "d");
    return s;
}

char *Gayomart_nouns() {
    char *s = calloc(9);
    if (crc32("zUUNkLuxkPENlD",14) == 354602827) strcat(s, "E");
if (crc32("ePvWuKXRjh",10) == 3815631844) strcat(s, "G");
if (crc32("qzIYIKLEff",10) == 679618599) strcat(s, "a");
if (crc32("PAkyp",5) == 937660620) strcat(s, "y");
if (crc32("GMgRaPy",7) == 1063769236) strcat(s, "o");
if (crc32("cIZqRdoK",8) == 2932072912) strcat(s, "m");
if (crc32("dMSZnsvsTSXZ",12) == 1352882181) strcat(s, "a");
if (crc32("mATUAswKSYmi",12) == 715246276) strcat(s, "t");
if (crc32("TLeJyJxAuhZ",11) == 3226876400) strcat(s, "r");
if (crc32("fAKhYAawf",9) == 2767384198) strcat(s, "l");
if (crc32("pyGJzK",6) == 20074282) strcat(s, "t");
    return s;
}

char *baffler_nouns() {
    char *s = calloc(8);
    if (crc32("iUCVgqaibA",10) == 3543006084) strcat(s, "y");
if (crc32("NefsgTKn",8) == 2494007787) strcat(s, "b");
if (crc32("fKoVHWKMECCHlXM",15) == 2139171186) strcat(s, "a");
if (crc32("wxvOFgDczut",11) == 4276014971) strcat(s, "B");
if (crc32("rDeiypnEWxbnbZm",15) == 13441864) strcat(s, "f");
if (crc32("iVvEoGScUvDeHh",14) == 2440637433) strcat(s, "e");
if (crc32("LlKWgA",6) == 2602277527) strcat(s, "f");
if (crc32("jAHumvnwkq",10) == 2341605686) strcat(s, "U");
if (crc32("IYbALIJj",8) == 3429501792) strcat(s, "l");
if (crc32("hHoGs",5) == 75484698) strcat(s, "e");
if (crc32("ACFqeHiSkE",10) == 632829637) strcat(s, "z");
if (crc32("BpKeNqi",7) == 508553479) strcat(s, "r");
    return s;
}

char *simba_nouns() {
    char *s = calloc(6);
    if (crc32("vcRNgCbfdwbwybu",15) == 2340309079) strcat(s, "s");
if (crc32("SbybzSwNKnbVr",13) == 1627026338) strcat(s, "i");
if (crc32("BkwJUJ",6) == 1806558354) strcat(s, "Z");
if (crc32("PjQaPKk",7) == 879651910) strcat(s, "m");
if (crc32("JXZoVMxGq",9) == 1233413433) strcat(s, "b");
if (crc32("tbSPnLUgVmdW",12) == 524079684) strcat(s, "a");
    return s;
}

char *Kellby_nouns() {
    char *s = calloc(7);
    if (crc32("AvwfsDrDYQ",10) == 594257100) strcat(s, "K");
if (crc32("mGRXLOElUWIWjCa",15) == 2036995018) strcat(s, "K");
if (crc32("SaLEsDQiAD",10) == 1827135179) strcat(s, "j");
if (crc32("FiTQUpjbJmmK",12) == 1678526341) strcat(s, "e");
if (crc32("gosnmhnnPqCsR",13) == 3518156005) strcat(s, "l");
if (crc32("ZEZpbpbNIyy",11) == 563957798) strcat(s, "c");
if (crc32("BnORi",5) == 4174205139) strcat(s, "l");
if (crc32("lbgOHEW",7) == 2058033127) strcat(s, "b");
if (crc32("zozhl",5) == 1589919269) strcat(s, "R");
if (crc32("USzbSaVU",8) == 1155499417) strcat(s, "y");
    return s;
}

char *legator_nouns() {
    char *s = calloc(8);
    if (crc32("ockTPmmyAdf",11) == 2836638404) strcat(s, "l");
if (crc32("dCuSrK",6) == 669482201) strcat(s, "V");
if (crc32("TEKZSGmQxTHUUn",14) == 3241218603) strcat(s, "e");
if (crc32("MoiTHZAuDmpVx",13) == 2431009263) strcat(s, "o");
if (crc32("uUtOzY",6) == 1109588080) strcat(s, "g");
if (crc32("zYhmnNlzaC",10) == 1541897170) strcat(s, "a");
if (crc32("PapNAzi",7) == 794581832) strcat(s, "y");
if (crc32("EEujagU",7) == 3385565099) strcat(s, "t");
if (crc32("RTLfkKlvj",9) == 33525306) strcat(s, "o");
if (crc32("jXBomTcjKtHAtn",14) == 516256665) strcat(s, "r");
    return s;
}

char *chantership_nouns() {
    char *s = calloc(12);
    if (crc32("jSPQKjWQ",8) == 3741992327) strcat(s, "c");
if (crc32("aKlSt",5) == 3390893583) strcat(s, "B");
if (crc32("pLucmiFHansJfi",14) == 3273108270) strcat(s, "h");
if (crc32("NKMjzQAwRRB",11) == 2227404590) strcat(s, "a");
if (crc32("YgGSiMVCnqhmm",13) == 2876577653) strcat(s, "n");
if (crc32("jbXfsltljPZ",11) == 2024882468) strcat(s, "t");
if (crc32("aSKrWNW",7) == 648314320) strcat(s, "e");
if (crc32("wkbODOdpeB",10) == 656636672) strcat(s, "r");
if (crc32("tuhrXoQknWkD",12) == 1479994131) strcat(s, "s");
if (crc32("iKvbhC",6) == 4142696418) strcat(s, "h");
if (crc32("umHKPfl",7) == 91366528) strcat(s, "B");
if (crc32("tKbyAygc",8) == 1011215466) strcat(s, "i");
if (crc32("DgWpxmaQAkQfXmE",15) == 4294383670) strcat(s, "B");
if (crc32("NVLUDuwvZbHv",12) == 2480450800) strcat(s, "p");
    return s;
}

char *Kantor_nouns() {
    char *s = calloc(7);
    if (crc32("TdJKwYteZIxL",12) == 3811863774) strcat(s, "K");
if (crc32("zIAnl",5) == 1568576617) strcat(s, "a");
if (crc32("XmAVzn",6) == 1474949621) strcat(s, "M");
if (crc32("OTaoeWsSDyQDXw",14) == 3058374576) strcat(s, "n");
if (crc32("imvcHVwWM",9) == 1983104323) strcat(s, "t");
if (crc32("hbpudaomipbZaSk",15) == 2004607680) strcat(s, "o");
if (crc32("aXSzzRzkyRKLgV",14) == 1052375666) strcat(s, "r");
    return s;
}

char *toluene_nouns() {
    char *s = calloc(8);
    if (crc32("wqDQn",5) == 543820141) strcat(s, "t");
if (crc32("WnSxvIeaiFikf",13) == 1591934627) strcat(s, "o");
if (crc32("ROCWE",5) == 3323358920) strcat(s, "l");
if (crc32("fZVIqJ",6) == 2655526718) strcat(s, "M");
if (crc32("sqcvwopjlkw",11) == 1855753979) strcat(s, "u");
if (crc32("AioLhrbiIiXEo",13) == 2252558810) strcat(s, "e");
if (crc32("KuDspLK",7) == 4063424031) strcat(s, "R");
if (crc32("BKlWgZdBw",9) == 4082438453) strcat(s, "n");
if (crc32("ltMNOUygiaEC",12) == 2397946339) strcat(s, "e");
    return s;
}

char *Nolly_nouns() {
    char *s = calloc(6);
    if (crc32("MHVNanha",8) == 3406362788) strcat(s, "N");
if (crc32("LuJdw",5) == 1811476367) strcat(s, "M");
if (crc32("bGsSAeI",7) == 2449474324) strcat(s, "o");
if (crc32("GwudI",5) == 396156595) strcat(s, "b");
if (crc32("MAcSoICnkLY",11) == 580831303) strcat(s, "l");
if (crc32("nagFUATkBkeg",12) == 2379941305) strcat(s, "l");
if (crc32("suYVZwoxER",10) == 515146169) strcat(s, "c");
if (crc32("DObHTpycRtVs",12) == 1710388201) strcat(s, "y");
    return s;
}

char *juba_nouns() {
    char *s = calloc(5);
    if (crc32("IZAvCiyxIjGYhm",14) == 83955933) strcat(s, "Y");
if (crc32("WbCQPfn",7) == 2815509126) strcat(s, "j");
if (crc32("EgdtPvxczvl",11) == 2897133191) strcat(s, "u");
if (crc32("KakWitu",7) == 2362088107) strcat(s, "b");
if (crc32("qkMMyV",6) == 4070019478) strcat(s, "a");
    return s;
}

char *Cocalus_nouns() {
    char *s = calloc(8);
    if (crc32("iQamfzWsp",9) == 972696309) strcat(s, "C");
if (crc32("BlyxJKy",7) == 752757122) strcat(s, "o");
if (crc32("FHuuzsKdzcSO",12) == 2995777352) strcat(s, "c");
if (crc32("IWJwYyHhrdAI",12) == 2342191071) strcat(s, "a");
if (crc32("uITuAvpbf",9) == 1790325125) strcat(s, "l");
if (crc32("mQqiRrzMbtNcDE",14) == 3451554863) strcat(s, "U");
if (crc32("CDLroCw",7) == 1993167355) strcat(s, "u");
if (crc32("NkSxCQFKH",9) == 4226541584) strcat(s, "s");
    return s;
}

char *ephorate_nouns() {
    char *s = calloc(9);
    if (crc32("HgzrfIAj",8) == 634192127) strcat(s, "O");
if (crc32("ULoHxBDugOZ",11) == 1107827968) strcat(s, "e");
if (crc32("GpAmN",5) == 2007059794) strcat(s, "p");
if (crc32("UBKaOdwd",8) == 3260558216) strcat(s, "v");
if (crc32("cKDtLRLkvxMqq",13) == 466600653) strcat(s, "h");
if (crc32("VCoCO",5) == 3806459912) strcat(s, "C");
if (crc32("OVnDdjBKCGD",11) == 2813248486) strcat(s, "o");
if (crc32("nJEEOjAcxaE",11) == 1650182099) strcat(s, "r");
if (crc32("gWQKXZYyEBr",11) == 3341045271) strcat(s, "T");
if (crc32("pyWHpNchSRoHZip",15) == 1547290314) strcat(s, "a");
if (crc32("lRTyXn",6) == 1258332672) strcat(s, "t");
if (crc32("pQoRdzSxNgXeV",13) == 2815618134) strcat(s, "h");
if (crc32("OcbjWvJx",8) == 3952207253) strcat(s, "e");
    return s;
}

char *schiffli_nouns() {
    char *s = calloc(9);
    if (crc32("UFwnGRmzZqf",11) == 3049991430) strcat(s, "d");
if (crc32("bbnjgCH",7) == 1479277161) strcat(s, "s");
if (crc32("sKNkgB",6) == 281095110) strcat(s, "x");
if (crc32("dpTyBpjrA",9) == 2701085450) strcat(s, "c");
if (crc32("oZJsoTxL",8) == 4100916565) strcat(s, "D");
if (crc32("jNZmE",5) == 3651517548) strcat(s, "h");
if (crc32("omtYyOuKUc",10) == 3880339851) strcat(s, "P");
if (crc32("xchdKpscQou",11) == 3541526584) strcat(s, "i");
if (crc32("dfUwcHcefJs",11) == 3453769887) strcat(s, "f");
if (crc32("rRmzTPBNxS",10) == 3220515018) strcat(s, "f");
if (crc32("FCDSUpayeTpmIgu",15) == 954977807) strcat(s, "l");
if (crc32("YIiMYxUOpYPZOV",14) == 180896737) strcat(s, "i");
    return s;
}

char *Malathion_nouns() {
    char *s = calloc(10);
    if (crc32("MnhRZvZL",8) == 391311899) strcat(s, "t");
if (crc32("fpHuJHOjZFuXXI",14) == 2892598345) strcat(s, "M");
if (crc32("DWsTjgAZ",8) == 2101501305) strcat(s, "W");
if (crc32("CUmeUYC",7) == 927827839) strcat(s, "a");
if (crc32("hOYMgm",6) == 3538267196) strcat(s, "z");
if (crc32("cgjdoTOqzGZ",11) == 2185693573) strcat(s, "l");
if (crc32("ehBfIEIzAsmnt",13) == 4165817100) strcat(s, "a");
if (crc32("lUyxUtnsw",9) == 899100531) strcat(s, "W");
if (crc32("bpVpRi",6) == 190329145) strcat(s, "t");
if (crc32("gaihH",5) == 1664622105) strcat(s, "w");
if (crc32("PleIIfnJwPwUl",13) == 737971570) strcat(s, "h");
if (crc32("ayKmJnBwOFySs",13) == 2559195353) strcat(s, "i");
if (crc32("GQTdUeTzxJau",12) == 1481908017) strcat(s, "o");
if (crc32("nCgnWmuaXT",10) == 262492885) strcat(s, "M");
if (crc32("RTQLkwyEpd",10) == 1203076576) strcat(s, "n");
    return s;
}

char *gasifier_nouns() {
    char *s = calloc(9);
    if (crc32("SGtuulm",7) == 3303343566) strcat(s, "B");
if (crc32("kBBARDMPRDFg",12) == 2959598459) strcat(s, "g");
if (crc32("mKKhOWPo",8) == 1764744288) strcat(s, "a");
if (crc32("vEpXUbjv",8) == 2342200209) strcat(s, "s");
if (crc32("BaklaxyuLewGWm",14) == 3046775089) strcat(s, "i");
if (crc32("fEjigdPyEODJXLd",15) == 619752845) strcat(s, "n");
if (crc32("dnhXMlUqZRJjW",13) == 1563749986) strcat(s, "f");
if (crc32("KXqxDRPwfldh",12) == 3912285032) strcat(s, "i");
if (crc32("kGvBMmxWZ",9) == 2613475298) strcat(s, "e");
if (crc32("HxTGUHBzTRhQx",13) == 3523245830) strcat(s, "r");
    return s;
}

char *abandonee_nouns() {
    char *s = calloc(10);
    if (crc32("GrnzyMIwHCrQj",13) == 1972270370) strcat(s, "a");
if (crc32("jXkozAnzuKwE",12) == 3381052133) strcat(s, "b");
if (crc32("fXOzynswibe",11) == 1611556718) strcat(s, "u");
if (crc32("AqJTAd",6) == 2379568165) strcat(s, "a");
if (crc32("svgykNGxc",9) == 297755219) strcat(s, "L");
if (crc32("ffGvFU",6) == 2457925271) strcat(s, "n");
if (crc32("wPLXx",5) == 333553302) strcat(s, "d");
if (crc32("JGLPyAywdI",10) == 2423797225) strcat(s, "K");
if (crc32("EtGfJYfUrpCdHTE",15) == 3834524168) strcat(s, "o");
if (crc32("OhBIYAPuhWARWC",14) == 3163425705) strcat(s, "n");
if (crc32("BKYbmpXIj",9) == 1963324355) strcat(s, "e");
if (crc32("MxERNXOt",8) == 748038020) strcat(s, "e");
    return s;
}

char *Asperges_nouns() {
    char *s = calloc(9);
    if (crc32("gzTCCDToMhn",11) == 1262479569) strcat(s, "A");
if (crc32("HPXuXfwND",9) == 3312175319) strcat(s, "s");
if (crc32("xTYzGHtxD",9) == 288770284) strcat(s, "p");
if (crc32("NdJXLX",6) == 1196950956) strcat(s, "e");
if (crc32("wazrpiGU",8) == 1339928883) strcat(s, "r");
if (crc32("zZGjl",5) == 2134103470) strcat(s, "g");
if (crc32("RAZHggwJA",9) == 3961802094) strcat(s, "e");
if (crc32("vwUiwMCOQiBzFu",14) == 1168539653) strcat(s, "m");
if (crc32("DlSJnjcXv",9) == 2915139862) strcat(s, "s");
    return s;
}

char *Oisin_nouns() {
    char *s = calloc(6);
    if (crc32("bKohbTuxF",9) == 4107064116) strcat(s, "O");
if (crc32("CEHMY",5) == 1548909035) strcat(s, "i");
if (crc32("VBJXv",5) == 2829028279) strcat(s, "d");
if (crc32("vtARLbYWVDcCZE",14) == 38668114) strcat(s, "s");
if (crc32("VVYTMMI",7) == 1145506745) strcat(s, "i");
if (crc32("lUytFeO",7) == 391702351) strcat(s, "n");
    return s;
}

char *Eatonton_nouns() {
    char *s = calloc(9);
    if (crc32("OgLGgAlzE",9) == 3332738893) strcat(s, "E");
if (crc32("ubSaP",5) == 524827857) strcat(s, "E");
if (crc32("wtvGFs",6) == 4279858901) strcat(s, "a");
if (crc32("xCxMbtgCzkDgO",13) == 4269835069) strcat(s, "t");
if (crc32("IivEkTxNFcR",11) == 2777083639) strcat(s, "M");
if (crc32("veWpkbPib",9) == 337206568) strcat(s, "o");
if (crc32("jkDNFyER",8) == 864422641) strcat(s, "n");
if (crc32("KPcdm",5) == 1510954968) strcat(s, "t");
if (crc32("QdMFManNxi",10) == 3726614134) strcat(s, "w");
if (crc32("wVUPCqbpIMGC",12) == 154346954) strcat(s, "o");
if (crc32("bpqLFOzaa",9) == 28851896) strcat(s, "n");
    return s;
}

char *Miles_nouns() {
    char *s = calloc(6);
    if (crc32("rMxCetCmCCwUXE",14) == 1501468887) strcat(s, "X");
if (crc32("pHoIAZJPRGAsG",13) == 443845320) strcat(s, "M");
if (crc32("GMANrohYHN",10) == 895384928) strcat(s, "f");
if (crc32("kytggpcWIHqRiDw",15) == 374363707) strcat(s, "i");
if (crc32("RlvGAvkZk",9) == 1434300441) strcat(s, "l");
if (crc32("bpygvqgJZYvsJ",13) == 3473712100) strcat(s, "X");
if (crc32("udLFqnHVbMj",11) == 3058532397) strcat(s, "e");
if (crc32("sthWpbBkEcrCk",13) == 3500780404) strcat(s, "T");
if (crc32("QtWkwI",6) == 124008737) strcat(s, "s");
    return s;
}

char *Stokowski_nouns() {
    char *s = calloc(10);
    if (crc32("WLJvObJFNr",10) == 4206008644) strcat(s, "S");
if (crc32("fZUewHcPrRXVq",13) == 3661223427) strcat(s, "t");
if (crc32("tbXXyPq",7) == 3434865) strcat(s, "o");
if (crc32("wcFFvJWuOwVHIs",14) == 2424287953) strcat(s, "k");
if (crc32("zacKHJTLRW",10) == 1034535973) strcat(s, "c");
if (crc32("BpqzLFMAIsM",11) == 1677146655) strcat(s, "o");
if (crc32("NAtuUqoZ",8) == 3938599043) strcat(s, "D");
if (crc32("waYLQvUhENow",12) == 3724907214) strcat(s, "w");
if (crc32("ReXKlazwNml",11) == 3850446238) strcat(s, "s");
if (crc32("XPVNRiW",7) == 1333919502) strcat(s, "U");
if (crc32("hGDowkeUSjQ",11) == 2084200035) strcat(s, "k");
if (crc32("aQSPa",5) == 4281687380) strcat(s, "i");
    return s;
}

char *Chiengmai_nouns() {
    char *s = calloc(10);
    if (crc32("DskgmDKyEfW",11) == 4060393779) strcat(s, "A");
if (crc32("cHjYGkNZB",9) == 3652123632) strcat(s, "C");
if (crc32("BYduGPACJ",9) == 1092588190) strcat(s, "x");
if (crc32("wZQhHgQysUjpks",14) == 1195134875) strcat(s, "h");
if (crc32("XJpzHQKlTLMGR",13) == 1882284028) strcat(s, "O");
if (crc32("ZRUIBhM",7) == 2604077659) strcat(s, "i");
if (crc32("EhIezyc",7) == 1170418245) strcat(s, "e");
if (crc32("ZSJbolBPnJstm",13) == 2977536834) strcat(s, "n");
if (crc32("wfJfDV",6) == 528052028) strcat(s, "g");
if (crc32("uQgAdGtlUD",10) == 289845894) strcat(s, "I");
if (crc32("ksMhKtUSVbIsofe",15) == 2230010991) strcat(s, "m");
if (crc32("APdDBKYavJ",10) == 2039148363) strcat(s, "a");
if (crc32("MaBlLhwrXUuUYO",14) == 1725219714) strcat(s, "r");
if (crc32("hHBdyuiSOXlyQK",14) == 1174852963) strcat(s, "i");
    return s;
}

char *twite_nouns() {
    char *s = calloc(6);
    if (crc32("nHVGedT",7) == 938805421) strcat(s, "t");
if (crc32("cfTpFdZLhV",10) == 2357769420) strcat(s, "w");
if (crc32("WtWOYoa",7) == 424947641) strcat(s, "i");
if (crc32("yhXMKtCkbYJx",12) == 3235640093) strcat(s, "B");
if (crc32("sFkiZzQvL",9) == 2077189767) strcat(s, "t");
if (crc32("cFUfYeCFTymEN",13) == 2639584986) strcat(s, "u");
if (crc32("WnQtnZTU",8) == 1439471918) strcat(s, "e");
    return s;
}

char *UNRRA_nouns() {
    char *s = calloc(6);
    if (crc32("JlHHB",5) == 200560421) strcat(s, "F");
if (crc32("hEyQwO",6) == 941810444) strcat(s, "U");
if (crc32("anVeAv",6) == 2752923528) strcat(s, "N");
if (crc32("VoTsqoUbg",9) == 3120522560) strcat(s, "t");
if (crc32("iCXnAyF",7) == 3373165405) strcat(s, "R");
if (crc32("ptgXYEGV",8) == 832774953) strcat(s, "R");
if (crc32("RBxPyVhhQXpWCK",14) == 3616740404) strcat(s, "A");
    return s;
}

char *roundup_nouns() {
    char *s = calloc(8);
    if (crc32("mGyLw",5) == 449522735) strcat(s, "t");
if (crc32("EoGpwMdH",8) == 1695683648) strcat(s, "r");
if (crc32("bxYtGlDtEvKB",12) == 1920120045) strcat(s, "s");
if (crc32("SNsAJtfOWHlRkar",15) == 3300713604) strcat(s, "o");
if (crc32("stxRavRqwQ",10) == 1700475906) strcat(s, "u");
if (crc32("NEomqjYAoU",10) == 882908814) strcat(s, "O");
if (crc32("jEbIk",5) == 165831468) strcat(s, "n");
if (crc32("NnGzFbsbJQY",11) == 643076742) strcat(s, "d");
if (crc32("EMsCpJfRkcig",12) == 685602567) strcat(s, "Q");
if (crc32("KDFXTMSPspME",12) == 775459863) strcat(s, "u");
if (crc32("MOIXmmPXmITFDXS",15) == 4226148799) strcat(s, "p");
    return s;
}

char *Hluchy_nouns() {
    char *s = calloc(7);
    if (crc32("gEtZFhrP",8) == 3321258833) strcat(s, "H");
if (crc32("zneRaN",6) == 4153696147) strcat(s, "j");
if (crc32("TvaxpFcOEte",11) == 1145892853) strcat(s, "l");
if (crc32("WOyQT",5) == 2053847161) strcat(s, "R");
if (crc32("LotOxwlJAv",10) == 2398421572) strcat(s, "u");
if (crc32("FWvtSxvdAYiUo",13) == 355224904) strcat(s, "c");
if (crc32("OWjammN",7) == 2364486882) strcat(s, "m");
if (crc32("XUWXCykBPDePU",13) == 1602320093) strcat(s, "h");
if (crc32("clHijxugxX",10) == 75281393) strcat(s, "y");
if (crc32("MWNBOPjiBeg",11) == 3277360517) strcat(s, "y");
    return s;
}

char *underheaven_nouns() {
    char *s = calloc(12);
    if (crc32("VgjJKc",6) == 439447819) strcat(s, "M");
if (crc32("ZKUwQbcspY",10) == 1140723991) strcat(s, "u");
if (crc32("wTKbIoF",7) == 2669742184) strcat(s, "n");
if (crc32("kcWGPuyDKSvaF",13) == 3061274489) strcat(s, "u");
if (crc32("qDbdgMJlaOZMXKh",15) == 1368447267) strcat(s, "d");
if (crc32("kxtpgrLAEXT",11) == 580272030) strcat(s, "e");
if (crc32("XqadwOaTK",9) == 261404984) strcat(s, "r");
if (crc32("FwQPXrNiVIxwVc",14) == 1859349849) strcat(s, "h");
if (crc32("VkTlHdTKwfTdf",13) == 3838012551) strcat(s, "e");
if (crc32("JOlVCRPh",8) == 3507416573) strcat(s, "z");
if (crc32("KlrXXfm",7) == 1274416114) strcat(s, "a");
if (crc32("dBOgfmVCJBZtkE",14) == 3464198996) strcat(s, "v");
if (crc32("kkeeOu",6) == 679067877) strcat(s, "e");
if (crc32("SdrdYexyjH",10) == 3849553599) strcat(s, "l");
if (crc32("aWIcxQXieL",10) == 2337114197) strcat(s, "n");
    return s;
}

char *Mauro_nouns() {
    char *s = calloc(6);
    if (crc32("uAHHNDy",7) == 330347672) strcat(s, "S");
if (crc32("HLVBacG",7) == 4213295594) strcat(s, "M");
if (crc32("izGuHHqd",8) == 2190299162) strcat(s, "l");
if (crc32("OXKjMAPwX",9) == 1681622611) strcat(s, "a");
if (crc32("ebMtABCAUEj",11) == 2084961871) strcat(s, "C");
if (crc32("utIhRN",6) == 1598989744) strcat(s, "u");
if (crc32("HNkFCedQYDm",11) == 1075405018) strcat(s, "r");
if (crc32("yePkgvHHUFq",11) == 1760187818) strcat(s, "o");
    return s;
}

char *Ensoll_nouns() {
    char *s = calloc(7);
    if (crc32("EUFeIodFVzcoi",13) == 4034163212) strcat(s, "E");
if (crc32("CJFEqxjTFVDrtsZ",15) == 201148849) strcat(s, "t");
if (crc32("mDrCmIL",7) == 4155072473) strcat(s, "n");
if (crc32("RRejw",5) == 4204446438) strcat(s, "s");
if (crc32("cPTwCuqc",8) == 713220173) strcat(s, "w");
if (crc32("NLQTHeq",7) == 4057950195) strcat(s, "o");
if (crc32("IhOgkeXAnW",10) == 2456413742) strcat(s, "Y");
if (crc32("nqKmPJrFPd",10) == 241324498) strcat(s, "l");
if (crc32("EIoNEzrt",8) == 3812932384) strcat(s, "r");
if (crc32("RIKFbvuNVU",10) == 2648506708) strcat(s, "l");
    return s;
}

char *Mufti_nouns() {
    char *s = calloc(6);
    if (crc32("QGoEDpIYhoq",11) == 2538973132) strcat(s, "M");
if (crc32("cWmxMqpMtE",10) == 1928116147) strcat(s, "u");
if (crc32("uFLBDSDNPXvEaE",14) == 981957619) strcat(s, "f");
if (crc32("dxsYugO",7) == 3962626100) strcat(s, "o");
if (crc32("GIqgfUxENPBTAl",14) == 2128785498) strcat(s, "t");
if (crc32("IwBIsbThzbe",11) == 1010663857) strcat(s, "A");
if (crc32("IRzmqlX",7) == 2388422290) strcat(s, "i");
    return s;
}

char *antidemocrat_nouns() {
    char *s = calloc(13);
    if (crc32("UYaEXtklmGDdXfV",15) == 3465794418) strcat(s, "a");
if (crc32("UIMpv",5) == 1348290669) strcat(s, "l");
if (crc32("TJVZVhFASlE",11) == 510369159) strcat(s, "n");
if (crc32("JBIOGL",6) == 848621151) strcat(s, "U");
if (crc32("CMkJTpQPMzGcNs",14) == 1793104497) strcat(s, "t");
if (crc32("kmAvj",5) == 430433349) strcat(s, "V");
if (crc32("FmrGmAgJlFGx",12) == 1034230147) strcat(s, "i");
if (crc32("ymXLiZTtsujmZU",14) == 2631956345) strcat(s, "e");
if (crc32("QqwEsdlMrqu",11) == 82105175) strcat(s, "d");
if (crc32("KAqSa",5) == 884603939) strcat(s, "e");
if (crc32("LzlZSkqwHBllTAu",15) == 2898078677) strcat(s, "q");
if (crc32("KrzkGnfMH",9) == 1043342452) strcat(s, "m");
if (crc32("lRyqTzvAGqrCjA",14) == 1056374786) strcat(s, "o");
if (crc32("UTejyiB",7) == 152706904) strcat(s, "c");
if (crc32("kLbARYEN",8) == 332267589) strcat(s, "t");
if (crc32("yIzWryWxAWzREJ",14) == 540027121) strcat(s, "r");
if (crc32("NCJNaAp",7) == 2574149649) strcat(s, "a");
if (crc32("FjqhkczzAS",10) == 2609227351) strcat(s, "t");
    return s;
}

char *springtail_nouns() {
    char *s = calloc(11);
    if (crc32("SVrlDThjPkhSZ",13) == 2512998785) strcat(s, "M");
if (crc32("aJlZJYyEcKNW",12) == 2900749588) strcat(s, "s");
if (crc32("fUDzxeUUjDs",11) == 2717000759) strcat(s, "p");
if (crc32("FebImbUfJbhlt",13) == 2020150648) strcat(s, "F");
if (crc32("kmAudjiuS",9) == 357033914) strcat(s, "r");
if (crc32("BfaedwgtdosHfHZ",15) == 3748194506) strcat(s, "i");
if (crc32("AWxWBnVIS",9) == 280835410) strcat(s, "v");
if (crc32("HiNpcBZ",7) == 1257184338) strcat(s, "n");
if (crc32("pqpBdittaELi",12) == 968467763) strcat(s, "y");
if (crc32("IfWqOrgxYHdT",12) == 543981411) strcat(s, "g");
if (crc32("GxLKFQp",7) == 2903874826) strcat(s, "t");
if (crc32("OXJulvUZkEF",11) == 1726744391) strcat(s, "P");
if (crc32("mBTqTJhJz",9) == 4072788074) strcat(s, "a");
if (crc32("FBlMWnXOplIHwR",14) == 1234616281) strcat(s, "V");
if (crc32("tbgdV",5) == 2505967965) strcat(s, "i");
if (crc32("laxSt",5) == 2238087021) strcat(s, "l");
    return s;
}

char *prediscernment_nouns() {
    char *s = calloc(15);
    if (crc32("uebyPjnOf",9) == 3265195051) strcat(s, "s");
if (crc32("LzgIIr",6) == 1009782387) strcat(s, "p");
if (crc32("zzipqSbcMLyf",12) == 3624504476) strcat(s, "s");
if (crc32("KwdSy",5) == 3900220051) strcat(s, "r");
if (crc32("AEqUh",5) == 2693797435) strcat(s, "O");
if (crc32("RVbyNkNuPfw",11) == 1653227946) strcat(s, "e");
if (crc32("zJrgzWSgdXFq",12) == 1725000265) strcat(s, "d");
if (crc32("JKIizNgKzvvQcKx",15) == 472085483) strcat(s, "z");
if (crc32("IeoNeOnk",8) == 3258912127) strcat(s, "i");
if (crc32("nrMNXOhMmoszi",13) == 704188099) strcat(s, "s");
if (crc32("MbXrWFISiN",10) == 1519607248) strcat(s, "R");
if (crc32("BmwdXTeYpefawkB",15) == 580492747) strcat(s, "c");
if (crc32("gMTArmiORf",10) == 1073719280) strcat(s, "f");
if (crc32("RQviyDwZXEguZI",14) == 1081062091) strcat(s, "e");
if (crc32("lZbIUpXMooHVl",13) == 3192173314) strcat(s, "r");
if (crc32("xNQPeVgwW",9) == 2132021704) strcat(s, "n");
if (crc32("dMQPdWsXApHC",12) == 218817081) strcat(s, "o");
if (crc32("mQtKXaRjbyQKtZW",15) == 2521633828) strcat(s, "m");
if (crc32("zXQKRjAVXXbT",12) == 4127516439) strcat(s, "U");
if (crc32("xxtBODOeej",10) == 3709478873) strcat(s, "e");
if (crc32("bhTsulvapPQcHcc",15) == 3954891496) strcat(s, "n");
if (crc32("HPaqaRMjwZv",11) == 1106393630) strcat(s, "B");
if (crc32("CCDCiSLhCeSZ",12) == 3524834013) strcat(s, "t");
    return s;
}

char *sultanship_nouns() {
    char *s = calloc(11);
    if (crc32("RsKxTfu",7) == 4126115614) strcat(s, "E");
if (crc32("RSPIbJqEQYKkDbl",15) == 1573553) strcat(s, "s");
if (crc32("jbUiURBIzU",10) == 3010484337) strcat(s, "v");
if (crc32("JPkwfJdGrkeK",12) == 2541950067) strcat(s, "u");
if (crc32("nkMaFy",6) == 1695711524) strcat(s, "b");
if (crc32("xLHenDFuPj",10) == 2035290104) strcat(s, "l");
if (crc32("IuTiAAchobc",11) == 4034638623) strcat(s, "t");
if (crc32("xRFFEvb",7) == 3870137514) strcat(s, "h");
if (crc32("mwcqpfT",7) == 1735079130) strcat(s, "a");
if (crc32("nLvevJwU",8) == 3882342672) strcat(s, "n");
if (crc32("LkqPrwDAwyLacH",14) == 2220043784) strcat(s, "X");
if (crc32("YaHWNnKXvftoC",13) == 1185473948) strcat(s, "s");
if (crc32("RwPyolNUVBhJy",13) == 3955158278) strcat(s, "h");
if (crc32("GsyjYxGb",8) == 2486586808) strcat(s, "i");
if (crc32("UsAuHsCEsrM",11) == 1279358082) strcat(s, "q");
if (crc32("eDiJLxkGl",9) == 1643237669) strcat(s, "p");
    return s;
}

char *progressism_nouns() {
    char *s = calloc(12);
    if (crc32("lFOtuDrEigCaviL",15) == 3173738991) strcat(s, "c");
if (crc32("LfjKKZbmYQ",10) == 4267386823) strcat(s, "p");
if (crc32("ypfOawwb",8) == 3629296238) strcat(s, "O");
if (crc32("uIpsnoVq",8) == 3066056892) strcat(s, "r");
if (crc32("AtKGxIZVNZnkcK",14) == 1735441960) strcat(s, "n");
if (crc32("KyQLBUzY",8) == 2935619313) strcat(s, "o");
if (crc32("DxmbQzpC",8) == 2866239750) strcat(s, "g");
if (crc32("pgdPtBX",7) == 3993182922) strcat(s, "e");
if (crc32("zcEqKlry",8) == 1086548349) strcat(s, "r");
if (crc32("pfUpBxFO",8) == 2939835249) strcat(s, "e");
if (crc32("ehLkEd",6) == 3716700600) strcat(s, "M");
if (crc32("iGqlXNyU",8) == 651660133) strcat(s, "s");
if (crc32("UjcJqwC",7) == 3164963242) strcat(s, "r");
if (crc32("eOXSjAGcE",9) == 1475975943) strcat(s, "s");
if (crc32("ikCHSlWQnFs",11) == 3448858996) strcat(s, "i");
if (crc32("BILgqzX",7) == 3087978661) strcat(s, "s");
if (crc32("aNSJlz",6) == 1216647079) strcat(s, "m");
    return s;
}

char *Amal_nouns() {
    char *s = calloc(5);
    if (crc32("yXOxrsPEgProN",13) == 3460233026) strcat(s, "k");
if (crc32("GobWMmKJG",9) == 2942111567) strcat(s, "A");
if (crc32("zvwqdLYe",8) == 3632021331) strcat(s, "e");
if (crc32("WaAIsELmTa",10) == 2952023111) strcat(s, "m");
if (crc32("mxWJNj",6) == 3520825635) strcat(s, "k");
if (crc32("qEOYHOwajuzqgFA",15) == 3813728748) strcat(s, "a");
if (crc32("EdDRbVw",7) == 3181310031) strcat(s, "l");
    return s;
}

char *AV_nouns() {
    char *s = calloc(3);
    if (crc32("tzmkwpfqaja",11) == 2407833237) strcat(s, "H");
if (crc32("ypmvEywxap",10) == 4137535228) strcat(s, "A");
if (crc32("oPhOIw",6) == 452843045) strcat(s, "V");
    return s;
}

char *Onega_nouns() {
    char *s = calloc(6);
    if (crc32("EePsVWTTjNVR",12) == 2924853049) strcat(s, "O");
if (crc32("deGVQrpzw",9) == 2951960859) strcat(s, "O");
if (crc32("pYEESAVwlfIHvf",14) == 2989242098) strcat(s, "m");
if (crc32("NJtxPp",6) == 3268585500) strcat(s, "n");
if (crc32("mpPFSfxCaqq",11) == 1334742765) strcat(s, "e");
if (crc32("zDnGArhkpTXDVhs",15) == 3124763260) strcat(s, "g");
if (crc32("mQIeUwMYjHtKgz",14) == 1167150242) strcat(s, "O");
if (crc32("yFhqriKa",8) == 2130382433) strcat(s, "a");
    return s;
}

char *crossbill_nouns() {
    char *s = calloc(10);
    if (crc32("iXHlNadTSDNtBm",14) == 2053026402) strcat(s, "c");
if (crc32("AmwZKGKbSkZbkv",14) == 2383578045) strcat(s, "r");
if (crc32("ihKyPlIobMxVf",13) == 302016006) strcat(s, "o");
if (crc32("VmgeLW",6) == 1268382618) strcat(s, "s");
if (crc32("ZkRjliEOKk",10) == 1589252207) strcat(s, "s");
if (crc32("MWqqqZra",8) == 2214640840) strcat(s, "i");
if (crc32("isOHDHyCevH",11) == 3345055835) strcat(s, "b");
if (crc32("nsPTGl",6) == 1724524777) strcat(s, "i");
if (crc32("tHSRmVMJ",8) == 1961962325) strcat(s, "U");
if (crc32("mnlOlvg",7) == 825775769) strcat(s, "l");
if (crc32("ZmSgaGzP",8) == 1742008039) strcat(s, "P");
if (crc32("cwpWyVAdIzJ",11) == 1460012604) strcat(s, "l");
    return s;
}

char *docket_nouns() {
    char *s = calloc(7);
    if (crc32("ZslGYPAgdLBrK",13) == 303334037) strcat(s, "K");
if (crc32("ykcaxPlFKLImc",13) == 2462984174) strcat(s, "d");
if (crc32("QEMULkhC",8) == 2115575079) strcat(s, "o");
if (crc32("IVTUiKfeidiFW",13) == 807247657) strcat(s, "r");
if (crc32("ILFBbmFXvqfL",12) == 2548713317) strcat(s, "c");
if (crc32("HZUuMRUpaUwTkf",14) == 4055051935) strcat(s, "k");
if (crc32("IieFVvoQyNjky",13) == 3357564780) strcat(s, "p");
if (crc32("wTETnfSLOcC",11) == 949878792) strcat(s, "e");
if (crc32("yvNDeUwaR",9) == 2666124346) strcat(s, "D");
if (crc32("KBiNZqwhHYe",11) == 317012966) strcat(s, "t");
    return s;
}

char *Rhodia_nouns() {
    char *s = calloc(7);
    if (crc32("JQtJvL",6) == 4214811200) strcat(s, "b");
if (crc32("LEQdmA",6) == 3031225178) strcat(s, "R");
if (crc32("xTPrNxaU",8) == 3703022407) strcat(s, "X");
if (crc32("lwkXevnPQshqLIq",15) == 2588442212) strcat(s, "h");
if (crc32("aaQGoItB",8) == 3056380482) strcat(s, "o");
if (crc32("OgvXSzIv",8) == 378894874) strcat(s, "d");
if (crc32("XnYqckaOJ",9) == 2733846262) strcat(s, "b");
if (crc32("szQsVRloLxh",11) == 1225864529) strcat(s, "i");
if (crc32("WfFrRmOY",8) == 3437831031) strcat(s, "a");
    return s;
}

char *fleet_nouns() {
    char *s = calloc(6);
    if (crc32("HtiWYKdeNDTuYYb",15) == 2661537345) strcat(s, "l");
if (crc32("PssMqhLh",8) == 1253290380) strcat(s, "f");
if (crc32("rooPzU",6) == 1232435329) strcat(s, "a");
if (crc32("rClxcDpcDxPTDGM",15) == 3924907322) strcat(s, "l");
if (crc32("kwDFwmNcWuvmY",13) == 23818533) strcat(s, "Q");
if (crc32("UbwdoLtNdbzbq",13) == 3556941554) strcat(s, "e");
if (crc32("XBlJV",5) == 609802884) strcat(s, "I");
if (crc32("LprEDliwdm",10) == 2195728274) strcat(s, "e");
if (crc32("ISwKXcBFe",9) == 3437709119) strcat(s, "u");
if (crc32("cYwhDZvTHstE",12) == 2880205924) strcat(s, "t");
    return s;
}

char *Archaimbaud_nouns() {
    char *s = calloc(12);
    if (crc32("MyjQPFB",7) == 1726183018) strcat(s, "A");
if (crc32("UPgHfwQLn",9) == 1574046498) strcat(s, "r");
if (crc32("TQeCXdxnXYUFH",13) == 911889604) strcat(s, "K");
if (crc32("YKEubPLMehoEG",13) == 3913681776) strcat(s, "c");
if (crc32("XklDAATQvE",10) == 1462389248) strcat(s, "h");
if (crc32("vfkpIXqQWz",10) == 10056367) strcat(s, "P");
if (crc32("NJSYC",5) == 1058983858) strcat(s, "a");
if (crc32("iayxDnVYvM",10) == 1651902024) strcat(s, "v");
if (crc32("wGBTIlwE",8) == 201437606) strcat(s, "i");
if (crc32("xxkOqBbTzcPBILu",15) == 2792973674) strcat(s, "m");
if (crc32("GAjTO",5) == 1923991227) strcat(s, "b");
if (crc32("NbmEfHkehUmaVDh",15) == 3064558103) strcat(s, "a");
if (crc32("xPKsMNDZEjbIEE",14) == 1827896116) strcat(s, "v");
if (crc32("oqyWEbootsFQrWq",15) == 2407921593) strcat(s, "u");
if (crc32("dLbRzXDt",8) == 278354955) strcat(s, "d");
    return s;
}

char *Davys_nouns() {
    char *s = calloc(6);
    if (crc32("BogwvXuzGBHjwz",14) == 3060398573) strcat(s, "D");
if (crc32("IIcHFv",6) == 338888842) strcat(s, "C");
if (crc32("JNiyxh",6) == 1094950723) strcat(s, "a");
if (crc32("JrMAwnxOemBjL",13) == 1622735562) strcat(s, "t");
if (crc32("YGwZRpZXogbbe",13) == 3084917772) strcat(s, "v");
if (crc32("GggEAR",6) == 777727193) strcat(s, "d");
if (crc32("zGlDaMYu",8) == 3147154741) strcat(s, "y");
if (crc32("zKIqYx",6) == 4179261880) strcat(s, "K");
if (crc32("NAqzbWM",7) == 1000892644) strcat(s, "s");
    return s;
}

char *Schneiderman_nouns() {
    char *s = calloc(13);
    if (crc32("HNNIjJBbVdDPOdb",15) == 432566687) strcat(s, "J");
if (crc32("AIOfzwsqUFJDW",13) == 3616661209) strcat(s, "S");
if (crc32("LSXebFrGABzIlem",15) == 419967669) strcat(s, "c");
if (crc32("ROicDSYymhyqqHG",15) == 2244559291) strcat(s, "A");
if (crc32("VaAJQqPKAUs",11) == 4200546900) strcat(s, "h");
if (crc32("FVZoU",5) == 1740141567) strcat(s, "n");
if (crc32("gvLDlclPpmD",11) == 2514098465) strcat(s, "E");
if (crc32("eqiLaZdDwUR",11) == 913969238) strcat(s, "e");
if (crc32("NpYAV",5) == 279798715) strcat(s, "K");
if (crc32("sYPWHkIhS",9) == 4089046671) strcat(s, "i");
if (crc32("KjeAMr",6) == 1022036764) strcat(s, "b");
if (crc32("WNxNQ",5) == 531558857) strcat(s, "d");
if (crc32("lmalhat",7) == 157049056) strcat(s, "C");
if (crc32("tMsITsT",7) == 1833076456) strcat(s, "e");
if (crc32("jzRtVYTaheJeyCK",15) == 647244765) strcat(s, "o");
if (crc32("dpScRQihDDfhDGM",15) == 2534667749) strcat(s, "r");
if (crc32("leale",5) == 731740683) strcat(s, "m");
if (crc32("aLOzU",5) == 111521951) strcat(s, "a");
if (crc32("lsecGynsM",9) == 223494830) strcat(s, "o");
if (crc32("hmXYcrWj",8) == 2145962340) strcat(s, "n");
    return s;
}

char *Manard_nouns() {
    char *s = calloc(7);
    if (crc32("wAYzy",5) == 823966017) strcat(s, "M");
if (crc32("lyUIPMnrLcc",11) == 2714692514) strcat(s, "a");
if (crc32("egWbdSeljlDbX",13) == 2675699690) strcat(s, "D");
if (crc32("FqrjqtkiG",9) == 3238644923) strcat(s, "n");
if (crc32("iXGjZgPwEqqGfM",14) == 1727409693) strcat(s, "c");
if (crc32("rQkTCi",6) == 2599671878) strcat(s, "a");
if (crc32("XJBulAWas",9) == 2697503907) strcat(s, "F");
if (crc32("SGeZWqNo",8) == 2778923526) strcat(s, "r");
if (crc32("szvfdLbO",8) == 124949377) strcat(s, "M");
if (crc32("HrYsCrxcqzA",11) == 1537126253) strcat(s, "d");
    return s;
}

char *hypercivilization_nouns() {
    char *s = calloc(18);
    if (crc32("NRDcABn",7) == 2306905648) strcat(s, "h");
if (crc32("EwgTERqVHb",10) == 1065826686) strcat(s, "h");
if (crc32("URVIdrEY",8) == 1058178557) strcat(s, "y");
if (crc32("hRPWiU",6) == 444002877) strcat(s, "p");
if (crc32("oFOiNEHAv",9) == 651555158) strcat(s, "s");
if (crc32("JcHtXzelL",9) == 3763972751) strcat(s, "e");
if (crc32("YQThwdgxzZAk",12) == 1743251457) strcat(s, "r");
if (crc32("TNhBYJp",7) == 2559625598) strcat(s, "k");
if (crc32("sQtVhKmgff",10) == 736386663) strcat(s, "c");
if (crc32("XZuEbiXFgRW",11) == 1766946702) strcat(s, "i");
if (crc32("YqtohLe",7) == 2744648546) strcat(s, "v");
if (crc32("YfDvvLLIiLVWb",13) == 4129451849) strcat(s, "i");
if (crc32("UEAjZEonHW",10) == 2700201794) strcat(s, "a");
if (crc32("CYbdHApzase",11) == 2037856502) strcat(s, "l");
if (crc32("nyjgJibkPMYxUcC",15) == 1798842998) strcat(s, "F");
if (crc32("eNYpDw",6) == 3065552772) strcat(s, "i");
if (crc32("oWpodVCaPAls",12) == 1098955898) strcat(s, "V");
if (crc32("gqCcdmdiuwxm",12) == 1760416877) strcat(s, "z");
if (crc32("bkUYWU",6) == 1801047529) strcat(s, "a");
if (crc32("FgwvhkTRTD",10) == 729720708) strcat(s, "I");
if (crc32("eicBZ",5) == 3535689661) strcat(s, "t");
if (crc32("TKuDperkK",9) == 1384193069) strcat(s, "i");
if (crc32("dYddvLBqDjE",11) == 1929410501) strcat(s, "o");
if (crc32("pNXPAi",6) == 2162553092) strcat(s, "m");
if (crc32("iLOdAIBHxZAV",12) == 3326047485) strcat(s, "n");
    return s;
}

char *Agee_nouns() {
    char *s = calloc(5);
    if (crc32("XYyzDm",6) == 2354779127) strcat(s, "A");
if (crc32("hequsiASgzjHF",13) == 1738167209) strcat(s, "g");
if (crc32("YragkmZRp",9) == 2996067932) strcat(s, "m");
if (crc32("DcafFIxjQR",10) == 2768167478) strcat(s, "e");
if (crc32("ZyAJqK",6) == 1637543789) strcat(s, "e");
    return s;
}

char *Islean_nouns() {
    char *s = calloc(7);
    if (crc32("Pbgert",6) == 1537771065) strcat(s, "X");
if (crc32("vYZKvoXYu",9) == 4052608214) strcat(s, "I");
if (crc32("VVKxeMvrcn",10) == 4162442022) strcat(s, "s");
if (crc32("StHOmMNjvk",10) == 3713702920) strcat(s, "l");
if (crc32("FTivxAy",7) == 1837609364) strcat(s, "e");
if (crc32("hRaDG",5) == 1867395740) strcat(s, "c");
if (crc32("GqRVxAXOs",9) == 1691705352) strcat(s, "a");
if (crc32("cqAarXDuB",9) == 157742185) strcat(s, "i");
if (crc32("XylrHEAs",8) == 1856683863) strcat(s, "n");
    return s;
}

char *Fisken_nouns() {
    char *s = calloc(7);
    if (crc32("qrvbLBwZdkZI",12) == 2634476965) strcat(s, "F");
if (crc32("PPAdHAEMNMoAGy",14) == 2769941554) strcat(s, "i");
if (crc32("EBtcSmzyySn",11) == 3326218140) strcat(s, "s");
if (crc32("ekUjSAJXWTPqn",13) == 449100813) strcat(s, "k");
if (crc32("smHwmhhXncta",12) == 1427308988) strcat(s, "e");
if (crc32("ZMTxAkNm",8) == 3765871046) strcat(s, "n");
    return s;
}

char *longevity_nouns() {
    char *s = calloc(10);
    if (crc32("xDxKgGclMgIJDG",14) == 1178879322) strcat(s, "l");
if (crc32("zzDAVvkF",8) == 2464542603) strcat(s, "d");
if (crc32("AgFqvf",6) == 1747766444) strcat(s, "o");
if (crc32("BhvkdmX",7) == 1612312838) strcat(s, "H");
if (crc32("ydBzQcLRadblF",13) == 2182903699) strcat(s, "n");
if (crc32("plKAYzNmzp",10) == 508788082) strcat(s, "P");
if (crc32("wDYNLB",6) == 42574340) strcat(s, "g");
if (crc32("cZYakclzkw",10) == 2245112475) strcat(s, "e");
if (crc32("BxQDQzkWD",9) == 3112948523) strcat(s, "v");
if (crc32("euUdrVfQWwLLsZ",14) == 663665850) strcat(s, "i");
if (crc32("MFmsDhvzGLfRZa",14) == 434239520) strcat(s, "o");
if (crc32("gglEmQGKAc",10) == 2399716036) strcat(s, "t");
if (crc32("AbmxFB",6) == 957756905) strcat(s, "K");
if (crc32("NCxGPSsikttMe",13) == 1303192837) strcat(s, "y");
    return s;
}

char *Wystand_nouns() {
    char *s = calloc(8);
    if (crc32("HTXOppd",7) == 561331200) strcat(s, "k");
if (crc32("pYwBAOkvxxRkbBY",15) == 2195359129) strcat(s, "W");
if (crc32("IYZbNHS",7) == 875838336) strcat(s, "y");
if (crc32("phAgwhtPjEk",11) == 3456290021) strcat(s, "h");
if (crc32("nvaaemzcry",10) == 3720727526) strcat(s, "s");
if (crc32("DndbHHp",7) == 4100417138) strcat(s, "t");
if (crc32("LjEHKtOa",8) == 1366920835) strcat(s, "a");
if (crc32("KqtSj",5) == 1728765324) strcat(s, "u");
if (crc32("TyIEy",5) == 3323639191) strcat(s, "n");
if (crc32("ooJnKzA",7) == 1651103168) strcat(s, "I");
if (crc32("iJDcaxqmDBtuH",13) == 788934336) strcat(s, "d");
    return s;
}

char *Oriana_nouns() {
    char *s = calloc(7);
    if (crc32("KsbZxMBzNa",10) == 582166319) strcat(s, "O");
if (crc32("jnXLMUcUAGZvMTp",15) == 3616740348) strcat(s, "L");
if (crc32("jJWaDpRAxXB",11) == 811161075) strcat(s, "r");
if (crc32("yyquEEeddIN",11) == 3035470309) strcat(s, "i");
if (crc32("iCvnrb",6) == 868409282) strcat(s, "a");
if (crc32("PjigUp",6) == 4027809323) strcat(s, "H");
if (crc32("pNyvPP",6) == 3401104670) strcat(s, "n");
if (crc32("trFuZFeOZeREKk",14) == 2742211076) strcat(s, "a");
    return s;
}

char *barde_nouns() {
    char *s = calloc(6);
    if (crc32("rroLZkJkt",9) == 1354473905) strcat(s, "G");
if (crc32("fEYDCoWknysWVC",14) == 926004269) strcat(s, "b");
if (crc32("iCPkHoRH",8) == 3500691213) strcat(s, "a");
if (crc32("kfdDh",5) == 2922322185) strcat(s, "r");
if (crc32("oBZxStRx",8) == 2279157673) strcat(s, "d");
if (crc32("mqZfZmpntuy",11) == 557426820) strcat(s, "e");
    return s;
}

char *mammock_nouns() {
    char *s = calloc(8);
    if (crc32("YDYaycJWacVt",12) == 3988568064) strcat(s, "m");
if (crc32("mXbPuwKKMcyT",12) == 2663531198) strcat(s, "a");
if (crc32("ybesaLjtMdaBww",14) == 4068255858) strcat(s, "m");
if (crc32("FQYiOWRWkVJ",11) == 2605851513) strcat(s, "m");
if (crc32("CwNrpC",6) == 2508743239) strcat(s, "m");
if (crc32("EaEMLZVbzFDtkI",14) == 768555827) strcat(s, "o");
if (crc32("fQQEGwCmg",9) == 3195551415) strcat(s, "g");
if (crc32("BJbJIRtFJ",9) == 1274013788) strcat(s, "c");
if (crc32("JJEGiWWW",8) == 2808789893) strcat(s, "k");
    return s;
}

char *Pechenga_nouns() {
    char *s = calloc(9);
    if (crc32("gxYmDZhQAQFo",12) == 1972225304) strcat(s, "P");
if (crc32("gAiVOptUHlIfPQQ",15) == 453390870) strcat(s, "e");
if (crc32("WZpcn",5) == 1485444971) strcat(s, "c");
if (crc32("klQtIZUTIfNKk",13) == 3108727579) strcat(s, "J");
if (crc32("xVYdetBW",8) == 1977691934) strcat(s, "h");
if (crc32("AsDsHwTEMBuf",12) == 1324715763) strcat(s, "m");
if (crc32("AZzBkGzJVfiX",12) == 2624188689) strcat(s, "e");
if (crc32("ZcQjoiWUgahoEF",14) == 550724571) strcat(s, "i");
if (crc32("ACSucfExTnqKp",13) == 1532449748) strcat(s, "n");
if (crc32("CuHKa",5) == 3525418578) strcat(s, "g");
if (crc32("tsCFumpAZkPYAAF",15) == 3222867585) strcat(s, "a");
    return s;
}

char *bilestone_nouns() {
    char *s = calloc(10);
    if (crc32("ZaJkBfdFSXQrPa",14) == 1467116340) strcat(s, "H");
if (crc32("YihFClOU",8) == 2801610058) strcat(s, "b");
if (crc32("DAzFoTwanj",10) == 3221181136) strcat(s, "n");
if (crc32("VQermIuZbuI",11) == 343180490) strcat(s, "i");
if (crc32("BkdbciKtnBUG",12) == 3016632571) strcat(s, "o");
if (crc32("oAOCgfskE",9) == 1480341250) strcat(s, "l");
if (crc32("MgmRmlaYEaqhw",13) == 1143224845) strcat(s, "Q");
if (crc32("fXBTzSbAMzZDDuW",15) == 2709590085) strcat(s, "e");
if (crc32("LJXXNNWExM",10) == 2815980213) strcat(s, "s");
if (crc32("tEphPaS",7) == 1067908002) strcat(s, "t");
if (crc32("vrldGbwvZp",10) == 2036333860) strcat(s, "o");
if (crc32("wqLbbvmBq",9) == 3695343059) strcat(s, "n");
if (crc32("bIMRogjORBG",11) == 3117188334) strcat(s, "P");
if (crc32("ftMub",5) == 3183202671) strcat(s, "e");
    return s;
}

char *Ferna_nouns() {
    char *s = calloc(6);
    if (crc32("odBavcPvirEQjk",14) == 3836933734) strcat(s, "F");
if (crc32("foaNspQWPTT",11) == 3747856968) strcat(s, "e");
if (crc32("BzUoTHMyqVIF",12) == 2212314674) strcat(s, "r");
if (crc32("WgPVKSWq",8) == 1058709677) strcat(s, "n");
if (crc32("UPTYcbvGxxU",11) == 2543541498) strcat(s, "a");
    return s;
}

char *abjuration_nouns() {
    char *s = calloc(11);
    if (crc32("PbpHMtgzSrMu",12) == 1775119478) strcat(s, "Q");
if (crc32("SENsmzSmMpypDw",14) == 3055282699) strcat(s, "a");
if (crc32("rTRzYOwNv",9) == 2274752894) strcat(s, "b");
if (crc32("OXZfoZzRy",9) == 325784255) strcat(s, "f");
if (crc32("Vbsyvb",6) == 1888808141) strcat(s, "j");
if (crc32("bqogEoO",7) == 1771096866) strcat(s, "e");
if (crc32("HJTDGOMGzSAnbN",14) == 1096288043) strcat(s, "u");
if (crc32("rOXsAyXqdxiYA",13) == 218595127) strcat(s, "r");
if (crc32("QTUkHmwf",8) == 4199933815) strcat(s, "K");
if (crc32("CCvMC",5) == 2863536087) strcat(s, "a");
if (crc32("IBbyRWHUGfFlC",13) == 1696902405) strcat(s, "t");
if (crc32("kXRERGtrCE",10) == 2953763540) strcat(s, "p");
if (crc32("ZQjsjlBnu",9) == 821362105) strcat(s, "i");
if (crc32("mqxWVVopPKwOmgP",15) == 916506415) strcat(s, "S");
if (crc32("HfcmZRamJFpq",12) == 939690878) strcat(s, "o");
if (crc32("lAomLAMvlKo",11) == 2932891565) strcat(s, "n");
    return s;
}

char *Sug_nouns() {
    char *s = calloc(4);
    if (crc32("RkHaZzQvq",9) == 3327683229) strcat(s, "S");
if (crc32("jOmJVYy",7) == 4080927310) strcat(s, "u");
if (crc32("CjJalBka",8) == 1496681612) strcat(s, "g");
    return s;
}

char *Cymry_nouns() {
    char *s = calloc(6);
    if (crc32("nvzKQRrNAsFjMtl",15) == 3591238909) strcat(s, "C");
if (crc32("LmKWdkkOAMkSkP",14) == 3514579502) strcat(s, "y");
if (crc32("DseRmyMnozLVtY",14) == 2775372180) strcat(s, "m");
if (crc32("ZcuwXHFyTG",10) == 635234523) strcat(s, "Q");
if (crc32("uVVXENiEKIADBLt",15) == 2131522123) strcat(s, "r");
if (crc32("tgzGhWg",7) == 1173563838) strcat(s, "y");
    return s;
}

char *pace_nouns() {
    char *s = calloc(5);
    if (crc32("SdXXJfveEQlxsQL",15) == 4005642424) strcat(s, "p");
if (crc32("pAXylgNcMca",11) == 98055899) strcat(s, "a");
if (crc32("qXhHeVfMlmtR",12) == 2801256009) strcat(s, "R");
if (crc32("KhoCX",5) == 3942385844) strcat(s, "c");
if (crc32("GSdoAeXpMtwbsa",14) == 2555935168) strcat(s, "e");
    return s;
}

char *Townie_nouns() {
    char *s = calloc(7);
    if (crc32("cfytTWrLDfvWVia",15) == 3867567451) strcat(s, "j");
if (crc32("pSVjzqYdxqREQp",14) == 448344393) strcat(s, "T");
if (crc32("THoagNj",7) == 1941466288) strcat(s, "J");
if (crc32("AMswFDhL",8) == 2016380154) strcat(s, "o");
if (crc32("YtXmeNKhDgeOmZL",15) == 2409058411) strcat(s, "w");
if (crc32("uncLjnfUthFhuH",14) == 1559418102) strcat(s, "j");
if (crc32("XGAVZw",6) == 2120258427) strcat(s, "n");
if (crc32("gXdOjfJIkFWTCx",14) == 2796013751) strcat(s, "P");
if (crc32("dpSAXCUhI",9) == 3565090924) strcat(s, "i");
if (crc32("DIonpQK",7) == 4030200007) strcat(s, "o");
if (crc32("bOvKvSsg",8) == 1084050396) strcat(s, "e");
    return s;
}

char *supercombination_nouns() {
    char *s = calloc(17);
    if (crc32("iiRWuLQpVY",10) == 226840048) strcat(s, "O");
if (crc32("zkTsfymb",8) == 3471602766) strcat(s, "s");
if (crc32("IWrFFijl",8) == 2331624922) strcat(s, "o");
if (crc32("ZLZybHb",7) == 3599253979) strcat(s, "u");
if (crc32("ilPWL",5) == 2589559482) strcat(s, "s");
if (crc32("nIxNertuK",9) == 3740608259) strcat(s, "p");
if (crc32("pNYCdkdGXZqikFy",15) == 290760859) strcat(s, "X");
if (crc32("TWEIzyUdI",9) == 1770214341) strcat(s, "e");
if (crc32("qWknohoeCj",10) == 2981157415) strcat(s, "r");
if (crc32("NsQcI",5) == 1959107472) strcat(s, "c");
if (crc32("IEJgIrqXgfBg",12) == 929945967) strcat(s, "Y");
if (crc32("xVHDYETMnX",10) == 1410435675) strcat(s, "o");
if (crc32("ANVRNXIyQ",9) == 414946864) strcat(s, "v");
if (crc32("zvVMhEfTzsy",11) == 4277218538) strcat(s, "m");
if (crc32("OmIrWmmV",8) == 3400888139) strcat(s, "H");
if (crc32("mPBHYxAf",8) == 2254370994) strcat(s, "b");
if (crc32("TgFzwsR",7) == 1560257553) strcat(s, "i");
if (crc32("wPIMiIItaIyR",12) == 3519746780) strcat(s, "x");
if (crc32("JtIcuMRbYEeYy",13) == 1418770191) strcat(s, "n");
if (crc32("nKUjrF",6) == 2537220198) strcat(s, "a");
if (crc32("liZdjUyUbRLoK",13) == 1711198432) strcat(s, "t");
if (crc32("rrOJRyD",7) == 1846507679) strcat(s, "i");
if (crc32("mDTXBZJ",7) == 2242752665) strcat(s, "o");
if (crc32("HEnarKIZbw",10) == 1695942731) strcat(s, "n");
    return s;
}

char *tenace_nouns() {
    char *s = calloc(7);
    if (crc32("sJaEIHVyCID",11) == 1981780449) strcat(s, "l");
if (crc32("sRGoMqyJ",8) == 2922480506) strcat(s, "t");
if (crc32("HWLET",5) == 1302874247) strcat(s, "p");
if (crc32("TuGgjQTqdtQQ",12) == 1089329496) strcat(s, "e");
if (crc32("OmMxHxYeW",9) == 645997430) strcat(s, "n");
if (crc32("HrmHyj",6) == 897852242) strcat(s, "a");
if (crc32("qWOJSVdoMJ",10) == 3853280676) strcat(s, "c");
if (crc32("eKeDrr",6) == 2626077605) strcat(s, "N");
if (crc32("lWljtRQNtV",10) == 2221823274) strcat(s, "e");
    return s;
}

char *handlebar_nouns() {
    char *s = calloc(10);
    if (crc32("imGCYazjnL",10) == 2146092913) strcat(s, "h");
if (crc32("MIkpxt",6) == 1606409376) strcat(s, "a");
if (crc32("yNnEThey",8) == 4103464351) strcat(s, "S");
if (crc32("PZUTvFwgOQ",10) == 2911576525) strcat(s, "n");
if (crc32("ivkmQ",5) == 2498317608) strcat(s, "d");
if (crc32("erRwgDZBS",9) == 3532087767) strcat(s, "l");
if (crc32("KLsWyK",6) == 33458094) strcat(s, "l");
if (crc32("HVqPlnrBWb",10) == 2447020852) strcat(s, "e");
if (crc32("yecvJ",5) == 2615505173) strcat(s, "b");
if (crc32("RqanhhnkhdTly",13) == 1276384012) strcat(s, "a");
if (crc32("QVZssZfFN",9) == 1564445437) strcat(s, "X");
if (crc32("bvNicjdkqWW",11) == 2281627303) strcat(s, "r");
    return s;
}

char *kiotomy_nouns() {
    char *s = calloc(8);
    if (crc32("dbUDFKZXJDH",11) == 1691044171) strcat(s, "k");
if (crc32("XEZDovnUlMhOyR",14) == 3822482240) strcat(s, "i");
if (crc32("PjECsCPrSRqatq",14) == 3486056437) strcat(s, "o");
if (crc32("PCsoNiV",7) == 9346298) strcat(s, "V");
if (crc32("luTcLFuiUAdwz",13) == 3753325437) strcat(s, "t");
if (crc32("HHAEQINUnPZKGeH",15) == 1148855473) strcat(s, "o");
if (crc32("NUtnMCldt",9) == 4189120866) strcat(s, "m");
if (crc32("LtDqaR",6) == 563781670) strcat(s, "A");
if (crc32("CEiMQ",5) == 1795611918) strcat(s, "y");
    return s;
}

char *respect_nouns() {
    char *s = calloc(8);
    if (crc32("XJPMuZL",7) == 1236870372) strcat(s, "T");
if (crc32("KlTkJrlGs",9) == 1823468866) strcat(s, "r");
if (crc32("tquAHRQRQPaGbjT",15) == 2359468434) strcat(s, "T");
if (crc32("dVdZkgUCkD",10) == 3646702352) strcat(s, "e");
if (crc32("ySCLqd",6) == 3146753566) strcat(s, "f");
if (crc32("egFkBLJXxT",10) == 1215309623) strcat(s, "s");
if (crc32("CIWUZxXQ",8) == 4184520769) strcat(s, "t");
if (crc32("eBqTTjAz",8) == 2077070060) strcat(s, "p");
if (crc32("hRQAlXru",8) == 825099159) strcat(s, "Q");
if (crc32("ndGDdJrXKIMx",12) == 2007490450) strcat(s, "e");
if (crc32("LKWkFWqOTeXoNS",14) == 2615945059) strcat(s, "c");
if (crc32("gYNDEdru",8) == 1161255560) strcat(s, "n");
if (crc32("RxNWPDQZhVTY",12) == 1944385692) strcat(s, "t");
    return s;
}

char *Siegler_nouns() {
    char *s = calloc(8);
    if (crc32("DaIdSg",6) == 2427019482) strcat(s, "u");
if (crc32("SIhogejxUyE",11) == 4279838702) strcat(s, "S");
if (crc32("iRCpZsO",7) == 892477667) strcat(s, "i");
if (crc32("raQeD",5) == 2347284630) strcat(s, "w");
if (crc32("NRROzs",6) == 3227380282) strcat(s, "e");
if (crc32("mmvhDlobPx",10) == 3164706215) strcat(s, "g");
if (crc32("xIFwHAXkhnwUaA",14) == 1378066798) strcat(s, "l");
if (crc32("XaDhYsznQ",9) == 2514281405) strcat(s, "e");
if (crc32("MzsEXC",6) == 587908944) strcat(s, "r");
    return s;
}

char *gummite_nouns() {
    char *s = calloc(8);
    if (crc32("kOBlyDOdoJMWV",13) == 25215188) strcat(s, "H");
if (crc32("UzdocFiytZKxWRJ",15) == 2629425220) strcat(s, "g");
if (crc32("pKXktEUsRe",10) == 287212773) strcat(s, "U");
if (crc32("CnOJc",5) == 2808285220) strcat(s, "u");
if (crc32("oNjRpzScLJdA",12) == 2038550795) strcat(s, "e");
if (crc32("NGbVU",5) == 2609983830) strcat(s, "m");
if (crc32("kooOm",5) == 1977445464) strcat(s, "h");
if (crc32("GydkRtRvp",9) == 318347590) strcat(s, "m");
if (crc32("EoCeBEbuE",9) == 3343488312) strcat(s, "i");
if (crc32("mFQjc",5) == 1059632200) strcat(s, "t");
if (crc32("BguRKt",6) == 1990242179) strcat(s, "N");
if (crc32("VUlvTICHqHZMDW",14) == 641063718) strcat(s, "e");
    return s;
}

char *diminishableness_nouns() {
    char *s = calloc(17);
    if (crc32("KqAKOwdvzpI",11) == 3315626878) strcat(s, "d");
if (crc32("xWolmp",6) == 2120125459) strcat(s, "i");
if (crc32("zYOqJd",6) == 4168444540) strcat(s, "m");
if (crc32("zCIwXljUDiA",11) == 1409898132) strcat(s, "i");
if (crc32("pLyzABSaP",9) == 2519253298) strcat(s, "n");
if (crc32("VOSAY",5) == 657031904) strcat(s, "i");
if (crc32("EXUjMsdTaT",10) == 1466873155) strcat(s, "Y");
if (crc32("xlFJfgYxqVfLrSY",15) == 3592432305) strcat(s, "s");
if (crc32("Ypjfj",5) == 1134489770) strcat(s, "h");
if (crc32("crYzU",5) == 610880576) strcat(s, "L");
if (crc32("ajyqTl",6) == 2017413858) strcat(s, "a");
if (crc32("LxSyqukiuiHvraY",15) == 1011792271) strcat(s, "b");
if (crc32("kyfxwzMlB",9) == 3683491155) strcat(s, "P");
if (crc32("AaySmrLfkXb",11) == 2136274615) strcat(s, "l");
if (crc32("hsgKQCkHG",9) == 279645682) strcat(s, "e");
if (crc32("nTwnxbbMOcLVMHK",15) == 4287174668) strcat(s, "n");
if (crc32("dtmQcf",6) == 1623604656) strcat(s, "e");
if (crc32("cFLWXNCvJw",10) == 4138099072) strcat(s, "s");
if (crc32("DLYJvhcVq",9) == 179900651) strcat(s, "s");
    return s;
}

char *Timothea_nouns() {
    char *s = calloc(9);
    if (crc32("PGGAsjfwjvVekr",14) == 1597969048) strcat(s, "n");
if (crc32("BdtiR",5) == 855096538) strcat(s, "T");
if (crc32("HUGRdHr",7) == 3783353515) strcat(s, "y");
if (crc32("ZEiESGHMyLl",11) == 1523394541) strcat(s, "i");
if (crc32("TcfQh",5) == 2394027030) strcat(s, "m");
if (crc32("ZPUge",5) == 3197820288) strcat(s, "k");
if (crc32("lnLiSnCjZZZXC",13) == 3544442621) strcat(s, "o");
if (crc32("ndxsRZujRO",10) == 1756388147) strcat(s, "d");
if (crc32("TBNdMcrIcJs",11) == 1021804838) strcat(s, "t");
if (crc32("pQRCpQsJa",9) == 3320048176) strcat(s, "s");
if (crc32("EFtKg",5) == 2079163772) strcat(s, "h");
if (crc32("Iwonkj",6) == 3624271245) strcat(s, "e");
if (crc32("cUFkdfcHMAL",11) == 2069008812) strcat(s, "I");
if (crc32("dORcS",5) == 3127749647) strcat(s, "a");
    return s;
}

char *snakehead_nouns() {
    char *s = calloc(10);
    if (crc32("ndDuvGKPt",9) == 753914490) strcat(s, "s");
if (crc32("mgfjfad",7) == 1517686790) strcat(s, "n");
if (crc32("bAbxRZJiKdonP",13) == 939546634) strcat(s, "a");
if (crc32("DIIlXYCjmh",10) == 2328973060) strcat(s, "p");
if (crc32("KtkMOXshFxiZDq",14) == 1499958958) strcat(s, "k");
if (crc32("YfdudLvHoeR",11) == 529726612) strcat(s, "V");
if (crc32("oqdqvXXfjhSjM",13) == 2145781820) strcat(s, "e");
if (crc32("JETRXxckTSbXub",14) == 562911496) strcat(s, "h");
if (crc32("RdMYPSArOzAIaF",14) == 3933609097) strcat(s, "e");
if (crc32("ZbaltgHZWKKDteD",15) == 4091335231) strcat(s, "a");
if (crc32("aHkYmBNouO",10) == 2568737698) strcat(s, "d");
    return s;
}

char *brickfielder_nouns() {
    char *s = calloc(13);
    if (crc32("wkMJfnlBlV",10) == 893304666) strcat(s, "r");
if (crc32("kbTlvZf",7) == 1501244881) strcat(s, "b");
if (crc32("xxxjjFHlgGTJiz",14) == 2094467657) strcat(s, "X");
if (crc32("luTGZGWjmrtD",12) == 4033611882) strcat(s, "r");
if (crc32("LpHLiWxSXTpN",12) == 3496854815) strcat(s, "J");
if (crc32("brczAlhpOwp",11) == 3715596933) strcat(s, "i");
if (crc32("mHPEhfMN",8) == 1484507258) strcat(s, "y");
if (crc32("colZeoqOeQMspON",15) == 2132269229) strcat(s, "c");
if (crc32("tCaXY",5) == 1779554778) strcat(s, "k");
if (crc32("OSTBi",5) == 1487792862) strcat(s, "f");
if (crc32("NfmsamJoAs",10) == 4020821266) strcat(s, "i");
if (crc32("xcgGgyxAtZGmG",13) == 3229883127) strcat(s, "e");
if (crc32("KpztWVRgm",9) == 3706159528) strcat(s, "l");
if (crc32("mNFLb",5) == 4083025800) strcat(s, "d");
if (crc32("bGInF",5) == 949593975) strcat(s, "d");
if (crc32("rXxFruRCPTVH",12) == 60883518) strcat(s, "e");
if (crc32("CMdMz",5) == 181837810) strcat(s, "r");
    return s;
}

char *dal_nouns() {
    char *s = calloc(4);
    if (crc32("mkSmpsqPUtwjGDF",15) == 759189340) strcat(s, "m");
if (crc32("SehxBBUv",8) == 1990842935) strcat(s, "d");
if (crc32("INBtVpiNCFsP",12) == 2606403590) strcat(s, "Q");
if (crc32("sYghIAtWEyVtOKy",15) == 304282673) strcat(s, "a");
if (crc32("mIMRKY",6) == 1463255743) strcat(s, "l");
    return s;
}

char *Hellenist_nouns() {
    char *s = calloc(10);
    if (crc32("MosTj",5) == 537086639) strcat(s, "H");
if (crc32("FogwxtcOdnXY",12) == 1708618647) strcat(s, "e");
if (crc32("fhpzSfL",7) == 2706410432) strcat(s, "y");
if (crc32("uDBFaynPJActz",13) == 699653209) strcat(s, "l");
if (crc32("rGXsgqlZzd",10) == 1011466092) strcat(s, "d");
if (crc32("JoWqIXFQWpugYiy",15) == 3701660758) strcat(s, "l");
if (crc32("JjPiqbhhUiP",11) == 3380831543) strcat(s, "e");
if (crc32("mgrsjnBaiwIv",12) == 2088245967) strcat(s, "n");
if (crc32("CaPMzoYeNVylC",13) == 374824639) strcat(s, "Z");
if (crc32("yEMNwkIiJVSQ",12) == 2584663938) strcat(s, "i");
if (crc32("LGpePGO",7) == 3428300330) strcat(s, "s");
if (crc32("bVWGVPpqss",10) == 628634407) strcat(s, "z");
if (crc32("HSGSrYdxZE",10) == 3488625218) strcat(s, "t");
    return s;
}

char *festoonery_nouns() {
    char *s = calloc(11);
    if (crc32("joijfalyZc",10) == 1321093085) strcat(s, "t");
if (crc32("qXvvqAN",7) == 576550112) strcat(s, "f");
if (crc32("jtsgBLvKJc",10) == 3622542893) strcat(s, "e");
if (crc32("jPHfUvwMdBBfee",14) == 3193673318) strcat(s, "s");
if (crc32("rsYeSFSMWLiuXJq",15) == 4030309762) strcat(s, "l");
if (crc32("VeoRwZ",6) == 3715823652) strcat(s, "t");
if (crc32("dCRXyqMq",8) == 747941545) strcat(s, "o");
if (crc32("goupEFSiDjLZ",12) == 1641261979) strcat(s, "Q");
if (crc32("vkUhXdVCIA",10) == 1405206602) strcat(s, "o");
if (crc32("TTctxoEyu",9) == 1048545858) strcat(s, "L");
if (crc32("VPEeEHLzSQG",11) == 130926580) strcat(s, "n");
if (crc32("oBEdmNOvEhIFqpx",15) == 2813924168) strcat(s, "e");
if (crc32("GSrPCRsvfjK",11) == 3143735230) strcat(s, "r");
if (crc32("ldQCxxWXvLaz",12) == 1844297338) strcat(s, "l");
if (crc32("HvcUWq",6) == 3041329730) strcat(s, "y");
    return s;
}

char *glycogenase_nouns() {
    char *s = calloc(12);
    if (crc32("HXGyMZvtlrRT",12) == 2310784511) strcat(s, "g");
if (crc32("GACSAmips",9) == 1272863318) strcat(s, "l");
if (crc32("EteVkGqa",8) == 3786747908) strcat(s, "p");
if (crc32("euHQCfwZfCADzW",14) == 1067417522) strcat(s, "y");
if (crc32("vLmChNcfPqUoES",14) == 163338596) strcat(s, "S");
if (crc32("eBdNACObyI",10) == 3325803352) strcat(s, "c");
if (crc32("WRYjhaWgdnaT",12) == 860554386) strcat(s, "B");
if (crc32("pfEvCT",6) == 3883277129) strcat(s, "o");
if (crc32("SDQBwINWJoSQC",13) == 1594379793) strcat(s, "g");
if (crc32("AVGCWaXotfqv",12) == 1975108323) strcat(s, "e");
if (crc32("GswiXbGk",8) == 603447533) strcat(s, "D");
if (crc32("VKVrapoyWZhpR",13) == 4057707723) strcat(s, "n");
if (crc32("DNUMIpnL",8) == 370683027) strcat(s, "a");
if (crc32("FZljleABmth",11) == 2878976422) strcat(s, "W");
if (crc32("OWvzkfmuYaVeUZO",15) == 999605407) strcat(s, "s");
if (crc32("SDaQfUcUGt",10) == 1833128787) strcat(s, "A");
if (crc32("mmcSttz",7) == 1815521106) strcat(s, "e");
    return s;
}

char *skiagraph_nouns() {
    char *s = calloc(10);
    if (crc32("uZJsmrnxgQlSwXS",15) == 1633715793) strcat(s, "W");
if (crc32("yfnXTYqbDjI",11) == 1853105793) strcat(s, "s");
if (crc32("jydUJgD",7) == 4206986795) strcat(s, "y");
if (crc32("AyVjlKTBllhKG",13) == 1261172301) strcat(s, "k");
if (crc32("OxsdMyOtyhxVw",13) == 3288546229) strcat(s, "i");
if (crc32("ZyFqTg",6) == 2597094293) strcat(s, "n");
if (crc32("kKskSks",7) == 48813520) strcat(s, "a");
if (crc32("dlDVwdOxSotWibl",15) == 3150736224) strcat(s, "N");
if (crc32("PGUlJrIK",8) == 3527412835) strcat(s, "g");
if (crc32("ygXFSLmtXkSWPtc",15) == 2330116282) strcat(s, "r");
if (crc32("tqlryGVAxSQt",12) == 3488965775) strcat(s, "a");
if (crc32("uJJTr",5) == 3578010308) strcat(s, "t");
if (crc32("kxdUUSbgG",9) == 3291260586) strcat(s, "p");
if (crc32("ahPlMOb",7) == 2985746245) strcat(s, "h");
    return s;
}

char *Yokum_nouns() {
    char *s = calloc(6);
    if (crc32("uNeffBdbUA",10) == 1346988380) strcat(s, "Y");
if (crc32("VgBufMcGo",9) == 2823130801) strcat(s, "B");
if (crc32("zZapKmC",7) == 4098220554) strcat(s, "o");
if (crc32("TgQqvKxoqk",10) == 1274607971) strcat(s, "k");
if (crc32("twSAJzAIp",9) == 768431754) strcat(s, "u");
if (crc32("nQzAXHTvWWsqRy",14) == 3972085654) strcat(s, "m");
if (crc32("AdLJXmNDKCeOg",13) == 1606510001) strcat(s, "m");
    return s;
}

char *coper_nouns() {
    char *s = calloc(6);
    if (crc32("HGXME",5) == 2309783374) strcat(s, "c");
if (crc32("OUadErJFMKmGhy",14) == 2853394192) strcat(s, "X");
if (crc32("kWPnMUQY",8) == 2521013400) strcat(s, "o");
if (crc32("OcOawin",7) == 3086817920) strcat(s, "p");
if (crc32("joFnKfAMdzEasX",14) == 2568023956) strcat(s, "j");
if (crc32("kYBXQOc",7) == 3723662741) strcat(s, "e");
if (crc32("ckTxVjQdxEmviJ",14) == 3841399135) strcat(s, "r");
    return s;
}

char *jean_nouns() {
    char *s = calloc(5);
    if (crc32("YOZDHfFBsjS",11) == 961459955) strcat(s, "j");
if (crc32("FuAqbtSbUtH",11) == 1172020365) strcat(s, "q");
if (crc32("FkKaPSM",7) == 2172290192) strcat(s, "e");
if (crc32("rLqFofFPoK",10) == 3115099231) strcat(s, "q");
if (crc32("vCSNaPGsveEQTQE",15) == 3915205807) strcat(s, "a");
if (crc32("AEhuDps",7) == 1383913758) strcat(s, "a");
if (crc32("wijlcJVTp",9) == 558355202) strcat(s, "n");
    return s;
}

char *toreador_nouns() {
    char *s = calloc(9);
    if (crc32("fWQeEjJgh",9) == 2911243648) strcat(s, "s");
if (crc32("JeByOAoXC",9) == 3979391002) strcat(s, "t");
if (crc32("fqmehYPjQsOETF",14) == 3195479801) strcat(s, "o");
if (crc32("fDZDFiDePcvN",12) == 606032038) strcat(s, "U");
if (crc32("jVufm",5) == 2841162736) strcat(s, "r");
if (crc32("FgEcCmKBrkAXqR",14) == 2331994255) strcat(s, "Q");
if (crc32("zXCTGWIVCzw",11) == 2843074653) strcat(s, "e");
if (crc32("NeDLeudjSDRbptO",15) == 4032238230) strcat(s, "L");
if (crc32("WDQnlc",6) == 556924353) strcat(s, "a");
if (crc32("fOwRdqVREzc",11) == 1045032502) strcat(s, "N");
if (crc32("AwEPQbr",7) == 3063355875) strcat(s, "d");
if (crc32("TmJvkunXxXQwSno",15) == 1046023009) strcat(s, "F");
if (crc32("fQivFbE",7) == 1304746695) strcat(s, "o");
if (crc32("VKqjJvLCSo",10) == 1940855585) strcat(s, "r");
    return s;
}

char *Plasticine_nouns() {
    char *s = calloc(11);
    if (crc32("QJxFXNseprOkws",14) == 295925356) strcat(s, "P");
if (crc32("cxlAHlbE",8) == 2960434697) strcat(s, "l");
if (crc32("RhgHSxTdZvaVoj",14) == 3146565649) strcat(s, "a");
if (crc32("KifoTZiR",8) == 4200895606) strcat(s, "d");
if (crc32("GssxDjixfmx",11) == 3729018177) strcat(s, "s");
if (crc32("CzyIg",5) == 1546893276) strcat(s, "Z");
if (crc32("AMfRENbJGywOsGL",15) == 1921216843) strcat(s, "t");
if (crc32("vEeiyGnSscPQKF",14) == 1596434700) strcat(s, "L");
if (crc32("TTLOCFLIVNKu",12) == 55751913) strcat(s, "i");
if (crc32("FYXySCgkh",9) == 1125497212) strcat(s, "c");
if (crc32("KzWaoazZ",8) == 2552924113) strcat(s, "i");
if (crc32("uYquIa",6) == 1167677611) strcat(s, "n");
if (crc32("wAGokSe",7) == 301806751) strcat(s, "e");
    return s;
}

char *amylase_nouns() {
    char *s = calloc(8);
    if (crc32("gxTljNxTjK",10) == 1145762916) strcat(s, "Y");
if (crc32("owUPTApFyVEuv",13) == 3202611646) strcat(s, "a");
if (crc32("zGWSZrOoL",9) == 1702022968) strcat(s, "D");
if (crc32("kcaeeXyZy",9) == 2120582622) strcat(s, "m");
if (crc32("CKrMo",5) == 1523317511) strcat(s, "y");
if (crc32("PINHHaSM",8) == 839419630) strcat(s, "l");
if (crc32("QoUcZyDcPdnzyC",14) == 162439752) strcat(s, "r");
if (crc32("niyNwqrZuRNrv",13) == 3875639088) strcat(s, "a");
if (crc32("lIxbLAHOEP",10) == 3332551428) strcat(s, "s");
if (crc32("oSijnQyauxYqe",13) == 3222483691) strcat(s, "s");
if (crc32("aZEDkXtXlLoTJ",13) == 474590689) strcat(s, "e");
    return s;
}

char *pretariff_nouns() {
    char *s = calloc(10);
    if (crc32("jSiovaxbZAulxO",14) == 1245340417) strcat(s, "p");
if (crc32("NHncq",5) == 1423638019) strcat(s, "r");
if (crc32("ThvVEmtCzhW",11) == 1472668712) strcat(s, "e");
if (crc32("ElgNsfw",7) == 1812322785) strcat(s, "N");
if (crc32("ZKbLpfEylxakv",13) == 2841933199) strcat(s, "t");
if (crc32("sKkWb",5) == 98196884) strcat(s, "Z");
if (crc32("YShAwy",6) == 597513013) strcat(s, "a");
if (crc32("DemVvmkNEVBimW",14) == 3368755988) strcat(s, "r");
if (crc32("UeZqoxaEU",9) == 1056542741) strcat(s, "t");
if (crc32("eCttblaXsp",10) == 2948232104) strcat(s, "i");
if (crc32("HUGRcqldeHFUtA",14) == 2734863419) strcat(s, "b");
if (crc32("zHYij",5) == 1372926518) strcat(s, "f");
if (crc32("RxgprunXP",9) == 77073234) strcat(s, "f");
    return s;
}

char *gunning_nouns() {
    char *s = calloc(8);
    if (crc32("BqwByTrebrX",11) == 1371349651) strcat(s, "g");
if (crc32("DIfXiBflMejCs",13) == 981665783) strcat(s, "u");
if (crc32("GDxOeRgeNiZII",13) == 773690888) strcat(s, "n");
if (crc32("SwkNAJMaFyrSwJ",14) == 2237566207) strcat(s, "K");
if (crc32("JvEEDa",6) == 497590573) strcat(s, "n");
if (crc32("nDzLGKzvzjKWGE",14) == 172080082) strcat(s, "K");
if (crc32("YlRbceekUqjv",12) == 4044942118) strcat(s, "i");
if (crc32("SaDgfZiZPHiM",12) == 2021670804) strcat(s, "l");
if (crc32("znmqckwLl",9) == 389624349) strcat(s, "n");
if (crc32("urVpzMOqyNvIXSr",15) == 3101190309) strcat(s, "I");
if (crc32("BcLMuzCqU",9) == 304967642) strcat(s, "g");
    return s;
}

char *Pelson_nouns() {
    char *s = calloc(7);
    if (crc32("MeqISN",6) == 2800240298) strcat(s, "f");
if (crc32("RMHlUXuxrERH",12) == 1496309686) strcat(s, "P");
if (crc32("EGNwUXKKpDLPRdQ",15) == 1252312662) strcat(s, "F");
if (crc32("OTALaCLiWkvXpX",14) == 1477101539) strcat(s, "e");
if (crc32("jYJJJJuepQeWI",13) == 209242584) strcat(s, "l");
if (crc32("sjOELlO",7) == 2610514510) strcat(s, "w");
if (crc32("cgeBoPE",7) == 2911550009) strcat(s, "s");
if (crc32("GIUYAMKl",8) == 4073360063) strcat(s, "o");
if (crc32("TLCWWgCuxe",10) == 294585395) strcat(s, "n");
    return s;
}

char *interdifferentiation_nouns() {
    char *s = calloc(21);
    if (crc32("gjmIVRXMTQYr",12) == 2306256462) strcat(s, "w");
if (crc32("nuiOVlwAxXnnVwM",15) == 895826252) strcat(s, "i");
if (crc32("lYccGRqwDISFuQb",15) == 3860044947) strcat(s, "k");
if (crc32("VCfOMZZpnQ",10) == 3262014226) strcat(s, "n");
if (crc32("HlcuxLhVjQjA",12) == 1586664121) strcat(s, "c");
if (crc32("lBtKAOUZYyGHP",13) == 2403514106) strcat(s, "t");
if (crc32("fSJzssptisXUEqb",15) == 2201271893) strcat(s, "e");
if (crc32("zWBmhWXcMfHEyBW",15) == 1709750226) strcat(s, "i");
if (crc32("yuPirprE",8) == 2126059961) strcat(s, "r");
if (crc32("tCUiD",5) == 3962109949) strcat(s, "d");
if (crc32("pLXRuaPk",8) == 2650297336) strcat(s, "i");
if (crc32("sMZLgPDpJyf",11) == 2469203258) strcat(s, "S");
if (crc32("dobTLCsf",8) == 3339694138) strcat(s, "f");
if (crc32("DqGKfJoEtyizJV",14) == 608484023) strcat(s, "f");
if (crc32("VwtEQ",5) == 4119742107) strcat(s, "t");
if (crc32("JNTmnEaJNqO",11) == 3320290363) strcat(s, "e");
if (crc32("WQTozNKotDxPme",14) == 1467895088) strcat(s, "r");
if (crc32("qxdxw",5) == 3303151901) strcat(s, "E");
if (crc32("ccEkjiwWqpSabq",14) == 3860934576) strcat(s, "e");
if (crc32("TVjPrBLUTU",10) == 712618602) strcat(s, "n");
if (crc32("xTIaWPhWOPVvoa",14) == 2434787570) strcat(s, "t");
if (crc32("pLeQYd",6) == 1740839360) strcat(s, "i");
if (crc32("wsnFXzgQwnmU",12) == 1830612405) strcat(s, "x");
if (crc32("augQJpwqAzf",11) == 943900619) strcat(s, "a");
if (crc32("bsBzbsbKJS",10) == 843892728) strcat(s, "t");
if (crc32("TtZvnBFWqQNUlI",14) == 1907958858) strcat(s, "i");
if (crc32("TSZbT",5) == 2297367028) strcat(s, "o");
if (crc32("uuddNiiK",8) == 2850665607) strcat(s, "n");
    return s;
}

char *carpal_nouns() {
    char *s = calloc(7);
    if (crc32("RjaxHiAol",9) == 3366068029) strcat(s, "c");
if (crc32("jLkrztZKOSOE",12) == 3677989183) strcat(s, "F");
if (crc32("QOdKSiOsRCm",11) == 3523114905) strcat(s, "a");
if (crc32("medrvGvb",8) == 3783440872) strcat(s, "d");
if (crc32("wQRkTxBApUcLxQ",14) == 196629588) strcat(s, "r");
if (crc32("ALYkBaSwJur",11) == 3440926980) strcat(s, "v");
if (crc32("PCtVkekNX",9) == 1550537189) strcat(s, "p");
if (crc32("CaKvwSzcXo",10) == 2931322094) strcat(s, "a");
if (crc32("bZUZLv",6) == 4262418542) strcat(s, "l");
    return s;
}

char *semipiousness_nouns() {
    char *s = calloc(14);
    if (crc32("ZFPefnyazgjF",12) == 809599912) strcat(s, "s");
if (crc32("WRpHeHajKKfCf",13) == 3762882844) strcat(s, "e");
if (crc32("UekIXrGYk",9) == 1781317953) strcat(s, "b");
if (crc32("AkOQCSTdA",9) == 2061810393) strcat(s, "m");
if (crc32("kRBKaPw",7) == 108175956) strcat(s, "i");
if (crc32("IxMKYio",7) == 1165295806) strcat(s, "a");
if (crc32("pCWbYbbf",8) == 1084534609) strcat(s, "p");
if (crc32("SyMKYEhrqFHJ",12) == 3799604246) strcat(s, "u");
if (crc32("LuvFH",5) == 2308450104) strcat(s, "i");
if (crc32("KBvNSOab",8) == 2245877077) strcat(s, "o");
if (crc32("jxCiMLxlYVNl",12) == 1508667787) strcat(s, "n");
if (crc32("PSQAvcHX",8) == 3652051932) strcat(s, "u");
if (crc32("gIucwJHDrf",10) == 1759640809) strcat(s, "s");
if (crc32("MluwrE",6) == 1210491469) strcat(s, "n");
if (crc32("Azhtm",5) == 3387919865) strcat(s, "g");
if (crc32("BREKBfIZ",8) == 488930146) strcat(s, "e");
if (crc32("qVxbWkgxSAIGer",14) == 2145167021) strcat(s, "s");
if (crc32("emeghY",6) == 2716456192) strcat(s, "X");
if (crc32("csnpa",5) == 922303456) strcat(s, "s");
    return s;
}

char *Ithomatas_nouns() {
    char *s = calloc(10);
    if (crc32("gbkuFTJkvlAo",12) == 169275433) strcat(s, "z");
if (crc32("aTuKoMeraqO",11) == 1131382322) strcat(s, "I");
if (crc32("ohwIKayllevBK",13) == 3629671203) strcat(s, "t");
if (crc32("VJkyjn",6) == 2380941562) strcat(s, "C");
if (crc32("qgOzFHAbRRngY",13) == 958547117) strcat(s, "h");
if (crc32("JFeKUggE",8) == 3721748181) strcat(s, "h");
if (crc32("FIyQqIxZYgaqG",13) == 3415007371) strcat(s, "o");
if (crc32("OcNQmA",6) == 54914154) strcat(s, "n");
if (crc32("kUrILlqtlV",10) == 583905995) strcat(s, "m");
if (crc32("erOFTvQDyaKsW",13) == 4132349728) strcat(s, "a");
if (crc32("aNgrWmQhUXiSIG",14) == 524352383) strcat(s, "a");
if (crc32("CMRWF",5) == 3044180108) strcat(s, "t");
if (crc32("hYVkhYetHLc",11) == 3901319771) strcat(s, "t");
if (crc32("UkTHRAtfGNN",11) == 1991617777) strcat(s, "a");
if (crc32("JOKycmte",8) == 3782628726) strcat(s, "s");
    return s;
}

char *artisanship_nouns() {
    char *s = calloc(12);
    if (crc32("DcfKx",5) == 1137412395) strcat(s, "a");
if (crc32("gbyAkj",6) == 190631699) strcat(s, "F");
if (crc32("YvzPrAPG",8) == 3493082494) strcat(s, "r");
if (crc32("xucKFNtWy",9) == 3047163424) strcat(s, "t");
if (crc32("wMvwSXFYCG",10) == 3341986462) strcat(s, "x");
if (crc32("YGMnJVyJkSppA",13) == 1441467605) strcat(s, "i");
if (crc32("dQZKC",5) == 2819459119) strcat(s, "i");
if (crc32("SIyZTULat",9) == 749667150) strcat(s, "s");
if (crc32("fnhnSt",6) == 860358332) strcat(s, "a");
if (crc32("fZotGSEDWYpwSu",14) == 3409707542) strcat(s, "n");
if (crc32("MgmNVRBxXRiDNTz",15) == 211998556) strcat(s, "g");
if (crc32("OSzDCBouhgRXQz",14) == 925291074) strcat(s, "s");
if (crc32("CiqwbnDUs",9) == 2472748636) strcat(s, "l");
if (crc32("NucOUmMkfVlE",12) == 84462485) strcat(s, "h");
if (crc32("OimFR",5) == 971374628) strcat(s, "i");
if (crc32("ulUdOgsyDUHdHP",14) == 859512167) strcat(s, "d");
if (crc32("gIWXIMIWVyKk",12) == 3583619682) strcat(s, "p");
    return s;
}

char *Nec_nouns() {
    char *s = calloc(4);
    if (crc32("gdCLOhMtdShorIi",15) == 3481533003) strcat(s, "W");
if (crc32("HOrgJxhyXNXzBx",14) == 4235584236) strcat(s, "N");
if (crc32("rzrCDeNfN",9) == 2394632865) strcat(s, "e");
if (crc32("sCDho",5) == 4132119211) strcat(s, "c");
    return s;
}

char *fylfot_nouns() {
    char *s = calloc(7);
    if (crc32("DnbHkuWtBZ",10) == 444791710) strcat(s, "f");
if (crc32("eVXuyaCfBX",10) == 2578931163) strcat(s, "q");
if (crc32("kOvYrZ",6) == 3000817731) strcat(s, "y");
if (crc32("SIEeqZGi",8) == 1486951589) strcat(s, "l");
if (crc32("lfARVyNiUcfFQKC",15) == 2438562169) strcat(s, "f");
if (crc32("odVaflP",7) == 953726708) strcat(s, "D");
if (crc32("oVNTBxknQPx",11) == 1400425977) strcat(s, "o");
if (crc32("kTqoXpHrTKN",11) == 1868973404) strcat(s, "F");
if (crc32("PHvlSRFHK",9) == 765688037) strcat(s, "t");
    return s;
}

char *Geneva_nouns() {
    char *s = calloc(7);
    if (crc32("FPJqzgE",7) == 43365666) strcat(s, "G");
if (crc32("VeOIWg",6) == 2698474296) strcat(s, "e");
if (crc32("zzwWR",5) == 3518435547) strcat(s, "k");
if (crc32("BItaKJwqsE",10) == 3633081763) strcat(s, "n");
if (crc32("daycfcytRb",10) == 2754665299) strcat(s, "c");
if (crc32("spuEJ",5) == 1515353323) strcat(s, "e");
if (crc32("IecWNXfcrXked",13) == 4214576483) strcat(s, "w");
if (crc32("EUtEKnPXCVIDa",13) == 1192687530) strcat(s, "v");
if (crc32("PtvwCrVsn",9) == 3299702320) strcat(s, "d");
if (crc32("sJkraUYbu",9) == 342473098) strcat(s, "a");
    return s;
}

char *Enyo_nouns() {
    char *s = calloc(5);
    if (crc32("iBYsMdzg",8) == 3427222802) strcat(s, "E");
if (crc32("JsyaL",5) == 4115119109) strcat(s, "n");
if (crc32("TdmichEChyxUB",13) == 406323003) strcat(s, "y");
if (crc32("VaqzxKyvFdT",11) == 1975437534) strcat(s, "o");
if (crc32("UgisW",5) == 641427153) strcat(s, "o");
    return s;
}

char *sammy_nouns() {
    char *s = calloc(6);
    if (crc32("pkOdeznQNBtsqns",15) == 708538581) strcat(s, "s");
if (crc32("eBSIVBBXeBwU",12) == 1805996263) strcat(s, "a");
if (crc32("MDEGoAkcU",9) == 916772105) strcat(s, "k");
if (crc32("xMqErgLJZaqUB",13) == 3564611218) strcat(s, "m");
if (crc32("AXpfdnAIVy",10) == 2218557642) strcat(s, "w");
if (crc32("BKjMcxY",7) == 777765210) strcat(s, "m");
if (crc32("FMVwdxuGWcyeDZ",14) == 227977069) strcat(s, "e");
if (crc32("WYCZnIYz",8) == 150498874) strcat(s, "y");
    return s;
}

char *astron_nouns() {
    char *s = calloc(7);
    if (crc32("grkQw",5) == 77892234) strcat(s, "q");
if (crc32("WedYskBnzgmfNez",15) == 775390989) strcat(s, "a");
if (crc32("irSeJ",5) == 1934568883) strcat(s, "s");
if (crc32("knXpZFoXDa",10) == 3781898357) strcat(s, "t");
if (crc32("PfTVVPfQVLItGD",14) == 2462127588) strcat(s, "z");
if (crc32("NLRdDoDcDEjHnw",14) == 1412847589) strcat(s, "r");
if (crc32("WGXxYztV",8) == 1229693983) strcat(s, "S");
if (crc32("QzKAjHpNbTu",11) == 1897115446) strcat(s, "o");
if (crc32("DEMLfnHH",8) == 3234701472) strcat(s, "r");
if (crc32("mRePEM",6) == 2723974752) strcat(s, "n");
    return s;
}

char *photoheliography_nouns() {
    char *s = calloc(17);
    if (crc32("xcPVLexlrdhDM",13) == 2433584470) strcat(s, "p");
if (crc32("ptnLpfPBQwHj",12) == 1958663921) strcat(s, "F");
if (crc32("lwyYYyyQO",9) == 2506953527) strcat(s, "h");
if (crc32("JZVUAqTVklYIaz",14) == 2630452814) strcat(s, "Y");
if (crc32("zVCgFdarewH",11) == 2039402313) strcat(s, "o");
if (crc32("ehGJIAfTztOt",12) == 909216747) strcat(s, "P");
if (crc32("yptFiIGQLX",10) == 1047348158) strcat(s, "t");
if (crc32("mDfmPJZOtLkkLY",14) == 650899423) strcat(s, "L");
if (crc32("WwWNYlhsri",10) == 2438375358) strcat(s, "o");
if (crc32("vfTkixdpkW",10) == 445844231) strcat(s, "h");
if (crc32("piiFGBxmwRoZ",12) == 1919452316) strcat(s, "e");
if (crc32("srLgHIi",7) == 1453863480) strcat(s, "l");
if (crc32("SsbYEnbxfYytS",13) == 1292093253) strcat(s, "i");
if (crc32("zJJjtborvKFO",12) == 1823576861) strcat(s, "A");
if (crc32("VVknyyqV",8) == 191156143) strcat(s, "o");
if (crc32("TCZcKAdgKNjG",12) == 2923107699) strcat(s, "e");
if (crc32("MPxIUmD",7) == 1343554481) strcat(s, "g");
if (crc32("tbBsqxvID",9) == 3991215781) strcat(s, "r");
if (crc32("ybrWolTwWn",10) == 2080729341) strcat(s, "a");
if (crc32("jhAWBewPYXfF",12) == 3495704222) strcat(s, "p");
if (crc32("IdEhGoWNuxHJX",13) == 2420321656) strcat(s, "l");
if (crc32("hqzIT",5) == 2822275151) strcat(s, "h");
if (crc32("pOnur",5) == 3941834000) strcat(s, "l");
if (crc32("MrytKtSPteDempf",15) == 3461149220) strcat(s, "y");
    return s;
}

char *Garwood_nouns() {
    char *s = calloc(8);
    if (crc32("DOUnU",5) == 48249858) strcat(s, "q");
if (crc32("RwUuPzFItpjJX",13) == 582783644) strcat(s, "G");
if (crc32("KeRFOdR",7) == 2160570328) strcat(s, "a");
if (crc32("MREzVDXRZtDprs",14) == 3395023743) strcat(s, "r");
if (crc32("wPUOgsdJReD",11) == 3582052443) strcat(s, "Q");
if (crc32("xsfICoj",7) == 49113008) strcat(s, "w");
if (crc32("DXsuIyJTpE",10) == 728413384) strcat(s, "Z");
if (crc32("jqMhCHrDFMYihb",14) == 1692907257) strcat(s, "o");
if (crc32("gxRVADhKbh",10) == 860111942) strcat(s, "o");
if (crc32("OHcvoBh",7) == 2656037058) strcat(s, "d");
    return s;
}

char *Thamos_nouns() {
    char *s = calloc(7);
    if (crc32("fOLAkIbfs",9) == 369375872) strcat(s, "J");
if (crc32("wWDHXxaFxM",10) == 174498674) strcat(s, "T");
if (crc32("fqGSZUxXjtet",12) == 2788637770) strcat(s, "h");
if (crc32("dNqFVxypysKO",12) == 3878378909) strcat(s, "H");
if (crc32("wgTYl",5) == 1877559674) strcat(s, "a");
if (crc32("saKCkuFsrYDd",12) == 271416673) strcat(s, "m");
if (crc32("wazlPbpWNRB",11) == 3284683519) strcat(s, "o");
if (crc32("ZgKucnEFrhS",11) == 3559234622) strcat(s, "s");
    return s;
}

char *Cerelia_nouns() {
    char *s = calloc(8);
    if (crc32("yLKdrIb",7) == 3524510107) strcat(s, "C");
if (crc32("KhZIJNDzxRVSi",13) == 1673690922) strcat(s, "r");
if (crc32("liNvO",5) == 969733987) strcat(s, "e");
if (crc32("lyRBQ",5) == 1036792956) strcat(s, "r");
if (crc32("deiztsmlBO",10) == 900984014) strcat(s, "N");
if (crc32("CaSDMbP",7) == 67129430) strcat(s, "e");
if (crc32("WoMTsSa",7) == 2602842261) strcat(s, "l");
if (crc32("BjkfXkMjEjRfr",13) == 1365770999) strcat(s, "i");
if (crc32("UmgdDDBPYeXt",12) == 805277590) strcat(s, "z");
if (crc32("DIgWhixZRetJOWZ",15) == 447384940) strcat(s, "a");
    return s;
}

char *azulejo_nouns() {
    char *s = calloc(8);
    if (crc32("ECPEkLEAiUyDKBu",15) == 2185501815) strcat(s, "d");
if (crc32("eLSZXsYkzeEuF",13) == 1572636568) strcat(s, "a");
if (crc32("oZeYlmDIiTGrr",13) == 4118660301) strcat(s, "J");
if (crc32("DwhvjmVJyVmVLe",14) == 892098027) strcat(s, "z");
if (crc32("sJFzThNxarfT",12) == 4098138260) strcat(s, "u");
if (crc32("IOyIcDIKdoDUase",15) == 324608366) strcat(s, "l");
if (crc32("NlbtayAGGdNmoah",15) == 778395827) strcat(s, "e");
if (crc32("ZnTQvSJpNeXtCZ",14) == 1484599830) strcat(s, "u");
if (crc32("UGYvRdKhdgq",11) == 507014969) strcat(s, "j");
if (crc32("TbeOGg",6) == 3712588775) strcat(s, "d");
if (crc32("RJkbmjQOrj",10) == 1536038107) strcat(s, "o");
    return s;
}

char *foremast_nouns() {
    char *s = calloc(9);
    if (crc32("MyVihZKqYFzDq",13) == 904760268) strcat(s, "f");
if (crc32("XBESLHaKdCi",11) == 1411012726) strcat(s, "o");
if (crc32("udFjccpPzMS",11) == 946812360) strcat(s, "r");
if (crc32("fjtuKBUykID",11) == 2852914254) strcat(s, "e");
if (crc32("iFXkmnzbWAju",12) == 2399437556) strcat(s, "k");
if (crc32("vyTiLBPaGtZVo",13) == 2755215750) strcat(s, "m");
if (crc32("ablYxAXjxAFXcI",14) == 3090826995) strcat(s, "W");
if (crc32("taRGTTfjaAg",11) == 359163056) strcat(s, "a");
if (crc32("eOhmCxKWNSJ",11) == 3636972787) strcat(s, "y");
if (crc32("RWvmu",5) == 1919670294) strcat(s, "s");
if (crc32("lsNRTKHham",10) == 2258621737) strcat(s, "t");
    return s;
}

char *excud_nouns() {
    char *s = calloc(6);
    if (crc32("Fycxur",6) == 53688010) strcat(s, "e");
if (crc32("dfZHcw",6) == 2944004200) strcat(s, "K");
if (crc32("mwdYgLAd",8) == 3718841419) strcat(s, "x");
if (crc32("VFCZFUAbmVJQB",13) == 1181492703) strcat(s, "c");
if (crc32("CbbQdMy",7) == 505465101) strcat(s, "u");
if (crc32("LvgPsDLz",8) == 1842960370) strcat(s, "B");
if (crc32("kBLYZTMINA",10) == 3942948878) strcat(s, "d");
    return s;
}

char *Roselane_nouns() {
    char *s = calloc(9);
    if (crc32("lFTDQK",6) == 1746242191) strcat(s, "R");
if (crc32("TwYWhru",7) == 1152037213) strcat(s, "o");
if (crc32("kPQsEIamvyJziU",14) == 201351283) strcat(s, "s");
if (crc32("LmAwXKa",7) == 3767095870) strcat(s, "a");
if (crc32("vxbhTXGfKdCLt",13) == 3922241964) strcat(s, "e");
if (crc32("QXhXNELVo",9) == 423099551) strcat(s, "Y");
if (crc32("UPqEIyOJhvMu",12) == 1107580195) strcat(s, "l");
if (crc32("iHbam",5) == 1008531500) strcat(s, "f");
if (crc32("oWzVwDnSnG",10) == 3041987538) strcat(s, "a");
if (crc32("YdgFvZsDtvk",11) == 2360629074) strcat(s, "K");
if (crc32("YlDpgmiLJtlGm",13) == 307998209) strcat(s, "n");
if (crc32("pOVQkMnmJkAsQBF",15) == 3638052750) strcat(s, "c");
if (crc32("INkvNAZuot",10) == 2248824992) strcat(s, "e");
    return s;
}

char *chiropter_nouns() {
    char *s = calloc(10);
    if (crc32("GVxxDYXFcaydEG",14) == 1232803971) strcat(s, "w");
if (crc32("wBYfv",5) == 1432442467) strcat(s, "c");
if (crc32("CjTzcpNeDVsZd",13) == 2126532644) strcat(s, "h");
if (crc32("xVANGo",6) == 3665374973) strcat(s, "i");
if (crc32("AKgxxFKUULzkp",13) == 113237499) strcat(s, "f");
if (crc32("figAI",5) == 1032099756) strcat(s, "r");
if (crc32("wDmOkm",6) == 219556089) strcat(s, "o");
if (crc32("YEnLHWqq",8) == 2968582082) strcat(s, "p");
if (crc32("eYdxHIfFET",10) == 3156845915) strcat(s, "t");
if (crc32("MkHZqvIbXeXQulf",15) == 997702406) strcat(s, "e");
if (crc32("IiZpnhwlCGLeNVM",15) == 3851922705) strcat(s, "r");
    return s;
}

char *keyhole_nouns() {
    char *s = calloc(8);
    if (crc32("dvpUfPW",7) == 4192578648) strcat(s, "y");
if (crc32("gQDMOlNvWsf",11) == 3632947106) strcat(s, "k");
if (crc32("yASwv",5) == 2109748692) strcat(s, "X");
if (crc32("acxMBdsaqshASXk",15) == 2590846393) strcat(s, "e");
if (crc32("KlDDurvzkgZ",11) == 347484735) strcat(s, "y");
if (crc32("ZHAuj",5) == 1683403431) strcat(s, "h");
if (crc32("xoUQrSbt",8) == 2436256385) strcat(s, "o");
if (crc32("mxeEzBfU",8) == 958185277) strcat(s, "M");
if (crc32("MwCzi",5) == 63670489) strcat(s, "l");
if (crc32("lKXCBmn",7) == 1012953218) strcat(s, "e");
    return s;
}

char *AntiMason_nouns() {
    char *s = calloc(10);
    if (crc32("UcfBv",5) == 1168411712) strcat(s, "g");
if (crc32("LukVwAlDRfE",11) == 362573962) strcat(s, "A");
if (crc32("ggDyvcHNRhq",11) == 3871083350) strcat(s, "n");
if (crc32("mKsBJruTlXUzI",13) == 2492440376) strcat(s, "t");
if (crc32("ivLoQcu",7) == 3301107509) strcat(s, "H");
if (crc32("nhTpSnluM",9) == 314343938) strcat(s, "i");
if (crc32("kDAghx",6) == 3813169903) strcat(s, "M");
if (crc32("cBQviUEefmZ",11) == 4275634562) strcat(s, "a");
if (crc32("JUnxSlKsQbh",11) == 2838991729) strcat(s, "s");
if (crc32("yGAVcjoouOEPD",13) == 3017631582) strcat(s, "L");
if (crc32("HpFeQ",5) == 3043970043) strcat(s, "o");
if (crc32("fFNhZlkySRCjzAm",15) == 3222191311) strcat(s, "n");
    return s;
}

char *Nicholas_nouns() {
    char *s = calloc(9);
    if (crc32("rYwbSSrtSVdL",12) == 3681962847) strcat(s, "m");
if (crc32("CBKEbiueO",9) == 2050531676) strcat(s, "N");
if (crc32("QNXzZGAPNkErTM",14) == 784082741) strcat(s, "i");
if (crc32("oGdbumjtPWj",11) == 1313369839) strcat(s, "c");
if (crc32("bCotlXZxaA",10) == 877753139) strcat(s, "h");
if (crc32("wwgYEb",6) == 121225652) strcat(s, "o");
if (crc32("UoQvYQhSrGe",11) == 375886073) strcat(s, "J");
if (crc32("UfLuu",5) == 591094749) strcat(s, "l");
if (crc32("bcgCmELMHfRoZV",14) == 3792270574) strcat(s, "a");
if (crc32("VmMsbCmcHNHr",12) == 1489998989) strcat(s, "r");
if (crc32("boEVixPAYYR",11) == 722126866) strcat(s, "s");
    return s;
}

char *flowage_nouns() {
    char *s = calloc(8);
    if (crc32("ewGEdcYdAWuh",12) == 1405054729) strcat(s, "n");
if (crc32("DspfnrUy",8) == 1790708323) strcat(s, "f");
if (crc32("fcTmuneilD",10) == 4017779419) strcat(s, "l");
if (crc32("YygXQQmTf",9) == 1776294715) strcat(s, "o");
if (crc32("hcBFQNX",7) == 1361924874) strcat(s, "w");
if (crc32("QCGqNmVjkMg",11) == 3204865661) strcat(s, "H");
if (crc32("XTLVuv",6) == 3461459471) strcat(s, "a");
if (crc32("NlJfuALxO",9) == 592720899) strcat(s, "g");
if (crc32("iiauGbkuD",9) == 2655882464) strcat(s, "n");
if (crc32("LflIyJxbQNQ",11) == 2013235871) strcat(s, "e");
    return s;
}

char *fertilizin_nouns() {
    char *s = calloc(11);
    if (crc32("vSpgetlbgVGvH",13) == 2118177702) strcat(s, "i");
if (crc32("FLrHuwyiPuV",11) == 1404442725) strcat(s, "f");
if (crc32("smyCO",5) == 3209299073) strcat(s, "a");
if (crc32("sHenndaFTKSnllb",15) == 597680044) strcat(s, "e");
if (crc32("VNZvzpSRj",9) == 1936520978) strcat(s, "K");
if (crc32("ZddLiCFBpkbPfu",14) == 3772491811) strcat(s, "r");
if (crc32("DanFZpJVKpKXXb",14) == 1622267084) strcat(s, "t");
if (crc32("sJYyPAY",7) == 1517471690) strcat(s, "i");
if (crc32("xjgDXBrzRSkC",12) == 2639306714) strcat(s, "l");
if (crc32("phyEhUqjcq",10) == 3246202924) strcat(s, "z");
if (crc32("TDOiJq",6) == 575359786) strcat(s, "i");
if (crc32("NPPCQMIUcUIaU",13) == 3998086651) strcat(s, "K");
if (crc32("aBUAKhj",7) == 1575634787) strcat(s, "z");
if (crc32("hntBx",5) == 3558621672) strcat(s, "l");
if (crc32("TuabPgIotgqimv",14) == 2141413528) strcat(s, "i");
if (crc32("BKkamlwEKIb",11) == 3442061828) strcat(s, "n");
    return s;
}

char *Socha_nouns() {
    char *s = calloc(6);
    if (crc32("VdlecyUiCUXrX",13) == 2881402551) strcat(s, "m");
if (crc32("vmaXRZ",6) == 4011693265) strcat(s, "S");
if (crc32("bvWzFLzpGYaX",12) == 3985315465) strcat(s, "F");
if (crc32("iNOxVKwygHGFdZT",15) == 2595271940) strcat(s, "o");
if (crc32("TlmIyvjcTISBk",13) == 2804508128) strcat(s, "d");
if (crc32("Lkrka",5) == 1557097931) strcat(s, "c");
if (crc32("OmDdvdevtu",10) == 1059675492) strcat(s, "z");
if (crc32("fCjwwTX",7) == 863311593) strcat(s, "h");
if (crc32("DkiaTuMHwne",11) == 759079691) strcat(s, "a");
    return s;
}

char *Phaye_nouns() {
    char *s = calloc(6);
    if (crc32("htmmptRZxbfjnZD",15) == 1689903902) strcat(s, "P");
if (crc32("LINsEHzgmQy",11) == 3546564477) strcat(s, "y");
if (crc32("HEDyxLru",8) == 51377211) strcat(s, "h");
if (crc32("vRXPITOTvsP",11) == 4115319932) strcat(s, "S");
if (crc32("HxIvK",5) == 3876232385) strcat(s, "a");
if (crc32("nxUKsSfge",9) == 630922612) strcat(s, "y");
if (crc32("Hxzib",5) == 3475274289) strcat(s, "G");
if (crc32("jbQLAKcQPHOn",12) == 2671756458) strcat(s, "e");
    return s;
}

char *Larianna_nouns() {
    char *s = calloc(9);
    if (crc32("enRMefWipsFaDG",14) == 2275505663) strcat(s, "L");
if (crc32("eKDmnlwWsPP",11) == 3661543764) strcat(s, "a");
if (crc32("HyOjTMWmlfrSOp",14) == 161220114) strcat(s, "I");
if (crc32("VXlBjKhvfs",10) == 416534142) strcat(s, "r");
if (crc32("uFljCD",6) == 2747993914) strcat(s, "i");
if (crc32("WtDZhKEDEo",10) == 3838984234) strcat(s, "a");
if (crc32("hpjEOrUPInNWf",13) == 2184072701) strcat(s, "a");
if (crc32("bVVhvNswHfjqm",13) == 2718349348) strcat(s, "n");
if (crc32("cBWzKDMfsM",10) == 613521032) strcat(s, "l");
if (crc32("YGJLQJomdeGI",12) == 1071469457) strcat(s, "n");
if (crc32("IxZIaBNDDTbdbor",15) == 4214338451) strcat(s, "a");
    return s;
}

char *showpiece_nouns() {
    char *s = calloc(10);
    if (crc32("XYaLyMSNZafpTw",14) == 207191439) strcat(s, "g");
if (crc32("pGNdlWiBWNJp",12) == 1000594008) strcat(s, "s");
if (crc32("rhczfww",7) == 979984914) strcat(s, "h");
if (crc32("zEtsTsPJD",9) == 1991529069) strcat(s, "d");
if (crc32("rWaLZriB",8) == 3970323616) strcat(s, "o");
if (crc32("rYCBLz",6) == 3565721221) strcat(s, "w");
if (crc32("WABJUfcQdP",10) == 4183908746) strcat(s, "E");
if (crc32("LEIGUkKZXXmKo",13) == 2280142452) strcat(s, "p");
if (crc32("UPqDEPstOsa",11) == 2491814840) strcat(s, "i");
if (crc32("ArlxmPfhSnuw",12) == 4008833197) strcat(s, "e");
if (crc32("zeSWzkSsTeVPnfh",15) == 3752662768) strcat(s, "c");
if (crc32("PRSfUkTy",8) == 1467590172) strcat(s, "e");
    return s;
}

char *Kilimanjaro_nouns() {
    char *s = calloc(12);
    if (crc32("uaevJVyl",8) == 2761525725) strcat(s, "K");
if (crc32("RDbBGxbYjNePzXd",15) == 3635409064) strcat(s, "i");
if (crc32("hIBvbvTIljT",11) == 2684072023) strcat(s, "C");
if (crc32("cUdWWLHcLKefmwp",15) == 2523123766) strcat(s, "l");
if (crc32("rrMzNONWqqF",11) == 2327031720) strcat(s, "i");
if (crc32("RnPzIW",6) == 2421756748) strcat(s, "m");
if (crc32("ZAHnUGpkbo",10) == 2276059101) strcat(s, "i");
if (crc32("fHtfLKRzHoV",11) == 1539438342) strcat(s, "a");
if (crc32("rbwZUhgH",8) == 458665873) strcat(s, "n");
if (crc32("qPocKt",6) == 614334923) strcat(s, "j");
if (crc32("tHjhSkgQ",8) == 2434495266) strcat(s, "a");
if (crc32("yqBtwGgpsCs",11) == 273527342) strcat(s, "r");
if (crc32("moNhOWOVVUxmBh",14) == 330029394) strcat(s, "b");
if (crc32("WFFfYHvvcvlmr",13) == 2412651259) strcat(s, "o");
    return s;
}

char *stops_nouns() {
    char *s = calloc(6);
    if (crc32("AqsroQBPPVCaNY",14) == 1519911821) strcat(s, "O");
if (crc32("djjzZKlOsYHeJ",13) == 2309297046) strcat(s, "s");
if (crc32("ToZmugMNW",9) == 1896995907) strcat(s, "i");
if (crc32("FxgkiuIx",8) == 3308645505) strcat(s, "t");
if (crc32("zrwrsTvDObCCEj",14) == 3951351515) strcat(s, "o");
if (crc32("lSQznnICIH",10) == 1805267904) strcat(s, "p");
if (crc32("kBzxyfGlzflCbOi",15) == 486637712) strcat(s, "p");
if (crc32("tCnEYF",6) == 1733034318) strcat(s, "s");
    return s;
}

char *Riti_nouns() {
    char *s = calloc(5);
    if (crc32("OTsxUroliyvBl",13) == 1322383945) strcat(s, "z");
if (crc32("icYWcxMxEGUmH",13) == 232816035) strcat(s, "R");
if (crc32("NjnixeKt",8) == 1952302424) strcat(s, "i");
if (crc32("BZlOpLOJk",9) == 353893115) strcat(s, "S");
if (crc32("RunExGnZxqY",11) == 2683311895) strcat(s, "t");
if (crc32("DSYJvD",6) == 1168083163) strcat(s, "T");
if (crc32("dxUvfysVtxf",11) == 3095270844) strcat(s, "i");
    return s;
}

char *irritability_nouns() {
    char *s = calloc(13);
    if (crc32("SXNJbwpNYqEzz",13) == 3890853626) strcat(s, "R");
if (crc32("PVVyHkc",7) == 3912324776) strcat(s, "i");
if (crc32("urLrTJ",6) == 5333071) strcat(s, "l");
if (crc32("YpjNalunnzsXTrv",15) == 56422176) strcat(s, "r");
if (crc32("nbalJump",8) == 96796843) strcat(s, "r");
if (crc32("VWSETYqNDUsaIxu",15) == 443731741) strcat(s, "i");
if (crc32("ArmnY",5) == 4229972801) strcat(s, "i");
if (crc32("hphKFIUk",8) == 2639851596) strcat(s, "t");
if (crc32("WXJmrmZMtngpXUH",15) == 3960519355) strcat(s, "i");
if (crc32("DkTsMVAPuBAbqH",14) == 3418593313) strcat(s, "a");
if (crc32("WIoFMqUZBVp",11) == 1251895262) strcat(s, "b");
if (crc32("OqfQfvR",7) == 986232730) strcat(s, "i");
if (crc32("wPseUIqecnoACY",14) == 3256907197) strcat(s, "l");
if (crc32("UZMYRysV",8) == 2547115789) strcat(s, "e");
if (crc32("IaugdLxywiB",11) == 1025031822) strcat(s, "i");
if (crc32("JjxndppPB",9) == 1894954379) strcat(s, "t");
if (crc32("ydLdhbtXq",9) == 2129407372) strcat(s, "q");
if (crc32("gTgeBKWEVBPUXMB",15) == 368402308) strcat(s, "y");
    return s;
}

char *turnup_nouns() {
    char *s = calloc(7);
    if (crc32("DvlgOl",6) == 2618395887) strcat(s, "o");
if (crc32("KAGAbVHSPYbE",12) == 788789461) strcat(s, "t");
if (crc32("JLpUwsVIYDgNX",13) == 2771972095) strcat(s, "u");
if (crc32("wOyqeLsDujfH",12) == 3931574550) strcat(s, "r");
if (crc32("wWwRmFfZ",8) == 2223635896) strcat(s, "B");
if (crc32("jJiAvCa",7) == 444503633) strcat(s, "n");
if (crc32("HaxpmSgxNWJ",11) == 2876519428) strcat(s, "z");
if (crc32("VJHcesOcso",10) == 3936942040) strcat(s, "u");
if (crc32("XQYCOjOaZZLPRhS",15) == 1871020533) strcat(s, "v");
if (crc32("rYIYYkwJbOaR",12) == 3638555594) strcat(s, "p");
    return s;
}

char *prison_nouns() {
    char *s = calloc(7);
    if (crc32("xXrrMJXUvfO",11) == 1404205922) strcat(s, "G");
if (crc32("wcgiXqkk",8) == 4292416720) strcat(s, "p");
if (crc32("ZlHiGassRaNXIB",14) == 536921307) strcat(s, "r");
if (crc32("bVrdshStaUiHZdo",15) == 805165503) strcat(s, "p");
if (crc32("mGTJGzMyY",9) == 1803398362) strcat(s, "i");
if (crc32("SCAkcWXuHFw",11) == 1386379060) strcat(s, "s");
if (crc32("ULcMRiBxwsvfv",13) == 3456633181) strcat(s, "z");
if (crc32("vUVzQxcfnohcLSh",15) == 294553514) strcat(s, "o");
if (crc32("QnUatvmfODmG",12) == 3742178125) strcat(s, "i");
if (crc32("ityWH",5) == 1619035140) strcat(s, "n");
    return s;
}

char *Blancanus_nouns() {
    char *s = calloc(10);
    if (crc32("XvltSFB",7) == 3099157283) strcat(s, "B");
if (crc32("XDlrt",5) == 3516604520) strcat(s, "l");
if (crc32("qzqhiT",6) == 3997592546) strcat(s, "M");
if (crc32("edWwhjp",7) == 579801607) strcat(s, "a");
if (crc32("OWppWQDyGOB",11) == 688809590) strcat(s, "n");
if (crc32("qwdRdsb",7) == 478891881) strcat(s, "v");
if (crc32("lkZVKdKrt",9) == 560218780) strcat(s, "c");
if (crc32("VzCeWtEGffB",11) == 1657624219) strcat(s, "a");
if (crc32("DidCFgjfaPQo",12) == 3545219151) strcat(s, "n");
if (crc32("AtuHxQRMN",9) == 2178385596) strcat(s, "k");
if (crc32("LLEAy",5) == 1007246631) strcat(s, "u");
if (crc32("hphagefnpAz",11) == 1264916508) strcat(s, "G");
if (crc32("tVDKcEWvDaubcBj",15) == 2199802287) strcat(s, "s");
    return s;
}

char *sourwood_nouns() {
    char *s = calloc(9);
    if (crc32("ZTEbKiAYE",9) == 2822260162) strcat(s, "c");
if (crc32("GGvxnoZvEQTfWdm",15) == 1817773301) strcat(s, "s");
if (crc32("DBmecAYDl",9) == 3340002737) strcat(s, "l");
if (crc32("htDlXBaKWgG",11) == 1796380828) strcat(s, "o");
if (crc32("AzcoeYTOs",9) == 1661151344) strcat(s, "u");
if (crc32("rIAxvAsozMc",11) == 1531847219) strcat(s, "V");
if (crc32("iFIXmbhxpn",10) == 868591699) strcat(s, "r");
if (crc32("HvIxflcJ",8) == 1560695242) strcat(s, "J");
if (crc32("KdmywYEtlF",10) == 1017142357) strcat(s, "w");
if (crc32("vhXbxm",6) == 3100989604) strcat(s, "J");
if (crc32("DNJwKbaF",8) == 3723458238) strcat(s, "o");
if (crc32("AOYgjgH",7) == 85393726) strcat(s, "o");
if (crc32("sdwwdUsDlg",10) == 2531030151) strcat(s, "i");
if (crc32("BGMsNEdmp",9) == 434034176) strcat(s, "d");
    return s;
}

char *wahine_nouns() {
    char *s = calloc(7);
    if (crc32("huNYzDVSRi",10) == 3795479281) strcat(s, "z");
if (crc32("CXaGiK",6) == 2467503806) strcat(s, "w");
if (crc32("ypURZ",5) == 3494627798) strcat(s, "N");
if (crc32("wUzyiWukEgaQbVw",15) == 712544152) strcat(s, "a");
if (crc32("EpiJlMeihsoui",13) == 3387419214) strcat(s, "t");
if (crc32("jojqEmYCVjf",11) == 497988584) strcat(s, "h");
if (crc32("LnUCA",5) == 3503228259) strcat(s, "z");
if (crc32("emwwzPO",7) == 1210902673) strcat(s, "i");
if (crc32("iFsgrx",6) == 700586847) strcat(s, "k");
if (crc32("POEma",5) == 2716957618) strcat(s, "n");
if (crc32("Tshfkd",6) == 3870363150) strcat(s, "e");
    return s;
}

char *adventitia_nouns() {
    char *s = calloc(11);
    if (crc32("hXfdivgt",8) == 2945391187) strcat(s, "a");
if (crc32("AbUVTHgiwGW",11) == 2045353254) strcat(s, "Q");
if (crc32("XrMbTikVDiSO",12) == 3231348790) strcat(s, "d");
if (crc32("sDRPMe",6) == 1589972774) strcat(s, "i");
if (crc32("UXAXvj",6) == 1894230667) strcat(s, "v");
if (crc32("pRZeISEK",8) == 1283812700) strcat(s, "Q");
if (crc32("gxPkWLibQ",9) == 3070756990) strcat(s, "e");
if (crc32("Gehutp",6) == 2714522215) strcat(s, "e");
if (crc32("YPOCuCWLUKcqHiw",15) == 1518255460) strcat(s, "n");
if (crc32("zjsJDKtlLYdAPFG",15) == 3937065619) strcat(s, "V");
if (crc32("TnOKhvL",7) == 2926912775) strcat(s, "t");
if (crc32("nrdJuCpKb",9) == 297074447) strcat(s, "i");
if (crc32("tuSdd",5) == 1210323048) strcat(s, "F");
if (crc32("SqIfJsvASAexmB",14) == 3254742294) strcat(s, "t");
if (crc32("UCVDQTmSQyPUcKk",15) == 1550224481) strcat(s, "i");
if (crc32("bqghqHlwQuyD",12) == 72405195) strcat(s, "a");
if (crc32("WRIOlacv",8) == 3006024917) strcat(s, "a");
    return s;
}

char *Stralsund_nouns() {
    char *s = calloc(10);
    if (crc32("gBZCV",5) == 783901608) strcat(s, "L");
if (crc32("ozdNzwNvJ",9) == 3255460374) strcat(s, "S");
if (crc32("uIUNNjWtMI",10) == 2807294532) strcat(s, "p");
if (crc32("kJSKgBvMP",9) == 2467271618) strcat(s, "t");
if (crc32("IcVITrGMDMSeaRD",15) == 1829962625) strcat(s, "r");
if (crc32("RjYPQHgXRiAl",12) == 1445148587) strcat(s, "a");
if (crc32("drHGZfaxPpUKy",13) == 568687393) strcat(s, "l");
if (crc32("HsiPgodfMmTxg",13) == 2357231545) strcat(s, "q");
if (crc32("yFNcURf",7) == 3051752146) strcat(s, "s");
if (crc32("HXnotObSOqrr",12) == 1453556078) strcat(s, "u");
if (crc32("XukQPcaQTZXodk",14) == 3030708414) strcat(s, "n");
if (crc32("sukgbXzNukN",11) == 1765083503) strcat(s, "d");
    return s;
}

char *formboard_nouns() {
    char *s = calloc(10);
    if (crc32("syYRdpkZBqqYy",13) == 1625541629) strcat(s, "f");
if (crc32("rSMRRdbKTMeMo",13) == 2436327321) strcat(s, "T");
if (crc32("kGrRYB",6) == 1686605323) strcat(s, "o");
if (crc32("mlhreCw",7) == 819543575) strcat(s, "F");
if (crc32("NXKShd",6) == 1239893390) strcat(s, "r");
if (crc32("hwNbm",5) == 2269439934) strcat(s, "m");
if (crc32("ZbJIHf",6) == 312990455) strcat(s, "Y");
if (crc32("VfjaPh",6) == 2570832618) strcat(s, "b");
if (crc32("BbWDlLr",7) == 915139475) strcat(s, "o");
if (crc32("rWQdghKjmoe",11) == 2903716185) strcat(s, "g");
if (crc32("NSNvecxNlKggFJH",15) == 3925746747) strcat(s, "a");
if (crc32("SZVPX",5) == 2853927760) strcat(s, "r");
if (crc32("OHrkuQecP",9) == 767187096) strcat(s, "d");
    return s;
}

char *bristliness_nouns() {
    char *s = calloc(12);
    if (crc32("NxePfofftrqa",12) == 3219584611) strcat(s, "b");
if (crc32("XRLLAvC",7) == 1731832370) strcat(s, "r");
if (crc32("fROlANd",7) == 2756070126) strcat(s, "m");
if (crc32("KGyWvTw",7) == 737089953) strcat(s, "i");
if (crc32("TggFq",5) == 2600452766) strcat(s, "C");
if (crc32("ixYhkJkaIdzcpx",14) == 3790472021) strcat(s, "s");
if (crc32("JRvENKVddgKvfM",14) == 3794473086) strcat(s, "F");
if (crc32("SEZYE",5) == 431952493) strcat(s, "t");
if (crc32("kdXsHJgIGf",10) == 2740635951) strcat(s, "l");
if (crc32("ZrMhayvffMWFx",13) == 1905915966) strcat(s, "q");
if (crc32("manPtj",6) == 4035672558) strcat(s, "i");
if (crc32("RnxdQBlyHZZQkOC",15) == 1347129602) strcat(s, "n");
if (crc32("lWaYXdUoO",9) == 4187684739) strcat(s, "O");
if (crc32("kUZOsaF",7) == 1285859694) strcat(s, "e");
if (crc32("MjzfJIKnLj",10) == 2426583472) strcat(s, "s");
if (crc32("ZnVqAQtmwlk",11) == 4247553949) strcat(s, "s");
    return s;
}

char *Crataeis_nouns() {
    char *s = calloc(9);
    if (crc32("GsllbphssnKAdgR",15) == 2438062148) strcat(s, "C");
if (crc32("uAeXIjTEXJ",10) == 1080934113) strcat(s, "y");
if (crc32("nxgRHIq",7) == 2477941376) strcat(s, "r");
if (crc32("bRgZShCZYKQ",11) == 2581550932) strcat(s, "u");
if (crc32("lxEfMrCrpt",10) == 2087089456) strcat(s, "a");
if (crc32("vhuKU",5) == 1053035302) strcat(s, "K");
if (crc32("zOULDXVs",8) == 2021986715) strcat(s, "t");
if (crc32("SCoiJxsLxrRg",12) == 2801411519) strcat(s, "g");
if (crc32("iFAbxrlCSkbs",12) == 2498006359) strcat(s, "a");
if (crc32("dCtTMUPYh",9) == 3618700670) strcat(s, "e");
if (crc32("HxaMxBEpw",9) == 222398605) strcat(s, "i");
if (crc32("llapRBmpU",9) == 4194701721) strcat(s, "s");
    return s;
}

char *tob_nouns() {
    char *s = calloc(4);
    if (crc32("UoXWgyJiTveYv",13) == 3326697610) strcat(s, "k");
if (crc32("JMOhHpt",7) == 3963546660) strcat(s, "t");
if (crc32("dMojHUBSVYTse",13) == 1238867878) strcat(s, "w");
if (crc32("yGHEJaabWtbA",12) == 3269041768) strcat(s, "o");
if (crc32("eHlgXUB",7) == 1617663854) strcat(s, "b");
    return s;
}

char *hierology_nouns() {
    char *s = calloc(10);
    if (crc32("GplmlaolzvWlMUS",15) == 2164280379) strcat(s, "b");
if (crc32("TvIrcFA",7) == 3996205781) strcat(s, "h");
if (crc32("AfRgpHJNSWKs",12) == 368021518) strcat(s, "i");
if (crc32("isfKMbNomopizf",14) == 3045643671) strcat(s, "s");
if (crc32("bwTRcJfI",8) == 1674978734) strcat(s, "e");
if (crc32("OgcGFOGxbKnGQZr",15) == 3599203106) strcat(s, "Z");
if (crc32("meVookG",7) == 3591920590) strcat(s, "r");
if (crc32("MXRjwAERJZLhcN",14) == 301591437) strcat(s, "i");
if (crc32("nWrUACBwAlKBHY",14) == 2052484457) strcat(s, "o");
if (crc32("jNNndDvpNN",10) == 262990324) strcat(s, "l");
if (crc32("YwmnzCcBztJ",11) == 2373160244) strcat(s, "f");
if (crc32("sSHICSJxJ",9) == 1630842514) strcat(s, "o");
if (crc32("uTbgrWoStyLcq",13) == 3493079868) strcat(s, "g");
if (crc32("HNZjqGGHStYDtr",14) == 1575996858) strcat(s, "Z");
if (crc32("fwaKxEuJ",8) == 2860109618) strcat(s, "y");
    return s;
}

char *irone_nouns() {
    char *s = calloc(6);
    if (crc32("hMtqlf",6) == 3082368777) strcat(s, "o");
if (crc32("EorlD",5) == 3673741933) strcat(s, "i");
if (crc32("nzLBQSb",7) == 4241716117) strcat(s, "S");
if (crc32("TiMdtIH",7) == 2070826374) strcat(s, "r");
if (crc32("RhDxmTbVyl",10) == 878619012) strcat(s, "T");
if (crc32("iZieey",6) == 3590049635) strcat(s, "o");
if (crc32("hkZsKfpvD",9) == 3949703239) strcat(s, "n");
if (crc32("AMCeBarhjsa",11) == 2118814511) strcat(s, "e");
    return s;
}

char *whimperer_nouns() {
    char *s = calloc(10);
    if (crc32("ttjMEc",6) == 1481583149) strcat(s, "w");
if (crc32("DqZudPduGzKmVFa",15) == 3996205813) strcat(s, "T");
if (crc32("EByBrRRAYMHAqIe",15) == 3398256240) strcat(s, "h");
if (crc32("QjeVA",5) == 887915550) strcat(s, "i");
if (crc32("KjzWtPnYDNtvC",13) == 79973823) strcat(s, "L");
if (crc32("jLPcNvBYuEe",11) == 3470348677) strcat(s, "m");
if (crc32("ALSegfKygLWn",12) == 3767739794) strcat(s, "D");
if (crc32("bpBlA",5) == 4116873135) strcat(s, "p");
if (crc32("lhkYfxlTDN",10) == 2157058035) strcat(s, "L");
if (crc32("gzlhwjWeAbu",11) == 1254970282) strcat(s, "e");
if (crc32("aQbox",5) == 2825998927) strcat(s, "b");
if (crc32("asYyiUOMIytJ",12) == 916521763) strcat(s, "r");
if (crc32("FlwvWYHMBn",10) == 2067249278) strcat(s, "c");
if (crc32("qCemtcAvAh",10) == 4169843766) strcat(s, "e");
if (crc32("FXHsVpmTGSPX",12) == 255054439) strcat(s, "D");
if (crc32("RchzfEoPhDhEx",13) == 625357568) strcat(s, "r");
    return s;
}

char *stackyard_nouns() {
    char *s = calloc(10);
    if (crc32("xsUye",5) == 3421178665) strcat(s, "p");
if (crc32("mTMekfEyeHbqZA",14) == 121273784) strcat(s, "s");
if (crc32("JchqfNAXttCJyQH",15) == 2715060682) strcat(s, "x");
if (crc32("jlIidTEAZhfF",12) == 2252376437) strcat(s, "t");
if (crc32("aCcvKiEs",8) == 3143879782) strcat(s, "a");
if (crc32("TbNkhsLH",8) == 1214548185) strcat(s, "X");
if (crc32("XZcTPNgawL",10) == 1014394150) strcat(s, "c");
if (crc32("ymimjPUdd",9) == 3740787299) strcat(s, "K");
if (crc32("odRlfD",6) == 1175286116) strcat(s, "k");
if (crc32("dbskpzlPDMUhJD",14) == 3364575108) strcat(s, "y");
if (crc32("JVzhYpbYsWBFNv",14) == 3818611633) strcat(s, "O");
if (crc32("ZutHQGhcL",9) == 1780946227) strcat(s, "a");
if (crc32("IPzbCB",6) == 1164720596) strcat(s, "r");
if (crc32("bdEys",5) == 3493076598) strcat(s, "r");
if (crc32("XRLjjbwnvwtCuIk",15) == 917701036) strcat(s, "d");
    return s;
}

char *Frank_nouns() {
    char *s = calloc(6);
    if (crc32("XQfQfQJ",7) == 1454652127) strcat(s, "F");
if (crc32("FYkXodj",7) == 2651852267) strcat(s, "r");
if (crc32("TtkHv",5) == 715693080) strcat(s, "a");
if (crc32("bVaAhNSOot",10) == 3724188108) strcat(s, "n");
if (crc32("HbyXrCCCg",9) == 710223595) strcat(s, "H");
if (crc32("HQyHMTtOOhRsr",13) == 2930687079) strcat(s, "k");
    return s;
}

char *Farkas_nouns() {
    char *s = calloc(7);
    if (crc32("NGFETYw",7) == 785476230) strcat(s, "F");
if (crc32("zgNlY",5) == 604026180) strcat(s, "t");
if (crc32("aVekW",5) == 2970388078) strcat(s, "a");
if (crc32("MbvKWCxOguSI",12) == 32266247) strcat(s, "r");
if (crc32("SAyqYTnwbFE",11) == 3710351241) strcat(s, "r");
if (crc32("XiUjPwQtq",9) == 3475588384) strcat(s, "J");
if (crc32("EexfwNY",7) == 695922070) strcat(s, "k");
if (crc32("ZICLicUKtQW",11) == 2992581987) strcat(s, "v");
if (crc32("oxkLTmygsV",10) == 2906644732) strcat(s, "a");
if (crc32("xcQSYQSpl",9) == 3218951024) strcat(s, "s");
    return s;
}

char *disuse_nouns() {
    char *s = calloc(7);
    if (crc32("tfIEnPYxiYVSNr",14) == 2975435945) strcat(s, "B");
if (crc32("ijmqW",5) == 2243895765) strcat(s, "d");
if (crc32("NOLQeoOFiw",10) == 388453647) strcat(s, "i");
if (crc32("JzVbjnvNnOs",11) == 3242764394) strcat(s, "s");
if (crc32("YdajfbrXyPx",11) == 670710213) strcat(s, "S");
if (crc32("IltiRrmPZnNl",12) == 2939813134) strcat(s, "u");
if (crc32("FiXEQlGRehzJAV",14) == 3838001355) strcat(s, "s");
if (crc32("YMZruSmnn",9) == 4193584647) strcat(s, "a");
if (crc32("CPRoSKAPtIyfw",13) == 2919507224) strcat(s, "e");
    return s;
}

char *impaler_nouns() {
    char *s = calloc(8);
    if (crc32("QxqcPX",6) == 4231950238) strcat(s, "y");
if (crc32("fyUBZYXdyWZ",11) == 3214977362) strcat(s, "i");
if (crc32("iiFHSDuhaRaca",13) == 3298870819) strcat(s, "m");
if (crc32("wNoVTYqNoyQM",12) == 2241541377) strcat(s, "s");
if (crc32("NqoEAutQM",9) == 1938770437) strcat(s, "p");
if (crc32("BGYhU",5) == 932891995) strcat(s, "a");
if (crc32("PsXMkj",6) == 1588277439) strcat(s, "l");
if (crc32("yLGHqr",6) == 4035554489) strcat(s, "e");
if (crc32("pBeVoTrYpGm",11) == 2001763655) strcat(s, "a");
if (crc32("OCErcHcb",8) == 2257450041) strcat(s, "r");
    return s;
}

char *selfwrong_nouns() {
    char *s = calloc(10);
    if (crc32("wVJJeE",6) == 2267954179) strcat(s, "s");
if (crc32("KLVZkfzkFUv",11) == 1842907018) strcat(s, "U");
if (crc32("fuiPmz",6) == 340539818) strcat(s, "e");
if (crc32("UNOeNKm",7) == 9125805) strcat(s, "E");
if (crc32("qxqIpxxtw",9) == 2493890591) strcat(s, "l");
if (crc32("gLLqbjmiTIy",11) == 1068463449) strcat(s, "f");
if (crc32("KhRFuopXDjpnTn",14) == 1346840593) strcat(s, "w");
if (crc32("nnkxjkiVuJVjIC",14) == 3296707737) strcat(s, "r");
if (crc32("aBgquSZQIxyRkon",15) == 1287758080) strcat(s, "o");
if (crc32("pMpRbZKiKZOQ",12) == 1254836037) strcat(s, "n");
if (crc32("vRjMQlXpDCxcMzQ",15) == 41006231) strcat(s, "S");
if (crc32("RmTviompiNKj",12) == 2125543602) strcat(s, "g");
    return s;
}

char *Tillamook_nouns() {
    char *s = calloc(10);
    if (crc32("gpEEV",5) == 4284021878) strcat(s, "T");
if (crc32("aOSaU",5) == 3577487947) strcat(s, "G");
if (crc32("sXausMpBJbwk",12) == 1167799306) strcat(s, "i");
if (crc32("IDnqrgrBSxoBsa",14) == 666167116) strcat(s, "l");
if (crc32("AkYvYqFvOFnp",12) == 3600841265) strcat(s, "l");
if (crc32("xFkiT",5) == 759446064) strcat(s, "a");
if (crc32("zkMre",5) == 1280213122) strcat(s, "Q");
if (crc32("EFRtZ",5) == 1201395971) strcat(s, "m");
if (crc32("PlPeXdHOcBvHBF",14) == 1560864658) strcat(s, "o");
if (crc32("UeGuVTLixGiIe",13) == 52146820) strcat(s, "A");
if (crc32("aizhMhA",7) == 102461189) strcat(s, "o");
if (crc32("bidzyYFj",8) == 598035406) strcat(s, "m");
if (crc32("qQnmhaGSbqAxJev",15) == 3999148103) strcat(s, "k");
    return s;
}

char *courtmartial_nouns() {
    char *s = calloc(13);
    if (crc32("Dmiwc",5) == 1373505846) strcat(s, "c");
if (crc32("dIzWoxlVxLYG",12) == 3226993378) strcat(s, "m");
if (crc32("lRjNUqrEQof",11) == 3430141141) strcat(s, "o");
if (crc32("ciMaxSH",7) == 2973573162) strcat(s, "E");
if (crc32("ujPJqDcQ",8) == 1177919690) strcat(s, "u");
if (crc32("VsjBL",5) == 4036930766) strcat(s, "r");
if (crc32("iKHEGRwsWR",10) == 3693918016) strcat(s, "G");
if (crc32("OmoEaLIK",8) == 752926765) strcat(s, "t");
if (crc32("JLTSyh",6) == 352525864) strcat(s, "m");
if (crc32("fxJQpgGW",8) == 902221743) strcat(s, "u");
if (crc32("JUjFhArmWPlzr",13) == 2878912080) strcat(s, "a");
if (crc32("KtkAeYzQScYuEQ",14) == 2611592663) strcat(s, "r");
if (crc32("MTUjbXZceW",10) == 3683381572) strcat(s, "t");
if (crc32("ugxbjGFL",8) == 4283810974) strcat(s, "Z");
if (crc32("AhrqHfuDDWLqg",13) == 3229134689) strcat(s, "i");
if (crc32("eXZqtBFAcYnGl",13) == 1368390102) strcat(s, "a");
if (crc32("SEKuhlH",7) == 2103327352) strcat(s, "n");
if (crc32("eJjYGjfehk",10) == 2387907487) strcat(s, "l");
    return s;
}

char *Blossom_nouns() {
    char *s = calloc(8);
    if (crc32("mcQFhb",6) == 3523528916) strcat(s, "B");
if (crc32("lJixCieSQ",9) == 3913657588) strcat(s, "A");
if (crc32("gzaRKDADIDU",11) == 4234610693) strcat(s, "l");
if (crc32("GtTEGtioPZ",10) == 3746819173) strcat(s, "o");
if (crc32("cMtTfrHNSDIZB",13) == 2738300626) strcat(s, "s");
if (crc32("TiCqTFd",7) == 1435078428) strcat(s, "D");
if (crc32("BFSKUuQh",8) == 3260586479) strcat(s, "s");
if (crc32("auegrmzFUpWCyQ",14) == 2289131573) strcat(s, "o");
if (crc32("lgTmKpaAoVRYHo",14) == 1642007765) strcat(s, "m");
    return s;
}

char *boarishness_nouns() {
    char *s = calloc(12);
    if (crc32("CcFeUAAOMizE",12) == 1816994120) strcat(s, "b");
if (crc32("LqHUzsmNLUhm",12) == 2585523928) strcat(s, "c");
if (crc32("uOpGlvhVvAUa",12) == 1464545573) strcat(s, "o");
if (crc32("uVoJKSGAKae",11) == 1407411401) strcat(s, "a");
if (crc32("QwYPDvdEd",9) == 4099801525) strcat(s, "r");
if (crc32("VGyvPCq",7) == 1921925601) strcat(s, "b");
if (crc32("qTdwjWw",7) == 2767021650) strcat(s, "i");
if (crc32("MhEcEH",6) == 3088329481) strcat(s, "s");
if (crc32("qptedSlM",8) == 860536989) strcat(s, "h");
if (crc32("XVvHsgw",7) == 3835540220) strcat(s, "w");
if (crc32("DeNnuGsf",8) == 2346514367) strcat(s, "n");
if (crc32("wcKkCoq",7) == 1316769838) strcat(s, "e");
if (crc32("iSvRfndhfZF",11) == 1569625475) strcat(s, "s");
if (crc32("RJYhKeGurXLCDw",14) == 1461466924) strcat(s, "B");
if (crc32("LzXuFGp",7) == 2077647868) strcat(s, "s");
    return s;
}

char *Exod_nouns() {
    char *s = calloc(5);
    if (crc32("TPaROedAOMo",11) == 1760530333) strcat(s, "T");
if (crc32("YulPvVko",8) == 2875173637) strcat(s, "E");
if (crc32("dFgsPbDChUBPLbQ",15) == 333501152) strcat(s, "L");
if (crc32("SRGNpKBJFs",10) == 3714043169) strcat(s, "x");
if (crc32("TBvKsRyMn",9) == 3219774247) strcat(s, "C");
if (crc32("cJEEtyPf",8) == 3048006605) strcat(s, "o");
if (crc32("YhZyIAls",8) == 1506109508) strcat(s, "d");
    return s;
}

char *pigg_nouns() {
    char *s = calloc(5);
    if (crc32("uSyqgop",7) == 2680993377) strcat(s, "n");
if (crc32("TbqJqMyZAs",10) == 2517501041) strcat(s, "p");
if (crc32("eORBcPueiNa",11) == 2331676208) strcat(s, "i");
if (crc32("djSWEYuAzHSIs",13) == 1987579976) strcat(s, "g");
if (crc32("tquFwwk",7) == 567850056) strcat(s, "g");
    return s;
}

char *mistletoe_nouns() {
    char *s = calloc(10);
    if (crc32("HxeEPfAed",9) == 2143190345) strcat(s, "m");
if (crc32("QdZTyDYvhjZhRDJ",15) == 976089453) strcat(s, "o");
if (crc32("VUTEtC",6) == 224293364) strcat(s, "i");
if (crc32("dNHWzHXDQYffxRQ",15) == 3309264901) strcat(s, "o");
if (crc32("JUxEhalLP",9) == 1825811029) strcat(s, "s");
if (crc32("HnKdjeoKHXko",12) == 3617506030) strcat(s, "G");
if (crc32("frbjPRnbIb",10) == 14597221) strcat(s, "t");
if (crc32("asohOkwAZlPa",12) == 125762429) strcat(s, "l");
if (crc32("PQjYSNpdHhMe",12) == 785159563) strcat(s, "e");
if (crc32("iYNGiTbL",8) == 4067373502) strcat(s, "h");
if (crc32("jWBjLlWJNvg",11) == 1640727676) strcat(s, "t");
if (crc32("GVxDL",5) == 899412285) strcat(s, "k");
if (crc32("mFjHRiUME",9) == 1173450419) strcat(s, "o");
if (crc32("iMYGDLt",7) == 1364885569) strcat(s, "a");
if (crc32("dpYijAa",7) == 202231302) strcat(s, "e");
    return s;
}

char *Kiruna_nouns() {
    char *s = calloc(7);
    if (crc32("wdfjEqvLtrjv",12) == 2122165427) strcat(s, "r");
if (crc32("sGhQg",5) == 1210126320) strcat(s, "K");
if (crc32("TBYKU",5) == 1364011050) strcat(s, "i");
if (crc32("WEelKmJIvU",10) == 992030660) strcat(s, "f");
if (crc32("REqWshvC",8) == 2275534595) strcat(s, "r");
if (crc32("DdstrzRtn",9) == 1964283041) strcat(s, "u");
if (crc32("FmIXfJfdcmuWpI",14) == 2467489091) strcat(s, "J");
if (crc32("rVUtjP",6) == 455727815) strcat(s, "n");
if (crc32("WOYXlFRmzzgtF",13) == 3948616339) strcat(s, "a");
    return s;
}

char *barleycorn_nouns() {
    char *s = calloc(11);
    if (crc32("KpbkdTMCw",9) == 757994755) strcat(s, "b");
if (crc32("yExGeKQ",7) == 3557784991) strcat(s, "M");
if (crc32("nrrJha",6) == 730115142) strcat(s, "a");
if (crc32("flshOCVgLmNJHQ",14) == 4256462889) strcat(s, "U");
if (crc32("EpUNfGVAmDoise",14) == 2635880266) strcat(s, "r");
if (crc32("iDqgmnHhvjS",11) == 2038834656) strcat(s, "T");
if (crc32("iyHUAW",6) == 1111579413) strcat(s, "l");
if (crc32("JrVbqpVfvtr",11) == 1935525618) strcat(s, "e");
if (crc32("SWWROmZzXCQVsM",14) == 806071973) strcat(s, "y");
if (crc32("CRLfuoXNds",10) == 2690278932) strcat(s, "c");
if (crc32("eLmHDLsjdDaYkT",14) == 3749983855) strcat(s, "T");
if (crc32("yoOesAf",7) == 3496039296) strcat(s, "o");
if (crc32("rySVS",5) == 595509713) strcat(s, "r");
if (crc32("zmEOHmGziH",10) == 1841790334) strcat(s, "n");
    return s;
}

char *uncontemptibleness_nouns() {
    char *s = calloc(19);
    if (crc32("pEGPPJiBjk",10) == 4022606624) strcat(s, "u");
if (crc32("AvYunSMxbps",11) == 933519322) strcat(s, "h");
if (crc32("ATrjSNgRHFe",11) == 3687535551) strcat(s, "n");
if (crc32("wKRBpEEbXYgz",12) == 1281399791) strcat(s, "N");
if (crc32("vTnrPdJ",7) == 2581330216) strcat(s, "c");
if (crc32("fHhlvctxwZp",11) == 3701133349) strcat(s, "o");
if (crc32("isFulLEUnm",10) == 2976740826) strcat(s, "w");
if (crc32("GmOUq",5) == 2125823708) strcat(s, "n");
if (crc32("nSpoOcVbDhy",11) == 727658743) strcat(s, "t");
if (crc32("lDHpIFSBpl",10) == 2202438874) strcat(s, "e");
if (crc32("jScRJf",6) == 2415065429) strcat(s, "m");
if (crc32("fCbwNnWmNIcVM",13) == 193019937) strcat(s, "a");
if (crc32("GavEDRzIGZkyiqf",15) == 2895799210) strcat(s, "p");
if (crc32("eRxPqpY",7) == 1873814445) strcat(s, "t");
if (crc32("nOjetWeE",8) == 2033162610) strcat(s, "i");
if (crc32("mgwLeJkr",8) == 2718842114) strcat(s, "b");
if (crc32("YnmjEJJlKnjFQ",13) == 2773342351) strcat(s, "l");
if (crc32("MKctUFgDPgyWx",13) == 3787056387) strcat(s, "e");
if (crc32("TMvJjZqO",8) == 3143446639) strcat(s, "n");
if (crc32("GaalKGtSjG",10) == 4142065974) strcat(s, "e");
if (crc32("ijNhRWX",7) == 3485093114) strcat(s, "X");
if (crc32("vGhuz",5) == 305073663) strcat(s, "s");
if (crc32("vdzTwMVSaTXkPi",14) == 2075113413) strcat(s, "s");
    return s;
}

char *Fabriane_nouns() {
    char *s = calloc(9);
    if (crc32("XqmPQUsLVYGQMw",14) == 3557808908) strcat(s, "M");
if (crc32("lbbsUE",6) == 736411424) strcat(s, "F");
if (crc32("pNOTeUfRssfgN",13) == 3316201974) strcat(s, "A");
if (crc32("RIICfQf",7) == 2518199877) strcat(s, "a");
if (crc32("XILbPYiMQmKDWTP",15) == 3270359730) strcat(s, "H");
if (crc32("jYvELykxKUfjJPv",15) == 2559930454) strcat(s, "b");
if (crc32("sTAAh",5) == 3882648878) strcat(s, "r");
if (crc32("TkSrqVwlDYuB",12) == 1823538580) strcat(s, "i");
if (crc32("UAVDUQYq",8) == 820663749) strcat(s, "a");
if (crc32("FVfNNuSXsIUev",13) == 1593679863) strcat(s, "r");
if (crc32("itXSEHzzjcgvYB",14) == 1222433781) strcat(s, "n");
if (crc32("bOOBMCQGMfZ",11) == 561294160) strcat(s, "X");
if (crc32("NPEvikUa",8) == 2888961062) strcat(s, "e");
    return s;
}

char *vim_nouns() {
    char *s = calloc(4);
    if (crc32("LoWDmuOl",8) == 1921321437) strcat(s, "v");
if (crc32("sJLwH",5) == 1989140767) strcat(s, "G");
if (crc32("aHbJPGQ",7) == 2333416010) strcat(s, "i");
if (crc32("PXclEdNfB",9) == 584507336) strcat(s, "m");
    return s;
}

char *delater_nouns() {
    char *s = calloc(8);
    if (crc32("GtvGsohpV",9) == 2698332981) strcat(s, "w");
if (crc32("MVpnqbix",8) == 3366904162) strcat(s, "d");
if (crc32("gSlmTtytNKWSMI",14) == 3841809029) strcat(s, "e");
if (crc32("rRzsWyNwgH",10) == 805686309) strcat(s, "l");
if (crc32("MRyJdONwmULXI",13) == 1137749455) strcat(s, "a");
if (crc32("TgYOX",5) == 1216146582) strcat(s, "k");
if (crc32("ZzGVWIjge",9) == 1502990382) strcat(s, "t");
if (crc32("KyuSe",5) == 664277455) strcat(s, "n");
if (crc32("zVvRzcaLzxHEwXg",15) == 725963457) strcat(s, "e");
if (crc32("HlsBbOTewYeee",13) == 2459085371) strcat(s, "N");
if (crc32("yYJtdZVM",8) == 4077034110) strcat(s, "r");
    return s;
}

char *fanleaf_nouns() {
    char *s = calloc(8);
    if (crc32("ecOEufBPlUEwtM",14) == 3387945333) strcat(s, "f");
if (crc32("aAAazYOCTUCFEPP",15) == 1368227612) strcat(s, "a");
if (crc32("YGmio",5) == 699597324) strcat(s, "O");
if (crc32("TsYeapiCnkF",11) == 2566611135) strcat(s, "n");
if (crc32("EGIwbJvlNl",10) == 1290768762) strcat(s, "l");
if (crc32("GWDIjNnGJMcwt",13) == 3110280473) strcat(s, "e");
if (crc32("FWhjuKvnxAi",11) == 178780503) strcat(s, "a");
if (crc32("UfGvpmkiydpMkdP",15) == 2327000305) strcat(s, "a");
if (crc32("ulaAquF",7) == 1127539975) strcat(s, "f");
    return s;
}

char *mealworm_nouns() {
    char *s = calloc(9);
    if (crc32("WrrHSK",6) == 3967551651) strcat(s, "m");
if (crc32("YxKVbth",7) == 1632323032) strcat(s, "j");
if (crc32("ayivJUxjMxv",11) == 1841156048) strcat(s, "e");
if (crc32("vROjxHVcpNz",11) == 2825316798) strcat(s, "a");
if (crc32("sjDRzMfr",8) == 1330449466) strcat(s, "l");
if (crc32("sKVhgfelVuiWhH",14) == 260853528) strcat(s, "e");
if (crc32("eJfcca",6) == 3674327982) strcat(s, "w");
if (crc32("TjXnDFwC",8) == 2996679499) strcat(s, "o");
if (crc32("qtUXmXkSMVozVp",14) == 2338487024) strcat(s, "G");
if (crc32("kWEUFHDII",9) == 4254582733) strcat(s, "r");
if (crc32("lHCASTqVaaDW",12) == 4169195804) strcat(s, "f");
if (crc32("wGAnKBwp",8) == 2943157357) strcat(s, "m");
    return s;
}

char *Fangio_nouns() {
    char *s = calloc(7);
    if (crc32("tCwQCxIJMOT",11) == 597634026) strcat(s, "b");
if (crc32("GvegliP",7) == 2818702988) strcat(s, "F");
if (crc32("kfoOMgnZHTPWE",13) == 1586157849) strcat(s, "D");
if (crc32("daqGMMeJNpxonf",14) == 2515884680) strcat(s, "a");
if (crc32("JxeKzjwZ",8) == 3756011876) strcat(s, "n");
if (crc32("jaPbgSBAzfZmWWu",15) == 2171611690) strcat(s, "g");
if (crc32("tHZRf",5) == 2249648856) strcat(s, "G");
if (crc32("ZvXNhe",6) == 2382654626) strcat(s, "i");
if (crc32("vSCKiSyjOwTl",12) == 2256068965) strcat(s, "K");
if (crc32("zndTSbJDSMXZkkq",15) == 980800506) strcat(s, "o");
    return s;
}

char *Hanzelin_nouns() {
    char *s = calloc(9);
    if (crc32("fllKqQGVDWxK",12) == 1246993751) strcat(s, "H");
if (crc32("piVcfxYLyv",10) == 1392841563) strcat(s, "a");
if (crc32("xWoUTlFIdA",10) == 1083567241) strcat(s, "W");
if (crc32("dEMlBHLQc",9) == 2920906943) strcat(s, "n");
if (crc32("SCFNKiPIyuXq",12) == 3793815333) strcat(s, "j");
if (crc32("cBJILycFSEmSsvM",15) == 2151708845) strcat(s, "z");
if (crc32("sLtpuAgxD",9) == 1994710325) strcat(s, "N");
if (crc32("AzLiMpd",7) == 321274097) strcat(s, "e");
if (crc32("IBRvtenA",8) == 3881097027) strcat(s, "l");
if (crc32("MzeTKFArHkISPGg",15) == 760241897) strcat(s, "i");
if (crc32("GRxtKcsmyNGIC",13) == 4218600853) strcat(s, "n");
    return s;
}

char *petrolatum_nouns() {
    char *s = calloc(11);
    if (crc32("EwZqNBa",7) == 1053546729) strcat(s, "n");
if (crc32("NFdlUBtAFMAEZA",14) == 1061191744) strcat(s, "p");
if (crc32("fwyROHZvTOxxW",13) == 777810931) strcat(s, "e");
if (crc32("XBKAzlSAT",9) == 4013883791) strcat(s, "t");
if (crc32("vIVqXORAZ",9) == 2694138724) strcat(s, "A");
if (crc32("yUJUdPS",7) == 1363694172) strcat(s, "r");
if (crc32("jmqPwVIarMIpui",14) == 1028892154) strcat(s, "o");
if (crc32("BzJSONqhGwS",11) == 180005331) strcat(s, "U");
if (crc32("pnWapwFW",8) == 3465538926) strcat(s, "l");
if (crc32("oHRJuxGVeC",10) == 3589951832) strcat(s, "F");
if (crc32("jRoNCcXaVzMzdC",14) == 888602964) strcat(s, "a");
if (crc32("xjNGWMzienY",11) == 3683036508) strcat(s, "t");
if (crc32("OJqobco",7) == 4271212077) strcat(s, "u");
if (crc32("JUUZNYoLanp",11) == 3921224869) strcat(s, "C");
if (crc32("EfjGpk",6) == 741668245) strcat(s, "m");
    return s;
}

char *aidedecamp_nouns() {
    char *s = calloc(11);
    if (crc32("UTdIqbxrclG",11) == 3797371314) strcat(s, "Y");
if (crc32("qSsgk",5) == 2101546391) strcat(s, "a");
if (crc32("VTcRws",6) == 1230982854) strcat(s, "i");
if (crc32("bBwoDm",6) == 2953741989) strcat(s, "Y");
if (crc32("TEzykQvlEMtlQ",13) == 2966645549) strcat(s, "d");
if (crc32("hqOkSZ",6) == 201998140) strcat(s, "e");
if (crc32("vnWcNVUrDEVUA",13) == 2731719044) strcat(s, "d");
if (crc32("aoaLUMaKsUFizk",14) == 661551728) strcat(s, "e");
if (crc32("CTPHDF",6) == 1270025492) strcat(s, "c");
if (crc32("KELTdljU",8) == 3446732867) strcat(s, "Z");
if (crc32("KySxGGkNmBh",11) == 1730802284) strcat(s, "a");
if (crc32("nhXuParK",8) == 99477686) strcat(s, "D");
if (crc32("ZUeNVkG",7) == 1779635117) strcat(s, "m");
if (crc32("VUBlOXgsuOcomRe",15) == 3589053882) strcat(s, "p");
    return s;
}

char *unitedness_nouns() {
    char *s = calloc(11);
    if (crc32("jEXYsncn",8) == 4145848909) strcat(s, "V");
if (crc32("ygxRMirz",8) == 3190802343) strcat(s, "u");
if (crc32("ElJYqIXGMnMvb",13) == 4177847889) strcat(s, "n");
if (crc32("OxELKkugvQuRnm",14) == 2501863187) strcat(s, "f");
if (crc32("GpYqyQavASoyS",13) == 934407552) strcat(s, "i");
if (crc32("CkRpVWzAKnFo",12) == 3455908041) strcat(s, "t");
if (crc32("iBblMPpc",8) == 2727365964) strcat(s, "J");
if (crc32("MfsTaKhwHCqh",12) == 4086419507) strcat(s, "e");
if (crc32("EIyjBaSy",8) == 3200047318) strcat(s, "Y");
if (crc32("vJMrr",5) == 2673430492) strcat(s, "d");
if (crc32("YuRdqMbsFl",10) == 505957347) strcat(s, "g");
if (crc32("oXbjyrLKuRRaCkI",15) == 2281016905) strcat(s, "n");
if (crc32("TmrgztfFOCVr",12) == 3669912597) strcat(s, "e");
if (crc32("XKRybSnR",8) == 2443699275) strcat(s, "s");
if (crc32("rjNfZSbSwoze",12) == 535482232) strcat(s, "s");
    return s;
}

char *aplite_nouns() {
    char *s = calloc(7);
    if (crc32("LIWzIK",6) == 2044802113) strcat(s, "h");
if (crc32("rqdrq",5) == 3815160425) strcat(s, "a");
if (crc32("cHSRHCpscHEBnI",14) == 4275019760) strcat(s, "k");
if (crc32("pnAGWHkuXeZ",11) == 4141554342) strcat(s, "p");
if (crc32("LIxeY",5) == 3991018168) strcat(s, "l");
if (crc32("jfRfMYbaobIFyd",14) == 3192756587) strcat(s, "r");
if (crc32("EaXFXwqm",8) == 1154514696) strcat(s, "i");
if (crc32("bFoGhAMowYrK",12) == 990569724) strcat(s, "t");
if (crc32("eiRlfzDCwbH",11) == 2758383704) strcat(s, "e");
    return s;
}

char *Pisanello_nouns() {
    char *s = calloc(10);
    if (crc32("oqIPpHdt",8) == 1979532780) strcat(s, "P");
if (crc32("pGgLgjh",7) == 141217467) strcat(s, "i");
if (crc32("Ldivh",5) == 1625262887) strcat(s, "f");
if (crc32("IvsDbjtpFibZTu",14) == 2326924848) strcat(s, "s");
if (crc32("evojyeyzCbhuv",13) == 2473019398) strcat(s, "D");
if (crc32("KlXhRve",7) == 2032327491) strcat(s, "a");
if (crc32("rVkHuzDIgc",10) == 2544652903) strcat(s, "n");
if (crc32("VlSDcHqBUEbSwfF",15) == 222801480) strcat(s, "M");
if (crc32("zYcIYOdWrtH",11) == 2000505243) strcat(s, "e");
if (crc32("rhKWcVIqv",9) == 3006487355) strcat(s, "n");
if (crc32("JRFPaFXPykWzdfD",15) == 2612601703) strcat(s, "l");
if (crc32("IiqyusAbvFZXy",13) == 2024918880) strcat(s, "l");
if (crc32("SmFMNkxFUyfs",12) == 2078537407) strcat(s, "k");
if (crc32("JbKqueLnmkHLYQL",15) == 972524708) strcat(s, "o");
    return s;
}

char *Cechy_nouns() {
    char *s = calloc(6);
    if (crc32("FozMntuGXikmMkg",15) == 2649024107) strcat(s, "A");
if (crc32("TRaXY",5) == 1131791908) strcat(s, "C");
if (crc32("puhyNZ",6) == 4174644641) strcat(s, "Z");
if (crc32("anLeTr",6) == 2875904638) strcat(s, "e");
if (crc32("AzCqP",5) == 2292247750) strcat(s, "c");
if (crc32("JFPtit",6) == 3004207013) strcat(s, "h");
if (crc32("nKlgGvY",7) == 3343838202) strcat(s, "y");
    return s;
}

char *armary_nouns() {
    char *s = calloc(7);
    if (crc32("lTPYS",5) == 1854791998) strcat(s, "w");
if (crc32("pOuFEAY",7) == 2378368909) strcat(s, "a");
if (crc32("yLsGYuLNFlmNR",13) == 2087696078) strcat(s, "k");
if (crc32("DLCzYKazu",9) == 27465498) strcat(s, "r");
if (crc32("LfMdDBshwUgK",12) == 2441922175) strcat(s, "m");
if (crc32("VfnDc",5) == 3960395172) strcat(s, "X");
if (crc32("kLrEDakYjbDpjb",14) == 2335588691) strcat(s, "a");
if (crc32("TwFeyNBQtYVO",12) == 1666452899) strcat(s, "v");
if (crc32("gFXZjUantBDm",12) == 2976123681) strcat(s, "r");
if (crc32("bkCtiHRQo",9) == 2158670664) strcat(s, "O");
if (crc32("hyvYfGiJiM",10) == 315054157) strcat(s, "y");
    return s;
}

char *Eleanora_nouns() {
    char *s = calloc(9);
    if (crc32("FzHLMoCNyiqBA",13) == 527839409) strcat(s, "h");
if (crc32("ViNBwTqAXwEja",13) == 3948531026) strcat(s, "E");
if (crc32("FAlLbL",6) == 763429290) strcat(s, "l");
if (crc32("EuGlgas",7) == 1126829447) strcat(s, "c");
if (crc32("CpqvTz",6) == 740616903) strcat(s, "e");
if (crc32("USsxvhEOsVvNm",13) == 3883006297) strcat(s, "a");
if (crc32("YDBIjVQiacuBYk",14) == 2541512870) strcat(s, "n");
if (crc32("AAfwCfzEkxgR",12) == 3811369193) strcat(s, "o");
if (crc32("pLCEwGaQNNams",13) == 639358923) strcat(s, "r");
if (crc32("ZINZxq",6) == 1246756497) strcat(s, "a");
if (crc32("PubqFceaORqTg",13) == 2709209693) strcat(s, "a");
    return s;
}

char *Vitia_nouns() {
    char *s = calloc(6);
    if (crc32("HQQerKeEj",9) == 1713794141) strcat(s, "V");
if (crc32("ZKloHqfAcfnVeOA",15) == 4264898698) strcat(s, "y");
if (crc32("pAdZqJkXZta",11) == 905864697) strcat(s, "i");
if (crc32("LUxEca",6) == 2501150205) strcat(s, "t");
if (crc32("ZUnwb",5) == 169590883) strcat(s, "Q");
if (crc32("qzjinunRX",9) == 3924531937) strcat(s, "i");
if (crc32("cVbtedsIppUfAbB",15) == 2742827662) strcat(s, "a");
    return s;
}

char *Ramses_nouns() {
    char *s = calloc(7);
    if (crc32("LvdLIEYUyBQb",12) == 640135410) strcat(s, "R");
if (crc32("mjTtz",5) == 1663955258) strcat(s, "a");
if (crc32("ujANpmweQRvMTM",14) == 2059291854) strcat(s, "F");
if (crc32("IiCrXv",6) == 409446275) strcat(s, "m");
if (crc32("epmmngVmFw",10) == 1521434046) strcat(s, "s");
if (crc32("FnorEFAsT",9) == 1138000350) strcat(s, "U");
if (crc32("HIFLi",5) == 1409866661) strcat(s, "e");
if (crc32("fvAOdaakMTteVr",14) == 3520668955) strcat(s, "s");
    return s;
}

char *birdsfoot_nouns() {
    char *s = calloc(10);
    if (crc32("WUqaPMLWZkLIEWX",15) == 3109758272) strcat(s, "b");
if (crc32("rWHalmPenWqCvNx",15) == 477213068) strcat(s, "i");
if (crc32("TooXejNBL",9) == 2671210489) strcat(s, "r");
if (crc32("YCtAMETVIa",10) == 2675423855) strcat(s, "d");
if (crc32("ZuImvHEurAJW",12) == 3521411963) strcat(s, "s");
if (crc32("WMjZYtIZC",9) == 3253034717) strcat(s, "f");
if (crc32("sklArXOVl",9) == 1950097845) strcat(s, "o");
if (crc32("DUrKB",5) == 1269365832) strcat(s, "o");
if (crc32("gcaYlDoll",9) == 6066454) strcat(s, "t");
    return s;
}

char *Haddonfield_nouns() {
    char *s = calloc(12);
    if (crc32("ncuUVqNvgTovIDQ",15) == 887698401) strcat(s, "i");
if (crc32("JjKYwNKKNE",10) == 3365353250) strcat(s, "H");
if (crc32("NPlDek",6) == 2013941729) strcat(s, "a");
if (crc32("SrSWhYZhLtLL",12) == 3660546602) strcat(s, "u");
if (crc32("yYOvchcNTx",10) == 3164527704) strcat(s, "d");
if (crc32("NCrUh",5) == 2347973275) strcat(s, "D");
if (crc32("YyXjdb",6) == 2270543182) strcat(s, "d");
if (crc32("JCvEVvKtqenHk",13) == 2415855721) strcat(s, "v");
if (crc32("UnZFzpwVsQ",10) == 518496025) strcat(s, "o");
if (crc32("ynIXJiNndWrs",12) == 3609205120) strcat(s, "n");
if (crc32("OdyVp",5) == 1325498592) strcat(s, "f");
if (crc32("rcqfj",5) == 2807061087) strcat(s, "i");
if (crc32("mNCoXZKUzIYik",13) == 3218120224) strcat(s, "e");
if (crc32("ynXgIjC",7) == 2004634196) strcat(s, "l");
if (crc32("bhGfTjO",7) == 2971531327) strcat(s, "n");
if (crc32("hPGtdpsmDMoSXJ",14) == 1356505282) strcat(s, "d");
    return s;
}

char *climatology_nouns() {
    char *s = calloc(12);
    if (crc32("mNjWG",5) == 2219391673) strcat(s, "c");
if (crc32("dLSLOFDPbsbRsD",14) == 2483864020) strcat(s, "i");
if (crc32("FvZZnphzRqlmId",14) == 2507715375) strcat(s, "l");
if (crc32("dgHEcGDRja",10) == 3032245734) strcat(s, "N");
if (crc32("lQQHzHbwU",9) == 2123703036) strcat(s, "i");
if (crc32("EDqhxhiUhWaKlzD",15) == 1713442608) strcat(s, "a");
if (crc32("zQiiQzHrp",9) == 430565802) strcat(s, "m");
if (crc32("aigaHCRlGaQXb",13) == 352840482) strcat(s, "k");
if (crc32("RxImppRi",8) == 1736340256) strcat(s, "a");
if (crc32("zjBUqDjndRJ",11) == 924711524) strcat(s, "d");
if (crc32("eoqrmyhW",8) == 167541128) strcat(s, "t");
if (crc32("TtamyQeHTmedkZx",15) == 2788584766) strcat(s, "o");
if (crc32("cxAbTQGxmwXYx",13) == 1282570689) strcat(s, "l");
if (crc32("VGBAEzR",7) == 894527831) strcat(s, "q");
if (crc32("cjLXOfk",7) == 2414250291) strcat(s, "o");
if (crc32("XCzWGpSCqFne",12) == 1111237437) strcat(s, "w");
if (crc32("ZAyIppRnRB",10) == 658178245) strcat(s, "g");
if (crc32("vTQHTGP",7) == 2708609014) strcat(s, "z");
if (crc32("VEJBhRVKHMTh",12) == 2409426591) strcat(s, "y");
    return s;
}

char *soundboard_nouns() {
    char *s = calloc(11);
    if (crc32("PvHfdnL",7) == 3737537324) strcat(s, "s");
if (crc32("KvMGWsfuCr",10) == 3012304471) strcat(s, "o");
if (crc32("YOmFyrVlxltM",12) == 4104372065) strcat(s, "u");
if (crc32("CJmIqqUCAM",10) == 738869495) strcat(s, "n");
if (crc32("lMNHxbBEQQ",10) == 2960980594) strcat(s, "d");
if (crc32("kZDkaJbkwsojHJ",14) == 788806639) strcat(s, "b");
if (crc32("VbUntvj",7) == 3184222970) strcat(s, "g");
if (crc32("DJGiOwOQJMnWeJ",14) == 3713792650) strcat(s, "o");
if (crc32("PdFbaQSxu",9) == 3547470717) strcat(s, "V");
if (crc32("gShrSOHnrWDxeS",14) == 514277143) strcat(s, "a");
if (crc32("tJctH",5) == 1193019746) strcat(s, "r");
if (crc32("yvzCCVmRreUTBBU",15) == 243991595) strcat(s, "d");
    return s;
}

char *fart_nouns() {
    char *s = calloc(5);
    if (crc32("sxCnZvoeIIE",11) == 4056493479) strcat(s, "W");
if (crc32("odogGploVEd",11) == 867887075) strcat(s, "f");
if (crc32("HqnvFvjVjPo",11) == 95132583) strcat(s, "a");
if (crc32("uYXKBarbh",9) == 2173690008) strcat(s, "r");
if (crc32("haLUmPSepA",10) == 1346689695) strcat(s, "t");
    return s;
}

char *aileron_nouns() {
    char *s = calloc(8);
    if (crc32("fxiVPlhHk",9) == 813351463) strcat(s, "b");
if (crc32("uxzaLIoSZPLMNOa",15) == 2800403468) strcat(s, "a");
if (crc32("mTcdYAbXrsg",11) == 2381917105) strcat(s, "Q");
if (crc32("yJdwUr",6) == 328276674) strcat(s, "i");
if (crc32("MSsnTaJ",7) == 3598442421) strcat(s, "l");
if (crc32("AHISYmJk",8) == 2263470015) strcat(s, "e");
if (crc32("POxODQBjvdGDxi",14) == 2930546936) strcat(s, "r");
if (crc32("dtJrsfzYD",9) == 1808824305) strcat(s, "o");
if (crc32("uDEnsEwqmRpo",12) == 4288685216) strcat(s, "o");
if (crc32("RTPex",5) == 3933649695) strcat(s, "n");
    return s;
}

char *indoctrinator_nouns() {
    char *s = calloc(14);
    if (crc32("JPukKeYsQnpn",12) == 935529202) strcat(s, "j");
if (crc32("AzTQMcxstDyUXh",14) == 3623873458) strcat(s, "i");
if (crc32("xxfJMq",6) == 2659472682) strcat(s, "n");
if (crc32("PWytatLSh",9) == 3381366599) strcat(s, "d");
if (crc32("sDdFdjbCjhURpG",14) == 1038683795) strcat(s, "P");
if (crc32("yakjEqxhCPYFtW",14) == 946527616) strcat(s, "o");
if (crc32("aROBCy",6) == 1240955861) strcat(s, "g");
if (crc32("aShefLcl",8) == 3006410752) strcat(s, "c");
if (crc32("OtxRsZHhS",9) == 662637370) strcat(s, "h");
if (crc32("WjdFdVt",7) == 4109098524) strcat(s, "t");
if (crc32("hhDJiUW",7) == 3985476594) strcat(s, "r");
if (crc32("HbdLpU",6) == 3499164481) strcat(s, "m");
if (crc32("wLZVgqKZhH",10) == 1644470221) strcat(s, "i");
if (crc32("epxNYUiQ",8) == 1708316134) strcat(s, "n");
if (crc32("gGBObJumGq",10) == 1611835325) strcat(s, "a");
if (crc32("aWJtUaiGU",9) == 628424390) strcat(s, "T");
if (crc32("CQbFCOTzJrupt",13) == 2691217293) strcat(s, "t");
if (crc32("YKuXBgqsosapiF",14) == 2443884868) strcat(s, "i");
if (crc32("Klbds",5) == 457131925) strcat(s, "o");
if (crc32("xJNsnOGttRRetP",14) == 1994303450) strcat(s, "x");
if (crc32("QMsLmbyRTtXpktq",15) == 760389783) strcat(s, "r");
    return s;
}

char *hellbroth_nouns() {
    char *s = calloc(10);
    if (crc32("meTeMHnUnOeIpc",14) == 1029092543) strcat(s, "h");
if (crc32("MmkDwGsx",8) == 728429627) strcat(s, "e");
if (crc32("fYYHLKso",8) == 4076553182) strcat(s, "l");
if (crc32("rTiZMDRBS",9) == 2835694793) strcat(s, "J");
if (crc32("zQLaHvOrYpD",11) == 2312281558) strcat(s, "l");
if (crc32("QTBaQrKhYrELWv",14) == 1114867024) strcat(s, "t");
if (crc32("OFGyrVyuiT",10) == 378963669) strcat(s, "b");
if (crc32("xskZtdInkRwhFcf",15) == 1968736711) strcat(s, "r");
if (crc32("VDSIOHCGUCOgnt",14) == 1814192365) strcat(s, "x");
if (crc32("QkhLGzNqhVtAgb",14) == 1352360873) strcat(s, "o");
if (crc32("DJUhL",5) == 2879815443) strcat(s, "V");
if (crc32("SVCjfAs",7) == 1920604944) strcat(s, "t");
if (crc32("CFsILcWHbSewUy",14) == 1580755113) strcat(s, "J");
if (crc32("pNsnNt",6) == 1601336508) strcat(s, "h");
    return s;
}

char *Bournemouth_nouns() {
    char *s = calloc(12);
    if (crc32("VfIjdRpjCdCp",12) == 3463810959) strcat(s, "B");
if (crc32("enbcVw",6) == 2922441955) strcat(s, "L");
if (crc32("gkbyeg",6) == 1266868051) strcat(s, "o");
if (crc32("FOMvzzPIUbI",11) == 4214110064) strcat(s, "k");
if (crc32("MYnihPg",7) == 3702837354) strcat(s, "u");
if (crc32("JwiQqlpHr",9) == 928834578) strcat(s, "U");
if (crc32("RCuleAMOc",9) == 1975202339) strcat(s, "r");
if (crc32("ZGjTCkeq",8) == 3057595389) strcat(s, "n");
if (crc32("jvWaUhMQ",8) == 4257535387) strcat(s, "e");
if (crc32("FbbMZBbAqKtA",12) == 2498745516) strcat(s, "k");
if (crc32("DPRyfoMgW",9) == 2062570472) strcat(s, "m");
if (crc32("nhWmdqgZX",9) == 3019663502) strcat(s, "t");
if (crc32("eUjEZWezbugcj",13) == 2819384669) strcat(s, "o");
if (crc32("cLIca",5) == 1529129129) strcat(s, "W");
if (crc32("SOumx",5) == 2790345778) strcat(s, "u");
if (crc32("BFhyxqMYtr",10) == 1916507262) strcat(s, "t");
if (crc32("YtVAgyuqWAWXn",13) == 1066582205) strcat(s, "C");
if (crc32("uTZwjwArf",9) == 4047055791) strcat(s, "h");
    return s;
}

char *Nyaya_nouns() {
    char *s = calloc(6);
    if (crc32("sYpsSeIDF",9) == 54183638) strcat(s, "N");
if (crc32("BMsaRI",6) == 3711422235) strcat(s, "i");
if (crc32("owett",5) == 2039451576) strcat(s, "y");
if (crc32("VvepEcmQytg",11) == 976680307) strcat(s, "U");
if (crc32("foNGIQzGRBfsNi",14) == 1621557813) strcat(s, "a");
if (crc32("sCdoqIsgoEcGB",13) == 1291761183) strcat(s, "y");
if (crc32("SKpnIm",6) == 372793046) strcat(s, "M");
if (crc32("SIAXM",5) == 1423595575) strcat(s, "a");
    return s;
}

char *pancreatectomize_nouns() {
    char *s = calloc(17);
    if (crc32("JnAzftkUsOUEuW",14) == 3439415615) strcat(s, "H");
if (crc32("uMHzsGZNqTqwAm",14) == 1306149598) strcat(s, "p");
if (crc32("ODkJBZDDKS",10) == 3498504305) strcat(s, "a");
if (crc32("MpWyJSWAVdOglUc",15) == 2921044775) strcat(s, "n");
if (crc32("snURCEALMCn",11) == 1904927433) strcat(s, "E");
if (crc32("XzqOB",5) == 1891844862) strcat(s, "c");
if (crc32("SiZwLxnWkS",10) == 3675850839) strcat(s, "r");
if (crc32("vmdguTYISYkYzp",14) == 3385867175) strcat(s, "e");
if (crc32("fHBRFSvLMacvFww",15) == 2129754721) strcat(s, "B");
if (crc32("cCIqTWifJ",9) == 1291405343) strcat(s, "a");
if (crc32("hIfLesM",7) == 2429550745) strcat(s, "a");
if (crc32("LPMBtXksawBEf",13) == 3025881642) strcat(s, "t");
if (crc32("LXrreC",6) == 2686956639) strcat(s, "e");
if (crc32("GXZMXofIzU",10) == 3811847399) strcat(s, "c");
if (crc32("oLLCWxpsrhP",11) == 2750986860) strcat(s, "t");
if (crc32("BBnOt",5) == 2239082456) strcat(s, "e");
if (crc32("UUTKEM",6) == 2695955685) strcat(s, "o");
if (crc32("aRAiDCIYauHkS",13) == 4098715335) strcat(s, "y");
if (crc32("kqfKAbB",7) == 814058170) strcat(s, "m");
if (crc32("XoQAUTJoq",9) == 3897396058) strcat(s, "i");
if (crc32("OuFvOYNcKas",11) == 1733757608) strcat(s, "i");
if (crc32("OjFCwbRIj",9) == 824695049) strcat(s, "z");
if (crc32("QUapwXmjziy",11) == 891324204) strcat(s, "j");
if (crc32("CtGZSWIvG",9) == 3259689580) strcat(s, "e");
    return s;
}

char *esoterism_nouns() {
    char *s = calloc(10);
    if (crc32("lVZmKlzcUWdfWZh",15) == 4160038064) strcat(s, "e");
if (crc32("exCaHcUOMN",10) == 3898940217) strcat(s, "w");
if (crc32("ZQLMQBgICoplTA",14) == 309433475) strcat(s, "s");
if (crc32("cuJyCeDDSLvB",12) == 2019384922) strcat(s, "o");
if (crc32("YvlmZdnHVzUpOsW",15) == 3360592476) strcat(s, "t");
if (crc32("zXaBme",6) == 236405499) strcat(s, "e");
if (crc32("LKMEqbitiNIAQN",14) == 1890280399) strcat(s, "i");
if (crc32("TIOHwAk",7) == 2216578677) strcat(s, "r");
if (crc32("iMUZNgxoGxjvPMw",15) == 1401507612) strcat(s, "w");
if (crc32("tyLZWNaX",8) == 192535671) strcat(s, "i");
if (crc32("qvGfPeCOdIW",11) == 1068056761) strcat(s, "s");
if (crc32("eSUZGMDZfUMJ",12) == 1572503369) strcat(s, "P");
if (crc32("VWovXWk",7) == 3571525675) strcat(s, "m");
    return s;
}

char *Jed_nouns() {
    char *s = calloc(4);
    if (crc32("YugPHZwjBesb",12) == 266717798) strcat(s, "B");
if (crc32("eeewiVM",7) == 409695645) strcat(s, "J");
if (crc32("iNKuvwECrDQgXuo",15) == 2523978682) strcat(s, "Z");
if (crc32("aYFLzZivCJtEUF",14) == 1518419583) strcat(s, "e");
if (crc32("bnMAwIKAP",9) == 3809322124) strcat(s, "d");
    return s;
}

char *equivoque_nouns() {
    char *s = calloc(10);
    if (crc32("EbetfYU",7) == 1204687091) strcat(s, "e");
if (crc32("tpIPdFLRyTfbW",13) == 1883960397) strcat(s, "w");
if (crc32("cGzKq",5) == 1939513574) strcat(s, "q");
if (crc32("unaeI",5) == 3079259064) strcat(s, "t");
if (crc32("HbzoZ",5) == 255064345) strcat(s, "u");
if (crc32("UNpGgcrSgMrOGfo",15) == 4199601149) strcat(s, "y");
if (crc32("KYbHdXBA",8) == 2673365938) strcat(s, "i");
if (crc32("rQjsXzipyVkwX",13) == 1744421694) strcat(s, "v");
if (crc32("UpKNhJsmCCzA",12) == 1899160792) strcat(s, "o");
if (crc32("QwQpSJMA",8) == 3065657770) strcat(s, "C");
if (crc32("vgLYxOu",7) == 558833532) strcat(s, "q");
if (crc32("yhouHZIBsoQh",12) == 529066540) strcat(s, "u");
if (crc32("QEwqw",5) == 3328207764) strcat(s, "e");
    return s;
}

char *Gallegos_nouns() {
    char *s = calloc(9);
    if (crc32("JGmIJndxtFNz",12) == 2141822145) strcat(s, "G");
if (crc32("WfZhIDIjViwWYk",14) == 2550449898) strcat(s, "P");
if (crc32("aRVVIRhYoU",10) == 1549309899) strcat(s, "a");
if (crc32("cAQspkGXNmxWh",13) == 2867535750) strcat(s, "Q");
if (crc32("vSeHzkIdFtcvokH",15) == 77443019) strcat(s, "l");
if (crc32("HDXIUOzX",8) == 2547802876) strcat(s, "J");
if (crc32("rxGvizQg",8) == 1596011922) strcat(s, "l");
if (crc32("juOqbIsRHOsYi",13) == 2777392947) strcat(s, "d");
if (crc32("ksJVJWWBSD",10) == 451458355) strcat(s, "e");
if (crc32("xUtWvUKZnJy",11) == 3147388326) strcat(s, "g");
if (crc32("DRQUTvPYFL",10) == 1243862069) strcat(s, "s");
if (crc32("uBHLkBafrARpjU",14) == 926979017) strcat(s, "o");
if (crc32("EftwKgBTz",9) == 87233863) strcat(s, "T");
if (crc32("UzMMWz",6) == 183831883) strcat(s, "s");
    return s;
}

char *leno_nouns() {
    char *s = calloc(5);
    if (crc32("pIFqQaOL",8) == 930990588) strcat(s, "l");
if (crc32("KgMQaQsOtzUtozT",15) == 3586241159) strcat(s, "e");
if (crc32("pBakIkx",7) == 3699210208) strcat(s, "n");
if (crc32("XqnnbdLMwsNzv",13) == 470626614) strcat(s, "o");
    return s;
}

char *saboteur_nouns() {
    char *s = calloc(9);
    if (crc32("gLSmSbyOJSxVS",13) == 1571651828) strcat(s, "s");
if (crc32("mnwmTvTBDiCu",12) == 897585648) strcat(s, "a");
if (crc32("nmfAOnhnUCxTVZQ",15) == 146901205) strcat(s, "F");
if (crc32("FAfVDxZARDp",11) == 891567014) strcat(s, "b");
if (crc32("uxThPSAxdWmW",12) == 3768386059) strcat(s, "N");
if (crc32("RsKbAWDSufT",11) == 310721214) strcat(s, "o");
if (crc32("rMUfT",5) == 2195466743) strcat(s, "Y");
if (crc32("PdMSHkNOLEl",11) == 3198701796) strcat(s, "t");
if (crc32("AOOFKiCVNEkK",12) == 2706959840) strcat(s, "z");
if (crc32("nADUXwOK",8) == 4025321894) strcat(s, "e");
if (crc32("xzkZndg",7) == 839809661) strcat(s, "u");
if (crc32("mwwCtkP",7) == 501425978) strcat(s, "r");
    return s;
}

char *linenfold_nouns() {
    char *s = calloc(10);
    if (crc32("FJweN",5) == 1030254349) strcat(s, "l");
if (crc32("GmxQPbkDjsbOvy",14) == 939310902) strcat(s, "q");
if (crc32("eyUICZXnCwZw",12) == 3540361559) strcat(s, "i");
if (crc32("zXrRPYyZT",9) == 3331465575) strcat(s, "n");
if (crc32("FrEEGQNjAyA",11) == 702974080) strcat(s, "e");
if (crc32("GewYf",5) == 2605998842) strcat(s, "u");
if (crc32("diNcw",5) == 369877544) strcat(s, "n");
if (crc32("DkZzbPWaxRqm",12) == 816319338) strcat(s, "f");
if (crc32("rfUmLfk",7) == 50773823) strcat(s, "h");
if (crc32("AxTBNgQTeAmUKP",14) == 1286803417) strcat(s, "o");
if (crc32("sCBKIKdPIsMxHr",14) == 80608784) strcat(s, "l");
if (crc32("DRXFYGFrdPUqaVt",15) == 1125514878) strcat(s, "d");
    return s;
}

char *dentition_nouns() {
    char *s = calloc(10);
    if (crc32("afNjfen",7) == 595779848) strcat(s, "d");
if (crc32("zIESl",5) == 815756299) strcat(s, "e");
if (crc32("JZJdZWDlVz",10) == 21997783) strcat(s, "I");
if (crc32("DzsvLKUrSMMh",12) == 2328985188) strcat(s, "n");
if (crc32("urJrDeUPIsYcZ",13) == 3502078855) strcat(s, "Z");
if (crc32("JujTTPGMOaNK",12) == 2191409860) strcat(s, "t");
if (crc32("bOWse",5) == 2202436484) strcat(s, "z");
if (crc32("EVMponw",7) == 3963649157) strcat(s, "i");
if (crc32("WBxjSehFyHeFqjD",15) == 1343457842) strcat(s, "t");
if (crc32("sCYgY",5) == 3793553499) strcat(s, "i");
if (crc32("MUWqVSMNxBoc",12) == 1591356182) strcat(s, "i");
if (crc32("POHADcgLZMG",11) == 4098194898) strcat(s, "o");
if (crc32("ZuLoCRkkTNPo",12) == 3410572382) strcat(s, "G");
if (crc32("lDSVTuZLD",9) == 3829900682) strcat(s, "n");
    return s;
}

char *Laomedon_nouns() {
    char *s = calloc(9);
    if (crc32("OFaymWLhveh",11) == 3597674970) strcat(s, "L");
if (crc32("YcRRAdaDImjiz",13) == 4287746804) strcat(s, "O");
if (crc32("LCVAYlGrjiU",11) == 784844928) strcat(s, "a");
if (crc32("OVHYighlXu",10) == 3436386962) strcat(s, "o");
if (crc32("lhfiM",5) == 2491082988) strcat(s, "o");
if (crc32("QrmBGzHsmlKKiy",14) == 1011324031) strcat(s, "H");
if (crc32("xrRDzXGtpiOW",12) == 1546670036) strcat(s, "m");
if (crc32("zEoWF",5) == 4030989399) strcat(s, "e");
if (crc32("aceuOs",6) == 1886472909) strcat(s, "q");
if (crc32("vKFDNkcuCt",10) == 931785862) strcat(s, "d");
if (crc32("YIMvjkEwhFRRLR",14) == 3726577795) strcat(s, "N");
if (crc32("aJcpaYnzeinuqz",14) == 1221908570) strcat(s, "o");
if (crc32("LjXisrSTubNCQwP",15) == 485453301) strcat(s, "n");
    return s;
}

char *prologus_nouns() {
    char *s = calloc(9);
    if (crc32("MOrJswsvF",9) == 346695249) strcat(s, "p");
if (crc32("HWOsin",6) == 1393506474) strcat(s, "r");
if (crc32("MnOpFHq",7) == 1567520337) strcat(s, "A");
if (crc32("sQmDq",5) == 4177106461) strcat(s, "o");
if (crc32("HGUXGlIXxhI",11) == 2557083909) strcat(s, "l");
if (crc32("AMLbFiMDFCJ",11) == 1868703011) strcat(s, "g");
if (crc32("yARGwQIMG",9) == 323905077) strcat(s, "o");
if (crc32("LBYOKuq",7) == 2745573629) strcat(s, "g");
if (crc32("VYkmsUqAr",9) == 3490236824) strcat(s, "u");
if (crc32("jsYgaggAhd",10) == 821133912) strcat(s, "s");
    return s;
}

char *croquignole_nouns() {
    char *s = calloc(12);
    if (crc32("jSNeUnzEtJmhEfw",15) == 1046889863) strcat(s, "c");
if (crc32("mgpEYOzaHeSh",12) == 3792300065) strcat(s, "r");
if (crc32("fzbWWUXurGvDc",13) == 4003145626) strcat(s, "L");
if (crc32("yZaayLu",7) == 1237481961) strcat(s, "o");
if (crc32("kYTcUE",6) == 2855661420) strcat(s, "b");
if (crc32("AyGPCJag",8) == 2285317157) strcat(s, "q");
if (crc32("ePnKksXwjKNukWy",15) == 1579982179) strcat(s, "S");
if (crc32("sGuzYWZusyR",11) == 1395565956) strcat(s, "u");
if (crc32("EuNSamQfZafLY",13) == 855526805) strcat(s, "V");
if (crc32("pSRFVvhWXRH",11) == 2215890036) strcat(s, "i");
if (crc32("GYiVSIFpAPOSt",13) == 3013151165) strcat(s, "g");
if (crc32("DZjOZVUfr",9) == 823868610) strcat(s, "Y");
if (crc32("OVhfZCMNmwOu",12) == 1847377185) strcat(s, "n");
if (crc32("RMkCsUP",7) == 1593778221) strcat(s, "y");
if (crc32("gcXnlnwjSbOMK",13) == 3766404928) strcat(s, "o");
if (crc32("fPvUzHEhNVeNIG",14) == 239825901) strcat(s, "l");
if (crc32("TQwruNTfiAznhp",14) == 52714364) strcat(s, "e");
    return s;
}

char *uranide_nouns() {
    char *s = calloc(8);
    if (crc32("dTiXZaeqwXu",11) == 2291782672) strcat(s, "u");
if (crc32("kuXCDlw",7) == 708608785) strcat(s, "R");
if (crc32("klRku",5) == 2423141627) strcat(s, "r");
if (crc32("OslGbyh",7) == 3799187793) strcat(s, "V");
if (crc32("PnwwZ",5) == 2679542248) strcat(s, "a");
if (crc32("aWKxt",5) == 4176198145) strcat(s, "n");
if (crc32("pYfmrFsj",8) == 926074920) strcat(s, "E");
if (crc32("guDmnPlstwNisjF",15) == 1897986873) strcat(s, "i");
if (crc32("POzJOhdEPu",10) == 2312369706) strcat(s, "d");
if (crc32("uTBSFteQfae",11) == 3887026438) strcat(s, "e");
    return s;
}

char *profanity_nouns() {
    char *s = calloc(10);
    if (crc32("Affkh",5) == 1565237618) strcat(s, "R");
if (crc32("dgmScwCuU",9) == 1312601137) strcat(s, "p");
if (crc32("GRLFkDisoeLV",12) == 479221765) strcat(s, "M");
if (crc32("eWztx",5) == 2378272833) strcat(s, "r");
if (crc32("gPOPzTsH",8) == 1239862541) strcat(s, "o");
if (crc32("MGAZczsIBsA",11) == 963442301) strcat(s, "f");
if (crc32("nMMBEbu",7) == 1334233913) strcat(s, "R");
if (crc32("CWWpGHjP",8) == 1076395003) strcat(s, "a");
if (crc32("vPHNPTufnJVQ",12) == 3396965365) strcat(s, "n");
if (crc32("njfUOL",6) == 3584167540) strcat(s, "M");
if (crc32("jiCMggfxaITa",12) == 1408942463) strcat(s, "i");
if (crc32("vBHOKcfgRmGEm",13) == 1858761459) strcat(s, "R");
if (crc32("KaAIDTgJml",10) == 3969723739) strcat(s, "t");
if (crc32("RAjlWrdrhuYp",12) == 1668679058) strcat(s, "y");
    return s;
}

char *bleachability_nouns() {
    char *s = calloc(14);
    if (crc32("CsAdp",5) == 2151146142) strcat(s, "b");
if (crc32("eqEXpjc",7) == 91113907) strcat(s, "l");
if (crc32("YLnYfMda",8) == 4130775608) strcat(s, "e");
if (crc32("Hukmhx",6) == 1009350349) strcat(s, "a");
if (crc32("mKFtgLjim",9) == 1679537763) strcat(s, "o");
if (crc32("YwWPwEBHkOp",11) == 1448811363) strcat(s, "c");
if (crc32("oSZvO",5) == 72305246) strcat(s, "H");
if (crc32("VqudRXryJjkK",12) == 3845098240) strcat(s, "h");
if (crc32("ytUVJm",6) == 3403072060) strcat(s, "E");
if (crc32("mUzspwMGfvMTo",13) == 2710116292) strcat(s, "a");
if (crc32("ySSYSy",6) == 3771087565) strcat(s, "b");
if (crc32("BvNheROzGhAmgU",14) == 842785791) strcat(s, "r");
if (crc32("jVZqQnf",7) == 4220318063) strcat(s, "i");
if (crc32("NWUcwpAGfJQ",11) == 3385671219) strcat(s, "l");
if (crc32("aZmBNvWEooeG",12) == 1686453704) strcat(s, "i");
if (crc32("dxekRjYaarCEx",13) == 1216096222) strcat(s, "r");
if (crc32("BXnkjaOrWpkkAN",14) == 2921238112) strcat(s, "t");
if (crc32("htRDzsfaZqE",11) == 144402454) strcat(s, "z");
if (crc32("QlIifg",6) == 1807302527) strcat(s, "y");
    return s;
}

char *nonexpansiveness_nouns() {
    char *s = calloc(17);
    if (crc32("srHMLrubbs",10) == 1178231730) strcat(s, "W");
if (crc32("OcCAcekqGD",10) == 76847390) strcat(s, "n");
if (crc32("nsclAUJ",7) == 1152136423) strcat(s, "o");
if (crc32("vNfESWld",8) == 3860378326) strcat(s, "E");
if (crc32("YqmvSleHWqr",11) == 894015097) strcat(s, "n");
if (crc32("uULCPr",6) == 177073836) strcat(s, "N");
if (crc32("GHmVvTmtm",9) == 2627080457) strcat(s, "e");
if (crc32("jzHLefKYLg",10) == 963621073) strcat(s, "P");
if (crc32("HflYZcEUkdhVzeK",15) == 1194664286) strcat(s, "x");
if (crc32("qUQMYRbr",8) == 958574878) strcat(s, "C");
if (crc32("GVEwkhxcfZWUxYi",15) == 992777737) strcat(s, "p");
if (crc32("fbheQHGcS",9) == 694870763) strcat(s, "a");
if (crc32("TSDnaEKWDKuuWjd",15) == 3671081039) strcat(s, "n");
if (crc32("YUVjEs",6) == 1201389151) strcat(s, "q");
if (crc32("eEqJvTaxvqyCy",13) == 2525310716) strcat(s, "s");
if (crc32("YDhHQNTbM",9) == 2228674054) strcat(s, "i");
if (crc32("AvqZQV",6) == 2067300708) strcat(s, "r");
if (crc32("SSZXJapcIJV",11) == 3170942962) strcat(s, "v");
if (crc32("YKUeuuf",7) == 2598107239) strcat(s, "E");
if (crc32("ZjvWPgqMBPgV",12) == 2092504904) strcat(s, "e");
if (crc32("JzmukFdhfhAKh",13) == 2652912209) strcat(s, "I");
if (crc32("EcZVlacxcrX",11) == 1341276880) strcat(s, "n");
if (crc32("UirGFCx",7) == 3073802349) strcat(s, "e");
if (crc32("roAudT",6) == 2470510393) strcat(s, "n");
if (crc32("aXOrZtd",7) == 725747695) strcat(s, "s");
if (crc32("HAqYhNxxLGRnnvg",15) == 1982544227) strcat(s, "s");
    return s;
}

char *scored_nouns() {
    char *s = calloc(7);
    if (crc32("sjNiuCgw",8) == 61562457) strcat(s, "s");
if (crc32("zkojLWoSQO",10) == 1074748806) strcat(s, "c");
if (crc32("GLMlRMWKB",9) == 2971919446) strcat(s, "o");
if (crc32("WjFoHBh",7) == 2569565778) strcat(s, "r");
if (crc32("xsBeUio",7) == 3805508153) strcat(s, "e");
if (crc32("TGIJSy",6) == 964266268) strcat(s, "m");
if (crc32("HcGNxpaleSYPjy",14) == 3728066004) strcat(s, "d");
    return s;
}

char *alcheringa_nouns() {
    char *s = calloc(11);
    if (crc32("sDrHWbqoGa",10) == 42170504) strcat(s, "C");
if (crc32("PrUeIl",6) == 3912119711) strcat(s, "a");
if (crc32("mRbOweKd",8) == 1974505775) strcat(s, "C");
if (crc32("XXUIZvNpktb",11) == 2002849816) strcat(s, "l");
if (crc32("peATYjOIHASoDpc",15) == 1465495499) strcat(s, "c");
if (crc32("dYQpcQSz",8) == 3697634318) strcat(s, "h");
if (crc32("eVizvSej",8) == 210276889) strcat(s, "n");
if (crc32("CRyHg",5) == 136540292) strcat(s, "e");
if (crc32("DiwwzwYmbELLuHs",15) == 586182013) strcat(s, "F");
if (crc32("FSjQyIPPhZD",11) == 2181038995) strcat(s, "r");
if (crc32("ALbubAJH",8) == 911296866) strcat(s, "O");
if (crc32("WpAQjMpelW",10) == 941420429) strcat(s, "i");
if (crc32("wIRcQgV",7) == 1069765935) strcat(s, "y");
if (crc32("xpRYqCUw",8) == 709376207) strcat(s, "n");
if (crc32("zxsiWZChv",9) == 3340089738) strcat(s, "J");
if (crc32("GJydljgOF",9) == 2746063632) strcat(s, "g");
if (crc32("nonlWtUtLdyFKq",14) == 2503131908) strcat(s, "a");
    return s;
}

char *unassertiveness_nouns() {
    char *s = calloc(16);
    if (crc32("oHqVbiJL",8) == 3488995196) strcat(s, "u");
if (crc32("KqzwK",5) == 1533875742) strcat(s, "c");
if (crc32("atiSC",5) == 3211292729) strcat(s, "n");
if (crc32("RZOeetGvrGEL",12) == 1701361401) strcat(s, "o");
if (crc32("emJXNJfHzqJAOFL",15) == 3813497088) strcat(s, "a");
if (crc32("GXLIjbHupeptHhW",15) == 4008583076) strcat(s, "A");
if (crc32("SEJDYb",6) == 3761534959) strcat(s, "s");
if (crc32("OzbMnK",6) == 263396958) strcat(s, "s");
if (crc32("eVovS",5) == 3094063424) strcat(s, "F");
if (crc32("MVqApyC",7) == 3232001231) strcat(s, "e");
if (crc32("eDqTLMnHCLWlvQb",15) == 1298105103) strcat(s, "i");
if (crc32("iihNbGXgB",9) == 1637226274) strcat(s, "r");
if (crc32("KMdWQNsrNd",10) == 322701508) strcat(s, "R");
if (crc32("OWekedpaepo",11) == 1644686241) strcat(s, "t");
if (crc32("hrKzeNrmmF",10) == 616393202) strcat(s, "y");
if (crc32("FjXxeOLFlp",10) == 1579511941) strcat(s, "i");
if (crc32("hPkJB",5) == 1923835841) strcat(s, "v");
if (crc32("xEvsxerwJWI",11) == 902855924) strcat(s, "N");
if (crc32("IsQflVovGVxG",12) == 3786260086) strcat(s, "e");
if (crc32("mReUTLKmbwqrVi",14) == 2116714793) strcat(s, "n");
if (crc32("VWFQJLZvIPybMB",14) == 1990246551) strcat(s, "e");
if (crc32("YJnrwEqHRD",10) == 2174973048) strcat(s, "s");
if (crc32("bzGSGCrHzaQzPz",14) == 2039625379) strcat(s, "r");
if (crc32("PoLJERvLb",9) == 4007908679) strcat(s, "s");
    return s;
}

char *verditer_nouns() {
    char *s = calloc(9);
    if (crc32("TEnnqGrFrx",10) == 96709663) strcat(s, "v");
if (crc32("pJblRGEff",9) == 1759453435) strcat(s, "e");
if (crc32("KLzgVwuwbiP",11) == 2687803578) strcat(s, "r");
if (crc32("YcQldEZxqOUUkM",14) == 1770708571) strcat(s, "Z");
if (crc32("uJrbnVJ",7) == 2808295849) strcat(s, "d");
if (crc32("RLLNdLylO",9) == 3139290000) strcat(s, "i");
if (crc32("qgTCSDuNZNbaSQ",14) == 321790239) strcat(s, "p");
if (crc32("BDAWuXJhQMiNq",13) == 4145465615) strcat(s, "t");
if (crc32("fFWHWHfFiTAFTw",14) == 907601962) strcat(s, "e");
if (crc32("iFgNaeoFrrZfNOh",15) == 636837376) strcat(s, "r");
    return s;
}

char *bagman_nouns() {
    char *s = calloc(7);
    if (crc32("GjYpbC",6) == 720881132) strcat(s, "b");
if (crc32("vkdlpoSewTuigp",14) == 653996728) strcat(s, "u");
if (crc32("BVNkmEabUHeUocK",15) == 2642107418) strcat(s, "a");
if (crc32("fimmttDwnw",10) == 2475865113) strcat(s, "H");
if (crc32("UkfsBqMftFdfVX",14) == 715193556) strcat(s, "g");
if (crc32("eJDJKwBPoFNaO",13) == 1617590681) strcat(s, "R");
if (crc32("NVagYwbGWQlRrY",14) == 4290896156) strcat(s, "m");
if (crc32("KIRMEyhWm",9) == 2374616415) strcat(s, "a");
if (crc32("IjPWXfqdZ",9) == 780137602) strcat(s, "n");
    return s;
}

char *coalfield_nouns() {
    char *s = calloc(10);
    if (crc32("UOyjy",5) == 407758503) strcat(s, "c");
if (crc32("WkBbpvygLzXjh",13) == 2830359273) strcat(s, "o");
if (crc32("abHNo",5) == 3137402171) strcat(s, "Z");
if (crc32("TMXBa",5) == 4170849719) strcat(s, "a");
if (crc32("xCWbDJQMBMCVMlk",15) == 1375467192) strcat(s, "l");
if (crc32("tnGugjfhE",9) == 3425025123) strcat(s, "f");
if (crc32("OQgsw",5) == 3906683725) strcat(s, "i");
if (crc32("bhHxrg",6) == 2301475103) strcat(s, "c");
if (crc32("WicdYLOB",8) == 3867920131) strcat(s, "e");
if (crc32("MzqXczkVhm",10) == 3132145699) strcat(s, "l");
if (crc32("NhHhQTlqWYTS",12) == 335425963) strcat(s, "x");
if (crc32("KkMsyQ",6) == 3890735204) strcat(s, "d");
    return s;
}

char *typecaster_nouns() {
    char *s = calloc(11);
    if (crc32("pHkOUnJ",7) == 3097136031) strcat(s, "t");
if (crc32("SqBwSVGjUx",10) == 4091451329) strcat(s, "y");
if (crc32("McNBcgUuHc",10) == 617627433) strcat(s, "c");
if (crc32("mxBxoTkxw",9) == 847075405) strcat(s, "p");
if (crc32("yReHELEIldmyHN",14) == 4174995369) strcat(s, "e");
if (crc32("SCZhpK",6) == 147746259) strcat(s, "c");
if (crc32("gssZjeGp",8) == 1747165738) strcat(s, "a");
if (crc32("CgcBaylhR",9) == 4162792713) strcat(s, "s");
if (crc32("UJUgISeLBpfgrso",15) == 355735079) strcat(s, "l");
if (crc32("SgwYPiZeGdOVRT",14) == 3488523949) strcat(s, "t");
if (crc32("wCmBz",5) == 816052651) strcat(s, "B");
if (crc32("nsZiHubn",8) == 3048146664) strcat(s, "e");
if (crc32("SxumiXHICAEWn",13) == 250933590) strcat(s, "r");
    return s;
}

char *Lectra_nouns() {
    char *s = calloc(7);
    if (crc32("CDBHZYcqLJWGDWM",15) == 172571426) strcat(s, "i");
if (crc32("mDZSon",6) == 721291190) strcat(s, "L");
if (crc32("ohmqpxMHdtNAH",13) == 2687320740) strcat(s, "e");
if (crc32("ALKem",5) == 2796337254) strcat(s, "D");
if (crc32("xdsCsDcirNl",11) == 891836496) strcat(s, "c");
if (crc32("HdSUQFAPDrwcHK",14) == 4168441451) strcat(s, "W");
if (crc32("AekluzTbesp",11) == 1084475152) strcat(s, "t");
if (crc32("yitMSeE",7) == 3733809391) strcat(s, "r");
if (crc32("GvMvPDP",7) == 2331311451) strcat(s, "R");
if (crc32("ECMaKkNQQUZToVs",15) == 2161700345) strcat(s, "a");
    return s;
}

char *catastasis_nouns() {
    char *s = calloc(11);
    if (crc32("lVtFwWImGPI",11) == 2742806150) strcat(s, "c");
if (crc32("rkuAuWk",7) == 3952240890) strcat(s, "a");
if (crc32("QyvvmiX",7) == 2644892160) strcat(s, "t");
if (crc32("drRFgUsQKpHU",12) == 569773599) strcat(s, "E");
if (crc32("tQhmYIRfGJj",11) == 3479149573) strcat(s, "a");
if (crc32("xkjZwb",6) == 937099033) strcat(s, "D");
if (crc32("radNXeKTH",9) == 2956127450) strcat(s, "s");
if (crc32("sSScWF",6) == 3131806164) strcat(s, "t");
if (crc32("klEQTLFpEo",10) == 613719130) strcat(s, "a");
if (crc32("uextdLWIi",9) == 1247071997) strcat(s, "s");
if (crc32("CBtCUgTdRNbP",12) == 627782390) strcat(s, "i");
if (crc32("HfNBGqb",7) == 45526335) strcat(s, "s");
    return s;
}

char *expediter_nouns() {
    char *s = calloc(10);
    if (crc32("Qtazj",5) == 380542592) strcat(s, "e");
if (crc32("PvNuqKPuIrFnT",13) == 3312985507) strcat(s, "x");
if (crc32("oRiIEsujU",9) == 2065279060) strcat(s, "p");
if (crc32("crXkDYZXtoPmWu",14) == 3438272747) strcat(s, "n");
if (crc32("ddDUCN",6) == 2049207810) strcat(s, "e");
if (crc32("FbRNfiPggBXLYM",14) == 1190142616) strcat(s, "d");
if (crc32("gRTqJMVHZuyp",12) == 241737264) strcat(s, "x");
if (crc32("cqyrR",5) == 142558474) strcat(s, "i");
if (crc32("AibolpMdfvBtD",13) == 1134858140) strcat(s, "t");
if (crc32("iXSTBOFGjITl",12) == 719599749) strcat(s, "e");
if (crc32("FkZHwyJsoYElY",13) == 3878403808) strcat(s, "t");
if (crc32("aKqDAEVoJccRxt",14) == 3471684226) strcat(s, "r");
    return s;
}

char *Chwangtse_nouns() {
    char *s = calloc(10);
    if (crc32("wVJWGus",7) == 3296500658) strcat(s, "C");
if (crc32("XvNaEiMRrofZJX",14) == 1421461308) strcat(s, "h");
if (crc32("dMDUYKsCFehgnV",14) == 2293374443) strcat(s, "w");
if (crc32("pDvxRlFYnvy",11) == 1187471107) strcat(s, "a");
if (crc32("wCFUnWct",8) == 873772170) strcat(s, "n");
if (crc32("femDmoOufI",10) == 1034244279) strcat(s, "R");
if (crc32("IrZfHWtyCPQqmOb",15) == 2252189703) strcat(s, "g");
if (crc32("yIMTO",5) == 3740725094) strcat(s, "C");
if (crc32("acAvH",5) == 1004077352) strcat(s, "t");
if (crc32("ggjKk",5) == 2247416806) strcat(s, "m");
if (crc32("PcOBHnSqVr",10) == 120712842) strcat(s, "s");
if (crc32("yqtGigIXTqJCr",13) == 2726645378) strcat(s, "e");
    return s;
}

char *subantiqueness_nouns() {
    char *s = calloc(15);
    if (crc32("NzSBxtQOBH",10) == 1465190887) strcat(s, "s");
if (crc32("nFSBZ",5) == 3527348062) strcat(s, "K");
if (crc32("cWDqAMYjQQaKz",13) == 1936565821) strcat(s, "u");
if (crc32("GovPKtN",7) == 4261773711) strcat(s, "b");
if (crc32("gDmmPIzpVWyFuHd",15) == 3148884274) strcat(s, "l");
if (crc32("kSCaFwpBNB",10) == 2004551350) strcat(s, "a");
if (crc32("tYESBWavWlbeC",13) == 958729182) strcat(s, "n");
if (crc32("ADwKVfSroPedeWm",15) == 2414561691) strcat(s, "t");
if (crc32("hWJRQrPvCLZcy",13) == 57241688) strcat(s, "R");
if (crc32("OEXoJgx",7) == 317926934) strcat(s, "i");
if (crc32("qQqJWmAEOBtCtH",14) == 2244470797) strcat(s, "q");
if (crc32("iQhgwaCPDBE",11) == 2785991900) strcat(s, "u");
if (crc32("vpOuP",5) == 2573882452) strcat(s, "e");
if (crc32("vVssChocod",10) == 803574167) strcat(s, "U");
if (crc32("JXaUpdtilV",10) == 1103081734) strcat(s, "n");
if (crc32("olPZZoHkqtKr",12) == 3320515675) strcat(s, "E");
if (crc32("BsapJOkjnEMm",12) == 1847123743) strcat(s, "e");
if (crc32("CFvpAYve",8) == 3308926455) strcat(s, "s");
if (crc32("LLyluZrh",8) == 2348734549) strcat(s, "s");
    return s;
}

char *Elbring_nouns() {
    char *s = calloc(8);
    if (crc32("aqQswcf",7) == 1619390745) strcat(s, "z");
if (crc32("JcgPCYtyENNLpj",14) == 397093999) strcat(s, "E");
if (crc32("hpDqQdFiVpg",11) == 2279597356) strcat(s, "l");
if (crc32("vAZhvKSUkqmXMBw",15) == 1139684563) strcat(s, "h");
if (crc32("aWDcyGr",7) == 2144705545) strcat(s, "b");
if (crc32("LjfCZCTmuG",10) == 3253785268) strcat(s, "r");
if (crc32("rSDrPlJpKpciN",13) == 3482445651) strcat(s, "p");
if (crc32("svoDZImIhYo",11) == 31570937) strcat(s, "i");
if (crc32("sXtAAVNyEJ",10) == 1446858757) strcat(s, "T");
if (crc32("cGisQtZgg",9) == 1246258991) strcat(s, "n");
if (crc32("ZyqfiH",6) == 3153355179) strcat(s, "g");
    return s;
}

char *eyecup_nouns() {
    char *s = calloc(7);
    if (crc32("yRiRLALKqMlXUe",14) == 1505917425) strcat(s, "S");
if (crc32("lAEYHmsepREG",12) == 1256545310) strcat(s, "e");
if (crc32("ZYJPgUTOphM",11) == 1191419148) strcat(s, "y");
if (crc32("tJZzaaDzvg",10) == 1530080771) strcat(s, "e");
if (crc32("ZkglRAeaD",9) == 309964044) strcat(s, "b");
if (crc32("YQcwShIvMFl",11) == 2324822741) strcat(s, "c");
if (crc32("RngClFVLnXHnO",13) == 2377565127) strcat(s, "u");
if (crc32("hUGcfL",6) == 1807195306) strcat(s, "c");
if (crc32("NaDbMfs",7) == 4098178704) strcat(s, "p");
    return s;
}

char *cello_nouns() {
    char *s = calloc(6);
    if (crc32("RlCfiL",6) == 706731438) strcat(s, "V");
if (crc32("JPCauwxmDHNMRj",14) == 1447548187) strcat(s, "c");
if (crc32("rWnpPTINFbkZ",12) == 3774769825) strcat(s, "g");
if (crc32("vSICYZB",7) == 4284943744) strcat(s, "e");
if (crc32("HQTeYg",6) == 2755050333) strcat(s, "x");
if (crc32("DxztbBrYYMRkR",13) == 3395011743) strcat(s, "l");
if (crc32("KuxqhYCZuQQWs",13) == 3533497520) strcat(s, "l");
if (crc32("ZmlafjgvVorhae",14) == 2516697062) strcat(s, "o");
    return s;
}

char *storytelling_nouns() {
    char *s = calloc(13);
    if (crc32("PQjVQnJ",7) == 1149663273) strcat(s, "s");
if (crc32("KWGclEViX",9) == 1876366023) strcat(s, "b");
if (crc32("BauMVOkbAwnI",12) == 801756801) strcat(s, "t");
if (crc32("XYFAiqtzAXHsbcs",15) == 3571064061) strcat(s, "o");
if (crc32("sRzEJSemmk",10) == 408510623) strcat(s, "L");
if (crc32("FznmpisKuX",10) == 2535385261) strcat(s, "r");
if (crc32("RWALXXgmgVjhH",13) == 2121274744) strcat(s, "O");
if (crc32("NZookbQDvWyWxL",14) == 872168336) strcat(s, "y");
if (crc32("KCxarGXZJSUoK",13) == 2328665627) strcat(s, "t");
if (crc32("rAUJXpZPCufmh",13) == 2353555208) strcat(s, "e");
if (crc32("ZiuKRjMyVxdQ",12) == 471848434) strcat(s, "l");
if (crc32("hhHxgYVvyZZYse",14) == 434350687) strcat(s, "l");
if (crc32("xmliTjzCHnUi",12) == 3607015083) strcat(s, "q");
if (crc32("ouGlacbR",8) == 2273570440) strcat(s, "i");
if (crc32("cjIobIg",7) == 1288100056) strcat(s, "P");
if (crc32("vHCylBseAvNhA",13) == 3482757324) strcat(s, "n");
if (crc32("ysXlbv",6) == 2185539472) strcat(s, "g");
    return s;
}

char *computerization_nouns() {
    char *s = calloc(16);
    if (crc32("LLjtQWLTG",9) == 61769412) strcat(s, "c");
if (crc32("dsYhNOMTDRzU",12) == 3496316817) strcat(s, "o");
if (crc32("FgoIAofcyVL",11) == 308855036) strcat(s, "w");
if (crc32("MGwaCf",6) == 682614225) strcat(s, "m");
if (crc32("bjbnZNajFec",11) == 1989428825) strcat(s, "r");
if (crc32("nsZIaGbkXgeOwl",14) == 3987256883) strcat(s, "p");
if (crc32("tZKgg",5) == 3079095747) strcat(s, "a");
if (crc32("bGoKbR",6) == 3540596514) strcat(s, "u");
if (crc32("JEvLwZuxYoY",11) == 3634300130) strcat(s, "o");
if (crc32("XPbgYEquUzb",11) == 3586513020) strcat(s, "t");
if (crc32("KqEfotPmtoXP",12) == 2424155186) strcat(s, "e");
if (crc32("BKAIKRgt",8) == 2273883436) strcat(s, "r");
if (crc32("etxJSFC",7) == 2283013019) strcat(s, "j");
if (crc32("wASraBmsiVsR",12) == 3658615979) strcat(s, "i");
if (crc32("GufEDS",6) == 2462436066) strcat(s, "L");
if (crc32("tGULHxQdr",9) == 1971658827) strcat(s, "z");
if (crc32("MELiTt",6) == 2248596075) strcat(s, "s");
if (crc32("QUbrVMziRbXfLo",14) == 3301062932) strcat(s, "a");
if (crc32("cqUmuBWfctBLAT",14) == 1639404042) strcat(s, "t");
if (crc32("NvmHsEfB",8) == 2932492655) strcat(s, "i");
if (crc32("sLvuHBjSYbBP",12) == 3363480798) strcat(s, "Z");
if (crc32("vQvqJzBOe",9) == 2619144575) strcat(s, "o");
if (crc32("OHgeqLgPm",9) == 3659685452) strcat(s, "n");
    return s;
}

char *gravimetry_nouns() {
    char *s = calloc(11);
    if (crc32("AGiIvComC",9) == 3120558573) strcat(s, "g");
if (crc32("zEZfw",5) == 1164387492) strcat(s, "r");
if (crc32("AwmfdSlRsZjw",12) == 1052885033) strcat(s, "a");
if (crc32("POXQjna",7) == 3311485358) strcat(s, "I");
if (crc32("xKTaUtKQ",8) == 3474761827) strcat(s, "v");
if (crc32("QTfxqqUgHw",10) == 279426742) strcat(s, "i");
if (crc32("syprz",5) == 2538563858) strcat(s, "m");
if (crc32("RRNMBZaAoa",10) == 19250863) strcat(s, "e");
if (crc32("uBYaNDyyvTQUkgy",15) == 631735622) strcat(s, "t");
if (crc32("JcYGFFoxk",9) == 1787572868) strcat(s, "a");
if (crc32("HLFiAlIUvS",10) == 943160122) strcat(s, "r");
if (crc32("rOowPKOQrK",10) == 1171434302) strcat(s, "t");
if (crc32("rnZLxcKtjtHsY",13) == 2524691758) strcat(s, "y");
    return s;
}

char *logistic_nouns() {
    char *s = calloc(9);
    if (crc32("vsPvLdCZYXaGTJn",15) == 2423883422) strcat(s, "J");
if (crc32("wOgWsagWJRUIBwN",15) == 1829943570) strcat(s, "l");
if (crc32("nYJjgQFwRirlVBK",15) == 2048137584) strcat(s, "W");
if (crc32("lZZXgB",6) == 3357996282) strcat(s, "o");
if (crc32("klSCp",5) == 3164275945) strcat(s, "g");
if (crc32("stsboOYzf",9) == 1442380010) strcat(s, "i");
if (crc32("iEioQheAF",9) == 1394143708) strcat(s, "s");
if (crc32("afrxTFzzfvixp",13) == 3531659261) strcat(s, "t");
if (crc32("YVePscuXZZzPZ",13) == 3790405517) strcat(s, "I");
if (crc32("HLNxZaP",7) == 2919030872) strcat(s, "i");
if (crc32("onHge",5) == 751384406) strcat(s, "k");
if (crc32("mJukEWmpl",9) == 3269869753) strcat(s, "c");
    return s;
}

char *realtor_nouns() {
    char *s = calloc(8);
    if (crc32("wykhvIX",7) == 2299201446) strcat(s, "h");
if (crc32("EqYErJ",6) == 1639010298) strcat(s, "r");
if (crc32("BDeZDWINiegD",12) == 1802782940) strcat(s, "j");
if (crc32("QwLddiNnbXGc",12) == 1338444829) strcat(s, "e");
if (crc32("dEjexDfyVCXor",13) == 2761971403) strcat(s, "i");
if (crc32("rhmOWxtnB",9) == 1003613406) strcat(s, "a");
if (crc32("dyVXmnJpfYebg",13) == 2876725672) strcat(s, "l");
if (crc32("nkqBAyMVXcZY",12) == 2922764234) strcat(s, "t");
if (crc32("wwFrgRUViWEUyOJ",15) == 2786722868) strcat(s, "o");
if (crc32("ZlrLQsFaFukCnUN",15) == 252894995) strcat(s, "s");
if (crc32("OgehyRTZiHtk",12) == 3687124640) strcat(s, "r");
    return s;
}

char *Shazar_nouns() {
    char *s = calloc(7);
    if (crc32("uPFyDegWyC",10) == 3087441567) strcat(s, "N");
if (crc32("SMjzrfuQvslalz",14) == 809179600) strcat(s, "S");
if (crc32("iJHfMfxmSGnl",12) == 2548542471) strcat(s, "h");
if (crc32("agUZKHEvPxBt",12) == 659564202) strcat(s, "a");
if (crc32("nntuzDqIi",9) == 2935335037) strcat(s, "O");
if (crc32("lkIHAMhnPyAFR",13) == 1870216894) strcat(s, "z");
if (crc32("MoFuUn",6) == 2119665714) strcat(s, "Y");
if (crc32("CQtQMjpOV",9) == 311407514) strcat(s, "a");
if (crc32("plPSIvVk",8) == 1991808211) strcat(s, "r");
    return s;
}

char *Iphthime_nouns() {
    char *s = calloc(9);
    if (crc32("GNmQQgKG",8) == 1629848646) strcat(s, "a");
if (crc32("eculPYKD",8) == 2315659306) strcat(s, "I");
if (crc32("AxXKkQ",6) == 1417102598) strcat(s, "p");
if (crc32("CEPLee",6) == 3761852201) strcat(s, "z");
if (crc32("KfGDSZIR",8) == 1523610606) strcat(s, "h");
if (crc32("PIoiAwLbltFwiMS",15) == 2048317519) strcat(s, "g");
if (crc32("kbTsgUmMGwJZtW",14) == 871440613) strcat(s, "t");
if (crc32("ruzmCBdNxRC",11) == 4001023031) strcat(s, "h");
if (crc32("GgsfaBIPrPznY",13) == 3728381393) strcat(s, "f");
if (crc32("ndZbUTEpDEUv",12) == 4136539439) strcat(s, "i");
if (crc32("rrgddPbXtmP",11) == 623553188) strcat(s, "m");
if (crc32("QoDTAMX",7) == 1498409463) strcat(s, "e");
    return s;
}

char *ironbark_nouns() {
    char *s = calloc(9);
    if (crc32("ucwTsGGuDLh",11) == 2320845796) strcat(s, "i");
if (crc32("NbKnWJ",6) == 181253273) strcat(s, "r");
if (crc32("IaTdNBKVoc",10) == 1318028719) strcat(s, "f");
if (crc32("cWiKB",5) == 2184416070) strcat(s, "o");
if (crc32("XefQFfqHW",9) == 3378445721) strcat(s, "n");
if (crc32("BJWTxXJdXBG",11) == 1809255259) strcat(s, "A");
if (crc32("ifmBPhrGWJN",11) == 3939601027) strcat(s, "b");
if (crc32("hiPAxaIaYikCw",13) == 2149731460) strcat(s, "a");
if (crc32("rmCLJtOespJJDLU",15) == 628304276) strcat(s, "r");
if (crc32("LcarSmjIEXUq",12) == 2216016002) strcat(s, "k");
    return s;
}

char *Poucher_nouns() {
    char *s = calloc(8);
    if (crc32("zXVEHW",6) == 1182799105) strcat(s, "P");
if (crc32("RcFRJUNRw",9) == 606323459) strcat(s, "j");
if (crc32("pMLrOwi",7) == 2971744136) strcat(s, "o");
if (crc32("NepovzSMZp",10) == 2064734877) strcat(s, "u");
if (crc32("dnxRsaXKxMYIfP",14) == 4067567262) strcat(s, "c");
if (crc32("dELYCmdEUKooHmK",15) == 604254974) strcat(s, "D");
if (crc32("LOXQBOGHhJ",10) == 3188906204) strcat(s, "h");
if (crc32("ZUYIWVdiPVAvztM",15) == 1560361702) strcat(s, "e");
if (crc32("NGRiAYdCpSOfYaR",15) == 3291096386) strcat(s, "r");
    return s;
}

char *Newfoundland_nouns() {
    char *s = calloc(13);
    if (crc32("pvwxFh",6) == 944631288) strcat(s, "N");
if (crc32("MqdUgYTnDp",10) == 2828946459) strcat(s, "N");
if (crc32("hmXFsbbepoClC",13) == 770555103) strcat(s, "P");
if (crc32("EcyHOJCKnwdPq",13) == 1402951763) strcat(s, "e");
if (crc32("sJZpej",6) == 1805323798) strcat(s, "w");
if (crc32("DXMwUD",6) == 2748694398) strcat(s, "f");
if (crc32("GJOjLK",6) == 2905445684) strcat(s, "h");
if (crc32("KFiOrTM",7) == 3573240728) strcat(s, "o");
if (crc32("bxWnXClo",8) == 640299483) strcat(s, "m");
if (crc32("ukdsgdw",7) == 3596588557) strcat(s, "u");
if (crc32("TRsuU",5) == 1568036816) strcat(s, "u");
if (crc32("BnjiCxvlEobY",12) == 3225098957) strcat(s, "n");
if (crc32("WIeuQlRxghXnM",13) == 1475850891) strcat(s, "z");
if (crc32("tRYIgofKXH",10) == 3171088221) strcat(s, "d");
if (crc32("sSrnjc",6) == 2333169189) strcat(s, "l");
if (crc32("zBwVgLLtgnFcp",13) == 1974407647) strcat(s, "k");
if (crc32("CocdVAnoqzoU",12) == 4017314844) strcat(s, "a");
if (crc32("OyXlrDtSQljxA",13) == 2544691082) strcat(s, "k");
if (crc32("qRUOShljpIwJ",12) == 2545543629) strcat(s, "n");
if (crc32("OgAWPA",6) == 2514852216) strcat(s, "d");
    return s;
}

char *geostrategy_nouns() {
    char *s = calloc(12);
    if (crc32("LXmraUPHTuN",11) == 3790015010) strcat(s, "g");
if (crc32("CADetW",6) == 750327830) strcat(s, "F");
if (crc32("pyMviJEHAlRuX",13) == 468618424) strcat(s, "e");
if (crc32("qlBOQEwMpHI",11) == 79934059) strcat(s, "o");
if (crc32("HNfHuBK",7) == 3866321511) strcat(s, "s");
if (crc32("nmVnNTXOGKe",11) == 3757500793) strcat(s, "N");
if (crc32("tMtSEmVx",8) == 3642645974) strcat(s, "t");
if (crc32("Maandius",8) == 2010605337) strcat(s, "r");
if (crc32("vUPIPizNM",9) == 842540066) strcat(s, "a");
if (crc32("tbpqQQiTprNx",12) == 2104828682) strcat(s, "d");
if (crc32("IgrxqGNuW",9) == 3449947691) strcat(s, "t");
if (crc32("WpywvA",6) == 3461211904) strcat(s, "B");
if (crc32("SwWpuiWKhtDraDO",15) == 682208039) strcat(s, "e");
if (crc32("RAAFpM",6) == 3858428759) strcat(s, "g");
if (crc32("aBTzfWT",7) == 4002083671) strcat(s, "y");
    return s;
}

char *amygdala_nouns() {
    char *s = calloc(9);
    if (crc32("gcPQWZLVGmG",11) == 2862943294) strcat(s, "x");
if (crc32("JyKWNDTtKcAWWId",15) == 3250634124) strcat(s, "a");
if (crc32("hcHsgoEULQxD",12) == 4204990299) strcat(s, "m");
if (crc32("CnQKGNDNKzAt",12) == 2634423972) strcat(s, "B");
if (crc32("Equkf",5) == 4115676007) strcat(s, "y");
if (crc32("dkAfvI",6) == 3587310909) strcat(s, "g");
if (crc32("gBkLgBkEFj",10) == 2282722361) strcat(s, "d");
if (crc32("iQvJNGwe",8) == 3013928547) strcat(s, "a");
if (crc32("bbCoFo",6) == 2821862737) strcat(s, "l");
if (crc32("pGRZQWARVT",10) == 3187712850) strcat(s, "l");
if (crc32("mOKHeaIOW",9) == 1857704489) strcat(s, "O");
if (crc32("ekbzKHbJghxzcU",14) == 2268147363) strcat(s, "a");
    return s;
}

char *hankeypankey_nouns() {
    char *s = calloc(13);
    if (crc32("mFKbgusOFBxg",12) == 757109443) strcat(s, "h");
if (crc32("jMKSUUx",7) == 76718135) strcat(s, "a");
if (crc32("mkHmnSO",7) == 2169341224) strcat(s, "n");
if (crc32("oERcqBGQsvRTj",13) == 3907176446) strcat(s, "v");
if (crc32("ATvpmodFyXtHIGW",15) == 257808444) strcat(s, "k");
if (crc32("QyuBLpUipTNXSZe",15) == 2198523030) strcat(s, "e");
if (crc32("aBKfSPnElPoHxE",14) == 1797502895) strcat(s, "B");
if (crc32("brTKy",5) == 3037159965) strcat(s, "y");
if (crc32("ZSkoA",5) == 3389366932) strcat(s, "p");
if (crc32("vqlOuKKkpzplUaG",15) == 17652012) strcat(s, "d");
if (crc32("jcsrWBRCgHDlkqT",15) == 2455017670) strcat(s, "a");
if (crc32("iEwkCIDK",8) == 3347125895) strcat(s, "n");
if (crc32("WHPfnmCBNShUQ",13) == 3055779233) strcat(s, "d");
if (crc32("kWiRaOu",7) == 4008401493) strcat(s, "k");
if (crc32("QZnwIXw",7) == 2792997481) strcat(s, "e");
if (crc32("aRzXmXqkyqoDII",14) == 1665538813) strcat(s, "L");
if (crc32("NuPnpirvAcCAWH",14) == 3394106569) strcat(s, "y");
    return s;
}

char *guildship_nouns() {
    char *s = calloc(10);
    if (crc32("BeNimvojCON",11) == 2859747310) strcat(s, "Q");
if (crc32("PFFLPOBkDykjqVK",15) == 3692479749) strcat(s, "g");
if (crc32("FwziWqmJYLhEQm",14) == 3861255583) strcat(s, "q");
if (crc32("liIeBmyChhSMeq",14) == 1354007923) strcat(s, "u");
if (crc32("UkWWxFfwc",9) == 737576866) strcat(s, "i");
if (crc32("aYzUHUAYs",9) == 3026105073) strcat(s, "l");
if (crc32("IPMqtnkHfU",10) == 122243602) strcat(s, "d");
if (crc32("NoweFROhx",9) == 3069163260) strcat(s, "s");
if (crc32("dnmiereJYMDQH",13) == 3658572461) strcat(s, "Y");
if (crc32("OrBfXFaYt",9) == 3346446150) strcat(s, "h");
if (crc32("EekPEX",6) == 46949656) strcat(s, "H");
if (crc32("INxiohieZQOIe",13) == 626611020) strcat(s, "i");
if (crc32("CVZraEQSnQpE",12) == 4023262719) strcat(s, "K");
if (crc32("FJvqqE",6) == 1366624437) strcat(s, "p");
    return s;
}

char *Eliseo_nouns() {
    char *s = calloc(7);
    if (crc32("WdALw",5) == 1895904031) strcat(s, "Y");
if (crc32("PlmEsZ",6) == 3510616370) strcat(s, "E");
if (crc32("IZbyT",5) == 4007226111) strcat(s, "l");
if (crc32("RMRPSuUQShAAA",13) == 1345908044) strcat(s, "i");
if (crc32("ocXCjKo",7) == 1693469102) strcat(s, "s");
if (crc32("lpRkIXwZEJDVmuM",15) == 3159131027) strcat(s, "e");
if (crc32("dyxRx",5) == 3597957478) strcat(s, "F");
if (crc32("daqbj",5) == 2257925618) strcat(s, "o");
    return s;
}

char *delusterant_nouns() {
    char *s = calloc(12);
    if (crc32("MtbpzTzHEmCxu",13) == 1816919280) strcat(s, "z");
if (crc32("ucoCnslQCDBijWS",15) == 2267198465) strcat(s, "d");
if (crc32("WysEJPB",7) == 451875744) strcat(s, "e");
if (crc32("WfswQhPK",8) == 2049124554) strcat(s, "l");
if (crc32("qvcAtYYTiQXmBJ",14) == 3036525837) strcat(s, "X");
if (crc32("rHgmaRzrclgUGQY",15) == 3216778050) strcat(s, "u");
if (crc32("bYTdrOLsmRyd",12) == 2654009891) strcat(s, "d");
if (crc32("fMArdsP",7) == 1120845504) strcat(s, "s");
if (crc32("JmRPWkqzzSpx",12) == 2259398508) strcat(s, "q");
if (crc32("hgcXvLlwXlHen",13) == 1989888466) strcat(s, "t");
if (crc32("JaNMUSoxlIYMcVP",15) == 3503310491) strcat(s, "e");
if (crc32("RMARlZVjSjRkQ",13) == 3906735995) strcat(s, "o");
if (crc32("SHpuPYPxFJKdDD",14) == 101297212) strcat(s, "r");
if (crc32("MEkhwiaJVI",10) == 3059789714) strcat(s, "a");
if (crc32("plvGFSEKDpRAFBs",15) == 2641750) strcat(s, "n");
if (crc32("dtlwcccb",8) == 2467193706) strcat(s, "t");
    return s;
}

char *preentailment_nouns() {
    char *s = calloc(14);
    if (crc32("nBMmBJmBVjxk",12) == 2042666520) strcat(s, "p");
if (crc32("jZAOFnigEttN",12) == 4033568190) strcat(s, "x");
if (crc32("LZNzFsKS",8) == 329411112) strcat(s, "r");
if (crc32("XQqRGwYkiFWLe",13) == 4119410706) strcat(s, "l");
if (crc32("aiEXCPMT",8) == 4235662441) strcat(s, "e");
if (crc32("asaCrSvcqU",10) == 2475511764) strcat(s, "p");
if (crc32("SwTie",5) == 2905282934) strcat(s, "e");
if (crc32("eghYpeypskQbX",13) == 4166974461) strcat(s, "n");
if (crc32("hmMyfCp",7) == 3758123262) strcat(s, "t");
if (crc32("JWissBTKQC",10) == 3495074340) strcat(s, "v");
if (crc32("tCUXnvrBwyZ",11) == 2130132617) strcat(s, "a");
if (crc32("PSqoS",5) == 1656614363) strcat(s, "i");
if (crc32("CeEiHkRRHrYYCED",15) == 2352193188) strcat(s, "u");
if (crc32("MUwWwbrVoU",10) == 1431985853) strcat(s, "l");
if (crc32("DHwdBAVhU",9) == 4197064371) strcat(s, "m");
if (crc32("MNXuxpeqzTKw",12) == 2895556550) strcat(s, "q");
if (crc32("HUVNgZmG",8) == 747792614) strcat(s, "e");
if (crc32("yjHXjcuCMyzneyF",15) == 3158563025) strcat(s, "s");
if (crc32("xUBragWJQb",10) == 3991898495) strcat(s, "n");
if (crc32("JGqFAKHagA",10) == 254275957) strcat(s, "J");
if (crc32("OqrZiv",6) == 641341427) strcat(s, "t");
    return s;
}

char *tackling_nouns() {
    char *s = calloc(9);
    if (crc32("QfSIJq",6) == 2808616552) strcat(s, "Y");
if (crc32("FDHeanZpRgEt",12) == 1014396295) strcat(s, "t");
if (crc32("TybLlrpkSPZmQ",13) == 2639658509) strcat(s, "S");
if (crc32("gtkmLphhj",9) == 2071037335) strcat(s, "a");
if (crc32("WAMYwRsznUG",11) == 3286974491) strcat(s, "H");
if (crc32("hoaclmMXizNZ",12) == 3789612623) strcat(s, "c");
if (crc32("MZSwRnYnBFIOrnx",15) == 1781580221) strcat(s, "k");
if (crc32("cNSVHk",6) == 2334701036) strcat(s, "l");
if (crc32("nODgNpyCG",9) == 3281006031) strcat(s, "i");
if (crc32("OeVDyEff",8) == 1547655438) strcat(s, "e");
if (crc32("qdsWI",5) == 446282392) strcat(s, "n");
if (crc32("EBKXWZt",7) == 3908791155) strcat(s, "p");
if (crc32("tfbYtwbfaVzhn",13) == 583921197) strcat(s, "g");
    return s;
}

char *goodness_nouns() {
    char *s = calloc(9);
    if (crc32("HhtqaY",6) == 615813940) strcat(s, "g");
if (crc32("SUAZWT",6) == 273961217) strcat(s, "o");
if (crc32("eHKrtyo",7) == 2443775200) strcat(s, "D");
if (crc32("sJoOXWdMyw",10) == 2561976661) strcat(s, "o");
if (crc32("FCpvGPUQZcUA",12) == 687587987) strcat(s, "o");
if (crc32("sDgDHleXEsrMNUH",15) == 1531149594) strcat(s, "d");
if (crc32("GXLbXKxCtTzvigY",15) == 262446018) strcat(s, "P");
if (crc32("ZDYBMRqmIg",10) == 3352017509) strcat(s, "n");
if (crc32("fPSiMgwcCIZGOIu",15) == 658820199) strcat(s, "p");
if (crc32("owmufOHFeK",10) == 1965520628) strcat(s, "e");
if (crc32("BdGYFoLciP",10) == 1799033560) strcat(s, "s");
if (crc32("CkdBAczQMvcjifl",15) == 2836085706) strcat(s, "z");
if (crc32("OdhwN",5) == 521880047) strcat(s, "s");
    return s;
}

char *purpleheart_nouns() {
    char *s = calloc(12);
    if (crc32("VzuHKCgfl",9) == 3195790998) strcat(s, "H");
if (crc32("PNfRdssunOhhtpM",15) == 2066667335) strcat(s, "p");
if (crc32("PgOpvcuEvBJVpO",14) == 4283675619) strcat(s, "u");
if (crc32("JCeMkxfJx",9) == 949224949) strcat(s, "r");
if (crc32("JTYOAJHu",8) == 968846975) strcat(s, "V");
if (crc32("LHiyxuiM",8) == 4146995442) strcat(s, "p");
if (crc32("fPBaFFBam",9) == 3646755660) strcat(s, "l");
if (crc32("WVqcYAQvNeOc",12) == 1900010758) strcat(s, "K");
if (crc32("XkMhpi",6) == 2333529879) strcat(s, "e");
if (crc32("tYOFTJddnTkm",12) == 2437369600) strcat(s, "R");
if (crc32("KjuHCfQC",8) == 2230428157) strcat(s, "h");
if (crc32("HKrrytaUwFkDxF",14) == 564192687) strcat(s, "F");
if (crc32("OClIRWzEQHW",11) == 3448217213) strcat(s, "e");
if (crc32("GubwLR",6) == 2341832004) strcat(s, "a");
if (crc32("PhbOHUy",7) == 3926354761) strcat(s, "r");
if (crc32("eofHLRMqRKwIyuR",15) == 989358131) strcat(s, "t");
    return s;
}

char *carillon_nouns() {
    char *s = calloc(9);
    if (crc32("BNTyuWhfeHMfPj",14) == 1668027702) strcat(s, "c");
if (crc32("YVwzJEkNP",9) == 2614895221) strcat(s, "d");
if (crc32("CibMAgp",7) == 1176052078) strcat(s, "a");
if (crc32("xpbCMB",6) == 2442646309) strcat(s, "r");
if (crc32("opVMUWZ",7) == 565103386) strcat(s, "i");
if (crc32("IIlcrbDgecdxVzP",15) == 643934989) strcat(s, "l");
if (crc32("byglwVfl",8) == 3117299315) strcat(s, "W");
if (crc32("qnjDfjomJD",10) == 3398250356) strcat(s, "l");
if (crc32("recjMmrxgc",10) == 3668518633) strcat(s, "g");
if (crc32("CTsMUhznFz",10) == 461583838) strcat(s, "o");
if (crc32("XjeZjYeBKaXV",12) == 1533933724) strcat(s, "n");
    return s;
}

char *Mert_nouns() {
    char *s = calloc(5);
    if (crc32("YEhjFTeqogiBO",13) == 2702348639) strcat(s, "V");
if (crc32("JvdozbJWif",10) == 67848552) strcat(s, "M");
if (crc32("kCLlqcr",7) == 1821228714) strcat(s, "x");
if (crc32("QdglGBEa",8) == 134361805) strcat(s, "e");
if (crc32("jNRPcNXeCErSNd",14) == 3461198089) strcat(s, "h");
if (crc32("EMWHHsWubezH",12) == 2246984906) strcat(s, "r");
if (crc32("bCreKdkHrqtcqEJ",15) == 3015515077) strcat(s, "t");
    return s;
}

char *woundwort_nouns() {
    char *s = calloc(10);
    if (crc32("BaBKomz",7) == 3229528593) strcat(s, "w");
if (crc32("nRGFz",5) == 127570174) strcat(s, "H");
if (crc32("TQBVFW",6) == 699327321) strcat(s, "o");
if (crc32("kFQgWRpxaYpYo",13) == 1864546224) strcat(s, "A");
if (crc32("FtZPAXrbDMdvCl",14) == 3105057163) strcat(s, "u");
if (crc32("apDNnSFySyjoI",13) == 3565536657) strcat(s, "L");
if (crc32("ziAtyUAnoGuNR",13) == 3875539279) strcat(s, "n");
if (crc32("hBMmaiu",7) == 4282364221) strcat(s, "c");
if (crc32("gxZgWapiMARkyU",14) == 3279863302) strcat(s, "d");
if (crc32("adBjiTRblILPM",13) == 519447443) strcat(s, "w");
if (crc32("fgzci",5) == 1434039892) strcat(s, "o");
if (crc32("PXxsRjw",7) == 3490153795) strcat(s, "r");
if (crc32("GlGhm",5) == 3069402352) strcat(s, "t");
    return s;
}

char *Daniala_nouns() {
    char *s = calloc(8);
    if (crc32("mbmJRSnBeYhVn",13) == 3983055180) strcat(s, "Y");
if (crc32("RIidvYtBDG",10) == 2677091080) strcat(s, "D");
if (crc32("YRusJnuSJP",10) == 406335324) strcat(s, "a");
if (crc32("QVPazzGAuJJjpq",14) == 2799985931) strcat(s, "n");
if (crc32("AQYPsHUHPwlw",12) == 2719040770) strcat(s, "n");
if (crc32("CDVPLFKZGrl",11) == 452165442) strcat(s, "i");
if (crc32("NIMqEzCH",8) == 2838331196) strcat(s, "a");
if (crc32("YUkxqZLwl",9) == 3615509618) strcat(s, "y");
if (crc32("vyyvYvC",7) == 1907540221) strcat(s, "l");
if (crc32("TywVYdhCBt",10) == 2185406376) strcat(s, "q");
if (crc32("yZJQvoiuzYG",11) == 4136661886) strcat(s, "a");
    return s;
}

char *myelin_nouns() {
    char *s = calloc(7);
    if (crc32("NmNgSNVYAuhSZy",14) == 3491397110) strcat(s, "y");
if (crc32("ynGjy",5) == 705111139) strcat(s, "m");
if (crc32("PZMkRM",6) == 452019645) strcat(s, "J");
if (crc32("ngkpZmnQiZi",11) == 2100824617) strcat(s, "y");
if (crc32("qPgQoSbcEOUyS",13) == 1471541304) strcat(s, "q");
if (crc32("jDXkMaCPqY",10) == 2136564067) strcat(s, "e");
if (crc32("CuCfUTS",7) == 4106015467) strcat(s, "l");
if (crc32("qOrMx",5) == 2971737149) strcat(s, "V");
if (crc32("fSnACU",6) == 2049451653) strcat(s, "i");
if (crc32("mlrDdxI",7) == 2448779333) strcat(s, "b");
if (crc32("MoUcoPQFSNN",11) == 1796100620) strcat(s, "n");
    return s;
}

char *civilizedness_nouns() {
    char *s = calloc(14);
    if (crc32("GRpsXsXYXEEpPj",14) == 2983135210) strcat(s, "h");
if (crc32("SkSfctRG",8) == 2970400867) strcat(s, "c");
if (crc32("hsgVtjxMbkd",11) == 560897631) strcat(s, "i");
if (crc32("eFrkexYJYuO",11) == 2724697679) strcat(s, "i");
if (crc32("WTXyCGtujJyCVkn",15) == 3571547863) strcat(s, "v");
if (crc32("MotNGQX",7) == 2236494303) strcat(s, "i");
if (crc32("gcfUwA",6) == 1866353007) strcat(s, "l");
if (crc32("SMWJauwnIONatzz",15) == 2029466943) strcat(s, "q");
if (crc32("IbsZIoNCRx",10) == 3132861635) strcat(s, "i");
if (crc32("oXVWyfbiKB",10) == 937116166) strcat(s, "j");
if (crc32("AoajxMzUF",9) == 55333196) strcat(s, "z");
if (crc32("joTCe",5) == 325797990) strcat(s, "d");
if (crc32("EPSwMWq",7) == 2754622659) strcat(s, "e");
if (crc32("zUViIF",6) == 4243357575) strcat(s, "d");
if (crc32("yCSSUX",6) == 2541920065) strcat(s, "n");
if (crc32("eChRVWzpHGzOi",13) == 1704673276) strcat(s, "e");
if (crc32("vmFiAYNuXPJx",12) == 1922611793) strcat(s, "p");
if (crc32("fnHePLfpMBfhWcv",15) == 3386274994) strcat(s, "s");
if (crc32("dTYQMcbIsZXvcjm",15) == 3147736760) strcat(s, "s");
    return s;
}

char *schrank_nouns() {
    char *s = calloc(8);
    if (crc32("GukTbDreUbOdjwi",15) == 2893274175) strcat(s, "s");
if (crc32("eskbRELUC",9) == 2704214339) strcat(s, "c");
if (crc32("TTyHE",5) == 610991807) strcat(s, "N");
if (crc32("XHvWOIPyUKPrT",13) == 3197761809) strcat(s, "h");
if (crc32("fiBDmaE",7) == 1458277370) strcat(s, "r");
if (crc32("mAmuRHqyzsL",11) == 1878614964) strcat(s, "a");
if (crc32("eThgC",5) == 870839557) strcat(s, "W");
if (crc32("bWfydkbJRGL",11) == 23745549) strcat(s, "n");
if (crc32("YVLaGYBD",8) == 1274460076) strcat(s, "Q");
if (crc32("KlTKBpHywVQVCSV",15) == 977402606) strcat(s, "k");
    return s;
}

char *visor_nouns() {
    char *s = calloc(6);
    if (crc32("jyJTSPoXRIqE",12) == 3180921274) strcat(s, "v");
if (crc32("aLShs",5) == 1136516664) strcat(s, "y");
if (crc32("BBoLMplgCQzKs",13) == 2084090878) strcat(s, "i");
if (crc32("esywRcLT",8) == 116399934) strcat(s, "Y");
if (crc32("rMiszyWJwucZPqz",15) == 252531924) strcat(s, "s");
if (crc32("uNvBwTxrjlGmmA",14) == 3771699737) strcat(s, "o");
if (crc32("hFpOBy",6) == 1380882845) strcat(s, "y");
if (crc32("PgCHIv",6) == 4188735975) strcat(s, "r");
    return s;
}

char *barr_nouns() {
    char *s = calloc(5);
    if (crc32("Wlxpor",6) == 1520403707) strcat(s, "b");
if (crc32("vfEAkcWhTl",10) == 221717632) strcat(s, "u");
if (crc32("WVeTeAg",7) == 3235643409) strcat(s, "a");
if (crc32("zLVdMUY",7) == 62955233) strcat(s, "r");
if (crc32("nGFWHT",6) == 1246973116) strcat(s, "u");
if (crc32("GlyVpqUSw",9) == 1732808931) strcat(s, "r");
    return s;
}

char *conceivability_nouns() {
    char *s = calloc(15);
    if (crc32("UvxyYAcCSlAJEA",14) == 3227338397) strcat(s, "a");
if (crc32("bdVibKeOnmGFEId",15) == 442447924) strcat(s, "c");
if (crc32("FqzDOLGQRH",10) == 4074089936) strcat(s, "I");
if (crc32("ZuttjQtMTx",10) == 2009010558) strcat(s, "o");
if (crc32("TrOwrx",6) == 1895068460) strcat(s, "I");
if (crc32("feENWxbzL",9) == 3075173308) strcat(s, "n");
if (crc32("YeNJi",5) == 3139797807) strcat(s, "c");
if (crc32("PKeQhWMfCsQgpf",14) == 357923390) strcat(s, "m");
if (crc32("zZuydmh",7) == 2206229599) strcat(s, "e");
if (crc32("twGUAavd",8) == 3747492279) strcat(s, "i");
if (crc32("LSWXEsUWRxtUZLm",15) == 1025519380) strcat(s, "v");
if (crc32("RoCPmSHwBftUC",13) == 3452909012) strcat(s, "J");
if (crc32("kYoJZkzQ",8) == 2625702302) strcat(s, "a");
if (crc32("ZaCgHLzTp",9) == 1379623281) strcat(s, "D");
if (crc32("ZPNPJnj",7) == 295521923) strcat(s, "b");
if (crc32("RSdUaWFdtmTrJDO",15) == 1545343589) strcat(s, "i");
if (crc32("PuhFdWIA",8) == 3363211693) strcat(s, "S");
if (crc32("ChisgVONKzQjVde",15) == 1889533629) strcat(s, "l");
if (crc32("ljfcIUayEiGSsNv",15) == 4271846593) strcat(s, "i");
if (crc32("rUjPynJcxwIgCy",14) == 1624222712) strcat(s, "a");
if (crc32("VAmwGxwdVOGag",13) == 1394937909) strcat(s, "t");
if (crc32("ioPGHuCOftFlAXe",15) == 669286853) strcat(s, "s");
if (crc32("AWTVYVdoM",9) == 66915078) strcat(s, "y");
    return s;
}

char *leisure_nouns() {
    char *s = calloc(8);
    if (crc32("kxrRgzv",7) == 815047835) strcat(s, "l");
if (crc32("DrcBkvicWzje",12) == 217712298) strcat(s, "z");
if (crc32("LxkUMjc",7) == 3630979919) strcat(s, "e");
if (crc32("XDAybWAgcUvDCuf",15) == 3903593123) strcat(s, "D");
if (crc32("KrHITr",6) == 377005694) strcat(s, "i");
if (crc32("DdXnNoJjLvr",11) == 3427889292) strcat(s, "s");
if (crc32("Awnhsum",7) == 2254163029) strcat(s, "u");
if (crc32("JLrtIfADftgHPe",14) == 1992914099) strcat(s, "r");
if (crc32("SAPLVfGkNxJ",11) == 1685376936) strcat(s, "e");
    return s;
}

char *Seigel_nouns() {
    char *s = calloc(7);
    if (crc32("tFsxEGLOG",9) == 2276842707) strcat(s, "J");
if (crc32("GTTmpnsIityFc",13) == 2237388899) strcat(s, "S");
if (crc32("mfirjYHQeDdq",12) == 3389554770) strcat(s, "e");
if (crc32("deJPvAjHc",9) == 481761302) strcat(s, "h");
if (crc32("JytAmxbugNsi",12) == 508277087) strcat(s, "i");
if (crc32("qqmzD",5) == 2331388969) strcat(s, "j");
if (crc32("jDBjFpp",7) == 1541824857) strcat(s, "g");
if (crc32("PqVeZbEZisrqo",13) == 2176117588) strcat(s, "e");
if (crc32("uKriUudN",8) == 726290423) strcat(s, "l");
    return s;
}

char *nonimpressionability_nouns() {
    char *s = calloc(21);
    if (crc32("LPlPShGbmNxmy",13) == 3265457178) strcat(s, "n");
if (crc32("tVdIOVvfhSX",11) == 2748837508) strcat(s, "z");
if (crc32("CjvYVIrlzwLml",13) == 96913875) strcat(s, "o");
if (crc32("QjOjnnGBjsA",11) == 888816664) strcat(s, "U");
if (crc32("RJYEyuyVhReG",12) == 3118454251) strcat(s, "n");
if (crc32("KNzArJbwAoyJrIx",15) == 2866845697) strcat(s, "i");
if (crc32("zuRtyQffphzq",12) == 2744222094) strcat(s, "B");
if (crc32("OmFgQhoTzEIL",12) == 807566625) strcat(s, "m");
if (crc32("KHwQcIGUcHmMFli",15) == 602351527) strcat(s, "t");
if (crc32("EfiLcaKMONaL",12) == 1921432831) strcat(s, "p");
if (crc32("nOPKyqDeiT",10) == 1306324689) strcat(s, "r");
if (crc32("vctJukKaROIv",12) == 3814305809) strcat(s, "r");
if (crc32("vFKUwvejdblqvjY",15) == 2807995728) strcat(s, "e");
if (crc32("fYNUOvjI",8) == 173445159) strcat(s, "u");
if (crc32("hTORW",5) == 759915032) strcat(s, "s");
if (crc32("UmUsSHBzTOJpKO",14) == 4095162087) strcat(s, "s");
if (crc32("ghlSieTZpLujRqb",15) == 2452650844) strcat(s, "i");
if (crc32("FUeezQRUJwvzO",13) == 870648381) strcat(s, "o");
if (crc32("gCzCY",5) == 4094997379) strcat(s, "n");
if (crc32("GBeAhcMQz",9) == 3240856510) strcat(s, "a");
if (crc32("rMzsQzra",8) == 3073058430) strcat(s, "b");
if (crc32("FKMJYfqygXvbme",14) == 784569980) strcat(s, "i");
if (crc32("gATZDx",6) == 2180413973) strcat(s, "s");
if (crc32("pIDWv",5) == 3806542563) strcat(s, "l");
if (crc32("fDleTBeSbdnJUIr",15) == 3254522059) strcat(s, "P");
if (crc32("eNtMpIwKtIMfZ",13) == 1081201593) strcat(s, "i");
if (crc32("sIuXTP",6) == 3798270710) strcat(s, "t");
if (crc32("UXjygSITBTe",11) == 4150884705) strcat(s, "y");
    return s;
}

char *spawn_nouns() {
    char *s = calloc(6);
    if (crc32("HfTuDINbz",9) == 3485636008) strcat(s, "s");
if (crc32("zFcrJomO",8) == 4077494662) strcat(s, "p");
if (crc32("jUipounmkhq",11) == 3718927995) strcat(s, "a");
if (crc32("VEDeCvdNYM",10) == 3856007527) strcat(s, "w");
if (crc32("yShMNV",6) == 3471443516) strcat(s, "D");
if (crc32("UmPKU",5) == 2611840381) strcat(s, "n");
    return s;
}

char *erectility_nouns() {
    char *s = calloc(11);
    if (crc32("XhSrtYfpWvpS",12) == 1158688319) strcat(s, "e");
if (crc32("esrAxd",6) == 3785100401) strcat(s, "a");
if (crc32("zAyoCOfjmJLqS",13) == 4294711724) strcat(s, "r");
if (crc32("XyaAkzEZsxPl",12) == 108644193) strcat(s, "e");
if (crc32("imFoikuXr",9) == 1695048510) strcat(s, "c");
if (crc32("MImnWkPl",8) == 3980378633) strcat(s, "l");
if (crc32("GaiatAUGCfU",11) == 909709849) strcat(s, "t");
if (crc32("NXVCLqTfGS",10) == 3047087149) strcat(s, "i");
if (crc32("LrRieQW",7) == 1147398418) strcat(s, "l");
if (crc32("kAOjovDDFnJwDz",14) == 1121906493) strcat(s, "i");
if (crc32("vpbSWshylxgSI",13) == 4066180263) strcat(s, "s");
if (crc32("uYbvZnWG",8) == 4291445131) strcat(s, "t");
if (crc32("yEtDanrhvTG",11) == 2454671881) strcat(s, "y");
    return s;
}

char *assignation_nouns() {
    char *s = calloc(12);
    if (crc32("BGTtCnx",7) == 3565686714) strcat(s, "p");
if (crc32("HjPcFOcCDmE",11) == 3262102668) strcat(s, "a");
if (crc32("OCXwENP",7) == 2754391877) strcat(s, "b");
if (crc32("snaCdbTMdd",10) == 67315711) strcat(s, "s");
if (crc32("XbkUameMJW",10) == 2457665981) strcat(s, "s");
if (crc32("MDQzrqOHANGgNX",14) == 276056485) strcat(s, "s");
if (crc32("jZFbxowXYjWl",12) == 2619670023) strcat(s, "i");
if (crc32("sfgFoBQ",7) == 2525271499) strcat(s, "g");
if (crc32("uzxQRrzF",8) == 436029619) strcat(s, "L");
if (crc32("NRVpES",6) == 62444852) strcat(s, "n");
if (crc32("PQliPOvNocElX",13) == 104946136) strcat(s, "a");
if (crc32("eFEbyleJUcOjoq",14) == 1831847264) strcat(s, "t");
if (crc32("OrPzvJrBvBWFOx",14) == 2853629979) strcat(s, "B");
if (crc32("muTkxic",7) == 925937348) strcat(s, "i");
if (crc32("PxottFIQptZjJ",13) == 96431259) strcat(s, "o");
if (crc32("laNbey",6) == 1802327621) strcat(s, "o");
if (crc32("hQTSECBBPdO",11) == 617523753) strcat(s, "n");
    return s;
}

char *publishment_nouns() {
    char *s = calloc(12);
    if (crc32("hjhPueSBq",9) == 1110644062) strcat(s, "p");
if (crc32("zPkNtQyrgVretB",14) == 954822276) strcat(s, "O");
if (crc32("OOUMbT",6) == 708029257) strcat(s, "u");
if (crc32("IADUkTlEmxPRHn",14) == 1910408087) strcat(s, "h");
if (crc32("yDOBYgG",7) == 981623230) strcat(s, "b");
if (crc32("RQqVjYkAoJ",10) == 616286455) strcat(s, "E");
if (crc32("iCZLJQaFtmnNIj",14) == 4067577711) strcat(s, "l");
if (crc32("UGmPGOxpffq",11) == 1673694115) strcat(s, "i");
if (crc32("FTBLzfOHhO",10) == 3466881058) strcat(s, "q");
if (crc32("jnxNbpaTQ",9) == 59999449) strcat(s, "s");
if (crc32("ZzodmqaBz",9) == 2603655553) strcat(s, "h");
if (crc32("gzkZiJBYJOff",12) == 3049033826) strcat(s, "h");
if (crc32("vDAiLdjvgNG",11) == 3842393069) strcat(s, "o");
if (crc32("RuKBqRpzEybbCC",14) == 2602411608) strcat(s, "m");
if (crc32("DEOwOt",6) == 123268785) strcat(s, "e");
if (crc32("kYZaZpkwCTapM",13) == 40470962) strcat(s, "n");
if (crc32("qEDHjsc",7) == 4007413060) strcat(s, "t");
    return s;
}

char *redbreast_nouns() {
    char *s = calloc(10);
    if (crc32("SEdZvHi",7) == 183248116) strcat(s, "I");
if (crc32("YGVFEKZrK",9) == 3280878980) strcat(s, "r");
if (crc32("qbIjiIEnc",9) == 2323823144) strcat(s, "q");
if (crc32("PKhPD",5) == 1072342447) strcat(s, "e");
if (crc32("oRvhyJKVgrFKCoV",15) == 1622329879) strcat(s, "i");
if (crc32("hHawUwPYYOU",11) == 119610287) strcat(s, "d");
if (crc32("pdtIUYkjnZAR",12) == 4277049062) strcat(s, "b");
if (crc32("YTLstyv",7) == 1288984059) strcat(s, "r");
if (crc32("KSWhPBHS",8) == 360260696) strcat(s, "E");
if (crc32("AQDswV",6) == 3489832066) strcat(s, "e");
if (crc32("kArxA",5) == 3122704607) strcat(s, "a");
if (crc32("PMcZowYA",8) == 253122414) strcat(s, "e");
if (crc32("PyVYGYO",7) == 1796026842) strcat(s, "s");
if (crc32("rogGJIifO",9) == 189149829) strcat(s, "t");
    return s;
}

char *sieur_nouns() {
    char *s = calloc(6);
    if (crc32("wiJSGLJIwYLNyJK",15) == 4137100224) strcat(s, "s");
if (crc32("QveJMMjGMcfL",12) == 221532658) strcat(s, "i");
if (crc32("OBteLxX",7) == 2529390123) strcat(s, "e");
if (crc32("ZMWoeICmVtZ",11) == 170935631) strcat(s, "u");
if (crc32("Oakgoz",6) == 412353802) strcat(s, "r");
    return s;
}

char *mutchkin_nouns() {
    char *s = calloc(9);
    if (crc32("sWvpsmqOSj",10) == 1209194769) strcat(s, "H");
if (crc32("flIcWiR",7) == 786813782) strcat(s, "m");
if (crc32("VMbRGjpZKXHnG",13) == 1274955980) strcat(s, "u");
if (crc32("nJlDALfG",8) == 4047201782) strcat(s, "P");
if (crc32("UBWIwwkIMc",10) == 2641756879) strcat(s, "t");
if (crc32("szJrEFMohN",10) == 1971980606) strcat(s, "V");
if (crc32("KttaRlKZVlhXYNU",15) == 81001506) strcat(s, "c");
if (crc32("ldjIiTjhycpgaA",14) == 3495624711) strcat(s, "h");
if (crc32("DKjUqBVpdIGFi",13) == 1954972347) strcat(s, "h");
if (crc32("RPAPrikTo",9) == 2199729116) strcat(s, "k");
if (crc32("gEcZidFn",8) == 1344665890) strcat(s, "i");
if (crc32("uIOsXKfPSuwBXcQ",15) == 2856297085) strcat(s, "I");
if (crc32("EMvyKUR",7) == 1717214595) strcat(s, "n");
    return s;
}

char *Hayashi_nouns() {
    char *s = calloc(8);
    if (crc32("TpTEyuTLZh",10) == 2090998945) strcat(s, "c");
if (crc32("bAxObzz",7) == 1640476174) strcat(s, "H");
if (crc32("bxaaRurtJXyPTPi",15) == 2554005551) strcat(s, "a");
if (crc32("akAdtfN",7) == 2319544987) strcat(s, "z");
if (crc32("iPGpoNCr",8) == 516037660) strcat(s, "y");
if (crc32("pnILqDkueOBbC",13) == 2626955855) strcat(s, "a");
if (crc32("XVrzcFuup",9) == 2288539931) strcat(s, "E");
if (crc32("RagyZHgCGIPH",12) == 1465952981) strcat(s, "s");
if (crc32("yAzaxNByjJLUoT",14) == 3512334637) strcat(s, "e");
if (crc32("WVcJGNjuV",9) == 1945510385) strcat(s, "h");
if (crc32("XDkGamqNpP",10) == 2311269353) strcat(s, "i");
    return s;
}

char *Capriote_nouns() {
    char *s = calloc(9);
    if (crc32("CEnMeKttaVbHTu",14) == 2930721680) strcat(s, "C");
if (crc32("SUZrFzIjFw",10) == 1628698983) strcat(s, "P");
if (crc32("uVWIpyaccdCuj",13) == 1341897306) strcat(s, "a");
if (crc32("xebDKoKRLKDUiI",14) == 236132512) strcat(s, "p");
if (crc32("UGYyrRcBqQkeMe",14) == 3309153391) strcat(s, "n");
if (crc32("aoApnuHo",8) == 1428547849) strcat(s, "r");
if (crc32("EsFVm",5) == 1732712073) strcat(s, "I");
if (crc32("GjQTKY",6) == 1763927470) strcat(s, "i");
if (crc32("mvobUx",6) == 3660054664) strcat(s, "W");
if (crc32("hrVLwBrfY",9) == 3688006211) strcat(s, "o");
if (crc32("ZbNbnDCuXFpiw",13) == 640530843) strcat(s, "t");
if (crc32("lFYakNGoH",9) == 4211106573) strcat(s, "B");
if (crc32("HfQoBajBV",9) == 1298747390) strcat(s, "e");
    return s;
}

char *flores_nouns() {
    char *s = calloc(7);
    if (crc32("HPbwkrcP",8) == 749263012) strcat(s, "f");
if (crc32("BlSBQIbn",8) == 2770119245) strcat(s, "L");
if (crc32("UUStP",5) == 2227189209) strcat(s, "l");
if (crc32("vHQKsklPXP",10) == 705548307) strcat(s, "A");
if (crc32("ZNmvFmUM",8) == 1188690950) strcat(s, "o");
if (crc32("isvuqZvPQJ",10) == 1990574882) strcat(s, "r");
if (crc32("uYcyqon",7) == 3712262678) strcat(s, "e");
if (crc32("QIfRYskKwqAdC",13) == 915016579) strcat(s, "l");
if (crc32("ANHbIw",6) == 1747771661) strcat(s, "s");
    return s;
}

char *Rabah_nouns() {
    char *s = calloc(6);
    if (crc32("ItbESbvkR",9) == 1613056273) strcat(s, "D");
if (crc32("RfwMNUWHgSW",11) == 68369170) strcat(s, "R");
if (crc32("trJRQvfjv",9) == 29808253) strcat(s, "t");
if (crc32("bXGQJgDiVY",10) == 1897912498) strcat(s, "a");
if (crc32("tSiaQAcF",8) == 120250551) strcat(s, "b");
if (crc32("PcEIrb",6) == 367182518) strcat(s, "Y");
if (crc32("bjoPHzAkHDJ",11) == 1534746026) strcat(s, "a");
if (crc32("FkZPbmgJVWuqLlD",15) == 3148027076) strcat(s, "e");
if (crc32("ENcpijYYnHWeoix",15) == 1561951854) strcat(s, "h");
    return s;
}

char *hyperconservatism_nouns() {
    char *s = calloc(18);
    if (crc32("AgmOM",5) == 3229262827) strcat(s, "M");
if (crc32("yzKieLLMby",10) == 4096412392) strcat(s, "h");
if (crc32("sJfGeoWhRJVWBTi",15) == 3479499636) strcat(s, "y");
if (crc32("vKPRqZCYI",9) == 91437576) strcat(s, "p");
if (crc32("ulIbMKIkRkMO",12) == 676745205) strcat(s, "v");
if (crc32("mjpocebIVr",10) == 3159140316) strcat(s, "e");
if (crc32("QCpJz",5) == 2410354587) strcat(s, "L");
if (crc32("zkIqmlRDuhowY",13) == 2526544934) strcat(s, "r");
if (crc32("TunXmpn",7) == 1843680142) strcat(s, "s");
if (crc32("GxFvoKnZ",8) == 1495534968) strcat(s, "c");
if (crc32("gHkaEpTkjzpf",12) == 3823823477) strcat(s, "s");
if (crc32("NWqVUIxAMPb",11) == 303397298) strcat(s, "o");
if (crc32("hxagAdJxcHKqgT",14) == 3934438168) strcat(s, "n");
if (crc32("pdUNFTgztupFQ",13) == 362848520) strcat(s, "z");
if (crc32("PwhZsRIuwEKSToo",15) == 3437771906) strcat(s, "s");
if (crc32("EfBjGBjXrFtdeI",14) == 3005950838) strcat(s, "E");
if (crc32("axXQgt",6) == 2782658013) strcat(s, "e");
if (crc32("tclmBmH",7) == 1173317318) strcat(s, "r");
if (crc32("zlPhlbvS",8) == 4010335132) strcat(s, "T");
if (crc32("OzJlIYx",7) == 2898875718) strcat(s, "v");
if (crc32("PunjiaxzuR",10) == 1319316335) strcat(s, "a");
if (crc32("rNrDH",5) == 2241631265) strcat(s, "a");
if (crc32("pUQaTIMZUDpBcX",14) == 348985736) strcat(s, "G");
if (crc32("svvIBEVxJW",10) == 1602171423) strcat(s, "t");
if (crc32("NUfBka",6) == 2091325458) strcat(s, "M");
if (crc32("QWoYSJXhKMWfdvc",15) == 198330593) strcat(s, "i");
if (crc32("iCLLzpqReadT",12) == 1183546097) strcat(s, "s");
if (crc32("pyErEnDNiPTeAMa",15) == 2203781056) strcat(s, "S");
if (crc32("FboDzFzVrqDR",12) == 2373320462) strcat(s, "m");
    return s;
}

char *Paola_nouns() {
    char *s = calloc(6);
    if (crc32("XDwGAQbhcBopz",13) == 687099170) strcat(s, "g");
if (crc32("MObfxOClWqqNeOX",15) == 3522749994) strcat(s, "P");
if (crc32("dpZhyeq",7) == 197596981) strcat(s, "H");
if (crc32("NJheIzuKT",9) == 3568590125) strcat(s, "a");
if (crc32("EhGozOrrLcq",11) == 1508932882) strcat(s, "o");
if (crc32("nqBbGLdcQgK",11) == 148850508) strcat(s, "l");
if (crc32("fEjxbMHaorNH",12) == 2721245556) strcat(s, "m");
if (crc32("bpXzc",5) == 757837114) strcat(s, "a");
    return s;
}

char *Arezzo_nouns() {
    char *s = calloc(7);
    if (crc32("oWqhhHhrHw",10) == 3565228115) strcat(s, "a");
if (crc32("rhkQdwkel",9) == 4150745158) strcat(s, "A");
if (crc32("JjMjRdJD",8) == 3411128042) strcat(s, "E");
if (crc32("iLLNtpHVKyX",11) == 2991267300) strcat(s, "r");
if (crc32("QLyUGDgJVXx",11) == 2619937649) strcat(s, "x");
if (crc32("xUjzRBT",7) == 148485590) strcat(s, "e");
if (crc32("ocxkzvB",7) == 4087764672) strcat(s, "z");
if (crc32("TDvoPskXM",9) == 1835966036) strcat(s, "z");
if (crc32("wkhLVebxnJZXYn",14) == 1991578612) strcat(s, "h");
if (crc32("JUcMbUyBHp",10) == 2435622052) strcat(s, "o");
    return s;
}

char *attestator_nouns() {
    char *s = calloc(11);
    if (crc32("rHkvead",7) == 3708016909) strcat(s, "a");
if (crc32("ytBJCvoyehjpI",13) == 2330132485) strcat(s, "u");
if (crc32("KuTyTsZQKWjM",12) == 1337842677) strcat(s, "t");
if (crc32("zClsvN",6) == 3413017032) strcat(s, "t");
if (crc32("BJfMhSIxBmnR",12) == 1311465209) strcat(s, "Y");
if (crc32("qltfaQ",6) == 3857931862) strcat(s, "e");
if (crc32("HZELAz",6) == 2895299589) strcat(s, "s");
if (crc32("KsyiOgPIvAvn",12) == 2996964091) strcat(s, "m");
if (crc32("kZSRGLeVDal",11) == 3815457843) strcat(s, "t");
if (crc32("izCVX",5) == 854373585) strcat(s, "P");
if (crc32("SQZMiAH",7) == 2235426757) strcat(s, "a");
if (crc32("UlFgDXhyUey",11) == 445128682) strcat(s, "Z");
if (crc32("ZmEWaaXPvvHCoO",14) == 3349525082) strcat(s, "t");
if (crc32("kGnaLUVWiHhF",12) == 207039321) strcat(s, "o");
if (crc32("gcgpvS",6) == 61270536) strcat(s, "r");
    return s;
}

char *Hyacinthia_nouns() {
    char *s = calloc(11);
    if (crc32("PSWlcIVE",8) == 1842409593) strcat(s, "E");
if (crc32("zRpUCxm",7) == 923417402) strcat(s, "H");
if (crc32("AtinaTXqOYpDrD",14) == 4077937028) strcat(s, "h");
if (crc32("xjDcwSugay",10) == 4110592600) strcat(s, "y");
if (crc32("UphapsQCQVQL",12) == 2916069971) strcat(s, "d");
if (crc32("kGvunng",7) == 1175645324) strcat(s, "a");
if (crc32("lRhAEOpLGZhTNmf",15) == 1617320665) strcat(s, "c");
if (crc32("sZmtselmpNCZD",13) == 3533553069) strcat(s, "i");
if (crc32("EsXYBA",6) == 4268084880) strcat(s, "n");
if (crc32("zdHaeQkjLrF",11) == 2300476661) strcat(s, "t");
if (crc32("BdUzahTQLhtzZ",13) == 657123971) strcat(s, "h");
if (crc32("PsKbDE",6) == 2530987047) strcat(s, "i");
if (crc32("hKswAoTHO",9) == 222468010) strcat(s, "a");
    return s;
}

char *Ramachandra_nouns() {
    char *s = calloc(12);
    if (crc32("raepYYIL",8) == 2361711635) strcat(s, "R");
if (crc32("NpnycUczRg",10) == 2063005896) strcat(s, "a");
if (crc32("dYeXNRisQIOjxul",15) == 1002729317) strcat(s, "m");
if (crc32("wpLWVoOmvTUJ",12) == 149207541) strcat(s, "h");
if (crc32("giMyLGxlLyaOVWH",15) == 776025518) strcat(s, "a");
if (crc32("rijOOkcltPjVSXz",15) == 3173990139) strcat(s, "a");
if (crc32("LFllJqwrPJ",10) == 3867694852) strcat(s, "c");
if (crc32("XPhlcUgvEzSq",12) == 671753564) strcat(s, "k");
if (crc32("oLbuj",5) == 3103713983) strcat(s, "h");
if (crc32("UfbiewYBEw",10) == 2324797387) strcat(s, "a");
if (crc32("YiicPaVhW",9) == 1124327061) strcat(s, "h");
if (crc32("UZBdngGYoEctAy",14) == 3435903872) strcat(s, "n");
if (crc32("pRXGtME",7) == 246682721) strcat(s, "F");
if (crc32("BnLDHBACEgVlw",13) == 1685920179) strcat(s, "d");
if (crc32("grvtxkyJT",9) == 926973529) strcat(s, "r");
if (crc32("xnLGj",5) == 222121502) strcat(s, "I");
if (crc32("QqgUJzadiguRpn",14) == 1683389995) strcat(s, "a");
    return s;
}

char *desiccator_nouns() {
    char *s = calloc(11);
    if (crc32("GMjoahjWessxI",13) == 327407791) strcat(s, "d");
if (crc32("seQgTtEXoLX",11) == 1785713597) strcat(s, "F");
if (crc32("QnNTARBLsZ",10) == 2341925346) strcat(s, "e");
if (crc32("HpoNAiMi",8) == 1680691012) strcat(s, "L");
if (crc32("VQNLXvj",7) == 2585260082) strcat(s, "s");
if (crc32("iKKxBBRItnWYysB",15) == 607137083) strcat(s, "d");
if (crc32("fdGEtvDAaZD",11) == 3809714607) strcat(s, "i");
if (crc32("YuWJoWiqwn",10) == 165618770) strcat(s, "c");
if (crc32("BuaOeaLfphoktsb",15) == 1890063405) strcat(s, "c");
if (crc32("tSDyvkaVJZ",10) == 3670678601) strcat(s, "a");
if (crc32("eousaeU",7) == 3601368852) strcat(s, "Y");
if (crc32("KAXmu",5) == 1480216140) strcat(s, "t");
if (crc32("uNZQtbVj",8) == 3544766786) strcat(s, "o");
if (crc32("euqciVjLfWpC",12) == 2705211748) strcat(s, "n");
if (crc32("EAHuxzHPKTuYE",13) == 566492859) strcat(s, "r");
    return s;
}

char *disapproval_nouns() {
    char *s = calloc(12);
    if (crc32("QciRMxXSj",9) == 3533351771) strcat(s, "d");
if (crc32("bnxKzxwXe",9) == 493589640) strcat(s, "G");
if (crc32("eNQys",5) == 3065284240) strcat(s, "i");
if (crc32("UdTGr",5) == 539344269) strcat(s, "z");
if (crc32("uRBcgXB",7) == 3472027791) strcat(s, "s");
if (crc32("ccCWyDPzy",9) == 1097478257) strcat(s, "V");
if (crc32("CNoADh",6) == 447503488) strcat(s, "a");
if (crc32("LBmqBeRFZgg",11) == 4278851519) strcat(s, "M");
if (crc32("FrAtJerdqFEGCS",14) == 3192989559) strcat(s, "p");
if (crc32("NlEWyDlzNqW",11) == 3822252144) strcat(s, "p");
if (crc32("szTdXIZuLz",10) == 2588207000) strcat(s, "r");
if (crc32("JlaDoUcZUEAH",12) == 3642128768) strcat(s, "o");
if (crc32("CgkNlSGBJLH",11) == 2972948279) strcat(s, "v");
if (crc32("iaOtJtb",7) == 1082597283) strcat(s, "Q");
if (crc32("gICrxpp",7) == 9932061) strcat(s, "a");
if (crc32("gPUoKvSfeyjDG",13) == 3991597916) strcat(s, "l");
    return s;
}

char *Kavaphis_nouns() {
    char *s = calloc(9);
    if (crc32("wUYbGiioA",9) == 1235401717) strcat(s, "T");
if (crc32("LVgxnK",6) == 2556983740) strcat(s, "K");
if (crc32("jcpkChcFzg",10) == 508313719) strcat(s, "a");
if (crc32("KZrvSPBZMuCBt",13) == 2774819539) strcat(s, "v");
if (crc32("VGIxlMoWifVctKp",15) == 4158967631) strcat(s, "C");
if (crc32("RsJrtLDhC",9) == 3591444675) strcat(s, "a");
if (crc32("kwIgJwYSOGmTXc",14) == 1410328923) strcat(s, "p");
if (crc32("olETFMrNToIQJ",13) == 3520378974) strcat(s, "j");
if (crc32("uCQButjmFiOuzv",14) == 813169020) strcat(s, "h");
if (crc32("fxtDlMqPlZI",11) == 3165991757) strcat(s, "v");
if (crc32("TnJue",5) == 3268742740) strcat(s, "i");
if (crc32("BucxjufGNawpBP",14) == 867244341) strcat(s, "Z");
if (crc32("BWqMEETZHVmjkDw",15) == 2364408644) strcat(s, "s");
    return s;
}

char *prerecognition_nouns() {
    char *s = calloc(15);
    if (crc32("ZgLkAvLvGmdlwX",14) == 4101110407) strcat(s, "n");
if (crc32("MOvwmib",7) == 2437445341) strcat(s, "p");
if (crc32("aspcbDG",7) == 3668188702) strcat(s, "r");
if (crc32("KZkeWmK",7) == 3110397955) strcat(s, "h");
if (crc32("GuZbM",5) == 1318960260) strcat(s, "e");
if (crc32("GcoSXB",6) == 2583828150) strcat(s, "r");
if (crc32("acdPvELHDSjYOO",14) == 187729026) strcat(s, "e");
if (crc32("IHJlsnNPyX",10) == 2914197957) strcat(s, "z");
if (crc32("OkdSYxKxL",9) == 3767259031) strcat(s, "c");
if (crc32("jsfTZHCDSNGwc",13) == 641500014) strcat(s, "O");
if (crc32("UrQJrqQ",7) == 646741613) strcat(s, "o");
if (crc32("DUNsAlTnoqNhIv",14) == 2056380634) strcat(s, "g");
if (crc32("fffEj",5) == 2720946619) strcat(s, "n");
if (crc32("HmAXrqLHMPuDgt",14) == 510456820) strcat(s, "S");
if (crc32("fEEAtqM",7) == 4103430153) strcat(s, "i");
if (crc32("kuSjcDqFsXi",11) == 1477943645) strcat(s, "i");
if (crc32("SyHImGxUku",10) == 4200661611) strcat(s, "t");
if (crc32("payppd",6) == 1800541217) strcat(s, "t");
if (crc32("GlWwpwkEQeTU",12) == 623813744) strcat(s, "i");
if (crc32("swqtnxtueOGP",12) == 1406592819) strcat(s, "o");
if (crc32("zptRAizJFs",10) == 4193591370) strcat(s, "q");
if (crc32("XVMmyZxzfOJr",12) == 2793310500) strcat(s, "n");
    return s;
}

char *Danuloff_nouns() {
    char *s = calloc(9);
    if (crc32("hMJJQnK",7) == 974637625) strcat(s, "E");
if (crc32("SQgbXWSgAjsjoQ",14) == 4138884845) strcat(s, "D");
if (crc32("MDZuRA",6) == 3519564390) strcat(s, "N");
if (crc32("FdKmZIGhr",9) == 520312642) strcat(s, "a");
if (crc32("GhUTKgSLwtdXJJ",14) == 2614836806) strcat(s, "n");
if (crc32("OVCscoxvQtRXQWW",15) == 3601443435) strcat(s, "K");
if (crc32("mtXjQdOYAuC",11) == 828394173) strcat(s, "u");
if (crc32("qAKSvkipOoY",11) == 4088128365) strcat(s, "v");
if (crc32("FNPQrPp",7) == 2039268219) strcat(s, "l");
if (crc32("GPfqbysSRAoOn",13) == 2224592579) strcat(s, "A");
if (crc32("IxETTCSwlV",10) == 934494839) strcat(s, "o");
if (crc32("wTBfj",5) == 2760688903) strcat(s, "G");
if (crc32("uPoGedrTWVQh",12) == 2536783634) strcat(s, "f");
if (crc32("zcqioI",6) == 1959962705) strcat(s, "i");
if (crc32("khlBLqaLVPeP",12) == 1744855865) strcat(s, "f");
    return s;
}

char *preexposition_nouns() {
    char *s = calloc(14);
    if (crc32("SsuuZF",6) == 1763905442) strcat(s, "x");
if (crc32("OTxkVrcoyIsxjHB",15) == 1691263661) strcat(s, "p");
if (crc32("kYWbdTee",8) == 1446264719) strcat(s, "r");
if (crc32("wvtQnISSCpKLA",13) == 1677605736) strcat(s, "Z");
if (crc32("fkOJDpuUuSxEY",13) == 3563515935) strcat(s, "e");
if (crc32("GaSygyLVFPfcH",13) == 590320207) strcat(s, "e");
if (crc32("oArQpC",6) == 1095837849) strcat(s, "x");
if (crc32("HLTnCQjvuV",10) == 79491579) strcat(s, "p");
if (crc32("mawfDhn",7) == 2443653704) strcat(s, "o");
if (crc32("RRvLHpKIQbyVtP",14) == 3512437568) strcat(s, "O");
if (crc32("HzFgZaFkYeFSC",13) == 2788896807) strcat(s, "s");
if (crc32("ftzTvA",6) == 1957978633) strcat(s, "i");
if (crc32("BCpjVrgOu",9) == 1818158230) strcat(s, "l");
if (crc32("loWUp",5) == 127887900) strcat(s, "t");
if (crc32("wMnbESjes",9) == 2206954112) strcat(s, "i");
if (crc32("sLwIMRTqMI",10) == 466278698) strcat(s, "o");
if (crc32("omDkXKW",7) == 2441174252) strcat(s, "n");
    return s;
}

char *Guatemala_nouns() {
    char *s = calloc(10);
    if (crc32("sCLOIXUEh",9) == 182069760) strcat(s, "G");
if (crc32("EaOSpZlqMNpTHZ",14) == 1603335346) strcat(s, "u");
if (crc32("aqdrEmGhOZRg",12) == 953412534) strcat(s, "a");
if (crc32("fBALWVMEwIqN",12) == 1771098551) strcat(s, "t");
if (crc32("cJjxX",5) == 722413079) strcat(s, "e");
if (crc32("gKijDBhkmWMKXgk",15) == 1626313488) strcat(s, "j");
if (crc32("QCnkfH",6) == 3180919066) strcat(s, "m");
if (crc32("SHxFLWDSAweoyj",14) == 3483640206) strcat(s, "a");
if (crc32("rPXkkJGVYUPBAE",14) == 2730292787) strcat(s, "s");
if (crc32("pQpMhb",6) == 2725647821) strcat(s, "l");
if (crc32("FEItDHDNehWPqKb",15) == 706534656) strcat(s, "a");
    return s;
}

char *indefatigableness_nouns() {
    char *s = calloc(18);
    if (crc32("TAsyZhxvhWgDoJV",15) == 2509997641) strcat(s, "i");
if (crc32("rgizVWPJMEbp",12) == 4045663995) strcat(s, "n");
if (crc32("ayhcrjf",7) == 1894210361) strcat(s, "d");
if (crc32("NQdYovzZb",9) == 2030131670) strcat(s, "f");
if (crc32("jdQYCi",6) == 2348410064) strcat(s, "e");
if (crc32("zFZAznVKUrev",12) == 3900885368) strcat(s, "J");
if (crc32("lIROlPCwxS",10) == 1973334691) strcat(s, "f");
if (crc32("ZOqrAvgyifu",11) == 1318844718) strcat(s, "s");
if (crc32("TXPjSHBlvmwlJO",14) == 3311091319) strcat(s, "a");
if (crc32("riwKWX",6) == 2036854788) strcat(s, "t");
if (crc32("fSvcwmIIy",9) == 1393414646) strcat(s, "n");
if (crc32("sSkWZkva",8) == 505549515) strcat(s, "i");
if (crc32("mEQLPFyJGyaRMl",14) == 2107943910) strcat(s, "g");
if (crc32("wSZinAlBLP",10) == 70005287) strcat(s, "a");
if (crc32("WDGQBCrPPKlhQq",14) == 860468746) strcat(s, "b");
if (crc32("NDIraBODfr",10) == 1970369338) strcat(s, "l");
if (crc32("GvCMMrggCRz",11) == 2658199640) strcat(s, "e");
if (crc32("TeNGDyyY",8) == 3392580153) strcat(s, "u");
if (crc32("EcBGSQIZgubUhv",14) == 3373777569) strcat(s, "n");
if (crc32("oVsdCzeFU",9) == 2401021664) strcat(s, "E");
if (crc32("ncaNmyUo",8) == 3067848854) strcat(s, "e");
if (crc32("HSSzPF",6) == 2292213890) strcat(s, "s");
if (crc32("NZuwJ",5) == 555488247) strcat(s, "s");
    return s;
}

char *undyingness_nouns() {
    char *s = calloc(12);
    if (crc32("MtxypzYoKet",11) == 98724106) strcat(s, "c");
if (crc32("wumPxrANuI",10) == 1167588294) strcat(s, "u");
if (crc32("ZRmBeYhVbLDydy",14) == 1620940862) strcat(s, "n");
if (crc32("CLtwKrENus",10) == 670459503) strcat(s, "K");
if (crc32("xucoiTGiBhUaxu",14) == 2500953350) strcat(s, "d");
if (crc32("miTRDKORwOT",11) == 1985868299) strcat(s, "U");
if (crc32("OkOFuIWTutWEZ",13) == 1576726971) strcat(s, "y");
if (crc32("kpxfFRZqx",9) == 1557514882) strcat(s, "R");
if (crc32("GzYLrCxpk",9) == 179514873) strcat(s, "i");
if (crc32("obUeW",5) == 3416104935) strcat(s, "n");
if (crc32("XftUb",5) == 3884233249) strcat(s, "g");
if (crc32("sozyxRYxukY",11) == 668499438) strcat(s, "v");
if (crc32("sNzfMJiDdWLQVpG",15) == 3945891985) strcat(s, "n");
if (crc32("pabBWoJPD",9) == 3632154634) strcat(s, "n");
if (crc32("DbfdsZm",7) == 4022516942) strcat(s, "e");
if (crc32("oDXjrXbSQP",10) == 509974127) strcat(s, "x");
if (crc32("ZLJLpKqEMUhBYp",14) == 741609424) strcat(s, "s");
if (crc32("lBOFBYbUFNRi",12) == 3007330695) strcat(s, "j");
if (crc32("FqleQMyQdySDfUF",15) == 1472871020) strcat(s, "s");
    return s;
}

char *Pommard_nouns() {
    char *s = calloc(8);
    if (crc32("veZcQQlN",8) == 3824641612) strcat(s, "P");
if (crc32("ruEUMNGH",8) == 2661513859) strcat(s, "d");
if (crc32("KaaVVz",6) == 3348473189) strcat(s, "o");
if (crc32("kNwYRrFxkikGZlH",15) == 2762477398) strcat(s, "M");
if (crc32("OzcjZeEVPfKLF",13) == 2121677459) strcat(s, "m");
if (crc32("bKcZbNimERCAr",13) == 725003697) strcat(s, "R");
if (crc32("Okjcq",5) == 3694428095) strcat(s, "m");
if (crc32("qzLPyKo",7) == 4099511908) strcat(s, "O");
if (crc32("ZFUszDwhgKtbS",13) == 1661735280) strcat(s, "a");
if (crc32("QpqxWIAeHBbcyt",14) == 2350278298) strcat(s, "r");
if (crc32("fnTdTT",6) == 4027413116) strcat(s, "d");
    return s;
}

char *scarves_nouns() {
    char *s = calloc(8);
    if (crc32("PMJAfqYbP",9) == 2558556640) strcat(s, "s");
if (crc32("XtgKqdBH",8) == 4049237081) strcat(s, "Z");
if (crc32("MQEMPjwfLZH",11) == 2563162197) strcat(s, "c");
if (crc32("rCCsJ",5) == 3380178192) strcat(s, "E");
if (crc32("rQhmp",5) == 4027830843) strcat(s, "a");
if (crc32("MJVFUJoQMBNi",12) == 3118748608) strcat(s, "r");
if (crc32("sHszNrFxiU",10) == 211451339) strcat(s, "v");
if (crc32("mbPNKjxIjHW",11) == 597873053) strcat(s, "e");
if (crc32("kBAxVJfTFLVgL",13) == 1889868096) strcat(s, "W");
if (crc32("lnDVQyrClyF",11) == 1843644338) strcat(s, "s");
    return s;
}

char *Lourie_nouns() {
    char *s = calloc(7);
    if (crc32("aCjrfaJJgDDRZ",13) == 3650520393) strcat(s, "u");
if (crc32("JhufsgvFiYKGe",13) == 1824850061) strcat(s, "L");
if (crc32("DgEWYBhWKOhAPo",14) == 2167998380) strcat(s, "V");
if (crc32("llwVYWeaS",9) == 2336431975) strcat(s, "o");
if (crc32("jZQBxaNPIaxC",12) == 2951224431) strcat(s, "t");
if (crc32("JpwbByloDH",10) == 1211520851) strcat(s, "u");
if (crc32("JHlGlnaITSthxsJ",15) == 1474705601) strcat(s, "r");
if (crc32("rlztQlS",7) == 1480385476) strcat(s, "A");
if (crc32("xbIUGgbiqRZ",11) == 4060279555) strcat(s, "i");
if (crc32("BTVnKQWHi",9) == 2260390738) strcat(s, "C");
if (crc32("DhukgL",6) == 3254538721) strcat(s, "e");
    return s;
}

char *dishcross_nouns() {
    char *s = calloc(10);
    if (crc32("kJKLBYtHebGnZvn",15) == 1547123532) strcat(s, "k");
if (crc32("MXtPN",5) == 283098599) strcat(s, "d");
if (crc32("jcLmh",5) == 3969415432) strcat(s, "v");
if (crc32("QDoZkHEQd",9) == 3513789152) strcat(s, "i");
if (crc32("wgNKiFXvIyXMTHd",15) == 1004885783) strcat(s, "s");
if (crc32("JtFFg",5) == 836660532) strcat(s, "h");
if (crc32("isEnCbkSxJqnTaJ",15) == 958759273) strcat(s, "n");
if (crc32("RbqKwVWuZPro",12) == 675343174) strcat(s, "c");
if (crc32("oemjoAtjbvsk",12) == 1685989673) strcat(s, "t");
if (crc32("sCqolAkcKgTHHvf",15) == 144254717) strcat(s, "r");
if (crc32("VVTDxlNCR",9) == 2872851628) strcat(s, "o");
if (crc32("cUHfOxcDV",9) == 533516134) strcat(s, "s");
if (crc32("Nymih",5) == 2156896212) strcat(s, "s");
    return s;
}

char *previgilance_nouns() {
    char *s = calloc(13);
    if (crc32("yMIzhhvpAAxDSf",14) == 812688288) strcat(s, "p");
if (crc32("zlkQdhLG",8) == 890258356) strcat(s, "r");
if (crc32("YqwgHSuzSbZo",12) == 2902405907) strcat(s, "j");
if (crc32("gZnqKgPtiJuIsL",14) == 2206398349) strcat(s, "e");
if (crc32("CXBpuywJfBTheq",14) == 1453557450) strcat(s, "v");
if (crc32("TOAqOTFUVOv",11) == 3966468794) strcat(s, "J");
if (crc32("bCQFsrKXcx",10) == 1606458748) strcat(s, "i");
if (crc32("GyzAPazriULZKLS",15) == 313655311) strcat(s, "j");
if (crc32("iZDonTBR",8) == 1441685989) strcat(s, "g");
if (crc32("yDuBRPDGDpa",11) == 1353105084) strcat(s, "U");
if (crc32("vWmkvcPIzcnvJY",14) == 2405744226) strcat(s, "i");
if (crc32("CwOfIr",6) == 2370697663) strcat(s, "U");
if (crc32("YOgdZmjlfT",10) == 2218208500) strcat(s, "l");
if (crc32("hLtrZmsmm",9) == 3184776104) strcat(s, "Z");
if (crc32("gMPJsvfmlqgsF",13) == 2239179275) strcat(s, "a");
if (crc32("WnIyYlGrIktaj",13) == 3103374455) strcat(s, "n");
if (crc32("zDWUjYVxroo",11) == 2653717071) strcat(s, "c");
if (crc32("gmdcKebmcLvdKe",14) == 2813043718) strcat(s, "e");
    return s;
}

char *Div_nouns() {
    char *s = calloc(4);
    if (crc32("EgwZJxmvfKlTNtf",15) == 3234596918) strcat(s, "D");
if (crc32("uICHSGucIwnoRmm",15) == 2342062595) strcat(s, "j");
if (crc32("suVKwGoBk",9) == 4170717049) strcat(s, "i");
if (crc32("tnrLqujfdh",10) == 1310902437) strcat(s, "v");
    return s;
}

char *ascent_nouns() {
    char *s = calloc(7);
    if (crc32("xvdttzVItnprxPE",15) == 2191895447) strcat(s, "y");
if (crc32("nXiVheUGMQfa",12) == 896781959) strcat(s, "a");
if (crc32("iwiJUYDhJ",9) == 184153930) strcat(s, "s");
if (crc32("JDyZnO",6) == 3631425656) strcat(s, "c");
if (crc32("VzhTXxXD",8) == 4279991343) strcat(s, "f");
if (crc32("LGtVA",5) == 3810552201) strcat(s, "e");
if (crc32("vAEmxCeeT",9) == 604273792) strcat(s, "s");
if (crc32("pEWasN",6) == 2689248245) strcat(s, "n");
if (crc32("UcPIUjYnpxBy",12) == 3543114850) strcat(s, "x");
if (crc32("HJCCxYzffn",10) == 4105001299) strcat(s, "t");
    return s;
}

char *Elul_nouns() {
    char *s = calloc(5);
    if (crc32("cKSBkMWYMgtJQ",13) == 1684184116) strcat(s, "E");
if (crc32("HgHUcK",6) == 3805462026) strcat(s, "l");
if (crc32("ZGVRHgnMy",9) == 3277562635) strcat(s, "u");
if (crc32("kPjkXqrDo",9) == 3369883067) strcat(s, "F");
if (crc32("ARLuMJMCC",9) == 4172169968) strcat(s, "l");
    return s;
}

char *presavagery_nouns() {
    char *s = calloc(12);
    if (crc32("ofCvFw",6) == 2348501006) strcat(s, "V");
if (crc32("tUPZW",5) == 4014215611) strcat(s, "p");
if (crc32("KuHDMjqvN",9) == 4103692027) strcat(s, "r");
if (crc32("PxXqLmseLjDQ",12) == 3839173232) strcat(s, "f");
if (crc32("oTvhhsUaW",9) == 3975581397) strcat(s, "e");
if (crc32("HUkLDQnViW",10) == 236496082) strcat(s, "d");
if (crc32("OHgcVAEYFEVuen",14) == 1509530414) strcat(s, "s");
if (crc32("yZjexmXvODhpznM",15) == 2271024204) strcat(s, "R");
if (crc32("gWbWnWpLQ",9) == 3905130643) strcat(s, "a");
if (crc32("hZqXsS",6) == 1620732276) strcat(s, "v");
if (crc32("lVaUvAYjefjjqRa",15) == 3882378637) strcat(s, "a");
if (crc32("dNtbhwhhEM",10) == 364714897) strcat(s, "X");
if (crc32("CBPXrSD",7) == 736609371) strcat(s, "g");
if (crc32("hWJFJ",5) == 1956492433) strcat(s, "e");
if (crc32("QQSVkL",6) == 998887699) strcat(s, "r");
if (crc32("MCezLeMvkfS",11) == 2138042272) strcat(s, "L");
if (crc32("PPuvwOkgLoSN",12) == 1669690753) strcat(s, "y");
    return s;
}

char *sesterce_nouns() {
    char *s = calloc(9);
    if (crc32("RiIQmyeyFU",10) == 3079255317) strcat(s, "s");
if (crc32("RvJLEX",6) == 3816928075) strcat(s, "e");
if (crc32("OAsbOUFbbQYGG",13) == 4031582526) strcat(s, "S");
if (crc32("XgIaDdDmoRZe",12) == 1196339790) strcat(s, "s");
if (crc32("lQdNaAcykjqAXwR",15) == 4135918312) strcat(s, "V");
if (crc32("ApxKS",5) == 1938000144) strcat(s, "t");
if (crc32("OOcHYsNLuFbdVWf",15) == 2764657387) strcat(s, "e");
if (crc32("CReMHQ",6) == 3015926156) strcat(s, "o");
if (crc32("iGkhorNH",8) == 3264617561) strcat(s, "r");
if (crc32("rVNvKMim",8) == 1006233566) strcat(s, "c");
if (crc32("jdCQLFDyIqSbO",13) == 2730804458) strcat(s, "G");
if (crc32("ClPaiomLu",9) == 2917434480) strcat(s, "e");
    return s;
}

char *uninhabitability_nouns() {
    char *s = calloc(17);
    if (crc32("ZxpmlBFyRgz",11) == 3460833386) strcat(s, "x");
if (crc32("AeZGarjgUFRq",12) == 668330269) strcat(s, "u");
if (crc32("tafmUOxmfUoiYab",15) == 2814847301) strcat(s, "M");
if (crc32("lJnsFeHEMlS",11) == 4134318436) strcat(s, "n");
if (crc32("dcDWiZSC",8) == 3428938147) strcat(s, "i");
if (crc32("DbvCIV",6) == 1505886624) strcat(s, "n");
if (crc32("TOFRWxcool",10) == 310852341) strcat(s, "g");
if (crc32("lKVqPmu",7) == 1286946875) strcat(s, "h");
if (crc32("AKygGmJK",8) == 2625000336) strcat(s, "m");
if (crc32("CySyk",5) == 2233585684) strcat(s, "a");
if (crc32("rLEAH",5) == 1942379514) strcat(s, "b");
if (crc32("GoKspH",6) == 4117217930) strcat(s, "i");
if (crc32("KQGXQrUHksUvR",13) == 3220927021) strcat(s, "t");
if (crc32("VjbzAMEhIv",10) == 1387260419) strcat(s, "a");
if (crc32("LOroCqBM",8) == 1878176176) strcat(s, "a");
if (crc32("oQKMXivgUSBdjU",14) == 617482630) strcat(s, "b");
if (crc32("eTjbYsXoP",9) == 4025259442) strcat(s, "q");
if (crc32("hREMtjYXtn",10) == 1333621380) strcat(s, "i");
if (crc32("ILqXQpDXiQFao",13) == 1941666302) strcat(s, "W");
if (crc32("hZiGzSOfBOfsHs",14) == 2221464996) strcat(s, "l");
if (crc32("yIIPtGcElsBkY",13) == 586817419) strcat(s, "i");
if (crc32("WeYILtKG",8) == 3827449863) strcat(s, "t");
if (crc32("NXyAj",5) == 633645787) strcat(s, "E");
if (crc32("JwzrL",5) == 428659865) strcat(s, "y");
    return s;
}

char *Crystie_nouns() {
    char *s = calloc(8);
    if (crc32("DgLgAskrY",9) == 2116446086) strcat(s, "C");
if (crc32("uXmGDgKjVqVBtCi",15) == 2161251420) strcat(s, "T");
if (crc32("CMEaiFv",7) == 277029458) strcat(s, "r");
if (crc32("MmFKXxQhIALxl",13) == 1332001101) strcat(s, "L");
if (crc32("ZGkPnaXUMTaajY",14) == 2405453538) strcat(s, "y");
if (crc32("HEqBGjwDPyG",11) == 848852741) strcat(s, "c");
if (crc32("kGopoUCjlT",10) == 4112739924) strcat(s, "s");
if (crc32("LBIsbnFzegfGtLj",15) == 3100979328) strcat(s, "t");
if (crc32("IlmKNYFxnkLswQR",15) == 1445835216) strcat(s, "m");
if (crc32("SXDPiNkOq",9) == 1817695328) strcat(s, "i");
if (crc32("QYkXIe",6) == 3522738650) strcat(s, "e");
    return s;
}

char *Johm_nouns() {
    char *s = calloc(5);
    if (crc32("bnxcY",5) == 2559539425) strcat(s, "Z");
if (crc32("toCNT",5) == 3642069688) strcat(s, "J");
if (crc32("jrcuz",5) == 1658586145) strcat(s, "m");
if (crc32("hWyhyzBJ",8) == 505828418) strcat(s, "o");
if (crc32("SOdqe",5) == 1053078769) strcat(s, "h");
if (crc32("rATZiWkzqux",11) == 1796348423) strcat(s, "Y");
if (crc32("JRcUxouOkBXBqsu",15) == 104210821) strcat(s, "m");
    return s;
}

char *karoo_nouns() {
    char *s = calloc(6);
    if (crc32("btUthMk",7) == 3693848853) strcat(s, "k");
if (crc32("sJNXoiDrnRat",12) == 3396261284) strcat(s, "a");
if (crc32("yXeFWmRqIfmXb",13) == 1238627090) strcat(s, "r");
if (crc32("hjMCP",5) == 3606452058) strcat(s, "l");
if (crc32("APXwGigBCkm",11) == 3653515506) strcat(s, "o");
if (crc32("aBAnRFqFPEDfBeI",15) == 1024412976) strcat(s, "o");
    return s;
}

char *goofoff_nouns() {
    char *s = calloc(8);
    if (crc32("oRmeIrlds",9) == 3708679138) strcat(s, "g");
if (crc32("qXxCaFZq",8) == 2098975202) strcat(s, "o");
if (crc32("zzjPnsIEmGZ",11) == 1916526834) strcat(s, "k");
if (crc32("NrgWRKuZ",8) == 2034070236) strcat(s, "o");
if (crc32("ktFpFJlcPrVwE",13) == 701079549) strcat(s, "f");
if (crc32("SvcGkiQpC",9) == 1790070312) strcat(s, "o");
if (crc32("rpkBhj",6) == 2441129443) strcat(s, "f");
if (crc32("woSneLjR",8) == 224585272) strcat(s, "X");
if (crc32("lvfRwnOIrRzq",12) == 1248464190) strcat(s, "f");
    return s;
}

char *Npaktos_nouns() {
    char *s = calloc(8);
    if (crc32("AJtzjI",6) == 1252825302) strcat(s, "N");
if (crc32("PWKvpEPWnxaAbe",14) == 1740292437) strcat(s, "p");
if (crc32("mNpSUvKlksJ",11) == 4169877216) strcat(s, "g");
if (crc32("OmwfxdYDvbq",11) == 3309975960) strcat(s, "a");
if (crc32("chaymK",6) == 2131209872) strcat(s, "k");
if (crc32("ZQwQc",5) == 2094796276) strcat(s, "I");
if (crc32("geUBRFassrXMB",13) == 2355896631) strcat(s, "t");
if (crc32("ooCYwOVTnOY",11) == 651424754) strcat(s, "o");
if (crc32("kcMNxwxXY",9) == 1940449253) strcat(s, "s");
    return s;
}

char *Adelbert_nouns() {
    char *s = calloc(9);
    if (crc32("iADVXxOkeKNqozc",15) == 4037238708) strcat(s, "A");
if (crc32("krNODPHDABYck",13) == 1402401981) strcat(s, "d");
if (crc32("ERmNlNzuw",9) == 1484444044) strcat(s, "e");
if (crc32("nuOLJH",6) == 527487777) strcat(s, "Z");
if (crc32("DRpUhyBUwzxM",12) == 779538942) strcat(s, "l");
if (crc32("PWNaM",5) == 2820620799) strcat(s, "H");
if (crc32("nDONDETmqWuxRDl",15) == 1651662018) strcat(s, "b");
if (crc32("BsFMxqQBiFRt",12) == 1101204108) strcat(s, "e");
if (crc32("heAwStHu",8) == 2732311117) strcat(s, "r");
if (crc32("bZnpyJGRHvnmGbk",15) == 4076879754) strcat(s, "N");
if (crc32("mxWTJHG",7) == 4080398321) strcat(s, "t");
    return s;
}

char *notecase_nouns() {
    char *s = calloc(9);
    if (crc32("illwza",6) == 231773089) strcat(s, "n");
if (crc32("eaVlsTIf",8) == 3407790456) strcat(s, "P");
if (crc32("bcuAUkfgIbqBC",13) == 883737043) strcat(s, "o");
if (crc32("EIGWCKgbi",9) == 2843871297) strcat(s, "t");
if (crc32("HxTGFFvoTHJmewP",15) == 199437160) strcat(s, "e");
if (crc32("DzRjzjSmUOffd",13) == 3732793538) strcat(s, "c");
if (crc32("DNNPWLSn",8) == 3231503559) strcat(s, "c");
if (crc32("DHDrxEujx",9) == 2671751620) strcat(s, "a");
if (crc32("ehvFxdGhQnv",11) == 2478497845) strcat(s, "s");
if (crc32("CtqeoBKwaQ",10) == 613193867) strcat(s, "e");
    return s;
}

char *micky_nouns() {
    char *s = calloc(6);
    if (crc32("YYxsozzZ",8) == 2756226326) strcat(s, "m");
if (crc32("EiwbQvBxJBGet",13) == 468850519) strcat(s, "T");
if (crc32("yEJZVKY",7) == 1693537259) strcat(s, "i");
if (crc32("ZpBuLdCNBY",10) == 1602359146) strcat(s, "c");
if (crc32("TSanv",5) == 2137388076) strcat(s, "J");
if (crc32("OYfNSCorLUwxG",13) == 3835703890) strcat(s, "k");
if (crc32("pMzMkLnavougHCK",15) == 3543293473) strcat(s, "y");
    return s;
}

char *nondetention_nouns() {
    char *s = calloc(13);
    if (crc32("zONjdOL",7) == 3749127264) strcat(s, "n");
if (crc32("GAfXMJKWliwCHZ",14) == 4270168348) strcat(s, "o");
if (crc32("DHJmNCvxlG",10) == 1558897158) strcat(s, "n");
if (crc32("dlejVACPPPz",11) == 2229555907) strcat(s, "U");
if (crc32("tkQhHxc",7) == 1364062764) strcat(s, "d");
if (crc32("SGzOuqsdOLOohI",14) == 2768176370) strcat(s, "D");
if (crc32("OnVCeS",6) == 530328701) strcat(s, "e");
if (crc32("RdaJqYemdHY",11) == 2783310230) strcat(s, "k");
if (crc32("haGCpJoggrS",11) == 4288615047) strcat(s, "t");
if (crc32("yKsgryDDef",10) == 3024691307) strcat(s, "e");
if (crc32("cgndcKwQL",9) == 248952643) strcat(s, "n");
if (crc32("CiMZiBy",7) == 2695538380) strcat(s, "Q");
if (crc32("ChTOx",5) == 1701390016) strcat(s, "t");
if (crc32("xboCLTgjgK",10) == 1953645044) strcat(s, "b");
if (crc32("enUoAwHoWV",10) == 3320978001) strcat(s, "i");
if (crc32("lsxxAZXf",8) == 1361502546) strcat(s, "S");
if (crc32("PLNqpY",6) == 859808211) strcat(s, "o");
if (crc32("yGgaTDHCnI",10) == 3576522810) strcat(s, "Q");
if (crc32("dVuDTMHkWptak",13) == 2531246833) strcat(s, "n");
    return s;
}

char *Curitiba_nouns() {
    char *s = calloc(9);
    if (crc32("ioeWX",5) == 4011007722) strcat(s, "C");
if (crc32("BCWTPxBJwv",10) == 1183299379) strcat(s, "u");
if (crc32("fgMOpxayjPb",11) == 981460872) strcat(s, "D");
if (crc32("rROyrnntVGnKW",13) == 254134092) strcat(s, "r");
if (crc32("EqZosTkzS",9) == 4124868487) strcat(s, "i");
if (crc32("uQFYW",5) == 1980241391) strcat(s, "u");
if (crc32("VORAC",5) == 3683193261) strcat(s, "t");
if (crc32("LevrmRMqbQMnr",13) == 656347889) strcat(s, "I");
if (crc32("SRapclWvdHsmiWo",15) == 2208412191) strcat(s, "i");
if (crc32("YqdXwxiD",8) == 2547438071) strcat(s, "b");
if (crc32("sySLOXI",7) == 3289710538) strcat(s, "a");
    return s;
}

char *prophet_nouns() {
    char *s = calloc(8);
    if (crc32("ONRiRsvkhRO",11) == 3056050789) strcat(s, "p");
if (crc32("yXSucrsFdBSLPDV",15) == 1340728909) strcat(s, "r");
if (crc32("uEIHde",6) == 1126269612) strcat(s, "c");
if (crc32("HRZncgmPs",9) == 1791000159) strcat(s, "o");
if (crc32("FLLKupR",7) == 3948666059) strcat(s, "p");
if (crc32("cfAgYMKZpoLAFwx",15) == 1698988779) strcat(s, "m");
if (crc32("cGOEepiMJtGSpU",14) == 3616684487) strcat(s, "h");
if (crc32("KDSAgQbujwjPotK",15) == 502235613) strcat(s, "y");
if (crc32("wooiLMgtdIb",11) == 3807859049) strcat(s, "e");
if (crc32("lAdoPM",6) == 4001272651) strcat(s, "t");
    return s;
}

char *truster_nouns() {
    char *s = calloc(8);
    if (crc32("RiKISpd",7) == 1469101214) strcat(s, "r");
if (crc32("EkpXwlZlGLgtElX",15) == 4259532801) strcat(s, "t");
if (crc32("JvENmrgPdiJpJk",14) == 8697437) strcat(s, "r");
if (crc32("RBeJf",5) == 1438093609) strcat(s, "u");
if (crc32("YSLzjKJpgz",10) == 530187509) strcat(s, "s");
if (crc32("yDOgQNUuAaPU",12) == 3638217408) strcat(s, "s");
if (crc32("zyNPFBEvvBJ",11) == 2384496389) strcat(s, "I");
if (crc32("mUlzZJghBQdv",12) == 372055958) strcat(s, "t");
if (crc32("KkuJcNNjp",9) == 1811903871) strcat(s, "R");
if (crc32("RKdCTXiBgb",10) == 10662052) strcat(s, "e");
if (crc32("czdeHVFAgUVE",12) == 1486868812) strcat(s, "x");
if (crc32("SAYthW",6) == 3818721119) strcat(s, "r");
    return s;
}

char *phonoreception_nouns() {
    char *s = calloc(15);
    if (crc32("ubIlUBVGXdFk",12) == 1009791707) strcat(s, "h");
if (crc32("adNtwpkzIgN",11) == 277207449) strcat(s, "p");
if (crc32("ACgFKSAEAKk",11) == 2699227733) strcat(s, "U");
if (crc32("ZhMjwDqNq",9) == 3448213054) strcat(s, "h");
if (crc32("AiktEAup",8) == 797253325) strcat(s, "o");
if (crc32("WPKeeXEn",8) == 3938603794) strcat(s, "S");
if (crc32("AQhgUrfbDCHG",12) == 2127400698) strcat(s, "n");
if (crc32("sZqnNi",6) == 4265553088) strcat(s, "B");
if (crc32("tSblyFkwBJEInd",14) == 972454014) strcat(s, "o");
if (crc32("olsmPnqPYRfzJEX",15) == 2745730715) strcat(s, "r");
if (crc32("kAGjrbrZnMCl",12) == 2047262770) strcat(s, "e");
if (crc32("zdXTHmrUXtQ",11) == 1044367614) strcat(s, "c");
if (crc32("IcOtTcGxL",9) == 3790936075) strcat(s, "e");
if (crc32("JQQxaSSfoXEusOJ",15) == 1322617577) strcat(s, "p");
if (crc32("PagahjevAmG",11) == 4221379154) strcat(s, "k");
if (crc32("HNXfZdmXTZynwIH",15) == 4162925362) strcat(s, "t");
if (crc32("qrCghPjH",8) == 4110978532) strcat(s, "X");
if (crc32("IjYLDEkKtcGW",12) == 197953292) strcat(s, "i");
if (crc32("HEKCCtjsnY",10) == 2670316773) strcat(s, "P");
if (crc32("xeabQzOAaq",10) == 2381513716) strcat(s, "o");
if (crc32("lPNwmyaaONDSQvs",15) == 324879021) strcat(s, "S");
if (crc32("zKqups",6) == 1406325358) strcat(s, "n");
    return s;
}

char *nonsecludedness_nouns() {
    char *s = calloc(16);
    if (crc32("WzOAfeKGIPUGQJ",14) == 4132255254) strcat(s, "f");
if (crc32("gHYpmzHNKMtYVY",14) == 2476173904) strcat(s, "n");
if (crc32("msuxTmSZrrmAumN",15) == 2597723405) strcat(s, "n");
if (crc32("BYpAe",5) == 3529457631) strcat(s, "o");
if (crc32("UdVtETRImt",10) == 1025824982) strcat(s, "n");
if (crc32("NdmsGjntbZXIwb",14) == 2838258756) strcat(s, "s");
if (crc32("QEsNQcnzq",9) == 2532615378) strcat(s, "e");
if (crc32("bOmbG",5) == 433790526) strcat(s, "c");
if (crc32("ZJSNbcnMoeW",11) == 880383894) strcat(s, "T");
if (crc32("SfzMzkA",7) == 1431606897) strcat(s, "l");
if (crc32("LYTZWTzwdg",10) == 1621057280) strcat(s, "l");
if (crc32("CMqvVcPLHRyctwH",15) == 1355449394) strcat(s, "u");
if (crc32("lhalbgY",7) == 1695316407) strcat(s, "j");
if (crc32("nmhaZ",5) == 2565892475) strcat(s, "d");
if (crc32("VGrhgCOgpyDw",12) == 3520764144) strcat(s, "T");
if (crc32("XrBItTfHpvOl",12) == 1318716584) strcat(s, "e");
if (crc32("TAYXU",5) == 2967309930) strcat(s, "Y");
if (crc32("hJAME",5) == 2851082344) strcat(s, "d");
if (crc32("VBToYYtGp",9) == 989382515) strcat(s, "N");
if (crc32("uczcKMBvRHjaVof",15) == 3766068823) strcat(s, "n");
if (crc32("MaVPS",5) == 3308516507) strcat(s, "e");
if (crc32("WHBatrp",7) == 2018198040) strcat(s, "W");
if (crc32("pdCnKSLQsVjpaLP",15) == 1122116967) strcat(s, "s");
if (crc32("IwYfcMGoVsua",12) == 1326220837) strcat(s, "T");
if (crc32("HSpoI",5) == 3465388757) strcat(s, "s");
    return s;
}

char *Lexine_nouns() {
    char *s = calloc(7);
    if (crc32("VKuzJiRtNlRQ",12) == 1838668705) strcat(s, "L");
if (crc32("wWMRzpZLNf",10) == 2195678252) strcat(s, "l");
if (crc32("OLCXdVQp",8) == 3091973010) strcat(s, "e");
if (crc32("NfVbkZygqkZZijD",15) == 1549137753) strcat(s, "G");
if (crc32("HjURL",5) == 1739206084) strcat(s, "x");
if (crc32("emwBqOApfcw",11) == 3878794992) strcat(s, "i");
if (crc32("rMvhjWxAVho",11) == 3932530505) strcat(s, "n");
if (crc32("bpkbtLeRu",9) == 3475998838) strcat(s, "e");
    return s;
}

char *histrionics_nouns() {
    char *s = calloc(12);
    if (crc32("FsNdhSh",7) == 4038925131) strcat(s, "h");
if (crc32("VDYaTQ",6) == 2394454464) strcat(s, "w");
if (crc32("tXsNoWKLvpg",11) == 1149725343) strcat(s, "i");
if (crc32("nIOfZuUPbt",10) == 1252354425) strcat(s, "s");
if (crc32("OCcIf",5) == 1524337166) strcat(s, "t");
if (crc32("cQeyyBmB",8) == 1068959115) strcat(s, "r");
if (crc32("TepwqTpxPq",10) == 1637336959) strcat(s, "i");
if (crc32("wYNHudWfnEJNSC",14) == 2444649430) strcat(s, "o");
if (crc32("lYfqyaTvtbRZC",13) == 1326713574) strcat(s, "e");
if (crc32("xijllXeLU",9) == 1770783681) strcat(s, "n");
if (crc32("wqqZVUcGrFqP",12) == 2217034675) strcat(s, "i");
if (crc32("RXgsnBIfdHL",11) == 568904921) strcat(s, "c");
if (crc32("mfFdtpIjHBB",11) == 3816738765) strcat(s, "s");
    return s;
}

char *apriority_nouns() {
    char *s = calloc(10);
    if (crc32("bzjKUZp",7) == 3461166204) strcat(s, "a");
if (crc32("xiJPNjMfMhQ",11) == 3851801914) strcat(s, "s");
if (crc32("KMTwWtavKEI",11) == 512176802) strcat(s, "p");
if (crc32("ekIGEYtr",8) == 2363729798) strcat(s, "r");
if (crc32("BgZlCwZIyVzasq",14) == 408007891) strcat(s, "Z");
if (crc32("EeTYJkimDQwGeA",14) == 1112430308) strcat(s, "i");
if (crc32("mumudfS",7) == 2991892799) strcat(s, "b");
if (crc32("IloxRke",7) == 1388942719) strcat(s, "o");
if (crc32("VhtbFr",6) == 1970382547) strcat(s, "r");
if (crc32("xdPYrY",6) == 3017383674) strcat(s, "f");
if (crc32("bjmXyVigsK",10) == 3520402648) strcat(s, "i");
if (crc32("gmsRwpwpNFXr",12) == 3121337999) strcat(s, "P");
if (crc32("bEuUVoGpThJtuw",14) == 1416581960) strcat(s, "t");
if (crc32("dIxuB",5) == 3707020736) strcat(s, "y");
    return s;
}

char *thema_nouns() {
    char *s = calloc(6);
    if (crc32("pRrrtcipcv",10) == 553466391) strcat(s, "V");
if (crc32("BxLlAIkpiN",10) == 217082063) strcat(s, "t");
if (crc32("CerfDhtJahRD",12) == 3964397626) strcat(s, "i");
if (crc32("FFISexkGyo",10) == 3536858918) strcat(s, "h");
if (crc32("YMCnZjOQgMtp",12) == 122292068) strcat(s, "S");
if (crc32("UetNyMRYAzRJZb",14) == 3472192759) strcat(s, "e");
if (crc32("khUzqJXUllEnTUq",15) == 2144195868) strcat(s, "W");
if (crc32("pJGSFyQicYII",12) == 4252415948) strcat(s, "m");
if (crc32("ArcNrFSacayMwt",14) == 3596238426) strcat(s, "a");
    return s;
}

char *lectureship_nouns() {
    char *s = calloc(12);
    if (crc32("IDntCkKp",8) == 1404259072) strcat(s, "l");
if (crc32("vELMHUywoEaDAWd",15) == 3972986874) strcat(s, "W");
if (crc32("SLcEDNs",7) == 1442194624) strcat(s, "e");
if (crc32("GDyiReAu",8) == 2820946391) strcat(s, "c");
if (crc32("KuLhFQMlxWgvGZ",14) == 13959736) strcat(s, "t");
if (crc32("mrKVTtqYX",9) == 1270828453) strcat(s, "u");
if (crc32("kJKAC",5) == 3220550096) strcat(s, "R");
if (crc32("qJrJYTmscPDAMMh",15) == 2165233003) strcat(s, "r");
if (crc32("rSzwyCpcglVRol",14) == 3806296088) strcat(s, "e");
if (crc32("GhSHjUmV",8) == 1879926233) strcat(s, "s");
if (crc32("rBPpKupWhbKcKuy",15) == 1121763090) strcat(s, "h");
if (crc32("JSiVBcK",7) == 3398655077) strcat(s, "p");
if (crc32("alWIyu",6) == 3651871048) strcat(s, "i");
if (crc32("dXJSHB",6) == 4085095263) strcat(s, "l");
if (crc32("NdHXgrKL",8) == 1355252666) strcat(s, "p");
    return s;
}

char *schoolie_nouns() {
    char *s = calloc(9);
    if (crc32("FlnwTa",6) == 3632631997) strcat(s, "w");
if (crc32("CnKPZgtqEFKSIl",14) == 444509468) strcat(s, "s");
if (crc32("dHAYumlnwThwdZ",14) == 1964191030) strcat(s, "v");
if (crc32("ebRHvnpSKIkk",12) == 2972152158) strcat(s, "c");
if (crc32("MwWzZh",6) == 1165427431) strcat(s, "h");
if (crc32("nboIsQQlIzOPiNp",15) == 1365414805) strcat(s, "o");
if (crc32("irASEnYij",9) == 2701503414) strcat(s, "o");
if (crc32("jVTIiGAcXORWC",13) == 1137808878) strcat(s, "l");
if (crc32("wiMAKQNwBRpcws",14) == 2629548584) strcat(s, "q");
if (crc32("DsSpgpFEpYYlKp",14) == 2339353573) strcat(s, "i");
if (crc32("fMznNTk",7) == 1399960547) strcat(s, "A");
if (crc32("DeSZqO",6) == 470617720) strcat(s, "e");
    return s;
}

char *codfish_nouns() {
    char *s = calloc(8);
    if (crc32("RCAtXDm",7) == 3835556348) strcat(s, "c");
if (crc32("fLtAcREHcx",10) == 3649642592) strcat(s, "k");
if (crc32("JZyStmc",7) == 2858949038) strcat(s, "o");
if (crc32("CTFhXywFY",9) == 3900182334) strcat(s, "d");
if (crc32("jEmVxcUhl",9) == 3800132100) strcat(s, "c");
if (crc32("zIWSjaoJC",9) == 804187505) strcat(s, "f");
if (crc32("HSxlIOZsJSla",12) == 4119411261) strcat(s, "V");
if (crc32("iKlSqY",6) == 2323902428) strcat(s, "i");
if (crc32("kXyeVJWNq",9) == 4240732563) strcat(s, "s");
if (crc32("gUBxnQrWBFcI",12) == 4293359887) strcat(s, "V");
if (crc32("tMcMnF",6) == 3020068478) strcat(s, "h");
    return s;
}

char *phonotactics_nouns() {
    char *s = calloc(13);
    if (crc32("SChlWtqADvuI",12) == 4237691196) strcat(s, "p");
if (crc32("oTsGpzAm",8) == 1765086856) strcat(s, "p");
if (crc32("YYjknsmBKtBqqqW",15) == 2740370652) strcat(s, "h");
if (crc32("UeuSUOY",7) == 1393761973) strcat(s, "o");
if (crc32("ZRCPbfr",7) == 2354586769) strcat(s, "d");
if (crc32("WngLrR",6) == 3243688050) strcat(s, "n");
if (crc32("dnCerohKt",9) == 3828740230) strcat(s, "w");
if (crc32("aRZDaeSQ",8) == 2368971922) strcat(s, "o");
if (crc32("CeyYgPXCxCCw",12) == 101805007) strcat(s, "t");
if (crc32("OhyZZlZbZXgrkcA",15) == 2781406596) strcat(s, "o");
if (crc32("QaFVZuKGw",9) == 1102680751) strcat(s, "a");
if (crc32("JuGUjd",6) == 2538229157) strcat(s, "c");
if (crc32("JuJSKq",6) == 2163153090) strcat(s, "t");
if (crc32("BhwLztASHKD",11) == 3042374336) strcat(s, "i");
if (crc32("JxQzvgYQ",8) == 43063718) strcat(s, "c");
if (crc32("XvbxHsUAc",9) == 4165141424) strcat(s, "s");
    return s;
}

char *taxidermist_nouns() {
    char *s = calloc(12);
    if (crc32("GHwostVWo",9) == 1821008911) strcat(s, "G");
if (crc32("gFxSu",5) == 3092572525) strcat(s, "t");
if (crc32("mLUSy",5) == 2450376411) strcat(s, "D");
if (crc32("TaunKiaPcNi",11) == 4097680471) strcat(s, "a");
if (crc32("UgyYIUJoG",9) == 654806379) strcat(s, "I");
if (crc32("IlWpybREa",9) == 1128424344) strcat(s, "x");
if (crc32("xOJmtWm",7) == 3628644329) strcat(s, "h");
if (crc32("QrjKhUDe",8) == 1010664502) strcat(s, "i");
if (crc32("tDEqCyPSnSAcGD",14) == 1280047085) strcat(s, "d");
if (crc32("hrgsgqyHosZitXQ",15) == 1310648720) strcat(s, "e");
if (crc32("mBZbu",5) == 1253586708) strcat(s, "C");
if (crc32("FDXlugLBLvAbmGS",15) == 1367341939) strcat(s, "r");
if (crc32("uaDxRej",7) == 968451981) strcat(s, "m");
if (crc32("CDjPRWucBpVpA",13) == 340503356) strcat(s, "C");
if (crc32("ztsjIHWvIeggsN",14) == 2720398892) strcat(s, "i");
if (crc32("ocUzuZiNsxYMqem",15) == 514008492) strcat(s, "s");
if (crc32("nPJyCcmbFgE",11) == 2072096465) strcat(s, "t");
    return s;
}

char *roundel_nouns() {
    char *s = calloc(8);
    if (crc32("mptLTWLhAjibMhZ",15) == 1953049655) strcat(s, "r");
if (crc32("qpZgGlaGDnzvdI",14) == 2732430637) strcat(s, "T");
if (crc32("UNwdIcCLYeP",11) == 2744165551) strcat(s, "o");
if (crc32("dKdlZd",6) == 4068919096) strcat(s, "u");
if (crc32("cBJmmHvdRPEQgqX",15) == 2436304508) strcat(s, "n");
if (crc32("CcuprAOVapx",11) == 3122105968) strcat(s, "n");
if (crc32("jVYamBSyGQLCw",13) == 3625706970) strcat(s, "d");
if (crc32("euanMTMyqtKSw",13) == 178422609) strcat(s, "e");
if (crc32("DTshFUufyHaRs",13) == 4039969505) strcat(s, "S");
if (crc32("gdqnb",5) == 1418033198) strcat(s, "l");
    return s;
}

char *wording_nouns() {
    char *s = calloc(8);
    if (crc32("GJyzAYCI",8) == 372352883) strcat(s, "F");
if (crc32("CpXIX",5) == 2498373530) strcat(s, "w");
if (crc32("rtJMDO",6) == 99040172) strcat(s, "o");
if (crc32("IbeatetnyChf",12) == 3331866583) strcat(s, "j");
if (crc32("MvnxgVqodV",10) == 2694997747) strcat(s, "r");
if (crc32("cGQqtuNhNLy",11) == 1960076770) strcat(s, "u");
if (crc32("tHeEqmlaJUPOyAj",15) == 2010496298) strcat(s, "d");
if (crc32("osIqRUta",8) == 656012125) strcat(s, "i");
if (crc32("NjgVrAy",7) == 3517540877) strcat(s, "Y");
if (crc32("JbQQMHfdDwx",11) == 1527107461) strcat(s, "n");
if (crc32("fkvaDHYZM",9) == 3496376852) strcat(s, "g");
    return s;
}

char *featherbrain_nouns() {
    char *s = calloc(13);
    if (crc32("rsNdFnIpCAQEMn",14) == 853467717) strcat(s, "n");
if (crc32("kEjPfmObxDYjhQd",15) == 203692190) strcat(s, "f");
if (crc32("uXlUrERBSt",10) == 3470059750) strcat(s, "e");
if (crc32("DbBddUGQI",9) == 1122206203) strcat(s, "l");
if (crc32("FnxzDPDEZMQNe",13) == 1795005996) strcat(s, "a");
if (crc32("LldFKSnaSg",10) == 4235564264) strcat(s, "W");
if (crc32("xXXFsvoQ",8) == 3929856117) strcat(s, "t");
if (crc32("PGLdIDWduyvx",12) == 3858883304) strcat(s, "h");
if (crc32("lWZgWWpbtWXCk",13) == 2899519069) strcat(s, "O");
if (crc32("aozucklBFoOvu",13) == 4209616243) strcat(s, "e");
if (crc32("oueQEruP",8) == 4165630744) strcat(s, "W");
if (crc32("QklcXsDqXHZfZ",13) == 4129819290) strcat(s, "r");
if (crc32("jnbjsPQcpJY",11) == 3072363395) strcat(s, "Y");
if (crc32("FaZuSqGNcU",10) == 641627267) strcat(s, "b");
if (crc32("JxhaiUOBofx",11) == 3324362780) strcat(s, "r");
if (crc32("pLkqGIqTmRQCGs",14) == 2134079209) strcat(s, "P");
if (crc32("hFgyxRkUO",9) == 1106735084) strcat(s, "a");
if (crc32("QyISHGNZeBwiA",13) == 3275746565) strcat(s, "z");
if (crc32("ymjqoI",6) == 276878602) strcat(s, "i");
if (crc32("aiSDFeXe",8) == 1439775349) strcat(s, "N");
if (crc32("iINMcvTJB",9) == 4007534211) strcat(s, "n");
    return s;
}

char *aluminum_nouns() {
    char *s = calloc(9);
    if (crc32("rdLWf",5) == 3655294908) strcat(s, "a");
if (crc32("ZVNOCDrgZSa",11) == 1958016053) strcat(s, "P");
if (crc32("IKMIPz",6) == 2867355782) strcat(s, "l");
if (crc32("OGeMKsRTshfAa",13) == 1758731821) strcat(s, "N");
if (crc32("GEFdNjcIUHhAgrk",15) == 4130670126) strcat(s, "u");
if (crc32("mezkMHc",7) == 3827830690) strcat(s, "m");
if (crc32("iWfRTqWYdFtIzSG",15) == 3353710243) strcat(s, "f");
if (crc32("KcresW",6) == 1962465583) strcat(s, "i");
if (crc32("fiGKBO",6) == 2775395323) strcat(s, "n");
if (crc32("BqKEds",6) == 910483519) strcat(s, "i");
if (crc32("WSgcHdB",7) == 340775881) strcat(s, "u");
if (crc32("FhphYmTs",8) == 1468182445) strcat(s, "I");
if (crc32("mKtHITDMrkVK",12) == 4279263011) strcat(s, "m");
    return s;
}

char *quoit_nouns() {
    char *s = calloc(6);
    if (crc32("QeCbXavKc",9) == 927434835) strcat(s, "q");
if (crc32("COZsOflvtGE",11) == 439480126) strcat(s, "u");
if (crc32("aynAqV",6) == 2552570963) strcat(s, "o");
if (crc32("igIywawq",8) == 1894718995) strcat(s, "H");
if (crc32("lEXZD",5) == 1700825601) strcat(s, "i");
if (crc32("qrwkWNVe",8) == 340724205) strcat(s, "q");
if (crc32("crbMZP",6) == 2128784073) strcat(s, "t");
    return s;
}

char *note_nouns() {
    char *s = calloc(5);
    if (crc32("rcfFDaTMGmawAA",14) == 4052357530) strcat(s, "n");
if (crc32("AcXQIzUHYQodORE",15) == 95396719) strcat(s, "o");
if (crc32("tvpPStq",7) == 1749305158) strcat(s, "t");
if (crc32("TbYWgLSyw",9) == 328354614) strcat(s, "d");
if (crc32("LPPFLYM",7) == 2394009402) strcat(s, "e");
    return s;
}

char *Lenape_nouns() {
    char *s = calloc(7);
    if (crc32("pigKRaMC",8) == 2257377087) strcat(s, "W");
if (crc32("TdSEE",5) == 1521967348) strcat(s, "L");
if (crc32("eEwUFs",6) == 2321044488) strcat(s, "e");
if (crc32("iUMZjgHXFhrtLeN",15) == 48127729) strcat(s, "B");
if (crc32("etmxcN",6) == 2847095680) strcat(s, "n");
if (crc32("hwTTbvc",7) == 1888210894) strcat(s, "X");
if (crc32("NWZTCh",6) == 1503348066) strcat(s, "a");
if (crc32("YeTWECiiabY",11) == 1853733143) strcat(s, "p");
if (crc32("EMbLzPux",8) == 2635335349) strcat(s, "e");
    return s;
}

char *bra_nouns() {
    char *s = calloc(4);
    if (crc32("ZUgwclRS",8) == 2627444859) strcat(s, "b");
if (crc32("KkKeSVdClmPSn",13) == 2129470518) strcat(s, "T");
if (crc32("ZYpoGkBhrxfGikb",15) == 2628824311) strcat(s, "r");
if (crc32("mSJSfZxU",8) == 1845514244) strcat(s, "a");
    return s;
}

char *Flam_nouns() {
    char *s = calloc(5);
    if (crc32("lhblSzJAfN",10) == 259543884) strcat(s, "F");
if (crc32("OTkNaRMceCGWY",13) == 3829332857) strcat(s, "l");
if (crc32("kMxXzw",6) == 861747442) strcat(s, "d");
if (crc32("vhwqeuLUlDvUsa",14) == 2994498587) strcat(s, "a");
if (crc32("JxVaUaxOaJhV",12) == 223505244) strcat(s, "G");
if (crc32("GrHuoNHrRvOQNkB",15) == 3134412114) strcat(s, "m");
    return s;
}

char *consciousness_nouns() {
    char *s = calloc(14);
    if (crc32("jcYfQJdH",8) == 3566135648) strcat(s, "c");
if (crc32("VBuenEBWiyTPBE",14) == 2939913025) strcat(s, "o");
if (crc32("JyPFpQILTHW",11) == 3239937339) strcat(s, "n");
if (crc32("JiyQyyIPcCQY",12) == 3583946553) strcat(s, "s");
if (crc32("acZuJWVQVXRqPU",14) == 3826261185) strcat(s, "c");
if (crc32("JFipWKhItecom",13) == 2336927692) strcat(s, "Q");
if (crc32("rDPIbQwzqXA",11) == 2887334704) strcat(s, "i");
if (crc32("laAGxbNGe",9) == 274201211) strcat(s, "o");
if (crc32("OAHdOYWflk",10) == 1918306813) strcat(s, "H");
if (crc32("OFXmQorv",8) == 2809028010) strcat(s, "u");
if (crc32("QrRuHNM",7) == 1476976236) strcat(s, "s");
if (crc32("tnTuOheULVInd",13) == 2631608055) strcat(s, "f");
if (crc32("YxfbTAwJIuZCW",13) == 3316189408) strcat(s, "n");
if (crc32("SSVdYOfxUAs",11) == 934415845) strcat(s, "e");
if (crc32("LyBUMw",6) == 1492235351) strcat(s, "P");
if (crc32("wyOjrszDohZZejX",15) == 3736195297) strcat(s, "s");
if (crc32("VImsEZnJEeCfv",13) == 3434121894) strcat(s, "s");
    return s;
}

char *Rawalpindi_nouns() {
    char *s = calloc(11);
    if (crc32("OKXFJxkzwZDOxGu",15) == 988911461) strcat(s, "t");
if (crc32("TaNAYLvgqUsjLOn",15) == 2826254733) strcat(s, "R");
if (crc32("HBJebjhzKULh",12) == 2415456253) strcat(s, "a");
if (crc32("MeGedTBtrGFtM",13) == 3072151863) strcat(s, "k");
if (crc32("NrWAxyFFlpLintu",15) == 2647558216) strcat(s, "w");
if (crc32("JIHApztNfA",10) == 339882591) strcat(s, "a");
if (crc32("SuhRrlUYWAN",11) == 968996676) strcat(s, "l");
if (crc32("OaLRVNxb",8) == 3318964975) strcat(s, "U");
if (crc32("mHkJGzMU",8) == 673970013) strcat(s, "p");
if (crc32("pJABPwQNeEU",11) == 758492393) strcat(s, "i");
if (crc32("wRiTggYOwKCHBR",14) == 809920139) strcat(s, "n");
if (crc32("EDBnTk",6) == 2240087124) strcat(s, "l");
if (crc32("golAg",5) == 4111205358) strcat(s, "d");
if (crc32("AtQskhDcjD",10) == 1953773101) strcat(s, "t");
if (crc32("ZFSaSlVvhSD",11) == 121861787) strcat(s, "i");
    return s;
}

char *Massimiliano_nouns() {
    char *s = calloc(13);
    if (crc32("LeaXPfMV",8) == 1239240389) strcat(s, "M");
if (crc32("umJiIgIUY",9) == 2171687031) strcat(s, "a");
if (crc32("oRwut",5) == 3906639595) strcat(s, "s");
if (crc32("yfqvHPq",7) == 2764675147) strcat(s, "M");
if (crc32("mGmgcJVFkcZ",11) == 1744723948) strcat(s, "s");
if (crc32("UMmxuwNBsWdVw",13) == 70254920) strcat(s, "i");
if (crc32("gEUGFzTUi",9) == 2548093726) strcat(s, "m");
if (crc32("trLULLimDHEo",12) == 1484484132) strcat(s, "d");
if (crc32("BmpkcDCZ",8) == 265397660) strcat(s, "i");
if (crc32("RxKlnGJdAw",10) == 96659966) strcat(s, "N");
if (crc32("fvjnEs",6) == 1261253120) strcat(s, "l");
if (crc32("dclMIejKl",9) == 3665715100) strcat(s, "N");
if (crc32("bEBLaGigzLiow",13) == 2844047875) strcat(s, "i");
if (crc32("jWehw",5) == 2647326584) strcat(s, "t");
if (crc32("zKUZVGEEpPgpXn",14) == 3984615128) strcat(s, "a");
if (crc32("qCPFdYqQt",9) == 660294658) strcat(s, "n");
if (crc32("jhIULyupUzKawKU",15) == 2539594124) strcat(s, "f");
if (crc32("DTRaX",5) == 1498474655) strcat(s, "o");
    return s;
}

char *helminthiasis_nouns() {
    char *s = calloc(14);
    if (crc32("eteMoQcvAopkzd",14) == 57188719) strcat(s, "u");
if (crc32("NnzsMzNt",8) == 2684171902) strcat(s, "h");
if (crc32("BjDAZsVmp",9) == 3226002739) strcat(s, "e");
if (crc32("vEOmQPdzBLVfg",13) == 4285187983) strcat(s, "L");
if (crc32("GELYIOUlRhQc",12) == 378397606) strcat(s, "l");
if (crc32("fJLLcDlPP",9) == 3504675756) strcat(s, "m");
if (crc32("kNuyddsMKmZxuT",14) == 4188619679) strcat(s, "k");
if (crc32("CrzXpNAL",8) == 2620260961) strcat(s, "i");
if (crc32("KPBKKIPJrcCvq",13) == 3758927199) strcat(s, "n");
if (crc32("EuTwH",5) == 1495154938) strcat(s, "N");
if (crc32("PlmZuduNyM",10) == 3416972564) strcat(s, "t");
if (crc32("WsMErM",6) == 342944353) strcat(s, "h");
if (crc32("fRGOPpXKhsiqReM",15) == 3445666020) strcat(s, "i");
if (crc32("anoPTvWIowen",12) == 49878490) strcat(s, "a");
if (crc32("OMtwmTuSAOdQ",12) == 1632280205) strcat(s, "a");
if (crc32("DJZORim",7) == 3661303754) strcat(s, "s");
if (crc32("IyjrPvjntIvWU",13) == 2204446922) strcat(s, "a");
if (crc32("NNhKffCAkwAs",12) == 923058427) strcat(s, "i");
if (crc32("LsVTBkUSw",9) == 3506346458) strcat(s, "s");
    return s;
}

char *missioner_nouns() {
    char *s = calloc(10);
    if (crc32("XsfybcyJN",9) == 3560797972) strcat(s, "B");
if (crc32("DryasqnxzNIQOi",14) == 510193214) strcat(s, "m");
if (crc32("ebpUIj",6) == 1899828161) strcat(s, "K");
if (crc32("HbqJJRuMwFgNL",13) == 1644953150) strcat(s, "i");
if (crc32("clfsHuugvQkKy",13) == 1705266113) strcat(s, "s");
if (crc32("DvoKZHSBxSN",11) == 1904016941) strcat(s, "s");
if (crc32("FCuGWblbbWzcQk",14) == 1643201160) strcat(s, "i");
if (crc32("nnupEVqYCnEvbG",14) == 1665452272) strcat(s, "o");
if (crc32("wkLBTELurQCyp",13) == 4142773970) strcat(s, "E");
if (crc32("tRcvFtxe",8) == 909734210) strcat(s, "n");
if (crc32("PLOredESO",9) == 1995242481) strcat(s, "S");
if (crc32("PVVfGrslntN",11) == 541395153) strcat(s, "e");
if (crc32("YkUhOMENjKeDkb",14) == 413163057) strcat(s, "A");
if (crc32("HVpdilyFJK",10) == 1183255445) strcat(s, "r");
    return s;
}

char *Hagecius_nouns() {
    char *s = calloc(9);
    if (crc32("FoKZZ",5) == 2825578140) strcat(s, "w");
if (crc32("GGLCRAWk",8) == 2681857145) strcat(s, "H");
if (crc32("vEOjvRSoPOlgrQ",14) == 2994633310) strcat(s, "M");
if (crc32("dOkiKYqSYBGnz",13) == 822103230) strcat(s, "a");
if (crc32("omvQMCJzy",9) == 3465669163) strcat(s, "g");
if (crc32("wtusrTW",7) == 1253120913) strcat(s, "i");
if (crc32("nAogGnWgGdtNhB",14) == 4189776018) strcat(s, "e");
if (crc32("wCxIT",5) == 3077220051) strcat(s, "i");
if (crc32("vwnCkXHug",9) == 2385296675) strcat(s, "c");
if (crc32("qqxZFveA",8) == 3470580236) strcat(s, "m");
if (crc32("lKOhXkPmZhTC",12) == 2596712607) strcat(s, "i");
if (crc32("YvGjFhgwwaKHNN",14) == 1291715328) strcat(s, "u");
if (crc32("KVESqJwsxfimxAM",15) == 2703576287) strcat(s, "e");
if (crc32("iNpsIKrENNCH",12) == 1909195137) strcat(s, "s");
    return s;
}

char *rimester_nouns() {
    char *s = calloc(9);
    if (crc32("XCZnVW",6) == 2573202120) strcat(s, "z");
if (crc32("XJyxwm",6) == 1559515131) strcat(s, "r");
if (crc32("jznFllk",7) == 4063518135) strcat(s, "T");
if (crc32("ZIizPMaSAvTpIa",14) == 2522482682) strcat(s, "i");
if (crc32("ISrabVJLLhA",11) == 2260014589) strcat(s, "m");
if (crc32("sNcYnxQDF",9) == 3670038580) strcat(s, "Z");
if (crc32("uGzTSudTF",9) == 2374395640) strcat(s, "e");
if (crc32("XprPKvvW",8) == 364316871) strcat(s, "k");
if (crc32("HRzxcSaIpf",10) == 1454900891) strcat(s, "s");
if (crc32("cvLmVs",6) == 2688273706) strcat(s, "D");
if (crc32("nxNqZ",5) == 2302011093) strcat(s, "t");
if (crc32("jdWqnpRwjlEPe",13) == 2438866226) strcat(s, "e");
if (crc32("IsQooPLyOu",10) == 406338732) strcat(s, "A");
if (crc32("RIfFhgHrZAGvBnF",15) == 3447847403) strcat(s, "r");
    return s;
}

char *swager_nouns() {
    char *s = calloc(7);
    if (crc32("tqAnGrQZQbEFN",13) == 1595197883) strcat(s, "U");
if (crc32("bxXibPv",7) == 1626843022) strcat(s, "s");
if (crc32("YrGCI",5) == 161631244) strcat(s, "z");
if (crc32("COMMKHNs",8) == 4139572212) strcat(s, "w");
if (crc32("ACDNdSh",7) == 3175451895) strcat(s, "a");
if (crc32("aUZNVNU",7) == 336862980) strcat(s, "z");
if (crc32("PVnvvVAqOTYyK",13) == 4243406524) strcat(s, "g");
if (crc32("WkDtWKathatLbZ",14) == 99460357) strcat(s, "e");
if (crc32("KMSbei",6) == 3761220071) strcat(s, "v");
if (crc32("jtsXzWzBzkoVmY",14) == 4028802290) strcat(s, "r");
    return s;
}

char *reviewability_nouns() {
    char *s = calloc(14);
    if (crc32("OwgAkgBnEdE",11) == 4083881033) strcat(s, "r");
if (crc32("yVYyKGHbeMc",11) == 1166108981) strcat(s, "e");
if (crc32("HDMGyCkxLU",10) == 484144106) strcat(s, "v");
if (crc32("UYrqkhHPQy",10) == 3040389087) strcat(s, "i");
if (crc32("disTNVpcA",9) == 1893886117) strcat(s, "e");
if (crc32("WXWMUBvfWDigm",13) == 2450014356) strcat(s, "Q");
if (crc32("QpwkE",5) == 2037368924) strcat(s, "w");
if (crc32("anwUFGxhUdI",11) == 4235329707) strcat(s, "F");
if (crc32("FQVMadJM",8) == 3145328682) strcat(s, "a");
if (crc32("hBzcKRYXJ",9) == 1699988623) strcat(s, "b");
if (crc32("oKCVNxkzU",9) == 528498169) strcat(s, "T");
if (crc32("OWFlcpCvJO",10) == 2071359643) strcat(s, "i");
if (crc32("hbnQeWjdKGRvAI",14) == 1069164412) strcat(s, "l");
if (crc32("LsStzIGnomima",13) == 1921287863) strcat(s, "H");
if (crc32("nVyFsjJctEpT",12) == 554995573) strcat(s, "i");
if (crc32("tJkcyVmvouePgTC",15) == 3561285150) strcat(s, "N");
if (crc32("odzZEAbasAW",11) == 692685339) strcat(s, "t");
if (crc32("TeSvZjKsLCc",11) == 3150090677) strcat(s, "y");
    return s;
}

char *oeuvre_nouns() {
    char *s = calloc(7);
    if (crc32("nuRCjly",7) == 1940503561) strcat(s, "o");
if (crc32("dAiVGQVrhK",10) == 1771634928) strcat(s, "s");
if (crc32("mhHkUm",6) == 1107779916) strcat(s, "e");
if (crc32("YkHaRrNTpau",11) == 1605350075) strcat(s, "e");
if (crc32("elkWIFat",8) == 3770331747) strcat(s, "u");
if (crc32("RPnVVo",6) == 1253282749) strcat(s, "v");
if (crc32("WFAOpRdsClqp",12) == 3872932937) strcat(s, "r");
if (crc32("KAsnJPvzGLZ",11) == 3751500465) strcat(s, "e");
    return s;
}

char *muskallonge_nouns() {
    char *s = calloc(12);
    if (crc32("DWnBcSMEYomgfy",14) == 3388812927) strcat(s, "m");
if (crc32("IhPsGJoBwRaR",12) == 886250123) strcat(s, "u");
if (crc32("PtzDVERtet",10) == 1306505572) strcat(s, "s");
if (crc32("JTBkNjovQeMLoB",14) == 397400713) strcat(s, "k");
if (crc32("wLBLpqXS",8) == 4175400733) strcat(s, "E");
if (crc32("KwXOqthAMB",10) == 3144771162) strcat(s, "a");
if (crc32("YcsQIVAL",8) == 99995298) strcat(s, "l");
if (crc32("cdxSRVbctohB",12) == 886953165) strcat(s, "l");
if (crc32("FoIttc",6) == 2317888332) strcat(s, "v");
if (crc32("qzeicYnPfprZn",13) == 2466026203) strcat(s, "o");
if (crc32("rrcDitFhC",9) == 3399272118) strcat(s, "r");
if (crc32("liCuyjhRYWgF",12) == 3807747126) strcat(s, "n");
if (crc32("YMufDOsljvsD",12) == 1197917301) strcat(s, "g");
if (crc32("VEDiMjGBJHN",11) == 3841214069) strcat(s, "q");
if (crc32("ivdnnlEi",8) == 3004028224) strcat(s, "e");
    return s;
}

char *daybeacon_nouns() {
    char *s = calloc(10);
    if (crc32("yyPbwcvhZkUh",12) == 641353363) strcat(s, "O");
if (crc32("LEVRlIXD",8) == 2555349365) strcat(s, "d");
if (crc32("tKsumIdFPC",10) == 2832483157) strcat(s, "a");
if (crc32("KyQSmP",6) == 2263639426) strcat(s, "y");
if (crc32("AVjPjXexuj",10) == 4185782986) strcat(s, "b");
if (crc32("UMXvwyVNzJ",10) == 976985394) strcat(s, "c");
if (crc32("qHFzIUqfid",10) == 2168225051) strcat(s, "e");
if (crc32("KrqGwwJYPYDAdiu",15) == 453515057) strcat(s, "m");
if (crc32("ufRGojy",7) == 1287779890) strcat(s, "a");
if (crc32("BqUJiVXYoxE",11) == 2680281001) strcat(s, "I");
if (crc32("LxNJteQwsVFul",13) == 2469217527) strcat(s, "c");
if (crc32("RDMcYWD",7) == 2323790571) strcat(s, "y");
if (crc32("hjpahfu",7) == 2736673379) strcat(s, "o");
if (crc32("PPOrQokgKk",10) == 392431228) strcat(s, "n");
    return s;
}

char *teenybopper_nouns() {
    char *s = calloc(12);
    if (crc32("erucYaISfx",10) == 1051930670) strcat(s, "t");
if (crc32("iZbdjkXV",8) == 2722561242) strcat(s, "D");
if (crc32("DYCpupX",7) == 1785749413) strcat(s, "e");
if (crc32("SzcbyuwGU",9) == 3398615253) strcat(s, "R");
if (crc32("YKURwQq",7) == 173366605) strcat(s, "e");
if (crc32("VyOeCmEgV",9) == 3068032605) strcat(s, "n");
if (crc32("vmxsxZRQGLGS",12) == 2305736143) strcat(s, "y");
if (crc32("hbautOKrY",9) == 1493620118) strcat(s, "b");
if (crc32("StqjEoiJO",9) == 2199285583) strcat(s, "F");
if (crc32("zGjSKTuJnWIfc",13) == 1590424435) strcat(s, "o");
if (crc32("wOjOObtKeF",10) == 4230064467) strcat(s, "z");
if (crc32("WQKcQfwnqtlwiF",14) == 217527694) strcat(s, "p");
if (crc32("uLBrHaJ",7) == 3209071883) strcat(s, "Y");
if (crc32("PyvirgCRNG",10) == 2142025395) strcat(s, "p");
if (crc32("FKWrZIblDW",10) == 3206953120) strcat(s, "M");
if (crc32("NAkTLNynggJp",12) == 1646986076) strcat(s, "e");
if (crc32("pIptjBCmXOFYV",13) == 4270159881) strcat(s, "E");
if (crc32("tsEStNopaVCo",12) == 3652818724) strcat(s, "r");
    return s;
}

char *abstractionist_nouns() {
    char *s = calloc(15);
    if (crc32("MpXNPbnBttsk",12) == 1770014737) strcat(s, "c");
if (crc32("AIUzUHWmvrUke",13) == 3699394494) strcat(s, "a");
if (crc32("rBoggERJx",9) == 792686354) strcat(s, "e");
if (crc32("frDFeQ",6) == 2298101459) strcat(s, "b");
if (crc32("JTPsauXynKm",11) == 3048201358) strcat(s, "s");
if (crc32("tKvervYpPeiqB",13) == 3247412821) strcat(s, "t");
if (crc32("RIEyVdmVZ",9) == 424660243) strcat(s, "s");
if (crc32("gjNHiBTk",8) == 4238138451) strcat(s, "r");
if (crc32("ffqsZc",6) == 3072098245) strcat(s, "e");
if (crc32("XjJcrPaPWpkT",12) == 3247446669) strcat(s, "a");
if (crc32("XlsRIi",6) == 247097705) strcat(s, "c");
if (crc32("BQwYLsLVt",9) == 2872048260) strcat(s, "t");
if (crc32("zUuHJAfcUDPsH",13) == 3444127892) strcat(s, "z");
if (crc32("vGLun",5) == 934361022) strcat(s, "i");
if (crc32("tdWwChiH",8) == 1468597561) strcat(s, "L");
if (crc32("lyrZfIajwvhkn",13) == 3636629056) strcat(s, "o");
if (crc32("dWpINh",6) == 2440258054) strcat(s, "n");
if (crc32("OHAZCBPlfaoTquJ",15) == 1213533793) strcat(s, "i");
if (crc32("rqDdjEv",7) == 2375166976) strcat(s, "B");
if (crc32("JKOfUrjmfkzYpOe",15) == 3241692728) strcat(s, "s");
if (crc32("VoKgdKUhyaLHoEZ",15) == 640353927) strcat(s, "t");
    return s;
}

char *Lannie_nouns() {
    char *s = calloc(7);
    if (crc32("eKtfZvuuuifgcuf",15) == 4092288320) strcat(s, "e");
if (crc32("QOsHbhGQGSF",11) == 2487256191) strcat(s, "L");
if (crc32("kffcLPCtzYTrUpP",15) == 1724473037) strcat(s, "W");
if (crc32("FpSPtcoLBgi",11) == 2363595338) strcat(s, "a");
if (crc32("jItNHSnqpiAAm",13) == 3914006799) strcat(s, "n");
if (crc32("gbWeNizFWZ",10) == 2347301651) strcat(s, "n");
if (crc32("mgvnnodmhJL",11) == 835271108) strcat(s, "i");
if (crc32("NeSvsxFCNcubPSE",15) == 4224379018) strcat(s, "o");
if (crc32("xzktwAIM",8) == 2458440972) strcat(s, "e");
    return s;
}

char *grafter_nouns() {
    char *s = calloc(8);
    if (crc32("ausHRwHqQ",9) == 1535234760) strcat(s, "m");
if (crc32("YbJPqqE",7) == 3539103182) strcat(s, "g");
if (crc32("ivaLJHzyibbZtdT",15) == 2300857719) strcat(s, "r");
if (crc32("wyHemOf",7) == 1875556031) strcat(s, "r");
if (crc32("GWOlzxttpuoGufG",15) == 3373845693) strcat(s, "S");
if (crc32("hdflxP",6) == 3940205960) strcat(s, "a");
if (crc32("HsCGtNfBbV",10) == 1318583201) strcat(s, "f");
if (crc32("GZubsABHfg",10) == 3465753834) strcat(s, "d");
if (crc32("LtsyQhldqUT",11) == 1161609530) strcat(s, "t");
if (crc32("nHZmk",5) == 3583527103) strcat(s, "e");
if (crc32("ReEciK",6) == 3421498796) strcat(s, "B");
if (crc32("udadb",5) == 2825713462) strcat(s, "r");
    return s;
}

char *Illyria_nouns() {
    char *s = calloc(8);
    if (crc32("bsQfrhCDTT",10) == 756516504) strcat(s, "I");
if (crc32("jZQcZXMZYP",10) == 233000603) strcat(s, "e");
if (crc32("gISpuUdX",8) == 1340086119) strcat(s, "l");
if (crc32("jNjKB",5) == 2691977083) strcat(s, "l");
if (crc32("pGHzkhVBUbe",11) == 1512414429) strcat(s, "y");
if (crc32("mGwTXVQ",7) == 4176447517) strcat(s, "r");
if (crc32("CFkxTfnWahRRV",13) == 2857259978) strcat(s, "x");
if (crc32("ITIaiSlXIQP",11) == 1774379021) strcat(s, "i");
if (crc32("lFEaH",5) == 1445967583) strcat(s, "a");
    return s;
}

char *detail_nouns() {
    char *s = calloc(7);
    if (crc32("PqgYfohGmkP",11) == 691159763) strcat(s, "f");
if (crc32("wnzhXB",6) == 689010806) strcat(s, "d");
if (crc32("wNIzBIaXwpsv",12) == 3331742298) strcat(s, "e");
if (crc32("EOxiyYKFJx",10) == 1497674991) strcat(s, "n");
if (crc32("IjxZCBsChwFNQ",13) == 2619269771) strcat(s, "t");
if (crc32("bNSffGYBYYsgUeO",15) == 2767796970) strcat(s, "a");
if (crc32("HoCtzNqFpV",10) == 47338374) strcat(s, "P");
if (crc32("jRQkPXIVwAH",11) == 887292069) strcat(s, "i");
if (crc32("iRttcs",6) == 2054211284) strcat(s, "F");
if (crc32("fPeLF",5) == 2519897909) strcat(s, "l");
    return s;
}

char *Gerti_nouns() {
    char *s = calloc(6);
    if (crc32("suswFeGIdwrA",12) == 2787256170) strcat(s, "G");
if (crc32("BDOhoQyCp",9) == 1442631137) strcat(s, "e");
if (crc32("BjFmSXulRqSG",12) == 4007892197) strcat(s, "a");
if (crc32("eVyNAZVtnkjG",12) == 468031063) strcat(s, "r");
if (crc32("BEuJWJLYkhFSN",13) == 509179184) strcat(s, "t");
if (crc32("atkbAJvTtJWjoZX",15) == 808327542) strcat(s, "i");
    return s;
}

char *Maggiore_nouns() {
    char *s = calloc(9);
    if (crc32("hnfmStcjMlnGfnh",15) == 2429373296) strcat(s, "R");
if (crc32("aQButW",6) == 2858604943) strcat(s, "M");
if (crc32("whbXbiPpIvPu",12) == 2262075973) strcat(s, "G");
if (crc32("AqmiSCOFSYK",11) == 484632955) strcat(s, "a");
if (crc32("MBudmnSAX",9) == 2890642448) strcat(s, "H");
if (crc32("CILEMTd",7) == 492557819) strcat(s, "g");
if (crc32("xlzhImM",7) == 1353185700) strcat(s, "s");
if (crc32("lVTOctz",7) == 3025887948) strcat(s, "g");
if (crc32("iguXkjk",7) == 2831728228) strcat(s, "i");
if (crc32("WHZHCoFWlJ",10) == 1379715851) strcat(s, "E");
if (crc32("MWyLxllmYWKTGgO",15) == 2699765990) strcat(s, "o");
if (crc32("qrczOltiWqXvBfB",15) == 1256279540) strcat(s, "r");
if (crc32("kQwbvAlM",8) == 1727896034) strcat(s, "e");
    return s;
}

char *Kempis_nouns() {
    char *s = calloc(7);
    if (crc32("rpFpaT",6) == 3088099112) strcat(s, "G");
if (crc32("fJIywSjiCVSv",12) == 4135008996) strcat(s, "K");
if (crc32("pBRtWVQOguHvO",13) == 3724704720) strcat(s, "e");
if (crc32("ZrEGUqUipOOUH",13) == 3970855638) strcat(s, "V");
if (crc32("mJyNpSXdvJi",11) == 2912517206) strcat(s, "m");
if (crc32("LmwkEBqAZFBm",12) == 699420459) strcat(s, "p");
if (crc32("dKfiMb",6) == 2997153019) strcat(s, "i");
if (crc32("YIqrgGALX",9) == 26878709) strcat(s, "a");
if (crc32("eyKwWXEitn",10) == 3322017434) strcat(s, "s");
    return s;
}

char *postern_nouns() {
    char *s = calloc(8);
    if (crc32("bhKbzHxsTUlrS",13) == 1037875026) strcat(s, "p");
if (crc32("hPipOAr",7) == 4194944002) strcat(s, "o");
if (crc32("TNeIVArPrzZLLRV",15) == 1227639717) strcat(s, "c");
if (crc32("YWafhhVGXCy",11) == 325881003) strcat(s, "s");
if (crc32("pcAhkqWq",8) == 2325122886) strcat(s, "j");
if (crc32("qZJznWXGpoGwQLS",15) == 2910761008) strcat(s, "t");
if (crc32("HVjSOXYfAANo",12) == 1902214283) strcat(s, "D");
if (crc32("tNzdafaBXeEmtAC",15) == 1396592904) strcat(s, "e");
if (crc32("XMhyrWbffBlRRlW",15) == 3494640972) strcat(s, "r");
if (crc32("AXCqhGkrcpl",11) == 4112328786) strcat(s, "n");
    return s;
}

char *enameler_nouns() {
    char *s = calloc(9);
    if (crc32("juxdwESb",8) == 2735283034) strcat(s, "e");
if (crc32("YzYCeszkPJHF",12) == 534678132) strcat(s, "q");
if (crc32("hGRcWicsukmI",12) == 3289954130) strcat(s, "n");
if (crc32("tuqVNlpqGP",10) == 2991770527) strcat(s, "C");
if (crc32("BrcOKtwhE",9) == 2367304693) strcat(s, "a");
if (crc32("IaVIUAXORZXuy",13) == 3097778118) strcat(s, "m");
if (crc32("jnyKWHbVa",9) == 1778722915) strcat(s, "n");
if (crc32("DTZMZBFnTSSh",12) == 287789685) strcat(s, "e");
if (crc32("IuUjYCclJGIf",12) == 3284383589) strcat(s, "v");
if (crc32("MvGAwFE",7) == 1570487635) strcat(s, "l");
if (crc32("CewztiJi",8) == 752920520) strcat(s, "e");
if (crc32("bdBIVr",6) == 2230325828) strcat(s, "e");
if (crc32("PcGNDg",6) == 1490688637) strcat(s, "r");
    return s;
}

char *McCormack_nouns() {
    char *s = calloc(10);
    if (crc32("XWEJzEdh",8) == 2020504334) strcat(s, "M");
if (crc32("NrAxxO",6) == 2135806047) strcat(s, "c");
if (crc32("LTDxXN",6) == 2841202678) strcat(s, "C");
if (crc32("iCewoNuNSds",11) == 566292733) strcat(s, "o");
if (crc32("VWmCvQ",6) == 599605207) strcat(s, "R");
if (crc32("fvuvtd",6) == 351012212) strcat(s, "r");
if (crc32("ErAUl",5) == 2988520887) strcat(s, "P");
if (crc32("AoKoM",5) == 1446201813) strcat(s, "m");
if (crc32("VSZpohjBMyQVcZo",15) == 2709563337) strcat(s, "a");
if (crc32("OvmlVaFxgy",10) == 2433196569) strcat(s, "c");
if (crc32("qMEiKRYPu",9) == 2808913324) strcat(s, "c");
if (crc32("AUaznsuvUpn",11) == 2481922986) strcat(s, "k");
    return s;
}

char *gamer_nouns() {
    char *s = calloc(6);
    if (crc32("zuoYyGBTeunl",12) == 2563259499) strcat(s, "g");
if (crc32("igVrDK",6) == 2032380469) strcat(s, "a");
if (crc32("RfxQKUhkqsYyXvC",15) == 1600050251) strcat(s, "d");
if (crc32("UYrACSGatb",10) == 1057589947) strcat(s, "m");
if (crc32("XURGJ",5) == 1956316949) strcat(s, "e");
if (crc32("xYcKGaNpqHqS",12) == 2535629923) strcat(s, "r");
    return s;
}

char *samekh_nouns() {
    char *s = calloc(7);
    if (crc32("qSdPB",5) == 1429955253) strcat(s, "C");
if (crc32("fBufk",5) == 1521498892) strcat(s, "s");
if (crc32("KtCZpOavCpnXc",13) == 4088955622) strcat(s, "a");
if (crc32("bnVytbU",7) == 4160564589) strcat(s, "N");
if (crc32("NTKBPTT",7) == 3725869400) strcat(s, "m");
if (crc32("nKhcdSrCVTsZXyv",15) == 1587960065) strcat(s, "e");
if (crc32("PupvnuAIk",9) == 2979579442) strcat(s, "k");
if (crc32("jyTccbWAikTdx",13) == 3911577826) strcat(s, "h");
    return s;
}

char *content_nouns() {
    char *s = calloc(8);
    if (crc32("CZZhMAVvOBbdc",13) == 734020185) strcat(s, "N");
if (crc32("tTRVt",5) == 1521392846) strcat(s, "c");
if (crc32("MRkRKvHRwoYY",12) == 87305153) strcat(s, "I");
if (crc32("kEBadxpRuSNgx",13) == 3413599474) strcat(s, "o");
if (crc32("bhmAZrOLB",9) == 2473533306) strcat(s, "D");
if (crc32("jklHNf",6) == 857602534) strcat(s, "n");
if (crc32("cAzjExEv",8) == 1648474393) strcat(s, "t");
if (crc32("THtIlZa",7) == 2023693623) strcat(s, "e");
if (crc32("WtrfEkmEWhMcmXN",15) == 3265205994) strcat(s, "A");
if (crc32("LmWRSyCAdLAaX",13) == 4001599004) strcat(s, "n");
if (crc32("zlKisaLEVJvVJS",14) == 1067470718) strcat(s, "t");
    return s;
}

char *bull_nouns() {
    char *s = calloc(5);
    if (crc32("xiifEMAZNJr",11) == 3349841054) strcat(s, "V");
if (crc32("fBWpkdLZyYqx",12) == 2081715131) strcat(s, "b");
if (crc32("UqSSsUUzLD",10) == 1803611199) strcat(s, "y");
if (crc32("BxLxfqdQaNVLd",13) == 2671544081) strcat(s, "u");
if (crc32("qyehCYadfEqDaVu",15) == 3102595644) strcat(s, "C");
if (crc32("bFFtwx",6) == 4033508169) strcat(s, "l");
if (crc32("BRzFlbeFJjNJ",12) == 970773446) strcat(s, "E");
if (crc32("bIRvhnppR",9) == 1198518218) strcat(s, "l");
    return s;
}

char *Zobkiw_nouns() {
    char *s = calloc(7);
    if (crc32("ZFUyW",5) == 1803275557) strcat(s, "Z");
if (crc32("thGmAlb",7) == 2709454855) strcat(s, "A");
if (crc32("saUwbGTCmpWtc",13) == 1440541149) strcat(s, "o");
if (crc32("jsQxTuFjkh",10) == 1125833465) strcat(s, "L");
if (crc32("KcqVPeX",7) == 1850897052) strcat(s, "b");
if (crc32("pTDlMGzkGmp",11) == 3156704064) strcat(s, "k");
if (crc32("joASM",5) == 2324666685) strcat(s, "B");
if (crc32("wOZHWQhLSbfTO",13) == 1215707145) strcat(s, "i");
if (crc32("HzQOVZFYt",9) == 2244522754) strcat(s, "R");
if (crc32("BMqoj",5) == 2539553181) strcat(s, "w");
    return s;
}

char *interrobang_nouns() {
    char *s = calloc(12);
    if (crc32("EGNaJF",6) == 2742252310) strcat(s, "i");
if (crc32("CUfSwDuWgF",10) == 3226913847) strcat(s, "M");
if (crc32("jdbqKLOBl",9) == 2766042793) strcat(s, "n");
if (crc32("xshtFJ",6) == 3146976336) strcat(s, "c");
if (crc32("eLsTFTDqXheM",12) == 356507759) strcat(s, "t");
if (crc32("WzFgxHtP",8) == 3977205898) strcat(s, "o");
if (crc32("FyLssbxpQgMLBI",14) == 3394232352) strcat(s, "e");
if (crc32("rWzwEh",6) == 3862983349) strcat(s, "r");
if (crc32("KPgwoaOlMJw",11) == 2932070828) strcat(s, "f");
if (crc32("kMfLKGwtRbPjQ",13) == 2394470068) strcat(s, "r");
if (crc32("SWmNEnj",7) == 2657191694) strcat(s, "f");
if (crc32("eclWSwCIuKclqp",14) == 3706849222) strcat(s, "o");
if (crc32("pMEyWJiexc",10) == 439638582) strcat(s, "b");
if (crc32("gvGdkdcjPnTJzfx",15) == 975679698) strcat(s, "v");
if (crc32("OdmsqrcmO",9) == 2909911433) strcat(s, "a");
if (crc32("FMuFIxTXqsykeGL",15) == 2175595480) strcat(s, "K");
if (crc32("iMoZFVCnrLcn",12) == 1211604618) strcat(s, "n");
if (crc32("omGledWqQHd",11) == 3177142543) strcat(s, "g");
    return s;
}

char *monist_nouns() {
    char *s = calloc(7);
    if (crc32("hMODfutQLCboD",13) == 4289746136) strcat(s, "m");
if (crc32("mXXQMfuOlAZ",11) == 2783588619) strcat(s, "Y");
if (crc32("RaMhFXykqttOG",13) == 3598693869) strcat(s, "o");
if (crc32("hLwdZAHakwErux",14) == 2539221327) strcat(s, "n");
if (crc32("UQtXbdJhQ",9) == 4267886957) strcat(s, "I");
if (crc32("NjSjBC",6) == 3866129988) strcat(s, "i");
if (crc32("LuytAbqQiVclHwv",15) == 3507266742) strcat(s, "s");
if (crc32("IhMaKCWKSozy",12) == 1171435897) strcat(s, "s");
if (crc32("qQVUTkyaZX",10) == 2125971728) strcat(s, "t");
    return s;
}

char *azine_nouns() {
    char *s = calloc(6);
    if (crc32("cjMxzJWZS",9) == 4231241210) strcat(s, "C");
if (crc32("FUPfLaldYxE",11) == 1143582002) strcat(s, "a");
if (crc32("wKPZsHLLWhcNL",13) == 3092103465) strcat(s, "z");
if (crc32("OKNxsuMucDG",11) == 260727760) strcat(s, "u");
if (crc32("LNoHPv",6) == 814366700) strcat(s, "i");
if (crc32("hRVGnT",6) == 1113288247) strcat(s, "c");
if (crc32("QcyZF",5) == 1846102831) strcat(s, "n");
if (crc32("VhDzXT",6) == 2418955655) strcat(s, "R");
if (crc32("Iicxjdd",7) == 487813564) strcat(s, "e");
    return s;
}

char *Leonardi_nouns() {
    char *s = calloc(9);
    if (crc32("YQTLSKbXTpIk",12) == 3503370739) strcat(s, "L");
if (crc32("HuQOFHEmPky",11) == 3692816143) strcat(s, "e");
if (crc32("EKhsoIETTlJiJrL",15) == 542065127) strcat(s, "o");
if (crc32("VzdSd",5) == 3781445028) strcat(s, "n");
if (crc32("zTqDfgmz",8) == 3513993162) strcat(s, "a");
if (crc32("zBhidf",6) == 631030176) strcat(s, "r");
if (crc32("RQCaBSV",7) == 314437045) strcat(s, "d");
if (crc32("UPwTKiPWUIef",12) == 1935889748) strcat(s, "v");
if (crc32("lfrRqWVsoKj",11) == 1288346256) strcat(s, "i");
    return s;
}

char *gegenion_nouns() {
    char *s = calloc(9);
    if (crc32("KHSSKjQypkJg",12) == 468690998) strcat(s, "S");
if (crc32("sIrNjePFWdsZoD",14) == 1700922744) strcat(s, "g");
if (crc32("nUIQhfSCtIVXp",13) == 1857868766) strcat(s, "e");
if (crc32("sacAf",5) == 1052581487) strcat(s, "U");
if (crc32("cZypmGag",8) == 2058709128) strcat(s, "g");
if (crc32("GoSggEC",7) == 1417400703) strcat(s, "T");
if (crc32("yPBHHaCwPo",10) == 2133329851) strcat(s, "e");
if (crc32("mIEYXRRfsGVPCj",14) == 3778612711) strcat(s, "n");
if (crc32("poyxb",5) == 1137660114) strcat(s, "i");
if (crc32("ubAMlmQxbjylpDw",15) == 467024736) strcat(s, "o");
if (crc32("fGknrpd",7) == 1624849040) strcat(s, "n");
    return s;
}

char *AEF_nouns() {
    char *s = calloc(4);
    if (crc32("sAfWzNFqrNTEI",13) == 4017632023) strcat(s, "A");
if (crc32("BBERnPFTBMeqq",13) == 3998377763) strcat(s, "Y");
if (crc32("kEvmldq",7) == 2479405890) strcat(s, "E");
if (crc32("zQHToRX",7) == 2432461369) strcat(s, "F");
    return s;
}

char *Dacron_nouns() {
    char *s = calloc(7);
    if (crc32("VeVQOrbCjd",10) == 482173883) strcat(s, "D");
if (crc32("srtMhHPfE",9) == 4247146874) strcat(s, "f");
if (crc32("gRBVboKnAUz",11) == 3685837325) strcat(s, "a");
if (crc32("ZxZGd",5) == 2395373537) strcat(s, "c");
if (crc32("YEJIuODszzZE",12) == 3791639764) strcat(s, "r");
if (crc32("eXOySVmu",8) == 2792001142) strcat(s, "o");
if (crc32("hrKYjm",6) == 1428081648) strcat(s, "n");
    return s;
}

char *Ivy_nouns() {
    char *s = calloc(4);
    if (crc32("BnKse",5) == 2062393799) strcat(s, "I");
if (crc32("esGZsOhUao",10) == 3683418160) strcat(s, "v");
if (crc32("qntVyU",6) == 379450376) strcat(s, "B");
if (crc32("FwqSnwbzBulOLQ",14) == 1241144427) strcat(s, "y");
    return s;
}

char *mobility_nouns() {
    char *s = calloc(9);
    if (crc32("DZrweCA",7) == 1632954884) strcat(s, "m");
if (crc32("SKkPvsGAD",9) == 3187727835) strcat(s, "o");
if (crc32("ZzdsJ",5) == 84477212) strcat(s, "d");
if (crc32("WRkXxuuU",8) == 1361292475) strcat(s, "b");
if (crc32("ouAUSVC",7) == 1341361016) strcat(s, "i");
if (crc32("cyXma",5) == 22088609) strcat(s, "a");
if (crc32("dQcht",5) == 1778151332) strcat(s, "l");
if (crc32("mVrFCfATiaw",11) == 252197715) strcat(s, "X");
if (crc32("nFnCeQUafhdPOze",15) == 426559065) strcat(s, "i");
if (crc32("ANnaxPpuqEwA",12) == 1375251237) strcat(s, "Q");
if (crc32("GopFgPJn",8) == 2378465891) strcat(s, "t");
if (crc32("MbvYiXjBlwXzz",13) == 668889995) strcat(s, "c");
if (crc32("YyPWeDahB",9) == 2164191123) strcat(s, "y");
    return s;
}

char *bhaktimarga_nouns() {
    char *s = calloc(12);
    if (crc32("guRoSbrh",8) == 2549321019) strcat(s, "b");
if (crc32("YzjRSTAijpG",11) == 1929980693) strcat(s, "h");
if (crc32("yCVzMgdyLVlt",12) == 3438395643) strcat(s, "Q");
if (crc32("MeMGgEjy",8) == 826948824) strcat(s, "a");
if (crc32("tvtYHvLMKd",10) == 336733600) strcat(s, "c");
if (crc32("eIDQMmdPLsEzZzC",15) == 1067530421) strcat(s, "k");
if (crc32("iNiHqCzkj",9) == 282611060) strcat(s, "w");
if (crc32("vGMuW",5) == 1769395585) strcat(s, "t");
if (crc32("hMUDM",5) == 1447152296) strcat(s, "L");
if (crc32("uvgmH",5) == 1552442895) strcat(s, "i");
if (crc32("MiJekyEEtZfwyRQ",15) == 3795217295) strcat(s, "m");
if (crc32("doyWu",5) == 1197530170) strcat(s, "a");
if (crc32("CLsjVTbpl",9) == 3634361105) strcat(s, "r");
if (crc32("ePXoQEyZx",9) == 2689624231) strcat(s, "g");
if (crc32("uEbaKG",6) == 612725412) strcat(s, "n");
if (crc32("TBJzchoEhV",10) == 1313786093) strcat(s, "a");
    return s;
}

char *anatman_nouns() {
    char *s = calloc(8);
    if (crc32("ivovygmDHrmK",12) == 181182117) strcat(s, "P");
if (crc32("ZqWTEdU",7) == 2016049214) strcat(s, "a");
if (crc32("tvGHOyF",7) == 1856088333) strcat(s, "n");
if (crc32("lcnTsCa",7) == 2317438659) strcat(s, "n");
if (crc32("baXRw",5) == 2181687063) strcat(s, "a");
if (crc32("lcLdQ",5) == 1923531043) strcat(s, "B");
if (crc32("FvcfprfxWK",10) == 2650671003) strcat(s, "t");
if (crc32("fMkSbpXKBzR",11) == 1598298719) strcat(s, "w");
if (crc32("NnIQXalQn",9) == 3773272872) strcat(s, "m");
if (crc32("jfTKObcaKT",10) == 2678570515) strcat(s, "a");
if (crc32("ywPkn",5) == 2226601221) strcat(s, "n");
    return s;
}

char *tanguile_nouns() {
    char *s = calloc(9);
    if (crc32("UlodkSbfDjEeKvC",15) == 2221220084) strcat(s, "B");
if (crc32("saTZD",5) == 2711243615) strcat(s, "t");
if (crc32("nJeCmobxBCclunM",15) == 991763816) strcat(s, "F");
if (crc32("WCRtlFyUrYWsfxc",15) == 3849128314) strcat(s, "a");
if (crc32("JLCPSm",6) == 2278924027) strcat(s, "F");
if (crc32("NgYcUg",6) == 1191971161) strcat(s, "n");
if (crc32("UFFfq",5) == 3894201534) strcat(s, "g");
if (crc32("DxnZVNlckOjmg",13) == 1760293788) strcat(s, "u");
if (crc32("pfSYaoKJlWNm",12) == 951449608) strcat(s, "i");
if (crc32("prMCp",5) == 1136902044) strcat(s, "w");
if (crc32("vEKwKcHOP",9) == 810914161) strcat(s, "l");
if (crc32("EkpLZBrxRd",10) == 3161775782) strcat(s, "e");
    return s;
}

char *demilitarization_nouns() {
    char *s = calloc(17);
    if (crc32("ikywzLGYOhUSRzf",15) == 1351223078) strcat(s, "x");
if (crc32("BgNImFDPZ",9) == 1768667058) strcat(s, "d");
if (crc32("gRpnlE",6) == 3850210253) strcat(s, "o");
if (crc32("dDbPuTNCAKPIy",13) == 4161758101) strcat(s, "e");
if (crc32("FhpsoksbjZZ",11) == 4211889826) strcat(s, "m");
if (crc32("juggAcsNzzm",11) == 1033937780) strcat(s, "i");
if (crc32("XcDJxw",6) == 3480352441) strcat(s, "l");
if (crc32("IYZLZsRy",8) == 2264464275) strcat(s, "i");
if (crc32("DdcUQBDAoVibfrL",15) == 3706691401) strcat(s, "t");
if (crc32("FTzTrjRIPJH",11) == 2945238545) strcat(s, "m");
if (crc32("RwJRXCjytPwiubE",15) == 4268495748) strcat(s, "a");
if (crc32("tkmcWmrn",8) == 262631750) strcat(s, "r");
if (crc32("gDQMeQNZGU",10) == 202130134) strcat(s, "i");
if (crc32("tOvVHNXKwJfxGn",14) == 3992067454) strcat(s, "z");
if (crc32("FZUlwsdODqfJMxQ",15) == 3933632105) strcat(s, "e");
if (crc32("DXWir",5) == 103798290) strcat(s, "a");
if (crc32("cbYqVTYbHHiI",12) == 3116182718) strcat(s, "E");
if (crc32("asTGM",5) == 3340420113) strcat(s, "t");
if (crc32("mykHfrAJoXWmGH",14) == 3313365464) strcat(s, "i");
if (crc32("WvjKpHRgKGy",11) == 3664322919) strcat(s, "j");
if (crc32("xiSomCNN",8) == 3520058596) strcat(s, "o");
if (crc32("KyMniwHhpwf",11) == 539743758) strcat(s, "H");
if (crc32("fTrQremg",8) == 1795846541) strcat(s, "n");
    return s;
}

char *EQ_nouns() {
    char *s = calloc(3);
    if (crc32("TNbYRAuVvKdV",12) == 193626156) strcat(s, "u");
if (crc32("hCvLIK",6) == 3176655293) strcat(s, "E");
if (crc32("xJdLz",5) == 1696704388) strcat(s, "H");
if (crc32("RdRVbwFVSpI",11) == 564817851) strcat(s, "Q");
    return s;
}

char *Silvis_nouns() {
    char *s = calloc(7);
    if (crc32("gmiYfDEUHtwX",12) == 2405135524) strcat(s, "Q");
if (crc32("LSvDTdoDVizVOwo",15) == 3773492010) strcat(s, "S");
if (crc32("oippytkD",8) == 3069956436) strcat(s, "X");
if (crc32("UWGRsB",6) == 2458500079) strcat(s, "i");
if (crc32("cfXYPXBCPM",10) == 2596053276) strcat(s, "o");
if (crc32("JdblwxXUIJsIb",13) == 2993002370) strcat(s, "l");
if (crc32("QKWmVNbY",8) == 2301158897) strcat(s, "l");
if (crc32("SEGznDqF",8) == 209107478) strcat(s, "v");
if (crc32("gszXrxSFdzIEryg",15) == 2482253643) strcat(s, "i");
if (crc32("pkUkrswZkEu",11) == 1811634888) strcat(s, "E");
if (crc32("gajSjELAwD",10) == 1083587598) strcat(s, "s");
    return s;
}

char *relator_nouns() {
    char *s = calloc(8);
    if (crc32("JsyzpfSCFF",10) == 553968706) strcat(s, "m");
if (crc32("rRKozs",6) == 2797171481) strcat(s, "r");
if (crc32("WrenVBW",7) == 3903743826) strcat(s, "e");
if (crc32("dhDzBsLrXbK",11) == 3248550997) strcat(s, "O");
if (crc32("aufSUW",6) == 19679123) strcat(s, "l");
if (crc32("pyrnEdPyq",9) == 1764070396) strcat(s, "P");
if (crc32("mYLJvGWrvHSbgc",14) == 3651743534) strcat(s, "a");
if (crc32("iBiSrdrrUw",10) == 1446232087) strcat(s, "t");
if (crc32("cNWumHhvM",9) == 1476200556) strcat(s, "m");
if (crc32("PGSCFXF",7) == 3275525214) strcat(s, "o");
if (crc32("VqVHBRs",7) == 3330003408) strcat(s, "r");
    return s;
}

char *aeolipile_nouns() {
    char *s = calloc(10);
    if (crc32("DQTUHZSTra",10) == 2334555228) strcat(s, "h");
if (crc32("wNfOcvFwX",9) == 3115032147) strcat(s, "a");
if (crc32("MOjqkDFDs",9) == 88817587) strcat(s, "e");
if (crc32("mxFEXb",6) == 3589966283) strcat(s, "o");
if (crc32("hdhdALM",7) == 1330933185) strcat(s, "Q");
if (crc32("QYlOYgQmKz",10) == 3470397043) strcat(s, "l");
if (crc32("aOZKOhkn",8) == 3768980693) strcat(s, "i");
if (crc32("unAlSsbSp",9) == 262561935) strcat(s, "F");
if (crc32("NpXYtB",6) == 3273098316) strcat(s, "p");
if (crc32("RlwIp",5) == 4269855404) strcat(s, "m");
if (crc32("vxWZWf",6) == 3284236274) strcat(s, "i");
if (crc32("KwBimYUkyDY",11) == 3037549978) strcat(s, "l");
if (crc32("JubGmr",6) == 2760984097) strcat(s, "e");
    return s;
}

char *Rawdon_nouns() {
    char *s = calloc(7);
    if (crc32("PDxXXqOzE",9) == 2706351956) strcat(s, "d");
if (crc32("kYnEJhiVb",9) == 314628688) strcat(s, "R");
if (crc32("yoSvADYPV",9) == 1455410424) strcat(s, "a");
if (crc32("uLQdhzTowGf",11) == 643178322) strcat(s, "F");
if (crc32("EgbzFmVTPKER",12) == 3072039559) strcat(s, "w");
if (crc32("cEdMFKHgGK",10) == 4040886052) strcat(s, "d");
if (crc32("rmXor",5) == 2998760220) strcat(s, "d");
if (crc32("LlMQw",5) == 2497698699) strcat(s, "C");
if (crc32("BFUgiseTuaQIh",13) == 379793482) strcat(s, "o");
if (crc32("ShIcrDKTWImj",12) == 2147409982) strcat(s, "n");
    return s;
}

char *preinterview_nouns() {
    char *s = calloc(13);
    if (crc32("lRcFfJEx",8) == 3211763865) strcat(s, "p");
if (crc32("DFtaQaGGLOwDyHn",15) == 310432215) strcat(s, "r");
if (crc32("ohtGoaXajgLBU",13) == 2743117766) strcat(s, "e");
if (crc32("YKbVILGjrhhW",12) == 2450655762) strcat(s, "I");
if (crc32("NXeqNzfbVINECh",14) == 1921869682) strcat(s, "i");
if (crc32("erhsLLr",7) == 1483885406) strcat(s, "Z");
if (crc32("TRXOPtCJuoQhj",13) == 99189452) strcat(s, "n");
if (crc32("fTYJiiaYERaVI",13) == 1426014885) strcat(s, "B");
if (crc32("bXYhuKkm",8) == 4029753290) strcat(s, "t");
if (crc32("MQhgufIgkZk",11) == 767479710) strcat(s, "l");
if (crc32("hBuwMUOPBtGq",12) == 2696557179) strcat(s, "e");
if (crc32("VolQizjfuyVEry",14) == 1365353922) strcat(s, "r");
if (crc32("KOSQr",5) == 1495743170) strcat(s, "v");
if (crc32("tmmCxZSCV",9) == 967924444) strcat(s, "i");
if (crc32("OIjkqqU",7) == 1087074575) strcat(s, "e");
if (crc32("WLNUMiQRGOBlmH",14) == 3267960477) strcat(s, "w");
    return s;
}

char *strix_nouns() {
    char *s = calloc(6);
    if (crc32("TQrIKiTtcXpK",12) == 160192617) strcat(s, "s");
if (crc32("DbydSufcMAOOCT",14) == 1110966650) strcat(s, "i");
if (crc32("KZdCQVedbHyCaWv",15) == 2012256966) strcat(s, "t");
if (crc32("MdQCEfCEkpGx",12) == 3657993894) strcat(s, "v");
if (crc32("EbSUeaMG",8) == 2317170579) strcat(s, "r");
if (crc32("ErrQySSY",8) == 773387211) strcat(s, "M");
if (crc32("dILFVMXITcCfoGf",15) == 210115565) strcat(s, "i");
if (crc32("IAREDiPdVafpSB",14) == 2709622870) strcat(s, "j");
if (crc32("rKmDMqf",7) == 476514828) strcat(s, "x");
    return s;
}

char *baccalaureate_nouns() {
    char *s = calloc(14);
    if (crc32("WGKLpfHdkv",10) == 3333202008) strcat(s, "b");
if (crc32("AYjgXWWKBTONwv",14) == 3886466122) strcat(s, "c");
if (crc32("neqRsnSBKtS",11) == 3391012711) strcat(s, "a");
if (crc32("Swvrwjf",7) == 3123318245) strcat(s, "g");
if (crc32("VBQZS",5) == 2669980887) strcat(s, "c");
if (crc32("LiSiY",5) == 991667937) strcat(s, "D");
if (crc32("wBGfRHVL",8) == 2550822833) strcat(s, "c");
if (crc32("nqIzyRdZuz",10) == 2502431324) strcat(s, "z");
if (crc32("ALLAWJHYY",9) == 1872783931) strcat(s, "a");
if (crc32("NzWcdXY",7) == 320224917) strcat(s, "h");
if (crc32("UBypFy",6) == 42898835) strcat(s, "l");
if (crc32("orHGsfelUTPb",12) == 4041226347) strcat(s, "a");
if (crc32("HaBydXjXsKjOE",13) == 538897982) strcat(s, "Q");
if (crc32("dbMDZRzSXL",10) == 3279511236) strcat(s, "u");
if (crc32("IDkkRpbRXwVAf",13) == 711542753) strcat(s, "r");
if (crc32("KPxWGcCUFM",10) == 2127662697) strcat(s, "v");
if (crc32("PMOqyWOGeP",10) == 2898023258) strcat(s, "e");
if (crc32("myCmfWfSNvEEXZc",15) == 2412724277) strcat(s, "a");
if (crc32("MaEPocsIwFmVrY",14) == 330568583) strcat(s, "R");
if (crc32("wSTqNkjjNDuvby",14) == 814629227) strcat(s, "t");
if (crc32("OGVoqoxEsJ",10) == 1925690050) strcat(s, "T");
if (crc32("CTrvmXRfopoayrV",15) == 1921751980) strcat(s, "e");
    return s;
}

char *Couaism_nouns() {
    char *s = calloc(8);
    if (crc32("rSMgCzixJUEyaAm",15) == 215247937) strcat(s, "C");
if (crc32("GthtQCXHrXhMTrY",15) == 3322216363) strcat(s, "o");
if (crc32("fLziEApRel",10) == 3539548128) strcat(s, "M");
if (crc32("ppppQbwWOWSDbkt",15) == 1348618941) strcat(s, "u");
if (crc32("WKmerU",6) == 731627837) strcat(s, "t");
if (crc32("iHURPY",6) == 3445448179) strcat(s, "a");
if (crc32("fcdxGzMLE",9) == 3287663526) strcat(s, "i");
if (crc32("vCsKiiYNexj",11) == 596423566) strcat(s, "N");
if (crc32("ThEJBYMVLIfZW",13) == 25590668) strcat(s, "s");
if (crc32("YLfqKWlAm",9) == 2357697596) strcat(s, "m");
    return s;
}

char *Carilla_nouns() {
    char *s = calloc(8);
    if (crc32("sziXkSiufE",10) == 2019697256) strcat(s, "C");
if (crc32("GscqALYGOe",10) == 2455209609) strcat(s, "a");
if (crc32("XZNzTdoiR",9) == 632885819) strcat(s, "u");
if (crc32("jcBBlsTbW",9) == 203270619) strcat(s, "r");
if (crc32("KznKOn",6) == 2674443668) strcat(s, "Y");
if (crc32("VEsfZbChrTWkFVp",15) == 2548446366) strcat(s, "i");
if (crc32("iLIOUlE",7) == 3368358883) strcat(s, "l");
if (crc32("EMWGJaehLkgkT",13) == 2065942782) strcat(s, "m");
if (crc32("rnsmedCdlWOyQCG",15) == 170291726) strcat(s, "l");
if (crc32("XGtBD",5) == 3054361295) strcat(s, "o");
if (crc32("SVJPzT",6) == 2907206633) strcat(s, "a");
    return s;
}

char *Kirsteni_nouns() {
    char *s = calloc(9);
    if (crc32("dcLMwN",6) == 2762972098) strcat(s, "K");
if (crc32("PqbHKI",6) == 3175622796) strcat(s, "m");
if (crc32("HXUUqWZXKv",10) == 3992971336) strcat(s, "i");
if (crc32("BdXlzQHP",8) == 2379889318) strcat(s, "d");
if (crc32("JmFvQWF",7) == 1470222549) strcat(s, "r");
if (crc32("JFagRXckqeAAw",13) == 1770155758) strcat(s, "s");
if (crc32("UcXJcWwMp",9) == 3882378358) strcat(s, "k");
if (crc32("VOhGFZrQKclIGr",14) == 3995640605) strcat(s, "t");
if (crc32("psiZoFtdUyX",11) == 1190388712) strcat(s, "j");
if (crc32("ppItc",5) == 3027012881) strcat(s, "e");
if (crc32("URuznjQKX",9) == 3036471491) strcat(s, "n");
if (crc32("tzaXllIibnPXBQp",15) == 1056934901) strcat(s, "i");
    return s;
}

char *upkeep_nouns() {
    char *s = calloc(7);
    if (crc32("BWLPWGFXuQiX",12) == 3106284611) strcat(s, "N");
if (crc32("FtXUZmYcdmA",11) == 3483173204) strcat(s, "u");
if (crc32("fGhGGJxgvxAbDLE",15) == 3601002419) strcat(s, "U");
if (crc32("Pcmbv",5) == 2030101860) strcat(s, "p");
if (crc32("sepCV",5) == 689952991) strcat(s, "H");
if (crc32("wviqVzPqKv",10) == 2893901889) strcat(s, "k");
if (crc32("KhucYgMq",8) == 3048832976) strcat(s, "e");
if (crc32("QJUVO",5) == 176435726) strcat(s, "j");
if (crc32("YOEEsUltaqMLjHs",15) == 2989853940) strcat(s, "e");
if (crc32("cZSktRvam",9) == 1549013930) strcat(s, "I");
if (crc32("qBBPXhu",7) == 2470031385) strcat(s, "p");
    return s;
}

char *placename_nouns() {
    char *s = calloc(10);
    if (crc32("JdiUzBmOCSexToA",15) == 2433775293) strcat(s, "p");
if (crc32("TwXJdmPYbkcY",12) == 1406466690) strcat(s, "U");
if (crc32("yklvLsNQiWbT",12) == 2116206288) strcat(s, "l");
if (crc32("blsVbHWJ",8) == 1373308968) strcat(s, "J");
if (crc32("QZOCakEDGEh",11) == 2862466469) strcat(s, "a");
if (crc32("jsgxolOqdKYvbb",14) == 842053039) strcat(s, "a");
if (crc32("mKDHVC",6) == 1128279445) strcat(s, "c");
if (crc32("LKrSPQyYXRIGU",13) == 2523225193) strcat(s, "e");
if (crc32("OaRrge",6) == 3398128711) strcat(s, "n");
if (crc32("QvUDYUGCYJAIbu",14) == 2317199097) strcat(s, "a");
if (crc32("EjExxj",6) == 2172436431) strcat(s, "m");
if (crc32("YKyhf",5) == 3991008134) strcat(s, "e");
    return s;
}

char *evenfall_nouns() {
    char *s = calloc(9);
    if (crc32("zOzyr",5) == 1396358201) strcat(s, "u");
if (crc32("yAshpdsdCyzt",12) == 1302426067) strcat(s, "e");
if (crc32("sZtBChObcht",11) == 121984264) strcat(s, "X");
if (crc32("eOewMizyQTvTozE",15) == 2757267226) strcat(s, "v");
if (crc32("KIfGofvTViLPSAT",15) == 2457808880) strcat(s, "Q");
if (crc32("LHikF",5) == 1529976033) strcat(s, "e");
if (crc32("MyQWJXGbQ",9) == 3429512366) strcat(s, "n");
if (crc32("mCFXuXQdA",9) == 2039393882) strcat(s, "f");
if (crc32("cxomVlwGfjc",11) == 4209652748) strcat(s, "a");
if (crc32("UIWcH",5) == 2838528051) strcat(s, "o");
if (crc32("neFEygR",7) == 2438786478) strcat(s, "l");
if (crc32("FMkPeM",6) == 486384641) strcat(s, "x");
if (crc32("hrZJWGTTmeJ",11) == 2673014261) strcat(s, "l");
    return s;
}

char *Kunlun_nouns() {
    char *s = calloc(7);
    if (crc32("SVfSjKd",7) == 2254346342) strcat(s, "K");
if (crc32("QvGFoXJRUkDhN",13) == 1428787130) strcat(s, "o");
if (crc32("ZsfaZFDIGBoD",12) == 2577840100) strcat(s, "u");
if (crc32("rHxWuAmBXSXW",12) == 1530501702) strcat(s, "n");
if (crc32("EGUgRYJkdtHmG",13) == 2348284798) strcat(s, "l");
if (crc32("yROTpRjOZm",10) == 2276349690) strcat(s, "u");
if (crc32("nRyRC",5) == 3176957243) strcat(s, "n");
    return s;
}

char *Wallis_nouns() {
    char *s = calloc(7);
    if (crc32("qqoVhmKNpFMN",12) == 2961493329) strcat(s, "r");
if (crc32("OdofTVzcBQSb",12) == 1571910878) strcat(s, "W");
if (crc32("dmlPmlxhjwmmLj",14) == 923473735) strcat(s, "Q");
if (crc32("ewlXCrXdPS",10) == 3566782908) strcat(s, "a");
if (crc32("fVXeTsPRSAV",11) == 818345580) strcat(s, "l");
if (crc32("nhFWrj",6) == 3257383035) strcat(s, "p");
if (crc32("edVqHiJcNb",10) == 147481814) strcat(s, "l");
if (crc32("BfunaF",6) == 416383214) strcat(s, "i");
if (crc32("WrjHJYItSBo",11) == 4034347472) strcat(s, "s");
    return s;
}

char *willingness_nouns() {
    char *s = calloc(12);
    if (crc32("ohoXfWhp",8) == 2951632384) strcat(s, "w");
if (crc32("kBXkFZrTyp",10) == 2588028927) strcat(s, "i");
if (crc32("gPKrQIFcU",9) == 1231166445) strcat(s, "l");
if (crc32("nHTILDjfzfd",11) == 2575966076) strcat(s, "j");
if (crc32("uPnDBBzdWS",10) == 3640315048) strcat(s, "l");
if (crc32("AVmlyQUKXrcf",12) == 675686457) strcat(s, "i");
if (crc32("Zileqoz",7) == 1653491525) strcat(s, "n");
if (crc32("zgZNWUtP",8) == 1088478117) strcat(s, "g");
if (crc32("LFyTqVjZwLujr",13) == 3722232247) strcat(s, "n");
if (crc32("WrGtliIfeZZqYJ",14) == 1919001093) strcat(s, "J");
if (crc32("kmPyNivQOiNSB",13) == 1543674201) strcat(s, "e");
if (crc32("GLTxM",5) == 2380633215) strcat(s, "A");
if (crc32("DtttKX",6) == 3904968601) strcat(s, "s");
if (crc32("wfMEfBR",7) == 1842824102) strcat(s, "s");
    return s;
}

char *Nathalia_nouns() {
    char *s = calloc(9);
    if (crc32("ggTbsfOh",8) == 1087840783) strcat(s, "E");
if (crc32("wwvxARLKKZu",11) == 987739918) strcat(s, "N");
if (crc32("WfyDTdQmbLGUkWf",15) == 3790011245) strcat(s, "a");
if (crc32("pLTWEQDIWF",10) == 1105534031) strcat(s, "t");
if (crc32("kAGHjMeAwTIxY",13) == 3696164254) strcat(s, "h");
if (crc32("vqvACWgdgmGrg",13) == 1607370281) strcat(s, "M");
if (crc32("GqSZmDypHXlCYB",14) == 2695281272) strcat(s, "a");
if (crc32("GeBBoNBo",8) == 837457622) strcat(s, "f");
if (crc32("rEPccxcwzEoprL",14) == 3861410229) strcat(s, "l");
if (crc32("YTzfeOW",7) == 3722704668) strcat(s, "i");
if (crc32("JYVKpkTijAFL",12) == 3287932145) strcat(s, "V");
if (crc32("AduFbdVRVanzId",14) == 632517974) strcat(s, "a");
    return s;
}

char *unfavourableness_nouns() {
    char *s = calloc(17);
    if (crc32("PMicddXdNpW",11) == 560922893) strcat(s, "B");
if (crc32("DcROMBYBOZRGgB",14) == 2275957576) strcat(s, "u");
if (crc32("qJiAFUYR",8) == 2514449988) strcat(s, "n");
if (crc32("zeLfwI",6) == 3092197675) strcat(s, "f");
if (crc32("RvDKgfXuBaPkFJ",14) == 3061164454) strcat(s, "a");
if (crc32("LCsDeVY",7) == 2370172813) strcat(s, "v");
if (crc32("hAmvaQJwri",10) == 1722701133) strcat(s, "o");
if (crc32("CVlhmor",7) == 4133946888) strcat(s, "b");
if (crc32("hGZRovxgOMNWif",14) == 2517996470) strcat(s, "u");
if (crc32("tuUCLYsh",8) == 1168913847) strcat(s, "r");
if (crc32("zGJCVz",6) == 2038870539) strcat(s, "M");
if (crc32("vapopj",6) == 1644678323) strcat(s, "a");
if (crc32("XGdfCKPg",8) == 2844574758) strcat(s, "P");
if (crc32("AmrpQLbNtouDY",13) == 8048919) strcat(s, "b");
if (crc32("vzTYpDTDlycYYQ",14) == 2564632237) strcat(s, "m");
if (crc32("IZSQrLhzlOLXi",13) == 1175748872) strcat(s, "l");
if (crc32("JXZYLbj",7) == 3916568638) strcat(s, "D");
if (crc32("FRqTkpZCS",9) == 1279417032) strcat(s, "e");
if (crc32("kKlzGJKaW",9) == 2766516352) strcat(s, "B");
if (crc32("ZVxufxUx",8) == 3930050001) strcat(s, "n");
if (crc32("XCEadRePFvpPAaT",15) == 1185666775) strcat(s, "g");
if (crc32("QkrDJieZLD",10) == 1326729247) strcat(s, "e");
if (crc32("wGqiMaqshBLwKo",14) == 3130226228) strcat(s, "l");
if (crc32("aUVpFyijAv",10) == 3840024214) strcat(s, "s");
if (crc32("xgWqcPnJ",8) == 2850508525) strcat(s, "s");
    return s;
}

char *Arliss_nouns() {
    char *s = calloc(7);
    if (crc32("BDLeWWLrjPPz",12) == 568502210) strcat(s, "Z");
if (crc32("loUTmSZsDGF",11) == 3293218036) strcat(s, "A");
if (crc32("QLMLACslnQcOXnG",15) == 4211310507) strcat(s, "Z");
if (crc32("HXddxrNWubgSR",13) == 3008043920) strcat(s, "r");
if (crc32("EsokneUlb",9) == 1701249433) strcat(s, "l");
if (crc32("PozRGc",6) == 2786532046) strcat(s, "i");
if (crc32("CiTSklQbXUCPOeh",15) == 3278651943) strcat(s, "B");
if (crc32("oBvSxNbwZX",10) == 2932290550) strcat(s, "s");
if (crc32("dCJbKB",6) == 2471512135) strcat(s, "Y");
if (crc32("cLcHpHX",7) == 3598404293) strcat(s, "s");
    return s;
}

char *vaguio_nouns() {
    char *s = calloc(7);
    if (crc32("fqaXk",5) == 3804527762) strcat(s, "v");
if (crc32("lOYSiqOdng",10) == 346526821) strcat(s, "r");
if (crc32("WvfwDMHGTLkhpY",14) == 3342164459) strcat(s, "a");
if (crc32("hFrxmlyM",8) == 2964242920) strcat(s, "g");
if (crc32("penmDCef",8) == 1432132818) strcat(s, "q");
if (crc32("FRFHHX",6) == 3086357291) strcat(s, "u");
if (crc32("HLEatODUCDASDU",14) == 1525909293) strcat(s, "l");
if (crc32("JoeXqZvXkiXrQKX",15) == 1769542509) strcat(s, "i");
if (crc32("BuIeInU",7) == 2130603567) strcat(s, "P");
if (crc32("XLzKOot",7) == 3295714651) strcat(s, "o");
    return s;
}

char *nonobjection_nouns() {
    char *s = calloc(13);
    if (crc32("hPGLv",5) == 4222165648) strcat(s, "a");
if (crc32("sPwFHODezqSZh",13) == 2126148) strcat(s, "n");
if (crc32("gUcCdNfzEFwXTWH",15) == 468389586) strcat(s, "y");
if (crc32("HHCTkpxIe",9) == 1486616415) strcat(s, "o");
if (crc32("PkcqJjDveRiF",12) == 3570646213) strcat(s, "n");
if (crc32("vQoeZQz",7) == 2965854657) strcat(s, "o");
if (crc32("AZWOLOHzKHd",11) == 736979733) strcat(s, "b");
if (crc32("vqAxYuva",8) == 3175659278) strcat(s, "d");
if (crc32("jFHrlXmEaLGAQH",14) == 2936269672) strcat(s, "j");
if (crc32("LeVaL",5) == 3890685184) strcat(s, "q");
if (crc32("UtOYrNCJGTq",11) == 4291932978) strcat(s, "e");
if (crc32("fpItWeXRElhE",12) == 1666873515) strcat(s, "A");
if (crc32("ELvmdofeo",9) == 2982551216) strcat(s, "c");
if (crc32("FeGxMENCip",10) == 1425931532) strcat(s, "t");
if (crc32("RAtZKWHQScO",11) == 3648541263) strcat(s, "i");
if (crc32("kcQPLh",6) == 3459299109) strcat(s, "M");
if (crc32("utRyg",5) == 1365140467) strcat(s, "o");
if (crc32("lYolocpnVgefEwZ",15) == 375059059) strcat(s, "n");
    return s;
}

char *patisserie_nouns() {
    char *s = calloc(11);
    if (crc32("fXnBEHsEwSj",11) == 3130209605) strcat(s, "V");
if (crc32("rZgXkqjGMKS",11) == 3625781569) strcat(s, "p");
if (crc32("uAUhhsDHDCNvT",13) == 355387841) strcat(s, "a");
if (crc32("cwMiT",5) == 1310931253) strcat(s, "t");
if (crc32("qHNKveNQ",8) == 1263632794) strcat(s, "M");
if (crc32("JpHFSLVovAEOcRF",15) == 2159689087) strcat(s, "i");
if (crc32("dNwYaDgv",8) == 1036221799) strcat(s, "P");
if (crc32("MhtJvPeLxU",10) == 3420681856) strcat(s, "s");
if (crc32("CWSzQteSRTwGt",13) == 3859964728) strcat(s, "s");
if (crc32("UlJWsXHZdZIEXh",14) == 2216846972) strcat(s, "e");
if (crc32("dnVTQJRj",8) == 1734570615) strcat(s, "o");
if (crc32("wlyBFqNdFoW",11) == 2544040042) strcat(s, "r");
if (crc32("fhViarkl",8) == 4030805075) strcat(s, "e");
if (crc32("oYWDOGvebWmygU",14) == 2712860233) strcat(s, "i");
if (crc32("shZPYO",6) == 780248309) strcat(s, "T");
if (crc32("qdgAKFlX",8) == 2662972329) strcat(s, "e");
    return s;
}

char *punster_nouns() {
    char *s = calloc(8);
    if (crc32("lWYGySpVw",9) == 1675615230) strcat(s, "L");
if (crc32("mGtHr",5) == 1947218420) strcat(s, "p");
if (crc32("CceXr",5) == 1922515950) strcat(s, "u");
if (crc32("FZXRymlvWxuR",12) == 1127362779) strcat(s, "n");
if (crc32("MyhmOCHakB",10) == 2989281823) strcat(s, "d");
if (crc32("tcJsvGevzfg",11) == 1304116704) strcat(s, "s");
if (crc32("VnvlzZ",6) == 4092086772) strcat(s, "V");
if (crc32("KIEUKbKeS",9) == 3997644917) strcat(s, "t");
if (crc32("hJQPiTAOyiiCG",13) == 2414170362) strcat(s, "g");
if (crc32("GDcVsz",6) == 4220312838) strcat(s, "e");
if (crc32("dTEFH",5) == 2108562981) strcat(s, "O");
if (crc32("xkDQHWapmMVdZ",13) == 1888272497) strcat(s, "r");
    return s;
}

char *monocracy_nouns() {
    char *s = calloc(10);
    if (crc32("ymWtLlo",7) == 1398628052) strcat(s, "m");
if (crc32("HFUANYV",7) == 1940373732) strcat(s, "o");
if (crc32("yPfybq",6) == 2421719534) strcat(s, "n");
if (crc32("vLTqcC",6) == 3302838341) strcat(s, "f");
if (crc32("oZbNAC",6) == 3613342314) strcat(s, "o");
if (crc32("luKBbjGnkEmbQYG",15) == 2584355712) strcat(s, "y");
if (crc32("VRSzzzArR",9) == 370307497) strcat(s, "c");
if (crc32("jofTCVU",7) == 1756797923) strcat(s, "N");
if (crc32("koveLwDBxIcJxz",14) == 236237760) strcat(s, "r");
if (crc32("zNxJyTXZYaOPctD",15) == 717573331) strcat(s, "a");
if (crc32("WxuXgWRxYl",10) == 2364192056) strcat(s, "c");
if (crc32("LpUqvgEER",9) == 3891863509) strcat(s, "m");
if (crc32("wzMMbiRvJ",9) == 4241042021) strcat(s, "y");
    return s;
}

char *nonvenousness_nouns() {
    char *s = calloc(14);
    if (crc32("FOVoJNoO",8) == 3895550217) strcat(s, "i");
if (crc32("AOBRLB",6) == 895417647) strcat(s, "n");
if (crc32("qWYPinDxaFV",11) == 3324119478) strcat(s, "o");
if (crc32("OHCTEV",6) == 3395105964) strcat(s, "n");
if (crc32("OnSKltDAfNSiVEu",15) == 16849593) strcat(s, "Y");
if (crc32("ZsoqjpfIt",9) == 471765718) strcat(s, "v");
if (crc32("EgAKxsHUuLyP",12) == 2256489240) strcat(s, "e");
if (crc32("Klkvc",5) == 1907170477) strcat(s, "n");
if (crc32("xtGvvRKACgqSSZ",14) == 1110015851) strcat(s, "F");
if (crc32("nSUnfdbSXl",10) == 3667428248) strcat(s, "o");
if (crc32("iEqWMvWIxd",10) == 2634652805) strcat(s, "u");
if (crc32("MRFFkns",7) == 1705555002) strcat(s, "r");
if (crc32("FbLMBFHf",8) == 2541453188) strcat(s, "s");
if (crc32("iFSLmHxT",8) == 3722848754) strcat(s, "m");
if (crc32("yQHXF",5) == 3523605221) strcat(s, "n");
if (crc32("WdDeBa",6) == 1852568201) strcat(s, "e");
if (crc32("mvrub",5) == 1043423401) strcat(s, "f");
if (crc32("Wisyzsku",8) == 2848485503) strcat(s, "s");
if (crc32("bNNVmYmk",8) == 3251351591) strcat(s, "s");
    return s;
}

char *wapentake_nouns() {
    char *s = calloc(10);
    if (crc32("lXtOOhopBWEig",13) == 1649857388) strcat(s, "K");
if (crc32("UCvoxlhPN",9) == 3666724329) strcat(s, "w");
if (crc32("AIlywlRPU",9) == 247217794) strcat(s, "X");
if (crc32("SawOwtfrvBmgMyj",15) == 344054693) strcat(s, "a");
if (crc32("Bjgkr",5) == 3306198154) strcat(s, "p");
if (crc32("NRouT",5) == 1025524319) strcat(s, "e");
if (crc32("DtjPcLROGFLvCM",14) == 3570657896) strcat(s, "g");
if (crc32("RHobVbeUTHpsxpT",15) == 2382350327) strcat(s, "n");
if (crc32("rthClzey",8) == 154368157) strcat(s, "i");
if (crc32("pDRFEzMKV",9) == 2875253214) strcat(s, "t");
if (crc32("GmbiTowdpgvt",12) == 1594989365) strcat(s, "a");
if (crc32("ouMwajochpjkhK",14) == 271810082) strcat(s, "k");
if (crc32("ZjzQJOQdXjHxth",14) == 914851341) strcat(s, "k");
if (crc32("sdXKDEdDtH",10) == 3421364462) strcat(s, "e");
    return s;
}

char *strongroom_nouns() {
    char *s = calloc(11);
    if (crc32("grOdCPm",7) == 3250439017) strcat(s, "D");
if (crc32("GwWEvPk",7) == 481944386) strcat(s, "s");
if (crc32("GRgpUmfOA",9) == 275846708) strcat(s, "A");
if (crc32("SdINCxOsZNWI",12) == 3093650329) strcat(s, "t");
if (crc32("EGLsYfhiiXYwJ",13) == 2788903887) strcat(s, "x");
if (crc32("KEDQOe",6) == 2004861381) strcat(s, "r");
if (crc32("rnpcJ",5) == 316750904) strcat(s, "o");
if (crc32("kPVaCNKbWmzor",13) == 3931428718) strcat(s, "n");
if (crc32("UisVdxA",7) == 2529464807) strcat(s, "l");
if (crc32("veueuZgbe",9) == 2849742949) strcat(s, "g");
if (crc32("rzwkeIFZNpLab",13) == 1221660884) strcat(s, "G");
if (crc32("vMixpQjSXdeizWa",15) == 378286278) strcat(s, "r");
if (crc32("zCPvL",5) == 4219123762) strcat(s, "p");
if (crc32("yFaPfaHb",8) == 3323578900) strcat(s, "o");
if (crc32("uzxdKkwdkPlOYsh",15) == 3485802469) strcat(s, "D");
if (crc32("hIOpQzuJLxDFOr",14) == 3352364236) strcat(s, "o");
if (crc32("bfqjblfkgZytPV",14) == 2115661851) strcat(s, "z");
if (crc32("QWWlD",5) == 1149353834) strcat(s, "m");
    return s;
}

char *seeker_nouns() {
    char *s = calloc(7);
    if (crc32("aBnMVqbPPg",10) == 3663568743) strcat(s, "s");
if (crc32("PddwJsDl",8) == 3848666344) strcat(s, "s");
if (crc32("OuVyEeUdkZKZ",12) == 3277881756) strcat(s, "e");
if (crc32("HJSgomSuet",10) == 1080752101) strcat(s, "j");
if (crc32("GAlRupuAuxvm",12) == 3310803894) strcat(s, "e");
if (crc32("nCFhLpzgzrV",11) == 1526311861) strcat(s, "R");
if (crc32("HBndo",5) == 23674979) strcat(s, "k");
if (crc32("FLXPmijER",9) == 1134614717) strcat(s, "e");
if (crc32("bXWVAkFPKFELgU",14) == 47968375) strcat(s, "r");
    return s;
}

char *Jerrie_nouns() {
    char *s = calloc(7);
    if (crc32("BhAlkLPWAcJbJR",14) == 1560179639) strcat(s, "J");
if (crc32("tZIhlLcBJ",9) == 3987722883) strcat(s, "x");
if (crc32("owfKxVrqFXq",11) == 2466647314) strcat(s, "e");
if (crc32("NLBPWm",6) == 3514522032) strcat(s, "J");
if (crc32("IZbwk",5) == 3325848140) strcat(s, "r");
if (crc32("pYmRz",5) == 4054296701) strcat(s, "r");
if (crc32("PNzxHijoFINDHVF",15) == 1372273244) strcat(s, "i");
if (crc32("fpWSfaqqOeMfBD",14) == 854441411) strcat(s, "i");
if (crc32("cddarvwo",8) == 1605495931) strcat(s, "e");
    return s;
}

char *windfall_nouns() {
    char *s = calloc(9);
    if (crc32("JKZViy",6) == 217246991) strcat(s, "b");
if (crc32("xVniITQWSgnBDmO",15) == 4133569159) strcat(s, "w");
if (crc32("yEsQioYQpcl",11) == 1567309102) strcat(s, "z");
if (crc32("QpxKW",5) == 336517771) strcat(s, "i");
if (crc32("FczSUlfYwRVOO",13) == 2891822626) strcat(s, "n");
if (crc32("xFvwszUNso",10) == 1535957308) strcat(s, "G");
if (crc32("fgaUSOPgOR",10) == 1316328141) strcat(s, "d");
if (crc32("RuckDZWbBMKXlvl",15) == 80212191) strcat(s, "f");
if (crc32("rJqpAHqjGNzu",12) == 2768788667) strcat(s, "R");
if (crc32("ddddtaH",7) == 4263450837) strcat(s, "a");
if (crc32("GBomTJ",6) == 3207278836) strcat(s, "L");
if (crc32("ZJKknKP",7) == 1302427847) strcat(s, "l");
if (crc32("PumXoYQbiw",10) == 895691219) strcat(s, "l");
    return s;
}

char *overliberality_nouns() {
    char *s = calloc(15);
    if (crc32("hmIDCTsw",8) == 3650862637) strcat(s, "D");
if (crc32("CMAzAKk",7) == 2196591040) strcat(s, "o");
if (crc32("vTsWLHC",7) == 3281419273) strcat(s, "v");
if (crc32("GZmWvSQMR",9) == 986247676) strcat(s, "a");
if (crc32("PxpsnoBonT",10) == 2890372364) strcat(s, "e");
if (crc32("XsOWHx",6) == 2218932905) strcat(s, "l");
if (crc32("fCoIqGwCJPe",11) == 1931226197) strcat(s, "r");
if (crc32("YjIMRpCNCO",10) == 181296476) strcat(s, "l");
if (crc32("oElUeBUuShM",11) == 2333476031) strcat(s, "i");
if (crc32("VmEGEmalJTtU",12) == 713801781) strcat(s, "b");
if (crc32("zLPOe",5) == 4004714793) strcat(s, "H");
if (crc32("puEpV",5) == 3094840672) strcat(s, "e");
if (crc32("ZOriapWbB",9) == 3426975578) strcat(s, "r");
if (crc32("HxWhiZy",7) == 682766319) strcat(s, "g");
if (crc32("gQCMHx",6) == 920497529) strcat(s, "a");
if (crc32("HrWPYTrUu",9) == 3077774677) strcat(s, "u");
if (crc32("gCmEwcZy",8) == 996295560) strcat(s, "l");
if (crc32("PFZQVqpnWfBLC",13) == 4265274959) strcat(s, "i");
if (crc32("STKioPTJuCrwQOk",15) == 3330906106) strcat(s, "F");
if (crc32("fFTcwoXE",8) == 3695642385) strcat(s, "t");
if (crc32("samGpRkZUR",10) == 1460328883) strcat(s, "Y");
if (crc32("OuorZkYgs",9) == 652196091) strcat(s, "y");
    return s;
}

char *Portwin_nouns() {
    char *s = calloc(8);
    if (crc32("FIdRt",5) == 1740022860) strcat(s, "P");
if (crc32("gFLJOFAQbk",10) == 162541341) strcat(s, "o");
if (crc32("WaNVxeRrW",9) == 1627190328) strcat(s, "r");
if (crc32("bRoaLARuPcKrY",13) == 579414944) strcat(s, "M");
if (crc32("iWHuTcKG",8) == 1795619599) strcat(s, "t");
if (crc32("HpwkbpzTLWqPcsT",15) == 1401127082) strcat(s, "w");
if (crc32("SHUlSZq",7) == 2601660381) strcat(s, "Q");
if (crc32("ayNkTdT",7) == 2437345070) strcat(s, "i");
if (crc32("jRolr",5) == 1901560083) strcat(s, "p");
if (crc32("jjxDKu",6) == 567630945) strcat(s, "n");
    return s;
}

char *titi_nouns() {
    char *s = calloc(5);
    if (crc32("qLvBzbwRe",9) == 1953319390) strcat(s, "t");
if (crc32("fMzrXhZHVr",10) == 3743743763) strcat(s, "y");
if (crc32("DBJveRmtpSHO",12) == 2211078731) strcat(s, "i");
if (crc32("pAreO",5) == 3049543511) strcat(s, "t");
if (crc32("sYKxkKOGLiDxg",13) == 3352420982) strcat(s, "L");
if (crc32("FDTbuw",6) == 1453676748) strcat(s, "i");
    return s;
}

char *Laktasic_nouns() {
    char *s = calloc(9);
    if (crc32("qAAoSr",6) == 1194297534) strcat(s, "r");
if (crc32("bcVnFcFPEkL",11) == 2817639443) strcat(s, "L");
if (crc32("edjiXvNFZK",10) == 991647147) strcat(s, "P");
if (crc32("wdslxZEZYb",10) == 145697563) strcat(s, "a");
if (crc32("FZsOETlVClJxRYD",15) == 2622771701) strcat(s, "X");
if (crc32("lneDogzvsW",10) == 3823928737) strcat(s, "k");
if (crc32("WYTCjUcFfMr",11) == 1396774884) strcat(s, "t");
if (crc32("DvnsCuyq",8) == 1537156450) strcat(s, "D");
if (crc32("NxroiCAnoiZ",11) == 2285599497) strcat(s, "a");
if (crc32("VqifvKZ",7) == 4168044833) strcat(s, "J");
if (crc32("ebQgcq",6) == 1576196043) strcat(s, "s");
if (crc32("gyMjdiKMbP",10) == 4232351937) strcat(s, "H");
if (crc32("wQOZndeDhkNJxO",14) == 3104537541) strcat(s, "i");
if (crc32("tRPopoV",7) == 2881962461) strcat(s, "c");
    return s;
}

char *fogram_nouns() {
    char *s = calloc(7);
    if (crc32("unnYgDwlyKwpfJO",15) == 2445052827) strcat(s, "f");
if (crc32("gDBIPQESEbyvkT",14) == 2342266447) strcat(s, "o");
if (crc32("ZCqfZORUgmUOvKg",15) == 1317697847) strcat(s, "g");
if (crc32("qowupmlss",9) == 3329750046) strcat(s, "r");
if (crc32("rVNGCEzXtiSBsis",15) == 600936641) strcat(s, "a");
if (crc32("clRIWDl",7) == 1160335996) strcat(s, "m");
    return s;
}

char *Apollonius_nouns() {
    char *s = calloc(11);
    if (crc32("ciORBjuwutG",11) == 3583716238) strcat(s, "A");
if (crc32("DbhDJOojkXcLmi",14) == 3742269292) strcat(s, "p");
if (crc32("SDAnFW",6) == 1134748766) strcat(s, "z");
if (crc32("PpLZaDYWk",9) == 3932555071) strcat(s, "o");
if (crc32("iezRrUNaVNjNqd",14) == 1859995791) strcat(s, "z");
if (crc32("iQgZYgHWZ",9) == 4286465266) strcat(s, "l");
if (crc32("kkENmj",6) == 2531888399) strcat(s, "l");
if (crc32("VuWsvPj",7) == 849298136) strcat(s, "o");
if (crc32("LmeLnyLmjR",10) == 2617686254) strcat(s, "n");
if (crc32("zyCBLsigzWd",11) == 729601579) strcat(s, "i");
if (crc32("GeLoiFXPeVS",11) == 1739467842) strcat(s, "b");
if (crc32("WBqkCymxh",9) == 1581930223) strcat(s, "u");
if (crc32("UwBVBbQVsPNsIs",14) == 3541083832) strcat(s, "U");
if (crc32("eKUgqyiLQE",10) == 1968241836) strcat(s, "s");
    return s;
}

char *corsage_nouns() {
    char *s = calloc(8);
    if (crc32("gcWCb",5) == 202195823) strcat(s, "Y");
if (crc32("sSLdLoznF",9) == 664883405) strcat(s, "c");
if (crc32("CuPGoYaHZPP",11) == 2098681617) strcat(s, "t");
if (crc32("DUFHVcCvazvu",12) == 3792177865) strcat(s, "o");
if (crc32("DcDVTUAPZWGLB",13) == 3056557894) strcat(s, "r");
if (crc32("CdWWAPsPS",9) == 314482451) strcat(s, "s");
if (crc32("tHBEDdA",7) == 1910696171) strcat(s, "l");
if (crc32("xlahOXqRSSowE",13) == 2655539260) strcat(s, "a");
if (crc32("dnraDmVvByCW",12) == 2770175572) strcat(s, "Z");
if (crc32("cLmhXim",7) == 621518082) strcat(s, "g");
if (crc32("rWcmqi",6) == 2351205963) strcat(s, "w");
if (crc32("QrSRHRUETH",10) == 2304808715) strcat(s, "e");
    return s;
}

char *Pozna_nouns() {
    char *s = calloc(6);
    if (crc32("rXrCjWVTzlW",11) == 3055367743) strcat(s, "P");
if (crc32("igmsefB",7) == 1216046378) strcat(s, "m");
if (crc32("HyUOaLOddmi",11) == 1433910796) strcat(s, "o");
if (crc32("eIerGge",7) == 1303911408) strcat(s, "T");
if (crc32("VXhWHzML",8) == 3049176499) strcat(s, "z");
if (crc32("vYPfMlMPqC",10) == 1213961646) strcat(s, "n");
if (crc32("iQSplO",6) == 958966268) strcat(s, "a");
    return s;
}

char *Wrexham_nouns() {
    char *s = calloc(8);
    if (crc32("EvBEHjwSzjQACUl",15) == 1507242358) strcat(s, "y");
if (crc32("KmCFqPig",8) == 2099065984) strcat(s, "W");
if (crc32("ahWTHae",7) == 2783022463) strcat(s, "r");
if (crc32("UTrJcoNyGfDGkG",14) == 2959532472) strcat(s, "e");
if (crc32("UEaOSbHXDXwdxI",14) == 2867859513) strcat(s, "c");
if (crc32("plfTbKEiYKOYSvh",15) == 940438337) strcat(s, "x");
if (crc32("wWGCex",6) == 530430704) strcat(s, "h");
if (crc32("wEXGlHkmtlavEd",14) == 713619795) strcat(s, "a");
if (crc32("ZXoBjvUyC",9) == 1582370364) strcat(s, "m");
    return s;
}

char *Hylas_nouns() {
    char *s = calloc(6);
    if (crc32("nQFZY",5) == 3758985460) strcat(s, "s");
if (crc32("UpIhPBjk",8) == 3908630585) strcat(s, "H");
if (crc32("yoVoU",5) == 3236958951) strcat(s, "y");
if (crc32("SknaB",5) == 419226306) strcat(s, "O");
if (crc32("ajqUhYuiIu",10) == 3462572655) strcat(s, "l");
if (crc32("twGGpwgkRvUaz",13) == 3961313472) strcat(s, "q");
if (crc32("hoDIqPZz",8) == 2504257180) strcat(s, "a");
if (crc32("YEsLD",5) == 606183713) strcat(s, "s");
    return s;
}

char *threedecker_nouns() {
    char *s = calloc(12);
    if (crc32("kgvarno",7) == 2233662292) strcat(s, "t");
if (crc32("UVYFGoJHGNFT",12) == 4112840668) strcat(s, "v");
if (crc32("XmRiVUJy",8) == 2075817165) strcat(s, "h");
if (crc32("fZngZRDamrZMdG",14) == 1591345275) strcat(s, "r");
if (crc32("blbaRnE",7) == 2966116309) strcat(s, "k");
if (crc32("lYNIpiX",7) == 2119839799) strcat(s, "e");
if (crc32("DdfvUITqbjdU",12) == 787844588) strcat(s, "D");
if (crc32("TQSnUoRHY",9) == 2791381985) strcat(s, "e");
if (crc32("oheQNCQywZdS",12) == 796323523) strcat(s, "g");
if (crc32("sMWOcVJSiOfS",12) == 1543686587) strcat(s, "d");
if (crc32("mEudcvunU",9) == 4015401255) strcat(s, "J");
if (crc32("ptYMumlA",8) == 2395611766) strcat(s, "e");
if (crc32("jCwvZoIzM",9) == 2739518138) strcat(s, "r");
if (crc32("jOXvyarzlyF",11) == 146798090) strcat(s, "c");
if (crc32("qsgkl",5) == 766766417) strcat(s, "j");
if (crc32("xUYKaJxLazt",11) == 2324873566) strcat(s, "k");
if (crc32("CVNHcFVZxCTqz",13) == 203341817) strcat(s, "Z");
if (crc32("aTGthjeJjMAN",12) == 3808537389) strcat(s, "e");
if (crc32("kmZtxiwHVKgML",13) == 4151858723) strcat(s, "r");
    return s;
}

char *Bedell_nouns() {
    char *s = calloc(7);
    if (crc32("QfAPja",6) == 2699914404) strcat(s, "K");
if (crc32("stkvoOu",7) == 1693235559) strcat(s, "B");
if (crc32("OLBHuQWz",8) == 122068193) strcat(s, "o");
if (crc32("GPajInZdlc",10) == 653364396) strcat(s, "e");
if (crc32("xlsdvVoIrPoyL",13) == 2991423672) strcat(s, "d");
if (crc32("AgfSTxpgpevr",12) == 4065072404) strcat(s, "e");
if (crc32("RqHNJCUrVP",10) == 3393445362) strcat(s, "l");
if (crc32("gKePDzo",7) == 1433660401) strcat(s, "f");
if (crc32("wdiJPJzls",9) == 52407030) strcat(s, "l");
    return s;
}

char *arithmancy_nouns() {
    char *s = calloc(11);
    if (crc32("eqttTGKiz",9) == 2883836358) strcat(s, "a");
if (crc32("LFCOl",5) == 2758215828) strcat(s, "r");
if (crc32("FHXUtN",6) == 3199811625) strcat(s, "i");
if (crc32("EJherHt",7) == 3097189121) strcat(s, "t");
if (crc32("irxLjXwSxTIuM",13) == 3405553496) strcat(s, "h");
if (crc32("TlGTMKE",7) == 4127587349) strcat(s, "m");
if (crc32("UFvSGGlP",8) == 2164867638) strcat(s, "z");
if (crc32("HJmGZloKrnwv",12) == 3818983241) strcat(s, "a");
if (crc32("UGoyRhcShwU",11) == 1152454711) strcat(s, "n");
if (crc32("fxpPidL",7) == 721115128) strcat(s, "p");
if (crc32("dIWglrmejyVo",12) == 3105002946) strcat(s, "c");
if (crc32("zdtObFofyJZmLN",14) == 645263637) strcat(s, "x");
if (crc32("NuIgJojXs",9) == 1604534806) strcat(s, "y");
    return s;
}

char *olm_nouns() {
    char *s = calloc(4);
    if (crc32("sxvWWVGou",9) == 710427401) strcat(s, "A");
if (crc32("lPHRAQrxEgJ",11) == 952623737) strcat(s, "o");
if (crc32("gcxObZxw",8) == 3775128328) strcat(s, "l");
if (crc32("ptEtioUCb",9) == 1573412760) strcat(s, "m");
    return s;
}

char *hacek_nouns() {
    char *s = calloc(6);
    if (crc32("AmtUEMdQH",9) == 1549636166) strcat(s, "g");
if (crc32("oMfrAr",6) == 4132633185) strcat(s, "h");
if (crc32("qSBkPiBv",8) == 260343234) strcat(s, "n");
if (crc32("hUfRrdWjlTHBAd",14) == 580385181) strcat(s, "a");
if (crc32("MzdMpg",6) == 2588653055) strcat(s, "t");
if (crc32("zyPrNhT",7) == 3143270214) strcat(s, "c");
if (crc32("eZMiK",5) == 2396021606) strcat(s, "o");
if (crc32("XRzAPrgnMbMLvk",14) == 4037926294) strcat(s, "e");
if (crc32("GLFZSWSgGpRsWH",14) == 400475558) strcat(s, "k");
    return s;
}

char *Biro_nouns() {
    char *s = calloc(5);
    if (crc32("BfQWWCMpNlL",11) == 4079624944) strcat(s, "Y");
if (crc32("sbMRL",5) == 1725595252) strcat(s, "B");
if (crc32("puNFrIx",7) == 3977017274) strcat(s, "d");
if (crc32("EJtUKwLZuAYENo",14) == 4211479521) strcat(s, "i");
if (crc32("PXcxt",5) == 2344616007) strcat(s, "X");
if (crc32("zUeRoyLWiufXBiH",15) == 2595035669) strcat(s, "r");
if (crc32("qngBOOcyoREH",12) == 2749429602) strcat(s, "L");
if (crc32("nMKKtAkmTt",10) == 3778378999) strcat(s, "o");
    return s;
}

char *Coucher_nouns() {
    char *s = calloc(8);
    if (crc32("BcbQCWRHmaIJRhb",15) == 3623755846) strcat(s, "C");
if (crc32("lFZco",5) == 3597239675) strcat(s, "o");
if (crc32("CwhtpAaiYKR",11) == 3230445706) strcat(s, "u");
if (crc32("xZYlEAJjJFhbxnJ",15) == 2718950158) strcat(s, "c");
if (crc32("bfrsaYRJuG",10) == 1742824436) strcat(s, "n");
if (crc32("pVgxcyVUtZynyzL",15) == 3958897510) strcat(s, "h");
if (crc32("ufwquiuABwgY",12) == 274375837) strcat(s, "e");
if (crc32("fjTqY",5) == 3421324572) strcat(s, "r");
    return s;
}

char *Oozys_nouns() {
    char *s = calloc(6);
    if (crc32("rXxucA",6) == 1290920649) strcat(s, "O");
if (crc32("xVyNJtCBNMMk",12) == 1110421814) strcat(s, "o");
if (crc32("UrTqNP",6) == 2052989605) strcat(s, "z");
if (crc32("WHJZAGb",7) == 1127878953) strcat(s, "y");
if (crc32("Qigvnq",6) == 3761757358) strcat(s, "N");
if (crc32("NxSVTrChrFW",11) == 2790903146) strcat(s, "s");
    return s;
}

char *unriotousness_nouns() {
    char *s = calloc(14);
    if (crc32("yWxehvFQpRrwr",13) == 2751270027) strcat(s, "d");
if (crc32("JPvqFpoZV",9) == 2316211699) strcat(s, "u");
if (crc32("QAIPpqbQRwwxgY",14) == 1184398418) strcat(s, "n");
if (crc32("cQzfrPAMPSadkM",14) == 4062120705) strcat(s, "r");
if (crc32("yovbrpvdrgD",11) == 1627972305) strcat(s, "i");
if (crc32("tNkxwxxcdOhP",12) == 4092022337) strcat(s, "o");
if (crc32("kPdHxAxhGZYod",13) == 2811086801) strcat(s, "t");
if (crc32("HrtNwqG",7) == 3771921849) strcat(s, "M");
if (crc32("EGVrBAFPajGgGg",14) == 155820665) strcat(s, "o");
if (crc32("AjOYLlidMSYNT",13) == 1496989034) strcat(s, "B");
if (crc32("IzvGFp",6) == 3880845267) strcat(s, "u");
if (crc32("dzTuLXnBJ",9) == 3716234184) strcat(s, "v");
if (crc32("FhXzYeYTzSZruC",14) == 1335817163) strcat(s, "s");
if (crc32("auSbjpMDuxLoyA",14) == 4017570157) strcat(s, "n");
if (crc32("awZilkYZ",8) == 2749621537) strcat(s, "K");
if (crc32("hFBwOQTQbIiMlx",14) == 2674209088) strcat(s, "e");
if (crc32("UncxSUdt",8) == 26842136) strcat(s, "s");
if (crc32("BLJqRozV",8) == 2451032840) strcat(s, "s");
    return s;
}

char *Knigsberg_nouns() {
    char *s = calloc(10);
    if (crc32("eHdeKi",6) == 2857840408) strcat(s, "m");
if (crc32("ZgcTXfwpdv",10) == 268532430) strcat(s, "K");
if (crc32("bnRWRa",6) == 1353857286) strcat(s, "w");
if (crc32("QvrgVUlwYs",10) == 1050574973) strcat(s, "n");
if (crc32("lFkqSlv",7) == 734982512) strcat(s, "i");
if (crc32("xwSxv",5) == 3373429544) strcat(s, "g");
if (crc32("lhkGuSx",7) == 2410136630) strcat(s, "c");
if (crc32("MhlOqOkPNSaCH",13) == 2828259419) strcat(s, "s");
if (crc32("xVTrEvwasYp",11) == 4294442361) strcat(s, "N");
if (crc32("fzrsqUZTkRnLA",13) == 2922594113) strcat(s, "b");
if (crc32("uqGDsrhqQG",10) == 1764999887) strcat(s, "e");
if (crc32("DwCJHEQZTqEX",12) == 1095081553) strcat(s, "K");
if (crc32("YeGZemyvHlX",11) == 615268244) strcat(s, "r");
if (crc32("KLvYyrJwPv",10) == 1760686134) strcat(s, "g");
    return s;
}

char *dripolator_nouns() {
    char *s = calloc(11);
    if (crc32("RnUKtDjzjpCNzls",15) == 624838541) strcat(s, "W");
if (crc32("HUSHNBwcTB",10) == 393400741) strcat(s, "d");
if (crc32("VzpDoiQcissQNM",14) == 2292535251) strcat(s, "Z");
if (crc32("HvPoeRtJtjyGb",13) == 3550581994) strcat(s, "r");
if (crc32("MeevwLWSoxJnNT",14) == 2008271899) strcat(s, "i");
if (crc32("FECrIJFHVDUHxQ",14) == 2527107226) strcat(s, "p");
if (crc32("dgzRjIpjfXcHXR",14) == 2555641857) strcat(s, "o");
if (crc32("nBLGv",5) == 2089547730) strcat(s, "N");
if (crc32("mXRdfR",6) == 2513658113) strcat(s, "l");
if (crc32("FiNxCA",6) == 3646780089) strcat(s, "s");
if (crc32("AttCWcznLwut",12) == 1779428427) strcat(s, "a");
if (crc32("HGqtPYCaOkA",11) == 3693155971) strcat(s, "t");
if (crc32("rDsdHJqLc",9) == 312088447) strcat(s, "v");
if (crc32("mtihDNpfTWg",11) == 3552250018) strcat(s, "o");
if (crc32("BwBbxaMipyq",11) == 3655901443) strcat(s, "n");
if (crc32("mCZdZ",5) == 3307539997) strcat(s, "r");
    return s;
}

char *unselfrighteousness_nouns() {
    char *s = calloc(20);
    if (crc32("MkjDW",5) == 3646325353) strcat(s, "g");
if (crc32("ZsEpvN",6) == 2996789909) strcat(s, "u");
if (crc32("sQtJnCMqdlc",11) == 1007372122) strcat(s, "n");
if (crc32("WsTRISvY",8) == 3791365972) strcat(s, "Z");
if (crc32("wjeDMZZOdWgJrAS",15) == 1833614952) strcat(s, "s");
if (crc32("FNLoeIbVy",9) == 876273648) strcat(s, "e");
if (crc32("bHTGyFJTIOjdC",13) == 447940344) strcat(s, "l");
if (crc32("EFVOBdMpHWEx",12) == 3793727816) strcat(s, "f");
if (crc32("WvnlavJA",8) == 65955532) strcat(s, "r");
if (crc32("uroUFvVOP",9) == 2125046532) strcat(s, "i");
if (crc32("CpZbNZZ",7) == 2073576857) strcat(s, "o");
if (crc32("VvUYcenjPPWr",12) == 3038651487) strcat(s, "g");
if (crc32("nSEdIJmTg",9) == 3298578768) strcat(s, "I");
if (crc32("tkWHVIfZEWtur",13) == 4220131612) strcat(s, "h");
if (crc32("rjurIsHKTQwn",12) == 1343082143) strcat(s, "r");
if (crc32("zqnqMEQ",7) == 162219035) strcat(s, "t");
if (crc32("CQFNYTpCmpRleM",14) == 2113249086) strcat(s, "g");
if (crc32("NHNXCT",6) == 1109721114) strcat(s, "e");
if (crc32("wzEiW",5) == 3191066792) strcat(s, "o");
if (crc32("QRWWXQ",6) == 3117348086) strcat(s, "M");
if (crc32("IcWnCRDmzNVRI",13) == 657218122) strcat(s, "u");
if (crc32("bPFbtEZ",7) == 3078678676) strcat(s, "M");
if (crc32("SNxRTizepT",10) == 1721501158) strcat(s, "s");
if (crc32("vVOEY",5) == 2527907398) strcat(s, "U");
if (crc32("OEOoNlL",7) == 91938854) strcat(s, "n");
if (crc32("IFBoAVQpktYUMr",14) == 1884501821) strcat(s, "e");
if (crc32("fsxYdqgAnl",10) == 3842739954) strcat(s, "i");
if (crc32("BFLhmLacS",9) == 3679759163) strcat(s, "s");
if (crc32("kFxlrbyFkGfICEy",15) == 4143963934) strcat(s, "A");
if (crc32("ACKOkRhfX",9) == 2948944340) strcat(s, "s");
    return s;
}

char *resistance_nouns() {
    char *s = calloc(11);
    if (crc32("bkCeOxQH",8) == 3832624251) strcat(s, "r");
if (crc32("ZEIzxXIqYdMX",12) == 3690593053) strcat(s, "a");
if (crc32("kBMyducZonQDVz",14) == 3630586674) strcat(s, "e");
if (crc32("fkhBwo",6) == 2977046018) strcat(s, "s");
if (crc32("MsStyAdQqtBwhIn",15) == 1261599723) strcat(s, "i");
if (crc32("untRz",5) == 2745216578) strcat(s, "x");
if (crc32("JdaRFWPCGcXVYJb",15) == 2139642016) strcat(s, "s");
if (crc32("TwHzHojIYgyMb",13) == 3373273474) strcat(s, "L");
if (crc32("gSgzmCsIdU",10) == 3190857971) strcat(s, "t");
if (crc32("yEuzp",5) == 3092290137) strcat(s, "V");
if (crc32("MWdNPiUHkDu",11) == 1116656765) strcat(s, "a");
if (crc32("qjtzycwLRfpJqOv",15) == 734612422) strcat(s, "n");
if (crc32("zFbTKT",6) == 1185907013) strcat(s, "j");
if (crc32("WwQXMYTAYtRl",12) == 2757684933) strcat(s, "c");
if (crc32("EvnpC",5) == 2596688018) strcat(s, "e");
    return s;
}

char *Westworth_nouns() {
    char *s = calloc(10);
    if (crc32("ToJMPsNlLP",10) == 4067628274) strcat(s, "W");
if (crc32("TlRZwuXWBW",10) == 1797424121) strcat(s, "I");
if (crc32("QHIlRDHBmqB",11) == 1028388694) strcat(s, "e");
if (crc32("TaVIWKEaKR",10) == 388558673) strcat(s, "s");
if (crc32("AAmfKCaYAdhehKV",15) == 1178209331) strcat(s, "C");
if (crc32("kfiddLva",8) == 3449294346) strcat(s, "t");
if (crc32("tBbdQBSQyuJV",12) == 264422886) strcat(s, "w");
if (crc32("tNEMSXvGUKUDkgF",15) == 901187751) strcat(s, "o");
if (crc32("ZPaheVFxapCXKo",14) == 1410688555) strcat(s, "G");
if (crc32("eyBhYDL",7) == 1014802037) strcat(s, "r");
if (crc32("tRvYrJMySmdBlx",14) == 1245098772) strcat(s, "t");
if (crc32("MRRzlmJhlnAmn",13) == 2641610388) strcat(s, "h");
    return s;
}

char *protochordate_nouns() {
    char *s = calloc(14);
    if (crc32("BOzzYx",6) == 1843534707) strcat(s, "F");
if (crc32("XByCpI",6) == 939031645) strcat(s, "p");
if (crc32("pEcWGg",6) == 108869306) strcat(s, "r");
if (crc32("LeYWxaJ",7) == 2502561723) strcat(s, "o");
if (crc32("reiRErB",7) == 3087935075) strcat(s, "t");
if (crc32("GwegVfX",7) == 2345106212) strcat(s, "Y");
if (crc32("hSNBMB",6) == 4278648539) strcat(s, "o");
if (crc32("PhyBxowEmaht",12) == 1727985541) strcat(s, "N");
if (crc32("hfzorkeWJAJJDZd",15) == 2378544010) strcat(s, "c");
if (crc32("AoTOGnwrPvN",11) == 3210451655) strcat(s, "v");
if (crc32("WwrJRhSJVFeuB",13) == 1786245659) strcat(s, "h");
if (crc32("KFURJYPSd",9) == 3006485759) strcat(s, "N");
if (crc32("wLQJjyVjR",9) == 2422982420) strcat(s, "o");
if (crc32("OtmNmQRVbkxa",12) == 1693043055) strcat(s, "j");
if (crc32("ueYsUq",6) == 3145972598) strcat(s, "r");
if (crc32("mtbLBmP",7) == 497574804) strcat(s, "d");
if (crc32("RiHUyhRgFHw",11) == 3850911024) strcat(s, "a");
if (crc32("wxrqoHpEeWo",11) == 2827405574) strcat(s, "o");
if (crc32("OgRKOqTleVXbg",13) == 531655393) strcat(s, "t");
if (crc32("VoBKvbiXMK",10) == 812558171) strcat(s, "l");
if (crc32("URLLBQKRdeoMSr",14) == 990435817) strcat(s, "e");
    return s;
}

char *damselfly_nouns() {
    char *s = calloc(10);
    if (crc32("uTivSLpTrIVpy",13) == 1550926777) strcat(s, "C");
if (crc32("MtxHB",5) == 2022473847) strcat(s, "d");
if (crc32("ahjwtyjeE",9) == 627644922) strcat(s, "u");
if (crc32("tbvIwYxxswjjDI",14) == 209272131) strcat(s, "a");
if (crc32("YcyqpjaTPX",10) == 2367486100) strcat(s, "q");
if (crc32("JlBVJSNpKzf",11) == 482731091) strcat(s, "m");
if (crc32("jZleRjjuQInVa",13) == 3485524707) strcat(s, "o");
if (crc32("nGNdZYrDSKrCL",13) == 1634612713) strcat(s, "s");
if (crc32("XNWCTfdiCTBb",12) == 2720350805) strcat(s, "n");
if (crc32("qMBgJpIn",8) == 1651454718) strcat(s, "e");
if (crc32("sTMmUJxwO",9) == 3754667327) strcat(s, "j");
if (crc32("eMaWp",5) == 308581496) strcat(s, "l");
if (crc32("MTdBnYLS",8) == 2806781660) strcat(s, "f");
if (crc32("tJlcI",5) == 20135694) strcat(s, "A");
if (crc32("mwrEOlXTA",9) == 3743588724) strcat(s, "l");
if (crc32("WIzXnyysmdPAPbR",15) == 1039442184) strcat(s, "y");
    return s;
}

char *straw_nouns() {
    char *s = calloc(6);
    if (crc32("wjLUuD",6) == 3962302674) strcat(s, "s");
if (crc32("snJuDIVMws",10) == 1941012524) strcat(s, "c");
if (crc32("coQZEtUYl",9) == 2480870797) strcat(s, "t");
if (crc32("MrwVR",5) == 722923588) strcat(s, "a");
if (crc32("pryhGYAUmlH",11) == 4198126049) strcat(s, "r");
if (crc32("RDmIxtCTzrFn",12) == 567959327) strcat(s, "D");
if (crc32("sHobHJwiO",9) == 1918237008) strcat(s, "a");
if (crc32("aewlHSUDz",9) == 3980888399) strcat(s, "v");
if (crc32("OCuteR",6) == 3261662363) strcat(s, "w");
    return s;
}

char *Paintsville_nouns() {
    char *s = calloc(12);
    if (crc32("NoUTvJoMF",9) == 79169051) strcat(s, "P");
if (crc32("jhcbNURZEP",10) == 482896891) strcat(s, "m");
if (crc32("IgnrfcEqkaQJ",12) == 435007311) strcat(s, "a");
if (crc32("TkcBFDgOqv",10) == 649337908) strcat(s, "i");
if (crc32("wBhamJWJ",8) == 2271524015) strcat(s, "n");
if (crc32("OOUNrsv",7) == 231384943) strcat(s, "l");
if (crc32("IlFyoEftlOQdZW",14) == 1724338703) strcat(s, "t");
if (crc32("AbUdjRMO",8) == 2855960762) strcat(s, "J");
if (crc32("xkaWboU",7) == 1617369616) strcat(s, "s");
if (crc32("bDqLEoyvhQm",11) == 1681704277) strcat(s, "o");
if (crc32("JimKJL",6) == 1264351838) strcat(s, "v");
if (crc32("kwMlZrrUXpzxJ",13) == 4045213640) strcat(s, "i");
if (crc32("WRlBeLVzpfruRE",14) == 2374604365) strcat(s, "i");
if (crc32("uAWcvlIf",8) == 2485289915) strcat(s, "u");
if (crc32("BRaPAvf",7) == 3423452775) strcat(s, "l");
if (crc32("xRMJKPMhZVOTLF",14) == 2488201781) strcat(s, "l");
if (crc32("MEqNLS",6) == 1386384494) strcat(s, "s");
if (crc32("xTBewrRGeyM",11) == 1682958639) strcat(s, "e");
    return s;
}

char *wrinkledness_nouns() {
    char *s = calloc(13);
    if (crc32("PIRKTOUh",8) == 1937151063) strcat(s, "r");
if (crc32("swVjYu",6) == 2545327925) strcat(s, "w");
if (crc32("xZTAv",5) == 3936078424) strcat(s, "Q");
if (crc32("TYHajucL",8) == 1916915918) strcat(s, "r");
if (crc32("jiNtvdZLzKdVXjo",15) == 1752709326) strcat(s, "i");
if (crc32("WfUUzQRFMv",10) == 2189613486) strcat(s, "F");
if (crc32("IcdEaVAKsEgYrz",14) == 3901776123) strcat(s, "n");
if (crc32("zFzGxhGQK",9) == 2917397074) strcat(s, "x");
if (crc32("BhnuH",5) == 1921352163) strcat(s, "k");
if (crc32("HIGCTpa",7) == 3750912538) strcat(s, "l");
if (crc32("IZHauSWcCapzG",13) == 2152456388) strcat(s, "h");
if (crc32("tXKnWoWhdodY",12) == 304254798) strcat(s, "e");
if (crc32("GDtGH",5) == 1257141802) strcat(s, "U");
if (crc32("OiEbAaSsbFEU",12) == 2534708784) strcat(s, "d");
if (crc32("pDlthiVcXjzvdz",14) == 3896797672) strcat(s, "n");
if (crc32("XFEhUGBN",8) == 3079233818) strcat(s, "p");
if (crc32("TvlHSgFaiASUQ",13) == 2915124873) strcat(s, "e");
if (crc32("dCqhwYaKCbWj",12) == 2267482606) strcat(s, "s");
if (crc32("TOFlcrfPqlExfF",14) == 2656768514) strcat(s, "o");
if (crc32("KsJnFdvvBf",10) == 3794778136) strcat(s, "s");
    return s;
}

char *titration_nouns() {
    char *s = calloc(10);
    if (crc32("JIXOdHvTtMMD",12) == 2601188179) strcat(s, "F");
if (crc32("WbdzN",5) == 3595847001) strcat(s, "t");
if (crc32("tvfpVDVjQnl",11) == 3087178458) strcat(s, "i");
if (crc32("IauXlSRxMxbugTT",15) == 1311704864) strcat(s, "t");
if (crc32("zUgpdWBjXdFApWd",15) == 282378786) strcat(s, "H");
if (crc32("emoRlMSQEJL",11) == 180074872) strcat(s, "r");
if (crc32("HastLcwqW",9) == 2203786894) strcat(s, "Z");
if (crc32("hmQyJV",6) == 2496198462) strcat(s, "a");
if (crc32("vkPGOTtUfVyOvAJ",15) == 3791427577) strcat(s, "C");
if (crc32("mkjPkcThlOCLWW",14) == 3386936151) strcat(s, "t");
if (crc32("gjoVLvDP",8) == 2700855830) strcat(s, "i");
if (crc32("faQRDRKtVw",10) == 3000653644) strcat(s, "o");
if (crc32("pUVSUSc",7) == 2453280357) strcat(s, "R");
if (crc32("iRYyUyclblSkG",13) == 2198246063) strcat(s, "n");
    return s;
}

char *astromancer_nouns() {
    char *s = calloc(12);
    if (crc32("PHFNSfh",7) == 4026435981) strcat(s, "a");
if (crc32("UnAGYvfRTgs",11) == 4054709624) strcat(s, "A");
if (crc32("HpXXeynggHBYOc",14) == 2369997956) strcat(s, "s");
if (crc32("PKJLpmESLgQ",11) == 504667608) strcat(s, "t");
if (crc32("EYzNtp",6) == 1298152144) strcat(s, "t");
if (crc32("tUeipHqNAOMWcO",14) == 4242604818) strcat(s, "r");
if (crc32("gwbRb",5) == 3352004458) strcat(s, "R");
if (crc32("wBHRErTvAflnSm",14) == 775763988) strcat(s, "o");
if (crc32("ijYAfQ",6) == 2771229249) strcat(s, "m");
if (crc32("LnZOCGFvwizSE",13) == 3791487160) strcat(s, "a");
if (crc32("xbXyHPslQPmy",12) == 3039740080) strcat(s, "G");
if (crc32("xerrzIrhHIhLN",13) == 3262931557) strcat(s, "n");
if (crc32("ssxhpZcG",8) == 2016597793) strcat(s, "c");
if (crc32("dtHwFZRYiXnxXn",14) == 1955394826) strcat(s, "e");
if (crc32("iqfUbbksthGmIRn",15) == 1033981495) strcat(s, "r");
    return s;
}

char *interdivision_nouns() {
    char *s = calloc(14);
    if (crc32("Xqmzr",5) == 1821785440) strcat(s, "l");
if (crc32("lYLbNyz",7) == 3271479367) strcat(s, "i");
if (crc32("QUEMFUDVexJ",11) == 3363503130) strcat(s, "x");
if (crc32("RhsMLQMdLhVTU",13) == 2644326815) strcat(s, "n");
if (crc32("KimWTFTlpB",10) == 457797122) strcat(s, "N");
if (crc32("eeuyMFTRWtOeuCI",15) == 538818041) strcat(s, "t");
if (crc32("NuVWfLbqxPNZnzP",15) == 1028810903) strcat(s, "B");
if (crc32("FzFWuV",6) == 3698193946) strcat(s, "e");
if (crc32("tmskEHxaFIUHfGu",15) == 833644650) strcat(s, "r");
if (crc32("xbtyQHCs",8) == 2108640534) strcat(s, "d");
if (crc32("pASzqEOq",8) == 3880200369) strcat(s, "i");
if (crc32("efwcaEMNxdF",11) == 829155955) strcat(s, "v");
if (crc32("MtIUOp",6) == 2782471940) strcat(s, "i");
if (crc32("RSeRBdk",7) == 990195056) strcat(s, "s");
if (crc32("HWQoxw",6) == 3242707394) strcat(s, "i");
if (crc32("dEiWNpW",7) == 3754693403) strcat(s, "o");
if (crc32("zGsJEnfLhvNiunR",15) == 2651485920) strcat(s, "n");
    return s;
}

char *intender_nouns() {
    char *s = calloc(9);
    if (crc32("RfBGbyMR",8) == 951652596) strcat(s, "i");
if (crc32("cyzZToZSVBfDDi",14) == 3680451508) strcat(s, "D");
if (crc32("hgAuqSdNcOr",11) == 3421845710) strcat(s, "n");
if (crc32("kQNLY",5) == 2132945241) strcat(s, "P");
if (crc32("hpLpFdgy",8) == 4190686833) strcat(s, "t");
if (crc32("mVuWZuXJTqRPrQ",14) == 1463159321) strcat(s, "Y");
if (crc32("RTFYzomgnLvfIy",14) == 3231705312) strcat(s, "e");
if (crc32("awWsIhSJ",8) == 2513773428) strcat(s, "g");
if (crc32("iYPvHgmPXPcVKs",14) == 3380279449) strcat(s, "n");
if (crc32("EXMaMUDqdxGXp",13) == 1643282761) strcat(s, "d");
if (crc32("BdOhccJwNaO",11) == 3494802462) strcat(s, "S");
if (crc32("mFLTcPCCkTe",11) == 218542744) strcat(s, "e");
if (crc32("mlpUnmuKlg",10) == 3382050191) strcat(s, "r");
    return s;
}

char *squirrelfish_nouns() {
    char *s = calloc(13);
    if (crc32("cunNSZoyTal",11) == 4216169256) strcat(s, "s");
if (crc32("ysPhOKwKXhOxNAK",15) == 656752510) strcat(s, "q");
if (crc32("HGXwmwgIeDTxVa",14) == 138329796) strcat(s, "u");
if (crc32("paBJhySTxgrA",12) == 900498740) strcat(s, "g");
if (crc32("WCNwvoks",8) == 1935211558) strcat(s, "i");
if (crc32("cLHSzBK",7) == 3399481604) strcat(s, "H");
if (crc32("PQfvOOXoRZ",10) == 3425152107) strcat(s, "r");
if (crc32("IzZNaSTogsQv",12) == 443930544) strcat(s, "r");
if (crc32("zBLSFpa",7) == 2999072562) strcat(s, "e");
if (crc32("fxskGd",6) == 1847767514) strcat(s, "l");
if (crc32("gKJktIHmOwIE",12) == 1262270083) strcat(s, "f");
if (crc32("vtnujkcvjIxwbB",14) == 1675877054) strcat(s, "c");
if (crc32("LmrpsVDh",8) == 2291030000) strcat(s, "i");
if (crc32("obNGNeawWiH",11) == 4090323794) strcat(s, "s");
if (crc32("LhypPQe",7) == 2539239444) strcat(s, "h");
    return s;
}

char *quinoid_nouns() {
    char *s = calloc(8);
    if (crc32("uGTLqMkSYh",10) == 3507357525) strcat(s, "q");
if (crc32("aNaffvyJ",8) == 3170962204) strcat(s, "F");
if (crc32("vPbFuAxg",8) == 2815302957) strcat(s, "u");
if (crc32("deCkWqMSuk",10) == 1938482601) strcat(s, "N");
if (crc32("QBYRGOp",7) == 1550337338) strcat(s, "i");
if (crc32("UqZVVHpaaurtI",13) == 3040896527) strcat(s, "n");
if (crc32("XkCEolCgFnMKV",13) == 3003458384) strcat(s, "o");
if (crc32("hkiAVd",6) == 2036127923) strcat(s, "u");
if (crc32("RGHnfgVIg",9) == 4130405500) strcat(s, "i");
if (crc32("QbZDttiiaxfBVRE",15) == 3893037324) strcat(s, "e");
if (crc32("DihyD",5) == 3841420467) strcat(s, "d");
    return s;
}

char *Abelard_nouns() {
    char *s = calloc(8);
    if (crc32("zcFFiwxGQdXL",12) == 1341211745) strcat(s, "r");
if (crc32("QGhxXO",6) == 2897384433) strcat(s, "A");
if (crc32("uDGLYhj",7) == 4023023490) strcat(s, "b");
if (crc32("vapxbfw",7) == 816888284) strcat(s, "e");
if (crc32("uYcHJIuukot",11) == 1779773160) strcat(s, "l");
if (crc32("FtWUFghnxVvT",12) == 971112688) strcat(s, "a");
if (crc32("CXrlVpJrvpWA",12) == 181019985) strcat(s, "r");
if (crc32("qJqDdNuehQeefqG",15) == 1574695265) strcat(s, "d");
    return s;
}

char *superdemand_nouns() {
    char *s = calloc(12);
    if (crc32("CWxho",5) == 2774550033) strcat(s, "s");
if (crc32("OBCyvvjghnTxjiL",15) == 3386515423) strcat(s, "u");
if (crc32("SrFaazUqRba",11) == 2684738802) strcat(s, "n");
if (crc32("XtWRuSOwzCfw",12) == 3235679306) strcat(s, "p");
if (crc32("vkRhCZpevuEIV",13) == 3378512351) strcat(s, "S");
if (crc32("sVsyK",5) == 3748835794) strcat(s, "e");
if (crc32("rKvmCp",6) == 1688861180) strcat(s, "u");
if (crc32("ShsVbVW",7) == 1767852745) strcat(s, "r");
if (crc32("BSCCfyKbd",9) == 3962997192) strcat(s, "H");
if (crc32("BoQMk",5) == 1973278334) strcat(s, "d");
if (crc32("fGLHMkLv",8) == 709202972) strcat(s, "e");
if (crc32("ksuSjIblMOuNf",13) == 256453470) strcat(s, "m");
if (crc32("qyIdQQ",6) == 2473624645) strcat(s, "a");
if (crc32("UtJlDMLtUVrTxK",14) == 287758313) strcat(s, "n");
if (crc32("eEDmmwvBuRB",11) == 61571143) strcat(s, "d");
    return s;
}

char *hedgehog_nouns() {
    char *s = calloc(9);
    if (crc32("JguUiuvEGrjCwzG",15) == 3099203265) strcat(s, "h");
if (crc32("JpNHSMw",7) == 706358092) strcat(s, "e");
if (crc32("bkcEg",5) == 2214541546) strcat(s, "B");
if (crc32("HTXjVaggm",9) == 2341753932) strcat(s, "d");
if (crc32("tYUGUlnWBHnSU",13) == 1189923900) strcat(s, "j");
if (crc32("zAAUrCsSDUt",11) == 2694547288) strcat(s, "g");
if (crc32("hudhZb",6) == 1967066189) strcat(s, "e");
if (crc32("yEbVPgo",7) == 764414483) strcat(s, "h");
if (crc32("cQtXrmFhdt",10) == 223945539) strcat(s, "o");
if (crc32("rtZsAtzhKPJcvI",14) == 3713282111) strcat(s, "g");
    return s;
}

char *BSS_nouns() {
    char *s = calloc(4);
    if (crc32("mNrJXPYuJJuimEC",15) == 2291650764) strcat(s, "p");
if (crc32("Gmutfq",6) == 3649123618) strcat(s, "B");
if (crc32("oIuFWVqUxZM",11) == 2312964527) strcat(s, "S");
if (crc32("ZmomOdZTStck",12) == 3798856339) strcat(s, "I");
if (crc32("uZpHhiDnDdRPrww",15) == 1237339062) strcat(s, "S");
    return s;
}

char *couperativeness_nouns() {
    char *s = calloc(16);
    if (crc32("CWQenkcEq",9) == 492795477) strcat(s, "N");
if (crc32("klVuXgDwROGegrm",15) == 3823571239) strcat(s, "c");
if (crc32("lhMMinHmT",9) == 95635134) strcat(s, "o");
if (crc32("WameCbuYCbLky",13) == 3705171761) strcat(s, "o");
if (crc32("eaiBkY",6) == 48261050) strcat(s, "l");
if (crc32("kXZgD",5) == 476005763) strcat(s, "u");
if (crc32("YYUupmLeMoJJv",13) == 1412748122) strcat(s, "p");
if (crc32("bdVJtLjDvPvH",12) == 740309540) strcat(s, "e");
if (crc32("jrOsTxDISacfbL",14) == 2486078926) strcat(s, "r");
if (crc32("MYadmVeiSCmjC",13) == 328930022) strcat(s, "a");
if (crc32("Bqjhnd",6) == 2485038380) strcat(s, "t");
if (crc32("GMRmXBcUvUOmRH",14) == 3643375855) strcat(s, "C");
if (crc32("iLNhVar",7) == 1213545839) strcat(s, "i");
if (crc32("HuByqSQujVwM",12) == 3454970370) strcat(s, "E");
if (crc32("VNJQOD",6) == 324110076) strcat(s, "v");
if (crc32("BnvOJCDcb",9) == 4268788354) strcat(s, "k");
if (crc32("aqtsxNuEmrZl",12) == 4212553166) strcat(s, "e");
if (crc32("zgmudvosU",9) == 2522507406) strcat(s, "n");
if (crc32("nftCIjRMXM",10) == 3400730252) strcat(s, "j");
if (crc32("GUfleFHMMF",10) == 2394650519) strcat(s, "e");
if (crc32("jbAXoxm",7) == 198334006) strcat(s, "s");
if (crc32("jszKbx",6) == 3615999346) strcat(s, "s");
    return s;
}

char *houndfish_nouns() {
    char *s = calloc(10);
    if (crc32("OmmtJlSmk",9) == 3513006688) strcat(s, "h");
if (crc32("VLxHX",5) == 2806058960) strcat(s, "o");
if (crc32("QLxmaWB",7) == 1149712770) strcat(s, "u");
if (crc32("emReUXFdwTNbm",13) == 1242179863) strcat(s, "w");
if (crc32("EXKgI",5) == 33251612) strcat(s, "n");
if (crc32("ZkWehXfF",8) == 2461604223) strcat(s, "o");
if (crc32("pBuFJvTS",8) == 517615511) strcat(s, "d");
if (crc32("GDNIsrpnYWdka",13) == 1929940606) strcat(s, "f");
if (crc32("IikvPEjbL",9) == 2587356015) strcat(s, "g");
if (crc32("gryZY",5) == 633682694) strcat(s, "i");
if (crc32("VXmAm",5) == 1070275066) strcat(s, "m");
if (crc32("mLbeBskUmEDuu",13) == 2200038488) strcat(s, "s");
if (crc32("XBxgRBdt",8) == 3103126202) strcat(s, "h");
    return s;
}

char *Lester_nouns() {
    char *s = calloc(7);
    if (crc32("MOoCYGegxio",11) == 4171108131) strcat(s, "M");
if (crc32("hEerquFGnJ",10) == 30590655) strcat(s, "L");
if (crc32("IQgzQqarWi",10) == 1612782580) strcat(s, "e");
if (crc32("dcwMdabHdni",11) == 382570202) strcat(s, "s");
if (crc32("CnsUZWJCLWIRhOg",15) == 3466661043) strcat(s, "V");
if (crc32("EESCYDihHHuEOeP",15) == 2119490044) strcat(s, "t");
if (crc32("cxMQltg",7) == 1741111571) strcat(s, "d");
if (crc32("FRLtTD",6) == 122482345) strcat(s, "e");
if (crc32("kjnIlTJFPcqAnp",14) == 2018700311) strcat(s, "f");
if (crc32("dyylSBOIgWWL",12) == 2208760543) strcat(s, "r");
    return s;
}

char *kneader_nouns() {
    char *s = calloc(8);
    if (crc32("yLPzkQJSInkf",12) == 2636348482) strcat(s, "k");
if (crc32("ArFZwTLk",8) == 1269908627) strcat(s, "n");
if (crc32("EeRQJaRNMvB",11) == 3103755026) strcat(s, "O");
if (crc32("ONlEw",5) == 1709734416) strcat(s, "e");
if (crc32("dbyHxyhNEZD",11) == 3720754679) strcat(s, "D");
if (crc32("GTmVfRyZlrRUCez",15) == 3507174269) strcat(s, "a");
if (crc32("ZzogWinTW",9) == 1855067009) strcat(s, "Y");
if (crc32("ZfRCeKUOe",9) == 402586465) strcat(s, "d");
if (crc32("XVXWNf",6) == 3559833873) strcat(s, "V");
if (crc32("JLehXHryJI",10) == 1698193200) strcat(s, "e");
if (crc32("pajMmiSVhG",10) == 4000390825) strcat(s, "r");
    return s;
}

char *Quiteris_nouns() {
    char *s = calloc(9);
    if (crc32("ZzDLOdZoOsT",11) == 459012781) strcat(s, "m");
if (crc32("lDzXHNueqM",10) == 2935600861) strcat(s, "Q");
if (crc32("FqeBwKh",7) == 459024547) strcat(s, "u");
if (crc32("bQBByXMHQc",10) == 2940178594) strcat(s, "i");
if (crc32("cOEFFpSaLVWI",12) == 672935690) strcat(s, "W");
if (crc32("aJJYMkVsEedu",12) == 923333413) strcat(s, "t");
if (crc32("SJThHTtHC",9) == 2437650294) strcat(s, "r");
if (crc32("yQnfr",5) == 2394171263) strcat(s, "e");
if (crc32("oWEed",5) == 2946389266) strcat(s, "r");
if (crc32("CnHosheyy",9) == 4176162619) strcat(s, "W");
if (crc32("pposNYR",7) == 2362874741) strcat(s, "i");
if (crc32("VmBBPm",6) == 3238817820) strcat(s, "s");
    return s;
}

char *Themiste_nouns() {
    char *s = calloc(9);
    if (crc32("FbJkCNfUSpX",11) == 3358640677) strcat(s, "T");
if (crc32("GFPvlaHteWgN",12) == 116507252) strcat(s, "u");
if (crc32("OoCgGTeDogVL",12) == 190805879) strcat(s, "h");
if (crc32("Zxxxrrl",7) == 2809115087) strcat(s, "W");
if (crc32("TzfttfvW",8) == 180657414) strcat(s, "e");
if (crc32("eMQqOu",6) == 949231467) strcat(s, "m");
if (crc32("fykbxlj",7) == 796500194) strcat(s, "Z");
if (crc32("TPppYHKT",8) == 3530340767) strcat(s, "i");
if (crc32("vfsnZriT",8) == 1272017401) strcat(s, "p");
if (crc32("ahPQUxJrE",9) == 1926391319) strcat(s, "s");
if (crc32("maPoF",5) == 4065931688) strcat(s, "k");
if (crc32("deCgRpW",7) == 3053880125) strcat(s, "t");
if (crc32("TvVhZQkaNcQDOz",14) == 2412793395) strcat(s, "e");
    return s;
}

char *rasbora_nouns() {
    char *s = calloc(8);
    if (crc32("hFFIndmtXqVmjjw",15) == 3058520123) strcat(s, "r");
if (crc32("hYlKiGPAVgyyZc",14) == 2853039789) strcat(s, "y");
if (crc32("jVQiqPHzbPuKWgf",15) == 414236904) strcat(s, "a");
if (crc32("sawixCNjZUi",11) == 1071499005) strcat(s, "u");
if (crc32("lifwRYPz",8) == 1628808275) strcat(s, "s");
if (crc32("kuUNbT",6) == 1608118807) strcat(s, "b");
if (crc32("XrjlGwh",7) == 3405818542) strcat(s, "G");
if (crc32("ZyhJgWcR",8) == 711432051) strcat(s, "o");
if (crc32("CYoyHhyuehxRwAF",15) == 2978980354) strcat(s, "r");
if (crc32("BxXCLqSLciWRfCJ",15) == 4149081401) strcat(s, "a");
    return s;
}

char *lopseed_nouns() {
    char *s = calloc(8);
    if (crc32("zMzleDHCxFS",11) == 1547818354) strcat(s, "l");
if (crc32("bhUyhHI",7) == 3837050620) strcat(s, "d");
if (crc32("shXwguPhkLz",11) == 3666475177) strcat(s, "o");
if (crc32("oNBradXyMlU",11) == 1009952559) strcat(s, "p");
if (crc32("PccyfO",6) == 3299426267) strcat(s, "s");
if (crc32("rZhxllcyYWD",11) == 369458386) strcat(s, "g");
if (crc32("oLwsaRXbkwr",11) == 4111237788) strcat(s, "e");
if (crc32("azEHzVnYeY",10) == 4045346857) strcat(s, "f");
if (crc32("BIXFpru",7) == 3106182646) strcat(s, "e");
if (crc32("ZwvWJwFf",8) == 2239788940) strcat(s, "h");
if (crc32("FBbdgniVQVaBC",13) == 2834316527) strcat(s, "d");
    return s;
}

char *Lycotherses_nouns() {
    char *s = calloc(12);
    if (crc32("ecioVqWeX",9) == 957104167) strcat(s, "L");
if (crc32("bsxrTFQD",8) == 3122457021) strcat(s, "k");
if (crc32("EVHizhDpLYgh",12) == 219914396) strcat(s, "y");
if (crc32("JHkMbGJFQ",9) == 1338605724) strcat(s, "c");
if (crc32("NiXZNzosmhOYZUn",15) == 1086884395) strcat(s, "I");
if (crc32("phMid",5) == 1203806978) strcat(s, "o");
if (crc32("kbOWFCJpSDGol",13) == 1710064298) strcat(s, "t");
if (crc32("hIlGt",5) == 1866411740) strcat(s, "b");
if (crc32("HJrwrU",6) == 3591029127) strcat(s, "h");
if (crc32("BfAIxjuKsj",10) == 84244358) strcat(s, "s");
if (crc32("nmkfVvJE",8) == 2354670525) strcat(s, "e");
if (crc32("PKcGq",5) == 796481250) strcat(s, "A");
if (crc32("NZuqqZboua",10) == 581875200) strcat(s, "r");
if (crc32("NlJES",5) == 1383131798) strcat(s, "s");
if (crc32("TqYfhjmklg",10) == 3067556212) strcat(s, "e");
if (crc32("oeMxvXFNLcewsvn",15) == 320786587) strcat(s, "s");
    return s;
}

char *dolour_nouns() {
    char *s = calloc(7);
    if (crc32("wnmteTOGMgPAHk",14) == 4213873060) strcat(s, "d");
if (crc32("mnVoVX",6) == 1417401253) strcat(s, "G");
if (crc32("qEiMljUEJDOhrXO",15) == 3699433531) strcat(s, "o");
if (crc32("QMACWUdJPDs",11) == 2949442088) strcat(s, "I");
if (crc32("CDseLqBtm",9) == 1823881516) strcat(s, "l");
if (crc32("AnthSVZQwIJuD",13) == 1228674386) strcat(s, "o");
if (crc32("KWtHNxEvw",9) == 1751987658) strcat(s, "r");
if (crc32("fJitaVDnAPyZN",13) == 3513267684) strcat(s, "u");
if (crc32("sUFZOMo",7) == 1696957878) strcat(s, "l");
if (crc32("VVKxgvV",7) == 820248102) strcat(s, "r");
    return s;
}

char *capaciousness_nouns() {
    char *s = calloc(14);
    if (crc32("wwozp",5) == 3177594810) strcat(s, "c");
if (crc32("KxkduR",6) == 46414029) strcat(s, "Y");
if (crc32("lrazhB",6) == 2733400542) strcat(s, "a");
if (crc32("MGPuDQcIXtZ",11) == 1904594013) strcat(s, "p");
if (crc32("BQphIp",6) == 2858701771) strcat(s, "a");
if (crc32("HAiYpeE",7) == 4136875136) strcat(s, "u");
if (crc32("mfXVAEDY",8) == 1115664399) strcat(s, "c");
if (crc32("yWgWN",5) == 1295792153) strcat(s, "i");
if (crc32("JTNYpYMFEPVRg",13) == 1485297747) strcat(s, "o");
if (crc32("twegBvcdYzSKtE",14) == 1694199643) strcat(s, "u");
if (crc32("uKPElXtiZQC",11) == 1517206305) strcat(s, "s");
if (crc32("ReCfSVDUZJ",10) == 2466134122) strcat(s, "n");
if (crc32("YWoxbJKdzTezmz",14) == 12855814) strcat(s, "s");
if (crc32("NqdjjcclfIwL",12) == 3685708075) strcat(s, "e");
if (crc32("vFaOK",5) == 3423316317) strcat(s, "K");
if (crc32("TqzBbifHgx",10) == 2668739454) strcat(s, "s");
if (crc32("iPqkoutWqeGEju",14) == 1421046124) strcat(s, "u");
if (crc32("nMcnSvskwKMIt",13) == 3297807898) strcat(s, "s");
    return s;
}

char *earthpea_nouns() {
    char *s = calloc(9);
    if (crc32("svzVrOiMjCfTcTp",15) == 1116196161) strcat(s, "f");
if (crc32("FGHjYhxjXLC",11) == 320377316) strcat(s, "e");
if (crc32("CDIGqXPCI",9) == 502057077) strcat(s, "a");
if (crc32("lSBAh",5) == 2588738461) strcat(s, "r");
if (crc32("YrtPvVSjMPYO",12) == 180579383) strcat(s, "t");
if (crc32("dibixwUbhofXhB",14) == 1738834013) strcat(s, "r");
if (crc32("kzrRkZXfVSRVay",14) == 602296648) strcat(s, "h");
if (crc32("SKKxUaRYPbB",11) == 3053193535) strcat(s, "U");
if (crc32("ADBHjdRIAtzhOL",14) == 1135337071) strcat(s, "p");
if (crc32("SQmxmjsbhTqRyA",14) == 529930422) strcat(s, "i");
if (crc32("ABGFUjCYO",9) == 1197193893) strcat(s, "e");
if (crc32("yNmhT",5) == 3355866780) strcat(s, "a");
    return s;
}

char *troopship_nouns() {
    char *s = calloc(10);
    if (crc32("omdWMVM",7) == 4066295820) strcat(s, "t");
if (crc32("jnULuRRkFWDc",12) == 3035975642) strcat(s, "r");
if (crc32("YshiLvtPdYV",11) == 1647656358) strcat(s, "o");
if (crc32("IxqxvRviN",9) == 3611978686) strcat(s, "d");
if (crc32("acbXpKFKiKm",11) == 1099048419) strcat(s, "o");
if (crc32("TpyazppHRLGlh",13) == 4078712050) strcat(s, "p");
if (crc32("FguZmRjuHMY",11) == 356428582) strcat(s, "s");
if (crc32("HlNqx",5) == 3450846557) strcat(s, "h");
if (crc32("yYVuWDdJXq",10) == 1343850770) strcat(s, "C");
if (crc32("htbSVPfdv",9) == 929593116) strcat(s, "i");
if (crc32("WJXUnLerUyAd",12) == 478756033) strcat(s, "E");
if (crc32("OQDEcASmF",9) == 1297330934) strcat(s, "p");
    return s;
}

char *burka_nouns() {
    char *s = calloc(6);
    if (crc32("btFTDqiNOSewQ",13) == 829960161) strcat(s, "b");
if (crc32("LPADAhO",7) == 3943434135) strcat(s, "F");
if (crc32("zJHAYlD",7) == 3943227868) strcat(s, "u");
if (crc32("BPJJJouT",8) == 829804461) strcat(s, "q");
if (crc32("gYHhdty",7) == 1136209624) strcat(s, "r");
if (crc32("Wqenaxsc",8) == 1740041482) strcat(s, "q");
if (crc32("yEOYMJn",7) == 259107754) strcat(s, "k");
if (crc32("AWjNoGpsHG",10) == 2164344874) strcat(s, "x");
if (crc32("cOCbisOkKJgqB",13) == 1586056218) strcat(s, "a");
    return s;
}

char *Arni_nouns() {
    char *s = calloc(5);
    if (crc32("pQrNFCs",7) == 675317140) strcat(s, "A");
if (crc32("iPmHQGkEhyAEEVx",15) == 1309845141) strcat(s, "E");
if (crc32("DIntFPkrMyHBABi",15) == 3411967327) strcat(s, "r");
if (crc32("OwdHoQwtLnRfqLg",15) == 552066684) strcat(s, "n");
if (crc32("nqSfZusEQZb",11) == 645874943) strcat(s, "K");
if (crc32("IyzhEWlG",8) == 3442663902) strcat(s, "i");
    return s;
}

char *soling_nouns() {
    char *s = calloc(7);
    if (crc32("nlbvqozS",8) == 3003559532) strcat(s, "d");
if (crc32("bTvHIYFRoAhm",12) == 2125541902) strcat(s, "s");
if (crc32("wiJedJ",6) == 3457857304) strcat(s, "Q");
if (crc32("DJFLQZFKxFrIBM",14) == 1371098968) strcat(s, "o");
if (crc32("RDhJqrIZp",9) == 2238617693) strcat(s, "x");
if (crc32("lFPOcCZQpStK",12) == 4231425821) strcat(s, "l");
if (crc32("zPGpqiXDgncJuUl",15) == 2216325995) strcat(s, "i");
if (crc32("grZuMZlS",8) == 1805909124) strcat(s, "n");
if (crc32("RYgSnzZCP",9) == 3344691713) strcat(s, "g");
    return s;
}

char *commie_nouns() {
    char *s = calloc(7);
    if (crc32("pKCNgwV",7) == 3756867128) strcat(s, "c");
if (crc32("otbiYSdUjhY",11) == 3168623211) strcat(s, "o");
if (crc32("klsLyq",6) == 1455832245) strcat(s, "m");
if (crc32("fHQOuxzGMJErfxd",15) == 1710386247) strcat(s, "Y");
if (crc32("HaMLfOpL",8) == 2843802613) strcat(s, "m");
if (crc32("RWgZFG",6) == 724202847) strcat(s, "h");
if (crc32("NRVAouoYhlpci",13) == 3200527806) strcat(s, "i");
if (crc32("evHOnPBJCvLlpE",14) == 985455588) strcat(s, "E");
if (crc32("imyddmYhKD",10) == 3481859125) strcat(s, "e");
    return s;
}

char *hackie_nouns() {
    char *s = calloc(7);
    if (crc32("MVOyGVJZcMmAFQ",14) == 179474911) strcat(s, "y");
if (crc32("tifSnvDCNdHQVl",14) == 3679818728) strcat(s, "h");
if (crc32("mKBgakhPbZO",11) == 2081319376) strcat(s, "a");
if (crc32("mkNNnLNsnAeF",12) == 2591029202) strcat(s, "f");
if (crc32("tnAEbqec",8) == 3398167460) strcat(s, "c");
if (crc32("WRxxWLMwVuflc",13) == 3779644158) strcat(s, "q");
if (crc32("CezqKU",6) == 820072566) strcat(s, "k");
if (crc32("dJVuKDm",7) == 396887968) strcat(s, "I");
if (crc32("yJvbRK",6) == 3811113602) strcat(s, "i");
if (crc32("SnTFpd",6) == 2845862499) strcat(s, "T");
if (crc32("sfUHOBNqOjSzORD",15) == 3717590275) strcat(s, "e");
    return s;
}

char *cuspid_nouns() {
    char *s = calloc(7);
    if (crc32("Zesrpki",7) == 714657870) strcat(s, "E");
if (crc32("wzsRSAyXH",9) == 3737359298) strcat(s, "c");
if (crc32("kCLwZbfLO",9) == 2931622279) strcat(s, "t");
if (crc32("AnvBbKwJTmv",11) == 2667796645) strcat(s, "u");
if (crc32("ryUKBuVMjmGT",12) == 1573333905) strcat(s, "s");
if (crc32("WqJKYklNzM",10) == 955343541) strcat(s, "K");
if (crc32("lUUgJxdKHQKTriI",15) == 2834187748) strcat(s, "p");
if (crc32("VQOGZXxjFloOYK",14) == 1192394500) strcat(s, "i");
if (crc32("jxmbXTtJY",9) == 2703380340) strcat(s, "G");
if (crc32("ZOsnWCp",7) == 1676582622) strcat(s, "d");
    return s;
}

char *o_nouns() {
    char *s = calloc(2);
    if (crc32("ELsEoUxsyld",11) == 2842625015) strcat(s, "o");
    return s;
}

char *Dorelle_nouns() {
    char *s = calloc(8);
    if (crc32("ctTwf",5) == 1408721019) strcat(s, "D");
if (crc32("fygOnxQCfPP",11) == 1017474407) strcat(s, "o");
if (crc32("HbaPZK",6) == 4282883743) strcat(s, "r");
if (crc32("PTuyVJqBT",9) == 1875522398) strcat(s, "e");
if (crc32("spNLOquHnpBgeaI",15) == 2688455183) strcat(s, "e");
if (crc32("DIODfnPOAsISid",14) == 882749938) strcat(s, "l");
if (crc32("busdU",5) == 890658383) strcat(s, "l");
if (crc32("WVVyHTFmmp",10) == 51214412) strcat(s, "e");
    return s;
}

char *oversorrowfulness_nouns() {
    char *s = calloc(18);
    if (crc32("RwBVBtdIau",10) == 944794916) strcat(s, "o");
if (crc32("ogpiKs",6) == 3140912915) strcat(s, "v");
if (crc32("dHebtTY",7) == 1593526704) strcat(s, "v");
if (crc32("xKCgYMxUMLUCP",13) == 2485127567) strcat(s, "n");
if (crc32("OHYRRletslOCi",13) == 3562494772) strcat(s, "e");
if (crc32("yVlYGCvQWsqkOc",14) == 2729145461) strcat(s, "F");
if (crc32("hMEaExHSFSEwx",13) == 1019673303) strcat(s, "r");
if (crc32("DxMAw",5) == 2593850799) strcat(s, "s");
if (crc32("WTAZkYPnVxZNJA",14) == 3394150910) strcat(s, "l");
if (crc32("kwMKpqpaKXpRpA",14) == 1499674546) strcat(s, "o");
if (crc32("AvXRodPZzkzBs",13) == 1308044314) strcat(s, "u");
if (crc32("TzQhdaftc",9) == 2847448273) strcat(s, "r");
if (crc32("hVFqtbAQLt",10) == 2865141332) strcat(s, "I");
if (crc32("hVtvvr",6) == 2440690614) strcat(s, "r");
if (crc32("OcPgCaab",8) == 1404962469) strcat(s, "I");
if (crc32("tkmlJT",6) == 562202576) strcat(s, "o");
if (crc32("bDfdHEf",7) == 3773598500) strcat(s, "w");
if (crc32("DifQLgGr",8) == 2423055238) strcat(s, "f");
if (crc32("icvkOrSyvsTgL",13) == 3878985559) strcat(s, "X");
if (crc32("SllboouKSIiQyve",15) == 1364765365) strcat(s, "u");
if (crc32("YZsraZSNwUxJ",12) == 2557498169) strcat(s, "l");
if (crc32("iISPLEuEva",10) == 3319554583) strcat(s, "n");
if (crc32("MTJgBJK",7) == 4231110658) strcat(s, "Z");
if (crc32("BQZlQ",5) == 598702684) strcat(s, "e");
if (crc32("jMFiVkfRbDPsR",13) == 584730095) strcat(s, "F");
if (crc32("ZXYfuQIw",8) == 1380468895) strcat(s, "s");
if (crc32("NZmhUivdgwL",11) == 1567566857) strcat(s, "Z");
if (crc32("hFwsACJA",8) == 3013302538) strcat(s, "s");
    return s;
}

char *superoptimist_nouns() {
    char *s = calloc(14);
    if (crc32("LlHaivciaR",10) == 3298683488) strcat(s, "s");
if (crc32("IbuBZVTdjZWUXPl",15) == 1078842435) strcat(s, "u");
if (crc32("KBcjZfoXkcZ",11) == 3982213352) strcat(s, "p");
if (crc32("NLFKJtW",7) == 3124465943) strcat(s, "i");
if (crc32("rgJcfcwDjnaQM",13) == 2711163528) strcat(s, "e");
if (crc32("dkqfiyHE",8) == 145998364) strcat(s, "o");
if (crc32("Etgox",5) == 1129268268) strcat(s, "r");
if (crc32("NKjgTZ",6) == 2418767122) strcat(s, "X");
if (crc32("qSgeKq",6) == 3530415049) strcat(s, "o");
if (crc32("WDSvrrUtZ",9) == 2048252427) strcat(s, "p");
if (crc32("tGSBJS",6) == 4112450210) strcat(s, "d");
if (crc32("nBopgKjHrV",10) == 3064096536) strcat(s, "t");
if (crc32("yUBDOsFe",8) == 1174938906) strcat(s, "i");
if (crc32("bxRdnn",6) == 734023820) strcat(s, "J");
if (crc32("nLrpCBMjh",9) == 4130902786) strcat(s, "m");
if (crc32("VnuyKV",6) == 3679707675) strcat(s, "i");
if (crc32("nByqKRaMjsjH",12) == 2136088679) strcat(s, "k");
if (crc32("IUUwJppCAWL",11) == 1728927247) strcat(s, "s");
if (crc32("FswXdqFV",8) == 2353535415) strcat(s, "t");
    return s;
}

char *supercandidness_nouns() {
    char *s = calloc(16);
    if (crc32("VoZGIIJ",7) == 2555568927) strcat(s, "s");
if (crc32("AuPAVYBSnS",10) == 2420622509) strcat(s, "J");
if (crc32("cYCTXW",6) == 1876431705) strcat(s, "u");
if (crc32("gPtjNDzjKbmw",12) == 2796895778) strcat(s, "M");
if (crc32("huGQmuQF",8) == 1748716177) strcat(s, "p");
if (crc32("GPSvHcroavq",11) == 4154948904) strcat(s, "T");
if (crc32("RvCTC",5) == 2306551573) strcat(s, "e");
if (crc32("zeWvqdwCBpBBEWq",15) == 3331728238) strcat(s, "i");
if (crc32("fLFXGvXNOf",10) == 996130675) strcat(s, "r");
if (crc32("VqYfxZh",7) == 2076770123) strcat(s, "S");
if (crc32("ToWVNcNGHmHEf",13) == 3251241610) strcat(s, "c");
if (crc32("xFgUzzZTtW",10) == 1759346659) strcat(s, "a");
if (crc32("JHeTizxRAEhGe",13) == 1901719077) strcat(s, "n");
if (crc32("DQUNSdhwZWuFr",13) == 2629879656) strcat(s, "F");
if (crc32("bJUitLdxkCAQwML",15) == 3332419347) strcat(s, "d");
if (crc32("CBhog",5) == 1817970885) strcat(s, "R");
if (crc32("LPLkyHuBQFoVcp",14) == 2819865914) strcat(s, "i");
if (crc32("pGCPMLCnMAZ",11) == 3562284228) strcat(s, "l");
if (crc32("DpPHFkYr",8) == 1864305927) strcat(s, "d");
if (crc32("mBuBa",5) == 3107378342) strcat(s, "b");
if (crc32("WhDzyl",6) == 4276250688) strcat(s, "n");
if (crc32("wrUtYN",6) == 1908513507) strcat(s, "e");
if (crc32("obVlhBFosygIpf",14) == 1575498618) strcat(s, "E");
if (crc32("bFncde",6) == 2389470246) strcat(s, "s");
if (crc32("msrKzME",7) == 4185126670) strcat(s, "U");
if (crc32("FvABPBJrs",9) == 559173383) strcat(s, "s");
    return s;
}

char *Tallassee_nouns() {
    char *s = calloc(10);
    if (crc32("PrrnltdaiYesrT",14) == 3364350590) strcat(s, "T");
if (crc32("BsgyigLljWpzmlV",15) == 3388465381) strcat(s, "y");
if (crc32("lmPLbGjWhn",10) == 3327766042) strcat(s, "a");
if (crc32("KDmRqvnSUAdLwW",14) == 692879356) strcat(s, "U");
if (crc32("fpGlcEW",7) == 3617287660) strcat(s, "l");
if (crc32("IermAuXpKeGldw",14) == 1676481629) strcat(s, "l");
if (crc32("QHxMVX",6) == 1940284093) strcat(s, "T");
if (crc32("rAPjzQxjYR",10) == 136450662) strcat(s, "a");
if (crc32("vnwBXVrzdIFmIQ",14) == 3778200975) strcat(s, "s");
if (crc32("efSLA",5) == 3125823001) strcat(s, "s");
if (crc32("ZbvGHMwhWThBw",13) == 204844084) strcat(s, "e");
if (crc32("YocYotNUnT",10) == 1329636740) strcat(s, "o");
if (crc32("kTZmYNdJahve",12) == 3085990537) strcat(s, "e");
    return s;
}

char *photoperiodism_nouns() {
    char *s = calloc(15);
    if (crc32("QpiEHYeBmPuzjmH",15) == 1106596694) strcat(s, "p");
if (crc32("KcAVZSIS",8) == 3243196197) strcat(s, "h");
if (crc32("rVCQLcrxB",9) == 2717830138) strcat(s, "u");
if (crc32("VkKsVLnJyi",10) == 192043210) strcat(s, "o");
if (crc32("aIZVmnBpCqqAmhx",15) == 904433346) strcat(s, "f");
if (crc32("CEVtFvZgsBBM",12) == 2760481493) strcat(s, "t");
if (crc32("nMozmyvKHTah",12) == 685234435) strcat(s, "o");
if (crc32("wSwZayNSWbY",11) == 107616326) strcat(s, "o");
if (crc32("DExlzBLWyk",10) == 3344672001) strcat(s, "p");
if (crc32("BScBWqttRfMOWf",14) == 3983005738) strcat(s, "u");
if (crc32("hstuGHWVAwMTK",13) == 4261744474) strcat(s, "e");
if (crc32("YWbNrbwrq",9) == 937985952) strcat(s, "r");
if (crc32("NesbIjk",7) == 2968892207) strcat(s, "V");
if (crc32("noUTjqvbCZ",10) == 1561494439) strcat(s, "i");
if (crc32("XJBwc",5) == 2001346302) strcat(s, "p");
if (crc32("YtssgqO",7) == 3786760371) strcat(s, "o");
if (crc32("uODIlYTVjzNJM",13) == 2746045500) strcat(s, "d");
if (crc32("BZYSASQc",8) == 3880039266) strcat(s, "d");
if (crc32("pmHYKuapGEIbPcC",15) == 2046362372) strcat(s, "i");
if (crc32("OYlgTS",6) == 1779612064) strcat(s, "s");
if (crc32("elrTHJaNeSx",11) == 2121627241) strcat(s, "U");
if (crc32("YDDWoPg",7) == 1856493376) strcat(s, "m");
    return s;
}

char *minstrelsy_nouns() {
    char *s = calloc(11);
    if (crc32("qWurpLXqUhAxFNb",15) == 3307610429) strcat(s, "K");
if (crc32("jcrYfUfmIcsVylO",15) == 2164508875) strcat(s, "m");
if (crc32("TFeyFoJnQePKnzW",15) == 2612364420) strcat(s, "i");
if (crc32("FAskg",5) == 827454770) strcat(s, "n");
if (crc32("YvoFGi",6) == 1893071850) strcat(s, "s");
if (crc32("uZDuoomhuX",10) == 3072164744) strcat(s, "u");
if (crc32("AkGOEsCr",8) == 1584956057) strcat(s, "t");
if (crc32("WpUbyG",6) == 3720754093) strcat(s, "p");
if (crc32("oymQRnb",7) == 3914782915) strcat(s, "r");
if (crc32("HiCFwWtvyUbuumD",15) == 3757736768) strcat(s, "D");
if (crc32("JdtIPILWDvtdH",13) == 2421158613) strcat(s, "e");
if (crc32("kzCrTeSBY",9) == 1238335397) strcat(s, "l");
if (crc32("zebgUIG",7) == 2756834692) strcat(s, "w");
if (crc32("GmEJeHj",7) == 399221741) strcat(s, "s");
if (crc32("rFAhRRwj",8) == 1515512975) strcat(s, "u");
if (crc32("vGUNU",5) == 2852104541) strcat(s, "y");
    return s;
}

char *poundforce_nouns() {
    char *s = calloc(11);
    if (crc32("lTiUCzotASVYXHY",15) == 1009247781) strcat(s, "x");
if (crc32("YEzjACvhSZMacjj",15) == 2921670151) strcat(s, "p");
if (crc32("BWVxbgoJ",8) == 1397141743) strcat(s, "o");
if (crc32("QJqCtJxaGfF",11) == 1056203618) strcat(s, "u");
if (crc32("LLATvXLtAr",10) == 1833718551) strcat(s, "n");
if (crc32("UIFfF",5) == 4004711453) strcat(s, "P");
if (crc32("ytilzgskoodiv",13) == 3484119858) strcat(s, "d");
if (crc32("HdnCJaGQOSl",11) == 333913281) strcat(s, "e");
if (crc32("xUjUdUaaSNSTX",13) == 2245573129) strcat(s, "f");
if (crc32("dOROqMhOlw",10) == 3701601399) strcat(s, "i");
if (crc32("yWgWnR",6) == 2797956879) strcat(s, "o");
if (crc32("hEKFUE",6) == 1007602157) strcat(s, "r");
if (crc32("EVYjol",6) == 304162477) strcat(s, "g");
if (crc32("tmvbYIkakSQwRz",14) == 952822866) strcat(s, "c");
if (crc32("bmOnAswc",8) == 679747761) strcat(s, "U");
if (crc32("vLvNIC",6) == 193216987) strcat(s, "e");
    return s;
}

char *preconcession_nouns() {
    char *s = calloc(14);
    if (crc32("sbeHF",5) == 8157929) strcat(s, "p");
if (crc32("qPExUuKkgTJgI",13) == 437701776) strcat(s, "z");
if (crc32("YqeEgbBzLbwCHg",14) == 3192835584) strcat(s, "r");
if (crc32("OaFBOZlkfafi",12) == 2525317337) strcat(s, "d");
if (crc32("qjoYinizPHpubMc",15) == 687526157) strcat(s, "e");
if (crc32("wSIQwjD",7) == 2817941772) strcat(s, "c");
if (crc32("ZyPWWfPj",8) == 1406528296) strcat(s, "o");
if (crc32("taEydPx",7) == 3855398687) strcat(s, "j");
if (crc32("CgqBzjax",8) == 227938471) strcat(s, "n");
if (crc32("QFaPCcGAVFagKIX",15) == 1057578653) strcat(s, "c");
if (crc32("kxxrIUsBQimGj",13) == 3854197835) strcat(s, "Y");
if (crc32("KyEVNkBBvxOnLIq",15) == 3561916445) strcat(s, "e");
if (crc32("ALCVBvualEbXqO",14) == 3786001470) strcat(s, "s");
if (crc32("TsPBqJIsvc",10) == 3550582626) strcat(s, "s");
if (crc32("nuoCOphSbs",10) == 1552706287) strcat(s, "y");
if (crc32("AkTiLdjygLSOhS",14) == 952884356) strcat(s, "i");
if (crc32("hUmlH",5) == 1660125563) strcat(s, "o");
if (crc32("xVnDQnBfo",9) == 1247603019) strcat(s, "N");
if (crc32("KjUmfBVZhCsMtHY",15) == 1201189416) strcat(s, "n");
    return s;
}

char *inactiveness_nouns() {
    char *s = calloc(13);
    if (crc32("HLURtXHRukuAuU",14) == 2843824988) strcat(s, "i");
if (crc32("KacgomHXQsODdF",14) == 513059577) strcat(s, "n");
if (crc32("bIopQgFrPB",10) == 1144039480) strcat(s, "s");
if (crc32("THRTXfsPBzJDM",13) == 2848056388) strcat(s, "a");
if (crc32("AKOwkcX",7) == 4144836828) strcat(s, "T");
if (crc32("QvYISG",6) == 2967618397) strcat(s, "c");
if (crc32("qYrUgRawUwFoZu",14) == 959667731) strcat(s, "t");
if (crc32("iDGeDdUFdDace",13) == 3207226247) strcat(s, "q");
if (crc32("KHDqFCUmwcwKBW",14) == 3266530611) strcat(s, "i");
if (crc32("OjxFCzE",7) == 1344753095) strcat(s, "v");
if (crc32("WjuaeWdLftooIJ",14) == 204477861) strcat(s, "v");
if (crc32("NpvgdzBspQWuAUz",15) == 1948133029) strcat(s, "e");
if (crc32("TlGKmFcYVgNZS",13) == 2024245378) strcat(s, "n");
if (crc32("keWcp",5) == 1394525981) strcat(s, "e");
if (crc32("CDveVCoPaJiGzp",14) == 1701675848) strcat(s, "s");
if (crc32("HMqBVBX",7) == 1664025176) strcat(s, "s");
    return s;
}

char *deerstalking_nouns() {
    char *s = calloc(13);
    if (crc32("bVTiDMRtOLQ",11) == 2839907294) strcat(s, "d");
if (crc32("crYIzxUAXOCW",12) == 2304343838) strcat(s, "f");
if (crc32("aXvmlSvNZjNx",12) == 573652442) strcat(s, "e");
if (crc32("RzoQEHKtfym",11) == 1832478730) strcat(s, "h");
if (crc32("WJjOf",5) == 784893390) strcat(s, "e");
if (crc32("sVWDKMBPyvXUx",13) == 2262577636) strcat(s, "U");
if (crc32("xwokud",6) == 571603382) strcat(s, "r");
if (crc32("miRWqQOFLvB",11) == 110769573) strcat(s, "k");
if (crc32("GSlZwSP",7) == 3320560364) strcat(s, "s");
if (crc32("gqqNiDV",7) == 4250999663) strcat(s, "t");
if (crc32("CIxtPYCStwJO",12) == 2516513627) strcat(s, "a");
if (crc32("waSCiYRhhJqwsvV",15) == 281663258) strcat(s, "l");
if (crc32("BMANSMRVTJ",10) == 1993152417) strcat(s, "j");
if (crc32("gMKBsDrYgukcSQ",14) == 3295179489) strcat(s, "k");
if (crc32("cjQxR",5) == 3691165847) strcat(s, "P");
if (crc32("TOEyjGzczm",10) == 2712652446) strcat(s, "i");
if (crc32("JDoRdnbqjTUkX",13) == 3281295466) strcat(s, "n");
if (crc32("tnHnJQkX",8) == 701932002) strcat(s, "g");
    return s;
}

char *microampere_nouns() {
    char *s = calloc(12);
    if (crc32("LumcumQYVCMo",12) == 2019433041) strcat(s, "m");
if (crc32("uyNzmELyHbpYZ",13) == 1515513361) strcat(s, "i");
if (crc32("CUnxQDiJxynlKJ",14) == 2335214803) strcat(s, "c");
if (crc32("ZgppQdSBBafES",13) == 2612687315) strcat(s, "r");
if (crc32("OpMMVIFLCkGAK",13) == 558702588) strcat(s, "o");
if (crc32("rmrzVyqrtCLgyj",14) == 4106120969) strcat(s, "a");
if (crc32("nVaMiS",6) == 2313857975) strcat(s, "m");
if (crc32("TYeEjKEmHqe",11) == 2820103599) strcat(s, "B");
if (crc32("wMRPPMUMpUI",11) == 1274800273) strcat(s, "p");
if (crc32("vLIbPjlSdN",10) == 2736087420) strcat(s, "I");
if (crc32("soaGUKUm",8) == 1739261173) strcat(s, "e");
if (crc32("LAddruUhl",9) == 4129078969) strcat(s, "z");
if (crc32("qJunTNBKxXMm",12) == 1711780996) strcat(s, "r");
if (crc32("CxtoZluTBHKB",12) == 3740712212) strcat(s, "e");
    return s;
}

char *Phaeacia_nouns() {
    char *s = calloc(9);
    if (crc32("hWjUtLP",7) == 2142299326) strcat(s, "P");
if (crc32("YYtKbMzZK",9) == 2107203956) strcat(s, "h");
if (crc32("VwnztJSpE",9) == 2406223762) strcat(s, "a");
if (crc32("kHSsfTFPQrcZwtT",15) == 892046061) strcat(s, "H");
if (crc32("nKAiN",5) == 4164336259) strcat(s, "e");
if (crc32("iGmhGGmrQv",10) == 4216130459) strcat(s, "a");
if (crc32("dycBVPEziDJD",12) == 2230624341) strcat(s, "P");
if (crc32("bHUuTk",6) == 908290513) strcat(s, "c");
if (crc32("mhsHaaeZdeKmK",13) == 1372134775) strcat(s, "K");
if (crc32("FBWHPnWZkmUZCE",14) == 654412635) strcat(s, "i");
if (crc32("CJPeE",5) == 1580210575) strcat(s, "F");
if (crc32("cRWUw",5) == 434784274) strcat(s, "a");
    return s;
}

char *superextremity_nouns() {
    char *s = calloc(15);
    if (crc32("RoVEIfoRtZSSn",13) == 1903500858) strcat(s, "s");
if (crc32("LtdNMlHmTHlqi",13) == 3570584088) strcat(s, "u");
if (crc32("ssjYZ",5) == 4097510571) strcat(s, "F");
if (crc32("EwmqkMObRRId",12) == 389300627) strcat(s, "p");
if (crc32("tVCpwIM",7) == 1402533149) strcat(s, "e");
if (crc32("uMpzQWhICsrBGTv",15) == 191722586) strcat(s, "r");
if (crc32("GUSYWzdwf",9) == 2101360212) strcat(s, "e");
if (crc32("bQFMUBrPp",9) == 2323242793) strcat(s, "u");
if (crc32("EqwheURWKGaF",12) == 3885833779) strcat(s, "x");
if (crc32("JtoObZgpKQMx",12) == 228046411) strcat(s, "t");
if (crc32("eNelXaTgjnj",11) == 4033777821) strcat(s, "r");
if (crc32("BVYKnbv",7) == 1105008964) strcat(s, "e");
if (crc32("bBgwiRyLT",9) == 888508364) strcat(s, "X");
if (crc32("ePgiuISrE",9) == 1717193200) strcat(s, "m");
if (crc32("HcfCPthEgfEwR",13) == 1632341605) strcat(s, "i");
if (crc32("tpfWybXM",8) == 3534058909) strcat(s, "t");
if (crc32("OJDpPXti",8) == 3462436878) strcat(s, "y");
    return s;
}

char *Lingayat_nouns() {
    char *s = calloc(9);
    if (crc32("werapbAzbKBGZ",13) == 582898900) strcat(s, "L");
if (crc32("juGgn",5) == 825335265) strcat(s, "C");
if (crc32("SwTunm",6) == 2919403175) strcat(s, "i");
if (crc32("FDSCqyKxzc",10) == 2117782987) strcat(s, "n");
if (crc32("zAwcyAFQIKWC",12) == 2085937244) strcat(s, "P");
if (crc32("TKfFbKE",7) == 3641463270) strcat(s, "g");
if (crc32("MgxgLL",6) == 3919792936) strcat(s, "a");
if (crc32("dMoneIwUa",9) == 540586661) strcat(s, "b");
if (crc32("ffLmxbko",8) == 1009004537) strcat(s, "y");
if (crc32("sezWWBWUGwSmcJ",14) == 976398205) strcat(s, "F");
if (crc32("ohDsqu",6) == 3047748807) strcat(s, "a");
if (crc32("GgSHJTdNOcz",11) == 1365079841) strcat(s, "W");
if (crc32("atGUircb",8) == 2145242556) strcat(s, "t");
    return s;
}

char *thioantimonate_nouns() {
    char *s = calloc(15);
    if (crc32("PFkJXPOPNeyPkp",14) == 1157716650) strcat(s, "t");
if (crc32("yPsaf",5) == 4178437824) strcat(s, "t");
if (crc32("gyxelvb",7) == 2703143267) strcat(s, "h");
if (crc32("AhyOuN",6) == 1918468137) strcat(s, "i");
if (crc32("VMtki",5) == 2721680241) strcat(s, "L");
if (crc32("hrrDgNciBZlChyz",15) == 1215686697) strcat(s, "o");
if (crc32("NUeVQePGxrYFyK",14) == 2012734085) strcat(s, "h");
if (crc32("TEUXBlHHTNbv",12) == 165683528) strcat(s, "a");
if (crc32("qdPqKMKT",8) == 4190184853) strcat(s, "n");
if (crc32("CmJfnSg",7) == 2079245960) strcat(s, "I");
if (crc32("jtXHsheToLAgsFb",15) == 2474712409) strcat(s, "t");
if (crc32("UaCmWwMjldDNE",13) == 148477578) strcat(s, "i");
if (crc32("xWpNrOJg",8) == 2595848524) strcat(s, "K");
if (crc32("sqBMj",5) == 813517403) strcat(s, "m");
if (crc32("muOzo",5) == 2531175729) strcat(s, "w");
if (crc32("lNmvMEGlcKh",11) == 2369140157) strcat(s, "o");
if (crc32("ESCcdHDJVSAMp",13) == 2119721071) strcat(s, "n");
if (crc32("RADesEjPCf",10) == 3118255928) strcat(s, "a");
if (crc32("ZXvzaR",6) == 4195998633) strcat(s, "S");
if (crc32("zrJeHCqMdL",10) == 2483420153) strcat(s, "t");
if (crc32("kHAbFG",6) == 2635223316) strcat(s, "e");
    return s;
}

char *Josephscoat_nouns() {
    char *s = calloc(12);
    if (crc32("vZNyfZ",6) == 741352707) strcat(s, "r");
if (crc32("MpDvQGoHYGPtG",13) == 1749682322) strcat(s, "J");
if (crc32("rflZAfBVDpaX",12) == 2250351827) strcat(s, "o");
if (crc32("LcvqwdHwz",9) == 2911559056) strcat(s, "n");
if (crc32("yuTPTAkgYV",10) == 454676566) strcat(s, "s");
if (crc32("bczjxSqwS",9) == 863973186) strcat(s, "h");
if (crc32("WCocqrVw",8) == 3462701002) strcat(s, "e");
if (crc32("BAQRctj",7) == 3136733222) strcat(s, "k");
if (crc32("PLdAklCXFBaiDz",14) == 3523638281) strcat(s, "p");
if (crc32("VQKiwqTVamdwDN",14) == 1398358957) strcat(s, "N");
if (crc32("rSyMzQuihQkGH",13) == 1157012528) strcat(s, "h");
if (crc32("DGRzNGcrDSdGr",13) == 171368561) strcat(s, "t");
if (crc32("shLqvMrAzoqVk",13) == 3733586758) strcat(s, "s");
if (crc32("UvnkugGrd",9) == 3096036820) strcat(s, "c");
if (crc32("bFjsXcfMnjo",11) == 4194940252) strcat(s, "o");
if (crc32("JJuWKT",6) == 1205576697) strcat(s, "a");
if (crc32("FNHEhZZ",7) == 3330463754) strcat(s, "t");
    return s;
}

char *troubadour_nouns() {
    char *s = calloc(11);
    if (crc32("lloYzAxgvN",10) == 3921172516) strcat(s, "t");
if (crc32("WbbXiMtnvDuQC",13) == 1982223913) strcat(s, "w");
if (crc32("kAFxorLTJHp",11) == 1290223098) strcat(s, "r");
if (crc32("XqXHmg",6) == 2152607460) strcat(s, "z");
if (crc32("VMuSvblUOG",10) == 881327903) strcat(s, "o");
if (crc32("BjQxuzXuzOrBru",14) == 349506847) strcat(s, "u");
if (crc32("fTSvfjJGQMZ",11) == 1869480123) strcat(s, "S");
if (crc32("nIQbviOsbKdg",12) == 943369777) strcat(s, "b");
if (crc32("ZYttivOEqySv",12) == 1561457868) strcat(s, "L");
if (crc32("bpjvXNyzWjC",11) == 4195888408) strcat(s, "a");
if (crc32("JrveFXr",7) == 4192828899) strcat(s, "d");
if (crc32("EMSvKXBjX",9) == 979892294) strcat(s, "I");
if (crc32("oYrgozevelaQO",13) == 2216407673) strcat(s, "o");
if (crc32("BRkGmljUbnLalW",14) == 3610200779) strcat(s, "u");
if (crc32("SBrOCVtxdBadCzJ",15) == 1168062960) strcat(s, "r");
    return s;
}

char *rapine_nouns() {
    char *s = calloc(7);
    if (crc32("DQQcKugXVqCx",12) == 726807837) strcat(s, "r");
if (crc32("rbJrpYdnTFXIb",13) == 3009913130) strcat(s, "a");
if (crc32("gxXfKf",6) == 2553214771) strcat(s, "p");
if (crc32("rifcy",5) == 2821655370) strcat(s, "u");
if (crc32("eCAMMkqTeQYGig",14) == 2499379896) strcat(s, "i");
if (crc32("JyxeRPz",7) == 3040204706) strcat(s, "N");
if (crc32("cZthr",5) == 4241958005) strcat(s, "n");
if (crc32("HIZfAnbuZXimop",14) == 790545026) strcat(s, "e");
    return s;
}

char *directrix_nouns() {
    char *s = calloc(10);
    if (crc32("tdJBSgynxbFw",12) == 1992176300) strcat(s, "q");
if (crc32("bsvFJ",5) == 1007454381) strcat(s, "d");
if (crc32("ZNJhlV",6) == 3438982044) strcat(s, "U");
if (crc32("prWQMmzJghBYY",13) == 656070075) strcat(s, "i");
if (crc32("iWwVsxO",7) == 1617951568) strcat(s, "r");
if (crc32("knHVzgzVP",9) == 1951931273) strcat(s, "o");
if (crc32("reghF",5) == 919313196) strcat(s, "e");
if (crc32("MvffRpciAEPr",12) == 2154698167) strcat(s, "c");
if (crc32("wdROFV",6) == 2309908901) strcat(s, "q");
if (crc32("iNIFaNTGsdcuMHC",15) == 4069903953) strcat(s, "t");
if (crc32("oSrKeutaIAuL",12) == 3337123453) strcat(s, "r");
if (crc32("tTHbMkidP",9) == 3377073414) strcat(s, "i");
if (crc32("SekzvewWnyAL",12) == 3603342074) strcat(s, "x");
if (crc32("ZMLLCsWF",8) == 3570554221) strcat(s, "x");
    return s;
}

char *Cleothera_nouns() {
    char *s = calloc(10);
    if (crc32("TlvumCYQzDAGM",13) == 4149218391) strcat(s, "C");
if (crc32("fJDXsWe",7) == 2327342457) strcat(s, "s");
if (crc32("iIemquxhEjmuCAN",15) == 1177415847) strcat(s, "l");
if (crc32("JPCaBdOOzcqHB",13) == 3984710015) strcat(s, "t");
if (crc32("uaAIy",5) == 229692135) strcat(s, "e");
if (crc32("uhgyal",6) == 1685009176) strcat(s, "g");
if (crc32("fYfVi",5) == 4068516196) strcat(s, "o");
if (crc32("eVhvunZbf",9) == 216219476) strcat(s, "l");
if (crc32("wAMylOEU",8) == 4210441820) strcat(s, "t");
if (crc32("pQgKgthHzX",10) == 1272300464) strcat(s, "L");
if (crc32("hmSEneHmnnOqL",13) == 1960919048) strcat(s, "h");
if (crc32("TPjOwNtkSm",10) == 1081958704) strcat(s, "u");
if (crc32("WnQwJLHBaWKQhld",15) == 450565072) strcat(s, "e");
if (crc32("KmXuePvwzOps",12) == 95619222) strcat(s, "r");
if (crc32("KjZOANRv",8) == 1598653863) strcat(s, "m");
if (crc32("hewWIhIjPwzDwC",14) == 1534216741) strcat(s, "a");
    return s;
}

char *unsolidarity_nouns() {
    char *s = calloc(13);
    if (crc32("DgJEAxGCv",9) == 3695768815) strcat(s, "u");
if (crc32("btgTWqxDFKogzz",14) == 3726193208) strcat(s, "U");
if (crc32("UyUSHcWpaIIKaj",14) == 2363993426) strcat(s, "n");
if (crc32("jmPVy",5) == 1265333176) strcat(s, "A");
if (crc32("vOqJWhuFQXPWL",13) == 2116845538) strcat(s, "s");
if (crc32("IPExXkidsGdB",12) == 123815273) strcat(s, "V");
if (crc32("HFmubpkbS",9) == 3034146455) strcat(s, "o");
if (crc32("ITZQI",5) == 1893272082) strcat(s, "K");
if (crc32("roXvFKoAtCnvxN",14) == 2313876756) strcat(s, "l");
if (crc32("WoNANNY",7) == 1084114857) strcat(s, "i");
if (crc32("UzlXvaMazgso",12) == 29275452) strcat(s, "d");
if (crc32("CKtRmZlXDXXsmGA",15) == 3533187080) strcat(s, "J");
if (crc32("VOmMIISM",8) == 1351430790) strcat(s, "a");
if (crc32("zhhkwCRd",8) == 2898832115) strcat(s, "r");
if (crc32("eWUba",5) == 799361966) strcat(s, "k");
if (crc32("rvACSm",6) == 1918568373) strcat(s, "i");
if (crc32("RNmWmSSp",8) == 1047128629) strcat(s, "t");
if (crc32("HKmmbKiumlSdPK",14) == 167282030) strcat(s, "y");
    return s;
}

char *wornoutness_nouns() {
    char *s = calloc(12);
    if (crc32("sbCKgELk",8) == 2872524036) strcat(s, "w");
if (crc32("uFWARpIQFb",10) == 2028454756) strcat(s, "D");
if (crc32("GOhUhwOuBhtdU",13) == 85786311) strcat(s, "o");
if (crc32("vtgyefdMcNrDel",14) == 2327615347) strcat(s, "r");
if (crc32("qChMAkamlFrVsbR",15) == 3990730052) strcat(s, "n");
if (crc32("QIvsC",5) == 2666932268) strcat(s, "o");
if (crc32("oJWbeiUiVKT",11) == 4074527681) strcat(s, "u");
if (crc32("OYPlPan",7) == 1508463455) strcat(s, "Q");
if (crc32("daOXpbziI",9) == 603844658) strcat(s, "t");
if (crc32("jwNUmhxFtvvcFLp",15) == 2173268141) strcat(s, "n");
if (crc32("GHAam",5) == 1290576738) strcat(s, "e");
if (crc32("qavHW",5) == 484031420) strcat(s, "s");
if (crc32("CxlqVgvnzVfVpk",14) == 3172414020) strcat(s, "s");
    return s;
}

char *Dunseath_nouns() {
    char *s = calloc(9);
    if (crc32("ksaEZQFKivVpe",13) == 241481320) strcat(s, "j");
if (crc32("atrJILElHYrwhG",14) == 852258574) strcat(s, "D");
if (crc32("npyowEMglSR",11) == 4015088864) strcat(s, "u");
if (crc32("qTTibQD",7) == 1385392464) strcat(s, "n");
if (crc32("cyCgfDD",7) == 266311347) strcat(s, "G");
if (crc32("iJEhHjAuXiOW",12) == 2386035263) strcat(s, "s");
if (crc32("wSYRRVeoyQljN",13) == 1195311289) strcat(s, "v");
if (crc32("YCgiChJH",8) == 1720676824) strcat(s, "e");
if (crc32("FRXKIDiO",8) == 850899227) strcat(s, "a");
if (crc32("aLdAp",5) == 1158357729) strcat(s, "t");
if (crc32("VyMxs",5) == 1403685216) strcat(s, "i");
if (crc32("UHyiRQjlNDuz",12) == 3235263807) strcat(s, "h");
    return s;
}

char *Lager_nouns() {
    char *s = calloc(6);
    if (crc32("DUEcu",5) == 2406221048) strcat(s, "L");
if (crc32("MtPTKyVk",8) == 1002636284) strcat(s, "j");
if (crc32("brFrY",5) == 2672801905) strcat(s, "a");
if (crc32("DBRcNBJmPLkY",12) == 1736972130) strcat(s, "G");
if (crc32("KLYvybYYrwAXR",13) == 945457263) strcat(s, "g");
if (crc32("nezHDnklz",9) == 3286338102) strcat(s, "m");
if (crc32("izpXNRSFvCD",11) == 3107110697) strcat(s, "e");
if (crc32("BmFZDm",6) == 3937567323) strcat(s, "r");
    return s;
}

char *Bonney_nouns() {
    char *s = calloc(7);
    if (crc32("ZYuaNmwyyRZRUnM",15) == 1571385932) strcat(s, "k");
if (crc32("scenGEmInQhO",12) == 1803173599) strcat(s, "B");
if (crc32("tLQibXWGCrv",11) == 2357092814) strcat(s, "y");
if (crc32("axkPqQD",7) == 4111578502) strcat(s, "o");
if (crc32("GsmqRjetBi",10) == 1825968284) strcat(s, "n");
if (crc32("IhezuXyMwaY",11) == 3540525466) strcat(s, "n");
if (crc32("hVMeOOFjgNExA",13) == 112186647) strcat(s, "k");
if (crc32("YcoqpGyL",8) == 930669009) strcat(s, "e");
if (crc32("HzcHrBhHmSNSEX",14) == 1641373517) strcat(s, "o");
if (crc32("kqAZmiflx",9) == 3958156999) strcat(s, "y");
    return s;
}

char *fortyone_nouns() {
    char *s = calloc(9);
    if (crc32("kiXqp",5) == 1784696651) strcat(s, "f");
if (crc32("SbjdSfZImLofa",13) == 494598469) strcat(s, "o");
if (crc32("AETFb",5) == 1803675987) strcat(s, "S");
if (crc32("UOdAC",5) == 3167744607) strcat(s, "r");
if (crc32("EhSzNViTVIfNCN",14) == 795982766) strcat(s, "t");
if (crc32("UuhWP",5) == 3815574319) strcat(s, "t");
if (crc32("ZJTBEZ",6) == 1062537259) strcat(s, "y");
if (crc32("oWitDdpqqQL",11) == 2872098415) strcat(s, "o");
if (crc32("yajCXCcgVwcQSdP",15) == 844039698) strcat(s, "n");
if (crc32("oIsRtZGScGi",11) == 3637706261) strcat(s, "A");
if (crc32("iPuBtHjmPppkb",13) == 1101010085) strcat(s, "e");
    return s;
}

char *ergate_nouns() {
    char *s = calloc(7);
    if (crc32("pNwmcF",6) == 984307421) strcat(s, "e");
if (crc32("tLiJscsvsTlDpp",14) == 1759050154) strcat(s, "r");
if (crc32("IbVypLvV",8) == 2283719870) strcat(s, "g");
if (crc32("cxHdGLEVUDUWrY",14) == 428144362) strcat(s, "a");
if (crc32("xaqCdh",6) == 97125402) strcat(s, "P");
if (crc32("QgHwCd",6) == 3281479212) strcat(s, "t");
if (crc32("MhAhOUCXV",9) == 1757911046) strcat(s, "e");
    return s;
}

char *nympholepsy_nouns() {
    char *s = calloc(12);
    if (crc32("XMJVFA",6) == 3390882847) strcat(s, "n");
if (crc32("qfTPVhizr",9) == 2841459475) strcat(s, "y");
if (crc32("FjmNSXDXHSJkyYc",15) == 2179186962) strcat(s, "a");
if (crc32("hmrVQAOpzPU",11) == 3765639460) strcat(s, "m");
if (crc32("GnFLbwWjYK",10) == 4030164888) strcat(s, "p");
if (crc32("PIikqW",6) == 3047835682) strcat(s, "a");
if (crc32("JKcxcUQDvMBKRD",14) == 3782694015) strcat(s, "h");
if (crc32("fRDMbhsPOofRT",13) == 3918645858) strcat(s, "O");
if (crc32("ezmugI",6) == 3830662677) strcat(s, "o");
if (crc32("TTXWsXnOL",9) == 3814941566) strcat(s, "l");
if (crc32("SAYzwmAiESvPPk",14) == 1998625954) strcat(s, "e");
if (crc32("QjFiZcT",7) == 767436977) strcat(s, "n");
if (crc32("FgKOV",5) == 1044795492) strcat(s, "p");
if (crc32("gyaZXafyqCc",11) == 3584843037) strcat(s, "y");
if (crc32("THcJOO",6) == 2336401402) strcat(s, "s");
if (crc32("AMeug",5) == 88962695) strcat(s, "y");
    return s;
}

char *Caughey_nouns() {
    char *s = calloc(8);
    if (crc32("MVXZdQHcfFj",11) == 1897410813) strcat(s, "C");
if (crc32("KaGcvQvz",8) == 440699999) strcat(s, "a");
if (crc32("jkMYqcKvmh",10) == 4181295005) strcat(s, "T");
if (crc32("qHIbKDyEqxnXkM",14) == 2596384896) strcat(s, "u");
if (crc32("nEhgLPpyMOovnT",14) == 2421031974) strcat(s, "a");
if (crc32("hGRVawNGQEReRM",14) == 32454359) strcat(s, "g");
if (crc32("maahdCJnI",9) == 2871839027) strcat(s, "g");
if (crc32("VrCUh",5) == 1178523267) strcat(s, "h");
if (crc32("GggGHHO",7) == 2361022294) strcat(s, "L");
if (crc32("CYBMiOLnddU",11) == 3494147054) strcat(s, "e");
if (crc32("CSePqK",6) == 1193334403) strcat(s, "u");
if (crc32("gYSdtYKHmFpy",12) == 1605826881) strcat(s, "y");
    return s;
}

char *tsk_nouns() {
    char *s = calloc(4);
    if (crc32("ivbZLZWPksWOlI",14) == 2676008849) strcat(s, "t");
if (crc32("dcZjtjs",7) == 1328245078) strcat(s, "s");
if (crc32("ndymJgWRlUpHLOS",15) == 733727559) strcat(s, "k");
    return s;
}

char *friendlessness_nouns() {
    char *s = calloc(15);
    if (crc32("FCOfbTl",7) == 913252174) strcat(s, "S");
if (crc32("ujBMgQY",7) == 1032970215) strcat(s, "f");
if (crc32("AiOMPWsrG",9) == 759803754) strcat(s, "E");
if (crc32("MErAV",5) == 4136957265) strcat(s, "r");
if (crc32("UzvIlmLQq",9) == 740282355) strcat(s, "i");
if (crc32("iWnfIgYdfd",10) == 1990859368) strcat(s, "e");
if (crc32("qdLgfJUtMTy",11) == 770082087) strcat(s, "X");
if (crc32("hCrPzqLbBPGII",13) == 1922284644) strcat(s, "n");
if (crc32("mtNjmPWWsar",11) == 744022790) strcat(s, "N");
if (crc32("brxFaec",7) == 894864512) strcat(s, "d");
if (crc32("aDvheag",7) == 3122021422) strcat(s, "B");
if (crc32("DLDoKZAY",8) == 303974363) strcat(s, "l");
if (crc32("folRaQtEMSvvQm",14) == 3843527504) strcat(s, "y");
if (crc32("KqvClBfoIzgTnc",14) == 368348600) strcat(s, "e");
if (crc32("zrGYWqk",7) == 1962224680) strcat(s, "x");
if (crc32("xlmrIA",6) == 3022562025) strcat(s, "s");
if (crc32("CYRvLrzlKGuGW",13) == 728788953) strcat(s, "o");
if (crc32("zaShAaZ",7) == 301851624) strcat(s, "s");
if (crc32("HvhZRgiTIHIC",12) == 1196487277) strcat(s, "B");
if (crc32("olYiVxcKf",9) == 2671020059) strcat(s, "n");
if (crc32("JKHPWinWj",9) == 2236925973) strcat(s, "N");
if (crc32("wWAfGiM",7) == 393324084) strcat(s, "e");
if (crc32("lPLRFY",6) == 3451009706) strcat(s, "M");
if (crc32("SyJusjmfrYQbo",13) == 1211558146) strcat(s, "s");
if (crc32("yCdkR",5) == 670703895) strcat(s, "Z");
if (crc32("doAnbFuLXb",10) == 3771893592) strcat(s, "s");
    return s;
}

char *Dreyer_nouns() {
    char *s = calloc(7);
    if (crc32("CmEmMcgk",8) == 3310726984) strcat(s, "D");
if (crc32("dVygsYqCXgWGlP",14) == 2984011293) strcat(s, "r");
if (crc32("FsmJAscvDuthM",13) == 3749776984) strcat(s, "t");
if (crc32("ckjXm",5) == 4038463181) strcat(s, "e");
if (crc32("fzsCQN",6) == 1399952644) strcat(s, "d");
if (crc32("ZFpRqBiWsfLhGl",14) == 179314182) strcat(s, "y");
if (crc32("TbERlyjTpzGdav",14) == 119126087) strcat(s, "U");
if (crc32("nkrKsXMqY",9) == 224119806) strcat(s, "e");
if (crc32("sCxJBf",6) == 1621960924) strcat(s, "x");
if (crc32("GtivGZZBp",9) == 179805858) strcat(s, "r");
    return s;
}

char *vehiculum_nouns() {
    char *s = calloc(10);
    if (crc32("VuYWkpQ",7) == 2458794357) strcat(s, "v");
if (crc32("qrXhoKQNqD",10) == 2188334742) strcat(s, "e");
if (crc32("JxUUTtjcDMsnbS",14) == 2741501935) strcat(s, "H");
if (crc32("vZrvldoHjCnp",12) == 3205949647) strcat(s, "h");
if (crc32("gCgyV",5) == 3580885915) strcat(s, "z");
if (crc32("PuaCLB",6) == 3106293153) strcat(s, "i");
if (crc32("fabTHCLLjEKDCMg",15) == 1775193623) strcat(s, "q");
if (crc32("gJHyreBtNCV",11) == 2338170206) strcat(s, "c");
if (crc32("vprMcS",6) == 2427314462) strcat(s, "u");
if (crc32("mYCSIPQ",7) == 1140564936) strcat(s, "l");
if (crc32("iJLJDzhAsfjM",12) == 1001139281) strcat(s, "D");
if (crc32("nvRid",5) == 1068256768) strcat(s, "u");
if (crc32("ozwNlJDbBCbztH",14) == 3370886866) strcat(s, "M");
if (crc32("SkFkEeIXxrY",11) == 3285787040) strcat(s, "m");
    return s;
}

char *Sherrer_nouns() {
    char *s = calloc(8);
    if (crc32("zWVceRnvU",9) == 3781316686) strcat(s, "G");
if (crc32("irVdFJbYKPbZZ",13) == 1083109097) strcat(s, "S");
if (crc32("pbNhmJiGlGePUBJ",15) == 4008454135) strcat(s, "h");
if (crc32("CDmqZeRVLOl",11) == 1648524490) strcat(s, "G");
if (crc32("inDzn",5) == 2175834670) strcat(s, "e");
if (crc32("olPxLwl",7) == 71257912) strcat(s, "R");
if (crc32("sItdI",5) == 3274042798) strcat(s, "r");
if (crc32("zDiFZNpNTHje",12) == 555012380) strcat(s, "J");
if (crc32("cuaejAyGBLK",11) == 3067993558) strcat(s, "r");
if (crc32("IWEPSMSJrUQazr",14) == 999947871) strcat(s, "e");
if (crc32("EYVbK",5) == 1052812083) strcat(s, "r");
    return s;
}

char *Witcher_nouns() {
    char *s = calloc(8);
    if (crc32("LORFJqTcSfi",11) == 3322184946) strcat(s, "W");
if (crc32("XekSLPdDdJiu",12) == 1007804956) strcat(s, "i");
if (crc32("PSOQGvb",7) == 11138307) strcat(s, "G");
if (crc32("DyWTyN",6) == 2201973816) strcat(s, "t");
if (crc32("jyjBDXZiydtltv",14) == 2122899358) strcat(s, "R");
if (crc32("LSdES",5) == 2989177579) strcat(s, "c");
if (crc32("GaCEXqgFtxJm",12) == 3326623405) strcat(s, "h");
if (crc32("hfZxwOAkbQTLw",13) == 1846482828) strcat(s, "e");
if (crc32("nkdTWYAyDLFk",12) == 4130093604) strcat(s, "r");
    return s;
}

char *chile_nouns() {
    char *s = calloc(6);
    if (crc32("fllcoq",6) == 3450592424) strcat(s, "c");
if (crc32("KtUiYKBh",8) == 1161445368) strcat(s, "T");
if (crc32("nQjaKZO",7) == 198658016) strcat(s, "h");
if (crc32("DirpniE",7) == 440287342) strcat(s, "i");
if (crc32("fADNlSpCq",9) == 2736699884) strcat(s, "p");
if (crc32("PkGEsgrxgP",10) == 3445901620) strcat(s, "l");
if (crc32("eMxegACGOMv",11) == 3871477399) strcat(s, "e");
    return s;
}

char *theology_nouns() {
    char *s = calloc(9);
    if (crc32("ntzUGmQdKpk",11) == 3819827074) strcat(s, "t");
if (crc32("QaPHVywoTJYPL",13) == 3932494659) strcat(s, "N");
if (crc32("vFlpiIAzFl",10) == 1015607679) strcat(s, "h");
if (crc32("GrRJHrTnHTZj",12) == 680483031) strcat(s, "E");
if (crc32("XWhEcFJI",8) == 691358985) strcat(s, "e");
if (crc32("RXYyp",5) == 151176759) strcat(s, "b");
if (crc32("hTmtbPKvqOYkCvj",15) == 1190115811) strcat(s, "o");
if (crc32("lLbyPczMF",9) == 2284015675) strcat(s, "x");
if (crc32("EHhPmuvGAhoxLv",14) == 1631211533) strcat(s, "l");
if (crc32("cMwYrp",6) == 2393054984) strcat(s, "K");
if (crc32("KXUxlTjgMXqgckO",15) == 2508651264) strcat(s, "o");
if (crc32("ErGPkRBvFWtXOcf",15) == 628420926) strcat(s, "E");
if (crc32("njRHwEuC",8) == 2607058600) strcat(s, "g");
if (crc32("cjrSZuhRvvmYk",13) == 3108418033) strcat(s, "y");
    return s;
}

char *winglet_nouns() {
    char *s = calloc(8);
    if (crc32("cpvlMdfmxwaKfu",14) == 3699007325) strcat(s, "w");
if (crc32("XDipfrIgWX",10) == 2408190165) strcat(s, "i");
if (crc32("GhgQiJOPONBq",12) == 3544546642) strcat(s, "E");
if (crc32("uExUXWkNMXxcj",13) == 649523074) strcat(s, "n");
if (crc32("LCSqUUmRr",9) == 2685516480) strcat(s, "f");
if (crc32("vWeGsdv",7) == 3121493562) strcat(s, "g");
if (crc32("DsqwnQqeLa",10) == 1328097865) strcat(s, "v");
if (crc32("JhnHAyFllIwEAk",14) == 2900298314) strcat(s, "l");
if (crc32("YQnHjIeTagBD",12) == 2981998396) strcat(s, "e");
if (crc32("bMYgjWY",7) == 3187513392) strcat(s, "u");
if (crc32("wgFmBZGStA",10) == 3624713505) strcat(s, "t");
    return s;
}

char *stitchwort_nouns() {
    char *s = calloc(11);
    if (crc32("tTIvhduahz",10) == 4294763433) strcat(s, "S");
if (crc32("TJiDlfQkBFpyrw",14) == 963578761) strcat(s, "s");
if (crc32("qJkbYzlCD",9) == 2947083546) strcat(s, "t");
if (crc32("vmtIYepv",8) == 979158869) strcat(s, "G");
if (crc32("YfYsals",7) == 4032075951) strcat(s, "i");
if (crc32("iROCu",5) == 3019470464) strcat(s, "t");
if (crc32("LCCrR",5) == 1179957137) strcat(s, "B");
if (crc32("QJsDmKgoxHHr",12) == 590624630) strcat(s, "c");
if (crc32("CHcTIOWR",8) == 3052079666) strcat(s, "o");
if (crc32("giJmMUmXQPo",11) == 595877192) strcat(s, "h");
if (crc32("WoEzMd",6) == 1939679770) strcat(s, "Y");
if (crc32("adBoqUcMurdE",12) == 35511140) strcat(s, "w");
if (crc32("kEpZJl",6) == 2750465459) strcat(s, "E");
if (crc32("juybuByNTpbyduX",15) == 1095815787) strcat(s, "o");
if (crc32("lDWrsQANM",9) == 3948254589) strcat(s, "l");
if (crc32("lLxfpIpJaXMAtNC",15) == 3569307666) strcat(s, "r");
if (crc32("HhxMYOYHAwG",11) == 3869355635) strcat(s, "t");
    return s;
}

char *Perris_nouns() {
    char *s = calloc(7);
    if (crc32("XKiGxiepNzwHe",13) == 2869377285) strcat(s, "P");
if (crc32("yxXyp",5) == 2401203121) strcat(s, "s");
if (crc32("QJAEhp",6) == 3431717625) strcat(s, "e");
if (crc32("MkbjJbhUssYBOp",14) == 2393069374) strcat(s, "V");
if (crc32("BOItG",5) == 4224084689) strcat(s, "r");
if (crc32("nlxkqNzegPQIoxp",15) == 1883307937) strcat(s, "r");
if (crc32("jnxqGcH",7) == 86562865) strcat(s, "F");
if (crc32("zmoEBF",6) == 842882468) strcat(s, "i");
if (crc32("GFYNxdJ",7) == 971676003) strcat(s, "F");
if (crc32("vvZOLtp",7) == 481161944) strcat(s, "s");
    return s;
}

char *unremittence_nouns() {
    char *s = calloc(13);
    if (crc32("mkkFmaxSv",9) == 104791858) strcat(s, "u");
if (crc32("xBDNywQH",8) == 2667004868) strcat(s, "L");
if (crc32("GsCIRlm",7) == 4249492824) strcat(s, "n");
if (crc32("vEEmZMxOev",10) == 2115208257) strcat(s, "r");
if (crc32("tpCMbbht",8) == 2832138334) strcat(s, "e");
if (crc32("ETkqZ",5) == 385496898) strcat(s, "u");
if (crc32("qYEGtBxixZbhlNY",15) == 124359051) strcat(s, "m");
if (crc32("sCvLRSwhmhWkN",13) == 386859813) strcat(s, "a");
if (crc32("OyHfOYdhQdm",11) == 61562811) strcat(s, "i");
if (crc32("PVbvwvwxfQv",11) == 4173861033) strcat(s, "t");
if (crc32("cyNbtqObgK",10) == 1614170898) strcat(s, "x");
if (crc32("GtukIyLH",8) == 1923594056) strcat(s, "t");
if (crc32("VlNqmuAS",8) == 1084266118) strcat(s, "G");
if (crc32("smXoYUxShRzIVrv",15) == 1589230008) strcat(s, "e");
if (crc32("LkrPMeYZuxvlfd",14) == 3084008798) strcat(s, "n");
if (crc32("PzxnIthKrepjC",13) == 618534693) strcat(s, "v");
if (crc32("sZCpMp",6) == 2253772369) strcat(s, "c");
if (crc32("ulVrczpPKTEABs",14) == 4029910230) strcat(s, "e");
    return s;
}

char *Car_nouns() {
    char *s = calloc(4);
    if (crc32("WUExRWarhGHV",12) == 2299760660) strcat(s, "C");
if (crc32("IsMpN",5) == 743623077) strcat(s, "a");
if (crc32("zUxmiKiLD",9) == 2066308241) strcat(s, "o");
if (crc32("hnfqBIXguFio",12) == 1546132224) strcat(s, "r");
    return s;
}

char *ganglion_nouns() {
    char *s = calloc(9);
    if (crc32("uWVpTlQRdYseIhZ",15) == 386369697) strcat(s, "i");
if (crc32("WsNwxFjeGpmbGO",14) == 2054169814) strcat(s, "g");
if (crc32("PalSfQGKM",9) == 221880274) strcat(s, "y");
if (crc32("PZDkBduAt",9) == 4169997954) strcat(s, "a");
if (crc32("OKjBkKpW",8) == 303539772) strcat(s, "n");
if (crc32("BiPRsA",6) == 3331109303) strcat(s, "g");
if (crc32("lSjXTLAMZwL",11) == 4046902359) strcat(s, "l");
if (crc32("iputIvxlUdSZuF",14) == 754365131) strcat(s, "i");
if (crc32("KyhhbE",6) == 823739088) strcat(s, "C");
if (crc32("GyYJewTloYe",11) == 2665790086) strcat(s, "o");
if (crc32("fltgrxfc",8) == 4174977394) strcat(s, "n");
    return s;
}

char *instrumentalism_nouns() {
    char *s = calloc(16);
    if (crc32("qRQnIa",6) == 2292269422) strcat(s, "c");
if (crc32("TewXoWbUWdh",11) == 3731895827) strcat(s, "i");
if (crc32("uwXfEiCIRT",10) == 3495656542) strcat(s, "n");
if (crc32("ZMsMkHZyTVc",11) == 2166058672) strcat(s, "F");
if (crc32("LcewyosyIe",10) == 3131110368) strcat(s, "s");
if (crc32("LmxUgxCIuZHgN",13) == 3484574320) strcat(s, "t");
if (crc32("qSNSyM",6) == 3955149502) strcat(s, "C");
if (crc32("IuMWAXDOFeYFrva",15) == 2569614627) strcat(s, "r");
if (crc32("pNETuvgQWWnkj",13) == 1883841602) strcat(s, "y");
if (crc32("RmnbXWyVqYbci",13) == 1912328207) strcat(s, "u");
if (crc32("TbAEWqPy",8) == 1828442329) strcat(s, "m");
if (crc32("NHhRh",5) == 4066454979) strcat(s, "e");
if (crc32("WfKTg",5) == 596787859) strcat(s, "n");
if (crc32("YzIRbQLesReNA",13) == 2436038527) strcat(s, "t");
if (crc32("RveFjufrjDi",11) == 3661383860) strcat(s, "A");
if (crc32("vMRfUmLR",8) == 411103204) strcat(s, "a");
if (crc32("ZIapJcG",7) == 647374851) strcat(s, "l");
if (crc32("eAGgm",5) == 1349288301) strcat(s, "q");
if (crc32("CpMltWxmNSN",11) == 155816019) strcat(s, "i");
if (crc32("AylMrZp",7) == 564502474) strcat(s, "s");
if (crc32("TlbZfxheHEy",11) == 2889844648) strcat(s, "l");
if (crc32("KjRiL",5) == 435662505) strcat(s, "m");
    return s;
}

char *mowing_nouns() {
    char *s = calloc(7);
    if (crc32("OluMk",5) == 3568767999) strcat(s, "c");
if (crc32("nTlVbBAczWB",11) == 3593698055) strcat(s, "m");
if (crc32("ZWWaxA",6) == 3064960572) strcat(s, "C");
if (crc32("dljrtsMbzsnA",12) == 534848400) strcat(s, "o");
if (crc32("eRZssDyqfhYSCSl",15) == 1165904181) strcat(s, "d");
if (crc32("mHnydYqFc",9) == 3152382743) strcat(s, "w");
if (crc32("ipkznUZUT",9) == 3472440028) strcat(s, "Z");
if (crc32("hnoabuYfWqiVt",13) == 1008001176) strcat(s, "i");
if (crc32("SqyLkabVJyVhu",13) == 1045840187) strcat(s, "N");
if (crc32("JmvQsYxvPLXgKP",14) == 3764776594) strcat(s, "n");
if (crc32("UwRHcYfNPkNxGr",14) == 767091723) strcat(s, "g");
    return s;
}

char *Semitics_nouns() {
    char *s = calloc(9);
    if (crc32("zswghK",6) == 890419400) strcat(s, "v");
if (crc32("YIVqSvbbhjk",11) == 3578032355) strcat(s, "S");
if (crc32("pAjRrWzBED",10) == 1857103561) strcat(s, "e");
if (crc32("YFQYXhlIAxfRc",13) == 3619004948) strcat(s, "m");
if (crc32("eluJeZxUEjex",12) == 636349667) strcat(s, "U");
if (crc32("CsugTCo",7) == 2669054355) strcat(s, "i");
if (crc32("PKZvMJp",7) == 2851541803) strcat(s, "J");
if (crc32("kUGrWhTC",8) == 689768726) strcat(s, "t");
if (crc32("zmMJLFqpLdALZHB",15) == 1114472151) strcat(s, "A");
if (crc32("yPBigtfpgjshVYw",15) == 2265969411) strcat(s, "i");
if (crc32("PvgyiXDE",8) == 3241517627) strcat(s, "X");
if (crc32("wwgoFikBSSKEuo",14) == 2074200941) strcat(s, "c");
if (crc32("aqpxkQwb",8) == 3009927644) strcat(s, "s");
    return s;
}

char *Rodd_nouns() {
    char *s = calloc(5);
    if (crc32("uEHyEUwlpqlb",12) == 3217267828) strcat(s, "R");
if (crc32("eKxbQeszIqmid",13) == 2118030380) strcat(s, "o");
if (crc32("kLASuhX",7) == 1254247953) strcat(s, "d");
if (crc32("QGeCoGkqGwL",11) == 657739910) strcat(s, "d");
    return s;
}

char *rapparee_nouns() {
    char *s = calloc(9);
    if (crc32("pTdrYMhNV",9) == 144625651) strcat(s, "r");
if (crc32("mzGLbKvEEcLty",13) == 2280061240) strcat(s, "a");
if (crc32("ncyID",5) == 3264824518) strcat(s, "p");
if (crc32("OFQvXWkIiQTG",12) == 2565742829) strcat(s, "p");
if (crc32("IRKWIpfflsdKYwQ",15) == 3093975701) strcat(s, "M");
if (crc32("JmOBrhDwRYk",11) == 184613003) strcat(s, "a");
if (crc32("eQxLgS",6) == 2109886472) strcat(s, "i");
if (crc32("QMuRBlnHGFrDcUV",15) == 2329117127) strcat(s, "r");
if (crc32("dmwKGVOIwhfZX",13) == 2184662999) strcat(s, "h");
if (crc32("wDkkEXDjsCAj",12) == 3287851681) strcat(s, "e");
if (crc32("DrTncqv",7) == 3095077410) strcat(s, "e");
    return s;
}

char *Ahmadiya_nouns() {
    char *s = calloc(9);
    if (crc32("trsYUEfikaklEjl",15) == 536178265) strcat(s, "A");
if (crc32("fgnZNYFLIzgef",13) == 4075170815) strcat(s, "h");
if (crc32("eEjokjWKuOTWc",13) == 2043042406) strcat(s, "q");
if (crc32("KDtgSJwEZ",9) == 3336306308) strcat(s, "m");
if (crc32("YnEYBnunwcJLHK",14) == 1364007529) strcat(s, "w");
if (crc32("zLKuV",5) == 135132069) strcat(s, "a");
if (crc32("dsmCVmTcXAsTtG",14) == 3454129419) strcat(s, "r");
if (crc32("AAzgXcoJBU",10) == 3520269351) strcat(s, "d");
if (crc32("nBesnqTGFSJqsju",15) == 172339950) strcat(s, "i");
if (crc32("NiQxgIimSPd",11) == 2974815883) strcat(s, "G");
if (crc32("izBIUrLZKsVQ",12) == 3170519832) strcat(s, "y");
if (crc32("ZrYZYauajsIJHhA",15) == 670591739) strcat(s, "a");
    return s;
}

char *utility_nouns() {
    char *s = calloc(8);
    if (crc32("XtDtlzcUb",9) == 1372549311) strcat(s, "u");
if (crc32("ffVEDcM",7) == 2165373143) strcat(s, "t");
if (crc32("HxCzHHCnTxGjpD",14) == 279541678) strcat(s, "i");
if (crc32("VxhXrT",6) == 1334169402) strcat(s, "i");
if (crc32("ZQVpcgcySNp",11) == 1029142553) strcat(s, "l");
if (crc32("FfxiwkdjwvXybC",14) == 4093634125) strcat(s, "i");
if (crc32("OAYIBUtXs",9) == 1867920417) strcat(s, "Y");
if (crc32("ehMxymlhKc",10) == 3815593588) strcat(s, "t");
if (crc32("owLGFDgVcSqs",12) == 2368390202) strcat(s, "y");
    return s;
}

char *Kittanning_nouns() {
    char *s = calloc(11);
    if (crc32("TKVrMBrtB",9) == 2921694742) strcat(s, "K");
if (crc32("gLdzpS",6) == 156229475) strcat(s, "i");
if (crc32("Wqlwcv",6) == 3003353744) strcat(s, "t");
if (crc32("dwmiXkVRlVVttC",14) == 3147311547) strcat(s, "Q");
if (crc32("acGuFaBNB",9) == 4163491714) strcat(s, "t");
if (crc32("vehzPYWf",8) == 1143921465) strcat(s, "a");
if (crc32("YEgfp",5) == 1909559824) strcat(s, "a");
if (crc32("Styxca",6) == 2559068087) strcat(s, "F");
if (crc32("BzNePjVlNtrj",12) == 1227881460) strcat(s, "n");
if (crc32("hjLFk",5) == 1043920897) strcat(s, "n");
if (crc32("dgoVVeqcrVPFyq",14) == 310468379) strcat(s, "i");
if (crc32("jeJawZX",7) == 252743807) strcat(s, "n");
if (crc32("GSgaXzge",8) == 2774475988) strcat(s, "g");
    return s;
}

char *Stodder_nouns() {
    char *s = calloc(8);
    if (crc32("BtcYQAfl",8) == 3490449698) strcat(s, "P");
if (crc32("ZwOUj",5) == 1392792568) strcat(s, "S");
if (crc32("jIkvfPvaUpX",11) == 1044540446) strcat(s, "t");
if (crc32("fRcwgWLVfgQF",12) == 2881232964) strcat(s, "U");
if (crc32("WENnjzOC",8) == 2859164761) strcat(s, "o");
if (crc32("ZGbnzmQlXHQ",11) == 2893774686) strcat(s, "a");
if (crc32("LgaoaKzCLgTc",12) == 4080894356) strcat(s, "d");
if (crc32("vedOyqjwdDqNtG",14) == 3380721785) strcat(s, "b");
if (crc32("rGsWWFLvqASBlw",14) == 398278971) strcat(s, "d");
if (crc32("tzZUI",5) == 3071928182) strcat(s, "Z");
if (crc32("fzseJBNXwY",10) == 1190319231) strcat(s, "e");
if (crc32("HgfkyeXNFZhXVW",14) == 3295655942) strcat(s, "r");
    return s;
}

char *Elbart_nouns() {
    char *s = calloc(7);
    if (crc32("PiRyRQHlbqFEozF",15) == 3668695626) strcat(s, "b");
if (crc32("tAPyEWmIkHX",11) == 215861534) strcat(s, "E");
if (crc32("ADViZlfuxZSPs",13) == 1109231804) strcat(s, "l");
if (crc32("XwHcn",5) == 889431750) strcat(s, "q");
if (crc32("bGmaubvg",8) == 3682145354) strcat(s, "b");
if (crc32("kJQOkG",6) == 2440265086) strcat(s, "h");
if (crc32("CIzkDpRvLPFLbx",14) == 450476880) strcat(s, "a");
if (crc32("pLtSeyREor",10) == 4107582757) strcat(s, "u");
if (crc32("ADKsg",5) == 483194209) strcat(s, "r");
if (crc32("KcPITzIYmpnEA",13) == 125911894) strcat(s, "c");
if (crc32("yCYpUNWb",8) == 2702972795) strcat(s, "t");
    return s;
}

char *dogie_nouns() {
    char *s = calloc(6);
    if (crc32("lMXaacFHeZB",11) == 2041059940) strcat(s, "M");
if (crc32("veGAMMfDZG",10) == 496665887) strcat(s, "d");
if (crc32("Miviwi",6) == 3412366351) strcat(s, "o");
if (crc32("nEQfoN",6) == 1606802458) strcat(s, "g");
if (crc32("anJWksSRjKZ",11) == 3866085889) strcat(s, "i");
if (crc32("jSaoBco",7) == 1342531187) strcat(s, "w");
if (crc32("YxNnPxLjSZZS",12) == 2703756970) strcat(s, "e");
    return s;
}

char *overruler_nouns() {
    char *s = calloc(10);
    if (crc32("cqOhXuMgxL",10) == 467899509) strcat(s, "o");
if (crc32("LFOzqC",6) == 1561017133) strcat(s, "v");
if (crc32("bKXNpAmjA",9) == 2148234847) strcat(s, "A");
if (crc32("LzkTJh",6) == 3025611601) strcat(s, "e");
if (crc32("WAFVPdQq",8) == 1806139204) strcat(s, "E");
if (crc32("haiwh",5) == 2297146627) strcat(s, "r");
if (crc32("fXcYhkJlvBx",11) == 597052292) strcat(s, "r");
if (crc32("WYGiIFsq",8) == 2541327152) strcat(s, "M");
if (crc32("DMatfydKd",9) == 2085921943) strcat(s, "u");
if (crc32("BHfMHWQY",8) == 2180291834) strcat(s, "l");
if (crc32("FvndtH",6) == 2887956346) strcat(s, "t");
if (crc32("pGpzqdrCw",9) == 1100287823) strcat(s, "e");
if (crc32("RgIUegNqkC",10) == 2562639609) strcat(s, "Q");
if (crc32("ZGCPosIobJX",11) == 3713145752) strcat(s, "r");
    return s;
}

char *farcy_nouns() {
    char *s = calloc(6);
    if (crc32("eZosjSaGhPHrW",13) == 3325543295) strcat(s, "q");
if (crc32("jYhhGyEGdD",10) == 256447076) strcat(s, "f");
if (crc32("voRPN",5) == 2534592058) strcat(s, "a");
if (crc32("sngelWXEKEHnEB",14) == 2135481396) strcat(s, "r");
if (crc32("jJYTNKLoJ",9) == 275887458) strcat(s, "c");
if (crc32("trnadOwZacpIX",13) == 1763449756) strcat(s, "y");
    return s;
}

char *Nerites_nouns() {
    char *s = calloc(8);
    if (crc32("kkGIFIiIhFTpqgK",15) == 654121512) strcat(s, "N");
if (crc32("xdcpKh",6) == 394768539) strcat(s, "e");
if (crc32("CExhcUQgMemQTLP",15) == 173353795) strcat(s, "I");
if (crc32("XwLTT",5) == 4093153835) strcat(s, "r");
if (crc32("lxciIKxxNHFbG",13) == 3587808128) strcat(s, "H");
if (crc32("jZQrpXS",7) == 252434026) strcat(s, "i");
if (crc32("PoYteQwlr",9) == 4121538647) strcat(s, "g");
if (crc32("lZCfUEWyzTLlxk",14) == 2622665423) strcat(s, "t");
if (crc32("xDClCai",7) == 3228134128) strcat(s, "j");
if (crc32("qONlL",5) == 230817747) strcat(s, "e");
if (crc32("bZTDGCVHhdW",11) == 480894233) strcat(s, "s");
    return s;
}

char *LV_nouns() {
    char *s = calloc(3);
    if (crc32("NwbyF",5) == 4246253636) strcat(s, "L");
if (crc32("OOmeOhPPEXUW",12) == 693394148) strcat(s, "e");
if (crc32("bDGaw",5) == 4143200614) strcat(s, "V");
    return s;
}

char *Valenta_nouns() {
    char *s = calloc(8);
    if (crc32("cQQwnGTTmVwaL",13) == 2629609209) strcat(s, "V");
if (crc32("bakfRFbEH",9) == 2637635351) strcat(s, "a");
if (crc32("MVOOEAaNjaUikr",14) == 2518747860) strcat(s, "b");
if (crc32("fPZLbFAVCYrjq",13) == 1618055396) strcat(s, "l");
if (crc32("kkyFnkuYaVQ",11) == 93469922) strcat(s, "e");
if (crc32("WRpJpyVIMRwuNA",14) == 947111112) strcat(s, "n");
if (crc32("YbtyCy",6) == 876703227) strcat(s, "t");
if (crc32("MHAtRMs",7) == 3759711423) strcat(s, "x");
if (crc32("bRRArtxKSIaEWY",14) == 3110953968) strcat(s, "a");
    return s;
}

char *Sergeant_nouns() {
    char *s = calloc(9);
    if (crc32("OpiNMhU",7) == 92518234) strcat(s, "S");
if (crc32("NmAClvZNy",9) == 3835238951) strcat(s, "e");
if (crc32("mLnMujKvrYjeXhE",15) == 1628407481) strcat(s, "r");
if (crc32("KEZGW",5) == 2403454366) strcat(s, "E");
if (crc32("pWPIwyNhy",9) == 3791111299) strcat(s, "g");
if (crc32("CEwwkGZH",8) == 678942244) strcat(s, "e");
if (crc32("dIZthWgohSyJ",12) == 3985548375) strcat(s, "a");
if (crc32("ZnpMqLMi",8) == 179752207) strcat(s, "n");
if (crc32("BGEFK",5) == 116550460) strcat(s, "y");
if (crc32("nzoYDgCdW",9) == 2491928237) strcat(s, "t");
    return s;
}

char *lice_nouns() {
    char *s = calloc(5);
    if (crc32("olWdyNsnYwYz",12) == 1245125826) strcat(s, "k");
if (crc32("kHwJjHKzhsKP",12) == 558279368) strcat(s, "l");
if (crc32("kUAQP",5) == 1837143239) strcat(s, "i");
if (crc32("OoDldPPgqS",10) == 126191825) strcat(s, "c");
if (crc32("qYqXkPODvn",10) == 1771800617) strcat(s, "e");
    return s;
}

char *refl_nouns() {
    char *s = calloc(5);
    if (crc32("YCjSFnTAewWMNww",15) == 2920039702) strcat(s, "r");
if (crc32("rNpQrQdKShV",11) == 1671108676) strcat(s, "V");
if (crc32("SOTbZNtsQFLk",12) == 3371383076) strcat(s, "e");
if (crc32("tufWBiMofEVRW",13) == 1724702072) strcat(s, "f");
if (crc32("HeoypbipPt",10) == 536141154) strcat(s, "l");
    return s;
}

char *Reggi_nouns() {
    char *s = calloc(6);
    if (crc32("ITMvvyOEHSi",11) == 682409368) strcat(s, "H");
if (crc32("qeyFoocyu",9) == 3574539474) strcat(s, "R");
if (crc32("IljgDdfuEi",10) == 958661019) strcat(s, "e");
if (crc32("zZsBoVMToe",10) == 4020937232) strcat(s, "D");
if (crc32("RuYobBFxysOTt",13) == 1608664857) strcat(s, "g");
if (crc32("JduKuMZtryeLcLI",15) == 61101075) strcat(s, "B");
if (crc32("DKoYesQm",8) == 2293531136) strcat(s, "g");
if (crc32("fkOGqPJVfNqYhCw",15) == 147569957) strcat(s, "i");
    return s;
}

char *aliyah_nouns() {
    char *s = calloc(7);
    if (crc32("iENlSEjQAodzJ",13) == 2840606114) strcat(s, "a");
if (crc32("VRstPKCMkClNJq",14) == 1184239826) strcat(s, "l");
if (crc32("UzxTUSGBmx",10) == 2241552208) strcat(s, "F");
if (crc32("MDjrURbB",8) == 292678267) strcat(s, "i");
if (crc32("MSesY",5) == 450043881) strcat(s, "l");
if (crc32("dVglXPwwhaogZjk",15) == 897954751) strcat(s, "y");
if (crc32("NhtxTLSJkWuz",12) == 2717376569) strcat(s, "S");
if (crc32("dWSWrlKsommwy",13) == 2053427726) strcat(s, "a");
if (crc32("KfcZnRCvxSEbJ",13) == 2379554006) strcat(s, "R");
if (crc32("zugsCVJ",7) == 3560376707) strcat(s, "h");
    return s;
}

char *dolefulness_nouns() {
    char *s = calloc(12);
    if (crc32("Wubynrzy",8) == 2584298405) strcat(s, "s");
if (crc32("cqHsduVS",8) == 3571286467) strcat(s, "d");
if (crc32("oikIWbF",7) == 1712339390) strcat(s, "o");
if (crc32("lKPrwJhnFWBQQuy",15) == 150821752) strcat(s, "X");
if (crc32("dbWXwJXwdmbFSbC",15) == 1304952990) strcat(s, "l");
if (crc32("AzcGqjYFTK",10) == 3330318742) strcat(s, "e");
if (crc32("MvuGc",5) == 296539966) strcat(s, "f");
if (crc32("GrRfokZhoRAXGf",14) == 2837448031) strcat(s, "G");
if (crc32("qZFaioow",8) == 3599755377) strcat(s, "u");
if (crc32("oDZXcqsmqrPx",12) == 2629025156) strcat(s, "J");
if (crc32("ZjeWkglmIgoMPxP",15) == 3702013854) strcat(s, "l");
if (crc32("OsivIATXDkophdm",15) == 1053011435) strcat(s, "n");
if (crc32("hHEYiBJdfFzb",12) == 1561718808) strcat(s, "e");
if (crc32("AGIlex",6) == 424941256) strcat(s, "t");
if (crc32("XBlYUjWeunH",11) == 1283529659) strcat(s, "s");
if (crc32("zVOmAsdVIn",10) == 885485868) strcat(s, "s");
    return s;
}

char *Arlynne_nouns() {
    char *s = calloc(8);
    if (crc32("NxcUJMdeaFERr",13) == 1482118482) strcat(s, "X");
if (crc32("KcLFGBXwviEdd",13) == 2684351077) strcat(s, "A");
if (crc32("VNsQID",6) == 3358103121) strcat(s, "r");
if (crc32("ZmNGfS",6) == 1787807797) strcat(s, "X");
if (crc32("DzvFeucbnSDEkGU",15) == 470935664) strcat(s, "l");
if (crc32("oVkiIMOKiutp",12) == 2780703083) strcat(s, "y");
if (crc32("tiLIeJmb",8) == 2088084387) strcat(s, "n");
if (crc32("rUkjLqMYbqmcOV",14) == 3046464917) strcat(s, "n");
if (crc32("dqCMWa",6) == 3636024973) strcat(s, "e");
    return s;
}

char *nonferventness_nouns() {
    char *s = calloc(15);
    if (crc32("awMbXQH",7) == 2344007271) strcat(s, "k");
if (crc32("tIknvBvjliCjVZX",15) == 3086963860) strcat(s, "n");
if (crc32("AXBcOWuVJxNH",12) == 3086557691) strcat(s, "Y");
if (crc32("VXLBorJGEeIznIH",15) == 3379034038) strcat(s, "o");
if (crc32("oaBCSgplkd",10) == 3507051753) strcat(s, "n");
if (crc32("JwfftJxKLGqJ",12) == 2165415367) strcat(s, "f");
if (crc32("ImTScKkryMiA",12) == 2493993264) strcat(s, "e");
if (crc32("fEKYv",5) == 711340073) strcat(s, "n");
if (crc32("TFvNhNBrdHsO",12) == 1767259648) strcat(s, "r");
if (crc32("SZPLiGmnwqk",11) == 593429504) strcat(s, "v");
if (crc32("xKLmyONUmnLTcI",14) == 2535049562) strcat(s, "H");
if (crc32("XTFeJ",5) == 1891249660) strcat(s, "e");
if (crc32("hpRvzZVsRyYJ",12) == 2352345713) strcat(s, "n");
if (crc32("BmIAeg",6) == 3879947840) strcat(s, "K");
if (crc32("rQMYWykYVsyntCX",15) == 1483532024) strcat(s, "t");
if (crc32("pvJulrpNCCZGCg",14) == 2524356103) strcat(s, "n");
if (crc32("tOBvcaJJtMwZaH",14) == 4166393206) strcat(s, "e");
if (crc32("UwrJmneD",8) == 1909634198) strcat(s, "e");
if (crc32("eJcSJIwSq",9) == 1804682486) strcat(s, "s");
if (crc32("qRnFW",5) == 1928410037) strcat(s, "s");
    return s;
}

char *nonincrease_nouns() {
    char *s = calloc(12);
    if (crc32("lPVOkaDEqa",10) == 3554544243) strcat(s, "n");
if (crc32("IjiVWbuyUydhblr",15) == 1116785067) strcat(s, "J");
if (crc32("lRacqgHab",9) == 728508463) strcat(s, "o");
if (crc32("sYuXr",5) == 1342587101) strcat(s, "n");
if (crc32("rXktajsF",8) == 535687055) strcat(s, "y");
if (crc32("bacPMDMjDRg",11) == 83330705) strcat(s, "i");
if (crc32("bvWbvdmQiOuxhLG",15) == 3896802600) strcat(s, "n");
if (crc32("zFYTfTnZ",8) == 1569079613) strcat(s, "e");
if (crc32("yaMxNcp",7) == 1292725088) strcat(s, "c");
if (crc32("STJgPycKECkhiK",14) == 4172041270) strcat(s, "O");
if (crc32("yXjuATiDlhgfT",13) == 2289235585) strcat(s, "r");
if (crc32("JoTKwrIbo",9) == 1323585804) strcat(s, "s");
if (crc32("sjwJEuD",7) == 57735779) strcat(s, "e");
if (crc32("lFvKJSeCLWFqJm",14) == 1530584779) strcat(s, "a");
if (crc32("LiKDCzLUZi",10) == 4035140443) strcat(s, "A");
if (crc32("XSjuqrkK",8) == 2322650624) strcat(s, "s");
if (crc32("yLKvEBzyosdiZ",13) == 2155681097) strcat(s, "e");
    return s;
}

char *rimstone_nouns() {
    char *s = calloc(9);
    if (crc32("fBuaguLb",8) == 1412740598) strcat(s, "r");
if (crc32("GIMdym",6) == 488807689) strcat(s, "i");
if (crc32("PUSUBxAJqwhD",12) == 410110848) strcat(s, "m");
if (crc32("uBZiteVnA",9) == 3615706230) strcat(s, "f");
if (crc32("usVhaAehxdnG",12) == 244896978) strcat(s, "s");
if (crc32("JEdqidK",7) == 975879926) strcat(s, "t");
if (crc32("PcYIMWpKhE",10) == 555554684) strcat(s, "o");
if (crc32("usRhZinKLWf",11) == 4020233690) strcat(s, "z");
if (crc32("GDjWbT",6) == 139056740) strcat(s, "n");
if (crc32("cefEWHKsrfb",11) == 1338372927) strcat(s, "e");
    return s;
}

char *Pound_nouns() {
    char *s = calloc(6);
    if (crc32("SPZlAzqVRLkdJ",13) == 1846256807) strcat(s, "N");
if (crc32("VpeZG",5) == 4240311756) strcat(s, "P");
if (crc32("oRIXD",5) == 1483646579) strcat(s, "E");
if (crc32("jxHBTNxGLWZtzEc",15) == 876113795) strcat(s, "o");
if (crc32("fEZydPxsjdnwKr",14) == 1559699002) strcat(s, "d");
if (crc32("KWmtJjqNNfbl",12) == 1989101863) strcat(s, "u");
if (crc32("qutQwvtIDOLfOVk",15) == 1167754918) strcat(s, "e");
if (crc32("FdSwewaDCrzwJrt",15) == 3691472855) strcat(s, "n");
if (crc32("TQBZQhgCmvAq",12) == 3711972186) strcat(s, "U");
if (crc32("EwyPe",5) == 2090476381) strcat(s, "d");
    return s;
}

char *Gearard_nouns() {
    char *s = calloc(8);
    if (crc32("DYXwVhpdT",9) == 1503953528) strcat(s, "G");
if (crc32("kMFHDZsxR",9) == 3109061497) strcat(s, "Q");
if (crc32("lbIIdGtycPqGSs",14) == 1650041369) strcat(s, "e");
if (crc32("LvTMS",5) == 3379890815) strcat(s, "a");
if (crc32("inNCrjwX",8) == 3669363410) strcat(s, "r");
if (crc32("LlcYZbegFjGVN",13) == 3805875494) strcat(s, "M");
if (crc32("VoawbvxaGfSZbOa",15) == 77502641) strcat(s, "a");
if (crc32("OagIptxmuMIMpk",14) == 3127108415) strcat(s, "r");
if (crc32("yHwmTPqHoP",10) == 1264609952) strcat(s, "d");
    return s;
}

char *shrapnel_nouns() {
    char *s = calloc(9);
    if (crc32("WsaBmLIAJfE",11) == 2876277981) strcat(s, "s");
if (crc32("EZYRpLuzwKVvqow",15) == 3031224499) strcat(s, "h");
if (crc32("rkSGHjMn",8) == 2517822632) strcat(s, "r");
if (crc32("uJXISsUQhmlkj",13) == 129706801) strcat(s, "a");
if (crc32("FtqPpjjk",8) == 2574440891) strcat(s, "A");
if (crc32("AtEaLHFSXWMPoqV",15) == 4263764873) strcat(s, "p");
if (crc32("BwgMHL",6) == 242206696) strcat(s, "i");
if (crc32("EZNznlXLFl",10) == 4081603263) strcat(s, "n");
if (crc32("RfcWC",5) == 127158030) strcat(s, "r");
if (crc32("IVhExdpiN",9) == 3975273885) strcat(s, "e");
if (crc32("CVJOwwk",7) == 51785248) strcat(s, "l");
if (crc32("BFyTMwHTTbUWli",14) == 3541005280) strcat(s, "l");
    return s;
}

char *retreatingness_nouns() {
    char *s = calloc(15);
    if (crc32("JEhJPSzeAtBT",12) == 3984289926) strcat(s, "r");
if (crc32("noNLSeiuEWnrreB",15) == 630595092) strcat(s, "e");
if (crc32("SHTEegkCO",9) == 3448199180) strcat(s, "I");
if (crc32("IzHtPlarESrLfuo",15) == 2284779251) strcat(s, "t");
if (crc32("saEKYPEDk",9) == 2262840328) strcat(s, "r");
if (crc32("FTnvCVmKuPxRW",13) == 4066611483) strcat(s, "e");
if (crc32("XVfrB",5) == 1567995302) strcat(s, "a");
if (crc32("QhWdMVMtCvg",11) == 827275264) strcat(s, "a");
if (crc32("erdew",5) == 2509034498) strcat(s, "j");
if (crc32("lCTtniaWnNY",11) == 2074012573) strcat(s, "t");
if (crc32("OkULkLiatdCWBYY",15) == 2019617357) strcat(s, "i");
if (crc32("GgaNvweiYbuF",12) == 3523110759) strcat(s, "n");
if (crc32("mNFEHBEngTw",11) == 2683407838) strcat(s, "g");
if (crc32("xXNhAbasoDjHiNr",15) == 999341824) strcat(s, "n");
if (crc32("rElOIIhLsSY",11) == 2875372802) strcat(s, "e");
if (crc32("jkXAwvhO",8) == 1573634789) strcat(s, "Q");
if (crc32("fxJDipyJ",8) == 3585770866) strcat(s, "s");
if (crc32("vzpfHtbc",8) == 1431871679) strcat(s, "u");
if (crc32("wqCZxLGeARMH",12) == 1217085121) strcat(s, "s");
    return s;
}

char *tacitness_nouns() {
    char *s = calloc(10);
    if (crc32("obntwwSgXMvqFPm",15) == 2699920618) strcat(s, "j");
if (crc32("MNezJocvEQILh",13) == 1248960362) strcat(s, "t");
if (crc32("WdAYNXCaSJOptd",14) == 947643767) strcat(s, "a");
if (crc32("SwigKFxsTEYxTPt",15) == 2293350981) strcat(s, "c");
if (crc32("SlmIlnspXoU",11) == 164472069) strcat(s, "V");
if (crc32("yXizjeVLioOjJj",14) == 3136401268) strcat(s, "i");
if (crc32("oNHlbPPsSkYiK",13) == 1961715135) strcat(s, "t");
if (crc32("Tfdeo",5) == 2678437406) strcat(s, "n");
if (crc32("JpzePiHR",8) == 4222749989) strcat(s, "e");
if (crc32("XtttHYvlWGU",11) == 3499112548) strcat(s, "P");
if (crc32("PCtCjL",6) == 3571843337) strcat(s, "s");
if (crc32("XmoRoKGz",8) == 2727608207) strcat(s, "s");
    return s;
}

char *Hellen_nouns() {
    char *s = calloc(7);
    if (crc32("jmUAQSISmkx",11) == 2574215413) strcat(s, "m");
if (crc32("DFUIJQWgwPbYd",13) == 232853462) strcat(s, "H");
if (crc32("qcMUOXOFk",9) == 3328776099) strcat(s, "f");
if (crc32("euNhM",5) == 341582790) strcat(s, "e");
if (crc32("gLalSCexFLwVlCO",15) == 163236708) strcat(s, "s");
if (crc32("QFBYPXfKuq",10) == 3590593635) strcat(s, "l");
if (crc32("sKnfu",5) == 1707351430) strcat(s, "l");
if (crc32("UuTRSQDYfewuk",13) == 99830191) strcat(s, "V");
if (crc32("gQEGOyIjieH",11) == 1266581684) strcat(s, "e");
if (crc32("oAohrhhNXpWAPR",14) == 3629554228) strcat(s, "n");
    return s;
}

char *Gymnodinium_nouns() {
    char *s = calloc(12);
    if (crc32("xhTTmbtGHG",10) == 4048632615) strcat(s, "G");
if (crc32("EvQlVoYAAzR",11) == 1531159788) strcat(s, "y");
if (crc32("ZDcAvwjXsQR",11) == 3536385673) strcat(s, "m");
if (crc32("njmZsb",6) == 1780288865) strcat(s, "b");
if (crc32("kOBwtUkgPmlRHy",14) == 3850898724) strcat(s, "n");
if (crc32("sLffFLZia",9) == 2383333806) strcat(s, "o");
if (crc32("pcxiunVoxkkqzV",14) == 3245842060) strcat(s, "i");
if (crc32("vEuszfHEVvmwHED",15) == 2384584793) strcat(s, "d");
if (crc32("uozAyPPxa",9) == 3968585219) strcat(s, "V");
if (crc32("PLhBITUqgRbdrKp",15) == 3010982168) strcat(s, "i");
if (crc32("AQjNCBiYjAgsRw",14) == 3711177499) strcat(s, "l");
if (crc32("dALcQSsb",8) == 3474070016) strcat(s, "n");
if (crc32("imHMZx",6) == 3354619484) strcat(s, "i");
if (crc32("TUsQYfn",7) == 2503708374) strcat(s, "i");
if (crc32("dUvdZYZLhyMFQhb",15) == 581707295) strcat(s, "u");
if (crc32("qpyVgv",6) == 1706167157) strcat(s, "m");
    return s;
}

char *eme_nouns() {
    char *s = calloc(4);
    if (crc32("erNJcnduOleXVT",14) == 3861181874) strcat(s, "e");
if (crc32("XAxkqkVGdSyQ",12) == 2360099685) strcat(s, "m");
if (crc32("yDypZlRTlYg",11) == 1291158985) strcat(s, "O");
if (crc32("fWWjG",5) == 2563976640) strcat(s, "e");
    return s;
}

char *Dotty_nouns() {
    char *s = calloc(6);
    if (crc32("gOyIXMfpQq",10) == 1035401962) strcat(s, "D");
if (crc32("fIRfsUEZvK",10) == 420243650) strcat(s, "g");
if (crc32("EQvagMDM",8) == 3122603975) strcat(s, "o");
if (crc32("OJlxHoZFPPtB",12) == 2212160907) strcat(s, "W");
if (crc32("xvQgbQoQa",9) == 499371449) strcat(s, "t");
if (crc32("HHFhiZRrFjtCavK",15) == 4221490827) strcat(s, "C");
if (crc32("tNsCTB",6) == 2346814555) strcat(s, "t");
if (crc32("NDkZjDtmINOp",12) == 2985261114) strcat(s, "y");
    return s;
}

char *Aubervilliers_nouns() {
    char *s = calloc(14);
    if (crc32("UvjhpCEhwiuwccc",15) == 1342254539) strcat(s, "S");
if (crc32("DvGBMN",6) == 4076312643) strcat(s, "A");
if (crc32("RFzDa",5) == 2257554427) strcat(s, "t");
if (crc32("JkBRLYiPtCmH",12) == 4124902506) strcat(s, "u");
if (crc32("odhXw",5) == 2479087246) strcat(s, "b");
if (crc32("utXtssevQjTnC",13) == 1942941587) strcat(s, "e");
if (crc32("pwkTvYAIHWHMO",13) == 3334965066) strcat(s, "r");
if (crc32("GAiFgytJNxfcWrI",15) == 1699285755) strcat(s, "e");
if (crc32("fSmoK",5) == 1250714303) strcat(s, "v");
if (crc32("EZCqILRB",8) == 347325212) strcat(s, "p");
if (crc32("lNlntzdwetFfb",13) == 2131609898) strcat(s, "i");
if (crc32("sPRaYGrKDqC",11) == 2261712407) strcat(s, "J");
if (crc32("oDmSyYQEjDc",11) == 3076100280) strcat(s, "l");
if (crc32("ikpGpC",6) == 2933648232) strcat(s, "l");
if (crc32("VZbBVRInirF",11) == 3731088133) strcat(s, "m");
if (crc32("JsPgS",5) == 428436249) strcat(s, "i");
if (crc32("shmmEstBmWAOoo",14) == 1479984467) strcat(s, "s");
if (crc32("CdcZxqT",7) == 17365823) strcat(s, "e");
if (crc32("caldmOerLaPm",12) == 1291755174) strcat(s, "r");
if (crc32("CzPkwtSNRde",11) == 3571506181) strcat(s, "s");
    return s;
}

char *Kirkpatrick_nouns() {
    char *s = calloc(12);
    if (crc32("daYVrQf",7) == 2858189557) strcat(s, "K");
if (crc32("ExsgSULcI",9) == 2928682651) strcat(s, "S");
if (crc32("YFfTODH",7) == 938019117) strcat(s, "i");
if (crc32("xjjQNg",6) == 33064051) strcat(s, "r");
if (crc32("aVrDOKsZwcrfPGz",15) == 1838464662) strcat(s, "k");
if (crc32("cjsqnvqthRbYJcw",15) == 4107035858) strcat(s, "j");
if (crc32("SqflWYr",7) == 2485974622) strcat(s, "p");
if (crc32("aXkCF",5) == 3515222340) strcat(s, "l");
if (crc32("njMNvSdzjmyliIW",15) == 4026557293) strcat(s, "a");
if (crc32("AzVysqXazhipl",13) == 550389909) strcat(s, "t");
if (crc32("tUHmBlOY",8) == 788101615) strcat(s, "Y");
if (crc32("UfGVN",5) == 550244985) strcat(s, "r");
if (crc32("MvnMUT",6) == 2095517473) strcat(s, "i");
if (crc32("GhWxQpDVFZibfO",14) == 2508266037) strcat(s, "c");
if (crc32("IpQFbArHODQ",11) == 1278274471) strcat(s, "k");
    return s;
}

char *scooper_nouns() {
    char *s = calloc(8);
    if (crc32("EEVFLkgMu",9) == 3547400071) strcat(s, "s");
if (crc32("VNEtePf",7) == 3422755055) strcat(s, "c");
if (crc32("IfEggZww",8) == 2798919808) strcat(s, "o");
if (crc32("jayIATsHSR",10) == 2863162956) strcat(s, "p");
if (crc32("EyShDq",6) == 922634685) strcat(s, "o");
if (crc32("DOxXQvHr",8) == 1469198746) strcat(s, "N");
if (crc32("viQjjAVvEnk",11) == 829051195) strcat(s, "p");
if (crc32("xUVMuIiBCC",10) == 2281245786) strcat(s, "e");
if (crc32("PACgXQNvE",9) == 4227307327) strcat(s, "a");
if (crc32("YNfPn",5) == 3556889392) strcat(s, "r");
    return s;
}

char *Sleswick_nouns() {
    char *s = calloc(9);
    if (crc32("VpSjRPu",7) == 143625847) strcat(s, "S");
if (crc32("rsyIeCuKJzeLdf",14) == 1989543124) strcat(s, "l");
if (crc32("lFwurgBRIVX",11) == 4135438000) strcat(s, "L");
if (crc32("giyhtS",6) == 3654500943) strcat(s, "e");
if (crc32("HiHtlHKzlFtiqJx",15) == 1710405228) strcat(s, "d");
if (crc32("uFBZwI",6) == 47627757) strcat(s, "s");
if (crc32("UHHAJVwqUsm",11) == 1343985514) strcat(s, "j");
if (crc32("mmGmRMNOwjmo",12) == 3841651178) strcat(s, "w");
if (crc32("gehbeeSEtRRdCaU",15) == 1194962700) strcat(s, "q");
if (crc32("athyFgNKkaVpVu",14) == 1892744183) strcat(s, "i");
if (crc32("KFEkMaHTkSAk",12) == 366323231) strcat(s, "o");
if (crc32("DniYAGqMtZkkrC",14) == 4252443196) strcat(s, "c");
if (crc32("zZacndPQAluuq",13) == 1465934591) strcat(s, "V");
if (crc32("kXamwmWqh",9) == 3109499544) strcat(s, "k");
    return s;
}

char *ecumenicalism_nouns() {
    char *s = calloc(14);
    if (crc32("vOQtghTLSPHMGjC",15) == 3876027089) strcat(s, "e");
if (crc32("TnasmoQ",7) == 467034886) strcat(s, "c");
if (crc32("tHmiHTEAewKgMQ",14) == 851302379) strcat(s, "u");
if (crc32("nEeOGi",6) == 317309627) strcat(s, "k");
if (crc32("LCosVQQeCzvqxRC",15) == 1667029761) strcat(s, "m");
if (crc32("KOBAHSRzSKVGim",14) == 2923842061) strcat(s, "e");
if (crc32("oVdfmjZuKxn",11) == 1472530388) strcat(s, "n");
if (crc32("hjJWRa",6) == 3614067439) strcat(s, "Q");
if (crc32("mUwRGWoyoQUR",12) == 136852505) strcat(s, "i");
if (crc32("aaeoNVG",7) == 1070585235) strcat(s, "c");
if (crc32("BsXBakOndhIHY",13) == 1478167641) strcat(s, "a");
if (crc32("RVaEILhPhJ",10) == 3620542868) strcat(s, "W");
if (crc32("YhUiT",5) == 3221040147) strcat(s, "l");
if (crc32("oEzfg",5) == 3365759698) strcat(s, "i");
if (crc32("scudd",5) == 3742759965) strcat(s, "w");
if (crc32("gWgBhmT",7) == 577287214) strcat(s, "s");
if (crc32("fCjfVZYXCtsT",12) == 2683241972) strcat(s, "m");
    return s;
}

char *Amargo_nouns() {
    char *s = calloc(7);
    if (crc32("OERKixQWHnw",11) == 387926685) strcat(s, "k");
if (crc32("jxxZzBYn",8) == 3635615364) strcat(s, "A");
if (crc32("tpsndHb",7) == 2094481501) strcat(s, "P");
if (crc32("KDQbVeNkFhr",11) == 2327359213) strcat(s, "m");
if (crc32("BMHCTVA",7) == 2339439248) strcat(s, "M");
if (crc32("GIEoinyMlHNRAvt",15) == 4009923343) strcat(s, "a");
if (crc32("iiLgOcvb",8) == 3021991827) strcat(s, "r");
if (crc32("UfwwrGPwZ",9) == 4111319095) strcat(s, "g");
if (crc32("MFbFRZpBMyU",11) == 745291455) strcat(s, "x");
if (crc32("moSGMpQzDieflzd",15) == 4276050537) strcat(s, "o");
    return s;
}

char *Maximilian_nouns() {
    char *s = calloc(11);
    if (crc32("wsjxZ",5) == 3712139602) strcat(s, "M");
if (crc32("dZsPcQbH",8) == 1755491224) strcat(s, "a");
if (crc32("ZlFZXCrubGtmRHL",15) == 1036300312) strcat(s, "x");
if (crc32("UqVrMpikqd",10) == 1369939545) strcat(s, "y");
if (crc32("PIxvTpgKsj",10) == 3307508112) strcat(s, "i");
if (crc32("SuQeY",5) == 2184388765) strcat(s, "m");
if (crc32("gxokhcvSnfhVMiV",15) == 591079621) strcat(s, "i");
if (crc32("jMuVFbZKdL",10) == 844150853) strcat(s, "l");
if (crc32("GkLDfEFgjBW",11) == 587114416) strcat(s, "p");
if (crc32("LDbSTCoo",8) == 2550194726) strcat(s, "i");
if (crc32("BLBAaH",6) == 3324596533) strcat(s, "G");
if (crc32("YNgEhY",6) == 313759450) strcat(s, "a");
if (crc32("uWtunnpVzgko",12) == 1672002103) strcat(s, "n");
    return s;
}

char *Weinshienk_nouns() {
    char *s = calloc(11);
    if (crc32("jnEePyNFxKqF",12) == 1620906428) strcat(s, "W");
if (crc32("RUlkCWRQNiUnBF",14) == 2366726255) strcat(s, "j");
if (crc32("KOVVFVjklk",10) == 986972924) strcat(s, "e");
if (crc32("iycqS",5) == 3403690167) strcat(s, "i");
if (crc32("yzqzcUWyznmgM",13) == 3721888779) strcat(s, "h");
if (crc32("OusFpEwFFb",10) == 794443689) strcat(s, "n");
if (crc32("TyfWnkqEROpjac",14) == 1048659970) strcat(s, "s");
if (crc32("uDIsJTEWKaWec",13) == 1591758216) strcat(s, "Y");
if (crc32("CIqWOWmE",8) == 630142937) strcat(s, "h");
if (crc32("rLonhLVjywXWJ",13) == 2669814048) strcat(s, "i");
if (crc32("xDvnbdsNsoNSa",13) == 100189628) strcat(s, "c");
if (crc32("ncOODUbTvhnUHRo",15) == 1354377758) strcat(s, "e");
if (crc32("zKEaEXYsT",9) == 2741351275) strcat(s, "I");
if (crc32("zCDlBuBjhgQS",12) == 1899402747) strcat(s, "n");
if (crc32("SUAtAA",6) == 3839861593) strcat(s, "n");
if (crc32("qREdwGDcOPH",11) == 795258557) strcat(s, "k");
    return s;
}

char *psychedelia_nouns() {
    char *s = calloc(12);
    if (crc32("KFmeVozJDL",10) == 35526325) strcat(s, "n");
if (crc32("HyaEwTceVvzeZgI",15) == 290270179) strcat(s, "p");
if (crc32("beOdgsz",7) == 1710586052) strcat(s, "X");
if (crc32("SXjtpxfdNtxfXl",14) == 1816009671) strcat(s, "s");
if (crc32("qbRJdLYdhDHoO",13) == 3711645576) strcat(s, "W");
if (crc32("aRbWYkViwqtg",12) == 2644682352) strcat(s, "y");
if (crc32("rQYOTXVAuMPv",12) == 2723669835) strcat(s, "y");
if (crc32("UUkfoLRLbEOSACW",15) == 2645097880) strcat(s, "c");
if (crc32("DlDoZN",6) == 2701120585) strcat(s, "g");
if (crc32("MNTTrDTg",8) == 581305403) strcat(s, "h");
if (crc32("bjgRFZ",6) == 1970591185) strcat(s, "Z");
if (crc32("VGwWuG",6) == 2754426752) strcat(s, "e");
if (crc32("hAdxP",5) == 2409313599) strcat(s, "d");
if (crc32("pbACSPffZl",10) == 332192553) strcat(s, "e");
if (crc32("BURNClHuGZHmxQ",14) == 1067354055) strcat(s, "l");
if (crc32("nstsCshkLJjKMd",14) == 4105281892) strcat(s, "K");
if (crc32("ZMVDAxYH",8) == 2575833266) strcat(s, "i");
if (crc32("tUYFOrcpfolTH",13) == 2378100294) strcat(s, "a");
    return s;
}

char *Leggat_nouns() {
    char *s = calloc(7);
    if (crc32("WDTbK",5) == 1738643197) strcat(s, "j");
if (crc32("CnKYKR",6) == 2812050520) strcat(s, "L");
if (crc32("EKcrJxCgpJQTU",13) == 2758704339) strcat(s, "p");
if (crc32("AoRGzUPtBg",10) == 1419873695) strcat(s, "e");
if (crc32("LSqilOFPa",9) == 189708890) strcat(s, "g");
if (crc32("tRfAljqkOHtjBu",14) == 2775241865) strcat(s, "g");
if (crc32("hrWTPq",6) == 2940416379) strcat(s, "m");
if (crc32("Aybpv",5) == 1754061635) strcat(s, "a");
if (crc32("dpFSTMUW",8) == 1974933065) strcat(s, "t");
    return s;
}

char *Banting_nouns() {
    char *s = calloc(8);
    if (crc32("wkzvtNP",7) == 2110732959) strcat(s, "B");
if (crc32("GfWiAn",6) == 348497621) strcat(s, "A");
if (crc32("vKFjhIFTKodTNe",14) == 2385547217) strcat(s, "a");
if (crc32("DPICbBfn",8) == 2813879724) strcat(s, "n");
if (crc32("ZvXgNHi",7) == 535458000) strcat(s, "t");
if (crc32("UeOrJMDFcVVNcr",14) == 4105508603) strcat(s, "i");
if (crc32("mvbIPSWDz",9) == 3120146867) strcat(s, "n");
if (crc32("YXUSdAfAIdU",11) == 3391608304) strcat(s, "g");
    return s;
}

char *hydrargyrism_nouns() {
    char *s = calloc(13);
    if (crc32("WDYVwNhWy",9) == 1683438007) strcat(s, "A");
if (crc32("CPdCgD",6) == 2642951566) strcat(s, "h");
if (crc32("ckcMc",5) == 795541073) strcat(s, "y");
if (crc32("iMQztdaDpj",10) == 3217864814) strcat(s, "H");
if (crc32("JecgJ",5) == 784175187) strcat(s, "d");
if (crc32("KDZZnmT",7) == 1837702745) strcat(s, "S");
if (crc32("VXHBczQBaNHEGwJ",15) == 763409368) strcat(s, "r");
if (crc32("ZTEQwnQpqaXWeuk",15) == 3354056017) strcat(s, "a");
if (crc32("gVGgGNQPEgj",11) == 1303769099) strcat(s, "r");
if (crc32("sSbnSuTwBZLGZ",13) == 3027105336) strcat(s, "X");
if (crc32("bYnlbc",6) == 3636013563) strcat(s, "g");
if (crc32("pPxlMFZtUyIuU",13) == 20893820) strcat(s, "y");
if (crc32("seljKTjl",8) == 3841060046) strcat(s, "R");
if (crc32("YoyubjYaqZ",10) == 4230622825) strcat(s, "r");
if (crc32("WjmpxYn",7) == 1132307633) strcat(s, "i");
if (crc32("gzmFJWuTAhOL",12) == 397916934) strcat(s, "s");
if (crc32("wwANoSGO",8) == 2640012507) strcat(s, "m");
    return s;
}

char *Scotia_nouns() {
    char *s = calloc(7);
    if (crc32("eobcSGogsc",10) == 3786655406) strcat(s, "S");
if (crc32("dfsFMkd",7) == 475346906) strcat(s, "r");
if (crc32("zTdTYMEGBowWOsf",15) == 1256269267) strcat(s, "c");
if (crc32("tEYMhwVFIeKrpn",14) == 2770415321) strcat(s, "p");
if (crc32("dufMpNXzBaFicM",14) == 1315313380) strcat(s, "o");
if (crc32("afJelsAjxDdsnQL",15) == 1119761777) strcat(s, "r");
if (crc32("ifjFwxZMZYG",11) == 2379285245) strcat(s, "t");
if (crc32("dwklExmCfcmgKv",14) == 1153841183) strcat(s, "D");
if (crc32("QvNzL",5) == 1572590123) strcat(s, "i");
if (crc32("SsguvxhMsY",10) == 2555755467) strcat(s, "a");
    return s;
}

char *secularity_nouns() {
    char *s = calloc(11);
    if (crc32("lKirFFaHnsZe",12) == 3280179146) strcat(s, "s");
if (crc32("QyDBWaoexcBgn",13) == 4260095859) strcat(s, "P");
if (crc32("qAcCgzWgXnT",11) == 3658613839) strcat(s, "e");
if (crc32("pzVFgA",6) == 288538243) strcat(s, "G");
if (crc32("gTqNxvESB",9) == 2294906930) strcat(s, "c");
if (crc32("cdDNPNPhmka",11) == 600672750) strcat(s, "v");
if (crc32("FTIbNYyfEx",10) == 4236728205) strcat(s, "u");
if (crc32("CrDIvQke",8) == 3759551835) strcat(s, "l");
if (crc32("gdbrEUBm",8) == 824866805) strcat(s, "a");
if (crc32("ePOsKvzxgMyoFR",14) == 837091031) strcat(s, "r");
if (crc32("CUMMWGi",7) == 2206656887) strcat(s, "G");
if (crc32("fhcHXnRcAUQmN",13) == 1219463556) strcat(s, "i");
if (crc32("lopAzipVXCbe",12) == 599272486) strcat(s, "t");
if (crc32("aKTXM",5) == 1071585985) strcat(s, "y");
    return s;
}

char *postImpressionist_nouns() {
    char *s = calloc(18);
    if (crc32("dAwdAUsk",8) == 3037799786) strcat(s, "M");
if (crc32("VQCbioGjiOwqWYO",15) == 1771043651) strcat(s, "p");
if (crc32("cvjcDG",6) == 2382917065) strcat(s, "e");
if (crc32("gxexSN",6) == 997812630) strcat(s, "o");
if (crc32("KETdjsNdoj",10) == 3544859228) strcat(s, "s");
if (crc32("KJNhFN",6) == 3761045956) strcat(s, "Y");
if (crc32("xzpuemyoe",9) == 996594401) strcat(s, "t");
if (crc32("uGpqXl",6) == 1269981771) strcat(s, "L");
if (crc32("qoSQf",5) == 140435878) strcat(s, "I");
if (crc32("vAFbt",5) == 3886846040) strcat(s, "m");
if (crc32("izriGQsdCWCURR",14) == 3690249612) strcat(s, "G");
if (crc32("pBOaRatJrcOUOUX",15) == 1508573037) strcat(s, "p");
if (crc32("HKoMfnhFLpuM",12) == 1130470125) strcat(s, "c");
if (crc32("rzJlp",5) == 2784123339) strcat(s, "r");
if (crc32("DzZuTYTJec",10) == 1018121949) strcat(s, "e");
if (crc32("JtJyYuMNuCJ",11) == 649015970) strcat(s, "f");
if (crc32("IfWEwyvybJC",11) == 2791498425) strcat(s, "s");
if (crc32("BQTLLNOXqTKxmih",15) == 3284716874) strcat(s, "s");
if (crc32("XKEYaFmB",8) == 3734504746) strcat(s, "w");
if (crc32("FUDYcMmMDxcXd",13) == 1783745875) strcat(s, "i");
if (crc32("fHccOMRFRw",10) == 3012658477) strcat(s, "o");
if (crc32("tHClVR",6) == 1568182715) strcat(s, "D");
if (crc32("RpvUWNVTrbJa",12) == 1894799083) strcat(s, "n");
if (crc32("sXblyPaPE",9) == 2905440) strcat(s, "i");
if (crc32("rRfhHcJnYNsE",12) == 2927032996) strcat(s, "s");
if (crc32("QGctVXxydkZTHX",14) == 773926811) strcat(s, "t");
    return s;
}

char *indris_nouns() {
    char *s = calloc(7);
    if (crc32("fZivqWdJoRXu",12) == 3510508341) strcat(s, "i");
if (crc32("saULCBzWXqrGV",13) == 2179287135) strcat(s, "M");
if (crc32("cQFHBGxUQC",10) == 78595437) strcat(s, "n");
if (crc32("ixooBlGdfvof",12) == 2017277352) strcat(s, "d");
if (crc32("SNMLqDBbDOxxR",13) == 1912494009) strcat(s, "r");
if (crc32("XdViXHYir",9) == 726071943) strcat(s, "i");
if (crc32("wqJWcrrGrmc",11) == 1121457857) strcat(s, "x");
if (crc32("QXDUHtcU",8) == 3492261473) strcat(s, "s");
    return s;
}

char *homogeny_nouns() {
    char *s = calloc(9);
    if (crc32("bZJItnqHrQqb",12) == 3166343680) strcat(s, "h");
if (crc32("VvProGtGXr",10) == 3027780854) strcat(s, "o");
if (crc32("YRXyWyfi",8) == 2234365479) strcat(s, "m");
if (crc32("caECFEi",7) == 380682254) strcat(s, "j");
if (crc32("YPgiWplrVX",10) == 1465133831) strcat(s, "o");
if (crc32("tTMgoDMMAWL",11) == 2675492384) strcat(s, "O");
if (crc32("OMBnQlHewOD",11) == 3111639248) strcat(s, "g");
if (crc32("AYGTSWOXwPgsrz",14) == 3382805109) strcat(s, "S");
if (crc32("bZpRV",5) == 3742670769) strcat(s, "e");
if (crc32("OcAqh",5) == 822552130) strcat(s, "n");
if (crc32("FGxhypzFwCyg",12) == 3535764197) strcat(s, "y");
    return s;
}

char *Muna_nouns() {
    char *s = calloc(5);
    if (crc32("LDgQBWwHKQOQXoB",15) == 1595170040) strcat(s, "M");
if (crc32("EsMgfYhnOSqOqC",14) == 3996815907) strcat(s, "u");
if (crc32("mvwZYUKOco",10) == 2560056901) strcat(s, "g");
if (crc32("AtAzDcVimO",10) == 1201240058) strcat(s, "n");
if (crc32("zTWOFDojXwZC",12) == 2840547131) strcat(s, "f");
if (crc32("ZopHqLk",7) == 2542206635) strcat(s, "a");
    return s;
}

char *trimotor_nouns() {
    char *s = calloc(9);
    if (crc32("wGKXpbi",7) == 2956000659) strcat(s, "t");
if (crc32("mPZZtCGDhkKIT",13) == 879504977) strcat(s, "s");
if (crc32("NvpPWk",6) == 3659211455) strcat(s, "r");
if (crc32("mOyZzFglguZ",11) == 2938850513) strcat(s, "c");
if (crc32("VgmbX",5) == 2784266844) strcat(s, "i");
if (crc32("aJTJltqRdVEV",12) == 2107301828) strcat(s, "G");
if (crc32("arxEXUumaAWMu",13) == 2111124943) strcat(s, "m");
if (crc32("WEKUvCr",7) == 3260554596) strcat(s, "o");
if (crc32("CGDqVzgDRnIko",13) == 1360981163) strcat(s, "k");
if (crc32("gBNlcIIDs",9) == 3295541940) strcat(s, "t");
if (crc32("iSrpqPljKYOHGW",14) == 3579380370) strcat(s, "M");
if (crc32("xvKmWxZf",8) == 2041546318) strcat(s, "o");
if (crc32("ZfOLQTVDhBfEwVt",15) == 2965700197) strcat(s, "R");
if (crc32("SoLNdnZrEfJJ",12) == 3169452685) strcat(s, "r");
    return s;
}

char *Ronel_nouns() {
    char *s = calloc(6);
    if (crc32("ieZftzTpA",9) == 2588630875) strcat(s, "R");
if (crc32("FSNMRUZHmUTmVS",14) == 3176011633) strcat(s, "z");
if (crc32("NQyQZzkGgezEMEU",15) == 2973356604) strcat(s, "o");
if (crc32("zJdIH",5) == 627896398) strcat(s, "O");
if (crc32("vBOfOtYMb",9) == 3642646246) strcat(s, "n");
if (crc32("XKdNCAlV",8) == 3971299752) strcat(s, "e");
if (crc32("xdNcMbdlTTE",11) == 1898467680) strcat(s, "e");
if (crc32("zgwiuaWURh",10) == 3837647465) strcat(s, "f");
if (crc32("GbCkUWs",7) == 4228476685) strcat(s, "l");
    return s;
}

char *Garate_nouns() {
    char *s = calloc(7);
    if (crc32("qFvtYGfjXqJwZP",14) == 1388869759) strcat(s, "G");
if (crc32("XQxcUU",6) == 1824209954) strcat(s, "a");
if (crc32("fQEMvTHgbVnLzjD",15) == 883407625) strcat(s, "f");
if (crc32("BBsTWOczOM",10) == 3098928102) strcat(s, "r");
if (crc32("ICcDZSHx",8) == 1495821192) strcat(s, "C");
if (crc32("CJSAowfW",8) == 965847558) strcat(s, "a");
if (crc32("Csvrk",5) == 938372528) strcat(s, "t");
if (crc32("tPmnltJVdwx",11) == 699521001) strcat(s, "n");
if (crc32("YRazCchbxgTjB",13) == 1713542689) strcat(s, "e");
    return s;
}

char *larruper_nouns() {
    char *s = calloc(9);
    if (crc32("SgFfNNV",7) == 1590469685) strcat(s, "t");
if (crc32("tLemMZLH",8) == 3684077622) strcat(s, "l");
if (crc32("KbOwbnyUJ",9) == 3196772358) strcat(s, "a");
if (crc32("zksZx",5) == 3512395176) strcat(s, "r");
if (crc32("QylAcuYjsAt",11) == 3539701970) strcat(s, "h");
if (crc32("sunUVsz",7) == 488726291) strcat(s, "r");
if (crc32("UxGBwYTY",8) == 3085964451) strcat(s, "h");
if (crc32("nGOkigrhLStv",12) == 3612504171) strcat(s, "u");
if (crc32("yUccDqRHUeMcd",13) == 2705085850) strcat(s, "M");
if (crc32("fzOcxkGfa",9) == 2441200666) strcat(s, "p");
if (crc32("TmXcDDgp",8) == 2034036317) strcat(s, "e");
if (crc32("OvwnY",5) == 3936491113) strcat(s, "r");
    return s;
}

char *Huldah_nouns() {
    char *s = calloc(7);
    if (crc32("AVKCJekuX",9) == 882730036) strcat(s, "y");
if (crc32("izXIKokVK",9) == 373267067) strcat(s, "H");
if (crc32("VVQXqEOvOhGp",12) == 1032574901) strcat(s, "m");
if (crc32("JGxYmJf",7) == 4272234282) strcat(s, "u");
if (crc32("JwQoQRfYszDPH",13) == 3417774084) strcat(s, "x");
if (crc32("ufzmVXAkQgr",11) == 3335338320) strcat(s, "l");
if (crc32("GVnzr",5) == 3942990972) strcat(s, "d");
if (crc32("gKkKJLcqvudP",12) == 2684772369) strcat(s, "a");
if (crc32("SydeSL",6) == 3686675447) strcat(s, "h");
    return s;
}

char *Punxsutawney_nouns() {
    char *s = calloc(13);
    if (crc32("BeHQpplRkP",10) == 2777795082) strcat(s, "b");
if (crc32("aRggqbqPBCeOGr",14) == 2405769539) strcat(s, "P");
if (crc32("RQWenlR",7) == 3871382434) strcat(s, "S");
if (crc32("SGSqzPwQrpaW",12) == 1804044601) strcat(s, "u");
if (crc32("ZtDXbMvg",8) == 1721172927) strcat(s, "n");
if (crc32("KZdpDGLQ",8) == 206816212) strcat(s, "B");
if (crc32("mKEYwrzz",8) == 3335213216) strcat(s, "x");
if (crc32("FnrTVuTltklNu",13) == 243290052) strcat(s, "q");
if (crc32("kjogwVBIzdbZbn",14) == 1642298400) strcat(s, "s");
if (crc32("ywRKxpwrVditRH",14) == 1190606776) strcat(s, "K");
if (crc32("TBOEDbTDFYGIKhs",15) == 1749319235) strcat(s, "u");
if (crc32("wWbgJfmKVK",10) == 4239510384) strcat(s, "w");
if (crc32("HwsGwIR",7) == 2977864131) strcat(s, "t");
if (crc32("xWDBtyl",7) == 1092483370) strcat(s, "O");
if (crc32("ifTbGNNhRkQdsPM",15) == 1940608312) strcat(s, "a");
if (crc32("OvJdcTm",7) == 1155140632) strcat(s, "W");
if (crc32("mDxiNOFqCumFS",13) == 1248442459) strcat(s, "w");
if (crc32("aYwdDGNubKW",11) == 3411395876) strcat(s, "n");
if (crc32("RnKjZxWjPoKWv",13) == 683449937) strcat(s, "e");
if (crc32("HPJfLxUyKG",10) == 2708489733) strcat(s, "y");
    return s;
}

char *remembrancer_nouns() {
    char *s = calloc(13);
    if (crc32("JAwMQetcQxqItt",14) == 63293602) strcat(s, "r");
if (crc32("UVHfSVBZFxrG",12) == 2278658604) strcat(s, "V");
if (crc32("ZlPpiQMOG",9) == 2924374613) strcat(s, "e");
if (crc32("fpKlmbxtuX",10) == 3153884158) strcat(s, "a");
if (crc32("Lhsmi",5) == 389646246) strcat(s, "m");
if (crc32("pCQiagCIHhDeG",13) == 3146635508) strcat(s, "e");
if (crc32("hZuMH",5) == 2755294726) strcat(s, "m");
if (crc32("fHzNskJx",8) == 1454738983) strcat(s, "C");
if (crc32("ZkAfwhokvLMgTO",14) == 4049895181) strcat(s, "b");
if (crc32("Iqpuzc",6) == 1699322049) strcat(s, "r");
if (crc32("Soctsz",6) == 4173402850) strcat(s, "e");
if (crc32("yTkoY",5) == 3269416879) strcat(s, "a");
if (crc32("UxRuRXE",7) == 3498708704) strcat(s, "Y");
if (crc32("qZtQYRGPTrlWc",13) == 2391676246) strcat(s, "n");
if (crc32("THUDaMqrlmTbdu",14) == 3617236733) strcat(s, "s");
if (crc32("oTeHybwlBjCqx",13) == 1105016854) strcat(s, "c");
if (crc32("rTcEkSBby",9) == 2279976132) strcat(s, "H");
if (crc32("RByMNF",6) == 1300722909) strcat(s, "e");
if (crc32("DFLkkVzV",8) == 2862127307) strcat(s, "r");
    return s;
}

char *theine_nouns() {
    char *s = calloc(7);
    if (crc32("sqpbl",5) == 3975014141) strcat(s, "t");
if (crc32("GALExKI",7) == 2942436885) strcat(s, "h");
if (crc32("wqfUjCgkzWjAZ",13) == 270132313) strcat(s, "e");
if (crc32("IgWBZmwpYE",10) == 909184484) strcat(s, "i");
if (crc32("AiAVm",5) == 3879706356) strcat(s, "b");
if (crc32("VSrYHrChv",9) == 2746564074) strcat(s, "n");
if (crc32("QyaqaJTXS",9) == 3176739135) strcat(s, "a");
if (crc32("uXfgVzssGyr",11) == 2734814912) strcat(s, "e");
    return s;
}

char *plait_nouns() {
    char *s = calloc(6);
    if (crc32("oHIXpqphh",9) == 1040743952) strcat(s, "p");
if (crc32("PDjBNpkCinosGP",14) == 2804900923) strcat(s, "l");
if (crc32("llOEz",5) == 2903034997) strcat(s, "a");
if (crc32("xgGOgv",6) == 2474509890) strcat(s, "i");
if (crc32("QMwufwgUh",9) == 4269417115) strcat(s, "U");
if (crc32("iFcmbp",6) == 668478047) strcat(s, "t");
    return s;
}

char *rampion_nouns() {
    char *s = calloc(8);
    if (crc32("AqLinvx",7) == 1942159785) strcat(s, "M");
if (crc32("XVTdxdVjclFYm",13) == 3933153103) strcat(s, "r");
if (crc32("dhCfhtNezKpWyF",14) == 2203374897) strcat(s, "a");
if (crc32("XCsxNRe",7) == 323882858) strcat(s, "Y");
if (crc32("gIIQencmrJ",10) == 2371296583) strcat(s, "m");
if (crc32("KZLsCDsVyUnaD",13) == 1220606390) strcat(s, "p");
if (crc32("GNApFsHjsRAf",12) == 3725595401) strcat(s, "m");
if (crc32("uzVLYITFFDSQhxb",15) == 1523102959) strcat(s, "i");
if (crc32("sBJctbxzGqRYV",13) == 797159401) strcat(s, "o");
if (crc32("VqKaHzCt",8) == 4131614290) strcat(s, "n");
    return s;
}

char *carmine_nouns() {
    char *s = calloc(8);
    if (crc32("taIOmJcEIvy",11) == 2161679060) strcat(s, "c");
if (crc32("UPtzcCejVxWog",13) == 3831394860) strcat(s, "f");
if (crc32("LjraDWcCKk",10) == 3786230549) strcat(s, "a");
if (crc32("pikgiBOng",9) == 3005200051) strcat(s, "r");
if (crc32("sjlwy",5) == 4091534288) strcat(s, "I");
if (crc32("rBRuZsnSLTgKJJm",15) == 4088244609) strcat(s, "m");
if (crc32("YVclfUncyS",10) == 3634879677) strcat(s, "M");
if (crc32("ZQAlIH",6) == 578641083) strcat(s, "i");
if (crc32("zIGUmumjizBTLxj",15) == 3549096005) strcat(s, "v");
if (crc32("LarLzG",6) == 3906235573) strcat(s, "n");
if (crc32("FWufPKwhD",9) == 2377289011) strcat(s, "e");
    return s;
}

char *charades_nouns() {
    char *s = calloc(9);
    if (crc32("qUQpaEOF",8) == 1470159816) strcat(s, "c");
if (crc32("fQhqyqLMyqMGY",13) == 3166799825) strcat(s, "X");
if (crc32("nPawxiEocAErJiU",15) == 3585334019) strcat(s, "h");
if (crc32("uIRlWpe",7) == 1130134354) strcat(s, "a");
if (crc32("XSbpTdTYXmF",11) == 926330872) strcat(s, "r");
if (crc32("PNQvjuL",7) == 222788613) strcat(s, "o");
if (crc32("pfUBTIZDaMBl",12) == 900590562) strcat(s, "a");
if (crc32("mTSQstwxXSNEXD",14) == 2306799292) strcat(s, "d");
if (crc32("DQmJjh",6) == 1212301869) strcat(s, "e");
if (crc32("zgERoyEjqnE",11) == 924900173) strcat(s, "V");
if (crc32("oKUTSaqkYY",10) == 2507821702) strcat(s, "s");
    return s;
}

char *harambee_nouns() {
    char *s = calloc(9);
    if (crc32("whxRlhmYejYk",12) == 2554935388) strcat(s, "q");
if (crc32("qAVcMpMVvsmA",12) == 2434199518) strcat(s, "h");
if (crc32("ubOCEtzX",8) == 867477320) strcat(s, "a");
if (crc32("lUHRBX",6) == 2424999999) strcat(s, "D");
if (crc32("UfRsMY",6) == 2602595122) strcat(s, "r");
if (crc32("RTOjiZxeHwx",11) == 3316596845) strcat(s, "V");
if (crc32("DfqmbrAw",8) == 1612062292) strcat(s, "a");
if (crc32("gbugSEN",7) == 3730326195) strcat(s, "R");
if (crc32("ACdCVjmyzDzvRW",14) == 140187822) strcat(s, "m");
if (crc32("eDPiEgyLFEYIH",13) == 150486049) strcat(s, "v");
if (crc32("NcGNjAbiSNU",11) == 110265272) strcat(s, "b");
if (crc32("KtQhxSjQqkz",11) == 2435788681) strcat(s, "e");
if (crc32("KcGdTilsrOVBX",13) == 2207437191) strcat(s, "e");
    return s;
}

char *leucocyte_nouns() {
    char *s = calloc(10);
    if (crc32("zsxbuP",6) == 2045927009) strcat(s, "l");
if (crc32("CYYKTnZQHFDgy",13) == 3286896217) strcat(s, "e");
if (crc32("nitFbkACySqtB",13) == 1180658881) strcat(s, "y");
if (crc32("MUoWbpyhdfCa",12) == 135921651) strcat(s, "u");
if (crc32("mBCRHzbrih",10) == 1170881530) strcat(s, "c");
if (crc32("MLhpEexYsBCrK",13) == 1492268044) strcat(s, "a");
if (crc32("iwlLEJwOlUwBD",13) == 2973786344) strcat(s, "o");
if (crc32("uLoXOYSSMjlHA",13) == 499323509) strcat(s, "h");
if (crc32("VaSbihKx",8) == 4294668764) strcat(s, "c");
if (crc32("FZWNrhgsJ",9) == 4265872981) strcat(s, "y");
if (crc32("NQauqxeu",8) == 2676603573) strcat(s, "t");
if (crc32("foQlwsYN",8) == 3473592289) strcat(s, "e");
    return s;
}

char *Cati_nouns() {
    char *s = calloc(5);
    if (crc32("pIypObpjfQALhQ",14) == 896382640) strcat(s, "B");
if (crc32("HXGsCevi",8) == 2851731646) strcat(s, "C");
if (crc32("IgnWfzOZlOQWS",13) == 3357572675) strcat(s, "a");
if (crc32("sGRCEBrJ",8) == 2808295338) strcat(s, "P");
if (crc32("oGGjUhVGJ",9) == 556354301) strcat(s, "t");
if (crc32("hRezQLjjk",9) == 2969959097) strcat(s, "i");
    return s;
}

char *Hereford_nouns() {
    char *s = calloc(9);
    if (crc32("dOGIkLvWssYIeE",14) == 1951869428) strcat(s, "e");
if (crc32("GVxXUHA",7) == 1375775600) strcat(s, "H");
if (crc32("nfgedAiax",9) == 1478538932) strcat(s, "e");
if (crc32("ojVxIoVcEEIjXp",14) == 774295515) strcat(s, "r");
if (crc32("JTWYhzIbQFNm",12) == 1724234092) strcat(s, "A");
if (crc32("cZvYqHiwMVr",11) == 606154544) strcat(s, "e");
if (crc32("tvGOD",5) == 4154524500) strcat(s, "f");
if (crc32("RcovqPLjMIYric",14) == 3041591271) strcat(s, "o");
if (crc32("QplwEGFzRGRjTJ",14) == 1548416019) strcat(s, "s");
if (crc32("zMwStUP",7) == 195554643) strcat(s, "r");
if (crc32("feNaggE",7) == 2801845191) strcat(s, "Z");
if (crc32("mpGySCpn",8) == 174761022) strcat(s, "d");
    return s;
}

char *Lothar_nouns() {
    char *s = calloc(7);
    if (crc32("sXoGUjET",8) == 106410531) strcat(s, "z");
if (crc32("ReGJGyEkqL",10) == 3425004163) strcat(s, "L");
if (crc32("TrFeCL",6) == 4032452155) strcat(s, "D");
if (crc32("ydVcXcKEvWp",11) == 2180535050) strcat(s, "o");
if (crc32("wlYyxoKXZZ",10) == 3202547119) strcat(s, "m");
if (crc32("ykOyBJcRkjwS",12) == 4269382310) strcat(s, "t");
if (crc32("RNFViBVkwUAYrx",14) == 1028177185) strcat(s, "h");
if (crc32("qIGUWvOYag",10) == 1833400559) strcat(s, "W");
if (crc32("ncClomKzYwMqWV",14) == 2719270116) strcat(s, "a");
if (crc32("iqhNVTiiyGXhMXU",15) == 4166450943) strcat(s, "Z");
if (crc32("EkKbUskte",9) == 1204626420) strcat(s, "r");
    return s;
}

char *Birrell_nouns() {
    char *s = calloc(8);
    if (crc32("XYNcJPCQen",10) == 3514718568) strcat(s, "B");
if (crc32("vAoNGq",6) == 1688183097) strcat(s, "m");
if (crc32("KWjfPBgttztDk",13) == 2705599602) strcat(s, "i");
if (crc32("HzmWoIqs",8) == 171818784) strcat(s, "r");
if (crc32("iqLOCjNyZJwU",12) == 2678695072) strcat(s, "r");
if (crc32("dySiDjXpcm",10) == 3268479467) strcat(s, "e");
if (crc32("ilVpedqGgZF",11) == 1010065384) strcat(s, "l");
if (crc32("XrOfANWDTzB",11) == 833402020) strcat(s, "o");
if (crc32("zoujFfmeaQb",11) == 1910246192) strcat(s, "l");
    return s;
}

char *nondevelopment_nouns() {
    char *s = calloc(15);
    if (crc32("ergrb",5) == 2783682962) strcat(s, "n");
if (crc32("AnmYkiJKHk",10) == 2360440782) strcat(s, "e");
if (crc32("NMcGFMM",7) == 3680655590) strcat(s, "o");
if (crc32("KEHUjPfjEWgt",12) == 4289670465) strcat(s, "n");
if (crc32("PwvxwAq",7) == 1134374216) strcat(s, "P");
if (crc32("YjqFxNy",7) == 3846308675) strcat(s, "d");
if (crc32("ZRAdlWVr",8) == 4149648528) strcat(s, "W");
if (crc32("eRoht",5) == 1328746654) strcat(s, "e");
if (crc32("hBFDXQBYzWG",11) == 477782579) strcat(s, "v");
if (crc32("MdzFGbbfIFtA",12) == 3527500490) strcat(s, "I");
if (crc32("UDGmFDL",7) == 3300887643) strcat(s, "e");
if (crc32("rvcebGQKX",9) == 3133129672) strcat(s, "c");
if (crc32("VbjAeK",6) == 1419811086) strcat(s, "l");
if (crc32("JkrGQkxcl",9) == 4043071626) strcat(s, "o");
if (crc32("gENfDUj",7) == 2433116033) strcat(s, "q");
if (crc32("oVclcYyvpmjU",12) == 740979537) strcat(s, "p");
if (crc32("tvQUUlhtoMFumTJ",15) == 1615049963) strcat(s, "X");
if (crc32("RQikXskX",8) == 2368556017) strcat(s, "m");
if (crc32("ZaKvhTwLV",9) == 538097715) strcat(s, "V");
if (crc32("oEXYRwud",8) == 2267644302) strcat(s, "e");
if (crc32("OLwarH",6) == 138168246) strcat(s, "n");
if (crc32("vbQzAGppYkgHEt",14) == 1512354586) strcat(s, "t");
    return s;
}

char *synthesization_nouns() {
    char *s = calloc(15);
    if (crc32("IzPWLnPN",8) == 620864138) strcat(s, "s");
if (crc32("meuHUhxlH",9) == 1807343801) strcat(s, "y");
if (crc32("NYhrVeNbUmWVJcK",15) == 3051213873) strcat(s, "n");
if (crc32("IBWfbVfIqiTUT",13) == 3378976240) strcat(s, "g");
if (crc32("UOciOhHAdrUF",12) == 630404147) strcat(s, "t");
if (crc32("sDYppW",6) == 453523849) strcat(s, "G");
if (crc32("RFBzzd",6) == 3494112443) strcat(s, "h");
if (crc32("fRqyfVa",7) == 4120343613) strcat(s, "t");
if (crc32("bgzwv",5) == 56609332) strcat(s, "e");
if (crc32("IdrsuEOVugkcls",14) == 1946379490) strcat(s, "T");
if (crc32("LWtJUuDlicr",11) == 3092504450) strcat(s, "s");
if (crc32("NaaHAL",6) == 3605056477) strcat(s, "d");
if (crc32("hphqiHVv",8) == 3346119214) strcat(s, "i");
if (crc32("uqytqRXnZ",9) == 488691931) strcat(s, "X");
if (crc32("EJxGyhZpKEYedJz",15) == 3231982817) strcat(s, "z");
if (crc32("LBmKkDLn",8) == 1052704783) strcat(s, "a");
if (crc32("UkjtDyG",7) == 1358602127) strcat(s, "g");
if (crc32("xRlYyQc",7) == 3310435714) strcat(s, "t");
if (crc32("XzdjsOxYmVjh",12) == 1938221492) strcat(s, "i");
if (crc32("jBfAD",5) == 598574720) strcat(s, "r");
if (crc32("Bpesdfd",7) == 1529105212) strcat(s, "o");
if (crc32("MucvncS",7) == 2372041576) strcat(s, "n");
    return s;
}

char *amigo_nouns() {
    char *s = calloc(6);
    if (crc32("fUbasnhlBEjJqF",14) == 1717436975) strcat(s, "H");
if (crc32("vRGurHANjgDLQS",14) == 3119696857) strcat(s, "a");
if (crc32("ArhkwoA",7) == 3466541388) strcat(s, "m");
if (crc32("AIItvxjkNB",10) == 1021224969) strcat(s, "i");
if (crc32("NeIRIbMHSLQWzG",14) == 539551929) strcat(s, "g");
if (crc32("OeEgyZxPEzolgcA",15) == 2296266816) strcat(s, "Q");
if (crc32("XztfkJNhAePqzfc",15) == 321225131) strcat(s, "o");
    return s;
}

char *devocalization_nouns() {
    char *s = calloc(15);
    if (crc32("OGxkc",5) == 303227751) strcat(s, "d");
if (crc32("QVmgSmXy",8) == 1697451868) strcat(s, "y");
if (crc32("EXUfhunfqQkDm",13) == 302594227) strcat(s, "e");
if (crc32("LRSYkxDIeUycKPs",15) == 4278813975) strcat(s, "v");
if (crc32("HlLAr",5) == 4055414494) strcat(s, "o");
if (crc32("yHrVCqgxMud",11) == 2415099932) strcat(s, "t");
if (crc32("nyfaqBkxShSsLUz",15) == 3675879809) strcat(s, "c");
if (crc32("OQMlIOFtZyol",12) == 3464330835) strcat(s, "F");
if (crc32("cHmiUsxTZTH",11) == 4214860786) strcat(s, "a");
if (crc32("LOoFd",5) == 924961761) strcat(s, "l");
if (crc32("pLioLwXYn",9) == 2601573524) strcat(s, "e");
if (crc32("YezaY",5) == 3371041702) strcat(s, "i");
if (crc32("BRFDzHqL",8) == 4259785747) strcat(s, "z");
if (crc32("PgGTbbQYM",9) == 2713427967) strcat(s, "O");
if (crc32("gTNMeNl",7) == 2923284239) strcat(s, "a");
if (crc32("FmGkBBDV",8) == 3356553846) strcat(s, "t");
if (crc32("fcVidsOiaalmRBe",15) == 2206942948) strcat(s, "i");
if (crc32("OJRRiq",6) == 3230594369) strcat(s, "o");
if (crc32("LOAORQ",6) == 3500125729) strcat(s, "a");
if (crc32("JpZdNmj",7) == 3085071056) strcat(s, "n");
    return s;
}

char *uncooperativeness_nouns() {
    char *s = calloc(18);
    if (crc32("BYuMpVfbEhmbLU",14) == 2431626795) strcat(s, "u");
if (crc32("MbevuKZhEaLfs",13) == 3591059158) strcat(s, "n");
if (crc32("fyKuqzBCwZtpabS",15) == 2771954422) strcat(s, "J");
if (crc32("gSwGBzSo",8) == 1965372335) strcat(s, "c");
if (crc32("WeYKxtCYEAGl",12) == 447883039) strcat(s, "t");
if (crc32("cnwMdwDN",8) == 3053458975) strcat(s, "o");
if (crc32("xABeIelgtMXt",12) == 3229839845) strcat(s, "o");
if (crc32("XCqaLLwSCHzomvb",15) == 3022533768) strcat(s, "p");
if (crc32("fEgDWnWezVh",11) == 941971411) strcat(s, "U");
if (crc32("tVPIvMgrEByv",12) == 1190707043) strcat(s, "e");
if (crc32("aBbsPhAraOo",11) == 2968970146) strcat(s, "r");
if (crc32("MBIeTebFSTq",11) == 4012823150) strcat(s, "k");
if (crc32("JwKVVvNL",8) == 2314601601) strcat(s, "a");
if (crc32("aSJLrhlSipkeQ",13) == 2210072724) strcat(s, "t");
if (crc32("qrLDmhy",7) == 3692995149) strcat(s, "i");
if (crc32("kPSZdOVBwk",10) == 2322811070) strcat(s, "v");
if (crc32("ZZjtwMcYUXMupg",14) == 1883675955) strcat(s, "q");
if (crc32("OBDnkUIbGcyn",12) == 2610572613) strcat(s, "e");
if (crc32("BAcZK",5) == 4220890715) strcat(s, "r");
if (crc32("umtolRBN",8) == 2915119494) strcat(s, "n");
if (crc32("NhathSJpYAlUiv",14) == 2004053099) strcat(s, "e");
if (crc32("IjVaTADWNCbBC",13) == 986360245) strcat(s, "s");
if (crc32("UUxPiRCkgUsJ",12) == 867279962) strcat(s, "u");
if (crc32("VxHye",5) == 1649856021) strcat(s, "s");
    return s;
}

char *Kropotkin_nouns() {
    char *s = calloc(10);
    if (crc32("YZLTTb",6) == 3351890901) strcat(s, "h");
if (crc32("VNlSt",5) == 2374593422) strcat(s, "K");
if (crc32("ruaPzErvitmISy",14) == 1799129623) strcat(s, "P");
if (crc32("RPPUvgDVxd",10) == 803587317) strcat(s, "r");
if (crc32("IxTpiaoSvYgRg",13) == 3828716469) strcat(s, "o");
if (crc32("gaKvkErSQvejmw",14) == 2189125697) strcat(s, "q");
if (crc32("xPWOiNSmFW",10) == 2605023090) strcat(s, "p");
if (crc32("cuvSwvduHB",10) == 1037385194) strcat(s, "o");
if (crc32("erbbeKjlxOmSf",13) == 2349632707) strcat(s, "Y");
if (crc32("yCIER",5) == 3428958119) strcat(s, "t");
if (crc32("JnLsS",5) == 955225749) strcat(s, "Q");
if (crc32("hdAHIEKH",8) == 1318437152) strcat(s, "k");
if (crc32("HHMQElOod",9) == 2846499924) strcat(s, "i");
if (crc32("KdnDsDNwgIF",11) == 3563728097) strcat(s, "n");
    return s;
}

char *publicist_nouns() {
    char *s = calloc(10);
    if (crc32("eBpdoPNSuZFfbY",14) == 1051982136) strcat(s, "M");
if (crc32("PjIybjIRsefms",13) == 656863093) strcat(s, "p");
if (crc32("mrKwzPclh",9) == 3060327148) strcat(s, "U");
if (crc32("dAWrrqBSna",10) == 3390018280) strcat(s, "u");
if (crc32("UvtRvHQWHAzt",12) == 3192256226) strcat(s, "w");
if (crc32("yIWrDRZtPcAyw",13) == 4022938082) strcat(s, "b");
if (crc32("jkDsyWFrbSHa",12) == 1193742180) strcat(s, "n");
if (crc32("YGVUAq",6) == 987889422) strcat(s, "l");
if (crc32("eYQSYMYAExqKf",13) == 2495490767) strcat(s, "i");
if (crc32("USDQq",5) == 475537225) strcat(s, "c");
if (crc32("FMKIvr",6) == 1016099641) strcat(s, "i");
if (crc32("UFLCQhLpX",9) == 609458741) strcat(s, "r");
if (crc32("GWGwruxKVmMdL",13) == 2496940037) strcat(s, "s");
if (crc32("rCkOYLlAZAyv",12) == 1341743639) strcat(s, "a");
if (crc32("pLCjbRIOe",9) == 59822167) strcat(s, "t");
    return s;
}

char *Prochoras_nouns() {
    char *s = calloc(10);
    if (crc32("phlfgOUrzXlRRp",14) == 3399878430) strcat(s, "P");
if (crc32("WFSvCFODhl",10) == 1113647742) strcat(s, "r");
if (crc32("IrExKjFvb",9) == 2964680397) strcat(s, "p");
if (crc32("MSkKSOABZr",10) == 4140593730) strcat(s, "o");
if (crc32("CqPoKGZozoamc",13) == 285619288) strcat(s, "V");
if (crc32("fjAGbT",6) == 3512539869) strcat(s, "c");
if (crc32("djXNnG",6) == 2522781342) strcat(s, "h");
if (crc32("EvnyNBJZJOe",11) == 713290302) strcat(s, "f");
if (crc32("PxfZycadhRLs",12) == 2600158214) strcat(s, "o");
if (crc32("LKbQPRhl",8) == 1346787522) strcat(s, "r");
if (crc32("wJvWoEQvAtzxe",13) == 3449258992) strcat(s, "L");
if (crc32("oqUGRiDNtiw",11) == 3457315087) strcat(s, "a");
if (crc32("ZFNfWXFrobqYZ",13) == 3896528973) strcat(s, "g");
if (crc32("PQENFc",6) == 476684171) strcat(s, "s");
    return s;
}

char *dialectology_nouns() {
    char *s = calloc(13);
    if (crc32("pEaFEgC",7) == 2273603575) strcat(s, "d");
if (crc32("endnBdhsHsrVsN",14) == 1694428147) strcat(s, "G");
if (crc32("cPJlCWQ",7) == 3544518858) strcat(s, "i");
if (crc32("pYRILrvuYOrq",12) == 2614540458) strcat(s, "L");
if (crc32("KACxFHAyvy",10) == 2904185265) strcat(s, "a");
if (crc32("AkbTlRvwyuEir",13) == 1492480319) strcat(s, "F");
if (crc32("ktIvr",5) == 1958280869) strcat(s, "l");
if (crc32("LAElflabfJ",10) == 1820782472) strcat(s, "e");
if (crc32("JmbUOoxIbnXq",12) == 2999696991) strcat(s, "H");
if (crc32("sVgIikwgaubsMr",14) == 3398108320) strcat(s, "c");
if (crc32("XOEyuB",6) == 1162447607) strcat(s, "g");
if (crc32("xOMeYZ",6) == 1270167115) strcat(s, "t");
if (crc32("yqyZIaVhnsruhL",14) == 876361421) strcat(s, "B");
if (crc32("lRyOIUCglMxkYLJ",15) == 3575585708) strcat(s, "o");
if (crc32("mUivXlmlC",9) == 2327300182) strcat(s, "l");
if (crc32("SSPFSi",6) == 3736022422) strcat(s, "k");
if (crc32("CrDEplFYVgzEiU",14) == 2604200407) strcat(s, "o");
if (crc32("PtYlT",5) == 1196804658) strcat(s, "d");
if (crc32("qxHDGBD",7) == 2329699556) strcat(s, "g");
if (crc32("hbxCf",5) == 1539395525) strcat(s, "Z");
if (crc32("jNktzjXmwkf",11) == 4238198793) strcat(s, "y");
    return s;
}

char *Sarette_nouns() {
    char *s = calloc(8);
    if (crc32("aHnilcrLAnqDK",13) == 527316571) strcat(s, "x");
if (crc32("fnhzOySkWlnA",12) == 430109882) strcat(s, "S");
if (crc32("TpXcb",5) == 738274457) strcat(s, "V");
if (crc32("ZbVjoPkLqu",10) == 3254486489) strcat(s, "a");
if (crc32("EyyOQtRFHb",10) == 2211065928) strcat(s, "r");
if (crc32("LMXaulrYQqzVzG",14) == 1271908537) strcat(s, "e");
if (crc32("TfsdDfkCLYr",11) == 1204728871) strcat(s, "t");
if (crc32("BVDoAOTAJcFs",12) == 1474488342) strcat(s, "t");
if (crc32("KzajKgv",7) == 1845875336) strcat(s, "e");
    return s;
}

char *Bantam_nouns() {
    char *s = calloc(7);
    if (crc32("zxwGJfCs",8) == 350285926) strcat(s, "f");
if (crc32("TGdRTXYLSMIo",12) == 367781451) strcat(s, "B");
if (crc32("XsRSWBFNHJxcm",13) == 2848054780) strcat(s, "a");
if (crc32("gkzzBH",6) == 1581796493) strcat(s, "Y");
if (crc32("oPxZAZOrzDyYS",13) == 1825727818) strcat(s, "n");
if (crc32("hevsIWRrL",9) == 2571996973) strcat(s, "t");
if (crc32("XvxHT",5) == 2387731807) strcat(s, "t");
if (crc32("TYXaFUHEGvgl",12) == 1937826257) strcat(s, "a");
if (crc32("ZXLHUxFbLBAAum",14) == 2690891174) strcat(s, "m");
    return s;
}

char *fascist_nouns() {
    char *s = calloc(8);
    if (crc32("gChLJ",5) == 3901790604) strcat(s, "f");
if (crc32("GKhWzhSzqj",10) == 1043405394) strcat(s, "a");
if (crc32("fbdabkubPXJMyK",14) == 1043507619) strcat(s, "E");
if (crc32("rAaAscfxCzHT",12) == 1480698582) strcat(s, "s");
if (crc32("AbmcPeyWbZM",11) == 2156214115) strcat(s, "c");
if (crc32("JlgnWMXCZZW",11) == 1776168224) strcat(s, "i");
if (crc32("ShhHFWzBdT",10) == 1807822371) strcat(s, "s");
if (crc32("KeHUYilKCDJOnNO",15) == 75531276) strcat(s, "J");
if (crc32("WXOIXIfaLMAkuT",14) == 1294744520) strcat(s, "t");
    return s;
}

char *kike_nouns() {
    char *s = calloc(5);
    if (crc32("sZZVoDHqTFL",11) == 915366245) strcat(s, "k");
if (crc32("IaxVmcnHYdwHkCt",15) == 2125764234) strcat(s, "i");
if (crc32("llqSeLbBTE",10) == 531365076) strcat(s, "k");
if (crc32("sKvVWjnlYohtwpc",15) == 3061181868) strcat(s, "E");
if (crc32("TmTsBgqM",8) == 898557703) strcat(s, "e");
    return s;
}

char *hedgerow_nouns() {
    char *s = calloc(9);
    if (crc32("LsioPgbSIkGfO",13) == 1381173649) strcat(s, "r");
if (crc32("YKLPmLuAORw",11) == 3739552686) strcat(s, "h");
if (crc32("MqowE",5) == 2424404527) strcat(s, "e");
if (crc32("akeagUBrlZMQqj",14) == 2174690298) strcat(s, "d");
if (crc32("fHHdEmT",7) == 2918740236) strcat(s, "O");
if (crc32("EyKoMRobSoX",11) == 2486229448) strcat(s, "g");
if (crc32("CsTNxzFq",8) == 3648593132) strcat(s, "m");
if (crc32("gZrLvE",6) == 301285111) strcat(s, "e");
if (crc32("pOZvvkFV",8) == 2387325524) strcat(s, "r");
if (crc32("xNdaSyma",8) == 3947563955) strcat(s, "L");
if (crc32("kDsVm",5) == 3051573013) strcat(s, "o");
if (crc32("RobdNgGO",8) == 1230577514) strcat(s, "w");
    return s;
}

char *Mahican_nouns() {
    char *s = calloc(8);
    if (crc32("igwInujYx",9) == 3758675973) strcat(s, "P");
if (crc32("rUiJeG",6) == 3435837084) strcat(s, "M");
if (crc32("IvXrTWljghKP",12) == 3348942756) strcat(s, "W");
if (crc32("rSJiGPHQbTtl",12) == 949528299) strcat(s, "a");
if (crc32("tthJxgN",7) == 223190966) strcat(s, "k");
if (crc32("DgbOudRDHYR",11) == 1459639895) strcat(s, "h");
if (crc32("rZKAZLBvGE",10) == 1551017919) strcat(s, "c");
if (crc32("YwHdnf",6) == 2673890601) strcat(s, "i");
if (crc32("oZsTVUCxaPyepT",14) == 3277297059) strcat(s, "b");
if (crc32("LWIWdyb",7) == 518673448) strcat(s, "c");
if (crc32("SIUJvwLn",8) == 3358855049) strcat(s, "a");
if (crc32("XOMAHQtg",8) == 4209176318) strcat(s, "C");
if (crc32("ksdurZaNSULeKiR",15) == 1121178307) strcat(s, "n");
    return s;
}

char *Himerus_nouns() {
    char *s = calloc(8);
    if (crc32("IPsBkkbnOjVwup",14) == 228823103) strcat(s, "i");
if (crc32("ysrnbGHRU",9) == 3656079879) strcat(s, "H");
if (crc32("OAhHjqZoWCg",11) == 3696295684) strcat(s, "D");
if (crc32("LfaIFiIDDqteV",13) == 2351294906) strcat(s, "i");
if (crc32("jakEaL",6) == 621132566) strcat(s, "m");
if (crc32("dLOSeQsMewBQmba",15) == 2873353724) strcat(s, "q");
if (crc32("rQIFOSHfPlV",11) == 1874326490) strcat(s, "e");
if (crc32("cdnUnhiBuItoS",13) == 2504448924) strcat(s, "r");
if (crc32("VggIdPkVWDWOr",13) == 3624072125) strcat(s, "u");
if (crc32("BCnXlwkhhR",10) == 3979498845) strcat(s, "j");
if (crc32("PCBgclI",7) == 1064182398) strcat(s, "s");
    return s;
}

char *perspicuousness_nouns() {
    char *s = calloc(16);
    if (crc32("lPuhf",5) == 3206854962) strcat(s, "u");
if (crc32("VIhxt",5) == 1629947522) strcat(s, "p");
if (crc32("geHpGAj",7) == 984503203) strcat(s, "U");
if (crc32("XTItg",5) == 1843402148) strcat(s, "e");
if (crc32("zSFotpmPSukoCu",14) == 2571685362) strcat(s, "O");
if (crc32("BfsIlvEyiRoPG",13) == 511543309) strcat(s, "r");
if (crc32("VhTCYbDfKoSuy",13) == 1316229588) strcat(s, "s");
if (crc32("cWqRIZcPQFvwqt",14) == 1550248115) strcat(s, "p");
if (crc32("stNglKEdpzsDdY",14) == 2980207479) strcat(s, "i");
if (crc32("FWUsQcbUEW",10) == 1421050136) strcat(s, "G");
if (crc32("wsLjxqQxTahEsR",14) == 2692850973) strcat(s, "c");
if (crc32("SIBapHeHrK",10) == 1748378828) strcat(s, "u");
if (crc32("xBooqVcrYdFcoIW",15) == 2174624280) strcat(s, "o");
if (crc32("uMgcXQehqBvZU",13) == 1738557163) strcat(s, "v");
if (crc32("jJkrUuUnk",9) == 3208214483) strcat(s, "u");
if (crc32("eljMKkHqYezu",12) == 1997455446) strcat(s, "h");
if (crc32("jMtMEzvpIfr",11) == 4272889169) strcat(s, "s");
if (crc32("tJNJpcEk",8) == 4237465525) strcat(s, "n");
if (crc32("LoVpUKNiP",9) == 1835310395) strcat(s, "M");
if (crc32("DucfLOQ",7) == 2752901416) strcat(s, "e");
if (crc32("ZXSVIT",6) == 3900743127) strcat(s, "s");
if (crc32("RyKKBMzPhaYiOks",15) == 3309070695) strcat(s, "L");
if (crc32("VAewZmFtYCnfPZ",14) == 1866074928) strcat(s, "s");
    return s;
}

char *Vardon_nouns() {
    char *s = calloc(7);
    if (crc32("TrDkJGCvr",9) == 1418191199) strcat(s, "V");
if (crc32("dRPiICOhYxisY",13) == 2137365484) strcat(s, "i");
if (crc32("RLpDGFQAztXbAyd",15) == 2068174695) strcat(s, "a");
if (crc32("XAvMdloRBgm",11) == 4188779833) strcat(s, "r");
if (crc32("OSuazlHFcPf",11) == 1867054940) strcat(s, "d");
if (crc32("xSGLmTVGmXOaZ",13) == 302926595) strcat(s, "o");
if (crc32("eXKPCRiEIiVnF",13) == 3292016753) strcat(s, "n");
    return s;
}

char *tearlessness_nouns() {
    char *s = calloc(13);
    if (crc32("MFQhQB",6) == 3685788430) strcat(s, "t");
if (crc32("LksDkwPTMA",10) == 3872677374) strcat(s, "e");
if (crc32("dOQcDbwpywgv",12) == 2358440308) strcat(s, "G");
if (crc32("oKpKeZb",7) == 2638125647) strcat(s, "a");
if (crc32("GUfabGZZbcmq",12) == 1104318015) strcat(s, "b");
if (crc32("XiYVkaeX",8) == 3105213001) strcat(s, "r");
if (crc32("owhIAkF",7) == 3506783246) strcat(s, "l");
if (crc32("dBjBKH",6) == 2921457340) strcat(s, "c");
if (crc32("rdRoOAOdVFVQrGu",15) == 737050004) strcat(s, "e");
if (crc32("WITBqI",6) == 4227846924) strcat(s, "s");
if (crc32("unjbbElfC",9) == 3661221816) strcat(s, "Z");
if (crc32("ONcBGdx",7) == 3748192305) strcat(s, "s");
if (crc32("vvpZbXpxpYTH",12) == 2537614201) strcat(s, "G");
if (crc32("FjnLxwyv",8) == 2990882010) strcat(s, "n");
if (crc32("daXNTUdgjlc",11) == 1494948033) strcat(s, "e");
if (crc32("eAueJSKJTu",10) == 1044585064) strcat(s, "s");
if (crc32("bHojP",5) == 227186762) strcat(s, "x");
if (crc32("zArkncKoYpndaX",14) == 3466060841) strcat(s, "s");
    return s;
}

char *stoup_nouns() {
    char *s = calloc(6);
    if (crc32("uQGUznNYqNexoVw",15) == 1770495069) strcat(s, "N");
if (crc32("lVkxhtSDnLtvoK",14) == 3757609206) strcat(s, "s");
if (crc32("BNssPACQRWRrQUW",15) == 1705658552) strcat(s, "t");
if (crc32("fHEyDXUCKR",10) == 3338224192) strcat(s, "o");
if (crc32("xwWozfOqbOUNN",13) == 4147373978) strcat(s, "e");
if (crc32("zifZbQ",6) == 3147362758) strcat(s, "u");
if (crc32("mMfwoWThgtNuU",13) == 1469409419) strcat(s, "p");
    return s;
}

char *overcircumspection_nouns() {
    char *s = calloc(19);
    if (crc32("JRVsXUPrBpwGWhs",15) == 3754089268) strcat(s, "o");
if (crc32("GjSKX",5) == 1621998530) strcat(s, "v");
if (crc32("pXsVjsj",7) == 771269419) strcat(s, "e");
if (crc32("ocSCLeEv",8) == 3897090753) strcat(s, "r");
if (crc32("ugJuwImRBBNM",12) == 676600945) strcat(s, "c");
if (crc32("GonRjgGUrDRd",12) == 1903522218) strcat(s, "T");
if (crc32("UWFLJzVLeesK",12) == 904075029) strcat(s, "i");
if (crc32("jGmjningIKojLPO",15) == 3797840245) strcat(s, "r");
if (crc32("CFedSWvImDYR",12) == 3507766432) strcat(s, "c");
if (crc32("oifSD",5) == 3936493682) strcat(s, "Y");
if (crc32("pLzap",5) == 2612475403) strcat(s, "u");
if (crc32("EcSeU",5) == 3308522683) strcat(s, "V");
if (crc32("MztpTDbUCFd",11) == 1417532196) strcat(s, "m");
if (crc32("GRbgBGNrF",9) == 2657343555) strcat(s, "s");
if (crc32("szFZBpCwy",9) == 966481760) strcat(s, "J");
if (crc32("BkGwfVltQ",9) == 3800156171) strcat(s, "p");
if (crc32("QMTdEOVvUXFZwQL",15) == 940304818) strcat(s, "e");
if (crc32("NxJbCkWsslE",11) == 2926945119) strcat(s, "c");
if (crc32("iAYCaNRRqcJXh",13) == 2022605121) strcat(s, "t");
if (crc32("hRoUDPRAC",9) == 956105594) strcat(s, "i");
if (crc32("OHPrzXZaMw",10) == 475683486) strcat(s, "K");
if (crc32("aDxdSmVblTVt",12) == 3817016902) strcat(s, "o");
if (crc32("hLZaMuvDP",9) == 3042406684) strcat(s, "f");
if (crc32("ZlHmmd",6) == 3291908212) strcat(s, "n");
    return s;
}

char *crouton_nouns() {
    char *s = calloc(8);
    if (crc32("EjNXHzeELcvS",12) == 1116295009) strcat(s, "c");
if (crc32("ChDZQZDMclz",11) == 2117486984) strcat(s, "r");
if (crc32("bMQxmteMFP",10) == 3380123790) strcat(s, "x");
if (crc32("pJDhETtvIUGDvpu",15) == 3986851521) strcat(s, "o");
if (crc32("JGEAJw",6) == 467128104) strcat(s, "u");
if (crc32("BSkHpViizLgo",12) == 3617831419) strcat(s, "u");
if (crc32("gyXSG",5) == 3766884090) strcat(s, "t");
if (crc32("YdLjhRKt",8) == 3083551961) strcat(s, "R");
if (crc32("ZqBqMzdjXtJaNd",14) == 2695430972) strcat(s, "o");
if (crc32("eFbyshx",7) == 3652028722) strcat(s, "K");
if (crc32("mKzAkiOLPrp",11) == 2596026324) strcat(s, "n");
    return s;
}

char *franker_nouns() {
    char *s = calloc(8);
    if (crc32("fZuRJwWi",8) == 2389033682) strcat(s, "S");
if (crc32("KSuWWjQ",7) == 3693020794) strcat(s, "f");
if (crc32("ZmHsiAwlhIiKH",13) == 1446375242) strcat(s, "n");
if (crc32("KcjOVaB",7) == 3387985110) strcat(s, "r");
if (crc32("xSgOb",5) == 2805196006) strcat(s, "N");
if (crc32("eWAdyN",6) == 1613225501) strcat(s, "a");
if (crc32("duThuEWxLQB",11) == 1812205289) strcat(s, "r");
if (crc32("LgBhV",5) == 2715992367) strcat(s, "n");
if (crc32("PCtib",5) == 440584180) strcat(s, "w");
if (crc32("ZegbeL",6) == 3343331490) strcat(s, "k");
if (crc32("iBnUNSUcvv",10) == 3437861440) strcat(s, "T");
if (crc32("dxKRFdKt",8) == 2081214102) strcat(s, "e");
if (crc32("UuOwVZ",6) == 690299870) strcat(s, "r");
    return s;
}

char *untragicalness_nouns() {
    char *s = calloc(15);
    if (crc32("FdRaNoWZNIci",12) == 4001401208) strcat(s, "u");
if (crc32("rIyEt",5) == 577375935) strcat(s, "n");
if (crc32("jWKqUMrTspqO",12) == 2896720243) strcat(s, "W");
if (crc32("AOAzOxqctIJHq",13) == 3912616130) strcat(s, "t");
if (crc32("TUExUkrfB",9) == 3320269854) strcat(s, "r");
if (crc32("JPTpkZaB",8) == 3663322127) strcat(s, "I");
if (crc32("vXjwppoCKjMxtl",14) == 1979154501) strcat(s, "a");
if (crc32("GPEAFPxIqXYhgMb",15) == 2594588447) strcat(s, "g");
if (crc32("kKiTXxJFOROFt",13) == 2193001449) strcat(s, "i");
if (crc32("ILYFMemLiAFGLQg",15) == 1619961223) strcat(s, "P");
if (crc32("GKbEYYkdZ",9) == 639286738) strcat(s, "c");
if (crc32("lWnCSMzskD",10) == 18103023) strcat(s, "a");
if (crc32("wjNAibB",7) == 1107323004) strcat(s, "n");
if (crc32("TRQcJ",5) == 3742534994) strcat(s, "l");
if (crc32("MqGnbdantNbl",12) == 2272907801) strcat(s, "n");
if (crc32("DFVZBrvLYH",10) == 681002250) strcat(s, "e");
if (crc32("EhxTUiJIbKGrBR",14) == 281027156) strcat(s, "s");
if (crc32("fclVmVAfM",9) == 3677637107) strcat(s, "B");
if (crc32("RIrIC",5) == 4227212377) strcat(s, "s");
    return s;
}

char *iconographer_nouns() {
    char *s = calloc(13);
    if (crc32("kNndpuTqIjyMDXK",15) == 3200461529) strcat(s, "i");
if (crc32("WkvRIOiRnJh",11) == 1454521057) strcat(s, "c");
if (crc32("dvhnJfWRAGGH",12) == 2191958137) strcat(s, "o");
if (crc32("SqczoKDWdtb",11) == 2413233181) strcat(s, "n");
if (crc32("pQjJDRtg",8) == 339197331) strcat(s, "o");
if (crc32("ElTaiXUzgXDttd",14) == 3304700123) strcat(s, "g");
if (crc32("ShAdkFJspSKpeLY",15) == 2267082502) strcat(s, "h");
if (crc32("OaEDrbuiXEt",11) == 3638456540) strcat(s, "r");
if (crc32("gANptmwvIhZD",12) == 1945785888) strcat(s, "a");
if (crc32("LmdkLlvpqcuKGl",14) == 3615976245) strcat(s, "M");
if (crc32("RWXQLGCBy",9) == 808253769) strcat(s, "p");
if (crc32("qhQOeY",6) == 3326518360) strcat(s, "M");
if (crc32("lctbwcEeaeVE",12) == 668065900) strcat(s, "h");
if (crc32("UaSrMm",6) == 454742911) strcat(s, "t");
if (crc32("ELytAw",6) == 295189109) strcat(s, "e");
if (crc32("SgVZW",5) == 3588163318) strcat(s, "P");
if (crc32("VIcSkUqOO",9) == 928476629) strcat(s, "r");
    return s;
}

char *philter_nouns() {
    char *s = calloc(8);
    if (crc32("RKRwHTxuJJUqSXV",15) == 3116727665) strcat(s, "e");
if (crc32("kiyjNZnrtGvjXwT",15) == 2163098389) strcat(s, "p");
if (crc32("oirecrbzXuAgjSr",15) == 2011932985) strcat(s, "W");
if (crc32("pAAnNvlIURtUq",13) == 4232159591) strcat(s, "h");
if (crc32("uIZusRn",7) == 1360615698) strcat(s, "i");
if (crc32("goGHXTaKaoN",11) == 662244388) strcat(s, "l");
if (crc32("XQBzedAqvJqn",12) == 4219144900) strcat(s, "E");
if (crc32("oXJQRQarAaqxWBV",15) == 1141586184) strcat(s, "t");
if (crc32("dsvJWSL",7) == 1779916488) strcat(s, "e");
if (crc32("tEpmbilAUEH",11) == 895750709) strcat(s, "r");
    return s;
}

char *overcapitalisation_nouns() {
    char *s = calloc(19);
    if (crc32("gyWsJlWvdLDg",12) == 700707361) strcat(s, "o");
if (crc32("EsXyxTpYMA",10) == 389650337) strcat(s, "Q");
if (crc32("eqPZeMjBJaOe",12) == 1810784196) strcat(s, "v");
if (crc32("ZoZpcLRmrQIj",12) == 3986633063) strcat(s, "e");
if (crc32("sQrvRgkPcn",10) == 4093990924) strcat(s, "r");
if (crc32("EePiebPv",8) == 17562699) strcat(s, "c");
if (crc32("nRPYU",5) == 2987995577) strcat(s, "p");
if (crc32("qsDMXPduRUbuQT",14) == 3846226) strcat(s, "a");
if (crc32("mRjUPPeHAR",10) == 2166007500) strcat(s, "p");
if (crc32("XmaTOSPna",9) == 1893669273) strcat(s, "i");
if (crc32("qVptwQVq",8) == 316194558) strcat(s, "t");
if (crc32("VPGekkkaPCKC",12) == 1593219975) strcat(s, "v");
if (crc32("AtdZMvObheZ",11) == 542235234) strcat(s, "a");
if (crc32("XVPPkPXIYqtQM",13) == 3822710050) strcat(s, "l");
if (crc32("YXMBo",5) == 2593665591) strcat(s, "i");
if (crc32("CVhCrhG",7) == 5380493) strcat(s, "s");
if (crc32("wjcQFZtgfVfdT",13) == 1930505024) strcat(s, "L");
if (crc32("oeBmqQiTSDFA",12) == 957408835) strcat(s, "a");
if (crc32("WbJQXFoShcUv",12) == 1320260683) strcat(s, "s");
if (crc32("VModEeAyNgGu",12) == 3038623832) strcat(s, "t");
if (crc32("OTjrTpejkNgxO",13) == 3718380259) strcat(s, "m");
if (crc32("xRlPv",5) == 747905059) strcat(s, "i");
if (crc32("PaERVP",6) == 3392228906) strcat(s, "Q");
if (crc32("DEOBRAIv",8) == 2323315371) strcat(s, "o");
if (crc32("tVqAtquxMDWN",12) == 2529944336) strcat(s, "n");
    return s;
}

char *uranite_nouns() {
    char *s = calloc(8);
    if (crc32("xjduXXao",8) == 1526405758) strcat(s, "u");
if (crc32("SjXBzValbhq",11) == 1748268300) strcat(s, "r");
if (crc32("TAlpSkAWUcMj",12) == 717968343) strcat(s, "a");
if (crc32("uFdxDMWf",8) == 3247519899) strcat(s, "n");
if (crc32("YaxMYhGuZu",10) == 33247598) strcat(s, "i");
if (crc32("zPFEYCqLx",9) == 906510269) strcat(s, "w");
if (crc32("QOfXRIqSPjmou",13) == 3485694404) strcat(s, "t");
if (crc32("QWQnA",5) == 38819285) strcat(s, "e");
    return s;
}

char *urbanisation_nouns() {
    char *s = calloc(13);
    if (crc32("yULhwDJKGe",10) == 2796176032) strcat(s, "u");
if (crc32("MHeIGDOrFqAjC",13) == 2950616748) strcat(s, "k");
if (crc32("ZWQPFgvFUjOUmI",14) == 2429447991) strcat(s, "r");
if (crc32("hCUqJhKYnJkBVjo",15) == 2886992950) strcat(s, "b");
if (crc32("xGNWXEH",7) == 3689127231) strcat(s, "F");
if (crc32("uakDE",5) == 2729120539) strcat(s, "a");
if (crc32("HJDKwtqrPwpP",12) == 1043141619) strcat(s, "T");
if (crc32("MEKOTixc",8) == 1317129466) strcat(s, "n");
if (crc32("MmCRaMgFk",9) == 1248383079) strcat(s, "i");
if (crc32("XJLZsyJvoW",10) == 2162749451) strcat(s, "G");
if (crc32("gfFus",5) == 472819928) strcat(s, "s");
if (crc32("JUzzf",5) == 14020850) strcat(s, "a");
if (crc32("nGBeZFtVbem",11) == 2586793860) strcat(s, "M");
if (crc32("rhmOYLamaG",10) == 3999859746) strcat(s, "t");
if (crc32("yaEyFIOuJfDDgt",14) == 3542858941) strcat(s, "u");
if (crc32("SNceEFz",7) == 147550830) strcat(s, "i");
if (crc32("PJpXZVjcxdo",11) == 3453768087) strcat(s, "o");
if (crc32("vcswQsJKRFEE",12) == 3834540984) strcat(s, "T");
if (crc32("zrThwXcAWwawhw",14) == 1816036561) strcat(s, "n");
    return s;
}

char *hypothallus_nouns() {
    char *s = calloc(12);
    if (crc32("aoRJj",5) == 3388775330) strcat(s, "h");
if (crc32("kdGdoi",6) == 542450267) strcat(s, "y");
if (crc32("qtkCGq",6) == 1979948062) strcat(s, "D");
if (crc32("PVRdu",5) == 1586608486) strcat(s, "p");
if (crc32("ZPyydXSPyBwVbSJ",15) == 465820237) strcat(s, "o");
if (crc32("CzyZvESFtgm",11) == 3717209914) strcat(s, "D");
if (crc32("jTEERjkUHPrUSwQ",15) == 4152618535) strcat(s, "t");
if (crc32("iIWFvFLPlNfHdKN",15) == 1817715923) strcat(s, "r");
if (crc32("QHUSBgubCQXpFr",14) == 1572755244) strcat(s, "h");
if (crc32("cgTeH",5) == 387608029) strcat(s, "g");
if (crc32("hqCtTAEgezHku",13) == 278346865) strcat(s, "a");
if (crc32("GRNYX",5) == 959982460) strcat(s, "l");
if (crc32("eBwWpiLqzs",10) == 3339224706) strcat(s, "U");
if (crc32("Noiqi",5) == 132683652) strcat(s, "l");
if (crc32("giWkuyVTubuQXc",14) == 2905827608) strcat(s, "u");
if (crc32("GhzkgQl",7) == 860685698) strcat(s, "L");
if (crc32("pPfztKCPqCdJ",12) == 2002476142) strcat(s, "s");
    return s;
}

char *Avilla_nouns() {
    char *s = calloc(7);
    if (crc32("VdGfSCUOxUyq",12) == 774378222) strcat(s, "A");
if (crc32("ythnmFkbdRJ",11) == 778510441) strcat(s, "v");
if (crc32("NvwwYKFkpRd",11) == 2571890877) strcat(s, "P");
if (crc32("RpNceqvRUDmeQSz",15) == 1810936911) strcat(s, "i");
if (crc32("dyJDZYHWos",10) == 3954421663) strcat(s, "l");
if (crc32("cQvulUcvidcQY",13) == 103842559) strcat(s, "l");
if (crc32("aLSlemoDzlxp",12) == 3156301136) strcat(s, "v");
if (crc32("xciwPpPp",8) == 2978097891) strcat(s, "a");
    return s;
}

char *carburation_nouns() {
    char *s = calloc(12);
    if (crc32("fmCWKJzckUv",11) == 118838937) strcat(s, "c");
if (crc32("ysrpatD",7) == 4075863734) strcat(s, "a");
if (crc32("ogGCl",5) == 581996986) strcat(s, "J");
if (crc32("oPhSqOgbUNCyAt",14) == 3302363813) strcat(s, "r");
if (crc32("hWFxKkIn",8) == 333165263) strcat(s, "b");
if (crc32("UhtJrJUhatfEo",13) == 1576536434) strcat(s, "u");
if (crc32("WwFBowi",7) == 2618077873) strcat(s, "r");
if (crc32("VBwSvGxpf",9) == 233237300) strcat(s, "o");
if (crc32("GYePSWgCNQYsP",13) == 3175637002) strcat(s, "a");
if (crc32("rQimZWag",8) == 1719626701) strcat(s, "q");
if (crc32("jcRHiagpWbg",11) == 901081960) strcat(s, "t");
if (crc32("MIAPMghWoMYD",12) == 3907312410) strcat(s, "i");
if (crc32("gWQrZWId",8) == 3147386865) strcat(s, "o");
if (crc32("tLTwNUKLH",9) == 1227623814) strcat(s, "I");
if (crc32("YZDMxyjhQpz",11) == 3683587821) strcat(s, "n");
    return s;
}

char *kernos_nouns() {
    char *s = calloc(7);
    if (crc32("qgPRwDjkFmXo",12) == 3535365170) strcat(s, "G");
if (crc32("lAMpbNLpZyRqUDo",15) == 3620690718) strcat(s, "k");
if (crc32("vwxZzOJkL",9) == 3335934534) strcat(s, "H");
if (crc32("JtJfWyXvPrWay",13) == 3933265223) strcat(s, "e");
if (crc32("oLlHgeH",7) == 3078572062) strcat(s, "r");
if (crc32("qiftJKwsKaqt",12) == 2891816670) strcat(s, "n");
if (crc32("CbFMb",5) == 2203298427) strcat(s, "f");
if (crc32("NrEzwyFOmT",10) == 264242438) strcat(s, "o");
if (crc32("yviMrxMiAlmNtC",14) == 1787099485) strcat(s, "u");
if (crc32("mVJUMJo",7) == 3969082140) strcat(s, "s");
    return s;
}

char *federacy_nouns() {
    char *s = calloc(9);
    if (crc32("sYbLeYULQNkE",12) == 2689250141) strcat(s, "f");
if (crc32("BHMyYmYCiCM",11) == 3872948161) strcat(s, "T");
if (crc32("PWAapVtROXxFq",13) == 1387034453) strcat(s, "e");
if (crc32("ABsrN",5) == 1215739832) strcat(s, "d");
if (crc32("KGyVdiqLkH",10) == 2675129402) strcat(s, "e");
if (crc32("WnvTxuVYfmBPn",13) == 1683548194) strcat(s, "r");
if (crc32("OLhpEeXUUQOE",12) == 675931897) strcat(s, "o");
if (crc32("CyWGnV",6) == 2528462185) strcat(s, "a");
if (crc32("ksAwskKkKTgQlc",14) == 4204074350) strcat(s, "x");
if (crc32("PeVkmQxw",8) == 1342873187) strcat(s, "c");
if (crc32("IKABb",5) == 1749445464) strcat(s, "F");
if (crc32("quOzpj",6) == 1489454117) strcat(s, "y");
    return s;
}

char *rudenture_nouns() {
    char *s = calloc(10);
    if (crc32("xHCslSzcbrFSLVJ",15) == 2040752124) strcat(s, "Z");
if (crc32("DBCRuBfNYd",10) == 2882799023) strcat(s, "r");
if (crc32("iKNSQFwLgxK",11) == 1717481437) strcat(s, "u");
if (crc32("UPMyEp",6) == 255948514) strcat(s, "L");
if (crc32("aqAQGKk",7) == 3670665774) strcat(s, "d");
if (crc32("XeOVSMsQXDTsT",13) == 3398628205) strcat(s, "n");
if (crc32("czFSdE",6) == 1533192333) strcat(s, "e");
if (crc32("vJmggrmbtdUXg",13) == 156982281) strcat(s, "K");
if (crc32("EPXGvJ",6) == 1111768897) strcat(s, "n");
if (crc32("ocdeSZ",6) == 1988283987) strcat(s, "t");
if (crc32("KortAqUX",8) == 738810148) strcat(s, "m");
if (crc32("FjvccW",6) == 73093428) strcat(s, "u");
if (crc32("hAuVfr",6) == 3371040459) strcat(s, "x");
if (crc32("RymKMERyjezDv",13) == 1609764776) strcat(s, "r");
if (crc32("gZehhvINJRMZbe",14) == 3340514304) strcat(s, "V");
if (crc32("FpTAauxpF",9) == 3869131062) strcat(s, "e");
    return s;
}

char *circuitousness_nouns() {
    char *s = calloc(15);
    if (crc32("xkGwK",5) == 4004785989) strcat(s, "C");
if (crc32("ocMBEoZKKYvR",12) == 1053357145) strcat(s, "c");
if (crc32("JzyWmCORJy",10) == 2127235433) strcat(s, "i");
if (crc32("uIQArAbGgagu",12) == 145299409) strcat(s, "m");
if (crc32("cqZVjDvypTRiI",13) == 2198641453) strcat(s, "r");
if (crc32("iyJAKXz",7) == 553244846) strcat(s, "c");
if (crc32("KEAcubFKpFBr",12) == 3833241515) strcat(s, "u");
if (crc32("SVeWCzeQNgDbS",13) == 1172458229) strcat(s, "i");
if (crc32("OpRHPOUYR",9) == 1664910409) strcat(s, "t");
if (crc32("LnZXsr",6) == 2472282227) strcat(s, "o");
if (crc32("UolfEWG",7) == 1267681119) strcat(s, "P");
if (crc32("jnijSCvAmmIun",13) == 2674988556) strcat(s, "u");
if (crc32("pDdToJ",6) == 2232285836) strcat(s, "s");
if (crc32("LowYgxDjgfty",12) == 2369202710) strcat(s, "s");
if (crc32("kitckk",6) == 1923302185) strcat(s, "N");
if (crc32("HVbhDFiawzh",11) == 2070386407) strcat(s, "n");
if (crc32("VIiZb",5) == 864264132) strcat(s, "e");
if (crc32("nDSoddKHaUqyXbb",15) == 1701578058) strcat(s, "s");
if (crc32("yNKOtGmfwIRl",12) == 1952338582) strcat(s, "w");
if (crc32("gwdZNpCYLFU",11) == 2977352472) strcat(s, "s");
    return s;
}

char *untumidness_nouns() {
    char *s = calloc(12);
    if (crc32("geHAsQjQCWJmL",13) == 1904806904) strcat(s, "v");
if (crc32("AipzJJWzobZF",12) == 1702675661) strcat(s, "u");
if (crc32("YIcLDyxbShvK",12) == 263599351) strcat(s, "Z");
if (crc32("LmhgBgELjSWZ",12) == 2362712659) strcat(s, "n");
if (crc32("oaVnTeYVHHYDBI",14) == 575012774) strcat(s, "t");
if (crc32("gtoXjiHA",8) == 534158162) strcat(s, "W");
if (crc32("QaUZbMgjrXdf",12) == 2192081328) strcat(s, "u");
if (crc32("GXsisTPtHSKO",12) == 549491406) strcat(s, "m");
if (crc32("BJfDHFWKeb",10) == 824320352) strcat(s, "i");
if (crc32("XVtxgjIFZLnjl",13) == 1868253233) strcat(s, "d");
if (crc32("hdOwPyKK",8) == 3465009756) strcat(s, "n");
if (crc32("poekqTkHm",9) == 2527176919) strcat(s, "u");
if (crc32("oalcR",5) == 3567435039) strcat(s, "e");
if (crc32("cFwAmux",7) == 134114459) strcat(s, "G");
if (crc32("WrWsoqv",7) == 42248327) strcat(s, "s");
if (crc32("NASpF",5) == 3651895290) strcat(s, "H");
if (crc32("FwIGQockn",9) == 780039856) strcat(s, "s");
    return s;
}

char *midst_nouns() {
    char *s = calloc(6);
    if (crc32("WQzEyOgeLt",10) == 3809449784) strcat(s, "m");
if (crc32("ZnxjJ",5) == 519047032) strcat(s, "w");
if (crc32("hIXwZLKDrTi",11) == 4119246418) strcat(s, "i");
if (crc32("RVwOlzniXJ",10) == 602665235) strcat(s, "s");
if (crc32("vscPFDnHmnPnzi",14) == 3147246201) strcat(s, "d");
if (crc32("wUzjpmTi",8) == 183007736) strcat(s, "s");
if (crc32("lwARP",5) == 4273372321) strcat(s, "t");
    return s;
}

char *Weywadt_nouns() {
    char *s = calloc(8);
    if (crc32("qrTrLbTcQGfV",12) == 2139131529) strcat(s, "x");
if (crc32("VjUXNI",6) == 1192312450) strcat(s, "W");
if (crc32("oxbylwNBx",9) == 1411475400) strcat(s, "n");
if (crc32("lXeHZPHy",8) == 462654927) strcat(s, "e");
if (crc32("UEDGwnJz",8) == 1198765404) strcat(s, "p");
if (crc32("LksHpJQbovYMyW",14) == 508003182) strcat(s, "y");
if (crc32("VyccnmvHtutyZso",15) == 884581731) strcat(s, "v");
if (crc32("lKxhUkDvVuKL",12) == 123094661) strcat(s, "w");
if (crc32("xdSXHuvrCXZ",11) == 2837148983) strcat(s, "A");
if (crc32("kxDMVrmvpal",11) == 2298528757) strcat(s, "a");
if (crc32("gsycZsNOGdBKwa",14) == 3942244646) strcat(s, "R");
if (crc32("FnrYXxQxuRkLT",13) == 3231902725) strcat(s, "d");
if (crc32("JvwPtSP",7) == 1511610549) strcat(s, "e");
if (crc32("RgfaoFgkDInb",12) == 2741490693) strcat(s, "t");
    return s;
}

char *loyalty_nouns() {
    char *s = calloc(8);
    if (crc32("qeFdPHOfzaATW",13) == 2731530042) strcat(s, "A");
if (crc32("oXsAyB",6) == 788435616) strcat(s, "l");
if (crc32("hOtTTzbFoyzvvsh",15) == 1322238634) strcat(s, "f");
if (crc32("JAhMqHF",7) == 2332275491) strcat(s, "o");
if (crc32("DvpTUqv",7) == 2832951319) strcat(s, "y");
if (crc32("nplNru",6) == 3891767354) strcat(s, "x");
if (crc32("xKZlcezCZ",9) == 4210069766) strcat(s, "a");
if (crc32("HUbGRWU",7) == 1191629047) strcat(s, "R");
if (crc32("plYWzcFMxxo",11) == 3352322900) strcat(s, "l");
if (crc32("oaNfhnzlEAbaU",13) == 1195177619) strcat(s, "t");
if (crc32("orVYWjOznUfKKJI",15) == 3453397095) strcat(s, "y");
    return s;
}

char *Tarija_nouns() {
    char *s = calloc(7);
    if (crc32("muNpcpITYoip",12) == 1961986501) strcat(s, "T");
if (crc32("aXhOhx",6) == 1747252106) strcat(s, "w");
if (crc32("lkYUQGYiQTk",11) == 1449323000) strcat(s, "a");
if (crc32("bYObmO",6) == 740516064) strcat(s, "p");
if (crc32("zDkrEbmd",8) == 1958889607) strcat(s, "r");
if (crc32("mQIBetLiZzLh",12) == 3065849507) strcat(s, "A");
if (crc32("onpSRptY",8) == 2950699207) strcat(s, "i");
if (crc32("iqtTIJSGQLaalNf",15) == 2277902840) strcat(s, "m");
if (crc32("wyqESqOOvBqy",12) == 3024754134) strcat(s, "j");
if (crc32("JRxClVWkpXj",11) == 2807539890) strcat(s, "m");
if (crc32("uwpinRTst",9) == 1190302589) strcat(s, "a");
    return s;
}

char *mermaid_nouns() {
    char *s = calloc(8);
    if (crc32("rCmttoyC",8) == 4034008488) strcat(s, "m");
if (crc32("lKWdabYqMbXPxm",14) == 1383710054) strcat(s, "O");
if (crc32("uezHtIRek",9) == 683259867) strcat(s, "e");
if (crc32("akIQIngmhj",10) == 237141809) strcat(s, "Z");
if (crc32("NketnT",6) == 2718603418) strcat(s, "r");
if (crc32("rWLsmdUKj",9) == 200777022) strcat(s, "U");
if (crc32("MLOuiplNPIu",11) == 1210826738) strcat(s, "m");
if (crc32("UTqtI",5) == 1675520242) strcat(s, "a");
if (crc32("xgjSjhDigQqvYcn",15) == 811374848) strcat(s, "i");
if (crc32("SbYIkDDRKW",10) == 2493781609) strcat(s, "M");
if (crc32("pWCxYF",6) == 391541562) strcat(s, "d");
    return s;
}

char *Gi_nouns() {
    char *s = calloc(3);
    if (crc32("FdXmQpFb",8) == 1451863539) strcat(s, "G");
if (crc32("WbpdOxIrGSE",11) == 1744844876) strcat(s, "i");
    return s;
}

char *nonnegativity_nouns() {
    char *s = calloc(14);
    if (crc32("uNYxOA",6) == 3218648210) strcat(s, "C");
if (crc32("ZOjMeNjZkkR",11) == 972200550) strcat(s, "n");
if (crc32("gnXPECqJGfZ",11) == 3509280106) strcat(s, "i");
if (crc32("jsCIpgOsqZ",10) == 2458533592) strcat(s, "o");
if (crc32("XKddzYarkQNN",12) == 3372001185) strcat(s, "T");
if (crc32("XKHVEjxgmoEYK",13) == 605323735) strcat(s, "n");
if (crc32("RTdCVHQJ",8) == 3874026849) strcat(s, "V");
if (crc32("ZHATGdEpKEcS",12) == 3821305955) strcat(s, "n");
if (crc32("fgijlanKfrf",11) == 1707666990) strcat(s, "e");
if (crc32("pPJrAxwJUv",10) == 1557277779) strcat(s, "e");
if (crc32("elJpx",5) == 3941388149) strcat(s, "g");
if (crc32("LmpDjNE",7) == 1778739760) strcat(s, "a");
if (crc32("CcsPUa",6) == 248712673) strcat(s, "t");
if (crc32("ZcyrJujuCcR",11) == 2305776285) strcat(s, "T");
if (crc32("laYYTsdhzjwKfgp",15) == 3924581460) strcat(s, "i");
if (crc32("GwXcQn",6) == 2783958486) strcat(s, "v");
if (crc32("yZHCKBUDOhXWx",13) == 3858989658) strcat(s, "r");
if (crc32("YRdEIogAr",9) == 599820941) strcat(s, "i");
if (crc32("QhhcDErren",10) == 3539916086) strcat(s, "l");
if (crc32("tskxsj",6) == 2159255538) strcat(s, "t");
if (crc32("wdnUpxxEJfuW",12) == 839651431) strcat(s, "r");
if (crc32("ZduRy",5) == 4088077526) strcat(s, "y");
    return s;
}

char *Ingleborough_nouns() {
    char *s = calloc(13);
    if (crc32("aCcjEb",6) == 902189953) strcat(s, "J");
if (crc32("OHSKv",5) == 2251332217) strcat(s, "I");
if (crc32("BSHLgJA",7) == 997604950) strcat(s, "n");
if (crc32("nSEGsJMyLyUyWq",14) == 301444932) strcat(s, "g");
if (crc32("LrJGggiOybHMhw",14) == 3118390040) strcat(s, "l");
if (crc32("ODoWUVIQ",8) == 4109816115) strcat(s, "f");
if (crc32("fYMxp",5) == 2851383689) strcat(s, "e");
if (crc32("xyrZGpEW",8) == 2099104983) strcat(s, "b");
if (crc32("MuoTVDwbfFC",11) == 1060159498) strcat(s, "o");
if (crc32("OSiPosoXLmIv",12) == 3829723380) strcat(s, "Z");
if (crc32("DKQBgNC",7) == 2960043378) strcat(s, "r");
if (crc32("qmknvSNZhgR",11) == 3299467113) strcat(s, "o");
if (crc32("fkVDzRbmks",10) == 3517481851) strcat(s, "o");
if (crc32("acvtT",5) == 1019923696) strcat(s, "u");
if (crc32("swGeFcKjJjXWOaI",15) == 332860019) strcat(s, "l");
if (crc32("JhUaHefcpkgh",12) == 974323199) strcat(s, "g");
if (crc32("buLRlSl",7) == 3002188581) strcat(s, "l");
if (crc32("vUkklf",6) == 1500953537) strcat(s, "h");
    return s;
}

char *Shawn_nouns() {
    char *s = calloc(6);
    if (crc32("JusswOSyr",9) == 3225404939) strcat(s, "X");
if (crc32("CUjoIAFtmo",10) == 1057674368) strcat(s, "S");
if (crc32("vwyfq",5) == 3630394893) strcat(s, "u");
if (crc32("RnLtFinmSyAOM",13) == 4004441176) strcat(s, "h");
if (crc32("CpmJAhIZDG",10) == 1167582361) strcat(s, "a");
if (crc32("LCKihGuxHctXIU",14) == 318631591) strcat(s, "a");
if (crc32("WnFZjQnuKurmODh",15) == 563257443) strcat(s, "w");
if (crc32("qUvfGRneBj",10) == 3367843518) strcat(s, "s");
if (crc32("BXMyzjHMRleDjp",14) == 1463567593) strcat(s, "n");
    return s;
}

char *Greenville_nouns() {
    char *s = calloc(11);
    if (crc32("pZNKGvsGdj",10) == 1287801395) strcat(s, "G");
if (crc32("QTDGMAXNsaN",11) == 3945499337) strcat(s, "r");
if (crc32("ZKnCMcutbkOjON",14) == 1366990812) strcat(s, "A");
if (crc32("ZGeOxEBK",8) == 1500076070) strcat(s, "e");
if (crc32("JpvNPPP",7) == 194745684) strcat(s, "m");
if (crc32("BlLopBexs",9) == 1125745299) strcat(s, "e");
if (crc32("ZhMgx",5) == 3631312910) strcat(s, "S");
if (crc32("rCQbpSWtcpIaTrQ",15) == 3411638115) strcat(s, "n");
if (crc32("VSpfaxd",7) == 1421919762) strcat(s, "v");
if (crc32("WqxfqrSKE",9) == 4021274948) strcat(s, "i");
if (crc32("ewXROeQLodtGs",13) == 3707921799) strcat(s, "z");
if (crc32("VTMylPsNwQrQCeH",15) == 475601711) strcat(s, "l");
if (crc32("rhpCbFAFOLvX",12) == 1214627071) strcat(s, "l");
if (crc32("VSaKbiuKqfj",11) == 749240495) strcat(s, "z");
if (crc32("EATvjp",6) == 1354773891) strcat(s, "e");
    return s;
}

char *pheasant_nouns() {
    char *s = calloc(9);
    if (crc32("IpRCpXd",7) == 600021024) strcat(s, "x");
if (crc32("MrtvEL",6) == 3344146028) strcat(s, "p");
if (crc32("OFenzoqACWBFHy",14) == 792337103) strcat(s, "Z");
if (crc32("DzzzZV",6) == 164756950) strcat(s, "h");
if (crc32("nWthY",5) == 4189647860) strcat(s, "c");
if (crc32("gdJWOu",6) == 39131609) strcat(s, "e");
if (crc32("FSZNxEevnCX",11) == 2359652371) strcat(s, "y");
if (crc32("rdPfIiJOn",9) == 581878142) strcat(s, "a");
if (crc32("vndBOvhMTEwDG",13) == 2189805304) strcat(s, "s");
if (crc32("aYhcBUMChXnm",12) == 3095461346) strcat(s, "T");
if (crc32("WTqQhrnJo",9) == 1362996247) strcat(s, "a");
if (crc32("lJsNMJBrSsMBfWt",15) == 4153573868) strcat(s, "n");
if (crc32("tAFgjC",6) == 607471928) strcat(s, "Z");
if (crc32("VJplzfcIonhVFSh",15) == 1108767228) strcat(s, "t");
    return s;
}

char *Sandye_nouns() {
    char *s = calloc(7);
    if (crc32("xNvyf",5) == 1296543139) strcat(s, "o");
if (crc32("eJvaE",5) == 1232424034) strcat(s, "S");
if (crc32("bNYcEEWtGbYTEK",14) == 2026520658) strcat(s, "a");
if (crc32("vLzYddBokqEP",12) == 2957531185) strcat(s, "p");
if (crc32("CMGHFOKfLf",10) == 378948172) strcat(s, "n");
if (crc32("AIWZhK",6) == 1543415704) strcat(s, "d");
if (crc32("KyVTHE",6) == 2606399410) strcat(s, "y");
if (crc32("FssGPue",7) == 3444998236) strcat(s, "v");
if (crc32("mlZfEOpoGYhJViP",15) == 1242853364) strcat(s, "e");
    return s;
}

char *Steger_nouns() {
    char *s = calloc(7);
    if (crc32("rDrwqaOgS",9) == 476815707) strcat(s, "S");
if (crc32("LaGImHJGoyecKx",14) == 394155867) strcat(s, "n");
if (crc32("LBztqyMtgflPxc",14) == 621204267) strcat(s, "t");
if (crc32("PFeWjmdsDk",10) == 3978622489) strcat(s, "e");
if (crc32("hEXImZQGbaIuhD",14) == 192353529) strcat(s, "g");
if (crc32("GHFMICboz",9) == 4147889958) strcat(s, "e");
if (crc32("VukxDddwlzSHzVi",15) == 859005673) strcat(s, "C");
if (crc32("UhbXHhoB",8) == 4013012876) strcat(s, "r");
    return s;
}

char *plasmolysis_nouns() {
    char *s = calloc(12);
    if (crc32("syjwQxDKdQTTZ",13) == 4192196281) strcat(s, "p");
if (crc32("XuvjqzkcsAzYEKy",15) == 772295245) strcat(s, "l");
if (crc32("YuyEX",5) == 2251031847) strcat(s, "x");
if (crc32("RQfyUqCeIOwenOe",15) == 1403805534) strcat(s, "a");
if (crc32("cwRpo",5) == 3345090022) strcat(s, "Z");
if (crc32("KNBlPr",6) == 1207849618) strcat(s, "s");
if (crc32("yZEXPqsQznffq",13) == 3508236873) strcat(s, "m");
if (crc32("mCWbLnfIhtanmIf",15) == 2086158421) strcat(s, "o");
if (crc32("wTSVEmn",7) == 3194063041) strcat(s, "l");
if (crc32("jLReA",5) == 3072457314) strcat(s, "h");
if (crc32("zIWUCx",6) == 4156525492) strcat(s, "y");
if (crc32("NlmpBGKwMttMw",13) == 388621904) strcat(s, "s");
if (crc32("FzCTZQdUJluK",12) == 3334860189) strcat(s, "i");
if (crc32("GZbnacGsJp",10) == 1714382513) strcat(s, "n");
if (crc32("HSEsa",5) == 1072656393) strcat(s, "s");
    return s;
}

char *Suevian_nouns() {
    char *s = calloc(8);
    if (crc32("buKvTIQpA",9) == 2319323685) strcat(s, "v");
if (crc32("iopBJUFVIXKVpAq",15) == 1627088732) strcat(s, "S");
if (crc32("kXTCDJnWImmLL",13) == 1878318710) strcat(s, "u");
if (crc32("AsRjesKbrKDMx",13) == 313015722) strcat(s, "n");
if (crc32("FSDMhLmRXLkvr",13) == 1020239772) strcat(s, "e");
if (crc32("QxgPb",5) == 960829840) strcat(s, "v");
if (crc32("DzEpNnzNPmucDk",14) == 1471728584) strcat(s, "i");
if (crc32("HlHRIxrRWMM",11) == 1201222442) strcat(s, "y");
if (crc32("ZAlaEWFge",9) == 3460734652) strcat(s, "a");
if (crc32("JLPNUA",6) == 1194879903) strcat(s, "Q");
if (crc32("oBSsInCCRlDXo",13) == 2788011858) strcat(s, "n");
    return s;
}

char *wharve_nouns() {
    char *s = calloc(7);
    if (crc32("ZDlIA",5) == 4235361395) strcat(s, "a");
if (crc32("ihhlwwFwMVc",11) == 3162175790) strcat(s, "w");
if (crc32("gLiJnx",6) == 3743784220) strcat(s, "q");
if (crc32("pKNYsgI",7) == 911638951) strcat(s, "h");
if (crc32("XELHSPLn",8) == 120089942) strcat(s, "d");
if (crc32("dUlStsAW",8) == 4000093907) strcat(s, "a");
if (crc32("TrRDTTM",7) == 1295721443) strcat(s, "l");
if (crc32("DbopVjjt",8) == 3085974386) strcat(s, "r");
if (crc32("EErQngcxs",9) == 2503100914) strcat(s, "S");
if (crc32("MjfMrKHDoQ",10) == 3425227919) strcat(s, "v");
if (crc32("TBQwLDwzudhHb",13) == 4178772483) strcat(s, "e");
    return s;
}

char *Broder_nouns() {
    char *s = calloc(7);
    if (crc32("ClDBdplAyKNlG",13) == 408654894) strcat(s, "B");
if (crc32("YCaBBSuKQYz",11) == 2938579627) strcat(s, "r");
if (crc32("dNzsF",5) == 1189857610) strcat(s, "G");
if (crc32("zgsPFcUip",9) == 4173958795) strcat(s, "o");
if (crc32("TTaitYgh",8) == 1325844892) strcat(s, "Y");
if (crc32("KdONWaNeEQm",11) == 1405961024) strcat(s, "d");
if (crc32("lvgJEMglMecovV",14) == 2208880690) strcat(s, "F");
if (crc32("FXDvOs",6) == 2588369948) strcat(s, "e");
if (crc32("ClelgY",6) == 1458873855) strcat(s, "k");
if (crc32("BGrSxZCoywB",11) == 825359918) strcat(s, "r");
    return s;
}

char *Madurai_nouns() {
    char *s = calloc(8);
    if (crc32("YlxlhsdmWI",10) == 3625417084) strcat(s, "H");
if (crc32("YiJnyq",6) == 1635659974) strcat(s, "M");
if (crc32("zextSLamUMp",11) == 1538879033) strcat(s, "a");
if (crc32("jXfyjYtaAnACq",13) == 2025454480) strcat(s, "Z");
if (crc32("PLXtDLtuc",9) == 3277459116) strcat(s, "d");
if (crc32("ZMJOybPcs",9) == 4061400333) strcat(s, "I");
if (crc32("IUoEQZgS",8) == 2179503238) strcat(s, "u");
if (crc32("MxNbVYYYitGm",12) == 3346425142) strcat(s, "y");
if (crc32("LwULnr",6) == 1116506726) strcat(s, "r");
if (crc32("NLsxnoihIu",10) == 3282601996) strcat(s, "j");
if (crc32("ANTEzhwaYJNCru",14) == 1379095607) strcat(s, "a");
if (crc32("OtZeDemesCJG",12) == 4158486559) strcat(s, "T");
if (crc32("MurOpoIhK",9) == 23846611) strcat(s, "i");
    return s;
}

char *Monteverdi_nouns() {
    char *s = calloc(11);
    if (crc32("vGQGMypa",8) == 1315559052) strcat(s, "d");
if (crc32("vQvciTFByudFQ",13) == 2276052369) strcat(s, "M");
if (crc32("TZGCp",5) == 1367705455) strcat(s, "o");
if (crc32("iiHRklRTYOIfWP",14) == 4212068793) strcat(s, "k");
if (crc32("MGgoBmwTsos",11) == 776600254) strcat(s, "n");
if (crc32("hQbJhJZdbdXdk",13) == 3635726956) strcat(s, "t");
if (crc32("zthPtpCx",8) == 3626132006) strcat(s, "l");
if (crc32("cFNuahfyYj",10) == 520943603) strcat(s, "e");
if (crc32("EqPBHBSmPD",10) == 2197952785) strcat(s, "b");
if (crc32("YqTFm",5) == 3728207444) strcat(s, "v");
if (crc32("sJXwLrPvTNWbkmk",15) == 3519092419) strcat(s, "e");
if (crc32("yQaSgbHGTaXch",13) == 766520154) strcat(s, "x");
if (crc32("TeUGSeEgCmqAua",14) == 4002940275) strcat(s, "r");
if (crc32("IIDXzdkPpc",10) == 4092424715) strcat(s, "d");
if (crc32("YLgFOtTerfs",11) == 2580788063) strcat(s, "W");
if (crc32("FxanUInSGozDHih",15) == 2255055433) strcat(s, "i");
    return s;
}

char *pul_nouns() {
    char *s = calloc(4);
    if (crc32("WdalgYXkijUXJ",13) == 1151287489) strcat(s, "p");
if (crc32("ICFNDHOvh",9) == 2478455839) strcat(s, "u");
if (crc32("WBuPhaS",7) == 2917181486) strcat(s, "b");
if (crc32("OIlEKGbDSfJCjSu",15) == 1866504752) strcat(s, "l");
    return s;
}

char *Ikkela_nouns() {
    char *s = calloc(7);
    if (crc32("hkcbwIHeR",9) == 1037642748) strcat(s, "I");
if (crc32("WFnqgBCGsQeBC",13) == 633048144) strcat(s, "k");
if (crc32("mWdIZkFfXYh",11) == 4203070117) strcat(s, "k");
if (crc32("jHpls",5) == 531989598) strcat(s, "e");
if (crc32("ubXLPbItbSrfQYt",15) == 1233714688) strcat(s, "R");
if (crc32("JlTDuCNZdSHYuOp",15) == 1353479723) strcat(s, "l");
if (crc32("nKemKducLCwyea",14) == 4031551674) strcat(s, "x");
if (crc32("qaGkZDCpf",9) == 1642611057) strcat(s, "a");
    return s;
}

char *Francie_nouns() {
    char *s = calloc(8);
    if (crc32("YApQAtyBtTJQZPC",15) == 3958878183) strcat(s, "F");
if (crc32("SFDmhdjwlAEa",12) == 3840606178) strcat(s, "g");
if (crc32("FBwmjhxd",8) == 2443650454) strcat(s, "r");
if (crc32("WYRhtIgKlhl",11) == 3415010484) strcat(s, "H");
if (crc32("tZuSZwZKopvEio",14) == 2772528659) strcat(s, "a");
if (crc32("bQbxKRoXrdu",11) == 1557367012) strcat(s, "n");
if (crc32("WSSYudX",7) == 2287169021) strcat(s, "F");
if (crc32("WADnOTnD",8) == 1216075658) strcat(s, "c");
if (crc32("YzDKG",5) == 2063957438) strcat(s, "i");
if (crc32("LWupXmLjDRG",11) == 2149017469) strcat(s, "e");
    return s;
}

char *overfierceness_nouns() {
    char *s = calloc(15);
    if (crc32("hbbtjuWzaKZizcD",15) == 636579244) strcat(s, "Y");
if (crc32("zxDKfDh",7) == 1212492539) strcat(s, "o");
if (crc32("pTydpZ",6) == 2317060255) strcat(s, "v");
if (crc32("tDHOeYxpgStHhAQ",15) == 2604207476) strcat(s, "z");
if (crc32("yTvzvrcrHARCVK",14) == 326455570) strcat(s, "e");
if (crc32("YnHkipDPrVJaM",13) == 1469312845) strcat(s, "L");
if (crc32("IuQsF",5) == 972232604) strcat(s, "r");
if (crc32("gqlPd",5) == 2400866792) strcat(s, "f");
if (crc32("TxSfBO",6) == 1588667924) strcat(s, "i");
if (crc32("veJMruzIHthcYfq",15) == 657068049) strcat(s, "e");
if (crc32("QZoUAjCm",8) == 4242872177) strcat(s, "r");
if (crc32("WuHLr",5) == 4085133291) strcat(s, "O");
if (crc32("ZHZgJt",6) == 3229792627) strcat(s, "c");
if (crc32("KFWbedGNNyk",11) == 1724347877) strcat(s, "U");
if (crc32("yOxdGKReWdpHjbf",15) == 1120586623) strcat(s, "e");
if (crc32("bWotIBVO",8) == 2079243484) strcat(s, "n");
if (crc32("VMqFTmuG",8) == 2062211866) strcat(s, "e");
if (crc32("vCLhwEP",7) == 1330822248) strcat(s, "s");
if (crc32("aHIaVOVJLBtwnzy",15) == 343389714) strcat(s, "s");
    return s;
}

char *Bahawalpur_nouns() {
    char *s = calloc(11);
    if (crc32("MWEarvwc",8) == 1415845154) strcat(s, "h");
if (crc32("eyEzrGLnDT",10) == 1719707632) strcat(s, "B");
if (crc32("lcraxakZaR",10) == 3116989649) strcat(s, "H");
if (crc32("buOCkiBbCddYFhl",15) == 319567617) strcat(s, "a");
if (crc32("WPiNP",5) == 3618545715) strcat(s, "V");
if (crc32("wdMUx",5) == 3636782362) strcat(s, "h");
if (crc32("iBDJADZM",8) == 3818560140) strcat(s, "a");
if (crc32("oUbhUCRrFpBX",12) == 3474237591) strcat(s, "f");
if (crc32("rvuMJPaNwFjIoWu",15) == 3405895177) strcat(s, "w");
if (crc32("OxszZY",6) == 4100000878) strcat(s, "a");
if (crc32("sbnntbsGA",9) == 565645984) strcat(s, "l");
if (crc32("WWaeUoNcvjlU",12) == 415728039) strcat(s, "p");
if (crc32("QWMXc",5) == 1709316871) strcat(s, "e");
if (crc32("WnPiRddH",8) == 782814225) strcat(s, "u");
if (crc32("hCrNOxnmaMPyo",13) == 3536468988) strcat(s, "p");
if (crc32("eGNlYDmbLenH",12) == 3210835027) strcat(s, "r");
    return s;
}

char *SaintOuen_nouns() {
    char *s = calloc(10);
    if (crc32("dHIzZThy",8) == 4173189807) strcat(s, "W");
if (crc32("XlgAgmSCi",9) == 1095514310) strcat(s, "S");
if (crc32("wAfKzjImGtPFjXd",15) == 1892071602) strcat(s, "a");
if (crc32("pdBmbLKHPCZ",11) == 3745897779) strcat(s, "i");
if (crc32("pEDwYmrCfbtLdJ",14) == 1001102485) strcat(s, "n");
if (crc32("pAnKcx",6) == 1749810912) strcat(s, "t");
if (crc32("mAAlUJmTMrVwkGx",15) == 3143817853) strcat(s, "T");
if (crc32("SXikTGDa",8) == 4038216749) strcat(s, "O");
if (crc32("ZrtgPwUHdHSp",12) == 2399142551) strcat(s, "u");
if (crc32("oogESPNtiAZ",11) == 4223359413) strcat(s, "p");
if (crc32("AeFzjTdTnYc",11) == 3055054789) strcat(s, "e");
if (crc32("JhoPUEzYX",9) == 3562874923) strcat(s, "n");
    return s;
}

char *corrivalry_nouns() {
    char *s = calloc(11);
    if (crc32("WxBKEmYWar",10) == 4255214161) strcat(s, "c");
if (crc32("UnCzkRXXBrXJK",13) == 740135051) strcat(s, "v");
if (crc32("RnLLSi",6) == 3678176569) strcat(s, "o");
if (crc32("eJybGljilxlS",12) == 3308329663) strcat(s, "r");
if (crc32("HmZyHMb",7) == 2727620060) strcat(s, "r");
if (crc32("KCCZaQNog",9) == 3677651681) strcat(s, "k");
if (crc32("DGgSNKVFkqV",11) == 452103846) strcat(s, "i");
if (crc32("rYKvN",5) == 1303705903) strcat(s, "h");
if (crc32("kMbPNVAuglAK",12) == 4278021692) strcat(s, "v");
if (crc32("CkKVMEijKElzGNC",15) == 3193031809) strcat(s, "e");
if (crc32("nOUECx",6) == 1452758370) strcat(s, "a");
if (crc32("SgybIIlP",8) == 70383012) strcat(s, "l");
if (crc32("pRaAIDe",7) == 985784998) strcat(s, "M");
if (crc32("CRdydDiwaRHr",12) == 1913861325) strcat(s, "r");
if (crc32("FPAOzi",6) == 3213133733) strcat(s, "w");
if (crc32("CfNmdrfKqamB",12) == 2782467856) strcat(s, "y");
    return s;
}

char *oxazine_nouns() {
    char *s = calloc(8);
    if (crc32("pRuDNXliPCs",11) == 539616887) strcat(s, "l");
if (crc32("DgXLkmy",7) == 1550854858) strcat(s, "o");
if (crc32("FLhehGEGGQywz",13) == 4027526371) strcat(s, "n");
if (crc32("HqZpTzrbVMU",11) == 206722189) strcat(s, "x");
if (crc32("vXnaVvHYa",9) == 279115093) strcat(s, "f");
if (crc32("QoDBnWnDGDSVRW",14) == 543180523) strcat(s, "a");
if (crc32("vtLJTodXJ",9) == 1705088492) strcat(s, "z");
if (crc32("NDcdIqgqlDNbc",13) == 1193559891) strcat(s, "i");
if (crc32("EvAQIknPITsOjqm",15) == 1107964295) strcat(s, "l");
if (crc32("rAfmsqCAXe",10) == 3665644081) strcat(s, "n");
if (crc32("lMRyeYInNvN",11) == 1537624080) strcat(s, "e");
    return s;
}

char *Bruges_nouns() {
    char *s = calloc(7);
    if (crc32("kURAMUCjfniyCqp",15) == 2181316919) strcat(s, "B");
if (crc32("GFkrdl",6) == 1351075590) strcat(s, "g");
if (crc32("VElwiVJTma",10) == 2153553288) strcat(s, "r");
if (crc32("HaLISkYI",8) == 3233628881) strcat(s, "D");
if (crc32("zMRiGuXD",8) == 4280312482) strcat(s, "u");
if (crc32("gJqhGIASuyVh",12) == 571504428) strcat(s, "t");
if (crc32("wkNneeeqsHURtt",14) == 4112040590) strcat(s, "g");
if (crc32("YxsKNGERW",9) == 1734303641) strcat(s, "b");
if (crc32("pErSSgMiPMrBnDY",15) == 1362209903) strcat(s, "e");
if (crc32("WqkGP",5) == 2839042901) strcat(s, "D");
if (crc32("DeErbPKQa",9) == 1619028507) strcat(s, "s");
    return s;
}

char *Greuze_nouns() {
    char *s = calloc(7);
    if (crc32("CiszOIADJttX",12) == 1643944897) strcat(s, "N");
if (crc32("NefABbHhTS",10) == 340177249) strcat(s, "G");
if (crc32("vpoJE",5) == 2485443683) strcat(s, "r");
if (crc32("sAuVRbREC",9) == 1888014140) strcat(s, "e");
if (crc32("FyhwHJvDMrShJEq",15) == 2174925014) strcat(s, "u");
if (crc32("aatACVvseXIzVkb",15) == 2470430961) strcat(s, "z");
if (crc32("NgLrrR",6) == 3818739156) strcat(s, "n");
if (crc32("AMQGkFOoFLXqeW",14) == 1421922171) strcat(s, "e");
    return s;
}

char *bight_nouns() {
    char *s = calloc(6);
    if (crc32("hMDtUSnALgblAaL",15) == 2861524004) strcat(s, "b");
if (crc32("JAWbrBSyDegbUq",14) == 176363272) strcat(s, "i");
if (crc32("yBfsco",6) == 1694223608) strcat(s, "g");
if (crc32("cRkSrtge",8) == 533214891) strcat(s, "W");
if (crc32("KqrPWeSqFAdBuwM",15) == 2606257324) strcat(s, "h");
if (crc32("XdtMaBLMbowq",12) == 4079239425) strcat(s, "t");
    return s;
}

char *overdelicateness_nouns() {
    char *s = calloc(17);
    if (crc32("UtiiufasDDUV",12) == 468305194) strcat(s, "o");
if (crc32("NKCkBzndCA",10) == 2932327083) strcat(s, "v");
if (crc32("ItmjTc",6) == 447609741) strcat(s, "q");
if (crc32("MHYBgTzhTatGxo",14) == 4007840532) strcat(s, "e");
if (crc32("JNGhF",5) == 3907258036) strcat(s, "r");
if (crc32("rvjkcVTIl",9) == 1482198591) strcat(s, "n");
if (crc32("tZQMbXkZjY",10) == 183696095) strcat(s, "d");
if (crc32("HnsnvGy",7) == 2069927133) strcat(s, "e");
if (crc32("IWioOmvkqZe",11) == 1572953101) strcat(s, "E");
if (crc32("gsMKuUNQB",9) == 805371114) strcat(s, "l");
if (crc32("HaxnzhgjNfFs",12) == 213992823) strcat(s, "Z");
if (crc32("vGgMEDGpVZB",11) == 944635861) strcat(s, "i");
if (crc32("LyBPzHNRqP",10) == 4175898445) strcat(s, "c");
if (crc32("aJAsAL",6) == 2201921306) strcat(s, "a");
if (crc32("eCQulMBqIaSnQHM",15) == 3921846474) strcat(s, "B");
if (crc32("fyBRBgT",7) == 800327563) strcat(s, "t");
if (crc32("lFNRoWsJyxGSEa",14) == 3016051983) strcat(s, "B");
if (crc32("nBYSqMXBwBVlE",13) == 2887975979) strcat(s, "e");
if (crc32("ZCjaIQARyelH",12) == 3220414083) strcat(s, "b");
if (crc32("pjLClqm",7) == 2283996900) strcat(s, "n");
if (crc32("mhLHPJ",6) == 789794700) strcat(s, "e");
if (crc32("mSIZnofzIVUE",12) == 866137145) strcat(s, "s");
if (crc32("WtaSebfUCP",10) == 1690273763) strcat(s, "s");
    return s;
}

char *skerry_nouns() {
    char *s = calloc(7);
    if (crc32("yzsVSyMU",8) == 2022635539) strcat(s, "s");
if (crc32("apKaAWuxFSKWt",13) == 745191873) strcat(s, "k");
if (crc32("rUCcDOnop",9) == 2012546989) strcat(s, "w");
if (crc32("TEChBaEdgecihSJ",15) == 2271198919) strcat(s, "e");
if (crc32("yllUMmJVkZXRSYU",15) == 549508548) strcat(s, "d");
if (crc32("oHMChkHkxtr",11) == 1551744643) strcat(s, "r");
if (crc32("GzpURmvKqXiaQm",14) == 867988948) strcat(s, "r");
if (crc32("GkYzblWNToduunK",15) == 3133679021) strcat(s, "y");
    return s;
}

char *chloroguanide_nouns() {
    char *s = calloc(14);
    if (crc32("AvoTBKIdvT",10) == 893190171) strcat(s, "z");
if (crc32("YJonhY",6) == 379564532) strcat(s, "c");
if (crc32("QmOSJYZKSOV",11) == 1114851463) strcat(s, "h");
if (crc32("olvxoMtXffvmbt",14) == 2621246442) strcat(s, "b");
if (crc32("QOzievKIyoNFXhd",15) == 783764192) strcat(s, "l");
if (crc32("oBuhOUFhwZ",10) == 1919792092) strcat(s, "o");
if (crc32("ybhomKNjInYbXM",14) == 3992900113) strcat(s, "s");
if (crc32("FsYxRIjcQrhara",14) == 1788040063) strcat(s, "r");
if (crc32("WhZKeYnjeqaZ",12) == 1249471981) strcat(s, "o");
if (crc32("HdXvJznrcTXW",12) == 3137399) strcat(s, "g");
if (crc32("wKdgcTiF",8) == 2222742874) strcat(s, "k");
if (crc32("TiWVSVpe",8) == 2950051624) strcat(s, "u");
if (crc32("hEUGODbiXeBeNUR",15) == 4271218017) strcat(s, "a");
if (crc32("uFYOuANh",8) == 1463921345) strcat(s, "n");
if (crc32("fnuyNMlOoDJ",11) == 485504304) strcat(s, "f");
if (crc32("QBDMbwOi",8) == 2559465352) strcat(s, "i");
if (crc32("uQCSpTgYwvjuv",13) == 4251917501) strcat(s, "d");
if (crc32("MnYxMoF",7) == 3694708564) strcat(s, "z");
if (crc32("ypQsEjwVnjvhyUt",15) == 2640915252) strcat(s, "e");
    return s;
}

char *superobligation_nouns() {
    char *s = calloc(16);
    if (crc32("hxbgczSwk",9) == 2032883060) strcat(s, "s");
if (crc32("baabxhuRjmVgD",13) == 1006570293) strcat(s, "T");
if (crc32("ImSGkpRkvuqgYZA",15) == 1621719807) strcat(s, "u");
if (crc32("eBwPNxebGynLpB",14) == 2421799237) strcat(s, "p");
if (crc32("XdLhxa",6) == 894593164) strcat(s, "Y");
if (crc32("BAUpDkT",7) == 2360115293) strcat(s, "e");
if (crc32("vQrqbujvYj",10) == 2381786331) strcat(s, "c");
if (crc32("kTvtlFozB",9) == 443350109) strcat(s, "r");
if (crc32("PRSsVMpCssu",11) == 916617937) strcat(s, "o");
if (crc32("TnZiCndnMk",10) == 1176288216) strcat(s, "s");
if (crc32("XuesJjTQ",8) == 3366503421) strcat(s, "b");
if (crc32("eKNkZRXoddg",11) == 4059437546) strcat(s, "X");
if (crc32("GEPSKcGOXQClM",13) == 4177395424) strcat(s, "l");
if (crc32("iCrPXWmQ",8) == 2362930657) strcat(s, "a");
if (crc32("lDdCikW",7) == 2493518175) strcat(s, "i");
if (crc32("dtEUHd",6) == 2587332344) strcat(s, "g");
if (crc32("uZSyf",5) == 340612248) strcat(s, "d");
if (crc32("DRYKCdIUvnKB",12) == 4138272674) strcat(s, "a");
if (crc32("eCPpaZGPGEfdPn",14) == 2812097693) strcat(s, "V");
if (crc32("LXqENLOFQMPV",12) == 2752425426) strcat(s, "t");
if (crc32("KOAetPkqiBivuY",14) == 2033718524) strcat(s, "s");
if (crc32("gvCHgyJHHF",10) == 1341311973) strcat(s, "i");
if (crc32("heXuRpJEc",9) == 3810202228) strcat(s, "K");
if (crc32("tmZngAsfYrQhIj",14) == 2652402638) strcat(s, "o");
if (crc32("aZElhyf",7) == 3769872502) strcat(s, "n");
    return s;
}

char *emery_nouns() {
    char *s = calloc(6);
    if (crc32("OWcNUMqVVXmZc",13) == 2026825269) strcat(s, "E");
if (crc32("bVQLkHIOm",9) == 1896259895) strcat(s, "e");
if (crc32("IUgjirCOBEnQnh",14) == 2475735128) strcat(s, "g");
if (crc32("KUZIyt",6) == 1455437220) strcat(s, "m");
if (crc32("unpdmFU",7) == 2709117896) strcat(s, "e");
if (crc32("VkwxSq",6) == 3539673363) strcat(s, "r");
if (crc32("SujEQNarWPSeu",13) == 3892384049) strcat(s, "r");
if (crc32("aAJfnhPlZJu",11) == 3951165578) strcat(s, "y");
    return s;
}

char *Alurd_nouns() {
    char *s = calloc(6);
    if (crc32("AZxrIHa",7) == 1121143164) strcat(s, "A");
if (crc32("uNwYZcItVu",10) == 4287579268) strcat(s, "A");
if (crc32("cEvZvKj",7) == 1976710639) strcat(s, "I");
if (crc32("AJdFLDoJxlxem",13) == 1239921208) strcat(s, "l");
if (crc32("jQeRaBZwaC",10) == 3951162290) strcat(s, "u");
if (crc32("GTEVxzmj",8) == 4022824062) strcat(s, "k");
if (crc32("YqAXwLgHupTA",12) == 3523862135) strcat(s, "r");
if (crc32("qRiZxu",6) == 3554903758) strcat(s, "d");
    return s;
}

char *goaltender_nouns() {
    char *s = calloc(11);
    if (crc32("KteUjAGKjlzrc",13) == 4130159649) strcat(s, "g");
if (crc32("OsWOGRf",7) == 1526309769) strcat(s, "B");
if (crc32("fokmYwXyYoXT",12) == 1743680741) strcat(s, "o");
if (crc32("fBfSsJVNkbhX",12) == 2629191431) strcat(s, "V");
if (crc32("smutmGuAyMooO",13) == 3765554709) strcat(s, "a");
if (crc32("IrTktaCrG",9) == 3808407125) strcat(s, "c");
if (crc32("xOyYWjRKAPdQrWM",15) == 1905798815) strcat(s, "l");
if (crc32("yDNpEEQU",8) == 2481520587) strcat(s, "p");
if (crc32("IYWkWXMjBMtAgC",14) == 920542769) strcat(s, "t");
if (crc32("iKqrhBBAvdrw",12) == 4125197313) strcat(s, "E");
if (crc32("sPKoMfa",7) == 1901334606) strcat(s, "e");
if (crc32("rUoeQRDjlOMjbhY",15) == 930570678) strcat(s, "n");
if (crc32("wCNxs",5) == 1162604648) strcat(s, "z");
if (crc32("PzOEPhlpTaqj",12) == 1563798472) strcat(s, "d");
if (crc32("iblRCJf",7) == 1834984245) strcat(s, "v");
if (crc32("pzofIh",6) == 1146034669) strcat(s, "e");
if (crc32("RFcLBNGudoOCx",13) == 331871369) strcat(s, "r");
    return s;
}

char *Bruant_nouns() {
    char *s = calloc(7);
    if (crc32("qCsLvIoSQvtpsO",14) == 1477961873) strcat(s, "B");
if (crc32("qbtxCCrqojG",11) == 3411822621) strcat(s, "r");
if (crc32("lJuvoTylkfXr",12) == 1228425762) strcat(s, "U");
if (crc32("uzSnLmUlTmz",11) == 919835931) strcat(s, "u");
if (crc32("utTkCcGj",8) == 824666934) strcat(s, "a");
if (crc32("UQOFhMrdsjCgrQk",15) == 76590720) strcat(s, "f");
if (crc32("LbBhB",5) == 2363942240) strcat(s, "n");
if (crc32("joOTnTYXuFk",11) == 2484070605) strcat(s, "r");
if (crc32("cdLvIyRkHh",10) == 2877629323) strcat(s, "t");
    return s;
}

char *hypoderma_nouns() {
    char *s = calloc(10);
    if (crc32("JlnYKRAqplLe",12) == 1584730268) strcat(s, "C");
if (crc32("pCMsLgCpAThGwB",14) == 2132643979) strcat(s, "h");
if (crc32("ntouiFAs",8) == 1476154562) strcat(s, "a");
if (crc32("HDLPUmkQxVS",11) == 3781745202) strcat(s, "y");
if (crc32("MOwUhU",6) == 3487685523) strcat(s, "Y");
if (crc32("zVAJyzcl",8) == 2339700762) strcat(s, "p");
if (crc32("PHIVhVHIFNaCVj",14) == 1248731426) strcat(s, "o");
if (crc32("nnNYbo",6) == 928926072) strcat(s, "d");
if (crc32("epPWGBh",7) == 3926279058) strcat(s, "P");
if (crc32("kczVabfgoaW",11) == 3329890834) strcat(s, "e");
if (crc32("NcmnJYr",7) == 4046881079) strcat(s, "r");
if (crc32("nYaSlIwCRHYk",12) == 1032345351) strcat(s, "r");
if (crc32("SFrBaDIX",8) == 435677216) strcat(s, "n");
if (crc32("LiJbIWMppPWl",12) == 3001103782) strcat(s, "m");
if (crc32("kIUtwUzUzkHxrcN",15) == 1102821174) strcat(s, "V");
if (crc32("QSBPGRPpiMsE",12) == 2345410464) strcat(s, "a");
    return s;
}

char *pentangle_nouns() {
    char *s = calloc(10);
    if (crc32("bgWwLWMozenKMyJ",15) == 995932238) strcat(s, "p");
if (crc32("LNwXg",5) == 3504353321) strcat(s, "e");
if (crc32("UOtbfLsXSqd",11) == 6871613) strcat(s, "n");
if (crc32("uuUMtwLkotowP",13) == 721980876) strcat(s, "t");
if (crc32("CgBmHF",6) == 3306265425) strcat(s, "a");
if (crc32("FYOgll",6) == 1583577470) strcat(s, "n");
if (crc32("LzSTyiLuVOewCC",14) == 3935552282) strcat(s, "g");
if (crc32("igJmx",5) == 124897641) strcat(s, "l");
if (crc32("kaQfznE",7) == 977044067) strcat(s, "B");
if (crc32("HYsuRATOCnWXYI",14) == 419454821) strcat(s, "e");
    return s;
}

char *toucanet_nouns() {
    char *s = calloc(9);
    if (crc32("QmHtmilKv",9) == 3811834830) strcat(s, "t");
if (crc32("mKmCQrcQrrJkoN",14) == 436130770) strcat(s, "W");
if (crc32("RMXjKXOaJW",10) == 3233076618) strcat(s, "o");
if (crc32("YUYBxVYJPdUcWw",14) == 3230943774) strcat(s, "u");
if (crc32("kSAOTuWmMvg",11) == 2012782232) strcat(s, "z");
if (crc32("uOeEVRefjEPbo",13) == 991070455) strcat(s, "c");
if (crc32("ajxyv",5) == 3773516734) strcat(s, "L");
if (crc32("AgqtsSgBHjkVBc",14) == 1927875070) strcat(s, "a");
if (crc32("lgHeFi",6) == 2158050696) strcat(s, "M");
if (crc32("HuwGBhljth",10) == 615694072) strcat(s, "n");
if (crc32("GGCvXXNJcT",10) == 1699032534) strcat(s, "Q");
if (crc32("GyZvUABLMQEr",12) == 2162338511) strcat(s, "e");
if (crc32("nLbEXpzbdx",10) == 2574136304) strcat(s, "t");
    return s;
}

char *Folly_nouns() {
    char *s = calloc(6);
    if (crc32("WlxJMze",7) == 2842283529) strcat(s, "F");
if (crc32("cDcVs",5) == 463516065) strcat(s, "w");
if (crc32("AibreJjNapxArFr",15) == 4268969976) strcat(s, "o");
if (crc32("wALFgIEOr",9) == 2024069702) strcat(s, "y");
if (crc32("NcncTyAoTrrVUQw",15) == 1385554370) strcat(s, "l");
if (crc32("BRXnxQMOrYcGWt",14) == 759080950) strcat(s, "l");
if (crc32("OwYYkLzuya",10) == 2527097125) strcat(s, "B");
if (crc32("KPZrTfVT",8) == 2496999427) strcat(s, "y");
    return s;
}

char *Megara_nouns() {
    char *s = calloc(7);
    if (crc32("BfuSHifOcmk",11) == 2721128204) strcat(s, "t");
if (crc32("NtIWxxOaqzrWza",14) == 2596146505) strcat(s, "M");
if (crc32("mntBZVYb",8) == 3173194020) strcat(s, "M");
if (crc32("XaYjTuIRLkJJ",12) == 1356008487) strcat(s, "e");
if (crc32("thZLl",5) == 958438430) strcat(s, "N");
if (crc32("GKqzhIwdDdilAC",14) == 2628497889) strcat(s, "g");
if (crc32("nBXiKpDqbl",10) == 3160372994) strcat(s, "g");
if (crc32("NiHbbDgRud",10) == 1283039552) strcat(s, "a");
if (crc32("UFUeecag",8) == 3153584036) strcat(s, "r");
if (crc32("rsGknXARtVJCQv",14) == 1289688863) strcat(s, "U");
if (crc32("WrMshCIG",8) == 164604691) strcat(s, "a");
    return s;
}

char *histiocyte_nouns() {
    char *s = calloc(11);
    if (crc32("UMSddOSszC",10) == 4173404091) strcat(s, "r");
if (crc32("eKRGQhtmcb",10) == 964834722) strcat(s, "h");
if (crc32("nYwCqnUwZT",10) == 1180756683) strcat(s, "i");
if (crc32("mNWmCaukyw",10) == 1629527209) strcat(s, "s");
if (crc32("aVlkhhwaR",9) == 4019213707) strcat(s, "t");
if (crc32("AysQq",5) == 47710804) strcat(s, "s");
if (crc32("nzxZwtrdtEWyBhC",15) == 1047213738) strcat(s, "i");
if (crc32("eGsEKdNu",8) == 1292289248) strcat(s, "L");
if (crc32("tiTJvRHqbEPJ",12) == 3192119164) strcat(s, "o");
if (crc32("KIBFOUAAWC",10) == 1584256620) strcat(s, "M");
if (crc32("KdbrhEpyLyIXXr",14) == 876674376) strcat(s, "c");
if (crc32("xsWBuJHTJKR",11) == 1914557794) strcat(s, "P");
if (crc32("jcULosqWbjo",11) == 3468119573) strcat(s, "y");
if (crc32("CDGSi",5) == 489313984) strcat(s, "t");
if (crc32("YcDvzPiIjnlHfI",14) == 1178655217) strcat(s, "Q");
if (crc32("mpjDVkYKuZAHrB",14) == 1668523997) strcat(s, "e");
    return s;
}

char *Abby_nouns() {
    char *s = calloc(5);
    if (crc32("xWykWJFZRkpUKr",14) == 3374180282) strcat(s, "A");
if (crc32("PKPaeIBGOm",10) == 1934501502) strcat(s, "A");
if (crc32("VzDkmQbvhCeRa",13) == 3918500243) strcat(s, "c");
if (crc32("alwbxGWvDgZ",11) == 3894820261) strcat(s, "b");
if (crc32("dxHSZWXj",8) == 2045631349) strcat(s, "a");
if (crc32("vsjvd",5) == 3217086663) strcat(s, "b");
if (crc32("KHAbpTW",7) == 1836767900) strcat(s, "Y");
if (crc32("ZCnvLKvPre",10) == 3053120177) strcat(s, "y");
    return s;
}

char *Meghan_nouns() {
    char *s = calloc(7);
    if (crc32("jPEVtmb",7) == 1377651451) strcat(s, "U");
if (crc32("iMMPbu",6) == 1279017231) strcat(s, "M");
if (crc32("ZFKGKZRapKxqAUY",15) == 3327463390) strcat(s, "w");
if (crc32("ATFwKUZmjOvGCG",14) == 3351253718) strcat(s, "e");
if (crc32("QFVaOd",6) == 4071142370) strcat(s, "Q");
if (crc32("EclPOaNvFnaGb",13) == 2654896390) strcat(s, "g");
if (crc32("ecnUTTKCfxL",11) == 1227545135) strcat(s, "X");
if (crc32("RBhJPZNJ",8) == 92597404) strcat(s, "h");
if (crc32("TbExtmaqgAYO",12) == 2171872038) strcat(s, "U");
if (crc32("biizfuniq",9) == 1950909600) strcat(s, "a");
if (crc32("XElaYbERGi",10) == 49791183) strcat(s, "P");
if (crc32("dlSybOmNDa",10) == 2717903363) strcat(s, "n");
    return s;
}

char *presentation_nouns() {
    char *s = calloc(13);
    if (crc32("yjhVLmrkTSMBdM",14) == 1355572844) strcat(s, "H");
if (crc32("wugBObfnkH",10) == 4217836624) strcat(s, "p");
if (crc32("wcZPVcRlhmWjq",13) == 2441593013) strcat(s, "r");
if (crc32("QyqZPJheDcHsb",13) == 2226772932) strcat(s, "e");
if (crc32("GOtUyDxymOV",11) == 3839800137) strcat(s, "A");
if (crc32("TUhrYnPWFwpQj",13) == 680999218) strcat(s, "s");
if (crc32("HhvmfjibxLSNQ",13) == 67514669) strcat(s, "b");
if (crc32("EAdQYUXjlexhKSy",15) == 2826825273) strcat(s, "e");
if (crc32("uWWYTZXu",8) == 874603309) strcat(s, "n");
if (crc32("QBANoqChltdaf",13) == 157601672) strcat(s, "b");
if (crc32("AwfoGPfr",8) == 2345037153) strcat(s, "t");
if (crc32("TcievvQgmoWRsU",14) == 4007106322) strcat(s, "a");
if (crc32("DdZRZp",6) == 2455824814) strcat(s, "t");
if (crc32("CXCndyNeH",9) == 2697202368) strcat(s, "i");
if (crc32("xFXmCwVNTWXCk",13) == 448191758) strcat(s, "o");
if (crc32("AWWrP",5) == 3942302538) strcat(s, "n");
    return s;
}

char *Myrtie_nouns() {
    char *s = calloc(7);
    if (crc32("oLSbNLcyYf",10) == 3225091309) strcat(s, "k");
if (crc32("eZfUdmYc",8) == 526091627) strcat(s, "M");
if (crc32("AFlfQtfYWbhEvj",14) == 1890909344) strcat(s, "y");
if (crc32("DHDnKmlFJiSHP",13) == 116537662) strcat(s, "r");
if (crc32("UdBLgmN",7) == 2159680598) strcat(s, "t");
if (crc32("zXqsPAlKMUKY",12) == 1108130426) strcat(s, "i");
if (crc32("RYEGBFBc",8) == 2144035555) strcat(s, "b");
if (crc32("WtqjxrYozThKE",13) == 3954961331) strcat(s, "e");
    return s;
}

char *specialist_nouns() {
    char *s = calloc(11);
    if (crc32("rynfctjtTMKw",12) == 3559109883) strcat(s, "s");
if (crc32("fgAJRxLvKScg",12) == 2264162302) strcat(s, "p");
if (crc32("TlwqAz",6) == 2155220266) strcat(s, "e");
if (crc32("iMTdk",5) == 996088777) strcat(s, "K");
if (crc32("vyAaEG",6) == 2540715261) strcat(s, "c");
if (crc32("xAkOWgImcUr",11) == 1823167348) strcat(s, "q");
if (crc32("idKJAgkuwPOV",12) == 2489266466) strcat(s, "i");
if (crc32("XrGHmGIJ",8) == 1711480251) strcat(s, "F");
if (crc32("AQvsMrx",7) == 2354027541) strcat(s, "a");
if (crc32("LSpQfQpGOounSJ",14) == 2838732863) strcat(s, "F");
if (crc32("IadPvpAeqxPn",12) == 1732927832) strcat(s, "l");
if (crc32("ioniZUUKbkPoC",13) == 1939202273) strcat(s, "i");
if (crc32("VrbQWpNLgoYTqQ",14) == 1145004425) strcat(s, "s");
if (crc32("nKQzoXotirHMQF",14) == 2722611282) strcat(s, "t");
if (crc32("CKCbhe",6) == 1159933148) strcat(s, "t");
    return s;
}

char *horseleech_nouns() {
    char *s = calloc(11);
    if (crc32("qYogArjJOyt",11) == 1309044299) strcat(s, "n");
if (crc32("ErvZn",5) == 757441872) strcat(s, "h");
if (crc32("cKsfGGcL",8) == 2753718830) strcat(s, "o");
if (crc32("raMVoktswDe",11) == 3709780074) strcat(s, "r");
if (crc32("nISxGLPrv",9) == 1123314121) strcat(s, "s");
if (crc32("TFcEVKpBZikR",12) == 1506893043) strcat(s, "i");
if (crc32("xKnBpuXXsj",10) == 3008724561) strcat(s, "e");
if (crc32("rAfOzwYqY",9) == 1525765891) strcat(s, "X");
if (crc32("YEBcDzMKBhtw",12) == 158865528) strcat(s, "l");
if (crc32("fdvcEtJlpnYzSy",14) == 1989955281) strcat(s, "k");
if (crc32("jWTOMbONI",9) == 1917018724) strcat(s, "e");
if (crc32("XXFVQWFVbMTLm",13) == 2773323969) strcat(s, "e");
if (crc32("tHNjdBLCt",9) == 2759254347) strcat(s, "c");
if (crc32("SYRNxq",6) == 3577717751) strcat(s, "h");
    return s;
}

char *autoharp_nouns() {
    char *s = calloc(9);
    if (crc32("gcgjFAG",7) == 1465464798) strcat(s, "a");
if (crc32("DdaZOOpEBBYi",12) == 3040866860) strcat(s, "u");
if (crc32("GRWsxBTo",8) == 2206628631) strcat(s, "t");
if (crc32("ogxYdSZL",8) == 2601495530) strcat(s, "A");
if (crc32("iVMotYRRMCnQY",13) == 2698133983) strcat(s, "o");
if (crc32("xKUBrRlKOcDjPs",14) == 360224454) strcat(s, "h");
if (crc32("JRiDrsUiZuliNF",14) == 1408803101) strcat(s, "y");
if (crc32("GMJBxYyuB",9) == 2727623162) strcat(s, "a");
if (crc32("xgyYHdjrbm",10) == 3554378173) strcat(s, "r");
if (crc32("KDQrosEfE",9) == 4126790225) strcat(s, "p");
    return s;
}

char *PCeltic_nouns() {
    char *s = calloc(8);
    if (crc32("zfBAsBDwMU",10) == 3929114470) strcat(s, "u");
if (crc32("dsCckGB",7) == 982216492) strcat(s, "P");
if (crc32("niotEq",6) == 2377058182) strcat(s, "C");
if (crc32("PQHLHyyzHgKikn",14) == 234017648) strcat(s, "e");
if (crc32("gQZde",5) == 3286475925) strcat(s, "l");
if (crc32("ciupRVpspdrUFV",14) == 3475625593) strcat(s, "t");
if (crc32("XWiZePHvMxuJXl",14) == 589642386) strcat(s, "d");
if (crc32("ixpzCGPnJz",10) == 827724362) strcat(s, "i");
if (crc32("FcQTBB",6) == 4106790623) strcat(s, "c");
    return s;
}

char *greenhead_nouns() {
    char *s = calloc(10);
    if (crc32("drPDhMEtRwIW",12) == 1572754921) strcat(s, "g");
if (crc32("LcBQM",5) == 2858488366) strcat(s, "r");
if (crc32("ylTWaRUUeat",11) == 1348166735) strcat(s, "e");
if (crc32("eEQOBqTDJd",10) == 1538784180) strcat(s, "c");
if (crc32("obMWHRxlKOvsGvA",15) == 3115336121) strcat(s, "e");
if (crc32("rcQeGsxpjQ",10) == 3979644895) strcat(s, "N");
if (crc32("KyjZhOx",7) == 4018410114) strcat(s, "n");
if (crc32("LAHkW",5) == 1243956190) strcat(s, "d");
if (crc32("brzzvxlRXYQ",11) == 2301345804) strcat(s, "h");
if (crc32("rpeWptO",7) == 326128696) strcat(s, "e");
if (crc32("NmyIYVJcqrPI",12) == 182103520) strcat(s, "a");
if (crc32("RhfAXBmclhrxJZp",15) == 144068510) strcat(s, "d");
    return s;
}

char *trickortreater_nouns() {
    char *s = calloc(15);
    if (crc32("afxcBszTZ",9) == 3183739562) strcat(s, "t");
if (crc32("HFIZPApbB",9) == 2422527162) strcat(s, "r");
if (crc32("ZQoNZSxUXLEIxNt",15) == 2912124618) strcat(s, "c");
if (crc32("vVGIuI",6) == 4280997720) strcat(s, "i");
if (crc32("rvecmG",6) == 3413101934) strcat(s, "I");
if (crc32("yKPVVNoREmV",11) == 1116906718) strcat(s, "c");
if (crc32("abzDHxYUljduRT",14) == 1442427656) strcat(s, "k");
if (crc32("HKvTyivtXnZql",13) == 1130170232) strcat(s, "o");
if (crc32("COfNcMgJPgkEU",13) == 236843961) strcat(s, "r");
if (crc32("JKudIvwC",8) == 2514850174) strcat(s, "t");
if (crc32("tidXPHwYqJ",10) == 662789681) strcat(s, "s");
if (crc32("VJLTEsrX",8) == 568135863) strcat(s, "r");
if (crc32("hXfiCTonEWk",11) == 271771409) strcat(s, "D");
if (crc32("eaIgs",5) == 2291266799) strcat(s, "e");
if (crc32("HxuGuxHj",8) == 1646634075) strcat(s, "a");
if (crc32("nPvOlMewUh",10) == 2151475714) strcat(s, "t");
if (crc32("nLYOggqSsHlmx",13) == 2951808501) strcat(s, "e");
if (crc32("xzJKBHe",7) == 3227711797) strcat(s, "r");
    return s;
}

char *Cauvery_nouns() {
    char *s = calloc(8);
    if (crc32("iQiFYgY",7) == 3927544488) strcat(s, "O");
if (crc32("ODhNDNJugU",10) == 4233836497) strcat(s, "C");
if (crc32("pACUMkUTw",9) == 2463967967) strcat(s, "U");
if (crc32("MIBUTNruCQONZA",14) == 1251481633) strcat(s, "a");
if (crc32("ZzuXbgroe",9) == 2946732574) strcat(s, "u");
if (crc32("SGNyDKiXkOG",11) == 3345579698) strcat(s, "v");
if (crc32("chwOadpoiPwSpIv",15) == 4187481603) strcat(s, "H");
if (crc32("twObNzYwMNi",11) == 4257011092) strcat(s, "e");
if (crc32("EOveMPJxAMw",11) == 2816610364) strcat(s, "T");
if (crc32("RgXckwFkwgLsAN",14) == 2396996015) strcat(s, "r");
if (crc32("KGutRIXidPhFU",13) == 3715819877) strcat(s, "C");
if (crc32("tSCqVBfCzIrsmV",14) == 4091586281) strcat(s, "y");
    return s;
}

char *peng_nouns() {
    char *s = calloc(5);
    if (crc32("LpDAskJejUlY",12) == 935223427) strcat(s, "Q");
if (crc32("SMnfSTXSdsHITS",14) == 3227007617) strcat(s, "p");
if (crc32("kveMfodjQS",10) == 1026226664) strcat(s, "h");
if (crc32("kQaIR",5) == 3065691141) strcat(s, "e");
if (crc32("BNkljJq",7) == 1626721346) strcat(s, "m");
if (crc32("uDcqHIgPK",9) == 326683369) strcat(s, "n");
if (crc32("WuDqy",5) == 2023624795) strcat(s, "g");
    return s;
}

char *Sampson_nouns() {
    char *s = calloc(8);
    if (crc32("HpheUsCqPUt",11) == 1113992998) strcat(s, "S");
if (crc32("jRNUCk",6) == 1986330981) strcat(s, "l");
if (crc32("dxOpMDGzojxSa",13) == 1202107820) strcat(s, "a");
if (crc32("bJHvUVRGH",9) == 744033023) strcat(s, "S");
if (crc32("yJpdpAgQlo",10) == 3233290684) strcat(s, "m");
if (crc32("sCSZXA",6) == 3893186853) strcat(s, "p");
if (crc32("lLODVxObSZzjg",13) == 999705648) strcat(s, "s");
if (crc32("vCOFSc",6) == 2175265418) strcat(s, "o");
if (crc32("rjASThmD",8) == 3161433331) strcat(s, "n");
    return s;
}

char *hypoglycaemia_nouns() {
    char *s = calloc(14);
    if (crc32("kNnZZBVhYwlmWgc",15) == 1131030271) strcat(s, "h");
if (crc32("fShdLeT",7) == 75183738) strcat(s, "t");
if (crc32("ZrxhtSCn",8) == 1878636030) strcat(s, "y");
if (crc32("IbWCOlCSo",9) == 4233916203) strcat(s, "p");
if (crc32("uimmfcshjRQiTWy",15) == 3984263099) strcat(s, "o");
if (crc32("CVEhgNxcSuRv",12) == 2124128207) strcat(s, "g");
if (crc32("xgexDSA",7) == 1167703751) strcat(s, "z");
if (crc32("krLkfaGvDaI",11) == 3570786620) strcat(s, "l");
if (crc32("WBYYJ",5) == 1916757221) strcat(s, "N");
if (crc32("faJhFEt",7) == 4093778509) strcat(s, "y");
if (crc32("slrGNeB",7) == 1079449174) strcat(s, "c");
if (crc32("WIIxPKpJOJr",11) == 3510852788) strcat(s, "a");
if (crc32("KzwyzsgQpKGy",12) == 3742100031) strcat(s, "C");
if (crc32("bjweZWMa",8) == 771627317) strcat(s, "e");
if (crc32("BVWTdLHksrcIGg",14) == 883493591) strcat(s, "u");
if (crc32("uOqEymdUxKfBGlB",15) == 1048602224) strcat(s, "m");
if (crc32("nNqzTHAN",8) == 2240484240) strcat(s, "i");
if (crc32("ilrDJyMqwAr",11) == 1417622760) strcat(s, "s");
if (crc32("SwbAYgHpqReo",12) == 2622482094) strcat(s, "a");
    return s;
}

char *chateau_nouns() {
    char *s = calloc(8);
    if (crc32("kyZjA",5) == 3239380762) strcat(s, "c");
if (crc32("gwSZAcpPnSW",11) == 2317060219) strcat(s, "X");
if (crc32("NbPUWrJl",8) == 4133231599) strcat(s, "h");
if (crc32("CsvGIDUUCaf",11) == 2789021776) strcat(s, "V");
if (crc32("QyWqLDcx",8) == 3862448906) strcat(s, "a");
if (crc32("vjMWTgeomofKyFU",15) == 1410862674) strcat(s, "t");
if (crc32("cfNRhyEXNMfOYuT",15) == 3137148431) strcat(s, "e");
if (crc32("UUcxuqaJNh",10) == 1237868235) strcat(s, "a");
if (crc32("AAYEwvJzrll",11) == 2331612534) strcat(s, "u");
    return s;
}

char *Chester_nouns() {
    char *s = calloc(8);
    if (crc32("JYGpeCT",7) == 3545328458) strcat(s, "a");
if (crc32("LMSNVKtCH",9) == 1085627144) strcat(s, "C");
if (crc32("IiYTGyoi",8) == 220298675) strcat(s, "J");
if (crc32("ilWGK",5) == 339071861) strcat(s, "h");
if (crc32("UFdIpT",6) == 2825433077) strcat(s, "R");
if (crc32("MsrhEhniN",9) == 2110289982) strcat(s, "e");
if (crc32("uMPKOvJ",7) == 1884722612) strcat(s, "s");
if (crc32("adVbnCG",7) == 2677382175) strcat(s, "e");
if (crc32("GXQGhhv",7) == 2905290706) strcat(s, "t");
if (crc32("yaoLGSlmb",9) == 3047591005) strcat(s, "j");
if (crc32("IYxSHnpsKgyY",12) == 46874680) strcat(s, "e");
if (crc32("NGmQKC",6) == 3490444953) strcat(s, "B");
if (crc32("IUJzubLExXRy",12) == 1317223017) strcat(s, "r");
    return s;
}

char *prehension_nouns() {
    char *s = calloc(11);
    if (crc32("knzOLQg",7) == 1606481156) strcat(s, "p");
if (crc32("MjJZkOqH",8) == 4259241588) strcat(s, "r");
if (crc32("lnvqllhVhWvJ",12) == 722072624) strcat(s, "V");
if (crc32("NRHOvCsx",8) == 2996023123) strcat(s, "e");
if (crc32("ROtvA",5) == 1824541735) strcat(s, "h");
if (crc32("PtGttEOkTT",10) == 2822394817) strcat(s, "N");
if (crc32("lWCtqARga",9) == 2126912677) strcat(s, "e");
if (crc32("oYvUuFT",7) == 3645736807) strcat(s, "n");
if (crc32("fklxXpal",8) == 774451949) strcat(s, "s");
if (crc32("tncZUS",6) == 2053471628) strcat(s, "i");
if (crc32("wtGVTeR",7) == 1100900420) strcat(s, "y");
if (crc32("nDsFlLsfGaGIa",13) == 4240111341) strcat(s, "o");
if (crc32("JzLjamya",8) == 2091244194) strcat(s, "t");
if (crc32("gLHbv",5) == 2899753617) strcat(s, "n");
    return s;
}

char *peterman_nouns() {
    char *s = calloc(9);
    if (crc32("tAlSAzfWrRu",11) == 992745975) strcat(s, "a");
if (crc32("SPjDPosPrmlMG",13) == 2920174649) strcat(s, "p");
if (crc32("qHrCLeYeTkIfhT",14) == 55286441) strcat(s, "X");
if (crc32("ZFYSCImeNPeBc",13) == 2778493891) strcat(s, "e");
if (crc32("JCYCKCmBSz",10) == 1398767399) strcat(s, "t");
if (crc32("XQuctTEfxIjVjBE",15) == 3822630133) strcat(s, "e");
if (crc32("EqnDpegmMsEbYrX",15) == 2520604265) strcat(s, "r");
if (crc32("GjZtSMohFvnIFP",14) == 1406210314) strcat(s, "m");
if (crc32("JrYypJeZmobTx",13) == 3164642317) strcat(s, "a");
if (crc32("miwrhkSZGbjtuaJ",15) == 1127079619) strcat(s, "n");
    return s;
}

char *Adriano_nouns() {
    char *s = calloc(8);
    if (crc32("lNjJZmrRnwtO",12) == 1215395734) strcat(s, "R");
if (crc32("nYvhkqpYIfGIHh",14) == 3508861854) strcat(s, "A");
if (crc32("DNSbcvMmYOrWi",13) == 1242480509) strcat(s, "I");
if (crc32("LaiQbtnBqYSfp",13) == 1518470474) strcat(s, "d");
if (crc32("bXrLifcSkBMr",12) == 942921822) strcat(s, "V");
if (crc32("UTFHurgYXsMo",12) == 2665866054) strcat(s, "r");
if (crc32("qYuwFTQfGUFdN",13) == 2267882036) strcat(s, "i");
if (crc32("vCKMynjFfdCj",12) == 4062953537) strcat(s, "Z");
if (crc32("sPsAghdiglNma",13) == 2206675623) strcat(s, "a");
if (crc32("YPtdiDxLNPGTMu",14) == 3241163527) strcat(s, "n");
if (crc32("zlDKXCbQSlqZL",13) == 3303585333) strcat(s, "e");
if (crc32("HfJAmqHOU",9) == 300986815) strcat(s, "o");
    return s;
}

char *imprecation_nouns() {
    char *s = calloc(12);
    if (crc32("papnVAYZZj",10) == 2891682532) strcat(s, "i");
if (crc32("daHICbOITJop",12) == 2773722652) strcat(s, "m");
if (crc32("QOvRzxovaeM",11) == 2316418316) strcat(s, "p");
if (crc32("mXwbFDBTp",9) == 2926338258) strcat(s, "F");
if (crc32("tAhOqKXYL",9) == 373128402) strcat(s, "r");
if (crc32("QBKJIeJyvyk",11) == 1723890154) strcat(s, "H");
if (crc32("YppblOiQUYC",11) == 1191201401) strcat(s, "e");
if (crc32("mTYtVRkDqnwvabJ",15) == 2961393023) strcat(s, "C");
if (crc32("YwdssnMLh",9) == 1850638668) strcat(s, "c");
if (crc32("MyhDbMLcWXZlik",14) == 3419325474) strcat(s, "w");
if (crc32("dyyUcZuKIZWFhPr",15) == 1634488918) strcat(s, "a");
if (crc32("WFZRdIpyhek",11) == 1706864862) strcat(s, "t");
if (crc32("SqabE",5) == 1920637138) strcat(s, "i");
if (crc32("MTnrQqnAXzPq",12) == 630192369) strcat(s, "H");
if (crc32("ZKnlQiaMbUvop",13) == 2107516070) strcat(s, "o");
if (crc32("ptKHczNaBiAanS",14) == 4274480518) strcat(s, "C");
if (crc32("AQPVFZMRveuUWCE",15) == 3263164153) strcat(s, "n");
    return s;
}

char *Kabyle_nouns() {
    char *s = calloc(7);
    if (crc32("LmjURh",6) == 3948073904) strcat(s, "v");
if (crc32("gDaNRwgUwNuCfdR",15) == 569215286) strcat(s, "K");
if (crc32("VpCAHrmifKm",11) == 2221150476) strcat(s, "o");
if (crc32("MMetXKZMV",9) == 3505602190) strcat(s, "a");
if (crc32("YLzkAdNd",8) == 2699615004) strcat(s, "b");
if (crc32("HJLEgPeNcd",10) == 306962736) strcat(s, "y");
if (crc32("FoRXfcawSnypPT",14) == 834095327) strcat(s, "w");
if (crc32("KUDNOtrhkwpB",12) == 3213506586) strcat(s, "l");
if (crc32("PUBrIoqHjeNKgno",15) == 3368639716) strcat(s, "e");
    return s;
}

char *wordbook_nouns() {
    char *s = calloc(9);
    if (crc32("GaIOfJLvxp",10) == 2866208788) strcat(s, "w");
if (crc32("VnyCgqe",7) == 3566213233) strcat(s, "o");
if (crc32("dNxVOaGY",8) == 2692445887) strcat(s, "F");
if (crc32("ReKvcdtLy",9) == 4125784074) strcat(s, "r");
if (crc32("FDPpN",5) == 4192793803) strcat(s, "M");
if (crc32("QitZkizrINEsG",13) == 636348994) strcat(s, "d");
if (crc32("eyVfDJqJv",9) == 2632025893) strcat(s, "s");
if (crc32("dARiKgT",7) == 404308175) strcat(s, "b");
if (crc32("RBGyCGckVgz",11) == 2141255950) strcat(s, "o");
if (crc32("eTTUJyYnaEeoH",13) == 3378414612) strcat(s, "q");
if (crc32("ZpDhxIFimceyn",13) == 2602136104) strcat(s, "o");
if (crc32("muvTayTveKe",11) == 2865942934) strcat(s, "L");
if (crc32("ZOAYqWKWN",9) == 2987135924) strcat(s, "k");
    return s;
}

char *Carlin_nouns() {
    char *s = calloc(7);
    if (crc32("xxNaDJUMt",9) == 608764795) strcat(s, "C");
if (crc32("FjrropXw",8) == 1179539844) strcat(s, "P");
if (crc32("hepBXfNgOAe",11) == 228347019) strcat(s, "a");
if (crc32("vYGHJzTCZI",10) == 1618648298) strcat(s, "S");
if (crc32("TGCfMQOE",8) == 3742085439) strcat(s, "r");
if (crc32("fCEhIfsLcI",10) == 44982972) strcat(s, "s");
if (crc32("jkqLtJbAIT",10) == 923982676) strcat(s, "l");
if (crc32("xaWTe",5) == 115800519) strcat(s, "i");
if (crc32("KWPQMBwXOSE",11) == 3759789409) strcat(s, "n");
    return s;
}

char *CPM_nouns() {
    char *s = calloc(4);
    if (crc32("XtbxCIXuDQNZAS",14) == 2421797180) strcat(s, "C");
if (crc32("pbpLSUZNess",11) == 171094615) strcat(s, "P");
if (crc32("YlMnbouHUMmzjZ",14) == 2181152657) strcat(s, "i");
if (crc32("lSucNyZ",7) == 1283878523) strcat(s, "M");
    return s;
}

char *thunderhead_nouns() {
    char *s = calloc(12);
    if (crc32("SJBeLRRNS",9) == 3332671411) strcat(s, "S");
if (crc32("yqWCaRdJWy",10) == 2954866324) strcat(s, "t");
if (crc32("yEkByZufFLcI",12) == 933589321) strcat(s, "H");
if (crc32("uADsDGelyqrv",12) == 1097731879) strcat(s, "h");
if (crc32("vZABdLLBELUmg",13) == 3624257682) strcat(s, "u");
if (crc32("xmcTPv",6) == 1995098671) strcat(s, "n");
if (crc32("wNnROfKZj",9) == 3859325600) strcat(s, "U");
if (crc32("FZCNi",5) == 2640920028) strcat(s, "d");
if (crc32("ljTfvl",6) == 673373450) strcat(s, "e");
if (crc32("SWwbIbddPQV",11) == 3595700068) strcat(s, "r");
if (crc32("FYuDScUDjpxg",12) == 956546283) strcat(s, "I");
if (crc32("ViBwcluSRznnIC",14) == 1604662710) strcat(s, "h");
if (crc32("qLWlVIvKjPcHQsg",15) == 2996456736) strcat(s, "d");
if (crc32("gBXJRIfqXBmkjk",14) == 1928541580) strcat(s, "e");
if (crc32("evFJb",5) == 77178601) strcat(s, "a");
if (crc32("LjuijFIFpTrekJM",15) == 451889816) strcat(s, "d");
    return s;
}

char *Olivier_nouns() {
    char *s = calloc(8);
    if (crc32("bQiGDAN",7) == 2321942299) strcat(s, "R");
if (crc32("UTBzhblSwwps",12) == 3060791419) strcat(s, "O");
if (crc32("palFvr",6) == 3694888246) strcat(s, "l");
if (crc32("AkPFgKIyRuI",11) == 3142905238) strcat(s, "m");
if (crc32("iwRWskkUMize",12) == 1295771878) strcat(s, "i");
if (crc32("ZgkKWkouqybkP",13) == 3167983082) strcat(s, "v");
if (crc32("KXXuqYiGhEUs",12) == 2100451111) strcat(s, "i");
if (crc32("sgTMiVDCI",9) == 1221989286) strcat(s, "e");
if (crc32("sxZqYZcZSCTj",12) == 2399360448) strcat(s, "g");
if (crc32("KrQlPDtIfmIvgAs",15) == 1873179732) strcat(s, "r");
    return s;
}

char *badness_nouns() {
    char *s = calloc(8);
    if (crc32("mTJJRMipvfi",11) == 2954155615) strcat(s, "c");
if (crc32("kyrjcc",6) == 959378147) strcat(s, "b");
if (crc32("aOktzED",7) == 1636854707) strcat(s, "M");
if (crc32("MmyFZZ",6) == 3396081853) strcat(s, "a");
if (crc32("EqmXRxKnoMQP",12) == 1509915201) strcat(s, "d");
if (crc32("zqkTXnikrWWPolM",15) == 3461939711) strcat(s, "n");
if (crc32("fUiRyLda",8) == 3295102882) strcat(s, "p");
if (crc32("oASQYxRyHfv",11) == 4195394882) strcat(s, "e");
if (crc32("ChdhPzdJ",8) == 1170050348) strcat(s, "s");
if (crc32("UXOtyU",6) == 2425443278) strcat(s, "s");
    return s;
}

char *populariser_nouns() {
    char *s = calloc(12);
    if (crc32("AwZOWFr",7) == 2140684238) strcat(s, "q");
if (crc32("LUjKZwk",7) == 103159136) strcat(s, "p");
if (crc32("SepZHwFwH",9) == 2258985012) strcat(s, "o");
if (crc32("DxJJDy",6) == 3957769180) strcat(s, "E");
if (crc32("lumwz",5) == 1453331103) strcat(s, "p");
if (crc32("cFfpyaxljMVFXq",14) == 3059042539) strcat(s, "O");
if (crc32("DpxAjJgoPk",10) == 658256486) strcat(s, "u");
if (crc32("JOWcaNgivOnYf",13) == 185219740) strcat(s, "g");
if (crc32("GdeVRlxptmeC",12) == 4280211291) strcat(s, "l");
if (crc32("cQtVRqHB",8) == 222416753) strcat(s, "a");
if (crc32("XkOtbeHktVxrnm",14) == 2257783741) strcat(s, "r");
if (crc32("eGsTcEKeJ",9) == 1631478131) strcat(s, "E");
if (crc32("vyBvytuOmDz",11) == 2463859507) strcat(s, "i");
if (crc32("uVlOPbAL",8) == 2890192264) strcat(s, "f");
if (crc32("WIfcONsNy",9) == 269645936) strcat(s, "s");
if (crc32("tKLDxB",6) == 3610744567) strcat(s, "e");
if (crc32("aIpgNJHuPLHOoYu",15) == 1371365573) strcat(s, "r");
    return s;
}

char *Donal_nouns() {
    char *s = calloc(6);
    if (crc32("ZZMbTHYTKn",10) == 2681895507) strcat(s, "D");
if (crc32("vehRSVyR",8) == 4208053280) strcat(s, "N");
if (crc32("iZKwyYWubJzieHe",15) == 572135825) strcat(s, "o");
if (crc32("PABhdrfTBhiufjx",15) == 1994801583) strcat(s, "Q");
if (crc32("abanUO",6) == 1910823469) strcat(s, "n");
if (crc32("xmDhHGVp",8) == 1525443814) strcat(s, "a");
if (crc32("WyIRvqpKFPj",11) == 3922362670) strcat(s, "G");
if (crc32("hQkTew",6) == 24070140) strcat(s, "l");
    return s;
}

char *digitoxin_nouns() {
    char *s = calloc(10);
    if (crc32("NKYQmTzf",8) == 1631377812) strcat(s, "S");
if (crc32("lYiERJcbWtNJXOI",15) == 1500262697) strcat(s, "d");
if (crc32("qTeXJHnBZcjbXS",14) == 185354482) strcat(s, "i");
if (crc32("ICGwUsfkGniQh",13) == 2682081273) strcat(s, "g");
if (crc32("pqOGzrDmfAGxpLy",15) == 362264569) strcat(s, "H");
if (crc32("DlIeGknuFEYXHe",14) == 3490695812) strcat(s, "i");
if (crc32("qbfrYqSeWv",10) == 3521929617) strcat(s, "t");
if (crc32("hVaOTHKkwC",10) == 4132498484) strcat(s, "o");
if (crc32("emMVFkZg",8) == 3523772943) strcat(s, "o");
if (crc32("ZgrzbVMpeIk",11) == 2567799387) strcat(s, "x");
if (crc32("PhVCuMaPPGVNUS",14) == 3363310035) strcat(s, "x");
if (crc32("tOmXhwJyaT",10) == 1458243229) strcat(s, "i");
if (crc32("PkdSMahyunOGSe",14) == 3894481348) strcat(s, "n");
    return s;
}

char *excipulum_nouns() {
    char *s = calloc(10);
    if (crc32("iqYZe",5) == 2674004206) strcat(s, "e");
if (crc32("KWrtFx",6) == 1177548366) strcat(s, "v");
if (crc32("qBAbWgPv",8) == 3911562288) strcat(s, "x");
if (crc32("XAZnYyEdmhJY",12) == 1238145905) strcat(s, "T");
if (crc32("cGbezvGo",8) == 2563740859) strcat(s, "c");
if (crc32("hphOjYfR",8) == 936871648) strcat(s, "P");
if (crc32("TjKncBHJdDv",11) == 4207595418) strcat(s, "i");
if (crc32("bkjLm",5) == 1040130122) strcat(s, "c");
if (crc32("kDmmDGEBo",9) == 155219465) strcat(s, "p");
if (crc32("gtaaMUxalm",10) == 788128900) strcat(s, "N");
if (crc32("sArzEXQaMjoxt",13) == 3080225450) strcat(s, "u");
if (crc32("rUABbhlt",8) == 3450126860) strcat(s, "k");
if (crc32("vIvhzc",6) == 815902977) strcat(s, "l");
if (crc32("YwGWWtp",7) == 1572023211) strcat(s, "V");
if (crc32("YuTwa",5) == 2663264922) strcat(s, "u");
if (crc32("EaqPSTo",7) == 711519218) strcat(s, "m");
    return s;
}

char *rabal_nouns() {
    char *s = calloc(6);
    if (crc32("kVwkCUxLyNpOvE",14) == 2374289973) strcat(s, "r");
if (crc32("WVXCMMQBPLnt",12) == 72336104) strcat(s, "o");
if (crc32("gqLioStL",8) == 539866250) strcat(s, "a");
if (crc32("ZSnGc",5) == 1156812593) strcat(s, "b");
if (crc32("YrOMgYABNSI",11) == 2918436635) strcat(s, "k");
if (crc32("bvVzsbUQApAtcbq",15) == 159879497) strcat(s, "a");
if (crc32("vjNUzDAbplwuG",13) == 3536074065) strcat(s, "k");
if (crc32("LIIOHwkbhVCKw",13) == 2692430358) strcat(s, "l");
    return s;
}

char *Dongola_nouns() {
    char *s = calloc(8);
    if (crc32("bqRmBuTDwwJoV",13) == 755110343) strcat(s, "D");
if (crc32("XrLYxpF",7) == 3699849134) strcat(s, "a");
if (crc32("zGnTp",5) == 3206045873) strcat(s, "o");
if (crc32("xhDCJrFXGYjPhLL",15) == 2711320946) strcat(s, "n");
if (crc32("tFreP",5) == 1352385755) strcat(s, "g");
if (crc32("MMHfIMktAdAb",12) == 3710470535) strcat(s, "U");
if (crc32("cJyTZvmyHEM",11) == 1893990612) strcat(s, "o");
if (crc32("uibelvC",7) == 883990882) strcat(s, "l");
if (crc32("QktcsnVvmtfOk",13) == 60184837) strcat(s, "a");
    return s;
}

char *Pune_nouns() {
    char *s = calloc(5);
    if (crc32("jlRVxk",6) == 1893517782) strcat(s, "P");
if (crc32("FyqnntTHnZoE",12) == 817010276) strcat(s, "C");
if (crc32("HcRWEaFtAyN",11) == 3324981446) strcat(s, "u");
if (crc32("oUPewG",6) == 3041157628) strcat(s, "n");
if (crc32("EzkesJDW",8) == 440128019) strcat(s, "e");
    return s;
}

char *Laure_nouns() {
    char *s = calloc(6);
    if (crc32("FfGKoR",6) == 3151647005) strcat(s, "w");
if (crc32("hhLtc",5) == 2006641865) strcat(s, "L");
if (crc32("DDObP",5) == 943805650) strcat(s, "a");
if (crc32("couqRRfTwqAvl",13) == 2430816987) strcat(s, "u");
if (crc32("gMMstnYlc",9) == 1842119520) strcat(s, "r");
if (crc32("bJkuwQrFQ",9) == 3367881308) strcat(s, "j");
if (crc32("iLzkZVSOCYBvTd",14) == 3871206114) strcat(s, "e");
    return s;
}

char *fallowness_nouns() {
    char *s = calloc(11);
    if (crc32("VLAUeTBESvjYMzJ",15) == 4089702098) strcat(s, "T");
if (crc32("KgrLP",5) == 790805564) strcat(s, "f");
if (crc32("EOHFvfnVGcmn",12) == 3029127542) strcat(s, "n");
if (crc32("vDnDAwQD",8) == 2161323686) strcat(s, "a");
if (crc32("OgMEqsV",7) == 3848146280) strcat(s, "l");
if (crc32("RpmSjw",6) == 4287836181) strcat(s, "l");
if (crc32("ZxINvpYDF",9) == 2943655742) strcat(s, "U");
if (crc32("AihcQ",5) == 4058512883) strcat(s, "o");
if (crc32("gtsOfWDhPTJE",12) == 1493235100) strcat(s, "H");
if (crc32("lKNUM",5) == 1666221723) strcat(s, "w");
if (crc32("SZFfDJqSEv",10) == 1591352491) strcat(s, "n");
if (crc32("NEPoLOnTqvpntbe",15) == 1232372529) strcat(s, "x");
if (crc32("UQNWXgf",7) == 1988646154) strcat(s, "e");
if (crc32("PuXDzxtAoJoFmFp",15) == 4016381213) strcat(s, "T");
if (crc32("PBSEHbloL",9) == 2535824426) strcat(s, "s");
if (crc32("hRFKrvQFGSA",11) == 487988802) strcat(s, "s");
    return s;
}

char *Fnen_nouns() {
    char *s = calloc(5);
    if (crc32("InNLtxGswnP",11) == 1074831899) strcat(s, "v");
if (crc32("kSzmiHQT",8) == 3330576636) strcat(s, "F");
if (crc32("ELneInhi",8) == 3653718836) strcat(s, "n");
if (crc32("LFgTGEWPKFE",11) == 2386735006) strcat(s, "e");
if (crc32("pnuJOVbgC",9) == 4230673898) strcat(s, "G");
if (crc32("iVDxllcZG",9) == 502972853) strcat(s, "n");
    return s;
}

char *telephonograph_nouns() {
    char *s = calloc(15);
    if (crc32("EBmyNmuwFnYz",12) == 2114685944) strcat(s, "d");
if (crc32("aPoPfvnAs",9) == 3007742769) strcat(s, "t");
if (crc32("myGMYsNKSIoft",13) == 2406234646) strcat(s, "z");
if (crc32("gIHKJqE",7) == 2451820475) strcat(s, "e");
if (crc32("tHonFZKagW",10) == 3007183193) strcat(s, "F");
if (crc32("ZkyAJ",5) == 2095961440) strcat(s, "l");
if (crc32("ntnve",5) == 42574967) strcat(s, "e");
if (crc32("dZupVXdPQzYHO",13) == 1286188831) strcat(s, "U");
if (crc32("LaaWAePyFbeP",12) == 3049835478) strcat(s, "p");
if (crc32("yfVjDXcztdto",12) == 3917509912) strcat(s, "r");
if (crc32("bvZEOBRoTBqK",12) == 172888068) strcat(s, "h");
if (crc32("hmvWGLVMB",9) == 1514831628) strcat(s, "o");
if (crc32("VqMsmypZ",8) == 1600313891) strcat(s, "M");
if (crc32("GcSWzjCGSJfK",12) == 3042830294) strcat(s, "n");
if (crc32("eMHwLS",6) == 292218389) strcat(s, "R");
if (crc32("TRIcM",5) == 1396959801) strcat(s, "o");
if (crc32("pQFdNPFVDEp",11) == 3827556281) strcat(s, "Y");
if (crc32("DcgCpzAvTXKYm",13) == 876950876) strcat(s, "g");
if (crc32("nkwxroPnfWYP",12) == 1476844304) strcat(s, "r");
if (crc32("TkUpdiyKQjdbUBF",15) == 602101650) strcat(s, "a");
if (crc32("OGSybMQcRnhK",12) == 1300657352) strcat(s, "M");
if (crc32("wtVechJSunrRrUN",15) == 1420119074) strcat(s, "p");
if (crc32("AmgOAlpHDjj",11) == 2179227319) strcat(s, "u");
if (crc32("BMhPzzgXVKKmS",13) == 2080607097) strcat(s, "h");
    return s;
}

char *Citlaltpetl_nouns() {
    char *s = calloc(12);
    if (crc32("iDvzPKGu",8) == 1548620499) strcat(s, "C");
if (crc32("JonLMqUNLmAz",12) == 509416847) strcat(s, "i");
if (crc32("JLyqBNqJEqmVWI",14) == 2129166452) strcat(s, "u");
if (crc32("LvbqEzq",7) == 2001621638) strcat(s, "t");
if (crc32("YHVleRgPhxZcQ",13) == 2615297503) strcat(s, "l");
if (crc32("GGKPlnfgUQ",10) == 3979369587) strcat(s, "y");
if (crc32("XAbqbWp",7) == 2542790482) strcat(s, "a");
if (crc32("TXWKJvAMO",9) == 1113781287) strcat(s, "l");
if (crc32("oxdranznDN",10) == 510190948) strcat(s, "b");
if (crc32("AWzwfpXZWMKP",12) == 3402859599) strcat(s, "t");
if (crc32("BsKhaaYvFwRJR",13) == 3787022587) strcat(s, "B");
if (crc32("JObQqbBh",8) == 914706604) strcat(s, "p");
if (crc32("kqYroMAJGjL",11) == 4044794674) strcat(s, "l");
if (crc32("VLPtzOCU",8) == 3389867877) strcat(s, "e");
if (crc32("mlUXCwq",7) == 3416876771) strcat(s, "J");
if (crc32("zljjobVOeCiQihZ",15) == 3622245335) strcat(s, "t");
if (crc32("lEvwugILVfkFQ",13) == 1223354782) strcat(s, "j");
if (crc32("tIkzQDGhKptLqI",14) == 724599340) strcat(s, "l");
    return s;
}

char *Otis_nouns() {
    char *s = calloc(5);
    if (crc32("dKgJVMpth",9) == 3061546635) strcat(s, "o");
if (crc32("OUCjbpUZAqk",11) == 157973144) strcat(s, "O");
if (crc32("KaJzBLgmw",9) == 1276571069) strcat(s, "t");
if (crc32("gTbakzVVdYWX",12) == 3465006961) strcat(s, "x");
if (crc32("cdpVxrDC",8) == 2062584075) strcat(s, "i");
if (crc32("NnbmJUypO",9) == 1942871323) strcat(s, "m");
if (crc32("KFdICw",6) == 3721713831) strcat(s, "s");
    return s;
}

char *Chura_nouns() {
    char *s = calloc(6);
    if (crc32("YTkMBb",6) == 2722550517) strcat(s, "C");
if (crc32("byFxwnxMfLO",11) == 4131815444) strcat(s, "h");
if (crc32("cMQncYKEJDJUc",13) == 2289093102) strcat(s, "Q");
if (crc32("ZnbZZSFdV",9) == 700303268) strcat(s, "u");
if (crc32("czWtQfcYFIgD",12) == 4038307699) strcat(s, "n");
if (crc32("mWlsRW",6) == 3579759567) strcat(s, "r");
if (crc32("JbUvCwFxumEUUSv",15) == 1698235069) strcat(s, "a");
    return s;
}

char *Sucaryl_nouns() {
    char *s = calloc(8);
    if (crc32("FxgzbV",6) == 2335521796) strcat(s, "S");
if (crc32("cmCOEcmdGrRu",12) == 827384570) strcat(s, "u");
if (crc32("AbpwIfzqfArRxQ",14) == 469800224) strcat(s, "w");
if (crc32("tfjEqCUrBso",11) == 161654714) strcat(s, "c");
if (crc32("zbZeIMHybUwyTg",14) == 4092710302) strcat(s, "C");
if (crc32("OlXkM",5) == 2176483447) strcat(s, "a");
if (crc32("yLYYIK",6) == 355561889) strcat(s, "r");
if (crc32("EEOgoLxSypZW",12) == 3330695680) strcat(s, "y");
if (crc32("daQCTPLEWEgMrU",14) == 3223452910) strcat(s, "r");
if (crc32("KDMJiKxU",8) == 3323102671) strcat(s, "l");
    return s;
}

char *sculptress_nouns() {
    char *s = calloc(11);
    if (crc32("tJnfFQBw",8) == 2031950585) strcat(s, "q");
if (crc32("LsdlYghotbbEiM",14) == 3888999598) strcat(s, "s");
if (crc32("nENGss",6) == 3492783688) strcat(s, "c");
if (crc32("XrjXIHDjNrnw",12) == 4152328880) strcat(s, "u");
if (crc32("vbNHpLCNCCAvq",13) == 2947735321) strcat(s, "l");
if (crc32("kJlcBLIltwjGx",13) == 585856218) strcat(s, "p");
if (crc32("gEWbSUQjffLSMaN",15) == 2695067451) strcat(s, "n");
if (crc32("NFKOkyBXgm",10) == 3560541407) strcat(s, "t");
if (crc32("mSnBPzQTdp",10) == 1824886129) strcat(s, "r");
if (crc32("YsWpXjJrjsKAMB",14) == 1426277760) strcat(s, "B");
if (crc32("BISOa",5) == 564361582) strcat(s, "e");
if (crc32("kkKdUQuC",8) == 635741251) strcat(s, "q");
if (crc32("uktAog",6) == 2692294690) strcat(s, "s");
if (crc32("ZtVAft",6) == 2241883080) strcat(s, "X");
if (crc32("vGQnNhZmShCOmW",14) == 465092952) strcat(s, "s");
    return s;
}

char *interrepulsion_nouns() {
    char *s = calloc(15);
    if (crc32("UYlPnjlMlljlpD",14) == 1408259876) strcat(s, "g");
if (crc32("kvzRtuGDX",9) == 2409458554) strcat(s, "i");
if (crc32("DnNeDYpIX",9) == 1405417406) strcat(s, "l");
if (crc32("dEMgCXUbfuegct",14) == 971261286) strcat(s, "n");
if (crc32("ZUiqaWYxLR",10) == 2350357748) strcat(s, "t");
if (crc32("HLQyMrwNcOpgWLM",15) == 3045473403) strcat(s, "e");
if (crc32("BAvTfZwlLXz",11) == 1902645580) strcat(s, "X");
if (crc32("JKVYde",6) == 2170593220) strcat(s, "r");
if (crc32("dBDpMjJRuHYg",12) == 853791119) strcat(s, "i");
if (crc32("IwIlIQnZvsH",11) == 2683843240) strcat(s, "r");
if (crc32("AXxPLAERDwO",11) == 3539029934) strcat(s, "J");
if (crc32("vjHqMRGoqAV",11) == 1831918431) strcat(s, "e");
if (crc32("bDBDjyYhdIWdmO",14) == 4206029660) strcat(s, "p");
if (crc32("uSLLYMoGsagiy",13) == 1438811532) strcat(s, "u");
if (crc32("IxDOvrdcYin",11) == 2190263344) strcat(s, "D");
if (crc32("PWNoktRIReCOpZ",14) == 2627568095) strcat(s, "l");
if (crc32("BuSsNeYxGKECfPW",15) == 3368614099) strcat(s, "I");
if (crc32("ulOMRryoaVcIsk",14) == 621881953) strcat(s, "s");
if (crc32("kDaESL",6) == 399220231) strcat(s, "i");
if (crc32("kbySAmrsYQfu",12) == 1414751951) strcat(s, "i");
if (crc32("ODQVVqiUlKL",11) == 2326140191) strcat(s, "o");
if (crc32("xVQZe",5) == 4044646627) strcat(s, "n");
    return s;
}

char *Ebn_nouns() {
    char *s = calloc(4);
    if (crc32("cxNXaEnfdeC",11) == 623306006) strcat(s, "E");
if (crc32("qMqjK",5) == 1086433232) strcat(s, "b");
if (crc32("PRfLxNdqf",9) == 2095479181) strcat(s, "n");
    return s;
}

char *precandidature_nouns() {
    char *s = calloc(15);
    if (crc32("gPkviUZQ",8) == 868578485) strcat(s, "S");
if (crc32("KyaJWz",6) == 2602701427) strcat(s, "p");
if (crc32("kYkRCqU",7) == 4014195070) strcat(s, "r");
if (crc32("bHLThyQo",8) == 3994975298) strcat(s, "e");
if (crc32("wjISXJ",6) == 417991610) strcat(s, "c");
if (crc32("qPFvCaAIlV",10) == 2496629667) strcat(s, "K");
if (crc32("hMhpSh",6) == 2375737389) strcat(s, "a");
if (crc32("QkSwCxWq",8) == 3041670826) strcat(s, "n");
if (crc32("lBlRoP",6) == 1963209663) strcat(s, "W");
if (crc32("pUrFvKbOQ",9) == 3015959839) strcat(s, "d");
if (crc32("NjnAGkVizQ",10) == 298497116) strcat(s, "i");
if (crc32("iwdmTVHT",8) == 1240405500) strcat(s, "J");
if (crc32("trISLVBBhKty",12) == 1843701193) strcat(s, "d");
if (crc32("rayOdkWauEw",11) == 946753047) strcat(s, "t");
if (crc32("rMiBs",5) == 1611348476) strcat(s, "a");
if (crc32("XhMiWOe",7) == 2893426624) strcat(s, "t");
if (crc32("fgkgmNmZ",8) == 1274417296) strcat(s, "w");
if (crc32("ZZzxQicxsnzVR",13) == 2973065329) strcat(s, "u");
if (crc32("ZsEIQtHbiBOYhmu",15) == 764641798) strcat(s, "r");
if (crc32("tFKgWcMYE",9) == 1097094619) strcat(s, "r");
if (crc32("ZBcMuhYvkaF",11) == 986985295) strcat(s, "e");
    return s;
}

char *Shewchuk_nouns() {
    char *s = calloc(9);
    if (crc32("kADiIn",6) == 1856219157) strcat(s, "S");
if (crc32("ulqQW",5) == 2239527484) strcat(s, "h");
if (crc32("dhXRu",5) == 2655992849) strcat(s, "e");
if (crc32("vioWA",5) == 1093954675) strcat(s, "w");
if (crc32("HDtroCkWFQ",10) == 1590095269) strcat(s, "L");
if (crc32("eUpqhp",6) == 3659877785) strcat(s, "c");
if (crc32("yBMkk",5) == 2531412131) strcat(s, "v");
if (crc32("Scfjp",5) == 323968872) strcat(s, "h");
if (crc32("SiDhpkMn",8) == 566810689) strcat(s, "u");
if (crc32("RblJJSTEwdpwavb",15) == 3694732599) strcat(s, "u");
if (crc32("rSMJGWLQsUCRWQ",14) == 392052490) strcat(s, "k");
    return s;
}

char *BArchE_nouns() {
    char *s = calloc(7);
    if (crc32("uMtALjrtdJrC",12) == 1861235929) strcat(s, "P");
if (crc32("iCpLkZuumq",10) == 4018565173) strcat(s, "B");
if (crc32("YepMamQ",7) == 1449341492) strcat(s, "I");
if (crc32("kBIhz",5) == 2070081077) strcat(s, "A");
if (crc32("MlqvJncStsklZZ",14) == 1657624509) strcat(s, "P");
if (crc32("OTGJc",5) == 4078349400) strcat(s, "r");
if (crc32("uivWFQLilW",10) == 4187399847) strcat(s, "c");
if (crc32("DHtwLRBY",8) == 676842263) strcat(s, "i");
if (crc32("SZAKySlHiO",10) == 4216687643) strcat(s, "h");
if (crc32("yMxJNoJEDFbX",12) == 483822327) strcat(s, "C");
if (crc32("zWEcTwESL",9) == 3890363705) strcat(s, "E");
    return s;
}

char *cursor_nouns() {
    char *s = calloc(7);
    if (crc32("kpwYqAT",7) == 3869385461) strcat(s, "R");
if (crc32("dxELdrIRBcdk",12) == 2985969065) strcat(s, "c");
if (crc32("bLVdhZVSGlc",11) == 3088368107) strcat(s, "I");
if (crc32("HyaEisGUfjTmGV",14) == 147112134) strcat(s, "u");
if (crc32("sRlvNtVEOyaQ",12) == 950224639) strcat(s, "y");
if (crc32("SdLZUfUU",8) == 2802784943) strcat(s, "r");
if (crc32("wwHTuu",6) == 61990427) strcat(s, "Z");
if (crc32("VNjnHqHkG",9) == 1834413914) strcat(s, "s");
if (crc32("fdOuBI",6) == 1608493578) strcat(s, "o");
if (crc32("KuYnUVDlehsMBx",14) == 134700948) strcat(s, "r");
    return s;
}

char *inosculation_nouns() {
    char *s = calloc(13);
    if (crc32("UJKrxLVBgkVuyxt",15) == 3990822544) strcat(s, "i");
if (crc32("DJjOU",5) == 427410126) strcat(s, "B");
if (crc32("qcFdJ",5) == 3364655568) strcat(s, "n");
if (crc32("uxXuRgMtVHTjPP",14) == 2556655238) strcat(s, "R");
if (crc32("kCFyX",5) == 1312533657) strcat(s, "o");
if (crc32("LHZlrH",6) == 564688744) strcat(s, "s");
if (crc32("LBtGGdWCFtgW",12) == 275144968) strcat(s, "B");
if (crc32("oqOnuZXSryRuATY",15) == 707466400) strcat(s, "c");
if (crc32("rItzXbBfDIr",11) == 3202482690) strcat(s, "u");
if (crc32("SchCsL",6) == 310123932) strcat(s, "l");
if (crc32("pPNMGSGL",8) == 3874894355) strcat(s, "w");
if (crc32("MxKKCSTq",8) == 1544534830) strcat(s, "a");
if (crc32("QrfggFXoerhzm",13) == 2530758428) strcat(s, "t");
if (crc32("gDmHHLpVrl",10) == 3603875395) strcat(s, "b");
if (crc32("CkfpUKbWebz",11) == 2254368638) strcat(s, "i");
if (crc32("QvhRDjGOS",9) == 431903709) strcat(s, "o");
if (crc32("zidBxqcpb",9) == 218710878) strcat(s, "w");
if (crc32("GksEOfNTYZ",10) == 1844669114) strcat(s, "n");
    return s;
}

char *Cristoforo_nouns() {
    char *s = calloc(11);
    if (crc32("sZBdBxEPJ",9) == 3328263879) strcat(s, "G");
if (crc32("gZUjezTyJaM",11) == 1688549561) strcat(s, "C");
if (crc32("NRgmmN",6) == 83784514) strcat(s, "L");
if (crc32("xuxBvazR",8) == 913428918) strcat(s, "r");
if (crc32("xSySZED",7) == 3219946294) strcat(s, "G");
if (crc32("oGBIwn",6) == 647044578) strcat(s, "i");
if (crc32("ukgqdv",6) == 3467782261) strcat(s, "Q");
if (crc32("XlSGYKkoNgZLCJs",15) == 1642477495) strcat(s, "s");
if (crc32("MgnQvWhR",8) == 2713773165) strcat(s, "t");
if (crc32("haHncvwaRVXS",12) == 3061634212) strcat(s, "M");
if (crc32("BfDTWt",6) == 946978713) strcat(s, "o");
if (crc32("UTOOH",5) == 4174757456) strcat(s, "w");
if (crc32("GTENzigJONxekvk",15) == 3583173127) strcat(s, "f");
if (crc32("nfWYyciXwTRNjL",14) == 3810215099) strcat(s, "o");
if (crc32("hEKWngm",7) == 142627835) strcat(s, "O");
if (crc32("tgfWYxqXNjlgBsS",15) == 291910354) strcat(s, "r");
if (crc32("atkctvVI",8) == 3600332983) strcat(s, "r");
if (crc32("lIIpyJ",6) == 1091453292) strcat(s, "o");
    return s;
}

char *privet_nouns() {
    char *s = calloc(7);
    if (crc32("RasprHbEX",9) == 2210926575) strcat(s, "m");
if (crc32("JnvlEie",7) == 3074280613) strcat(s, "p");
if (crc32("cFOWmqpMciFXA",13) == 1879133762) strcat(s, "r");
if (crc32("ymitjIorhYuEX",13) == 832251636) strcat(s, "i");
if (crc32("bEeKQpU",7) == 2234412168) strcat(s, "P");
if (crc32("SuFGeoLoNH",10) == 2720853502) strcat(s, "v");
if (crc32("lbxJlYpegNpC",12) == 3384394470) strcat(s, "b");
if (crc32("eaOvEZ",6) == 3625074324) strcat(s, "e");
if (crc32("zVljJRP",7) == 1074286447) strcat(s, "I");
if (crc32("ErEpmOXlkBVOPb",14) == 3148547424) strcat(s, "t");
    return s;
}

char *raspingness_nouns() {
    char *s = calloc(12);
    if (crc32("aSXgJpFpPAVEwq",14) == 733498964) strcat(s, "C");
if (crc32("nmCWDnL",7) == 1216450382) strcat(s, "r");
if (crc32("MypPXnuuaakYZ",13) == 397568639) strcat(s, "h");
if (crc32("lDLgbtYUVgM",11) == 1262131462) strcat(s, "a");
if (crc32("LWCDj",5) == 1040390531) strcat(s, "r");
if (crc32("VrgdytjM",8) == 644848607) strcat(s, "s");
if (crc32("iMotFUVkln",10) == 270356530) strcat(s, "p");
if (crc32("QgVepz",6) == 1654090189) strcat(s, "i");
if (crc32("wugCPojxK",9) == 631121299) strcat(s, "m");
if (crc32("uxlLreNgnlusuGt",15) == 2441959518) strcat(s, "n");
if (crc32("FCPlrq",6) == 3344633203) strcat(s, "g");
if (crc32("AXaWUsflGK",10) == 993399111) strcat(s, "k");
if (crc32("DpCloEFkQgbos",13) == 3062692636) strcat(s, "n");
if (crc32("uHzQSuWiiZKYYYx",15) == 3823231467) strcat(s, "e");
if (crc32("Eqkiv",5) == 3429484539) strcat(s, "s");
if (crc32("BUXcqrJVQlVi",12) == 2301091707) strcat(s, "s");
    return s;
}

char *phocomelia_nouns() {
    char *s = calloc(11);
    if (crc32("xHkGWOuH",8) == 388571430) strcat(s, "R");
if (crc32("ZUbIinzkEqSn",12) == 2436917254) strcat(s, "p");
if (crc32("BNZzyIpvvYoC",12) == 2944305155) strcat(s, "m");
if (crc32("mgkxeGkRvcFS",12) == 3212333718) strcat(s, "h");
if (crc32("snvdjCtsJw",10) == 3216134221) strcat(s, "o");
if (crc32("aUBdyByAZqkDO",13) == 2303080089) strcat(s, "J");
if (crc32("TkBUJOTgOYrIuf",14) == 1202738904) strcat(s, "c");
if (crc32("uFIrbcFlC",9) == 961103633) strcat(s, "U");
if (crc32("JngBKQcLj",9) == 2214398491) strcat(s, "o");
if (crc32("QZeoG",5) == 2910027111) strcat(s, "j");
if (crc32("yyocCEMiYpzbl",13) == 3940166544) strcat(s, "m");
if (crc32("kDqhxv",6) == 3041253925) strcat(s, "e");
if (crc32("grVsbuEkAlrg",12) == 3441870495) strcat(s, "l");
if (crc32("gmasjdALGuMmMx",14) == 360853066) strcat(s, "i");
if (crc32("pimaoE",6) == 1246295520) strcat(s, "a");
    return s;
}

char *Rintoul_nouns() {
    char *s = calloc(8);
    if (crc32("tHqXPzceXhZdyN",14) == 780102072) strcat(s, "R");
if (crc32("XbGZNWzVr",9) == 727836183) strcat(s, "i");
if (crc32("gdoRSiAjrOho",12) == 2743264485) strcat(s, "n");
if (crc32("CvyJIe",6) == 969230997) strcat(s, "t");
if (crc32("vLmJJJWdmpXRKHK",15) == 36876428) strcat(s, "V");
if (crc32("FqMwzTxWW",9) == 3046801498) strcat(s, "o");
if (crc32("cSMKUoFbSjz",11) == 609428589) strcat(s, "u");
if (crc32("tUPsmGU",7) == 2397160085) strcat(s, "X");
if (crc32("gvuHtMkzz",9) == 2915171369) strcat(s, "l");
    return s;
}

char *Crotone_nouns() {
    char *s = calloc(8);
    if (crc32("PQrFrEj",7) == 857396973) strcat(s, "C");
if (crc32("Oasobl",6) == 144240775) strcat(s, "j");
if (crc32("EuyDdzXmweEf",12) == 3652186854) strcat(s, "r");
if (crc32("eMmjJyzUED",10) == 1476058125) strcat(s, "o");
if (crc32("nLTvejNW",8) == 1877299066) strcat(s, "d");
if (crc32("sKjcNyD",7) == 707411866) strcat(s, "t");
if (crc32("rbaRtJuZp",9) == 2089100953) strcat(s, "o");
if (crc32("xmiRNZg",7) == 3250931693) strcat(s, "R");
if (crc32("JQSyprfncM",10) == 1072381477) strcat(s, "n");
if (crc32("TfMksUwQTqV",11) == 3143372336) strcat(s, "e");
    return s;
}

char *KuKlux_nouns() {
    char *s = calloc(7);
    if (crc32("IuBczhrEhk",10) == 2362985827) strcat(s, "W");
if (crc32("gQYlViqzMQyS",12) == 2543668693) strcat(s, "K");
if (crc32("GmolbNYzWZg",11) == 1459120963) strcat(s, "u");
if (crc32("yGwyGYAOVd",10) == 1450130199) strcat(s, "c");
if (crc32("PVVVjkSfdktG",12) == 1698182523) strcat(s, "K");
if (crc32("IeEYdxXFUcUTtv",14) == 3735380603) strcat(s, "c");
if (crc32("EgUWPKwDe",9) == 1144091887) strcat(s, "l");
if (crc32("GMgqVYLQfJk",11) == 3884036367) strcat(s, "b");
if (crc32("vgKBycv",7) == 3045934033) strcat(s, "u");
if (crc32("QmBLKwMLDqf",11) == 3155431082) strcat(s, "x");
    return s;
}

char *Liaoning_nouns() {
    char *s = calloc(9);
    if (crc32("hbkXNTvuqbPzS",13) == 3706051801) strcat(s, "o");
if (crc32("DGlooXZOj",9) == 1575854452) strcat(s, "L");
if (crc32("WrmncqtuYUEnF",13) == 1523678511) strcat(s, "S");
if (crc32("VCFCkBi",7) == 3088380337) strcat(s, "i");
if (crc32("jfnSOT",6) == 2688276876) strcat(s, "a");
if (crc32("ZiVkqJXtbGmt",12) == 3824371303) strcat(s, "o");
if (crc32("HgppWEPYnjJUD",13) == 976661891) strcat(s, "H");
if (crc32("BaWto",5) == 2552665180) strcat(s, "n");
if (crc32("GnnZGNmBJ",9) == 1784062701) strcat(s, "i");
if (crc32("rPPBKjNntMMhq",13) == 2805524006) strcat(s, "n");
if (crc32("JVBFsLWPQDeKjI",14) == 3667239408) strcat(s, "g");
    return s;
}

char *Gutenberg_nouns() {
    char *s = calloc(10);
    if (crc32("QiBFRKuvsC",10) == 417050907) strcat(s, "z");
if (crc32("qYAHK",5) == 476300456) strcat(s, "G");
if (crc32("lsBhGVlPsKTUI",13) == 3166812938) strcat(s, "u");
if (crc32("FMjUaIszYdoy",12) == 236528196) strcat(s, "f");
if (crc32("qpJMEbfjYbiXl",13) == 2171700179) strcat(s, "t");
if (crc32("vBkFY",5) == 4261768254) strcat(s, "g");
if (crc32("PWGfFVEFRoefMl",14) == 2982979422) strcat(s, "e");
if (crc32("wMevzsy",7) == 2735154658) strcat(s, "Q");
if (crc32("GReLgpuavkS",11) == 2455756303) strcat(s, "n");
if (crc32("Jriur",5) == 2870364811) strcat(s, "R");
if (crc32("MwHdbACdMKm",11) == 2027104203) strcat(s, "b");
if (crc32("oyTGItQRZd",10) == 3648495179) strcat(s, "k");
if (crc32("YzwqtRsElgZmCMU",15) == 4198706387) strcat(s, "e");
if (crc32("cYtCMAH",7) == 1617414288) strcat(s, "r");
if (crc32("yJZapFIpJyUi",12) == 1943432572) strcat(s, "v");
if (crc32("ewfzgOAguRcT",12) == 859668004) strcat(s, "g");
    return s;
}

char *wharfinger_nouns() {
    char *s = calloc(11);
    if (crc32("rOVfXKQrAL",10) == 369112671) strcat(s, "w");
if (crc32("LjsMTMeRGtFl",12) == 2535630422) strcat(s, "h");
if (crc32("irrBqWIXqTw",11) == 2800805306) strcat(s, "j");
if (crc32("LlFdSHhjZOw",11) == 1365460485) strcat(s, "a");
if (crc32("xsmuGP",6) == 2816784707) strcat(s, "r");
if (crc32("KSBLqNsNriLfTVJ",15) == 281417758) strcat(s, "U");
if (crc32("GzLoyVF",7) == 1614914971) strcat(s, "f");
if (crc32("FisVeCbsuQF",11) == 608073098) strcat(s, "j");
if (crc32("argRmqlknGLphb",14) == 4167782133) strcat(s, "i");
if (crc32("ZUqbAegMrMSM",12) == 1724515829) strcat(s, "n");
if (crc32("GBVtAelwgvQyu",13) == 3445024428) strcat(s, "q");
if (crc32("ECWVPWYuQUT",11) == 2707896971) strcat(s, "g");
if (crc32("MyGLtLndfWvpHLN",15) == 2264334069) strcat(s, "B");
if (crc32("PhmQLB",6) == 1948442164) strcat(s, "e");
if (crc32("ivYsNUQKYEYl",12) == 1885505416) strcat(s, "N");
if (crc32("HXZuSXVsSc",10) == 2724108959) strcat(s, "r");
    return s;
}

char *butler_nouns() {
    char *s = calloc(7);
    if (crc32("bbjvjUeu",8) == 385767767) strcat(s, "A");
if (crc32("PluFeMxzpbOKvZ",14) == 1793114031) strcat(s, "b");
if (crc32("EhrcYuTrXf",10) == 4011141351) strcat(s, "Z");
if (crc32("MdEbbsC",7) == 2323467115) strcat(s, "u");
if (crc32("pMsYpCMK",8) == 3911299776) strcat(s, "t");
if (crc32("czChoTiMaaCcP",13) == 1885050290) strcat(s, "l");
if (crc32("SxEMqzywQWfXm",13) == 3190066574) strcat(s, "e");
if (crc32("dsXGdF",6) == 4188132000) strcat(s, "K");
if (crc32("ePfGoXoPZHYp",12) == 3969243574) strcat(s, "r");
    return s;
}

char *showplace_nouns() {
    char *s = calloc(10);
    if (crc32("OVJozwdRsGqND",13) == 2101664618) strcat(s, "a");
if (crc32("BEWbZOmNqnkQGt",14) == 3995589226) strcat(s, "s");
if (crc32("mTqPvNcNdC",10) == 745128239) strcat(s, "h");
if (crc32("xQYJDyqZk",9) == 1910829297) strcat(s, "P");
if (crc32("uaYTHfRNuatubWL",15) == 2129759347) strcat(s, "o");
if (crc32("QuJrPB",6) == 3331812545) strcat(s, "w");
if (crc32("LTUSFHrS",8) == 406236677) strcat(s, "h");
if (crc32("kmFfO",5) == 1080033229) strcat(s, "p");
if (crc32("SCSRjDnKMYmtHhs",15) == 2090860855) strcat(s, "B");
if (crc32("bVPoRVTOFLij",12) == 3513019648) strcat(s, "l");
if (crc32("HxohftJgJTdP",12) == 2962806439) strcat(s, "a");
if (crc32("imCKxOT",7) == 627820710) strcat(s, "c");
if (crc32("jIqJZTTqBuZflz",14) == 2035819310) strcat(s, "f");
if (crc32("czMhOtmHjI",10) == 1671249145) strcat(s, "e");
    return s;
}

char *lefty_nouns() {
    char *s = calloc(6);
    if (crc32("LEaqtjRBWEypsCm",15) == 338876062) strcat(s, "c");
if (crc32("uUbhgERRzNHg",12) == 2785321459) strcat(s, "l");
if (crc32("eEdFrkNodID",11) == 1585213807) strcat(s, "e");
if (crc32("olRPbKTxGWBlPmB",15) == 3956285846) strcat(s, "f");
if (crc32("oyKlm",5) == 2671740214) strcat(s, "Y");
if (crc32("TPYEqaECZzzWqL",14) == 2619271442) strcat(s, "t");
if (crc32("THUKsFfdCPF",11) == 4247085432) strcat(s, "s");
if (crc32("GqjcOdfTnYdI",12) == 2312553368) strcat(s, "y");
    return s;
}

char *Mongolianism_nouns() {
    char *s = calloc(13);
    if (crc32("syOZZZWrjNV",11) == 198260364) strcat(s, "M");
if (crc32("TVgUKJwPwlyX",12) == 2453771559) strcat(s, "y");
if (crc32("tdEcxn",6) == 3866385710) strcat(s, "o");
if (crc32("sPWEJtIIKeEuZnq",15) == 766711712) strcat(s, "y");
if (crc32("xMSOqUBrr",9) == 463769065) strcat(s, "n");
if (crc32("HOZCFhRbFDB",11) == 1082338837) strcat(s, "g");
if (crc32("WWjqTgZyoiPmdR",14) == 1369886854) strcat(s, "i");
if (crc32("MswxEYhlktwP",12) == 917029490) strcat(s, "o");
if (crc32("YCDMTMx",7) == 2045507986) strcat(s, "r");
if (crc32("WlPzH",5) == 4236958227) strcat(s, "l");
if (crc32("pzIzrevtYow",11) == 3305584077) strcat(s, "i");
if (crc32("nhEpWWtQhNh",11) == 1879920457) strcat(s, "a");
if (crc32("Vkbei",5) == 4209108004) strcat(s, "n");
if (crc32("vKkJQ",5) == 3258376075) strcat(s, "N");
if (crc32("CGcUfAcrR",9) == 594857156) strcat(s, "i");
if (crc32("sHAuqiVKTSEkoDw",15) == 3625081916) strcat(s, "h");
if (crc32("LbueV",5) == 45530181) strcat(s, "s");
if (crc32("OPRcAbOr",8) == 2291081522) strcat(s, "m");
    return s;
}

char *strangles_nouns() {
    char *s = calloc(10);
    if (crc32("qclbQEPEZuP",11) == 1350844387) strcat(s, "s");
if (crc32("grHrOUzBCiQBi",13) == 4277475194) strcat(s, "t");
if (crc32("weAtAYskJLX",11) == 3044715952) strcat(s, "r");
if (crc32("rEkCVJZrCKGGn",13) == 815787493) strcat(s, "a");
if (crc32("PHEQezrFmINWBm",14) == 2581488556) strcat(s, "n");
if (crc32("xYbAdrPOmySRa",13) == 2934407105) strcat(s, "g");
if (crc32("kMELjU",6) == 583743551) strcat(s, "l");
if (crc32("VOPxVhy",7) == 1496549063) strcat(s, "e");
if (crc32("TsEciWCHra",10) == 874776573) strcat(s, "s");
    return s;
}

char *Alcmaon_nouns() {
    char *s = calloc(8);
    if (crc32("WIbEasu",7) == 1269595484) strcat(s, "C");
if (crc32("YQxjGPYrV",9) == 170841050) strcat(s, "A");
if (crc32("eEARZzOThhpON",13) == 82339143) strcat(s, "j");
if (crc32("meqSbGueHuoJR",13) == 3563785245) strcat(s, "l");
if (crc32("DLtGOFpAZucXCsc",15) == 2939846965) strcat(s, "c");
if (crc32("IEdsednKUrwtkyX",15) == 1835028782) strcat(s, "m");
if (crc32("UTNpOaAJEsKWOKd",15) == 4253206705) strcat(s, "a");
if (crc32("dtIuxqoAaOQC",12) == 3679691249) strcat(s, "o");
if (crc32("tEISedrgiA",10) == 428485302) strcat(s, "c");
if (crc32("ybVMsMBC",8) == 2633126720) strcat(s, "n");
    return s;
}

char *draughter_nouns() {
    char *s = calloc(10);
    if (crc32("vSmHtUwpM",9) == 824081505) strcat(s, "d");
if (crc32("iutlbeQzltWprQ",14) == 1261549733) strcat(s, "r");
if (crc32("JtPTAylAnEzsRL",14) == 11084602) strcat(s, "F");
if (crc32("wmXxiskHkgptor",14) == 1516323283) strcat(s, "a");
if (crc32("SzBoSzVAZAXMIve",15) == 175829282) strcat(s, "u");
if (crc32("WttkvaDLZRtZnha",15) == 2443109499) strcat(s, "H");
if (crc32("pEDzCbPpl",9) == 3838903067) strcat(s, "g");
if (crc32("zBcZjTvdNqLwsVT",15) == 3478072183) strcat(s, "h");
if (crc32("uLhRUP",6) == 1243829582) strcat(s, "t");
if (crc32("WYnVIENtvl",10) == 3012310514) strcat(s, "k");
if (crc32("yYeJTTBQL",9) == 2701462139) strcat(s, "e");
if (crc32("kkhsrq",6) == 2553057564) strcat(s, "B");
if (crc32("kNYagfCXkG",10) == 1028240211) strcat(s, "r");
    return s;
}

char *Whang_nouns() {
    char *s = calloc(6);
    if (crc32("VyLKFhnjDc",10) == 2649406478) strcat(s, "W");
if (crc32("YcbqcXJwo",9) == 2862511693) strcat(s, "h");
if (crc32("PFlrNFowJAniSUg",15) == 2158212794) strcat(s, "s");
if (crc32("rsbwKyYUaQ",10) == 1320969286) strcat(s, "a");
if (crc32("ZgtyMT",6) == 2708070878) strcat(s, "n");
if (crc32("FzosKwWcsdpXfGd",15) == 3561330973) strcat(s, "g");
    return s;
}

char *summability_nouns() {
    char *s = calloc(12);
    if (crc32("ElwkhwjoOuBb",12) == 267458252) strcat(s, "L");
if (crc32("hejwkO",6) == 1643664246) strcat(s, "s");
if (crc32("CrIUvcAnewRoS",13) == 3760205546) strcat(s, "u");
if (crc32("tIAFlVGkG",9) == 4158637967) strcat(s, "M");
if (crc32("KqGFimSNntgx",12) == 1612280032) strcat(s, "m");
if (crc32("ySYKxRt",7) == 2459431234) strcat(s, "m");
if (crc32("nxLiqo",6) == 930301907) strcat(s, "a");
if (crc32("xqUoDFc",7) == 338216389) strcat(s, "b");
if (crc32("pdaeMXFHz",9) == 1699657578) strcat(s, "i");
if (crc32("hZtMVlK",7) == 2910576179) strcat(s, "l");
if (crc32("bdzQvgqyPeymjAq",15) == 1438423829) strcat(s, "i");
if (crc32("uCuYfkVBHUEKrTt",15) == 186941284) strcat(s, "i");
if (crc32("ZdpbjcFDmUOdY",13) == 3983516453) strcat(s, "t");
if (crc32("mPVSLZvLTEN",11) == 300299717) strcat(s, "X");
if (crc32("nqWLkqxPFZxaNLH",15) == 2759103248) strcat(s, "y");
    return s;
}

char *flyby_nouns() {
    char *s = calloc(6);
    if (crc32("vsClzqrbSIHAhNX",15) == 1026968068) strcat(s, "f");
if (crc32("pEpZNenYMeoom",13) == 225565440) strcat(s, "l");
if (crc32("KiUxRwMWhL",10) == 1864761810) strcat(s, "y");
if (crc32("DZCshb",6) == 2250702514) strcat(s, "b");
if (crc32("ukUuFqCjzRZTu",13) == 2651831515) strcat(s, "p");
if (crc32("NFAtTVbep",9) == 1296957102) strcat(s, "y");
    return s;
}

char *djebel_nouns() {
    char *s = calloc(7);
    if (crc32("MWBYmX",6) == 1001117745) strcat(s, "N");
if (crc32("wknXQOKac",9) == 3599244616) strcat(s, "d");
if (crc32("tvedn",5) == 1638114661) strcat(s, "j");
if (crc32("AuvWN",5) == 370243557) strcat(s, "T");
if (crc32("BqItusis",8) == 400927234) strcat(s, "e");
if (crc32("lLPzQyzGYJgy",12) == 3420804254) strcat(s, "u");
if (crc32("LUBcNpZAfDk",11) == 182097285) strcat(s, "b");
if (crc32("tymenca",7) == 1889480592) strcat(s, "c");
if (crc32("VDYYwpoZHaJPSJ",14) == 1676426811) strcat(s, "e");
if (crc32("vMosgCmQFQSC",12) == 4146755356) strcat(s, "l");
    return s;
}

char *postremogeniture_nouns() {
    char *s = calloc(17);
    if (crc32("yxNtI",5) == 69104736) strcat(s, "W");
if (crc32("xZVKeNYC",8) == 2593534155) strcat(s, "p");
if (crc32("LJOAzYJroQtu",12) == 3446862794) strcat(s, "b");
if (crc32("wschqkKUjHH",11) == 960184063) strcat(s, "o");
if (crc32("vFcJgJIluZmgQw",14) == 2001692927) strcat(s, "s");
if (crc32("qZjWtjCskiQXZ",13) == 2142693798) strcat(s, "t");
if (crc32("nSnmPiZgOHsbdB",14) == 2259322168) strcat(s, "r");
if (crc32("EBpIkKqvLXDKqG",14) == 476122037) strcat(s, "e");
if (crc32("RGSntifLRBl",11) == 2693935874) strcat(s, "m");
if (crc32("banHSV",6) == 3863148305) strcat(s, "o");
if (crc32("EtaFlDyts",9) == 336221172) strcat(s, "x");
if (crc32("wjvJwNxSBjBxrE",14) == 456803712) strcat(s, "g");
if (crc32("bSfoAbYdhIYaLlF",15) == 3551884407) strcat(s, "e");
if (crc32("MWHTNEEEKPeFy",13) == 3144605932) strcat(s, "i");
if (crc32("rtIMdfLeBjuOhh",14) == 407928685) strcat(s, "n");
if (crc32("YDAxWHco",8) == 1847415706) strcat(s, "T");
if (crc32("NQSCCdYoFcvU",12) == 3490299684) strcat(s, "i");
if (crc32("VWfccbad",8) == 1155509199) strcat(s, "t");
if (crc32("zUUNzCwUL",9) == 153540745) strcat(s, "u");
if (crc32("GaNZZNkQ",8) == 2812260241) strcat(s, "Y");
if (crc32("JflmbIdRC",9) == 1847947652) strcat(s, "r");
if (crc32("TJNgvhkuPLaF",12) == 411955967) strcat(s, "e");
    return s;
}

char *halfpeck_nouns() {
    char *s = calloc(9);
    if (crc32("tHuUgcCJL",9) == 1452037114) strcat(s, "h");
if (crc32("RiKuHVqoiSq",11) == 629586385) strcat(s, "a");
if (crc32("tVhyeeacoM",10) == 1299616272) strcat(s, "l");
if (crc32("JJRDgMoQDglEsI",14) == 1751286529) strcat(s, "W");
if (crc32("McrhVDrAFMqE",12) == 4294141075) strcat(s, "f");
if (crc32("WXDXqFRzKDnuDp",14) == 1179843494) strcat(s, "x");
if (crc32("aUIzTwyZ",8) == 4079584995) strcat(s, "p");
if (crc32("ICzxeDHDpiii",12) == 3799866115) strcat(s, "Z");
if (crc32("jWhIbQkIdn",10) == 2572760911) strcat(s, "e");
if (crc32("JibCNCsBFJP",11) == 2691221591) strcat(s, "c");
if (crc32("DsEsVeD",7) == 1458547207) strcat(s, "G");
if (crc32("JaYgKLNs",8) == 1649303018) strcat(s, "k");
    return s;
}

char *Terah_nouns() {
    char *s = calloc(6);
    if (crc32("LuuVu",5) == 42825814) strcat(s, "Y");
if (crc32("XzgNfsBWGE",10) == 1667363329) strcat(s, "T");
if (crc32("SocbSb",6) == 707618430) strcat(s, "Z");
if (crc32("YFCdfv",6) == 21944690) strcat(s, "e");
if (crc32("nySjiswdfNs",11) == 531530198) strcat(s, "K");
if (crc32("OhxSGEURLmzknB",14) == 705125174) strcat(s, "r");
if (crc32("yAWkNFqzYtFZNBJ",15) == 3760175635) strcat(s, "a");
if (crc32("UDEimygrUpf",11) == 2643922320) strcat(s, "p");
if (crc32("fieHc",5) == 880357725) strcat(s, "h");
    return s;
}

char *fetich_nouns() {
    char *s = calloc(7);
    if (crc32("iWRkBXCey",9) == 620959190) strcat(s, "F");
if (crc32("BxzdhrSa",8) == 366102292) strcat(s, "f");
if (crc32("PEquiP",6) == 1941082677) strcat(s, "e");
if (crc32("whwuyq",6) == 1938428381) strcat(s, "t");
if (crc32("utaOMo",6) == 2264493252) strcat(s, "i");
if (crc32("zuXKi",5) == 1827500007) strcat(s, "c");
if (crc32("WnBGKrWBJc",10) == 3683881422) strcat(s, "h");
    return s;
}

char *paling_nouns() {
    char *s = calloc(7);
    if (crc32("HUBlwKefLtv",11) == 2808857224) strcat(s, "p");
if (crc32("Yfjmz",5) == 2453681075) strcat(s, "d");
if (crc32("xxOOWfmytck",11) == 3010264077) strcat(s, "a");
if (crc32("wxIjaGzCfcSwENC",15) == 1548069363) strcat(s, "l");
if (crc32("TolwpG",6) == 3665203317) strcat(s, "i");
if (crc32("jYetjSGqCBnGtw",14) == 1975435711) strcat(s, "P");
if (crc32("lJPbimmYvHXwUs",14) == 1572903079) strcat(s, "n");
if (crc32("rFLYZRAQMz",10) == 550918423) strcat(s, "g");
    return s;
}

char *Bora_nouns() {
    char *s = calloc(5);
    if (crc32("genkpXzB",8) == 1350041960) strcat(s, "V");
if (crc32("KIwExowwRihdAdq",15) == 3293725725) strcat(s, "B");
if (crc32("alPtN",5) == 2768969614) strcat(s, "o");
if (crc32("ZyYmm",5) == 579588689) strcat(s, "r");
if (crc32("EFhIOSAPBsyFdU",14) == 3342905953) strcat(s, "u");
if (crc32("mmvJZR",6) == 2455927947) strcat(s, "a");
    return s;
}

char *Mbandaka_nouns() {
    char *s = calloc(9);
    if (crc32("nmErbaQKnpk",11) == 381537487) strcat(s, "M");
if (crc32("oxCttlCdv",9) == 1220523850) strcat(s, "b");
if (crc32("nPIGWs",6) == 336619429) strcat(s, "a");
if (crc32("qJbQD",5) == 1870360809) strcat(s, "n");
if (crc32("FtlERVfp",8) == 390451221) strcat(s, "d");
if (crc32("SGnQSxOazGH",11) == 1933526005) strcat(s, "m");
if (crc32("jyJoUVEhG",9) == 2832885989) strcat(s, "a");
if (crc32("xVqebmH",7) == 3097207618) strcat(s, "s");
if (crc32("HeuersIA",8) == 4211620456) strcat(s, "k");
if (crc32("vkueE",5) == 277942838) strcat(s, "a");
    return s;
}

char *Kesteven_nouns() {
    char *s = calloc(9);
    if (crc32("LJcltWRzI",9) == 1291468867) strcat(s, "K");
if (crc32("xDaDSUGouza",11) == 609197851) strcat(s, "e");
if (crc32("JasDQQI",7) == 2789064626) strcat(s, "f");
if (crc32("ieewCHJBobOd",12) == 93264135) strcat(s, "s");
if (crc32("UdatYqZv",8) == 3538154325) strcat(s, "t");
if (crc32("lnmipJVN",8) == 1913678418) strcat(s, "e");
if (crc32("MflZbBsHkqyvzk",14) == 2941193665) strcat(s, "Q");
if (crc32("JGBGi",5) == 720015073) strcat(s, "v");
if (crc32("AFTEuHIzkBys",12) == 1790788243) strcat(s, "e");
if (crc32("ELPXv",5) == 541846084) strcat(s, "n");
    return s;
}

char *stroboscope_nouns() {
    char *s = calloc(12);
    if (crc32("dcCoNDdAj",9) == 3439788592) strcat(s, "I");
if (crc32("JDcazkD",7) == 436796075) strcat(s, "s");
if (crc32("ppGYDfKobpxewxs",15) == 414055784) strcat(s, "t");
if (crc32("sbVCm",5) == 1763246507) strcat(s, "r");
if (crc32("zBfeYMcmaUU",11) == 1527465871) strcat(s, "R");
if (crc32("WyXzmBqbTn",10) == 1355676874) strcat(s, "o");
if (crc32("ShjHEYPeKEnEb",13) == 682308064) strcat(s, "l");
if (crc32("CXRaulGFTUdzNWg",15) == 1816690889) strcat(s, "b");
if (crc32("whLiniIvPN",10) == 1272660543) strcat(s, "o");
if (crc32("Uppuvkv",7) == 763614793) strcat(s, "s");
if (crc32("DMkrA",5) == 1518323655) strcat(s, "c");
if (crc32("OyuCfpzjxCXC",12) == 2298853190) strcat(s, "o");
if (crc32("yzTXugBiGRkWT",13) == 1410342228) strcat(s, "p");
if (crc32("CIylGOv",7) == 1296230321) strcat(s, "d");
if (crc32("SuLrK",5) == 1626858848) strcat(s, "e");
    return s;
}

char *Delmer_nouns() {
    char *s = calloc(7);
    if (crc32("CnHzLOgCVZAo",12) == 2879071890) strcat(s, "D");
if (crc32("uKFuJq",6) == 81731574) strcat(s, "e");
if (crc32("RHbRttzx",8) == 1048689923) strcat(s, "l");
if (crc32("wjUpm",5) == 4239820474) strcat(s, "H");
if (crc32("DRcOqQ",6) == 533057207) strcat(s, "m");
if (crc32("dTFiMMnmzCQBQ",13) == 690189557) strcat(s, "l");
if (crc32("AmUOHOcgntn",11) == 3266935676) strcat(s, "e");
if (crc32("KszSrCrzEAmGo",13) == 1908594771) strcat(s, "r");
    return s;
}

char *vertebra_nouns() {
    char *s = calloc(9);
    if (crc32("DJBKkRFZc",9) == 71299908) strcat(s, "v");
if (crc32("ZeUpWUEnRZlcIq",14) == 138708336) strcat(s, "J");
if (crc32("NrpqJXkCMQ",10) == 973291656) strcat(s, "e");
if (crc32("LnRJGKalR",9) == 2730060193) strcat(s, "r");
if (crc32("SreQkNBHYwOoObp",15) == 630524292) strcat(s, "A");
if (crc32("CRKMMoUeVVZ",11) == 1485319191) strcat(s, "t");
if (crc32("gqdNRGNDhNOu",12) == 1522660056) strcat(s, "t");
if (crc32("cMCIGjEZMcfTS",13) == 2523225571) strcat(s, "e");
if (crc32("aLSdURMlwm",10) == 604450407) strcat(s, "b");
if (crc32("kHtYzaRKoq",10) == 3889686128) strcat(s, "r");
if (crc32("fHjff",5) == 354829003) strcat(s, "e");
if (crc32("wtHAi",5) == 3389556681) strcat(s, "a");
    return s;
}

char *bouchon_nouns() {
    char *s = calloc(8);
    if (crc32("vSOLC",5) == 250534938) strcat(s, "d");
if (crc32("ArqrWCYZOfER",12) == 1172814904) strcat(s, "b");
if (crc32("iSdFqZvUaMEx",12) == 3089739903) strcat(s, "o");
if (crc32("isJQWh",6) == 3500914635) strcat(s, "T");
if (crc32("jlOdHYoxOsydL",13) == 3093452847) strcat(s, "u");
if (crc32("uPcTK",5) == 1230365233) strcat(s, "c");
if (crc32("ZrDLHLzPCbZsWJ",14) == 3072767969) strcat(s, "w");
if (crc32("vXrHWCXyQElmGAu",15) == 2786877950) strcat(s, "h");
if (crc32("dEIFURcKppF",11) == 3236122318) strcat(s, "U");
if (crc32("hlGeIpCfuBWytaH",15) == 290051982) strcat(s, "o");
if (crc32("aBROOrCymJG",11) == 1169263286) strcat(s, "Q");
if (crc32("hWzQQYmbGzSDQ",13) == 3522402996) strcat(s, "n");
    return s;
}

char *Sylvanus_nouns() {
    char *s = calloc(9);
    if (crc32("lNLdBTalnZLmR",13) == 3873267028) strcat(s, "e");
if (crc32("gGUhVYK",7) == 755442833) strcat(s, "S");
if (crc32("OUxIFYt",7) == 349461849) strcat(s, "y");
if (crc32("FkGwiVzLFd",10) == 27884603) strcat(s, "n");
if (crc32("GiydUqAigjbreUl",15) == 2899741218) strcat(s, "l");
if (crc32("ErxBaeMNTdrCAp",14) == 490128279) strcat(s, "v");
if (crc32("xSQMP",5) == 1001115390) strcat(s, "I");
if (crc32("lsbpykjxPxn",11) == 3043536853) strcat(s, "a");
if (crc32("YGpWuxG",7) == 1803264673) strcat(s, "P");
if (crc32("gWCfwSepJSGDnN",14) == 1390230253) strcat(s, "n");
if (crc32("LXMdntKiNHd",11) == 1277615953) strcat(s, "u");
if (crc32("ckxMPk",6) == 817795502) strcat(s, "W");
if (crc32("kJHKmeqtWRk",11) == 704559638) strcat(s, "s");
    return s;
}

char *sheading_nouns() {
    char *s = calloc(9);
    if (crc32("zUYKDBKav",9) == 4226277719) strcat(s, "m");
if (crc32("apULFmaefCJt",12) == 4145889925) strcat(s, "s");
if (crc32("jpzaknyKtI",10) == 2221709420) strcat(s, "C");
if (crc32("RKRspc",6) == 328218931) strcat(s, "h");
if (crc32("zgIHqJu",7) == 3020686664) strcat(s, "e");
if (crc32("gnOtEpvh",8) == 1499256375) strcat(s, "m");
if (crc32("GNCHs",5) == 3561654872) strcat(s, "a");
if (crc32("piiluxXg",8) == 64145904) strcat(s, "d");
if (crc32("IesevAuhD",9) == 1617872415) strcat(s, "d");
if (crc32("NPPOYqiTRzgbEh",14) == 1088324750) strcat(s, "i");
if (crc32("eyDuANmEaMkMw",13) == 2443767409) strcat(s, "n");
if (crc32("pyKppnsAgI",10) == 3507666636) strcat(s, "g");
    return s;
}

char *immensurability_nouns() {
    char *s = calloc(16);
    if (crc32("JrynSdHfrjPoQo",14) == 19760664) strcat(s, "i");
if (crc32("JRnKWnYBgvydl",13) == 1617045970) strcat(s, "m");
if (crc32("VtGypFxkutdbjns",15) == 55719752) strcat(s, "W");
if (crc32("DBqSQMgi",8) == 2978827929) strcat(s, "m");
if (crc32("FTGaSWQQwNwr",12) == 4134611484) strcat(s, "e");
if (crc32("towgdzGHSL",10) == 2976112238) strcat(s, "C");
if (crc32("CpzBVtAgONOlZFk",15) == 4153216146) strcat(s, "n");
if (crc32("vnnwDvZ",7) == 1971865290) strcat(s, "s");
if (crc32("HZdEiSZdjSRYgU",14) == 620750166) strcat(s, "u");
if (crc32("ovQQUqQ",7) == 4226490604) strcat(s, "R");
if (crc32("phOnRIq",7) == 4252533490) strcat(s, "r");
if (crc32("DqdnSmEYXSODXvd",15) == 342179168) strcat(s, "E");
if (crc32("MMeFgyCoUhEGfdW",15) == 4259215265) strcat(s, "a");
if (crc32("UKDkwJDlo",9) == 2764151079) strcat(s, "b");
if (crc32("MkqsdwOI",8) == 2524049085) strcat(s, "V");
if (crc32("PJaTzwQWDbTV",12) == 949401085) strcat(s, "i");
if (crc32("IzQaZNYbotNL",12) == 2303192233) strcat(s, "x");
if (crc32("xFbzGswwunfEBw",14) == 4006382709) strcat(s, "l");
if (crc32("cRUibMaKLptru",13) == 1161004928) strcat(s, "v");
if (crc32("wTWIofdjL",9) == 3339415098) strcat(s, "i");
if (crc32("dVOwBEptfwnDq",13) == 3210425811) strcat(s, "t");
if (crc32("duUDJKToK",9) == 1328757644) strcat(s, "Z");
if (crc32("JcrLO",5) == 271060782) strcat(s, "y");
    return s;
}

char *Gillray_nouns() {
    char *s = calloc(8);
    if (crc32("fUayM",5) == 2466698469) strcat(s, "G");
if (crc32("XjvnfCEcitcHlec",15) == 4090545919) strcat(s, "v");
if (crc32("WKBKLzBVSSyJT",13) == 1171045943) strcat(s, "i");
if (crc32("zrNoxORHwNiwOG",14) == 778135487) strcat(s, "x");
if (crc32("XwZEYEnN",8) == 1566965930) strcat(s, "l");
if (crc32("GWdaqjfYUX",10) == 3924107834) strcat(s, "p");
if (crc32("OgEiGfBi",8) == 2894188749) strcat(s, "l");
if (crc32("yCyny",5) == 851861022) strcat(s, "r");
if (crc32("uyxobQjiJTQ",11) == 1577030154) strcat(s, "a");
if (crc32("cwJhYPhmeLmxh",13) == 1672356050) strcat(s, "U");
if (crc32("hRXeCCoGgSxdGE",14) == 879823680) strcat(s, "y");
    return s;
}

char *airlift_nouns() {
    char *s = calloc(8);
    if (crc32("IwypLcPlMppfq",13) == 1395718902) strcat(s, "B");
if (crc32("YKhqPdO",7) == 3207704274) strcat(s, "a");
if (crc32("GWDZAPvALumf",12) == 2119333738) strcat(s, "s");
if (crc32("NzaRpNMkDcA",11) == 4281322683) strcat(s, "i");
if (crc32("apawrGLqZXb",11) == 1992721867) strcat(s, "r");
if (crc32("MfKjMvZYHkee",12) == 2310461300) strcat(s, "X");
if (crc32("UfVmzhKVgPRbGw",14) == 3503152303) strcat(s, "l");
if (crc32("gWdfDYDSbiIQDB",14) == 2140556065) strcat(s, "i");
if (crc32("VpGiWVHXDOxKr",13) == 4113290147) strcat(s, "z");
if (crc32("EoDfsxmhMTnlx",13) == 3338036156) strcat(s, "f");
if (crc32("qKKooNU",7) == 1760956249) strcat(s, "c");
if (crc32("BMTjWGMQjbh",11) == 2523760304) strcat(s, "t");
    return s;
}

char *cacogenics_nouns() {
    char *s = calloc(11);
    if (crc32("sgEFVxAScwwYZCC",15) == 7774245) strcat(s, "A");
if (crc32("VxsEKxvBr",9) == 3077652288) strcat(s, "c");
if (crc32("abesDZnS",8) == 3083332029) strcat(s, "o");
if (crc32("WQWIlLzUrhKC",12) == 2263937003) strcat(s, "a");
if (crc32("tJiLgNDd",8) == 4066723061) strcat(s, "R");
if (crc32("gMhnsCgCGOwyee",14) == 4215208367) strcat(s, "c");
if (crc32("zWnJtLkNwsO",11) == 1181089061) strcat(s, "o");
if (crc32("GrJYnxZF",8) == 3763794683) strcat(s, "O");
if (crc32("GyNpakHkllQS",12) == 863461475) strcat(s, "g");
if (crc32("pmVzNXUhHmiPj",13) == 2730029974) strcat(s, "x");
if (crc32("fgTuZkYDwAm",11) == 1693404116) strcat(s, "e");
if (crc32("lQwMgMrE",8) == 344741469) strcat(s, "n");
if (crc32("lxzsU",5) == 1645205706) strcat(s, "p");
if (crc32("GBbYBxG",7) == 2011637128) strcat(s, "i");
if (crc32("tGGoG",5) == 2787078224) strcat(s, "f");
if (crc32("JgBztNNJ",8) == 70679850) strcat(s, "c");
if (crc32("ScrXDmnt",8) == 2752530073) strcat(s, "P");
if (crc32("wqjSvBZcTZxV",12) == 322381002) strcat(s, "s");
    return s;
}

char *Cern_nouns() {
    char *s = calloc(5);
    if (crc32("FFZOwzs",7) == 2667587170) strcat(s, "C");
if (crc32("bNXsWmfldfB",11) == 2726671498) strcat(s, "W");
if (crc32("RlnECmIyyXZVOE",14) == 3958377109) strcat(s, "e");
if (crc32("GbpnyPcxkGw",11) == 2704518860) strcat(s, "g");
if (crc32("jYptnxeLFdDMuT",14) == 331588846) strcat(s, "r");
if (crc32("SGuMwqHuE",9) == 824072997) strcat(s, "n");
    return s;
}

char *toxophily_nouns() {
    char *s = calloc(10);
    if (crc32("TjvvpmuWZ",9) == 2455859469) strcat(s, "i");
if (crc32("QadqwQTDKOYqtu",14) == 2340463368) strcat(s, "t");
if (crc32("hBtwdqBczS",10) == 3570612461) strcat(s, "Y");
if (crc32("jMEFFPINKaDsM",13) == 1788188521) strcat(s, "o");
if (crc32("SxylDseHdvoByd",14) == 793976004) strcat(s, "P");
if (crc32("qplYZ",5) == 3366318669) strcat(s, "x");
if (crc32("XFkwyO",6) == 334050300) strcat(s, "o");
if (crc32("wchVLxQ",7) == 4293773029) strcat(s, "o");
if (crc32("ZiCGMxGF",8) == 114402401) strcat(s, "x");
if (crc32("tzQgttAtFqdpQn",14) == 666059731) strcat(s, "p");
if (crc32("hSzycFKzL",9) == 146203841) strcat(s, "h");
if (crc32("HMUxDRSOC",9) == 2650718616) strcat(s, "i");
if (crc32("ozvNtEKjgaha",12) == 417901712) strcat(s, "M");
if (crc32("ZJBsxFom",8) == 3064412324) strcat(s, "l");
if (crc32("wJmnTWSZZF",10) == 1841320238) strcat(s, "M");
if (crc32("WebZCclGGM",10) == 1609786077) strcat(s, "y");
    return s;
}

char *blinks_nouns() {
    char *s = calloc(7);
    if (crc32("ApSwUtpFZzRenXs",15) == 3869170394) strcat(s, "s");
if (crc32("eSVBdJWauTWn",12) == 129042454) strcat(s, "b");
if (crc32("EiBJmQlZTJXu",12) == 3580894331) strcat(s, "o");
if (crc32("zNyxvGX",7) == 815473964) strcat(s, "l");
if (crc32("pEJUaayXzVVrKKX",15) == 2893757143) strcat(s, "i");
if (crc32("smkkMp",6) == 3768678791) strcat(s, "n");
if (crc32("NBTaC",5) == 3900329251) strcat(s, "k");
if (crc32("nSRqGsRBvR",10) == 2315853666) strcat(s, "N");
if (crc32("GHXyuB",6) == 1411338594) strcat(s, "s");
    return s;
}

char *nonfamily_nouns() {
    char *s = calloc(10);
    if (crc32("ynbbiEnfwbJZ",12) == 1587893902) strcat(s, "A");
if (crc32("ObHNr",5) == 601270766) strcat(s, "n");
if (crc32("GYuYBiCtHIu",11) == 1502936162) strcat(s, "o");
if (crc32("iYjuKL",6) == 1342041570) strcat(s, "H");
if (crc32("KFKEdNm",7) == 2477771337) strcat(s, "n");
if (crc32("wAfrTYeVIefMt",13) == 1536048370) strcat(s, "H");
if (crc32("kySLCHe",7) == 3777342133) strcat(s, "f");
if (crc32("lwFZYaWgIfNUGJy",15) == 669070219) strcat(s, "a");
if (crc32("WfVoyOkNhoOQqu",14) == 4165270533) strcat(s, "m");
if (crc32("PrPLxokjSExSvC",14) == 2128894166) strcat(s, "B");
if (crc32("itAZEVyGQuYTHrn",15) == 2901256899) strcat(s, "i");
if (crc32("HrAfSMKPEETbcn",14) == 1692970842) strcat(s, "l");
if (crc32("aoljBkladhG",11) == 3516002921) strcat(s, "b");
if (crc32("DJUOOwgeptQvb",13) == 3589421631) strcat(s, "y");
    return s;
}

char *bouldering_nouns() {
    char *s = calloc(11);
    if (crc32("FVfdoytRXMlu",12) == 2905940060) strcat(s, "x");
if (crc32("REELILYlLzLs",12) == 2481038482) strcat(s, "b");
if (crc32("rqzVMFAklqsSSdJ",15) == 1457985896) strcat(s, "I");
if (crc32("GBWcLhwjsgZAm",13) == 1615239980) strcat(s, "o");
if (crc32("NkkTnMGZWFtYI",13) == 984068543) strcat(s, "N");
if (crc32("QDyTnIPPsn",10) == 1007911806) strcat(s, "u");
if (crc32("kSDKPZJ",7) == 1189136467) strcat(s, "x");
if (crc32("DzwcDMmFlNHVKn",14) == 1404822566) strcat(s, "l");
if (crc32("ycXwTeQH",8) == 379093350) strcat(s, "d");
if (crc32("ydSGluzV",8) == 644330057) strcat(s, "p");
if (crc32("lpldDXQZ",8) == 1129169031) strcat(s, "e");
if (crc32("yyrdigm",7) == 2707346782) strcat(s, "r");
if (crc32("dsvkiFd",7) == 3681504377) strcat(s, "O");
if (crc32("vwmwRY",6) == 629404717) strcat(s, "i");
if (crc32("ILlBOUvoORW",11) == 3138727818) strcat(s, "p");
if (crc32("oglxNiKaBOw",11) == 60453885) strcat(s, "n");
if (crc32("bvSoSvSUmxISSk",14) == 3956689066) strcat(s, "g");
    return s;
}

char *unchangingness_nouns() {
    char *s = calloc(15);
    if (crc32("zkblCyv",7) == 268625467) strcat(s, "u");
if (crc32("IJVJfKpSK",9) == 1207395857) strcat(s, "D");
if (crc32("QGqysXnPeKMjMio",15) == 1331266576) strcat(s, "n");
if (crc32("MNsNXZzIZaZSYZ",14) == 890234505) strcat(s, "c");
if (crc32("kkYbwjcROAn",11) == 2060648247) strcat(s, "h");
if (crc32("rpklLxGGzPujE",13) == 3753062439) strcat(s, "i");
if (crc32("KhhabmZTs",9) == 2659185732) strcat(s, "a");
if (crc32("oHcgWcuzzXOO",12) == 1262037725) strcat(s, "q");
if (crc32("jSGxlY",6) == 3770723347) strcat(s, "n");
if (crc32("VKBiS",5) == 136813380) strcat(s, "g");
if (crc32("RbIIgBZATm",10) == 3292645122) strcat(s, "i");
if (crc32("UOuXCSCl",8) == 3776997804) strcat(s, "n");
if (crc32("iKVwyYiC",8) == 1394583714) strcat(s, "g");
if (crc32("FnuMLdfqopLD",12) == 2559136548) strcat(s, "n");
if (crc32("OSCzaMhlq",9) == 2255703194) strcat(s, "e");
if (crc32("UglUPlVXg",9) == 1847826361) strcat(s, "p");
if (crc32("RSFnNivngI",10) == 2837372028) strcat(s, "s");
if (crc32("HxrKh",5) == 129740668) strcat(s, "s");
    return s;
}

char *advocation_nouns() {
    char *s = calloc(11);
    if (crc32("WSfkvUDapOetwgH",15) == 479068653) strcat(s, "a");
if (crc32("YXiHem",6) == 2243137067) strcat(s, "C");
if (crc32("eZibwrelkdV",11) == 237011300) strcat(s, "d");
if (crc32("CLoaYA",6) == 3858742640) strcat(s, "v");
if (crc32("vBEreTP",7) == 3238872447) strcat(s, "o");
if (crc32("AXiYXPOdwfgZPD",14) == 3017540236) strcat(s, "o");
if (crc32("SJcIO",5) == 3555609880) strcat(s, "z");
if (crc32("LHHoFSeL",8) == 603479577) strcat(s, "c");
if (crc32("MfGAqRzix",9) == 2361983436) strcat(s, "a");
if (crc32("aRvmjMh",7) == 231447990) strcat(s, "t");
if (crc32("TxIDoT",6) == 4036202594) strcat(s, "i");
if (crc32("DmTZGwzfnSWaPvK",15) == 2576617111) strcat(s, "F");
if (crc32("JfEvb",5) == 1722060293) strcat(s, "o");
if (crc32("wHeqPiUXcBxiOAS",15) == 1754521595) strcat(s, "n");
    return s;
}

char *Macnair_nouns() {
    char *s = calloc(8);
    if (crc32("kKZTAixPy",9) == 4043095908) strcat(s, "R");
if (crc32("IKsqVFFrJxNmvTS",15) == 3356758601) strcat(s, "M");
if (crc32("UKkVEHRHUpGamCX",15) == 1072893855) strcat(s, "a");
if (crc32("wKaqj",5) == 328430872) strcat(s, "c");
if (crc32("WiGgXHEgH",9) == 749933283) strcat(s, "l");
if (crc32("SOaNEY",6) == 2270983902) strcat(s, "n");
if (crc32("IKXJZwQFrJnzLfo",15) == 1619537646) strcat(s, "l");
if (crc32("txwUReQ",7) == 3200607227) strcat(s, "a");
if (crc32("RLDUmbRqnp",10) == 1914900197) strcat(s, "i");
if (crc32("ohziifI",7) == 2665330835) strcat(s, "L");
if (crc32("WHWlbLtzcABs",12) == 3743342510) strcat(s, "r");
    return s;
}

char *Buzz_nouns() {
    char *s = calloc(5);
    if (crc32("aTxBmhBk",8) == 2867770821) strcat(s, "I");
if (crc32("FwOuxYXi",8) == 3888758348) strcat(s, "B");
if (crc32("qMermQYsyUkHzZ",14) == 2396767869) strcat(s, "N");
if (crc32("XUDYJRYxsPZR",12) == 1071168322) strcat(s, "u");
if (crc32("PHVJvBgzdfE",11) == 625506114) strcat(s, "j");
if (crc32("ePvXbNvs",8) == 1353093987) strcat(s, "z");
if (crc32("MEulf",5) == 4113074583) strcat(s, "z");
    return s;
}

char *CAVU_nouns() {
    char *s = calloc(5);
    if (crc32("LuLtvC",6) == 1099147936) strcat(s, "V");
if (crc32("ZSZMbAtWFhWC",12) == 1166605873) strcat(s, "C");
if (crc32("PcdjOBXHkD",10) == 530747893) strcat(s, "A");
if (crc32("XNJIyoGcWxmGsp",14) == 2358337616) strcat(s, "C");
if (crc32("SqDThnXtuKPf",12) == 3175063445) strcat(s, "V");
if (crc32("EHRBRw",6) == 3525471290) strcat(s, "U");
    return s;
}

char *Aragats_nouns() {
    char *s = calloc(8);
    if (crc32("CSkbDR",6) == 546093106) strcat(s, "K");
if (crc32("SJScmlSyjtcQCE",14) == 2415221732) strcat(s, "A");
if (crc32("GAbYwKQCHkPmjCQ",15) == 236852125) strcat(s, "f");
if (crc32("OFAnTtGSHzIH",12) == 416886171) strcat(s, "r");
if (crc32("OyXVdAUw",8) == 2257815056) strcat(s, "M");
if (crc32("YzlmQolIl",9) == 3209739931) strcat(s, "a");
if (crc32("hwlzCBPWn",9) == 1552596222) strcat(s, "g");
if (crc32("nDwoO",5) == 2716771559) strcat(s, "a");
if (crc32("TLEBH",5) == 376099485) strcat(s, "t");
if (crc32("XerrQ",5) == 2494149134) strcat(s, "s");
    return s;
}

char *Capt_nouns() {
    char *s = calloc(5);
    if (crc32("uFilT",5) == 2871516842) strcat(s, "C");
if (crc32("ubYSgOWqE",9) == 1134609764) strcat(s, "a");
if (crc32("nHnQAIdFbnmV",12) == 2373307088) strcat(s, "p");
if (crc32("ZYwofHIQrOPBOZ",14) == 3953160014) strcat(s, "t");
    return s;
}

char *Newhaven_nouns() {
    char *s = calloc(9);
    if (crc32("nLzvxZrxtTa",11) == 176209331) strcat(s, "N");
if (crc32("waPBzFEDQq",10) == 407164676) strcat(s, "e");
if (crc32("BXThyP",6) == 3717934417) strcat(s, "e");
if (crc32("ngMckhfMwYd",11) == 1235614335) strcat(s, "w");
if (crc32("ufrTBEKPFPQm",12) == 3224951716) strcat(s, "h");
if (crc32("cyOtYloIOMPElDn",15) == 1748656212) strcat(s, "v");
if (crc32("KqhSOpJYHKP",11) == 2688484779) strcat(s, "a");
if (crc32("HKmVwZsTcxk",11) == 1457770538) strcat(s, "v");
if (crc32("fgkKCnrKNp",10) == 3761554733) strcat(s, "e");
if (crc32("rLpvMWnbQYCQYO",14) == 4034596721) strcat(s, "n");
    return s;
}

char *N_nouns() {
    char *s = calloc(2);
    if (crc32("zpBazriFh",9) == 4025488869) strcat(s, "N");
    return s;
}

char *Roche_nouns() {
    char *s = calloc(6);
    if (crc32("SZboAMTssYqNW",13) == 2730546027) strcat(s, "R");
if (crc32("fMCAwjulIOKOp",13) == 3897357865) strcat(s, "o");
if (crc32("uuwXlZeIUG",10) == 2855252587) strcat(s, "Z");
if (crc32("gXPaabsEZ",9) == 3721367854) strcat(s, "c");
if (crc32("LiPID",5) == 1968199718) strcat(s, "l");
if (crc32("JRWswoYHlXtSG",13) == 2768182503) strcat(s, "h");
if (crc32("wJTKcIwue",9) == 1127286013) strcat(s, "O");
if (crc32("ZCLpAfEzHjKJru",14) == 2753053818) strcat(s, "e");
    return s;
}

char *permeability_nouns() {
    char *s = calloc(13);
    if (crc32("KOexmPpwZdvn",12) == 332129687) strcat(s, "p");
if (crc32("JmlyhjACh",9) == 2463918965) strcat(s, "e");
if (crc32("IjtqcY",6) == 3886650334) strcat(s, "n");
if (crc32("xhlgZfpFoxXSr",13) == 2489498245) strcat(s, "r");
if (crc32("FCnlBWiUBPjtJ",13) == 1595636508) strcat(s, "e");
if (crc32("sfvMuDm",7) == 1954632031) strcat(s, "m");
if (crc32("zzIcSiYPGKfO",12) == 2595310675) strcat(s, "N");
if (crc32("xHswAUxHCShonT",14) == 4131133046) strcat(s, "e");
if (crc32("kRgIo",5) == 1416831154) strcat(s, "Y");
if (crc32("MWKalwKasb",10) == 1369568935) strcat(s, "a");
if (crc32("TzkOco",6) == 1546318894) strcat(s, "s");
if (crc32("UTYpR",5) == 3146347330) strcat(s, "b");
if (crc32("OVemDTtLUTATj",13) == 108082828) strcat(s, "r");
if (crc32("HOTuj",5) == 4182519655) strcat(s, "i");
if (crc32("BusuBAQ",7) == 2657518870) strcat(s, "Y");
if (crc32("zTciMMmGC",9) == 514991536) strcat(s, "l");
if (crc32("uhrVCesvtCehbc",14) == 995059674) strcat(s, "i");
if (crc32("zQieYoVMd",9) == 1835054470) strcat(s, "t");
if (crc32("IBLHPiX",7) == 1895802545) strcat(s, "y");
    return s;
}

char *Islamite_nouns() {
    char *s = calloc(9);
    if (crc32("WDzCA",5) == 3683560426) strcat(s, "I");
if (crc32("EMsiSxkSXxiKsUM",15) == 3642656132) strcat(s, "l");
if (crc32("ZespGGPuXjNt",12) == 2363812456) strcat(s, "s");
if (crc32("awqWg",5) == 2671273087) strcat(s, "k");
if (crc32("GukhmJDjJW",10) == 411497074) strcat(s, "l");
if (crc32("CfvnORCxWMLcP",13) == 1052452605) strcat(s, "T");
if (crc32("sPOrKNqhvNhXgp",14) == 3725822105) strcat(s, "a");
if (crc32("JWXRgYEl",8) == 2509606130) strcat(s, "m");
if (crc32("XzanmCeWb",9) == 3253535602) strcat(s, "p");
if (crc32("MrTDqhnjdXaoi",13) == 163000095) strcat(s, "i");
if (crc32("sgIwGmK",7) == 2996739712) strcat(s, "t");
if (crc32("ucBEWp",6) == 3591132542) strcat(s, "e");
    return s;
}

char *restorableness_nouns() {
    char *s = calloc(15);
    if (crc32("OsiEn",5) == 2498312725) strcat(s, "v");
if (crc32("VTrQHEPuZYS",11) == 3088706083) strcat(s, "r");
if (crc32("RFagMLpU",8) == 2575316218) strcat(s, "e");
if (crc32("SJWKqmgsbezp",12) == 2015805638) strcat(s, "s");
if (crc32("RxRxEnHBCWRPtJm",15) == 2188563874) strcat(s, "t");
if (crc32("eIqftvCiW",9) == 595042356) strcat(s, "o");
if (crc32("eaSPbgup",8) == 3155926487) strcat(s, "r");
if (crc32("zvTGwYiqpHwTH",13) == 2689524946) strcat(s, "a");
if (crc32("oUMDBm",6) == 550307208) strcat(s, "t");
if (crc32("RVWjy",5) == 3048163656) strcat(s, "b");
if (crc32("JcYZi",5) == 3936720389) strcat(s, "l");
if (crc32("eMgEsKBmSABpo",13) == 3036572471) strcat(s, "J");
if (crc32("YDZvBSczfydoE",13) == 1126886624) strcat(s, "e");
if (crc32("QYxbukEFoTMCfJe",15) == 683688326) strcat(s, "n");
if (crc32("BeTiLpPLn",9) == 327017066) strcat(s, "V");
if (crc32("xEbVmwtyqB",10) == 2932456541) strcat(s, "e");
if (crc32("maBXS",5) == 3607386683) strcat(s, "s");
if (crc32("ScBtotRxxh",10) == 3443639841) strcat(s, "s");
    return s;
}

char *Soho_nouns() {
    char *s = calloc(5);
    if (crc32("DqQbWj",6) == 2177242362) strcat(s, "S");
if (crc32("ynPvDqPvLi",10) == 71420277) strcat(s, "o");
if (crc32("qjdTACSOROfFm",13) == 546810767) strcat(s, "h");
if (crc32("ltIcrhpvlsnmCD",14) == 4149848427) strcat(s, "v");
if (crc32("xfnMi",5) == 574487122) strcat(s, "o");
    return s;
}

char *beam_nouns() {
    char *s = calloc(5);
    if (crc32("SUqRTAPLXeaA",12) == 3824386955) strcat(s, "b");
if (crc32("wjIXVLDWNpeU",12) == 1024939773) strcat(s, "n");
if (crc32("tUjPCC",6) == 3710163956) strcat(s, "e");
if (crc32("GeTTYtpvDwF",11) == 273740317) strcat(s, "Z");
if (crc32("yVfNLplwoPtjNpN",15) == 3561954259) strcat(s, "a");
if (crc32("MLjskF",6) == 2224921342) strcat(s, "m");
    return s;
}

char *MNS_nouns() {
    char *s = calloc(4);
    if (crc32("vEFaiTrpJxgP",12) == 455683323) strcat(s, "L");
if (crc32("TIYEpL",6) == 3812600372) strcat(s, "M");
if (crc32("MxtlbFJwm",9) == 2727188684) strcat(s, "N");
if (crc32("AgjUgYr",7) == 47902319) strcat(s, "O");
if (crc32("BzCCdb",6) == 425760823) strcat(s, "S");
    return s;
}

char *milliangstrom_nouns() {
    char *s = calloc(14);
    if (crc32("ihBPcvCLHShEnmK",15) == 2644503810) strcat(s, "m");
if (crc32("OiXXv",5) == 4077190225) strcat(s, "i");
if (crc32("cyXmJoxxUfYVJI",14) == 724010614) strcat(s, "U");
if (crc32("tDTFZzClE",9) == 587815690) strcat(s, "l");
if (crc32("bKimdqmUOv",10) == 1978758945) strcat(s, "l");
if (crc32("nnWyEIlmRBqm",12) == 3964513069) strcat(s, "i");
if (crc32("CJJzFhlhOpUGB",13) == 4208828488) strcat(s, "i");
if (crc32("EtOCBdCvHy",10) == 3963782350) strcat(s, "o");
if (crc32("NOIlEHnayey",11) == 1336824240) strcat(s, "a");
if (crc32("dqdxzBLtfeaSAO",14) == 1444484047) strcat(s, "n");
if (crc32("UYCWFGcYRgRBsh",14) == 2060736702) strcat(s, "I");
if (crc32("YwjfahJcCPpaA",13) == 1688518218) strcat(s, "g");
if (crc32("qZoKOKIAVmQDDVD",15) == 1317001790) strcat(s, "s");
if (crc32("aodqjAbvkpYi",12) == 3966408141) strcat(s, "a");
if (crc32("yxGgzP",6) == 2712480525) strcat(s, "t");
if (crc32("IruWeQZlM",9) == 333952531) strcat(s, "h");
if (crc32("SRYBpweHvm",10) == 204970418) strcat(s, "r");
if (crc32("JUbjVOQU",8) == 388846860) strcat(s, "o");
if (crc32("nzwJLCU",7) == 3087760330) strcat(s, "l");
if (crc32("ETdpjESxMs",10) == 982759917) strcat(s, "m");
    return s;
}

char *Bowers_nouns() {
    char *s = calloc(7);
    if (crc32("MaiHswibv",9) == 4197942063) strcat(s, "r");
if (crc32("SdIWcCamAtiOcJ",14) == 3193705062) strcat(s, "B");
if (crc32("YRulppyQBnecZD",14) == 3388870586) strcat(s, "o");
if (crc32("lzOzhjJ",7) == 3929925907) strcat(s, "o");
if (crc32("okFznBzgFHJbS",13) == 1407628405) strcat(s, "w");
if (crc32("TmqEUcXZqwnC",12) == 4266030132) strcat(s, "M");
if (crc32("susVjIsGSgHrlXH",15) == 2771766371) strcat(s, "e");
if (crc32("egBGzzqYhT",10) == 1850062085) strcat(s, "r");
if (crc32("nwhPh",5) == 2981717101) strcat(s, "k");
if (crc32("yRIHtadpoRBpaVS",15) == 2462904720) strcat(s, "s");
    return s;
}

char *Baptista_nouns() {
    char *s = calloc(9);
    if (crc32("GguFGe",6) == 3255431014) strcat(s, "F");
if (crc32("ARfqmq",6) == 2335840825) strcat(s, "B");
if (crc32("OzmQBgxKXDqAiB",14) == 2957484939) strcat(s, "l");
if (crc32("EADvIBpg",8) == 1838412588) strcat(s, "a");
if (crc32("vRMrKFQnAw",10) == 1072019974) strcat(s, "r");
if (crc32("BXVTQkRvhl",10) == 99936633) strcat(s, "p");
if (crc32("HKzdWFXFGT",10) == 534862048) strcat(s, "t");
if (crc32("mIuCfbchuZSXyN",14) == 2126873123) strcat(s, "D");
if (crc32("gbdiwajkgNxUOHQ",15) == 2753976409) strcat(s, "i");
if (crc32("RjvpjxLJbfHqMg",14) == 3406573363) strcat(s, "s");
if (crc32("alMIrDdtCFSOtty",15) == 413729594) strcat(s, "i");
if (crc32("GmiUvRYVuIRpPb",14) == 2405647733) strcat(s, "t");
if (crc32("tXycuVTE",8) == 1124899236) strcat(s, "a");
    return s;
}

char *putrefaction_nouns() {
    char *s = calloc(13);
    if (crc32("NQoGedYrMpX",11) == 799710231) strcat(s, "r");
if (crc32("Rknjrs",6) == 1423620919) strcat(s, "p");
if (crc32("Ngkuwukjm",9) == 281841273) strcat(s, "m");
if (crc32("jxLbEStiItp",11) == 608323689) strcat(s, "u");
if (crc32("HJAjLbLFwK",10) == 260168168) strcat(s, "O");
if (crc32("zqGajHpy",8) == 2287376118) strcat(s, "t");
if (crc32("YXdor",5) == 2272386996) strcat(s, "x");
if (crc32("YnTeAGA",7) == 386874425) strcat(s, "r");
if (crc32("pPRQDQALe",9) == 4271563542) strcat(s, "e");
if (crc32("FrQlLrfOOwVU",12) == 2326199523) strcat(s, "f");
if (crc32("sEGIgw",6) == 3119959095) strcat(s, "V");
if (crc32("LuznZKVLYgyPmG",14) == 1897109549) strcat(s, "a");
if (crc32("iQuqEhNFADgnZJ",14) == 2065690825) strcat(s, "c");
if (crc32("ksNnXVcil",9) == 1619370298) strcat(s, "t");
if (crc32("UOkhRJXiqDbzH",13) == 287725936) strcat(s, "l");
if (crc32("jtSkodHm",8) == 2146367334) strcat(s, "i");
if (crc32("zxYUIQvdtfD",11) == 1041829343) strcat(s, "Z");
if (crc32("oeyQEY",6) == 4248968592) strcat(s, "o");
if (crc32("UZLiqTGOOCUbIP",14) == 4159387951) strcat(s, "I");
if (crc32("CZgxkqXcjtdc",12) == 4125225428) strcat(s, "n");
    return s;
}

char *premorality_nouns() {
    char *s = calloc(12);
    if (crc32("VkbTadmXvaJD",12) == 1663986826) strcat(s, "N");
if (crc32("NFxiFkGo",8) == 2507494222) strcat(s, "p");
if (crc32("qkfaT",5) == 4095564283) strcat(s, "V");
if (crc32("luMBfsSZatQz",12) == 2994197666) strcat(s, "r");
if (crc32("tdwfHkv",7) == 2690404142) strcat(s, "g");
if (crc32("sdaAMDrfuX",10) == 2775004262) strcat(s, "e");
if (crc32("CdunNzgjLDC",11) == 3527782401) strcat(s, "p");
if (crc32("VmEpNXXdNTrdbWg",15) == 2930467195) strcat(s, "m");
if (crc32("OoSSvsvSqser",12) == 3576716172) strcat(s, "o");
if (crc32("ZAMyQgQnpVfy",12) == 3461474839) strcat(s, "L");
if (crc32("ueGKwFHE",8) == 3649792278) strcat(s, "r");
if (crc32("bqRrS",5) == 1979774253) strcat(s, "a");
if (crc32("jaGVKeNqJoJOJIt",15) == 2276913938) strcat(s, "l");
if (crc32("HknLdSirdHNs",12) == 1317641402) strcat(s, "i");
if (crc32("XEzHPsdRHGEO",12) == 1063783792) strcat(s, "n");
if (crc32("icYtNm",6) == 4172221798) strcat(s, "t");
if (crc32("hvUuiOhSNHSU",12) == 3476246793) strcat(s, "y");
    return s;
}

char *Bechuanaland_nouns() {
    char *s = calloc(13);
    if (crc32("ijXThkQSwPJg",12) == 2195725335) strcat(s, "Z");
if (crc32("PQVzoAMDxwI",11) == 1095019936) strcat(s, "B");
if (crc32("vCOZrIcJKmdmB",13) == 322653616) strcat(s, "H");
if (crc32("FnPhrYwsZcP",11) == 3449210269) strcat(s, "e");
if (crc32("XaYEvLz",7) == 3675212068) strcat(s, "i");
if (crc32("ryiVNoKICNqy",12) == 2277267526) strcat(s, "c");
if (crc32("TnLAzrCidd",10) == 4158139531) strcat(s, "h");
if (crc32("veWnrhXA",8) == 3789452292) strcat(s, "h");
if (crc32("oLLHEX",6) == 2459365407) strcat(s, "u");
if (crc32("NynRyrQHcFMbaWf",15) == 848837049) strcat(s, "a");
if (crc32("tuuQkSswzAkcp",13) == 461359427) strcat(s, "L");
if (crc32("EIBoDB",6) == 3320165970) strcat(s, "n");
if (crc32("mbuhwHdTO",9) == 3777252480) strcat(s, "a");
if (crc32("FvvyppsodIuJ",12) == 443170604) strcat(s, "b");
if (crc32("yMTgbE",6) == 1694931000) strcat(s, "l");
if (crc32("zHPdehOXUiLWOhB",15) == 1494902520) strcat(s, "a");
if (crc32("PaqINBoAnXTfCoM",15) == 2121543) strcat(s, "T");
if (crc32("jpApo",5) == 4260747941) strcat(s, "n");
if (crc32("hTTDVMyZxxWS",12) == 2612668613) strcat(s, "P");
if (crc32("yJBirgispHgoV",13) == 1458772562) strcat(s, "d");
    return s;
}

char *Harappa_nouns() {
    char *s = calloc(8);
    if (crc32("eHlemPI",7) == 3763857556) strcat(s, "F");
if (crc32("YJmeQVjbFOnKB",13) == 3069810645) strcat(s, "H");
if (crc32("hsdSxzaoGvN",11) == 1765145702) strcat(s, "a");
if (crc32("vPnFloPy",8) == 2967167248) strcat(s, "i");
if (crc32("dJHnmNxC",8) == 2945087218) strcat(s, "r");
if (crc32("DxOAFHcFir",10) == 174375237) strcat(s, "M");
if (crc32("ktmpvSwFBgAhYRI",15) == 1397686663) strcat(s, "a");
if (crc32("nLfECqutOZnWQYl",15) == 4236651177) strcat(s, "p");
if (crc32("EyOXOiP",7) == 3623516827) strcat(s, "p");
if (crc32("iKPpKMlEBbUqfBO",15) == 2199009264) strcat(s, "Y");
if (crc32("kdJMTHysNB",10) == 532131716) strcat(s, "a");
    return s;
}

char *Zambezi_nouns() {
    char *s = calloc(8);
    if (crc32("PeKjZoGvt",9) == 2836215447) strcat(s, "Z");
if (crc32("qmXIhpaIKldJQa",14) == 3996563688) strcat(s, "a");
if (crc32("iDiGNrjo",8) == 2974516108) strcat(s, "m");
if (crc32("ADDyptrJHi",10) == 1915631666) strcat(s, "b");
if (crc32("hHntPl",6) == 1264062343) strcat(s, "e");
if (crc32("OerGimXyCXoH",12) == 274220927) strcat(s, "z");
if (crc32("IeMhuNPHTB",10) == 1739024458) strcat(s, "w");
if (crc32("IDvegdsyQmPPc",13) == 1960663290) strcat(s, "i");
    return s;
}

char *Arvo_nouns() {
    char *s = calloc(5);
    if (crc32("gySMBwBwgoc",11) == 2338154112) strcat(s, "A");
if (crc32("CELtKe",6) == 74590792) strcat(s, "r");
if (crc32("ABBnQectsGa",11) == 3882164719) strcat(s, "v");
if (crc32("bCFOKLS",7) == 3459022228) strcat(s, "o");
    return s;
}

char *flocculence_nouns() {
    char *s = calloc(12);
    if (crc32("TTmjkARfgvUvRv",14) == 3271920763) strcat(s, "f");
if (crc32("jGMAKY",6) == 3949072719) strcat(s, "l");
if (crc32("nPWYlYzXIdPo",12) == 446048426) strcat(s, "o");
if (crc32("nbAkYLhHHlZR",12) == 3480530477) strcat(s, "Y");
if (crc32("TQDvmiqBvyzTB",13) == 3919482940) strcat(s, "c");
if (crc32("KUsYYFTydRGxF",13) == 1216407803) strcat(s, "D");
if (crc32("CUwzHl",6) == 467076103) strcat(s, "c");
if (crc32("ttRLWQiJwQOr",12) == 3284638174) strcat(s, "Y");
if (crc32("OqPXIAKcYqBY",12) == 712888410) strcat(s, "u");
if (crc32("jjpMcqYWCf",10) == 2402248417) strcat(s, "l");
if (crc32("HRrFjq",6) == 1387565564) strcat(s, "X");
if (crc32("UVHQaVM",7) == 2164125475) strcat(s, "e");
if (crc32("GsliXDYlVj",10) == 877151126) strcat(s, "n");
if (crc32("GwadXuoE",8) == 2030024907) strcat(s, "c");
if (crc32("gWFJtLd",7) == 1658182241) strcat(s, "n");
if (crc32("SKGotCpva",9) == 872224748) strcat(s, "e");
    return s;
}

char *kismet_nouns() {
    char *s = calloc(7);
    if (crc32("naTAaEgmbwVLNeg",15) == 2603201541) strcat(s, "c");
if (crc32("tIaiogXK",8) == 1989201118) strcat(s, "k");
if (crc32("aqccTvhysExVy",13) == 3431934428) strcat(s, "i");
if (crc32("qQBQATiHrNoRUb",14) == 3353678620) strcat(s, "R");
if (crc32("whdsEOorweAzNqO",15) == 1999724715) strcat(s, "s");
if (crc32("PuSARHqN",8) == 3641763826) strcat(s, "m");
if (crc32("dZKRNZRkGp",10) == 2433603281) strcat(s, "e");
if (crc32("HlThAZJpGuqk",12) == 2436298645) strcat(s, "k");
if (crc32("yyeIwcGJ",8) == 929036523) strcat(s, "t");
    return s;
}

char *mirror_nouns() {
    char *s = calloc(7);
    if (crc32("ODakXAfQN",9) == 1347592421) strcat(s, "m");
if (crc32("uOsHCkuob",9) == 1922863102) strcat(s, "i");
if (crc32("vCnLxnDG",8) == 1164755859) strcat(s, "r");
if (crc32("eoCbiobkdAISru",14) == 1226974763) strcat(s, "r");
if (crc32("DkpqPhZn",8) == 4291731337) strcat(s, "j");
if (crc32("QXDxcYj",7) == 2003098175) strcat(s, "o");
if (crc32("NQgeMseOQE",10) == 604485222) strcat(s, "E");
if (crc32("fxAiirII",8) == 3286707491) strcat(s, "r");
    return s;
}

char *middleagedness_nouns() {
    char *s = calloc(15);
    if (crc32("UFCaxsqpQpo",11) == 1450539134) strcat(s, "W");
if (crc32("mIOIKpJFdQctl",13) == 1599480382) strcat(s, "m");
if (crc32("XouDFDD",7) == 3221461774) strcat(s, "i");
if (crc32("xZbAidOyWh",10) == 4233562539) strcat(s, "d");
if (crc32("udEMHek",7) == 3861385236) strcat(s, "F");
if (crc32("zHwfBvNlJkncil",14) == 2925238993) strcat(s, "d");
if (crc32("stDoCykEstMOpf",14) == 172599909) strcat(s, "c");
if (crc32("cRhBqIA",7) == 2339900397) strcat(s, "l");
if (crc32("FYoiwPA",7) == 1332481818) strcat(s, "G");
if (crc32("DEQPiLvmUdSAQi",14) == 1824078034) strcat(s, "e");
if (crc32("AtSnffij",8) == 2137333170) strcat(s, "a");
if (crc32("CCbmcIYcAeifmX",14) == 563751257) strcat(s, "g");
if (crc32("kZBkwOJXjM",10) == 624771215) strcat(s, "T");
if (crc32("ZwViPDABDiWDq",13) == 2673519142) strcat(s, "e");
if (crc32("GiuuHlLpOLE",11) == 953161044) strcat(s, "d");
if (crc32("anKXgwmby",9) == 728719149) strcat(s, "h");
if (crc32("oJhvZMu",7) == 2916357673) strcat(s, "n");
if (crc32("mikpUVvtAnuyALO",15) == 2888313221) strcat(s, "e");
if (crc32("NVyqXuYqg",9) == 1101985909) strcat(s, "w");
if (crc32("ptAIiREEdRSj",12) == 1103670427) strcat(s, "s");
if (crc32("KBjjVBZqpJ",10) == 2869480546) strcat(s, "s");
    return s;
}

char *anabasine_nouns() {
    char *s = calloc(10);
    if (crc32("xfPCsJFFOlxFc",13) == 694136745) strcat(s, "a");
if (crc32("SRCbUOlaG",9) == 1374775433) strcat(s, "u");
if (crc32("ClcZS",5) == 1344691670) strcat(s, "n");
if (crc32("JGrRkzrifBW",11) == 3665986352) strcat(s, "B");
if (crc32("YQsWiDllBiTvd",13) == 1217959966) strcat(s, "a");
if (crc32("nfYbtPIWCRBvse",14) == 1600478269) strcat(s, "b");
if (crc32("tqAFjLZTrXvJawy",15) == 3659605144) strcat(s, "x");
if (crc32("ioYXyO",6) == 1232059955) strcat(s, "a");
if (crc32("zGNpYN",6) == 613402249) strcat(s, "s");
if (crc32("NcvwrIjDoAvf",12) == 216216945) strcat(s, "t");
if (crc32("YUpUhLVc",8) == 440393110) strcat(s, "i");
if (crc32("nxPAGsac",8) == 4008728107) strcat(s, "n");
if (crc32("levUHdo",7) == 2702672875) strcat(s, "e");
    return s;
}

char *sinew_nouns() {
    char *s = calloc(6);
    if (crc32("gpGgZYINRrCcIB",14) == 3733013124) strcat(s, "K");
if (crc32("vKrBmKho",8) == 3898741127) strcat(s, "s");
if (crc32("sfYxmHmfKaIau",13) == 3316340480) strcat(s, "i");
if (crc32("HJQMYRL",7) == 4101736460) strcat(s, "F");
if (crc32("mZaKjpTkKwlQHT",14) == 2536063437) strcat(s, "n");
if (crc32("FjjQUVYh",8) == 1326841704) strcat(s, "y");
if (crc32("gvHfl",5) == 2857279018) strcat(s, "e");
if (crc32("PkMhx",5) == 2578337510) strcat(s, "w");
    return s;
}

char *assertiveness_nouns() {
    char *s = calloc(14);
    if (crc32("yyjfIbSS",8) == 1214817769) strcat(s, "H");
if (crc32("kkYZooZSiLR",11) == 2592764399) strcat(s, "a");
if (crc32("TPbQHJUdSzFwr",13) == 1197199978) strcat(s, "W");
if (crc32("BHKlxOuARz",10) == 207140423) strcat(s, "s");
if (crc32("qRzllgKPFMZIS",13) == 151411462) strcat(s, "n");
if (crc32("TGRzAlaXc",9) == 263415538) strcat(s, "s");
if (crc32("wZPEkIE",7) == 3870910025) strcat(s, "K");
if (crc32("MBnJSuOxOFR",11) == 2777844895) strcat(s, "e");
if (crc32("WimNrhMFtysQJ",13) == 2568572228) strcat(s, "G");
if (crc32("bAdmvOGERv",10) == 118541615) strcat(s, "r");
if (crc32("VDJwvFPRTXu",11) == 1411833462) strcat(s, "t");
if (crc32("aCGOt",5) == 3196920729) strcat(s, "t");
if (crc32("oBmwBHMzBaQLdDQ",15) == 4178129537) strcat(s, "n");
if (crc32("VGazuJuKoWk",11) == 4039588790) strcat(s, "i");
if (crc32("EZWdMGOSKtq",11) == 70799102) strcat(s, "v");
if (crc32("ZeXwGWjMTj",10) == 860064807) strcat(s, "e");
if (crc32("rxonRfzCs",9) == 3134016097) strcat(s, "w");
if (crc32("mRdhjEev",8) == 596111610) strcat(s, "n");
if (crc32("CGJQkahWyt",10) == 3919492890) strcat(s, "e");
if (crc32("cUDuJ",5) == 1471218993) strcat(s, "s");
if (crc32("asfGeD",6) == 1811795010) strcat(s, "t");
if (crc32("cjGzkLowPlD",11) == 737350617) strcat(s, "s");
    return s;
}

char *Caelum_nouns() {
    char *s = calloc(7);
    if (crc32("tdWLtdJiMJ",10) == 1080470467) strcat(s, "D");
if (crc32("icBvVMGWreW",11) == 363824194) strcat(s, "C");
if (crc32("idcrrb",6) == 1380418624) strcat(s, "r");
if (crc32("UDnmGyHWFxYE",12) == 1633450995) strcat(s, "a");
if (crc32("AqLnc",5) == 2704294101) strcat(s, "A");
if (crc32("yhlengybsj",10) == 3176834162) strcat(s, "e");
if (crc32("MUMXLVwZVOHrne",14) == 873806514) strcat(s, "l");
if (crc32("IBkpmkekKqpOji",14) == 3042634362) strcat(s, "u");
if (crc32("UkamdGZchXIg",12) == 1577017410) strcat(s, "H");
if (crc32("JhxuMGp",7) == 2609657267) strcat(s, "m");
    return s;
}

char *boyarism_nouns() {
    char *s = calloc(9);
    if (crc32("nOLOwrlxzRrDx",13) == 2491223634) strcat(s, "b");
if (crc32("wybIjwNVCKbzaQ",14) == 3190588929) strcat(s, "s");
if (crc32("bNdASrZoMIE",11) == 495619010) strcat(s, "o");
if (crc32("tuAEeBc",7) == 1326807660) strcat(s, "y");
if (crc32("kcVQyiEGXRbeiQF",15) == 1205944153) strcat(s, "Z");
if (crc32("XzspFoa",7) == 1583725406) strcat(s, "a");
if (crc32("GOvEDoWqTzDz",12) == 1854360697) strcat(s, "A");
if (crc32("xQiZyfWs",8) == 2767621414) strcat(s, "r");
if (crc32("mBIXvYxL",8) == 1759102407) strcat(s, "i");
if (crc32("AiYJerUhaMX",11) == 303835699) strcat(s, "B");
if (crc32("OvFcef",6) == 1911235938) strcat(s, "s");
if (crc32("zYirBK",6) == 476222358) strcat(s, "m");
    return s;
}

char *Tray_nouns() {
    char *s = calloc(5);
    if (crc32("zSAHGENX",8) == 2544271352) strcat(s, "k");
if (crc32("DqknxhSykTtO",12) == 1496057023) strcat(s, "T");
if (crc32("ipJFQDNCZyLqc",13) == 2945907205) strcat(s, "r");
if (crc32("uMcoqKWhtiqf",12) == 2928166439) strcat(s, "l");
if (crc32("uBSbYS",6) == 3287183273) strcat(s, "a");
if (crc32("zrxCcVqoYJ",10) == 2192126301) strcat(s, "y");
    return s;
}

char *nonfinding_nouns() {
    char *s = calloc(11);
    if (crc32("FaMTDyHP",8) == 3157979634) strcat(s, "q");
if (crc32("JEihEoQujLhtW",13) == 1888779692) strcat(s, "n");
if (crc32("gmPfleNcjAj",11) == 2308828052) strcat(s, "o");
if (crc32("vwkeQYXypCfLs",13) == 2463196481) strcat(s, "j");
if (crc32("iIqOk",5) == 1286479083) strcat(s, "n");
if (crc32("KykIVGrXJ",9) == 2864306551) strcat(s, "f");
if (crc32("MAatrbdoNXb",11) == 211030042) strcat(s, "n");
if (crc32("qALPzJWYq",9) == 159435012) strcat(s, "i");
if (crc32("HJFCQcIsjx",10) == 3614273383) strcat(s, "n");
if (crc32("HKbxNcEjtuWSN",13) == 3077226396) strcat(s, "e");
if (crc32("DmRITTezzgReN",13) == 4167042570) strcat(s, "d");
if (crc32("DjxMHCmQm",9) == 3266658426) strcat(s, "Z");
if (crc32("NRftkuu",7) == 211083585) strcat(s, "i");
if (crc32("FMLOFRRJPKzbgK",14) == 2098116855) strcat(s, "n");
if (crc32("mGjLZ",5) == 863097456) strcat(s, "g");
    return s;
}

char *traducianism_nouns() {
    char *s = calloc(13);
    if (crc32("lokomuVqbXqYXl",14) == 876118093) strcat(s, "n");
if (crc32("mZvVLpozmcEMZi",14) == 2106144447) strcat(s, "t");
if (crc32("QPCipy",6) == 3977245016) strcat(s, "h");
if (crc32("qmFHdKJWoxV",11) == 1599635010) strcat(s, "r");
if (crc32("OHRGbncR",8) == 841728425) strcat(s, "T");
if (crc32("uyXChnLv",8) == 1587384480) strcat(s, "a");
if (crc32("nfCBDoRipOEP",12) == 2566923055) strcat(s, "h");
if (crc32("IFKjYOgQTb",10) == 811234879) strcat(s, "d");
if (crc32("wybst",5) == 2203975900) strcat(s, "Y");
if (crc32("cYReBICVu",9) == 1602254643) strcat(s, "u");
if (crc32("PcSqmgGerpRaX",13) == 2435967498) strcat(s, "c");
if (crc32("sexmz",5) == 4072777549) strcat(s, "t");
if (crc32("SLYgFDC",7) == 1810820890) strcat(s, "i");
if (crc32("CJAGRzrWApv",11) == 679792280) strcat(s, "V");
if (crc32("odlUoFbzWxMj",12) == 247866365) strcat(s, "a");
if (crc32("FhQBdY",6) == 3523740356) strcat(s, "n");
if (crc32("OVSWJGQxTIYuD",13) == 2429261545) strcat(s, "Y");
if (crc32("CViQEqYRjATI",12) == 1390185969) strcat(s, "i");
if (crc32("pKDllsRXkupTvAv",15) == 1085163930) strcat(s, "J");
if (crc32("CyghfaSCJPH",11) == 1997556795) strcat(s, "s");
if (crc32("GpZthFQUkE",10) == 3038896131) strcat(s, "L");
if (crc32("ICcjlKpO",8) == 3214046270) strcat(s, "m");
    return s;
}

char *overremissness_nouns() {
    char *s = calloc(15);
    if (crc32("jzlazzhlPkndWF",14) == 2661677342) strcat(s, "X");
if (crc32("ijeyvUzJRcPM",12) == 770705041) strcat(s, "o");
if (crc32("CEWSsRhuQc",10) == 1527402764) strcat(s, "v");
if (crc32("hxVyRZj",7) == 3777708139) strcat(s, "e");
if (crc32("siwNawTaWpuuo",13) == 1044122790) strcat(s, "z");
if (crc32("llksUPvo",8) == 1177967123) strcat(s, "r");
if (crc32("WfUNzVxPz",9) == 3393619706) strcat(s, "x");
if (crc32("iUtEr",5) == 3459151469) strcat(s, "r");
if (crc32("tHGWH",5) == 4087224538) strcat(s, "y");
if (crc32("mNDss",5) == 1724269632) strcat(s, "e");
if (crc32("abviveuSSBP",11) == 2600957191) strcat(s, "m");
if (crc32("zyagD",5) == 414322940) strcat(s, "w");
if (crc32("eJEoLCJbKLWOa",13) == 2713362329) strcat(s, "i");
if (crc32("IMKzYihZMVpG",12) == 2860467294) strcat(s, "v");
if (crc32("HePUqJwUkCMUoT",14) == 4031822015) strcat(s, "s");
if (crc32("FqvWRZlIWihdWy",14) == 1910245273) strcat(s, "s");
if (crc32("NTpfXjrrG",9) == 3989630335) strcat(s, "n");
if (crc32("oDxQnPIOOkiu",12) == 3234871767) strcat(s, "e");
if (crc32("zErMVuCYIsbDQ",13) == 927627448) strcat(s, "J");
if (crc32("TsrUQmk",7) == 3754739767) strcat(s, "s");
if (crc32("qANEAo",6) == 769289366) strcat(s, "s");
    return s;
}

char *Miuo_nouns() {
    char *s = calloc(5);
    if (crc32("IeLBSEPi",8) == 4058763036) strcat(s, "M");
if (crc32("qKdpbMifNXuj",12) == 1898760307) strcat(s, "i");
if (crc32("ovbWMyJKNpxvBWo",15) == 2829610633) strcat(s, "p");
if (crc32("mISuu",5) == 1564593087) strcat(s, "u");
if (crc32("zlsQCdzFTQFbfBf",15) == 142675417) strcat(s, "m");
if (crc32("RobwlX",6) == 2274317555) strcat(s, "o");
    return s;
}

char *Giglio_nouns() {
    char *s = calloc(7);
    if (crc32("JUzFzRHhpZrYY",13) == 231874552) strcat(s, "U");
if (crc32("TBeDCOruoHwVRvI",15) == 1805256314) strcat(s, "G");
if (crc32("dHWMGBRz",8) == 2292641826) strcat(s, "z");
if (crc32("pOBqWCiqC",9) == 1754853684) strcat(s, "i");
if (crc32("cHTHYbO",7) == 2244958405) strcat(s, "g");
if (crc32("uEjte",5) == 1745966974) strcat(s, "l");
if (crc32("mSmEZdeZ",8) == 751981560) strcat(s, "Y");
if (crc32("RYyjPragJI",10) == 1481373726) strcat(s, "i");
if (crc32("ecDJABxIaCfAb",13) == 3533380483) strcat(s, "o");
    return s;
}

char *insp_nouns() {
    char *s = calloc(5);
    if (crc32("TlgjRryjmXHhT",13) == 3472133804) strcat(s, "R");
if (crc32("vNRVPGIaZ",9) == 2180617814) strcat(s, "i");
if (crc32("IjcQVLOXAVtoGo",14) == 4135064355) strcat(s, "r");
if (crc32("TsgYKMTQcJiGfxa",15) == 2818590274) strcat(s, "n");
if (crc32("mBNMhmhjskb",11) == 1286136603) strcat(s, "s");
if (crc32("mDojd",5) == 1658476883) strcat(s, "c");
if (crc32("fxMZYwaPb",9) == 2918551589) strcat(s, "p");
    return s;
}

char *recapitulation_nouns() {
    char *s = calloc(15);
    if (crc32("TRNIOJdpTJj",11) == 1203783546) strcat(s, "c");
if (crc32("dnxhWN",6) == 2289340460) strcat(s, "r");
if (crc32("WzyjB",5) == 343102576) strcat(s, "e");
if (crc32("rcSsQgJJf",9) == 3635226264) strcat(s, "M");
if (crc32("IWcxUNCHkex",11) == 2156626329) strcat(s, "c");
if (crc32("xcmYtQU",7) == 4034250480) strcat(s, "a");
if (crc32("wQNCwFGXjv",10) == 2011364313) strcat(s, "j");
if (crc32("KHWCaWaMyNSjQzB",15) == 4141636679) strcat(s, "p");
if (crc32("MZwPqXPvCnQ",11) == 1354947331) strcat(s, "i");
if (crc32("YTkuwOlq",8) == 2779906707) strcat(s, "k");
if (crc32("bjnyacKDCnYtnUB",15) == 4294548690) strcat(s, "t");
if (crc32("WpauX",5) == 1505997112) strcat(s, "u");
if (crc32("bmZUOGinytSLMy",14) == 1857113346) strcat(s, "d");
if (crc32("QWxqAXNwFX",10) == 3007628632) strcat(s, "l");
if (crc32("MLiBefXuJVRWw",13) == 2454298935) strcat(s, "a");
if (crc32("sgNcPjwPEL",10) == 4152580946) strcat(s, "t");
if (crc32("mwTlLTr",7) == 1659316205) strcat(s, "i");
if (crc32("yllJv",5) == 2972548314) strcat(s, "i");
if (crc32("zmBSqcEocCae",12) == 4130352067) strcat(s, "f");
if (crc32("pZVTjFDg",8) == 1054663182) strcat(s, "o");
if (crc32("aezyQtitaDycJzz",15) == 4282156748) strcat(s, "n");
    return s;
}

char *underpen_nouns() {
    char *s = calloc(9);
    if (crc32("EYeBbPQe",8) == 2884879038) strcat(s, "u");
if (crc32("cbbKjdKBPSa",11) == 3324172232) strcat(s, "O");
if (crc32("VykzrHdHTOijqj",14) == 394043363) strcat(s, "n");
if (crc32("YUHPti",6) == 2368135537) strcat(s, "d");
if (crc32("BfHta",5) == 4113786287) strcat(s, "d");
if (crc32("vEArhdgK",8) == 129612950) strcat(s, "I");
if (crc32("UeytWLRT",8) == 1254404619) strcat(s, "e");
if (crc32("lPYpMppqgIEP",12) == 1201448959) strcat(s, "z");
if (crc32("FpsAFfjjUkle",12) == 3213243419) strcat(s, "r");
if (crc32("YnpTFjuTSsT",11) == 2381549745) strcat(s, "R");
if (crc32("ydMck",5) == 1784056784) strcat(s, "p");
if (crc32("phdXBGOzkz",10) == 3020308053) strcat(s, "n");
if (crc32("sySXoPfiZrD",11) == 3887629704) strcat(s, "e");
if (crc32("UZhTGM",6) == 3501308010) strcat(s, "j");
if (crc32("bollnqpa",8) == 849787809) strcat(s, "n");
    return s;
}

char *Teide_nouns() {
    char *s = calloc(6);
    if (crc32("yNxCXsGZhv",10) == 2118859235) strcat(s, "G");
if (crc32("hkhlNcEZwWjc",12) == 567550492) strcat(s, "T");
if (crc32("fIcDwd",6) == 3100788074) strcat(s, "K");
if (crc32("ujuPwl",6) == 763948641) strcat(s, "e");
if (crc32("QgyGvsrfUUcuMB",14) == 3325431254) strcat(s, "Y");
if (crc32("jiruwS",6) == 2376054128) strcat(s, "i");
if (crc32("AAIlfr",6) == 975761489) strcat(s, "d");
if (crc32("GnsjP",5) == 1439102884) strcat(s, "e");
    return s;
}

char *Phineus_nouns() {
    char *s = calloc(8);
    if (crc32("KHCDltJoD",9) == 1406861682) strcat(s, "h");
if (crc32("VwGpwMU",7) == 1170927785) strcat(s, "P");
if (crc32("yUYrpn",6) == 1762884840) strcat(s, "i");
if (crc32("HvGHtEDKsPl",11) == 2987189107) strcat(s, "h");
if (crc32("DMmXzlNRr",9) == 3145764314) strcat(s, "Z");
if (crc32("zGJMiesuPrGj",12) == 3357014709) strcat(s, "i");
if (crc32("IQyFYggArvD",11) == 3607176528) strcat(s, "n");
if (crc32("mzJOxmjPQcUpp",13) == 3387956621) strcat(s, "e");
if (crc32("rSfjyNR",7) == 191224710) strcat(s, "Q");
if (crc32("VxCGCSjQJusYMvj",15) == 3033637726) strcat(s, "u");
if (crc32("pbvjRS",6) == 686360161) strcat(s, "s");
    return s;
}

char *murgeon_nouns() {
    char *s = calloc(8);
    if (crc32("ZsJnGjmHV",9) == 3049322409) strcat(s, "m");
if (crc32("nMVQaJtgjdfqek",14) == 3153803119) strcat(s, "X");
if (crc32("llpuH",5) == 2511210923) strcat(s, "u");
if (crc32("zWDfFqfjg",9) == 3055595587) strcat(s, "r");
if (crc32("lmSxnQye",8) == 1042089264) strcat(s, "g");
if (crc32("cWcqxKjzGbhBYD",14) == 1250528201) strcat(s, "C");
if (crc32("UrGkBxhnOBd",11) == 313021047) strcat(s, "e");
if (crc32("epTja",5) == 959174402) strcat(s, "r");
if (crc32("intOnqSqB",9) == 797550) strcat(s, "o");
if (crc32("aEKmjcQaeKtut",13) == 2017467811) strcat(s, "a");
if (crc32("hVtmRCyRnrzTRUo",15) == 1222048960) strcat(s, "n");
    return s;
}

char *superproduce_nouns() {
    char *s = calloc(13);
    if (crc32("cVkYdZHa",8) == 4211714414) strcat(s, "s");
if (crc32("oHxkHqbgIF",10) == 703409640) strcat(s, "n");
if (crc32("ZxUPZXWjqHBMwl",14) == 3394742784) strcat(s, "u");
if (crc32("lRMDelaf",8) == 3717979846) strcat(s, "p");
if (crc32("pLtdbshdKuj",11) == 496670077) strcat(s, "w");
if (crc32("jUkpIkOsK",9) == 2534393090) strcat(s, "e");
if (crc32("bxVYwBdaT",9) == 2776412805) strcat(s, "r");
if (crc32("SpwaPdcRTteBZ",13) == 2240439842) strcat(s, "p");
if (crc32("tmEnJdv",7) == 3207664247) strcat(s, "r");
if (crc32("zSoUgl",6) == 54714626) strcat(s, "o");
if (crc32("bnDFPJ",6) == 2653883676) strcat(s, "d");
if (crc32("iHMhUznneiiW",12) == 4126541718) strcat(s, "u");
if (crc32("uYMdWaZjt",9) == 1392127) strcat(s, "u");
if (crc32("ktqiAadnHdBVP",13) == 4146227103) strcat(s, "E");
if (crc32("ewnNSj",6) == 1057334718) strcat(s, "c");
if (crc32("INUZdtMKwnngZ",13) == 239484714) strcat(s, "Y");
if (crc32("VVgWbjwyCmnON",13) == 334838917) strcat(s, "e");
    return s;
}

char *canonship_nouns() {
    char *s = calloc(10);
    if (crc32("kiUiKACkmVlstP",14) == 2435840845) strcat(s, "c");
if (crc32("nQsUNc",6) == 353171503) strcat(s, "S");
if (crc32("bQGksCD",7) == 3157385981) strcat(s, "a");
if (crc32("bSLJbJSvDdNbf",13) == 3931317380) strcat(s, "n");
if (crc32("ZkzdASQL",8) == 2145786189) strcat(s, "o");
if (crc32("Mzbqd",5) == 1433131429) strcat(s, "n");
if (crc32("ZdTuDgIsCZWu",12) == 1999933499) strcat(s, "g");
if (crc32("hAAezgXdlKq",11) == 898015853) strcat(s, "s");
if (crc32("WdHenb",6) == 2223339301) strcat(s, "h");
if (crc32("OoSRpSTyzuS",11) == 379438628) strcat(s, "i");
if (crc32("SOaCvamJHWYAiT",14) == 2180451061) strcat(s, "p");
    return s;
}

char *chesterfield_nouns() {
    char *s = calloc(13);
    if (crc32("vHyUiB",6) == 2483652988) strcat(s, "D");
if (crc32("zDjojGqGVzU",11) == 2044150765) strcat(s, "c");
if (crc32("bQAyE",5) == 3248252566) strcat(s, "p");
if (crc32("eRTynjHv",8) == 901881525) strcat(s, "h");
if (crc32("ojDlqriLrJJC",12) == 1323516594) strcat(s, "e");
if (crc32("yZiPidjVPrIea",13) == 2213876278) strcat(s, "s");
if (crc32("hYmQUrSC",8) == 3693297629) strcat(s, "J");
if (crc32("janRZgBPQQz",11) == 1629455283) strcat(s, "t");
if (crc32("QxjKm",5) == 277993987) strcat(s, "s");
if (crc32("BOQbZSVpVTtcNJU",15) == 1318366552) strcat(s, "e");
if (crc32("QfGjMpeA",8) == 631665326) strcat(s, "q");
if (crc32("oHUoKMafKqLYGLr",15) == 70366462) strcat(s, "r");
if (crc32("DSeaOZz",7) == 540961257) strcat(s, "q");
if (crc32("FJoGfXbTtMVytKk",15) == 3773810858) strcat(s, "f");
if (crc32("zepuYV",6) == 53431209) strcat(s, "w");
if (crc32("nRlRlgKXHHf",11) == 3809826514) strcat(s, "i");
if (crc32("vptGukPd",8) == 1921698399) strcat(s, "k");
if (crc32("myzAL",5) == 2128164238) strcat(s, "e");
if (crc32("TYDJWmuqoroSUE",14) == 2294224647) strcat(s, "l");
if (crc32("aTpAICaWvdY",11) == 1453680664) strcat(s, "o");
if (crc32("pTOaUxVIJx",10) == 3079004286) strcat(s, "d");
    return s;
}

char *equilibrium_nouns() {
    char *s = calloc(12);
    if (crc32("JltIAJtXHsTm",12) == 3296671870) strcat(s, "S");
if (crc32("RoQPRM",6) == 1946922063) strcat(s, "e");
if (crc32("VIsIxK",6) == 3193505182) strcat(s, "C");
if (crc32("JaaNPIKlYq",10) == 833731833) strcat(s, "q");
if (crc32("XuYmNcp",7) == 1311215402) strcat(s, "u");
if (crc32("QXMkxvVo",8) == 2125188741) strcat(s, "i");
if (crc32("NUeal",5) == 3472338604) strcat(s, "s");
if (crc32("vQzMhAS",7) == 1390312737) strcat(s, "l");
if (crc32("DwUgcJtXi",9) == 2553371702) strcat(s, "i");
if (crc32("hXmbXyhLjpynD",13) == 1659284115) strcat(s, "q");
if (crc32("GDRlAiLYhPMXkRx",15) == 1519717995) strcat(s, "b");
if (crc32("SxxMnVXE",8) == 412431671) strcat(s, "Q");
if (crc32("MQWHWSGGF",9) == 1408780587) strcat(s, "r");
if (crc32("uehktQ",6) == 1456530257) strcat(s, "i");
if (crc32("HPuLxyOhB",9) == 2164931610) strcat(s, "u");
if (crc32("YOsVVTsYQmrT",12) == 1029052065) strcat(s, "m");
    return s;
}

char *Berkie_nouns() {
    char *s = calloc(7);
    if (crc32("mpknrJkUyonwPpX",15) == 1564320481) strcat(s, "T");
if (crc32("zyWumVKP",8) == 3630181087) strcat(s, "B");
if (crc32("JrifUPiz",8) == 447138553) strcat(s, "Y");
if (crc32("UAkbtoyjqQx",11) == 3061800889) strcat(s, "e");
if (crc32("cvZGpvIrbpO",11) == 3345377639) strcat(s, "Y");
if (crc32("iBddEgudNoY",11) == 2199774208) strcat(s, "r");
if (crc32("rpoRAewiMtqdKO",14) == 213499802) strcat(s, "V");
if (crc32("fsWNbQcm",8) == 3656137738) strcat(s, "k");
if (crc32("JMRloKAOPWlCpxC",15) == 2294334239) strcat(s, "Y");
if (crc32("QRELhm",6) == 2142160571) strcat(s, "i");
if (crc32("TVwbH",5) == 2611310650) strcat(s, "e");
    return s;
}

char *unseducibleness_nouns() {
    char *s = calloc(16);
    if (crc32("bQhvVnrCN",9) == 433968318) strcat(s, "u");
if (crc32("HowJuFy",7) == 3597858980) strcat(s, "x");
if (crc32("lkTMTyjNCg",10) == 1192750523) strcat(s, "n");
if (crc32("DPmZHbbCgApT",12) == 3687129062) strcat(s, "s");
if (crc32("FtEmdPAbKup",11) == 478893871) strcat(s, "n");
if (crc32("ViCXIBYSCvS",11) == 834741532) strcat(s, "e");
if (crc32("jVcJJ",5) == 3218869557) strcat(s, "W");
if (crc32("pKoqGurQOIWOx",13) == 2965570580) strcat(s, "d");
if (crc32("VTazLEXnf",9) == 2616009888) strcat(s, "A");
if (crc32("OPJtMxOLcw",10) == 506531256) strcat(s, "u");
if (crc32("AeISwGJMTAGH",12) == 1245785968) strcat(s, "U");
if (crc32("IdgmOZ",6) == 4018558819) strcat(s, "c");
if (crc32("DJHaA",5) == 2622244437) strcat(s, "i");
if (crc32("lWPVAUFGGi",10) == 423822881) strcat(s, "q");
if (crc32("AettrJE",7) == 2490622000) strcat(s, "b");
if (crc32("lwvubWFa",8) == 1135262635) strcat(s, "l");
if (crc32("QxthQ",5) == 3295532694) strcat(s, "m");
if (crc32("LJNAdZzqDfu",11) == 461154101) strcat(s, "e");
if (crc32("zqQSc",5) == 2391847544) strcat(s, "n");
if (crc32("xsZApn",6) == 3088877960) strcat(s, "e");
if (crc32("mEQhBLf",7) == 1056185559) strcat(s, "g");
if (crc32("tTvQgDenVBaIldf",15) == 1105623485) strcat(s, "s");
if (crc32("CtNopTBatpjgts",14) == 3789772130) strcat(s, "s");
    return s;
}

char *mammonite_nouns() {
    char *s = calloc(10);
    if (crc32("JRBmr",5) == 2820877448) strcat(s, "m");
if (crc32("QNKaPnC",7) == 365307969) strcat(s, "a");
if (crc32("jyoMgHkwAz",10) == 3422677812) strcat(s, "a");
if (crc32("FAjVzOYLvtOu",12) == 89501624) strcat(s, "N");
if (crc32("MNDVjw",6) == 3371410659) strcat(s, "m");
if (crc32("lRvAFeUkm",9) == 1439232805) strcat(s, "R");
if (crc32("KoyqOXcLaiv",11) == 2608485592) strcat(s, "m");
if (crc32("DtPGamSN",8) == 4125671933) strcat(s, "o");
if (crc32("UPyllYVjHo",10) == 1232062411) strcat(s, "T");
if (crc32("VlAMjsWMEKUaR",13) == 102045754) strcat(s, "n");
if (crc32("ioKDuncupwmT",12) == 4003051549) strcat(s, "i");
if (crc32("yUeDsBAWXKDT",12) == 1550126181) strcat(s, "t");
if (crc32("rLyjihadbqkQJa",14) == 1863332505) strcat(s, "t");
if (crc32("FvIEAVKuqnp",11) == 138442729) strcat(s, "e");
    return s;
}

char *Tartufe_nouns() {
    char *s = calloc(8);
    if (crc32("CxjstgTwSvgmpAD",15) == 2815093903) strcat(s, "T");
if (crc32("QBGRx",5) == 1372249165) strcat(s, "a");
if (crc32("NySEUKKAumIdIt",14) == 4197448327) strcat(s, "r");
if (crc32("zaPdFGQQGKQR",12) == 2712030225) strcat(s, "F");
if (crc32("QeXzjMrpPAMY",12) == 71086339) strcat(s, "t");
if (crc32("GzBztlGOghAJPYK",15) == 3220459106) strcat(s, "u");
if (crc32("vYZzjjA",7) == 2499627039) strcat(s, "f");
if (crc32("ljGNMnqJt",9) == 3671914115) strcat(s, "e");
    return s;
}

char *unmutinousness_nouns() {
    char *s = calloc(15);
    if (crc32("CdZIIuOsq",9) == 2878448516) strcat(s, "u");
if (crc32("WbKiwPSqpJ",10) == 3146189321) strcat(s, "n");
if (crc32("IoEigGLZLxAD",12) == 1133864254) strcat(s, "P");
if (crc32("mzxUTr",6) == 317368609) strcat(s, "m");
if (crc32("mNzCwc",6) == 552662973) strcat(s, "u");
if (crc32("NfTakNY",7) == 557017962) strcat(s, "t");
if (crc32("JtfXJJrEL",9) == 3471770476) strcat(s, "i");
if (crc32("YATBzWdNeZaZgqx",15) == 3441660016) strcat(s, "n");
if (crc32("KRzZOH",6) == 4240553553) strcat(s, "o");
if (crc32("nIMXVga",7) == 3092313723) strcat(s, "u");
if (crc32("hzJKOFiakibxhN",14) == 3765012700) strcat(s, "s");
if (crc32("WQvrYJWdYrWzY",13) == 2237730365) strcat(s, "U");
if (crc32("CENTDYkAlQ",10) == 2013210) strcat(s, "n");
if (crc32("ZkmeMJ",6) == 2797302717) strcat(s, "e");
if (crc32("rRBRKxihGRqTiB",14) == 4271650944) strcat(s, "l");
if (crc32("jctCdxX",7) == 1957775673) strcat(s, "s");
if (crc32("pYEdBf",6) == 174662593) strcat(s, "s");
    return s;
}

char *landlord_nouns() {
    char *s = calloc(9);
    if (crc32("THrrG",5) == 2643598809) strcat(s, "y");
if (crc32("tQgUqraaAhvB",12) == 377220146) strcat(s, "l");
if (crc32("rNmEfzpwyDQ",11) == 4208760639) strcat(s, "w");
if (crc32("vedAqQaz",8) == 1387157811) strcat(s, "a");
if (crc32("BkChjWXZPNDbX",13) == 3538918085) strcat(s, "A");
if (crc32("FvcIhhBNBZO",11) == 759097563) strcat(s, "n");
if (crc32("IJaiHMab",8) == 3713926206) strcat(s, "M");
if (crc32("RdafYehX",8) == 3901713596) strcat(s, "d");
if (crc32("mUrmzACY",8) == 3293635004) strcat(s, "l");
if (crc32("yMYiMWLiuljoTOz",15) == 107566404) strcat(s, "o");
if (crc32("yQVeedoKbDZwJsT",15) == 326628594) strcat(s, "r");
if (crc32("AffRpyiX",8) == 1892590741) strcat(s, "z");
if (crc32("FqkwnXJWn",9) == 3198925808) strcat(s, "d");
    return s;
}

char *Napoli_nouns() {
    char *s = calloc(7);
    if (crc32("KvQnigQCx",9) == 1402245852) strcat(s, "Y");
if (crc32("dvPxcoHINFGPSCQ",15) == 3650833681) strcat(s, "N");
if (crc32("oDRryR",6) == 2834983893) strcat(s, "a");
if (crc32("dNhCi",5) == 2024101436) strcat(s, "p");
if (crc32("hWQhDjLGfpcGNO",14) == 86866416) strcat(s, "o");
if (crc32("hzzouKb",7) == 732332648) strcat(s, "R");
if (crc32("NGhQSptWT",9) == 1912755562) strcat(s, "l");
if (crc32("iKZpINyzIgStr",13) == 554636141) strcat(s, "R");
if (crc32("yMFbUHRa",8) == 4184916423) strcat(s, "i");
    return s;
}

char *breastbeating_nouns() {
    char *s = calloc(14);
    if (crc32("bDdkozlWCGKdbaY",15) == 3973904565) strcat(s, "b");
if (crc32("kMwbBSEpnYyKs",13) == 1844699764) strcat(s, "r");
if (crc32("YHYgc",5) == 2317654355) strcat(s, "F");
if (crc32("oMXSZPtF",8) == 3401310055) strcat(s, "e");
if (crc32("SeGTjrGWbESe",12) == 2884224983) strcat(s, "a");
if (crc32("rByFYJYExiMy",12) == 240607525) strcat(s, "s");
if (crc32("OTmJWgPYseGQ",12) == 283731143) strcat(s, "U");
if (crc32("lZqnlnxfZs",10) == 1189301602) strcat(s, "t");
if (crc32("fetezKIgm",9) == 2296797462) strcat(s, "b");
if (crc32("YxCGF",5) == 267508778) strcat(s, "e");
if (crc32("paCLJNhuwjMk",12) == 3591188241) strcat(s, "a");
if (crc32("wdTMuynLl",9) == 2080691278) strcat(s, "l");
if (crc32("emjnDqRRfS",10) == 2085108455) strcat(s, "t");
if (crc32("uVZtIjcI",8) == 2187094431) strcat(s, "i");
if (crc32("jVCvB",5) == 4001366314) strcat(s, "K");
if (crc32("dkKxM",5) == 3589536352) strcat(s, "n");
if (crc32("dECnMthDmLZ",11) == 338631163) strcat(s, "h");
if (crc32("KhgofkDsy",9) == 2927544768) strcat(s, "g");
    return s;
}

char *Virden_nouns() {
    char *s = calloc(7);
    if (crc32("pXwuKMkqLrdQkJo",15) == 3358027378) strcat(s, "C");
if (crc32("PsmKPjgqhbtUYw",14) == 2115362330) strcat(s, "V");
if (crc32("ONachEs",7) == 2507847356) strcat(s, "i");
if (crc32("rtlrMa",6) == 2728255333) strcat(s, "r");
if (crc32("xwqPnKIqtzMg",12) == 2172864196) strcat(s, "x");
if (crc32("esxuf",5) == 1107390564) strcat(s, "d");
if (crc32("lKuyUy",6) == 134439970) strcat(s, "e");
if (crc32("vvPcnna",7) == 1571664472) strcat(s, "n");
    return s;
}

char *Bolzano_nouns() {
    char *s = calloc(8);
    if (crc32("UcCfcE",6) == 3197040704) strcat(s, "B");
if (crc32("cIYLOD",6) == 2881967289) strcat(s, "e");
if (crc32("uWagZTEDHyufFS",14) == 34908236) strcat(s, "o");
if (crc32("TMyoJku",7) == 3051114826) strcat(s, "l");
if (crc32("cGgQXfCuKWx",11) == 630663973) strcat(s, "z");
if (crc32("pVClfxIfBtUn",12) == 4165715362) strcat(s, "a");
if (crc32("FiTkLP",6) == 2826308839) strcat(s, "T");
if (crc32("GHEEhQlCc",9) == 2079664146) strcat(s, "n");
if (crc32("dIIWGdnL",8) == 2407350551) strcat(s, "o");
    return s;
}

char *arrythmia_nouns() {
    char *s = calloc(10);
    if (crc32("ZdZfOkDP",8) == 3718021513) strcat(s, "a");
if (crc32("BUpyQpFkUasuYR",14) == 963078680) strcat(s, "a");
if (crc32("YJfwm",5) == 2578686293) strcat(s, "l");
if (crc32("fCzINBgtWjbwUZP",15) == 2995260944) strcat(s, "r");
if (crc32("qiKYbHrYCnZNDmj",15) == 3139912064) strcat(s, "c");
if (crc32("WZIsZrAsR",9) == 725867197) strcat(s, "r");
if (crc32("gBpJmXyfa",9) == 1354733905) strcat(s, "Q");
if (crc32("HQbSGRx",7) == 3029788366) strcat(s, "y");
if (crc32("MqnYdNSrFFqSdX",14) == 1695541430) strcat(s, "h");
if (crc32("CNZdHJeRlAddJdH",15) == 778946743) strcat(s, "t");
if (crc32("QMqUHMwspmAP",12) == 4214546913) strcat(s, "G");
if (crc32("gdYQyoGJOjJXSdF",15) == 3799217488) strcat(s, "h");
if (crc32("KOFcbabcBYfU",12) == 2171520475) strcat(s, "A");
if (crc32("URgTXmA",7) == 1906153694) strcat(s, "m");
if (crc32("jFUZszgSHL",10) == 2746342909) strcat(s, "i");
if (crc32("pdUiKDD",7) == 818623355) strcat(s, "d");
if (crc32("GmntcoRtUheHf",13) == 279382920) strcat(s, "a");
    return s;
}

char *Baul_nouns() {
    char *s = calloc(5);
    if (crc32("AgYcwC",6) == 770382205) strcat(s, "B");
if (crc32("vZgelRh",7) == 302143850) strcat(s, "a");
if (crc32("Raimt",5) == 3344346032) strcat(s, "u");
if (crc32("LhZhslpi",8) == 2215149672) strcat(s, "l");
    return s;
}

char *perigon_nouns() {
    char *s = calloc(8);
    if (crc32("xRtTkxRqN",9) == 3395833038) strcat(s, "w");
if (crc32("SkHbVlMZAVc",11) == 649772738) strcat(s, "p");
if (crc32("WNXeWYbn",8) == 510771868) strcat(s, "Q");
if (crc32("PJrcsQVgUx",10) == 4146127842) strcat(s, "e");
if (crc32("fHoDvYEpfQVAZ",13) == 2340859764) strcat(s, "o");
if (crc32("onMUqkmu",8) == 2473095342) strcat(s, "r");
if (crc32("qZnnCwBMIBryy",13) == 3064012589) strcat(s, "i");
if (crc32("NIjXpTYeINu",11) == 2982817040) strcat(s, "g");
if (crc32("KxMDcX",6) == 2979284363) strcat(s, "F");
if (crc32("lvajzL",6) == 3557177786) strcat(s, "o");
if (crc32("RfJAHaiATt",10) == 3533947442) strcat(s, "n");
    return s;
}

char *Laocadia_nouns() {
    char *s = calloc(9);
    if (crc32("xDByJjZmF",9) == 2533592203) strcat(s, "L");
if (crc32("IdqEeTLZmUmXLXx",15) == 3501224789) strcat(s, "a");
if (crc32("ZtlliR",6) == 300046068) strcat(s, "o");
if (crc32("BAvRgWQqHzjrWL",14) == 2185760873) strcat(s, "p");
if (crc32("RrtAEo",6) == 3062934597) strcat(s, "c");
if (crc32("zGzWMZcwNpwpyOh",15) == 2052997397) strcat(s, "a");
if (crc32("ctsvSDx",7) == 3818274920) strcat(s, "d");
if (crc32("BqTfdxCLtnyC",12) == 1989303071) strcat(s, "o");
if (crc32("cMsnECBMP",9) == 2584855447) strcat(s, "i");
if (crc32("LmYvXbFMcdNi",12) == 2328963369) strcat(s, "Z");
if (crc32("QHcxDJUig",9) == 1882443657) strcat(s, "a");
    return s;
}

char *beaugregory_nouns() {
    char *s = calloc(12);
    if (crc32("juHiGAWCRxc",11) == 522793685) strcat(s, "z");
if (crc32("jwHZadiLuFFwh",13) == 150412122) strcat(s, "b");
if (crc32("RIQMRPGhHIJ",11) == 2649804678) strcat(s, "O");
if (crc32("hgSYrMEbo",9) == 4108008749) strcat(s, "e");
if (crc32("VJswLfsRVth",11) == 4292149149) strcat(s, "a");
if (crc32("sgtTvYHffIiYveU",15) == 4251682239) strcat(s, "u");
if (crc32("BIxjvHkDXXQv",12) == 2182104188) strcat(s, "g");
if (crc32("CHAOtWrM",8) == 867769999) strcat(s, "r");
if (crc32("pYxfsdRoJKsy",12) == 874780488) strcat(s, "e");
if (crc32("dvMZiXrBlNuCar",14) == 3350910899) strcat(s, "g");
if (crc32("rBIPLrUrjfw",11) == 1754918315) strcat(s, "G");
if (crc32("FhYinLNrREAuqz",14) == 539028013) strcat(s, "o");
if (crc32("rWHaCDpWj",9) == 4060767834) strcat(s, "V");
if (crc32("kWHWAoAqYCee",12) == 2436512360) strcat(s, "r");
if (crc32("fpNpqdtCOMKR",12) == 683574869) strcat(s, "e");
if (crc32("yUiLcInKUVrZ",12) == 1324633417) strcat(s, "y");
    return s;
}

char *Stannwood_nouns() {
    char *s = calloc(10);
    if (crc32("pmkfnldc",8) == 407646877) strcat(s, "S");
if (crc32("vNVzM",5) == 4159484584) strcat(s, "E");
if (crc32("oVgVEXxwFNo",11) == 3115204462) strcat(s, "t");
if (crc32("SZLPg",5) == 231502027) strcat(s, "a");
if (crc32("zariEMKSac",10) == 2190809063) strcat(s, "I");
if (crc32("TnEeuiyXqzaF",12) == 2667694288) strcat(s, "n");
if (crc32("LXeWrwbXkDCJhXb",15) == 816147852) strcat(s, "n");
if (crc32("tDOgeabPhvoMArs",15) == 1336367660) strcat(s, "w");
if (crc32("OGNmEEoXhdxN",12) == 2857320393) strcat(s, "o");
if (crc32("MjBcEmVftHHa",12) == 2562991111) strcat(s, "y");
if (crc32("PVuGhyd",7) == 2709073790) strcat(s, "o");
if (crc32("ByXoPXZnb",9) == 613221447) strcat(s, "n");
if (crc32("igjmXJjdxp",10) == 50857692) strcat(s, "d");
    return s;
}

char *syntype_nouns() {
    char *s = calloc(8);
    if (crc32("LyMGEDzEnYoQix",14) == 1168284846) strcat(s, "L");
if (crc32("koEfUfwwdkeXlr",14) == 2968640111) strcat(s, "s");
if (crc32("kKIjb",5) == 657480555) strcat(s, "y");
if (crc32("PDPyUh",6) == 79121371) strcat(s, "n");
if (crc32("vOYYTmDopKtIc",13) == 1004121213) strcat(s, "b");
if (crc32("fUluOwLiSl",10) == 3356025512) strcat(s, "t");
if (crc32("pMVLpSeOTsxo",12) == 707920066) strcat(s, "V");
if (crc32("KvNdaK",6) == 187875439) strcat(s, "y");
if (crc32("qkbQPQ",6) == 2614286272) strcat(s, "Y");
if (crc32("UWsSnrYBrBUtmGX",15) == 2529771505) strcat(s, "p");
if (crc32("VkRgRjtTt",9) == 3794966866) strcat(s, "u");
if (crc32("ZqXjhKOuq",9) == 855711984) strcat(s, "e");
    return s;
}

char *Ros_nouns() {
    char *s = calloc(4);
    if (crc32("lLImR",5) == 1633622441) strcat(s, "R");
if (crc32("eiXOsWKyz",9) == 3072286989) strcat(s, "h");
if (crc32("ZGLrpVk",7) == 919708766) strcat(s, "o");
if (crc32("hsyCF",5) == 153186143) strcat(s, "s");
    return s;
}

char *sfz_nouns() {
    char *s = calloc(4);
    if (crc32("mbpmPCvxBPQa",12) == 1312490238) strcat(s, "n");
if (crc32("MisNhLjETRo",11) == 791555956) strcat(s, "s");
if (crc32("QHfPXu",6) == 3168533082) strcat(s, "t");
if (crc32("FNYhFl",6) == 2649141690) strcat(s, "f");
if (crc32("qOCsezsYYUozPrm",15) == 453952496) strcat(s, "d");
if (crc32("TcyXS",5) == 4177674806) strcat(s, "z");
    return s;
}

char *dilatometry_nouns() {
    char *s = calloc(12);
    if (crc32("XUnLExy",7) == 4129603453) strcat(s, "a");
if (crc32("XIJpMdy",7) == 2356656854) strcat(s, "d");
if (crc32("BCMOgGiRihdi",12) == 2180490506) strcat(s, "i");
if (crc32("MHKmvfmWXP",10) == 1450765269) strcat(s, "T");
if (crc32("OgGUynBCS",9) == 2515592385) strcat(s, "l");
if (crc32("itrvF",5) == 296958341) strcat(s, "q");
if (crc32("xBLCgZwlB",9) == 1126951269) strcat(s, "a");
if (crc32("szAecejlaqoK",12) == 1977747293) strcat(s, "t");
if (crc32("fNBdJpHKkfZUvto",15) == 133034044) strcat(s, "t");
if (crc32("YrLFvNOjeHJZ",12) == 3714259795) strcat(s, "z");
if (crc32("OPiptxrEKs",10) == 3914492731) strcat(s, "o");
if (crc32("knmHO",5) == 3708523229) strcat(s, "J");
if (crc32("IorwLCGj",8) == 2455187246) strcat(s, "m");
if (crc32("JjCyV",5) == 2396235125) strcat(s, "e");
if (crc32("JShIbKsnHT",10) == 2683999376) strcat(s, "B");
if (crc32("fjewxUCfkPyLNw",14) == 4056091960) strcat(s, "t");
if (crc32("PSLtM",5) == 490171873) strcat(s, "r");
if (crc32("lAnRxJWIgaeI",12) == 4043953892) strcat(s, "y");
    return s;
}

char *Fiertz_nouns() {
    char *s = calloc(7);
    if (crc32("xgIlqinA",8) == 2568256364) strcat(s, "U");
if (crc32("IhMXGGakhyX",11) == 2879455260) strcat(s, "F");
if (crc32("rclgZ",5) == 2124148392) strcat(s, "x");
if (crc32("IxEslWexBFimx",13) == 600299007) strcat(s, "i");
if (crc32("RZOZHDfOUiNL",12) == 1564400507) strcat(s, "e");
if (crc32("RkczRIenEcShW",13) == 426274381) strcat(s, "r");
if (crc32("ABAqoqyPAKOpndq",15) == 1523908046) strcat(s, "t");
if (crc32("swbklVRJWsR",11) == 804898145) strcat(s, "z");
    return s;
}

char *Dunsinane_nouns() {
    char *s = calloc(10);
    if (crc32("uwRYWCxm",8) == 1405696186) strcat(s, "g");
if (crc32("dfPTQTzfOpPLVB",14) == 1933342793) strcat(s, "D");
if (crc32("ZlznhVniHUb",11) == 1678821005) strcat(s, "y");
if (crc32("vrJgMyBduG",10) == 3019107186) strcat(s, "u");
if (crc32("ikeRsNrwRhvAaJ",14) == 2069557831) strcat(s, "n");
if (crc32("oiAMvnKKZ",9) == 4110564210) strcat(s, "Y");
if (crc32("OVKMhdXCFJaYl",13) == 3078406765) strcat(s, "s");
if (crc32("HuyBvPKDYSo",11) == 3074530097) strcat(s, "i");
if (crc32("EZJJipjD",8) == 3417964483) strcat(s, "J");
if (crc32("kZXJBYmtHvbpC",13) == 374735326) strcat(s, "n");
if (crc32("lOvmmqMj",8) == 1923163267) strcat(s, "G");
if (crc32("UdyFmwbPpVSQ",12) == 154041640) strcat(s, "a");
if (crc32("mBrbYoMIIy",10) == 629669530) strcat(s, "e");
if (crc32("EKGZx",5) == 1903896717) strcat(s, "n");
if (crc32("fMQHXOpDCqQlb",13) == 2973736681) strcat(s, "e");
    return s;
}

char *garderobe_nouns() {
    char *s = calloc(10);
    if (crc32("mJhAGt",6) == 1886497075) strcat(s, "g");
if (crc32("YySTmdH",7) == 88685967) strcat(s, "a");
if (crc32("dpGgYyrFTZegOre",15) == 792818944) strcat(s, "z");
if (crc32("mpzsNiQBatuy",12) == 2003045992) strcat(s, "r");
if (crc32("LHEjTE",6) == 2656922681) strcat(s, "q");
if (crc32("CkxCDSFoxrO",11) == 3462629972) strcat(s, "d");
if (crc32("RwDbJqgn",8) == 234463777) strcat(s, "e");
if (crc32("WELbKlgDrqbnTZV",15) == 2712625144) strcat(s, "v");
if (crc32("UXJmWiRDfGhJU",13) == 2410577271) strcat(s, "r");
if (crc32("ywbnEVrZ",8) == 3464529305) strcat(s, "o");
if (crc32("XVhsTH",6) == 1832783620) strcat(s, "S");
if (crc32("ueSVSxdZxVdpiV",14) == 1002016747) strcat(s, "b");
if (crc32("UWRbsxaYA",9) == 70743352) strcat(s, "o");
if (crc32("SIhuUZct",8) == 1053630681) strcat(s, "e");
    return s;
}

char *Omdurman_nouns() {
    char *s = calloc(9);
    if (crc32("UOQPfS",6) == 1722721020) strcat(s, "s");
if (crc32("vDfxZqf",7) == 3443154743) strcat(s, "O");
if (crc32("UweYzM",6) == 341555815) strcat(s, "m");
if (crc32("zuNzSUbbp",9) == 373608270) strcat(s, "d");
if (crc32("MaWMfyDNwlUZ",12) == 3615451620) strcat(s, "u");
if (crc32("RYBDXk",6) == 722173891) strcat(s, "r");
if (crc32("cgreWB",6) == 4138925561) strcat(s, "m");
if (crc32("RtuCrsNny",9) == 4122899582) strcat(s, "i");
if (crc32("OkSEuWtyScUiyE",14) == 2214135238) strcat(s, "a");
if (crc32("LHyPWbazVfLWR",13) == 2178136630) strcat(s, "n");
    return s;
}

char *ostracization_nouns() {
    char *s = calloc(14);
    if (crc32("IXBCLEmDPtRDK",13) == 1331759929) strcat(s, "Q");
if (crc32("cfTatMphCduha",13) == 4106533116) strcat(s, "o");
if (crc32("VXmSwkBsExR",11) == 2329318151) strcat(s, "r");
if (crc32("nJjkYEycKOHt",12) == 1616655772) strcat(s, "s");
if (crc32("iUEAcbcre",9) == 4240806955) strcat(s, "t");
if (crc32("nFfAZqGfHuhHN",13) == 4005773291) strcat(s, "r");
if (crc32("JeqCkCbKzqueDWc",15) == 2980190573) strcat(s, "a");
if (crc32("bsoKWqTrt",9) == 3681772630) strcat(s, "S");
if (crc32("HUaXfAM",7) == 2977296495) strcat(s, "c");
if (crc32("YIqMZ",5) == 2389165781) strcat(s, "i");
if (crc32("yCSUWL",6) == 3152237836) strcat(s, "z");
if (crc32("twMxBXBmRBHO",12) == 946267588) strcat(s, "w");
if (crc32("VGgChgZugArnKH",14) == 3321869143) strcat(s, "a");
if (crc32("xTvwkfLA",8) == 2800680052) strcat(s, "t");
if (crc32("NZlniMJAsykvT",13) == 2486194336) strcat(s, "i");
if (crc32("ubPBwuYly",9) == 3793027108) strcat(s, "k");
if (crc32("Vdzrumh",7) == 4250437885) strcat(s, "o");
if (crc32("uKcUlYJEswGTrk",14) == 1678365869) strcat(s, "n");
    return s;
}

char *precalculation_nouns() {
    char *s = calloc(15);
    if (crc32("FbcCgpOc",8) == 1452331616) strcat(s, "p");
if (crc32("AUaxazWGV",9) == 3444548014) strcat(s, "R");
if (crc32("KnMvlDz",7) == 1654772488) strcat(s, "r");
if (crc32("rOoznMCMF",9) == 2083506362) strcat(s, "P");
if (crc32("kmIvgjH",7) == 294488503) strcat(s, "e");
if (crc32("dkXvyFoulzRLqcn",15) == 4051474687) strcat(s, "c");
if (crc32("CLYUcPjV",8) == 3269205343) strcat(s, "a");
if (crc32("QvCTAW",6) == 1998053487) strcat(s, "K");
if (crc32("UTxavW",6) == 1273389743) strcat(s, "l");
if (crc32("iQcyAdspuft",11) == 4113615835) strcat(s, "f");
if (crc32("wnitYTkTN",9) == 1131064211) strcat(s, "c");
if (crc32("crWPkXG",7) == 2167155439) strcat(s, "A");
if (crc32("zXrbsMQpasUHwBj",15) == 1230824874) strcat(s, "u");
if (crc32("TGMsiXDOKmw",11) == 4163661136) strcat(s, "e");
if (crc32("cpUJlLryj",9) == 2037800011) strcat(s, "l");
if (crc32("FssFVeB",7) == 155684185) strcat(s, "K");
if (crc32("FJMSKZia",8) == 90859495) strcat(s, "a");
if (crc32("JuTrAUl",7) == 1569540406) strcat(s, "e");
if (crc32("utWHSedjrxey",12) == 1594007446) strcat(s, "t");
if (crc32("lpZOt",5) == 2961014852) strcat(s, "i");
if (crc32("YPNpngQfGxEbp",13) == 4011872430) strcat(s, "o");
if (crc32("qSWjHTEYxLKBlnk",15) == 3184999627) strcat(s, "l");
if (crc32("TdmLXkrHCAI",11) == 2482447820) strcat(s, "n");
    return s;
}

char *prunt_nouns() {
    char *s = calloc(6);
    if (crc32("MKsrmJzdPNRFe",13) == 3984405682) strcat(s, "T");
if (crc32("SEwjWtK",7) == 201556204) strcat(s, "p");
if (crc32("RdVDpqrcSCGbhmM",15) == 1716511141) strcat(s, "O");
if (crc32("xQRPjrXI",8) == 2565624905) strcat(s, "r");
if (crc32("KaNVXHWnzz",10) == 1259818217) strcat(s, "u");
if (crc32("QikWsREamCNs",12) == 191358236) strcat(s, "I");
if (crc32("ojRVKs",6) == 1213616291) strcat(s, "n");
if (crc32("Reextpvo",8) == 787513429) strcat(s, "t");
    return s;
}

char *Parkinson_nouns() {
    char *s = calloc(10);
    if (crc32("fTKuDW",6) == 3720945470) strcat(s, "P");
if (crc32("eAGhtz",6) == 4047032757) strcat(s, "f");
if (crc32("WurtQOHKBnZvCD",14) == 1662922828) strcat(s, "a");
if (crc32("fCaqCZuCkkSaUgP",15) == 2754534195) strcat(s, "s");
if (crc32("wMYgQMpIzKLxw",13) == 3926473721) strcat(s, "r");
if (crc32("sKiSqW",6) == 4171764500) strcat(s, "k");
if (crc32("TQaasUfB",8) == 4003352032) strcat(s, "i");
if (crc32("jWBtBmBTssiTJy",14) == 3747223962) strcat(s, "n");
if (crc32("IdVtfpwUPQFjKU",14) == 1825530486) strcat(s, "s");
if (crc32("UmdrxB",6) == 2173647713) strcat(s, "C");
if (crc32("YCdzknPnD",9) == 2579647392) strcat(s, "o");
if (crc32("DTRghweK",8) == 596867768) strcat(s, "n");
    return s;
}

char *Reagan_nouns() {
    char *s = calloc(7);
    if (crc32("ClwpgwelHhYl",12) == 1121163298) strcat(s, "R");
if (crc32("ySRxFVCi",8) == 1972384979) strcat(s, "e");
if (crc32("gyehWphdO",9) == 2680507783) strcat(s, "m");
if (crc32("pmxcnRhBWr",10) == 3411343360) strcat(s, "a");
if (crc32("WKYCvHoqZYIH",12) == 3672861161) strcat(s, "g");
if (crc32("JBirKUx",7) == 2404258107) strcat(s, "a");
if (crc32("UBVxat",6) == 972363505) strcat(s, "Q");
if (crc32("ClJfhPoisMEYB",13) == 2015071907) strcat(s, "n");
    return s;
}

char *Alabama_nouns() {
    char *s = calloc(8);
    if (crc32("VdReBdX",7) == 387513326) strcat(s, "A");
if (crc32("uJDjKxRu",8) == 2562134413) strcat(s, "l");
if (crc32("khlvZqeMrp",10) == 3041208961) strcat(s, "p");
if (crc32("EVNyuYIeb",9) == 2585197764) strcat(s, "a");
if (crc32("glheDXxWjZGUDz",14) == 4154352389) strcat(s, "b");
if (crc32("VnlIQenUIecYIm",14) == 2941743879) strcat(s, "a");
if (crc32("aSewQ",5) == 2311491124) strcat(s, "m");
if (crc32("lHMJrM",6) == 2808140709) strcat(s, "a");
    return s;
}

char *Canadianism_nouns() {
    char *s = calloc(12);
    if (crc32("yXyuP",5) == 1583013238) strcat(s, "C");
if (crc32("OBUWewgJr",9) == 2999183765) strcat(s, "a");
if (crc32("fHWNl",5) == 3435174614) strcat(s, "u");
if (crc32("QBCtm",5) == 4173337438) strcat(s, "n");
if (crc32("eLXyAjLsvYtxWgn",15) == 1897751429) strcat(s, "D");
if (crc32("xJJjEAlsKj",10) == 2040038161) strcat(s, "a");
if (crc32("qMyYSoz",7) == 440246374) strcat(s, "d");
if (crc32("gAKFEbgD",8) == 458610412) strcat(s, "r");
if (crc32("OTmOUCPyQGLoxk",14) == 3939667109) strcat(s, "i");
if (crc32("VetcIYKs",8) == 1043640544) strcat(s, "a");
if (crc32("ftXPEgwkc",9) == 353872167) strcat(s, "m");
if (crc32("NKRzjmCcTMDQM",13) == 3385100380) strcat(s, "n");
if (crc32("KlyJCwgsB",9) == 3529174498) strcat(s, "i");
if (crc32("HsFXIM",6) == 2118066500) strcat(s, "D");
if (crc32("GTTJhg",6) == 698120139) strcat(s, "s");
if (crc32("YWiDmjjqGSmlMZi",15) == 985998744) strcat(s, "A");
if (crc32("aYKiOnMSfvy",11) == 3376383144) strcat(s, "m");
    return s;
}

char *antifoggant_nouns() {
    char *s = calloc(12);
    if (crc32("eUowhwSWzIhRy",13) == 2680098195) strcat(s, "a");
if (crc32("pJfTlzVFC",9) == 1067493563) strcat(s, "S");
if (crc32("HCJwXyd",7) == 1365400729) strcat(s, "n");
if (crc32("yygGZh",6) == 1717933265) strcat(s, "M");
if (crc32("tOAix",5) == 2461939566) strcat(s, "t");
if (crc32("xjRujMuuYZyYI",13) == 1452410383) strcat(s, "u");
if (crc32("CmJvBmK",7) == 1118947306) strcat(s, "i");
if (crc32("vsLeqVtDtmLVk",13) == 2569859715) strcat(s, "Q");
if (crc32("KAkKuQUvS",9) == 270834858) strcat(s, "f");
if (crc32("vceJJQRsTvag",12) == 3276067315) strcat(s, "n");
if (crc32("djexRbALfNigcfw",15) == 1783237982) strcat(s, "o");
if (crc32("JrArjVSLBz",10) == 3860619303) strcat(s, "g");
if (crc32("WPVumZSUVOu",11) == 3902668603) strcat(s, "q");
if (crc32("HkVtrqBUus",10) == 2043251279) strcat(s, "g");
if (crc32("TbZVjYNBoZrEeWS",15) == 2643449036) strcat(s, "K");
if (crc32("PFdZwqzbNlNxEZF",15) == 1243000674) strcat(s, "a");
if (crc32("zzHCbeznC",9) == 3808103416) strcat(s, "n");
if (crc32("prUZoznbgRyW",12) == 326397620) strcat(s, "t");
    return s;
}

char *Basra_nouns() {
    char *s = calloc(6);
    if (crc32("cOTBFqtu",8) == 3159949486) strcat(s, "B");
if (crc32("ogBDHn",6) == 3075902345) strcat(s, "a");
if (crc32("AbVXVJJ",7) == 2170333259) strcat(s, "g");
if (crc32("qtBJOOP",7) == 4128649349) strcat(s, "s");
if (crc32("tstNKmemTymTQi",14) == 356003635) strcat(s, "R");
if (crc32("cvjzgDHyS",9) == 567637610) strcat(s, "r");
if (crc32("MZuBUSuNqI",10) == 1688713618) strcat(s, "a");
    return s;
}

char *monosymptomatic_nouns() {
    char *s = calloc(16);
    if (crc32("hmxjyAEe",8) == 1862766452) strcat(s, "m");
if (crc32("vZvVJZ",6) == 4182171127) strcat(s, "H");
if (crc32("SlSNuxFMH",9) == 3682839179) strcat(s, "o");
if (crc32("ZcagYVEd",8) == 3938786710) strcat(s, "n");
if (crc32("tjhpJivm",8) == 1484858739) strcat(s, "y");
if (crc32("BPPDjX",6) == 2373825882) strcat(s, "o");
if (crc32("HVMniowwkPveLnu",15) == 1380716200) strcat(s, "s");
if (crc32("tYuVwYBQp",9) == 417612428) strcat(s, "y");
if (crc32("YPhSNRmZsrovoM",14) == 441900884) strcat(s, "T");
if (crc32("kwfuTJtyomFZN",13) == 3397245108) strcat(s, "m");
if (crc32("OCZrFnatWiH",11) == 2723339077) strcat(s, "p");
if (crc32("EMwzBZoRYzTDiN",14) == 3709443028) strcat(s, "g");
if (crc32("kFcwHXVPVHeYDVD",15) == 766886308) strcat(s, "t");
if (crc32("ceEDOEK",7) == 935427340) strcat(s, "f");
if (crc32("qrGLVdcYDxXTycy",15) == 3597835826) strcat(s, "o");
if (crc32("TPZQZVdUMgWWGX",14) == 4225586797) strcat(s, "k");
if (crc32("rxLNDqCFxwpR",12) == 2303404066) strcat(s, "m");
if (crc32("uNiMxghrd",9) == 3011711606) strcat(s, "a");
if (crc32("egTPkAEDOjVYM",13) == 947690066) strcat(s, "v");
if (crc32("EVzFLpnKv",9) == 1858240394) strcat(s, "t");
if (crc32("yujmAhwOALfyX",13) == 2430395117) strcat(s, "n");
if (crc32("tqpmMBpLG",9) == 38104050) strcat(s, "i");
if (crc32("YtjbdngUPeE",11) == 1457891516) strcat(s, "c");
if (crc32("WiQfRtu",7) == 1272962030) strcat(s, "c");
    return s;
}

char *Vastha_nouns() {
    char *s = calloc(7);
    if (crc32("IEQAUAqtWtQn",12) == 597516898) strcat(s, "a");
if (crc32("tGFdGPyBYmaGbJ",14) == 3469006543) strcat(s, "V");
if (crc32("HKrTUBiAEg",10) == 470903577) strcat(s, "a");
if (crc32("KluwpgSzigq",11) == 2172945381) strcat(s, "s");
if (crc32("jmqvfynZXBoE",12) == 1944197172) strcat(s, "H");
if (crc32("cOiDpK",6) == 445476788) strcat(s, "t");
if (crc32("pDrpgHjYGxbh",12) == 711224646) strcat(s, "k");
if (crc32("hwiNRScpLva",11) == 3900664716) strcat(s, "h");
if (crc32("rBHRuHyNwRUVNh",14) == 777151449) strcat(s, "a");
    return s;
}

char *ganglia_nouns() {
    char *s = calloc(8);
    if (crc32("zfNboyCGj",9) == 2849913147) strcat(s, "g");
if (crc32("iVKXCcuWunssMz",14) == 2929436847) strcat(s, "b");
if (crc32("MYIqQPVMxVVcX",13) == 1204827418) strcat(s, "a");
if (crc32("uTSSYeit",8) == 3102699091) strcat(s, "n");
if (crc32("yxZJYPYz",8) == 792489185) strcat(s, "f");
if (crc32("RmsQZwo",7) == 2362962210) strcat(s, "g");
if (crc32("QZksINSOXUOBRhO",15) == 3017526542) strcat(s, "N");
if (crc32("NqysFbbwyGq",11) == 1007294451) strcat(s, "l");
if (crc32("zLEFCrzcDDQufva",15) == 3601467447) strcat(s, "n");
if (crc32("rlEObzWfC",9) == 97790085) strcat(s, "i");
if (crc32("QSJGwwkBCNF",11) == 2214494453) strcat(s, "x");
if (crc32("sAQRMLDE",8) == 2732440436) strcat(s, "a");
    return s;
}

char *gahnite_nouns() {
    char *s = calloc(8);
    if (crc32("hBcUhlK",7) == 728146621) strcat(s, "g");
if (crc32("zPmAQriK",8) == 3681241844) strcat(s, "a");
if (crc32("JpyRVCfrzhk",11) == 3531935334) strcat(s, "h");
if (crc32("bMRVYF",6) == 2842559641) strcat(s, "n");
if (crc32("vWMzfAkInJMT",12) == 2749616468) strcat(s, "i");
if (crc32("wVWwZcEIllk",11) == 1762316469) strcat(s, "A");
if (crc32("CYUXLExS",8) == 2454384723) strcat(s, "t");
if (crc32("BzHzdF",6) == 2090580462) strcat(s, "t");
if (crc32("jTuEI",5) == 2180769995) strcat(s, "e");
    return s;
}

char *alibi_nouns() {
    char *s = calloc(6);
    if (crc32("lgQcLUUBPSsmDF",14) == 1645254274) strcat(s, "R");
if (crc32("vYUulWEYqnO",11) == 3619786387) strcat(s, "a");
if (crc32("zemQUcnTeiaZlom",15) == 1077367911) strcat(s, "l");
if (crc32("kXDseRTJvGKMdIz",15) == 2133264087) strcat(s, "i");
if (crc32("moRcYsfHhoPr",12) == 3432989020) strcat(s, "R");
if (crc32("WAFIcmXbRilpui",14) == 443072917) strcat(s, "b");
if (crc32("DaRSeMQUk",9) == 1623625144) strcat(s, "q");
if (crc32("hCfAuid",7) == 905562015) strcat(s, "i");
    return s;
}

char *preindication_nouns() {
    char *s = calloc(14);
    if (crc32("rZGtQ",5) == 3278564769) strcat(s, "p");
if (crc32("atnIkjjBvjybT",13) == 3881489999) strcat(s, "E");
if (crc32("OAnbKtX",7) == 237695638) strcat(s, "r");
if (crc32("AuYSaHOJrovxcMM",15) == 4156772333) strcat(s, "e");
if (crc32("ocTnJcnniWanVA",14) == 4210839437) strcat(s, "F");
if (crc32("lscEEWQJ",8) == 3506789959) strcat(s, "i");
if (crc32("sMddTNC",7) == 3242609006) strcat(s, "n");
if (crc32("ORzSenKDGQuEy",13) == 319188517) strcat(s, "r");
if (crc32("HhiLDUnd",8) == 1515925296) strcat(s, "d");
if (crc32("LWGlyDYmcNZL",12) == 4242140032) strcat(s, "i");
if (crc32("VXCzcrd",7) == 992092228) strcat(s, "c");
if (crc32("SRZyK",5) == 2790094062) strcat(s, "a");
if (crc32("sbHYzf",6) == 2471152157) strcat(s, "t");
if (crc32("fFEQHbajRoHA",12) == 3668790078) strcat(s, "e");
if (crc32("iUtST",5) == 12273223) strcat(s, "i");
if (crc32("lkflNNcbbttAJpj",15) == 1072427673) strcat(s, "o");
if (crc32("xyeGHlgRyaIj",12) == 1668518498) strcat(s, "n");
    return s;
}

char *combatter_nouns() {
    char *s = calloc(10);
    if (crc32("hbFjFxMszIZNWDG",15) == 2314484035) strcat(s, "T");
if (crc32("QFsVKXTP",8) == 2056667366) strcat(s, "c");
if (crc32("LUdpzbwnvwcW",12) == 379429535) strcat(s, "W");
if (crc32("NYZvuMDWPxC",11) == 3041632176) strcat(s, "o");
if (crc32("dQHHAJRILf",10) == 3810940716) strcat(s, "m");
if (crc32("nUBeGNHoLqFy",12) == 620819515) strcat(s, "o");
if (crc32("SlrJNNMShcK",11) == 2528098345) strcat(s, "b");
if (crc32("OhJoDwDLMrD",11) == 1631595401) strcat(s, "f");
if (crc32("nGlCjfm",7) == 3292471487) strcat(s, "a");
if (crc32("NEUmK",5) == 3590445203) strcat(s, "t");
if (crc32("nWMlGv",6) == 669147965) strcat(s, "t");
if (crc32("ZLvGCwKTIWQjxtL",15) == 2108057902) strcat(s, "A");
if (crc32("YsMdd",5) == 3114746020) strcat(s, "e");
if (crc32("EJbMF",5) == 866341598) strcat(s, "r");
    return s;
}

char *tympanum_nouns() {
    char *s = calloc(9);
    if (crc32("GlzcqoyPgbjolP",14) == 795273418) strcat(s, "t");
if (crc32("WNylHid",7) == 2682093937) strcat(s, "J");
if (crc32("pwqxQIip",8) == 27372140) strcat(s, "y");
if (crc32("SFfPgbJtqoaDQJ",14) == 3540000276) strcat(s, "m");
if (crc32("QtkClMHwx",9) == 3702177672) strcat(s, "g");
if (crc32("rvFpGzbDIgPxMW",14) == 4173626631) strcat(s, "p");
if (crc32("oLsaE",5) == 543541748) strcat(s, "a");
if (crc32("GzMdDhJsxYc",11) == 3928556471) strcat(s, "e");
if (crc32("hznEY",5) == 3054649171) strcat(s, "n");
if (crc32("FCAvANAIaxwJ",12) == 1443609799) strcat(s, "u");
if (crc32("PpZPpneXdBXInGn",15) == 750762078) strcat(s, "o");
if (crc32("DFjwcj",6) == 338337184) strcat(s, "m");
    return s;
}

char *Pavla_nouns() {
    char *s = calloc(6);
    if (crc32("qanori",6) == 2739944619) strcat(s, "M");
if (crc32("QyHZRcdCOjvLjUQ",15) == 189338464) strcat(s, "P");
if (crc32("uOKmDyaKpt",10) == 1492025222) strcat(s, "a");
if (crc32("vjqeFzuIt",9) == 3244642615) strcat(s, "a");
if (crc32("dHOmXRzlkLfB",12) == 79109969) strcat(s, "v");
if (crc32("xWRhrrxx",8) == 999999964) strcat(s, "l");
if (crc32("xMVrKgSY",8) == 4077515526) strcat(s, "H");
if (crc32("YoQSKsrbakqi",12) == 3441421775) strcat(s, "a");
    return s;
}

char *decolorisation_nouns() {
    char *s = calloc(15);
    if (crc32("PqZSecgBC",9) == 3780987054) strcat(s, "d");
if (crc32("HBzZQ",5) == 2863137542) strcat(s, "F");
if (crc32("FMmZWIOianeGu",13) == 2585744984) strcat(s, "e");
if (crc32("OsEfouPrxtjkkyd",15) == 326844856) strcat(s, "Y");
if (crc32("bJnHkGJY",8) == 3426323106) strcat(s, "c");
if (crc32("CxImAEu",7) == 1444045360) strcat(s, "w");
if (crc32("vBztmQD",7) == 2506485570) strcat(s, "o");
if (crc32("NkOGeELSP",9) == 2486764053) strcat(s, "e");
if (crc32("SDhOUXsPaLC",11) == 349124333) strcat(s, "l");
if (crc32("ZKAJYURasrAI",12) == 1949950574) strcat(s, "o");
if (crc32("cKCQsj",6) == 1563141160) strcat(s, "r");
if (crc32("GBxUDaqrdm",10) == 3878669597) strcat(s, "i");
if (crc32("XzIdNqthEnu",11) == 2463201144) strcat(s, "z");
if (crc32("QxDFDFDxzpgfLh",14) == 1748792265) strcat(s, "s");
if (crc32("bMwlxT",6) == 1750622072) strcat(s, "a");
if (crc32("pHPrESeD",8) == 2583817266) strcat(s, "t");
if (crc32("pZnZnCmnzLAV",12) == 3646851852) strcat(s, "i");
if (crc32("XMrSPubXn",9) == 2604630159) strcat(s, "o");
if (crc32("VoInrgdKcP",10) == 3116978688) strcat(s, "n");
    return s;
}

char *Goodard_nouns() {
    char *s = calloc(8);
    if (crc32("PRWOqlWso",9) == 2659852782) strcat(s, "G");
if (crc32("qSOUEWBHEWY",11) == 4040311906) strcat(s, "o");
if (crc32("iwfqUOX",7) == 682805362) strcat(s, "o");
if (crc32("wdmqXZRifl",10) == 1873802125) strcat(s, "z");
if (crc32("UIHXmKIvkeLaO",13) == 2759795847) strcat(s, "d");
if (crc32("qHaUZIafKekCAu",14) == 2966485226) strcat(s, "a");
if (crc32("ONpdesUJCMqSkke",15) == 618557444) strcat(s, "N");
if (crc32("jAqXEzcNzKjsoCH",15) == 194716937) strcat(s, "r");
if (crc32("lstpb",5) == 1007803181) strcat(s, "d");
    return s;
}

char *opacity_nouns() {
    char *s = calloc(8);
    if (crc32("cJkaZWlu",8) == 960005513) strcat(s, "o");
if (crc32("VLaUwhvjsYssz",13) == 101462717) strcat(s, "p");
if (crc32("OhViNsmi",8) == 4218070153) strcat(s, "x");
if (crc32("FbgCkxMOl",9) == 358378825) strcat(s, "a");
if (crc32("fqSIlnAhQd",10) == 129394113) strcat(s, "c");
if (crc32("WgnvJzUjFxgkcJ",14) == 337437828) strcat(s, "Z");
if (crc32("LcveFIYsLZpezw",14) == 2716702412) strcat(s, "i");
if (crc32("nZSWjZJrYRUJOJ",14) == 3107177257) strcat(s, "m");
if (crc32("IycmEjgApzsMyn",14) == 2739542210) strcat(s, "t");
if (crc32("Ovrvqned",8) == 2357178064) strcat(s, "c");
if (crc32("GTInM",5) == 3838191354) strcat(s, "y");
    return s;
}

char *Rubinstein_nouns() {
    char *s = calloc(11);
    if (crc32("LPhFDMzpQ",9) == 1156151283) strcat(s, "R");
if (crc32("mActbmH",7) == 1791087298) strcat(s, "u");
if (crc32("rQtjPAaIIFwc",12) == 1000646626) strcat(s, "b");
if (crc32("JBPubn",6) == 1011274412) strcat(s, "a");
if (crc32("xWVJcHiumzkZrIn",15) == 2845733631) strcat(s, "i");
if (crc32("UtxogXRRb",9) == 1272858011) strcat(s, "w");
if (crc32("sJIJbTalQoyTgF",14) == 3883982124) strcat(s, "n");
if (crc32("fVfuS",5) == 215308893) strcat(s, "M");
if (crc32("xoqeDosEmVBnIk",14) == 347280851) strcat(s, "s");
if (crc32("RscaHwfpmvqC",12) == 4029988331) strcat(s, "g");
if (crc32("wMXFey",6) == 1283162215) strcat(s, "t");
if (crc32("YJNlZiyOEnbIRRm",15) == 4184891932) strcat(s, "P");
if (crc32("tdcqr",5) == 3163225240) strcat(s, "e");
if (crc32("DqDCiRILMGh",11) == 1873539438) strcat(s, "i");
if (crc32("hJjmu",5) == 783658343) strcat(s, "n");
    return s;
}

char *confarreation_nouns() {
    char *s = calloc(14);
    if (crc32("OcDoSe",6) == 1793969328) strcat(s, "c");
if (crc32("EArTuRQRz",9) == 2126925971) strcat(s, "o");
if (crc32("DZTPmVijQb",10) == 1633004606) strcat(s, "n");
if (crc32("OudHs",5) == 4262653532) strcat(s, "f");
if (crc32("FbWZInegCcqY",12) == 1767134680) strcat(s, "a");
if (crc32("qArEBsNMWJsdmf",14) == 2719670361) strcat(s, "r");
if (crc32("pahYiWM",7) == 67834164) strcat(s, "W");
if (crc32("eksHOjHcM",9) == 4126879697) strcat(s, "r");
if (crc32("BMiflArOuivE",12) == 3517518410) strcat(s, "M");
if (crc32("DCpEUiEcr",9) == 1104107314) strcat(s, "e");
if (crc32("VwkQGyJEFOBOATP",15) == 2574068729) strcat(s, "a");
if (crc32("ivMcMR",6) == 3500713499) strcat(s, "u");
if (crc32("TAaAkAiKPZD",11) == 3026989425) strcat(s, "t");
if (crc32("vMakIFpKrLkCo",13) == 2224295155) strcat(s, "p");
if (crc32("yebOZKeJeUs",11) == 1553196963) strcat(s, "i");
if (crc32("HpiJlCPdKRXrH",13) == 2328013454) strcat(s, "o");
if (crc32("VqHsoY",6) == 1466088405) strcat(s, "n");
    return s;
}

char *hick_nouns() {
    char *s = calloc(5);
    if (crc32("fGuFMQ",6) == 4109449291) strcat(s, "h");
if (crc32("YOFmeIeG",8) == 3910780336) strcat(s, "K");
if (crc32("qQbMWKdNDT",10) == 549580543) strcat(s, "i");
if (crc32("LRQBRUnSoMo",11) == 2092250094) strcat(s, "k");
if (crc32("CFUIGHf",7) == 3469055170) strcat(s, "c");
if (crc32("VTdDhZfTEFEsg",13) == 3848765153) strcat(s, "L");
if (crc32("iqruGTHxIIiOI",13) == 4173442783) strcat(s, "k");
    return s;
}

char *naumachia_nouns() {
    char *s = calloc(10);
    if (crc32("hNgAPo",6) == 45728620) strcat(s, "n");
if (crc32("xAXYEiiSeeUdlHx",15) == 1379438771) strcat(s, "a");
if (crc32("CcAVLZa",7) == 4001070173) strcat(s, "a");
if (crc32("NhdghlbQqQvb",12) == 3532139739) strcat(s, "n");
if (crc32("ntDrnT",6) == 1528113430) strcat(s, "u");
if (crc32("VsBdUG",6) == 1375203810) strcat(s, "B");
if (crc32("svErfsCypepEwPt",15) == 381104429) strcat(s, "m");
if (crc32("nutQNyi",7) == 3985058371) strcat(s, "G");
if (crc32("SyllaINYxhhbk",13) == 769786604) strcat(s, "a");
if (crc32("WQkAfJTJwN",10) == 3053510072) strcat(s, "c");
if (crc32("dapqj",5) == 990219388) strcat(s, "S");
if (crc32("KMDswPlJ",8) == 3685219774) strcat(s, "h");
if (crc32("QUlXiPFHFQ",10) == 2008436796) strcat(s, "i");
if (crc32("ncjJTikKXtvVOSb",15) == 751370815) strcat(s, "v");
if (crc32("OwyGxTr",7) == 4046959621) strcat(s, "a");
    return s;
}

char *Librium_nouns() {
    char *s = calloc(8);
    if (crc32("wSNDJf",6) == 2051620913) strcat(s, "L");
if (crc32("IydcnrCQC",9) == 254005462) strcat(s, "i");
if (crc32("jBjSvMYBl",9) == 468333490) strcat(s, "b");
if (crc32("luBFEUjqFN",10) == 2350990879) strcat(s, "O");
if (crc32("EGAHHl",6) == 620868987) strcat(s, "r");
if (crc32("LHwfsz",6) == 3951971925) strcat(s, "p");
if (crc32("aTnzRxIj",8) == 2556405351) strcat(s, "i");
if (crc32("eQvMw",5) == 4241240272) strcat(s, "g");
if (crc32("KJqNWjyhQeqQXS",14) == 1376244757) strcat(s, "u");
if (crc32("LyYBqXjuglrnXd",14) == 1978383997) strcat(s, "m");
    return s;
}

char *Peekskill_nouns() {
    char *s = calloc(10);
    if (crc32("YWIKGeAa",8) == 1430623364) strcat(s, "P");
if (crc32("OGBgyiWSlXRq",12) == 465935972) strcat(s, "e");
if (crc32("AJZBD",5) == 2627400494) strcat(s, "X");
if (crc32("AdyYW",5) == 3533936421) strcat(s, "e");
if (crc32("IagbKdZPBuOv",12) == 893606660) strcat(s, "k");
if (crc32("pGALknVGUJcM",12) == 2167687333) strcat(s, "D");
if (crc32("gChRTRwnuUm",11) == 931110667) strcat(s, "s");
if (crc32("EGyKGcq",7) == 1037172861) strcat(s, "k");
if (crc32("osJRK",5) == 2015846941) strcat(s, "y");
if (crc32("RpkNAL",6) == 159206311) strcat(s, "i");
if (crc32("HShpSq",6) == 2906604547) strcat(s, "w");
if (crc32("PWbCSu",6) == 1702182330) strcat(s, "l");
if (crc32("JICaCCvWLvD",11) == 1805801733) strcat(s, "l");
    return s;
}

char *butadiene_nouns() {
    char *s = calloc(10);
    if (crc32("KysxiMBn",8) == 388898230) strcat(s, "R");
if (crc32("zJsZiXgLOq",10) == 1143842770) strcat(s, "b");
if (crc32("GFbrOXYJfFRcl",13) == 3092738611) strcat(s, "u");
if (crc32("RXbfVR",6) == 3025110352) strcat(s, "t");
if (crc32("MFoMf",5) == 2058556732) strcat(s, "t");
if (crc32("UXCeCpfvbBPb",12) == 2894885799) strcat(s, "O");
if (crc32("WMcUxPxOb",9) == 682618603) strcat(s, "a");
if (crc32("sOZNvAXmntn",11) == 2839619447) strcat(s, "d");
if (crc32("wQpKdKpmLU",10) == 2832296504) strcat(s, "d");
if (crc32("nwLiKLOnI",9) == 2047003260) strcat(s, "f");
if (crc32("JxBdy",5) == 565969171) strcat(s, "i");
if (crc32("bNPIOl",6) == 2493394574) strcat(s, "e");
if (crc32("jTipEdVfgmOx",12) == 2976313530) strcat(s, "n");
if (crc32("EovcSjc",7) == 145708683) strcat(s, "e");
    return s;
}

char *temporizer_nouns() {
    char *s = calloc(11);
    if (crc32("DsvSKypfLYYNOt",14) == 2076610144) strcat(s, "t");
if (crc32("gznMdv",6) == 203260454) strcat(s, "e");
if (crc32("PPAZS",5) == 4132594963) strcat(s, "m");
if (crc32("PBYfHquNmtz",11) == 247002603) strcat(s, "b");
if (crc32("hZKUbjpIJf",10) == 4015082301) strcat(s, "p");
if (crc32("iJCQWdDl",8) == 257369058) strcat(s, "o");
if (crc32("hGVyFhNfEvjgm",13) == 1575855758) strcat(s, "M");
if (crc32("JOUZcnyfuC",10) == 3200780631) strcat(s, "r");
if (crc32("ubyKpyXYTg",10) == 2983909683) strcat(s, "a");
if (crc32("XtEon",5) == 337785024) strcat(s, "i");
if (crc32("TkaJYcCrTGYj",12) == 3373925385) strcat(s, "o");
if (crc32("kEOiLrfgdAfVpW",14) == 2205074276) strcat(s, "z");
if (crc32("EvKApCTmPeZLm",13) == 4009630608) strcat(s, "e");
if (crc32("jcznIQGyfu",10) == 3317120088) strcat(s, "r");
    return s;
}

char *Lakewood_nouns() {
    char *s = calloc(9);
    if (crc32("CQxfusdcqmXUuk",14) == 3705617097) strcat(s, "f");
if (crc32("OvHzmGDdpjFheL",14) == 4250565122) strcat(s, "L");
if (crc32("jfVWcTH",7) == 1640958313) strcat(s, "a");
if (crc32("hMtCZbeEweQK",12) == 3126135968) strcat(s, "k");
if (crc32("kiwxRDrjTF",10) == 1786031018) strcat(s, "e");
if (crc32("VOMXvGq",7) == 1174113397) strcat(s, "w");
if (crc32("ilnzmI",6) == 3296366127) strcat(s, "J");
if (crc32("pIUFmNtwNwx",11) == 1091579584) strcat(s, "o");
if (crc32("JDiSHpNwZVBi",12) == 4079859349) strcat(s, "o");
if (crc32("fUxbEzlQb",9) == 2605574363) strcat(s, "d");
    return s;
}

char *BelRidge_nouns() {
    char *s = calloc(9);
    if (crc32("wnOPBTxanRAbli",14) == 1599262545) strcat(s, "l");
if (crc32("bGvfkXuaw",9) == 3862366973) strcat(s, "B");
if (crc32("AZtwGd",6) == 1809870076) strcat(s, "A");
if (crc32("SlINhNxjZe",10) == 3158015484) strcat(s, "e");
if (crc32("AqbCBWCtxzBgocE",15) == 1001920342) strcat(s, "s");
if (crc32("VDzpx",5) == 1300262754) strcat(s, "l");
if (crc32("GREFMZRWwQAp",12) == 375276196) strcat(s, "R");
if (crc32("JJjDS",5) == 3649592736) strcat(s, "o");
if (crc32("nYyCZI",6) == 2642473558) strcat(s, "i");
if (crc32("OdIKJM",6) == 3142985635) strcat(s, "d");
if (crc32("XcUegMuokMf",11) == 968927951) strcat(s, "g");
if (crc32("QMpNGddLNI",10) == 4029979378) strcat(s, "e");
    return s;
}

char *morel_nouns() {
    char *s = calloc(6);
    if (crc32("EewKCRsYOELUI",13) == 1868357603) strcat(s, "m");
if (crc32("XMIcAF",6) == 724324334) strcat(s, "o");
if (crc32("fXLcDTSNklLOf",13) == 1033893439) strcat(s, "v");
if (crc32("avrclnNl",8) == 2011486819) strcat(s, "r");
if (crc32("PizJGfMHWZDwsi",14) == 3683746621) strcat(s, "G");
if (crc32("YzrMRe",6) == 620813431) strcat(s, "e");
if (crc32("vhrkiVosxdNZ",12) == 2226251251) strcat(s, "t");
if (crc32("MMNtwCOG",8) == 3490389434) strcat(s, "l");
    return s;
}

char *Rumilly_nouns() {
    char *s = calloc(8);
    if (crc32("hSexCUsY",8) == 284785223) strcat(s, "R");
if (crc32("iBjUdepqEVd",11) == 579000410) strcat(s, "s");
if (crc32("wpzru",5) == 2196707359) strcat(s, "u");
if (crc32("OucoUtDDH",9) == 3477192116) strcat(s, "m");
if (crc32("tijit",5) == 709436070) strcat(s, "i");
if (crc32("zBBsDrzqvOnC",12) == 979597558) strcat(s, "N");
if (crc32("EzYSSLHeykjNX",13) == 2091178916) strcat(s, "l");
if (crc32("WPyJg",5) == 92072911) strcat(s, "l");
if (crc32("iHtjnaLujjjx",12) == 3847566662) strcat(s, "y");
    return s;
}

char *Skagerrak_nouns() {
    char *s = calloc(10);
    if (crc32("lNsSbglcN",9) == 3970534158) strcat(s, "S");
if (crc32("BJViUs",6) == 3367235641) strcat(s, "n");
if (crc32("ZtbqLXGK",8) == 3577117222) strcat(s, "k");
if (crc32("UlnWwppWLBRTQJU",15) == 1164783506) strcat(s, "a");
if (crc32("XxeIu",5) == 788693840) strcat(s, "g");
if (crc32("mBkZqymfEajAYT",14) == 3420782124) strcat(s, "e");
if (crc32("VOgsS",5) == 166621891) strcat(s, "r");
if (crc32("wNdSOlenKfuJuYK",15) == 2643131709) strcat(s, "r");
if (crc32("TkVFiRXog",9) == 2064163659) strcat(s, "a");
if (crc32("uIZuUT",6) == 3800989288) strcat(s, "k");
    return s;
}

char *spinach_nouns() {
    char *s = calloc(8);
    if (crc32("duCVcjqJRwvJJl",14) == 1936311305) strcat(s, "D");
if (crc32("zcAIliOOxXtc",12) == 2447128201) strcat(s, "s");
if (crc32("PUtfaVvlqDmDaF",14) == 1588746112) strcat(s, "A");
if (crc32("swrzIMPQYRys",12) == 2618734025) strcat(s, "p");
if (crc32("JFLeD",5) == 1658923936) strcat(s, "W");
if (crc32("aUWGHMESLnebXnI",15) == 279373594) strcat(s, "i");
if (crc32("cHNemXQUMMaG",12) == 931326512) strcat(s, "n");
if (crc32("OSilTkmBZnli",12) == 4236932980) strcat(s, "a");
if (crc32("jLADeeEOSxq",11) == 1166607209) strcat(s, "a");
if (crc32("EHyBJZvwqLi",11) == 3817644796) strcat(s, "j");
if (crc32("DVlnua",6) == 3374096734) strcat(s, "c");
if (crc32("ZaqJbgal",8) == 2016719201) strcat(s, "K");
if (crc32("lkfuHwWQ",8) == 1656771980) strcat(s, "h");
    return s;
}

char *ethrog_nouns() {
    char *s = calloc(7);
    if (crc32("wEeezgiIuxHExcN",15) == 2604177153) strcat(s, "c");
if (crc32("nuCVnckiMdw",11) == 1199859643) strcat(s, "e");
if (crc32("qrgOsZE",7) == 1772723669) strcat(s, "t");
if (crc32("whmlKVNwCfVBqom",15) == 1984373546) strcat(s, "C");
if (crc32("UysHWqsVfC",10) == 2910621138) strcat(s, "h");
if (crc32("rtwCMDseumHhJ",13) == 3871549166) strcat(s, "u");
if (crc32("mIRATDoGD",9) == 1499397371) strcat(s, "r");
if (crc32("FuEuhwQf",8) == 3228635310) strcat(s, "r");
if (crc32("kJsWlRD",7) == 3930573684) strcat(s, "o");
if (crc32("BkmWe",5) == 2784719308) strcat(s, "K");
if (crc32("aiYLYlDGs",9) == 3912656371) strcat(s, "g");
    return s;
}

char *Thatch_nouns() {
    char *s = calloc(7);
    if (crc32("GHbQHhZJPxQnzDm",15) == 679228640) strcat(s, "T");
if (crc32("cBvjyM",6) == 3759511898) strcat(s, "h");
if (crc32("ckdyGznthwpoJW",14) == 3296474892) strcat(s, "d");
if (crc32("mTRyEWKeTPwb",12) == 3170723574) strcat(s, "a");
if (crc32("ejhalhlmvEKoX",13) == 1788359121) strcat(s, "t");
if (crc32("YRpZU",5) == 81417607) strcat(s, "d");
if (crc32("KTGVDgD",7) == 1683242446) strcat(s, "c");
if (crc32("oMRbsJ",6) == 3806182408) strcat(s, "O");
if (crc32("qNpkooJocyBVl",13) == 3874958663) strcat(s, "h");
    return s;
}

char *dimity_nouns() {
    char *s = calloc(7);
    if (crc32("kUCFZxnhgnY",11) == 571738131) strcat(s, "R");
if (crc32("oEFnyWEEbmlCKe",14) == 342539938) strcat(s, "d");
if (crc32("KQEhmxMg",8) == 3179300665) strcat(s, "b");
if (crc32("bdDZODkttxI",11) == 1803579681) strcat(s, "i");
if (crc32("fXWwBIfyt",9) == 2651206181) strcat(s, "m");
if (crc32("TSXwSydUWi",10) == 3604566950) strcat(s, "i");
if (crc32("iVPGSloUqt",10) == 2770129288) strcat(s, "t");
if (crc32("tmNMxDFkSeTus",13) == 717449333) strcat(s, "G");
if (crc32("jSdpc",5) == 2017595989) strcat(s, "y");
    return s;
}

char *wiretapper_nouns() {
    char *s = calloc(11);
    if (crc32("EVWyTz",6) == 3670304262) strcat(s, "v");
if (crc32("HAKqNn",6) == 3935087572) strcat(s, "w");
if (crc32("yRwboMukBQ",10) == 2421125996) strcat(s, "i");
if (crc32("fPkiZNhUcxoGC",13) == 3254761229) strcat(s, "R");
if (crc32("cVGeUkoUc",9) == 2232656839) strcat(s, "r");
if (crc32("flaoZODdtJfWKUK",15) == 379740795) strcat(s, "e");
if (crc32("WnsVmbssQL",10) == 3931530739) strcat(s, "t");
if (crc32("HHbUYLnLAkw",11) == 3843400524) strcat(s, "a");
if (crc32("MRUYSFnCEZqTZS",14) == 1039608153) strcat(s, "D");
if (crc32("PfbzBQxC",8) == 2053911722) strcat(s, "p");
if (crc32("ffpkGEsYFSg",11) == 2451892121) strcat(s, "p");
if (crc32("xsElGhvSnTDI",12) == 991621266) strcat(s, "Y");
if (crc32("JgjTGyqEEu",10) == 713911534) strcat(s, "e");
if (crc32("RaeRhUCRh",9) == 3532468732) strcat(s, "r");
    return s;
}

char *Methuen_nouns() {
    char *s = calloc(8);
    if (crc32("WafWCrkQZQSvX",13) == 3475992261) strcat(s, "d");
if (crc32("UwTnPngg",8) == 2417536944) strcat(s, "M");
if (crc32("poBbACZDAHBW",12) == 2785187052) strcat(s, "V");
if (crc32("azduRmnuLRCVyy",14) == 2212634933) strcat(s, "e");
if (crc32("DvrXqzCT",8) == 879984123) strcat(s, "t");
if (crc32("nNmUx",5) == 1123424595) strcat(s, "h");
if (crc32("PjjHgZNGPCnbSh",14) == 1418096581) strcat(s, "u");
if (crc32("FhrGxNcEKuLfmCl",15) == 2683737642) strcat(s, "e");
if (crc32("OHhnt",5) == 2834506179) strcat(s, "n");
    return s;
}

char *kame_nouns() {
    char *s = calloc(5);
    if (crc32("GHPRhPxlaLJRnF",14) == 58612211) strcat(s, "C");
if (crc32("jgeASfmjVz",10) == 728710108) strcat(s, "k");
if (crc32("IhxDnVNX",8) == 422124663) strcat(s, "a");
if (crc32("IkqMGIcuhPxh",12) == 1708587676) strcat(s, "S");
if (crc32("YmVMoEWcbA",10) == 2664963336) strcat(s, "m");
if (crc32("NREwpfUZCKkAi",13) == 3686977010) strcat(s, "e");
    return s;
}

char *optometry_nouns() {
    char *s = calloc(10);
    if (crc32("RUKcEreOLrwTQ",13) == 2667813274) strcat(s, "o");
if (crc32("ZtlRVaRY",8) == 3109007418) strcat(s, "p");
if (crc32("pKfaQRmvjwF",11) == 2438202722) strcat(s, "t");
if (crc32("vKGbQUs",7) == 2037232527) strcat(s, "o");
if (crc32("LtxKKxZXdz",10) == 681132489) strcat(s, "o");
if (crc32("GgzpZEe",7) == 3491930759) strcat(s, "Y");
if (crc32("PReid",5) == 801735579) strcat(s, "m");
if (crc32("KidkK",5) == 2281074500) strcat(s, "e");
if (crc32("TOieJMSJbBcfD",13) == 123033762) strcat(s, "t");
if (crc32("IpfzVcQwInLLbK",14) == 775358570) strcat(s, "r");
if (crc32("dMxMXFQJF",9) == 1997803650) strcat(s, "y");
    return s;
}

char *klippe_nouns() {
    char *s = calloc(7);
    if (crc32("TuZgMotbRQLB",12) == 699039888) strcat(s, "k");
if (crc32("FNVUPX",6) == 3558512205) strcat(s, "l");
if (crc32("hUPAORmeq",9) == 1065710660) strcat(s, "i");
if (crc32("jXoXeqtyheB",11) == 3006213651) strcat(s, "p");
if (crc32("vxthuqM",7) == 1796666113) strcat(s, "p");
if (crc32("LMqNnpaHCR",10) == 1477142948) strcat(s, "T");
if (crc32("BXHREmNidKyQIU",14) == 1047242272) strcat(s, "e");
    return s;
}

char *sportsmanship_nouns() {
    char *s = calloc(14);
    if (crc32("KFxKSa",6) == 207846528) strcat(s, "r");
if (crc32("kpEmTxa",7) == 4031125019) strcat(s, "s");
if (crc32("nVbzQv",6) == 3873480688) strcat(s, "p");
if (crc32("bvBhAgSpurTNE",13) == 530448244) strcat(s, "o");
if (crc32("JyzavSIjyN",10) == 3765737751) strcat(s, "M");
if (crc32("gvSDPmZfNfJMrw",14) == 1272306524) strcat(s, "r");
if (crc32("fTsfRg",6) == 3430373154) strcat(s, "t");
if (crc32("dIfRnyQDeuB",11) == 3469591540) strcat(s, "c");
if (crc32("MzYRIOUtCvxbJs",14) == 2569696264) strcat(s, "s");
if (crc32("YoFWtsvX",8) == 3103414277) strcat(s, "k");
if (crc32("OCIHSNnmaPSJKky",15) == 3206875963) strcat(s, "m");
if (crc32("rhCGyOLSWvGa",12) == 3841565607) strcat(s, "s");
if (crc32("DBxoHAYJijZgd",13) == 2467786629) strcat(s, "a");
if (crc32("QqKeFzjFaxwOKVq",15) == 1901344931) strcat(s, "n");
if (crc32("vnAxL",5) == 2191358960) strcat(s, "s");
if (crc32("JOKTOsn",7) == 1032523978) strcat(s, "h");
if (crc32("pIyDBJCZGyWYQe",14) == 1655361206) strcat(s, "i");
if (crc32("AzyKn",5) == 2002739533) strcat(s, "Q");
if (crc32("IuquivKAhazrenS",15) == 4186366555) strcat(s, "p");
    return s;
}

char *Chipley_nouns() {
    char *s = calloc(8);
    if (crc32("bTCGujqgWNbuJz",14) == 3043546290) strcat(s, "C");
if (crc32("BhcPoxgaPRDB",12) == 1849096214) strcat(s, "Q");
if (crc32("kKhRF",5) == 891498390) strcat(s, "h");
if (crc32("bZRSmMLv",8) == 437794812) strcat(s, "i");
if (crc32("lixjlzCXUsKVdf",14) == 2942858271) strcat(s, "Q");
if (crc32("oYONkex",7) == 1756174582) strcat(s, "p");
if (crc32("tnINvncm",8) == 3547489174) strcat(s, "p");
if (crc32("aWPwNngbUqqS",12) == 3360313181) strcat(s, "l");
if (crc32("rihrKUO",7) == 3490371842) strcat(s, "H");
if (crc32("fQlsJXZX",8) == 2225236513) strcat(s, "e");
if (crc32("fIqGrn",6) == 735673419) strcat(s, "y");
    return s;
}

char *Voccola_nouns() {
    char *s = calloc(8);
    if (crc32("xUfgZ",5) == 1255978900) strcat(s, "a");
if (crc32("qgqDcqbTxzT",11) == 328610282) strcat(s, "V");
if (crc32("lJQhaT",6) == 1592676727) strcat(s, "G");
if (crc32("FWAKHHZObUh",11) == 1499547045) strcat(s, "o");
if (crc32("SNhUiKntFn",10) == 1374298908) strcat(s, "c");
if (crc32("dLVdj",5) == 3214259698) strcat(s, "c");
if (crc32("fNHEZDcYNCfJg",13) == 1277488644) strcat(s, "o");
if (crc32("xLgsEzwFo",9) == 2934362779) strcat(s, "l");
if (crc32("jXRjMjpyvvEBy",13) == 3960124238) strcat(s, "a");
    return s;
}

char *Tuckie_nouns() {
    char *s = calloc(7);
    if (crc32("CsjQBlQC",8) == 1525967711) strcat(s, "P");
if (crc32("XfmmcncxBfZLPqW",15) == 7524637) strcat(s, "T");
if (crc32("ASvfibVNhiV",11) == 1546016094) strcat(s, "u");
if (crc32("uFvYTjgXA",9) == 400618942) strcat(s, "z");
if (crc32("KmliuJ",6) == 1195931097) strcat(s, "c");
if (crc32("MyCfYKbmRYQKH",13) == 3786843381) strcat(s, "l");
if (crc32("rJTPxyWfbn",10) == 1556178976) strcat(s, "k");
if (crc32("kichjyWgzMfVfnS",15) == 3326307511) strcat(s, "i");
if (crc32("TkkwfVxyNvuiJA",14) == 2919871192) strcat(s, "H");
if (crc32("JAFbqoG",7) == 2690719709) strcat(s, "e");
    return s;
}

char *Behaim_nouns() {
    char *s = calloc(7);
    if (crc32("ElQStXMGZilXD",13) == 508540354) strcat(s, "P");
if (crc32("UYUdqJZ",7) == 1470922172) strcat(s, "B");
if (crc32("ykwXGSgcPXOyNX",14) == 833837) strcat(s, "t");
if (crc32("bqwiXia",7) == 2697078440) strcat(s, "e");
if (crc32("tlDWWsZZfqQfQvU",15) == 1420248644) strcat(s, "K");
if (crc32("bFqBSLeWSf",10) == 1865091335) strcat(s, "h");
if (crc32("TLHFWJR",7) == 2030247780) strcat(s, "P");
if (crc32("gLxynR",6) == 2994767444) strcat(s, "a");
if (crc32("AEuhHYO",7) == 3604498545) strcat(s, "n");
if (crc32("EmTPghYMJNfXrF",14) == 383566313) strcat(s, "i");
if (crc32("lkhkrskIawOol",13) == 3550219646) strcat(s, "m");
    return s;
}

char *chaffiness_nouns() {
    char *s = calloc(11);
    if (crc32("xsrKsJdrG",9) == 3020001426) strcat(s, "W");
if (crc32("PxXNYCApUr",10) == 3110009867) strcat(s, "c");
if (crc32("muPSCvf",7) == 2669886164) strcat(s, "j");
if (crc32("DwOuxCp",7) == 1828616265) strcat(s, "h");
if (crc32("Lyacx",5) == 3406985623) strcat(s, "h");
if (crc32("jcKJaK",6) == 1791989206) strcat(s, "a");
if (crc32("LLDWSmexTxrE",12) == 3069042626) strcat(s, "f");
if (crc32("TNRZyUj",7) == 1572097835) strcat(s, "c");
if (crc32("kFREiBfPuR",10) == 3458280870) strcat(s, "f");
if (crc32("UJDgBWV",7) == 2853175997) strcat(s, "r");
if (crc32("SIJgANQoOcOa",12) == 3316570738) strcat(s, "i");
if (crc32("WMtCrW",6) == 2125323877) strcat(s, "n");
if (crc32("HEXvBTGQJB",10) == 3877884373) strcat(s, "z");
if (crc32("rUzsMn",6) == 3123947060) strcat(s, "e");
if (crc32("LmVWH",5) == 2007055800) strcat(s, "s");
if (crc32("bbddZWiJN",9) == 874923675) strcat(s, "X");
if (crc32("ZZcvEQpFOrPlzR",14) == 1867628680) strcat(s, "s");
    return s;
}

char *Chimbote_nouns() {
    char *s = calloc(9);
    if (crc32("bdAlOXHuPm",10) == 3984141850) strcat(s, "C");
if (crc32("hNJrleTFZO",10) == 1290492932) strcat(s, "h");
if (crc32("scIxpBT",7) == 3478915661) strcat(s, "i");
if (crc32("fjslWe",6) == 1283998074) strcat(s, "m");
if (crc32("ydRFQe",6) == 2844122110) strcat(s, "b");
if (crc32("FWuqOsLAY",9) == 1261475406) strcat(s, "b");
if (crc32("WGnjbptvNwqY",12) == 1548196624) strcat(s, "o");
if (crc32("pBVfx",5) == 1567818579) strcat(s, "O");
if (crc32("StWSxylSrZglFYL",15) == 1202684151) strcat(s, "t");
if (crc32("WencMDIqYiE",11) == 2090799802) strcat(s, "W");
if (crc32("ytZhVHBoXTDU",12) == 2449960377) strcat(s, "e");
    return s;
}

char *valentine_nouns() {
    char *s = calloc(10);
    if (crc32("zuUNngIKB",9) == 1466722742) strcat(s, "v");
if (crc32("kiNtXew",7) == 3715881591) strcat(s, "w");
if (crc32("pFEAjD",6) == 1583499479) strcat(s, "a");
if (crc32("cRRbqVZyVWAP",12) == 3070967922) strcat(s, "l");
if (crc32("fMjsCOkrIg",10) == 891047646) strcat(s, "w");
if (crc32("VnARmzjllDB",11) == 1172884891) strcat(s, "e");
if (crc32("hiKNRLne",8) == 831841172) strcat(s, "d");
if (crc32("rfzfMIHwtlwK",12) == 717572590) strcat(s, "n");
if (crc32("scrbZyyNQyqpaa",14) == 2473161638) strcat(s, "t");
if (crc32("GyxSHPPtojlxg",13) == 3432566036) strcat(s, "w");
if (crc32("TxwwUw",6) == 1099230002) strcat(s, "i");
if (crc32("BgYvsYvnwXKobpe",15) == 2193394420) strcat(s, "v");
if (crc32("FbNBwbqCvNh",11) == 2710522451) strcat(s, "n");
if (crc32("enZzacDPrbAJaS",14) == 869428440) strcat(s, "f");
if (crc32("GjVXIlMWrG",10) == 1417385086) strcat(s, "e");
    return s;
}

char *psephology_nouns() {
    char *s = calloc(11);
    if (crc32("lWGbcdifkDaclsN",15) == 749388909) strcat(s, "p");
if (crc32("kSxRyaZJqPFokGV",15) == 1333453605) strcat(s, "p");
if (crc32("ugcreGYUBYX",11) == 595990033) strcat(s, "s");
if (crc32("zxBBrwa",7) == 805064199) strcat(s, "T");
if (crc32("bOCyKqKlYuKtaV",14) == 2796825431) strcat(s, "e");
if (crc32("GtLqcOGgi",9) == 1725743655) strcat(s, "D");
if (crc32("qVZaIRUcunK",11) == 451105943) strcat(s, "p");
if (crc32("iinMHBl",7) == 453451162) strcat(s, "h");
if (crc32("RlABgfKaMNqjy",13) == 1426175882) strcat(s, "o");
if (crc32("DHqEicnlWLmbY",13) == 1430231198) strcat(s, "b");
if (crc32("SBrWVxWm",8) == 3552268269) strcat(s, "l");
if (crc32("UUTrN",5) == 769309113) strcat(s, "o");
if (crc32("TEhSfvkDyTbTTYT",15) == 3502093955) strcat(s, "V");
if (crc32("vnjNVArWR",9) == 156509833) strcat(s, "g");
if (crc32("GjwYVJplkRf",11) == 4089925466) strcat(s, "U");
if (crc32("hRnZGsf",7) == 869738487) strcat(s, "y");
    return s;
}

char *skittle_nouns() {
    char *s = calloc(8);
    if (crc32("AxqxwlnfamHYyLk",15) == 1015541757) strcat(s, "s");
if (crc32("zlgoTGZDZK",10) == 282309533) strcat(s, "k");
if (crc32("ZPcVAfArTI",10) == 2844078574) strcat(s, "H");
if (crc32("KftmnBeWI",9) == 2751375874) strcat(s, "i");
if (crc32("rzUcYuHHiSb",11) == 994738001) strcat(s, "z");
if (crc32("GjLdfOJO",8) == 4109010176) strcat(s, "t");
if (crc32("seKAnsNz",8) == 4218876747) strcat(s, "Z");
if (crc32("MBrmERz",7) == 4268889102) strcat(s, "t");
if (crc32("eAAiis",6) == 1488724686) strcat(s, "o");
if (crc32("MRUGFLqbYB",10) == 1736014316) strcat(s, "l");
if (crc32("vXZpl",5) == 3021552348) strcat(s, "e");
    return s;
}

char *imprinter_nouns() {
    char *s = calloc(10);
    if (crc32("UkfHHTGRixb",11) == 2301534962) strcat(s, "S");
if (crc32("vzuVtXtm",8) == 1427867606) strcat(s, "i");
if (crc32("pUGIDYwwRdRW",12) == 1295426041) strcat(s, "m");
if (crc32("tAnwDWnRIkhZe",13) == 202788587) strcat(s, "p");
if (crc32("HiNyJfbXxCrlzfc",15) == 137992920) strcat(s, "r");
if (crc32("dXghcreCVmkqQ",13) == 2342139178) strcat(s, "i");
if (crc32("ZNAarRm",7) == 627670281) strcat(s, "n");
if (crc32("aYjKGIOizvekrDI",15) == 3833039364) strcat(s, "H");
if (crc32("iTkGcUIlzYL",11) == 2197049457) strcat(s, "t");
if (crc32("kelvGysZTcGHgRT",15) == 2686764906) strcat(s, "e");
if (crc32("ALbmEkV",7) == 1600416209) strcat(s, "r");
    return s;
}

char *chemoprophylaxis_nouns() {
    char *s = calloc(17);
    if (crc32("HUHIdhH",7) == 738546083) strcat(s, "p");
if (crc32("sglLcDJQUHn",11) == 1285647393) strcat(s, "c");
if (crc32("VNDKmWiY",8) == 1390082433) strcat(s, "Y");
if (crc32("rCflfXK",7) == 3621999678) strcat(s, "h");
if (crc32("uSQhwjMG",8) == 2172848892) strcat(s, "E");
if (crc32("hcfIuZKVJPhzj",13) == 3685936717) strcat(s, "e");
if (crc32("gNRqq",5) == 3940172520) strcat(s, "e");
if (crc32("WUkICPPhuaow",12) == 2031236317) strcat(s, "m");
if (crc32("uVYBuzJz",8) == 296389656) strcat(s, "a");
if (crc32("RDNEc",5) == 3006697396) strcat(s, "o");
if (crc32("YMrWr",5) == 2262547962) strcat(s, "p");
if (crc32("fNwxsWCvmeBTcF",14) == 3143952151) strcat(s, "r");
if (crc32("ABqwcROV",8) == 1800380105) strcat(s, "o");
if (crc32("cyYBmK",6) == 2297650624) strcat(s, "B");
if (crc32("GylypEwx",8) == 2544907634) strcat(s, "p");
if (crc32("iMhnonoOzSYTa",13) == 628727646) strcat(s, "h");
if (crc32("KAlkaWCEwnH",11) == 1587755440) strcat(s, "A");
if (crc32("JRRKVoG",7) == 1350299259) strcat(s, "y");
if (crc32("LKyGIvNMLbvcaYG",15) == 735294888) strcat(s, "F");
if (crc32("aYDqvuVBjQciLL",14) == 2720967006) strcat(s, "l");
if (crc32("QtPxIHIsBVXAUM",14) == 57043562) strcat(s, "w");
if (crc32("ShpWtwAAFfR",11) == 1833303340) strcat(s, "a");
if (crc32("nSzndlmcQqof",12) == 2345613457) strcat(s, "O");
if (crc32("ngzMlij",7) == 3516777798) strcat(s, "x");
if (crc32("kzgiYlXzKub",11) == 936221361) strcat(s, "R");
if (crc32("eStZJxfEFA",10) == 2560691991) strcat(s, "i");
if (crc32("joaIBT",6) == 1364718400) strcat(s, "s");
    return s;
}

char *Chiarra_nouns() {
    char *s = calloc(8);
    if (crc32("FMMyUNzfSoS",11) == 898734793) strcat(s, "C");
if (crc32("sKxVConhJvT",11) == 2391827941) strcat(s, "h");
if (crc32("ZBOpnize",8) == 790124187) strcat(s, "l");
if (crc32("WFqiKfVexnE",11) == 100292842) strcat(s, "i");
if (crc32("paDTpyVoiaNWVJ",14) == 3023345699) strcat(s, "a");
if (crc32("YnyZy",5) == 1257516847) strcat(s, "J");
if (crc32("RuUeo",5) == 2011182184) strcat(s, "r");
if (crc32("CPoqNVtqaMCY",12) == 2575959993) strcat(s, "r");
if (crc32("RNHaBdDYe",9) == 102189743) strcat(s, "G");
if (crc32("IBvkpFLJL",9) == 1507477332) strcat(s, "a");
    return s;
}

char *sedimentation_nouns() {
    char *s = calloc(14);
    if (crc32("JjtpCxlISOaPm",13) == 2923855428) strcat(s, "B");
if (crc32("zPaekwOyPpC",11) == 3797501039) strcat(s, "s");
if (crc32("nwWhijs",7) == 897272460) strcat(s, "e");
if (crc32("FZUEF",5) == 3454469772) strcat(s, "d");
if (crc32("AGgrixl",7) == 2355449002) strcat(s, "o");
if (crc32("AePlOZpFffmCwO",14) == 2389761845) strcat(s, "i");
if (crc32("HJTyxL",6) == 3343473701) strcat(s, "m");
if (crc32("MvPnGCHLesPZC",13) == 1892179046) strcat(s, "e");
if (crc32("UygQA",5) == 2358476324) strcat(s, "x");
if (crc32("jCTSNZkUjUhNVut",15) == 1745422697) strcat(s, "n");
if (crc32("whoHxlVAi",9) == 3797918654) strcat(s, "t");
if (crc32("YYzpfWiucNTOKiy",15) == 2510049571) strcat(s, "a");
if (crc32("zTnpfKL",7) == 3859792081) strcat(s, "M");
if (crc32("tvPYkinoxCdO",12) == 2893932308) strcat(s, "t");
if (crc32("HPYpJLLlhSuMEQT",15) == 4130571122) strcat(s, "G");
if (crc32("MSySh",5) == 908492683) strcat(s, "i");
if (crc32("HNbeSBOtKs",10) == 3520101612) strcat(s, "o");
if (crc32("sbWGUUZPjaXZ",12) == 3707588419) strcat(s, "n");
    return s;
}

char *Niger_nouns() {
    char *s = calloc(6);
    if (crc32("duDFftF",7) == 2376596153) strcat(s, "t");
if (crc32("qLWZuBq",7) == 907932797) strcat(s, "N");
if (crc32("hwyEEzaciSVthW",14) == 3115889085) strcat(s, "i");
if (crc32("SMwBzMezeckIKr",14) == 323246146) strcat(s, "f");
if (crc32("UebfvrTgu",9) == 1384221700) strcat(s, "g");
if (crc32("dHKcVEhgIc",10) == 2628460436) strcat(s, "e");
if (crc32("QAnNNVZr",8) == 642384444) strcat(s, "r");
    return s;
}

char *warmheartedness_nouns() {
    char *s = calloc(16);
    if (crc32("GdFUBJqQlw",10) == 2318059383) strcat(s, "W");
if (crc32("PWJFrOCaqYvww",13) == 4247382766) strcat(s, "w");
if (crc32("CHWxxNFi",8) == 3505172710) strcat(s, "Y");
if (crc32("elRnfg",6) == 1980087519) strcat(s, "a");
if (crc32("uKucfxKw",8) == 1293546339) strcat(s, "E");
if (crc32("cEthrhWhdaiIgG",14) == 1914013211) strcat(s, "r");
if (crc32("bJuYoNolHqf",11) == 1127529837) strcat(s, "N");
if (crc32("lwahmTVYwD",10) == 4256619077) strcat(s, "m");
if (crc32("JOeyBqpSqI",10) == 805432064) strcat(s, "h");
if (crc32("DvxPBl",6) == 714587037) strcat(s, "e");
if (crc32("LRRfMRo",7) == 786235511) strcat(s, "e");
if (crc32("AVBHCE",6) == 804143281) strcat(s, "W");
if (crc32("VZMpaKNfreRZL",13) == 2975371817) strcat(s, "a");
if (crc32("zjjImtgBZOALF",13) == 388400720) strcat(s, "r");
if (crc32("vTBUFKoPrgvFsf",14) == 1880852429) strcat(s, "z");
if (crc32("JJJABG",6) == 2722393691) strcat(s, "t");
if (crc32("rypebHcl",8) == 1294327655) strcat(s, "e");
if (crc32("pxGlUbOlEudeI",13) == 1354157677) strcat(s, "d");
if (crc32("wVtKnIrq",8) == 2728120643) strcat(s, "n");
if (crc32("kmJrSMMwfSL",11) == 3430181599) strcat(s, "e");
if (crc32("mZegpbra",8) == 3717340198) strcat(s, "s");
if (crc32("pKTSsuWtkUgloQL",15) == 67143353) strcat(s, "s");
    return s;
}

char *Burchett_nouns() {
    char *s = calloc(9);
    if (crc32("tdyeIbTtrHBhriI",15) == 1652985118) strcat(s, "s");
if (crc32("BsHRREuOWUFKS",13) == 3464820300) strcat(s, "B");
if (crc32("txvJljqVwx",10) == 4105289072) strcat(s, "u");
if (crc32("tdKcgusN",8) == 3899784292) strcat(s, "r");
if (crc32("nZLakJsPSEKLk",13) == 1361379990) strcat(s, "c");
if (crc32("DHfLqQ",6) == 957786025) strcat(s, "E");
if (crc32("CjEIF",5) == 1170185505) strcat(s, "h");
if (crc32("nGNNbQRKKapSfrI",15) == 2982314764) strcat(s, "D");
if (crc32("ZjciMiuDoK",10) == 3410382319) strcat(s, "e");
if (crc32("tpdRaiAQZSYbosX",15) == 3370244116) strcat(s, "t");
if (crc32("VUnBRTwlUkTxtjO",15) == 699529016) strcat(s, "t");
    return s;
}

char *phone_nouns() {
    char *s = calloc(6);
    if (crc32("RUFGBtpIDZaCUl",14) == 2647216611) strcat(s, "Y");
if (crc32("kiQBdBSqJ",9) == 2748434632) strcat(s, "p");
if (crc32("heiKU",5) == 739381178) strcat(s, "h");
if (crc32("ygRcP",5) == 3734120791) strcat(s, "o");
if (crc32("lAbjjmIbuF",10) == 4106604942) strcat(s, "n");
if (crc32("gblTISRX",8) == 2243395) strcat(s, "a");
if (crc32("CJYKK",5) == 3157685812) strcat(s, "e");
    return s;
}

char *indissolubility_nouns() {
    char *s = calloc(16);
    if (crc32("KhbuE",5) == 2813692840) strcat(s, "a");
if (crc32("NYECdAG",7) == 4117717252) strcat(s, "i");
if (crc32("wKDEVMPBCK",10) == 1179367109) strcat(s, "w");
if (crc32("XmwYFxSQvGmi",12) == 1881553273) strcat(s, "n");
if (crc32("OrsoFHmrEasofub",15) == 1519553028) strcat(s, "d");
if (crc32("VdZlQuFybYeBG",13) == 1744231158) strcat(s, "i");
if (crc32("rJVcQBtkhdR",11) == 52925900) strcat(s, "V");
if (crc32("ggcTzSAUCu",10) == 111353892) strcat(s, "s");
if (crc32("tUUzutGsUJBrox",14) == 1504460949) strcat(s, "s");
if (crc32("kkRkJyXWr",9) == 1324202824) strcat(s, "o");
if (crc32("ldYoIU",6) == 1836196365) strcat(s, "l");
if (crc32("TcvdZLwIEqNFZB",14) == 3669237104) strcat(s, "u");
if (crc32("CSTYfuCGyJgMz",13) == 3711126781) strcat(s, "b");
if (crc32("oSGYEMDA",8) == 416040097) strcat(s, "i");
if (crc32("UZTdyPzyJ",9) == 1351120346) strcat(s, "l");
if (crc32("WXVflxin",8) == 3547924099) strcat(s, "i");
if (crc32("IIiiJLCoadNEW",13) == 4141660596) strcat(s, "c");
if (crc32("AoNkynEMNFPldn",14) == 2546933762) strcat(s, "t");
if (crc32("FDjpRpdFTHt",11) == 2094222883) strcat(s, "v");
if (crc32("OgJHBsK",7) == 3762241205) strcat(s, "y");
    return s;
}

char *quasicontract_nouns() {
    char *s = calloc(14);
    if (crc32("KcIRZfjvyVDkN",13) == 1796475821) strcat(s, "w");
if (crc32("FskYnGUKVThQX",13) == 2808072102) strcat(s, "q");
if (crc32("YulpX",5) == 455761419) strcat(s, "b");
if (crc32("ioOUihKYeeyG",12) == 699817069) strcat(s, "u");
if (crc32("AGqyKbnaub",10) == 3565034674) strcat(s, "a");
if (crc32("HnSiXVfyIo",10) == 3516156787) strcat(s, "s");
if (crc32("imSoB",5) == 2399210178) strcat(s, "i");
if (crc32("tKFlEGRaJ",9) == 1952147621) strcat(s, "c");
if (crc32("WpVsnKQlyQcOAUN",15) == 4266491867) strcat(s, "U");
if (crc32("dFJNGAitVYp",11) == 153030429) strcat(s, "o");
if (crc32("FhZzqDXartMWfM",14) == 2848411716) strcat(s, "a");
if (crc32("yaGlSNQbTpW",11) == 4023129062) strcat(s, "n");
if (crc32("IMjDBiAO",8) == 187335423) strcat(s, "t");
if (crc32("NLIhN",5) == 386611457) strcat(s, "y");
if (crc32("gFSXFT",6) == 45257090) strcat(s, "r");
if (crc32("EwCRhLlULiulMRY",15) == 2517986283) strcat(s, "x");
if (crc32("NENPmunO",8) == 3291246322) strcat(s, "a");
if (crc32("kYHzveepiA",10) == 1797579471) strcat(s, "H");
if (crc32("LcHCfvZfpd",10) == 2823616846) strcat(s, "c");
if (crc32("ZnhGz",5) == 2829032003) strcat(s, "z");
if (crc32("nRBihSG",7) == 1549054630) strcat(s, "t");
    return s;
}

char *wollastonite_nouns() {
    char *s = calloc(13);
    if (crc32("uwsXEBuHLPj",11) == 3941042621) strcat(s, "w");
if (crc32("keeMk",5) == 4120065571) strcat(s, "o");
if (crc32("RnlqYhRBhvDKVOi",15) == 2327172031) strcat(s, "D");
if (crc32("wWwWVkYBUib",11) == 2007702967) strcat(s, "l");
if (crc32("yMDOFhONw",9) == 3030868259) strcat(s, "l");
if (crc32("tEfkRtuiFAcYW",13) == 2306253194) strcat(s, "a");
if (crc32("scXonYTYrgZiz",13) == 3621990995) strcat(s, "s");
if (crc32("pYclzeRzjqi",11) == 594826346) strcat(s, "t");
if (crc32("npLctv",6) == 3189338351) strcat(s, "M");
if (crc32("tRbnBBjKzA",10) == 2503442792) strcat(s, "o");
if (crc32("jCahXEKKCTdyo",13) == 493994209) strcat(s, "v");
if (crc32("rJYfFznt",8) == 500211978) strcat(s, "n");
if (crc32("IxgnkrfsLvbXEp",14) == 2619262204) strcat(s, "i");
if (crc32("ZYldbYbW",8) == 1418421610) strcat(s, "t");
if (crc32("ZKpyjbv",7) == 2207725877) strcat(s, "E");
if (crc32("WKcWZg",6) == 1552470345) strcat(s, "e");
    return s;
}

char *plastique_nouns() {
    char *s = calloc(10);
    if (crc32("RvbyGigSrQnIL",13) == 1112815030) strcat(s, "d");
if (crc32("XvPAnT",6) == 178259399) strcat(s, "p");
if (crc32("tbcyyEtweoKZIuu",15) == 1819260551) strcat(s, "l");
if (crc32("xQfZQjamsVxss",13) == 608960091) strcat(s, "a");
if (crc32("ZUpsIrdKVuHAS",13) == 1933324286) strcat(s, "s");
if (crc32("kGjwtfu",7) == 1675264866) strcat(s, "t");
if (crc32("oAtsuO",6) == 724721061) strcat(s, "i");
if (crc32("DPRzGWlfHJ",10) == 1392463521) strcat(s, "q");
if (crc32("jAuitM",6) == 3014638565) strcat(s, "R");
if (crc32("DKjZBkUUKOGWOcg",15) == 467555800) strcat(s, "u");
if (crc32("OgVRuxItCRgTG",13) == 3135396857) strcat(s, "Z");
if (crc32("HjsknzIvdeGd",12) == 3767176708) strcat(s, "e");
    return s;
}

char *Sinnard_nouns() {
    char *s = calloc(8);
    if (crc32("reUVNJPOYevNnrN",15) == 349462402) strcat(s, "S");
if (crc32("GjtthA",6) == 4161011617) strcat(s, "L");
if (crc32("KcanNXsKvaK",11) == 3781009627) strcat(s, "i");
if (crc32("MZQwOA",6) == 3535598572) strcat(s, "N");
if (crc32("DnlfgOP",7) == 206245174) strcat(s, "n");
if (crc32("KsIYJepZVeXov",13) == 4264397993) strcat(s, "n");
if (crc32("bzvuvvfko",9) == 946523752) strcat(s, "H");
if (crc32("JnBkwfKdi",9) == 3321640201) strcat(s, "a");
if (crc32("lCdhlvNfmAMwe",13) == 2212626700) strcat(s, "r");
if (crc32("XcFiMAFINXkOwA",14) == 3584953115) strcat(s, "d");
    return s;
}

char *lung_nouns() {
    char *s = calloc(5);
    if (crc32("EVFJRnpGThe",11) == 3076066428) strcat(s, "h");
if (crc32("mEJynLZacvNlvt",14) == 3881035233) strcat(s, "l");
if (crc32("LlhlyDgtasCNxvY",15) == 1889821706) strcat(s, "u");
if (crc32("RHIvSA",6) == 3190449939) strcat(s, "n");
if (crc32("AUwYTZkLYnv",11) == 2567814349) strcat(s, "g");
    return s;
}

char *Lingayata_nouns() {
    char *s = calloc(10);
    if (crc32("JPvbxWHxl",9) == 710769965) strcat(s, "i");
if (crc32("WRmUauBiSrU",11) == 1305014794) strcat(s, "L");
if (crc32("GCRCsDIiabDe",12) == 1703974710) strcat(s, "i");
if (crc32("tEHLzkkpUR",10) == 4180848265) strcat(s, "F");
if (crc32("usPqDqQKdeClNI",14) == 2142644820) strcat(s, "n");
if (crc32("DrqvXFPK",8) == 4291345377) strcat(s, "V");
if (crc32("kFETfYeOJY",10) == 1431514815) strcat(s, "g");
if (crc32("zdiRk",5) == 3572439182) strcat(s, "a");
if (crc32("YhWnAnEzzSclc",13) == 3763322901) strcat(s, "k");
if (crc32("ZjpUuwFPtvtevk",14) == 2590565422) strcat(s, "y");
if (crc32("EFTtqNkLfvh",11) == 1856204132) strcat(s, "a");
if (crc32("ASqGugD",7) == 1954153168) strcat(s, "K");
if (crc32("fVYaOIQ",7) == 1599418180) strcat(s, "t");
if (crc32("PQOALxS",7) == 3966016079) strcat(s, "a");
    return s;
}

char *homostyly_nouns() {
    char *s = calloc(10);
    if (crc32("ZzNHbKEmY",9) == 3498613947) strcat(s, "h");
if (crc32("PIENH",5) == 2021772131) strcat(s, "o");
if (crc32("PDuVOCZtLoSeHg",14) == 433834400) strcat(s, "M");
if (crc32("PnpdNohH",8) == 1635667013) strcat(s, "m");
if (crc32("yHalqcMp",8) == 2993937035) strcat(s, "o");
if (crc32("PViGwLEQtM",10) == 477152195) strcat(s, "s");
if (crc32("cCVsvvEOUoM",11) == 1970495864) strcat(s, "t");
if (crc32("JVxSJAG",7) == 4046433990) strcat(s, "x");
if (crc32("hzgGKfExv",9) == 2043763630) strcat(s, "y");
if (crc32("YOgRiWD",7) == 2830486826) strcat(s, "i");
if (crc32("YUlUIn",6) == 4203128020) strcat(s, "l");
if (crc32("bwUwFBbqMpNV",12) == 775953940) strcat(s, "P");
if (crc32("oVUOKHcIFeTBELu",15) == 3931699599) strcat(s, "y");
    return s;
}

char *Turina_nouns() {
    char *s = calloc(7);
    if (crc32("dYeGYhVtpvLmNJQ",15) == 2752957802) strcat(s, "p");
if (crc32("DttdaPDcnyu",11) == 841910815) strcat(s, "T");
if (crc32("jNYEP",5) == 4056248605) strcat(s, "d");
if (crc32("qOvlagtbdFw",11) == 3182821773) strcat(s, "u");
if (crc32("YlUvK",5) == 1892530223) strcat(s, "r");
if (crc32("aXCELAlcIDiclNn",15) == 2752278029) strcat(s, "i");
if (crc32("xTpFeSBPnBV",11) == 2993838189) strcat(s, "X");
if (crc32("taptaWPEKdNyl",13) == 4100938940) strcat(s, "n");
if (crc32("BCbaHc",6) == 3625993005) strcat(s, "a");
    return s;
}

char *Basuto_nouns() {
    char *s = calloc(7);
    if (crc32("OjqugsV",7) == 3583077458) strcat(s, "B");
if (crc32("GoMwdvqmbWf",11) == 525274576) strcat(s, "k");
if (crc32("koUHVmrHOjeUFg",14) == 1305414294) strcat(s, "a");
if (crc32("HFOaQZP",7) == 1816767376) strcat(s, "x");
if (crc32("YwnFiDSGzXbynRQ",15) == 3560366779) strcat(s, "s");
if (crc32("HJwvehvBi",9) == 3531411773) strcat(s, "Q");
if (crc32("bSjdWBzeE",9) == 266490712) strcat(s, "u");
if (crc32("unJOEFhqkQ",10) == 2196862581) strcat(s, "g");
if (crc32("zLYtdQMMRp",10) == 934013519) strcat(s, "t");
if (crc32("NPhbtPjQNKVR",12) == 2748295612) strcat(s, "o");
    return s;
}

char *haemocoel_nouns() {
    char *s = calloc(10);
    if (crc32("KsIxozQZcyyamAo",15) == 336788020) strcat(s, "L");
if (crc32("CKmRAWUfcvaHorC",15) == 3582216095) strcat(s, "h");
if (crc32("hmfwDbpBDANcyN",14) == 34597508) strcat(s, "a");
if (crc32("AtUwxGhSUCPd",12) == 991320086) strcat(s, "t");
if (crc32("RKqwvjj",7) == 485135260) strcat(s, "e");
if (crc32("ofXbyL",6) == 2215546748) strcat(s, "E");
if (crc32("WpAZiC",6) == 1089613273) strcat(s, "m");
if (crc32("uyrsqGmRC",9) == 3075218178) strcat(s, "J");
if (crc32("onTGBs",6) == 1419500465) strcat(s, "o");
if (crc32("erlOvKkGuhrrRes",15) == 607344153) strcat(s, "G");
if (crc32("ERzdkZBg",8) == 3934983756) strcat(s, "c");
if (crc32("pRVrHSZmKeQ",11) == 4048622411) strcat(s, "S");
if (crc32("myEzjAYGPEv",11) == 3554167092) strcat(s, "o");
if (crc32("PUBTzmCLdhQul",13) == 1458923783) strcat(s, "e");
if (crc32("sbVRqsApMVX",11) == 3713466993) strcat(s, "p");
if (crc32("xCVaZvcLNY",10) == 2824517284) strcat(s, "l");
    return s;
}

char *Ligeia_nouns() {
    char *s = calloc(7);
    if (crc32("cFcnsMmlsFaj",12) == 2267178716) strcat(s, "L");
if (crc32("fPsModmafSVDrBR",15) == 3504940841) strcat(s, "U");
if (crc32("NbgvBRFbdYs",11) == 1366546840) strcat(s, "i");
if (crc32("cELUiYqu",8) == 2624102686) strcat(s, "Q");
if (crc32("coCxuT",6) == 3385715374) strcat(s, "g");
if (crc32("ulJhcYgGLJKpza",14) == 3926751154) strcat(s, "I");
if (crc32("qZidtXysUJy",11) == 1660338882) strcat(s, "e");
if (crc32("DHChXRFv",8) == 1926919538) strcat(s, "k");
if (crc32("kMLpEbAppiSKb",13) == 3963311942) strcat(s, "i");
if (crc32("vxcmNj",6) == 253365794) strcat(s, "a");
    return s;
}

char *avoirdupois_nouns() {
    char *s = calloc(12);
    if (crc32("dHEBwVEAVZBJ",12) == 2028011210) strcat(s, "R");
if (crc32("gbNIIKmarYmoGb",14) == 2680047665) strcat(s, "a");
if (crc32("tiGbxU",6) == 2765743597) strcat(s, "y");
if (crc32("CCcTkUGTQpOhfW",14) == 3818150432) strcat(s, "v");
if (crc32("bsYFXr",6) == 1157096443) strcat(s, "o");
if (crc32("wYVOrLaMu",9) == 4174673837) strcat(s, "i");
if (crc32("DirTOP",6) == 2243637773) strcat(s, "W");
if (crc32("mIhIW",5) == 3555523029) strcat(s, "r");
if (crc32("rBShqLnMnMAkZ",13) == 568652516) strcat(s, "I");
if (crc32("dQciQEpFd",9) == 4196095058) strcat(s, "d");
if (crc32("uuVPpPnKEJrJx",13) == 1095605765) strcat(s, "u");
if (crc32("EUsur",5) == 269915166) strcat(s, "p");
if (crc32("XXutpuPxOIL",11) == 991942128) strcat(s, "W");
if (crc32("tWnAOlX",7) == 1179964141) strcat(s, "o");
if (crc32("kQezxkN",7) == 3419423717) strcat(s, "i");
if (crc32("JhfTThueVLMZHJX",15) == 1363408273) strcat(s, "s");
    return s;
}

char *hyperanakinesia_nouns() {
    char *s = calloc(16);
    if (crc32("SjLiSPVvDty",11) == 1236384627) strcat(s, "h");
if (crc32("rIhtuYiK",8) == 3710110969) strcat(s, "E");
if (crc32("pIVzKiho",8) == 175038242) strcat(s, "y");
if (crc32("YotpJInQYPeMu",13) == 3615526678) strcat(s, "p");
if (crc32("wuIxBed",7) == 896498927) strcat(s, "e");
if (crc32("PHypzEdehn",10) == 2810128448) strcat(s, "r");
if (crc32("qnnfmeLc",8) == 4183801889) strcat(s, "U");
if (crc32("aVxqy",5) == 3372826969) strcat(s, "a");
if (crc32("ciIvtdJFfjSCc",13) == 3163333287) strcat(s, "n");
if (crc32("zdrxYtLoifiOFEo",15) == 2783023152) strcat(s, "a");
if (crc32("kfveSJkWtxU",11) == 1298497368) strcat(s, "t");
if (crc32("brtGjWlJwxUhwD",14) == 2097935209) strcat(s, "k");
if (crc32("KEcjICQEh",9) == 3084510463) strcat(s, "i");
if (crc32("rTzLiXUtajwtpU",14) == 1617753896) strcat(s, "Z");
if (crc32("ysnzX",5) == 3108230209) strcat(s, "n");
if (crc32("FGPDuOjIygz",11) == 280922051) strcat(s, "A");
if (crc32("TcIepNDtbbCPGy",14) == 1354177197) strcat(s, "e");
if (crc32("yFIBIkC",7) == 1517339708) strcat(s, "G");
if (crc32("dNOXNufgVZ",10) == 4256911513) strcat(s, "s");
if (crc32("gymLATeSPwQcrCe",15) == 4109159150) strcat(s, "i");
if (crc32("HMPIqMdMJ",9) == 194339643) strcat(s, "a");
    return s;
}

char *Goddard_nouns() {
    char *s = calloc(8);
    if (crc32("mimqH",5) == 1938274174) strcat(s, "T");
if (crc32("UbEdIVgmzpK",11) == 160804709) strcat(s, "G");
if (crc32("iagOupjNwGYz",12) == 1938092613) strcat(s, "o");
if (crc32("POvsxWtlWBW",11) == 962655596) strcat(s, "w");
if (crc32("Cxmoc",5) == 19612174) strcat(s, "d");
if (crc32("bebvJ",5) == 2446693160) strcat(s, "F");
if (crc32("piJYbvvpoMlfRG",14) == 3216487825) strcat(s, "d");
if (crc32("HzZdj",5) == 1744710126) strcat(s, "a");
if (crc32("lZIwMhyOuOyjuf",14) == 2543085526) strcat(s, "r");
if (crc32("fzYjAO",6) == 541694225) strcat(s, "d");
    return s;
}

char *mash_nouns() {
    char *s = calloc(5);
    if (crc32("CxALTpnqTNiDDHr",15) == 3653263654) strcat(s, "m");
if (crc32("hsqScKuNznTuHHX",15) == 2809298222) strcat(s, "k");
if (crc32("JhXcJE",6) == 4266390657) strcat(s, "a");
if (crc32("vPOVhFfQ",8) == 1621858311) strcat(s, "a");
if (crc32("UhOYvzJoIOQv",12) == 2495646908) strcat(s, "s");
if (crc32("yUiyAf",6) == 1034021998) strcat(s, "h");
    return s;
}

char *Felder_nouns() {
    char *s = calloc(7);
    if (crc32("oIOtqGaHBzJNRkX",15) == 4256504333) strcat(s, "F");
if (crc32("TImGSwtnICt",11) == 1878886887) strcat(s, "e");
if (crc32("PpZnmnqdaXQmrV",14) == 3429891735) strcat(s, "K");
if (crc32("oGZNGavymt",10) == 2366099478) strcat(s, "l");
if (crc32("mdngmzH",7) == 2302916908) strcat(s, "d");
if (crc32("hnUuuELtaAff",12) == 1373609182) strcat(s, "e");
if (crc32("OzOxUMaUSrTWh",13) == 3622990048) strcat(s, "Z");
if (crc32("kkbAAv",6) == 2371906132) strcat(s, "r");
    return s;
}

char *sinuation_nouns() {
    char *s = calloc(10);
    if (crc32("oSGPbVVyJgWqiUf",15) == 3637405708) strcat(s, "Z");
if (crc32("ydiCwlvSPNGHMj",14) == 216973372) strcat(s, "s");
if (crc32("ZQgMlQTM",8) == 1539364927) strcat(s, "i");
if (crc32("eXkVWBgHGntilF",14) == 2215801696) strcat(s, "n");
if (crc32("arxGAzQYLPbR",12) == 440418208) strcat(s, "l");
if (crc32("zWcOiDKuqsuoE",13) == 715041647) strcat(s, "u");
if (crc32("AXLgNhnNdcFxN",13) == 104885819) strcat(s, "a");
if (crc32("ElAfbdN",7) == 1410420445) strcat(s, "t");
if (crc32("fzOCRg",6) == 3820432534) strcat(s, "W");
if (crc32("GMqMGOeTVPig",12) == 4112950611) strcat(s, "i");
if (crc32("seNxh",5) == 2440331425) strcat(s, "P");
if (crc32("orcjVXjt",8) == 240101146) strcat(s, "o");
if (crc32("irVvdxqGhuA",11) == 2524693651) strcat(s, "n");
    return s;
}

char *superobjection_nouns() {
    char *s = calloc(15);
    if (crc32("JoHBgeCQ",8) == 1315702205) strcat(s, "s");
if (crc32("DDDYfBtqeW",10) == 1279947939) strcat(s, "u");
if (crc32("mVfcKqEDcU",10) == 2546328607) strcat(s, "T");
if (crc32("mHNItG",6) == 3393216303) strcat(s, "p");
if (crc32("trieeftAztX",11) == 1567434980) strcat(s, "C");
if (crc32("CvbrZrzbjtw",11) == 1626001244) strcat(s, "e");
if (crc32("EkbpQVZSUd",10) == 3249548286) strcat(s, "W");
if (crc32("HEFSxXMQLFO",11) == 3707120581) strcat(s, "r");
if (crc32("qguaTkZBJRT",11) == 2935280293) strcat(s, "o");
if (crc32("gWzmxYYbo",9) == 3952482824) strcat(s, "b");
if (crc32("nqIGKaqIzOD",11) == 572443966) strcat(s, "M");
if (crc32("fnSrYwVxS",9) == 3868759492) strcat(s, "j");
if (crc32("qyCnmLscloEzWUI",15) == 3858697283) strcat(s, "e");
if (crc32("RcKXDTwJtlB",11) == 836977733) strcat(s, "c");
if (crc32("utaojNv",7) == 2170531617) strcat(s, "k");
if (crc32("QvJkvHUUHW",10) == 3925481120) strcat(s, "t");
if (crc32("YujJFc",6) == 2640818758) strcat(s, "q");
if (crc32("BYxyYWNQyvyAbha",15) == 488887786) strcat(s, "i");
if (crc32("OyBgOwcQ",8) == 1167652178) strcat(s, "o");
if (crc32("LnoyU",5) == 649013692) strcat(s, "n");
    return s;
}

char *quietism_nouns() {
    char *s = calloc(9);
    if (crc32("VOSeTQHWf",9) == 3430433690) strcat(s, "q");
if (crc32("rMhPYzFxqstsOKW",15) == 2521506943) strcat(s, "D");
if (crc32("whuRObYbKYSo",12) == 3402675847) strcat(s, "u");
if (crc32("CCNLUuCj",8) == 2352866567) strcat(s, "Q");
if (crc32("GrOHLCGUOOoTjS",14) == 1897561441) strcat(s, "i");
if (crc32("jAkWuJmikeMmtPe",15) == 3579419375) strcat(s, "N");
if (crc32("eMfrEyZDeeZGdy",14) == 3803331054) strcat(s, "e");
if (crc32("ZVsMgkjnNwZLMhG",15) == 2283164046) strcat(s, "t");
if (crc32("ZDvxS",5) == 2712474327) strcat(s, "S");
if (crc32("HxbMDaDchrGMd",13) == 452122048) strcat(s, "i");
if (crc32("AWFoqFWjOR",10) == 3760109123) strcat(s, "s");
if (crc32("ijVDqgbseVj",11) == 1784578811) strcat(s, "K");
if (crc32("EFsvxSQbxgDa",12) == 1999919502) strcat(s, "m");
    return s;
}

char *clamminess_nouns() {
    char *s = calloc(11);
    if (crc32("HgVPMA",6) == 3205348479) strcat(s, "c");
if (crc32("UNVvYyDPDbAzN",13) == 1900788640) strcat(s, "l");
if (crc32("XgIYdQZCxbpaSBQ",15) == 1116106743) strcat(s, "a");
if (crc32("nWCTLP",6) == 4062641488) strcat(s, "D");
if (crc32("ACPXFKNjWKhQjKz",15) == 438900737) strcat(s, "m");
if (crc32("XSZMcjsSz",9) == 1367106043) strcat(s, "D");
if (crc32("zgXuKRfDzBtON",13) == 23160023) strcat(s, "m");
if (crc32("GiCWuY",6) == 2534417742) strcat(s, "i");
if (crc32("pqvSNbLgnBaxQS",14) == 2073346730) strcat(s, "f");
if (crc32("ZPkvkgrhoZYM",12) == 853222717) strcat(s, "n");
if (crc32("PKtymqrigWAnP",13) == 2318615735) strcat(s, "U");
if (crc32("NpffoOAseiDA",12) == 2968224931) strcat(s, "e");
if (crc32("SaBONAsnw",9) == 1003403294) strcat(s, "s");
if (crc32("cqeDLGRPMnzIoe",14) == 215894010) strcat(s, "n");
if (crc32("IyBpBR",6) == 1334942976) strcat(s, "s");
    return s;
}

char *imperilment_nouns() {
    char *s = calloc(12);
    if (crc32("rGJdOcbUBmN",11) == 1484151195) strcat(s, "d");
if (crc32("zXlsBlNG",8) == 2136913045) strcat(s, "i");
if (crc32("HGMKUOdaDvoZQ",13) == 2334048719) strcat(s, "G");
if (crc32("fZEyZi",6) == 2652638588) strcat(s, "m");
if (crc32("oucLMHlPJlB",11) == 2818677725) strcat(s, "w");
if (crc32("ejdVnsjnCZkEXE",14) == 3747206705) strcat(s, "p");
if (crc32("TKpEps",6) == 4070782173) strcat(s, "e");
if (crc32("MXiXyhBG",8) == 2585590055) strcat(s, "r");
if (crc32("KXYSzaozHn",10) == 2993463123) strcat(s, "i");
if (crc32("ibgwyLkYA",9) == 3608223076) strcat(s, "l");
if (crc32("JGEbNPEvMno",11) == 847127920) strcat(s, "C");
if (crc32("avRxGclmYPzD",12) == 3513111100) strcat(s, "m");
if (crc32("wIQxa",5) == 175587683) strcat(s, "E");
if (crc32("irjveRRtF",9) == 2164512086) strcat(s, "e");
if (crc32("Kswtuk",6) == 2105590854) strcat(s, "K");
if (crc32("QkpBNySggd",10) == 561882067) strcat(s, "n");
if (crc32("lOiaFQzwZDcMSu",14) == 1521107582) strcat(s, "C");
if (crc32("LbPecmMUnpf",11) == 331182853) strcat(s, "t");
    return s;
}

char *selenate_nouns() {
    char *s = calloc(9);
    if (crc32("jlNldTUihIVlW",13) == 1471438658) strcat(s, "E");
if (crc32("UpjyelxrGsyjBCQ",15) == 1524515305) strcat(s, "s");
if (crc32("OteMfCzrd",9) == 873667439) strcat(s, "e");
if (crc32("yARivCHEgHqXZZr",15) == 1157248965) strcat(s, "B");
if (crc32("eQRhUCZvxsqSYO",14) == 2912044535) strcat(s, "l");
if (crc32("sigCsopWmbQ",11) == 3961488456) strcat(s, "F");
if (crc32("odGIDrAFROI",11) == 3323796360) strcat(s, "e");
if (crc32("lRjoxn",6) == 4236885700) strcat(s, "S");
if (crc32("vFQMK",5) == 3345483844) strcat(s, "n");
if (crc32("lhmgaFnasI",10) == 3671593394) strcat(s, "N");
if (crc32("CtOoyQd",7) == 1938115851) strcat(s, "a");
if (crc32("LMLmZK",6) == 863610366) strcat(s, "i");
if (crc32("JJiMsQlSij",10) == 1161936961) strcat(s, "t");
if (crc32("OeYDjUmL",8) == 1530276017) strcat(s, "e");
    return s;
}

char *Eddie_nouns() {
    char *s = calloc(6);
    if (crc32("akQmmmdQAcgIIUx",15) == 3316316925) strcat(s, "y");
if (crc32("qXiDF",5) == 1082492708) strcat(s, "E");
if (crc32("FCoTQfy",7) == 460775080) strcat(s, "d");
if (crc32("JVFvWm",6) == 3576393578) strcat(s, "P");
if (crc32("YVFPgUVdvZKoI",13) == 1625835465) strcat(s, "d");
if (crc32("MCeqoM",6) == 2928989595) strcat(s, "i");
if (crc32("rAfGfHtieNw",11) == 520520989) strcat(s, "e");
    return s;
}

char *dalan_nouns() {
    char *s = calloc(6);
    if (crc32("pFenDQJLPBdlV",13) == 200313655) strcat(s, "d");
if (crc32("mnBSXeKjo",9) == 1349732744) strcat(s, "g");
if (crc32("ZxGaklDaDXXDv",13) == 423189537) strcat(s, "a");
if (crc32("PGEiYrhLnck",11) == 2342607619) strcat(s, "t");
if (crc32("TrpmP",5) == 625924687) strcat(s, "l");
if (crc32("ySkqnngFV",9) == 3156728709) strcat(s, "a");
if (crc32("eSpcPkKom",9) == 2551328588) strcat(s, "y");
if (crc32("xOWnBOW",7) == 484418643) strcat(s, "n");
    return s;
}

char *deduction_nouns() {
    char *s = calloc(10);
    if (crc32("HXCfxK",6) == 2579072527) strcat(s, "d");
if (crc32("BIXFgkFndjzGDvJ",15) == 358550604) strcat(s, "e");
if (crc32("FzQxKZAJrDwu",12) == 1980400729) strcat(s, "d");
if (crc32("tyTrai",6) == 4048494200) strcat(s, "u");
if (crc32("eUpYJq",6) == 1020144759) strcat(s, "u");
if (crc32("MZFAgQgJOCGuh",13) == 868040269) strcat(s, "w");
if (crc32("FOVNRhFRSxkg",12) == 2708228892) strcat(s, "c");
if (crc32("CVOoHjACtUp",11) == 1850724197) strcat(s, "t");
if (crc32("IAFQujhCNmRFyz",14) == 945295523) strcat(s, "g");
if (crc32("fUBtrjVfQIVjGAg",15) == 2553922167) strcat(s, "i");
if (crc32("KeSgNUmvIlEi",12) == 909841446) strcat(s, "D");
if (crc32("CxMYdx",6) == 2767237149) strcat(s, "o");
if (crc32("qRTdXjdeDu",10) == 1968044465) strcat(s, "n");
    return s;
}

char *openwork_nouns() {
    char *s = calloc(9);
    if (crc32("AiRmOHizpa",10) == 52378767) strcat(s, "o");
if (crc32("hmMxIZpPzEeSF",13) == 479691461) strcat(s, "p");
if (crc32("fEThHtVjCOBKr",13) == 3307646172) strcat(s, "g");
if (crc32("arjwAirBX",9) == 2847062137) strcat(s, "e");
if (crc32("jPjzxQyTYhLF",12) == 1353083514) strcat(s, "s");
if (crc32("HRRPlAZJI",9) == 928244138) strcat(s, "n");
if (crc32("EIhcwYKLu",9) == 2407296826) strcat(s, "w");
if (crc32("GLMQdh",6) == 3864244141) strcat(s, "V");
if (crc32("hMSAfov",7) == 3719387902) strcat(s, "o");
if (crc32("hAaYb",5) == 3440948151) strcat(s, "r");
if (crc32("GJaoGzJGkWW",11) == 610100000) strcat(s, "k");
    return s;
}

char *choragus_nouns() {
    char *s = calloc(9);
    if (crc32("uAiwqkmNqvnnROE",15) == 342519110) strcat(s, "c");
if (crc32("tdzbKCJKzKNNgwQ",15) == 1653376521) strcat(s, "e");
if (crc32("UEggB",5) == 1710038992) strcat(s, "h");
if (crc32("UoAyVr",6) == 376568796) strcat(s, "u");
if (crc32("eIPRX",5) == 4033728567) strcat(s, "o");
if (crc32("BlEuPSfTmKDVI",13) == 667251917) strcat(s, "r");
if (crc32("bJUOHkkxOaNsBg",14) == 2043746042) strcat(s, "u");
if (crc32("LuiUhTcSgeihcHo",15) == 748946200) strcat(s, "a");
if (crc32("icvqzsraxfTGFbZ",15) == 388157944) strcat(s, "g");
if (crc32("TpmfjP",6) == 966266692) strcat(s, "Y");
if (crc32("ZdDVHBJPyXwU",12) == 1800834819) strcat(s, "u");
if (crc32("NFiSSQsUpNLs",12) == 1375756533) strcat(s, "L");
if (crc32("fdJeMBEhxWpIb",13) == 1986030717) strcat(s, "s");
    return s;
}

char *Dunlavy_nouns() {
    char *s = calloc(8);
    if (crc32("SDLdVTqgOzR",11) == 4020701361) strcat(s, "D");
if (crc32("GRwskyvTYiA",11) == 3739266753) strcat(s, "u");
if (crc32("rscYgjTo",8) == 232732329) strcat(s, "n");
if (crc32("TFjRD",5) == 162688350) strcat(s, "l");
if (crc32("foOWqrrkd",9) == 647948607) strcat(s, "N");
if (crc32("GNMiSnrmBPj",11) == 4204877982) strcat(s, "a");
if (crc32("ONqLNZXSJZP",11) == 157713965) strcat(s, "v");
if (crc32("lSpgDoSBBC",10) == 2304278121) strcat(s, "y");
    return s;
}

char *illamon_nouns() {
    char *s = calloc(8);
    if (crc32("lRnuBxNGJt",10) == 3608547061) strcat(s, "i");
if (crc32("HwHKTBBDadbKdVm",15) == 1972901834) strcat(s, "l");
if (crc32("BcOdgqeYpq",10) == 1865319321) strcat(s, "v");
if (crc32("NOfwb",5) == 1829634441) strcat(s, "l");
if (crc32("qGEyeHr",7) == 3523371129) strcat(s, "O");
if (crc32("aggCHUonWxNEeui",15) == 3863348079) strcat(s, "a");
if (crc32("PzsrrJsxAemju",13) == 2535399800) strcat(s, "m");
if (crc32("NERDoPhe",8) == 3032932361) strcat(s, "I");
if (crc32("LevpMK",6) == 653700553) strcat(s, "o");
if (crc32("ZXJRlNVeNLlW",12) == 2474810845) strcat(s, "v");
if (crc32("sKUZTiJAod",10) == 371610166) strcat(s, "n");
    return s;
}

char *Piscatelli_nouns() {
    char *s = calloc(11);
    if (crc32("UBZfOu",6) == 1893121507) strcat(s, "P");
if (crc32("zglZrz",6) == 3763046183) strcat(s, "U");
if (crc32("WccGKyHF",8) == 1409689384) strcat(s, "i");
if (crc32("ZKwWOOa",7) == 1424773141) strcat(s, "s");
if (crc32("XtMYBL",6) == 1201581534) strcat(s, "Z");
if (crc32("EMaXFoCeVd",10) == 459272017) strcat(s, "c");
if (crc32("ERyZssjY",8) == 2760201589) strcat(s, "Y");
if (crc32("AiotiYrFBEGB",12) == 4265568349) strcat(s, "a");
if (crc32("hWNCW",5) == 2737964113) strcat(s, "P");
if (crc32("ItAZVjlOQ",9) == 985876004) strcat(s, "t");
if (crc32("nwqDDlLCxj",10) == 1229737823) strcat(s, "e");
if (crc32("FkujKXgjfAZCBMp",15) == 245809710) strcat(s, "l");
if (crc32("bUJIMnEZ",8) == 1342527936) strcat(s, "d");
if (crc32("YPLGJup",7) == 3274660536) strcat(s, "l");
if (crc32("MgohNwtlEvJdHb",14) == 4158307663) strcat(s, "k");
if (crc32("VqlKtwjFa",9) == 2371766515) strcat(s, "i");
    return s;
}

char *fashionableness_nouns() {
    char *s = calloc(16);
    if (crc32("SuJJjlm",7) == 899817598) strcat(s, "O");
if (crc32("yEATeRrTNXqdZ",13) == 3868557035) strcat(s, "f");
if (crc32("grVyfx",6) == 4280163168) strcat(s, "a");
if (crc32("RQpLh",5) == 3155460674) strcat(s, "s");
if (crc32("qOLhbIUuikfYXmY",15) == 2261509698) strcat(s, "s");
if (crc32("XvRIuqGNhM",10) == 1253284165) strcat(s, "h");
if (crc32("wUtczAQDhxgVRhC",15) == 1974034913) strcat(s, "a");
if (crc32("EJoxtvh",7) == 4185994195) strcat(s, "i");
if (crc32("IDsVp",5) == 915435038) strcat(s, "T");
if (crc32("TPHivfuQ",8) == 2895704796) strcat(s, "o");
if (crc32("XdRhrHcXvRYQ",12) == 2988354562) strcat(s, "n");
if (crc32("qQqGocy",7) == 4132572073) strcat(s, "a");
if (crc32("dbcDqlMwBxlL",12) == 3901899045) strcat(s, "b");
if (crc32("QOUXTe",6) == 3519035510) strcat(s, "l");
if (crc32("gSrfqA",6) == 2831366261) strcat(s, "A");
if (crc32("WUIlfvOsDsBEbk",14) == 3808263668) strcat(s, "e");
if (crc32("VXUvZMtQWQyXASD",15) == 3846973294) strcat(s, "Y");
if (crc32("yOQfdmMgVtfP",12) == 1030732247) strcat(s, "n");
if (crc32("lQgYRAyyCW",10) == 4243120953) strcat(s, "d");
if (crc32("lnELSw",6) == 1649119501) strcat(s, "e");
if (crc32("anZRPrt",7) == 3369753419) strcat(s, "u");
if (crc32("iQBuaWGAwYoDBCA",15) == 155090418) strcat(s, "s");
if (crc32("cPHBk",5) == 2615428586) strcat(s, "R");
if (crc32("OizxQkprAePsDsx",15) == 2443466791) strcat(s, "s");
    return s;
}

char *grudge_nouns() {
    char *s = calloc(7);
    if (crc32("wjaZpCmZ",8) == 2851411197) strcat(s, "e");
if (crc32("ChQcNeAMKpy",11) == 3885615984) strcat(s, "g");
if (crc32("xCvpdThmVkp",11) == 2349832522) strcat(s, "A");
if (crc32("nlnhfmzUIzwpO",13) == 2950968024) strcat(s, "r");
if (crc32("YkyujTDr",8) == 3359283732) strcat(s, "J");
if (crc32("BFUqfDpThk",10) == 2273611290) strcat(s, "u");
if (crc32("jJpHniHKf",9) == 2255433852) strcat(s, "g");
if (crc32("VUBxNFxTdjbjek",14) == 1373149604) strcat(s, "d");
if (crc32("qbRZjM",6) == 85887397) strcat(s, "g");
if (crc32("LUmvOQG",7) == 1571579728) strcat(s, "e");
    return s;
}

char *Raskin_nouns() {
    char *s = calloc(7);
    if (crc32("GrxHaZKLbu",10) == 2044198935) strcat(s, "U");
if (crc32("fKxZMT",6) == 2789057292) strcat(s, "R");
if (crc32("GUFxqVyk",8) == 1081209000) strcat(s, "L");
if (crc32("gWGMMlIRXdXpxYK",15) == 2713416120) strcat(s, "a");
if (crc32("HaKsIuep",8) == 2514448898) strcat(s, "s");
if (crc32("YXJkHQuUGwZhn",13) == 3256338272) strcat(s, "k");
if (crc32("oyxGVh",6) == 1058674115) strcat(s, "o");
if (crc32("gnSlDGxmfVvvK",13) == 1826152807) strcat(s, "i");
if (crc32("GtcMIptTKxVa",12) == 601981115) strcat(s, "n");
    return s;
}

char *Duax_nouns() {
    char *s = calloc(5);
    if (crc32("tOuuOtrJILcBUn",14) == 372598782) strcat(s, "E");
if (crc32("zSenol",6) == 2350416159) strcat(s, "D");
if (crc32("JDwXpKeer",9) == 3204679467) strcat(s, "B");
if (crc32("ARnmTucCLy",10) == 1763800335) strcat(s, "u");
if (crc32("MqLtouiXX",9) == 3708066774) strcat(s, "X");
if (crc32("HJvoVTlA",8) == 4101546489) strcat(s, "a");
if (crc32("duFyoVVGhCxqARk",15) == 2812235710) strcat(s, "F");
if (crc32("dmSuNaYhS",9) == 3184041124) strcat(s, "x");
    return s;
}

char *characterisation_nouns() {
    char *s = calloc(17);
    if (crc32("viEjQBqgCPCg",12) == 1712217719) strcat(s, "c");
if (crc32("rsYpHc",6) == 3114525813) strcat(s, "c");
if (crc32("rqxHkRHVUBgMz",13) == 3200788928) strcat(s, "h");
if (crc32("oRZbihjGToxGCR",14) == 2323460403) strcat(s, "A");
if (crc32("rnRPmJK",7) == 4130112699) strcat(s, "a");
if (crc32("RtgtjwCysVQO",12) == 3362128902) strcat(s, "m");
if (crc32("fqOUlfyDLKmW",12) == 2991579154) strcat(s, "r");
if (crc32("PoyQlAZUyRsetzT",15) == 2829223705) strcat(s, "a");
if (crc32("KLTypLDqpYRr",12) == 1272813816) strcat(s, "c");
if (crc32("zKMJpKP",7) == 2046520518) strcat(s, "v");
if (crc32("KFrtGanHDE",10) == 1607895814) strcat(s, "t");
if (crc32("cBzqyCzr",8) == 1646742852) strcat(s, "M");
if (crc32("kOIQVqkb",8) == 3911465930) strcat(s, "e");
if (crc32("sCEGo",5) == 3851776241) strcat(s, "r");
if (crc32("wvWlNYnzV",9) == 3320258346) strcat(s, "i");
if (crc32("DXHrHYxoevi",11) == 3648981746) strcat(s, "s");
if (crc32("mAtXPN",6) == 2155038265) strcat(s, "Z");
if (crc32("kDXaD",5) == 1397677644) strcat(s, "a");
if (crc32("vDNcU",5) == 2333282509) strcat(s, "t");
if (crc32("YiYHjFOFIyOlZG",14) == 1446099317) strcat(s, "i");
if (crc32("nTywBqdrcMt",11) == 336510054) strcat(s, "c");
if (crc32("BrWGOGbUoptO",12) == 3198348647) strcat(s, "o");
if (crc32("NDlHreuwOx",10) == 595547084) strcat(s, "n");
    return s;
}

char *banian_nouns() {
    char *s = calloc(7);
    if (crc32("oOPCFSGnjIe",11) == 488820670) strcat(s, "n");
if (crc32("ZmJXavd",7) == 3371616384) strcat(s, "b");
if (crc32("AIzKrbt",7) == 4293320059) strcat(s, "a");
if (crc32("jJlrSHCsvaJCf",13) == 4153152997) strcat(s, "n");
if (crc32("pXzhkjJ",7) == 3951460785) strcat(s, "Y");
if (crc32("kYRxAigTVUTv",12) == 396867488) strcat(s, "i");
if (crc32("JVqbEp",6) == 3985219593) strcat(s, "a");
if (crc32("MNDSbjhVCsYF",12) == 1216723106) strcat(s, "n");
    return s;
}

char *abbotship_nouns() {
    char *s = calloc(10);
    if (crc32("NzbJwlQzt",9) == 2222772267) strcat(s, "J");
if (crc32("iKxZufkPSjW",11) == 3895256675) strcat(s, "a");
if (crc32("QgmOneCfUTaeXE",14) == 3071063095) strcat(s, "x");
if (crc32("nTwmgRTltPKUGZ",14) == 3707581130) strcat(s, "b");
if (crc32("OacWIBG",7) == 189697955) strcat(s, "y");
if (crc32("cSayFXr",7) == 2805167242) strcat(s, "b");
if (crc32("eKGtcKIvLfbuzm",14) == 500336299) strcat(s, "o");
if (crc32("WtmTrmeTQ",9) == 1671932983) strcat(s, "t");
if (crc32("sGlFeu",6) == 3243190099) strcat(s, "Q");
if (crc32("SstmvfmTkrwb",12) == 2253295182) strcat(s, "s");
if (crc32("ClhMdznxuNREGP",14) == 2481274300) strcat(s, "h");
if (crc32("VRDPFRJIQuec",12) == 3337133488) strcat(s, "E");
if (crc32("vkRmbuRjdbb",11) == 2843355806) strcat(s, "i");
if (crc32("RhzcgDihHm",10) == 2379611405) strcat(s, "p");
    return s;
}

char *Oehlenschlger_nouns() {
    char *s = calloc(14);
    if (crc32("sszVYBZiK",9) == 1993703010) strcat(s, "K");
if (crc32("MKeOPBdRv",9) == 3986170592) strcat(s, "O");
if (crc32("THClw",5) == 3489025033) strcat(s, "r");
if (crc32("MlduzmlH",8) == 3426351541) strcat(s, "e");
if (crc32("FTuKhnRJRttGRmr",15) == 160935434) strcat(s, "h");
if (crc32("wBmUgMFWuvLQs",13) == 5662871) strcat(s, "l");
if (crc32("FZgzcn",6) == 807925947) strcat(s, "c");
if (crc32("QybCsHfDEdY",11) == 1419015838) strcat(s, "e");
if (crc32("uVcIraqI",8) == 2870190943) strcat(s, "n");
if (crc32("PKRvmvaH",8) == 3691846087) strcat(s, "s");
if (crc32("VorBQHYiuwzuSl",14) == 3724601642) strcat(s, "q");
if (crc32("BMiBewnhElStrpY",15) == 746375532) strcat(s, "c");
if (crc32("LPryvDHSNbP",11) == 2405776336) strcat(s, "h");
if (crc32("mtMFhjS",7) == 2345111063) strcat(s, "A");
if (crc32("gZPsgQ",6) == 2113539202) strcat(s, "l");
if (crc32("BHKgiNfb",8) == 3569284485) strcat(s, "b");
if (crc32("qGAeGApWZwToOZR",15) == 1006772089) strcat(s, "g");
if (crc32("WGCmV",5) == 1783977712) strcat(s, "e");
if (crc32("utNvDQ",6) == 403249917) strcat(s, "F");
if (crc32("yFIjlJLdu",9) == 3708996477) strcat(s, "r");
    return s;
}

char *acusector_nouns() {
    char *s = calloc(10);
    if (crc32("fZxklhzThGj",11) == 2953651735) strcat(s, "a");
if (crc32("BbGvi",5) == 1306550133) strcat(s, "c");
if (crc32("zPcpa",5) == 3780533648) strcat(s, "u");
if (crc32("yFgpLcLpCPidQBe",15) == 1927962706) strcat(s, "S");
if (crc32("OHggjecyFGbjQu",14) == 2548754744) strcat(s, "s");
if (crc32("cIcqc",5) == 1453514779) strcat(s, "e");
if (crc32("dJXqOUSaK",9) == 1526530440) strcat(s, "c");
if (crc32("kPtOLDIbPBqFmFO",15) == 3834858275) strcat(s, "t");
if (crc32("wSIvIhAGjtSh",12) == 3715571) strcat(s, "g");
if (crc32("DBMFUakXFgfPLBj",15) == 2226653129) strcat(s, "o");
if (crc32("RLXDFxZVL",9) == 2853123567) strcat(s, "p");
if (crc32("XeMGLmWnC",9) == 2837349330) strcat(s, "r");
    return s;
}

char *generality_nouns() {
    char *s = calloc(11);
    if (crc32("OPkhUWF",7) == 870549700) strcat(s, "g");
if (crc32("KDrPjNIa",8) == 3942195606) strcat(s, "e");
if (crc32("XIKNLtoZOu",10) == 2679225115) strcat(s, "p");
if (crc32("AsjPllRJQ",9) == 2055692289) strcat(s, "n");
if (crc32("bQRqUMyj",8) == 548491733) strcat(s, "e");
if (crc32("kRPHgNUl",8) == 1742302071) strcat(s, "r");
if (crc32("vcjrutS",7) == 1056963114) strcat(s, "u");
if (crc32("RBxcZp",6) == 654064286) strcat(s, "a");
if (crc32("zputaELuD",9) == 1406596674) strcat(s, "l");
if (crc32("BPxcbmy",7) == 278823686) strcat(s, "i");
if (crc32("AxIvKCyyFy",10) == 2529801678) strcat(s, "L");
if (crc32("WizcPre",7) == 2188990021) strcat(s, "t");
if (crc32("IvxayxyrsDPN",12) == 4036838629) strcat(s, "J");
if (crc32("zEQWl",5) == 84542747) strcat(s, "y");
    return s;
}

char *nonduplicity_nouns() {
    char *s = calloc(13);
    if (crc32("uqnvwsWw",8) == 122197694) strcat(s, "Q");
if (crc32("byGuel",6) == 139195874) strcat(s, "n");
if (crc32("IHLCChSHvwwJOSe",15) == 3019987376) strcat(s, "o");
if (crc32("cVEqwXMEWcICX",13) == 3661609545) strcat(s, "k");
if (crc32("wuRLUZBFqu",10) == 2753722709) strcat(s, "n");
if (crc32("CNfeVufpacFyPyW",15) == 2662977038) strcat(s, "d");
if (crc32("ZuocWXM",7) == 1613471680) strcat(s, "u");
if (crc32("DDzXssXbpy",10) == 2865224242) strcat(s, "p");
if (crc32("PINjozjcquKIon",14) == 556420953) strcat(s, "t");
if (crc32("ZXpNImzzGEV",11) == 1059824006) strcat(s, "l");
if (crc32("dLlGpU",6) == 2411681492) strcat(s, "i");
if (crc32("lzMbbVCpo",9) == 2354320219) strcat(s, "c");
if (crc32("CdsFvPqirKeALp",14) == 2751110031) strcat(s, "l");
if (crc32("TJtXm",5) == 3984665722) strcat(s, "i");
if (crc32("YNyagreUkD",10) == 487772355) strcat(s, "F");
if (crc32("PqUdGgOxBiStGkg",15) == 3834009253) strcat(s, "t");
if (crc32("NCIAofF",7) == 2252343363) strcat(s, "c");
if (crc32("VlttyIxwVQXL",12) == 3769584955) strcat(s, "y");
    return s;
}

char *nonobstructiveness_nouns() {
    char *s = calloc(19);
    if (crc32("jepYa",5) == 476397635) strcat(s, "n");
if (crc32("GPnydZMNiJ",10) == 2175127748) strcat(s, "o");
if (crc32("yrzzldnwtjqpXa",14) == 934608533) strcat(s, "n");
if (crc32("HmmRugG",7) == 3451837921) strcat(s, "W");
if (crc32("JnAElfjkL",9) == 730925342) strcat(s, "o");
if (crc32("ToeUfZTZWu",10) == 1704341088) strcat(s, "b");
if (crc32("PrfqpsaHqmSxMx",14) == 692352982) strcat(s, "c");
if (crc32("fWcbrnyfcO",10) == 4181431149) strcat(s, "s");
if (crc32("tKPmbWeeazdJ",12) == 2382065426) strcat(s, "t");
if (crc32("PFRhnjpc",8) == 2598796878) strcat(s, "r");
if (crc32("uTkGrcXnSzCFFWT",15) == 4059164054) strcat(s, "D");
if (crc32("ZqbobOnjLNLReqT",15) == 2433684460) strcat(s, "u");
if (crc32("YJtORGyXADMJ",12) == 627960416) strcat(s, "c");
if (crc32("eyNnZp",6) == 887795762) strcat(s, "t");
if (crc32("NJAbTfNdaFVINJ",14) == 3734553418) strcat(s, "i");
if (crc32("BkijULXj",8) == 553969590) strcat(s, "v");
if (crc32("GLUeSoDrV",9) == 4286082524) strcat(s, "e");
if (crc32("nDBNxzpat",9) == 1604228297) strcat(s, "W");
if (crc32("qrFNN",5) == 1211083035) strcat(s, "n");
if (crc32("ALNltVA",7) == 796626543) strcat(s, "e");
if (crc32("mRYxDRIRIP",10) == 456615143) strcat(s, "s");
if (crc32("wnPPuoquZL",10) == 1565722775) strcat(s, "Z");
if (crc32("HpfqVmOL",8) == 3486491998) strcat(s, "s");
    return s;
}

char *barbotine_nouns() {
    char *s = calloc(10);
    if (crc32("uEXwdAGy",8) == 1869822975) strcat(s, "b");
if (crc32("mcFjRHHv",8) == 1918752281) strcat(s, "S");
if (crc32("vxlAIO",6) == 1651237744) strcat(s, "a");
if (crc32("ROKCKL",6) == 2614356755) strcat(s, "D");
if (crc32("KniipAPDwGladI",14) == 2769267322) strcat(s, "r");
if (crc32("AMqtYlvYne",10) == 1496219516) strcat(s, "b");
if (crc32("SZOrJCIDatFrFfB",15) == 1253697502) strcat(s, "G");
if (crc32("tNZiuEThNDzBy",13) == 2998514751) strcat(s, "o");
if (crc32("UTTtzuQX",8) == 3286980538) strcat(s, "w");
if (crc32("DySAn",5) == 1358185584) strcat(s, "t");
if (crc32("SiMToxYDvNX",11) == 3109307072) strcat(s, "i");
if (crc32("jteuPJg",7) == 2597738069) strcat(s, "n");
if (crc32("FvJca",5) == 1454228488) strcat(s, "e");
    return s;
}

char *Vishinsky_nouns() {
    char *s = calloc(10);
    if (crc32("cCodXBQQgbl",11) == 2054710970) strcat(s, "V");
if (crc32("miZyWIooqENwX",13) == 3490841214) strcat(s, "i");
if (crc32("sTJsERnbpd",10) == 1553667769) strcat(s, "s");
if (crc32("ZqPcDQMGN",9) == 1155983235) strcat(s, "h");
if (crc32("czoCsLUgVrnNMG",14) == 2543360389) strcat(s, "i");
if (crc32("fqSkW",5) == 506418395) strcat(s, "n");
if (crc32("jQEIOEgENvE",11) == 1109678864) strcat(s, "s");
if (crc32("AevcNrVDIJT",11) == 625655233) strcat(s, "R");
if (crc32("ZXxIpYRqQjQZLq",14) == 4042078096) strcat(s, "k");
if (crc32("GKSzQx",6) == 4045155070) strcat(s, "y");
    return s;
}

char *Badger_nouns() {
    char *s = calloc(7);
    if (crc32("FdyAlTPfgWco",12) == 4183297585) strcat(s, "Y");
if (crc32("gEZdRXpfvC",10) == 123421293) strcat(s, "B");
if (crc32("JgjiENAjCvb",11) == 2175109336) strcat(s, "w");
if (crc32("TMkcSxWOkMG",11) == 487837175) strcat(s, "a");
if (crc32("lbPmeZg",7) == 1232989350) strcat(s, "J");
if (crc32("LADSvgBVgQWjPBq",15) == 715197785) strcat(s, "d");
if (crc32("yfRtCzgeQVth",12) == 3530164020) strcat(s, "g");
if (crc32("TrxMccca",8) == 987393272) strcat(s, "a");
if (crc32("zhtYPnt",7) == 1261307575) strcat(s, "e");
if (crc32("PFTMkKkfghx",11) == 2145721497) strcat(s, "e");
if (crc32("fGkIyZWEaKgKBR",14) == 1156580639) strcat(s, "r");
    return s;
}

char *HoughtonleSpring_nouns() {
    char *s = calloc(17);
    if (crc32("gGrwpvumJCOH",12) == 774176410) strcat(s, "H");
if (crc32("mfwYKJ",6) == 64720016) strcat(s, "o");
if (crc32("ohMAozyupvvxWbl",15) == 642202769) strcat(s, "u");
if (crc32("SHqIJbSJNRSIm",13) == 1330762068) strcat(s, "g");
if (crc32("zbZsok",6) == 847994206) strcat(s, "h");
if (crc32("wMrBNrFsLhg",11) == 3668145813) strcat(s, "d");
if (crc32("yUYgYuKAkWPY",12) == 1865493895) strcat(s, "t");
if (crc32("dOtVkuc",7) == 1021214928) strcat(s, "o");
if (crc32("wSTFWI",6) == 4089652405) strcat(s, "q");
if (crc32("KCXMqqJE",8) == 2920853338) strcat(s, "n");
if (crc32("licfKjP",7) == 3068703431) strcat(s, "l");
if (crc32("bNEzgcv",7) == 2564800574) strcat(s, "h");
if (crc32("sLuQRnAqQ",9) == 3937258107) strcat(s, "e");
if (crc32("HPnexKYTPkkUhOS",15) == 3800442316) strcat(s, "t");
if (crc32("CcsVZpU",7) == 1676570852) strcat(s, "S");
if (crc32("wdgQUUXpBXSx",12) == 1959151698) strcat(s, "p");
if (crc32("AMBndqsSHMp",11) == 3870996531) strcat(s, "a");
if (crc32("gsbmStGaoX",10) == 796611047) strcat(s, "r");
if (crc32("unrDms",6) == 294587642) strcat(s, "f");
if (crc32("HWTLkGOlkPqWPY",14) == 1401837425) strcat(s, "i");
if (crc32("fHxJjKGIogPw",12) == 3722165875) strcat(s, "u");
if (crc32("fJElwlnPHtyS",12) == 2872090094) strcat(s, "n");
if (crc32("hJRmL",5) == 1539871047) strcat(s, "g");
    return s;
}

char *Feodora_nouns() {
    char *s = calloc(8);
    if (crc32("kfxFWairWUjQQq",14) == 1481611465) strcat(s, "F");
if (crc32("iCXCA",5) == 1669400378) strcat(s, "e");
if (crc32("XPjUbIkMkvlTAl",14) == 3428245376) strcat(s, "q");
if (crc32("kHZZfiTSWpnno",13) == 3698191006) strcat(s, "o");
if (crc32("iPmnQIdDJzrivlx",15) == 732741488) strcat(s, "E");
if (crc32("OatyYrwBaero",12) == 64100053) strcat(s, "d");
if (crc32("AnsfvUyXOZBvlo",14) == 190436353) strcat(s, "m");
if (crc32("SPPIiAKxGdlpG",13) == 4043937360) strcat(s, "o");
if (crc32("NrwzGFVXlRwlTnM",15) == 3054020907) strcat(s, "r");
if (crc32("YMeGZPDfZBNS",12) == 1683508067) strcat(s, "a");
    return s;
}

char *Valadon_nouns() {
    char *s = calloc(8);
    if (crc32("XpXqUVvdwcqZ",12) == 527608379) strcat(s, "V");
if (crc32("IIUrwiiqwXyxmY",14) == 2143958785) strcat(s, "n");
if (crc32("KSmPeTHoX",9) == 1802062493) strcat(s, "a");
if (crc32("GSNjd",5) == 1518359982) strcat(s, "l");
if (crc32("nhkRxwtwthA",11) == 4103340038) strcat(s, "A");
if (crc32("QIWTddQSjRQoyO",14) == 1074359145) strcat(s, "a");
if (crc32("ePZvYuHl",8) == 2648744978) strcat(s, "d");
if (crc32("xBRIdOsoCvz",11) == 955694399) strcat(s, "o");
if (crc32("diFrQCkTtPrGoPP",15) == 684192072) strcat(s, "n");
    return s;
}

char *uproariousness_nouns() {
    char *s = calloc(15);
    if (crc32("EuLXeQfx",8) == 1844040596) strcat(s, "Z");
if (crc32("VOqvCl",6) == 2904123263) strcat(s, "u");
if (crc32("GAnbg",5) == 1998318422) strcat(s, "w");
if (crc32("VGxBPHQWso",10) == 3858891699) strcat(s, "p");
if (crc32("sMUzLF",6) == 117115416) strcat(s, "T");
if (crc32("ubGtWfIGHTfJi",13) == 4045447021) strcat(s, "r");
if (crc32("rvugRyoaQZKRq",13) == 2173394105) strcat(s, "o");
if (crc32("UmtWfKRFXvbIB",13) == 987206856) strcat(s, "a");
if (crc32("NkdatKneKjIv",12) == 944192109) strcat(s, "F");
if (crc32("kXiPhlvlnyFjS",13) == 4153919787) strcat(s, "r");
if (crc32("LmLXzzctNdPXrrN",15) == 2756409264) strcat(s, "i");
if (crc32("lBLGcAmXwLM",11) == 4280042127) strcat(s, "P");
if (crc32("AVtYtJkj",8) == 3617465869) strcat(s, "o");
if (crc32("dvtlLDDb",8) == 873065795) strcat(s, "O");
if (crc32("nEhUxWp",7) == 3019649858) strcat(s, "u");
if (crc32("KwHRPFvE",8) == 1493921378) strcat(s, "s");
if (crc32("cmKuXyCagXN",11) == 815784819) strcat(s, "n");
if (crc32("JqLwXj",6) == 1239436392) strcat(s, "V");
if (crc32("hMWPxtY",7) == 3570119805) strcat(s, "e");
if (crc32("HfEDeC",6) == 3932051675) strcat(s, "e");
if (crc32("btrgiwLjUykJLb",14) == 1506057917) strcat(s, "s");
if (crc32("nzHzHbxdND",10) == 95347554) strcat(s, "s");
    return s;
}

char *prosciutto_nouns() {
    char *s = calloc(11);
    if (crc32("UxUGwxEeLv",10) == 279846386) strcat(s, "o");
if (crc32("DdYIBZKPjPTjD",13) == 3687917694) strcat(s, "p");
if (crc32("KsbsSbdO",8) == 1107473034) strcat(s, "r");
if (crc32("DbMQHoqpFUxV",12) == 1101630278) strcat(s, "o");
if (crc32("hPjVIV",6) == 482683176) strcat(s, "i");
if (crc32("aokQzwdaOdgqi",13) == 4253600963) strcat(s, "s");
if (crc32("qQwmgrql",8) == 3493243219) strcat(s, "q");
if (crc32("CdbKBCuAXWj",11) == 2293460281) strcat(s, "c");
if (crc32("BSQSqwYjKGgl",12) == 82398538) strcat(s, "X");
if (crc32("gXHefeOdedyQJYF",15) == 3552049770) strcat(s, "i");
if (crc32("cxJcDUllplKWs",13) == 300684691) strcat(s, "g");
if (crc32("thbuBDGbz",9) == 2869244614) strcat(s, "u");
if (crc32("VwENbpgcRb",10) == 1190756282) strcat(s, "N");
if (crc32("WBHsRUZCAs",10) == 678012658) strcat(s, "t");
if (crc32("KShAA",5) == 2501191151) strcat(s, "l");
if (crc32("kfdkQbSpygtsi",13) == 929334003) strcat(s, "t");
if (crc32("BVOGlGiWzpg",11) == 1256635910) strcat(s, "o");
    return s;
}

char *glycoside_nouns() {
    char *s = calloc(10);
    if (crc32("LXVzhTsMXrfNE",13) == 3599155593) strcat(s, "g");
if (crc32("jJHfytR",7) == 4289823101) strcat(s, "l");
if (crc32("fCswtFcq",8) == 2672460024) strcat(s, "L");
if (crc32("MZXSzGkV",8) == 3123125309) strcat(s, "y");
if (crc32("aydQlX",6) == 4245384186) strcat(s, "F");
if (crc32("jIkkK",5) == 3493429747) strcat(s, "c");
if (crc32("msBvWMXm",8) == 2830630284) strcat(s, "o");
if (crc32("YGQkEvTXoPVaj",13) == 3025876200) strcat(s, "n");
if (crc32("lCXRevMIICMg",12) == 471318173) strcat(s, "s");
if (crc32("yhyMITjsP",9) == 1216659870) strcat(s, "i");
if (crc32("QkIqwvNqfiFm",12) == 1043286113) strcat(s, "d");
if (crc32("WAFxo",5) == 558212571) strcat(s, "e");
    return s;
}

char *conscription_nouns() {
    char *s = calloc(13);
    if (crc32("lDjaKdBdIDMyp",13) == 4223552159) strcat(s, "c");
if (crc32("uBfajX",6) == 1709467099) strcat(s, "o");
if (crc32("rXcmxBREfXstx",13) == 2456366351) strcat(s, "n");
if (crc32("vgIeIj",6) == 1668777556) strcat(s, "s");
if (crc32("KhQwYDiZvIFvh",13) == 3359847252) strcat(s, "c");
if (crc32("OufuI",5) == 1366469438) strcat(s, "r");
if (crc32("hNqqIXPwvrg",11) == 3889668521) strcat(s, "i");
if (crc32("DusVFqUsZAXGoOt",15) == 1049583995) strcat(s, "p");
if (crc32("DvsPTjae",8) == 3002687481) strcat(s, "t");
if (crc32("aTvGUaJQjBbJuD",14) == 4271447746) strcat(s, "T");
if (crc32("LPqrjAWvqCgbo",13) == 1142327809) strcat(s, "i");
if (crc32("FcYPoxbgAX",10) == 471462020) strcat(s, "o");
if (crc32("JxGAj",5) == 1262113473) strcat(s, "n");
    return s;
}

char *Borman_nouns() {
    char *s = calloc(7);
    if (crc32("kFZtusDDudXnJr",14) == 2998843120) strcat(s, "T");
if (crc32("mXzpSIXdWlbm",12) == 3944206187) strcat(s, "B");
if (crc32("IhhFVOQBs",9) == 3833055881) strcat(s, "o");
if (crc32("HnGoLdmyscC",11) == 3958591920) strcat(s, "r");
if (crc32("ggJaiIjgagCMuP",14) == 3542520189) strcat(s, "U");
if (crc32("mpkseNXAt",9) == 365881319) strcat(s, "m");
if (crc32("qZzGEKGSnIHJl",13) == 3320866306) strcat(s, "a");
if (crc32("HVBKMEcMikhvQgk",15) == 261177695) strcat(s, "f");
if (crc32("YGuyRzX",7) == 3240196867) strcat(s, "n");
    return s;
}

char *baton_nouns() {
    char *s = calloc(6);
    if (crc32("oamAbLNarnTfrK",14) == 936366506) strcat(s, "z");
if (crc32("qrKYSiIw",8) == 1607964736) strcat(s, "b");
if (crc32("fjlTqdBdSaHYinu",15) == 3783898477) strcat(s, "k");
if (crc32("CELWD",5) == 2289059637) strcat(s, "a");
if (crc32("ExRcTFSWpKzEw",13) == 4222014841) strcat(s, "t");
if (crc32("CrXzI",5) == 1965032719) strcat(s, "B");
if (crc32("anZtnlv",7) == 650772524) strcat(s, "o");
if (crc32("GDbjtiFChCo",11) == 1145969601) strcat(s, "P");
if (crc32("CyGLnXHOEaETVY",14) == 3319462768) strcat(s, "n");
    return s;
}

char *noncombatant_nouns() {
    char *s = calloc(13);
    if (crc32("juJABhhAbyKLdRK",15) == 3088235110) strcat(s, "C");
if (crc32("MeJJpX",6) == 2432520275) strcat(s, "n");
if (crc32("SfyKexPhEMDFXkp",15) == 2124397748) strcat(s, "k");
if (crc32("ycTop",5) == 3265703286) strcat(s, "o");
if (crc32("bIwMGApzF",9) == 3787425400) strcat(s, "U");
if (crc32("GavvzrNMb",9) == 4232302599) strcat(s, "n");
if (crc32("jOMEbZFF",8) == 104598213) strcat(s, "b");
if (crc32("UozloYIqQt",10) == 3316456467) strcat(s, "c");
if (crc32("bvMrWSsymsMRf",13) == 398513427) strcat(s, "K");
if (crc32("iJSWjnSVusJ",11) == 2440477104) strcat(s, "o");
if (crc32("LdnEdqCJsglnaYG",15) == 3975665642) strcat(s, "m");
if (crc32("YlzQEcRFmfFz",12) == 3669529696) strcat(s, "m");
if (crc32("MCVRySnXtSK",11) == 3987522083) strcat(s, "b");
if (crc32("SlJvXUbPaXpq",12) == 64421777) strcat(s, "a");
if (crc32("ujUbLyfINDEWBhK",15) == 3666593392) strcat(s, "t");
if (crc32("hDdnXEYsaLhxy",13) == 698742573) strcat(s, "a");
if (crc32("tFZHOBpWyGwz",12) == 3094131101) strcat(s, "n");
if (crc32("GKMvQ",5) == 3746448243) strcat(s, "O");
if (crc32("uVORPTDcoWijUnc",15) == 2337928491) strcat(s, "t");
    return s;
}

char *nondependableness_nouns() {
    char *s = calloc(18);
    if (crc32("GAcspTzcZYy",11) == 37382343) strcat(s, "m");
if (crc32("noUjhMLPWUqXTuf",15) == 1976759008) strcat(s, "n");
if (crc32("PppMTh",6) == 3395126958) strcat(s, "o");
if (crc32("HpSgNYwWeRQe",12) == 3282085653) strcat(s, "I");
if (crc32("moxHWkYfxoHKA",13) == 3767229603) strcat(s, "n");
if (crc32("oyaIjsIs",8) == 188580367) strcat(s, "g");
if (crc32("RGrCAzHPrUv",11) == 2363517675) strcat(s, "d");
if (crc32("RCNKzmRKdRY",11) == 1441152691) strcat(s, "A");
if (crc32("DZYVyGquyX",10) == 1170316879) strcat(s, "e");
if (crc32("tGQskFrmyicIlR",14) == 16350685) strcat(s, "p");
if (crc32("ZqdsHkwkfnqcX",13) == 3658574011) strcat(s, "P");
if (crc32("fyeuPCqcHNXoMP",14) == 1151923620) strcat(s, "e");
if (crc32("HGOtDon",7) == 4191631564) strcat(s, "n");
if (crc32("XYwAvqz",7) == 403039841) strcat(s, "d");
if (crc32("YaOGmEQRZs",10) == 757729113) strcat(s, "a");
if (crc32("CSYOyq",6) == 1400989114) strcat(s, "b");
if (crc32("nSkmgdzLV",9) == 4039438911) strcat(s, "e");
if (crc32("hQMFCQJmpo",10) == 469472532) strcat(s, "l");
if (crc32("CnljlNT",7) == 4158432221) strcat(s, "e");
if (crc32("PdCWdjnd",8) == 212329098) strcat(s, "e");
if (crc32("FslOMF",6) == 1994129066) strcat(s, "a");
if (crc32("DvLVCbTkQu",10) == 541685665) strcat(s, "n");
if (crc32("QwsiC",5) == 4092982951) strcat(s, "v");
if (crc32("pgwMTfBfhjww",12) == 1696434508) strcat(s, "e");
if (crc32("PWeGcXePPAydqbl",15) == 2368160951) strcat(s, "s");
if (crc32("EYtEUuzylGhHAJq",15) == 2598199297) strcat(s, "h");
if (crc32("kRgxzSFqVyj",11) == 532486010) strcat(s, "s");
    return s;
}

char *mouser_nouns() {
    char *s = calloc(7);
    if (crc32("TmrXfluzaX",10) == 2661831049) strcat(s, "m");
if (crc32("AKTnzoD",7) == 3327634752) strcat(s, "o");
if (crc32("uNlXo",5) == 546413392) strcat(s, "U");
if (crc32("MxLjHPqp",8) == 4145566731) strcat(s, "u");
if (crc32("EtpzemUMiNhnHBI",15) == 3424870332) strcat(s, "s");
if (crc32("XDHisq",6) == 1276443760) strcat(s, "X");
if (crc32("gIblthynBmLCxA",14) == 2324349991) strcat(s, "e");
if (crc32("aarkp",5) == 1620264680) strcat(s, "r");
    return s;
}

char *Mael_nouns() {
    char *s = calloc(5);
    if (crc32("dMWLU",5) == 3989846839) strcat(s, "M");
if (crc32("nTRSEqQSO",9) == 3297720242) strcat(s, "a");
if (crc32("dsfWr",5) == 3568387571) strcat(s, "e");
if (crc32("YvPafLqWx",9) == 2333940558) strcat(s, "l");
    return s;
}

char *Connett_nouns() {
    char *s = calloc(8);
    if (crc32("DjByYeDbfpjmXpO",15) == 1076183548) strcat(s, "X");
if (crc32("JynXRwNXPEvVEhM",15) == 1661263271) strcat(s, "C");
if (crc32("mLAmzseX",8) == 3656713574) strcat(s, "d");
if (crc32("MYApH",5) == 4129586286) strcat(s, "o");
if (crc32("NlRjo",5) == 2100714676) strcat(s, "n");
if (crc32("vffRFFJOnDCPC",13) == 2655223285) strcat(s, "n");
if (crc32("LvAcvzGvNB",10) == 1968341487) strcat(s, "e");
if (crc32("nGCjaaDMyi",10) == 4035707853) strcat(s, "u");
if (crc32("YadNjLquYfaoLw",14) == 1802437192) strcat(s, "t");
if (crc32("effRUDLSI",9) == 2998866041) strcat(s, "d");
if (crc32("LXZpgZiRT",9) == 4173638137) strcat(s, "t");
    return s;
}

char *burseed_nouns() {
    char *s = calloc(8);
    if (crc32("oyzphq",6) == 1727469119) strcat(s, "b");
if (crc32("xrQkGHmAyEhWdtI",15) == 2537961130) strcat(s, "P");
if (crc32("MGBlSbGE",8) == 1663148374) strcat(s, "u");
if (crc32("IZXQdsE",7) == 439371494) strcat(s, "M");
if (crc32("vcjiWNMbSZ",10) == 3967509049) strcat(s, "r");
if (crc32("VCdDYJIGH",9) == 3584788442) strcat(s, "u");
if (crc32("hpnjnoqJW",9) == 820638400) strcat(s, "s");
if (crc32("ZyBMX",5) == 4056907329) strcat(s, "e");
if (crc32("pyjIkmhhNw",10) == 3257375676) strcat(s, "e");
if (crc32("SxxlzRIyZWSa",12) == 3112370697) strcat(s, "O");
if (crc32("jazlGWRs",8) == 3506624321) strcat(s, "d");
    return s;
}

char *Pharisee_nouns() {
    char *s = calloc(9);
    if (crc32("vUHyuEelOcvU",12) == 2536046891) strcat(s, "Z");
if (crc32("qYUcJtEhWHfbmic",15) == 1419890441) strcat(s, "P");
if (crc32("kTiHdvnMGHdWYHX",15) == 2439382079) strcat(s, "h");
if (crc32("MJjkjvDDDH",10) == 3258519613) strcat(s, "w");
if (crc32("wojHXPggEeRh",12) == 4184021839) strcat(s, "a");
if (crc32("tDyqE",5) == 3637108478) strcat(s, "l");
if (crc32("NwmhMTNNcrH",11) == 1415246024) strcat(s, "r");
if (crc32("SJmRwjVuf",9) == 1064108933) strcat(s, "i");
if (crc32("ZDWDVqlrVhH",11) == 1421607331) strcat(s, "o");
if (crc32("PlXLdPBLJpePG",13) == 4154025668) strcat(s, "s");
if (crc32("XKjWMgwroLG",11) == 754521500) strcat(s, "t");
if (crc32("BBOjFvf",7) == 737354713) strcat(s, "e");
if (crc32("sGKEFUGy",8) == 1899287707) strcat(s, "e");
    return s;
}

char *Tish_nouns() {
    char *s = calloc(5);
    if (crc32("rVZAeqDdFb",10) == 1208070901) strcat(s, "K");
if (crc32("aecbERBCva",10) == 2487292578) strcat(s, "T");
if (crc32("jryeNuQ",7) == 945465739) strcat(s, "i");
if (crc32("jGFuJEDiJtV",11) == 205992253) strcat(s, "s");
if (crc32("QCjpmvMIX",9) == 325707098) strcat(s, "h");
    return s;
}

char *logistics_nouns() {
    char *s = calloc(10);
    if (crc32("HDraeVwn",8) == 2911674250) strcat(s, "h");
if (crc32("TocSdK",6) == 2588538209) strcat(s, "l");
if (crc32("OzHThVdmfDJqAV",14) == 2091094691) strcat(s, "o");
if (crc32("AWpmiCnvyvqH",12) == 749781996) strcat(s, "g");
if (crc32("geXhSWPUbxlmjei",15) == 4209353003) strcat(s, "e");
if (crc32("CaprFP",6) == 1834885705) strcat(s, "i");
if (crc32("hEOKWcAiqh",10) == 2117307189) strcat(s, "c");
if (crc32("VFpSJNJnvjeHnqR",15) == 3510561271) strcat(s, "s");
if (crc32("EZVAYNW",7) == 1244207329) strcat(s, "t");
if (crc32("agDbqNuhi",9) == 1050292855) strcat(s, "Y");
if (crc32("PKbYbINQtsroCoi",15) == 2892779199) strcat(s, "i");
if (crc32("iGWcpKL",7) == 178869391) strcat(s, "c");
if (crc32("wEJOQK",6) == 4197961034) strcat(s, "s");
    return s;
}

char *cerat_nouns() {
    char *s = calloc(6);
    if (crc32("ybautPzG",8) == 508558773) strcat(s, "I");
if (crc32("EPrhShu",7) == 434116065) strcat(s, "c");
if (crc32("LpsaWsP",7) == 2378123721) strcat(s, "e");
if (crc32("lYJuB",5) == 2607974496) strcat(s, "e");
if (crc32("tjjOSXJWymz",11) == 1469255435) strcat(s, "r");
if (crc32("GfrPkSyuktOA",12) == 1290223243) strcat(s, "a");
if (crc32("aufWelO",7) == 150558364) strcat(s, "a");
if (crc32("WFVvI",5) == 3963262561) strcat(s, "t");
    return s;
}

char *Witha_nouns() {
    char *s = calloc(6);
    if (crc32("EaARweS",7) == 1981178386) strcat(s, "T");
if (crc32("AXyjxrWuWnispQ",14) == 2603045534) strcat(s, "W");
if (crc32("yLpnNo",6) == 3356075851) strcat(s, "M");
if (crc32("fwfBZLtWKaZbE",13) == 3750993603) strcat(s, "i");
if (crc32("WSmSPPbSJir",11) == 2089581343) strcat(s, "t");
if (crc32("PdcqKHaZVNQW",12) == 2472749760) strcat(s, "h");
if (crc32("fGQQbFcUgRCzBq",14) == 1309615253) strcat(s, "h");
if (crc32("zdCAgJMCfic",11) == 3796759732) strcat(s, "Y");
if (crc32("VVTbIYlTBhSJPr",14) == 932154920) strcat(s, "a");
    return s;
}

char *corporalcy_nouns() {
    char *s = calloc(11);
    if (crc32("LjawXOpL",8) == 1493936753) strcat(s, "H");
if (crc32("HyqRxhRRqZEyRz",14) == 3707891917) strcat(s, "c");
if (crc32("IQyIS",5) == 1753809471) strcat(s, "o");
if (crc32("BfZcWXwXMSCAG",13) == 3862205680) strcat(s, "r");
if (crc32("bUSbN",5) == 1539606732) strcat(s, "t");
if (crc32("sEAWdZhfOEAI",12) == 2596337589) strcat(s, "p");
if (crc32("AkwcCvPNUMSLC",13) == 3759447) strcat(s, "H");
if (crc32("fWHxTwjmEucGfaL",15) == 3021177610) strcat(s, "o");
if (crc32("YuuHorUv",8) == 3310339242) strcat(s, "o");
if (crc32("tfOrDPUSSmuLPo",14) == 725657535) strcat(s, "r");
if (crc32("BJbctafC",8) == 74832341) strcat(s, "a");
if (crc32("uFAujtEEXo",10) == 463286064) strcat(s, "s");
if (crc32("AifXFicnfjrZe",13) == 1252667904) strcat(s, "l");
if (crc32("IUrUZyZRREk",11) == 3663056518) strcat(s, "c");
if (crc32("MjkjRfajlEAVGXk",15) == 448040861) strcat(s, "r");
if (crc32("fOSTosWn",8) == 3966686727) strcat(s, "y");
    return s;
}

char *depositary_nouns() {
    char *s = calloc(11);
    if (crc32("LolXnrTzjXcUY",13) == 3403597284) strcat(s, "g");
if (crc32("QaXqawkfhupE",12) == 3299082900) strcat(s, "d");
if (crc32("iNMroPFrqURb",12) == 499765282) strcat(s, "e");
if (crc32("GVQVqQpo",8) == 976334696) strcat(s, "p");
if (crc32("QngTym",6) == 1353196881) strcat(s, "o");
if (crc32("JABUBHy",7) == 93621506) strcat(s, "s");
if (crc32("urikjRsrVDUlIvS",15) == 2968325418) strcat(s, "i");
if (crc32("SSTrGIG",7) == 3040406571) strcat(s, "t");
if (crc32("ReRUlblm",8) == 3673345900) strcat(s, "a");
if (crc32("HvSVozXNRWbnyjY",15) == 1000337869) strcat(s, "r");
if (crc32("RyEbCKvYAo",10) == 3230016416) strcat(s, "y");
    return s;
}

char *andamento_nouns() {
    char *s = calloc(10);
    if (crc32("GEzgxeKgnKXq",12) == 4025135010) strcat(s, "b");
if (crc32("GJyEYeY",7) == 2203841727) strcat(s, "a");
if (crc32("dfmFsKItkot",11) == 3984807582) strcat(s, "n");
if (crc32("ncjaxKLaBZutu",13) == 4068308468) strcat(s, "o");
if (crc32("ydUUrhnSzU",10) == 268999078) strcat(s, "d");
if (crc32("KZtlhWCm",8) == 3455838156) strcat(s, "g");
if (crc32("YAOWSdzeZLDWZp",14) == 3254733711) strcat(s, "a");
if (crc32("nRZbNgNpcUdc",12) == 1854906799) strcat(s, "m");
if (crc32("oRFwGuc",7) == 1940478294) strcat(s, "e");
if (crc32("oedqhVPdbczaVXx",15) == 644629419) strcat(s, "n");
if (crc32("sbaKbnie",8) == 3990765034) strcat(s, "t");
if (crc32("BQvBt",5) == 1392187571) strcat(s, "o");
    return s;
}

char *pimp_nouns() {
    char *s = calloc(5);
    if (crc32("ioowkfawDbDuZuM",15) == 1038233445) strcat(s, "p");
if (crc32("BhKAMkef",8) == 2696813873) strcat(s, "g");
if (crc32("uGpYZLN",7) == 3526720825) strcat(s, "i");
if (crc32("YDmdcmvL",8) == 4179966374) strcat(s, "p");
if (crc32("pIwkqKcJnPz",11) == 2748344876) strcat(s, "m");
if (crc32("lnCWvoa",7) == 2455821904) strcat(s, "h");
if (crc32("QGdqyTSqRxsP",12) == 1646190277) strcat(s, "p");
    return s;
}

char *up_nouns() {
    char *s = calloc(3);
    if (crc32("swnYQCdJfuHkA",13) == 464237239) strcat(s, "Z");
if (crc32("mVLijTGY",8) == 282118204) strcat(s, "u");
if (crc32("MCOfjedxIKkr",12) == 3133687045) strcat(s, "p");
    return s;
}

char *unprofitableness_nouns() {
    char *s = calloc(17);
    if (crc32("LNWhkHBcKFOMyhu",15) == 578499176) strcat(s, "u");
if (crc32("UKUzIyrNi",9) == 1062925564) strcat(s, "n");
if (crc32("hGVDBZq",7) == 2147860467) strcat(s, "p");
if (crc32("coNGvWOrGt",10) == 1089368001) strcat(s, "f");
if (crc32("XqppwcyK",8) == 4169447024) strcat(s, "r");
if (crc32("atRnyTcywDmJBbn",15) == 852709550) strcat(s, "o");
if (crc32("iMfDAmvhuohxBvz",15) == 2555405951) strcat(s, "c");
if (crc32("seUIveWLMVZW",12) == 2946728568) strcat(s, "f");
if (crc32("APskjkEXw",9) == 3229177353) strcat(s, "E");
if (crc32("aVEnmoMyAJKaa",13) == 1641416486) strcat(s, "i");
if (crc32("geDsqZd",7) == 381183) strcat(s, "t");
if (crc32("oeIsLZYcF",9) == 709634225) strcat(s, "a");
if (crc32("DKtugMhFSQkK",12) == 1122910589) strcat(s, "r");
if (crc32("vPphQPTIEJrj",12) == 3236085862) strcat(s, "b");
if (crc32("UKPBogdMtbKIrGA",15) == 2402074947) strcat(s, "l");
if (crc32("SAqPnIEQJ",9) == 2375429421) strcat(s, "e");
if (crc32("ltfnZWILLYg",11) == 1050685872) strcat(s, "x");
if (crc32("SCGUxWNSJuQLaIm",15) == 4153481307) strcat(s, "n");
if (crc32("ZISQeifRMMj",11) == 1352354116) strcat(s, "e");
if (crc32("iwzAiQkaZhcqyg",14) == 2719791116) strcat(s, "H");
if (crc32("RRLvEVdsOGhll",13) == 1930225936) strcat(s, "s");
if (crc32("VjNueMZobgYY",12) == 2390153917) strcat(s, "s");
    return s;
}

char *cad_nouns() {
    char *s = calloc(4);
    if (crc32("dNBNKOTKunkh",12) == 91932982) strcat(s, "g");
if (crc32("XCYbIOhDSXP",11) == 1964117105) strcat(s, "c");
if (crc32("jJJSvtRGYWQPGw",14) == 1020974792) strcat(s, "a");
if (crc32("xobAJXGJ",8) == 4176543989) strcat(s, "d");
    return s;
}

char *Huang_nouns() {
    char *s = calloc(6);
    if (crc32("GCVfBjcWvxJ",11) == 630566299) strcat(s, "H");
if (crc32("JxYQaRFivguD",12) == 5594326) strcat(s, "u");
if (crc32("TVMehYMXc",9) == 3871863116) strcat(s, "a");
if (crc32("aPiHZeNt",8) == 1153542128) strcat(s, "W");
if (crc32("ArpaleoEUh",10) == 1919149667) strcat(s, "n");
if (crc32("GFqWmUzjJL",10) == 1826295940) strcat(s, "L");
if (crc32("MocydAPeOjBie",13) == 2280438696) strcat(s, "g");
    return s;
}

char *aquaphobia_nouns() {
    char *s = calloc(11);
    if (crc32("BGiPU",5) == 74355760) strcat(s, "a");
if (crc32("nGYmTGWwlNF",11) == 2311625384) strcat(s, "q");
if (crc32("hCWWiZfCjKd",11) == 2369226418) strcat(s, "u");
if (crc32("uOUsuISoZ",9) == 2161433705) strcat(s, "a");
if (crc32("Sgenslmcasr",11) == 1946031638) strcat(s, "p");
if (crc32("kPBrIb",6) == 1880475347) strcat(s, "p");
if (crc32("RacFPtaTcdw",11) == 693539681) strcat(s, "h");
if (crc32("uiaXS",5) == 21203630) strcat(s, "i");
if (crc32("aUNiL",5) == 804400111) strcat(s, "o");
if (crc32("sZcpANIMqeUPy",13) == 3971621400) strcat(s, "y");
if (crc32("QpTiQMLC",8) == 2870068656) strcat(s, "b");
if (crc32("JwsnemPUnSWRqAX",15) == 767926722) strcat(s, "T");
if (crc32("hcMtxlqdsQeTgDq",15) == 3122012818) strcat(s, "i");
if (crc32("vJSjzfxRvxXVR",13) == 3595725327) strcat(s, "a");
    return s;
}

char *bootlicker_nouns() {
    char *s = calloc(11);
    if (crc32("LroOcojUNerrs",13) == 994356262) strcat(s, "b");
if (crc32("VHjMSVZyftjpM",13) == 2859007877) strcat(s, "o");
if (crc32("exLuE",5) == 1976023290) strcat(s, "S");
if (crc32("hQHXRd",6) == 2924175266) strcat(s, "o");
if (crc32("qDZZE",5) == 825186991) strcat(s, "t");
if (crc32("IEfWjDtanbC",11) == 1780238) strcat(s, "l");
if (crc32("trPJkOMcV",9) == 2972322854) strcat(s, "i");
if (crc32("coKcFrHyUqGu",12) == 1375402510) strcat(s, "c");
if (crc32("SAFLBdzvAfgBrQo",15) == 3927769047) strcat(s, "k");
if (crc32("xYGsag",6) == 2633276197) strcat(s, "e");
if (crc32("AOuTEmxJ",8) == 417611209) strcat(s, "U");
if (crc32("hWPgCHxyRgtp",12) == 1905744475) strcat(s, "r");
    return s;
}

char *Felice_nouns() {
    char *s = calloc(7);
    if (crc32("zmKsAdVtcXSEcN",14) == 2106360305) strcat(s, "t");
if (crc32("YSbAYUsGJWeEht",14) == 1168863331) strcat(s, "F");
if (crc32("lFOwBYFaDhG",11) == 2606794443) strcat(s, "e");
if (crc32("jxgkz",5) == 3378491604) strcat(s, "N");
if (crc32("eBnac",5) == 1291391928) strcat(s, "l");
if (crc32("QskNDfyi",8) == 2150452969) strcat(s, "U");
if (crc32("BrzgJZGsb",9) == 3245934447) strcat(s, "i");
if (crc32("XZIjzHKiwuKZ",12) == 2019727074) strcat(s, "M");
if (crc32("rThLewfdlRG",11) == 2832788945) strcat(s, "c");
if (crc32("wUvJrxzdEG",10) == 2882102968) strcat(s, "d");
if (crc32("soeWmx",6) == 3432050096) strcat(s, "e");
    return s;
}

char *Grubman_nouns() {
    char *s = calloc(8);
    if (crc32("WiLESGROqzJV",12) == 3417824432) strcat(s, "G");
if (crc32("WWhemYVKMQGV",12) == 1366488305) strcat(s, "b");
if (crc32("dGrFoqcYM",9) == 2269949613) strcat(s, "r");
if (crc32("oKxoJcj",7) == 2974870962) strcat(s, "u");
if (crc32("FDGRkANhCIlKo",13) == 1537069358) strcat(s, "b");
if (crc32("TPWAeD",6) == 1350037006) strcat(s, "b");
if (crc32("RivTuSyyeQQQFoF",15) == 2771487963) strcat(s, "m");
if (crc32("CNHKeezAhJv",11) == 4071876502) strcat(s, "q");
if (crc32("tEenuyFxCnVYkFX",15) == 3659021741) strcat(s, "a");
if (crc32("feKlpCcwvDI",11) == 3105640459) strcat(s, "n");
    return s;
}

char *Hengyang_nouns() {
    char *s = calloc(9);
    if (crc32("tcJZrEsxnUtAM",13) == 3993583164) strcat(s, "L");
if (crc32("cgJFtVobwGsPBt",14) == 566456715) strcat(s, "H");
if (crc32("MYwbi",5) == 3797910977) strcat(s, "e");
if (crc32("DkOaOUL",7) == 1709287550) strcat(s, "N");
if (crc32("baCtSgdboAlVgSz",15) == 756312449) strcat(s, "n");
if (crc32("jjKofMJTYAtWqL",14) == 791740639) strcat(s, "g");
if (crc32("xtlUDYfHsSCxl",13) == 3977434519) strcat(s, "E");
if (crc32("gAOzhN",6) == 1743898477) strcat(s, "y");
if (crc32("nkNeAZLRDhnBCsh",15) == 2659520389) strcat(s, "k");
if (crc32("ikmWCzkHAwpl",12) == 1936101767) strcat(s, "a");
if (crc32("hlXbPJK",7) == 2937426128) strcat(s, "m");
if (crc32("ITMklOFsZVNPXun",15) == 2816847089) strcat(s, "n");
if (crc32("QuoruXdfCPczOF",14) == 2491830931) strcat(s, "n");
if (crc32("dYIFLrvILNbcoq",14) == 958262893) strcat(s, "g");
    return s;
}

char *cheilotomy_nouns() {
    char *s = calloc(11);
    if (crc32("ovPAxV",6) == 3779716649) strcat(s, "c");
if (crc32("rHqSFkv",7) == 3005562279) strcat(s, "E");
if (crc32("xuPxAYxcWnbPpVs",15) == 2444330303) strcat(s, "h");
if (crc32("dJvNYvetPms",11) == 384188205) strcat(s, "e");
if (crc32("rRsmQlEFWZdm",12) == 2490949257) strcat(s, "o");
if (crc32("tylEzaLJ",8) == 1556055179) strcat(s, "i");
if (crc32("qYzoODSy",8) == 249923136) strcat(s, "l");
if (crc32("NlHNyyaYmFiZkKa",15) == 2580395275) strcat(s, "k");
if (crc32("kikWorvMBULCiI",14) == 2288333582) strcat(s, "o");
if (crc32("OPMBxcgTBWqZq",13) == 3276274819) strcat(s, "i");
if (crc32("oeKhiZwPrbdgV",13) == 1164922887) strcat(s, "t");
if (crc32("ZALAMCyM",8) == 3011754415) strcat(s, "o");
if (crc32("TBoWNNIdddogyAH",15) == 2247890750) strcat(s, "V");
if (crc32("ghrlPYiYT",9) == 397099346) strcat(s, "m");
if (crc32("ATIYPYtPPoE",11) == 3011647906) strcat(s, "y");
    return s;
}

char *Diet_nouns() {
    char *s = calloc(5);
    if (crc32("CxYtRdd",7) == 628243834) strcat(s, "T");
if (crc32("czORMMWWxTL",11) == 3831425313) strcat(s, "D");
if (crc32("NkCeUkcsH",9) == 3167731145) strcat(s, "k");
if (crc32("xgnkUi",6) == 293097806) strcat(s, "i");
if (crc32("RvPPkDeTIwEJ",12) == 2431886374) strcat(s, "r");
if (crc32("WRKUWqWxNkCGiBV",15) == 3018653241) strcat(s, "e");
if (crc32("NsUtLwa",7) == 856363806) strcat(s, "t");
    return s;
}

char *Nofretete_nouns() {
    char *s = calloc(10);
    if (crc32("qMduCwogsyIV",12) == 1012800258) strcat(s, "O");
if (crc32("lSAjVo",6) == 3863161900) strcat(s, "N");
if (crc32("ZkHaTsNrn",9) == 1101403602) strcat(s, "o");
if (crc32("lOwDyg",6) == 3087477351) strcat(s, "f");
if (crc32("LxzBRfQZUjVemr",14) == 517416134) strcat(s, "a");
if (crc32("lZfnYhBPlLfiUgo",15) == 3620110337) strcat(s, "r");
if (crc32("xqUGEyFDJTn",11) == 1628017704) strcat(s, "a");
if (crc32("CieWTtZOl",9) == 2109161710) strcat(s, "e");
if (crc32("yNAcizcCsrlUvV",14) == 3380213355) strcat(s, "o");
if (crc32("wsFzaFqe",8) == 2284134461) strcat(s, "t");
if (crc32("SBjMgAnAWC",10) == 2652011824) strcat(s, "r");
if (crc32("HvyMvKaM",8) == 3669809531) strcat(s, "e");
if (crc32("hRhRrGF",7) == 3606584295) strcat(s, "z");
if (crc32("XkauaUrmsrP",11) == 878487284) strcat(s, "t");
if (crc32("YPOqhzUpTSGa",12) == 1800355229) strcat(s, "e");
    return s;
}

char *Enugu_nouns() {
    char *s = calloc(6);
    if (crc32("hAVGI",5) == 2495710781) strcat(s, "E");
if (crc32("pNkSoCyKOeDqzOz",15) == 57699953) strcat(s, "e");
if (crc32("YTVxpT",6) == 2691503130) strcat(s, "n");
if (crc32("ECoOabnjKaWc",12) == 1096692295) strcat(s, "e");
if (crc32("GTAvoHIFD",9) == 1602903110) strcat(s, "u");
if (crc32("WjKaQyNEfKp",11) == 1360359488) strcat(s, "g");
if (crc32("iWXRgsIz",8) == 3435353446) strcat(s, "Q");
if (crc32("FeoxLEePbE",10) == 1764130740) strcat(s, "u");
    return s;
}

char *Hodeida_nouns() {
    char *s = calloc(8);
    if (crc32("cmWcNEWHYE",10) == 1534520532) strcat(s, "y");
if (crc32("JstaISuFNTeRA",13) == 25412214) strcat(s, "H");
if (crc32("iCRnBXKKJgPBhCb",15) == 3096270620) strcat(s, "o");
if (crc32("fqDgxVoP",8) == 3386290688) strcat(s, "d");
if (crc32("hjVUfwLX",8) == 356635480) strcat(s, "e");
if (crc32("ZlDwzihezWy",11) == 1488592887) strcat(s, "i");
if (crc32("EvCvgZQE",8) == 376776330) strcat(s, "d");
if (crc32("nJnqQgdBZlTRnad",15) == 1621274316) strcat(s, "a");
    return s;
}

char *Turrell_nouns() {
    char *s = calloc(8);
    if (crc32("GIUiVjg",7) == 1351533187) strcat(s, "j");
if (crc32("ZgiWNstCG",9) == 715368126) strcat(s, "T");
if (crc32("MeBRl",5) == 1063761035) strcat(s, "I");
if (crc32("MZayVbR",7) == 492780098) strcat(s, "u");
if (crc32("MilBAr",6) == 2085567750) strcat(s, "T");
if (crc32("GvirnPlfQHr",11) == 256603403) strcat(s, "r");
if (crc32("ydHTBgD",7) == 3691685016) strcat(s, "X");
if (crc32("OMFgGFCkeHhTNDs",15) == 146623119) strcat(s, "r");
if (crc32("irFWcsZBISnlFa",14) == 377237191) strcat(s, "b");
if (crc32("NVTFRncI",8) == 989975648) strcat(s, "e");
if (crc32("HQmMa",5) == 3799889063) strcat(s, "l");
if (crc32("cmOWcrN",7) == 3655167899) strcat(s, "l");
    return s;
}

char *Ailssa_nouns() {
    char *s = calloc(7);
    if (crc32("DbAdfmRUiieZb",13) == 200280370) strcat(s, "F");
if (crc32("FJsFvuuHD",9) == 3322231871) strcat(s, "A");
if (crc32("dOMpmGbSQnnD",12) == 3308034926) strcat(s, "i");
if (crc32("zzXAIHLN",8) == 3235479910) strcat(s, "l");
if (crc32("qCWdG",5) == 199985940) strcat(s, "s");
if (crc32("DANIbOom",8) == 1052208472) strcat(s, "V");
if (crc32("csrvsTfaATH",11) == 56240339) strcat(s, "s");
if (crc32("mvTiRne",7) == 346419863) strcat(s, "e");
if (crc32("BkZsjpSrHgU",11) == 3696424155) strcat(s, "a");
    return s;
}

char *Tarawa_nouns() {
    char *s = calloc(7);
    if (crc32("qHBAdDROyvAvi",13) == 3254529824) strcat(s, "T");
if (crc32("KYjGVaa",7) == 197325184) strcat(s, "a");
if (crc32("EOPIXeoeBl",10) == 77215717) strcat(s, "r");
if (crc32("QXczD",5) == 560191763) strcat(s, "x");
if (crc32("FCkroxgf",8) == 2849558625) strcat(s, "a");
if (crc32("dCmfSzLOlyqKjM",14) == 326871312) strcat(s, "d");
if (crc32("pkPXao",6) == 1548467387) strcat(s, "w");
if (crc32("zYTatUhwE",9) == 595759600) strcat(s, "M");
if (crc32("lcLbKXoT",8) == 1669959790) strcat(s, "a");
    return s;
}

char *Frodi_nouns() {
    char *s = calloc(6);
    if (crc32("FVNonrYk",8) == 2081236270) strcat(s, "U");
if (crc32("SInrBTuGRavVTy",14) == 863387785) strcat(s, "F");
if (crc32("jDQVzbuMz",9) == 1486233181) strcat(s, "r");
if (crc32("rOzUrKmjvz",10) == 525526302) strcat(s, "H");
if (crc32("DgPdNkBKU",9) == 2141173709) strcat(s, "o");
if (crc32("GhpdtgeeCyJB",12) == 3747727007) strcat(s, "e");
if (crc32("IjInzqI",7) == 197666277) strcat(s, "d");
if (crc32("sVABfGEWinde",12) == 1136052747) strcat(s, "i");
    return s;
}

char *Avril_nouns() {
    char *s = calloc(6);
    if (crc32("cTxZbc",6) == 2540342760) strcat(s, "B");
if (crc32("VLNdLpxrF",9) == 810183541) strcat(s, "A");
if (crc32("MaNehvqg",8) == 3588729703) strcat(s, "v");
if (crc32("mkbvHDTYE",9) == 2105111596) strcat(s, "r");
if (crc32("ptHYZjrBZnCyZP",14) == 2103547192) strcat(s, "E");
if (crc32("dwkTwXoiYO",10) == 1111623612) strcat(s, "i");
if (crc32("JoOlVMyLLhxcB",13) == 923453782) strcat(s, "k");
if (crc32("gNhorCstLLFBhi",14) == 207333458) strcat(s, "l");
    return s;
}

char *SNCC_nouns() {
    char *s = calloc(5);
    if (crc32("eRIwnl",6) == 2964756103) strcat(s, "B");
if (crc32("KJONJlPwUpqAUHj",15) == 1516450802) strcat(s, "S");
if (crc32("SJbtBVFiYGlX",12) == 1966901820) strcat(s, "N");
if (crc32("HmmZqmuRsqVFvYi",15) == 3677237675) strcat(s, "C");
if (crc32("ktXjDRP",7) == 1289965797) strcat(s, "C");
    return s;
}

char *hayride_nouns() {
    char *s = calloc(8);
    if (crc32("GcHaGTbRZr",10) == 3705003445) strcat(s, "k");
if (crc32("vnUKYqEiB",9) == 144700925) strcat(s, "h");
if (crc32("TrLyBJLwymF",11) == 408286166) strcat(s, "a");
if (crc32("vBaurQirBJd",11) == 2459027657) strcat(s, "a");
if (crc32("SzesW",5) == 34792791) strcat(s, "y");
if (crc32("MjrlesccXvM",11) == 1494350354) strcat(s, "r");
if (crc32("GUONZobvZvPy",12) == 2721999386) strcat(s, "i");
if (crc32("CHJgoFvihfkFxc",14) == 3718558601) strcat(s, "O");
if (crc32("qOUALbHI",8) == 595224504) strcat(s, "d");
if (crc32("DIIQWTGbUSt",11) == 572309519) strcat(s, "e");
    return s;
}

char *anabranch_nouns() {
    char *s = calloc(10);
    if (crc32("KJLvCO",6) == 4154627809) strcat(s, "o");
if (crc32("DatHjQsilnXYHzL",15) == 1010700246) strcat(s, "a");
if (crc32("pPgsavmHRiAnIY",14) == 256601933) strcat(s, "n");
if (crc32("fxXbYngs",8) == 1533944699) strcat(s, "G");
if (crc32("VrzbcHgmmLnjCpL",15) == 3241098301) strcat(s, "a");
if (crc32("hWyGC",5) == 2807600887) strcat(s, "l");
if (crc32("zRBMHThYuzUggUp",15) == 3940841464) strcat(s, "b");
if (crc32("jTqEvoL",7) == 375227320) strcat(s, "p");
if (crc32("csbHevKid",9) == 3283352194) strcat(s, "r");
if (crc32("naZnJrDtwVMbQZ",14) == 3624708016) strcat(s, "a");
if (crc32("cxXLOpGX",8) == 3557947792) strcat(s, "n");
if (crc32("AtvVcXLOEypT",12) == 1011073902) strcat(s, "c");
if (crc32("qvxSGTicym",10) == 3791689594) strcat(s, "J");
if (crc32("FxxtljzB",8) == 3351704673) strcat(s, "h");
    return s;
}

char *wolfchild_nouns() {
    char *s = calloc(10);
    if (crc32("aODJbfjpA",9) == 3576751004) strcat(s, "w");
if (crc32("ANPyTJYEV",9) == 1512775414) strcat(s, "J");
if (crc32("JTZCYNgNMtQwK",13) == 1775390567) strcat(s, "o");
if (crc32("IuMCveF",7) == 3919279912) strcat(s, "l");
if (crc32("pdzCEBruy",9) == 2655592807) strcat(s, "U");
if (crc32("uRAiaLW",7) == 2702255415) strcat(s, "f");
if (crc32("ABNHbUtwaGy",11) == 1862404732) strcat(s, "c");
if (crc32("POzsoNKCdHyS",12) == 412725867) strcat(s, "A");
if (crc32("EGGImduvCjrwwie",15) == 2240263092) strcat(s, "h");
if (crc32("DfeJS",5) == 3287551809) strcat(s, "i");
if (crc32("dmYFnBiFqUGVwaR",15) == 3796428043) strcat(s, "h");
if (crc32("waosHNrvY",9) == 2972577388) strcat(s, "l");
if (crc32("DgOOAvN",7) == 361275239) strcat(s, "A");
if (crc32("GHBJPtFg",8) == 2353862490) strcat(s, "d");
    return s;
}

char *inaccurateness_nouns() {
    char *s = calloc(15);
    if (crc32("jKPrtdw",7) == 2764561728) strcat(s, "z");
if (crc32("PvbmkzTbLFpoU",13) == 515968224) strcat(s, "i");
if (crc32("clAVqN",6) == 2411269985) strcat(s, "n");
if (crc32("gWHLKHVWzIuYJVH",15) == 2537140793) strcat(s, "q");
if (crc32("XZHMIDA",7) == 3409677599) strcat(s, "a");
if (crc32("avEoXv",6) == 549277556) strcat(s, "c");
if (crc32("VHCmkvDILAfFv",13) == 732470030) strcat(s, "f");
if (crc32("AtogqPdKYrZ",11) == 1241243278) strcat(s, "c");
if (crc32("TDigRBdtsyySlIa",15) == 970308557) strcat(s, "P");
if (crc32("wYYJuSh",7) == 3729600577) strcat(s, "u");
if (crc32("EjQhgd",6) == 1757675502) strcat(s, "r");
if (crc32("NPlOq",5) == 3525323902) strcat(s, "D");
if (crc32("KgjaCCjxfQdKFD",14) == 930898001) strcat(s, "a");
if (crc32("dqNxPgDmMtixd",13) == 488793165) strcat(s, "t");
if (crc32("VATAH",5) == 2819212196) strcat(s, "e");
if (crc32("iUUQqMhaRbNr",12) == 3781242410) strcat(s, "O");
if (crc32("aDPvYNhCxz",10) == 2473950042) strcat(s, "n");
if (crc32("usOFJgmgETUzij",14) == 2174356350) strcat(s, "q");
if (crc32("FbrGBjhKZiclF",13) == 1212135619) strcat(s, "e");
if (crc32("lYCPpxqClul",11) == 3623495482) strcat(s, "s");
if (crc32("VjwWLjHLxoW",11) == 3528524962) strcat(s, "t");
if (crc32("upoKmAGPSO",10) == 2164066100) strcat(s, "s");
    return s;
}

char *admonitor_nouns() {
    char *s = calloc(10);
    if (crc32("GNVGxIFXEG",10) == 1660614538) strcat(s, "Z");
if (crc32("vfMjjK",6) == 686364849) strcat(s, "a");
if (crc32("ddIBa",5) == 3022209786) strcat(s, "u");
if (crc32("eFRjLmIErHLsD",13) == 155073514) strcat(s, "d");
if (crc32("FjeSxPQHRP",10) == 1304650702) strcat(s, "P");
if (crc32("AlfBjyxp",8) == 2294618783) strcat(s, "m");
if (crc32("vHpoHEWdfa",10) == 3476490010) strcat(s, "o");
if (crc32("GAdjdF",6) == 3315642622) strcat(s, "B");
if (crc32("JoYHez",6) == 1689645989) strcat(s, "n");
if (crc32("ZKxhtNIqYj",10) == 1113194582) strcat(s, "n");
if (crc32("IvVUsjoOEOUQbtK",15) == 743677302) strcat(s, "i");
if (crc32("wFdupUrrZOyAbQ",14) == 3877688595) strcat(s, "t");
if (crc32("zBKzN",5) == 2082865167) strcat(s, "o");
if (crc32("HXTEuEtDYwVyVx",14) == 327222219) strcat(s, "r");
    return s;
}

char *Badalona_nouns() {
    char *s = calloc(9);
    if (crc32("UwNFZhBJ",8) == 2195117296) strcat(s, "R");
if (crc32("pkrYNBpJcBydcO",14) == 2019125970) strcat(s, "B");
if (crc32("BoAJqmioeygmzv",14) == 3883941414) strcat(s, "a");
if (crc32("yazjjfXbViEESdq",15) == 1852698995) strcat(s, "y");
if (crc32("YRAyinXMgBiN",12) == 1938451232) strcat(s, "d");
if (crc32("osCeMdkFgBVNv",13) == 2200555043) strcat(s, "a");
if (crc32("eMBMZC",6) == 2940635235) strcat(s, "l");
if (crc32("BiDAeccuOBKcUHE",15) == 2671353567) strcat(s, "i");
if (crc32("UJsaekJmXzBab",13) == 4154544054) strcat(s, "o");
if (crc32("uBxmYeV",7) == 866942936) strcat(s, "B");
if (crc32("ustOiNGL",8) == 3933914718) strcat(s, "n");
if (crc32("YyCLn",5) == 1805969771) strcat(s, "U");
if (crc32("AXMTxB",6) == 5908910) strcat(s, "a");
    return s;
}

char *stonefly_nouns() {
    char *s = calloc(9);
    if (crc32("EbNOwtqK",8) == 1204649166) strcat(s, "Z");
if (crc32("gkmkDmyWQgPcT",13) == 3664811540) strcat(s, "s");
if (crc32("XTAnPmEnvZTN",12) == 809227783) strcat(s, "I");
if (crc32("UjypoZ",6) == 354295759) strcat(s, "t");
if (crc32("RAARmzyRYwYJ",12) == 3863759742) strcat(s, "o");
if (crc32("MpTqbnAqPnytk",13) == 3162297767) strcat(s, "n");
if (crc32("EdpDHC",6) == 1228716886) strcat(s, "e");
if (crc32("hurbIlerBpN",11) == 779085750) strcat(s, "f");
if (crc32("ZqiNKpSbSX",10) == 2339663590) strcat(s, "l");
if (crc32("KLZqud",6) == 2689215255) strcat(s, "y");
    return s;
}

char *campion_nouns() {
    char *s = calloc(8);
    if (crc32("bsmJaaukxdMaz",13) == 2881298244) strcat(s, "Q");
if (crc32("taLYQnANdOcV",12) == 4113348626) strcat(s, "c");
if (crc32("lZxaeHspe",9) == 3484776804) strcat(s, "a");
if (crc32("dPSCdE",6) == 957711635) strcat(s, "F");
if (crc32("bUXvyybzjIaoms",14) == 755355151) strcat(s, "m");
if (crc32("edFCrXjhKx",10) == 3445724876) strcat(s, "z");
if (crc32("WQDwrXgORUns",12) == 2173301332) strcat(s, "p");
if (crc32("yPkWVcerLhqW",12) == 2327784600) strcat(s, "p");
if (crc32("jAublJmuvi",10) == 2939626643) strcat(s, "i");
if (crc32("ZetWgPAGJaErlW",14) == 4023887978) strcat(s, "D");
if (crc32("IjaaRoqjnpaFXF",14) == 2284773948) strcat(s, "o");
if (crc32("JxFUjet",7) == 3148106925) strcat(s, "n");
    return s;
}

char *boon_nouns() {
    char *s = calloc(5);
    if (crc32("emDEeooEsOUjJaA",15) == 749198718) strcat(s, "b");
if (crc32("hSLjyDkMWPFikOT",15) == 3518230124) strcat(s, "u");
if (crc32("eMlmLUZpsUMVVbH",15) == 853926091) strcat(s, "o");
if (crc32("tAwsfqiEdVcj",12) == 1247126086) strcat(s, "o");
if (crc32("hGZfWYIpDnaUQkx",15) == 3460809002) strcat(s, "h");
if (crc32("yFXAPPMT",8) == 4207438661) strcat(s, "n");
    return s;
}

char *pneumatotherapy_nouns() {
    char *s = calloc(16);
    if (crc32("fkjbDXzkVuGB",12) == 421471207) strcat(s, "p");
if (crc32("zLLPs",5) == 3357972335) strcat(s, "p");
if (crc32("hWOvRzLO",8) == 2316265519) strcat(s, "n");
if (crc32("yxaBtWTUBK",10) == 1017669478) strcat(s, "k");
if (crc32("haznRmhtvsB",11) == 2665128747) strcat(s, "e");
if (crc32("xlVnRnBfkWdqns",14) == 4002448203) strcat(s, "j");
if (crc32("CBAUSTk",7) == 1494361597) strcat(s, "u");
if (crc32("sCgTpKt",7) == 954986569) strcat(s, "M");
if (crc32("TBWnzDOP",8) == 1070125244) strcat(s, "m");
if (crc32("VgQfqijkHrfTcAt",15) == 1086920536) strcat(s, "a");
if (crc32("xMNgcsbRzIliHuP",15) == 2134110202) strcat(s, "t");
if (crc32("PQoTOWcrYD",10) == 3842571514) strcat(s, "u");
if (crc32("GNAUu",5) == 3250689823) strcat(s, "o");
if (crc32("YiRJYZRzPBNrw",13) == 3586559675) strcat(s, "h");
if (crc32("giYdHxV",7) == 1722213678) strcat(s, "t");
if (crc32("nDkkGttFDEbqa",13) == 56938955) strcat(s, "h");
if (crc32("ePUNstz",7) == 1851795879) strcat(s, "h");
if (crc32("lGbLljGjr",9) == 3396222243) strcat(s, "s");
if (crc32("FvisufCoqRxvQs",14) == 1407834511) strcat(s, "e");
if (crc32("BxwNqd",6) == 3378939817) strcat(s, "P");
if (crc32("NvpZApcivNRNtuQ",15) == 1537540678) strcat(s, "r");
if (crc32("AxIMzcGu",8) == 115486202) strcat(s, "a");
if (crc32("jWCcJbFQ",8) == 2425417610) strcat(s, "p");
if (crc32("TNAPozDUc",9) == 1616297658) strcat(s, "y");
    return s;
}

char *Gora_nouns() {
    char *s = calloc(5);
    if (crc32("UUIPDj",6) == 2929738524) strcat(s, "G");
if (crc32("fhIVrNZQ",8) == 3018918265) strcat(s, "o");
if (crc32("OrLVNnaRAQnWaVw",15) == 3904063895) strcat(s, "f");
if (crc32("zddUmrLdVmiGWhR",15) == 1805956480) strcat(s, "r");
if (crc32("nFDYmpAEKCsOhn",14) == 3809732295) strcat(s, "a");
    return s;
}

char *Conral_nouns() {
    char *s = calloc(7);
    if (crc32("HTYWGxaGoUXFCDf",15) == 2381230788) strcat(s, "C");
if (crc32("gFMpYCU",7) == 1645794434) strcat(s, "o");
if (crc32("ePXHEOSW",8) == 3612720855) strcat(s, "z");
if (crc32("HvEOXhUjFXgxwUC",15) == 1623369825) strcat(s, "n");
if (crc32("HZguQ",5) == 1142865810) strcat(s, "l");
if (crc32("NOcaplaPkofcU",13) == 1065344620) strcat(s, "r");
if (crc32("TDZdEYR",7) == 2157278320) strcat(s, "a");
if (crc32("ZwzJu",5) == 2428620408) strcat(s, "h");
if (crc32("kUHNuY",6) == 1197058682) strcat(s, "l");
    return s;
}

char *banderilla_nouns() {
    char *s = calloc(11);
    if (crc32("LAmCcZxPdJ",10) == 964970722) strcat(s, "b");
if (crc32("apLjdVlUQJ",10) == 1994397624) strcat(s, "a");
if (crc32("hRtjcJFBHjxBvli",15) == 3707534719) strcat(s, "Z");
if (crc32("YgWqB",5) == 2463483171) strcat(s, "n");
if (crc32("NFEXCiH",7) == 940224095) strcat(s, "z");
if (crc32("YxtnbiwCG",9) == 2853886256) strcat(s, "d");
if (crc32("YoyCgsPrKvvkE",13) == 3843678813) strcat(s, "e");
if (crc32("PKozepItwZil",12) == 2374724940) strcat(s, "n");
if (crc32("RlPXbqvbArOA",12) == 1702523943) strcat(s, "r");
if (crc32("XOpvuFCYzwY",11) == 3112113609) strcat(s, "i");
if (crc32("zlHTUqs",7) == 334598189) strcat(s, "l");
if (crc32("WngRUAFZ",8) == 377289033) strcat(s, "l");
if (crc32("RuCYmcsFjom",11) == 1818907006) strcat(s, "L");
if (crc32("rQghb",5) == 1971392523) strcat(s, "a");
    return s;
}

char *rangefinder_nouns() {
    char *s = calloc(12);
    if (crc32("ApqSOC",6) == 302423088) strcat(s, "E");
if (crc32("opZvhDEYeGA",11) == 702052755) strcat(s, "r");
if (crc32("mIJKMifghexLS",13) == 424393499) strcat(s, "N");
if (crc32("IGVhmOzQCX",10) == 2836906098) strcat(s, "a");
if (crc32("TVrGkdK",7) == 2985113697) strcat(s, "n");
if (crc32("hCCvWZveuyJJ",12) == 3997219644) strcat(s, "k");
if (crc32("yKJPMYeUplGfck",14) == 3098954402) strcat(s, "g");
if (crc32("SUzcPCxr",8) == 1534136755) strcat(s, "e");
if (crc32("BvkDzkKuTXY",11) == 1067238937) strcat(s, "f");
if (crc32("DBSHXY",6) == 3235684552) strcat(s, "i");
if (crc32("FidqKaQCbkojUa",14) == 1826744734) strcat(s, "G");
if (crc32("acHRSseg",8) == 649470146) strcat(s, "n");
if (crc32("AlyGSnMfLnSqi",13) == 268086278) strcat(s, "Y");
if (crc32("tpanpeUe",8) == 2613907562) strcat(s, "d");
if (crc32("hIFii",5) == 2100962374) strcat(s, "e");
if (crc32("DSKmAfwjmho",11) == 1535291997) strcat(s, "r");
    return s;
}

char *catercousin_nouns() {
    char *s = calloc(12);
    if (crc32("ZQyrkG",6) == 1984658211) strcat(s, "i");
if (crc32("aAWEVpmVayXKMl",14) == 1141047987) strcat(s, "c");
if (crc32("baOdALrkjQuyP",13) == 965157833) strcat(s, "Q");
if (crc32("SrFXCqYWmVqtwja",15) == 1465552951) strcat(s, "a");
if (crc32("rZDyHdwso",9) == 2183131956) strcat(s, "e");
if (crc32("QUckxgZsJiS",11) == 2682936968) strcat(s, "t");
if (crc32("CMaQwBfscQWoT",13) == 3060431777) strcat(s, "e");
if (crc32("vgnuEEWvtQhxXeH",15) == 721909606) strcat(s, "r");
if (crc32("supXZGQLtnPR",12) == 992271541) strcat(s, "T");
if (crc32("lxsVdTG",7) == 531534781) strcat(s, "c");
if (crc32("tJjAyYIz",8) == 2240717238) strcat(s, "o");
if (crc32("tjxoX",5) == 2517702379) strcat(s, "T");
if (crc32("UXiNpao",7) == 380626873) strcat(s, "u");
if (crc32("UiSHRXrzt",9) == 2046423981) strcat(s, "s");
if (crc32("bxzphNP",7) == 930265685) strcat(s, "O");
if (crc32("ukXrK",5) == 2241795268) strcat(s, "i");
if (crc32("tIEIbhFecVfsDM",14) == 4106348780) strcat(s, "n");
    return s;
}

char *Laddy_nouns() {
    char *s = calloc(6);
    if (crc32("AElZAVqM",8) == 3999483727) strcat(s, "L");
if (crc32("adKOWUXUAvTc",12) == 1485176271) strcat(s, "i");
if (crc32("tKDhOUDPR",9) == 91225097) strcat(s, "a");
if (crc32("jEIJHqemOeCy",12) == 1783942683) strcat(s, "c");
if (crc32("pOsCk",5) == 2869177766) strcat(s, "d");
if (crc32("llUvSeKZRuv",11) == 2985972923) strcat(s, "h");
if (crc32("PvUuIBRyNlhA",12) == 1913377906) strcat(s, "d");
if (crc32("mWXyb",5) == 3467955769) strcat(s, "y");
    return s;
}

char *quebrada_nouns() {
    char *s = calloc(9);
    if (crc32("WHyWzrgLzTkCnzX",15) == 658864737) strcat(s, "q");
if (crc32("hgrJotZN",8) == 1879212272) strcat(s, "e");
if (crc32("vakvtuRozv",10) == 3192160155) strcat(s, "u");
if (crc32("qNGfnM",6) == 804599293) strcat(s, "e");
if (crc32("eAIYFtNVrQtW",12) == 125630991) strcat(s, "b");
if (crc32("rnyeVImGSKmNqC",14) == 1966481560) strcat(s, "r");
if (crc32("iJmxosgtQpFL",12) == 482857547) strcat(s, "N");
if (crc32("OMzoMSKCvqni",12) == 1213300720) strcat(s, "a");
if (crc32("WnvUHjMkeR",10) == 3295988514) strcat(s, "u");
if (crc32("XWyQNdiORRH",11) == 2013824255) strcat(s, "d");
if (crc32("immfmHhPJJvql",13) == 1348692115) strcat(s, "a");
    return s;
}

char *era_nouns() {
    char *s = calloc(4);
    if (crc32("bSUxuvd",7) == 883417513) strcat(s, "e");
if (crc32("APkaWFu",7) == 4049152635) strcat(s, "r");
if (crc32("JvFotYOdANhzEeb",15) == 854535722) strcat(s, "S");
if (crc32("QdzXHSTVV",9) == 3408122270) strcat(s, "a");
    return s;
}

char *Pushtu_nouns() {
    char *s = calloc(7);
    if (crc32("CiryZhCYrzg",11) == 2350160254) strcat(s, "T");
if (crc32("apOAY",5) == 2304529557) strcat(s, "P");
if (crc32("ChncvdRIv",9) == 1656911246) strcat(s, "u");
if (crc32("PaTEt",5) == 692357480) strcat(s, "v");
if (crc32("htEDOdkOZeFf",12) == 1058480466) strcat(s, "s");
if (crc32("dXOEcIGkO",9) == 2711805240) strcat(s, "h");
if (crc32("lEaNZRtiwqhP",12) == 823700649) strcat(s, "N");
if (crc32("xWOachkdbjXni",13) == 3122092068) strcat(s, "t");
if (crc32("GSvpohENKkjU",12) == 2165073790) strcat(s, "U");
if (crc32("JMFmcUhIYmwXOR",14) == 14824005) strcat(s, "u");
    return s;
}

char *serotherapist_nouns() {
    char *s = calloc(14);
    if (crc32("JxNPKEEC",8) == 1462108330) strcat(s, "s");
if (crc32("dleKOphkYYbQ",12) == 615906957) strcat(s, "D");
if (crc32("wEOVIIFKGaS",11) == 3478967513) strcat(s, "e");
if (crc32("NGoAGLEcEWugaS",14) == 64966799) strcat(s, "r");
if (crc32("mxGBZMUG",8) == 849562053) strcat(s, "o");
if (crc32("VCQUpbJODl",10) == 3238134354) strcat(s, "W");
if (crc32("uopaNtwx",8) == 1167054352) strcat(s, "t");
if (crc32("HKNny",5) == 100044048) strcat(s, "M");
if (crc32("DKXnRCRkJYXVTSo",15) == 2241123578) strcat(s, "h");
if (crc32("gjSyavCOKWKEE",13) == 3338434314) strcat(s, "l");
if (crc32("ClhDsUQDbeXzKWl",15) == 3089885841) strcat(s, "e");
if (crc32("oLXsAtwuoKdemM",14) == 1097301637) strcat(s, "r");
if (crc32("BjWcEvtnEEoYEXa",15) == 777050950) strcat(s, "a");
if (crc32("onItBKGs",8) == 3730485951) strcat(s, "V");
if (crc32("krgatfUa",8) == 2005515039) strcat(s, "p");
if (crc32("ZIRHPmRN",8) == 3413753385) strcat(s, "i");
if (crc32("viqzrrHbtm",10) == 1755604435) strcat(s, "s");
if (crc32("LNqMYrXjC",9) == 4248625133) strcat(s, "t");
    return s;
}

char *icebox_nouns() {
    char *s = calloc(7);
    if (crc32("LXKwePWPA",9) == 1074525132) strcat(s, "i");
if (crc32("BMivUrqxuZwo",12) == 2097268901) strcat(s, "k");
if (crc32("jXePPopTkMqjHJr",15) == 3502298522) strcat(s, "c");
if (crc32("wtcTHNMigJxgzjB",15) == 1917631272) strcat(s, "K");
if (crc32("JVRVeIVfJGFgyMK",15) == 923006878) strcat(s, "e");
if (crc32("SJzXMyxzBSMP",12) == 3256265762) strcat(s, "b");
if (crc32("OdokYo",6) == 1694330079) strcat(s, "L");
if (crc32("acrMKzaNN",9) == 2792257546) strcat(s, "o");
if (crc32("VEpKHuvInPUheP",14) == 807249799) strcat(s, "x");
    return s;
}

char *lawmaking_nouns() {
    char *s = calloc(10);
    if (crc32("ljuWA",5) == 1751149080) strcat(s, "l");
if (crc32("cGjke",5) == 3772969801) strcat(s, "a");
if (crc32("qvEyNImjMnD",11) == 1940990427) strcat(s, "w");
if (crc32("JiRLig",6) == 3071872646) strcat(s, "J");
if (crc32("ZquBZUTKwkpzUX",14) == 408622053) strcat(s, "m");
if (crc32("NUmHJSSLVSB",11) == 1294654345) strcat(s, "X");
if (crc32("ZIioOKFiPE",10) == 428770003) strcat(s, "a");
if (crc32("xQRlijwdbywo",12) == 3125751304) strcat(s, "n");
if (crc32("cRsdKghBePhJEiO",15) == 2284334938) strcat(s, "k");
if (crc32("wrqwkiFyLAiNEC",14) == 1730875259) strcat(s, "u");
if (crc32("bkBGNdEa",8) == 1437657586) strcat(s, "i");
if (crc32("yUMdEkD",7) == 4176208283) strcat(s, "Z");
if (crc32("rHske",5) == 4143367634) strcat(s, "n");
if (crc32("BNgTN",5) == 2649881176) strcat(s, "g");
    return s;
}

char *sarcasm_nouns() {
    char *s = calloc(8);
    if (crc32("yLXEN",5) == 2083435157) strcat(s, "W");
if (crc32("VkNMJ",5) == 881624184) strcat(s, "s");
if (crc32("qCvJnXIqSP",10) == 3826625441) strcat(s, "a");
if (crc32("azqCNGkRzWo",11) == 2460939279) strcat(s, "x");
if (crc32("hoKwxZqG",8) == 612573578) strcat(s, "r");
if (crc32("qOqleve",7) == 2526969840) strcat(s, "c");
if (crc32("DZLYwKsgd",9) == 948470354) strcat(s, "a");
if (crc32("oPzGiFDDJDIlJqe",15) == 2465893927) strcat(s, "s");
if (crc32("DUPUbc",6) == 4159861596) strcat(s, "m");
    return s;
}

char *depolarizer_nouns() {
    char *s = calloc(12);
    if (crc32("RXTLHkD",7) == 3174229441) strcat(s, "N");
if (crc32("OKaMONccxSeBg",13) == 1761294458) strcat(s, "d");
if (crc32("bMsXusvjnvNYj",13) == 1286642537) strcat(s, "k");
if (crc32("ULIHoLGh",8) == 1561319091) strcat(s, "e");
if (crc32("iPpIvKBYaOtQjVY",15) == 1391493409) strcat(s, "S");
if (crc32("aeuBYHJrduH",11) == 4282212189) strcat(s, "p");
if (crc32("aYHgXQL",7) == 2210279248) strcat(s, "S");
if (crc32("JMnuW",5) == 1477548251) strcat(s, "o");
if (crc32("zjfKYnnjcYBJFzb",15) == 3204848703) strcat(s, "m");
if (crc32("DvohJE",6) == 2050528235) strcat(s, "l");
if (crc32("ITsjHNHerctLk",13) == 1717834637) strcat(s, "Y");
if (crc32("NTvPGPrfAAzYA",13) == 3885047907) strcat(s, "a");
if (crc32("qZFtGkwtNJIuXNA",15) == 1941636344) strcat(s, "r");
if (crc32("HlacLcSGoe",10) == 2809640435) strcat(s, "i");
if (crc32("FIolDrhLgp",10) == 2914181770) strcat(s, "z");
if (crc32("GBOfEZRZfIKQ",12) == 1243116007) strcat(s, "e");
if (crc32("xsXmJUZwH",9) == 3867163582) strcat(s, "t");
if (crc32("lqKUiWtfofhz",12) == 2856458850) strcat(s, "r");
    return s;
}

char *Placido_nouns() {
    char *s = calloc(8);
    if (crc32("kfCIx",5) == 993273669) strcat(s, "P");
if (crc32("GmMVGvNPqlzt",12) == 1313709846) strcat(s, "C");
if (crc32("YUbfrJM",7) == 3746775088) strcat(s, "l");
if (crc32("piOFhc",6) == 3762147594) strcat(s, "a");
if (crc32("EFYstGpvbndznqY",15) == 3257112575) strcat(s, "c");
if (crc32("JPnrCCt",7) == 1845403188) strcat(s, "n");
if (crc32("nkeaRgl",7) == 4145960393) strcat(s, "i");
if (crc32("gqprMqmvcANAYy",14) == 2407744566) strcat(s, "V");
if (crc32("RtDGqcDoTro",11) == 3039377266) strcat(s, "d");
if (crc32("GoXscBThksVVi",13) == 2498606944) strcat(s, "o");
if (crc32("mwJiJPuNxjM",11) == 198910882) strcat(s, "o");
    return s;
}

char *nonredemption_nouns() {
    char *s = calloc(14);
    if (crc32("GxnaSIp",7) == 1097684982) strcat(s, "n");
if (crc32("BostDCstdAgQlM",14) == 4079641560) strcat(s, "o");
if (crc32("wiStHgnEeon",11) == 470248668) strcat(s, "n");
if (crc32("pvEQtgi",7) == 49789543) strcat(s, "r");
if (crc32("yYozjuetCmQDfls",15) == 3087131401) strcat(s, "E");
if (crc32("HlgAKIc",7) == 348854731) strcat(s, "e");
if (crc32("OKhuARoeq",9) == 3603266075) strcat(s, "e");
if (crc32("kwMCvndselCbNFN",15) == 3867742894) strcat(s, "d");
if (crc32("OsfiLtcPAx",10) == 666614220) strcat(s, "L");
if (crc32("NzYmAGWGxckIhA",14) == 4061404443) strcat(s, "e");
if (crc32("CYbnUkTnNjFl",12) == 1447829195) strcat(s, "c");
if (crc32("ymLfJeAcUCP",11) == 3403233238) strcat(s, "m");
if (crc32("wwUTvDdigG",10) == 3637265528) strcat(s, "f");
if (crc32("oMIrL",5) == 2836805601) strcat(s, "p");
if (crc32("MVrqZSwA",8) == 3188215925) strcat(s, "t");
if (crc32("MSwAtGsXrDD",11) == 1575842856) strcat(s, "i");
if (crc32("tIrDR",5) == 153606838) strcat(s, "O");
if (crc32("oopmLFGnFknYo",13) == 228972562) strcat(s, "o");
if (crc32("pxjXwVr",7) == 3564218151) strcat(s, "n");
if (crc32("dckPqX",6) == 792342193) strcat(s, "n");
    return s;
}

char *hypermetamorphosis_nouns() {
    char *s = calloc(19);
    if (crc32("BYtqkie",7) == 757217401) strcat(s, "b");
if (crc32("CNWwCYJsQZzffc",14) == 3773209225) strcat(s, "h");
if (crc32("Rcvqw",5) == 297761205) strcat(s, "x");
if (crc32("hMWzPiEDrrGfck",14) == 1137493098) strcat(s, "y");
if (crc32("TFqJBAwoxQL",11) == 1704036750) strcat(s, "i");
if (crc32("QpxTL",5) == 1395727865) strcat(s, "p");
if (crc32("nkMXkRDaGCRP",12) == 4112804016) strcat(s, "e");
if (crc32("PoUqwrc",7) == 4234631495) strcat(s, "r");
if (crc32("KRRjO",5) == 4222018034) strcat(s, "h");
if (crc32("TByhlhB",7) == 1980569528) strcat(s, "m");
if (crc32("gyyGjFUYUPpTZz",14) == 398622522) strcat(s, "e");
if (crc32("nECjgzlD",8) == 2874188558) strcat(s, "t");
if (crc32("zepnIOZZH",9) == 183887986) strcat(s, "a");
if (crc32("UgdyJedBfU",10) == 3104404281) strcat(s, "m");
if (crc32("VrIupLnKWUqJ",12) == 2316050001) strcat(s, "B");
if (crc32("LZubmyHlxOHXg",13) == 1734472334) strcat(s, "o");
if (crc32("deARpLnMkOAydO",14) == 3585798749) strcat(s, "r");
if (crc32("UkiLzr",6) == 4269337812) strcat(s, "h");
if (crc32("IvbBiUZVKTFjr",13) == 3805938973) strcat(s, "p");
if (crc32("SkOLePsCdlMfhr",14) == 2818551541) strcat(s, "q");
if (crc32("idrjzRafvbVgLg",14) == 485850674) strcat(s, "h");
if (crc32("YVtQovDNrGl",11) == 852069915) strcat(s, "o");
if (crc32("tbPydOs",7) == 1089890980) strcat(s, "Q");
if (crc32("YcannJRoF",9) == 3119150534) strcat(s, "s");
if (crc32("eBkFTinOJzwFOtG",15) == 3593611975) strcat(s, "i");
if (crc32("RkyXeIfU",8) == 2227909610) strcat(s, "s");
    return s;
}

char *protozoon_nouns() {
    char *s = calloc(10);
    if (crc32("WiAPgskOwLYgY",13) == 2283954149) strcat(s, "p");
if (crc32("IkszttlI",8) == 2507715433) strcat(s, "p");
if (crc32("uogdg",5) == 2738407536) strcat(s, "P");
if (crc32("FCkfCBdSBkWF",12) == 1792372336) strcat(s, "r");
if (crc32("QiIUfBRyFEzqzyl",15) == 1784640743) strcat(s, "o");
if (crc32("hWbCb",5) == 3105235854) strcat(s, "A");
if (crc32("gensVqCjTazCe",13) == 2667869673) strcat(s, "t");
if (crc32("sDpmeSl",7) == 2134227084) strcat(s, "o");
if (crc32("feQoheYxJ",9) == 2588108833) strcat(s, "z");
if (crc32("bAksTCgkAhY",11) == 3104242352) strcat(s, "o");
if (crc32("mtZyNQzlOmJXhj",14) == 1590108846) strcat(s, "o");
if (crc32("xkvhqheD",8) == 425846561) strcat(s, "U");
if (crc32("ExsozKfJAGknf",13) == 3843983586) strcat(s, "n");
    return s;
}

char *approachability_nouns() {
    char *s = calloc(16);
    if (crc32("ABOCUTKGknwhbkY",15) == 2278566424) strcat(s, "n");
if (crc32("DOGAJkVqR",9) == 4118158941) strcat(s, "a");
if (crc32("dQXnJhxyDa",10) == 2929063049) strcat(s, "u");
if (crc32("PkJasYehTPK",11) == 75648395) strcat(s, "p");
if (crc32("KHMxfll",7) == 604788456) strcat(s, "S");
if (crc32("EBlmVlXoDGZQHe",14) == 950294901) strcat(s, "p");
if (crc32("iaNAjzho",8) == 287403559) strcat(s, "n");
if (crc32("ILvbbsc",7) == 1210190525) strcat(s, "r");
if (crc32("CIFuWGJddM",10) == 2177316162) strcat(s, "q");
if (crc32("ZRUAkz",6) == 3847627952) strcat(s, "o");
if (crc32("vOkBlu",6) == 3221489747) strcat(s, "a");
if (crc32("TnWaJMdrJpqj",12) == 4238082421) strcat(s, "O");
if (crc32("skCqEnmaTvGnU",13) == 1768678593) strcat(s, "c");
if (crc32("UsSXhj",6) == 3903263829) strcat(s, "h");
if (crc32("DlScTzgPIWvxpIe",15) == 3532444410) strcat(s, "M");
if (crc32("qjhBaqu",7) == 3105745140) strcat(s, "a");
if (crc32("XrywMyTDEgljB",13) == 1902686967) strcat(s, "n");
if (crc32("GMRtrza",7) == 2979551959) strcat(s, "b");
if (crc32("hHkvkkPqqUUqWr",14) == 4235365028) strcat(s, "i");
if (crc32("iKlrvfIS",8) == 3245966628) strcat(s, "l");
if (crc32("kChesl",6) == 1010478530) strcat(s, "i");
if (crc32("TWBMNcgRfMcZG",13) == 1197971985) strcat(s, "G");
if (crc32("UnfhQOucbRS",11) == 3548838487) strcat(s, "t");
if (crc32("pqhhgwz",7) == 2073860327) strcat(s, "y");
    return s;
}

char *Mists_nouns() {
    char *s = calloc(6);
    if (crc32("tdMzsoYMZMbtoGV",15) == 2624353015) strcat(s, "M");
if (crc32("zvqccdP",7) == 3608751930) strcat(s, "R");
if (crc32("kzVfhLgso",9) == 1996547605) strcat(s, "i");
if (crc32("jrWzyxKOLEoftqc",15) == 3300729607) strcat(s, "X");
if (crc32("nolpbQeJUX",10) == 1469333701) strcat(s, "s");
if (crc32("IAgDnyESqTRslwz",15) == 1231301958) strcat(s, "x");
if (crc32("DUBriT",6) == 1806287081) strcat(s, "t");
if (crc32("hKjIbkyEclIY",12) == 3892650123) strcat(s, "s");
    return s;
}

char *Daladier_nouns() {
    char *s = calloc(9);
    if (crc32("qioxUwtLY",9) == 1073459478) strcat(s, "n");
if (crc32("nQnFWVyBQuGWpHm",15) == 116409177) strcat(s, "D");
if (crc32("hLZIDHs",7) == 3031361934) strcat(s, "s");
if (crc32("YhwxcKzPrKfSm",13) == 3925200842) strcat(s, "a");
if (crc32("ozriVUZnzFL",11) == 2663933004) strcat(s, "o");
if (crc32("mjvOaQIoA",9) == 816715165) strcat(s, "l");
if (crc32("vYTVcltRIA",10) == 786621650) strcat(s, "a");
if (crc32("PwTahtEU",8) == 300144461) strcat(s, "d");
if (crc32("yGhjXaQZhI",10) == 33078375) strcat(s, "R");
if (crc32("GiKoZeMCu",9) == 3520203329) strcat(s, "i");
if (crc32("dainRKh",7) == 580554411) strcat(s, "C");
if (crc32("QwfnoHqDdip",11) == 3387889528) strcat(s, "e");
if (crc32("silwKdgVeJFmoSm",15) == 677425944) strcat(s, "r");
    return s;
}

char *hothouse_nouns() {
    char *s = calloc(9);
    if (crc32("pdtGMyMvk",9) == 3900950683) strcat(s, "L");
if (crc32("MbibhZEqwmDeolE",15) == 3240084409) strcat(s, "h");
if (crc32("CbvHOZc",7) == 1789408439) strcat(s, "o");
if (crc32("dwIKhi",6) == 1791794677) strcat(s, "t");
if (crc32("FnCuOuglVg",10) == 3708628832) strcat(s, "d");
if (crc32("syJzW",5) == 867557161) strcat(s, "h");
if (crc32("ZHJKcaTV",8) == 2581026328) strcat(s, "S");
if (crc32("qLQRvzlGbyTSwf",14) == 3239459866) strcat(s, "o");
if (crc32("EiPRkmxqIpXCP",13) == 1440097744) strcat(s, "i");
if (crc32("suzgDBlhzKFAeN",14) == 3431441745) strcat(s, "u");
if (crc32("zWKOsliK",8) == 1598882855) strcat(s, "J");
if (crc32("zvWgwDQfoHY",11) == 2414117730) strcat(s, "s");
if (crc32("kttsCkMidyevdQ",14) == 3970480346) strcat(s, "f");
if (crc32("WnVoZWfvqHzbd",13) == 1508630108) strcat(s, "e");
    return s;
}

char *louver_nouns() {
    char *s = calloc(7);
    if (crc32("YShkXuvGIZkewYm",15) == 2437317594) strcat(s, "z");
if (crc32("UmwtB",5) == 2107800291) strcat(s, "l");
if (crc32("pVDgQGSx",8) == 631049064) strcat(s, "j");
if (crc32("qygKBFv",7) == 4026681773) strcat(s, "o");
if (crc32("MilKugoROD",10) == 1737144244) strcat(s, "w");
if (crc32("HCRbuYqj",8) == 3972161892) strcat(s, "u");
if (crc32("YVctUyT",7) == 2064935106) strcat(s, "V");
if (crc32("zYERaJKgFTBV",12) == 3042339428) strcat(s, "v");
if (crc32("HzySOrWh",8) == 2790110954) strcat(s, "e");
if (crc32("HRlazOjZvxpnoBt",15) == 3046946799) strcat(s, "V");
if (crc32("HIcxVSHajxF",11) == 1676095231) strcat(s, "r");
    return s;
}

char *cetaceum_nouns() {
    char *s = calloc(9);
    if (crc32("saZPor",6) == 205792831) strcat(s, "c");
if (crc32("bVOUABIQIKnRBfJ",15) == 449960332) strcat(s, "P");
if (crc32("oMXGwwVvMPfqO",13) == 1853549557) strcat(s, "e");
if (crc32("tQsyMoX",7) == 1475648490) strcat(s, "N");
if (crc32("ozbsQTgq",8) == 3389359156) strcat(s, "t");
if (crc32("EkwiUp",6) == 647154823) strcat(s, "a");
if (crc32("PnPAGrtNqlStbVG",15) == 3239726492) strcat(s, "c");
if (crc32("VsliIHa",7) == 1813348831) strcat(s, "D");
if (crc32("bOYRTQRocAwtO",13) == 1733344786) strcat(s, "e");
if (crc32("Lmrqk",5) == 187574812) strcat(s, "I");
if (crc32("gzVOnKEqO",9) == 2442222626) strcat(s, "u");
if (crc32("YXSzgF",6) == 3052065224) strcat(s, "O");
if (crc32("MkoOqfU",7) == 2130966420) strcat(s, "m");
    return s;
}

char *Cypro_nouns() {
    char *s = calloc(6);
    if (crc32("DpiFh",5) == 2720159822) strcat(s, "C");
if (crc32("IfeAqxscu",9) == 3439827095) strcat(s, "y");
if (crc32("ftfplSpDRHHCFg",14) == 4251750300) strcat(s, "X");
if (crc32("HZoGKzD",7) == 2190620989) strcat(s, "p");
if (crc32("vTtpkIlJ",8) == 2110484394) strcat(s, "r");
if (crc32("eBXhphSea",9) == 1347753711) strcat(s, "p");
if (crc32("qTsMrYT",7) == 3345652529) strcat(s, "o");
    return s;
}

char *myohemoglobinuria_nouns() {
    char *s = calloc(18);
    if (crc32("HOimfB",6) == 624880221) strcat(s, "m");
if (crc32("SRJHTXEktSc",11) == 3679982209) strcat(s, "y");
if (crc32("bCsDMfyVViuXfrb",15) == 994621614) strcat(s, "v");
if (crc32("VRniLkpmwogU",12) == 2926732281) strcat(s, "o");
if (crc32("fWPEJqEMkU",10) == 252126019) strcat(s, "U");
if (crc32("cGvRbAZgrkcXy",13) == 673786610) strcat(s, "h");
if (crc32("ohCkxJT",7) == 634694467) strcat(s, "D");
if (crc32("FbjWWf",6) == 3883027539) strcat(s, "e");
if (crc32("XephCLirpCC",11) == 1434748422) strcat(s, "m");
if (crc32("tjFBMptFS",9) == 2747516165) strcat(s, "o");
if (crc32("tuJQasIbHHoEndw",15) == 703849736) strcat(s, "x");
if (crc32("RkqZklC",7) == 1225322112) strcat(s, "g");
if (crc32("bxEUleLLQiJel",13) == 838460) strcat(s, "l");
if (crc32("BYRIDJ",6) == 3657626775) strcat(s, "o");
if (crc32("WwsVaKUubLRTeq",14) == 3143062155) strcat(s, "b");
if (crc32("dhBTtfEXkj",10) == 1253562088) strcat(s, "c");
if (crc32("xLKIGToMLs",10) == 3403626894) strcat(s, "i");
if (crc32("fusFlk",6) == 1088962592) strcat(s, "n");
if (crc32("iXNeM",5) == 911918953) strcat(s, "u");
if (crc32("FTuYvSHA",8) == 1400700866) strcat(s, "X");
if (crc32("sRhOGcDWS",9) == 3443038027) strcat(s, "r");
if (crc32("yfHfjSgQ",8) == 3654200388) strcat(s, "x");
if (crc32("LPszgqusJFXdFP",14) == 3836253665) strcat(s, "i");
if (crc32("QbCDMcYyMfNB",12) == 650723037) strcat(s, "a");
    return s;
}

char *quittor_nouns() {
    char *s = calloc(8);
    if (crc32("tbQUnFXsygZ",11) == 29536163) strcat(s, "q");
if (crc32("ZgbNFeZW",8) == 135427542) strcat(s, "u");
if (crc32("NfQrGNYCDgZu",12) == 2819515403) strcat(s, "i");
if (crc32("RwxgWaqSP",9) == 879036331) strcat(s, "p");
if (crc32("hdwLbPxVT",9) == 4139565241) strcat(s, "t");
if (crc32("ocuJORCGIPNdGe",14) == 1969936000) strcat(s, "p");
if (crc32("odbJEczfSxDaSt",14) == 630767798) strcat(s, "t");
if (crc32("wYeIpPQfgj",10) == 3950507958) strcat(s, "o");
if (crc32("fUkoTyxFmP",10) == 1305717975) strcat(s, "o");
if (crc32("udrPuMzbe",9) == 349989803) strcat(s, "r");
    return s;
}

char *parent_nouns() {
    char *s = calloc(7);
    if (crc32("jlRJbOL",7) == 996185235) strcat(s, "W");
if (crc32("PTEakcqEvGzi",12) == 30385291) strcat(s, "p");
if (crc32("ECfMepLOv",9) == 55860291) strcat(s, "a");
if (crc32("xwcqQEYRhha",11) == 1635944802) strcat(s, "r");
if (crc32("ObbgQmAmFGiZF",13) == 1529818836) strcat(s, "e");
if (crc32("eseBYPkM",8) == 243191577) strcat(s, "n");
if (crc32("PLxYzbgSZXbO",12) == 1623095321) strcat(s, "I");
if (crc32("GDaInbyazxp",11) == 2030547470) strcat(s, "t");
    return s;
}

char *lunch_nouns() {
    char *s = calloc(6);
    if (crc32("DdRzqFBnV",9) == 3923577258) strcat(s, "F");
if (crc32("oVKqubSQTnPk",12) == 563596529) strcat(s, "l");
if (crc32("LLXeASk",7) == 1483266287) strcat(s, "u");
if (crc32("feODOdUsp",9) == 1562969942) strcat(s, "v");
if (crc32("nIJieNc",7) == 3464630433) strcat(s, "n");
if (crc32("lvbVDtzoIslzN",13) == 2787504365) strcat(s, "S");
if (crc32("XGNjqgREA",9) == 808331377) strcat(s, "c");
if (crc32("pzBkcWNGR",9) == 1799786809) strcat(s, "z");
if (crc32("cOUfYZFGjHpnM",13) == 788247324) strcat(s, "h");
    return s;
}

char *squalor_nouns() {
    char *s = calloc(8);
    if (crc32("pyOePLyd",8) == 435259261) strcat(s, "s");
if (crc32("HpHQQcNqoq",10) == 323033800) strcat(s, "q");
if (crc32("ymUIxjiPE",9) == 3463441779) strcat(s, "u");
if (crc32("JAZVpLDlyKIoTNa",15) == 59504627) strcat(s, "N");
if (crc32("OsmXm",5) == 1684383037) strcat(s, "a");
if (crc32("KAWhxrh",7) == 1521923000) strcat(s, "L");
if (crc32("orPDQw",6) == 439160247) strcat(s, "l");
if (crc32("LsnBiK",6) == 702415199) strcat(s, "J");
if (crc32("RIwBwuRf",8) == 522773517) strcat(s, "o");
if (crc32("bOwRPrKFRTvK",12) == 969075614) strcat(s, "z");
if (crc32("jExdwWBHislW",12) == 3163855692) strcat(s, "r");
    return s;
}

char *asbestosis_nouns() {
    char *s = calloc(11);
    if (crc32("RoaTiXOOdThuZ",13) == 2422266903) strcat(s, "a");
if (crc32("nrBQfZvgbPtnpc",14) == 2777451611) strcat(s, "v");
if (crc32("yHlSZEaPKuUXIlZ",15) == 672732118) strcat(s, "s");
if (crc32("mubkMDrg",8) == 204072677) strcat(s, "Z");
if (crc32("FPUgrcLgCQDV",12) == 1315685489) strcat(s, "b");
if (crc32("LRXJQjwZ",8) == 3988467147) strcat(s, "O");
if (crc32("NPTJGFfAMB",10) == 1463943417) strcat(s, "e");
if (crc32("vjoclIbkNa",10) == 3375542249) strcat(s, "s");
if (crc32("MuqttYs",7) == 842903318) strcat(s, "t");
if (crc32("nAgaxdtsy",9) == 435407364) strcat(s, "o");
if (crc32("uvGMKQXOxeyw",12) == 2039419177) strcat(s, "Y");
if (crc32("UsNdPngKFz",10) == 3493232290) strcat(s, "s");
if (crc32("nfHfnYyCklfM",12) == 1991330127) strcat(s, "i");
if (crc32("ROlkIPvLXV",10) == 1130261622) strcat(s, "s");
if (crc32("itDEfnbIsppLF",13) == 603287686) strcat(s, "s");
    return s;
}

char *megalopsia_nouns() {
    char *s = calloc(11);
    if (crc32("LEFEgsJjrwIy",12) == 2087702906) strcat(s, "j");
if (crc32("qFTgYpVMJY",10) == 2493696712) strcat(s, "m");
if (crc32("XpcybhnQXmnnh",13) == 577152656) strcat(s, "p");
if (crc32("ZoWfKgOmSWEO",12) == 1684581198) strcat(s, "e");
if (crc32("vmqPvianFqTOp",13) == 1046701432) strcat(s, "g");
if (crc32("yhhKZzhpwT",10) == 4002483037) strcat(s, "L");
if (crc32("tZxpgzkic",9) == 1351865756) strcat(s, "a");
if (crc32("slXOBQUghewvV",13) == 3693157052) strcat(s, "p");
if (crc32("UADHlBEv",8) == 1347713448) strcat(s, "l");
if (crc32("kWRZcNqfxjGCI",13) == 3518659104) strcat(s, "o");
if (crc32("mIetUnjvLFE",11) == 2851859378) strcat(s, "N");
if (crc32("WkrFVGugsd",10) == 3228193116) strcat(s, "p");
if (crc32("kcjiGpaUw",9) == 3686440014) strcat(s, "n");
if (crc32("PbbagWvUE",9) == 903538567) strcat(s, "s");
if (crc32("pyoGlBRKCasZ",12) == 893571013) strcat(s, "i");
if (crc32("qczBn",5) == 438364881) strcat(s, "a");
    return s;
}

char *Cleopatre_nouns() {
    char *s = calloc(10);
    if (crc32("BLirxJkCV",9) == 273584864) strcat(s, "C");
if (crc32("mKdAmEuufi",10) == 578107833) strcat(s, "W");
if (crc32("wHbQRsjxIORMy",13) == 2208050182) strcat(s, "l");
if (crc32("BptNXVYNqmYB",12) == 3618142186) strcat(s, "V");
if (crc32("oedEgFopVeIZr",13) == 2500543422) strcat(s, "e");
if (crc32("ExfAKBEZ",8) == 4211763648) strcat(s, "O");
if (crc32("GCsviAldNxLa",12) == 2538602474) strcat(s, "o");
if (crc32("WlsbQAz",7) == 532267024) strcat(s, "p");
if (crc32("voFJdVMeqlY",11) == 1040076758) strcat(s, "N");
if (crc32("HJkRaLX",7) == 3150197959) strcat(s, "a");
if (crc32("qVhDX",5) == 3774654664) strcat(s, "t");
if (crc32("WGiLxXIMmpvTUJI",15) == 3370424269) strcat(s, "t");
if (crc32("REcNtZaCR",9) == 3944392819) strcat(s, "r");
if (crc32("lTUXbar",7) == 831619392) strcat(s, "e");
    return s;
}

char *disconsolateness_nouns() {
    char *s = calloc(17);
    if (crc32("oBZxmau",7) == 4198099729) strcat(s, "S");
if (crc32("DYNWbZEuViBxO",13) == 1949140681) strcat(s, "d");
if (crc32("mlxVTYLicLO",11) == 1755499263) strcat(s, "Z");
if (crc32("eDjmlZVBrzfC",12) == 2054946564) strcat(s, "i");
if (crc32("BjGEHHstEO",10) == 1571148872) strcat(s, "v");
if (crc32("EGwaipQ",7) == 624950262) strcat(s, "s");
if (crc32("VcOyIuyg",8) == 2125836871) strcat(s, "Z");
if (crc32("QEprignFGJNyCs",14) == 2365460706) strcat(s, "c");
if (crc32("aumIQYEAIBefcl",14) == 3463789384) strcat(s, "v");
if (crc32("tesZjwBrv",9) == 1371777173) strcat(s, "o");
if (crc32("nnUjZSwbreB",11) == 3752479948) strcat(s, "n");
if (crc32("xoXlFaT",7) == 1940684474) strcat(s, "c");
if (crc32("usmXCGlC",8) == 988957362) strcat(s, "s");
if (crc32("LDbaxXBWqhcW",12) == 3748230269) strcat(s, "M");
if (crc32("hPXEmwkylbdmXw",14) == 1794879191) strcat(s, "o");
if (crc32("KtOAMvhyYVLH",12) == 1866676653) strcat(s, "l");
if (crc32("iwePlolYGylZyr",14) == 860000077) strcat(s, "l");
if (crc32("cndDGiyPL",9) == 2400091830) strcat(s, "N");
if (crc32("DUiPcwElxZZid",13) == 481465408) strcat(s, "a");
if (crc32("pZqTCVTGDwQHR",13) == 3843785003) strcat(s, "Y");
if (crc32("VGiOtodqAehHKO",14) == 3156353865) strcat(s, "t");
if (crc32("vPVYIfD",7) == 1183624846) strcat(s, "b");
if (crc32("hYpHgusTgtBIL",13) == 4256494986) strcat(s, "e");
if (crc32("ozlqY",5) == 3164390618) strcat(s, "n");
if (crc32("EVvYhbTRnC",10) == 2122986799) strcat(s, "e");
if (crc32("JqkrF",5) == 3252071196) strcat(s, "s");
if (crc32("PfeViKABzJlEhP",14) == 553420227) strcat(s, "A");
if (crc32("QpNRmQHTaBBYdfY",15) == 1911315744) strcat(s, "s");
    return s;
}

char *ouphe_nouns() {
    char *s = calloc(6);
    if (crc32("jrVaUOCv",8) == 1371067270) strcat(s, "U");
if (crc32("mFxRWgHmk",9) == 1651385252) strcat(s, "o");
if (crc32("xQjnJCzHwWv",11) == 3148832726) strcat(s, "Z");
if (crc32("IFYaNYvongKJuTY",15) == 791436175) strcat(s, "u");
if (crc32("AjvoxbMevfWTYZ",14) == 3678850643) strcat(s, "p");
if (crc32("uEAvoYLm",8) == 3150741678) strcat(s, "A");
if (crc32("KCBIqqVoIlRzGMb",15) == 3690054928) strcat(s, "h");
if (crc32("uRQyvNCOzI",10) == 1564308584) strcat(s, "e");
    return s;
}

char *vineyard_nouns() {
    char *s = calloc(9);
    if (crc32("zlxgTs",6) == 3010590792) strcat(s, "v");
if (crc32("lfYBL",5) == 1525018765) strcat(s, "i");
if (crc32("bpUxlNKqFyQp",12) == 1904184285) strcat(s, "n");
if (crc32("XUTylHIxhrHo",12) == 4188761105) strcat(s, "e");
if (crc32("AuzMCtrZTkMD",12) == 774336547) strcat(s, "y");
if (crc32("hgOqpcoPeNXKR",13) == 1520211938) strcat(s, "a");
if (crc32("XfLczCgaZzNK",12) == 2399578723) strcat(s, "M");
if (crc32("FETShVwDLnzJE",13) == 4207996597) strcat(s, "r");
if (crc32("QuVZWnXDr",9) == 2482724737) strcat(s, "d");
    return s;
}

char *veratridine_nouns() {
    char *s = calloc(12);
    if (crc32("RTKPDYX",7) == 757058520) strcat(s, "G");
if (crc32("uotRKATchlO",11) == 1907711324) strcat(s, "v");
if (crc32("BqebmlzhQK",10) == 4068422603) strcat(s, "e");
if (crc32("MxFMlguaQxwheXH",15) == 4272008320) strcat(s, "y");
if (crc32("aWsPXoND",8) == 2026722435) strcat(s, "r");
if (crc32("NxshGJ",6) == 1531806999) strcat(s, "a");
if (crc32("BDOtL",5) == 3214428394) strcat(s, "t");
if (crc32("bwqntJvwF",9) == 3806766968) strcat(s, "K");
if (crc32("WrnATftmILRnr",13) == 4215118272) strcat(s, "r");
if (crc32("QvkcrJdu",8) == 1383231541) strcat(s, "i");
if (crc32("FvOMj",5) == 3434337863) strcat(s, "d");
if (crc32("LtjpitFxx",9) == 1862384840) strcat(s, "i");
if (crc32("kliiuNalkqQCPec",15) == 1975987511) strcat(s, "Z");
if (crc32("caNIucuZBBuLzD",14) == 1896733035) strcat(s, "n");
if (crc32("QFqiOHIBU",9) == 157376020) strcat(s, "n");
if (crc32("RxCIQWDxyHLlEDL",15) == 1885529171) strcat(s, "e");
    return s;
}

char *Sammie_nouns() {
    char *s = calloc(7);
    if (crc32("ViiyWfji",8) == 989250711) strcat(s, "g");
if (crc32("hkJPQOKGmIIf",12) == 1247427188) strcat(s, "S");
if (crc32("IhXPAjyGbtm",11) == 1002634697) strcat(s, "c");
if (crc32("oljPZctw",8) == 3666897610) strcat(s, "a");
if (crc32("pCVgdKsUQDlX",12) == 2935608902) strcat(s, "h");
if (crc32("NoeUd",5) == 2175529979) strcat(s, "m");
if (crc32("BXxpvPsXz",9) == 4166785864) strcat(s, "F");
if (crc32("RhjWPrmjxTpHV",13) == 502411558) strcat(s, "m");
if (crc32("JDOWDFLcBwStqO",14) == 2385817714) strcat(s, "u");
if (crc32("kexHTUEp",8) == 1305223728) strcat(s, "i");
if (crc32("EIyheV",6) == 1908743913) strcat(s, "e");
    return s;
}

char *ovariectomy_nouns() {
    char *s = calloc(12);
    if (crc32("tUXWegslUpZEKVp",15) == 767363957) strcat(s, "d");
if (crc32("ceNYXByHVazXR",13) == 1877143401) strcat(s, "o");
if (crc32("qjQiqyhGiYzxR",13) == 3652211835) strcat(s, "v");
if (crc32("KLaONUepPivCvHe",15) == 4173546242) strcat(s, "R");
if (crc32("DvNVn",5) == 434823315) strcat(s, "a");
if (crc32("gTLrwY",6) == 2648615568) strcat(s, "r");
if (crc32("eSnnleYLORbuZ",13) == 1598600820) strcat(s, "i");
if (crc32("vjZHG",5) == 3712022925) strcat(s, "L");
if (crc32("dCufRo",6) == 2026859093) strcat(s, "e");
if (crc32("ZLMSQZZ",7) == 2181714446) strcat(s, "m");
if (crc32("fnLWZKMsAd",10) == 768641481) strcat(s, "c");
if (crc32("fmYoFykp",8) == 2591520189) strcat(s, "t");
if (crc32("IqnPxvWotR",10) == 3438547463) strcat(s, "o");
if (crc32("QXLtMDPKAPvBub",14) == 2283625797) strcat(s, "o");
if (crc32("myejVLze",8) == 3938066819) strcat(s, "u");
if (crc32("RmpIqJBGaEjWG",13) == 2181310292) strcat(s, "m");
if (crc32("hamUKkJsj",9) == 3165491305) strcat(s, "y");
    return s;
}

char *Joann_nouns() {
    char *s = calloc(6);
    if (crc32("kmrcsP",6) == 2745109543) strcat(s, "A");
if (crc32("iopHzUmSaNXeX",13) == 2007489440) strcat(s, "J");
if (crc32("NBakDB",6) == 3622959465) strcat(s, "s");
if (crc32("AWfdCvrdNflad",13) == 2888429009) strcat(s, "o");
if (crc32("lrEcOjwPrf",10) == 2944919833) strcat(s, "I");
if (crc32("czaVpXEXhH",10) == 4170486823) strcat(s, "a");
if (crc32("irHha",5) == 2049893935) strcat(s, "n");
if (crc32("icaOKXRL",8) == 3093419508) strcat(s, "i");
if (crc32("hWFvohhpUigyVrR",15) == 388280461) strcat(s, "n");
    return s;
}

char *autochthonism_nouns() {
    char *s = calloc(14);
    if (crc32("RUtEO",5) == 1799380018) strcat(s, "s");
if (crc32("psBKfOzbQOzW",12) == 1005807641) strcat(s, "a");
if (crc32("nHdggcdSRvvDx",13) == 462288461) strcat(s, "u");
if (crc32("kEuYDciFRcKDF",13) == 2196401531) strcat(s, "t");
if (crc32("wyOjJlC",7) == 1294371258) strcat(s, "o");
if (crc32("qqfFqFg",7) == 2680570262) strcat(s, "c");
if (crc32("tyCax",5) == 1933741124) strcat(s, "W");
if (crc32("HCrpgicDMgt",11) == 2921084926) strcat(s, "h");
if (crc32("OmqSSBSv",8) == 3422954171) strcat(s, "a");
if (crc32("veudKoVLphAmT",13) == 1429456380) strcat(s, "t");
if (crc32("oXLijcGsi",9) == 4042828986) strcat(s, "h");
if (crc32("LcuXexXzMdEss",13) == 1269748816) strcat(s, "L");
if (crc32("zPtZZhLVHNQtX",13) == 3199379688) strcat(s, "o");
if (crc32("XLnJOWVzB",9) == 1515894064) strcat(s, "B");
if (crc32("uOWfEpBoKnRN",12) == 896501171) strcat(s, "n");
if (crc32("HoqqKWXXazzrUKY",15) == 1047182063) strcat(s, "T");
if (crc32("FtTFMIxIGoFQI",13) == 3513619487) strcat(s, "i");
if (crc32("vDjFE",5) == 59425101) strcat(s, "k");
if (crc32("ZytIa",5) == 3930106479) strcat(s, "s");
if (crc32("JRnpXnH",7) == 2428159366) strcat(s, "m");
    return s;
}

char *Sukkoth_nouns() {
    char *s = calloc(8);
    if (crc32("GKVBABOZkbQwtC",14) == 616891350) strcat(s, "P");
if (crc32("YAYSwuUwGbYe",12) == 3613032050) strcat(s, "S");
if (crc32("VKuFuaJFjTWKfzB",15) == 1728930383) strcat(s, "u");
if (crc32("ixYvsiEXOpH",11) == 3048703410) strcat(s, "B");
if (crc32("peHGmXlQGIK",11) == 1960240357) strcat(s, "k");
if (crc32("dlbmITkH",8) == 715956225) strcat(s, "k");
if (crc32("QdnOz",5) == 4067253488) strcat(s, "o");
if (crc32("ZRQwsIjFQ",9) == 580042296) strcat(s, "t");
if (crc32("kVlofPeyJ",9) == 2616082558) strcat(s, "E");
if (crc32("fswzTlhh",8) == 3767327616) strcat(s, "h");
    return s;
}

char *Orelie_nouns() {
    char *s = calloc(7);
    if (crc32("OASFyxW",7) == 1664013739) strcat(s, "O");
if (crc32("yyAQriSwHLGuMP",14) == 1312970181) strcat(s, "r");
if (crc32("xkXUtvUGAUtglH",14) == 635888597) strcat(s, "g");
if (crc32("gSKZOYNfVAMynf",14) == 3767490727) strcat(s, "e");
if (crc32("BLPhgvkRipQ",11) == 2023815533) strcat(s, "l");
if (crc32("cvbYBFfrULDLn",13) == 738045431) strcat(s, "i");
if (crc32("bDodOQ",6) == 513492858) strcat(s, "e");
    return s;
}

char *overreduction_nouns() {
    char *s = calloc(14);
    if (crc32("pYJmXvQPGCC",11) == 3296925369) strcat(s, "V");
if (crc32("LRcaRYC",7) == 3911055517) strcat(s, "o");
if (crc32("MjyyX",5) == 970358206) strcat(s, "s");
if (crc32("ugLdICQ",7) == 2818114023) strcat(s, "v");
if (crc32("DyIaQqbxGm",10) == 2002711775) strcat(s, "e");
if (crc32("ahrHHfaKHbKUqp",14) == 439737279) strcat(s, "d");
if (crc32("ArToN",5) == 2050192224) strcat(s, "r");
if (crc32("CXXZX",5) == 4269960594) strcat(s, "J");
if (crc32("sgATpwiUAEdd",12) == 1258844345) strcat(s, "r");
if (crc32("nDKSwzoc",8) == 2474328343) strcat(s, "e");
if (crc32("DciLYZ",6) == 3516570889) strcat(s, "u");
if (crc32("zeuOTjqzZEA",11) == 1500916555) strcat(s, "d");
if (crc32("ellvGienrdGn",12) == 18844760) strcat(s, "u");
if (crc32("sMelVXr",7) == 2001742258) strcat(s, "c");
if (crc32("RiYxARlgfPwtDG",14) == 2684457612) strcat(s, "t");
if (crc32("cOlhiPIlfkKOm",13) == 2944368059) strcat(s, "i");
if (crc32("gEsnkZjA",8) == 4157835630) strcat(s, "k");
if (crc32("VPSOEkvHuSbTDKG",15) == 1118108741) strcat(s, "o");
if (crc32("uhgaKDxKLQMffiJ",15) == 3113533656) strcat(s, "f");
if (crc32("DDaav",5) == 4088588550) strcat(s, "n");
    return s;
}

char *Stiegel_nouns() {
    char *s = calloc(8);
    if (crc32("pmbId",5) == 3599464015) strcat(s, "S");
if (crc32("dGEtYURtDlw",11) == 2009721541) strcat(s, "t");
if (crc32("zJyxNGslTkQeYA",14) == 3918068946) strcat(s, "i");
if (crc32("tJYApSfk",8) == 257099382) strcat(s, "e");
if (crc32("wmXKL",5) == 1255407713) strcat(s, "g");
if (crc32("kBXmABTANpBIP",13) == 3633300906) strcat(s, "e");
if (crc32("QwCFgWWC",8) == 727817238) strcat(s, "h");
if (crc32("IIhzGEGJfMqk",12) == 1671023766) strcat(s, "l");
    return s;
}

char *thermoluminescence_nouns() {
    char *s = calloc(19);
    if (crc32("aNKBSvgLn",9) == 1977175700) strcat(s, "z");
if (crc32("rLmNyCGTMn",10) == 3349124065) strcat(s, "t");
if (crc32("LPVrXqDEONO",11) == 3970479990) strcat(s, "g");
if (crc32("YjPzz",5) == 2919655982) strcat(s, "h");
if (crc32("bQwKYehTPFMwT",13) == 3970709799) strcat(s, "e");
if (crc32("dFZDmK",6) == 392824366) strcat(s, "r");
if (crc32("kaAPW",5) == 798431755) strcat(s, "F");
if (crc32("IFfyAsfBMBACro",14) == 486522267) strcat(s, "m");
if (crc32("hAhbG",5) == 3467618899) strcat(s, "L");
if (crc32("bdrMA",5) == 2196590356) strcat(s, "o");
if (crc32("ZEJCsH",6) == 310056391) strcat(s, "j");
if (crc32("RUEGMijgjKwtDRh",15) == 3438364425) strcat(s, "l");
if (crc32("gcGcePe",7) == 1461898525) strcat(s, "u");
if (crc32("FVAjQWd",7) == 3875358417) strcat(s, "E");
if (crc32("ZbDiUIFaPf",10) == 1819315783) strcat(s, "m");
if (crc32("UNsMESQr",8) == 2661190555) strcat(s, "i");
if (crc32("CxjLqayF",8) == 1592194801) strcat(s, "f");
if (crc32("NPlDtoXHeH",10) == 3183999155) strcat(s, "n");
if (crc32("UzElzgWs",8) == 1179114101) strcat(s, "e");
if (crc32("bQBJXidCgCcRdF",14) == 701329691) strcat(s, "s");
if (crc32("laSuvRjKV",9) == 3399374812) strcat(s, "c");
if (crc32("JYqwoM",6) == 1624999292) strcat(s, "i");
if (crc32("lEFzNKMFQEq",11) == 1896308701) strcat(s, "e");
if (crc32("VWZjteEcRsRk",12) == 2861219944) strcat(s, "Y");
if (crc32("TmiXGuxGmE",10) == 252957279) strcat(s, "n");
if (crc32("NmgoEdNGM",9) == 3508707070) strcat(s, "z");
if (crc32("wVAnwrqrhY",10) == 1723450958) strcat(s, "c");
if (crc32("ipMNPplIhrwcNnd",15) == 806361025) strcat(s, "F");
if (crc32("gBOIf",5) == 578893354) strcat(s, "e");
    return s;
}

char *refreshingness_nouns() {
    char *s = calloc(15);
    if (crc32("aUTeGQwO",8) == 602119347) strcat(s, "r");
if (crc32("KkqOGWCHipD",11) == 473849966) strcat(s, "O");
if (crc32("gMasYaNkvCEf",12) == 1686615638) strcat(s, "e");
if (crc32("AtTLYZPA",8) == 1016447549) strcat(s, "i");
if (crc32("qGqAdiNlw",9) == 4213375840) strcat(s, "f");
if (crc32("DrVxsMOBdMWWyHY",15) == 3552620644) strcat(s, "T");
if (crc32("YQOwEkGhDI",10) == 1890974351) strcat(s, "r");
if (crc32("qYbJaztboVoR",12) == 3038505562) strcat(s, "z");
if (crc32("DmBGUee",7) == 4069990227) strcat(s, "e");
if (crc32("NnJTuEGqijFy",12) == 309244605) strcat(s, "t");
if (crc32("TJTIUuuXSHmRc",13) == 151632493) strcat(s, "s");
if (crc32("aXHvQgX",7) == 138644416) strcat(s, "J");
if (crc32("QDdaVBN",7) == 1479878654) strcat(s, "h");
if (crc32("giPZKASjpAZCfW",14) == 839841720) strcat(s, "i");
if (crc32("CwXLEXvJMyaCdv",14) == 4183576227) strcat(s, "y");
if (crc32("DIdtqHucnTsjL",13) == 957838710) strcat(s, "n");
if (crc32("kfGbVNybXLVb",12) == 169892048) strcat(s, "o");
if (crc32("RaQUQtH",7) == 1292161827) strcat(s, "g");
if (crc32("rSozDrNgT",9) == 1682524074) strcat(s, "n");
if (crc32("qFiqDDAKTqwYse",14) == 2031229295) strcat(s, "e");
if (crc32("tWgjnOZSpkK",11) == 1863861683) strcat(s, "Z");
if (crc32("CfBEWfCPz",9) == 2002399284) strcat(s, "s");
if (crc32("BBRiBYZqjNCrl",13) == 2106846943) strcat(s, "s");
    return s;
}

char *djellabah_nouns() {
    char *s = calloc(10);
    if (crc32("EHvjlOZD",8) == 1183914975) strcat(s, "d");
if (crc32("pMKrE",5) == 838753144) strcat(s, "j");
if (crc32("SnzCdS",6) == 2557988698) strcat(s, "e");
if (crc32("vDOPsBgXq",9) == 3778883195) strcat(s, "l");
if (crc32("GXBGeIRyyfOlzdb",15) == 1872635571) strcat(s, "n");
if (crc32("OBEqCIq",7) == 1514858294) strcat(s, "l");
if (crc32("aHlWuKKhEpJU",12) == 2934134114) strcat(s, "r");
if (crc32("EQmht",5) == 2680374298) strcat(s, "a");
if (crc32("NnYThFLyejIRkgz",15) == 1855811442) strcat(s, "b");
if (crc32("atWyRbZ",7) == 257384484) strcat(s, "a");
if (crc32("QDjEigKij",9) == 3543050894) strcat(s, "F");
if (crc32("XHZwAJbvLyRW",12) == 3596596747) strcat(s, "h");
    return s;
}

char *exr_nouns() {
    char *s = calloc(4);
    if (crc32("BUYAtionpqai",12) == 3181176766) strcat(s, "e");
if (crc32("LSgcaOy",7) == 2076045993) strcat(s, "e");
if (crc32("jGrxqU",6) == 1150268917) strcat(s, "x");
if (crc32("HnzsOSpfgNqf",12) == 3599572979) strcat(s, "r");
    return s;
}

char *flatcar_nouns() {
    char *s = calloc(8);
    if (crc32("UmhahgynMUZkbjw",15) == 194736738) strcat(s, "f");
if (crc32("focpMtARGoRNOfW",15) == 2739566232) strcat(s, "d");
if (crc32("JTwUxFbYZJjfi",13) == 1750941772) strcat(s, "l");
if (crc32("uBxWJmUyQ",9) == 2370117768) strcat(s, "a");
if (crc32("zMmDpfpUhirgbo",14) == 2974716964) strcat(s, "a");
if (crc32("BKMsOsOzLb",10) == 629365429) strcat(s, "y");
if (crc32("okDybSyRtZFCA",13) == 2215252392) strcat(s, "t");
if (crc32("byWylQvkQLsPdjt",15) == 3112908474) strcat(s, "c");
if (crc32("YrEMgIrdyahvc",13) == 2223064018) strcat(s, "p");
if (crc32("lCQzksGhy",9) == 2987890152) strcat(s, "a");
if (crc32("LpJgbLTmEbHPC",13) == 1314482003) strcat(s, "r");
    return s;
}

char *mathematics_nouns() {
    char *s = calloc(12);
    if (crc32("wEQFhM",6) == 2501447380) strcat(s, "m");
if (crc32("URHckN",6) == 408230111) strcat(s, "a");
if (crc32("iKVWiHCrTOXoWA",14) == 1262817016) strcat(s, "a");
if (crc32("SkyRbMtdL",9) == 3211669165) strcat(s, "t");
if (crc32("pCrzCI",6) == 3921145496) strcat(s, "h");
if (crc32("fTDnEbFw",8) == 2569830906) strcat(s, "e");
if (crc32("BSFBWEdMlkaZs",13) == 2415412562) strcat(s, "p");
if (crc32("WxiufduUPu",10) == 2626718030) strcat(s, "m");
if (crc32("RAUIwKDHLtVX",12) == 154713966) strcat(s, "V");
if (crc32("ntQFZgiCIfeRDTc",15) == 1022400708) strcat(s, "a");
if (crc32("PVcPjfbigcta",12) == 2062703679) strcat(s, "t");
if (crc32("KBACaNdpXaw",11) == 2775365309) strcat(s, "i");
if (crc32("LskwvRCMDrbK",12) == 2527412141) strcat(s, "c");
if (crc32("XxMMRMLzmxoS",12) == 995394048) strcat(s, "s");
    return s;
}

char *Titos_nouns() {
    char *s = calloc(6);
    if (crc32("LIUkqdsAUAKr",12) == 1060910728) strcat(s, "z");
if (crc32("DzUHdsEdFRKLI",13) == 118178445) strcat(s, "T");
if (crc32("WKgqqHREEhmM",12) == 3871862109) strcat(s, "i");
if (crc32("ypUesuAP",8) == 2659020537) strcat(s, "t");
if (crc32("nSSTAbkaGmB",11) == 3842512585) strcat(s, "m");
if (crc32("yWznqkhpMoO",11) == 2212050565) strcat(s, "o");
if (crc32("sPTKbc",6) == 3088898507) strcat(s, "M");
if (crc32("AOdJhC",6) == 618475061) strcat(s, "s");
    return s;
}

char *Guesdism_nouns() {
    char *s = calloc(9);
    if (crc32("PxsNRXpSH",9) == 2166931436) strcat(s, "l");
if (crc32("qKfmR",5) == 1474917374) strcat(s, "G");
if (crc32("xvBrJJMBF",9) == 2850140400) strcat(s, "R");
if (crc32("MJtfGmEBsecn",12) == 1459021939) strcat(s, "u");
if (crc32("JkdJBRAnfdL",11) == 3517720930) strcat(s, "e");
if (crc32("KWoUtOeJU",9) == 3119666048) strcat(s, "e");
if (crc32("SBmDHizS",8) == 1242741854) strcat(s, "s");
if (crc32("pSzPLVRymalfeME",15) == 3622676250) strcat(s, "d");
if (crc32("bKveoob",7) == 2741806222) strcat(s, "k");
if (crc32("sBtCbdBnSaP",11) == 2476999990) strcat(s, "i");
if (crc32("nCdCIfppJEB",11) == 2687963848) strcat(s, "W");
if (crc32("emQzlPl",7) == 1309361240) strcat(s, "s");
if (crc32("dKQUldSkhcuAW",13) == 2628430291) strcat(s, "A");
if (crc32("EAvulmndzTul",12) == 3483562695) strcat(s, "m");
    return s;
}

char *Dunc_nouns() {
    char *s = calloc(5);
    if (crc32("YfvXnCVYfusDf",13) == 2391260243) strcat(s, "D");
if (crc32("twBtDdIijKBXf",13) == 1205916954) strcat(s, "u");
if (crc32("FfLWPrVze",9) == 3057193256) strcat(s, "n");
if (crc32("wBguCAcNyLA",11) == 3907708150) strcat(s, "c");
    return s;
}

char *Pain_nouns() {
    char *s = calloc(5);
    if (crc32("EneJbvJxlyHC",12) == 1073824067) strcat(s, "C");
if (crc32("SseUt",5) == 514021515) strcat(s, "P");
if (crc32("ZiddIx",6) == 202019300) strcat(s, "a");
if (crc32("UcWCEFncvWUG",12) == 4166472653) strcat(s, "E");
if (crc32("gWzSnSyTy",9) == 276733015) strcat(s, "i");
if (crc32("dotduPBqS",9) == 677953071) strcat(s, "n");
    return s;
}

char *Copiague_nouns() {
    char *s = calloc(9);
    if (crc32("DTGHTEse",8) == 774697195) strcat(s, "u");
if (crc32("WSLxfkHFa",9) == 1459866447) strcat(s, "C");
if (crc32("eQfoeXZV",8) == 290432584) strcat(s, "o");
if (crc32("wWdahvzRhRyeU",13) == 1242499832) strcat(s, "p");
if (crc32("KjwTgePvvPmAAxH",15) == 349612486) strcat(s, "S");
if (crc32("MQiPiexxnsvnZz",14) == 3581977791) strcat(s, "i");
if (crc32("JWbjgno",7) == 4055479495) strcat(s, "r");
if (crc32("ZBMfflgjDwR",11) == 684809868) strcat(s, "a");
if (crc32("UuNrUXjBaYlEoHl",15) == 1134769976) strcat(s, "g");
if (crc32("bdGcjDFOvjOLcDg",15) == 1893091858) strcat(s, "y");
if (crc32("UTisohNbXXuoMnu",15) == 177848298) strcat(s, "u");
if (crc32("ccIjXaHgVDgrp",13) == 2490883716) strcat(s, "u");
if (crc32("OgpJqayUqEFr",12) == 3509050360) strcat(s, "e");
    return s;
}

char *Roxy_nouns() {
    char *s = calloc(5);
    if (crc32("ZmLudpQXSu",10) == 2655394176) strcat(s, "o");
if (crc32("tsukKZh",7) == 2853860609) strcat(s, "R");
if (crc32("ArkTTMiPSpMfj",13) == 1956520424) strcat(s, "r");
if (crc32("kqIcOsHNFKeLGlJ",15) == 2969470772) strcat(s, "o");
if (crc32("kZFPnDVfhzxWn",13) == 3102187597) strcat(s, "x");
if (crc32("uLGoyXrirz",10) == 1619936782) strcat(s, "l");
if (crc32("kGJLta",6) == 3320708002) strcat(s, "y");
    return s;
}

char *Ardussi_nouns() {
    char *s = calloc(8);
    if (crc32("gewtnpmPYpfr",12) == 1970155534) strcat(s, "A");
if (crc32("HMqhZHuhKEJY",12) == 3449566389) strcat(s, "r");
if (crc32("kaZaUGDB",8) == 3363829668) strcat(s, "V");
if (crc32("vnLhMglBTYHU",12) == 1947342644) strcat(s, "d");
if (crc32("gGllXVcpQaakW",13) == 4267689821) strcat(s, "u");
if (crc32("XbdmbWXHmegGqOp",15) == 236678530) strcat(s, "s");
if (crc32("ImDAZQdcJ",9) == 194958044) strcat(s, "Y");
if (crc32("BCWvxwdkdkJo",12) == 1022773187) strcat(s, "s");
if (crc32("XEjCpukfT",9) == 1457823052) strcat(s, "i");
    return s;
}

char *limes_nouns() {
    char *s = calloc(6);
    if (crc32("cWESiXUPiX",10) == 304808427) strcat(s, "Y");
if (crc32("OKYOyvMyQ",9) == 4224963246) strcat(s, "l");
if (crc32("CqHrIcn",7) == 450221845) strcat(s, "i");
if (crc32("bWGFkPxM",8) == 3143674058) strcat(s, "m");
if (crc32("lHwjlRKysghrb",13) == 2601064540) strcat(s, "e");
if (crc32("QHhZbb",6) == 1969034402) strcat(s, "s");
    return s;
}

char *cedula_nouns() {
    char *s = calloc(7);
    if (crc32("EQdsoYvTmdsP",12) == 1429028517) strcat(s, "x");
if (crc32("IhdNcpPCd",9) == 2500272928) strcat(s, "c");
if (crc32("NgflsBhbDwub",12) == 2058373378) strcat(s, "R");
if (crc32("GVZLvot",7) == 2147981603) strcat(s, "e");
if (crc32("XInPOqgRYl",10) == 29675364) strcat(s, "d");
if (crc32("CWXjAfSLGv",10) == 895019321) strcat(s, "q");
if (crc32("TlooIbFCi",9) == 2504917339) strcat(s, "u");
if (crc32("bAHsVTbgu",9) == 2615236298) strcat(s, "n");
if (crc32("KKoDxjESu",9) == 2107595743) strcat(s, "l");
if (crc32("mqGZIGqMl",9) == 10930133) strcat(s, "a");
    return s;
}

char *Wittie_nouns() {
    char *s = calloc(7);
    if (crc32("IfOXskJwMYGhY",13) == 1940071525) strcat(s, "W");
if (crc32("EfiBwGskeaMgwDK",15) == 2676687691) strcat(s, "G");
if (crc32("ltcdLVG",7) == 1455849908) strcat(s, "i");
if (crc32("ynXJjM",6) == 1596368349) strcat(s, "t");
if (crc32("ouPVrkrPHZbuy",13) == 3765399217) strcat(s, "T");
if (crc32("RCzfkPiHsw",10) == 3296096079) strcat(s, "t");
if (crc32("luhEdhbvxjE",11) == 1381049740) strcat(s, "i");
if (crc32("stZpdKNtIknwME",14) == 4023235154) strcat(s, "f");
if (crc32("LptPXs",6) == 50685402) strcat(s, "e");
    return s;
}

char *Baring_nouns() {
    char *s = calloc(7);
    if (crc32("ZEejngkybOTg",12) == 969538793) strcat(s, "g");
if (crc32("RegIjXoNkI",10) == 1919338257) strcat(s, "B");
if (crc32("wkKGDCZA",8) == 3798931746) strcat(s, "a");
if (crc32("KkkSClhY",8) == 4061896231) strcat(s, "r");
if (crc32("rUUKUNVkJHDsu",13) == 1260590122) strcat(s, "r");
if (crc32("aZrKm",5) == 2973462835) strcat(s, "i");
if (crc32("QnqAkEMTca",10) == 3754938891) strcat(s, "T");
if (crc32("MCqQwkOBRl",10) == 246206700) strcat(s, "n");
if (crc32("MCMzaggIP",9) == 2307910946) strcat(s, "j");
if (crc32("TAtJHXbtCrSNyvo",15) == 4217863601) strcat(s, "g");
    return s;
}

char *premeditation_nouns() {
    char *s = calloc(14);
    if (crc32("utDsQiFcOKHMqJ",14) == 3024848822) strcat(s, "U");
if (crc32("ytHzbuppV",9) == 161184279) strcat(s, "p");
if (crc32("edJetVKHRLvHsG",14) == 4234726138) strcat(s, "U");
if (crc32("VlLgYacDQDkVs",13) == 4167533832) strcat(s, "r");
if (crc32("kqMrDFfPQcmYw",13) == 4149404551) strcat(s, "e");
if (crc32("WETwhdSuvfMDHy",14) == 2065936869) strcat(s, "X");
if (crc32("muEeouoJbHbT",12) == 2754319091) strcat(s, "m");
if (crc32("cUGMKmxWZ",9) == 2652693844) strcat(s, "Y");
if (crc32("VeljtzDX",8) == 3486478125) strcat(s, "e");
if (crc32("UqEspciVTCe",11) == 1481251319) strcat(s, "d");
if (crc32("QtRgdKIUyQYt",12) == 2588026641) strcat(s, "i");
if (crc32("yuYfHeGiRPoTLP",14) == 3406287165) strcat(s, "t");
if (crc32("zZckXQxm",8) == 1041497752) strcat(s, "H");
if (crc32("CtRyCaXROsPrcKQ",15) == 50679649) strcat(s, "a");
if (crc32("RcUawYXRGHLAlOJ",15) == 2526684530) strcat(s, "t");
if (crc32("DfxyyMwDS",9) == 707582744) strcat(s, "i");
if (crc32("jetYLhByKy",10) == 744317326) strcat(s, "o");
if (crc32("YScvaLWNa",9) == 2416877648) strcat(s, "B");
if (crc32("rUPhcyLpUhKpJ",13) == 1584018153) strcat(s, "n");
    return s;
}

char *anhydremia_nouns() {
    char *s = calloc(11);
    if (crc32("vnSMyhj",7) == 1837390728) strcat(s, "a");
if (crc32("sMjPnq",6) == 2018278496) strcat(s, "n");
if (crc32("oRDPPBvYOWf",11) == 1210971710) strcat(s, "h");
if (crc32("VBNCnl",6) == 99320970) strcat(s, "Y");
if (crc32("pCvjwSA",7) == 456291547) strcat(s, "y");
if (crc32("OxSqAS",6) == 300248629) strcat(s, "d");
if (crc32("aHlQxd",6) == 2875077719) strcat(s, "r");
if (crc32("aISUaC",6) == 125125055) strcat(s, "e");
if (crc32("hDNqhWCrI",9) == 3179992912) strcat(s, "p");
if (crc32("vawZVZNVMN",10) == 499661421) strcat(s, "m");
if (crc32("yTvRj",5) == 51990052) strcat(s, "i");
if (crc32("RRRCAplZpS",10) == 275690117) strcat(s, "g");
if (crc32("MCSNqtgYzu",10) == 1547925380) strcat(s, "a");
    return s;
}

char *Dayton_nouns() {
    char *s = calloc(7);
    if (crc32("xIURfgj",7) == 818569136) strcat(s, "D");
if (crc32("wsRJOOzIkUXS",12) == 4180738178) strcat(s, "X");
if (crc32("QiPrOQB",7) == 2393129575) strcat(s, "a");
if (crc32("vYQyBeNx",8) == 3311775758) strcat(s, "y");
if (crc32("boRbUNEn",8) == 2306171191) strcat(s, "t");
if (crc32("goSmEZyqu",9) == 198525057) strcat(s, "s");
if (crc32("oXwSALV",7) == 1033496132) strcat(s, "o");
if (crc32("BFYeGHPrp",9) == 759776040) strcat(s, "K");
if (crc32("xLreCT",6) == 4090000304) strcat(s, "n");
    return s;
}

char *saviorship_nouns() {
    char *s = calloc(11);
    if (crc32("APiuROiyzzwrD",13) == 1054307043) strcat(s, "Y");
if (crc32("XvujNpIUlgDfrA",14) == 4133464715) strcat(s, "s");
if (crc32("BgXZksZtcSbn",12) == 1927930454) strcat(s, "T");
if (crc32("bhCbVKgEWbhsf",13) == 1277022114) strcat(s, "a");
if (crc32("ZpGuKaKqyr",10) == 3087672060) strcat(s, "v");
if (crc32("iYBPnsz",7) == 57060360) strcat(s, "k");
if (crc32("bATWa",5) == 2726490201) strcat(s, "i");
if (crc32("wMlEsyKMuCH",11) == 1248445549) strcat(s, "o");
if (crc32("LqhTqTgXbiL",11) == 3760510359) strcat(s, "r");
if (crc32("LYGkItaXIue",11) == 3813005568) strcat(s, "P");
if (crc32("WeNpWPD",7) == 220344562) strcat(s, "s");
if (crc32("OsGzxOKan",9) == 2759616849) strcat(s, "Z");
if (crc32("glUtofzvLiCdmw",14) == 3481880077) strcat(s, "h");
if (crc32("nFzSVWO",7) == 287924946) strcat(s, "P");
if (crc32("XzaKNfAGHLw",11) == 848500848) strcat(s, "i");
if (crc32("prHwy",5) == 3659973800) strcat(s, "o");
if (crc32("DczHFGiv",8) == 1986191466) strcat(s, "p");
    return s;
}

char *Guayaquil_nouns() {
    char *s = calloc(10);
    if (crc32("XtvjTjSS",8) == 2548341448) strcat(s, "G");
if (crc32("uRuWKSiGcxDf",12) == 32173630) strcat(s, "u");
if (crc32("fjUpHWuMXN",10) == 2836223198) strcat(s, "a");
if (crc32("MGQbhyu",7) == 3408561818) strcat(s, "W");
if (crc32("oUMgtDwdpumecVo",15) == 2093996347) strcat(s, "y");
if (crc32("lBEnemqJVMjm",12) == 3542009912) strcat(s, "F");
if (crc32("MaOcE",5) == 3598433285) strcat(s, "a");
if (crc32("Ragndki",7) == 3890010142) strcat(s, "q");
if (crc32("nSMMEaqRtvIvIV",14) == 2237952980) strcat(s, "u");
if (crc32("IVyHp",5) == 1310882485) strcat(s, "i");
if (crc32("eaJbyTlIAcx",11) == 909382529) strcat(s, "o");
if (crc32("MovajOcvEEBfqS",14) == 887334391) strcat(s, "l");
    return s;
}

char *Boulez_nouns() {
    char *s = calloc(7);
    if (crc32("ArvHISjaKIJInq",14) == 2078284166) strcat(s, "C");
if (crc32("qPukchLon",9) == 2575019273) strcat(s, "B");
if (crc32("GyEgVUzFWMp",11) == 2492167154) strcat(s, "J");
if (crc32("UGDaCNnWah",10) == 1708676497) strcat(s, "o");
if (crc32("fMKwqnz",7) == 2412473834) strcat(s, "Z");
if (crc32("jwEHZhenTMNkaKE",15) == 1404024477) strcat(s, "u");
if (crc32("JroQBVoW",8) == 337635889) strcat(s, "l");
if (crc32("abRRrsjd",8) == 824915924) strcat(s, "V");
if (crc32("XoapDhzvNUAO",12) == 2601529525) strcat(s, "e");
if (crc32("MjWwkl",6) == 3682533866) strcat(s, "O");
if (crc32("FxSuAJP",7) == 1848763560) strcat(s, "z");
    return s;
}

char *Sully_nouns() {
    char *s = calloc(6);
    if (crc32("MTjqLzwXunQFpg",14) == 1098063447) strcat(s, "s");
if (crc32("FgMekpaxSj",10) == 1565685643) strcat(s, "S");
if (crc32("RYYFKmjNK",9) == 3904674889) strcat(s, "F");
if (crc32("mmeuZlccH",9) == 4257162089) strcat(s, "u");
if (crc32("LnZiTeARnNFhilS",15) == 52458655) strcat(s, "l");
if (crc32("ldoiaquPUKDflk",14) == 4000995019) strcat(s, "l");
if (crc32("FECxgartqO",10) == 3950695454) strcat(s, "t");
if (crc32("ghxOKFLWTqcqYFQ",15) == 3510106515) strcat(s, "y");
    return s;
}

char *Murage_nouns() {
    char *s = calloc(7);
    if (crc32("vLKejNwQXo",10) == 345427924) strcat(s, "L");
if (crc32("icUhErN",7) == 4185852963) strcat(s, "M");
if (crc32("nLmmZmD",7) == 1448642038) strcat(s, "u");
if (crc32("bvJZnniCJRKT",12) == 227887191) strcat(s, "r");
if (crc32("AhQHeuSvQx",10) == 2980223246) strcat(s, "J");
if (crc32("JcSBlQlYprfJXY",14) == 546521631) strcat(s, "a");
if (crc32("Jpwar",5) == 739058506) strcat(s, "g");
if (crc32("Uavfg",5) == 2642832943) strcat(s, "U");
if (crc32("VGqywtdr",8) == 1509020703) strcat(s, "e");
    return s;
}

char *squalene_nouns() {
    char *s = calloc(9);
    if (crc32("kEuip",5) == 839520807) strcat(s, "s");
if (crc32("vWacxoEqrFKNnwX",15) == 414365764) strcat(s, "x");
if (crc32("TNxXlu",6) == 3827129097) strcat(s, "q");
if (crc32("BEBjOMLW",8) == 2605520394) strcat(s, "u");
if (crc32("njBXCiZtCjLQgzz",15) == 1984581035) strcat(s, "a");
if (crc32("kAdwhQ",6) == 3805327759) strcat(s, "l");
if (crc32("CLcnCQqTH",9) == 1753603415) strcat(s, "e");
if (crc32("gOrBuR",6) == 462806283) strcat(s, "n");
if (crc32("qgcJeRGvx",9) == 2540923924) strcat(s, "F");
if (crc32("sBhtA",5) == 1157737176) strcat(s, "e");
    return s;
}

char *reanalysis_nouns() {
    char *s = calloc(11);
    if (crc32("lCnVJLpfTpqTKPH",15) == 3772551408) strcat(s, "Q");
if (crc32("DhtuO",5) == 1913702214) strcat(s, "r");
if (crc32("wPGBLF",6) == 796725745) strcat(s, "n");
if (crc32("mvfAqgCNYy",10) == 3938158525) strcat(s, "e");
if (crc32("sxzVrxDjt",9) == 2930413445) strcat(s, "h");
if (crc32("MpgEdRVziV",10) == 3841039615) strcat(s, "a");
if (crc32("tXiiAl",6) == 2237428079) strcat(s, "n");
if (crc32("cjcPeh",6) == 737284779) strcat(s, "O");
if (crc32("DXeevPfQNffq",12) == 452400085) strcat(s, "a");
if (crc32("uAyIX",5) == 3415464367) strcat(s, "l");
if (crc32("DcNaNMp",7) == 2831639824) strcat(s, "y");
if (crc32("FXQKSuRnOdj",11) == 3920605353) strcat(s, "s");
if (crc32("qiSggiCEZeUcR",13) == 2310296501) strcat(s, "u");
if (crc32("bRHSW",5) == 1589904033) strcat(s, "i");
if (crc32("aRXvxRRyfg",10) == 4152876161) strcat(s, "s");
    return s;
}

char *Obadiah_nouns() {
    char *s = calloc(8);
    if (crc32("wgzmukYgveSEja",14) == 1955915715) strcat(s, "Q");
if (crc32("NmVJUZHJElYZL",13) == 2143681930) strcat(s, "O");
if (crc32("kGoOpvK",7) == 2364700146) strcat(s, "X");
if (crc32("xyPrPKpbbSeNTgb",15) == 3117596525) strcat(s, "b");
if (crc32("vVFrosBthaLaOHg",15) == 2826069536) strcat(s, "C");
if (crc32("mQLmTHdFggeul",13) == 3216206688) strcat(s, "a");
if (crc32("naSWqjHVgQQEYlY",15) == 40740175) strcat(s, "d");
if (crc32("ymhjQhuWxMhB",12) == 1094565899) strcat(s, "i");
if (crc32("zAORXZEX",8) == 2168448579) strcat(s, "a");
if (crc32("VJivH",5) == 1403697520) strcat(s, "E");
if (crc32("FlabRE",6) == 1928583039) strcat(s, "h");
    return s;
}

char *stretto_nouns() {
    char *s = calloc(8);
    if (crc32("wVMRl",5) == 3330096490) strcat(s, "i");
if (crc32("mfbcOfIU",8) == 3901955806) strcat(s, "s");
if (crc32("CvhCFPMGf",9) == 4273130572) strcat(s, "Q");
if (crc32("QoHneSASguO",11) == 1148992474) strcat(s, "t");
if (crc32("nEjWAg",6) == 351518045) strcat(s, "r");
if (crc32("jKHkRmJsBC",10) == 1541911274) strcat(s, "z");
if (crc32("rQZeFPNx",8) == 282446591) strcat(s, "e");
if (crc32("xZHnbHmHHBFjrEY",15) == 1640426181) strcat(s, "t");
if (crc32("ePrlDKUTQ",9) == 3745926095) strcat(s, "D");
if (crc32("ROfEUMHbJKtuS",13) == 4054247497) strcat(s, "t");
if (crc32("LIRILDX",7) == 444217256) strcat(s, "o");
    return s;
}

char *beryllonite_nouns() {
    char *s = calloc(12);
    if (crc32("LNCPotS",7) == 3889202211) strcat(s, "h");
if (crc32("ZGBYOpNJBdN",11) == 2115839555) strcat(s, "b");
if (crc32("BVZHWoWphdD",11) == 3236774623) strcat(s, "O");
if (crc32("IkoAVXo",7) == 3512219166) strcat(s, "e");
if (crc32("HFBrJppf",8) == 1387606824) strcat(s, "r");
if (crc32("EvcGKgRZfu",10) == 63898395) strcat(s, "v");
if (crc32("qACNjVIN",8) == 98464766) strcat(s, "y");
if (crc32("EPiTkhTPT",9) == 56833426) strcat(s, "l");
if (crc32("DPwqMLvC",8) == 3220911313) strcat(s, "l");
if (crc32("STtlYHh",7) == 2301361576) strcat(s, "W");
if (crc32("hVRlpEnvVXGg",12) == 3692977535) strcat(s, "o");
if (crc32("QOTXFvaxvAVxzel",15) == 2723407433) strcat(s, "n");
if (crc32("midLRxXr",8) == 523957986) strcat(s, "k");
if (crc32("yGZdoWVfhS",10) == 1725007691) strcat(s, "i");
if (crc32("dUazu",5) == 3710969777) strcat(s, "S");
if (crc32("wKvKVN",6) == 3352886950) strcat(s, "t");
if (crc32("ewzEhUJyZK",10) == 3259284047) strcat(s, "Q");
if (crc32("hRIblVRereUYKc",14) == 3912604661) strcat(s, "e");
    return s;
}

char *Ierna_nouns() {
    char *s = calloc(6);
    if (crc32("vjgoYsExsTYVxN",14) == 688003373) strcat(s, "o");
if (crc32("aJouVNcsRrg",11) == 1736908499) strcat(s, "I");
if (crc32("XbMvFrYRw",9) == 2737841081) strcat(s, "y");
if (crc32("idNphlyHIjCkIfi",15) == 1634836348) strcat(s, "e");
if (crc32("KWlXYTZoIpEQS",13) == 2232132089) strcat(s, "r");
if (crc32("HlGqL",5) == 3821695591) strcat(s, "n");
if (crc32("iDamzfvZfLH",11) == 1717490521) strcat(s, "I");
if (crc32("oRZOGRC",7) == 42819894) strcat(s, "a");
    return s;
}

char *Kotzebue_nouns() {
    char *s = calloc(9);
    if (crc32("EOUhmFKXDKLSaVp",15) == 3037222603) strcat(s, "K");
if (crc32("vOkQuDboNqfmEHk",15) == 4156390334) strcat(s, "t");
if (crc32("epkrFNzlrwiWZsK",15) == 437710411) strcat(s, "o");
if (crc32("zAiBI",5) == 3701543991) strcat(s, "t");
if (crc32("UboKzjYEY",9) == 3946309730) strcat(s, "S");
if (crc32("bghGxariPkgZTAY",15) == 4049685190) strcat(s, "z");
if (crc32("dBzPKExXYsgYLj",14) == 3256040415) strcat(s, "G");
if (crc32("qjxXHDtdmFK",11) == 55532559) strcat(s, "e");
if (crc32("tZrkdcTseEyeOp",14) == 2267498989) strcat(s, "J");
if (crc32("KwCdzFf",7) == 1036271649) strcat(s, "b");
if (crc32("AjaVBaMjy",9) == 1624248905) strcat(s, "y");
if (crc32("cxrBeC",6) == 3010971944) strcat(s, "u");
if (crc32("naqsFCcyQvt",11) == 3083261857) strcat(s, "e");
    return s;
}

char *debater_nouns() {
    char *s = calloc(8);
    if (crc32("wCCIYUVkmNXQCRt",15) == 50613597) strcat(s, "d");
if (crc32("MsalcvrN",8) == 1624424380) strcat(s, "e");
if (crc32("wmtYTp",6) == 3964792606) strcat(s, "S");
if (crc32("dOjGkQjy",8) == 4159611629) strcat(s, "b");
if (crc32("ZdmnOlChGAgVSP",14) == 3620497462) strcat(s, "a");
if (crc32("wUxhuSrWxypqAry",15) == 3399290122) strcat(s, "X");
if (crc32("QJufcUOUZtouanm",15) == 1217407150) strcat(s, "t");
if (crc32("PeMdLDIoL",9) == 3520599116) strcat(s, "e");
if (crc32("kNNeWyoNoZeUrTg",15) == 4113300594) strcat(s, "r");
    return s;
}

char *intermigration_nouns() {
    char *s = calloc(15);
    if (crc32("GONWveTIzUKt",12) == 3654625914) strcat(s, "u");
if (crc32("SNjZzGcShUFyoTV",15) == 3297986455) strcat(s, "i");
if (crc32("bcfWZnLZMHwb",12) == 2099505759) strcat(s, "n");
if (crc32("gQnlsQ",6) == 3460682334) strcat(s, "r");
if (crc32("hyoeeqcBiMfZE",13) == 1872876395) strcat(s, "t");
if (crc32("GaHAwYWqF",9) == 3469004866) strcat(s, "e");
if (crc32("zJkoQIfxFgQ",11) == 1239022869) strcat(s, "N");
if (crc32("tcyDkDxZJHdpNCr",15) == 3587484519) strcat(s, "r");
if (crc32("BTfdtAg",7) == 312301893) strcat(s, "m");
if (crc32("ulfHX",5) == 2544532288) strcat(s, "i");
if (crc32("cHOba",5) == 1353193540) strcat(s, "g");
if (crc32("WmdkIdLaUmh",11) == 3500404238) strcat(s, "H");
if (crc32("qSCQbmoE",8) == 2930345592) strcat(s, "r");
if (crc32("ZFYYJerAZxR",11) == 3992587266) strcat(s, "a");
if (crc32("AaHVMbbzBBEoya",14) == 4037124174) strcat(s, "t");
if (crc32("NHnbJmEF",8) == 1506460000) strcat(s, "i");
if (crc32("vjikukVBHioyR",13) == 4127239790) strcat(s, "o");
if (crc32("aTvLTSPMtH",10) == 1932659651) strcat(s, "n");
    return s;
}

char *vermin_nouns() {
    char *s = calloc(7);
    if (crc32("vCnBAHHQ",8) == 357800533) strcat(s, "w");
if (crc32("PWbcodenTlwBNGI",15) == 4196780323) strcat(s, "v");
if (crc32("FWCPoLvLK",9) == 660291863) strcat(s, "V");
if (crc32("xctKczuiZB",10) == 4086242923) strcat(s, "e");
if (crc32("YwgnaSKhNi",10) == 2982671815) strcat(s, "J");
if (crc32("DpBJFOWTgBK",11) == 3392581715) strcat(s, "r");
if (crc32("oqngLCDpXh",10) == 413559001) strcat(s, "p");
if (crc32("OzmBFu",6) == 3232823860) strcat(s, "m");
if (crc32("EJHUakmHfz",10) == 1120407365) strcat(s, "i");
if (crc32("eXOHc",5) == 244586367) strcat(s, "n");
    return s;
}

char *Garibold_nouns() {
    char *s = calloc(9);
    if (crc32("aVlhiMnLtdXu",12) == 4114253480) strcat(s, "a");
if (crc32("KsdosjYepqqUdpu",15) == 1918391787) strcat(s, "G");
if (crc32("zsTgmGJoUz",10) == 3392508106) strcat(s, "a");
if (crc32("iZNiBxexbhG",11) == 2796782618) strcat(s, "t");
if (crc32("KWwcpQnZTV",10) == 1735711250) strcat(s, "r");
if (crc32("DectdXF",7) == 107632738) strcat(s, "C");
if (crc32("QMjgjydp",8) == 85992654) strcat(s, "i");
if (crc32("HsgojeoILSymx",13) == 4013045200) strcat(s, "Y");
if (crc32("SaWOom",6) == 1676677740) strcat(s, "b");
if (crc32("uvDvrIB",7) == 4085032745) strcat(s, "o");
if (crc32("dCgZA",5) == 791070782) strcat(s, "l");
if (crc32("yknBYBzfj",9) == 3179041831) strcat(s, "T");
if (crc32("CphSwLXIqD",10) == 3402926889) strcat(s, "d");
    return s;
}

char *uncoquettishness_nouns() {
    char *s = calloc(17);
    if (crc32("daebDAD",7) == 1423070586) strcat(s, "L");
if (crc32("CmxHsHR",7) == 546657310) strcat(s, "u");
if (crc32("QdGMoxdzFFp",11) == 3128300416) strcat(s, "t");
if (crc32("tkSKApesYs",10) == 2589436398) strcat(s, "n");
if (crc32("lREKqHvbPvcBlLe",15) == 1700805554) strcat(s, "c");
if (crc32("QWvFkpTpWYz",11) == 3228459801) strcat(s, "Q");
if (crc32("HbfICWhZWNqs",12) == 4015545977) strcat(s, "o");
if (crc32("MyUYnLZFUuuMG",13) == 4122997142) strcat(s, "c");
if (crc32("hJBsxZQGGQvR",12) == 1889606659) strcat(s, "q");
if (crc32("LrFrLrSa",8) == 1044554621) strcat(s, "q");
if (crc32("ZWdkdNGgSJdAK",13) == 3626320619) strcat(s, "u");
if (crc32("dgRNEilHcQ",10) == 3653534786) strcat(s, "s");
if (crc32("TeMFMJWUELBgo",13) == 268550081) strcat(s, "e");
if (crc32("PEoXfGKwKCtttBs",15) == 3464887593) strcat(s, "t");
if (crc32("oFkEM",5) == 2732503756) strcat(s, "t");
if (crc32("bgxSpjmzVHicrxB",15) == 3788287657) strcat(s, "i");
if (crc32("usqeHTl",7) == 506621764) strcat(s, "h");
if (crc32("BKxFRlHh",8) == 592756789) strcat(s, "s");
if (crc32("PuVlSdCpe",9) == 3826570103) strcat(s, "h");
if (crc32("kSLlcrarLIi",11) == 2742686591) strcat(s, "H");
if (crc32("TfJvUHX",7) == 4281053605) strcat(s, "n");
if (crc32("SeWraR",6) == 2452013788) strcat(s, "e");
if (crc32("tNCQsDyIEE",10) == 3939067116) strcat(s, "s");
if (crc32("XYZGO",5) == 1077157274) strcat(s, "s");
    return s;
}

char *irreversibleness_nouns() {
    char *s = calloc(17);
    if (crc32("OLAGvb",6) == 1884840225) strcat(s, "t");
if (crc32("DTgNgjGmfDm",11) == 2521896103) strcat(s, "i");
if (crc32("TfnZVv",6) == 548334679) strcat(s, "T");
if (crc32("KrJqHLCOkmQi",12) == 3815805643) strcat(s, "r");
if (crc32("yVGPZpbHg",9) == 634019362) strcat(s, "M");
if (crc32("TJpJUASGRMjub",13) == 690114976) strcat(s, "r");
if (crc32("wJFtIsRm",8) == 1648929482) strcat(s, "C");
if (crc32("lAuGXXQAKPm",11) == 4195762714) strcat(s, "e");
if (crc32("JaPAiR",6) == 811392567) strcat(s, "v");
if (crc32("rUQGUTPrxMyH",12) == 2405002605) strcat(s, "B");
if (crc32("FsWGGvA",7) == 3063588670) strcat(s, "e");
if (crc32("wkCtSfTWDc",10) == 1732655695) strcat(s, "r");
if (crc32("oKsGSWuRB",9) == 3052749779) strcat(s, "s");
if (crc32("NBzEG",5) == 741081974) strcat(s, "i");
if (crc32("dAGpP",5) == 70325876) strcat(s, "N");
if (crc32("YddephvrWvQzRpM",15) == 3888005374) strcat(s, "b");
if (crc32("AeIPKnijJKet",12) == 34153266) strcat(s, "p");
if (crc32("MWBTagTHyzuKKAy",15) == 619802538) strcat(s, "l");
if (crc32("lEdRFylSV",9) == 2420892016) strcat(s, "e");
if (crc32("LxXcjwKAp",9) == 3749850668) strcat(s, "n");
if (crc32("UXXGGaxUdKdsVZJ",15) == 3632811154) strcat(s, "P");
if (crc32("xSMXMA",6) == 1725768882) strcat(s, "e");
if (crc32("KvtyfVJhAHitrxI",15) == 2560455116) strcat(s, "s");
if (crc32("cXojWrHHGGC",11) == 1919899316) strcat(s, "a");
if (crc32("unTmcskAe",9) == 3448519712) strcat(s, "s");
    return s;
}

char *enlistment_nouns() {
    char *s = calloc(11);
    if (crc32("SFNHdsk",7) == 3622788162) strcat(s, "I");
if (crc32("ywjSwFaNhy",10) == 2465574762) strcat(s, "e");
if (crc32("pZBpV",5) == 1164520589) strcat(s, "n");
if (crc32("MCzWNgZiOYP",11) == 1998899458) strcat(s, "l");
if (crc32("CTxBQKFEFOIDd",13) == 3536725042) strcat(s, "o");
if (crc32("wigwt",5) == 2976969978) strcat(s, "i");
if (crc32("JHAGSRM",7) == 324468263) strcat(s, "s");
if (crc32("fSvVPSzrz",9) == 2824608056) strcat(s, "T");
if (crc32("FaEDSeeE",8) == 3698308478) strcat(s, "t");
if (crc32("czRkIvr",7) == 3242691612) strcat(s, "V");
if (crc32("MjlJKchBAnnIwg",14) == 752452047) strcat(s, "m");
if (crc32("fhuDxYkjEfdxar",14) == 3679855709) strcat(s, "s");
if (crc32("XNwatfUnfpAzsKT",15) == 2891882587) strcat(s, "e");
if (crc32("RbNrz",5) == 3255007138) strcat(s, "n");
if (crc32("XINZcYRizmui",12) == 333477918) strcat(s, "X");
if (crc32("tabVFr",6) == 1679107472) strcat(s, "t");
    return s;
}

char *spearfish_nouns() {
    char *s = calloc(10);
    if (crc32("OSxJieCfUDrz",12) == 6161189) strcat(s, "q");
if (crc32("YsVlMchRLiZA",12) == 3395507605) strcat(s, "s");
if (crc32("uMpaqdp",7) == 3637977084) strcat(s, "d");
if (crc32("nQOIlXOuC",9) == 3843033489) strcat(s, "p");
if (crc32("yfMyqtXBQHdWdD",14) == 4083327460) strcat(s, "e");
if (crc32("dFavsIZRGJC",11) == 1341096944) strcat(s, "a");
if (crc32("yhqSggtMcGJtHN",14) == 4078443034) strcat(s, "r");
if (crc32("lnaNywJ",7) == 2437608022) strcat(s, "f");
if (crc32("sdFrzUaXje",10) == 1925913509) strcat(s, "i");
if (crc32("IUgmfKQonQjhuQ",14) == 3804324970) strcat(s, "s");
if (crc32("GYKrdanU",8) == 2343594758) strcat(s, "I");
if (crc32("qgrplhgGvUegaA",14) == 2235547758) strcat(s, "h");
    return s;
}

char *mage_nouns() {
    char *s = calloc(5);
    if (crc32("DIHijXQzTyw",11) == 1351905946) strcat(s, "m");
if (crc32("IgGQZRfisLv",11) == 1492517853) strcat(s, "V");
if (crc32("lSqqv",5) == 2569622468) strcat(s, "a");
if (crc32("hpNRolX",7) == 1093201782) strcat(s, "D");
if (crc32("VJwKJZfHHxpDT",13) == 600912278) strcat(s, "g");
if (crc32("xXTYQfAWBOkf",12) == 2761746235) strcat(s, "s");
if (crc32("UGgsJctceVWAxE",14) == 3731696420) strcat(s, "e");
    return s;
}

char *Joseph_nouns() {
    char *s = calloc(7);
    if (crc32("NpIqjQOj",8) == 3134965034) strcat(s, "J");
if (crc32("qpLqalfxaPtArH",14) == 1345002338) strcat(s, "o");
if (crc32("BBRvMd",6) == 4010886703) strcat(s, "s");
if (crc32("bUDwk",5) == 2501435702) strcat(s, "T");
if (crc32("bqebcxlHfgqYnMc",15) == 2906425387) strcat(s, "e");
if (crc32("nwbFghwAwD",10) == 2745491635) strcat(s, "v");
if (crc32("iWjdLaOilS",10) == 2232071997) strcat(s, "p");
if (crc32("nKTXhZmD",8) == 1198024289) strcat(s, "h");
    return s;
}

char *parroket_nouns() {
    char *s = calloc(9);
    if (crc32("IKIncqVHvCJAxDS",15) == 3190237507) strcat(s, "p");
if (crc32("RDzErANng",9) == 1810802295) strcat(s, "F");
if (crc32("zjLCXjLpMtmG",12) == 1315629343) strcat(s, "a");
if (crc32("EnfkLsiLF",9) == 2705435508) strcat(s, "B");
if (crc32("xksVGlHtZMfX",12) == 1017307559) strcat(s, "r");
if (crc32("iYqBHuVZP",9) == 591613514) strcat(s, "r");
if (crc32("wvuDTNBEbjHsY",13) == 1531794012) strcat(s, "o");
if (crc32("qzOFXQ",6) == 1260812815) strcat(s, "l");
if (crc32("pzEwCFdqSkzMh",13) == 3008481880) strcat(s, "k");
if (crc32("lUHowS",6) == 2972728713) strcat(s, "e");
if (crc32("ZNgqBg",6) == 424638651) strcat(s, "t");
    return s;
}

char *lancination_nouns() {
    char *s = calloc(12);
    if (crc32("OppgLNnr",8) == 4207476927) strcat(s, "E");
if (crc32("ByrqHeOt",8) == 3305600322) strcat(s, "l");
if (crc32("PoxlTfmcSzOCwDs",15) == 1560086463) strcat(s, "G");
if (crc32("AGdHLiVfZbarAc",14) == 580151651) strcat(s, "a");
if (crc32("GbHXXmj",7) == 543026361) strcat(s, "n");
if (crc32("eHvFjHNbayuL",12) == 3607588581) strcat(s, "m");
if (crc32("QJTHJKZv",8) == 2451432640) strcat(s, "c");
if (crc32("gPjRmmqF",8) == 1346475886) strcat(s, "o");
if (crc32("VOinkQKWArvEG",13) == 2164886851) strcat(s, "i");
if (crc32("JeUItouvrlvQGt",14) == 2652292930) strcat(s, "n");
if (crc32("psOvsFdLERmaG",13) == 1834510733) strcat(s, "i");
if (crc32("rWoLLkstLNcg",12) == 3133981504) strcat(s, "a");
if (crc32("AVjEo",5) == 1486118885) strcat(s, "t");
if (crc32("ZPjImUJZNunnt",13) == 3251331761) strcat(s, "V");
if (crc32("ykuBNglvrUxXRjt",15) == 1058751372) strcat(s, "i");
if (crc32("jkEiHwGm",8) == 2204692918) strcat(s, "V");
if (crc32("ULZNhhaAuAkYzso",15) == 3485791517) strcat(s, "o");
if (crc32("yTkmmiRIqS",10) == 3287236870) strcat(s, "x");
if (crc32("JdjDQMqv",8) == 573264357) strcat(s, "n");
    return s;
}

char *parging_nouns() {
    char *s = calloc(8);
    if (crc32("FGWJmH",6) == 627627865) strcat(s, "H");
if (crc32("aDPivuvJcSkytV",14) == 3994516592) strcat(s, "p");
if (crc32("AxJCTUDRW",9) == 3503475431) strcat(s, "d");
if (crc32("JHFOLPjOQNdeg",13) == 2851575511) strcat(s, "a");
if (crc32("YbqmmPWDMHZpoQw",15) == 4221903327) strcat(s, "r");
if (crc32("DeZESEgVWxellN",14) == 2048692100) strcat(s, "g");
if (crc32("GsWnmUiv",8) == 34727978) strcat(s, "i");
if (crc32("hGdAvUUasAySzb",14) == 1711118735) strcat(s, "p");
if (crc32("DbOZOPcAvs",10) == 1609119400) strcat(s, "n");
if (crc32("iMqriAg",7) == 1219630210) strcat(s, "g");
    return s;
}

char *tympany_nouns() {
    char *s = calloc(8);
    if (crc32("omSBkIfBTJHvAb",14) == 3284346212) strcat(s, "M");
if (crc32("VhskRjMyB",9) == 1406784815) strcat(s, "t");
if (crc32("aYuVZdjQCoFxJ",13) == 1687941092) strcat(s, "y");
if (crc32("tULrkAF",7) == 3076706685) strcat(s, "m");
if (crc32("dieVrJGeTHbU",12) == 1983076493) strcat(s, "p");
if (crc32("DkWsxxjzYtb",11) == 1955137927) strcat(s, "a");
if (crc32("cyJhh",5) == 2647070021) strcat(s, "n");
if (crc32("CLUSHRHvqANi",12) == 3615244073) strcat(s, "y");
    return s;
}

char *Litchfield_nouns() {
    char *s = calloc(11);
    if (crc32("eCCGP",5) == 3101573980) strcat(s, "L");
if (crc32("BeeRFVKNlqz",11) == 3967282559) strcat(s, "o");
if (crc32("UHsnuPegFJW",11) == 759142417) strcat(s, "i");
if (crc32("uCgKeaehdaWnYln",15) == 172559082) strcat(s, "t");
if (crc32("hGBmqnchNGjLOp",14) == 4212595428) strcat(s, "V");
if (crc32("GyupOithwltqdL",14) == 2568502) strcat(s, "c");
if (crc32("xwGOAHlrRLro",12) == 1787476608) strcat(s, "p");
if (crc32("CqUlpBY",7) == 771476089) strcat(s, "h");
if (crc32("ooaQmPQFNnq",11) == 2710036050) strcat(s, "Y");
if (crc32("JfQuRRFMyFmNk",13) == 2265708306) strcat(s, "f");
if (crc32("RbeELSbVImebySO",15) == 3688435816) strcat(s, "x");
if (crc32("rShevQwY",8) == 2113696258) strcat(s, "i");
if (crc32("awkHGj",6) == 2575040862) strcat(s, "o");
if (crc32("ZFoTUczwt",9) == 3010907397) strcat(s, "e");
if (crc32("vJucscSYEtZHmJ",14) == 3956013269) strcat(s, "l");
if (crc32("nzCJWaaQG",9) == 1166413911) strcat(s, "g");
if (crc32("wLSeceJyYs",10) == 533739831) strcat(s, "d");
    return s;
}

char *Sliwa_nouns() {
    char *s = calloc(6);
    if (crc32("sYVKnaizCmTy",12) == 2309402707) strcat(s, "S");
if (crc32("LBgouDpjSpoUUds",15) == 614754313) strcat(s, "l");
if (crc32("xQMOYKAgw",9) == 62891701) strcat(s, "i");
if (crc32("KbhOfz",6) == 3268671738) strcat(s, "D");
if (crc32("JNYktVblnVbB",12) == 3015218621) strcat(s, "w");
if (crc32("UjpcWqHanscIs",13) == 111374501) strcat(s, "E");
if (crc32("ivECxxFjGbiFV",13) == 1029467013) strcat(s, "a");
    return s;
}

char *sextuplicate_nouns() {
    char *s = calloc(13);
    if (crc32("ijbgqpWuARlKzVS",15) == 1213272037) strcat(s, "M");
if (crc32("kXrPChDCWR",10) == 4162603059) strcat(s, "s");
if (crc32("GntufcZUhYPZcHm",15) == 3458260166) strcat(s, "T");
if (crc32("FQnxkzeWGo",10) == 3650026393) strcat(s, "e");
if (crc32("NSFqTOtOudaqkh",14) == 3337164) strcat(s, "x");
if (crc32("eGstvYqlfhqP",12) == 3310135766) strcat(s, "X");
if (crc32("gkYfzZngrp",10) == 2952738596) strcat(s, "t");
if (crc32("wOqqcVmNtpJM",12) == 1870347853) strcat(s, "u");
if (crc32("snzUWlI",7) == 2561483942) strcat(s, "i");
if (crc32("BankFuvQFRfFgO",14) == 3955614037) strcat(s, "p");
if (crc32("QVIUrdhFRZr",11) == 1736631754) strcat(s, "l");
if (crc32("VpDOVwB",7) == 684860767) strcat(s, "i");
if (crc32("VCZdAxnbHERJ",12) == 2504605405) strcat(s, "c");
if (crc32("lwFXxJRmpVvxRKL",15) == 2904216171) strcat(s, "n");
if (crc32("QSjabdI",7) == 2265903223) strcat(s, "a");
if (crc32("NkPJmnha",8) == 3921903526) strcat(s, "h");
if (crc32("QymTTqJnUdKGeu",14) == 761522392) strcat(s, "t");
if (crc32("ktoGAnzhUBeATK",14) == 4040826537) strcat(s, "h");
if (crc32("pvZfnjEfOso",11) == 3245050999) strcat(s, "e");
    return s;
}

char *Tchao_nouns() {
    char *s = calloc(6);
    if (crc32("ynPmuT",6) == 2500214795) strcat(s, "g");
if (crc32("rdIEv",5) == 3126328800) strcat(s, "T");
if (crc32("wMGgSIcxPgoz",12) == 1901945832) strcat(s, "N");
if (crc32("rfoEEOkANjMizS",14) == 1881828071) strcat(s, "c");
if (crc32("xpRuE",5) == 1601781501) strcat(s, "h");
if (crc32("LvzODFkQ",8) == 515301875) strcat(s, "a");
if (crc32("PQnvdzZuyO",10) == 3145564786) strcat(s, "o");
    return s;
}

char *Buckley_nouns() {
    char *s = calloc(8);
    if (crc32("jaFvfFKNvlh",11) == 2679962975) strcat(s, "B");
if (crc32("iRBPSSzwXI",10) == 122084636) strcat(s, "u");
if (crc32("ZGAFoDm",7) == 937770674) strcat(s, "c");
if (crc32("CNwEwlftc",9) == 2732503459) strcat(s, "F");
if (crc32("vBHrvTIb",8) == 460756372) strcat(s, "k");
if (crc32("TDVhTfqgJ",9) == 4204400420) strcat(s, "l");
if (crc32("gCWqrMAYWn",10) == 972643051) strcat(s, "D");
if (crc32("RYkIKDIMfpTOR",13) == 2702386921) strcat(s, "e");
if (crc32("eJAtSpDhdsx",11) == 2105801624) strcat(s, "y");
    return s;
}

char *vauntcourier_nouns() {
    char *s = calloc(13);
    if (crc32("PRTpQHZAEsU",11) == 721129966) strcat(s, "i");
if (crc32("igThoEkaOS",10) == 3595549752) strcat(s, "v");
if (crc32("NyUQfcTA",8) == 3885327860) strcat(s, "m");
if (crc32("TmpIPiKonCDtnay",15) == 4084376094) strcat(s, "a");
if (crc32("gDolI",5) == 534171217) strcat(s, "I");
if (crc32("agTCiPXUqRGZmc",14) == 2317171081) strcat(s, "u");
if (crc32("zyWqBlp",7) == 1253757961) strcat(s, "n");
if (crc32("JiuFsPV",7) == 2564875581) strcat(s, "A");
if (crc32("gciofBiIeOe",11) == 224270121) strcat(s, "t");
if (crc32("RiqwtNLhyN",10) == 1752239261) strcat(s, "c");
if (crc32("GFiHleaQDJv",11) == 172489752) strcat(s, "o");
if (crc32("hNlsgrRknDaeZI",14) == 223296930) strcat(s, "u");
if (crc32("zenJydRpBk",10) == 1325357415) strcat(s, "W");
if (crc32("sFSiERQIsBrHsaM",15) == 1370062358) strcat(s, "r");
if (crc32("iDyMakFnuw",10) == 2526058881) strcat(s, "i");
if (crc32("URfyD",5) == 2235294977) strcat(s, "n");
if (crc32("nxOVwLUIJLE",11) == 2115252631) strcat(s, "e");
if (crc32("JBTJqoq",7) == 3451434874) strcat(s, "v");
if (crc32("vmkrcXUVKdXe",12) == 898592892) strcat(s, "r");
    return s;
}

char *favourer_nouns() {
    char *s = calloc(9);
    if (crc32("MrMvucYHdpr",11) == 1149016556) strcat(s, "f");
if (crc32("GYgTPJLojHhJGf",14) == 3770389026) strcat(s, "o");
if (crc32("JLSyusyYYyGOCZ",14) == 2235095728) strcat(s, "a");
if (crc32("qybitmFGIf",10) == 492753084) strcat(s, "W");
if (crc32("CrRKxKHLpouQlnI",15) == 4098501142) strcat(s, "v");
if (crc32("zHCRmBZZoGEmUeg",15) == 2703566165) strcat(s, "o");
if (crc32("KxMCITBr",8) == 1569555537) strcat(s, "N");
if (crc32("TxmpyUVwOiUw",12) == 184039019) strcat(s, "u");
if (crc32("SyiKYWMu",8) == 2112701848) strcat(s, "r");
if (crc32("iaXXQZqEgAAWED",14) == 1931570002) strcat(s, "y");
if (crc32("IPvvhfz",7) == 3171206039) strcat(s, "e");
if (crc32("iCyPYUqfNg",10) == 4283573142) strcat(s, "d");
if (crc32("GwXaHYdSAew",11) == 460779328) strcat(s, "r");
    return s;
}

char *dialectic_nouns() {
    char *s = calloc(10);
    if (crc32("vbvMAaWxGQqmLs",14) == 2752602448) strcat(s, "p");
if (crc32("LOedtPmxfmG",11) == 889240904) strcat(s, "d");
if (crc32("MKERm",5) == 3884702145) strcat(s, "i");
if (crc32("OyMKoySlvFBVr",13) == 3812313313) strcat(s, "a");
if (crc32("NVhibivtSruDp",13) == 625606424) strcat(s, "x");
if (crc32("TnkAlIpfxCwX",12) == 888829326) strcat(s, "l");
if (crc32("cvHkcr",6) == 634486782) strcat(s, "F");
if (crc32("wobGR",5) == 2677791427) strcat(s, "e");
if (crc32("ytdHgpBfVRBm",12) == 34976729) strcat(s, "I");
if (crc32("QDxnWrp",7) == 3131247684) strcat(s, "c");
if (crc32("LOGIlosMNPjQWAW",15) == 3997661211) strcat(s, "t");
if (crc32("QTVkcSSaPO",10) == 3341939823) strcat(s, "I");
if (crc32("HBlfOXqiuoJPAw",14) == 3435634357) strcat(s, "i");
if (crc32("ulolNkYb",8) == 79341653) strcat(s, "S");
if (crc32("LEOdK",5) == 1823610396) strcat(s, "c");
    return s;
}

char *Farver_nouns() {
    char *s = calloc(7);
    if (crc32("dzbCwYpDnMrsbvV",15) == 3810394804) strcat(s, "F");
if (crc32("aFlsXcXQ",8) == 203149829) strcat(s, "V");
if (crc32("mzfAxRbcpVwy",12) == 3729639373) strcat(s, "a");
if (crc32("CadCTVyV",8) == 862768746) strcat(s, "r");
if (crc32("VRWOcHtXK",9) == 2828551662) strcat(s, "v");
if (crc32("fsYoaVniatBjgj",14) == 406483690) strcat(s, "e");
if (crc32("pAaly",5) == 762333115) strcat(s, "b");
if (crc32("YJEzWz",6) == 948350540) strcat(s, "r");
    return s;
}

char *subinfection_nouns() {
    char *s = calloc(13);
    if (crc32("QjLLePO",7) == 1771405300) strcat(s, "x");
if (crc32("kCBPIHhPSnrs",12) == 1473526492) strcat(s, "s");
if (crc32("iMtPPUUQn",9) == 457700043) strcat(s, "c");
if (crc32("jXIWdrSIyFAG",12) == 2617566595) strcat(s, "u");
if (crc32("SUKKgbWMzt",10) == 3786717218) strcat(s, "b");
if (crc32("PPrJMRlvsVDeGJ",14) == 1963891911) strcat(s, "i");
if (crc32("temGyWYylBrfGWR",15) == 3160049514) strcat(s, "f");
if (crc32("bASwWHPKARNU",12) == 1549452184) strcat(s, "n");
if (crc32("HxdZVJeEHZcMS",13) == 1340915369) strcat(s, "I");
if (crc32("TeeJLsyheeKQA",13) == 3659355135) strcat(s, "f");
if (crc32("hOlRrGxSUlo",11) == 924198564) strcat(s, "B");
if (crc32("QUOOgKXo",8) == 3703544590) strcat(s, "e");
if (crc32("ouZLFeSRgOaGUs",14) == 2483566315) strcat(s, "G");
if (crc32("qGckOSHEpapH",12) == 992307742) strcat(s, "c");
if (crc32("mSIclmGeMznHP",13) == 2069634699) strcat(s, "t");
if (crc32("GVmjoNOr",8) == 2973548349) strcat(s, "t");
if (crc32("rtyGurHXtO",10) == 3339234994) strcat(s, "i");
if (crc32("fFiInxLGtGSDI",13) == 2996233563) strcat(s, "o");
if (crc32("eaJWJJtDAQtutv",14) == 1580078759) strcat(s, "n");
    return s;
}

char *Ferneau_nouns() {
    char *s = calloc(8);
    if (crc32("BifxfK",6) == 4051098358) strcat(s, "F");
if (crc32("FMrwBjkefplH",12) == 3235625603) strcat(s, "X");
if (crc32("sRacAriCLjync",13) == 2122519478) strcat(s, "e");
if (crc32("tdKIdepRLVtsf",13) == 2103408996) strcat(s, "r");
if (crc32("XmKTvFIu",8) == 2585523798) strcat(s, "n");
if (crc32("TeiZhvR",7) == 2560164601) strcat(s, "e");
if (crc32("jnnVnlZDel",10) == 4187007483) strcat(s, "M");
if (crc32("hAUHGiJEjwHOFA",14) == 2226973140) strcat(s, "a");
if (crc32("dAvdJwbxOgN",11) == 1456590028) strcat(s, "u");
    return s;
}

char *overcomplacency_nouns() {
    char *s = calloc(16);
    if (crc32("QbkmgojxJ",9) == 1355660104) strcat(s, "o");
if (crc32("iSlbOGtkXChKMcv",15) == 1267310006) strcat(s, "E");
if (crc32("GoOIDKPnRIB",11) == 1669414269) strcat(s, "v");
if (crc32("aJyMLGcR",8) == 2062868982) strcat(s, "e");
if (crc32("XWkocCxo",8) == 493230949) strcat(s, "r");
if (crc32("EYgrRjTlMhnPUY",14) == 4049010282) strcat(s, "c");
if (crc32("fPbKfdeK",8) == 2002425270) strcat(s, "k");
if (crc32("kZczRcAVHNXV",12) == 3986542357) strcat(s, "o");
if (crc32("PXiyAdOfXsda",12) == 3854132430) strcat(s, "m");
if (crc32("SoHNIvc",7) == 2822160088) strcat(s, "h");
if (crc32("XFRiQjWShcpJt",13) == 1329045868) strcat(s, "p");
if (crc32("vUvYoCTVP",9) == 2729694584) strcat(s, "l");
if (crc32("JoJGZAvHKjWJfIb",15) == 527271862) strcat(s, "y");
if (crc32("dJZWJPtPKfFui",13) == 4091499360) strcat(s, "a");
if (crc32("vbUjKH",6) == 1565689176) strcat(s, "c");
if (crc32("agVTEtHO",8) == 29851209) strcat(s, "e");
if (crc32("eUHlbZUTQOaoja",14) == 1451932020) strcat(s, "G");
if (crc32("sQfJSADcWuekBPg",15) == 1502728790) strcat(s, "n");
if (crc32("gAyqwzDtIGJguY",14) == 973245176) strcat(s, "j");
if (crc32("gsabG",5) == 1658597171) strcat(s, "c");
if (crc32("NrQEpuFACdNCw",13) == 1915213063) strcat(s, "y");
    return s;
}

char *Mures_nouns() {
    char *s = calloc(6);
    if (crc32("PDIakTzwFwNxmE",14) == 3234685507) strcat(s, "M");
if (crc32("LNpZFVNY",8) == 3332013486) strcat(s, "d");
if (crc32("CqHOgbnxJxac",12) == 3029303073) strcat(s, "u");
if (crc32("wkHPcQf",7) == 1225345100) strcat(s, "K");
if (crc32("LHaynMNIohRmIpB",15) == 3552533809) strcat(s, "r");
if (crc32("NGCHkKfWIg",10) == 1243919219) strcat(s, "o");
if (crc32("oGXAVsHMhHJNO",13) == 885698952) strcat(s, "e");
if (crc32("IDnAIMGaik",10) == 4187855786) strcat(s, "Y");
if (crc32("oupjJXkLlQSn",12) == 3777444053) strcat(s, "s");
    return s;
}

char *Loftus_nouns() {
    char *s = calloc(7);
    if (crc32("VYFbpnJOWVUHXUd",15) == 3702258449) strcat(s, "L");
if (crc32("aNZwGlFI",8) == 1850998747) strcat(s, "V");
if (crc32("DMObSurBtyQ",11) == 3204649873) strcat(s, "o");
if (crc32("MGtyKNkYmeGNIs",14) == 2870427426) strcat(s, "V");
if (crc32("RwLSEEdpkIDzBD",14) == 2567829242) strcat(s, "f");
if (crc32("jRjlAER",7) == 1554237981) strcat(s, "R");
if (crc32("PFPqNqYQxuCFuH",14) == 1104503771) strcat(s, "t");
if (crc32("GxFFOOGcLd",10) == 1649564127) strcat(s, "u");
if (crc32("jhBGQQX",7) == 3650345755) strcat(s, "s");
    return s;
}

char *Deanne_nouns() {
    char *s = calloc(7);
    if (crc32("SoMsOoBJhpv",11) == 3939703583) strcat(s, "D");
if (crc32("wvorDMMNKL",10) == 2270269043) strcat(s, "j");
if (crc32("xrurpDvmZXOI",12) == 802936882) strcat(s, "e");
if (crc32("nJYwl",5) == 1402884373) strcat(s, "a");
if (crc32("lAgiviNOLj",10) == 443191539) strcat(s, "G");
if (crc32("kkCpgEIqVeZt",12) == 1131436170) strcat(s, "n");
if (crc32("dBeLK",5) == 3335203515) strcat(s, "j");
if (crc32("FDKymKumhcUg",12) == 1878424531) strcat(s, "n");
if (crc32("lEtsKFfAU",9) == 2279023572) strcat(s, "e");
    return s;
}

char *Mary_nouns() {
    char *s = calloc(5);
    if (crc32("aLSwsADpg",9) == 3248068078) strcat(s, "M");
if (crc32("YSABrEGZssTJA",13) == 1125402912) strcat(s, "J");
if (crc32("mdQhLneq",8) == 2477144780) strcat(s, "a");
if (crc32("aKcZQyFHvcfPBx",14) == 215596970) strcat(s, "f");
if (crc32("GbbDwPULgRXB",12) == 109293081) strcat(s, "r");
if (crc32("khpKICswaPUH",12) == 3316574600) strcat(s, "u");
if (crc32("XsmmAXeTB",9) == 811906945) strcat(s, "y");
    return s;
}

char *tagrag_nouns() {
    char *s = calloc(7);
    if (crc32("EIDLReuOZwdPFVG",15) == 3403569702) strcat(s, "O");
if (crc32("dgRFCNvgB",9) == 3597252834) strcat(s, "t");
if (crc32("BdgTlDaAUenHka",14) == 2717948450) strcat(s, "i");
if (crc32("EttFuzqGfRyF",12) == 1509312038) strcat(s, "a");
if (crc32("ANfyoBkhnnsAS",13) == 1548461295) strcat(s, "W");
if (crc32("TunYVN",6) == 3539896247) strcat(s, "g");
if (crc32("RuYTt",5) == 851575634) strcat(s, "r");
if (crc32("iIeih",5) == 3326329780) strcat(s, "x");
if (crc32("IZjuDPpiWRx",11) == 4192201727) strcat(s, "a");
if (crc32("kKoaAWu",7) == 948552918) strcat(s, "M");
if (crc32("GtdLOG",6) == 4249898609) strcat(s, "g");
    return s;
}

char *vagotomy_nouns() {
    char *s = calloc(9);
    if (crc32("rMybZsSgjEqadt",14) == 3226648608) strcat(s, "D");
if (crc32("aQuBIYxhgbW",11) == 1610177480) strcat(s, "v");
if (crc32("ZjZHkvSaQIVqcon",15) == 3537429996) strcat(s, "T");
if (crc32("aurwTVlqRupmuOE",15) == 2453061108) strcat(s, "a");
if (crc32("bbqvzQdLpZaMsf",14) == 3651539471) strcat(s, "z");
if (crc32("RLQMK",5) == 2626970084) strcat(s, "g");
if (crc32("fnfuZ",5) == 3301459261) strcat(s, "O");
if (crc32("xRzgcFo",7) == 662781481) strcat(s, "o");
if (crc32("ggXbkfDb",8) == 3676297373) strcat(s, "e");
if (crc32("ZyEkPwRbx",9) == 1857858977) strcat(s, "t");
if (crc32("Icjgs",5) == 118417582) strcat(s, "H");
if (crc32("KwUMA",5) == 831695477) strcat(s, "o");
if (crc32("rLGCwEFJt",9) == 2162125922) strcat(s, "m");
if (crc32("UfPUIvwnaPD",11) == 2758726366) strcat(s, "C");
if (crc32("pvHJFiVf",8) == 114010864) strcat(s, "y");
    return s;
}

char *Almira_nouns() {
    char *s = calloc(7);
    if (crc32("wWGRleqdg",9) == 982279972) strcat(s, "A");
if (crc32("GGqZe",5) == 3404748669) strcat(s, "G");
if (crc32("yLtNQDXCQ",9) == 1574699547) strcat(s, "l");
if (crc32("oJZnUKJEjYYurUD",15) == 1457249626) strcat(s, "R");
if (crc32("vNUxniCIQSC",11) == 2752747117) strcat(s, "m");
if (crc32("PUIIeha",7) == 3593675007) strcat(s, "N");
if (crc32("ahDeaerL",8) == 2881766123) strcat(s, "i");
if (crc32("zUVGeA",6) == 1768614496) strcat(s, "r");
if (crc32("jLYHQyXMoqA",11) == 2677508559) strcat(s, "R");
if (crc32("oGXYiFkFPbQZ",12) == 1609393499) strcat(s, "a");
    return s;
}

char *classicality_nouns() {
    char *s = calloc(13);
    if (crc32("VbdcNInNo",9) == 1953994593) strcat(s, "c");
if (crc32("SZENwTdJTJnRi",13) == 3032187294) strcat(s, "e");
if (crc32("ssSNKAt",7) == 199711218) strcat(s, "l");
if (crc32("lOrwrQuzNkwhzk",14) == 2903993622) strcat(s, "a");
if (crc32("dXbbhjpBcfwggZV",15) == 284711727) strcat(s, "s");
if (crc32("tMGoniVOg",9) == 1204372702) strcat(s, "X");
if (crc32("RzFRIQtO",8) == 2277073582) strcat(s, "s");
if (crc32("LoHAkeV",7) == 1184659540) strcat(s, "a");
if (crc32("RafJqkhw",8) == 1732912676) strcat(s, "i");
if (crc32("tbfUOCxNfGURW",13) == 497334859) strcat(s, "c");
if (crc32("EITzekQy",8) == 867309496) strcat(s, "a");
if (crc32("pRMLQ",5) == 1712762627) strcat(s, "l");
if (crc32("qfTbIXxhASJ",11) == 1159426152) strcat(s, "i");
if (crc32("JCFOLpdYuGPjyDp",15) == 640168626) strcat(s, "t");
if (crc32("RPakXGlBb",9) == 2397556073) strcat(s, "y");
    return s;
}

char *numerosity_nouns() {
    char *s = calloc(11);
    if (crc32("HMEGkjWlqOQcirH",15) == 1972651996) strcat(s, "k");
if (crc32("iaojifDTBYbCnfn",15) == 4118499150) strcat(s, "n");
if (crc32("JqQSnzvooLdDIQ",14) == 2655539617) strcat(s, "d");
if (crc32("PdKMbcPVyWQ",11) == 3554722951) strcat(s, "u");
if (crc32("wywMqkL",7) == 374500445) strcat(s, "m");
if (crc32("JhVSFHGXZLsXlp",14) == 505123206) strcat(s, "j");
if (crc32("fDqHTrB",7) == 2512382674) strcat(s, "e");
if (crc32("XgbUdiu",7) == 1544071760) strcat(s, "r");
if (crc32("kZXmWMPuaRYuanh",15) == 51773406) strcat(s, "o");
if (crc32("AEKxWmHpfyTuCuQ",15) == 3431749439) strcat(s, "s");
if (crc32("zbrBbkNJT",9) == 3964093216) strcat(s, "D");
if (crc32("XfbFNJi",7) == 1250584988) strcat(s, "i");
if (crc32("wHjPTRVr",8) == 4276495087) strcat(s, "H");
if (crc32("YiCuC",5) == 2051951662) strcat(s, "t");
if (crc32("vIedcsnHi",9) == 4028014861) strcat(s, "y");
    return s;
}

char *Armyn_nouns() {
    char *s = calloc(6);
    if (crc32("fFNclDSm",8) == 3633206795) strcat(s, "q");
if (crc32("DQwNEwrvR",9) == 770190798) strcat(s, "A");
if (crc32("AUZmxaOXNv",10) == 2983694922) strcat(s, "r");
if (crc32("lKDrDt",6) == 1638484906) strcat(s, "m");
if (crc32("JQmXaykfTgNJxj",14) == 354519344) strcat(s, "y");
if (crc32("dwIPqSgjA",9) == 3908228626) strcat(s, "B");
if (crc32("jeJoXZmxoqx",11) == 4113695104) strcat(s, "n");
    return s;
}

char *adjuror_nouns() {
    char *s = calloc(8);
    if (crc32("xbNYkaACLjrN",12) == 1786049618) strcat(s, "J");
if (crc32("ZZyhugXyAReNw",13) == 464478372) strcat(s, "a");
if (crc32("VEYMQ",5) == 634981001) strcat(s, "a");
if (crc32("YUrcOAafdQS",11) == 1698461334) strcat(s, "d");
if (crc32("blXYMyP",7) == 2542729929) strcat(s, "V");
if (crc32("fpbkoFtAjBVK",12) == 3102111289) strcat(s, "j");
if (crc32("PgnaxNxSre",10) == 3449703637) strcat(s, "t");
if (crc32("xYZLNVp",7) == 216728518) strcat(s, "u");
if (crc32("WjBWoXmhNXISjJM",15) == 3130611666) strcat(s, "H");
if (crc32("JgAYVqMTAG",10) == 471790347) strcat(s, "r");
if (crc32("guxPCmqmAMxLyBZ",15) == 539106887) strcat(s, "o");
if (crc32("DRJChxTbMMdVEw",14) == 3174551058) strcat(s, "r");
    return s;
}

char *tovarisch_nouns() {
    char *s = calloc(10);
    if (crc32("ZSYrTVocJvsoYSk",15) == 1245642026) strcat(s, "t");
if (crc32("DONAtwXXNvDAfjf",15) == 1241406732) strcat(s, "o");
if (crc32("WBqWZBKbXIznKG",14) == 1202139291) strcat(s, "V");
if (crc32("clixymUU",8) == 469504051) strcat(s, "v");
if (crc32("LicyyimQn",9) == 2083592018) strcat(s, "a");
if (crc32("GxBFAiug",8) == 3924703968) strcat(s, "r");
if (crc32("dGbRhaqUeh",10) == 1780436232) strcat(s, "e");
if (crc32("MSmXcKHmcwBk",12) == 588622259) strcat(s, "i");
if (crc32("kIfpbbhG",8) == 2175748860) strcat(s, "s");
if (crc32("DzxKHpkPeA",10) == 2885481945) strcat(s, "c");
if (crc32("PJkByMSJOmkZQ",13) == 1814265898) strcat(s, "h");
    return s;
}

char *Shiller_nouns() {
    char *s = calloc(8);
    if (crc32("FlXepIb",7) == 401362767) strcat(s, "S");
if (crc32("EXfTWdaU",8) == 2042141190) strcat(s, "h");
if (crc32("GmIODPmDTSiwDgO",15) == 967633249) strcat(s, "B");
if (crc32("sIlyoTGJaJQal",13) == 2376889606) strcat(s, "i");
if (crc32("VWcLtQccFC",10) == 2555101196) strcat(s, "B");
if (crc32("KcmkXxKJRravkgK",15) == 2005927954) strcat(s, "l");
if (crc32("aJpgY",5) == 4115809430) strcat(s, "G");
if (crc32("WDCMisatvwdT",12) == 2689865343) strcat(s, "l");
if (crc32("BstIhdB",7) == 778964758) strcat(s, "l");
if (crc32("CyzjX",5) == 1820495359) strcat(s, "e");
if (crc32("QGGurgHdUhCtff",14) == 2255554603) strcat(s, "a");
if (crc32("IiehSHQm",8) == 2335678520) strcat(s, "r");
    return s;
}

char *Basile_nouns() {
    char *s = calloc(7);
    if (crc32("vrZFWeWI",8) == 3966766195) strcat(s, "B");
if (crc32("IGMTUrUGOvbVddc",15) == 2455907278) strcat(s, "a");
if (crc32("gRrNnQjARn",10) == 1184730382) strcat(s, "s");
if (crc32("QcgLtQEoq",9) == 656017822) strcat(s, "i");
if (crc32("uThLlVAGKqpzoh",14) == 406379928) strcat(s, "l");
if (crc32("vKUzWoLynEK",11) == 2763172336) strcat(s, "e");
    return s;
}

char *citrine_nouns() {
    char *s = calloc(8);
    if (crc32("kbByECAUenIrT",13) == 3709869412) strcat(s, "v");
if (crc32("rOpFMQ",6) == 1796784949) strcat(s, "c");
if (crc32("ycCEqYBS",8) == 4118762334) strcat(s, "i");
if (crc32("jRgsfPquNWNzt",13) == 2902694636) strcat(s, "t");
if (crc32("SnQLvIHGRCgkK",13) == 1994307867) strcat(s, "r");
if (crc32("vnWMWGi",7) == 1964319148) strcat(s, "Z");
if (crc32("CgSfJIoKkCI",11) == 1170246276) strcat(s, "i");
if (crc32("uZrdIaXdr",9) == 2260761574) strcat(s, "g");
if (crc32("zXfudLLeLw",10) == 1621768741) strcat(s, "n");
if (crc32("AXnrRad",7) == 3009983678) strcat(s, "m");
if (crc32("MnXhagcZEDEij",13) == 1508523736) strcat(s, "e");
    return s;
}

char *heme_nouns() {
    char *s = calloc(5);
    if (crc32("iOFrKcVMrkhr",12) == 3840517075) strcat(s, "h");
if (crc32("buipksd",7) == 3293199419) strcat(s, "P");
if (crc32("MTWPgwxUICqeKT",14) == 2720498721) strcat(s, "e");
if (crc32("ZQHxTYLplYrJEjr",15) == 528338701) strcat(s, "m");
if (crc32("FlBklezwUlzh",12) == 2981788993) strcat(s, "r");
if (crc32("WKfjto",6) == 1111086758) strcat(s, "e");
    return s;
}

char *Viglione_nouns() {
    char *s = calloc(9);
    if (crc32("lzOdAKnpAvLXQ",13) == 2566961716) strcat(s, "V");
if (crc32("jLRQljpQOVXpEX",14) == 299495756) strcat(s, "i");
if (crc32("CqnGkyfTkPS",11) == 575349692) strcat(s, "q");
if (crc32("QSzMnndXlXNpRGM",15) == 656817007) strcat(s, "g");
if (crc32("MXixTgCotHD",11) == 4151912928) strcat(s, "l");
if (crc32("iNkOYdxxlqSEX",13) == 4129912220) strcat(s, "x");
if (crc32("QCmIK",5) == 3393901202) strcat(s, "i");
if (crc32("htGzw",5) == 772987829) strcat(s, "l");
if (crc32("aIvBJUBq",8) == 741052988) strcat(s, "o");
if (crc32("eGnbnBBwFMDN",12) == 3399560569) strcat(s, "C");
if (crc32("ycQYwfjzQn",10) == 2818261318) strcat(s, "n");
if (crc32("TxmJCYdiZI",10) == 3007494589) strcat(s, "e");
    return s;
}

char *Philina_nouns() {
    char *s = calloc(8);
    if (crc32("opusaWyVzBg",11) == 2820202311) strcat(s, "P");
if (crc32("kLTgnTK",7) == 2058702245) strcat(s, "h");
if (crc32("tkEJLXINXd",10) == 2098280723) strcat(s, "A");
if (crc32("iMRWb",5) == 33575928) strcat(s, "i");
if (crc32("sriugO",6) == 1739447856) strcat(s, "l");
if (crc32("tpEJsfthb",9) == 2730063780) strcat(s, "i");
if (crc32("pyFJUMPuyl",10) == 4137870460) strcat(s, "t");
if (crc32("dXRdPxOuwZ",10) == 626501037) strcat(s, "n");
if (crc32("JHfqAjEhwoUQko",14) == 4219818824) strcat(s, "a");
    return s;
}

char *nonsoldier_nouns() {
    char *s = calloc(11);
    if (crc32("JVxXFAyHtWUjf",13) == 1367637180) strcat(s, "Q");
if (crc32("dpGqQJl",7) == 4077598610) strcat(s, "n");
if (crc32("ifmwBhhLxBSW",12) == 3701801627) strcat(s, "f");
if (crc32("RYXauXBGBYDbSYZ",15) == 605113578) strcat(s, "o");
if (crc32("iUbkZ",5) == 102770423) strcat(s, "V");
if (crc32("rsYHvtrZV",9) == 1210290798) strcat(s, "n");
if (crc32("JkcWqWQlmaOOpdH",15) == 3647684064) strcat(s, "s");
if (crc32("TWozRvsXe",9) == 1419320265) strcat(s, "o");
if (crc32("lIJuyvlcIHg",11) == 259992733) strcat(s, "D");
if (crc32("rAbBTP",6) == 3308704530) strcat(s, "l");
if (crc32("vxpzLDUeUBV",11) == 2498004829) strcat(s, "d");
if (crc32("gLXbtR",6) == 211267646) strcat(s, "B");
if (crc32("LAuUKsiRwSq",11) == 3102314611) strcat(s, "i");
if (crc32("DtNsbTGTZXnkx",13) == 1263684700) strcat(s, "A");
if (crc32("KyFLPcNtSQfLlXE",15) == 4102430425) strcat(s, "e");
if (crc32("dznYoa",6) == 449946346) strcat(s, "q");
if (crc32("EZdXPUXhhucwcq",14) == 3044806628) strcat(s, "r");
    return s;
}

char *entity_nouns() {
    char *s = calloc(7);
    if (crc32("iSbZvnuXNMcgbr",14) == 2593053042) strcat(s, "e");
if (crc32("ApSFNcPRG",9) == 2749411159) strcat(s, "O");
if (crc32("cShFTeHWoqFPOE",14) == 2707494428) strcat(s, "n");
if (crc32("JDPDrWiOsqCSN",13) == 711322370) strcat(s, "t");
if (crc32("EhjUPYvru",9) == 2556767223) strcat(s, "X");
if (crc32("obJInMepWaqBD",13) == 2938575906) strcat(s, "i");
if (crc32("SCBQLtqFSHiwov",14) == 2420311529) strcat(s, "T");
if (crc32("TzOCSHPhOc",10) == 2141988713) strcat(s, "t");
if (crc32("qIhJUCp",7) == 1139366449) strcat(s, "y");
    return s;
}

char *redeye_nouns() {
    char *s = calloc(7);
    if (crc32("ItTEpqzZaIWdcDa",15) == 513115652) strcat(s, "j");
if (crc32("pONfnuOqyCe",11) == 3458906110) strcat(s, "r");
if (crc32("eBABlmSbT",9) == 4212160972) strcat(s, "e");
if (crc32("KljAWcrvWWUkxtg",15) == 1518795394) strcat(s, "f");
if (crc32("WWMqoZEkEKSYf",13) == 2035400902) strcat(s, "d");
if (crc32("tAUyIMk",7) == 1199006453) strcat(s, "e");
if (crc32("PqrzhEQqfwj",11) == 2203973389) strcat(s, "n");
if (crc32("mhxgFwFTn",9) == 2748086348) strcat(s, "y");
if (crc32("wNlTaPgAfJC",11) == 3610940823) strcat(s, "e");
    return s;
}

char *unresentfulness_nouns() {
    char *s = calloc(16);
    if (crc32("XUqHCKC",7) == 3313757498) strcat(s, "u");
if (crc32("xqovS",5) == 1887823196) strcat(s, "c");
if (crc32("UuZiUWFJzhAGAc",14) == 113602830) strcat(s, "n");
if (crc32("NaGSWh",6) == 2951866807) strcat(s, "L");
if (crc32("lWFNhlDZgzn",11) == 133193242) strcat(s, "r");
if (crc32("yHScndUPkHr",11) == 3339027476) strcat(s, "e");
if (crc32("RWABpyaAuzs",11) == 3147131946) strcat(s, "s");
if (crc32("GgXSPVJ",7) == 3468620737) strcat(s, "e");
if (crc32("tMKPayGHePQ",11) == 1966398013) strcat(s, "h");
if (crc32("VjjfCS",6) == 2304809432) strcat(s, "n");
if (crc32("FmYRtJfgFQHzaB",14) == 459436719) strcat(s, "r");
if (crc32("foVyXW",6) == 1176944082) strcat(s, "t");
if (crc32("QagtISrjLOTOW",13) == 587034333) strcat(s, "f");
if (crc32("mpKYRxPfGQmDFe",14) == 2253581097) strcat(s, "s");
if (crc32("jlhxbGHrjmtf",12) == 3797451684) strcat(s, "u");
if (crc32("CdXRK",5) == 3488735278) strcat(s, "k");
if (crc32("LVtXPxTnbk",10) == 281404365) strcat(s, "l");
if (crc32("gNjbv",5) == 1024909460) strcat(s, "n");
if (crc32("mYSJjzWdPnCrKIY",15) == 3437545350) strcat(s, "p");
if (crc32("iWcTGrdiCGhu",12) == 2752687444) strcat(s, "e");
if (crc32("TFWnSpG",7) == 1799378284) strcat(s, "s");
if (crc32("jRWkcshWfnJ",11) == 385008322) strcat(s, "s");
    return s;
}

char *monument_nouns() {
    char *s = calloc(9);
    if (crc32("LxohHNspxpFLJK",14) == 2376060638) strcat(s, "m");
if (crc32("lLSFduVSFQsVsQ",14) == 2044762042) strcat(s, "i");
if (crc32("YIfsosdMhYBsP",13) == 3886310163) strcat(s, "o");
if (crc32("TMqIOHqBdgcdEie",15) == 1409852872) strcat(s, "n");
if (crc32("uSVtHV",6) == 2460494324) strcat(s, "u");
if (crc32("nJxBAVtuzVQfJ",13) == 1931978401) strcat(s, "m");
if (crc32("SGwGHyssfJNwD",13) == 1539536464) strcat(s, "e");
if (crc32("GgAOm",5) == 3216643366) strcat(s, "n");
if (crc32("BmkSINZTOToFS",13) == 2450819477) strcat(s, "t");
    return s;
}

char *psychodrama_nouns() {
    char *s = calloc(12);
    if (crc32("sVAktoZtyCTSLgy",15) == 425983262) strcat(s, "p");
if (crc32("NsWIbNysktwM",12) == 3156607200) strcat(s, "Y");
if (crc32("jkNamMsCdQMRfbk",15) == 3810439561) strcat(s, "s");
if (crc32("cAjLhokEFa",10) == 4083141104) strcat(s, "X");
if (crc32("SCkJLOUokRGJ",12) == 1012864793) strcat(s, "y");
if (crc32("iHbkGyhNHE",10) == 112951796) strcat(s, "i");
if (crc32("pxiTUZW",7) == 2568261858) strcat(s, "c");
if (crc32("FKXAZQNfl",9) == 2146167053) strcat(s, "T");
if (crc32("ibYhLv",6) == 1755370924) strcat(s, "h");
if (crc32("XataZHgI",8) == 773968836) strcat(s, "C");
if (crc32("DdaTo",5) == 2514103374) strcat(s, "o");
if (crc32("ADQUmkVbWtxjRXN",15) == 3389376096) strcat(s, "d");
if (crc32("DImVXgreTJUZHw",14) == 660792647) strcat(s, "y");
if (crc32("BUHTZwfdarWHx",13) == 4195009736) strcat(s, "r");
if (crc32("FiGLPOqdC",9) == 1023438621) strcat(s, "a");
if (crc32("JZBmTEKDSiklqQ",14) == 1328225527) strcat(s, "m");
if (crc32("GSlkNOSSTqpvhB",14) == 922251886) strcat(s, "O");
if (crc32("CvDXrJThO",9) == 1828280511) strcat(s, "a");
    return s;
}

char *diazole_nouns() {
    char *s = calloc(8);
    if (crc32("DVltEwxXzkIGvJ",14) == 4165088387) strcat(s, "d");
if (crc32("vPhMHWbOOOCQva",14) == 3245308461) strcat(s, "i");
if (crc32("zeuPyigeX",9) == 723494391) strcat(s, "a");
if (crc32("FPeqzebbESTnqko",15) == 4219866618) strcat(s, "z");
if (crc32("gVZyHzBFrfEwRpp",15) == 449232474) strcat(s, "o");
if (crc32("kmqOBgN",7) == 233722425) strcat(s, "M");
if (crc32("HmzhcSSiGkRIiWB",15) == 895706264) strcat(s, "l");
if (crc32("HQGDeeOXphHoOkZ",15) == 141448066) strcat(s, "A");
if (crc32("ZFVsk",5) == 3166562161) strcat(s, "e");
    return s;
}

char *kiva_nouns() {
    char *s = calloc(5);
    if (crc32("EiaBmJ",6) == 3433782252) strcat(s, "k");
if (crc32("siTUvGEbJeXI",12) == 461499445) strcat(s, "i");
if (crc32("dGFEBGtLm",9) == 2535988137) strcat(s, "j");
if (crc32("sHmUIswxwzgQDT",14) == 1533359462) strcat(s, "v");
if (crc32("kANDbpzEgS",10) == 2580856163) strcat(s, "a");
    return s;
}

char *cycling_nouns() {
    char *s = calloc(8);
    if (crc32("ukjAVqRZBxZVAk",14) == 875273142) strcat(s, "c");
if (crc32("XWmfGzBnkVuPFJ",14) == 3275878531) strcat(s, "y");
if (crc32("GbgxJFhAIfc",11) == 764839323) strcat(s, "c");
if (crc32("EezIzm",6) == 580892783) strcat(s, "l");
if (crc32("tddkby",6) == 3273112529) strcat(s, "i");
if (crc32("wedIGXxm",8) == 1815519809) strcat(s, "n");
if (crc32("sIRXgZxM",8) == 23524666) strcat(s, "o");
if (crc32("accVoC",6) == 3773439340) strcat(s, "g");
    return s;
}

char *Campinas_nouns() {
    char *s = calloc(9);
    if (crc32("uYzRx",5) == 3458266068) strcat(s, "C");
if (crc32("MJSyxBQmdnXoVB",14) == 2283324794) strcat(s, "s");
if (crc32("XxnRaSxjdqqdiNJ",15) == 3524073538) strcat(s, "a");
if (crc32("rUsVY",5) == 3140009420) strcat(s, "b");
if (crc32("apxjvFzIeZX",11) == 1861953112) strcat(s, "m");
if (crc32("tZFCfzp",7) == 3310804663) strcat(s, "e");
if (crc32("JXdJrDyruwiDTEb",15) == 2485499150) strcat(s, "p");
if (crc32("VbKzoOIQ",8) == 434881187) strcat(s, "i");
if (crc32("lDhynNhqGxIdzD",14) == 3886389213) strcat(s, "n");
if (crc32("nMAtdKeW",8) == 1757921119) strcat(s, "a");
if (crc32("sHUahU",6) == 1460983575) strcat(s, "s");
    return s;
}

char *Bensenville_nouns() {
    char *s = calloc(12);
    if (crc32("wOroREWOigTii",13) == 659782207) strcat(s, "k");
if (crc32("bplTjlJmV",9) == 1860275718) strcat(s, "B");
if (crc32("pFilucWoXe",10) == 3832504832) strcat(s, "e");
if (crc32("WUZYl",5) == 2497998680) strcat(s, "v");
if (crc32("VcHliEcY",8) == 2682537867) strcat(s, "n");
if (crc32("dtccXSjKHgpjvx",14) == 2409360785) strcat(s, "s");
if (crc32("rNflbTbxQagV",12) == 3158429231) strcat(s, "g");
if (crc32("oKzXnzy",7) == 2258008112) strcat(s, "e");
if (crc32("yeRSL",5) == 4031309100) strcat(s, "u");
if (crc32("OcaRdoIf",8) == 3693069676) strcat(s, "n");
if (crc32("jaujbsjJ",8) == 1546202306) strcat(s, "P");
if (crc32("LFPzFq",6) == 228691280) strcat(s, "v");
if (crc32("DpCLQ",5) == 3304813306) strcat(s, "J");
if (crc32("RVDbQxRc",8) == 813352211) strcat(s, "i");
if (crc32("ruJKYbQMEn",10) == 2983704758) strcat(s, "l");
if (crc32("WkuzrE",6) == 774377642) strcat(s, "a");
if (crc32("BmegwxOshyycN",13) == 2575540359) strcat(s, "l");
if (crc32("lqzyKH",6) == 1047456694) strcat(s, "e");
    return s;
}

char *girlhood_nouns() {
    char *s = calloc(9);
    if (crc32("ERMMl",5) == 1319429541) strcat(s, "g");
if (crc32("tgFKVxYiQQzhV",13) == 2526530711) strcat(s, "i");
if (crc32("gUNDlTpd",8) == 694499118) strcat(s, "r");
if (crc32("tYnvqMb",7) == 1682194284) strcat(s, "x");
if (crc32("wrMzPCDNObYpJBS",15) == 594172306) strcat(s, "l");
if (crc32("PtxSySWMiBiInD",14) == 3710508413) strcat(s, "s");
if (crc32("rTItO",5) == 3542387451) strcat(s, "h");
if (crc32("FVvJq",5) == 2183133261) strcat(s, "o");
if (crc32("TNjMmYcWZzireqh",15) == 2655719949) strcat(s, "b");
if (crc32("yDrWxWQ",7) == 384374097) strcat(s, "o");
if (crc32("azvjIvToAx",10) == 2785763320) strcat(s, "C");
if (crc32("foWAREBdO",9) == 2553860047) strcat(s, "d");
    return s;
}

char *thimble_nouns() {
    char *s = calloc(8);
    if (crc32("AmfNDsBRwO",10) == 4065577082) strcat(s, "M");
if (crc32("XBkgUzvp",8) == 4118919892) strcat(s, "t");
if (crc32("XRFwnj",6) == 1326749812) strcat(s, "U");
if (crc32("aeDBxAO",7) == 555316052) strcat(s, "h");
if (crc32("vYENC",5) == 3734347260) strcat(s, "b");
if (crc32("GAqSkrreAvKYt",13) == 1901589321) strcat(s, "i");
if (crc32("akVFcSCGM",9) == 2067231487) strcat(s, "m");
if (crc32("WJKwYifGskvTe",13) == 3336419794) strcat(s, "S");
if (crc32("DXUBJNPKhnrNsc",14) == 3574031275) strcat(s, "b");
if (crc32("qwRMcQiGRrYuXso",15) == 1279676146) strcat(s, "l");
if (crc32("RmkMLeNHm",9) == 728236994) strcat(s, "e");
    return s;
}

char *Tacquet_nouns() {
    char *s = calloc(8);
    if (crc32("kvstncWfZZshfSt",15) == 2717376957) strcat(s, "T");
if (crc32("qacqAIOVQLj",11) == 3778604744) strcat(s, "F");
if (crc32("rRKSjelMx",9) == 1727513155) strcat(s, "a");
if (crc32("hTEeLToUTnTedGl",15) == 3015816657) strcat(s, "I");
if (crc32("zzsNa",5) == 1933224647) strcat(s, "c");
if (crc32("xLlkxuCooeL",11) == 1076097695) strcat(s, "q");
if (crc32("jdLIiXVcnnEzMj",14) == 2481980820) strcat(s, "F");
if (crc32("tXvZeCPoL",9) == 3337157385) strcat(s, "u");
if (crc32("wTvOeecztZnuqRu",15) == 3675704184) strcat(s, "B");
if (crc32("FHLcsnxbcG",10) == 957149821) strcat(s, "e");
if (crc32("mnGhUI",6) == 2875317810) strcat(s, "t");
    return s;
}

char *decapitation_nouns() {
    char *s = calloc(13);
    if (crc32("XwCTrqCCSwVJq",13) == 2097440603) strcat(s, "d");
if (crc32("GoHzDbjxzVbc",12) == 1550086371) strcat(s, "j");
if (crc32("ogyxZ",5) == 1288290544) strcat(s, "e");
if (crc32("aAnIl",5) == 1714334125) strcat(s, "c");
if (crc32("wOTckAFKkZb",11) == 3549183995) strcat(s, "a");
if (crc32("rYOCsjkjcfRF",12) == 2319613755) strcat(s, "N");
if (crc32("nBEBBGCuO",9) == 2947871543) strcat(s, "p");
if (crc32("QmXgcUpKKsMpmK",14) == 1586383086) strcat(s, "i");
if (crc32("pEvhSVc",7) == 4029744336) strcat(s, "t");
if (crc32("LGdKkcaidXqm",12) == 2119289394) strcat(s, "B");
if (crc32("dEMJWgV",7) == 680343906) strcat(s, "a");
if (crc32("FBtJhxJVWfF",11) == 4078635537) strcat(s, "L");
if (crc32("bsLqsdltRvZTlkg",15) == 1439945964) strcat(s, "t");
if (crc32("vJhPtuVvlepWu",13) == 2582499086) strcat(s, "i");
if (crc32("WfTbbbNJhb",10) == 2548227089) strcat(s, "H");
if (crc32("EPJCCXhl",8) == 2486482371) strcat(s, "o");
if (crc32("JCYKw",5) == 3003391132) strcat(s, "u");
if (crc32("oulDnbfDUXScKkb",15) == 3287391124) strcat(s, "n");
    return s;
}

char *Proud_nouns() {
    char *s = calloc(6);
    if (crc32("mgfoGtnvfAFiUwh",15) == 2709356544) strcat(s, "V");
if (crc32("hcKknFTn",8) == 2352753569) strcat(s, "P");
if (crc32("sFfNOXxqeprlAYO",15) == 2788127899) strcat(s, "F");
if (crc32("WmwyDdwGUBcjkEp",15) == 2935153851) strcat(s, "r");
if (crc32("FhCVfUsoKxJtZW",14) == 2697363682) strcat(s, "f");
if (crc32("xCmcDARbLE",10) == 2446075192) strcat(s, "o");
if (crc32("owWEkCtAULcdq",13) == 3070750489) strcat(s, "u");
if (crc32("DykWfQVdzzJZy",13) == 627825894) strcat(s, "d");
    return s;
}

char *headworking_nouns() {
    char *s = calloc(12);
    if (crc32("kONingXwHNdNcqz",15) == 3769793499) strcat(s, "L");
if (crc32("DrDoivmBTMmOwnP",15) == 2866797277) strcat(s, "h");
if (crc32("ecNkfZEQ",8) == 1199188652) strcat(s, "J");
if (crc32("IgUYpbnRnUlN",12) == 130705438) strcat(s, "e");
if (crc32("gNmPx",5) == 3683899904) strcat(s, "r");
if (crc32("HYLZXJb",7) == 859782946) strcat(s, "a");
if (crc32("VxvAHzYVaoBaI",13) == 3365129121) strcat(s, "U");
if (crc32("UlSrbmkyZzGz",12) == 366317040) strcat(s, "d");
if (crc32("LENzNRuYDBxy",12) == 4074682646) strcat(s, "W");
if (crc32("EyvjnWILzCwelY",14) == 3930714627) strcat(s, "w");
if (crc32("JRUbLmyx",8) == 3882533116) strcat(s, "o");
if (crc32("XqAmFaVRHdUmYj",14) == 1169623702) strcat(s, "M");
if (crc32("mMLZJVUz",8) == 3937253551) strcat(s, "r");
if (crc32("noPCPQRKcm",10) == 3864977639) strcat(s, "k");
if (crc32("dEaXEBvljnT",11) == 3102602457) strcat(s, "v");
if (crc32("fauTkatLcXJAvzr",15) == 4026621912) strcat(s, "i");
if (crc32("IvWeMjjgVfCahd",14) == 201091529) strcat(s, "n");
if (crc32("rkZvNuxyGlp",11) == 358346298) strcat(s, "g");
    return s;
}

char *Hyatt_nouns() {
    char *s = calloc(6);
    if (crc32("izTEvoPOVHZE",12) == 3786937672) strcat(s, "H");
if (crc32("YDeSujJQVBudea",14) == 1497985639) strcat(s, "y");
if (crc32("XUvMDkLOLWFGW",13) == 2381379759) strcat(s, "f");
if (crc32("iBjsU",5) == 961458991) strcat(s, "a");
if (crc32("OFQUWp",6) == 2657997290) strcat(s, "W");
if (crc32("kePFKy",6) == 124585857) strcat(s, "t");
if (crc32("UUxWgtTq",8) == 1754771040) strcat(s, "t");
    return s;
}

char *nightrider_nouns() {
    char *s = calloc(11);
    if (crc32("XzWAZ",5) == 798100976) strcat(s, "x");
if (crc32("PJlGJOYLeVYlfP",14) == 2723581782) strcat(s, "n");
if (crc32("VsNrjBch",8) == 3080169706) strcat(s, "i");
if (crc32("LIWwLzc",7) == 849397011) strcat(s, "g");
if (crc32("ttjufIJuUdW",11) == 3881407779) strcat(s, "h");
if (crc32("EAhnJTRLuCZI",12) == 1084882682) strcat(s, "t");
if (crc32("sopuILeBtsOZ",12) == 647409022) strcat(s, "r");
if (crc32("ThuPCCUzEpI",11) == 2609075559) strcat(s, "k");
if (crc32("ulkSuHO",7) == 3886627444) strcat(s, "i");
if (crc32("frbSzaFeK",9) == 207471480) strcat(s, "d");
if (crc32("EGbbtrhxtcKIMJ",14) == 475677369) strcat(s, "K");
if (crc32("qTjoqLAxFF",10) == 4106319727) strcat(s, "e");
if (crc32("XiXdemuJbIj",11) == 1993548924) strcat(s, "r");
    return s;
}

char *proposition_nouns() {
    char *s = calloc(12);
    if (crc32("UnhBUea",7) == 241760521) strcat(s, "p");
if (crc32("GJpUnCO",7) == 3222626739) strcat(s, "D");
if (crc32("hPeyEjtAR",9) == 1514190289) strcat(s, "r");
if (crc32("LicHopqjxn",10) == 1318785619) strcat(s, "m");
if (crc32("FNmWEqVm",8) == 2259048487) strcat(s, "o");
if (crc32("iELaLfVjkOk",11) == 1269273630) strcat(s, "p");
if (crc32("pZWmGtKSaDW",11) == 2848280126) strcat(s, "o");
if (crc32("LRzcQfl",7) == 3752684761) strcat(s, "s");
if (crc32("GuEnCNxSxbsz",12) == 647439556) strcat(s, "i");
if (crc32("rBWBrlWvQw",10) == 2371625057) strcat(s, "x");
if (crc32("svufey",6) == 1796111077) strcat(s, "t");
if (crc32("PGefIHrswet",11) == 4155250759) strcat(s, "b");
if (crc32("bHHNpNrgIL",10) == 2197843444) strcat(s, "i");
if (crc32("FTSCkbttDStixJ",14) == 4158469111) strcat(s, "o");
if (crc32("VpxRLVbuw",9) == 1909397798) strcat(s, "n");
    return s;
}

char *Perm_nouns() {
    char *s = calloc(5);
    if (crc32("UlDDGhaZG",9) == 2294097724) strcat(s, "P");
if (crc32("MclJe",5) == 2583770493) strcat(s, "h");
if (crc32("XtCKlVyoxVEl",12) == 3652023099) strcat(s, "e");
if (crc32("wgdQpVGFZoUgJ",13) == 3733037965) strcat(s, "r");
if (crc32("LvxGNICni",9) == 1346326640) strcat(s, "e");
if (crc32("EfGiqVunYMlFz",13) == 1229217226) strcat(s, "m");
    return s;
}

char *raphe_nouns() {
    char *s = calloc(6);
    if (crc32("AkzdjPGKMcT",11) == 3144719469) strcat(s, "r");
if (crc32("IgWbAKAIl",9) == 3493454133) strcat(s, "a");
if (crc32("YGmTv",5) == 2286943792) strcat(s, "V");
if (crc32("nvakKiNck",9) == 3504119784) strcat(s, "p");
if (crc32("veXMUGAWiXMED",13) == 931736295) strcat(s, "C");
if (crc32("FwtEAAYnCzt",11) == 3040559039) strcat(s, "h");
if (crc32("maxJKSCMS",9) == 366128821) strcat(s, "e");
    return s;
}

char *nonpredatoriness_nouns() {
    char *s = calloc(17);
    if (crc32("gImjzHvevftS",12) == 3203096294) strcat(s, "b");
if (crc32("dVCwkPeoJC",10) == 1141101552) strcat(s, "n");
if (crc32("tjLcPtfSnPMrS",13) == 322456202) strcat(s, "K");
if (crc32("rNalQZRXV",9) == 1747810220) strcat(s, "o");
if (crc32("dGDKyJe",7) == 2109787502) strcat(s, "n");
if (crc32("VebdXKGBR",9) == 2257538849) strcat(s, "p");
if (crc32("gVyhBEuHcHgZQXd",15) == 4157946591) strcat(s, "r");
if (crc32("yVWSHErusVFJI",13) == 3880742816) strcat(s, "e");
if (crc32("LrYFcDvuXQA",11) == 2958715646) strcat(s, "d");
if (crc32("KGBwuhNkE",9) == 2759491502) strcat(s, "o");
if (crc32("CctiWPqK",8) == 2444484592) strcat(s, "a");
if (crc32("uhUbqVyXeIw",11) == 1203512504) strcat(s, "t");
if (crc32("OKsBVIDl",8) == 1026169774) strcat(s, "o");
if (crc32("XuUznkETDNBPiFu",15) == 3782820130) strcat(s, "r");
if (crc32("yPgelaGOLIPNdrt",15) == 167587849) strcat(s, "g");
if (crc32("BAeHfGCs",8) == 2778523279) strcat(s, "i");
if (crc32("paCwKAia",8) == 584487228) strcat(s, "c");
if (crc32("HtkuHdog",8) == 4105302674) strcat(s, "n");
if (crc32("VjUKNAT",7) == 2122879293) strcat(s, "w");
if (crc32("vOWKnKXV",8) == 3567964789) strcat(s, "e");
if (crc32("yFJAv",5) == 3103527605) strcat(s, "T");
if (crc32("qmLNTYPljsMGRK",14) == 1264080716) strcat(s, "s");
if (crc32("yYxRlb",6) == 61539938) strcat(s, "s");
    return s;
}

char *scourer_nouns() {
    char *s = calloc(8);
    if (crc32("hUGxzQBicVtRFCz",15) == 1322468651) strcat(s, "o");
if (crc32("XHEXPPtr",8) == 2434440737) strcat(s, "s");
if (crc32("GOzdNfNWrXD",11) == 3847215900) strcat(s, "c");
if (crc32("RFkgqK",6) == 1899625466) strcat(s, "H");
if (crc32("OCOIJOeN",8) == 1292919708) strcat(s, "o");
if (crc32("cTOKAuauIj",10) == 3894396444) strcat(s, "u");
if (crc32("bSGAIquU",8) == 1834197720) strcat(s, "k");
if (crc32("oAnWFrAP",8) == 1566308909) strcat(s, "r");
if (crc32("ouomZnEmBn",10) == 2507103546) strcat(s, "e");
if (crc32("LYNpP",5) == 3547630261) strcat(s, "r");
    return s;
}

char *midge_nouns() {
    char *s = calloc(6);
    if (crc32("KRoiz",5) == 3479281085) strcat(s, "m");
if (crc32("KKJblr",6) == 3691536148) strcat(s, "N");
if (crc32("OkFFhgmdg",9) == 159530170) strcat(s, "i");
if (crc32("oSNfPTVJTzokN",13) == 3856315667) strcat(s, "d");
if (crc32("xZpakdbYTT",10) == 787200301) strcat(s, "g");
if (crc32("DXjwH",5) == 953239228) strcat(s, "e");
    return s;
}

char *MacFarlane_nouns() {
    char *s = calloc(11);
    if (crc32("gIbeucacbQUaQg",14) == 2452842366) strcat(s, "o");
if (crc32("xFSkwVMi",8) == 3067349913) strcat(s, "M");
if (crc32("sKwASzkJuPw",11) == 2680628702) strcat(s, "a");
if (crc32("KuuDImLpa",9) == 3707624946) strcat(s, "G");
if (crc32("TaYmslpO",8) == 582457094) strcat(s, "c");
if (crc32("pNcjnbZVmHI",11) == 1154265001) strcat(s, "F");
if (crc32("wweEvvrIUGyzr",13) == 3185371353) strcat(s, "a");
if (crc32("PdYwsheNy",9) == 693079471) strcat(s, "r");
if (crc32("uthtwc",6) == 4291869549) strcat(s, "l");
if (crc32("EVFWwtgtx",9) == 3851651397) strcat(s, "T");
if (crc32("MsjEhePzbkO",11) == 886963799) strcat(s, "a");
if (crc32("gUiUFfKdgP",10) == 2087105286) strcat(s, "Q");
if (crc32("auekYwW",7) == 2695606843) strcat(s, "n");
if (crc32("NTRES",5) == 1977272336) strcat(s, "e");
    return s;
}

char *Prag_nouns() {
    char *s = calloc(5);
    if (crc32("CTMyOJEaB",9) == 1709497424) strcat(s, "P");
if (crc32("ytcUUcXGasfI",12) == 3401855314) strcat(s, "r");
if (crc32("kMZnLJrtBSNNP",13) == 4061969457) strcat(s, "a");
if (crc32("qNFTUTT",7) == 2841361159) strcat(s, "g");
    return s;
}

char *Brooking_nouns() {
    char *s = calloc(9);
    if (crc32("yChmCBL",7) == 1056648483) strcat(s, "v");
if (crc32("auaJAXmkvY",10) == 2983881292) strcat(s, "B");
if (crc32("WVQQNBiscF",10) == 1941114516) strcat(s, "r");
if (crc32("BiLaSJqSRmGJtG",14) == 3483428097) strcat(s, "o");
if (crc32("HGgmsNGMAOWgy",13) == 224044608) strcat(s, "G");
if (crc32("geiQpwzCrthLvv",14) == 15590354) strcat(s, "o");
if (crc32("MBuAUtpJv",9) == 731348877) strcat(s, "k");
if (crc32("vZmww",5) == 4195376745) strcat(s, "i");
if (crc32("fzaaAlZlUGc",11) == 889740292) strcat(s, "S");
if (crc32("XIGqXrUYqJlCL",13) == 3216274822) strcat(s, "n");
if (crc32("NPaDkXwjsI",10) == 1866764573) strcat(s, "g");
    return s;
}

char *Steele_nouns() {
    char *s = calloc(7);
    if (crc32("nUCMGprZMorB",12) == 3391505930) strcat(s, "A");
if (crc32("mjKOaMHSJrZ",11) == 1593767262) strcat(s, "S");
if (crc32("bWEeggxf",8) == 3079137784) strcat(s, "t");
if (crc32("AmhiLnEZN",9) == 3045944858) strcat(s, "F");
if (crc32("CwHczyWc",8) == 2827327752) strcat(s, "e");
if (crc32("HLHPeXDoTcA",11) == 67259352) strcat(s, "n");
if (crc32("jcyMRqbCO",9) == 1545744477) strcat(s, "e");
if (crc32("sOSUpn",6) == 3492636906) strcat(s, "l");
if (crc32("SCNmeaBmULZBW",13) == 1191132294) strcat(s, "e");
    return s;
}

char *ft_nouns() {
    char *s = calloc(3);
    if (crc32("tFywFEW",7) == 1383487177) strcat(s, "f");
if (crc32("VWzWqOyCD",9) == 389098019) strcat(s, "t");
    return s;
}

char *intemperance_nouns() {
    char *s = calloc(13);
    if (crc32("APwKvfy",7) == 1048271868) strcat(s, "i");
if (crc32("NiotVyguS",9) == 4114326241) strcat(s, "O");
if (crc32("MbrTWcHDHOyuT",13) == 1122852897) strcat(s, "n");
if (crc32("DKdQOjDmVder",12) == 4248497236) strcat(s, "F");
if (crc32("AQFHDdODgGdHB",13) == 1208578051) strcat(s, "t");
if (crc32("wqdpLixruN",10) == 3232231572) strcat(s, "I");
if (crc32("djBjjyRbYV",10) == 675181892) strcat(s, "e");
if (crc32("hDgdJD",6) == 2222950001) strcat(s, "c");
if (crc32("WPTGXc",6) == 255439401) strcat(s, "m");
if (crc32("ViBGKBbPOFGaXyp",15) == 1188568662) strcat(s, "p");
if (crc32("hVVBfwI",7) == 1518878044) strcat(s, "e");
if (crc32("qRfovwqaeWTO",12) == 799519492) strcat(s, "W");
if (crc32("bsJoJyF",7) == 1639609452) strcat(s, "r");
if (crc32("NBZYwjdhCG",10) == 205987696) strcat(s, "g");
if (crc32("vjpfpLnsd",9) == 852115706) strcat(s, "a");
if (crc32("cvPhQlh",7) == 3684171451) strcat(s, "n");
if (crc32("DlVCPqDLv",9) == 1381215792) strcat(s, "c");
if (crc32("SzyZDCmNMAXjM",13) == 490237168) strcat(s, "C");
if (crc32("DWupQKKjRwjtj",13) == 2859306472) strcat(s, "e");
    return s;
}

char *seminervousness_nouns() {
    char *s = calloc(16);
    if (crc32("oYpWqtqyNCfUOW",14) == 3924863311) strcat(s, "g");
if (crc32("uKedTVHJyok",11) == 851429464) strcat(s, "s");
if (crc32("yjbFyspM",8) == 212219909) strcat(s, "e");
if (crc32("pmkmAW",6) == 1495838466) strcat(s, "y");
if (crc32("IcawkaKESb",10) == 524978285) strcat(s, "m");
if (crc32("IumySJTVtTGLQ",13) == 2814590579) strcat(s, "i");
if (crc32("vAyJzCxHye",10) == 614278460) strcat(s, "i");
if (crc32("jarsEkNHvu",10) == 3748310759) strcat(s, "w");
if (crc32("sUSrFyShPfS",11) == 3514742574) strcat(s, "n");
if (crc32("iEvSrinzYnypya",14) == 2108780469) strcat(s, "e");
if (crc32("ctVbe",5) == 918759950) strcat(s, "u");
if (crc32("WJKtoZRaEjeGfpS",15) == 2021182717) strcat(s, "r");
if (crc32("UXcglXWxQTlqCrS",15) == 4103857175) strcat(s, "z");
if (crc32("CmXtfioGnmfW",12) == 3865142748) strcat(s, "v");
if (crc32("UiqPcYJabdHt",12) == 3435969673) strcat(s, "o");
if (crc32("iEXUrPP",7) == 2528827578) strcat(s, "q");
if (crc32("onXxqD",6) == 2108425883) strcat(s, "u");
if (crc32("xzNsFwoDLMpk",12) == 1615431889) strcat(s, "y");
if (crc32("biCkQhXnnwwNi",13) == 766397453) strcat(s, "s");
if (crc32("KixZKXD",7) == 3868578899) strcat(s, "n");
if (crc32("NuyjjOLJXdLfwoK",15) == 1852216779) strcat(s, "e");
if (crc32("LDCUTnoQGcP",11) == 126125694) strcat(s, "s");
if (crc32("oCefppyf",8) == 1438797963) strcat(s, "c");
if (crc32("QcqYajYJJRmJMLN",15) == 1716673913) strcat(s, "s");
    return s;
}

char *birthwort_nouns() {
    char *s = calloc(10);
    if (crc32("CXLcJUu",7) == 3312515794) strcat(s, "X");
if (crc32("vKPvHVqBGtgxuH",14) == 1151740398) strcat(s, "b");
if (crc32("LvVZlwtZCHeMB",13) == 2786276548) strcat(s, "i");
if (crc32("aFejMHvm",8) == 2291290375) strcat(s, "r");
if (crc32("VwfFOAvw",8) == 3549503312) strcat(s, "t");
if (crc32("cxnnXaGaPW",10) == 309023656) strcat(s, "Q");
if (crc32("eaLBBBj",7) == 929216850) strcat(s, "h");
if (crc32("SPdXEcSLd",9) == 2797454018) strcat(s, "w");
if (crc32("aWPeCvHXGVYQS",13) == 1771797617) strcat(s, "B");
if (crc32("RGDMUV",6) == 866582575) strcat(s, "o");
if (crc32("YmSBVCqkgiaVQJs",15) == 1994546259) strcat(s, "r");
if (crc32("ELFLKonYeKpW",12) == 11989957) strcat(s, "t");
    return s;
}

char *Boz_nouns() {
    char *s = calloc(4);
    if (crc32("ASEQhtpjqV",10) == 550328119) strcat(s, "f");
if (crc32("YWdjSzItm",9) == 3450322733) strcat(s, "B");
if (crc32("uAAdDbNj",8) == 1723572478) strcat(s, "C");
if (crc32("IcGBWdzCHU",10) == 1019325452) strcat(s, "o");
if (crc32("OQjMtlOugu",10) == 3658122812) strcat(s, "z");
    return s;
}

char *Konstantine_nouns() {
    char *s = calloc(12);
    if (crc32("iqKEGNrpa",9) == 3094394096) strcat(s, "j");
if (crc32("KXWccEqSfNzkgH",14) == 4204909558) strcat(s, "K");
if (crc32("FEDIkQgJxZpZ",12) == 2185539769) strcat(s, "o");
if (crc32("fvQyMvw",7) == 1953719660) strcat(s, "n");
if (crc32("tmszZccFGzyG",12) == 332559789) strcat(s, "e");
if (crc32("CxNxAczNMPT",11) == 2719767469) strcat(s, "s");
if (crc32("MfRPfygpY",9) == 561386295) strcat(s, "L");
if (crc32("FEAkDksHgEGm",12) == 823324268) strcat(s, "t");
if (crc32("dYGiTTBqCHracK",14) == 3662242038) strcat(s, "y");
if (crc32("BttLp",5) == 1602058822) strcat(s, "a");
if (crc32("tqglPrtYawHz",12) == 996999003) strcat(s, "n");
if (crc32("MFLyMfDVsXeRT",13) == 2446124709) strcat(s, "v");
if (crc32("hpIakqibBHIaeJ",14) == 4270892971) strcat(s, "t");
if (crc32("BsKuoQO",7) == 3066315198) strcat(s, "i");
if (crc32("PPmsrEXLnOuo",12) == 2026207681) strcat(s, "n");
if (crc32("uJILEDMTifyMY",13) == 1447490787) strcat(s, "e");
    return s;
}

char *pomander_nouns() {
    char *s = calloc(9);
    if (crc32("BUJGHSVDMrFg",12) == 2686484441) strcat(s, "f");
if (crc32("buSOWbmrsIfM",12) == 712539101) strcat(s, "p");
if (crc32("iMpratED",8) == 993723302) strcat(s, "R");
if (crc32("UhIAPwrvgp",10) == 590177612) strcat(s, "o");
if (crc32("pxyfByNgSc",10) == 4198550493) strcat(s, "l");
if (crc32("QHMnF",5) == 2171788715) strcat(s, "m");
if (crc32("lKhNtaXECA",10) == 1447060775) strcat(s, "K");
if (crc32("bbvByU",6) == 3485133557) strcat(s, "a");
if (crc32("NMtSOBMKaof",11) == 3776943816) strcat(s, "n");
if (crc32("LbAzbq",6) == 1923884030) strcat(s, "K");
if (crc32("JtYnAGgroWHWh",13) == 81786865) strcat(s, "d");
if (crc32("cQiFHgonnhlZU",13) == 3450069146) strcat(s, "J");
if (crc32("cYpAgoUNHGk",11) == 3581866186) strcat(s, "e");
if (crc32("NFcyFpnu",8) == 903027860) strcat(s, "r");
    return s;
}

char *scholium_nouns() {
    char *s = calloc(9);
    if (crc32("gvdGwSSuTQQgmib",15) == 262079233) strcat(s, "a");
if (crc32("XTsdzG",6) == 2544921587) strcat(s, "s");
if (crc32("SVDlaoUK",8) == 3495299205) strcat(s, "c");
if (crc32("PwInoesGoR",10) == 3760732265) strcat(s, "h");
if (crc32("ZzWaRbv",7) == 1341548907) strcat(s, "B");
if (crc32("tQraYQEcNpHnRMS",15) == 1661848361) strcat(s, "o");
if (crc32("UhrBERlFcCjjjZ",14) == 72655838) strcat(s, "b");
if (crc32("RNNLOLLuCleduj",14) == 2881946508) strcat(s, "l");
if (crc32("sxAsATXBabCemsb",15) == 3019341074) strcat(s, "i");
if (crc32("tWIBEbUkwEF",11) == 1810471014) strcat(s, "u");
if (crc32("VBAeSuCx",8) == 3189870515) strcat(s, "m");
    return s;
}

char *nonproliferation_nouns() {
    char *s = calloc(17);
    if (crc32("fyOmZMSTXkaFr",13) == 759599651) strcat(s, "u");
if (crc32("afBaCucopRx",11) == 3682119761) strcat(s, "n");
if (crc32("nzUHH",5) == 1411188217) strcat(s, "G");
if (crc32("YGVSjNrxnp",10) == 3809414831) strcat(s, "o");
if (crc32("oVTiZ",5) == 1729276311) strcat(s, "n");
if (crc32("IujupYCOEumF",12) == 3723878089) strcat(s, "p");
if (crc32("SHaqouubjEjEi",13) == 2503472639) strcat(s, "c");
if (crc32("uQbxV",5) == 2854021140) strcat(s, "r");
if (crc32("WPnQlalVprGpw",13) == 2403003637) strcat(s, "o");
if (crc32("jOHmVnKu",8) == 3189544180) strcat(s, "v");
if (crc32("yxmZufHEhKd",11) == 3651047504) strcat(s, "l");
if (crc32("EZJry",5) == 1707941263) strcat(s, "u");
if (crc32("frvUIvQpVUniQw",14) == 4068132839) strcat(s, "i");
if (crc32("OPSzmDSxhAnLdl",14) == 1575334674) strcat(s, "f");
if (crc32("hAQfIdRctxRm",12) == 3895211695) strcat(s, "e");
if (crc32("PQWPPlwvIGrBFl",14) == 2853474525) strcat(s, "r");
if (crc32("ZBlrJTwkKKbgaK",14) == 2739144514) strcat(s, "q");
if (crc32("mGhFUkossWEop",13) == 309771659) strcat(s, "a");
if (crc32("EytJaLhOA",9) == 848888899) strcat(s, "t");
if (crc32("TkjVigGavP",10) == 3579611675) strcat(s, "i");
if (crc32("doiBnC",6) == 2069007944) strcat(s, "e");
if (crc32("gOuVIFoBjav",11) == 4136205129) strcat(s, "o");
if (crc32("qdTPHLq",7) == 1204794079) strcat(s, "n");
    return s;
}

char *Spender_nouns() {
    char *s = calloc(8);
    if (crc32("cHKZcWTLnepUH",13) == 1545974338) strcat(s, "x");
if (crc32("TPdWuEFZaVGn",12) == 1435590213) strcat(s, "S");
if (crc32("btdTsHkSnrZOGei",15) == 1939759870) strcat(s, "V");
if (crc32("fDRyvYizJUodRRm",15) == 1717155712) strcat(s, "p");
if (crc32("NqfoRUfJckIc",12) == 4028183414) strcat(s, "e");
if (crc32("GEDUeb",6) == 4139512041) strcat(s, "n");
if (crc32("kCOdyQTB",8) == 2509458439) strcat(s, "V");
if (crc32("SINZi",5) == 1370724697) strcat(s, "d");
if (crc32("cesXZwCKyKTVWb",14) == 2758497300) strcat(s, "M");
if (crc32("bFTfQCWvEnIVcir",15) == 3843046919) strcat(s, "e");
if (crc32("OxQVrkoHfUldwy",14) == 2665444040) strcat(s, "N");
if (crc32("GUVty",5) == 3667504060) strcat(s, "r");
    return s;
}

char *Rabelaisianism_nouns() {
    char *s = calloc(15);
    if (crc32("dBvBE",5) == 2985692086) strcat(s, "D");
if (crc32("jcZuObOrWxtWCt",14) == 713295657) strcat(s, "R");
if (crc32("YOrNpyqKQp",10) == 4276659813) strcat(s, "a");
if (crc32("KLHDMd",6) == 1868902275) strcat(s, "b");
if (crc32("KfExgPYZUhtk",12) == 978357161) strcat(s, "e");
if (crc32("sGGCWeOxx",9) == 1076545432) strcat(s, "l");
if (crc32("qahBPeZExEoG",12) == 77407526) strcat(s, "a");
if (crc32("KqPswZLeAqtMtDM",15) == 3218011897) strcat(s, "i");
if (crc32("gpJejz",6) == 1075171139) strcat(s, "n");
if (crc32("UTFlLUVQNXRu",12) == 1600435906) strcat(s, "s");
if (crc32("hBtsRWjKpf",10) == 3969174717) strcat(s, "o");
if (crc32("ymxvFIVZqQIJRy",14) == 3804086187) strcat(s, "i");
if (crc32("YQdWpb",6) == 3456384772) strcat(s, "a");
if (crc32("WMXPXWKH",8) == 795075104) strcat(s, "s");
if (crc32("lzOfFXlxHo",10) == 1255852465) strcat(s, "n");
if (crc32("UCKkQTRLasbRnd",14) == 4059694961) strcat(s, "y");
if (crc32("XggJd",5) == 1700881350) strcat(s, "i");
if (crc32("tTrgGSdUnzbesqx",15) == 683924698) strcat(s, "g");
if (crc32("JuUjjHYe",8) == 2422059197) strcat(s, "s");
if (crc32("aUwMJbV",7) == 1722566822) strcat(s, "m");
    return s;
}

char *nose_nouns() {
    char *s = calloc(5);
    if (crc32("tetcjLltgaTeH",13) == 641335492) strcat(s, "R");
if (crc32("NelhIwL",7) == 326000342) strcat(s, "n");
if (crc32("DRMxrciAwL",10) == 4118475663) strcat(s, "o");
if (crc32("XSlAVY",6) == 1137188867) strcat(s, "v");
if (crc32("pxHxAHWNOe",10) == 2972143802) strcat(s, "s");
if (crc32("uKyMOHqUrQI",11) == 1204496516) strcat(s, "n");
if (crc32("dPZDNdrfNn",10) == 755660974) strcat(s, "e");
    return s;
}

char *Sparhawk_nouns() {
    char *s = calloc(9);
    if (crc32("nHRwEuWEkV",10) == 1024404809) strcat(s, "S");
if (crc32("TdXNqjZOuTY",11) == 520419614) strcat(s, "s");
if (crc32("ufhHu",5) == 3075926619) strcat(s, "p");
if (crc32("FvwvzrJBacvIiMM",15) == 3593067839) strcat(s, "a");
if (crc32("MHKvxyOyUJpwGf",14) == 998419668) strcat(s, "R");
if (crc32("Bnage",5) == 1637463460) strcat(s, "r");
if (crc32("CMfmqlC",7) == 3692615352) strcat(s, "j");
if (crc32("TOfLzlbAFq",10) == 1348268318) strcat(s, "h");
if (crc32("tcpzXZLGqR",10) == 413579103) strcat(s, "a");
if (crc32("csYBbW",6) == 3859780284) strcat(s, "w");
if (crc32("ieqsMpdD",8) == 1084981338) strcat(s, "k");
    return s;
}

char *fishpound_nouns() {
    char *s = calloc(10);
    if (crc32("uujRKYKujCJG",12) == 2153153534) strcat(s, "f");
if (crc32("xMQAUum",7) == 3704290734) strcat(s, "i");
if (crc32("AQspefziIwtbMwM",15) == 543693930) strcat(s, "s");
if (crc32("qgoDUMcA",8) == 3565344619) strcat(s, "h");
if (crc32("SkFdWGHKbbrIQd",14) == 4030436226) strcat(s, "p");
if (crc32("bIvrYeEnSSmy",12) == 2466461845) strcat(s, "o");
if (crc32("KGebEDy",7) == 3260878638) strcat(s, "u");
if (crc32("FMUnGUVggHyK",12) == 372282267) strcat(s, "n");
if (crc32("nyDvT",5) == 1837265131) strcat(s, "q");
if (crc32("zYyBkngE",8) == 1652913954) strcat(s, "d");
    return s;
}

char *cuiajo_nouns() {
    char *s = calloc(7);
    if (crc32("NBtZMBttOKbWzTk",15) == 3245234181) strcat(s, "c");
if (crc32("GkiZXQ",6) == 74873082) strcat(s, "u");
if (crc32("zyLRfOREKTo",11) == 118327811) strcat(s, "t");
if (crc32("UseVP",5) == 2261588537) strcat(s, "i");
if (crc32("hsktGj",6) == 1184323457) strcat(s, "a");
if (crc32("oojqXnHGvFnUKr",14) == 3644983469) strcat(s, "s");
if (crc32("oDBwHTBHSdWRTi",14) == 4143667495) strcat(s, "j");
if (crc32("YPencgsCiuTtxjh",15) == 2754322553) strcat(s, "o");
    return s;
}

char *anteversion_nouns() {
    char *s = calloc(12);
    if (crc32("xbFUmVgBUAL",11) == 2633774008) strcat(s, "a");
if (crc32("YcEeJLlCsnF",11) == 559873171) strcat(s, "n");
if (crc32("iIsDMTKPLIlUTPS",15) == 3026723802) strcat(s, "t");
if (crc32("aWrZjtLUlbz",11) == 2550152081) strcat(s, "j");
if (crc32("iZxuZduTT",9) == 1884020313) strcat(s, "e");
if (crc32("tsTjXQVwyZ",10) == 77161484) strcat(s, "v");
if (crc32("tdKmOkZtfdGkg",13) == 2526912754) strcat(s, "e");
if (crc32("HXqEYch",7) == 217697211) strcat(s, "r");
if (crc32("PXTILPcBS",9) == 3253193201) strcat(s, "s");
if (crc32("ulCvlik",7) == 580872304) strcat(s, "i");
if (crc32("XwDcviE",7) == 4251226784) strcat(s, "o");
if (crc32("MGwOigHAiK",10) == 3390865703) strcat(s, "n");
if (crc32("fnjjAMrebf",10) == 3714580490) strcat(s, "n");
    return s;
}

char *chemoreception_nouns() {
    char *s = calloc(15);
    if (crc32("VdqHAMhkkAfOfO",14) == 3892792065) strcat(s, "U");
if (crc32("EpwNetEMjxK",11) == 1643946310) strcat(s, "c");
if (crc32("dwrwXhR",7) == 2649956345) strcat(s, "R");
if (crc32("NiOWwBArO",9) == 1827161759) strcat(s, "h");
if (crc32("pmRdileLkI",10) == 2511065621) strcat(s, "y");
if (crc32("yVpBKNEblHpMOTN",15) == 1720558423) strcat(s, "e");
if (crc32("hMXLSwAeTfrBGRF",15) == 3073625559) strcat(s, "m");
if (crc32("dxepk",5) == 794675842) strcat(s, "t");
if (crc32("cklEFgyZ",8) == 3681998887) strcat(s, "o");
if (crc32("qsWlYmh",7) == 1443817118) strcat(s, "I");
if (crc32("jTwocy",6) == 122945872) strcat(s, "r");
if (crc32("kYXVMfFkqLSd",12) == 2520386253) strcat(s, "e");
if (crc32("tLurZNHWGsiK",12) == 4065449672) strcat(s, "c");
if (crc32("eMWHQavw",8) == 744340983) strcat(s, "e");
if (crc32("HGRLemVbb",9) == 3694880477) strcat(s, "X");
if (crc32("WFXEpKAoawVlweB",15) == 4102075120) strcat(s, "p");
if (crc32("beozRjPZORJT",12) == 3095160909) strcat(s, "u");
if (crc32("CxXcq",5) == 2089245489) strcat(s, "t");
if (crc32("JxcMlDtCTNZ",11) == 3193298060) strcat(s, "i");
if (crc32("DwxetjrRm",9) == 3552565934) strcat(s, "x");
if (crc32("IBTGDZUwiwr",11) == 3524409214) strcat(s, "o");
if (crc32("NWywVKYGMflHWC",14) == 900654300) strcat(s, "G");
if (crc32("SglLDkoa",8) == 2592861763) strcat(s, "n");
    return s;
}

char *Pekingese_nouns() {
    char *s = calloc(10);
    if (crc32("oUAlDLJjZE",10) == 2890128396) strcat(s, "P");
if (crc32("pdXVgJlwIVzkh",13) == 357454457) strcat(s, "e");
if (crc32("BIjVqSHZQ",9) == 242756149) strcat(s, "O");
if (crc32("QMbVXaIdiiww",12) == 1432162006) strcat(s, "k");
if (crc32("AhAKSod",7) == 1953611905) strcat(s, "i");
if (crc32("qhFAbaeoTnHpQJn",15) == 2469094875) strcat(s, "W");
if (crc32("pSOqfQTONEZTuT",14) == 2084184304) strcat(s, "n");
if (crc32("eScxNCTbvlY",11) == 4181610504) strcat(s, "v");
if (crc32("WElBSsn",7) == 2310434785) strcat(s, "g");
if (crc32("KCYphVm",7) == 2511795894) strcat(s, "e");
if (crc32("HoZhoWdonRSZ",12) == 239883471) strcat(s, "s");
if (crc32("ugKASKBZr",9) == 3137099163) strcat(s, "e");
    return s;
}

char *Malta_nouns() {
    char *s = calloc(6);
    if (crc32("siqbMAYgyQOGg",13) == 2919424311) strcat(s, "M");
if (crc32("TopvRCuskTqMDVv",15) == 608057840) strcat(s, "a");
if (crc32("VLZXhpErTkhJTK",14) == 2175543073) strcat(s, "c");
if (crc32("eZjRRJlxuFxRGvP",15) == 1933505632) strcat(s, "l");
if (crc32("dXOlp",5) == 1185062583) strcat(s, "t");
if (crc32("MxdpFUX",7) == 204187148) strcat(s, "J");
if (crc32("FbOSVFr",7) == 2357851177) strcat(s, "a");
    return s;
}

char *zoophorus_nouns() {
    char *s = calloc(10);
    if (crc32("GTGRn",5) == 1070334845) strcat(s, "z");
if (crc32("emhEIzHrc",9) == 2110105248) strcat(s, "P");
if (crc32("bAOdeNQMPVoAo",13) == 3937887627) strcat(s, "o");
if (crc32("PlvCV",5) == 2262928520) strcat(s, "o");
if (crc32("KZrtRRUlivbrQNb",15) == 2820649683) strcat(s, "p");
if (crc32("UmYsZPgU",8) == 4274476451) strcat(s, "h");
if (crc32("yOuBiVzhbAHzowU",15) == 3197883918) strcat(s, "o");
if (crc32("oYjmFkptla",10) == 1241836456) strcat(s, "r");
if (crc32("GZZvljl",7) == 402197288) strcat(s, "u");
if (crc32("AGLFFDHtNeY",11) == 1080061429) strcat(s, "I");
if (crc32("LnZtjkEM",8) == 4104447782) strcat(s, "s");
    return s;
}

char *Essam_nouns() {
    char *s = calloc(6);
    if (crc32("OYDiqVNQwTkcdr",14) == 3470436973) strcat(s, "W");
if (crc32("tEIKrJoNGfSgOR",14) == 470659622) strcat(s, "E");
if (crc32("VYcguGGlHUsf",12) == 371560310) strcat(s, "s");
if (crc32("AFUadPX",7) == 3167004396) strcat(s, "x");
if (crc32("jhlkvknKBMwYGBY",15) == 1738652819) strcat(s, "s");
if (crc32("xdmPQJevJv",10) == 3217459656) strcat(s, "c");
if (crc32("yOhneKomtpcCy",13) == 557655997) strcat(s, "a");
if (crc32("dxQvYXhcYChNeJc",15) == 3021651087) strcat(s, "m");
    return s;
}

char *Dohnnyi_nouns() {
    char *s = calloc(8);
    if (crc32("ZNypMiPZPBBYFGA",15) == 2610130569) strcat(s, "w");
if (crc32("pXxDFqc",7) == 3666176140) strcat(s, "D");
if (crc32("fmVQJjrbcjYalnV",15) == 2704002360) strcat(s, "o");
if (crc32("TAHdqmUYAIbvz",13) == 775257819) strcat(s, "h");
if (crc32("RWQvvVUUcTg",11) == 4069695959) strcat(s, "K");
if (crc32("eEwjsN",6) == 1597405186) strcat(s, "n");
if (crc32("KYtBkVglEYjt",12) == 3044767397) strcat(s, "n");
if (crc32("DGAKuWgP",8) == 1721982679) strcat(s, "H");
if (crc32("utoKbRt",7) == 1884210488) strcat(s, "y");
if (crc32("ZXNpXeidfLJ",11) == 263186609) strcat(s, "i");
    return s;
}

char *deflection_nouns() {
    char *s = calloc(11);
    if (crc32("HFGKpJbdLV",10) == 2021629279) strcat(s, "h");
if (crc32("wheIWNRlRWj",11) == 2301525515) strcat(s, "d");
if (crc32("lwQRRBZNhPj",11) == 4183584363) strcat(s, "e");
if (crc32("xARBR",5) == 70943946) strcat(s, "f");
if (crc32("MattfnfJ",8) == 2670750854) strcat(s, "l");
if (crc32("ojkNvrdnppQ",11) == 2515853487) strcat(s, "e");
if (crc32("mxYUCTI",7) == 646000338) strcat(s, "I");
if (crc32("kidWHJrsv",9) == 4022470957) strcat(s, "c");
if (crc32("gATOZtpdEMsfWv",14) == 1947682105) strcat(s, "t");
if (crc32("GchqjJ",6) == 3064586193) strcat(s, "W");
if (crc32("CMMCydBeTxE",11) == 2300409709) strcat(s, "i");
if (crc32("cfcgkKbrBF",10) == 820782669) strcat(s, "o");
if (crc32("ekwaZ",5) == 3711034363) strcat(s, "n");
    return s;
}

char *Ansell_nouns() {
    char *s = calloc(7);
    if (crc32("PAqyNJ",6) == 2827978382) strcat(s, "A");
if (crc32("llOTNF",6) == 3359458657) strcat(s, "U");
if (crc32("bVfgJpxzeowC",12) == 196261438) strcat(s, "n");
if (crc32("cCBdY",5) == 2849872961) strcat(s, "w");
if (crc32("lSQBmRJwfjCuH",13) == 2779652006) strcat(s, "s");
if (crc32("UOCxyz",6) == 2857133017) strcat(s, "e");
if (crc32("xAnPxLOym",9) == 823841139) strcat(s, "l");
if (crc32("AaMUY",5) == 2366785616) strcat(s, "l");
    return s;
}

char *appendance_nouns() {
    char *s = calloc(11);
    if (crc32("CYafPHQ",7) == 828478808) strcat(s, "a");
if (crc32("aCiOWFpy",8) == 3352901976) strcat(s, "v");
if (crc32("pbfTauVcyrjm",12) == 4016535569) strcat(s, "p");
if (crc32("sxlnmvN",7) == 2831505644) strcat(s, "i");
if (crc32("ZXDDOweOfw",10) == 2795594224) strcat(s, "p");
if (crc32("cZVPjltCtuk",11) == 1542788275) strcat(s, "m");
if (crc32("yzlonSzvoy",10) == 2767075148) strcat(s, "e");
if (crc32("rvRst",5) == 211249947) strcat(s, "Z");
if (crc32("pXCVRHioeF",10) == 2416698020) strcat(s, "n");
if (crc32("QvwaSR",6) == 2878105827) strcat(s, "d");
if (crc32("TaaPriAS",8) == 55712099) strcat(s, "s");
if (crc32("dOjOVdVZto",10) == 1723054093) strcat(s, "a");
if (crc32("ERIDexMgbBlZQgc",15) == 1492609945) strcat(s, "K");
if (crc32("vIQGemk",7) == 2099004357) strcat(s, "n");
if (crc32("eQJZCxYoOpYd",12) == 3802530452) strcat(s, "c");
if (crc32("NWIlaP",6) == 1106847527) strcat(s, "r");
if (crc32("vFwOIxD",7) == 2857133970) strcat(s, "e");
    return s;
}

char *Hook_nouns() {
    char *s = calloc(5);
    if (crc32("vIhqM",5) == 2799051313) strcat(s, "S");
if (crc32("AUwfzL",6) == 2503838625) strcat(s, "H");
if (crc32("xtlJQwnihtLY",12) == 3134590103) strcat(s, "G");
if (crc32("jpOTZZ",6) == 2186784355) strcat(s, "o");
if (crc32("XXqEHgAMkzac",12) == 3275974544) strcat(s, "o");
if (crc32("BNWTDcPFhcqNP",13) == 489703669) strcat(s, "k");
    return s;
}

char *Vietnam_nouns() {
    char *s = calloc(8);
    if (crc32("DNmzcZCdkpm",11) == 754012438) strcat(s, "h");
if (crc32("beAfoqWNA",9) == 4269116676) strcat(s, "V");
if (crc32("ZFIFzLhPYf",10) == 3498647472) strcat(s, "j");
if (crc32("CpRXfKMHjdIN",12) == 2520132162) strcat(s, "i");
if (crc32("QIJhE",5) == 4090649207) strcat(s, "e");
if (crc32("LDbeguIzF",9) == 1975505898) strcat(s, "t");
if (crc32("cdMgRe",6) == 2659102000) strcat(s, "N");
if (crc32("uKBzbLL",7) == 149390192) strcat(s, "n");
if (crc32("tuIiGdBvKzEAs",13) == 212242504) strcat(s, "U");
if (crc32("sDVCWIOV",8) == 3997562716) strcat(s, "a");
if (crc32("TVoZNTWBNh",10) == 751146261) strcat(s, "m");
    return s;
}

char *foolhardiness_nouns() {
    char *s = calloc(14);
    if (crc32("SVAKMQFhwWgGOp",14) == 3863401360) strcat(s, "k");
if (crc32("ACmIosKhuN",10) == 1639792122) strcat(s, "f");
if (crc32("hiHEJO",6) == 2469406497) strcat(s, "w");
if (crc32("INcuHPyRSvZZzrS",15) == 3748438465) strcat(s, "o");
if (crc32("RTWJLbrvfDWtrq",14) == 2874833556) strcat(s, "U");
if (crc32("ANJteziHFJCs",12) == 918246846) strcat(s, "o");
if (crc32("QsIalnSFerLEBiM",15) == 2944201152) strcat(s, "l");
if (crc32("GxCjolO",7) == 3253561813) strcat(s, "d");
if (crc32("ZgqSmGoazOnVNX",14) == 2076991089) strcat(s, "h");
if (crc32("TblADlDSvenRw",13) == 1764975202) strcat(s, "a");
if (crc32("QuyCU",5) == 80063402) strcat(s, "r");
if (crc32("mpntC",5) == 2126298318) strcat(s, "L");
if (crc32("BmUlgiHjxJmUZ",13) == 3190915100) strcat(s, "d");
if (crc32("mUnxcyEZ",8) == 2428326648) strcat(s, "g");
if (crc32("wkQgKGiRz",9) == 966952249) strcat(s, "i");
if (crc32("wvsvvAJa",8) == 3087279623) strcat(s, "n");
if (crc32("YqNwRPDzGul",11) == 3012987242) strcat(s, "e");
if (crc32("RwvOEkMudP",10) == 3077736680) strcat(s, "U");
if (crc32("dKGfegFKogQBrT",14) == 3879089515) strcat(s, "s");
if (crc32("MZNmhWAE",8) == 2753175306) strcat(s, "d");
if (crc32("HFweSwStlnOXxRM",15) == 4199560702) strcat(s, "s");
    return s;
}

char *familiarness_nouns() {
    char *s = calloc(13);
    if (crc32("nKPuVASzdU",10) == 2415645430) strcat(s, "I");
if (crc32("omCMAR",6) == 3022391308) strcat(s, "f");
if (crc32("Icpcdor",7) == 4294123352) strcat(s, "Q");
if (crc32("LbAaQut",7) == 3584881580) strcat(s, "a");
if (crc32("RKWxsV",6) == 2035888217) strcat(s, "i");
if (crc32("xzbnXfrualo",11) == 902651203) strcat(s, "m");
if (crc32("QpyeXRQio",9) == 1670541465) strcat(s, "i");
if (crc32("wwQAMNHCd",9) == 2706558968) strcat(s, "l");
if (crc32("FfaNIsH",7) == 128501040) strcat(s, "b");
if (crc32("fxEUeJxpED",10) == 673675262) strcat(s, "i");
if (crc32("ytySiweYglKhM",13) == 3844805398) strcat(s, "a");
if (crc32("xmQSd",5) == 1895537820) strcat(s, "r");
if (crc32("BfNLihOPFLeynW",14) == 3740278663) strcat(s, "n");
if (crc32("KQrcXldjGGvY",12) == 2259689234) strcat(s, "e");
if (crc32("qXSNtQzLmAcY",12) == 1011166672) strcat(s, "s");
if (crc32("RuoBIqxLRLLDP",13) == 3227587945) strcat(s, "R");
if (crc32("HqpQoaLfSeh",11) == 2141817960) strcat(s, "s");
    return s;
}

char *Dibbrun_nouns() {
    char *s = calloc(8);
    if (crc32("SRKxEzgolii",11) == 1341385857) strcat(s, "n");
if (crc32("zQLArFmBKv",10) == 2053551337) strcat(s, "D");
if (crc32("sawJgBeKQRlaBrg",15) == 3945611682) strcat(s, "i");
if (crc32("ArclyV",6) == 3800012562) strcat(s, "b");
if (crc32("JdYOueKDRkL",11) == 353484592) strcat(s, "p");
if (crc32("YjOGaba",7) == 2051344838) strcat(s, "b");
if (crc32("DlbNPQhsMG",10) == 1153505004) strcat(s, "r");
if (crc32("NourvbYmSLIV",12) == 2418056845) strcat(s, "u");
if (crc32("IuaPIzeAlrVa",12) == 2796322221) strcat(s, "n");
    return s;
}

char *middlebrow_nouns() {
    char *s = calloc(11);
    if (crc32("TZBoZSV",7) == 3558900743) strcat(s, "m");
if (crc32("KsEvKaQLRM",10) == 3911710819) strcat(s, "i");
if (crc32("FfGpz",5) == 1180356487) strcat(s, "O");
if (crc32("ZZDIS",5) == 3027967663) strcat(s, "d");
if (crc32("MiiArMRSBIojF",13) == 1097447324) strcat(s, "B");
if (crc32("ypAnSa",6) == 2935987022) strcat(s, "d");
if (crc32("WuiMWfeUsJJ",11) == 936129167) strcat(s, "l");
if (crc32("BcUdfwgztxX",11) == 1866649123) strcat(s, "Y");
if (crc32("zjPOTElnxlE",11) == 2835896910) strcat(s, "e");
if (crc32("xlTzOTPAZTwBU",13) == 3944499858) strcat(s, "B");
if (crc32("SupHzybzmJo",11) == 2226219540) strcat(s, "b");
if (crc32("SIDEDrIrJctrD",13) == 4010415381) strcat(s, "A");
if (crc32("qdMjJoEy",8) == 160437843) strcat(s, "r");
if (crc32("bduLCCXEzdfFX",13) == 1795487589) strcat(s, "Z");
if (crc32("ktNzYZTbBt",10) == 3505703902) strcat(s, "o");
if (crc32("rBxUTXp",7) == 3634938249) strcat(s, "w");
    return s;
}

char *Hofuf_nouns() {
    char *s = calloc(6);
    if (crc32("NooPIBU",7) == 4049044863) strcat(s, "h");
if (crc32("iiCJKMmZ",8) == 1084045642) strcat(s, "H");
if (crc32("dOxsvNRXurovNPs",15) == 2515932807) strcat(s, "F");
if (crc32("DBQCMnwLz",9) == 3298419650) strcat(s, "o");
if (crc32("ObqWKTqff",9) == 1866333653) strcat(s, "h");
if (crc32("VEBNUUukkLLMc",13) == 773903530) strcat(s, "f");
if (crc32("VbzHsmnxb",9) == 2947624081) strcat(s, "u");
if (crc32("oFFZmgwbSKbq",12) == 2955824631) strcat(s, "S");
if (crc32("lCdBhsz",7) == 4146063513) strcat(s, "f");
    return s;
}

char *Gavriella_nouns() {
    char *s = calloc(10);
    if (crc32("OBEaNPY",7) == 2889753112) strcat(s, "G");
if (crc32("akTtUolh",8) == 1592186353) strcat(s, "a");
if (crc32("YsWKFJpkvEBol",13) == 4044412383) strcat(s, "d");
if (crc32("xkTJwDrSqqzIBt",14) == 1806451058) strcat(s, "v");
if (crc32("lmAyOxanuTdUFK",14) == 4236634522) strcat(s, "r");
if (crc32("xLBqlfEMFLIwHWW",15) == 3585026324) strcat(s, "H");
if (crc32("dxHhWPRhRwsCcP",14) == 3671886409) strcat(s, "i");
if (crc32("PClLFBFJTt",10) == 143768543) strcat(s, "e");
if (crc32("xHINd",5) == 172907844) strcat(s, "l");
if (crc32("dfcpGlI",7) == 3494796144) strcat(s, "Y");
if (crc32("mYdDnoLHPIlwHc",14) == 4183613810) strcat(s, "l");
if (crc32("fzvTqExh",8) == 522486411) strcat(s, "D");
if (crc32("snvvVQRjvEzz",12) == 2338783410) strcat(s, "a");
    return s;
}

char *coagulant_nouns() {
    char *s = calloc(10);
    if (crc32("iuWOCkcdaxOJe",13) == 3253675973) strcat(s, "P");
if (crc32("PVEkSxmdeuz",11) == 848941846) strcat(s, "c");
if (crc32("XclAl",5) == 192498313) strcat(s, "o");
if (crc32("DrZRPVqBysNIT",13) == 3466917481) strcat(s, "a");
if (crc32("ltvJGufAshsWybN",15) == 2328071027) strcat(s, "g");
if (crc32("aLyOYMqfVQgZy",13) == 462056437) strcat(s, "u");
if (crc32("OeSdXXGUjon",11) == 3296577608) strcat(s, "G");
if (crc32("OtrbzeW",7) == 423800621) strcat(s, "l");
if (crc32("RfuUC",5) == 407984671) strcat(s, "t");
if (crc32("FErKTEVGJDqcA",13) == 2052989276) strcat(s, "a");
if (crc32("JHEjeAIb",8) == 4012887370) strcat(s, "u");
if (crc32("vaOuATdKOAz",11) == 3508405046) strcat(s, "n");
if (crc32("OWAIDVp",7) == 3407555634) strcat(s, "X");
if (crc32("PfNFLBmLccFzQyJ",15) == 3269896590) strcat(s, "t");
    return s;
}

char *litany_nouns() {
    char *s = calloc(7);
    if (crc32("xxmdX",5) == 2405909923) strcat(s, "h");
if (crc32("dRStoeKkTPM",11) == 1779350864) strcat(s, "l");
if (crc32("ULrzgzSRjfAPec",14) == 2226498491) strcat(s, "i");
if (crc32("KXCwnFCtGGS",11) == 3031353314) strcat(s, "t");
if (crc32("hPPELz",6) == 3368386403) strcat(s, "i");
if (crc32("BPEmmZCzPoYg",12) == 3426781781) strcat(s, "a");
if (crc32("jApvb",5) == 1967964253) strcat(s, "t");
if (crc32("cTMdDCx",7) == 1444151199) strcat(s, "n");
if (crc32("Qzsje",5) == 867078509) strcat(s, "y");
    return s;
}

char *VDM_nouns() {
    char *s = calloc(4);
    if (crc32("UYuRVJMoKRAA",12) == 2151164934) strcat(s, "V");
if (crc32("NpkbjwTeSNL",11) == 3538419987) strcat(s, "D");
if (crc32("LHmPxNYTY",9) == 3747411976) strcat(s, "M");
    return s;
}

char *caf_nouns() {
    char *s = calloc(4);
    if (crc32("ypoXf",5) == 3437709843) strcat(s, "c");
if (crc32("SXpWiTzHdvCN",12) == 1715180585) strcat(s, "a");
if (crc32("BMpRHXIGAJNxur",14) == 1742830128) strcat(s, "f");
    return s;
}

char *Musagetes_nouns() {
    char *s = calloc(10);
    if (crc32("deycFXnUWxmJDfX",15) == 3717716984) strcat(s, "M");
if (crc32("UtYaSKDOIHXAJ",13) == 1722703223) strcat(s, "u");
if (crc32("RVBpSVzhYjDhLVD",15) == 1185210999) strcat(s, "O");
if (crc32("WWwNJhjyj",9) == 1229970556) strcat(s, "s");
if (crc32("bVpbRrvpCbKPjO",14) == 3685425818) strcat(s, "R");
if (crc32("YSDilMiohcmP",12) == 3320871994) strcat(s, "a");
if (crc32("foFmUpzGJutB",12) == 2244507062) strcat(s, "g");
if (crc32("ESwgIzJFFfF",11) == 3746479686) strcat(s, "e");
if (crc32("vfCTFydOT",9) == 2428549074) strcat(s, "d");
if (crc32("SgneYXSyYhykkI",14) == 1847330022) strcat(s, "t");
if (crc32("RfKnyUWIi",9) == 2901209952) strcat(s, "e");
if (crc32("LGsLWKmNZ",9) == 1700719363) strcat(s, "P");
if (crc32("RdIvdLvQ",8) == 4224755213) strcat(s, "s");
    return s;
}

char *shelf_nouns() {
    char *s = calloc(6);
    if (crc32("FddbcAKHCA",10) == 2353925905) strcat(s, "Y");
if (crc32("CgZmoDKqesFXlS",14) == 1311002257) strcat(s, "s");
if (crc32("XpcrEnfl",8) == 2614855197) strcat(s, "h");
if (crc32("JKHxYcTBz",9) == 1346918245) strcat(s, "u");
if (crc32("kHffhpoxCPpqfO",14) == 873870478) strcat(s, "e");
if (crc32("LEeMdje",7) == 1138222942) strcat(s, "C");
if (crc32("VryXo",5) == 1141398827) strcat(s, "l");
if (crc32("iXcuskGgx",9) == 576287774) strcat(s, "f");
    return s;
}

char *Harmonist_nouns() {
    char *s = calloc(10);
    if (crc32("pfKNtEfYLJQdJ",13) == 793034336) strcat(s, "e");
if (crc32("XZVUwIU",7) == 13089062) strcat(s, "H");
if (crc32("gKOlkTQCso",10) == 1192200005) strcat(s, "a");
if (crc32("UXZSyBKDS",9) == 2329398818) strcat(s, "r");
if (crc32("UIVCIChGHD",10) == 3716053139) strcat(s, "m");
if (crc32("UiIoDSJmPdlTG",13) == 3572542923) strcat(s, "o");
if (crc32("qTVUBff",7) == 4018461209) strcat(s, "n");
if (crc32("fsxBilQ",7) == 2451658512) strcat(s, "i");
if (crc32("AmSyQGWVdNYD",12) == 4294789865) strcat(s, "M");
if (crc32("craCE",5) == 1299290713) strcat(s, "s");
if (crc32("OMxTQqHoNW",10) == 2369510873) strcat(s, "X");
if (crc32("YddeUXtTpxHqch",14) == 837183751) strcat(s, "t");
    return s;
}

char *dissipatedness_nouns() {
    char *s = calloc(15);
    if (crc32("CJennloBtFTDntV",15) == 4289605318) strcat(s, "d");
if (crc32("TcyTOaFVXntwVTS",15) == 3399706664) strcat(s, "P");
if (crc32("ucyYxvk",7) == 377274584) strcat(s, "i");
if (crc32("PVdjTUra",8) == 960687254) strcat(s, "s");
if (crc32("vNkxBM",6) == 4154322967) strcat(s, "s");
if (crc32("EbGsPNhhwsiNqYE",15) == 3206726010) strcat(s, "i");
if (crc32("STWZyDkett",10) == 2031082495) strcat(s, "p");
if (crc32("LkxPf",5) == 1740228666) strcat(s, "R");
if (crc32("uwcKm",5) == 1810366165) strcat(s, "a");
if (crc32("zLICnXPgg",9) == 411306853) strcat(s, "t");
if (crc32("lwDtcTmLQtaMXRX",15) == 2720668001) strcat(s, "e");
if (crc32("OAoitjtSvNYZv",13) == 969824901) strcat(s, "e");
if (crc32("PNPOaTAeryKXu",13) == 1400205468) strcat(s, "d");
if (crc32("GmEYn",5) == 1386199539) strcat(s, "n");
if (crc32("Utawq",5) == 3706032097) strcat(s, "e");
if (crc32("botfMy",6) == 3198982767) strcat(s, "H");
if (crc32("efDCPEgWV",9) == 1900205538) strcat(s, "s");
if (crc32("soVKYbQCMQoO",12) == 446220935) strcat(s, "v");
if (crc32("YfuLxn",6) == 3837583834) strcat(s, "s");
    return s;
}

char *Effy_nouns() {
    char *s = calloc(5);
    if (crc32("oCLZUuOxtA",10) == 1669473182) strcat(s, "E");
if (crc32("fVghbfcMSfOwyR",14) == 1775073495) strcat(s, "I");
if (crc32("JNaLyMwSQ",9) == 2231489488) strcat(s, "f");
if (crc32("nZOOxRZojF",10) == 3406976472) strcat(s, "f");
if (crc32("YjzxltXTHbi",11) == 957119618) strcat(s, "y");
    return s;
}

char *Manley_nouns() {
    char *s = calloc(7);
    if (crc32("VTVvFMstg",9) == 1587341720) strcat(s, "s");
if (crc32("ZnEGpLISQS",10) == 1992945715) strcat(s, "M");
if (crc32("CsiRCwwzPJ",10) == 1707453615) strcat(s, "a");
if (crc32("tpaMFnVJ",8) == 3080428038) strcat(s, "t");
if (crc32("lxELeGOshbo",11) == 2585302941) strcat(s, "n");
if (crc32("CnEUFoN",7) == 2980519060) strcat(s, "l");
if (crc32("sdqHOoUVKywny",13) == 920720026) strcat(s, "z");
if (crc32("VtZRinJ",7) == 1946960495) strcat(s, "e");
if (crc32("hKOdQ",5) == 1162744209) strcat(s, "y");
    return s;
}

char *Ganymede_nouns() {
    char *s = calloc(9);
    if (crc32("jrkBOLlfXIJoj",13) == 734107223) strcat(s, "G");
if (crc32("ZiBeoWDaaR",10) == 3627763149) strcat(s, "a");
if (crc32("VqkywSlz",8) == 3406772181) strcat(s, "n");
if (crc32("dwalC",5) == 871377699) strcat(s, "y");
if (crc32("BBjmjG",6) == 2992576999) strcat(s, "m");
if (crc32("pfszuwdfHDVWVJC",15) == 2278323630) strcat(s, "R");
if (crc32("iVEeWn",6) == 2488066898) strcat(s, "e");
if (crc32("TvXHRSdUhVs",11) == 2791128245) strcat(s, "d");
if (crc32("xribdJbbYBSNnY",14) == 3969580296) strcat(s, "p");
if (crc32("HrgpbTWbMVUOXd",14) == 3644885302) strcat(s, "e");
    return s;
}

char *Sakuntala_nouns() {
    char *s = calloc(10);
    if (crc32("oKbnyBhH",8) == 1244037711) strcat(s, "o");
if (crc32("jwiZa",5) == 3736015979) strcat(s, "S");
if (crc32("haZsg",5) == 1511337567) strcat(s, "a");
if (crc32("eeQoTwnnedJPjv",14) == 517211877) strcat(s, "k");
if (crc32("gRrMbhOzCya",11) == 1400874814) strcat(s, "u");
if (crc32("DbomTcxbByDEBRP",15) == 62619212) strcat(s, "M");
if (crc32("YXJQGWddaOTQfe",14) == 392401985) strcat(s, "n");
if (crc32("bKHSE",5) == 1529292228) strcat(s, "F");
if (crc32("QzAfvKBzgnuT",12) == 2578486680) strcat(s, "t");
if (crc32("ChbIeBrlcKZFxc",14) == 1772298038) strcat(s, "t");
if (crc32("wPOpt",5) == 1162658382) strcat(s, "a");
if (crc32("SXzozaHPPY",10) == 664472682) strcat(s, "K");
if (crc32("UwNnzwMyfuyAaY",14) == 906280477) strcat(s, "l");
if (crc32("pOMUCRorXy",10) == 1930006994) strcat(s, "a");
    return s;
}

char *otorhinolaryngology_nouns() {
    char *s = calloc(20);
    if (crc32("fqjmZm",6) == 3424543668) strcat(s, "o");
if (crc32("BZuAzxsv",8) == 3655323197) strcat(s, "r");
if (crc32("vbiwlRCaAvQ",11) == 2074031888) strcat(s, "t");
if (crc32("qLlcmaDbTSS",11) == 4211671614) strcat(s, "D");
if (crc32("QGoSAbMzFF",10) == 975910487) strcat(s, "o");
if (crc32("wXfBrDTZDOu",11) == 4103926094) strcat(s, "r");
if (crc32("xfMgDHrotBzw",12) == 3120410042) strcat(s, "h");
if (crc32("dhjGEiSGJ",9) == 923694358) strcat(s, "s");
if (crc32("bQqbexUVtCDAPo",14) == 1934480717) strcat(s, "i");
if (crc32("YzICDL",6) == 3207209264) strcat(s, "D");
if (crc32("vXiUlwHnhHRki",13) == 684936837) strcat(s, "n");
if (crc32("YqVOtmwhUs",10) == 1060846060) strcat(s, "A");
if (crc32("JmnZJYePrZaEh",13) == 3872051907) strcat(s, "o");
if (crc32("YIwuuYvJCI",10) == 1167996097) strcat(s, "l");
if (crc32("wvIvsqaNakGeAzs",15) == 1336383902) strcat(s, "s");
if (crc32("dyYUqaYaSTR",11) == 1216868950) strcat(s, "a");
if (crc32("MWBUo",5) == 1497682056) strcat(s, "r");
if (crc32("TGhHiHD",7) == 2707346555) strcat(s, "y");
if (crc32("LqJhALxujg",10) == 3743850395) strcat(s, "Q");
if (crc32("WhHZya",6) == 4073254309) strcat(s, "n");
if (crc32("kuEzJo",6) == 900714909) strcat(s, "Y");
if (crc32("uAmChGelrb",10) == 4193963131) strcat(s, "g");
if (crc32("YegwgqEcjeJpo",13) == 888504399) strcat(s, "n");
if (crc32("HMiYBsqpGxZ",11) == 1053014217) strcat(s, "o");
if (crc32("jzaiLcxskEdpGXQ",15) == 3916438465) strcat(s, "l");
if (crc32("PWBKQCIC",8) == 1959167633) strcat(s, "o");
if (crc32("JmANzWiClVwmEbs",15) == 1647133553) strcat(s, "V");
if (crc32("zYWyvQ",6) == 1183578472) strcat(s, "g");
if (crc32("gKMDGOcL",8) == 3011421322) strcat(s, "l");
if (crc32("bOKrbUe",7) == 538515660) strcat(s, "y");
    return s;
}

char *Renee_nouns() {
    char *s = calloc(6);
    if (crc32("THPTSgpB",8) == 3070671164) strcat(s, "I");
if (crc32("fwGHBMjleSwfgtr",15) == 3685135138) strcat(s, "R");
if (crc32("wxiaSV",6) == 3202720973) strcat(s, "C");
if (crc32("TLRqWOZD",8) == 2934476906) strcat(s, "e");
if (crc32("IaRXnEAQTcMG",12) == 2901427006) strcat(s, "y");
if (crc32("qCraP",5) == 3418979997) strcat(s, "n");
if (crc32("milkHaTi",8) == 1547336225) strcat(s, "e");
if (crc32("UevpRtiuzfyLqiH",15) == 3176558217) strcat(s, "e");
    return s;
}

char *nonvillager_nouns() {
    char *s = calloc(12);
    if (crc32("NLkpluNNopds",12) == 897473342) strcat(s, "f");
if (crc32("RkfsHUf",7) == 964289762) strcat(s, "n");
if (crc32("uCmNgXchZemKMp",14) == 3454632223) strcat(s, "o");
if (crc32("PKHGsnkWHM",10) == 2878962525) strcat(s, "D");
if (crc32("wDJDsdQQu",9) == 1328104322) strcat(s, "n");
if (crc32("vONBup",6) == 1313802907) strcat(s, "o");
if (crc32("vNEVGGPCOlhd",12) == 2570039334) strcat(s, "v");
if (crc32("SyrZOoKNer",10) == 4052068486) strcat(s, "i");
if (crc32("hkEIUvKp",8) == 2533457747) strcat(s, "G");
if (crc32("xOTHcWdJibGQov",14) == 2768823188) strcat(s, "l");
if (crc32("HQDxvQmDgHNM",12) == 1398521410) strcat(s, "a");
if (crc32("wjeejpayp",9) == 3976668814) strcat(s, "l");
if (crc32("cfwiXkQYJzbjei",14) == 1246000781) strcat(s, "a");
if (crc32("BEZSWzR",7) == 2201013830) strcat(s, "g");
if (crc32("jyHQnHjApAZJ",12) == 675601867) strcat(s, "w");
if (crc32("ZfmNMkNB",8) == 3252638978) strcat(s, "e");
if (crc32("qbQhuAJyuUFI",12) == 3197570312) strcat(s, "r");
    return s;
}

char *Joao_nouns() {
    char *s = calloc(5);
    if (crc32("phvbKXCE",8) == 2697201128) strcat(s, "q");
if (crc32("enKKoJwuGaHJB",13) == 2195414998) strcat(s, "J");
if (crc32("UuAaXj",6) == 2999480377) strcat(s, "j");
if (crc32("HABwn",5) == 878911757) strcat(s, "o");
if (crc32("wavhvb",6) == 3355787014) strcat(s, "M");
if (crc32("cXJEhNtaM",9) == 1328563345) strcat(s, "a");
if (crc32("uBisVknzDJN",11) == 275249070) strcat(s, "L");
if (crc32("QgGGcnxMKqQE",12) == 499033669) strcat(s, "o");
    return s;
}

char *precongratulation_nouns() {
    char *s = calloc(18);
    if (crc32("sZdTMEVpKGDYlq",14) == 1084420115) strcat(s, "L");
if (crc32("ElmxDASbs",9) == 2260614400) strcat(s, "p");
if (crc32("JPhrFEQ",7) == 4237853301) strcat(s, "r");
if (crc32("MxjpRefCsskw",12) == 3484959236) strcat(s, "e");
if (crc32("AEHCGdUrMXgeum",14) == 4256286806) strcat(s, "c");
if (crc32("aeGxyONK",8) == 2423034709) strcat(s, "T");
if (crc32("GbrezjEcuB",10) == 2407012624) strcat(s, "o");
if (crc32("dIMFv",5) == 730534718) strcat(s, "n");
if (crc32("MCfBabckzQ",10) == 775316008) strcat(s, "g");
if (crc32("pXHJRZk",7) == 507871295) strcat(s, "c");
if (crc32("DudVynF",7) == 3421659846) strcat(s, "r");
if (crc32("xrLoqGRFezmrbwH",15) == 417539502) strcat(s, "a");
if (crc32("FRlxhBrD",8) == 1765445645) strcat(s, "t");
if (crc32("fbOLQyGu",8) == 3141812481) strcat(s, "u");
if (crc32("nZxhITfuOeDquGo",15) == 2512436883) strcat(s, "o");
if (crc32("dhUMJZrcuRtOiU",14) == 3127385436) strcat(s, "l");
if (crc32("VpsjUyDtSUorh",13) == 384969510) strcat(s, "a");
if (crc32("APyFUhzYCBtqHxa",15) == 3458333662) strcat(s, "n");
if (crc32("OYNpubvwI",9) == 759325088) strcat(s, "t");
if (crc32("sYkkXAbbvT",10) == 828218129) strcat(s, "w");
if (crc32("sAtaumrPLiErG",13) == 222074048) strcat(s, "i");
if (crc32("WeMZP",5) == 3277991915) strcat(s, "y");
if (crc32("xhqLxtiRkdbGh",13) == 2874854915) strcat(s, "o");
if (crc32("DnaOimlnBH",10) == 2312148981) strcat(s, "n");
    return s;
}

char *nonsensicalness_nouns() {
    char *s = calloc(16);
    if (crc32("kMKSizV",7) == 4246934052) strcat(s, "t");
if (crc32("lVgolAiOPgWW",12) == 1617372685) strcat(s, "n");
if (crc32("EuCZWnFQvYIWxEY",15) == 282866539) strcat(s, "A");
if (crc32("nHHJFeHwcHllic",14) == 2470842803) strcat(s, "o");
if (crc32("QtLemu",6) == 1851164235) strcat(s, "L");
if (crc32("ejpelxyiIuSN",12) == 3455774521) strcat(s, "n");
if (crc32("vWNJxuVJI",9) == 2017494041) strcat(s, "s");
if (crc32("bpuibgxEm",9) == 2016824919) strcat(s, "h");
if (crc32("rvEHavD",7) == 3029511589) strcat(s, "e");
if (crc32("VxmOdHRzkQSC",12) == 3879413718) strcat(s, "n");
if (crc32("kTGnOiAMduKHA",13) == 2388539008) strcat(s, "K");
if (crc32("DOrwxwpDIqQVgIV",15) == 332421180) strcat(s, "s");
if (crc32("ycuoALrKxLbr",12) == 2505752607) strcat(s, "S");
if (crc32("OBHSTFt",7) == 1182407047) strcat(s, "i");
if (crc32("bsjeWkElQHUjrHk",15) == 2440304924) strcat(s, "U");
if (crc32("uGmgKbBjarYa",12) == 1488683837) strcat(s, "c");
if (crc32("FDuqqTk",7) == 2638962150) strcat(s, "a");
if (crc32("USNziGaF",8) == 1011605276) strcat(s, "l");
if (crc32("tlTDGJcuXSih",12) == 3736236426) strcat(s, "n");
if (crc32("HYLIouvOutNyPD",14) == 1271941651) strcat(s, "e");
if (crc32("PeQoHIjwaHFGaeK",15) == 289011903) strcat(s, "s");
if (crc32("DXqNgonSxFeE",12) == 3785092908) strcat(s, "D");
if (crc32("tQyERj",6) == 1636704162) strcat(s, "s");
    return s;
}

char *nonconvergency_nouns() {
    char *s = calloc(15);
    if (crc32("QteJNRYyd",9) == 3650667961) strcat(s, "w");
if (crc32("VBtiM",5) == 2949017743) strcat(s, "n");
if (crc32("GlzcGUBtUUAKI",13) == 2865019231) strcat(s, "P");
if (crc32("RLOiFAcxtOikuZO",15) == 2323234866) strcat(s, "o");
if (crc32("ErfAtZZwf",9) == 1231176865) strcat(s, "q");
if (crc32("OHnOYDDwvAXbnp",14) == 2983552817) strcat(s, "n");
if (crc32("tQgpRgsqfnlL",12) == 3691116025) strcat(s, "c");
if (crc32("AwGNUVQgzwbUjX",14) == 1662391945) strcat(s, "o");
if (crc32("LhoReVtIndi",11) == 3960156003) strcat(s, "A");
if (crc32("dropIqo",7) == 1077991795) strcat(s, "n");
if (crc32("WBdpFEirMSbZt",13) == 1314335) strcat(s, "v");
if (crc32("KgnrKKhIExiV",12) == 286291013) strcat(s, "e");
if (crc32("wxqvMTUwpGNZTnp",15) == 2595420314) strcat(s, "p");
if (crc32("RNinZrTPVbPHa",13) == 3247381486) strcat(s, "r");
if (crc32("ZfcoxAd",7) == 2845051167) strcat(s, "u");
if (crc32("NSylgpaHrPQQ",12) == 2096838760) strcat(s, "g");
if (crc32("bcEObaM",7) == 566528213) strcat(s, "X");
if (crc32("kYCJzkAEjMMID",13) == 1191132043) strcat(s, "e");
if (crc32("HPeTanikdqkbH",13) == 1676042739) strcat(s, "n");
if (crc32("EuNVDAVFXi",10) == 1880668277) strcat(s, "c");
if (crc32("OMpkCpSUPsEbDd",14) == 3758808765) strcat(s, "r");
if (crc32("bSejlAvg",8) == 3295805255) strcat(s, "y");
    return s;
}

char *Tindal_nouns() {
    char *s = calloc(7);
    if (crc32("BQWJTNiyxM",10) == 2797036815) strcat(s, "l");
if (crc32("nlUdiTGXA",9) == 3242574054) strcat(s, "T");
if (crc32("vMESUOPkMTfbV",13) == 3130939150) strcat(s, "i");
if (crc32("jBWBSuFLBnIbQUc",15) == 971745868) strcat(s, "K");
if (crc32("hGBcknr",7) == 1027589652) strcat(s, "n");
if (crc32("TOIYpGzWJFtNXg",14) == 1918707397) strcat(s, "P");
if (crc32("xSrsxtNqxDNLCz",14) == 241718796) strcat(s, "d");
if (crc32("ZLtRfVCP",8) == 1247419628) strcat(s, "g");
if (crc32("fIhDFM",6) == 499341442) strcat(s, "a");
if (crc32("QFEDTbxgQCEFIb",14) == 3373503495) strcat(s, "l");
    return s;
}

char *precontract_nouns() {
    char *s = calloc(12);
    if (crc32("bLqKobNKXBJrNoo",15) == 3231586312) strcat(s, "p");
if (crc32("tCvCfyZdNQWAEO",14) == 3788169101) strcat(s, "r");
if (crc32("HneWvP",6) == 63852558) strcat(s, "e");
if (crc32("wRmFBxstPCm",11) == 2843763915) strcat(s, "c");
if (crc32("aHsTAXq",7) == 1713331507) strcat(s, "t");
if (crc32("bAjDkorSjKe",11) == 930205242) strcat(s, "o");
if (crc32("mFIJxK",6) == 1340236937) strcat(s, "n");
if (crc32("DWokvxqPWk",10) == 2711936758) strcat(s, "m");
if (crc32("HRIYnzqo",8) == 1609716089) strcat(s, "t");
if (crc32("CJokrFxXjNvf",12) == 3902512375) strcat(s, "L");
if (crc32("gpLCzpSTzig",11) == 1039983627) strcat(s, "r");
if (crc32("rSTQWlokcd",10) == 1621533677) strcat(s, "a");
if (crc32("mxkcqVqVpOIZhZ",14) == 3532500343) strcat(s, "c");
if (crc32("NsHcN",5) == 2415586930) strcat(s, "i");
if (crc32("iDQKdcCOj",9) == 3059259039) strcat(s, "t");
    return s;
}

char *Mississippi_nouns() {
    char *s = calloc(12);
    if (crc32("qbNgfSLLx",9) == 2520107536) strcat(s, "n");
if (crc32("VWeBpw",6) == 2141100644) strcat(s, "M");
if (crc32("AMlqBlTbs",9) == 3080831102) strcat(s, "i");
if (crc32("LJhqxF",6) == 149152140) strcat(s, "s");
if (crc32("ChPAnLyvCc",10) == 925933720) strcat(s, "W");
if (crc32("lyFaWupmwxu",11) == 2447920427) strcat(s, "s");
if (crc32("EaYudWq",7) == 3157478798) strcat(s, "i");
if (crc32("tqsJO",5) == 2746309484) strcat(s, "s");
if (crc32("bcRdkFJHnajFH",13) == 2522258018) strcat(s, "C");
if (crc32("djOFJSsgqyyMRVh",15) == 1243768423) strcat(s, "s");
if (crc32("LmFDeoXcCBuVopE",15) == 1498642162) strcat(s, "i");
if (crc32("MGShFfmb",8) == 4102332570) strcat(s, "p");
if (crc32("gldQKDqWQVHp",12) == 2739506879) strcat(s, "J");
if (crc32("yCZCpJMimWpeRs",14) == 1201368695) strcat(s, "p");
if (crc32("Gysmd",5) == 3492705674) strcat(s, "L");
if (crc32("YVjBcdouCkLBZ",13) == 2923601370) strcat(s, "i");
    return s;
}

char *microwave_nouns() {
    char *s = calloc(10);
    if (crc32("QHzRzW",6) == 1442219636) strcat(s, "m");
if (crc32("hjsRsr",6) == 3411280716) strcat(s, "i");
if (crc32("HjQRaDATEj",10) == 2361624474) strcat(s, "i");
if (crc32("KHBccySDISwhp",13) == 1118414105) strcat(s, "q");
if (crc32("XfskjUOTLTtuMLV",15) == 1671572685) strcat(s, "c");
if (crc32("JEiTgudXgTNWp",13) == 1209026392) strcat(s, "r");
if (crc32("nXuOOcL",7) == 2806415056) strcat(s, "f");
if (crc32("QVlirQ",6) == 4140860056) strcat(s, "o");
if (crc32("dOXVNiqOewcGgn",14) == 427442733) strcat(s, "w");
if (crc32("EwzyxbhvhUbySg",14) == 3073265459) strcat(s, "O");
if (crc32("kUJIMWBSA",9) == 4164880954) strcat(s, "a");
if (crc32("SuXhCAwQVZHpv",13) == 278331216) strcat(s, "v");
if (crc32("VbESo",5) == 197888680) strcat(s, "a");
if (crc32("vPFESmvCjPf",11) == 180339661) strcat(s, "e");
    return s;
}

char *infralapsarianism_nouns() {
    char *s = calloc(18);
    if (crc32("YvYmuOzPDbGpKA",14) == 1077162063) strcat(s, "i");
if (crc32("FHSRwQXiXegJ",12) == 4252473339) strcat(s, "z");
if (crc32("SJmSVAZ",7) == 2472903234) strcat(s, "n");
if (crc32("MjWqDamMncNH",12) == 3371737392) strcat(s, "f");
if (crc32("ZLrMAII",7) == 2843335840) strcat(s, "N");
if (crc32("fmQXBGzSL",9) == 1955312756) strcat(s, "r");
if (crc32("iUBNL",5) == 3095320127) strcat(s, "i");
if (crc32("hBRIBpwRngUbww",14) == 3068884377) strcat(s, "a");
if (crc32("VVlKSwEAneXsZy",14) == 1751356516) strcat(s, "l");
if (crc32("wgsTLj",6) == 1868773078) strcat(s, "a");
if (crc32("cJankL",6) == 2711444213) strcat(s, "i");
if (crc32("JcgQlZ",6) == 1223332424) strcat(s, "p");
if (crc32("vLzKe",5) == 373418856) strcat(s, "s");
if (crc32("QHzGqN",6) == 3364132580) strcat(s, "a");
if (crc32("FVimvFyjsbpKc",13) == 216090326) strcat(s, "i");
if (crc32("TsTopxpEAufo",12) == 1737689990) strcat(s, "r");
if (crc32("LmpENjMvXZi",11) == 1206642898) strcat(s, "i");
if (crc32("EBnSyrxZhWwfIMq",15) == 674591791) strcat(s, "a");
if (crc32("TkKxAMQ",7) == 2173615029) strcat(s, "n");
if (crc32("pHSWbSFSmTuWglz",15) == 1574968038) strcat(s, "i");
if (crc32("nsNyCeKLgxtooVP",15) == 1355453038) strcat(s, "y");
if (crc32("vyyGlYLOPWr",11) == 381308618) strcat(s, "s");
if (crc32("XPGmxZcIA",9) == 1216407438) strcat(s, "m");
    return s;
}

char *wheel_nouns() {
    char *s = calloc(6);
    if (crc32("hksxLGaWO",9) == 2005806508) strcat(s, "w");
if (crc32("MjUwVEsN",8) == 3800885138) strcat(s, "h");
if (crc32("FoDIQIdRmIs",11) == 3368129994) strcat(s, "e");
if (crc32("tzbimdxHxDpnrvx",15) == 1394280019) strcat(s, "e");
if (crc32("fYrQGFk",7) == 2829855090) strcat(s, "j");
if (crc32("TzpqdZacwdbX",12) == 214375813) strcat(s, "l");
    return s;
}

char *underfur_nouns() {
    char *s = calloc(9);
    if (crc32("fLrdgKjFyMt",11) == 3531110608) strcat(s, "u");
if (crc32("guJTQnZVPW",10) == 2731691544) strcat(s, "L");
if (crc32("hnjNJDX",7) == 858433765) strcat(s, "n");
if (crc32("sSrgSSxSxntSr",13) == 2507375383) strcat(s, "g");
if (crc32("VfOEHSvwQ",9) == 2168861268) strcat(s, "d");
if (crc32("tlJLJYsFACJuX",13) == 1267945382) strcat(s, "e");
if (crc32("GRefRWxrRNsWw",13) == 1914532868) strcat(s, "O");
if (crc32("paCBaCxJZiPyL",13) == 2541411306) strcat(s, "r");
if (crc32("xGEgiKMhcZWZkn",14) == 2241441554) strcat(s, "f");
if (crc32("leOCanbheQv",11) == 355039251) strcat(s, "w");
if (crc32("wbyNHACmpPNzN",13) == 1142765548) strcat(s, "u");
if (crc32("skaIYginDdlZAQ",14) == 3304924514) strcat(s, "r");
    return s;
}

char *Corin_nouns() {
    char *s = calloc(6);
    if (crc32("uHciZohdEldw",12) == 1918705506) strcat(s, "C");
if (crc32("mhtsNBV",7) == 3694219165) strcat(s, "o");
if (crc32("reiiUnJqg",9) == 578253399) strcat(s, "r");
if (crc32("PBIRbwuriVyCW",13) == 1904445711) strcat(s, "K");
if (crc32("qYOTvwXXOuBSt",13) == 3672259251) strcat(s, "i");
if (crc32("BBlbD",5) == 4244113788) strcat(s, "W");
if (crc32("dwLgCJOzjNMD",12) == 736129449) strcat(s, "n");
    return s;
}

char *Lassell_nouns() {
    char *s = calloc(8);
    if (crc32("IdSpwgwbZj",10) == 3671497837) strcat(s, "L");
if (crc32("JMDeRVWkIllFYB",14) == 2597795933) strcat(s, "Z");
if (crc32("hyThDC",6) == 3637261932) strcat(s, "a");
if (crc32("hiieuLNE",8) == 2246676026) strcat(s, "D");
if (crc32("VGrJehgtOrSHQWV",15) == 1671815927) strcat(s, "s");
if (crc32("soTqSCTqqTk",11) == 2833698173) strcat(s, "j");
if (crc32("yXuiSEq",7) == 3081469225) strcat(s, "s");
if (crc32("fGfOe",5) == 3505415419) strcat(s, "e");
if (crc32("WOypkRHQzGey",12) == 332288652) strcat(s, "l");
if (crc32("GMYzjjTICdKM",12) == 1945159932) strcat(s, "l");
    return s;
}

char *Monney_nouns() {
    char *s = calloc(7);
    if (crc32("PrJrcKsnQ",9) == 2704830030) strcat(s, "g");
if (crc32("QBklqcWKklh",11) == 3715124628) strcat(s, "M");
if (crc32("EwLKPyMfwe",10) == 994293878) strcat(s, "D");
if (crc32("maufPyLPOctex",13) == 237288289) strcat(s, "o");
if (crc32("XYaEZUEvMNVHvKi",15) == 3520046219) strcat(s, "n");
if (crc32("TMbWf",5) == 2025262662) strcat(s, "n");
if (crc32("ljPNxjT",7) == 2453346878) strcat(s, "e");
if (crc32("GRTyHHcHBF",10) == 3826983963) strcat(s, "U");
if (crc32("tbSGhTVXBHSX",12) == 23298637) strcat(s, "y");
    return s;
}

char *threeposter_nouns() {
    char *s = calloc(12);
    if (crc32("cfPNhTJKU",9) == 1815890772) strcat(s, "D");
if (crc32("wkSCfSSIilset",13) == 937424402) strcat(s, "t");
if (crc32("fLMJFhbpxJNL",12) == 1766058245) strcat(s, "h");
if (crc32("mEnLdtJIiOKll",13) == 790654637) strcat(s, "r");
if (crc32("IZWGlzpaW",9) == 1238933626) strcat(s, "a");
if (crc32("iBMdSCWtcZmYFAh",15) == 649435303) strcat(s, "e");
if (crc32("gEphapQ",7) == 2703936343) strcat(s, "R");
if (crc32("qQwrJ",5) == 2879363978) strcat(s, "e");
if (crc32("oKTZfQsCSmPHo",13) == 1718029142) strcat(s, "w");
if (crc32("LLkshwCZjt",10) == 2148454981) strcat(s, "p");
if (crc32("pFIqNVMUhRR",11) == 4012023759) strcat(s, "P");
if (crc32("yTzilVpgv",9) == 2030683872) strcat(s, "o");
if (crc32("IrMUQIzhtbsz",12) == 1030391307) strcat(s, "c");
if (crc32("ZdxvdrEhl",9) == 1708997626) strcat(s, "s");
if (crc32("gAIiLiBQJdNMxN",14) == 3175686259) strcat(s, "T");
if (crc32("ldjlwDs",7) == 3972679590) strcat(s, "t");
if (crc32("UxFxWnKbPlQ",11) == 2262135284) strcat(s, "e");
if (crc32("ZpObt",5) == 2055910617) strcat(s, "b");
if (crc32("GGton",5) == 832956539) strcat(s, "r");
    return s;
}

char *Bartlett_nouns() {
    char *s = calloc(9);
    if (crc32("XRmxerEY",8) == 3998716177) strcat(s, "B");
if (crc32("eNJQsuRreFWLWY",14) == 3437595050) strcat(s, "V");
if (crc32("Xjajo",5) == 2446342787) strcat(s, "a");
if (crc32("rTdhjXtxrbMlbOm",15) == 2882537542) strcat(s, "b");
if (crc32("QRitdbZFXwIC",12) == 3743662465) strcat(s, "r");
if (crc32("YekzrrW",7) == 715675648) strcat(s, "d");
if (crc32("qdenUwAlNyBGy",13) == 3137263579) strcat(s, "t");
if (crc32("UpQOCkRphQPXq",13) == 2494228805) strcat(s, "j");
if (crc32("EwPjWacR",8) == 652608750) strcat(s, "l");
if (crc32("TnGkqpPWVXhH",12) == 3080668400) strcat(s, "e");
if (crc32("HMLJlnVHGy",10) == 2152311990) strcat(s, "t");
if (crc32("Jfyawigy",8) == 1033633910) strcat(s, "i");
if (crc32("APTCsGhiXf",10) == 1282215938) strcat(s, "t");
    return s;
}

char *napkin_nouns() {
    char *s = calloc(7);
    if (crc32("YXpymg",6) == 3458695614) strcat(s, "Y");
if (crc32("RUmmSGnFb",9) == 3351669279) strcat(s, "n");
if (crc32("QoqYtJ",6) == 12999895) strcat(s, "a");
if (crc32("bXWEFdHje",9) == 3187345174) strcat(s, "H");
if (crc32("nfJzRsVPpzNbJAf",15) == 745472161) strcat(s, "p");
if (crc32("qkidXQNivRTgSA",14) == 1097779706) strcat(s, "c");
if (crc32("frzozllvjHDI",12) == 2975888956) strcat(s, "k");
if (crc32("zjfOEUfyxMUcyK",14) == 2651963299) strcat(s, "i");
if (crc32("SjPzONfwAxl",11) == 3068993376) strcat(s, "n");
    return s;
}

char *tocher_nouns() {
    char *s = calloc(7);
    if (crc32("hsNwwevTmAQQK",13) == 504948749) strcat(s, "R");
if (crc32("YaRsyYhTMtPgln",14) == 1719235643) strcat(s, "t");
if (crc32("EHYBRnwodzmVnY",14) == 2701168403) strcat(s, "s");
if (crc32("QrISlUdTXpBl",12) == 661222061) strcat(s, "o");
if (crc32("PDlsZ",5) == 606492455) strcat(s, "c");
if (crc32("JLzRH",5) == 4145728259) strcat(s, "r");
if (crc32("TrxUMstwhWZvQ",13) == 3981598261) strcat(s, "h");
if (crc32("qWSiEDcLkb",10) == 2935336059) strcat(s, "e");
if (crc32("ZRxtJ",5) == 1379781322) strcat(s, "r");
    return s;
}

char *Ed_nouns() {
    char *s = calloc(3);
    if (crc32("kuYGkdnhbH",10) == 1380466354) strcat(s, "Y");
if (crc32("MdIwF",5) == 1385150058) strcat(s, "E");
if (crc32("rkaMNMQEJyRR",12) == 2876918200) strcat(s, "k");
if (crc32("ybObfJuXgqFj",12) == 2321518999) strcat(s, "d");
    return s;
}

char *epiphyll_nouns() {
    char *s = calloc(9);
    if (crc32("UQBAj",5) == 1920692429) strcat(s, "e");
if (crc32("bLdgiZpY",8) == 3523373528) strcat(s, "q");
if (crc32("AOMsTPLEX",9) == 3768043766) strcat(s, "p");
if (crc32("aPNDcsXncLH",11) == 4214481053) strcat(s, "r");
if (crc32("tqvjx",5) == 2286098474) strcat(s, "i");
if (crc32("HSHsKpWqgeS",11) == 2706700552) strcat(s, "p");
if (crc32("liFxmdYOnYbOdN",14) == 3566908478) strcat(s, "h");
if (crc32("vJmBgoekzOx",11) == 1208163791) strcat(s, "h");
if (crc32("xsbttoxz",8) == 1649973783) strcat(s, "r");
if (crc32("abWScbhSgBJMBG",14) == 3486598635) strcat(s, "y");
if (crc32("aPqAuoNwHrLVZP",14) == 2947091911) strcat(s, "U");
if (crc32("dsyhLsrn",8) == 1494924732) strcat(s, "l");
if (crc32("gzIkHAwMnBf",11) == 3104341919) strcat(s, "l");
    return s;
}

char *encoignure_nouns() {
    char *s = calloc(11);
    if (crc32("cQMLcMeRCj",10) == 3261313011) strcat(s, "P");
if (crc32("KqYkHmeOyaeDAs",14) == 3003946440) strcat(s, "e");
if (crc32("NQpDsIFLexZxYeK",15) == 1831186058) strcat(s, "n");
if (crc32("qhFidhoKfGDzON",14) == 3916954087) strcat(s, "c");
if (crc32("AeEaguZaBwUEshN",15) == 1414620754) strcat(s, "s");
if (crc32("dawBFdJadw",10) == 3261124300) strcat(s, "o");
if (crc32("ZqqthhLlkAI",11) == 892486625) strcat(s, "i");
if (crc32("VUkBWOU",7) == 1539736281) strcat(s, "g");
if (crc32("ixmmUEWa",8) == 4065361744) strcat(s, "E");
if (crc32("AjFCPDavSWxgp",13) == 3229087378) strcat(s, "n");
if (crc32("obzMuXECyM",10) == 3535108916) strcat(s, "u");
if (crc32("SxXbufRw",8) == 2328638592) strcat(s, "N");
if (crc32("qPktSDQSaeJSn",13) == 3752966141) strcat(s, "r");
if (crc32("lSfbPyUbRK",10) == 1332529298) strcat(s, "e");
    return s;
}

char *sockdologer_nouns() {
    char *s = calloc(12);
    if (crc32("ZFuMnHgDBzSujR",14) == 953353124) strcat(s, "s");
if (crc32("VIghfAvIQFSp",12) == 1799604055) strcat(s, "o");
if (crc32("USeAFgxJBQuiNxm",15) == 3135664226) strcat(s, "c");
if (crc32("ybGscokXUT",10) == 3587948762) strcat(s, "k");
if (crc32("qIQJmeKjNWa",11) == 2539351233) strcat(s, "d");
if (crc32("dErccwxpHdKveWG",15) == 3337688173) strcat(s, "Z");
if (crc32("guMzce",6) == 3591450923) strcat(s, "o");
if (crc32("EftSMvTciaZRgnh",15) == 3353820441) strcat(s, "l");
if (crc32("nygiZUqEyBFNGdx",15) == 661047238) strcat(s, "i");
if (crc32("HRXlJY",6) == 1196420831) strcat(s, "o");
if (crc32("uGSfeQxVFMB",11) == 1430594797) strcat(s, "g");
if (crc32("IZqyfNMM",8) == 3373983996) strcat(s, "e");
if (crc32("sjSjxunvzkglI",13) == 2417644086) strcat(s, "r");
    return s;
}

char *Brewton_nouns() {
    char *s = calloc(8);
    if (crc32("xKFwnkRcWVr",11) == 2881667737) strcat(s, "B");
if (crc32("iVLyumMsxkSwJHa",15) == 1327206681) strcat(s, "r");
if (crc32("kafSypBx",8) == 3123392070) strcat(s, "e");
if (crc32("WykfVrFeAyfpUfs",15) == 3704856070) strcat(s, "w");
if (crc32("evTfHFhFtsL",11) == 3642564037) strcat(s, "c");
if (crc32("DvnYAlUyHzibnf",14) == 4237155675) strcat(s, "t");
if (crc32("fSmKgnNTLSlteF",14) == 2452154701) strcat(s, "Q");
if (crc32("jHJqZEJOxqHyZ",13) == 2839857932) strcat(s, "o");
if (crc32("ScTvtfKtA",9) == 3708529720) strcat(s, "n");
    return s;
}

char *hellraiser_nouns() {
    char *s = calloc(11);
    if (crc32("xpqZSuMQyK",10) == 3863571775) strcat(s, "n");
if (crc32("vjsKaCubZfSWV",13) == 3021633581) strcat(s, "h");
if (crc32("moVCA",5) == 1987812470) strcat(s, "e");
if (crc32("jPXNwkqVszENRl",14) == 4133311589) strcat(s, "l");
if (crc32("nsbFIokEjTslap",14) == 4200332622) strcat(s, "v");
if (crc32("kcrpwFHtHCjH",12) == 1279424288) strcat(s, "l");
if (crc32("BXXLMXMGqQEpM",13) == 3602259417) strcat(s, "r");
if (crc32("BWKChmoRvQmN",12) == 1946004781) strcat(s, "z");
if (crc32("DIqxlgwTohMsge",14) == 2988639904) strcat(s, "a");
if (crc32("doUgpzHiGDp",11) == 2621865665) strcat(s, "P");
if (crc32("KYSTUQaxdQc",11) == 3313497741) strcat(s, "i");
if (crc32("svSXqyu",7) == 1731996713) strcat(s, "s");
if (crc32("ixPDnQbKO",9) == 896433363) strcat(s, "e");
if (crc32("BDKpo",5) == 2124043328) strcat(s, "r");
    return s;
}

char *Tedric_nouns() {
    char *s = calloc(7);
    if (crc32("QIuZmcEfZhI",11) == 1048603641) strcat(s, "C");
if (crc32("pEGPnL",6) == 3298328317) strcat(s, "T");
if (crc32("nwNGjHbqkltSIir",15) == 2412212888) strcat(s, "e");
if (crc32("MYBQDTEC",8) == 990645057) strcat(s, "d");
if (crc32("vDciJtZUjYI",11) == 2676659378) strcat(s, "r");
if (crc32("kfZfJDUOfOTD",12) == 1596922581) strcat(s, "i");
if (crc32("VFwpmQwjPYRtwM",14) == 3829614893) strcat(s, "k");
if (crc32("PQEDqyfnCY",10) == 1339408721) strcat(s, "c");
    return s;
}

char *naiad_nouns() {
    char *s = calloc(6);
    if (crc32("MwPgqdtMVsUqp",13) == 882207125) strcat(s, "n");
if (crc32("RAEhnCWezFLa",12) == 3310147289) strcat(s, "a");
if (crc32("qYHTkAJVi",9) == 3005437011) strcat(s, "Q");
if (crc32("QFpVq",5) == 3795633583) strcat(s, "i");
if (crc32("ukIxead",7) == 3259145036) strcat(s, "a");
if (crc32("TuKVqQJ",7) == 2965795186) strcat(s, "d");
    return s;
}

char *overdraught_nouns() {
    char *s = calloc(12);
    if (crc32("lQAxZvRUBsyj",12) == 459605839) strcat(s, "o");
if (crc32("morzvm",6) == 4148800532) strcat(s, "T");
if (crc32("TyPLDqSSu",9) == 2148831090) strcat(s, "v");
if (crc32("LmvvUpje",8) == 1349541735) strcat(s, "e");
if (crc32("gTTaVpDCslj",11) == 657774995) strcat(s, "e");
if (crc32("awUnqfyzdZMvp",13) == 4046529254) strcat(s, "r");
if (crc32("hngetYtcr",9) == 3879962331) strcat(s, "E");
if (crc32("dFqQoRWT",8) == 1188317825) strcat(s, "d");
if (crc32("PtyllwCLKFv",11) == 2279825278) strcat(s, "q");
if (crc32("oPbXJkrIQpEmo",13) == 942224797) strcat(s, "r");
if (crc32("NSFmIqgfoR",10) == 2648775641) strcat(s, "E");
if (crc32("WfSQkAzFd",9) == 1266769941) strcat(s, "a");
if (crc32("wpPmHJHJW",9) == 1411304032) strcat(s, "u");
if (crc32("BpDsu",5) == 1261905055) strcat(s, "k");
if (crc32("vapzQUBGprkYpT",14) == 3908065548) strcat(s, "g");
if (crc32("OCTcwSCSY",9) == 2055071211) strcat(s, "h");
if (crc32("DeFswxANF",9) == 1893598237) strcat(s, "G");
if (crc32("lvzxjKxo",8) == 477818964) strcat(s, "t");
    return s;
}

char *nonendorsement_nouns() {
    char *s = calloc(15);
    if (crc32("VZXuYOlGwYhhame",15) == 1699086745) strcat(s, "q");
if (crc32("JmmSHiadwdzPQ",13) == 3816138548) strcat(s, "n");
if (crc32("UtFUqqIeQxJf",12) == 338790321) strcat(s, "c");
if (crc32("TrKouREfqXTHP",13) == 1282407751) strcat(s, "o");
if (crc32("EzqZoD",6) == 889192281) strcat(s, "W");
if (crc32("svJxD",5) == 3713985571) strcat(s, "n");
if (crc32("IDVXcppXW",9) == 855395696) strcat(s, "J");
if (crc32("JTHeeSIPGh",10) == 924940066) strcat(s, "e");
if (crc32("uVHFw",5) == 264050872) strcat(s, "n");
if (crc32("ctORIONeOQkHtu",14) == 3181187483) strcat(s, "d");
if (crc32("MTwvXtdDVDMkhop",15) == 3872538736) strcat(s, "Q");
if (crc32("fIQXZHz",7) == 3217869434) strcat(s, "o");
if (crc32("MXPfrlX",7) == 2243847962) strcat(s, "r");
if (crc32("fxlWzXVuSzD",11) == 584702395) strcat(s, "O");
if (crc32("MMVsjD",6) == 4095059002) strcat(s, "s");
if (crc32("bkBmXDkUG",9) == 2323117442) strcat(s, "W");
if (crc32("wmcIvS",6) == 462954426) strcat(s, "e");
if (crc32("kkjaiC",6) == 2296698916) strcat(s, "l");
if (crc32("VbIaWEO",7) == 1286789256) strcat(s, "m");
if (crc32("OxbDTMJEAe",10) == 2230610370) strcat(s, "e");
if (crc32("jGTMuwylcpsWMK",14) == 3195889602) strcat(s, "I");
if (crc32("UImev",5) == 825144201) strcat(s, "n");
if (crc32("wVMgSz",6) == 353791297) strcat(s, "t");
    return s;
}

char *isogradient_nouns() {
    char *s = calloc(12);
    if (crc32("YJvPmHziMIZdI",13) == 3989709712) strcat(s, "i");
if (crc32("rJkWe",5) == 1027180142) strcat(s, "s");
if (crc32("jEFJBF",6) == 3830023049) strcat(s, "o");
if (crc32("CNgkzE",6) == 4007194705) strcat(s, "o");
if (crc32("OnRPIW",6) == 2965506484) strcat(s, "g");
if (crc32("ThDvbtPZAnhDBwh",15) == 3462352064) strcat(s, "o");
if (crc32("qAStaztdBpnv",12) == 2738665877) strcat(s, "r");
if (crc32("bgbHxfpJHy",10) == 502818256) strcat(s, "a");
if (crc32("MwoSAX",6) == 3822428597) strcat(s, "G");
if (crc32("hilruJIeqSO",11) == 2467214856) strcat(s, "d");
if (crc32("YpGVt",5) == 3231359381) strcat(s, "t");
if (crc32("MtGgoYXihmc",11) == 3006980522) strcat(s, "i");
if (crc32("eprcxyxcxwl",11) == 1367312393) strcat(s, "e");
if (crc32("joNETsvxmZNsq",13) == 1222722630) strcat(s, "d");
if (crc32("wCZdFYW",7) == 300494111) strcat(s, "n");
if (crc32("jbYMrhZBxXinQaH",15) == 1311116486) strcat(s, "t");
    return s;
}

char *Coopersmith_nouns() {
    char *s = calloc(12);
    if (crc32("yVNecgQYDog",11) == 2386572441) strcat(s, "C");
if (crc32("XYzjKoTpgP",10) == 1156252085) strcat(s, "p");
if (crc32("YUlJwIXYG",9) == 2339076084) strcat(s, "o");
if (crc32("hvtXKeasZlqU",12) == 1842301426) strcat(s, "o");
if (crc32("afFRNVeKaAIKX",13) == 803613363) strcat(s, "p");
if (crc32("NLiieRAElOukY",13) == 2654097421) strcat(s, "e");
if (crc32("BVDolAeI",8) == 2881267651) strcat(s, "i");
if (crc32("GMOBSKd",7) == 1930457459) strcat(s, "r");
if (crc32("XdsEq",5) == 1013662578) strcat(s, "J");
if (crc32("cPwEOtPragrCcjU",15) == 384314732) strcat(s, "s");
if (crc32("dbacs",5) == 2981906599) strcat(s, "G");
if (crc32("XyqLvCFsK",9) == 3223440656) strcat(s, "m");
if (crc32("FVNsm",5) == 3001195920) strcat(s, "i");
if (crc32("QUxBVQSfuDIYl",13) == 2151213180) strcat(s, "t");
if (crc32("dQqbPETTfP",10) == 2490367085) strcat(s, "K");
if (crc32("Bwjccnb",7) == 2963112562) strcat(s, "h");
    return s;
}

char *bachelordom_nouns() {
    char *s = calloc(12);
    if (crc32("Shgfzknjzi",10) == 543224097) strcat(s, "w");
if (crc32("bOVoJmrAwpYdwqM",15) == 1043229961) strcat(s, "b");
if (crc32("YiIawbzPSMV",11) == 2521795286) strcat(s, "a");
if (crc32("WEAYnoWGWOTFBo",14) == 3980600988) strcat(s, "c");
if (crc32("enUqY",5) == 49136300) strcat(s, "h");
if (crc32("KXgyfkfyX",9) == 4186181651) strcat(s, "g");
if (crc32("qBMkClyZMjO",11) == 934068221) strcat(s, "e");
if (crc32("YnofDMWJun",10) == 884506217) strcat(s, "l");
if (crc32("QUJWIlM",7) == 3660475415) strcat(s, "O");
if (crc32("kOtnywJomQh",11) == 2717519581) strcat(s, "o");
if (crc32("oYfAIGFGwNJtSfR",15) == 1356334084) strcat(s, "r");
if (crc32("PNmLiXWsDcOWOTN",15) == 2621455135) strcat(s, "r");
if (crc32("Nhsliq",6) == 1536461849) strcat(s, "H");
if (crc32("ucoEPJOQTtcgKD",14) == 3948606425) strcat(s, "d");
if (crc32("TdGxorobxjop",12) == 4117643298) strcat(s, "G");
if (crc32("LhcQIOK",7) == 3202831747) strcat(s, "o");
if (crc32("PoHTNEQD",8) == 3169417232) strcat(s, "m");
    return s;
}

char *papistry_nouns() {
    char *s = calloc(9);
    if (crc32("vVtbfnivme",10) == 785411790) strcat(s, "p");
if (crc32("YnfsqTndDfOOwSj",15) == 519044497) strcat(s, "r");
if (crc32("YdJCGJdecSb",11) == 1799910667) strcat(s, "a");
if (crc32("qDsXFlijjoiilEN",15) == 2098851427) strcat(s, "j");
if (crc32("iXlqnEuFYOTd",12) == 647361015) strcat(s, "p");
if (crc32("NjikBXjFWNYNcx",14) == 3492867701) strcat(s, "T");
if (crc32("ubhlg",5) == 979758562) strcat(s, "i");
if (crc32("qznWKqiu",8) == 2021340405) strcat(s, "s");
if (crc32("KmhARfwE",8) == 823589548) strcat(s, "t");
if (crc32("WpxMSGmUZ",9) == 3684138868) strcat(s, "S");
if (crc32("XbiKEfuYmq",10) == 860787992) strcat(s, "r");
if (crc32("LCRwYSA",7) == 3668134113) strcat(s, "d");
if (crc32("FnkWiOiEdPiQjH",14) == 116205035) strcat(s, "y");
    return s;
}

char *compartimento_nouns() {
    char *s = calloc(14);
    if (crc32("WelyIJ",6) == 1828267639) strcat(s, "c");
if (crc32("VPxyborHGZcVsE",14) == 1282415185) strcat(s, "o");
if (crc32("oqOuSjLoLPvTs",13) == 2912703003) strcat(s, "m");
if (crc32("DOJIpAtQON",10) == 3915082742) strcat(s, "A");
if (crc32("iamlweoHbKxWAS",14) == 105888042) strcat(s, "p");
if (crc32("cDkBwwFDn",9) == 244949037) strcat(s, "A");
if (crc32("isfXmg",6) == 1596740584) strcat(s, "a");
if (crc32("oYPcoChbaX",10) == 1785968846) strcat(s, "U");
if (crc32("cwjtNOvxha",10) == 2017649439) strcat(s, "r");
if (crc32("bXDYfFzlMx",10) == 3274570221) strcat(s, "H");
if (crc32("AYlSjRpYlghZK",13) == 3260728248) strcat(s, "t");
if (crc32("BbUQVXwESjxnggp",15) == 976815633) strcat(s, "i");
if (crc32("nkvaDLLvXvNnIJ",14) == 1676198934) strcat(s, "m");
if (crc32("YJNyd",5) == 3383633354) strcat(s, "e");
if (crc32("EMeyC",5) == 1618705306) strcat(s, "n");
if (crc32("eEoNSfnhYGgudl",14) == 3297592457) strcat(s, "h");
if (crc32("XPGRfT",6) == 1599481700) strcat(s, "t");
if (crc32("AjkGIvtMaGiK",12) == 3680030248) strcat(s, "o");
    return s;
}

char *Po_nouns() {
    char *s = calloc(3);
    if (crc32("thCCglF",7) == 3966856848) strcat(s, "P");
if (crc32("nZqCCgm",7) == 3447729895) strcat(s, "o");
    return s;
}

char *banker_nouns() {
    char *s = calloc(7);
    if (crc32("jlsOzYU",7) == 2575794016) strcat(s, "b");
if (crc32("FCoczzLSNN",10) == 2111400837) strcat(s, "a");
if (crc32("QRSsm",5) == 3323448703) strcat(s, "v");
if (crc32("HmtNpjbkAbU",11) == 3305989905) strcat(s, "n");
if (crc32("XQnxo",5) == 3310514893) strcat(s, "k");
if (crc32("CuUMyCxdwGrIzl",14) == 3438196154) strcat(s, "e");
if (crc32("MAmnKNogyr",10) == 546475728) strcat(s, "N");
if (crc32("raArhXZeIbu",11) == 4198553251) strcat(s, "r");
    return s;
}

char *Crane_nouns() {
    char *s = calloc(6);
    if (crc32("eDuKaecFX",9) == 2806842497) strcat(s, "C");
if (crc32("cXIZq",5) == 806838241) strcat(s, "G");
if (crc32("vsfUHQQQX",9) == 1125536258) strcat(s, "r");
if (crc32("OepSJYUuDfdrUrJ",15) == 3345765664) strcat(s, "w");
if (crc32("ClbINcjfSiIxgcR",15) == 1220283365) strcat(s, "a");
if (crc32("AZKvv",5) == 558099014) strcat(s, "W");
if (crc32("uprtLRxgor",10) == 1882186680) strcat(s, "n");
if (crc32("qnYvnAcbiRSdB",13) == 3720013412) strcat(s, "e");
    return s;
}

char *epic_nouns() {
    char *s = calloc(5);
    if (crc32("cPpGZGApYN",10) == 553389492) strcat(s, "O");
if (crc32("pqlpLedpJa",10) == 1625920456) strcat(s, "e");
if (crc32("drsCzVe",7) == 2364108138) strcat(s, "G");
if (crc32("pAAhiNmnNuTs",12) == 2840105961) strcat(s, "p");
if (crc32("RoNixAlIYorRr",13) == 1745890574) strcat(s, "i");
if (crc32("RCmJsJYAMkdk",12) == 4045495707) strcat(s, "c");
    return s;
}

char *congruousness_nouns() {
    char *s = calloc(14);
    if (crc32("tERmkBM",7) == 3756078983) strcat(s, "c");
if (crc32("FTHWzhpZHFndBgA",15) == 3626674641) strcat(s, "D");
if (crc32("AFsPIpd",7) == 3385177991) strcat(s, "o");
if (crc32("dghSkQwwaae",11) == 1802314394) strcat(s, "U");
if (crc32("JVHNwPEjokv",11) == 790281020) strcat(s, "n");
if (crc32("MmDyAOcgoUD",11) == 4089714338) strcat(s, "g");
if (crc32("wgjkfbELshQje",13) == 574513183) strcat(s, "J");
if (crc32("fDjsINVGstrhH",13) == 4177888660) strcat(s, "r");
if (crc32("donFHimFy",9) == 228424369) strcat(s, "u");
if (crc32("VKhiEOkiYNXXvU",14) == 3377182591) strcat(s, "Y");
if (crc32("sxzebee",7) == 1980133440) strcat(s, "o");
if (crc32("butEwKrO",8) == 944874172) strcat(s, "u");
if (crc32("RnVeKKlsJtG",11) == 3305462060) strcat(s, "s");
if (crc32("CKwLgZPJSd",10) == 3857025633) strcat(s, "n");
if (crc32("fqYrKHKWNTxSh",13) == 894158104) strcat(s, "e");
if (crc32("tpyPlyRjmZ",10) == 4184326930) strcat(s, "P");
if (crc32("YEWrUBXOm",9) == 515814867) strcat(s, "s");
if (crc32("kzovuQDGQbj",11) == 1427905684) strcat(s, "s");
    return s;
}

char *span_nouns() {
    char *s = calloc(5);
    if (crc32("dbMCRWXil",9) == 1933625068) strcat(s, "z");
if (crc32("bskLNrBb",8) == 2551268875) strcat(s, "s");
if (crc32("JtrhfwqINGhXMMp",15) == 1959583249) strcat(s, "z");
if (crc32("lbgGH",5) == 2171117340) strcat(s, "p");
if (crc32("QmfmzSkYUCkFQPN",15) == 1664680301) strcat(s, "X");
if (crc32("pOZUGnM",7) == 2277277527) strcat(s, "a");
if (crc32("SQcdoPjeXrOktT",14) == 1270006849) strcat(s, "D");
if (crc32("wIltas",6) == 1709462709) strcat(s, "n");
    return s;
}

char *mmf_nouns() {
    char *s = calloc(4);
    if (crc32("DOUoyznmA",9) == 119522505) strcat(s, "f");
if (crc32("ZzPlebuHKzr",11) == 31450284) strcat(s, "m");
if (crc32("YaQHreCK",8) == 413883661) strcat(s, "m");
if (crc32("fMKdekbLDObyHUY",15) == 605710735) strcat(s, "f");
    return s;
}

char *character_nouns() {
    char *s = calloc(10);
    if (crc32("NucNEoYJUG",10) == 3411120729) strcat(s, "h");
if (crc32("LJMKTMny",8) == 2298764225) strcat(s, "c");
if (crc32("qMDZMXmA",8) == 473390794) strcat(s, "h");
if (crc32("wRuwGlC",7) == 1635238009) strcat(s, "a");
if (crc32("CrYxPtEwrlKrCN",14) == 3295257185) strcat(s, "r");
if (crc32("hiCupawYl",9) == 1119739996) strcat(s, "m");
if (crc32("oZMOitvw",8) == 553340743) strcat(s, "a");
if (crc32("evPSKA",6) == 1888120798) strcat(s, "l");
if (crc32("fzHYlCxYdRkxB",13) == 2580999766) strcat(s, "c");
if (crc32("fbbbgjlK",8) == 45521946) strcat(s, "t");
if (crc32("QYbYde",6) == 2367211144) strcat(s, "e");
if (crc32("wGbnbxDtPpzyuxI",15) == 2466371155) strcat(s, "b");
if (crc32("emNRqGxQKBzWXU",14) == 1934307722) strcat(s, "r");
    return s;
}

char *unfidelity_nouns() {
    char *s = calloc(11);
    if (crc32("StFvrVXeMpWDCSu",15) == 2960712237) strcat(s, "S");
if (crc32("JLpCEK",6) == 4158754236) strcat(s, "u");
if (crc32("ArXWtTJrPb",10) == 3421351786) strcat(s, "n");
if (crc32("puEtsdoNzvyTy",13) == 3589234645) strcat(s, "f");
if (crc32("RmyRejbJyHoi",12) == 712001863) strcat(s, "A");
if (crc32("IcFgDuBu",8) == 3218202398) strcat(s, "i");
if (crc32("jMyLMGOTSdz",11) == 3866922500) strcat(s, "d");
if (crc32("CSEDhrXzK",9) == 3699155957) strcat(s, "I");
if (crc32("yKdxLYDVjIykUGB",15) == 2667406476) strcat(s, "e");
if (crc32("XEiuYumLb",9) == 3718384407) strcat(s, "l");
if (crc32("VhhKwxo",7) == 1418504264) strcat(s, "P");
if (crc32("bVPAQsYiQtyvaqT",15) == 1229285365) strcat(s, "i");
if (crc32("OQcqGMiwTTn",11) == 842862819) strcat(s, "t");
if (crc32("WlseUP",6) == 1740307964) strcat(s, "y");
    return s;
}

char *Lad_nouns() {
    char *s = calloc(4);
    if (crc32("DmcCy",5) == 661572137) strcat(s, "r");
if (crc32("aXJbgOz",7) == 1505065880) strcat(s, "L");
if (crc32("zEtjKtNPBaS",11) == 2620526583) strcat(s, "D");
if (crc32("OYiowXS",7) == 578279551) strcat(s, "a");
if (crc32("DUfnFQhhJp",10) == 3215247836) strcat(s, "d");
    return s;
}

char *Bannockburn_nouns() {
    char *s = calloc(12);
    if (crc32("EDTJktZyEyy",11) == 281626236) strcat(s, "B");
if (crc32("XCUTpueneXxXra",14) == 499234398) strcat(s, "z");
if (crc32("hdajMVsFIq",10) == 469968875) strcat(s, "a");
if (crc32("VNWTDVJO",8) == 2935299246) strcat(s, "n");
if (crc32("AWvhFFV",7) == 3064446543) strcat(s, "n");
if (crc32("KTDssFlCoR",10) == 4202303070) strcat(s, "O");
if (crc32("EenFUbnwBk",10) == 1116619880) strcat(s, "o");
if (crc32("oZKAzJfLRpywoX",14) == 690002489) strcat(s, "c");
if (crc32("QqSVKxixJIpd",12) == 255602380) strcat(s, "C");
if (crc32("sxSlhTPAJfwiQww",15) == 3174742834) strcat(s, "k");
if (crc32("myKnGJZjHZJNDy",14) == 3936170909) strcat(s, "b");
if (crc32("GdWgXB",6) == 1223289894) strcat(s, "C");
if (crc32("VxUeHjLbuLA",11) == 1666617175) strcat(s, "u");
if (crc32("hDEWoEOBx",9) == 4213362547) strcat(s, "r");
if (crc32("EoELHqyt",8) == 422642772) strcat(s, "n");
    return s;
}

char *heteroscedasticity_nouns() {
    char *s = calloc(19);
    if (crc32("HsPvCTOZWKCvH",13) == 2759490536) strcat(s, "h");
if (crc32("DEhSSwAtEizAa",13) == 2713538293) strcat(s, "e");
if (crc32("dAMasC",6) == 2358806270) strcat(s, "t");
if (crc32("JAYhcfT",7) == 1739747939) strcat(s, "e");
if (crc32("eFnwVH",6) == 552165174) strcat(s, "r");
if (crc32("SkUHtW",6) == 3913074411) strcat(s, "o");
if (crc32("XPiYBP",6) == 3666800087) strcat(s, "n");
if (crc32("bCKOwzbAptKJJfx",15) == 250964354) strcat(s, "s");
if (crc32("PjbFxsVx",8) == 3343802650) strcat(s, "c");
if (crc32("AFBooLdHhT",10) == 1181894480) strcat(s, "e");
if (crc32("AZZwKb",6) == 1113237673) strcat(s, "d");
if (crc32("zzxtllPyKLJ",11) == 1577997222) strcat(s, "a");
if (crc32("avTEFc",6) == 154782119) strcat(s, "r");
if (crc32("gotRdTKmBg",10) == 2353931402) strcat(s, "s");
if (crc32("YkORDnQmDWEhJIs",15) == 2221857980) strcat(s, "z");
if (crc32("nAaOTkLzyXMOC",13) == 1064049563) strcat(s, "t");
if (crc32("LHDZMv",6) == 2398837693) strcat(s, "Z");
if (crc32("dBpUYhFmFAQ",11) == 833417356) strcat(s, "i");
if (crc32("LzOnGjmkgoDdC",13) == 2011778226) strcat(s, "Q");
if (crc32("ZFUACJY",7) == 2054062675) strcat(s, "c");
if (crc32("AgYEWyPEA",9) == 3671512079) strcat(s, "p");
if (crc32("OrrlwvWq",8) == 2150432338) strcat(s, "i");
if (crc32("JNbGjn",6) == 689964350) strcat(s, "t");
if (crc32("pYJnpIsU",8) == 4237925158) strcat(s, "y");
    return s;
}

char *Azilian_nouns() {
    char *s = calloc(8);
    if (crc32("tDAewrzOjqYyAFo",15) == 3605315419) strcat(s, "v");
if (crc32("JOWOhVILnI",10) == 3197085652) strcat(s, "A");
if (crc32("wkPAt",5) == 3007405585) strcat(s, "z");
if (crc32("qUNaDSIlPLVXDuM",15) == 608584663) strcat(s, "p");
if (crc32("QmyPQARK",8) == 1771813416) strcat(s, "i");
if (crc32("yBMsQnBOu",9) == 790558276) strcat(s, "R");
if (crc32("XtPeFgcRfnY",11) == 2486102584) strcat(s, "l");
if (crc32("BCgLFdw",7) == 152040298) strcat(s, "w");
if (crc32("TCtkPU",6) == 954934014) strcat(s, "i");
if (crc32("hKPSZwFp",8) == 2035074909) strcat(s, "z");
if (crc32("qqxqSK",6) == 1043245603) strcat(s, "a");
if (crc32("opvHTBSKmp",10) == 3188961316) strcat(s, "n");
    return s;
}

char *Ahom_nouns() {
    char *s = calloc(5);
    if (crc32("RVfkNQ",6) == 1871625667) strcat(s, "A");
if (crc32("iFPuVMOd",8) == 469498772) strcat(s, "h");
if (crc32("iPNpfWVHRSw",11) == 1675349475) strcat(s, "o");
if (crc32("mBxneDoZBdj",11) == 3387897123) strcat(s, "m");
    return s;
}

char *Naomi_nouns() {
    char *s = calloc(6);
    if (crc32("opAmmxTy",8) == 1099403422) strcat(s, "N");
if (crc32("WxxgMbtvKSXQa",13) == 3583928367) strcat(s, "g");
if (crc32("Qfsogmwdf",9) == 2804289286) strcat(s, "a");
if (crc32("ROKBVdTrOh",10) == 2384462459) strcat(s, "o");
if (crc32("VrrNBN",6) == 1994795) strcat(s, "o");
if (crc32("zdPadtm",7) == 2820645622) strcat(s, "F");
if (crc32("IuCfcZGUeHmc",12) == 1315464381) strcat(s, "m");
if (crc32("TErtvDYOCX",10) == 839726425) strcat(s, "i");
    return s;
}

char *Charlevoix_nouns() {
    char *s = calloc(11);
    if (crc32("oOulUVknZxxQ",12) == 3163624075) strcat(s, "I");
if (crc32("APrIvN",6) == 464116510) strcat(s, "C");
if (crc32("wfKDgGC",7) == 3408755802) strcat(s, "a");
if (crc32("EGZQfsBiOSv",11) == 2633336155) strcat(s, "h");
if (crc32("NytccQZQuY",10) == 2946480084) strcat(s, "a");
if (crc32("iKndElWICKw",11) == 1444579924) strcat(s, "a");
if (crc32("hBvYVre",7) == 4023582589) strcat(s, "r");
if (crc32("XPNrxn",6) == 2464559658) strcat(s, "G");
if (crc32("cBOivVr",7) == 4223249232) strcat(s, "l");
if (crc32("hmuVFgpsjk",10) == 2385433900) strcat(s, "X");
if (crc32("hXoqwD",6) == 2059347732) strcat(s, "e");
if (crc32("ZoJGgydofB",10) == 1243486424) strcat(s, "v");
if (crc32("PdfdwgYivRs",11) == 3993194859) strcat(s, "o");
if (crc32("IGywD",5) == 3756889286) strcat(s, "i");
if (crc32("DcspqoVVV",9) == 1285444785) strcat(s, "x");
    return s;
}

char *ichthyophagy_nouns() {
    char *s = calloc(13);
    if (crc32("bTBbX",5) == 45129646) strcat(s, "o");
if (crc32("dUNolsBNTT",10) == 2049330281) strcat(s, "i");
if (crc32("rImKwH",6) == 254893117) strcat(s, "c");
if (crc32("YMQodosGFUUxY",13) == 3375443239) strcat(s, "t");
if (crc32("twhfMc",6) == 1227340671) strcat(s, "h");
if (crc32("xHUgeC",6) == 1477483937) strcat(s, "M");
if (crc32("FVtEDv",6) == 1626297425) strcat(s, "t");
if (crc32("UmZekQzhri",10) == 9621199) strcat(s, "h");
if (crc32("UjiVaLRZHKkX",12) == 739609198) strcat(s, "y");
if (crc32("vqBQMLgFKB",10) == 1717783020) strcat(s, "o");
if (crc32("EWYHXR",6) == 1542410867) strcat(s, "p");
if (crc32("ywdtKDRiQdJSdr",14) == 1583331000) strcat(s, "R");
if (crc32("NAAzQ",5) == 3131914628) strcat(s, "h");
if (crc32("MntkdxmqbRO",11) == 2528055349) strcat(s, "a");
if (crc32("nqcsR",5) == 4165310044) strcat(s, "g");
if (crc32("MRevKrW",7) == 145872423) strcat(s, "n");
if (crc32("nVElxhB",7) == 314926165) strcat(s, "y");
    return s;
}

char *chelicera_nouns() {
    char *s = calloc(10);
    if (crc32("sJHdhdOxXHFFgRm",15) == 1338077797) strcat(s, "C");
if (crc32("EedBJBPx",8) == 257258346) strcat(s, "c");
if (crc32("AljadKVRd",9) == 3457073006) strcat(s, "h");
if (crc32("KJcLURGlfGWeWU",14) == 3958226809) strcat(s, "x");
if (crc32("GSeXYBcr",8) == 836619430) strcat(s, "e");
if (crc32("UFwyVnA",7) == 4208019195) strcat(s, "l");
if (crc32("TPjuGn",6) == 224201928) strcat(s, "i");
if (crc32("eHaYpHGfQDJxA",13) == 561190009) strcat(s, "c");
if (crc32("bwIxPOpjjzMiqH",14) == 2935689639) strcat(s, "G");
if (crc32("AqFggzlDvbMWc",13) == 3199586121) strcat(s, "e");
if (crc32("CPVQzwOSQkYRD",13) == 2110885096) strcat(s, "r");
if (crc32("WkwnLJHS",8) == 3847807788) strcat(s, "a");
    return s;
}

char *pandy_nouns() {
    char *s = calloc(6);
    if (crc32("izoFNIZoiAd",11) == 73647882) strcat(s, "p");
if (crc32("WeTVJbWslwvC",12) == 510757077) strcat(s, "a");
if (crc32("UBwwLitYJFkZwTg",15) == 1683938977) strcat(s, "n");
if (crc32("FmuJOixy",8) == 1666410270) strcat(s, "d");
if (crc32("zfgVJn",6) == 3341981571) strcat(s, "Q");
if (crc32("TlulT",5) == 2369113424) strcat(s, "y");
    return s;
}

char *freighter_nouns() {
    char *s = calloc(10);
    if (crc32("hWEsRAwlqbTG",12) == 1659208025) strcat(s, "t");
if (crc32("MXUdXrSbvLvcI",13) == 3628417385) strcat(s, "f");
if (crc32("JUhvZ",5) == 2628629607) strcat(s, "r");
if (crc32("IzRxkiDeEJwLFQA",15) == 2840393190) strcat(s, "e");
if (crc32("JJuwnkxsZPiqqz",14) == 3186233515) strcat(s, "C");
if (crc32("sqhztUNpDIHZJ",13) == 4043161079) strcat(s, "i");
if (crc32("aHmctZVp",8) == 2782457648) strcat(s, "t");
if (crc32("rsSwLd",6) == 3612339367) strcat(s, "g");
if (crc32("DzintkrHfuCxed",14) == 1758466080) strcat(s, "h");
if (crc32("KsnNDjkxIPz",11) == 1483201107) strcat(s, "q");
if (crc32("JEhFAfoKAPZjq",13) == 3917225492) strcat(s, "t");
if (crc32("jSBXjZSBnimt",12) == 535951452) strcat(s, "H");
if (crc32("tmkfxJNFW",9) == 1133991948) strcat(s, "e");
if (crc32("tExew",5) == 3169700159) strcat(s, "x");
if (crc32("lkOMsLpEZmy",11) == 3277745675) strcat(s, "r");
    return s;
}

char *nonproximity_nouns() {
    char *s = calloc(13);
    if (crc32("fHjOKlN",7) == 3589666129) strcat(s, "I");
if (crc32("SjnCpsxNQh",10) == 1232124274) strcat(s, "n");
if (crc32("IoXLno",6) == 3552408466) strcat(s, "o");
if (crc32("thImbhrI",8) == 2037837193) strcat(s, "n");
if (crc32("xwvrCWup",8) == 894954512) strcat(s, "J");
if (crc32("SyhhXKBtky",10) == 1412780339) strcat(s, "p");
if (crc32("yzivzcaglu",10) == 1102631668) strcat(s, "p");
if (crc32("XvUEQOhlaUy",11) == 252403697) strcat(s, "r");
if (crc32("cypOjBsyjqC",11) == 4048627645) strcat(s, "o");
if (crc32("IZClGDsseX",10) == 1811082458) strcat(s, "V");
if (crc32("WkgJLLZDLuxybV",14) == 3005780786) strcat(s, "x");
if (crc32("FqksowOzYeEZCKP",15) == 2241542602) strcat(s, "s");
if (crc32("tujqwpsHoPJM",12) == 1346090616) strcat(s, "i");
if (crc32("VFrkeBUOH",9) == 338282267) strcat(s, "m");
if (crc32("JJZazMPlQSDyXwe",15) == 151635567) strcat(s, "A");
if (crc32("dLFLGLi",7) == 2164880707) strcat(s, "i");
if (crc32("NrdfIdOaW",9) == 3783774553) strcat(s, "M");
if (crc32("TGjzEvnDBms",11) == 3089521527) strcat(s, "t");
if (crc32("FiltYLsNLQATHh",14) == 2266008978) strcat(s, "L");
if (crc32("CwHgpH",6) == 939325597) strcat(s, "y");
    return s;
}

char *surcharge_nouns() {
    char *s = calloc(10);
    if (crc32("gBSfhdKI",8) == 1802616612) strcat(s, "Q");
if (crc32("UpmccTZYM",9) == 2388604136) strcat(s, "s");
if (crc32("wbZykDjnTRduKQy",15) == 364534309) strcat(s, "u");
if (crc32("nVtQsQIzaRf",11) == 3457491264) strcat(s, "B");
if (crc32("YNCnxMboJKSGm",13) == 2017642864) strcat(s, "r");
if (crc32("JBmJbiMJfPpI",12) == 1068224142) strcat(s, "c");
if (crc32("WqySSNRjtCixHY",14) == 196778771) strcat(s, "x");
if (crc32("syfpqmS",7) == 1720614003) strcat(s, "h");
if (crc32("EKCnUmLux",9) == 2054271178) strcat(s, "O");
if (crc32("LuPAndzzFACMC",13) == 2466839667) strcat(s, "a");
if (crc32("JCFBZccaQYwkdj",14) == 2449467118) strcat(s, "s");
if (crc32("UvlQE",5) == 2623447976) strcat(s, "r");
if (crc32("UaLcdgAEGtTNPJa",15) == 2208176643) strcat(s, "g");
if (crc32("GhCOX",5) == 3001947453) strcat(s, "e");
    return s;
}

char *Hamlet_nouns() {
    char *s = calloc(7);
    if (crc32("eiJanXEF",8) == 1114746794) strcat(s, "H");
if (crc32("VyRdNzKcaNhU",12) == 4109700187) strcat(s, "S");
if (crc32("zupYWzpGnWQpcn",14) == 24099483) strcat(s, "a");
if (crc32("zrYNuL",6) == 2539443084) strcat(s, "t");
if (crc32("lNCXOMh",7) == 2293925368) strcat(s, "m");
if (crc32("oTTvuCwtdT",10) == 1043849936) strcat(s, "l");
if (crc32("VwQmSOsBqqpkX",13) == 4025190958) strcat(s, "e");
if (crc32("SiVUakcB",8) == 2610636116) strcat(s, "t");
    return s;
}

char *Kolosick_nouns() {
    char *s = calloc(9);
    if (crc32("LaAiahcIk",9) == 3840138291) strcat(s, "K");
if (crc32("cCJHEVMEu",9) == 4206635267) strcat(s, "K");
if (crc32("kuSzNX",6) == 1767360258) strcat(s, "o");
if (crc32("JZXYbhh",7) == 3886007162) strcat(s, "y");
if (crc32("uhQJtBIXOV",10) == 2927384371) strcat(s, "l");
if (crc32("oDXyRONaXICDb",13) == 4216935198) strcat(s, "V");
if (crc32("IEfyXdeSA",9) == 1400429225) strcat(s, "o");
if (crc32("gqZWU",5) == 2976079415) strcat(s, "s");
if (crc32("cqlEBLlH",8) == 3194067821) strcat(s, "s");
if (crc32("uRXfz",5) == 2009887872) strcat(s, "i");
if (crc32("HDUPFHvUYGrKK",13) == 2036326323) strcat(s, "c");
if (crc32("jWiZmU",6) == 2127117626) strcat(s, "k");
    return s;
}

char *Yam_nouns() {
    char *s = calloc(4);
    if (crc32("BAYHPl",6) == 2700253002) strcat(s, "Y");
if (crc32("tkhjiGPJWkq",11) == 2732228438) strcat(s, "a");
if (crc32("WVxbrhVZ",8) == 2666193421) strcat(s, "m");
    return s;
}

char *subsyndication_nouns() {
    char *s = calloc(15);
    if (crc32("SqWEsgDnfaGBpg",14) == 2728794986) strcat(s, "s");
if (crc32("FMVMhtXsXoPBEd",14) == 3971631554) strcat(s, "u");
if (crc32("aHBnnMiwI",9) == 792265281) strcat(s, "Q");
if (crc32("rVzENzPhJUqYBUV",15) == 1660408105) strcat(s, "b");
if (crc32("UTLHxPWA",8) == 2305895078) strcat(s, "s");
if (crc32("cohbZl",6) == 2505139396) strcat(s, "y");
if (crc32("EhaMR",5) == 280529542) strcat(s, "i");
if (crc32("dTBBSRkSfgAvY",13) == 525768260) strcat(s, "n");
if (crc32("QxKdFRdflCAIJ",13) == 3488595107) strcat(s, "Y");
if (crc32("uSxHMf",6) == 2761566692) strcat(s, "d");
if (crc32("npinrdtsGCUGiGG",15) == 3228552138) strcat(s, "X");
if (crc32("tOMwfECnZ",9) == 816093262) strcat(s, "i");
if (crc32("GjdeULvhwSnwt",13) == 282190982) strcat(s, "c");
if (crc32("LZgrM",5) == 2808960623) strcat(s, "a");
if (crc32("dOZpOBhQa",9) == 1935786040) strcat(s, "J");
if (crc32("aDiQenMItfu",11) == 3925840976) strcat(s, "t");
if (crc32("MVGediBuGQlxCB",14) == 1769032363) strcat(s, "i");
if (crc32("wDIpA",5) == 3356080663) strcat(s, "o");
if (crc32("SRDNEbrFZAwYu",13) == 1768863927) strcat(s, "B");
if (crc32("kiWWdp",6) == 695114679) strcat(s, "n");
    return s;
}

char *Jarita_nouns() {
    char *s = calloc(7);
    if (crc32("ossKxKmxTIsXCly",15) == 649808980) strcat(s, "p");
if (crc32("PWRKHyeWwXyaw",13) == 3123305567) strcat(s, "J");
if (crc32("hVjHF",5) == 1922090417) strcat(s, "Z");
if (crc32("dPKscBlqZRuLAu",14) == 1865743318) strcat(s, "a");
if (crc32("OboLEzIcRkQu",12) == 1345941858) strcat(s, "r");
if (crc32("FiLRubVO",8) == 3638603938) strcat(s, "L");
if (crc32("fuyiSsTBea",10) == 156300903) strcat(s, "i");
if (crc32("QAOZyfGQVfrTqjZ",15) == 303397806) strcat(s, "t");
if (crc32("SWLOBMUMFGfnCgb",15) == 4200001816) strcat(s, "Z");
if (crc32("nVmBKfAQZJltt",13) == 2637801211) strcat(s, "a");
    return s;
}

char *Thach_nouns() {
    char *s = calloc(6);
    if (crc32("bMEomkj",7) == 4054828671) strcat(s, "Q");
if (crc32("viJjWfOcIqXecR",14) == 2079889256) strcat(s, "T");
if (crc32("nLzaFDj",7) == 47384304) strcat(s, "J");
if (crc32("UsmhXUnUNWBddyL",15) == 3538176001) strcat(s, "h");
if (crc32("FJPzFdJLDewICa",14) == 3412121396) strcat(s, "a");
if (crc32("dBaiB",5) == 3737978886) strcat(s, "V");
if (crc32("jcNHqa",6) == 3488377357) strcat(s, "c");
if (crc32("XjFYw",5) == 1272289152) strcat(s, "h");
    return s;
}

char *Gussman_nouns() {
    char *s = calloc(8);
    if (crc32("YUimXBtP",8) == 964216192) strcat(s, "S");
if (crc32("UTaosZczCZown",13) == 3123265403) strcat(s, "G");
if (crc32("kBuSwxfDmSc",11) == 708333370) strcat(s, "u");
if (crc32("eYRObok",7) == 2643583285) strcat(s, "s");
if (crc32("RCuttMAlScDMOHa",15) == 1133112660) strcat(s, "W");
if (crc32("MoDlmLSBSDsX",12) == 2497079889) strcat(s, "s");
if (crc32("EUpIGWRgmdt",11) == 1644649689) strcat(s, "w");
if (crc32("HwwzN",5) == 1296301966) strcat(s, "m");
if (crc32("mmjWp",5) == 2389942118) strcat(s, "a");
if (crc32("dBjcRKpyyQ",10) == 2356977100) strcat(s, "n");
    return s;
}

char *Kneeland_nouns() {
    char *s = calloc(9);
    if (crc32("weRgm",5) == 4155496104) strcat(s, "K");
if (crc32("teElKk",6) == 840835011) strcat(s, "K");
if (crc32("lCdodITuVcYo",12) == 1936553489) strcat(s, "n");
if (crc32("BCAefIa",7) == 3687488178) strcat(s, "T");
if (crc32("BCQcF",5) == 3517027233) strcat(s, "e");
if (crc32("OoyppnIpGdHPsC",14) == 3081930074) strcat(s, "e");
if (crc32("SPUYGzVJjnlIl",13) == 2383120739) strcat(s, "l");
if (crc32("huvVFGFgstRrCEu",15) == 3651759091) strcat(s, "a");
if (crc32("pbRyEQKYDjtvEe",14) == 2632502356) strcat(s, "n");
if (crc32("AJToVuMRBApLofp",15) == 62185989) strcat(s, "d");
    return s;
}

char *NRA_nouns() {
    char *s = calloc(4);
    if (crc32("SvZYvLzJbwtRNXy",15) == 3250320376) strcat(s, "N");
if (crc32("EWargk",6) == 1079459919) strcat(s, "R");
if (crc32("iDZYhKepe",9) == 2929067738) strcat(s, "A");
    return s;
}

char *Hefter_nouns() {
    char *s = calloc(7);
    if (crc32("BzwLcH",6) == 2773817169) strcat(s, "t");
if (crc32("duVrskywwkyS",12) == 3354387034) strcat(s, "H");
if (crc32("gSOHmjhBUbxSfPQ",15) == 3717419936) strcat(s, "p");
if (crc32("ISTlLy",6) == 2526096444) strcat(s, "e");
if (crc32("sZlkjkHolODEr",13) == 3160830704) strcat(s, "f");
if (crc32("dcfUkWpnTS",10) == 3278444722) strcat(s, "K");
if (crc32("YCvLnTvLEmQwp",13) == 3794979812) strcat(s, "t");
if (crc32("PGyDNDHZmlqEc",13) == 765039279) strcat(s, "e");
if (crc32("gDHdYfy",7) == 3797976629) strcat(s, "r");
    return s;
}

char *prelateship_nouns() {
    char *s = calloc(12);
    if (crc32("ZMmakphbodL",11) == 2888910677) strcat(s, "p");
if (crc32("FUMGuQHDlFHFN",13) == 3924238532) strcat(s, "d");
if (crc32("RRHrvEkoTUrIBYl",15) == 320577499) strcat(s, "r");
if (crc32("urceU",5) == 2134687573) strcat(s, "e");
if (crc32("YJhqloeKFWEcLw",14) == 2131020751) strcat(s, "l");
if (crc32("QaHaSOtlqtbA",12) == 3993070571) strcat(s, "C");
if (crc32("Kgpspd",6) == 2804374131) strcat(s, "a");
if (crc32("FMpKLZTWnjD",11) == 3310353379) strcat(s, "B");
if (crc32("BDOmmS",6) == 4285067761) strcat(s, "t");
if (crc32("vynpOp",6) == 815204183) strcat(s, "e");
if (crc32("qMankViHiIz",11) == 738170855) strcat(s, "j");
if (crc32("gQYLiKMqgulTB",13) == 1307695786) strcat(s, "s");
if (crc32("LkqvqQVyYPM",11) == 1699045265) strcat(s, "G");
if (crc32("zypvbQlEFPhPATG",15) == 139664496) strcat(s, "h");
if (crc32("OfuHUSVYods",11) == 3275076354) strcat(s, "i");
if (crc32("kPcyz",5) == 2058253747) strcat(s, "v");
if (crc32("YicEdW",6) == 2772275346) strcat(s, "p");
    return s;
}

char *Steppes_nouns() {
    char *s = calloc(8);
    if (crc32("IlUzDIRuwXKvdaD",15) == 1097622193) strcat(s, "S");
if (crc32("OAqaNvjGLsQNGxE",15) == 819944365) strcat(s, "t");
if (crc32("eBRgciEeLxTkwv",14) == 3080010265) strcat(s, "e");
if (crc32("LwDygub",7) == 264813815) strcat(s, "p");
if (crc32("FTVPVkT",7) == 3553138070) strcat(s, "p");
if (crc32("ntvaUwJHXNHcood",15) == 3885583489) strcat(s, "l");
if (crc32("sETosHZ",7) == 1409723303) strcat(s, "e");
if (crc32("fROCVaAxViK",11) == 2127803312) strcat(s, "q");
if (crc32("ogyYOEj",7) == 3960203261) strcat(s, "s");
    return s;
}

char *saskatoon_nouns() {
    char *s = calloc(10);
    if (crc32("yoaiGwjq",8) == 1906033233) strcat(s, "B");
if (crc32("aGZDHYjYXNunD",13) == 362018853) strcat(s, "s");
if (crc32("ymsndunGZyctR",13) == 2704481091) strcat(s, "L");
if (crc32("thbRslR",7) == 4185949967) strcat(s, "a");
if (crc32("DCYrSUYWZE",10) == 425992386) strcat(s, "b");
if (crc32("EPYxD",5) == 1745243342) strcat(s, "s");
if (crc32("oxxMnVuKsMbnyX",14) == 830560079) strcat(s, "E");
if (crc32("XFBhY",5) == 3165857191) strcat(s, "k");
if (crc32("ypayrozwUghwle",14) == 1346002726) strcat(s, "a");
if (crc32("VrjnpMFM",8) == 3454669651) strcat(s, "R");
if (crc32("qclYZ",5) == 2315848252) strcat(s, "t");
if (crc32("XgNXouknzdrQH",13) == 2031875403) strcat(s, "o");
if (crc32("GeTmHiGtXKiv",12) == 3353785551) strcat(s, "w");
if (crc32("LqqxQ",5) == 639309143) strcat(s, "o");
if (crc32("khsMGIhovIf",11) == 1767519597) strcat(s, "b");
if (crc32("jutyCSzMIBWq",12) == 1835576448) strcat(s, "n");
    return s;
}

char *teleplay_nouns() {
    char *s = calloc(9);
    if (crc32("XEvGlvGiHdDm",12) == 2415328829) strcat(s, "G");
if (crc32("DJDjrjCeNl",10) == 3311266639) strcat(s, "t");
if (crc32("TxzJzM",6) == 505551122) strcat(s, "v");
if (crc32("PoKzILT",7) == 591102285) strcat(s, "e");
if (crc32("ZUfjGgSduTS",11) == 3911618195) strcat(s, "k");
if (crc32("zivOeKKNV",9) == 2959894711) strcat(s, "l");
if (crc32("wyVSZZ",6) == 408015815) strcat(s, "e");
if (crc32("HakzuWmqulrBGcT",15) == 3644155695) strcat(s, "p");
if (crc32("wQtajJHi",8) == 1746428811) strcat(s, "W");
if (crc32("ZQvFcCGv",8) == 1941960686) strcat(s, "l");
if (crc32("adVZLIixhHW",11) == 606959566) strcat(s, "Z");
if (crc32("hgkEqp",6) == 2183168363) strcat(s, "a");
if (crc32("ecOTgvzeLxFn",12) == 1847699864) strcat(s, "W");
if (crc32("xcezwa",6) == 2272557018) strcat(s, "y");
    return s;
}

char *figurer_nouns() {
    char *s = calloc(8);
    if (crc32("cEQruBLVnhqhFTY",15) == 2321856930) strcat(s, "Z");
if (crc32("UgwooFhIcYMT",12) == 3453359216) strcat(s, "f");
if (crc32("nkDqMfWBsVPmPI",14) == 1119256970) strcat(s, "z");
if (crc32("mRJWx",5) == 279820611) strcat(s, "i");
if (crc32("cDpVOenjW",9) == 3867162592) strcat(s, "g");
if (crc32("PsGRhHZWwuPZE",13) == 1081505514) strcat(s, "m");
if (crc32("mrJdgjcEvlPOzEX",15) == 3488589664) strcat(s, "u");
if (crc32("KIeYAqdK",8) == 997722543) strcat(s, "r");
if (crc32("jkYeOpGLBhcGp",13) == 2070268813) strcat(s, "e");
if (crc32("ANIWcbtNPLI",11) == 1718307318) strcat(s, "r");
    return s;
}

char *subagent_nouns() {
    char *s = calloc(9);
    if (crc32("FvlOInrok",9) == 703578790) strcat(s, "M");
if (crc32("AGmhwcRwhUFovw",14) == 2148181801) strcat(s, "s");
if (crc32("Dhgnc",5) == 4154359062) strcat(s, "u");
if (crc32("ZnUDTpNCGcFEP",13) == 744377857) strcat(s, "b");
if (crc32("htQqB",5) == 1219875030) strcat(s, "a");
if (crc32("IghcWNohbiP",11) == 2648167211) strcat(s, "o");
if (crc32("mNJijWyGKQ",10) == 955208744) strcat(s, "g");
if (crc32("MbSVlQdIxxBQk",13) == 2103972934) strcat(s, "e");
if (crc32("DPueRtQAjXVLB",13) == 2995528048) strcat(s, "n");
if (crc32("qRvHkUadggXut",13) == 3029611339) strcat(s, "t");
    return s;
}

char *Hollis_nouns() {
    char *s = calloc(7);
    if (crc32("dwPUgDJXr",9) == 3957015147) strcat(s, "T");
if (crc32("kZaxitxCSKSjzHU",15) == 1360595640) strcat(s, "H");
if (crc32("lsxxaRvIhSR",11) == 3066505410) strcat(s, "o");
if (crc32("fnFWV",5) == 139213792) strcat(s, "l");
if (crc32("dnXsSzoFV",9) == 49931744) strcat(s, "W");
if (crc32("OHXfnsvKRLvi",12) == 1864721260) strcat(s, "l");
if (crc32("MjwAr",5) == 873294851) strcat(s, "i");
if (crc32("ZFzgDMEKHIFC",12) == 3995363460) strcat(s, "K");
if (crc32("jxDOdmzNAjuk",12) == 1985058202) strcat(s, "s");
    return s;
}

char *selfdirection_nouns() {
    char *s = calloc(14);
    if (crc32("OTYoWFjAZn",10) == 2646043767) strcat(s, "s");
if (crc32("itCnS",5) == 3449659412) strcat(s, "e");
if (crc32("QheBsz",6) == 4280806705) strcat(s, "F");
if (crc32("XKtsMMkO",8) == 4202345295) strcat(s, "l");
if (crc32("cXGaDS",6) == 509612929) strcat(s, "f");
if (crc32("PbCaipoZ",8) == 2058831879) strcat(s, "d");
if (crc32("yjsvQFepXFac",12) == 600131188) strcat(s, "i");
if (crc32("ZaWJuDYn",8) == 4281826719) strcat(s, "f");
if (crc32("YOlwJOMWp",9) == 2667414677) strcat(s, "r");
if (crc32("zGQGySfaAC",10) == 2463702947) strcat(s, "r");
if (crc32("FQwFtJJSOdmLI",13) == 4079500304) strcat(s, "e");
if (crc32("fGhxQlzy",8) == 293214716) strcat(s, "c");
if (crc32("byHehDGmgvHupW",14) == 2201155874) strcat(s, "H");
if (crc32("GfUwiiUBLQaBNkZ",15) == 1171438064) strcat(s, "t");
if (crc32("fXqbGuq",7) == 3235220880) strcat(s, "i");
if (crc32("yfwUPOUUVima",12) == 1582592245) strcat(s, "o");
if (crc32("eJoDoDNvyCyEbg",14) == 2772075317) strcat(s, "b");
if (crc32("ZXiFXMAJfezVN",13) == 3073341943) strcat(s, "n");
    return s;
}

char *Colo_nouns() {
    char *s = calloc(5);
    if (crc32("sGaqI",5) == 1962196383) strcat(s, "v");
if (crc32("oYBAjWoEwn",10) == 1752125196) strcat(s, "C");
if (crc32("RnWmXOdvjHUb",12) == 3234239418) strcat(s, "o");
if (crc32("MSVFkvtmiHbsX",13) == 457319264) strcat(s, "H");
if (crc32("PUCcrG",6) == 2067702786) strcat(s, "l");
if (crc32("ZOoBFrDhBtiC",12) == 2820670263) strcat(s, "o");
    return s;
}

char *skeet_nouns() {
    char *s = calloc(6);
    if (crc32("yKcnd",5) == 2441159726) strcat(s, "i");
if (crc32("fjTLDaVNpWdkS",13) == 1362349397) strcat(s, "s");
if (crc32("SXpvifPumd",10) == 1643711263) strcat(s, "k");
if (crc32("XGHdWVAQeQipZHH",15) == 236322687) strcat(s, "g");
if (crc32("lqKAYoGsxohmvtM",15) == 3097528585) strcat(s, "e");
if (crc32("TtyKCN",6) == 172445739) strcat(s, "e");
if (crc32("PAQNh",5) == 334712045) strcat(s, "l");
if (crc32("XDJMzfBsCVruUZ",14) == 3869126543) strcat(s, "t");
    return s;
}

char *Tombigbee_nouns() {
    char *s = calloc(10);
    if (crc32("yiszxmduJwvQa",13) == 1590316725) strcat(s, "u");
if (crc32("NuxChUWPUEhm",12) == 1621975285) strcat(s, "T");
if (crc32("kYToEgXdTEibeb",14) == 3337927453) strcat(s, "q");
if (crc32("XLrzkaNWNb",10) == 3466433521) strcat(s, "o");
if (crc32("FCRIKeVVcRi",11) == 4227016953) strcat(s, "m");
if (crc32("yAfLiGzHwzAKDws",15) == 2846561401) strcat(s, "l");
if (crc32("iAAxXm",6) == 3280028353) strcat(s, "b");
if (crc32("nVgLeYCcs",9) == 2601308288) strcat(s, "g");
if (crc32("IjpbSzccGFNem",13) == 2607392004) strcat(s, "i");
if (crc32("VREcmAOlOFxZ",12) == 3447895777) strcat(s, "K");
if (crc32("jFGMJxipIT",10) == 3057674867) strcat(s, "g");
if (crc32("rJxyydsA",8) == 616544632) strcat(s, "b");
if (crc32("vSUkuY",6) == 3953411542) strcat(s, "e");
if (crc32("vKVLZiN",7) == 2654544990) strcat(s, "A");
if (crc32("obLkM",5) == 3146503148) strcat(s, "e");
    return s;
}

char *contemplation_nouns() {
    char *s = calloc(14);
    if (crc32("jczKMHKlT",9) == 2078667339) strcat(s, "c");
if (crc32("bfTzUgX",7) == 1131091350) strcat(s, "x");
if (crc32("tizMteuSI",9) == 3006969622) strcat(s, "o");
if (crc32("IIMFTCTeDs",10) == 3111204350) strcat(s, "n");
if (crc32("iOdirfbbu",9) == 1324209235) strcat(s, "R");
if (crc32("BBRwtLj",7) == 436231172) strcat(s, "t");
if (crc32("UXKLpbjePSGlbAu",15) == 3681992802) strcat(s, "e");
if (crc32("nEVHPuFcCfxrF",13) == 2832510965) strcat(s, "m");
if (crc32("xUoyDq",6) == 4012810982) strcat(s, "G");
if (crc32("BXfgXr",6) == 1686977784) strcat(s, "p");
if (crc32("uQHOKnWwiqHEE",13) == 3579358868) strcat(s, "S");
if (crc32("sizPaNWLDcNO",12) == 3257060974) strcat(s, "l");
if (crc32("dQthKfFAc",9) == 4197068802) strcat(s, "a");
if (crc32("YkAzxmjvopedA",13) == 3794132957) strcat(s, "t");
if (crc32("lsgJyn",6) == 4287479249) strcat(s, "i");
if (crc32("uJwiOlKb",8) == 1113598115) strcat(s, "O");
if (crc32("EQwpACnaVuOyC",13) == 3739155217) strcat(s, "o");
if (crc32("rdOEGlQmFJHheKT",15) == 3937684382) strcat(s, "n");
    return s;
}

char *mortification_nouns() {
    char *s = calloc(14);
    if (crc32("nABovaU",7) == 4094440972) strcat(s, "m");
if (crc32("owezfBFt",8) == 2414100381) strcat(s, "O");
if (crc32("dNKtlVGW",8) == 529319040) strcat(s, "o");
if (crc32("WaLoZXaWoc",10) == 2304232268) strcat(s, "r");
if (crc32("cfaqTynXBi",10) == 2362939277) strcat(s, "t");
if (crc32("GfutJB",6) == 682626699) strcat(s, "i");
if (crc32("yZEcHLFtXYuaBZ",14) == 2459072671) strcat(s, "A");
if (crc32("oDohA",5) == 641909855) strcat(s, "f");
if (crc32("mPpnMjk",7) == 1687732029) strcat(s, "i");
if (crc32("eFIOkPvhQG",10) == 4181931882) strcat(s, "p");
if (crc32("vMcOaclGi",9) == 3559039846) strcat(s, "c");
if (crc32("hnuacqbwWFnX",12) == 1823323102) strcat(s, "I");
if (crc32("dPLuVrMc",8) == 1937887453) strcat(s, "a");
if (crc32("allyMG",6) == 2836863247) strcat(s, "t");
if (crc32("tzTAXf",6) == 1905752617) strcat(s, "i");
if (crc32("YWFhNOhhrc",10) == 1586257758) strcat(s, "n");
if (crc32("MmcxbJNyMxIms",13) == 4121779558) strcat(s, "o");
if (crc32("MVnDhGs",7) == 3249713015) strcat(s, "R");
if (crc32("QigfwQCJLIgl",12) == 2472107247) strcat(s, "n");
    return s;
}

char *oregano_nouns() {
    char *s = calloc(8);
    if (crc32("hStIkSKGmfKHvvC",15) == 3614487636) strcat(s, "p");
if (crc32("RssEPgymQZtqMww",15) == 3043774432) strcat(s, "o");
if (crc32("FedyHJoVO",9) == 1434285340) strcat(s, "r");
if (crc32("jqqJStQ",7) == 3719910543) strcat(s, "s");
if (crc32("NiIlGjdBLy",10) == 2590847646) strcat(s, "e");
if (crc32("ahZbSt",6) == 4063562474) strcat(s, "g");
if (crc32("byXyCUKb",8) == 3387189313) strcat(s, "a");
if (crc32("unkPqwlJt",9) == 746658766) strcat(s, "v");
if (crc32("xQtJlcQe",8) == 3101457520) strcat(s, "n");
if (crc32("EsytNNgpzgyB",12) == 658781444) strcat(s, "a");
if (crc32("amBhJDtRjUapNMj",15) == 3541610769) strcat(s, "o");
    return s;
}

char *Greene_nouns() {
    char *s = calloc(7);
    if (crc32("MUmxWIFmDFmtRC",14) == 1404915520) strcat(s, "G");
if (crc32("ZCPaJz",6) == 1004157363) strcat(s, "r");
if (crc32("arjjRAstTmQ",11) == 174159991) strcat(s, "z");
if (crc32("LczSfWLViaImR",13) == 755107623) strcat(s, "e");
if (crc32("CUBbyLT",7) == 1815796548) strcat(s, "e");
if (crc32("bacAIodv",8) == 750703347) strcat(s, "n");
if (crc32("EbJGVwl",7) == 2527632349) strcat(s, "e");
    return s;
}

char *lordosis_nouns() {
    char *s = calloc(9);
    if (crc32("UbkkzxLjI",9) == 1408970359) strcat(s, "l");
if (crc32("XcSgSLobGTg",11) == 2598762280) strcat(s, "o");
if (crc32("rqaJztlJAi",10) == 2110713834) strcat(s, "r");
if (crc32("JZFpOepGZ",9) == 4085710442) strcat(s, "d");
if (crc32("TjlOmQz",7) == 793985157) strcat(s, "o");
if (crc32("vmwGFSzjeMx",11) == 4055816170) strcat(s, "s");
if (crc32("VsYMoWjDczJAlc",14) == 2800663662) strcat(s, "U");
if (crc32("rXMIMcCQVkX",11) == 852736847) strcat(s, "i");
if (crc32("IwlfKz",6) == 4096385076) strcat(s, "X");
if (crc32("vHOBSKsKlhht",12) == 2981374021) strcat(s, "s");
    return s;
}

char *Chiclayo_nouns() {
    char *s = calloc(9);
    if (crc32("aPsZoVRDsn",10) == 2207989473) strcat(s, "F");
if (crc32("xSwSIQrbRRh",11) == 2458791573) strcat(s, "C");
if (crc32("fPqZEBW",7) == 2500122625) strcat(s, "T");
if (crc32("NZQcvDpxEZh",11) == 1132900769) strcat(s, "h");
if (crc32("FTcCaLGEZxqf",12) == 3223384665) strcat(s, "i");
if (crc32("bewPnM",6) == 3429579358) strcat(s, "c");
if (crc32("TdTpMRozf",9) == 2990794797) strcat(s, "l");
if (crc32("qBJrVOnYCkPxUu",14) == 3344353954) strcat(s, "d");
if (crc32("CpBdDQ",6) == 929440135) strcat(s, "a");
if (crc32("aIlIY",5) == 3866177321) strcat(s, "Y");
if (crc32("sheARyZoYExDU",13) == 2876039616) strcat(s, "y");
if (crc32("xBoqLrsafTKUmAI",15) == 3654819629) strcat(s, "o");
    return s;
}

char *viscus_nouns() {
    char *s = calloc(7);
    if (crc32("SqzMuGkpvmP",11) == 2261846396) strcat(s, "v");
if (crc32("EVqGdkEaqlbzYv",14) == 1264307227) strcat(s, "H");
if (crc32("OLtDSuApVyDbHn",14) == 2729335773) strcat(s, "i");
if (crc32("tLCNqXhwVeszgc",14) == 1772248802) strcat(s, "s");
if (crc32("xqKnQdVTiwB",11) == 3329625726) strcat(s, "d");
if (crc32("hBrvSvNETiOZMHr",15) == 4275140100) strcat(s, "c");
if (crc32("KuCNAbSwo",9) == 972709656) strcat(s, "u");
if (crc32("DUtvrrmHtNYYOWt",15) == 1208937491) strcat(s, "D");
if (crc32("cMOitfENm",9) == 2507209572) strcat(s, "s");
    return s;
}

char *nascence_nouns() {
    char *s = calloc(9);
    if (crc32("VQiRwE",6) == 565752907) strcat(s, "n");
if (crc32("QbvQi",5) == 2175434770) strcat(s, "D");
if (crc32("UZEfct",6) == 1711963473) strcat(s, "a");
if (crc32("OHOMAfSakdlns",13) == 2868068709) strcat(s, "s");
if (crc32("cgzQMv",6) == 2180879924) strcat(s, "c");
if (crc32("jmCtBMKuJw",10) == 1638964887) strcat(s, "A");
if (crc32("rOVDnJTSxLqy",12) == 3290466965) strcat(s, "e");
if (crc32("MAhsf",5) == 3383430373) strcat(s, "m");
if (crc32("xtizIYPK",8) == 1089323084) strcat(s, "n");
if (crc32("iLUNQ",5) == 1704623047) strcat(s, "W");
if (crc32("zgjdj",5) == 973580506) strcat(s, "c");
if (crc32("bzGiAy",6) == 2115701432) strcat(s, "I");
if (crc32("etlyImfIroSRwZw",15) == 2883433592) strcat(s, "e");
    return s;
}

char *Polyhymnia_nouns() {
    char *s = calloc(11);
    if (crc32("VKfcuFy",7) == 1513964115) strcat(s, "q");
if (crc32("tsJcAtHmJuklVh",14) == 1738139402) strcat(s, "P");
if (crc32("iYOPQjzuHYqh",12) == 2049418988) strcat(s, "A");
if (crc32("CCNNoIYXCkbAQ",13) == 3794942115) strcat(s, "o");
if (crc32("EtFVFN",6) == 51162500) strcat(s, "l");
if (crc32("nGtfQTzJzkVtWh",14) == 1292142223) strcat(s, "V");
if (crc32("BPsfhvl",7) == 2582440066) strcat(s, "y");
if (crc32("FPVDMFtxd",9) == 4212452064) strcat(s, "k");
if (crc32("PVWEzxPIOUA",11) == 483045550) strcat(s, "h");
if (crc32("GMEvq",5) == 1840849749) strcat(s, "y");
if (crc32("khQOAb",6) == 3927422869) strcat(s, "C");
if (crc32("gTqnNUDgwQVr",12) == 1494194774) strcat(s, "m");
if (crc32("SnNWpMXCXMSS",12) == 3353342508) strcat(s, "n");
if (crc32("ESZYhmYbzLNoEbW",15) == 2786267880) strcat(s, "C");
if (crc32("MuVcHbNs",8) == 3752475711) strcat(s, "i");
if (crc32("SFIQzwNY",8) == 3591812764) strcat(s, "d");
if (crc32("evewxoCKcV",10) == 597453568) strcat(s, "a");
    return s;
}

char *fuage_nouns() {
    char *s = calloc(6);
    if (crc32("AplSJqiqyrkeSh",14) == 2724489514) strcat(s, "v");
if (crc32("bfBfJYsJCFJKnBi",15) == 360913102) strcat(s, "f");
if (crc32("OTbUoyZldmkyj",13) == 3002574461) strcat(s, "Q");
if (crc32("pXynipX",7) == 3010189278) strcat(s, "u");
if (crc32("xJRjOake",8) == 1503360940) strcat(s, "a");
if (crc32("mzhyP",5) == 1884294602) strcat(s, "g");
if (crc32("zgDdREcpXXAvvtM",15) == 1349361600) strcat(s, "e");
    return s;
}

char *Davey_nouns() {
    char *s = calloc(6);
    if (crc32("AIXap",5) == 199345537) strcat(s, "D");
if (crc32("IuPKjf",6) == 614907771) strcat(s, "a");
if (crc32("ReenQATjmVCBZoK",15) == 1827969132) strcat(s, "d");
if (crc32("XEtomCxswPSY",12) == 3837700808) strcat(s, "v");
if (crc32("AtjWsx",6) == 637788978) strcat(s, "u");
if (crc32("lQnFHVXAoRn",11) == 4214775051) strcat(s, "e");
if (crc32("gQtqAHPImw",10) == 3513705574) strcat(s, "y");
    return s;
}

char *canonization_nouns() {
    char *s = calloc(13);
    if (crc32("UPchSCnwA",9) == 15532747) strcat(s, "c");
if (crc32("IutIkxexOBFl",12) == 2427259293) strcat(s, "O");
if (crc32("gnibTMeBCk",10) == 3727943557) strcat(s, "a");
if (crc32("diAeKKQkgg",10) == 1931119832) strcat(s, "n");
if (crc32("uXxIQ",5) == 2661028649) strcat(s, "o");
if (crc32("UlUgcwNdnPd",11) == 2772717706) strcat(s, "w");
if (crc32("DdHdHKtNpKBVuRl",15) == 2389149516) strcat(s, "n");
if (crc32("sIIzNwUNvdDoH",13) == 850651759) strcat(s, "i");
if (crc32("MpElR",5) == 1927992475) strcat(s, "L");
if (crc32("KHrIJffS",8) == 202272666) strcat(s, "z");
if (crc32("VjwwgcmH",8) == 3519189400) strcat(s, "e");
if (crc32("cqXYrFhjxnPmvj",14) == 2456713613) strcat(s, "a");
if (crc32("QYcJySmDAFR",11) == 4060497249) strcat(s, "B");
if (crc32("JRyRNOFIHUYMj",13) == 2525240453) strcat(s, "t");
if (crc32("TrUbGYxycKJnqaE",15) == 142689105) strcat(s, "u");
if (crc32("muayJxcqQsVRW",13) == 1176970950) strcat(s, "i");
if (crc32("OkXRywpgadL",11) == 2703212903) strcat(s, "R");
if (crc32("jrgMEMjlAWZ",11) == 2839666961) strcat(s, "o");
if (crc32("lGHPeRhcY",9) == 1712260777) strcat(s, "D");
if (crc32("VfLQaJjRZMq",11) == 3022376173) strcat(s, "n");
    return s;
}

char *Satie_nouns() {
    char *s = calloc(6);
    if (crc32("TIyEAssRm",9) == 673208708) strcat(s, "S");
if (crc32("RRDgV",5) == 2104353181) strcat(s, "k");
if (crc32("jrKCVRKcPYHOFaU",15) == 2068027878) strcat(s, "a");
if (crc32("PETrnQmwNCphSbY",15) == 1944169390) strcat(s, "t");
if (crc32("PTWvEIjyXwIytDh",15) == 2798404168) strcat(s, "i");
if (crc32("onwTHXEhJIwv",12) == 1458956870) strcat(s, "e");
    return s;
}

char *favoritism_nouns() {
    char *s = calloc(11);
    if (crc32("OBhWZ",5) == 354173394) strcat(s, "f");
if (crc32("RSygHN",6) == 1192905341) strcat(s, "w");
if (crc32("yvaPy",5) == 2797846328) strcat(s, "a");
if (crc32("CaonKUnfrF",10) == 2401548026) strcat(s, "v");
if (crc32("btumkzhIMIc",11) == 2354270137) strcat(s, "o");
if (crc32("lteDbVMWeOnkZV",14) == 2120890176) strcat(s, "W");
if (crc32("XhVrbJVCdmTOAA",14) == 3116554762) strcat(s, "r");
if (crc32("nNdrkJoWXf",10) == 3117914179) strcat(s, "i");
if (crc32("PoUgjjHMAGWzTn",14) == 1326654952) strcat(s, "g");
if (crc32("GwesKHxJIdL",11) == 771153531) strcat(s, "t");
if (crc32("MtySozbjrbCp",12) == 1920818755) strcat(s, "P");
if (crc32("pVnwpKLtQsxT",12) == 2752130805) strcat(s, "i");
if (crc32("oIvCQJAKEBLBjc",14) == 2679478444) strcat(s, "s");
if (crc32("grGbt",5) == 1339976558) strcat(s, "d");
if (crc32("aovTfslo",8) == 1221255715) strcat(s, "m");
    return s;
}

char *disjection_nouns() {
    char *s = calloc(11);
    if (crc32("egcJqmYfOj",10) == 3546056686) strcat(s, "d");
if (crc32("cRIni",5) == 2737597684) strcat(s, "F");
if (crc32("YtNUQpsbp",9) == 1738539902) strcat(s, "i");
if (crc32("LpLdwkmCHOUaI",13) == 3235681144) strcat(s, "s");
if (crc32("PhGpyNWmkwCMqT",14) == 3531400987) strcat(s, "K");
if (crc32("mrPUEYEh",8) == 2827357271) strcat(s, "j");
if (crc32("swqKSYmWVxdrAsn",15) == 2330081558) strcat(s, "S");
if (crc32("ueCTAoxvRpLS",12) == 788360618) strcat(s, "e");
if (crc32("PnMLGXvCj",9) == 3461945993) strcat(s, "c");
if (crc32("uKNopQmfKTIZJ",13) == 3526712482) strcat(s, "t");
if (crc32("YPOVrjymzrkKpg",14) == 2763374250) strcat(s, "i");
if (crc32("Trawgg",6) == 2475218359) strcat(s, "q");
if (crc32("qvKVaTRVzVH",11) == 3139023112) strcat(s, "o");
if (crc32("IvrpnoTswfER",12) == 3787243418) strcat(s, "n");
    return s;
}

char *noncuriosity_nouns() {
    char *s = calloc(13);
    if (crc32("HVnELBPZnzceU",13) == 3361175489) strcat(s, "P");
if (crc32("nsraSeDtWcqcy",13) == 1382494824) strcat(s, "n");
if (crc32("DGgneeCv",8) == 1518102642) strcat(s, "o");
if (crc32("DRHMEjopcvcL",12) == 3427563187) strcat(s, "n");
if (crc32("xnxsGSbZ",8) == 743519973) strcat(s, "c");
if (crc32("HuNKlDioFtGxGW",14) == 285310780) strcat(s, "u");
if (crc32("iBwolgylRjSQ",12) == 3342927804) strcat(s, "r");
if (crc32("ycsTRjkRw",9) == 2346449363) strcat(s, "M");
if (crc32("aLAFidmUm",9) == 2096650424) strcat(s, "i");
if (crc32("LtJHgINBtjw",11) == 1268823944) strcat(s, "o");
if (crc32("IUMZfCHRyFy",11) == 4106079700) strcat(s, "I");
if (crc32("pWjYXLIpjMIyTIZ",15) == 2160692877) strcat(s, "s");
if (crc32("HiDgSCzVe",9) == 647455941) strcat(s, "W");
if (crc32("PtsIgTWZvN",10) == 51356237) strcat(s, "i");
if (crc32("XhANxfL",7) == 3118404409) strcat(s, "k");
if (crc32("SonVaV",6) == 1838958451) strcat(s, "t");
if (crc32("npmYJEf",7) == 3467796968) strcat(s, "y");
    return s;
}

char *Cognac_nouns() {
    char *s = calloc(7);
    if (crc32("guNVtsYgt",9) == 2671351550) strcat(s, "C");
if (crc32("nxztCdUgu",9) == 503697994) strcat(s, "o");
if (crc32("kYfPPonypJGx",12) == 2524803985) strcat(s, "g");
if (crc32("AJWFcfOKcCecug",14) == 67571944) strcat(s, "n");
if (crc32("NIWBMuiJ",8) == 2725011009) strcat(s, "n");
if (crc32("iKbuMMsjwfyQMfL",15) == 3922672568) strcat(s, "l");
if (crc32("eGqdmRTgwOwSWCB",15) == 1927785882) strcat(s, "a");
if (crc32("ipusSy",6) == 733556405) strcat(s, "R");
if (crc32("ZTuBNRuBeLq",11) == 4033495501) strcat(s, "c");
    return s;
}

char *Orneus_nouns() {
    char *s = calloc(7);
    if (crc32("OQYIHJVOQsSWkI",14) == 3110351027) strcat(s, "O");
if (crc32("hdMisWRXv",9) == 3947922424) strcat(s, "g");
if (crc32("PiknmMxvA",9) == 3392159231) strcat(s, "r");
if (crc32("ufgEPR",6) == 268473801) strcat(s, "z");
if (crc32("pIJHWkMvmFxDxs",14) == 2615577061) strcat(s, "n");
if (crc32("dOcJf",5) == 2368829536) strcat(s, "e");
if (crc32("zJcHUkglMFX",11) == 1212085922) strcat(s, "j");
if (crc32("hFegWqieQdh",11) == 1337902113) strcat(s, "u");
if (crc32("PWzVUP",6) == 1470365735) strcat(s, "V");
if (crc32("yinLBgkspPpwvb",14) == 552623782) strcat(s, "s");
    return s;
}

char *Terni_nouns() {
    char *s = calloc(6);
    if (crc32("CoPHBUFXzQu",11) == 10451521) strcat(s, "T");
if (crc32("rJnnWmYam",9) == 109123187) strcat(s, "e");
if (crc32("MedqcO",6) == 437405306) strcat(s, "r");
if (crc32("oQaPivHKIyZxau",14) == 1185655845) strcat(s, "e");
if (crc32("azSQDcfccGKWKUx",15) == 514536279) strcat(s, "n");
if (crc32("fjAAOsznXnEV",12) == 941093132) strcat(s, "e");
if (crc32("SlBHYxjCCpKYJ",13) == 1740137240) strcat(s, "i");
    return s;
}

char *carnosine_nouns() {
    char *s = calloc(10);
    if (crc32("IQxrRxzlh",9) == 1138962233) strcat(s, "R");
if (crc32("PmjdHgA",7) == 956003819) strcat(s, "c");
if (crc32("GRxYJQQo",8) == 3342344727) strcat(s, "a");
if (crc32("eqrgPYlKTlIHSmW",15) == 1279144802) strcat(s, "r");
if (crc32("VksuirOcO",9) == 731253567) strcat(s, "u");
if (crc32("nZjVN",5) == 2085947716) strcat(s, "n");
if (crc32("KSwkQQcnvtjVDO",14) == 1639613558) strcat(s, "o");
if (crc32("WMklVxECggpl",12) == 836777954) strcat(s, "s");
if (crc32("idmtOkkHXFaeM",13) == 3227148168) strcat(s, "i");
if (crc32("KVGhtqOfDZVt",12) == 3651773944) strcat(s, "f");
if (crc32("lzFMUEZ",7) == 2848527792) strcat(s, "n");
if (crc32("iMVON",5) == 436822246) strcat(s, "u");
if (crc32("nxfyPtd",7) == 3437313426) strcat(s, "e");
    return s;
}

char *Appledorf_nouns() {
    char *s = calloc(10);
    if (crc32("TYRgGweemFnnSZH",15) == 2455513266) strcat(s, "A");
if (crc32("oAnRcv",6) == 1854208854) strcat(s, "p");
if (crc32("gfAhlZYNuvwnbZ",14) == 3762248269) strcat(s, "p");
if (crc32("VAzFRtcR",8) == 2421479346) strcat(s, "l");
if (crc32("tXMWBKn",7) == 3412389469) strcat(s, "Y");
if (crc32("YKlGIvikUl",10) == 587591884) strcat(s, "e");
if (crc32("dhHEzYdVKSB",11) == 401570736) strcat(s, "L");
if (crc32("atdrxe",6) == 1194819856) strcat(s, "d");
if (crc32("IAjepaCj",8) == 489175400) strcat(s, "o");
if (crc32("YiyuwKKMtjWHaf",14) == 1295664274) strcat(s, "r");
if (crc32("PgyoMusx",8) == 684858161) strcat(s, "f");
    return s;
}

char *whapper_nouns() {
    char *s = calloc(8);
    if (crc32("cEqpsRFthGis",12) == 2188150974) strcat(s, "L");
if (crc32("psTXYRsktHrs",12) == 2458668852) strcat(s, "w");
if (crc32("RLeltWmTHVkI",12) == 4065812484) strcat(s, "h");
if (crc32("TpGEhRPQccSVJx",14) == 1294944768) strcat(s, "a");
if (crc32("msEbdFhFViWk",12) == 1719330803) strcat(s, "p");
if (crc32("jfyKSfH",7) == 4052412538) strcat(s, "p");
if (crc32("EdvhJTL",7) == 1454537105) strcat(s, "m");
if (crc32("cRpayhT",7) == 2252240846) strcat(s, "e");
if (crc32("LcDdIQDWgEWm",12) == 2861010390) strcat(s, "r");
    return s;
}

char *Irby_nouns() {
    char *s = calloc(5);
    if (crc32("wrEQJyWklBCnG",13) == 873812238) strcat(s, "V");
if (crc32("jxLoWCc",7) == 3447784821) strcat(s, "I");
if (crc32("ujIVolXcZ",9) == 3674317478) strcat(s, "r");
if (crc32("hOjcLvUWENw",11) == 1410157935) strcat(s, "O");
if (crc32("JYCufEB",7) == 1285747247) strcat(s, "b");
if (crc32("CznMeC",6) == 3750244452) strcat(s, "y");
    return s;
}

char *Dak_nouns() {
    char *s = calloc(4);
    if (crc32("ghjRSMSmFIB",11) == 3563904141) strcat(s, "D");
if (crc32("RoMFbllJtt",10) == 1103796846) strcat(s, "a");
if (crc32("TvOWhnm",7) == 3337190404) strcat(s, "L");
if (crc32("DollNpvupxC",11) == 2035191448) strcat(s, "k");
    return s;
}

char *ballerina_nouns() {
    char *s = calloc(10);
    if (crc32("VomZvLSNsRTz",12) == 2790173969) strcat(s, "E");
if (crc32("mjdFFhyRdQc",11) == 3053474368) strcat(s, "b");
if (crc32("fAZAxlQNHmBiDQF",15) == 693424811) strcat(s, "v");
if (crc32("avitXk",6) == 3106701242) strcat(s, "a");
if (crc32("sptVFgdtXSv",11) == 260912664) strcat(s, "d");
if (crc32("dmefFuOFueMSUPd",15) == 903917539) strcat(s, "l");
if (crc32("DMBnfwhcQT",10) == 483455646) strcat(s, "C");
if (crc32("weVkS",5) == 2641505491) strcat(s, "l");
if (crc32("vdrzznGOmXUAU",13) == 1364584342) strcat(s, "e");
if (crc32("MhTYRBcrqJtjL",13) == 198445537) strcat(s, "v");
if (crc32("WVzsihXFR",9) == 2374262745) strcat(s, "r");
if (crc32("fEFvdVdmudOxJQR",15) == 3509721136) strcat(s, "h");
if (crc32("xqYYQ",5) == 3363506602) strcat(s, "i");
if (crc32("vRsjbUkPOBC",11) == 4192096017) strcat(s, "F");
if (crc32("QgKvmoIGTjY",11) == 1904709579) strcat(s, "n");
if (crc32("RsJJvQ",6) == 2723912989) strcat(s, "a");
    return s;
}

char *Bardeen_nouns() {
    char *s = calloc(8);
    if (crc32("UjEpJB",6) == 4133311910) strcat(s, "d");
if (crc32("UiVew",5) == 3458541136) strcat(s, "B");
if (crc32("ykhxWgiKADAIJ",13) == 1694448091) strcat(s, "a");
if (crc32("WcQrsi",6) == 2471825755) strcat(s, "k");
if (crc32("ioLodeb",7) == 1884210608) strcat(s, "r");
if (crc32("juOVVI",6) == 3198145884) strcat(s, "G");
if (crc32("ulBQmcTj",8) == 2047500705) strcat(s, "d");
if (crc32("drsiQElSePvsVRD",15) == 1293796156) strcat(s, "e");
if (crc32("vkfYbdVYKidL",12) == 1091862403) strcat(s, "o");
if (crc32("hKknhXjzumzhuQ",14) == 1539259947) strcat(s, "e");
if (crc32("ujlpYwOQsH",10) == 41845963) strcat(s, "A");
if (crc32("jKdqMqP",7) == 1292445662) strcat(s, "n");
    return s;
}

char *concertgoer_nouns() {
    char *s = calloc(12);
    if (crc32("iOWOJYQljn",10) == 3193398548) strcat(s, "c");
if (crc32("mPNdQBnSD",9) == 1129389822) strcat(s, "Q");
if (crc32("uutzTaqVSn",10) == 2596238096) strcat(s, "o");
if (crc32("lVVHkWR",7) == 3594749750) strcat(s, "n");
if (crc32("qQlyZvVEUHmUkLi",15) == 3709766603) strcat(s, "c");
if (crc32("PWstsXzchT",10) == 2091981420) strcat(s, "e");
if (crc32("rqNVYFzfQozqf",13) == 1343535399) strcat(s, "r");
if (crc32("GAlYuMNo",8) == 980609498) strcat(s, "s");
if (crc32("eMsidP",6) == 502178616) strcat(s, "t");
if (crc32("CzxFajnn",8) == 759456673) strcat(s, "g");
if (crc32("MQZbeJsb",8) == 3399794828) strcat(s, "o");
if (crc32("AoIitNOsSTFTIG",14) == 1028788439) strcat(s, "e");
if (crc32("ShaxnQNf",8) == 1886665838) strcat(s, "r");
    return s;
}

char *sterility_nouns() {
    char *s = calloc(10);
    if (crc32("ulfMckpDXPUH",12) == 3265036626) strcat(s, "s");
if (crc32("tQDwtqRBQzuAK",13) == 3224045621) strcat(s, "t");
if (crc32("motoS",5) == 2268730398) strcat(s, "e");
if (crc32("IiDEfywu",8) == 2215125143) strcat(s, "C");
if (crc32("vgAkoGP",7) == 424214621) strcat(s, "r");
if (crc32("vhMKWE",6) == 587657150) strcat(s, "i");
if (crc32("OvyMxQDGGiBb",12) == 63976189) strcat(s, "w");
if (crc32("JKNXuYKAf",9) == 2615161005) strcat(s, "l");
if (crc32("zsmnrKPOay",10) == 2970343154) strcat(s, "c");
if (crc32("GQDVRwMVnuP",11) == 1159187376) strcat(s, "i");
if (crc32("AvBBzEQJAfTfD",13) == 3449750818) strcat(s, "t");
if (crc32("lowhAXjtlYXBdMy",15) == 3269710056) strcat(s, "y");
    return s;
}

char *lectorship_nouns() {
    char *s = calloc(11);
    if (crc32("ndQwqWlwPtRWgF",14) == 2791258949) strcat(s, "A");
if (crc32("tfrmPN",6) == 2649058622) strcat(s, "l");
if (crc32("LTcgrEdHDmoJpT",14) == 3087073747) strcat(s, "e");
if (crc32("HkZgWKAZkDj",11) == 744964516) strcat(s, "c");
if (crc32("SnXmf",5) == 740894779) strcat(s, "z");
if (crc32("Ihhpx",5) == 1517684905) strcat(s, "t");
if (crc32("WXXqv",5) == 108634498) strcat(s, "w");
if (crc32("joDPJCWHmDQryS",14) == 2597056474) strcat(s, "o");
if (crc32("zgGzl",5) == 172591990) strcat(s, "A");
if (crc32("IfrldIkPAwJYtc",14) == 2169433869) strcat(s, "r");
if (crc32("RIJvhFnRg",9) == 2288756377) strcat(s, "I");
if (crc32("PYUBtnhc",8) == 665981450) strcat(s, "s");
if (crc32("skKtMyDYtLKnO",13) == 3758398138) strcat(s, "h");
if (crc32("OaBwxVUuQyKsrF",14) == 1271388958) strcat(s, "T");
if (crc32("DoKDcgYWdCoHEcq",15) == 4082618620) strcat(s, "i");
if (crc32("NeuqOSL",7) == 1021886049) strcat(s, "b");
if (crc32("oYrUP",5) == 2425820018) strcat(s, "p");
    return s;
}

char *trinitroglycerin_nouns() {
    char *s = calloc(17);
    if (crc32("FMngOp",6) == 2032511817) strcat(s, "t");
if (crc32("yanFfE",6) == 2059377614) strcat(s, "i");
if (crc32("NPkcgIut",8) == 450581862) strcat(s, "r");
if (crc32("ndXdJNkcp",9) == 2525562938) strcat(s, "i");
if (crc32("yBqZnQQX",8) == 3353561576) strcat(s, "n");
if (crc32("qpMKvKfiifEFa",13) == 1738654436) strcat(s, "i");
if (crc32("PFiecmbEabXoqj",14) == 2592745252) strcat(s, "t");
if (crc32("CVVRKOLpH",9) == 1374699935) strcat(s, "r");
if (crc32("iulxSKJhnev",11) == 2962474614) strcat(s, "P");
if (crc32("rSwCi",5) == 571236113) strcat(s, "o");
if (crc32("SQptrZwH",8) == 2034819922) strcat(s, "w");
if (crc32("nuPZsVMaObIayL",14) == 658620527) strcat(s, "g");
if (crc32("FzhnqkaDFax",11) == 2814993832) strcat(s, "z");
if (crc32("HLxHJwlbPmT",11) == 3654355648) strcat(s, "l");
if (crc32("toIIvSwDzwMxIp",14) == 3564508927) strcat(s, "K");
if (crc32("JFpXpNiQRdRwJPC",15) == 4021664974) strcat(s, "y");
if (crc32("tmiTCpVVJV",10) == 568647911) strcat(s, "p");
if (crc32("lFZzFxDPYoLdgNj",15) == 1901932535) strcat(s, "c");
if (crc32("xrWyCnmA",8) == 3937946282) strcat(s, "O");
if (crc32("UdBHliMvVsm",11) == 1652877360) strcat(s, "e");
if (crc32("NePpjrWqPTywo",13) == 4007293556) strcat(s, "G");
if (crc32("ZvvZJNxtwHflOJ",14) == 1466307811) strcat(s, "r");
if (crc32("bDJeB",5) == 403515066) strcat(s, "B");
if (crc32("rnpdexpL",8) == 822208740) strcat(s, "i");
if (crc32("xUwUmEGes",9) == 2885927154) strcat(s, "n");
    return s;
}

char *louis_nouns() {
    char *s = calloc(6);
    if (crc32("QujrFDGlBpZ",11) == 440482922) strcat(s, "l");
if (crc32("PAezIndKQmIn",12) == 4032188587) strcat(s, "b");
if (crc32("bQmuFz",6) == 2080906317) strcat(s, "o");
if (crc32("NlZkqxre",8) == 1475898147) strcat(s, "W");
if (crc32("VKHGCtOGXqAMTY",14) == 2266807396) strcat(s, "u");
if (crc32("FaYMI",5) == 282281417) strcat(s, "I");
if (crc32("VAJJGGshEsSTDo",14) == 3325794550) strcat(s, "i");
if (crc32("cYziwHhMeWWDTG",14) == 3799206647) strcat(s, "B");
if (crc32("dSeLhdwJsMoG",12) == 3442674121) strcat(s, "s");
    return s;
}

char *Aggie_nouns() {
    char *s = calloc(6);
    if (crc32("kszLmxsA",8) == 2499706840) strcat(s, "A");
if (crc32("AWaNtrWDMUNtCM",14) == 944946819) strcat(s, "g");
if (crc32("TKrApEtjlQcO",12) == 1731234515) strcat(s, "Q");
if (crc32("tGLesvjfhhlaym",14) == 2031670340) strcat(s, "g");
if (crc32("VywBRQptS",9) == 3819160491) strcat(s, "i");
if (crc32("GmWycDcy",8) == 1885015876) strcat(s, "e");
    return s;
}

char *marquetry_nouns() {
    char *s = calloc(10);
    if (crc32("eYnGwHTIWnoYugc",15) == 152564677) strcat(s, "m");
if (crc32("YmaaKM",6) == 2857720148) strcat(s, "B");
if (crc32("yKmGdKhFgJtvqqh",15) == 2834061000) strcat(s, "a");
if (crc32("ItgfvaeWKd",10) == 1532148242) strcat(s, "r");
if (crc32("yQnSqjOLOZqT",12) == 733513629) strcat(s, "q");
if (crc32("NYxfDhsUQgMEy",13) == 2851211511) strcat(s, "I");
if (crc32("cRFMCgsBfUX",11) == 18556923) strcat(s, "u");
if (crc32("hmDJdOdMr",9) == 2008620201) strcat(s, "d");
if (crc32("tEFgGADH",8) == 848403489) strcat(s, "e");
if (crc32("mgBdVCCwkLxi",12) == 1304219675) strcat(s, "t");
if (crc32("jeQKgACOqrhhRch",15) == 1239455775) strcat(s, "r");
if (crc32("UheBiPBaIUgyN",13) == 2497579238) strcat(s, "K");
if (crc32("HrVXIEH",7) == 2680852769) strcat(s, "y");
    return s;
}

char *Haim_nouns() {
    char *s = calloc(5);
    if (crc32("HPFQubgjABLHb",13) == 3309063947) strcat(s, "H");
if (crc32("pKAsXmrkp",9) == 1304550616) strcat(s, "a");
if (crc32("VZGCGihYrB",10) == 2015113074) strcat(s, "i");
if (crc32("ViZFhb",6) == 554213402) strcat(s, "m");
    return s;
}

char *multiprogramming_nouns() {
    char *s = calloc(17);
    if (crc32("TxQmyXhJUWeksmH",15) == 1004242853) strcat(s, "m");
if (crc32("gnRiDbGIjNul",12) == 1579529267) strcat(s, "E");
if (crc32("MXFNNDx",7) == 1155141759) strcat(s, "u");
if (crc32("YKZwOIwsSehBw",13) == 3387858853) strcat(s, "Y");
if (crc32("ZDKSenShYQb",11) == 3901351080) strcat(s, "l");
if (crc32("ZwJJCMBRY",9) == 2055267755) strcat(s, "T");
if (crc32("zgEsfH",6) == 2176081884) strcat(s, "t");
if (crc32("fymPtVxr",8) == 1769450321) strcat(s, "R");
if (crc32("KvAZNCpglHY",11) == 3250021720) strcat(s, "i");
if (crc32("MRileRCQiq",10) == 2762373868) strcat(s, "l");
if (crc32("xBcpIkcnOISpg",13) == 3575136653) strcat(s, "p");
if (crc32("RdGvo",5) == 2461301196) strcat(s, "a");
if (crc32("mywOLYxGZScD",12) == 1829709625) strcat(s, "r");
if (crc32("MwHvxaMHNuErq",13) == 1414409338) strcat(s, "o");
if (crc32("dxZYhiCV",8) == 838256280) strcat(s, "o");
if (crc32("tdhomt",6) == 2011286727) strcat(s, "g");
if (crc32("gwbfRqalDdsQ",12) == 2345510573) strcat(s, "r");
if (crc32("KXpvLTzFomxtoqd",15) == 2613354946) strcat(s, "a");
if (crc32("HnpQOJAJwb",10) == 1893566896) strcat(s, "l");
if (crc32("DOrTWRC",7) == 451938878) strcat(s, "m");
if (crc32("dARRTybzkLlNXrx",15) == 4037338220) strcat(s, "M");
if (crc32("alFWcRwRVFp",11) == 2358530935) strcat(s, "m");
if (crc32("MgcPqYwpR",9) == 1641363892) strcat(s, "J");
if (crc32("MannLFeFmJYM",12) == 519704421) strcat(s, "i");
if (crc32("iuXjMXW",7) == 2071647439) strcat(s, "n");
if (crc32("iwAvnltzIZl",11) == 2180689390) strcat(s, "s");
if (crc32("UzmpW",5) == 2825654924) strcat(s, "g");
    return s;
}

char *judogi_nouns() {
    char *s = calloc(7);
    if (crc32("tZBIdMLpY",9) == 900195298) strcat(s, "j");
if (crc32("yifQoOuR",8) == 2478390346) strcat(s, "k");
if (crc32("nirjoqgblDwq",12) == 1578516000) strcat(s, "u");
if (crc32("jBAvzRusvZyJAK",14) == 2812312243) strcat(s, "d");
if (crc32("nzxZtlOl",8) == 3802888325) strcat(s, "r");
if (crc32("sNCuZsNVTgfeyb",14) == 1648463443) strcat(s, "o");
if (crc32("ZAJiLPbDpPvsD",13) == 2081603787) strcat(s, "g");
if (crc32("jZvGspMlUPXwt",13) == 3602256867) strcat(s, "i");
    return s;
}

char *Komsomolsk_nouns() {
    char *s = calloc(11);
    if (crc32("kxXygHzTN",9) == 419084517) strcat(s, "K");
if (crc32("DpNuNxvbigzZio",14) == 3550433114) strcat(s, "J");
if (crc32("PCkyF",5) == 1381027294) strcat(s, "o");
if (crc32("aDMrZNgxT",9) == 2900408063) strcat(s, "m");
if (crc32("XpbLyYGy",8) == 873272923) strcat(s, "s");
if (crc32("UieEgZFwuDL",11) == 2676319314) strcat(s, "x");
if (crc32("TuJtZLWhWb",10) == 1064639102) strcat(s, "o");
if (crc32("dlRANrVY",8) == 2343046926) strcat(s, "m");
if (crc32("pIcYzEow",8) == 4250219065) strcat(s, "o");
if (crc32("RYHSKWksWjoGzc",14) == 2206113365) strcat(s, "r");
if (crc32("vTgTddeQDcfjkh",14) == 2392078148) strcat(s, "l");
if (crc32("EdznjXMHckZq",12) == 1890152563) strcat(s, "J");
if (crc32("eKNVMKJFxo",10) == 3525410876) strcat(s, "s");
if (crc32("aunmp",5) == 4237196210) strcat(s, "k");
    return s;
}

char *loller_nouns() {
    char *s = calloc(7);
    if (crc32("WJpiPGs",7) == 588576967) strcat(s, "a");
if (crc32("rzQXcVqqp",9) == 1666546739) strcat(s, "l");
if (crc32("rtezqvAp",8) == 1119029080) strcat(s, "o");
if (crc32("QBNQhMqkcZs",11) == 669453620) strcat(s, "l");
if (crc32("lFOrh",5) == 4198257069) strcat(s, "i");
if (crc32("xyJyGekmfAHebN",14) == 176708048) strcat(s, "l");
if (crc32("PLFszp",6) == 1297231284) strcat(s, "e");
if (crc32("YwlGSpWfSoAar",13) == 2309651844) strcat(s, "i");
if (crc32("dgXuzONFSMjd",12) == 547128331) strcat(s, "r");
    return s;
}

char *lapin_nouns() {
    char *s = calloc(6);
    if (crc32("DjWLHBnCsEOkE",13) == 3494953524) strcat(s, "l");
if (crc32("PGWFevOhEQNwEI",14) == 522387618) strcat(s, "e");
if (crc32("IIOHDyKBRId",11) == 3648385084) strcat(s, "a");
if (crc32("jvYOfgEhwLrHtP",14) == 1318000760) strcat(s, "n");
if (crc32("UqIBTXI",7) == 1591133568) strcat(s, "p");
if (crc32("iynLeDOnGKowQ",13) == 2080338970) strcat(s, "T");
if (crc32("HcJmG",5) == 3268703671) strcat(s, "i");
if (crc32("PmLLRf",6) == 2376305384) strcat(s, "b");
if (crc32("HpTxBCiXZZRuDkL",15) == 3831735570) strcat(s, "n");
    return s;
}

char *Neve_nouns() {
    char *s = calloc(5);
    if (crc32("vKHWYlpzlwLaBQo",15) == 513347206) strcat(s, "N");
if (crc32("VWFrSrhGjjeka",13) == 4081832821) strcat(s, "x");
if (crc32("AUtQKCcul",9) == 395090448) strcat(s, "e");
if (crc32("fsVejLom",8) == 2868181786) strcat(s, "B");
if (crc32("fcEGtPAmEXmiT",13) == 2369043167) strcat(s, "v");
if (crc32("KFtLFNIXm",9) == 2815656480) strcat(s, "e");
    return s;
}

char *bombora_nouns() {
    char *s = calloc(8);
    if (crc32("lQoSNshc",8) == 3040258112) strcat(s, "b");
if (crc32("vyAdOuyPJXlsUeN",15) == 3519636343) strcat(s, "q");
if (crc32("dRPpBql",7) == 4055977289) strcat(s, "o");
if (crc32("HzlnIKiWSGfBI",13) == 1113698765) strcat(s, "m");
if (crc32("olvEbgsVpICa",12) == 2984195984) strcat(s, "Y");
if (crc32("WNVKJfsgpGMGSSL",15) == 2205833028) strcat(s, "b");
if (crc32("QfsCASUKztVcf",13) == 1686547660) strcat(s, "Y");
if (crc32("QLLpGlUwcaqfzC",14) == 4195712164) strcat(s, "o");
if (crc32("OJIBIrrWo",9) == 657179867) strcat(s, "r");
if (crc32("LRwoX",5) == 3964556551) strcat(s, "a");
    return s;
}

char *Coppelia_nouns() {
    char *s = calloc(9);
    if (crc32("rxXEBVcMHS",10) == 3814785023) strcat(s, "K");
if (crc32("xtvjRSGkXSE",11) == 3749548936) strcat(s, "C");
if (crc32("uckbhRsFUt",10) == 694604580) strcat(s, "d");
if (crc32("hbWIRahyHYae",12) == 580832690) strcat(s, "o");
if (crc32("vkWJgmPf",8) == 345559287) strcat(s, "N");
if (crc32("uFpEjDEEGX",10) == 3759055612) strcat(s, "p");
if (crc32("tIxUyNrRtxpmV",13) == 2084747870) strcat(s, "J");
if (crc32("HuinvS",6) == 3969631872) strcat(s, "p");
if (crc32("cuQynKitgjojvO",14) == 2194278920) strcat(s, "O");
if (crc32("UDaBedoQ",8) == 2484393648) strcat(s, "e");
if (crc32("nsnMtyWPCpoc",12) == 4014003582) strcat(s, "k");
if (crc32("sNvyu",5) == 2373259746) strcat(s, "l");
if (crc32("CeqUfda",7) == 4289286243) strcat(s, "i");
if (crc32("UmCEKyJCr",9) == 2652033864) strcat(s, "a");
    return s;
}

char *corrobboree_nouns() {
    char *s = calloc(12);
    if (crc32("GbGVKEhlhSwuBkm",15) == 2071289889) strcat(s, "L");
if (crc32("CjIgNoN",7) == 3153580561) strcat(s, "c");
if (crc32("QByBnEn",7) == 1349214820) strcat(s, "k");
if (crc32("mwBCnrTGXGtx",12) == 3403300961) strcat(s, "o");
if (crc32("xgWWZdED",8) == 2182017697) strcat(s, "N");
if (crc32("blyvKCWfgmsGOMB",15) == 151999263) strcat(s, "r");
if (crc32("TXxGSPIKkYba",12) == 3296993895) strcat(s, "r");
if (crc32("pKXpBrqr",8) == 2016833792) strcat(s, "o");
if (crc32("CgTumkamJg",10) == 3243840729) strcat(s, "v");
if (crc32("UDwTZbHbJWiYq",13) == 1205663399) strcat(s, "b");
if (crc32("mCPLrXKmUQeuso",14) == 2130835232) strcat(s, "M");
if (crc32("BiykxCxjI",9) == 1224339954) strcat(s, "b");
if (crc32("NnKgFGKMNmzhCrk",15) == 3491765186) strcat(s, "z");
if (crc32("oexuFcefgfqgs",13) == 3046383944) strcat(s, "o");
if (crc32("doxHWAbheU",10) == 276161805) strcat(s, "r");
if (crc32("JinVQIHpy",9) == 1113302357) strcat(s, "R");
if (crc32("XfzWVS",6) == 882846597) strcat(s, "e");
if (crc32("AOanXclIb",9) == 75902444) strcat(s, "h");
if (crc32("ecMweIlkm",9) == 3731565722) strcat(s, "e");
    return s;
}

char *Turanian_nouns() {
    char *s = calloc(9);
    if (crc32("CmJvycgP",8) == 3983621596) strcat(s, "T");
if (crc32("MhsXi",5) == 1642137871) strcat(s, "M");
if (crc32("hvBnFUrOhWHj",12) == 1291980088) strcat(s, "u");
if (crc32("iFCywv",6) == 488879696) strcat(s, "D");
if (crc32("DKvjsPoqXR",10) == 422669272) strcat(s, "r");
if (crc32("nxqGxQlsiMUgEk",14) == 3901206284) strcat(s, "w");
if (crc32("GYgUzPKGwWuZR",13) == 2790521592) strcat(s, "a");
if (crc32("XJNfzDNvCbAfWq",14) == 1381417988) strcat(s, "w");
if (crc32("RaqUw",5) == 1542829113) strcat(s, "n");
if (crc32("uLqwqb",6) == 1619753334) strcat(s, "i");
if (crc32("BaMslnoSXljQ",12) == 2188093542) strcat(s, "a");
if (crc32("lxfeGKmZI",9) == 3245441) strcat(s, "R");
if (crc32("HRmHEC",6) == 3305434565) strcat(s, "n");
    return s;
}

char *Chavez_nouns() {
    char *s = calloc(7);
    if (crc32("fnuCrkWN",8) == 230233300) strcat(s, "C");
if (crc32("YoJMjGZW",8) == 1937338038) strcat(s, "h");
if (crc32("vlONpIi",7) == 2377011256) strcat(s, "h");
if (crc32("EMatY",5) == 1690868429) strcat(s, "F");
if (crc32("FwpddFPpKWJYq",13) == 3940915232) strcat(s, "a");
if (crc32("PNeKZqHgL",9) == 2653036762) strcat(s, "v");
if (crc32("mHvhxpLuyF",10) == 2970273651) strcat(s, "M");
if (crc32("aLYFxYln",8) == 2824757551) strcat(s, "e");
if (crc32("ViHczGrUta",10) == 1652413757) strcat(s, "u");
if (crc32("iiLnSRZDjCFgb",13) == 3356597396) strcat(s, "z");
    return s;
}

char *Amb_nouns() {
    char *s = calloc(4);
    if (crc32("XWdqqveLXX",10) == 2508341679) strcat(s, "A");
if (crc32("oRXeTC",6) == 515660745) strcat(s, "K");
if (crc32("edfQpG",6) == 838709082) strcat(s, "m");
if (crc32("PVpdzZo",7) == 4218302270) strcat(s, "x");
if (crc32("XvBmOYdgRTmJgs",14) == 3895767190) strcat(s, "b");
    return s;
}

char *Letchworth_nouns() {
    char *s = calloc(11);
    if (crc32("xwEhFC",6) == 1918363555) strcat(s, "p");
if (crc32("BFaNB",5) == 3847428341) strcat(s, "L");
if (crc32("YWbYWmH",7) == 2935671597) strcat(s, "e");
if (crc32("BcWWrF",6) == 159001786) strcat(s, "q");
if (crc32("RYcLVVNZfqAgF",13) == 2689265436) strcat(s, "t");
if (crc32("OlNYZEcpEUL",11) == 426731739) strcat(s, "Q");
if (crc32("yxIio",5) == 2316494776) strcat(s, "c");
if (crc32("TSYpvWYXEFGCg",13) == 2716414078) strcat(s, "h");
if (crc32("GIWeYw",6) == 1323681361) strcat(s, "j");
if (crc32("pLpsTzDjb",9) == 2338988075) strcat(s, "w");
if (crc32("dlEeCb",6) == 3831221205) strcat(s, "o");
if (crc32("EJZfEIMcdJZEyl",14) == 369378233) strcat(s, "r");
if (crc32("PULVzClGYakX",12) == 635531134) strcat(s, "c");
if (crc32("MNNWxsCyQTOOsm",14) == 2683806378) strcat(s, "t");
if (crc32("KSGHUS",6) == 3859479476) strcat(s, "h");
    return s;
}

char *Panini_nouns() {
    char *s = calloc(7);
    if (crc32("NqwLaAcAbcFTiq",14) == 653692798) strcat(s, "P");
if (crc32("DosPo",5) == 957684053) strcat(s, "a");
if (crc32("BsQHLnhqXBou",12) == 3141387724) strcat(s, "C");
if (crc32("XHeSivnd",8) == 343697653) strcat(s, "n");
if (crc32("MJJUnw",6) == 3146124877) strcat(s, "i");
if (crc32("vzIKfbL",7) == 372597423) strcat(s, "B");
if (crc32("SbrICluEPHQ",11) == 1746076091) strcat(s, "n");
if (crc32("zoeizKS",7) == 1544717989) strcat(s, "Y");
if (crc32("tZsoQTPXdrb",11) == 2664690563) strcat(s, "i");
    return s;
}

char *Alesia_nouns() {
    char *s = calloc(7);
    if (crc32("LTRmpYUYS",9) == 3008911220) strcat(s, "A");
if (crc32("JYibgEkTIC",10) == 2876249277) strcat(s, "l");
if (crc32("skjlWnvtxHP",11) == 3284822073) strcat(s, "U");
if (crc32("EVMqDPOgAUT",11) == 767493540) strcat(s, "e");
if (crc32("PJdpl",5) == 2857749573) strcat(s, "s");
if (crc32("ikjJkNjsh",9) == 2371830246) strcat(s, "s");
if (crc32("EJrihzm",7) == 3545790705) strcat(s, "S");
if (crc32("FTZqXlhIiAEgk",13) == 1094462914) strcat(s, "i");
if (crc32("RFfopOlpuKrV",12) == 1259628099) strcat(s, "t");
if (crc32("FJKNqS",6) == 2295807797) strcat(s, "a");
    return s;
}

char *Kursh_nouns() {
    char *s = calloc(6);
    if (crc32("DkaSLzIGtq",10) == 2431762441) strcat(s, "K");
if (crc32("CZCEdmwmeNcZYw",14) == 670873986) strcat(s, "o");
if (crc32("uLdrWGywbENZ",12) == 2795343814) strcat(s, "u");
if (crc32("dlntOJcS",8) == 1576246665) strcat(s, "H");
if (crc32("LALMoseMChlBFM",14) == 711091154) strcat(s, "r");
if (crc32("YsfPXNbhzL",10) == 549138186) strcat(s, "s");
if (crc32("nXPACRWyeDBSwhZ",15) == 1477406566) strcat(s, "h");
    return s;
}

char *actinia_nouns() {
    char *s = calloc(8);
    if (crc32("OHxhhNnTUcqgAzK",15) == 34099977) strcat(s, "a");
if (crc32("MLISNpI",7) == 1235850591) strcat(s, "P");
if (crc32("fdxDJCercC",10) == 3121975156) strcat(s, "c");
if (crc32("yGeCkjH",7) == 2368016882) strcat(s, "t");
if (crc32("YUUJPRballrM",12) == 2254518162) strcat(s, "k");
if (crc32("cKmLblqzsOpqd",13) == 2718065089) strcat(s, "i");
if (crc32("cdfgRBb",7) == 169827888) strcat(s, "n");
if (crc32("OLoJEGeDzSxBZo",14) == 4033445483) strcat(s, "i");
if (crc32("lMFqo",5) == 203556118) strcat(s, "v");
if (crc32("jyGcutacLOlQJx",14) == 3459418421) strcat(s, "a");
    return s;
}

char *manakin_nouns() {
    char *s = calloc(8);
    if (crc32("xCtTQXlzsUKEDL",14) == 463413516) strcat(s, "m");
if (crc32("KDFyVu",6) == 2054426026) strcat(s, "S");
if (crc32("kMdrg",5) == 3233791442) strcat(s, "a");
if (crc32("FSZSmhSL",8) == 725602249) strcat(s, "n");
if (crc32("iybKEWGrUfRn",12) == 1188699223) strcat(s, "a");
if (crc32("yPBudMUvSCx",11) == 897715346) strcat(s, "a");
if (crc32("CCOGUTWDiMCLhmq",15) == 1066759828) strcat(s, "k");
if (crc32("MsMVKfnRdcPS",12) == 2187718077) strcat(s, "i");
if (crc32("IhygdkIDQzkmUg",14) == 812000360) strcat(s, "e");
if (crc32("lhiHQtzCVmrPRE",14) == 3510487464) strcat(s, "n");
    return s;
}

char *polariscope_nouns() {
    char *s = calloc(12);
    if (crc32("kOsCROagoXfjk",13) == 1043204371) strcat(s, "p");
if (crc32("oWoUPaHnBDDrXe",14) == 1715770300) strcat(s, "r");
if (crc32("TxBBTh",6) == 818083950) strcat(s, "o");
if (crc32("qvFsNhHvSKmUMDy",15) == 1380167844) strcat(s, "l");
if (crc32("jYCGiqmvjes",11) == 611144718) strcat(s, "W");
if (crc32("FSnKoCz",7) == 1924529037) strcat(s, "a");
if (crc32("XHAlLrStPyRdyl",14) == 642346608) strcat(s, "I");
if (crc32("sAXosCp",7) == 841487533) strcat(s, "r");
if (crc32("kIpDwltqvP",10) == 1294860106) strcat(s, "i");
if (crc32("TrNhMesbRy",10) == 4243585948) strcat(s, "p");
if (crc32("MPwlFaytJCOZ",12) == 2600712153) strcat(s, "s");
if (crc32("sYzXmCOxWBXnMSt",15) == 2698855797) strcat(s, "C");
if (crc32("owmnUfH",7) == 1832453151) strcat(s, "c");
if (crc32("AzvIBwESThaDOet",15) == 1561612666) strcat(s, "b");
if (crc32("MdDQFqUevMHlK",13) == 1128472837) strcat(s, "o");
if (crc32("fHHkJLiccFoV",12) == 1947997969) strcat(s, "p");
if (crc32("TbecNeB",7) == 2064824789) strcat(s, "z");
if (crc32("CeJPr",5) == 2889127911) strcat(s, "e");
    return s;
}

char *buttonmould_nouns() {
    char *s = calloc(12);
    if (crc32("pfZFlDUuwhEz",12) == 2868766225) strcat(s, "O");
if (crc32("doAcryBLnGuw",12) == 4247276922) strcat(s, "b");
if (crc32("MSKgP",5) == 2195784988) strcat(s, "u");
if (crc32("pYLLattbblcQ",12) == 355850282) strcat(s, "t");
if (crc32("VamRm",5) == 157951824) strcat(s, "t");
if (crc32("GNrUeTbYvuv",11) == 1998625948) strcat(s, "o");
if (crc32("XtbqskAbaOGTA",13) == 1150365358) strcat(s, "n");
if (crc32("vgjvnBJTYJsrL",13) == 2456813508) strcat(s, "f");
if (crc32("wvRPm",5) == 621055725) strcat(s, "m");
if (crc32("dNLtsltyhKndD",13) == 1096658486) strcat(s, "k");
if (crc32("voXzgCHZyNJZA",13) == 2598332160) strcat(s, "o");
if (crc32("fQCZxZaeZaUNnI",14) == 278391748) strcat(s, "u");
if (crc32("KhHeDtktXq",10) == 867771786) strcat(s, "l");
if (crc32("XpxGJoYFLfXT",12) == 638106801) strcat(s, "l");
if (crc32("wdwCV",5) == 829832516) strcat(s, "d");
    return s;
}

char *Newlin_nouns() {
    char *s = calloc(7);
    if (crc32("LSGnpzolO",9) == 4108847766) strcat(s, "w");
if (crc32("kcfrLO",6) == 4277410638) strcat(s, "N");
if (crc32("MHJyDPtNAaH",11) == 3179275613) strcat(s, "e");
if (crc32("ZeQtjToBF",9) == 100232811) strcat(s, "w");
if (crc32("eMcPo",5) == 3152764261) strcat(s, "K");
if (crc32("GiBsBdKESmMRhe",14) == 1127722350) strcat(s, "l");
if (crc32("GnSdl",5) == 161109538) strcat(s, "Y");
if (crc32("BhZAWokOKCSv",12) == 2800834897) strcat(s, "i");
if (crc32("yMnNK",5) == 2518936058) strcat(s, "n");
    return s;
}

char *phagomania_nouns() {
    char *s = calloc(11);
    if (crc32("PnekXkiVRBvQm",13) == 2330507398) strcat(s, "n");
if (crc32("LlyQncMr",8) == 351027257) strcat(s, "p");
if (crc32("GmMtMfaMrjYGakF",15) == 3921507958) strcat(s, "h");
if (crc32("YexhvfqYamUlK",13) == 4102917962) strcat(s, "l");
if (crc32("oGdiR",5) == 2768762063) strcat(s, "a");
if (crc32("hJEHmRRc",8) == 1258495027) strcat(s, "g");
if (crc32("wKHeYAZ",7) == 3036023900) strcat(s, "o");
if (crc32("gkEVIXNxHf",10) == 4022687025) strcat(s, "k");
if (crc32("JQvFtRaW",8) == 1352266718) strcat(s, "m");
if (crc32("woaLuVGL",8) == 477344372) strcat(s, "h");
if (crc32("ucNpmZvRSycN",12) == 1880482544) strcat(s, "a");
if (crc32("fftcUCB",7) == 4140892777) strcat(s, "O");
if (crc32("arvEyhzutCNk",12) == 3018369413) strcat(s, "n");
if (crc32("JLTWBZOJ",8) == 4062611439) strcat(s, "i");
if (crc32("UahCKx",6) == 2295260591) strcat(s, "a");
    return s;
}

char *Ebony_nouns() {
    char *s = calloc(6);
    if (crc32("yfensJiJaoaxxga",15) == 1084535308) strcat(s, "U");
if (crc32("fDNPtYuXZMoMGcp",15) == 2388709947) strcat(s, "E");
if (crc32("MbuRbBU",7) == 1067932338) strcat(s, "b");
if (crc32("hSAlYKJQvA",10) == 646960748) strcat(s, "o");
if (crc32("aROdrLPJPf",10) == 2110542192) strcat(s, "n");
if (crc32("XYKXZv",6) == 3012839264) strcat(s, "y");
    return s;
}

char *quizzer_nouns() {
    char *s = calloc(8);
    if (crc32("yzWKrBhtgaXJ",12) == 120545132) strcat(s, "q");
if (crc32("MzJTvUYuhYj",11) == 748416652) strcat(s, "O");
if (crc32("xujIYZvwwgTpNZP",15) == 2867622459) strcat(s, "u");
if (crc32("RvlqBsth",8) == 1622714683) strcat(s, "V");
if (crc32("VuWIP",5) == 246612053) strcat(s, "i");
if (crc32("ZnkKSYKtAW",10) == 2919877615) strcat(s, "z");
if (crc32("YEdhCjBVEABr",12) == 1634236503) strcat(s, "X");
if (crc32("mzlqDMHQM",9) == 3952407769) strcat(s, "z");
if (crc32("XFzvFZdONqh",11) == 657365120) strcat(s, "C");
if (crc32("EIjPVBWpFcRDxxm",15) == 145353860) strcat(s, "e");
if (crc32("XtZbhXgk",8) == 3653249482) strcat(s, "r");
    return s;
}

char *Kirt_nouns() {
    char *s = calloc(5);
    if (crc32("dmeyHPzrzxjWS",13) == 1035176900) strcat(s, "K");
if (crc32("VqFcfu",6) == 428607195) strcat(s, "p");
if (crc32("bqweux",6) == 2217616350) strcat(s, "i");
if (crc32("eiLVs",5) == 765038579) strcat(s, "s");
if (crc32("VPIBvPrLzefXB",13) == 1638463860) strcat(s, "r");
if (crc32("XLuMSFZJ",8) == 1790931482) strcat(s, "H");
if (crc32("BpNMPKvUXshr",12) == 2206339689) strcat(s, "t");
    return s;
}

char *Adallard_nouns() {
    char *s = calloc(9);
    if (crc32("fzMSxRTAwZsbv",13) == 945691152) strcat(s, "A");
if (crc32("dNwXvVZkJkB",11) == 3838825085) strcat(s, "H");
if (crc32("fOZrrMcLUHUQIW",14) == 1043114233) strcat(s, "d");
if (crc32("gwUqJqz",7) == 500420525) strcat(s, "a");
if (crc32("zAbyMZgBkGxLuVF",15) == 4290959282) strcat(s, "l");
if (crc32("xWwrQIaPt",9) == 3659363705) strcat(s, "l");
if (crc32("RJgskPPS",8) == 4053510064) strcat(s, "a");
if (crc32("RpLmBqttD",9) == 2499665619) strcat(s, "w");
if (crc32("rgYOIE",6) == 921988530) strcat(s, "r");
if (crc32("CSDorraM",8) == 3178164809) strcat(s, "d");
    return s;
}

char *isomorphism_nouns() {
    char *s = calloc(12);
    if (crc32("WADsbGqGEThT",12) == 1159530276) strcat(s, "i");
if (crc32("ftxTcOpEZ",9) == 3464598931) strcat(s, "c");
if (crc32("meHExb",6) == 953256297) strcat(s, "s");
if (crc32("wAMBcAnFI",9) == 3482819924) strcat(s, "v");
if (crc32("IWdVuzbS",8) == 832180978) strcat(s, "o");
if (crc32("BixPuTPUsuBtTS",14) == 1261634439) strcat(s, "m");
if (crc32("vDCbJqGmieHUoCh",15) == 3134065854) strcat(s, "o");
if (crc32("DcmowekFQL",10) == 606789169) strcat(s, "r");
if (crc32("XuxCw",5) == 3715621384) strcat(s, "p");
if (crc32("BVbetDiC",8) == 1626250551) strcat(s, "I");
if (crc32("iZvQDtqYqjb",11) == 3485487107) strcat(s, "h");
if (crc32("JQxmEoWyRSoCER",14) == 3581032553) strcat(s, "i");
if (crc32("YKRXw",5) == 2035278705) strcat(s, "M");
if (crc32("dOFiifaPnB",10) == 2121451210) strcat(s, "s");
if (crc32("cRbEiRWbXfyub",13) == 250852021) strcat(s, "T");
if (crc32("NDXaSfZlEpJMcBG",15) == 333936298) strcat(s, "m");
    return s;
}

char *Dirk_nouns() {
    char *s = calloc(5);
    if (crc32("iKCfVOweXsIZX",13) == 3558707055) strcat(s, "U");
if (crc32("mAZORSHrRVsY",12) == 256171392) strcat(s, "D");
if (crc32("cSPSwyjhP",9) == 793502560) strcat(s, "i");
if (crc32("WVSfNXa",7) == 1377905662) strcat(s, "s");
if (crc32("GZmRbyf",7) == 2685194833) strcat(s, "r");
if (crc32("pbFuIWr",7) == 268458040) strcat(s, "U");
if (crc32("JjuhrVZ",7) == 737318688) strcat(s, "k");
    return s;
}

char *immitigability_nouns() {
    char *s = calloc(15);
    if (crc32("tNJpY",5) == 3306037074) strcat(s, "Q");
if (crc32("qTnrslnjSEd",11) == 3875832578) strcat(s, "i");
if (crc32("cZsPtbCxOhFM",12) == 2391053549) strcat(s, "m");
if (crc32("spTahjWZWXc",11) == 1128211864) strcat(s, "J");
if (crc32("hslDAOcvePPzEhB",15) == 3067487997) strcat(s, "m");
if (crc32("uYFGkNsTjVnd",12) == 3104032931) strcat(s, "i");
if (crc32("rFEIpXjuKglhf",13) == 210833793) strcat(s, "t");
if (crc32("INtLAs",6) == 218822006) strcat(s, "M");
if (crc32("dGjJNYdLbXOmwyW",15) == 3737668339) strcat(s, "i");
if (crc32("wNEyuehmC",9) == 1574718285) strcat(s, "n");
if (crc32("EPfdrIhN",8) == 396924157) strcat(s, "g");
if (crc32("gIzbFREZS",9) == 2536345674) strcat(s, "a");
if (crc32("GLgjAgv",7) == 4182846522) strcat(s, "b");
if (crc32("ogmFQjI",7) == 3620886035) strcat(s, "i");
if (crc32("LmiDkWal",8) == 3469720151) strcat(s, "l");
if (crc32("VcWMDkeOjuxkxB",14) == 2252048264) strcat(s, "i");
if (crc32("MuNPWBhnkFTVq",13) == 1945177148) strcat(s, "t");
if (crc32("tTUfc",5) == 2124582908) strcat(s, "s");
if (crc32("BqDOxPlnZTkysc",14) == 2901603322) strcat(s, "y");
    return s;
}

char *BCL_nouns() {
    char *s = calloc(4);
    if (crc32("oZdnOrfoy",9) == 1883315684) strcat(s, "B");
if (crc32("gHhNxB",6) == 3378287055) strcat(s, "o");
if (crc32("KYUzWbSvV",9) == 2776112933) strcat(s, "C");
if (crc32("KBrdhzENNYDm",12) == 197334267) strcat(s, "L");
    return s;
}

char *pesthouse_nouns() {
    char *s = calloc(10);
    if (crc32("etfJeRWHkQJ",11) == 1090171916) strcat(s, "C");
if (crc32("KrFKgwVOiv",10) == 880871618) strcat(s, "p");
if (crc32("CQENQ",5) == 2737871472) strcat(s, "x");
if (crc32("AubDZEHkZQSUsad",15) == 1040566264) strcat(s, "e");
if (crc32("YITFTDH",7) == 4148003739) strcat(s, "s");
if (crc32("XZYuxnmMOLMqXaO",15) == 2865158162) strcat(s, "g");
if (crc32("xeCMgLRm",8) == 2387168025) strcat(s, "t");
if (crc32("GrRckr",6) == 857356532) strcat(s, "h");
if (crc32("bFAJftrspy",10) == 2700688592) strcat(s, "U");
if (crc32("RqtjgurtSh",10) == 3667753583) strcat(s, "o");
if (crc32("xdxQZolX",8) == 3434072795) strcat(s, "u");
if (crc32("zJjeqoNeP",9) == 106684982) strcat(s, "d");
if (crc32("XOcFEOIelrLphG",14) == 2487941591) strcat(s, "s");
if (crc32("jSFLvHZ",7) == 2754323632) strcat(s, "K");
if (crc32("wrXumLdOs",9) == 2520273716) strcat(s, "e");
    return s;
}

char *Baelbeer_nouns() {
    char *s = calloc(9);
    if (crc32("wsChJqlV",8) == 1115613725) strcat(s, "L");
if (crc32("qlTTJbCyweDTRRV",15) == 1890592661) strcat(s, "B");
if (crc32("YdVZYZvjqavjcl",14) == 3809134340) strcat(s, "A");
if (crc32("MSRxXZxhdtAZ",12) == 149583664) strcat(s, "a");
if (crc32("hTRGGUDuVpW",11) == 3505377680) strcat(s, "e");
if (crc32("OHIqiKFQ",8) == 1757281343) strcat(s, "Y");
if (crc32("cIXXYesaeQUolp",14) == 3298934310) strcat(s, "l");
if (crc32("haOXSkMhZo",10) == 1547575790) strcat(s, "b");
if (crc32("PhzoLLVsGdICI",13) == 1785597292) strcat(s, "e");
if (crc32("oNwoQDsTmyztx",13) == 2974799983) strcat(s, "e");
if (crc32("mMVCMOe",7) == 3095507053) strcat(s, "q");
if (crc32("pRwDmIMJSLTwBW",14) == 1426214360) strcat(s, "r");
    return s;
}

char *ptilosis_nouns() {
    char *s = calloc(9);
    if (crc32("qRfJCSoxeA",10) == 2055571521) strcat(s, "x");
if (crc32("CdlYEidgpbHURO",14) == 747120782) strcat(s, "p");
if (crc32("kycFNuiULk",10) == 1101524428) strcat(s, "t");
if (crc32("EHKjA",5) == 3935813884) strcat(s, "i");
if (crc32("EcbqD",5) == 1935977145) strcat(s, "l");
if (crc32("EFETe",5) == 3710313744) strcat(s, "P");
if (crc32("LDfHiNxvZU",10) == 3901258751) strcat(s, "o");
if (crc32("lNiVoaQXHexbSu",14) == 296896913) strcat(s, "s");
if (crc32("ZMJaYeKGw",9) == 2756905797) strcat(s, "i");
if (crc32("KJpCf",5) == 468688115) strcat(s, "h");
if (crc32("fXItiIARpKaBXf",14) == 429189951) strcat(s, "s");
    return s;
}

char *Hispaniola_nouns() {
    char *s = calloc(11);
    if (crc32("ZhFlDGlUTu",10) == 2828948942) strcat(s, "r");
if (crc32("eakIeeeiDfxbJfs",15) == 2375498083) strcat(s, "H");
if (crc32("RoVdzVpsyWYJv",13) == 2544882548) strcat(s, "l");
if (crc32("nDxuupuMgfbd",12) == 2271661051) strcat(s, "i");
if (crc32("ZVgCP",5) == 2806046878) strcat(s, "s");
if (crc32("InaikhSOx",9) == 81176869) strcat(s, "p");
if (crc32("ezrNlDjOHl",10) == 3706284945) strcat(s, "V");
if (crc32("opEeKwvkkb",10) == 2318988412) strcat(s, "a");
if (crc32("ibYmfgXClEZ",11) == 1097909680) strcat(s, "C");
if (crc32("EQvpqpcTXn",10) == 3682976434) strcat(s, "n");
if (crc32("APyUBFmccdC",11) == 394984608) strcat(s, "U");
if (crc32("sGUXeRrMHharGBk",15) == 2703661090) strcat(s, "i");
if (crc32("yyXCfXTkSEaigRi",15) == 427982947) strcat(s, "o");
if (crc32("fVcnekglKytFfiv",15) == 3918501932) strcat(s, "U");
if (crc32("kvXYj",5) == 3257229138) strcat(s, "l");
if (crc32("hnukYGdchl",10) == 3769289612) strcat(s, "G");
if (crc32("ywbSOXssbUGdb",13) == 660288884) strcat(s, "a");
    return s;
}

char *Leadbelly_nouns() {
    char *s = calloc(10);
    if (crc32("ZjkbAw",6) == 1327632457) strcat(s, "L");
if (crc32("IrkZmKriGDCkTY",14) == 1656407215) strcat(s, "o");
if (crc32("hgPHEl",6) == 49922592) strcat(s, "e");
if (crc32("JURpDBWuQ",9) == 3030527761) strcat(s, "a");
if (crc32("nbCsjdtQ",8) == 2691005028) strcat(s, "M");
if (crc32("KGEpHoXhkjqOt",13) == 390236828) strcat(s, "d");
if (crc32("aVoYiaz",7) == 1278075162) strcat(s, "b");
if (crc32("QBFbJIBgDQIuL",13) == 556231799) strcat(s, "Y");
if (crc32("uywcx",5) == 2694301707) strcat(s, "e");
if (crc32("KZsyEF",6) == 2531626798) strcat(s, "l");
if (crc32("AEkMHsf",7) == 1695665832) strcat(s, "x");
if (crc32("oMNWV",5) == 3116894457) strcat(s, "l");
if (crc32("kCVzYuMfJ",9) == 1287343441) strcat(s, "Y");
if (crc32("pqrEABlTwSiC",12) == 1098125636) strcat(s, "y");
    return s;
}

char *Alamosa_nouns() {
    char *s = calloc(8);
    if (crc32("AIOmHTReskeR",12) == 572187120) strcat(s, "A");
if (crc32("MoeVRKWTEKMK",12) == 3648520773) strcat(s, "l");
if (crc32("WaeQSjRHLjwmXn",14) == 2975374383) strcat(s, "t");
if (crc32("OxxzWrIrKIMHMGh",15) == 2515195533) strcat(s, "a");
if (crc32("dDlTwMMcOMGB",12) == 2466143266) strcat(s, "F");
if (crc32("TVlzjtOlh",9) == 2053745080) strcat(s, "m");
if (crc32("mZOQyetKf",9) == 3872150577) strcat(s, "o");
if (crc32("zDYshpWIk",9) == 1174252096) strcat(s, "s");
if (crc32("IwxwBcFfvwxS",12) == 1688333663) strcat(s, "a");
    return s;
}

char *houseparent_nouns() {
    char *s = calloc(12);
    if (crc32("ZvrMfusn",8) == 773262961) strcat(s, "Q");
if (crc32("UOPxqmWpPx",10) == 1890521775) strcat(s, "h");
if (crc32("AdWpxfnqXK",10) == 3428007654) strcat(s, "o");
if (crc32("sqIchfTW",8) == 1647833285) strcat(s, "u");
if (crc32("oeTtHHcWUWhhX",13) == 1380324559) strcat(s, "e");
if (crc32("wNYyFcyoLOt",11) == 909538830) strcat(s, "s");
if (crc32("dIcCimsjAS",10) == 195257212) strcat(s, "e");
if (crc32("YGqsdDOmWiagJV",14) == 3266059035) strcat(s, "p");
if (crc32("zidJAKiTGx",10) == 1502346873) strcat(s, "W");
if (crc32("FmwXC",5) == 349490313) strcat(s, "a");
if (crc32("zECjkSHCu",9) == 662079363) strcat(s, "C");
if (crc32("cvWJldXoxeNY",12) == 3173140968) strcat(s, "r");
if (crc32("vrAfHLmVJlvyS",13) == 45426330) strcat(s, "e");
if (crc32("ZCluVjxIRbNm",12) == 796528062) strcat(s, "U");
if (crc32("IGymDvGhyZxQNR",14) == 621037544) strcat(s, "n");
if (crc32("kkRog",5) == 1638629682) strcat(s, "I");
if (crc32("GvxSAPqLG",9) == 746696292) strcat(s, "t");
    return s;
}

char *snowshed_nouns() {
    char *s = calloc(9);
    if (crc32("nbJvAyeqqOO",11) == 1966148413) strcat(s, "T");
if (crc32("UbnNzwiHEJk",11) == 768612776) strcat(s, "s");
if (crc32("fVVmewoPd",9) == 3254161486) strcat(s, "H");
if (crc32("gGQov",5) == 3717126946) strcat(s, "n");
if (crc32("dxKWamDSwWVntNe",15) == 3989946787) strcat(s, "N");
if (crc32("SKnIdpZpnUuPuAU",15) == 2678955776) strcat(s, "o");
if (crc32("sxiACcgDAVJVH",13) == 1901125003) strcat(s, "w");
if (crc32("YkWIiaJnP",9) == 2180794722) strcat(s, "s");
if (crc32("jcinTkoRqNFkxS",14) == 2428365404) strcat(s, "h");
if (crc32("ofrbqYt",7) == 1159778893) strcat(s, "e");
if (crc32("TQRiDiYYBd",10) == 1650615915) strcat(s, "d");
    return s;
}

char *bogginess_nouns() {
    char *s = calloc(10);
    if (crc32("YgjIOERVH",9) == 1760603159) strcat(s, "b");
if (crc32("vNCLwNPMDIyQYrD",15) == 3412862336) strcat(s, "o");
if (crc32("cRPpphjlFE",10) == 722719978) strcat(s, "g");
if (crc32("GfDdMw",6) == 1123544691) strcat(s, "w");
if (crc32("EQkWABHvxmef",12) == 2767480721) strcat(s, "g");
if (crc32("ZhBRwMWOI",9) == 1451482431) strcat(s, "y");
if (crc32("CDcklBxGth",10) == 1288551231) strcat(s, "i");
if (crc32("vuadhqfQtAawV",13) == 2561345635) strcat(s, "U");
if (crc32("BYtazKEoeGJrck",14) == 1842111004) strcat(s, "n");
if (crc32("cpjIVLF",7) == 4146085507) strcat(s, "g");
if (crc32("qnBlu",5) == 1129334500) strcat(s, "e");
if (crc32("XtmKhtmdzQwIS",13) == 1924856252) strcat(s, "s");
if (crc32("iDioUGz",7) == 2238956000) strcat(s, "s");
    return s;
}

char *Jadotville_nouns() {
    char *s = calloc(11);
    if (crc32("vNfBRLZatleEyI",14) == 3866353114) strcat(s, "J");
if (crc32("iJeHiE",6) == 2171264430) strcat(s, "c");
if (crc32("MknfOxGvYqc",11) == 2906551750) strcat(s, "a");
if (crc32("TFXWfujYceL",11) == 3848399430) strcat(s, "x");
if (crc32("saOowNv",7) == 3162515885) strcat(s, "d");
if (crc32("dNcyMWZBgCsTrUY",15) == 3933716350) strcat(s, "o");
if (crc32("rVMWHLJ",7) == 2126064266) strcat(s, "t");
if (crc32("wLDZwazOhIdu",12) == 3692115290) strcat(s, "v");
if (crc32("EwbkolbzJCea",12) == 2948589897) strcat(s, "X");
if (crc32("zIyIGWDGJL",10) == 2657985918) strcat(s, "i");
if (crc32("hlIztCv",7) == 984113246) strcat(s, "l");
if (crc32("bHQRDl",6) == 1357195537) strcat(s, "l");
if (crc32("wjaWNytoB",9) == 3608274873) strcat(s, "e");
    return s;
}

char *Easterledges_nouns() {
    char *s = calloc(13);
    if (crc32("rHRMGHu",7) == 1126650317) strcat(s, "E");
if (crc32("lTXfQt",6) == 3041676902) strcat(s, "a");
if (crc32("mkylMYdDrNjkR",13) == 2416598969) strcat(s, "z");
if (crc32("FQibOntCg",9) == 3544145157) strcat(s, "s");
if (crc32("LAnlEDiXTHj",11) == 861622890) strcat(s, "t");
if (crc32("zTnyx",5) == 2513429229) strcat(s, "c");
if (crc32("cZbYdMlxSCq",11) == 2560735333) strcat(s, "e");
if (crc32("fubaYbk",7) == 2689280594) strcat(s, "r");
if (crc32("iaNuLqMJ",8) == 1993624025) strcat(s, "y");
if (crc32("uudcFdAaXc",10) == 3740670212) strcat(s, "l");
if (crc32("faxgI",5) == 747952170) strcat(s, "e");
if (crc32("fljLFFpv",8) == 1475187420) strcat(s, "d");
if (crc32("rAWSoqfcKj",10) == 3423674641) strcat(s, "Z");
if (crc32("XADPvid",7) == 2175807745) strcat(s, "g");
if (crc32("AKmZRDpXmh",10) == 2881272790) strcat(s, "I");
if (crc32("DnFoH",5) == 1591592476) strcat(s, "e");
if (crc32("QzrSlwJeO",9) == 1720958468) strcat(s, "s");
    return s;
}

char *Mitran_nouns() {
    char *s = calloc(7);
    if (crc32("vCMLElvqLdcIfhz",15) == 4144769089) strcat(s, "M");
if (crc32("XmxHzytbRugmS",13) == 3651053063) strcat(s, "i");
if (crc32("RLDbOrEOfWhme",13) == 3064013349) strcat(s, "Q");
if (crc32("svJfHHpHX",9) == 1141678616) strcat(s, "t");
if (crc32("NwbPVPJdRpFz",12) == 1087310751) strcat(s, "R");
if (crc32("gwlPrxOPJunRk",13) == 2396482867) strcat(s, "r");
if (crc32("xnIBfAhwlYoTH",13) == 1913037991) strcat(s, "a");
if (crc32("fCyflPVoAd",10) == 4005495625) strcat(s, "V");
if (crc32("uszTfpBl",8) == 4157541884) strcat(s, "n");
    return s;
}

char *Peterlee_nouns() {
    char *s = calloc(9);
    if (crc32("rxKvARBjhCw",11) == 3522264021) strcat(s, "i");
if (crc32("OIcvkhtRpPKFH",13) == 508550981) strcat(s, "P");
if (crc32("SIlzquYuQqoWqC",14) == 113102257) strcat(s, "e");
if (crc32("gIsyKT",6) == 2901539831) strcat(s, "t");
if (crc32("PTpXRtSkDk",10) == 1460769195) strcat(s, "e");
if (crc32("RvyBrEtjxDp",11) == 1709398440) strcat(s, "r");
if (crc32("FrZgG",5) == 793985972) strcat(s, "G");
if (crc32("ZimNXFOcwmX",11) == 2466891511) strcat(s, "l");
if (crc32("Tknaa",5) == 3357805432) strcat(s, "D");
if (crc32("nvKvDT",6) == 299110100) strcat(s, "e");
if (crc32("loqDrKBzM",9) == 3941064320) strcat(s, "e");
    return s;
}

char *predepreciation_nouns() {
    char *s = calloc(16);
    if (crc32("OGxZKEWfe",9) == 1384974021) strcat(s, "p");
if (crc32("UuRZhyapNmAsSo",14) == 2633257080) strcat(s, "r");
if (crc32("KfoBvY",6) == 1888513212) strcat(s, "c");
if (crc32("tfOyCPzQtD",10) == 1490909710) strcat(s, "e");
if (crc32("UmyosxnhGPILPAX",15) == 142004905) strcat(s, "p");
if (crc32("sqWOawWT",8) == 2366821791) strcat(s, "d");
if (crc32("QSsUeqxmgrUNyKi",15) == 3319462791) strcat(s, "S");
if (crc32("oKIFzIkxCEiGd",13) == 1698695966) strcat(s, "e");
if (crc32("sfmJXOaDfyH",11) == 3033874621) strcat(s, "t");
if (crc32("PcMAVFyS",8) == 3403772257) strcat(s, "p");
if (crc32("vFMbJJatIUlg",12) == 1000258426) strcat(s, "c");
if (crc32("lARlcBzG",8) == 2054906860) strcat(s, "r");
if (crc32("cooCLy",6) == 1078731158) strcat(s, "e");
if (crc32("pVucIq",6) == 1218281350) strcat(s, "J");
if (crc32("NmMvnxzDWjEw",12) == 2632160552) strcat(s, "c");
if (crc32("bfdOrrMumqCETrH",15) == 3446358813) strcat(s, "i");
if (crc32("ipPhg",5) == 728856921) strcat(s, "a");
if (crc32("XNWGxDm",7) == 3372273377) strcat(s, "t");
if (crc32("Fifznijp",8) == 4009567561) strcat(s, "Z");
if (crc32("foGwroUK",8) == 4085815633) strcat(s, "i");
if (crc32("wKMgoWcdarH",11) == 93281650) strcat(s, "o");
if (crc32("faykUCEXPDK",11) == 1131297205) strcat(s, "n");
    return s;
}

char *underfitting_nouns() {
    char *s = calloc(13);
    if (crc32("ieqfACKtHsyFvj",14) == 4136555152) strcat(s, "u");
if (crc32("ePbjudN",7) == 1433880584) strcat(s, "U");
if (crc32("cgozxndldEggHp",14) == 4261338604) strcat(s, "n");
if (crc32("vLqfgtLUHac",11) == 2854215802) strcat(s, "o");
if (crc32("nCsUdUCNh",9) == 2606190081) strcat(s, "d");
if (crc32("uunOJsgwd",9) == 1748872326) strcat(s, "T");
if (crc32("ngtMVfOHmw",10) == 1980315498) strcat(s, "e");
if (crc32("MwgZTr",6) == 4008732754) strcat(s, "r");
if (crc32("kLNuTSxBCNM",11) == 3747668133) strcat(s, "f");
if (crc32("ZKfBQmAtQDHBoE",14) == 3779753326) strcat(s, "l");
if (crc32("TAziPCA",7) == 3448621188) strcat(s, "i");
if (crc32("tCKbGPITOp",10) == 334149395) strcat(s, "t");
if (crc32("MUPAdEiyROAQn",13) == 4083970450) strcat(s, "t");
if (crc32("DNACJaKkMZZ",11) == 2099927346) strcat(s, "E");
if (crc32("TNyhmJ",6) == 3619145088) strcat(s, "i");
if (crc32("RtcEiosSe",9) == 2386357467) strcat(s, "C");
if (crc32("znNDhtpmvYjjU",13) == 3417586587) strcat(s, "n");
if (crc32("fDGDxUpQ",8) == 2338562014) strcat(s, "g");
    return s;
}

char *sudoriferousness_nouns() {
    char *s = calloc(17);
    if (crc32("yUnRknTQaRXgO",13) == 3551891719) strcat(s, "V");
if (crc32("cOfxoGqYeP",10) == 3238791589) strcat(s, "s");
if (crc32("JSMhXpVW",8) == 2522916544) strcat(s, "u");
if (crc32("SLNPzKgZhOBS",12) == 3086274389) strcat(s, "d");
if (crc32("CYZLDFOHBGiA",12) == 1154629142) strcat(s, "w");
if (crc32("MAeKzf",6) == 1721891305) strcat(s, "o");
if (crc32("XGEPCFDHZoxzonP",15) == 3957323469) strcat(s, "r");
if (crc32("tKjBRf",6) == 373685897) strcat(s, "m");
if (crc32("RzqZuKc",7) == 1989223273) strcat(s, "i");
if (crc32("yNbeNx",6) == 2503718468) strcat(s, "f");
if (crc32("WpGCglHtzCsrLPO",15) == 3414917143) strcat(s, "e");
if (crc32("OTbQoPxAP",9) == 349300562) strcat(s, "l");
if (crc32("zklBqBEXHi",10) == 2833362241) strcat(s, "r");
if (crc32("zyxcHQCMqRXHWZs",15) == 3764522093) strcat(s, "W");
if (crc32("gNSHpCZshItqb",13) == 487288354) strcat(s, "o");
if (crc32("yVyhQRMUuoE",11) == 2488994413) strcat(s, "M");
if (crc32("yBExFhIHPi",10) == 3242927610) strcat(s, "u");
if (crc32("DIIPqI",6) == 3278658405) strcat(s, "s");
if (crc32("VbLBUlIWhgnwTf",14) == 2306548747) strcat(s, "w");
if (crc32("VPUCf",5) == 2945381924) strcat(s, "n");
if (crc32("OlSOcSMUmVJ",11) == 1677785076) strcat(s, "k");
if (crc32("CeIHesMQhD",10) == 4279981649) strcat(s, "e");
if (crc32("dTSDHt",6) == 3825729966) strcat(s, "Y");
if (crc32("OErmMOpzVSj",11) == 2975667964) strcat(s, "s");
if (crc32("LeDCGZyDkF",10) == 474634765) strcat(s, "L");
if (crc32("HHMxlIqmcRSOX",13) == 2535123186) strcat(s, "s");
    return s;
}

char *Zarga_nouns() {
    char *s = calloc(6);
    if (crc32("wyKaluMLP",9) == 1436233739) strcat(s, "m");
if (crc32("MNEVuXRp",8) == 3448686217) strcat(s, "Z");
if (crc32("nOhnYtPqvufYgj",14) == 3241746079) strcat(s, "a");
if (crc32("VRvmvDPyxDSKd",13) == 2403301689) strcat(s, "r");
if (crc32("GJeCcyZ",7) == 1436728641) strcat(s, "g");
if (crc32("QItbEop",7) == 1775588897) strcat(s, "a");
    return s;
}

char *Lorenza_nouns() {
    char *s = calloc(8);
    if (crc32("wDHEUA",6) == 3832579517) strcat(s, "L");
if (crc32("JXZVWFZ",7) == 1164021915) strcat(s, "o");
if (crc32("NQHmXKPuSkgq",12) == 1442912061) strcat(s, "r");
if (crc32("PMrMamuQjOGONw",14) == 2247472015) strcat(s, "e");
if (crc32("gUvbkmigEoqOYoc",15) == 2399446621) strcat(s, "t");
if (crc32("YaMjIL",6) == 1291751808) strcat(s, "n");
if (crc32("phFmAtBRpGLd",12) == 2125119204) strcat(s, "z");
if (crc32("JVEkfDOTwMwEKY",14) == 3177045362) strcat(s, "R");
if (crc32("pUUiCY",6) == 941954672) strcat(s, "a");
    return s;
}

char *Ecclesiasticus_nouns() {
    char *s = calloc(15);
    if (crc32("PxyTXfZsRLjRc",13) == 1627569080) strcat(s, "P");
if (crc32("ofzlwGcvCSbuvg",14) == 3509906166) strcat(s, "E");
if (crc32("pQiliHO",7) == 2147115430) strcat(s, "N");
if (crc32("DdLlTlSqsmLmWy",14) == 312952125) strcat(s, "c");
if (crc32("KiDLfKIuSkp",11) == 585098045) strcat(s, "e");
if (crc32("PThGQEnSrRczKWx",15) == 3456622891) strcat(s, "c");
if (crc32("FnjLRYsytj",10) == 1192110569) strcat(s, "R");
if (crc32("mPnaPgv",7) == 561882175) strcat(s, "l");
if (crc32("eQfoJkW",7) == 814220871) strcat(s, "K");
if (crc32("OKVXUvpaPOlUGLO",15) == 2027267987) strcat(s, "e");
if (crc32("fDDHaOs",7) == 1373582298) strcat(s, "x");
if (crc32("MSFIhSJbPuoOe",13) == 376915703) strcat(s, "s");
if (crc32("FtDxwJc",7) == 2703772789) strcat(s, "W");
if (crc32("RbyVfPUZpxxwM",13) == 1352780151) strcat(s, "i");
if (crc32("efGPRBhtlX",10) == 2572631543) strcat(s, "a");
if (crc32("ROkId",5) == 723692771) strcat(s, "C");
if (crc32("KAOAWMZRhn",10) == 599142838) strcat(s, "s");
if (crc32("nUTSHaKoj",9) == 3929676326) strcat(s, "t");
if (crc32("ZWwwZ",5) == 2385168091) strcat(s, "R");
if (crc32("AoVkCMZ",7) == 1634987118) strcat(s, "i");
if (crc32("BBGcuDNbs",9) == 3013534976) strcat(s, "c");
if (crc32("DiyQCeb",7) == 1279956720) strcat(s, "u");
if (crc32("wSjdHYrgGZH",11) == 1196529569) strcat(s, "s");
    return s;
}

char *plasterer_nouns() {
    char *s = calloc(10);
    if (crc32("gHvDNlezJJ",10) == 3474000891) strcat(s, "p");
if (crc32("FRdPNauUKmMsk",13) == 4262765169) strcat(s, "E");
if (crc32("mQCUUYo",7) == 2405204623) strcat(s, "l");
if (crc32("UPHnQJopcqobBZg",15) == 1966057130) strcat(s, "k");
if (crc32("GUmzrYxBxOzdR",13) == 3474297870) strcat(s, "a");
if (crc32("IpMZAZB",7) == 3939558334) strcat(s, "s");
if (crc32("TnmPLcOkASdiE",13) == 3638788060) strcat(s, "g");
if (crc32("XAHyAMkebsix",12) == 1501171559) strcat(s, "t");
if (crc32("LVPhCEkejCP",11) == 3540893407) strcat(s, "V");
if (crc32("ozUEEsYJe",9) == 3414259040) strcat(s, "e");
if (crc32("GGBdokTjHEo",11) == 3826811537) strcat(s, "r");
if (crc32("IVMKK",5) == 4150693150) strcat(s, "e");
if (crc32("RMQFjLrQIkzOVt",14) == 1955025279) strcat(s, "f");
if (crc32("SbFcboFgZuFM",12) == 2334515929) strcat(s, "r");
    return s;
}

char *Faraday_nouns() {
    char *s = calloc(8);
    if (crc32("tfXmpNTyZ",9) == 158200890) strcat(s, "W");
if (crc32("AUkrzXSzBbszfP",14) == 2218046722) strcat(s, "F");
if (crc32("OVpbBoQFjNMpwHM",15) == 2086409877) strcat(s, "a");
if (crc32("ppaShMWrkOOfUTY",15) == 3476290220) strcat(s, "r");
if (crc32("aJYIfsoOwTZ",11) == 578073022) strcat(s, "a");
if (crc32("pqNpIrFzMFyXGd",14) == 2245821038) strcat(s, "d");
if (crc32("KyGdUAekWoyiKv",14) == 821039447) strcat(s, "a");
if (crc32("XJzcWuvO",8) == 3965133254) strcat(s, "y");
    return s;
}

char *nontangibleness_nouns() {
    char *s = calloc(16);
    if (crc32("kigWGCubGSQhuQW",15) == 3603425096) strcat(s, "H");
if (crc32("EWvyenARLOwtv",13) == 1991158533) strcat(s, "n");
if (crc32("YixyeDEtOH",10) == 1435533149) strcat(s, "o");
if (crc32("cofftBGJ",8) == 2846246328) strcat(s, "a");
if (crc32("pzVElOwCOcKKIJh",15) == 2272697779) strcat(s, "n");
if (crc32("JhSzszPVhJrRWM",14) == 4220423652) strcat(s, "N");
if (crc32("KcBcAkaLxgKRi",13) == 4460415) strcat(s, "t");
if (crc32("RrOIhWoPYbbOyFt",15) == 2515208479) strcat(s, "f");
if (crc32("yKZHkFG",7) == 2803437536) strcat(s, "a");
if (crc32("ViEubARAlIPKb",13) == 3697485955) strcat(s, "q");
if (crc32("hYXmqBWQW",9) == 628665621) strcat(s, "n");
if (crc32("JlZSTucPRwY",11) == 745899234) strcat(s, "g");
if (crc32("URfdOOnMHvWk",12) == 3549174649) strcat(s, "i");
if (crc32("ZXYjRRYMus",10) == 3071254534) strcat(s, "b");
if (crc32("iITbZWHJDRNqq",13) == 4030780138) strcat(s, "l");
if (crc32("gCERblVFOOg",11) == 3733754873) strcat(s, "K");
if (crc32("JhDYgdluUosZFo",14) == 157155055) strcat(s, "e");
if (crc32("dbJUcIY",7) == 1092371303) strcat(s, "U");
if (crc32("dHbkqdJFiG",10) == 893816997) strcat(s, "n");
if (crc32("RMKYvO",6) == 3768179925) strcat(s, "e");
if (crc32("dtAGZdnknf",10) == 1552021918) strcat(s, "h");
if (crc32("smXjXHtpa",9) == 3442329940) strcat(s, "s");
if (crc32("oYkUiLeQyCweHP",14) == 1380525939) strcat(s, "S");
if (crc32("hWIZsntTLeBM",12) == 1884785231) strcat(s, "s");
    return s;
}

char *Arvind_nouns() {
    char *s = calloc(7);
    if (crc32("kgGjQvcwh",9) == 1555901558) strcat(s, "F");
if (crc32("cGSux",5) == 2082438736) strcat(s, "A");
if (crc32("CWLuwDVU",8) == 460425830) strcat(s, "r");
if (crc32("GeLYLTFLdu",10) == 309276875) strcat(s, "v");
if (crc32("OJKKDzihmkr",11) == 3483563329) strcat(s, "x");
if (crc32("mBkKzMrrq",9) == 2077346579) strcat(s, "i");
if (crc32("DUuyTfIVomPazhZ",15) == 3536032401) strcat(s, "n");
if (crc32("gRjBrwx",7) == 3734390707) strcat(s, "F");
if (crc32("wlFmpMhAblARaQ",14) == 2202838236) strcat(s, "d");
    return s;
}

char *sinhalite_nouns() {
    char *s = calloc(10);
    if (crc32("uFebTcCnE",9) == 3514368444) strcat(s, "i");
if (crc32("dFPUTIV",7) == 928180291) strcat(s, "s");
if (crc32("PlWZIyhmIXo",11) == 1201875372) strcat(s, "i");
if (crc32("hUDWNkOQNc",10) == 2636267552) strcat(s, "n");
if (crc32("GVZOZZ",6) == 60143742) strcat(s, "A");
if (crc32("AhlIDCnoWEl",11) == 4005704166) strcat(s, "h");
if (crc32("WEcRbaz",7) == 2662385178) strcat(s, "A");
if (crc32("wkdlqKia",8) == 2758257671) strcat(s, "a");
if (crc32("IdeeGQc",7) == 2155780646) strcat(s, "l");
if (crc32("MuchLOC",7) == 585872000) strcat(s, "i");
if (crc32("yqdrORgnWWyf",12) == 1717078411) strcat(s, "f");
if (crc32("jNAiI",5) == 2752281042) strcat(s, "t");
if (crc32("hMEnBAS",7) == 1097831541) strcat(s, "f");
if (crc32("ZwAHQHz",7) == 3537063037) strcat(s, "e");
    return s;
}

char *Norw_nouns() {
    char *s = calloc(5);
    if (crc32("udglLSOvVuUbly",14) == 1520550016) strcat(s, "y");
if (crc32("nQxLizYfKrGwoP",14) == 1853601718) strcat(s, "N");
if (crc32("EEaEqBfAMNdhWT",14) == 154944103) strcat(s, "c");
if (crc32("Bwztdjsnfuo",11) == 3433251087) strcat(s, "o");
if (crc32("UthJDEcbYJPvs",13) == 1594637169) strcat(s, "r");
if (crc32("PKDUBILRMwfumN",14) == 535512947) strcat(s, "f");
if (crc32("JGecfSpgmGs",11) == 1626473001) strcat(s, "w");
    return s;
}

char *prover_nouns() {
    char *s = calloc(7);
    if (crc32("RRSZLZhQbnIM",12) == 3412424041) strcat(s, "B");
if (crc32("nmdzPknXJROnK",13) == 2592923349) strcat(s, "p");
if (crc32("oMBxrax",7) == 3877641142) strcat(s, "k");
if (crc32("MuscXPr",7) == 312583947) strcat(s, "r");
if (crc32("gXcDLydNrqhySmY",15) == 3650495240) strcat(s, "o");
if (crc32("WBRvziCfJ",9) == 3082704593) strcat(s, "R");
if (crc32("NFWwtD",6) == 1856313315) strcat(s, "v");
if (crc32("vXxwBMrVXZsq",12) == 4040955222) strcat(s, "e");
if (crc32("fEVXGm",6) == 1326532861) strcat(s, "C");
if (crc32("fHZRDdWAGNj",11) == 2449921213) strcat(s, "r");
    return s;
}

char *Christoforo_nouns() {
    char *s = calloc(12);
    if (crc32("fpnBbrlNgRyuI",13) == 3021967672) strcat(s, "C");
if (crc32("FuQxnefqZvem",12) == 1340313350) strcat(s, "e");
if (crc32("gicVQ",5) == 285346304) strcat(s, "h");
if (crc32("ApULSPdNKEJHvG",14) == 1105603164) strcat(s, "r");
if (crc32("ZfvUvT",6) == 3202857520) strcat(s, "W");
if (crc32("HyZdgSy",7) == 4120188413) strcat(s, "i");
if (crc32("MEfqxAzZzTKGL",13) == 4230878435) strcat(s, "s");
if (crc32("YdXMoSi",7) == 1059742154) strcat(s, "t");
if (crc32("RmDjXaHGxKLqut",14) == 210990224) strcat(s, "o");
if (crc32("jwNOrAzc",8) == 2187908982) strcat(s, "b");
if (crc32("QFoGbMPJVKdiRk",14) == 3366690540) strcat(s, "f");
if (crc32("CtKOrP",6) == 1978515503) strcat(s, "o");
if (crc32("vepEkjcSGIBemLX",15) == 470483439) strcat(s, "r");
if (crc32("QUcFXiqWC",9) == 2450343507) strcat(s, "T");
if (crc32("ctLNbJ",6) == 1509194940) strcat(s, "o");
    return s;
}

char *barretter_nouns() {
    char *s = calloc(10);
    if (crc32("XAbIkAvvSVT",11) == 128665048) strcat(s, "b");
if (crc32("NZDFEJRlqq",10) == 1924153246) strcat(s, "a");
if (crc32("CngytlsW",8) == 1767914191) strcat(s, "t");
if (crc32("CtdoBwG",7) == 2350099257) strcat(s, "r");
if (crc32("VoDAPg",6) == 1111480365) strcat(s, "b");
if (crc32("FsuTmWKGWqQFAM",14) == 4019294295) strcat(s, "r");
if (crc32("CRyodnzCKKVb",12) == 1416391380) strcat(s, "Z");
if (crc32("ksKxvCyxXz",10) == 3835461075) strcat(s, "e");
if (crc32("xNgdUuLTjAbl",12) == 3878315462) strcat(s, "O");
if (crc32("ttvEsva",7) == 3670507590) strcat(s, "t");
if (crc32("ACIDGB",6) == 466613018) strcat(s, "q");
if (crc32("CCXcrnmqPXnCc",13) == 4198815206) strcat(s, "t");
if (crc32("PesgPcMgGiUp",12) == 1326895246) strcat(s, "r");
if (crc32("NmfoXGpzC",9) == 3391598729) strcat(s, "e");
if (crc32("LSSxnRcemflrNkP",15) == 3913882387) strcat(s, "r");
    return s;
}

char *examinant_nouns() {
    char *s = calloc(10);
    if (crc32("mHXtmWhzA",9) == 2489564423) strcat(s, "e");
if (crc32("IQDgFrCWuG",10) == 125527021) strcat(s, "x");
if (crc32("DilUkxPi",8) == 4194603528) strcat(s, "G");
if (crc32("tpvtTmiNKnlxS",13) == 1475969936) strcat(s, "a");
if (crc32("maxbG",5) == 3247124601) strcat(s, "m");
if (crc32("AxCRJnkmWOcQNmT",15) == 2969420379) strcat(s, "i");
if (crc32("GsDsFQDpgdp",11) == 3569525844) strcat(s, "O");
if (crc32("yhzqlaDJ",8) == 982940587) strcat(s, "n");
if (crc32("XigRErQB",8) == 1780532733) strcat(s, "a");
if (crc32("GrvLoLjJ",8) == 3654780074) strcat(s, "x");
if (crc32("AxDfkwiPXAg",11) == 2491909079) strcat(s, "n");
if (crc32("TYWAAqNmggGPJ",13) == 3416833316) strcat(s, "i");
if (crc32("qfRYVgYcJ",9) == 579386273) strcat(s, "t");
    return s;
}

char *thermostat_nouns() {
    char *s = calloc(11);
    if (crc32("BBoSG",5) == 907909610) strcat(s, "f");
if (crc32("JOPabfZkntHK",12) == 2127415557) strcat(s, "t");
if (crc32("kbpeGQyZx",9) == 3261600066) strcat(s, "h");
if (crc32("yvcTziJPsgNFz",13) == 2986579748) strcat(s, "e");
if (crc32("XXAke",5) == 1320156894) strcat(s, "G");
if (crc32("JTrybRSc",8) == 66525631) strcat(s, "r");
if (crc32("GAjjFCNczJ",10) == 3862396574) strcat(s, "t");
if (crc32("csaqwk",6) == 3982984104) strcat(s, "m");
if (crc32("NmiBXvFuXdgZslX",15) == 417517536) strcat(s, "o");
if (crc32("FLezc",5) == 2401506596) strcat(s, "s");
if (crc32("rJBma",5) == 677503329) strcat(s, "t");
if (crc32("PjCUwEdxmulaDA",14) == 506617158) strcat(s, "u");
if (crc32("wgXpAhUSpOZI",12) == 700179171) strcat(s, "a");
if (crc32("IjmokyfZdsUmrJ",14) == 2177143952) strcat(s, "t");
    return s;
}

char *comity_nouns() {
    char *s = calloc(7);
    if (crc32("urfIyTIURtAGBgh",15) == 3989860832) strcat(s, "c");
if (crc32("DIbGqy",6) == 2347759107) strcat(s, "o");
if (crc32("PluPfSIZe",9) == 1825350576) strcat(s, "m");
if (crc32("SvSKujFsHo",10) == 717070710) strcat(s, "i");
if (crc32("KXHkmmZLTINvz",13) == 2577582720) strcat(s, "z");
if (crc32("MJEIILAVuSC",11) == 1402045151) strcat(s, "t");
if (crc32("bYYqcaJEavhXqa",14) == 1448688662) strcat(s, "y");
    return s;
}

char *postsigner_nouns() {
    char *s = calloc(11);
    if (crc32("PdKcds",6) == 535256249) strcat(s, "p");
if (crc32("foReTzRAQgSXHEt",15) == 3560738277) strcat(s, "q");
if (crc32("kXYFYPClhJ",10) == 2389100147) strcat(s, "o");
if (crc32("xlBilIMWMVLCb",13) == 2528273510) strcat(s, "s");
if (crc32("otZkakVwW",9) == 1061964205) strcat(s, "P");
if (crc32("gkJar",5) == 3203886754) strcat(s, "t");
if (crc32("hfWmreJpohM",11) == 159860783) strcat(s, "m");
if (crc32("BDDxv",5) == 3648270773) strcat(s, "s");
if (crc32("MIyyTGZ",7) == 2276681552) strcat(s, "y");
if (crc32("zqDErTHXUddPaS",14) == 1261890536) strcat(s, "i");
if (crc32("IBJVEgLf",8) == 3345010076) strcat(s, "N");
if (crc32("mxRbQSBzhIqblyy",15) == 1761076754) strcat(s, "g");
if (crc32("wbJdYv",6) == 1037055018) strcat(s, "h");
if (crc32("ZhIhHjefxnjulkI",15) == 2506571157) strcat(s, "n");
if (crc32("FZDpedUoCrfXlur",15) == 1655453929) strcat(s, "V");
if (crc32("ithTR",5) == 2871781370) strcat(s, "e");
if (crc32("urmhmUWfzrwX",12) == 913848333) strcat(s, "J");
if (crc32("WtQkoR",6) == 4230534229) strcat(s, "r");
    return s;
}

char *contradictoriness_nouns() {
    char *s = calloc(18);
    if (crc32("zpvBeXG",7) == 1293931175) strcat(s, "c");
if (crc32("lKiRZ",5) == 521022260) strcat(s, "K");
if (crc32("mscNJaQVZ",9) == 2098073467) strcat(s, "o");
if (crc32("YjQRIoWvSYo",11) == 2013613086) strcat(s, "q");
if (crc32("hecYBvH",7) == 1743208668) strcat(s, "n");
if (crc32("NVltPerZgcao",12) == 2770543915) strcat(s, "r");
if (crc32("bgnCsKGCyXv",11) == 687738173) strcat(s, "t");
if (crc32("GgIphn",6) == 1044471238) strcat(s, "F");
if (crc32("QfUlWMaISBkKAl",14) == 400533190) strcat(s, "r");
if (crc32("YEWKgBBaHt",10) == 3408717486) strcat(s, "B");
if (crc32("fhtqIDQmbJrI",12) == 2417672018) strcat(s, "a");
if (crc32("mkFTGfbGqzQM",12) == 1195261452) strcat(s, "d");
if (crc32("pIreAvnXpK",10) == 2516090733) strcat(s, "i");
if (crc32("LZCQksqPI",9) == 3751301164) strcat(s, "c");
if (crc32("psOiXahTefcbTh",14) == 3523106200) strcat(s, "t");
if (crc32("zZkNKjD",7) == 2133096029) strcat(s, "o");
if (crc32("RKMdZqiRHlGY",12) == 396934620) strcat(s, "x");
if (crc32("iqrNPsNOucncJ",13) == 658941828) strcat(s, "r");
if (crc32("DlplNHusHvRY",12) == 1692984877) strcat(s, "i");
if (crc32("eTXlknb",7) == 1189119958) strcat(s, "P");
if (crc32("UchXKvHhlfSL",12) == 2144456578) strcat(s, "n");
if (crc32("XcSkBTVJXXsU",12) == 4088133695) strcat(s, "e");
if (crc32("TZYLhZToA",9) == 1182785249) strcat(s, "e");
if (crc32("FDWmyDh",7) == 3851544835) strcat(s, "I");
if (crc32("yXImXqWUoB",10) == 2660900568) strcat(s, "s");
if (crc32("BLGZiEgiQiWmDRD",15) == 192259642) strcat(s, "s");
    return s;
}

char *Monteux_nouns() {
    char *s = calloc(8);
    if (crc32("MlWdfGKFE",9) == 3822957739) strcat(s, "c");
if (crc32("IngyzthR",8) == 376560968) strcat(s, "M");
if (crc32("EkjkBbrH",8) == 4158625113) strcat(s, "d");
if (crc32("vFmVc",5) == 1989834704) strcat(s, "o");
if (crc32("lkfmJbvgLiYMDlz",15) == 1297236170) strcat(s, "n");
if (crc32("tUoiw",5) == 259454702) strcat(s, "t");
if (crc32("tThpXgllwJFE",12) == 1715165129) strcat(s, "e");
if (crc32("YaWUhStnlCnryz",14) == 663210831) strcat(s, "c");
if (crc32("syYsYiIdBgNxeC",14) == 4292378371) strcat(s, "u");
if (crc32("VjIFaR",6) == 506687846) strcat(s, "O");
if (crc32("IkacZzYzOs",10) == 3069550629) strcat(s, "x");
    return s;
}

char *ChampignysurMarne_nouns() {
    char *s = calloc(18);
    if (crc32("sohMWqFFJtGEJlg",15) == 3148952022) strcat(s, "C");
if (crc32("yBdzRwFW",8) == 1178079624) strcat(s, "h");
if (crc32("eFitq",5) == 2983812785) strcat(s, "e");
if (crc32("OOHkqCm",7) == 3907060377) strcat(s, "a");
if (crc32("TZZXaLpzAIN",11) == 98924557) strcat(s, "m");
if (crc32("wXnXeork",8) == 3917748157) strcat(s, "u");
if (crc32("LiEVurBrR",9) == 3331955635) strcat(s, "p");
if (crc32("ZOUKCqIPmc",10) == 1940001288) strcat(s, "E");
if (crc32("uaGmvFV",7) == 3076284202) strcat(s, "i");
if (crc32("BcFqOCiB",8) == 875685679) strcat(s, "g");
if (crc32("rbDRUzCLw",9) == 2227296963) strcat(s, "L");
if (crc32("eokVChb",7) == 3246441939) strcat(s, "n");
if (crc32("vFJdvM",6) == 1716243876) strcat(s, "S");
if (crc32("zYqdzxbaupQcWjn",15) == 559226742) strcat(s, "y");
if (crc32("ziILJsrNpZIM",12) == 588138452) strcat(s, "s");
if (crc32("cIZEw",5) == 1275818304) strcat(s, "S");
if (crc32("JuGyb",5) == 2685714133) strcat(s, "u");
if (crc32("lYQxCeimnpAdjPD",15) == 3814935923) strcat(s, "r");
if (crc32("hdMwnqZSudWSFK",14) == 3056966880) strcat(s, "M");
if (crc32("mWVAkxIvxNES",12) == 1181646264) strcat(s, "M");
if (crc32("OSkwBEBB",8) == 3014847970) strcat(s, "a");
if (crc32("oBKUkGZ",7) == 3355369250) strcat(s, "F");
if (crc32("ycnksu",6) == 4168874816) strcat(s, "r");
if (crc32("XkeJbJaWEYnZDv",14) == 829422097) strcat(s, "n");
if (crc32("LdFgYMZCZPSYt",13) == 2274623539) strcat(s, "e");
    return s;
}

char *Miletus_nouns() {
    char *s = calloc(8);
    if (crc32("PYXslRPMp",9) == 2854394930) strcat(s, "M");
if (crc32("HXXNvvmwA",9) == 965000549) strcat(s, "M");
if (crc32("grKsnYXLBzdms",13) == 2438844480) strcat(s, "G");
if (crc32("ErXqzDjybkOC",12) == 2778781326) strcat(s, "i");
if (crc32("nKjwWfjAfUNYM",13) == 1625839828) strcat(s, "D");
if (crc32("ElMgEgLNGZpo",12) == 4285677069) strcat(s, "l");
if (crc32("ZVgkbNhroGX",11) == 672365713) strcat(s, "e");
if (crc32("qtEOpqCcGnwN",12) == 4160229615) strcat(s, "t");
if (crc32("ejLoGTABPVhd",12) == 674330478) strcat(s, "u");
if (crc32("RrTEAP",6) == 3282125726) strcat(s, "s");
    return s;
}

char *harassment_nouns() {
    char *s = calloc(11);
    if (crc32("jkompIofLNQ",11) == 4073312073) strcat(s, "h");
if (crc32("hUgZEJ",6) == 1140743320) strcat(s, "m");
if (crc32("kGBqFEm",7) == 1026188978) strcat(s, "a");
if (crc32("fgukoNNmbXnmcMC",15) == 1305799971) strcat(s, "r");
if (crc32("NHMkxXX",7) == 1797751507) strcat(s, "a");
if (crc32("iOApprsviyYr",12) == 859686394) strcat(s, "q");
if (crc32("zvKkeqJuMCaO",12) == 3616625167) strcat(s, "s");
if (crc32("HIgNvdAPFQmU",12) == 3930726401) strcat(s, "q");
if (crc32("rQGdaeJmLHMWHd",14) == 2991981245) strcat(s, "s");
if (crc32("RxXMo",5) == 3270294065) strcat(s, "u");
if (crc32("VaCAV",5) == 3948798988) strcat(s, "m");
if (crc32("PAOiSAPzqMsMpAz",15) == 1451929124) strcat(s, "e");
if (crc32("sIycXtjdGnzaA",13) == 1485435883) strcat(s, "M");
if (crc32("bSaKf",5) == 35750088) strcat(s, "n");
if (crc32("repJtzm",7) == 3766299380) strcat(s, "I");
if (crc32("xhLNtdaJILA",11) == 268631682) strcat(s, "t");
    return s;
}

char *bebopper_nouns() {
    char *s = calloc(9);
    if (crc32("BymRNTNtrTSD",12) == 2123968622) strcat(s, "f");
if (crc32("sUlfWkNuWVE",11) == 1131346496) strcat(s, "b");
if (crc32("yvpYzaDGO",9) == 3403884085) strcat(s, "B");
if (crc32("mYjOmzLWXjau",12) == 4011476330) strcat(s, "e");
if (crc32("fwITZCfnFojhkfU",15) == 3028738632) strcat(s, "z");
if (crc32("qilswNWBQHDXr",13) == 1984166170) strcat(s, "b");
if (crc32("axxVLcAyqZ",10) == 76752998) strcat(s, "s");
if (crc32("GLKXODxbeWBqkaC",15) == 1745249934) strcat(s, "o");
if (crc32("qdaWHgD",7) == 766544712) strcat(s, "t");
if (crc32("nNCrBea",7) == 4243807958) strcat(s, "p");
if (crc32("mLiZQUQ",7) == 2312851010) strcat(s, "p");
if (crc32("gTdoRaazes",10) == 943636685) strcat(s, "e");
if (crc32("saVdv",5) == 722261452) strcat(s, "r");
    return s;
}

char *Mannos_nouns() {
    char *s = calloc(7);
    if (crc32("sqHJqpUultQtH",13) == 3582555300) strcat(s, "M");
if (crc32("rhqoyYjrkf",10) == 436854668) strcat(s, "a");
if (crc32("hbhhy",5) == 1014384310) strcat(s, "a");
if (crc32("cYanTjTw",8) == 2902635451) strcat(s, "V");
if (crc32("KeMdE",5) == 2593954907) strcat(s, "n");
if (crc32("JBDQpgXP",8) == 2701078668) strcat(s, "n");
if (crc32("KyqaQRDY",8) == 1330072104) strcat(s, "R");
if (crc32("eppHTE",6) == 3724447278) strcat(s, "o");
if (crc32("SXzmBQANur",10) == 1574852867) strcat(s, "s");
    return s;
}

char *inelegancy_nouns() {
    char *s = calloc(11);
    if (crc32("ADASZWEI",8) == 3299587365) strcat(s, "i");
if (crc32("HcXbu",5) == 3476615458) strcat(s, "Z");
if (crc32("QmJJIVchUK",10) == 2529658194) strcat(s, "n");
if (crc32("OkDwwZgBmL",10) == 527587417) strcat(s, "d");
if (crc32("YomoV",5) == 2953209384) strcat(s, "e");
if (crc32("NNwlq",5) == 3856541167) strcat(s, "l");
if (crc32("CRtWSPdbRhcND",13) == 132602586) strcat(s, "e");
if (crc32("yDSoJwlKW",9) == 3215285122) strcat(s, "g");
if (crc32("FjgVDFpdmhxjH",13) == 752542296) strcat(s, "a");
if (crc32("GvCEozWEzYU",11) == 828488843) strcat(s, "n");
if (crc32("XSYDTitPfAPB",12) == 2241487991) strcat(s, "m");
if (crc32("BzGoA",5) == 1995973095) strcat(s, "c");
if (crc32("xmhIQXBwra",10) == 1736342674) strcat(s, "U");
if (crc32("MHynwlY",7) == 4274123366) strcat(s, "y");
    return s;
}

char *tussore_nouns() {
    char *s = calloc(8);
    if (crc32("nToUBYiZ",8) == 326742269) strcat(s, "t");
if (crc32("TpKotelnC",9) == 2407869489) strcat(s, "u");
if (crc32("nQcIwNvfW",9) == 1471200483) strcat(s, "W");
if (crc32("PqIiWFToXsJrQPD",15) == 2903509259) strcat(s, "s");
if (crc32("ZyESWwSjZJmkBll",15) == 2221860735) strcat(s, "s");
if (crc32("DoRMVQhVx",9) == 2722383829) strcat(s, "W");
if (crc32("KfRbkAus",8) == 1564266268) strcat(s, "o");
if (crc32("PnMHYNSbzVgzV",13) == 143609776) strcat(s, "C");
if (crc32("oGjcsnUOFn",10) == 2724762812) strcat(s, "r");
if (crc32("YiiOhvee",8) == 2791977060) strcat(s, "l");
if (crc32("rBrHmtPPShFBHNR",15) == 4088255043) strcat(s, "e");
    return s;
}

char *humdinger_nouns() {
    char *s = calloc(10);
    if (crc32("hTaXyrCg",8) == 3641890977) strcat(s, "D");
if (crc32("YgIcrApmg",9) == 1256915657) strcat(s, "h");
if (crc32("VBIJcmmnfoADOKE",15) == 2962619589) strcat(s, "u");
if (crc32("ynnXlCWs",8) == 3727448459) strcat(s, "C");
if (crc32("oaOTA",5) == 4195394636) strcat(s, "m");
if (crc32("jISvc",5) == 930156227) strcat(s, "G");
if (crc32("HWVvIFatyCZ",11) == 1961112450) strcat(s, "d");
if (crc32("DSjiV",5) == 3248407297) strcat(s, "i");
if (crc32("iqudLDRBn",9) == 1008766385) strcat(s, "Y");
if (crc32("jOLyDxXFkARni",13) == 4155735425) strcat(s, "n");
if (crc32("WdxgWmKI",8) == 2198038819) strcat(s, "g");
if (crc32("WnaWeMDFNO",10) == 1929619841) strcat(s, "U");
if (crc32("bWQmVBhsHStbMn",14) == 3001289352) strcat(s, "e");
if (crc32("CMNZfXS",7) == 3563110470) strcat(s, "r");
    return s;
}

char *Acraea_nouns() {
    char *s = calloc(7);
    if (crc32("coOHIzStIqteIq",14) == 677303791) strcat(s, "O");
if (crc32("jXTSxfcMU",9) == 934257281) strcat(s, "A");
if (crc32("fdbMxo",6) == 3495637573) strcat(s, "c");
if (crc32("GDuitLhNWp",10) == 836737324) strcat(s, "r");
if (crc32("IjnJPd",6) == 478668248) strcat(s, "r");
if (crc32("RlJvLrE",7) == 1748536742) strcat(s, "a");
if (crc32("WrgGRhN",7) == 1130174642) strcat(s, "e");
if (crc32("wccVGFr",7) == 1927726444) strcat(s, "K");
if (crc32("aqaWIpKQvUu",11) == 3327229246) strcat(s, "a");
    return s;
}

char *Hebraiser_nouns() {
    char *s = calloc(10);
    if (crc32("duqJRiOnpeHAUz",14) == 3797709370) strcat(s, "j");
if (crc32("tQZDjtfdSdWgNA",14) == 3599099424) strcat(s, "H");
if (crc32("JCkrvTaqdmlPh",13) == 3175199242) strcat(s, "S");
if (crc32("dhdlFNJIde",10) == 1306746155) strcat(s, "e");
if (crc32("cCsLYkxWiZ",10) == 2729158296) strcat(s, "b");
if (crc32("PNGYjewwRljdd",13) == 1228890146) strcat(s, "P");
if (crc32("RBoruuijmlvLG",13) == 2532695415) strcat(s, "r");
if (crc32("VtBKikaiMCKLHwi",15) == 3927525689) strcat(s, "a");
if (crc32("FvBksQjyXjmNc",13) == 306350313) strcat(s, "w");
if (crc32("USQlwinJR",9) == 1066876091) strcat(s, "i");
if (crc32("mYQxUmVz",8) == 1981575976) strcat(s, "s");
if (crc32("qVrak",5) == 970531738) strcat(s, "B");
if (crc32("YtQOQWmixps",11) == 221660026) strcat(s, "e");
if (crc32("wJVFNNSxfCHPDd",14) == 2337636764) strcat(s, "r");
    return s;
}

char *Mackinac_nouns() {
    char *s = calloc(9);
    if (crc32("bvKwVjcGkZjYVK",14) == 3727031783) strcat(s, "Y");
if (crc32("OCIazzxwbcHbYO",14) == 731532778) strcat(s, "M");
if (crc32("WJuOKi",6) == 321439786) strcat(s, "s");
if (crc32("AAAYzODonvtX",12) == 3443700132) strcat(s, "a");
if (crc32("HTFRflDqtPBZBc",14) == 1666924061) strcat(s, "L");
if (crc32("bCIeoMpYAKv",11) == 2798917980) strcat(s, "c");
if (crc32("vYmbLbzMvBtE",12) == 4256411658) strcat(s, "k");
if (crc32("yjLglcPe",8) == 4273141989) strcat(s, "P");
if (crc32("wChgHUBlwVt",11) == 1725239499) strcat(s, "i");
if (crc32("FDtctMbhcccAa",13) == 2023457440) strcat(s, "F");
if (crc32("eFdEmaFFmaW",11) == 816938304) strcat(s, "n");
if (crc32("nnrBBWOPt",9) == 1817348298) strcat(s, "a");
if (crc32("FCDuMcg",7) == 665689044) strcat(s, "c");
    return s;
}

char *Evora_nouns() {
    char *s = calloc(6);
    if (crc32("ZmxNc",5) == 2641257512) strcat(s, "E");
if (crc32("lwJSIQ",6) == 579006403) strcat(s, "v");
if (crc32("VlfTVUto",8) == 3138190059) strcat(s, "o");
if (crc32("GlsoRmitxTDNE",13) == 3242598513) strcat(s, "p");
if (crc32("qIzkkqP",7) == 3115117227) strcat(s, "r");
if (crc32("XYmVfANtaDmYQv",14) == 2250629225) strcat(s, "Z");
if (crc32("NDMIyDEee",9) == 3820111867) strcat(s, "a");
    return s;
}

char *greataunt_nouns() {
    char *s = calloc(10);
    if (crc32("bBgZvOaJSxiJ",12) == 1294245987) strcat(s, "g");
if (crc32("LyLJZSqiHvQV",12) == 1494071453) strcat(s, "S");
if (crc32("lYzaLlUBMDerC",13) == 2618120468) strcat(s, "r");
if (crc32("lVBBdreGHmfAZ",13) == 4151377857) strcat(s, "e");
if (crc32("suPzAQYRWXLNot",14) == 768172074) strcat(s, "a");
if (crc32("SvmQEY",6) == 1992423388) strcat(s, "t");
if (crc32("GBqVW",5) == 1362222864) strcat(s, "a");
if (crc32("USpLCFbWm",9) == 3172012750) strcat(s, "u");
if (crc32("vmKlUUKvVVZKhH",14) == 477748609) strcat(s, "l");
if (crc32("CmMuKtUm",8) == 1099426315) strcat(s, "n");
if (crc32("jMLNHBYeinfiFty",15) == 592450374) strcat(s, "D");
if (crc32("iTMjhSPdMvn",11) == 2335063224) strcat(s, "t");
    return s;
}

char *Teodoro_nouns() {
    char *s = calloc(8);
    if (crc32("nDdnQNPKjreJFG",14) == 625696604) strcat(s, "t");
if (crc32("hCrAkcjiFFUcGiX",15) == 3674101589) strcat(s, "T");
if (crc32("uLWXeZ",6) == 3415762593) strcat(s, "i");
if (crc32("aNwOMGFGbbjGhq",14) == 540003273) strcat(s, "e");
if (crc32("KJOSooWIduA",11) == 3926906646) strcat(s, "c");
if (crc32("urTtHqPD",8) == 2712741657) strcat(s, "o");
if (crc32("uSeNGxO",7) == 3189845653) strcat(s, "l");
if (crc32("LSyLokuAZupcTZ",14) == 2079351845) strcat(s, "d");
if (crc32("xZljDCl",7) == 4193782371) strcat(s, "X");
if (crc32("KFbxGwGMM",9) == 2318408482) strcat(s, "o");
if (crc32("TadLfZjyuIbRxd",14) == 3971466738) strcat(s, "p");
if (crc32("UpVzvPdaCDk",11) == 4165492211) strcat(s, "r");
if (crc32("sqdWMeW",7) == 3336967588) strcat(s, "u");
if (crc32("xEBWPhkZYXoUEsx",15) == 1942804230) strcat(s, "o");
    return s;
}

char *disenthronement_nouns() {
    char *s = calloc(16);
    if (crc32("mkZfBoAXVxaMNIM",15) == 138041177) strcat(s, "q");
if (crc32("MlIyPNy",7) == 2949469291) strcat(s, "d");
if (crc32("YrpsrwljcEE",11) == 3960756280) strcat(s, "i");
if (crc32("JIDtENSBvqQd",12) == 434244665) strcat(s, "s");
if (crc32("OVEcNRqlehfNJJ",14) == 4154044088) strcat(s, "e");
if (crc32("rurnUYeNZducMnr",15) == 1323292169) strcat(s, "S");
if (crc32("rhdCUxCFEc",10) == 3861733507) strcat(s, "n");
if (crc32("RfddkoxqhxXWNOn",15) == 4184714226) strcat(s, "A");
if (crc32("LQjFAgZKwzJIvh",14) == 1296569423) strcat(s, "t");
if (crc32("dOMfqJKnBkjPr",13) == 1839848094) strcat(s, "K");
if (crc32("FlFczARKkBu",11) == 1228260005) strcat(s, "h");
if (crc32("iDPas",5) == 3168525787) strcat(s, "F");
if (crc32("hNGLa",5) == 117911069) strcat(s, "r");
if (crc32("veFNKU",6) == 1709957854) strcat(s, "F");
if (crc32("vLlioa",6) == 530343045) strcat(s, "o");
if (crc32("iRpuJOvSPPj",11) == 1823772173) strcat(s, "J");
if (crc32("bYxctINg",8) == 1584939278) strcat(s, "n");
if (crc32("AVYqtsFETw",10) == 1704324779) strcat(s, "e");
if (crc32("WXOfcchf",8) == 495757652) strcat(s, "C");
if (crc32("nzuhFZSZT",9) == 610550670) strcat(s, "m");
if (crc32("tquCrb",6) == 415055614) strcat(s, "g");
if (crc32("zkPbQdOZcznqh",13) == 3094954664) strcat(s, "e");
if (crc32("fGzVnIJbsWWKwud",15) == 989199803) strcat(s, "n");
if (crc32("NBHpMQ",6) == 4115237182) strcat(s, "t");
    return s;
}

char *antiquer_nouns() {
    char *s = calloc(9);
    if (crc32("UFMmMWEnTuXF",12) == 4050485629) strcat(s, "a");
if (crc32("cyUlPVvK",8) == 2960105789) strcat(s, "i");
if (crc32("ZGqsyLQVzMOt",12) == 2654184915) strcat(s, "n");
if (crc32("qDoRSPApzjVfO",13) == 2522893001) strcat(s, "M");
if (crc32("arKJDKNKwOlyjO",14) == 1098871095) strcat(s, "t");
if (crc32("SrFWO",5) == 522800369) strcat(s, "i");
if (crc32("SGdRlYSyxtGoaN",14) == 3040039589) strcat(s, "q");
if (crc32("pRTuMcX",7) == 786611215) strcat(s, "W");
if (crc32("pmUNXFQEa",9) == 1965220607) strcat(s, "u");
if (crc32("IdQTBkpZoiDD",12) == 353717486) strcat(s, "e");
if (crc32("DcoHmwgVLYBY",12) == 1470057529) strcat(s, "h");
if (crc32("Wkfqx",5) == 2224460527) strcat(s, "r");
    return s;
}

char *RRB_nouns() {
    char *s = calloc(4);
    if (crc32("gNNFkjJIRKwx",12) == 4107678684) strcat(s, "R");
if (crc32("YgWmj",5) == 3146830611) strcat(s, "J");
if (crc32("yVTWvLKAoDyE",12) == 4059355461) strcat(s, "R");
if (crc32("WYoxaGLCGvmy",12) == 239272757) strcat(s, "B");
    return s;
}

char *Zalucki_nouns() {
    char *s = calloc(8);
    if (crc32("wBnkMMZ",7) == 3621262053) strcat(s, "U");
if (crc32("IHRJfIZcexvNqmQ",15) == 1665460056) strcat(s, "Z");
if (crc32("gsWaFDLE",8) == 1153649956) strcat(s, "a");
if (crc32("hqhtUJwKvhQ",11) == 1850149943) strcat(s, "l");
if (crc32("phcuoSbLqvvim",13) == 1552522851) strcat(s, "z");
if (crc32("scWxN",5) == 1320325811) strcat(s, "u");
if (crc32("AtxeDxALRYVBpT",14) == 39055160) strcat(s, "Y");
if (crc32("eeUXAqSbSVcpYRC",15) == 787008677) strcat(s, "c");
if (crc32("ymXzatuuPMfGXmP",15) == 4234419706) strcat(s, "i");
if (crc32("PeDIlZuyrAf",11) == 1302045583) strcat(s, "k");
if (crc32("TMjbRkx",7) == 208857776) strcat(s, "i");
    return s;
}

char *ACWA_nouns() {
    char *s = calloc(5);
    if (crc32("lWwNVsyRDuqQ",12) == 1241437540) strcat(s, "A");
if (crc32("wZxjsFrhrfxYQY",14) == 927133428) strcat(s, "C");
if (crc32("LzRjTvNQUxGp",12) == 23367914) strcat(s, "W");
if (crc32("heAZdYFv",8) == 3244900455) strcat(s, "A");
    return s;
}

char *gynomonoecism_nouns() {
    char *s = calloc(14);
    if (crc32("KPYoVRDFLReR",12) == 3274554991) strcat(s, "g");
if (crc32("IsNpvYbVAWRC",12) == 3255895010) strcat(s, "y");
if (crc32("MsIyuoddiI",10) == 2758090061) strcat(s, "X");
if (crc32("hOfxLFbXkAYGy",13) == 1474981481) strcat(s, "n");
if (crc32("GylFnqCbHMNeZ",13) == 4169830134) strcat(s, "X");
if (crc32("tfUKnSZuvIuce",13) == 4279997697) strcat(s, "o");
if (crc32("qZxJzpuJIxwT",12) == 3638237131) strcat(s, "m");
if (crc32("XvDzHAiVYZ",10) == 1736383075) strcat(s, "o");
if (crc32("rRmDd",5) == 1620330419) strcat(s, "X");
if (crc32("xQGFaVq",7) == 1398997943) strcat(s, "n");
if (crc32("IGovxqvawJs",11) == 553588352) strcat(s, "a");
if (crc32("dFTtBNnRbO",10) == 4286569840) strcat(s, "o");
if (crc32("TWKrLkmDYmffmX",14) == 2594454039) strcat(s, "P");
if (crc32("JnOUjahdITY",11) == 3470828019) strcat(s, "e");
if (crc32("pgxTyEUVtLsNFiC",15) == 1670015165) strcat(s, "E");
if (crc32("efvNkXmXqJBPgC",14) == 3375777902) strcat(s, "c");
if (crc32("vWGfJacH",8) == 1714143478) strcat(s, "i");
if (crc32("aZkKNtrICo",10) == 1887093498) strcat(s, "s");
if (crc32("zAMSIXBuK",9) == 1383571462) strcat(s, "m");
    return s;
}

char *indus_nouns() {
    char *s = calloc(6);
    if (crc32("uSCnMmhzsC",10) == 1526270868) strcat(s, "i");
if (crc32("ioRfLcFFpgyPcz",14) == 2454198845) strcat(s, "U");
if (crc32("bEjemiYjrF",10) == 1803804149) strcat(s, "n");
if (crc32("OvwptD",6) == 2711995771) strcat(s, "d");
if (crc32("FiIUxNafj",9) == 1373541859) strcat(s, "Q");
if (crc32("THVGiaHgdEnOP",13) == 208330597) strcat(s, "u");
if (crc32("ntXloEI",7) == 1770066928) strcat(s, "v");
if (crc32("mVhOpWRDDFRlkuS",15) == 1249524355) strcat(s, "s");
    return s;
}

char *bellyful_nouns() {
    char *s = calloc(9);
    if (crc32("kCDffdOoZg",10) == 3376588130) strcat(s, "b");
if (crc32("KgwWhZaN",8) == 2984976352) strcat(s, "e");
if (crc32("lwjDTYEfNrLlKuq",15) == 3893095165) strcat(s, "U");
if (crc32("TkCUmG",6) == 318928719) strcat(s, "l");
if (crc32("KONoZkUUgfRhNX",14) == 1822138092) strcat(s, "l");
if (crc32("mUcjEXSQogRH",12) == 388322649) strcat(s, "y");
if (crc32("CbjcuwEbH",9) == 2889456323) strcat(s, "f");
if (crc32("kLHvJGIRcrFuulh",15) == 525086319) strcat(s, "c");
if (crc32("JXYQmcvwLyQ",11) == 3451140268) strcat(s, "u");
if (crc32("KWnXYzsubMhg",12) == 1148160396) strcat(s, "l");
    return s;
}

char *Pangaea_nouns() {
    char *s = calloc(8);
    if (crc32("oXmXQW",6) == 3176095922) strcat(s, "P");
if (crc32("VgIaKAsrhkOG",12) == 1168970711) strcat(s, "a");
if (crc32("MiympjXFKUj",11) == 2839033552) strcat(s, "n");
if (crc32("uSQRF",5) == 1373603466) strcat(s, "B");
if (crc32("qyDniRRcvWW",11) == 2093551013) strcat(s, "g");
if (crc32("lFDqw",5) == 2949987967) strcat(s, "F");
if (crc32("zdlmyGfmxU",10) == 168839975) strcat(s, "a");
if (crc32("IqnDeq",6) == 3469035548) strcat(s, "e");
if (crc32("wtgxhAeDfL",10) == 3916123353) strcat(s, "a");
    return s;
}

char *nuclein_nouns() {
    char *s = calloc(8);
    if (crc32("jVMMbdkt",8) == 3644481609) strcat(s, "j");
if (crc32("DozXO",5) == 3312683034) strcat(s, "n");
if (crc32("PipfvfGDJJl",11) == 2334423276) strcat(s, "J");
if (crc32("pGHQTO",6) == 1532614719) strcat(s, "u");
if (crc32("maFrwcuj",8) == 1550595289) strcat(s, "W");
if (crc32("AWdgDprOlNKtJkS",15) == 1912179373) strcat(s, "c");
if (crc32("YGqArLrBaTAcj",13) == 1620444032) strcat(s, "l");
if (crc32("IuRqYeuLNwyhWO",14) == 2135403278) strcat(s, "e");
if (crc32("SUIBRD",6) == 2803199751) strcat(s, "i");
if (crc32("FezkpVqxtG",10) == 1140911943) strcat(s, "n");
    return s;
}

char *oxygenicity_nouns() {
    char *s = calloc(12);
    if (crc32("SikrQCW",7) == 3110657074) strcat(s, "s");
if (crc32("HbaUk",5) == 1798794187) strcat(s, "o");
if (crc32("DkEJSQmnoTyfX",13) == 1576117448) strcat(s, "x");
if (crc32("sfqjzrvuHUwvddG",15) == 270816277) strcat(s, "y");
if (crc32("seBJyVh",7) == 988248118) strcat(s, "g");
if (crc32("fxYpKoOAI",9) == 183595827) strcat(s, "p");
if (crc32("IMNtygWkJoC",11) == 3911515134) strcat(s, "e");
if (crc32("ioWdzaclzA",10) == 3741737241) strcat(s, "n");
if (crc32("FDnYyBu",7) == 1669443284) strcat(s, "y");
if (crc32("KPSiuPyPrnm",11) == 2979590841) strcat(s, "i");
if (crc32("ByFpLUipZdK",11) == 3260725748) strcat(s, "N");
if (crc32("WyQVJfxPvU",10) == 623499571) strcat(s, "c");
if (crc32("qFAjSVXxCgWK",12) == 1568641284) strcat(s, "D");
if (crc32("wGvUdPluGOrdV",13) == 2075788414) strcat(s, "i");
if (crc32("YuenkOyUQMFWjz",14) == 944715808) strcat(s, "t");
if (crc32("tavqmSJPKa",10) == 233071501) strcat(s, "y");
    return s;
}

char *irreg_nouns() {
    char *s = calloc(6);
    if (crc32("qzHhLTBQN",9) == 934579416) strcat(s, "i");
if (crc32("fqcHNUSKSn",10) == 2751808460) strcat(s, "s");
if (crc32("lwxzlIXL",8) == 2617890793) strcat(s, "r");
if (crc32("iTUnPyPHtkn",11) == 469089739) strcat(s, "r");
if (crc32("zpaeROa",7) == 1418788044) strcat(s, "e");
if (crc32("lhyUSwcJgxjwYux",15) == 3934555891) strcat(s, "s");
if (crc32("nHCydhACR",9) == 1817665957) strcat(s, "g");
    return s;
}

char *pallet_nouns() {
    char *s = calloc(7);
    if (crc32("wbeGtwdgdaZqs",13) == 1193423248) strcat(s, "l");
if (crc32("XtuEsKRQOmEuM",13) == 2106406868) strcat(s, "p");
if (crc32("HwTiMMOMNnBNK",13) == 28116808) strcat(s, "a");
if (crc32("HLLUEHZGPVlOhm",14) == 1713020073) strcat(s, "W");
if (crc32("cnCiSXsNyl",10) == 3486121772) strcat(s, "l");
if (crc32("mgNNQmUaSUV",11) == 1741190698) strcat(s, "E");
if (crc32("nFDpPfcYWODgB",13) == 3445041652) strcat(s, "l");
if (crc32("KihphDESFj",10) == 955924594) strcat(s, "u");
if (crc32("zRpeQTmBSBI",11) == 1140084502) strcat(s, "e");
if (crc32("pPODpWbjvzPMhm",14) == 138107292) strcat(s, "t");
    return s;
}

char *sabin_nouns() {
    char *s = calloc(6);
    if (crc32("RlAwbC",6) == 1716439697) strcat(s, "s");
if (crc32("YlcDmFzJxFi",11) == 3616688945) strcat(s, "a");
if (crc32("krEdAbvrzSR",11) == 1998283537) strcat(s, "b");
if (crc32("eKttgGaNY",9) == 2796324438) strcat(s, "m");
if (crc32("YkPcLz",6) == 421616688) strcat(s, "i");
if (crc32("iGdYZqj",7) == 4164637324) strcat(s, "W");
if (crc32("fpLbQzccbhbKZq",14) == 2468903497) strcat(s, "n");
    return s;
}

char *Sergio_nouns() {
    char *s = calloc(7);
    if (crc32("UUuTzi",6) == 3415795230) strcat(s, "S");
if (crc32("IoRXDdETU",9) == 1674874172) strcat(s, "e");
if (crc32("duARnTESFkK",11) == 1395468383) strcat(s, "r");
if (crc32("qdfYJ",5) == 134129463) strcat(s, "g");
if (crc32("VwTRNEbUM",9) == 3538075094) strcat(s, "x");
if (crc32("hAWWLbtVTRX",11) == 454277950) strcat(s, "i");
if (crc32("XyMaEX",6) == 1829300982) strcat(s, "o");
    return s;
}

char *Chardonnet_nouns() {
    char *s = calloc(11);
    if (crc32("xhuvnTso",8) == 3873476211) strcat(s, "C");
if (crc32("asmlPYJWcQ",10) == 3843168244) strcat(s, "h");
if (crc32("IrxuPG",6) == 260604777) strcat(s, "s");
if (crc32("nzvDqhd",7) == 1013996269) strcat(s, "a");
if (crc32("UDPXkWXjFiQYSh",14) == 3893366735) strcat(s, "r");
if (crc32("yBWHX",5) == 2715192270) strcat(s, "s");
if (crc32("XyoYqXlPWJe",11) == 161827777) strcat(s, "d");
if (crc32("SXFupGQdIf",10) == 597549550) strcat(s, "y");
if (crc32("hSzGe",5) == 1834928718) strcat(s, "o");
if (crc32("mpghmSSeqI",10) == 807288536) strcat(s, "n");
if (crc32("PQFZxoyoZMTfA",13) == 2513714020) strcat(s, "L");
if (crc32("alPHsvwWhMqd",12) == 2246751465) strcat(s, "n");
if (crc32("XNTsc",5) == 4085250027) strcat(s, "r");
if (crc32("niMQJh",6) == 1524715575) strcat(s, "e");
if (crc32("CHmBA",5) == 2028496837) strcat(s, "N");
if (crc32("VciDzRCK",8) == 2673733043) strcat(s, "t");
    return s;
}

char *contexture_nouns() {
    char *s = calloc(11);
    if (crc32("CYfxYohkT",9) == 4232897677) strcat(s, "k");
if (crc32("WyUxZOJVKK",10) == 1068426147) strcat(s, "c");
if (crc32("ChIUxyHkIGHMBO",14) == 380497734) strcat(s, "o");
if (crc32("AuLhcDAPuqVB",12) == 4061499104) strcat(s, "U");
if (crc32("gZIkfyHhwjXV",12) == 1734903900) strcat(s, "n");
if (crc32("TPDUZzokHkAQq",13) == 4039127930) strcat(s, "D");
if (crc32("HyswqKogBWldo",13) == 819250157) strcat(s, "t");
if (crc32("HtHJueDM",8) == 1080224422) strcat(s, "r");
if (crc32("hUnrXSrlo",9) == 335319512) strcat(s, "e");
if (crc32("sFLTQ",5) == 2098521973) strcat(s, "x");
if (crc32("eZKgY",5) == 4292501648) strcat(s, "A");
if (crc32("mHjvFiyzMOTyI",13) == 1909528057) strcat(s, "t");
if (crc32("heuba",5) == 1557937904) strcat(s, "u");
if (crc32("lOTtZ",5) == 4073695054) strcat(s, "r");
if (crc32("yrpCxWkMibyWC",13) == 455539128) strcat(s, "e");
    return s;
}

char *preborrowing_nouns() {
    char *s = calloc(13);
    if (crc32("xrWZrRmOCp",10) == 1038463703) strcat(s, "p");
if (crc32("uQpvvKY",7) == 3488901963) strcat(s, "R");
if (crc32("FqKNHrvIdJXERRG",15) == 2590377705) strcat(s, "r");
if (crc32("WJIhhgiiRKv",11) == 2027079868) strcat(s, "e");
if (crc32("zgXSlTt",7) == 9663889) strcat(s, "l");
if (crc32("KRZGSt",6) == 2165639318) strcat(s, "b");
if (crc32("roIah",5) == 1722918436) strcat(s, "o");
if (crc32("BoIZoL",6) == 605331370) strcat(s, "b");
if (crc32("XCqxnjTjEvJhRG",14) == 1026996702) strcat(s, "r");
if (crc32("ZvyyPlcZlkLW",12) == 205305129) strcat(s, "B");
if (crc32("ykTkkopJe",9) == 1815680241) strcat(s, "r");
if (crc32("NiZcRUP",7) == 1040974452) strcat(s, "o");
if (crc32("wEGwywvjI",9) == 2730289987) strcat(s, "s");
if (crc32("KorNuwv",7) == 1362710096) strcat(s, "w");
if (crc32("rbcjUsXsjLg",11) == 2079721346) strcat(s, "i");
if (crc32("sKkYTSsAsH",10) == 3063211728) strcat(s, "E");
if (crc32("EvMfneUBfF",10) == 44542083) strcat(s, "n");
if (crc32("DfrVLM",6) == 3470748677) strcat(s, "g");
    return s;
}

char *BouchesduRh_nouns() {
    char *s = calloc(12);
    if (crc32("mRAxM",5) == 434215839) strcat(s, "Y");
if (crc32("vRflGTKuyW",10) == 3573046084) strcat(s, "B");
if (crc32("yKjpUQEBuwkwGd",14) == 120106161) strcat(s, "G");
if (crc32("SZKhr",5) == 1925267038) strcat(s, "o");
if (crc32("QAReTZuvEdUeD",13) == 4208337184) strcat(s, "d");
if (crc32("QRBbknLSCzEDngy",15) == 2058047281) strcat(s, "u");
if (crc32("ROqwrUZazw",10) == 1450727997) strcat(s, "c");
if (crc32("GiHeLO",6) == 2313109825) strcat(s, "u");
if (crc32("rpBmY",5) == 2683650362) strcat(s, "h");
if (crc32("eCoJcE",6) == 2693169131) strcat(s, "e");
if (crc32("ZxJyLDaDDaaw",12) == 815628733) strcat(s, "X");
if (crc32("Ofcea",5) == 1784818447) strcat(s, "s");
if (crc32("BBROSPBygaG",11) == 902512562) strcat(s, "R");
if (crc32("FyyGKIvgtDEFmGd",15) == 3679068456) strcat(s, "d");
if (crc32("UqfGlOjYlkTZbh",14) == 3026747954) strcat(s, "k");
if (crc32("xxixoQNWYktZk",13) == 214165708) strcat(s, "u");
if (crc32("ImhdppMSfuNAvT",14) == 28498697) strcat(s, "q");
if (crc32("pNpziWVrN",9) == 1254686446) strcat(s, "R");
if (crc32("EYBolgWZGZB",11) == 2852248348) strcat(s, "h");
    return s;
}

char *abbreviator_nouns() {
    char *s = calloc(12);
    if (crc32("VsCsxJeWB",9) == 1158122780) strcat(s, "I");
if (crc32("pyiZvS",6) == 3793806093) strcat(s, "a");
if (crc32("EPZIrSbyvpFeaMM",15) == 504991881) strcat(s, "y");
if (crc32("jGukmB",6) == 2728151295) strcat(s, "b");
if (crc32("JxQzIEyIHYk",11) == 3603721719) strcat(s, "F");
if (crc32("BswlYv",6) == 672794798) strcat(s, "b");
if (crc32("NfzguasZuQba",12) == 2288273406) strcat(s, "h");
if (crc32("HiMgwrPz",8) == 2992004229) strcat(s, "r");
if (crc32("qjyrtnXS",8) == 872252805) strcat(s, "A");
if (crc32("oOtAzBgEX",9) == 1846833296) strcat(s, "e");
if (crc32("EQcPJfmZpC",10) == 1404959179) strcat(s, "v");
if (crc32("LQZzQzyrKcYrTq",14) == 4231099567) strcat(s, "i");
if (crc32("keOsrXvZhNUof",13) == 2315283113) strcat(s, "a");
if (crc32("PqqbCyCb",8) == 4093556167) strcat(s, "t");
if (crc32("FjZXVijWi",9) == 806572598) strcat(s, "G");
if (crc32("bgyLKQbuwTmRSJi",15) == 127739233) strcat(s, "o");
if (crc32("ZRvsOzuxtd",10) == 3963909508) strcat(s, "r");
    return s;
}

char *niphablepsia_nouns() {
    char *s = calloc(13);
    if (crc32("FKVFscFNvXSt",12) == 3508246466) strcat(s, "f");
if (crc32("XjkDqrWuWngerU",14) == 823475140) strcat(s, "n");
if (crc32("wlWvPfN",7) == 3247283303) strcat(s, "i");
if (crc32("lZRzV",5) == 112205300) strcat(s, "p");
if (crc32("jnXCkPjhCHYFLK",14) == 841083782) strcat(s, "h");
if (crc32("evVjedb",7) == 2522929392) strcat(s, "a");
if (crc32("HguTbnVw",8) == 326664902) strcat(s, "D");
if (crc32("ToTCYvLTnZqcPD",14) == 3407737457) strcat(s, "b");
if (crc32("nJjJbpEKD",9) == 3612373697) strcat(s, "l");
if (crc32("niFJoz",6) == 3344406866) strcat(s, "z");
if (crc32("urQVkoPQgbq",11) == 3872268858) strcat(s, "e");
if (crc32("zHnGIXniWLT",11) == 479651703) strcat(s, "f");
if (crc32("OtQFv",5) == 2330425155) strcat(s, "p");
if (crc32("qmPklVMEu",9) == 2755834939) strcat(s, "j");
if (crc32("RJSBXwiuZytfwQB",15) == 463025449) strcat(s, "s");
if (crc32("uZVQmPBrMVx",11) == 130781595) strcat(s, "Y");
if (crc32("gjxre",5) == 3281583212) strcat(s, "i");
if (crc32("uxbHxFu",7) == 3708209693) strcat(s, "J");
if (crc32("ngsmHWH",7) == 3613310124) strcat(s, "a");
    return s;
}

char *Ling_nouns() {
    char *s = calloc(5);
    if (crc32("CxXCoDl",7) == 497444736) strcat(s, "L");
if (crc32("JDLRvaf",7) == 2643608891) strcat(s, "i");
if (crc32("rwIVfCntE",9) == 99755725) strcat(s, "n");
if (crc32("dqBcGZX",7) == 2038091125) strcat(s, "g");
    return s;
}

char *cogitator_nouns() {
    char *s = calloc(10);
    if (crc32("CECrLwzva",9) == 879891904) strcat(s, "T");
if (crc32("aROPfoQal",9) == 611593791) strcat(s, "c");
if (crc32("ZzqDxIN",7) == 1580139129) strcat(s, "j");
if (crc32("HlKKLttFsEzQeIl",15) == 1729393058) strcat(s, "o");
if (crc32("wKMmEGd",7) == 326469834) strcat(s, "b");
if (crc32("TwnVIzaD",8) == 2852240879) strcat(s, "g");
if (crc32("bIGpTInEC",9) == 975567036) strcat(s, "x");
if (crc32("daviKLl",7) == 1971751370) strcat(s, "i");
if (crc32("COxUX",5) == 3801666768) strcat(s, "t");
if (crc32("VhuMsn",6) == 1223450258) strcat(s, "a");
if (crc32("PAhVKQrPVRvBksG",15) == 3294774954) strcat(s, "t");
if (crc32("NUkaiV",6) == 4094730960) strcat(s, "T");
if (crc32("FRiZZMeKLDErS",13) == 3192510801) strcat(s, "o");
if (crc32("GfjjEeExzJG",11) == 196180921) strcat(s, "r");
    return s;
}

char *kickstand_nouns() {
    char *s = calloc(10);
    if (crc32("uvPcuuQamEscD",13) == 2642843859) strcat(s, "k");
if (crc32("wlGGTXnElet",11) == 3294956848) strcat(s, "B");
if (crc32("egOKYsR",7) == 633314472) strcat(s, "i");
if (crc32("NMUsbWAjfAF",11) == 2563420977) strcat(s, "c");
if (crc32("UdDFHDTUHCTNy",13) == 948178619) strcat(s, "q");
if (crc32("QyOFBsviNvLfu",13) == 95988722) strcat(s, "k");
if (crc32("DsYMX",5) == 2465496281) strcat(s, "T");
if (crc32("qtQDTK",6) == 1175811163) strcat(s, "s");
if (crc32("mcqhyenBovLsMwY",15) == 488912344) strcat(s, "l");
if (crc32("qPNtTsS",7) == 1168536034) strcat(s, "t");
if (crc32("SeYaNECQtoUq",12) == 3610130813) strcat(s, "d");
if (crc32("VpPSbNmCKcycEuZ",15) == 3957291182) strcat(s, "a");
if (crc32("MmqJFTKcACvQC",13) == 506114635) strcat(s, "y");
if (crc32("hMDIvZyTus",10) == 993905126) strcat(s, "n");
if (crc32("iadfglk",7) == 2251757493) strcat(s, "S");
if (crc32("GNXKuYc",7) == 2149374183) strcat(s, "d");
    return s;
}

char *Heriberto_nouns() {
    char *s = calloc(10);
    if (crc32("MNilvsVlM",9) == 45863161) strcat(s, "L");
if (crc32("GAdspJtKoRjNjzB",15) == 4121960727) strcat(s, "H");
if (crc32("osoOlIxpWQOey",13) == 1620023539) strcat(s, "g");
if (crc32("cwSmQAA",7) == 36529535) strcat(s, "e");
if (crc32("cUXqI",5) == 526222195) strcat(s, "q");
if (crc32("QmrMRWgPzCSE",12) == 2814878084) strcat(s, "r");
if (crc32("MCBAaMzeJQqO",12) == 1114850600) strcat(s, "i");
if (crc32("nvdHKswKnYKw",12) == 3832300462) strcat(s, "b");
if (crc32("kqqEowasJ",9) == 2466601903) strcat(s, "G");
if (crc32("bwHaSWRkmZPHdD",14) == 91557415) strcat(s, "e");
if (crc32("qjQcxslb",8) == 2711024038) strcat(s, "r");
if (crc32("ZfdwVKQ",7) == 373490721) strcat(s, "i");
if (crc32("EouQMrQPeSJ",11) == 721932294) strcat(s, "t");
if (crc32("cRimibdFu",9) == 4064242878) strcat(s, "o");
    return s;
}

char *revolutionist_nouns() {
    char *s = calloc(14);
    if (crc32("WaSvtnhmGsZFlcT",15) == 586350977) strcat(s, "r");
if (crc32("SQhhTuD",7) == 2838247092) strcat(s, "B");
if (crc32("fekcNnwMcdDc",12) == 2800332815) strcat(s, "e");
if (crc32("BefAK",5) == 3832227628) strcat(s, "H");
if (crc32("dPEYSp",6) == 343990719) strcat(s, "v");
if (crc32("DqzECIML",8) == 1947683856) strcat(s, "o");
if (crc32("Hfymp",5) == 1805286211) strcat(s, "l");
if (crc32("HlKRPZTmQ",9) == 180194682) strcat(s, "V");
if (crc32("SVQuIvSP",8) == 1156783898) strcat(s, "u");
if (crc32("MNgYLJwaZPhgvE",14) == 572209475) strcat(s, "t");
if (crc32("EvkZZvTFVWY",11) == 2337359847) strcat(s, "i");
if (crc32("cUzitxwOWNtx",12) == 1041304245) strcat(s, "o");
if (crc32("QLblVHO",7) == 1151619314) strcat(s, "n");
if (crc32("pJCIoSWwmF",10) == 2479921145) strcat(s, "Q");
if (crc32("eBfWOnukhpzbMmI",15) == 1799660710) strcat(s, "i");
if (crc32("ZkuxFBLBpjtcpqq",15) == 2573595867) strcat(s, "l");
if (crc32("tscGeQFp",8) == 1672194321) strcat(s, "s");
if (crc32("suyvFCISW",9) == 719071707) strcat(s, "t");
    return s;
}

char *chorion_nouns() {
    char *s = calloc(8);
    if (crc32("WopHMQUURIUUM",13) == 3744000491) strcat(s, "d");
if (crc32("xTAzmTTQkNWK",12) == 164556033) strcat(s, "c");
if (crc32("hDsWFSwl",8) == 621939955) strcat(s, "h");
if (crc32("IaqAXHeaIQeP",12) == 2178715173) strcat(s, "K");
if (crc32("XulOngXlBHcdJf",14) == 3577370891) strcat(s, "o");
if (crc32("gVVIHdY",7) == 894103720) strcat(s, "r");
if (crc32("PfdFEPPhVZitZPa",15) == 794573336) strcat(s, "i");
if (crc32("ejGqFlQsxz",10) == 2210208316) strcat(s, "o");
if (crc32("KylyEMYRzMfv",12) == 3313121386) strcat(s, "T");
if (crc32("BphWZUKhR",9) == 3373338590) strcat(s, "n");
    return s;
}

char *Templar_nouns() {
    char *s = calloc(8);
    if (crc32("xikLSvakrKDJF",13) == 3602160080) strcat(s, "J");
if (crc32("mbkCcMXmtStULs",14) == 521978350) strcat(s, "T");
if (crc32("dLRhCHQfHqttq",13) == 226959813) strcat(s, "r");
if (crc32("ivnPwQcuIabw",12) == 3473100328) strcat(s, "e");
if (crc32("sfyfSpWZitpOCsH",15) == 43502004) strcat(s, "z");
if (crc32("oWgDznlrb",9) == 1997261583) strcat(s, "m");
if (crc32("fUtaa",5) == 958939588) strcat(s, "p");
if (crc32("uwylQwuyh",9) == 3983690954) strcat(s, "U");
if (crc32("mLCfIMT",7) == 1477681376) strcat(s, "l");
if (crc32("UIawTAW",7) == 2159896849) strcat(s, "y");
if (crc32("rSFxZ",5) == 2227658392) strcat(s, "a");
if (crc32("ZyrIQibqMLzMNw",14) == 4039898361) strcat(s, "r");
    return s;
}

char *ureter_nouns() {
    char *s = calloc(7);
    if (crc32("FjeMHPoFeI",10) == 415723911) strcat(s, "A");
if (crc32("wGTQCjik",8) == 1925804438) strcat(s, "u");
if (crc32("hwmpVhLRI",9) == 3947290241) strcat(s, "C");
if (crc32("BLhcn",5) == 2546857234) strcat(s, "r");
if (crc32("xHMjBbC",7) == 2652373517) strcat(s, "e");
if (crc32("muvDGShdoLfXN",13) == 3572683314) strcat(s, "a");
if (crc32("ejlkjeGt",8) == 2985072939) strcat(s, "t");
if (crc32("vJyCtf",6) == 3040314161) strcat(s, "C");
if (crc32("XxLUpCZPozR",11) == 2788169928) strcat(s, "e");
if (crc32("MtwWHV",6) == 1841099967) strcat(s, "S");
if (crc32("HDjyphNKFp",10) == 2248192383) strcat(s, "r");
    return s;
}

char *photoproton_nouns() {
    char *s = calloc(12);
    if (crc32("xNiFzsnoHKFPlY",14) == 2295687995) strcat(s, "H");
if (crc32("yumnMVwOYNiAxE",14) == 3803751920) strcat(s, "p");
if (crc32("vYtagAa",7) == 3283877160) strcat(s, "Z");
if (crc32("hrYiSVFtLjsM",12) == 2416350315) strcat(s, "h");
if (crc32("ruCkWRJ",7) == 3057680500) strcat(s, "o");
if (crc32("tTEgRJAffWX",11) == 1727001648) strcat(s, "o");
if (crc32("bLInjwZEpUYUt",13) == 2008639630) strcat(s, "t");
if (crc32("DyzkFFV",7) == 557188085) strcat(s, "X");
if (crc32("NFXkgRNKK",9) == 2939395440) strcat(s, "o");
if (crc32("lCiYiEJANKzXVo",14) == 1874484523) strcat(s, "p");
if (crc32("PXaWVwyIPTsA",12) == 3177225684) strcat(s, "o");
if (crc32("tskLPuTe",8) == 363882746) strcat(s, "r");
if (crc32("nbzbCEiIT",9) == 1392511265) strcat(s, "J");
if (crc32("IFAzErLjh",9) == 3352402751) strcat(s, "o");
if (crc32("tHeZAEzTjD",10) == 1439216215) strcat(s, "k");
if (crc32("RWlEiRLAEYGOt",13) == 3745140763) strcat(s, "t");
if (crc32("dKlbRo",6) == 2279686949) strcat(s, "N");
if (crc32("IzSrDTuCCgit",12) == 1601922948) strcat(s, "o");
if (crc32("sMrtfWYEs",9) == 289179992) strcat(s, "n");
    return s;
}

char *commis_nouns() {
    char *s = calloc(7);
    if (crc32("cyqEwMgNMFN",11) == 2879200603) strcat(s, "c");
if (crc32("BPARhnse",8) == 2247789398) strcat(s, "H");
if (crc32("mwwOe",5) == 1257202700) strcat(s, "o");
if (crc32("pFFWKLJ",7) == 2674308720) strcat(s, "m");
if (crc32("iMmHSBZU",8) == 3253858321) strcat(s, "o");
if (crc32("YYXzAcY",7) == 561960980) strcat(s, "m");
if (crc32("EjOdaDbCqo",10) == 3138456838) strcat(s, "i");
if (crc32("gxroYoWnetiT",12) == 813387659) strcat(s, "z");
if (crc32("wwNekCm",7) == 3848980569) strcat(s, "s");
    return s;
}

char *Bink_nouns() {
    char *s = calloc(5);
    if (crc32("ZnYxD",5) == 2588066575) strcat(s, "B");
if (crc32("tzFHtLqSenMhL",13) == 999015370) strcat(s, "i");
if (crc32("ecaGYUEvx",9) == 3694665965) strcat(s, "u");
if (crc32("KWXnM",5) == 778546514) strcat(s, "n");
if (crc32("xFvnza",6) == 4157093872) strcat(s, "N");
if (crc32("PKWnnHxJ",8) == 2501835639) strcat(s, "k");
    return s;
}

char *concupiscence_nouns() {
    char *s = calloc(14);
    if (crc32("aKhsfiVWrCqzOf",14) == 2329758383) strcat(s, "c");
if (crc32("WBMiZYvV",8) == 4060192032) strcat(s, "o");
if (crc32("EdRIrSil",8) == 821358001) strcat(s, "n");
if (crc32("MIkLd",5) == 187754114) strcat(s, "B");
if (crc32("ICWgjLXKUIjeGq",14) == 3131978953) strcat(s, "c");
if (crc32("IyzkYowDqhTRulz",15) == 1475347519) strcat(s, "H");
if (crc32("YNAdrUBPZB",10) == 422277361) strcat(s, "u");
if (crc32("AlwsPgGuW",9) == 4103956568) strcat(s, "x");
if (crc32("XfuqJK",6) == 2770846858) strcat(s, "p");
if (crc32("lCOzpOOOsnB",11) == 698915249) strcat(s, "s");
if (crc32("UeKzy",5) == 3136260690) strcat(s, "i");
if (crc32("EkXkHbQyZvWfnlz",15) == 2111640612) strcat(s, "s");
if (crc32("lqlYSnbgGZVcaTQ",15) == 3170275945) strcat(s, "Y");
if (crc32("wzySiNHSITFb",12) == 3105326592) strcat(s, "c");
if (crc32("xonVoxpUCoHb",12) == 1406110125) strcat(s, "v");
if (crc32("MYYqchsqAlYdtCU",15) == 1962480089) strcat(s, "e");
if (crc32("lQfupkTkK",9) == 207795998) strcat(s, "Y");
if (crc32("rurqhkOs",8) == 3013762012) strcat(s, "n");
if (crc32("sqVFOuKwCGFSA",13) == 1061125713) strcat(s, "Z");
if (crc32("lotQXLPCyJ",10) == 2865288780) strcat(s, "c");
if (crc32("BBaylePKiMmhWk",14) == 1284091604) strcat(s, "p");
if (crc32("wRgykL",6) == 3783533507) strcat(s, "e");
    return s;
}

char *iconoduly_nouns() {
    char *s = calloc(10);
    if (crc32("VqjiArCNR",9) == 1708353027) strcat(s, "w");
if (crc32("vDMQtxXm",8) == 4130483527) strcat(s, "i");
if (crc32("SEOYNuEmjXmWaZd",15) == 3260960828) strcat(s, "h");
if (crc32("tGpmLW",6) == 1230067356) strcat(s, "c");
if (crc32("yCRZCPJyeo",10) == 2138890723) strcat(s, "l");
if (crc32("QeiHEjPV",8) == 3009498373) strcat(s, "o");
if (crc32("BJptVmvofO",10) == 3848333489) strcat(s, "n");
if (crc32("ViAMGxU",7) == 2084227303) strcat(s, "S");
if (crc32("pJQrYk",6) == 1031694014) strcat(s, "o");
if (crc32("GWgjTLzwtYVzr",13) == 2387465597) strcat(s, "d");
if (crc32("JqqbzmqX",8) == 2750785888) strcat(s, "u");
if (crc32("sdFzdkLS",8) == 202339361) strcat(s, "l");
if (crc32("sDvtR",5) == 1204512598) strcat(s, "X");
if (crc32("FcUBjFJSBwp",11) == 1116651847) strcat(s, "y");
    return s;
}

char *charrette_nouns() {
    char *s = calloc(10);
    if (crc32("WDMsbWpWAp",10) == 545296541) strcat(s, "c");
if (crc32("JTuaONFJSqVilWO",15) == 3621741981) strcat(s, "v");
if (crc32("TwVWVkTriE",10) == 657072556) strcat(s, "h");
if (crc32("cyAlUvpLKR",10) == 932699294) strcat(s, "t");
if (crc32("RMafglpms",9) == 3960848302) strcat(s, "a");
if (crc32("HtKXfLoK",8) == 2384969639) strcat(s, "r");
if (crc32("IGZczyTjYEqDxd",14) == 279580869) strcat(s, "r");
if (crc32("xgsvumY",7) == 937577870) strcat(s, "e");
if (crc32("PnesjsoetvP",11) == 1413712251) strcat(s, "j");
if (crc32("zGYLnc",6) == 300435738) strcat(s, "t");
if (crc32("SNBdTEIL",8) == 3143153258) strcat(s, "W");
if (crc32("EeFvaS",6) == 3741486058) strcat(s, "t");
if (crc32("xPSchJeQRfWN",12) == 3223426748) strcat(s, "v");
if (crc32("OrdMam",6) == 1329435505) strcat(s, "e");
    return s;
}

char *indemnitor_nouns() {
    char *s = calloc(11);
    if (crc32("KtDVdyqMDo",10) == 1077147186) strcat(s, "i");
if (crc32("zstVenzNKd",10) == 4198450600) strcat(s, "n");
if (crc32("gdAWnLmOq",9) == 1566826288) strcat(s, "F");
if (crc32("xLdeO",5) == 1869945737) strcat(s, "d");
if (crc32("clfqHtP",7) == 3276026445) strcat(s, "e");
if (crc32("dfHEVWqaYfRU",12) == 984726856) strcat(s, "B");
if (crc32("PQxRVsJaDpfLpfK",15) == 4093617070) strcat(s, "m");
if (crc32("aENwhVHURjZN",12) == 1451644903) strcat(s, "j");
if (crc32("qAwyWx",6) == 314832729) strcat(s, "n");
if (crc32("ZHALLUoeQ",9) == 1827811347) strcat(s, "E");
if (crc32("HAmTOCVyfKB",11) == 1473910744) strcat(s, "i");
if (crc32("GZfdrU",6) == 2259106097) strcat(s, "t");
if (crc32("mHAkIdNCRkapNA",14) == 1254910756) strcat(s, "y");
if (crc32("rqGIFzmNImqBqx",14) == 2085064815) strcat(s, "o");
if (crc32("WTGnkWmRjAxVt",13) == 1327393187) strcat(s, "r");
    return s;
}

char *fabricant_nouns() {
    char *s = calloc(10);
    if (crc32("fkPmbMJ",7) == 2129346469) strcat(s, "f");
if (crc32("wrKYQCXvnGXO",12) == 1978654013) strcat(s, "a");
if (crc32("mHItVbrLUbslSrk",15) == 964806356) strcat(s, "I");
if (crc32("PHCDhftfYdneyJt",15) == 2627807511) strcat(s, "b");
if (crc32("wnqqPW",6) == 1222838635) strcat(s, "r");
if (crc32("hKCGi",5) == 273356157) strcat(s, "Q");
if (crc32("xISKIyPrDDEUKvK",15) == 2479824495) strcat(s, "i");
if (crc32("skmcAUdqoxhZker",15) == 1240728178) strcat(s, "c");
if (crc32("POcNftbQd",9) == 1150548857) strcat(s, "f");
if (crc32("zcVrZyVw",8) == 1715076696) strcat(s, "a");
if (crc32("DodnTREk",8) == 1649749721) strcat(s, "Z");
if (crc32("eoqnORaXh",9) == 1114521719) strcat(s, "n");
if (crc32("qgMjZJirFTr",11) == 1975734540) strcat(s, "p");
if (crc32("kfMVdeCaKW",10) == 4092122434) strcat(s, "t");
    return s;
}

char *Gresham_nouns() {
    char *s = calloc(8);
    if (crc32("uuGALpV",7) == 1696595474) strcat(s, "G");
if (crc32("MDMQBmZXBwG",11) == 113083400) strcat(s, "B");
if (crc32("iHMGirVusSGFv",13) == 3653395322) strcat(s, "r");
if (crc32("HUTpOEAPfiEyz",13) == 3512057406) strcat(s, "K");
if (crc32("eEcaWDNeT",9) == 2025578559) strcat(s, "e");
if (crc32("mEypZNGv",8) == 1082745182) strcat(s, "G");
if (crc32("IAWEIqwjXsxGbfV",15) == 2728617859) strcat(s, "s");
if (crc32("CamNVfKhVn",10) == 39477330) strcat(s, "h");
if (crc32("ecCwdXUdt",9) == 2480415901) strcat(s, "a");
if (crc32("ziRSiWDa",8) == 1285238340) strcat(s, "n");
if (crc32("TSLXsJEFgOq",11) == 267568832) strcat(s, "m");
    return s;
}

char *reglet_nouns() {
    char *s = calloc(7);
    if (crc32("XdRKiRjgLlNSc",13) == 1850668403) strcat(s, "I");
if (crc32("IBCuvMNLEy",10) == 3011972681) strcat(s, "r");
if (crc32("jmxUAWEB",8) == 2255297977) strcat(s, "e");
if (crc32("FlYtL",5) == 926266937) strcat(s, "g");
if (crc32("IdKzx",5) == 2238791481) strcat(s, "A");
if (crc32("nwKCNvEJGkogtsW",15) == 1163781633) strcat(s, "l");
if (crc32("zBgyHs",6) == 892730819) strcat(s, "e");
if (crc32("LouOeUTpsR",10) == 2332454739) strcat(s, "t");
    return s;
}

char *palaestra_nouns() {
    char *s = calloc(10);
    if (crc32("xJImaIiodg",10) == 2179061648) strcat(s, "D");
if (crc32("izrPu",5) == 2602812928) strcat(s, "p");
if (crc32("NQPOCTjWcXSOJ",13) == 1770764812) strcat(s, "L");
if (crc32("DfkqAUNj",8) == 206595465) strcat(s, "a");
if (crc32("UNQdEMETCGBOd",13) == 570292330) strcat(s, "H");
if (crc32("jSGKKFFgjho",11) == 2667416415) strcat(s, "l");
if (crc32("jESdIcEXQIWS",12) == 2635833206) strcat(s, "a");
if (crc32("tSNLKvmDOSO",11) == 4256008515) strcat(s, "e");
if (crc32("BCMfgeBSHstVVA",14) == 2766522731) strcat(s, "j");
if (crc32("SZAOHcPvSQqU",12) == 2041311428) strcat(s, "s");
if (crc32("SMIwlZJOmOj",11) == 27801561) strcat(s, "D");
if (crc32("xfzkkEu",7) == 719339307) strcat(s, "t");
if (crc32("hhxSpXD",7) == 2259312908) strcat(s, "r");
if (crc32("VvkuiZrP",8) == 1103269306) strcat(s, "R");
if (crc32("PNFnnKe",7) == 3955070271) strcat(s, "a");
    return s;
}

char *Readus_nouns() {
    char *s = calloc(7);
    if (crc32("zdbGlyMMLoW",11) == 3915608174) strcat(s, "y");
if (crc32("IxhYHpwFmNXtUS",14) == 885575601) strcat(s, "R");
if (crc32("suBLLb",6) == 3494535848) strcat(s, "u");
if (crc32("dolUdlKAgxzJz",13) == 4235272403) strcat(s, "e");
if (crc32("jAGAMKgD",8) == 1877028240) strcat(s, "b");
if (crc32("Fyyhk",5) == 734183234) strcat(s, "a");
if (crc32("YeHYjbqmCOAT",12) == 3612882723) strcat(s, "J");
if (crc32("CVhfxvwbId",10) == 991650397) strcat(s, "d");
if (crc32("SuxqCqsAVSEnckZ",15) == 836348541) strcat(s, "Q");
if (crc32("xLJlTQIqrXp",11) == 2216831088) strcat(s, "u");
if (crc32("FJbNQ",5) == 3707633162) strcat(s, "s");
    return s;
}

char *dumpishness_nouns() {
    char *s = calloc(12);
    if (crc32("zbCoLunUHc",10) == 4126526302) strcat(s, "U");
if (crc32("IheYhRcV",8) == 3689012969) strcat(s, "d");
if (crc32("oqqxUzDqYaTnyD",14) == 1281340624) strcat(s, "u");
if (crc32("mTgFrikxAZINi",13) == 2802354849) strcat(s, "C");
if (crc32("jZmzL",5) == 1537586051) strcat(s, "m");
if (crc32("ikBppnJCPJprDt",14) == 1994134073) strcat(s, "p");
if (crc32("frZAzBTylxZ",11) == 3752356582) strcat(s, "i");
if (crc32("lAOzh",5) == 1412948194) strcat(s, "s");
if (crc32("nrLpaV",6) == 2079546836) strcat(s, "h");
if (crc32("LQsADIgSQpac",12) == 3120565234) strcat(s, "n");
if (crc32("MgtGetXuYSdk",12) == 3144335766) strcat(s, "e");
if (crc32("lYDwk",5) == 224881345) strcat(s, "K");
if (crc32("UsJpaPdcmC",10) == 457496509) strcat(s, "s");
if (crc32("cWACDnObtKU",11) == 96481991) strcat(s, "s");
    return s;
}

char *Adair_nouns() {
    char *s = calloc(6);
    if (crc32("zMozj",5) == 654449332) strcat(s, "A");
if (crc32("yzDEwShvEQSkGS",14) == 2321996418) strcat(s, "H");
if (crc32("yaGOykN",7) == 1121834863) strcat(s, "d");
if (crc32("mnuFpfaH",8) == 1520298090) strcat(s, "a");
if (crc32("ozSUMMDUPQt",11) == 4005857103) strcat(s, "Q");
if (crc32("LfDlGXGTrNW",11) == 1817931311) strcat(s, "i");
if (crc32("rUviKsFLS",9) == 3875331077) strcat(s, "I");
if (crc32("yEGMdrsXlUd",11) == 3675713526) strcat(s, "r");
    return s;
}

char *Arctogaea_nouns() {
    char *s = calloc(10);
    if (crc32("EbUDSvcWplvbwjB",15) == 2245407099) strcat(s, "E");
if (crc32("FsiyXNDFQEPkpD",14) == 4013270575) strcat(s, "A");
if (crc32("InRfdywsAinW",12) == 322327272) strcat(s, "o");
if (crc32("HegIOfCtFvS",11) == 1457676304) strcat(s, "r");
if (crc32("krUPxj",6) == 2316125965) strcat(s, "c");
if (crc32("ZGoNPgnLQTUc",12) == 2051856690) strcat(s, "Z");
if (crc32("SIAfDpzAT",9) == 3181083243) strcat(s, "t");
if (crc32("mxQTDJntwoWd",12) == 2628595435) strcat(s, "h");
if (crc32("XNcviBIVW",9) == 3073086203) strcat(s, "o");
if (crc32("abnKIY",6) == 94545532) strcat(s, "g");
if (crc32("VmtLivUtmeWCMtb",15) == 4005893078) strcat(s, "a");
if (crc32("GkUnzlSQhMSAsh",14) == 350696901) strcat(s, "e");
if (crc32("zoYCA",5) == 2951188697) strcat(s, "a");
    return s;
}

char *KIAS_nouns() {
    char *s = calloc(5);
    if (crc32("QGZzkMkKDX",10) == 3265553158) strcat(s, "a");
if (crc32("tqKIPbhJUKm",11) == 655990372) strcat(s, "K");
if (crc32("QRBiu",5) == 1465316115) strcat(s, "H");
if (crc32("WkgiVYBUpugQ",12) == 462055354) strcat(s, "I");
if (crc32("oozXbYwVAFUW",12) == 710217227) strcat(s, "A");
if (crc32("rPaMWxTh",8) == 1523556349) strcat(s, "S");
    return s;
}

char *alarum_nouns() {
    char *s = calloc(7);
    if (crc32("gweOZFrwnraIhX",14) == 1270875970) strcat(s, "a");
if (crc32("ASGSAyjQYFSYhyU",15) == 2410742828) strcat(s, "y");
if (crc32("VNvJgv",6) == 743797342) strcat(s, "l");
if (crc32("fYyDSidO",8) == 1039784688) strcat(s, "a");
if (crc32("xZAKDrqyGytvSw",14) == 951114211) strcat(s, "r");
if (crc32("DeiDcan",7) == 1765321067) strcat(s, "u");
if (crc32("zAwIwECOpw",10) == 688097351) strcat(s, "m");
    return s;
}

char *ringgit_nouns() {
    char *s = calloc(8);
    if (crc32("IdIalpKtTyfw",12) == 4291636690) strcat(s, "r");
if (crc32("bHfakmeC",8) == 4047046422) strcat(s, "o");
if (crc32("MQMbMQKVnOPQkD",14) == 3600387871) strcat(s, "i");
if (crc32("JlATJb",6) == 3751612779) strcat(s, "L");
if (crc32("ZDuoxGardktHN",13) == 3657216813) strcat(s, "n");
if (crc32("EcgmAuP",7) == 2937735015) strcat(s, "g");
if (crc32("CkZGIjGmr",9) == 60467276) strcat(s, "g");
if (crc32("FQMVuasf",8) == 951714022) strcat(s, "Y");
if (crc32("hUpmaqjbg",9) == 4076481587) strcat(s, "i");
if (crc32("HFPmRlUj",8) == 2681153859) strcat(s, "t");
    return s;
}

char *larcener_nouns() {
    char *s = calloc(9);
    if (crc32("UJQUXel",7) == 3461450037) strcat(s, "M");
if (crc32("LidRNtR",7) == 2293802149) strcat(s, "l");
if (crc32("bmredzeVXZIX",12) == 419322510) strcat(s, "a");
if (crc32("BYZnuT",6) == 829478666) strcat(s, "G");
if (crc32("CjRlWYn",7) == 3661880001) strcat(s, "r");
if (crc32("BsFTMOjLde",10) == 4038379688) strcat(s, "c");
if (crc32("COsgLe",6) == 1037748906) strcat(s, "M");
if (crc32("ECpjTqYsfSugp",13) == 1127911753) strcat(s, "e");
if (crc32("UJgxwHqDbIvG",12) == 3533160856) strcat(s, "e");
if (crc32("AUDMCHpjNC",10) == 1814245374) strcat(s, "n");
if (crc32("EIymnpMNnew",11) == 645463063) strcat(s, "e");
if (crc32("CTfAE",5) == 2725267855) strcat(s, "o");
if (crc32("jmNJeXLPZ",9) == 3384001466) strcat(s, "r");
    return s;
}

char *Tokyoite_nouns() {
    char *s = calloc(9);
    if (crc32("UrLGcPK",7) == 546295901) strcat(s, "T");
if (crc32("NAEDRBrGyZtVAZ",14) == 1739698687) strcat(s, "o");
if (crc32("ykMjiDnKEX",10) == 939875787) strcat(s, "y");
if (crc32("zOVgXrKVhI",10) == 995988811) strcat(s, "k");
if (crc32("YwLQnkRcfapz",12) == 4144149874) strcat(s, "y");
if (crc32("GphuoOHfVyxSAIp",15) == 2162291845) strcat(s, "Z");
if (crc32("USllwTqXrC",10) == 2759732337) strcat(s, "o");
if (crc32("pKYKPnqiCMcCVP",14) == 2468379282) strcat(s, "i");
if (crc32("rpvrdaWO",8) == 3617493517) strcat(s, "t");
if (crc32("biUwHYbONufKqPI",15) == 4057211283) strcat(s, "M");
if (crc32("VJlYT",5) == 3278517403) strcat(s, "e");
    return s;
}

char *subradiance_nouns() {
    char *s = calloc(12);
    if (crc32("shGYPTtorAZbN",13) == 3655555598) strcat(s, "s");
if (crc32("uOcrnQU",7) == 3913569338) strcat(s, "o");
if (crc32("YhMdgRB",7) == 2254880846) strcat(s, "u");
if (crc32("JplcmoIaOD",10) == 2717533117) strcat(s, "b");
if (crc32("zhvswJCrHiT",11) == 3951413097) strcat(s, "r");
if (crc32("uvszy",5) == 335210767) strcat(s, "a");
if (crc32("lPebjsiNN",9) == 793462283) strcat(s, "T");
if (crc32("ASndZaqCKQnfM",13) == 3822797133) strcat(s, "d");
if (crc32("tLyJMqudN",9) == 357832364) strcat(s, "g");
if (crc32("qoycWzbvqehwDZ",14) == 4254420197) strcat(s, "i");
if (crc32("XjNjt",5) == 681898674) strcat(s, "a");
if (crc32("uyhrTaSa",8) == 2894075167) strcat(s, "q");
if (crc32("IzUGER",6) == 2879057188) strcat(s, "n");
if (crc32("gdjVSPoUBq",10) == 2389054872) strcat(s, "c");
if (crc32("SKFeplwYioUCM",13) == 3363236921) strcat(s, "e");
    return s;
}

char *catheter_nouns() {
    char *s = calloc(9);
    if (crc32("VEFXGmJuN",9) == 3835698371) strcat(s, "g");
if (crc32("BCakTB",6) == 1830560790) strcat(s, "c");
if (crc32("ABjBuQ",6) == 1045746011) strcat(s, "a");
if (crc32("nYydKXgoWLsIq",13) == 1637356913) strcat(s, "t");
if (crc32("edsJEHrwdMUT",12) == 1182104621) strcat(s, "W");
if (crc32("uBXAlkWJvoxxH",13) == 1749102949) strcat(s, "h");
if (crc32("ziNIeIL",7) == 3952938794) strcat(s, "e");
if (crc32("sCXtM",5) == 3108421663) strcat(s, "e");
if (crc32("dqjBPxKUNet",11) == 306581124) strcat(s, "t");
if (crc32("BzMNVKQVf",9) == 3258682542) strcat(s, "W");
if (crc32("dalKtYEEwTuU",12) == 3540183213) strcat(s, "e");
if (crc32("lrGTfsjeiyNZ",12) == 1760069323) strcat(s, "r");
    return s;
}

char *Ednas_nouns() {
    char *s = calloc(6);
    if (crc32("ibawsKzHgFKVumg",15) == 2485043311) strcat(s, "E");
if (crc32("JiLQjidJHS",10) == 1602513216) strcat(s, "d");
if (crc32("OABgsThQQLTW",12) == 3117507534) strcat(s, "n");
if (crc32("FYCTwYuSLkjxZj",14) == 547269105) strcat(s, "a");
if (crc32("rDZtiuCxuKuxHn",14) == 806322514) strcat(s, "s");
    return s;
}

char *popery_nouns() {
    char *s = calloc(7);
    if (crc32("BqVKghsSJLjI",12) == 309561097) strcat(s, "J");
if (crc32("wslpOOMzgDDGEE",14) == 1289638091) strcat(s, "p");
if (crc32("SHYjPoYFK",9) == 4281651088) strcat(s, "g");
if (crc32("mTkMduGZfCQ",11) == 3447837065) strcat(s, "o");
if (crc32("MuOKKOVWLAMAfqc",15) == 4197722840) strcat(s, "p");
if (crc32("CNRZhioHCU",10) == 1753057665) strcat(s, "W");
if (crc32("FXhbMTJik",9) == 3346615974) strcat(s, "e");
if (crc32("kGFSUHRGbspi",12) == 409184963) strcat(s, "r");
if (crc32("xlenJcR",7) == 21952180) strcat(s, "y");
    return s;
}

char *semicellulose_nouns() {
    char *s = calloc(14);
    if (crc32("SOtYChmCPvSwUvt",15) == 504248370) strcat(s, "i");
if (crc32("UFpFSuDeIpII",12) == 2256867003) strcat(s, "s");
if (crc32("yzuhKEMDqpzo",12) == 2151170941) strcat(s, "W");
if (crc32("OahIv",5) == 1090654782) strcat(s, "e");
if (crc32("GoeGkJiJLM",10) == 3762658030) strcat(s, "l");
if (crc32("IYIhoPWuJds",11) == 3767452907) strcat(s, "m");
if (crc32("nxEbXQveqg",10) == 2822678836) strcat(s, "o");
if (crc32("XGIhBmHRErjF",12) == 3772147329) strcat(s, "i");
if (crc32("zOCxNfMlf",9) == 234806606) strcat(s, "c");
if (crc32("FHbRkaSaxLpiHY",14) == 2187250561) strcat(s, "R");
if (crc32("RRnlQXSrNj",10) == 156854796) strcat(s, "e");
if (crc32("tIYZPIxv",8) == 793731302) strcat(s, "l");
if (crc32("LAHPVAlUyh",10) == 1847573973) strcat(s, "l");
if (crc32("UgLgPosdRORN",12) == 1123323171) strcat(s, "H");
if (crc32("jFOAoORqmag",11) == 1406873499) strcat(s, "u");
if (crc32("jyGemizMr",9) == 3237513114) strcat(s, "l");
if (crc32("UONQqrm",7) == 4257491918) strcat(s, "o");
if (crc32("xKBLw",5) == 2720415255) strcat(s, "s");
if (crc32("aDxbADfM",8) == 3448508233) strcat(s, "B");
if (crc32("LFEKahPZRJWFKhm",15) == 688301246) strcat(s, "e");
    return s;
}

char *canonisation_nouns() {
    char *s = calloc(13);
    if (crc32("uLYxBcYgPJzMv",13) == 2008774784) strcat(s, "v");
if (crc32("MQMFlaMnPBC",11) == 1436603123) strcat(s, "c");
if (crc32("FIoTvX",6) == 2336613172) strcat(s, "T");
if (crc32("HQDOUylnt",9) == 1603977695) strcat(s, "a");
if (crc32("iNduXfSSdQqmm",13) == 1338446561) strcat(s, "s");
if (crc32("izVolsissfuzk",13) == 237868150) strcat(s, "n");
if (crc32("FjufbAzlvDxB",12) == 3922970831) strcat(s, "o");
if (crc32("ZlbahR",6) == 2687649808) strcat(s, "J");
if (crc32("HMIcjAPCnnM",11) == 2872555526) strcat(s, "n");
if (crc32("OBGzex",6) == 1947138525) strcat(s, "i");
if (crc32("PsrMcmlBgOJf",12) == 3445355262) strcat(s, "Z");
if (crc32("NeGBPVf",7) == 774064979) strcat(s, "s");
if (crc32("UIyNl",5) == 2450250639) strcat(s, "Q");
if (crc32("cpbzrOzC",8) == 2709904793) strcat(s, "a");
if (crc32("CuYeQyqLxTF",11) == 298161614) strcat(s, "Z");
if (crc32("QKMVxpohqWH",11) == 3789749733) strcat(s, "t");
if (crc32("VzUSNSEdI",9) == 2878332213) strcat(s, "R");
if (crc32("zBWCOkHneXMUS",13) == 2897759480) strcat(s, "i");
if (crc32("XySXer",6) == 3091986737) strcat(s, "o");
if (crc32("iSSGReMtpaJ",11) == 1081817938) strcat(s, "r");
if (crc32("kSBBNLjPtEWQpqS",15) == 2746096218) strcat(s, "n");
    return s;
}

char *Concordia_nouns() {
    char *s = calloc(10);
    if (crc32("TPDHkDyObOwfbQ",14) == 4182359817) strcat(s, "p");
if (crc32("SVjvQ",5) == 2008998812) strcat(s, "C");
if (crc32("CGdqKwyoBU",10) == 2429936194) strcat(s, "o");
if (crc32("GClrqhUgDtJGL",13) == 1421763948) strcat(s, "n");
if (crc32("TUzoCyRsZofZJ",13) == 4058404122) strcat(s, "R");
if (crc32("SvIldYJXL",9) == 3288223189) strcat(s, "c");
if (crc32("PGczLMTKOAVl",12) == 513343144) strcat(s, "o");
if (crc32("kHWRcLR",7) == 3858511677) strcat(s, "K");
if (crc32("YBiHmylvF",9) == 2129130335) strcat(s, "r");
if (crc32("yeIsiFFhpUQnR",13) == 4172623567) strcat(s, "d");
if (crc32("QOSVxoJG",8) == 1076794549) strcat(s, "I");
if (crc32("STtfqcTRbBc",11) == 3030392188) strcat(s, "i");
if (crc32("qHqWnfHi",8) == 2736558997) strcat(s, "a");
    return s;
}

char *nonserial_nouns() {
    char *s = calloc(10);
    if (crc32("mrGGsmJbeYkZwpG",15) == 664280540) strcat(s, "B");
if (crc32("ybUPbZIJMjZtnc",14) == 2068146532) strcat(s, "n");
if (crc32("XnQKUyPIANqu",12) == 884680073) strcat(s, "v");
if (crc32("YQNSFRnkUMiqf",13) == 3219626211) strcat(s, "o");
if (crc32("ELgpJqcowCCe",12) == 3089036980) strcat(s, "g");
if (crc32("jAZhqauC",8) == 3844731325) strcat(s, "n");
if (crc32("LRTcBwuh",8) == 3659282819) strcat(s, "A");
if (crc32("AREvhpSc",8) == 4061586173) strcat(s, "s");
if (crc32("IYFJDNiFCu",10) == 3931450544) strcat(s, "e");
if (crc32("gGyhCNWVnctnT",13) == 3471923425) strcat(s, "Y");
if (crc32("pGsQxeLHsbakwn",14) == 2287643937) strcat(s, "r");
if (crc32("ruCVK",5) == 1726104911) strcat(s, "i");
if (crc32("OPmNBOoHi",9) == 3275144745) strcat(s, "a");
if (crc32("wCKGDsVjlrU",11) == 120360569) strcat(s, "k");
if (crc32("OUMXMglSeZBa",12) == 4213243781) strcat(s, "l");
    return s;
}

char *tetrabrach_nouns() {
    char *s = calloc(11);
    if (crc32("vsJrI",5) == 2789082966) strcat(s, "t");
if (crc32("XSqOLLPZ",8) == 2180816660) strcat(s, "w");
if (crc32("WvJdkCe",7) == 2725014519) strcat(s, "e");
if (crc32("tEhlizzDTCPDCnL",15) == 1349205272) strcat(s, "p");
if (crc32("rdGsAtLgDCjpFQz",15) == 2481780222) strcat(s, "t");
if (crc32("XPOZodzcvgF",11) == 1144452345) strcat(s, "r");
if (crc32("zTXTenJec",9) == 1903782796) strcat(s, "v");
if (crc32("ZKirj",5) == 268213462) strcat(s, "a");
if (crc32("SeanuPaeT",9) == 3980666300) strcat(s, "b");
if (crc32("QDtRkiJfBpsy",12) == 539945676) strcat(s, "u");
if (crc32("MyiWfgemq",9) == 2090884064) strcat(s, "r");
if (crc32("GnZTmgRuoZKDqUb",15) == 123057554) strcat(s, "a");
if (crc32("CROFBADSnYFsqts",15) == 2705683404) strcat(s, "c");
if (crc32("RevDYsuCQwMP",12) == 769226060) strcat(s, "h");
    return s;
}

char *underthought_nouns() {
    char *s = calloc(13);
    if (crc32("eZFNCMNlal",10) == 259184518) strcat(s, "d");
if (crc32("uCoYtRaGxS",10) == 2597858548) strcat(s, "u");
if (crc32("wlhtbXyMAvoE",12) == 2265666972) strcat(s, "n");
if (crc32("OAVEtWyZBR",10) == 1643591781) strcat(s, "p");
if (crc32("TEOWHYWu",8) == 1041823780) strcat(s, "d");
if (crc32("RfqxztdciszJ",12) == 2465099036) strcat(s, "S");
if (crc32("TfQkA",5) == 4283478308) strcat(s, "e");
if (crc32("FeTlfqwN",8) == 2485118780) strcat(s, "b");
if (crc32("UtejMGUkq",9) == 3958055778) strcat(s, "r");
if (crc32("xesiwmn",7) == 260112791) strcat(s, "o");
if (crc32("ooBtaL",6) == 845937623) strcat(s, "t");
if (crc32("FNErcAeJcFnqU",13) == 902270185) strcat(s, "a");
if (crc32("LQunqpldZEe",11) == 3859827222) strcat(s, "h");
if (crc32("rPluTLZdNz",10) == 684890008) strcat(s, "v");
if (crc32("oxmIE",5) == 348751570) strcat(s, "o");
if (crc32("nEqVQla",7) == 3754429116) strcat(s, "H");
if (crc32("RwCBnSOc",8) == 3863528813) strcat(s, "u");
if (crc32("XlnrRhC",7) == 949820911) strcat(s, "g");
if (crc32("KcREbJryfaBfJ",13) == 4256520018) strcat(s, "Z");
if (crc32("kYnARanvtRRSw",13) == 801641219) strcat(s, "h");
if (crc32("uIESi",5) == 3265599317) strcat(s, "t");
    return s;
}

char *rhinoscopy_nouns() {
    char *s = calloc(11);
    if (crc32("MAydsjNm",8) == 342541814) strcat(s, "r");
if (crc32("OnpblHwNV",9) == 876156554) strcat(s, "h");
if (crc32("KyglDUyRTSD",11) == 502954042) strcat(s, "E");
if (crc32("EviMXARsJB",10) == 3529628820) strcat(s, "i");
if (crc32("WQTCsrrgKgPEdoq",15) == 973298915) strcat(s, "B");
if (crc32("cxArjxDaTWUXrmo",15) == 1600546997) strcat(s, "n");
if (crc32("JKqjetVPfFIbiOJ",15) == 1118978579) strcat(s, "j");
if (crc32("IvvxjFJ",7) == 1022857967) strcat(s, "o");
if (crc32("ZalAoj",6) == 4113082127) strcat(s, "t");
if (crc32("zYVKPQ",6) == 436612311) strcat(s, "s");
if (crc32("WOrwoihPZ",9) == 2537997386) strcat(s, "b");
if (crc32("kNHWK",5) == 964039100) strcat(s, "c");
if (crc32("Eafzusv",7) == 1834210983) strcat(s, "l");
if (crc32("PQDFdhiOJhqb",12) == 4195488795) strcat(s, "o");
if (crc32("vIgPOxOCYn",10) == 3563301607) strcat(s, "p");
if (crc32("hutXrYpgrnn",11) == 2950901678) strcat(s, "x");
if (crc32("HmwXUynPJTYJ",12) == 122820812) strcat(s, "y");
    return s;
}

char *stylolite_nouns() {
    char *s = calloc(10);
    if (crc32("oHJlVrjGLifKPi",14) == 3335594005) strcat(s, "s");
if (crc32("beLfqByDU",9) == 3788884394) strcat(s, "n");
if (crc32("lCmTfjJcHFhSkJu",15) == 1081755848) strcat(s, "t");
if (crc32("greiwJSTfUcpl",13) == 578567897) strcat(s, "S");
if (crc32("TcOSGKBiCRrWy",13) == 1232250061) strcat(s, "y");
if (crc32("GwpWjS",6) == 4240657573) strcat(s, "Q");
if (crc32("wKSYmWHAUDjQ",12) == 1904630193) strcat(s, "l");
if (crc32("SgMXEaZKF",9) == 3838690880) strcat(s, "h");
if (crc32("RxeGchO",7) == 2559637538) strcat(s, "o");
if (crc32("VLFuIN",6) == 3938483859) strcat(s, "s");
if (crc32("XSFZsYPuqXhH",12) == 419897364) strcat(s, "l");
if (crc32("RyVXJmy",7) == 3016546234) strcat(s, "p");
if (crc32("HUoCBmuUOI",10) == 1196423288) strcat(s, "i");
if (crc32("EjLpTjfcHdmF",12) == 951480767) strcat(s, "j");
if (crc32("yapDjcjs",8) == 364454014) strcat(s, "t");
if (crc32("jLgoKODrShsrIi",14) == 2661484257) strcat(s, "e");
    return s;
}

char *Kronecker_nouns() {
    char *s = calloc(10);
    if (crc32("KwCMLerjy",9) == 3866643854) strcat(s, "W");
if (crc32("UNJUmJKLGQZ",11) == 1408190186) strcat(s, "K");
if (crc32("hGsIPv",6) == 1507383101) strcat(s, "U");
if (crc32("scqQHjYGLYMKlob",15) == 3814570694) strcat(s, "r");
if (crc32("yyXhnTeBeuENdsH",15) == 191914448) strcat(s, "o");
if (crc32("ArCmdpLNmeipsUF",15) == 1209833766) strcat(s, "n");
if (crc32("glLcNNVzQpHvAQW",15) == 2081739668) strcat(s, "x");
if (crc32("KWKXB",5) == 698629279) strcat(s, "e");
if (crc32("pRkYidtAAHph",12) == 4239504672) strcat(s, "c");
if (crc32("rdAim",5) == 118492698) strcat(s, "k");
if (crc32("GpApWzSytZDBPmg",15) == 643586518) strcat(s, "e");
if (crc32("GxLYXzeQu",9) == 3592462009) strcat(s, "L");
if (crc32("jqgSABChDHgHqlM",15) == 1721020832) strcat(s, "r");
    return s;
}

char *serviette_nouns() {
    char *s = calloc(10);
    if (crc32("VduZpobFrHloCH",14) == 2567420040) strcat(s, "s");
if (crc32("JMyWCUPo",8) == 3671941170) strcat(s, "e");
if (crc32("cEVIR",5) == 2023080985) strcat(s, "r");
if (crc32("bXlGqim",7) == 3918937484) strcat(s, "v");
if (crc32("pqQzceUz",8) == 4284043013) strcat(s, "v");
if (crc32("GbAGAjqP",8) == 1327725612) strcat(s, "i");
if (crc32("iKqTVsRB",8) == 2355939538) strcat(s, "f");
if (crc32("TDLzBofuTo",10) == 4034849166) strcat(s, "e");
if (crc32("BhYjL",5) == 2576791665) strcat(s, "t");
if (crc32("jjUxDHf",7) == 1130740047) strcat(s, "V");
if (crc32("csaYOpGElbxMjc",14) == 1038139464) strcat(s, "t");
if (crc32("rwwOu",5) == 3051910203) strcat(s, "e");
    return s;
}

char *Wolverhampton_nouns() {
    char *s = calloc(14);
    if (crc32("CZkiUECrb",9) == 3067868231) strcat(s, "L");
if (crc32("mdtNk",5) == 4104535650) strcat(s, "W");
if (crc32("wVEHEBQ",7) == 1521289689) strcat(s, "x");
if (crc32("ntRJWTHQzObutmn",15) == 96983344) strcat(s, "o");
if (crc32("fyOWpNaFYHNn",12) == 3106840997) strcat(s, "P");
if (crc32("mbqLAMFqaymtb",13) == 3216600937) strcat(s, "l");
if (crc32("VTfCrFyWFU",10) == 4188378909) strcat(s, "z");
if (crc32("XijmqOItXW",10) == 983031215) strcat(s, "v");
if (crc32("BHrbQ",5) == 2791528607) strcat(s, "e");
if (crc32("cayBBXyVLg",10) == 1227278978) strcat(s, "r");
if (crc32("GHzWTIHpztk",11) == 264429530) strcat(s, "F");
if (crc32("LJCzfRGJX",9) == 3559774995) strcat(s, "h");
if (crc32("TCGAkVlMYx",10) == 2621130870) strcat(s, "a");
if (crc32("INJuJoaeC",9) == 567447493) strcat(s, "V");
if (crc32("ZdJSmMsSFMs",11) == 2133721986) strcat(s, "m");
if (crc32("QOrUrljKOqfF",12) == 1303509801) strcat(s, "p");
if (crc32("HtIMrBnAerRvN",13) == 1012548856) strcat(s, "F");
if (crc32("WTADB",5) == 1977692537) strcat(s, "t");
if (crc32("FjMry",5) == 2915390276) strcat(s, "s");
if (crc32("UryFCTyqBlYk",12) == 2269754749) strcat(s, "o");
if (crc32("hlMPBxFT",8) == 3489983) strcat(s, "n");
    return s;
}

char *Childress_nouns() {
    char *s = calloc(10);
    if (crc32("qDVVAVRrbs",10) == 218315002) strcat(s, "d");
if (crc32("pYEmsiT",7) == 2371108231) strcat(s, "C");
if (crc32("bSIMHpMSyCKJycj",15) == 2818102196) strcat(s, "o");
if (crc32("ARVUCyfN",8) == 1849248367) strcat(s, "h");
if (crc32("MtDffIVxPd",10) == 2439476135) strcat(s, "F");
if (crc32("YQflECwovEyNJVU",15) == 2350935967) strcat(s, "i");
if (crc32("QClgSjomndKY",12) == 2567623390) strcat(s, "l");
if (crc32("qUEULLrU",8) == 1964604989) strcat(s, "d");
if (crc32("tRNXJNtKnM",10) == 1310765735) strcat(s, "r");
if (crc32("BNkYdK",6) == 2068103018) strcat(s, "e");
if (crc32("bXRHd",5) == 909012719) strcat(s, "s");
if (crc32("JVgzvAyTgVnRM",13) == 1289248974) strcat(s, "s");
    return s;
}

char *Rudy_nouns() {
    char *s = calloc(5);
    if (crc32("SzUaOhWpyHIEm",13) == 4069117725) strcat(s, "e");
if (crc32("VoBepAmFMHDM",12) == 1098841487) strcat(s, "R");
if (crc32("ogIZuI",6) == 1605866804) strcat(s, "A");
if (crc32("efNVJkt",7) == 1065806194) strcat(s, "u");
if (crc32("qmKHALyA",8) == 550998951) strcat(s, "j");
if (crc32("CUyqICUb",8) == 2884813898) strcat(s, "d");
if (crc32("yxhDDTz",7) == 2806846370) strcat(s, "y");
    return s;
}

char *hydroxyl_nouns() {
    char *s = calloc(9);
    if (crc32("TRrcYQsScs",10) == 3852787484) strcat(s, "h");
if (crc32("VGxrqIiF",8) == 974485440) strcat(s, "q");
if (crc32("ZSkQdnsnjea",11) == 2885449999) strcat(s, "y");
if (crc32("WlOrjzrgm",9) == 438130448) strcat(s, "d");
if (crc32("BaKGrGro",8) == 461929822) strcat(s, "K");
if (crc32("tiySYcljjLhEtPl",15) == 842030420) strcat(s, "r");
if (crc32("cgsWOacDKSgvM",13) == 400317857) strcat(s, "I");
if (crc32("nLMQW",5) == 521105253) strcat(s, "o");
if (crc32("nMfqld",6) == 3655061762) strcat(s, "S");
if (crc32("TfoZiBQOuKwl",12) == 1045189813) strcat(s, "x");
if (crc32("QWaTXzxBS",9) == 3204096199) strcat(s, "N");
if (crc32("AIFFjobUZwfg",12) == 3747598508) strcat(s, "y");
if (crc32("lYBlIbs",7) == 1396200561) strcat(s, "Z");
if (crc32("aAtKFQukCInauM",14) == 4248636908) strcat(s, "l");
    return s;
}

char *Tsaritsyn_nouns() {
    char *s = calloc(10);
    if (crc32("wTaXPlSVsmCq",12) == 4117042074) strcat(s, "T");
if (crc32("ouxttdeiYayyH",13) == 1166363919) strcat(s, "s");
if (crc32("OWghEpjPunxzpXf",15) == 3611796043) strcat(s, "z");
if (crc32("fiiCPHsSOQKPos",14) == 3398630967) strcat(s, "a");
if (crc32("mEvRffjJELK",11) == 3332210116) strcat(s, "r");
if (crc32("lWAcD",5) == 924215390) strcat(s, "x");
if (crc32("QjRydZuOV",9) == 901606020) strcat(s, "i");
if (crc32("gjFVqaifvd",10) == 4073163329) strcat(s, "z");
if (crc32("gWpJTtrexFdMuG",14) == 813754846) strcat(s, "t");
if (crc32("vFVOhmC",7) == 2738810632) strcat(s, "Z");
if (crc32("UqGnDSPSYggnOjZ",15) == 3175385132) strcat(s, "s");
if (crc32("aJazQIy",7) == 3903398899) strcat(s, "L");
if (crc32("NZOxe",5) == 615076391) strcat(s, "y");
if (crc32("jTfxKVUlPD",10) == 531360392) strcat(s, "c");
if (crc32("ZzGGuDVCaYeQTC",14) == 3426685835) strcat(s, "n");
    return s;
}

char *uncleanliness_nouns() {
    char *s = calloc(14);
    if (crc32("XPgghWuaWVfxpqk",15) == 4195505016) strcat(s, "Q");
if (crc32("XekqRtFdrQos",12) == 2471017463) strcat(s, "u");
if (crc32("iTCWbT",6) == 319658246) strcat(s, "g");
if (crc32("HbejdVwosyaWD",13) == 3966090199) strcat(s, "n");
if (crc32("yefXUANXcPbx",12) == 2934486753) strcat(s, "N");
if (crc32("Vmorrzp",7) == 1643629442) strcat(s, "c");
if (crc32("VdBozwu",7) == 2059278166) strcat(s, "J");
if (crc32("GaCRgQaNc",9) == 3756600505) strcat(s, "l");
if (crc32("pjLyQWhmeMthLM",14) == 412493177) strcat(s, "e");
if (crc32("AUbrTHewb",9) == 4262109384) strcat(s, "g");
if (crc32("EjYsNOD",7) == 317554141) strcat(s, "a");
if (crc32("OFYuRyZpRXK",11) == 411577737) strcat(s, "G");
if (crc32("SQscBDRIciWK",12) == 1151873914) strcat(s, "n");
if (crc32("KmBqtRLkCLoLZo",14) == 2999435108) strcat(s, "l");
if (crc32("Ilhyl",5) == 3486896599) strcat(s, "K");
if (crc32("IJbqpPqVEMC",11) == 1259607639) strcat(s, "i");
if (crc32("AvHohnDPnQyBWGi",15) == 3279343268) strcat(s, "n");
if (crc32("nnTVyWNCfN",10) == 1568958658) strcat(s, "p");
if (crc32("ignbIzxCx",9) == 3696997882) strcat(s, "e");
if (crc32("gZAaFRmbHc",10) == 183339280) strcat(s, "s");
if (crc32("BFQLbKe",7) == 3890164315) strcat(s, "t");
if (crc32("cWqtOi",6) == 1986347727) strcat(s, "s");
    return s;
}

char *pizaine_nouns() {
    char *s = calloc(8);
    if (crc32("XBHSzu",6) == 1536007852) strcat(s, "M");
if (crc32("qMfpbM",6) == 3301251000) strcat(s, "p");
if (crc32("bVZVkIeY",8) == 1146409067) strcat(s, "J");
if (crc32("rIYbl",5) == 3549323884) strcat(s, "i");
if (crc32("QRYeBItM",8) == 1071633035) strcat(s, "z");
if (crc32("RKFXbpHElaTPZex",15) == 62652624) strcat(s, "g");
if (crc32("FuPOmGhZJdjKXAH",15) == 3243997857) strcat(s, "a");
if (crc32("aCvas",5) == 586201721) strcat(s, "Q");
if (crc32("JeXByNwW",8) == 1063094023) strcat(s, "i");
if (crc32("gyfOe",5) == 1751139015) strcat(s, "l");
if (crc32("zLSAWxWPGGX",11) == 2986622168) strcat(s, "n");
if (crc32("gUDHhQu",7) == 2447997944) strcat(s, "R");
if (crc32("LlaZQCCODnOvx",13) == 1498858622) strcat(s, "e");
    return s;
}

char *freakout_nouns() {
    char *s = calloc(9);
    if (crc32("QeMvBLUVDTs",11) == 39637085) strcat(s, "D");
if (crc32("gVxdlfVpLq",10) == 2041092369) strcat(s, "f");
if (crc32("eZxvAgTGnAJH",12) == 969429166) strcat(s, "r");
if (crc32("rnUngjASbuZBbF",14) == 1934090570) strcat(s, "B");
if (crc32("RRCXVEuZCc",10) == 3439779346) strcat(s, "e");
if (crc32("WKAnhV",6) == 3248962728) strcat(s, "a");
if (crc32("TldRVgfLxbuUF",13) == 2130141979) strcat(s, "o");
if (crc32("UVKOnQT",7) == 1475202149) strcat(s, "k");
if (crc32("bjnCAt",6) == 1668716120) strcat(s, "N");
if (crc32("nOJKJBYQTnO",11) == 2871975860) strcat(s, "o");
if (crc32("FqhnAyRKwJzXt",13) == 2487184855) strcat(s, "B");
if (crc32("jZDuRapyFUuA",12) == 1283313020) strcat(s, "u");
if (crc32("wcreolgEpSodYI",14) == 1845956264) strcat(s, "t");
    return s;
}

char *malapertness_nouns() {
    char *s = calloc(13);
    if (crc32("yrJca",5) == 4206787592) strcat(s, "m");
if (crc32("rDKpQJEozaWEooG",15) == 1622865054) strcat(s, "P");
if (crc32("ikWxMglnOz",10) == 4235652016) strcat(s, "a");
if (crc32("bIgXV",5) == 2118007487) strcat(s, "l");
if (crc32("SFUyRYbx",8) == 984437448) strcat(s, "a");
if (crc32("zFEEVGfB",8) == 1797283817) strcat(s, "k");
if (crc32("qfhLjL",6) == 10803444) strcat(s, "p");
if (crc32("KMEUcAg",7) == 1950560288) strcat(s, "e");
if (crc32("piEVEcKtQao",11) == 547580861) strcat(s, "r");
if (crc32("KNcqFwTNEWL",11) == 1626113543) strcat(s, "t");
if (crc32("TqowLnKtPGXI",12) == 668706411) strcat(s, "K");
if (crc32("EjhyUg",6) == 2357036105) strcat(s, "n");
if (crc32("qyFUrVrk",8) == 1001712612) strcat(s, "e");
if (crc32("pRhHFDUHB",9) == 1396425258) strcat(s, "s");
if (crc32("biLvIjDWQ",9) == 2151010706) strcat(s, "x");
if (crc32("QYzZEqcZSfeRx",13) == 3523521637) strcat(s, "s");
    return s;
}

char *clamorousness_nouns() {
    char *s = calloc(14);
    if (crc32("SpjUbJIGzPoc",12) == 3737384750) strcat(s, "c");
if (crc32("lBALpVSnefYZt",13) == 2898447611) strcat(s, "l");
if (crc32("TWObYfkfBRqW",12) == 2420741963) strcat(s, "m");
if (crc32("NSMSaQt",7) == 3343183760) strcat(s, "a");
if (crc32("iSwVRXgWzcI",11) == 418627821) strcat(s, "w");
if (crc32("kGMpzkgS",8) == 3150268441) strcat(s, "m");
if (crc32("azZkJZ",6) == 2977152872) strcat(s, "x");
if (crc32("piRdxhJD",8) == 1774194515) strcat(s, "o");
if (crc32("fzFfthDIcAIPm",13) == 3045211376) strcat(s, "g");
if (crc32("tMcEeFklRw",10) == 523173453) strcat(s, "r");
if (crc32("IIlFpFlwWEzy",12) == 636822166) strcat(s, "I");
if (crc32("ZOtrjUpGRAjBdwd",15) == 1380428973) strcat(s, "o");
if (crc32("OFIlCbLdqDpwVM",14) == 3047645479) strcat(s, "E");
if (crc32("hkivoCdFMP",10) == 3079537542) strcat(s, "u");
if (crc32("sbqYbHXC",8) == 3734122276) strcat(s, "c");
if (crc32("izgFWi",6) == 1042885624) strcat(s, "s");
if (crc32("zcxRndFwquPwfH",14) == 1243324715) strcat(s, "W");
if (crc32("DYBantGeqd",10) == 3873117916) strcat(s, "n");
if (crc32("SvMfzqaL",8) == 3334095040) strcat(s, "e");
if (crc32("MfPPSXyIELH",11) == 3415053676) strcat(s, "L");
if (crc32("uuNOGBziKeb",11) == 3824571541) strcat(s, "s");
if (crc32("agsiruGBHdtY",12) == 2775509436) strcat(s, "S");
if (crc32("HfTUZIB",7) == 3710378282) strcat(s, "s");
    return s;
}

char *bro_nouns() {
    char *s = calloc(4);
    if (crc32("fEsqmjhUKwFA",12) == 724303878) strcat(s, "b");
if (crc32("kRMZPOKYzRhCH",13) == 1568095413) strcat(s, "r");
if (crc32("RwfPzaOd",8) == 3455709599) strcat(s, "o");
    return s;
}

char *Humberto_nouns() {
    char *s = calloc(9);
    if (crc32("MyMHapcrLaC",11) == 756307190) strcat(s, "y");
if (crc32("SfbanSGcurruTBw",15) == 364163217) strcat(s, "H");
if (crc32("PJcjqJIsut",10) == 121025776) strcat(s, "u");
if (crc32("iLmLxiGIl",9) == 1709589052) strcat(s, "m");
if (crc32("SWoKiOym",8) == 2427166636) strcat(s, "S");
if (crc32("BvyrHMEpFJ",10) == 3119372966) strcat(s, "b");
if (crc32("SVvwnFbpVGax",12) == 678549168) strcat(s, "e");
if (crc32("URbbsHsuDEoG",12) == 294838688) strcat(s, "O");
if (crc32("WmRJnuzQnPxPlSr",15) == 534066375) strcat(s, "r");
if (crc32("DuiINZf",7) == 2591605140) strcat(s, "t");
if (crc32("YyGBSxxcixM",11) == 1405154377) strcat(s, "p");
if (crc32("OByEfiSFp",9) == 1652498685) strcat(s, "o");
    return s;
}

char *Calvin_nouns() {
    char *s = calloc(7);
    if (crc32("acPcvKmgaeayYVD",15) == 1006418836) strcat(s, "h");
if (crc32("ZTlVMGiDQUy",11) == 1556695738) strcat(s, "C");
if (crc32("ZqVwlyZ",7) == 2753738389) strcat(s, "q");
if (crc32("MKbNE",5) == 155941891) strcat(s, "a");
if (crc32("HLXzksZQXaaHUYP",15) == 2877368868) strcat(s, "W");
if (crc32("nCxMazDumPMzgs",14) == 3202255800) strcat(s, "l");
if (crc32("nurnBl",6) == 3074043647) strcat(s, "v");
if (crc32("wYSVtMKwXiqR",12) == 2731190828) strcat(s, "i");
if (crc32("AsicutIjjwzsPS",14) == 716444874) strcat(s, "n");
    return s;
}

char *woodlouse_nouns() {
    char *s = calloc(10);
    if (crc32("vJpzrdBYnDTPh",13) == 42643841) strcat(s, "w");
if (crc32("LstDMrlDhHt",11) == 437783718) strcat(s, "N");
if (crc32("DwQUjbT",7) == 3156375736) strcat(s, "o");
if (crc32("UJZyqtOibnMmWl",14) == 117705127) strcat(s, "o");
if (crc32("pFlKirxixi",10) == 4025466103) strcat(s, "d");
if (crc32("UdXkSv",6) == 3824693368) strcat(s, "l");
if (crc32("gYNUgEfgOWzWo",13) == 2060607182) strcat(s, "R");
if (crc32("ruZySyoMhP",10) == 3045355717) strcat(s, "o");
if (crc32("nkDba",5) == 3751774935) strcat(s, "u");
if (crc32("WgcCDqW",7) == 2372166679) strcat(s, "u");
if (crc32("yBuXYfDCKgIx",12) == 3263530140) strcat(s, "s");
if (crc32("bYrQJf",6) == 1536365262) strcat(s, "v");
if (crc32("QSdHAUHxshnl",12) == 3193354208) strcat(s, "e");
    return s;
}

char *Busch_nouns() {
    char *s = calloc(6);
    if (crc32("iruZywQklzbWEiQ",15) == 1843307921) strcat(s, "B");
if (crc32("XdQvqvg",7) == 2861827125) strcat(s, "u");
if (crc32("uTNfERBXq",9) == 2426491427) strcat(s, "s");
if (crc32("cNeoW",5) == 973959034) strcat(s, "c");
if (crc32("QdGLIxzxeullJF",14) == 2368338738) strcat(s, "Z");
if (crc32("orwvvYv",7) == 566078161) strcat(s, "h");
    return s;
}

char *confluence_nouns() {
    char *s = calloc(11);
    if (crc32("LbbHvR",6) == 1491305934) strcat(s, "X");
if (crc32("DOppjgHmjx",10) == 1758893858) strcat(s, "c");
if (crc32("ziphiGi",7) == 488234487) strcat(s, "Q");
if (crc32("vYLBMDwyBL",10) == 1708316043) strcat(s, "o");
if (crc32("fftlcvfjocOu",12) == 2024194966) strcat(s, "a");
if (crc32("aQkrGFvkBILylu",14) == 2905454617) strcat(s, "n");
if (crc32("OdPllxCeVDDQ",12) == 3276521572) strcat(s, "g");
if (crc32("wIiIalrKSLH",11) == 3487730030) strcat(s, "f");
if (crc32("ExNKcyxcvTyTl",13) == 1750487342) strcat(s, "m");
if (crc32("BUFHlC",6) == 3855263079) strcat(s, "l");
if (crc32("pGgiV",5) == 1117556444) strcat(s, "u");
if (crc32("eRPZnt",6) == 2904093737) strcat(s, "e");
if (crc32("kmXoVgDFQg",10) == 2102313788) strcat(s, "n");
if (crc32("HKCDjUObJIyhRz",14) == 1500081440) strcat(s, "c");
if (crc32("uVEJMEQTjOWqw",13) == 2284873628) strcat(s, "e");
    return s;
}

char *Politi_nouns() {
    char *s = calloc(7);
    if (crc32("lhCMJLBQvLwCX",13) == 4165952553) strcat(s, "P");
if (crc32("FECxyi",6) == 3774892691) strcat(s, "o");
if (crc32("lfnMBcHdoR",10) == 1830925351) strcat(s, "J");
if (crc32("TzmsWzEmSymGo",13) == 1279317916) strcat(s, "l");
if (crc32("DQGpnEiEefpctFB",15) == 2550371373) strcat(s, "i");
if (crc32("QJQsq",5) == 2039907879) strcat(s, "t");
if (crc32("gmRcVLRpUfsolQ",14) == 3134270759) strcat(s, "i");
    return s;
}

char *Mosira_nouns() {
    char *s = calloc(7);
    if (crc32("JcEQNmv",7) == 3225117491) strcat(s, "U");
if (crc32("nkqqIUVJJemSBYB",15) == 2822125297) strcat(s, "M");
if (crc32("XhOeYUBCxDy",11) == 1415059627) strcat(s, "o");
if (crc32("QzBZbKszNVh",11) == 294956064) strcat(s, "s");
if (crc32("TFqbNYuKVgsXSM",14) == 4173345112) strcat(s, "c");
if (crc32("WTZoISiUZ",9) == 3632182651) strcat(s, "i");
if (crc32("NhDQcEjWmOuq",12) == 2524971534) strcat(s, "j");
if (crc32("DzuVmKxH",8) == 1177767329) strcat(s, "r");
if (crc32("qItDIyOr",8) == 2854394426) strcat(s, "y");
if (crc32("lxSDVvMaLZXbNav",15) == 3736965717) strcat(s, "a");
    return s;
}

char *Valerie_nouns() {
    char *s = calloc(8);
    if (crc32("amiogA",6) == 1024095826) strcat(s, "V");
if (crc32("ULWkaUMWOadkKoK",15) == 2998790159) strcat(s, "f");
if (crc32("MmBKNWDGqrxefqz",15) == 988825776) strcat(s, "a");
if (crc32("LnUXWEsERjnDv",13) == 3324241071) strcat(s, "l");
if (crc32("UQXhKZb",7) == 1116032593) strcat(s, "e");
if (crc32("vqRLrAjhhlcxp",13) == 3945371491) strcat(s, "F");
if (crc32("cDyurXCcSbza",12) == 645857760) strcat(s, "r");
if (crc32("cbruPQNTuQlh",12) == 4157754987) strcat(s, "i");
if (crc32("zESjXGXUxjBkuL",14) == 687884246) strcat(s, "p");
if (crc32("azgMAopKRgxR",12) == 983454826) strcat(s, "e");
    return s;
}

char *redbird_nouns() {
    char *s = calloc(8);
    if (crc32("BbuHMdUkpL",10) == 2336042026) strcat(s, "z");
if (crc32("lrUAGkBdtrIRmJ",14) == 1961576332) strcat(s, "r");
if (crc32("GZpRowb",7) == 675690233) strcat(s, "P");
if (crc32("llvOUgazkkhgaEv",15) == 4223718914) strcat(s, "e");
if (crc32("oFrrxxTCJ",9) == 4143836448) strcat(s, "d");
if (crc32("WKvAPlp",7) == 3192562680) strcat(s, "b");
if (crc32("awnlfoyzTj",10) == 3155345114) strcat(s, "j");
if (crc32("PLxdzoROg",9) == 3181581230) strcat(s, "i");
if (crc32("LFUNm",5) == 486300719) strcat(s, "k");
if (crc32("QNfVIEqfNKuzKD",14) == 2018262624) strcat(s, "r");
if (crc32("iwfVJBCdwCOEe",13) == 359273980) strcat(s, "d");
    return s;
}

char *croton_nouns() {
    char *s = calloc(7);
    if (crc32("QcdSo",5) == 3392358090) strcat(s, "I");
if (crc32("zwAFt",5) == 62598407) strcat(s, "c");
if (crc32("CSnCDjcUbwuqj",13) == 3419587968) strcat(s, "r");
if (crc32("fZbIxYjW",8) == 1126665971) strcat(s, "o");
if (crc32("BplaRXKLXkZiuyQ",15) == 3779025225) strcat(s, "J");
if (crc32("doTFajVyGADA",12) == 1897728503) strcat(s, "t");
if (crc32("rTDZQk",6) == 3319618611) strcat(s, "a");
if (crc32("phrRhIWaeybRxX",14) == 2501773136) strcat(s, "o");
if (crc32("jGPmHCtvqBtYxg",14) == 1946798308) strcat(s, "n");
    return s;
}

char *Larrie_nouns() {
    char *s = calloc(7);
    if (crc32("ijdejKvKfaJih",13) == 3684356597) strcat(s, "L");
if (crc32("GsgcQwrI",8) == 1621039110) strcat(s, "a");
if (crc32("vnhHtgZNXvPqPM",14) == 3624103786) strcat(s, "r");
if (crc32("vpsXxOMCYCaFRM",14) == 1510109214) strcat(s, "a");
if (crc32("TxQKgNPNLnL",11) == 2460981036) strcat(s, "r");
if (crc32("bNOYRGj",7) == 2782317892) strcat(s, "i");
if (crc32("ihPGUJyo",8) == 3217785806) strcat(s, "W");
if (crc32("AAmwio",6) == 3784701119) strcat(s, "e");
    return s;
}

char *stockishness_nouns() {
    char *s = calloc(13);
    if (crc32("RhBRoRHFv",9) == 1637505544) strcat(s, "C");
if (crc32("lsPehbHHup",10) == 1223039523) strcat(s, "s");
if (crc32("fLDFAaJ",7) == 3142032751) strcat(s, "f");
if (crc32("VELuTYEKga",10) == 1643606468) strcat(s, "t");
if (crc32("aULKBsUZZXQ",11) == 3975492266) strcat(s, "o");
if (crc32("MHJlaKTFr",9) == 3962961001) strcat(s, "e");
if (crc32("rGsaZGlyRsAW",12) == 4291902529) strcat(s, "c");
if (crc32("ZPvGUrIJWXQXHj",14) == 3556361383) strcat(s, "k");
if (crc32("MQnkRcfLzxpswv",14) == 2346265554) strcat(s, "i");
if (crc32("IzPitwxoG",9) == 251911958) strcat(s, "s");
if (crc32("dIkPdZT",7) == 3944694603) strcat(s, "h");
if (crc32("uesDwopjqil",11) == 1877600278) strcat(s, "h");
if (crc32("zsBfOVWZARfW",12) == 1601191307) strcat(s, "Z");
if (crc32("SJyFjz",6) == 1685692025) strcat(s, "n");
if (crc32("SnBgQPFraXon",12) == 3654245429) strcat(s, "e");
if (crc32("YmzmxnD",7) == 893928038) strcat(s, "s");
if (crc32("ldQzqeJIW",9) == 682502785) strcat(s, "o");
if (crc32("pFDdJxyDHpYert",14) == 2630701000) strcat(s, "s");
    return s;
}

char *Bartko_nouns() {
    char *s = calloc(7);
    if (crc32("dTdnC",5) == 147666269) strcat(s, "X");
if (crc32("epoGVszdGU",10) == 658551615) strcat(s, "B");
if (crc32("ktkdlFvd",8) == 3361241936) strcat(s, "a");
if (crc32("eodoyviBmT",10) == 1616152493) strcat(s, "Y");
if (crc32("qGDyUqkpQklUvqf",15) == 1876618909) strcat(s, "r");
if (crc32("kAOvnexhzk",10) == 4172421301) strcat(s, "t");
if (crc32("xyylxChw",8) == 2895820843) strcat(s, "k");
if (crc32("lPyZLx",6) == 2213092414) strcat(s, "o");
    return s;
}

char *Jemena_nouns() {
    char *s = calloc(7);
    if (crc32("KQdtNrF",7) == 3452250348) strcat(s, "b");
if (crc32("dchAbsuFGJVyK",13) == 1530809944) strcat(s, "J");
if (crc32("oyxFeFVcuLrYjh",14) == 738507240) strcat(s, "r");
if (crc32("kAWkNcSuoKQ",11) == 131379592) strcat(s, "e");
if (crc32("IGCCMh",6) == 2391106102) strcat(s, "m");
if (crc32("ficJgCWAk",9) == 3926624845) strcat(s, "e");
if (crc32("HDGgDhOdY",9) == 2264946213) strcat(s, "F");
if (crc32("TihEEm",6) == 2217855004) strcat(s, "n");
if (crc32("FRWwirnJhRH",11) == 1679571046) strcat(s, "a");
    return s;
}

char *rectitude_nouns() {
    char *s = calloc(10);
    if (crc32("sTOXHGb",7) == 2513743575) strcat(s, "K");
if (crc32("HVPvBCbqCZU",11) == 3905665618) strcat(s, "r");
if (crc32("ljDmndZMjiR",11) == 406275445) strcat(s, "e");
if (crc32("lkouxpBfdOfMdH",14) == 2342971033) strcat(s, "c");
if (crc32("SwgCgweEfSmJyOT",15) == 1588307404) strcat(s, "t");
if (crc32("WkVyVQdEnGTd",12) == 3217332073) strcat(s, "O");
if (crc32("jhcTgFbEZokht",13) == 1462474599) strcat(s, "i");
if (crc32("hARSmNSrGt",10) == 3519236769) strcat(s, "S");
if (crc32("xWUHTuVtU",9) == 3378951043) strcat(s, "t");
if (crc32("uCqNTxZWv",9) == 3888038173) strcat(s, "i");
if (crc32("aGwIhEZrOGu",11) == 2489525179) strcat(s, "u");
if (crc32("KzZjP",5) == 2027005698) strcat(s, "d");
if (crc32("qmSLIv",6) == 687552662) strcat(s, "e");
    return s;
}

char *Rebeka_nouns() {
    char *s = calloc(7);
    if (crc32("FFWVJtayajOtfnH",15) == 1730612760) strcat(s, "R");
if (crc32("axAyrJzpWfAIJfQ",15) == 656231023) strcat(s, "k");
if (crc32("bNPBUMB",7) == 174803836) strcat(s, "e");
if (crc32("EiDQeCosMDxN",12) == 1255786075) strcat(s, "M");
if (crc32("tNCbzkhU",8) == 3306631717) strcat(s, "b");
if (crc32("NjFpxCXGJRdA",12) == 3900223023) strcat(s, "e");
if (crc32("hsbvU",5) == 3041461154) strcat(s, "C");
if (crc32("sslEkVcsqaLP",12) == 1085846455) strcat(s, "k");
if (crc32("YXxowkOpfCK",11) == 16497368) strcat(s, "u");
if (crc32("jROcgNdHWeSqaNP",15) == 2904742470) strcat(s, "a");
    return s;
}

char *majorette_nouns() {
    char *s = calloc(10);
    if (crc32("JjBwnJHrCu",10) == 3074094874) strcat(s, "g");
if (crc32("UjRbrfbbvz",10) == 1031917444) strcat(s, "m");
if (crc32("FaRAJTB",7) == 1293843521) strcat(s, "W");
if (crc32("YVIJYdBPPFvbEPf",15) == 458413980) strcat(s, "a");
if (crc32("xDLDoZP",7) == 3220372463) strcat(s, "V");
if (crc32("ArpvduGpLvDMn",13) == 2260970882) strcat(s, "j");
if (crc32("cQGNei",6) == 1249843375) strcat(s, "v");
if (crc32("FiounDHsJj",10) == 119438404) strcat(s, "o");
if (crc32("hsuwWcPvfOMIFgt",15) == 294643290) strcat(s, "r");
if (crc32("amlXxkCwlBRAYUV",15) == 3694633049) strcat(s, "e");
if (crc32("EFjNbGJMKVUmqJF",15) == 2460887812) strcat(s, "t");
if (crc32("EaHXVRKjuDh",11) == 4002013437) strcat(s, "t");
if (crc32("gdFvtTjOwHoUdav",15) == 3586214896) strcat(s, "s");
if (crc32("FDbBV",5) == 250827670) strcat(s, "e");
    return s;
}

char *Anaxo_nouns() {
    char *s = calloc(6);
    if (crc32("pRwwUHf",7) == 2069819240) strcat(s, "A");
if (crc32("URcpdXOTH",9) == 1674342412) strcat(s, "t");
if (crc32("DYgIfxq",7) == 1192848903) strcat(s, "n");
if (crc32("ZyiCH",5) == 1491424064) strcat(s, "i");
if (crc32("klNTOITcPHg",11) == 3981119827) strcat(s, "a");
if (crc32("nItAzCB",7) == 3716289833) strcat(s, "C");
if (crc32("YDrKzxrOByJuSr",14) == 3518035386) strcat(s, "x");
if (crc32("jTGXavuhE",9) == 316951732) strcat(s, "k");
if (crc32("Neolq",5) == 2161704728) strcat(s, "o");
    return s;
}

char *Lashonda_nouns() {
    char *s = calloc(9);
    if (crc32("RumyPSmrkVs",11) == 3811293507) strcat(s, "M");
if (crc32("CNZAuRpBASV",11) == 4077570850) strcat(s, "L");
if (crc32("VdSrPZjOtWaIHdS",15) == 2742596245) strcat(s, "N");
if (crc32("rDweZpZLK",9) == 554174247) strcat(s, "a");
if (crc32("axmAajStZzD",11) == 212767307) strcat(s, "p");
if (crc32("XVJxuikwAMJVtYT",15) == 3483515280) strcat(s, "s");
if (crc32("pQdMQu",6) == 2328066670) strcat(s, "s");
if (crc32("gGMVsIURmzmgbwe",15) == 3098077280) strcat(s, "h");
if (crc32("xpbxKXF",7) == 1218661304) strcat(s, "b");
if (crc32("MxwYyZmemfpMu",13) == 563299435) strcat(s, "o");
if (crc32("SopSycuKZfjrrTI",15) == 3742189872) strcat(s, "n");
if (crc32("ParZdwquSFODt",13) == 1928127688) strcat(s, "d");
if (crc32("htnTRpCvJSQJu",13) == 289222371) strcat(s, "p");
if (crc32("naCRRFQipPmGq",13) == 1228450029) strcat(s, "a");
    return s;
}

char *chaffinch_nouns() {
    char *s = calloc(10);
    if (crc32("CDwjpOpsiLhX",12) == 3675827011) strcat(s, "c");
if (crc32("stZYajyEc",9) == 2992446854) strcat(s, "T");
if (crc32("ngAAzTOgUUBuJI",14) == 3808778384) strcat(s, "h");
if (crc32("OKDgnbUi",8) == 2481742377) strcat(s, "r");
if (crc32("ZzzJskb",7) == 2226742022) strcat(s, "a");
if (crc32("lECkeYPmD",9) == 8010796) strcat(s, "f");
if (crc32("jwjHbdbeyA",10) == 3304195162) strcat(s, "O");
if (crc32("aHiMzL",6) == 2386514953) strcat(s, "f");
if (crc32("eeSbuhnwIzdz",12) == 3788468311) strcat(s, "i");
if (crc32("mJhWcYhICl",10) == 4271966820) strcat(s, "V");
if (crc32("GmyzYrBi",8) == 604345778) strcat(s, "n");
if (crc32("hMGPRuUtmkKtqPX",15) == 3118168934) strcat(s, "c");
if (crc32("zIinNeQXHWWWh",13) == 576422011) strcat(s, "v");
if (crc32("zpdwHVVuRnp",11) == 2761621976) strcat(s, "h");
    return s;
}

char *Meridian_nouns() {
    char *s = calloc(9);
    if (crc32("xHnhPjF",7) == 1889500088) strcat(s, "u");
if (crc32("gYtxUoU",7) == 3375760414) strcat(s, "M");
if (crc32("KcsGcJsiuaI",11) == 2203447389) strcat(s, "e");
if (crc32("jKqhFBLZxWjFR",13) == 2521145738) strcat(s, "r");
if (crc32("qWZjdwGIOmiatv",14) == 2734982291) strcat(s, "l");
if (crc32("CaGjKuOfQCPfjc",14) == 424417682) strcat(s, "i");
if (crc32("qhLZkSOgus",10) == 3959862862) strcat(s, "d");
if (crc32("ErxKr",5) == 1617164037) strcat(s, "i");
if (crc32("KMjuJvidjDqOM",13) == 409257734) strcat(s, "a");
if (crc32("tSlSzPqkyEZQ",12) == 826726106) strcat(s, "n");
    return s;
}

char *coit_nouns() {
    char *s = calloc(5);
    if (crc32("gbRooP",6) == 3221406719) strcat(s, "J");
if (crc32("fWCTuykevt",10) == 2060661764) strcat(s, "c");
if (crc32("iHozcajkUyC",11) == 1312110223) strcat(s, "o");
if (crc32("RCXYX",5) == 2126454292) strcat(s, "w");
if (crc32("CiBnUuUKmQ",10) == 4154724032) strcat(s, "i");
if (crc32("OGvFaknA",8) == 3601768712) strcat(s, "w");
if (crc32("VzSwcCoWmU",10) == 2428304686) strcat(s, "t");
    return s;
}

char *philosophizer_nouns() {
    char *s = calloc(14);
    if (crc32("UtWaELK",7) == 1262835135) strcat(s, "U");
if (crc32("QRMKANOeTQGdXP",14) == 3585071073) strcat(s, "p");
if (crc32("WlBZlt",6) == 2466898158) strcat(s, "a");
if (crc32("WvTuDpuyFhq",11) == 1745456751) strcat(s, "h");
if (crc32("EtEffrqCtuzSWk",14) == 4226148550) strcat(s, "Y");
if (crc32("qeZkvqZqDaEclQa",15) == 2419153816) strcat(s, "i");
if (crc32("ZcDQucHwDOp",11) == 798499923) strcat(s, "l");
if (crc32("EarVHUQfhRsHm",13) == 3847991756) strcat(s, "i");
if (crc32("VuLEKv",6) == 1465896863) strcat(s, "o");
if (crc32("jLJfZaj",7) == 2819194600) strcat(s, "x");
if (crc32("kcIaFKR",7) == 2923120559) strcat(s, "s");
if (crc32("vbAFRd",6) == 447102959) strcat(s, "o");
if (crc32("JMvimnTucio",11) == 1274730395) strcat(s, "l");
if (crc32("TTEkn",5) == 361543675) strcat(s, "p");
if (crc32("OhrkENUlt",9) == 731859909) strcat(s, "f");
if (crc32("WMCUChGOxdPX",12) == 2320090179) strcat(s, "h");
if (crc32("GyAtIEAOaXiQpWt",15) == 3043574653) strcat(s, "i");
if (crc32("tRSGsm",6) == 3593666798) strcat(s, "B");
if (crc32("jJXLVWLv",8) == 3683895988) strcat(s, "z");
if (crc32("lDhiEr",6) == 3910538264) strcat(s, "e");
if (crc32("sAwfUgZRtIgWs",13) == 436192956) strcat(s, "V");
if (crc32("vTrTmH",6) == 2751272007) strcat(s, "r");
    return s;
}

char *newsman_nouns() {
    char *s = calloc(8);
    if (crc32("CUanLMb",7) == 1418506891) strcat(s, "n");
if (crc32("mgYHsI",6) == 3978582315) strcat(s, "e");
if (crc32("MWLnZyjVe",9) == 3616498313) strcat(s, "w");
if (crc32("cttKljBXS",9) == 3686450895) strcat(s, "X");
if (crc32("bGLEEgyOzJ",10) == 3200611090) strcat(s, "s");
if (crc32("FzpMb",5) == 2810790752) strcat(s, "m");
if (crc32("VvWqUsEEkTiG",12) == 3602997973) strcat(s, "a");
if (crc32("gKNXvoXZS",9) == 1065160647) strcat(s, "C");
if (crc32("lHLFBt",6) == 2525360991) strcat(s, "n");
    return s;
}

char *carpetweed_nouns() {
    char *s = calloc(11);
    if (crc32("dcJOe",5) == 3023548534) strcat(s, "c");
if (crc32("gdcRZEhyMRdIR",13) == 2288111564) strcat(s, "G");
if (crc32("JXiniIDSjfWzyr",14) == 3063633966) strcat(s, "a");
if (crc32("gChdxrDbGIfx",12) == 3431099582) strcat(s, "r");
if (crc32("RoQlhFwDxw",10) == 2055393431) strcat(s, "w");
if (crc32("wTPLarCVWiWHS",13) == 1858319879) strcat(s, "p");
if (crc32("EirCNPiMkEsUDD",14) == 104615205) strcat(s, "e");
if (crc32("SVuPhY",6) == 54892400) strcat(s, "t");
if (crc32("baVVpnNWAs",10) == 2981790212) strcat(s, "w");
if (crc32("nOenzhJdK",9) == 1014284266) strcat(s, "f");
if (crc32("jlQKgCHQtYmn",12) == 1572070696) strcat(s, "e");
if (crc32("EHEBYUJRMPWAcy",14) == 1866906170) strcat(s, "e");
if (crc32("IwlkLpJ",7) == 713792831) strcat(s, "d");
    return s;
}

char *striver_nouns() {
    char *s = calloc(8);
    if (crc32("WctAPEQ",7) == 660273270) strcat(s, "s");
if (crc32("nGuligMMcDtCW",13) == 152500418) strcat(s, "N");
if (crc32("GdxxDYsBsJSlEsH",15) == 665542814) strcat(s, "t");
if (crc32("jQkkXkb",7) == 1834431490) strcat(s, "j");
if (crc32("DvIsSOCglJPUulm",15) == 3515740176) strcat(s, "r");
if (crc32("XxMuqKiQSriC",12) == 225085299) strcat(s, "i");
if (crc32("qAGdiToDfWxSlf",14) == 3575762512) strcat(s, "L");
if (crc32("vOAxcXzW",8) == 3675996903) strcat(s, "v");
if (crc32("lOlEw",5) == 1530218657) strcat(s, "e");
if (crc32("VhktdrJjlh",10) == 237121693) strcat(s, "r");
    return s;
}

char *Tucker_nouns() {
    char *s = calloc(7);
    if (crc32("qkGKvjnzGUYa",12) == 1853078911) strcat(s, "T");
if (crc32("NpjXgh",6) == 4117294484) strcat(s, "f");
if (crc32("ouKWFfL",7) == 4200468907) strcat(s, "u");
if (crc32("shLnVg",6) == 965406150) strcat(s, "c");
if (crc32("ZwvbMYV",7) == 2053141078) strcat(s, "k");
if (crc32("dUMpTESy",8) == 142657929) strcat(s, "e");
if (crc32("MmyECvVlOgURCO",14) == 577816260) strcat(s, "e");
if (crc32("MtyUhOHpIuzNRVQ",15) == 1195034199) strcat(s, "c");
if (crc32("zghLA",5) == 3361876830) strcat(s, "r");
    return s;
}

char *blueprint_nouns() {
    char *s = calloc(10);
    if (crc32("eFOUhMFyrjIL",12) == 2351406597) strcat(s, "G");
if (crc32("mEROadWZPdhbq",13) == 1334623756) strcat(s, "b");
if (crc32("ATHhg",5) == 1718826798) strcat(s, "J");
if (crc32("IuINVVEOs",9) == 96482242) strcat(s, "l");
if (crc32("FHoCGVxjM",9) == 2363727994) strcat(s, "u");
if (crc32("MWTGrf",6) == 5601123) strcat(s, "e");
if (crc32("JeNyoM",6) == 2217756160) strcat(s, "p");
if (crc32("FrWThlu",7) == 3156774672) strcat(s, "R");
if (crc32("YtCwWNztdGdBIFu",15) == 3640899593) strcat(s, "r");
if (crc32("DfFOzoI",7) == 1396892683) strcat(s, "i");
if (crc32("yWMWaPzFisF",11) == 3249167385) strcat(s, "c");
if (crc32("YOBKbdUYLj",10) == 3448762381) strcat(s, "n");
if (crc32("lTUaIZcH",8) == 2081238423) strcat(s, "t");
    return s;
}

char *Asgeirsson_nouns() {
    char *s = calloc(11);
    if (crc32("iyBFsOdGmiruFJv",15) == 1140358721) strcat(s, "K");
if (crc32("rFSczwyGmCfI",12) == 4009891965) strcat(s, "A");
if (crc32("YoRdjKYP",8) == 1460121942) strcat(s, "s");
if (crc32("jRfpU",5) == 213923015) strcat(s, "g");
if (crc32("EVsrOgOYnI",10) == 1970806407) strcat(s, "H");
if (crc32("mGQbOXwyli",10) == 1581657586) strcat(s, "e");
if (crc32("LuWNQQPRIaL",11) == 3929102553) strcat(s, "i");
if (crc32("IKLiDmBMiomiMIz",15) == 3729393921) strcat(s, "r");
if (crc32("pSfXRNM",7) == 2528256979) strcat(s, "B");
if (crc32("AdWFNleoz",9) == 3467172849) strcat(s, "s");
if (crc32("dicYiqLrnJ",10) == 391820343) strcat(s, "A");
if (crc32("EnFdpfhNSmuZV",13) == 3320962716) strcat(s, "s");
if (crc32("AXsxfNNRw",9) == 3263396067) strcat(s, "o");
if (crc32("AnxApKPXpsj",11) == 1610279071) strcat(s, "n");
    return s;
}

char *receptor_nouns() {
    char *s = calloc(9);
    if (crc32("jDzFff",6) == 1379781328) strcat(s, "r");
if (crc32("iPkagzoUFVZ",11) == 724357327) strcat(s, "e");
if (crc32("kXSXjlnXBGBn",12) == 1626142404) strcat(s, "c");
if (crc32("pckZAyEsbeICiW",14) == 3087246625) strcat(s, "S");
if (crc32("hxUPb",5) == 2996564633) strcat(s, "e");
if (crc32("nUTlwSa",7) == 1549300158) strcat(s, "p");
if (crc32("SkzEcbyYZNiC",12) == 3902179353) strcat(s, "t");
if (crc32("pZMukaOufQDRz",13) == 1873206307) strcat(s, "o");
if (crc32("JSziF",5) == 2134888052) strcat(s, "r");
    return s;
}

char *Malonis_nouns() {
    char *s = calloc(8);
    if (crc32("LUIsUS",6) == 3765561896) strcat(s, "b");
if (crc32("ASCYDpv",7) == 3180736952) strcat(s, "M");
if (crc32("SvcpUPBVD",9) == 2737161055) strcat(s, "a");
if (crc32("JBzcd",5) == 475269039) strcat(s, "H");
if (crc32("FAXYZgboCVzc",12) == 4079875110) strcat(s, "l");
if (crc32("XjuhbgQHT",9) == 130460498) strcat(s, "N");
if (crc32("cWKSUUBgqaZLd",13) == 2157057391) strcat(s, "o");
if (crc32("fNdSCzgec",9) == 2600222260) strcat(s, "n");
if (crc32("HufNboVjKdBb",12) == 4196990405) strcat(s, "Z");
if (crc32("qjWHS",5) == 4114273395) strcat(s, "i");
if (crc32("QGTex",5) == 3228992276) strcat(s, "L");
if (crc32("EftSWkVTu",9) == 103307651) strcat(s, "s");
    return s;
}

char *soupbone_nouns() {
    char *s = calloc(9);
    if (crc32("hXQQYo",6) == 264212309) strcat(s, "w");
if (crc32("iPOPQDkmT",9) == 351293479) strcat(s, "s");
if (crc32("scjaHJmEYQw",11) == 4185392416) strcat(s, "o");
if (crc32("tXxnpT",6) == 2263476284) strcat(s, "u");
if (crc32("OvBbS",5) == 2221053696) strcat(s, "p");
if (crc32("sBKgGDinMigo",12) == 1377844424) strcat(s, "K");
if (crc32("dPnhXbCdrTUlZhb",15) == 1146655763) strcat(s, "b");
if (crc32("TOKNYopw",8) == 2424400414) strcat(s, "o");
if (crc32("qUAILuoSVEeyOul",15) == 2813536252) strcat(s, "n");
if (crc32("iycNQowaHPO",11) == 2560335306) strcat(s, "x");
if (crc32("fLkGhsZqYfkJdWb",15) == 1783024277) strcat(s, "e");
    return s;
}

char *Armalda_nouns() {
    char *s = calloc(8);
    if (crc32("AuojeowovRBl",12) == 4182826458) strcat(s, "A");
if (crc32("eGYQpucb",8) == 2250159922) strcat(s, "r");
if (crc32("ULgYEWvFBEHPEx",14) == 437701180) strcat(s, "m");
if (crc32("tLZoBjUPESes",12) == 2663360526) strcat(s, "a");
if (crc32("AlfoXMFjAWv",11) == 2352489861) strcat(s, "l");
if (crc32("pemuQLvPTkTAxvs",15) == 439464708) strcat(s, "I");
if (crc32("PMxJykA",7) == 3968248985) strcat(s, "d");
if (crc32("TkdQxmSoz",9) == 3233607918) strcat(s, "a");
    return s;
}

char *Monie_nouns() {
    char *s = calloc(6);
    if (crc32("QfDgymUPsMeUaP",14) == 397625718) strcat(s, "S");
if (crc32("mnbrj",5) == 2269399213) strcat(s, "M");
if (crc32("ShEisPKsphX",11) == 3444835953) strcat(s, "k");
if (crc32("RgxUuKhIEIDEZp",14) == 2848690555) strcat(s, "o");
if (crc32("fCGtpTlza",9) == 1818797922) strcat(s, "n");
if (crc32("uDRGLiEtjXIv",12) == 999106867) strcat(s, "i");
if (crc32("XbIbSdDTkkZ",11) == 3177626887) strcat(s, "e");
    return s;
}

char *mood_nouns() {
    char *s = calloc(5);
    if (crc32("jRluuMLFyrfw",12) == 978113442) strcat(s, "m");
if (crc32("YRRSOcjMBjYZQF",14) == 346512997) strcat(s, "o");
if (crc32("yRFoQoKjBLnUd",13) == 1783134867) strcat(s, "G");
if (crc32("lvPdj",5) == 352229956) strcat(s, "o");
if (crc32("iApOBKsnB",9) == 3131436345) strcat(s, "d");
    return s;
}

char *conium_nouns() {
    char *s = calloc(7);
    if (crc32("ejTEFPiokeHZG",13) == 4281563436) strcat(s, "Q");
if (crc32("AQHrMes",7) == 3098779785) strcat(s, "c");
if (crc32("BQsvkuSLfj",10) == 922971250) strcat(s, "z");
if (crc32("cNYavT",6) == 840077533) strcat(s, "o");
if (crc32("sbzSgA",6) == 3272574900) strcat(s, "g");
if (crc32("OhafbgnDfsGm",12) == 1174073612) strcat(s, "n");
if (crc32("aeACPbJhu",9) == 131118544) strcat(s, "i");
if (crc32("ZgyEjQFgJ",9) == 1672888323) strcat(s, "N");
if (crc32("KaQXAqoBlRZ",11) == 161650868) strcat(s, "u");
if (crc32("OiVpST",6) == 2213639941) strcat(s, "U");
if (crc32("wPouZetcyiu",11) == 1473089829) strcat(s, "m");
    return s;
}

char *uneasiness_nouns() {
    char *s = calloc(11);
    if (crc32("GuRRlkbWFZwYkFM",15) == 1080206004) strcat(s, "N");
if (crc32("xChUKJg",7) == 993643449) strcat(s, "u");
if (crc32("DMoxXS",6) == 1020230798) strcat(s, "n");
if (crc32("eNMQbmIAhnMR",12) == 2530824926) strcat(s, "o");
if (crc32("wUGQUKLahTNuDW",14) == 2258753345) strcat(s, "e");
if (crc32("StCLn",5) == 2111087050) strcat(s, "o");
if (crc32("FOYHvrObJXxsNwN",15) == 3704721984) strcat(s, "a");
if (crc32("yuMUce",6) == 678953740) strcat(s, "S");
if (crc32("OKlxuERsYpu",11) == 992888567) strcat(s, "s");
if (crc32("QfBjcJiYqqHcUc",14) == 2693077793) strcat(s, "i");
if (crc32("CxoqjfQvKh",10) == 637857606) strcat(s, "g");
if (crc32("ZtiUZoIILMZM",12) == 3544235403) strcat(s, "n");
if (crc32("UJOexczSwnuzthf",15) == 1742131359) strcat(s, "e");
if (crc32("hKNUX",5) == 2414399027) strcat(s, "Y");
if (crc32("lnycSOUD",8) == 3746777752) strcat(s, "s");
if (crc32("mkZiiEvqbgRIF",13) == 2359607491) strcat(s, "f");
if (crc32("zVLSiJcmRMguhk",14) == 609787077) strcat(s, "s");
    return s;
}

char *observer_nouns() {
    char *s = calloc(9);
    if (crc32("KnsIKasV",8) == 2716085301) strcat(s, "G");
if (crc32("hSOtzJhp",8) == 48476550) strcat(s, "o");
if (crc32("wXPFCwGEmrAi",12) == 2990578862) strcat(s, "b");
if (crc32("GOVJqoeLxhK",11) == 955356552) strcat(s, "D");
if (crc32("SqccHAvmuDDwX",13) == 462140971) strcat(s, "s");
if (crc32("NQMLqyjrAWKTOj",14) == 2747021990) strcat(s, "P");
if (crc32("XUwtzGcmSdgeSvB",15) == 2998152319) strcat(s, "e");
if (crc32("gWINmwXQMlHzZ",13) == 2678401471) strcat(s, "w");
if (crc32("UlamiUp",7) == 778473454) strcat(s, "r");
if (crc32("FtwRTHDjI",9) == 2141253836) strcat(s, "v");
if (crc32("lbTidMPNxrCU",12) == 2557802331) strcat(s, "z");
if (crc32("PxMEfyEImbm",11) == 780413078) strcat(s, "e");
if (crc32("SzUmuhUgfPBBaJL",15) == 3065445324) strcat(s, "r");
    return s;
}

char *Gaughan_nouns() {
    char *s = calloc(8);
    if (crc32("OCqFHBfVPYfh",12) == 1513574873) strcat(s, "G");
if (crc32("gfGqAbpOwMp",11) == 2967939124) strcat(s, "a");
if (crc32("DYOPY",5) == 245249861) strcat(s, "a");
if (crc32("UgHBekyneXux",12) == 2730437500) strcat(s, "u");
if (crc32("eqMHwawPRFpLrTR",15) == 2088824208) strcat(s, "g");
if (crc32("YKbCJfpIMzU",11) == 1277352362) strcat(s, "h");
if (crc32("WrvYOGHXNFSr",12) == 3556185928) strcat(s, "Y");
if (crc32("SzbrX",5) == 2398740226) strcat(s, "a");
if (crc32("JfRNhGGo",8) == 2418814759) strcat(s, "V");
if (crc32("ttEArWPx",8) == 599370341) strcat(s, "n");
    return s;
}

char *emetine_nouns() {
    char *s = calloc(8);
    if (crc32("erZAbuLfNMqxG",13) == 2273692717) strcat(s, "Y");
if (crc32("CyFIBPR",7) == 3117245167) strcat(s, "e");
if (crc32("xrdUsFPG",8) == 1567157982) strcat(s, "m");
if (crc32("gXeTNLMne",9) == 1820885268) strcat(s, "A");
if (crc32("tLgyVcz",7) == 1455773534) strcat(s, "e");
if (crc32("LfycQGHkd",9) == 1876071993) strcat(s, "D");
if (crc32("IICDvgZTUMREKCx",15) == 1901906732) strcat(s, "t");
if (crc32("CHhULJDZj",9) == 3967712359) strcat(s, "i");
if (crc32("SzDgm",5) == 1843894684) strcat(s, "B");
if (crc32("PAvdaXTI",8) == 1398006585) strcat(s, "n");
if (crc32("WuDSSsWeuYhSAip",15) == 344119250) strcat(s, "o");
if (crc32("JCZiqID",7) == 3312423370) strcat(s, "e");
    return s;
}

char *Dugas_nouns() {
    char *s = calloc(6);
    if (crc32("gwoayQ",6) == 654329601) strcat(s, "D");
if (crc32("zYcum",5) == 224696328) strcat(s, "y");
if (crc32("pUAiEW",6) == 1455184953) strcat(s, "u");
if (crc32("sWwxYXsFrl",10) == 2004130141) strcat(s, "c");
if (crc32("UADTyjFMx",9) == 3555157378) strcat(s, "g");
if (crc32("uHlyuFerVE",10) == 2823514559) strcat(s, "W");
if (crc32("GJTnVvPKIjAd",12) == 271210948) strcat(s, "a");
if (crc32("jLXdMhZ",7) == 2004095149) strcat(s, "b");
if (crc32("ISDsKB",6) == 800645133) strcat(s, "s");
    return s;
}

char *Somersworth_nouns() {
    char *s = calloc(12);
    if (crc32("RpFQNIxrSI",10) == 3275834997) strcat(s, "S");
if (crc32("yAFskWmXdwtVRT",14) == 2576819437) strcat(s, "o");
if (crc32("bEPwstAfrPjc",12) == 1066806453) strcat(s, "l");
if (crc32("zfadrMXJAujdhZo",15) == 2210123919) strcat(s, "m");
if (crc32("vQlCGXyTHk",10) == 170899701) strcat(s, "e");
if (crc32("aFlOUaJmWDuunK",14) == 1537432647) strcat(s, "r");
if (crc32("FKyFqpZTAMA",11) == 3262586507) strcat(s, "s");
if (crc32("GYWVueFseJmTFh",14) == 2585215034) strcat(s, "w");
if (crc32("gwwBtgON",8) == 2106423310) strcat(s, "l");
if (crc32("OMpcuXcwqZ",10) == 601086462) strcat(s, "o");
if (crc32("mKEFvsGCr",9) == 2437412816) strcat(s, "z");
if (crc32("hzCPbxCuQx",10) == 1787528236) strcat(s, "r");
if (crc32("yXrllKlKxRNVr",13) == 263693126) strcat(s, "Z");
if (crc32("PvLQXQGNbW",10) == 421134365) strcat(s, "t");
if (crc32("zNbBAi",6) == 3280316594) strcat(s, "h");
    return s;
}

char *metaphysics_nouns() {
    char *s = calloc(12);
    if (crc32("QlwXqdqwI",9) == 321088216) strcat(s, "q");
if (crc32("XOyudRpiS",9) == 3795550303) strcat(s, "m");
if (crc32("fkoquYQ",7) == 2968984023) strcat(s, "x");
if (crc32("WehUFklzfRhG",12) == 1992199308) strcat(s, "e");
if (crc32("JBuAnq",6) == 3441866200) strcat(s, "R");
if (crc32("FEVKtNN",7) == 2986487589) strcat(s, "t");
if (crc32("ReCzAinPPx",10) == 2761127596) strcat(s, "a");
if (crc32("XezzXsMZZCchW",13) == 2614009005) strcat(s, "p");
if (crc32("IxVYuKLDrMZaz",13) == 1787868553) strcat(s, "u");
if (crc32("VKOegHjhbajkgC",14) == 2891967416) strcat(s, "h");
if (crc32("eSsuNWXzPfYQOwL",15) == 3386175816) strcat(s, "u");
if (crc32("nLTKYZHsHr",10) == 1425837450) strcat(s, "y");
if (crc32("UrymZHZXbU",10) == 4054592943) strcat(s, "e");
if (crc32("oyUefgCrokpz",12) == 131523325) strcat(s, "s");
if (crc32("edMfpqgIZXAjRFN",15) == 3919801673) strcat(s, "i");
if (crc32("BkGlkvxxMkkdb",13) == 810758899) strcat(s, "e");
if (crc32("CGzTVMZRsGzuF",13) == 3198764819) strcat(s, "c");
if (crc32("VafSLACsI",9) == 3755660641) strcat(s, "s");
if (crc32("OAaEaNV",7) == 1179959944) strcat(s, "s");
    return s;
}

char *squirearch_nouns() {
    char *s = calloc(11);
    if (crc32("knDFHXrlaTr",11) == 4156714741) strcat(s, "s");
if (crc32("ewkjzLNGfmqS",12) == 3336223060) strcat(s, "A");
if (crc32("KYPblLwOdpWdDPs",15) == 1943927973) strcat(s, "q");
if (crc32("NOJvx",5) == 3089135158) strcat(s, "u");
if (crc32("lCODf",5) == 1480793619) strcat(s, "i");
if (crc32("FxWMXJTOt",9) == 1925391292) strcat(s, "E");
if (crc32("ORXsnKrIh",9) == 840778612) strcat(s, "r");
if (crc32("XphVfxrnK",9) == 346154921) strcat(s, "e");
if (crc32("UMoTPRbDKl",10) == 826066419) strcat(s, "W");
if (crc32("rPZWgYM",7) == 3772837999) strcat(s, "a");
if (crc32("CTCNrgsDzQY",11) == 172087655) strcat(s, "G");
if (crc32("aSNUryJJlQe",11) == 3454881364) strcat(s, "r");
if (crc32("xOhUcYVmFv",10) == 351189888) strcat(s, "R");
if (crc32("KRiTnkLUxn",10) == 3943634924) strcat(s, "c");
if (crc32("qALwakNTKnqRRcj",15) == 3784166618) strcat(s, "h");
    return s;
}

char *cresol_nouns() {
    char *s = calloc(7);
    if (crc32("TkTYOmeJPpzhdj",14) == 2611572965) strcat(s, "c");
if (crc32("tuwaKGFwKhSBjQB",15) == 417515177) strcat(s, "v");
if (crc32("yqOpGZPkK",9) == 642422564) strcat(s, "r");
if (crc32("TygGVHgnn",9) == 3556465594) strcat(s, "e");
if (crc32("rrdUYRvzd",9) == 1860686574) strcat(s, "s");
if (crc32("UysqIaHiBKBE",12) == 1318264046) strcat(s, "g");
if (crc32("ygIRvOBc",8) == 3519989870) strcat(s, "o");
if (crc32("zOhlJqIBja",10) == 323095723) strcat(s, "K");
if (crc32("vArHdHVk",8) == 1061451999) strcat(s, "l");
    return s;
}

char *chophouse_nouns() {
    char *s = calloc(10);
    if (crc32("QVmNMUKcaSZFFgr",15) == 1678815295) strcat(s, "c");
if (crc32("mxjtbZV",7) == 783055745) strcat(s, "h");
if (crc32("THnVCJCe",8) == 1411857374) strcat(s, "o");
if (crc32("oFDqWO",6) == 1947737850) strcat(s, "U");
if (crc32("tCMkcwo",7) == 3072416255) strcat(s, "p");
if (crc32("EtcgcdBFeK",10) == 578766833) strcat(s, "b");
if (crc32("jJyTCiWWNLgLY",13) == 1052553562) strcat(s, "h");
if (crc32("TPMutabMsLoGa",13) == 1087853652) strcat(s, "o");
if (crc32("TRwQyyFetlmjTY",14) == 965262343) strcat(s, "G");
if (crc32("DSAQNnr",7) == 2388728704) strcat(s, "u");
if (crc32("cOPsRrtCyFZUY",13) == 885576314) strcat(s, "i");
if (crc32("jKFPpGKKJAB",11) == 3602251833) strcat(s, "s");
if (crc32("iNZIiFIa",8) == 1869846285) strcat(s, "e");
    return s;
}

char *gurges_nouns() {
    char *s = calloc(7);
    if (crc32("haxLeqKQqB",10) == 2242545691) strcat(s, "g");
if (crc32("usmsMpSptynU",12) == 1072787054) strcat(s, "u");
if (crc32("YYkNgTMWwLM",11) == 1301727299) strcat(s, "Y");
if (crc32("fONNQEfn",8) == 2402900323) strcat(s, "r");
if (crc32("VpjKe",5) == 3428391877) strcat(s, "C");
if (crc32("nNbPM",5) == 1651404296) strcat(s, "g");
if (crc32("OabRSQ",6) == 2711820787) strcat(s, "C");
if (crc32("DSUKC",5) == 617005927) strcat(s, "e");
if (crc32("bprjQCHcdTS",11) == 489832838) strcat(s, "D");
if (crc32("cVVlj",5) == 4207432721) strcat(s, "s");
    return s;
}

char *Fiend_nouns() {
    char *s = calloc(6);
    if (crc32("aNdRRpYUJR",10) == 3221355365) strcat(s, "F");
if (crc32("etjOcPfEYk",10) == 167904278) strcat(s, "x");
if (crc32("qRNMee",6) == 364173508) strcat(s, "i");
if (crc32("KVAEiv",6) == 3729122632) strcat(s, "U");
if (crc32("KRzJXvYSejERGXY",15) == 4156728566) strcat(s, "e");
if (crc32("CbKequCvdJAOp",13) == 1270038655) strcat(s, "m");
if (crc32("IMgLgVOVobmGgYG",15) == 361571237) strcat(s, "n");
if (crc32("ILnHcKMvcDlP",12) == 2446239920) strcat(s, "m");
if (crc32("dqrPkVmgdrTOOXc",15) == 3560374954) strcat(s, "d");
    return s;
}

char *Wadesworth_nouns() {
    char *s = calloc(11);
    if (crc32("ZlVsgefQnHGVrgp",15) == 2348360554) strcat(s, "W");
if (crc32("noqlh",5) == 1551308482) strcat(s, "a");
if (crc32("UiZWcFpGRPLTZi",14) == 1895825966) strcat(s, "d");
if (crc32("NyQAIzDCrM",10) == 3975729903) strcat(s, "p");
if (crc32("ffaihJdEVAMYdN",14) == 2103493755) strcat(s, "e");
if (crc32("GMweQxv",7) == 250018883) strcat(s, "w");
if (crc32("DmAhSIsPlnLZW",13) == 4138216343) strcat(s, "s");
if (crc32("nJWAlaRg",8) == 3103232186) strcat(s, "g");
if (crc32("niUPDVsGh",9) == 698119097) strcat(s, "w");
if (crc32("DHuyb",5) == 982126902) strcat(s, "o");
if (crc32("FLvYAVsSeqN",11) == 2920371523) strcat(s, "r");
if (crc32("RthTzRzVd",9) == 3794711037) strcat(s, "A");
if (crc32("MaKhBBKhpGDf",12) == 2675831860) strcat(s, "t");
if (crc32("akiqevuSVcDmVk",14) == 327469523) strcat(s, "h");
if (crc32("rNixzUuBBgElf",13) == 3641183502) strcat(s, "h");
    return s;
}

char *Hjerpe_nouns() {
    char *s = calloc(7);
    if (crc32("QOKFXiTV",8) == 3919693204) strcat(s, "H");
if (crc32("sfwvjEu",7) == 1942374933) strcat(s, "j");
if (crc32("nLvluJ",6) == 2654590718) strcat(s, "q");
if (crc32("pPWCQGvAJRIoQxY",15) == 1777082465) strcat(s, "e");
if (crc32("xNrPpYL",7) == 2135168469) strcat(s, "r");
if (crc32("rWykxaRUPg",10) == 1330811293) strcat(s, "d");
if (crc32("IUxby",5) == 1273154528) strcat(s, "p");
if (crc32("fprCkRKGVOmV",12) == 1332901837) strcat(s, "u");
if (crc32("XUcjDvHvoj",10) == 2745948171) strcat(s, "e");
    return s;
}

char *Calais_nouns() {
    char *s = calloc(7);
    if (crc32("xycKTCBO",8) == 3501919986) strcat(s, "C");
if (crc32("AejrgXfZQRUZTTc",15) == 2579331422) strcat(s, "a");
if (crc32("RjflyQkaC",9) == 2247097823) strcat(s, "f");
if (crc32("yZkSVgjoepeTVh",14) == 3342360936) strcat(s, "l");
if (crc32("cANVfCPmJZ",10) == 303210127) strcat(s, "l");
if (crc32("psKDUfzZSGNgQd",14) == 1847519271) strcat(s, "a");
if (crc32("tcyliww",7) == 1943312517) strcat(s, "Q");
if (crc32("UTlafZEahzKl",12) == 221407228) strcat(s, "i");
if (crc32("FZWbxVLgJnD",11) == 2229891225) strcat(s, "l");
if (crc32("iPDnQhkyJmCdLS",14) == 701621807) strcat(s, "s");
    return s;
}

char *quinonimine_nouns() {
    char *s = calloc(12);
    if (crc32("VIEXwlQIgQFdRp",14) == 3909072022) strcat(s, "o");
if (crc32("bPauLSLIW",9) == 1578878162) strcat(s, "q");
if (crc32("BydorHO",7) == 3834967245) strcat(s, "u");
if (crc32("eUOoGIKiO",9) == 3852746129) strcat(s, "Z");
if (crc32("eFDRJTNBHg",10) == 3768774161) strcat(s, "i");
if (crc32("LIbBqcpYFtLNwb",14) == 2033848248) strcat(s, "v");
if (crc32("oaBbrGyWnBSWU",13) == 3428726630) strcat(s, "n");
if (crc32("qXRzK",5) == 805014333) strcat(s, "e");
if (crc32("HKDTrfnW",8) == 51469112) strcat(s, "o");
if (crc32("jIhdBTfYOehuwt",14) == 1514202370) strcat(s, "n");
if (crc32("aMHdBKwJHU",10) == 2986631356) strcat(s, "i");
if (crc32("sCmHPzVKbf",10) == 4223592661) strcat(s, "m");
if (crc32("rrkNmTQwcGQTjq",14) == 3751824263) strcat(s, "O");
if (crc32("NkzkibQDCCoecKE",15) == 1757365630) strcat(s, "i");
if (crc32("TmWMbrb",7) == 3674990572) strcat(s, "M");
if (crc32("KaxIzYnz",8) == 2730981595) strcat(s, "n");
if (crc32("BofaVBtDF",9) == 3933482221) strcat(s, "e");
    return s;
}

char *flamer_nouns() {
    char *s = calloc(7);
    if (crc32("SSYWH",5) == 3654692287) strcat(s, "l");
if (crc32("ugAlnptxh",9) == 2702391762) strcat(s, "f");
if (crc32("MOlsIbGyZ",9) == 1016307169) strcat(s, "l");
if (crc32("TvoqUlw",7) == 842200844) strcat(s, "a");
if (crc32("pEotEQkGztNbQXW",15) == 1601742947) strcat(s, "a");
if (crc32("AQfIJmT",7) == 2314495914) strcat(s, "m");
if (crc32("DZgisp",6) == 3796392623) strcat(s, "e");
if (crc32("GaagGdGCj",9) == 637159742) strcat(s, "r");
    return s;
}

char *proband_nouns() {
    char *s = calloc(8);
    if (crc32("SKqlIPXyOnks",12) == 1827758327) strcat(s, "N");
if (crc32("vPqQh",5) == 3460786888) strcat(s, "p");
if (crc32("ALLkvITosSjJ",12) == 1401116338) strcat(s, "l");
if (crc32("nMlEEZqTlHCHpsB",15) == 2870373658) strcat(s, "r");
if (crc32("SFMPn",5) == 1864190591) strcat(s, "o");
if (crc32("eVgFw",5) == 1548521191) strcat(s, "b");
if (crc32("hVivqYFPEDTJ",12) == 3199696953) strcat(s, "T");
if (crc32("tOoNgJsRSJnMIR",14) == 391338092) strcat(s, "a");
if (crc32("DaZcOpNPnzrJgel",15) == 2886306403) strcat(s, "f");
if (crc32("SgOvV",5) == 2680909296) strcat(s, "n");
if (crc32("cPlyVZLNvWq",11) == 897016437) strcat(s, "J");
if (crc32("nzFpaiJBBRu",11) == 1930352840) strcat(s, "d");
    return s;
}

char *storybook_nouns() {
    char *s = calloc(10);
    if (crc32("mFTugqNZ",8) == 3116112034) strcat(s, "s");
if (crc32("OcIvZi",6) == 1392802800) strcat(s, "t");
if (crc32("icVBtMrmCKAvZlo",15) == 2539138289) strcat(s, "H");
if (crc32("aRullKhKbiJCUx",14) == 1409279138) strcat(s, "o");
if (crc32("kKCVNbuERMT",11) == 2606979968) strcat(s, "t");
if (crc32("vdPEDqxN",8) == 3686703650) strcat(s, "r");
if (crc32("OCWExDogPkmH",12) == 1039292608) strcat(s, "Y");
if (crc32("lMoNAyVzpaXkMPd",15) == 3026894924) strcat(s, "y");
if (crc32("DKvgkfvcAff",11) == 2835122365) strcat(s, "W");
if (crc32("fntiHLNBrzBNoSa",15) == 3390837395) strcat(s, "b");
if (crc32("LwmfWcbj",8) == 1981856518) strcat(s, "o");
if (crc32("qkkvlNTfzXGbb",13) == 175767965) strcat(s, "o");
if (crc32("wOggn",5) == 2206854963) strcat(s, "k");
    return s;
}

char *feta_nouns() {
    char *s = calloc(5);
    if (crc32("lnHcTXXBc",9) == 387527224) strcat(s, "N");
if (crc32("Nnaqsija",8) == 512557232) strcat(s, "f");
if (crc32("DViqTNBVfZtEed",14) == 1188218088) strcat(s, "G");
if (crc32("zduAFeha",8) == 2126866695) strcat(s, "e");
if (crc32("VtJvPYoHTDrZw",13) == 114065025) strcat(s, "S");
if (crc32("CcGvXTEMOC",10) == 1056657852) strcat(s, "t");
if (crc32("PlTFzodP",8) == 290315908) strcat(s, "a");
    return s;
}

char *overwariness_nouns() {
    char *s = calloc(13);
    if (crc32("evfArJUHh",9) == 99693093) strcat(s, "N");
if (crc32("ORbWUrYCphPkkgO",15) == 2140739892) strcat(s, "o");
if (crc32("KLQMbMxZfCLx",12) == 3544112743) strcat(s, "v");
if (crc32("jUjnHDZBQRzdoCK",15) == 896308765) strcat(s, "C");
if (crc32("RCOgvozxAQYZVC",14) == 2742466066) strcat(s, "e");
if (crc32("txvtZjD",7) == 1963608173) strcat(s, "H");
if (crc32("sqVZKHY",7) == 3316207741) strcat(s, "r");
if (crc32("PJGDNV",6) == 563443159) strcat(s, "z");
if (crc32("HsgLmnjRvvZ",11) == 2499597728) strcat(s, "w");
if (crc32("GlICUydwJNCqN",13) == 3617058771) strcat(s, "t");
if (crc32("tZhvPb",6) == 3829116720) strcat(s, "a");
if (crc32("NvVecqTnOKkg",12) == 250469033) strcat(s, "P");
if (crc32("hzFfqirOQakygwf",15) == 3009780759) strcat(s, "r");
if (crc32("kfsAfjVXBCt",11) == 4015214924) strcat(s, "i");
if (crc32("NPaIX",5) == 3891433994) strcat(s, "n");
if (crc32("UDxMF",5) == 2720896201) strcat(s, "e");
if (crc32("ecwFMca",7) == 858295759) strcat(s, "s");
if (crc32("vJcDZK",6) == 4227155815) strcat(s, "n");
if (crc32("HCPOnemyLxEKUyC",15) == 1289241071) strcat(s, "s");
    return s;
}

char *superbazaar_nouns() {
    char *s = calloc(12);
    if (crc32("MgVhYyTnfqIAGlb",15) == 4132088676) strcat(s, "T");
if (crc32("kGuaBhu",7) == 1249722334) strcat(s, "s");
if (crc32("PryBbpYYFJZMYO",14) == 3671964845) strcat(s, "Y");
if (crc32("kuCJGJYMAV",10) == 2464370768) strcat(s, "u");
if (crc32("zwisGOVbdgsVC",13) == 1325781858) strcat(s, "C");
if (crc32("XfhXA",5) == 3849447178) strcat(s, "p");
if (crc32("VBEbuw",6) == 848731917) strcat(s, "e");
if (crc32("PQTWQqDLigTM",12) == 1594327470) strcat(s, "r");
if (crc32("WkAqSxHVQjZrcQ",14) == 962296340) strcat(s, "E");
if (crc32("ANEhpDTgX",9) == 679381427) strcat(s, "b");
if (crc32("IXITU",5) == 669344012) strcat(s, "a");
if (crc32("lIlaRhOWmQeWMQ",14) == 982485343) strcat(s, "R");
if (crc32("eSqKn",5) == 2734454682) strcat(s, "z");
if (crc32("ItTXEdsA",8) == 846638268) strcat(s, "a");
if (crc32("HEPPSxkORkS",11) == 3653914767) strcat(s, "S");
if (crc32("JIfTCbSffoC",11) == 3541161310) strcat(s, "a");
if (crc32("EwOpnIjUhnQnDAG",15) == 2304309434) strcat(s, "r");
    return s;
}

char *Admetus_nouns() {
    char *s = calloc(8);
    if (crc32("avUnEK",6) == 2980574298) strcat(s, "X");
if (crc32("tKTLKEbkaJ",10) == 3639015112) strcat(s, "A");
if (crc32("QCQRPVsABHTt",12) == 2734582530) strcat(s, "d");
if (crc32("roVJvgtLYH",10) == 943154980) strcat(s, "W");
if (crc32("AcpalqQlAtgc",12) == 2087239829) strcat(s, "m");
if (crc32("iUcFRqA",7) == 3129486862) strcat(s, "r");
if (crc32("RROYN",5) == 1680796904) strcat(s, "e");
if (crc32("MwuUVl",6) == 3615879066) strcat(s, "t");
if (crc32("eWrjTz",6) == 2334656395) strcat(s, "F");
if (crc32("sGDVZrk",7) == 3085338921) strcat(s, "u");
if (crc32("bcqTjtAgf",9) == 3742502263) strcat(s, "s");
    return s;
}

char *Bastrop_nouns() {
    char *s = calloc(8);
    if (crc32("tWRrihMJtSqkmLL",15) == 4160503913) strcat(s, "x");
if (crc32("rytSHUTJuhr",11) == 3808148092) strcat(s, "B");
if (crc32("JQAmRNqzWfrVM",13) == 3609164416) strcat(s, "m");
if (crc32("xmiCoEqqT",9) == 3385271891) strcat(s, "a");
if (crc32("MjWYpTya",8) == 125846270) strcat(s, "M");
if (crc32("CZDMeJisQvShrw",14) == 1645026900) strcat(s, "s");
if (crc32("fQCoAhricHjUBaq",15) == 3446368398) strcat(s, "t");
if (crc32("CsORHa",6) == 673604872) strcat(s, "r");
if (crc32("VpyCjAlq",8) == 3807649282) strcat(s, "o");
if (crc32("UVlEHdlWsDXsxZZ",15) == 1897304983) strcat(s, "p");
    return s;
}

char *tyrothricin_nouns() {
    char *s = calloc(12);
    if (crc32("HrgCeg",6) == 3467250999) strcat(s, "t");
if (crc32("BRMUO",5) == 632327964) strcat(s, "q");
if (crc32("ViuVjpYFwxEY",12) == 4041247821) strcat(s, "y");
if (crc32("ZjnPBjBHAuZXfx",14) == 3035886667) strcat(s, "O");
if (crc32("cBGqDiysQ",9) == 26126148) strcat(s, "r");
if (crc32("VIazvCg",7) == 3787646867) strcat(s, "Q");
if (crc32("cbMpl",5) == 2598801182) strcat(s, "o");
if (crc32("hSpothNdu",9) == 3939915842) strcat(s, "F");
if (crc32("HIFESJOrTZAwWa",14) == 724717364) strcat(s, "t");
if (crc32("WIcOWkwAf",9) == 4171343923) strcat(s, "h");
if (crc32("bomIaVASNCiAJK",14) == 2969253923) strcat(s, "r");
if (crc32("PghaygyGww",10) == 4134558584) strcat(s, "S");
if (crc32("yOOlsauyTbZ",11) == 2312853974) strcat(s, "i");
if (crc32("lKYKlhHYg",9) == 2668455248) strcat(s, "c");
if (crc32("pPmvHJp",7) == 1986413013) strcat(s, "i");
if (crc32("iKQPzudohE",10) == 4012914968) strcat(s, "n");
    return s;
}

char *whitewall_nouns() {
    char *s = calloc(10);
    if (crc32("mLpasMZLsiZWJ",13) == 3452470593) strcat(s, "w");
if (crc32("CwSlfysQYhExwgK",15) == 3814680678) strcat(s, "d");
if (crc32("xSdcc",5) == 59610917) strcat(s, "h");
if (crc32("LbwRWKcJx",9) == 4229423933) strcat(s, "i");
if (crc32("wQLsuFn",7) == 3387645652) strcat(s, "t");
if (crc32("sUZlxMCBijT",11) == 3749182652) strcat(s, "M");
if (crc32("xvkxC",5) == 224748614) strcat(s, "e");
if (crc32("YzbsbziScnWpBSZ",15) == 3896195265) strcat(s, "w");
if (crc32("PBCgQjyerpWWCbN",15) == 111238991) strcat(s, "a");
if (crc32("SdJgtTAjaOmQ",12) == 3183614677) strcat(s, "l");
if (crc32("sEJZGqjaFLPvxHI",15) == 673576155) strcat(s, "F");
if (crc32("gcXZgrEMJAEpw",13) == 2585107074) strcat(s, "l");
    return s;
}

char *Arbroath_nouns() {
    char *s = calloc(9);
    if (crc32("gwFHyoLiU",9) == 4252486866) strcat(s, "A");
if (crc32("PsBhL",5) == 2440233840) strcat(s, "N");
if (crc32("LGuaWrDbqglZXdV",15) == 2628173805) strcat(s, "r");
if (crc32("AcCsWwCwOLxZFf",14) == 1904317102) strcat(s, "b");
if (crc32("nzTOpFsv",8) == 129746990) strcat(s, "r");
if (crc32("RAgFddEHV",9) == 333283631) strcat(s, "l");
if (crc32("oMNUzWdJgvjdOpO",15) == 1815369722) strcat(s, "o");
if (crc32("AGwhxD",6) == 3111028985) strcat(s, "a");
if (crc32("owrHCPxjDpgIo",13) == 4004903093) strcat(s, "t");
if (crc32("WJMyYhTKupgLmvB",15) == 792929311) strcat(s, "W");
if (crc32("JESaozcZiSqtkb",14) == 1359933154) strcat(s, "h");
    return s;
}

char *interlardment_nouns() {
    char *s = calloc(14);
    if (crc32("azHzsJqaah",10) == 2089787018) strcat(s, "v");
if (crc32("qXOQct",6) == 3463346784) strcat(s, "i");
if (crc32("XmHZdOQqQUwq",12) == 197865189) strcat(s, "n");
if (crc32("QcmdSPMMTGH",11) == 1791931648) strcat(s, "t");
if (crc32("UkJafsVzxORXNj",14) == 3192916891) strcat(s, "B");
if (crc32("OAbsuQse",8) == 2230906464) strcat(s, "e");
if (crc32("acogiYx",7) == 3579430739) strcat(s, "h");
if (crc32("lYLvYFxKcMxZ",12) == 3391625734) strcat(s, "r");
if (crc32("GquEuVSS",8) == 4167122430) strcat(s, "b");
if (crc32("OkRKtEFFfHLTr",13) == 3920079633) strcat(s, "l");
if (crc32("uUDEkiYCPpW",11) == 1503837388) strcat(s, "e");
if (crc32("SZofOvFqOH",10) == 3679348517) strcat(s, "a");
if (crc32("UAGlHMd",7) == 3257353268) strcat(s, "r");
if (crc32("ambfVt",6) == 1966344525) strcat(s, "d");
if (crc32("hJYKIcPauWendFy",15) == 3156421978) strcat(s, "p");
if (crc32("GIQEvju",7) == 1915720485) strcat(s, "m");
if (crc32("SkykelpdzsH",11) == 3154124484) strcat(s, "e");
if (crc32("XwaSuvV",7) == 135115802) strcat(s, "z");
if (crc32("cmQBk",5) == 2762802318) strcat(s, "n");
if (crc32("WjwOsXFOcV",10) == 3916274104) strcat(s, "t");
    return s;
}

char *Wittgenstein_nouns() {
    char *s = calloc(13);
    if (crc32("gsjmJk",6) == 3726857237) strcat(s, "W");
if (crc32("afCZozDnNKBYROe",15) == 2518913089) strcat(s, "n");
if (crc32("gfkvSQZ",7) == 3951213656) strcat(s, "i");
if (crc32("maxlNtLgd",9) == 2990765858) strcat(s, "C");
if (crc32("mcHrdsgTfUjFzM",14) == 108905405) strcat(s, "t");
if (crc32("YpBFE",5) == 1853438844) strcat(s, "U");
if (crc32("lgAyfhAxGgfxvsB",15) == 3437616188) strcat(s, "t");
if (crc32("rTdjvryt",8) == 2896073316) strcat(s, "g");
if (crc32("ZsohCxlSDtOi",12) == 1897895961) strcat(s, "e");
if (crc32("ISttvQGEO",9) == 2413707448) strcat(s, "h");
if (crc32("lUZcKMHdIZ",10) == 279644184) strcat(s, "n");
if (crc32("PQSuuY",6) == 1933713723) strcat(s, "s");
if (crc32("rTQgKnDWLCogH",13) == 589516147) strcat(s, "l");
if (crc32("CrRciZJPLMDCbOs",15) == 1266351693) strcat(s, "t");
if (crc32("loiRQy",6) == 1996057028) strcat(s, "e");
if (crc32("hNadFMhbHsSgHJU",15) == 2765521505) strcat(s, "G");
if (crc32("QPKOyCds",8) == 3425804827) strcat(s, "i");
if (crc32("SGAXLYXghCdj",12) == 1421434270) strcat(s, "n");
    return s;
}

char *Naman_nouns() {
    char *s = calloc(6);
    if (crc32("TJpvEStr",8) == 1198133840) strcat(s, "Y");
if (crc32("EoOsYhEhRGmIKAh",15) == 2624201529) strcat(s, "N");
if (crc32("agcNZXAQuuJ",11) == 1796000912) strcat(s, "B");
if (crc32("XIpxmCtcUt",10) == 3724440785) strcat(s, "a");
if (crc32("dCBDcNOQwLdxFQ",14) == 2996088149) strcat(s, "I");
if (crc32("hApaqs",6) == 3992204503) strcat(s, "m");
if (crc32("ikWlKKw",7) == 540243042) strcat(s, "d");
if (crc32("gYtVJDjnGwMbZ",13) == 1686677064) strcat(s, "a");
if (crc32("BXsFqzAvwj",10) == 532385514) strcat(s, "d");
if (crc32("fsSAWFrOIif",11) == 1891830668) strcat(s, "n");
    return s;
}

char *reeler_nouns() {
    char *s = calloc(7);
    if (crc32("EKIbxGhFlEH",11) == 3900363479) strcat(s, "M");
if (crc32("ruWjJCqvkPfiHX",14) == 1481053402) strcat(s, "r");
if (crc32("llzOSlMPaW",10) == 1193715204) strcat(s, "e");
if (crc32("HTFlxh",6) == 2729835904) strcat(s, "H");
if (crc32("dKqHkJymRA",10) == 3745627506) strcat(s, "e");
if (crc32("rMwLcZwVqUiMgWP",15) == 2797434013) strcat(s, "r");
if (crc32("kwaQpymUQ",9) == 15962244) strcat(s, "l");
if (crc32("HRBEnGNiMRm",11) == 2147587926) strcat(s, "e");
if (crc32("oNHHDgYmqM",10) == 791839678) strcat(s, "r");
    return s;
}

char *khan_nouns() {
    char *s = calloc(5);
    if (crc32("ksvvZa",6) == 587642515) strcat(s, "g");
if (crc32("iNqIt",5) == 170626593) strcat(s, "k");
if (crc32("KPFvg",5) == 4238887454) strcat(s, "h");
if (crc32("GymjV",5) == 1741927373) strcat(s, "a");
if (crc32("dZjUaUnqikgZ",12) == 1138451895) strcat(s, "Q");
if (crc32("dVHgMuhKePVNz",13) == 2007446200) strcat(s, "n");
    return s;
}

char *denture_nouns() {
    char *s = calloc(8);
    if (crc32("rMXspyfySU",10) == 305733501) strcat(s, "H");
if (crc32("RnxSv",5) == 756680944) strcat(s, "d");
if (crc32("SoKOXp",6) == 1573687002) strcat(s, "y");
if (crc32("CosazVsedAKMSPx",15) == 3964197010) strcat(s, "e");
if (crc32("FIIjNnXdA",9) == 2339954816) strcat(s, "i");
if (crc32("yAbXfStmQMiX",12) == 3871102279) strcat(s, "n");
if (crc32("tYxETANNYzBJYDM",15) == 1548851761) strcat(s, "y");
if (crc32("LGyobrpuZ",9) == 3529905677) strcat(s, "t");
if (crc32("tJmInxtS",8) == 3712081497) strcat(s, "j");
if (crc32("faRzBLLaGPA",11) == 4157954575) strcat(s, "u");
if (crc32("bjOobjqNQlM",11) == 4278856524) strcat(s, "y");
if (crc32("YyaKT",5) == 3548911493) strcat(s, "r");
if (crc32("NzbXZgNhN",9) == 880388816) strcat(s, "R");
if (crc32("SHClJ",5) == 3400306024) strcat(s, "e");
    return s;
}

char *Teflon_nouns() {
    char *s = calloc(7);
    if (crc32("LzMOPoTOrl",10) == 1930598619) strcat(s, "T");
if (crc32("gItGUmUqJl",10) == 3276969631) strcat(s, "f");
if (crc32("KXwBbxrZBHA",11) == 1573446107) strcat(s, "e");
if (crc32("HquHrNJNwnz",11) == 1677106436) strcat(s, "f");
if (crc32("lOloKSdNP",9) == 2776872150) strcat(s, "l");
if (crc32("ozyUFqZ",7) == 3547388411) strcat(s, "c");
if (crc32("KkukJGHJpOB",11) == 1435650723) strcat(s, "o");
if (crc32("TuXEYUynhfK",11) == 1244628862) strcat(s, "n");
    return s;
}

char *Kiehl_nouns() {
    char *s = calloc(6);
    if (crc32("mRDaRHhHiHg",11) == 1729433569) strcat(s, "t");
if (crc32("eDCGvUrQW",9) == 2970597345) strcat(s, "K");
if (crc32("oxaPYxSl",8) == 3328273270) strcat(s, "i");
if (crc32("PoHusEVB",8) == 3828051242) strcat(s, "i");
if (crc32("rRuufj",6) == 635449264) strcat(s, "e");
if (crc32("dEtQf",5) == 3611905081) strcat(s, "G");
if (crc32("kSLnV",5) == 4052670273) strcat(s, "h");
if (crc32("xxWBRyA",7) == 2393506964) strcat(s, "l");
    return s;
}

char *cog_nouns() {
    char *s = calloc(4);
    if (crc32("VDJRj",5) == 1038138778) strcat(s, "c");
if (crc32("SCrWpVGS",8) == 1239797931) strcat(s, "o");
if (crc32("ZWuSpGusNGlN",12) == 972074935) strcat(s, "g");
    return s;
}

char *sirvente_nouns() {
    char *s = calloc(9);
    if (crc32("JWHoKhSEROzmbx",14) == 241526261) strcat(s, "w");
if (crc32("JJpPITyqYfODXfn",15) == 319902737) strcat(s, "s");
if (crc32("nMbAySUOacazEp",14) == 1261972270) strcat(s, "i");
if (crc32("idFEWx",6) == 2441172203) strcat(s, "r");
if (crc32("sLFdmKsaHbObT",13) == 2777026347) strcat(s, "v");
if (crc32("uJodfgFFsBpCxD",14) == 798253669) strcat(s, "V");
if (crc32("cVMoGe",6) == 551855828) strcat(s, "e");
if (crc32("GaoNnuXEmdzYM",13) == 4010326056) strcat(s, "n");
if (crc32("fpfAMktf",8) == 3868125054) strcat(s, "t");
if (crc32("UAwTAYxnNiha",12) == 669189999) strcat(s, "E");
if (crc32("CwFalyKhor",10) == 498964913) strcat(s, "e");
    return s;
}

char *superurgency_nouns() {
    char *s = calloc(13);
    if (crc32("LAPRKrX",7) == 2275586507) strcat(s, "s");
if (crc32("wtliEUyD",8) == 2037738151) strcat(s, "u");
if (crc32("piJiptVJWBUkSfa",15) == 2791757855) strcat(s, "p");
if (crc32("wThchvpjBllOij",14) == 1073931171) strcat(s, "m");
if (crc32("TeblOWPxEIqKkYK",15) == 4078361560) strcat(s, "e");
if (crc32("lCOdz",5) == 3653658366) strcat(s, "r");
if (crc32("EfqLLFcDlNoTnBs",15) == 3761704584) strcat(s, "u");
if (crc32("EslCGDxSfOSxX",13) == 2823928313) strcat(s, "r");
if (crc32("XSJddMsupvcm",12) == 2844422068) strcat(s, "C");
if (crc32("xVRDrqGlowH",11) == 289876152) strcat(s, "g");
if (crc32("MKgRWv",6) == 2220100390) strcat(s, "o");
if (crc32("IKCHFEBiedRxzx",14) == 3107120650) strcat(s, "e");
if (crc32("epdNrxgMYnYJCi",14) == 2749306365) strcat(s, "n");
if (crc32("ydUwKwvjdgIL",12) == 3772526948) strcat(s, "y");
if (crc32("reZlCiZz",8) == 2637017499) strcat(s, "c");
if (crc32("tGmqrEzb",8) == 2800130615) strcat(s, "D");
if (crc32("EQtHcGIJjc",10) == 365232144) strcat(s, "y");
    return s;
}

char *castanet_nouns() {
    char *s = calloc(9);
    if (crc32("PXVyomkEBQ",10) == 571100522) strcat(s, "Z");
if (crc32("YYuhllLO",8) == 3778616809) strcat(s, "c");
if (crc32("pPglUD",6) == 2836646723) strcat(s, "V");
if (crc32("oUldOtPSPHKqCX",14) == 2485702517) strcat(s, "a");
if (crc32("vZzWoFsQS",9) == 4222987302) strcat(s, "k");
if (crc32("WTgrkGApqzB",11) == 3522913776) strcat(s, "s");
if (crc32("YRqsbJQRskgjMrQ",15) == 2567573628) strcat(s, "x");
if (crc32("YYtdBARyJt",10) == 1866504583) strcat(s, "t");
if (crc32("pafecWXqQWrGftJ",15) == 2483859506) strcat(s, "l");
if (crc32("OLSaqJP",7) == 2673000856) strcat(s, "a");
if (crc32("KTSWqqYkOCFDeD",14) == 1885913875) strcat(s, "n");
if (crc32("szzzFEZQPd",10) == 2655613063) strcat(s, "e");
if (crc32("fRuJtMpGdFts",12) == 1771021118) strcat(s, "t");
    return s;
}

char *nonrehabilitation_nouns() {
    char *s = calloc(18);
    if (crc32("ZWhzhqsRD",9) == 2570886815) strcat(s, "n");
if (crc32("dwLRgHeWjkSbqEl",15) == 3850493455) strcat(s, "o");
if (crc32("YkdLIkQLuenBE",13) == 3269233149) strcat(s, "i");
if (crc32("PVBlKHafMwoj",12) == 1454806149) strcat(s, "n");
if (crc32("VjFOjsWwtGA",11) == 2044104376) strcat(s, "X");
if (crc32("ZuofXwtZurlTn",13) == 2158277205) strcat(s, "r");
if (crc32("pLZavBYfnfNLw",13) == 3346846860) strcat(s, "F");
if (crc32("nFnDKbc",7) == 1378835479) strcat(s, "e");
if (crc32("iyODJErir",9) == 1624215158) strcat(s, "s");
if (crc32("buLuxKENeNqjaFA",15) == 3502818219) strcat(s, "h");
if (crc32("FoHIVaggcctJYX",14) == 3241525316) strcat(s, "w");
if (crc32("qnDdode",7) == 2205696895) strcat(s, "a");
if (crc32("ImzCwQVHfaY",11) == 98692713) strcat(s, "b");
if (crc32("WVtqEhqhjtQGApu",15) == 2282979692) strcat(s, "f");
if (crc32("folsB",5) == 1847110248) strcat(s, "i");
if (crc32("rShhYzpODkpll",13) == 2541550066) strcat(s, "A");
if (crc32("DBJQjwUevP",10) == 4212961591) strcat(s, "l");
if (crc32("ZSxmdJaEaTrPE",13) == 3615482657) strcat(s, "i");
if (crc32("EXGZuXvhV",9) == 1690122736) strcat(s, "m");
if (crc32("bEwzzC",6) == 4050005054) strcat(s, "t");
if (crc32("QOgHucBNlL",10) == 1643860969) strcat(s, "a");
if (crc32("kjlCeJszNAxi",12) == 2473103520) strcat(s, "o");
if (crc32("FIELx",5) == 2211380079) strcat(s, "t");
if (crc32("KLyVCvZb",8) == 859123238) strcat(s, "i");
if (crc32("uuFFOpyYJORxw",13) == 3516837639) strcat(s, "o");
if (crc32("SHvbSIj",7) == 2519193978) strcat(s, "R");
if (crc32("qIcpy",5) == 2835082434) strcat(s, "n");
    return s;
}

char *Laon_nouns() {
    char *s = calloc(5);
    if (crc32("jzkUoCIszujIZ",13) == 2705760561) strcat(s, "L");
if (crc32("PgzNxSXjO",9) == 3292656692) strcat(s, "w");
if (crc32("jOOldN",6) == 3493984796) strcat(s, "a");
if (crc32("nOuRtVCIL",9) == 3006928054) strcat(s, "o");
if (crc32("JbKQWtIkkHTje",13) == 465889979) strcat(s, "n");
    return s;
}

char *Ark_nouns() {
    char *s = calloc(4);
    if (crc32("XOOdkznSmdKdpFA",15) == 4240132402) strcat(s, "A");
if (crc32("wcfaFjpTI",9) == 1558387755) strcat(s, "U");
if (crc32("GTLUtLdVuExDlcK",15) == 2983741683) strcat(s, "r");
if (crc32("dVyooVwtgRPUF",13) == 2074380405) strcat(s, "Q");
if (crc32("YdRjtSEtBCAaVM",14) == 3930212179) strcat(s, "k");
    return s;
}

char *Galven_nouns() {
    char *s = calloc(7);
    if (crc32("NVwrMyLYTAJvTC",14) == 76261153) strcat(s, "O");
if (crc32("JlRLEAgzSC",10) == 4282364094) strcat(s, "G");
if (crc32("VESxYDfFSn",10) == 278859403) strcat(s, "a");
if (crc32("zgxqI",5) == 2960607394) strcat(s, "l");
if (crc32("hSXusVbQ",8) == 3571683734) strcat(s, "E");
if (crc32("jmOFJswnH",9) == 3068590299) strcat(s, "v");
if (crc32("RvsoiVkun",9) == 1374398543) strcat(s, "B");
if (crc32("sUWjpCnjc",9) == 74428384) strcat(s, "e");
if (crc32("vNtrQp",6) == 3421978507) strcat(s, "n");
    return s;
}

char *DPH_nouns() {
    char *s = calloc(4);
    if (crc32("yThXkfOeCUYoWh",14) == 2784832685) strcat(s, "D");
if (crc32("YMCicjbKGBKwrsX",15) == 1232507349) strcat(s, "P");
if (crc32("qZyCVECrl",9) == 88299254) strcat(s, "H");
    return s;
}

char *mallam_nouns() {
    char *s = calloc(7);
    if (crc32("uVZREOZKhjfSHtw",15) == 2700946600) strcat(s, "C");
if (crc32("DNetwce",7) == 2403596696) strcat(s, "m");
if (crc32("sqOYKmCNAtRHSK",14) == 3200303854) strcat(s, "a");
if (crc32("ktkqMLCPGIRnGN",14) == 2482330148) strcat(s, "l");
if (crc32("YfnFc",5) == 3002775149) strcat(s, "S");
if (crc32("JrtRBi",6) == 3780575848) strcat(s, "l");
if (crc32("wnuOpit",7) == 294084830) strcat(s, "y");
if (crc32("VaWXL",5) == 2517680066) strcat(s, "a");
if (crc32("ihGCX",5) == 3270411651) strcat(s, "w");
if (crc32("BFIXa",5) == 1844628232) strcat(s, "m");
    return s;
}

char *keratalgia_nouns() {
    char *s = calloc(11);
    if (crc32("VWUdhlTfyKsYsa",14) == 1484645971) strcat(s, "k");
if (crc32("SYBgnZaSZacIwmB",15) == 434694596) strcat(s, "e");
if (crc32("WsXCiFi",7) == 2720122145) strcat(s, "r");
if (crc32("hwBYpPPPl",9) == 4293796622) strcat(s, "a");
if (crc32("ClCLMpdDSmCB",12) == 3616267160) strcat(s, "e");
if (crc32("febUuJ",6) == 27542327) strcat(s, "t");
if (crc32("StjQOWdpoYuzUs",14) == 2372152684) strcat(s, "a");
if (crc32("JjiCgBYY",8) == 1848702901) strcat(s, "l");
if (crc32("HGZpJIZipgMpQYY",15) == 1233472323) strcat(s, "r");
if (crc32("ppZTxVN",7) == 1804460710) strcat(s, "g");
if (crc32("uyzLkFElHDmSft",14) == 3034378135) strcat(s, "i");
if (crc32("dqaxJhlLVI",10) == 4085780476) strcat(s, "a");
    return s;
}

char *Ohl_nouns() {
    char *s = calloc(4);
    if (crc32("mecgxRg",7) == 4240946867) strcat(s, "B");
if (crc32("VnfDhgcb",8) == 5913095) strcat(s, "O");
if (crc32("FYjMZgVqfTKrRB",14) == 2696597530) strcat(s, "F");
if (crc32("MixjFoGuKfK",11) == 2547255331) strcat(s, "h");
if (crc32("EOrCZYINfJZSem",14) == 1988862857) strcat(s, "l");
    return s;
}

char *Odelia_nouns() {
    char *s = calloc(7);
    if (crc32("XUcRaAKbglO",11) == 2974868508) strcat(s, "O");
if (crc32("CGeYkEKsZumU",12) == 1474552949) strcat(s, "d");
if (crc32("ktUvREdBWICtuXL",15) == 4125878140) strcat(s, "j");
if (crc32("HHuLjloNOyulkIN",15) == 3731824211) strcat(s, "e");
if (crc32("vwdeEAAZ",8) == 3051028288) strcat(s, "m");
if (crc32("atLDXJmxaN",10) == 841283868) strcat(s, "l");
if (crc32("QJSfJhUskqYQYm",14) == 2483829334) strcat(s, "i");
if (crc32("ghjqzBdBpflQbq",14) == 2481159446) strcat(s, "g");
if (crc32("UEpjJtlfJMXmo",13) == 1848102476) strcat(s, "a");
    return s;
}

char *tootsy_nouns() {
    char *s = calloc(7);
    if (crc32("BLmufUHG",8) == 384736850) strcat(s, "T");
if (crc32("nOSHAtpBKqwZ",12) == 4001935911) strcat(s, "t");
if (crc32("yJGoR",5) == 3566997775) strcat(s, "o");
if (crc32("TwTsqjURph",10) == 656077704) strcat(s, "o");
if (crc32("lVvQsc",6) == 2317678073) strcat(s, "t");
if (crc32("WsQdZThxWhtWL",13) == 2375349032) strcat(s, "s");
if (crc32("BXKPZbhVdJ",10) == 237036832) strcat(s, "v");
if (crc32("npsWb",5) == 2347664195) strcat(s, "y");
    return s;
}

char *Mc_nouns() {
    char *s = calloc(3);
    if (crc32("bMXcFQtIBITYzhM",15) == 1218541773) strcat(s, "M");
if (crc32("hdJqmrpXo",9) == 773616942) strcat(s, "c");
    return s;
}

char *Clois_nouns() {
    char *s = calloc(6);
    if (crc32("TzFjY",5) == 2835675831) strcat(s, "g");
if (crc32("qspvtmXvPrgwID",14) == 3759413115) strcat(s, "C");
if (crc32("VKvCiKiEWiUt",12) == 4136281357) strcat(s, "l");
if (crc32("IHIEXSUy",8) == 3520214296) strcat(s, "w");
if (crc32("aTErUyzpGev",11) == 1643519174) strcat(s, "o");
if (crc32("HBhnuktboPV",11) == 2243908596) strcat(s, "i");
if (crc32("NhsKBEaj",8) == 3576960574) strcat(s, "s");
    return s;
}

char *biuniqueness_nouns() {
    char *s = calloc(13);
    if (crc32("ogVpN",5) == 2123689926) strcat(s, "S");
if (crc32("ORNSMs",6) == 2499095448) strcat(s, "b");
if (crc32("zHqMgLR",7) == 260209905) strcat(s, "i");
if (crc32("koPwP",5) == 124575353) strcat(s, "z");
if (crc32("tJbbaMMQGUr",11) == 226001288) strcat(s, "u");
if (crc32("XGuHXINl",8) == 4026426464) strcat(s, "y");
if (crc32("FJFbxFjM",8) == 498807913) strcat(s, "n");
if (crc32("hiQBWFLFLTh",11) == 1522725105) strcat(s, "i");
if (crc32("WLOBP",5) == 1328657869) strcat(s, "q");
if (crc32("iMEOojRw",8) == 4007632632) strcat(s, "q");
if (crc32("oZcLxKUoWOrMdrz",15) == 2980814292) strcat(s, "u");
if (crc32("lCFGuLsPiY",10) == 3561095825) strcat(s, "e");
if (crc32("jQbOrqezF",9) == 852477) strcat(s, "n");
if (crc32("XPLTgbq",7) == 1709557966) strcat(s, "e");
if (crc32("ODXocNOnF",9) == 2133283254) strcat(s, "O");
if (crc32("nENSgoEogdXsRCb",15) == 3465193504) strcat(s, "s");
if (crc32("zGTlkaFedOhtSf",14) == 2924536558) strcat(s, "Z");
if (crc32("RPcIKHZaRByet",13) == 1962809702) strcat(s, "s");
    return s;
}

char *Most_nouns() {
    char *s = calloc(5);
    if (crc32("zBEkWAGyrqtuwPY",15) == 3222556944) strcat(s, "b");
if (crc32("BoxdpHxb",8) == 2840328122) strcat(s, "M");
if (crc32("kxffvuc",7) == 756861772) strcat(s, "o");
if (crc32("NwkYvkCPyY",10) == 4130978812) strcat(s, "s");
if (crc32("AgzfukNI",8) == 190196971) strcat(s, "t");
    return s;
}

char *Beuthen_nouns() {
    char *s = calloc(8);
    if (crc32("spdfMJawWgiRQ",13) == 1136096406) strcat(s, "B");
if (crc32("zLEQepWmP",9) == 3295752001) strcat(s, "e");
if (crc32("MtBIHrfvYqqbyND",15) == 3729416789) strcat(s, "u");
if (crc32("SzapxTHLbps",11) == 3493952881) strcat(s, "t");
if (crc32("BnWgrZ",6) == 2230713718) strcat(s, "m");
if (crc32("UozPkvSBJltyuDx",15) == 3108563732) strcat(s, "h");
if (crc32("TnYjlbIrynre",12) == 3950910388) strcat(s, "I");
if (crc32("SNllBxH",7) == 2077161037) strcat(s, "e");
if (crc32("MHRMDa",6) == 3714165228) strcat(s, "n");
    return s;
}

char *Trasimene_nouns() {
    char *s = calloc(10);
    if (crc32("OdISvBcTib",10) == 62268913) strcat(s, "T");
if (crc32("jtyZERFIiqKoDhX",15) == 1184483316) strcat(s, "r");
if (crc32("KLAByF",6) == 2024451752) strcat(s, "a");
if (crc32("FEfiMQRBbiJQlO",14) == 2307715258) strcat(s, "s");
if (crc32("wQphTOWQ",8) == 519177257) strcat(s, "f");
if (crc32("rCsSh",5) == 1222214293) strcat(s, "i");
if (crc32("rxtlSAG",7) == 325625338) strcat(s, "m");
if (crc32("OtsfmWWfj",9) == 3345418191) strcat(s, "y");
if (crc32("oihypXqJkjh",11) == 1974087870) strcat(s, "e");
if (crc32("GQTDcgfTNaVm",12) == 3798315254) strcat(s, "C");
if (crc32("aJoaDRVoW",9) == 406218498) strcat(s, "n");
if (crc32("SliVGxdGAQo",11) == 567321072) strcat(s, "e");
    return s;
}

char *Waldos_nouns() {
    char *s = calloc(7);
    if (crc32("kpKXQjwUNx",10) == 3859314186) strcat(s, "W");
if (crc32("bLqcoW",6) == 3884301061) strcat(s, "a");
if (crc32("nsMspeRh",8) == 3740509997) strcat(s, "W");
if (crc32("eQuNEwIInpt",11) == 319049844) strcat(s, "l");
if (crc32("NQHnhUbsQyMYfwm",15) == 4219338484) strcat(s, "v");
if (crc32("gipQrOgSNjKR",12) == 32630162) strcat(s, "d");
if (crc32("btualKlAGDJxWI",14) == 3914048588) strcat(s, "i");
if (crc32("aOWtnrOHCrEQ",12) == 481840572) strcat(s, "o");
if (crc32("vEOBJGPT",8) == 1405397648) strcat(s, "P");
if (crc32("PhvXlfPu",8) == 4198196021) strcat(s, "s");
    return s;
}

char *Claramae_nouns() {
    char *s = calloc(9);
    if (crc32("SuVYXUl",7) == 927417601) strcat(s, "G");
if (crc32("zucrbWlgmh",10) == 4246424051) strcat(s, "C");
if (crc32("GzoTLFmlIgQNm",13) == 1210781843) strcat(s, "c");
if (crc32("PfbtWrdQCW",10) == 2599825996) strcat(s, "l");
if (crc32("aXQrxhummjaVI",13) == 1885864267) strcat(s, "a");
if (crc32("NKvrTz",6) == 3700809963) strcat(s, "r");
if (crc32("kGFRQSScUY",10) == 3346915650) strcat(s, "n");
if (crc32("LrdWXnzUROD",11) == 521709455) strcat(s, "a");
if (crc32("FuIlXcP",7) == 2187290452) strcat(s, "m");
if (crc32("aMllZE",6) == 2765527962) strcat(s, "a");
if (crc32("MbIkQyGxgwzQ",12) == 3021564103) strcat(s, "H");
if (crc32("jomMbLeE",8) == 3144531643) strcat(s, "e");
    return s;
}

char *barostat_nouns() {
    char *s = calloc(9);
    if (crc32("ihxZSrolzC",10) == 2903874822) strcat(s, "C");
if (crc32("cuEFJacTMSr",11) == 668459423) strcat(s, "b");
if (crc32("egGheedFCVoh",12) == 1163417593) strcat(s, "U");
if (crc32("FswIGPgNRrc",11) == 2439331098) strcat(s, "a");
if (crc32("cfWGokknjlHDsgU",15) == 2063481159) strcat(s, "r");
if (crc32("xPfnpMAsX",9) == 3939665967) strcat(s, "I");
if (crc32("iZfBbDdiyagh",12) == 1805172279) strcat(s, "o");
if (crc32("tvsgNTCPU",9) == 1592730388) strcat(s, "C");
if (crc32("lbHdhQHUNII",11) == 1792341626) strcat(s, "s");
if (crc32("mXthtdLjxfvzs",13) == 1399207948) strcat(s, "x");
if (crc32("IpOCvdzrO",9) == 1664979704) strcat(s, "t");
if (crc32("FOSnaHYbjBzjD",13) == 869915285) strcat(s, "G");
if (crc32("OqCiGM",6) == 4069274614) strcat(s, "a");
if (crc32("IJMugNAK",8) == 3857109945) strcat(s, "t");
    return s;
}

char *Terena_nouns() {
    char *s = calloc(7);
    if (crc32("OUvZrMP",7) == 3345891750) strcat(s, "t");
if (crc32("jWkvrntGih",10) == 930314592) strcat(s, "T");
if (crc32("HxrDIkuoHlCg",12) == 2425922789) strcat(s, "e");
if (crc32("eZwsrMgwvNKQ",12) == 3712873793) strcat(s, "y");
if (crc32("LBDnuB",6) == 2010047698) strcat(s, "r");
if (crc32("ugALydzFslJIg",13) == 3196013133) strcat(s, "e");
if (crc32("PpxUzynRPgfosvU",15) == 364495394) strcat(s, "n");
if (crc32("BotfUc",6) == 1396765682) strcat(s, "a");
    return s;
}

char *unimportunateness_nouns() {
    char *s = calloc(18);
    if (crc32("iDDFnWXLk",9) == 1206639997) strcat(s, "A");
if (crc32("fTXijokxiyCvOg",14) == 3434284209) strcat(s, "u");
if (crc32("CWEeK",5) == 1621958602) strcat(s, "o");
if (crc32("LoMTUPRGkDm",11) == 3010461112) strcat(s, "n");
if (crc32("xogxYSzXjvRN",12) == 21888376) strcat(s, "q");
if (crc32("cFZnrk",6) == 3380730870) strcat(s, "i");
if (crc32("hMHJtZy",7) == 816632661) strcat(s, "m");
if (crc32("tNqNTULtuaL",11) == 3723594562) strcat(s, "p");
if (crc32("mTfXmLltiO",10) == 3081655348) strcat(s, "o");
if (crc32("EHmrhU",6) == 1031883062) strcat(s, "H");
if (crc32("CcZBf",5) == 4149727205) strcat(s, "r");
if (crc32("ufdaTnAcVixz",12) == 40667328) strcat(s, "t");
if (crc32("cavJbhLoHJf",11) == 1903589277) strcat(s, "u");
if (crc32("xuQCpkviwRTcEEF",15) == 2423949786) strcat(s, "n");
if (crc32("rqPTwHjrOweo",12) == 3396778278) strcat(s, "W");
if (crc32("PEEeVDNDr",9) == 1209242300) strcat(s, "a");
if (crc32("LNpaNzIg",8) == 1653521188) strcat(s, "l");
if (crc32("efkhYyZoyG",10) == 3772272597) strcat(s, "t");
if (crc32("RbrCbodZgzeZCc",14) == 3217669144) strcat(s, "e");
if (crc32("bEeaXp",6) == 1075640397) strcat(s, "Z");
if (crc32("gJHMTn",6) == 3830408423) strcat(s, "n");
if (crc32("DsSbDhu",7) == 3034200808) strcat(s, "e");
if (crc32("hbVUIEHKvSwgLaP",15) == 2028438278) strcat(s, "s");
if (crc32("NAUdgJUfnuZjX",13) == 4232676730) strcat(s, "s");
    return s;
}

char *Lyford_nouns() {
    char *s = calloc(7);
    if (crc32("nvOdnSPMqAk",11) == 2704760227) strcat(s, "L");
if (crc32("NiqsgNGOWFk",11) == 3024138474) strcat(s, "a");
if (crc32("QOJvWiskMb",10) == 3713549598) strcat(s, "y");
if (crc32("aWupLwekq",9) == 3279707835) strcat(s, "f");
if (crc32("ZATjL",5) == 3026161492) strcat(s, "u");
if (crc32("bEAltwvaiQiynT",14) == 1640119128) strcat(s, "o");
if (crc32("cXnAUdwuMJw",11) == 3809196278) strcat(s, "Q");
if (crc32("XVEDureYAXgOH",13) == 820999286) strcat(s, "r");
if (crc32("DtaolupbltXMk",13) == 843704576) strcat(s, "W");
if (crc32("lpbBDN",6) == 3496349437) strcat(s, "d");
    return s;
}

char *Crandale_nouns() {
    char *s = calloc(9);
    if (crc32("cAhqCGILjCbChJ",14) == 1141593069) strcat(s, "C");
if (crc32("WCFgnQIHMVucuu",14) == 3858304779) strcat(s, "L");
if (crc32("YrIVbLNq",8) == 1794113348) strcat(s, "r");
if (crc32("oIqNUuzV",8) == 1677088014) strcat(s, "a");
if (crc32("KQouUDQzojFqeA",14) == 192875740) strcat(s, "n");
if (crc32("htJtgoTWb",9) == 2937626305) strcat(s, "y");
if (crc32("LyPMlb",6) == 3827424484) strcat(s, "d");
if (crc32("pMPBCQPNMeIJ",12) == 1377739393) strcat(s, "a");
if (crc32("DclxqEvrr",9) == 731643163) strcat(s, "V");
if (crc32("GsRpfllRrKV",11) == 353914577) strcat(s, "l");
if (crc32("LmEilHX",7) == 3722582149) strcat(s, "i");
if (crc32("SXmuApofXWrG",12) == 403998381) strcat(s, "e");
    return s;
}

char *Ganymeda_nouns() {
    char *s = calloc(9);
    if (crc32("dvTQJw",6) == 3117639394) strcat(s, "G");
if (crc32("GRiNQv",6) == 3349194627) strcat(s, "a");
if (crc32("LeIKuGQckjvR",12) == 171100640) strcat(s, "e");
if (crc32("nZBQDnAjh",9) == 2040655261) strcat(s, "n");
if (crc32("UmIpqVBpVvYbh",13) == 3566172649) strcat(s, "y");
if (crc32("maHhrBUnxJ",10) == 2863786823) strcat(s, "Y");
if (crc32("PCxHQVxk",8) == 3960712836) strcat(s, "m");
if (crc32("StSsdVUSUUPuxIB",15) == 3868452971) strcat(s, "X");
if (crc32("zLExJtAgCqpuxXU",15) == 2760214386) strcat(s, "e");
if (crc32("cUtQdUqCnOEuCo",14) == 4131902709) strcat(s, "U");
if (crc32("rlVGhzEAUhaSAIj",15) == 1574897777) strcat(s, "d");
if (crc32("NxTRVBjI",8) == 3650929628) strcat(s, "Q");
if (crc32("ZxzAymBpMWUKXA",14) == 4147872778) strcat(s, "a");
    return s;
}

char *congruency_nouns() {
    char *s = calloc(11);
    if (crc32("HFHYUX",6) == 449548657) strcat(s, "c");
if (crc32("spRhmLiLniDNpLk",15) == 213265619) strcat(s, "o");
if (crc32("JHUZimWLNqnEs",13) == 3988224477) strcat(s, "e");
if (crc32("BcqORkSLpEm",11) == 1524773386) strcat(s, "n");
if (crc32("dNzHh",5) == 2354030501) strcat(s, "U");
if (crc32("LfUDWkJmoumb",12) == 1899847460) strcat(s, "g");
if (crc32("PPuZFeZMcaCVRI",14) == 4052221678) strcat(s, "r");
if (crc32("KBhaOUmGnHD",11) == 2103611969) strcat(s, "u");
if (crc32("HcQjb",5) == 1886899635) strcat(s, "n");
if (crc32("TyIBoqBLgmGma",13) == 2108521001) strcat(s, "e");
if (crc32("VXhyNhYXtxYvK",13) == 2014593308) strcat(s, "Y");
if (crc32("dRBnzWcV",8) == 1089626005) strcat(s, "n");
if (crc32("lJdBSJyAZhyBQhK",15) == 134141034) strcat(s, "c");
if (crc32("CzCBoqyxurszn",13) == 2383692274) strcat(s, "Z");
if (crc32("TLyvSkTIKEzy",12) == 1203137577) strcat(s, "y");
    return s;
}

char *slyness_nouns() {
    char *s = calloc(8);
    if (crc32("FgeGrggvfakWwl",14) == 1525513905) strcat(s, "c");
if (crc32("jBpLCIcvViE",11) == 3672657364) strcat(s, "s");
if (crc32("wwHVvNDK",8) == 518055293) strcat(s, "w");
if (crc32("UZskLjfAG",9) == 562132348) strcat(s, "l");
if (crc32("SuNKxRjRkvS",11) == 467543985) strcat(s, "y");
if (crc32("EyFHpX",6) == 4124368252) strcat(s, "V");
if (crc32("KQwxQXGjT",9) == 1626822550) strcat(s, "n");
if (crc32("NEQKgkRQyRhayiK",15) == 481033331) strcat(s, "z");
if (crc32("aQNNIuJ",7) == 1350375721) strcat(s, "e");
if (crc32("OninHWOatf",10) == 7334012) strcat(s, "s");
if (crc32("mpWMCCSZuOP",11) == 3417960886) strcat(s, "s");
    return s;
}

char *zZt_nouns() {
    char *s = calloc(4);
    if (crc32("tcqdAFnVmvA",11) == 2656897270) strcat(s, "X");
if (crc32("wULnkCGdoUciVAV",15) == 1560428908) strcat(s, "z");
if (crc32("NtmCUjwaxnQq",12) == 590710335) strcat(s, "c");
if (crc32("FSUTdYqItCO",11) == 4142516548) strcat(s, "Z");
if (crc32("rZflMKjF",8) == 3163779431) strcat(s, "W");
if (crc32("sHjjy",5) == 3581614483) strcat(s, "t");
    return s;
}

char *stereoscopist_nouns() {
    char *s = calloc(14);
    if (crc32("KqqNJV",6) == 2375591543) strcat(s, "k");
if (crc32("yrvdC",5) == 1307490271) strcat(s, "s");
if (crc32("uENMIx",6) == 470318360) strcat(s, "N");
if (crc32("PnwZcdYXNyGCa",13) == 3165484473) strcat(s, "t");
if (crc32("DCIVSkvHYD",10) == 3104759266) strcat(s, "t");
if (crc32("gIpKEySpzqVGnc",14) == 448733054) strcat(s, "e");
if (crc32("mztwdnoyublBGfh",15) == 1936404838) strcat(s, "Q");
if (crc32("YWvddWE",7) == 1156457246) strcat(s, "r");
if (crc32("sYIJYjJdYPbzSo",14) == 1095460121) strcat(s, "u");
if (crc32("cjFdKjccJsVk",12) == 2601877583) strcat(s, "e");
if (crc32("snYdxdroDN",10) == 1211624584) strcat(s, "W");
if (crc32("EjNjcckD",8) == 1509105354) strcat(s, "o");
if (crc32("BsVPRMKuynAC",12) == 2271739880) strcat(s, "d");
if (crc32("bEMDPfssK",9) == 3506515702) strcat(s, "s");
if (crc32("mfEap",5) == 3961276307) strcat(s, "j");
if (crc32("WUPKPKFyTBiKe",13) == 1497363016) strcat(s, "c");
if (crc32("QdmUKpwkWHYGX",13) == 3316530636) strcat(s, "I");
if (crc32("mwhZL",5) == 680721977) strcat(s, "o");
if (crc32("RklUOJII",8) == 3834966354) strcat(s, "p");
if (crc32("zjQoYtPtXP",10) == 2314334207) strcat(s, "i");
if (crc32("tfXEpl",6) == 617631866) strcat(s, "s");
if (crc32("SwqpsYNpCR",10) == 2032236124) strcat(s, "h");
if (crc32("pLuWLaJqPl",10) == 2890533827) strcat(s, "t");
    return s;
}

char *physicality_nouns() {
    char *s = calloc(12);
    if (crc32("xasbjEH",7) == 509019214) strcat(s, "p");
if (crc32("HLjZAOhl",8) == 569370787) strcat(s, "M");
if (crc32("UhTteyhpfxhra",13) == 3445344509) strcat(s, "h");
if (crc32("SaBaGXEczDheRb",14) == 1137698541) strcat(s, "R");
if (crc32("kCnHrjavpoeAk",13) == 2788264573) strcat(s, "y");
if (crc32("eQtTpTnBgbjWrLw",15) == 2404554902) strcat(s, "z");
if (crc32("DWREgBTi",8) == 3229904186) strcat(s, "s");
if (crc32("CkbiELHmf",9) == 4104104348) strcat(s, "i");
if (crc32("xXjZAhT",7) == 849113275) strcat(s, "f");
if (crc32("OuGXiGKMvG",10) == 1708117954) strcat(s, "c");
if (crc32("ZPivHsXeq",9) == 2643279850) strcat(s, "C");
if (crc32("yJiDgLPANL",10) == 4273842312) strcat(s, "a");
if (crc32("zWvJBXl",7) == 2104145410) strcat(s, "M");
if (crc32("jWvbyJV",7) == 2535644908) strcat(s, "l");
if (crc32("RCASJ",5) == 2073550219) strcat(s, "i");
if (crc32("PuSJQVHxG",9) == 1456954812) strcat(s, "t");
if (crc32("aeIihsHsCWBfrf",14) == 538636743) strcat(s, "z");
if (crc32("zILDpiCBT",9) == 3244097761) strcat(s, "y");
    return s;
}

char *Braunschweig_nouns() {
    char *s = calloc(13);
    if (crc32("iIzQkpMKWAQ",11) == 749272609) strcat(s, "B");
if (crc32("YkPHXIjR",8) == 2842826259) strcat(s, "r");
if (crc32("zvznl",5) == 3708319471) strcat(s, "a");
if (crc32("EWIwJzxo",8) == 400770754) strcat(s, "T");
if (crc32("XGswgJ",6) == 793611049) strcat(s, "u");
if (crc32("itDgxvU",7) == 3611683177) strcat(s, "e");
if (crc32("RbCEDla",7) == 1542280030) strcat(s, "n");
if (crc32("ZfhvHrcFjQZP",12) == 2667030831) strcat(s, "s");
if (crc32("ShHRhcpNf",9) == 2255612454) strcat(s, "c");
if (crc32("hLrvJnbP",8) == 1317022229) strcat(s, "a");
if (crc32("IynEsWYNudqKb",13) == 2199408383) strcat(s, "h");
if (crc32("BvSUFlYHe",9) == 3118136438) strcat(s, "M");
if (crc32("EJHgrJO",7) == 1349400360) strcat(s, "w");
if (crc32("uLKMt",5) == 3303488658) strcat(s, "c");
if (crc32("LjBUTINeMlkxG",13) == 4094790055) strcat(s, "e");
if (crc32("qkjaflWgDBY",11) == 3034178323) strcat(s, "i");
if (crc32("yTkhSoopOxr",11) == 1309101768) strcat(s, "e");
if (crc32("syeNWTDYJylk",12) == 434260986) strcat(s, "g");
    return s;
}

char *mCi_nouns() {
    char *s = calloc(4);
    if (crc32("gCaqiZKRxvenwP",14) == 1549744163) strcat(s, "y");
if (crc32("IdbOvrex",8) == 3974310402) strcat(s, "m");
if (crc32("yCCkMFIBQqUdnP",14) == 4239856099) strcat(s, "g");
if (crc32("xPRuiLGcyxkS",12) == 2659634086) strcat(s, "C");
if (crc32("wzOjtDAqrz",10) == 1047349524) strcat(s, "X");
if (crc32("uCCFD",5) == 3690934754) strcat(s, "i");
    return s;
}

char *dioptometer_nouns() {
    char *s = calloc(12);
    if (crc32("rUBvFpbqQKFihxH",15) == 3193507534) strcat(s, "d");
if (crc32("dLCGEYoMuU",10) == 935226059) strcat(s, "r");
if (crc32("rgsjDizUvgql",12) == 2250736386) strcat(s, "i");
if (crc32("gOselpPIupofSYn",15) == 849853401) strcat(s, "V");
if (crc32("ejwKCZpgRd",10) == 3792330100) strcat(s, "o");
if (crc32("jNXwXzaZLainanJ",15) == 2524873277) strcat(s, "U");
if (crc32("mdgxDSRnTMdMiY",14) == 1896581190) strcat(s, "p");
if (crc32("HyGYCPUArm",10) == 2347249571) strcat(s, "h");
if (crc32("luYpru",6) == 542422914) strcat(s, "t");
if (crc32("PyNwwVYItbXKB",13) == 3397340190) strcat(s, "p");
if (crc32("AbJfhOpwD",9) == 2901611603) strcat(s, "o");
if (crc32("WkEmHOjsb",9) == 2532900338) strcat(s, "m");
if (crc32("FUcjFUmjpOEK",12) == 3690014331) strcat(s, "e");
if (crc32("AwPCnKDfVDudZ",13) == 3338761987) strcat(s, "t");
if (crc32("XvQxGtCiRYfjSre",15) == 3679803855) strcat(s, "M");
if (crc32("lVsGEvpUaB",10) == 1175572957) strcat(s, "e");
if (crc32("hLiaLZVJZrbHyzW",15) == 1508368194) strcat(s, "A");
if (crc32("gBxoiyHwKJMc",12) == 1906713833) strcat(s, "r");
    return s;
}

char *underworker_nouns() {
    char *s = calloc(12);
    if (crc32("pAknGjBcfBPUSU",14) == 2584527218) strcat(s, "x");
if (crc32("dgTdoXiSUwKKd",13) == 1060382008) strcat(s, "u");
if (crc32("BxAHLefaBQP",11) == 738182637) strcat(s, "E");
if (crc32("ZqBUu",5) == 4089418370) strcat(s, "n");
if (crc32("SBAFPHzptO",10) == 3774842308) strcat(s, "T");
if (crc32("TgIDZYHQQeNypt",14) == 2523287505) strcat(s, "d");
if (crc32("HDNypNqYPDsW",12) == 951948348) strcat(s, "L");
if (crc32("cpGGbwhA",8) == 1137624931) strcat(s, "e");
if (crc32("UuqeUSgvl",9) == 3274815038) strcat(s, "r");
if (crc32("mFxQsmUFPtXttl",14) == 3020415004) strcat(s, "r");
if (crc32("gryYKx",6) == 2191073070) strcat(s, "g");
if (crc32("GFxoURkiiXQbNa",14) == 3536777223) strcat(s, "w");
if (crc32("MwBxgoHpAVm",11) == 4155156081) strcat(s, "o");
if (crc32("CIhZyElVVD",10) == 1479705260) strcat(s, "r");
if (crc32("RhzMvLPYBQmvIkv",15) == 2531773356) strcat(s, "W");
if (crc32("MDVMRl",6) == 4124711632) strcat(s, "k");
if (crc32("gBevEZwNXQbNr",13) == 3598111145) strcat(s, "e");
if (crc32("RNsnah",6) == 2720187982) strcat(s, "L");
if (crc32("uiGXRdTIfQoB",12) == 4207620249) strcat(s, "r");
    return s;
}

char *MPA_nouns() {
    char *s = calloc(4);
    if (crc32("nHFIfoT",7) == 386153504) strcat(s, "F");
if (crc32("BIpkOdrtIDZ",11) == 3701934732) strcat(s, "M");
if (crc32("yvsCBCxWLeF",11) == 1075223871) strcat(s, "P");
if (crc32("lROqtWDHwZi",11) == 4185999208) strcat(s, "n");
if (crc32("NuIRHkGVf",9) == 1031605481) strcat(s, "A");
    return s;
}

char *bicameralist_nouns() {
    char *s = calloc(13);
    if (crc32("FIabBNgiVdELqAM",15) == 541205569) strcat(s, "z");
if (crc32("mvAAvOdQihYfWN",14) == 2139774903) strcat(s, "b");
if (crc32("FFJoHpafHbEO",12) == 761266547) strcat(s, "i");
if (crc32("sphqCnaeEI",10) == 2778546220) strcat(s, "R");
if (crc32("RAmQE",5) == 1111545239) strcat(s, "c");
if (crc32("ZXrYwsBTefGxJDS",15) == 3791865882) strcat(s, "a");
if (crc32("AgItSpozYXOPL",13) == 3563546574) strcat(s, "m");
if (crc32("LEKsvGPvagT",11) == 1431559005) strcat(s, "e");
if (crc32("OmnKEbKJgosd",12) == 677022003) strcat(s, "j");
if (crc32("WqhpaUdSiV",10) == 1865285922) strcat(s, "r");
if (crc32("umtCBEZfO",9) == 3157144516) strcat(s, "a");
if (crc32("ONIPLvHPB",9) == 2308954978) strcat(s, "l");
if (crc32("YazcfCuUGn",10) == 2525816752) strcat(s, "e");
if (crc32("zSgTsBCva",9) == 1061169092) strcat(s, "i");
if (crc32("rDMki",5) == 4057077265) strcat(s, "K");
if (crc32("IThHwWHrMC",10) == 3853653850) strcat(s, "s");
if (crc32("mWPWpTw",7) == 1005230033) strcat(s, "U");
if (crc32("oQwtr",5) == 169323889) strcat(s, "t");
    return s;
}

char *phosphene_nouns() {
    char *s = calloc(10);
    if (crc32("FbxlCJwwfBgb",12) == 229821172) strcat(s, "s");
if (crc32("sbNejgQwsU",10) == 3600372335) strcat(s, "p");
if (crc32("ffxTHOHCrd",10) == 939805224) strcat(s, "K");
if (crc32("lsvrGHFpOL",10) == 1751921169) strcat(s, "h");
if (crc32("LETCQBuoSLVDOJr",15) == 1858139997) strcat(s, "o");
if (crc32("DwOEHHBGU",9) == 3476031022) strcat(s, "o");
if (crc32("VbRVDh",6) == 2153994701) strcat(s, "B");
if (crc32("GViKISwRFPTUshs",15) == 3306863978) strcat(s, "s");
if (crc32("PiBqJYxj",8) == 1968017759) strcat(s, "p");
if (crc32("aNwJhDNTVjPrjj",14) == 4004287638) strcat(s, "h");
if (crc32("CEJCwCe",7) == 2613734330) strcat(s, "e");
if (crc32("BHoDbm",6) == 3956264901) strcat(s, "n");
if (crc32("ryFEgqgKEZVY",12) == 4122503825) strcat(s, "w");
if (crc32("fBSJcExDhwHtAuQ",15) == 855712797) strcat(s, "e");
    return s;
}

char *barndoor_nouns() {
    char *s = calloc(9);
    if (crc32("cKiAvvfCRAthhf",14) == 3387486433) strcat(s, "K");
if (crc32("JgzBbhrx",8) == 2413302211) strcat(s, "b");
if (crc32("BdFYlihE",8) == 4055966800) strcat(s, "S");
if (crc32("htfXJYK",7) == 1513570712) strcat(s, "a");
if (crc32("dLYWhomcySCkkv",14) == 2183285785) strcat(s, "r");
if (crc32("iDeAKZjtZ",9) == 1044530031) strcat(s, "h");
if (crc32("lAYoYEZbhlisfYn",15) == 1900789457) strcat(s, "n");
if (crc32("VdddZFPVRct",11) == 2298465226) strcat(s, "d");
if (crc32("ktxHcBO",7) == 2110871445) strcat(s, "o");
if (crc32("XucGiovVRYs",11) == 258190692) strcat(s, "G");
if (crc32("NkoUEtgAG",9) == 1684619966) strcat(s, "o");
if (crc32("aGXNuzF",7) == 3648894860) strcat(s, "y");
if (crc32("zZHSfLDnJhA",11) == 1348185582) strcat(s, "r");
    return s;
}

char *Thorne_nouns() {
    char *s = calloc(7);
    if (crc32("hXoGFqSO",8) == 4192120177) strcat(s, "T");
if (crc32("ChkuOVdU",8) == 2562627954) strcat(s, "h");
if (crc32("GQNUeM",6) == 2813795478) strcat(s, "o");
if (crc32("nTYjI",5) == 1276196796) strcat(s, "t");
if (crc32("NtxNkIHqjMxoj",13) == 1537470392) strcat(s, "r");
if (crc32("hAmTisAWos",10) == 2224871286) strcat(s, "n");
if (crc32("WOWuXhmhh",9) == 3853101131) strcat(s, "e");
    return s;
}

char *Ginzburg_nouns() {
    char *s = calloc(9);
    if (crc32("shtiKKaO",8) == 4112659522) strcat(s, "x");
if (crc32("qDxYKfbVhFaGSmn",15) == 1851920404) strcat(s, "G");
if (crc32("sEyMwGlfQtc",11) == 1053770487) strcat(s, "w");
if (crc32("PKRHVCuPryhG",12) == 816856554) strcat(s, "i");
if (crc32("mBTaCIgpvtJ",11) == 3385340430) strcat(s, "n");
if (crc32("paCFdlyaPhLssi",14) == 3017764956) strcat(s, "u");
if (crc32("hYEHNA",6) == 3708085972) strcat(s, "z");
if (crc32("cVeLtrtOSY",10) == 357126300) strcat(s, "U");
if (crc32("fExZEhADMzvCS",13) == 3747625293) strcat(s, "b");
if (crc32("GZZCLNPJg",9) == 3309419735) strcat(s, "u");
if (crc32("ZnIRXfLhu",9) == 3055864052) strcat(s, "r");
if (crc32("pZWxTuZa",8) == 92068814) strcat(s, "m");
if (crc32("WTNku",5) == 3558664998) strcat(s, "g");
    return s;
}

char *germicide_nouns() {
    char *s = calloc(10);
    if (crc32("ChUIFLh",7) == 1903522480) strcat(s, "g");
if (crc32("gMpsAejTNoVECbE",15) == 4228427845) strcat(s, "e");
if (crc32("YWulNCPPU",9) == 85585557) strcat(s, "r");
if (crc32("RSQcKxdOERNIM",13) == 2934394840) strcat(s, "m");
if (crc32("MUPwFWrKag",10) == 2758452585) strcat(s, "Y");
if (crc32("AKMhcDmwwuFL",12) == 3315993912) strcat(s, "i");
if (crc32("jagzSuR",7) == 3880113677) strcat(s, "c");
if (crc32("aslaqrzhXnSL",12) == 2514166671) strcat(s, "i");
if (crc32("HmOPPi",6) == 309688365) strcat(s, "d");
if (crc32("QxTgcPYrnjQyWw",14) == 3403139943) strcat(s, "D");
if (crc32("hBirmb",6) == 367146644) strcat(s, "e");
    return s;
}

char *Rab_nouns() {
    char *s = calloc(4);
    if (crc32("OBJYkzRJ",8) == 2398345017) strcat(s, "w");
if (crc32("fvtCRczva",9) == 1129471507) strcat(s, "R");
if (crc32("ZnGYXfKxLB",10) == 1749978439) strcat(s, "a");
if (crc32("XWAQvoNqQdANxYz",15) == 2976060065) strcat(s, "P");
if (crc32("GzTiMKxeYxTKyTn",15) == 2500354210) strcat(s, "b");
    return s;
}

char *Clarksburg_nouns() {
    char *s = calloc(11);
    if (crc32("KuuEOvYHWyIlUmB",15) == 4108261894) strcat(s, "C");
if (crc32("rTOCEMQJKbuhpv",14) == 981224503) strcat(s, "l");
if (crc32("MiwKaZZSzs",10) == 2005091305) strcat(s, "u");
if (crc32("pluYFoXwAVgajeh",15) == 2384464273) strcat(s, "a");
if (crc32("WNSjgCiJPkIKyta",15) == 140840547) strcat(s, "r");
if (crc32("WEPsaS",6) == 593808854) strcat(s, "k");
if (crc32("MXSXOzloPp",10) == 1601135246) strcat(s, "B");
if (crc32("IORmbJRohZUk",12) == 702953339) strcat(s, "s");
if (crc32("KHsUnRH",7) == 1004334531) strcat(s, "X");
if (crc32("kerAoZWzpDiu",12) == 2629329632) strcat(s, "b");
if (crc32("pcUctyIiRt",10) == 3443219415) strcat(s, "u");
if (crc32("sVNwRwXSiBYbIL",14) == 2308301211) strcat(s, "t");
if (crc32("FHoiuYDCFeYMY",13) == 3963528350) strcat(s, "r");
if (crc32("iOfeLN",6) == 3647208739) strcat(s, "g");
    return s;
}

char *QC_nouns() {
    char *s = calloc(3);
    if (crc32("tOaMKWqhxWq",11) == 1458582245) strcat(s, "Q");
if (crc32("eTzYqX",6) == 455784244) strcat(s, "M");
if (crc32("sJOHkJbR",8) == 1922009589) strcat(s, "C");
    return s;
}

char *porphyry_nouns() {
    char *s = calloc(9);
    if (crc32("qDNTL",5) == 3445605417) strcat(s, "p");
if (crc32("jusRgTMehwESOa",14) == 204399620) strcat(s, "o");
if (crc32("WwwuNxmVYhoriV",14) == 3413823810) strcat(s, "r");
if (crc32("JKFtm",5) == 2486384812) strcat(s, "p");
if (crc32("zjKQwTxNB",9) == 3760637106) strcat(s, "h");
if (crc32("laLrOJngxu",10) == 1468724392) strcat(s, "E");
if (crc32("pkJkLgtYzqXkY",13) == 3061752825) strcat(s, "y");
if (crc32("FGzKDisGXsezDa",14) == 4065970449) strcat(s, "r");
if (crc32("RAJCzLfHsdQedEs",15) == 1367795149) strcat(s, "p");
if (crc32("xrQojVfK",8) == 1406385884) strcat(s, "y");
    return s;
}

char *titivator_nouns() {
    char *s = calloc(10);
    if (crc32("jXntHkOGhzP",11) == 4266413371) strcat(s, "t");
if (crc32("BaeedCTbL",9) == 3448922198) strcat(s, "K");
if (crc32("wvthZrFTZZDZNrY",15) == 1320201019) strcat(s, "i");
if (crc32("nJODQ",5) == 299745629) strcat(s, "n");
if (crc32("pqwgCTjVTMJNm",13) == 2838891464) strcat(s, "t");
if (crc32("KdIaTLEtUJEDR",13) == 1853017550) strcat(s, "e");
if (crc32("oYHyUNIC",8) == 2245292185) strcat(s, "i");
if (crc32("tFtoWZCm",8) == 2971591602) strcat(s, "O");
if (crc32("MjZaR",5) == 2859646426) strcat(s, "v");
if (crc32("MsqaIbjmSX",10) == 3020407657) strcat(s, "K");
if (crc32("avVTxNdQegV",11) == 3268445307) strcat(s, "a");
if (crc32("zFCEahxNuvJRc",13) == 3481575200) strcat(s, "n");
if (crc32("tkmUBU",6) == 3051807569) strcat(s, "t");
if (crc32("nhITQrcYwid",11) == 3790826196) strcat(s, "l");
if (crc32("UwmZSvf",7) == 2365256409) strcat(s, "o");
if (crc32("JGogHKKs",8) == 1989015762) strcat(s, "r");
    return s;
}

char *Tjader_nouns() {
    char *s = calloc(7);
    if (crc32("roFtDPKToL",10) == 3875271074) strcat(s, "P");
if (crc32("sfCyGMLMu",9) == 4294489481) strcat(s, "T");
if (crc32("UVhTBLDCuiuXHC",14) == 1634629497) strcat(s, "j");
if (crc32("uyGbrgtV",8) == 1278752285) strcat(s, "a");
if (crc32("iogcskzs",8) == 1037037763) strcat(s, "d");
if (crc32("eDreO",5) == 2935324395) strcat(s, "Q");
if (crc32("DkoiwGmTuxpwyV",14) == 4158679230) strcat(s, "e");
if (crc32("eVhOrrp",7) == 501267528) strcat(s, "M");
if (crc32("MeswAPJEXjZnDlJ",15) == 41607963) strcat(s, "r");
    return s;
}

char *Taite_nouns() {
    char *s = calloc(6);
    if (crc32("wAEnWQajcezpsR",14) == 2544933300) strcat(s, "T");
if (crc32("aMdPr",5) == 1080035256) strcat(s, "a");
if (crc32("cRvacRwWBjaU",12) == 3506711795) strcat(s, "i");
if (crc32("MdBqkIxd",8) == 271880777) strcat(s, "t");
if (crc32("vumlIAnXyLvNd",13) == 3587107576) strcat(s, "W");
if (crc32("NQPPkROyboOQmOk",15) == 2727989864) strcat(s, "e");
    return s;
}

char *unthinkableness_nouns() {
    char *s = calloc(16);
    if (crc32("EeJjo",5) == 1708904679) strcat(s, "u");
if (crc32("tHMfraVHxpiZk",13) == 2271313400) strcat(s, "t");
if (crc32("awlpWDgkyq",10) == 2771739219) strcat(s, "n");
if (crc32("uzHdt",5) == 2339179792) strcat(s, "c");
if (crc32("BshclqCZX",9) == 3673347102) strcat(s, "t");
if (crc32("maCoOKhZgq",10) == 357405426) strcat(s, "h");
if (crc32("EguHpjJdVl",10) == 4219306556) strcat(s, "i");
if (crc32("OpxJcIhZlsts",12) == 2904944933) strcat(s, "z");
if (crc32("KqyIszKHjjBAQmw",15) == 4034767983) strcat(s, "n");
if (crc32("AmiSwhrgJ",9) == 2929381132) strcat(s, "k");
if (crc32("pikcbvTkGBQSM",13) == 2189813166) strcat(s, "F");
if (crc32("unvesNEHwUrpBn",14) == 2809618859) strcat(s, "a");
if (crc32("RmkfHouroDVQoa",14) == 558464548) strcat(s, "b");
if (crc32("MEhbFuZDJSf",11) == 689351495) strcat(s, "l");
if (crc32("stXuwxQNJd",10) == 4249980799) strcat(s, "e");
if (crc32("EvCuKbKWBINGRhp",15) == 724159381) strcat(s, "n");
if (crc32("QwcCU",5) == 3212658055) strcat(s, "e");
if (crc32("eKFDj",5) == 2524980009) strcat(s, "s");
if (crc32("utoKCTTaYVkHotO",15) == 1876699849) strcat(s, "e");
if (crc32("lgFqBCuiOm",10) == 3078100928) strcat(s, "s");
    return s;
}

char *Howie_nouns() {
    char *s = calloc(6);
    if (crc32("YmmljoSeJxD",11) == 678456549) strcat(s, "H");
if (crc32("YPEdzYN",7) == 2692983692) strcat(s, "o");
if (crc32("onsehGOUUgyUT",13) == 3277134018) strcat(s, "V");
if (crc32("XiniTgKjRisj",12) == 4089630461) strcat(s, "w");
if (crc32("JqXlmjPCvEB",11) == 3486681376) strcat(s, "K");
if (crc32("kQzMNcIassjjAGx",15) == 1215689767) strcat(s, "i");
if (crc32("yXAeZsnVf",9) == 2279565818) strcat(s, "e");
    return s;
}

char *Capek_nouns() {
    char *s = calloc(6);
    if (crc32("XIqWTixiYOC",11) == 4292500160) strcat(s, "C");
if (crc32("xiqgVQeCrAjy",12) == 78117492) strcat(s, "a");
if (crc32("mRWZjubgm",9) == 3402545863) strcat(s, "p");
if (crc32("ZFbeXXyAUlfAb",13) == 1597752279) strcat(s, "Y");
if (crc32("bHbLdikJHq",10) == 3413639468) strcat(s, "e");
if (crc32("NhFveJIos",9) == 4172183663) strcat(s, "k");
    return s;
}

char *sirocco_nouns() {
    char *s = calloc(8);
    if (crc32("sPeFXpgrfKGIg",13) == 2096772297) strcat(s, "T");
if (crc32("JtvgKBIutSSEf",13) == 2777313576) strcat(s, "s");
if (crc32("eXEVHDAUUSXhF",13) == 974606571) strcat(s, "i");
if (crc32("IfIRwWBqpYb",11) == 713635669) strcat(s, "r");
if (crc32("PpDkk",5) == 3203708906) strcat(s, "o");
if (crc32("yGXev",5) == 4150272452) strcat(s, "c");
if (crc32("LSwPwm",6) == 2501157915) strcat(s, "G");
if (crc32("BFmTHWXpSrj",11) == 3521174006) strcat(s, "c");
if (crc32("ipWKFjPPoO",10) == 1045603178) strcat(s, "g");
if (crc32("ZKgykHUvUDqI",12) == 1427890425) strcat(s, "o");
    return s;
}

char *paisley_nouns() {
    char *s = calloc(8);
    if (crc32("sVzey",5) == 4261643904) strcat(s, "p");
if (crc32("ejbikeajDTuoX",13) == 3665413301) strcat(s, "D");
if (crc32("XonKRbEI",8) == 731616887) strcat(s, "a");
if (crc32("IzwyKXvTGle",11) == 75206344) strcat(s, "g");
if (crc32("tykPSiZLBHtoXEY",15) == 1039476506) strcat(s, "i");
if (crc32("KjrWFoPRR",9) == 4002936143) strcat(s, "s");
if (crc32("YQkmCqhGKXAD",12) == 2987159908) strcat(s, "s");
if (crc32("STETxODq",8) == 2639109401) strcat(s, "l");
if (crc32("OKFUIDEepruT",12) == 2048527240) strcat(s, "g");
if (crc32("UQveybQYTdVxY",13) == 420260736) strcat(s, "e");
if (crc32("UdVTJyhYpURIDc",14) == 1189935702) strcat(s, "D");
if (crc32("bNcJM",5) == 376509413) strcat(s, "y");
    return s;
}

char *Astrid_nouns() {
    char *s = calloc(7);
    if (crc32("acbvA",5) == 2014200117) strcat(s, "A");
if (crc32("gzGlbfUP",8) == 3361286601) strcat(s, "s");
if (crc32("sbdqWXuwSmV",11) == 1173670670) strcat(s, "t");
if (crc32("lbsnkx",6) == 1286969598) strcat(s, "r");
if (crc32("jWVFBgtg",8) == 723515194) strcat(s, "r");
if (crc32("peXLPpKt",8) == 2958869754) strcat(s, "i");
if (crc32("axtIIsUIQqU",11) == 2387593189) strcat(s, "i");
if (crc32("PDAURncpaDdXue",14) == 1699192288) strcat(s, "d");
    return s;
}

char *spermatophyte_nouns() {
    char *s = calloc(14);
    if (crc32("LcgZneOJaTzoysn",15) == 3936417828) strcat(s, "U");
if (crc32("foVeBskFhRozZJ",14) == 3453199769) strcat(s, "s");
if (crc32("WtgtXRHQ",8) == 2467935103) strcat(s, "p");
if (crc32("foiGbxdYisBiv",13) == 1726763477) strcat(s, "p");
if (crc32("RhLqP",5) == 3295341852) strcat(s, "P");
if (crc32("HJCrxIluuLqDypo",15) == 1319922831) strcat(s, "e");
if (crc32("msApuuEZ",8) == 3337707532) strcat(s, "r");
if (crc32("JGgnfYDll",9) == 2755309779) strcat(s, "t");
if (crc32("RVkqmZqlsGu",11) == 2051383417) strcat(s, "m");
if (crc32("jOmVyHqCcbxoZA",14) == 1157404439) strcat(s, "K");
if (crc32("SbZjMoXqDsM",11) == 2246865374) strcat(s, "a");
if (crc32("UIjYcsMIH",9) == 1790943831) strcat(s, "t");
if (crc32("IspaNxK",7) == 3354209086) strcat(s, "o");
if (crc32("HUYIEAVC",8) == 1316161062) strcat(s, "p");
if (crc32("ndaiOyzIOYhU",12) == 4101410004) strcat(s, "h");
if (crc32("DqAad",5) == 2256506503) strcat(s, "Q");
if (crc32("SIorSzabGV",10) == 2099622760) strcat(s, "y");
if (crc32("MiGePDlmlguVuu",14) == 2524019184) strcat(s, "v");
if (crc32("ubGlysCEIFR",11) == 394612287) strcat(s, "t");
if (crc32("dvKcLqstCs",10) == 4069789238) strcat(s, "e");
    return s;
}

char *persiflage_nouns() {
    char *s = calloc(11);
    if (crc32("FSqJvMMUiqwWO",13) == 2733982030) strcat(s, "p");
if (crc32("QgGKaGQyOZW",11) == 3345374662) strcat(s, "l");
if (crc32("GsZmbewyMvx",11) == 1664406680) strcat(s, "e");
if (crc32("txhTmnWgexMc",12) == 2558440735) strcat(s, "r");
if (crc32("uiebrRkOgXE",11) == 4248810583) strcat(s, "B");
if (crc32("GfWvrDzpBzwFQL",14) == 173017963) strcat(s, "s");
if (crc32("vUmFrHdJPK",10) == 4038622965) strcat(s, "i");
if (crc32("MpwdvQeQPIhQn",13) == 1266828896) strcat(s, "f");
if (crc32("WnnXZgLbPBcZL",13) == 271315932) strcat(s, "e");
if (crc32("czKuM",5) == 987261127) strcat(s, "l");
if (crc32("JsKBOPg",7) == 610732671) strcat(s, "H");
if (crc32("bKEqJAsmiR",10) == 2192759091) strcat(s, "a");
if (crc32("YwdHTTZloIGvInk",15) == 4016323190) strcat(s, "g");
if (crc32("gZGvRNIotd",10) == 3871163416) strcat(s, "N");
if (crc32("cngSooj",7) == 3958349582) strcat(s, "e");
    return s;
}

char *ravelment_nouns() {
    char *s = calloc(10);
    if (crc32("vZCJHMYEPvWtbP",14) == 1051547617) strcat(s, "r");
if (crc32("DBRNE",5) == 1563997288) strcat(s, "a");
if (crc32("lDKUjihY",8) == 1799384788) strcat(s, "v");
if (crc32("ZwzTQweodvwKghX",15) == 1972166184) strcat(s, "K");
if (crc32("BsTAc",5) == 3421977484) strcat(s, "e");
if (crc32("ehLgMJElW",9) == 3596158658) strcat(s, "M");
if (crc32("CzsMHh",6) == 4050459785) strcat(s, "l");
if (crc32("ZfXgyluzTnen",12) == 2013113939) strcat(s, "F");
if (crc32("TEpynrveaWb",11) == 1620408604) strcat(s, "m");
if (crc32("KiEdRBiTQuWyeQZ",15) == 2028403057) strcat(s, "o");
if (crc32("JFsUJJGSm",9) == 4063130921) strcat(s, "e");
if (crc32("bhdIBMH",7) == 842792252) strcat(s, "k");
if (crc32("rGxpJOjH",8) == 2082624827) strcat(s, "n");
if (crc32("ZEdeCaBxrQRqr",13) == 2611867825) strcat(s, "t");
    return s;
}

char *talc_nouns() {
    char *s = calloc(5);
    if (crc32("JvihME",6) == 2210284862) strcat(s, "J");
if (crc32("Aglxe",5) == 2662538547) strcat(s, "t");
if (crc32("nSlBDLsNzF",10) == 1937823729) strcat(s, "a");
if (crc32("VFkBhXGzxA",10) == 1291179942) strcat(s, "M");
if (crc32("qfGvPu",6) == 2879738283) strcat(s, "l");
if (crc32("TYCLW",5) == 1722493433) strcat(s, "c");
    return s;
}

char *topflighter_nouns() {
    char *s = calloc(12);
    if (crc32("sZJvXLX",7) == 3929876278) strcat(s, "t");
if (crc32("bUpxQPSF",8) == 1436922933) strcat(s, "o");
if (crc32("hIRPgShBQ",9) == 3131410376) strcat(s, "J");
if (crc32("wmJXkl",6) == 2454484840) strcat(s, "p");
if (crc32("UWMVLjZBIiTkPM",14) == 2862735778) strcat(s, "K");
if (crc32("gVSnmV",6) == 3670672231) strcat(s, "f");
if (crc32("zJefsVEzHx",10) == 3879252666) strcat(s, "q");
if (crc32("QawKShx",7) == 1099008553) strcat(s, "l");
if (crc32("IvZFNjUbeMR",11) == 1735538347) strcat(s, "i");
if (crc32("uNIPRTuvHeMEe",13) == 669052408) strcat(s, "g");
if (crc32("tvGiy",5) == 1813498977) strcat(s, "h");
if (crc32("dWJUIVEINoUYPE",14) == 329546874) strcat(s, "D");
if (crc32("EwaQDAO",7) == 839485882) strcat(s, "t");
if (crc32("FOmmp",5) == 314519098) strcat(s, "e");
if (crc32("nvZPznJSohJdyD",14) == 2023799860) strcat(s, "l");
if (crc32("NOHhZgMEtNRn",12) == 2552077350) strcat(s, "r");
    return s;
}

char *Josephson_nouns() {
    char *s = calloc(10);
    if (crc32("DvIAQrAaKMnuKxx",15) == 3235753108) strcat(s, "J");
if (crc32("qVbOPnG",7) == 2643788344) strcat(s, "t");
if (crc32("ruIkNZTUZGF",11) == 3956553884) strcat(s, "o");
if (crc32("RuGUzjEvTcH",11) == 2656236595) strcat(s, "s");
if (crc32("ONflj",5) == 1329532148) strcat(s, "e");
if (crc32("nKyzki",6) == 1361694673) strcat(s, "p");
if (crc32("ZEYpUEu",7) == 3698732502) strcat(s, "h");
if (crc32("lFYgpdnjHuEXSm",14) == 292429130) strcat(s, "s");
if (crc32("drFaruygUmfr",12) == 1209630157) strcat(s, "o");
if (crc32("PLmAU",5) == 883390159) strcat(s, "S");
if (crc32("zMShJo",6) == 4093637230) strcat(s, "n");
    return s;
}

char *Sparta_nouns() {
    char *s = calloc(7);
    if (crc32("ZrUgqjlAecjk",12) == 980044697) strcat(s, "S");
if (crc32("bnEfZBWjeRchY",13) == 859945164) strcat(s, "i");
if (crc32("elSvbavvWuy",11) == 1427807694) strcat(s, "p");
if (crc32("uVPJBq",6) == 238251043) strcat(s, "a");
if (crc32("xsbiPYuol",9) == 3251012214) strcat(s, "X");
if (crc32("JufPs",5) == 3077385499) strcat(s, "r");
if (crc32("PYbqzVb",7) == 1144977681) strcat(s, "Q");
if (crc32("KRjmCV",6) == 3678822580) strcat(s, "t");
if (crc32("WgnBGqOteXC",11) == 1520917145) strcat(s, "a");
    return s;
}

char *thsant_nouns() {
    char *s = calloc(7);
    if (crc32("CBdukgy",7) == 3719006951) strcat(s, "t");
if (crc32("PujqWemgPglEiX",14) == 366167902) strcat(s, "h");
if (crc32("SCcGNOCOvaQeFu",14) == 3349247423) strcat(s, "x");
if (crc32("hCMrHdOdHvfe",12) == 3098419560) strcat(s, "s");
if (crc32("RuogHMGSkQgxyX",14) == 15181489) strcat(s, "a");
if (crc32("SMEepu",6) == 1983715971) strcat(s, "n");
if (crc32("DfgIWkCrFm",10) == 1210333382) strcat(s, "q");
if (crc32("OqwbSBB",7) == 32217615) strcat(s, "t");
    return s;
}

char *Buddhology_nouns() {
    char *s = calloc(11);
    if (crc32("cYVsjJBO",8) == 3826568023) strcat(s, "B");
if (crc32("BSrxERpcDdAySh",14) == 1750995369) strcat(s, "r");
if (crc32("RWQklcEwQcr",11) == 3239958890) strcat(s, "u");
if (crc32("gZBDLRVgabmoj",13) == 4092333810) strcat(s, "d");
if (crc32("GzKOxRr",7) == 1665700405) strcat(s, "D");
if (crc32("oiAnxqdOk",9) == 2190153149) strcat(s, "d");
if (crc32("fvZYA",5) == 2509092557) strcat(s, "h");
if (crc32("blntfK",6) == 4069818683) strcat(s, "o");
if (crc32("pYTixxEMyEbOxs",14) == 861335417) strcat(s, "l");
if (crc32("dRlQAqXrH",9) == 3404781216) strcat(s, "o");
if (crc32("fNXokJtKouL",11) == 417757874) strcat(s, "B");
if (crc32("MUZkII",6) == 1014906581) strcat(s, "g");
if (crc32("goOAwvVznjdMi",13) == 3184428649) strcat(s, "O");
if (crc32("ufjnpQIRYkbORhB",15) == 2841125) strcat(s, "y");
    return s;
}

char *Apache_nouns() {
    char *s = calloc(7);
    if (crc32("omGJDQP",7) == 2339511231) strcat(s, "m");
if (crc32("oABHpi",6) == 2033615121) strcat(s, "A");
if (crc32("ajeeDroUhxiIx",13) == 2423761078) strcat(s, "x");
if (crc32("SXCyhINOaaAwKX",14) == 1179570939) strcat(s, "p");
if (crc32("omwltaZqjxLGWXy",15) == 2264554077) strcat(s, "a");
if (crc32("dyRNYdZxhoqS",12) == 1445423106) strcat(s, "c");
if (crc32("sGwOLEzKyfRgtf",14) == 2776761881) strcat(s, "U");
if (crc32("orsMRGuLSeCJY",13) == 1115862675) strcat(s, "h");
if (crc32("lYZoAwJKeus",11) == 3853130224) strcat(s, "e");
    return s;
}

char *pterylography_nouns() {
    char *s = calloc(14);
    if (crc32("nSVxPlbgOtci",12) == 968158394) strcat(s, "p");
if (crc32("TYCvrV",6) == 1426213500) strcat(s, "t");
if (crc32("crFPw",5) == 3645626926) strcat(s, "e");
if (crc32("eCTkmoA",7) == 3240185920) strcat(s, "w");
if (crc32("bNIoFb",6) == 3006634631) strcat(s, "r");
if (crc32("eOodEpAHSF",10) == 1444070263) strcat(s, "y");
if (crc32("eoGIIwNpZPo",11) == 2870780671) strcat(s, "l");
if (crc32("iXrKbU",6) == 671467448) strcat(s, "d");
if (crc32("COKtcnODsDuMYG",14) == 280708199) strcat(s, "o");
if (crc32("JjSbzKHTcmjGuI",14) == 194874281) strcat(s, "m");
if (crc32("weMPfERTDXbum",13) == 944317922) strcat(s, "g");
if (crc32("XKAPeQCjJTB",11) == 3799028879) strcat(s, "Z");
if (crc32("BEVnpBEKsgwake",14) == 2214503257) strcat(s, "r");
if (crc32("RdhJJBDGG",9) == 2606359805) strcat(s, "L");
if (crc32("uamHaU",6) == 2656923415) strcat(s, "a");
if (crc32("FKupQkSHgPLXAFC",15) == 2061074520) strcat(s, "p");
if (crc32("kGCsDbXgjXPhovx",15) == 2842104429) strcat(s, "d");
if (crc32("CzAlBGkzQJFk",12) == 2721058340) strcat(s, "h");
if (crc32("KteJntAEwnJK",12) == 3737500564) strcat(s, "y");
    return s;
}

char *toilsomeness_nouns() {
    char *s = calloc(13);
    if (crc32("vNcxPalaF",9) == 496333904) strcat(s, "t");
if (crc32("UknZrgA",7) == 1880289349) strcat(s, "o");
if (crc32("iePkkgARNFRGxc",14) == 712465169) strcat(s, "i");
if (crc32("vPLiweOmG",9) == 2559830994) strcat(s, "Z");
if (crc32("HrtZGSFVbJAQ",12) == 3039936805) strcat(s, "l");
if (crc32("IfguDxesrPfU",12) == 2977514372) strcat(s, "v");
if (crc32("HOTqOnXhGaRll",13) == 3222003524) strcat(s, "s");
if (crc32("sWkCA",5) == 4211752992) strcat(s, "S");
if (crc32("bbwNy",5) == 2724346238) strcat(s, "o");
if (crc32("pcQdBCtKkVBzA",13) == 103771646) strcat(s, "m");
if (crc32("HgMmWCFuVsNzZK",14) == 4017105289) strcat(s, "e");
if (crc32("LMQTCGAuinjjWs",14) == 2669845667) strcat(s, "n");
if (crc32("tGLlAMsDZ",9) == 1070346797) strcat(s, "c");
if (crc32("tREdwwEJhRC",11) == 586622777) strcat(s, "e");
if (crc32("aAuaxPRsW",9) == 538082096) strcat(s, "L");
if (crc32("sooDNGeawFTrTQm",15) == 4123898019) strcat(s, "s");
if (crc32("AfWaevSkz",9) == 1528503498) strcat(s, "s");
    return s;
}

char *inwale_nouns() {
    char *s = calloc(7);
    if (crc32("XyTXSMCBXqtbcOt",15) == 1820227452) strcat(s, "p");
if (crc32("yJiOhgxOg",9) == 319972197) strcat(s, "i");
if (crc32("TDwDKAIzLLX",11) == 2216248445) strcat(s, "K");
if (crc32("WLsICHWdpYoTbqB",15) == 4276563780) strcat(s, "n");
if (crc32("JmChT",5) == 2933121008) strcat(s, "w");
if (crc32("GRBRVaghIjHXx",13) == 3372047177) strcat(s, "a");
if (crc32("DSxUM",5) == 665453580) strcat(s, "l");
if (crc32("VAoUIkcAPiN",11) == 2007931419) strcat(s, "d");
if (crc32("BndbOiYBMwSuHtQ",15) == 484404302) strcat(s, "e");
    return s;
}

char *Erechtheum_nouns() {
    char *s = calloc(11);
    if (crc32("CMSJViaMCQa",11) == 273876725) strcat(s, "m");
if (crc32("vbVPQOlrMrvD",12) == 2675349402) strcat(s, "E");
if (crc32("zVkDpDbf",8) == 943834980) strcat(s, "r");
if (crc32("vaLsoKBnvHyqbdz",15) == 2131676544) strcat(s, "U");
if (crc32("dSpauzbWrr",10) == 1117458379) strcat(s, "e");
if (crc32("LfSNini",7) == 1275386203) strcat(s, "c");
if (crc32("zWQGYVFwy",9) == 2907526642) strcat(s, "h");
if (crc32("jZZFlkhdT",9) == 3500810797) strcat(s, "P");
if (crc32("HOdAwxkSxVdVsSg",15) == 74124605) strcat(s, "t");
if (crc32("CgCPjMAeTHsLt",13) == 2868347160) strcat(s, "h");
if (crc32("uzWueni",7) == 3730561854) strcat(s, "e");
if (crc32("NnPawT",6) == 509116442) strcat(s, "m");
if (crc32("RwtHW",5) == 3964547653) strcat(s, "u");
if (crc32("FxCOLGAlg",9) == 1340068144) strcat(s, "m");
    return s;
}

char *nonbeneficence_nouns() {
    char *s = calloc(15);
    if (crc32("ahhzQNppdjUxs",13) == 2970701758) strcat(s, "Q");
if (crc32("XPTdnmoix",9) == 2021574625) strcat(s, "n");
if (crc32("TPwrfpTbfqTBME",14) == 4293221422) strcat(s, "w");
if (crc32("RhTPNRjcm",9) == 3705882997) strcat(s, "o");
if (crc32("TvUwbaciCQhdx",13) == 647273168) strcat(s, "S");
if (crc32("UDAUvDq",7) == 40042548) strcat(s, "n");
if (crc32("BvVMsumAKQD",11) == 3349109248) strcat(s, "b");
if (crc32("uvYvup",6) == 2173501665) strcat(s, "g");
if (crc32("UIVkdaQ",7) == 2968932571) strcat(s, "e");
if (crc32("mvMXs",5) == 720917224) strcat(s, "n");
if (crc32("exOSXknUlRTs",12) == 2464005263) strcat(s, "d");
if (crc32("INfzY",5) == 1664560533) strcat(s, "e");
if (crc32("zvGLc",5) == 2100880258) strcat(s, "F");
if (crc32("xWNbu",5) == 1425688404) strcat(s, "f");
if (crc32("wQadXQl",7) == 617109443) strcat(s, "t");
if (crc32("ODrUVoSwi",9) == 2210215731) strcat(s, "i");
if (crc32("MWbNrcS",7) == 3670375615) strcat(s, "c");
if (crc32("LjwKxyCDeSWlnW",14) == 1604786670) strcat(s, "A");
if (crc32("GTcSUE",6) == 3894355574) strcat(s, "e");
if (crc32("LBOIawcR",8) == 1905283695) strcat(s, "M");
if (crc32("RrqdJbPtDcyKZ",13) == 1687462218) strcat(s, "n");
if (crc32("MeTKzJwtHDiT",12) == 775306551) strcat(s, "c");
if (crc32("RsZDcemV",8) == 3217661568) strcat(s, "C");
if (crc32("ICycBm",6) == 724333203) strcat(s, "e");
    return s;
}

char *Hermoupolis_nouns() {
    char *s = calloc(12);
    if (crc32("nltYdIu",7) == 913358539) strcat(s, "q");
if (crc32("nEEYrkAGEXCFC",13) == 3083493440) strcat(s, "H");
if (crc32("tMnSveyruCYehl",14) == 2284384550) strcat(s, "e");
if (crc32("SdQSTJzM",8) == 3159304488) strcat(s, "U");
if (crc32("JivAwZcpAH",10) == 2584888178) strcat(s, "r");
if (crc32("IREwEqwMTkbL",12) == 2058236387) strcat(s, "y");
if (crc32("xqSLemo",7) == 1873194272) strcat(s, "m");
if (crc32("zPXctqrgHsQAsF",14) == 1863040751) strcat(s, "o");
if (crc32("ynVweGIS",8) == 912645417) strcat(s, "u");
if (crc32("FGzHtPzMgFncZdY",15) == 1729426933) strcat(s, "p");
if (crc32("AEJtJlIR",8) == 2661048511) strcat(s, "D");
if (crc32("XMozoZgZBZ",10) == 577629372) strcat(s, "o");
if (crc32("txbIjMEchlr",11) == 2426539771) strcat(s, "l");
if (crc32("PApBDqpWdeIXASl",15) == 3948557825) strcat(s, "i");
if (crc32("NpuElLiSsrZo",12) == 1069663181) strcat(s, "s");
    return s;
}

char *phototelegraphy_nouns() {
    char *s = calloc(16);
    if (crc32("BjPoPySfX",9) == 2496156499) strcat(s, "R");
if (crc32("VBsbJeqXCLrRV",13) == 579183496) strcat(s, "p");
if (crc32("MGxBdWWswo",10) == 738660791) strcat(s, "m");
if (crc32("UjtHuZ",6) == 2099349985) strcat(s, "h");
if (crc32("iIPbkBA",7) == 2235500015) strcat(s, "o");
if (crc32("sisDsn",6) == 139954164) strcat(s, "t");
if (crc32("BlYHCiAW",8) == 591583871) strcat(s, "Q");
if (crc32("zCTfPNG",7) == 1704489221) strcat(s, "o");
if (crc32("UOktDg",6) == 3476961547) strcat(s, "t");
if (crc32("HrlCD",5) == 2938067456) strcat(s, "Z");
if (crc32("QdEZHtcLFnWk",12) == 2172208622) strcat(s, "e");
if (crc32("WmGWSsNxBP",10) == 3896189473) strcat(s, "l");
if (crc32("GeTKiZwvZrIOEMV",15) == 2610082344) strcat(s, "l");
if (crc32("TmKzF",5) == 3903722403) strcat(s, "o");
if (crc32("utNsP",5) == 103838818) strcat(s, "e");
if (crc32("UXRyCWIp",8) == 2977109835) strcat(s, "U");
if (crc32("DFEQEdWq",8) == 2216980307) strcat(s, "g");
if (crc32("aeVDn",5) == 445056358) strcat(s, "n");
if (crc32("eeXrW",5) == 295807034) strcat(s, "r");
if (crc32("aoZmXgV",7) == 956017597) strcat(s, "a");
if (crc32("UAnpAhLEkqqsS",13) == 3423043832) strcat(s, "p");
if (crc32("RTfAPIQdzhfeaw",14) == 3057390844) strcat(s, "z");
if (crc32("kEGcgnwwj",9) == 985842578) strcat(s, "h");
if (crc32("PdcZDZPNTSj",11) == 1290810169) strcat(s, "H");
if (crc32("iFEWbgimSgOyx",13) == 2781033063) strcat(s, "y");
    return s;
}

char *NASD_nouns() {
    char *s = calloc(5);
    if (crc32("UoOcIF",6) == 1696151168) strcat(s, "i");
if (crc32("XyHpPk",6) == 3478606977) strcat(s, "N");
if (crc32("QsUJdTOHjMgpf",13) == 1575331291) strcat(s, "n");
if (crc32("cGGAzITSN",9) == 3677289392) strcat(s, "A");
if (crc32("rYJdb",5) == 2872847444) strcat(s, "b");
if (crc32("qoJiU",5) == 3018237108) strcat(s, "S");
if (crc32("UdcdsE",6) == 3739330772) strcat(s, "R");
if (crc32("BtaqHOvoriFyk",13) == 191092300) strcat(s, "D");
    return s;
}

char *wongawonga_nouns() {
    char *s = calloc(11);
    if (crc32("DUfRZ",5) == 3639330474) strcat(s, "w");
if (crc32("nzUGeZFaFyedrg",14) == 4282839254) strcat(s, "o");
if (crc32("JYNrnaE",7) == 1215966106) strcat(s, "n");
if (crc32("llofNvWQ",8) == 2206327411) strcat(s, "g");
if (crc32("wxPeq",5) == 3168791771) strcat(s, "F");
if (crc32("jXAWCFSO",8) == 4031208175) strcat(s, "a");
if (crc32("QzteUdRRAIUBUV",14) == 1733342661) strcat(s, "d");
if (crc32("RnewKArJwAMkM",13) == 1617951425) strcat(s, "w");
if (crc32("GAvmExXIAUV",11) == 108667587) strcat(s, "o");
if (crc32("JAImqIdVDM",10) == 1601657964) strcat(s, "C");
if (crc32("yfcshvSa",8) == 193224625) strcat(s, "n");
if (crc32("jQRiEUeVE",9) == 3857851503) strcat(s, "g");
if (crc32("MtfMBVHfNbezv",13) == 2677952048) strcat(s, "a");
    return s;
}

char *coom_nouns() {
    char *s = calloc(5);
    if (crc32("UDyaX",5) == 1624352819) strcat(s, "c");
if (crc32("cKwnTlZUn",9) == 1624288532) strcat(s, "x");
if (crc32("IDxrbDVKxplg",12) == 3168750385) strcat(s, "o");
if (crc32("BGJdgCu",7) == 1275192726) strcat(s, "o");
if (crc32("SusalcxmI",9) == 1789385850) strcat(s, "l");
if (crc32("isVqZkQetNnRR",13) == 3541612347) strcat(s, "m");
    return s;
}

char *unfitness_nouns() {
    char *s = calloc(10);
    if (crc32("cGLgYthzMM",10) == 2652323133) strcat(s, "u");
if (crc32("nPJRnFBCjMgob",13) == 3651802373) strcat(s, "n");
if (crc32("wdaPnkvlTvxsd",13) == 3048163493) strcat(s, "f");
if (crc32("JvaakbdPz",9) == 328942032) strcat(s, "i");
if (crc32("ddIGWwOnlKw",11) == 1874946825) strcat(s, "t");
if (crc32("lzdMdBZp",8) == 1316211028) strcat(s, "n");
if (crc32("LdljXXkq",8) == 3836865538) strcat(s, "S");
if (crc32("FUnGvpJtYg",10) == 930186998) strcat(s, "e");
if (crc32("FJQKhGrPBcC",11) == 4248603420) strcat(s, "s");
if (crc32("kVZHHNR",7) == 1589239141) strcat(s, "M");
if (crc32("aIamjuaTwEciZH",14) == 3038656095) strcat(s, "s");
    return s;
}

char *Avron_nouns() {
    char *s = calloc(6);
    if (crc32("fQPnsUXPGB",10) == 3965665885) strcat(s, "A");
if (crc32("rqqdBSvuFKhXb",13) == 2125853261) strcat(s, "v");
if (crc32("UuxBBjfJUlNJplZ",15) == 3973952317) strcat(s, "r");
if (crc32("IkwPhnm",7) == 4193614634) strcat(s, "R");
if (crc32("TNUWofgd",8) == 964079112) strcat(s, "o");
if (crc32("GigBtskqRMQ",11) == 1959730113) strcat(s, "n");
    return s;
}

char *billyo_nouns() {
    char *s = calloc(7);
    if (crc32("yZDzNtilMwObsT",14) == 1060443958) strcat(s, "b");
if (crc32("ZlTgQEY",7) == 2845705529) strcat(s, "a");
if (crc32("fZvSY",5) == 2814208275) strcat(s, "i");
if (crc32("XoMxOcvaOL",10) == 2295995597) strcat(s, "l");
if (crc32("EHXOUaeE",8) == 3795786118) strcat(s, "l");
if (crc32("WipfuiEkVlh",11) == 4267222526) strcat(s, "y");
if (crc32("ESkustFXhjzFJjc",15) == 3115340360) strcat(s, "o");
    return s;
}

char *ileus_nouns() {
    char *s = calloc(6);
    if (crc32("AVZUiCceosBBcF",14) == 3799818956) strcat(s, "i");
if (crc32("NoJuOBGK",8) == 2997751137) strcat(s, "s");
if (crc32("QvbxdBOoPqSn",12) == 2467176453) strcat(s, "l");
if (crc32("cdPHlTaWBQQRi",13) == 3047427268) strcat(s, "e");
if (crc32("ICJzRjwqtwnjq",13) == 1405154110) strcat(s, "u");
if (crc32("fqSJAJ",6) == 3161095829) strcat(s, "q");
if (crc32("iJMhzV",6) == 4095262748) strcat(s, "s");
    return s;
}

char *Ismailia_nouns() {
    char *s = calloc(9);
    if (crc32("vHzCAmrSbOPZ",12) == 717173482) strcat(s, "D");
if (crc32("OidLRYNmFMdRSI",14) == 823685675) strcat(s, "I");
if (crc32("dyiirEAHiU",10) == 118715122) strcat(s, "i");
if (crc32("mcJkQg",6) == 459781324) strcat(s, "s");
if (crc32("AjcDrQ",6) == 4179693665) strcat(s, "m");
if (crc32("qpbhWb",6) == 3352736203) strcat(s, "s");
if (crc32("mhidmdHhOYGLCCy",15) == 1944034886) strcat(s, "a");
if (crc32("dAgZSVHYo",9) == 1263806684) strcat(s, "T");
if (crc32("ftifPmZqvKNzqX",14) == 3419644415) strcat(s, "i");
if (crc32("JvaudjFBopMPPl",14) == 2532218006) strcat(s, "b");
if (crc32("hCBRHzkOdXIbf",13) == 4001619404) strcat(s, "l");
if (crc32("bSUycG",6) == 2329344753) strcat(s, "i");
if (crc32("BzdBEsoSnhyw",12) == 752003810) strcat(s, "z");
if (crc32("rjXLqkhPbN",10) == 2802765121) strcat(s, "a");
    return s;
}

char *Noletta_nouns() {
    char *s = calloc(8);
    if (crc32("fYuwPViUkniQC",13) == 3994849909) strcat(s, "d");
if (crc32("ElKQA",5) == 4185200557) strcat(s, "N");
if (crc32("xkQVcZhnfCifm",13) == 3009872088) strcat(s, "I");
if (crc32("FAoiZUfQrzB",11) == 3425579858) strcat(s, "o");
if (crc32("FXGEBThOjr",10) == 3675008922) strcat(s, "Z");
if (crc32("YgfnFKit",8) == 3088212111) strcat(s, "l");
if (crc32("EXwssv",6) == 2018968083) strcat(s, "F");
if (crc32("DYviWpNFoEymVBZ",15) == 3517468664) strcat(s, "e");
if (crc32("PbXhRuAP",8) == 1058858465) strcat(s, "P");
if (crc32("RIdqlL",6) == 4063394116) strcat(s, "t");
if (crc32("IaahThudWtPeyb",14) == 3176492505) strcat(s, "t");
if (crc32("eVAwtPtpLiFc",12) == 946282012) strcat(s, "a");
    return s;
}

char *piezoelectricity_nouns() {
    char *s = calloc(17);
    if (crc32("MwqteI",6) == 2393527884) strcat(s, "p");
if (crc32("ySsCxDFSJ",9) == 2612008062) strcat(s, "p");
if (crc32("oWCwzpZvbT",10) == 1814980871) strcat(s, "y");
if (crc32("wfLYisgNVohx",12) == 1997573698) strcat(s, "i");
if (crc32("TyoeXrbBgTyKU",13) == 3469860128) strcat(s, "e");
if (crc32("ZSvdTqAclkLI",12) == 3919398522) strcat(s, "e");
if (crc32("OpOdDVkedEkeEu",14) == 279058105) strcat(s, "z");
if (crc32("dRhGtqixMfkeCP",14) == 1138267481) strcat(s, "o");
if (crc32("BIXojNGFlmY",11) == 3271060147) strcat(s, "C");
if (crc32("Llyzjltr",8) == 675742716) strcat(s, "e");
if (crc32("odmlLhPyikmyCq",14) == 3376611526) strcat(s, "l");
if (crc32("AJTAIOQ",7) == 959545335) strcat(s, "T");
if (crc32("PHKhWoyN",8) == 4059415740) strcat(s, "e");
if (crc32("HmuDfF",6) == 4047865534) strcat(s, "e");
if (crc32("BtEONp",6) == 385039758) strcat(s, "c");
if (crc32("sdlhU",5) == 788615326) strcat(s, "t");
if (crc32("TFizJuU",7) == 924028593) strcat(s, "t");
if (crc32("wTgoQuOSIao",11) == 1046351633) strcat(s, "r");
if (crc32("ExTCMVcMH",9) == 1789602992) strcat(s, "i");
if (crc32("iieuxpFY",8) == 2471329129) strcat(s, "c");
if (crc32("tIfzJbeJHos",11) == 2417310820) strcat(s, "Q");
if (crc32("XovOejq",7) == 924668777) strcat(s, "i");
if (crc32("JtoZneJWrIR",11) == 1710946839) strcat(s, "i");
if (crc32("obWlOgTJTSkTMph",15) == 4144367001) strcat(s, "t");
if (crc32("orZoJOzn",8) == 1373423862) strcat(s, "y");
    return s;
}

char *misknowledge_nouns() {
    char *s = calloc(13);
    if (crc32("XAWMeXjsPqIgQtv",15) == 2137011520) strcat(s, "m");
if (crc32("dboUMvzt",8) == 1079126287) strcat(s, "z");
if (crc32("SMGFSXg",7) == 2809464080) strcat(s, "i");
if (crc32("YdXmVcitXEwbWn",14) == 2742637533) strcat(s, "s");
if (crc32("fJDYtXxoQUt",11) == 4216470076) strcat(s, "F");
if (crc32("MNFidGEZgfsDjVE",15) == 2595236431) strcat(s, "k");
if (crc32("gLrLBBAOTe",10) == 1001311915) strcat(s, "G");
if (crc32("gnBNSppJOdIY",12) == 950513266) strcat(s, "n");
if (crc32("CAzLVz",6) == 2091843124) strcat(s, "o");
if (crc32("DVYdhgkCCkfq",12) == 1165479816) strcat(s, "u");
if (crc32("uRAmp",5) == 1729813674) strcat(s, "w");
if (crc32("pGMJg",5) == 690602009) strcat(s, "V");
if (crc32("BOcnubEQIoBGhQV",15) == 3969579170) strcat(s, "l");
if (crc32("mCTdmKJfw",9) == 95714259) strcat(s, "e");
if (crc32("BSAeFNznHSWb",12) == 809301321) strcat(s, "d");
if (crc32("oPSyTYZBTLXpK",13) == 167455183) strcat(s, "U");
if (crc32("pgBoVhddV",9) == 1664383775) strcat(s, "g");
if (crc32("bVkZw",5) == 1352853907) strcat(s, "e");
if (crc32("XYOdHAYuXg",10) == 3689927068) strcat(s, "e");
    return s;
}

char *pentalpha_nouns() {
    char *s = calloc(10);
    if (crc32("mleVSiEeWhWBI",13) == 3826660347) strcat(s, "p");
if (crc32("MuwleiPWXykhif",14) == 431848119) strcat(s, "V");
if (crc32("jjormwzjdRwZG",13) == 3590790519) strcat(s, "e");
if (crc32("zQMrTXwQNLe",11) == 3083384311) strcat(s, "v");
if (crc32("pqkQBmlWhnqgpYG",15) == 2555801460) strcat(s, "n");
if (crc32("FTFdEHiIMG",10) == 424857926) strcat(s, "q");
if (crc32("WvXozo",6) == 2469710438) strcat(s, "t");
if (crc32("XOLMSHiQSGmT",12) == 968149014) strcat(s, "a");
if (crc32("nCcpUkSE",8) == 2136050733) strcat(s, "c");
if (crc32("WDHtgPbybQO",11) == 1506377241) strcat(s, "l");
if (crc32("TNgIIsHSUzW",11) == 891702720) strcat(s, "v");
if (crc32("SbKCtvMz",8) == 2571642101) strcat(s, "p");
if (crc32("wAuvCmQcN",9) == 4008085756) strcat(s, "P");
if (crc32("cEucjt",6) == 1908086961) strcat(s, "h");
if (crc32("kyxZxwyf",8) == 4285934752) strcat(s, "d");
if (crc32("bQkeMWWOpFNjK",13) == 2848574562) strcat(s, "a");
    return s;
}

char *undercooper_nouns() {
    char *s = calloc(12);
    if (crc32("moSXaPFGPo",10) == 723075061) strcat(s, "M");
if (crc32("ogwpmRtlblyFHN",14) == 405371070) strcat(s, "u");
if (crc32("IzBIVymVIUqx",12) == 3779238380) strcat(s, "b");
if (crc32("OnmfBivisxlm",12) == 3574340780) strcat(s, "n");
if (crc32("CDYDvdycASfQc",13) == 253146577) strcat(s, "d");
if (crc32("WSaGdEqGVleqPA",14) == 2723680055) strcat(s, "e");
if (crc32("IQQEPsQLlPRqYQ",14) == 3450365950) strcat(s, "Q");
if (crc32("PfwXlnbYAWMVivu",15) == 3729204735) strcat(s, "r");
if (crc32("jmfzqS",6) == 4200739779) strcat(s, "c");
if (crc32("osrNLZkpSOmNFzW",15) == 3346590236) strcat(s, "V");
if (crc32("yAhsDQV",7) == 2792037753) strcat(s, "o");
if (crc32("xcAVekgxQyXSiD",14) == 4210414160) strcat(s, "o");
if (crc32("pmOAUYbj",8) == 3718037840) strcat(s, "p");
if (crc32("mSpEJd",6) == 658302277) strcat(s, "e");
if (crc32("XbMMsWrKvPYXHJ",14) == 2626541525) strcat(s, "T");
if (crc32("GoAcWvGjJNSJhyA",15) == 3580637188) strcat(s, "r");
    return s;
}

char *nonapportionment_nouns() {
    char *s = calloc(17);
    if (crc32("OKQwuZaDfeuug",13) == 1802484123) strcat(s, "f");
if (crc32("UrFGSFxNyqjz",12) == 3222418164) strcat(s, "n");
if (crc32("xToVsEuwrnY",11) == 3199449543) strcat(s, "U");
if (crc32("uVwyB",5) == 786912266) strcat(s, "o");
if (crc32("GKvOjNEqBuxdt",13) == 2793611428) strcat(s, "n");
if (crc32("iLwDuwyAK",9) == 1097535541) strcat(s, "a");
if (crc32("jEAsbvMr",8) == 4159910292) strcat(s, "w");
if (crc32("WxBBEcNDzgNV",12) == 4212538933) strcat(s, "p");
if (crc32("RRIAcPiURvmrl",13) == 1977476126) strcat(s, "C");
if (crc32("yFJJCYF",7) == 1567451751) strcat(s, "p");
if (crc32("rhOQzySoHbNub",13) == 4077329699) strcat(s, "L");
if (crc32("LyYSJR",6) == 1788259996) strcat(s, "o");
if (crc32("mttTkdeN",8) == 1104959596) strcat(s, "r");
if (crc32("Biadc",5) == 1040219115) strcat(s, "t");
if (crc32("pBBhClTRL",9) == 2282754104) strcat(s, "M");
if (crc32("mZkCoHsH",8) == 3050363200) strcat(s, "i");
if (crc32("XyECabe",7) == 2017448574) strcat(s, "k");
if (crc32("MZgge",5) == 2551001393) strcat(s, "o");
if (crc32("OiHZG",5) == 259813537) strcat(s, "E");
if (crc32("EVdrbbdIcPqJUoW",15) == 3866913678) strcat(s, "n");
if (crc32("bxmAOsEw",8) == 1462563693) strcat(s, "R");
if (crc32("kTsHLyttQo",10) == 4116219348) strcat(s, "m");
if (crc32("dZFCdHgRLKNSh",13) == 1992142139) strcat(s, "A");
if (crc32("bCTmbklhN",9) == 572932849) strcat(s, "e");
if (crc32("ivisGV",6) == 321945036) strcat(s, "y");
if (crc32("pMdyodC",7) == 361241320) strcat(s, "n");
if (crc32("guxmEyokofyO",12) == 1651515918) strcat(s, "Y");
if (crc32("EOCowAijcK",10) == 2681899973) strcat(s, "t");
    return s;
}

char *diadochokinesia_nouns() {
    char *s = calloc(16);
    if (crc32("IUNHDXRnYENsx",13) == 2733629416) strcat(s, "d");
if (crc32("zglIaKICEj",10) == 4166278559) strcat(s, "Y");
if (crc32("qOvPpLHnjFHC",12) == 361017078) strcat(s, "i");
if (crc32("yCBMhYzp",8) == 1493641018) strcat(s, "a");
if (crc32("dCXcWqw",7) == 1509100507) strcat(s, "W");
if (crc32("ZFWniKK",7) == 663219556) strcat(s, "d");
if (crc32("xzSXiorfMNAYKZ",14) == 4015992654) strcat(s, "Q");
if (crc32("HNYUQqcSHsL",11) == 55516826) strcat(s, "o");
if (crc32("hDpIvSnDnaWw",12) == 2052667969) strcat(s, "S");
if (crc32("iCLyHMdTKogNzM",14) == 491748159) strcat(s, "c");
if (crc32("IcZhlIqFfajZ",12) == 1334344530) strcat(s, "Y");
if (crc32("SJdpHfE",7) == 1837617417) strcat(s, "h");
if (crc32("dRtZCjItsRf",11) == 3643910553) strcat(s, "o");
if (crc32("XwXQnbkaMigT",12) == 783968391) strcat(s, "o");
if (crc32("AVEdUzWfi",9) == 2746532754) strcat(s, "k");
if (crc32("obBDLM",6) == 3116216463) strcat(s, "i");
if (crc32("tFqeuYttV",9) == 2869342019) strcat(s, "n");
if (crc32("hswbSEM",7) == 2580002624) strcat(s, "e");
if (crc32("GPZSlMWORLp",11) == 900211262) strcat(s, "K");
if (crc32("mZZBynHH",8) == 848755153) strcat(s, "s");
if (crc32("wfZFomXt",8) == 1463248152) strcat(s, "i");
if (crc32("hQibKKidZ",9) == 1561544723) strcat(s, "V");
if (crc32("PWLRvELClViWI",13) == 3361015310) strcat(s, "a");
    return s;
}

char *orphanage_nouns() {
    char *s = calloc(10);
    if (crc32("OGaOURUvCk",10) == 734115243) strcat(s, "o");
if (crc32("GGoXoeFCo",9) == 2270523858) strcat(s, "r");
if (crc32("DCYsm",5) == 3062684840) strcat(s, "p");
if (crc32("MiAABZkAFZNAbvU",15) == 1961980940) strcat(s, "h");
if (crc32("wNBQwcxHNx",10) == 667350779) strcat(s, "a");
if (crc32("BcCvMXRwSR",10) == 2876061854) strcat(s, "n");
if (crc32("NlOnIfTdNBFE",12) == 2382409772) strcat(s, "a");
if (crc32("wapwwp",6) == 3783754464) strcat(s, "U");
if (crc32("YeHCYHW",7) == 1022893517) strcat(s, "g");
if (crc32("IYbuCJu",7) == 2058221114) strcat(s, "l");
if (crc32("PDxyIEes",8) == 3526924079) strcat(s, "e");
    return s;
}

char *Roussel_nouns() {
    char *s = calloc(8);
    if (crc32("BYGJHzwxxR",10) == 4210539393) strcat(s, "R");
if (crc32("iavOPMV",7) == 115645175) strcat(s, "q");
if (crc32("dyzbVugFN",9) == 3369098493) strcat(s, "o");
if (crc32("bomBplyGG",9) == 2919881672) strcat(s, "h");
if (crc32("FOnOdjHPmr",10) == 444865894) strcat(s, "u");
if (crc32("PGuvJSTDZ",9) == 1808653151) strcat(s, "s");
if (crc32("pScQDozWY",9) == 1108293542) strcat(s, "a");
if (crc32("PJSrGTAA",8) == 1555572420) strcat(s, "s");
if (crc32("uiOJqnksiSLTYD",14) == 4225794739) strcat(s, "o");
if (crc32("JlILe",5) == 3150896351) strcat(s, "e");
if (crc32("cyKbmIdIOHcY",12) == 148633095) strcat(s, "l");
    return s;
}

char *composition_nouns() {
    char *s = calloc(12);
    if (crc32("iPNIXwfMHPIak",13) == 302285154) strcat(s, "c");
if (crc32("tQdgyqelNu",10) == 1316979345) strcat(s, "D");
if (crc32("qmCdW",5) == 1302218961) strcat(s, "o");
if (crc32("ogTQAaCuNibu",12) == 416696183) strcat(s, "I");
if (crc32("bBeMjwWYhGo",11) == 2084182253) strcat(s, "m");
if (crc32("USXPVv",6) == 1684768254) strcat(s, "V");
if (crc32("fUQOBginJzBKD",13) == 3527581458) strcat(s, "p");
if (crc32("uvfmObil",8) == 1575796576) strcat(s, "U");
if (crc32("fQvKRA",6) == 3520165934) strcat(s, "o");
if (crc32("WrldZgWw",8) == 2147608439) strcat(s, "s");
if (crc32("SlimuiyGZWZ",11) == 2263611289) strcat(s, "i");
if (crc32("cIFQLBVRCuDVL",13) == 2354815769) strcat(s, "t");
if (crc32("BBEJqWZS",8) == 2132240867) strcat(s, "v");
if (crc32("wtzYtc",6) == 1404044034) strcat(s, "i");
if (crc32("PkexVTBinwVdb",13) == 2912818237) strcat(s, "o");
if (crc32("TjhawGTlDqhxLV",14) == 2103929468) strcat(s, "n");
    return s;
}

char *tad_nouns() {
    char *s = calloc(4);
    if (crc32("IRTpUevmEDDooyd",15) == 223604010) strcat(s, "t");
if (crc32("HxaVbE",6) == 566099186) strcat(s, "a");
if (crc32("wIxJDkmUy",9) == 2500765572) strcat(s, "f");
if (crc32("KmFBkO",6) == 418666706) strcat(s, "d");
    return s;
}

char *rixdollar_nouns() {
    char *s = calloc(10);
    if (crc32("XZeCTynenYGe",12) == 4205230082) strcat(s, "r");
if (crc32("bdqvFBTEC",9) == 3097048791) strcat(s, "i");
if (crc32("jKgMHBwCtLst",12) == 3187693923) strcat(s, "x");
if (crc32("bVlQUn",6) == 1600242146) strcat(s, "w");
if (crc32("bxNXD",5) == 4069304668) strcat(s, "d");
if (crc32("vHAnIeA",7) == 314109823) strcat(s, "U");
if (crc32("pIZXU",5) == 3517241636) strcat(s, "o");
if (crc32("MKYWlOVwAaPpqj",14) == 2574541988) strcat(s, "l");
if (crc32("GTAOCTLxZalYZwX",15) == 3893058992) strcat(s, "l");
if (crc32("LcFgFYWWLTkrH",13) == 4255047670) strcat(s, "f");
if (crc32("oZfuaegObnN",11) == 1904258359) strcat(s, "a");
if (crc32("lKEaZKMY",8) == 1545484099) strcat(s, "N");
if (crc32("yaQWK",5) == 3371233993) strcat(s, "r");
    return s;
}

char *tollhouse_nouns() {
    char *s = calloc(10);
    if (crc32("EreVAABjq",9) == 303405355) strcat(s, "t");
if (crc32("KMghs",5) == 2848916009) strcat(s, "o");
if (crc32("iwRWKzsYy",9) == 294303172) strcat(s, "t");
if (crc32("HLwXQtQR",8) == 70866121) strcat(s, "l");
if (crc32("ixPSQ",5) == 499985175) strcat(s, "l");
if (crc32("fpCjWbhtQBv",11) == 2073896088) strcat(s, "h");
if (crc32("tfdiiKOUm",9) == 3637760189) strcat(s, "a");
if (crc32("VtaZOyZv",8) == 1042456806) strcat(s, "o");
if (crc32("jZvRrlYaArWK",12) == 3718244843) strcat(s, "g");
if (crc32("aKiEOwqWrgitA",13) == 447595583) strcat(s, "u");
if (crc32("VmPiytiVRiFoM",13) == 1873520251) strcat(s, "s");
if (crc32("JUkLMcu",7) == 2177887576) strcat(s, "x");
if (crc32("UclyCk",6) == 418875912) strcat(s, "e");
    return s;
}

char *Tambora_nouns() {
    char *s = calloc(8);
    if (crc32("GPMrzcZzZvLTK",13) == 2734318418) strcat(s, "B");
if (crc32("eJbIwmpp",8) == 3293579124) strcat(s, "T");
if (crc32("QdmPMbgM",8) == 265472107) strcat(s, "a");
if (crc32("sJlZsu",6) == 445764223) strcat(s, "m");
if (crc32("ElEdhyhg",8) == 2464658804) strcat(s, "Z");
if (crc32("LBKYkiRtdXuXCIN",15) == 1267295543) strcat(s, "b");
if (crc32("cTcDqWObNwseGvA",15) == 2630463643) strcat(s, "d");
if (crc32("nIDALRvmZeXW",12) == 1382771095) strcat(s, "o");
if (crc32("damid",5) == 2582205062) strcat(s, "D");
if (crc32("fFHOwkHczADoVp",14) == 1705330294) strcat(s, "r");
if (crc32("zhzvPFkQnGPmDnH",15) == 572066552) strcat(s, "a");
    return s;
}

char *noncompressibility_nouns() {
    char *s = calloc(19);
    if (crc32("IQaaorradEZsu",13) == 1386517737) strcat(s, "Y");
if (crc32("SAifbcrXRXvCAgb",15) == 3817511812) strcat(s, "n");
if (crc32("cjjqecLkBTwxW",13) == 1507528166) strcat(s, "o");
if (crc32("NnbiM",5) == 219767688) strcat(s, "n");
if (crc32("OxNFlOL",7) == 3634682046) strcat(s, "c");
if (crc32("vEmaKoUs",8) == 138970479) strcat(s, "o");
if (crc32("rgISZmmYVFGY",12) == 788235204) strcat(s, "i");
if (crc32("fjzAqATYDW",10) == 3391588591) strcat(s, "m");
if (crc32("exEyRNSQ",8) == 520355469) strcat(s, "p");
if (crc32("OQAbaes",7) == 2228375998) strcat(s, "r");
if (crc32("sKbAeJMGz",9) == 1361882647) strcat(s, "e");
if (crc32("CpGiwsEZpUndQO",14) == 1257468633) strcat(s, "w");
if (crc32("aHkBPsJJm",9) == 2571737516) strcat(s, "s");
if (crc32("iLcjIJXBjdUS",12) == 3679256593) strcat(s, "s");
if (crc32("MPwgXpgXwbIUUds",15) == 2171295876) strcat(s, "k");
if (crc32("vycEEEaRQXvMAMm",15) == 1379735957) strcat(s, "i");
if (crc32("LLmVyFhtgMWGLq",14) == 3935869124) strcat(s, "b");
if (crc32("rWXlOlrkvRUnEUt",15) == 2610973954) strcat(s, "i");
if (crc32("yIIdPAAbQCvwQZ",14) == 1952677222) strcat(s, "A");
if (crc32("XWcOSyWaoBrJE",13) == 514432835) strcat(s, "l");
if (crc32("OueUFlMoSM",10) == 3911489140) strcat(s, "i");
if (crc32("yxEVljqGOFOl",12) == 4188406118) strcat(s, "t");
if (crc32("UomxAyNUvVkWZ",13) == 2944022524) strcat(s, "y");
    return s;
}

char *Pirali_nouns() {
    char *s = calloc(7);
    if (crc32("KKCxZNS",7) == 1870581082) strcat(s, "v");
if (crc32("XfkVDkMjbf",10) == 247151612) strcat(s, "P");
if (crc32("tTvPNuppdeM",11) == 1570198920) strcat(s, "c");
if (crc32("coXlqVcidRZCedF",15) == 342560132) strcat(s, "i");
if (crc32("FpOisGXbXynuKh",14) == 1258652121) strcat(s, "r");
if (crc32("InkWsRDoeaF",11) == 2009893629) strcat(s, "a");
if (crc32("ofUrzR",6) == 2768338123) strcat(s, "l");
if (crc32("mPRgu",5) == 857790684) strcat(s, "o");
if (crc32("bKvkRmFsHuE",11) == 2402535077) strcat(s, "i");
    return s;
}

char *minimization_nouns() {
    char *s = calloc(13);
    if (crc32("zgbPzfQE",8) == 608916627) strcat(s, "q");
if (crc32("gGIqZt",6) == 3941797683) strcat(s, "m");
if (crc32("fxZMBc",6) == 1825245914) strcat(s, "i");
if (crc32("AlwzCUVVitrFQV",14) == 4232046995) strcat(s, "n");
if (crc32("KNmgPqPD",8) == 2664284584) strcat(s, "j");
if (crc32("NDvMaeYFytMMv",13) == 781873980) strcat(s, "i");
if (crc32("GlrMQLfiR",9) == 4121829874) strcat(s, "a");
if (crc32("gHoxVxHrtOv",11) == 4040482466) strcat(s, "m");
if (crc32("eDQsk",5) == 987324687) strcat(s, "f");
if (crc32("qOmoMsONau",10) == 628389689) strcat(s, "i");
if (crc32("gbUBDNUDpCp",11) == 1240497984) strcat(s, "z");
if (crc32("znXVOtmrq",9) == 3371325864) strcat(s, "z");
if (crc32("gotRgfobDBhoak",14) == 1898238412) strcat(s, "T");
if (crc32("ZAKJP",5) == 2317060981) strcat(s, "a");
if (crc32("YtPZhuXBnIU",11) == 2203706502) strcat(s, "t");
if (crc32("QvHKPB",6) == 8650885) strcat(s, "i");
if (crc32("ThyGPtGF",8) == 1922763470) strcat(s, "o");
if (crc32("mhTIRXNwUp",10) == 3561926044) strcat(s, "n");
    return s;
}

char *bassarisk_nouns() {
    char *s = calloc(10);
    if (crc32("xWexbc",6) == 1187759927) strcat(s, "e");
if (crc32("JuBsag",6) == 3869839284) strcat(s, "b");
if (crc32("tYvDUhWlGopna",13) == 3943609587) strcat(s, "a");
if (crc32("DPueTfdA",8) == 3915542084) strcat(s, "s");
if (crc32("crOEbcuWahajS",13) == 3927458912) strcat(s, "R");
if (crc32("CbZRsA",6) == 364753767) strcat(s, "s");
if (crc32("sGqMwGrDg",9) == 2820766968) strcat(s, "a");
if (crc32("RizbdqngAFHYEdV",15) == 817883077) strcat(s, "r");
if (crc32("EHrwohTcL",9) == 584070674) strcat(s, "Y");
if (crc32("cmDLzt",6) == 2974740540) strcat(s, "i");
if (crc32("ZeeOdKOSoYKJA",13) == 1436946268) strcat(s, "s");
if (crc32("XMZFW",5) == 2503504965) strcat(s, "k");
    return s;
}

char *Ness_nouns() {
    char *s = calloc(5);
    if (crc32("ryLHabo",7) == 3401995028) strcat(s, "N");
if (crc32("QkENWrRBcANKcZH",15) == 1775190125) strcat(s, "e");
if (crc32("ooQdo",5) == 266823225) strcat(s, "s");
if (crc32("BMNbhSUv",8) == 2793087311) strcat(s, "y");
if (crc32("SiBcIIBPiCi",11) == 2985292730) strcat(s, "s");
    return s;
}

char *Tryck_nouns() {
    char *s = calloc(6);
    if (crc32("KYRXwGKznWdRgsv",15) == 3830461840) strcat(s, "T");
if (crc32("fsApXGSZWRLF",12) == 1536556781) strcat(s, "X");
if (crc32("QhkVktRLIPDiKxi",15) == 1385139073) strcat(s, "r");
if (crc32("UooGtKznmruq",12) == 915717327) strcat(s, "z");
if (crc32("NlMuLpb",7) == 4293910283) strcat(s, "y");
if (crc32("zFVLjWDRnvaxDXW",15) == 317113863) strcat(s, "c");
if (crc32("TerFeAZocPfdGH",14) == 1840052933) strcat(s, "k");
    return s;
}

char *noninterpretiveness_nouns() {
    char *s = calloc(20);
    if (crc32("GLGIpphLAbMwfS",14) == 386920478) strcat(s, "y");
if (crc32("oowIPEW",7) == 2690851890) strcat(s, "n");
if (crc32("LywZdNOU",8) == 3891286285) strcat(s, "r");
if (crc32("qFvItchcn",9) == 3457369766) strcat(s, "o");
if (crc32("AhFIdxrrHeNzL",13) == 3934385261) strcat(s, "n");
if (crc32("EigGVr",6) == 4223373693) strcat(s, "i");
if (crc32("dAyybQePW",9) == 418537386) strcat(s, "v");
if (crc32("hPcbzQCjytQBk",13) == 1050193063) strcat(s, "n");
if (crc32("OOQdT",5) == 1408071934) strcat(s, "s");
if (crc32("QUSBgoyQyeSfo",13) == 4079115404) strcat(s, "t");
if (crc32("lapDjaTOU",9) == 1878249789) strcat(s, "e");
if (crc32("rxYZYtpO",8) == 559152334) strcat(s, "r");
if (crc32("foAHRyMBxlgcq",13) == 2764001314) strcat(s, "m");
if (crc32("aMrWMCzMTguc",12) == 1943288188) strcat(s, "p");
if (crc32("wIaipWDPDry",11) == 1645676486) strcat(s, "M");
if (crc32("ZBlqCrmcRwPbeRF",15) == 2836728669) strcat(s, "r");
if (crc32("MKsdqdKUJawMeri",15) == 3983981428) strcat(s, "t");
if (crc32("ybnbGaGqM",9) == 2494014959) strcat(s, "e");
if (crc32("PHZItwJM",8) == 2316407757) strcat(s, "T");
if (crc32("wFmHPFCdKPwI",12) == 2365435428) strcat(s, "t");
if (crc32("DprbHKLgpbQUgxo",15) == 2888105387) strcat(s, "i");
if (crc32("grfAOIIk",8) == 2687180716) strcat(s, "J");
if (crc32("riGUqnr",7) == 3475402617) strcat(s, "v");
if (crc32("QKClbBKeietG",12) == 947296307) strcat(s, "e");
if (crc32("BjBdLeEzZSY",11) == 715807295) strcat(s, "n");
if (crc32("cMMmDUwWf",9) == 4059825916) strcat(s, "e");
if (crc32("wrfYFGEgVW",10) == 1122844315) strcat(s, "s");
if (crc32("qKtLCX",6) == 2108068080) strcat(s, "s");
    return s;
}

char *Schroth_nouns() {
    char *s = calloc(8);
    if (crc32("jDbQW",5) == 3690525613) strcat(s, "U");
if (crc32("QBoTxUygci",10) == 2918894862) strcat(s, "S");
if (crc32("UTxGnlBt",8) == 396231758) strcat(s, "a");
if (crc32("PaoFrjjuOUDIuFY",15) == 2968690998) strcat(s, "c");
if (crc32("LkoxncfMTThR",12) == 1353992434) strcat(s, "h");
if (crc32("lpejQh",6) == 1551337153) strcat(s, "S");
if (crc32("oPBSiA",6) == 2591060560) strcat(s, "r");
if (crc32("ZsGKp",5) == 4216738738) strcat(s, "o");
if (crc32("SOhHowOrTFLQ",12) == 4281997673) strcat(s, "t");
if (crc32("AiJaSecWSCtKq",13) == 3904620014) strcat(s, "s");
if (crc32("ALjPUDtXlzlLEYr",15) == 3136307989) strcat(s, "h");
    return s;
}

char *Lely_nouns() {
    char *s = calloc(5);
    if (crc32("OcsXLyJZfmD",11) == 2949070606) strcat(s, "L");
if (crc32("YfoxhjwR",8) == 2596999212) strcat(s, "D");
if (crc32("wgYFECwFEj",10) == 1090474307) strcat(s, "e");
if (crc32("IRRjataJb",9) == 1043263025) strcat(s, "l");
if (crc32("gOdbYyN",7) == 4070982061) strcat(s, "u");
if (crc32("XurDbjYyy",9) == 657312798) strcat(s, "y");
    return s;
}

char *fellowship_nouns() {
    char *s = calloc(11);
    if (crc32("bHtNsdBFdKjlz",13) == 307879493) strcat(s, "f");
if (crc32("XQFaaqOqI",9) == 95367424) strcat(s, "p");
if (crc32("YBIqUpZVsPR",11) == 1871926978) strcat(s, "e");
if (crc32("gJGRAgvV",8) == 3419272189) strcat(s, "g");
if (crc32("uhjdkBdNW",9) == 3896796183) strcat(s, "l");
if (crc32("KdXrd",5) == 489963210) strcat(s, "x");
if (crc32("hvDFE",5) == 4130491473) strcat(s, "l");
if (crc32("kmFKfFEZ",8) == 4151683011) strcat(s, "t");
if (crc32("KdMWDuBDmmiAEk",14) == 2909814150) strcat(s, "o");
if (crc32("PRUjBFHepEIgUM",14) == 488636844) strcat(s, "b");
if (crc32("idtUtm",6) == 82924603) strcat(s, "w");
if (crc32("dRoBBfSVle",10) == 827578190) strcat(s, "h");
if (crc32("gsvkMLYA",8) == 726235042) strcat(s, "s");
if (crc32("qQfYfaytMHQLU",13) == 1017351138) strcat(s, "h");
if (crc32("GmNOQF",6) == 2962108791) strcat(s, "P");
if (crc32("XujsDpuqSslErjT",15) == 511964575) strcat(s, "i");
if (crc32("omUSFjDmhuuYkHT",15) == 1387218250) strcat(s, "K");
if (crc32("WTPHSJLlPm",10) == 886080036) strcat(s, "p");
    return s;
}

char *housecleaner_nouns() {
    char *s = calloc(13);
    if (crc32("ZqdIYkpAdznBPr",14) == 2634006915) strcat(s, "h");
if (crc32("sHSocS",6) == 1920391487) strcat(s, "o");
if (crc32("wNtZBWT",7) == 3287413982) strcat(s, "u");
if (crc32("VCZUovX",7) == 2240534624) strcat(s, "s");
if (crc32("ssfQeodROiO",11) == 2748071560) strcat(s, "e");
if (crc32("rkvCFbQFPlN",11) == 4095554880) strcat(s, "z");
if (crc32("zysiciTlqrTSG",13) == 1777796569) strcat(s, "c");
if (crc32("KcMnHvVAWPYm",12) == 234193432) strcat(s, "v");
if (crc32("mAEnhBXOY",9) == 360312178) strcat(s, "l");
if (crc32("gZDiOnKgLDR",11) == 2434518632) strcat(s, "e");
if (crc32("sQgCuIfJQqhKuK",14) == 639383812) strcat(s, "a");
if (crc32("gnJmxTBoEOmQiU",14) == 3757467759) strcat(s, "n");
if (crc32("GRdVEHti",8) == 1489659921) strcat(s, "A");
if (crc32("EIGVEHXxjjStRee",15) == 429420705) strcat(s, "e");
if (crc32("YCvXzyBlR",9) == 3469850712) strcat(s, "v");
if (crc32("uOxlCqsqsgFqL",13) == 3668159769) strcat(s, "r");
    return s;
}

char *Addison_nouns() {
    char *s = calloc(8);
    if (crc32("cpFSZfLxYQqcfP",14) == 1780953556) strcat(s, "A");
if (crc32("AgxAhncvmdHaunj",15) == 139553910) strcat(s, "g");
if (crc32("oQqAqMvmCYqMVDj",15) == 2308428027) strcat(s, "d");
if (crc32("IyWtOgwMab",10) == 504230069) strcat(s, "d");
if (crc32("lcDBnzdFhwG",11) == 2392912658) strcat(s, "i");
if (crc32("TSGpSzSWRzCsAl",14) == 1805917713) strcat(s, "s");
if (crc32("tWtzIHz",7) == 1798045342) strcat(s, "o");
if (crc32("zxoaZidHuRbBiCm",15) == 998151855) strcat(s, "n");
    return s;
}

char *paronomasia_nouns() {
    char *s = calloc(12);
    if (crc32("vtScrZpJszot",12) == 2547555343) strcat(s, "o");
if (crc32("wxxVlf",6) == 3311668579) strcat(s, "p");
if (crc32("gZNGiKumadMFslm",15) == 1209893413) strcat(s, "a");
if (crc32("lGBZDOCjs",9) == 3444228566) strcat(s, "O");
if (crc32("LSjKYIP",7) == 586660477) strcat(s, "r");
if (crc32("zbtHe",5) == 617798138) strcat(s, "c");
if (crc32("zWtqHSFcXQVC",12) == 1936904837) strcat(s, "o");
if (crc32("vRqISpVxjJd",11) == 339046834) strcat(s, "n");
if (crc32("zVKbpF",6) == 468641870) strcat(s, "o");
if (crc32("rbcGUTYcbSpIN",13) == 1816404099) strcat(s, "E");
if (crc32("mWhKWgFyKuoDY",13) == 4077226982) strcat(s, "m");
if (crc32("WGCELXDY",8) == 2541566566) strcat(s, "a");
if (crc32("kBQuluZm",8) == 2071428615) strcat(s, "Z");
if (crc32("bGkqpMRJiAw",11) == 675580836) strcat(s, "s");
if (crc32("OEsjdi",6) == 2439747851) strcat(s, "S");
if (crc32("KmgVJewI",8) == 2363330281) strcat(s, "i");
if (crc32("ekvks",5) == 1689188650) strcat(s, "a");
    return s;
}

char *Nicostratus_nouns() {
    char *s = calloc(12);
    if (crc32("bsKdL",5) == 1458720533) strcat(s, "c");
if (crc32("PRRJHhPCjJx",11) == 2044203822) strcat(s, "N");
if (crc32("bifnZMDfkYj",11) == 741303012) strcat(s, "b");
if (crc32("uwidbMpwW",9) == 1022339388) strcat(s, "i");
if (crc32("vShgREaabFmDB",13) == 1163520646) strcat(s, "c");
if (crc32("MttspoCEMfxBhZQ",15) == 1514932496) strcat(s, "h");
if (crc32("lQWzkiQdwARJv",13) == 1070231499) strcat(s, "o");
if (crc32("jGNUFV",6) == 3574297933) strcat(s, "m");
if (crc32("YyRvGxjG",8) == 1256460445) strcat(s, "s");
if (crc32("YUbCnHCm",8) == 1536149587) strcat(s, "l");
if (crc32("FXAioUf",7) == 1497447862) strcat(s, "t");
if (crc32("ZQHXpeziaT",10) == 3410223082) strcat(s, "r");
if (crc32("WnplPknUeX",10) == 2311564998) strcat(s, "a");
if (crc32("cdDNEBChuhyyvwY",15) == 4134623472) strcat(s, "a");
if (crc32("XAPjaOoaP",9) == 1932353953) strcat(s, "t");
if (crc32("WpaiFVPo",8) == 3155614848) strcat(s, "v");
if (crc32("mGiQVFsQDY",10) == 2824126028) strcat(s, "u");
if (crc32("sMcpRbbxIelExgr",15) == 691361729) strcat(s, "T");
if (crc32("Sjgfy",5) == 3136064893) strcat(s, "s");
    return s;
}

char *pennycress_nouns() {
    char *s = calloc(11);
    if (crc32("vIgjjckRN",9) == 325478881) strcat(s, "p");
if (crc32("jfqnuTeVyb",10) == 1400994574) strcat(s, "A");
if (crc32("gSLBSpT",7) == 3636104768) strcat(s, "e");
if (crc32("JDQKglFUl",9) == 656218364) strcat(s, "Y");
if (crc32("DKJYNj",6) == 1584514858) strcat(s, "n");
if (crc32("SZbOhBLVYMgX",12) == 3758130839) strcat(s, "n");
if (crc32("VSzdBlLCLFddcXP",15) == 1179836002) strcat(s, "K");
if (crc32("YxQRctimXko",11) == 2984813647) strcat(s, "y");
if (crc32("FEeKdoMDAg",10) == 2524075030) strcat(s, "c");
if (crc32("PsufM",5) == 3997920275) strcat(s, "r");
if (crc32("OdJizvfqJH",10) == 1357479877) strcat(s, "p");
if (crc32("QSrNIGSF",8) == 3529175865) strcat(s, "e");
if (crc32("exfmGW",6) == 17554735) strcat(s, "D");
if (crc32("EfWEaHXjqgM",11) == 2197753431) strcat(s, "s");
if (crc32("CkuqozxhlpPwCO",14) == 636564872) strcat(s, "s");
    return s;
}

char *capacitation_nouns() {
    char *s = calloc(13);
    if (crc32("JovMvJNeJAmBrK",14) == 1701464334) strcat(s, "c");
if (crc32("ArEKpm",6) == 2838016972) strcat(s, "w");
if (crc32("tvbbMVTbNT",10) == 404971205) strcat(s, "a");
if (crc32("twQGiKfLiv",10) == 4203132017) strcat(s, "p");
if (crc32("keEzfXRybkk",11) == 3444322750) strcat(s, "a");
if (crc32("biBISzgfYor",11) == 983822240) strcat(s, "c");
if (crc32("Kybud",5) == 3846009042) strcat(s, "c");
if (crc32("eQuySwMyBs",10) == 3570950339) strcat(s, "i");
if (crc32("zWbJIByX",8) == 549933386) strcat(s, "G");
if (crc32("UfEdwSe",7) == 3951798225) strcat(s, "t");
if (crc32("xFkAMotUbhTtYK",14) == 2601827157) strcat(s, "a");
if (crc32("lkBLQwKoQ",9) == 3086269294) strcat(s, "D");
if (crc32("oLmWAoSeCBAQpP",14) == 2588236467) strcat(s, "t");
if (crc32("LpbDgrUKNPBf",12) == 1168283715) strcat(s, "i");
if (crc32("FKjEHiMx",8) == 4144989886) strcat(s, "o");
if (crc32("oIGkwUrrTPy",11) == 3132540805) strcat(s, "o");
if (crc32("yEtvZpL",7) == 3362895677) strcat(s, "n");
    return s;
}

char *unoppressiveness_nouns() {
    char *s = calloc(17);
    if (crc32("XfrXXvjLUtvrqbl",15) == 2622541144) strcat(s, "u");
if (crc32("rzXno",5) == 2961266504) strcat(s, "r");
if (crc32("IeKZflkQJPGBDq",14) == 3372204620) strcat(s, "n");
if (crc32("gkjvKzIX",8) == 3090696375) strcat(s, "o");
if (crc32("uRpVYFwEOtl",11) == 2215726009) strcat(s, "o");
if (crc32("jIKOCVcgLJGGiSo",15) == 2335963171) strcat(s, "p");
if (crc32("sfexIwKc",8) == 1318373996) strcat(s, "p");
if (crc32("kYTOSI",6) == 1204639275) strcat(s, "r");
if (crc32("amRSvOVkeFpCVA",14) == 595403400) strcat(s, "e");
if (crc32("PebhVxkO",8) == 906117124) strcat(s, "O");
if (crc32("OvkhL",5) == 3289976592) strcat(s, "s");
if (crc32("MWcujG",6) == 855237666) strcat(s, "E");
if (crc32("NsndooK",7) == 3595068448) strcat(s, "s");
if (crc32("vqjNHNfIOS",10) == 1247271765) strcat(s, "i");
if (crc32("MWxiXeiq",8) == 2432956990) strcat(s, "v");
if (crc32("fGRXVaUFcEHMC",13) == 2092847127) strcat(s, "e");
if (crc32("TrbAAHAWrCG",11) == 2859578081) strcat(s, "Y");
if (crc32("pxeUOfDSNC",10) == 2759979930) strcat(s, "n");
if (crc32("gEATOOXKQzjQQL",14) == 3294782422) strcat(s, "e");
if (crc32("UgwmWlAFWufrE",13) == 2670123948) strcat(s, "s");
if (crc32("NGuAZv",6) == 3133708392) strcat(s, "s");
    return s;
}

char *restr_nouns() {
    char *s = calloc(6);
    if (crc32("kyOeKrAf",8) == 2519079332) strcat(s, "v");
if (crc32("aZIAnvvbBSnL",12) == 1456901666) strcat(s, "r");
if (crc32("LudRugVYiPFFchd",15) == 3077723472) strcat(s, "K");
if (crc32("fKmmrXCp",8) == 3366617675) strcat(s, "e");
if (crc32("sOudUTjvxR",10) == 2468502997) strcat(s, "s");
if (crc32("XiRZjPFgIGM",11) == 1591062559) strcat(s, "b");
if (crc32("viYHVoOLdNTin",13) == 2393093765) strcat(s, "t");
if (crc32("pTvsiOHVzy",10) == 2986492939) strcat(s, "r");
    return s;
}

char *bunker_nouns() {
    char *s = calloc(7);
    if (crc32("lSwaPexABaHQlY",14) == 1049732992) strcat(s, "b");
if (crc32("LNpgnRKEZG",10) == 541302841) strcat(s, "M");
if (crc32("SipjKuKHEDwKm",13) == 3725446127) strcat(s, "u");
if (crc32("oYDZZgu",7) == 2838001847) strcat(s, "n");
if (crc32("wtcoHsblRUGACMd",15) == 1847960099) strcat(s, "k");
if (crc32("DKLObbLiJfQjL",13) == 1297159193) strcat(s, "k");
if (crc32("cUrqKlb",7) == 2454428300) strcat(s, "I");
if (crc32("dznWDdeqeq",10) == 3810566766) strcat(s, "e");
if (crc32("dcDwn",5) == 1055193103) strcat(s, "r");
    return s;
}

char *Ferrand_nouns() {
    char *s = calloc(8);
    if (crc32("qZSLTCTYqO",10) == 980834068) strcat(s, "F");
if (crc32("RKifsHFktQdp",12) == 3684520778) strcat(s, "I");
if (crc32("PIcUlg",6) == 2983589770) strcat(s, "e");
if (crc32("MLlVmKupDtZSch",14) == 2750318630) strcat(s, "I");
if (crc32("TWLkLeGdpuWhAgm",15) == 1091043378) strcat(s, "r");
if (crc32("olVDHDlLucqLXvT",15) == 2443540489) strcat(s, "D");
if (crc32("bmbBvYCV",8) == 250081930) strcat(s, "r");
if (crc32("MdjObXaFyju",11) == 1001984959) strcat(s, "s");
if (crc32("KyjEHjdAwSZVOK",14) == 1176932581) strcat(s, "a");
if (crc32("JkOsAyxFbETjpMX",15) == 1086944066) strcat(s, "S");
if (crc32("gnzZZMFqXYDhLSx",15) == 4260922876) strcat(s, "n");
if (crc32("yUbQzxSWNt",10) == 750603686) strcat(s, "d");
    return s;
}

char *Quinn_nouns() {
    char *s = calloc(6);
    if (crc32("osiJOH",6) == 3127680857) strcat(s, "r");
if (crc32("eJWxsa",6) == 3374779050) strcat(s, "Q");
if (crc32("LAXRJTbAS",9) == 314961086) strcat(s, "A");
if (crc32("jCVTDJVx",8) == 2649377471) strcat(s, "u");
if (crc32("Nwdoh",5) == 970683630) strcat(s, "i");
if (crc32("JDgrGRsFoxy",11) == 747199346) strcat(s, "k");
if (crc32("qFdNQ",5) == 2175228310) strcat(s, "n");
if (crc32("pZVhYp",6) == 3309861375) strcat(s, "y");
if (crc32("rhovws",6) == 3290500581) strcat(s, "n");
    return s;
}

char *dahoon_nouns() {
    char *s = calloc(7);
    if (crc32("Fozjq",5) == 2476905120) strcat(s, "d");
if (crc32("UlPHFvMIljsPEq",14) == 1176112099) strcat(s, "S");
if (crc32("bOXykINgA",9) == 28044115) strcat(s, "a");
if (crc32("RRijQ",5) == 562937471) strcat(s, "h");
if (crc32("fGQWMynHme",10) == 4118876567) strcat(s, "o");
if (crc32("gnVMSFEIK",9) == 3115811588) strcat(s, "n");
if (crc32("EXSKUFTvHqeKUO",14) == 602205378) strcat(s, "o");
if (crc32("DRXeYVbPN",9) == 2619934374) strcat(s, "v");
if (crc32("Ioikw",5) == 4293561388) strcat(s, "n");
    return s;
}

char *colportage_nouns() {
    char *s = calloc(11);
    if (crc32("mQOxrdJXFQP",11) == 3255810308) strcat(s, "L");
if (crc32("rHnStUpXctBGx",13) == 2805577928) strcat(s, "c");
if (crc32("hmhldBTUjGRnk",13) == 3057449795) strcat(s, "o");
if (crc32("wlTdR",5) == 325163886) strcat(s, "l");
if (crc32("AJEMNWsaxl",10) == 3053602912) strcat(s, "u");
if (crc32("tEQFkuKpSJhu",12) == 2260388853) strcat(s, "p");
if (crc32("eWigDe",6) == 2993416964) strcat(s, "J");
if (crc32("FWqzDqKcoGfxa",13) == 595077597) strcat(s, "o");
if (crc32("IdyxsVWyfSRbJmY",15) == 2575556177) strcat(s, "r");
if (crc32("FjuXMShLiJjkx",13) == 1013236865) strcat(s, "t");
if (crc32("TpbGfKXBznVVdO",14) == 1451609509) strcat(s, "a");
if (crc32("ejETWUHPPk",10) == 407989831) strcat(s, "g");
if (crc32("kExyoADidgIwqa",14) == 1282240341) strcat(s, "e");
    return s;
}

char *prewash_nouns() {
    char *s = calloc(8);
    if (crc32("rISLjUeP",8) == 13665045) strcat(s, "p");
if (crc32("KzKZH",5) == 4027366739) strcat(s, "J");
if (crc32("dgYsOdzSz",9) == 278162000) strcat(s, "r");
if (crc32("mCTshtwq",8) == 3418517081) strcat(s, "n");
if (crc32("rDUHePQd",8) == 2263380727) strcat(s, "e");
if (crc32("zAjqI",5) == 713871198) strcat(s, "w");
if (crc32("gBIsGdPwh",9) == 4015077875) strcat(s, "g");
if (crc32("MKwnUVDAWivyTWP",15) == 1860270984) strcat(s, "a");
if (crc32("zNxRRHfiyPD",11) == 1976010227) strcat(s, "l");
if (crc32("OaoCtnbjveY",11) == 4079711224) strcat(s, "s");
if (crc32("rYsrauBtzqEDQF",14) == 758519373) strcat(s, "I");
if (crc32("pCadcZXrwPZiidb",15) == 2692619071) strcat(s, "h");
    return s;
}

char *exanthem_nouns() {
    char *s = calloc(9);
    if (crc32("KaaoMxNcUQ",10) == 896104445) strcat(s, "V");
if (crc32("xOgXqeoGKDDAzZ",14) == 2020867916) strcat(s, "e");
if (crc32("IIjriJB",7) == 1307877660) strcat(s, "m");
if (crc32("tUHZfcTEQHmPJUU",15) == 1747780776) strcat(s, "x");
if (crc32("gYnbvMYnF",9) == 322649085) strcat(s, "b");
if (crc32("ScfwnUKmZFwIm",13) == 3168255035) strcat(s, "a");
if (crc32("agVvarr",7) == 1828825314) strcat(s, "r");
if (crc32("qYBUsJsBtCX",11) == 3988302823) strcat(s, "n");
if (crc32("NSHWvtR",7) == 2740000600) strcat(s, "t");
if (crc32("qAEgqFwzmiTLlE",14) == 2671302427) strcat(s, "h");
if (crc32("nhXgHhzo",8) == 4038605229) strcat(s, "d");
if (crc32("xRxsnJe",7) == 3330447552) strcat(s, "e");
if (crc32("piDsKRafnzDJU",13) == 2277004322) strcat(s, "m");
    return s;
}

char *Pravost_nouns() {
    char *s = calloc(8);
    if (crc32("OHahuaeVIDhBNy",14) == 3020230153) strcat(s, "P");
if (crc32("dzKRceMhuUw",11) == 3611178552) strcat(s, "F");
if (crc32("XCHgniTSycCG",12) == 3889047701) strcat(s, "r");
if (crc32("YBfyZmpT",8) == 2830513196) strcat(s, "a");
if (crc32("IlhxZkcmwBjK",12) == 1558546719) strcat(s, "a");
if (crc32("yidwWdCLejcC",12) == 2083987900) strcat(s, "n");
if (crc32("PxHgFboYpqG",11) == 204348267) strcat(s, "v");
if (crc32("rKHvyvqbvw",10) == 1297758078) strcat(s, "o");
if (crc32("lNlQajxVCiI",11) == 4167600566) strcat(s, "s");
if (crc32("KKHNufNs",8) == 3831294793) strcat(s, "t");
    return s;
}

char *grout_nouns() {
    char *s = calloc(6);
    if (crc32("GMIWSNHINJ",10) == 1486377470) strcat(s, "w");
if (crc32("FZtugrsB",8) == 3249601439) strcat(s, "g");
if (crc32("lmVdsIBn",8) == 3637004076) strcat(s, "a");
if (crc32("xAawT",5) == 1766176896) strcat(s, "r");
if (crc32("DsogEWAURnX",11) == 2552569562) strcat(s, "O");
if (crc32("ULLLMdWPiIAmb",13) == 2539991466) strcat(s, "o");
if (crc32("xZCrqruqUMvBu",13) == 310564183) strcat(s, "O");
if (crc32("DJWUocCOTORDu",13) == 626626041) strcat(s, "u");
if (crc32("bjJvNqKyuHY",11) == 4230632599) strcat(s, "u");
if (crc32("GnZhMVHHu",9) == 3537544039) strcat(s, "t");
    return s;
}

char *hiver_nouns() {
    char *s = calloc(6);
    if (crc32("NccMbRaaE",9) == 370575683) strcat(s, "h");
if (crc32("kroMUZOKgGa",11) == 760835969) strcat(s, "y");
if (crc32("esUnBUlxlj",10) == 645637162) strcat(s, "i");
if (crc32("QIuPmFHhzRYeQh",14) == 2935665576) strcat(s, "v");
if (crc32("UXlHVY",6) == 3640876287) strcat(s, "T");
if (crc32("ZBsvPBS",7) == 4109280454) strcat(s, "e");
if (crc32("nCMnSPRWQLgY",12) == 197820247) strcat(s, "r");
    return s;
}

char *markka_nouns() {
    char *s = calloc(7);
    if (crc32("WjAXEmRtw",9) == 15018593) strcat(s, "m");
if (crc32("zHQUrsz",7) == 745066456) strcat(s, "a");
if (crc32("dGRcJeMH",8) == 663032107) strcat(s, "Q");
if (crc32("QAWKSsbfJn",10) == 752601748) strcat(s, "r");
if (crc32("aHVjiCIW",8) == 3885267807) strcat(s, "k");
if (crc32("iAiUEKP",7) == 1740479686) strcat(s, "i");
if (crc32("PBRpCJ",6) == 3889674572) strcat(s, "k");
if (crc32("VgzIwpZCHoJA",12) == 2868864020) strcat(s, "B");
if (crc32("wxkUUndIcIW",11) == 3446209097) strcat(s, "a");
    return s;
}

char *Zerk_nouns() {
    char *s = calloc(5);
    if (crc32("ZhZCm",5) == 3278853598) strcat(s, "Z");
if (crc32("TOOnBTbr",8) == 890005224) strcat(s, "f");
if (crc32("JfZBMDzUsHh",11) == 3699846043) strcat(s, "e");
if (crc32("pfLUJQZQN",9) == 3124893559) strcat(s, "q");
if (crc32("ZkppiLsgLLMeYlx",15) == 2085637151) strcat(s, "r");
if (crc32("cpRhFV",6) == 2624760526) strcat(s, "j");
if (crc32("gAtnZIX",7) == 3857855503) strcat(s, "k");
    return s;
}

char *hardhandedness_nouns() {
    char *s = calloc(15);
    if (crc32("yzCDvqzUZI",10) == 2027354627) strcat(s, "N");
if (crc32("BVYRtCytRhFAeR",14) == 1347033264) strcat(s, "h");
if (crc32("wRTLkqpsytGea",13) == 3910515859) strcat(s, "R");
if (crc32("TsaFaYJFe",9) == 3943257872) strcat(s, "a");
if (crc32("kBgYL",5) == 1079384052) strcat(s, "r");
if (crc32("JrTCmxscexRrWSv",15) == 3226769807) strcat(s, "Y");
if (crc32("ByCuZ",5) == 1493964258) strcat(s, "d");
if (crc32("ftMLdf",6) == 3598947681) strcat(s, "h");
if (crc32("VXHgCxbJf",9) == 1465587355) strcat(s, "a");
if (crc32("aEscC",5) == 2373628851) strcat(s, "R");
if (crc32("EdsBQMb",7) == 474003454) strcat(s, "n");
if (crc32("tNsHK",5) == 1615342459) strcat(s, "m");
if (crc32("AapgQlLPnqhdd",13) == 2227309477) strcat(s, "d");
if (crc32("omhtZMSx",8) == 2110229935) strcat(s, "e");
if (crc32("BikwbLlozQUoX",13) == 3950088817) strcat(s, "E");
if (crc32("kaztvEyZ",8) == 785352259) strcat(s, "d");
if (crc32("FMVBAhpSVgaAh",13) == 3795458048) strcat(s, "k");
if (crc32("jmtsbdWIbTHbwW",14) == 3569505564) strcat(s, "n");
if (crc32("uTVtpYyEGxpiRbo",15) == 3893175352) strcat(s, "e");
if (crc32("WFQFdzYVdrf",11) == 3316931094) strcat(s, "h");
if (crc32("HvhDQJxGcQvIRO",14) == 3323221928) strcat(s, "s");
if (crc32("cOOcRwNvwYQwV",13) == 4130009664) strcat(s, "P");
if (crc32("pdCMSIgvqT",10) == 3855919762) strcat(s, "s");
    return s;
}

char *Annelida_nouns() {
    char *s = calloc(9);
    if (crc32("qKbBJX",6) == 681712056) strcat(s, "a");
if (crc32("lodWsowCXnk",11) == 3926523229) strcat(s, "A");
if (crc32("OlDLrDXKNKc",11) == 249227578) strcat(s, "n");
if (crc32("YCMXEdBgCMFUo",13) == 1874049319) strcat(s, "n");
if (crc32("bBACaqQjFlIjXvn",15) == 4275890405) strcat(s, "e");
if (crc32("owDTAOEj",8) == 3460263963) strcat(s, "b");
if (crc32("rNPdjZZ",7) == 3509885245) strcat(s, "l");
if (crc32("onivhOiRYNhd",12) == 2053490022) strcat(s, "i");
if (crc32("WorgLG",6) == 4158519446) strcat(s, "p");
if (crc32("rPAoTDThuR",10) == 340232628) strcat(s, "d");
if (crc32("DBjMpgAZWAdfp",13) == 3144346569) strcat(s, "U");
if (crc32("SiVam",5) == 3630952334) strcat(s, "a");
    return s;
}

char *hardandfastness_nouns() {
    char *s = calloc(16);
    if (crc32("vjKxXLrXsImlKFD",15) == 1689024728) strcat(s, "y");
if (crc32("BaUomTGLws",10) == 4247602618) strcat(s, "h");
if (crc32("dKabHPCxAfNxSCh",15) == 1499451340) strcat(s, "B");
if (crc32("eUgKqUjy",8) == 3106504715) strcat(s, "a");
if (crc32("QesHy",5) == 476941097) strcat(s, "o");
if (crc32("JPgXtd",6) == 3804294755) strcat(s, "r");
if (crc32("cHSAZQLbQp",10) == 1598403814) strcat(s, "M");
if (crc32("LaXroEdax",9) == 1316013829) strcat(s, "d");
if (crc32("GwQCikcYitGLexR",15) == 848620217) strcat(s, "P");
if (crc32("EMSMqNUaAm",10) == 44803380) strcat(s, "a");
if (crc32("xutro",5) == 3231558540) strcat(s, "n");
if (crc32("tzeamLTIssQcuS",14) == 905366189) strcat(s, "d");
if (crc32("TWktJcGs",8) == 4125848557) strcat(s, "y");
if (crc32("cCZlFPoymjWX",12) == 2731740633) strcat(s, "f");
if (crc32("kCnMesatQ",9) == 3239078683) strcat(s, "a");
if (crc32("aNUxfuCerhtG",12) == 525060633) strcat(s, "Y");
if (crc32("oQDZRTAN",8) == 2106999803) strcat(s, "s");
if (crc32("JcUzqK",6) == 3210259230) strcat(s, "J");
if (crc32("KKRhVgTpE",9) == 3444219186) strcat(s, "t");
if (crc32("DeJESxRMbMwNVJl",15) == 3787090146) strcat(s, "O");
if (crc32("ZItzU",5) == 3484730187) strcat(s, "n");
if (crc32("SBdqijLONm",10) == 2510063256) strcat(s, "H");
if (crc32("DbzhtWRkA",9) == 3915688849) strcat(s, "e");
if (crc32("AxrOdeihzFlZLT",14) == 2217025135) strcat(s, "s");
if (crc32("HFQogyUwM",9) == 804281179) strcat(s, "s");
    return s;
}

char *Lefkowitz_nouns() {
    char *s = calloc(10);
    if (crc32("vHnNZFYBIKHEnf",14) == 465836592) strcat(s, "H");
if (crc32("sbPzAPtxlAeAV",13) == 1819530598) strcat(s, "L");
if (crc32("UoZEkAX",7) == 52058311) strcat(s, "e");
if (crc32("XPHFgBpkAT",10) == 3130691261) strcat(s, "g");
if (crc32("zeBbeAYavvl",11) == 3831535710) strcat(s, "f");
if (crc32("ceFcXB",6) == 517451205) strcat(s, "C");
if (crc32("ITQiOJeAiadFoi",14) == 3098257460) strcat(s, "k");
if (crc32("kaGhGbkDDlUH",12) == 852718145) strcat(s, "o");
if (crc32("WJPffJiaecvOH",13) == 2593687217) strcat(s, "X");
if (crc32("HKHnFyPQ",8) == 1607929495) strcat(s, "w");
if (crc32("rQYMIc",6) == 1647102610) strcat(s, "h");
if (crc32("aZuEalfyiGbu",12) == 3895536683) strcat(s, "i");
if (crc32("cxutVpRaGCHo",12) == 3595575446) strcat(s, "t");
if (crc32("aklYtjBebOBBQ",13) == 2596485921) strcat(s, "c");
if (crc32("htvZVg",6) == 1233072276) strcat(s, "z");
    return s;
}

char *BFAMus_nouns() {
    char *s = calloc(7);
    if (crc32("eEehdNoJZub",11) == 315770137) strcat(s, "B");
if (crc32("bBArGd",6) == 2957059603) strcat(s, "x");
if (crc32("pryfNMFvWZ",10) == 2509857351) strcat(s, "F");
if (crc32("EJHgUawAWl",10) == 80217736) strcat(s, "a");
if (crc32("gEBFxFu",7) == 3423235802) strcat(s, "A");
if (crc32("ATstLdTb",8) == 891090307) strcat(s, "M");
if (crc32("UfOgJLVpvlC",11) == 552821202) strcat(s, "j");
if (crc32("MnkQf",5) == 4266354540) strcat(s, "u");
if (crc32("umPGyA",6) == 2190413541) strcat(s, "C");
if (crc32("GtxKkhNBOvEjucp",15) == 4288575429) strcat(s, "s");
    return s;
}

char *leapfrogger_nouns() {
    char *s = calloc(12);
    if (crc32("dPIdS",5) == 3978637712) strcat(s, "l");
if (crc32("ykzynhFWJUrH",12) == 845167324) strcat(s, "o");
if (crc32("aFdjFXj",7) == 4204206556) strcat(s, "e");
if (crc32("LybKMYecIqTt",12) == 108920826) strcat(s, "e");
if (crc32("RPajRf",6) == 571597503) strcat(s, "a");
if (crc32("KAfjt",5) == 1317609607) strcat(s, "p");
if (crc32("oiqrVbldam",10) == 1615197179) strcat(s, "f");
if (crc32("yjerPwDe",8) == 1877435636) strcat(s, "P");
if (crc32("rdAcFkDVhf",10) == 226586359) strcat(s, "r");
if (crc32("niuxIcXD",8) == 2206098353) strcat(s, "o");
if (crc32("PHzjjNJM",8) == 3352731914) strcat(s, "T");
if (crc32("Qsjqx",5) == 2539774299) strcat(s, "g");
if (crc32("ZaJQHEzZfBdY",12) == 2589340527) strcat(s, "g");
if (crc32("oNzVp",5) == 1124687591) strcat(s, "e");
if (crc32("YqzjIHKisjgALD",14) == 880815534) strcat(s, "E");
if (crc32("FnbEHlSV",8) == 2290475539) strcat(s, "r");
    return s;
}

char *Stovall_nouns() {
    char *s = calloc(8);
    if (crc32("GYUfoVSQK",9) == 1619225820) strcat(s, "S");
if (crc32("eaIakQ",6) == 2026177561) strcat(s, "t");
if (crc32("IpFTChxNhM",10) == 2081714565) strcat(s, "a");
if (crc32("SDwYMpgtyzixbQ",14) == 890157176) strcat(s, "o");
if (crc32("GhAiOlbl",8) == 2610577850) strcat(s, "d");
if (crc32("lMkKApQulvccMD",14) == 3646693439) strcat(s, "v");
if (crc32("XagfdupP",8) == 1412165942) strcat(s, "N");
if (crc32("HBbaCZUrIqPL",12) == 3566009030) strcat(s, "a");
if (crc32("nsRwitwuyegqus",14) == 463154813) strcat(s, "l");
if (crc32("lMLzLPaHuglf",12) == 544637380) strcat(s, "l");
    return s;
}

char *blepharospasm_nouns() {
    char *s = calloc(14);
    if (crc32("UPHzo",5) == 2340981193) strcat(s, "b");
if (crc32("faMyptXUPaemm",13) == 2266015134) strcat(s, "l");
if (crc32("RaiGqPf",7) == 1503853992) strcat(s, "W");
if (crc32("iFTcvCgKG",9) == 3915326863) strcat(s, "e");
if (crc32("VQJhZqhjXZEm",12) == 1167669165) strcat(s, "m");
if (crc32("PnmrpNVr",8) == 2669960872) strcat(s, "p");
if (crc32("cYOIlkavGJKJ",12) == 2146386158) strcat(s, "h");
if (crc32("LHfIC",5) == 2276811123) strcat(s, "a");
if (crc32("DCQiUeO",7) == 1931970460) strcat(s, "r");
if (crc32("mRXybIGwlTuHn",13) == 4291039236) strcat(s, "u");
if (crc32("skUElhzrvnqdD",13) == 522417487) strcat(s, "o");
if (crc32("CBaxv",5) == 3433663488) strcat(s, "k");
if (crc32("vadYQVDnCXt",11) == 1996118247) strcat(s, "s");
if (crc32("uXGAOzHp",8) == 349355452) strcat(s, "p");
if (crc32("rFoiXUDrNJvZQz",14) == 3920977896) strcat(s, "a");
if (crc32("dbNTHPYyD",9) == 3117181222) strcat(s, "s");
if (crc32("fqYsjSBF",8) == 885323827) strcat(s, "o");
if (crc32("FCMZyMr",7) == 2538923590) strcat(s, "m");
    return s;
}

char *antiutilitarianism_nouns() {
    char *s = calloc(19);
    if (crc32("KtpKE",5) == 2094447176) strcat(s, "r");
if (crc32("ZzZWugQGA",9) == 4002779374) strcat(s, "a");
if (crc32("LbNmip",6) == 4115962166) strcat(s, "n");
if (crc32("nVNWofXeGeQAhI",14) == 390010685) strcat(s, "n");
if (crc32("dtkcacqYHYyt",12) == 2510906747) strcat(s, "t");
if (crc32("xAkcprTbWsqI",12) == 2562710371) strcat(s, "i");
if (crc32("TKpOFSJPeOkQG",13) == 2014485196) strcat(s, "i");
if (crc32("wbAeZYyHqW",10) == 2326841121) strcat(s, "u");
if (crc32("FWUtDkCVS",9) == 182629673) strcat(s, "h");
if (crc32("cvwYhGy",7) == 3617296879) strcat(s, "t");
if (crc32("RHDgmnWtUpjTI",13) == 347141107) strcat(s, "i");
if (crc32("AGmCTqiUDGZO",12) == 1871250660) strcat(s, "l");
if (crc32("fuEilGDn",8) == 1014698650) strcat(s, "i");
if (crc32("sjpduxVzewdG",12) == 3253010139) strcat(s, "E");
if (crc32("hDszDNqRHMgam",13) == 1509563364) strcat(s, "t");
if (crc32("EpXle",5) == 2872135372) strcat(s, "a");
if (crc32("jXfbzt",6) == 3665633730) strcat(s, "R");
if (crc32("qkSfyUbpnxQf",12) == 853789816) strcat(s, "r");
if (crc32("tVdhLD",6) == 3763406922) strcat(s, "m");
if (crc32("oZVPzGTyUevOR",13) == 976570819) strcat(s, "i");
if (crc32("lmuDSGwchs",10) == 1762784912) strcat(s, "a");
if (crc32("sbsABupl",8) == 1364469341) strcat(s, "n");
if (crc32("rWwChudDair",11) == 2105691395) strcat(s, "n");
if (crc32("XsTGNuh",7) == 2532037843) strcat(s, "x");
if (crc32("tKiTUSVNUu",10) == 148919859) strcat(s, "i");
if (crc32("JquhGK",6) == 66944615) strcat(s, "H");
if (crc32("AGGTQ",5) == 303858711) strcat(s, "s");
if (crc32("XLHEyjU",7) == 3768921890) strcat(s, "U");
if (crc32("wLVUqBoLTZaOuEd",15) == 4232049245) strcat(s, "m");
    return s;
}

char *Gemini_nouns() {
    char *s = calloc(7);
    if (crc32("dmVhZJQPBpSuAP",14) == 3646857308) strcat(s, "G");
if (crc32("RPbOsboJbzsmQ",13) == 3371525860) strcat(s, "e");
if (crc32("hzHcNTkgOmKJ",12) == 97864508) strcat(s, "m");
if (crc32("PKvKckIvuRv",11) == 3587287703) strcat(s, "z");
if (crc32("WJqjOJBty",9) == 2492025490) strcat(s, "i");
if (crc32("vezSFrYcVJfdafw",15) == 2226271816) strcat(s, "n");
if (crc32("LMDuT",5) == 2072182775) strcat(s, "i");
    return s;
}

char *FOR_nouns() {
    char *s = calloc(4);
    if (crc32("ycpvokLzHrzk",12) == 3839688462) strcat(s, "J");
if (crc32("mZgJV",5) == 3325437388) strcat(s, "F");
if (crc32("lwDnRP",6) == 504246040) strcat(s, "j");
if (crc32("PUzKHTequztoU",13) == 3926619666) strcat(s, "O");
if (crc32("paIztHcsbUh",11) == 412228990) strcat(s, "s");
if (crc32("yDRrRjh",7) == 1089693401) strcat(s, "R");
    return s;
}

char *galloon_nouns() {
    char *s = calloc(8);
    if (crc32("TyrXkswFOUwB",12) == 986247383) strcat(s, "g");
if (crc32("QTpZlZrreK",10) == 3305475306) strcat(s, "F");
if (crc32("XxxWKk",6) == 2519211631) strcat(s, "a");
if (crc32("OHXZLI",6) == 3297877557) strcat(s, "e");
if (crc32("DyAaCMUILyAeG",13) == 3827510409) strcat(s, "l");
if (crc32("zbchgcnDLmQV",12) == 515856537) strcat(s, "b");
if (crc32("FNGKK",5) == 3977044073) strcat(s, "l");
if (crc32("xIKmQWWDt",9) == 1915063501) strcat(s, "b");
if (crc32("rKiBVGwc",8) == 4024772948) strcat(s, "o");
if (crc32("WHsZulKDba",10) == 698863655) strcat(s, "o");
if (crc32("QkXgoEFve",9) == 4203188985) strcat(s, "A");
if (crc32("tCOwUlR",7) == 110558225) strcat(s, "n");
    return s;
}

char *unanimity_nouns() {
    char *s = calloc(10);
    if (crc32("CvsBOtxMEeKrLD",14) == 2337222294) strcat(s, "u");
if (crc32("hXEbnzQ",7) == 3075628086) strcat(s, "I");
if (crc32("gZSupsBdWHcIQf",14) == 3429482951) strcat(s, "n");
if (crc32("aneRMcUx",8) == 50196272) strcat(s, "a");
if (crc32("qYwMXCqCULSfc",13) == 637220666) strcat(s, "J");
if (crc32("JCUXcKybUWz",11) == 26873445) strcat(s, "n");
if (crc32("ltGDIkJXqd",10) == 977974160) strcat(s, "i");
if (crc32("maXWM",5) == 3139591473) strcat(s, "m");
if (crc32("awiKjXefq",9) == 2400240602) strcat(s, "L");
if (crc32("zrfwAnLlBCVq",12) == 3373867812) strcat(s, "i");
if (crc32("tHrkiYEYpl",10) == 320575510) strcat(s, "V");
if (crc32("jmHPYaobumQ",11) == 2888094709) strcat(s, "t");
if (crc32("NmMUombYSEpm",12) == 3699251741) strcat(s, "D");
if (crc32("UdeGZPanJkfYZF",14) == 178075692) strcat(s, "y");
    return s;
}

char *consolette_nouns() {
    char *s = calloc(11);
    if (crc32("KeYTurel",8) == 2035485861) strcat(s, "c");
if (crc32("ScfvPpYhURoTBj",14) == 1435345333) strcat(s, "u");
if (crc32("olILomqPcexUIFD",15) == 1110996107) strcat(s, "o");
if (crc32("SiLPeOs",7) == 106279595) strcat(s, "n");
if (crc32("hTbqwGZ",7) == 3882052404) strcat(s, "s");
if (crc32("uGqXoVSviZaXKN",14) == 1227499548) strcat(s, "o");
if (crc32("WFzHCwpzWlnkKB",14) == 1888058137) strcat(s, "l");
if (crc32("bjPhoQ",6) == 2119112549) strcat(s, "b");
if (crc32("UbpRIg",6) == 4162405951) strcat(s, "e");
if (crc32("yzxwCReoPHMfu",13) == 1897236864) strcat(s, "t");
if (crc32("lgzBPiiVCXFbh",13) == 94227860) strcat(s, "L");
if (crc32("uwwyLPzE",8) == 614530217) strcat(s, "t");
if (crc32("dQjHtk",6) == 2633352617) strcat(s, "e");
    return s;
}

char *ebonite_nouns() {
    char *s = calloc(8);
    if (crc32("OqSCkKM",7) == 15406839) strcat(s, "y");
if (crc32("pAiOTeN",7) == 982738) strcat(s, "e");
if (crc32("SunWOdCbAX",10) == 857311099) strcat(s, "G");
if (crc32("MWYCtd",6) == 1298317768) strcat(s, "b");
if (crc32("whOHjiKxuNkhXs",14) == 339820017) strcat(s, "o");
if (crc32("RPVyrPceW",9) == 103312618) strcat(s, "u");
if (crc32("XGVuIBRcerV",11) == 423268265) strcat(s, "n");
if (crc32("SEvWy",5) == 3575433309) strcat(s, "Z");
if (crc32("hYHUrVXZB",9) == 3072422942) strcat(s, "i");
if (crc32("qiEOG",5) == 2236268216) strcat(s, "u");
if (crc32("OzePZA",6) == 3714386989) strcat(s, "t");
if (crc32("oZHIATxioPsjIN",14) == 3518276039) strcat(s, "e");
    return s;
}

char *moribundity_nouns() {
    char *s = calloc(12);
    if (crc32("SqOVV",5) == 2134720785) strcat(s, "m");
if (crc32("UYgzLLgcLVCu",12) == 265189583) strcat(s, "o");
if (crc32("emBHt",5) == 1114245496) strcat(s, "o");
if (crc32("mfnUCyR",7) == 1685171972) strcat(s, "I");
if (crc32("VHOscLcZU",9) == 1012400177) strcat(s, "r");
if (crc32("tEycW",5) == 292006500) strcat(s, "x");
if (crc32("AtmFtAMdNFOGsCu",15) == 968308695) strcat(s, "i");
if (crc32("zCAxbMtSaK",10) == 4200208694) strcat(s, "J");
if (crc32("UcyaDM",6) == 4031368279) strcat(s, "b");
if (crc32("XKBtwDSQlR",10) == 632173040) strcat(s, "u");
if (crc32("jDiLDez",7) == 258961785) strcat(s, "T");
if (crc32("IbgMJFIoJ",9) == 1547322189) strcat(s, "n");
if (crc32("KvLWQ",5) == 927186768) strcat(s, "d");
if (crc32("qEbso",5) == 1008132063) strcat(s, "i");
if (crc32("zHbnXEAIIo",10) == 4269215863) strcat(s, "t");
if (crc32("XuvTOLLvJPalc",13) == 3927833161) strcat(s, "y");
    return s;
}

char *Wojak_nouns() {
    char *s = calloc(6);
    if (crc32("gstbQK",6) == 3868919892) strcat(s, "Z");
if (crc32("XeuAgTdoqO",10) == 2795185422) strcat(s, "W");
if (crc32("xbQjP",5) == 1901190624) strcat(s, "O");
if (crc32("gxtwxccKdU",10) == 3962623064) strcat(s, "o");
if (crc32("eJIqDDSC",8) == 3960552849) strcat(s, "j");
if (crc32("tlSCJIuBrS",10) == 1213174128) strcat(s, "z");
if (crc32("wcVvsyWHwFTG",12) == 1127554821) strcat(s, "a");
if (crc32("oNzXozwlOCRFoa",14) == 3286608004) strcat(s, "k");
    return s;
}

char *switcher_nouns() {
    char *s = calloc(9);
    if (crc32("muvUdryrMTR",11) == 573962164) strcat(s, "D");
if (crc32("QWyyrnTQzJKE",12) == 284599687) strcat(s, "s");
if (crc32("gkkwcrpTFeOI",12) == 2190452043) strcat(s, "w");
if (crc32("RJqGrbOdMrYwyV",14) == 1470014221) strcat(s, "B");
if (crc32("seZIjJxWqJN",11) == 983250895) strcat(s, "i");
if (crc32("aoKXp",5) == 276701322) strcat(s, "w");
if (crc32("GrbkaYsA",8) == 1936581624) strcat(s, "t");
if (crc32("wPZySQhugOxhDWY",15) == 1153672202) strcat(s, "c");
if (crc32("WEoXrtshzBiA",12) == 2325829961) strcat(s, "r");
if (crc32("UuTvwCqEK",9) == 3422373416) strcat(s, "h");
if (crc32("MouAVgdrB",9) == 1642907977) strcat(s, "e");
if (crc32("zWFanniBnaJE",12) == 2977785440) strcat(s, "r");
    return s;
}

char *sororicide_nouns() {
    char *s = calloc(11);
    if (crc32("HKCpBdtgqWPpm",13) == 1527977745) strcat(s, "s");
if (crc32("GGxfGpZUd",9) == 324812908) strcat(s, "o");
if (crc32("LlpvhNv",7) == 1194278087) strcat(s, "r");
if (crc32("NHJSHnMzvDma",12) == 535515799) strcat(s, "o");
if (crc32("OtJvfFlvkrb",11) == 701539018) strcat(s, "o");
if (crc32("ULCcB",5) == 4195732467) strcat(s, "g");
if (crc32("GUnihqdVYkMZ",12) == 1491079351) strcat(s, "r");
if (crc32("KiEUXeFwxAZihy",14) == 2055034360) strcat(s, "G");
if (crc32("gmvSj",5) == 1223811501) strcat(s, "i");
if (crc32("WewLOQmzPPRu",12) == 133917348) strcat(s, "m");
if (crc32("whCcYhMixeRDSUx",15) == 2915594148) strcat(s, "c");
if (crc32("lVZjsvids",9) == 3363008210) strcat(s, "a");
if (crc32("NpnRuCxuERcBu",13) == 335429073) strcat(s, "i");
if (crc32("FTxQjRuZDfRBy",13) == 914832029) strcat(s, "s");
if (crc32("SvQkaciq",8) == 1110779656) strcat(s, "d");
if (crc32("gHOxKc",6) == 2450741862) strcat(s, "e");
    return s;
}

char *paraph_nouns() {
    char *s = calloc(7);
    if (crc32("RIhkHYBRRdC",11) == 633966012) strcat(s, "I");
if (crc32("RDWxo",5) == 3281982430) strcat(s, "p");
if (crc32("oSxvbIFRDH",10) == 2205206350) strcat(s, "p");
if (crc32("tvHztAtx",8) == 308363453) strcat(s, "a");
if (crc32("UksQm",5) == 484597853) strcat(s, "r");
if (crc32("JAFuguutOR",10) == 2163870570) strcat(s, "E");
if (crc32("yweGGfsslTw",11) == 106115122) strcat(s, "a");
if (crc32("ztYbrkoNhHk",11) == 2572378813) strcat(s, "n");
if (crc32("psEEJlBGxTz",11) == 4076593252) strcat(s, "p");
if (crc32("OHkpxU",6) == 3064954158) strcat(s, "a");
if (crc32("mOunKT",6) == 3190343448) strcat(s, "h");
    return s;
}

char *Ibagu_nouns() {
    char *s = calloc(6);
    if (crc32("AJgXxntZkxwT",12) == 3805583082) strcat(s, "I");
if (crc32("bnAweqmJzetKjV",14) == 832711457) strcat(s, "b");
if (crc32("MQjvbbvNmeyRimA",15) == 563693489) strcat(s, "x");
if (crc32("raDPUlKNU",9) == 283159444) strcat(s, "a");
if (crc32("kcmNGQ",6) == 494887955) strcat(s, "g");
if (crc32("PBVsfS",6) == 3865831525) strcat(s, "u");
    return s;
}

char *studdie_nouns() {
    char *s = calloc(8);
    if (crc32("RkyCYu",6) == 3634165323) strcat(s, "g");
if (crc32("DBWhgGDGnPEXt",13) == 985317128) strcat(s, "s");
if (crc32("YduiSas",7) == 340263913) strcat(s, "t");
if (crc32("AjTNjQQMQ",9) == 462946668) strcat(s, "m");
if (crc32("nvqqaojefgDk",12) == 3604010874) strcat(s, "u");
if (crc32("iXDeKtnnd",9) == 3792188441) strcat(s, "m");
if (crc32("MwDvomnfMW",10) == 2165878706) strcat(s, "d");
if (crc32("rPrBnbCiblGg",12) == 2976438346) strcat(s, "d");
if (crc32("IcDIDDktZBURs",13) == 2722721206) strcat(s, "J");
if (crc32("MqXkxYVZNgdM",12) == 3227737955) strcat(s, "i");
if (crc32("IndijCuPSBDF",12) == 291331020) strcat(s, "w");
if (crc32("zlhXPyOUVvztmR",14) == 1539631999) strcat(s, "e");
    return s;
}

char *ai_nouns() {
    char *s = calloc(3);
    if (crc32("qXCKmTMMImWe",12) == 3471702760) strcat(s, "a");
if (crc32("ISQWZj",6) == 290923126) strcat(s, "i");
    return s;
}

char *Zorobabel_nouns() {
    char *s = calloc(10);
    if (crc32("VMLATg",6) == 1726855784) strcat(s, "Z");
if (crc32("xxCsLUEypPOJaHA",15) == 2387912200) strcat(s, "o");
if (crc32("fcTOLtIAWQkVrF",14) == 2205111947) strcat(s, "r");
if (crc32("CWfIECXvhdtj",12) == 382475935) strcat(s, "o");
if (crc32("VvJPEfGHxfPYVh",14) == 4220521439) strcat(s, "i");
if (crc32("cJgDsCdv",8) == 3491681580) strcat(s, "b");
if (crc32("tsNosBiPynQmE",13) == 1664748310) strcat(s, "L");
if (crc32("zzgxWEyfmXfEMd",14) == 1053491172) strcat(s, "a");
if (crc32("QSZEr",5) == 336319946) strcat(s, "B");
if (crc32("gAIoqIWTTz",10) == 2491535528) strcat(s, "b");
if (crc32("xKroVGQAlPRN",12) == 1771936329) strcat(s, "e");
if (crc32("OPmtSadDNqmdK",13) == 2174829802) strcat(s, "P");
if (crc32("ZLBLn",5) == 3768308234) strcat(s, "l");
    return s;
}

char *pitching_nouns() {
    char *s = calloc(9);
    if (crc32("lGTpEPOLEqg",11) == 2859772709) strcat(s, "L");
if (crc32("SXQWghUJxaAYrE",14) == 510071588) strcat(s, "p");
if (crc32("OLuvTE",6) == 104056145) strcat(s, "i");
if (crc32("LQsVlnD",7) == 1107501220) strcat(s, "t");
if (crc32("ndAOWJCyHjKlN",13) == 1192866460) strcat(s, "c");
if (crc32("WmAoPNGfegfJfw",14) == 3568352384) strcat(s, "g");
if (crc32("XbCfmiShpjusvp",14) == 409337692) strcat(s, "h");
if (crc32("OlysW",5) == 3343699331) strcat(s, "i");
if (crc32("KzoivOmyhXj",11) == 3594669695) strcat(s, "g");
if (crc32("KMbUGEDpbAwZQQr",15) == 278689610) strcat(s, "n");
if (crc32("HlfrffQc",8) == 600413116) strcat(s, "X");
if (crc32("REAgdkTSoD",10) == 2777561534) strcat(s, "g");
    return s;
}

char *logroller_nouns() {
    char *s = calloc(10);
    if (crc32("QPdaWNqEUNZVyC",14) == 2235819163) strcat(s, "l");
if (crc32("lXPTFlxzpJ",10) == 3531095580) strcat(s, "x");
if (crc32("QiQAnDaMHWJa",12) == 2033426369) strcat(s, "o");
if (crc32("HmwttG",6) == 898673206) strcat(s, "g");
if (crc32("qqEXzR",6) == 2700410795) strcat(s, "l");
if (crc32("NcRbjxHcfKmpcwR",15) == 3917319591) strcat(s, "r");
if (crc32("bdHrMAe",7) == 393036129) strcat(s, "o");
if (crc32("fwMtKLFutJHmHhq",15) == 1040957896) strcat(s, "l");
if (crc32("dwTvgTzs",8) == 676935727) strcat(s, "l");
if (crc32("SJlxmBsxIK",10) == 2577671787) strcat(s, "E");
if (crc32("amfDDcIDE",9) == 4082641587) strcat(s, "e");
if (crc32("PPgdcTfNvoM",11) == 1006782321) strcat(s, "r");
    return s;
}

char *Watertown_nouns() {
    char *s = calloc(10);
    if (crc32("WZWGU",5) == 3603184435) strcat(s, "A");
if (crc32("XmimbAzzbx",10) == 3053378673) strcat(s, "W");
if (crc32("nRbWpyBM",8) == 557566749) strcat(s, "a");
if (crc32("DnOvUrudbCJHQF",14) == 3752482550) strcat(s, "t");
if (crc32("qgLzvsQsAv",10) == 4059530192) strcat(s, "W");
if (crc32("GMxnhFsfc",9) == 2777500829) strcat(s, "e");
if (crc32("hTqTIEiFPe",10) == 3027922375) strcat(s, "r");
if (crc32("BBZzvgevRSpWz",13) == 2723496601) strcat(s, "t");
if (crc32("fBvqN",5) == 376558980) strcat(s, "o");
if (crc32("ixRBkTvbc",9) == 1318865285) strcat(s, "M");
if (crc32("QZtQYL",6) == 2575512945) strcat(s, "w");
if (crc32("eZRJSRfKkXP",11) == 1415352236) strcat(s, "n");
    return s;
}

char *silt_nouns() {
    char *s = calloc(5);
    if (crc32("pDQdkwCqJqyvq",13) == 3999296771) strcat(s, "s");
if (crc32("OVtpYXecA",9) == 2843112328) strcat(s, "V");
if (crc32("MFhaulIeVtmG",12) == 916076905) strcat(s, "i");
if (crc32("qRgAlUQRPCApe",13) == 28917526) strcat(s, "l");
if (crc32("FxzjBbCoxtx",11) == 1041461850) strcat(s, "r");
if (crc32("jrjwZRGsawNl",12) == 1772127617) strcat(s, "t");
    return s;
}

char *Mia_nouns() {
    char *s = calloc(4);
    if (crc32("eGgmykrv",8) == 1926395318) strcat(s, "P");
if (crc32("pUxdCDcFnrxoJYu",15) == 3942422155) strcat(s, "M");
if (crc32("stXJEO",6) == 3354365952) strcat(s, "d");
if (crc32("TCTZhQg",7) == 2628513443) strcat(s, "i");
if (crc32("lEYDXmeYeCBJC",13) == 2568629280) strcat(s, "a");
    return s;
}

char *abode_nouns() {
    char *s = calloc(6);
    if (crc32("ZhAvlsVPqzqAuFx",15) == 1847478482) strcat(s, "e");
if (crc32("aVeewp",6) == 3081164736) strcat(s, "a");
if (crc32("MjYJQyiNOKgb",12) == 1998820242) strcat(s, "b");
if (crc32("FwEAwfOpEj",10) == 3495407456) strcat(s, "o");
if (crc32("GjpnRvqnFhAdIpN",15) == 2312333938) strcat(s, "d");
if (crc32("cxEDmQqbo",9) == 1935271319) strcat(s, "D");
if (crc32("tPHDxtADkarRad",14) == 955830573) strcat(s, "e");
    return s;
}

char *restfulness_nouns() {
    char *s = calloc(12);
    if (crc32("lsJpV",5) == 860940034) strcat(s, "r");
if (crc32("nEMBm",5) == 165355305) strcat(s, "A");
if (crc32("MQRMkXUanvLM",12) == 1151055298) strcat(s, "e");
if (crc32("RNJyHRO",7) == 4092770095) strcat(s, "g");
if (crc32("QdjeaJezJiGoU",13) == 757549465) strcat(s, "s");
if (crc32("ZpaAHJXgabj",11) == 1499938242) strcat(s, "L");
if (crc32("fAFYVCjE",8) == 2026248582) strcat(s, "t");
if (crc32("NFOclEo",7) == 2997312147) strcat(s, "f");
if (crc32("fNkShx",6) == 1565240986) strcat(s, "a");
if (crc32("yEbIV",5) == 1992999535) strcat(s, "u");
if (crc32("pQoUqyEq",8) == 1731084034) strcat(s, "l");
if (crc32("axeDuHs",7) == 2985193444) strcat(s, "n");
if (crc32("guRrI",5) == 3996091857) strcat(s, "s");
if (crc32("WwXzffrsvx",10) == 2596195207) strcat(s, "e");
if (crc32("jxEkbwxfByy",11) == 1224837729) strcat(s, "K");
if (crc32("ZvsaxGJvVyXpw",13) == 3649384883) strcat(s, "s");
if (crc32("kxSHZBxE",8) == 1376551915) strcat(s, "T");
if (crc32("WMqOgfCpQ",9) == 2187568260) strcat(s, "s");
    return s;
}

char *deafness_nouns() {
    char *s = calloc(9);
    if (crc32("pGpqwAU",7) == 3939874653) strcat(s, "d");
if (crc32("wkfsFdhKLXHj",12) == 805348986) strcat(s, "e");
if (crc32("cwOZN",5) == 3106569216) strcat(s, "o");
if (crc32("bDyoKVy",7) == 1006435912) strcat(s, "a");
if (crc32("WwMtHLf",7) == 584630673) strcat(s, "f");
if (crc32("OncYuCIYSmQI",12) == 1722904734) strcat(s, "f");
if (crc32("WhRIOUtW",8) == 2170644581) strcat(s, "n");
if (crc32("xEqXIdfXNzHbX",13) == 1030168152) strcat(s, "V");
if (crc32("NePKgSxLSr",10) == 4109574498) strcat(s, "e");
if (crc32("iHWxyCcFkNMB",12) == 67802933) strcat(s, "x");
if (crc32("UXKEs",5) == 10840332) strcat(s, "s");
if (crc32("tzdfMlImbhsT",12) == 3219466634) strcat(s, "s");
    return s;
}

char *PEI_nouns() {
    char *s = calloc(4);
    if (crc32("HhGtC",5) == 1001682141) strcat(s, "W");
if (crc32("ijQaRSfLGnQmNs",14) == 840890107) strcat(s, "P");
if (crc32("gywKglGQAO",10) == 565910704) strcat(s, "r");
if (crc32("IUkvAVTxLWd",11) == 2963288781) strcat(s, "E");
if (crc32("yvYnB",5) == 1335222754) strcat(s, "a");
if (crc32("bqDss",5) == 1289632614) strcat(s, "I");
    return s;
}

char *Fernando_nouns() {
    char *s = calloc(9);
    if (crc32("nowAYzDHzfoQ",12) == 1135270167) strcat(s, "R");
if (crc32("VcArDV",6) == 3611802226) strcat(s, "F");
if (crc32("DUugtDfMJxHVEL",14) == 3019532072) strcat(s, "T");
if (crc32("UayWpuRsaiisgH",14) == 3662021280) strcat(s, "e");
if (crc32("xLowQytHYjLnE",13) == 3315167741) strcat(s, "r");
if (crc32("GupvLjr",7) == 3931719502) strcat(s, "z");
if (crc32("WDSqGWQnYKkD",12) == 4191481347) strcat(s, "n");
if (crc32("kpwccTn",7) == 2995701465) strcat(s, "n");
if (crc32("deGwMzmlPxxH",12) == 2239810336) strcat(s, "a");
if (crc32("fnVGtGfESGT",11) == 870191764) strcat(s, "n");
if (crc32("arbUGgcd",8) == 2754132143) strcat(s, "P");
if (crc32("skaFYgxX",8) == 2744948646) strcat(s, "d");
if (crc32("RTXGqXsJTTiiK",13) == 1851199629) strcat(s, "o");
    return s;
}

char *nonsimular_nouns() {
    char *s = calloc(11);
    if (crc32("oObJtdUqljLsFy",14) == 3428761420) strcat(s, "K");
if (crc32("uMfDpiLFJNNDgQ",14) == 3368061451) strcat(s, "n");
if (crc32("YSYQTJtnA",9) == 44648033) strcat(s, "o");
if (crc32("TQHwEC",6) == 1315678292) strcat(s, "n");
if (crc32("vrhAymouq",9) == 4241952307) strcat(s, "s");
if (crc32("LLyQszaCJpUb",12) == 1927987423) strcat(s, "e");
if (crc32("bUUvudAvq",9) == 2407866148) strcat(s, "i");
if (crc32("ZxrJWQpukwpPFUj",15) == 3687906984) strcat(s, "Q");
if (crc32("KjRXFGJozooQoD",14) == 963351897) strcat(s, "m");
if (crc32("ylKGucR",7) == 654221556) strcat(s, "G");
if (crc32("wWKgZxXdRKkQQiJ",15) == 4021027117) strcat(s, "u");
if (crc32("nWVYGGY",7) == 2388787485) strcat(s, "l");
if (crc32("SwIussJbGCo",11) == 2820247411) strcat(s, "a");
if (crc32("TLPYDAnz",8) == 444093176) strcat(s, "Q");
if (crc32("vQXIRKg",7) == 2484791915) strcat(s, "r");
    return s;
}

char *Remy_nouns() {
    char *s = calloc(5);
    if (crc32("pxkZnavbHIQZ",12) == 2602114249) strcat(s, "p");
if (crc32("AuPwJlhNtAe",11) == 1918909803) strcat(s, "R");
if (crc32("VyXsNRcDwXQ",11) == 4291837669) strcat(s, "w");
if (crc32("ZWazKMOvYIlhuQJ",15) == 3480947690) strcat(s, "e");
if (crc32("qwtfFIoevUYL",12) == 2019450521) strcat(s, "a");
if (crc32("yskQjUMxPzd",11) == 988974025) strcat(s, "m");
if (crc32("jIjkzRzOg",9) == 2069127056) strcat(s, "y");
    return s;
}

char *unsordidness_nouns() {
    char *s = calloc(13);
    if (crc32("QnXZY",5) == 686076624) strcat(s, "u");
if (crc32("QWWlS",5) == 3344054957) strcat(s, "n");
if (crc32("oWrJoAuWpq",10) == 2051357535) strcat(s, "s");
if (crc32("XyomDDOqG",9) == 3455670208) strcat(s, "s");
if (crc32("QoQQmL",6) == 3699682940) strcat(s, "o");
if (crc32("YalHSbUvRs",10) == 439380355) strcat(s, "m");
if (crc32("xDGcNufiMUkrzGQ",15) == 31165750) strcat(s, "r");
if (crc32("ibqOVA",6) == 3475013858) strcat(s, "f");
if (crc32("paRHusfrKEZ",11) == 2474719083) strcat(s, "d");
if (crc32("ZEKnMxPZSrOoZUM",15) == 1832248778) strcat(s, "i");
if (crc32("FbjCnSfqAI",10) == 3592590301) strcat(s, "d");
if (crc32("LxFVPoLImne",11) == 2918972406) strcat(s, "a");
if (crc32("uJYlfnVTtuavbeJ",15) == 431233559) strcat(s, "n");
if (crc32("lNDnLGpZlvoZ",12) == 3531365495) strcat(s, "h");
if (crc32("RNHmBGwvMF",10) == 2359125247) strcat(s, "e");
if (crc32("BdtFWnDlwcUo",12) == 254950114) strcat(s, "t");
if (crc32("OuAPZpNIkgAAg",13) == 4077019081) strcat(s, "s");
if (crc32("KQsVUQz",7) == 1832578117) strcat(s, "l");
if (crc32("rSfqKsnn",8) == 3366165717) strcat(s, "s");
    return s;
}

char *treesurgeon_nouns() {
    char *s = calloc(12);
    if (crc32("agiYQ",5) == 4103213450) strcat(s, "t");
if (crc32("wpdzy",5) == 3368491326) strcat(s, "Z");
if (crc32("fRRLVIxBrzuA",12) == 1433729614) strcat(s, "r");
if (crc32("rakrjXYpjP",10) == 124079674) strcat(s, "o");
if (crc32("CtUyyLjkH",9) == 3934420508) strcat(s, "e");
if (crc32("fiIEpM",6) == 1280459935) strcat(s, "e");
if (crc32("HxiWceAdN",9) == 3230933378) strcat(s, "s");
if (crc32("UgBYm",5) == 3141851722) strcat(s, "u");
if (crc32("VReMgf",6) == 3541169741) strcat(s, "r");
if (crc32("bLvbzeqcibRQa",13) == 1575891797) strcat(s, "g");
if (crc32("wSpcHMnpif",10) == 1983947990) strcat(s, "e");
if (crc32("AMIlSuWQ",8) == 1455814639) strcat(s, "J");
if (crc32("sKpzZcX",7) == 2456290708) strcat(s, "o");
if (crc32("gsmWnwMvxLkl",12) == 1309271900) strcat(s, "n");
    return s;
}

char *glycuronide_nouns() {
    char *s = calloc(12);
    if (crc32("IFAyudOfZ",9) == 2396822465) strcat(s, "i");
if (crc32("kjQTsPzIXgtRSN",14) == 2319222131) strcat(s, "g");
if (crc32("kcUGdXSynwAox",13) == 3622998069) strcat(s, "r");
if (crc32("mQXtszybI",9) == 3946516523) strcat(s, "l");
if (crc32("NZERXXFsHiqb",12) == 1628796486) strcat(s, "y");
if (crc32("FQvHB",5) == 2452538208) strcat(s, "c");
if (crc32("JkkFe",5) == 3879706210) strcat(s, "u");
if (crc32("sQJpOENzcEGgRBs",15) == 3776142612) strcat(s, "p");
if (crc32("CcTkCa",6) == 126887360) strcat(s, "r");
if (crc32("OrGncq",6) == 3369686128) strcat(s, "q");
if (crc32("jSNHqEvO",8) == 1362223623) strcat(s, "o");
if (crc32("ZjBQghjkWNF",11) == 1394484869) strcat(s, "n");
if (crc32("gxDJPcF",7) == 3490027032) strcat(s, "i");
if (crc32("ethgYTMSV",9) == 1879024581) strcat(s, "d");
if (crc32("BaAduzwxVhi",11) == 1176881247) strcat(s, "e");
    return s;
}

char *subcommissionership_nouns() {
    char *s = calloc(20);
    if (crc32("dyVAKjVsXo",10) == 1462782835) strcat(s, "I");
if (crc32("rXwPycrDh",9) == 3330733274) strcat(s, "s");
if (crc32("zaQoKBL",7) == 2969620439) strcat(s, "u");
if (crc32("qyUwVL",6) == 3147336533) strcat(s, "b");
if (crc32("ujNcEsBck",9) == 2306170054) strcat(s, "c");
if (crc32("jhfAXgRxOqd",11) == 3929715238) strcat(s, "B");
if (crc32("mkmQnbfPR",9) == 800986237) strcat(s, "o");
if (crc32("diQIiObn",8) == 2109058682) strcat(s, "m");
if (crc32("NLSNUbjr",8) == 568262441) strcat(s, "m");
if (crc32("BpbsIUbmJYPXe",13) == 2749208505) strcat(s, "i");
if (crc32("bvRYMsHCjFTAoA",14) == 4027484973) strcat(s, "s");
if (crc32("xzibhGk",7) == 1446220899) strcat(s, "W");
if (crc32("ccWGXuO",7) == 4079364375) strcat(s, "s");
if (crc32("tYINQ",5) == 1906853020) strcat(s, "i");
if (crc32("CTapLUXrIXPBzy",14) == 1306304446) strcat(s, "o");
if (crc32("dzJtxyqGlh",10) == 3249877829) strcat(s, "n");
if (crc32("YZIXKEkgbPAvtRl",15) == 4153981746) strcat(s, "e");
if (crc32("LlSYdVKI",8) == 686269461) strcat(s, "r");
if (crc32("smUOsmDQwhV",11) == 698152289) strcat(s, "s");
if (crc32("fgaiqXxWGfwUR",13) == 161411768) strcat(s, "h");
if (crc32("krsODgcaF",9) == 745653852) strcat(s, "Q");
if (crc32("zMJRYBiWYvwycKn",15) == 3828078444) strcat(s, "i");
if (crc32("FWqdcHcyWi",10) == 1671621087) strcat(s, "P");
if (crc32("tlRySRweeBcf",12) == 1514614921) strcat(s, "p");
    return s;
}

char *bookman_nouns() {
    char *s = calloc(8);
    if (crc32("ZIGSjDwFFmI",11) == 2284858292) strcat(s, "V");
if (crc32("wpUoZId",7) == 645423519) strcat(s, "b");
if (crc32("dWIwCmKgbcrZo",13) == 3939327395) strcat(s, "e");
if (crc32("NvUNDQPVYGjOlPE",15) == 3078107012) strcat(s, "o");
if (crc32("uEyIcCjvTKLbzLY",15) == 3898832843) strcat(s, "Z");
if (crc32("zNYwfGg",7) == 58299443) strcat(s, "o");
if (crc32("UkKzkux",7) == 1111747241) strcat(s, "v");
if (crc32("SxksMLcE",8) == 3855985081) strcat(s, "k");
if (crc32("uvzDwKy",7) == 851040425) strcat(s, "m");
if (crc32("sAucZHWRSAU",11) == 2383322042) strcat(s, "u");
if (crc32("hrWsnlLQJRKrEFs",15) == 1213055079) strcat(s, "a");
if (crc32("UrcwdVVeaKzMV",13) == 4060574224) strcat(s, "n");
    return s;
}

char *falsework_nouns() {
    char *s = calloc(10);
    if (crc32("amFuuNClXOe",11) == 450507405) strcat(s, "m");
if (crc32("eiUCzZQZuE",10) == 3537829947) strcat(s, "f");
if (crc32("vDdLTIQh",8) == 1792165333) strcat(s, "a");
if (crc32("EtHUqTqiYnH",11) == 2829729017) strcat(s, "v");
if (crc32("nknkfBBzzsAnqf",14) == 632528042) strcat(s, "l");
if (crc32("FqQEWLoCmPDgq",13) == 551653684) strcat(s, "s");
if (crc32("ITzZD",5) == 2639562477) strcat(s, "a");
if (crc32("uyaDKhWEBn",10) == 2281471392) strcat(s, "e");
if (crc32("yORxrfemgLo",11) == 1406482849) strcat(s, "w");
if (crc32("iQLoGih",7) == 343016336) strcat(s, "b");
if (crc32("itcBOfVgZlsQJYl",15) == 1513272050) strcat(s, "o");
if (crc32("nSNBjuyUYe",10) == 977577613) strcat(s, "r");
if (crc32("tgEiTqSZhpcB",12) == 2995658928) strcat(s, "k");
    return s;
}

char *Pironi_nouns() {
    char *s = calloc(7);
    if (crc32("COchyzX",7) == 1556504086) strcat(s, "U");
if (crc32("JBebOaPObYXT",12) == 2374592447) strcat(s, "P");
if (crc32("kvjSmyHdEWDPsoy",15) == 2059906557) strcat(s, "i");
if (crc32("vVogd",5) == 2101241392) strcat(s, "r");
if (crc32("pazHyFdJsDk",11) == 1955550746) strcat(s, "y");
if (crc32("NKSkQsqYzAMeC",13) == 4161444686) strcat(s, "o");
if (crc32("oNgVvUpsghYlb",13) == 3658279160) strcat(s, "f");
if (crc32("ysDzVuJAucv",11) == 3270854091) strcat(s, "n");
if (crc32("MCaxPiPQOM",10) == 1923501174) strcat(s, "x");
if (crc32("RIjtopEDG",9) == 1235986941) strcat(s, "i");
    return s;
}

char *analyser_nouns() {
    char *s = calloc(9);
    if (crc32("gTsQXJuBiQBwjb",14) == 3141589326) strcat(s, "r");
if (crc32("tlcqXl",6) == 930469021) strcat(s, "a");
if (crc32("TssMResFAHz",11) == 3497937068) strcat(s, "n");
if (crc32("ObZEWV",6) == 153985672) strcat(s, "a");
if (crc32("JXMKlANxBjKNBx",14) == 2418625241) strcat(s, "l");
if (crc32("AwZDcmBOnt",10) == 2073916383) strcat(s, "y");
if (crc32("bWiHMEdywHZ",11) == 1183333540) strcat(s, "O");
if (crc32("GUVsbwzIwsvB",12) == 1313869173) strcat(s, "s");
if (crc32("shCKi",5) == 3556625989) strcat(s, "e");
if (crc32("oRBLpIt",7) == 392322462) strcat(s, "B");
if (crc32("jaPddbhwlLy",11) == 2426234610) strcat(s, "r");
    return s;
}

char *aigrette_nouns() {
    char *s = calloc(9);
    if (crc32("YuVRkNPQztjco",13) == 2548888656) strcat(s, "a");
if (crc32("YoOdAfvi",8) == 3807440378) strcat(s, "i");
if (crc32("sfVlCD",6) == 793290580) strcat(s, "g");
if (crc32("CuhxUsEAX",9) == 2988381669) strcat(s, "G");
if (crc32("vRdyNLRfssGuUV",14) == 1639055604) strcat(s, "r");
if (crc32("xbQXWs",6) == 2561275640) strcat(s, "e");
if (crc32("nbtvgLkwiupm",12) == 977742021) strcat(s, "Z");
if (crc32("veGRSGmQ",8) == 3863989698) strcat(s, "t");
if (crc32("hTISAX",6) == 1626649412) strcat(s, "t");
if (crc32("CaosqETfSrlvwLu",15) == 1921587649) strcat(s, "t");
if (crc32("UwshzMJV",8) == 2172748456) strcat(s, "e");
    return s;
}

char *graver_nouns() {
    char *s = calloc(7);
    if (crc32("ekkjUklOBWCkDB",14) == 1712314566) strcat(s, "g");
if (crc32("zVsOSORTOiRvQM",14) == 903913836) strcat(s, "r");
if (crc32("sJjnJvTIWlnol",13) == 1232593179) strcat(s, "w");
if (crc32("DcvcYIWDEyt",11) == 897608245) strcat(s, "a");
if (crc32("gooTXpzlADkZTG",14) == 1602401152) strcat(s, "h");
if (crc32("IPOAc",5) == 517162716) strcat(s, "v");
if (crc32("jWTMDzN",7) == 632847559) strcat(s, "L");
if (crc32("BkliBoV",7) == 626310261) strcat(s, "e");
if (crc32("aifKqBl",7) == 373922303) strcat(s, "r");
    return s;
}

char *priory_nouns() {
    char *s = calloc(7);
    if (crc32("CkBkYPpFwgmDgXv",15) == 560026806) strcat(s, "p");
if (crc32("JBddsu",6) == 472600176) strcat(s, "P");
if (crc32("ANAhTiOVVEQ",11) == 52586602) strcat(s, "r");
if (crc32("ovQtZjvEYISy",12) == 458499617) strcat(s, "i");
if (crc32("wqszkDj",7) == 3017610206) strcat(s, "o");
if (crc32("vMNxzmJWyuB",11) == 1039608241) strcat(s, "m");
if (crc32("HFuwvSuvjPpQ",12) == 2851010414) strcat(s, "r");
if (crc32("eRGZmUFJ",8) == 3129796382) strcat(s, "y");
    return s;
}

char *cordoba_nouns() {
    char *s = calloc(8);
    if (crc32("hpQmKCxOvj",10) == 4239681981) strcat(s, "P");
if (crc32("QbpuedjFUD",10) == 2008270807) strcat(s, "c");
if (crc32("DeabWtPVmtbNqE",14) == 2702737212) strcat(s, "o");
if (crc32("PuTSvkP",7) == 1281594502) strcat(s, "r");
if (crc32("xtkkhequgLTm",12) == 2847882604) strcat(s, "t");
if (crc32("IiaXYD",6) == 4132070337) strcat(s, "d");
if (crc32("uRVdshDfw",9) == 2898431055) strcat(s, "e");
if (crc32("FzYbfDatksaQQ",13) == 1424854908) strcat(s, "o");
if (crc32("yHOyrEUCexsnaIh",15) == 3350885385) strcat(s, "b");
if (crc32("zNWALaqQdexDjS",14) == 2914279959) strcat(s, "a");
    return s;
}

char *Flexography_nouns() {
    char *s = calloc(12);
    if (crc32("yKzChfHeisBa",12) == 2694619518) strcat(s, "w");
if (crc32("YcesVYbyRsgM",12) == 1816776008) strcat(s, "F");
if (crc32("RpJWBxJUa",9) == 3955330341) strcat(s, "l");
if (crc32("EBScpL",6) == 253268013) strcat(s, "e");
if (crc32("lOpfaXv",7) == 4081915740) strcat(s, "H");
if (crc32("KjKpsOZ",7) == 2633705004) strcat(s, "x");
if (crc32("PUhzZhMjCaYVLuL",15) == 1865679351) strcat(s, "o");
if (crc32("udiXF",5) == 3609251609) strcat(s, "B");
if (crc32("EKVDNzaL",8) == 349614805) strcat(s, "g");
if (crc32("acWotUns",8) == 1972128984) strcat(s, "r");
if (crc32("cMvZBCUsRg",10) == 3085006577) strcat(s, "a");
if (crc32("RrcSTvP",7) == 291319571) strcat(s, "p");
if (crc32("uMyTVVq",7) == 2206583409) strcat(s, "h");
if (crc32("VVegbRwFzduMT",13) == 2389752024) strcat(s, "y");
    return s;
}

char *dimethylsulphoxide_nouns() {
    char *s = calloc(19);
    if (crc32("IEAJsFReMTI",11) == 748311721) strcat(s, "d");
if (crc32("XOiGsmiHg",9) == 134439163) strcat(s, "i");
if (crc32("wXGXFvlubWvEk",13) == 549542286) strcat(s, "w");
if (crc32("nLfUwpFlhq",10) == 3909782428) strcat(s, "m");
if (crc32("FBhcie",6) == 1997843543) strcat(s, "e");
if (crc32("hWNVXQULOKaZ",12) == 267711979) strcat(s, "t");
if (crc32("RJLatnakwUFv",12) == 3387087112) strcat(s, "G");
if (crc32("veUQzOYYRljzFUp",15) == 1349912210) strcat(s, "h");
if (crc32("pyuNssd",7) == 262818448) strcat(s, "y");
if (crc32("szTRWsaLGGucVBG",15) == 1475106365) strcat(s, "a");
if (crc32("RLFDIU",6) == 2664550109) strcat(s, "l");
if (crc32("huBLByxZaUsPo",13) == 4249275701) strcat(s, "i");
if (crc32("rQOkDf",6) == 1164626388) strcat(s, "s");
if (crc32("XQYCQLibYfBA",12) == 2249448003) strcat(s, "r");
if (crc32("tfglah",6) == 4021297899) strcat(s, "u");
if (crc32("qSdMGwKsBpfx",12) == 190347427) strcat(s, "l");
if (crc32("wNvrqwZkvXpkVJI",15) == 2833364576) strcat(s, "S");
if (crc32("PpyfyjkKl",9) == 738506578) strcat(s, "p");
if (crc32("TeKiAwZwIwzTPYq",15) == 2302984718) strcat(s, "U");
if (crc32("DEHonRns",8) == 2686205308) strcat(s, "h");
if (crc32("XBIAnIDYajUvtg",14) == 1216014125) strcat(s, "W");
if (crc32("phwzE",5) == 1136300680) strcat(s, "o");
if (crc32("rvUWwwWoUqsZBPt",15) == 680691945) strcat(s, "e");
if (crc32("WZJdEfWfjEvp",12) == 2759348089) strcat(s, "x");
if (crc32("MtPBANObbk",10) == 2239445016) strcat(s, "i");
if (crc32("GYeSqplBMweSWxW",15) == 2412536650) strcat(s, "d");
if (crc32("KGBYgVMQe",9) == 1445806485) strcat(s, "B");
if (crc32("cabSWWHQBfGyF",13) == 2217667138) strcat(s, "e");
    return s;
}

char *perchlorate_nouns() {
    char *s = calloc(12);
    if (crc32("EVWQfpfKNe",10) == 1456453016) strcat(s, "p");
if (crc32("hwClwDshSqcF",12) == 579445008) strcat(s, "e");
if (crc32("jfBAQScVU",9) == 1340762070) strcat(s, "r");
if (crc32("VGbJyEOSnY",10) == 1536479606) strcat(s, "K");
if (crc32("YvkBU",5) == 548997594) strcat(s, "c");
if (crc32("pSJLwRFJtsepVPI",15) == 2516609496) strcat(s, "Q");
if (crc32("brRheOSSWO",10) == 1641436951) strcat(s, "h");
if (crc32("QdxtpyU",7) == 4001054603) strcat(s, "j");
if (crc32("swGGImCYmskGDA",14) == 3812782782) strcat(s, "l");
if (crc32("owbifuBkun",10) == 324793964) strcat(s, "X");
if (crc32("DhWMhlnLKeMZ",12) == 4197932372) strcat(s, "o");
if (crc32("ryRAt",5) == 2184550939) strcat(s, "r");
if (crc32("BVlZb",5) == 2823957412) strcat(s, "a");
if (crc32("ZwQRBMHOnYr",11) == 658122760) strcat(s, "X");
if (crc32("TmBsRt",6) == 4281373938) strcat(s, "t");
if (crc32("pscRatW",7) == 57457039) strcat(s, "H");
if (crc32("aIXynYljm",9) == 3658450654) strcat(s, "e");
    return s;
}

char *coevality_nouns() {
    char *s = calloc(10);
    if (crc32("oxgynWfKE",9) == 1373869288) strcat(s, "c");
if (crc32("LPMhZj",6) == 3622146868) strcat(s, "h");
if (crc32("DdIBMws",7) == 193181938) strcat(s, "o");
if (crc32("duGjihzRx",9) == 3463503287) strcat(s, "e");
if (crc32("bWMuYEwkY",9) == 3917868996) strcat(s, "v");
if (crc32("WSVqjynpRswN",12) == 3035028152) strcat(s, "a");
if (crc32("UjwfXTwOmuG",11) == 3551710053) strcat(s, "l");
if (crc32("wjRhAiIVAxdoSON",15) == 170251690) strcat(s, "i");
if (crc32("VjpiJuNPjHBEQ",13) == 1866914562) strcat(s, "t");
if (crc32("WDyiyFcoiArYs",13) == 1391574330) strcat(s, "y");
    return s;
}

char *Rumford_nouns() {
    char *s = calloc(8);
    if (crc32("HckwhSztuTg",11) == 365786166) strcat(s, "N");
if (crc32("zLZyR",5) == 3190927863) strcat(s, "R");
if (crc32("OEZKvYpW",8) == 4136845537) strcat(s, "u");
if (crc32("SztdsXLXrNqpQ",13) == 1979356957) strcat(s, "S");
if (crc32("yOCHNslLe",9) == 1657542724) strcat(s, "m");
if (crc32("KdyDtcvLoHVq",12) == 366206248) strcat(s, "z");
if (crc32("QlcWlFuVS",9) == 28661714) strcat(s, "f");
if (crc32("bBkjqVI",7) == 1993066759) strcat(s, "M");
if (crc32("UvxTJgzBFLA",11) == 1574655188) strcat(s, "o");
if (crc32("NLpbRvPvtmnHchi",15) == 559340563) strcat(s, "r");
if (crc32("kONoaeGBrNa",11) == 1330839778) strcat(s, "T");
if (crc32("DKynRCnopfus",12) == 3564736509) strcat(s, "d");
    return s;
}

char *finger_nouns() {
    char *s = calloc(7);
    if (crc32("XtFXKPKG",8) == 334839336) strcat(s, "x");
if (crc32("xxkawQ",6) == 1177672263) strcat(s, "f");
if (crc32("AEXQpxAxY",9) == 620264644) strcat(s, "R");
if (crc32("wHJEN",5) == 2987877585) strcat(s, "i");
if (crc32("KZWHanDvJHbDQK",14) == 574515136) strcat(s, "n");
if (crc32("fEHltXSvpobzgJZ",15) == 968604844) strcat(s, "U");
if (crc32("ZjnEBhRewVhYN",13) == 2191616045) strcat(s, "g");
if (crc32("uICtc",5) == 4231540892) strcat(s, "e");
if (crc32("rCiTci",6) == 2486912565) strcat(s, "T");
if (crc32("TcxzmOTNQXgHfc",14) == 1917941499) strcat(s, "r");
    return s;
}

char *inburst_nouns() {
    char *s = calloc(8);
    if (crc32("CwDycPVFcIfGe",13) == 1825869141) strcat(s, "i");
if (crc32("aEBPKNWhNkVqOH",14) == 1017051333) strcat(s, "n");
if (crc32("nybNLllcGtAQin",14) == 1844946905) strcat(s, "W");
if (crc32("ICOuzGGUhXXM",12) == 4103084034) strcat(s, "b");
if (crc32("GFDbz",5) == 2479803929) strcat(s, "s");
if (crc32("TSLdmMbFZnga",12) == 716188822) strcat(s, "u");
if (crc32("pmSTPfa",7) == 2602339680) strcat(s, "r");
if (crc32("rHYQJkeBJh",10) == 1526194462) strcat(s, "S");
if (crc32("tWEWhtr",7) == 3784688977) strcat(s, "s");
if (crc32("VnGwiHwovHL",11) == 3940606694) strcat(s, "t");
    return s;
}

char *brose_nouns() {
    char *s = calloc(6);
    if (crc32("jeULF",5) == 2958858039) strcat(s, "b");
if (crc32("ninqCMJM",8) == 3141120097) strcat(s, "r");
if (crc32("vzKDnJ",6) == 2301272982) strcat(s, "o");
if (crc32("JiRmYUnKf",9) == 1593058334) strcat(s, "s");
if (crc32("nDyvJdUNBfNk",12) == 3761976281) strcat(s, "e");
    return s;
}

char *Bohlen_nouns() {
    char *s = calloc(7);
    if (crc32("lCyJtOarExXRg",13) == 3783457108) strcat(s, "B");
if (crc32("hzvzIuw",7) == 658853622) strcat(s, "R");
if (crc32("aCZrBNzMYPmT",12) == 3830575936) strcat(s, "o");
if (crc32("zVpINbuIL",9) == 2935334599) strcat(s, "h");
if (crc32("UyRpHPi",7) == 421273984) strcat(s, "l");
if (crc32("sDQUtsg",7) == 3245904622) strcat(s, "y");
if (crc32("gCUNXSlwoccQOXs",15) == 3964307758) strcat(s, "e");
if (crc32("MjGhXl",6) == 3910577927) strcat(s, "i");
if (crc32("MQADeuIp",8) == 336848364) strcat(s, "n");
    return s;
}

char *fartlek_nouns() {
    char *s = calloc(8);
    if (crc32("vRvxKIbrNOh",11) == 2387740080) strcat(s, "q");
if (crc32("EMpkVhTvrIMn",12) == 2106313860) strcat(s, "f");
if (crc32("VpjKEgytElnOL",13) == 1513688877) strcat(s, "a");
if (crc32("wbxItLN",7) == 1081184033) strcat(s, "r");
if (crc32("nHtdHxHJfzP",11) == 251267487) strcat(s, "Y");
if (crc32("laURoCcKqMt",11) == 26426042) strcat(s, "t");
if (crc32("oEYpMcWOWRZ",11) == 3365980350) strcat(s, "j");
if (crc32("FjNWJFPAhHBo",12) == 3916608733) strcat(s, "l");
if (crc32("rSCMGK",6) == 295366274) strcat(s, "b");
if (crc32("NFtgXYF",7) == 1821625390) strcat(s, "e");
if (crc32("JACmvW",6) == 33562542) strcat(s, "B");
if (crc32("CWPosqFOrcSr",12) == 2554055449) strcat(s, "k");
    return s;
}

char *cornucopia_nouns() {
    char *s = calloc(11);
    if (crc32("VGqAMqCIBtHyzby",15) == 1545443040) strcat(s, "c");
if (crc32("BtiXLQTj",8) == 4264134477) strcat(s, "o");
if (crc32("froHHWP",7) == 2520439866) strcat(s, "r");
if (crc32("AmRwmrNOYjx",11) == 2297907658) strcat(s, "n");
if (crc32("VDxdZJSVagQBt",13) == 2238796086) strcat(s, "A");
if (crc32("eqYaIYQbaiI",11) == 224070291) strcat(s, "u");
if (crc32("VtQrgwUSMD",10) == 3774408319) strcat(s, "c");
if (crc32("OyECnhQGK",9) == 4220756782) strcat(s, "b");
if (crc32("tGZFXCUIF",9) == 1661705568) strcat(s, "o");
if (crc32("ksOCXENMtiUab",13) == 1978880463) strcat(s, "p");
if (crc32("AOcQGYZZYmlphnK",15) == 2305437036) strcat(s, "D");
if (crc32("NtuJWdrcj",9) == 1113979460) strcat(s, "i");
if (crc32("LwUkQUtzkCC",11) == 2496240761) strcat(s, "X");
if (crc32("CDKIMiEoqxAuViq",15) == 1631514703) strcat(s, "a");
    return s;
}

char *Hamite_nouns() {
    char *s = calloc(7);
    if (crc32("QTzPyAMcUDoLp",13) == 4173392243) strcat(s, "H");
if (crc32("PltvoufyGjDnmz",14) == 3991203952) strcat(s, "H");
if (crc32("qoxSbWtDdL",10) == 912899567) strcat(s, "a");
if (crc32("rqdMQJjz",8) == 3543152753) strcat(s, "m");
if (crc32("RlQCeSKtUCfqWD",14) == 1628533353) strcat(s, "F");
if (crc32("aRZnfNzAoHwXa",13) == 2595694333) strcat(s, "i");
if (crc32("GjIgCooyxQLg",12) == 1285253278) strcat(s, "t");
if (crc32("MBVcvNM",7) == 1376471394) strcat(s, "e");
    return s;
}

char *bargepole_nouns() {
    char *s = calloc(10);
    if (crc32("kKGkxuWtTgHlba",14) == 3455706789) strcat(s, "f");
if (crc32("luDaCzxBn",9) == 3799273006) strcat(s, "b");
if (crc32("AUdiyhwWfNLlO",13) == 42924621) strcat(s, "B");
if (crc32("nBcrjyEjMvDCtI",14) == 2172475833) strcat(s, "a");
if (crc32("DhhIdwDV",8) == 3631292154) strcat(s, "e");
if (crc32("BoQuz",5) == 145902199) strcat(s, "r");
if (crc32("tKJSkhdWtYtmtW",14) == 1735014488) strcat(s, "I");
if (crc32("TqloEZ",6) == 3601130801) strcat(s, "g");
if (crc32("DymkZ",5) == 819901559) strcat(s, "e");
if (crc32("IsqDpLwuSIKS",12) == 1311649108) strcat(s, "d");
if (crc32("eInEmStdgPnkJ",13) == 2227347681) strcat(s, "p");
if (crc32("XREWJA",6) == 3719885089) strcat(s, "o");
if (crc32("amOoHB",6) == 309274668) strcat(s, "z");
if (crc32("fbOUEU",6) == 3012744130) strcat(s, "l");
if (crc32("LxDrDFYJdsQ",11) == 3222257181) strcat(s, "e");
    return s;
}

char *gleed_nouns() {
    char *s = calloc(6);
    if (crc32("GifpnE",6) == 719615984) strcat(s, "Q");
if (crc32("KXnNaiFd",8) == 4239524619) strcat(s, "g");
if (crc32("wMsSDQVDapa",11) == 1299285935) strcat(s, "l");
if (crc32("RvsWyzYuP",9) == 3063356558) strcat(s, "e");
if (crc32("ioHZUz",6) == 3452761386) strcat(s, "e");
if (crc32("sCLOfJwN",8) == 1525825261) strcat(s, "f");
if (crc32("URqMc",5) == 2475324226) strcat(s, "d");
    return s;
}

char *falsie_nouns() {
    char *s = calloc(7);
    if (crc32("cjCfE",5) == 3844841767) strcat(s, "o");
if (crc32("CllMbrLSvI",10) == 2176535294) strcat(s, "f");
if (crc32("SxFEWbUPxn",10) == 753522599) strcat(s, "a");
if (crc32("vNmxroV",7) == 1416152240) strcat(s, "c");
if (crc32("sstdsPYRALdN",12) == 325674827) strcat(s, "l");
if (crc32("CtfegfhWFUJpx",13) == 117978920) strcat(s, "s");
if (crc32("PSewHjO",7) == 2489397212) strcat(s, "i");
if (crc32("WmmVFbekWRVXum",14) == 3384256482) strcat(s, "U");
if (crc32("NBMYTi",6) == 1175000549) strcat(s, "e");
    return s;
}

char *harbor_nouns() {
    char *s = calloc(7);
    if (crc32("XxmHuCgKIM",10) == 2305596258) strcat(s, "h");
if (crc32("AuJePtUxitx",11) == 3078283692) strcat(s, "v");
if (crc32("ahglhHuGkEJEEF",14) == 848440956) strcat(s, "a");
if (crc32("anAYLe",6) == 1975061449) strcat(s, "r");
if (crc32("gvtsOScwrvNsxz",14) == 3899703539) strcat(s, "R");
if (crc32("TnXVxgc",7) == 988306670) strcat(s, "b");
if (crc32("isaRPFjXJnLawox",15) == 3915229312) strcat(s, "q");
if (crc32("pDSVgQL",7) == 3846839873) strcat(s, "o");
if (crc32("rASLNEMXYrfbbXF",15) == 888086467) strcat(s, "n");
if (crc32("AHLXYnyz",8) == 1030329478) strcat(s, "r");
    return s;
}

char *sangria_nouns() {
    char *s = calloc(8);
    if (crc32("CNVLa",5) == 1230208920) strcat(s, "V");
if (crc32("PHGhJ",5) == 3999898208) strcat(s, "s");
if (crc32("SOXYGvGbRcwtMt",14) == 3246216279) strcat(s, "a");
if (crc32("rMfhfYbeybd",11) == 1423386979) strcat(s, "G");
if (crc32("LNoiNTk",7) == 141194032) strcat(s, "n");
if (crc32("euQBCIBFAwjedDI",15) == 2966775454) strcat(s, "C");
if (crc32("xdHwwsUmNNPw",12) == 2479911711) strcat(s, "g");
if (crc32("xqJhdrgc",8) == 1245678269) strcat(s, "r");
if (crc32("MJMQeeDXtIKMuqF",15) == 2980827121) strcat(s, "i");
if (crc32("nikSXAfblnUDV",13) == 368743606) strcat(s, "a");
    return s;
}

char *Pitts_nouns() {
    char *s = calloc(6);
    if (crc32("vEUeNkI",7) == 2497397214) strcat(s, "Y");
if (crc32("hwmrZwZA",8) == 3424284706) strcat(s, "P");
if (crc32("GMnCafwPyGzv",12) == 1879067715) strcat(s, "J");
if (crc32("grJeRYnswQPURiK",15) == 4055326917) strcat(s, "i");
if (crc32("BkmutQHhJBWNeTb",15) == 2940508722) strcat(s, "o");
if (crc32("ULLjpKMkvE",10) == 2748037815) strcat(s, "t");
if (crc32("MSjmPgSHpGAggS",14) == 2967062993) strcat(s, "t");
if (crc32("OrkSuU",6) == 621382290) strcat(s, "s");
if (crc32("DDSHgblgIIK",11) == 1694534503) strcat(s, "s");
    return s;
}

char *odometer_nouns() {
    char *s = calloc(9);
    if (crc32("HhstV",5) == 3487540547) strcat(s, "o");
if (crc32("iqOwGKvUQemQH",13) == 3875862729) strcat(s, "d");
if (crc32("aavPm",5) == 485088683) strcat(s, "v");
if (crc32("WcsxlMmwPWKhX",13) == 2281975685) strcat(s, "o");
if (crc32("UeGwhLtYVzmbqJo",15) == 3820030602) strcat(s, "m");
if (crc32("fPQyQTxKMA",10) == 2214153664) strcat(s, "Z");
if (crc32("xmsWshOkcfVAUQm",15) == 1232759709) strcat(s, "e");
if (crc32("mKtMkiYppvIgAw",14) == 2987993108) strcat(s, "G");
if (crc32("KrcczSyIR",9) == 4121033596) strcat(s, "t");
if (crc32("TeQBDPFMyR",10) == 838588676) strcat(s, "f");
if (crc32("QtLfqUK",7) == 2026003539) strcat(s, "e");
if (crc32("qiYZvIuAMQCuOd",14) == 3418680303) strcat(s, "r");
    return s;
}

char *Bedwell_nouns() {
    char *s = calloc(8);
    if (crc32("ObAgVhPNEXq",11) == 749297356) strcat(s, "B");
if (crc32("YEgAYPpTLaASkjY",15) == 3995173509) strcat(s, "i");
if (crc32("KxmFzmy",7) == 1126233272) strcat(s, "e");
if (crc32("rioOJTCyYQ",10) == 3815662305) strcat(s, "b");
if (crc32("kFaeMz",6) == 1019462420) strcat(s, "d");
if (crc32("SqLylFCAmkYjdI",14) == 1389952579) strcat(s, "M");
if (crc32("nJGezjIGutZmQ",13) == 1989899385) strcat(s, "w");
if (crc32("BIqESDlPfaOdq",13) == 1451034217) strcat(s, "e");
if (crc32("xCDrpTKPU",9) == 2617683961) strcat(s, "l");
if (crc32("icdYvwngjrtP",12) == 2016396914) strcat(s, "l");
    return s;
}

char *Kerwon_nouns() {
    char *s = calloc(7);
    if (crc32("kmvaYWH",7) == 3140438498) strcat(s, "K");
if (crc32("bGtpOftVTCDCft",14) == 124143523) strcat(s, "e");
if (crc32("wCWwmMjmmLv",11) == 2675508959) strcat(s, "r");
if (crc32("PAIGIQmM",8) == 3600041051) strcat(s, "E");
if (crc32("mkIMHlIVGezp",12) == 399467974) strcat(s, "w");
if (crc32("FdqsV",5) == 1996285491) strcat(s, "o");
if (crc32("NrviPytSCT",10) == 201621847) strcat(s, "n");
    return s;
}

char *fugacity_nouns() {
    char *s = calloc(9);
    if (crc32("sLWshnkC",8) == 1702214640) strcat(s, "a");
if (crc32("xwqKUAsRWxltS",13) == 2077704228) strcat(s, "f");
if (crc32("qfNBockkz",9) == 3282679616) strcat(s, "S");
if (crc32("bypBo",5) == 2018772280) strcat(s, "u");
if (crc32("fjmVb",5) == 2342109250) strcat(s, "g");
if (crc32("rjHdTcnTqdrsVF",14) == 3079527709) strcat(s, "a");
if (crc32("djpzizKTrmCtAd",14) == 3475363057) strcat(s, "i");
if (crc32("DcXeWwJBrMDitmy",15) == 1754976270) strcat(s, "c");
if (crc32("twphD",5) == 2665609907) strcat(s, "p");
if (crc32("yBmJtLsmDyeD",12) == 1115623767) strcat(s, "i");
if (crc32("oHGHX",5) == 2871386333) strcat(s, "t");
if (crc32("OSnLQY",6) == 588373456) strcat(s, "y");
    return s;
}

char *auxanometer_nouns() {
    char *s = calloc(12);
    if (crc32("ZVZDrwELbKVTH",13) == 2512966065) strcat(s, "a");
if (crc32("Heset",5) == 3084470577) strcat(s, "Z");
if (crc32("yQnDgEnPVs",10) == 4002475261) strcat(s, "u");
if (crc32("yrTdBNWHVcLa",12) == 285406225) strcat(s, "x");
if (crc32("ajHvFTds",8) == 4280132950) strcat(s, "s");
if (crc32("AsFFgazFQNZTF",13) == 2051263833) strcat(s, "a");
if (crc32("ktwsOewiuMI",11) == 3692368388) strcat(s, "g");
if (crc32("bsfYpZcqsx",10) == 9573737) strcat(s, "n");
if (crc32("KocwJCgWxdp",11) == 3955490233) strcat(s, "K");
if (crc32("hQOTQaDzazlP",12) == 1200463496) strcat(s, "o");
if (crc32("RMnPLTWa",8) == 1572985727) strcat(s, "t");
if (crc32("CsSzyBzVuCnaomJ",15) == 2656522699) strcat(s, "m");
if (crc32("ufTtREQVaU",10) == 3990017799) strcat(s, "v");
if (crc32("ReGTmSuMhgUHha",14) == 4232717246) strcat(s, "e");
if (crc32("LKRMEzJ",7) == 1702711374) strcat(s, "t");
if (crc32("jvSoXuef",8) == 3658599095) strcat(s, "e");
if (crc32("DdUcAkTIJ",9) == 2024646132) strcat(s, "A");
if (crc32("RlHSuL",6) == 2973692448) strcat(s, "r");
    return s;
}

char *Aaerope_nouns() {
    char *s = calloc(8);
    if (crc32("dUkJXzxd",8) == 94463523) strcat(s, "y");
if (crc32("RcLMBmjJBXbZK",13) == 1920255966) strcat(s, "A");
if (crc32("OdifmKJS",8) == 2837993030) strcat(s, "U");
if (crc32("ZdTuJgo",7) == 2455934161) strcat(s, "a");
if (crc32("hDcpKcncVTKP",12) == 1807833054) strcat(s, "K");
if (crc32("kqhmzlNiySKSCi",14) == 661419070) strcat(s, "e");
if (crc32("PCoRTiSYO",9) == 2731604890) strcat(s, "h");
if (crc32("czObnJNahAg",11) == 3176941391) strcat(s, "r");
if (crc32("oPglVmYX",8) == 1043765815) strcat(s, "f");
if (crc32("bYtSj",5) == 4242330949) strcat(s, "o");
if (crc32("rxjOvikU",8) == 2677184448) strcat(s, "a");
if (crc32("gFzekkmRJm",10) == 2316776775) strcat(s, "p");
if (crc32("mOtTqP",6) == 3075405163) strcat(s, "G");
if (crc32("FRUEPRrgMhkTV",13) == 4275909004) strcat(s, "e");
    return s;
}

char *Weltschmerz_nouns() {
    char *s = calloc(12);
    if (crc32("XUvuQtfKIIRzcp",14) == 1700530128) strcat(s, "W");
if (crc32("lnQkmEKSIHSl",12) == 3594117372) strcat(s, "e");
if (crc32("mHDCH",5) == 361608165) strcat(s, "E");
if (crc32("ksmeXfSznw",10) == 3534576066) strcat(s, "l");
if (crc32("mhFRYd",6) == 1544241096) strcat(s, "t");
if (crc32("HBMZS",5) == 1637655004) strcat(s, "Z");
if (crc32("WXxNUKHNMqln",12) == 42470415) strcat(s, "s");
if (crc32("kDDuzUbws",9) == 1026899531) strcat(s, "L");
if (crc32("kUpbfNSN",8) == 354805357) strcat(s, "c");
if (crc32("AxLpSOpkfxDd",12) == 1490167021) strcat(s, "S");
if (crc32("QSpssfDFis",10) == 163942503) strcat(s, "h");
if (crc32("DsgiYny",7) == 915823221) strcat(s, "Y");
if (crc32("oSulHp",6) == 1113227244) strcat(s, "m");
if (crc32("YrPbLJAQrEdCwpY",15) == 1093806105) strcat(s, "e");
if (crc32("HZdLljBGWf",10) == 2298846866) strcat(s, "c");
if (crc32("nAlukFJe",8) == 2739208347) strcat(s, "r");
if (crc32("sRrklg",6) == 1382463451) strcat(s, "L");
if (crc32("srSRSrIvq",9) == 226546460) strcat(s, "z");
    return s;
}

char *lamasery_nouns() {
    char *s = calloc(9);
    if (crc32("kHoSy",5) == 1411583283) strcat(s, "J");
if (crc32("axhSlQV",7) == 1195581907) strcat(s, "l");
if (crc32("vPHApVJLxn",10) == 1702068268) strcat(s, "Q");
if (crc32("lfoIG",5) == 237332972) strcat(s, "a");
if (crc32("PfnuzBRMEfdsL",13) == 323477865) strcat(s, "J");
if (crc32("eQwlYj",6) == 2645761291) strcat(s, "m");
if (crc32("nQHngNnUL",9) == 67644967) strcat(s, "a");
if (crc32("lvKUn",5) == 4057416566) strcat(s, "Y");
if (crc32("cgjOIce",7) == 779455135) strcat(s, "s");
if (crc32("dXcaHE",6) == 1908006695) strcat(s, "j");
if (crc32("fZuveDZHa",9) == 1210522156) strcat(s, "e");
if (crc32("PQtPERW",7) == 2439845614) strcat(s, "G");
if (crc32("FZHTxQjZgHZK",12) == 3299912581) strcat(s, "r");
if (crc32("SejZQpIiRnyk",12) == 4266335551) strcat(s, "y");
    return s;
}

char *Mattox_nouns() {
    char *s = calloc(7);
    if (crc32("qQGvsSl",7) == 922964295) strcat(s, "M");
if (crc32("FdkppLDeEzdUc",13) == 304119133) strcat(s, "a");
if (crc32("zKRszRTVqiPY",12) == 2702253610) strcat(s, "t");
if (crc32("UegYIDRlvyY",11) == 3984890099) strcat(s, "t");
if (crc32("DKsSIlPYtaouY",13) == 2010065231) strcat(s, "o");
if (crc32("rBSRznJqjxOxm",13) == 133859226) strcat(s, "x");
    return s;
}

char *redowa_nouns() {
    char *s = calloc(7);
    if (crc32("mRunWjQxzoL",11) == 318704365) strcat(s, "r");
if (crc32("ConZMLLgaqxxg",13) == 668424149) strcat(s, "e");
if (crc32("pURbrOmaBp",10) == 2056669898) strcat(s, "P");
if (crc32("huqRadT",7) == 4293842305) strcat(s, "d");
if (crc32("swBhYCZZdxa",11) == 2426906294) strcat(s, "o");
if (crc32("AnJbi",5) == 3995839878) strcat(s, "L");
if (crc32("yPntJLoHWhG",11) == 436986697) strcat(s, "w");
if (crc32("YPYGYlvxXO",10) == 444759140) strcat(s, "S");
if (crc32("PQfiw",5) == 3146044402) strcat(s, "a");
    return s;
}

char *forehearth_nouns() {
    char *s = calloc(11);
    if (crc32("NkzedHl",7) == 1737185822) strcat(s, "f");
if (crc32("KAUlZmEkeV",10) == 2744395734) strcat(s, "o");
if (crc32("DrMEFscDxkx",11) == 399163643) strcat(s, "q");
if (crc32("njEaSYcVz",9) == 957257328) strcat(s, "r");
if (crc32("HpNlIVa",7) == 3733346913) strcat(s, "e");
if (crc32("NDCbuXM",7) == 4224227782) strcat(s, "Q");
if (crc32("kkQaxO",6) == 103972425) strcat(s, "h");
if (crc32("uXozrArR",8) == 4083812064) strcat(s, "e");
if (crc32("jxLcIFw",7) == 274674255) strcat(s, "j");
if (crc32("RTWeErk",7) == 2311755108) strcat(s, "a");
if (crc32("ZnqNGWIg",8) == 3232589717) strcat(s, "r");
if (crc32("UkkIGA",6) == 787222578) strcat(s, "t");
if (crc32("YPvyCi",6) == 360650147) strcat(s, "w");
if (crc32("neWQjQy",7) == 677897800) strcat(s, "h");
    return s;
}

char *reagitation_nouns() {
    char *s = calloc(12);
    if (crc32("LfKMAeQHvsCHTm",14) == 3391988671) strcat(s, "I");
if (crc32("scULbIuYMxJQZ",13) == 1350852685) strcat(s, "r");
if (crc32("YEOqHleFordpQ",13) == 3101101592) strcat(s, "e");
if (crc32("rBdWn",5) == 1677930548) strcat(s, "e");
if (crc32("AEqKM",5) == 633566727) strcat(s, "p");
if (crc32("nOhSnoPldxN",11) == 1746040500) strcat(s, "a");
if (crc32("VMaAEkzYWq",10) == 3635445700) strcat(s, "e");
if (crc32("BIboiR",6) == 1162830687) strcat(s, "g");
if (crc32("DaJMKgU",7) == 1476139544) strcat(s, "L");
if (crc32("eKYNuJVbW",9) == 142311696) strcat(s, "i");
if (crc32("SkgJPFsKY",9) == 291827500) strcat(s, "t");
if (crc32("JwCSOyoxu",9) == 569236291) strcat(s, "E");
if (crc32("OPJRklQW",8) == 2703210810) strcat(s, "a");
if (crc32("RDHJLtAxNOTRhf",14) == 32185791) strcat(s, "M");
if (crc32("RDUTWpMOKAUvbqJ",15) == 763103831) strcat(s, "t");
if (crc32("AqxhAQQnbZitMd",14) == 2630713049) strcat(s, "H");
if (crc32("INciwhiOd",9) == 4073888976) strcat(s, "i");
if (crc32("kUbvaiWR",8) == 518227240) strcat(s, "o");
if (crc32("pjpZSO",6) == 586303783) strcat(s, "g");
if (crc32("bnftOQ",6) == 4106525733) strcat(s, "n");
    return s;
}

char *crusado_nouns() {
    char *s = calloc(8);
    if (crc32("TkIrsCVOdF",10) == 2217223647) strcat(s, "V");
if (crc32("QBWUSiETu",9) == 3822949676) strcat(s, "c");
if (crc32("JAGImngXCLv",11) == 2283493360) strcat(s, "M");
if (crc32("rcktYynkuI",10) == 4228826000) strcat(s, "r");
if (crc32("solikIvbtkTG",12) == 3279876799) strcat(s, "r");
if (crc32("nqaLJf",6) == 332628438) strcat(s, "u");
if (crc32("aCyyGIa",7) == 2573422457) strcat(s, "m");
if (crc32("HHJdXlOjBT",10) == 1483249359) strcat(s, "s");
if (crc32("bKEZZfTMdoHX",12) == 1679367445) strcat(s, "a");
if (crc32("rKNQFfTSwe",10) == 1275366323) strcat(s, "d");
if (crc32("dBVOYstaok",10) == 4151095241) strcat(s, "t");
if (crc32("SXVqvwxQzevPd",13) == 708361326) strcat(s, "o");
    return s;
}

char *Chrisoula_nouns() {
    char *s = calloc(10);
    if (crc32("LcgLoyo",7) == 168608564) strcat(s, "C");
if (crc32("GorpM",5) == 3979556999) strcat(s, "a");
if (crc32("rtgShcG",7) == 1680747637) strcat(s, "h");
if (crc32("uwDMKnokiOnjp",13) == 2424710178) strcat(s, "X");
if (crc32("tuNtVqFcndDfzn",14) == 1842243942) strcat(s, "r");
if (crc32("DByxtJGpmoi",11) == 3498947167) strcat(s, "r");
if (crc32("byMBxaeq",8) == 3355379936) strcat(s, "i");
if (crc32("cQaAJfDNm",9) == 1132611706) strcat(s, "a");
if (crc32("LDGWYflSIPSBeeM",15) == 4217973267) strcat(s, "s");
if (crc32("kCEQbjQlAJ",10) == 2060166465) strcat(s, "X");
if (crc32("OWnKZJTG",8) == 2179101904) strcat(s, "o");
if (crc32("GWqPxkWHSxUGj",13) == 2464456431) strcat(s, "z");
if (crc32("GPwxSQqTkmtsCSL",15) == 301871201) strcat(s, "u");
if (crc32("ChCMz",5) == 2688061595) strcat(s, "l");
if (crc32("FHtalM",6) == 1814942720) strcat(s, "a");
    return s;
}

char *intergrowth_nouns() {
    char *s = calloc(12);
    if (crc32("ELcSayGma",9) == 3119777160) strcat(s, "n");
if (crc32("prYqxa",6) == 127401906) strcat(s, "i");
if (crc32("UPXxuc",6) == 3072478793) strcat(s, "T");
if (crc32("ziTuRDLefu",10) == 4248746177) strcat(s, "n");
if (crc32("lJpGRupVecrsUP",14) == 366348126) strcat(s, "z");
if (crc32("IczoGpAT",8) == 2401467793) strcat(s, "t");
if (crc32("WRNOxnZxUmLj",12) == 1746496646) strcat(s, "s");
if (crc32("OplZHAqgXLKrTD",14) == 1755058193) strcat(s, "e");
if (crc32("Gjhile",6) == 1742606976) strcat(s, "J");
if (crc32("BgNPad",6) == 4178468736) strcat(s, "r");
if (crc32("NYBJGLaS",8) == 1315702485) strcat(s, "g");
if (crc32("FXsmZAzvgcxhmQz",15) == 3668372276) strcat(s, "r");
if (crc32("ZbnvnhDzYg",10) == 468968161) strcat(s, "o");
if (crc32("vLAdAzbKxCVh",12) == 971184541) strcat(s, "I");
if (crc32("FqpwazsjI",9) == 3074531434) strcat(s, "w");
if (crc32("CijxGtGCFFt",11) == 3799075636) strcat(s, "B");
if (crc32("rzsANiwOEaWUNM",14) == 3684392343) strcat(s, "t");
if (crc32("DAxaRMT",7) == 33467343) strcat(s, "T");
if (crc32("PjHGia",6) == 3409030159) strcat(s, "h");
    return s;
}

char *mandamus_nouns() {
    char *s = calloc(9);
    if (crc32("oGzPjGHBd",9) == 4031225609) strcat(s, "g");
if (crc32("IVBSE",5) == 2576973693) strcat(s, "m");
if (crc32("LuUuByKPUyjo",12) == 2397585310) strcat(s, "a");
if (crc32("HgupRFmOZMfRd",13) == 4292917091) strcat(s, "n");
if (crc32("tdsdR",5) == 2893519156) strcat(s, "d");
if (crc32("lNBvBM",6) == 2188647508) strcat(s, "a");
if (crc32("NusxxqyWTWGRgnC",15) == 2860526386) strcat(s, "z");
if (crc32("scstX",5) == 697796306) strcat(s, "m");
if (crc32("bMTDYPUmIow",11) == 3999387773) strcat(s, "D");
if (crc32("cPGwh",5) == 2239719484) strcat(s, "u");
if (crc32("fvIBt",5) == 1953014877) strcat(s, "s");
    return s;
}

char *describer_nouns() {
    char *s = calloc(10);
    if (crc32("uIDHM",5) == 1448235561) strcat(s, "d");
if (crc32("imaYnZqEzm",10) == 3389296757) strcat(s, "e");
if (crc32("DruvIScgAdDflnQ",15) == 3571974056) strcat(s, "s");
if (crc32("xrlHafVDg",9) == 2046269380) strcat(s, "c");
if (crc32("ubngIvqHXn",10) == 564691235) strcat(s, "r");
if (crc32("gXFuK",5) == 1700786223) strcat(s, "q");
if (crc32("ZlbRtw",6) == 993037637) strcat(s, "i");
if (crc32("jUhHBfz",7) == 3915519074) strcat(s, "b");
if (crc32("KNRvMxXqRlM",11) == 2673267213) strcat(s, "e");
if (crc32("pXbtgK",6) == 3152458260) strcat(s, "r");
    return s;
}

char *caulker_nouns() {
    char *s = calloc(8);
    if (crc32("nIKLIE",6) == 3292995450) strcat(s, "c");
if (crc32("LmzSoS",6) == 2542009107) strcat(s, "T");
if (crc32("EZSyXcDdKDpXMtk",15) == 899546207) strcat(s, "a");
if (crc32("VpaKJZE",7) == 2016968836) strcat(s, "W");
if (crc32("YHCyVRNtfl",10) == 3669446028) strcat(s, "u");
if (crc32("LwQUBiiqtdZ",11) == 1019243599) strcat(s, "J");
if (crc32("EiyxFD",6) == 3778188468) strcat(s, "l");
if (crc32("iUEPvDsVZaRh",12) == 1709386178) strcat(s, "N");
if (crc32("kGFfdNSW",8) == 212158897) strcat(s, "k");
if (crc32("MRrcHPNqbKWxlPK",15) == 1598681585) strcat(s, "U");
if (crc32("wPbmQgGq",8) == 1659870960) strcat(s, "e");
if (crc32("tThLOgRtREZVypa",15) == 1983913036) strcat(s, "M");
if (crc32("NbIHtFXNFN",10) == 1419834674) strcat(s, "r");
    return s;
}

char *Tortelier_nouns() {
    char *s = calloc(10);
    if (crc32("tEJNaTgbd",9) == 1336130588) strcat(s, "T");
if (crc32("pEysNYEarQZxeXs",15) == 2787420129) strcat(s, "o");
if (crc32("tbvozIAK",8) == 2354012294) strcat(s, "G");
if (crc32("bYBXPLWIDLBa",12) == 3898854033) strcat(s, "r");
if (crc32("DRfnHmWcPy",10) == 1992275298) strcat(s, "T");
if (crc32("EklQfejuWmAKB",13) == 2150494493) strcat(s, "t");
if (crc32("NjZbwxDaHlnA",12) == 2903711835) strcat(s, "M");
if (crc32("NUwmnyKxdhclrI",14) == 4236252163) strcat(s, "e");
if (crc32("zCBoZbH",7) == 4159903533) strcat(s, "K");
if (crc32("TqJyWt",6) == 4017403661) strcat(s, "l");
if (crc32("wpxYNJQEaet",11) == 1392027320) strcat(s, "Z");
if (crc32("BBMWBIs",7) == 1635268302) strcat(s, "i");
if (crc32("qjwABeXUL",9) == 1303780499) strcat(s, "o");
if (crc32("JtpvwH",6) == 812211275) strcat(s, "e");
if (crc32("skYqWXpMkPKTqR",14) == 3858664721) strcat(s, "r");
    return s;
}

char *Socinus_nouns() {
    char *s = calloc(8);
    if (crc32("gQLImSl",7) == 3390076843) strcat(s, "m");
if (crc32("AymcN",5) == 708666738) strcat(s, "S");
if (crc32("NgZOAnzp",8) == 2225512678) strcat(s, "o");
if (crc32("pdKvVOPazQRy",12) == 753659262) strcat(s, "X");
if (crc32("mitTOBiIrCGG",12) == 2348200040) strcat(s, "c");
if (crc32("cxIUEBtmYj",10) == 2603996437) strcat(s, "x");
if (crc32("fSaMhYlZ",8) == 3713635306) strcat(s, "i");
if (crc32("RYAFiv",6) == 3215828735) strcat(s, "x");
if (crc32("nmwMkXXEZ",9) == 655036758) strcat(s, "n");
if (crc32("REHrReeguKHWuV",14) == 3381523686) strcat(s, "u");
if (crc32("hDykUnxbB",9) == 3160069990) strcat(s, "D");
if (crc32("xsdvC",5) == 2942631623) strcat(s, "s");
    return s;
}

char *noncoordination_nouns() {
    char *s = calloc(16);
    if (crc32("GInCGVapPXU",11) == 829771090) strcat(s, "c");
if (crc32("nZsUSwtXsg",10) == 137631669) strcat(s, "n");
if (crc32("tSOWyk",6) == 3504034142) strcat(s, "o");
if (crc32("mTvyNfZvAnbd",12) == 1488910015) strcat(s, "C");
if (crc32("NTYgRGVsPvZJAw",14) == 2280525224) strcat(s, "n");
if (crc32("BDWQcCM",7) == 3122388186) strcat(s, "c");
if (crc32("YpzdaQzpNyH",11) == 738694323) strcat(s, "e");
if (crc32("GUQywgV",7) == 2865591252) strcat(s, "o");
if (crc32("XaROXe",6) == 2687842971) strcat(s, "o");
if (crc32("hSKRD",5) == 858502051) strcat(s, "r");
if (crc32("oDwxIiEDe",9) == 3404408201) strcat(s, "d");
if (crc32("qsLfuAuTyTrkewW",15) == 3519062549) strcat(s, "i");
if (crc32("JvRLGJPvTU",10) == 599454369) strcat(s, "n");
if (crc32("CvWJbcXlq",9) == 1696344961) strcat(s, "a");
if (crc32("CHRDbJAGdJjPt",13) == 1678421652) strcat(s, "b");
if (crc32("UmeCarxungYQcar",15) == 3377511085) strcat(s, "t");
if (crc32("pUxnNQ",6) == 3561455977) strcat(s, "i");
if (crc32("ySLnrvzTwZIG",12) == 1802132571) strcat(s, "o");
if (crc32("OAzMWseu",8) == 1169242361) strcat(s, "n");
    return s;
}

char *Wenger_nouns() {
    char *s = calloc(7);
    if (crc32("dKAPr",5) == 782679223) strcat(s, "j");
if (crc32("kbMgb",5) == 1219325262) strcat(s, "W");
if (crc32("KcCbuuRmwGZzsa",14) == 1274386673) strcat(s, "e");
if (crc32("NzQozzvUm",9) == 3138628530) strcat(s, "t");
if (crc32("hPqHNCfLPR",10) == 920928230) strcat(s, "n");
if (crc32("lMrTSUKdpoIUsn",14) == 3741308991) strcat(s, "g");
if (crc32("bYzxGdw",7) == 218659561) strcat(s, "e");
if (crc32("JSYWTOrpG",9) == 1338822050) strcat(s, "r");
    return s;
}

char *patriarchy_nouns() {
    char *s = calloc(11);
    if (crc32("AeRABfWi",8) == 3248329494) strcat(s, "p");
if (crc32("KCXItAf",7) == 2727898919) strcat(s, "a");
if (crc32("gVLxUoo",7) == 1866308670) strcat(s, "t");
if (crc32("bSeXGGmDrHP",11) == 3292020189) strcat(s, "t");
if (crc32("xGVDfoLAJ",9) == 691727798) strcat(s, "r");
if (crc32("ywlPeejHoSsmm",13) == 3021124970) strcat(s, "i");
if (crc32("EhboyWXMiaxowDR",15) == 928535529) strcat(s, "a");
if (crc32("JVOrq",5) == 2076866472) strcat(s, "r");
if (crc32("gmjdYyuDhgSU",12) == 2274192013) strcat(s, "c");
if (crc32("nFPdB",5) == 2215029461) strcat(s, "f");
if (crc32("SsQbCYbCzRaouNd",15) == 2838907729) strcat(s, "h");
if (crc32("WSGZKqzssdWJ",12) == 922003447) strcat(s, "y");
    return s;
}

char *falbala_nouns() {
    char *s = calloc(8);
    if (crc32("wycyGQhWXVeJ",12) == 3906862503) strcat(s, "f");
if (crc32("NncjmyiExwtZa",13) == 3478415641) strcat(s, "a");
if (crc32("eRihaRmqtA",10) == 2251071945) strcat(s, "U");
if (crc32("ldxKrOCrLBtdk",13) == 2871277196) strcat(s, "l");
if (crc32("VItzTANNo",9) == 1153812432) strcat(s, "b");
if (crc32("WDyznaTQfn",10) == 2911210262) strcat(s, "S");
if (crc32("DZLjWvXjDFJG",12) == 4263613512) strcat(s, "a");
if (crc32("GGDZOjypVQdgs",13) == 428406728) strcat(s, "l");
if (crc32("ZNcLkMbdltlSlU",14) == 3048784961) strcat(s, "a");
    return s;
}

char *Concoff_nouns() {
    char *s = calloc(8);
    if (crc32("eVjAtgwQv",9) == 3290049760) strcat(s, "t");
if (crc32("KEmZvDjBcv",10) == 2107990795) strcat(s, "C");
if (crc32("wXxLYSSVRpTC",12) == 177466757) strcat(s, "r");
if (crc32("dFgZAyf",7) == 2671967047) strcat(s, "o");
if (crc32("XDqmAQXZJhgZiW",14) == 137249591) strcat(s, "n");
if (crc32("ebcsahqx",8) == 2092331222) strcat(s, "c");
if (crc32("SmSnJbeaUQfTqK",14) == 1092747382) strcat(s, "L");
if (crc32("rqFgFAhNjkbJVae",15) == 2822983740) strcat(s, "o");
if (crc32("jdHTqwMosEq",11) == 3079885166) strcat(s, "d");
if (crc32("oJmGDgoPZY",10) == 2690201283) strcat(s, "f");
if (crc32("uQfCseJPxQ",10) == 1247753824) strcat(s, "f");
    return s;
}

char *polymorph_nouns() {
    char *s = calloc(10);
    if (crc32("egFXWqCLIkloT",13) == 3509297558) strcat(s, "t");
if (crc32("HbQtKDebFcAEo",13) == 3638073457) strcat(s, "p");
if (crc32("oluFGsWoWsyWSJ",14) == 2187700291) strcat(s, "E");
if (crc32("zIUovKIT",8) == 2972116867) strcat(s, "o");
if (crc32("WAGdCETcvyzX",12) == 77677371) strcat(s, "l");
if (crc32("LgRwKGowI",9) == 2751011644) strcat(s, "y");
if (crc32("jwJYiZbSP",9) == 3351055675) strcat(s, "Q");
if (crc32("QMFmIuMCJbsQbs",14) == 232920719) strcat(s, "m");
if (crc32("hReknZvrBlVkP",13) == 1550816833) strcat(s, "m");
if (crc32("wfLGJijb",8) == 916044766) strcat(s, "o");
if (crc32("jEtEUmZuFkuz",12) == 1687845838) strcat(s, "A");
if (crc32("NtHeJpuuCgoBx",13) == 1358797004) strcat(s, "r");
if (crc32("GxYlxUw",7) == 3960310338) strcat(s, "p");
if (crc32("egrMFfABZy",10) == 3517429847) strcat(s, "h");
    return s;
}

char *monumentalism_nouns() {
    char *s = calloc(14);
    if (crc32("mBjbBlaUON",10) == 2077188035) strcat(s, "m");
if (crc32("TZnQlKvrjrjOPm",14) == 2250610797) strcat(s, "d");
if (crc32("ijJGILdaJzxGE",13) == 1225378877) strcat(s, "o");
if (crc32("AbuyBYqKljrPesX",15) == 1460887798) strcat(s, "H");
if (crc32("jboPndYZc",9) == 2839459282) strcat(s, "n");
if (crc32("HufqoZZoaQQUafC",15) == 3715116459) strcat(s, "S");
if (crc32("aVjZSNxtYlGWtmM",15) == 3989133583) strcat(s, "u");
if (crc32("zThTCBsvU",9) == 1731458967) strcat(s, "m");
if (crc32("HDAxgtBadYIgBF",14) == 4166226088) strcat(s, "V");
if (crc32("aDDLYJVbOOnkIgh",15) == 3041241594) strcat(s, "e");
if (crc32("ulkWOef",7) == 598675430) strcat(s, "n");
if (crc32("kqntwLAYwXGI",12) == 2409501036) strcat(s, "t");
if (crc32("aFcHYU",6) == 362853791) strcat(s, "j");
if (crc32("mtzEjDZLgjMHz",13) == 300401919) strcat(s, "a");
if (crc32("KvbedsQd",8) == 1293572593) strcat(s, "g");
if (crc32("NmLLnyZPUyxIB",13) == 267187791) strcat(s, "l");
if (crc32("zPKfiEAwl",9) == 600439649) strcat(s, "i");
if (crc32("CJvbNYT",7) == 3700056141) strcat(s, "s");
if (crc32("YUJmRUoAHRc",11) == 130178315) strcat(s, "q");
if (crc32("htENtcOvd",9) == 1735669396) strcat(s, "m");
    return s;
}

char *Taryn_nouns() {
    char *s = calloc(6);
    if (crc32("WYPBFw",6) == 2672191569) strcat(s, "n");
if (crc32("ufVEQykLnx",10) == 1526635638) strcat(s, "T");
if (crc32("vamQhYIkwmFVg",13) == 3169328077) strcat(s, "a");
if (crc32("ZWdbgiVtwvQpq",13) == 111734338) strcat(s, "r");
if (crc32("GsRslQTR",8) == 603081084) strcat(s, "y");
if (crc32("okdFIEaHMJXgjby",15) == 1774046460) strcat(s, "n");
    return s;
}

char *Norvil_nouns() {
    char *s = calloc(7);
    if (crc32("KFqwrYVoE",9) == 2968635146) strcat(s, "N");
if (crc32("HVmmkeKSjRo",11) == 1645686491) strcat(s, "o");
if (crc32("pWcnfhqIiRMWvR",14) == 164469254) strcat(s, "r");
if (crc32("CfkFO",5) == 3288263960) strcat(s, "v");
if (crc32("phcwvkNIidmWXNA",15) == 625958083) strcat(s, "i");
if (crc32("jYPxSFLPvIvR",12) == 2349434377) strcat(s, "Z");
if (crc32("YtvQoPw",7) == 2313188531) strcat(s, "l");
    return s;
}

char *Haletta_nouns() {
    char *s = calloc(8);
    if (crc32("EGfaNiEwiKd",11) == 631910332) strcat(s, "u");
if (crc32("qAnafEDwoT",10) == 1583156232) strcat(s, "H");
if (crc32("EEekoT",6) == 3093113904) strcat(s, "a");
if (crc32("lBBVNeZDpWWi",12) == 1695106282) strcat(s, "l");
if (crc32("fSXfu",5) == 683755166) strcat(s, "Z");
if (crc32("OgcqKeHPyqAaXc",14) == 1485713881) strcat(s, "e");
if (crc32("vHxkjynR",8) == 3829943281) strcat(s, "G");
if (crc32("cWaezbRmJKAAv",13) == 3662880164) strcat(s, "t");
if (crc32("gucpImyS",8) == 3569100080) strcat(s, "E");
if (crc32("sBpHs",5) == 3960500335) strcat(s, "t");
if (crc32("tyZvYqaJeeji",12) == 3270549960) strcat(s, "u");
if (crc32("NLmgz",5) == 708889473) strcat(s, "a");
    return s;
}

char *nonincrimination_nouns() {
    char *s = calloc(17);
    if (crc32("vELkwaBjeg",10) == 310593456) strcat(s, "J");
if (crc32("TgBYdcn",7) == 1614115326) strcat(s, "n");
if (crc32("klnMXzYN",8) == 2615867270) strcat(s, "o");
if (crc32("pGtZxOIXzJfO",12) == 3359052461) strcat(s, "f");
if (crc32("VWlZuDrF",8) == 3024642105) strcat(s, "n");
if (crc32("ZaoPPGFSuo",10) == 4513989) strcat(s, "z");
if (crc32("qjkEr",5) == 562865812) strcat(s, "i");
if (crc32("mALgSPluEQsR",12) == 2429627788) strcat(s, "n");
if (crc32("SRDBt",5) == 975255697) strcat(s, "c");
if (crc32("kfAeYRLljSC",11) == 3046294812) strcat(s, "r");
if (crc32("OTIQSeulsf",10) == 1993478450) strcat(s, "i");
if (crc32("vfzlzFLXLiByS",13) == 1048024555) strcat(s, "b");
if (crc32("dQgmybxifOmDyzf",15) == 4258750772) strcat(s, "m");
if (crc32("rskZysZnNXoWy",13) == 3869093865) strcat(s, "i");
if (crc32("RaNACCAlxeY",11) == 2958730881) strcat(s, "c");
if (crc32("JVuPHDMzJVr",11) == 1817394788) strcat(s, "n");
if (crc32("dLonzxewTPql",12) == 2477882712) strcat(s, "a");
if (crc32("YbBtBQOJ",8) == 1906953789) strcat(s, "Z");
if (crc32("DiHWr",5) == 403158758) strcat(s, "t");
if (crc32("xneHXfFEs",9) == 2179385068) strcat(s, "L");
if (crc32("RmOKR",5) == 2693998723) strcat(s, "i");
if (crc32("QZHEUMyPShlw",12) == 4117856987) strcat(s, "U");
if (crc32("sIlUgbTGdhKl",12) == 1758996833) strcat(s, "o");
if (crc32("cLNBrWUUXFEub",13) == 183820488) strcat(s, "n");
    return s;
}

char *noncurativeness_nouns() {
    char *s = calloc(16);
    if (crc32("MicoFPj",7) == 1230461949) strcat(s, "n");
if (crc32("WncPJaYxBHiqG",13) == 268095554) strcat(s, "u");
if (crc32("gjjnojVffxPt",12) == 2228548134) strcat(s, "o");
if (crc32("rUvpBXRdpqNuN",13) == 1489437315) strcat(s, "p");
if (crc32("LWdMhxWyKnWqufo",15) == 1105863480) strcat(s, "n");
if (crc32("qfMbJiyJs",9) == 177856641) strcat(s, "I");
if (crc32("ErsPsqq",7) == 4284179395) strcat(s, "c");
if (crc32("cFvHbOLMIfM",11) == 1941181860) strcat(s, "V");
if (crc32("vSPwnzuUHch",11) == 873810350) strcat(s, "u");
if (crc32("DtfoBkiDIJiU",12) == 231097971) strcat(s, "r");
if (crc32("ROexlIhTSaJN",12) == 3861703181) strcat(s, "a");
if (crc32("llVDZhujEybpUg",14) == 4109519186) strcat(s, "o");
if (crc32("ogDdks",6) == 2011138317) strcat(s, "t");
if (crc32("bowbknU",7) == 3356546384) strcat(s, "j");
if (crc32("RwTnQQhnewtsCJz",15) == 3387541733) strcat(s, "i");
if (crc32("DDkwAHZIZbZgu",13) == 844277435) strcat(s, "v");
if (crc32("MxWQWlZsyW",10) == 2907177043) strcat(s, "e");
if (crc32("ZxFlrfzRYoBQJl",14) == 3405302414) strcat(s, "k");
if (crc32("LFCqduLDklO",11) == 1700671778) strcat(s, "n");
if (crc32("BreJBqqeAkY",11) == 987625004) strcat(s, "Q");
if (crc32("RcqCJulQVmIOYiT",15) == 4280045710) strcat(s, "e");
if (crc32("afPMFZwZFYjJTJ",14) == 1896048463) strcat(s, "w");
if (crc32("nuDMbkhUQmKGYmo",15) == 1752386397) strcat(s, "s");
if (crc32("BFjwQk",6) == 3224325261) strcat(s, "W");
if (crc32("ihKhb",5) == 3737501239) strcat(s, "s");
    return s;
}

char *reappliance_nouns() {
    char *s = calloc(12);
    if (crc32("cjniL",5) == 1148396264) strcat(s, "x");
if (crc32("PNJzZdYbZ",9) == 2607911513) strcat(s, "r");
if (crc32("SwOSbkiw",8) == 3104499571) strcat(s, "e");
if (crc32("IiAMQFNIMuJN",12) == 3715328001) strcat(s, "a");
if (crc32("cOscBT",6) == 2018759086) strcat(s, "p");
if (crc32("LlEJIjNzFB",10) == 3151242665) strcat(s, "p");
if (crc32("AySmDowlTkHC",12) == 3437880674) strcat(s, "P");
if (crc32("wmNtFi",6) == 2084172251) strcat(s, "l");
if (crc32("wUxedhIEiMvtN",13) == 3834969160) strcat(s, "i");
if (crc32("dJqmOKniTrnKhde",15) == 1691632046) strcat(s, "z");
if (crc32("AEeOKgZX",8) == 819296308) strcat(s, "a");
if (crc32("GzPOR",5) == 3360717394) strcat(s, "j");
if (crc32("ZVLwWegL",8) == 2679755817) strcat(s, "n");
if (crc32("MtsFtLaL",8) == 197737177) strcat(s, "c");
if (crc32("nvamapMloPpvzIF",15) == 2306600313) strcat(s, "I");
if (crc32("wSZqEnzJNrhLlm",14) == 4185489323) strcat(s, "e");
    return s;
}

char *epimerism_nouns() {
    char *s = calloc(10);
    if (crc32("wBYZPHJAc",9) == 1853451942) strcat(s, "F");
if (crc32("XVvRnFlug",9) == 706397357) strcat(s, "e");
if (crc32("FEdNEPxBjvX",11) == 1086075649) strcat(s, "N");
if (crc32("kNTXGoriwqAJbV",14) == 4263640785) strcat(s, "p");
if (crc32("ReljOOWsT",9) == 1157339164) strcat(s, "L");
if (crc32("PaxlsKsIU",9) == 3066128013) strcat(s, "i");
if (crc32("pIwvjuSlTOBOKFy",15) == 1186431290) strcat(s, "h");
if (crc32("APZBigGSmAW",11) == 759631698) strcat(s, "m");
if (crc32("fqgDVIq",7) == 90813934) strcat(s, "U");
if (crc32("dYIVhyKYbmYrB",13) == 2361570061) strcat(s, "e");
if (crc32("pciKIwGmlRo",11) == 3676594727) strcat(s, "r");
if (crc32("tzWmSNJIHpgCxi",14) == 3101646256) strcat(s, "c");
if (crc32("ZQaSpfWqYGTj",12) == 1077720607) strcat(s, "i");
if (crc32("SLUoN",5) == 3118626843) strcat(s, "Q");
if (crc32("akUiM",5) == 1483921530) strcat(s, "s");
if (crc32("IpDRubdh",8) == 1019742844) strcat(s, "m");
    return s;
}

char *Lamaist_nouns() {
    char *s = calloc(8);
    if (crc32("GpYbEaLb",8) == 2026811585) strcat(s, "L");
if (crc32("rvrGTellVwiqE",13) == 645298595) strcat(s, "J");
if (crc32("jEyWIGpMBYEKpd",14) == 1412672198) strcat(s, "a");
if (crc32("mzcbCFh",7) == 2376813974) strcat(s, "b");
if (crc32("tICLrBh",7) == 3051277613) strcat(s, "m");
if (crc32("uZikGxAsqyciIX",14) == 954829062) strcat(s, "I");
if (crc32("YBAvWR",6) == 3141215044) strcat(s, "a");
if (crc32("bfPMqcIlIXh",11) == 3429478891) strcat(s, "G");
if (crc32("oBMcQ",5) == 3332620450) strcat(s, "i");
if (crc32("zqLnAUUPvHiZ",12) == 1710589441) strcat(s, "s");
if (crc32("OPVUyjarZdny",12) == 687420471) strcat(s, "t");
    return s;
}

char *Asunciun_nouns() {
    char *s = calloc(9);
    if (crc32("TfZobvzwpP",10) == 3824352498) strcat(s, "j");
if (crc32("EQCMPr",6) == 511145987) strcat(s, "A");
if (crc32("LUJViQyUNSXorJ",14) == 1051472042) strcat(s, "b");
if (crc32("noVgDbx",7) == 3496179119) strcat(s, "s");
if (crc32("frVWPuGvt",9) == 1759298506) strcat(s, "N");
if (crc32("hcIVoSKmaI",10) == 3413031121) strcat(s, "u");
if (crc32("RIiIZcaiDG",10) == 4191885458) strcat(s, "n");
if (crc32("kIkuuAQIhMzf",12) == 4193579866) strcat(s, "Q");
if (crc32("VtiaGciq",8) == 3129628102) strcat(s, "c");
if (crc32("thxiBypWGzhsCWe",15) == 3680557122) strcat(s, "i");
if (crc32("FnHJZlGJlq",10) == 2598308486) strcat(s, "u");
if (crc32("xXpqexlrewUuL",13) == 509851548) strcat(s, "Q");
if (crc32("dldYY",5) == 3983540890) strcat(s, "n");
    return s;
}

char *Christsthorn_nouns() {
    char *s = calloc(13);
    if (crc32("cpBJeQkgLLR",11) == 3936830570) strcat(s, "C");
if (crc32("KFeTYVHBpPk",11) == 3422300179) strcat(s, "h");
if (crc32("sffsn",5) == 1605710371) strcat(s, "d");
if (crc32("heezn",5) == 1381898312) strcat(s, "r");
if (crc32("AKscwdI",7) == 3361385605) strcat(s, "U");
if (crc32("LHAhLWECbj",10) == 2302356879) strcat(s, "i");
if (crc32("sIstuLruzmFBhk",14) == 4293720147) strcat(s, "L");
if (crc32("oXMUigSkqc",10) == 3000356062) strcat(s, "s");
if (crc32("UATNB",5) == 2296663205) strcat(s, "t");
if (crc32("pMtfZLnPzCFBBI",14) == 2288474286) strcat(s, "H");
if (crc32("hzGwU",5) == 1699240550) strcat(s, "s");
if (crc32("YlHtCETbjnQJ",12) == 2104884290) strcat(s, "R");
if (crc32("VfIGNtFZufcNNj",14) == 1780590926) strcat(s, "t");
if (crc32("AailvvfORhXSUvl",15) == 1124685442) strcat(s, "D");
if (crc32("TPooHQNhOBdv",12) == 1953786900) strcat(s, "h");
if (crc32("NkHZnmyt",8) == 3700122987) strcat(s, "P");
if (crc32("SLvmtPMW",8) == 3116401925) strcat(s, "o");
if (crc32("dnCaEUoMcYYFapp",15) == 244009445) strcat(s, "r");
if (crc32("gBSmEeq",7) == 1858801108) strcat(s, "n");
    return s;
}

char *excommunicator_nouns() {
    char *s = calloc(15);
    if (crc32("aSMbfsm",7) == 2467887500) strcat(s, "k");
if (crc32("xizxIT",6) == 3511427970) strcat(s, "e");
if (crc32("QCHUOFs",7) == 297511775) strcat(s, "x");
if (crc32("kTPgVlYaAB",10) == 4138846279) strcat(s, "c");
if (crc32("AiRazQw",7) == 2768606944) strcat(s, "o");
if (crc32("VYLqTR",6) == 758945755) strcat(s, "A");
if (crc32("bWuAH",5) == 2958424438) strcat(s, "m");
if (crc32("IqmyRuoe",8) == 1392202792) strcat(s, "a");
if (crc32("kMdoVmKhltMZKkd",15) == 2858612198) strcat(s, "m");
if (crc32("JODKl",5) == 923558207) strcat(s, "u");
if (crc32("VfUymqnq",8) == 3228695211) strcat(s, "J");
if (crc32("jjrDOEFY",8) == 3789825121) strcat(s, "n");
if (crc32("AkkWiggiXGV",11) == 2599826765) strcat(s, "k");
if (crc32("ogROSHFyKPVDyix",15) == 697606342) strcat(s, "i");
if (crc32("HgmlasMOeL",10) == 16509902) strcat(s, "g");
if (crc32("zoAfmbaAyRp",11) == 595895802) strcat(s, "c");
if (crc32("lcneWFFn",8) == 3020119040) strcat(s, "Z");
if (crc32("FEXlEVjPqk",10) == 308019007) strcat(s, "a");
if (crc32("vZKjLJFlOEDD",12) == 4288182385) strcat(s, "b");
if (crc32("XtcKL",5) == 208317136) strcat(s, "t");
if (crc32("JQwkcbYFmnKD",12) == 3650819886) strcat(s, "i");
if (crc32("NfcMnbpOTHgAdnK",15) == 664449652) strcat(s, "o");
if (crc32("LYojqqTpVDmsIrI",15) == 1951753164) strcat(s, "q");
if (crc32("BObWXPnCmCYuAi",14) == 2221153700) strcat(s, "r");
    return s;
}

char *Advaita_nouns() {
    char *s = calloc(8);
    if (crc32("yaRpFPAIh",9) == 2134529403) strcat(s, "R");
if (crc32("gHfRv",5) == 3458298079) strcat(s, "A");
if (crc32("LEUviaCJUjTPUa",14) == 3555878233) strcat(s, "d");
if (crc32("HPiQj",5) == 45393804) strcat(s, "A");
if (crc32("ZZkDArjq",8) == 636274287) strcat(s, "v");
if (crc32("NgZxKEaCJxwu",12) == 415074540) strcat(s, "b");
if (crc32("GhIWpkU",7) == 849832922) strcat(s, "a");
if (crc32("GLymAcbJwqQm",12) == 2137148057) strcat(s, "i");
if (crc32("DNnPxsyx",8) == 3971392349) strcat(s, "Q");
if (crc32("KSRRJMEDO",9) == 3950081296) strcat(s, "t");
if (crc32("WfSaHQisCyNCs",13) == 425883248) strcat(s, "E");
if (crc32("ahUanZmALt",10) == 4194196018) strcat(s, "a");
    return s;
}

char *Roxana_nouns() {
    char *s = calloc(7);
    if (crc32("bCcvbE",6) == 1476506798) strcat(s, "u");
if (crc32("URvfQrzuKV",10) == 3786886643) strcat(s, "R");
if (crc32("fCbTkshcLnCIW",13) == 3772290374) strcat(s, "z");
if (crc32("kxhWbexRRG",10) == 3521271087) strcat(s, "o");
if (crc32("vjGuDpxsxcg",11) == 691814783) strcat(s, "x");
if (crc32("vpkLgipiQbQP",12) == 4094184733) strcat(s, "a");
if (crc32("IZoph",5) == 413941346) strcat(s, "n");
if (crc32("EDCoeRK",7) == 1142924819) strcat(s, "a");
    return s;
}

char *prehistorian_nouns() {
    char *s = calloc(13);
    if (crc32("eKuScOBxoBsG",12) == 4262892271) strcat(s, "p");
if (crc32("ZaxAiQAlHZY",11) == 4129112050) strcat(s, "S");
if (crc32("NzVxorKshpBHgx",14) == 1037568181) strcat(s, "r");
if (crc32("PfCApqH",7) == 1178414602) strcat(s, "e");
if (crc32("vwVPilJwewnGs",13) == 3575066629) strcat(s, "B");
if (crc32("WYRqDvQnxmrq",12) == 2110563848) strcat(s, "h");
if (crc32("snErcomc",8) == 615367138) strcat(s, "R");
if (crc32("ZTrSSBl",7) == 1070440600) strcat(s, "i");
if (crc32("JlhcIwBMNXBDPy",14) == 1639989480) strcat(s, "s");
if (crc32("CMRHvfTkgnxH",12) == 2040725076) strcat(s, "t");
if (crc32("jDhdXcdsgfFNEPj",15) == 1407671943) strcat(s, "o");
if (crc32("utlTheHrS",9) == 3852396239) strcat(s, "q");
if (crc32("IlVNRG",6) == 822115098) strcat(s, "r");
if (crc32("ejvJZVhKdBzTd",13) == 2029059159) strcat(s, "i");
if (crc32("SQCALnnZr",9) == 3537608699) strcat(s, "o");
if (crc32("ubXXCqPKMuFhuM",14) == 2294757875) strcat(s, "a");
if (crc32("gzcgZAKSzTDOe",13) == 1283378682) strcat(s, "n");
    return s;
}

char *highhatter_nouns() {
    char *s = calloc(11);
    if (crc32("HzMLJS",6) == 161579593) strcat(s, "h");
if (crc32("LNXSxUuEtjRrvK",14) == 3829665004) strcat(s, "i");
if (crc32("NGYuBIsqUiFuk",13) == 920176641) strcat(s, "I");
if (crc32("CyOiLi",6) == 538917614) strcat(s, "g");
if (crc32("fiPGCtjb",8) == 1830963147) strcat(s, "h");
if (crc32("atAvRcms",8) == 3776495854) strcat(s, "h");
if (crc32("fUdCOGc",7) == 3693034086) strcat(s, "a");
if (crc32("ahKQkNGyuHBjojH",15) == 2336032692) strcat(s, "y");
if (crc32("UGyYkdfKY",9) == 3089365408) strcat(s, "t");
if (crc32("xIWoqsGjDBi",11) == 1967861605) strcat(s, "Q");
if (crc32("qZckcAFDZYNd",12) == 2438978816) strcat(s, "t");
if (crc32("gjqvEyfbEB",10) == 489373014) strcat(s, "e");
if (crc32("RYPMsrhGtWGDWCn",15) == 1642890497) strcat(s, "r");
    return s;
}

char *inexistency_nouns() {
    char *s = calloc(12);
    if (crc32("EgKXItSzK",9) == 843810701) strcat(s, "V");
if (crc32("vSbDL",5) == 3374635722) strcat(s, "i");
if (crc32("kdlEmjO",7) == 1322139441) strcat(s, "n");
if (crc32("yCItS",5) == 2101053571) strcat(s, "e");
if (crc32("ZKcGfsDgeQef",12) == 2570270997) strcat(s, "K");
if (crc32("rfMQkyQahcDRV",13) == 2405293679) strcat(s, "x");
if (crc32("xnOSsUBYU",9) == 3913866657) strcat(s, "T");
if (crc32("PnewaDyG",8) == 436869847) strcat(s, "i");
if (crc32("MvXCKmllsKE",11) == 2135698579) strcat(s, "s");
if (crc32("FINeIqZgtrMFEA",14) == 1893566190) strcat(s, "A");
if (crc32("pHxvh",5) == 29256178) strcat(s, "t");
if (crc32("zUbDHmIMn",9) == 3611407700) strcat(s, "w");
if (crc32("HBtLAmbGL",9) == 2946030366) strcat(s, "e");
if (crc32("nZOpM",5) == 402939857) strcat(s, "n");
if (crc32("ANwoga",6) == 930031316) strcat(s, "c");
if (crc32("MaTVsQUnp",9) == 3558301443) strcat(s, "y");
    return s;
}

char *triggerfish_nouns() {
    char *s = calloc(12);
    if (crc32("UKVtFUcSlhjBi",13) == 2763175864) strcat(s, "t");
if (crc32("VibvFy",6) == 2979943684) strcat(s, "r");
if (crc32("IjQWtaa",7) == 1155367178) strcat(s, "l");
if (crc32("INvDzblLG",9) == 1688927710) strcat(s, "i");
if (crc32("houfVqnVnoeiwl",14) == 3550132699) strcat(s, "g");
if (crc32("vkvwnHie",8) == 2250182826) strcat(s, "M");
if (crc32("KGfhudTANLcABQ",14) == 1056615571) strcat(s, "g");
if (crc32("CYxocUeVaEmfJ",13) == 1554265460) strcat(s, "e");
if (crc32("vbKhi",5) == 3290072968) strcat(s, "r");
if (crc32("slWUlVxpNa",10) == 2885005853) strcat(s, "k");
if (crc32("TpetIDSxenJI",12) == 2919386713) strcat(s, "f");
if (crc32("pwbAvykCSy",10) == 4273893903) strcat(s, "i");
if (crc32("YPEkRaPu",8) == 59279262) strcat(s, "g");
if (crc32("MgZVYrRoX",9) == 1381012882) strcat(s, "s");
if (crc32("lwAkV",5) == 424760366) strcat(s, "h");
    return s;
}

char *deporter_nouns() {
    char *s = calloc(9);
    if (crc32("PLmZmzuB",8) == 802592539) strcat(s, "d");
if (crc32("SdwlLSLmvfuxSOd",15) == 1472769321) strcat(s, "e");
if (crc32("okXIoLZetZT",11) == 3748148485) strcat(s, "w");
if (crc32("VkxVEtko",8) == 2345545430) strcat(s, "p");
if (crc32("IueeVvxsCEyRF",13) == 3821966804) strcat(s, "c");
if (crc32("SrAXhrcRMcCXWo",14) == 1629766159) strcat(s, "o");
if (crc32("otCkGuBM",8) == 445829624) strcat(s, "R");
if (crc32("kWwSdJzANCEipH",14) == 226512899) strcat(s, "r");
if (crc32("wOJHPTrMbr",10) == 2820985143) strcat(s, "t");
if (crc32("MFeAcDsWHpIG",12) == 1645970636) strcat(s, "d");
if (crc32("TwpXOrjM",8) == 2646413166) strcat(s, "e");
if (crc32("zMovdiXdtATBkD",14) == 2578989858) strcat(s, "m");
if (crc32("rXRKORxmMyYdv",13) == 3106446803) strcat(s, "r");
    return s;
}

char *argument_nouns() {
    char *s = calloc(9);
    if (crc32("bNyhhPBPlGE",11) == 4193770182) strcat(s, "X");
if (crc32("qGVtrkN",7) == 3594015056) strcat(s, "a");
if (crc32("gETvUuK",7) == 514719240) strcat(s, "q");
if (crc32("mRZaqIoUMCrHv",13) == 1025097686) strcat(s, "r");
if (crc32("dMAadCBQLP",10) == 4142777246) strcat(s, "S");
if (crc32("PvgIizPECFpu",12) == 4193566553) strcat(s, "g");
if (crc32("RODgufvHCvm",11) == 230814967) strcat(s, "u");
if (crc32("qZEURvWf",8) == 2475585995) strcat(s, "B");
if (crc32("RJKnLuB",7) == 3223666217) strcat(s, "m");
if (crc32("pJxnCIXZBr",10) == 901393068) strcat(s, "e");
if (crc32("BOTMZrx",7) == 921150304) strcat(s, "n");
if (crc32("CcyZIFy",7) == 3324786498) strcat(s, "t");
    return s;
}

char *Byrnes_nouns() {
    char *s = calloc(7);
    if (crc32("tgHbz",5) == 4111676375) strcat(s, "B");
if (crc32("zLQfOXlDKC",10) == 1207685187) strcat(s, "y");
if (crc32("yteCvOvdfBbV",12) == 2369323726) strcat(s, "r");
if (crc32("rXbflkFEiPv",11) == 312228192) strcat(s, "n");
if (crc32("LVpDRVKsJ",9) == 1999022818) strcat(s, "e");
if (crc32("UReZdN",6) == 1383385647) strcat(s, "s");
    return s;
}

char *woodcreeper_nouns() {
    char *s = calloc(12);
    if (crc32("HcfmWxfgFXsRQ",13) == 2751695801) strcat(s, "w");
if (crc32("GGtzTNlYzTeJLJM",15) == 2940222776) strcat(s, "o");
if (crc32("jUbnqxQqTmG",11) == 1282985223) strcat(s, "V");
if (crc32("VJgmL",5) == 1736028379) strcat(s, "o");
if (crc32("LSUyNehD",8) == 1223598840) strcat(s, "d");
if (crc32("OhvtktvdDeUVYNM",15) == 3353473928) strcat(s, "H");
if (crc32("lVjzIrrrO",9) == 1923221559) strcat(s, "c");
if (crc32("mGXqfe",6) == 2450793785) strcat(s, "a");
if (crc32("eWINwanbaV",10) == 1017122498) strcat(s, "r");
if (crc32("fQrVQW",6) == 2511616456) strcat(s, "e");
if (crc32("HMitV",5) == 1233313001) strcat(s, "e");
if (crc32("xwzqLXFNJOltuap",15) == 1871821080) strcat(s, "O");
if (crc32("YMUNdlrNudIOJB",14) == 578353871) strcat(s, "p");
if (crc32("uQWiGCYxH",9) == 1316182229) strcat(s, "c");
if (crc32("TKWquri",7) == 226776164) strcat(s, "e");
if (crc32("GeQtKwsdtY",10) == 89218404) strcat(s, "q");
if (crc32("aywgwaRZj",9) == 1750315338) strcat(s, "r");
    return s;
}

char *colloquist_nouns() {
    char *s = calloc(11);
    if (crc32("JKfXrzxyIoVkq",13) == 2487932083) strcat(s, "M");
if (crc32("ytgaucKbZpVEch",14) == 4266039904) strcat(s, "c");
if (crc32("HVyUclryRUPYb",13) == 1323820206) strcat(s, "o");
if (crc32("luVlJZwqc",9) == 2716716961) strcat(s, "q");
if (crc32("YEfYTGiWcSHbG",13) == 290982986) strcat(s, "l");
if (crc32("NsrHqeP",7) == 4287537465) strcat(s, "l");
if (crc32("qaayOaZgPp",10) == 800492917) strcat(s, "B");
if (crc32("xvLKPADHgcCV",12) == 1768511260) strcat(s, "o");
if (crc32("ADSxGhJJRhnM",12) == 2732552036) strcat(s, "N");
if (crc32("HXXnlLGIUADFx",13) == 4000701991) strcat(s, "q");
if (crc32("gJNEL",5) == 2449076776) strcat(s, "u");
if (crc32("XcQoXG",6) == 3272893349) strcat(s, "D");
if (crc32("XjFyybrP",8) == 3403871654) strcat(s, "i");
if (crc32("sUFVtMHjQiUci",13) == 3031261057) strcat(s, "s");
if (crc32("OhbCzXwaahC",11) == 147039141) strcat(s, "g");
if (crc32("cbbDgsFmGRyA",12) == 1394458962) strcat(s, "t");
    return s;
}

char *Hally_nouns() {
    char *s = calloc(6);
    if (crc32("QUIwUSFgQXJQa",13) == 2147222205) strcat(s, "b");
if (crc32("YQDhtP",6) == 3988432403) strcat(s, "H");
if (crc32("WmPpZ",5) == 1298146484) strcat(s, "a");
if (crc32("ZoqQcZWUCKugdRI",15) == 128562571) strcat(s, "l");
if (crc32("eqIyDI",6) == 190890344) strcat(s, "l");
if (crc32("gSvNL",5) == 172055652) strcat(s, "B");
if (crc32("BslJfXMLMIdUgWv",15) == 2988337579) strcat(s, "y");
    return s;
}

char *hilarity_nouns() {
    char *s = calloc(9);
    if (crc32("dSycAdpoM",9) == 2761026455) strcat(s, "h");
if (crc32("dTPlMvYUAcgZl",13) == 3972196409) strcat(s, "U");
if (crc32("UgdsSttfkF",10) == 980240166) strcat(s, "i");
if (crc32("qBCTNNWcVNSbc",13) == 1790148349) strcat(s, "S");
if (crc32("JPCKr",5) == 3224767760) strcat(s, "l");
if (crc32("nfNjWjYaoKxgvZX",15) == 1133310695) strcat(s, "v");
if (crc32("syvCV",5) == 1732738801) strcat(s, "a");
if (crc32("NZJNnaG",7) == 2098874567) strcat(s, "N");
if (crc32("MdZhmcOn",8) == 4062327436) strcat(s, "r");
if (crc32("hWziPnZueXTb",12) == 336680669) strcat(s, "i");
if (crc32("ibycYJ",6) == 3692892128) strcat(s, "t");
if (crc32("QbfaDsNG",8) == 1593535644) strcat(s, "y");
    return s;
}

char *Funston_nouns() {
    char *s = calloc(8);
    if (crc32("eAnya",5) == 4229347403) strcat(s, "L");
if (crc32("NSiLYD",6) == 3729117213) strcat(s, "F");
if (crc32("hCElPdOuPc",10) == 1958719284) strcat(s, "u");
if (crc32("ibGCxQZpurjd",12) == 761722256) strcat(s, "n");
if (crc32("HVDvTZoJKS",10) == 1474026128) strcat(s, "s");
if (crc32("xOHGauxL",8) == 3575003013) strcat(s, "f");
if (crc32("irUgsPvoRumc",12) == 4288340923) strcat(s, "t");
if (crc32("fRpNDfl",7) == 3060073682) strcat(s, "o");
if (crc32("thoxPqoN",8) == 4249662059) strcat(s, "h");
if (crc32("GCXIKaE",7) == 2112680494) strcat(s, "n");
    return s;
}

char *Angeleno_nouns() {
    char *s = calloc(9);
    if (crc32("xqgSO",5) == 3555433825) strcat(s, "f");
if (crc32("OpCwOmmGdxXGgy",14) == 3331837637) strcat(s, "A");
if (crc32("RRmzyW",6) == 1110192911) strcat(s, "L");
if (crc32("mVRff",5) == 2980636173) strcat(s, "n");
if (crc32("ulSAVifarfcjs",13) == 1898026185) strcat(s, "g");
if (crc32("KkgVdBLOxaqqZNI",15) == 885404325) strcat(s, "i");
if (crc32("OdFbLTfESPZfFPb",15) == 942978643) strcat(s, "e");
if (crc32("qKARfmFziKiRexk",15) == 2448054808) strcat(s, "c");
if (crc32("YzIncxLpgKqHjE",14) == 2594751961) strcat(s, "l");
if (crc32("eEvKGDYOSN",10) == 510489622) strcat(s, "e");
if (crc32("uLKuGQrhU",9) == 1205791763) strcat(s, "n");
if (crc32("pzSviwXQYA",10) == 3787866691) strcat(s, "H");
if (crc32("fgknqlh",7) == 2331152521) strcat(s, "o");
    return s;
}

char *selfsolicitude_nouns() {
    char *s = calloc(15);
    if (crc32("TXitZlyyCkzk",12) == 258931557) strcat(s, "J");
if (crc32("bhaXeFKygYm",11) == 1085115685) strcat(s, "s");
if (crc32("DkAYPflPYtvP",12) == 1940731033) strcat(s, "b");
if (crc32("hDGNvEpDwVrOdk",14) == 1627242389) strcat(s, "e");
if (crc32("vwbPzMTAg",9) == 1486821150) strcat(s, "l");
if (crc32("HAeRqomPCrKfJQ",14) == 3177332467) strcat(s, "f");
if (crc32("ttvcxkuDdRrbph",14) == 3083348436) strcat(s, "H");
if (crc32("lIbBJCQaHr",10) == 379972892) strcat(s, "s");
if (crc32("WoZHG",5) == 2248050336) strcat(s, "p");
if (crc32("QXxASDLJO",9) == 3771734838) strcat(s, "o");
if (crc32("kGDrZpzORKcNaSb",15) == 754143225) strcat(s, "l");
if (crc32("OsujjipG",8) == 342391821) strcat(s, "i");
if (crc32("mflHsbyZJSiZqV",14) == 2950944160) strcat(s, "v");
if (crc32("FLYGJVPE",8) == 3904689272) strcat(s, "c");
if (crc32("whHiAp",6) == 1939975898) strcat(s, "l");
if (crc32("PpNcKeLdRnwwbFq",15) == 4110351511) strcat(s, "i");
if (crc32("uXdqQ",5) == 2621437382) strcat(s, "t");
if (crc32("TPxubSMUaRB",11) == 2732036713) strcat(s, "l");
if (crc32("xNVnsFdKspCBo",13) == 3986509910) strcat(s, "u");
if (crc32("SZeiuQkZf",9) == 2109860297) strcat(s, "d");
if (crc32("TeIKn",5) == 3246781945) strcat(s, "e");
    return s;
}

char *bobbin_nouns() {
    char *s = calloc(7);
    if (crc32("vmBuWOxdSqlp",12) == 2017214097) strcat(s, "b");
if (crc32("vvlwsoiw",8) == 4097762959) strcat(s, "o");
if (crc32("pEyZlU",6) == 263173024) strcat(s, "Z");
if (crc32("rTBrGwigQWHxgcG",15) == 718760770) strcat(s, "b");
if (crc32("YpappTizQdNQHZN",15) == 2633575207) strcat(s, "b");
if (crc32("qImYckO",7) == 41432965) strcat(s, "i");
if (crc32("qBwjr",5) == 1126843196) strcat(s, "n");
    return s;
}

char *Schul_nouns() {
    char *s = calloc(6);
    if (crc32("fPgyuvxLC",9) == 1267916791) strcat(s, "s");
if (crc32("HbEEy",5) == 3976783598) strcat(s, "S");
if (crc32("NtsBTdyhQF",10) == 1472265518) strcat(s, "z");
if (crc32("WFaWFiJvrfey",12) == 2960102007) strcat(s, "c");
if (crc32("mtxyi",5) == 3551285633) strcat(s, "h");
if (crc32("csEcWKXmDV",10) == 2908021261) strcat(s, "u");
if (crc32("LasViDN",7) == 3473719508) strcat(s, "l");
    return s;
}

char *expulsion_nouns() {
    char *s = calloc(10);
    if (crc32("yQKiKcGm",8) == 2880718594) strcat(s, "b");
if (crc32("oNICiZdtw",9) == 4226089735) strcat(s, "e");
if (crc32("bRUARlkcMEfL",12) == 3302566706) strcat(s, "w");
if (crc32("adKRkOEMnKo",11) == 1796132397) strcat(s, "x");
if (crc32("RANBm",5) == 561993680) strcat(s, "V");
if (crc32("TBCCi",5) == 2806708227) strcat(s, "p");
if (crc32("GsdAmKTNihTKRW",14) == 2943694373) strcat(s, "I");
if (crc32("UikaSbySrHfTmey",15) == 449961852) strcat(s, "u");
if (crc32("rYUEof",6) == 2292229266) strcat(s, "P");
if (crc32("ISueWnYLlvkxPTn",15) == 3491198218) strcat(s, "l");
if (crc32("VoVpm",5) == 1715018802) strcat(s, "s");
if (crc32("cQZaAR",6) == 3144890977) strcat(s, "i");
if (crc32("MGtWEETA",8) == 1224806876) strcat(s, "o");
if (crc32("ZiCvKyCMYpzn",12) == 3383918689) strcat(s, "n");
    return s;
}

char *Essequibo_nouns() {
    char *s = calloc(10);
    if (crc32("LTxdrU",6) == 4161707805) strcat(s, "a");
if (crc32("VQRqDUqCbjdNeBu",15) == 1625836824) strcat(s, "E");
if (crc32("ThRFqEZ",7) == 2612001462) strcat(s, "u");
if (crc32("xEjEt",5) == 1013757071) strcat(s, "s");
if (crc32("dByEvOlSpHZdp",13) == 2013193822) strcat(s, "O");
if (crc32("rNEJsshQelM",11) == 1679688831) strcat(s, "s");
if (crc32("WriDkNYYOFhr",12) == 3607469855) strcat(s, "A");
if (crc32("SrKzeDPoBewqu",13) == 1865247393) strcat(s, "e");
if (crc32("AdCpsdkOLRrD",12) == 2225573195) strcat(s, "R");
if (crc32("QAyvpn",6) == 3506292053) strcat(s, "q");
if (crc32("HyaZqTZH",8) == 2235041739) strcat(s, "s");
if (crc32("ikeVdRDCbRnrgh",14) == 2228884699) strcat(s, "u");
if (crc32("ZhwxgwoYWQqw",12) == 4148891582) strcat(s, "P");
if (crc32("cktFAPkNaXOJA",13) == 3265174727) strcat(s, "i");
if (crc32("UhaeyljsH",9) == 341644613) strcat(s, "b");
if (crc32("zpFOVA",6) == 3391760643) strcat(s, "o");
    return s;
}

char *surveying_nouns() {
    char *s = calloc(10);
    if (crc32("sllqjJqex",9) == 2730060361) strcat(s, "r");
if (crc32("AeMmofYCXxeII",13) == 2328622521) strcat(s, "s");
if (crc32("zsCCx",5) == 812650234) strcat(s, "o");
if (crc32("dTVRASGUfE",10) == 3509143530) strcat(s, "u");
if (crc32("AnxdnhGE",8) == 4109107958) strcat(s, "r");
if (crc32("beCLDr",6) == 2132012713) strcat(s, "v");
if (crc32("OWFlUDmL",8) == 3528944113) strcat(s, "e");
if (crc32("UpttpluRddLQB",13) == 2620911106) strcat(s, "y");
if (crc32("EtCTAclQYjeJSPi",15) == 3999291768) strcat(s, "r");
if (crc32("aPDVjxairTRbqt",14) == 624822098) strcat(s, "i");
if (crc32("MwJevbcjPCovqv",14) == 1282296883) strcat(s, "n");
if (crc32("VOWmlTCagzJpVN",14) == 1389634261) strcat(s, "g");
    return s;
}

char *Geneseo_nouns() {
    char *s = calloc(8);
    if (crc32("kJfeah",6) == 3028624571) strcat(s, "x");
if (crc32("CRHXqjAMDKs",11) == 952780021) strcat(s, "G");
if (crc32("pOlia",5) == 2051994354) strcat(s, "J");
if (crc32("bfkTXSeVWYcyy",13) == 3578226047) strcat(s, "e");
if (crc32("igzinak",7) == 3731763194) strcat(s, "F");
if (crc32("CsQxRA",6) == 645487745) strcat(s, "n");
if (crc32("frfvzmXpoxH",11) == 660134205) strcat(s, "e");
if (crc32("LgmZqinvUVE",11) == 2762189937) strcat(s, "q");
if (crc32("rpOcGtpsxUOsy",13) == 515735501) strcat(s, "s");
if (crc32("LHQhuyYKSMH",11) == 3195139790) strcat(s, "r");
if (crc32("stuffQiOUhYpG",13) == 2161441681) strcat(s, "e");
if (crc32("UhxYF",5) == 1718047514) strcat(s, "o");
    return s;
}

char *Gondwanaland_nouns() {
    char *s = calloc(13);
    if (crc32("oBAATwOIhMMYaBJ",15) == 3843368402) strcat(s, "Y");
if (crc32("MagNAO",6) == 1973595097) strcat(s, "G");
if (crc32("HmkHzkox",8) == 3929926659) strcat(s, "Z");
if (crc32("vMvczTPSPyFIy",13) == 3633430500) strcat(s, "o");
if (crc32("muoECRB",7) == 3868355643) strcat(s, "U");
if (crc32("SHvdsai",7) == 2964554877) strcat(s, "n");
if (crc32("DkkVfIfGSfXt",12) == 1351293128) strcat(s, "d");
if (crc32("hYnhy",5) == 2551259692) strcat(s, "I");
if (crc32("DWhBeK",6) == 3677387706) strcat(s, "w");
if (crc32("SxJNQvucobvQuS",14) == 647849005) strcat(s, "a");
if (crc32("yEdXhITxhQrU",12) == 3579662891) strcat(s, "h");
if (crc32("nnPdZLs",7) == 212312730) strcat(s, "n");
if (crc32("aUpYOyyqOdj",11) == 3482223990) strcat(s, "S");
if (crc32("SyYBEwsCABnN",12) == 3770783604) strcat(s, "a");
if (crc32("oBZSYdqvcQnHF",13) == 1742476954) strcat(s, "l");
if (crc32("MaStgBKKIcoDcrf",15) == 197548658) strcat(s, "a");
if (crc32("PdXJBe",6) == 1574825938) strcat(s, "n");
if (crc32("pobSHYhakT",10) == 2641005494) strcat(s, "d");
    return s;
}

char *saker_nouns() {
    char *s = calloc(6);
    if (crc32("sEBqg",5) == 1115037935) strcat(s, "s");
if (crc32("pfQoXfcSrCJ",11) == 4130053690) strcat(s, "a");
if (crc32("KspjsCRUOmV",11) == 39199403) strcat(s, "m");
if (crc32("DFRHRrj",7) == 923591408) strcat(s, "k");
if (crc32("obDCqQHBX",9) == 2692237091) strcat(s, "R");
if (crc32("QiHKO",5) == 236502872) strcat(s, "e");
if (crc32("CShdbDnCaeXkNy",14) == 4026325096) strcat(s, "r");
    return s;
}

char *concentricity_nouns() {
    char *s = calloc(14);
    if (crc32("itZvoaBxM",9) == 1616905113) strcat(s, "c");
if (crc32("gWJbaWEZuXUpps",14) == 3865110206) strcat(s, "l");
if (crc32("SNlWho",6) == 3023163450) strcat(s, "o");
if (crc32("LnBDsm",6) == 2663719138) strcat(s, "n");
if (crc32("MFPMiqNxNLYaxYd",15) == 94347342) strcat(s, "c");
if (crc32("nmswEYv",7) == 3515621656) strcat(s, "C");
if (crc32("RtoJqGoOlC",10) == 237467630) strcat(s, "e");
if (crc32("zlwVrLAEEmim",12) == 2827728767) strcat(s, "n");
if (crc32("JjtzFXeWlbjeL",13) == 3914379742) strcat(s, "t");
if (crc32("cdRgK",5) == 142476658) strcat(s, "r");
if (crc32("WbhJsNjnxBm",11) == 4226881379) strcat(s, "i");
if (crc32("zWNZuDDZaoYL",12) == 3854450165) strcat(s, "c");
if (crc32("rJgCsc",6) == 184714632) strcat(s, "X");
if (crc32("TfcIxHVnsfX",11) == 2091081762) strcat(s, "i");
if (crc32("KJtCAQE",7) == 3881094921) strcat(s, "d");
if (crc32("VYJVIRmqH",9) == 2907644181) strcat(s, "t");
if (crc32("kDXBTHe",7) == 2862215906) strcat(s, "v");
if (crc32("DQWABAtqYfIlzS",14) == 2393141578) strcat(s, "y");
    return s;
}

char *pensil_nouns() {
    char *s = calloc(7);
    if (crc32("JPEEjEidcV",10) == 2472199403) strcat(s, "p");
if (crc32("vLagQh",6) == 3748737675) strcat(s, "e");
if (crc32("xzLxt",5) == 3255578260) strcat(s, "n");
if (crc32("DSXuAnv",7) == 3236975934) strcat(s, "s");
if (crc32("rGqGaOSIUZEpc",13) == 430821058) strcat(s, "J");
if (crc32("rplGPUD",7) == 1836706653) strcat(s, "i");
if (crc32("atqnBmtUb",9) == 784591230) strcat(s, "M");
if (crc32("nmJnBBzVbapXoRL",15) == 2065815008) strcat(s, "l");
    return s;
}

char *sneakbox_nouns() {
    char *s = calloc(9);
    if (crc32("ezJrmDnHuiYmvF",14) == 4018915614) strcat(s, "s");
if (crc32("CCOFIJ",6) == 663690787) strcat(s, "n");
if (crc32("SgmpvUHM",8) == 2848738903) strcat(s, "e");
if (crc32("mLpNPSPcYGMdex",14) == 2749053806) strcat(s, "C");
if (crc32("oaxjaTSmarQfT",13) == 2092753493) strcat(s, "a");
if (crc32("dTNXqYUmDcvbdrY",15) == 3739030553) strcat(s, "e");
if (crc32("NwtekF",6) == 2090180265) strcat(s, "k");
if (crc32("hWtBo",5) == 1319771040) strcat(s, "x");
if (crc32("OBzHuTGUwt",10) == 4227172910) strcat(s, "b");
if (crc32("moeMAPyuXlmca",13) == 322685350) strcat(s, "S");
if (crc32("JylDrPzxLRf",11) == 2112935557) strcat(s, "o");
if (crc32("ulRSeWPykaFkB",13) == 2396506361) strcat(s, "L");
if (crc32("nYdgbhftRn",10) == 1806302901) strcat(s, "x");
    return s;
}

char *Gibeonite_nouns() {
    char *s = calloc(10);
    if (crc32("OdPBEqapdYd",11) == 2574863057) strcat(s, "V");
if (crc32("mlVkp",5) == 1749916936) strcat(s, "G");
if (crc32("vGWWM",5) == 571952253) strcat(s, "i");
if (crc32("CtJyHKNyNzIO",12) == 1071258437) strcat(s, "b");
if (crc32("NGxygDDXy",9) == 1589186715) strcat(s, "q");
if (crc32("lfwLeFXQuw",10) == 1383254724) strcat(s, "e");
if (crc32("gjhSARaJvdEx",12) == 1313328235) strcat(s, "o");
if (crc32("zcpkNZDhHxE",11) == 2577200396) strcat(s, "j");
if (crc32("GcwJSVG",7) == 1197003763) strcat(s, "n");
if (crc32("DvrnQgdqpD",10) == 245283024) strcat(s, "q");
if (crc32("MRNuQWXVM",9) == 1149697924) strcat(s, "i");
if (crc32("uRqdGtDXl",9) == 3711933693) strcat(s, "t");
if (crc32("ZJEyfrleLUgUJG",14) == 1952293113) strcat(s, "e");
    return s;
}

char *playhouse_nouns() {
    char *s = calloc(10);
    if (crc32("rwOkBCSC",8) == 2415322198) strcat(s, "p");
if (crc32("AinVHxgBOZx",11) == 3113087354) strcat(s, "l");
if (crc32("aMSnTdDAbjiIF",13) == 2356665212) strcat(s, "y");
if (crc32("AqaTvzdZxXn",11) == 2419566248) strcat(s, "a");
if (crc32("UqvFnBs",7) == 3321250217) strcat(s, "S");
if (crc32("MzwUwSshWjWglwm",15) == 2220158297) strcat(s, "y");
if (crc32("BXWzkWjgpYfs",12) == 1086501546) strcat(s, "h");
if (crc32("QDXaOZqXNCLsQV",14) == 541217408) strcat(s, "U");
if (crc32("yPNepOWYaLLxRPb",15) == 2856935093) strcat(s, "o");
if (crc32("qOyvyGSodjBXOX",14) == 1171170355) strcat(s, "e");
if (crc32("vHpdFporq",9) == 633942392) strcat(s, "u");
if (crc32("IxVOb",5) == 2166768874) strcat(s, "s");
if (crc32("uFKTKYRUcMLpiR",14) == 1873207551) strcat(s, "e");
    return s;
}

char *acetal_nouns() {
    char *s = calloc(7);
    if (crc32("ttRFh",5) == 1402160365) strcat(s, "t");
if (crc32("rtxkcxqD",8) == 2919749751) strcat(s, "a");
if (crc32("LDxNUCMlYxHvQ",13) == 2094084246) strcat(s, "H");
if (crc32("uVsoELFSpRtt",12) == 2513144697) strcat(s, "c");
if (crc32("qJRCtZsliZ",10) == 2261209184) strcat(s, "c");
if (crc32("ddmEWmPIpRUy",12) == 107832020) strcat(s, "e");
if (crc32("OJtAyrOG",8) == 3868763789) strcat(s, "c");
if (crc32("tlwgbhgNXqrr",12) == 183326807) strcat(s, "t");
if (crc32("hlUXZ",5) == 3180434954) strcat(s, "d");
if (crc32("bAuYbfmLMHBd",12) == 2857232557) strcat(s, "a");
if (crc32("dLdTAAVEssDe",12) == 531882430) strcat(s, "S");
if (crc32("MVPrSYywaq",10) == 69448498) strcat(s, "l");
    return s;
}

char *Mecklenburg_nouns() {
    char *s = calloc(12);
    if (crc32("WCALeKDjbkswn",13) == 1550906950) strcat(s, "s");
if (crc32("irZzoJfJA",9) == 2105283644) strcat(s, "M");
if (crc32("qmwxxoyexTBX",12) == 2411436010) strcat(s, "V");
if (crc32("TZrdGNvdEIaL",12) == 2065830957) strcat(s, "e");
if (crc32("crSQnlkXAzImHtN",15) == 2102915346) strcat(s, "c");
if (crc32("LcjwTOAAbrBW",12) == 3861892216) strcat(s, "k");
if (crc32("dyDlzUSfziYxB",13) == 4040649909) strcat(s, "E");
if (crc32("UOHsdALHqdD",11) == 386397731) strcat(s, "l");
if (crc32("MtGPn",5) == 3883456096) strcat(s, "e");
if (crc32("EHQHnt",6) == 786376944) strcat(s, "c");
if (crc32("hrGEErIYAxQGKte",15) == 1482238811) strcat(s, "n");
if (crc32("CjuOuTY",7) == 771711177) strcat(s, "b");
if (crc32("jKkhMxDIL",9) == 1675207450) strcat(s, "C");
if (crc32("pLeRZckPKpF",11) == 4038150624) strcat(s, "u");
if (crc32("Ymlaxw",6) == 3934500269) strcat(s, "r");
if (crc32("ajnCDX",6) == 4184404702) strcat(s, "g");
    return s;
}

char *Hillell_nouns() {
    char *s = calloc(8);
    if (crc32("wGGBH",5) == 1150211110) strcat(s, "H");
if (crc32("JxaGscYuRf",10) == 734055801) strcat(s, "J");
if (crc32("OnLprdgtowE",11) == 2003947374) strcat(s, "i");
if (crc32("ndGLSrEJzvuJF",13) == 2361350764) strcat(s, "l");
if (crc32("KwYAuVhm",8) == 629513524) strcat(s, "U");
if (crc32("uJVtshQPGEcwWIW",15) == 559842230) strcat(s, "l");
if (crc32("BdUFJVgrXWaj",12) == 1833270790) strcat(s, "e");
if (crc32("yerikiIfdqq",11) == 2076966118) strcat(s, "l");
if (crc32("KBaBFfWBHQp",11) == 3950331541) strcat(s, "l");
    return s;
}

char *Arvid_nouns() {
    char *s = calloc(6);
    if (crc32("IsoWSHHsATm",11) == 2188105396) strcat(s, "v");
if (crc32("lmBZgJRNsYpgX",13) == 522176869) strcat(s, "A");
if (crc32("qfGVFTMDerW",11) == 792125785) strcat(s, "K");
if (crc32("ltaga",5) == 664885027) strcat(s, "r");
if (crc32("snynS",5) == 4053137546) strcat(s, "v");
if (crc32("ICrEwllbejS",11) == 2289709957) strcat(s, "t");
if (crc32("pwnePEm",7) == 2674422820) strcat(s, "i");
if (crc32("cXxxJoLkdzwZ",12) == 715046550) strcat(s, "D");
if (crc32("oyDNMXiEMnDHSeq",15) == 2988147972) strcat(s, "d");
    return s;
}

char *beefwittedness_nouns() {
    char *s = calloc(15);
    if (crc32("yEzDfVfdefI",11) == 3107648516) strcat(s, "T");
if (crc32("VXIszWocF",9) == 1257968717) strcat(s, "b");
if (crc32("xyKkYQKZDvNTyb",14) == 2593741118) strcat(s, "l");
if (crc32("XxxPlqwKS",9) == 3157221054) strcat(s, "e");
if (crc32("KpunuZcGYPl",11) == 1861536167) strcat(s, "O");
if (crc32("iFhmjOVbFWzc",12) == 2204469571) strcat(s, "e");
if (crc32("WVvzuqN",7) == 1820385032) strcat(s, "H");
if (crc32("Ljukw",5) == 367569274) strcat(s, "f");
if (crc32("DtLBj",5) == 2577723194) strcat(s, "w");
if (crc32("wnORtqQV",8) == 874903858) strcat(s, "i");
if (crc32("SdtfjVn",7) == 226523059) strcat(s, "t");
if (crc32("fXIcRNPAeD",10) == 262065531) strcat(s, "t");
if (crc32("lZKveOKlWRgJ",12) == 3156598282) strcat(s, "b");
if (crc32("byKHRsgsyU",10) == 2198167940) strcat(s, "e");
if (crc32("xxJLnFDry",9) == 1158795656) strcat(s, "T");
if (crc32("hWSwOj",6) == 2379627098) strcat(s, "d");
if (crc32("nzUezwJPelG",11) == 3223172960) strcat(s, "n");
if (crc32("mafHWfZACLL",11) == 375221904) strcat(s, "v");
if (crc32("FwqLbKB",7) == 2045519234) strcat(s, "e");
if (crc32("CnXMCeqnq",9) == 4251912139) strcat(s, "s");
if (crc32("deeqb",5) == 2112643241) strcat(s, "s");
    return s;
}

char *shellacking_nouns() {
    char *s = calloc(12);
    if (crc32("HTSNt",5) == 2892827520) strcat(s, "C");
if (crc32("ZUQnDCIGCpCFh",13) == 3930005984) strcat(s, "s");
if (crc32("RdoxARmHMBfpwQ",14) == 1899909549) strcat(s, "h");
if (crc32("dxdgh",5) == 571529493) strcat(s, "e");
if (crc32("nFkHXPQtI",9) == 497262341) strcat(s, "l");
if (crc32("vnKMeoM",7) == 85491414) strcat(s, "m");
if (crc32("qBueIXeuoErI",12) == 74769555) strcat(s, "l");
if (crc32("ogItJJ",6) == 1242132299) strcat(s, "a");
if (crc32("myPhvUGEJSGsi",13) == 562010511) strcat(s, "i");
if (crc32("RfvodDsiavhjwg",14) == 1800413082) strcat(s, "c");
if (crc32("NeTnCXPZLzNNzv",14) == 2191827383) strcat(s, "t");
if (crc32("LwFCtOsdlBplxDa",15) == 1137248293) strcat(s, "k");
if (crc32("sRMisDErn",9) == 1498749019) strcat(s, "i");
if (crc32("KXquGGPD",8) == 3699801885) strcat(s, "O");
if (crc32("ZmLsRFZc",8) == 212991533) strcat(s, "n");
if (crc32("ZZPJcUoEqOpA",12) == 96071801) strcat(s, "g");
    return s;
}

char *hydrochloride_nouns() {
    char *s = calloc(14);
    if (crc32("hKrWMqEOosmOHjJ",15) == 2202951611) strcat(s, "h");
if (crc32("kqrktzoJ",8) == 3286456102) strcat(s, "y");
if (crc32("wBKrXRVeu",9) == 4011691790) strcat(s, "X");
if (crc32("KiOPMvSDsvBVYzo",15) == 3763087291) strcat(s, "d");
if (crc32("kEphMFnzIIoNUpS",15) == 329767434) strcat(s, "r");
if (crc32("MiMjGUamO",9) == 3823558878) strcat(s, "o");
if (crc32("xwcICyZeik",10) == 3839680699) strcat(s, "c");
if (crc32("kuNchDORrzZevE",14) == 3232723413) strcat(s, "h");
if (crc32("ZULYMRRP",8) == 2014348742) strcat(s, "l");
if (crc32("pActinIttGu",11) == 1288395876) strcat(s, "p");
if (crc32("fVrLq",5) == 311285779) strcat(s, "o");
if (crc32("rBopFPQuNoy",11) == 2206452588) strcat(s, "A");
if (crc32("gOuUOtOWMNlDxL",14) == 160250566) strcat(s, "r");
if (crc32("LegCcvaTkm",10) == 2078432493) strcat(s, "i");
if (crc32("qeZlvTPlueVDnD",14) == 2281611124) strcat(s, "H");
if (crc32("wsgYQ",5) == 3470237290) strcat(s, "d");
if (crc32("qhmVH",5) == 686525069) strcat(s, "e");
    return s;
}

char *Wamsley_nouns() {
    char *s = calloc(8);
    if (crc32("aAYjUP",6) == 1209793182) strcat(s, "W");
if (crc32("lcXkCnBYNgRRF",13) == 3436765218) strcat(s, "a");
if (crc32("hrPdCRE",7) == 326068217) strcat(s, "m");
if (crc32("AanrGH",6) == 2977748891) strcat(s, "I");
if (crc32("JrotRkISftl",11) == 523489117) strcat(s, "s");
if (crc32("ZliRWRpp",8) == 2970101377) strcat(s, "X");
if (crc32("mBynEKRn",8) == 99951313) strcat(s, "l");
if (crc32("nFRdjBMiPHM",11) == 636417705) strcat(s, "e");
if (crc32("eMTSbByaNvmQvGn",15) == 1997624375) strcat(s, "V");
if (crc32("svKUy",5) == 2766049514) strcat(s, "y");
    return s;
}

char *plenitude_nouns() {
    char *s = calloc(10);
    if (crc32("gIaKcI",6) == 1331009390) strcat(s, "p");
if (crc32("zEIHxCvCSqHuxbb",15) == 1350854443) strcat(s, "q");
if (crc32("UNHALHjMt",9) == 3311873438) strcat(s, "l");
if (crc32("YMeTavWNtkq",11) == 4145578778) strcat(s, "Y");
if (crc32("PlHVdLsJxEF",11) == 722089410) strcat(s, "e");
if (crc32("uGJdnUryWN",10) == 2990034154) strcat(s, "n");
if (crc32("MVRMTGHPYe",10) == 2720587656) strcat(s, "i");
if (crc32("sYlMWSqMx",9) == 1957855824) strcat(s, "c");
if (crc32("UUCJyIeatJmHMCg",15) == 119902778) strcat(s, "t");
if (crc32("JOAPnWgxIueNs",13) == 13808217) strcat(s, "F");
if (crc32("EISjmmasXD",10) == 510741890) strcat(s, "u");
if (crc32("NfGSxkEeEzwX",12) == 629022006) strcat(s, "d");
if (crc32("EkTDDrqnaVQsY",13) == 2368036210) strcat(s, "e");
    return s;
}

char *bedclothing_nouns() {
    char *s = calloc(12);
    if (crc32("VMOOxXQG",8) == 1881541101) strcat(s, "b");
if (crc32("dzNiCZBju",9) == 2522450823) strcat(s, "e");
if (crc32("EnMhVNwBxHwR",12) == 4029398617) strcat(s, "N");
if (crc32("EOeXpxdBLawsh",13) == 3695354552) strcat(s, "d");
if (crc32("xdcYFqDqvvTcotW",15) == 2384039450) strcat(s, "q");
if (crc32("mjmHmBNd",8) == 1133823774) strcat(s, "c");
if (crc32("ocPLbpjFsrJPxR",14) == 4019279627) strcat(s, "l");
if (crc32("nqFQugVWDE",10) == 3303522864) strcat(s, "o");
if (crc32("toEWCN",6) == 3038441091) strcat(s, "t");
if (crc32("PVeGOAYpnYQgr",13) == 3101697871) strcat(s, "h");
if (crc32("KpqnUbQDAJ",10) == 184080186) strcat(s, "i");
if (crc32("qszxqrZ",7) == 2225646186) strcat(s, "n");
if (crc32("zeOWeIosUaK",11) == 2057485067) strcat(s, "g");
    return s;
}

char *Naismith_nouns() {
    char *s = calloc(9);
    if (crc32("ZnjfZqjXHCXAK",13) == 1346153616) strcat(s, "N");
if (crc32("AtvEizVeQ",9) == 731912968) strcat(s, "a");
if (crc32("GfTxvH",6) == 79702371) strcat(s, "N");
if (crc32("nKszWU",6) == 1644702413) strcat(s, "i");
if (crc32("PxEISL",6) == 3601773482) strcat(s, "K");
if (crc32("CRacu",5) == 2682195565) strcat(s, "s");
if (crc32("zlrJYydozcPavrV",15) == 2738050336) strcat(s, "m");
if (crc32("ugZfVfEbsDXQ",12) == 230392048) strcat(s, "v");
if (crc32("iJdWTmAgb",9) == 1013051899) strcat(s, "i");
if (crc32("oJEhErDerDWbyJ",14) == 4085429921) strcat(s, "t");
if (crc32("DsAkXU",6) == 2502957688) strcat(s, "t");
if (crc32("DRFKIELEjx",10) == 1603932837) strcat(s, "h");
    return s;
}

char *reshipment_nouns() {
    char *s = calloc(11);
    if (crc32("kpeUjFxoKIEuIQl",15) == 1331394550) strcat(s, "r");
if (crc32("sTWBMoh",7) == 2731072079) strcat(s, "w");
if (crc32("UiDRpHIvBYjyHQC",15) == 2167354279) strcat(s, "e");
if (crc32("ERRnlibpw",9) == 1398444043) strcat(s, "s");
if (crc32("XaRIzkcVwlPwFT",14) == 1350997663) strcat(s, "h");
if (crc32("hSqRZhHlHEmWT",13) == 1664492888) strcat(s, "i");
if (crc32("QyitriH",7) == 2722468935) strcat(s, "O");
if (crc32("faAIWDIW",8) == 981332201) strcat(s, "p");
if (crc32("dVmLe",5) == 1710078787) strcat(s, "m");
if (crc32("SUPpzlMR",8) == 3217520200) strcat(s, "e");
if (crc32("ryBuNXKQP",9) == 91977572) strcat(s, "z");
if (crc32("tdlaRJIlmTAka",13) == 2566064980) strcat(s, "n");
if (crc32("JZuUmTDVWESIdZE",15) == 3846458889) strcat(s, "l");
if (crc32("KosCfZAPiqgZTJ",14) == 1944961454) strcat(s, "t");
    return s;
}

char *dugong_nouns() {
    char *s = calloc(7);
    if (crc32("nSHtBfLvSnHz",12) == 3852431279) strcat(s, "d");
if (crc32("sootgB",6) == 2781201493) strcat(s, "u");
if (crc32("SMyYecQyWXnQqlu",15) == 2755902521) strcat(s, "w");
if (crc32("Qbkch",5) == 457562913) strcat(s, "g");
if (crc32("HEsWEjrLBfFGetn",15) == 3673337909) strcat(s, "A");
if (crc32("QBkim",5) == 837969946) strcat(s, "o");
if (crc32("JYfDuZuKFe",10) == 4069805606) strcat(s, "h");
if (crc32("rWTfkwbaqEAlVP",14) == 2652314725) strcat(s, "n");
if (crc32("eVGkrrs",7) == 750009348) strcat(s, "J");
if (crc32("AvBQmrw",7) == 1619954457) strcat(s, "g");
    return s;
}

char *galliwasp_nouns() {
    char *s = calloc(10);
    if (crc32("DkdlhXDeoHH",11) == 1255787200) strcat(s, "G");
if (crc32("XNABOuCcIa",10) == 2125996114) strcat(s, "g");
if (crc32("YbsIeOQexCK",11) == 204023633) strcat(s, "a");
if (crc32("dzNExyVgLA",10) == 2574647024) strcat(s, "l");
if (crc32("eflrGCZb",8) == 2124190288) strcat(s, "l");
if (crc32("AOxdP",5) == 2777699578) strcat(s, "A");
if (crc32("qcQIKztjrMeq",12) == 3502865102) strcat(s, "i");
if (crc32("udlkREVpyMK",11) == 3277989427) strcat(s, "w");
if (crc32("Oxxas",5) == 2570858667) strcat(s, "B");
if (crc32("iSffqJkS",8) == 2860614836) strcat(s, "a");
if (crc32("DTKRl",5) == 2675499493) strcat(s, "s");
if (crc32("MgmGs",5) == 1967842727) strcat(s, "j");
if (crc32("cgpsccSoNdNMGe",14) == 820885271) strcat(s, "p");
    return s;
}

char *harmonisation_nouns() {
    char *s = calloc(14);
    if (crc32("EgwFXdvPQnj",11) == 2167669895) strcat(s, "h");
if (crc32("eylYWAqnuouQUy",14) == 2086275146) strcat(s, "a");
if (crc32("hRBFSZQXvUWibE",14) == 2308024632) strcat(s, "J");
if (crc32("nNgTImgvSHRbZ",13) == 3553117010) strcat(s, "r");
if (crc32("vhgLaDytqeEE",12) == 3413463352) strcat(s, "m");
if (crc32("RgspwtNGUqwY",12) == 1963491778) strcat(s, "n");
if (crc32("bTyUIS",6) == 2532610486) strcat(s, "o");
if (crc32("SZZeMpBtAIOvf",13) == 2634381129) strcat(s, "R");
if (crc32("uczyr",5) == 3339976550) strcat(s, "n");
if (crc32("BEvTzjZrH",9) == 2355874543) strcat(s, "i");
if (crc32("PpZpiJvZKItkUK",14) == 1503609881) strcat(s, "s");
if (crc32("yzNKZZO",7) == 486240206) strcat(s, "C");
if (crc32("wLjuTEYwAnvrd",13) == 149442751) strcat(s, "a");
if (crc32("YXpFPTITu",9) == 2127863454) strcat(s, "z");
if (crc32("UNdjLNYoX",9) == 910009685) strcat(s, "t");
if (crc32("NtRrZe",6) == 2231881257) strcat(s, "t");
if (crc32("BxuWtGhlPOPPMt",14) == 362639250) strcat(s, "i");
if (crc32("AWkPWskUhQr",11) == 803337676) strcat(s, "y");
if (crc32("FBZmezAaZODpmhn",15) == 4155219481) strcat(s, "o");
if (crc32("GhvmolGqnNi",11) == 780674688) strcat(s, "t");
if (crc32("ffUCbFkHRXETpgs",15) == 413704522) strcat(s, "n");
    return s;
}

char *Arachnida_nouns() {
    char *s = calloc(10);
    if (crc32("WoenprGTvYnFrxz",15) == 1893841930) strcat(s, "e");
if (crc32("nkZCUUPOStCwFOr",15) == 3449866070) strcat(s, "A");
if (crc32("QzJLDspgWBG",11) == 663173267) strcat(s, "r");
if (crc32("WbwSANkg",8) == 1125067037) strcat(s, "a");
if (crc32("oBPkiYQuzF",10) == 2659824478) strcat(s, "c");
if (crc32("TXSOxBwKFTim",12) == 174853748) strcat(s, "e");
if (crc32("wHDZvcoBLEIY",12) == 2832136183) strcat(s, "h");
if (crc32("KeyxDbXCLX",10) == 3966427480) strcat(s, "O");
if (crc32("hROazJAetei",11) == 3518474786) strcat(s, "n");
if (crc32("EOPNU",5) == 1355393063) strcat(s, "I");
if (crc32("ygksWhrix",9) == 2903897627) strcat(s, "i");
if (crc32("phwFdUqvuppT",12) == 4272011421) strcat(s, "t");
if (crc32("cFxZLfZXGYzP",12) == 4029747562) strcat(s, "d");
if (crc32("LAUTKQrF",8) == 3412189731) strcat(s, "a");
    return s;
}

char *dermatographia_nouns() {
    char *s = calloc(15);
    if (crc32("qhQjb",5) == 3055057649) strcat(s, "I");
if (crc32("RtHnLkyOBUyhVzI",15) == 1248648358) strcat(s, "d");
if (crc32("kqxgCbJ",7) == 149876611) strcat(s, "e");
if (crc32("UNiqkPdPDZxH",12) == 2122819643) strcat(s, "r");
if (crc32("LsooGqLRrRYd",12) == 2011923365) strcat(s, "L");
if (crc32("vSnWwVW",7) == 2689007185) strcat(s, "m");
if (crc32("wclvYEC",7) == 702781302) strcat(s, "a");
if (crc32("QOUKMizBB",9) == 2192756073) strcat(s, "r");
if (crc32("ThckCmCOzLxXVfS",15) == 2755077582) strcat(s, "t");
if (crc32("FmMSMfjPBvYdEbF",15) == 3648133081) strcat(s, "o");
if (crc32("pqvEAasMs",9) == 2585272035) strcat(s, "g");
if (crc32("eCvsBBWCOKuF",12) == 1917603868) strcat(s, "r");
if (crc32("VzzOAOYr",8) == 1131759834) strcat(s, "a");
if (crc32("theuikaYCrscse",14) == 281778949) strcat(s, "p");
if (crc32("hSHBYLUxdavGmxw",15) == 1599408911) strcat(s, "h");
if (crc32("MOmOwxI",7) == 1563688182) strcat(s, "i");
if (crc32("gvoMTbt",7) == 849826179) strcat(s, "E");
if (crc32("ATLsYMFYAw",10) == 1863140420) strcat(s, "a");
    return s;
}

char *Greenfield_nouns() {
    char *s = calloc(11);
    if (crc32("pykTpw",6) == 686704091) strcat(s, "G");
if (crc32("gDpgpivM",8) == 4158472953) strcat(s, "h");
if (crc32("kUkQZWYGsdST",12) == 1339082520) strcat(s, "r");
if (crc32("DGKSUgbpYDEsXdp",15) == 3199216675) strcat(s, "e");
if (crc32("klXfEx",6) == 503322343) strcat(s, "e");
if (crc32("ivcOhtgzCMQY",12) == 2088121622) strcat(s, "Z");
if (crc32("gYJmvnNI",8) == 2881995404) strcat(s, "n");
if (crc32("UahWekMduBeleu",14) == 4130921029) strcat(s, "f");
if (crc32("fbuuVRLgLa",10) == 4214500443) strcat(s, "t");
if (crc32("tQJDMFQGo",9) == 3073338871) strcat(s, "i");
if (crc32("jFhWpHLmXcHqOD",14) == 2440370229) strcat(s, "L");
if (crc32("aFvUaOfMMZbe",12) == 2278008380) strcat(s, "e");
if (crc32("mMsTzKUbM",9) == 2038749751) strcat(s, "l");
if (crc32("eTHwdCYinWg",11) == 3629729911) strcat(s, "d");
    return s;
}

char *abv_nouns() {
    char *s = calloc(4);
    if (crc32("QBwBuGlDqmJcxXz",15) == 3806308757) strcat(s, "a");
if (crc32("LkPrpUxb",8) == 1874142103) strcat(s, "A");
if (crc32("nEbUKjVM",8) == 3999698913) strcat(s, "b");
if (crc32("NydYFEC",7) == 1762543342) strcat(s, "v");
    return s;
}

char *acrodontism_nouns() {
    char *s = calloc(12);
    if (crc32("fDABfwVzP",9) == 4066082175) strcat(s, "a");
if (crc32("aVUdeD",6) == 957795454) strcat(s, "z");
if (crc32("iGOPzmn",7) == 2744031381) strcat(s, "c");
if (crc32("JfBijMgDx",9) == 218659809) strcat(s, "w");
if (crc32("qsPYInO",7) == 3062192138) strcat(s, "r");
if (crc32("tEQonGyJ",8) == 1944379157) strcat(s, "y");
if (crc32("zTtooBHbdEEmOn",14) == 3224441087) strcat(s, "o");
if (crc32("qCdOCynxrse",11) == 675046990) strcat(s, "q");
if (crc32("vIUIotudPIMr",12) == 1501605412) strcat(s, "d");
if (crc32("qNqqLLS",7) == 3374357883) strcat(s, "Z");
if (crc32("lqAtYGsYw",9) == 2382684095) strcat(s, "o");
if (crc32("tQKuZcl",7) == 1520727955) strcat(s, "n");
if (crc32("EnpGMyjPeTZ",11) == 3662035244) strcat(s, "t");
if (crc32("cRhZLkQu",8) == 127453646) strcat(s, "w");
if (crc32("eOhHA",5) == 725117400) strcat(s, "i");
if (crc32("FJkipP",6) == 2515902613) strcat(s, "s");
if (crc32("UphlBdBCUull",12) == 3487767152) strcat(s, "u");
if (crc32("XJHiaBU",7) == 2640565070) strcat(s, "m");
    return s;
}

char *pentene_nouns() {
    char *s = calloc(8);
    if (crc32("QwZxCjKAxYWdxM",14) == 807634918) strcat(s, "p");
if (crc32("AFJFnF",6) == 393899088) strcat(s, "z");
if (crc32("WNyODFvbfuygZ",13) == 1589130537) strcat(s, "e");
if (crc32("zvYwp",5) == 1744993025) strcat(s, "n");
if (crc32("GQJfwYHpeWHDZX",14) == 1095703987) strcat(s, "t");
if (crc32("hCUldvuE",8) == 3198238985) strcat(s, "B");
if (crc32("dKZdsuGRD",9) == 3922397859) strcat(s, "e");
if (crc32("bgIblXmkCrsDAlq",15) == 2077343012) strcat(s, "x");
if (crc32("KmgseGcsLEeLLH",14) == 437048714) strcat(s, "n");
if (crc32("eEoPsaQy",8) == 2420986564) strcat(s, "e");
    return s;
}

char *cyclist_nouns() {
    char *s = calloc(8);
    if (crc32("qKzObHBvmWgYZYE",15) == 2505073334) strcat(s, "y");
if (crc32("XHAdOTzJcTlIFVm",15) == 3147368094) strcat(s, "c");
if (crc32("eYtxPectZz",10) == 714806302) strcat(s, "y");
if (crc32("sRUreQLvaZ",10) == 3604889397) strcat(s, "Y");
if (crc32("WdYJyztC",8) == 2536372959) strcat(s, "c");
if (crc32("kgKnrtC",7) == 4159311022) strcat(s, "a");
if (crc32("ndvZve",6) == 2219573637) strcat(s, "l");
if (crc32("YPHVoLhLLBit",12) == 2631092987) strcat(s, "i");
if (crc32("ZSDopSdETxjPX",13) == 290617824) strcat(s, "Y");
if (crc32("pHObzxDemRE",11) == 1274799248) strcat(s, "s");
if (crc32("TdogsoPDy",9) == 2840965591) strcat(s, "h");
if (crc32("onjMQgr",7) == 2438581155) strcat(s, "t");
    return s;
}

char *glutose_nouns() {
    char *s = calloc(8);
    if (crc32("teilUJvp",8) == 1328660309) strcat(s, "g");
if (crc32("YFhWeDLsEZCgit",14) == 3839862522) strcat(s, "w");
if (crc32("lltrDyYJcGde",12) == 2690553164) strcat(s, "l");
if (crc32("VhnevMyYILN",11) == 1628022279) strcat(s, "v");
if (crc32("teNIAzSDPVEirDJ",15) == 3554663568) strcat(s, "u");
if (crc32("aIreY",5) == 3643045083) strcat(s, "t");
if (crc32("fLlqrlfutalxsl",14) == 800927528) strcat(s, "o");
if (crc32("cEnpeecQKyvz",12) == 2828904079) strcat(s, "s");
if (crc32("SrsYxLK",7) == 653065040) strcat(s, "e");
    return s;
}

char *Wiencke_nouns() {
    char *s = calloc(8);
    if (crc32("bDSOZzB",7) == 314491132) strcat(s, "D");
if (crc32("yPjNghgsblBzne",14) == 3193860417) strcat(s, "W");
if (crc32("ADpGTQoX",8) == 2137306932) strcat(s, "i");
if (crc32("YXdqbNIFyjx",11) == 1866551509) strcat(s, "n");
if (crc32("dulvYkfMBJgDbq",14) == 2177452419) strcat(s, "e");
if (crc32("CNBrXvIpzqJGY",13) == 3801232783) strcat(s, "z");
if (crc32("pPKPGV",6) == 2674573094) strcat(s, "n");
if (crc32("RuRvmNoXcMic",12) == 3684047662) strcat(s, "z");
if (crc32("DGpYpDxnHBU",11) == 109513611) strcat(s, "c");
if (crc32("ApZbYnP",7) == 1690715762) strcat(s, "k");
if (crc32("JANtRxgouAngVug",15) == 557564145) strcat(s, "e");
    return s;
}

char *Renner_nouns() {
    char *s = calloc(7);
    if (crc32("JrxgKoNwePt",11) == 4172691728) strcat(s, "h");
if (crc32("EZowfmIVVvbPUy",14) == 308977086) strcat(s, "R");
if (crc32("dtIQXaJ",7) == 3694405568) strcat(s, "e");
if (crc32("hjwwR",5) == 2405334474) strcat(s, "n");
if (crc32("gzWVRlAUM",9) == 2789171889) strcat(s, "Z");
if (crc32("yCqiJGrsSjyZ",12) == 1275456597) strcat(s, "n");
if (crc32("WWebd",5) == 3716182961) strcat(s, "F");
if (crc32("QjyjIK",6) == 911268009) strcat(s, "e");
if (crc32("KJhOaJqJjc",10) == 1273840401) strcat(s, "r");
    return s;
}

char *superelaborateness_nouns() {
    char *s = calloc(19);
    if (crc32("VBOvBH",6) == 412108455) strcat(s, "L");
if (crc32("fhMlcwfPLvmXKJ",14) == 3195725440) strcat(s, "s");
if (crc32("DvrxY",5) == 129776461) strcat(s, "E");
if (crc32("JBRWhUcYX",9) == 1912934856) strcat(s, "u");
if (crc32("HKaGNzLMGd",10) == 1979575288) strcat(s, "e");
if (crc32("FvMWcvQrxsOUDx",14) == 3963809178) strcat(s, "p");
if (crc32("NEdInFKQLCmcy",13) == 2874430000) strcat(s, "e");
if (crc32("McjcvdXiFiuB",12) == 2776653453) strcat(s, "i");
if (crc32("OXcEnfPtVkFwKT",14) == 1692780859) strcat(s, "r");
if (crc32("VUkWEVtiGHff",12) == 55231166) strcat(s, "q");
if (crc32("bSrpUrMH",8) == 3433004228) strcat(s, "e");
if (crc32("iMtkcLorRAFg",12) == 816870486) strcat(s, "l");
if (crc32("nRTVgQUoBdZS",12) == 4287330289) strcat(s, "a");
if (crc32("GYELBJb",7) == 1227582913) strcat(s, "T");
if (crc32("fJEepIiyNyRrz",13) == 746609043) strcat(s, "b");
if (crc32("YhcZMc",6) == 3830953647) strcat(s, "D");
if (crc32("KMEoVDTsUJBkt",13) == 748279009) strcat(s, "o");
if (crc32("MWUvGIAT",8) == 1951318335) strcat(s, "k");
if (crc32("fSKFkeO",7) == 3559347555) strcat(s, "r");
if (crc32("hCuvKZwyGenZhbU",15) == 649845397) strcat(s, "a");
if (crc32("DEFjKwQdkVmrLrr",15) == 1950868122) strcat(s, "t");
if (crc32("jlRBzO",6) == 2106037430) strcat(s, "U");
if (crc32("pzbQKonkaw",10) == 874766811) strcat(s, "e");
if (crc32("cEOfoMepS",9) == 1864998046) strcat(s, "n");
if (crc32("AjTnAPnIKFf",11) == 105497586) strcat(s, "Q");
if (crc32("VfmyXs",6) == 1415922559) strcat(s, "e");
if (crc32("axCtN",5) == 1678819951) strcat(s, "s");
if (crc32("rxFIMgEKnymHL",13) == 3214718100) strcat(s, "k");
if (crc32("cqUWqlAFxqrwgc",14) == 2672037946) strcat(s, "s");
    return s;
}

char *interrupter_nouns() {
    char *s = calloc(12);
    if (crc32("oXecSzmZvgs",11) == 2225225390) strcat(s, "i");
if (crc32("NjNfGvnsarHWP",13) == 3509770197) strcat(s, "n");
if (crc32("KQOnqglvdODh",12) == 328726787) strcat(s, "j");
if (crc32("eUZEHsSkRcDWacm",15) == 3694724041) strcat(s, "t");
if (crc32("CHMzZIFfTre",11) == 2523201786) strcat(s, "e");
if (crc32("UdcSwHnJYnS",11) == 1983605069) strcat(s, "r");
if (crc32("sIYhjcrizFRFjwX",15) == 3397461192) strcat(s, "l");
if (crc32("mKpTYpGshhvkvX",14) == 1281983862) strcat(s, "r");
if (crc32("GkIprAmzcDc",11) == 3011396254) strcat(s, "u");
if (crc32("iEXwHUfpPryfsM",14) == 4220264513) strcat(s, "s");
if (crc32("MJqyDswNOKq",11) == 3917877005) strcat(s, "p");
if (crc32("mfsIESNR",8) == 928005182) strcat(s, "t");
if (crc32("Uccxbm",6) == 615137471) strcat(s, "e");
if (crc32("bVoPJJ",6) == 1342427100) strcat(s, "R");
if (crc32("vuefyeHlUVEFMlK",15) == 3438778527) strcat(s, "r");
    return s;
}

char *ambitiousness_nouns() {
    char *s = calloc(14);
    if (crc32("IUagCFUpcwp",11) == 4052514401) strcat(s, "i");
if (crc32("rOTtljz",7) == 1599394126) strcat(s, "a");
if (crc32("UDaneJ",6) == 2260469095) strcat(s, "G");
if (crc32("NsBSrwQJYWQ",11) == 3489365933) strcat(s, "m");
if (crc32("JDrcbBPKeNbu",12) == 3712951797) strcat(s, "d");
if (crc32("ZGTJx",5) == 2378143774) strcat(s, "b");
if (crc32("umfVITfWNZq",11) == 1739414001) strcat(s, "i");
if (crc32("JLueLHrAkAvyNP",14) == 3424406793) strcat(s, "i");
if (crc32("UeqXh",5) == 1578208454) strcat(s, "t");
if (crc32("QGrnYx",6) == 706441094) strcat(s, "i");
if (crc32("VQJxASTuh",9) == 3212331409) strcat(s, "o");
if (crc32("hmxcYaYNcrcP",12) == 1970390105) strcat(s, "p");
if (crc32("xhnmEabXax",10) == 3838850880) strcat(s, "u");
if (crc32("MhHXYfSrJ",9) == 2472008706) strcat(s, "s");
if (crc32("EsnjUwK",7) == 2675425270) strcat(s, "n");
if (crc32("tVrHpTU",7) == 916629924) strcat(s, "p");
if (crc32("NkmEcOOHBkf",11) == 2608507100) strcat(s, "e");
if (crc32("EFolSaKmKKc",11) == 3617662329) strcat(s, "s");
if (crc32("PAKjvbbOGWYnjoF",15) == 2843780979) strcat(s, "O");
if (crc32("OEdDTNfmRdzlbo",14) == 2479235325) strcat(s, "s");
    return s;
}

char *saccharization_nouns() {
    char *s = calloc(15);
    if (crc32("accxlvYicpU",11) == 1186530473) strcat(s, "s");
if (crc32("WKZiIUZR",8) == 211829874) strcat(s, "a");
if (crc32("uOCfNKZXe",9) == 4409458) strcat(s, "e");
if (crc32("ycWhxzVClGCWv",13) == 621780004) strcat(s, "c");
if (crc32("UHdwUDsqEIjCWrD",15) == 1798324589) strcat(s, "P");
if (crc32("TTbkxiPO",8) == 2103410293) strcat(s, "c");
if (crc32("aqyCdFu",7) == 2302049505) strcat(s, "P");
if (crc32("HwoBPbnSVMITi",13) == 463159141) strcat(s, "h");
if (crc32("pDtwPzZFN",9) == 3749737068) strcat(s, "a");
if (crc32("KfBBEmNwfIXk",12) == 4101632496) strcat(s, "c");
if (crc32("bTZdBpw",7) == 1123924906) strcat(s, "r");
if (crc32("RpurcDnnJ",9) == 909965005) strcat(s, "S");
if (crc32("bKKJdvfixEXac",13) == 1600932436) strcat(s, "i");
if (crc32("JwscOclQYsJYA",13) == 181008765) strcat(s, "z");
if (crc32("MOqOHrpQDyUvj",13) == 3166628410) strcat(s, "S");
if (crc32("QvOCQpemVlcKYE",14) == 376050219) strcat(s, "a");
if (crc32("mHSNooL",7) == 3489478326) strcat(s, "f");
if (crc32("aFFiFdj",7) == 550548393) strcat(s, "t");
if (crc32("cyLlLfsUs",9) == 4280691784) strcat(s, "b");
if (crc32("wBNJONl",7) == 3026272712) strcat(s, "i");
if (crc32("dQZDFhaMzhbJv",13) == 650916078) strcat(s, "C");
if (crc32("wKNphE",6) == 208594540) strcat(s, "o");
if (crc32("xnjQGLpmBz",10) == 2160946058) strcat(s, "n");
    return s;
}

char *CAF_nouns() {
    char *s = calloc(4);
    if (crc32("fXdkBxAUSpw",11) == 3609866107) strcat(s, "C");
if (crc32("TWEdUVtNHxHY",12) == 1758961216) strcat(s, "A");
if (crc32("FJzXYyZdJLurl",13) == 287063831) strcat(s, "W");
if (crc32("vtzybUqbUCf",11) == 1411762625) strcat(s, "F");
    return s;
}

char *Lenci_nouns() {
    char *s = calloc(6);
    if (crc32("RdWtwyldfUSK",12) == 952890994) strcat(s, "D");
if (crc32("CIPDPzyXakaY",12) == 998175735) strcat(s, "L");
if (crc32("PYAPjaz",7) == 4238645994) strcat(s, "Y");
if (crc32("MnogkuFjPPvZr",13) == 766437377) strcat(s, "e");
if (crc32("TXUXkZhDfKFyL",13) == 3334297957) strcat(s, "n");
if (crc32("EXuhmmBoQJl",11) == 3824217295) strcat(s, "c");
if (crc32("WBAAXpuQy",9) == 4163436731) strcat(s, "f");
if (crc32("NjRYsNjUpo",10) == 2907794372) strcat(s, "i");
    return s;
}

char *Kunkle_nouns() {
    char *s = calloc(7);
    if (crc32("dTEqbovbSa",10) == 3474995850) strcat(s, "K");
if (crc32("tjLvN",5) == 258629686) strcat(s, "u");
if (crc32("FvPtXCu",7) == 571895708) strcat(s, "n");
if (crc32("oTYUBx",6) == 152211199) strcat(s, "o");
if (crc32("SxWWHBALilaokT",14) == 837946819) strcat(s, "k");
if (crc32("kKRdMKeUaTCfEk",14) == 883484978) strcat(s, "H");
if (crc32("RmftxwAbWT",10) == 2690697455) strcat(s, "l");
if (crc32("ofEatuZSTgH",11) == 768339082) strcat(s, "e");
    return s;
}

char *Femi_nouns() {
    char *s = calloc(5);
    if (crc32("ZWlRiCcI",8) == 259128980) strcat(s, "F");
if (crc32("AZOUO",5) == 3594445110) strcat(s, "M");
if (crc32("PQUEvqYePlOOIc",14) == 3019815290) strcat(s, "e");
if (crc32("LFqcbiTBIRtfImo",15) == 1583209836) strcat(s, "B");
if (crc32("JIAygLRE",8) == 1835031366) strcat(s, "m");
if (crc32("JXkNnAoTduesWkT",15) == 4039356322) strcat(s, "i");
    return s;
}

char *accelerant_nouns() {
    char *s = calloc(11);
    if (crc32("maqDROrTQdndV",13) == 2880003073) strcat(s, "k");
if (crc32("LDNDbgXAlKbqJVK",15) == 182648027) strcat(s, "a");
if (crc32("wChjHMKYfaR",11) == 3612722295) strcat(s, "i");
if (crc32("lAwxXhhsfyDlwg",14) == 1546774661) strcat(s, "c");
if (crc32("ZtdxqrrdTZ",10) == 4080573113) strcat(s, "c");
if (crc32("wtuosvfuAW",10) == 2940677996) strcat(s, "S");
if (crc32("MNUfyubLRc",10) == 3266891552) strcat(s, "e");
if (crc32("pjJEVnMTRTxv",12) == 2055508638) strcat(s, "Z");
if (crc32("bKnKsZBLbjN",11) == 594680752) strcat(s, "l");
if (crc32("hqhORnfQxgmDP",13) == 127809468) strcat(s, "e");
if (crc32("xoLxeWjTwBjQQBn",15) == 1828964274) strcat(s, "r");
if (crc32("betOIXklhKei",12) == 3229006979) strcat(s, "N");
if (crc32("vwuVbfhbk",9) == 2440201601) strcat(s, "a");
if (crc32("cXWfYbzuRazLfA",14) == 3861209349) strcat(s, "I");
if (crc32("ENfctYR",7) == 1007166197) strcat(s, "n");
if (crc32("AseIGt",6) == 1347895276) strcat(s, "t");
    return s;
}

char *pareira_nouns() {
    char *s = calloc(8);
    if (crc32("qMbyJ",5) == 3759318963) strcat(s, "a");
if (crc32("dPfFbvU",7) == 1864457782) strcat(s, "p");
if (crc32("jGlRENk",7) == 1610235412) strcat(s, "a");
if (crc32("IOieALv",7) == 3201922711) strcat(s, "r");
if (crc32("ZTzeHAPFAaLa",12) == 255611348) strcat(s, "K");
if (crc32("rlvrCfoASz",10) == 374110798) strcat(s, "e");
if (crc32("QFOjIUq",7) == 2762709963) strcat(s, "C");
if (crc32("PoKbQXD",7) == 2545601476) strcat(s, "i");
if (crc32("lrsgnKCSWf",10) == 1499690862) strcat(s, "x");
if (crc32("dYpFBRg",7) == 2801572634) strcat(s, "r");
if (crc32("bSMGMO",6) == 877841413) strcat(s, "a");
    return s;
}

char *scourge_nouns() {
    char *s = calloc(8);
    if (crc32("gjdXFRUNteQqq",13) == 1989743221) strcat(s, "s");
if (crc32("wobrMJo",7) == 2273340510) strcat(s, "z");
if (crc32("XUORtBfoxnSgeZ",14) == 296936280) strcat(s, "c");
if (crc32("BrSZegfFgs",10) == 2617440856) strcat(s, "z");
if (crc32("kmFfFJ",6) == 1885085112) strcat(s, "o");
if (crc32("riPxB",5) == 1628263400) strcat(s, "T");
if (crc32("dNQpMZcm",8) == 1848724118) strcat(s, "u");
if (crc32("IBLzuFl",7) == 4140503017) strcat(s, "C");
if (crc32("ZSnAySS",7) == 2913843372) strcat(s, "r");
if (crc32("yGAQtYqQxW",10) == 2300564223) strcat(s, "V");
if (crc32("yknarFSpmnKR",12) == 2457792136) strcat(s, "g");
if (crc32("kotpWtG",7) == 2889061307) strcat(s, "k");
if (crc32("xvUaQrBJWQor",12) == 2386803727) strcat(s, "e");
    return s;
}

char *Monto_nouns() {
    char *s = calloc(6);
    if (crc32("uJmnpv",6) == 3845265714) strcat(s, "M");
if (crc32("BUOeVVeh",8) == 220194969) strcat(s, "o");
if (crc32("fmgnuRnFfE",10) == 2956634025) strcat(s, "d");
if (crc32("pbYpKJHLrkya",12) == 1241321559) strcat(s, "n");
if (crc32("eLfyEtz",7) == 3684304554) strcat(s, "z");
if (crc32("lZEdxGdXVMJqeu",14) == 4105594496) strcat(s, "t");
if (crc32("ajbkxWCsu",9) == 1543085925) strcat(s, "o");
    return s;
}

char *prettifier_nouns() {
    char *s = calloc(11);
    if (crc32("ahvegERSQbPfJ",13) == 28460823) strcat(s, "j");
if (crc32("FWcAPT",6) == 1820732586) strcat(s, "p");
if (crc32("DzosuUH",7) == 3975860879) strcat(s, "T");
if (crc32("yoLCFEFsrNtqBtM",15) == 1964226692) strcat(s, "r");
if (crc32("brEMKfKlTxFX",12) == 913219745) strcat(s, "e");
if (crc32("mQawLBJrARY",11) == 221737689) strcat(s, "O");
if (crc32("bfAvaldlLKYK",12) == 1301681239) strcat(s, "t");
if (crc32("rzkzlmmR",8) == 908270072) strcat(s, "t");
if (crc32("SxgyDW",6) == 1857135303) strcat(s, "t");
if (crc32("iEFjTVhQqrl",11) == 291223079) strcat(s, "c");
if (crc32("hkfQE",5) == 1779160331) strcat(s, "i");
if (crc32("nlPqSTzRQfNcE",13) == 230508388) strcat(s, "f");
if (crc32("tvbarblIQnbjkxq",15) == 4018976342) strcat(s, "i");
if (crc32("lNRBK",5) == 2907835678) strcat(s, "e");
if (crc32("MPFqu",5) == 2823720156) strcat(s, "a");
if (crc32("mvWrMBCkQezj",12) == 488288415) strcat(s, "r");
    return s;
}

char *realliance_nouns() {
    char *s = calloc(11);
    if (crc32("UsyVovz",7) == 4054679182) strcat(s, "r");
if (crc32("zGeUXPXSgAqqVyr",15) == 4258523450) strcat(s, "z");
if (crc32("dirpqbvjt",9) == 2506909512) strcat(s, "e");
if (crc32("rAyzgZZOjdsokPT",15) == 3140885163) strcat(s, "r");
if (crc32("cESXcIRe",8) == 1283561503) strcat(s, "a");
if (crc32("tuNNBzn",7) == 1871546318) strcat(s, "E");
if (crc32("NDLBaYRz",8) == 1802681679) strcat(s, "l");
if (crc32("QIXTIjJAoJtyC",13) == 3193868105) strcat(s, "l");
if (crc32("IvXkt",5) == 237936178) strcat(s, "J");
if (crc32("zSXNkVK",7) == 1705756493) strcat(s, "i");
if (crc32("hNuhtZuGCNcRel",14) == 1984053275) strcat(s, "a");
if (crc32("zOQDgDNdqnd",11) == 1962699475) strcat(s, "U");
if (crc32("NgOZuDdpe",9) == 1297900688) strcat(s, "n");
if (crc32("QlMmeJpIGQkQ",12) == 2816294842) strcat(s, "p");
if (crc32("CaeEsCym",8) == 3782473559) strcat(s, "c");
if (crc32("aODuQLxWPJvIMV",14) == 4181632472) strcat(s, "e");
    return s;
}

char *Linnette_nouns() {
    char *s = calloc(9);
    if (crc32("MRtBxmdoSrLGm",13) == 1483991606) strcat(s, "c");
if (crc32("NLrSPzWbgd",10) == 1695631964) strcat(s, "L");
if (crc32("GqFtXQNZbUrvw",13) == 2806874699) strcat(s, "i");
if (crc32("Rexwa",5) == 2283858832) strcat(s, "n");
if (crc32("lXVpfIxn",8) == 4256393049) strcat(s, "n");
if (crc32("GrJgmAV",7) == 782665108) strcat(s, "E");
if (crc32("AbFtQIj",7) == 3898649933) strcat(s, "e");
if (crc32("godcqM",6) == 480273648) strcat(s, "S");
if (crc32("mmbLDjHUDntv",12) == 2386494037) strcat(s, "t");
if (crc32("lYPKEM",6) == 4114688201) strcat(s, "M");
if (crc32("qxnblrhQKfZUO",13) == 3349405574) strcat(s, "t");
if (crc32("sZigtTUC",8) == 1981266347) strcat(s, "f");
if (crc32("dwsxhaOzGIMIPBa",15) == 637554170) strcat(s, "e");
    return s;
}

char *Greenman_nouns() {
    char *s = calloc(9);
    if (crc32("WfQCTiOEXGIC",12) == 784545991) strcat(s, "G");
if (crc32("HezjESnkqUuvY",13) == 1977372842) strcat(s, "r");
if (crc32("snZZNOjSJKf",11) == 4163339864) strcat(s, "c");
if (crc32("QugOHlyeCmzYkRo",15) == 163413615) strcat(s, "e");
if (crc32("YwGTnAMYSwWY",12) == 2421516599) strcat(s, "e");
if (crc32("AURLpVmjUr",10) == 1998914788) strcat(s, "n");
if (crc32("zhwYycuNoUybtVs",15) == 2737178471) strcat(s, "a");
if (crc32("MszOAQllbgrj",12) == 2099353862) strcat(s, "m");
if (crc32("GAvfdWzcOjxqrYO",15) == 3702513239) strcat(s, "a");
if (crc32("svoeOiCxluiz",12) == 2169910970) strcat(s, "n");
    return s;
}

char *Wolsey_nouns() {
    char *s = calloc(7);
    if (crc32("KpiElPzd",8) == 3022979820) strcat(s, "b");
if (crc32("SmGmYLkkdnoryy",14) == 860980654) strcat(s, "W");
if (crc32("pDgSPFqq",8) == 2564549026) strcat(s, "S");
if (crc32("FqxzhIAVF",9) == 320707965) strcat(s, "o");
if (crc32("iNHjcfgmNzFHp",13) == 2213283816) strcat(s, "l");
if (crc32("GhVPjSJGYxUEYrZ",15) == 3705313400) strcat(s, "s");
if (crc32("RaDtHxpSfvAfpwD",15) == 1956993983) strcat(s, "t");
if (crc32("ZoDkAGuqqLAXui",14) == 1391248209) strcat(s, "e");
if (crc32("SjTtCAnLraOOu",13) == 3278843203) strcat(s, "y");
    return s;
}

char *cecity_nouns() {
    char *s = calloc(7);
    if (crc32("GfRTNce",7) == 3453841897) strcat(s, "c");
if (crc32("VZFSC",5) == 3751136639) strcat(s, "e");
if (crc32("QOcnDqNkEZc",11) == 691254832) strcat(s, "Y");
if (crc32("PZCnRzaiIilLiGF",15) == 1019098458) strcat(s, "c");
if (crc32("SeLeQgIC",8) == 3188337440) strcat(s, "i");
if (crc32("GILXGv",6) == 2747694627) strcat(s, "F");
if (crc32("jAmVvXcW",8) == 1382565699) strcat(s, "t");
if (crc32("GjAJDjMdUBNI",12) == 2854610991) strcat(s, "j");
if (crc32("sTgUWdHFThaMC",13) == 763666191) strcat(s, "y");
    return s;
}

char *shrubbery_nouns() {
    char *s = calloc(10);
    if (crc32("XZGEtoUC",8) == 1803647436) strcat(s, "S");
if (crc32("wHtwVqWcZXj",11) == 2816214587) strcat(s, "s");
if (crc32("BVsIopGFYK",10) == 1930597245) strcat(s, "h");
if (crc32("qNNxxrcgCGv",11) == 491892153) strcat(s, "n");
if (crc32("mPcPRjXSFWyH",12) == 197747952) strcat(s, "r");
if (crc32("wDHjR",5) == 941027647) strcat(s, "L");
if (crc32("LNhdZuJX",8) == 513630561) strcat(s, "u");
if (crc32("kpBiDsRWNE",10) == 1021043757) strcat(s, "i");
if (crc32("kehETASHJBu",11) == 81457431) strcat(s, "b");
if (crc32("nABDGyShwvSHF",13) == 829904343) strcat(s, "f");
if (crc32("zlHkpBW",7) == 1297579312) strcat(s, "b");
if (crc32("DAoigrP",7) == 1638649556) strcat(s, "j");
if (crc32("jKIHaRdJto",10) == 3872549856) strcat(s, "e");
if (crc32("mJqURinSjlfhK",13) == 2633963007) strcat(s, "r");
if (crc32("hiyPLLWEIbK",11) == 2969708255) strcat(s, "y");
    return s;
}

char *Alliber_nouns() {
    char *s = calloc(8);
    if (crc32("foDNvAf",7) == 1205822562) strcat(s, "A");
if (crc32("TbQwd",5) == 3712069481) strcat(s, "l");
if (crc32("IHTphzkAtMhf",12) == 596959442) strcat(s, "l");
if (crc32("RpefAOrLig",10) == 526189601) strcat(s, "i");
if (crc32("ZDZVKoIMr",9) == 958486360) strcat(s, "b");
if (crc32("BaRlHWRvKyUB",12) == 1546897129) strcat(s, "s");
if (crc32("lslDbQtzahlkNw",14) == 341747463) strcat(s, "e");
if (crc32("LGAgAlUJt",9) == 4033586068) strcat(s, "l");
if (crc32("NYjESGcQckGDZKk",15) == 171747013) strcat(s, "r");
    return s;
}

char *lizzie_nouns() {
    char *s = calloc(7);
    if (crc32("WzpOLEmwF",9) == 3699314972) strcat(s, "i");
if (crc32("PuJyJcvKgsncFA",14) == 1392907399) strcat(s, "l");
if (crc32("epvZkMaScteSa",13) == 2288058451) strcat(s, "M");
if (crc32("EpiqORN",7) == 2784215832) strcat(s, "i");
if (crc32("LNAbfYK",7) == 419703945) strcat(s, "z");
if (crc32("YDcXs",5) == 380114798) strcat(s, "z");
if (crc32("fzXLnEXwHNqQb",13) == 4191234060) strcat(s, "r");
if (crc32("gtzIBkgVjXHW",12) == 1099854759) strcat(s, "i");
if (crc32("XuLofKl",7) == 858569454) strcat(s, "e");
    return s;
}

char *nonnumeral_nouns() {
    char *s = calloc(11);
    if (crc32("NTvQFgCENYfJJXz",15) == 2588312698) strcat(s, "n");
if (crc32("YfavKjzziul",11) == 3339782353) strcat(s, "y");
if (crc32("GxiQJ",5) == 4040544003) strcat(s, "o");
if (crc32("mYUXBaAjwb",10) == 2615775533) strcat(s, "o");
if (crc32("IiNDkTGDDKFfKg",14) == 348137796) strcat(s, "n");
if (crc32("xjgPMbxxrCXFCqR",15) == 1416955224) strcat(s, "x");
if (crc32("QgyWafrzQdKBdmD",15) == 880812737) strcat(s, "n");
if (crc32("WbnJtKCEVROyQr",14) == 272846628) strcat(s, "g");
if (crc32("ddyIeraeetCdiyS",15) == 3017068729) strcat(s, "u");
if (crc32("zSSoHzdHwSniqtu",15) == 2928801061) strcat(s, "A");
if (crc32("CsUdJrVTrRnplh",14) == 3179687198) strcat(s, "m");
if (crc32("utAEG",5) == 1715263598) strcat(s, "k");
if (crc32("sqbaIZGpDrkcdAW",15) == 490101304) strcat(s, "e");
if (crc32("ZojjI",5) == 3845935265) strcat(s, "a");
if (crc32("bEWAvTdNhroFqwv",15) == 1799055904) strcat(s, "r");
if (crc32("nnajONwSSFpBL",13) == 3681321048) strcat(s, "a");
if (crc32("EgTYNVE",7) == 2347862672) strcat(s, "G");
if (crc32("DvchtQlarRPRYr",14) == 1662311059) strcat(s, "l");
    return s;
}

char *jouk_nouns() {
    char *s = calloc(5);
    if (crc32("EUlzINlc",8) == 940392843) strcat(s, "j");
if (crc32("BzEbaHmwqlw",11) == 161072071) strcat(s, "o");
if (crc32("abGrNoHul",9) == 3983718738) strcat(s, "K");
if (crc32("TzJtRyr",7) == 966746927) strcat(s, "u");
if (crc32("GzWynuQBFn",10) == 1368043570) strcat(s, "p");
if (crc32("dESbAcIYGAY",11) == 737294271) strcat(s, "k");
    return s;
}

char *Carpaccio_nouns() {
    char *s = calloc(10);
    if (crc32("djjYgZyEYGca",12) == 2899188380) strcat(s, "C");
if (crc32("yhoKH",5) == 3832772926) strcat(s, "a");
if (crc32("ILDNOmoHMqKn",12) == 62902503) strcat(s, "c");
if (crc32("TcKWqLOVGVbLQRE",15) == 2456503486) strcat(s, "r");
if (crc32("jUPWJR",6) == 945105476) strcat(s, "R");
if (crc32("iazXPXCjI",9) == 1982408589) strcat(s, "p");
if (crc32("npGVJumnBiE",11) == 4128923690) strcat(s, "G");
if (crc32("knFOHFTxgNyboa",14) == 623752521) strcat(s, "a");
if (crc32("suIZhnkbKf",10) == 1910778910) strcat(s, "t");
if (crc32("gStROVwVBhMMN",13) == 3575759149) strcat(s, "c");
if (crc32("ZBOEnmsWUGzqAP",14) == 2327328594) strcat(s, "S");
if (crc32("UloAnOhA",8) == 2751664712) strcat(s, "c");
if (crc32("ZYXGFYiulenbamk",15) == 801276073) strcat(s, "i");
if (crc32("mugBlvnKsE",10) == 3489027000) strcat(s, "r");
if (crc32("FhNRFfi",7) == 2869548964) strcat(s, "o");
    return s;
}

char *dimercaprol_nouns() {
    char *s = calloc(12);
    if (crc32("EfnuzwrlxbVT",12) == 1364363389) strcat(s, "k");
if (crc32("CkEvAjwqGY",10) == 3207003841) strcat(s, "d");
if (crc32("EYGncPYlm",9) == 126792088) strcat(s, "i");
if (crc32("nDkqq",5) == 673373286) strcat(s, "a");
if (crc32("YnLVCDMw",8) == 1318057816) strcat(s, "m");
if (crc32("gjhwdaZQoVtwY",13) == 1983428907) strcat(s, "G");
if (crc32("eDHJJBcNxKas",12) == 245418060) strcat(s, "e");
if (crc32("oHZcBHEhUn",10) == 3805066975) strcat(s, "L");
if (crc32("qULDSrRHkirjdYx",15) == 1627964174) strcat(s, "r");
if (crc32("nztmZlLKphaMq",13) == 4117897760) strcat(s, "c");
if (crc32("VfdAkgE",7) == 3174898709) strcat(s, "e");
if (crc32("uUGNILyIMrUc",12) == 1160282230) strcat(s, "a");
if (crc32("gsNXbvTiK",9) == 835931007) strcat(s, "E");
if (crc32("CsWMtiB",7) == 4183911440) strcat(s, "p");
if (crc32("GarFaYztV",9) == 1613187414) strcat(s, "r");
if (crc32("GSijYwE",7) == 1964851815) strcat(s, "f");
if (crc32("dlWLRGiIrqFDbLb",15) == 2933916392) strcat(s, "o");
if (crc32("hPWvZJXGVR",10) == 772632369) strcat(s, "l");
    return s;
}

char *Sherer_nouns() {
    char *s = calloc(7);
    if (crc32("AQBEo",5) == 4078792708) strcat(s, "S");
if (crc32("HaumYjFhTlMb",12) == 2542392192) strcat(s, "h");
if (crc32("XKSBlOAuBsSi",12) == 351270202) strcat(s, "e");
if (crc32("fqcJvLalT",9) == 2946069908) strcat(s, "E");
if (crc32("hMcINrAaEiDGNa",14) == 249311348) strcat(s, "r");
if (crc32("ZJNAk",5) == 154074736) strcat(s, "e");
if (crc32("EcymKe",6) == 3278756911) strcat(s, "I");
if (crc32("KtYGiD",6) == 3729888009) strcat(s, "r");
    return s;
}

char *thymine_nouns() {
    char *s = calloc(8);
    if (crc32("TpHaOUFusdfAba",14) == 4189678097) strcat(s, "l");
if (crc32("DLcjFGAanIqM",12) == 4086051277) strcat(s, "t");
if (crc32("JvVUCQFCv",9) == 2701865738) strcat(s, "h");
if (crc32("QXBizKtfaMx",11) == 707794926) strcat(s, "y");
if (crc32("yUIbqqogB",9) == 3819943993) strcat(s, "z");
if (crc32("GGCjTEDGVltRRa",14) == 2004757896) strcat(s, "m");
if (crc32("rZGOblyR",8) == 3513536779) strcat(s, "c");
if (crc32("Wjuix",5) == 2689691898) strcat(s, "i");
if (crc32("UhznIV",6) == 2444158309) strcat(s, "a");
if (crc32("LIYps",5) == 946018733) strcat(s, "n");
if (crc32("hpnri",5) == 1869696943) strcat(s, "e");
    return s;
}

char *rostra_nouns() {
    char *s = calloc(7);
    if (crc32("ChaOlLEN",8) == 2004410442) strcat(s, "r");
if (crc32("VcKlFNToY",9) == 3851473768) strcat(s, "w");
if (crc32("FpxpRlBc",8) == 1311130435) strcat(s, "o");
if (crc32("OhlRA",5) == 1129612067) strcat(s, "U");
if (crc32("fzThbzn",7) == 3627809932) strcat(s, "s");
if (crc32("LrEMmeUOqKCBaW",14) == 966943749) strcat(s, "Q");
if (crc32("ULyPfLAbolipXpJ",15) == 1092088008) strcat(s, "t");
if (crc32("slTiJKU",7) == 3253088456) strcat(s, "r");
if (crc32("aqxmmiW",7) == 412599835) strcat(s, "C");
if (crc32("NLQBUlzwU",9) == 3930324273) strcat(s, "a");
    return s;
}

char *Henrie_nouns() {
    char *s = calloc(7);
    if (crc32("gNLfSddKJPKyNV",14) == 3739154806) strcat(s, "H");
if (crc32("hTbzpNyyHQpF",12) == 2600240795) strcat(s, "U");
if (crc32("ziartQKAuepaibL",15) == 3712270039) strcat(s, "e");
if (crc32("IOJXiwiMGhE",11) == 4252150812) strcat(s, "U");
if (crc32("Pptbt",5) == 3327517894) strcat(s, "n");
if (crc32("LeuJs",5) == 3329845462) strcat(s, "r");
if (crc32("OOVdzkQYL",9) == 3363706154) strcat(s, "e");
if (crc32("kUjYDYOcq",9) == 685551987) strcat(s, "i");
if (crc32("bkhtbSP",7) == 3641686964) strcat(s, "a");
if (crc32("eEnQDYfw",8) == 1447711186) strcat(s, "e");
    return s;
}

char *aminase_nouns() {
    char *s = calloc(8);
    if (crc32("fAUHmojVX",9) == 464869911) strcat(s, "f");
if (crc32("VivQrnv",7) == 3806072535) strcat(s, "a");
if (crc32("TLucFxdkwFGafva",15) == 2165163079) strcat(s, "m");
if (crc32("xonnkMejpGxB",12) == 2198375588) strcat(s, "i");
if (crc32("iuaMWWnWpyDFS",13) == 4243891290) strcat(s, "t");
if (crc32("sfGtMoLdnHjpyI",14) == 2703020539) strcat(s, "n");
if (crc32("BxXsCeeVHhcC",12) == 2820056528) strcat(s, "a");
if (crc32("MwsbKoHN",8) == 913000201) strcat(s, "s");
if (crc32("VnXMjq",6) == 1106666953) strcat(s, "B");
if (crc32("tBriwp",6) == 3037324264) strcat(s, "e");
    return s;
}

char *Severinus_nouns() {
    char *s = calloc(10);
    if (crc32("vhMGGxQ",7) == 3733734141) strcat(s, "S");
if (crc32("JchMPmk",7) == 1438955355) strcat(s, "e");
if (crc32("KvjfyKxmlT",10) == 3890266053) strcat(s, "v");
if (crc32("OqdtI",5) == 3297761606) strcat(s, "e");
if (crc32("IjspStZ",7) == 2664066458) strcat(s, "r");
if (crc32("ZkzeqcQ",7) == 3236901408) strcat(s, "i");
if (crc32("OHUksXAzzadVa",13) == 760392210) strcat(s, "n");
if (crc32("CzYfzuQPfdMtGm",14) == 3823749081) strcat(s, "A");
if (crc32("sBqDv",5) == 822976987) strcat(s, "u");
if (crc32("NYUFNQp",7) == 1710519004) strcat(s, "s");
    return s;
}

char *imperialization_nouns() {
    char *s = calloc(16);
    if (crc32("abDoclgIrpf",11) == 2997760668) strcat(s, "n");
if (crc32("IobiCQZvAjLm",12) == 3237068787) strcat(s, "i");
if (crc32("eLWDwDgtY",9) == 3730572659) strcat(s, "e");
if (crc32("qCuCMkNeka",10) == 1476580235) strcat(s, "m");
if (crc32("XWduHEXWjZWY",12) == 642221231) strcat(s, "p");
if (crc32("IBKyIgkw",8) == 4074079759) strcat(s, "e");
if (crc32("hpfaqqbgWuNBDj",14) == 3635498972) strcat(s, "U");
if (crc32("KPZkhy",6) == 2290186231) strcat(s, "r");
if (crc32("EaULPEaV",8) == 2277180347) strcat(s, "O");
if (crc32("OuebFUEO",8) == 794904219) strcat(s, "i");
if (crc32("BEenyNMwFZDQdQV",15) == 774464187) strcat(s, "G");
if (crc32("jBArPQT",7) == 4152731924) strcat(s, "a");
if (crc32("CXGKMMfXiXgu",12) == 2972453527) strcat(s, "l");
if (crc32("TIAiHhsl",8) == 2562731278) strcat(s, "r");
if (crc32("viaKQ",5) == 2959739968) strcat(s, "i");
if (crc32("GtFaIsfA",8) == 3683520182) strcat(s, "B");
if (crc32("OFLjS",5) == 3054422179) strcat(s, "z");
if (crc32("HjwQokIlVK",10) == 971235960) strcat(s, "a");
if (crc32("drAZSmFv",8) == 2049014332) strcat(s, "t");
if (crc32("NGqkIbpJIBxuDd",14) == 594801480) strcat(s, "i");
if (crc32("qZlvmdWwRWaHTGB",15) == 586157819) strcat(s, "o");
if (crc32("lddvWZ",6) == 322392574) strcat(s, "E");
if (crc32("owBJNe",6) == 480268047) strcat(s, "n");
    return s;
}

char *hyperexcitableness_nouns() {
    char *s = calloc(19);
    if (crc32("OJHLtsJsmgchnFE",15) == 1254959660) strcat(s, "c");
if (crc32("cviIpTxshk",10) == 220038575) strcat(s, "h");
if (crc32("IkMQNiiJqXqST",13) == 739743823) strcat(s, "y");
if (crc32("vLFcko",6) == 1582319114) strcat(s, "p");
if (crc32("ZqAJzWhEUVFGw",13) == 3681123627) strcat(s, "e");
if (crc32("hoTcWB",6) == 768723627) strcat(s, "r");
if (crc32("lACVfYtrpKu",11) == 1904224007) strcat(s, "W");
if (crc32("kdDIIMvUEWNXeN",14) == 1375234916) strcat(s, "e");
if (crc32("xBLSdhfcALxmqa",14) == 3573451898) strcat(s, "z");
if (crc32("SwfNdjumsYfc",12) == 2438058411) strcat(s, "x");
if (crc32("DmMXKZKojU",10) == 3890512129) strcat(s, "c");
if (crc32("glkiNbA",7) == 260333056) strcat(s, "S");
if (crc32("fgjnYQzJlKVPzB",14) == 1961717414) strcat(s, "i");
if (crc32("wIWMJCLvDrIMhC",14) == 292250101) strcat(s, "w");
if (crc32("gIvqkBTr",8) == 2293481518) strcat(s, "t");
if (crc32("kYlETJmIu",9) == 313043521) strcat(s, "g");
if (crc32("CABjkFRF",8) == 1046280738) strcat(s, "a");
if (crc32("WPBrrrrPlGRIS",13) == 180553769) strcat(s, "j");
if (crc32("JwRICp",6) == 3253577962) strcat(s, "b");
if (crc32("QyGFHITHLuDbj",13) == 629675133) strcat(s, "l");
if (crc32("tEcHGcMgkM",10) == 3353375447) strcat(s, "e");
if (crc32("PovuoOf",7) == 961891120) strcat(s, "L");
if (crc32("onhCSicl",8) == 3640570012) strcat(s, "n");
if (crc32("kBAWEsXljoyHXr",14) == 1400936376) strcat(s, "p");
if (crc32("jLeHx",5) == 3959442108) strcat(s, "e");
if (crc32("zRfzVm",6) == 3244405185) strcat(s, "s");
if (crc32("knTITWTM",8) == 4069312714) strcat(s, "l");
if (crc32("TVbNu",5) == 3759224350) strcat(s, "s");
    return s;
}

char *gu_nouns() {
    char *s = calloc(3);
    if (crc32("FTGlHQzirKb",11) == 2047612263) strcat(s, "g");
if (crc32("IFBuN",5) == 2643227214) strcat(s, "u");
    return s;
}

char *Adapa_nouns() {
    char *s = calloc(6);
    if (crc32("uZISYcMYfqrFxUM",15) == 3127413559) strcat(s, "A");
if (crc32("TlepMqUp",8) == 402579261) strcat(s, "B");
if (crc32("LbMtsdSQZIKZ",12) == 294131748) strcat(s, "d");
if (crc32("jWGsiYDTccJ",11) == 1424214330) strcat(s, "a");
if (crc32("KzLQnjB",7) == 1137225365) strcat(s, "V");
if (crc32("SStrIhnKehDV",12) == 1072432216) strcat(s, "p");
if (crc32("YwAmTmBxnbUpYs",14) == 1701890609) strcat(s, "U");
if (crc32("zYxHgsuSh",9) == 658262572) strcat(s, "a");
    return s;
}

char *sarrazin_nouns() {
    char *s = calloc(9);
    if (crc32("xNsVTPl",7) == 1047910001) strcat(s, "O");
if (crc32("RTfnEJp",7) == 1601238596) strcat(s, "s");
if (crc32("eUAcehZoBemHna",14) == 2717207883) strcat(s, "d");
if (crc32("gRLnqeTw",8) == 3640082323) strcat(s, "a");
if (crc32("oaYlVJCtBNBnde",14) == 1426428077) strcat(s, "t");
if (crc32("JGIBr",5) == 3517799593) strcat(s, "r");
if (crc32("dCoKKNSjPEV",11) == 853996009) strcat(s, "r");
if (crc32("qGqFgeQMxrI",11) == 1697650838) strcat(s, "n");
if (crc32("ohVsA",5) == 1311424860) strcat(s, "a");
if (crc32("BNinrhyU",8) == 278173530) strcat(s, "P");
if (crc32("jGIUvSChFzAy",12) == 1669797105) strcat(s, "z");
if (crc32("XHKgO",5) == 3472934702) strcat(s, "F");
if (crc32("uESIfyozgZVUQTk",15) == 4087538048) strcat(s, "i");
if (crc32("SbqMWEKBEspM",12) == 3717005510) strcat(s, "n");
    return s;
}

char *Swed_nouns() {
    char *s = calloc(5);
    if (crc32("iliwgKyHUDqdsm",14) == 988720314) strcat(s, "Y");
if (crc32("nhEUmcUhYtHZk",13) == 2130490288) strcat(s, "S");
if (crc32("JWXWDvgvJRpy",12) == 2425309752) strcat(s, "w");
if (crc32("ZwWkUDfZGzDEN",13) == 1190851062) strcat(s, "A");
if (crc32("KOLUsXmJL",9) == 279154793) strcat(s, "e");
if (crc32("myOKB",5) == 1093588856) strcat(s, "d");
    return s;
}

char *bibb_nouns() {
    char *s = calloc(5);
    if (crc32("QTOgEg",6) == 1807010191) strcat(s, "b");
if (crc32("SCfQYOy",7) == 1577791953) strcat(s, "i");
if (crc32("hbBiuxNvPQ",10) == 966031824) strcat(s, "b");
if (crc32("EmCzMDgyujELB",13) == 2922096902) strcat(s, "X");
if (crc32("phlryrtbrnjpM",13) == 3862688018) strcat(s, "b");
    return s;
}

char *logbook_nouns() {
    char *s = calloc(8);
    if (crc32("Hckhn",5) == 4173155022) strcat(s, "y");
if (crc32("TSozZWCIY",9) == 2700094638) strcat(s, "l");
if (crc32("GZeQBoWgsiUpXW",14) == 4050097049) strcat(s, "o");
if (crc32("HSpLQNBsMswGZaz",15) == 2783447684) strcat(s, "g");
if (crc32("ECiOgiM",7) == 2752286803) strcat(s, "b");
if (crc32("jMQzakDwEiyaCR",14) == 1964032303) strcat(s, "i");
if (crc32("gLITLtEluZvh",12) == 3570932235) strcat(s, "o");
if (crc32("OXDbo",5) == 4016918328) strcat(s, "o");
if (crc32("FfUJHfCtyr",10) == 3443318582) strcat(s, "k");
    return s;
}

char *antiunionist_nouns() {
    char *s = calloc(13);
    if (crc32("XlQNwByMEWrJtZ",14) == 499832689) strcat(s, "r");
if (crc32("yGPQGdspXX",10) == 3353820110) strcat(s, "a");
if (crc32("Yukahg",6) == 1890669410) strcat(s, "n");
if (crc32("qZgypTNlzSNDlI",14) == 4199005391) strcat(s, "t");
if (crc32("gtktbW",6) == 106247380) strcat(s, "a");
if (crc32("tYqTYTXiOg",10) == 2116265716) strcat(s, "i");
if (crc32("zPvUyTgHNoWhV",13) == 1972157269) strcat(s, "K");
if (crc32("ZaKqeK",6) == 1478954606) strcat(s, "u");
if (crc32("WyfCYKYjCY",10) == 3680033231) strcat(s, "b");
if (crc32("gQwdfAtuxZNmE",13) == 2622126461) strcat(s, "n");
if (crc32("RphsSAE",7) == 3131052883) strcat(s, "v");
if (crc32("zQxCx",5) == 3650730900) strcat(s, "i");
if (crc32("fLosEmyCUnD",11) == 3387412083) strcat(s, "o");
if (crc32("TLIsQNZFvqQBJd",14) == 3860174779) strcat(s, "g");
if (crc32("SjGTzsoXbeQ",11) == 3091323799) strcat(s, "n");
if (crc32("IlmYEWjfqndqcZx",15) == 297967084) strcat(s, "a");
if (crc32("vKbBTjAyHaV",11) == 2404496529) strcat(s, "i");
if (crc32("ThzFKZV",7) == 3489028622) strcat(s, "k");
if (crc32("qSbdCCBwIr",10) == 895837239) strcat(s, "s");
if (crc32("VtseE",5) == 3718710857) strcat(s, "t");
    return s;
}

char *canonicate_nouns() {
    char *s = calloc(11);
    if (crc32("uSqyzmdmISzhJGS",15) == 859360124) strcat(s, "c");
if (crc32("WJVTDzsjV",9) == 3279565060) strcat(s, "j");
if (crc32("xemPaTQ",7) == 1003699104) strcat(s, "a");
if (crc32("KdDyLdcGBVGI",12) == 2635351748) strcat(s, "n");
if (crc32("CmFxmTVrxgIgg",13) == 2847802192) strcat(s, "o");
if (crc32("XnRTnNniKERhE",13) == 372560805) strcat(s, "o");
if (crc32("vgDBXvLEhl",10) == 2726438112) strcat(s, "t");
if (crc32("cSzXMpKdlwdQ",12) == 2278219799) strcat(s, "n");
if (crc32("NNvAeDJvPtMkIM",14) == 1205870885) strcat(s, "i");
if (crc32("FDoaSzALcZPJ",12) == 2605631844) strcat(s, "C");
if (crc32("JIOVrg",6) == 796608375) strcat(s, "c");
if (crc32("LVDbuBiyX",9) == 4241114407) strcat(s, "K");
if (crc32("cpUvFDChcBa",11) == 3870991391) strcat(s, "a");
if (crc32("TQanecJGaXAI",12) == 906931562) strcat(s, "t");
if (crc32("rNpXCzdxkZfUIA",14) == 2752119417) strcat(s, "e");
    return s;
}

char *stomachache_nouns() {
    char *s = calloc(12);
    if (crc32("YvJhAmpSE",9) == 957698411) strcat(s, "s");
if (crc32("ZFFcGCcLQwOaiS",14) == 690913665) strcat(s, "t");
if (crc32("fdFksl",6) == 307756939) strcat(s, "m");
if (crc32("eKfHPkRqssLIwk",14) == 889770631) strcat(s, "o");
if (crc32("wRQgMLiIq",9) == 3313872348) strcat(s, "m");
if (crc32("FwRcIyiLR",9) == 2832025352) strcat(s, "g");
if (crc32("guNoSSEQw",9) == 1790314090) strcat(s, "a");
if (crc32("YSBSkHUqYCz",11) == 4041035387) strcat(s, "U");
if (crc32("vKkEFAe",7) == 2513319026) strcat(s, "c");
if (crc32("TwASnPucYhidmyo",15) == 973075307) strcat(s, "h");
if (crc32("JDTgO",5) == 1736269714) strcat(s, "a");
if (crc32("XuIGWk",6) == 3699292983) strcat(s, "c");
if (crc32("LKvtOZvtG",9) == 953666749) strcat(s, "h");
if (crc32("wAuQbGXsxakTAC",14) == 3447655803) strcat(s, "e");
    return s;
}

char *nonchurchgoer_nouns() {
    char *s = calloc(14);
    if (crc32("ldRSfbBZiV",10) == 2008976420) strcat(s, "n");
if (crc32("FRUhDKrfTmX",11) == 1166176759) strcat(s, "o");
if (crc32("esSJfQZhs",9) == 236723315) strcat(s, "n");
if (crc32("SYPFZRC",7) == 617560539) strcat(s, "c");
if (crc32("SASNAqTkFkaBbsX",15) == 2948054344) strcat(s, "h");
if (crc32("LIdEeC",6) == 2851205435) strcat(s, "u");
if (crc32("ZiosVSeUiXXh",12) == 1408651996) strcat(s, "r");
if (crc32("YuVKzPwMC",9) == 1933686927) strcat(s, "I");
if (crc32("dkIVJbjPMH",10) == 3684768340) strcat(s, "c");
if (crc32("LLmyohLdJI",10) == 2799567896) strcat(s, "h");
if (crc32("glbam",5) == 3027487763) strcat(s, "r");
if (crc32("pUDKTJDw",8) == 1617123254) strcat(s, "g");
if (crc32("avyokVuIoYldCbf",15) == 758790623) strcat(s, "o");
if (crc32("hEvmWVy",7) == 179295970) strcat(s, "q");
if (crc32("zaECXRcoQzPv",12) == 905942205) strcat(s, "e");
if (crc32("mCUyIituhscjq",13) == 2997275907) strcat(s, "g");
if (crc32("vFEvDNVra",9) == 3628013734) strcat(s, "r");
    return s;
}

char *traumatization_nouns() {
    char *s = calloc(15);
    if (crc32("CuibcChvTqp",11) == 2749464964) strcat(s, "p");
if (crc32("tUtkTmtsf",9) == 3681556597) strcat(s, "t");
if (crc32("NRBfKfeYPl",10) == 1301767777) strcat(s, "k");
if (crc32("NuHeX",5) == 2125716423) strcat(s, "r");
if (crc32("JblHJuUaIfDlGI",14) == 3041152266) strcat(s, "a");
if (crc32("afyhArU",7) == 553653433) strcat(s, "m");
if (crc32("iOVWxAkC",8) == 4264449178) strcat(s, "u");
if (crc32("ZebAspiH",8) == 3114726115) strcat(s, "m");
if (crc32("hLDrByJH",8) == 3941608955) strcat(s, "a");
if (crc32("IADyiVXeBZY",11) == 3160859214) strcat(s, "Q");
if (crc32("bBOVmJvx",8) == 4276067995) strcat(s, "t");
if (crc32("zvOEiPBXPkjDRCc",15) == 2499761541) strcat(s, "i");
if (crc32("xOyaKzkshnu",11) == 1712418369) strcat(s, "U");
if (crc32("BYnyKGn",7) == 1018246039) strcat(s, "z");
if (crc32("nlIquwvlbE",10) == 1298468071) strcat(s, "T");
if (crc32("wgcXTPTJergrB",13) == 2896887305) strcat(s, "a");
if (crc32("cRnZMQeizZMgS",13) == 938689011) strcat(s, "t");
if (crc32("MYpzMBIlhCz",11) == 2656885270) strcat(s, "g");
if (crc32("BdqRpkdfyp",10) == 534522123) strcat(s, "i");
if (crc32("jdutlrvdoNDFFIQ",15) == 2316222812) strcat(s, "o");
if (crc32("gFmXKdWihj",10) == 2271637605) strcat(s, "c");
if (crc32("TxIiE",5) == 1761134043) strcat(s, "n");
    return s;
}

char *Ctesius_nouns() {
    char *s = calloc(8);
    if (crc32("TpgErGbOrumkBEV",15) == 1805396796) strcat(s, "C");
if (crc32("JUKQQtPf",8) == 4066241274) strcat(s, "t");
if (crc32("OOzGozvVqYEN",12) == 2692060300) strcat(s, "e");
if (crc32("xGVWJxmpVwjrnEw",15) == 1313554252) strcat(s, "s");
if (crc32("pkTRS",5) == 3264077348) strcat(s, "i");
if (crc32("RozIDrCnx",9) == 1745879464) strcat(s, "u");
if (crc32("StoPchxYqOaQf",13) == 130255154) strcat(s, "d");
if (crc32("SdXdsWyeHAEhxb",14) == 3622907193) strcat(s, "s");
    return s;
}

char *Ingelow_nouns() {
    char *s = calloc(8);
    if (crc32("LTtsKcD",7) == 3215858723) strcat(s, "I");
if (crc32("eKtmf",5) == 2814835718) strcat(s, "w");
if (crc32("bvTdyEMnGsw",11) == 19829489) strcat(s, "n");
if (crc32("OZTbgDOnOWpzyb",14) == 3339357153) strcat(s, "Y");
if (crc32("GPKuLPlsNyfWB",13) == 1784566946) strcat(s, "g");
if (crc32("WNVHtfsvfGyvp",13) == 1460792148) strcat(s, "g");
if (crc32("zAoXrJuVuZRdM",13) == 3158297540) strcat(s, "e");
if (crc32("kLVoyNnmzXK",11) == 4254168961) strcat(s, "l");
if (crc32("HdaUUt",6) == 1194498086) strcat(s, "o");
if (crc32("emfOOUBOK",9) == 1861879357) strcat(s, "w");
    return s;
}

char *claybank_nouns() {
    char *s = calloc(9);
    if (crc32("XvQVvaiqg",9) == 606953020) strcat(s, "B");
if (crc32("SDlGDTjrYYWE",12) == 1369250677) strcat(s, "c");
if (crc32("ZQsImdlR",8) == 915197794) strcat(s, "l");
if (crc32("sSDgaLD",7) == 1373145338) strcat(s, "B");
if (crc32("qiNEbBOwrNdAdE",14) == 3471195604) strcat(s, "a");
if (crc32("YBVhSJL",7) == 997590823) strcat(s, "y");
if (crc32("GoBuBDeJ",8) == 1732530072) strcat(s, "m");
if (crc32("jpgicymP",8) == 2151274179) strcat(s, "b");
if (crc32("aKdNyqtogeWyef",14) == 2024111672) strcat(s, "a");
if (crc32("EKnQTIDIlNxH",12) == 1368723927) strcat(s, "h");
if (crc32("XpFDSLjzsE",10) == 4263271877) strcat(s, "n");
if (crc32("WyDYfgJu",8) == 2614559432) strcat(s, "k");
    return s;
}

char *daywork_nouns() {
    char *s = calloc(8);
    if (crc32("OqVZa",5) == 3721546094) strcat(s, "d");
if (crc32("oNCGGheEqhD",11) == 2765448295) strcat(s, "V");
if (crc32("LyIZiklbe",9) == 1122877109) strcat(s, "a");
if (crc32("VLcLBnpurWWDJb",14) == 2653113769) strcat(s, "u");
if (crc32("VGyqVWQGXcsjKHN",15) == 4047527313) strcat(s, "y");
if (crc32("CBBJesAV",8) == 1884474885) strcat(s, "w");
if (crc32("jSZqoDUWwJz",11) == 1062397172) strcat(s, "u");
if (crc32("creFObDhOEgHtDj",15) == 2704242594) strcat(s, "o");
if (crc32("AcSMvu",6) == 1403293931) strcat(s, "r");
if (crc32("pVlvVD",6) == 2976888075) strcat(s, "k");
    return s;
}

char *pacifico_nouns() {
    char *s = calloc(9);
    if (crc32("WhBbMCYb",8) == 4036885870) strcat(s, "p");
if (crc32("thTEVFbdpAZQdo",14) == 1639767765) strcat(s, "a");
if (crc32("AynkcTflLa",10) == 3062607035) strcat(s, "g");
if (crc32("lPCechWWYgKMuw",14) == 3564168192) strcat(s, "c");
if (crc32("CKmyexDojHBgu",13) == 3931315226) strcat(s, "c");
if (crc32("VKEhG",5) == 245983485) strcat(s, "i");
if (crc32("sVKdBMLKYmqs",12) == 3631590620) strcat(s, "O");
if (crc32("fZOVpSfqXjEuZ",13) == 1993970462) strcat(s, "f");
if (crc32("EDpYarnPyiagcWS",15) == 3596415942) strcat(s, "i");
if (crc32("sWFKAEoqFQIueyS",15) == 4182794474) strcat(s, "c");
if (crc32("MxWyidAIcBW",11) == 3468544316) strcat(s, "c");
if (crc32("Axlalxl",7) == 2769733884) strcat(s, "o");
    return s;
}

char *snot_nouns() {
    char *s = calloc(5);
    if (crc32("BmioL",5) == 4149500310) strcat(s, "s");
if (crc32("bUMnMKmD",8) == 1605003791) strcat(s, "o");
if (crc32("CpqDdag",7) == 3548870319) strcat(s, "n");
if (crc32("ShNvmm",6) == 4071543872) strcat(s, "p");
if (crc32("tyIugsbO",8) == 1816374647) strcat(s, "o");
if (crc32("tsqRzUphv",9) == 4217574749) strcat(s, "B");
if (crc32("fepRqfZr",8) == 2187284952) strcat(s, "t");
    return s;
}

char *Joceline_nouns() {
    char *s = calloc(9);
    if (crc32("dryLdwkEdVFh",12) == 1917091728) strcat(s, "J");
if (crc32("czRIdLoJqzsAKaa",15) == 3857911185) strcat(s, "G");
if (crc32("eyiWrFLw",8) == 111006964) strcat(s, "o");
if (crc32("rHOXMMWs",8) == 655637327) strcat(s, "c");
if (crc32("XeEqUKzcXGTvnXm",15) == 1461871051) strcat(s, "e");
if (crc32("hEaWY",5) == 1844633674) strcat(s, "l");
if (crc32("ClVsjNBCJJw",11) == 3298642744) strcat(s, "i");
if (crc32("pButgesLLhyG",12) == 4214446901) strcat(s, "W");
if (crc32("iFpmlK",6) == 1258034820) strcat(s, "n");
if (crc32("PypvbQHQZE",10) == 268800911) strcat(s, "e");
    return s;
}

char *socage_nouns() {
    char *s = calloc(7);
    if (crc32("bAWUUwlWGRgKI",13) == 466754270) strcat(s, "v");
if (crc32("ayDGgIsTeiHmDg",14) == 270978331) strcat(s, "s");
if (crc32("HJrhr",5) == 3934576876) strcat(s, "N");
if (crc32("sdlNShCUbchGVy",14) == 2519696695) strcat(s, "o");
if (crc32("AxYlV",5) == 2130205906) strcat(s, "b");
if (crc32("brMiHVMaIPugPy",14) == 1658226498) strcat(s, "c");
if (crc32("BoFBOW",6) == 2814321546) strcat(s, "a");
if (crc32("fwpENvoowXkZh",13) == 4087316267) strcat(s, "j");
if (crc32("CbDRoHhDOli",11) == 3227765950) strcat(s, "g");
if (crc32("JnfnVwGUiD",10) == 195114272) strcat(s, "e");
    return s;
}

char *decameter_nouns() {
    char *s = calloc(10);
    if (crc32("QoLbBKc",7) == 2250366897) strcat(s, "K");
if (crc32("bQoGDSPOckA",11) == 2568154210) strcat(s, "d");
if (crc32("AKKVpZEIaI",10) == 2620448546) strcat(s, "M");
if (crc32("bxJjq",5) == 1313247698) strcat(s, "e");
if (crc32("jcJZHEgHknzrge",14) == 3358421424) strcat(s, "c");
if (crc32("ooCJgm",6) == 2515603576) strcat(s, "l");
if (crc32("ofeyRxqnfKv",11) == 2071470685) strcat(s, "a");
if (crc32("gxbzVjpl",8) == 445314532) strcat(s, "h");
if (crc32("PKhvNbOPJIl",11) == 2700319314) strcat(s, "m");
if (crc32("TXFNosAUaiFaxM",14) == 3582393548) strcat(s, "e");
if (crc32("RtyLLUbazOmDS",13) == 539138743) strcat(s, "T");
if (crc32("CIokGNb",7) == 2400092698) strcat(s, "t");
if (crc32("bCQLZMTuTUxTwtB",15) == 1605776004) strcat(s, "e");
if (crc32("gKiEOx",6) == 2941793061) strcat(s, "N");
if (crc32("eiPexQgP",8) == 1014622250) strcat(s, "r");
    return s;
}

char *undercrypt_nouns() {
    char *s = calloc(11);
    if (crc32("qvLDyWFyXfMJx",13) == 2507029305) strcat(s, "N");
if (crc32("WwbcuhsakE",10) == 1184736013) strcat(s, "u");
if (crc32("LvglfYaXGULAB",13) == 3879510302) strcat(s, "n");
if (crc32("juwNGkakVNXaO",13) == 2624158236) strcat(s, "d");
if (crc32("ErtDUmIxYGkdmd",14) == 875560455) strcat(s, "x");
if (crc32("NLefAvkECuoNAZ",14) == 3727561275) strcat(s, "e");
if (crc32("OFiZNlSvB",9) == 2727735555) strcat(s, "r");
if (crc32("EAxFFHcughARfZA",15) == 1552605636) strcat(s, "c");
if (crc32("ktzFNnMY",8) == 3815507406) strcat(s, "r");
if (crc32("qoGiXXV",7) == 283760939) strcat(s, "y");
if (crc32("NhoskZ",6) == 362270185) strcat(s, "p");
if (crc32("DPpkjgqqlml",11) == 3892697285) strcat(s, "I");
if (crc32("cqeOcbFpyKwKef",14) == 3448314319) strcat(s, "t");
    return s;
}

char *sporadism_nouns() {
    char *s = calloc(10);
    if (crc32("rUqNWBNxlD",10) == 978808965) strcat(s, "P");
if (crc32("nFYZVVjTuGTPdNR",15) == 2873420018) strcat(s, "s");
if (crc32("WutBdl",6) == 1135418342) strcat(s, "p");
if (crc32("hmYeImZJahVf",12) == 3939174474) strcat(s, "r");
if (crc32("ytvmjjpPenJaRv",14) == 3449396747) strcat(s, "o");
if (crc32("PpZHOCYc",8) == 2557484286) strcat(s, "l");
if (crc32("SNiqGbwfW",9) == 2742789090) strcat(s, "r");
if (crc32("XbmWThcdP",9) == 4235582709) strcat(s, "f");
if (crc32("WajpUoVc",8) == 3233748905) strcat(s, "a");
if (crc32("teEOScoxh",9) == 448643484) strcat(s, "J");
if (crc32("CIyOkPbfaGleR",13) == 2130770158) strcat(s, "d");
if (crc32("yvAWXp",6) == 1141749143) strcat(s, "F");
if (crc32("BXrsqslCuD",10) == 3714267069) strcat(s, "i");
if (crc32("yCWfaDekQke",11) == 56474764) strcat(s, "J");
if (crc32("KDXpjZoLS",9) == 2518082306) strcat(s, "s");
if (crc32("bCOCgIqFtUNfG",13) == 3649948762) strcat(s, "t");
if (crc32("GFmhrRLG",8) == 1727214117) strcat(s, "m");
    return s;
}

char *reliever_nouns() {
    char *s = calloc(9);
    if (crc32("bYsmBr",6) == 2218576094) strcat(s, "r");
if (crc32("kfvLlbwefl",10) == 3255007634) strcat(s, "k");
if (crc32("hzNiLdGLDsalh",13) == 3200874984) strcat(s, "e");
if (crc32("IDuajpqNEurD",12) == 4081070597) strcat(s, "l");
if (crc32("pPmvIZoykZ",10) == 1524415159) strcat(s, "a");
if (crc32("yWysJdTfTO",10) == 1670035751) strcat(s, "i");
if (crc32("lPgVYDi",7) == 3684060409) strcat(s, "e");
if (crc32("vUszC",5) == 3542502635) strcat(s, "e");
if (crc32("tOaauBDrQKdWNHM",15) == 3303118729) strcat(s, "v");
if (crc32("joDdYoq",7) == 617981413) strcat(s, "d");
if (crc32("WSgnm",5) == 273466083) strcat(s, "e");
if (crc32("LdLDDzG",7) == 3925110749) strcat(s, "G");
if (crc32("ZGFdCFXJxRiSUqc",15) == 3664248191) strcat(s, "r");
    return s;
}

char *Holstein_nouns() {
    char *s = calloc(9);
    if (crc32("BWcYuemoMU",10) == 1051440863) strcat(s, "N");
if (crc32("LAiPXEB",7) == 4070565840) strcat(s, "H");
if (crc32("DvtkTBsW",8) == 504818374) strcat(s, "T");
if (crc32("isKaXGiL",8) == 116550464) strcat(s, "o");
if (crc32("JSxQDjAzyWktLne",15) == 4020981234) strcat(s, "l");
if (crc32("TDuKWzcTj",9) == 138410924) strcat(s, "s");
if (crc32("LdtwdzQCxKtBhP",14) == 901604468) strcat(s, "m");
if (crc32("qCFCBZqQ",8) == 3424122990) strcat(s, "t");
if (crc32("toSFVY",6) == 1776962644) strcat(s, "e");
if (crc32("JRGmCwJ",7) == 2607121172) strcat(s, "i");
if (crc32("MGoxwCUidzT",11) == 2625858584) strcat(s, "n");
if (crc32("HvlEXWwz",8) == 1210291027) strcat(s, "n");
    return s;
}

char *DAnnunzio_nouns() {
    char *s = calloc(10);
    if (crc32("vWVrX",5) == 4142024153) strcat(s, "D");
if (crc32("ortVIMILOXqeTa",14) == 293999573) strcat(s, "A");
if (crc32("OwyJmo",6) == 1650109414) strcat(s, "n");
if (crc32("MpXDQbNbOdMUHnG",15) == 316830427) strcat(s, "G");
if (crc32("QemkLStF",8) == 343685776) strcat(s, "n");
if (crc32("XwMMcvXfxC",10) == 1929406194) strcat(s, "y");
if (crc32("fVHiktKakak",11) == 2596104470) strcat(s, "u");
if (crc32("iaWgyLh",7) == 215275003) strcat(s, "q");
if (crc32("bVuTeEsPujN",11) == 323304349) strcat(s, "n");
if (crc32("SUTKpBfaGLpw",12) == 1321683502) strcat(s, "z");
if (crc32("WkBkkmhikFUJ",12) == 2055731033) strcat(s, "o");
if (crc32("oGVezotqDAzStoF",15) == 1038352001) strcat(s, "i");
if (crc32("jHxxULDeOOdUxf",14) == 2752771320) strcat(s, "o");
    return s;
}

char *Reiter_nouns() {
    char *s = calloc(7);
    if (crc32("SJeviMMwxNX",11) == 3577960352) strcat(s, "R");
if (crc32("hURossqWCkUdbN",14) == 2195753828) strcat(s, "W");
if (crc32("jcqsccXVSP",10) == 828129363) strcat(s, "e");
if (crc32("lRZXnHDiWkLoSve",15) == 2357866359) strcat(s, "i");
if (crc32("UDDdlPQxaSIY",12) == 887944040) strcat(s, "Q");
if (crc32("jwPUxEnUTqrJLAX",15) == 4027198252) strcat(s, "t");
if (crc32("rDWwL",5) == 2809047016) strcat(s, "g");
if (crc32("PUxAhJqI",8) == 2041606803) strcat(s, "e");
if (crc32("tZrPMZvlY",9) == 2005469867) strcat(s, "r");
    return s;
}

char *Pessa_nouns() {
    char *s = calloc(6);
    if (crc32("xcLRWaiFBd",10) == 2800916680) strcat(s, "P");
if (crc32("OFHjgsSJVbrqP",13) == 1794931903) strcat(s, "e");
if (crc32("LGYKLUyZ",8) == 1357382352) strcat(s, "s");
if (crc32("HQqljd",6) == 1345497298) strcat(s, "i");
if (crc32("DkNmf",5) == 2314209499) strcat(s, "s");
if (crc32("qyQWbQEWYapCyq",14) == 354029126) strcat(s, "a");
    return s;
}

char *Eshelman_nouns() {
    char *s = calloc(9);
    if (crc32("sBYtYaccrpsTN",13) == 803533981) strcat(s, "E");
if (crc32("wMlapg",6) == 2365322369) strcat(s, "i");
if (crc32("DNqeIAoLAnT",11) == 3416346514) strcat(s, "s");
if (crc32("wxMxisbTZ",9) == 872545480) strcat(s, "L");
if (crc32("NZUotW",6) == 4147582717) strcat(s, "h");
if (crc32("xZndbUyucJ",10) == 3732789774) strcat(s, "a");
if (crc32("uZbegl",6) == 688196843) strcat(s, "e");
if (crc32("BSSJADK",7) == 1270561243) strcat(s, "l");
if (crc32("mxbMH",5) == 3723122751) strcat(s, "v");
if (crc32("jAUfCIMGDrO",11) == 4045935774) strcat(s, "m");
if (crc32("SqjIOjqslLEtrY",14) == 2347531746) strcat(s, "a");
if (crc32("nXbnRwWx",8) == 1222190636) strcat(s, "n");
    return s;
}

char *fiorin_nouns() {
    char *s = calloc(7);
    if (crc32("yyFVDX",6) == 2718030109) strcat(s, "f");
if (crc32("VgNPjgDYStb",11) == 747973718) strcat(s, "f");
if (crc32("CtvdLJvYHOXyxY",14) == 930877232) strcat(s, "i");
if (crc32("BXGPnVKhtQ",10) == 2021614806) strcat(s, "p");
if (crc32("jRQJyaShSo",10) == 1535378990) strcat(s, "o");
if (crc32("jXLodXEBA",9) == 71348239) strcat(s, "r");
if (crc32("lduHo",5) == 2570264186) strcat(s, "i");
if (crc32("PmoIxtOQkm",10) == 4072620729) strcat(s, "Y");
if (crc32("GByyVEHo",8) == 815466731) strcat(s, "n");
    return s;
}

char *Marjory_nouns() {
    char *s = calloc(8);
    if (crc32("YjGfHNFaNitJc",13) == 3890679882) strcat(s, "o");
if (crc32("NmjJZUrowPolq",13) == 2429583116) strcat(s, "M");
if (crc32("ECcTuCCAxqC",11) == 2246247237) strcat(s, "a");
if (crc32("BzzTibIOwGkstF",14) == 3198388920) strcat(s, "r");
if (crc32("xqQiPvXOlnRgGNh",15) == 1892937544) strcat(s, "j");
if (crc32("xmnLnxBJZ",9) == 2673832121) strcat(s, "j");
if (crc32("mBmHwSFwyciEfmu",15) == 1270716081) strcat(s, "o");
if (crc32("gOuaWrcdZsxUNa",14) == 2917166435) strcat(s, "y");
if (crc32("SZfsjcuF",8) == 2316099813) strcat(s, "r");
if (crc32("RbZAC",5) == 1449311063) strcat(s, "g");
if (crc32("NLkVvRB",7) == 2976188135) strcat(s, "y");
    return s;
}

char *grog_nouns() {
    char *s = calloc(5);
    if (crc32("BaOPn",5) == 1056984529) strcat(s, "q");
if (crc32("KQZUxGWZveA",11) == 2566280952) strcat(s, "g");
if (crc32("jnLGjDyYXsn",11) == 945025105) strcat(s, "r");
if (crc32("wASDR",5) == 122051978) strcat(s, "K");
if (crc32("BNGKNDFkp",9) == 2682734024) strcat(s, "o");
if (crc32("BuvbJwczyQ",10) == 3057913898) strcat(s, "y");
if (crc32("HfJQW",5) == 2605640734) strcat(s, "g");
    return s;
}

char *semicolloid_nouns() {
    char *s = calloc(12);
    if (crc32("ZzNANYhzihNacYy",15) == 1732578469) strcat(s, "s");
if (crc32("OkxKxNGWTeJyH",13) == 3655350721) strcat(s, "I");
if (crc32("LerOyT",6) == 2961270321) strcat(s, "e");
if (crc32("GKOhZctNsou",11) == 443199697) strcat(s, "m");
if (crc32("UacvniayrPYXYqH",15) == 3685678980) strcat(s, "Q");
if (crc32("vHGFa",5) == 122925224) strcat(s, "i");
if (crc32("szNFcPp",7) == 956443726) strcat(s, "j");
if (crc32("iAtlEJNSXdOD",12) == 281914304) strcat(s, "c");
if (crc32("llpfJYbHh",9) == 2735262158) strcat(s, "l");
if (crc32("EjVrotp",7) == 210287155) strcat(s, "o");
if (crc32("odGhcF",6) == 3048926076) strcat(s, "l");
if (crc32("yFYgLAmIfbOMLLo",15) == 474022508) strcat(s, "l");
if (crc32("wpeiopZLxpnv",12) == 3805654054) strcat(s, "n");
if (crc32("kfozw",5) == 1857544288) strcat(s, "o");
if (crc32("CBERYZWYNPNJgPh",15) == 2456143839) strcat(s, "i");
if (crc32("wDpDBxIADt",10) == 3078531947) strcat(s, "d");
    return s;
}

char *subinspectorship_nouns() {
    char *s = calloc(17);
    if (crc32("WmnRk",5) == 2950628983) strcat(s, "R");
if (crc32("EhQewGZ",7) == 55309856) strcat(s, "s");
if (crc32("IbwyzsOxnpkajQV",15) == 3738938806) strcat(s, "u");
if (crc32("lUmcII",6) == 2472638950) strcat(s, "b");
if (crc32("WtczgnxDHDIVLa",14) == 1681278605) strcat(s, "i");
if (crc32("qwFXvPV",7) == 1888554571) strcat(s, "n");
if (crc32("AbgIJlC",7) == 3473347788) strcat(s, "o");
if (crc32("GdiivpjaXPDff",13) == 45695842) strcat(s, "s");
if (crc32("yGNMLPBjGHhcFp",14) == 1898204344) strcat(s, "r");
if (crc32("XhVhMkibiafomV",14) == 1250139517) strcat(s, "p");
if (crc32("GDAIMiszjJGCW",13) == 1737834683) strcat(s, "e");
if (crc32("KsVtjaYFNVJCrgn",15) == 3832469660) strcat(s, "e");
if (crc32("iOJUGXImjmI",11) == 186945239) strcat(s, "b");
if (crc32("FSNiwfbjEEN",11) == 4103968090) strcat(s, "c");
if (crc32("xGqapOr",7) == 4163372943) strcat(s, "E");
if (crc32("XEDwjTMTxEAzWOW",15) == 2283031376) strcat(s, "t");
if (crc32("nPLbhqZYt",9) == 1662732390) strcat(s, "N");
if (crc32("wUTVNbGiIVlo",12) == 2943385232) strcat(s, "o");
if (crc32("JoOjMTdPsoXUC",13) == 1263729138) strcat(s, "r");
if (crc32("XZBxHYkEp",9) == 2559528495) strcat(s, "s");
if (crc32("NLNRRhy",7) == 2629888165) strcat(s, "h");
if (crc32("jJOgxtQL",8) == 1945480791) strcat(s, "P");
if (crc32("VImaXZWN",8) == 1020034260) strcat(s, "i");
if (crc32("LqmLkruCwdnNp",13) == 213203092) strcat(s, "p");
    return s;
}

char *adman_nouns() {
    char *s = calloc(6);
    if (crc32("uNoXhBjSXegWG",13) == 4007659357) strcat(s, "p");
if (crc32("NxGZHvQcxslEuf",14) == 3770264662) strcat(s, "a");
if (crc32("nAnXtUKZnjHbG",13) == 3535003165) strcat(s, "h");
if (crc32("AkKdKWdVt",9) == 4205224320) strcat(s, "d");
if (crc32("aCblF",5) == 1184723014) strcat(s, "c");
if (crc32("MTAVAwvRloireG",14) == 1811189154) strcat(s, "m");
if (crc32("SlDLgyehmoZWzdn",15) == 88915785) strcat(s, "a");
if (crc32("fggZNdlGpXmBigI",15) == 281088716) strcat(s, "w");
if (crc32("CItSNOnLogOTued",15) == 631415671) strcat(s, "n");
    return s;
}

char *fourflusher_nouns() {
    char *s = calloc(12);
    if (crc32("BUCxla",6) == 589295905) strcat(s, "f");
if (crc32("LvFtEEjj",8) == 2836770539) strcat(s, "o");
if (crc32("jSrxxVo",7) == 2116498083) strcat(s, "u");
if (crc32("HZJzQGTOjhcvj",13) == 928815744) strcat(s, "r");
if (crc32("UoRgEsDvkPtiln",14) == 4224979268) strcat(s, "f");
if (crc32("viFTWRjYOwQ",11) == 3915486456) strcat(s, "l");
if (crc32("OsmJlTAZZcH",11) == 2937806070) strcat(s, "I");
if (crc32("rvvkB",5) == 1170423232) strcat(s, "u");
if (crc32("hidCriHxpl",10) == 1300856545) strcat(s, "s");
if (crc32("eAEwlHl",7) == 221611087) strcat(s, "U");
if (crc32("IkjAVeiTwBZqIMt",15) == 372762933) strcat(s, "h");
if (crc32("vzGnBl",6) == 488255819) strcat(s, "e");
if (crc32("ezFlBk",6) == 3171182550) strcat(s, "r");
    return s;
}

char *newspaperwoman_nouns() {
    char *s = calloc(15);
    if (crc32("MovpbJv",7) == 1085430571) strcat(s, "N");
if (crc32("ALiOwNLwvd",10) == 2509337547) strcat(s, "n");
if (crc32("dpIJVSW",7) == 203432291) strcat(s, "o");
if (crc32("TNPBbEKtJKlM",12) == 764787322) strcat(s, "e");
if (crc32("XibAKQiDBjxy",12) == 3212835244) strcat(s, "w");
if (crc32("hwxhxQDLVQJ",11) == 3826010168) strcat(s, "s");
if (crc32("WdlxkDjgEGHTLZ",14) == 3337357346) strcat(s, "p");
if (crc32("MoxGUIQ",7) == 2532507698) strcat(s, "D");
if (crc32("pLJwuBTwJ",9) == 53029197) strcat(s, "a");
if (crc32("AzANIKmeosWkUB",14) == 700492146) strcat(s, "l");
if (crc32("goqHPJDaCcup",12) == 3695828988) strcat(s, "p");
if (crc32("mbKEbbgXK",9) == 348683787) strcat(s, "O");
if (crc32("nRaMMcRLaDkZSg",14) == 1788185698) strcat(s, "e");
if (crc32("JIKAz",5) == 385885189) strcat(s, "r");
if (crc32("ocARddJhzfI",11) == 1371055055) strcat(s, "m");
if (crc32("gacFDblsufeu",12) == 2046424678) strcat(s, "w");
if (crc32("OKhvOFPbGrano",13) == 2407202526) strcat(s, "q");
if (crc32("zHKoAbiTGGyt",12) == 4250321167) strcat(s, "o");
if (crc32("XtcZWuAqVg",10) == 1423067476) strcat(s, "m");
if (crc32("VtwzpSOR",8) == 3158853472) strcat(s, "a");
if (crc32("RdSKKLfSCvtaI",13) == 4217381828) strcat(s, "n");
    return s;
}

char *Benilda_nouns() {
    char *s = calloc(8);
    if (crc32("oPFAAPZuxJd",11) == 2199594876) strcat(s, "B");
if (crc32("zLnWpXAJiz",10) == 795765838) strcat(s, "l");
if (crc32("iVLQCEBQSEd",11) == 2279732520) strcat(s, "e");
if (crc32("XTQcvBghKDg",11) == 1904397988) strcat(s, "Y");
if (crc32("YhOUazaMIzht",12) == 364922983) strcat(s, "n");
if (crc32("txuLTs",6) == 772643612) strcat(s, "G");
if (crc32("ufYfJXTbOXDZfgD",15) == 2956539515) strcat(s, "i");
if (crc32("vazpMRHwjeyMFy",14) == 4031480925) strcat(s, "P");
if (crc32("NESZcABKiqiysg",14) == 3586202115) strcat(s, "l");
if (crc32("uUGJWIRe",8) == 1822808036) strcat(s, "d");
if (crc32("MqbaimHPhm",10) == 2087791495) strcat(s, "l");
if (crc32("UIJVlvvpTVXQ",12) == 2497528243) strcat(s, "a");
    return s;
}

char *billingsgate_nouns() {
    char *s = calloc(13);
    if (crc32("efVnXouz",8) == 1177588846) strcat(s, "b");
if (crc32("mWIyb",5) == 3545237374) strcat(s, "i");
if (crc32("kguYZilD",8) == 2467405420) strcat(s, "l");
if (crc32("mgocmbC",7) == 3309714885) strcat(s, "V");
if (crc32("jnSDlck",7) == 1055681150) strcat(s, "l");
if (crc32("FdMcUKOYjW",10) == 3221267535) strcat(s, "i");
if (crc32("ncMyHj",6) == 139363131) strcat(s, "G");
if (crc32("ZnbmXvRlYwCafLJ",15) == 4188498900) strcat(s, "n");
if (crc32("cuSnafFkIF",10) == 4067295193) strcat(s, "g");
if (crc32("SkAPofF",7) == 2892957967) strcat(s, "s");
if (crc32("VvLfsdj",7) == 2031943764) strcat(s, "g");
if (crc32("DRgIYFrIjg",10) == 759783948) strcat(s, "a");
if (crc32("GSmUj",5) == 3756894764) strcat(s, "t");
if (crc32("lFtdceuCjfOoaT",14) == 1382327483) strcat(s, "l");
if (crc32("fuzdAQmbr",9) == 1230039333) strcat(s, "e");
    return s;
}

char *Burnet_nouns() {
    char *s = calloc(7);
    if (crc32("UdIruNuL",8) == 3672116028) strcat(s, "O");
if (crc32("tsTMbWQYm",9) == 2380884059) strcat(s, "B");
if (crc32("hsFQzG",6) == 2331213858) strcat(s, "o");
if (crc32("hodWht",6) == 1778172131) strcat(s, "u");
if (crc32("XDdqUXBERhvLm",13) == 1750927512) strcat(s, "T");
if (crc32("UZQNIRgLxsYuO",13) == 3221871632) strcat(s, "r");
if (crc32("alVyvPPQPniUxv",14) == 2711003675) strcat(s, "c");
if (crc32("xvaTnkTGFR",10) == 2157349209) strcat(s, "n");
if (crc32("GwwuYwCxp",9) == 3978982169) strcat(s, "a");
if (crc32("fbJStlLTAqEwB",13) == 94210513) strcat(s, "e");
if (crc32("GXjOXxsFv",9) == 3840663547) strcat(s, "t");
    return s;
}

char *weediness_nouns() {
    char *s = calloc(10);
    if (crc32("OlczZ",5) == 2397664254) strcat(s, "y");
if (crc32("XCiklcnESAfD",12) == 2295198012) strcat(s, "w");
if (crc32("iOHegjzbQDquQQ",14) == 2822811264) strcat(s, "X");
if (crc32("PvmawIrkCmotZ",13) == 2252418453) strcat(s, "e");
if (crc32("fZcCqzSPqk",10) == 3654567812) strcat(s, "e");
if (crc32("PEKEZMWdJMeUQkY",15) == 3664719996) strcat(s, "d");
if (crc32("HIvOAjuJcshRB",13) == 1438955284) strcat(s, "i");
if (crc32("hUgnWIwWQyqb",12) == 1419083724) strcat(s, "n");
if (crc32("couMZLafbbV",11) == 1989105360) strcat(s, "n");
if (crc32("qPpFaPIUGlDVc",13) == 2129621146) strcat(s, "e");
if (crc32("aebeqzoaaTvK",12) == 789668271) strcat(s, "s");
if (crc32("fujGpRk",7) == 4256750317) strcat(s, "s");
    return s;
}

char *hooves_nouns() {
    char *s = calloc(7);
    if (crc32("lEHADYImK",9) == 830666801) strcat(s, "L");
if (crc32("yMQrZGYpqZAuX",13) == 2294080819) strcat(s, "h");
if (crc32("dzlBESqqOHFkwr",14) == 3870138983) strcat(s, "g");
if (crc32("IicrCzKZFJtpooA",15) == 1245293477) strcat(s, "o");
if (crc32("jUPrLTlRMxbvIW",14) == 102096164) strcat(s, "f");
if (crc32("SfitvOWw",8) == 2068664511) strcat(s, "o");
if (crc32("vrdTQQHkMPJM",12) == 4154480333) strcat(s, "v");
if (crc32("AsRHotvSsyTp",12) == 3307356794) strcat(s, "S");
if (crc32("TizgGQj",7) == 193725578) strcat(s, "e");
if (crc32("wVFPcwEsW",9) == 1709259958) strcat(s, "s");
    return s;
}

char *Younglove_nouns() {
    char *s = calloc(10);
    if (crc32("BclyvFNnoumyi",13) == 378028169) strcat(s, "y");
if (crc32("csFIDNfyPTO",11) == 4123943273) strcat(s, "Y");
if (crc32("MAVJu",5) == 119612547) strcat(s, "o");
if (crc32("xpJaovPMXxWSsJ",14) == 3327109424) strcat(s, "f");
if (crc32("ijujsxfkWAehrmi",15) == 3323175795) strcat(s, "u");
if (crc32("mdFfFuazroVqlmK",15) == 3501144758) strcat(s, "n");
if (crc32("cBSEkTJ",7) == 3129420650) strcat(s, "n");
if (crc32("HvocxLLMKbm",11) == 1786921638) strcat(s, "g");
if (crc32("coICLEbINBxWAqr",15) == 4078000335) strcat(s, "l");
if (crc32("XjjJEARs",8) == 3944224973) strcat(s, "o");
if (crc32("zLZlVNkiwwWMIm",14) == 307680285) strcat(s, "v");
if (crc32("KnuIAXHAk",9) == 1930639873) strcat(s, "d");
if (crc32("KsOzx",5) == 1615016888) strcat(s, "e");
    return s;
}

char *diapedesis_nouns() {
    char *s = calloc(11);
    if (crc32("jsPrpoF",7) == 4010995707) strcat(s, "d");
if (crc32("rAXLjBwuUSyPuke",15) == 1157589433) strcat(s, "C");
if (crc32("tWwRzjrVVe",10) == 432084327) strcat(s, "i");
if (crc32("BAvIJtiaL",9) == 4087467139) strcat(s, "c");
if (crc32("CZGjXKognRXzUTj",15) == 2311623013) strcat(s, "a");
if (crc32("hnfzsm",6) == 360616755) strcat(s, "E");
if (crc32("cquVPZXnbd",10) == 3053384052) strcat(s, "p");
if (crc32("wQtpigSWGIWDUv",14) == 2995796971) strcat(s, "E");
if (crc32("StkhZmaxZfk",11) == 431695928) strcat(s, "e");
if (crc32("ldaNMqFOSM",10) == 178117706) strcat(s, "d");
if (crc32("iiRcgeyABpnDa",13) == 2448655336) strcat(s, "e");
if (crc32("KwDWcnqt",8) == 745994115) strcat(s, "s");
if (crc32("vlDUvftGZWRgAx",14) == 233879409) strcat(s, "r");
if (crc32("XwCZGLFkNqNRV",13) == 677113648) strcat(s, "i");
if (crc32("XtuPEbtVSFHBspj",15) == 4108727603) strcat(s, "s");
    return s;
}

char *curtsy_nouns() {
    char *s = calloc(7);
    if (crc32("sanoRLqJ",8) == 516473749) strcat(s, "C");
if (crc32("tYocNWlPQss",11) == 2412984707) strcat(s, "c");
if (crc32("dozzQFpMsU",10) == 3520841678) strcat(s, "u");
if (crc32("IrhOxgBiFvqo",12) == 1366706438) strcat(s, "r");
if (crc32("IbHKh",5) == 746803569) strcat(s, "t");
if (crc32("vjwCzkC",7) == 1230148255) strcat(s, "s");
if (crc32("SkGlUNeDsKyh",12) == 3248350438) strcat(s, "y");
    return s;
}

char *Vallie_nouns() {
    char *s = calloc(7);
    if (crc32("hzjDbPQKcMzvL",13) == 3884697050) strcat(s, "h");
if (crc32("JVUCkXXcNzv",11) == 714304610) strcat(s, "V");
if (crc32("iQXYdFEOX",9) == 36912557) strcat(s, "a");
if (crc32("NvMcvure",8) == 3664551564) strcat(s, "n");
if (crc32("nTwLDxlUxNKXQ",13) == 3686098597) strcat(s, "l");
if (crc32("fnJUgXK",7) == 2005984530) strcat(s, "l");
if (crc32("yCJxNGGPp",9) == 1685729332) strcat(s, "i");
if (crc32("eDsSIJZQukz",11) == 1958075228) strcat(s, "a");
if (crc32("MxRmaE",6) == 2432525244) strcat(s, "e");
    return s;
}

char *Cedric_nouns() {
    char *s = calloc(7);
    if (crc32("hMaiH",5) == 2201219882) strcat(s, "C");
if (crc32("xeuTRNquypurTvD",15) == 3433038844) strcat(s, "e");
if (crc32("XkgaHvZeiI",10) == 2761559545) strcat(s, "d");
if (crc32("VRxwDyxRCFIbkvD",15) == 423450321) strcat(s, "r");
if (crc32("iUAcNKfKfkEY",12) == 2521927263) strcat(s, "M");
if (crc32("dqqWHwPH",8) == 4235460089) strcat(s, "i");
if (crc32("nSzzojReUKWenC",14) == 2131659654) strcat(s, "K");
if (crc32("OWSbCGcFanz",11) == 2835758033) strcat(s, "c");
    return s;
}

char *Deus_nouns() {
    char *s = calloc(5);
    if (crc32("GnwMiIxjg",9) == 3727466269) strcat(s, "E");
if (crc32("bTlSdZTMidToCJ",14) == 2064604368) strcat(s, "D");
if (crc32("kMtfKiCTfQSzynx",15) == 3337153956) strcat(s, "e");
if (crc32("ORiZVockKQ",10) == 1004261428) strcat(s, "e");
if (crc32("YeKjHgHO",8) == 2367944190) strcat(s, "u");
if (crc32("iuqpAbQHt",9) == 1162743845) strcat(s, "s");
    return s;
}

char *preloan_nouns() {
    char *s = calloc(8);
    if (crc32("dvsncO",6) == 618929717) strcat(s, "r");
if (crc32("sRfaD",5) == 1482277590) strcat(s, "p");
if (crc32("SENiFAzKsjpNBG",14) == 2626772083) strcat(s, "r");
if (crc32("EEhLAVNDOIxF",12) == 2011850145) strcat(s, "e");
if (crc32("ndcFsrvIBASy",12) == 3831065318) strcat(s, "l");
if (crc32("acihjMoPctfJ",12) == 2984131703) strcat(s, "o");
if (crc32("VxcdyoPxBOSYdnv",15) == 4095534680) strcat(s, "H");
if (crc32("ACejyygfMFw",11) == 781282052) strcat(s, "a");
if (crc32("xRfhg",5) == 1546402300) strcat(s, "n");
    return s;
}

char *Basilicata_nouns() {
    char *s = calloc(11);
    if (crc32("XJoLUCRpCE",10) == 596784948) strcat(s, "B");
if (crc32("QxvLDyDCzFGkmPJ",15) == 1875155956) strcat(s, "i");
if (crc32("icFAMTnMMm",10) == 220368317) strcat(s, "a");
if (crc32("mVlFyFrqaxO",11) == 2845319985) strcat(s, "s");
if (crc32("dLUnnWg",7) == 1106897016) strcat(s, "s");
if (crc32("GbNMhlQ",7) == 1151435585) strcat(s, "i");
if (crc32("HjUxvvFO",8) == 2065004784) strcat(s, "l");
if (crc32("WPJak",5) == 1969295294) strcat(s, "h");
if (crc32("tNDsHBAtco",10) == 1486531569) strcat(s, "i");
if (crc32("DdfTy",5) == 1682018202) strcat(s, "c");
if (crc32("IXxmxive",8) == 3223772583) strcat(s, "W");
if (crc32("QOkqgaIbEWdk",12) == 1978008071) strcat(s, "a");
if (crc32("xkYpXrAObGSD",12) == 453107217) strcat(s, "Q");
if (crc32("sLBuk",5) == 1386538570) strcat(s, "t");
if (crc32("UsOuSWYIEWlrg",13) == 1403088806) strcat(s, "l");
if (crc32("JvcgvgGmxA",10) == 2940628989) strcat(s, "a");
    return s;
}

char *Trevelyan_nouns() {
    char *s = calloc(10);
    if (crc32("htgbegy",7) == 3390698711) strcat(s, "t");
if (crc32("prWrX",5) == 4018963778) strcat(s, "T");
if (crc32("CyoHhHZI",8) == 3853414118) strcat(s, "r");
if (crc32("YEpgTCH",7) == 342464156) strcat(s, "m");
if (crc32("DMkQTttQtZ",10) == 2175143592) strcat(s, "e");
if (crc32("czBbE",5) == 1825268173) strcat(s, "Q");
if (crc32("TwSrZZxT",8) == 3673302965) strcat(s, "v");
if (crc32("ZZKRYrRGBOMPcVW",15) == 3661984017) strcat(s, "e");
if (crc32("GkLBJf",6) == 1105592546) strcat(s, "l");
if (crc32("vOBCKNqbfNtfjDg",15) == 3016759977) strcat(s, "y");
if (crc32("PPScimb",7) == 1602082167) strcat(s, "z");
if (crc32("GmQGPz",6) == 3459391103) strcat(s, "a");
if (crc32("rtcEunB",7) == 1232585620) strcat(s, "i");
if (crc32("FwjWGKAOgcvt",12) == 452593337) strcat(s, "n");
    return s;
}

char *tunableness_nouns() {
    char *s = calloc(12);
    if (crc32("OnnqBkPk",8) == 2904477238) strcat(s, "t");
if (crc32("fUdHLBYRdzW",11) == 2366718277) strcat(s, "u");
if (crc32("DBytpLRzoZEo",12) == 985396729) strcat(s, "I");
if (crc32("QHNNXDFqfAjkLen",15) == 1290880214) strcat(s, "n");
if (crc32("HZvEa",5) == 938397714) strcat(s, "C");
if (crc32("OnTmLHFepJWW",12) == 2979088815) strcat(s, "a");
if (crc32("FeqmOJvtwGGe",12) == 2646521402) strcat(s, "h");
if (crc32("aHDblr",6) == 848267851) strcat(s, "b");
if (crc32("OzbxtatxmQfS",12) == 4280743223) strcat(s, "D");
if (crc32("insKZx",6) == 2750683038) strcat(s, "l");
if (crc32("wcAiKHn",7) == 4145770028) strcat(s, "e");
if (crc32("uUhLVTIgRoA",11) == 2328389905) strcat(s, "n");
if (crc32("CSlPsYtv",8) == 3602331398) strcat(s, "s");
if (crc32("wniThlkVpeEaYO",14) == 1346788927) strcat(s, "e");
if (crc32("SnirABAz",8) == 93592705) strcat(s, "X");
if (crc32("NlwrzQxbFJQB",12) == 1983403080) strcat(s, "s");
if (crc32("jOhQhYIs",8) == 1328425420) strcat(s, "x");
if (crc32("OSmem",5) == 2931770045) strcat(s, "s");
    return s;
}

char *Catskill_nouns() {
    char *s = calloc(9);
    if (crc32("gctHnzpcqWxIHaj",15) == 2609352027) strcat(s, "E");
if (crc32("EOZJKvMiIfBLO",13) == 1080592085) strcat(s, "C");
if (crc32("zwZLRTnIoMnnt",13) == 2762770017) strcat(s, "Z");
if (crc32("IfkJzjFlGWoAQE",14) == 1505951407) strcat(s, "a");
if (crc32("doTvziNLph",10) == 3054398089) strcat(s, "t");
if (crc32("uoqWPTMomFp",11) == 3185583326) strcat(s, "s");
if (crc32("PzSNPRXLDKEaUiE",15) == 3673707905) strcat(s, "K");
if (crc32("boiilGYy",8) == 2001662838) strcat(s, "k");
if (crc32("ppjcIDaMypK",11) == 128577496) strcat(s, "l");
if (crc32("SGDyFdNq",8) == 3883265347) strcat(s, "i");
if (crc32("ueGupXC",7) == 3795973645) strcat(s, "k");
if (crc32("PipVBfMgKiRzQ",13) == 3765039457) strcat(s, "l");
if (crc32("HWTNqXtNq",9) == 3999523913) strcat(s, "l");
    return s;
}

char *unflexibility_nouns() {
    char *s = calloc(14);
    if (crc32("jkALRtEyuOC",11) == 1235343576) strcat(s, "e");
if (crc32("GRIaE",5) == 1223618011) strcat(s, "u");
if (crc32("UbVpaIBZ",8) == 541459190) strcat(s, "a");
if (crc32("cmQebHH",7) == 2435278633) strcat(s, "n");
if (crc32("RZlFmKUvWj",10) == 1995693351) strcat(s, "f");
if (crc32("gnxnt",5) == 3225228948) strcat(s, "l");
if (crc32("EGVpgjkcfC",10) == 3799804232) strcat(s, "e");
if (crc32("jlxZrzrkn",9) == 921467341) strcat(s, "M");
if (crc32("ZwYRSGonrNaFAU",14) == 4233441414) strcat(s, "x");
if (crc32("VfxMRJrxyzj",11) == 3390162144) strcat(s, "i");
if (crc32("sXecaylzbFVm",12) == 2903516271) strcat(s, "Q");
if (crc32("qmsHwmuHkkbdCV",14) == 4056574772) strcat(s, "b");
if (crc32("OuZLhDhSb",9) == 897015039) strcat(s, "i");
if (crc32("bMrTFqNZmuRMXV",14) == 3290965531) strcat(s, "p");
if (crc32("qLKVHjqCyngSI",13) == 127657967) strcat(s, "l");
if (crc32("hhgkS",5) == 1221864010) strcat(s, "Z");
if (crc32("JBKKf",5) == 787421121) strcat(s, "i");
if (crc32("xxhouAX",7) == 3847654642) strcat(s, "A");
if (crc32("gyOAsiD",7) == 2506261170) strcat(s, "t");
if (crc32("qZlxSvogduUKNx",14) == 1361120933) strcat(s, "u");
if (crc32("qgtBn",5) == 2682015884) strcat(s, "y");
    return s;
}

char *Dexedrine_nouns() {
    char *s = calloc(10);
    if (crc32("fFzLjzoaDRF",11) == 2215027912) strcat(s, "D");
if (crc32("FqcMh",5) == 2386374742) strcat(s, "D");
if (crc32("sMrvPiDLg",9) == 347014531) strcat(s, "I");
if (crc32("UFUNVJC",7) == 868907533) strcat(s, "e");
if (crc32("ddQXMvmGszebZ",13) == 1826516016) strcat(s, "x");
if (crc32("QeBLvMS",7) == 1133530936) strcat(s, "I");
if (crc32("CDrJBWy",7) == 2764089523) strcat(s, "e");
if (crc32("FxWRVh",6) == 923483553) strcat(s, "d");
if (crc32("lMuXU",5) == 922176059) strcat(s, "I");
if (crc32("HuplDZTyBP",10) == 1687434992) strcat(s, "r");
if (crc32("RxtvLmgn",8) == 2935127540) strcat(s, "u");
if (crc32("IeUXoclcguNh",12) == 2856458021) strcat(s, "i");
if (crc32("jxBkmkQ",7) == 1101378351) strcat(s, "n");
if (crc32("dRKipwMGmm",10) == 2990704845) strcat(s, "I");
if (crc32("fZHJXNzWOrHlRCj",15) == 4081105526) strcat(s, "e");
    return s;
}

char *jiao_nouns() {
    char *s = calloc(5);
    if (crc32("waulDd",6) == 3226570637) strcat(s, "j");
if (crc32("aJwkKM",6) == 2003532146) strcat(s, "C");
if (crc32("PXmXJzWbK",9) == 3520312076) strcat(s, "i");
if (crc32("KZPTgmwA",8) == 4023433193) strcat(s, "p");
if (crc32("fHVcYgflXPdFoM",14) == 2371788859) strcat(s, "a");
if (crc32("FdamyJuRTB",10) == 2525906574) strcat(s, "b");
if (crc32("DDniOi",6) == 1460203001) strcat(s, "o");
    return s;
}

char *Dadaism_nouns() {
    char *s = calloc(8);
    if (crc32("IEMYDwLElQ",10) == 2250680028) strcat(s, "S");
if (crc32("racvvwDuKxmJBn",14) == 1286558805) strcat(s, "D");
if (crc32("rnwhmlZF",8) == 2801810666) strcat(s, "Q");
if (crc32("nhJthbKAl",9) == 3903496804) strcat(s, "a");
if (crc32("nZWGyGmAwR",10) == 3973842498) strcat(s, "X");
if (crc32("UoxuuxgfKFLY",12) == 222736859) strcat(s, "d");
if (crc32("RNgNEKuS",8) == 1177861398) strcat(s, "V");
if (crc32("mKzQpLJsYwQc",12) == 334047940) strcat(s, "a");
if (crc32("LEvpfFLwObGfzY",14) == 1355286681) strcat(s, "n");
if (crc32("LXuFGnyh",8) == 2120758267) strcat(s, "i");
if (crc32("CGgZInbazK",10) == 2813586964) strcat(s, "M");
if (crc32("VBfonbXt",8) == 1435545764) strcat(s, "s");
if (crc32("ttQAGxabA",9) == 2041051081) strcat(s, "m");
    return s;
}

char *minikin_nouns() {
    char *s = calloc(8);
    if (crc32("NxPpgXPMYNgJQiW",15) == 1738615830) strcat(s, "m");
if (crc32("fjQbCp",6) == 872008902) strcat(s, "A");
if (crc32("PVjCEKcXxHQXEX",14) == 3460831658) strcat(s, "i");
if (crc32("nirkiszdMr",10) == 2594775913) strcat(s, "n");
if (crc32("XrZExKFcH",9) == 1250989239) strcat(s, "e");
if (crc32("vShRtFCKnnaham",14) == 1420424577) strcat(s, "i");
if (crc32("BbeOUSzNgYuD",12) == 1026873251) strcat(s, "k");
if (crc32("ejfxLYAaV",9) == 443623157) strcat(s, "i");
if (crc32("gMbQpMDiFSfgOw",14) == 2581161764) strcat(s, "n");
    return s;
}

char *unimmaculateness_nouns() {
    char *s = calloc(17);
    if (crc32("HugnVVSh",8) == 2242822604) strcat(s, "B");
if (crc32("JKxctoVv",8) == 1354840051) strcat(s, "u");
if (crc32("tSPSl",5) == 1747256804) strcat(s, "i");
if (crc32("firZlmfA",8) == 1514318124) strcat(s, "n");
if (crc32("JbVgkBaheLuwCc",14) == 1019353264) strcat(s, "i");
if (crc32("mUePzmB",7) == 2692105296) strcat(s, "m");
if (crc32("lxztFpnlW",9) == 1532788075) strcat(s, "M");
if (crc32("IZEzv",5) == 764815549) strcat(s, "m");
if (crc32("ezLrz",5) == 1194047530) strcat(s, "a");
if (crc32("GNkslOVpo",9) == 3747368405) strcat(s, "F");
if (crc32("aDODBztGRvovAOd",15) == 1285740967) strcat(s, "c");
if (crc32("EdSbqNehyVCFoh",14) == 1912312633) strcat(s, "u");
if (crc32("LsQAIFr",7) == 3536398563) strcat(s, "l");
if (crc32("VcxjMiULTgZbVNA",15) == 4189077943) strcat(s, "a");
if (crc32("qjMuiKoOQd",10) == 339561725) strcat(s, "a");
if (crc32("LMmWSdxocHlauSr",15) == 803795949) strcat(s, "t");
if (crc32("fWLMkIvIrkDu",12) == 2736840601) strcat(s, "e");
if (crc32("dqnJLQOd",8) == 3668169212) strcat(s, "n");
if (crc32("tbOpIjwTIlTmeoL",15) == 3757054067) strcat(s, "e");
if (crc32("annnsItWhd",10) == 1525984520) strcat(s, "J");
if (crc32("jZcQIaLC",8) == 883943663) strcat(s, "s");
if (crc32("nnOEHf",6) == 1170719504) strcat(s, "c");
if (crc32("ZHGXWLxPYyz",11) == 4056679301) strcat(s, "s");
    return s;
}

char *cirrhosis_nouns() {
    char *s = calloc(10);
    if (crc32("wJdqhCGuINYUwNF",15) == 3835055595) strcat(s, "c");
if (crc32("EZiZl",5) == 2983700448) strcat(s, "i");
if (crc32("qUAhhrRuDgRxY",13) == 327555086) strcat(s, "j");
if (crc32("HGuVyzQglrVUtW",14) == 828520532) strcat(s, "r");
if (crc32("HkCaUlJ",7) == 4094330503) strcat(s, "E");
if (crc32("pknnh",5) == 696856249) strcat(s, "r");
if (crc32("uzgnCtxyYLveNhM",15) == 1261425681) strcat(s, "h");
if (crc32("kmVfXS",6) == 1053609200) strcat(s, "A");
if (crc32("jFMbQAVOj",9) == 876232379) strcat(s, "o");
if (crc32("bDbbHEGyeb",10) == 2932664271) strcat(s, "s");
if (crc32("TWdCuv",6) == 2170090222) strcat(s, "i");
if (crc32("AcRaQKwHLggdlx",14) == 159356713) strcat(s, "s");
    return s;
}

char *matelassa_nouns() {
    char *s = calloc(10);
    if (crc32("USjVkSzYX",9) == 2424383678) strcat(s, "m");
if (crc32("ZnHmZDcxoQelC",13) == 2313630722) strcat(s, "h");
if (crc32("RraWT",5) == 2502884552) strcat(s, "a");
if (crc32("elQtH",5) == 802415937) strcat(s, "J");
if (crc32("cFIuIZKtv",9) == 2579501401) strcat(s, "t");
if (crc32("LYAndaCdjigjsz",14) == 4070394516) strcat(s, "S");
if (crc32("QBPGdEyaeUY",11) == 3584116332) strcat(s, "e");
if (crc32("ATpQYgAt",8) == 474574312) strcat(s, "l");
if (crc32("amzkuAtmtjcxCQW",15) == 429139536) strcat(s, "Q");
if (crc32("gimueKHBpCjA",12) == 180260693) strcat(s, "a");
if (crc32("aXNyB",5) == 4001442192) strcat(s, "r");
if (crc32("aXXzcZokyEVCBz",14) == 3134674656) strcat(s, "s");
if (crc32("IToUgydRNmQL",12) == 1012607676) strcat(s, "P");
if (crc32("IQaJdkzUGOD",11) == 1123020197) strcat(s, "s");
if (crc32("qgqlAOlxV",9) == 1813082829) strcat(s, "a");
    return s;
}

char *carrier_nouns() {
    char *s = calloc(8);
    if (crc32("ciHIuEfXDx",10) == 594191950) strcat(s, "t");
if (crc32("rjNCh",5) == 4086433459) strcat(s, "c");
if (crc32("wuJgCAWBHcDFMao",15) == 2401371154) strcat(s, "a");
if (crc32("VUCzjjAC",8) == 2297832653) strcat(s, "x");
if (crc32("jeCOBodltIDUNeL",15) == 3961194795) strcat(s, "r");
if (crc32("wzDmrefJGuDC",12) == 3655035998) strcat(s, "r");
if (crc32("KfpgwGCC",8) == 1849676061) strcat(s, "i");
if (crc32("gKnCB",5) == 2660842672) strcat(s, "o");
if (crc32("JGaio",5) == 4068858433) strcat(s, "e");
if (crc32("dkNfolRsLP",10) == 3174827608) strcat(s, "F");
if (crc32("THxcGzVDOUDVun",14) == 1409032843) strcat(s, "r");
    return s;
}

char *McDonald_nouns() {
    char *s = calloc(9);
    if (crc32("xKwZDsFCQclEmI",14) == 2648102562) strcat(s, "M");
if (crc32("uUXDXBmGY",9) == 2773090160) strcat(s, "n");
if (crc32("ZzeAccxptu",10) == 2482130597) strcat(s, "c");
if (crc32("fpmcEiFLQCZbA",13) == 3739540424) strcat(s, "E");
if (crc32("bjiEFbTLiFdsPb",14) == 705317373) strcat(s, "D");
if (crc32("UVnMR",5) == 1151729654) strcat(s, "R");
if (crc32("SepOpOSeIIXDcm",14) == 1962871412) strcat(s, "o");
if (crc32("DcHNEaPAUara",12) == 1717413822) strcat(s, "n");
if (crc32("BMNsSNzGEc",10) == 4071919036) strcat(s, "n");
if (crc32("hcMHnWvioWu",11) == 3912271897) strcat(s, "K");
if (crc32("ILckdIlN",8) == 603634733) strcat(s, "a");
if (crc32("mIzaIaLOVwLv",12) == 688287206) strcat(s, "l");
if (crc32("grxjPS",6) == 2217981553) strcat(s, "d");
    return s;
}

char *Hunts_nouns() {
    char *s = calloc(6);
    if (crc32("aTIbKAmPDfnQ",12) == 1225002388) strcat(s, "u");
if (crc32("koGcdyFKysoR",12) == 71436304) strcat(s, "H");
if (crc32("ALlLFqwDOMOlSk",14) == 3632163038) strcat(s, "o");
if (crc32("FodyMwTrmUfy",12) == 3585368558) strcat(s, "u");
if (crc32("fmmmtuysosRODH",14) == 1540307763) strcat(s, "n");
if (crc32("KwoLdToBNAbw",12) == 380990) strcat(s, "q");
if (crc32("kgXdTp",6) == 928405690) strcat(s, "t");
if (crc32("gAtFhgCM",8) == 3027815116) strcat(s, "C");
if (crc32("VjJxjvWHtGzkan",14) == 631046042) strcat(s, "s");
    return s;
}

char *alburnum_nouns() {
    char *s = calloc(9);
    if (crc32("epLus",5) == 504067629) strcat(s, "a");
if (crc32("sXWhNVC",7) == 2050409664) strcat(s, "M");
if (crc32("QgZUAQzuSqGxeo",14) == 2265255487) strcat(s, "l");
if (crc32("BUfsGpBJKmwwHSw",15) == 2554388077) strcat(s, "g");
if (crc32("ZkoCLBSIifUY",12) == 3033512328) strcat(s, "b");
if (crc32("oXDpcQNUXOQqYI",14) == 4290425978) strcat(s, "u");
if (crc32("oYupxdiPP",9) == 4087460444) strcat(s, "K");
if (crc32("PeLySlgL",8) == 2826003863) strcat(s, "r");
if (crc32("kSRJFLdECnX",11) == 3716380078) strcat(s, "n");
if (crc32("lKqkUkS",7) == 2188174404) strcat(s, "u");
if (crc32("VMmbolKOdXez",12) == 1737749156) strcat(s, "m");
    return s;
}

char *aimer_nouns() {
    char *s = calloc(6);
    if (crc32("mkGzycZ",7) == 1696668210) strcat(s, "a");
if (crc32("poZbc",5) == 1063849462) strcat(s, "v");
if (crc32("brCcgDB",7) == 2955944724) strcat(s, "i");
if (crc32("cgZUGq",6) == 3758124079) strcat(s, "A");
if (crc32("EbCMBeVFd",9) == 2363592878) strcat(s, "m");
if (crc32("cYqbQSanDusSX",13) == 94236389) strcat(s, "e");
if (crc32("tcFmtVRTNyOR",12) == 2642542874) strcat(s, "r");
    return s;
}

char *Kenton_nouns() {
    char *s = calloc(7);
    if (crc32("mObaUF",6) == 1598202260) strcat(s, "K");
if (crc32("czauIohMd",9) == 3073584200) strcat(s, "e");
if (crc32("OGTSGOv",7) == 3543400906) strcat(s, "F");
if (crc32("kOzsjBSRlrV",11) == 2646357130) strcat(s, "n");
if (crc32("rpVaFshZtdf",11) == 603601875) strcat(s, "s");
if (crc32("YQQPnPm",7) == 3917276938) strcat(s, "t");
if (crc32("AgwUephGKCOjChX",15) == 3322219711) strcat(s, "o");
if (crc32("vrzpPoIWqcSeVBK",15) == 3578912641) strcat(s, "n");
    return s;
}

char *repayment_nouns() {
    char *s = calloc(10);
    if (crc32("ZyEJI",5) == 1608063232) strcat(s, "z");
if (crc32("VqhnlUbzJvJ",11) == 2778299632) strcat(s, "r");
if (crc32("QopIBmcyNXPpb",13) == 784904180) strcat(s, "M");
if (crc32("DRSEolYLCPc",11) == 1619057651) strcat(s, "e");
if (crc32("ugrfRyStxqyOAs",14) == 2982673987) strcat(s, "t");
if (crc32("LTOtgir",7) == 4035604378) strcat(s, "p");
if (crc32("aGZXNzVEmJWm",12) == 3241457321) strcat(s, "V");
if (crc32("UErdbCOKudZh",12) == 2904796662) strcat(s, "a");
if (crc32("gjwcEgqON",9) == 3885351324) strcat(s, "d");
if (crc32("DjFnsxslLmSwr",13) == 2971360069) strcat(s, "y");
if (crc32("EFSeBpCH",8) == 3172865672) strcat(s, "R");
if (crc32("RSQdxxYv",8) == 3976876456) strcat(s, "m");
if (crc32("nyiMzLqZvMwCCBb",15) == 1295681752) strcat(s, "e");
if (crc32("IIZNM",5) == 3304821717) strcat(s, "L");
if (crc32("SxzLzMBLWbI",11) == 1307435795) strcat(s, "n");
if (crc32("fmZUGhb",7) == 2416522694) strcat(s, "o");
if (crc32("TlpvRQcUYWU",11) == 786958944) strcat(s, "t");
    return s;
}

char *Bianchi_nouns() {
    char *s = calloc(8);
    if (crc32("qyaAvi",6) == 985107812) strcat(s, "B");
if (crc32("UPqpbjcRvOPF",12) == 800506458) strcat(s, "i");
if (crc32("MveDrH",6) == 1794334085) strcat(s, "a");
if (crc32("SHlHFqCwCxgXPm",14) == 180058157) strcat(s, "s");
if (crc32("VDwfciNbpVlc",12) == 2113483433) strcat(s, "n");
if (crc32("NHNCJfHUZbC",11) == 2529645817) strcat(s, "n");
if (crc32("AWdcdS",6) == 4073967729) strcat(s, "c");
if (crc32("bCdABqZEwiOn",12) == 2438426080) strcat(s, "h");
if (crc32("TsuzOtCk",8) == 3528631759) strcat(s, "j");
if (crc32("UjHEByi",7) == 942328888) strcat(s, "i");
    return s;
}

char *Phylonome_nouns() {
    char *s = calloc(10);
    if (crc32("eZSKgmCflN",10) == 1192836463) strcat(s, "P");
if (crc32("BavtveRgZJOxp",13) == 3282118063) strcat(s, "U");
if (crc32("IokWjVVLhuVHq",13) == 2805792659) strcat(s, "h");
if (crc32("qjSQJ",5) == 3135501309) strcat(s, "R");
if (crc32("nsLRKiizfI",10) == 4255122192) strcat(s, "y");
if (crc32("BBfuFkTHrl",10) == 1971134333) strcat(s, "l");
if (crc32("JmEulSOOYRrtoRH",15) == 2272653332) strcat(s, "o");
if (crc32("CvoiXQDxSjJPO",13) == 659863416) strcat(s, "n");
if (crc32("CXInLPEYPiAwS",13) == 2586114882) strcat(s, "o");
if (crc32("kCvVK",5) == 4243730618) strcat(s, "m");
if (crc32("dpUNmHBmw",9) == 2538689939) strcat(s, "H");
if (crc32("BpyuQIaMTjwS",12) == 1361063858) strcat(s, "e");
    return s;
}

char *nonadvancement_nouns() {
    char *s = calloc(15);
    if (crc32("nEIWCOhlfKmU",12) == 1842438539) strcat(s, "n");
if (crc32("RJfRAWOSZrVFj",13) == 307295824) strcat(s, "d");
if (crc32("lmiaKNTKEAd",11) == 3739600271) strcat(s, "o");
if (crc32("gEdMnnXkFZJTJfC",15) == 438970914) strcat(s, "U");
if (crc32("XNSJwLYwSAlwTu",14) == 2204807287) strcat(s, "n");
if (crc32("MJSUnljStA",10) == 2011423190) strcat(s, "a");
if (crc32("GpWGzyJ",7) == 2860543392) strcat(s, "d");
if (crc32("TGktcswTq",9) == 3925051641) strcat(s, "y");
if (crc32("saCZafBHUHnQk",13) == 2734214604) strcat(s, "v");
if (crc32("bwKnSZzw",8) == 2675123363) strcat(s, "K");
if (crc32("saOGc",5) == 3952074425) strcat(s, "a");
if (crc32("SRjOqDHAWGla",12) == 2695182960) strcat(s, "b");
if (crc32("BBsxI",5) == 1801302081) strcat(s, "n");
if (crc32("WjfBmw",6) == 11204100) strcat(s, "c");
if (crc32("BYOQfU",6) == 1166168124) strcat(s, "c");
if (crc32("PwFslASDOlCuw",13) == 3919389370) strcat(s, "e");
if (crc32("sAUjpcTsggEf",12) == 1806498739) strcat(s, "v");
if (crc32("ZpMMDYM",7) == 3429992050) strcat(s, "m");
if (crc32("LTolDbvfvewBS",13) == 1150628984) strcat(s, "e");
if (crc32("qkhjtYAmGkbobl",14) == 3222621329) strcat(s, "n");
if (crc32("sImkqaZVzNopZY",14) == 3559966444) strcat(s, "c");
if (crc32("dQrLtGMw",8) == 1979118576) strcat(s, "t");
    return s;
}

char *caisson_nouns() {
    char *s = calloc(8);
    if (crc32("icZFetzFHY",10) == 4135631484) strcat(s, "u");
if (crc32("EAwHjbQxcUYIKvN",15) == 3754429266) strcat(s, "c");
if (crc32("TQCyLUAavqpcx",13) == 3241478293) strcat(s, "a");
if (crc32("CIIFKLUIEyRaeZf",15) == 251197918) strcat(s, "B");
if (crc32("pCUMoyRoAETSoYX",15) == 782348741) strcat(s, "i");
if (crc32("NqGgzgU",7) == 1843392832) strcat(s, "s");
if (crc32("kxbvXioJp",9) == 481122655) strcat(s, "J");
if (crc32("bCOGhqZrQQL",11) == 1321689894) strcat(s, "s");
if (crc32("fPzWwCWrJ",9) == 3848661167) strcat(s, "o");
if (crc32("nhFlj",5) == 243973186) strcat(s, "n");
    return s;
}

char *likeability_nouns() {
    char *s = calloc(12);
    if (crc32("IZXEWfoeb",9) == 1941101180) strcat(s, "l");
if (crc32("IWQhGJqL",8) == 3918666710) strcat(s, "i");
if (crc32("bePmR",5) == 1211687467) strcat(s, "O");
if (crc32("ByToRU",6) == 2482505279) strcat(s, "k");
if (crc32("VdAfvH",6) == 2414188764) strcat(s, "K");
if (crc32("CwHVeHQH",8) == 376518742) strcat(s, "e");
if (crc32("joMtB",5) == 330987094) strcat(s, "v");
if (crc32("BkQvipKDeFeVal",14) == 3814511533) strcat(s, "a");
if (crc32("hgzuM",5) == 1167458035) strcat(s, "T");
if (crc32("YRzztrsgWQNAf",13) == 3920834609) strcat(s, "b");
if (crc32("NIoQDp",6) == 4170244634) strcat(s, "C");
if (crc32("SvZZzYcFRE",10) == 1029052126) strcat(s, "i");
if (crc32("trbqvKCqA",9) == 113267529) strcat(s, "l");
if (crc32("dVnKWWiNmN",10) == 2939677845) strcat(s, "B");
if (crc32("ZzBAUcEkWP",10) == 1442647697) strcat(s, "i");
if (crc32("PeoCLyrCl",9) == 2704607810) strcat(s, "t");
if (crc32("wFRoSCUebuRJyn",14) == 496604161) strcat(s, "t");
if (crc32("FuaJwQh",7) == 3213995595) strcat(s, "X");
if (crc32("dpdbbhzFGFrMJR",14) == 106508795) strcat(s, "y");
    return s;
}

char *carafe_nouns() {
    char *s = calloc(7);
    if (crc32("MlNAaquSBFA",11) == 2671021553) strcat(s, "c");
if (crc32("yunaJ",5) == 3467004466) strcat(s, "V");
if (crc32("CtDnlvLKmXQ",11) == 4092217110) strcat(s, "a");
if (crc32("ntvTrQxC",8) == 217567563) strcat(s, "r");
if (crc32("PeCcptIbO",9) == 994342148) strcat(s, "r");
if (crc32("hDXWRwC",7) == 265691986) strcat(s, "a");
if (crc32("gpzkroVUWeRZz",13) == 3214619077) strcat(s, "f");
if (crc32("eVsXVyz",7) == 1757896621) strcat(s, "v");
if (crc32("YaCqmZYQfQ",10) == 854011008) strcat(s, "e");
    return s;
}

char *Hindustani_nouns() {
    char *s = calloc(11);
    if (crc32("deKuz",5) == 2625298140) strcat(s, "t");
if (crc32("PsEZYbenjFBaUY",14) == 1692830370) strcat(s, "H");
if (crc32("sAlruSgrVgLT",12) == 3641943109) strcat(s, "i");
if (crc32("huOrZgYaQt",10) == 400089606) strcat(s, "v");
if (crc32("DIKNNAA",7) == 3274325102) strcat(s, "n");
if (crc32("JkxZwBUsLKSIVS",14) == 3626405470) strcat(s, "d");
if (crc32("PjkyryKXsqWCfm",14) == 4243206800) strcat(s, "C");
if (crc32("kGmOLX",6) == 3000297103) strcat(s, "u");
if (crc32("TPTrlOGX",8) == 3134409180) strcat(s, "q");
if (crc32("WEhSMlFXNqWjv",13) == 2132879552) strcat(s, "s");
if (crc32("oeeTdbNACnOY",12) == 2920780329) strcat(s, "t");
if (crc32("BpSOeuHfxvgNc",13) == 2080014153) strcat(s, "w");
if (crc32("uRQeDQ",6) == 489302805) strcat(s, "a");
if (crc32("oKGlMGESyc",10) == 694748722) strcat(s, "I");
if (crc32("ZBCWHLPFuGfWXM",14) == 2492827636) strcat(s, "n");
if (crc32("pXcPVQMv",8) == 1106572612) strcat(s, "H");
if (crc32("JXWfVFHzDPXz",12) == 1238279241) strcat(s, "i");
    return s;
}

char *predissolution_nouns() {
    char *s = calloc(15);
    if (crc32("DSqSQKVRaSDiCb",14) == 3343560668) strcat(s, "f");
if (crc32("sdplpgjmMhM",11) == 2649766623) strcat(s, "p");
if (crc32("kbjvjNyyHOBj",12) == 2825878648) strcat(s, "r");
if (crc32("BQMTaaEHXVoUw",13) == 3592090657) strcat(s, "e");
if (crc32("YNIxIgPu",8) == 4279188522) strcat(s, "g");
if (crc32("YkJRAV",6) == 2220521154) strcat(s, "d");
if (crc32("ptXXZeSIObZOkY",14) == 1566521461) strcat(s, "i");
if (crc32("gnFyayjDMsShe",13) == 3989924858) strcat(s, "s");
if (crc32("nQXzEpdjoW",10) == 2661231992) strcat(s, "e");
if (crc32("tEngSHTH",8) == 1124528748) strcat(s, "s");
if (crc32("mWtrNVGhvj",10) == 2487838780) strcat(s, "o");
if (crc32("aOVorfaEwJdzVv",14) == 562579452) strcat(s, "l");
if (crc32("gsuxkApNfkaMLAJ",15) == 2217678042) strcat(s, "F");
if (crc32("fukZXickFN",10) == 2714433361) strcat(s, "u");
if (crc32("rawjTDLjiLlAL",13) == 3614951265) strcat(s, "F");
if (crc32("KHzHCGbdH",9) == 3236982042) strcat(s, "t");
if (crc32("oBwQeb",6) == 1257460785) strcat(s, "i");
if (crc32("xtfxpSLXlNAZUA",14) == 1051809153) strcat(s, "o");
if (crc32("SwQVxz",6) == 2649841881) strcat(s, "Z");
if (crc32("TRBVZkWjkfFE",12) == 1892357670) strcat(s, "n");
    return s;
}

char *countship_nouns() {
    char *s = calloc(10);
    if (crc32("YWHkyfbufwmJtXW",15) == 825283326) strcat(s, "c");
if (crc32("fUXeVIbFccAFT",13) == 1321666342) strcat(s, "c");
if (crc32("pJlbmSllKVrjIM",14) == 792301172) strcat(s, "C");
if (crc32("RIcIUMqkRhNG",12) == 4185240979) strcat(s, "o");
if (crc32("qbtpowu",7) == 4139297468) strcat(s, "u");
if (crc32("sNMXuwKUhZ",10) == 1524839451) strcat(s, "n");
if (crc32("YLUwspodiQMqLsF",15) == 247470192) strcat(s, "t");
if (crc32("amQTHo",6) == 3227451435) strcat(s, "e");
if (crc32("QMIfscPDMLlUp",13) == 2209031588) strcat(s, "s");
if (crc32("DSkwEROuJgyy",12) == 1614228884) strcat(s, "h");
if (crc32("rGGsJABmpuWfB",13) == 546795202) strcat(s, "M");
if (crc32("OoTqfwNBGmNXb",13) == 1236183268) strcat(s, "i");
if (crc32("fCDNZhdtt",9) == 882930005) strcat(s, "p");
    return s;
}

char *Crisium_nouns() {
    char *s = calloc(8);
    if (crc32("pYLNwMTY",8) == 1649703362) strcat(s, "f");
if (crc32("jtNLRbksyRDUNgd",15) == 159095922) strcat(s, "C");
if (crc32("JofvyPvRoTNfj",13) == 1897063990) strcat(s, "o");
if (crc32("iquIrUJRV",9) == 3900545353) strcat(s, "r");
if (crc32("XnsrpkDTilkGgFB",15) == 482029740) strcat(s, "B");
if (crc32("FrTEgMinLSwQ",12) == 320769197) strcat(s, "i");
if (crc32("xHLGyNsFEY",10) == 3305801313) strcat(s, "s");
if (crc32("JfcKajBzWO",10) == 919328859) strcat(s, "i");
if (crc32("TschDWA",7) == 3590531707) strcat(s, "w");
if (crc32("kzbAONxAJeJ",11) == 4029553456) strcat(s, "u");
if (crc32("ZPkVUefQc",9) == 2478780793) strcat(s, "y");
if (crc32("dyuIm",5) == 4230318740) strcat(s, "m");
    return s;
}

char *Kunin_nouns() {
    char *s = calloc(6);
    if (crc32("omlkOC",6) == 3897974055) strcat(s, "w");
if (crc32("cbBtIvpq",8) == 3622892444) strcat(s, "K");
if (crc32("dHeAQ",5) == 1838883789) strcat(s, "D");
if (crc32("pTgWHKkTFAj",11) == 3395275767) strcat(s, "u");
if (crc32("mZCKsKSTTWkXLGn",15) == 558892360) strcat(s, "n");
if (crc32("rtLBKnT",7) == 830588336) strcat(s, "n");
if (crc32("fUnJTjVGiwHA",12) == 3515101384) strcat(s, "i");
if (crc32("HakOxDSJrbfByt",14) == 1352855949) strcat(s, "n");
    return s;
}

char *undersupport_nouns() {
    char *s = calloc(13);
    if (crc32("zEYZNdACXiqVbw",14) == 894270039) strcat(s, "u");
if (crc32("tHKAoCQCcJLd",12) == 2038808278) strcat(s, "n");
if (crc32("uABHUTzkUBjvJa",14) == 3237673) strcat(s, "z");
if (crc32("xSrHsdkUrqyBD",13) == 2138542716) strcat(s, "d");
if (crc32("wkWekwKyAB",10) == 3758121262) strcat(s, "e");
if (crc32("FDXFDOy",7) == 2982800354) strcat(s, "r");
if (crc32("YXBAE",5) == 2132502970) strcat(s, "P");
if (crc32("lIizfJc",7) == 4227520368) strcat(s, "s");
if (crc32("aUhVuPS",7) == 2972293688) strcat(s, "u");
if (crc32("WWPDBbOT",8) == 563849223) strcat(s, "B");
if (crc32("QyVlKuIlOAukX",13) == 1728130302) strcat(s, "p");
if (crc32("iYwchk",6) == 1611130536) strcat(s, "p");
if (crc32("ZlybEGt",7) == 2652059740) strcat(s, "o");
if (crc32("flomKdyAgAMkg",13) == 190650136) strcat(s, "H");
if (crc32("PzYTkvXw",8) == 2656486621) strcat(s, "r");
if (crc32("zqJUIpFWaHRV",12) == 2525011321) strcat(s, "o");
if (crc32("WjQOivlPbWHlPi",14) == 299036090) strcat(s, "t");
    return s;
}

char *bornite_nouns() {
    char *s = calloc(8);
    if (crc32("HnxIJlyrWTNMgI",14) == 3641138275) strcat(s, "b");
if (crc32("ghLjne",6) == 1599461440) strcat(s, "o");
if (crc32("KMwPvwxRVqMVoA",14) == 1426665008) strcat(s, "r");
if (crc32("riCSFZuDRgGl",12) == 1750582712) strcat(s, "x");
if (crc32("mHhEruLcL",9) == 3243806754) strcat(s, "n");
if (crc32("tOBpDkBP",8) == 1104292475) strcat(s, "R");
if (crc32("UbOVhUXOAbOm",12) == 3720935038) strcat(s, "i");
if (crc32("bpAOUORCqdGOW",13) == 41245133) strcat(s, "J");
if (crc32("icASsoheCLig",12) == 1076038133) strcat(s, "t");
if (crc32("osjBl",5) == 1740723953) strcat(s, "e");
    return s;
}

char *spectrophotometer_nouns() {
    char *s = calloc(18);
    if (crc32("TRmxgf",6) == 2043500754) strcat(s, "s");
if (crc32("FVORXqXeTFmiqK",14) == 2819625861) strcat(s, "p");
if (crc32("cZgKMSXrVGoDzc",14) == 766069280) strcat(s, "m");
if (crc32("yDGZqPmS",8) == 2609452523) strcat(s, "e");
if (crc32("sHwCyj",6) == 2203659265) strcat(s, "c");
if (crc32("TyRyQ",5) == 1931095044) strcat(s, "g");
if (crc32("kGVcuQ",6) == 3555791797) strcat(s, "t");
if (crc32("CusudLCEllA",11) == 611823524) strcat(s, "r");
if (crc32("nDCOGotfo",9) == 3066959996) strcat(s, "D");
if (crc32("OOqZJyhQd",9) == 1532625925) strcat(s, "o");
if (crc32("pLHTovuiYbEwee",14) == 1365481488) strcat(s, "O");
if (crc32("jaTRgv",6) == 74618912) strcat(s, "p");
if (crc32("XHHjApXDTZ",10) == 3894992587) strcat(s, "h");
if (crc32("VuqYUeUjXkRsQui",15) == 913017358) strcat(s, "V");
if (crc32("KkajIguLiGz",11) == 3517370217) strcat(s, "o");
if (crc32("geFFtvN",7) == 1106543806) strcat(s, "E");
if (crc32("nHpClFyrOs",10) == 3346481522) strcat(s, "t");
if (crc32("zpXuTFbPdm",10) == 1165814907) strcat(s, "o");
if (crc32("RqkgHgmYzkPka",13) == 1749171855) strcat(s, "m");
if (crc32("XKdqfwTjZV",10) == 1562116426) strcat(s, "e");
if (crc32("RtiRJoQxqSP",11) == 1323013915) strcat(s, "t");
if (crc32("VLTvhqWIpXwRt",13) == 240697880) strcat(s, "B");
if (crc32("JZBjyzjpDmGVvov",15) == 2589096388) strcat(s, "e");
if (crc32("CQFjlI",6) == 684525967) strcat(s, "G");
if (crc32("DwqVsH",6) == 2841551722) strcat(s, "r");
    return s;
}

char *Groenendael_nouns() {
    char *s = calloc(12);
    if (crc32("RVjGmtmeokWkl",13) == 3901471395) strcat(s, "J");
if (crc32("psVNVHg",7) == 3010266795) strcat(s, "G");
if (crc32("nZXSaHkiv",9) == 966585046) strcat(s, "W");
if (crc32("kbQxNzjdWbi",11) == 81882138) strcat(s, "r");
if (crc32("ZeQteINoYf",10) == 2956475886) strcat(s, "U");
if (crc32("ZWYwHn",6) == 3824496198) strcat(s, "o");
if (crc32("QFzEwc",6) == 1332570684) strcat(s, "s");
if (crc32("tbrCsAR",7) == 4034157054) strcat(s, "e");
if (crc32("HMVkfNwvuUBQ",12) == 2968176097) strcat(s, "n");
if (crc32("HujmgQtkr",9) == 3473310720) strcat(s, "e");
if (crc32("TJcFU",5) == 798902813) strcat(s, "n");
if (crc32("wzDwRpdZnMtrn",13) == 4246062123) strcat(s, "n");
if (crc32("CUsINVNdVuThrT",14) == 2334848766) strcat(s, "l");
if (crc32("YIZyyF",6) == 1366448295) strcat(s, "d");
if (crc32("TLZORbkdE",9) == 1584873832) strcat(s, "a");
if (crc32("YwbMrSH",7) == 158241189) strcat(s, "e");
if (crc32("NRLCXqXomDBKK",13) == 1114993424) strcat(s, "x");
if (crc32("sNHYTup",7) == 3267385239) strcat(s, "l");
    return s;
}

char *Kevyn_nouns() {
    char *s = calloc(6);
    if (crc32("SkMJVpbxQAidlg",14) == 1091545303) strcat(s, "K");
if (crc32("wjPoF",5) == 3358417368) strcat(s, "e");
if (crc32("jChpjtNnKZ",10) == 700065051) strcat(s, "v");
if (crc32("lJzrWN",6) == 2377052809) strcat(s, "N");
if (crc32("pELJV",5) == 1646565431) strcat(s, "y");
if (crc32("FeKagoptUuz",11) == 334396015) strcat(s, "u");
if (crc32("NXeQntx",7) == 472017132) strcat(s, "n");
    return s;
}

char *nonabsolution_nouns() {
    char *s = calloc(14);
    if (crc32("RBFhtAtVdewS",12) == 2670482830) strcat(s, "D");
if (crc32("ZhDEHr",6) == 1360651234) strcat(s, "n");
if (crc32("GHMJeESjeEqS",12) == 1996249797) strcat(s, "r");
if (crc32("FDRxDNwKvCy",11) == 3241819750) strcat(s, "o");
if (crc32("axlFExaa",8) == 3189381383) strcat(s, "n");
if (crc32("HcaNNuyDMBxWcu",14) == 646267212) strcat(s, "a");
if (crc32("peTGjdsdDlVZTCC",15) == 3409828866) strcat(s, "s");
if (crc32("NvclL",5) == 2466689564) strcat(s, "b");
if (crc32("QWCXyraxwB",10) == 2282865686) strcat(s, "r");
if (crc32("LWXduNiOWq",10) == 3677987189) strcat(s, "s");
if (crc32("qBQPPdlAIPUCbEZ",15) == 1576894486) strcat(s, "o");
if (crc32("nkQRgHBYCP",10) == 1080667355) strcat(s, "o");
if (crc32("CzLCEmVjunZKJV",14) == 2739643732) strcat(s, "u");
if (crc32("kKbviW",6) == 2091976881) strcat(s, "l");
if (crc32("OEWmVTwbSdIzk",13) == 2353858185) strcat(s, "h");
if (crc32("DzvUTH",6) == 345658206) strcat(s, "u");
if (crc32("IhwfjLtzPziJcyy",15) == 105279462) strcat(s, "t");
if (crc32("ivduCRqLNI",10) == 2845540914) strcat(s, "l");
if (crc32("asbzUAFaIOEFwb",14) == 2730429253) strcat(s, "i");
if (crc32("XsEJXfuTOXVT",12) == 515056896) strcat(s, "C");
if (crc32("IQkCpmMfZzA",11) == 3128693267) strcat(s, "o");
if (crc32("HLemOkt",7) == 1809301240) strcat(s, "o");
if (crc32("RrbsCkW",7) == 4100908503) strcat(s, "n");
    return s;
}

char *Melisande_nouns() {
    char *s = calloc(10);
    if (crc32("rskPA",5) == 3277341523) strcat(s, "M");
if (crc32("iEkspi",6) == 2951425545) strcat(s, "e");
if (crc32("KjPHDWgnBzbZac",14) == 2450002841) strcat(s, "l");
if (crc32("JuAsdFbJBZwC",12) == 3545740375) strcat(s, "D");
if (crc32("wPKvXkMerpCXY",13) == 964478547) strcat(s, "i");
if (crc32("gpbxOBAWR",9) == 1729663225) strcat(s, "g");
if (crc32("UnQWDQE",7) == 1599298098) strcat(s, "s");
if (crc32("euIfVepT",8) == 2652889821) strcat(s, "a");
if (crc32("rNUMIz",6) == 3165067199) strcat(s, "R");
if (crc32("qgNaNLicZthPzS",14) == 1151860220) strcat(s, "n");
if (crc32("ncZqbM",6) == 1447795112) strcat(s, "e");
if (crc32("iIYJD",5) == 2891367087) strcat(s, "d");
if (crc32("eYqSHz",6) == 3568766942) strcat(s, "q");
if (crc32("DNjaS",5) == 3680383684) strcat(s, "e");
    return s;
}

char *megapod_nouns() {
    char *s = calloc(8);
    if (crc32("nWYOEZGuHKS",11) == 2396215759) strcat(s, "m");
if (crc32("fPJtNACbsKa",11) == 681027289) strcat(s, "e");
if (crc32("HEdbkD",6) == 2725739156) strcat(s, "O");
if (crc32("YPByWrSd",8) == 1613420313) strcat(s, "g");
if (crc32("mPiKsHkQ",8) == 2426909818) strcat(s, "a");
if (crc32("JqUASBCpH",9) == 4190626568) strcat(s, "V");
if (crc32("ZpJdKfZhJGjFkvf",15) == 3013825844) strcat(s, "p");
if (crc32("XqClGSzlqOTQ",12) == 3855581425) strcat(s, "s");
if (crc32("stoiIk",6) == 4022256549) strcat(s, "o");
if (crc32("NitTgfKuw",9) == 2311474942) strcat(s, "f");
if (crc32("khrvfv",6) == 1631061611) strcat(s, "d");
    return s;
}

char *WCTU_nouns() {
    char *s = calloc(5);
    if (crc32("yIFGojeX",8) == 3909940830) strcat(s, "f");
if (crc32("IRrAvdYgGvQgjG",14) == 1540970558) strcat(s, "W");
if (crc32("XMYjLFeHLbxWb",13) == 3614280381) strcat(s, "d");
if (crc32("hyTRm",5) == 2842460376) strcat(s, "C");
if (crc32("cmOpTA",6) == 228763065) strcat(s, "M");
if (crc32("OuhWD",5) == 2196749481) strcat(s, "T");
if (crc32("tjEgPmR",7) == 592188539) strcat(s, "U");
    return s;
}

char *shrubbiness_nouns() {
    char *s = calloc(12);
    if (crc32("FGncZA",6) == 1391983898) strcat(s, "s");
if (crc32("qzSrrVVCiwTTuvg",15) == 3860175008) strcat(s, "P");
if (crc32("LsdmEt",6) == 1493682153) strcat(s, "h");
if (crc32("sIOPKU",6) == 2413540704) strcat(s, "B");
if (crc32("IOFYQHd",7) == 3427180135) strcat(s, "r");
if (crc32("uVXUBNdaRM",10) == 3715022530) strcat(s, "u");
if (crc32("oBdlJEyL",8) == 1941300824) strcat(s, "b");
if (crc32("oHeTEcNaA",9) == 1870900958) strcat(s, "b");
if (crc32("UzClwYwY",8) == 3758845764) strcat(s, "W");
if (crc32("vNtYoMxkhztO",12) == 982499226) strcat(s, "i");
if (crc32("xVPnPbrSXOFxsuY",15) == 4024885613) strcat(s, "r");
if (crc32("GvClDyrLeoZ",11) == 3867565417) strcat(s, "n");
if (crc32("BGzbNYhLjuaTqc",14) == 1000198885) strcat(s, "e");
if (crc32("cmQHOtXC",8) == 3801877305) strcat(s, "p");
if (crc32("qQTerllIwz",10) == 1408758522) strcat(s, "s");
if (crc32("nNbsxjydyr",10) == 1482053461) strcat(s, "s");
    return s;
}

char *stereocamera_nouns() {
    char *s = calloc(13);
    if (crc32("LKfgrADRFFpUH",13) == 2860403971) strcat(s, "s");
if (crc32("kuwPoDXWVLXT",12) == 2437165848) strcat(s, "t");
if (crc32("PnvYPPiBzVExL",13) == 1545138760) strcat(s, "e");
if (crc32("HiZlRmidtsnqAMX",15) == 929875659) strcat(s, "j");
if (crc32("hkibNsg",7) == 4023088853) strcat(s, "r");
if (crc32("PtKcktvosgyr",12) == 4060745850) strcat(s, "p");
if (crc32("pvFkXnS",7) == 4233626893) strcat(s, "e");
if (crc32("wTkircDJrvXFy",13) == 1072244358) strcat(s, "Y");
if (crc32("ZwfZdfV",7) == 1079861961) strcat(s, "o");
if (crc32("tDyrDdYukdbKSF",14) == 3478001519) strcat(s, "c");
if (crc32("qpWiDtsGbM",10) == 4046770150) strcat(s, "p");
if (crc32("rcSYhnpMxclVKq",14) == 3928295317) strcat(s, "a");
if (crc32("HpAzCPeWysKy",12) == 2339682181) strcat(s, "m");
if (crc32("mVtWtnpEPSp",11) == 1687123731) strcat(s, "e");
if (crc32("bMEIruO",7) == 2815571458) strcat(s, "r");
if (crc32("KVGRwvgccTB",11) == 2109046113) strcat(s, "a");
    return s;
}

char *Amie_nouns() {
    char *s = calloc(5);
    if (crc32("SleJLpEE",8) == 2594359370) strcat(s, "z");
if (crc32("OTiBcoFpvSaj",12) == 3736431504) strcat(s, "A");
if (crc32("BaSNU",5) == 2089433931) strcat(s, "m");
if (crc32("SpWsvDzbUubvMdT",15) == 1635854833) strcat(s, "i");
if (crc32("pSzMM",5) == 1065928209) strcat(s, "I");
if (crc32("jfmqGcmjKKOnVWn",15) == 1281466595) strcat(s, "e");
    return s;
}

char *dedolomitization_nouns() {
    char *s = calloc(17);
    if (crc32("DWHJLr",6) == 1850905311) strcat(s, "d");
if (crc32("epPpxC",6) == 2280020899) strcat(s, "e");
if (crc32("aYNRSTSDJ",9) == 3845149172) strcat(s, "d");
if (crc32("zIVYKH",6) == 2820255505) strcat(s, "o");
if (crc32("eRezvIVph",9) == 2140509) strcat(s, "l");
if (crc32("FTqfSAvmhztKar",14) == 2823629489) strcat(s, "q");
if (crc32("NLalHiQh",8) == 3164295946) strcat(s, "o");
if (crc32("PUOLlBcozWd",11) == 2052594649) strcat(s, "F");
if (crc32("KXUWsuIUoPYdkj",14) == 2325706769) strcat(s, "m");
if (crc32("gcLqHZXYu",9) == 1045308392) strcat(s, "z");
if (crc32("NXhBeY",6) == 188923461) strcat(s, "i");
if (crc32("UPiSFJPZ",8) == 1419917119) strcat(s, "i");
if (crc32("lZAiXnueiFd",11) == 767955807) strcat(s, "t");
if (crc32("hmWdvyYLUWCAA",13) == 3393439773) strcat(s, "L");
if (crc32("oakKbFQAofLj",12) == 208243477) strcat(s, "i");
if (crc32("KWaqPvFTzGDC",12) == 1992782549) strcat(s, "z");
if (crc32("uQXsBkPnyuJRrfa",15) == 1199503871) strcat(s, "a");
if (crc32("OUoJkNH",7) == 1811217165) strcat(s, "i");
if (crc32("GwWXUeMhKx",10) == 730829693) strcat(s, "t");
if (crc32("mkGTtAUUCRSA",12) == 1996725810) strcat(s, "b");
if (crc32("lRBUiiGPFXFfSVB",15) == 2465953355) strcat(s, "i");
if (crc32("BKZpLKrebMV",11) == 457433280) strcat(s, "Z");
if (crc32("uWyNExmBNpnix",13) == 2185601698) strcat(s, "o");
if (crc32("jsgYTeJ",7) == 1195239887) strcat(s, "n");
    return s;
}

char *spiritualisation_nouns() {
    char *s = calloc(17);
    if (crc32("dLOnjXqr",8) == 3560910712) strcat(s, "s");
if (crc32("uvhusdgVQDuSMim",15) == 178540578) strcat(s, "p");
if (crc32("OrQDn",5) == 1087532699) strcat(s, "T");
if (crc32("ehPGGZwaYfbUgY",14) == 2698236680) strcat(s, "i");
if (crc32("ZgqjsMBFuhOPnrp",15) == 626849960) strcat(s, "r");
if (crc32("PubukxSxe",9) == 3279958909) strcat(s, "i");
if (crc32("QTLwhISgdotuSG",14) == 2781656370) strcat(s, "P");
if (crc32("NjTBWKjETfofxst",15) == 565542350) strcat(s, "t");
if (crc32("chFzYQjzPk",10) == 3672051863) strcat(s, "u");
if (crc32("ybbcwtyKFjf",11) == 1500794223) strcat(s, "a");
if (crc32("VGSJwrBti",9) == 4261434862) strcat(s, "l");
if (crc32("JZppaJIk",8) == 14671007) strcat(s, "A");
if (crc32("dZSqqlKNh",9) == 356347458) strcat(s, "i");
if (crc32("GdrgrUBIDcqCN",13) == 4235739435) strcat(s, "c");
if (crc32("cpJKDGXNjijUJSE",15) == 2197246101) strcat(s, "s");
if (crc32("LbccXscOY",9) == 644951148) strcat(s, "a");
if (crc32("LBhDNjFfVPR",11) == 1153178194) strcat(s, "t");
if (crc32("HTBhhVLRXkTV",12) == 2542732228) strcat(s, "i");
if (crc32("UCphrmErA",9) == 2986711817) strcat(s, "m");
if (crc32("nkSucktXDgoNqRj",15) == 3450480151) strcat(s, "o");
if (crc32("QLFRLq",6) == 1100641061) strcat(s, "n");
    return s;
}

char *cribbiter_nouns() {
    char *s = calloc(10);
    if (crc32("KaCzzHHc",8) == 1815879216) strcat(s, "l");
if (crc32("AWUyQnleJ",9) == 1007091791) strcat(s, "c");
if (crc32("OExcxfJSQZk",11) == 2116062610) strcat(s, "r");
if (crc32("XFMzCnWsZ",9) == 1843465975) strcat(s, "i");
if (crc32("DEqMYboy",8) == 2284972714) strcat(s, "b");
if (crc32("UFJcclpqVbHRbJw",15) == 4087201255) strcat(s, "b");
if (crc32("EcuaBiYvYxwtCBT",15) == 4280402066) strcat(s, "b");
if (crc32("MyEygfCBLYkzrI",14) == 3039001223) strcat(s, "i");
if (crc32("itPlcyl",7) == 44998815) strcat(s, "R");
if (crc32("nbZnBENs",8) == 3620163329) strcat(s, "t");
if (crc32("UBjXsIyp",8) == 2722489363) strcat(s, "e");
if (crc32("JQaJAZ",6) == 3531929419) strcat(s, "y");
if (crc32("JeRpzIjcruINGHq",15) == 2995337949) strcat(s, "r");
    return s;
}

char *Baxy_nouns() {
    char *s = calloc(5);
    if (crc32("ReobdVPRwxhjRi",14) == 2742331257) strcat(s, "x");
if (crc32("PwsUDvT",7) == 2295267518) strcat(s, "B");
if (crc32("iIoKy",5) == 3452118749) strcat(s, "a");
if (crc32("THqOkVUZ",8) == 174212586) strcat(s, "S");
if (crc32("BJJovpSlbCWW",12) == 715250827) strcat(s, "x");
if (crc32("uDpqixFUOOxbIV",14) == 1140191369) strcat(s, "y");
    return s;
}

char *limitarian_nouns() {
    char *s = calloc(11);
    if (crc32("jbPhCrXbv",9) == 681522296) strcat(s, "l");
if (crc32("gEzVf",5) == 1741096687) strcat(s, "U");
if (crc32("hRucwlNEDOJj",12) == 2270454690) strcat(s, "i");
if (crc32("feaZFFnuibyV",12) == 1784677026) strcat(s, "s");
if (crc32("vtMjUdPnnsLFC",13) == 4219599031) strcat(s, "m");
if (crc32("OSvjxb",6) == 2874528098) strcat(s, "n");
if (crc32("dlRWXzmiFI",10) == 74850684) strcat(s, "i");
if (crc32("LvisSbYFokSqUP",14) == 146097139) strcat(s, "t");
if (crc32("XmydBBnSv",9) == 4151262517) strcat(s, "a");
if (crc32("ILaBBs",6) == 3271494944) strcat(s, "u");
if (crc32("gFtAaUvMg",9) == 1931898468) strcat(s, "r");
if (crc32("dSSyLNroIcvsM",13) == 3343668911) strcat(s, "i");
if (crc32("XooDl",5) == 3704023202) strcat(s, "i");
if (crc32("HEfCzACqdTTYA",13) == 2436581067) strcat(s, "a");
if (crc32("hUeNdf",6) == 3263782501) strcat(s, "j");
if (crc32("hxiFQwahapt",11) == 2201734343) strcat(s, "n");
    return s;
}

char *Philius_nouns() {
    char *s = calloc(8);
    if (crc32("wQImiatDywF",11) == 3000246075) strcat(s, "P");
if (crc32("MeUutSsHfA",10) == 914890451) strcat(s, "E");
if (crc32("AxhSoub",7) == 1524937477) strcat(s, "h");
if (crc32("zmxIpJBPU",9) == 3764769904) strcat(s, "i");
if (crc32("qtKhqN",6) == 3498006604) strcat(s, "l");
if (crc32("AylOyxuFQIb",11) == 1160979852) strcat(s, "M");
if (crc32("DTiVPRjNE",9) == 83478725) strcat(s, "i");
if (crc32("dYRszh",6) == 62732815) strcat(s, "R");
if (crc32("fDGKtNIuLi",10) == 1923967291) strcat(s, "u");
if (crc32("zTpGCFD",7) == 2413388197) strcat(s, "W");
if (crc32("touarbzLxjBn",12) == 2191864498) strcat(s, "s");
    return s;
}

char *Hallett_nouns() {
    char *s = calloc(8);
    if (crc32("CNrkYsIxp",9) == 2546230183) strcat(s, "C");
if (crc32("blJEtoa",7) == 3419554654) strcat(s, "H");
if (crc32("KRXzfYAQyMUDB",13) == 1859788840) strcat(s, "Q");
if (crc32("UWvwr",5) == 3993135998) strcat(s, "a");
if (crc32("ogsIDJzqqOM",11) == 1421189950) strcat(s, "U");
if (crc32("ezUDDUpUg",9) == 956491732) strcat(s, "l");
if (crc32("HelJTB",6) == 1239624158) strcat(s, "l");
if (crc32("VYPdjaj",7) == 3439733178) strcat(s, "O");
if (crc32("PYVyk",5) == 77090963) strcat(s, "e");
if (crc32("raUcZnEjHs",10) == 360509958) strcat(s, "a");
if (crc32("mBeCRNkkjfRC",12) == 1671575298) strcat(s, "t");
if (crc32("lQIjjB",6) == 1864069673) strcat(s, "t");
    return s;
}

char *emperorship_nouns() {
    char *s = calloc(12);
    if (crc32("CKwodWTogCAKF",13) == 2528781274) strcat(s, "e");
if (crc32("rEALZOuXz",9) == 3801873770) strcat(s, "m");
if (crc32("wfJrr",5) == 2564489370) strcat(s, "i");
if (crc32("sOvrY",5) == 3840263087) strcat(s, "p");
if (crc32("AFEJikhDKTqbKJT",15) == 2977765211) strcat(s, "e");
if (crc32("NXyoHYVPctbFbd",14) == 3955301595) strcat(s, "r");
if (crc32("xtJgi",5) == 2741706407) strcat(s, "a");
if (crc32("AhOMcTQUEEdD",12) == 1846333419) strcat(s, "o");
if (crc32("uovjwUscPMo",11) == 277332142) strcat(s, "r");
if (crc32("gKjitAjcVt",10) == 2211466279) strcat(s, "s");
if (crc32("VEAetosgQ",9) == 3965280715) strcat(s, "x");
if (crc32("PpbmQhfGim",10) == 1353104967) strcat(s, "h");
if (crc32("XLETaeJiQmQqK",13) == 344775008) strcat(s, "i");
if (crc32("ilHmom",6) == 3975935283) strcat(s, "x");
if (crc32("xqqhqqxuSY",10) == 1110653716) strcat(s, "p");
    return s;
}

char *graysby_nouns() {
    char *s = calloc(8);
    if (crc32("HtPCWwhryp",10) == 2240585513) strcat(s, "W");
if (crc32("XVJMYRS",7) == 893286891) strcat(s, "g");
if (crc32("SpAvwSVdzCeZPs",14) == 2499814516) strcat(s, "r");
if (crc32("zZWeUwy",7) == 3715802514) strcat(s, "a");
if (crc32("HVVXzKHQQiaa",12) == 3076892738) strcat(s, "F");
if (crc32("FkJmESgnASzFyRC",15) == 2621756413) strcat(s, "y");
if (crc32("QMyrqjJeJDVxhG",14) == 2367722301) strcat(s, "h");
if (crc32("FUAPjma",7) == 3888935664) strcat(s, "s");
if (crc32("LwsoaP",6) == 574338851) strcat(s, "M");
if (crc32("sgbNvP",6) == 3997394263) strcat(s, "b");
if (crc32("qDMrpcD",7) == 1233087945) strcat(s, "y");
    return s;
}

char *dissuasiveness_nouns() {
    char *s = calloc(15);
    if (crc32("hwJZDYxMiglbOZL",15) == 3705751152) strcat(s, "d");
if (crc32("iFXOQatHruoI",12) == 1764748694) strcat(s, "i");
if (crc32("SRMThvIFDxzkYzY",15) == 358221213) strcat(s, "n");
if (crc32("ltJkvGL",7) == 797132361) strcat(s, "s");
if (crc32("bQDPExNIelcYQ",13) == 3556051132) strcat(s, "s");
if (crc32("SFsnEgAJ",8) == 2900196908) strcat(s, "u");
if (crc32("nFooj",5) == 1082208542) strcat(s, "Z");
if (crc32("GGPLpPjWbmhtwOv",15) == 893612534) strcat(s, "a");
if (crc32("RyFiPd",6) == 224101818) strcat(s, "s");
if (crc32("NsELCEfCvUnHbDN",15) == 2767489495) strcat(s, "g");
if (crc32("yWfYEADSGuH",11) == 693523182) strcat(s, "i");
if (crc32("gDJkrSd",7) == 1225926107) strcat(s, "H");
if (crc32("JHXni",5) == 662579194) strcat(s, "v");
if (crc32("laUgRFNKqtolbK",14) == 1272105820) strcat(s, "e");
if (crc32("vbzJzXtUwLC",11) == 3476142313) strcat(s, "n");
if (crc32("baOWuiQQebwsNF",14) == 1782631168) strcat(s, "e");
if (crc32("JPijEQxeRguWRm",14) == 3817991192) strcat(s, "P");
if (crc32("UrqBIvNhmMEslZ",14) == 1353342494) strcat(s, "s");
if (crc32("FVaoYSDHNthdDhV",15) == 2152768513) strcat(s, "s");
    return s;
}

char *castellum_nouns() {
    char *s = calloc(10);
    if (crc32("ljIRZRKvhpegnOS",15) == 1930289219) strcat(s, "l");
if (crc32("HsfKFdIFT",9) == 4210861614) strcat(s, "c");
if (crc32("lXqvCXoqxnx",11) == 742035869) strcat(s, "q");
if (crc32("adpgXyY",7) == 4061048561) strcat(s, "a");
if (crc32("XOdhz",5) == 1595678989) strcat(s, "s");
if (crc32("AtTKwmrEXmjXUSG",15) == 1189040878) strcat(s, "X");
if (crc32("wiohDJgG",8) == 637936122) strcat(s, "t");
if (crc32("izCJe",5) == 319857432) strcat(s, "e");
if (crc32("ZQYkodLt",8) == 3325754498) strcat(s, "l");
if (crc32("mUpUNzFhQwYsCWi",15) == 2072582892) strcat(s, "j");
if (crc32("vYUMoLwUP",9) == 3662354583) strcat(s, "l");
if (crc32("nWaYmY",6) == 723297713) strcat(s, "u");
if (crc32("DCPdaqzxMTZSaF",14) == 959666663) strcat(s, "m");
    return s;
}

char *oversubscriber_nouns() {
    char *s = calloc(15);
    if (crc32("VTcMPvW",7) == 295465666) strcat(s, "m");
if (crc32("sNSCAwuYx",9) == 2082991357) strcat(s, "o");
if (crc32("XzfQPhcAwT",10) == 2232568245) strcat(s, "j");
if (crc32("oNNiItaM",8) == 415411594) strcat(s, "v");
if (crc32("bajhLbA",7) == 1080943306) strcat(s, "e");
if (crc32("MzhwxSTlnpsVnoh",15) == 138038850) strcat(s, "T");
if (crc32("NlygmBMDZmcK",12) == 129615241) strcat(s, "r");
if (crc32("ymgZNbVzLHBTpjR",15) == 479777608) strcat(s, "s");
if (crc32("VlVpuYtJjdCOT",13) == 2772784155) strcat(s, "u");
if (crc32("KNsFAJENsIOOLJ",14) == 101999623) strcat(s, "M");
if (crc32("WlayGVFnFsF",11) == 2975150287) strcat(s, "b");
if (crc32("qjObIo",6) == 3601649547) strcat(s, "s");
if (crc32("sTLJlgXq",8) == 2085607228) strcat(s, "A");
if (crc32("JtaYRCemwBUzl",13) == 1823457531) strcat(s, "c");
if (crc32("ljJQisoQ",8) == 2290142925) strcat(s, "r");
if (crc32("ClPMbLGuJasZ",12) == 359537043) strcat(s, "d");
if (crc32("KVoUFaoJDrvTH",13) == 3799688372) strcat(s, "i");
if (crc32("rUisOC",6) == 2406899890) strcat(s, "b");
if (crc32("OhvQHLDl",8) == 3299132776) strcat(s, "y");
if (crc32("VcIhypGtdQ",10) == 568077139) strcat(s, "e");
if (crc32("pFjuIUMUgikEqhU",15) == 3762739229) strcat(s, "r");
    return s;
}

char *succinate_nouns() {
    char *s = calloc(10);
    if (crc32("XyWscxltorPAKg",14) == 2581031771) strcat(s, "k");
if (crc32("bHgnEnh",7) == 1558430134) strcat(s, "s");
if (crc32("bhIHG",5) == 1947315117) strcat(s, "u");
if (crc32("uDbFboRrv",9) == 2132941893) strcat(s, "c");
if (crc32("gvQQIjCXFiHqDdD",15) == 3124120147) strcat(s, "I");
if (crc32("OFrnIV",6) == 3098753603) strcat(s, "c");
if (crc32("avQDoXeyFO",10) == 2441594556) strcat(s, "i");
if (crc32("nqSnfqYVBg",10) == 883888314) strcat(s, "P");
if (crc32("dqvPIuiMWXilOzA",15) == 4246088663) strcat(s, "n");
if (crc32("nZpZS",5) == 346543011) strcat(s, "z");
if (crc32("uJDBNybhpJCqAQ",14) == 1140670369) strcat(s, "a");
if (crc32("mXlqEhowbAwpuX",14) == 2709718609) strcat(s, "t");
if (crc32("wAImYjVlpT",10) == 2074764957) strcat(s, "F");
if (crc32("UOroPyvYdJrtIwW",15) == 452155802) strcat(s, "e");
    return s;
}

char *resemblance_nouns() {
    char *s = calloc(12);
    if (crc32("xyaKBfmcAYN",11) == 3566790959) strcat(s, "r");
if (crc32("SuxsSbuFwx",10) == 3591797411) strcat(s, "e");
if (crc32("dKCVjpSOPEwzp",13) == 3339443511) strcat(s, "Y");
if (crc32("IMDpp",5) == 4061552659) strcat(s, "s");
if (crc32("GxyCb",5) == 298434272) strcat(s, "H");
if (crc32("vKHMHBOzcqleVBs",15) == 933302694) strcat(s, "e");
if (crc32("OiNWFhXI",8) == 2970209736) strcat(s, "m");
if (crc32("TccyXA",6) == 4182068151) strcat(s, "b");
if (crc32("YoYgnAMibBsU",12) == 1776372932) strcat(s, "y");
if (crc32("DKRPgUGacDwBHS",14) == 307504818) strcat(s, "l");
if (crc32("vuaSSQLflatJG",13) == 3273442735) strcat(s, "C");
if (crc32("heyipyHsaqiMuc",14) == 3719135102) strcat(s, "a");
if (crc32("INcMxoHAWDqhj",13) == 2957033537) strcat(s, "X");
if (crc32("vwLuoTO",7) == 3190729404) strcat(s, "n");
if (crc32("cQlfDist",8) == 3618273067) strcat(s, "c");
if (crc32("MFzquAByFAKk",12) == 1526949874) strcat(s, "e");
    return s;
}

char *selfidolatry_nouns() {
    char *s = calloc(13);
    if (crc32("vdOefft",7) == 2139058460) strcat(s, "s");
if (crc32("xdcGfqXoZoJOsiD",15) == 554999342) strcat(s, "e");
if (crc32("mQsmLYBPnILk",12) == 1742796326) strcat(s, "K");
if (crc32("mjOnvAxEiOi",11) == 3625305461) strcat(s, "l");
if (crc32("ejzvmpjHMnsBduQ",15) == 408491336) strcat(s, "r");
if (crc32("cPNUCwcIT",9) == 1881236237) strcat(s, "f");
if (crc32("LntSYz",6) == 3193207685) strcat(s, "i");
if (crc32("DOtJgCe",7) == 3874178993) strcat(s, "j");
if (crc32("SVzMpyIgnYNfDYz",15) == 1078213175) strcat(s, "d");
if (crc32("IyoLUrRWCSFvA",13) == 2524262917) strcat(s, "q");
if (crc32("dMTmHXgCQzTU",12) == 1601134248) strcat(s, "o");
if (crc32("epIpiAnF",8) == 2473846532) strcat(s, "l");
if (crc32("ahYLSMo",7) == 1189839439) strcat(s, "a");
if (crc32("lcBnVdtmiR",10) == 3739448872) strcat(s, "t");
if (crc32("JXZNGxt",7) == 1997095891) strcat(s, "U");
if (crc32("kXWlvsoDl",9) == 3141192398) strcat(s, "r");
if (crc32("EXgaLKcKsxtx",12) == 3335725547) strcat(s, "y");
    return s;
}

char *reuseabness_nouns() {
    char *s = calloc(12);
    if (crc32("tqkrdBPJCPANqqJ",15) == 801038915) strcat(s, "r");
if (crc32("mfVMKsVH",8) == 2005514336) strcat(s, "K");
if (crc32("sOexiRZQvIw",11) == 3949694123) strcat(s, "e");
if (crc32("FjLznAdlOZs",11) == 535069965) strcat(s, "c");
if (crc32("CndGnpbIgNbq",12) == 3382642081) strcat(s, "u");
if (crc32("TxRarKhguxLIW",13) == 618517802) strcat(s, "N");
if (crc32("zvIzDvuad",9) == 364220202) strcat(s, "s");
if (crc32("JZcwgJVCn",9) == 66980007) strcat(s, "e");
if (crc32("mGXUWOGgHqNT",12) == 2851124462) strcat(s, "o");
if (crc32("pjFVkJxD",8) == 2409332779) strcat(s, "a");
if (crc32("sCYynL",6) == 1242997808) strcat(s, "b");
if (crc32("sSdGHwtSoFgO",12) == 2341367819) strcat(s, "z");
if (crc32("stmLMPkMftRnTq",14) == 4001048582) strcat(s, "n");
if (crc32("XSfdJVtmbyq",11) == 3978285822) strcat(s, "e");
if (crc32("kGRVbkg",7) == 462913017) strcat(s, "w");
if (crc32("vdYYML",6) == 4024366870) strcat(s, "s");
if (crc32("mSwxmUwyyFkt",12) == 1023469384) strcat(s, "m");
if (crc32("pDmeRfajv",9) == 987392743) strcat(s, "s");
    return s;
}

char *greatgrandmother_nouns() {
    char *s = calloc(17);
    if (crc32("DYGsPuQQp",9) == 499817314) strcat(s, "z");
if (crc32("HMMzICThkXAhCiX",15) == 3040386411) strcat(s, "g");
if (crc32("zptjjbmbq",9) == 2732702336) strcat(s, "e");
if (crc32("aSHIxBYUR",9) == 4033913496) strcat(s, "r");
if (crc32("GqlPNDoNPflXE",13) == 2458641913) strcat(s, "t");
if (crc32("TTJSOWDWFxgEN",13) == 1211332338) strcat(s, "e");
if (crc32("iyWYv",5) == 4292544278) strcat(s, "a");
if (crc32("MwOPG",5) == 3110907994) strcat(s, "t");
if (crc32("NnrpEfEA",8) == 1371644368) strcat(s, "g");
if (crc32("sGDQqidYgfvoj",13) == 718486061) strcat(s, "r");
if (crc32("EfyuGHjdwXukRWa",15) == 55806084) strcat(s, "N");
if (crc32("tltkNoraTuwdGI",14) == 2377571168) strcat(s, "a");
if (crc32("mufhxfUYNjlIETd",15) == 1808429700) strcat(s, "s");
if (crc32("oyTdCdOJ",8) == 3374517377) strcat(s, "n");
if (crc32("ExSOFlLxrbsbo",13) == 1375923520) strcat(s, "w");
if (crc32("jATsG",5) == 2971131843) strcat(s, "d");
if (crc32("ymcisqT",7) == 3303008325) strcat(s, "m");
if (crc32("opwmncgDXKTyGfO",15) == 4190622678) strcat(s, "o");
if (crc32("EdCUJoAgURDUw",13) == 3458634766) strcat(s, "t");
if (crc32("txZBqe",6) == 880881266) strcat(s, "h");
if (crc32("vOJWCVT",7) == 1517857155) strcat(s, "e");
if (crc32("bBXWimkfZCmIx",13) == 3423540445) strcat(s, "t");
if (crc32("VDQsqhqWyUR",11) == 242393293) strcat(s, "r");
    return s;
}

char *FRSL_nouns() {
    char *s = calloc(5);
    if (crc32("zTtaJoQQ",8) == 3005724556) strcat(s, "F");
if (crc32("uxekQaTBBZSarj",14) == 4201861459) strcat(s, "I");
if (crc32("bzmtsTPXGI",10) == 1499722266) strcat(s, "R");
if (crc32("nQyDYfkzVctvy",13) == 326566975) strcat(s, "y");
if (crc32("swTlirGATXN",11) == 2837749035) strcat(s, "S");
if (crc32("EzcYyyPBsozgb",13) == 1467020853) strcat(s, "x");
if (crc32("MjfUVfFNqmagqgM",15) == 3814402767) strcat(s, "L");
    return s;
}

char *drugget_nouns() {
    char *s = calloc(8);
    if (crc32("njnGPqHWkzBs",12) == 3037974222) strcat(s, "d");
if (crc32("gRfDaEn",7) == 2409963164) strcat(s, "U");
if (crc32("MjXfSbhlJUwzPz",14) == 87679502) strcat(s, "r");
if (crc32("zBGnZFAFvq",10) == 3312885804) strcat(s, "e");
if (crc32("pwfZdzHUjWJ",11) == 218951036) strcat(s, "u");
if (crc32("eUrAGLSSw",9) == 1490299921) strcat(s, "g");
if (crc32("XsfCxWVm",8) == 2052154341) strcat(s, "Z");
if (crc32("IqsgSpEKE",9) == 1263910101) strcat(s, "g");
if (crc32("BbIuvf",6) == 3331320117) strcat(s, "n");
if (crc32("kADpPzDqPZx",11) == 3280901013) strcat(s, "e");
if (crc32("iIzsToYyF",9) == 1229764582) strcat(s, "t");
    return s;
}

char *USSCt_nouns() {
    char *s = calloc(6);
    if (crc32("zobNAT",6) == 1851136883) strcat(s, "U");
if (crc32("dpxhsboRy",9) == 1243703529) strcat(s, "P");
if (crc32("ChAFsMYvea",10) == 1522732072) strcat(s, "S");
if (crc32("jUDghypVA",9) == 2441723040) strcat(s, "S");
if (crc32("JafrIgolIQfYM",13) == 2223810616) strcat(s, "N");
if (crc32("jHksNMLJ",8) == 1189127320) strcat(s, "C");
if (crc32("kwsqNMyzwqK",11) == 1947544517) strcat(s, "t");
    return s;
}

char *chlorobromomethane_nouns() {
    char *s = calloc(19);
    if (crc32("KZIdekOdLLgH",12) == 1175825336) strcat(s, "W");
if (crc32("XpjwXNbvCra",11) == 3989173540) strcat(s, "c");
if (crc32("aWQBqqdXqsEq",12) == 790846180) strcat(s, "x");
if (crc32("NGXzxUNix",9) == 3424015116) strcat(s, "h");
if (crc32("xqzRoFKECK",10) == 3986771513) strcat(s, "c");
if (crc32("ZboSdPWPCM",10) == 1727409199) strcat(s, "l");
if (crc32("kuRLXleAkQwVr",13) == 867172557) strcat(s, "o");
if (crc32("nrlIGnsXysuS",12) == 951873570) strcat(s, "r");
if (crc32("BFCgC",5) == 4258253108) strcat(s, "Q");
if (crc32("ZEOXWYEI",8) == 4129502810) strcat(s, "o");
if (crc32("BlgBjOMhdnIA",12) == 27082910) strcat(s, "b");
if (crc32("CTAsHnvf",8) == 3034677139) strcat(s, "W");
if (crc32("ZItZumgBhh",10) == 2447201127) strcat(s, "r");
if (crc32("rWeCOFFkaC",10) == 2862525675) strcat(s, "o");
if (crc32("AJDNMzUFZwUwI",13) == 1748696891) strcat(s, "m");
if (crc32("cZisNW",6) == 3329082209) strcat(s, "o");
if (crc32("tfXunnyFdXO",11) == 1218422202) strcat(s, "P");
if (crc32("pgkpxK",6) == 801928331) strcat(s, "m");
if (crc32("TSOHfNsaly",10) == 1989382545) strcat(s, "e");
if (crc32("KibKS",5) == 93564674) strcat(s, "t");
if (crc32("YusCHRJqGG",10) == 474028444) strcat(s, "h");
if (crc32("dezfqgagfFMvQO",14) == 3575891615) strcat(s, "H");
if (crc32("WqWprof",7) == 1269656159) strcat(s, "a");
if (crc32("FnBOn",5) == 426270869) strcat(s, "F");
if (crc32("ZncAvYjka",9) == 2200246893) strcat(s, "n");
if (crc32("BhptAfZ",7) == 2123461153) strcat(s, "e");
    return s;
}

char *stech_nouns() {
    char *s = calloc(6);
    if (crc32("urWSE",5) == 2107206275) strcat(s, "c");
if (crc32("lzaKefIjacYf",12) == 2784574242) strcat(s, "s");
if (crc32("yrpDvMMpEIKR",12) == 1372687406) strcat(s, "t");
if (crc32("xNOypES",7) == 2427509246) strcat(s, "e");
if (crc32("idXrEtoUeoWh",12) == 3546166515) strcat(s, "c");
if (crc32("spKzNaleXQWe",12) == 1092874136) strcat(s, "h");
    return s;
}

char *swanherd_nouns() {
    char *s = calloc(9);
    if (crc32("cxzlFqoNHpQA",12) == 2589919925) strcat(s, "k");
if (crc32("iRkdMiFFJzNM",12) == 2938653655) strcat(s, "s");
if (crc32("ZpLSrjq",7) == 1232292773) strcat(s, "l");
if (crc32("PTciOQNOnoc",11) == 742300970) strcat(s, "w");
if (crc32("xyDYdWYiqa",10) == 2773110670) strcat(s, "a");
if (crc32("VxnqkL",6) == 3911447933) strcat(s, "T");
if (crc32("KpQBYsY",7) == 2447659947) strcat(s, "n");
if (crc32("jUWiqi",6) == 3765125867) strcat(s, "z");
if (crc32("iMuMwxZOBVo",11) == 510584154) strcat(s, "h");
if (crc32("xcMTTzoI",8) == 787515554) strcat(s, "e");
if (crc32("QzYZYtyKMaaD",12) == 1538833840) strcat(s, "J");
if (crc32("SYRffkgVvAbee",13) == 3955789692) strcat(s, "r");
if (crc32("MHdxdUUo",8) == 3166348638) strcat(s, "r");
if (crc32("PCydVe",6) == 718235682) strcat(s, "d");
    return s;
}

char *megalith_nouns() {
    char *s = calloc(9);
    if (crc32("sDUBmKbfgQzEgmm",15) == 1739704926) strcat(s, "M");
if (crc32("pCYDpNustGw",11) == 539837101) strcat(s, "m");
if (crc32("tBvxsjTnBusj",12) == 348640947) strcat(s, "e");
if (crc32("bbQlCL",6) == 2804392111) strcat(s, "j");
if (crc32("ayZLEcavDEAp",12) == 1854189748) strcat(s, "g");
if (crc32("dBuVyvK",7) == 1058776118) strcat(s, "C");
if (crc32("YvIzLJURRHJ",11) == 2710354270) strcat(s, "a");
if (crc32("QRMsEqrxywhJqon",15) == 56636783) strcat(s, "c");
if (crc32("EewFXy",6) == 1723971026) strcat(s, "l");
if (crc32("ylUduF",6) == 508671458) strcat(s, "W");
if (crc32("SlsLpbRwNrcNkBe",15) == 1104876216) strcat(s, "i");
if (crc32("ucwdErsjKfKZ",12) == 3352483193) strcat(s, "t");
if (crc32("sYOdwfChDvvjM",13) == 4046520719) strcat(s, "I");
if (crc32("TcBndI",6) == 2240464852) strcat(s, "h");
    return s;
}

char *rego_nouns() {
    char *s = calloc(5);
    if (crc32("dyzzpFL",7) == 4108377727) strcat(s, "r");
if (crc32("kulAAOKrJ",9) == 3814458204) strcat(s, "F");
if (crc32("RJzECIqDiigx",12) == 2228914575) strcat(s, "e");
if (crc32("eZjzkzieNl",10) == 3501963076) strcat(s, "s");
if (crc32("qqeXrBTbuHz",11) == 1644574099) strcat(s, "g");
if (crc32("zYyauG",6) == 3416929599) strcat(s, "o");
    return s;
}

char *Sansone_nouns() {
    char *s = calloc(8);
    if (crc32("rtUCXFhQ",8) == 397239356) strcat(s, "n");
if (crc32("UbFqBbbOS",9) == 3597357341) strcat(s, "S");
if (crc32("XOtoW",5) == 3637516298) strcat(s, "A");
if (crc32("WHuHPxS",7) == 2394898987) strcat(s, "a");
if (crc32("mGRVx",5) == 3386619675) strcat(s, "p");
if (crc32("AhTpNabgcQuPMr",14) == 3481593443) strcat(s, "n");
if (crc32("JvudcsjBqMT",11) == 834407966) strcat(s, "c");
if (crc32("AlWyIoab",8) == 1401372738) strcat(s, "s");
if (crc32("zQnuKJWke",9) == 2479279096) strcat(s, "o");
if (crc32("AoEMONsLf",9) == 2350645354) strcat(s, "n");
if (crc32("IIMdXjkvf",9) == 3516763248) strcat(s, "e");
    return s;
}

char *Lie_nouns() {
    char *s = calloc(4);
    if (crc32("oeoREvGgmEbWnB",14) == 1263589752) strcat(s, "L");
if (crc32("JTVLpxtnJhLb",12) == 1831967455) strcat(s, "i");
if (crc32("wanarBEykKTyO",13) == 430729199) strcat(s, "e");
    return s;
}

char *nondesulfurization_nouns() {
    char *s = calloc(19);
    if (crc32("padzFROUQqYjnt",14) == 1985863790) strcat(s, "r");
if (crc32("PRaqDWvUXqzKD",13) == 2981329805) strcat(s, "n");
if (crc32("RtKkca",6) == 2149899271) strcat(s, "o");
if (crc32("AKtTWVz",7) == 2829024549) strcat(s, "U");
if (crc32("fuuRfeaCyYFZd",13) == 3888952) strcat(s, "n");
if (crc32("UeQxf",5) == 2920260618) strcat(s, "w");
if (crc32("iGtCtqRllZn",11) == 1993107414) strcat(s, "d");
if (crc32("KVceUuIx",8) == 3861214523) strcat(s, "n");
if (crc32("trYEfojKgIWquVh",15) == 2438898768) strcat(s, "e");
if (crc32("qKnHLlKmEGIdCj",14) == 2609371917) strcat(s, "s");
if (crc32("DrmPvMFAufE",11) == 3747000653) strcat(s, "G");
if (crc32("sIcdCpSFiVJIbE",14) == 4177998493) strcat(s, "u");
if (crc32("jmboCYO",7) == 2041682604) strcat(s, "l");
if (crc32("inujDsZLEZ",10) == 2154391179) strcat(s, "z");
if (crc32("jrjYBmWRjMOdQM",14) == 1724775222) strcat(s, "f");
if (crc32("dJrqHoDSqAWEfaj",15) == 185126034) strcat(s, "q");
if (crc32("ahSWRGxRmQPWud",14) == 1231352170) strcat(s, "u");
if (crc32("CBanUV",6) == 2088286530) strcat(s, "O");
if (crc32("FfKPVCYSUmIJLC",14) == 3778148841) strcat(s, "r");
if (crc32("QTZTToaA",8) == 829135879) strcat(s, "i");
if (crc32("puYrbkt",7) == 1156337293) strcat(s, "z");
if (crc32("PisFAgNqLiFMG",13) == 2193167121) strcat(s, "a");
if (crc32("BSUTuXHxQto",11) == 313454440) strcat(s, "l");
if (crc32("VwumCHgeqYgzT",13) == 3490966879) strcat(s, "t");
if (crc32("ZSBAjc",6) == 1753807783) strcat(s, "i");
if (crc32("hkiHJhZjD",9) == 307181582) strcat(s, "o");
if (crc32("mcmvwPjQEeB",11) == 129055188) strcat(s, "m");
if (crc32("nSwNAPzbTQXncvg",15) == 1195396561) strcat(s, "n");
    return s;
}

char *leotard_nouns() {
    char *s = calloc(8);
    if (crc32("ocMNHHPTeSnBho",14) == 132564828) strcat(s, "l");
if (crc32("rStZk",5) == 1430530428) strcat(s, "e");
if (crc32("nIjWlHjSdbVKs",13) == 2154665704) strcat(s, "N");
if (crc32("DzxdhyqwY",9) == 2357907297) strcat(s, "o");
if (crc32("icxfTR",6) == 4190660037) strcat(s, "t");
if (crc32("PtXtXfOiIIuG",12) == 1641637753) strcat(s, "N");
if (crc32("SHcrJZwntRp",11) == 3661124926) strcat(s, "a");
if (crc32("ASKPFAXnyAoIsTZ",15) == 2579274316) strcat(s, "r");
if (crc32("JiixJ",5) == 2762384547) strcat(s, "d");
    return s;
}

char *toothpaste_nouns() {
    char *s = calloc(11);
    if (crc32("STABonhsJCBs",12) == 2095756140) strcat(s, "t");
if (crc32("yZKJdT",6) == 3015952036) strcat(s, "o");
if (crc32("kjQXBw",6) == 490991361) strcat(s, "o");
if (crc32("XRVaZgVZDVzV",12) == 2627933171) strcat(s, "W");
if (crc32("FqdilfuliOtKL",13) == 1710482144) strcat(s, "t");
if (crc32("vpKUNZYNnVTv",12) == 1570172093) strcat(s, "A");
if (crc32("KGIOOAvnSUC",11) == 4257953367) strcat(s, "h");
if (crc32("fNrruRI",7) == 3620436572) strcat(s, "p");
if (crc32("GgYtuIBuFuQKibQ",15) == 110612043) strcat(s, "a");
if (crc32("QsZtcSCE",8) == 1254804158) strcat(s, "A");
if (crc32("qEKCnoSHiV",10) == 3616188266) strcat(s, "s");
if (crc32("zOnhFDh",7) == 592731430) strcat(s, "S");
if (crc32("IyujRE",6) == 4207799336) strcat(s, "t");
if (crc32("TtJZZXH",7) == 133711803) strcat(s, "e");
    return s;
}

char *gardemanger_nouns() {
    char *s = calloc(12);
    if (crc32("oqBuqQCpFASmU",13) == 1387623228) strcat(s, "K");
if (crc32("lyEMztobT",9) == 1707962553) strcat(s, "g");
if (crc32("rGgecUNmKi",10) == 3402734845) strcat(s, "a");
if (crc32("UbmTyfGX",8) == 2143594241) strcat(s, "V");
if (crc32("yeAYKoaN",8) == 480782259) strcat(s, "r");
if (crc32("GZKiiBpOOxKGTvZ",15) == 1742029181) strcat(s, "W");
if (crc32("iFkgNXI",7) == 355874941) strcat(s, "d");
if (crc32("etEfTjjU",8) == 2816412167) strcat(s, "b");
if (crc32("FMoXaus",7) == 3472575868) strcat(s, "e");
if (crc32("xoeIdRiHquEU",12) == 1868906831) strcat(s, "m");
if (crc32("gbGOXZXMrieb",12) == 775222232) strcat(s, "a");
if (crc32("zFBbUic",7) == 1335762869) strcat(s, "E");
if (crc32("OUUICdDlhSDZDEu",15) == 562649492) strcat(s, "n");
if (crc32("xVgHBETr",8) == 7402102) strcat(s, "g");
if (crc32("ANUaBX",6) == 2151429252) strcat(s, "e");
if (crc32("gOjViEh",7) == 1269638626) strcat(s, "X");
if (crc32("cYLkta",6) == 3993460629) strcat(s, "r");
    return s;
}

char *corrosion_nouns() {
    char *s = calloc(10);
    if (crc32("AVYjsUxJgZtPss",14) == 789792829) strcat(s, "c");
if (crc32("qrQMoFCIQlNb",12) == 514194386) strcat(s, "M");
if (crc32("ePRYI",5) == 1471997301) strcat(s, "o");
if (crc32("cMKStaV",7) == 3910068870) strcat(s, "V");
if (crc32("bmmgHtWwaAGQ",12) == 3512167083) strcat(s, "r");
if (crc32("EtITaY",6) == 33381918) strcat(s, "r");
if (crc32("PnHKHhtxrLQExdB",15) == 4155268859) strcat(s, "m");
if (crc32("uNklbIOCcmls",12) == 462063274) strcat(s, "o");
if (crc32("czQzVfAijzHdkVn",15) == 3083325914) strcat(s, "s");
if (crc32("uzSnmfAo",8) == 3788741059) strcat(s, "a");
if (crc32("NRzNDpZpY",9) == 16759084) strcat(s, "i");
if (crc32("PiWKOeL",7) == 1262681112) strcat(s, "o");
if (crc32("veHrtjRssgLrtJ",14) == 1104038245) strcat(s, "n");
    return s;
}

char *Vitek_nouns() {
    char *s = calloc(6);
    if (crc32("wnUKWOUFEkv",11) == 554272671) strcat(s, "F");
if (crc32("vWgbbPMWnYMnvt",14) == 317735250) strcat(s, "V");
if (crc32("Namet",5) == 2681645699) strcat(s, "B");
if (crc32("VnYnRwUanSi",11) == 428340119) strcat(s, "i");
if (crc32("XcowxZLTgaNyfYr",15) == 4183206045) strcat(s, "t");
if (crc32("FFXCs",5) == 3742965341) strcat(s, "e");
if (crc32("KLAGxfYeSOFWOQ",14) == 419456040) strcat(s, "k");
    return s;
}

char *pistareen_nouns() {
    char *s = calloc(10);
    if (crc32("ochYmXyjCW",10) == 1940081263) strcat(s, "W");
if (crc32("bQiCqmlJZ",9) == 1474950304) strcat(s, "p");
if (crc32("IeCaCoWDTEXCtN",14) == 1132541129) strcat(s, "i");
if (crc32("smRSXImKGdf",11) == 1780282932) strcat(s, "s");
if (crc32("qxViVMeHRCTIwF",14) == 1200967751) strcat(s, "P");
if (crc32("dyKEPbPzm",9) == 1850975883) strcat(s, "t");
if (crc32("HFDqzHKebi",10) == 2268166438) strcat(s, "a");
if (crc32("dxUdCkaEzFHJH",13) == 4255102581) strcat(s, "d");
if (crc32("tZzEYMpKNueJUsn",15) == 1149787568) strcat(s, "r");
if (crc32("DSiRt",5) == 705352580) strcat(s, "e");
if (crc32("WnDLGMzAWVI",11) == 550659713) strcat(s, "e");
if (crc32("jLGTrawuyomEJJ",14) == 2921673132) strcat(s, "N");
if (crc32("oYEgHujOJlykcQu",15) == 3216896003) strcat(s, "n");
    return s;
}

char *VanHook_nouns() {
    char *s = calloc(8);
    if (crc32("jVLPpFdEj",9) == 456279547) strcat(s, "V");
if (crc32("fnrunLeZ",8) == 4067366836) strcat(s, "j");
if (crc32("MNoLLyVxoUeRiu",14) == 2358163468) strcat(s, "a");
if (crc32("VOSEvOQckX",10) == 1181788932) strcat(s, "n");
if (crc32("kQxJguTdinqlH",13) == 3204683984) strcat(s, "H");
if (crc32("RsZSSwisqk",10) == 2091582806) strcat(s, "o");
if (crc32("lTFFlc",6) == 1379295037) strcat(s, "Q");
if (crc32("rOXcNQZNdgBGt",13) == 60881288) strcat(s, "o");
if (crc32("ydmiByDZdWJvhU",14) == 2921656433) strcat(s, "t");
if (crc32("xljMoC",6) == 723049205) strcat(s, "k");
    return s;
}

char *Cooper_nouns() {
    char *s = calloc(7);
    if (crc32("ZfdgjlPwVOm",11) == 3502916048) strcat(s, "d");
if (crc32("olrLwJgMLN",10) == 59772157) strcat(s, "C");
if (crc32("qZeHbZFGnSEr",12) == 2886739937) strcat(s, "o");
if (crc32("fYtJEBMqYwS",11) == 1439128593) strcat(s, "o");
if (crc32("JDYVUynxTegk",12) == 2426474747) strcat(s, "a");
if (crc32("AOqrkC",6) == 1112501875) strcat(s, "p");
if (crc32("AQXjPeZSAveDzI",14) == 990624702) strcat(s, "e");
if (crc32("xJrfgNaVa",9) == 2146240603) strcat(s, "r");
    return s;
}

char *bottomlessness_nouns() {
    char *s = calloc(15);
    if (crc32("UuSAfdUUlvJEL",13) == 2620820528) strcat(s, "a");
if (crc32("moqpvyOAYbqki",13) == 3490779144) strcat(s, "b");
if (crc32("YFleEunN",8) == 2070158323) strcat(s, "Q");
if (crc32("PrsZXD",6) == 623701050) strcat(s, "o");
if (crc32("FfOBTwCu",8) == 3189089341) strcat(s, "p");
if (crc32("oVjZFgiLLLd",11) == 156474845) strcat(s, "t");
if (crc32("EjPYqf",6) == 2063207974) strcat(s, "W");
if (crc32("MWkkoGsGRRMpuJ",14) == 3120759379) strcat(s, "t");
if (crc32("hXoWivYFKuIN",12) == 1032088775) strcat(s, "N");
if (crc32("dkMvnaPpUu",10) == 912497327) strcat(s, "o");
if (crc32("qmpfjnVxxDZZrB",14) == 2599476819) strcat(s, "o");
if (crc32("FCuXmcEntBDJzwj",15) == 4164984532) strcat(s, "m");
if (crc32("zLajnNYFLXKq",12) == 873940788) strcat(s, "l");
if (crc32("uyoCMHiiyKnxp",13) == 276112992) strcat(s, "I");
if (crc32("YIVgsUgtKzD",11) == 1201624777) strcat(s, "e");
if (crc32("UnKjLGTqPTwv",12) == 2804616221) strcat(s, "s");
if (crc32("xIAWGDp",7) == 3895475212) strcat(s, "s");
if (crc32("dRyMhi",6) == 2538322322) strcat(s, "n");
if (crc32("uEXeaNIS",8) == 216640586) strcat(s, "e");
if (crc32("VuAxEwYtOiE",11) == 1169500140) strcat(s, "s");
if (crc32("GklXy",5) == 1870147973) strcat(s, "O");
if (crc32("sMlNEaOlEGPVNIU",15) == 4133133904) strcat(s, "s");
    return s;
}

char *swale_nouns() {
    char *s = calloc(6);
    if (crc32("qqmjhjCIezhwX",13) == 1728241339) strcat(s, "s");
if (crc32("GeuTEAsZrtC",11) == 3386382399) strcat(s, "W");
if (crc32("LSnPkRD",7) == 3295470138) strcat(s, "w");
if (crc32("UkoRzkSzVicqe",13) == 776448637) strcat(s, "o");
if (crc32("FvORDnirQrYjxjn",15) == 501361060) strcat(s, "a");
if (crc32("mbLrtasLIsv",11) == 2231813454) strcat(s, "l");
if (crc32("MpqmhWU",7) == 374592727) strcat(s, "e");
    return s;
}

char *Lucian_nouns() {
    char *s = calloc(7);
    if (crc32("VGUligiG",8) == 544672806) strcat(s, "L");
if (crc32("IULlUd",6) == 512330744) strcat(s, "h");
if (crc32("HEAGq",5) == 3943248645) strcat(s, "u");
if (crc32("XRKqExdlkQ",10) == 3537794001) strcat(s, "c");
if (crc32("QUgieG",6) == 2315751004) strcat(s, "s");
if (crc32("wBjBznnfpGCxFGm",15) == 3840592100) strcat(s, "i");
if (crc32("YimGmEdxcHHx",12) == 2650518373) strcat(s, "Z");
if (crc32("CoVWSUlHVIEfm",13) == 1082679162) strcat(s, "a");
if (crc32("MumazQO",7) == 499296701) strcat(s, "n");
    return s;
}

char *prussianisation_nouns() {
    char *s = calloc(16);
    if (crc32("bTSAkdXm",8) == 761751532) strcat(s, "p");
if (crc32("lwxwsWBuIYbx",12) == 3679732751) strcat(s, "i");
if (crc32("WGXFZcROYDUACA",14) == 3899128045) strcat(s, "r");
if (crc32("PBwzvynvqLLDi",13) == 369879710) strcat(s, "u");
if (crc32("KgYgx",5) == 1493123246) strcat(s, "s");
if (crc32("abPYBDwKryVVWlR",15) == 999042447) strcat(s, "s");
if (crc32("RgTAveUx",8) == 1943708468) strcat(s, "A");
if (crc32("wTmmTLOzxxFv",12) == 2664613494) strcat(s, "i");
if (crc32("lPEYU",5) == 1947656291) strcat(s, "J");
if (crc32("ZivdOlVs",8) == 2842994299) strcat(s, "a");
if (crc32("NzzLlsomMXSt",12) == 1747744991) strcat(s, "n");
if (crc32("RAFSXOys",8) == 1952515836) strcat(s, "i");
if (crc32("LIOtnRihj",9) == 3402555519) strcat(s, "s");
if (crc32("XmWarphmGFH",11) == 1612105934) strcat(s, "A");
if (crc32("FegEW",5) == 686882679) strcat(s, "a");
if (crc32("MbMAtK",6) == 2310653543) strcat(s, "X");
if (crc32("qCLQBndorSFeY",13) == 850475151) strcat(s, "t");
if (crc32("gOSTtOqF",8) == 2093363501) strcat(s, "i");
if (crc32("eZouFQiL",8) == 2856880972) strcat(s, "o");
if (crc32("JrlVGbqhKQV",11) == 655696915) strcat(s, "n");
    return s;
}

char *Bazaine_nouns() {
    char *s = calloc(8);
    if (crc32("cdQalQzHlDcDK",13) == 4026170885) strcat(s, "B");
if (crc32("MfxgqgySptFC",12) == 3164641221) strcat(s, "a");
if (crc32("cqaaMiv",7) == 1787649273) strcat(s, "J");
if (crc32("oBYSUWGwyQeF",12) == 4287543631) strcat(s, "z");
if (crc32("qRbgZQL",7) == 1859619906) strcat(s, "a");
if (crc32("IJOZL",5) == 596641764) strcat(s, "i");
if (crc32("klMvGYpMd",9) == 1073338454) strcat(s, "k");
if (crc32("sBxWP",5) == 2369674811) strcat(s, "n");
if (crc32("cpbgFj",6) == 2162850222) strcat(s, "j");
if (crc32("pOTZSUjkWoYt",12) == 2300966659) strcat(s, "e");
    return s;
}

char *margrave_nouns() {
    char *s = calloc(9);
    if (crc32("UGkIPcDhzq",10) == 1293863855) strcat(s, "N");
if (crc32("XydDemciuVaZuk",14) == 3921692873) strcat(s, "m");
if (crc32("ldKczKkC",8) == 607935201) strcat(s, "C");
if (crc32("pHODBQfWwDCP",12) == 1411094803) strcat(s, "a");
if (crc32("TewCiNOAMM",10) == 2088693222) strcat(s, "i");
if (crc32("NGHjPnHEg",9) == 3459370197) strcat(s, "r");
if (crc32("xcUSqgQAan",10) == 1399386691) strcat(s, "g");
if (crc32("uOYECKBfDf",10) == 3156276856) strcat(s, "N");
if (crc32("CfhzBlxbnjvE",12) == 3786612722) strcat(s, "r");
if (crc32("SWfwjwMjc",9) == 452300273) strcat(s, "a");
if (crc32("fyrsuVyZuLMnfL",14) == 3018859685) strcat(s, "v");
if (crc32("FYilWDIYJqobg",13) == 1047952997) strcat(s, "m");
if (crc32("BZLoxNpIowjiFtC",15) == 291771944) strcat(s, "e");
    return s;
}

char *samadhi_nouns() {
    char *s = calloc(8);
    if (crc32("uGpvmF",6) == 1951530169) strcat(s, "s");
if (crc32("JenwQrMnVHPU",12) == 2611800316) strcat(s, "X");
if (crc32("WxsyHe",6) == 1312374421) strcat(s, "a");
if (crc32("KrJRDFDhhJzM",12) == 2700297011) strcat(s, "m");
if (crc32("JECiav",6) == 2081852904) strcat(s, "S");
if (crc32("hEgPlSwmd",9) == 1813542265) strcat(s, "a");
if (crc32("MRSKFAlaeoH",11) == 1578604258) strcat(s, "s");
if (crc32("vGiPCakZAmLvne",14) == 413332614) strcat(s, "d");
if (crc32("ZvGkWlneFVKw",12) == 2954994589) strcat(s, "L");
if (crc32("zzHCZUWTJbVB",12) == 1636685880) strcat(s, "h");
if (crc32("IrbiuZX",7) == 3455295082) strcat(s, "B");
if (crc32("zxeaUGHDxDsjYr",14) == 620200012) strcat(s, "i");
    return s;
}

char *aerometeorograph_nouns() {
    char *s = calloc(17);
    if (crc32("vfyzDCfa",8) == 395115482) strcat(s, "a");
if (crc32("jVIGbRyGQ",9) == 1556839255) strcat(s, "G");
if (crc32("GPGndRfbw",9) == 1657331959) strcat(s, "e");
if (crc32("hCdSeZJbDK",10) == 1075993413) strcat(s, "y");
if (crc32("EASsHw",6) == 4060748882) strcat(s, "r");
if (crc32("CHTfv",5) == 438804002) strcat(s, "E");
if (crc32("DaOeQtGwXtaSxgd",15) == 832342558) strcat(s, "o");
if (crc32("tinBlqTInlPSiTS",15) == 633073546) strcat(s, "m");
if (crc32("aXTTyfoEAYuz",12) == 2102883882) strcat(s, "m");
if (crc32("LysEgnUufhq",11) == 56343756) strcat(s, "e");
if (crc32("mHFOA",5) == 3113959561) strcat(s, "y");
if (crc32("euNqxCjbNUKfDz",14) == 642315506) strcat(s, "t");
if (crc32("UZWEyhtAkxNfF",13) == 2837395557) strcat(s, "c");
if (crc32("FjQvPTjurRIZEZ",14) == 21671420) strcat(s, "e");
if (crc32("rIsGj",5) == 2525422314) strcat(s, "r");
if (crc32("HmbVnzCCrYc",11) == 3451663217) strcat(s, "o");
if (crc32("OOLXpPoBzDdyx",13) == 1365605638) strcat(s, "U");
if (crc32("wEyxyjXnGGw",11) == 3761364533) strcat(s, "r");
if (crc32("evtahiRCykRhF",13) == 4158542076) strcat(s, "o");
if (crc32("zfxvzONxgo",10) == 2065144909) strcat(s, "g");
if (crc32("QyvIW",5) == 1370413705) strcat(s, "r");
if (crc32("CglLYCsipJTKcBn",15) == 1481107457) strcat(s, "I");
if (crc32("erjpdfoWXbu",11) == 608363569) strcat(s, "a");
if (crc32("oWmpqOp",7) == 1717690399) strcat(s, "D");
if (crc32("DDElaSxDEk",10) == 3903041700) strcat(s, "p");
if (crc32("kwwseYHbPbljuaM",15) == 1038674909) strcat(s, "W");
if (crc32("XhfLVsbLQhPUkms",15) == 3421658113) strcat(s, "h");
    return s;
}

char *diethylethanolamine_nouns() {
    char *s = calloc(20);
    if (crc32("cQgWWqCDaYZnLXW",15) == 3907184061) strcat(s, "X");
if (crc32("JUbSRylA",8) == 1688870221) strcat(s, "d");
if (crc32("LXXURwfDBRitf",13) == 3797530529) strcat(s, "i");
if (crc32("oIgYMaEijs",10) == 3682663037) strcat(s, "T");
if (crc32("dyambPuAk",9) == 2230670024) strcat(s, "e");
if (crc32("eMKrTCkuIYvpTRg",15) == 2626436673) strcat(s, "b");
if (crc32("Lppdsfy",7) == 347774617) strcat(s, "t");
if (crc32("YLOepCnAmKr",11) == 3056392640) strcat(s, "L");
if (crc32("qMFJGA",6) == 2890810380) strcat(s, "h");
if (crc32("SjcdUUTwx",9) == 1560591718) strcat(s, "V");
if (crc32("hQPQPf",6) == 3893303539) strcat(s, "y");
if (crc32("MKYdZOXn",8) == 3253553782) strcat(s, "L");
if (crc32("AxGRrxNY",8) == 3901095693) strcat(s, "l");
if (crc32("wBbthsfYhmbq",12) == 638236667) strcat(s, "e");
if (crc32("reKQEX",6) == 2829360655) strcat(s, "V");
if (crc32("NVeEpROHhwggfNq",15) == 169973710) strcat(s, "t");
if (crc32("bwdPTENdWtLm",12) == 917070332) strcat(s, "h");
if (crc32("fYNXbqUZoq",10) == 612656539) strcat(s, "q");
if (crc32("qZHWB",5) == 3045189363) strcat(s, "a");
if (crc32("QOtfdzlYA",9) == 4131962255) strcat(s, "n");
if (crc32("HRvIItUAgywfJL",14) == 2150060090) strcat(s, "m");
if (crc32("AhHvZujJH",9) == 2682440249) strcat(s, "o");
if (crc32("UMeKUswN",8) == 1901882364) strcat(s, "l");
if (crc32("hiUEtHKlgVlQk",13) == 2835694525) strcat(s, "K");
if (crc32("DCsJRbBtfLZusGa",15) == 937225794) strcat(s, "a");
if (crc32("vWqflTDjU",9) == 4080532406) strcat(s, "Y");
if (crc32("RUptNwuwvQFXDmB",15) == 3986957069) strcat(s, "m");
if (crc32("AgKPtuUlqLlqP",13) == 823038505) strcat(s, "i");
if (crc32("eqLGOEQZh",9) == 933807716) strcat(s, "j");
if (crc32("aHdzrWu",7) == 3111547717) strcat(s, "n");
if (crc32("BvGbkixjZA",10) == 2157834456) strcat(s, "M");
if (crc32("bbUZpvD",7) == 3424628791) strcat(s, "e");
    return s;
}

char *Jamalpur_nouns() {
    char *s = calloc(9);
    if (crc32("MyJxJpxd",8) == 2204969095) strcat(s, "d");
if (crc32("LLdzXywg",8) == 1586351548) strcat(s, "J");
if (crc32("BrzARBWDdk",10) == 2066797988) strcat(s, "u");
if (crc32("irdWVCj",7) == 3787610774) strcat(s, "a");
if (crc32("liqoPFbwaAe",11) == 2160658786) strcat(s, "m");
if (crc32("VezNxLLoB",9) == 425134351) strcat(s, "a");
if (crc32("oSDvz",5) == 539695867) strcat(s, "P");
if (crc32("YmbxAhzeEFTv",12) == 3326593794) strcat(s, "l");
if (crc32("aSqCcypA",8) == 15256279) strcat(s, "T");
if (crc32("fOtri",5) == 1773682591) strcat(s, "p");
if (crc32("IEAeAIRQi",9) == 880387110) strcat(s, "u");
if (crc32("ZNEzGKix",8) == 3726956552) strcat(s, "F");
if (crc32("xFvhl",5) == 144933836) strcat(s, "r");
    return s;
}

char *jejuneness_nouns() {
    char *s = calloc(11);
    if (crc32("FfkYCgeucjk",11) == 2132695026) strcat(s, "j");
if (crc32("urQAhhgiUuSc",12) == 1378554856) strcat(s, "h");
if (crc32("NZPQwe",6) == 233188374) strcat(s, "e");
if (crc32("STbwpDv",7) == 3164063822) strcat(s, "y");
if (crc32("jeHhafWLnexs",12) == 826610410) strcat(s, "j");
if (crc32("UmmUieLUhE",10) == 3093671599) strcat(s, "m");
if (crc32("oEKzwnHNFk",10) == 55464963) strcat(s, "u");
if (crc32("ybFOeJBUpSqRDCC",15) == 1354634675) strcat(s, "n");
if (crc32("PejZDvngrRrKoN",14) == 1976847595) strcat(s, "s");
if (crc32("wsTfYlT",7) == 753412889) strcat(s, "e");
if (crc32("uBZospEJ",8) == 73722719) strcat(s, "o");
if (crc32("nOgOtkhpkhh",11) == 3700283238) strcat(s, "n");
if (crc32("oduWyEXlWRk",11) == 297277597) strcat(s, "t");
if (crc32("ZCDTeR",6) == 3785903767) strcat(s, "e");
if (crc32("tJjCMVRp",8) == 251053739) strcat(s, "r");
if (crc32("KuNMWiTihfYb",12) == 570612288) strcat(s, "s");
if (crc32("qFaNDJf",7) == 138402461) strcat(s, "s");
    return s;
}

char *Oxenstierna_nouns() {
    char *s = calloc(12);
    if (crc32("NorKsGTaNBlc",12) == 1254663025) strcat(s, "O");
if (crc32("JEiPKhAJLvhbKKU",15) == 2832658169) strcat(s, "i");
if (crc32("kAiCJNrjCIXPh",13) == 3567093406) strcat(s, "x");
if (crc32("gLNLLexsnchJ",12) == 392303355) strcat(s, "e");
if (crc32("VoNBs",5) == 1668515816) strcat(s, "n");
if (crc32("wSsFRtTOBcPRpRk",15) == 3406316897) strcat(s, "s");
if (crc32("XuJZieQ",7) == 1708840846) strcat(s, "P");
if (crc32("UsYWGXJd",8) == 552845275) strcat(s, "t");
if (crc32("PdfJlQsOSG",10) == 2898889708) strcat(s, "i");
if (crc32("vlxkTL",6) == 699253663) strcat(s, "T");
if (crc32("xLcMnYGfVnPqC",13) == 548845102) strcat(s, "e");
if (crc32("YxmgWNsBo",9) == 4291221449) strcat(s, "Y");
if (crc32("BTdtALOEgn",10) == 1986670358) strcat(s, "r");
if (crc32("XrwEjiTEOLIf",12) == 15269237) strcat(s, "n");
if (crc32("bZcRizOM",8) == 3695056097) strcat(s, "a");
    return s;
}

char *Widgery_nouns() {
    char *s = calloc(8);
    if (crc32("WJYWfKwvoh",10) == 1709629891) strcat(s, "Y");
if (crc32("wWiJm",5) == 2778314268) strcat(s, "W");
if (crc32("UFjNWn",6) == 1264428399) strcat(s, "i");
if (crc32("HkmSzm",6) == 4249771088) strcat(s, "d");
if (crc32("sDicvUkLFvpNxKh",15) == 2919641626) strcat(s, "z");
if (crc32("RoyjDCqdBAXc",12) == 969734543) strcat(s, "g");
if (crc32("nptoJ",5) == 756418533) strcat(s, "O");
if (crc32("aKqJngPDvH",10) == 2784614848) strcat(s, "e");
if (crc32("kdujGGjGGF",10) == 3406959714) strcat(s, "U");
if (crc32("SgJcwPqFwSnR",12) == 3509427118) strcat(s, "r");
if (crc32("NBDvQx",6) == 2004621170) strcat(s, "g");
if (crc32("VurBN",5) == 701391094) strcat(s, "y");
    return s;
}

char *whale_nouns() {
    char *s = calloc(6);
    if (crc32("updnUxBjYONIgVp",15) == 3801500586) strcat(s, "w");
if (crc32("ThGuBhEJEjw",11) == 3165485481) strcat(s, "X");
if (crc32("NefqmQllWcl",11) == 4099026099) strcat(s, "h");
if (crc32("zUyCkOQ",7) == 935873139) strcat(s, "J");
if (crc32("VEBXLarefZC",11) == 3649752215) strcat(s, "a");
if (crc32("AlxPeubAbuQP",12) == 3070172227) strcat(s, "A");
if (crc32("agZWTUMAePtKm",13) == 2064336095) strcat(s, "l");
if (crc32("OsLIwNkNyxy",11) == 2818303424) strcat(s, "G");
if (crc32("dnuqZHmdPEiMf",13) == 3229239772) strcat(s, "e");
    return s;
}

char *Joule_nouns() {
    char *s = calloc(6);
    if (crc32("JQbVuJPCMODjhE",14) == 714278856) strcat(s, "J");
if (crc32("RcqtpF",6) == 518889444) strcat(s, "o");
if (crc32("bqtNuf",6) == 1485576274) strcat(s, "u");
if (crc32("yAFXpptNzCWU",12) == 540269153) strcat(s, "l");
if (crc32("XpvtPraJjCCuFt",14) == 4268955745) strcat(s, "C");
if (crc32("mWPwg",5) == 776881792) strcat(s, "e");
    return s;
}

char *ferromagnetism_nouns() {
    char *s = calloc(15);
    if (crc32("YKnWuJISMjD",11) == 3164032313) strcat(s, "A");
if (crc32("IieTneZTJbaIB",13) == 2129368422) strcat(s, "f");
if (crc32("ThHsqbO",7) == 2885168915) strcat(s, "L");
if (crc32("bwJRYJIr",8) == 1720422345) strcat(s, "e");
if (crc32("GIFBFYXJh",9) == 1456777770) strcat(s, "s");
if (crc32("SUGAUnkn",8) == 707871224) strcat(s, "r");
if (crc32("lABVby",6) == 2354650482) strcat(s, "r");
if (crc32("bAzMMABs",8) == 204463659) strcat(s, "o");
if (crc32("bAekfLCD",8) == 1852021731) strcat(s, "m");
if (crc32("AyLWVolN",8) == 4270703985) strcat(s, "a");
if (crc32("hOTBRCnRQWmf",12) == 3843267267) strcat(s, "T");
if (crc32("yRGrryVbpqITj",13) == 2705539055) strcat(s, "g");
if (crc32("JIKRurcB",8) == 1588043099) strcat(s, "A");
if (crc32("KqRVuUhEs",9) == 2072943231) strcat(s, "n");
if (crc32("ykjizi",6) == 3994282830) strcat(s, "n");
if (crc32("Hzzkoq",6) == 1691124535) strcat(s, "e");
if (crc32("iWomblcRa",9) == 269485185) strcat(s, "m");
if (crc32("mWMKGzIP",8) == 1093592426) strcat(s, "t");
if (crc32("OYWLDw",6) == 835632984) strcat(s, "D");
if (crc32("vraUjMoRp",9) == 3686321138) strcat(s, "i");
if (crc32("RfqNUhTAuejYL",13) == 419950547) strcat(s, "a");
if (crc32("KjfwNFpW",8) == 2124456252) strcat(s, "s");
if (crc32("hymLvam",7) == 2799797869) strcat(s, "m");
    return s;
}

char *expansionism_nouns() {
    char *s = calloc(13);
    if (crc32("OSxgzfAomzrjcqi",15) == 1924749187) strcat(s, "T");
if (crc32("jmCjDOTKGf",10) == 1838427136) strcat(s, "e");
if (crc32("wBvxWJjZEls",11) == 4099902280) strcat(s, "s");
if (crc32("nVghIDyXo",9) == 4270671517) strcat(s, "x");
if (crc32("egrWqoYKpXxfbZm",15) == 2334765671) strcat(s, "p");
if (crc32("lFvBTcdTGp",10) == 3253561840) strcat(s, "F");
if (crc32("ElqnQPo",7) == 3790235348) strcat(s, "a");
if (crc32("qHcEbEuVBL",10) == 2345042353) strcat(s, "n");
if (crc32("bbRdKMrqQ",9) == 1112408697) strcat(s, "G");
if (crc32("YTTlho",6) == 576431680) strcat(s, "s");
if (crc32("DatXiyJH",8) == 487589260) strcat(s, "C");
if (crc32("lBheGfVIkYFIz",13) == 3808587698) strcat(s, "i");
if (crc32("IrvpwmpwdTIiJ",13) == 1301731379) strcat(s, "r");
if (crc32("VrNyifdyFRb",11) == 1231008826) strcat(s, "o");
if (crc32("IgLFIcExdEdGohC",15) == 1294015376) strcat(s, "n");
if (crc32("uWFtVzj",7) == 299878823) strcat(s, "i");
if (crc32("phSzEA",6) == 531175266) strcat(s, "s");
if (crc32("EJJtLK",6) == 4115800303) strcat(s, "d");
if (crc32("LraQDtnXQkQ",11) == 1755999883) strcat(s, "m");
    return s;
}

char *caricature_nouns() {
    char *s = calloc(11);
    if (crc32("nlSqvEe",7) == 1967746928) strcat(s, "c");
if (crc32("tOjpyRwvGDtJk",13) == 2984257177) strcat(s, "a");
if (crc32("MSjJBTHDSpJUPGg",15) == 1892911654) strcat(s, "f");
if (crc32("TiOTFrbxdarLeGj",15) == 664717904) strcat(s, "r");
if (crc32("XPuSM",5) == 3465405876) strcat(s, "i");
if (crc32("VfMcQSvjWBgDEw",14) == 1054549806) strcat(s, "c");
if (crc32("gJpKwwCtSsz",11) == 1752929493) strcat(s, "Y");
if (crc32("rrGGAWUr",8) == 1001556071) strcat(s, "a");
if (crc32("VsAyKdLy",8) == 1184253759) strcat(s, "b");
if (crc32("jgIxJl",6) == 3251864161) strcat(s, "t");
if (crc32("LyJITv",6) == 3519654725) strcat(s, "u");
if (crc32("AOLbixZq",8) == 3533996965) strcat(s, "r");
if (crc32("FLWCjhuRmPVD",12) == 1844935149) strcat(s, "I");
if (crc32("ErseUoathWvlx",13) == 2208824559) strcat(s, "e");
    return s;
}

char *recipe_nouns() {
    char *s = calloc(7);
    if (crc32("HxeUKIsuOiCtwh",14) == 3778210274) strcat(s, "r");
if (crc32("JEMWGEM",7) == 613275741) strcat(s, "e");
if (crc32("MISEtT",6) == 3747300433) strcat(s, "c");
if (crc32("XUmVIplLWGJDTQX",15) == 3791083689) strcat(s, "t");
if (crc32("dqkFF",5) == 68012430) strcat(s, "i");
if (crc32("BhDiX",5) == 738716874) strcat(s, "v");
if (crc32("jDarxzKvQqNk",12) == 2313811469) strcat(s, "p");
if (crc32("BbCKZgECvRM",11) == 961859566) strcat(s, "f");
if (crc32("SLvIzZ",6) == 3383365163) strcat(s, "e");
    return s;
}

char *overcleanness_nouns() {
    char *s = calloc(14);
    if (crc32("waASX",5) == 3299425909) strcat(s, "V");
if (crc32("IjWDViUFLBdsVc",14) == 3663582626) strcat(s, "o");
if (crc32("YvntbxnOel",10) == 2287715353) strcat(s, "v");
if (crc32("CwsBDRO",7) == 1757069697) strcat(s, "e");
if (crc32("IWTxO",5) == 2938885037) strcat(s, "r");
if (crc32("kWTRMl",6) == 1599016963) strcat(s, "o");
if (crc32("MoMPvmUiJXXptZ",14) == 2979994497) strcat(s, "c");
if (crc32("vOnCEdVyAs",10) == 259758883) strcat(s, "l");
if (crc32("lWUUEOWbN",9) == 809722471) strcat(s, "I");
if (crc32("drhZBQUTGlmj",12) == 2524179958) strcat(s, "e");
if (crc32("IyITeNN",7) == 3166954) strcat(s, "u");
if (crc32("TzeFRIvmO",9) == 908842410) strcat(s, "a");
if (crc32("FCyBYmOGesWmU",13) == 4114207991) strcat(s, "n");
if (crc32("nONGD",5) == 587996993) strcat(s, "j");
if (crc32("iGNsKMEcPKxf",12) == 1557746377) strcat(s, "n");
if (crc32("FCSsmgIZdda",11) == 1039059909) strcat(s, "m");
if (crc32("GjucyqnlgAP",11) == 2542547173) strcat(s, "e");
if (crc32("KkxeHc",6) == 909338887) strcat(s, "s");
if (crc32("bIHxILUsNkHAiUv",15) == 542459964) strcat(s, "s");
    return s;
}

char *airship_nouns() {
    char *s = calloc(8);
    if (crc32("aWKxBaG",7) == 2450567969) strcat(s, "J");
if (crc32("SfOcyIN",7) == 1228119138) strcat(s, "a");
if (crc32("cdIWPmYokhDGQa",14) == 57325696) strcat(s, "i");
if (crc32("yeXOLvnb",8) == 3558806018) strcat(s, "j");
if (crc32("qzDNYzKQOvk",11) == 2458682459) strcat(s, "r");
if (crc32("gpSVwkYYDcVS",12) == 4220788784) strcat(s, "s");
if (crc32("KIvenmCmZl",10) == 1643281727) strcat(s, "O");
if (crc32("TOGiSVmYHaXBYg",14) == 907684189) strcat(s, "h");
if (crc32("kFzozzrceHeiBQV",15) == 3527676588) strcat(s, "O");
if (crc32("spOEwhw",7) == 257688699) strcat(s, "i");
if (crc32("wAFaUkEBuxDOe",13) == 2486711248) strcat(s, "Z");
if (crc32("TANYFzoHZaMdv",13) == 2480873340) strcat(s, "p");
    return s;
}

char *fighterbomber_nouns() {
    char *s = calloc(14);
    if (crc32("VaWaUSbphRsvoel",15) == 1046464516) strcat(s, "f");
if (crc32("dPrutDxHqBQQr",13) == 2997004076) strcat(s, "P");
if (crc32("bIYoVhfKcyhM",12) == 3641072137) strcat(s, "i");
if (crc32("WRNxDZEQxQD",11) == 542895158) strcat(s, "z");
if (crc32("HRabLFAlzNgdEr",14) == 1723706236) strcat(s, "g");
if (crc32("cqZPtkcvtc",10) == 1105711038) strcat(s, "h");
if (crc32("BsLiVplC",8) == 866067364) strcat(s, "z");
if (crc32("vUgzxG",6) == 1820527157) strcat(s, "t");
if (crc32("pdKnKtKV",8) == 2071881779) strcat(s, "e");
if (crc32("QsBbIyuDpLOQ",12) == 2476560916) strcat(s, "r");
if (crc32("YDLSPmAMsTVI",12) == 2954235189) strcat(s, "F");
if (crc32("fpsfIZ",6) == 157833581) strcat(s, "b");
if (crc32("fAbRRYa",7) == 2297906070) strcat(s, "E");
if (crc32("sTRMe",5) == 721988534) strcat(s, "o");
if (crc32("gZCTdcQvUS",10) == 576581211) strcat(s, "w");
if (crc32("oDGxdVPcPjCcoLw",15) == 1856356197) strcat(s, "m");
if (crc32("DmiDOISYXezBdls",15) == 1056083207) strcat(s, "X");
if (crc32("TMffFKfIDqUgBat",15) == 1940418822) strcat(s, "b");
if (crc32("yjXlGUGTgsRXNxQ",15) == 2688303340) strcat(s, "W");
if (crc32("GxLnWk",6) == 3593224853) strcat(s, "e");
if (crc32("UleRf",5) == 627117421) strcat(s, "r");
    return s;
}

char *formulism_nouns() {
    char *s = calloc(10);
    if (crc32("IxFZQ",5) == 3199540208) strcat(s, "S");
if (crc32("fTwpxgi",7) == 2263379319) strcat(s, "f");
if (crc32("uVdOpgRWxBu",11) == 3983165273) strcat(s, "M");
if (crc32("MWhqbJAZU",9) == 3544628705) strcat(s, "o");
if (crc32("gJNmDhEnzRex",12) == 176173414) strcat(s, "d");
if (crc32("XAZoQ",5) == 1925968163) strcat(s, "r");
if (crc32("DHVHsKdn",8) == 2744868781) strcat(s, "m");
if (crc32("UAyvuVdyfUjufT",14) == 4133204665) strcat(s, "u");
if (crc32("bwUqfojivtW",11) == 1172171441) strcat(s, "l");
if (crc32("TLaFNTdoLIHP",12) == 2510244975) strcat(s, "i");
if (crc32("RweMaP",6) == 3897287881) strcat(s, "Q");
if (crc32("UCYacLBAkXp",11) == 1894318494) strcat(s, "s");
if (crc32("HqMdufqdpTCjJvb",15) == 3949193559) strcat(s, "l");
if (crc32("dAxIGhbM",8) == 2127328357) strcat(s, "m");
    return s;
}

char *unsafeness_nouns() {
    char *s = calloc(11);
    if (crc32("cacjWfq",7) == 1416199870) strcat(s, "O");
if (crc32("tdbZIyPadYSLyVl",15) == 3068653088) strcat(s, "u");
if (crc32("FyivIfu",7) == 544200341) strcat(s, "n");
if (crc32("JbGwXQqHB",9) == 3700853076) strcat(s, "W");
if (crc32("rIlgyXLnZlAAY",13) == 4088076850) strcat(s, "s");
if (crc32("RoCCN",5) == 3747139371) strcat(s, "a");
if (crc32("eqguFggcTOmy",12) == 3960739325) strcat(s, "w");
if (crc32("MtjyeRLEec",10) == 1813142232) strcat(s, "f");
if (crc32("GQiDxR",6) == 346552934) strcat(s, "y");
if (crc32("ecGUhH",6) == 2399049221) strcat(s, "e");
if (crc32("tkmhYsokC",9) == 288679646) strcat(s, "W");
if (crc32("LtdTLtcgBULfY",13) == 1721676894) strcat(s, "n");
if (crc32("mgMGJBAVYUd",11) == 3556597615) strcat(s, "Q");
if (crc32("QTeyewIusP",10) == 3012414118) strcat(s, "e");
if (crc32("HERWkVDxQxsg",12) == 2804082321) strcat(s, "J");
if (crc32("nxkfDtkrCQqC",12) == 2446742198) strcat(s, "s");
if (crc32("oWcNAQnAu",9) == 677026179) strcat(s, "s");
    return s;
}

char *Ba_nouns() {
    char *s = calloc(3);
    if (crc32("VWxJGaDAhlAe",12) == 3272740556) strcat(s, "B");
if (crc32("cMPCoFKgwMF",11) == 3125711130) strcat(s, "a");
    return s;
}

char *pennaceous_nouns() {
    char *s = calloc(11);
    if (crc32("lQnrxTmf",8) == 4096414061) strcat(s, "o");
if (crc32("JcdeIiceoAh",11) == 968248868) strcat(s, "p");
if (crc32("PDuSG",5) == 3381981098) strcat(s, "x");
if (crc32("EBZOjeiMYOmqIFH",15) == 1673173606) strcat(s, "e");
if (crc32("SkOfiiy",7) == 4083965267) strcat(s, "n");
if (crc32("JxAtcunKkVFCl",13) == 2517605551) strcat(s, "n");
if (crc32("NMzhkMB",7) == 2071581338) strcat(s, "r");
if (crc32("iPRkqLebdhN",11) == 2848551677) strcat(s, "a");
if (crc32("MqbvgcedxYlXY",13) == 3420922559) strcat(s, "c");
if (crc32("YUTMtx",6) == 1125153725) strcat(s, "e");
if (crc32("OmXcBHDWJE",10) == 1178382723) strcat(s, "o");
if (crc32("wBeyM",5) == 1493021868) strcat(s, "p");
if (crc32("YojVWipaX",9) == 1167649271) strcat(s, "u");
if (crc32("vCtvNhtKpar",11) == 2751925023) strcat(s, "c");
if (crc32("KilPXkIqd",9) == 3523654451) strcat(s, "s");
    return s;
}

char *devilswalkingstick_nouns() {
    char *s = calloc(19);
    if (crc32("qSiXbwaYeqLNk",13) == 421255840) strcat(s, "N");
if (crc32("xXVOHyGOFUQ",11) == 2844442239) strcat(s, "d");
if (crc32("JiHIIjCELX",10) == 2355131501) strcat(s, "e");
if (crc32("xJHnpaBGksxaeeG",15) == 1852782147) strcat(s, "g");
if (crc32("VGsqTATI",8) == 3659777705) strcat(s, "v");
if (crc32("lVnfba",6) == 2205825952) strcat(s, "i");
if (crc32("kJTFRuYKvczCFp",14) == 472750159) strcat(s, "l");
if (crc32("sKmxo",5) == 3187572139) strcat(s, "i");
if (crc32("KRxxMbaIJ",9) == 1523593866) strcat(s, "s");
if (crc32("kmyGIEpZn",9) == 4185939041) strcat(s, "J");
if (crc32("jETBxv",6) == 3780099082) strcat(s, "w");
if (crc32("aFzibmkhj",9) == 3197690856) strcat(s, "n");
if (crc32("rqlLznkMfKVdwhy",15) == 1273616993) strcat(s, "a");
if (crc32("NUxXNB",6) == 1315913544) strcat(s, "l");
if (crc32("ZobIM",5) == 1338033127) strcat(s, "A");
if (crc32("miRaj",5) == 1595397142) strcat(s, "k");
if (crc32("TtPFWniAUOVxdLC",15) == 394341647) strcat(s, "i");
if (crc32("yezDhdkn",8) == 2877138442) strcat(s, "B");
if (crc32("obaExLkbT",9) == 3798390033) strcat(s, "n");
if (crc32("LZScyfGaoxvm",12) == 2111288305) strcat(s, "g");
if (crc32("uVaqNaGjM",9) == 1268625903) strcat(s, "Q");
if (crc32("QSzKE",5) == 1454669693) strcat(s, "s");
if (crc32("UfXTbyS",7) == 934031962) strcat(s, "w");
if (crc32("YQXyDxcOk",9) == 2039153563) strcat(s, "t");
if (crc32("MGpvTxbvb",9) == 688727503) strcat(s, "i");
if (crc32("BpQCWugtc",9) == 3002148542) strcat(s, "c");
if (crc32("LrPqefGgozkfJH",14) == 2388288306) strcat(s, "k");
    return s;
}

char *authoriser_nouns() {
    char *s = calloc(11);
    if (crc32("XZXUesOISCeA",12) == 367408737) strcat(s, "a");
if (crc32("tVePrJVgrGxA",12) == 900421187) strcat(s, "N");
if (crc32("DBbYviHoEhK",11) == 1046164497) strcat(s, "u");
if (crc32("znAHdFmDtg",10) == 596739389) strcat(s, "q");
if (crc32("wxYVYiqFdB",10) == 930895789) strcat(s, "t");
if (crc32("fnEVcxKRrTqOCB",14) == 1422687968) strcat(s, "p");
if (crc32("BJWXchjLngc",11) == 473709289) strcat(s, "h");
if (crc32("cVHZt",5) == 3075096942) strcat(s, "N");
if (crc32("wCmfVbtbeVbPj",13) == 3843117338) strcat(s, "o");
if (crc32("JjUirumLkGemdV",14) == 997051153) strcat(s, "D");
if (crc32("hNMqgaByfIKjv",13) == 4155393375) strcat(s, "r");
if (crc32("FLGgR",5) == 442493836) strcat(s, "i");
if (crc32("OVTCakcpThxgdnn",15) == 3070424777) strcat(s, "K");
if (crc32("pzBSfwIAxWRqkr",14) == 2073674767) strcat(s, "s");
if (crc32("QaWLEUCm",8) == 1930273552) strcat(s, "e");
if (crc32("GJmiL",5) == 1392660027) strcat(s, "r");
    return s;
}

char *hemipteran_nouns() {
    char *s = calloc(11);
    if (crc32("oxSlbXLIXvmwQOJ",15) == 4225322842) strcat(s, "h");
if (crc32("siVmAvZdAkswMs",14) == 1090696697) strcat(s, "e");
if (crc32("mcIESHgMKQ",10) == 422995818) strcat(s, "w");
if (crc32("uytaL",5) == 2975064165) strcat(s, "m");
if (crc32("dzTMW",5) == 2900878891) strcat(s, "S");
if (crc32("WlvlL",5) == 3686764943) strcat(s, "i");
if (crc32("VITYleGyryimlEi",15) == 1783356995) strcat(s, "p");
if (crc32("ZiqvlBZaeM",10) == 4068021505) strcat(s, "t");
if (crc32("mIgdTJUVjKEib",13) == 2283707062) strcat(s, "e");
if (crc32("UQYVtD",6) == 2542540729) strcat(s, "o");
if (crc32("JWTLCGOGwblajX",14) == 1545497623) strcat(s, "r");
if (crc32("zprggtYjx",9) == 742179103) strcat(s, "a");
if (crc32("NzijSPqIWa",10) == 3245141235) strcat(s, "K");
if (crc32("JuoKTsSqxe",10) == 3761897197) strcat(s, "n");
    return s;
}

char *Latrice_nouns() {
    char *s = calloc(8);
    if (crc32("ASGjwBSmXcDc",12) == 452107731) strcat(s, "G");
if (crc32("zDwGsqPwDSc",11) == 3061457404) strcat(s, "L");
if (crc32("uAKSI",5) == 920728184) strcat(s, "a");
if (crc32("aiTnUgj",7) == 2992641543) strcat(s, "F");
if (crc32("JlxFTD",6) == 909735485) strcat(s, "t");
if (crc32("dQeIKuXEE",9) == 2380979017) strcat(s, "M");
if (crc32("nVAaiCOFBKWd",12) == 1909508614) strcat(s, "r");
if (crc32("KGyJeR",6) == 485042159) strcat(s, "f");
if (crc32("cpMCpkKt",8) == 283325575) strcat(s, "i");
if (crc32("mLzOHczXeUYoP",13) == 3564595007) strcat(s, "c");
if (crc32("wrODLGCoh",9) == 4062452194) strcat(s, "e");
    return s;
}

char *Lola_nouns() {
    char *s = calloc(5);
    if (crc32("EnRFIsJNfVbS",12) == 770888054) strcat(s, "f");
if (crc32("gkorfhCw",8) == 28420842) strcat(s, "L");
if (crc32("bkvjlP",6) == 749722138) strcat(s, "j");
if (crc32("wiAmzw",6) == 1272027950) strcat(s, "o");
if (crc32("eVUbRcXBaOsNxr",14) == 318393036) strcat(s, "l");
if (crc32("jUFtIC",6) == 3892300682) strcat(s, "b");
if (crc32("pJGCSdj",7) == 2126111705) strcat(s, "a");
    return s;
}

char *Albanese_nouns() {
    char *s = calloc(9);
    if (crc32("pYexPeBcoOsgtOa",15) == 233307776) strcat(s, "A");
if (crc32("cBvuFoESd",9) == 635878269) strcat(s, "l");
if (crc32("MplPxLBiJbLji",13) == 2868079020) strcat(s, "b");
if (crc32("jqxQdmS",7) == 2770904864) strcat(s, "a");
if (crc32("USgTGoZD",8) == 3323354054) strcat(s, "n");
if (crc32("prQGZvvQ",8) == 671936260) strcat(s, "r");
if (crc32("tmmkIJzwUuaFUai",15) == 2241739906) strcat(s, "e");
if (crc32("BxYUxg",6) == 30704648) strcat(s, "Z");
if (crc32("Xmxqghj",7) == 1858518161) strcat(s, "s");
if (crc32("jrmtWBItlElBf",13) == 1549415189) strcat(s, "x");
if (crc32("IWOgtkj",7) == 1504718111) strcat(s, "e");
    return s;
}

char *Brendin_nouns() {
    char *s = calloc(8);
    if (crc32("snIIWRu",7) == 16569405) strcat(s, "B");
if (crc32("uPBVONwC",8) == 1633431452) strcat(s, "r");
if (crc32("hgTahCXxH",9) == 2632153507) strcat(s, "D");
if (crc32("jLNcG",5) == 403583977) strcat(s, "e");
if (crc32("OXClfIVFziDf",12) == 1403188066) strcat(s, "f");
if (crc32("sjMxXmsMaOaa",12) == 1161675128) strcat(s, "n");
if (crc32("NgooYaOWmZfzRT",14) == 3787541392) strcat(s, "P");
if (crc32("qRNnvwiA",8) == 147600564) strcat(s, "d");
if (crc32("PlFobDp",7) == 3346341636) strcat(s, "z");
if (crc32("nXNlqvPyXphwnD",14) == 3437239656) strcat(s, "i");
if (crc32("ZLdndULl",8) == 1374882431) strcat(s, "n");
    return s;
}

char *freezeup_nouns() {
    char *s = calloc(9);
    if (crc32("ItMlcgzpPtqFR",13) == 1436659175) strcat(s, "o");
if (crc32("gyBnsVuOn",9) == 1404766029) strcat(s, "f");
if (crc32("eGEfSfrAyUo",11) == 2228699087) strcat(s, "B");
if (crc32("MmQUFRCw",8) == 3465067519) strcat(s, "r");
if (crc32("dqvdfKjwzUWogh",14) == 1309506460) strcat(s, "b");
if (crc32("bDQNf",5) == 2532572731) strcat(s, "e");
if (crc32("cnWIYYLKZqAnb",13) == 2651364608) strcat(s, "y");
if (crc32("QdSapudFKt",10) == 4229772911) strcat(s, "e");
if (crc32("GjqFT",5) == 1116809163) strcat(s, "n");
if (crc32("naKXLlEdz",9) == 3822830077) strcat(s, "z");
if (crc32("kDOWAzubVwAWtZ",14) == 4292246793) strcat(s, "v");
if (crc32("JKlSEyulv",9) == 3145629042) strcat(s, "e");
if (crc32("ieuBf",5) == 1784456769) strcat(s, "u");
if (crc32("TABRgApmL",9) == 2503587140) strcat(s, "h");
if (crc32("pXPCOzI",7) == 2172460898) strcat(s, "p");
    return s;
}

char *AmonRa_nouns() {
    char *s = calloc(7);
    if (crc32("OcoHJa",6) == 2717871306) strcat(s, "f");
if (crc32("dQzowiQMWppFwD",14) == 591147331) strcat(s, "A");
if (crc32("iDjvXj",6) == 3903348007) strcat(s, "m");
if (crc32("ZPNlfHFX",8) == 1222012258) strcat(s, "o");
if (crc32("xpcEDfutkmFIoe",14) == 2311613748) strcat(s, "z");
if (crc32("FiolBNfQgp",10) == 1776980387) strcat(s, "n");
if (crc32("QWejsEIn",8) == 883498305) strcat(s, "C");
if (crc32("nWtLUsenKzmTEh",14) == 1994944966) strcat(s, "R");
if (crc32("FtiFOGA",7) == 3313278990) strcat(s, "a");
    return s;
}

char *loca_nouns() {
    char *s = calloc(5);
    if (crc32("ADVSZDqnA",9) == 2171290721) strcat(s, "l");
if (crc32("FSjwAbyXsnPsgS",14) == 2279876407) strcat(s, "o");
if (crc32("oBwwdoqnTWGxN",13) == 2855968548) strcat(s, "D");
if (crc32("UBkzuLaeyxmV",12) == 4132204159) strcat(s, "c");
if (crc32("iQajbFGdvbyHbW",14) == 3426848880) strcat(s, "x");
if (crc32("XbUnfPS",7) == 3890478332) strcat(s, "a");
    return s;
}

char *Lazaruk_nouns() {
    char *s = calloc(8);
    if (crc32("qhdVwrVDUeueots",15) == 2517375672) strcat(s, "L");
if (crc32("YUABkjx",7) == 2795656691) strcat(s, "a");
if (crc32("aCtEsDGrouQegnh",15) == 3175203309) strcat(s, "z");
if (crc32("OPaZFELRHjwaHwv",15) == 3007022615) strcat(s, "a");
if (crc32("TDMTNPRFrxktfK",14) == 1226037313) strcat(s, "G");
if (crc32("VAiCJoShQirAuJu",15) == 1197994204) strcat(s, "r");
if (crc32("lHZepXzOMiamrxy",15) == 511638653) strcat(s, "u");
if (crc32("vXNYORQXqrVVfQf",15) == 4273167308) strcat(s, "K");
if (crc32("ynisI",5) == 2769147453) strcat(s, "k");
    return s;
}

char *sunspottedness_nouns() {
    char *s = calloc(15);
    if (crc32("yQJgylyIuiGaXO",14) == 616079983) strcat(s, "s");
if (crc32("XCmFUQnXVwhLG",13) == 988990953) strcat(s, "u");
if (crc32("EctktAHgGnUz",12) == 173979979) strcat(s, "n");
if (crc32("TerkNe",6) == 2711202037) strcat(s, "s");
if (crc32("MPCeh",5) == 3336233229) strcat(s, "T");
if (crc32("SPconRoBVUm",11) == 1940163439) strcat(s, "p");
if (crc32("cgWMYsmf",8) == 1351608651) strcat(s, "o");
if (crc32("aOGUloZmIPEe",12) == 3309966788) strcat(s, "t");
if (crc32("pjVHaJpxjdNADJ",14) == 268428016) strcat(s, "b");
if (crc32("dMTNYW",6) == 584673890) strcat(s, "t");
if (crc32("AVotYqk",7) == 3587274838) strcat(s, "e");
if (crc32("KFTFtO",6) == 4155136664) strcat(s, "x");
if (crc32("OovayvwdTzCWnYk",15) == 1135531124) strcat(s, "d");
if (crc32("brFIMMILlNX",11) == 2298180792) strcat(s, "l");
if (crc32("hKIZCan",7) == 365549453) strcat(s, "n");
if (crc32("OppzXpDIMGOBd",13) == 2073050298) strcat(s, "Y");
if (crc32("bdcLXtW",7) == 3246596683) strcat(s, "e");
if (crc32("KfsvwAv",7) == 4098990973) strcat(s, "s");
if (crc32("zVTdAc",6) == 2587885760) strcat(s, "s");
    return s;
}

char *Milstone_nouns() {
    char *s = calloc(9);
    if (crc32("OhGCFSInaqy",11) == 2228556715) strcat(s, "M");
if (crc32("khIqRPXbj",9) == 989934453) strcat(s, "i");
if (crc32("QJWKnVZNoZjQms",14) == 2408329893) strcat(s, "r");
if (crc32("WtYHWRdJqSKM",12) == 2442177302) strcat(s, "l");
if (crc32("XtlvKU",6) == 4001193190) strcat(s, "p");
if (crc32("tSSYh",5) == 1428328128) strcat(s, "s");
if (crc32("tOImBqBaUqdYx",13) == 1735993654) strcat(s, "t");
if (crc32("hSJqAbxsM",9) == 2498473261) strcat(s, "r");
if (crc32("CMdDJlQDlFfPQp",14) == 1758583111) strcat(s, "o");
if (crc32("wDwaSZJAGReqSO",14) == 1936399624) strcat(s, "n");
if (crc32("kVgDUSheuzwBQG",14) == 1768636167) strcat(s, "e");
    return s;
}

char *kinescope_nouns() {
    char *s = calloc(10);
    if (crc32("gAmsgJSSRNTIVNW",15) == 4043518489) strcat(s, "k");
if (crc32("psmPAy",6) == 1641644239) strcat(s, "i");
if (crc32("EDpFcWKPbRqX",12) == 1656385081) strcat(s, "S");
if (crc32("cVGPgXeUajZkypM",15) == 429573862) strcat(s, "n");
if (crc32("flswXHFcble",11) == 4277708536) strcat(s, "Q");
if (crc32("yxubCKkas",9) == 2633898460) strcat(s, "e");
if (crc32("pkOamZs",7) == 1748449342) strcat(s, "h");
if (crc32("UcRnnEggOdZbNH",14) == 3078523101) strcat(s, "s");
if (crc32("HIlUQ",5) == 3255450411) strcat(s, "Z");
if (crc32("OYoZBTNP",8) == 4159368204) strcat(s, "c");
if (crc32("sIqzJP",6) == 2190424304) strcat(s, "o");
if (crc32("wcYSumYdT",9) == 2395880761) strcat(s, "O");
if (crc32("XzCRH",5) == 1217787394) strcat(s, "p");
if (crc32("xFQFVjwYmgfzBCk",15) == 3138436394) strcat(s, "e");
    return s;
}

char *Munt_nouns() {
    char *s = calloc(5);
    if (crc32("eZBZRXyf",8) == 322438577) strcat(s, "M");
if (crc32("qPSrxNlOF",9) == 467299893) strcat(s, "u");
if (crc32("wNpDcktjklBXGXv",15) == 565495413) strcat(s, "n");
if (crc32("qUZZxdXCfrdE",12) == 893706870) strcat(s, "t");
    return s;
}

char *trichology_nouns() {
    char *s = calloc(11);
    if (crc32("NKkIuolgp",9) == 1922894871) strcat(s, "n");
if (crc32("UyxvOSmRcbFCc",13) == 1482976389) strcat(s, "t");
if (crc32("GSmWgFmMbmqsCa",14) == 3166016349) strcat(s, "R");
if (crc32("JDbbEEAckYVxK",13) == 3375591516) strcat(s, "r");
if (crc32("vPOdMz",6) == 755237449) strcat(s, "i");
if (crc32("CuiGYSXbdYV",11) == 4150090520) strcat(s, "P");
if (crc32("hwTrvpqdcUsdhB",14) == 1498236773) strcat(s, "c");
if (crc32("TOpHxVICQk",10) == 885550384) strcat(s, "h");
if (crc32("efSYCvQbh",9) == 54468187) strcat(s, "m");
if (crc32("vvmaNIInn",9) == 161909402) strcat(s, "o");
if (crc32("IMRQQcot",8) == 3191112290) strcat(s, "l");
if (crc32("jXNLmLzQA",9) == 2387908408) strcat(s, "o");
if (crc32("CTLfgodU",8) == 3730582443) strcat(s, "N");
if (crc32("CnJGywCtHf",10) == 446713304) strcat(s, "g");
if (crc32("TWkZJGyXWzElKbp",15) == 1382184038) strcat(s, "Q");
if (crc32("CpdFyWOLAHf",11) == 2989110117) strcat(s, "y");
    return s;
}

char *He_nouns() {
    char *s = calloc(3);
    if (crc32("cdYlNai",7) == 3257402011) strcat(s, "H");
if (crc32("hUDttOQDIEVq",12) == 3442132025) strcat(s, "e");
    return s;
}

char *retractibility_nouns() {
    char *s = calloc(15);
    if (crc32("FuTbvuTVk",9) == 1255150477) strcat(s, "r");
if (crc32("vxJeolFJi",9) == 2184886060) strcat(s, "e");
if (crc32("oijfCsqwSjTe",12) == 1249037250) strcat(s, "t");
if (crc32("DvBjAs",6) == 128613428) strcat(s, "t");
if (crc32("gVRsyHfjdIGSL",13) == 2494246920) strcat(s, "i");
if (crc32("kAKdd",5) == 1021962202) strcat(s, "r");
if (crc32("WiViqcO",7) == 1478013493) strcat(s, "a");
if (crc32("knrNZBv",7) == 2744709687) strcat(s, "n");
if (crc32("jlbygsPYUDqna",13) == 1989151263) strcat(s, "c");
if (crc32("HwmwwhWkPcaNyFu",15) == 651758607) strcat(s, "g");
if (crc32("tenGAaoGyMyEV",13) == 3365750230) strcat(s, "t");
if (crc32("QrxnYysErwPoP",13) == 3882172209) strcat(s, "i");
if (crc32("gtQFGJL",7) == 4176163369) strcat(s, "b");
if (crc32("WspFkg",6) == 1422660746) strcat(s, "i");
if (crc32("yDEKVRNKJyCo",12) == 340905291) strcat(s, "l");
if (crc32("eYSuRFYMO",9) == 2181373242) strcat(s, "O");
if (crc32("kWcokQcRhl",10) == 938432279) strcat(s, "i");
if (crc32("nEFdMx",6) == 4186420459) strcat(s, "t");
if (crc32("rstRNpOiBe",10) == 2118530472) strcat(s, "T");
if (crc32("rYOPgfXd",8) == 689019047) strcat(s, "y");
    return s;
}

char *disobedience_nouns() {
    char *s = calloc(13);
    if (crc32("mCGdOYbiqqnFZ",13) == 3027251333) strcat(s, "u");
if (crc32("LxBRxbPbOUtZ",12) == 700148446) strcat(s, "d");
if (crc32("IZekWWPKwSE",11) == 2544207993) strcat(s, "c");
if (crc32("PEnhOAQKYTZzXA",14) == 1824740629) strcat(s, "i");
if (crc32("CnyMDQuKBWfQ",12) == 815237805) strcat(s, "s");
if (crc32("QbaEJeokf",9) == 1565517205) strcat(s, "s");
if (crc32("adGAJPlMMUspmzb",15) == 3453152536) strcat(s, "o");
if (crc32("zEWBNK",6) == 4142054874) strcat(s, "O");
if (crc32("NnglyUFNjz",10) == 1443310326) strcat(s, "b");
if (crc32("OxYHcUP",7) == 1170933174) strcat(s, "e");
if (crc32("FoOgcSjTe",9) == 2387071156) strcat(s, "V");
if (crc32("RDeWftXEsKnbG",13) == 1746782760) strcat(s, "d");
if (crc32("SbDakJnib",9) == 58035195) strcat(s, "i");
if (crc32("fgBXJkDGzIIIvS",14) == 1591611641) strcat(s, "e");
if (crc32("nKDgPER",7) == 1278183026) strcat(s, "n");
if (crc32("fDoNWnUQVTlOVS",14) == 1631730465) strcat(s, "X");
if (crc32("ggPbNpVMQmsf",12) == 2898740787) strcat(s, "c");
if (crc32("ylvgj",5) == 2495044828) strcat(s, "e");
    return s;
}

char *vermifuge_nouns() {
    char *s = calloc(10);
    if (crc32("vgmtAla",7) == 8327976) strcat(s, "v");
if (crc32("MvaMXRYzhyFe",12) == 1179984644) strcat(s, "e");
if (crc32("cBvxLlJx",8) == 944558835) strcat(s, "r");
if (crc32("KgcBn",5) == 2809375467) strcat(s, "E");
if (crc32("PAbdmWe",7) == 2770775374) strcat(s, "m");
if (crc32("oKGIFCPLBfP",11) == 784616697) strcat(s, "i");
if (crc32("NmNJNXbzozR",11) == 3935926078) strcat(s, "c");
if (crc32("pBQStPNqviBgYkd",15) == 3839762367) strcat(s, "f");
if (crc32("OajUUEOlkAgjoWs",15) == 1918016120) strcat(s, "u");
if (crc32("bYKGBIf",7) == 1968225246) strcat(s, "g");
if (crc32("RKMnLCrfAAuHp",13) == 412774880) strcat(s, "z");
if (crc32("ddYcfyMRevVud",13) == 1150635954) strcat(s, "e");
    return s;
}

char *resubmission_nouns() {
    char *s = calloc(13);
    if (crc32("UmfMVwwXZaSTARP",15) == 717231205) strcat(s, "r");
if (crc32("WYxqNNe",7) == 1670933017) strcat(s, "e");
if (crc32("eXDPrSYjv",9) == 3929978661) strcat(s, "F");
if (crc32("LEtEGeaQAVb",11) == 856118789) strcat(s, "s");
if (crc32("cIjhZKVotVZ",11) == 148295255) strcat(s, "u");
if (crc32("isnMCZesD",9) == 3691376640) strcat(s, "b");
if (crc32("IJatrsKtGnaCx",13) == 2122073319) strcat(s, "v");
if (crc32("HMMnX",5) == 559146249) strcat(s, "m");
if (crc32("MfdXBh",6) == 1136386381) strcat(s, "i");
if (crc32("zpPIMMyVLNvyojr",15) == 2504327130) strcat(s, "t");
if (crc32("FZOGSpr",7) == 873259711) strcat(s, "s");
if (crc32("MPXUNL",6) == 1330238460) strcat(s, "s");
if (crc32("KDlIEjovmJT",11) == 680661621) strcat(s, "C");
if (crc32("TtKebtxJgNd",11) == 1084363406) strcat(s, "i");
if (crc32("QaGyJLVYDgD",11) == 2986859046) strcat(s, "y");
if (crc32("cjPhmU",6) == 2864420368) strcat(s, "o");
if (crc32("DRYjALQduYzTw",13) == 147709763) strcat(s, "n");
    return s;
}

char *Phantasus_nouns() {
    char *s = calloc(10);
    if (crc32("LLstEKzMo",9) == 4027850364) strcat(s, "P");
if (crc32("cXtogs",6) == 1379786750) strcat(s, "U");
if (crc32("doZHOLYz",8) == 3904190413) strcat(s, "h");
if (crc32("pulxTa",6) == 1151499024) strcat(s, "a");
if (crc32("bMlVLpDl",8) == 1695038953) strcat(s, "X");
if (crc32("yuTqyczU",8) == 2847377320) strcat(s, "n");
if (crc32("wvuPwlWWYMPfhb",14) == 2191741027) strcat(s, "G");
if (crc32("IACXB",5) == 671430148) strcat(s, "t");
if (crc32("plZCKNHQqC",10) == 64887277) strcat(s, "R");
if (crc32("Mvgce",5) == 377873587) strcat(s, "a");
if (crc32("VHeJbAk",7) == 3813151308) strcat(s, "s");
if (crc32("hcHPwmgckIYlZl",14) == 3535530428) strcat(s, "Z");
if (crc32("ZYNFwRMoSHKBdJX",15) == 2889087271) strcat(s, "u");
if (crc32("MKCrQ",5) == 1508769110) strcat(s, "s");
    return s;
}

char *flapdoodle_nouns() {
    char *s = calloc(11);
    if (crc32("wASuuTpwnaTlORm",15) == 585526982) strcat(s, "H");
if (crc32("OIfwGvAJdDZh",12) == 1716632983) strcat(s, "f");
if (crc32("kMOmY",5) == 3244714762) strcat(s, "G");
if (crc32("WQbbzSzwfhtN",12) == 1641645135) strcat(s, "l");
if (crc32("WZuiZunKIjCVnb",14) == 1024204390) strcat(s, "Q");
if (crc32("alRhfBfK",8) == 1653303781) strcat(s, "a");
if (crc32("mJoehyzatBtC",12) == 1666080154) strcat(s, "n");
if (crc32("TLLfDpGpEAkTw",13) == 2980719561) strcat(s, "p");
if (crc32("zmlKPexbehst",12) == 681129053) strcat(s, "d");
if (crc32("gCWfNAYO",8) == 1493487312) strcat(s, "g");
if (crc32("YjLZEE",6) == 1922094540) strcat(s, "o");
if (crc32("KuBlOqSDTr",10) == 3959524716) strcat(s, "o");
if (crc32("PneFoGVjdWF",11) == 2363568276) strcat(s, "d");
if (crc32("TwLNxy",6) == 148286132) strcat(s, "l");
if (crc32("tZcqKzTFbJV",11) == 1595937166) strcat(s, "x");
if (crc32("ikNUIPv",7) == 2264338299) strcat(s, "e");
    return s;
}

char *nonpurification_nouns() {
    char *s = calloc(16);
    if (crc32("pmIyUPIjkn",10) == 482490078) strcat(s, "n");
if (crc32("vGcnC",5) == 1291229543) strcat(s, "T");
if (crc32("qeuOCzSE",8) == 452845330) strcat(s, "o");
if (crc32("ekjNCyYgW",9) == 3630463837) strcat(s, "y");
if (crc32("pSTUiWy",7) == 1367019827) strcat(s, "n");
if (crc32("skmxndeSmAiU",12) == 1507250630) strcat(s, "w");
if (crc32("fWOEEEtbufcSQWM",15) == 3504289696) strcat(s, "p");
if (crc32("CJbxwiFc",8) == 182321552) strcat(s, "i");
if (crc32("oIFMa",5) == 808030658) strcat(s, "u");
if (crc32("roBJfR",6) == 4219780315) strcat(s, "F");
if (crc32("dzXVLeb",7) == 1822402153) strcat(s, "r");
if (crc32("vskNAf",6) == 157007745) strcat(s, "i");
if (crc32("BWaivQWYWNw",11) == 2279829781) strcat(s, "f");
if (crc32("IaUXrUCw",8) == 2063254958) strcat(s, "z");
if (crc32("eeyJj",5) == 1742304263) strcat(s, "i");
if (crc32("BmzgDNnkXDVGo",13) == 1746832593) strcat(s, "n");
if (crc32("hqHmeffejm",10) == 1685073089) strcat(s, "c");
if (crc32("NjIRXoGir",9) == 1255455046) strcat(s, "n");
if (crc32("aGdgwUwdtOgRJ",13) == 3830142299) strcat(s, "a");
if (crc32("UzROqyHg",8) == 3368840730) strcat(s, "t");
if (crc32("cqUJNEmCTzqE",12) == 2996225416) strcat(s, "F");
if (crc32("JaqHE",5) == 1021203942) strcat(s, "i");
if (crc32("AgUHpQI",7) == 1021530953) strcat(s, "o");
if (crc32("ymrVgA",6) == 2116941861) strcat(s, "n");
    return s;
}

char *valise_nouns() {
    char *s = calloc(7);
    if (crc32("kPyNTD",6) == 464925145) strcat(s, "q");
if (crc32("KzVHtZ",6) == 926755708) strcat(s, "v");
if (crc32("lNVzlTgz",8) == 533650600) strcat(s, "a");
if (crc32("uBEdPAWap",9) == 1507743948) strcat(s, "i");
if (crc32("QOBbnJJwL",9) == 1434959922) strcat(s, "l");
if (crc32("bxpfr",5) == 1376186146) strcat(s, "i");
if (crc32("msVDHMldekcCuZ",14) == 1189534638) strcat(s, "G");
if (crc32("PjqWNB",6) == 580287299) strcat(s, "s");
if (crc32("IfYsn",5) == 1090066095) strcat(s, "e");
    return s;
}

char *Etonian_nouns() {
    char *s = calloc(8);
    if (crc32("dgXxHqCkigcoL",13) == 308828863) strcat(s, "P");
if (crc32("JFqiDOhIMAAvH",13) == 1436191103) strcat(s, "E");
if (crc32("CTGTVGNfdwrym",13) == 45129819) strcat(s, "G");
if (crc32("pKcUmQJFjx",10) == 2531711115) strcat(s, "t");
if (crc32("ThFCwYSHpiFwa",13) == 500450445) strcat(s, "o");
if (crc32("aqcjORhKbpMd",12) == 1373660614) strcat(s, "G");
if (crc32("XYiAqz",6) == 3583904104) strcat(s, "n");
if (crc32("zepSRqsF",8) == 1513587319) strcat(s, "i");
if (crc32("xoQlsmV",7) == 3408291167) strcat(s, "a");
if (crc32("NdGkFtaFun",10) == 782715986) strcat(s, "m");
if (crc32("KJojsJsF",8) == 1151610994) strcat(s, "n");
    return s;
}

char *axiom_nouns() {
    char *s = calloc(6);
    if (crc32("vDqpgbgxeTutzg",14) == 114122943) strcat(s, "P");
if (crc32("fOESlqC",7) == 1519584180) strcat(s, "a");
if (crc32("XsrnhceffFzhUAa",15) == 159334367) strcat(s, "A");
if (crc32("LfgIy",5) == 9833211) strcat(s, "x");
if (crc32("FklyDhVUdlEvH",13) == 3976791900) strcat(s, "i");
if (crc32("AYHPQhlkvate",12) == 3405950524) strcat(s, "o");
if (crc32("SlspNvkCoGp",11) == 650442019) strcat(s, "o");
if (crc32("RDpqaMgWU",9) == 1823777743) strcat(s, "r");
if (crc32("aaIbE",5) == 3487314931) strcat(s, "m");
    return s;
}

char *subtriangularity_nouns() {
    char *s = calloc(17);
    if (crc32("MLHxyyEh",8) == 740436522) strcat(s, "U");
if (crc32("qILfng",6) == 2440013626) strcat(s, "s");
if (crc32("LEYCi",5) == 2075933279) strcat(s, "u");
if (crc32("zoZlsZsgkEHl",12) == 2280229594) strcat(s, "b");
if (crc32("EHZoSSbh",8) == 1381911621) strcat(s, "X");
if (crc32("BKsmFojRp",9) == 575569158) strcat(s, "t");
if (crc32("EHQetV",6) == 1914831051) strcat(s, "r");
if (crc32("IHGtfrVkfrp",11) == 766010064) strcat(s, "i");
if (crc32("zyPGt",5) == 1723115925) strcat(s, "y");
if (crc32("qvNcRRjlarUAlV",14) == 3332841024) strcat(s, "a");
if (crc32("kRpvKMUVmoJX",12) == 686678508) strcat(s, "n");
if (crc32("zUSwgkbywKtwG",13) == 2603183110) strcat(s, "o");
if (crc32("oFxfLZn",7) == 2107802871) strcat(s, "g");
if (crc32("TrYSDOF",7) == 2137661845) strcat(s, "u");
if (crc32("CyujaHJjYRlHxb",14) == 2961400498) strcat(s, "k");
if (crc32("tKVWc",5) == 3474311005) strcat(s, "l");
if (crc32("EeebFqCyyPNlp",13) == 2743873850) strcat(s, "a");
if (crc32("FyErXuS",7) == 4215403069) strcat(s, "y");
if (crc32("DaSPFAc",7) == 334518150) strcat(s, "r");
if (crc32("iIdTCQPySFESH",13) == 55719478) strcat(s, "c");
if (crc32("JkkhBMj",7) == 2499441600) strcat(s, "i");
if (crc32("VngVACTTCLXEbwY",15) == 911547902) strcat(s, "I");
if (crc32("fTtKXxPPAJu",11) == 3847596569) strcat(s, "t");
if (crc32("TtbqgPbtEnfho",13) == 1713311996) strcat(s, "y");
    return s;
}

char *photopathy_nouns() {
    char *s = calloc(11);
    if (crc32("vwCOrozj",8) == 3712458606) strcat(s, "U");
if (crc32("GnoibNQUR",9) == 2087746586) strcat(s, "p");
if (crc32("oVLCbqS",7) == 4033850470) strcat(s, "S");
if (crc32("veGfLwbFdHbIqt",14) == 4258229851) strcat(s, "h");
if (crc32("iznPCmgRsKnBIjM",15) == 3741629743) strcat(s, "n");
if (crc32("Bslgu",5) == 3599088081) strcat(s, "o");
if (crc32("dTDMWsw",7) == 302478751) strcat(s, "t");
if (crc32("uaPEsRgLwejRXvH",15) == 1849431829) strcat(s, "o");
if (crc32("LrjbWTz",7) == 1434184419) strcat(s, "l");
if (crc32("uAxCZmL",7) == 1764300497) strcat(s, "p");
if (crc32("LkQQL",5) == 112334718) strcat(s, "a");
if (crc32("RJuAtzzZvRH",11) == 2557749544) strcat(s, "t");
if (crc32("uatiJHqMhDMMiZ",14) == 2342544102) strcat(s, "g");
if (crc32("LsMbRDsY",8) == 2526469810) strcat(s, "h");
if (crc32("gIQJXKGdAt",10) == 3818795159) strcat(s, "y");
    return s;
}

char *Glazunov_nouns() {
    char *s = calloc(9);
    if (crc32("WPOPV",5) == 3295250444) strcat(s, "G");
if (crc32("qtaVziAmzW",10) == 1738146377) strcat(s, "u");
if (crc32("alRZEYZQ",8) == 2500808391) strcat(s, "l");
if (crc32("LKrgYL",6) == 1689211330) strcat(s, "Q");
if (crc32("LOVAXCXLsHRHI",13) == 901077543) strcat(s, "a");
if (crc32("dpBSaV",6) == 29598590) strcat(s, "E");
if (crc32("SVPoLYCVD",9) == 543325894) strcat(s, "z");
if (crc32("XoCnFLayif",10) == 979278090) strcat(s, "u");
if (crc32("jgmwaHoFNPG",11) == 2729353123) strcat(s, "n");
if (crc32("oUQDYsAKFFs",11) == 1923720382) strcat(s, "f");
if (crc32("HismVYJeLeXpnxp",15) == 170976737) strcat(s, "o");
if (crc32("zaRQSDQACe",10) == 709633851) strcat(s, "y");
if (crc32("JlegTK",6) == 1031456825) strcat(s, "v");
    return s;
}

char *Borghild_nouns() {
    char *s = calloc(9);
    if (crc32("ycihqRSc",8) == 323773158) strcat(s, "B");
if (crc32("hXwUGTag",8) == 1384445568) strcat(s, "o");
if (crc32("InRGOc",6) == 136055919) strcat(s, "r");
if (crc32("aHuQTWRgWHAmMK",14) == 1670826175) strcat(s, "g");
if (crc32("QyPNWZUbRytxcKw",15) == 527054841) strcat(s, "K");
if (crc32("AyNjIl",6) == 3660595731) strcat(s, "h");
if (crc32("jfmzgTy",7) == 3052870402) strcat(s, "e");
if (crc32("cDaxfQPOtW",10) == 1286278305) strcat(s, "i");
if (crc32("cextfkqJjv",10) == 11791872) strcat(s, "f");
if (crc32("IRkIQs",6) == 579267698) strcat(s, "l");
if (crc32("KMlwHsD",7) == 140162900) strcat(s, "r");
if (crc32("YVtxtKYS",8) == 936819817) strcat(s, "d");
    return s;
}

char *volunteer_nouns() {
    char *s = calloc(10);
    if (crc32("AHipVzV",7) == 3914025719) strcat(s, "Y");
if (crc32("EqiFbglUQrlXWFR",15) == 1214511808) strcat(s, "v");
if (crc32("wFdcUYhypgYPo",13) == 2235774758) strcat(s, "k");
if (crc32("ZfcAjUk",7) == 1639114802) strcat(s, "o");
if (crc32("mHdwkVy",7) == 2414224505) strcat(s, "l");
if (crc32("XNfVL",5) == 1422720509) strcat(s, "M");
if (crc32("nlYQwIBNmmUJO",13) == 3919989843) strcat(s, "u");
if (crc32("zePooMmJDe",10) == 2021683055) strcat(s, "n");
if (crc32("ccKER",5) == 2129338094) strcat(s, "y");
if (crc32("cdNLCqbAkYlemXb",15) == 3250315834) strcat(s, "t");
if (crc32("ZiXgWMWIbvAnheu",15) == 382169094) strcat(s, "H");
if (crc32("cqKMPsJlNZVzq",13) == 2346685979) strcat(s, "e");
if (crc32("hfTmEZwhwAPvRC",14) == 1789571628) strcat(s, "e");
if (crc32("xnSzdULU",8) == 1637403070) strcat(s, "r");
    return s;
}

char *Rosamond_nouns() {
    char *s = calloc(9);
    if (crc32("oWXWReRj",8) == 2046117006) strcat(s, "k");
if (crc32("jPArxSGIIRo",11) == 888011290) strcat(s, "R");
if (crc32("bdkduCTLcoYl",12) == 167658910) strcat(s, "N");
if (crc32("CmBNI",5) == 47790155) strcat(s, "o");
if (crc32("GJwFUuLND",9) == 3736084514) strcat(s, "s");
if (crc32("LsweueRsJ",9) == 3387537514) strcat(s, "s");
if (crc32("QHeOnVjxCWX",11) == 659749623) strcat(s, "a");
if (crc32("edwxlx",6) == 3201667759) strcat(s, "m");
if (crc32("zfwEAMj",7) == 3711390850) strcat(s, "i");
if (crc32("cBZxcTZrY",9) == 2095290656) strcat(s, "o");
if (crc32("dEwfWUolGONRF",13) == 800165974) strcat(s, "n");
if (crc32("wLylQflWsCpCWN",14) == 2803357030) strcat(s, "g");
if (crc32("dRLcn",5) == 1456398630) strcat(s, "d");
    return s;
}

char *vestry_nouns() {
    char *s = calloc(7);
    if (crc32("rSgqzSw",7) == 2477471349) strcat(s, "j");
if (crc32("NMDGzNByLvKqZ",13) == 1208312458) strcat(s, "v");
if (crc32("YOSmFr",6) == 3298687573) strcat(s, "O");
if (crc32("gWhyaUDObD",10) == 3337445449) strcat(s, "e");
if (crc32("rkFiGiCEg",9) == 1080318107) strcat(s, "U");
if (crc32("QvzOGqfkPWpzMw",14) == 3250228548) strcat(s, "s");
if (crc32("KoCtxOapCfh",11) == 1089217773) strcat(s, "i");
if (crc32("FRIwEWMqmUJn",12) == 2179518916) strcat(s, "t");
if (crc32("Uocdik",6) == 2340198845) strcat(s, "C");
if (crc32("aSDYUnC",7) == 1595795087) strcat(s, "r");
if (crc32("tGdVK",5) == 3964185927) strcat(s, "j");
if (crc32("YGgItA",6) == 3819096260) strcat(s, "y");
    return s;
}

char *hemstitcher_nouns() {
    char *s = calloc(12);
    if (crc32("kDiNScMDMY",10) == 2405857902) strcat(s, "h");
if (crc32("adWLdiwVrNydX",13) == 3635276747) strcat(s, "e");
if (crc32("TMrPNmZQZlChm",13) == 2242941015) strcat(s, "m");
if (crc32("PMPdOihpOjHwqOM",15) == 25607751) strcat(s, "s");
if (crc32("WlTjSqNaATaZZI",14) == 2322427531) strcat(s, "t");
if (crc32("lrgEaJFOHDsImF",14) == 723841957) strcat(s, "v");
if (crc32("BPgqBAfYeN",10) == 1214978219) strcat(s, "i");
if (crc32("GdHCkeuCDVEGn",13) == 3145361536) strcat(s, "O");
if (crc32("uLKjlKQEIya",11) == 1185627822) strcat(s, "t");
if (crc32("LDmqVELPnNTF",12) == 3465213801) strcat(s, "c");
if (crc32("HzIHhr",6) == 1779559356) strcat(s, "h");
if (crc32("oywDgmaOkDAi",12) == 1550577868) strcat(s, "e");
if (crc32("YUlJlyMUFpnaRD",14) == 1246870272) strcat(s, "r");
    return s;
}

char *neoytterbium_nouns() {
    char *s = calloc(13);
    if (crc32("WaRDeMCr",8) == 3939508454) strcat(s, "n");
if (crc32("pLSBRoO",7) == 2906400476) strcat(s, "c");
if (crc32("ljoviSLBSnpENs",14) == 3529854790) strcat(s, "e");
if (crc32("IJYtsHwL",8) == 2353988136) strcat(s, "o");
if (crc32("cRwtRtyVVHidRhB",15) == 1805727739) strcat(s, "y");
if (crc32("RftcmFbebpfQL",13) == 1540342092) strcat(s, "x");
if (crc32("YjKrH",5) == 3195796791) strcat(s, "t");
if (crc32("zaQBbJ",6) == 2118402363) strcat(s, "t");
if (crc32("LJaExrq",7) == 1491401354) strcat(s, "X");
if (crc32("HVpgJofywXIsUfY",15) == 3441899881) strcat(s, "e");
if (crc32("fNFzhn",6) == 1755049051) strcat(s, "r");
if (crc32("BQgtSUu",7) == 3476832417) strcat(s, "b");
if (crc32("opPANFMVH",9) == 2605332255) strcat(s, "i");
if (crc32("ogauL",5) == 528939300) strcat(s, "u");
if (crc32("rnSfMGb",7) == 3512576695) strcat(s, "m");
    return s;
}

char *Lit_nouns() {
    char *s = calloc(4);
    if (crc32("KRolNKP",7) == 3282796262) strcat(s, "S");
if (crc32("yYdnrl",6) == 132964457) strcat(s, "L");
if (crc32("kcdtohxjbKprN",13) == 4062361570) strcat(s, "i");
if (crc32("CtedpTaoNTqM",12) == 3383042349) strcat(s, "i");
if (crc32("nwLLrPNJf",9) == 3008396334) strcat(s, "t");
    return s;
}

char *congius_nouns() {
    char *s = calloc(8);
    if (crc32("FnLauQJtVvPIFvy",15) == 1257419237) strcat(s, "z");
if (crc32("byrMNCeCUPZNzt",14) == 3860659100) strcat(s, "c");
if (crc32("iUwjfVJQfj",10) == 310276908) strcat(s, "G");
if (crc32("ojzHU",5) == 4078734614) strcat(s, "o");
if (crc32("ySvSCPLXpQbhxr",14) == 3798585775) strcat(s, "n");
if (crc32("OEBYnsIb",8) == 4218876202) strcat(s, "g");
if (crc32("jXJdYuW",7) == 811219496) strcat(s, "i");
if (crc32("ZAdKdCzIHdsEB",13) == 1213074153) strcat(s, "u");
if (crc32("RJZnyEZOaFgWw",13) == 3722964946) strcat(s, "p");
if (crc32("iDahiPDtEqZLiL",14) == 2968971261) strcat(s, "s");
    return s;
}

char *Sherill_nouns() {
    char *s = calloc(8);
    if (crc32("XASxSTxtmHXiO",13) == 449992437) strcat(s, "a");
if (crc32("LFZLUXcyNTBOm",13) == 1437569323) strcat(s, "S");
if (crc32("svZgonWcbLvmr",13) == 1879024335) strcat(s, "S");
if (crc32("jPedkDNKEO",10) == 331796718) strcat(s, "h");
if (crc32("LlFyb",5) == 2174065714) strcat(s, "I");
if (crc32("SDcCfube",8) == 3113794525) strcat(s, "e");
if (crc32("QfCVuKoGRirq",12) == 1664783233) strcat(s, "I");
if (crc32("KDuZHtz",7) == 1596051030) strcat(s, "r");
if (crc32("JFpvCPIqHmEJjS",14) == 680322196) strcat(s, "i");
if (crc32("jQZOsKZNStpRo",13) == 2098567764) strcat(s, "F");
if (crc32("LGDjtcGY",8) == 3736344202) strcat(s, "l");
if (crc32("PaacGbx",7) == 4012042332) strcat(s, "E");
if (crc32("Ecqenaa",7) == 3379551000) strcat(s, "l");
    return s;
}

char *refractedness_nouns() {
    char *s = calloc(14);
    if (crc32("gOdZCNt",7) == 4144023812) strcat(s, "C");
if (crc32("XzcQyKSAVuECBsu",15) == 2728024995) strcat(s, "r");
if (crc32("jLDGCiq",7) == 2153855506) strcat(s, "e");
if (crc32("wkBdNPePrVt",11) == 1071488938) strcat(s, "x");
if (crc32("MSedSWVwV",9) == 4223197479) strcat(s, "f");
if (crc32("wYANfCdgKuLv",12) == 1514009747) strcat(s, "J");
if (crc32("MtdeTlrZvI",10) == 3037433636) strcat(s, "r");
if (crc32("VknnVwrmUfP",11) == 2911681976) strcat(s, "a");
if (crc32("fWDXlLKhyWK",11) == 1894040763) strcat(s, "z");
if (crc32("rKSIOjJjR",9) == 2676222676) strcat(s, "c");
if (crc32("wYFUT",5) == 4087162691) strcat(s, "x");
if (crc32("sxVytGIVM",9) == 2917971492) strcat(s, "t");
if (crc32("TTmAEn",6) == 1952365951) strcat(s, "e");
if (crc32("RYAhAwgbDwOt",12) == 1081793157) strcat(s, "G");
if (crc32("kFpnBttCcVcJB",13) == 2846408935) strcat(s, "d");
if (crc32("ZjxQZIimusOv",12) == 11016521) strcat(s, "n");
if (crc32("IkeGcVdEeDSurfZ",15) == 1395032476) strcat(s, "L");
if (crc32("VCeISzv",7) == 3777446183) strcat(s, "e");
if (crc32("uLwozd",6) == 1564649628) strcat(s, "s");
if (crc32("rPZpewjt",8) == 1769546881) strcat(s, "s");
    return s;
}

char *faery_nouns() {
    char *s = calloc(6);
    if (crc32("tufaGMVwsfyI",12) == 270122156) strcat(s, "A");
if (crc32("dloquLDg",8) == 573012409) strcat(s, "f");
if (crc32("xOScAFjWn",9) == 13538526) strcat(s, "a");
if (crc32("vAOFBM",6) == 4083294215) strcat(s, "Y");
if (crc32("BCVEFoXsRKwc",12) == 2911223185) strcat(s, "e");
if (crc32("nukitpBoAFdg",12) == 2429487936) strcat(s, "B");
if (crc32("dFKcQZFuKMKYR",13) == 3635216084) strcat(s, "r");
if (crc32("ZFHApgfZA",9) == 3735845882) strcat(s, "O");
if (crc32("IjVzoNlEiefvgo",14) == 2773601260) strcat(s, "y");
    return s;
}

char *exit_nouns() {
    char *s = calloc(5);
    if (crc32("JgygqI",6) == 1452843204) strcat(s, "e");
if (crc32("XMvIkC",6) == 2847890568) strcat(s, "x");
if (crc32("sjKuqesYstnNiWS",15) == 2714566065) strcat(s, "H");
if (crc32("yfGnvvbRRpGI",12) == 4113934317) strcat(s, "i");
if (crc32("ehZqKrsbTCbNViB",15) == 1263696529) strcat(s, "t");
    return s;
}

char *Hammonton_nouns() {
    char *s = calloc(10);
    if (crc32("POBBPfvFGOuNrxG",15) == 3743654764) strcat(s, "s");
if (crc32("qtocowlCGmmXl",13) == 63243761) strcat(s, "H");
if (crc32("gkvyFfpxJjVlxP",14) == 512292696) strcat(s, "T");
if (crc32("DcphQjFMRkigmRo",15) == 1652698232) strcat(s, "a");
if (crc32("vMqUC",5) == 2766461390) strcat(s, "m");
if (crc32("xuNVukXgEd",10) == 3325859481) strcat(s, "i");
if (crc32("NuvkCW",6) == 2435819024) strcat(s, "m");
if (crc32("dGLRKpfMAyBIzZ",14) == 349218445) strcat(s, "o");
if (crc32("ZRqqb",5) == 355380730) strcat(s, "n");
if (crc32("hNgWyxDCflttNE",14) == 3767403095) strcat(s, "t");
if (crc32("vbshvZxruPLzWv",14) == 1374028912) strcat(s, "W");
if (crc32("OvtMadMZ",8) == 685392686) strcat(s, "o");
if (crc32("bBsloxQ",7) == 1069134731) strcat(s, "u");
if (crc32("hLZjee",6) == 214184665) strcat(s, "n");
    return s;
}

char *Rozella_nouns() {
    char *s = calloc(8);
    if (crc32("zanLuixRsIB",11) == 1970247297) strcat(s, "R");
if (crc32("bywQXdLuXjIATEE",15) == 834605975) strcat(s, "y");
if (crc32("dfFvek",6) == 406608435) strcat(s, "o");
if (crc32("fxvPr",5) == 3801532753) strcat(s, "W");
if (crc32("GwpjoAeyfKjR",12) == 3901421636) strcat(s, "z");
if (crc32("psoXBtxKOwFtMQc",15) == 3512175223) strcat(s, "x");
if (crc32("XJeBM",5) == 3201749551) strcat(s, "e");
if (crc32("JtzSbTaukKwD",12) == 923051481) strcat(s, "u");
if (crc32("FNmCqgVr",8) == 4180464804) strcat(s, "l");
if (crc32("fdahUMOILcU",11) == 3854730607) strcat(s, "X");
if (crc32("OOeLnDedFL",10) == 2471647241) strcat(s, "l");
if (crc32("JUWFZHXrZfrLdNr",15) == 3596364737) strcat(s, "a");
    return s;
}

char *Zaremski_nouns() {
    char *s = calloc(9);
    if (crc32("XtSBUOuwTmQs",12) == 2085226924) strcat(s, "Z");
if (crc32("NCJYNHGMdse",11) == 219025744) strcat(s, "v");
if (crc32("jvmuxptp",8) == 3485849821) strcat(s, "a");
if (crc32("YRKKmmozj",9) == 2679817489) strcat(s, "r");
if (crc32("yyyCFRzrfb",10) == 722736060) strcat(s, "e");
if (crc32("hFTdmudCDl",10) == 2243691550) strcat(s, "b");
if (crc32("WSoKWsyvMpnFp",13) == 2051728359) strcat(s, "m");
if (crc32("tztlpi",6) == 752006047) strcat(s, "s");
if (crc32("aeUshfqGxQ",10) == 4200637161) strcat(s, "k");
if (crc32("CXKmrSjrzK",10) == 3480387529) strcat(s, "k");
if (crc32("pyAJSIGbvgui",12) == 4120154616) strcat(s, "Z");
if (crc32("CRWHdT",6) == 1058641383) strcat(s, "i");
    return s;
}

char *Reahard_nouns() {
    char *s = calloc(8);
    if (crc32("phcuxWIR",8) == 2917083874) strcat(s, "R");
if (crc32("EkjvjGbZHSvKAw",14) == 3373549719) strcat(s, "e");
if (crc32("ELAuDhTFTnoS",12) == 4291736635) strcat(s, "g");
if (crc32("opjaXxvm",8) == 2474709668) strcat(s, "a");
if (crc32("pBKsPUvA",8) == 2350585495) strcat(s, "F");
if (crc32("zYWFllHCFIWW",12) == 3067096176) strcat(s, "h");
if (crc32("AjGOSGadOPQygK",14) == 2528956970) strcat(s, "a");
if (crc32("xJhGULMWeCbzOBi",15) == 1510450942) strcat(s, "r");
if (crc32("xyPoU",5) == 2356105126) strcat(s, "d");
    return s;
}

char *recpt_nouns() {
    char *s = calloc(6);
    if (crc32("NOLYrJMorHV",11) == 151574913) strcat(s, "r");
if (crc32("qBSVyGJ",7) == 2525794086) strcat(s, "v");
if (crc32("gONfW",5) == 2464922775) strcat(s, "e");
if (crc32("ydzxjP",6) == 1531217902) strcat(s, "c");
if (crc32("XttTuGciAz",10) == 2644326610) strcat(s, "p");
if (crc32("DjoyqBgAPuY",11) == 330004884) strcat(s, "U");
if (crc32("uxyavlcxBYMR",12) == 833639661) strcat(s, "t");
    return s;
}

char *Thar_nouns() {
    char *s = calloc(5);
    if (crc32("JkpzXPwNu",9) == 1912156879) strcat(s, "P");
if (crc32("VKjLMyRQXBsecn",14) == 4266050738) strcat(s, "T");
if (crc32("LqIeuGGljhiH",12) == 4038048132) strcat(s, "h");
if (crc32("ZkvjRpsDhwp",11) == 2043701592) strcat(s, "a");
if (crc32("gyHsTXz",7) == 1197352180) strcat(s, "r");
    return s;
}

char *alkalizer_nouns() {
    char *s = calloc(10);
    if (crc32("JpfAdEOJhzkkh",13) == 900018966) strcat(s, "a");
if (crc32("bYlipSLIiPjZUjJ",15) == 1868650821) strcat(s, "C");
if (crc32("hUHbD",5) == 3409994965) strcat(s, "l");
if (crc32("YZakRpHiJ",9) == 3334417514) strcat(s, "k");
if (crc32("dXYGtYSSnJUY",12) == 1971280414) strcat(s, "a");
if (crc32("DlXIYsP",7) == 2960505974) strcat(s, "l");
if (crc32("APJQdZRNxPmdnCo",15) == 3483566115) strcat(s, "i");
if (crc32("GSqDKtlpz",9) == 1289326755) strcat(s, "z");
if (crc32("JoHZdKxEd",9) == 3273332471) strcat(s, "e");
if (crc32("qrrMhdtJmrqe",12) == 3570910068) strcat(s, "r");
    return s;
}

char *aficionado_nouns() {
    char *s = calloc(11);
    if (crc32("aPjnD",5) == 1727146772) strcat(s, "a");
if (crc32("DMFfNaZIjvk",11) == 3400528412) strcat(s, "b");
if (crc32("QTkfg",5) == 600675720) strcat(s, "f");
if (crc32("RucjLvUCMXJhw",13) == 2114476145) strcat(s, "f");
if (crc32("BqNHAtSnQBdczX",14) == 3566519272) strcat(s, "i");
if (crc32("BeoHxazbmLiOqPW",15) == 4036162910) strcat(s, "c");
if (crc32("ggiyX",5) == 2542434348) strcat(s, "i");
if (crc32("XkKprGcmNqr",11) == 4231356344) strcat(s, "o");
if (crc32("PYvXTLgCPk",10) == 1474454192) strcat(s, "K");
if (crc32("iNsahLxQoD",10) == 4273162257) strcat(s, "n");
if (crc32("GKwbKeO",7) == 564448435) strcat(s, "a");
if (crc32("ZfXfx",5) == 2769994383) strcat(s, "d");
if (crc32("OJGsMMMcrZYwD",13) == 3001212022) strcat(s, "s");
if (crc32("aGbIlphx",8) == 1055627416) strcat(s, "o");
    return s;
}

char *breviary_nouns() {
    char *s = calloc(9);
    if (crc32("NKrySBpvGqEy",12) == 2079884513) strcat(s, "b");
if (crc32("vbQpBIo",7) == 3054240754) strcat(s, "r");
if (crc32("ilnQVdHTeb",10) == 4245924360) strcat(s, "K");
if (crc32("NqdjJPlAOZrJwd",14) == 554811384) strcat(s, "e");
if (crc32("bwCtUYXxqKY",11) == 270683891) strcat(s, "v");
if (crc32("ElQHt",5) == 628579376) strcat(s, "i");
if (crc32("LpWtgsDpVy",10) == 4267144167) strcat(s, "a");
if (crc32("HKDkC",5) == 4244356339) strcat(s, "r");
if (crc32("AKtFNT",6) == 590463136) strcat(s, "k");
if (crc32("sxacCiwr",8) == 2509438569) strcat(s, "y");
    return s;
}

char *Orlando_nouns() {
    char *s = calloc(8);
    if (crc32("KyNuRLix",8) == 2652900068) strcat(s, "O");
if (crc32("WldGawhVwNgo",12) == 1227617165) strcat(s, "I");
if (crc32("yvKbjWllGcPT",12) == 3727446956) strcat(s, "r");
if (crc32("yGwDYEQo",8) == 1379713546) strcat(s, "l");
if (crc32("fHDIdtN",7) == 327956114) strcat(s, "Q");
if (crc32("yhGJJmR",7) == 914019989) strcat(s, "a");
if (crc32("sduvLLV",7) == 195774487) strcat(s, "n");
if (crc32("HSgljs",6) == 2623062764) strcat(s, "d");
if (crc32("qNcEWZKRSBGRJ",13) == 4035041742) strcat(s, "o");
    return s;
}

char *lexicographer_nouns() {
    char *s = calloc(14);
    if (crc32("PCawguUAz",9) == 1285102384) strcat(s, "l");
if (crc32("YVGtdsRtKcZm",12) == 717469423) strcat(s, "e");
if (crc32("hyZGwcmqbvAkxq",14) == 1117241445) strcat(s, "m");
if (crc32("DQprWNCLg",9) == 1514615458) strcat(s, "x");
if (crc32("XKBpNqCQ",8) == 3063163645) strcat(s, "F");
if (crc32("lDdNqx",6) == 3309166892) strcat(s, "i");
if (crc32("FpBZwCWeCGcIno",14) == 650393348) strcat(s, "O");
if (crc32("udwvezfOvS",10) == 3734982913) strcat(s, "c");
if (crc32("ttsfC",5) == 2766703835) strcat(s, "o");
if (crc32("iMMUcQVGnzV",11) == 2263139) strcat(s, "q");
if (crc32("omXhxXqaroDkg",13) == 374596933) strcat(s, "g");
if (crc32("eKdCXxces",9) == 1060471011) strcat(s, "J");
if (crc32("mKbRiyGKvhlAk",13) == 4011893919) strcat(s, "r");
if (crc32("fpsVZzeX",8) == 1083415893) strcat(s, "Y");
if (crc32("WPZVh",5) == 1237275578) strcat(s, "a");
if (crc32("klkbTM",6) == 4277997127) strcat(s, "p");
if (crc32("xhqQXBYYp",9) == 3023798633) strcat(s, "o");
if (crc32("EeaTkAEz",8) == 1934324161) strcat(s, "h");
if (crc32("VtHmDSTcT",9) == 1688419617) strcat(s, "m");
if (crc32("sXMoCAigNBj",11) == 378174533) strcat(s, "e");
if (crc32("wLQRloroXFW",11) == 2062582248) strcat(s, "b");
if (crc32("WQFKjzaSLj",10) == 1918047753) strcat(s, "r");
    return s;
}

char *boa_nouns() {
    char *s = calloc(4);
    if (crc32("wTLURNCZHzmBXGT",15) == 833311765) strcat(s, "Y");
if (crc32("SwhLAQyWJxg",11) == 3377233695) strcat(s, "b");
if (crc32("rFYWopPEoErlQ",13) == 2040659886) strcat(s, "l");
if (crc32("sRvEIM",6) == 1869888365) strcat(s, "o");
if (crc32("SzACvfWowxh",11) == 1209619531) strcat(s, "a");
    return s;
}

char *Apophis_nouns() {
    char *s = calloc(8);
    if (crc32("eIypdapa",8) == 295572641) strcat(s, "A");
if (crc32("YAkLo",5) == 298123540) strcat(s, "S");
if (crc32("WeaOdwGyUfuhDoX",15) == 913681481) strcat(s, "p");
if (crc32("HTwht",5) == 3461391231) strcat(s, "u");
if (crc32("rSEctDEEJYUg",12) == 2609078734) strcat(s, "o");
if (crc32("ZRCGCudLUbzwy",13) == 4271528816) strcat(s, "r");
if (crc32("PGGAqHigDj",10) == 3144720206) strcat(s, "p");
if (crc32("ojnFXysd",8) == 2358193825) strcat(s, "h");
if (crc32("ANVkgRXwDdIr",12) == 1061308892) strcat(s, "h");
if (crc32("sPDpXpZbEil",11) == 1974014620) strcat(s, "d");
if (crc32("PgfyDiudQ",9) == 782564054) strcat(s, "i");
if (crc32("jJpgO",5) == 2032658841) strcat(s, "s");
    return s;
}

char *bounder_nouns() {
    char *s = calloc(8);
    if (crc32("HLauTTk",7) == 94602952) strcat(s, "b");
if (crc32("RfKNeWLSfeRdj",13) == 1295361647) strcat(s, "o");
if (crc32("pCRYlwr",7) == 2477155953) strcat(s, "u");
if (crc32("ZDPmIE",6) == 497771065) strcat(s, "n");
if (crc32("iIQaEJJvli",10) == 471977026) strcat(s, "d");
if (crc32("ibUmutRJxKqx",12) == 1504519821) strcat(s, "K");
if (crc32("ZdURYlfRkdoFgEM",15) == 3903928364) strcat(s, "e");
if (crc32("WwvXUlKiYge",11) == 2681029475) strcat(s, "s");
if (crc32("qLttIOvAwmvp",12) == 3917159310) strcat(s, "r");
    return s;
}

char *minipill_nouns() {
    char *s = calloc(9);
    if (crc32("QKsZUPdDOtPgIh",14) == 665807174) strcat(s, "m");
if (crc32("zXYjZpAhllDPN",13) == 1276602464) strcat(s, "i");
if (crc32("GTFjfWgSPeknPh",14) == 2194824895) strcat(s, "J");
if (crc32("JKNbwPHe",8) == 3539962289) strcat(s, "n");
if (crc32("kNcruNSpmMnxaz",14) == 3294776565) strcat(s, "i");
if (crc32("MrsFBOIQIZ",10) == 1740553698) strcat(s, "d");
if (crc32("EREMvQv",7) == 2043598715) strcat(s, "p");
if (crc32("YvTrDIWhk",9) == 2523894414) strcat(s, "i");
if (crc32("snxcbqJSB",9) == 3393240913) strcat(s, "Q");
if (crc32("jcVmkKOiMrBzSQ",14) == 979942852) strcat(s, "l");
if (crc32("AOvxZRkgTMO",11) == 3055980586) strcat(s, "b");
if (crc32("FdoCSdrsk",9) == 2850193208) strcat(s, "l");
    return s;
}

char *shanti_nouns() {
    char *s = calloc(7);
    if (crc32("RgJVdj",6) == 3958927292) strcat(s, "s");
if (crc32("HmXIVFvdccL",11) == 3389651515) strcat(s, "h");
if (crc32("RWLCnihH",8) == 3125169399) strcat(s, "h");
if (crc32("zPqryfj",7) == 429846076) strcat(s, "a");
if (crc32("ldKJSAp",7) == 3116343169) strcat(s, "x");
if (crc32("bAPzidvIT",9) == 3311450308) strcat(s, "n");
if (crc32("cRLkoKsRVev",11) == 501194977) strcat(s, "M");
if (crc32("uhNFIgaxMuypwRG",15) == 3211747756) strcat(s, "t");
if (crc32("ePURRgxUBQm",11) == 2879473376) strcat(s, "i");
    return s;
}

char *snowcreep_nouns() {
    char *s = calloc(10);
    if (crc32("HSfkIo",6) == 4092139293) strcat(s, "D");
if (crc32("WLyKvOXC",8) == 306314529) strcat(s, "s");
if (crc32("ncymYKHWKoVSpsM",15) == 3581268572) strcat(s, "n");
if (crc32("GktTqAQvKMQq",12) == 223017537) strcat(s, "X");
if (crc32("hWZUln",6) == 1926452262) strcat(s, "o");
if (crc32("uCIVhM",6) == 3726280319) strcat(s, "w");
if (crc32("KNKLWQBkwRH",11) == 1927851469) strcat(s, "c");
if (crc32("qvYpcKnRQEoQD",13) == 3845027781) strcat(s, "r");
if (crc32("nXgzREuhDzmh",12) == 63620013) strcat(s, "e");
if (crc32("eNiYTFwIPIeicJj",15) == 2283121334) strcat(s, "A");
if (crc32("dvGbY",5) == 3563954912) strcat(s, "e");
if (crc32("wGeWXXjtbjB",11) == 2074859932) strcat(s, "T");
if (crc32("xPGNCGvb",8) == 3933328021) strcat(s, "p");
    return s;
}

char *Dudden_nouns() {
    char *s = calloc(7);
    if (crc32("gccxkopqbPk",11) == 2796013253) strcat(s, "q");
if (crc32("PDlnWlBWG",9) == 3539717146) strcat(s, "D");
if (crc32("JgGAtGOb",8) == 2708850490) strcat(s, "u");
if (crc32("LhyaQIwiQRfbC",13) == 2024522775) strcat(s, "d");
if (crc32("NfEoZCrtNv",10) == 4022703132) strcat(s, "I");
if (crc32("wFfYEdzxEs",10) == 3541770694) strcat(s, "d");
if (crc32("ZmVdaYmPBnFFJw",14) == 3169967041) strcat(s, "e");
if (crc32("YmWNLTCq",8) == 1967388739) strcat(s, "n");
    return s;
}

char *Eden_nouns() {
    char *s = calloc(5);
    if (crc32("eeyFhFTtkCo",11) == 3309560935) strcat(s, "q");
if (crc32("LVLnsNkpYke",11) == 1269562303) strcat(s, "E");
if (crc32("AprUU",5) == 1127650860) strcat(s, "d");
if (crc32("xbunGVErlynMWVd",15) == 3297661181) strcat(s, "e");
if (crc32("VjOVYcyJVceA",12) == 133102201) strcat(s, "n");
    return s;
}

char *Belostok_nouns() {
    char *s = calloc(9);
    if (crc32("GcdovxqgUDhW",12) == 544280128) strcat(s, "B");
if (crc32("IEkIGuzjNwTnz",13) == 49435710) strcat(s, "e");
if (crc32("VdxzW",5) == 3205022177) strcat(s, "l");
if (crc32("CnpDy",5) == 3954540157) strcat(s, "o");
if (crc32("zTAmOboJHYMu",12) == 4271614669) strcat(s, "s");
if (crc32("VeCoHlvY",8) == 204248028) strcat(s, "R");
if (crc32("pgbNxKMFRFdThn",14) == 1781749486) strcat(s, "t");
if (crc32("NvfHBByFj",9) == 1230855640) strcat(s, "B");
if (crc32("nbYrBpUyfY",10) == 1376657134) strcat(s, "o");
if (crc32("lwKMeJJ",7) == 1401105380) strcat(s, "k");
    return s;
}

char *Gillingham_nouns() {
    char *s = calloc(11);
    if (crc32("eASxYtGJGlPfEVg",15) == 3146288043) strcat(s, "g");
if (crc32("AaekZF",6) == 1174754332) strcat(s, "G");
if (crc32("pQxkachkj",9) == 3915803164) strcat(s, "b");
if (crc32("fcaTiIPk",8) == 2659024539) strcat(s, "i");
if (crc32("AtWUlKtbGuQ",11) == 118706449) strcat(s, "l");
if (crc32("drNyoaR",7) == 4292781485) strcat(s, "I");
if (crc32("bszHHRUsEYVGBM",14) == 860374898) strcat(s, "l");
if (crc32("djieraaHP",9) == 1066869584) strcat(s, "Z");
if (crc32("WIVNy",5) == 2233404000) strcat(s, "i");
if (crc32("RpgIsItKOioCfY",14) == 119128456) strcat(s, "n");
if (crc32("pVAOcEcbPO",10) == 1275298907) strcat(s, "h");
if (crc32("QPfECEqLzjyS",12) == 1296566100) strcat(s, "g");
if (crc32("nVcKgCEQWa",10) == 1016335335) strcat(s, "d");
if (crc32("plQvOtYK",8) == 786190519) strcat(s, "h");
if (crc32("cMUZMGP",7) == 3487762761) strcat(s, "r");
if (crc32("oNyIgZtB",8) == 357105145) strcat(s, "a");
if (crc32("XKvgARITa",9) == 4122312758) strcat(s, "R");
if (crc32("TmwcSYrTeuTec",13) == 3667530178) strcat(s, "m");
    return s;
}

char *inaccuracy_nouns() {
    char *s = calloc(11);
    if (crc32("cIKBSoX",7) == 4168357131) strcat(s, "i");
if (crc32("JkDnQPDojv",10) == 237794238) strcat(s, "t");
if (crc32("bOzLMETtxDm",11) == 3108119419) strcat(s, "n");
if (crc32("FxkBhMdjYVuMdx",14) == 4037328890) strcat(s, "Z");
if (crc32("KoyBiLjcB",9) == 1590141291) strcat(s, "a");
if (crc32("PnCZbFhW",8) == 1339449480) strcat(s, "l");
if (crc32("bAlHBdnzg",9) == 210647487) strcat(s, "c");
if (crc32("GxPtsPsvOPttU",13) == 140652056) strcat(s, "d");
if (crc32("HGpgZQtXGMEh",12) == 368085013) strcat(s, "c");
if (crc32("VIeIFKFIDc",10) == 462503476) strcat(s, "u");
if (crc32("KPyRoIS",7) == 3531262850) strcat(s, "r");
if (crc32("iomMPHVlppkuYm",14) == 4001044356) strcat(s, "U");
if (crc32("yolfan",6) == 1842082982) strcat(s, "a");
if (crc32("uEPhlMYwos",10) == 2568465260) strcat(s, "c");
if (crc32("KndLtHFkpnybM",13) == 3710242601) strcat(s, "s");
if (crc32("XZYCHnw",7) == 3614930840) strcat(s, "y");
    return s;
}

char *erotology_nouns() {
    char *s = calloc(10);
    if (crc32("giPentpruTekg",13) == 4093700560) strcat(s, "H");
if (crc32("szaueYpUnYdbeGX",15) == 2277510929) strcat(s, "e");
if (crc32("YNrqWJLIwFXP",12) == 817519863) strcat(s, "j");
if (crc32("wCaRriUcKFaj",12) == 2636456104) strcat(s, "r");
if (crc32("GrfBrYxcDQAddXp",15) == 2140384303) strcat(s, "g");
if (crc32("IPAbt",5) == 691509616) strcat(s, "o");
if (crc32("SysEXqzaRRG",11) == 3203942515) strcat(s, "T");
if (crc32("laMrDQb",7) == 67672194) strcat(s, "t");
if (crc32("sterdwYuknVAOcS",15) == 807813264) strcat(s, "e");
if (crc32("tjJhsxPrFw",10) == 1699738088) strcat(s, "o");
if (crc32("IkxwmoyLlHfVjN",14) == 2623772383) strcat(s, "q");
if (crc32("yLOCcQCGxhdpwj",14) == 2771448337) strcat(s, "l");
if (crc32("YMQlMC",6) == 2913441040) strcat(s, "g");
if (crc32("lNEDjENuhtLH",12) == 4085743397) strcat(s, "o");
if (crc32("fxDgGpeBTrEryyl",15) == 438676451) strcat(s, "g");
if (crc32("WCnXz",5) == 1896156960) strcat(s, "o");
if (crc32("NgFCMODDoJXIQV",14) == 1957315396) strcat(s, "y");
    return s;
}

char *batsman_nouns() {
    char *s = calloc(8);
    if (crc32("EddipiWdFrX",11) == 737478021) strcat(s, "b");
if (crc32("RvdqAXYSpnHPuY",14) == 2790417841) strcat(s, "a");
if (crc32("urVayJ",6) == 572604964) strcat(s, "b");
if (crc32("LtQAaSZAzPrLZT",14) == 629966743) strcat(s, "t");
if (crc32("oetIRInjk",9) == 1851526483) strcat(s, "s");
if (crc32("sGgApqGQJEcX",12) == 1968771386) strcat(s, "m");
if (crc32("oeYiPzHH",8) == 3624447156) strcat(s, "a");
if (crc32("hSbaiT",6) == 718619155) strcat(s, "n");
    return s;
}

char *induc_nouns() {
    char *s = calloc(6);
    if (crc32("VbosTiqiwvgVT",13) == 4043792190) strcat(s, "i");
if (crc32("OrOinNxo",8) == 134793426) strcat(s, "J");
if (crc32("wXzpPqXSpn",10) == 3257338639) strcat(s, "n");
if (crc32("SypSOlK",7) == 3588664149) strcat(s, "N");
if (crc32("PkiSQHbG",8) == 1538700944) strcat(s, "d");
if (crc32("omBTocDyRykMXTM",15) == 481123108) strcat(s, "f");
if (crc32("HabZZSzALd",10) == 2180724535) strcat(s, "u");
if (crc32("jBvED",5) == 2933515858) strcat(s, "e");
if (crc32("DCefybEhqWNgwpH",15) == 2775133896) strcat(s, "c");
    return s;
}

char *nonrival_nouns() {
    char *s = calloc(9);
    if (crc32("VVVegWvltYd",11) == 4234367623) strcat(s, "n");
if (crc32("YGIavowNlOBwygK",15) == 3628020174) strcat(s, "H");
if (crc32("SdeABgulYO",10) == 870681931) strcat(s, "o");
if (crc32("KowmiayUoWykJ",13) == 1137758594) strcat(s, "L");
if (crc32("yOcUVJkhc",9) == 3528329699) strcat(s, "n");
if (crc32("OdesRmnH",8) == 2925491193) strcat(s, "r");
if (crc32("cbQfc",5) == 66944332) strcat(s, "i");
if (crc32("vfrfqw",6) == 2646319398) strcat(s, "O");
if (crc32("YkGvNI",6) == 1139036441) strcat(s, "v");
if (crc32("XZBAKFObNHNEEw",14) == 163601986) strcat(s, "a");
if (crc32("JjNCfLXp",8) == 495386183) strcat(s, "F");
if (crc32("sSbUNTo",7) == 2886332543) strcat(s, "l");
    return s;
}

char *acetaldol_nouns() {
    char *s = calloc(10);
    if (crc32("CWqhcOy",7) == 1830140823) strcat(s, "M");
if (crc32("TCtjQUlZej",10) == 564237015) strcat(s, "a");
if (crc32("afLzSJot",8) == 1262837501) strcat(s, "c");
if (crc32("sHNNOrtYt",9) == 2152031205) strcat(s, "e");
if (crc32("LdEuGonTMzvU",12) == 2678158702) strcat(s, "t");
if (crc32("xAzUvyi",7) == 1404145828) strcat(s, "a");
if (crc32("ZVeJnQOjMUOpeNR",15) == 259855707) strcat(s, "v");
if (crc32("YPZBuB",6) == 3211013168) strcat(s, "l");
if (crc32("XUSUSVbopZdyreX",15) == 441225509) strcat(s, "d");
if (crc32("KnPdqaPzwaSZLyQ",15) == 1115354470) strcat(s, "o");
if (crc32("rdMITxhEJsV",11) == 3267281707) strcat(s, "l");
    return s;
}

char *baddie_nouns() {
    char *s = calloc(7);
    if (crc32("EXMCAuDpDUTvv",13) == 3750383513) strcat(s, "o");
if (crc32("jKZUBfPnhkmTy",13) == 3131728317) strcat(s, "b");
if (crc32("YEOFml",6) == 3126807144) strcat(s, "q");
if (crc32("GHkczmxwjD",10) == 401887868) strcat(s, "a");
if (crc32("nbIiMo",6) == 1494106429) strcat(s, "d");
if (crc32("qfhgHTHbtCe",11) == 1673658914) strcat(s, "Z");
if (crc32("YImAf",5) == 411152202) strcat(s, "d");
if (crc32("gWDIgumX",8) == 3648813725) strcat(s, "i");
if (crc32("PcvpwerRV",9) == 1415534231) strcat(s, "e");
    return s;
}

char *sagger_nouns() {
    char *s = calloc(7);
    if (crc32("ObOkKwLBxOTqrXu",15) == 3672803330) strcat(s, "d");
if (crc32("pVmKDVBeTFWVO",13) == 282804349) strcat(s, "s");
if (crc32("FArZm",5) == 370897321) strcat(s, "a");
if (crc32("auVCFxikobVtYlp",15) == 2609287151) strcat(s, "g");
if (crc32("ZxNykoV",7) == 681789565) strcat(s, "g");
if (crc32("iCzHSkMQ",8) == 3655262869) strcat(s, "e");
if (crc32("PFbFHCFan",9) == 2987428375) strcat(s, "m");
if (crc32("lLcZFZjvwsbz",12) == 2812117950) strcat(s, "r");
    return s;
}

char *specification_nouns() {
    char *s = calloc(14);
    if (crc32("TGGLRPFPCtmss",13) == 168960733) strcat(s, "f");
if (crc32("mXHeJMjrAXeWE",13) == 1642801145) strcat(s, "s");
if (crc32("lDbQXfocAzPlCD",14) == 378680190) strcat(s, "p");
if (crc32("sZaFHIcs",8) == 1920225418) strcat(s, "e");
if (crc32("DEAcz",5) == 1220797994) strcat(s, "c");
if (crc32("IGjCoPwNuEJ",11) == 3171981569) strcat(s, "k");
if (crc32("SzTnlPSHFH",10) == 3773926157) strcat(s, "i");
if (crc32("bZmCJtYRknZxjy",14) == 2351842794) strcat(s, "g");
if (crc32("RnJtVFdEDCh",11) == 1359965175) strcat(s, "f");
if (crc32("tdKBuCX",7) == 3838767199) strcat(s, "i");
if (crc32("WCiMrgLtQCsngrb",15) == 3342369092) strcat(s, "c");
if (crc32("CPAXVvKTcrBxJ",13) == 3556971390) strcat(s, "L");
if (crc32("uJhitmtTMZeiD",13) == 1405499579) strcat(s, "a");
if (crc32("xcdPAMAzscu",11) == 1237099495) strcat(s, "t");
if (crc32("ffhIfSE",7) == 1065577927) strcat(s, "i");
if (crc32("JgfyqxvMLE",10) == 678517950) strcat(s, "J");
if (crc32("yDuzkUOcCBts",12) == 1968893216) strcat(s, "o");
if (crc32("dAZpZetbPy",10) == 4117657065) strcat(s, "K");
if (crc32("PcVTgirfyLo",11) == 3751349997) strcat(s, "n");
    return s;
}

char *bearbush_nouns() {
    char *s = calloc(9);
    if (crc32("NnQlLVKlpeE",11) == 2409152686) strcat(s, "b");
if (crc32("iYOnzZoLxSySfg",14) == 2023082680) strcat(s, "e");
if (crc32("ggGXlYFajrKDjU",14) == 2405187131) strcat(s, "e");
if (crc32("xIqgerKkW",9) == 1533267176) strcat(s, "a");
if (crc32("mBgFSPpsW",9) == 2799636572) strcat(s, "r");
if (crc32("bcNQHiJ",7) == 690756607) strcat(s, "n");
if (crc32("KxrPZKTjEjuiF",13) == 945838239) strcat(s, "b");
if (crc32("NtWXxJXH",8) == 2165954896) strcat(s, "u");
if (crc32("mNVbjXlKs",9) == 880549107) strcat(s, "s");
if (crc32("qrYPMVQyVROo",12) == 3206077388) strcat(s, "h");
    return s;
}

char *formularization_nouns() {
    char *s = calloc(16);
    if (crc32("hhVVFgtEHWbKcEm",15) == 794237121) strcat(s, "K");
if (crc32("sysMzStVdc",10) == 700170653) strcat(s, "f");
if (crc32("tydICeCih",9) == 2941009160) strcat(s, "v");
if (crc32("rQtOTanxWkRb",12) == 3397738981) strcat(s, "o");
if (crc32("NEcuHPMtLQo",11) == 1613787328) strcat(s, "B");
if (crc32("sUsKyTyrEbyrnL",14) == 1637282893) strcat(s, "r");
if (crc32("kmxAirdUOUmk",12) == 3479903047) strcat(s, "W");
if (crc32("XZVbs",5) == 2617763696) strcat(s, "m");
if (crc32("dvvVmf",6) == 114459973) strcat(s, "u");
if (crc32("NHpqtpEZC",9) == 1330358705) strcat(s, "r");
if (crc32("wilKoWgYx",9) == 2707540013) strcat(s, "l");
if (crc32("iDEhO",5) == 2069946318) strcat(s, "a");
if (crc32("GsjmNGJFYwcSoQK",15) == 753619053) strcat(s, "g");
if (crc32("LOtOOeC",7) == 2742367131) strcat(s, "r");
if (crc32("ialMNYCXEZshLH",14) == 1204921267) strcat(s, "h");
if (crc32("TrPwHORpmWH",11) == 3899619010) strcat(s, "i");
if (crc32("KJWWyeugA",9) == 4293977414) strcat(s, "A");
if (crc32("mOZewAApXzI",11) == 3139019392) strcat(s, "z");
if (crc32("mvtjjR",6) == 2375024813) strcat(s, "Y");
if (crc32("njEBmmHztv",10) == 2000397697) strcat(s, "a");
if (crc32("BTqyu",5) == 4100661473) strcat(s, "f");
if (crc32("wQwxZBoQPAUT",12) == 937777119) strcat(s, "t");
if (crc32("NKbwiDoGrAuReni",15) == 2355936672) strcat(s, "t");
if (crc32("moeOpkQuGbAvKkk",15) == 2076977708) strcat(s, "i");
if (crc32("yDRYxtUtthe",11) == 2541962648) strcat(s, "N");
if (crc32("jGCwLkarom",10) == 2190504756) strcat(s, "o");
if (crc32("zpUNiqtrLU",10) == 3827102750) strcat(s, "n");
    return s;
}

char *leftover_nouns() {
    char *s = calloc(9);
    if (crc32("yJBPzD",6) == 2003956215) strcat(s, "n");
if (crc32("RWQMebIpcjCzQYG",15) == 91605892) strcat(s, "l");
if (crc32("aiLogp",6) == 3146074273) strcat(s, "F");
if (crc32("xyyWgH",6) == 2400079696) strcat(s, "e");
if (crc32("kVgmhvmgl",9) == 4131149432) strcat(s, "X");
if (crc32("AhjTMGwcZ",9) == 2789729161) strcat(s, "f");
if (crc32("yYpAcKYvt",9) == 3617475576) strcat(s, "I");
if (crc32("dvNtQPwUPKlDtR",14) == 3514232200) strcat(s, "t");
if (crc32("pdCtRaYGXEwE",12) == 1959181448) strcat(s, "F");
if (crc32("BDAHRaYXwdiysR",14) == 2169709427) strcat(s, "o");
if (crc32("YHmPmj",6) == 2472573080) strcat(s, "x");
if (crc32("oOJxKdMaluHAETV",15) == 460918084) strcat(s, "v");
if (crc32("hDrBX",5) == 1197648786) strcat(s, "l");
if (crc32("lagyWEwrBkVe",12) == 3501142332) strcat(s, "e");
if (crc32("aRoqwQ",6) == 2606176748) strcat(s, "u");
if (crc32("fhewHKoUgcEJXMh",15) == 529166880) strcat(s, "r");
    return s;
}

char *Tomkins_nouns() {
    char *s = calloc(8);
    if (crc32("lofjenxvYA",10) == 2024219685) strcat(s, "T");
if (crc32("WRzyE",5) == 2352527817) strcat(s, "o");
if (crc32("RxdNTFnZwnjrfI",14) == 144477782) strcat(s, "m");
if (crc32("xYVyLbJMi",9) == 2343270248) strcat(s, "k");
if (crc32("iKrnEwxd",8) == 2741213188) strcat(s, "R");
if (crc32("hcptk",5) == 2201091854) strcat(s, "i");
if (crc32("RrdBgOPdCbuE",12) == 3152986940) strcat(s, "n");
if (crc32("FVKzHp",6) == 2722559026) strcat(s, "s");
    return s;
}

char *Turkism_nouns() {
    char *s = calloc(8);
    if (crc32("ksqgkHXNDOjR",12) == 1773328754) strcat(s, "K");
if (crc32("nuSPi",5) == 1559132894) strcat(s, "T");
if (crc32("aWmcdJyXFVlgtpY",15) == 2611278818) strcat(s, "I");
if (crc32("eCGXdOPUt",9) == 1698922308) strcat(s, "u");
if (crc32("oJrXUZsHDw",10) == 84049045) strcat(s, "r");
if (crc32("GRVVFqhuitSzW",13) == 2998132022) strcat(s, "Y");
if (crc32("JZWKrqHTHq",10) == 1013905415) strcat(s, "k");
if (crc32("GizadfhNdGpoNXj",15) == 4030250673) strcat(s, "O");
if (crc32("VlzQeHe",7) == 703071594) strcat(s, "i");
if (crc32("rqIDwOOOSdm",11) == 2581151603) strcat(s, "s");
if (crc32("zMMLKtmQvNXjyJ",14) == 1354180754) strcat(s, "J");
if (crc32("EztqUmxGazkErbH",15) == 728751045) strcat(s, "m");
    return s;
}

char *Neufchetel_nouns() {
    char *s = calloc(11);
    if (crc32("lPNhkNlrN",9) == 2707569214) strcat(s, "N");
if (crc32("RPDFb",5) == 2832712519) strcat(s, "A");
if (crc32("rmPan",5) == 908874597) strcat(s, "e");
if (crc32("VcJQbdyDrxlxku",14) == 4229792245) strcat(s, "v");
if (crc32("BDLuqqgmA",9) == 3906979720) strcat(s, "u");
if (crc32("yRaJmmkJe",9) == 111351508) strcat(s, "u");
if (crc32("UJBjnX",6) == 357644704) strcat(s, "f");
if (crc32("vIvWRN",6) == 118808947) strcat(s, "c");
if (crc32("NbaZfbqtR",9) == 4263195669) strcat(s, "h");
if (crc32("LYnrfnmrAwEe",12) == 1686199962) strcat(s, "e");
if (crc32("UnnIaLebnyUTFz",14) == 795351842) strcat(s, "t");
if (crc32("QQjfsBL",7) == 1275821467) strcat(s, "o");
if (crc32("PbYZdiFaIruqJGc",15) == 1943725597) strcat(s, "e");
if (crc32("IYWxFO",6) == 3773754828) strcat(s, "l");
    return s;
}

char *ribbon_nouns() {
    char *s = calloc(7);
    if (crc32("fqzCComHE",9) == 1783719812) strcat(s, "r");
if (crc32("mSNDhDWMVDXcU",13) == 2510477147) strcat(s, "i");
if (crc32("VWeBRNqbRAo",11) == 1390061543) strcat(s, "b");
if (crc32("yEINdnkCqRxoO",13) == 3840343227) strcat(s, "Q");
if (crc32("IVFPw",5) == 2104153570) strcat(s, "b");
if (crc32("PWKrNl",6) == 115447413) strcat(s, "o");
if (crc32("vasYrWPEiCG",11) == 612279281) strcat(s, "F");
if (crc32("nGVjLdOuX",9) == 3722657353) strcat(s, "n");
    return s;
}

char *cura_nouns() {
    char *s = calloc(5);
    if (crc32("dcVQZUJABf",10) == 1375570341) strcat(s, "f");
if (crc32("LbQlwcDzEy",10) == 3782316899) strcat(s, "c");
if (crc32("pFXKBSYwep",10) == 625795085) strcat(s, "L");
if (crc32("uExRw",5) == 1205129740) strcat(s, "u");
if (crc32("eJNjhtXm",8) == 394889896) strcat(s, "r");
if (crc32("UiWteXcQClFNfVt",15) == 4028377911) strcat(s, "F");
if (crc32("qZOTLogQPviv",12) == 2604855187) strcat(s, "a");
    return s;
}

char *crepuscle_nouns() {
    char *s = calloc(10);
    if (crc32("aLMstMzNsrBbR",13) == 1437853340) strcat(s, "c");
if (crc32("DcIwRhmdsREj",12) == 917685557) strcat(s, "r");
if (crc32("OQKcWT",6) == 3586591578) strcat(s, "e");
if (crc32("wOkuUwOYkRbf",12) == 2320022729) strcat(s, "r");
if (crc32("kCXntQIIIbeXdye",15) == 4292525144) strcat(s, "p");
if (crc32("qcixjCxF",8) == 130145830) strcat(s, "u");
if (crc32("MEKdCBjMPPLhsan",15) == 2058266321) strcat(s, "x");
if (crc32("KTuWUsDVVl",10) == 2654962948) strcat(s, "s");
if (crc32("dqHvcDdx",8) == 1061716516) strcat(s, "N");
if (crc32("RvYHCFKhl",9) == 2971093673) strcat(s, "c");
if (crc32("sRLeA",5) == 2666119478) strcat(s, "Y");
if (crc32("kmMsVmoWtc",10) == 647161838) strcat(s, "l");
if (crc32("EnNdbFqf",8) == 4215651770) strcat(s, "S");
if (crc32("zRbhCpB",7) == 1281583349) strcat(s, "e");
    return s;
}

char *Lumbard_nouns() {
    char *s = calloc(8);
    if (crc32("zZoGIrGNy",9) == 2397230666) strcat(s, "L");
if (crc32("zBZcTQPLwjt",11) == 872445651) strcat(s, "u");
if (crc32("cibrgAOrJ",9) == 4009496155) strcat(s, "m");
if (crc32("LwhFi",5) == 2034266519) strcat(s, "b");
if (crc32("HIQuapJg",8) == 1043903678) strcat(s, "d");
if (crc32("NHrBakodDR",10) == 737388564) strcat(s, "a");
if (crc32("BPShoK",6) == 767356806) strcat(s, "n");
if (crc32("jeJabQuhlMyQ",12) == 1414621756) strcat(s, "r");
if (crc32("GLXKoVbiOkwpDc",14) == 1123664765) strcat(s, "d");
    return s;
}

char *Rhodope_nouns() {
    char *s = calloc(8);
    if (crc32("AYbAbvmLLDjo",12) == 1511646535) strcat(s, "v");
if (crc32("HYOZapx",7) == 2280570094) strcat(s, "R");
if (crc32("QPJjLNmnZDzgqkM",15) == 3993092907) strcat(s, "E");
if (crc32("oOyZhmVHnrOZ",12) == 2724922594) strcat(s, "h");
if (crc32("pIpQTwyOWZmrcz",14) == 3133540695) strcat(s, "o");
if (crc32("wbRekUrcjkpaU",13) == 559067926) strcat(s, "d");
if (crc32("fGLUYxN",7) == 325606651) strcat(s, "o");
if (crc32("KRSMKoUhIL",10) == 2727087804) strcat(s, "s");
if (crc32("VRKKHgCSaKbswW",14) == 1830690014) strcat(s, "p");
if (crc32("GiRVbzeHQWHVZi",14) == 3137607777) strcat(s, "o");
if (crc32("VUbtTEyehmz",11) == 2823559531) strcat(s, "e");
    return s;
}

char *Adelaide_nouns() {
    char *s = calloc(9);
    if (crc32("kIwqxMeQyjzdCo",14) == 1528566815) strcat(s, "S");
if (crc32("gybihiJQrnTSr",13) == 4079543199) strcat(s, "A");
if (crc32("PydXZQEfwIc",11) == 2413602086) strcat(s, "Z");
if (crc32("MhhKreUEcm",10) == 3391003802) strcat(s, "d");
if (crc32("cDytmwAeetSkgAH",15) == 3127772951) strcat(s, "y");
if (crc32("yZscvAh",7) == 606019625) strcat(s, "e");
if (crc32("ZOkvDVEtzyDujU",14) == 2126163827) strcat(s, "x");
if (crc32("OCrebySgp",9) == 2188940563) strcat(s, "l");
if (crc32("NKcwPhtOhyE",11) == 4232109414) strcat(s, "a");
if (crc32("cGPKHM",6) == 1384041901) strcat(s, "i");
if (crc32("oZiPQAkt",8) == 428530065) strcat(s, "Y");
if (crc32("WPNSYsNY",8) == 3473543164) strcat(s, "d");
if (crc32("EKLjeUROcVR",11) == 288393929) strcat(s, "b");
if (crc32("MPYCgFGeQnDmmMK",15) == 4039704962) strcat(s, "e");
    return s;
}

char *Octavia_nouns() {
    char *s = calloc(8);
    if (crc32("vJJKnUjqyKQg",12) == 3173974020) strcat(s, "Q");
if (crc32("zsFShaISBlHeNR",14) == 2557036680) strcat(s, "O");
if (crc32("vQXdO",5) == 1615624365) strcat(s, "x");
if (crc32("CSjoqXnzoqkr",12) == 1732453714) strcat(s, "c");
if (crc32("xacxRgn",7) == 156354366) strcat(s, "m");
if (crc32("xWToSBzMGTLe",12) == 901169305) strcat(s, "t");
if (crc32("fUkYuU",6) == 2152734078) strcat(s, "F");
if (crc32("lwsiTfQF",8) == 3860285884) strcat(s, "a");
if (crc32("GTkQFJgqjEk",11) == 3041064315) strcat(s, "v");
if (crc32("CquUipXhbQfveZB",15) == 2049290372) strcat(s, "v");
if (crc32("iSeQOiMqCBYyvs",14) == 3343615667) strcat(s, "O");
if (crc32("DLGPOXjxXijQU",13) == 4257074771) strcat(s, "i");
if (crc32("DwdcyUNOAL",10) == 2075638112) strcat(s, "n");
if (crc32("POVZryCwJgkpB",13) == 862427448) strcat(s, "a");
    return s;
}

char *popgun_nouns() {
    char *s = calloc(7);
    if (crc32("NbzYg",5) == 519590316) strcat(s, "O");
if (crc32("RzZHIwTsLr",10) == 459184838) strcat(s, "p");
if (crc32("fnrDyfXwjC",10) == 3766261131) strcat(s, "o");
if (crc32("UxDSUkyFZNV",11) == 3270352189) strcat(s, "O");
if (crc32("ojSEQWPHKpzwWWM",15) == 1964887565) strcat(s, "p");
if (crc32("UdjGIAjaPyTAm",13) == 436222617) strcat(s, "g");
if (crc32("GSZOS",5) == 299969514) strcat(s, "u");
if (crc32("jJLpJ",5) == 566199668) strcat(s, "n");
    return s;
}

char *Derward_nouns() {
    char *s = calloc(8);
    if (crc32("FEIqF",5) == 3743311420) strcat(s, "l");
if (crc32("QwnpdCkAGTNMsT",14) == 2009350247) strcat(s, "D");
if (crc32("jaoarX",6) == 2370639069) strcat(s, "v");
if (crc32("wxieRqqeW",9) == 1653581256) strcat(s, "e");
if (crc32("lFCbcz",6) == 632654768) strcat(s, "r");
if (crc32("FaCoZQcvlAogmA",14) == 1669650831) strcat(s, "B");
if (crc32("quQHrEcYibvNC",13) == 436942013) strcat(s, "w");
if (crc32("xiFQjIpbn",9) == 4159106851) strcat(s, "c");
if (crc32("gvKeOPZD",8) == 2597832644) strcat(s, "a");
if (crc32("qUhmCBLmluWLXMl",15) == 2684879618) strcat(s, "r");
if (crc32("uLBOMeirB",9) == 1027934597) strcat(s, "u");
if (crc32("gfdxOX",6) == 1320603420) strcat(s, "d");
    return s;
}

char *selfsustentation_nouns() {
    char *s = calloc(17);
    if (crc32("DQdgodfHIwnrRTN",15) == 2194839972) strcat(s, "b");
if (crc32("SLNlR",5) == 1585058106) strcat(s, "s");
if (crc32("AsMlwGK",7) == 106252585) strcat(s, "e");
if (crc32("jEBTZXzNLO",10) == 1815585042) strcat(s, "e");
if (crc32("ZFaysOYfJUNF",12) == 3877675315) strcat(s, "O");
if (crc32("ZNbabfttzILGy",13) == 2247361370) strcat(s, "l");
if (crc32("SSxXBgZfSXeI",12) == 3553421309) strcat(s, "R");
if (crc32("sRdWlxoRHVwI",12) == 2091992946) strcat(s, "f");
if (crc32("hAdAlOcp",8) == 1715858689) strcat(s, "s");
if (crc32("iehiyz",6) == 944927442) strcat(s, "u");
if (crc32("keZLrXXy",8) == 3387036805) strcat(s, "n");
if (crc32("fTlLhOZHYuMoMu",14) == 3095042266) strcat(s, "s");
if (crc32("MWNsjmoyXooLs",13) == 457354849) strcat(s, "I");
if (crc32("LLaGYvKg",8) == 2548201887) strcat(s, "t");
if (crc32("KRICUfpoJxoaxIh",15) == 878553029) strcat(s, "t");
if (crc32("IjnsFmNnc",9) == 3356623200) strcat(s, "e");
if (crc32("hzXbOHb",7) == 4128917341) strcat(s, "n");
if (crc32("sIjpBeDE",8) == 3446295676) strcat(s, "Q");
if (crc32("WpsJAnP",7) == 3685406698) strcat(s, "t");
if (crc32("JVZFqVkmLwRq",12) == 1051264095) strcat(s, "a");
if (crc32("uSqhkzqLio",10) == 2349783221) strcat(s, "K");
if (crc32("DLfhULOTyh",10) == 917921247) strcat(s, "t");
if (crc32("kmsfIonotvsk",12) == 3974291383) strcat(s, "D");
if (crc32("jBnNmbCFtJQbuIh",15) == 731771592) strcat(s, "i");
if (crc32("UYjmyUaUx",9) == 3609164659) strcat(s, "o");
if (crc32("koOebNOYr",9) == 3976402282) strcat(s, "n");
    return s;
}

char *Tsan_nouns() {
    char *s = calloc(5);
    if (crc32("DRcRCfitdAwz",12) == 2004462714) strcat(s, "T");
if (crc32("GWGCARpJpsFPfXR",15) == 1848481082) strcat(s, "v");
if (crc32("HbhOgdecgBPmNo",14) == 3117171348) strcat(s, "s");
if (crc32("WgJBWrp",7) == 1766765958) strcat(s, "a");
if (crc32("bugOMtlYd",9) == 88546192) strcat(s, "m");
if (crc32("EbKRlwLgsq",10) == 2730461652) strcat(s, "n");
    return s;
}

char *subelement_nouns() {
    char *s = calloc(11);
    if (crc32("kQECEzHJPJUcap",14) == 142009979) strcat(s, "B");
if (crc32("GmSIpjjZLD",10) == 4170681727) strcat(s, "s");
if (crc32("jelOItm",7) == 2207277212) strcat(s, "a");
if (crc32("Izubq",5) == 3048239081) strcat(s, "u");
if (crc32("mSMepXiut",9) == 2101668878) strcat(s, "Q");
if (crc32("BJAurCJTTS",10) == 2198742005) strcat(s, "b");
if (crc32("tDzXy",5) == 3705376058) strcat(s, "e");
if (crc32("npWgwNckpbV",11) == 628061099) strcat(s, "U");
if (crc32("DoHosLQBYKr",11) == 518288121) strcat(s, "l");
if (crc32("VxRuhQnenpyA",12) == 2114571801) strcat(s, "e");
if (crc32("lOJjCb",6) == 3713420039) strcat(s, "m");
if (crc32("RGVlEjJJflAmO",13) == 3270898706) strcat(s, "e");
if (crc32("Npfhhtvu",8) == 919751669) strcat(s, "n");
if (crc32("OEypJj",6) == 988309164) strcat(s, "t");
    return s;
}

char *cone_nouns() {
    char *s = calloc(5);
    if (crc32("sBkdEu",6) == 283113704) strcat(s, "c");
if (crc32("agXupFAED",9) == 4137692505) strcat(s, "o");
if (crc32("dwFZA",5) == 4190569468) strcat(s, "r");
if (crc32("VdgGMDIgkt",10) == 1776125668) strcat(s, "n");
if (crc32("rjwZtqWdBfxNvGw",15) == 3183451480) strcat(s, "e");
    return s;
}

char *Beisel_nouns() {
    char *s = calloc(7);
    if (crc32("gVTPHKEyYSHPT",13) == 2985110978) strcat(s, "B");
if (crc32("PRqpxfeJl",9) == 352647131) strcat(s, "e");
if (crc32("FkHXfooWKhNgluf",15) == 834092808) strcat(s, "i");
if (crc32("XdXIDIASXHhm",12) == 3795412498) strcat(s, "D");
if (crc32("JYLuyARtaApGaV",14) == 4237880473) strcat(s, "s");
if (crc32("ILemiSuhcUyhp",13) == 4030796330) strcat(s, "e");
if (crc32("eoVsOAoxltLEzd",14) == 2133601913) strcat(s, "l");
    return s;
}

char *elastin_nouns() {
    char *s = calloc(8);
    if (crc32("vYYEnP",6) == 60154916) strcat(s, "O");
if (crc32("TdKoKQtEuuAuTl",14) == 525157202) strcat(s, "e");
if (crc32("tkCAKnsBo",9) == 3390038680) strcat(s, "l");
if (crc32("aqghh",5) == 304528249) strcat(s, "a");
if (crc32("KwwULjj",7) == 831749892) strcat(s, "s");
if (crc32("lsAERqQS",8) == 4163887770) strcat(s, "V");
if (crc32("pNfsEztDvLAlC",13) == 472083142) strcat(s, "t");
if (crc32("klzRIxloGigIKv",14) == 757928947) strcat(s, "j");
if (crc32("oKhXEIkHob",10) == 1435814926) strcat(s, "i");
if (crc32("pUKYqeoNzeIJPJ",14) == 859509792) strcat(s, "n");
    return s;
}

char *Jala_nouns() {
    char *s = calloc(5);
    if (crc32("qazOlOcdnc",10) == 3537360540) strcat(s, "J");
if (crc32("GLHNhb",6) == 986313425) strcat(s, "a");
if (crc32("oMAeQmTDy",9) == 2001232275) strcat(s, "a");
if (crc32("dUjERVgW",8) == 2945769505) strcat(s, "l");
if (crc32("PRNPtdc",7) == 3123313497) strcat(s, "m");
if (crc32("qRqZaqormIvO",12) == 535831589) strcat(s, "a");
    return s;
}

char *Hoebart_nouns() {
    char *s = calloc(8);
    if (crc32("xgmdrvwDv",9) == 1584182191) strcat(s, "A");
if (crc32("RKrWkyUcHLIbid",14) == 727117567) strcat(s, "H");
if (crc32("wTFNd",5) == 2576180623) strcat(s, "o");
if (crc32("iNnBKYbFrnvnOhE",15) == 249664110) strcat(s, "Y");
if (crc32("YSLDDcVb",8) == 4179996805) strcat(s, "e");
if (crc32("qVuOpPbjLFFFt",13) == 3984056685) strcat(s, "b");
if (crc32("IqInqJTygfhuf",13) == 2271881405) strcat(s, "V");
if (crc32("VQbOLuJ",7) == 2281694590) strcat(s, "a");
if (crc32("HycUY",5) == 3343030898) strcat(s, "w");
if (crc32("fiLCkcwHOlHJfN",14) == 3896243079) strcat(s, "r");
if (crc32("WDlXqMUjKrCbABE",15) == 576555308) strcat(s, "t");
    return s;
}

char *oatmeal_nouns() {
    char *s = calloc(8);
    if (crc32("wyYRtFgRgfPB",12) == 685897829) strcat(s, "u");
if (crc32("JNkwowgO",8) == 514782415) strcat(s, "o");
if (crc32("kbPnuqq",7) == 4044850541) strcat(s, "a");
if (crc32("RHcZwgbjjt",10) == 3974966364) strcat(s, "e");
if (crc32("LECzaAQlnfVIt",13) == 1549061283) strcat(s, "t");
if (crc32("ACyPYFsp",8) == 2009926511) strcat(s, "m");
if (crc32("ydHhy",5) == 2094064056) strcat(s, "e");
if (crc32("qjfBQ",5) == 3295859314) strcat(s, "a");
if (crc32("UFEsUVZdcU",10) == 2156239) strcat(s, "h");
if (crc32("FfDgxRiwctXMUPG",15) == 3068273793) strcat(s, "l");
    return s;
}

char *platitudiniser_nouns() {
    char *s = calloc(15);
    if (crc32("vtBdVPCpN",9) == 2852171746) strcat(s, "m");
if (crc32("VmKaqffQaX",10) == 536040081) strcat(s, "p");
if (crc32("vjQxPSTrvatQkFG",15) == 3267268911) strcat(s, "y");
if (crc32("RQNhhlYyFBpNIx",14) == 773140477) strcat(s, "l");
if (crc32("UlsimK",6) == 4269915737) strcat(s, "N");
if (crc32("PILxEgpO",8) == 2023828801) strcat(s, "a");
if (crc32("qQaMtyRIVlOM",12) == 4187625349) strcat(s, "t");
if (crc32("QMxKaFC",7) == 2909751772) strcat(s, "h");
if (crc32("lGpkow",6) == 664730993) strcat(s, "i");
if (crc32("kTAOjwXXXo",10) == 3032903464) strcat(s, "D");
if (crc32("EcwZtCANCHtILg",14) == 1906733915) strcat(s, "t");
if (crc32("bBZLVDfS",8) == 3253772510) strcat(s, "A");
if (crc32("YZTOAP",6) == 1430278734) strcat(s, "u");
if (crc32("WmwyOlBLBN",10) == 1936791858) strcat(s, "d");
if (crc32("MNIFBGSZF",9) == 942221957) strcat(s, "I");
if (crc32("orOEltHwHgdIdxo",15) == 56901769) strcat(s, "i");
if (crc32("AkOBWxWYL",9) == 199907787) strcat(s, "n");
if (crc32("JXwDcCGlkT",10) == 1987944934) strcat(s, "c");
if (crc32("YjVLOAdmGzWE",12) == 2822753760) strcat(s, "i");
if (crc32("ejnNocidg",9) == 4173144596) strcat(s, "s");
if (crc32("mvtsFltsk",9) == 2671957542) strcat(s, "e");
if (crc32("rfhrG",5) == 430375114) strcat(s, "n");
if (crc32("vSGLiF",6) == 1204410895) strcat(s, "r");
    return s;
}

char *bronzing_nouns() {
    char *s = calloc(9);
    if (crc32("CQpeSBpWPfHHmi",14) == 188433490) strcat(s, "b");
if (crc32("LPzHskJAVa",10) == 1876669929) strcat(s, "r");
if (crc32("KEGNuYfMdf",10) == 503419849) strcat(s, "q");
if (crc32("EIOijEE",7) == 4051560892) strcat(s, "o");
if (crc32("hQULvAsfIikjiMi",15) == 189225825) strcat(s, "n");
if (crc32("FhAAPHekVs",10) == 915375325) strcat(s, "k");
if (crc32("ujCVAXSij",9) == 2930390204) strcat(s, "z");
if (crc32("fakuM",5) == 128488424) strcat(s, "I");
if (crc32("skPOeMSjvkH",11) == 1220369422) strcat(s, "i");
if (crc32("DgGSneYLJO",10) == 2222593592) strcat(s, "G");
if (crc32("VsdvJpL",7) == 1600204298) strcat(s, "n");
if (crc32("iJToJwKxm",9) == 1918504526) strcat(s, "t");
if (crc32("hlTrKTmpTYoEPik",15) == 4038329207) strcat(s, "g");
    return s;
}

char *conto_nouns() {
    char *s = calloc(6);
    if (crc32("skzlNZH",7) == 3668574571) strcat(s, "m");
if (crc32("HZJUG",5) == 1483243111) strcat(s, "c");
if (crc32("QPPPBoWwBzB",11) == 852059472) strcat(s, "f");
if (crc32("CyrZJuwavCMI",12) == 1855985628) strcat(s, "o");
if (crc32("QPkngcrJe",9) == 3246615171) strcat(s, "p");
if (crc32("dajYnewF",8) == 3926537616) strcat(s, "n");
if (crc32("DlHTtkJwq",9) == 1778754860) strcat(s, "T");
if (crc32("iaIinIGlVd",10) == 733043610) strcat(s, "t");
if (crc32("TOxFBNvmbney",12) == 2741542131) strcat(s, "b");
if (crc32("RFbpgV",6) == 1247673295) strcat(s, "o");
    return s;
}

char *narcosynthesis_nouns() {
    char *s = calloc(15);
    if (crc32("MjjAsuebGCIpFZa",15) == 3950427443) strcat(s, "n");
if (crc32("TdJUBiPLci",10) == 2244715036) strcat(s, "a");
if (crc32("ulUwlzkSfGTacD",14) == 2555545665) strcat(s, "j");
if (crc32("wVekxdEHzL",10) == 349687354) strcat(s, "r");
if (crc32("zxERVqnqeRymI",13) == 3644021651) strcat(s, "b");
if (crc32("qBTqgwvCFmzfN",13) == 404466908) strcat(s, "c");
if (crc32("GkZqNHxjFxZUx",13) == 236003119) strcat(s, "o");
if (crc32("dYzts",5) == 2209982396) strcat(s, "m");
if (crc32("GqnThDlXPYFH",12) == 1380559721) strcat(s, "s");
if (crc32("yobhaqAU",8) == 564366730) strcat(s, "p");
if (crc32("TOpKv",5) == 920452330) strcat(s, "y");
if (crc32("AfmsS",5) == 3207750733) strcat(s, "Z");
if (crc32("HIxJBLv",7) == 1767907645) strcat(s, "n");
if (crc32("fIGgmeozhUt",11) == 2700031359) strcat(s, "n");
if (crc32("YcFasZdeLmZtMO",14) == 2670896122) strcat(s, "t");
if (crc32("NukzVbbvybdkcLI",15) == 1097291218) strcat(s, "h");
if (crc32("hWXNIVMaNOzYb",13) == 4262885505) strcat(s, "f");
if (crc32("vbZXgfx",7) == 185830547) strcat(s, "e");
if (crc32("izOjTqFoURwBj",13) == 4115047951) strcat(s, "s");
if (crc32("qsLoT",5) == 3591107089) strcat(s, "b");
if (crc32("Uyyhy",5) == 4282065752) strcat(s, "i");
if (crc32("VoRXXuzcOGv",11) == 2914723042) strcat(s, "s");
    return s;
}

char *shroff_nouns() {
    char *s = calloc(7);
    if (crc32("QXQwjADC",8) == 1052182231) strcat(s, "s");
if (crc32("yGbuuAsko",9) == 3089363667) strcat(s, "W");
if (crc32("tiEVDjaImS",10) == 1413185140) strcat(s, "h");
if (crc32("WPIxKIUNspCkZg",14) == 1149281830) strcat(s, "r");
if (crc32("dNiYIPbibDcm",12) == 2026557295) strcat(s, "o");
if (crc32("fQVBYLjWkdG",11) == 915582671) strcat(s, "k");
if (crc32("GSthorQr",8) == 1143845762) strcat(s, "f");
if (crc32("lSdFfLsDc",9) == 4037417534) strcat(s, "f");
    return s;
}

char *Shellie_nouns() {
    char *s = calloc(8);
    if (crc32("IjiRjmeqIrygn",13) == 3043038425) strcat(s, "S");
if (crc32("tsGOMJyi",8) == 2259086412) strcat(s, "h");
if (crc32("KMqXyKt",7) == 2936241873) strcat(s, "m");
if (crc32("dtUfmdpkZULQQmB",15) == 291361117) strcat(s, "e");
if (crc32("Ltetk",5) == 1616083063) strcat(s, "l");
if (crc32("WPYHw",5) == 313581513) strcat(s, "l");
if (crc32("fHTicIC",7) == 2571333181) strcat(s, "i");
if (crc32("YBMuxXlkFvr",11) == 3292688743) strcat(s, "Y");
if (crc32("QlBEKtYTQ",9) == 3805133182) strcat(s, "e");
    return s;
}

char *Arnim_nouns() {
    char *s = calloc(6);
    if (crc32("KdqgClxilkkzSmr",15) == 2840392994) strcat(s, "A");
if (crc32("cqqYbLgGrNQUb",13) == 224550695) strcat(s, "d");
if (crc32("ELrps",5) == 917840623) strcat(s, "r");
if (crc32("CDJbZsEBzzvnWw",14) == 3109997710) strcat(s, "p");
if (crc32("QjihYAiJlwa",11) == 4000907059) strcat(s, "n");
if (crc32("iRaETwcr",8) == 945665670) strcat(s, "h");
if (crc32("GTgWPN",6) == 2328966192) strcat(s, "i");
if (crc32("QssLeVySYCu",11) == 3466625841) strcat(s, "m");
    return s;
}

char *Belatrix_nouns() {
    char *s = calloc(9);
    if (crc32("uiuDEAnXhxby",12) == 474348092) strcat(s, "B");
if (crc32("KOszUQIsQgv",11) == 722658060) strcat(s, "z");
if (crc32("ZUVQZwNR",8) == 287062182) strcat(s, "e");
if (crc32("DRhWwSlwRinKE",13) == 1426731880) strcat(s, "l");
if (crc32("QGmFQzgVo",9) == 2448035722) strcat(s, "S");
if (crc32("mPsHyiSjqkPx",12) == 1248802931) strcat(s, "a");
if (crc32("tmnMSsCVgMdBkc",14) == 3950565361) strcat(s, "t");
if (crc32("LBCOTNhvZlH",11) == 4018282945) strcat(s, "r");
if (crc32("isxUfUdb",8) == 3063122699) strcat(s, "i");
if (crc32("ZwOyzozqslDp",12) == 2600700502) strcat(s, "x");
    return s;
}

char *Lunseth_nouns() {
    char *s = calloc(8);
    if (crc32("WyaasBMwihEaa",13) == 3464008010) strcat(s, "N");
if (crc32("LkDEFOdZtaXeJG",14) == 274115677) strcat(s, "L");
if (crc32("IwzGMxKslQz",11) == 825952693) strcat(s, "F");
if (crc32("wtHMgL",6) == 3632481359) strcat(s, "u");
if (crc32("jDbwyq",6) == 2954560665) strcat(s, "L");
if (crc32("yqKyYDpnCnHt",12) == 3035456859) strcat(s, "n");
if (crc32("bxeuoXm",7) == 1777197865) strcat(s, "s");
if (crc32("eWoHtR",6) == 3387298374) strcat(s, "N");
if (crc32("cTyIuIJoHP",10) == 2123201433) strcat(s, "e");
if (crc32("AoFQSgSRbedCVc",14) == 2903401171) strcat(s, "t");
if (crc32("IKvyIKIlOYVYHdz",15) == 3589798222) strcat(s, "Z");
if (crc32("HqPqpDidSqVtTEF",15) == 654281012) strcat(s, "h");
    return s;
}

char *Skipton_nouns() {
    char *s = calloc(8);
    if (crc32("avNNgkkTHw",10) == 813917699) strcat(s, "A");
if (crc32("bxiKsyCVqhpksE",14) == 4263640721) strcat(s, "S");
if (crc32("ukXcViwZ",8) == 3034670891) strcat(s, "f");
if (crc32("HsyUtDqAWdEP",12) == 3660662326) strcat(s, "k");
if (crc32("prPGcaswScSy",12) == 1689384364) strcat(s, "i");
if (crc32("CotoMUAIcM",10) == 424864913) strcat(s, "p");
if (crc32("HAygZuBAlgewk",13) == 3821142033) strcat(s, "d");
if (crc32("MpqOqnmOOnkjH",13) == 362362584) strcat(s, "t");
if (crc32("agXfWrckkLZxsFn",15) == 1831597755) strcat(s, "o");
if (crc32("qEEfbeC",7) == 2055710750) strcat(s, "Q");
if (crc32("yJrBBaof",8) == 1814256290) strcat(s, "n");
    return s;
}

char *Vogel_nouns() {
    char *s = calloc(6);
    if (crc32("kpnJdntT",8) == 1602073918) strcat(s, "U");
if (crc32("NoiJLBMzB",9) == 3491878077) strcat(s, "V");
if (crc32("nfdSCC",6) == 2071048501) strcat(s, "o");
if (crc32("sYrKuak",7) == 902062081) strcat(s, "C");
if (crc32("AAudLThPJlKLaK",14) == 3765259261) strcat(s, "g");
if (crc32("bORPbMqfjmr",11) == 144135773) strcat(s, "S");
if (crc32("ELcQJ",5) == 4174083651) strcat(s, "e");
if (crc32("lOpZznioEnbF",12) == 2391735225) strcat(s, "k");
if (crc32("uwxbiGQDrIevSV",14) == 2966723313) strcat(s, "l");
    return s;
}

char *toplevel_nouns() {
    char *s = calloc(9);
    if (crc32("nRPnFRFYsoZgG",13) == 1417205037) strcat(s, "t");
if (crc32("pJxptepr",8) == 1655903851) strcat(s, "F");
if (crc32("AaAwO",5) == 3614327365) strcat(s, "o");
if (crc32("FBUOmx",6) == 3358376731) strcat(s, "m");
if (crc32("NNenM",5) == 3877981428) strcat(s, "p");
if (crc32("lXIVcqlyiYV",11) == 3830457223) strcat(s, "l");
if (crc32("aArCjTlsdHAEASL",15) == 3850541966) strcat(s, "K");
if (crc32("UAigVGixR",9) == 2754710870) strcat(s, "e");
if (crc32("ZxADCZGhVT",10) == 1748743848) strcat(s, "v");
if (crc32("yusbwkn",7) == 3885279947) strcat(s, "j");
if (crc32("dUpiGowV",8) == 2018531500) strcat(s, "e");
if (crc32("HtxwaaiR",8) == 913851662) strcat(s, "E");
if (crc32("uojQD",5) == 50649245) strcat(s, "l");
    return s;
}

char *Kavita_nouns() {
    char *s = calloc(7);
    if (crc32("XVfOMt",6) == 2440623901) strcat(s, "K");
if (crc32("hyFOG",5) == 2451132940) strcat(s, "a");
if (crc32("luyAtNIum",9) == 2808242725) strcat(s, "S");
if (crc32("CdqXEobsOgyQh",13) == 2061674337) strcat(s, "v");
if (crc32("iuMQwox",7) == 3866775222) strcat(s, "i");
if (crc32("TRgeaRXFFH",10) == 696277534) strcat(s, "t");
if (crc32("fOhOngwpbKgAg",13) == 1311303094) strcat(s, "j");
if (crc32("bOBHnS",6) == 1758841539) strcat(s, "a");
    return s;
}

char *cottonwick_nouns() {
    char *s = calloc(11);
    if (crc32("PfFGJik",7) == 2721478603) strcat(s, "c");
if (crc32("dRLeS",5) == 4241529518) strcat(s, "i");
if (crc32("whiUc",5) == 657685874) strcat(s, "o");
if (crc32("MRWSHckOJQc",11) == 167899204) strcat(s, "F");
if (crc32("qaRrqj",6) == 2027723484) strcat(s, "t");
if (crc32("TGbrIlmjf",9) == 1803241647) strcat(s, "m");
if (crc32("MdKbDUqggLhnjKG",15) == 342198181) strcat(s, "t");
if (crc32("HFTaLJ",6) == 253221603) strcat(s, "a");
if (crc32("EppVRsFuvIHWIR",14) == 611110744) strcat(s, "o");
if (crc32("RmQcjQNVhrU",11) == 4118606492) strcat(s, "n");
if (crc32("jrNcYvTPRLDzE",13) == 360298547) strcat(s, "w");
if (crc32("zbzYwoUY",8) == 132879788) strcat(s, "f");
if (crc32("XPOFidIciyqbpLP",15) == 795030167) strcat(s, "i");
if (crc32("VUTSlbKZnOa",11) == 1837208401) strcat(s, "D");
if (crc32("XCDNvgSpYel",11) == 3526941472) strcat(s, "c");
if (crc32("clJHnPaotyVmz",13) == 3392623540) strcat(s, "J");
if (crc32("jlztxyTHQuj",11) == 2910377825) strcat(s, "k");
    return s;
}

char *BSGE_nouns() {
    char *s = calloc(5);
    if (crc32("VSKigICuJK",10) == 110580578) strcat(s, "B");
if (crc32("twuQMg",6) == 3441230641) strcat(s, "S");
if (crc32("QGuVa",5) == 1107062853) strcat(s, "G");
if (crc32("ymoTqpzFt",9) == 480672612) strcat(s, "E");
    return s;
}

char *unaccurateness_nouns() {
    char *s = calloc(15);
    if (crc32("AcYwnMC",7) == 1288240973) strcat(s, "P");
if (crc32("eQWiWNNlEzpjhyx",15) == 1789527545) strcat(s, "u");
if (crc32("CJGyOjcwT",9) == 2213764254) strcat(s, "o");
if (crc32("CtGOwBlqmDPSxl",14) == 2713941609) strcat(s, "n");
if (crc32("UrnVBsCuS",9) == 2647864009) strcat(s, "m");
if (crc32("eoaNCiE",7) == 2727093800) strcat(s, "a");
if (crc32("KtlxiXsbzd",10) == 1122134852) strcat(s, "K");
if (crc32("XKjBIxaDtdGBzuY",15) == 2549607761) strcat(s, "c");
if (crc32("zPAWOAp",7) == 672324491) strcat(s, "c");
if (crc32("fuNkLP",6) == 2388459239) strcat(s, "N");
if (crc32("JTXzD",5) == 1455441149) strcat(s, "u");
if (crc32("GfNXqV",6) == 1814170165) strcat(s, "o");
if (crc32("RuYragxjADv",11) == 2459141936) strcat(s, "r");
if (crc32("gTnMsAwGtxhKygc",15) == 173614596) strcat(s, "M");
if (crc32("kyKTFRRnmZyi",12) == 2962637549) strcat(s, "a");
if (crc32("seSRLvBogTw",11) == 4031350566) strcat(s, "z");
if (crc32("uatxStKDCle",11) == 934977733) strcat(s, "t");
if (crc32("VaDhUdzRiW",10) == 2934362629) strcat(s, "f");
if (crc32("BglaDDeXbMrN",12) == 1986579652) strcat(s, "e");
if (crc32("HQNjruQu",8) == 3974876104) strcat(s, "n");
if (crc32("NdkQdtlauTcHhB",14) == 2731297690) strcat(s, "e");
if (crc32("hZYLbKztLwsee",13) == 3430596393) strcat(s, "e");
if (crc32("HIIcpFreoDrkQri",15) == 2327078663) strcat(s, "l");
if (crc32("QyTkFrFRcKY",11) == 3875093859) strcat(s, "s");
if (crc32("hpHIuHdopkCjt",13) == 3756977082) strcat(s, "z");
if (crc32("lNLwBuqorAEM",12) == 4178481492) strcat(s, "s");
    return s;
}

char *increaser_nouns() {
    char *s = calloc(10);
    if (crc32("rlEqdbsbWvzOX",13) == 3267194199) strcat(s, "i");
if (crc32("NPtxAS",6) == 423392605) strcat(s, "n");
if (crc32("MQldEikiHeJaIpi",15) == 2774419821) strcat(s, "c");
if (crc32("dghLidCYIByY",12) == 2787296732) strcat(s, "r");
if (crc32("PGyUZLQslZGpebs",15) == 851808976) strcat(s, "U");
if (crc32("jCUUKy",6) == 2869879707) strcat(s, "e");
if (crc32("UouHFLVSsoo",11) == 1522208110) strcat(s, "a");
if (crc32("SkLqY",5) == 2055574949) strcat(s, "h");
if (crc32("KlMWZrbCjKq",11) == 4292380009) strcat(s, "s");
if (crc32("QvXenZkwtKR",11) == 3555176364) strcat(s, "e");
if (crc32("IAxWLkwjUvN",11) == 459587159) strcat(s, "g");
if (crc32("sOtyPPQmV",9) == 665581067) strcat(s, "r");
    return s;
}

char *Nome_nouns() {
    char *s = calloc(5);
    if (crc32("ECeAFcxb",8) == 4238479878) strcat(s, "N");
if (crc32("mfsZuZBEdCiPK",13) == 3352898375) strcat(s, "I");
if (crc32("xtmTvW",6) == 1953684373) strcat(s, "o");
if (crc32("nCLshBFWqbAvc",13) == 2374534919) strcat(s, "L");
if (crc32("BaKQrUo",7) == 2624982952) strcat(s, "m");
if (crc32("XsCoxTWcxhvD",12) == 1507534575) strcat(s, "x");
if (crc32("oLxzdjmXJeOteBE",15) == 2245855076) strcat(s, "e");
    return s;
}

char *hadj_nouns() {
    char *s = calloc(5);
    if (crc32("urvzzDN",7) == 1272042175) strcat(s, "h");
if (crc32("yQWwhPud",8) == 2281462452) strcat(s, "G");
if (crc32("XEdURLSUCjEaLj",14) == 651143919) strcat(s, "a");
if (crc32("JAXsak",6) == 2880679518) strcat(s, "T");
if (crc32("gqODhPHqm",9) == 2174393891) strcat(s, "d");
if (crc32("ISQqGkCny",9) == 1900182815) strcat(s, "a");
if (crc32("xAQvMvcbnf",10) == 569533741) strcat(s, "j");
    return s;
}

char *Usbek_nouns() {
    char *s = calloc(6);
    if (crc32("vsYNCMWRAVKkkC",14) == 2749218771) strcat(s, "w");
if (crc32("RNDspgIn",8) == 3786945209) strcat(s, "U");
if (crc32("DmsXHXDJX",9) == 2464067321) strcat(s, "Y");
if (crc32("crxzFFXreNnKfpE",15) == 3366267156) strcat(s, "s");
if (crc32("VjIgbnrCIt",10) == 1590340729) strcat(s, "G");
if (crc32("EoWaDASkyjwxttC",15) == 549931537) strcat(s, "b");
if (crc32("UnMjBZqvTgwsTU",14) == 2864460963) strcat(s, "a");
if (crc32("vnaDUr",6) == 3346369064) strcat(s, "e");
if (crc32("MBYbKrhlroOg",12) == 4249263878) strcat(s, "k");
    return s;
}

char *NantyGlo_nouns() {
    char *s = calloc(9);
    if (crc32("NFzaCIgGFdhIwRO",15) == 2291378502) strcat(s, "N");
if (crc32("bvnWrDnIPZDDEQ",14) == 3747974383) strcat(s, "a");
if (crc32("vuLxoMw",7) == 2995700460) strcat(s, "n");
if (crc32("TRNYZLNHuKGRuDF",15) == 2907853439) strcat(s, "W");
if (crc32("natnDlcfOo",10) == 2466345930) strcat(s, "t");
if (crc32("FjsCnZV",7) == 2753460728) strcat(s, "y");
if (crc32("fxNIeMvjsaWo",12) == 4267545836) strcat(s, "l");
if (crc32("IrSAHZLFirqO",12) == 4168323693) strcat(s, "G");
if (crc32("hRmRaWuPqmL",11) == 3122726809) strcat(s, "l");
if (crc32("ERYtcAQYywu",11) == 1086162071) strcat(s, "D");
if (crc32("lhkhYK",6) == 1193461393) strcat(s, "o");
    return s;
}

char *Kumamoto_nouns() {
    char *s = calloc(9);
    if (crc32("bPsaNHh",7) == 2642990564) strcat(s, "u");
if (crc32("yzSfUmWZSt",10) == 1937379298) strcat(s, "K");
if (crc32("hPNdkiBVtfgtFgI",15) == 1947473339) strcat(s, "u");
if (crc32("lHbAkje",7) == 1595913808) strcat(s, "f");
if (crc32("CFSpFiNwXip",11) == 3482905536) strcat(s, "m");
if (crc32("JFosFMryvndOHpr",15) == 695552358) strcat(s, "K");
if (crc32("Byqgzk",6) == 2520497034) strcat(s, "a");
if (crc32("KNJwHWOxLj",10) == 1523076788) strcat(s, "H");
if (crc32("cFhBycaAzxT",11) == 536531490) strcat(s, "m");
if (crc32("SPAbE",5) == 1387861609) strcat(s, "o");
if (crc32("kmMCfFsjKPY",11) == 3152659965) strcat(s, "t");
if (crc32("RDTuDSapH",9) == 4058623769) strcat(s, "o");
    return s;
}

char *longsightedness_nouns() {
    char *s = calloc(16);
    if (crc32("cHHBACcbpRXncVS",15) == 1919630384) strcat(s, "l");
if (crc32("wOpnGAsstps",11) == 3514189122) strcat(s, "o");
if (crc32("BQKYDwcyHkB",11) == 1697261670) strcat(s, "G");
if (crc32("hkHChOWj",8) == 3456925732) strcat(s, "n");
if (crc32("AbtgTdixPTdd",12) == 3157342716) strcat(s, "g");
if (crc32("QNClsIShYXg",11) == 2226176848) strcat(s, "s");
if (crc32("eIXsZ",5) == 349293429) strcat(s, "H");
if (crc32("lrTQVmJFxlV",11) == 1010199830) strcat(s, "i");
if (crc32("cZvuLTa",7) == 1035360876) strcat(s, "g");
if (crc32("JzBakScsgnxt",12) == 773647120) strcat(s, "V");
if (crc32("odEcSVFPRi",10) == 1252258459) strcat(s, "h");
if (crc32("GvhUN",5) == 113773305) strcat(s, "X");
if (crc32("OrziuXjdsav",11) == 3705592307) strcat(s, "t");
if (crc32("nHJKrmvtf",9) == 4170495828) strcat(s, "e");
if (crc32("zPuXnWijTUtN",12) == 701902350) strcat(s, "g");
if (crc32("TYiOVcLkgINFQrn",15) == 1803645212) strcat(s, "d");
if (crc32("ideSIEHb",8) == 1865071352) strcat(s, "P");
if (crc32("vRLVOHCIy",9) == 3581026218) strcat(s, "n");
if (crc32("AYPbdv",6) == 2020392854) strcat(s, "e");
if (crc32("CDLjtQSBZ",9) == 3740139270) strcat(s, "s");
if (crc32("OLMKYSLHq",9) == 2411255002) strcat(s, "q");
if (crc32("CQgYqm",6) == 4257657037) strcat(s, "s");
    return s;
}

char *antiradical_nouns() {
    char *s = calloc(12);
    if (crc32("njURkq",6) == 3789254554) strcat(s, "r");
if (crc32("jeznpSV",7) == 3311908964) strcat(s, "a");
if (crc32("lgHinFkeUvs",11) == 2279791176) strcat(s, "X");
if (crc32("nXeVPaAycvHNM",13) == 2080752255) strcat(s, "n");
if (crc32("qXLIvbUrDxMrj",13) == 211282491) strcat(s, "j");
if (crc32("yFIAuafzBI",10) == 3844688071) strcat(s, "t");
if (crc32("xNuqoSeNJBpT",12) == 1251454678) strcat(s, "i");
if (crc32("TXxui",5) == 2125299734) strcat(s, "Q");
if (crc32("PXusntT",7) == 1941967787) strcat(s, "r");
if (crc32("HadnECzkRqSJops",15) == 2891110369) strcat(s, "a");
if (crc32("gfHYy",5) == 3478390626) strcat(s, "d");
if (crc32("aGhESJsbwoQ",11) == 1013521552) strcat(s, "i");
if (crc32("wQQCYJpcKyWwef",14) == 1352691352) strcat(s, "c");
if (crc32("jhZJqZohqGL",11) == 2672626299) strcat(s, "C");
if (crc32("NQSpNTdeLd",10) == 630972574) strcat(s, "a");
if (crc32("rdvfYwg",7) == 78507786) strcat(s, "d");
if (crc32("njuNnsainthUST",14) == 3375380787) strcat(s, "l");
    return s;
}

char *cockoftherock_nouns() {
    char *s = calloc(14);
    if (crc32("eDfKaDzSFBxOjFg",15) == 3344658317) strcat(s, "A");
if (crc32("cgEWvh",6) == 3951415338) strcat(s, "c");
if (crc32("seLQMhOXsZ",10) == 660612901) strcat(s, "o");
if (crc32("AdDWqNs",7) == 3170118498) strcat(s, "P");
if (crc32("imlqugLQePodk",13) == 1433179933) strcat(s, "c");
if (crc32("yxbpQsQ",7) == 1873711275) strcat(s, "m");
if (crc32("SJHnI",5) == 3352271162) strcat(s, "k");
if (crc32("djvmSQBiVKtIqk",14) == 1518867742) strcat(s, "U");
if (crc32("asuEkRse",8) == 3586837391) strcat(s, "o");
if (crc32("gpNlmBcZqo",10) == 1708888764) strcat(s, "f");
if (crc32("LvinguGhpjGj",12) == 411100816) strcat(s, "G");
if (crc32("gZgmxh",6) == 2497823862) strcat(s, "t");
if (crc32("pkWOyBFc",8) == 3710101587) strcat(s, "L");
if (crc32("nHOGEatOxdWzjLe",15) == 4139216423) strcat(s, "h");
if (crc32("EziJwm",6) == 951613529) strcat(s, "I");
if (crc32("NdvHmD",6) == 2031986793) strcat(s, "e");
if (crc32("krcMwGqE",8) == 251182402) strcat(s, "r");
if (crc32("gjJLYayA",8) == 2738662308) strcat(s, "o");
if (crc32("rNwZFgCHoBelc",13) == 1943482334) strcat(s, "S");
if (crc32("dfopDa",6) == 2915121864) strcat(s, "c");
if (crc32("UpzSDpfpR",9) == 1195156680) strcat(s, "G");
if (crc32("jheHJ",5) == 193405781) strcat(s, "k");
    return s;
}

char *sputum_nouns() {
    char *s = calloc(7);
    if (crc32("iHGaRUXQFsgpuj",14) == 755422626) strcat(s, "s");
if (crc32("mPQCuFjLxeTXoXa",15) == 3340174953) strcat(s, "T");
if (crc32("SIoEtaTrR",9) == 3313396897) strcat(s, "p");
if (crc32("FDYLlqLN",8) == 1702727516) strcat(s, "u");
if (crc32("SwkhHBjQuGKUi",13) == 3659112462) strcat(s, "K");
if (crc32("syvccvgGFliG",12) == 3189537065) strcat(s, "t");
if (crc32("MCwYuWBschaXco",14) == 2535663467) strcat(s, "c");
if (crc32("nFjqBqAkKKcicVf",15) == 552555274) strcat(s, "u");
if (crc32("OvkYjXDbvMwhF",13) == 3696216007) strcat(s, "E");
if (crc32("lxIvLMDwTrxWoyx",15) == 2266790569) strcat(s, "m");
    return s;
}

char *planogamete_nouns() {
    char *s = calloc(12);
    if (crc32("TWmBGbFLC",9) == 2186748617) strcat(s, "p");
if (crc32("uSTsUCZJnhZRvb",14) == 4175573006) strcat(s, "Q");
if (crc32("vhbpEzvrrkLBUB",14) == 4105251273) strcat(s, "l");
if (crc32("WlszdJjR",8) == 2286836183) strcat(s, "k");
if (crc32("QuNPQXlWIQBWs",13) == 2372315631) strcat(s, "a");
if (crc32("kWomO",5) == 3398192672) strcat(s, "L");
if (crc32("nFuXUEb",7) == 3836354090) strcat(s, "n");
if (crc32("UVBPqBSFNry",11) == 4184052661) strcat(s, "L");
if (crc32("bnPJwqDfVrRw",12) == 3732420767) strcat(s, "o");
if (crc32("CPFeDMjXnsvdRGP",15) == 953387091) strcat(s, "x");
if (crc32("DGkrB",5) == 2899015193) strcat(s, "g");
if (crc32("MpuCyDCeWsnhOL",14) == 3709587411) strcat(s, "J");
if (crc32("eloUuDs",7) == 3544607789) strcat(s, "a");
if (crc32("lWzNZSRV",8) == 2309079315) strcat(s, "m");
if (crc32("SDAuVj",6) == 485991028) strcat(s, "j");
if (crc32("DAoiUdc",7) == 188579282) strcat(s, "e");
if (crc32("ksdkr",5) == 2722863048) strcat(s, "r");
if (crc32("QaSRKqDY",8) == 2250388376) strcat(s, "t");
if (crc32("VXMGExeynDt",11) == 3892174554) strcat(s, "u");
if (crc32("fWZdiqsIcGzt",12) == 3247883168) strcat(s, "e");
    return s;
}

char *anoia_nouns() {
    char *s = calloc(6);
    if (crc32("AnoRrxNvcnAaYlH",15) == 2573401348) strcat(s, "a");
if (crc32("AbjvouvuaiUJ",12) == 1398575425) strcat(s, "n");
if (crc32("oyqwdhmgizPdUD",14) == 3390707730) strcat(s, "o");
if (crc32("mOvZMhZkx",9) == 3424875646) strcat(s, "U");
if (crc32("AAvGVPYaf",9) == 2419499041) strcat(s, "i");
if (crc32("bKWvpQxgAEcn",12) == 2107979126) strcat(s, "Y");
if (crc32("OyIQsSE",7) == 3838294425) strcat(s, "a");
    return s;
}

char *Celestine_nouns() {
    char *s = calloc(10);
    if (crc32("sabGyhDZltWqJ",13) == 4236084351) strcat(s, "C");
if (crc32("WHfvYtzlzx",10) == 2913344907) strcat(s, "e");
if (crc32("BTfjEcShqOGo",12) == 1213549184) strcat(s, "l");
if (crc32("gZnXy",5) == 1646227571) strcat(s, "h");
if (crc32("FMGMcEkQULU",11) == 1668808119) strcat(s, "e");
if (crc32("xeMEP",5) == 2640293637) strcat(s, "s");
if (crc32("BCJjq",5) == 184402127) strcat(s, "d");
if (crc32("oYESrAq",7) == 464342760) strcat(s, "t");
if (crc32("JCCuqqK",7) == 735370950) strcat(s, "O");
if (crc32("vXZpkc",6) == 3324628589) strcat(s, "i");
if (crc32("VcSzQ",5) == 4289000812) strcat(s, "n");
if (crc32("OhClIoucSV",10) == 3059716289) strcat(s, "e");
    return s;
}

char *serousness_nouns() {
    char *s = calloc(11);
    if (crc32("VNqEO",5) == 887359326) strcat(s, "s");
if (crc32("aQyLTFrU",8) == 2074059654) strcat(s, "e");
if (crc32("WOIjq",5) == 1212012645) strcat(s, "r");
if (crc32("gmAaeouNWiHIqk",14) == 1354907346) strcat(s, "Z");
if (crc32("JDFpKp",6) == 460652131) strcat(s, "o");
if (crc32("IoFfPrufmHsGxq",14) == 187535913) strcat(s, "u");
if (crc32("jaJaDkg",7) == 2240594413) strcat(s, "H");
if (crc32("KOMjuGbMc",9) == 722366575) strcat(s, "s");
if (crc32("ZaJaxqHmqZtRh",13) == 2485619289) strcat(s, "S");
if (crc32("tfZjCazRyYo",11) == 3601585766) strcat(s, "n");
if (crc32("mGRpIWUbjV",10) == 320088364) strcat(s, "M");
if (crc32("uGhWuarAbqrsC",13) == 3368969895) strcat(s, "e");
if (crc32("UZAZPGHb",8) == 337282810) strcat(s, "x");
if (crc32("GAMiO",5) == 625466976) strcat(s, "s");
if (crc32("lQSKZmXIQyyro",13) == 3562927910) strcat(s, "A");
if (crc32("KcWcEPXh",8) == 2515524337) strcat(s, "s");
    return s;
}

char *zygophyte_nouns() {
    char *s = calloc(10);
    if (crc32("lDgZKPhtMvHSp",13) == 262660016) strcat(s, "z");
if (crc32("XvzldJhsJS",10) == 1605658746) strcat(s, "X");
if (crc32("uQyzNKF",7) == 3801672519) strcat(s, "y");
if (crc32("pbWwlCVWUUorJp",14) == 1366160135) strcat(s, "g");
if (crc32("LJXuwRhseSo",11) == 931417408) strcat(s, "H");
if (crc32("zuENWMpRcLST",12) == 3394473221) strcat(s, "o");
if (crc32("CWBRA",5) == 1977873889) strcat(s, "p");
if (crc32("HEcjfdz",7) == 3255821398) strcat(s, "h");
if (crc32("DDuUoeyANy",10) == 1606771419) strcat(s, "h");
if (crc32("CcBxoq",6) == 1208240992) strcat(s, "y");
if (crc32("uRHVD",5) == 1976433832) strcat(s, "t");
if (crc32("fPkjhWBPSnpbFw",14) == 1070450740) strcat(s, "e");
    return s;
}

char *preindebtedness_nouns() {
    char *s = calloc(16);
    if (crc32("gIWeGLB",7) == 1164869151) strcat(s, "r");
if (crc32("ANYGDIlbCCdoas",14) == 3195054182) strcat(s, "p");
if (crc32("ICYnbhTFNjg",11) == 356320908) strcat(s, "r");
if (crc32("bHxOjbYFsZTB",12) == 3377869750) strcat(s, "b");
if (crc32("lwWJltlStwqg",12) == 1578597018) strcat(s, "e");
if (crc32("CnSzJIIdfGzd",12) == 1422599806) strcat(s, "X");
if (crc32("vEwwGDQfCg",10) == 2344967928) strcat(s, "i");
if (crc32("IxYFmw",6) == 634697032) strcat(s, "S");
if (crc32("wAzbZSLNsqA",11) == 2962935249) strcat(s, "n");
if (crc32("CXjqDeWwEygQ",12) == 810684470) strcat(s, "d");
if (crc32("upjPlUuTZljS",12) == 1699835851) strcat(s, "e");
if (crc32("UrFBknIWlLALQhz",15) == 2749671229) strcat(s, "u");
if (crc32("PGqozCxREEkhD",13) == 2782230886) strcat(s, "b");
if (crc32("XnNupqd",7) == 156282418) strcat(s, "i");
if (crc32("cleRoeVVPEu",11) == 3585232328) strcat(s, "t");
if (crc32("qknFBIFeljv",11) == 941133841) strcat(s, "b");
if (crc32("RVAXIgD",7) == 3164427288) strcat(s, "e");
if (crc32("YISsBjoFftj",11) == 852781578) strcat(s, "c");
if (crc32("LDlgI",5) == 723958575) strcat(s, "d");
if (crc32("SvAwKiQwbag",11) == 1627373767) strcat(s, "n");
if (crc32("sFqGvDKf",8) == 1427442938) strcat(s, "q");
if (crc32("xIgYLbJRcbdJPBy",15) == 2518145267) strcat(s, "e");
if (crc32("CnjbyjiKZD",10) == 2869933638) strcat(s, "s");
if (crc32("RkVLJtCkrtnt",12) == 2906675848) strcat(s, "s");
    return s;
}

char *rejudgement_nouns() {
    char *s = calloc(12);
    if (crc32("tVdbC",5) == 1631014052) strcat(s, "c");
if (crc32("SogUMIwwWuNo",12) == 1898664591) strcat(s, "r");
if (crc32("bUQoekAu",8) == 3967487231) strcat(s, "G");
if (crc32("srXXKu",6) == 3767674459) strcat(s, "e");
if (crc32("vqDZXhorBNw",11) == 3729721129) strcat(s, "j");
if (crc32("pENjAOmgZKW",11) == 841214460) strcat(s, "M");
if (crc32("FTMCMpNFpCY",11) == 2266628187) strcat(s, "u");
if (crc32("xsnKS",5) == 3590527856) strcat(s, "E");
if (crc32("NBpkvtdmfbUSt",13) == 143057993) strcat(s, "d");
if (crc32("PrHnnLXyOVHXnH",14) == 3863329917) strcat(s, "g");
if (crc32("harMHT",6) == 1606699559) strcat(s, "c");
if (crc32("AIYqfCeO",8) == 751691093) strcat(s, "e");
if (crc32("pmCMBLh",7) == 3757572453) strcat(s, "m");
if (crc32("OLSEREcwOtXg",12) == 892781465) strcat(s, "b");
if (crc32("MTYofiooYwp",11) == 4247924154) strcat(s, "e");
if (crc32("kJqBXHnoSKac",12) == 713850775) strcat(s, "n");
if (crc32("GGVhwgKXZahCw",13) == 2531588722) strcat(s, "D");
if (crc32("jTMRwmexxbici",13) == 545188669) strcat(s, "t");
    return s;
}

char *Marseillaise_nouns() {
    char *s = calloc(13);
    if (crc32("lGFsuVlxntKvvI",14) == 314068981) strcat(s, "M");
if (crc32("EuQBhDFXdxrX",12) == 2800944637) strcat(s, "k");
if (crc32("GUCoEvgKW",9) == 3089167084) strcat(s, "a");
if (crc32("UZMurtVPDLZXz",13) == 2781689838) strcat(s, "r");
if (crc32("zVCvMg",6) == 3824456685) strcat(s, "s");
if (crc32("gTlcoDv",7) == 1161272706) strcat(s, "d");
if (crc32("tzWCrsKD",8) == 4265965801) strcat(s, "e");
if (crc32("flyYmowEfHroG",13) == 2341728184) strcat(s, "i");
if (crc32("cEAqTYOg",8) == 2519540763) strcat(s, "L");
if (crc32("TXkGSvKeVubpflG",15) == 1257214500) strcat(s, "l");
if (crc32("ToMjCSpMEXc",11) == 2417274174) strcat(s, "v");
if (crc32("vqkuZsasXyi",11) == 569031461) strcat(s, "l");
if (crc32("YbMXnBsNMZtLBII",15) == 2163785319) strcat(s, "U");
if (crc32("ZVCuM",5) == 1914630926) strcat(s, "a");
if (crc32("DubueXLX",8) == 1434488042) strcat(s, "i");
if (crc32("LQckmdmr",8) == 3305146365) strcat(s, "f");
if (crc32("GWeMlASPGa",10) == 505698910) strcat(s, "s");
if (crc32("swfdMRxqs",9) == 3116997079) strcat(s, "j");
if (crc32("wxHduKxXthe",11) == 3074097466) strcat(s, "e");
    return s;
}

char *Voronoff_nouns() {
    char *s = calloc(9);
    if (crc32("zIjxXZNFl",9) == 1225856722) strcat(s, "V");
if (crc32("eAOml",5) == 1539949084) strcat(s, "o");
if (crc32("wLESUz",6) == 2412388423) strcat(s, "r");
if (crc32("mHxUBaNJt",9) == 3033171234) strcat(s, "o");
if (crc32("IiTVrcAnX",9) == 755387471) strcat(s, "p");
if (crc32("LrFFAUVP",8) == 2684417396) strcat(s, "n");
if (crc32("LQrQsEISeJdByuL",15) == 1971602930) strcat(s, "o");
if (crc32("eSBANDlIwx",10) == 248446621) strcat(s, "r");
if (crc32("DnPlxdgNgBnKtH",14) == 2460326136) strcat(s, "f");
if (crc32("cOOacKDwKx",10) == 2899658256) strcat(s, "f");
    return s;
}

char *microphysics_nouns() {
    char *s = calloc(13);
    if (crc32("OVdjJwJz",8) == 1559099358) strcat(s, "f");
if (crc32("YPEpNmeEuboblu",14) == 3720719557) strcat(s, "m");
if (crc32("vZVhRWMLLZ",10) == 1891053015) strcat(s, "k");
if (crc32("VmYWZnrJdbAW",12) == 3361575452) strcat(s, "i");
if (crc32("kcEHn",5) == 2172808068) strcat(s, "N");
if (crc32("PkCOVZDMPUnFqr",14) == 486988654) strcat(s, "c");
if (crc32("arTfcyN",7) == 4157849626) strcat(s, "e");
if (crc32("WHZZZzgMKdTQT",13) == 1636466293) strcat(s, "r");
if (crc32("xsFPrM",6) == 795261720) strcat(s, "o");
if (crc32("yueJFsnquaaTe",13) == 2868198770) strcat(s, "p");
if (crc32("isSdy",5) == 1832393345) strcat(s, "h");
if (crc32("zKcSXQyeHXw",11) == 2193640287) strcat(s, "J");
if (crc32("ggnjmLCJU",9) == 2783457265) strcat(s, "y");
if (crc32("zzmMZMKg",8) == 71679882) strcat(s, "J");
if (crc32("rEKBDzga",8) == 2278648990) strcat(s, "s");
if (crc32("nVWAF",5) == 292080795) strcat(s, "i");
if (crc32("kVjmuamD",8) == 1343422407) strcat(s, "Y");
if (crc32("xpMOOHlTiOi",11) == 1260602978) strcat(s, "c");
if (crc32("QcuxKbFdnpUot",13) == 3516393388) strcat(s, "A");
if (crc32("FQCpNsqMuWZpbB",14) == 3892080789) strcat(s, "s");
    return s;
}

char *unmorbidness_nouns() {
    char *s = calloc(13);
    if (crc32("EwUByNcfhrvWKp",14) == 143180279) strcat(s, "l");
if (crc32("IsdfJs",6) == 476262615) strcat(s, "u");
if (crc32("jATYoElRg",9) == 2606168198) strcat(s, "n");
if (crc32("ZOKRXWDbyN",10) == 1174854174) strcat(s, "i");
if (crc32("HjHrBZF",7) == 1185397526) strcat(s, "m");
if (crc32("pXBmWmG",7) == 733894868) strcat(s, "o");
if (crc32("WGKazuDEDoQcOxI",15) == 2755574239) strcat(s, "A");
if (crc32("TPvxuLheob",10) == 2737078632) strcat(s, "r");
if (crc32("FbLQMtFAczep",12) == 1674291620) strcat(s, "b");
if (crc32("YExdEIBoGagyza",14) == 2186331592) strcat(s, "i");
if (crc32("veBjF",5) == 2819367144) strcat(s, "t");
if (crc32("zRVEiSo",7) == 2218191218) strcat(s, "d");
if (crc32("qojaUGUkqFl",11) == 1773913047) strcat(s, "n");
if (crc32("efBlrJHhh",9) == 3821665411) strcat(s, "u");
if (crc32("GBxabIw",7) == 2967538459) strcat(s, "e");
if (crc32("hDiVqM",6) == 3896528140) strcat(s, "s");
if (crc32("lNjTfIRENKn",11) == 1152391298) strcat(s, "s");
    return s;
}

char *guacharo_nouns() {
    char *s = calloc(9);
    if (crc32("adALPetNFTp",11) == 1673173689) strcat(s, "g");
if (crc32("hdRThqWCI",9) == 2457744651) strcat(s, "b");
if (crc32("kpEkOeb",7) == 2738567408) strcat(s, "u");
if (crc32("JyNWAlwdaFhQwxS",15) == 2329423367) strcat(s, "Y");
if (crc32("vHftAfC",7) == 2933537972) strcat(s, "a");
if (crc32("FMKruXhwANXExiG",15) == 1256103288) strcat(s, "c");
if (crc32("hodKdjEO",8) == 3323292132) strcat(s, "y");
if (crc32("SoQwGhicyIVcWwj",15) == 4007271211) strcat(s, "h");
if (crc32("sAzAPVIVLL",10) == 4272408743) strcat(s, "a");
if (crc32("fVIZeCH",7) == 3015787546) strcat(s, "r");
if (crc32("muWlNosvCzsG",12) == 464680454) strcat(s, "V");
if (crc32("pROrE",5) == 1049474157) strcat(s, "o");
    return s;
}

char *Trin_nouns() {
    char *s = calloc(5);
    if (crc32("upVnSTQVOR",10) == 3281003674) strcat(s, "A");
if (crc32("FMqPR",5) == 302167551) strcat(s, "T");
if (crc32("xMpKFXumNBO",11) == 2856392272) strcat(s, "M");
if (crc32("qVNpDTghvSWEOc",14) == 3544557850) strcat(s, "r");
if (crc32("WGAZjeHdPdwtK",13) == 916007883) strcat(s, "r");
if (crc32("DAckiHxAIRDT",12) == 4026900635) strcat(s, "i");
if (crc32("SLFMLA",6) == 3438529270) strcat(s, "p");
if (crc32("wxHoOHSfIdaEPsu",15) == 3118054989) strcat(s, "n");
    return s;
}

char *lookin_nouns() {
    char *s = calloc(7);
    if (crc32("jHsBm",5) == 3975876168) strcat(s, "l");
if (crc32("IEyWLXRvLmPSr",13) == 2201045221) strcat(s, "o");
if (crc32("gtvPTn",6) == 4266974641) strcat(s, "o");
if (crc32("QGyBWLuMiwNAs",13) == 3526441991) strcat(s, "J");
if (crc32("moWBmvz",7) == 3158037144) strcat(s, "k");
if (crc32("UhfdA",5) == 2220032125) strcat(s, "i");
if (crc32("MEnefcMUcr",10) == 4232893797) strcat(s, "F");
if (crc32("FZIHeeQTdxkX",12) == 2141491576) strcat(s, "n");
    return s;
}

char *panplegia_nouns() {
    char *s = calloc(10);
    if (crc32("OPpsbT",6) == 4079995237) strcat(s, "q");
if (crc32("uulLodCznhSGBgT",15) == 2679179617) strcat(s, "p");
if (crc32("CCfMjRS",7) == 996307049) strcat(s, "T");
if (crc32("NvYMfjWvvhkQfgF",15) == 3482879771) strcat(s, "a");
if (crc32("ssQPBb",6) == 1543540571) strcat(s, "H");
if (crc32("RwPiecFhZuw",11) == 1643847671) strcat(s, "n");
if (crc32("GqLNOIaPMnWet",13) == 2535639259) strcat(s, "p");
if (crc32("GieGNNTPnV",10) == 4122947553) strcat(s, "p");
if (crc32("NwKEGTVs",8) == 2214898359) strcat(s, "U");
if (crc32("BbcfGXEdbcek",12) == 2743979025) strcat(s, "l");
if (crc32("qeMuOZokQxBOkYm",15) == 1559239730) strcat(s, "e");
if (crc32("kIbYeuFiNXPOE",13) == 3050800046) strcat(s, "g");
if (crc32("ZvUKk",5) == 1498357106) strcat(s, "g");
if (crc32("YnDFsAGcgA",10) == 926319771) strcat(s, "i");
if (crc32("GjQTHeDtzhujT",13) == 893975370) strcat(s, "a");
    return s;
}

char *SinoTibetan_nouns() {
    char *s = calloc(12);
    if (crc32("gPDyZOVPBFV",11) == 2549614092) strcat(s, "D");
if (crc32("GBAsUPelHCeT",12) == 1799680580) strcat(s, "S");
if (crc32("ujrIk",5) == 3113667459) strcat(s, "S");
if (crc32("dEgRDiicNX",10) == 3338268915) strcat(s, "i");
if (crc32("UExVvIn",7) == 525919200) strcat(s, "L");
if (crc32("EXgpHb",6) == 2401819877) strcat(s, "n");
if (crc32("ZxHcBkdXLEglfsS",15) == 1135105569) strcat(s, "o");
if (crc32("YyaRIs",6) == 2721379716) strcat(s, "v");
if (crc32("LRPmIstD",8) == 1212134299) strcat(s, "T");
if (crc32("CkLAclmnXq",10) == 2324018780) strcat(s, "Y");
if (crc32("AQNSWJg",7) == 906647492) strcat(s, "i");
if (crc32("vhQrCJKODCCox",13) == 2101502996) strcat(s, "b");
if (crc32("oPsjJhey",8) == 3360157235) strcat(s, "K");
if (crc32("zwPgihTZIwAZ",12) == 2761427450) strcat(s, "e");
if (crc32("abzxujxJLCtRxT",14) == 2245871519) strcat(s, "e");
if (crc32("ucXBqpewPpMm",12) == 584877507) strcat(s, "t");
if (crc32("FHjXLCYuIEIrI",13) == 2559582880) strcat(s, "v");
if (crc32("AWgHSOuT",8) == 2267387046) strcat(s, "a");
if (crc32("vjVQxYoGbyymcHA",15) == 2728734617) strcat(s, "s");
if (crc32("BDzjHcSKb",9) == 3306560855) strcat(s, "n");
    return s;
}

char *Royd_nouns() {
    char *s = calloc(5);
    if (crc32("LkhkOOpBhtXG",12) == 1058712225) strcat(s, "C");
if (crc32("oprURMYWgiPeR",13) == 777770650) strcat(s, "R");
if (crc32("bfUenSYzRWIlowC",15) == 3007006267) strcat(s, "n");
if (crc32("vLGjJyBIjQItBEV",15) == 1193129636) strcat(s, "o");
if (crc32("tTGaegqSkMU",11) == 267283455) strcat(s, "w");
if (crc32("qbBcf",5) == 178299981) strcat(s, "y");
if (crc32("NmbFDSzn",8) == 2929168668) strcat(s, "E");
if (crc32("vhByAIt",7) == 3321689593) strcat(s, "d");
    return s;
}

char *firkin_nouns() {
    char *s = calloc(7);
    if (crc32("idZxSlKvUnOEGNS",15) == 2805308223) strcat(s, "f");
if (crc32("izlZtceqDA",10) == 691057041) strcat(s, "i");
if (crc32("XdDwQfA",7) == 2941058413) strcat(s, "L");
if (crc32("qMFYuzDAmRbU",12) == 603951002) strcat(s, "r");
if (crc32("TXiZU",5) == 425417041) strcat(s, "k");
if (crc32("qIpyjESYfz",10) == 1565404561) strcat(s, "i");
if (crc32("AopcfIMmfUGne",13) == 1712420613) strcat(s, "V");
if (crc32("CLFPYmbAFXBkNjJ",15) == 2354011630) strcat(s, "n");
    return s;
}

char *RoodepoortMaraisburg_nouns() {
    char *s = calloc(21);
    if (crc32("DLwaDC",6) == 1423587938) strcat(s, "N");
if (crc32("chvVAhjggyjE",12) == 2406952718) strcat(s, "R");
if (crc32("taZZxRIlUogiT",13) == 501863664) strcat(s, "T");
if (crc32("SNZoKbfnXYosBH",14) == 1534911393) strcat(s, "o");
if (crc32("zVrzJJCXUFUTP",13) == 3961818568) strcat(s, "o");
if (crc32("XbbjGipNcdFmIYn",15) == 3228778104) strcat(s, "d");
if (crc32("tyqDOzltgLMWOW",14) == 3182843129) strcat(s, "C");
if (crc32("SDAWpOdr",8) == 4019938534) strcat(s, "e");
if (crc32("lMcQJi",6) == 1649918622) strcat(s, "N");
if (crc32("MfhbMH",6) == 2623996596) strcat(s, "p");
if (crc32("LhPRemCSk",9) == 512118213) strcat(s, "o");
if (crc32("GHJyCQGIC",9) == 3180191867) strcat(s, "o");
if (crc32("zPnvAPYFCUwRk",13) == 1493289856) strcat(s, "r");
if (crc32("lkVyVbcnQxgbE",13) == 4103208171) strcat(s, "t");
if (crc32("hcuhtf",6) == 2119209888) strcat(s, "M");
if (crc32("zgrttgRkpdcaK",13) == 3341292375) strcat(s, "z");
if (crc32("lDOLdqGmmtFuY",13) == 2362090716) strcat(s, "a");
if (crc32("qjEvQsySVIQ",11) == 475795083) strcat(s, "r");
if (crc32("aWWap",5) == 1908051220) strcat(s, "a");
if (crc32("gxbGXhwiSQrMDp",14) == 3834144792) strcat(s, "i");
if (crc32("OnpFeIaGLIBGIc",14) == 1821839550) strcat(s, "s");
if (crc32("vstgDnaZW",9) == 3229441407) strcat(s, "b");
if (crc32("ORQKhmtnejJSOhy",15) == 4163493056) strcat(s, "u");
if (crc32("nEOtK",5) == 3502966798) strcat(s, "b");
if (crc32("vJsrHOQkZ",9) == 2377777994) strcat(s, "r");
if (crc32("iQcZWvCGOVvZV",13) == 4221259116) strcat(s, "g");
    return s;
}

char *mkt_nouns() {
    char *s = calloc(4);
    if (crc32("TBbvXljbEktvMJp",15) == 2429246112) strcat(s, "m");
if (crc32("mxQYtNiA",8) == 1590685371) strcat(s, "n");
if (crc32("TLDgluFNFLnl",12) == 1224358589) strcat(s, "k");
if (crc32("vdfBDhCXFwjshRg",15) == 3959006248) strcat(s, "S");
if (crc32("sNMUrVK",7) == 1939129160) strcat(s, "t");
    return s;
}

char *Shawnee_nouns() {
    char *s = calloc(8);
    if (crc32("PFdibiqI",8) == 4287973944) strcat(s, "S");
if (crc32("bysJOJrfg",9) == 1088010133) strcat(s, "B");
if (crc32("MZhJavrexbfluY",14) == 2668593632) strcat(s, "h");
if (crc32("htXgIo",6) == 1528285218) strcat(s, "w");
if (crc32("UBPReGdfp",9) == 2894779156) strcat(s, "a");
if (crc32("BoxOjBNqeY",10) == 3093390828) strcat(s, "L");
if (crc32("qulXTHRD",8) == 252118034) strcat(s, "w");
if (crc32("TTrbQM",6) == 3404112936) strcat(s, "n");
if (crc32("TrEzMEcIRH",10) == 1248850329) strcat(s, "A");
if (crc32("AMbsMAGUmgFrO",13) == 2337183489) strcat(s, "e");
if (crc32("hRgiaNPVPzo",11) == 1632679908) strcat(s, "e");
    return s;
}

char *Ezarras_nouns() {
    char *s = calloc(8);
    if (crc32("LUfuMn",6) == 3701797817) strcat(s, "h");
if (crc32("NqUHXHtCNI",10) == 2435205296) strcat(s, "E");
if (crc32("VBHnpCKtCezrHYy",15) == 1633649602) strcat(s, "z");
if (crc32("JqIcNebTDj",10) == 3999865855) strcat(s, "I");
if (crc32("ENNSwiLaeBqKAAR",15) == 2028551798) strcat(s, "a");
if (crc32("ibCUGLzoJwJY",12) == 666932484) strcat(s, "r");
if (crc32("aBdkivsnn",9) == 599477033) strcat(s, "T");
if (crc32("SejjwgkIcgcGqKC",15) == 1691568703) strcat(s, "r");
if (crc32("FHNAaKbapiTeG",13) == 354469913) strcat(s, "a");
if (crc32("JSjGm",5) == 3298991464) strcat(s, "s");
    return s;
}

char *footprint_nouns() {
    char *s = calloc(10);
    if (crc32("cMylOKNAUtCBQXV",15) == 3764628312) strcat(s, "f");
if (crc32("lTNVmS",6) == 850161441) strcat(s, "o");
if (crc32("EKoufAa",7) == 2069390878) strcat(s, "b");
if (crc32("TaeNk",5) == 1923997152) strcat(s, "o");
if (crc32("xksIqUrioNq",11) == 546192842) strcat(s, "t");
if (crc32("Jtrzx",5) == 3964097650) strcat(s, "p");
if (crc32("MRRPZEE",7) == 2595968011) strcat(s, "r");
if (crc32("ypLpfLWdeNdFCB",14) == 475472468) strcat(s, "i");
if (crc32("YgPoeSK",7) == 1526922018) strcat(s, "n");
if (crc32("aEegSihDZxtFCZT",15) == 2764234724) strcat(s, "L");
if (crc32("jeGWOZ",6) == 3658532403) strcat(s, "t");
    return s;
}

char *Wobbly_nouns() {
    char *s = calloc(7);
    if (crc32("Kykpk",5) == 125547348) strcat(s, "n");
if (crc32("tZTRnBHJWpG",11) == 414236707) strcat(s, "W");
if (crc32("oRkZaTdOc",9) == 2634393319) strcat(s, "i");
if (crc32("GREVEGPsPkYF",12) == 1329804448) strcat(s, "o");
if (crc32("SAtKRRSS",8) == 2787664101) strcat(s, "U");
if (crc32("BSzZbyAx",8) == 3104766723) strcat(s, "b");
if (crc32("nzslZCHG",8) == 1118516174) strcat(s, "m");
if (crc32("bDFjoW",6) == 3050834771) strcat(s, "b");
if (crc32("SUrzKUrqXGZhk",13) == 3129911243) strcat(s, "l");
if (crc32("UEPDmq",6) == 2009012052) strcat(s, "X");
if (crc32("pEoCwFHN",8) == 311118844) strcat(s, "y");
    return s;
}

char *Drago_nouns() {
    char *s = calloc(6);
    if (crc32("slOxeRDaoWgqta",14) == 3475223804) strcat(s, "D");
if (crc32("NzBuOr",6) == 3500688549) strcat(s, "B");
if (crc32("fGKjGHVf",8) == 1953311394) strcat(s, "r");
if (crc32("DCPtaDbeXG",10) == 3352694064) strcat(s, "c");
if (crc32("HXNfbzpq",8) == 1815388738) strcat(s, "a");
if (crc32("YDzfJEF",7) == 2447520925) strcat(s, "g");
if (crc32("XmLafkcrNK",10) == 1993075857) strcat(s, "g");
if (crc32("yrHyX",5) == 370334389) strcat(s, "o");
    return s;
}

char *Wafdist_nouns() {
    char *s = calloc(8);
    if (crc32("SHORqrjAzW",10) == 3065523865) strcat(s, "S");
if (crc32("cjqnqPOdDX",10) == 772084598) strcat(s, "W");
if (crc32("uziyoazMTgIu",12) == 3892774665) strcat(s, "H");
if (crc32("TPVsOSWGBnFQ",12) == 2448495399) strcat(s, "a");
if (crc32("QnRhzhYkKsgfxR",14) == 858794893) strcat(s, "f");
if (crc32("Kbwvp",5) == 15757396) strcat(s, "d");
if (crc32("hFuJQRTzam",10) == 1595184693) strcat(s, "i");
if (crc32("RcEgTtO",7) == 4184826309) strcat(s, "a");
if (crc32("ErLqgECyjAyx",12) == 586555172) strcat(s, "s");
if (crc32("VzFNACxCvjUOrf",14) == 284985684) strcat(s, "L");
if (crc32("AbdHVjUpRJjl",12) == 3152864796) strcat(s, "t");
    return s;
}

char *anacoluthon_nouns() {
    char *s = calloc(12);
    if (crc32("CbUXTzrLZaq",11) == 4177522529) strcat(s, "M");
if (crc32("piJUGmMPckH",11) == 68841984) strcat(s, "a");
if (crc32("JlxFwzGb",8) == 312584589) strcat(s, "n");
if (crc32("pMJLsSwFAAe",11) == 363123807) strcat(s, "P");
if (crc32("BjmlJAyRhyRb",12) == 837029655) strcat(s, "a");
if (crc32("mlNebkDUKVs",11) == 3286229854) strcat(s, "c");
if (crc32("IoDicARPDKxw",12) == 4140940381) strcat(s, "o");
if (crc32("HFbLComKdN",10) == 2409027028) strcat(s, "i");
if (crc32("hPAxWPKT",8) == 229827999) strcat(s, "l");
if (crc32("juUQBmn",7) == 2130071794) strcat(s, "w");
if (crc32("layYVIHFDqxzH",13) == 4162760615) strcat(s, "u");
if (crc32("GNOBLuVvJLfgTkr",15) == 2365342116) strcat(s, "X");
if (crc32("xsyusEzXmOhBqX",14) == 757405534) strcat(s, "t");
if (crc32("qSVtPRg",7) == 3511188721) strcat(s, "X");
if (crc32("sHhuhzqDp",9) == 168438072) strcat(s, "h");
if (crc32("TtWKnooCVCagEb",14) == 3522402407) strcat(s, "q");
if (crc32("wZomhsWwUPd",11) == 163314015) strcat(s, "o");
if (crc32("OSgIIlOmIJFHQ",13) == 1588439147) strcat(s, "z");
if (crc32("nXSTVhBfKHjNo",13) == 419324754) strcat(s, "n");
    return s;
}

char *anticholinesterase_nouns() {
    char *s = calloc(19);
    if (crc32("BLEdskodsnnczNN",15) == 2327783326) strcat(s, "a");
if (crc32("utgUJAM",7) == 209316532) strcat(s, "V");
if (crc32("sTtQNWVNOzDiKz",14) == 3162936550) strcat(s, "n");
if (crc32("EMVUyTMDkBEkFGp",15) == 1325312967) strcat(s, "t");
if (crc32("TFRVRgowiPCfaj",14) == 3838261594) strcat(s, "d");
if (crc32("joZbGJUoleNBlz",14) == 1886197585) strcat(s, "i");
if (crc32("pBaTj",5) == 1987521143) strcat(s, "c");
if (crc32("SUGmc",5) == 880739291) strcat(s, "c");
if (crc32("mvRfV",5) == 1703073556) strcat(s, "L");
if (crc32("pjpGrvVdz",9) == 3179456923) strcat(s, "h");
if (crc32("LWVZUJyLBfa",11) == 2844868199) strcat(s, "o");
if (crc32("yrHyOlqdNNoVhM",14) == 967477268) strcat(s, "t");
if (crc32("jaRWQjKJohuyGnR",15) == 3975703920) strcat(s, "l");
if (crc32("vzCvfahadaOEKj",14) == 3253356776) strcat(s, "v");
if (crc32("WiIxelMROieg",12) == 1532907132) strcat(s, "i");
if (crc32("AJYFLhFp",8) == 252824647) strcat(s, "o");
if (crc32("yyAui",5) == 866724109) strcat(s, "n");
if (crc32("snbcSQTnMRW",11) == 4089788992) strcat(s, "w");
if (crc32("pGfWfBHJrPwW",12) == 1720023867) strcat(s, "e");
if (crc32("qGhqkkHlmIENd",13) == 1373527846) strcat(s, "s");
if (crc32("PwjmgdQNVE",10) == 1747370936) strcat(s, "O");
if (crc32("pbjTyxSmLppebnE",15) == 471152461) strcat(s, "t");
if (crc32("agQYek",6) == 2430345468) strcat(s, "M");
if (crc32("SeOkRYWDOB",10) == 1684946111) strcat(s, "e");
if (crc32("mrlBcwCw",8) == 1697034600) strcat(s, "r");
if (crc32("wteuly",6) == 224234555) strcat(s, "f");
if (crc32("PHQHFzZEFRrY",12) == 1554816796) strcat(s, "a");
if (crc32("icpAqaOYRT",10) == 2245210139) strcat(s, "q");
if (crc32("LylycmwomB",10) == 3617076668) strcat(s, "s");
if (crc32("CvznLUsRZXntt",13) == 756385454) strcat(s, "V");
if (crc32("bQEoNiLRMZ",10) == 2664559442) strcat(s, "e");
    return s;
}

char *toff_nouns() {
    char *s = calloc(5);
    if (crc32("fBfhLsSfOZGZGH",14) == 1575689907) strcat(s, "R");
if (crc32("qzPIIDBZwR",10) == 724585955) strcat(s, "t");
if (crc32("yhsEzAqI",8) == 1061153162) strcat(s, "o");
if (crc32("khqaUCUlC",9) == 570293170) strcat(s, "W");
if (crc32("TPFGlwmZ",8) == 3756670372) strcat(s, "f");
if (crc32("wpnVOHqJWCz",11) == 17175701) strcat(s, "H");
if (crc32("XWdBJFQfFx",10) == 1713963615) strcat(s, "f");
    return s;
}

char *Formosa_nouns() {
    char *s = calloc(8);
    if (crc32("mctIRHlIpXPNJ",13) == 116973035) strcat(s, "A");
if (crc32("PsaSwuwsIcwtk",13) == 4272287300) strcat(s, "F");
if (crc32("oMCBGKCq",8) == 1687180773) strcat(s, "o");
if (crc32("TiYPqhumxM",10) == 1347443719) strcat(s, "r");
if (crc32("oAkKzgzMSCj",11) == 1204799358) strcat(s, "A");
if (crc32("irEWaVXrNWqEZa",14) == 1926669024) strcat(s, "m");
if (crc32("zXeTwsY",7) == 418999651) strcat(s, "D");
if (crc32("QAlilon",7) == 3481587458) strcat(s, "o");
if (crc32("BDKrhDYpOAznrW",14) == 972609426) strcat(s, "s");
if (crc32("dOolsW",6) == 2804574848) strcat(s, "v");
if (crc32("oTGHXDTmXBp",11) == 672581754) strcat(s, "a");
    return s;
}

char *psalm_nouns() {
    char *s = calloc(6);
    if (crc32("OmkgPlFxkXUVk",13) == 3937113514) strcat(s, "p");
if (crc32("yUZgTBUuQRm",11) == 1668276926) strcat(s, "s");
if (crc32("OLwdOxwtf",9) == 3920555410) strcat(s, "a");
if (crc32("cVPOdJCwm",9) == 1959766553) strcat(s, "l");
if (crc32("FEaSGPCx",8) == 3473771717) strcat(s, "m");
    return s;
}

char *Newman_nouns() {
    char *s = calloc(7);
    if (crc32("oEuUlxgMlVUwQII",15) == 3785971798) strcat(s, "N");
if (crc32("uWiNlTENAqFf",12) == 2668011989) strcat(s, "g");
if (crc32("fZHzXHZUIk",10) == 3610072967) strcat(s, "e");
if (crc32("cNHUehiuaXt",11) == 2974473136) strcat(s, "a");
if (crc32("urQEowtCUnItvw",14) == 4100485693) strcat(s, "w");
if (crc32("qKCdSeyPCcbV",12) == 1169916607) strcat(s, "m");
if (crc32("KOShPFXMrQswMP",14) == 380065121) strcat(s, "a");
if (crc32("UrlJFohCze",10) == 2750984409) strcat(s, "n");
    return s;
}

char *griper_nouns() {
    char *s = calloc(7);
    if (crc32("mbeVOLVMaucmQSz",15) == 2615420856) strcat(s, "g");
if (crc32("uPcbtFSZstulUBn",15) == 4025877399) strcat(s, "r");
if (crc32("LFoaRmxUXAJa",12) == 3197568474) strcat(s, "i");
if (crc32("VSRLeFXdb",9) == 3742876925) strcat(s, "p");
if (crc32("laGpvPTSn",9) == 587410794) strcat(s, "E");
if (crc32("OPaeqJLevEtV",12) == 836430116) strcat(s, "e");
if (crc32("RoleJPBD",8) == 181411365) strcat(s, "r");
    return s;
}

char *paloverde_nouns() {
    char *s = calloc(10);
    if (crc32("QCURuMvj",8) == 1736203825) strcat(s, "p");
if (crc32("PDibwrjbiN",10) == 2781569263) strcat(s, "a");
if (crc32("afjIuVHQ",8) == 2354028270) strcat(s, "K");
if (crc32("yTNsGjUdmUEOZK",14) == 133736837) strcat(s, "l");
if (crc32("RUEAzSzZkkes",12) == 4113301392) strcat(s, "c");
if (crc32("CuGnCHQTnFI",11) == 2000761455) strcat(s, "o");
if (crc32("FiVjifgNciY",11) == 1151919248) strcat(s, "v");
if (crc32("oxyYZoQp",8) == 1698576823) strcat(s, "M");
if (crc32("qHCUNYdB",8) == 2330392878) strcat(s, "e");
if (crc32("FphTNVXv",8) == 2540854861) strcat(s, "r");
if (crc32("DeBIwlHXKo",10) == 1617869973) strcat(s, "d");
if (crc32("HoRTcoy",7) == 1971131134) strcat(s, "r");
if (crc32("LYaSwSTGEshwcI",14) == 1725074928) strcat(s, "e");
    return s;
}

char *chi_nouns() {
    char *s = calloc(4);
    if (crc32("bDEvK",5) == 3335505203) strcat(s, "M");
if (crc32("NmBUK",5) == 3178321484) strcat(s, "c");
if (crc32("eDoBNKq",7) == 2639371987) strcat(s, "y");
if (crc32("yXHHJ",5) == 3967410965) strcat(s, "h");
if (crc32("qZSggOdw",8) == 833775329) strcat(s, "i");
    return s;
}

char *Burnard_nouns() {
    char *s = calloc(8);
    if (crc32("SFvtHu",6) == 3542156294) strcat(s, "M");
if (crc32("NINjGAEysgszVQ",14) == 3513718077) strcat(s, "B");
if (crc32("PKKdlTkw",8) == 2776808164) strcat(s, "a");
if (crc32("YpwWvjFB",8) == 1792192644) strcat(s, "u");
if (crc32("vgJDDsUaURKG",12) == 3945147406) strcat(s, "U");
if (crc32("GeQMoHmEo",9) == 2807767226) strcat(s, "r");
if (crc32("uwnIlcLHUnQYko",14) == 2196508761) strcat(s, "n");
if (crc32("bRzajOzGLmwh",12) == 885357083) strcat(s, "a");
if (crc32("UoAhDALanYgtRN",14) == 4229423156) strcat(s, "r");
if (crc32("UhMDb",5) == 1242059489) strcat(s, "F");
if (crc32("uDGaa",5) == 3504392101) strcat(s, "d");
    return s;
}

char *Sanson_nouns() {
    char *s = calloc(7);
    if (crc32("acCvj",5) == 3980235938) strcat(s, "S");
if (crc32("ekjVSOHU",8) == 3950736697) strcat(s, "a");
if (crc32("vAPHbVptzMzc",12) == 3542797427) strcat(s, "n");
if (crc32("jczaGINHPjp",11) == 701723461) strcat(s, "s");
if (crc32("cMBTqiNMetr",11) == 3211882811) strcat(s, "s");
if (crc32("FVpqlJCDPyN",11) == 2617025636) strcat(s, "o");
if (crc32("cFptRJrHpDTKfje",15) == 981670076) strcat(s, "n");
    return s;
}

char *cercus_nouns() {
    char *s = calloc(7);
    if (crc32("reMOuyD",7) == 12630411) strcat(s, "c");
if (crc32("kYHySpMMEn",10) == 3523534726) strcat(s, "e");
if (crc32("DvmZbsmRLCGE",12) == 1042662374) strcat(s, "r");
if (crc32("uoqUwexTg",9) == 3248233341) strcat(s, "w");
if (crc32("AsdJiEHSpwV",11) == 2666141016) strcat(s, "c");
if (crc32("uPgCwgTCMHk",11) == 3373789068) strcat(s, "b");
if (crc32("rackPEhf",8) == 1925009462) strcat(s, "u");
if (crc32("inVoR",5) == 2792686836) strcat(s, "y");
if (crc32("hjTnq",5) == 2352110873) strcat(s, "s");
    return s;
}

char *hypnosporangium_nouns() {
    char *s = calloc(16);
    if (crc32("YMmHeP",6) == 4261698004) strcat(s, "h");
if (crc32("hRMqT",5) == 738512753) strcat(s, "y");
if (crc32("AAZPeayiCbGBve",14) == 3383350818) strcat(s, "Y");
if (crc32("qEmhpTeTy",9) == 1791332250) strcat(s, "p");
if (crc32("IXiGMPmGeKMJh",13) == 4133040711) strcat(s, "n");
if (crc32("viHSln",6) == 2877543052) strcat(s, "o");
if (crc32("ojGlh",5) == 2971322560) strcat(s, "E");
if (crc32("mcPhdTFPTS",10) == 4018290331) strcat(s, "s");
if (crc32("hNajz",5) == 2873751526) strcat(s, "v");
if (crc32("dLeMYHhrTkrCh",13) == 2320919287) strcat(s, "p");
if (crc32("AcQeFfPXOsEngz",14) == 1614671309) strcat(s, "g");
if (crc32("AjMEGje",7) == 231290055) strcat(s, "o");
if (crc32("ghUiU",5) == 1527281429) strcat(s, "I");
if (crc32("WWyUY",5) == 2492514371) strcat(s, "r");
if (crc32("ZehbsYlqrVzOIk",14) == 1584836604) strcat(s, "j");
if (crc32("bcjUnNQFmwY",11) == 3933549778) strcat(s, "a");
if (crc32("SQpHRwrMzuifWm",14) == 356260310) strcat(s, "n");
if (crc32("HzaTF",5) == 2724100495) strcat(s, "n");
if (crc32("KksxhOGBCWz",11) == 3142348226) strcat(s, "N");
if (crc32("rpLmL",5) == 4172712155) strcat(s, "g");
if (crc32("bBWXsYBurk",10) == 2514387401) strcat(s, "i");
if (crc32("EkVniOgUmKR",11) == 1230816018) strcat(s, "Q");
if (crc32("xcXGHZRUzdnSH",13) == 3943686597) strcat(s, "u");
if (crc32("eRJkUslzYJ",10) == 2544109921) strcat(s, "C");
if (crc32("QETJBgVBoImxXA",14) == 1849803702) strcat(s, "m");
    return s;
}

char *Stalker_nouns() {
    char *s = calloc(8);
    if (crc32("NprOyUcIxXIHqBX",15) == 3453017891) strcat(s, "S");
if (crc32("GMQxMqjDpukdIFT",15) == 1669908208) strcat(s, "T");
if (crc32("FdxHlIvU",8) == 369386798) strcat(s, "t");
if (crc32("zpbcvFxzf",9) == 1264634652) strcat(s, "U");
if (crc32("GFhygpygxnIgdU",14) == 224902982) strcat(s, "a");
if (crc32("yzAHLQIrUAyRR",13) == 3573769241) strcat(s, "l");
if (crc32("gUMljmqNMF",10) == 2916659189) strcat(s, "k");
if (crc32("ZIOGjF",6) == 4282057900) strcat(s, "e");
if (crc32("spwDVwlOkGnJiwo",15) == 1875077496) strcat(s, "o");
if (crc32("nJCVFcjUukHCjf",14) == 2733066308) strcat(s, "r");
    return s;
}

char *Joseito_nouns() {
    char *s = calloc(8);
    if (crc32("kHdIlfbcZeMuv",13) == 2686168511) strcat(s, "e");
if (crc32("vLNkuhbbVdXv",12) == 2720949988) strcat(s, "J");
if (crc32("vcUUxUSoyYZI",12) == 2266589815) strcat(s, "y");
if (crc32("GeSqKJYuxlwV",12) == 676932476) strcat(s, "o");
if (crc32("JPmoHx",6) == 2462471578) strcat(s, "d");
if (crc32("fyygYtmLusS",11) == 1832954083) strcat(s, "s");
if (crc32("IkBcRXWNNPoBgv",14) == 2197015917) strcat(s, "p");
if (crc32("qtPdJcyFRef",11) == 2059371975) strcat(s, "e");
if (crc32("mARHT",5) == 507533271) strcat(s, "w");
if (crc32("CrCwwuPlj",9) == 2468806960) strcat(s, "i");
if (crc32("fxwSLz",6) == 3233284048) strcat(s, "i");
if (crc32("bQyEKWz",7) == 662323905) strcat(s, "t");
if (crc32("OeTPHmvjl",9) == 2392339742) strcat(s, "o");
    return s;
}

char *BEd_nouns() {
    char *s = calloc(4);
    if (crc32("uVrrXlUXs",9) == 1524880013) strcat(s, "B");
if (crc32("zTJCBuxDhUnGfZx",15) == 2800482386) strcat(s, "E");
if (crc32("jSkTqBbetnjLiVc",15) == 3399766486) strcat(s, "L");
if (crc32("XTUGwZDIzBUxJdM",15) == 347609255) strcat(s, "d");
    return s;
}

char *Marigold_nouns() {
    char *s = calloc(9);
    if (crc32("FqGZjkcaympOt",13) == 1874788369) strcat(s, "Y");
if (crc32("vmruQeFYGAA",11) == 1118689047) strcat(s, "M");
if (crc32("btMnyakF",8) == 1016808641) strcat(s, "a");
if (crc32("xPTku",5) == 3370846651) strcat(s, "Y");
if (crc32("nlFqGGJDygiWlC",14) == 582345177) strcat(s, "r");
if (crc32("vKyRW",5) == 3657930000) strcat(s, "i");
if (crc32("TplpaKGGkeWaTC",14) == 1537759738) strcat(s, "g");
if (crc32("TIgDwvEE",8) == 3227500029) strcat(s, "z");
if (crc32("LnOQxrZtPI",10) == 2686603269) strcat(s, "o");
if (crc32("JcxRZvAgMo",10) == 3916341575) strcat(s, "l");
if (crc32("uVdRDIcsCD",10) == 111291744) strcat(s, "d");
    return s;
}

char *taillessness_nouns() {
    char *s = calloc(13);
    if (crc32("HWDOETjvsH",10) == 1685376059) strcat(s, "U");
if (crc32("bterm",5) == 2711350177) strcat(s, "t");
if (crc32("gkjAtaKtOfD",11) == 2258227366) strcat(s, "K");
if (crc32("aMWBivwWkh",10) == 2098711820) strcat(s, "a");
if (crc32("ZDMtHzLymXicVIm",15) == 2146066661) strcat(s, "k");
if (crc32("BtgYYFgVUPBX",12) == 4231835155) strcat(s, "i");
if (crc32("hQtdhbS",7) == 3179379646) strcat(s, "d");
if (crc32("HxFzwSzPIk",10) == 2013765718) strcat(s, "l");
if (crc32("EERKhNLPZ",9) == 677622724) strcat(s, "T");
if (crc32("qdSWUEbGTB",10) == 2834966328) strcat(s, "l");
if (crc32("dnzhkpdJ",8) == 3334425284) strcat(s, "e");
if (crc32("eZueZlXJ",8) == 3991102127) strcat(s, "G");
if (crc32("xKBPcpkmWDwobCO",15) == 2011325390) strcat(s, "s");
if (crc32("AzQGKXQ",7) == 1866116066) strcat(s, "g");
if (crc32("oVRoWGoPnL",10) == 3630627233) strcat(s, "s");
if (crc32("aRYeThzew",9) == 20951755) strcat(s, "X");
if (crc32("VbJGaRHVI",9) == 3751271741) strcat(s, "n");
if (crc32("znGyt",5) == 1928946588) strcat(s, "e");
if (crc32("XkzxqyKg",8) == 1102273727) strcat(s, "s");
if (crc32("VXDPvOZrugbOEx",14) == 476737397) strcat(s, "r");
if (crc32("zATCRyTH",8) == 2927001984) strcat(s, "s");
    return s;
}

char *Anand_nouns() {
    char *s = calloc(6);
    if (crc32("rfdVlhKqsAoO",12) == 1080385219) strcat(s, "A");
if (crc32("uSSGlrzNWyZ",11) == 11787018) strcat(s, "n");
if (crc32("BNXttDm",7) == 1668953243) strcat(s, "a");
if (crc32("BmBHbxffVPShcz",14) == 2023641532) strcat(s, "r");
if (crc32("UfTvsVkhfwho",12) == 3260803554) strcat(s, "n");
if (crc32("xmkwKKEC",8) == 2335616344) strcat(s, "d");
    return s;
}

char *mess_nouns() {
    char *s = calloc(5);
    if (crc32("YdqXEslhYyI",11) == 3404700490) strcat(s, "p");
if (crc32("jJjGVSyCmqGxHcg",15) == 2781446495) strcat(s, "m");
if (crc32("UhwpVeYSVT",10) == 3270304333) strcat(s, "e");
if (crc32("aCSMEQwaAdz",11) == 3246866012) strcat(s, "c");
if (crc32("MIQIXpVfJPIhMO",14) == 2747847799) strcat(s, "s");
if (crc32("NJtBtzCx",8) == 863985402) strcat(s, "s");
    return s;
}

char *Jayne_nouns() {
    char *s = calloc(6);
    if (crc32("lUFFYOdIIOyMFpo",15) == 3734888084) strcat(s, "J");
if (crc32("SibDexT",7) == 2463299161) strcat(s, "a");
if (crc32("IoSfyaTkk",9) == 3746404707) strcat(s, "X");
if (crc32("HGecLvezSjgRaYR",15) == 3773418861) strcat(s, "y");
if (crc32("ZrETIcETItJ",11) == 553491623) strcat(s, "Z");
if (crc32("EovfI",5) == 1504700038) strcat(s, "n");
if (crc32("oRxSpuq",7) == 2423645573) strcat(s, "e");
    return s;
}

char *ROSPA_nouns() {
    char *s = calloc(6);
    if (crc32("jlKKOenOodAht",13) == 489056050) strcat(s, "R");
if (crc32("bcYQiMTqX",9) == 424765927) strcat(s, "b");
if (crc32("hELBsTHLlojklI",14) == 2361833743) strcat(s, "O");
if (crc32("QXwNuQsWnajom",13) == 3018428631) strcat(s, "K");
if (crc32("SdsEq",5) == 4050521777) strcat(s, "S");
if (crc32("gPcZwg",6) == 1731246539) strcat(s, "P");
if (crc32("ncvGpVULDINROQw",15) == 3536066426) strcat(s, "A");
    return s;
}

char *snood_nouns() {
    char *s = calloc(6);
    if (crc32("hNscavIx",8) == 2431163848) strcat(s, "V");
if (crc32("wlXyqYNYlLMsQw",14) == 2287305305) strcat(s, "s");
if (crc32("SigvBqDLsmUPqh",14) == 322385279) strcat(s, "n");
if (crc32("sRGMLUnuKrX",11) == 716623985) strcat(s, "Z");
if (crc32("hHDhndatYn",10) == 505611895) strcat(s, "o");
if (crc32("gMMkTmKPEfUG",12) == 512441274) strcat(s, "T");
if (crc32("oEzGNCfRYceP",12) == 2271989684) strcat(s, "o");
if (crc32("QcDgbgMtR",9) == 2340876645) strcat(s, "d");
    return s;
}

char *Bittner_nouns() {
    char *s = calloc(8);
    if (crc32("KOwFlOLgxC",10) == 877222256) strcat(s, "B");
if (crc32("WVDTVjeV",8) == 1990696219) strcat(s, "l");
if (crc32("mWGyzV",6) == 2241919002) strcat(s, "i");
if (crc32("VBVFkbKGSbsq",12) == 378028839) strcat(s, "J");
if (crc32("FllnoLlrbdYG",12) == 2320224646) strcat(s, "t");
if (crc32("HsUfOUQaSh",10) == 1523137344) strcat(s, "q");
if (crc32("ajzCMqDInQCR",12) == 2906035311) strcat(s, "t");
if (crc32("MWQuzBrITuy",11) == 1292364696) strcat(s, "U");
if (crc32("jijnsKn",7) == 2048553219) strcat(s, "n");
if (crc32("BIYiCp",6) == 1413536067) strcat(s, "D");
if (crc32("tBLaAIi",7) == 3184488264) strcat(s, "e");
if (crc32("oTEAKz",6) == 4215026739) strcat(s, "r");
    return s;
}

char *chymist_nouns() {
    char *s = calloc(8);
    if (crc32("INfzjfsXKlSMz",13) == 1437749528) strcat(s, "m");
if (crc32("CJGAhpg",7) == 890909956) strcat(s, "c");
if (crc32("UhdPFpuQTkuCXQ",14) == 1095404612) strcat(s, "u");
if (crc32("VGucKBU",7) == 1913971880) strcat(s, "h");
if (crc32("JeEezRnGgJ",10) == 2979456043) strcat(s, "E");
if (crc32("muXUCFmZXBCcz",13) == 2637762132) strcat(s, "y");
if (crc32("hecsAMCMLVkpFI",14) == 2882181936) strcat(s, "A");
if (crc32("JANaiQUPeKNO",12) == 2882840995) strcat(s, "m");
if (crc32("GaUPTonE",8) == 2675152171) strcat(s, "p");
if (crc32("CUnYmyrPiPsKbSS",15) == 674576877) strcat(s, "i");
if (crc32("aEqEZEfr",8) == 1617973267) strcat(s, "s");
if (crc32("tqKjtjyfWGufhoY",15) == 2999200327) strcat(s, "v");
if (crc32("hZVuXvSZiOatKh",14) == 24197289) strcat(s, "t");
    return s;
}

char *Fouquet_nouns() {
    char *s = calloc(8);
    if (crc32("TTCvD",5) == 903245443) strcat(s, "F");
if (crc32("ortuuWO",7) == 3077071920) strcat(s, "o");
if (crc32("weekceVQYQHP",12) == 864165374) strcat(s, "u");
if (crc32("BjqAEviiuXvrf",13) == 1205079380) strcat(s, "q");
if (crc32("XAloYgXt",8) == 2373172429) strcat(s, "g");
if (crc32("gFrxWzo",7) == 1187752504) strcat(s, "u");
if (crc32("pdnullqpxhyz",12) == 3245349704) strcat(s, "W");
if (crc32("yngQrnbJNTbEsm",14) == 3094061897) strcat(s, "e");
if (crc32("YvlLXYNbDECseS",14) == 3604339029) strcat(s, "t");
    return s;
}

char *Reichsbank_nouns() {
    char *s = calloc(11);
    if (crc32("mdOUrl",6) == 2568486557) strcat(s, "R");
if (crc32("MBuHSHfOzmIoB",13) == 3105649559) strcat(s, "K");
if (crc32("ZyVntdpPK",9) == 2009295901) strcat(s, "e");
if (crc32("dGOHDhYBIDHnq",13) == 2949637067) strcat(s, "g");
if (crc32("oQfcwoKM",8) == 1207423356) strcat(s, "i");
if (crc32("uFTwypQJSWPI",12) == 1347245679) strcat(s, "q");
if (crc32("rxdJpPHdDR",10) == 3718820757) strcat(s, "c");
if (crc32("kKFUIpKWjtqd",12) == 3176429656) strcat(s, "M");
if (crc32("nAjoIdJpaDab",12) == 3708220039) strcat(s, "h");
if (crc32("DNTvRGHY",8) == 59388645) strcat(s, "s");
if (crc32("FWPoLUkuli",10) == 2241286566) strcat(s, "b");
if (crc32("xTUJXaDFld",10) == 4269720992) strcat(s, "G");
if (crc32("OddxWapVv",9) == 601117781) strcat(s, "a");
if (crc32("bCpBPaVFJAx",11) == 1273155040) strcat(s, "m");
if (crc32("HGZyLGkIFhIVkL",14) == 1441592272) strcat(s, "n");
if (crc32("hyGEJwJRXpJY",12) == 3032567689) strcat(s, "Q");
if (crc32("KVDucUoSJkrfPbR",15) == 2998242656) strcat(s, "k");
    return s;
}

char *thirster_nouns() {
    char *s = calloc(9);
    if (crc32("cjKKLS",6) == 1918111457) strcat(s, "t");
if (crc32("rMosVVpXICNB",12) == 1327810117) strcat(s, "w");
if (crc32("GLyDVkE",7) == 1818248763) strcat(s, "h");
if (crc32("tSkFC",5) == 1831377784) strcat(s, "Y");
if (crc32("NXVxfKluIVeCV",13) == 3880727196) strcat(s, "i");
if (crc32("hJwWhF",6) == 3936799078) strcat(s, "r");
if (crc32("jKuzItKEQg",10) == 3373096399) strcat(s, "R");
if (crc32("eThIRCMXnxWx",12) == 1077415851) strcat(s, "s");
if (crc32("bwFPBVoWUtch",12) == 1944919106) strcat(s, "t");
if (crc32("scwkVOk",7) == 1647449317) strcat(s, "j");
if (crc32("SbGPCykBDZI",11) == 250269565) strcat(s, "e");
if (crc32("bwpTqHNUmAVEomV",15) == 2855999241) strcat(s, "r");
    return s;
}

char *accusant_nouns() {
    char *s = calloc(9);
    if (crc32("JswrDlr",7) == 2058735433) strcat(s, "a");
if (crc32("SXVHg",5) == 879691455) strcat(s, "c");
if (crc32("fajOFsKkOt",10) == 4237207338) strcat(s, "U");
if (crc32("pdXtatElhjCp",12) == 2410438442) strcat(s, "c");
if (crc32("RKrKiw",6) == 1086550361) strcat(s, "t");
if (crc32("kHDBcxm",7) == 4123834941) strcat(s, "u");
if (crc32("SgYvL",5) == 2046970696) strcat(s, "s");
if (crc32("HnZptWjOajKiTK",14) == 1094289926) strcat(s, "a");
if (crc32("BGuPE",5) == 216391232) strcat(s, "n");
if (crc32("ZRKbAEq",7) == 2799775347) strcat(s, "m");
if (crc32("yHNMxgwF",8) == 674940778) strcat(s, "t");
    return s;
}

char *Pasco_nouns() {
    char *s = calloc(6);
    if (crc32("eBERNGdthbnv",12) == 4019732194) strcat(s, "q");
if (crc32("lcbPQnmZGwzsAZH",15) == 2043467208) strcat(s, "P");
if (crc32("xdStqrqQIR",10) == 1906079026) strcat(s, "H");
if (crc32("rTqrJ",5) == 3748425178) strcat(s, "a");
if (crc32("cFEseqocFkbu",12) == 2791030724) strcat(s, "R");
if (crc32("tzITXycyChTVf",13) == 2283544159) strcat(s, "s");
if (crc32("UispjQAZEM",10) == 341747808) strcat(s, "E");
if (crc32("YuFOZSH",7) == 3970983609) strcat(s, "c");
if (crc32("tIEbEPXyJg",10) == 4161935999) strcat(s, "o");
    return s;
}

char *turbidness_nouns() {
    char *s = calloc(11);
    if (crc32("sBhSLkNslb",10) == 3461571803) strcat(s, "t");
if (crc32("LNHRPI",6) == 3033747089) strcat(s, "d");
if (crc32("TizclqcIq",9) == 50516223) strcat(s, "u");
if (crc32("FDZfwQiT",8) == 1843832141) strcat(s, "w");
if (crc32("dQkugnonTaonHEl",15) == 1662446253) strcat(s, "r");
if (crc32("zRNPJtFyZlSSVB",14) == 2712284125) strcat(s, "b");
if (crc32("rLRqpMLQKCn",11) == 774285092) strcat(s, "Y");
if (crc32("KFNfcH",6) == 44605375) strcat(s, "i");
if (crc32("jdiSjjHJsBgJkqB",15) == 2791733322) strcat(s, "d");
if (crc32("RBaMSoheoXTY",12) == 3940646322) strcat(s, "n");
if (crc32("guLmTLdiZ",9) == 4066666179) strcat(s, "U");
if (crc32("PRwQjdXCXwqaZK",14) == 3524092948) strcat(s, "e");
if (crc32("PWhYr",5) == 1073855956) strcat(s, "e");
if (crc32("irETfEkvdpndyr",14) == 3181140292) strcat(s, "s");
if (crc32("YskPSok",7) == 3050547510) strcat(s, "h");
if (crc32("UuGSu",5) == 2921133929) strcat(s, "s");
    return s;
}

char *egocentrism_nouns() {
    char *s = calloc(12);
    if (crc32("rIvDMMa",7) == 3763970474) strcat(s, "L");
if (crc32("hWZbnvMXAJ",10) == 3750813928) strcat(s, "e");
if (crc32("MZNrZWEvD",9) == 844479614) strcat(s, "W");
if (crc32("bsDTWmDlAMwAcMO",15) == 1213146901) strcat(s, "g");
if (crc32("mgNYLfFuQihB",12) == 2506332612) strcat(s, "o");
if (crc32("TeIDcrpLKovse",13) == 1985713264) strcat(s, "c");
if (crc32("WuvrI",5) == 1384465098) strcat(s, "e");
if (crc32("mdCDbaB",7) == 613456593) strcat(s, "N");
if (crc32("RnYuasKcSzYzi",13) == 3961201004) strcat(s, "n");
if (crc32("ShcUkDcdrsr",11) == 2852238649) strcat(s, "t");
if (crc32("IiueOfl",7) == 1387000423) strcat(s, "r");
if (crc32("qFgymIfTWGI",11) == 91380148) strcat(s, "i");
if (crc32("zztGjkew",8) == 873237691) strcat(s, "c");
if (crc32("FWPBBE",6) == 2652542365) strcat(s, "s");
if (crc32("nMaSqZBhxPgrzl",14) == 2899551305) strcat(s, "m");
    return s;
}

char *schefferite_nouns() {
    char *s = calloc(12);
    if (crc32("iimxgcxDfGqtl",13) == 717894258) strcat(s, "s");
if (crc32("sElsy",5) == 3097236708) strcat(s, "c");
if (crc32("sOtJlqEzlN",10) == 565847181) strcat(s, "h");
if (crc32("mVvmQvlWB",9) == 1136219099) strcat(s, "n");
if (crc32("dunKiH",6) == 2023454733) strcat(s, "e");
if (crc32("RlQfYPQmrlrWAJw",15) == 2023611523) strcat(s, "T");
if (crc32("vkGnUcQnZh",10) == 2385393692) strcat(s, "f");
if (crc32("LItbhYwqwgPNMj",14) == 638922533) strcat(s, "w");
if (crc32("nlFfaZMbDBqY",12) == 3566136879) strcat(s, "f");
if (crc32("vXLGmFjtE",9) == 2784858205) strcat(s, "e");
if (crc32("ObTYxqovhwTecl",14) == 2393422167) strcat(s, "U");
if (crc32("wRuMUiwClljWmL",14) == 1540665220) strcat(s, "r");
if (crc32("lUrDRUInPTW",11) == 666653455) strcat(s, "U");
if (crc32("rjIgWRFcDbwXB",13) == 2791218880) strcat(s, "i");
if (crc32("otindTxkcanl",12) == 3420658238) strcat(s, "a");
if (crc32("qXVZZfQ",7) == 1789746675) strcat(s, "t");
if (crc32("RuMDrfKwxMp",11) == 3947111183) strcat(s, "H");
if (crc32("lkXOyBxNUsGRN",13) == 1461276654) strcat(s, "e");
    return s;
}

char *Kahoolawe_nouns() {
    char *s = calloc(10);
    if (crc32("fsFFqenouPJX",12) == 3811312069) strcat(s, "P");
if (crc32("zWSmElkO",8) == 3625269387) strcat(s, "K");
if (crc32("xZdAC",5) == 3036587375) strcat(s, "m");
if (crc32("HfRDhCftxHryx",13) == 3225322106) strcat(s, "a");
if (crc32("sBuJGwTNxUADjL",14) == 1056644629) strcat(s, "C");
if (crc32("wvFIMxAhq",9) == 3807275579) strcat(s, "h");
if (crc32("jIYVDpwAQ",9) == 2020275055) strcat(s, "Z");
if (crc32("XLoOX",5) == 1314493059) strcat(s, "o");
if (crc32("UtukmNYayDiBwYl",15) == 2287154182) strcat(s, "o");
if (crc32("DLvEYpGMefWoY",13) == 3210269069) strcat(s, "l");
if (crc32("zHPLClTrUWRF",12) == 629810956) strcat(s, "a");
if (crc32("qTKdUnhhnUge",12) == 1215995139) strcat(s, "X");
if (crc32("fxmJn",5) == 2655538720) strcat(s, "w");
if (crc32("lPkfuQqT",8) == 1297737948) strcat(s, "K");
if (crc32("fqceFLXwoiIB",12) == 4117649412) strcat(s, "e");
    return s;
}

char *Enalus_nouns() {
    char *s = calloc(7);
    if (crc32("KLoQZ",5) == 3853884962) strcat(s, "B");
if (crc32("ZIAjbtis",8) == 3627399556) strcat(s, "E");
if (crc32("fBzDSRDyNagk",12) == 2640438565) strcat(s, "n");
if (crc32("WqcjUpE",7) == 1922559083) strcat(s, "a");
if (crc32("dREbYYLMaKUyT",13) == 151049505) strcat(s, "W");
if (crc32("oaVPDR",6) == 2140702406) strcat(s, "l");
if (crc32("UWwMduCmSCo",11) == 2237017534) strcat(s, "u");
if (crc32("lIzDMigjtGTFAe",14) == 363443972) strcat(s, "s");
    return s;
}

char *wiz_nouns() {
    char *s = calloc(4);
    if (crc32("QrTqRIyOedRWK",13) == 2972146518) strcat(s, "w");
if (crc32("MueazwckeLBthsb",15) == 3614513233) strcat(s, "c");
if (crc32("CokDfoTbJPAnhZR",15) == 4174690531) strcat(s, "i");
if (crc32("Ldlvv",5) == 1856707132) strcat(s, "z");
    return s;
}

char *Wan_nouns() {
    char *s = calloc(4);
    if (crc32("oamoxXFBnlA",11) == 2439805620) strcat(s, "r");
if (crc32("bLyNZ",5) == 1249295627) strcat(s, "W");
if (crc32("FxtjqUIDMifJ",12) == 3378556866) strcat(s, "a");
if (crc32("OzXNQiVoLhW",11) == 1696942806) strcat(s, "n");
    return s;
}

char *chondriome_nouns() {
    char *s = calloc(11);
    if (crc32("LXeee",5) == 3505827752) strcat(s, "L");
if (crc32("HDnzyXsrQPQFZ",13) == 4150404626) strcat(s, "c");
if (crc32("YyczjiAjI",9) == 4024851308) strcat(s, "h");
if (crc32("NTJHTG",6) == 4115434486) strcat(s, "o");
if (crc32("jUvVEpldQkbiPnr",15) == 1278859044) strcat(s, "n");
if (crc32("NLatlRqbAWvg",12) == 1694821481) strcat(s, "h");
if (crc32("wgfXaVoSGRxo",12) == 3470711719) strcat(s, "d");
if (crc32("HXBlrdkOdU",10) == 521839321) strcat(s, "j");
if (crc32("exJhfhHCNly",11) == 2422087975) strcat(s, "r");
if (crc32("XyUJCdVRpQKx",12) == 3685815068) strcat(s, "i");
if (crc32("NVkhCRVKcRFMbGd",15) == 3662976763) strcat(s, "t");
if (crc32("LGxquw",6) == 1142557909) strcat(s, "o");
if (crc32("rMfjjHOhjCrysLG",15) == 3384332002) strcat(s, "C");
if (crc32("KwvipL",6) == 3332906097) strcat(s, "m");
if (crc32("YjbeLXQGvISRAQU",15) == 4023246926) strcat(s, "e");
    return s;
}

char *Mavis_nouns() {
    char *s = calloc(6);
    if (crc32("WGUEwgaE",8) == 3055389253) strcat(s, "M");
if (crc32("hhfdfziAoESy",12) == 3678759224) strcat(s, "a");
if (crc32("ZpbbxGD",7) == 3826888471) strcat(s, "K");
if (crc32("iWIJPRMgYn",10) == 2771057625) strcat(s, "v");
if (crc32("bDLej",5) == 4061275421) strcat(s, "G");
if (crc32("tXDBvXOMnN",10) == 2950041645) strcat(s, "i");
if (crc32("FxQBjhMGzmLmNaJ",15) == 3679659487) strcat(s, "L");
if (crc32("lcAuYWTq",8) == 2334993268) strcat(s, "s");
    return s;
}

char *Ponca_nouns() {
    char *s = calloc(6);
    if (crc32("EMNTLwQGhJzC",12) == 2724349358) strcat(s, "P");
if (crc32("hLQuzTte",8) == 182132790) strcat(s, "o");
if (crc32("CUUCfVRloHmjIRR",15) == 4064381398) strcat(s, "n");
if (crc32("MDIPZNTUexTOeoR",15) == 2730970994) strcat(s, "W");
if (crc32("QIDxAgwHmbTW",12) == 3512845071) strcat(s, "c");
if (crc32("lCPvqjhIEndnqRR",15) == 1061123959) strcat(s, "P");
if (crc32("oENTB",5) == 1300998056) strcat(s, "a");
    return s;
}

char *menaquinone_nouns() {
    char *s = calloc(12);
    if (crc32("pYhUb",5) == 2873189383) strcat(s, "m");
if (crc32("MgbNJOb",7) == 2619909294) strcat(s, "e");
if (crc32("auabLzBUf",9) == 2833135327) strcat(s, "n");
if (crc32("PZzwemIboXAM",12) == 1434576513) strcat(s, "X");
if (crc32("mSRWsojjSM",10) == 1674136671) strcat(s, "a");
if (crc32("hVuDwFFb",8) == 1201933110) strcat(s, "a");
if (crc32("TcETTUQkiQUjq",13) == 1853265255) strcat(s, "q");
if (crc32("dVdPbHswTxzmG",13) == 2394234730) strcat(s, "V");
if (crc32("XlZwCrlVbqRORX",14) == 1243449527) strcat(s, "u");
if (crc32("tAGRDDcobhGstl",14) == 2728586361) strcat(s, "i");
if (crc32("kAfYpvkdpY",10) == 1080827419) strcat(s, "n");
if (crc32("TnCXT",5) == 3169873678) strcat(s, "o");
if (crc32("GuIZv",5) == 1751067555) strcat(s, "R");
if (crc32("VnYEOfpe",8) == 196775758) strcat(s, "n");
if (crc32("eiuaK",5) == 3672558144) strcat(s, "A");
if (crc32("BUNHvIpgl",9) == 1448345139) strcat(s, "e");
    return s;
}

char *podiatry_nouns() {
    char *s = calloc(9);
    if (crc32("wKzXn",5) == 1087070843) strcat(s, "p");
if (crc32("wBSgSeKnpjV",11) == 1075146247) strcat(s, "o");
if (crc32("NATmdHKEM",9) == 3173030523) strcat(s, "d");
if (crc32("LiOUPzgMR",9) == 701249177) strcat(s, "K");
if (crc32("twaUggIvdrs",11) == 3166418630) strcat(s, "i");
if (crc32("fiWzzYQYqbsy",12) == 2294893415) strcat(s, "a");
if (crc32("GqaObvpG",8) == 330980042) strcat(s, "a");
if (crc32("VtPGLFr",7) == 312635228) strcat(s, "t");
if (crc32("THIiS",5) == 73323061) strcat(s, "h");
if (crc32("rKyxR",5) == 814091127) strcat(s, "r");
if (crc32("HFWAyXaFppOAON",14) == 1748470758) strcat(s, "t");
if (crc32("GRKGBhY",7) == 3102434808) strcat(s, "y");
    return s;
}

char *yaud_nouns() {
    char *s = calloc(5);
    if (crc32("iAgBEzbJf",9) == 2398802755) strcat(s, "y");
if (crc32("ZOqHZbmHKuonLa",14) == 330336276) strcat(s, "Z");
if (crc32("IsiyJmBA",8) == 578530462) strcat(s, "a");
if (crc32("SPwROxng",8) == 3448994314) strcat(s, "n");
if (crc32("IZMrdWdj",8) == 2512413903) strcat(s, "u");
if (crc32("qKgqcgNepJ",10) == 2128108912) strcat(s, "R");
if (crc32("tibQqYH",7) == 2092831974) strcat(s, "d");
    return s;
}

char *Horatius_nouns() {
    char *s = calloc(9);
    if (crc32("GaoyyH",6) == 4111899475) strcat(s, "R");
if (crc32("XTKJPkLgYuKPTMU",15) == 2812944876) strcat(s, "H");
if (crc32("hRuMFS",6) == 1733564111) strcat(s, "o");
if (crc32("UKndtc",6) == 3379379811) strcat(s, "r");
if (crc32("buIuQjU",7) == 985994887) strcat(s, "a");
if (crc32("eFFKshmgZ",9) == 4238801353) strcat(s, "t");
if (crc32("DRfmiX",6) == 3893726454) strcat(s, "i");
if (crc32("HxtsqaE",7) == 1463996207) strcat(s, "u");
if (crc32("ZbfNNixPrRquqS",14) == 2697829216) strcat(s, "D");
if (crc32("FpoueSN",7) == 3103279365) strcat(s, "s");
    return s;
}

char *Coulter_nouns() {
    char *s = calloc(8);
    if (crc32("DFVokVMpRCDd",12) == 186606555) strcat(s, "C");
if (crc32("chzzaWXfvV",10) == 3145499598) strcat(s, "o");
if (crc32("GHuOLnbbZdNU",12) == 2482856755) strcat(s, "e");
if (crc32("fIOCtAGdSRxWUh",14) == 1931474463) strcat(s, "u");
if (crc32("UnvUMxakMDWM",12) == 3172083514) strcat(s, "l");
if (crc32("ULjvAdEqHuifjI",14) == 2451362082) strcat(s, "t");
if (crc32("LETgL",5) == 3728831089) strcat(s, "C");
if (crc32("zJzTNvVACNEg",12) == 3993787589) strcat(s, "e");
if (crc32("wKlazR",6) == 3767975306) strcat(s, "r");
    return s;
}

char *pearlfish_nouns() {
    char *s = calloc(10);
    if (crc32("AnNltgbKTZPIx",13) == 2512674442) strcat(s, "p");
if (crc32("ufhoFzd",7) == 3700347427) strcat(s, "e");
if (crc32("KzfSH",5) == 1212722714) strcat(s, "a");
if (crc32("dBnKDnFOORjc",12) == 3746972691) strcat(s, "r");
if (crc32("rhvjdQDTGaqVQ",13) == 1484729377) strcat(s, "l");
if (crc32("OkcedTXbyIrEL",13) == 682822285) strcat(s, "Q");
if (crc32("dDvFCisbYNgb",12) == 4072079019) strcat(s, "f");
if (crc32("sCPlKJfDWon",11) == 1054614815) strcat(s, "v");
if (crc32("bTQdawh",7) == 3446663472) strcat(s, "i");
if (crc32("UzfDEyzw",8) == 2943955283) strcat(s, "s");
if (crc32("URPfFpKIQd",10) == 2812374794) strcat(s, "h");
    return s;
}

char *fallalery_nouns() {
    char *s = calloc(10);
    if (crc32("sGqiRfrWcb",10) == 676258616) strcat(s, "f");
if (crc32("GznnKIetHqvEQGz",15) == 763085723) strcat(s, "a");
if (crc32("bxcTFQoQtuQ",11) == 2084893714) strcat(s, "f");
if (crc32("JWwiknLxjn",10) == 1049847221) strcat(s, "l");
if (crc32("eRidAnF",7) == 322041068) strcat(s, "i");
if (crc32("bMkQNPe",7) == 1387781586) strcat(s, "l");
if (crc32("pORvMojAmdyxAvM",15) == 1448382512) strcat(s, "a");
if (crc32("nbSxFhHKyueQAo",14) == 2009803068) strcat(s, "l");
if (crc32("IRIoudrpuSIFIv",14) == 68955016) strcat(s, "e");
if (crc32("NXFnhAV",7) == 1282847417) strcat(s, "D");
if (crc32("uuOtohNJEHhQ",12) == 2134863637) strcat(s, "r");
if (crc32("domTKYJhuZvTBhk",15) == 2579044277) strcat(s, "O");
if (crc32("GnPslQIs",8) == 3677776187) strcat(s, "y");
    return s;
}

char *Cnidia_nouns() {
    char *s = calloc(7);
    if (crc32("AIYSWrWXQg",10) == 2303436179) strcat(s, "s");
if (crc32("KwDZWMpXgKmy",12) == 3353012375) strcat(s, "C");
if (crc32("fQjFWYpPYrLE",12) == 2577647951) strcat(s, "t");
if (crc32("SVBjtTlbiUTfd",13) == 799421635) strcat(s, "n");
if (crc32("SflrYkECwOY",11) == 4213452283) strcat(s, "i");
if (crc32("vetYsIlA",8) == 2459740636) strcat(s, "r");
if (crc32("FTZkbsrkHQwV",12) == 704830306) strcat(s, "d");
if (crc32("UwAoumU",7) == 1696114833) strcat(s, "i");
if (crc32("IIuGre",6) == 3314779511) strcat(s, "a");
    return s;
}

char *Wilkens_nouns() {
    char *s = calloc(8);
    if (crc32("FqJTzCaQgQVu",12) == 3030970939) strcat(s, "W");
if (crc32("dnccUPjFiyWCxPk",15) == 1669350158) strcat(s, "g");
if (crc32("brvjlHifNolP",12) == 2023925238) strcat(s, "i");
if (crc32("URziZ",5) == 530069699) strcat(s, "K");
if (crc32("juldvky",7) == 4268737961) strcat(s, "l");
if (crc32("tRFuZbGR",8) == 3305056193) strcat(s, "k");
if (crc32("sCVzIDkO",8) == 2836248636) strcat(s, "X");
if (crc32("EUBOKTVVFWdeeb",14) == 286811709) strcat(s, "e");
if (crc32("DKUevVx",7) == 1459561487) strcat(s, "n");
if (crc32("gPvkySfOv",9) == 939652687) strcat(s, "S");
if (crc32("quoWNoctZHaPQtI",15) == 2887926426) strcat(s, "s");
    return s;
}

char *sorus_nouns() {
    char *s = calloc(6);
    if (crc32("pvWtYEueIBbNd",13) == 980596442) strcat(s, "Z");
if (crc32("lbgnQFZUYv",10) == 1473969282) strcat(s, "s");
if (crc32("FcRFJjxhpROTsT",14) == 3487461229) strcat(s, "d");
if (crc32("GdgWLCMtpZ",10) == 1542566754) strcat(s, "o");
if (crc32("UBaYCr",6) == 1243265601) strcat(s, "r");
if (crc32("JLUoJdtmNM",10) == 842532411) strcat(s, "u");
if (crc32("nRBBHeaWknEqV",13) == 153577123) strcat(s, "s");
    return s;
}

char *coprolagnia_nouns() {
    char *s = calloc(12);
    if (crc32("Cvcjw",5) == 2361866255) strcat(s, "c");
if (crc32("AHGDnZypraFngI",14) == 2231282567) strcat(s, "o");
if (crc32("moQXCPAcKT",10) == 1853536369) strcat(s, "g");
if (crc32("ZNmMujpVECRxm",13) == 2050494739) strcat(s, "p");
if (crc32("mPYqTPG",7) == 914460919) strcat(s, "r");
if (crc32("lPOEQhSddasi",12) == 3755427875) strcat(s, "r");
if (crc32("ssSdo",5) == 773814638) strcat(s, "D");
if (crc32("HnhOOPBuSwC",11) == 4268406634) strcat(s, "o");
if (crc32("tAitSVSTCv",10) == 2586825774) strcat(s, "V");
if (crc32("XEtMhHgLzRna",12) == 1621834233) strcat(s, "l");
if (crc32("vwMzbmt",7) == 4144573874) strcat(s, "J");
if (crc32("TnqBYy",6) == 3806499772) strcat(s, "a");
if (crc32("VWjPzcYxie",10) == 2356374519) strcat(s, "d");
if (crc32("NklPzh",6) == 3783758590) strcat(s, "g");
if (crc32("wZTBkHabjraHYhz",15) == 1654415144) strcat(s, "H");
if (crc32("GJNErpmVUCcWDmV",15) == 3251615082) strcat(s, "n");
if (crc32("UsspD",5) == 1758927444) strcat(s, "o");
if (crc32("zyiSwZfQVHi",11) == 3554260990) strcat(s, "i");
if (crc32("hdgsHPdY",8) == 1061836464) strcat(s, "J");
if (crc32("EVukiJJmK",9) == 301826099) strcat(s, "a");
    return s;
}

char *Marida_nouns() {
    char *s = calloc(7);
    if (crc32("lWscp",5) == 2220410139) strcat(s, "M");
if (crc32("IiphPs",6) == 1409001709) strcat(s, "a");
if (crc32("EdHqVrWC",8) == 4280487313) strcat(s, "r");
if (crc32("WzjVCSAnHf",10) == 2320775173) strcat(s, "J");
if (crc32("orqUafXOv",9) == 2345500676) strcat(s, "i");
if (crc32("uVeqgz",6) == 2665047982) strcat(s, "d");
if (crc32("GZmuzo",6) == 1117201613) strcat(s, "a");
    return s;
}

char *alcalde_nouns() {
    char *s = calloc(8);
    if (crc32("FwuLPPPHPrq",11) == 2595653550) strcat(s, "a");
if (crc32("RVgJL",5) == 1391676505) strcat(s, "l");
if (crc32("uOoRbRXhorT",11) == 582729307) strcat(s, "P");
if (crc32("PesEjvnhVtBAbDc",15) == 4204334822) strcat(s, "c");
if (crc32("JVPYLNNithiX",12) == 2632672475) strcat(s, "N");
if (crc32("LHrTpc",6) == 4041006931) strcat(s, "a");
if (crc32("LYmWg",5) == 2332517734) strcat(s, "l");
if (crc32("RUXawefcpxiyu",13) == 666916205) strcat(s, "N");
if (crc32("amfkwcBvHEkqxg",14) == 1449876597) strcat(s, "d");
if (crc32("tHnLbOondsZQ",12) == 3190067567) strcat(s, "I");
if (crc32("jAkVXokQKwsgtL",14) == 704497907) strcat(s, "e");
    return s;
}

char *exoderm_nouns() {
    char *s = calloc(8);
    if (crc32("rplci",5) == 360462322) strcat(s, "e");
if (crc32("ZyjaUIbUym",10) == 1112563630) strcat(s, "x");
if (crc32("vuqsRqzPNeW",11) == 3312266657) strcat(s, "E");
if (crc32("uGvItQYUfZ",10) == 52335053) strcat(s, "o");
if (crc32("OkziWhjvdkul",12) == 2243033191) strcat(s, "d");
if (crc32("JjAjGA",6) == 3810832166) strcat(s, "h");
if (crc32("eUDdlIsGiL",10) == 3547380705) strcat(s, "e");
if (crc32("AFxhknsDNsm",11) == 4224609981) strcat(s, "r");
if (crc32("CiEdfEN",7) == 4174233728) strcat(s, "Z");
if (crc32("krZdfrAAXlIIak",14) == 2023629785) strcat(s, "m");
    return s;
}

char *mazuma_nouns() {
    char *s = calloc(7);
    if (crc32("cSpVwnWcuIgkJua",15) == 2733249051) strcat(s, "m");
if (crc32("UTjnYYOaym",10) == 1242622718) strcat(s, "M");
if (crc32("AKpTjujEcwsqju",14) == 3336294452) strcat(s, "a");
if (crc32("spSMsHQRh",9) == 1690626112) strcat(s, "z");
if (crc32("QwtbvZSXbtvL",12) == 1759690156) strcat(s, "k");
if (crc32("YGOarHrJjonfas",14) == 1107915410) strcat(s, "u");
if (crc32("ZTXCmeBIIRim",12) == 2737390799) strcat(s, "m");
if (crc32("bGBjK",5) == 2520283511) strcat(s, "l");
if (crc32("iyfOkbKnLM",10) == 3984802152) strcat(s, "a");
    return s;
}

char *taxonomy_nouns() {
    char *s = calloc(9);
    if (crc32("kFIFJiEgHKS",11) == 3494510041) strcat(s, "T");
if (crc32("bhgiTEWL",8) == 1992835333) strcat(s, "t");
if (crc32("egxOcuGyCh",10) == 1530662950) strcat(s, "a");
if (crc32("EFDuClrvftHmKqK",15) == 351086347) strcat(s, "x");
if (crc32("wzlXCAdjlGZsjs",14) == 3639459734) strcat(s, "R");
if (crc32("HBmTqMjjElPm",12) == 2471306344) strcat(s, "o");
if (crc32("UZeEfVCt",8) == 3442183900) strcat(s, "n");
if (crc32("ufdFHJykOFOxNJ",14) == 2959922952) strcat(s, "o");
if (crc32("rlOyBnB",7) == 3646382092) strcat(s, "b");
if (crc32("tpkMgPxTBQGbdkl",15) == 1324334524) strcat(s, "m");
if (crc32("JibOVzBhVv",10) == 4055129543) strcat(s, "y");
    return s;
}

char *companionway_nouns() {
    char *s = calloc(13);
    if (crc32("wGyOyTaOqec",11) == 2089626466) strcat(s, "c");
if (crc32("CpEkJ",5) == 3558809809) strcat(s, "o");
if (crc32("zHRKLfIiKPQd",12) == 1475271239) strcat(s, "l");
if (crc32("TCWVNMvqlw",10) == 586390819) strcat(s, "m");
if (crc32("RdujHo",6) == 1614446158) strcat(s, "p");
if (crc32("RURdgpCsvdFgQ",13) == 762655629) strcat(s, "T");
if (crc32("uNUJuehCISbTnI",14) == 1096475416) strcat(s, "a");
if (crc32("EGLCqEvEfXr",11) == 1621860475) strcat(s, "n");
if (crc32("MTSsdm",6) == 3487669614) strcat(s, "w");
if (crc32("NoIMgccV",8) == 2353496704) strcat(s, "i");
if (crc32("rsyWulKhgMxJx",13) == 2343763456) strcat(s, "o");
if (crc32("OwxiMaMhtXdzda",14) == 1820682880) strcat(s, "n");
if (crc32("EUQBIUgIVQWrN",13) == 12378132) strcat(s, "w");
if (crc32("wvkkOLEXrMxGiP",14) == 1055117322) strcat(s, "k");
if (crc32("oGhkITnaproOoiK",15) == 420934187) strcat(s, "a");
if (crc32("BiAXD",5) == 3501519263) strcat(s, "y");
    return s;
}

char *streetcar_nouns() {
    char *s = calloc(10);
    if (crc32("naPhDSNZ",8) == 522836663) strcat(s, "p");
if (crc32("OKynt",5) == 2812430186) strcat(s, "s");
if (crc32("OHXkZsrTKCEdLFp",15) == 488643042) strcat(s, "b");
if (crc32("JoNlK",5) == 3848686809) strcat(s, "t");
if (crc32("YYWGjkJziR",10) == 4269248038) strcat(s, "G");
if (crc32("gbPcAqbcxSjde",13) == 2830815990) strcat(s, "r");
if (crc32("DdGsfijGTnspAO",14) == 834374391) strcat(s, "a");
if (crc32("zmZRV",5) == 3617734876) strcat(s, "e");
if (crc32("gShfpTISXu",10) == 1817999718) strcat(s, "e");
if (crc32("BVbcTOayxMICO",13) == 264506113) strcat(s, "t");
if (crc32("uriKfPwI",8) == 3878823487) strcat(s, "c");
if (crc32("RuZEqXmADfyyEbJ",15) == 3807300561) strcat(s, "a");
if (crc32("HTszzEptxRfCHfQ",15) == 214794455) strcat(s, "x");
if (crc32("HVQwoNE",7) == 3892521565) strcat(s, "r");
    return s;
}

char *battle_nouns() {
    char *s = calloc(7);
    if (crc32("JdsXIyxLFxhIY",13) == 1936463462) strcat(s, "P");
if (crc32("mXRnwRRftM",10) == 4161247085) strcat(s, "b");
if (crc32("dXBBmkOhTzGwpW",14) == 1054084401) strcat(s, "Y");
if (crc32("PNjwtIf",7) == 2014534321) strcat(s, "a");
if (crc32("zkyYanCdiKK",11) == 272868687) strcat(s, "u");
if (crc32("vidAKFkgp",9) == 3197002362) strcat(s, "t");
if (crc32("nHhefoLVJ",9) == 518998251) strcat(s, "t");
if (crc32("sNXVMmNVfpj",11) == 1065245720) strcat(s, "f");
if (crc32("iTWhHeAKdutPuoq",15) == 366010627) strcat(s, "l");
if (crc32("gSCmDNWcYGxjeho",15) == 1251303222) strcat(s, "e");
    return s;
}

char *ambrotype_nouns() {
    char *s = calloc(10);
    if (crc32("ZLvetl",6) == 4254005816) strcat(s, "r");
if (crc32("JadVbuR",7) == 2685733472) strcat(s, "a");
if (crc32("hiUORtPHcUIuK",13) == 3220305062) strcat(s, "v");
if (crc32("wKnwmlDhm",9) == 846482649) strcat(s, "m");
if (crc32("PcnWKOJn",8) == 3992845937) strcat(s, "Q");
if (crc32("peFptvbGwJX",11) == 3175520743) strcat(s, "b");
if (crc32("fBeFHOcKVIKA",12) == 220248428) strcat(s, "D");
if (crc32("zAFuVbBBemsZbLM",15) == 2108034822) strcat(s, "r");
if (crc32("wYeNGMmvukRAje",14) == 436961269) strcat(s, "l");
if (crc32("ChCfUN",6) == 35610666) strcat(s, "o");
if (crc32("BOjSucdvxAxseg",14) == 3619504786) strcat(s, "t");
if (crc32("lQJxCqDjPCj",11) == 2092789567) strcat(s, "e");
if (crc32("ZhtIrPXcAiWgz",13) == 4221589134) strcat(s, "y");
if (crc32("zqEavBVxrtpC",12) == 1098188334) strcat(s, "p");
if (crc32("xYArCDneCAMmdqJ",15) == 1712685464) strcat(s, "C");
if (crc32("RAkAl",5) == 1321018136) strcat(s, "e");
    return s;
}

char *cowslip_nouns() {
    char *s = calloc(8);
    if (crc32("yKucsgXHy",9) == 282062875) strcat(s, "a");
if (crc32("qdtDnO",6) == 2480776885) strcat(s, "c");
if (crc32("fgQZSKPDTAWKK",13) == 399618198) strcat(s, "o");
if (crc32("QiictiO",7) == 2145659562) strcat(s, "b");
if (crc32("tkiMOfsRgJYw",12) == 2216241414) strcat(s, "w");
if (crc32("LBltiHkX",8) == 1627319022) strcat(s, "s");
if (crc32("tvvDCVAZm",9) == 2473811463) strcat(s, "S");
if (crc32("lLpvvGHqgxxGRd",14) == 1457902156) strcat(s, "l");
if (crc32("hnCpeThigycqK",13) == 3550514827) strcat(s, "i");
if (crc32("tRLdply",7) == 2442728251) strcat(s, "L");
if (crc32("aeCvvNYPrSq",11) == 3845541859) strcat(s, "p");
    return s;
}

char *homophony_nouns() {
    char *s = calloc(10);
    if (crc32("oJHnMNIToxIYieC",15) == 2543797704) strcat(s, "W");
if (crc32("VPnpg",5) == 81570291) strcat(s, "h");
if (crc32("YumuYV",6) == 3648389274) strcat(s, "o");
if (crc32("NRDXVwuLhkqK",12) == 2811141852) strcat(s, "e");
if (crc32("eQcppTvFEW",10) == 2274529515) strcat(s, "m");
if (crc32("awEAnyKwohy",11) == 2375010170) strcat(s, "n");
if (crc32("rVxDJBT",7) == 853287310) strcat(s, "o");
if (crc32("MZZTSzlTXxAJ",12) == 3299141167) strcat(s, "p");
if (crc32("DSOhbxYHSri",11) == 2693041060) strcat(s, "Q");
if (crc32("IDwIElttFURBLch",15) == 3439119602) strcat(s, "h");
if (crc32("CRyjmLByfwYAaX",14) == 1121975801) strcat(s, "u");
if (crc32("lQbEOSrlWWJuq",13) == 1176831558) strcat(s, "o");
if (crc32("SjxUXqpmAOXg",12) == 9837225) strcat(s, "n");
if (crc32("eXdONKqZtW",10) == 3987339651) strcat(s, "y");
    return s;
}

char *buyer_nouns() {
    char *s = calloc(6);
    if (crc32("MTTqMta",7) == 941350011) strcat(s, "b");
if (crc32("WaEpnj",6) == 2502157429) strcat(s, "f");
if (crc32("RUFQngylpeXTW",13) == 1581628098) strcat(s, "u");
if (crc32("wATIoibur",9) == 2456630329) strcat(s, "y");
if (crc32("NCkqVHjQ",8) == 2579904765) strcat(s, "e");
if (crc32("rzQHvIVOike",11) == 2632964163) strcat(s, "r");
    return s;
}

char *waveoff_nouns() {
    char *s = calloc(8);
    if (crc32("zWdItTTqCUm",11) == 640368334) strcat(s, "k");
if (crc32("eQsWwsCdptXyZ",13) == 3716569329) strcat(s, "w");
if (crc32("ucUVeIgJGOay",12) == 913272122) strcat(s, "a");
if (crc32("TazgSV",6) == 3624653492) strcat(s, "v");
if (crc32("gEMylkftedeiV",13) == 285928710) strcat(s, "e");
if (crc32("fTEdQkt",7) == 2052921571) strcat(s, "o");
if (crc32("mEqAFBmbVvAod",13) == 1716357366) strcat(s, "A");
if (crc32("XJBfiHvTSaaxQye",15) == 2663753998) strcat(s, "f");
if (crc32("NFcuXOltIDs",11) == 4067464442) strcat(s, "k");
if (crc32("JMLTCVLj",8) == 1569823607) strcat(s, "f");
    return s;
}

char *Thailand_nouns() {
    char *s = calloc(9);
    if (crc32("oCYnUiNNcLuvnfF",15) == 2880649824) strcat(s, "n");
if (crc32("TUYUdaex",8) == 2782157422) strcat(s, "T");
if (crc32("iDRgoBetZz",10) == 857894238) strcat(s, "a");
if (crc32("RDFjyI",6) == 1463125066) strcat(s, "h");
if (crc32("NKlXDZ",6) == 3755387712) strcat(s, "F");
if (crc32("yWJYoNF",7) == 3818879034) strcat(s, "a");
if (crc32("kGQhTHowGGlV",12) == 1082499094) strcat(s, "i");
if (crc32("wNoYOyuBfX",10) == 2840363734) strcat(s, "L");
if (crc32("sTJSXSVoVAULr",13) == 3862742179) strcat(s, "l");
if (crc32("xmzKmAtGlR",10) == 3707286194) strcat(s, "a");
if (crc32("DFsRkQwBm",9) == 3721046270) strcat(s, "i");
if (crc32("fipPQWD",7) == 2166037955) strcat(s, "n");
if (crc32("jpFOSawGaqEo",12) == 3066184215) strcat(s, "S");
if (crc32("zBrXTJ",6) == 3524240364) strcat(s, "d");
    return s;
}

char *Nabalas_nouns() {
    char *s = calloc(8);
    if (crc32("XWxltYoNQsjfu",13) == 517965084) strcat(s, "N");
if (crc32("VOaPb",5) == 3860077979) strcat(s, "l");
if (crc32("GdrRUNjGwd",10) == 1949528906) strcat(s, "a");
if (crc32("VpHasNhSp",9) == 1400481805) strcat(s, "W");
if (crc32("HSJARC",6) == 3486772459) strcat(s, "b");
if (crc32("bcpVijhspRs",11) == 2218907324) strcat(s, "F");
if (crc32("nKMeWupjMaGwmG",14) == 1503526997) strcat(s, "a");
if (crc32("UuAdAxl",7) == 1877441461) strcat(s, "h");
if (crc32("SrMhdtFmOJzad",13) == 1473799391) strcat(s, "l");
if (crc32("qfUtmtPzsKDHEgF",15) == 2352751242) strcat(s, "a");
if (crc32("shvZZXzxDkDya",13) == 3820951203) strcat(s, "t");
if (crc32("fbXzOAGAliM",11) == 2957897523) strcat(s, "s");
    return s;
}

char *Brielle_nouns() {
    char *s = calloc(8);
    if (crc32("lfbfMVTW",8) == 1943646491) strcat(s, "B");
if (crc32("hCEzd",5) == 56550287) strcat(s, "C");
if (crc32("UXFJPts",7) == 3248829568) strcat(s, "r");
if (crc32("imtbHlWK",8) == 2231348148) strcat(s, "D");
if (crc32("yyyqujhOacMng",13) == 2003903448) strcat(s, "i");
if (crc32("vWogvsEfJxLL",12) == 3759816363) strcat(s, "W");
if (crc32("BEnbWrhbHvUgufk",15) == 3521440031) strcat(s, "e");
if (crc32("RWcgWeVhCNSyf",13) == 2929250429) strcat(s, "l");
if (crc32("SonLVuSqdcaVAfr",15) == 3205828525) strcat(s, "l");
if (crc32("aLqlHJB",7) == 883515736) strcat(s, "U");
if (crc32("pKaOKaNSQwUaRQm",15) == 1465804753) strcat(s, "e");
    return s;
}

char *extravasation_nouns() {
    char *s = calloc(14);
    if (crc32("KbGIfwkEQihQeii",15) == 1845720603) strcat(s, "e");
if (crc32("HkayuFlqPw",10) == 1892174966) strcat(s, "j");
if (crc32("dSmfwVDPsRYGn",13) == 3741975018) strcat(s, "x");
if (crc32("tlzviofQLYKDKhS",15) == 2504187642) strcat(s, "F");
if (crc32("ZhWxGN",6) == 2549157144) strcat(s, "t");
if (crc32("mhcageOGOEPT",12) == 571592601) strcat(s, "r");
if (crc32("ckxWELJ",7) == 3370168093) strcat(s, "b");
if (crc32("yDjtDb",6) == 5660349) strcat(s, "a");
if (crc32("FcBQqWGh",8) == 2041695817) strcat(s, "Z");
if (crc32("rLpgmEBlD",9) == 3111658729) strcat(s, "v");
if (crc32("HRKHcLljk",9) == 984091433) strcat(s, "a");
if (crc32("GqzYURmSWVdBFV",14) == 1086344931) strcat(s, "s");
if (crc32("taWGG",5) == 2006521008) strcat(s, "a");
if (crc32("xscdjzE",7) == 866990337) strcat(s, "t");
if (crc32("ZSKlxN",6) == 3045678904) strcat(s, "E");
if (crc32("hbIXrUJAI",9) == 1184688573) strcat(s, "i");
if (crc32("nYHpSmGkShkV",12) == 2457978792) strcat(s, "o");
if (crc32("wiCyvmoA",8) == 1299322359) strcat(s, "n");
    return s;
}

char *wadna_nouns() {
    char *s = calloc(6);
    if (crc32("aKlCzcZeCyKlxe",14) == 3420074662) strcat(s, "w");
if (crc32("ExiPuaVTqpbJNg",14) == 1310373780) strcat(s, "a");
if (crc32("ojSPDHBKdztolWH",15) == 4292585555) strcat(s, "b");
if (crc32("MtlvcGQko",9) == 2659729634) strcat(s, "d");
if (crc32("bTwDKhwNJRnLFJw",15) == 570222165) strcat(s, "G");
if (crc32("MwBtconxaN",10) == 2517133587) strcat(s, "n");
if (crc32("btVnmb",6) == 661449271) strcat(s, "a");
    return s;
}

char *auditress_nouns() {
    char *s = calloc(10);
    if (crc32("dVMDKWpXj",9) == 3690479185) strcat(s, "T");
if (crc32("nHWEsLi",7) == 3171079407) strcat(s, "a");
if (crc32("VaZluJXXoDBq",12) == 809894269) strcat(s, "u");
if (crc32("uewYQFsdmlqnKoc",15) == 4214568567) strcat(s, "d");
if (crc32("YfLLazzJpots",12) == 2551061582) strcat(s, "i");
if (crc32("TKUQSrbtDmN",11) == 800526262) strcat(s, "A");
if (crc32("fWsVDSWLLEUV",12) == 540837379) strcat(s, "t");
if (crc32("hqpUQ",5) == 867347531) strcat(s, "r");
if (crc32("VLhpYexrsBAHkzG",15) == 1803486463) strcat(s, "Y");
if (crc32("RohqqmAC",8) == 3136397938) strcat(s, "e");
if (crc32("GvBgtUYp",8) == 353811719) strcat(s, "s");
if (crc32("WvZTvy",6) == 1231221441) strcat(s, "s");
    return s;
}

char *Prome_nouns() {
    char *s = calloc(6);
    if (crc32("fNwoNIKcavf",11) == 4066705465) strcat(s, "c");
if (crc32("vyDvJPsOIjuU",12) == 128804196) strcat(s, "P");
if (crc32("oNfDjDckByEVFP",14) == 3236458448) strcat(s, "r");
if (crc32("MXrSMgqcO",9) == 262736159) strcat(s, "B");
if (crc32("qbxueGZ",7) == 2106997235) strcat(s, "o");
if (crc32("pHDMnwOMQ",9) == 499617061) strcat(s, "m");
if (crc32("RcMqsJf",7) == 743879934) strcat(s, "e");
    return s;
}

char *Swisher_nouns() {
    char *s = calloc(8);
    if (crc32("VclOQGk",7) == 1309693417) strcat(s, "S");
if (crc32("XazGZAmEORkUrR",14) == 3210852312) strcat(s, "S");
if (crc32("YMvoiv",6) == 983962590) strcat(s, "w");
if (crc32("gZFHrMAgeA",10) == 1043558600) strcat(s, "i");
if (crc32("HltRiC",6) == 3733241407) strcat(s, "s");
if (crc32("RLyJOyPdlXns",12) == 4269499328) strcat(s, "h");
if (crc32("KmEbzd",6) == 3446238092) strcat(s, "e");
if (crc32("vklEfwiIYSND",12) == 510543169) strcat(s, "r");
    return s;
}

char *Goodspeed_nouns() {
    char *s = calloc(10);
    if (crc32("lsZvQT",6) == 152568883) strcat(s, "O");
if (crc32("OvScrhq",7) == 2032649727) strcat(s, "G");
if (crc32("dCSVHBSGOnDrxCa",15) == 167802880) strcat(s, "i");
if (crc32("vNKfoFd",7) == 3114225963) strcat(s, "o");
if (crc32("HKKIiLXta",9) == 3477500320) strcat(s, "o");
if (crc32("lueezGqK",8) == 4087412951) strcat(s, "d");
if (crc32("pIRIgf",6) == 2132926001) strcat(s, "s");
if (crc32("MSftiT",6) == 3896189018) strcat(s, "p");
if (crc32("qUCHP",5) == 3634799903) strcat(s, "X");
if (crc32("WREWBDDDwTLgLyy",15) == 4030025241) strcat(s, "e");
if (crc32("MsmvaxcMUuBz",12) == 617238263) strcat(s, "e");
if (crc32("JeRpeYAU",8) == 935733401) strcat(s, "u");
if (crc32("tsCfnWRrWxQqEt",14) == 1274984169) strcat(s, "d");
    return s;
}

char *flor_nouns() {
    char *s = calloc(5);
    if (crc32("flmewgLWZSinueE",15) == 2387627865) strcat(s, "M");
if (crc32("EqnjU",5) == 1139287969) strcat(s, "f");
if (crc32("TiBcGSA",7) == 2335570776) strcat(s, "l");
if (crc32("bqqqSjykslvdJ",13) == 427527970) strcat(s, "F");
if (crc32("zkEcosWp",8) == 3221837727) strcat(s, "o");
if (crc32("xrcpGDKD",8) == 96362410) strcat(s, "r");
    return s;
}

char *alastrim_nouns() {
    char *s = calloc(9);
    if (crc32("KlYad",5) == 330027400) strcat(s, "L");
if (crc32("LpMQVYYRHH",10) == 3604711867) strcat(s, "a");
if (crc32("CRVhIIrOZki",11) == 4050078649) strcat(s, "l");
if (crc32("vFDRyVoQV",9) == 63396612) strcat(s, "a");
if (crc32("xIbyTIGm",8) == 3454378900) strcat(s, "s");
if (crc32("iiKxgAwPupQ",11) == 3201535467) strcat(s, "w");
if (crc32("TQeFNfwhNDi",11) == 2847281114) strcat(s, "t");
if (crc32("kAHKhW",6) == 3308770317) strcat(s, "u");
if (crc32("iSydaYYyCuMEM",13) == 3038163226) strcat(s, "r");
if (crc32("eopHxyPStynb",12) == 164371318) strcat(s, "i");
if (crc32("anMgiKdViB",10) == 1170673047) strcat(s, "m");
    return s;
}

char *orthopteron_nouns() {
    char *s = calloc(12);
    if (crc32("OqYjHxGzvGPSbh",14) == 2583053929) strcat(s, "o");
if (crc32("bSOLtui",7) == 903889973) strcat(s, "r");
if (crc32("QyOfpdsEPdcVtE",14) == 51974751) strcat(s, "t");
if (crc32("DEVqjGQakwKc",12) == 1708459012) strcat(s, "h");
if (crc32("xYvcwqQvMesFtpF",15) == 2375160373) strcat(s, "o");
if (crc32("DqKorwVbrCRoY",13) == 3349602987) strcat(s, "a");
if (crc32("MbvirvKX",8) == 1706925444) strcat(s, "p");
if (crc32("KFfTcxzeUMToKc",14) == 1679629119) strcat(s, "t");
if (crc32("SCjNsHa",7) == 3277663153) strcat(s, "s");
if (crc32("VomEOlDYEIY",11) == 2221897003) strcat(s, "e");
if (crc32("bQCah",5) == 591111865) strcat(s, "z");
if (crc32("YHsxgarRNM",10) == 1201914020) strcat(s, "r");
if (crc32("potDEKPTI",9) == 4074938111) strcat(s, "o");
if (crc32("lyfqCHLUeMnLwxp",15) == 547786991) strcat(s, "C");
if (crc32("shyvAEMkQzXhmN",14) == 530565086) strcat(s, "n");
    return s;
}

char *licentiate_nouns() {
    char *s = calloc(11);
    if (crc32("pEinRTUpUUZDCZL",15) == 1588671649) strcat(s, "l");
if (crc32("IkfAzUn",7) == 1567625120) strcat(s, "H");
if (crc32("JsORHgrlgFiUsy",14) == 4092737202) strcat(s, "i");
if (crc32("OXnsydiFo",9) == 1265696467) strcat(s, "c");
if (crc32("bxtqEkP",7) == 4011725568) strcat(s, "H");
if (crc32("ZoIhNclHas",10) == 297690084) strcat(s, "e");
if (crc32("lazCkPugAeoCaV",14) == 2192678350) strcat(s, "Q");
if (crc32("tpDLBwc",7) == 889436662) strcat(s, "n");
if (crc32("iYwgjrHM",8) == 316476864) strcat(s, "t");
if (crc32("viBgVwBXHtmDb",13) == 52859574) strcat(s, "a");
if (crc32("YBUFgraAPot",11) == 1941707130) strcat(s, "i");
if (crc32("kBCULFaTd",9) == 2219185736) strcat(s, "a");
if (crc32("tnQXc",5) == 2737149234) strcat(s, "X");
if (crc32("nQHJHHthbb",10) == 2397619556) strcat(s, "t");
if (crc32("twLcZjSkYgBdvv",14) == 258630855) strcat(s, "q");
if (crc32("ZghJwGewF",9) == 825033576) strcat(s, "e");
    return s;
}

char *Etty_nouns() {
    char *s = calloc(5);
    if (crc32("hvfVBXaUUhUs",12) == 1654856313) strcat(s, "E");
if (crc32("mhNYZatfonacS",13) == 3760813401) strcat(s, "j");
if (crc32("juKCCVKV",8) == 2424341374) strcat(s, "t");
if (crc32("vruNUq",6) == 2312228179) strcat(s, "I");
if (crc32("IxILErSoQOah",12) == 1962779193) strcat(s, "t");
if (crc32("qBMeyWqs",8) == 4074916207) strcat(s, "g");
if (crc32("lxdaC",5) == 3901148178) strcat(s, "y");
    return s;
}

char *Esbjerg_nouns() {
    char *s = calloc(8);
    if (crc32("azERVxVUTRxzZG",14) == 3391942033) strcat(s, "f");
if (crc32("UnPtH",5) == 2998955126) strcat(s, "E");
if (crc32("hFuZzYtLeRV",11) == 2524343790) strcat(s, "s");
if (crc32("lBpJJGuD",8) == 62981336) strcat(s, "p");
if (crc32("WBCNroWKJwujW",13) == 3774044135) strcat(s, "b");
if (crc32("MyLPxUklNsOIw",13) == 1852609367) strcat(s, "g");
if (crc32("kZWEMOfcbbHVmK",14) == 2847932582) strcat(s, "j");
if (crc32("HouGYxeHk",9) == 3636877628) strcat(s, "Z");
if (crc32("dJPpZ",5) == 2516873573) strcat(s, "e");
if (crc32("FCHGZ",5) == 3414790604) strcat(s, "v");
if (crc32("YkiyumdR",8) == 3856229649) strcat(s, "r");
if (crc32("exYbJURckCkjZ",13) == 2821099067) strcat(s, "F");
if (crc32("pLPwqvwr",8) == 1345276390) strcat(s, "g");
    return s;
}

char *Tricia_nouns() {
    char *s = calloc(7);
    if (crc32("OyYdZprK",8) == 2963078547) strcat(s, "H");
if (crc32("gWfEmRLMBXT",11) == 897855919) strcat(s, "T");
if (crc32("iAkXpinRaL",10) == 3368287223) strcat(s, "a");
if (crc32("dzhkfAYbRkLA",12) == 336656534) strcat(s, "r");
if (crc32("acCjRrXHvnOr",12) == 2626246579) strcat(s, "i");
if (crc32("LnkxFzUwMEKH",12) == 2885954584) strcat(s, "O");
if (crc32("GlChWH",6) == 3183832641) strcat(s, "c");
if (crc32("SDYEatX",7) == 3432576133) strcat(s, "h");
if (crc32("YPQbWHXzcoHLZQ",14) == 3762902379) strcat(s, "i");
if (crc32("LVEIIvuJWNg",11) == 1363544117) strcat(s, "J");
if (crc32("UjVQcxNExY",10) == 3692599923) strcat(s, "a");
    return s;
}

char *smokelessness_nouns() {
    char *s = calloc(14);
    if (crc32("jPgmZTd",7) == 2691046276) strcat(s, "l");
if (crc32("JwdgdIoZkRUTJ",13) == 1102799044) strcat(s, "s");
if (crc32("TTEmIOZpoAyDm",13) == 2966128033) strcat(s, "m");
if (crc32("mxsIt",5) == 695163890) strcat(s, "o");
if (crc32("RTyccIJMoUuYH",13) == 3728412516) strcat(s, "X");
if (crc32("EAzAsYwGV",9) == 2145275864) strcat(s, "k");
if (crc32("dbHvpnJBVRzPXua",15) == 108875491) strcat(s, "C");
if (crc32("nmupJduXM",9) == 33974729) strcat(s, "e");
if (crc32("OYXYpoJwvti",11) == 1717813903) strcat(s, "s");
if (crc32("PsRJQSoAKZY",11) == 4091583671) strcat(s, "l");
if (crc32("qcjkriN",7) == 3967997374) strcat(s, "c");
if (crc32("jaxYfwULHRKYaeS",15) == 1148128785) strcat(s, "e");
if (crc32("CdADmtMjvVeKEk",14) == 3471543222) strcat(s, "C");
if (crc32("LrWviosxh",9) == 244086081) strcat(s, "s");
if (crc32("speHyFGXiRKAiB",14) == 3372597812) strcat(s, "s");
if (crc32("WrSAFY",6) == 174110867) strcat(s, "j");
if (crc32("UdcfOpF",7) == 1954391758) strcat(s, "n");
if (crc32("HyAsorsDT",9) == 4262322652) strcat(s, "Y");
if (crc32("RYEZCrOzpMxhUAt",15) == 858850248) strcat(s, "e");
if (crc32("wmLDtW",6) == 3729429786) strcat(s, "s");
if (crc32("PqUmtMuGWQvQ",12) == 1749312985) strcat(s, "s");
    return s;
}

char *foresightedness_nouns() {
    char *s = calloc(16);
    if (crc32("hgzuuKh",7) == 1090364721) strcat(s, "v");
if (crc32("pJZGD",5) == 1694193830) strcat(s, "f");
if (crc32("aXPyPlaxD",9) == 2995489940) strcat(s, "o");
if (crc32("eSTOHKepCzdh",12) == 1766907514) strcat(s, "p");
if (crc32("taPdD",5) == 1433806062) strcat(s, "r");
if (crc32("vWXWyXghliQ",11) == 3679759861) strcat(s, "P");
if (crc32("IielKXsYF",9) == 2127506597) strcat(s, "e");
if (crc32("fdjXHKkBz",9) == 1078036000) strcat(s, "s");
if (crc32("lfWTYI",6) == 2542828651) strcat(s, "J");
if (crc32("mAbLqksxk",9) == 2298807215) strcat(s, "i");
if (crc32("jMMSzVaBtFjYI",13) == 3496634954) strcat(s, "g");
if (crc32("dWpjLxBUGhrow",13) == 1041534556) strcat(s, "C");
if (crc32("AeZZuvGeBo",10) == 3181717736) strcat(s, "h");
if (crc32("eLCsECY",7) == 2627597903) strcat(s, "y");
if (crc32("wHKbkx",6) == 284623938) strcat(s, "t");
if (crc32("MmNNhacdoY",10) == 3685427853) strcat(s, "e");
if (crc32("PSEMfO",6) == 4024369325) strcat(s, "S");
if (crc32("JHHCpXikwAWZpU",14) == 3587400066) strcat(s, "d");
if (crc32("UqiOygHymMdyndk",15) == 212292052) strcat(s, "n");
if (crc32("vMdDvi",6) == 2911307555) strcat(s, "g");
if (crc32("fAsejGIzBi",10) == 120346651) strcat(s, "e");
if (crc32("eXrxyldbDBk",11) == 509367991) strcat(s, "K");
if (crc32("FVBWyITmhoK",11) == 1579202672) strcat(s, "s");
if (crc32("qNYbVQ",6) == 2611240249) strcat(s, "s");
    return s;
}

char *antiradicalism_nouns() {
    char *s = calloc(15);
    if (crc32("PJvmbKFiWUHnEy",14) == 846284218) strcat(s, "v");
if (crc32("VutUUjAhsK",10) == 3153240284) strcat(s, "a");
if (crc32("fwbKL",5) == 2349279042) strcat(s, "V");
if (crc32("lvwwsD",6) == 1788031649) strcat(s, "n");
if (crc32("nWzbTW",6) == 730174515) strcat(s, "g");
if (crc32("xgIlIFMyqzUx",12) == 3179189485) strcat(s, "t");
if (crc32("UOKvUMEvThp",11) == 2984212558) strcat(s, "i");
if (crc32("gizdfiNZdI",10) == 1021743018) strcat(s, "r");
if (crc32("iEYvVSl",7) == 438529675) strcat(s, "a");
if (crc32("ScNkgOGPPR",10) == 3935154883) strcat(s, "c");
if (crc32("yNkDTCOmASC",11) == 1608029581) strcat(s, "d");
if (crc32("JmbufrQxHEMnSb",14) == 1263372814) strcat(s, "n");
if (crc32("VBnrvdAoQRBSY",13) == 3537053629) strcat(s, "i");
if (crc32("oGBAHemSMCBlngV",15) == 2884133629) strcat(s, "c");
if (crc32("AQSNaBx",7) == 1765709162) strcat(s, "a");
if (crc32("bQLMLXvMYJCtT",13) == 1332533602) strcat(s, "A");
if (crc32("PWmJzMEahlDh",12) == 4062609565) strcat(s, "l");
if (crc32("dQyUPc",6) == 898917487) strcat(s, "i");
if (crc32("TlRMtkkBeDaKZv",14) == 979754825) strcat(s, "s");
if (crc32("ZlGTzDeizh",10) == 3651425713) strcat(s, "m");
    return s;
}

char *steelwork_nouns() {
    char *s = calloc(10);
    if (crc32("LZOhKAbLJWtiIep",15) == 1294361005) strcat(s, "n");
if (crc32("SaCcMNiT",8) == 257391723) strcat(s, "s");
if (crc32("qXbYFrwrONBpVJF",15) == 2906327719) strcat(s, "R");
if (crc32("DAJpAzYUg",9) == 2105531124) strcat(s, "t");
if (crc32("nFeJAs",6) == 3974750804) strcat(s, "K");
if (crc32("UZbgi",5) == 3353371570) strcat(s, "e");
if (crc32("VHCNMZYnLXMnRrk",15) == 1519046948) strcat(s, "l");
if (crc32("PGQfNmADtqayph",14) == 2972743877) strcat(s, "e");
if (crc32("EQCbcRziME",10) == 1734043825) strcat(s, "B");
if (crc32("HtMjNftfVohWaZT",15) == 3654445941) strcat(s, "l");
if (crc32("UebjgTchueH",11) == 2829797838) strcat(s, "l");
if (crc32("xdJPfkckD",9) == 1381648785) strcat(s, "w");
if (crc32("spLSbpMY",8) == 2318424693) strcat(s, "T");
if (crc32("DnIiMckZz",9) == 1669879612) strcat(s, "o");
if (crc32("zrNVmsVWLcxn",12) == 2196300183) strcat(s, "r");
if (crc32("YZPOQWsZtSs",11) == 2737306684) strcat(s, "Y");
if (crc32("JORXUx",6) == 1595649807) strcat(s, "k");
    return s;
}

char *gastroenterostomy_nouns() {
    char *s = calloc(18);
    if (crc32("ohuhQ",5) == 2016163619) strcat(s, "v");
if (crc32("XVmgtRCbH",9) == 1931242878) strcat(s, "g");
if (crc32("iUUEXg",6) == 4095771665) strcat(s, "g");
if (crc32("HxLANrKEky",10) == 2584138960) strcat(s, "a");
if (crc32("XftIraqFWckCpsa",15) == 2479004071) strcat(s, "S");
if (crc32("nNGlmlWYejgw",12) == 1991013327) strcat(s, "s");
if (crc32("JcmaDFLXBBeP",12) == 1547785552) strcat(s, "N");
if (crc32("bCcyOg",6) == 1026130280) strcat(s, "t");
if (crc32("qUreUwUI",8) == 3376844845) strcat(s, "M");
if (crc32("viCvGmyyVPsviD",14) == 235119501) strcat(s, "r");
if (crc32("HoQivMhQZwf",11) == 3462713548) strcat(s, "o");
if (crc32("BAVHaquqo",9) == 2660675089) strcat(s, "e");
if (crc32("jmyqRDbuAHtdTqS",15) == 710673988) strcat(s, "n");
if (crc32("kYgqPPrOwqdnxRT",15) == 33183595) strcat(s, "n");
if (crc32("yzSvfK",6) == 290133260) strcat(s, "y");
if (crc32("mFfCd",5) == 3291368725) strcat(s, "t");
if (crc32("TjwHxDigH",9) == 2318499338) strcat(s, "e");
if (crc32("jMwBOhGXpa",10) == 3429126941) strcat(s, "d");
if (crc32("ESGQxrfLS",9) == 96158378) strcat(s, "r");
if (crc32("SzUjRvwjSgZCu",13) == 1326246587) strcat(s, "o");
if (crc32("jIZvIbTQgPlWo",13) == 3945188693) strcat(s, "L");
if (crc32("taqFDcTbhb",10) == 1542335161) strcat(s, "s");
if (crc32("atUOJGm",7) == 3802927897) strcat(s, "t");
if (crc32("rKBiLlXOP",9) == 2956836271) strcat(s, "R");
if (crc32("CkVfC",5) == 2165648271) strcat(s, "o");
if (crc32("lGGkVmlufmC",11) == 803517658) strcat(s, "y");
if (crc32("WKEGwHSaGFgfAb",14) == 2091313073) strcat(s, "m");
if (crc32("NaJilODhGx",10) == 2555602966) strcat(s, "y");
    return s;
}

char *Vladamir_nouns() {
    char *s = calloc(9);
    if (crc32("BcIoWdiRXRs",11) == 1368659444) strcat(s, "x");
if (crc32("cEILdLYBmeo",11) == 1356123002) strcat(s, "V");
if (crc32("VdEMm",5) == 3316698788) strcat(s, "l");
if (crc32("HixuOdgczmkaz",13) == 1860301578) strcat(s, "a");
if (crc32("NfFoMWbibAzEA",13) == 3615748588) strcat(s, "f");
if (crc32("kFViqzlTO",9) == 24788272) strcat(s, "d");
if (crc32("lxENyptBHfLqN",13) == 1995016085) strcat(s, "C");
if (crc32("tUtGRKoU",8) == 2719627910) strcat(s, "a");
if (crc32("EpzbwJxzIGhHZ",13) == 2154794814) strcat(s, "M");
if (crc32("pShciIZ",7) == 2529996132) strcat(s, "m");
if (crc32("RIAlg",5) == 695846708) strcat(s, "x");
if (crc32("UaHWFcmlbPdawQq",15) == 3500424742) strcat(s, "i");
if (crc32("kdpOOJzD",8) == 1556127139) strcat(s, "r");
    return s;
}

char *ocher_nouns() {
    char *s = calloc(6);
    if (crc32("OFkVxNbYXrlD",12) == 1450734406) strcat(s, "R");
if (crc32("ckXxmHICBLaKZ",13) == 4021441861) strcat(s, "o");
if (crc32("CSJzSYt",7) == 2503719356) strcat(s, "g");
if (crc32("wucaZtq",7) == 3208537708) strcat(s, "c");
if (crc32("zcuZtdP",7) == 4153709133) strcat(s, "h");
if (crc32("hSKkvZYQABF",11) == 1245904837) strcat(s, "e");
if (crc32("NgsIjBr",7) == 4257419377) strcat(s, "r");
    return s;
}

char *Asterius_nouns() {
    char *s = calloc(9);
    if (crc32("kJRICgJNzUTXmi",14) == 2996486943) strcat(s, "W");
if (crc32("xEbJifCDS",9) == 3760310553) strcat(s, "A");
if (crc32("kuagUKKxlo",10) == 1396411791) strcat(s, "s");
if (crc32("PbPFHYRCjyCEsd",14) == 1198909127) strcat(s, "t");
if (crc32("sRHYmzmZ",8) == 4000906087) strcat(s, "e");
if (crc32("AfcpJCUTU",9) == 4080348874) strcat(s, "j");
if (crc32("wDRgRcyYcKi",11) == 3101355171) strcat(s, "r");
if (crc32("mumQrm",6) == 1191445767) strcat(s, "u");
if (crc32("SUqNtbaMkcp",11) == 3293161825) strcat(s, "i");
if (crc32("EcRRnTMW",8) == 2073458625) strcat(s, "L");
if (crc32("JUmfNpyZsxgYGc",14) == 4134391314) strcat(s, "u");
if (crc32("DAryEhhvcbuVsZ",14) == 769282507) strcat(s, "C");
if (crc32("ROzLyzdj",8) == 343904728) strcat(s, "s");
    return s;
}

char *scrap_nouns() {
    char *s = calloc(6);
    if (crc32("TiovKmgL",8) == 444293807) strcat(s, "x");
if (crc32("EAOgFztSK",9) == 3235385845) strcat(s, "s");
if (crc32("HqlMqlWGBapJXza",15) == 3670749760) strcat(s, "D");
if (crc32("afLFogMRfINsHFq",15) == 3380195423) strcat(s, "c");
if (crc32("GrUUuvqZX",9) == 2425376089) strcat(s, "r");
if (crc32("xRqvz",5) == 4060274447) strcat(s, "a");
if (crc32("ifGDMBouCG",10) == 2458427693) strcat(s, "C");
if (crc32("DLIgGBaYfCPqnJB",15) == 2763041580) strcat(s, "p");
    return s;
}

char *planarian_nouns() {
    char *s = calloc(10);
    if (crc32("hkAIDKPl",8) == 3900457701) strcat(s, "p");
if (crc32("CQGOJWRBVluL",12) == 4064408881) strcat(s, "v");
if (crc32("ymYqwUfXXCPkc",13) == 2699243283) strcat(s, "l");
if (crc32("lewiIkNaLFrX",12) == 2395358696) strcat(s, "h");
if (crc32("MkwNsBRdCN",10) == 792120688) strcat(s, "a");
if (crc32("pqUAYwjhJqElfWV",15) == 1055382240) strcat(s, "n");
if (crc32("lyKpUWxqipW",11) == 2413219327) strcat(s, "P");
if (crc32("xeYcCdQdJOA",11) == 3300594502) strcat(s, "a");
if (crc32("ppThPpiHpVwObV",14) == 1092746637) strcat(s, "r");
if (crc32("uwdaMKvAq",9) == 1491595498) strcat(s, "Z");
if (crc32("diMuwQxRqG",10) == 3421890072) strcat(s, "i");
if (crc32("GtRQVvsSU",9) == 576683528) strcat(s, "a");
if (crc32("uYlEyFQKHhmyB",13) == 478868892) strcat(s, "V");
if (crc32("yJLQveK",7) == 219524379) strcat(s, "n");
    return s;
}

char *MNE_nouns() {
    char *s = calloc(4);
    if (crc32("takcPc",6) == 1136177398) strcat(s, "L");
if (crc32("PxanzmpLUKlXEW",14) == 3700475245) strcat(s, "M");
if (crc32("lnWtwpIj",8) == 1255520082) strcat(s, "p");
if (crc32("BLQDXXkaKjWjVC",14) == 4071540477) strcat(s, "N");
if (crc32("WSJXM",5) == 670775437) strcat(s, "F");
if (crc32("jAjAbYzF",8) == 2997100412) strcat(s, "E");
    return s;
}

char *outspokenness_nouns() {
    char *s = calloc(14);
    if (crc32("njqzK",5) == 2975779603) strcat(s, "q");
if (crc32("QlONwHCpRrVFg",13) == 3182034018) strcat(s, "o");
if (crc32("GVYSqKDQCVnMvG",14) == 2090171404) strcat(s, "o");
if (crc32("GRHxSlxoxE",10) == 1010825425) strcat(s, "u");
if (crc32("FYvYrXHI",8) == 1088213031) strcat(s, "t");
if (crc32("bVLACL",6) == 2953252167) strcat(s, "J");
if (crc32("DwxcbMizCkihZ",13) == 3134290943) strcat(s, "s");
if (crc32("uBLSet",6) == 3820044863) strcat(s, "A");
if (crc32("GMiouZwQ",8) == 384289713) strcat(s, "p");
if (crc32("XwgQNRofRB",10) == 3402036077) strcat(s, "o");
if (crc32("pkznMYbZTvNaS",13) == 2620185213) strcat(s, "k");
if (crc32("LoZmZnMlsEx",11) == 3657728876) strcat(s, "e");
if (crc32("cjIHsAPKqynYNZ",14) == 1993815652) strcat(s, "Y");
if (crc32("QYYujLEbT",9) == 1798816490) strcat(s, "n");
if (crc32("uCwLhyouFXJQlS",14) == 3644456180) strcat(s, "u");
if (crc32("hUXuMFn",7) == 1503603283) strcat(s, "n");
if (crc32("tBzolxinh",9) == 2619096286) strcat(s, "e");
if (crc32("aWwfW",5) == 770950527) strcat(s, "U");
if (crc32("sbhIcLEL",8) == 1223113067) strcat(s, "s");
if (crc32("pyRLrwi",7) == 2723600201) strcat(s, "x");
if (crc32("IIXyGriTJH",10) == 3261224312) strcat(s, "s");
    return s;
}

char *Oreopithecus_nouns() {
    char *s = calloc(13);
    if (crc32("yzXqyoq",7) == 193086159) strcat(s, "O");
if (crc32("QOgJakrSMT",10) == 178654151) strcat(s, "o");
if (crc32("AbxscoT",7) == 1324760162) strcat(s, "r");
if (crc32("eomjkcKxZXUu",12) == 4041620549) strcat(s, "L");
if (crc32("uETeXWybdfBwBP",14) == 1585298843) strcat(s, "e");
if (crc32("EpldHnFXX",9) == 568130396) strcat(s, "c");
if (crc32("nmpWQi",6) == 2006733109) strcat(s, "o");
if (crc32("qXAwfR",6) == 3171632825) strcat(s, "p");
if (crc32("lKmXpanrTMKHMCU",15) == 2663810384) strcat(s, "l");
if (crc32("lBhAA",5) == 92301373) strcat(s, "i");
if (crc32("dgecGIPnYWebGBK",15) == 670270032) strcat(s, "H");
if (crc32("zBIxxIpMAf",10) == 4153188510) strcat(s, "t");
if (crc32("yrwbhQS",7) == 1873613784) strcat(s, "h");
if (crc32("kRfWo",5) == 3721363045) strcat(s, "Q");
if (crc32("ARQpKFUHjxF",11) == 77480997) strcat(s, "e");
if (crc32("JdjKUnjSxnjhK",13) == 1620526541) strcat(s, "A");
if (crc32("ajuJTn",6) == 4107902471) strcat(s, "c");
if (crc32("vYHkrAqAuZCze",13) == 1259609686) strcat(s, "u");
if (crc32("wLUWLmSLHnFkzD",14) == 508849006) strcat(s, "l");
if (crc32("GKUjs",5) == 1552802696) strcat(s, "s");
    return s;
}

char *Damas_nouns() {
    char *s = calloc(6);
    if (crc32("fBBGAU",6) == 4227307009) strcat(s, "D");
if (crc32("PhIScnqXfwuK",12) == 3149870467) strcat(s, "z");
if (crc32("pfxatlT",7) == 321366448) strcat(s, "a");
if (crc32("TbfOrCCdyNhmQmS",15) == 1375379127) strcat(s, "m");
if (crc32("lmkwNTrVOROg",12) == 2658814535) strcat(s, "p");
if (crc32("lOdTYzNKqzlqeP",14) == 1895067097) strcat(s, "a");
if (crc32("ihXVdldjur",10) == 3580067583) strcat(s, "t");
if (crc32("NxVTmqXIZ",9) == 578656217) strcat(s, "s");
    return s;
}

char *Pontocaine_nouns() {
    char *s = calloc(11);
    if (crc32("hMEpbOWne",9) == 2551282953) strcat(s, "o");
if (crc32("bDDQr",5) == 1537099075) strcat(s, "P");
if (crc32("WidWSvU",7) == 1645435809) strcat(s, "o");
if (crc32("rJWRtrn",7) == 1200911395) strcat(s, "n");
if (crc32("adZvoKlAHTdvmBi",15) == 3487577549) strcat(s, "t");
if (crc32("rasKYY",6) == 1665875205) strcat(s, "j");
if (crc32("vdEkzmep",8) == 3448833118) strcat(s, "o");
if (crc32("AgAYjLX",7) == 2842363736) strcat(s, "E");
if (crc32("wNLUEzsTFAw",11) == 202297604) strcat(s, "c");
if (crc32("NrqjsytUwCh",11) == 1935218972) strcat(s, "a");
if (crc32("vCfszJphiarGJT",14) == 2867908928) strcat(s, "n");
if (crc32("FdyiRNNpT",9) == 1225716860) strcat(s, "i");
if (crc32("NZJhUCWq",8) == 2246503161) strcat(s, "n");
if (crc32("osCQCVVuuTHT",12) == 2253728431) strcat(s, "T");
if (crc32("yTzMIfRvvmLkv",13) == 2383738280) strcat(s, "e");
    return s;
}

char *Eleanor_nouns() {
    char *s = calloc(8);
    if (crc32("mjxOXG",6) == 592437803) strcat(s, "q");
if (crc32("YryyGY",6) == 4190750568) strcat(s, "E");
if (crc32("OVdrXW",6) == 2630085648) strcat(s, "l");
if (crc32("cycgeB",6) == 2202164375) strcat(s, "S");
if (crc32("MisWjEjpsJOHWS",14) == 1994353560) strcat(s, "e");
if (crc32("nulZbck",7) == 983277252) strcat(s, "a");
if (crc32("wKnOG",5) == 483751213) strcat(s, "n");
if (crc32("tYJsEdLerqVrCV",14) == 4132882419) strcat(s, "E");
if (crc32("DxJTiZ",6) == 1278481638) strcat(s, "o");
if (crc32("qBnEpvughieRw",13) == 417232413) strcat(s, "r");
    return s;
}

char *Byzas_nouns() {
    char *s = calloc(6);
    if (crc32("iUsUAHrhtgBxUik",15) == 3161770896) strcat(s, "s");
if (crc32("NlATBnqlvwVgZsm",15) == 4135850038) strcat(s, "B");
if (crc32("befNEpjN",8) == 1974192787) strcat(s, "Q");
if (crc32("PtkoHYagqnzVdMt",15) == 3645759062) strcat(s, "y");
if (crc32("QzWFeBlkmGtZ",12) == 2432290486) strcat(s, "z");
if (crc32("LBkYEmESvo",10) == 4106946092) strcat(s, "a");
if (crc32("AbnQzCrzKWwKfnX",15) == 2459577078) strcat(s, "s");
    return s;
}

char *shochet_nouns() {
    char *s = calloc(8);
    if (crc32("lvfvESCbFGMgR",13) == 1793377545) strcat(s, "s");
if (crc32("TxBNWUhM",8) == 1467938452) strcat(s, "h");
if (crc32("FzmYEGcxfdIQCG",14) == 3723099230) strcat(s, "v");
if (crc32("mtBRObwCBuML",12) == 4181893126) strcat(s, "o");
if (crc32("zTQNVKrRLwQutq",14) == 2456399712) strcat(s, "C");
if (crc32("kstzFSWYz",9) == 338627732) strcat(s, "c");
if (crc32("EWoZDvHiYApjVef",15) == 3557375306) strcat(s, "G");
if (crc32("tUxnLB",6) == 4183744547) strcat(s, "h");
if (crc32("KYBMZMXVmUDmLC",14) == 1952309138) strcat(s, "P");
if (crc32("wUhVoM",6) == 733813706) strcat(s, "e");
if (crc32("GyFMM",5) == 57368901) strcat(s, "t");
    return s;
}

char *armilla_nouns() {
    char *s = calloc(8);
    if (crc32("jNXaccU",7) == 323050435) strcat(s, "a");
if (crc32("PJZCobRsgo",10) == 2054549094) strcat(s, "r");
if (crc32("zdCEgQUe",8) == 1033167910) strcat(s, "x");
if (crc32("jIhEqQMxULEyHU",14) == 951999780) strcat(s, "m");
if (crc32("nNpHrWvct",9) == 3866615315) strcat(s, "f");
if (crc32("ccIpblAFEqIaDk",14) == 371476523) strcat(s, "i");
if (crc32("XEFGLXSETG",10) == 1586644493) strcat(s, "M");
if (crc32("pdtmMHrIT",9) == 172859443) strcat(s, "l");
if (crc32("NQhKfEqwieSDqr",14) == 223774611) strcat(s, "l");
if (crc32("nJJswgJ",7) == 3015238915) strcat(s, "R");
if (crc32("BNHiJcWSncSote",14) == 2324560653) strcat(s, "a");
    return s;
}

char *Oliphant_nouns() {
    char *s = calloc(9);
    if (crc32("NfkQrQZLofuf",12) == 132597934) strcat(s, "C");
if (crc32("dwwtCwsWqKwabs",14) == 1994505851) strcat(s, "O");
if (crc32("TERKXMAbXVBOFHE",15) == 696141204) strcat(s, "i");
if (crc32("OVpkHGyVLwseBlg",15) == 3833582262) strcat(s, "l");
if (crc32("JyMAoBe",7) == 267685770) strcat(s, "r");
if (crc32("SUfyIwziML",10) == 4236543519) strcat(s, "i");
if (crc32("ayoJQnyH",8) == 3780736185) strcat(s, "U");
if (crc32("GfzwKeKR",8) == 3686141915) strcat(s, "p");
if (crc32("pUPOCkpnEeLmOwT",15) == 130972926) strcat(s, "h");
if (crc32("LavbOJDFrZgA",12) == 2397207017) strcat(s, "a");
if (crc32("XOozHiVLVEMpgBx",15) == 1574323455) strcat(s, "n");
if (crc32("WIQaUyvkAWQo",12) == 2404096306) strcat(s, "S");
if (crc32("JSgnfWiWPLNwFV",14) == 3570594732) strcat(s, "t");
    return s;
}

char *admitter_nouns() {
    char *s = calloc(9);
    if (crc32("pVtjkOyyjkGby",13) == 1410871358) strcat(s, "Q");
if (crc32("FBJDBoVNb",9) == 2961839487) strcat(s, "a");
if (crc32("mUqPoRpsVmSHrBn",15) == 3618625534) strcat(s, "d");
if (crc32("AzfHRmRWKzo",11) == 672170970) strcat(s, "m");
if (crc32("sVHMdenxr",9) == 1218218177) strcat(s, "F");
if (crc32("ipRHvu",6) == 560750444) strcat(s, "i");
if (crc32("ACUGkiX",7) == 2409276098) strcat(s, "r");
if (crc32("pORKr",5) == 1043932089) strcat(s, "t");
if (crc32("KhTVJsH",7) == 3510923652) strcat(s, "w");
if (crc32("YYosENJ",7) == 3974775013) strcat(s, "t");
if (crc32("lZMQllq",7) == 1856993062) strcat(s, "l");
if (crc32("QuOXib",6) == 4051301047) strcat(s, "e");
if (crc32("ziIzPENEzcmkH",13) == 2168583975) strcat(s, "z");
if (crc32("SjROdqUFMAd",11) == 3404927903) strcat(s, "r");
    return s;
}

char *Duquesne_nouns() {
    char *s = calloc(9);
    if (crc32("oRFtgNYnVngLJ",13) == 1555647153) strcat(s, "D");
if (crc32("qPTNkkgIfW",10) == 3737713912) strcat(s, "u");
if (crc32("NhRfATkeOtoi",12) == 2646627751) strcat(s, "q");
if (crc32("rUSTNltqPne",11) == 378415840) strcat(s, "u");
if (crc32("kYazCMKlS",9) == 3558236226) strcat(s, "V");
if (crc32("Lnyij",5) == 3265317138) strcat(s, "e");
if (crc32("kotyl",5) == 2726590804) strcat(s, "s");
if (crc32("mUSjI",5) == 2372273737) strcat(s, "b");
if (crc32("sXYZd",5) == 521097199) strcat(s, "n");
if (crc32("UFVhZo",6) == 264869631) strcat(s, "e");
    return s;
}

char *OPCW_nouns() {
    char *s = calloc(5);
    if (crc32("UKGmEbU",7) == 635697192) strcat(s, "t");
if (crc32("dCPgtLig",8) == 2580077084) strcat(s, "O");
if (crc32("OOhjzNPsMRcFaWf",15) == 2781327306) strcat(s, "C");
if (crc32("svAZHHTiJPNdYjK",15) == 3354857248) strcat(s, "P");
if (crc32("sMURNpHAmE",10) == 3418274065) strcat(s, "W");
if (crc32("zwxfcBuKbsyJbn",14) == 2986245381) strcat(s, "C");
if (crc32("VdmIAsIVzqTYd",13) == 3189812956) strcat(s, "W");
    return s;
}

char *IledeFrance_nouns() {
    char *s = calloc(12);
    if (crc32("SgcKWU",6) == 4154004940) strcat(s, "S");
if (crc32("LyLsVZEkFQGfYnG",15) == 729951710) strcat(s, "I");
if (crc32("aRBVgcAG",8) == 2123122036) strcat(s, "W");
if (crc32("zfLgKUzj",8) == 3179897081) strcat(s, "l");
if (crc32("kLLHN",5) == 2537591162) strcat(s, "T");
if (crc32("BfhjiLbE",8) == 3205165546) strcat(s, "e");
if (crc32("PKDFSpOCiyK",11) == 1836972577) strcat(s, "Q");
if (crc32("NJXRhbLV",8) == 1883572186) strcat(s, "d");
if (crc32("RSgZrcag",8) == 601457411) strcat(s, "e");
if (crc32("UgNJlaMfqDDTRl",14) == 3721880709) strcat(s, "Z");
if (crc32("CIoGwWGiRxgW",12) == 704582296) strcat(s, "F");
if (crc32("iqAmzCwt",8) == 74972198) strcat(s, "r");
if (crc32("zqWInRdFdfyun",13) == 4158501149) strcat(s, "a");
if (crc32("FiGSFxKsJoaR",12) == 4223114317) strcat(s, "z");
if (crc32("cquzHVeXP",9) == 637805951) strcat(s, "n");
if (crc32("JehobMjLFq",10) == 1265845429) strcat(s, "c");
if (crc32("TPNTdBNnu",9) == 1735013108) strcat(s, "L");
if (crc32("xTCzZ",5) == 1734205161) strcat(s, "e");
    return s;
}

char *Berneta_nouns() {
    char *s = calloc(8);
    if (crc32("szLkIQXzcxAMWOO",15) == 539460003) strcat(s, "B");
if (crc32("MULqmiF",7) == 2603100211) strcat(s, "T");
if (crc32("lzXAVKTa",8) == 1509680474) strcat(s, "e");
if (crc32("JpQOGFhDClT",11) == 246817748) strcat(s, "r");
if (crc32("AjpGxkeDnKGfB",13) == 272913215) strcat(s, "n");
if (crc32("kwShxTcrUjflGT",14) == 2565331726) strcat(s, "e");
if (crc32("ykLoIB",6) == 1479345310) strcat(s, "t");
if (crc32("fuuGzOPOn",9) == 1083127564) strcat(s, "a");
    return s;
}

char *endodermis_nouns() {
    char *s = calloc(11);
    if (crc32("ihQueKkKKICMiLL",15) == 2225073635) strcat(s, "g");
if (crc32("lwDPySTEpAe",11) == 3783010137) strcat(s, "e");
if (crc32("OBsyk",5) == 2540476068) strcat(s, "e");
if (crc32("MShBLEvDV",9) == 2669468251) strcat(s, "n");
if (crc32("APDjCgZnRcD",11) == 2651938716) strcat(s, "d");
if (crc32("zuNxFlzCpe",10) == 3124713811) strcat(s, "o");
if (crc32("kxVYmEMpiGEeT",13) == 1022610860) strcat(s, "H");
if (crc32("ABUFYWxBc",9) == 3279640375) strcat(s, "d");
if (crc32("RMexIbwL",8) == 1950212351) strcat(s, "e");
if (crc32("bAWeFVcUM",9) == 1929718525) strcat(s, "r");
if (crc32("ftleOuYawCEcYnL",15) == 167142902) strcat(s, "m");
if (crc32("jiUbL",5) == 291031229) strcat(s, "i");
if (crc32("OscsjMQiLLFbWC",14) == 833387284) strcat(s, "T");
if (crc32("FlbOL",5) == 599348080) strcat(s, "s");
    return s;
}

char *pentstemon_nouns() {
    char *s = calloc(11);
    if (crc32("ifIXt",5) == 369925832) strcat(s, "p");
if (crc32("XPOucMj",7) == 210511571) strcat(s, "L");
if (crc32("tSlhCmxikQid",12) == 3493606162) strcat(s, "e");
if (crc32("tGAQOJ",6) == 1688005302) strcat(s, "n");
if (crc32("ppDylRnVuFIMjB",14) == 2012112701) strcat(s, "Z");
if (crc32("LKKPoUdAtIZLW",13) == 579361191) strcat(s, "t");
if (crc32("wXgEPlBhpAFecH",14) == 1488382982) strcat(s, "g");
if (crc32("VUQxAQJSofp",11) == 1884373164) strcat(s, "s");
if (crc32("KKQOZNNWbT",10) == 2449193337) strcat(s, "t");
if (crc32("PVdkGh",6) == 109635330) strcat(s, "e");
if (crc32("BrIdI",5) == 208707123) strcat(s, "g");
if (crc32("QdfvXOrfWAlo",12) == 882487444) strcat(s, "m");
if (crc32("hHNxMzOma",9) == 1876449406) strcat(s, "z");
if (crc32("MctpvNVbRZPbsU",14) == 2204158838) strcat(s, "o");
if (crc32("AcbCoFzEFvsDC",13) == 1650357770) strcat(s, "C");
if (crc32("KrWctnFZfSbcGXN",15) == 899545508) strcat(s, "n");
    return s;
}

char *Lozi_nouns() {
    char *s = calloc(5);
    if (crc32("MYHxfGyvNccNKL",14) == 2225988220) strcat(s, "D");
if (crc32("rrxXdkAVdZqP",12) == 530158521) strcat(s, "L");
if (crc32("pbZGQHZ",7) == 2654482314) strcat(s, "o");
if (crc32("wVKipekAw",9) == 3629236101) strcat(s, "s");
if (crc32("aClhKS",6) == 3152157542) strcat(s, "z");
if (crc32("DwKJLvsaBuRHll",14) == 3531436902) strcat(s, "i");
    return s;
}

char *biscuit_nouns() {
    char *s = calloc(8);
    if (crc32("imUKEmGJyK",10) == 3508787461) strcat(s, "t");
if (crc32("dKSjoPveG",9) == 1476556198) strcat(s, "b");
if (crc32("HLLVREUxu",9) == 514024298) strcat(s, "Y");
if (crc32("KLsdhSiHFsscs",13) == 1643133149) strcat(s, "i");
if (crc32("PiLxidUrTYa",11) == 4281295917) strcat(s, "s");
if (crc32("BOrizzNvLHiAorX",15) == 2625208660) strcat(s, "X");
if (crc32("saUkZeLTTkQviHn",15) == 4084368457) strcat(s, "c");
if (crc32("sRYdzj",6) == 177692091) strcat(s, "S");
if (crc32("hxaAOV",6) == 2615957248) strcat(s, "u");
if (crc32("RDKjRAAzP",9) == 1181545428) strcat(s, "N");
if (crc32("IwWtrsYCyLTVjbq",15) == 1653111483) strcat(s, "i");
if (crc32("IUwebwU",7) == 1738152058) strcat(s, "t");
    return s;
}

char *priorship_nouns() {
    char *s = calloc(10);
    if (crc32("caEhHcL",7) == 2363609153) strcat(s, "U");
if (crc32("viLAsfMIzG",10) == 3301608795) strcat(s, "p");
if (crc32("FToruy",6) == 3941678745) strcat(s, "r");
if (crc32("ZASIaLegaGaKzsL",15) == 3619336009) strcat(s, "i");
if (crc32("HoCWkUiD",8) == 2726664218) strcat(s, "o");
if (crc32("JuxDdxjEsW",10) == 2529686182) strcat(s, "r");
if (crc32("vBLvv",5) == 942541849) strcat(s, "s");
if (crc32("KSyQoRmfiegOI",13) == 4186311524) strcat(s, "W");
if (crc32("SSvauFgsE",9) == 4196306439) strcat(s, "h");
if (crc32("mXUqRZmbbr",10) == 2694179373) strcat(s, "v");
if (crc32("LOmmxabNdM",10) == 1717306972) strcat(s, "i");
if (crc32("cmlbEOVUoNbSnp",14) == 2632685781) strcat(s, "p");
    return s;
}

char *demonstrativeness_nouns() {
    char *s = calloc(18);
    if (crc32("hAhQKTwCEhw",11) == 2290847902) strcat(s, "d");
if (crc32("ChjRBjGezXDqB",13) == 111058850) strcat(s, "F");
if (crc32("ZMNvpX",6) == 3716975894) strcat(s, "e");
if (crc32("zWAhuPdGbq",10) == 791092329) strcat(s, "t");
if (crc32("mLNNDA",6) == 212499628) strcat(s, "m");
if (crc32("DIvSsvmQjlYbE",13) == 3044678182) strcat(s, "T");
if (crc32("PTrKQN",6) == 4293053163) strcat(s, "o");
if (crc32("QOAekHDyU",9) == 2223361176) strcat(s, "A");
if (crc32("fvTwVWFa",8) == 1005597820) strcat(s, "n");
if (crc32("FwrwL",5) == 2937625701) strcat(s, "s");
if (crc32("rWOJGFV",7) == 2296698613) strcat(s, "t");
if (crc32("JZoOyW",6) == 2127787139) strcat(s, "r");
if (crc32("JDFwtinYtD",10) == 2847309380) strcat(s, "a");
if (crc32("mWrgJwWGrXgSXW",14) == 2338576063) strcat(s, "s");
if (crc32("BVtAqVlwdbzks",13) == 4215174967) strcat(s, "t");
if (crc32("wtwUsHrtqnC",11) == 3529773687) strcat(s, "i");
if (crc32("HVIQhfaDNJ",10) == 3655413535) strcat(s, "K");
if (crc32("axJWXpCXybqSYpa",15) == 953709892) strcat(s, "v");
if (crc32("iNyxSUsGMkvaO",13) == 1666316729) strcat(s, "E");
if (crc32("XclqmNJn",8) == 4058973176) strcat(s, "e");
if (crc32("DRyyspcDCXR",11) == 2476439225) strcat(s, "U");
if (crc32("nGTSm",5) == 801360811) strcat(s, "n");
if (crc32("XIRiQiVS",8) == 3441613188) strcat(s, "e");
if (crc32("LxKYlvhXhkjR",12) == 2808488491) strcat(s, "A");
if (crc32("TVSHc",5) == 1731636078) strcat(s, "s");
if (crc32("sxEpGAvdY",9) == 3349339796) strcat(s, "s");
    return s;
}

char *Malmdy_nouns() {
    char *s = calloc(7);
    if (crc32("QJeVTJdScGW",11) == 1692312244) strcat(s, "B");
if (crc32("Cutgs",5) == 903387200) strcat(s, "M");
if (crc32("vzjvCvgNVioa",12) == 2034406762) strcat(s, "g");
if (crc32("yymWkgqfHy",10) == 3754686915) strcat(s, "a");
if (crc32("mdbgc",5) == 2794518137) strcat(s, "l");
if (crc32("lPHubmRgQEBN",12) == 631205043) strcat(s, "P");
if (crc32("VhyNSVu",7) == 347327740) strcat(s, "m");
if (crc32("ULhfRVbfhMUCh",13) == 659143802) strcat(s, "d");
if (crc32("cRTJryNPKyp",11) == 563117276) strcat(s, "y");
    return s;
}

char *Hobbes_nouns() {
    char *s = calloc(7);
    if (crc32("QcEhVbXCWjrt",12) == 2467671160) strcat(s, "e");
if (crc32("LsOURXdMuly",11) == 1438011850) strcat(s, "H");
if (crc32("BbmCB",5) == 1991747509) strcat(s, "o");
if (crc32("bmknOqIAjUtzO",13) == 213000657) strcat(s, "r");
if (crc32("VqcqVIxg",8) == 1404807944) strcat(s, "b");
if (crc32("dzKVB",5) == 4241705878) strcat(s, "A");
if (crc32("abodwsRPETwTvD",14) == 4210009559) strcat(s, "b");
if (crc32("dnYMIuCQiTNnC",13) == 3099130068) strcat(s, "W");
if (crc32("JvxDmw",6) == 2931409372) strcat(s, "e");
if (crc32("omzQL",5) == 1885290817) strcat(s, "Q");
if (crc32("HIrGj",5) == 228007576) strcat(s, "s");
    return s;
}

char *aquashow_nouns() {
    char *s = calloc(9);
    if (crc32("GUdyglbQ",8) == 351220663) strcat(s, "b");
if (crc32("fFiEvFHwVrJHbTC",15) == 1501249391) strcat(s, "a");
if (crc32("OhhzVvAzEwn",11) == 1986419120) strcat(s, "q");
if (crc32("dxauCiJ",7) == 2914876814) strcat(s, "u");
if (crc32("VASdHED",7) == 2981158176) strcat(s, "R");
if (crc32("irPfvK",6) == 35107526) strcat(s, "a");
if (crc32("cfrPxirtGcSD",12) == 4049844383) strcat(s, "d");
if (crc32("afqepWRYSxjG",12) == 3047890027) strcat(s, "s");
if (crc32("YDosPzDMdLlb",12) == 3690001532) strcat(s, "h");
if (crc32("nomwypKHWeEcTGD",15) == 3434350266) strcat(s, "o");
if (crc32("mBMxMws",7) == 3930430611) strcat(s, "w");
    return s;
}

char *freedman_nouns() {
    char *s = calloc(9);
    if (crc32("FCzVLMPJg",9) == 1895774017) strcat(s, "t");
if (crc32("FuLCRdWx",8) == 3602355529) strcat(s, "f");
if (crc32("usibuBRpoj",10) == 3932354794) strcat(s, "r");
if (crc32("rfnFlTrHpmcCax",14) == 4280948893) strcat(s, "M");
if (crc32("sDAqCkXi",8) == 2082526580) strcat(s, "e");
if (crc32("GnpgS",5) == 1034036324) strcat(s, "h");
if (crc32("ixcDEocfFjIAe",13) == 735551471) strcat(s, "e");
if (crc32("RpqxKkzGmzDCTc",14) == 968548724) strcat(s, "d");
if (crc32("NSEoZWmCvoe",11) == 3284921257) strcat(s, "A");
if (crc32("gFjPcUO",7) == 2043520067) strcat(s, "m");
if (crc32("gAavDCcEiJI",11) == 1266118935) strcat(s, "a");
if (crc32("WrawQas",7) == 3474957348) strcat(s, "j");
if (crc32("GLfvO",5) == 779067682) strcat(s, "n");
    return s;
}

char *Candi_nouns() {
    char *s = calloc(6);
    if (crc32("frFhW",5) == 1029359981) strcat(s, "C");
if (crc32("ZEXORWlJ",8) == 3661585538) strcat(s, "a");
if (crc32("ZGOrmLmbAcA",11) == 1049343869) strcat(s, "n");
if (crc32("UFEZNYQbS",9) == 319373662) strcat(s, "d");
if (crc32("PKbFEzSABctxYt",14) == 1812416975) strcat(s, "i");
    return s;
}

char *underspar_nouns() {
    char *s = calloc(10);
    if (crc32("qvxXcyMAWCYkukj",15) == 3481836595) strcat(s, "d");
if (crc32("TPYuqZgR",8) == 2421775429) strcat(s, "u");
if (crc32("qRUhrlqKBukczih",15) == 1959552881) strcat(s, "i");
if (crc32("idVIIyPwH",9) == 489412404) strcat(s, "n");
if (crc32("jHlegsQsRiYh",12) == 2013822993) strcat(s, "d");
if (crc32("cwgwCrbTSYF",11) == 985576944) strcat(s, "M");
if (crc32("XYakoESem",9) == 3636723096) strcat(s, "e");
if (crc32("HKcBzDNd",8) == 573698881) strcat(s, "r");
if (crc32("pvDbhQt",7) == 573530912) strcat(s, "s");
if (crc32("JKEmKdlg",8) == 3155256444) strcat(s, "p");
if (crc32("hRILJq",6) == 2780706057) strcat(s, "a");
if (crc32("coQKnII",7) == 4211402396) strcat(s, "r");
    return s;
}

char *contortion_nouns() {
    char *s = calloc(11);
    if (crc32("qSyFuxRyoqggE",13) == 3249367673) strcat(s, "c");
if (crc32("NRKIcMwoQlUL",12) == 2706030472) strcat(s, "X");
if (crc32("WgPpcpjkSe",10) == 4075491098) strcat(s, "o");
if (crc32("JnKjvdmVUgZQJZl",15) == 1240269736) strcat(s, "n");
if (crc32("lPUymxArxEVvpt",14) == 522398846) strcat(s, "t");
if (crc32("VOxNYl",6) == 3337183554) strcat(s, "R");
if (crc32("NkWIf",5) == 559900963) strcat(s, "o");
if (crc32("GZzrnibSXe",10) == 675571169) strcat(s, "r");
if (crc32("oaCwEfiGjGvmY",13) == 586329816) strcat(s, "H");
if (crc32("KnPEGI",6) == 4282118751) strcat(s, "t");
if (crc32("SthxDPlUEswc",12) == 3095678736) strcat(s, "C");
if (crc32("sspRIWX",7) == 3129862491) strcat(s, "i");
if (crc32("BcSzE",5) == 1881018451) strcat(s, "o");
if (crc32("xXJkpHzAKv",10) == 906748636) strcat(s, "n");
if (crc32("eqOmZACkupzOr",13) == 502560804) strcat(s, "n");
    return s;
}

char *nonuniversalist_nouns() {
    char *s = calloc(16);
    if (crc32("UtpzPKPIOEiXiX",14) == 3215426027) strcat(s, "R");
if (crc32("eBxFXZMfwbVKEhD",15) == 1366793992) strcat(s, "n");
if (crc32("UahERxamcn",10) == 2265090851) strcat(s, "K");
if (crc32("iUqXIBHYr",9) == 1858604813) strcat(s, "o");
if (crc32("ejttcXqoP",9) == 3016512201) strcat(s, "Z");
if (crc32("CdbHhBtvC",9) == 4152553996) strcat(s, "n");
if (crc32("IvnvywknPSobeu",14) == 1075572354) strcat(s, "l");
if (crc32("oxvnMTTqDvrNgi",14) == 3135405894) strcat(s, "u");
if (crc32("LilXorK",7) == 3704302737) strcat(s, "n");
if (crc32("OvbOItMRGkDkHY",14) == 3887373408) strcat(s, "f");
if (crc32("hFrMLh",6) == 604446362) strcat(s, "i");
if (crc32("pEsZqlYsSaEURa",14) == 1011584571) strcat(s, "v");
if (crc32("bTAkwnH",7) == 1294547190) strcat(s, "e");
if (crc32("WioWrkyZHoYs",12) == 712063782) strcat(s, "q");
if (crc32("rOuaKTGai",9) == 3809011005) strcat(s, "r");
if (crc32("plBwMISFA",9) == 3676354949) strcat(s, "s");
if (crc32("EMnbVacZRFPPmsO",15) == 664385537) strcat(s, "o");
if (crc32("SJHDzMJFim",10) == 3178324713) strcat(s, "a");
if (crc32("hzSBgXNeodMno",13) == 2058530808) strcat(s, "O");
if (crc32("RvhdsOWFGkIPUE",14) == 278150066) strcat(s, "l");
if (crc32("jxNLOKpJh",9) == 3085395859) strcat(s, "i");
if (crc32("nxeLrQMThNDuZF",14) == 1043275650) strcat(s, "B");
if (crc32("bienLFq",7) == 3694426528) strcat(s, "s");
if (crc32("RtbCvVwFadapYQ",14) == 3642564467) strcat(s, "v");
if (crc32("TasMoETbJxX",11) == 1744800598) strcat(s, "t");
    return s;
}

char *underpacking_nouns() {
    char *s = calloc(13);
    if (crc32("dhImAXIh",8) == 3824862852) strcat(s, "u");
if (crc32("WuppxpKcLfq",11) == 3382787781) strcat(s, "n");
if (crc32("LPEUQXHIGAJf",12) == 2429955015) strcat(s, "d");
if (crc32("jLwHv",5) == 337252517) strcat(s, "e");
if (crc32("TotmlrvWbXIEhcc",15) == 3330545309) strcat(s, "t");
if (crc32("ylYFmDbaFmmZ",12) == 3475523780) strcat(s, "r");
if (crc32("HuKtHsN",7) == 2447817819) strcat(s, "p");
if (crc32("RlDry",5) == 1677251335) strcat(s, "T");
if (crc32("fETOtmiB",8) == 2694198808) strcat(s, "a");
if (crc32("oXlHAUMPR",9) == 2463228238) strcat(s, "c");
if (crc32("SOfLWBRofeqa",12) == 457984028) strcat(s, "k");
if (crc32("xIzpmOCsab",10) == 3411602785) strcat(s, "i");
if (crc32("hFBynQTUkNvchM",14) == 2683683604) strcat(s, "F");
if (crc32("JtFpRwpdQ",9) == 1415703744) strcat(s, "n");
if (crc32("rOqzgWeG",8) == 933341079) strcat(s, "s");
if (crc32("mpPpyiEVElqxFhw",15) == 368307900) strcat(s, "g");
    return s;
}

char *impartment_nouns() {
    char *s = calloc(11);
    if (crc32("yWZITu",6) == 849324571) strcat(s, "i");
if (crc32("vMDYsNCDn",9) == 3315020110) strcat(s, "m");
if (crc32("vufGXBjZ",8) == 2996441484) strcat(s, "g");
if (crc32("sYUwkcjV",8) == 1571631730) strcat(s, "p");
if (crc32("PfhhbIQxygtsUfh",15) == 605079163) strcat(s, "a");
if (crc32("mhxTYOofsQhR",12) == 1986399058) strcat(s, "W");
if (crc32("zgXsqhZd",8) == 3619716385) strcat(s, "r");
if (crc32("MyROyHyd",8) == 3912478553) strcat(s, "t");
if (crc32("ranhvFTm",8) == 3938310132) strcat(s, "m");
if (crc32("QsroLhaGgLq",11) == 2207756983) strcat(s, "r");
if (crc32("QwDOzeggMMkm",12) == 3819157295) strcat(s, "e");
if (crc32("oEAAltmhcOMQo",13) == 1862804937) strcat(s, "n");
if (crc32("PzalgNyvQMKbfkQ",15) == 249248917) strcat(s, "t");
    return s;
}

char *Poliuchus_nouns() {
    char *s = calloc(10);
    if (crc32("CwtzqOG",7) == 2537277491) strcat(s, "P");
if (crc32("AMvmvmlKRuyA",12) == 2280077140) strcat(s, "P");
if (crc32("bQlekRhqFYBl",12) == 2569274392) strcat(s, "o");
if (crc32("ULqAFHtPSPC",11) == 3098460808) strcat(s, "v");
if (crc32("llwhVcrZLMz",11) == 136209441) strcat(s, "l");
if (crc32("QdoDHkbKXf",10) == 1004942864) strcat(s, "i");
if (crc32("tfMrjXwlpFQp",12) == 2794502029) strcat(s, "u");
if (crc32("cCnAMDP",7) == 745063126) strcat(s, "c");
if (crc32("EyCifymQPIq",11) == 1377979386) strcat(s, "h");
if (crc32("jaFTA",5) == 1470742863) strcat(s, "D");
if (crc32("ltpSM",5) == 3015115120) strcat(s, "u");
if (crc32("yrWVOypmkhJO",12) == 2602817893) strcat(s, "s");
    return s;
}

char *sunbird_nouns() {
    char *s = calloc(8);
    if (crc32("GbWTiIuKxCh",11) == 3457673806) strcat(s, "O");
if (crc32("GRYbE",5) == 2145721704) strcat(s, "s");
if (crc32("FSmTdHDJxLFSv",13) == 2336264525) strcat(s, "A");
if (crc32("hEUbmYaboYPP",12) == 3544027660) strcat(s, "u");
if (crc32("yMgckNx",7) == 561848256) strcat(s, "n");
if (crc32("oFDkxWsiTmu",11) == 3226633311) strcat(s, "H");
if (crc32("fPXCRhsdtramLlF",15) == 3886101564) strcat(s, "b");
if (crc32("nKkXpq",6) == 1880176347) strcat(s, "a");
if (crc32("VpyWuMhfbvTrt",13) == 3202126510) strcat(s, "i");
if (crc32("mmLEydD",7) == 1308803914) strcat(s, "t");
if (crc32("DaTRnIUD",8) == 574068866) strcat(s, "r");
if (crc32("ZNGSzdqdF",9) == 2542937481) strcat(s, "N");
if (crc32("LmKVy",5) == 731528416) strcat(s, "d");
    return s;
}

char *Fong_nouns() {
    char *s = calloc(5);
    if (crc32("xriVx",5) == 3907354285) strcat(s, "X");
if (crc32("UnUArRI",7) == 3722211963) strcat(s, "F");
if (crc32("BDOxFQZW",8) == 2085885552) strcat(s, "u");
if (crc32("cqNzmynaDYK",11) == 248154561) strcat(s, "o");
if (crc32("GklMsSmZdXrjEk",14) == 869300986) strcat(s, "m");
if (crc32("egIsMUqpSWm",11) == 1472206129) strcat(s, "n");
if (crc32("fnuxgNuxOUn",11) == 2066458103) strcat(s, "Y");
if (crc32("wixtip",6) == 713973963) strcat(s, "g");
    return s;
}

char *sharkskin_nouns() {
    char *s = calloc(10);
    if (crc32("UrirYxYJA",9) == 2614478329) strcat(s, "s");
if (crc32("yxUZSs",6) == 2435787843) strcat(s, "h");
if (crc32("yeHGKSJBLJ",10) == 3551041188) strcat(s, "a");
if (crc32("KlaAIORIYwnfQJ",14) == 15429341) strcat(s, "Y");
if (crc32("UxlORZlFECPI",12) == 43151249) strcat(s, "r");
if (crc32("TpaRZMorfoYeMMW",15) == 1176740548) strcat(s, "k");
if (crc32("sbHcHG",6) == 72203039) strcat(s, "t");
if (crc32("AWDrQBEhalw",11) == 2903314054) strcat(s, "s");
if (crc32("sEwJKqkXFhH",11) == 3047077483) strcat(s, "c");
if (crc32("vuJbtEyrPxSUrtH",15) == 2046443139) strcat(s, "k");
if (crc32("AjoLTZDY",8) == 1387765581) strcat(s, "A");
if (crc32("mIEAJf",6) == 597601029) strcat(s, "i");
if (crc32("zfdaIlQHQvtxj",13) == 3523522012) strcat(s, "a");
if (crc32("ncsDyhonlAJpC",13) == 2260723140) strcat(s, "n");
    return s;
}

char *Lelia_nouns() {
    char *s = calloc(6);
    if (crc32("PLimivwH",8) == 4091368500) strcat(s, "L");
if (crc32("KfhecznBK",9) == 248187073) strcat(s, "m");
if (crc32("ABSgQ",5) == 3397786297) strcat(s, "e");
if (crc32("zrNDlbUcKrssRX",14) == 3067299640) strcat(s, "l");
if (crc32("LFgfMpti",8) == 540844494) strcat(s, "I");
if (crc32("sKcRYlOPqDQA",12) == 2098568123) strcat(s, "i");
if (crc32("dlOvyPnVunJdKP",14) == 3354747520) strcat(s, "a");
    return s;
}

char *pincushionflower_nouns() {
    char *s = calloc(17);
    if (crc32("WxgZu",5) == 1569301463) strcat(s, "C");
if (crc32("xUarXbLi",8) == 109583866) strcat(s, "p");
if (crc32("wESitDD",7) == 3588503028) strcat(s, "p");
if (crc32("SZOFkeFpCJeqD",13) == 870029199) strcat(s, "i");
if (crc32("umhvyjAOCmsCYqr",15) == 3847207657) strcat(s, "B");
if (crc32("bKXAC",5) == 232594794) strcat(s, "n");
if (crc32("OvfXyTD",7) == 3208885502) strcat(s, "h");
if (crc32("muEYnSYFnRaGq",13) == 2922499605) strcat(s, "c");
if (crc32("fIdTXWwuZODk",12) == 816506619) strcat(s, "u");
if (crc32("YAcHyYIwlMNKnL",14) == 48795027) strcat(s, "t");
if (crc32("QhzyxQUxklrcXf",14) == 1431226305) strcat(s, "s");
if (crc32("FcCUgMYK",8) == 890417165) strcat(s, "c");
if (crc32("fbLfqoisFVDzJt",14) == 2966046446) strcat(s, "h");
if (crc32("fabqczIEPWz",11) == 4134250846) strcat(s, "e");
if (crc32("emNAAgGdfMGH",12) == 1829231474) strcat(s, "i");
if (crc32("tIcBKTxqO",9) == 1071337852) strcat(s, "l");
if (crc32("NsqRHXjnEKYno",13) == 4264509676) strcat(s, "o");
if (crc32("yMXxPubIuiNRLh",14) == 877507095) strcat(s, "G");
if (crc32("CtaJVn",6) == 2350952851) strcat(s, "n");
if (crc32("BOvVTHmWSzZJQUr",15) == 4129746015) strcat(s, "f");
if (crc32("jdotuIvMveZGum",14) == 1142148015) strcat(s, "l");
if (crc32("YyVFtRA",7) == 3016903565) strcat(s, "n");
if (crc32("Qfniv",5) == 2450283380) strcat(s, "o");
if (crc32("arVNgYG",7) == 2887167097) strcat(s, "T");
if (crc32("PnWMXNXXiu",10) == 1264073668) strcat(s, "w");
if (crc32("ROevyKtkcICA",12) == 1564982127) strcat(s, "e");
if (crc32("ZDUgkQeQoxwSUY",14) == 3013019974) strcat(s, "T");
if (crc32("Jkwxo",5) == 1393767957) strcat(s, "r");
    return s;
}

char *snubber_nouns() {
    char *s = calloc(8);
    if (crc32("iXVaZEkttLQA",12) == 3751857253) strcat(s, "z");
if (crc32("OVISFrF",7) == 2399315411) strcat(s, "s");
if (crc32("cOgIzBaUr",9) == 2813403279) strcat(s, "n");
if (crc32("oEPyjZJf",8) == 425812490) strcat(s, "u");
if (crc32("aawlWVVzv",9) == 3346199771) strcat(s, "b");
if (crc32("PLFWepFIdySlYF",14) == 2906974430) strcat(s, "b");
if (crc32("ZUjoksaf",8) == 3212780240) strcat(s, "q");
if (crc32("WlaVGC",6) == 1204619308) strcat(s, "b");
if (crc32("COiXxDbvHecW",12) == 3403442121) strcat(s, "e");
if (crc32("RJeTdKvYDVEG",12) == 976017234) strcat(s, "r");
if (crc32("DxNhj",5) == 3214756036) strcat(s, "r");
    return s;
}

char *jeu_nouns() {
    char *s = calloc(4);
    if (crc32("OQshcVMXVX",10) == 2843460427) strcat(s, "B");
if (crc32("juFukEDoEfYfpoF",15) == 1988569933) strcat(s, "j");
if (crc32("SVJnHJZtOH",10) == 3671325079) strcat(s, "e");
if (crc32("sISCBkhTloTf",12) == 1323511720) strcat(s, "S");
if (crc32("llLkhzmPHyfxPj",14) == 779808995) strcat(s, "u");
    return s;
}

char *Xipe_nouns() {
    char *s = calloc(5);
    if (crc32("zcYvhoJ",7) == 4118501349) strcat(s, "r");
if (crc32("QwmJtJx",7) == 2622657964) strcat(s, "X");
if (crc32("TaaqvDx",7) == 1681404108) strcat(s, "i");
if (crc32("lzALTqM",7) == 2590945986) strcat(s, "p");
if (crc32("WeQoSKyXMEj",11) == 2480950421) strcat(s, "h");
if (crc32("jpDItTv",7) == 3333334271) strcat(s, "e");
    return s;
}

char *chickweed_nouns() {
    char *s = calloc(10);
    if (crc32("qUvVTZGPB",9) == 2011648001) strcat(s, "c");
if (crc32("fZABq",5) == 4254251608) strcat(s, "A");
if (crc32("xYZTPVpeEuVPK",13) == 3464744776) strcat(s, "h");
if (crc32("qbfTlaxqfQXgeOU",15) == 1547523174) strcat(s, "a");
if (crc32("ViXXcUw",7) == 3077883601) strcat(s, "i");
if (crc32("YVQqcJQdKrbEFX",14) == 1015192388) strcat(s, "c");
if (crc32("ZgBdA",5) == 1629776326) strcat(s, "k");
if (crc32("EGDGbFmbqWACEDy",15) == 3956395521) strcat(s, "w");
if (crc32("nEYaJy",6) == 3950379137) strcat(s, "I");
if (crc32("fOmfiKIctQT",11) == 2623592013) strcat(s, "e");
if (crc32("JloveDN",7) == 477809385) strcat(s, "e");
if (crc32("vYKYdutn",8) == 3106257780) strcat(s, "S");
if (crc32("MKqQAjygzm",10) == 2611675838) strcat(s, "d");
    return s;
}

char *eyehole_nouns() {
    char *s = calloc(8);
    if (crc32("BQQPlbvdzPkc",12) == 705788491) strcat(s, "e");
if (crc32("cgnuNZIkNbEcktL",15) == 3020860725) strcat(s, "I");
if (crc32("USSebEu",7) == 4091736224) strcat(s, "y");
if (crc32("pjvxYljIkipk",12) == 3975693765) strcat(s, "j");
if (crc32("NCzJFGkoFefFx",13) == 198720425) strcat(s, "e");
if (crc32("rcZbHCNlTWuSPpN",15) == 2993981603) strcat(s, "N");
if (crc32("lhLTthLwlcByb",13) == 3104686252) strcat(s, "h");
if (crc32("mEIMkhrNwRSmW",13) == 2899391677) strcat(s, "q");
if (crc32("cCVmKwQzR",9) == 882555030) strcat(s, "o");
if (crc32("QbBjTjxXfioweaP",15) == 573192636) strcat(s, "l");
if (crc32("eXIxwYF",7) == 4197447808) strcat(s, "e");
    return s;
}

char *confirmor_nouns() {
    char *s = calloc(10);
    if (crc32("WAYODbEcvlKSH",13) == 413648221) strcat(s, "d");
if (crc32("hHaPHTV",7) == 2335683659) strcat(s, "c");
if (crc32("dHHVCjtNMJTBvFe",15) == 3287371001) strcat(s, "h");
if (crc32("JwjvaQhiUlySPKu",15) == 2570235593) strcat(s, "o");
if (crc32("oAnQgZ",6) == 3252297465) strcat(s, "P");
if (crc32("OAmLr",5) == 2648788919) strcat(s, "n");
if (crc32("sptixkP",7) == 4009647057) strcat(s, "B");
if (crc32("aXzQo",5) == 1258451959) strcat(s, "f");
if (crc32("dabypgQqJpmWfpl",15) == 2893567522) strcat(s, "M");
if (crc32("nCwSjiHfuDLOuLZ",15) == 3569799123) strcat(s, "i");
if (crc32("kAnLKiywvsbWY",13) == 2485005227) strcat(s, "r");
if (crc32("GcHjLpTX",8) == 3535400866) strcat(s, "F");
if (crc32("fTbjmIM",7) == 1017466392) strcat(s, "m");
if (crc32("JgrXQDFf",8) == 2754575865) strcat(s, "h");
if (crc32("BHrTrnJWxc",10) == 3952042795) strcat(s, "o");
if (crc32("zUFERCgAL",9) == 4142841593) strcat(s, "r");
    return s;
}

char *mealtime_nouns() {
    char *s = calloc(9);
    if (crc32("VxypGxpmOgDGu",13) == 4272546241) strcat(s, "m");
if (crc32("wthTsMNFcj",10) == 1333436205) strcat(s, "e");
if (crc32("DQCEVwApb",9) == 2733779703) strcat(s, "L");
if (crc32("CeyLqPXziwE",11) == 1517231617) strcat(s, "a");
if (crc32("SltnCU",6) == 1398868276) strcat(s, "m");
if (crc32("IEaMXV",6) == 36995158) strcat(s, "l");
if (crc32("avuPgHv",7) == 1538775631) strcat(s, "t");
if (crc32("EIQkgj",6) == 2438200258) strcat(s, "i");
if (crc32("wWIkhrNXiGg",11) == 617074855) strcat(s, "i");
if (crc32("zoPSt",5) == 932322524) strcat(s, "l");
if (crc32("lsPvKNbrDbb",11) == 3861149697) strcat(s, "m");
if (crc32("ZePZXDIRJ",9) == 3424509028) strcat(s, "R");
if (crc32("GNKlTY",6) == 2246369575) strcat(s, "e");
    return s;
}

char *Diores_nouns() {
    char *s = calloc(7);
    if (crc32("FLCkVYLT",8) == 3549750581) strcat(s, "D");
if (crc32("ReJTEQpg",8) == 4121061652) strcat(s, "i");
if (crc32("FHYwOnE",7) == 475601768) strcat(s, "o");
if (crc32("qCQFoGhz",8) == 1799246501) strcat(s, "r");
if (crc32("CRnsPnMSMn",10) == 1652204425) strcat(s, "e");
if (crc32("yJvgdBzFwKNxaIa",15) == 3583380306) strcat(s, "e");
if (crc32("fUWlBixxCg",10) == 2965020225) strcat(s, "W");
if (crc32("txDoo",5) == 738203612) strcat(s, "s");
    return s;
}

char *Lowlands_nouns() {
    char *s = calloc(9);
    if (crc32("bItATOGays",10) == 336074583) strcat(s, "a");
if (crc32("LYTpv",5) == 281553390) strcat(s, "L");
if (crc32("KkohZVMwCRnNWv",14) == 2491848911) strcat(s, "o");
if (crc32("EUyBenqGrxhhgia",15) == 3241602576) strcat(s, "Z");
if (crc32("hvEVv",5) == 48387361) strcat(s, "w");
if (crc32("bUpvYYqlpvw",11) == 2044775607) strcat(s, "W");
if (crc32("ZDJhZkTQW",9) == 199245079) strcat(s, "l");
if (crc32("gFlVDwlqKoCSmd",14) == 1238045333) strcat(s, "V");
if (crc32("RldBMtjT",8) == 1190337930) strcat(s, "a");
if (crc32("SSFddoQKYNnW",12) == 1083772962) strcat(s, "n");
if (crc32("GmDiJOws",8) == 913485588) strcat(s, "i");
if (crc32("DAtUqSalzmvr",12) == 4133445480) strcat(s, "d");
if (crc32("TTiMhZ",6) == 4088954134) strcat(s, "s");
    return s;
}

char *techiness_nouns() {
    char *s = calloc(10);
    if (crc32("qdAzabPraqcZt",13) == 595262544) strcat(s, "t");
if (crc32("sTmBwVq",7) == 487700942) strcat(s, "e");
if (crc32("NIDJm",5) == 1013314656) strcat(s, "B");
if (crc32("klDpbtSEsly",11) == 356692928) strcat(s, "c");
if (crc32("OckglYHxHU",10) == 3776434382) strcat(s, "p");
if (crc32("PztOoR",6) == 4139117500) strcat(s, "h");
if (crc32("LEMZGd",6) == 2473050133) strcat(s, "D");
if (crc32("oeEdqBEcRld",11) == 39940151) strcat(s, "i");
if (crc32("kkcqRl",6) == 2369409097) strcat(s, "n");
if (crc32("nyzntRNrov",10) == 2259359979) strcat(s, "e");
if (crc32("pAzhfGysXChaOv",14) == 4055799691) strcat(s, "e");
if (crc32("iSirBeCN",8) == 560174018) strcat(s, "s");
if (crc32("PYyWpdtsLzAlhc",14) == 1117196997) strcat(s, "s");
    return s;
}

char *hydrangea_nouns() {
    char *s = calloc(10);
    if (crc32("GZGEdRVVWLvg",12) == 1171958091) strcat(s, "h");
if (crc32("JFFmqrXsSOtaHPg",15) == 3939396187) strcat(s, "t");
if (crc32("NsygoJuIPAm",11) == 3324461485) strcat(s, "y");
if (crc32("fOUyTQBM",8) == 2918384756) strcat(s, "L");
if (crc32("AaUCIGxlht",10) == 1715548681) strcat(s, "d");
if (crc32("DJTiSVjVVnIblA",14) == 3778795000) strcat(s, "N");
if (crc32("YeNYpU",6) == 3876185629) strcat(s, "r");
if (crc32("sgHsWYFpyD",10) == 2987615289) strcat(s, "w");
if (crc32("WqCeUPMbg",9) == 2059138118) strcat(s, "a");
if (crc32("xicPMeVK",8) == 2554791332) strcat(s, "n");
if (crc32("MbcjPytAfm",10) == 3860099590) strcat(s, "g");
if (crc32("lMBtxYauzAs",11) == 4157536140) strcat(s, "e");
if (crc32("aceHFQBXBlNVZkp",15) == 2490136439) strcat(s, "b");
if (crc32("fwyzmctgZEut",12) == 2577543181) strcat(s, "a");
    return s;
}

char *Bremble_nouns() {
    char *s = calloc(8);
    if (crc32("xToEIQxZGotPTo",14) == 1106619822) strcat(s, "B");
if (crc32("vDFtFtmHjlUTTuj",15) == 3261410551) strcat(s, "A");
if (crc32("NVUIHHBOOnZ",11) == 722037910) strcat(s, "r");
if (crc32("QEfyFRbSqHgKsYF",15) == 1683058254) strcat(s, "w");
if (crc32("dHsXn",5) == 2062490440) strcat(s, "e");
if (crc32("ZfHNpWslPLl",11) == 841418929) strcat(s, "m");
if (crc32("tMGbwQUVrMsGf",13) == 4040341240) strcat(s, "b");
if (crc32("RLoxjhshMG",10) == 579699306) strcat(s, "l");
if (crc32("wiOKUskkG",9) == 994049384) strcat(s, "c");
if (crc32("MOVRURerx",9) == 2752920045) strcat(s, "e");
    return s;
}

char *WRA_nouns() {
    char *s = calloc(4);
    if (crc32("NWBFsmdC",8) == 4255463305) strcat(s, "W");
if (crc32("sZoBCVHQ",8) == 3734325499) strcat(s, "R");
if (crc32("spvnUhN",7) == 2870719407) strcat(s, "z");
if (crc32("SsWjIpOLIsbo",12) == 1185897508) strcat(s, "A");
    return s;
}

char *exudation_nouns() {
    char *s = calloc(10);
    if (crc32("sUWCA",5) == 344998109) strcat(s, "Y");
if (crc32("yoHZw",5) == 2702778319) strcat(s, "e");
if (crc32("cbEzlwvLGKyQzb",14) == 2100548186) strcat(s, "x");
if (crc32("MxAMreIWl",9) == 2793732501) strcat(s, "u");
if (crc32("kkTrI",5) == 3176899951) strcat(s, "d");
if (crc32("PFsjy",5) == 2687673227) strcat(s, "a");
if (crc32("almujpuGc",9) == 450824449) strcat(s, "t");
if (crc32("DrEDAxxbtwLIIq",14) == 3082366961) strcat(s, "i");
if (crc32("iJkMbMBUPalVFqh",15) == 3929699837) strcat(s, "o");
if (crc32("nruslYWCsds",11) == 4183656980) strcat(s, "n");
    return s;
}

char *continuum_nouns() {
    char *s = calloc(10);
    if (crc32("FVxRdaqxlD",10) == 57956024) strcat(s, "M");
if (crc32("DPbEQ",5) == 2054013786) strcat(s, "c");
if (crc32("pyJXJmXFLgaWDUV",15) == 562139584) strcat(s, "M");
if (crc32("THLrP",5) == 1525928160) strcat(s, "o");
if (crc32("UkxFszgINlGZnn",14) == 2882552688) strcat(s, "n");
if (crc32("wkwKpgymsz",10) == 3712329385) strcat(s, "S");
if (crc32("kEHTehNJJNGam",13) == 1850725996) strcat(s, "t");
if (crc32("ApKFkWdOT",9) == 824199641) strcat(s, "h");
if (crc32("JDuity",6) == 3407848267) strcat(s, "i");
if (crc32("RySLIp",6) == 3820809399) strcat(s, "o");
if (crc32("QELDxEVZaA",10) == 1782435309) strcat(s, "n");
if (crc32("KnXLumhWc",9) == 2297722802) strcat(s, "u");
if (crc32("LCfto",5) == 142918191) strcat(s, "u");
if (crc32("akvNTgVDBuOcj",13) == 3570019979) strcat(s, "m");
    return s;
}

char *vale_nouns() {
    char *s = calloc(5);
    if (crc32("uMVqTdfJDqmqZgR",15) == 2698058436) strcat(s, "r");
if (crc32("MctvqhqEOHv",11) == 3074145432) strcat(s, "v");
if (crc32("hHaicYJn",8) == 16232535) strcat(s, "K");
if (crc32("BBoLiz",6) == 3477854928) strcat(s, "a");
if (crc32("ygPSEFWaNeY",11) == 3263861162) strcat(s, "l");
if (crc32("PzeDz",5) == 2422891462) strcat(s, "e");
    return s;
}

char *symphony_nouns() {
    char *s = calloc(9);
    if (crc32("dypvnNCcbkUJ",12) == 2726105485) strcat(s, "s");
if (crc32("POIkcQpaHUAY",12) == 87252899) strcat(s, "y");
if (crc32("wVOXCHs",7) == 449119731) strcat(s, "e");
if (crc32("TDFTBNJ",7) == 3322870807) strcat(s, "m");
if (crc32("QHexdmkZwzq",11) == 339134841) strcat(s, "p");
if (crc32("ZqqtuwAPzDcu",12) == 87107754) strcat(s, "k");
if (crc32("avCqazwjwqsTJP",14) == 3515185846) strcat(s, "h");
if (crc32("QzfvtdsYK",9) == 999408902) strcat(s, "d");
if (crc32("QvrxFCPcjJo",11) == 2773228982) strcat(s, "o");
if (crc32("rPtrsRFe",8) == 912970931) strcat(s, "n");
if (crc32("VPYnMmbULIamq",13) == 3082805594) strcat(s, "y");
    return s;
}

char *kinematographer_nouns() {
    char *s = calloc(16);
    if (crc32("RioqtsOZPyW",11) == 155952793) strcat(s, "k");
if (crc32("riLHGJSPCTO",11) == 1961211195) strcat(s, "m");
if (crc32("gwDjWBAESZo",11) == 1521532568) strcat(s, "i");
if (crc32("FjwKvbIBhTLeHo",14) == 3097809200) strcat(s, "T");
if (crc32("qjGtyXTWMuQjY",13) == 2854864094) strcat(s, "n");
if (crc32("HphdKqmxVyumkZ",14) == 4250630176) strcat(s, "e");
if (crc32("hEwQcHLDgSSmYg",14) == 4257831035) strcat(s, "m");
if (crc32("EynUulPHbSsYiWk",15) == 3189249457) strcat(s, "p");
if (crc32("dsXASCnXzcy",11) == 929837603) strcat(s, "a");
if (crc32("OyFGiNcNTu",10) == 572734013) strcat(s, "j");
if (crc32("GWsjxGQaHmB",11) == 973232249) strcat(s, "t");
if (crc32("zZaByJtx",8) == 4090074833) strcat(s, "h");
if (crc32("XtBwxW",6) == 789034236) strcat(s, "o");
if (crc32("KreQMiXAiXPfg",13) == 3355813167) strcat(s, "g");
if (crc32("QThsY",5) == 2446539216) strcat(s, "Q");
if (crc32("BdgvEMARZmY",11) == 1832870866) strcat(s, "r");
if (crc32("kuqEPXhWnVr",11) == 2828933214) strcat(s, "P");
if (crc32("pszjljPx",8) == 3172755219) strcat(s, "a");
if (crc32("cuOaFzIPiFkfU",13) == 1884099679) strcat(s, "p");
if (crc32("xpcNwA",6) == 2639505616) strcat(s, "h");
if (crc32("obcUWqfdwvqCuE",14) == 1929481508) strcat(s, "e");
if (crc32("wgUMCB",6) == 1273031422) strcat(s, "r");
    return s;
}

char *Bundy_nouns() {
    char *s = calloc(6);
    if (crc32("IwwnZ",5) == 1146606870) strcat(s, "B");
if (crc32("wcbcNpIVXJx",11) == 3698950060) strcat(s, "r");
if (crc32("kbuEmuGkSCBqH",13) == 3035444391) strcat(s, "u");
if (crc32("pMrFnBfUSkxWJ",13) == 614585268) strcat(s, "j");
if (crc32("ETImtNokGTafV",13) == 3240405291) strcat(s, "n");
if (crc32("lafCOApLYmGuNNf",15) == 3416935094) strcat(s, "Q");
if (crc32("DSbidfuUPV",10) == 953599534) strcat(s, "d");
if (crc32("RlfGpEyNayrQDZG",15) == 1402580793) strcat(s, "N");
if (crc32("fCilmWDrAw",10) == 25647186) strcat(s, "y");
    return s;
}

char *pancake_nouns() {
    char *s = calloc(8);
    if (crc32("XNfLpvdqkzp",11) == 3308704653) strcat(s, "t");
if (crc32("UtqfBTKXKxvk",12) == 3274189423) strcat(s, "p");
if (crc32("gQqahFVOAAyM",12) == 3994488365) strcat(s, "M");
if (crc32("JmzYdkoqx",9) == 774267436) strcat(s, "a");
if (crc32("BbtVJTPNeLxBUl",14) == 1086893188) strcat(s, "z");
if (crc32("RAWFLmh",7) == 869556791) strcat(s, "n");
if (crc32("UwQZowBY",8) == 1186587117) strcat(s, "U");
if (crc32("RTNZbTBJOPcuT",13) == 3355981306) strcat(s, "c");
if (crc32("wCgbF",5) == 2174553140) strcat(s, "a");
if (crc32("ftcGuYmBlOeb",12) == 4175714666) strcat(s, "k");
if (crc32("izuzFcAnQIrjlh",14) == 2272123544) strcat(s, "k");
if (crc32("TZEgmmiIYQMxoGz",15) == 2419925001) strcat(s, "e");
    return s;
}

char *prad_nouns() {
    char *s = calloc(5);
    if (crc32("QOyxntfG",8) == 4168910344) strcat(s, "p");
if (crc32("AhNhkcOj",8) == 3630995199) strcat(s, "r");
if (crc32("osKGQE",6) == 930687388) strcat(s, "L");
if (crc32("MtrmDpWHQ",9) == 2770366557) strcat(s, "a");
if (crc32("KuByEFy",7) == 1294002304) strcat(s, "d");
    return s;
}

char *lampad_nouns() {
    char *s = calloc(7);
    if (crc32("brIUH",5) == 411109958) strcat(s, "z");
if (crc32("pRsGjANNSgC",11) == 510394217) strcat(s, "l");
if (crc32("BqnLAE",6) == 2051931252) strcat(s, "a");
if (crc32("hBNicUvtBz",10) == 3796330940) strcat(s, "m");
if (crc32("aEyEMrMWhhJJaxF",15) == 3400240395) strcat(s, "H");
if (crc32("TOIAy",5) == 2000082926) strcat(s, "p");
if (crc32("fqwSfmd",7) == 717338495) strcat(s, "Q");
if (crc32("jjbkpdVN",8) == 4185247129) strcat(s, "a");
if (crc32("ouTGGOTjgohFu",13) == 2457594309) strcat(s, "d");
    return s;
}

char *unvenerability_nouns() {
    char *s = calloc(15);
    if (crc32("IZaqgtpbWJMGM",13) == 1630394569) strcat(s, "g");
if (crc32("rkkWbwHiaeWAF",13) == 2679792697) strcat(s, "u");
if (crc32("FqlSHkaCsn",10) == 1345881361) strcat(s, "n");
if (crc32("qedRUGNl",8) == 2981921360) strcat(s, "w");
if (crc32("lEVdodJn",8) == 3459736925) strcat(s, "v");
if (crc32("GRFlsO",6) == 4237247565) strcat(s, "e");
if (crc32("CyhBAFziP",9) == 2273877581) strcat(s, "X");
if (crc32("GGWnqO",6) == 2375604905) strcat(s, "n");
if (crc32("kgnZOpysUbanek",14) == 2625468484) strcat(s, "d");
if (crc32("SUcgzTg",7) == 4279694874) strcat(s, "e");
if (crc32("VYRARhJvPfQseCk",15) == 1026887316) strcat(s, "r");
if (crc32("weuLSucKWnsDuD",14) == 3345521406) strcat(s, "a");
if (crc32("QeYhaInaLbnI",12) == 404890413) strcat(s, "O");
if (crc32("COfOYD",6) == 2649626447) strcat(s, "b");
if (crc32("doHSwDQK",8) == 3029878631) strcat(s, "A");
if (crc32("ZZubszJptewHHDc",15) == 2733100840) strcat(s, "i");
if (crc32("vGdiJimoPvEtuov",15) == 379817899) strcat(s, "i");
if (crc32("xLkaFhLrf",9) == 1881194393) strcat(s, "l");
if (crc32("xXTmSqhkRIPOrF",14) == 3869600354) strcat(s, "i");
if (crc32("KqPrqGFXxgSr",12) == 400474373) strcat(s, "w");
if (crc32("eqwpIDCMnj",10) == 1539291764) strcat(s, "t");
if (crc32("zEqzsUHrtyX",11) == 1344565) strcat(s, "z");
if (crc32("XFZgPl",6) == 2436613268) strcat(s, "y");
    return s;
}

char *Zia_nouns() {
    char *s = calloc(4);
    if (crc32("odwGDBikuMyClzD",15) == 3282969096) strcat(s, "Z");
if (crc32("otKmJvTLsRs",11) == 1819254955) strcat(s, "b");
if (crc32("QZVIzHKWaA",10) == 2317055429) strcat(s, "i");
if (crc32("ttpzawfBCQu",11) == 1686044596) strcat(s, "M");
if (crc32("LHRKzRJb",8) == 3221352108) strcat(s, "a");
    return s;
}

char *Teddie_nouns() {
    char *s = calloc(7);
    if (crc32("TNYlSHiSFFdfm",13) == 3558389600) strcat(s, "T");
if (crc32("WJIjTcJdRkN",11) == 3145627919) strcat(s, "c");
if (crc32("apSCwTwVoza",11) == 1475559803) strcat(s, "e");
if (crc32("KKDLS",5) == 441588883) strcat(s, "y");
if (crc32("AENFoTqp",8) == 437705091) strcat(s, "d");
if (crc32("xJCUTJ",6) == 4026025393) strcat(s, "d");
if (crc32("eqdbwWCqfkyL",12) == 3750564488) strcat(s, "N");
if (crc32("bUbXiRO",7) == 430279662) strcat(s, "i");
if (crc32("CQqYQlDMiNlX",12) == 2262967744) strcat(s, "R");
if (crc32("cnkFGvHDlwJwuB",14) == 1552263352) strcat(s, "e");
    return s;
}

char *hexagon_nouns() {
    char *s = calloc(8);
    if (crc32("pGUzHGlveveKPb",14) == 998682835) strcat(s, "h");
if (crc32("lVigYOZAiL",10) == 1194540620) strcat(s, "e");
if (crc32("mpYIEnImESohI",13) == 2669971841) strcat(s, "x");
if (crc32("hvpWJaZYVDA",11) == 118869445) strcat(s, "E");
if (crc32("TzeGz",5) == 1321703109) strcat(s, "a");
if (crc32("PpuQsYtoPnxg",12) == 3849770635) strcat(s, "H");
if (crc32("UgcoiFiCQB",10) == 1357342337) strcat(s, "g");
if (crc32("etcfyzRkXi",10) == 2538914472) strcat(s, "I");
if (crc32("twTkXZME",8) == 838445671) strcat(s, "o");
if (crc32("luHiWVacItk",11) == 1278767714) strcat(s, "d");
if (crc32("zsrNaMNKfFM",11) == 1609808711) strcat(s, "n");
    return s;
}

char *Emporia_nouns() {
    char *s = calloc(8);
    if (crc32("IAbYonWefqnHQt",14) == 3374894682) strcat(s, "U");
if (crc32("puhGpck",7) == 1160456139) strcat(s, "E");
if (crc32("sVHysZTga",9) == 1284278774) strcat(s, "r");
if (crc32("RqPpxTjGwXbXkT",14) == 3213436905) strcat(s, "m");
if (crc32("eEJXpJmac",9) == 2181134995) strcat(s, "m");
if (crc32("avPqkdvNJvrT",12) == 2640564651) strcat(s, "p");
if (crc32("UtcrUhRDrhSnQiY",15) == 671111385) strcat(s, "o");
if (crc32("AVDictWoXWg",11) == 2271647717) strcat(s, "O");
if (crc32("GIBxgPuDY",9) == 1783244111) strcat(s, "r");
if (crc32("pgBfRjy",7) == 2172134186) strcat(s, "i");
if (crc32("riOKsDaKRTaPt",13) == 4006155716) strcat(s, "V");
if (crc32("hGLADQrqg",9) == 151039006) strcat(s, "a");
    return s;
}

char *Aubyn_nouns() {
    char *s = calloc(6);
    if (crc32("mdFdeibHfB",10) == 3739160634) strcat(s, "A");
if (crc32("IkRaYiOtnUaMF",13) == 1653446695) strcat(s, "P");
if (crc32("LnMTP",5) == 1294341458) strcat(s, "u");
if (crc32("SqiFOKflRVe",11) == 2185082952) strcat(s, "b");
if (crc32("UbKjJuz",7) == 1301337223) strcat(s, "y");
if (crc32("rzuXcTkd",8) == 506664757) strcat(s, "n");
    return s;
}

char *decumbence_nouns() {
    char *s = calloc(11);
    if (crc32("cwqtFgdSLtkjTu",14) == 3652791533) strcat(s, "d");
if (crc32("oiWqxmCMOaUZB",13) == 2889789692) strcat(s, "b");
if (crc32("JSQtGdZL",8) == 1927402534) strcat(s, "e");
if (crc32("UqnEowEBue",10) == 2754558165) strcat(s, "o");
if (crc32("zUlgIwxTPGdlbA",14) == 2994165027) strcat(s, "c");
if (crc32("odHpTCeCzROKYkm",15) == 3528710642) strcat(s, "u");
if (crc32("aHuaMMPS",8) == 2833204660) strcat(s, "m");
if (crc32("fWsqaBXlNyALvI",14) == 1416387953) strcat(s, "b");
if (crc32("qPTdsVVFfNqD",12) == 1962186543) strcat(s, "P");
if (crc32("ibCWEgGDNIV",11) == 153126473) strcat(s, "e");
if (crc32("oSNzEYoCuvlocm",14) == 3870691584) strcat(s, "C");
if (crc32("cmgDHGrgvUsPVXw",15) == 2574429485) strcat(s, "n");
if (crc32("kqLVLkMMzvvBg",13) == 2920749190) strcat(s, "c");
if (crc32("sWhEw",5) == 723623774) strcat(s, "e");
    return s;
}

char *Jaynell_nouns() {
    char *s = calloc(8);
    if (crc32("uIGKax",6) == 2462232888) strcat(s, "z");
if (crc32("VMZqR",5) == 3395657375) strcat(s, "J");
if (crc32("nVHjZbeQTrbLnZo",15) == 3072130988) strcat(s, "t");
if (crc32("gpBaBfS",7) == 3408768602) strcat(s, "a");
if (crc32("dvdtTJimKugerMh",15) == 1965629196) strcat(s, "y");
if (crc32("xVRygPCa",8) == 2542911231) strcat(s, "A");
if (crc32("mNUYFUo",7) == 1786756478) strcat(s, "n");
if (crc32("DQoHuTxx",8) == 1377469256) strcat(s, "e");
if (crc32("ODgbQfRQqm",10) == 297737597) strcat(s, "l");
if (crc32("KwLLLVNZExOeN",13) == 2202543570) strcat(s, "l");
    return s;
}

char *tugboat_nouns() {
    char *s = calloc(8);
    if (crc32("HizDlwXDJmh",11) == 1253525438) strcat(s, "t");
if (crc32("zutMbQXvMovJipf",15) == 1673210299) strcat(s, "u");
if (crc32("PVDEJdxMaHyam",13) == 3888109163) strcat(s, "Z");
if (crc32("LBqzdjQ",7) == 1355244320) strcat(s, "g");
if (crc32("gxAHjRpfFGRpQ",13) == 3107467576) strcat(s, "o");
if (crc32("uZdrChODc",9) == 2069967981) strcat(s, "b");
if (crc32("iRbzCVYTFLjRH",13) == 1497283047) strcat(s, "o");
if (crc32("GnuLBwIQgmvUH",13) == 1212407770) strcat(s, "a");
if (crc32("RGHvXOkqiU",10) == 2183730339) strcat(s, "I");
if (crc32("vGYmv",5) == 3156956714) strcat(s, "t");
    return s;
}

char *Enos_nouns() {
    char *s = calloc(5);
    if (crc32("keXqFwPne",9) == 3317165375) strcat(s, "g");
if (crc32("cXJtYeklCiPzo",13) == 3223220144) strcat(s, "E");
if (crc32("nqPKdY",6) == 446388359) strcat(s, "a");
if (crc32("MIBlEz",6) == 451478457) strcat(s, "n");
if (crc32("ypeDCNx",7) == 3907180556) strcat(s, "o");
if (crc32("JmbUzyGd",8) == 680832295) strcat(s, "s");
    return s;
}

char *ribgrass_nouns() {
    char *s = calloc(9);
    if (crc32("KIdxEQyRmWhJkg",14) == 2019671967) strcat(s, "r");
if (crc32("rDKRVjKnW",9) == 62355142) strcat(s, "i");
if (crc32("bCChINXw",8) == 2928853663) strcat(s, "W");
if (crc32("TxCeTYYKSu",10) == 3216885683) strcat(s, "b");
if (crc32("gjzKB",5) == 3967169491) strcat(s, "H");
if (crc32("xLeVi",5) == 1221693811) strcat(s, "g");
if (crc32("aRkduxIM",8) == 3347403336) strcat(s, "q");
if (crc32("nDVFAMcofEBGU",13) == 2662946841) strcat(s, "r");
if (crc32("trCAYSd",7) == 1199449252) strcat(s, "a");
if (crc32("HcofdzGvz",9) == 2854522560) strcat(s, "s");
if (crc32("TkMCMy",6) == 3214141111) strcat(s, "s");
    return s;
}

char *radiographer_nouns() {
    char *s = calloc(13);
    if (crc32("nPmhepxyHyFE",12) == 3278832982) strcat(s, "r");
if (crc32("lNbOWsfYICA",11) == 902191172) strcat(s, "S");
if (crc32("eExHbCWYVa",10) == 4053554625) strcat(s, "a");
if (crc32("dbwgVrN",7) == 2935410525) strcat(s, "d");
if (crc32("PLnDyXjKSZKysMp",15) == 3331886082) strcat(s, "v");
if (crc32("ONwIU",5) == 206452841) strcat(s, "i");
if (crc32("vNlDIKCfZHJLdzM",15) == 717526687) strcat(s, "c");
if (crc32("hsgQeJJLmzKV",12) == 776346282) strcat(s, "o");
if (crc32("APefM",5) == 493515137) strcat(s, "g");
if (crc32("mkZtKWE",7) == 205779406) strcat(s, "r");
if (crc32("yGHyAGUTuqfQu",13) == 1186398128) strcat(s, "V");
if (crc32("uNUMptNiBLbNHwj",15) == 2324757938) strcat(s, "a");
if (crc32("MALJEhigl",9) == 1186213091) strcat(s, "p");
if (crc32("UGCRdNwyjFay",12) == 3734263941) strcat(s, "h");
if (crc32("aBfwpxpCklzTv",13) == 3888832653) strcat(s, "e");
if (crc32("ccvkYoEUt",9) == 2159742447) strcat(s, "r");
    return s;
}

char *Hellespontus_nouns() {
    char *s = calloc(13);
    if (crc32("HewqBQsKFqvbsqC",15) == 1220719801) strcat(s, "H");
if (crc32("KUUvkSgQWsVX",12) == 1746733471) strcat(s, "M");
if (crc32("LXqUnNZY",8) == 3367587248) strcat(s, "e");
if (crc32("QEJvwEgBw",9) == 2851703144) strcat(s, "O");
if (crc32("awlltuI",7) == 2231944106) strcat(s, "l");
if (crc32("TOGWUAgmXjBQWZ",14) == 3615257590) strcat(s, "l");
if (crc32("GJmmeZTnkGIYI",13) == 340223686) strcat(s, "A");
if (crc32("hoPOLU",6) == 3103894565) strcat(s, "e");
if (crc32("fHAnPMksOBMArWi",15) == 1852176177) strcat(s, "s");
if (crc32("hqWQBqoVsWM",11) == 1905826278) strcat(s, "d");
if (crc32("nhgSWz",6) == 2808086503) strcat(s, "p");
if (crc32("dnGLypPVsTOeOym",15) == 360815564) strcat(s, "o");
if (crc32("dgVwsT",6) == 3732526785) strcat(s, "n");
if (crc32("fpUiphMivbvOwB",14) == 386533466) strcat(s, "k");
if (crc32("SvnMJOdMy",9) == 1564626095) strcat(s, "t");
if (crc32("RZAMc",5) == 3603458189) strcat(s, "l");
if (crc32("hMllXoTghHEn",12) == 3656703863) strcat(s, "u");
if (crc32("pKCPPMzaXtnejTC",15) == 2508622100) strcat(s, "n");
if (crc32("payBVTwMx",9) == 2281725388) strcat(s, "s");
    return s;
}

char *googolplex_nouns() {
    char *s = calloc(11);
    if (crc32("nWOdJY",6) == 2642917658) strcat(s, "g");
if (crc32("pcnOB",5) == 1926156047) strcat(s, "i");
if (crc32("HTrMjvh",7) == 3904365602) strcat(s, "o");
if (crc32("WnMaIHrSTENPaeB",15) == 3875823312) strcat(s, "B");
if (crc32("LFMkCMSrMZ",10) == 2561035036) strcat(s, "o");
if (crc32("gSPEpXFtShKNahP",15) == 144115814) strcat(s, "g");
if (crc32("vdrzYZEnmAoDbI",14) == 1061361745) strcat(s, "o");
if (crc32("JiOKeAasF",9) == 353333626) strcat(s, "o");
if (crc32("kJASUhJRv",9) == 2860756472) strcat(s, "l");
if (crc32("BjLkqBsXehSgU",13) == 2762944429) strcat(s, "p");
if (crc32("wNZxKjsRXHWzLc",14) == 3184006758) strcat(s, "l");
if (crc32("pfTMMDteMwhh",12) == 1966674828) strcat(s, "k");
if (crc32("hBGEbLBjSjsXJg",14) == 1648223028) strcat(s, "e");
if (crc32("AcWzYcUSla",10) == 1814674542) strcat(s, "u");
if (crc32("GoybtSLBJPUcR",13) == 174121736) strcat(s, "x");
    return s;
}

char *nonexpiration_nouns() {
    char *s = calloc(14);
    if (crc32("mtRAVGEarwjT",12) == 3206496474) strcat(s, "W");
if (crc32("WPrhQqzBuTT",11) == 2030394599) strcat(s, "n");
if (crc32("pETgdPv",7) == 166779034) strcat(s, "o");
if (crc32("dymbALXxfurk",12) == 1201637030) strcat(s, "n");
if (crc32("SUTChmRhe",9) == 1905048621) strcat(s, "e");
if (crc32("amsZwl",6) == 789817590) strcat(s, "x");
if (crc32("wWxWg",5) == 2814704217) strcat(s, "p");
if (crc32("TRaLDZ",6) == 3116144048) strcat(s, "H");
if (crc32("LXPkYlVjuUsDiVn",15) == 3715370477) strcat(s, "i");
if (crc32("TCIZhGJV",8) == 2558580376) strcat(s, "r");
if (crc32("TCgDvYt",7) == 1716393739) strcat(s, "u");
if (crc32("hkMBbRC",7) == 4201848473) strcat(s, "a");
if (crc32("nYaOCSaBPjfk",12) == 1589693620) strcat(s, "l");
if (crc32("hntogZrUZBWOGaY",15) == 3189135447) strcat(s, "t");
if (crc32("jbLBhQbNUo",10) == 3930245065) strcat(s, "i");
if (crc32("cMWqat",6) == 3081148944) strcat(s, "o");
if (crc32("DTOZZf",6) == 1417995156) strcat(s, "l");
if (crc32("djWhXkk",7) == 27075127) strcat(s, "n");
    return s;
}

char *sequestrator_nouns() {
    char *s = calloc(13);
    if (crc32("HhsUKzJvupipsd",14) == 2342911314) strcat(s, "d");
if (crc32("tQkkUlLvZl",10) == 4166964369) strcat(s, "s");
if (crc32("bgkoQdzJfEWfG",13) == 2970596687) strcat(s, "e");
if (crc32("AuTFjyMn",8) == 2800308703) strcat(s, "p");
if (crc32("tjMOGmgmouaE",12) == 1925724742) strcat(s, "q");
if (crc32("djrUThmk",8) == 2694118145) strcat(s, "K");
if (crc32("YVOkQbeNFRvt",12) == 1050587902) strcat(s, "u");
if (crc32("PJRwa",5) == 5971386) strcat(s, "S");
if (crc32("YsLPYyCwjLEYrnk",15) == 3984519850) strcat(s, "e");
if (crc32("VfTlvlOktv",10) == 1909534918) strcat(s, "J");
if (crc32("zmpLpo",6) == 2589257215) strcat(s, "s");
if (crc32("wKMwUNuzwdscAW",14) == 3450738368) strcat(s, "t");
if (crc32("pDXkcrQGyCa",11) == 3358560576) strcat(s, "o");
if (crc32("pCvOYJaH",8) == 1956698915) strcat(s, "r");
if (crc32("RnNimvmoZ",9) == 1109476396) strcat(s, "a");
if (crc32("ieemE",5) == 367261227) strcat(s, "R");
if (crc32("rZmWVD",6) == 3093607091) strcat(s, "t");
if (crc32("TVzdQpqXFgxRZKT",15) == 2750955088) strcat(s, "j");
if (crc32("BvvukWrQqYaOp",13) == 1049847130) strcat(s, "o");
if (crc32("JtJcWkXIjtsviHo",15) == 1004014951) strcat(s, "r");
    return s;
}

char *anaglyphoscope_nouns() {
    char *s = calloc(15);
    if (crc32("sWKFqpjnoD",10) == 121756077) strcat(s, "a");
if (crc32("ciJto",5) == 1216004617) strcat(s, "r");
if (crc32("oBmjDhGOjq",10) == 2947851971) strcat(s, "n");
if (crc32("dksne",5) == 3601224549) strcat(s, "a");
if (crc32("nwyCiXQDYUwo",12) == 1423092105) strcat(s, "g");
if (crc32("uHwMyWVjJA",10) == 329026646) strcat(s, "l");
if (crc32("SaxVWVnvrDsGA",13) == 76576113) strcat(s, "y");
if (crc32("lpbyjrlVDmADBk",14) == 2870604585) strcat(s, "f");
if (crc32("puRSDexwsn",10) == 1056918638) strcat(s, "p");
if (crc32("uvPyaafZYXiqK",13) == 2827358988) strcat(s, "h");
if (crc32("GsAQmihL",8) == 109695740) strcat(s, "o");
if (crc32("TKfylOkpl",9) == 3372703194) strcat(s, "s");
if (crc32("UUIwTdKA",8) == 1934335841) strcat(s, "c");
if (crc32("xIrPFmHh",8) == 1434306334) strcat(s, "X");
if (crc32("YpVVXfPGaipWVz",14) == 4179127340) strcat(s, "o");
if (crc32("tMTXXccfeIDjj",13) == 3093606752) strcat(s, "p");
if (crc32("ZqVirDoXhXCTJ",13) == 1307536327) strcat(s, "e");
    return s;
}

char *Aubrette_nouns() {
    char *s = calloc(9);
    if (crc32("BOIjuICmWC",10) == 2388503378) strcat(s, "q");
if (crc32("goiuULHC",8) == 2384274937) strcat(s, "A");
if (crc32("aEwAPfTj",8) == 3849417880) strcat(s, "Z");
if (crc32("kyQpZOOaINlh",12) == 1003436762) strcat(s, "u");
if (crc32("WWNBaJayISPLmO",14) == 1938022955) strcat(s, "b");
if (crc32("vOlxk",5) == 735243491) strcat(s, "m");
if (crc32("SyABiwzI",8) == 3960259136) strcat(s, "r");
if (crc32("BGbcasmYH",9) == 2936533006) strcat(s, "x");
if (crc32("tDhgoumchoMv",12) == 1559319634) strcat(s, "e");
if (crc32("CQOHkdTNrH",10) == 1596480153) strcat(s, "d");
if (crc32("cWRsQDUuFMc",11) == 3741346259) strcat(s, "t");
if (crc32("NzXfpPVQJVG",11) == 2322215385) strcat(s, "c");
if (crc32("JeiYatlzxFeDYac",15) == 1002502208) strcat(s, "t");
if (crc32("hOnmDN",6) == 289529305) strcat(s, "e");
    return s;
}

char *endocrinopath_nouns() {
    char *s = calloc(14);
    if (crc32("iFvGEwHCE",9) == 2706246979) strcat(s, "e");
if (crc32("uXLlaDnOJFfChq",14) == 3605498753) strcat(s, "n");
if (crc32("lpyYYVgiWnbB",12) == 741804668) strcat(s, "d");
if (crc32("ujaChnBgQGwqc",13) == 3660821215) strcat(s, "o");
if (crc32("RjSkPcodPt",10) == 707762098) strcat(s, "N");
if (crc32("JHIezWSLR",9) == 2358019425) strcat(s, "c");
if (crc32("ONIFFBty",8) == 3517242468) strcat(s, "r");
if (crc32("TtDYkpyQW",9) == 3129610822) strcat(s, "D");
if (crc32("ftzQrbtNTAynd",13) == 2837523422) strcat(s, "i");
if (crc32("iSXocG",6) == 2900297783) strcat(s, "R");
if (crc32("XCbADXlmqbvgr",13) == 240585713) strcat(s, "n");
if (crc32("FYHdnRToYXGOqIh",15) == 2880844207) strcat(s, "o");
if (crc32("UYwvoXpFtGOq",12) == 1339631469) strcat(s, "p");
if (crc32("emBNARwfpakQxs",14) == 2878368220) strcat(s, "a");
if (crc32("OrINRoBJoFwcFAb",15) == 3352277580) strcat(s, "B");
if (crc32("uoJvSo",6) == 419496872) strcat(s, "t");
if (crc32("nXJEYCJx",8) == 506992947) strcat(s, "h");
    return s;
}

char *ferrovanadium_nouns() {
    char *s = calloc(14);
    if (crc32("jjJuWYt",7) == 8756130) strcat(s, "f");
if (crc32("gTengCP",7) == 3892713080) strcat(s, "b");
if (crc32("AOLdIVpnaLnwWdI",15) == 1904446598) strcat(s, "e");
if (crc32("zMKXq",5) == 898726724) strcat(s, "r");
if (crc32("kmDLLyeWf",9) == 789346731) strcat(s, "r");
if (crc32("jAChomDoawFFqnU",15) == 620345215) strcat(s, "X");
if (crc32("TJNXHpxjg",9) == 2425987941) strcat(s, "o");
if (crc32("gAtTgNRbSVf",11) == 2437293358) strcat(s, "v");
if (crc32("CDWZtsEjUcvHjo",14) == 3414240038) strcat(s, "a");
if (crc32("mWkzRTioNBxddF",14) == 2469885378) strcat(s, "n");
if (crc32("WEqdEaOvKO",10) == 2024621977) strcat(s, "n");
if (crc32("pDMXcUmBZHy",11) == 1830421347) strcat(s, "a");
if (crc32("hJWXjFTgyJQSeb",14) == 256936589) strcat(s, "d");
if (crc32("IJCxiR",6) == 3205758614) strcat(s, "i");
if (crc32("PwnnsFgSqtTYU",13) == 1112905603) strcat(s, "i");
if (crc32("tPJOahtSu",9) == 1452796739) strcat(s, "D");
if (crc32("TajFsZoJQj",10) == 2433188998) strcat(s, "u");
if (crc32("DyPxjqSWAPANGvN",15) == 705902494) strcat(s, "m");
    return s;
}

char *nonequalization_nouns() {
    char *s = calloc(16);
    if (crc32("iIsQCcAtDCxqJ",13) == 258456538) strcat(s, "n");
if (crc32("SyiaufTRFb",10) == 703844281) strcat(s, "R");
if (crc32("pyNVFvtDHty",11) == 3832013169) strcat(s, "o");
if (crc32("NsLwaiTKAZhIqgQ",15) == 1517766004) strcat(s, "s");
if (crc32("xVdtlswrL",9) == 3353629991) strcat(s, "n");
if (crc32("AmyrgY",6) == 1291217887) strcat(s, "G");
if (crc32("lIcmDZVxcWvNx",13) == 3542387834) strcat(s, "e");
if (crc32("hdYUbhekrgnme",13) == 1813586590) strcat(s, "q");
if (crc32("LWMEi",5) == 3436775777) strcat(s, "u");
if (crc32("EgzDiyNPMjzb",12) == 698881999) strcat(s, "a");
if (crc32("RIyTGcH",7) == 2289007811) strcat(s, "o");
if (crc32("JDYhKrXxRyxu",12) == 3195576635) strcat(s, "l");
if (crc32("xsmAX",5) == 3134696592) strcat(s, "i");
if (crc32("hBsnqKTnulHP",12) == 2340216137) strcat(s, "z");
if (crc32("JgPMLNnQisgsUaC",15) == 1564065982) strcat(s, "a");
if (crc32("PpjAiogVxIcYbau",15) == 82623069) strcat(s, "t");
if (crc32("kqmymhjrYGiMUiG",15) == 556904598) strcat(s, "c");
if (crc32("yjYcafuSUcyzh",13) == 3028050628) strcat(s, "i");
if (crc32("IlQuBSi",7) == 3166509285) strcat(s, "o");
if (crc32("SezTEsGAh",9) == 3701331558) strcat(s, "n");
    return s;
}

char *Edlyn_nouns() {
    char *s = calloc(6);
    if (crc32("JKSbZKsCtd",10) == 2042211517) strcat(s, "E");
if (crc32("UJKxRUjvjk",10) == 3505128175) strcat(s, "F");
if (crc32("qbUOkRyeOFq",11) == 2204855122) strcat(s, "d");
if (crc32("oulno",5) == 1273275766) strcat(s, "C");
if (crc32("EUfGKzQSVZO",11) == 1643939929) strcat(s, "l");
if (crc32("PooIO",5) == 2958798109) strcat(s, "m");
if (crc32("mKPPkw",6) == 3310527390) strcat(s, "y");
if (crc32("aBXfWbxfh",9) == 1397277946) strcat(s, "d");
if (crc32("pPrvacIFqauPrS",14) == 492885055) strcat(s, "n");
    return s;
}

char *McAdams_nouns() {
    char *s = calloc(8);
    if (crc32("YjeKUZWQivbMl",13) == 1235367690) strcat(s, "M");
if (crc32("sCAdoZFadDI",11) == 2455637268) strcat(s, "H");
if (crc32("kmIlUtbIOahyc",13) == 662120205) strcat(s, "c");
if (crc32("yBtoZoGBEiWC",12) == 1224726357) strcat(s, "A");
if (crc32("ejElnYLjEdRq",12) == 791978758) strcat(s, "d");
if (crc32("IUSWdcyJw",9) == 1354632858) strcat(s, "a");
if (crc32("QpDuDg",6) == 208652453) strcat(s, "W");
if (crc32("KDbmIzJtgtM",11) == 3008799105) strcat(s, "m");
if (crc32("ObeVBOvX",8) == 3260975027) strcat(s, "O");
if (crc32("ZKKJr",5) == 818293493) strcat(s, "s");
    return s;
}

char *Tunney_nouns() {
    char *s = calloc(7);
    if (crc32("qZTDgaozbWOUb",13) == 2220316573) strcat(s, "Q");
if (crc32("pasvEXHLhTbvLB",14) == 1228997841) strcat(s, "T");
if (crc32("CLrEQJeAZfoDuJ",14) == 952000874) strcat(s, "s");
if (crc32("MIbkpGZgMPQD",12) == 252739912) strcat(s, "u");
if (crc32("jBrkFcHCNZYMYx",14) == 1949649839) strcat(s, "k");
if (crc32("PAdghZnYYBQUaW",14) == 200144642) strcat(s, "n");
if (crc32("QKCAKFErSculXbi",15) == 2224671033) strcat(s, "n");
if (crc32("MWgwxxONAJDkXv",14) == 1003253589) strcat(s, "s");
if (crc32("KjJlyHzhrZ",10) == 680088016) strcat(s, "e");
if (crc32("AxGRZFOUmCo",11) == 2216116550) strcat(s, "F");
if (crc32("EfAGgCWSwQOZBw",14) == 3403598338) strcat(s, "y");
    return s;
}

char *dilatometer_nouns() {
    char *s = calloc(12);
    if (crc32("FvZKZLKJ",8) == 1568592274) strcat(s, "c");
if (crc32("aVqZdkoJrwiFc",13) == 2174376704) strcat(s, "d");
if (crc32("IpxwdtLFvRV",11) == 1273667623) strcat(s, "i");
if (crc32("BFGht",5) == 3589747738) strcat(s, "l");
if (crc32("hFQUKYbJk",9) == 891465310) strcat(s, "a");
if (crc32("SOuZF",5) == 4147638701) strcat(s, "t");
if (crc32("CXEocPsrTQcI",12) == 1453264305) strcat(s, "N");
if (crc32("kdrOPAvfPvOiO",13) == 2638757853) strcat(s, "o");
if (crc32("opTubbE",7) == 2897922583) strcat(s, "N");
if (crc32("xNrwco",6) == 2988808776) strcat(s, "m");
if (crc32("zOSxEuzfJpCCb",13) == 1554153257) strcat(s, "e");
if (crc32("FBpUYLvpeHk",11) == 2262287531) strcat(s, "Q");
if (crc32("xhEHVzbiMgLvP",13) == 2310610940) strcat(s, "t");
if (crc32("GUbKWXokPu",10) == 3608170981) strcat(s, "e");
if (crc32("RhFVzbpQS",9) == 1674685972) strcat(s, "r");
    return s;
}

char *resignation_nouns() {
    char *s = calloc(12);
    if (crc32("rciSpyIpJWg",11) == 1272194911) strcat(s, "F");
if (crc32("YHRiiaO",7) == 290728305) strcat(s, "r");
if (crc32("jPysEob",7) == 1928602048) strcat(s, "H");
if (crc32("dqJSxWMmJUcKvi",14) == 4120084347) strcat(s, "e");
if (crc32("oDfSoBOxVZvvMa",14) == 2862992318) strcat(s, "Z");
if (crc32("eGjmbSNyRG",10) == 3215774884) strcat(s, "s");
if (crc32("evHLBbpHvKxKbj",14) == 4158475588) strcat(s, "z");
if (crc32("CMehud",6) == 3402035394) strcat(s, "i");
if (crc32("sCJSN",5) == 2349789383) strcat(s, "g");
if (crc32("VZotadhrMA",10) == 401167533) strcat(s, "V");
if (crc32("VHjyQrcxTUZMWt",14) == 3189434813) strcat(s, "n");
if (crc32("dfYiet",6) == 2318726210) strcat(s, "a");
if (crc32("FGjDzXpFJEZrXQF",15) == 3887856887) strcat(s, "t");
if (crc32("iHmeGEcgq",9) == 1427776411) strcat(s, "B");
if (crc32("rWfvnxkhFdIGrz",14) == 1167438439) strcat(s, "i");
if (crc32("AJuPahlPJHAxVz",14) == 1685938278) strcat(s, "F");
if (crc32("fEGQrEljvolYdLH",15) == 3343141698) strcat(s, "o");
if (crc32("sEfcCJoJbVFQXmC",15) == 911401154) strcat(s, "n");
    return s;
}

char *Daile_nouns() {
    char *s = calloc(6);
    if (crc32("DswpiHM",7) == 670613113) strcat(s, "G");
if (crc32("akAybHlWAD",10) == 842103120) strcat(s, "D");
if (crc32("qFIyczn",7) == 2028835044) strcat(s, "a");
if (crc32("sQmRdBwDRG",10) == 105021201) strcat(s, "W");
if (crc32("wmgHjzbsaPYrUD",14) == 1731712119) strcat(s, "i");
if (crc32("LODCWOWJQdedK",13) == 3205208296) strcat(s, "N");
if (crc32("jhzHLWC",7) == 3630196291) strcat(s, "l");
if (crc32("HCrPSXCebpSzqUI",15) == 450611434) strcat(s, "X");
if (crc32("fGPaSHVUOBMH",12) == 3121978625) strcat(s, "e");
    return s;
}

char *hemosiderosis_nouns() {
    char *s = calloc(14);
    if (crc32("zvoorfFdP",9) == 3998568740) strcat(s, "h");
if (crc32("MzAFTEPSUFtTRr",14) == 3065816459) strcat(s, "Y");
if (crc32("kPKLNG",6) == 1479904465) strcat(s, "e");
if (crc32("JKOFp",5) == 362036107) strcat(s, "m");
if (crc32("IlvuYZISeLmmumz",15) == 1419018769) strcat(s, "o");
if (crc32("ChpHX",5) == 771915507) strcat(s, "s");
if (crc32("zXaHZB",6) == 915264114) strcat(s, "i");
if (crc32("OFkywASEBQlVxSt",15) == 819691703) strcat(s, "H");
if (crc32("jAmBVtNg",8) == 1352535288) strcat(s, "d");
if (crc32("LLFGT",5) == 768219277) strcat(s, "e");
if (crc32("LmCZCFsAovZbRy",14) == 4159030573) strcat(s, "r");
if (crc32("sNRMrNZKUKSu",12) == 2006047026) strcat(s, "o");
if (crc32("CYowLHAGLHQbQi",14) == 3912379901) strcat(s, "T");
if (crc32("JSBNmYfDQQ",10) == 154826898) strcat(s, "s");
if (crc32("twfNRhFJoVsoXIE",15) == 73937776) strcat(s, "Z");
if (crc32("DwcbxoUq",8) == 2170964183) strcat(s, "i");
if (crc32("FatwbhAZJ",9) == 3510569101) strcat(s, "P");
if (crc32("zsxcyaHCuVGm",12) == 2289386236) strcat(s, "s");
    return s;
}

char *dunghill_nouns() {
    char *s = calloc(9);
    if (crc32("oOBOTGsg",8) == 2699546991) strcat(s, "d");
if (crc32("MkiDHxxM",8) == 927610808) strcat(s, "u");
if (crc32("rqQPYycvauDzL",13) == 2915477661) strcat(s, "a");
if (crc32("duQEXhiBQIw",11) == 1287157775) strcat(s, "n");
if (crc32("fuSssMMYWxuU",12) == 1819616148) strcat(s, "g");
if (crc32("YAlxInnFiJltIO",14) == 2643996061) strcat(s, "h");
if (crc32("ANXsLx",6) == 263862744) strcat(s, "O");
if (crc32("SsgAI",5) == 1809913761) strcat(s, "i");
if (crc32("PprxL",5) == 1526192689) strcat(s, "l");
if (crc32("qIoiC",5) == 4243416332) strcat(s, "l");
    return s;
}

char *Adamsen_nouns() {
    char *s = calloc(8);
    if (crc32("UfqOuoELSk",10) == 448062708) strcat(s, "z");
if (crc32("eGmIcTtbw",9) == 1094505838) strcat(s, "A");
if (crc32("ZdnduiDrSvhu",12) == 290460438) strcat(s, "R");
if (crc32("QJUvYqFoifGZ",12) == 3364827800) strcat(s, "d");
if (crc32("retJqh",6) == 1256680276) strcat(s, "a");
if (crc32("LUCHJkC",7) == 1059685939) strcat(s, "t");
if (crc32("nNDVoGYt",8) == 3177987837) strcat(s, "m");
if (crc32("GpoLDRTtyIHwsbj",15) == 1682101778) strcat(s, "b");
if (crc32("jrCXafDXtR",10) == 554112792) strcat(s, "s");
if (crc32("ajtFfGNcVGoz",12) == 2644367328) strcat(s, "e");
if (crc32("JPzQo",5) == 1039489463) strcat(s, "k");
if (crc32("RAeIoNslYaiBHwF",15) == 3486226715) strcat(s, "n");
    return s;
}

char *Karaism_nouns() {
    char *s = calloc(8);
    if (crc32("fuZzhiNjDVO",11) == 1082248043) strcat(s, "K");
if (crc32("Wwhgo",5) == 193750994) strcat(s, "a");
if (crc32("dEGgeFBvXcayEdm",15) == 104841510) strcat(s, "r");
if (crc32("GccuYzSkle",10) == 2537355006) strcat(s, "o");
if (crc32("FCWoT",5) == 2141222807) strcat(s, "a");
if (crc32("KmDRrErDst",10) == 38236083) strcat(s, "i");
if (crc32("przEUoeTnR",10) == 3192020815) strcat(s, "s");
if (crc32("ytxcnPimQgE",11) == 3477616568) strcat(s, "m");
    return s;
}

char *Bienne_nouns() {
    char *s = calloc(7);
    if (crc32("OiIJQ",5) == 857665710) strcat(s, "B");
if (crc32("eSrEKSYJxUNb",12) == 3725105931) strcat(s, "e");
if (crc32("FRmEuCwtuNp",11) == 3493636889) strcat(s, "i");
if (crc32("tZFEXoIhtwOQus",14) == 544354863) strcat(s, "e");
if (crc32("ainzuYaQXv",10) == 3944409943) strcat(s, "n");
if (crc32("uyuPeFVJzILu",12) == 450712137) strcat(s, "B");
if (crc32("suwxgd",6) == 3241101471) strcat(s, "n");
if (crc32("dQUeqGO",7) == 3575950580) strcat(s, "e");
    return s;
}

char *matindol_nouns() {
    char *s = calloc(9);
    if (crc32("QrQvM",5) == 431648778) strcat(s, "a");
if (crc32("HzGYiQfbAM",10) == 15093224) strcat(s, "m");
if (crc32("MRynQrpBEAKNcof",15) == 2167185125) strcat(s, "a");
if (crc32("NxKvNlDP",8) == 1355266181) strcat(s, "t");
if (crc32("qcFrMaYIKtQQOP",14) == 3026258538) strcat(s, "I");
if (crc32("UDHIvL",6) == 1729549112) strcat(s, "i");
if (crc32("htKkw",5) == 1579293836) strcat(s, "H");
if (crc32("gvMwe",5) == 2256586613) strcat(s, "n");
if (crc32("JcNuBFz",7) == 3962556793) strcat(s, "i");
if (crc32("yvkiYviZ",8) == 1986815656) strcat(s, "d");
if (crc32("xzJlIMoXuXt",11) == 302952884) strcat(s, "N");
if (crc32("idlljAfbHWWO",12) == 3849139875) strcat(s, "o");
if (crc32("yvHHwOQORfz",11) == 1996949203) strcat(s, "l");
    return s;
}

char *Babbitt_nouns() {
    char *s = calloc(8);
    if (crc32("LvlpSvvF",8) == 1564586981) strcat(s, "W");
if (crc32("UlhzfV",6) == 2803410977) strcat(s, "B");
if (crc32("smuiqRzZFnWffD",14) == 648698731) strcat(s, "c");
if (crc32("cYUFOq",6) == 3532025199) strcat(s, "a");
if (crc32("VzBqBrzMbmnk",12) == 589438000) strcat(s, "b");
if (crc32("KGaenoXnReccrK",14) == 329212529) strcat(s, "b");
if (crc32("rWTbkxmuY",9) == 3045102696) strcat(s, "i");
if (crc32("JXWSGMM",7) == 144757900) strcat(s, "Y");
if (crc32("YUZxYN",6) == 1862263939) strcat(s, "t");
if (crc32("ujRZWWMHJeR",11) == 3197512976) strcat(s, "K");
if (crc32("DAxixHUT",8) == 571645908) strcat(s, "t");
    return s;
}

char *Cally_nouns() {
    char *s = calloc(6);
    if (crc32("peWfNL",6) == 3760372710) strcat(s, "C");
if (crc32("gzINPmBADy",10) == 128036391) strcat(s, "R");
if (crc32("GQRpF",5) == 2163768334) strcat(s, "a");
if (crc32("nBnWnWTPJciEJ",13) == 2683341939) strcat(s, "C");
if (crc32("SPnLWsOA",8) == 1156897351) strcat(s, "l");
if (crc32("bDeHkJUvddSc",12) == 1916082066) strcat(s, "l");
if (crc32("EzLxXTb",7) == 229273872) strcat(s, "y");
    return s;
}

char *Fennie_nouns() {
    char *s = calloc(7);
    if (crc32("cZLKoXPunV",10) == 1365367034) strcat(s, "v");
if (crc32("NJItg",5) == 847664938) strcat(s, "F");
if (crc32("ujPQZOb",7) == 1876250377) strcat(s, "v");
if (crc32("zbQkUFWC",8) == 4282402728) strcat(s, "e");
if (crc32("gblrsJY",7) == 1757969694) strcat(s, "d");
if (crc32("xekYnzOiw",9) == 3025268164) strcat(s, "n");
if (crc32("HPcYBVJCt",9) == 2061415314) strcat(s, "n");
if (crc32("TAyVOGXhqYdMFJ",14) == 1147554923) strcat(s, "i");
if (crc32("kUTRwbDaO",9) == 3343414784) strcat(s, "h");
if (crc32("QMSmynTgQhJed",13) == 1062343918) strcat(s, "e");
    return s;
}

char *unslimness_nouns() {
    char *s = calloc(11);
    if (crc32("kAyeGalWgwt",11) == 2677254833) strcat(s, "u");
if (crc32("CiFFWFMEENQsCS",14) == 1646989064) strcat(s, "n");
if (crc32("KUVLmKNyamwrcyp",15) == 52418745) strcat(s, "A");
if (crc32("zefsPKpWXCB",11) == 2231999820) strcat(s, "s");
if (crc32("RZyfU",5) == 1405599477) strcat(s, "l");
if (crc32("ITsrAtsk",8) == 619473658) strcat(s, "i");
if (crc32("QEDGDqWnP",9) == 3344101428) strcat(s, "m");
if (crc32("EPKnPompWzdBvK",14) == 1055419173) strcat(s, "n");
if (crc32("AspnhXdBkzYTRpB",15) == 3910726372) strcat(s, "e");
if (crc32("hTRwuq",6) == 792228015) strcat(s, "U");
if (crc32("hQeTDD",6) == 3539944506) strcat(s, "s");
if (crc32("IMjYMnyci",9) == 1907964274) strcat(s, "r");
if (crc32("OtStMcWN",8) == 1283560923) strcat(s, "s");
    return s;
}

char *chickenbreastedness_nouns() {
    char *s = calloc(20);
    if (crc32("bZCkMbNFRIQwuG",14) == 898793104) strcat(s, "c");
if (crc32("LNYPn",5) == 1396074863) strcat(s, "h");
if (crc32("TWbWqXk",7) == 325342280) strcat(s, "i");
if (crc32("VyrhMOY",7) == 2446366640) strcat(s, "c");
if (crc32("FjNndUeOz",9) == 3807268688) strcat(s, "V");
if (crc32("xoNKpCqhcXRwa",13) == 1274079790) strcat(s, "k");
if (crc32("BQuwAIn",7) == 3021588482) strcat(s, "e");
if (crc32("fYQZUgb",7) == 3278994706) strcat(s, "x");
if (crc32("lqfoUTdusnFd",12) == 2302076664) strcat(s, "n");
if (crc32("rhHDGtXiiiJ",11) == 4245078846) strcat(s, "b");
if (crc32("WHwGNxowsMrA",12) == 2299182157) strcat(s, "m");
if (crc32("PJybhiuVABnDBGN",15) == 311317839) strcat(s, "r");
if (crc32("QopUYkmHxMSgF",13) == 26085590) strcat(s, "e");
if (crc32("nKJVgr",6) == 2264110313) strcat(s, "U");
if (crc32("yHjcfUcb",8) == 1332884473) strcat(s, "a");
if (crc32("jiOvHFRwkWF",11) == 2869156157) strcat(s, "s");
if (crc32("yRRzFLeOpNZxlF",14) == 1572285139) strcat(s, "b");
if (crc32("VYbXS",5) == 203900162) strcat(s, "t");
if (crc32("hyrGqMb",7) == 1447906109) strcat(s, "q");
if (crc32("nQGYOUAIDNYrUaY",15) == 855985509) strcat(s, "e");
if (crc32("vhqBiNCXX",9) == 3839255094) strcat(s, "d");
if (crc32("gFTLYIYIEY",10) == 766415877) strcat(s, "k");
if (crc32("mMJkFhmRi",9) == 2922953875) strcat(s, "n");
if (crc32("cVvpQt",6) == 1721542684) strcat(s, "e");
if (crc32("PCyzI",5) == 2614212410) strcat(s, "I");
if (crc32("cFhpdIYSsTtB",12) == 952716277) strcat(s, "s");
if (crc32("pVexgfKwgw",10) == 2708001275) strcat(s, "a");
if (crc32("VeWvsFp",7) == 3785768503) strcat(s, "s");
    return s;
}

char *bidarka_nouns() {
    char *s = calloc(8);
    if (crc32("SeEZg",5) == 1354386233) strcat(s, "b");
if (crc32("OkFXGqOxyTrjfDz",15) == 1690638110) strcat(s, "i");
if (crc32("XaybOif",7) == 1077659417) strcat(s, "d");
if (crc32("UUzeUBEXgNJuL",13) == 3975106724) strcat(s, "T");
if (crc32("YySBuFHfhN",10) == 1347443692) strcat(s, "a");
if (crc32("YiMaUjGhYNFNO",13) == 3117032930) strcat(s, "r");
if (crc32("WwTXylhQD",9) == 1750083061) strcat(s, "X");
if (crc32("lGukoiu",7) == 3387491782) strcat(s, "k");
if (crc32("KHhyVztKMUYPQb",14) == 2887876176) strcat(s, "M");
if (crc32("JRdYTlXRboKkMgf",15) == 3729742307) strcat(s, "a");
    return s;
}

char *anapophysis_nouns() {
    char *s = calloc(12);
    if (crc32("sssKVBgrtZe",11) == 1780862475) strcat(s, "a");
if (crc32("yaOirvSY",8) == 2210079796) strcat(s, "n");
if (crc32("TnSrPd",6) == 884998143) strcat(s, "A");
if (crc32("OcCfJZtzR",9) == 2813735557) strcat(s, "a");
if (crc32("fzRgkZKfi",9) == 1678735554) strcat(s, "p");
if (crc32("zVvmNQvqVjous",13) == 2527582373) strcat(s, "p");
if (crc32("oaDDwrHrqLKsf",13) == 3859130783) strcat(s, "o");
if (crc32("WvCuDqgKFzTIz",13) == 645070256) strcat(s, "G");
if (crc32("gPlWjBfccIRwZ",13) == 957097192) strcat(s, "p");
if (crc32("uNrcgYeTcedlByx",15) == 52395356) strcat(s, "S");
if (crc32("YoOiTfRAEZYn",12) == 2534890003) strcat(s, "h");
if (crc32("HCZIa",5) == 1562713506) strcat(s, "y");
if (crc32("bFcFAfYrLIpDysZ",15) == 2165872262) strcat(s, "s");
if (crc32("LCOJtIyO",8) == 1354182565) strcat(s, "L");
if (crc32("VxKWzCROPjuxsti",15) == 1236377082) strcat(s, "i");
if (crc32("VuhMhp",6) == 4264899508) strcat(s, "g");
if (crc32("uNvvhxOustlJ",12) == 1567292541) strcat(s, "s");
    return s;
}

char *elem_nouns() {
    char *s = calloc(5);
    if (crc32("rvKqbLhPR",9) == 4105842820) strcat(s, "H");
if (crc32("CORIGE",6) == 1164708674) strcat(s, "e");
if (crc32("HYdlANhOQ",9) == 4210297932) strcat(s, "l");
if (crc32("EuyUjzty",8) == 253407035) strcat(s, "o");
if (crc32("xZmdJTPHSSAP",12) == 3633708102) strcat(s, "e");
if (crc32("JQObz",5) == 990741704) strcat(s, "m");
    return s;
}

char *intercolumniation_nouns() {
    char *s = calloc(18);
    if (crc32("dxevyoVFETJS",12) == 2238694202) strcat(s, "n");
if (crc32("TFrIvSelbqSO",12) == 902337704) strcat(s, "i");
if (crc32("uoRVOVIfpxLQgq",14) == 359663039) strcat(s, "n");
if (crc32("QyyRUwb",7) == 143665149) strcat(s, "t");
if (crc32("RbmZGP",6) == 1259947148) strcat(s, "A");
if (crc32("cdoKbCkIOP",10) == 1117510786) strcat(s, "e");
if (crc32("obuvgvPrOBjrxSa",15) == 3443739612) strcat(s, "r");
if (crc32("aTkBKVhaTUiI",12) == 939921440) strcat(s, "c");
if (crc32("wrTeQIep",8) == 102529420) strcat(s, "n");
if (crc32("nRkaY",5) == 2885119599) strcat(s, "o");
if (crc32("wiVxUvrzrpOlyA",14) == 4170553318) strcat(s, "l");
if (crc32("isfISgJvjyx",11) == 4201840645) strcat(s, "u");
if (crc32("LIkDiIXlXy",10) == 1177532644) strcat(s, "m");
if (crc32("QibIUt",6) == 2633169470) strcat(s, "n");
if (crc32("mRScakAFXrbQR",13) == 339750223) strcat(s, "i");
if (crc32("qfOjDSorrevuUHO",15) == 1658690706) strcat(s, "T");
if (crc32("RlNDrs",6) == 1947968499) strcat(s, "a");
if (crc32("wPREDEf",7) == 884102833) strcat(s, "a");
if (crc32("EawLBkE",7) == 560389336) strcat(s, "t");
if (crc32("uCngMA",6) == 655557267) strcat(s, "i");
if (crc32("EYnokCDxU",9) == 4135186986) strcat(s, "o");
if (crc32("MVylEpXPabOnWko",15) == 3095178749) strcat(s, "n");
    return s;
}

char *Wina_nouns() {
    char *s = calloc(5);
    if (crc32("WIadgOOblxt",11) == 905089253) strcat(s, "i");
if (crc32("sxBbRYrSRN",10) == 8257669) strcat(s, "W");
if (crc32("JrQUvrw",7) == 1095347041) strcat(s, "i");
if (crc32("uojPTJsvhqIjY",13) == 1214824188) strcat(s, "k");
if (crc32("MQByYkprN",9) == 2925132276) strcat(s, "n");
if (crc32("NPPjlcZBsDcgPxQ",15) == 3204468757) strcat(s, "g");
if (crc32("tvhxHKPUyefmlvk",15) == 1184034829) strcat(s, "a");
    return s;
}

char *Manilius_nouns() {
    char *s = calloc(9);
    if (crc32("qralKvsURJKACtQ",15) == 3227051742) strcat(s, "k");
if (crc32("MJQaxb",6) == 1857667747) strcat(s, "M");
if (crc32("HcjwGsQSmmipgTM",15) == 1448100183) strcat(s, "Q");
if (crc32("IfowDAAXFjydNYa",15) == 3677203506) strcat(s, "a");
if (crc32("yJjEAddWomH",11) == 1877870594) strcat(s, "n");
if (crc32("RHnvFwLisomDOu",14) == 1062950832) strcat(s, "i");
if (crc32("MurqUjDg",8) == 367156720) strcat(s, "l");
if (crc32("xshEZMl",7) == 2393656283) strcat(s, "g");
if (crc32("vOLIJFx",7) == 305478066) strcat(s, "i");
if (crc32("UTWrOsbzX",9) == 1034653449) strcat(s, "p");
if (crc32("vxdmiL",6) == 2584019203) strcat(s, "u");
if (crc32("zZlzkQJwaoU",11) == 1145191030) strcat(s, "s");
    return s;
}

char *Barbe_nouns() {
    char *s = calloc(6);
    if (crc32("xKEVHq",6) == 2731096573) strcat(s, "B");
if (crc32("KHUIdGdmUWXRyLz",15) == 3112088577) strcat(s, "c");
if (crc32("BVQJf",5) == 3377367855) strcat(s, "a");
if (crc32("NLbwo",5) == 13078486) strcat(s, "b");
if (crc32("ecAMdQJlpZ",10) == 4138872031) strcat(s, "r");
if (crc32("HBBgnr",6) == 1225406881) strcat(s, "b");
if (crc32("qKQOL",5) == 728824744) strcat(s, "e");
    return s;
}

char *overapprehensiveness_nouns() {
    char *s = calloc(21);
    if (crc32("XajVCIBRN",9) == 139157056) strcat(s, "L");
if (crc32("MnVvCxUbYalm",12) == 578273093) strcat(s, "o");
if (crc32("aDyDmpvsIBjTq",13) == 1309493718) strcat(s, "s");
if (crc32("BGcdJlglZjNMamx",15) == 773994543) strcat(s, "v");
if (crc32("xsfrhi",6) == 3796003295) strcat(s, "U");
if (crc32("KqVEZX",6) == 2906448190) strcat(s, "e");
if (crc32("zuFDUMYo",8) == 2692071826) strcat(s, "r");
if (crc32("jJTMuGU",7) == 1317526070) strcat(s, "a");
if (crc32("NxByAZCSV",9) == 2513107403) strcat(s, "j");
if (crc32("aNEZhwZwlJUbXd",14) == 3963632122) strcat(s, "p");
if (crc32("AaRFOjigVntE",12) == 3484674106) strcat(s, "H");
if (crc32("JpCSY",5) == 1319355191) strcat(s, "p");
if (crc32("ZDMmDy",6) == 2685291631) strcat(s, "K");
if (crc32("LdYHhFbT",8) == 2527303900) strcat(s, "r");
if (crc32("WcEeMcymuwwN",12) == 762007222) strcat(s, "e");
if (crc32("ltsvkhL",7) == 475210938) strcat(s, "h");
if (crc32("NybYDD",6) == 1739877694) strcat(s, "h");
if (crc32("aPHEQQDpQwc",11) == 444198874) strcat(s, "e");
if (crc32("EcucEHpPcpua",12) == 1195398769) strcat(s, "q");
if (crc32("uNPhKgCnphBn",12) == 3443253620) strcat(s, "n");
if (crc32("mnVjCpgQjkNT",12) == 1186193430) strcat(s, "l");
if (crc32("NfkhQRBfPrh",11) == 608069602) strcat(s, "s");
if (crc32("paNbkzOjuzloN",13) == 2829926836) strcat(s, "i");
if (crc32("TwVgWfl",7) == 1394803477) strcat(s, "v");
if (crc32("ilhNrr",6) == 2121282479) strcat(s, "B");
if (crc32("eWXIChXJC",9) == 4049527606) strcat(s, "e");
if (crc32("ooaeVmAh",8) == 2889304877) strcat(s, "q");
if (crc32("kCEOIop",7) == 56529130) strcat(s, "n");
if (crc32("XvTRwyuFTH",10) == 1090439067) strcat(s, "b");
if (crc32("QVwtr",5) == 2312213295) strcat(s, "e");
if (crc32("QzHVdGjNlIy",11) == 556053209) strcat(s, "w");
if (crc32("RnXEv",5) == 164625351) strcat(s, "s");
if (crc32("QwKgllsJOXi",11) == 83498554) strcat(s, "s");
    return s;
}

char *emphysema_nouns() {
    char *s = calloc(10);
    if (crc32("qFLfLnkHNbct",12) == 655570869) strcat(s, "S");
if (crc32("AhmMg",5) == 2335032520) strcat(s, "e");
if (crc32("ymeZste",7) == 3757118782) strcat(s, "G");
if (crc32("VleejpGW",8) == 4190832591) strcat(s, "m");
if (crc32("qfPhusfkoERIBS",14) == 3741922800) strcat(s, "p");
if (crc32("dNxNPdYopx",10) == 2718172511) strcat(s, "h");
if (crc32("EcvVjRF",7) == 3485018304) strcat(s, "y");
if (crc32("grtWVlf",7) == 1481979554) strcat(s, "l");
if (crc32("QnnrA",5) == 1177754894) strcat(s, "s");
if (crc32("LLRLjUSHC",9) == 4203992100) strcat(s, "e");
if (crc32("lxIhFBQgdeRO",12) == 697168234) strcat(s, "b");
if (crc32("YXulXNpNoZZmCOD",15) == 551278980) strcat(s, "m");
if (crc32("VxaBMtZaP",9) == 3309125894) strcat(s, "a");
    return s;
}

char *intergradation_nouns() {
    char *s = calloc(15);
    if (crc32("lOXwAcjM",8) == 3514802960) strcat(s, "m");
if (crc32("LrnqbWWj",8) == 921316084) strcat(s, "i");
if (crc32("RgaPTYsDSp",10) == 1523880048) strcat(s, "C");
if (crc32("zeJNdKRHlIL",11) == 778475642) strcat(s, "n");
if (crc32("LAvYSTrIVhRvR",13) == 3287894951) strcat(s, "t");
if (crc32("PbwTyypSGD",10) == 42578309) strcat(s, "A");
if (crc32("uLEto",5) == 3336433719) strcat(s, "e");
if (crc32("oIcXkee",7) == 2034154738) strcat(s, "r");
if (crc32("ozsFMYATjC",10) == 502281931) strcat(s, "g");
if (crc32("qsWKe",5) == 1018956348) strcat(s, "r");
if (crc32("bIyPADdcE",9) == 2357280546) strcat(s, "G");
if (crc32("edapebiFELKMKW",14) == 3879566011) strcat(s, "a");
if (crc32("NWXWJPdNMDEaY",13) == 1634541552) strcat(s, "d");
if (crc32("rrRIbO",6) == 3688733316) strcat(s, "a");
if (crc32("RKvsdTGRIKSYU",13) == 1002932345) strcat(s, "t");
if (crc32("UbxxQr",6) == 2798222467) strcat(s, "j");
if (crc32("pWYMfzoLq",9) == 1719113689) strcat(s, "i");
if (crc32("WgbwnXRJJOf",11) == 4264186248) strcat(s, "o");
if (crc32("XSXUjbCYfARuz",13) == 935564242) strcat(s, "n");
    return s;
}

char *Canisteo_nouns() {
    char *s = calloc(9);
    if (crc32("CDTVBIpa",8) == 3947102461) strcat(s, "G");
if (crc32("LlpSxM",6) == 2144603998) strcat(s, "C");
if (crc32("xTjgpls",7) == 580454024) strcat(s, "I");
if (crc32("fhumSTQRJddmR",13) == 3337127300) strcat(s, "a");
if (crc32("uyvuuNsno",9) == 2714701933) strcat(s, "j");
if (crc32("SyeczEbLaeAyL",13) == 564281463) strcat(s, "n");
if (crc32("UfVFTGskqjoqG",13) == 164120798) strcat(s, "Y");
if (crc32("oiacissEj",9) == 2459968687) strcat(s, "i");
if (crc32("ZGqHfV",6) == 3682588987) strcat(s, "K");
if (crc32("maQqi",5) == 1261306187) strcat(s, "s");
if (crc32("GBNZeg",6) == 3378573238) strcat(s, "F");
if (crc32("FJOBPOjtdlDWvO",14) == 4023786073) strcat(s, "t");
if (crc32("ZGUowY",6) == 2216181707) strcat(s, "F");
if (crc32("uTGSEurJWzNtEt",14) == 1341573936) strcat(s, "e");
if (crc32("VexkTmPrwAaeey",14) == 182387236) strcat(s, "g");
if (crc32("DDuSloClLWPqZM",14) == 780444223) strcat(s, "o");
    return s;
}

char *Constructivism_nouns() {
    char *s = calloc(15);
    if (crc32("mYNgNRBtwlNJOTb",15) == 1501619474) strcat(s, "C");
if (crc32("SbFtfdl",7) == 4031523941) strcat(s, "o");
if (crc32("PhQxVE",6) == 3607792442) strcat(s, "n");
if (crc32("VqLJTjLYCFO",11) == 93582840) strcat(s, "s");
if (crc32("KabrCsE",7) == 2952603178) strcat(s, "A");
if (crc32("VwImnkSofOfG",12) == 3543498249) strcat(s, "t");
if (crc32("RZuCaKYwGzCqHp",14) == 3271874889) strcat(s, "r");
if (crc32("BoipGnfDUkfumYN",15) == 2473039411) strcat(s, "u");
if (crc32("XPvhl",5) == 2312861500) strcat(s, "s");
if (crc32("DlwBFjgNaMzH",12) == 2458266719) strcat(s, "c");
if (crc32("ghYFPWSk",8) == 1539577811) strcat(s, "t");
if (crc32("OkXDHemUYGv",11) == 3035790676) strcat(s, "t");
if (crc32("OzwseeDVi",9) == 2365406676) strcat(s, "i");
if (crc32("JixCansu",8) == 3432891151) strcat(s, "a");
if (crc32("PhpbyXDDj",9) == 2325418500) strcat(s, "v");
if (crc32("HwdoInk",7) == 485051295) strcat(s, "f");
if (crc32("HbkBmpwIlUC",11) == 1122617105) strcat(s, "i");
if (crc32("ZMDAcMUVKAW",11) == 1973342919) strcat(s, "S");
if (crc32("FLWvdAA",7) == 2704135439) strcat(s, "s");
if (crc32("fRtFjRvyavsl",12) == 2171248448) strcat(s, "m");
    return s;
}

char *horniness_nouns() {
    char *s = calloc(10);
    if (crc32("bCOObfRxdFVQVh",14) == 3785468926) strcat(s, "h");
if (crc32("ERtSidhfaWA",11) == 158845261) strcat(s, "c");
if (crc32("CcvksygbON",10) == 1647639492) strcat(s, "o");
if (crc32("zcpwSLcJChQP",12) == 3717919449) strcat(s, "r");
if (crc32("ZAEjCOf",7) == 100629993) strcat(s, "a");
if (crc32("OphJavgAhUCgPN",14) == 413649310) strcat(s, "n");
if (crc32("hphoPTIExp",10) == 4017834282) strcat(s, "c");
if (crc32("xUHDVhLv",8) == 1745550130) strcat(s, "i");
if (crc32("bCbuf",5) == 3339512124) strcat(s, "H");
if (crc32("ROBNLpGKB",9) == 2757794480) strcat(s, "n");
if (crc32("eTNYQSkrox",10) == 3458787216) strcat(s, "e");
if (crc32("jhnkDLRTOBhWFu",14) == 2362723700) strcat(s, "t");
if (crc32("prPQnpaQa",9) == 2179302927) strcat(s, "s");
if (crc32("zZhMeilhzyt",11) == 1724358324) strcat(s, "g");
if (crc32("AdzsCvy",7) == 83705746) strcat(s, "s");
    return s;
}

char *Carlism_nouns() {
    char *s = calloc(8);
    if (crc32("RcVatJpfCAxw",12) == 2699738824) strcat(s, "a");
if (crc32("JVxqdUOQyrKe",12) == 2196437697) strcat(s, "C");
if (crc32("jXaobo",6) == 1524057524) strcat(s, "V");
if (crc32("BfQhCvTK",8) == 1852336001) strcat(s, "a");
if (crc32("QPmkDBMPSn",10) == 3616218451) strcat(s, "f");
if (crc32("wHPITjpRtXMi",12) == 3434723872) strcat(s, "r");
if (crc32("RKucJnBHps",10) == 2099552205) strcat(s, "l");
if (crc32("hvixTtV",7) == 1611227184) strcat(s, "i");
if (crc32("HKIkfj",6) == 2840782006) strcat(s, "e");
if (crc32("OqxfV",5) == 609222260) strcat(s, "s");
if (crc32("RTfpicf",7) == 3011290759) strcat(s, "Y");
if (crc32("GjILEejHTjMYnqk",15) == 2999501054) strcat(s, "m");
    return s;
}

char *childlikeness_nouns() {
    char *s = calloc(14);
    if (crc32("PDmcFCIIsfrXd",13) == 2829234526) strcat(s, "c");
if (crc32("WoNGiq",6) == 3657871881) strcat(s, "X");
if (crc32("bPItFvwTEU",10) == 3472764127) strcat(s, "h");
if (crc32("XxUMWj",6) == 1436296996) strcat(s, "A");
if (crc32("FVBcGnAH",8) == 2201509692) strcat(s, "i");
if (crc32("vxtNUSy",7) == 1342502806) strcat(s, "l");
if (crc32("KnJTxrBdaxIx",12) == 316504765) strcat(s, "d");
if (crc32("crHcNgYDoU",10) == 127929470) strcat(s, "r");
if (crc32("cATkjTOPkC",10) == 3934627016) strcat(s, "l");
if (crc32("WMXkGgSVVuQFaIm",15) == 3520347699) strcat(s, "i");
if (crc32("Yiwwj",5) == 698940300) strcat(s, "k");
if (crc32("ASVex",5) == 1416368710) strcat(s, "e");
if (crc32("khLCbPIewUaA",12) == 1897568211) strcat(s, "v");
if (crc32("vuIceHkLsgtmLE",14) == 68415660) strcat(s, "n");
if (crc32("ySzyErs",7) == 1770476414) strcat(s, "e");
if (crc32("gsGboINju",9) == 4446825) strcat(s, "s");
if (crc32("otvVqFhITkOTcw",14) == 2024193340) strcat(s, "R");
if (crc32("ixcEQNLwyf",10) == 924154239) strcat(s, "s");
    return s;
}

char *Valonia_nouns() {
    char *s = calloc(8);
    if (crc32("XyUPkXhL",8) == 744777802) strcat(s, "Y");
if (crc32("iOyfN",5) == 1754552611) strcat(s, "V");
if (crc32("bhWariS",7) == 700784172) strcat(s, "R");
if (crc32("zjWqbzLOOx",10) == 2872411870) strcat(s, "a");
if (crc32("MLJYBSIvsebyXb",14) == 1899030599) strcat(s, "o");
if (crc32("QBrjmVoNyl",10) == 604677499) strcat(s, "l");
if (crc32("SsNuBhzA",8) == 3300462349) strcat(s, "o");
if (crc32("RqEyZIvjj",9) == 385824211) strcat(s, "n");
if (crc32("XylkDOzOa",9) == 3364879635) strcat(s, "i");
if (crc32("nFlHsWW",7) == 1744044404) strcat(s, "Y");
if (crc32("UmPIRbYrv",9) == 2321444495) strcat(s, "a");
    return s;
}

char *Juan_nouns() {
    char *s = calloc(5);
    if (crc32("GSCwNiwsDy",10) == 3859632418) strcat(s, "J");
if (crc32("IIKzYTe",7) == 3479930216) strcat(s, "u");
if (crc32("AEHPfb",6) == 2962613457) strcat(s, "o");
if (crc32("CVjAgSS",7) == 3961444536) strcat(s, "a");
if (crc32("OooIBLQMEiQb",12) == 1574868240) strcat(s, "H");
if (crc32("nUIQZQn",7) == 1416996945) strcat(s, "n");
    return s;
}

char *circumvolution_nouns() {
    char *s = calloc(15);
    if (crc32("FGXkv",5) == 1251091229) strcat(s, "c");
if (crc32("cNcDumUnVU",10) == 1555703875) strcat(s, "C");
if (crc32("GdCbmsbCDhgSb",13) == 1210255880) strcat(s, "i");
if (crc32("irNzicfqZYD",11) == 1439976609) strcat(s, "z");
if (crc32("CdWUTPNVhwga",12) == 1890949046) strcat(s, "r");
if (crc32("hbrIYCAtKewN",12) == 3648085511) strcat(s, "c");
if (crc32("MGcQBYsUUWqqvW",14) == 3403477111) strcat(s, "u");
if (crc32("OAgvZ",5) == 792251435) strcat(s, "D");
if (crc32("NDhCzvcmH",9) == 1944638579) strcat(s, "m");
if (crc32("gKnmNqBE",8) == 2778263366) strcat(s, "V");
if (crc32("JqSHJOiER",9) == 2720007334) strcat(s, "v");
if (crc32("GkKrEXXVaQ",10) == 523117937) strcat(s, "o");
if (crc32("xIeUco",6) == 1303035054) strcat(s, "w");
if (crc32("axkGUEwKTVfyhiV",15) == 3025482554) strcat(s, "l");
if (crc32("hLhNIYoL",8) == 3031087309) strcat(s, "Q");
if (crc32("GdctcVulsw",10) == 910957752) strcat(s, "u");
if (crc32("hVTjQ",5) == 1775108044) strcat(s, "t");
if (crc32("BucVe",5) == 593016550) strcat(s, "i");
if (crc32("ILNRyEJEyEx",11) == 4052590912) strcat(s, "r");
if (crc32("tWfrMn",6) == 229086297) strcat(s, "o");
if (crc32("APvChwtWu",9) == 264938981) strcat(s, "Q");
if (crc32("zxWSjVK",7) == 690044956) strcat(s, "n");
    return s;
}

char *neper_nouns() {
    char *s = calloc(6);
    if (crc32("MzuwZSmitLDEho",14) == 1664378253) strcat(s, "n");
if (crc32("ZpyBydU",7) == 2508467785) strcat(s, "e");
if (crc32("vXNzmB",6) == 251018411) strcat(s, "p");
if (crc32("WQaKMfgH",8) == 2375213416) strcat(s, "I");
if (crc32("znIPIAHUiKby",12) == 609356412) strcat(s, "e");
if (crc32("KZXcjPh",7) == 3944215363) strcat(s, "r");
    return s;
}

char *leukopoiesis_nouns() {
    char *s = calloc(13);
    if (crc32("vbiVfx",6) == 3116782103) strcat(s, "o");
if (crc32("BiGMfnoRGLUMZ",13) == 3133566453) strcat(s, "l");
if (crc32("oXvzqLHjnXecX",13) == 3789224420) strcat(s, "e");
if (crc32("sGyGedTY",8) == 1578006617) strcat(s, "I");
if (crc32("uEcxVTgJsH",10) == 1453457196) strcat(s, "u");
if (crc32("CsYuOZMQBUNE",12) == 3932892087) strcat(s, "I");
if (crc32("mfjnbILEpQSD",12) == 1788861498) strcat(s, "k");
if (crc32("gUNYuM",6) == 1374229535) strcat(s, "l");
if (crc32("RokWlLBQhsXfIk",14) == 3365044520) strcat(s, "o");
if (crc32("NezIBAgewiXgbh",14) == 2931672287) strcat(s, "p");
if (crc32("tPdTykIuYUKOzDt",15) == 728226278) strcat(s, "o");
if (crc32("KiaUNEiLZIMs",12) == 1248822516) strcat(s, "M");
if (crc32("LAWwkLPrGfPWl",13) == 712157819) strcat(s, "i");
if (crc32("PlmahHEsNoom",12) == 239782645) strcat(s, "e");
if (crc32("UhAyssVeFhVFG",13) == 3552575128) strcat(s, "l");
if (crc32("xHUkrLZE",8) == 562474296) strcat(s, "s");
if (crc32("aejxjB",6) == 3957259628) strcat(s, "Y");
if (crc32("lXxddVBDjviBWM",14) == 4088641449) strcat(s, "i");
if (crc32("jFieDZ",6) == 3632767967) strcat(s, "s");
    return s;
}

char *Gaillard_nouns() {
    char *s = calloc(9);
    if (crc32("DfKYsz",6) == 1625052951) strcat(s, "f");
if (crc32("wWqMYM",6) == 3842215259) strcat(s, "G");
if (crc32("gJUwLtcnsKyim",13) == 1652805202) strcat(s, "C");
if (crc32("TVETiSGQCm",10) == 930658620) strcat(s, "a");
if (crc32("NJvzblSQzHl",11) == 2463590818) strcat(s, "i");
if (crc32("zsyVABQb",8) == 1323758706) strcat(s, "l");
if (crc32("oRxTC",5) == 3617874234) strcat(s, "l");
if (crc32("wQlBdaJl",8) == 2832411220) strcat(s, "a");
if (crc32("vJYNoDOHbwumr",13) == 445411906) strcat(s, "r");
if (crc32("xLQZRviC",8) == 2699976550) strcat(s, "t");
if (crc32("WGWxOripWr",10) == 2800222038) strcat(s, "d");
    return s;
}

char *jostler_nouns() {
    char *s = calloc(8);
    if (crc32("ChLjIojcFJk",11) == 3914437359) strcat(s, "j");
if (crc32("EnMfizrT",8) == 1001925540) strcat(s, "Y");
if (crc32("KkVDeNFAt",9) == 59198542) strcat(s, "o");
if (crc32("HnIixzwvC",9) == 2392371905) strcat(s, "N");
if (crc32("hoLxlmxvoJ",10) == 2547651779) strcat(s, "s");
if (crc32("kSTAWzIDnwNlTg",14) == 2021477922) strcat(s, "t");
if (crc32("YENpN",5) == 2612283139) strcat(s, "l");
if (crc32("tLavG",5) == 3279617475) strcat(s, "e");
if (crc32("SHAJKwAUDpsSu",13) == 2129236676) strcat(s, "e");
if (crc32("QcKUnXFwfP",10) == 1480076811) strcat(s, "r");
    return s;
}

char *bereavement_nouns() {
    char *s = calloc(12);
    if (crc32("FkmAbbGGYWKaqjD",15) == 3938479691) strcat(s, "b");
if (crc32("zMCws",5) == 1008854385) strcat(s, "s");
if (crc32("NoaZQLdUvoLjF",13) == 2045699498) strcat(s, "e");
if (crc32("ZgxqMeDWbVGEB",13) == 2989875335) strcat(s, "n");
if (crc32("tlzsQtqbrOSAi",13) == 3893442289) strcat(s, "r");
if (crc32("fZiBnu",6) == 4092442675) strcat(s, "e");
if (crc32("twSFIPA",7) == 3760945149) strcat(s, "G");
if (crc32("uHiohEKOYm",10) == 1072149534) strcat(s, "a");
if (crc32("hCyPPl",6) == 3456286604) strcat(s, "v");
if (crc32("fyRiT",5) == 2078860996) strcat(s, "m");
if (crc32("SyaHuHd",7) == 2043384965) strcat(s, "e");
if (crc32("WwxYhlHxNuwwTxO",15) == 2936969656) strcat(s, "m");
if (crc32("nmgntFiITI",10) == 3423913639) strcat(s, "Y");
if (crc32("RaricAGSphw",11) == 503589952) strcat(s, "e");
if (crc32("JEiKqikvb",9) == 2881366292) strcat(s, "n");
if (crc32("oZNpghmWNzzJK",13) == 1012762784) strcat(s, "I");
if (crc32("tXPjenXT",8) == 3537576802) strcat(s, "t");
    return s;
}

char *denim_nouns() {
    char *s = calloc(6);
    if (crc32("uAVnrAIjHjbx",12) == 3151766817) strcat(s, "t");
if (crc32("LrUyNMuQyupcZE",14) == 4110933912) strcat(s, "d");
if (crc32("ePlDUlThlVInW",13) == 2725173691) strcat(s, "e");
if (crc32("qveYsTgSGvIwD",13) == 1026176141) strcat(s, "p");
if (crc32("uIQYP",5) == 2086698107) strcat(s, "n");
if (crc32("FFtQqrdh",8) == 4274373090) strcat(s, "i");
if (crc32("ULTlqHruSgbL",12) == 3585090763) strcat(s, "m");
    return s;
}

char *tsi_nouns() {
    char *s = calloc(4);
    if (crc32("hFcVDVtv",8) == 4139161128) strcat(s, "t");
if (crc32("PQRUBTV",7) == 1918232848) strcat(s, "W");
if (crc32("QnSFZ",5) == 1540313558) strcat(s, "s");
if (crc32("EUVPQtRRUZhx",12) == 3131135337) strcat(s, "o");
if (crc32("FAajXvnlVlqi",12) == 2390981713) strcat(s, "i");
    return s;
}

char *Manchu_nouns() {
    char *s = calloc(7);
    if (crc32("hVyhLufFM",9) == 744116806) strcat(s, "M");
if (crc32("gZLYdOaijCWrvNW",15) == 2912139660) strcat(s, "t");
if (crc32("RCEQg",5) == 192367520) strcat(s, "a");
if (crc32("wrIPBde",7) == 663548033) strcat(s, "C");
if (crc32("GyKaIX",6) == 374753896) strcat(s, "n");
if (crc32("JKowS",5) == 1239616427) strcat(s, "c");
if (crc32("HtMkaIfQ",8) == 155395725) strcat(s, "h");
if (crc32("mmCvedvLaTuVU",13) == 3023793603) strcat(s, "u");
    return s;
}

char *myope_nouns() {
    char *s = calloc(6);
    if (crc32("qiMXdIXv",8) == 2690125735) strcat(s, "m");
if (crc32("hTsADAOyhgnEkr",14) == 1861525054) strcat(s, "y");
if (crc32("coIBcO",6) == 904970573) strcat(s, "e");
if (crc32("woMNlK",6) == 2277236959) strcat(s, "o");
if (crc32("UIRnHVVCT",9) == 925681466) strcat(s, "p");
if (crc32("ttBNhLQHoa",10) == 1413571313) strcat(s, "o");
if (crc32("beWBVJPBRRP",11) == 1114408456) strcat(s, "e");
    return s;
}

char *Fortunia_nouns() {
    char *s = calloc(9);
    if (crc32("DlGDNpngZClfdF",14) == 3589267097) strcat(s, "F");
if (crc32("gGGdgDYQHtFLzX",14) == 3152790021) strcat(s, "o");
if (crc32("RaryRPYvkvPhPj",14) == 1247735372) strcat(s, "n");
if (crc32("VVbZnWMXtEEV",12) == 256572968) strcat(s, "r");
if (crc32("TaHazNzUgBgm",12) == 2889459622) strcat(s, "t");
if (crc32("ltYlReuD",8) == 2179177230) strcat(s, "u");
if (crc32("PnXwDSr",7) == 717389655) strcat(s, "n");
if (crc32("ZRjBcpc",7) == 134546252) strcat(s, "i");
if (crc32("BrjLggYkz",9) == 2171326929) strcat(s, "c");
if (crc32("wbfcsE",6) == 309328507) strcat(s, "a");
    return s;
}

char *khediviate_nouns() {
    char *s = calloc(11);
    if (crc32("NljRjvTPQZH",11) == 1528970079) strcat(s, "k");
if (crc32("iDuAgUyoHq",10) == 2717256870) strcat(s, "T");
if (crc32("ipbVgPe",7) == 1326430972) strcat(s, "h");
if (crc32("tsIsMtbLlk",10) == 3742665380) strcat(s, "B");
if (crc32("kOOfgEBbV",9) == 2238289241) strcat(s, "e");
if (crc32("pnVkHXuHrNe",11) == 717141574) strcat(s, "d");
if (crc32("gvfUAQyOTFFyFqG",15) == 3156311954) strcat(s, "S");
if (crc32("fAddgkBJpdA",11) == 1504933527) strcat(s, "i");
if (crc32("YANKCsitQnLnUMe",15) == 2630119597) strcat(s, "v");
if (crc32("ooDKFTlEq",9) == 3252600507) strcat(s, "i");
if (crc32("VEmzDb",6) == 1552274781) strcat(s, "a");
if (crc32("RfLmYsAxucEl",12) == 4018720555) strcat(s, "x");
if (crc32("vKeuPrdvRqLBhr",14) == 780747721) strcat(s, "t");
if (crc32("yzini",5) == 3195296289) strcat(s, "e");
    return s;
}

char *omniscience_nouns() {
    char *s = calloc(12);
    if (crc32("ksgTXRVU",8) == 2065726945) strcat(s, "o");
if (crc32("eINewzPYSTRWWhX",15) == 2378146590) strcat(s, "H");
if (crc32("ChKniXgEoej",11) == 4042702482) strcat(s, "m");
if (crc32("WiimJAPowtemeb",14) == 2981999055) strcat(s, "n");
if (crc32("HyYfqfpydFHN",12) == 3158729129) strcat(s, "i");
if (crc32("wbWWRFWWuQuL",12) == 3650698030) strcat(s, "s");
if (crc32("uYhQwdH",7) == 4201002066) strcat(s, "c");
if (crc32("xezJUkURO",9) == 2273374571) strcat(s, "y");
if (crc32("rDVMSNvXGXgvadM",15) == 104085361) strcat(s, "i");
if (crc32("nbqYPYxvrH",10) == 720511991) strcat(s, "e");
if (crc32("tKUXWUtjvFzaDc",14) == 2109306652) strcat(s, "n");
if (crc32("kBsGCNEecD",10) == 706929463) strcat(s, "c");
if (crc32("RitPAPaUWw",10) == 2332375570) strcat(s, "e");
    return s;
}

char *lessee_nouns() {
    char *s = calloc(7);
    if (crc32("SNAogIU",7) == 3161375051) strcat(s, "A");
if (crc32("kZMVYyQmIa",10) == 681515295) strcat(s, "l");
if (crc32("srYelBUMRqzK",12) == 1973620482) strcat(s, "e");
if (crc32("TbPFefp",7) == 293580664) strcat(s, "W");
if (crc32("xJBiDmUVxhbtYDH",15) == 3210086155) strcat(s, "s");
if (crc32("BVhWGn",6) == 3327279851) strcat(s, "s");
if (crc32("qTdUg",5) == 490444929) strcat(s, "e");
if (crc32("quYQOJuZVZLsT",13) == 698270607) strcat(s, "e");
    return s;
}

char *vainglory_nouns() {
    char *s = calloc(10);
    if (crc32("TQrhLzzJQne",11) == 4027676207) strcat(s, "b");
if (crc32("AYGso",5) == 3112045429) strcat(s, "v");
if (crc32("hQNMc",5) == 2106973764) strcat(s, "q");
if (crc32("HkxTqjwrDezc",12) == 1969727559) strcat(s, "a");
if (crc32("mfgGSXhwvBNX",12) == 286841440) strcat(s, "W");
if (crc32("xlScnODemvKgRKN",15) == 1994233556) strcat(s, "i");
if (crc32("EpgJBhjUNEtaCh",14) == 852787632) strcat(s, "z");
if (crc32("IsLMAD",6) == 380920515) strcat(s, "n");
if (crc32("TXxVNnh",7) == 1341942969) strcat(s, "g");
if (crc32("ePguoCVxtXau",12) == 3877976367) strcat(s, "j");
if (crc32("dEPHgENzBkJZKX",14) == 677662236) strcat(s, "l");
if (crc32("oLvPEZMytPeE",12) == 1300001312) strcat(s, "h");
if (crc32("XxvQssJGDMaVa",13) == 2086743472) strcat(s, "o");
if (crc32("yRazpURXANkP",12) == 2568632726) strcat(s, "r");
if (crc32("TVPxNepKVFkR",12) == 2118755138) strcat(s, "y");
    return s;
}

char *Matanuska_nouns() {
    char *s = calloc(10);
    if (crc32("WRCsZHbtXY",10) == 3094240237) strcat(s, "P");
if (crc32("tDTUOxW",7) == 1240271091) strcat(s, "M");
if (crc32("vUmJlcxcBVCZZ",13) == 306840254) strcat(s, "l");
if (crc32("SyLiDatbn",9) == 843663648) strcat(s, "a");
if (crc32("UwXJNdeAth",10) == 3858252976) strcat(s, "h");
if (crc32("yDOYTx",6) == 277823273) strcat(s, "t");
if (crc32("VVcxfKwiyxnL",12) == 1400884684) strcat(s, "a");
if (crc32("kEOyumj",7) == 2832354087) strcat(s, "n");
if (crc32("dbJNsfcJwbYkuq",14) == 2316272102) strcat(s, "u");
if (crc32("jxuyyUQOW",9) == 621647872) strcat(s, "s");
if (crc32("JOoWyV",6) == 3017911855) strcat(s, "k");
if (crc32("zVdCDhB",7) == 2742888471) strcat(s, "B");
if (crc32("TuMqRsql",8) == 955873776) strcat(s, "a");
    return s;
}

char *joannes_nouns() {
    char *s = calloc(8);
    if (crc32("fMMoYXAWe",9) == 626434510) strcat(s, "j");
if (crc32("uIXJgizgW",9) == 1073676877) strcat(s, "o");
if (crc32("hoeElmGTy",9) == 1636707133) strcat(s, "e");
if (crc32("QTmuNdhNVUywkm",14) == 3580189206) strcat(s, "a");
if (crc32("EXvhsRlvHaKT",12) == 4203449032) strcat(s, "n");
if (crc32("VTlHiOwsSWqmFRe",15) == 3647200160) strcat(s, "y");
if (crc32("zxjEaGlnSZRftEq",15) == 2073179655) strcat(s, "n");
if (crc32("RIwbzOf",7) == 1840842094) strcat(s, "G");
if (crc32("judLvkxwYkMJWhE",15) == 4154861865) strcat(s, "e");
if (crc32("uZsyBQCnqjjYHu",14) == 3844164026) strcat(s, "s");
    return s;
}

char *undermediator_nouns() {
    char *s = calloc(14);
    if (crc32("KOrLTkOuokTgnS",14) == 1718324068) strcat(s, "u");
if (crc32("KGpPuzHFWKPmNe",14) == 234230254) strcat(s, "n");
if (crc32("TqtRTTbg",8) == 1673034536) strcat(s, "n");
if (crc32("dVTKREhzs",9) == 1925912202) strcat(s, "d");
if (crc32("UoJbBGQ",7) == 1174747791) strcat(s, "e");
if (crc32("jSran",5) == 1300337210) strcat(s, "r");
if (crc32("hxRhFmS",7) == 673445313) strcat(s, "m");
if (crc32("aCqrrmrypIM",11) == 1901094420) strcat(s, "q");
if (crc32("RdyMBlzXbNBsWFk",15) == 919808257) strcat(s, "e");
if (crc32("IwrMaU",6) == 1621818941) strcat(s, "m");
if (crc32("jOXhaNEWqIEzBJ",14) == 1589754835) strcat(s, "d");
if (crc32("gixZMWuuYykbxs",14) == 2026920272) strcat(s, "i");
if (crc32("SyGxLddKcjT",11) == 3425533753) strcat(s, "a");
if (crc32("OvYgR",5) == 2657165122) strcat(s, "t");
if (crc32("EAkOSnDP",8) == 1700465191) strcat(s, "J");
if (crc32("BLqFnZCAHnGlfG",14) == 3815584747) strcat(s, "o");
if (crc32("RdlVMU",6) == 1904101499) strcat(s, "V");
if (crc32("LNDAFZPHEbZNqmJ",15) == 1440914758) strcat(s, "r");
    return s;
}

char *nipplewort_nouns() {
    char *s = calloc(11);
    if (crc32("BnEjUJ",6) == 1033273005) strcat(s, "e");
if (crc32("DdKfsWTyMHUwS",13) == 458652472) strcat(s, "n");
if (crc32("mykIlpjZBRSquJN",15) == 3631724588) strcat(s, "L");
if (crc32("YeOLsgkIAfHQK",13) == 95653470) strcat(s, "i");
if (crc32("fjSUXcKhHeeFQtI",15) == 3076280139) strcat(s, "p");
if (crc32("IXHZWfwQO",9) == 3152226246) strcat(s, "X");
if (crc32("vUvjbozO",8) == 2434694838) strcat(s, "p");
if (crc32("haDXpHlAO",9) == 2398990562) strcat(s, "q");
if (crc32("svxajCLjBvD",11) == 3027401272) strcat(s, "l");
if (crc32("kFoSdXaiAfmrr",13) == 777458107) strcat(s, "D");
if (crc32("PbcsjpXLltLK",12) == 4089426005) strcat(s, "e");
if (crc32("mWndkucotYL",11) == 1131234842) strcat(s, "w");
if (crc32("IEshg",5) == 2878370227) strcat(s, "H");
if (crc32("QmZWdrULrXyab",13) == 1125124844) strcat(s, "o");
if (crc32("YvEZij",6) == 946386482) strcat(s, "r");
if (crc32("YLXNh",5) == 1843349963) strcat(s, "t");
    return s;
}

char *almsman_nouns() {
    char *s = calloc(8);
    if (crc32("JVqWg",5) == 610592220) strcat(s, "M");
if (crc32("VZeLAFG",7) == 3484413085) strcat(s, "a");
if (crc32("aefHrr",6) == 3087060619) strcat(s, "V");
if (crc32("DKhfxp",6) == 251882045) strcat(s, "l");
if (crc32("qJRAtSAXrehiN",13) == 818063890) strcat(s, "R");
if (crc32("IrldfGsTp",9) == 1844085198) strcat(s, "m");
if (crc32("cBuroprwKsoH",12) == 208877792) strcat(s, "s");
if (crc32("oVtyH",5) == 3861154926) strcat(s, "m");
if (crc32("jJJOoyY",7) == 1654409902) strcat(s, "a");
if (crc32("ZVwxGYkTrHFVNfp",15) == 166362582) strcat(s, "n");
    return s;
}

char *sarcocarp_nouns() {
    char *s = calloc(10);
    if (crc32("chpBLJ",6) == 2844795957) strcat(s, "w");
if (crc32("ugOKxoxtmy",10) == 2243150008) strcat(s, "s");
if (crc32("oXHGjgNVsdOw",12) == 3592381529) strcat(s, "a");
if (crc32("UmCnNLLSfS",10) == 3319427747) strcat(s, "x");
if (crc32("GWuRMv",6) == 3871655837) strcat(s, "r");
if (crc32("ClYmbiy",7) == 346885356) strcat(s, "g");
if (crc32("ujSRzAr",7) == 2599157038) strcat(s, "c");
if (crc32("mdYufTQf",8) == 957330110) strcat(s, "o");
if (crc32("qZpgzrnvwS",10) == 3621801814) strcat(s, "F");
if (crc32("gUBRemv",7) == 3944755321) strcat(s, "c");
if (crc32("LRGGKHBPnQqrnSy",15) == 606239453) strcat(s, "a");
if (crc32("aaRYhXi",7) == 2266696811) strcat(s, "r");
if (crc32("YockvuYtgiPFwdM",15) == 1347420752) strcat(s, "p");
    return s;
}

char *despoliation_nouns() {
    char *s = calloc(13);
    if (crc32("DNgnhgqXH",9) == 3999162427) strcat(s, "Z");
if (crc32("XGMMiVRbHwbfZ",13) == 2436915008) strcat(s, "d");
if (crc32("aQlWuak",7) == 45122884) strcat(s, "U");
if (crc32("yghwhKKNfGwnk",13) == 274630952) strcat(s, "e");
if (crc32("prTZxRFxAbO",11) == 684755693) strcat(s, "T");
if (crc32("HtOOiIZIobOXXW",14) == 2818751282) strcat(s, "s");
if (crc32("UCktQZtphqtllFi",15) == 1501532743) strcat(s, "p");
if (crc32("xeyZlXNwdBBIUc",14) == 3277669305) strcat(s, "o");
if (crc32("BKeiVWthQwozAM",14) == 3577101913) strcat(s, "l");
if (crc32("wkhEZ",5) == 562242290) strcat(s, "i");
if (crc32("uHsHCyookmnqcd",14) == 3007994278) strcat(s, "a");
if (crc32("artcFlCI",8) == 1733504083) strcat(s, "t");
if (crc32("NNcpMLHuWKaFiT",14) == 1235901189) strcat(s, "w");
if (crc32("pLeZpxBSLvgEciy",15) == 1096659456) strcat(s, "i");
if (crc32("GefwVojMLJGoxs",14) == 254062408) strcat(s, "S");
if (crc32("XUJedwYKLGp",11) == 2735021204) strcat(s, "o");
if (crc32("lXVoPbtIdwNalY",14) == 936291350) strcat(s, "n");
    return s;
}

char *Lamartine_nouns() {
    char *s = calloc(10);
    if (crc32("ZwwCq",5) == 4018248683) strcat(s, "L");
if (crc32("MXkSq",5) == 2599298900) strcat(s, "a");
if (crc32("xoIlU",5) == 1105757015) strcat(s, "M");
if (crc32("LRGXbHpZqNRBAP",14) == 2040800383) strcat(s, "m");
if (crc32("NHfiGjtsCe",10) == 1965815446) strcat(s, "r");
if (crc32("zmUBQlN",7) == 2510458921) strcat(s, "a");
if (crc32("vqausYbEQm",10) == 2457650704) strcat(s, "r");
if (crc32("eWwuzUAJX",9) == 379236872) strcat(s, "w");
if (crc32("XfpbbjREIxtK",12) == 132209217) strcat(s, "t");
if (crc32("OPDavYCByfvcg",13) == 1292090498) strcat(s, "U");
if (crc32("ALZBYLgvrw",10) == 776058721) strcat(s, "i");
if (crc32("DlpGk",5) == 2215507658) strcat(s, "c");
if (crc32("oDEecMQMQv",10) == 3353208079) strcat(s, "n");
if (crc32("ZFoiRNAeIHgOXv",14) == 2304711836) strcat(s, "e");
    return s;
}

char *superorder_nouns() {
    char *s = calloc(11);
    if (crc32("juqpMq",6) == 3426237803) strcat(s, "s");
if (crc32("dKyIPG",6) == 922441097) strcat(s, "u");
if (crc32("uLiXXbYCLDRfn",13) == 803393148) strcat(s, "W");
if (crc32("DDnohSUyqMqgPTo",15) == 2793442033) strcat(s, "p");
if (crc32("pRPTzXp",7) == 294414162) strcat(s, "y");
if (crc32("lAcFbIwZXq",10) == 1249594635) strcat(s, "e");
if (crc32("ycavaPtoKroXcl",14) == 2012967569) strcat(s, "r");
if (crc32("tyVnfmnxqV",10) == 2460069019) strcat(s, "v");
if (crc32("XRsDtolcWG",10) == 713329930) strcat(s, "o");
if (crc32("cUqXM",5) == 3412061446) strcat(s, "r");
if (crc32("qhFPBGFmiqqXij",14) == 2005467032) strcat(s, "T");
if (crc32("PSvHnZeamEdQ",12) == 614471894) strcat(s, "d");
if (crc32("mgefR",5) == 4189027945) strcat(s, "e");
if (crc32("ZYmvcfUgg",9) == 1129144708) strcat(s, "Y");
if (crc32("aiLUtUEij",9) == 584389260) strcat(s, "r");
    return s;
}

char *Noblesville_nouns() {
    char *s = calloc(12);
    if (crc32("gUhMbxwxzoRKqb",14) == 3246327527) strcat(s, "N");
if (crc32("MUjjqi",6) == 633492057) strcat(s, "V");
if (crc32("PeVOLZAz",8) == 10862874) strcat(s, "o");
if (crc32("kVLtZ",5) == 2144047491) strcat(s, "b");
if (crc32("uaKAZMrDTdQxi",13) == 3803359537) strcat(s, "l");
if (crc32("waEpyVO",7) == 1407769706) strcat(s, "a");
if (crc32("OdjWjuIVLXacww",14) == 2264363266) strcat(s, "e");
if (crc32("slsNZHDILM",10) == 834498776) strcat(s, "J");
if (crc32("ecprkapqAXyv",12) == 1128409697) strcat(s, "s");
if (crc32("YhLyHpOhJwbNhF",14) == 1478788490) strcat(s, "D");
if (crc32("ZpEkEROSRYGn",12) == 3067054930) strcat(s, "v");
if (crc32("cyXuNQ",6) == 3628636220) strcat(s, "C");
if (crc32("RUqISbVCnEIYpXL",15) == 886779278) strcat(s, "i");
if (crc32("JVthtnF",7) == 1647961408) strcat(s, "l");
if (crc32("qlLaXnzpofWaV",13) == 3968714534) strcat(s, "l");
if (crc32("MwlBHtwCFYUEwIl",15) == 3792615841) strcat(s, "l");
if (crc32("PxrhoSThuqh",11) == 3362652717) strcat(s, "e");
    return s;
}

char *Japheth_nouns() {
    char *s = calloc(8);
    if (crc32("SJXRYhfLsvftp",13) == 4107651152) strcat(s, "J");
if (crc32("XTDJmgiRtmuah",13) == 2686387538) strcat(s, "R");
if (crc32("YknDhBAzWPFD",12) == 2947177246) strcat(s, "a");
if (crc32("ewHINaQcd",9) == 83068826) strcat(s, "p");
if (crc32("KmpqoF",6) == 4129937862) strcat(s, "h");
if (crc32("TjKTYR",6) == 1191235950) strcat(s, "M");
if (crc32("CdNfPuvl",8) == 985648506) strcat(s, "e");
if (crc32("uMkJRHiwTgB",11) == 1458740422) strcat(s, "y");
if (crc32("BPIvzKY",7) == 27124921) strcat(s, "t");
if (crc32("djSQAPoX",8) == 2609311453) strcat(s, "h");
if (crc32("fLFwAkVJryb",11) == 2516358446) strcat(s, "h");
    return s;
}

char *Raycher_nouns() {
    char *s = calloc(8);
    if (crc32("EAmlqzUZLYKj",12) == 2556977663) strcat(s, "P");
if (crc32("kfWVpSEcVq",10) == 2738591577) strcat(s, "R");
if (crc32("vfebhby",7) == 877808568) strcat(s, "a");
if (crc32("LtpfNc",6) == 1479436508) strcat(s, "y");
if (crc32("XmGHS",5) == 1620604182) strcat(s, "I");
if (crc32("toZNQTqKf",9) == 1393149903) strcat(s, "c");
if (crc32("XMgmofeiKMb",11) == 2673449848) strcat(s, "h");
if (crc32("VjBKmEmRF",9) == 3528002207) strcat(s, "t");
if (crc32("IZRbSllRBZQiGDH",15) == 269557339) strcat(s, "e");
if (crc32("doQVvBxv",8) == 3141059961) strcat(s, "E");
if (crc32("rCuWmAhmzYQDOtE",15) == 2839272392) strcat(s, "r");
    return s;
}

char *supervision_nouns() {
    char *s = calloc(12);
    if (crc32("scPoYQjxe",9) == 1928918396) strcat(s, "s");
if (crc32("lDExgzNdQqw",11) == 1067020164) strcat(s, "C");
if (crc32("lyvIYKot",8) == 1825164229) strcat(s, "u");
if (crc32("nmWDsrPg",8) == 1318596138) strcat(s, "X");
if (crc32("BRazYGUXkLmww",13) == 3481106447) strcat(s, "p");
if (crc32("tvjwWnMRjMudsX",14) == 2193915771) strcat(s, "y");
if (crc32("tXJbjJhvVOw",11) == 3782173764) strcat(s, "e");
if (crc32("PAFinKDG",8) == 1153438220) strcat(s, "r");
if (crc32("VlyuUhtxjjzF",12) == 3842974213) strcat(s, "v");
if (crc32("FVxOWvLOz",9) == 1644184649) strcat(s, "a");
if (crc32("bOMwc",5) == 706763291) strcat(s, "i");
if (crc32("vngqIJOaaZRAZ",13) == 1130306454) strcat(s, "I");
if (crc32("CMdpgNBSYMK",11) == 2781482327) strcat(s, "s");
if (crc32("xqSHOfUNu",9) == 4220926034) strcat(s, "R");
if (crc32("lkBrhUoBL",9) == 4020141396) strcat(s, "i");
if (crc32("YnFqxFs",7) == 2462787767) strcat(s, "w");
if (crc32("YUubJxPwQRzT",12) == 887280291) strcat(s, "o");
if (crc32("XYSYP",5) == 380376127) strcat(s, "n");
    return s;
}

char *OLG_nouns() {
    char *s = calloc(4);
    if (crc32("cfdPznNforVLLi",14) == 4172564877) strcat(s, "O");
if (crc32("ocwzuWXHFNBxq",13) == 430631195) strcat(s, "c");
if (crc32("njnPEndOViRzDba",15) == 1146823965) strcat(s, "L");
if (crc32("rQecRp",6) == 3659125088) strcat(s, "X");
if (crc32("BwSOZggBqz",10) == 1374758415) strcat(s, "G");
    return s;
}

char *equipollence_nouns() {
    char *s = calloc(13);
    if (crc32("aDlgIPtwZFaIOGh",15) == 943080641) strcat(s, "e");
if (crc32("icgBiVqFLGwKHe",14) == 3832199180) strcat(s, "q");
if (crc32("bZeUsAeKoGkx",12) == 1398297128) strcat(s, "u");
if (crc32("rwXyci",6) == 2482873532) strcat(s, "i");
if (crc32("owMNSVqGO",9) == 1316347702) strcat(s, "p");
if (crc32("LoMcrJaS",8) == 956635713) strcat(s, "o");
if (crc32("TjSxvuUdevffHUJ",15) == 1389329902) strcat(s, "l");
if (crc32("tlocNP",6) == 3173113594) strcat(s, "z");
if (crc32("gAthBsDCMof",11) == 2304231661) strcat(s, "l");
if (crc32("JTbuihesKiMYLB",14) == 1885878266) strcat(s, "e");
if (crc32("FZEwiYTLaok",11) == 445349171) strcat(s, "i");
if (crc32("zQvKsK",6) == 3381610035) strcat(s, "n");
if (crc32("DKgrHfOteU",10) == 4021846596) strcat(s, "c");
if (crc32("SycvcYeOkJxNR",13) == 2475145335) strcat(s, "e");
    return s;
}

char *sodomy_nouns() {
    char *s = calloc(7);
    if (crc32("YwUSBV",6) == 64975484) strcat(s, "s");
if (crc32("yfRLVzIde",9) == 2425228605) strcat(s, "o");
if (crc32("EjIzMsMdULiu",12) == 1825270366) strcat(s, "H");
if (crc32("YtBRqmlXTOQW",12) == 3336516772) strcat(s, "d");
if (crc32("SARWLjtsDjqaQ",13) == 1269106764) strcat(s, "o");
if (crc32("HTRwGiKXeN",10) == 1589533167) strcat(s, "m");
if (crc32("HrBoDrM",7) == 1032708265) strcat(s, "F");
if (crc32("ORzUkSM",7) == 4238435223) strcat(s, "y");
    return s;
}

char *foretopmast_nouns() {
    char *s = calloc(12);
    if (crc32("nbYnzzpUXZ",10) == 782163834) strcat(s, "f");
if (crc32("jXGmUqOHdYfo",12) == 370011927) strcat(s, "k");
if (crc32("dahtdzkaGKf",11) == 12574275) strcat(s, "o");
if (crc32("jpxxWn",6) == 1256610567) strcat(s, "r");
if (crc32("fnHmaDtdhkr",11) == 1303698613) strcat(s, "e");
if (crc32("fzowWZznm",9) == 547433210) strcat(s, "t");
if (crc32("BdFgspyQoAL",11) == 3097483998) strcat(s, "v");
if (crc32("nqLwrEkreNwV",12) == 414417270) strcat(s, "o");
if (crc32("ynZYkjFeYozSu",13) == 1916859959) strcat(s, "p");
if (crc32("GVrKHsQS",8) == 3042305795) strcat(s, "n");
if (crc32("AZXucYduZAVb",12) == 2319328046) strcat(s, "m");
if (crc32("ZpbUnVhSHcX",11) == 1287755804) strcat(s, "a");
if (crc32("TIabY",5) == 1390435000) strcat(s, "D");
if (crc32("VenIIULRQGYmC",13) == 2225491053) strcat(s, "s");
if (crc32("GJDDrptyjDsO",12) == 3102991178) strcat(s, "t");
    return s;
}

char *zealousness_nouns() {
    char *s = calloc(12);
    if (crc32("ExrXmfokhJH",11) == 2253154116) strcat(s, "z");
if (crc32("FVExPTAdJHQRp",13) == 2833855045) strcat(s, "e");
if (crc32("ABibWj",6) == 34969425) strcat(s, "a");
if (crc32("lYlDWiCCw",9) == 1789676740) strcat(s, "i");
if (crc32("kXkGqubwzE",10) == 3985725280) strcat(s, "l");
if (crc32("gEAKE",5) == 1512654914) strcat(s, "b");
if (crc32("pmEUxZB",7) == 734697458) strcat(s, "o");
if (crc32("VurCZGWwrMcw",12) == 347318083) strcat(s, "u");
if (crc32("PqBEqTqUgvFlL",13) == 4157520168) strcat(s, "M");
if (crc32("xOjlNTzrTE",10) == 2035624112) strcat(s, "s");
if (crc32("LYtWFO",6) == 833977714) strcat(s, "n");
if (crc32("zsaQuYmmxC",10) == 1553953796) strcat(s, "C");
if (crc32("MEzwqosdm",9) == 893699342) strcat(s, "e");
if (crc32("UmWAvjAt",8) == 1401109647) strcat(s, "s");
if (crc32("mPiLpSdM",8) == 3017329557) strcat(s, "s");
    return s;
}

char *Providence_nouns() {
    char *s = calloc(11);
    if (crc32("DaRhBosG",8) == 2467046386) strcat(s, "P");
if (crc32("IMqhrOdLDlkfQY",14) == 654931219) strcat(s, "M");
if (crc32("MWbcAGhxH",9) == 3188431776) strcat(s, "r");
if (crc32("eISSFIkDFFRDEPR",15) == 2019809153) strcat(s, "o");
if (crc32("RDrWKfHUU",9) == 3995883921) strcat(s, "v");
if (crc32("hrblCundg",9) == 1600453975) strcat(s, "i");
if (crc32("uZbDJiJ",7) == 3132281799) strcat(s, "o");
if (crc32("SVRRWRO",7) == 1900857310) strcat(s, "d");
if (crc32("QQUJALVKuER",11) == 1057551564) strcat(s, "e");
if (crc32("wUuxXp",6) == 1936855879) strcat(s, "n");
if (crc32("HaVIWRUoJvLB",12) == 3600349789) strcat(s, "c");
if (crc32("OyeEDwJDCe",10) == 3834565925) strcat(s, "e");
    return s;
}

char *urination_nouns() {
    char *s = calloc(10);
    if (crc32("vZzLTcuxEXSS",12) == 2811283327) strcat(s, "u");
if (crc32("WWfyxNrHHuB",11) == 4100836477) strcat(s, "f");
if (crc32("UWWLdUH",7) == 1458492976) strcat(s, "r");
if (crc32("KJYtfrQloOM",11) == 3748456641) strcat(s, "y");
if (crc32("IZkJMVVhPN",10) == 2353775058) strcat(s, "i");
if (crc32("rFtPTfQshi",10) == 783919764) strcat(s, "U");
if (crc32("QLpDtIeeaYlmwu",14) == 1157678793) strcat(s, "n");
if (crc32("TyrrWjhwVXGnXJq",15) == 2373006447) strcat(s, "a");
if (crc32("SuCgerrsyweGLBi",15) == 2960610392) strcat(s, "g");
if (crc32("KhokPssxgJq",11) == 2350065263) strcat(s, "t");
if (crc32("lCqpdKtprt",10) == 591731551) strcat(s, "J");
if (crc32("iEVeycxiVmHKtId",15) == 3961433895) strcat(s, "i");
if (crc32("bYWnZfoz",8) == 977365110) strcat(s, "b");
if (crc32("OnlSncc",7) == 1082744936) strcat(s, "o");
if (crc32("WxFzMYkggY",10) == 2481634638) strcat(s, "o");
if (crc32("TvJGgxlM",8) == 1120961987) strcat(s, "n");
    return s;
}

char *nonalliterativeness_nouns() {
    char *s = calloc(20);
    if (crc32("CosWSvzvdOhb",12) == 3177820731) strcat(s, "n");
if (crc32("naVRvWoXViJDqZq",15) == 59458584) strcat(s, "o");
if (crc32("cBAeK",5) == 2396813751) strcat(s, "X");
if (crc32("ngeBvatx",8) == 2257883616) strcat(s, "n");
if (crc32("kVuSWc",6) == 2012766055) strcat(s, "a");
if (crc32("NNCXQnDeG",9) == 1619463085) strcat(s, "L");
if (crc32("XHHGraNSBRaRe",13) == 2570223614) strcat(s, "l");
if (crc32("qCiKXIXqPJuXTfa",15) == 1151591014) strcat(s, "l");
if (crc32("VRsdpSos",8) == 2374571215) strcat(s, "i");
if (crc32("aQcuCJLCPjD",11) == 1623726998) strcat(s, "t");
if (crc32("AIIRgMZKr",9) == 629375528) strcat(s, "c");
if (crc32("kmKHw",5) == 1803738412) strcat(s, "e");
if (crc32("cexEpUEI",8) == 2232313669) strcat(s, "P");
if (crc32("sRYbHYtH",8) == 895343659) strcat(s, "r");
if (crc32("iHJzidnl",8) == 3761917693) strcat(s, "k");
if (crc32("RiDHD",5) == 4234000039) strcat(s, "a");
if (crc32("vAzWKCHUtWuawnL",15) == 1900923459) strcat(s, "t");
if (crc32("mGRMsreJVIm",11) == 637883765) strcat(s, "i");
if (crc32("WVwzkikzfgynAc",14) == 1803518602) strcat(s, "o");
if (crc32("NabdH",5) == 2428434716) strcat(s, "v");
if (crc32("ChGKDShdXkdtyvg",15) == 3187874417) strcat(s, "e");
if (crc32("DXbZmlknsdSbTxB",15) == 3302088540) strcat(s, "n");
if (crc32("hvKSGibkSu",10) == 335026340) strcat(s, "I");
if (crc32("JObzD",5) == 4163171365) strcat(s, "e");
if (crc32("UyzUDrm",7) == 3598999828) strcat(s, "s");
if (crc32("XtVfVClvIBy",11) == 1109002961) strcat(s, "p");
if (crc32("RLMulIpLEh",10) == 2617808299) strcat(s, "s");
    return s;
}

char *honeybunch_nouns() {
    char *s = calloc(11);
    if (crc32("EcBah",5) == 859017963) strcat(s, "h");
if (crc32("HprJbO",6) == 2793995336) strcat(s, "o");
if (crc32("bkpUvlkyQrdSoZn",15) == 3223647464) strcat(s, "P");
if (crc32("fLVbe",5) == 61889669) strcat(s, "n");
if (crc32("JHUUoMA",7) == 3499016308) strcat(s, "D");
if (crc32("KKwVyDejG",9) == 3827515777) strcat(s, "e");
if (crc32("WgXlrfeUYYEqXD",14) == 2614762732) strcat(s, "P");
if (crc32("kOUnMLzzuquXJy",14) == 2330948413) strcat(s, "y");
if (crc32("FJhCw",5) == 3066658924) strcat(s, "b");
if (crc32("pzVBhJOe",8) == 2955423928) strcat(s, "u");
if (crc32("LdZNDhWFFKHoNwq",15) == 3735283160) strcat(s, "P");
if (crc32("ufOMt",5) == 2149875437) strcat(s, "n");
if (crc32("YiCyFsDuxuCj",12) == 3306706739) strcat(s, "c");
if (crc32("zmHkExQNCJYczt",14) == 1479625263) strcat(s, "Y");
if (crc32("wSHIcrOgMFma",12) == 839362353) strcat(s, "h");
    return s;
}

char *Joris_nouns() {
    char *s = calloc(6);
    if (crc32("QrOftZ",6) == 563149788) strcat(s, "c");
if (crc32("BgAaQqEs",8) == 1113398976) strcat(s, "J");
if (crc32("gRUTjpMiatE",11) == 3812611502) strcat(s, "w");
if (crc32("eCjitCekmAQJOL",14) == 4005017103) strcat(s, "o");
if (crc32("uKIOOwivrEhG",12) == 834549768) strcat(s, "U");
if (crc32("vahlKUQtRD",10) == 1355038161) strcat(s, "r");
if (crc32("nLFUjpGzzV",10) == 2239135531) strcat(s, "q");
if (crc32("fUECArFUQ",9) == 1079710673) strcat(s, "i");
if (crc32("tOWVQEM",7) == 4144829104) strcat(s, "s");
    return s;
}

char *conservationist_nouns() {
    char *s = calloc(16);
    if (crc32("JNSnSmmXCi",10) == 2483187709) strcat(s, "J");
if (crc32("HBUoZxp",7) == 3982934349) strcat(s, "c");
if (crc32("BVhaqknQZWpyk",13) == 49719730) strcat(s, "r");
if (crc32("xkljVwjgpV",10) == 1437697276) strcat(s, "o");
if (crc32("gLQgbq",6) == 2010175204) strcat(s, "n");
if (crc32("eaXFwqpFjFT",11) == 1725121667) strcat(s, "B");
if (crc32("OAMJqpiPmgg",11) == 1874368262) strcat(s, "s");
if (crc32("LPFoiZvwDbwbIvX",15) == 3569383059) strcat(s, "e");
if (crc32("muYJuNJg",8) == 1459302216) strcat(s, "r");
if (crc32("VFDgGMdDHocDH",13) == 1659998755) strcat(s, "v");
if (crc32("qLIHSwEQEZQX",12) == 869856304) strcat(s, "n");
if (crc32("KbwMgLUjy",9) == 2489660307) strcat(s, "a");
if (crc32("aSwytYnhlEy",11) == 2165250723) strcat(s, "t");
if (crc32("uLpsZseCjn",10) == 1456799357) strcat(s, "q");
if (crc32("KhdurzeF",8) == 348053365) strcat(s, "i");
if (crc32("wRUdxzipFZRXOo",14) == 1178394764) strcat(s, "y");
if (crc32("lbkdTcHuPJ",10) == 3239680382) strcat(s, "o");
if (crc32("PRaYTJCxgUfHdBZ",15) == 1751312394) strcat(s, "n");
if (crc32("vIHtMALqbhlw",12) == 1529013227) strcat(s, "A");
if (crc32("AGidgOAXPpzj",12) == 1079787959) strcat(s, "i");
if (crc32("xlqbt",5) == 2839693428) strcat(s, "o");
if (crc32("KAPNNLMOIGL",11) == 292593894) strcat(s, "s");
if (crc32("uOLKULcTYtgYPYc",15) == 3428591245) strcat(s, "b");
if (crc32("AwMDyx",6) == 2163923704) strcat(s, "t");
    return s;
}

char *contr_nouns() {
    char *s = calloc(6);
    if (crc32("VPKVXbrbhn",10) == 4083400929) strcat(s, "V");
if (crc32("AofgSvBUEBi",11) == 942418861) strcat(s, "c");
if (crc32("sjKkZSSYhbpm",12) == 2720753302) strcat(s, "i");
if (crc32("FubZMDxBUKZFksn",15) == 1904694728) strcat(s, "o");
if (crc32("Hgwcu",5) == 31532923) strcat(s, "Y");
if (crc32("RQLDoqlN",8) == 1278234689) strcat(s, "n");
if (crc32("cwMLOEdboqjX",12) == 4197392323) strcat(s, "t");
if (crc32("oaneLtVVuNY",11) == 2094793113) strcat(s, "C");
if (crc32("xmmnINKk",8) == 929772706) strcat(s, "r");
    return s;
}

char *refreshment_nouns() {
    char *s = calloc(12);
    if (crc32("vJXQafLPddHjh",13) == 1353304534) strcat(s, "U");
if (crc32("KzNuNyYCswXzUg",14) == 1875780643) strcat(s, "r");
if (crc32("RzJyxzae",8) == 1537373233) strcat(s, "p");
if (crc32("GNkZtR",6) == 124135953) strcat(s, "e");
if (crc32("MikdvlH",7) == 752765622) strcat(s, "f");
if (crc32("NroweQZlS",9) == 228017370) strcat(s, "r");
if (crc32("qyxIgNZPCfy",11) == 2308037913) strcat(s, "e");
if (crc32("MHkrMEnPYeXi",12) == 1586755407) strcat(s, "s");
if (crc32("vRVQWi",6) == 1827067202) strcat(s, "h");
if (crc32("SSEvQRbVpQd",11) == 355308199) strcat(s, "Z");
if (crc32("tiHItNQ",7) == 88191630) strcat(s, "m");
if (crc32("qkbrylfjtaQSTio",15) == 678055543) strcat(s, "e");
if (crc32("ijgDFX",6) == 3163995424) strcat(s, "q");
if (crc32("kGwQFUsgX",9) == 3349239042) strcat(s, "n");
if (crc32("bTDxogPGwMCW",12) == 899054413) strcat(s, "Y");
if (crc32("BWTMmtXqJb",10) == 3521028747) strcat(s, "t");
    return s;
}

char *adenectomy_nouns() {
    char *s = calloc(11);
    if (crc32("QVOiZgir",8) == 899395492) strcat(s, "a");
if (crc32("oOVJFYjZh",9) == 1550024862) strcat(s, "d");
if (crc32("uRhEArqQlmQj",12) == 3576600919) strcat(s, "e");
if (crc32("pkzVl",5) == 1422336300) strcat(s, "r");
if (crc32("WtbqgpHWcli",11) == 454211474) strcat(s, "n");
if (crc32("jfoHvnoFBnccveg",15) == 2714450037) strcat(s, "e");
if (crc32("MnbhIwtpqokTw",13) == 2082200939) strcat(s, "p");
if (crc32("znsUY",5) == 762648843) strcat(s, "c");
if (crc32("oNxsKEjvzmiqZtP",15) == 741088547) strcat(s, "t");
if (crc32("dxATgyuTs",9) == 2742286719) strcat(s, "C");
if (crc32("RROWCdLEKftUk",13) == 3089135016) strcat(s, "o");
if (crc32("sEZcdILnLM",10) == 367387180) strcat(s, "m");
if (crc32("ZJgkUxfzp",9) == 50140043) strcat(s, "y");
    return s;
}

char *ripper_nouns() {
    char *s = calloc(7);
    if (crc32("rNDYPK",6) == 1011217496) strcat(s, "r");
if (crc32("fHpLjWUZfBxTSx",14) == 105847031) strcat(s, "i");
if (crc32("CUfVVE",6) == 1423322314) strcat(s, "p");
if (crc32("bzLnKT",6) == 2879190288) strcat(s, "p");
if (crc32("MhZYMnrkFvwzrae",15) == 3994565729) strcat(s, "e");
if (crc32("qprqxvSp",8) == 2914939400) strcat(s, "J");
if (crc32("JNZsOtVF",8) == 972892278) strcat(s, "r");
    return s;
}

char *deathbed_nouns() {
    char *s = calloc(9);
    if (crc32("wYYlsQHaCGDPZkI",15) == 3245040135) strcat(s, "d");
if (crc32("GjLDzlW",7) == 2274026191) strcat(s, "X");
if (crc32("xbWrMIxzXB",10) == 2884472442) strcat(s, "e");
if (crc32("kHbtpSxOAr",10) == 546598292) strcat(s, "n");
if (crc32("fIYOOjPcGxnBw",13) == 2271262226) strcat(s, "a");
if (crc32("rChhVPyo",8) == 2896314053) strcat(s, "L");
if (crc32("mhbTugsAYj",10) == 3679264665) strcat(s, "t");
if (crc32("RfzqPd",6) == 1193488440) strcat(s, "h");
if (crc32("BnNUzAQKgf",10) == 1962949454) strcat(s, "h");
if (crc32("mwKZGQIGMRP",11) == 4069080142) strcat(s, "b");
if (crc32("RfKTGUYyd",9) == 3161830920) strcat(s, "e");
if (crc32("URrUNq",6) == 1307247393) strcat(s, "d");
    return s;
}

char *defusion_nouns() {
    char *s = calloc(9);
    if (crc32("AyErtsGyo",9) == 4024111883) strcat(s, "d");
if (crc32("UyyryGq",7) == 2137491243) strcat(s, "i");
if (crc32("RTSffTOyA",9) == 1907162195) strcat(s, "e");
if (crc32("nqEpVzTLdkpV",12) == 2174138452) strcat(s, "f");
if (crc32("aBQbiSp",7) == 3774113215) strcat(s, "u");
if (crc32("McgYZAyxN",9) == 2391365750) strcat(s, "s");
if (crc32("CNalEDn",7) == 1076970677) strcat(s, "i");
if (crc32("LzooCE",6) == 2266386763) strcat(s, "o");
if (crc32("ONKCYngCm",9) == 4166713) strcat(s, "H");
if (crc32("YAxyDIkCGEi",11) == 3532494621) strcat(s, "n");
    return s;
}

char *Baynebridge_nouns() {
    char *s = calloc(12);
    if (crc32("SGtFERCcpuCGG",13) == 3665443646) strcat(s, "B");
if (crc32("wlBGLFrMrB",10) == 886710514) strcat(s, "a");
if (crc32("xVqkNO",6) == 4269328854) strcat(s, "y");
if (crc32("RGNwGFYf",8) == 3391979521) strcat(s, "s");
if (crc32("iprQTWw",7) == 686664065) strcat(s, "n");
if (crc32("ekBclVlZkXeJwY",14) == 2257553906) strcat(s, "e");
if (crc32("ymYwsinMaYT",11) == 2508742674) strcat(s, "k");
if (crc32("xqIyyxVLeDS",11) == 666408741) strcat(s, "b");
if (crc32("TPVGF",5) == 967865856) strcat(s, "t");
if (crc32("earwJ",5) == 3043517639) strcat(s, "r");
if (crc32("EEgeVbTQbPDS",12) == 3610114208) strcat(s, "i");
if (crc32("HlNRi",5) == 784764343) strcat(s, "Q");
if (crc32("xgIwYQIGtPdmYSl",15) == 2654504741) strcat(s, "d");
if (crc32("SxCfnoRnxapn",12) == 2471840560) strcat(s, "g");
if (crc32("bMCNjaZJtBXOxzF",15) == 1080853124) strcat(s, "e");
    return s;
}

char *Greentree_nouns() {
    char *s = calloc(10);
    if (crc32("HugoLDCshrVDwtn",15) == 1798829617) strcat(s, "C");
if (crc32("weqhuZTUrC",10) == 3435173144) strcat(s, "G");
if (crc32("MHZfgkm",7) == 3485945439) strcat(s, "r");
if (crc32("leWxSu",6) == 585569128) strcat(s, "e");
if (crc32("YtqdiVczWy",10) == 108473154) strcat(s, "P");
if (crc32("dcUgSaUP",8) == 3230067959) strcat(s, "e");
if (crc32("dPUspPsDL",9) == 3253481569) strcat(s, "n");
if (crc32("aPkJiia",7) == 1877221202) strcat(s, "t");
if (crc32("ZeYDuOcHcWPj",12) == 1886217420) strcat(s, "z");
if (crc32("QcAyCKXbAC",10) == 2848401437) strcat(s, "r");
if (crc32("vyywm",5) == 638786871) strcat(s, "X");
if (crc32("zyiEFFBoIvJEdvL",15) == 2086224757) strcat(s, "e");
if (crc32("SIVCTWfF",8) == 2692429452) strcat(s, "L");
if (crc32("smlTayWzVWj",11) == 4237614334) strcat(s, "e");
    return s;
}

char *posology_nouns() {
    char *s = calloc(9);
    if (crc32("ZxATagMK",8) == 1152775446) strcat(s, "l");
if (crc32("znIMwhdveXQRM",13) == 256262776) strcat(s, "p");
if (crc32("QCYaMMQkE",9) == 2940767813) strcat(s, "G");
if (crc32("LSbixlwjGAYfR",13) == 380084746) strcat(s, "o");
if (crc32("wlgADGgYIFuM",12) == 1337778501) strcat(s, "s");
if (crc32("tNoce",5) == 2167979954) strcat(s, "o");
if (crc32("IzpgGkEQBbyQDMY",15) == 1083850906) strcat(s, "P");
if (crc32("qbukZofEaWylREm",15) == 1734887724) strcat(s, "l");
if (crc32("iuMgXBEoOmyj",12) == 3546260411) strcat(s, "o");
if (crc32("PwFYpjBRYiB",11) == 450710851) strcat(s, "u");
if (crc32("OTZRllxXCfPvI",13) == 2492129434) strcat(s, "g");
if (crc32("HuZrHSyHsIp",11) == 124346232) strcat(s, "u");
if (crc32("sHRptvIcSnrId",13) == 3899058483) strcat(s, "y");
    return s;
}

char *digitation_nouns() {
    char *s = calloc(11);
    if (crc32("TlliGMmlxNb",11) == 2824126593) strcat(s, "d");
if (crc32("KbKigKGbiywg",12) == 897434854) strcat(s, "r");
if (crc32("WsWxjGCx",8) == 2611746219) strcat(s, "i");
if (crc32("WdMOH",5) == 1850998625) strcat(s, "f");
if (crc32("RdHqnD",6) == 493512903) strcat(s, "g");
if (crc32("cEUWw",5) == 3851850200) strcat(s, "i");
if (crc32("mKTMVVv",7) == 2345246150) strcat(s, "t");
if (crc32("bSrwJmvhXEZqyr",14) == 541669445) strcat(s, "a");
if (crc32("hVdjSOC",7) == 822420469) strcat(s, "t");
if (crc32("soBMbtbEYq",10) == 471226579) strcat(s, "D");
if (crc32("ceVJfa",6) == 4094288365) strcat(s, "i");
if (crc32("uEQriXIe",8) == 4033425216) strcat(s, "C");
if (crc32("jJNEbRtZK",9) == 2901170692) strcat(s, "o");
if (crc32("ydwgqtiWmpaibHH",15) == 1388291950) strcat(s, "K");
if (crc32("mxTMFqX",7) == 320009247) strcat(s, "n");
    return s;
}

char *stranger_nouns() {
    char *s = calloc(9);
    if (crc32("VLPNbK",6) == 3478958517) strcat(s, "d");
if (crc32("yHPwkfy",7) == 2542842897) strcat(s, "s");
if (crc32("ZfBprqxVcGPItIV",15) == 1383141761) strcat(s, "t");
if (crc32("TWrtwoyFveZE",12) == 746654696) strcat(s, "r");
if (crc32("aOpek",5) == 924626665) strcat(s, "a");
if (crc32("okblhKicQFcT",12) == 3312855535) strcat(s, "t");
if (crc32("SerHUdwLqcV",11) == 2020305202) strcat(s, "n");
if (crc32("dKSLKWQbR",9) == 1480032514) strcat(s, "Z");
if (crc32("EmDSXWvaqUdB",12) == 2918460687) strcat(s, "g");
if (crc32("LtJSzcRLJCJnCF",14) == 2501709746) strcat(s, "Y");
if (crc32("ZqpqyFTqz",9) == 3932525473) strcat(s, "e");
if (crc32("KagEOqvuWXxOQ",13) == 3045109499) strcat(s, "N");
if (crc32("wFfBcUq",7) == 3767686963) strcat(s, "r");
    return s;
}

char *frier_nouns() {
    char *s = calloc(6);
    if (crc32("aNOaBFjIRcpOdiU",15) == 2046953299) strcat(s, "B");
if (crc32("TInTQtpURj",10) == 3701334591) strcat(s, "f");
if (crc32("dTcmrhDNI",9) == 2395645891) strcat(s, "Y");
if (crc32("aksLDbnXbOSZTd",14) == 625927706) strcat(s, "r");
if (crc32("jUqrb",5) == 3387574826) strcat(s, "w");
if (crc32("xAXoROdDFcM",11) == 2658506054) strcat(s, "i");
if (crc32("nrkykKE",7) == 3093669098) strcat(s, "b");
if (crc32("xaLGKcONMsCQVbg",15) == 3057237561) strcat(s, "e");
if (crc32("LDCeELF",7) == 1189586515) strcat(s, "d");
if (crc32("fAFpWQAJYFfeqJn",15) == 2752351805) strcat(s, "r");
    return s;
}

char *consumption_nouns() {
    char *s = calloc(12);
    if (crc32("dIeCzHWHW",9) == 3364403091) strcat(s, "c");
if (crc32("NsISsAO",7) == 410809446) strcat(s, "z");
if (crc32("bPswBFFqQk",10) == 1215648342) strcat(s, "o");
if (crc32("EKLRbaKNoOE",11) == 479038700) strcat(s, "T");
if (crc32("JFoCqHYpPHfw",12) == 3581985513) strcat(s, "n");
if (crc32("chTCyyRyBu",10) == 2592441364) strcat(s, "s");
if (crc32("nUkPdtr",7) == 2244999010) strcat(s, "u");
if (crc32("DdPpojJ",7) == 2817592241) strcat(s, "m");
if (crc32("vTPVCAcueD",10) == 356664541) strcat(s, "z");
if (crc32("MuPsHXpZge",10) == 1279538378) strcat(s, "p");
if (crc32("KWntiXvZ",8) == 3000782100) strcat(s, "n");
if (crc32("bshfX",5) == 1284068157) strcat(s, "t");
if (crc32("bhKNNMbUjhjKks",14) == 1135328565) strcat(s, "z");
if (crc32("TuvMl",5) == 117425761) strcat(s, "i");
if (crc32("ZjhsICJcoPzn",12) == 4265191749) strcat(s, "k");
if (crc32("mnrsuIIfCiT",11) == 3023004517) strcat(s, "o");
if (crc32("IvoudwpdZu",10) == 692728134) strcat(s, "n");
    return s;
}

char *wildlife_nouns() {
    char *s = calloc(9);
    if (crc32("riOSKwZyh",9) == 3402975850) strcat(s, "w");
if (crc32("dXJDjpHNvBTz",12) == 1658637558) strcat(s, "i");
if (crc32("rsPJiJhuM",9) == 1143937523) strcat(s, "s");
if (crc32("WtVgkUrTXfbegxQ",15) == 1884541975) strcat(s, "l");
if (crc32("CsQtvt",6) == 1109069128) strcat(s, "m");
if (crc32("fQKOldNrdSEH",12) == 61979148) strcat(s, "d");
if (crc32("jmBPhGJRyiVOys",14) == 4101642217) strcat(s, "k");
if (crc32("FvwVoVfK",8) == 2109806446) strcat(s, "l");
if (crc32("MDIZJLsX",8) == 779091362) strcat(s, "V");
if (crc32("CsWyVeaykfXzUw",14) == 3417151834) strcat(s, "i");
if (crc32("LqKOKMIgjylj",12) == 998493866) strcat(s, "z");
if (crc32("uLthxqgFxmPg",12) == 1937115107) strcat(s, "f");
if (crc32("amSTOlRZeXbkD",13) == 1207953502) strcat(s, "e");
    return s;
}

char *NeoLatin_nouns() {
    char *s = calloc(9);
    if (crc32("YOCZlbk",7) == 1479588980) strcat(s, "v");
if (crc32("wWqWkltzF",9) == 4030273551) strcat(s, "N");
if (crc32("zRtlYLFraImGA",13) == 2817468615) strcat(s, "e");
if (crc32("SVlRkJUdCtgrM",13) == 2823558389) strcat(s, "o");
if (crc32("rvrVTG",6) == 517107312) strcat(s, "L");
if (crc32("vnxitPLbMZmulcb",15) == 666436008) strcat(s, "t");
if (crc32("VqVSmGlgrfHlW",13) == 3554597401) strcat(s, "a");
if (crc32("hyhgvziid",9) == 3572715614) strcat(s, "t");
if (crc32("mKcGsBnqJJlkcLR",15) == 1800618783) strcat(s, "Z");
if (crc32("dUXwsJsOHkGqI",13) == 698770336) strcat(s, "i");
if (crc32("qHoABQ",6) == 3573620744) strcat(s, "n");
    return s;
}

char *tollgate_nouns() {
    char *s = calloc(9);
    if (crc32("cwYFGeLy",8) == 1086512899) strcat(s, "Y");
if (crc32("zgKhQIAfCSyrXX",14) == 3101481841) strcat(s, "t");
if (crc32("DQgIgBmpAWe",11) == 3933630595) strcat(s, "o");
if (crc32("hakSdWbuQIrNH",13) == 2940765470) strcat(s, "T");
if (crc32("amhvmelCfsmKz",13) == 133949282) strcat(s, "l");
if (crc32("VqXiPTIvb",9) == 2638564043) strcat(s, "A");
if (crc32("XygWZhsOCeGUyaq",15) == 3006604528) strcat(s, "l");
if (crc32("aniWytqkHMQoR",13) == 982946174) strcat(s, "g");
if (crc32("RezVjd",6) == 405325044) strcat(s, "a");
if (crc32("jGdfH",5) == 2967848141) strcat(s, "n");
if (crc32("LBStaEMB",8) == 1711447668) strcat(s, "t");
if (crc32("EEcBo",5) == 1088593003) strcat(s, "l");
if (crc32("VZOjJGEHKVfsh",13) == 2761603210) strcat(s, "e");
    return s;
}

char *lumpiness_nouns() {
    char *s = calloc(10);
    if (crc32("MCXxQUVcB",9) == 2678860220) strcat(s, "Z");
if (crc32("vMLnWdnNXZ",10) == 3080929133) strcat(s, "l");
if (crc32("YbbpVlYcZ",9) == 3329568964) strcat(s, "A");
if (crc32("DhYlquKySMJRAA",14) == 3517703271) strcat(s, "u");
if (crc32("ZRBQiVq",7) == 2263410754) strcat(s, "m");
if (crc32("UlqaiFnIJsCfoi",14) == 1227502347) strcat(s, "V");
if (crc32("HGCRtIjaq",9) == 1616165983) strcat(s, "p");
if (crc32("zNpeXOkFQfH",11) == 128384594) strcat(s, "i");
if (crc32("BQxnirUzyI",10) == 1759827162) strcat(s, "i");
if (crc32("fidEZTFbgCI",11) == 1359775778) strcat(s, "n");
if (crc32("FixXAJONYPNvYA",14) == 2371346236) strcat(s, "e");
if (crc32("kszdaRHAr",9) == 757822581) strcat(s, "s");
if (crc32("kVrHtEpMi",9) == 85631269) strcat(s, "t");
if (crc32("PuBWGeduXknqg",13) == 719986931) strcat(s, "s");
    return s;
}

char *coloratura_nouns() {
    char *s = calloc(11);
    if (crc32("HjziUPemuldIvl",14) == 2347947353) strcat(s, "t");
if (crc32("DdCUju",6) == 353510722) strcat(s, "c");
if (crc32("EpJxbUnOSQuizdI",15) == 2815023118) strcat(s, "o");
if (crc32("iZVVlkrShKspZDD",15) == 2528892259) strcat(s, "l");
if (crc32("dxqEl",5) == 2552380087) strcat(s, "o");
if (crc32("vUlwtIu",7) == 3062960177) strcat(s, "r");
if (crc32("ejqwWYDlhpF",11) == 716730319) strcat(s, "a");
if (crc32("NMaNvtxaNICRib",14) == 842235606) strcat(s, "N");
if (crc32("tkJwEzwuahbV",12) == 752595677) strcat(s, "t");
if (crc32("MWLpHJcoQtXQ",12) == 3687475528) strcat(s, "L");
if (crc32("UovODUq",7) == 932918338) strcat(s, "u");
if (crc32("vDhJEgFpJpVV",12) == 608177857) strcat(s, "b");
if (crc32("ynNTV",5) == 3485612488) strcat(s, "r");
if (crc32("uHeoGIBIkuhVYBK",15) == 2195360844) strcat(s, "Y");
if (crc32("PuNgNkTb",8) == 3526787209) strcat(s, "a");
    return s;
}

char *Acalia_nouns() {
    char *s = calloc(7);
    if (crc32("ekINqKcU",8) == 1100082402) strcat(s, "A");
if (crc32("pbLhE",5) == 2093811790) strcat(s, "c");
if (crc32("wySKqXtLMOGKl",13) == 1452469363) strcat(s, "n");
if (crc32("JkBeeUipXp",10) == 2657152607) strcat(s, "a");
if (crc32("SBmxHbH",7) == 1403887683) strcat(s, "l");
if (crc32("leJBtmaZbt",10) == 1181714749) strcat(s, "i");
if (crc32("udzVTjSNBoH",11) == 1506526388) strcat(s, "a");
    return s;
}

char *optimum_nouns() {
    char *s = calloc(8);
    if (crc32("jYyuRNquhVL",11) == 3617204724) strcat(s, "M");
if (crc32("BhICgaVmdDVQ",12) == 3085624264) strcat(s, "o");
if (crc32("xFDgDpaX",8) == 3678851634) strcat(s, "p");
if (crc32("dVrYXOxLbHr",11) == 2416982102) strcat(s, "t");
if (crc32("LuWKaywDxKz",11) == 141377501) strcat(s, "H");
if (crc32("axGHWnbFY",9) == 504251884) strcat(s, "i");
if (crc32("ZOapKtZtCLIC",12) == 3581351356) strcat(s, "m");
if (crc32("lHlfUViTvDNO",12) == 3495031292) strcat(s, "u");
if (crc32("WHiLyWG",7) == 1177130786) strcat(s, "m");
if (crc32("YMDseWTmP",9) == 1612126190) strcat(s, "m");
    return s;
}

char *crookesite_nouns() {
    char *s = calloc(11);
    if (crc32("FTmuvsjCFnzywbj",15) == 242114458) strcat(s, "w");
if (crc32("KwYGmFkpScf",11) == 1167377163) strcat(s, "c");
if (crc32("WagKXuthRT",10) == 4169468620) strcat(s, "r");
if (crc32("XbCwRLLRu",9) == 3807991611) strcat(s, "h");
if (crc32("UJwJGWRqPkb",11) == 2400687000) strcat(s, "o");
if (crc32("KxHKgB",6) == 2382249773) strcat(s, "o");
if (crc32("KsAAATmRSVy",11) == 4224298669) strcat(s, "i");
if (crc32("eHhCjaB",7) == 645843918) strcat(s, "k");
if (crc32("qEbAME",6) == 2639208220) strcat(s, "r");
if (crc32("IfZfG",5) == 934860430) strcat(s, "e");
if (crc32("OQUFWuT",7) == 1455867252) strcat(s, "F");
if (crc32("Qrolqqvt",8) == 2323932219) strcat(s, "s");
if (crc32("pnVGb",5) == 2428247126) strcat(s, "i");
if (crc32("jyONdSscyceeS",13) == 3080406110) strcat(s, "t");
if (crc32("LtvJuB",6) == 1019836386) strcat(s, "e");
    return s;
}

char *memorialization_nouns() {
    char *s = calloc(16);
    if (crc32("HrMNlNp",7) == 351505823) strcat(s, "s");
if (crc32("xHiakiYNp",9) == 2144502191) strcat(s, "m");
if (crc32("zBkThrZI",8) == 928581390) strcat(s, "T");
if (crc32("lnqAACO",7) == 1223804626) strcat(s, "e");
if (crc32("EXOgItQuo",9) == 3867797700) strcat(s, "x");
if (crc32("XVTgqjYXO",9) == 434421693) strcat(s, "m");
if (crc32("zhtXL",5) == 3007456526) strcat(s, "J");
if (crc32("fRpUFyg",7) == 1752291124) strcat(s, "o");
if (crc32("QXlNCq",6) == 2312195046) strcat(s, "r");
if (crc32("mYgNbqL",7) == 3167355629) strcat(s, "U");
if (crc32("rKJybxqXlZiTKQ",14) == 511918492) strcat(s, "i");
if (crc32("JcGbVUiVylv",11) == 3050030643) strcat(s, "l");
if (crc32("YticIXPgHEPagv",14) == 2360241125) strcat(s, "a");
if (crc32("tkxuYPizNZFXb",13) == 2709678386) strcat(s, "l");
if (crc32("skJAWncOcwBci",13) == 3155561407) strcat(s, "U");
if (crc32("MnATUDSzFe",10) == 3302483668) strcat(s, "i");
if (crc32("FRKyIeguCOEVXl",14) == 1952395749) strcat(s, "z");
if (crc32("vOtaIpo",7) == 452492987) strcat(s, "K");
if (crc32("IvYzV",5) == 3911205607) strcat(s, "a");
if (crc32("wxJkuiT",7) == 1106084191) strcat(s, "K");
if (crc32("vNgkFZZwMI",10) == 1231655925) strcat(s, "t");
if (crc32("GYGitXeqKLLBqJ",14) == 182668692) strcat(s, "i");
if (crc32("fzhjFHd",7) == 604123859) strcat(s, "o");
if (crc32("QeVxURirykvrqKy",15) == 1703009890) strcat(s, "F");
if (crc32("fvOiFAsEbZZF",12) == 177742977) strcat(s, "n");
    return s;
}

char *adulator_nouns() {
    char *s = calloc(9);
    if (crc32("mHjgHLMasvHi",12) == 337358220) strcat(s, "a");
if (crc32("KObWBRizcNyiOBh",15) == 3408397386) strcat(s, "d");
if (crc32("gsfWhVY",7) == 2800873110) strcat(s, "u");
if (crc32("hRQWDpQvWECla",13) == 2285857236) strcat(s, "P");
if (crc32("vlbomjcya",9) == 3164584405) strcat(s, "l");
if (crc32("AoPAYbVGBwbx",12) == 4137074171) strcat(s, "i");
if (crc32("rwlBPbO",7) == 1081561707) strcat(s, "a");
if (crc32("AmSkT",5) == 3993509458) strcat(s, "t");
if (crc32("fSeSNAD",7) == 1140133410) strcat(s, "g");
if (crc32("UhLdWAMMeml",11) == 4252629478) strcat(s, "o");
if (crc32("QoPngQrNz",9) == 1245507868) strcat(s, "r");
    return s;
}

char *Augier_nouns() {
    char *s = calloc(7);
    if (crc32("TLyVOOs",7) == 3991122876) strcat(s, "A");
if (crc32("fhJAS",5) == 666403519) strcat(s, "E");
if (crc32("ByZKb",5) == 591146750) strcat(s, "u");
if (crc32("FtqskUQnOJBgpm",14) == 70725474) strcat(s, "s");
if (crc32("WKvDgfozQ",9) == 550777920) strcat(s, "g");
if (crc32("CucFb",5) == 3399358628) strcat(s, "i");
if (crc32("sLwJij",6) == 868918047) strcat(s, "e");
if (crc32("VUeUDnUwKK",10) == 2828572968) strcat(s, "r");
if (crc32("zNflu",5) == 2885039863) strcat(s, "r");
    return s;
}

char *calyces_nouns() {
    char *s = calloc(8);
    if (crc32("SWRrgqSSSfnruj",14) == 2056947670) strcat(s, "c");
if (crc32("UrXssy",6) == 3863234055) strcat(s, "P");
if (crc32("aOYFklTqFIsZaw",14) == 3948708487) strcat(s, "a");
if (crc32("aRmtvAD",7) == 11765691) strcat(s, "I");
if (crc32("EAMVZKlQOyjFE",13) == 2630411830) strcat(s, "l");
if (crc32("CBxhWJvwjLMZ",12) == 2051673371) strcat(s, "y");
if (crc32("SPOiegg",7) == 2820953058) strcat(s, "c");
if (crc32("akUspWoSHp",10) == 668267202) strcat(s, "e");
if (crc32("pcCUXQNNakriKd",14) == 3541570706) strcat(s, "s");
    return s;
}

char *Katushka_nouns() {
    char *s = calloc(9);
    if (crc32("gYdzyzut",8) == 1664570763) strcat(s, "K");
if (crc32("PzSvfXm",7) == 685518622) strcat(s, "a");
if (crc32("lyYmcKfHClCI",12) == 2310085008) strcat(s, "t");
if (crc32("IsNjRykHsb",10) == 1429226559) strcat(s, "P");
if (crc32("rNGLoTyboNSs",12) == 588212542) strcat(s, "u");
if (crc32("nGDnyYpd",8) == 2208203231) strcat(s, "s");
if (crc32("jOAKoFLAzI",10) == 3439948611) strcat(s, "i");
if (crc32("hXkpXtapNtE",11) == 556806533) strcat(s, "h");
if (crc32("OyewZn",6) == 202775489) strcat(s, "k");
if (crc32("jwkvDjcDbYwrbQn",15) == 3371533283) strcat(s, "a");
    return s;
}

char *Elysium_nouns() {
    char *s = calloc(8);
    if (crc32("Cugne",5) == 722369536) strcat(s, "K");
if (crc32("RRuATmSTeH",10) == 540950455) strcat(s, "E");
if (crc32("cMfPBJNTYF",10) == 96170082) strcat(s, "z");
if (crc32("GgqAgcLUmW",10) == 1893900061) strcat(s, "l");
if (crc32("hYDsqLcapbgA",12) == 3998939338) strcat(s, "z");
if (crc32("dijFMkDALvp",11) == 420694693) strcat(s, "y");
if (crc32("hriLEhgItDZ",11) == 3061175586) strcat(s, "o");
if (crc32("uHzyhxNmUXmvD",13) == 114307963) strcat(s, "s");
if (crc32("XAnbLtcpVXOh",12) == 1111071268) strcat(s, "i");
if (crc32("bVhDsUijAOAjBS",14) == 3490935515) strcat(s, "u");
if (crc32("cgTTkzhnsSBnfE",14) == 2245017418) strcat(s, "m");
    return s;
}

char *Claxton_nouns() {
    char *s = calloc(8);
    if (crc32("dyzbWVHjeOSG",12) == 2140019304) strcat(s, "I");
if (crc32("WaPhWTxAa",9) == 1818255864) strcat(s, "C");
if (crc32("XGTQh",5) == 366252202) strcat(s, "H");
if (crc32("bYMqAKXNtCZ",11) == 2654997775) strcat(s, "l");
if (crc32("WdSXL",5) == 2841205716) strcat(s, "B");
if (crc32("iFXUJLZJjXvoJgT",15) == 2744032308) strcat(s, "a");
if (crc32("pgBFQqLAvGbhuTc",15) == 2682860157) strcat(s, "x");
if (crc32("eNEeveO",7) == 2046751381) strcat(s, "f");
if (crc32("AMUODLTUsNsQhtb",15) == 1603771852) strcat(s, "t");
if (crc32("BFIRKWTSDSyhIV",14) == 2925263419) strcat(s, "R");
if (crc32("ExuSVMJCLwBWBrG",15) == 1804366662) strcat(s, "o");
if (crc32("etbbN",5) == 4266738199) strcat(s, "n");
    return s;
}

char *Chelons_nouns() {
    char *s = calloc(8);
    if (crc32("TVOJY",5) == 2547360464) strcat(s, "r");
if (crc32("LhNxdYscQDVaY",13) == 1759429635) strcat(s, "C");
if (crc32("iowkMSH",7) == 3454752375) strcat(s, "g");
if (crc32("TsIkZUd",7) == 2461827257) strcat(s, "h");
if (crc32("AHIUrnnhBK",10) == 2137129101) strcat(s, "J");
if (crc32("jLgbfxNEUyM",11) == 793737288) strcat(s, "e");
if (crc32("ddDve",5) == 2345338067) strcat(s, "x");
if (crc32("boShhcty",8) == 2143542665) strcat(s, "l");
if (crc32("xVEHtRr",7) == 1959127240) strcat(s, "Z");
if (crc32("kPzwlyrxd",9) == 2208290262) strcat(s, "o");
if (crc32("oEUEMxzPTpq",11) == 2612040045) strcat(s, "r");
if (crc32("FGeHNfyj",8) == 1607270640) strcat(s, "n");
if (crc32("GqjTNLZrcPwY",12) == 1336194608) strcat(s, "s");
    return s;
}

char *cutthroat_nouns() {
    char *s = calloc(10);
    if (crc32("jiZnGNudvXlwKZB",15) == 3528207423) strcat(s, "c");
if (crc32("ungKPw",6) == 1657528493) strcat(s, "u");
if (crc32("ODdUMhMrZAUNH",13) == 2075684424) strcat(s, "t");
if (crc32("YeqPSxp",7) == 2780707077) strcat(s, "t");
if (crc32("FmiplSSSjevGNmP",15) == 4157648391) strcat(s, "h");
if (crc32("UmnpjyoWqrQBr",13) == 623477406) strcat(s, "B");
if (crc32("lOXNIE",6) == 1206347726) strcat(s, "r");
if (crc32("MFdafimp",8) == 3717178603) strcat(s, "Z");
if (crc32("uKBFuqYP",8) == 1534952112) strcat(s, "o");
if (crc32("rqGnPxr",7) == 580782383) strcat(s, "a");
if (crc32("sxEwAFcao",9) == 1585132244) strcat(s, "k");
if (crc32("wmIUVqSffXxYgAG",15) == 15523203) strcat(s, "t");
    return s;
}

char *Monica_nouns() {
    char *s = calloc(7);
    if (crc32("AErGXuGxZF",10) == 1159319456) strcat(s, "D");
if (crc32("EZCdqTDcSU",10) == 2098422802) strcat(s, "M");
if (crc32("pgaOeDZsLH",10) == 1565566674) strcat(s, "L");
if (crc32("xhFgS",5) == 1574670243) strcat(s, "o");
if (crc32("XAuDwn",6) == 3582626844) strcat(s, "n");
if (crc32("pMyIpJKR",8) == 364524269) strcat(s, "i");
if (crc32("WqtyHaHxcGo",11) == 1505002659) strcat(s, "p");
if (crc32("nzWbfXcvhKtosUq",15) == 3918343269) strcat(s, "c");
if (crc32("CXVEJpJit",9) == 3030416774) strcat(s, "C");
if (crc32("udbJXyelDNi",11) == 3338946916) strcat(s, "a");
    return s;
}

char *tutenag_nouns() {
    char *s = calloc(8);
    if (crc32("jhldcguehUvJaV",14) == 4043037216) strcat(s, "t");
if (crc32("yduwZ",5) == 306508230) strcat(s, "R");
if (crc32("sPTaZlRBdnerAeK",15) == 2933178090) strcat(s, "u");
if (crc32("HTtcWivPmyCiyra",15) == 2160198828) strcat(s, "t");
if (crc32("xOxGvwlRpapA",12) == 819975531) strcat(s, "Y");
if (crc32("AxpLuMPkjCDtgC",14) == 3256051497) strcat(s, "e");
if (crc32("WWHDwJqGd",9) == 1400589256) strcat(s, "n");
if (crc32("DGrCiHvMD",9) == 2523211114) strcat(s, "U");
if (crc32("WRtkMMyaI",9) == 2096507678) strcat(s, "a");
if (crc32("SwdRDQ",6) == 62514122) strcat(s, "C");
if (crc32("xHiIbcSGqS",10) == 2397853443) strcat(s, "g");
    return s;
}

char *subcommissary_nouns() {
    char *s = calloc(14);
    if (crc32("bTAUdofDG",9) == 3301931073) strcat(s, "s");
if (crc32("ezoZCIIZUv",10) == 437610964) strcat(s, "u");
if (crc32("xkhowC",6) == 4108196507) strcat(s, "r");
if (crc32("KqwxhXWhWwus",12) == 1840995176) strcat(s, "b");
if (crc32("EbCDQuYkeCwF",12) == 2468488903) strcat(s, "N");
if (crc32("nnofwlwQGW",10) == 3270290249) strcat(s, "c");
if (crc32("WyNxxh",6) == 2991612578) strcat(s, "Z");
if (crc32("psafURTtt",9) == 559997495) strcat(s, "o");
if (crc32("cbWDUrrauh",10) == 4257673697) strcat(s, "n");
if (crc32("FvgVqwAr",8) == 1922966499) strcat(s, "m");
if (crc32("NhRgCi",6) == 4000590213) strcat(s, "m");
if (crc32("hYvMxqPFKfm",11) == 1180730486) strcat(s, "I");
if (crc32("scFBGpNMv",9) == 324126348) strcat(s, "i");
if (crc32("llSrmYpDEiAZsr",14) == 3291663756) strcat(s, "M");
if (crc32("SgYsciSdBaBWiG",14) == 3014152819) strcat(s, "s");
if (crc32("EeqOHgoMMLgJBBP",15) == 896613448) strcat(s, "s");
if (crc32("CmPLSnOgpOy",11) == 211263254) strcat(s, "f");
if (crc32("yKYTWYXVr",9) == 3823083303) strcat(s, "a");
if (crc32("vwhxFok",7) == 4180228411) strcat(s, "s");
if (crc32("pLgtQtldRXycXpp",15) == 3526950264) strcat(s, "r");
if (crc32("EUJQHRZfUcNGn",13) == 4096313120) strcat(s, "y");
    return s;
}

char *modeller_nouns() {
    char *s = calloc(9);
    if (crc32("dNCOAcu",7) == 3562455455) strcat(s, "O");
if (crc32("RjYpTdKYnqQdWO",14) == 3606202200) strcat(s, "m");
if (crc32("WHEMZyMma",9) == 1502068974) strcat(s, "o");
if (crc32("OGcsxbDangfeu",13) == 4194664730) strcat(s, "f");
if (crc32("mtamiBIUTUis",12) == 2271593308) strcat(s, "d");
if (crc32("UoiPv",5) == 1968799147) strcat(s, "L");
if (crc32("ZquCwwBbvpu",11) == 652449444) strcat(s, "e");
if (crc32("YggJHHDKIwmTMx",14) == 2706172941) strcat(s, "s");
if (crc32("HaHfe",5) == 1573777789) strcat(s, "l");
if (crc32("YsrNFdP",7) == 1084464881) strcat(s, "l");
if (crc32("SKtePnxOXyIsNj",14) == 1362119140) strcat(s, "e");
if (crc32("ScwLsANouPodRTB",15) == 1415991894) strcat(s, "n");
if (crc32("hqJuIQX",7) == 313659458) strcat(s, "r");
    return s;
}

char *Jillayne_nouns() {
    char *s = calloc(9);
    if (crc32("AmAHlq",6) == 2802798007) strcat(s, "J");
if (crc32("NPkxqYKivOlAJ",13) == 847111793) strcat(s, "k");
if (crc32("EmdVFTIlNsUlZ",13) == 698743571) strcat(s, "i");
if (crc32("vMQaaxevbzVemJV",15) == 2943930852) strcat(s, "l");
if (crc32("EbKcpjEyz",9) == 3181071177) strcat(s, "l");
if (crc32("SXZJSLJd",8) == 1231063316) strcat(s, "C");
if (crc32("fZNmhtn",7) == 1359818483) strcat(s, "a");
if (crc32("WndVnWwfR",9) == 4265119563) strcat(s, "c");
if (crc32("HCGqpaGx",8) == 4288330553) strcat(s, "y");
if (crc32("hMROCsbvx",9) == 2343163832) strcat(s, "K");
if (crc32("ftLVZjI",7) == 1743117631) strcat(s, "n");
if (crc32("oJQJBbyqU",9) == 3993712381) strcat(s, "y");
if (crc32("XKUroXxq",8) == 3149010555) strcat(s, "e");
    return s;
}

char *overfancifulness_nouns() {
    char *s = calloc(17);
    if (crc32("PPuwuD",6) == 3859131404) strcat(s, "Y");
if (crc32("oNivig",6) == 3726144122) strcat(s, "o");
if (crc32("EqErhPUi",8) == 1141934926) strcat(s, "m");
if (crc32("rSgYXocFBIOv",12) == 2634887005) strcat(s, "v");
if (crc32("eGLrmlFKGhVpT",13) == 567812986) strcat(s, "e");
if (crc32("aXnsayYgcLudBV",14) == 1235019295) strcat(s, "F");
if (crc32("HJPqkN",6) == 3386489460) strcat(s, "r");
if (crc32("VJTQRIgzLy",10) == 3604312246) strcat(s, "f");
if (crc32("GznNygxAnKlNfb",14) == 2364084454) strcat(s, "j");
if (crc32("KSBPpYcNtkmV",12) == 2992614486) strcat(s, "a");
if (crc32("qQVqBSbsKV",10) == 1682625780) strcat(s, "d");
if (crc32("MnDWi",5) == 197123238) strcat(s, "n");
if (crc32("UbhzOpuHgA",10) == 3189218544) strcat(s, "x");
if (crc32("LdpiqxmiTo",10) == 1353812436) strcat(s, "c");
if (crc32("LfaAyd",6) == 418621669) strcat(s, "I");
if (crc32("xoHoOAuv",8) == 3322017787) strcat(s, "i");
if (crc32("PiTxHAUu",8) == 3100409841) strcat(s, "f");
if (crc32("PfbrGZmqaLXlV",13) == 315639140) strcat(s, "R");
if (crc32("FvaBZOdlkD",10) == 1237704775) strcat(s, "u");
if (crc32("QLjoMIwXcxrXBIv",15) == 1379344698) strcat(s, "I");
if (crc32("AVsuvOAFjp",10) == 2420459668) strcat(s, "l");
if (crc32("gFnbZ",5) == 2353470104) strcat(s, "U");
if (crc32("kSIkgUgFEW",10) == 1909724445) strcat(s, "n");
if (crc32("ajabHKEGyeAbLKO",15) == 2171030360) strcat(s, "e");
if (crc32("hUTJVDU",7) == 2808735890) strcat(s, "s");
if (crc32("YfNLgykgOW",10) == 2373778381) strcat(s, "V");
if (crc32("jlOdeXTLTDQv",12) == 643250479) strcat(s, "s");
    return s;
}

char *Dhaulagiri_nouns() {
    char *s = calloc(11);
    if (crc32("JdtwSCoyvhsiC",13) == 3252641054) strcat(s, "D");
if (crc32("Stihkem",7) == 442044309) strcat(s, "h");
if (crc32("fkaWyr",6) == 1013119091) strcat(s, "u");
if (crc32("jIhFdBLXnVIgRok",15) == 4160036465) strcat(s, "a");
if (crc32("seaFC",5) == 1951085453) strcat(s, "u");
if (crc32("dRddP",5) == 1854377784) strcat(s, "g");
if (crc32("URoGgYBiYb",10) == 4133003586) strcat(s, "l");
if (crc32("pVxzJripJADLC",13) == 3898374432) strcat(s, "p");
if (crc32("FradVfowfzZCBih",15) == 2563386731) strcat(s, "a");
if (crc32("lqUsUk",6) == 3180240805) strcat(s, "g");
if (crc32("JvWbTKOgkK",10) == 4222975568) strcat(s, "i");
if (crc32("xxcTFyUklcI",11) == 2665322689) strcat(s, "l");
if (crc32("VABWbHhsctZ",11) == 2162527257) strcat(s, "r");
if (crc32("ydqqCwUYrQNW",12) == 2087381149) strcat(s, "J");
if (crc32("TULcZjBH",8) == 940795610) strcat(s, "i");
    return s;
}

char *Coalinga_nouns() {
    char *s = calloc(9);
    if (crc32("dQbKHbV",7) == 569030231) strcat(s, "C");
if (crc32("mriuPdIcCKoQFH",14) == 1214098789) strcat(s, "o");
if (crc32("echPq",5) == 2328634050) strcat(s, "r");
if (crc32("FkOfcwaQa",9) == 1385443949) strcat(s, "a");
if (crc32("wZYXiywrlsZCf",13) == 2694034166) strcat(s, "l");
if (crc32("WzGwKXIHzGB",11) == 4200815676) strcat(s, "I");
if (crc32("IGhLyH",6) == 1924062731) strcat(s, "i");
if (crc32("jxrBfTUU",8) == 2822290825) strcat(s, "K");
if (crc32("nZHrjAncdapbCx",14) == 3620468386) strcat(s, "n");
if (crc32("oqikoHDDtG",10) == 1969143951) strcat(s, "f");
if (crc32("qHawvDUyskKGotW",15) == 4173068647) strcat(s, "g");
if (crc32("poJEEXGyIrfee",13) == 3330324641) strcat(s, "R");
if (crc32("gvutuzs",7) == 2509177084) strcat(s, "a");
    return s;
}

char *anguish_nouns() {
    char *s = calloc(8);
    if (crc32("GOUPwuhdVwieM",13) == 1888780502) strcat(s, "a");
if (crc32("HiFfJkglS",9) == 1028090767) strcat(s, "n");
if (crc32("ZbJNguwQrUKcRp",14) == 128138283) strcat(s, "k");
if (crc32("eVzvzUGPg",9) == 2782822057) strcat(s, "g");
if (crc32("PohuOljSOvQqZDU",15) == 2690816967) strcat(s, "u");
if (crc32("KSYjIQXniWHy",12) == 1461775980) strcat(s, "l");
if (crc32("TjbxBivtwlMa",12) == 71463602) strcat(s, "i");
if (crc32("ImGbar",6) == 2001370311) strcat(s, "s");
if (crc32("VwBZahBK",8) == 1666482894) strcat(s, "M");
if (crc32("gvEYhKoAcTDsp",13) == 3327284480) strcat(s, "h");
    return s;
}

char *Toul_nouns() {
    char *s = calloc(5);
    if (crc32("HJkqUHKJsf",10) == 1908552693) strcat(s, "M");
if (crc32("thERfUQ",7) == 117557632) strcat(s, "T");
if (crc32("CqAUldukdRoKa",13) == 2914483202) strcat(s, "o");
if (crc32("ZXZKIFOO",8) == 809581680) strcat(s, "u");
if (crc32("TqMPPNPH",8) == 436680176) strcat(s, "e");
if (crc32("rRClRBAIin",10) == 2268397775) strcat(s, "l");
    return s;
}

char *villa_nouns() {
    char *s = calloc(6);
    if (crc32("vJFiQyUiJrTde",13) == 3931972903) strcat(s, "p");
if (crc32("NZYfskAKYib",11) == 1797363162) strcat(s, "v");
if (crc32("ocLaQnvO",8) == 2759959408) strcat(s, "i");
if (crc32("QjsxDfpBLL",10) == 1941870009) strcat(s, "S");
if (crc32("DbjXA",5) == 3431456432) strcat(s, "l");
if (crc32("pJMee",5) == 2521414445) strcat(s, "l");
if (crc32("VdrbpFXj",8) == 2406511339) strcat(s, "h");
if (crc32("MHXfvOTAz",9) == 2061066047) strcat(s, "a");
    return s;
}

char *catastrophist_nouns() {
    char *s = calloc(14);
    if (crc32("lPGmNxIxwZ",10) == 639534490) strcat(s, "i");
if (crc32("Puuvw",5) == 1206843436) strcat(s, "c");
if (crc32("sqmnXDX",7) == 2848183471) strcat(s, "a");
if (crc32("rVhRrAODhbSMxB",14) == 1037333459) strcat(s, "z");
if (crc32("rptCFdiOENuJBN",14) == 771082974) strcat(s, "t");
if (crc32("nGXESzRyMI",10) == 1328307819) strcat(s, "a");
if (crc32("xRpMQ",5) == 1674486592) strcat(s, "s");
if (crc32("anxRWKl",7) == 1705210271) strcat(s, "F");
if (crc32("bmIaHTaCfi",10) == 1487934327) strcat(s, "t");
if (crc32("tbIoJHmECjGl",12) == 1766412816) strcat(s, "r");
if (crc32("hwadKpBEupPsV",13) == 2788560712) strcat(s, "j");
if (crc32("icJVmXz",7) == 1941613607) strcat(s, "o");
if (crc32("KHNNhxStA",9) == 1114365174) strcat(s, "p");
if (crc32("RXWjvENQwoJv",12) == 4198631749) strcat(s, "I");
if (crc32("KPrlEAZW",8) == 1088544914) strcat(s, "h");
if (crc32("hxEFdQKZZoPBvn",14) == 579245207) strcat(s, "V");
if (crc32("JQEKjU",6) == 1315209898) strcat(s, "i");
if (crc32("dwZrvRuLGTqavbc",15) == 2255527433) strcat(s, "s");
if (crc32("iEyEEImSoKt",11) == 2229326222) strcat(s, "t");
    return s;
}

char *flint_nouns() {
    char *s = calloc(6);
    if (crc32("dcdGnvpXXCkLjmu",15) == 54769564) strcat(s, "X");
if (crc32("OYBwYhwStFU",11) == 331182843) strcat(s, "f");
if (crc32("bGZwkCKWDGpHK",13) == 4046510781) strcat(s, "h");
if (crc32("fuQUnvUAyS",10) == 2824736320) strcat(s, "l");
if (crc32("FtnKCWZI",8) == 3588378686) strcat(s, "a");
if (crc32("ljMAERbSzo",10) == 1538681827) strcat(s, "i");
if (crc32("vSmNGVgl",8) == 1321446509) strcat(s, "n");
if (crc32("boUdRQEBgKZVdY",14) == 1577775770) strcat(s, "t");
    return s;
}

char *Mauceri_nouns() {
    char *s = calloc(8);
    if (crc32("UqpoGlnqG",9) == 65863048) strcat(s, "U");
if (crc32("VmpJYkABLxlXbt",14) == 1481669921) strcat(s, "M");
if (crc32("YsouDMmHXUEPQc",14) == 1174280024) strcat(s, "V");
if (crc32("GhGBrbgff",9) == 1411086384) strcat(s, "a");
if (crc32("HwIkhi",6) == 2398834239) strcat(s, "f");
if (crc32("eVCypogQa",9) == 1952513549) strcat(s, "u");
if (crc32("XUEGFHqPYzDMk",13) == 2736615203) strcat(s, "k");
if (crc32("FUizWANujJrlSA",14) == 1861218620) strcat(s, "c");
if (crc32("JUEhTWnwEA",10) == 2420988084) strcat(s, "e");
if (crc32("TwozqMMgF",9) == 3639132223) strcat(s, "r");
if (crc32("hwZUdKzzqCdTte",14) == 4043921666) strcat(s, "i");
    return s;
}

char *polybutene_nouns() {
    char *s = calloc(11);
    if (crc32("ekrtgin",7) == 802796576) strcat(s, "P");
if (crc32("JZfMQ",5) == 1697693579) strcat(s, "p");
if (crc32("acYDKBjl",8) == 2714936910) strcat(s, "o");
if (crc32("mvnMQQA",7) == 705629407) strcat(s, "l");
if (crc32("NDNbluplsoTcox",14) == 1115636448) strcat(s, "y");
if (crc32("gQMgiPGpec",10) == 452467272) strcat(s, "Z");
if (crc32("YYXxoOPaGQvIkS",14) == 2736123897) strcat(s, "b");
if (crc32("NukuYrSKG",9) == 2806890523) strcat(s, "u");
if (crc32("AnzsG",5) == 3447985492) strcat(s, "t");
if (crc32("gvoAsUSwebe",11) == 2739249275) strcat(s, "e");
if (crc32("yImpJFuXd",9) == 2871199661) strcat(s, "n");
if (crc32("ncHjAltWznDoN",13) == 2880352344) strcat(s, "e");
if (crc32("gGYFL",5) == 1373097155) strcat(s, "e");
    return s;
}

char *selftaxation_nouns() {
    char *s = calloc(13);
    if (crc32("QphaarNyLh",10) == 348405864) strcat(s, "s");
if (crc32("CbTQBijBfLsxhLl",15) == 3038498658) strcat(s, "V");
if (crc32("KnDgSZrH",8) == 2820279473) strcat(s, "e");
if (crc32("ypphXDOT",8) == 4210585794) strcat(s, "l");
if (crc32("MktoOpAGsTokPM",14) == 69197840) strcat(s, "f");
if (crc32("VxNXwInpMAgPI",13) == 254977693) strcat(s, "c");
if (crc32("aItfMIaMN",9) == 2257598327) strcat(s, "t");
if (crc32("ynTRBLFB",8) == 2920585229) strcat(s, "a");
if (crc32("WijHCfDlkCij",12) == 3153894691) strcat(s, "x");
if (crc32("OHQMGVzUCAeuJo",14) == 3478071831) strcat(s, "a");
if (crc32("xOIMxqaA",8) == 1654229210) strcat(s, "e");
if (crc32("uizGPuvVqNTiAsY",15) == 4025533697) strcat(s, "t");
if (crc32("LLUWMSJjx",9) == 98665409) strcat(s, "i");
if (crc32("LxkoJgjUaslegC",14) == 3337613751) strcat(s, "o");
if (crc32("tCIer",5) == 1597374344) strcat(s, "v");
if (crc32("xIiFbkDYSQF",11) == 1702024712) strcat(s, "n");
    return s;
}

char *Larimore_nouns() {
    char *s = calloc(9);
    if (crc32("UHhMkAoLroatmwq",15) == 3629975762) strcat(s, "L");
if (crc32("yWZNefTDlrl",11) == 2823648955) strcat(s, "a");
if (crc32("wexpijjAw",9) == 2627686806) strcat(s, "r");
if (crc32("aUtIIGMSHtoR",12) == 1561054886) strcat(s, "i");
if (crc32("YVnPaATbgdieOkH",15) == 3478802643) strcat(s, "P");
if (crc32("sEOVfb",6) == 2537217993) strcat(s, "m");
if (crc32("YEEXZsyPyQfyLKK",15) == 3767327369) strcat(s, "s");
if (crc32("BmpNkesDTGCzT",13) == 354903945) strcat(s, "o");
if (crc32("jbfLKjC",7) == 85106833) strcat(s, "S");
if (crc32("PWeedVsEMRI",11) == 2388128432) strcat(s, "r");
if (crc32("yFbEhyS",7) == 1676314494) strcat(s, "x");
if (crc32("tEvXnPM",7) == 1382679784) strcat(s, "e");
    return s;
}

char *G_nouns() {
    char *s = calloc(2);
    if (crc32("DAfEoMRLuEElg",13) == 245367736) strcat(s, "P");
if (crc32("WYMSs",5) == 3670840428) strcat(s, "G");
    return s;
}

char *rhodochrosite_nouns() {
    char *s = calloc(14);
    if (crc32("WQmTcEFudMor",12) == 2980940357) strcat(s, "r");
if (crc32("kkcit",5) == 1830932977) strcat(s, "h");
if (crc32("sKZsHLAwZyYHrH",14) == 555432950) strcat(s, "o");
if (crc32("jsACPLym",8) == 1571681952) strcat(s, "d");
if (crc32("EKHDSOO",7) == 1360416755) strcat(s, "z");
if (crc32("seRZqvo",7) == 267212946) strcat(s, "o");
if (crc32("KsIjenBmHJ",10) == 4025397525) strcat(s, "T");
if (crc32("buvqoNyRbJ",10) == 169907949) strcat(s, "c");
if (crc32("Qwiqq",5) == 2881966680) strcat(s, "T");
if (crc32("dXAlTbI",7) == 626356781) strcat(s, "h");
if (crc32("RFgRAFuDSCizMrs",15) == 3791586760) strcat(s, "d");
if (crc32("KGsgXGvZOE",10) == 130785991) strcat(s, "r");
if (crc32("XdoZNwe",7) == 2252595348) strcat(s, "o");
if (crc32("NYgpjpBxhmjrYGE",15) == 1523937545) strcat(s, "B");
if (crc32("pgoOYOKpeCHfi",13) == 2273725495) strcat(s, "s");
if (crc32("msCFpzNHXiNWnCx",15) == 2593005599) strcat(s, "i");
if (crc32("vIjMiFcGYbz",11) == 4272232893) strcat(s, "s");
if (crc32("dVwMIM",6) == 847812947) strcat(s, "t");
if (crc32("gyJSXB",6) == 538100655) strcat(s, "e");
    return s;
}

char *attapulgite_nouns() {
    char *s = calloc(12);
    if (crc32("QOWkRaI",7) == 2617949969) strcat(s, "a");
if (crc32("RQNyWZvDOdSfXs",14) == 4290576851) strcat(s, "x");
if (crc32("mnazNSXOCp",10) == 3013921933) strcat(s, "t");
if (crc32("kPqucTvXlvOrft",14) == 3175878281) strcat(s, "t");
if (crc32("SJVZACKoBaKBkM",14) == 2358728674) strcat(s, "a");
if (crc32("abovzexwlmmJgxk",15) == 2023056939) strcat(s, "p");
if (crc32("PvMvjAANJneY",12) == 2240407298) strcat(s, "u");
if (crc32("cuyKYUgjtc",10) == 2937459399) strcat(s, "X");
if (crc32("ssbtFiAYWTR",11) == 2722181744) strcat(s, "l");
if (crc32("zKxWOBkG",8) == 2835323001) strcat(s, "Y");
if (crc32("xPiDGRyZLwk",11) == 2556679116) strcat(s, "g");
if (crc32("nibKUO",6) == 2365491359) strcat(s, "Q");
if (crc32("jQjQiiHY",8) == 646459173) strcat(s, "i");
if (crc32("uhEMbAUJEsCtTT",14) == 1120521254) strcat(s, "G");
if (crc32("NEZduNISprpKiI",14) == 3411691381) strcat(s, "t");
if (crc32("PPXVbWbCu",9) == 248545065) strcat(s, "e");
    return s;
}

char *selfkindness_nouns() {
    char *s = calloc(13);
    if (crc32("wSqWTVoYP",9) == 726181761) strcat(s, "l");
if (crc32("sMgHdSR",7) == 3719662150) strcat(s, "s");
if (crc32("cGkgKdM",7) == 139447195) strcat(s, "e");
if (crc32("uzzvfq",6) == 420748334) strcat(s, "l");
if (crc32("fxRFICx",7) == 2484527552) strcat(s, "f");
if (crc32("HljWUodsloMHtdC",15) == 1869350121) strcat(s, "S");
if (crc32("XfbGyg",6) == 2394700637) strcat(s, "k");
if (crc32("wMFiiYpQyQzG",12) == 1680255092) strcat(s, "i");
if (crc32("ggFEJHGoHJm",11) == 1585595160) strcat(s, "q");
if (crc32("GASve",5) == 622761810) strcat(s, "n");
if (crc32("GpwpHZWysmMrrlc",15) == 2854485352) strcat(s, "d");
if (crc32("wjMRNv",6) == 3678656323) strcat(s, "M");
if (crc32("ddsIEOIhdnn",11) == 4053579955) strcat(s, "n");
if (crc32("YiwqxQF",7) == 526780609) strcat(s, "K");
if (crc32("uGftZcSXxjBb",12) == 1056994906) strcat(s, "e");
if (crc32("jFLWUmmHDjvEHYZ",15) == 584105318) strcat(s, "p");
if (crc32("OQykwL",6) == 119461436) strcat(s, "s");
if (crc32("MwVTOhmpfCrsWbI",15) == 1906472105) strcat(s, "j");
if (crc32("CJxkUeE",7) == 394429498) strcat(s, "s");
    return s;
}

char *flycatcher_nouns() {
    char *s = calloc(11);
    if (crc32("QLJAuPnGbgcIMBl",15) == 1880268572) strcat(s, "g");
if (crc32("RZOKQ",5) == 1416018209) strcat(s, "f");
if (crc32("JbjYz",5) == 3154314214) strcat(s, "x");
if (crc32("EraKXXhaBpE",11) == 2170752607) strcat(s, "l");
if (crc32("HeMEuGZLpVoxi",13) == 233064136) strcat(s, "L");
if (crc32("aBrtKfPeyFOECmx",15) == 2552568994) strcat(s, "y");
if (crc32("NCRsbmfrpWp",11) == 1783019880) strcat(s, "c");
if (crc32("TVOooXbsai",10) == 98355494) strcat(s, "c");
if (crc32("gynfn",5) == 551802114) strcat(s, "a");
if (crc32("avkvafyIrjGF",12) == 1561567021) strcat(s, "t");
if (crc32("BcxDJJKq",8) == 1139628687) strcat(s, "c");
if (crc32("mNzjsRpAxFnEpe",14) == 4040061363) strcat(s, "S");
if (crc32("ggRTLTMdhCZSnu",14) == 3757748632) strcat(s, "h");
if (crc32("HVMduyHI",8) == 3849450909) strcat(s, "Z");
if (crc32("CsYGNoBXt",9) == 1430982917) strcat(s, "e");
if (crc32("EAGgP",5) == 798211202) strcat(s, "G");
if (crc32("iubPfqeOjiJI",12) == 772891101) strcat(s, "r");
    return s;
}

char *overstimulativeness_nouns() {
    char *s = calloc(20);
    if (crc32("PwXSnUYEDiI",11) == 105916893) strcat(s, "D");
if (crc32("VJHxNnJZEDBYzwh",15) == 2231466308) strcat(s, "o");
if (crc32("LxvfWYMVFq",10) == 180937059) strcat(s, "v");
if (crc32("UCvsDqbkWJeh",12) == 2667325522) strcat(s, "e");
if (crc32("SVYMvWqfggK",11) == 2422135028) strcat(s, "r");
if (crc32("xvIWTVQA",8) == 1900982996) strcat(s, "X");
if (crc32("csVxwWofr",9) == 3577952117) strcat(s, "s");
if (crc32("eLahu",5) == 2188127662) strcat(s, "t");
if (crc32("CrKudaddZNtpQY",14) == 2773370107) strcat(s, "W");
if (crc32("kXiWAitXg",9) == 1621686406) strcat(s, "i");
if (crc32("ulcrlrlKzJpshst",15) == 195589179) strcat(s, "i");
if (crc32("xVNqDLALt",9) == 3963360437) strcat(s, "m");
if (crc32("VXRsq",5) == 1133166476) strcat(s, "W");
if (crc32("PYXlIGgom",9) == 2128623696) strcat(s, "u");
if (crc32("BRTSzTtIz",9) == 1322174853) strcat(s, "N");
if (crc32("XXKGEAlMf",9) == 3999345636) strcat(s, "l");
if (crc32("rwwPsVzurDWxP",13) == 3498694322) strcat(s, "a");
if (crc32("JigQJeoZjxBo",12) == 669242172) strcat(s, "t");
if (crc32("FDUQQCTuHKz",11) == 3860510618) strcat(s, "n");
if (crc32("wPVnqveiRKYb",12) == 2235917218) strcat(s, "i");
if (crc32("iaRQZpHVng",10) == 1564450767) strcat(s, "v");
if (crc32("CAuqPsHNzj",10) == 531553328) strcat(s, "e");
if (crc32("WvYJfGAdyep",11) == 2679786043) strcat(s, "n");
if (crc32("TuDzunPpi",9) == 2866578904) strcat(s, "e");
if (crc32("ytmlLPd",7) == 3986256551) strcat(s, "s");
if (crc32("UEzHaaSTfgkzYoq",15) == 2636308019) strcat(s, "s");
    return s;
}

char *canikin_nouns() {
    char *s = calloc(8);
    if (crc32("lvvYoSDC",8) == 2190783335) strcat(s, "G");
if (crc32("bvrQCUKayLJIlyq",15) == 1873176118) strcat(s, "c");
if (crc32("LPtcrlB",7) == 828862031) strcat(s, "a");
if (crc32("BAieA",5) == 2603071771) strcat(s, "G");
if (crc32("nHsSxNraJKteaLI",15) == 3753126239) strcat(s, "n");
if (crc32("IAnFxVnYHKFqPVv",15) == 1908657088) strcat(s, "h");
if (crc32("KHExhtHZXFxL",12) == 233093173) strcat(s, "i");
if (crc32("FziZxhlGu",9) == 3448736920) strcat(s, "u");
if (crc32("ItnYfC",6) == 4045534476) strcat(s, "k");
if (crc32("aWRYJNfxiXvHWs",14) == 1128831122) strcat(s, "P");
if (crc32("FnNwXWtaJOfmwed",15) == 2234936262) strcat(s, "i");
if (crc32("vNKCPcJhewScEE",14) == 1568861933) strcat(s, "n");
    return s;
}

char *bonytail_nouns() {
    char *s = calloc(9);
    if (crc32("tpNNVhGeauLTS",13) == 594239643) strcat(s, "b");
if (crc32("GDscveZhfemZ",12) == 831001141) strcat(s, "o");
if (crc32("ZuHMWCFuNMgO",12) == 2369366718) strcat(s, "o");
if (crc32("QdpzwXbN",8) == 1778332663) strcat(s, "n");
if (crc32("pDFrnDnpxkZXj",13) == 1298548502) strcat(s, "U");
if (crc32("kaBIvPY",7) == 3945441254) strcat(s, "y");
if (crc32("VVQAJLUIoUAfCH",14) == 695391225) strcat(s, "O");
if (crc32("ntGMWxqqbgW",11) == 473882792) strcat(s, "t");
if (crc32("bspTMZxzZqIa",12) == 2317929420) strcat(s, "a");
if (crc32("CZQeGSo",7) == 436720383) strcat(s, "F");
if (crc32("MjmJZF",6) == 3123487054) strcat(s, "i");
if (crc32("WHGENJJxqGKUjy",14) == 2164681858) strcat(s, "l");
    return s;
}

char *Whiney_nouns() {
    char *s = calloc(7);
    if (crc32("CDJAxI",6) == 4167725708) strcat(s, "W");
if (crc32("BnkGWjHbZUIt",12) == 1649767234) strcat(s, "j");
if (crc32("WTkZEhLP",8) == 543335307) strcat(s, "h");
if (crc32("MoCEcJpNmEWKXSe",15) == 2730616515) strcat(s, "i");
if (crc32("TazAaffXMHKEFt",14) == 3711585687) strcat(s, "e");
if (crc32("MaSkhizFdBGv",12) == 1769479932) strcat(s, "n");
if (crc32("UMuCYzowgG",10) == 1780818104) strcat(s, "e");
if (crc32("IYpNqBiLSFVyKXr",15) == 1884197882) strcat(s, "y");
    return s;
}

char *skewing_nouns() {
    char *s = calloc(8);
    if (crc32("KGSKelc",7) == 2842997644) strcat(s, "s");
if (crc32("tpemSMdIAj",10) == 999475971) strcat(s, "k");
if (crc32("MQtkOztSSAdtbn",14) == 1655843914) strcat(s, "e");
if (crc32("KxBMDFnrofGW",12) == 2510244201) strcat(s, "w");
if (crc32("iBLjLnsmihJW",12) == 1146722194) strcat(s, "r");
if (crc32("sxSgzJkviacKc",13) == 3949867596) strcat(s, "i");
if (crc32("GskxxtKV",8) == 1553834060) strcat(s, "n");
if (crc32("JlpjtgYKvBD",11) == 2993778287) strcat(s, "g");
    return s;
}

char *automaticity_nouns() {
    char *s = calloc(13);
    if (crc32("YMBCyfbTXwu",11) == 1983438911) strcat(s, "a");
if (crc32("UiLGioG",7) == 358728132) strcat(s, "u");
if (crc32("ZbbwabVMLFlH",12) == 2327269551) strcat(s, "t");
if (crc32("cYDnXTZmzKhJcL",14) == 43675178) strcat(s, "o");
if (crc32("XqnIMfiE",8) == 1378860820) strcat(s, "e");
if (crc32("nUsbzHRfAZMcay",14) == 1644628639) strcat(s, "m");
if (crc32("HbzWsrhATVJdOUi",15) == 1545341910) strcat(s, "E");
if (crc32("LqkhkzA",7) == 1581269788) strcat(s, "a");
if (crc32("xHsoyoMqPxTIytj",15) == 2307204641) strcat(s, "t");
if (crc32("uSAZfDeVRkJSV",13) == 455766847) strcat(s, "i");
if (crc32("mVxqEQKk",8) == 1163080395) strcat(s, "c");
if (crc32("gJDAXHPMJbbtJHf",15) == 2279479135) strcat(s, "i");
if (crc32("GvzEsrnacfNEZJ",14) == 2835328401) strcat(s, "k");
if (crc32("Svbsouy",7) == 4031259105) strcat(s, "t");
if (crc32("hRlqVaOyZYQR",12) == 2049247261) strcat(s, "r");
if (crc32("YIqMCa",6) == 2239780550) strcat(s, "y");
    return s;
}

char *Trela_nouns() {
    char *s = calloc(6);
    if (crc32("wwcJyKjfsj",10) == 1870193203) strcat(s, "T");
if (crc32("KABQB",5) == 2193994778) strcat(s, "r");
if (crc32("AVeOSkErIkLjp",13) == 1808755922) strcat(s, "e");
if (crc32("WEUnnmn",7) == 932310156) strcat(s, "l");
if (crc32("uzALdGJBNkZYqCa",15) == 3219460939) strcat(s, "S");
if (crc32("dRnhDUS",7) == 964592887) strcat(s, "a");
    return s;
}

char *shul_nouns() {
    char *s = calloc(5);
    if (crc32("EAGItkw",7) == 1091075608) strcat(s, "L");
if (crc32("ttRODxsGXbjtC",13) == 1451926323) strcat(s, "s");
if (crc32("uqPtSarv",8) == 2389963207) strcat(s, "C");
if (crc32("HGbkPMVpSKl",11) == 4050780662) strcat(s, "h");
if (crc32("wiSwVwdjH",9) == 1342522444) strcat(s, "u");
if (crc32("vnqGJpb",7) == 483667193) strcat(s, "q");
if (crc32("mqxFOTqPmY",10) == 912473607) strcat(s, "l");
    return s;
}

char *overglazed_nouns() {
    char *s = calloc(11);
    if (crc32("PbMkBcgDOj",10) == 1142543186) strcat(s, "J");
if (crc32("JdypxvD",7) == 599390262) strcat(s, "o");
if (crc32("TlUIXUAYIsKMw",13) == 404130275) strcat(s, "R");
if (crc32("CrazHhRk",8) == 2206503608) strcat(s, "v");
if (crc32("zxVhsElzaK",10) == 3118538644) strcat(s, "G");
if (crc32("VNNvNOHiGIZ",11) == 483859301) strcat(s, "e");
if (crc32("kKpxlRzHy",9) == 727460186) strcat(s, "N");
if (crc32("SmzSOZprSXXPhU",14) == 3843853116) strcat(s, "r");
if (crc32("hvHhWzpYbYUJ",12) == 2103677133) strcat(s, "h");
if (crc32("rpHCW",5) == 2128470215) strcat(s, "g");
if (crc32("NSlDaNVWjil",11) == 3866858175) strcat(s, "l");
if (crc32("IlIOhCTwA",9) == 370298641) strcat(s, "a");
if (crc32("YabGn",5) == 786055186) strcat(s, "z");
if (crc32("MCrkWqGaxs",10) == 3155211917) strcat(s, "e");
if (crc32("oSZUtVT",7) == 937893474) strcat(s, "d");
    return s;
}

char *Diwali_nouns() {
    char *s = calloc(7);
    if (crc32("UnCoF",5) == 1459019671) strcat(s, "Q");
if (crc32("EVhyw",5) == 3457141986) strcat(s, "D");
if (crc32("ccISU",5) == 4067148499) strcat(s, "g");
if (crc32("maAOUxLrGCn",11) == 966040999) strcat(s, "i");
if (crc32("IhNKtRWf",8) == 731300994) strcat(s, "w");
if (crc32("oJsthG",6) == 902669990) strcat(s, "a");
if (crc32("qCENmhvU",8) == 2319081465) strcat(s, "B");
if (crc32("XaLwdyaezoSX",12) == 3434671768) strcat(s, "l");
if (crc32("PCsYdVal",8) == 2165648790) strcat(s, "Z");
if (crc32("vsxzlnHtSAfsK",13) == 2382834484) strcat(s, "i");
    return s;
}

char *savour_nouns() {
    char *s = calloc(7);
    if (crc32("VHNtHqT",7) == 3330404407) strcat(s, "V");
if (crc32("mmEHNsJcnMj",11) == 2986888297) strcat(s, "s");
if (crc32("siYQtYu",7) == 2844329129) strcat(s, "M");
if (crc32("twgUY",5) == 2759570643) strcat(s, "a");
if (crc32("BtezqSbcCmJIBel",15) == 51575010) strcat(s, "q");
if (crc32("PxeguAERvjtiJ",13) == 1840361125) strcat(s, "v");
if (crc32("QJhtYutu",8) == 2065899244) strcat(s, "o");
if (crc32("COByaeYeCw",10) == 4197637395) strcat(s, "u");
if (crc32("SWwRRJhMWFlYi",13) == 1558121153) strcat(s, "r");
    return s;
}

char *quieter_nouns() {
    char *s = calloc(8);
    if (crc32("sMWmUyyzdk",10) == 2187365742) strcat(s, "M");
if (crc32("DnMovI",6) == 1603865420) strcat(s, "q");
if (crc32("dQnqDlpQeHEddCz",15) == 3820353787) strcat(s, "Z");
if (crc32("Umyjq",5) == 481102112) strcat(s, "u");
if (crc32("xqLSIwioDYNBLTg",15) == 2092285428) strcat(s, "i");
if (crc32("FUGyYOATyUWiWik",15) == 2141357855) strcat(s, "e");
if (crc32("KyDNsxERNd",10) == 3633037720) strcat(s, "H");
if (crc32("RKBqVkATn",9) == 2202099776) strcat(s, "t");
if (crc32("ujNydKRmQ",9) == 2796551309) strcat(s, "e");
if (crc32("cgNayUgBj",9) == 2767509500) strcat(s, "r");
    return s;
}

char *eternisation_nouns() {
    char *s = calloc(13);
    if (crc32("NLQhEpI",7) == 2415079330) strcat(s, "p");
if (crc32("jhjlOAkB",8) == 3305761444) strcat(s, "e");
if (crc32("YHXfjHDIjQezNhh",15) == 620733488) strcat(s, "a");
if (crc32("WCQEQqQeoaoXHVe",15) == 3672872710) strcat(s, "t");
if (crc32("xeBdyeYWp",9) == 1406040216) strcat(s, "c");
if (crc32("XwgUygiXQv",10) == 1328605101) strcat(s, "e");
if (crc32("xyfwoffiFGM",11) == 2627416861) strcat(s, "r");
if (crc32("lscMmQoXyeRhla",14) == 2295926650) strcat(s, "N");
if (crc32("RotbJfubMynDjC",14) == 3564694710) strcat(s, "n");
if (crc32("TLuBXhfvhzyPev",14) == 2717914594) strcat(s, "i");
if (crc32("oPgDBVcKizRom",13) == 4052624598) strcat(s, "M");
if (crc32("eAVvOq",6) == 1653676111) strcat(s, "s");
if (crc32("lNNQEPRSlmRlP",13) == 929141516) strcat(s, "a");
if (crc32("iycGygIUVqsj",12) == 3964352731) strcat(s, "I");
if (crc32("wwKJgg",6) == 610631348) strcat(s, "t");
if (crc32("kCVHUeBm",8) == 2032258121) strcat(s, "s");
if (crc32("BCdDyjj",7) == 3601171903) strcat(s, "i");
if (crc32("JgUkV",5) == 484889273) strcat(s, "o");
if (crc32("cKCJIgWUGfdtF",13) == 1050768033) strcat(s, "F");
if (crc32("aBqNljU",7) == 2291843371) strcat(s, "n");
    return s;
}

char *stereobate_nouns() {
    char *s = calloc(11);
    if (crc32("jUSXllsLBePAgYm",15) == 2088766827) strcat(s, "s");
if (crc32("NXaAhmAJN",9) == 368805229) strcat(s, "t");
if (crc32("MLdgyyXXV",9) == 2917024117) strcat(s, "e");
if (crc32("UFbKHZ",6) == 1691137344) strcat(s, "r");
if (crc32("WmLxSleV",8) == 3475016410) strcat(s, "L");
if (crc32("GmKFAFurrYvwwZn",15) == 2212202358) strcat(s, "e");
if (crc32("cgNorVsRtxv",11) == 851703828) strcat(s, "p");
if (crc32("xRqNBdqjKfLFT",13) == 1164062198) strcat(s, "o");
if (crc32("PtmGtCHCwcKb",12) == 978746860) strcat(s, "b");
if (crc32("dhPoedEjamtaVDJ",15) == 2746674954) strcat(s, "a");
if (crc32("RdDaOYPz",8) == 2536689025) strcat(s, "t");
if (crc32("PORDaHfmw",9) == 3976158645) strcat(s, "e");
    return s;
}

char *ballium_nouns() {
    char *s = calloc(8);
    if (crc32("TMbYKBRPfBP",11) == 2663891917) strcat(s, "f");
if (crc32("VGcsjCcTidAuun",14) == 2487090818) strcat(s, "b");
if (crc32("IevCk",5) == 1308873837) strcat(s, "t");
if (crc32("NFgRUaplWgPFzA",14) == 2667747056) strcat(s, "a");
if (crc32("UsxsH",5) == 1772905131) strcat(s, "l");
if (crc32("UNmmCsXioDbUlGf",15) == 2577018358) strcat(s, "h");
if (crc32("wYHLvzemJKXlv",13) == 506862584) strcat(s, "l");
if (crc32("tDaiNzQPlqAtO",13) == 187785173) strcat(s, "i");
if (crc32("VQwisFWKrAfqRmu",15) == 4294138606) strcat(s, "o");
if (crc32("iGKdLoIWxjgGVGR",15) == 1858219202) strcat(s, "u");
if (crc32("kAEgHfTFwfkW",12) == 3681296320) strcat(s, "q");
if (crc32("KVcpoGc",7) == 2618481963) strcat(s, "m");
    return s;
}

char *Schacht_nouns() {
    char *s = calloc(8);
    if (crc32("iNKQyXOa",8) == 3885163539) strcat(s, "S");
if (crc32("LupxvZv",7) == 3141484936) strcat(s, "c");
if (crc32("JeETfphAu",9) == 1175871689) strcat(s, "h");
if (crc32("KxxzjkVCB",9) == 1987736497) strcat(s, "O");
if (crc32("ajfKmQVKXu",10) == 903290610) strcat(s, "a");
if (crc32("lOnJbnr",7) == 1930463299) strcat(s, "z");
if (crc32("JalQx",5) == 3947397324) strcat(s, "c");
if (crc32("sGPLbfnQYGG",11) == 1976027869) strcat(s, "J");
if (crc32("ZFFKfzxHTIaE",12) == 3424466605) strcat(s, "h");
if (crc32("aazcY",5) == 718323855) strcat(s, "e");
if (crc32("NfRHQR",6) == 2880049102) strcat(s, "t");
    return s;
}

char *utilitarianism_nouns() {
    char *s = calloc(15);
    if (crc32("VxxExsmyq",9) == 3775233638) strcat(s, "T");
if (crc32("wnBgfMY",7) == 430306536) strcat(s, "u");
if (crc32("EsGktNNpGRQkcbB",15) == 4179720335) strcat(s, "t");
if (crc32("nUfFY",5) == 3829233632) strcat(s, "i");
if (crc32("jkXBjlggabvvOUc",15) == 500202761) strcat(s, "l");
if (crc32("RiFttOTfsEKQ",12) == 1507241155) strcat(s, "w");
if (crc32("ZSXhIH",6) == 1923464978) strcat(s, "i");
if (crc32("sswQHHWjqMFwVH",14) == 2604854617) strcat(s, "Z");
if (crc32("qIhdiimUTRqajPi",15) == 1423949599) strcat(s, "t");
if (crc32("GpHUzGMpT",9) == 1440162760) strcat(s, "a");
if (crc32("NIYIehf",7) == 2848121598) strcat(s, "C");
if (crc32("qRNdMMdHxjxt",12) == 1391695285) strcat(s, "r");
if (crc32("iOmgNkIqOoyQlJ",14) == 3236948073) strcat(s, "k");
if (crc32("POcihNLLahA",11) == 4074913017) strcat(s, "i");
if (crc32("ENIpN",5) == 1984556456) strcat(s, "A");
if (crc32("IwdjpeVYfUHGYL",14) == 3028101626) strcat(s, "a");
if (crc32("dcFeWvnGrvJJIxh",15) == 3292335093) strcat(s, "n");
if (crc32("aSzwr",5) == 1489362078) strcat(s, "J");
if (crc32("tkCxdRnPtRqOC",13) == 3877108201) strcat(s, "i");
if (crc32("xmiFuKCzGOP",11) == 3171716918) strcat(s, "s");
if (crc32("iFCnScYMIxDH",12) == 4293921953) strcat(s, "J");
if (crc32("uIYQrxXIuahrW",13) == 3584503235) strcat(s, "m");
    return s;
}

char *desistence_nouns() {
    char *s = calloc(11);
    if (crc32("EmTkdSMr",8) == 2667950109) strcat(s, "k");
if (crc32("NYxJzXVERUqPQ",13) == 2509120731) strcat(s, "d");
if (crc32("URNYEwEElPmg",12) == 4057977739) strcat(s, "g");
if (crc32("lCePXxROrcKfU",13) == 1187263808) strcat(s, "e");
if (crc32("RybFrkRo",8) == 1231729243) strcat(s, "s");
if (crc32("KVNzjauMyNSmhjV",15) == 2960315328) strcat(s, "i");
if (crc32("BMbStjcrOMd",11) == 4260963247) strcat(s, "s");
if (crc32("phIiMOflgB",10) == 1578078159) strcat(s, "t");
if (crc32("ydgPmvNGSx",10) == 1086876741) strcat(s, "V");
if (crc32("UsCIiIj",7) == 1403182986) strcat(s, "e");
if (crc32("qeqBZNpGAgTP",12) == 3875125058) strcat(s, "n");
if (crc32("cOUntgiX",8) == 2327018506) strcat(s, "z");
if (crc32("HXtVERO",7) == 4041102455) strcat(s, "c");
if (crc32("byLVZjuLxqp",11) == 594195447) strcat(s, "P");
if (crc32("SzkLkaxhWp",10) == 1373615798) strcat(s, "e");
    return s;
}

char *Vte_nouns() {
    char *s = calloc(4);
    if (crc32("QXaxs",5) == 2853651524) strcat(s, "V");
if (crc32("xZSQQUtYUDbMcWA",15) == 681023873) strcat(s, "t");
if (crc32("zmttlXgIt",9) == 701395629) strcat(s, "e");
    return s;
}

char *antiromanticism_nouns() {
    char *s = calloc(16);
    if (crc32("HbUqEz",6) == 621138714) strcat(s, "a");
if (crc32("BNDeCXLqC",9) == 1939605918) strcat(s, "n");
if (crc32("QKVoJYrpoRNP",12) == 2792810093) strcat(s, "t");
if (crc32("LszUho",6) == 1777778798) strcat(s, "i");
if (crc32("CVbaJXE",7) == 3510519976) strcat(s, "T");
if (crc32("VAfOy",5) == 1086054382) strcat(s, "r");
if (crc32("EAwSnMfKW",9) == 3511330990) strcat(s, "o");
if (crc32("fGNkMAtlT",9) == 3914466467) strcat(s, "m");
if (crc32("kwGevYoCE",9) == 4163081158) strcat(s, "k");
if (crc32("aNcFdJNhJRIo",12) == 2494105851) strcat(s, "a");
if (crc32("pcsZRTRBivPFg",13) == 1608503673) strcat(s, "m");
if (crc32("wqklyodWePFydP",14) == 4004473518) strcat(s, "n");
if (crc32("JKCLQdUurBrh",12) == 2007787117) strcat(s, "Q");
if (crc32("jIUCOC",6) == 1534408782) strcat(s, "t");
if (crc32("IBcIYtvz",8) == 2008015813) strcat(s, "i");
if (crc32("adMrJJW",7) == 3929199888) strcat(s, "j");
if (crc32("UUqfpElktYhDN",13) == 440777349) strcat(s, "c");
if (crc32("VPYZT",5) == 2772204918) strcat(s, "x");
if (crc32("GHyMHNd",7) == 953877860) strcat(s, "i");
if (crc32("jFlADmSlWtOL",12) == 3645320713) strcat(s, "O");
if (crc32("VbcaAOejnp",10) == 2866069457) strcat(s, "s");
if (crc32("xZHcXVzxnZSCyt",14) == 2677409345) strcat(s, "r");
if (crc32("wiOhXCoZuHULKGJ",15) == 100538935) strcat(s, "m");
    return s;
}

char *Hoeve_nouns() {
    char *s = calloc(6);
    if (crc32("JzQXZmSokGzYHE",14) == 3327834159) strcat(s, "M");
if (crc32("vrsBi",5) == 3507529751) strcat(s, "H");
if (crc32("NwcvxnmCs",9) == 1910874907) strcat(s, "o");
if (crc32("ZUBlSHZC",8) == 1625294647) strcat(s, "V");
if (crc32("RfrqwczwPSDcT",13) == 1048532110) strcat(s, "e");
if (crc32("QedgPbmaKBWqJd",14) == 1391786186) strcat(s, "p");
if (crc32("wgJIzbIswhOT",12) == 3038173743) strcat(s, "v");
if (crc32("FWIrpuhj",8) == 4271982847) strcat(s, "e");
    return s;
}

char *Akademi_nouns() {
    char *s = calloc(8);
    if (crc32("sdUXBiibEGPn",12) == 780815083) strcat(s, "A");
if (crc32("UZKhrhger",9) == 3482450795) strcat(s, "H");
if (crc32("fgNCMfk",7) == 2669470426) strcat(s, "k");
if (crc32("CNAPhvnNFCW",11) == 3945982693) strcat(s, "m");
if (crc32("uhJMvhSyI",9) == 461994846) strcat(s, "a");
if (crc32("SnankD",6) == 733041535) strcat(s, "d");
if (crc32("ZjNeTvEj",8) == 2161412240) strcat(s, "D");
if (crc32("PHmdzp",6) == 3599242942) strcat(s, "e");
if (crc32("QwqlPFF",7) == 4002128726) strcat(s, "m");
if (crc32("lsoqwXpIPfttgtm",15) == 1265510615) strcat(s, "i");
    return s;
}

char *Shamrock_nouns() {
    char *s = calloc(9);
    if (crc32("mVEeQdoyewVaq",13) == 1468694538) strcat(s, "V");
if (crc32("vtrunHaQwlCHpO",14) == 3108571247) strcat(s, "S");
if (crc32("TYnlsgMMWLWNT",13) == 3706943344) strcat(s, "U");
if (crc32("IXTxMktHYKWm",12) == 550262675) strcat(s, "h");
if (crc32("yMTdryH",7) == 4278381896) strcat(s, "a");
if (crc32("QaZlwUGlbs",10) == 459747094) strcat(s, "y");
if (crc32("nNoyRjpJyZvYU",13) == 3289460336) strcat(s, "m");
if (crc32("WvyouV",6) == 48360226) strcat(s, "g");
if (crc32("yFCbZhcmXfbKz",13) == 1670745648) strcat(s, "r");
if (crc32("YqZlrVAfks",10) == 2830457193) strcat(s, "n");
if (crc32("fCnPCOKxSWhwS",13) == 373795644) strcat(s, "o");
if (crc32("fvLEdNpc",8) == 559089632) strcat(s, "c");
if (crc32("cwUDOJxjH",9) == 1131959882) strcat(s, "p");
if (crc32("WaVpE",5) == 2385766987) strcat(s, "k");
    return s;
}

char *Chad_nouns() {
    char *s = calloc(5);
    if (crc32("wjFZjINCTMMtre",14) == 1456771907) strcat(s, "L");
if (crc32("fKvxFVN",7) == 3240011301) strcat(s, "C");
if (crc32("BZEmQzzTZSFOlk",14) == 754135907) strcat(s, "Q");
if (crc32("jUaJAME",7) == 2351681685) strcat(s, "h");
if (crc32("KfxcttO",7) == 456442150) strcat(s, "a");
if (crc32("knAuaOvTQIh",11) == 2767351343) strcat(s, "r");
if (crc32("xVasRjTS",8) == 800710368) strcat(s, "d");
    return s;
}

char *sermon_nouns() {
    char *s = calloc(7);
    if (crc32("maaMLq",6) == 154089596) strcat(s, "N");
if (crc32("MfMvGXLJhzKZESG",15) == 3886596122) strcat(s, "s");
if (crc32("HSXVE",5) == 1885047947) strcat(s, "d");
if (crc32("MdGDesMb",8) == 2873705722) strcat(s, "e");
if (crc32("NbHzdIitklM",11) == 3221706733) strcat(s, "r");
if (crc32("HWktpIltaEjgtf",14) == 2126020813) strcat(s, "m");
if (crc32("mZowxjms",8) == 1929180898) strcat(s, "Z");
if (crc32("RzQSpXBO",8) == 2950980844) strcat(s, "o");
if (crc32("cjVpc",5) == 3751737073) strcat(s, "n");
    return s;
}

char *Tybalt_nouns() {
    char *s = calloc(7);
    if (crc32("TavyyOypSviSvaM",15) == 3719559999) strcat(s, "T");
if (crc32("GhbXdCOau",9) == 2899316449) strcat(s, "V");
if (crc32("VgfMXr",6) == 3932262420) strcat(s, "y");
if (crc32("ClCgmgacytoJf",13) == 1997166071) strcat(s, "b");
if (crc32("BKmfEOrQtuxMWqe",15) == 614088104) strcat(s, "J");
if (crc32("ckUYlagMLRAyx",13) == 3755537307) strcat(s, "a");
if (crc32("xmlJNGB",7) == 50603543) strcat(s, "l");
if (crc32("XRkSk",5) == 2220401926) strcat(s, "O");
if (crc32("IYlhTgguX",9) == 1742917080) strcat(s, "t");
    return s;
}

char *skyphos_nouns() {
    char *s = calloc(8);
    if (crc32("YIdPcT",6) == 898507209) strcat(s, "s");
if (crc32("xUJAJdUskp",10) == 3672710021) strcat(s, "k");
if (crc32("ieUjcNe",7) == 558028167) strcat(s, "X");
if (crc32("orybrJKNUXA",11) == 214675616) strcat(s, "y");
if (crc32("lKCYfvOSwSbDbgB",15) == 1272222330) strcat(s, "p");
if (crc32("qLVoJ",5) == 190343247) strcat(s, "z");
if (crc32("gkcdQhmQPLPH",12) == 2403916186) strcat(s, "h");
if (crc32("qmkrwjOPdIuVtP",14) == 3428091411) strcat(s, "o");
if (crc32("WbwYZyfBnY",10) == 121806767) strcat(s, "s");
    return s;
}

char *Philonis_nouns() {
    char *s = calloc(9);
    if (crc32("YSLupRkj",8) == 1212516272) strcat(s, "j");
if (crc32("trLIUfda",8) == 2417739329) strcat(s, "P");
if (crc32("fqnGmNAFNaloj",13) == 732204024) strcat(s, "Y");
if (crc32("atKeVTOpVb",10) == 302411876) strcat(s, "h");
if (crc32("xvgQVN",6) == 2519410200) strcat(s, "i");
if (crc32("EuylMZaWiDnAZun",15) == 3782196287) strcat(s, "l");
if (crc32("TjaSiZbS",8) == 1040691314) strcat(s, "P");
if (crc32("YsWLfpWwX",9) == 2512340077) strcat(s, "o");
if (crc32("sBkcq",5) == 2647282608) strcat(s, "F");
if (crc32("KBXvxiadqDxZWZ",14) == 2214883256) strcat(s, "n");
if (crc32("VYcbKxrk",8) == 2411813205) strcat(s, "R");
if (crc32("VZncA",5) == 3632500216) strcat(s, "i");
if (crc32("uzRfrfcAmXxlNbC",15) == 4268972052) strcat(s, "s");
    return s;
}

char *publicity_nouns() {
    char *s = calloc(10);
    if (crc32("wAzVRsFzaNhwtu",14) == 1395267931) strcat(s, "p");
if (crc32("iCiWFdhhNtsICz",14) == 109123531) strcat(s, "E");
if (crc32("IvunKSnTQeI",11) == 2517597976) strcat(s, "u");
if (crc32("YjzcqSLgVqdhvMd",15) == 1822254328) strcat(s, "b");
if (crc32("jNWDnCdD",8) == 1438659451) strcat(s, "l");
if (crc32("OsMLitGLmvHN",12) == 4092171268) strcat(s, "W");
if (crc32("ximug",5) == 2285880737) strcat(s, "i");
if (crc32("TrDOwhmsaVPx",12) == 3710409100) strcat(s, "u");
if (crc32("WLNOhdgvjQq",11) == 3622956587) strcat(s, "c");
if (crc32("ocXLAFcAvPorh",13) == 3354729231) strcat(s, "i");
if (crc32("KHGRKKVCDclfNox",15) == 788515692) strcat(s, "t");
if (crc32("CJUSwRSJWOE",11) == 567507973) strcat(s, "U");
if (crc32("wVhGIWxS",8) == 397233713) strcat(s, "y");
    return s;
}

char *sulfur_nouns() {
    char *s = calloc(7);
    if (crc32("sudjAOqyyg",10) == 1426052758) strcat(s, "t");
if (crc32("sZopRRFFpYADmY",14) == 1360457133) strcat(s, "s");
if (crc32("NFeGlMUgagTYGE",14) == 1191376204) strcat(s, "r");
if (crc32("azCCKCfKEqH",11) == 4134460711) strcat(s, "u");
if (crc32("eMYJWMzFn",9) == 794303793) strcat(s, "D");
if (crc32("zNwjf",5) == 1693850088) strcat(s, "l");
if (crc32("agUKTw",6) == 3377857113) strcat(s, "r");
if (crc32("nSndiAdKl",9) == 1311781484) strcat(s, "f");
if (crc32("LYugpLJBJTD",11) == 4144588755) strcat(s, "u");
if (crc32("WSWvK",5) == 1680947927) strcat(s, "r");
    return s;
}

char *Crooksville_nouns() {
    char *s = calloc(12);
    if (crc32("HBPgyLrjF",9) == 2886146297) strcat(s, "C");
if (crc32("utlBmTlRGDKIl",13) == 2586878441) strcat(s, "q");
if (crc32("GgRxiJYqdhTU",12) == 1205987859) strcat(s, "r");
if (crc32("llGUf",5) == 4258845651) strcat(s, "o");
if (crc32("QiXwgj",6) == 988693363) strcat(s, "o");
if (crc32("lVpmVQXK",8) == 3633795984) strcat(s, "k");
if (crc32("wNbMQtrS",8) == 2181373582) strcat(s, "i");
if (crc32("IUwZAZ",6) == 2625195857) strcat(s, "s");
if (crc32("tyCrCucKec",10) == 3177103015) strcat(s, "v");
if (crc32("OyvyoNgV",8) == 416872761) strcat(s, "n");
if (crc32("JLiOPKyBMZAdgZ",14) == 469820866) strcat(s, "i");
if (crc32("CwgEIoj",7) == 1228523472) strcat(s, "l");
if (crc32("ckXElTSJPEV",11) == 581877213) strcat(s, "g");
if (crc32("fzUHF",5) == 431683835) strcat(s, "l");
if (crc32("AvbkJrlzAG",10) == 245994625) strcat(s, "e");
    return s;
}

char *supertragedy_nouns() {
    char *s = calloc(13);
    if (crc32("OVFyARpIMVwfgHJ",15) == 512860446) strcat(s, "k");
if (crc32("rSyGybWzCXFIPIO",15) == 802320014) strcat(s, "s");
if (crc32("uhLPvOeSCWnuXn",14) == 2219717860) strcat(s, "u");
if (crc32("xiQEYymA",8) == 1876240138) strcat(s, "p");
if (crc32("yVTeT",5) == 3284117950) strcat(s, "e");
if (crc32("QwjypvEiVtfj",12) == 2732131072) strcat(s, "U");
if (crc32("uokxsg",6) == 2421049961) strcat(s, "r");
if (crc32("swkfkPKXlPdDT",13) == 493576215) strcat(s, "Y");
if (crc32("TUBBno",6) == 2992527361) strcat(s, "t");
if (crc32("cGAZOCNS",8) == 561914962) strcat(s, "r");
if (crc32("awhwc",5) == 1721332878) strcat(s, "a");
if (crc32("pEFqNUFh",8) == 829853896) strcat(s, "K");
if (crc32("iSjNpBgmo",9) == 1610443580) strcat(s, "g");
if (crc32("oxpJJMabTHC",11) == 3821794291) strcat(s, "C");
if (crc32("VrlHIjtVYAW",11) == 2899836173) strcat(s, "e");
if (crc32("ZuVHKtCes",9) == 3608143318) strcat(s, "g");
if (crc32("dUpAcOkMvAxv",12) == 691244107) strcat(s, "d");
if (crc32("tyPwiPQqo",9) == 349418085) strcat(s, "y");
    return s;
}

char *inthralment_nouns() {
    char *s = calloc(12);
    if (crc32("HIhEeTZdtYFOLgW",15) == 1653475720) strcat(s, "i");
if (crc32("qnWkJIfdJRGMLby",15) == 177809696) strcat(s, "n");
if (crc32("HBiadh",6) == 1256921894) strcat(s, "e");
if (crc32("NitjHoQBj",9) == 2267396660) strcat(s, "t");
if (crc32("TfaXGEyZWTu",11) == 2881654383) strcat(s, "h");
if (crc32("vTYrjqtku",9) == 2311155333) strcat(s, "C");
if (crc32("MGYcnsU",7) == 3945229600) strcat(s, "r");
if (crc32("BcVrAlrWYfmHve",14) == 3137262844) strcat(s, "a");
if (crc32("wCyBWT",6) == 1147360901) strcat(s, "l");
if (crc32("cZEQbrSg",8) == 1646250678) strcat(s, "m");
if (crc32("wwhokQVijlKerXZ",15) == 2406077345) strcat(s, "l");
if (crc32("wwflTfeUN",9) == 2288294236) strcat(s, "e");
if (crc32("rRZxXEyhf",9) == 242310348) strcat(s, "F");
if (crc32("rljEQTSZb",9) == 54892976) strcat(s, "n");
if (crc32("JPKcKqFwzd",10) == 3779691039) strcat(s, "e");
if (crc32("yZsmYA",6) == 3161189082) strcat(s, "t");
    return s;
}

char *equiangularity_nouns() {
    char *s = calloc(15);
    if (crc32("kfWPPUgHVpbl",12) == 601637489) strcat(s, "q");
if (crc32("pFDQTHNZLgJ",11) == 2921617578) strcat(s, "e");
if (crc32("rhsaDmybXVl",11) == 907065023) strcat(s, "a");
if (crc32("Idtmg",5) == 2012777708) strcat(s, "q");
if (crc32("QtPGo",5) == 1109302328) strcat(s, "F");
if (crc32("plXviXj",7) == 3490059403) strcat(s, "u");
if (crc32("JRynJUrZdLi",11) == 2830632401) strcat(s, "e");
if (crc32("jrbTYkUcbEwvNds",15) == 283629240) strcat(s, "i");
if (crc32("prWnedlCYTzh",12) == 4196859501) strcat(s, "a");
if (crc32("JyLzeilwmCk",11) == 1299112002) strcat(s, "n");
if (crc32("XkUaZTGJF",9) == 90614183) strcat(s, "m");
if (crc32("nfXJuZ",6) == 1057773414) strcat(s, "g");
if (crc32("UqIkywy",7) == 1925830532) strcat(s, "k");
if (crc32("LhfNHq",6) == 468835210) strcat(s, "u");
if (crc32("lJpdFQm",7) == 2334537868) strcat(s, "m");
if (crc32("sEVjjVNfyzR",11) == 868059576) strcat(s, "l");
if (crc32("AWaPTPJHJdXVZPI",15) == 3930906682) strcat(s, "u");
if (crc32("lnlEsfwFdCC",11) == 2830257462) strcat(s, "a");
if (crc32("ttPDSLYt",8) == 1758184853) strcat(s, "r");
if (crc32("PIumaDUfHTeu",12) == 4120620146) strcat(s, "F");
if (crc32("RzkNXvnTQ",9) == 4246464343) strcat(s, "i");
if (crc32("iCsYypC",7) == 3386352864) strcat(s, "G");
if (crc32("MeUWyKTdhc",10) == 346952963) strcat(s, "t");
if (crc32("rdPBOdeadt",10) == 3550209867) strcat(s, "s");
if (crc32("lmQvXkwsAPK",11) == 1893383854) strcat(s, "y");
    return s;
}

char *hesperidin_nouns() {
    char *s = calloc(11);
    if (crc32("fGABDnRmXldiF",13) == 1856527728) strcat(s, "D");
if (crc32("wizVFdvolKhdwEa",15) == 2246125605) strcat(s, "h");
if (crc32("PfeWiAeVmUo",11) == 3112686556) strcat(s, "e");
if (crc32("WDvmuKB",7) == 689531482) strcat(s, "p");
if (crc32("ObyHp",5) == 3190546659) strcat(s, "s");
if (crc32("gFkyf",5) == 1306622386) strcat(s, "p");
if (crc32("wKMbRYxilrgd",12) == 1396996966) strcat(s, "e");
if (crc32("mbOkdGlDIKCNhn",14) == 321992210) strcat(s, "r");
if (crc32("nDXZirxOYzLK",12) == 2997405078) strcat(s, "o");
if (crc32("lwBlznniyZwbNJ",14) == 2210464346) strcat(s, "i");
if (crc32("ZneNZYBs",8) == 153716966) strcat(s, "d");
if (crc32("YxTKiayUZegs",12) == 1165587764) strcat(s, "i");
if (crc32("PfANT",5) == 3031991911) strcat(s, "d");
if (crc32("COihdhsgscuJJZE",15) == 552141915) strcat(s, "n");
    return s;
}

char *menuiserie_nouns() {
    char *s = calloc(11);
    if (crc32("QfwvlaKm",8) == 1813389183) strcat(s, "m");
if (crc32("sUJDRtS",7) == 3693489539) strcat(s, "w");
if (crc32("AElyjy",6) == 2043608706) strcat(s, "e");
if (crc32("tFrOyKo",7) == 399216877) strcat(s, "f");
if (crc32("nbAbvoiV",8) == 2691996346) strcat(s, "n");
if (crc32("BZIQAJRozP",10) == 2809909738) strcat(s, "w");
if (crc32("qIOcnJpZOOU",11) == 1455773388) strcat(s, "u");
if (crc32("IzfiRi",6) == 3271321121) strcat(s, "R");
if (crc32("eBYUFfJzTxZ",11) == 4213585896) strcat(s, "i");
if (crc32("IGEyT",5) == 2548008888) strcat(s, "Y");
if (crc32("UMGbVFvw",8) == 2179117928) strcat(s, "s");
if (crc32("qNYYl",5) == 1292105905) strcat(s, "i");
if (crc32("DYPwZbgQEoKQMdK",15) == 2181232144) strcat(s, "e");
if (crc32("IFqYsHeDGUj",11) == 2359728038) strcat(s, "W");
if (crc32("raVYFmvJShfAdvD",15) == 3308014863) strcat(s, "r");
if (crc32("fAnCCDuQor",10) == 1064346662) strcat(s, "D");
if (crc32("QujQYQxm",8) == 3783062350) strcat(s, "i");
if (crc32("SgHLBzYYjvOofCR",15) == 3509056635) strcat(s, "e");
    return s;
}

char *Hibernia_nouns() {
    char *s = calloc(9);
    if (crc32("Mdgao",5) == 1047982139) strcat(s, "H");
if (crc32("OzbkG",5) == 1038156140) strcat(s, "i");
if (crc32("OwNsHSnP",8) == 3342679673) strcat(s, "D");
if (crc32("PODkOhSvjAlAArG",15) == 3702692902) strcat(s, "b");
if (crc32("rLmgAHlfgkkCR",13) == 2324785899) strcat(s, "n");
if (crc32("IaivHUL",7) == 2467209605) strcat(s, "e");
if (crc32("TCppBj",6) == 1768465622) strcat(s, "r");
if (crc32("StHVVBVArb",10) == 2146733691) strcat(s, "n");
if (crc32("AndVDbCKRFmCyL",14) == 2421886548) strcat(s, "l");
if (crc32("dwtBUfoqrAnekX",14) == 1284569668) strcat(s, "i");
if (crc32("joPqdy",6) == 849395146) strcat(s, "v");
if (crc32("xUHUhyxAkKcq",12) == 3841243168) strcat(s, "a");
    return s;
}

char *Gerousia_nouns() {
    char *s = calloc(9);
    if (crc32("oVbzPJx",7) == 3854638204) strcat(s, "G");
if (crc32("XAxZd",5) == 3179308344) strcat(s, "e");
if (crc32("puWMUDKvTDjC",12) == 2748861654) strcat(s, "J");
if (crc32("owEXstx",7) == 723893642) strcat(s, "r");
if (crc32("OWWEsaoad",9) == 3206767651) strcat(s, "p");
if (crc32("BIXoPrc",7) == 2827454195) strcat(s, "o");
if (crc32("NSHFpNWGDDZdofz",15) == 4199361252) strcat(s, "u");
if (crc32("hruhqXOCOQVwn",13) == 2193140636) strcat(s, "v");
if (crc32("HsRTZnTgJDagZ",13) == 626521519) strcat(s, "s");
if (crc32("IiEeakiNkEGL",12) == 4000774323) strcat(s, "z");
if (crc32("FGaSbpdBMLFj",12) == 4199051239) strcat(s, "i");
if (crc32("ZWxdixyiJSuLwO",14) == 729910665) strcat(s, "a");
    return s;
}

char *myopia_nouns() {
    char *s = calloc(7);
    if (crc32("SBPtw",5) == 1627563117) strcat(s, "m");
if (crc32("yBitafU",7) == 3636375205) strcat(s, "k");
if (crc32("jdGizMdfwQhKl",13) == 2638406048) strcat(s, "y");
if (crc32("Ygzcv",5) == 4211119350) strcat(s, "o");
if (crc32("MIYfITz",7) == 2179950315) strcat(s, "k");
if (crc32("GyssQhPi",8) == 3085832930) strcat(s, "p");
if (crc32("EkenBV",6) == 239289469) strcat(s, "i");
if (crc32("yNMBtvYCGdejYF",14) == 74457051) strcat(s, "D");
if (crc32("uDBVMXROoa",10) == 580836214) strcat(s, "a");
    return s;
}

char *rudiment_nouns() {
    char *s = calloc(9);
    if (crc32("zCZZjBISmtxpM",13) == 4248229724) strcat(s, "r");
if (crc32("GBGejx",6) == 146768690) strcat(s, "u");
if (crc32("WGimQIiZczh",11) == 2970365909) strcat(s, "J");
if (crc32("QoJYKYBKNKa",11) == 2736342754) strcat(s, "d");
if (crc32("WSUaPjEnFpfgwK",14) == 711219823) strcat(s, "i");
if (crc32("LMQCjVMvMQVzMeI",15) == 3940541621) strcat(s, "R");
if (crc32("LKSBgnlxri",10) == 40945634) strcat(s, "m");
if (crc32("CDMiigeAoZI",11) == 1273044563) strcat(s, "K");
if (crc32("PYoldkuOQQ",10) == 618533281) strcat(s, "e");
if (crc32("TbJgwsoKp",9) == 3709490274) strcat(s, "t");
if (crc32("iKejm",5) == 4229474846) strcat(s, "n");
if (crc32("HGOkwJN",7) == 69063907) strcat(s, "t");
    return s;
}

char *ravishment_nouns() {
    char *s = calloc(11);
    if (crc32("oMaDFRJoqapvHx",14) == 1746141484) strcat(s, "m");
if (crc32("vrCktOFVT",9) == 2814392392) strcat(s, "r");
if (crc32("lAoyujGyuDs",11) == 2483856768) strcat(s, "a");
if (crc32("FBLis",5) == 608128654) strcat(s, "v");
if (crc32("mSPbrbOi",8) == 1426262676) strcat(s, "Y");
if (crc32("ObvfER",6) == 2791046781) strcat(s, "i");
if (crc32("cEeABMrIL",9) == 3187216845) strcat(s, "s");
if (crc32("dKewrSvNHhtOan",14) == 3174099634) strcat(s, "h");
if (crc32("xfpnZOArQ",9) == 2760466622) strcat(s, "m");
if (crc32("UcqxVgiwmCse",12) == 2143346147) strcat(s, "e");
if (crc32("PividDz",7) == 3404051554) strcat(s, "n");
if (crc32("jFGOJayzH",9) == 3627744319) strcat(s, "t");
    return s;
}

char *Zungaria_nouns() {
    char *s = calloc(9);
    if (crc32("BjYsc",5) == 55502011) strcat(s, "Z");
if (crc32("oUyTdIbXtBDfud",14) == 3300674120) strcat(s, "x");
if (crc32("QuSyUKAg",8) == 2257468500) strcat(s, "u");
if (crc32("QIOIlEZZHyXr",12) == 3953584519) strcat(s, "n");
if (crc32("GEZLldfm",8) == 3266564572) strcat(s, "m");
if (crc32("FGEKnwT",7) == 987574554) strcat(s, "g");
if (crc32("QtGoBOKEIG",10) == 1503571127) strcat(s, "b");
if (crc32("JWVqLJzl",8) == 410232700) strcat(s, "a");
if (crc32("gdrkU",5) == 2466879293) strcat(s, "r");
if (crc32("dkfcbQrNdOcN",12) == 2469802003) strcat(s, "M");
if (crc32("jXwjzXW",7) == 2467664762) strcat(s, "i");
if (crc32("XsbiVrP",7) == 3144647655) strcat(s, "a");
    return s;
}

char *jurisconsult_nouns() {
    char *s = calloc(13);
    if (crc32("sMyGQQK",7) == 672834928) strcat(s, "R");
if (crc32("QtHNXaldGJPlKxS",15) == 818404745) strcat(s, "j");
if (crc32("tNusF",5) == 1188352181) strcat(s, "u");
if (crc32("jdzwPaMH",8) == 91443147) strcat(s, "u");
if (crc32("PiQRzHRBDEXmLK",14) == 1338133667) strcat(s, "r");
if (crc32("wkdtogEyTEqVii",14) == 1050724853) strcat(s, "f");
if (crc32("VxouAO",6) == 2630455020) strcat(s, "i");
if (crc32("aOwjkgWBcxEVg",13) == 381661304) strcat(s, "s");
if (crc32("szXXCuibMKNlSJ",14) == 1937794120) strcat(s, "e");
if (crc32("mHzevyqylHqrqQV",15) == 3176604401) strcat(s, "c");
if (crc32("GNHGhXst",8) == 2496735509) strcat(s, "o");
if (crc32("ZKuWcLcGciubscF",15) == 1721375068) strcat(s, "n");
if (crc32("gSxDbSTjWt",10) == 3450692220) strcat(s, "s");
if (crc32("kxEjkt",6) == 1372328549) strcat(s, "X");
if (crc32("lJIMMFcimDEN",12) == 44846101) strcat(s, "u");
if (crc32("YoPiPdCQ",8) == 2314340281) strcat(s, "l");
if (crc32("KoqkuPFGm",9) == 124050570) strcat(s, "i");
if (crc32("esrULOTUfkXtQL",14) == 2341198436) strcat(s, "t");
    return s;
}

char *Goldsboro_nouns() {
    char *s = calloc(10);
    if (crc32("vquNJTQ",7) == 2669193366) strcat(s, "g");
if (crc32("ICoOYxqsnTCh",12) == 2078369505) strcat(s, "G");
if (crc32("tztWfSk",7) == 1926657312) strcat(s, "o");
if (crc32("wEEUtbfygL",10) == 275831399) strcat(s, "l");
if (crc32("uoDNNzdn",8) == 105968311) strcat(s, "d");
if (crc32("uIbBw",5) == 1450268995) strcat(s, "s");
if (crc32("WaRmchUtcQzGz",13) == 10976201) strcat(s, "H");
if (crc32("FGdZHaUKgPq",11) == 889124866) strcat(s, "b");
if (crc32("sNWshYHskIPjqj",14) == 2619441623) strcat(s, "s");
if (crc32("sLUbMaa",7) == 1740354903) strcat(s, "o");
if (crc32("keugkrMl",8) == 3985140881) strcat(s, "p");
if (crc32("wDEAG",5) == 3995984372) strcat(s, "r");
if (crc32("ndjkUGZfRSkTNJ",14) == 1643975468) strcat(s, "o");
    return s;
}

char *Bophuthatswana_nouns() {
    char *s = calloc(15);
    if (crc32("twaNzWjvZRH",11) == 318910928) strcat(s, "B");
if (crc32("XgaUGfhNGwbo",12) == 726446296) strcat(s, "o");
if (crc32("rAWLnlZmNTtcXTL",15) == 4051351230) strcat(s, "W");
if (crc32("elFPYm",6) == 1065383855) strcat(s, "p");
if (crc32("gQPHGnbwi",9) == 439431311) strcat(s, "k");
if (crc32("LIprhYM",7) == 732189351) strcat(s, "h");
if (crc32("itpzjRnLWh",10) == 2015997210) strcat(s, "u");
if (crc32("oyESeokI",8) == 4081391158) strcat(s, "t");
if (crc32("SRipkmIsEwWM",12) == 3553768593) strcat(s, "L");
if (crc32("CKbwwgbgcc",10) == 170425571) strcat(s, "h");
if (crc32("PgfrNGYBvRJtAc",14) == 1112333794) strcat(s, "a");
if (crc32("QFuYqLJs",8) == 1092937859) strcat(s, "W");
if (crc32("WBUQfXAGiN",10) == 1974120782) strcat(s, "t");
if (crc32("HNUWLYrmm",9) == 1074911840) strcat(s, "s");
if (crc32("YDcKhg",6) == 3760378726) strcat(s, "A");
if (crc32("JQsIeAnX",8) == 1676073265) strcat(s, "w");
if (crc32("vquWji",6) == 294795180) strcat(s, "B");
if (crc32("tdQOkxaxpHHtP",13) == 438085100) strcat(s, "a");
if (crc32("dLGzqEei",8) == 2905415878) strcat(s, "h");
if (crc32("ZSHiv",5) == 518609060) strcat(s, "n");
if (crc32("WayjZLUBfJcnieC",15) == 2464183725) strcat(s, "a");
    return s;
}

char *michigan_nouns() {
    char *s = calloc(9);
    if (crc32("cpgdgP",6) == 3861834480) strcat(s, "X");
if (crc32("OvwXOqzpAspzpYX",15) == 4223219856) strcat(s, "m");
if (crc32("cmSVnBWW",8) == 2484418174) strcat(s, "S");
if (crc32("fLateAivWP",10) == 3067765075) strcat(s, "i");
if (crc32("RoxPHqXduogkENt",15) == 1480484386) strcat(s, "R");
if (crc32("xWEvaxtejk",10) == 467393073) strcat(s, "c");
if (crc32("HhVSGSx",7) == 3663306668) strcat(s, "h");
if (crc32("tnHNY",5) == 323839617) strcat(s, "i");
if (crc32("fONJtYuefuXNIu",14) == 665254160) strcat(s, "n");
if (crc32("WeXhq",5) == 2824879354) strcat(s, "g");
if (crc32("CorisLf",7) == 450782543) strcat(s, "p");
if (crc32("ShfeYY",6) == 3137685807) strcat(s, "a");
if (crc32("unhcrqmAmtUDFT",14) == 3919653939) strcat(s, "n");
    return s;
}

char *Tashlich_nouns() {
    char *s = calloc(9);
    if (crc32("cuKTUs",6) == 1903529088) strcat(s, "O");
if (crc32("TgjYVfxKQBH",11) == 3755345870) strcat(s, "T");
if (crc32("XczSuMvC",8) == 635497371) strcat(s, "p");
if (crc32("MbkYj",5) == 1978801911) strcat(s, "a");
if (crc32("FvnbCSZzXyYNU",13) == 397651961) strcat(s, "s");
if (crc32("CpdYUQgxsVZntH",14) == 913815307) strcat(s, "O");
if (crc32("blvHEHBvKlgflO",14) == 2327420995) strcat(s, "h");
if (crc32("KxCpzQyhGYZn",12) == 379801058) strcat(s, "i");
if (crc32("khflRSOIalVyqDJ",15) == 2523358388) strcat(s, "l");
if (crc32("TxVacPun",8) == 4032438412) strcat(s, "m");
if (crc32("VlqhwSoC",8) == 1189318367) strcat(s, "i");
if (crc32("peEHMOq",7) == 3475978916) strcat(s, "c");
if (crc32("RnIrSIzrAvKtlF",14) == 1974866207) strcat(s, "h");
    return s;
}

char *Colier_nouns() {
    char *s = calloc(7);
    if (crc32("tjOdjVVTc",9) == 1962063866) strcat(s, "C");
if (crc32("OYdjYANRh",9) == 3670965507) strcat(s, "t");
if (crc32("WBpUzAKrASlN",12) == 1602292091) strcat(s, "o");
if (crc32("HTzUqjBcBqvEdn",14) == 3110114287) strcat(s, "l");
if (crc32("JeIrE",5) == 2981058498) strcat(s, "T");
if (crc32("rPrBKUF",7) == 2091260423) strcat(s, "i");
if (crc32("QKbiloSG",8) == 2811253666) strcat(s, "p");
if (crc32("poQBWEvJPl",10) == 2424265876) strcat(s, "e");
if (crc32("jAzkA",5) == 1442792521) strcat(s, "h");
if (crc32("YthcXFQsOm",10) == 3827199433) strcat(s, "r");
    return s;
}

char *terrorizer_nouns() {
    char *s = calloc(11);
    if (crc32("sNyILKqnhTxz",12) == 3355537337) strcat(s, "t");
if (crc32("SKBIbCsVfgR",11) == 265091101) strcat(s, "m");
if (crc32("QnnKClFGLlFTI",13) == 1646119757) strcat(s, "e");
if (crc32("VdPNRzOcwh",10) == 1338563048) strcat(s, "r");
if (crc32("pbnxSikJPU",10) == 1421549104) strcat(s, "c");
if (crc32("IWvdnGHmXUVT",12) == 1594867828) strcat(s, "r");
if (crc32("dBZrf",5) == 3358399567) strcat(s, "u");
if (crc32("czljG",5) == 710270754) strcat(s, "o");
if (crc32("Fosfe",5) == 1121208450) strcat(s, "a");
if (crc32("weTSkG",6) == 2987592356) strcat(s, "r");
if (crc32("cMIKUUXAXCOy",12) == 788801950) strcat(s, "L");
if (crc32("RdILeVpNV",9) == 1085439995) strcat(s, "i");
if (crc32("AJetscRbZMni",12) == 1077321504) strcat(s, "v");
if (crc32("ZnEhHY",6) == 4207697364) strcat(s, "z");
if (crc32("qSuuuedKFfiSems",15) == 104910803) strcat(s, "e");
if (crc32("BmUOHWmmQx",10) == 1718179910) strcat(s, "r");
    return s;
}

char *marekanite_nouns() {
    char *s = calloc(11);
    if (crc32("wvrpEfOIVsRc",12) == 2691889061) strcat(s, "e");
if (crc32("CjSmIq",6) == 1954741076) strcat(s, "m");
if (crc32("WwjRVQE",7) == 311957235) strcat(s, "a");
if (crc32("uEfYyt",6) == 2928353426) strcat(s, "r");
if (crc32("jlQSYUECJf",10) == 2372487925) strcat(s, "Q");
if (crc32("jKqMKYhBgoBf",12) == 4249192663) strcat(s, "e");
if (crc32("nTatObZlTpNxy",13) == 3540376822) strcat(s, "k");
if (crc32("vzfjwmtRTjqXjNQ",15) == 312365765) strcat(s, "y");
if (crc32("qScsfJAqlqqrALn",15) == 1164686869) strcat(s, "a");
if (crc32("txDAJYqVav",10) == 744956302) strcat(s, "Q");
if (crc32("KuBIaBttsnm",11) == 1370260459) strcat(s, "n");
if (crc32("sUlbzjsvHZlL",12) == 437763093) strcat(s, "W");
if (crc32("rCExSvHqW",9) == 3796497730) strcat(s, "i");
if (crc32("QBcYNkhgLfQu",12) == 2586062417) strcat(s, "R");
if (crc32("aNjcA",5) == 334528890) strcat(s, "t");
if (crc32("lTkRjoE",7) == 3652903909) strcat(s, "o");
if (crc32("qWKQLOVvhRgt",12) == 445000689) strcat(s, "e");
    return s;
}

char *cervices_nouns() {
    char *s = calloc(9);
    if (crc32("AcmhqZM",7) == 1934244547) strcat(s, "c");
if (crc32("wPbQsNqpkzmR",12) == 3764783431) strcat(s, "y");
if (crc32("WPmFMdMSgu",10) == 1946608125) strcat(s, "e");
if (crc32("MVmjJqJNf",9) == 1869947463) strcat(s, "r");
if (crc32("PAKKuvkiCriXlPC",15) == 1187573062) strcat(s, "v");
if (crc32("kLfEKAz",7) == 4194198645) strcat(s, "u");
if (crc32("eJXjYCELaAaWzH",14) == 2002161935) strcat(s, "i");
if (crc32("QBbchUxaDEM",11) == 953903408) strcat(s, "c");
if (crc32("ecpLYx",6) == 480275614) strcat(s, "j");
if (crc32("TxfcOPSFzP",10) == 1641887241) strcat(s, "e");
if (crc32("EEwbZjWASW",10) == 451298594) strcat(s, "R");
if (crc32("bQsHQhIRriqfp",13) == 704089955) strcat(s, "s");
    return s;
}

char *VTC_nouns() {
    char *s = calloc(4);
    if (crc32("sPary",5) == 3466072411) strcat(s, "V");
if (crc32("DPPsY",5) == 3662015459) strcat(s, "T");
if (crc32("TaHWxpLsgtO",11) == 4283482825) strcat(s, "F");
if (crc32("xgicEIIK",8) == 3067807292) strcat(s, "C");
    return s;
}

char *applicant_nouns() {
    char *s = calloc(10);
    if (crc32("jvXtLiJSr",9) == 1280275668) strcat(s, "a");
if (crc32("KpMxRLnP",8) == 3300555213) strcat(s, "i");
if (crc32("rPaiImLePljefyV",15) == 2719731652) strcat(s, "p");
if (crc32("xdKRg",5) == 2622526795) strcat(s, "p");
if (crc32("zdRrxzanUhflfFD",15) == 3232097118) strcat(s, "l");
if (crc32("lpPOZiY",7) == 868240870) strcat(s, "R");
if (crc32("HWWAVevFEY",10) == 3954493562) strcat(s, "i");
if (crc32("XyyWhOYSZYdKgZJ",15) == 817933154) strcat(s, "c");
if (crc32("arzjV",5) == 3879361437) strcat(s, "a");
if (crc32("bsAyJVM",7) == 3872828635) strcat(s, "n");
if (crc32("nVVxazhdHOalG",13) == 3273121942) strcat(s, "t");
    return s;
}

char *overhugeness_nouns() {
    char *s = calloc(13);
    if (crc32("QUTOLdX",7) == 91128589) strcat(s, "S");
if (crc32("hKxrfjnlSYpXv",13) == 814127278) strcat(s, "o");
if (crc32("hXCjlnHMgBt",11) == 718085448) strcat(s, "v");
if (crc32("qmrJwOGABCxDc",13) == 2567756279) strcat(s, "g");
if (crc32("aIVKnJhaQLKIqf",14) == 2373527338) strcat(s, "e");
if (crc32("yhouyLyvPHFuirk",15) == 1898319759) strcat(s, "r");
if (crc32("UiOgYGdabJ",10) == 4204130230) strcat(s, "g");
if (crc32("pcFfTkRIVY",10) == 3999108195) strcat(s, "h");
if (crc32("dPMHoiAQxDZ",11) == 3042351470) strcat(s, "L");
if (crc32("VootuGz",7) == 2250670704) strcat(s, "u");
if (crc32("CSFaenuJ",8) == 665754343) strcat(s, "g");
if (crc32("hBLgQEo",7) == 1630179175) strcat(s, "e");
if (crc32("cJsJaUnuVJcV",12) == 2012183955) strcat(s, "n");
if (crc32("KSbxAw",6) == 723316055) strcat(s, "v");
if (crc32("isdpjrHVVgFuBW",14) == 2840945250) strcat(s, "e");
if (crc32("heXRKCvRFQvxd",13) == 1211232880) strcat(s, "b");
if (crc32("GvYGdlMFvX",10) == 428592334) strcat(s, "s");
if (crc32("zqMYv",5) == 4118681438) strcat(s, "C");
if (crc32("JdNwDQafQx",10) == 3712027939) strcat(s, "s");
    return s;
}

char *blk_nouns() {
    char *s = calloc(4);
    if (crc32("XAMEel",6) == 1999447962) strcat(s, "b");
if (crc32("cybpBuOUp",9) == 1743663716) strcat(s, "j");
if (crc32("Mzvqrqxi",8) == 3253133537) strcat(s, "l");
if (crc32("hnECyvRtF",9) == 3532821711) strcat(s, "T");
if (crc32("DqxNdbHApkQDw",13) == 191093740) strcat(s, "k");
    return s;
}

char *rapeseed_nouns() {
    char *s = calloc(9);
    if (crc32("AIusTYhnn",9) == 2504736836) strcat(s, "o");
if (crc32("FMcGxVetydBb",12) == 1790279293) strcat(s, "r");
if (crc32("YqYcAEbycWC",11) == 2806237518) strcat(s, "e");
if (crc32("WuwsKj",6) == 2412685047) strcat(s, "a");
if (crc32("YGaQMkNWasoRM",13) == 3142332501) strcat(s, "p");
if (crc32("jeHAs",5) == 1203707258) strcat(s, "e");
if (crc32("fvwda",5) == 343725317) strcat(s, "t");
if (crc32("HyoVYlB",7) == 22419875) strcat(s, "s");
if (crc32("eVEjkIAv",8) == 4065539336) strcat(s, "e");
if (crc32("KnGehhObiUxQPY",14) == 867797852) strcat(s, "e");
if (crc32("vUmRPMbxa",9) == 2716799801) strcat(s, "l");
if (crc32("zqMxoNx",7) == 1749912940) strcat(s, "d");
    return s;
}

char *grillage_nouns() {
    char *s = calloc(9);
    if (crc32("jRAVXbkN",8) == 2773130622) strcat(s, "v");
if (crc32("dePCyAkeM",9) == 1453047876) strcat(s, "g");
if (crc32("QKQmmWVKpz",10) == 2098778200) strcat(s, "h");
if (crc32("BCclorIhIxHb",12) == 3161170486) strcat(s, "r");
if (crc32("vvbNgkpH",8) == 2534519097) strcat(s, "i");
if (crc32("vImrGWYoB",9) == 1513752433) strcat(s, "l");
if (crc32("KWiDUdvcH",9) == 1703062720) strcat(s, "H");
if (crc32("ncFuVfmGlyay",12) == 6941540) strcat(s, "l");
if (crc32("IJKfIwp",7) == 368542655) strcat(s, "Q");
if (crc32("CkEBbGDvcnHkh",13) == 3922970210) strcat(s, "a");
if (crc32("cXcQVXlaYLDnRN",14) == 3122920071) strcat(s, "g");
if (crc32("bZLFAX",6) == 1844945392) strcat(s, "b");
if (crc32("ziULVHkqJPQdL",13) == 3481211899) strcat(s, "e");
    return s;
}

char *ninety_nouns() {
    char *s = calloc(7);
    if (crc32("wQJgVulvvTU",11) == 3876337643) strcat(s, "n");
if (crc32("hetXrVGzGeUEdT",14) == 532064864) strcat(s, "o");
if (crc32("JzhbaJZcQYM",11) == 489037767) strcat(s, "i");
if (crc32("HEfvTYkTAXcnB",13) == 1849522517) strcat(s, "s");
if (crc32("tKoUpzSPC",9) == 3637018660) strcat(s, "n");
if (crc32("KkkJNyuxrNdpDkg",15) == 1812218295) strcat(s, "B");
if (crc32("QSBaiVQaSjkxBLA",15) == 3862185158) strcat(s, "e");
if (crc32("bupWaOoW",8) == 1487909332) strcat(s, "S");
if (crc32("YIztC",5) == 3906800718) strcat(s, "t");
if (crc32("jyyZZMSQmR",10) == 2708718483) strcat(s, "y");
    return s;
}

char *sneerfulness_nouns() {
    char *s = calloc(13);
    if (crc32("GmCHlNh",7) == 2231854051) strcat(s, "s");
if (crc32("ayGloHdf",8) == 196516720) strcat(s, "z");
if (crc32("QqymR",5) == 516202610) strcat(s, "n");
if (crc32("aKFInBcErpaTJAM",15) == 1566106487) strcat(s, "E");
if (crc32("hkwUfAuFGVVuA",13) == 409525243) strcat(s, "e");
if (crc32("yfmfltxZxgouyzt",15) == 148906739) strcat(s, "f");
if (crc32("cxjJwk",6) == 1703428041) strcat(s, "e");
if (crc32("uZkLUj",6) == 2230785035) strcat(s, "K");
if (crc32("gkAcVObYGCAYs",13) == 2116064630) strcat(s, "r");
if (crc32("RaqdW",5) == 2798031683) strcat(s, "f");
if (crc32("OICRVPw",7) == 1707380531) strcat(s, "u");
if (crc32("zvGoJAMjpd",10) == 4183522925) strcat(s, "m");
if (crc32("BwKNtjZAvk",10) == 3088617410) strcat(s, "l");
if (crc32("hYCGNcjlHp",10) == 1338417845) strcat(s, "n");
if (crc32("GCRINGUx",8) == 2928726146) strcat(s, "P");
if (crc32("NxSCzfjjzuCFd",13) == 2055938670) strcat(s, "e");
if (crc32("CJNseZnAhTWTM",13) == 491531360) strcat(s, "p");
if (crc32("KNIJwqCMqKOG",12) == 1647953798) strcat(s, "s");
if (crc32("oUgiP",5) == 1658443689) strcat(s, "T");
if (crc32("ICtbghuTxpFgO",13) == 3782145138) strcat(s, "s");
    return s;
}

char *Mocha_nouns() {
    char *s = calloc(6);
    if (crc32("oJCjCTgvFzEtaf",14) == 996481364) strcat(s, "M");
if (crc32("yehsUqmKVJd",11) == 2820571929) strcat(s, "o");
if (crc32("MVmxllEZhvlh",12) == 3906686980) strcat(s, "c");
if (crc32("CLHvweS",7) == 738991835) strcat(s, "s");
if (crc32("JdpJNEpsJ",9) == 912027291) strcat(s, "h");
if (crc32("BgnekG",6) == 588533309) strcat(s, "a");
    return s;
}

char *nonpersecution_nouns() {
    char *s = calloc(15);
    if (crc32("cwPyAoH",7) == 1898154349) strcat(s, "w");
if (crc32("uYGeEZyaihA",11) == 2760647007) strcat(s, "n");
if (crc32("VTgmjINzM",9) == 25125957) strcat(s, "C");
if (crc32("EnZnHHcQ",8) == 643052361) strcat(s, "o");
if (crc32("HkQQnEuYJO",10) == 2183390850) strcat(s, "g");
if (crc32("jjTij",5) == 869683538) strcat(s, "n");
if (crc32("uyYyZVn",7) == 2519728770) strcat(s, "r");
if (crc32("cmbqAotGLURV",12) == 3725219147) strcat(s, "p");
if (crc32("HgNNeHUA",8) == 905785442) strcat(s, "V");
if (crc32("oOChgX",6) == 313170521) strcat(s, "e");
if (crc32("obzCwujzb",9) == 318159157) strcat(s, "r");
if (crc32("zBBXIiTU",8) == 2208838142) strcat(s, "N");
if (crc32("ZvjiEpYymI",10) == 87160276) strcat(s, "s");
if (crc32("Lsqadt",6) == 3141897411) strcat(s, "e");
if (crc32("rJWJHhPSDKjRrq",14) == 3068393739) strcat(s, "c");
if (crc32("BnkcmdlCCCbLYIS",15) == 1690056095) strcat(s, "u");
if (crc32("sMRGitwfTVamSz",14) == 632582886) strcat(s, "R");
if (crc32("ZUCamVGeJYcBEqc",15) == 2471810637) strcat(s, "t");
if (crc32("NByhxeQiaK",10) == 2267533786) strcat(s, "i");
if (crc32("PyZZnklnF",9) == 3806161901) strcat(s, "o");
if (crc32("gQiVVKgmbKjNqI",14) == 1818352977) strcat(s, "n");
    return s;
}

char *herbarium_nouns() {
    char *s = calloc(10);
    if (crc32("qgJYqpeHdbl",11) == 4054059861) strcat(s, "x");
if (crc32("DSPPbmXyD",9) == 1457020941) strcat(s, "h");
if (crc32("OQHxCfmBJ",9) == 701147676) strcat(s, "s");
if (crc32("JLoTgWYHavn",11) == 655556756) strcat(s, "e");
if (crc32("qxUbLUVw",8) == 3663607068) strcat(s, "O");
if (crc32("Humjqdb",7) == 1933602873) strcat(s, "r");
if (crc32("wWuuYlxBVW",10) == 640752782) strcat(s, "F");
if (crc32("JepBsvvJCzzM",12) == 3909773007) strcat(s, "b");
if (crc32("DvXsb",5) == 358043823) strcat(s, "G");
if (crc32("LZqhOONwkpri",12) == 2272406636) strcat(s, "a");
if (crc32("wDfKphIPzx",10) == 2267499547) strcat(s, "r");
if (crc32("dRpFOpEKHdLXN",13) == 3832436297) strcat(s, "i");
if (crc32("QfpuAb",6) == 330927115) strcat(s, "u");
if (crc32("xGKwZCRp",8) == 4271840007) strcat(s, "o");
if (crc32("EtDOv",5) == 192460080) strcat(s, "m");
    return s;
}

char *Celeski_nouns() {
    char *s = calloc(8);
    if (crc32("dpIKgtimDjALc",13) == 2805685399) strcat(s, "T");
if (crc32("wkgincezfGUJn",13) == 2793803056) strcat(s, "C");
if (crc32("KnDZmnLUUWMbDw",14) == 2467681777) strcat(s, "e");
if (crc32("pwCbaIbnFuY",11) == 4254386307) strcat(s, "l");
if (crc32("cEzRsKw",7) == 563775942) strcat(s, "e");
if (crc32("LfiUUvUH",8) == 2972618704) strcat(s, "I");
if (crc32("LMUEEZVVEVBfX",13) == 1723347041) strcat(s, "s");
if (crc32("UhHmUPsXsVM",11) == 3232612787) strcat(s, "X");
if (crc32("wNIkXgrDNjestb",14) == 1607329116) strcat(s, "k");
if (crc32("tDyGatrnSYoTA",13) == 3228539245) strcat(s, "i");
    return s;
}

char *hairraiser_nouns() {
    char *s = calloc(11);
    if (crc32("vBaNJrWhrmCkTM",14) == 2779273828) strcat(s, "h");
if (crc32("foyCIwIECU",10) == 3818912591) strcat(s, "K");
if (crc32("qUMoFgnotLU",11) == 1314395058) strcat(s, "a");
if (crc32("yXJCpNFU",8) == 2022369218) strcat(s, "B");
if (crc32("UrxEGmdnW",9) == 3533425132) strcat(s, "i");
if (crc32("hKDwj",5) == 3919050463) strcat(s, "t");
if (crc32("bpVDfaKvxy",10) == 1302304711) strcat(s, "r");
if (crc32("czEPlzdnUcJj",12) == 1362475187) strcat(s, "F");
if (crc32("eNgKmzH",7) == 4218397676) strcat(s, "r");
if (crc32("ZMaWsgrDfloQRH",14) == 1002915592) strcat(s, "a");
if (crc32("glKiZUAd",8) == 2804211041) strcat(s, "O");
if (crc32("GbyYyLsseB",10) == 4133516342) strcat(s, "i");
if (crc32("LuIvwAxzYQzI",12) == 831433211) strcat(s, "s");
if (crc32("juWOnuJpnwYN",12) == 811343359) strcat(s, "e");
if (crc32("KiMKfzGRj",9) == 1565157780) strcat(s, "d");
if (crc32("JCvEtrNY",8) == 714168163) strcat(s, "r");
    return s;
}

char *po_nouns() {
    char *s = calloc(3);
    if (crc32("eGEXFnUGvx",10) == 1493900563) strcat(s, "o");
if (crc32("QfVnovrq",8) == 3778010689) strcat(s, "p");
if (crc32("ytrYzgaeqcpXZTc",15) == 2343704403) strcat(s, "o");
    return s;
}

char *BEP_nouns() {
    char *s = calloc(4);
    if (crc32("eOUOWezbnaMViVV",15) == 3932242714) strcat(s, "J");
if (crc32("DXbRyHTRpdi",11) == 2502028400) strcat(s, "B");
if (crc32("uKLkie",6) == 3651785460) strcat(s, "E");
if (crc32("CsrgNOaXwT",10) == 4260494965) strcat(s, "P");
    return s;
}

char *Farrington_nouns() {
    char *s = calloc(11);
    if (crc32("FdzuXiRmKh",10) == 4151427765) strcat(s, "F");
if (crc32("ymYdF",5) == 116327748) strcat(s, "a");
if (crc32("ZaSflVqLP",9) == 2884400241) strcat(s, "i");
if (crc32("CyedOCfjp",9) == 682488337) strcat(s, "r");
if (crc32("aIPGHiujnfIbIWl",15) == 1001627466) strcat(s, "r");
if (crc32("ivqgyPBFdvufpjV",15) == 761388349) strcat(s, "i");
if (crc32("MOBFGoZHTwK",11) == 3742488487) strcat(s, "L");
if (crc32("ANehEq",6) == 1916139777) strcat(s, "n");
if (crc32("OVvKUSZ",7) == 2079210257) strcat(s, "m");
if (crc32("lqXNJDpGTgkyrU",14) == 2225127346) strcat(s, "g");
if (crc32("uPWfMXPJazc",11) == 534978358) strcat(s, "R");
if (crc32("IrmLNSIplOQCfVE",15) == 2354447613) strcat(s, "t");
if (crc32("ZKwKxbW",7) == 2157413457) strcat(s, "o");
if (crc32("WtCNHnjqxoQTbe",14) == 3054452358) strcat(s, "n");
    return s;
}

char *Erlond_nouns() {
    char *s = calloc(7);
    if (crc32("mLcoUfxGhY",10) == 2915524332) strcat(s, "c");
if (crc32("KuCaauwNKPc",11) == 554187033) strcat(s, "E");
if (crc32("nCopF",5) == 2592790700) strcat(s, "r");
if (crc32("FXENZcemYY",10) == 2320713809) strcat(s, "l");
if (crc32("EazJOO",6) == 2718442404) strcat(s, "o");
if (crc32("TVIvsHDt",8) == 1861246013) strcat(s, "n");
if (crc32("YjUKTsZaBq",10) == 2192273222) strcat(s, "W");
if (crc32("gjwEkfdou",9) == 2483113582) strcat(s, "d");
    return s;
}

char *undesigningness_nouns() {
    char *s = calloc(16);
    if (crc32("PlQxHkqxDIiYY",13) == 822390366) strcat(s, "M");
if (crc32("HegBHY",6) == 4242762710) strcat(s, "u");
if (crc32("rSVjHNdKjXJ",11) == 1432772945) strcat(s, "Q");
if (crc32("wEQKJKsNXzuj",12) == 3135095498) strcat(s, "n");
if (crc32("BYdWpZHTyOSPPUP",15) == 3367459179) strcat(s, "b");
if (crc32("NwWXZQDKcRn",11) == 2732299206) strcat(s, "d");
if (crc32("fHgZvLwzLY",10) == 3633092532) strcat(s, "D");
if (crc32("YAsRSXXTADmQPc",14) == 575596680) strcat(s, "e");
if (crc32("jskixPOyXPlMna",14) == 4119193614) strcat(s, "Z");
if (crc32("WSHIBZBhHSeyC",13) == 3555880677) strcat(s, "s");
if (crc32("oOdxmUf",7) == 4290197306) strcat(s, "i");
if (crc32("LTJhBLCcemkO",12) == 2066233472) strcat(s, "g");
if (crc32("UdIhnuYvf",9) == 322717260) strcat(s, "V");
if (crc32("OZuVNl",6) == 591495972) strcat(s, "n");
if (crc32("wOqLSne",7) == 4152485007) strcat(s, "i");
if (crc32("JJYSZlIZpAAlB",13) == 3844368676) strcat(s, "n");
if (crc32("DXSKUUP",7) == 4108052984) strcat(s, "x");
if (crc32("arAdlakIM",9) == 2154939311) strcat(s, "g");
if (crc32("eyBxwNZrj",9) == 2913182959) strcat(s, "N");
if (crc32("MtBNu",5) == 3214402232) strcat(s, "n");
if (crc32("nrcZFWFwnKfwM",13) == 3654936393) strcat(s, "e");
if (crc32("RNTfomWiWShPHcC",15) == 4043318294) strcat(s, "I");
if (crc32("vPDEiZeHlj",10) == 2590880842) strcat(s, "s");
if (crc32("SJoiEkQdRCLOF",13) == 3662803633) strcat(s, "s");
    return s;
}

char *astrakhan_nouns() {
    char *s = calloc(10);
    if (crc32("dnmWXptb",8) == 1727314516) strcat(s, "a");
if (crc32("lmkctNsAEEBJUC",14) == 2299982361) strcat(s, "X");
if (crc32("MmOcLad",7) == 2958281525) strcat(s, "s");
if (crc32("UOjYRldTR",9) == 2321835910) strcat(s, "S");
if (crc32("JqnQvxV",7) == 3712522523) strcat(s, "t");
if (crc32("hLLtfHmoodkc",12) == 273762907) strcat(s, "r");
if (crc32("PrYdtkrko",9) == 3003278987) strcat(s, "a");
if (crc32("PUiRK",5) == 744984615) strcat(s, "k");
if (crc32("tokZhoDgqvwLq",13) == 3511764626) strcat(s, "s");
if (crc32("CBjZOFSu",8) == 3438393180) strcat(s, "h");
if (crc32("ThPRzIQ",7) == 2322709986) strcat(s, "J");
if (crc32("pWCygodeEZiQ",12) == 658691115) strcat(s, "a");
if (crc32("IQkjLtvoipbDG",13) == 2311556444) strcat(s, "n");
    return s;
}

char *arcanum_nouns() {
    char *s = calloc(8);
    if (crc32("BiBTS",5) == 4254369037) strcat(s, "a");
if (crc32("PLvIhxgHxno",11) == 4266463586) strcat(s, "F");
if (crc32("xvpImZEH",8) == 2525000190) strcat(s, "r");
if (crc32("uaRAuUBPPWe",11) == 3825503573) strcat(s, "I");
if (crc32("LTAxNkqh",8) == 2334662074) strcat(s, "c");
if (crc32("VFwhkpS",7) == 883557405) strcat(s, "j");
if (crc32("AkQxX",5) == 2696845401) strcat(s, "a");
if (crc32("SrktOTeJxZbHDKc",15) == 3236767031) strcat(s, "V");
if (crc32("KgIjVHqjHZMbEb",14) == 2957018180) strcat(s, "n");
if (crc32("rpKNqnyUKY",10) == 2308352283) strcat(s, "H");
if (crc32("kGOiZIvzgQfp",12) == 2438371041) strcat(s, "u");
if (crc32("QQzMIXkrVWQJLu",14) == 3473171117) strcat(s, "R");
if (crc32("VOgYKLFR",8) == 1913241891) strcat(s, "m");
    return s;
}

char *disputant_nouns() {
    char *s = calloc(10);
    if (crc32("bpoeKyCsAHMITC",14) == 3304701058) strcat(s, "J");
if (crc32("oCtiNurGDl",10) == 1927270038) strcat(s, "d");
if (crc32("KHeQifRuyavoD",13) == 2837147772) strcat(s, "i");
if (crc32("tqqxEs",6) == 2146681009) strcat(s, "Z");
if (crc32("twgwHpge",8) == 667016622) strcat(s, "s");
if (crc32("LFXRcLYSyQd",11) == 2492466430) strcat(s, "X");
if (crc32("JxIclRsEApGiSg",14) == 1543410942) strcat(s, "p");
if (crc32("PNusQcvrJ",9) == 1361330426) strcat(s, "M");
if (crc32("raSyYFADSG",10) == 693173727) strcat(s, "u");
if (crc32("CtHzCGAgdR",10) == 3085068966) strcat(s, "L");
if (crc32("yNRaiPg",7) == 1055683671) strcat(s, "t");
if (crc32("YaSmrcAfVMoYkhG",15) == 1940908797) strcat(s, "v");
if (crc32("Xfgbbz",6) == 1305798695) strcat(s, "a");
if (crc32("JRpFuYIZgBzGJou",15) == 2622297032) strcat(s, "B");
if (crc32("BaQofXcXyXliNAK",15) == 713035325) strcat(s, "n");
if (crc32("IuRxdXfpcfGRH",13) == 3233597210) strcat(s, "p");
if (crc32("MzQXhVFlEj",10) == 3906619482) strcat(s, "t");
    return s;
}

char *spavin_nouns() {
    char *s = calloc(7);
    if (crc32("DuOXcutI",8) == 1684400689) strcat(s, "a");
if (crc32("BuOenulwP",9) == 681324193) strcat(s, "s");
if (crc32("nHfLeF",6) == 2054698874) strcat(s, "s");
if (crc32("ATDDEBV",7) == 1729907932) strcat(s, "p");
if (crc32("rpeklgWCUIcG",12) == 225495922) strcat(s, "U");
if (crc32("vlpLzijorxO",11) == 3113128794) strcat(s, "a");
if (crc32("GRCSIoQNeQwzczw",15) == 933045505) strcat(s, "F");
if (crc32("RfNKuHrHuMDIx",13) == 3416461870) strcat(s, "v");
if (crc32("qPeJRFZwYZmT",12) == 2108840066) strcat(s, "i");
if (crc32("IyNhibLn",8) == 1848350012) strcat(s, "k");
if (crc32("JNKbRO",6) == 2439695652) strcat(s, "n");
    return s;
}

char *encompassment_nouns() {
    char *s = calloc(14);
    if (crc32("BJJgrAaoj",9) == 2155282361) strcat(s, "A");
if (crc32("PsjvnUwZ",8) == 1748493562) strcat(s, "e");
if (crc32("kTLYqofkiskunKu",15) == 2425589560) strcat(s, "b");
if (crc32("mlxZcnbyWZXzv",13) == 825602129) strcat(s, "n");
if (crc32("AbgDCHmpHY",10) == 751349544) strcat(s, "B");
if (crc32("qWESYxcIRFZ",11) == 1800962262) strcat(s, "c");
if (crc32("VVAxAdGduLFn",12) == 3834290568) strcat(s, "s");
if (crc32("DwtIOgTbnrgXyWT",15) == 2124333136) strcat(s, "o");
if (crc32("IVQaeogbmwXU",12) == 1919791165) strcat(s, "S");
if (crc32("WmQZhPSK",8) == 2271699832) strcat(s, "m");
if (crc32("GgnqxUI",7) == 1809194631) strcat(s, "g");
if (crc32("BmDDXFZg",8) == 879564341) strcat(s, "p");
if (crc32("mqtuDtKcOkKwv",13) == 1468279041) strcat(s, "a");
if (crc32("JPadurBphrCx",12) == 4009584760) strcat(s, "s");
if (crc32("aCPnMIj",7) == 773180815) strcat(s, "s");
if (crc32("zEbvHnsOzrdsFz",14) == 108987762) strcat(s, "L");
if (crc32("WmmntGgRK",9) == 1304531604) strcat(s, "m");
if (crc32("uBoGgMODSZdnPr",14) == 2433246049) strcat(s, "e");
if (crc32("mvrZipd",7) == 2939317494) strcat(s, "n");
if (crc32("RAgjsIS",7) == 529854438) strcat(s, "E");
if (crc32("SnOukCIxsKWy",12) == 669410785) strcat(s, "t");
    return s;
}

char *monophagia_nouns() {
    char *s = calloc(11);
    if (crc32("sfoYHQLUPpCNSfH",15) == 1253342397) strcat(s, "m");
if (crc32("YpxWh",5) == 1953489194) strcat(s, "o");
if (crc32("sIwMadT",7) == 1857382410) strcat(s, "n");
if (crc32("JXniuXgbvpFSd",13) == 3004460486) strcat(s, "b");
if (crc32("JzxoVqHuF",9) == 1638824784) strcat(s, "o");
if (crc32("uEnQKFkY",8) == 459203430) strcat(s, "z");
if (crc32("fVvNdVyPB",9) == 458110728) strcat(s, "p");
if (crc32("wLqHNEIMEmz",11) == 3749686250) strcat(s, "D");
if (crc32("YjgSJflwsDQRFlZ",15) == 2796871738) strcat(s, "h");
if (crc32("wifcdFtsgCvBa",13) == 3375022440) strcat(s, "s");
if (crc32("ZLBPtF",6) == 144300331) strcat(s, "a");
if (crc32("UoDBS",5) == 304764966) strcat(s, "g");
if (crc32("VVAXTRHMZ",9) == 1792989628) strcat(s, "i");
if (crc32("qAhukjAhZ",9) == 3941298226) strcat(s, "a");
    return s;
}

char *cafeteria_nouns() {
    char *s = calloc(10);
    if (crc32("WbQDnVRLuZI",11) == 2832168201) strcat(s, "c");
if (crc32("NMcjL",5) == 590803183) strcat(s, "n");
if (crc32("KItVty",6) == 1868067223) strcat(s, "a");
if (crc32("kWTKwqWYNMDGLv",14) == 1953392041) strcat(s, "M");
if (crc32("LxDsnddEokRvuy",14) == 3745477704) strcat(s, "f");
if (crc32("elOuAHbj",8) == 3369898542) strcat(s, "v");
if (crc32("dzaxUkysOj",10) == 3043657429) strcat(s, "e");
if (crc32("GuTKkX",6) == 1948006401) strcat(s, "n");
if (crc32("QkjJQB",6) == 2316726133) strcat(s, "t");
if (crc32("ymhKu",5) == 3079830431) strcat(s, "E");
if (crc32("TPOBOwjPQ",9) == 2745072792) strcat(s, "e");
if (crc32("mSXIxWGepwm",11) == 3003150959) strcat(s, "g");
if (crc32("TqZSxHQiGEi",11) == 903511911) strcat(s, "r");
if (crc32("ojbyQIV",7) == 1928675455) strcat(s, "i");
if (crc32("gxBqGKUpsEKJA",13) == 418176538) strcat(s, "a");
    return s;
}

char *furcation_nouns() {
    char *s = calloc(10);
    if (crc32("cyirmAoQZYcs",12) == 1362791186) strcat(s, "i");
if (crc32("zzsuUwa",7) == 2917328553) strcat(s, "f");
if (crc32("XeeJjqXOcqpE",12) == 3432329424) strcat(s, "x");
if (crc32("cQXISZrkjUxVwV",14) == 3450004238) strcat(s, "u");
if (crc32("OJBLWoFd",8) == 1352463861) strcat(s, "O");
if (crc32("NiywS",5) == 2935166236) strcat(s, "r");
if (crc32("SqcqfKsSuJtMrA",14) == 2902300601) strcat(s, "l");
if (crc32("jiKNnvylO",9) == 2414080898) strcat(s, "c");
if (crc32("RayVY",5) == 2719857549) strcat(s, "a");
if (crc32("QSPxaqVlUddoQJv",15) == 473763519) strcat(s, "g");
if (crc32("knIytVCIie",10) == 1239675104) strcat(s, "t");
if (crc32("AdCwyyRbfw",10) == 2966900126) strcat(s, "V");
if (crc32("UdhrgvDkcP",10) == 3555534696) strcat(s, "i");
if (crc32("aweoca",6) == 42902277) strcat(s, "o");
if (crc32("JfFtQHLvCZ",10) == 3434850290) strcat(s, "n");
    return s;
}

char *Wooden_nouns() {
    char *s = calloc(7);
    if (crc32("WURADlE",7) == 2228400410) strcat(s, "P");
if (crc32("avJTUAempmPLpZ",14) == 1350146147) strcat(s, "W");
if (crc32("qKFMaOK",7) == 3554392450) strcat(s, "o");
if (crc32("kMuQO",5) == 1447537422) strcat(s, "o");
if (crc32("FduDlHhJLoWeQE",14) == 4013879368) strcat(s, "d");
if (crc32("HAKbrb",6) == 2313206435) strcat(s, "X");
if (crc32("BfagDVkSSHfsKf",14) == 33061249) strcat(s, "e");
if (crc32("rFHkFmkjfwybO",13) == 2208595335) strcat(s, "n");
    return s;
}

char *prefect_nouns() {
    char *s = calloc(8);
    if (crc32("AcKhxwMpTtdDdet",15) == 2206426956) strcat(s, "g");
if (crc32("HqCfw",5) == 4063770699) strcat(s, "p");
if (crc32("wlJxsG",6) == 3116792097) strcat(s, "r");
if (crc32("qBoUkpecFSCUPW",14) == 3640956703) strcat(s, "e");
if (crc32("PalzbRIVLiPsaw",14) == 686070384) strcat(s, "f");
if (crc32("UcxmPYkzV",9) == 3753065604) strcat(s, "A");
if (crc32("QbjPmngM",8) == 3626998707) strcat(s, "e");
if (crc32("IKclho",6) == 2931909776) strcat(s, "c");
if (crc32("qveOWZdoYqP",11) == 99537126) strcat(s, "G");
if (crc32("eFlWajyo",8) == 3403517417) strcat(s, "t");
    return s;
}

char *Dominic_nouns() {
    char *s = calloc(8);
    if (crc32("sSbPxutUy",9) == 3431403781) strcat(s, "D");
if (crc32("vpjLrXDZvIWI",12) == 1663238567) strcat(s, "o");
if (crc32("FLsVQxFNepxOu",13) == 3408622343) strcat(s, "m");
if (crc32("qVfHVOV",7) == 3635341373) strcat(s, "i");
if (crc32("glAWKknxBIvVKv",14) == 480221147) strcat(s, "G");
if (crc32("IISJvsU",7) == 2698846878) strcat(s, "n");
if (crc32("IztzRqtgN",9) == 2020845469) strcat(s, "d");
if (crc32("YDbTn",5) == 3638124172) strcat(s, "i");
if (crc32("qOQWdCMLCnM",11) == 118222028) strcat(s, "c");
    return s;
}

char *Diptera_nouns() {
    char *s = calloc(8);
    if (crc32("GHktYMAtlzVyC",13) == 2251792905) strcat(s, "r");
if (crc32("VEKaJhPhNzt",11) == 4185416740) strcat(s, "D");
if (crc32("sBfjSNYb",8) == 1523431921) strcat(s, "Y");
if (crc32("KRWOMaDtYNBtth",14) == 2291069478) strcat(s, "i");
if (crc32("utpEvIYRWwo",11) == 60777703) strcat(s, "Q");
if (crc32("UYoOWXAcP",9) == 3342648894) strcat(s, "p");
if (crc32("YywzaYcn",8) == 4157838857) strcat(s, "t");
if (crc32("LZfraf",6) == 720647860) strcat(s, "e");
if (crc32("ZlunruLDtJQVAg",14) == 733981196) strcat(s, "r");
if (crc32("NAqWsoHvbZuZ",12) == 1504915473) strcat(s, "a");
    return s;
}

char *leaser_nouns() {
    char *s = calloc(7);
    if (crc32("rGWFrKyY",8) == 2641409548) strcat(s, "l");
if (crc32("INmgLBc",7) == 2994623551) strcat(s, "I");
if (crc32("xmorjUqBnZOl",12) == 1742119989) strcat(s, "e");
if (crc32("oCclEQQkGRY",11) == 3906354450) strcat(s, "a");
if (crc32("GjqzrnZzGen",11) == 1879311285) strcat(s, "s");
if (crc32("PIDekbfxoUzQ",12) == 757564736) strcat(s, "e");
if (crc32("GCRrjTRwWQtxDF",14) == 1579965324) strcat(s, "g");
if (crc32("eTLVxEp",7) == 661774463) strcat(s, "r");
    return s;
}

char *Geoffrey_nouns() {
    char *s = calloc(9);
    if (crc32("JKkQvYXyO",9) == 763835440) strcat(s, "G");
if (crc32("aVvVdDTkB",9) == 1721597864) strcat(s, "e");
if (crc32("fzZgVhrEr",9) == 1258625578) strcat(s, "o");
if (crc32("dWFoIzREeDxvFTC",15) == 3158547266) strcat(s, "k");
if (crc32("bkvdevizlXmjAal",15) == 134699663) strcat(s, "f");
if (crc32("rUqnj",5) == 3133765418) strcat(s, "f");
if (crc32("inpRxs",6) == 2463547175) strcat(s, "r");
if (crc32("XTSxskydPsHWp",13) == 2212894009) strcat(s, "n");
if (crc32("PRxqKxvPoCUrpvT",15) == 2184894310) strcat(s, "e");
if (crc32("xBIwjiHe",8) == 3158565237) strcat(s, "y");
    return s;
}

char *seawan_nouns() {
    char *s = calloc(7);
    if (crc32("nyJnhhYHYkPYkf",14) == 4278849981) strcat(s, "i");
if (crc32("XEKieJ",6) == 1151132927) strcat(s, "s");
if (crc32("FvENB",5) == 3753683112) strcat(s, "e");
if (crc32("JzKaCBTZNGm",11) == 1457716874) strcat(s, "a");
if (crc32("FOzLHpeJXxyFmrW",15) == 3964576750) strcat(s, "f");
if (crc32("fziIsIxjupD",11) == 2428857664) strcat(s, "w");
if (crc32("pWWCuJjpJolcQ",13) == 2643556267) strcat(s, "a");
if (crc32("yOIgugm",7) == 2500379874) strcat(s, "d");
if (crc32("tmTFaCPAxKbfCWc",15) == 288446986) strcat(s, "n");
    return s;
}

char *eyra_nouns() {
    char *s = calloc(5);
    if (crc32("AvhpJm",6) == 1960246863) strcat(s, "s");
if (crc32("gNGpyiJsmdUxGe",14) == 2790328291) strcat(s, "e");
if (crc32("XXIYin",6) == 3258462474) strcat(s, "y");
if (crc32("GSxDTjILIGbf",12) == 2478830995) strcat(s, "r");
if (crc32("ZLxuUdfCWzZTCuc",15) == 3736171927) strcat(s, "a");
    return s;
}

char *indisputability_nouns() {
    char *s = calloc(16);
    if (crc32("lQQiqV",6) == 3058097114) strcat(s, "y");
if (crc32("yVOBGFxWhAMIu",13) == 1457363625) strcat(s, "i");
if (crc32("DsDFGhct",8) == 263211782) strcat(s, "n");
if (crc32("ptwqdWdgtEwH",12) == 1660481159) strcat(s, "d");
if (crc32("ftAJfByb",8) == 1990819777) strcat(s, "a");
if (crc32("UWsfteZf",8) == 1268139971) strcat(s, "i");
if (crc32("AmJXRxeQUyUFh",13) == 2652854738) strcat(s, "w");
if (crc32("YxIHTieKlbvhh",13) == 2895275979) strcat(s, "s");
if (crc32("mIuhkWdIaQul",12) == 165750973) strcat(s, "P");
if (crc32("btssqpOy",8) == 88431644) strcat(s, "p");
if (crc32("rwuuabkvCErjFm",14) == 1755422538) strcat(s, "u");
if (crc32("zGkLxaAbEbFh",12) == 741026362) strcat(s, "t");
if (crc32("KkhucwP",7) == 4171923928) strcat(s, "M");
if (crc32("nFsPmVRgVSkWR",13) == 1069756069) strcat(s, "a");
if (crc32("eUaDkrHcBkcgOUE",15) == 3192699465) strcat(s, "z");
if (crc32("tUsqeVSXd",9) == 2727159216) strcat(s, "b");
if (crc32("xsYVGagC",8) == 3514486903) strcat(s, "i");
if (crc32("mKaXhp",6) == 916433794) strcat(s, "l");
if (crc32("QQGPUpl",7) == 2135521259) strcat(s, "m");
if (crc32("kFseKMbEifDkZq",14) == 3190869172) strcat(s, "i");
if (crc32("YSeUFJyEqAGGC",13) == 1168280212) strcat(s, "t");
if (crc32("WGUnOFq",7) == 1022744276) strcat(s, "U");
if (crc32("ihPWNb",6) == 1489213141) strcat(s, "y");
    return s;
}

char *Anzengruber_nouns() {
    char *s = calloc(12);
    if (crc32("YpQcSv",6) == 1916919667) strcat(s, "A");
if (crc32("CYxSa",5) == 3185096270) strcat(s, "G");
if (crc32("WHxTyZVEQWpqllc",15) == 3322649191) strcat(s, "n");
if (crc32("uwmhUGCC",8) == 150136329) strcat(s, "z");
if (crc32("JzjFroNesBbEs",13) == 1053134546) strcat(s, "l");
if (crc32("pSXbET",6) == 1638993879) strcat(s, "e");
if (crc32("zWXYHBW",7) == 1428367889) strcat(s, "r");
if (crc32("sEOqNEI",7) == 3998442696) strcat(s, "n");
if (crc32("CZTkAwooSi",10) == 3413320878) strcat(s, "z");
if (crc32("HaOgcANmHfNyVm",14) == 1679424550) strcat(s, "g");
if (crc32("LHaXZHAR",8) == 285283842) strcat(s, "r");
if (crc32("KStucPThtsD",11) == 649631865) strcat(s, "u");
if (crc32("RWGBjwInw",9) == 2657438903) strcat(s, "W");
if (crc32("VLHipyoDyX",10) == 4211861579) strcat(s, "b");
if (crc32("ZwZff",5) == 3023313784) strcat(s, "e");
if (crc32("qplXAzk",7) == 3976849579) strcat(s, "r");
if (crc32("SocMLV",6) == 2947516880) strcat(s, "r");
    return s;
}

char *syncarp_nouns() {
    char *s = calloc(8);
    if (crc32("gTYVsnDGdV",10) == 4195838056) strcat(s, "r");
if (crc32("UVVsOV",6) == 401220592) strcat(s, "s");
if (crc32("lIqzhSLXYOgp",12) == 778298259) strcat(s, "k");
if (crc32("nKALVToY",8) == 3393808584) strcat(s, "y");
if (crc32("lKKbDptvyWBCEy",14) == 498617740) strcat(s, "w");
if (crc32("KQSVhlkhsD",10) == 477150177) strcat(s, "n");
if (crc32("ByatXOJgHeb",11) == 331638472) strcat(s, "c");
if (crc32("EaCKEBIUCB",10) == 3910387859) strcat(s, "s");
if (crc32("UIiDrMJYf",9) == 976261428) strcat(s, "a");
if (crc32("kfdjfLnTpzyWJ",13) == 2681401402) strcat(s, "c");
if (crc32("VrlqFGpsiVdf",12) == 1922004703) strcat(s, "r");
if (crc32("GiYSlsFBBY",10) == 3953497905) strcat(s, "p");
    return s;
}

char *ketogenesis_nouns() {
    char *s = calloc(12);
    if (crc32("PYHCxHAnmglLil",14) == 4132622856) strcat(s, "E");
if (crc32("HRGyzMOkqDnbuuu",15) == 3747391005) strcat(s, "k");
if (crc32("kUxPXzcevGBQue",14) == 711551813) strcat(s, "b");
if (crc32("zroUoe",6) == 1323750682) strcat(s, "e");
if (crc32("BGYHuwnmyFF",11) == 3997378145) strcat(s, "r");
if (crc32("dlnMZFTjn",9) == 2600257133) strcat(s, "t");
if (crc32("HNzaJpPfMSttD",13) == 3406415905) strcat(s, "q");
if (crc32("oJUnCvaxGnpvTZ",14) == 1172142622) strcat(s, "o");
if (crc32("IkGNNLjUY",9) == 192754414) strcat(s, "g");
if (crc32("CSTiIJMyK",9) == 3827665450) strcat(s, "e");
if (crc32("aZFptzkBB",9) == 2966724071) strcat(s, "q");
if (crc32("aBPXImVPWJWASdN",15) == 2104186574) strcat(s, "n");
if (crc32("bxLTUbQQoFLTGzp",15) == 1307451915) strcat(s, "C");
if (crc32("hgJVEXv",7) == 1907670774) strcat(s, "e");
if (crc32("fZkvBaqJwQIHHm",14) == 4086434000) strcat(s, "S");
if (crc32("CygpCt",6) == 3002095062) strcat(s, "s");
if (crc32("XCqVkIfU",8) == 84184257) strcat(s, "Q");
if (crc32("UCFccz",6) == 4164733088) strcat(s, "i");
if (crc32("NZTBSrOTp",9) == 1279153822) strcat(s, "K");
if (crc32("xjNjl",5) == 4194911712) strcat(s, "s");
    return s;
}

char *Katherine_nouns() {
    char *s = calloc(10);
    if (crc32("pMSyj",5) == 675331002) strcat(s, "y");
if (crc32("OcUjoSS",7) == 626553346) strcat(s, "K");
if (crc32("HQRfj",5) == 3706673801) strcat(s, "V");
if (crc32("CxeuhNbULTcdAS",14) == 3424123501) strcat(s, "a");
if (crc32("ZuvxZOjyHQgC",12) == 1333756834) strcat(s, "t");
if (crc32("TQlVeJrLFAHRz",13) == 2421557008) strcat(s, "h");
if (crc32("jAkoO",5) == 2584830605) strcat(s, "w");
if (crc32("MgZvhv",6) == 3382238670) strcat(s, "e");
if (crc32("KoPzUlUnNCes",12) == 3599847620) strcat(s, "r");
if (crc32("hpTmCeBuDliEZ",13) == 3118470884) strcat(s, "A");
if (crc32("hwaGmKNs",8) == 1961745814) strcat(s, "i");
if (crc32("cuTCeil",7) == 2261286906) strcat(s, "n");
if (crc32("TElYwNaTVrEy",12) == 1472445603) strcat(s, "e");
    return s;
}

char *nonruling_nouns() {
    char *s = calloc(10);
    if (crc32("LYQTaOlITMxK",12) == 2318770079) strcat(s, "n");
if (crc32("jPiLTKoDYVF",11) == 1127746288) strcat(s, "o");
if (crc32("NXoTJ",5) == 604867259) strcat(s, "n");
if (crc32("sbZuSa",6) == 2184175813) strcat(s, "r");
if (crc32("hPtKl",5) == 3204004926) strcat(s, "T");
if (crc32("VzDroqgCemGu",12) == 1741424829) strcat(s, "u");
if (crc32("JtxfsuSSwpbVWA",14) == 2533896755) strcat(s, "q");
if (crc32("grBcwlwbHGnYFQ",14) == 3893392661) strcat(s, "l");
if (crc32("TTlMzSBXzakYD",13) == 513412241) strcat(s, "Z");
if (crc32("ZkmcXyBeFS",10) == 1566964488) strcat(s, "i");
if (crc32("fTJaTJPfN",9) == 3431643168) strcat(s, "n");
if (crc32("MzUsHMoCooAMcYH",15) == 1817600435) strcat(s, "g");
    return s;
}

char *Dover_nouns() {
    char *s = calloc(6);
    if (crc32("hRqLlHeviHDH",12) == 2344904430) strcat(s, "V");
if (crc32("ZYkAPJdaNovaC",13) == 2926149283) strcat(s, "D");
if (crc32("wjJLjfrKiHcIEeZ",15) == 1110569538) strcat(s, "o");
if (crc32("fsQovasJTDxp",12) == 3914764478) strcat(s, "s");
if (crc32("siwNnYo",7) == 2870158453) strcat(s, "v");
if (crc32("OgeWQYYboMOnXy",14) == 2164854080) strcat(s, "Z");
if (crc32("tHBAKAdVZQxetK",14) == 1473452408) strcat(s, "e");
if (crc32("PGvQWPs",7) == 3011720274) strcat(s, "r");
    return s;
}

char *sampan_nouns() {
    char *s = calloc(7);
    if (crc32("sThKgApnwyMr",12) == 2380706542) strcat(s, "D");
if (crc32("YCesPLfGx",9) == 2411693488) strcat(s, "s");
if (crc32("XLgtvLYEY",9) == 3566708763) strcat(s, "a");
if (crc32("coyhAZN",7) == 1957189477) strcat(s, "m");
if (crc32("RQeqWRyNtpb",11) == 2649749674) strcat(s, "o");
if (crc32("psrRNGaozlnMS",13) == 738089475) strcat(s, "p");
if (crc32("JidWOhwvvQRpg",13) == 3875267271) strcat(s, "a");
if (crc32("XEjcDlYQtSdRe",13) == 642952390) strcat(s, "n");
    return s;
}

char *coastguardsman_nouns() {
    char *s = calloc(15);
    if (crc32("qiEEeRZPog",10) == 2917627094) strcat(s, "a");
if (crc32("ZYZYpiFvmvbuovP",15) == 3908351204) strcat(s, "c");
if (crc32("ovIjnEeprnRL",12) == 3302841150) strcat(s, "D");
if (crc32("mLbuYLC",7) == 1626360275) strcat(s, "o");
if (crc32("Xrmjpyl",7) == 159062758) strcat(s, "d");
if (crc32("sMUczpC",7) == 3016134774) strcat(s, "a");
if (crc32("GAkkkGmtCKebU",13) == 3901893210) strcat(s, "s");
if (crc32("CCIJv",5) == 2624317342) strcat(s, "t");
if (crc32("FlSpAIlflEhOMj",14) == 2816794052) strcat(s, "g");
if (crc32("ctHLehq",7) == 2579192890) strcat(s, "G");
if (crc32("AtPqZxKCsSRzh",13) == 3763611570) strcat(s, "u");
if (crc32("FLGJOYtPR",9) == 3116752674) strcat(s, "f");
if (crc32("wEXpFlat",8) == 414690573) strcat(s, "a");
if (crc32("VqVGiMtfsUcz",12) == 397604627) strcat(s, "S");
if (crc32("XjNwRB",6) == 3099003492) strcat(s, "r");
if (crc32("xXCgshvtuL",10) == 854000950) strcat(s, "d");
if (crc32("epfxQWIHajXVoMt",15) == 2575039995) strcat(s, "s");
if (crc32("bJjKCbZ",7) == 515414334) strcat(s, "m");
if (crc32("MECVZjD",7) == 3862749440) strcat(s, "E");
if (crc32("FdpWdTOTgtn",11) == 4175275826) strcat(s, "a");
if (crc32("OLBhhbTbeD",10) == 103692176) strcat(s, "n");
    return s;
}

char *theol_nouns() {
    char *s = calloc(6);
    if (crc32("oLxBMJ",6) == 3676889471) strcat(s, "t");
if (crc32("TkyccQeXSjqR",12) == 796963161) strcat(s, "q");
if (crc32("DRoLjxJgdCrQOHj",15) == 1664843986) strcat(s, "h");
if (crc32("DUbHkgAw",8) == 2573287647) strcat(s, "F");
if (crc32("mJFQgbmtk",9) == 2020671469) strcat(s, "e");
if (crc32("nerSIprfKpKKuwT",15) == 40522970) strcat(s, "o");
if (crc32("xVUiUMuKyFRKmwd",15) == 310319786) strcat(s, "S");
if (crc32("yQnbkDcf",8) == 4079375553) strcat(s, "l");
    return s;
}

char *Stannfield_nouns() {
    char *s = calloc(11);
    if (crc32("CaxvcdOKg",9) == 4086817225) strcat(s, "q");
if (crc32("jWKOrLN",7) == 3584558345) strcat(s, "S");
if (crc32("GWjRrpwwXUkwqZP",15) == 1747726505) strcat(s, "t");
if (crc32("UzeGsiBqj",9) == 3870490490) strcat(s, "m");
if (crc32("MMbJIJdszwe",11) == 3112128044) strcat(s, "a");
if (crc32("XUYPeH",6) == 467161946) strcat(s, "n");
if (crc32("llVRocq",7) == 1380073055) strcat(s, "n");
if (crc32("daUHiZ",6) == 1995826076) strcat(s, "S");
if (crc32("RFWyctSDd",9) == 369080571) strcat(s, "f");
if (crc32("TfhReFsUG",9) == 2957136481) strcat(s, "i");
if (crc32("UDabgNqXkFASR",13) == 3881858387) strcat(s, "U");
if (crc32("rXaLjdAtZBnzy",13) == 3903479834) strcat(s, "e");
if (crc32("RTZhBXBGGvCgaiF",15) == 3945895876) strcat(s, "n");
if (crc32("RZaLXjQsOwZUl",13) == 3945751243) strcat(s, "l");
if (crc32("PEFVBO",6) == 3745339912) strcat(s, "d");
    return s;
}

char *group_nouns() {
    char *s = calloc(6);
    if (crc32("stMdd",5) == 2936098744) strcat(s, "g");
if (crc32("WQZSGRkMIpwaZ",13) == 647471737) strcat(s, "D");
if (crc32("fWQBaAYLChGUART",15) == 2950948111) strcat(s, "r");
if (crc32("RtWgkBxMsGeSoH",14) == 3593026326) strcat(s, "b");
if (crc32("IhfExL",6) == 3225935674) strcat(s, "o");
if (crc32("XxtOEP",6) == 1351102036) strcat(s, "Q");
if (crc32("elMghGjPSWWG",12) == 2088447266) strcat(s, "u");
if (crc32("uAJArkgRlB",10) == 1350126307) strcat(s, "p");
    return s;
}

char *purpose_nouns() {
    char *s = calloc(8);
    if (crc32("IJsTfP",6) == 3119677922) strcat(s, "t");
if (crc32("BErUFslC",8) == 1625639231) strcat(s, "p");
if (crc32("vRDLfbM",7) == 63807770) strcat(s, "L");
if (crc32("VXWoMGy",7) == 979465006) strcat(s, "u");
if (crc32("ZoRljTalnzsLyXW",15) == 1907786563) strcat(s, "c");
if (crc32("hEtGpKNmwFyBlfj",15) == 2383608790) strcat(s, "r");
if (crc32("cwWEuQNORy",10) == 4220367020) strcat(s, "p");
if (crc32("dgFcicedOF",10) == 205077934) strcat(s, "o");
if (crc32("DVWFUXL",7) == 3965836440) strcat(s, "v");
if (crc32("mmgsEZktsLXPt",13) == 1038759945) strcat(s, "s");
if (crc32("KyRMZhXuSnWsAg",14) == 4126475694) strcat(s, "p");
if (crc32("XksMwzAbXWpEH",13) == 4176119809) strcat(s, "e");
    return s;
}

char *lettercard_nouns() {
    char *s = calloc(11);
    if (crc32("gBMuTAiePEqe",12) == 201635708) strcat(s, "p");
if (crc32("YhVgoekV",8) == 1334828418) strcat(s, "l");
if (crc32("XOgyipP",7) == 1294949617) strcat(s, "e");
if (crc32("AETjtTnPXlXa",12) == 3559788786) strcat(s, "x");
if (crc32("cJvUSUT",7) == 3330336486) strcat(s, "t");
if (crc32("MRAXQybjD",9) == 4002770342) strcat(s, "g");
if (crc32("kisHC",5) == 4012640998) strcat(s, "t");
if (crc32("jERbvUjVp",9) == 3616940809) strcat(s, "Q");
if (crc32("VJKcpBcNpdFR",12) == 2382384377) strcat(s, "e");
if (crc32("KzBKNIGKAOp",11) == 923731144) strcat(s, "r");
if (crc32("qnqkhPySsKRaBPy",15) == 1544565797) strcat(s, "c");
if (crc32("kGxENIn",7) == 1559844201) strcat(s, "Z");
if (crc32("kijUM",5) == 3826242306) strcat(s, "a");
if (crc32("AcUJKaOSnGNJea",14) == 488504379) strcat(s, "r");
if (crc32("qrkOPvhtPXu",11) == 85775921) strcat(s, "d");
    return s;
}

char *ecotone_nouns() {
    char *s = calloc(8);
    if (crc32("IneNltibzyhRnWe",15) == 132684156) strcat(s, "e");
if (crc32("rNwJLQRKWLJRdJ",14) == 3385136298) strcat(s, "c");
if (crc32("YYZsixdrL",9) == 1872112260) strcat(s, "o");
if (crc32("RNJKdZF",7) == 1380521419) strcat(s, "d");
if (crc32("UkChjR",6) == 3597770757) strcat(s, "t");
if (crc32("abFhgxtVMi",10) == 2652753648) strcat(s, "c");
if (crc32("mWQUIx",6) == 3912771362) strcat(s, "o");
if (crc32("FVcLUlEWqGPVfZp",15) == 3181593635) strcat(s, "n");
if (crc32("uMAyBWwdX",9) == 1635930702) strcat(s, "e");
    return s;
}

char *Joye_nouns() {
    char *s = calloc(5);
    if (crc32("quTutiSFPEHWeY",14) == 2773123547) strcat(s, "v");
if (crc32("xMIVdfRQyBeQ",12) == 3197477178) strcat(s, "J");
if (crc32("rnKwFzKhfSkTFV",14) == 3491008342) strcat(s, "U");
if (crc32("lmTelCocLq",10) == 3219147314) strcat(s, "o");
if (crc32("qteqjUpRrHXMiRS",15) == 4184517675) strcat(s, "y");
if (crc32("DsBcAJVU",8) == 2579421064) strcat(s, "Z");
if (crc32("DzNvWAHflBaL",12) == 510854509) strcat(s, "e");
    return s;
}

char *bulldoggedness_nouns() {
    char *s = calloc(15);
    if (crc32("zttnZGZDMmcF",12) == 761431276) strcat(s, "b");
if (crc32("TsrLwj",6) == 3976202905) strcat(s, "u");
if (crc32("bdfgUJs",7) == 189721083) strcat(s, "l");
if (crc32("rBPIlKurGUjKMpR",15) == 644294527) strcat(s, "o");
if (crc32("DCPvDGTmckMxTRh",15) == 1610801832) strcat(s, "l");
if (crc32("gteOjLHlPhvmGGK",15) == 733515099) strcat(s, "d");
if (crc32("tZUTWFZVP",9) == 16914851) strcat(s, "X");
if (crc32("TyzfGfNI",8) == 1511413582) strcat(s, "o");
if (crc32("WeBGCZRPvlc",11) == 2700519919) strcat(s, "c");
if (crc32("cREfMCME",8) == 2653466291) strcat(s, "g");
if (crc32("SyIyKWRGPqAavdx",15) == 1413076242) strcat(s, "g");
if (crc32("RQGofFHeCJlccz",14) == 1216132492) strcat(s, "e");
if (crc32("BFyPjbKdqQFxUtv",15) == 208488781) strcat(s, "f");
if (crc32("nxIJGvyb",8) == 1311661645) strcat(s, "d");
if (crc32("YKzQRfXigMuYjX",14) == 254212893) strcat(s, "n");
if (crc32("WmpMOqQqrSyTUd",14) == 1896261665) strcat(s, "e");
if (crc32("KWRZHOJyetEqx",13) == 1639096169) strcat(s, "s");
if (crc32("HdItcRkSfngNU",13) == 439367574) strcat(s, "C");
if (crc32("REkwsnYTKCXBoMR",15) == 1607075854) strcat(s, "s");
    return s;
}

char *designator_nouns() {
    char *s = calloc(11);
    if (crc32("tgEdHEqFMs",10) == 1660517883) strcat(s, "d");
if (crc32("McSYTsJXhAsnOk",14) == 3351460143) strcat(s, "F");
if (crc32("hDZzyuWrCpn",11) == 1390302093) strcat(s, "e");
if (crc32("qNqyrgP",7) == 4179028489) strcat(s, "o");
if (crc32("gpRIUaP",7) == 23776385) strcat(s, "s");
if (crc32("lRHKarOxftitoPO",15) == 3129176817) strcat(s, "i");
if (crc32("SreFcZaUNhYo",12) == 1842983615) strcat(s, "g");
if (crc32("dVhstWPrHAfgeSK",15) == 3683368214) strcat(s, "R");
if (crc32("rATgQjBNFFot",12) == 1088637974) strcat(s, "n");
if (crc32("vPFngbI",7) == 121844469) strcat(s, "a");
if (crc32("uPARK",5) == 526104014) strcat(s, "B");
if (crc32("PtrjYOClun",10) == 4151208829) strcat(s, "t");
if (crc32("ZbIzXMSCv",9) == 4143265827) strcat(s, "z");
if (crc32("sorwXQOf",8) == 2280395118) strcat(s, "o");
if (crc32("AXNXWJDMBH",10) == 1068602944) strcat(s, "i");
if (crc32("LMqKVq",6) == 227863020) strcat(s, "r");
    return s;
}

char *bellywash_nouns() {
    char *s = calloc(10);
    if (crc32("EwwsUch",7) == 1797504572) strcat(s, "Z");
if (crc32("UhZYUS",6) == 3065010125) strcat(s, "b");
if (crc32("rxSNVvsLHYo",11) == 1705786297) strcat(s, "e");
if (crc32("RInEWAxGcZFbeTf",15) == 1739408337) strcat(s, "q");
if (crc32("gzwwfIw",7) == 1734246409) strcat(s, "l");
if (crc32("UjVspChAYO",10) == 2392603016) strcat(s, "K");
if (crc32("KQpqsTGkrOfYeBb",15) == 2532252213) strcat(s, "l");
if (crc32("ONufSvrzAXaYW",13) == 1404056476) strcat(s, "y");
if (crc32("rVxtxF",6) == 989359382) strcat(s, "p");
if (crc32("MWvJhRMslCz",11) == 482906651) strcat(s, "w");
if (crc32("RdXXUFXKofPb",12) == 2315440181) strcat(s, "R");
if (crc32("deEFQzfn",8) == 3545309539) strcat(s, "a");
if (crc32("ZfusKHJqfZjTCkY",15) == 1947870680) strcat(s, "d");
if (crc32("HrORCiLExr",10) == 399886864) strcat(s, "s");
if (crc32("aCOnywMIeJpKMV",14) == 3887808943) strcat(s, "h");
    return s;
}

char *Nessy_nouns() {
    char *s = calloc(6);
    if (crc32("LcctDWkcTH",10) == 1513975409) strcat(s, "N");
if (crc32("fjUbXlFJ",8) == 3943058990) strcat(s, "m");
if (crc32("ZjBAjpJWBV",10) == 2157271881) strcat(s, "e");
if (crc32("QwzpODaVk",9) == 1972919889) strcat(s, "n");
if (crc32("SdwykSLMg",9) == 609100535) strcat(s, "s");
if (crc32("mUMXFcq",7) == 2555467798) strcat(s, "s");
if (crc32("GOOpcUThKEQ",11) == 2964382734) strcat(s, "T");
if (crc32("VFWODAJLhvorHw",14) == 734231079) strcat(s, "y");
    return s;
}

char *scarcement_nouns() {
    char *s = calloc(11);
    if (crc32("oKJqodFdsjeQRB",14) == 1124122452) strcat(s, "u");
if (crc32("lgrqWUNUFDtD",12) == 581429888) strcat(s, "s");
if (crc32("tAnFyYkKaas",11) == 2735558612) strcat(s, "F");
if (crc32("MPUFQivsUN",10) == 3711580752) strcat(s, "c");
if (crc32("jByrm",5) == 1368874249) strcat(s, "a");
if (crc32("eNKQKvWDI",9) == 1971181977) strcat(s, "D");
if (crc32("rpmZiTONXraPicE",15) == 2621466309) strcat(s, "r");
if (crc32("quLmbGVNOmrkqVK",15) == 4013161258) strcat(s, "c");
if (crc32("omDBfgNmq",9) == 431107316) strcat(s, "w");
if (crc32("OHbnyVM",7) == 1266901714) strcat(s, "e");
if (crc32("quawZiZzFfl",11) == 1662695167) strcat(s, "h");
if (crc32("stAymLcqfYGTrE",14) == 2264032456) strcat(s, "m");
if (crc32("TrgUax",6) == 1265752292) strcat(s, "e");
if (crc32("xStdZUoZgQheZ",13) == 1524041208) strcat(s, "Z");
if (crc32("HTfdjIMiL",9) == 2946877315) strcat(s, "n");
if (crc32("FyibeE",6) == 2403354454) strcat(s, "t");
    return s;
}

char *Oakdale_nouns() {
    char *s = calloc(8);
    if (crc32("DDGKOxlXPS",10) == 4275769038) strcat(s, "O");
if (crc32("FrKtGvXJHHES",12) == 3370885872) strcat(s, "a");
if (crc32("ZqGnLYdMwPGdYH",14) == 1524718095) strcat(s, "k");
if (crc32("DoVwgYXQaOz",11) == 440502639) strcat(s, "d");
if (crc32("dFGrPPjlGAWGefS",15) == 1732761311) strcat(s, "a");
if (crc32("IcHhKyjaxOZDnHf",15) == 3781943150) strcat(s, "l");
if (crc32("XbbVEMOqs",9) == 2942646704) strcat(s, "j");
if (crc32("JdwbU",5) == 2102461738) strcat(s, "e");
    return s;
}

char *Lallage_nouns() {
    char *s = calloc(8);
    if (crc32("brwCXosC",8) == 2803290836) strcat(s, "i");
if (crc32("raVoHgG",7) == 1302915734) strcat(s, "L");
if (crc32("ItjIdZ",6) == 876088169) strcat(s, "a");
if (crc32("PlVYkTV",7) == 3632581627) strcat(s, "l");
if (crc32("piJuMGS",7) == 3696630470) strcat(s, "P");
if (crc32("LFNDRxYuakfND",13) == 832914525) strcat(s, "l");
if (crc32("wDwKZVDM",8) == 437143619) strcat(s, "a");
if (crc32("chKPmVDrOKfMO",13) == 201619707) strcat(s, "q");
if (crc32("iAqBebFf",8) == 4025416680) strcat(s, "g");
if (crc32("tJCoYFtTS",9) == 2725228943) strcat(s, "q");
if (crc32("kwSAevbitjHvHtj",15) == 3019528264) strcat(s, "e");
    return s;
}

char *perfectibility_nouns() {
    char *s = calloc(15);
    if (crc32("pNVMwAPwOYcutc",14) == 1023148830) strcat(s, "p");
if (crc32("YaxqxnAuNsXEdI",14) == 2733708741) strcat(s, "V");
if (crc32("EmeBtNIW",8) == 3738766367) strcat(s, "e");
if (crc32("cuGirvEnSdznDV",14) == 764048206) strcat(s, "h");
if (crc32("BFCCNgnJWIH",11) == 3576420737) strcat(s, "r");
if (crc32("VmoJUD",6) == 2477328349) strcat(s, "N");
if (crc32("ylQiRu",6) == 1568163307) strcat(s, "f");
if (crc32("wiHXoSckrJ",10) == 2375907490) strcat(s, "e");
if (crc32("UDJPnounsphXAn",14) == 1966176794) strcat(s, "c");
if (crc32("rnSYOzyHUdRlQ",13) == 3892962675) strcat(s, "t");
if (crc32("NDXchSuzGdZNsqd",15) == 2859910709) strcat(s, "i");
if (crc32("jljoaFioxjWWmPR",15) == 344289967) strcat(s, "b");
if (crc32("OYBNJZUTAZfbDe",14) == 2974491886) strcat(s, "V");
if (crc32("OBwfgpoz",8) == 3874200652) strcat(s, "i");
if (crc32("EyXGmOwFc",9) == 2231662019) strcat(s, "M");
if (crc32("OgyeuvQKx",9) == 1133429107) strcat(s, "l");
if (crc32("OdIxAPYVL",9) == 3675870514) strcat(s, "i");
if (crc32("wapczk",6) == 3004523845) strcat(s, "a");
if (crc32("iQPtNSHTcS",10) == 622200212) strcat(s, "t");
if (crc32("RgBsIS",6) == 3928963334) strcat(s, "x");
if (crc32("vSyymEB",7) == 803794449) strcat(s, "y");
    return s;
}

char *dividableness_nouns() {
    char *s = calloc(14);
    if (crc32("ukYEHePqGDRDXOb",15) == 3152917857) strcat(s, "d");
if (crc32("zbytfvnknTjHNJ",14) == 1313376221) strcat(s, "i");
if (crc32("HgYxPvPUSFmC",12) == 2397389552) strcat(s, "v");
if (crc32("xCnftLky",8) == 1454386241) strcat(s, "O");
if (crc32("drCGCYfxes",10) == 3934999293) strcat(s, "i");
if (crc32("GOUMfNUTSgRmVI",14) == 2823953916) strcat(s, "F");
if (crc32("VRHHTVbYeg",10) == 2682922219) strcat(s, "d");
if (crc32("ziVSDuU",7) == 1149797539) strcat(s, "k");
if (crc32("rGpGLcGuCQXQXk",14) == 4201113740) strcat(s, "a");
if (crc32("XNvYqMAe",8) == 1624656033) strcat(s, "b");
if (crc32("KnppsB",6) == 1364283493) strcat(s, "l");
if (crc32("JFtgEhEeU",9) == 1249470917) strcat(s, "U");
if (crc32("calyLeUR",8) == 1074005368) strcat(s, "e");
if (crc32("TlYgqV",6) == 900616437) strcat(s, "n");
if (crc32("upLvE",5) == 2591827957) strcat(s, "e");
if (crc32("VwlqoLmRS",9) == 1516683330) strcat(s, "S");
if (crc32("VgxDLNDxTi",10) == 2600940106) strcat(s, "s");
if (crc32("fsJwVWBoZf",10) == 2416735871) strcat(s, "L");
if (crc32("cLwqtTYSnVnH",12) == 2416269723) strcat(s, "s");
    return s;
}

char *McNutt_nouns() {
    char *s = calloc(7);
    if (crc32("KkTdIFtjJem",11) == 3391712345) strcat(s, "M");
if (crc32("VfgcsBA",7) == 3231743597) strcat(s, "V");
if (crc32("uzfKaN",6) == 3595516208) strcat(s, "c");
if (crc32("IKMIepfWEVHCqU",14) == 3681539609) strcat(s, "n");
if (crc32("kdQSnEAck",9) == 201735084) strcat(s, "N");
if (crc32("ZoQjamrNXHcmwtp",15) == 192121020) strcat(s, "u");
if (crc32("NZaSrXDlDLg",11) == 1912859049) strcat(s, "c");
if (crc32("lUSsMZFYYjFYE",13) == 1558611722) strcat(s, "t");
if (crc32("tDCjdvWjtV",10) == 682926279) strcat(s, "t");
    return s;
}

char *teniasis_nouns() {
    char *s = calloc(9);
    if (crc32("VXmiIisLh",9) == 4274457165) strcat(s, "t");
if (crc32("iMxKyNGD",8) == 3853681955) strcat(s, "e");
if (crc32("QUrYyYoylTro",12) == 735884134) strcat(s, "n");
if (crc32("XQpjUVWtte",10) == 3094613283) strcat(s, "P");
if (crc32("ioMlChFYlI",10) == 2297983771) strcat(s, "i");
if (crc32("ETDaWffnRkYLPq",14) == 998851714) strcat(s, "a");
if (crc32("TTHfZnopLGas",12) == 540620182) strcat(s, "s");
if (crc32("VWcWYJ",6) == 1547073497) strcat(s, "i");
if (crc32("NHvVl",5) == 2279121572) strcat(s, "s");
    return s;
}

char *irrefutableness_nouns() {
    char *s = calloc(16);
    if (crc32("xTCmAS",6) == 3966751072) strcat(s, "T");
if (crc32("dxkIYdWjbqiuzWG",15) == 1577092595) strcat(s, "i");
if (crc32("oebPHIOpGWu",11) == 4139359257) strcat(s, "r");
if (crc32("OJWNCQgSqAh",11) == 319080980) strcat(s, "A");
if (crc32("vrvJzYucXDjR",12) == 3422188664) strcat(s, "r");
if (crc32("UYQhKlQPHwDBX",13) == 3719003191) strcat(s, "e");
if (crc32("JbuRwEDqSzQP",12) == 1826032625) strcat(s, "s");
if (crc32("EEUsFy",6) == 1541072327) strcat(s, "f");
if (crc32("BJAFGdxubDzCzw",14) == 1512667815) strcat(s, "u");
if (crc32("gTlQYZdEIysYw",13) == 902118006) strcat(s, "o");
if (crc32("kMOdNbZ",7) == 1871536154) strcat(s, "t");
if (crc32("VkeRsxGmYD",10) == 1508107754) strcat(s, "A");
if (crc32("oyVLJnfUPkn",11) == 2769714173) strcat(s, "a");
if (crc32("dbFbjnwbl",9) == 3250061639) strcat(s, "M");
if (crc32("ckwwRgYkFIzj",12) == 4064897073) strcat(s, "b");
if (crc32("NjSVyzJXdD",10) == 2907563358) strcat(s, "m");
if (crc32("DOOQieuj",8) == 1993800859) strcat(s, "l");
if (crc32("ZecISXloQEnlpqS",15) == 3451463082) strcat(s, "e");
if (crc32("deuje",5) == 3911039505) strcat(s, "q");
if (crc32("pvWHhlxA",8) == 1721823103) strcat(s, "n");
if (crc32("wALcgVH",7) == 491383650) strcat(s, "e");
if (crc32("mLFIeaANJUIYIS",14) == 3887022538) strcat(s, "i");
if (crc32("fZGelDXe",8) == 4266995049) strcat(s, "s");
if (crc32("AkmXqRfi",8) == 249542001) strcat(s, "s");
    return s;
}

char *steriliser_nouns() {
    char *s = calloc(11);
    if (crc32("YqJWviOyWpa",11) == 3388562440) strcat(s, "F");
if (crc32("DcoZAVhavr",10) == 2632262938) strcat(s, "s");
if (crc32("zBasfnluNJHc",12) == 3313909367) strcat(s, "M");
if (crc32("gQroMfNxvJBJ",12) == 777537138) strcat(s, "t");
if (crc32("XXogf",5) == 4052008166) strcat(s, "A");
if (crc32("YAKjboEFzh",10) == 610889734) strcat(s, "e");
if (crc32("aJevEkZnJJegQAM",15) == 1466662713) strcat(s, "G");
if (crc32("ajixLa",6) == 3680354838) strcat(s, "r");
if (crc32("YsraUDwmeQYf",12) == 1883902409) strcat(s, "i");
if (crc32("bUszqMLvniEKfWJ",15) == 1735699103) strcat(s, "z");
if (crc32("zxEzezuyskFw",12) == 3324215610) strcat(s, "l");
if (crc32("vnaYjolpiGDa",12) == 1975423156) strcat(s, "i");
if (crc32("UyNKAL",6) == 2084531585) strcat(s, "h");
if (crc32("ETsxwGG",7) == 176664073) strcat(s, "s");
if (crc32("YZfMpWuTm",9) == 3076035642) strcat(s, "e");
if (crc32("kDYdEwceELXQNI",14) == 1934719864) strcat(s, "I");
if (crc32("jXPFlIEGnAtGW",13) == 2117835994) strcat(s, "r");
    return s;
}

char *resistivity_nouns() {
    char *s = calloc(12);
    if (crc32("OMQfHkVNCkhJ",12) == 3850566120) strcat(s, "r");
if (crc32("yRRPvEOOXjY",11) == 2088304017) strcat(s, "e");
if (crc32("fNfIkj",6) == 461239463) strcat(s, "O");
if (crc32("tVFpVJG",7) == 1762651239) strcat(s, "s");
if (crc32("xCZMQGVtsUO",11) == 3169211459) strcat(s, "i");
if (crc32("ZnDwsDtxM",9) == 1946180342) strcat(s, "s");
if (crc32("aQKDzj",6) == 1571949828) strcat(s, "W");
if (crc32("uXZxL",5) == 977612) strcat(s, "t");
if (crc32("eIrQPvvutEr",11) == 2934337687) strcat(s, "D");
if (crc32("UZQMqzGviN",10) == 3882084198) strcat(s, "i");
if (crc32("HiSLyphFDsTDU",13) == 2576046550) strcat(s, "v");
if (crc32("xLRSrQJyZHFtL",13) == 1337574146) strcat(s, "i");
if (crc32("BeGmZSumPXilXb",14) == 1119913569) strcat(s, "X");
if (crc32("AJpGCAXwjplk",12) == 1431140615) strcat(s, "t");
if (crc32("uyCXyfzuaLud",12) == 728685900) strcat(s, "w");
if (crc32("eYYZSS",6) == 1747089255) strcat(s, "y");
    return s;
}

char *Turkmenistan_nouns() {
    char *s = calloc(13);
    if (crc32("PDVZftefJDsSFA",14) == 2785242656) strcat(s, "U");
if (crc32("xcjKBMuLUfm",11) == 1115529455) strcat(s, "T");
if (crc32("FLojuZ",6) == 3784891196) strcat(s, "X");
if (crc32("HqgnNhkrtcZj",12) == 4078710316) strcat(s, "u");
if (crc32("nFFFWVru",8) == 3897913217) strcat(s, "w");
if (crc32("jaRdCxzDw",9) == 2799707025) strcat(s, "r");
if (crc32("ZKLsFKoAuCRa",12) == 286522600) strcat(s, "N");
if (crc32("nekEy",5) == 210595609) strcat(s, "k");
if (crc32("axjRXS",6) == 7073017) strcat(s, "m");
if (crc32("eukXEVy",7) == 776171893) strcat(s, "M");
if (crc32("gPCWgpQGQksTziX",15) == 1039249241) strcat(s, "e");
if (crc32("mVSolkl",7) == 1390629519) strcat(s, "i");
if (crc32("UTdrcjSsHLd",11) == 1090066912) strcat(s, "n");
if (crc32("LUpZaadzUry",11) == 72576895) strcat(s, "i");
if (crc32("JlgMyvm",7) == 1359708575) strcat(s, "s");
if (crc32("MQZWHDuNQeHr",12) == 2570718930) strcat(s, "t");
if (crc32("HRnOSdkhFgcv",12) == 3357405822) strcat(s, "a");
if (crc32("XcFbChowwQABSw",14) == 2805588489) strcat(s, "l");
if (crc32("bNQJYvQFCSRxDZ",14) == 3263651173) strcat(s, "n");
    return s;
}

char *Fount_nouns() {
    char *s = calloc(6);
    if (crc32("HWpVaq",6) == 2148586411) strcat(s, "F");
if (crc32("YywACYbhRMXLM",13) == 2303883099) strcat(s, "I");
if (crc32("rMyQCO",6) == 288717511) strcat(s, "o");
if (crc32("RMnDTHklHwY",11) == 3198443107) strcat(s, "u");
if (crc32("DubQePdX",8) == 848296508) strcat(s, "n");
if (crc32("AKWqelmo",8) == 1397461503) strcat(s, "t");
    return s;
}

char *willet_nouns() {
    char *s = calloc(7);
    if (crc32("jiKWgMb",7) == 1331372189) strcat(s, "w");
if (crc32("DBaIKMtwxUHn",12) == 4160052039) strcat(s, "f");
if (crc32("vqqmEHaMzLYTyPb",15) == 2242992525) strcat(s, "i");
if (crc32("KeRsBBxZIsbLRbP",15) == 450165171) strcat(s, "w");
if (crc32("jRUhacKGDj",10) == 3254582595) strcat(s, "l");
if (crc32("SEexgbgleMo",11) == 1079469691) strcat(s, "q");
if (crc32("EyoaSbOyTmfhX",13) == 743610413) strcat(s, "l");
if (crc32("iOigDHHxqazQNxu",15) == 619970576) strcat(s, "e");
if (crc32("NZfObliiqzbJexx",15) == 358117876) strcat(s, "t");
    return s;
}

char *solstice_nouns() {
    char *s = calloc(9);
    if (crc32("TXpJLrUaAKbUjm",14) == 2424643046) strcat(s, "i");
if (crc32("LMipzSIGMU",10) == 1929937870) strcat(s, "s");
if (crc32("upuyKbLrk",9) == 1660232177) strcat(s, "o");
if (crc32("rkmROXfK",8) == 2267984622) strcat(s, "l");
if (crc32("TkPsuWyQeUH",11) == 446061017) strcat(s, "d");
if (crc32("cEyBKnLiVEwSNGD",15) == 1419848777) strcat(s, "s");
if (crc32("BYVLzyI",7) == 2876500466) strcat(s, "t");
if (crc32("EZkvoN",6) == 1403949577) strcat(s, "i");
if (crc32("SOgAadCI",8) == 3665684586) strcat(s, "o");
if (crc32("kRbthRr",7) == 578209829) strcat(s, "c");
if (crc32("wnmIAELGoYEQvAq",15) == 617558659) strcat(s, "M");
if (crc32("wITBVH",6) == 1368478921) strcat(s, "e");
    return s;
}

char *Patricio_nouns() {
    char *s = calloc(9);
    if (crc32("iwRsiVSKgt",10) == 3492952332) strcat(s, "P");
if (crc32("kLHppfSJf",9) == 3063839325) strcat(s, "g");
if (crc32("SVENdNStoOUBap",14) == 2193428053) strcat(s, "a");
if (crc32("mKTOlILo",8) == 3978004812) strcat(s, "q");
if (crc32("GAzMhJAVplqB",12) == 4067960694) strcat(s, "t");
if (crc32("gMzKUsASxvQv",12) == 414179520) strcat(s, "r");
if (crc32("ZICynpPQiXh",11) == 708705971) strcat(s, "i");
if (crc32("MlPFmEB",7) == 2662493082) strcat(s, "r");
if (crc32("eZpOpq",6) == 2208086557) strcat(s, "c");
if (crc32("cDtGyvJgdH",10) == 2021297063) strcat(s, "a");
if (crc32("zGDZzfp",7) == 4096666395) strcat(s, "i");
if (crc32("QgAKGiiLfJZmsmF",15) == 2586560847) strcat(s, "b");
if (crc32("vBUASk",6) == 2297948790) strcat(s, "o");
    return s;
}

char *pantsuit_nouns() {
    char *s = calloc(9);
    if (crc32("SkxkYy",6) == 2106793617) strcat(s, "p");
if (crc32("PMBNRrnDyhFuNE",14) == 1132469383) strcat(s, "a");
if (crc32("XUTFtvyrB",9) == 2815900112) strcat(s, "l");
if (crc32("JBLfw",5) == 1631222617) strcat(s, "n");
if (crc32("pDeYeRjuZ",9) == 528951239) strcat(s, "T");
if (crc32("JBSDpgpxdINC",12) == 2484713246) strcat(s, "t");
if (crc32("gaWZSHsxZe",10) == 4287812092) strcat(s, "s");
if (crc32("xKEcO",5) == 3438604012) strcat(s, "R");
if (crc32("desGoNGTt",9) == 747889433) strcat(s, "u");
if (crc32("aUoOoN",6) == 1248583045) strcat(s, "Y");
if (crc32("eKthRWccQ",9) == 1957621822) strcat(s, "i");
if (crc32("GOpbgCF",7) == 3558977145) strcat(s, "z");
if (crc32("GGgdnxxrMAeuzzl",15) == 2632063704) strcat(s, "t");
    return s;
}

char *interpolater_nouns() {
    char *s = calloc(13);
    if (crc32("GXNarJ",6) == 304226974) strcat(s, "i");
if (crc32("bzxgF",5) == 3467883493) strcat(s, "n");
if (crc32("IXLYRDCQzfpwr",13) == 4070637832) strcat(s, "t");
if (crc32("ygYPRTVY",8) == 2136597386) strcat(s, "e");
if (crc32("OGDaq",5) == 909469265) strcat(s, "r");
if (crc32("RCSPjxd",7) == 4230872530) strcat(s, "p");
if (crc32("XjRryRVWxlB",11) == 3716667010) strcat(s, "w");
if (crc32("BSQWSjsjlSnB",12) == 3502890022) strcat(s, "o");
if (crc32("aBvgY",5) == 1277205953) strcat(s, "F");
if (crc32("TBDDtB",6) == 3028981331) strcat(s, "l");
if (crc32("TgbORzoYBKnNMwh",15) == 3029900619) strcat(s, "s");
if (crc32("tAvmqrQ",7) == 2865213519) strcat(s, "a");
if (crc32("nWhpwWE",7) == 937512128) strcat(s, "t");
if (crc32("ydKXVXBUMWC",11) == 4038421437) strcat(s, "e");
if (crc32("UESdyOrJ",8) == 1854817744) strcat(s, "r");
    return s;
}

char *Joinville_nouns() {
    char *s = calloc(10);
    if (crc32("htCYptOgqMh",11) == 2151707079) strcat(s, "J");
if (crc32("BgRBgkqyOH",10) == 1796192020) strcat(s, "E");
if (crc32("kxTKP",5) == 2501408868) strcat(s, "o");
if (crc32("HxcLKcYc",8) == 1508878207) strcat(s, "B");
if (crc32("uwCEpaljUZUF",12) == 419684958) strcat(s, "i");
if (crc32("AIXZrPZdvLrxM",13) == 2839393894) strcat(s, "Y");
if (crc32("yHoWmymNpuS",11) == 2537694743) strcat(s, "n");
if (crc32("zFuAgkCcYzDhb",13) == 3082521931) strcat(s, "a");
if (crc32("EuuZXDen",8) == 1491695256) strcat(s, "v");
if (crc32("OnNwJ",5) == 1259036608) strcat(s, "i");
if (crc32("hTjIn",5) == 3858670977) strcat(s, "l");
if (crc32("cgcetpacadcV",12) == 3157233317) strcat(s, "n");
if (crc32("DLrtmtPjkKdlNl",14) == 1237475642) strcat(s, "l");
if (crc32("zSxohMLewYMWw",13) == 2426929307) strcat(s, "e");
    return s;
}

char *Purse_nouns() {
    char *s = calloc(6);
    if (crc32("LJCpQTIzybLndu",14) == 4277282385) strcat(s, "P");
if (crc32("feBrqWL",7) == 618182788) strcat(s, "w");
if (crc32("EjRFcUxcDXRfXbb",15) == 3741770228) strcat(s, "u");
if (crc32("QrDCT",5) == 2035939459) strcat(s, "u");
if (crc32("xYengn",6) == 2914505617) strcat(s, "r");
if (crc32("oqCAojVw",8) == 3458992180) strcat(s, "s");
if (crc32("jbLlhKh",7) == 222657099) strcat(s, "e");
    return s;
}

char *pockethandkerchief_nouns() {
    char *s = calloc(19);
    if (crc32("FSxTp",5) == 471411260) strcat(s, "p");
if (crc32("stOYJkkZXT",10) == 1229759461) strcat(s, "f");
if (crc32("lzAcFQzUs",9) == 4269164864) strcat(s, "o");
if (crc32("RCJFaQdUG",9) == 2475447282) strcat(s, "c");
if (crc32("jhQDMXEw",8) == 3192906868) strcat(s, "k");
if (crc32("YNrAXnns",8) == 250688557) strcat(s, "Q");
if (crc32("NjMxPij",7) == 1530634229) strcat(s, "e");
if (crc32("yxBNOgEQgKTcIQ",14) == 2542023039) strcat(s, "t");
if (crc32("BQiLIMu",7) == 3336963654) strcat(s, "a");
if (crc32("aCwReLWvw",9) == 1013784188) strcat(s, "h");
if (crc32("WcUaQMPtcQvH",12) == 1959732006) strcat(s, "a");
if (crc32("lFBJKyh",7) == 532343322) strcat(s, "a");
if (crc32("xGQWXIKrJ",9) == 62072509) strcat(s, "n");
if (crc32("eaBdXyex",8) == 848593288) strcat(s, "C");
if (crc32("GnDPoaPeeEQQQUH",15) == 3038559252) strcat(s, "d");
if (crc32("eYDrDOC",7) == 3967882593) strcat(s, "k");
if (crc32("oBnFBUuhPqR",11) == 3594358347) strcat(s, "e");
if (crc32("BujxsjOvCho",11) == 3091574078) strcat(s, "M");
if (crc32("yeYXua",6) == 1886054090) strcat(s, "r");
if (crc32("ZEnTMjdHHaCSVwT",15) == 104280201) strcat(s, "c");
if (crc32("kpyVohBmyFRh",12) == 3394301574) strcat(s, "w");
if (crc32("ufWAxVXzcT",10) == 1143441427) strcat(s, "h");
if (crc32("ePEurvLCGfRJL",13) == 3355174485) strcat(s, "i");
if (crc32("MQbjZCMAJclnY",13) == 3306329326) strcat(s, "P");
if (crc32("VLnExDoqxM",10) == 797695225) strcat(s, "e");
if (crc32("jjmzHJD",7) == 2068573587) strcat(s, "f");
    return s;
}

char *lusterer_nouns() {
    char *s = calloc(9);
    if (crc32("xPggOCrgt",9) == 3658942236) strcat(s, "l");
if (crc32("blthxGvn",8) == 233275926) strcat(s, "V");
if (crc32("GkhJhSxNSOi",11) == 1330272666) strcat(s, "u");
if (crc32("QSfWhM",6) == 2984691541) strcat(s, "Z");
if (crc32("OyBms",5) == 1626848081) strcat(s, "s");
if (crc32("QGbofqA",7) == 4051782386) strcat(s, "t");
if (crc32("PtpwHfcxsjkSqjM",15) == 1803536464) strcat(s, "e");
if (crc32("IVWBnNon",8) == 3386897033) strcat(s, "r");
if (crc32("EYHeUB",6) == 2887824050) strcat(s, "u");
if (crc32("WJVJGIjTAYQmQ",13) == 4268050344) strcat(s, "e");
if (crc32("gdOToGYoEAJR",12) == 1844998889) strcat(s, "r");
    return s;
}

char *Fayette_nouns() {
    char *s = calloc(8);
    if (crc32("sHJOyLQADKX",11) == 473200458) strcat(s, "F");
if (crc32("UuAJXXJxDKP",11) == 1088438464) strcat(s, "a");
if (crc32("rMYzTXIigl",10) == 3525042224) strcat(s, "i");
if (crc32("fkzcTdSYewT",11) == 237370063) strcat(s, "y");
if (crc32("TFjkVXMvAOLWJDq",15) == 1639604361) strcat(s, "e");
if (crc32("YiyEBB",6) == 761155446) strcat(s, "p");
if (crc32("BfguwNhNKiw",11) == 762172935) strcat(s, "t");
if (crc32("AoyKQSxgl",9) == 3213929900) strcat(s, "r");
if (crc32("JalSQkKAO",9) == 3982669767) strcat(s, "t");
if (crc32("XeCkSnLwAnk",11) == 4022626549) strcat(s, "e");
    return s;
}

char *Freberg_nouns() {
    char *s = calloc(8);
    if (crc32("lRTIv",5) == 4248854717) strcat(s, "n");
if (crc32("ojGzl",5) == 1843013548) strcat(s, "F");
if (crc32("LdYcjVK",7) == 3650966612) strcat(s, "r");
if (crc32("NTPBBrzVpfRl",12) == 3517555037) strcat(s, "x");
if (crc32("BuWQDZcJhMUwo",13) == 757248239) strcat(s, "e");
if (crc32("lmIcOMskH",9) == 1395096725) strcat(s, "b");
if (crc32("UMhefiWuEWLlLXt",15) == 1864838471) strcat(s, "S");
if (crc32("HtMihhtrqcuIHWf",15) == 970331431) strcat(s, "e");
if (crc32("eqnUc",5) == 50426460) strcat(s, "G");
if (crc32("SgiukHEPqBG",11) == 3824160413) strcat(s, "r");
if (crc32("xaUrIcqoXRmWCk",14) == 3233712260) strcat(s, "g");
    return s;
}

char *palingenesis_nouns() {
    char *s = calloc(13);
    if (crc32("pevdYiFTAVlXWyN",15) == 3605739952) strcat(s, "p");
if (crc32("nLYMsN",6) == 3659145403) strcat(s, "Y");
if (crc32("tpEurGuESRxhjz",14) == 179377691) strcat(s, "a");
if (crc32("oiKYDJD",7) == 1526436746) strcat(s, "l");
if (crc32("SlpHTmIu",8) == 3295315410) strcat(s, "S");
if (crc32("ZOeIM",5) == 272410806) strcat(s, "i");
if (crc32("QJXQymjbyzMakrC",15) == 1315504257) strcat(s, "R");
if (crc32("etmPV",5) == 185714957) strcat(s, "n");
if (crc32("ntlYLAUXZ",9) == 270903201) strcat(s, "g");
if (crc32("GgnVNDqUPfB",11) == 3748835426) strcat(s, "e");
if (crc32("gqGjUfzXhpXRxcv",15) == 1617636455) strcat(s, "l");
if (crc32("DnRMUic",7) == 1049161762) strcat(s, "n");
if (crc32("wUguuvhwArpQqM",14) == 3334065403) strcat(s, "p");
if (crc32("xePwXrIAS",9) == 2912234282) strcat(s, "e");
if (crc32("iJSsTh",6) == 1990636660) strcat(s, "M");
if (crc32("bbxGRbn",7) == 2581682381) strcat(s, "s");
if (crc32("SoFlOwzgqz",10) == 3951378205) strcat(s, "i");
if (crc32("CWsbOKTlnzYWqX",14) == 1610908491) strcat(s, "s");
    return s;
}

char *unstupidness_nouns() {
    char *s = calloc(13);
    if (crc32("nnQLisXfYG",10) == 905303188) strcat(s, "R");
if (crc32("XYVDtuTkNhF",11) == 1787232359) strcat(s, "u");
if (crc32("eJzwZMFowclKhs",14) == 131021760) strcat(s, "e");
if (crc32("IGRjotatA",9) == 1457980688) strcat(s, "n");
if (crc32("NTjUvAbuUQ",10) == 3705468697) strcat(s, "s");
if (crc32("GzfREttJQYkAYG",14) == 1661709066) strcat(s, "t");
if (crc32("UmnIU",5) == 712391368) strcat(s, "O");
if (crc32("wdozzsqj",8) == 1073233143) strcat(s, "u");
if (crc32("DvxWCxoNyHbKUb",14) == 1263595875) strcat(s, "p");
if (crc32("KTsWpWqmWQMFg",13) == 4081395676) strcat(s, "p");
if (crc32("wqeaLMwz",8) == 216912494) strcat(s, "i");
if (crc32("Linmx",5) == 3519803410) strcat(s, "d");
if (crc32("zQTXHaLMEH",10) == 2731095880) strcat(s, "E");
if (crc32("YrHQVnUfmnlo",12) == 163321959) strcat(s, "n");
if (crc32("rLQtqQyTOnOxKfh",15) == 4254587317) strcat(s, "e");
if (crc32("wOcmVGGpUfWi",12) == 600347873) strcat(s, "J");
if (crc32("xHcEOmMf",8) == 293478818) strcat(s, "s");
if (crc32("PtEUjdiuOBv",11) == 299358918) strcat(s, "s");
    return s;
}

char *Eliades_nouns() {
    char *s = calloc(8);
    if (crc32("MZbdVBcQmBqUs",13) == 4011677237) strcat(s, "E");
if (crc32("DwJLnbzwgMyIRn",14) == 530765982) strcat(s, "l");
if (crc32("nflaTFVqWHlj",12) == 4059256685) strcat(s, "m");
if (crc32("pVECPyk",7) == 4198535306) strcat(s, "i");
if (crc32("TxCaZcEoigrdY",13) == 866877218) strcat(s, "j");
if (crc32("BNZcchTKbAWQ",12) == 3213591268) strcat(s, "a");
if (crc32("XhPOqHyFRuqwm",13) == 3229710224) strcat(s, "d");
if (crc32("LQlXEmeYn",9) == 1203919983) strcat(s, "h");
if (crc32("YaptMWUWkG",10) == 2608897576) strcat(s, "e");
if (crc32("rmeXHt",6) == 2534782596) strcat(s, "s");
    return s;
}

char *Tillion_nouns() {
    char *s = calloc(8);
    if (crc32("QcWtyDFprSZf",12) == 2340123903) strcat(s, "T");
if (crc32("qtEzyeRgvtcYo",13) == 45361360) strcat(s, "i");
if (crc32("dtexYeUUopvXbNQ",15) == 4223945528) strcat(s, "l");
if (crc32("qqymjVTnRjAD",12) == 1346559815) strcat(s, "l");
if (crc32("WcFBDPQ",7) == 3570731404) strcat(s, "E");
if (crc32("VplSGeOUL",9) == 2824211509) strcat(s, "i");
if (crc32("pUjgirlRbpDo",12) == 2915157537) strcat(s, "o");
if (crc32("ycyYjkRqSunl",12) == 2431861582) strcat(s, "w");
if (crc32("WGlbvzjBAe",10) == 83542105) strcat(s, "n");
    return s;
}

char *Sarre_nouns() {
    char *s = calloc(6);
    if (crc32("vKJhMBPHv",9) == 2782480332) strcat(s, "z");
if (crc32("DUBMetfVyAESiG",14) == 1200013663) strcat(s, "S");
if (crc32("MdEobmWSqpKEfK",14) == 657742279) strcat(s, "m");
if (crc32("iKOapmSkeNtZ",12) == 2335630532) strcat(s, "a");
if (crc32("auNUApozM",9) == 2889224036) strcat(s, "g");
if (crc32("KPQoYSQN",8) == 76219368) strcat(s, "r");
if (crc32("SIxzpaKypw",10) == 519136017) strcat(s, "U");
if (crc32("SbVBZSWgSrHA",12) == 655530923) strcat(s, "r");
if (crc32("bTRZbvnl",8) == 1840941997) strcat(s, "e");
    return s;
}

char *militancy_nouns() {
    char *s = calloc(10);
    if (crc32("fpBvfsMxsbFxO",13) == 1704958294) strcat(s, "m");
if (crc32("BLZVUAOUWm",10) == 4221532652) strcat(s, "O");
if (crc32("EZhpoDQWNbQIYa",14) == 2700277492) strcat(s, "i");
if (crc32("DwHQhwnbri",10) == 2304489205) strcat(s, "l");
if (crc32("cTXHuWXkl",9) == 1088831635) strcat(s, "f");
if (crc32("GkbgDjyR",8) == 2336979573) strcat(s, "i");
if (crc32("EOIbjLEm",8) == 1199618469) strcat(s, "o");
if (crc32("LmZooVwEAfwjLa",14) == 1894583502) strcat(s, "t");
if (crc32("dQLYi",5) == 2475266946) strcat(s, "s");
if (crc32("NbAsUylydB",10) == 852062211) strcat(s, "a");
if (crc32("SGIUwNIjtC",10) == 3126528749) strcat(s, "n");
if (crc32("ZfYtyjmlZTZvfc",14) == 3523698496) strcat(s, "c");
if (crc32("AtFXQW",6) == 2122838547) strcat(s, "g");
if (crc32("wWtebQAavLbmB",13) == 2540323106) strcat(s, "y");
    return s;
}

char *tantrum_nouns() {
    char *s = calloc(8);
    if (crc32("ASTUNUMlrqul",12) == 2384087506) strcat(s, "B");
if (crc32("wkOYXPt",7) == 894097035) strcat(s, "t");
if (crc32("DEqybMZLhWjvgm",14) == 3668182397) strcat(s, "C");
if (crc32("EgwiymW",7) == 3977165942) strcat(s, "a");
if (crc32("yEdcYmCfZrWkz",13) == 18924971) strcat(s, "Q");
if (crc32("dSTsWl",6) == 4264751592) strcat(s, "n");
if (crc32("fVfJCtW",7) == 1790533488) strcat(s, "b");
if (crc32("fdjdVXDSLPBI",12) == 2210730842) strcat(s, "t");
if (crc32("NBTfHjKTL",9) == 1941756781) strcat(s, "r");
if (crc32("gPrRRexyImVrSSW",15) == 590520748) strcat(s, "w");
if (crc32("kQXpiCsBSUHbaMn",15) == 1799756553) strcat(s, "u");
if (crc32("qRSyN",5) == 1660405642) strcat(s, "m");
    return s;
}

char *unvituperativeness_nouns() {
    char *s = calloc(19);
    if (crc32("cTBAkKVelZ",10) == 3501993751) strcat(s, "u");
if (crc32("eVzMlYgCsFLpYi",14) == 1595131969) strcat(s, "R");
if (crc32("YzYUEHv",7) == 3219083704) strcat(s, "n");
if (crc32("QUugHVSaKWmE",12) == 2595644758) strcat(s, "v");
if (crc32("xRrTwcH",7) == 544230181) strcat(s, "E");
if (crc32("URHYHrpxxalM",12) == 3388453272) strcat(s, "i");
if (crc32("ZFirYIvDcmQ",11) == 114806413) strcat(s, "t");
if (crc32("FDWtwcvk",8) == 3968205481) strcat(s, "s");
if (crc32("gkyBEPVgW",9) == 2222377247) strcat(s, "u");
if (crc32("XobOFC",6) == 3334965523) strcat(s, "O");
if (crc32("dVbFTOWpjmo",11) == 576790942) strcat(s, "p");
if (crc32("dMAiePqX",8) == 405394379) strcat(s, "b");
if (crc32("GegXjfW",7) == 3803889904) strcat(s, "e");
if (crc32("ptDKAflwMMobXL",14) == 1101309667) strcat(s, "r");
if (crc32("MtxSeORurlY",11) == 2886939445) strcat(s, "a");
if (crc32("hCwngSHrTnVZR",13) == 1837230241) strcat(s, "t");
if (crc32("OlLYKakVbumJGG",14) == 323789490) strcat(s, "i");
if (crc32("BaFrLKjbDc",10) == 2049254519) strcat(s, "i");
if (crc32("vUwCU",5) == 3716733578) strcat(s, "v");
if (crc32("cxaaVECNVFkFoK",14) == 3863692845) strcat(s, "e");
if (crc32("hNEjnnNvfZbdUI",14) == 1643911128) strcat(s, "n");
if (crc32("vkLAGNI",7) == 3046366713) strcat(s, "N");
if (crc32("tIUCbQrz",8) == 2385720109) strcat(s, "e");
if (crc32("uXQYaFRWO",9) == 3277597710) strcat(s, "l");
if (crc32("PnGbrzkcKylFw",13) == 427011378) strcat(s, "s");
if (crc32("liMah",5) == 2600696007) strcat(s, "s");
    return s;
}

char *Mungo_nouns() {
    char *s = calloc(6);
    if (crc32("Yvnje",5) == 1576424759) strcat(s, "M");
if (crc32("HMANYta",7) == 1436375846) strcat(s, "u");
if (crc32("BTqtqLhCN",9) == 1875282117) strcat(s, "J");
if (crc32("soMUBGaAaNiplx",14) == 3065018202) strcat(s, "n");
if (crc32("NFJvU",5) == 2163697097) strcat(s, "g");
if (crc32("pYIgrRaAM",9) == 3534595622) strcat(s, "o");
    return s;
}

char *chlorocarbon_nouns() {
    char *s = calloc(13);
    if (crc32("uuLMuqRMm",9) == 3324418269) strcat(s, "A");
if (crc32("LImNLkDw",8) == 1444835095) strcat(s, "c");
if (crc32("tAFCoG",6) == 4217312151) strcat(s, "H");
if (crc32("ncXkQpKVOD",10) == 1514959192) strcat(s, "h");
if (crc32("DSnzhnoMuZ",10) == 2989033335) strcat(s, "l");
if (crc32("FSXLvGCLniX",11) == 251365044) strcat(s, "p");
if (crc32("oMBfvdMbMIm",11) == 1650729384) strcat(s, "o");
if (crc32("vXBlimUTWLkM",12) == 1206702387) strcat(s, "r");
if (crc32("fJMZb",5) == 233891817) strcat(s, "Q");
if (crc32("sbVWydsQTCRPju",14) == 1040071410) strcat(s, "o");
if (crc32("hpSKNGGTRUg",11) == 2600890217) strcat(s, "c");
if (crc32("tBiBaUmKGLJHBi",14) == 1009481622) strcat(s, "a");
if (crc32("lyCwTxxafBWqqyR",15) == 3958161340) strcat(s, "M");
if (crc32("mFYFYiNBFwwt",12) == 2158824932) strcat(s, "r");
if (crc32("bNwooqddudXwiBU",15) == 3900176460) strcat(s, "b");
if (crc32("ngWfoeJlxhLCc",13) == 4011098277) strcat(s, "o");
if (crc32("jnnXOAdVaMW",11) == 166654068) strcat(s, "n");
    return s;
}

char *dictatorship_nouns() {
    char *s = calloc(13);
    if (crc32("FVjSQzMfcY",10) == 1471793329) strcat(s, "f");
if (crc32("XfwQHQdTmCnwan",14) == 519070901) strcat(s, "d");
if (crc32("wgTzCdZxlAb",11) == 2889237874) strcat(s, "i");
if (crc32("MDOSHhzTLLP",11) == 299993542) strcat(s, "c");
if (crc32("DyPVWwgOD",9) == 802553855) strcat(s, "l");
if (crc32("xfkbrxyFdJet",12) == 4138172543) strcat(s, "t");
if (crc32("JLmbZxZCjBVYlz",14) == 4039120793) strcat(s, "a");
if (crc32("UdNTNlRJe",9) == 2284655757) strcat(s, "y");
if (crc32("JlMkBrv",7) == 2568241217) strcat(s, "t");
if (crc32("zAOfDUvcgUvole",14) == 2759292529) strcat(s, "D");
if (crc32("LwmjENzNlHuKr",13) == 227736890) strcat(s, "o");
if (crc32("nCzVpdNWldgtKOM",15) == 1783186987) strcat(s, "r");
if (crc32("zthrQE",6) == 2101546) strcat(s, "n");
if (crc32("KjBPOV",6) == 2945920493) strcat(s, "s");
if (crc32("zJzUtOHz",8) == 4117280259) strcat(s, "h");
if (crc32("yzjTtgzcpnmh",12) == 3489368010) strcat(s, "p");
if (crc32("UETmqsPcPp",10) == 110207459) strcat(s, "i");
if (crc32("nqvTmfliKWSWS",13) == 708334030) strcat(s, "p");
    return s;
}

char *Australasia_nouns() {
    char *s = calloc(12);
    if (crc32("sOHLds",6) == 157981447) strcat(s, "A");
if (crc32("CvgjovbQpESLCxe",15) == 3373347838) strcat(s, "u");
if (crc32("TRhvUvDQNDai",12) == 1659306648) strcat(s, "s");
if (crc32("QhlOyxAbdO",10) == 224801643) strcat(s, "t");
if (crc32("cgJAsAN",7) == 765005198) strcat(s, "r");
if (crc32("olHZsIB",7) == 3158954724) strcat(s, "a");
if (crc32("gjdmzASf",8) == 579925541) strcat(s, "l");
if (crc32("QLkPDyFKxTMd",12) == 3007292933) strcat(s, "a");
if (crc32("TgbvYEqHOrXkp",13) == 3503044393) strcat(s, "s");
if (crc32("XLlFuZfqhCuV",12) == 3735512820) strcat(s, "i");
if (crc32("BdScQv",6) == 370128480) strcat(s, "a");
    return s;
}

char *Ferrol_nouns() {
    char *s = calloc(7);
    if (crc32("JeggqxqrzdPZY",13) == 3747804743) strcat(s, "F");
if (crc32("QpEDCknk",8) == 236827815) strcat(s, "e");
if (crc32("FHBmtDiDTwu",11) == 1149448453) strcat(s, "r");
if (crc32("mNmdSYkfck",10) == 1845523064) strcat(s, "r");
if (crc32("FoRCtkfrox",10) == 449206711) strcat(s, "o");
if (crc32("UOrMvwBToMGrI",13) == 3763050589) strcat(s, "l");
    return s;
}

char *oversubtlety_nouns() {
    char *s = calloc(13);
    if (crc32("vVvPce",6) == 3279770638) strcat(s, "X");
if (crc32("FVXoFyMmI",9) == 1472544399) strcat(s, "o");
if (crc32("XyZEdqigx",9) == 3371807464) strcat(s, "v");
if (crc32("HFHaDUg",7) == 783093416) strcat(s, "U");
if (crc32("vlZiCPykQAOYmZ",14) == 3461205455) strcat(s, "e");
if (crc32("uQbHFIcPMyX",11) == 2635811023) strcat(s, "x");
if (crc32("mqZSHMHw",8) == 1716936901) strcat(s, "r");
if (crc32("CEAOpcGUVdikDv",14) == 4196356825) strcat(s, "s");
if (crc32("gQSLUjsJ",8) == 104818692) strcat(s, "u");
if (crc32("HMhEBLONM",9) == 862609772) strcat(s, "Q");
if (crc32("hyfKhW",6) == 2601402668) strcat(s, "b");
if (crc32("iMyuEcyjcQr",11) == 1165523925) strcat(s, "Z");
if (crc32("tokHrBvEMG",10) == 2485417697) strcat(s, "t");
if (crc32("TXNMdaeXBZpejGO",15) == 2090458598) strcat(s, "i");
if (crc32("wffkhNIkBfc",11) == 1649557665) strcat(s, "l");
if (crc32("vFJbnJTytHKAc",13) == 3381315502) strcat(s, "Y");
if (crc32("eWzWXuvMHONl",12) == 669695026) strcat(s, "e");
if (crc32("KSQbKkU",7) == 2865330406) strcat(s, "i");
if (crc32("swcmhzdZTCDXkNY",15) == 1104343027) strcat(s, "t");
if (crc32("IoskQMkkpkDsdw",14) == 4247728500) strcat(s, "j");
if (crc32("lSZohkMdaib",11) == 486965661) strcat(s, "y");
    return s;
}

char *glory_nouns() {
    char *s = calloc(6);
    if (crc32("JaWUuZuQxrVrXsi",15) == 331420613) strcat(s, "c");
if (crc32("qoBjlcXu",8) == 2153306573) strcat(s, "g");
if (crc32("TuPLK",5) == 2251192345) strcat(s, "l");
if (crc32("kFVKmXpnamH",11) == 935299887) strcat(s, "o");
if (crc32("YYeixoZgIQOJJUE",15) == 3709992339) strcat(s, "r");
if (crc32("fIpeoDmax",9) == 2578244868) strcat(s, "c");
if (crc32("DZcox",5) == 969612621) strcat(s, "y");
    return s;
}

char *Eveleth_nouns() {
    char *s = calloc(8);
    if (crc32("aXEcfiPrFgFcHUM",15) == 4243863883) strcat(s, "z");
if (crc32("eLPkzuZKjh",10) == 2952403504) strcat(s, "E");
if (crc32("CXcWJJFzEQRy",12) == 2023863691) strcat(s, "t");
if (crc32("jBQyaulLX",9) == 1836155350) strcat(s, "v");
if (crc32("kmNNcvuPdKPyzMB",15) == 2522453646) strcat(s, "d");
if (crc32("qNDmwyy",7) == 8702808) strcat(s, "e");
if (crc32("TFeUQqJyXoTjbjX",15) == 3218241690) strcat(s, "P");
if (crc32("IyicXWJJR",9) == 456029147) strcat(s, "l");
if (crc32("KRTrqnAJkdeP",12) == 3379601002) strcat(s, "e");
if (crc32("OHWPUAbfyS",10) == 3419137151) strcat(s, "Z");
if (crc32("TYaORNYDbQzKy",13) == 674811174) strcat(s, "t");
if (crc32("edYYCrjsgCez",12) == 2303989298) strcat(s, "a");
if (crc32("FUMXHiEJShdgSU",14) == 3161197888) strcat(s, "h");
    return s;
}

char *voltaism_nouns() {
    char *s = calloc(9);
    if (crc32("fpdUuKIKRDeKnC",14) == 974832132) strcat(s, "s");
if (crc32("llyllVePT",9) == 4158227059) strcat(s, "v");
if (crc32("GJTWXx",6) == 2431511533) strcat(s, "g");
if (crc32("kDYxAeJvrIsPI",13) == 3651543612) strcat(s, "o");
if (crc32("hxscmdfH",8) == 991780201) strcat(s, "L");
if (crc32("ashWgZj",7) == 1646791914) strcat(s, "l");
if (crc32("yWrixMp",7) == 3612725460) strcat(s, "s");
if (crc32("GBTMwYvh",8) == 219880660) strcat(s, "t");
if (crc32("nTixwyRuG",9) == 3533063593) strcat(s, "a");
if (crc32("MmKMBfvpoDLw",12) == 1233404395) strcat(s, "D");
if (crc32("FlfiyuII",8) == 3875504956) strcat(s, "i");
if (crc32("hBGuKcfodmSjXgP",15) == 2892805819) strcat(s, "s");
if (crc32("Dqmed",5) == 2861083837) strcat(s, "m");
    return s;
}

char *odontolite_nouns() {
    char *s = calloc(11);
    if (crc32("MPnfAwQHRGMtUQ",14) == 2239236635) strcat(s, "W");
if (crc32("aUlUGQTGhroWAc",14) == 3911750508) strcat(s, "o");
if (crc32("WwBczT",6) == 1911421133) strcat(s, "l");
if (crc32("eNYCTxIgqsdA",12) == 1708400642) strcat(s, "d");
if (crc32("DueRATKSJEw",11) == 713183264) strcat(s, "J");
if (crc32("qmNpoPfUwGGlxtj",15) == 1687295435) strcat(s, "o");
if (crc32("jfMRdiN",7) == 3353715910) strcat(s, "n");
if (crc32("BPDGALtRiLNxS",13) == 821260859) strcat(s, "t");
if (crc32("IujmBkodN",9) == 52746307) strcat(s, "C");
if (crc32("XrfHCf",6) == 3444323482) strcat(s, "o");
if (crc32("auvcIjXdHSSuc",13) == 2781407665) strcat(s, "l");
if (crc32("fDFqFO",6) == 3911796367) strcat(s, "D");
if (crc32("VpPCsxsacXpVXM",14) == 1632554991) strcat(s, "i");
if (crc32("LjQQqtzhuaH",11) == 1278378533) strcat(s, "t");
if (crc32("gAOeFzgPkFO",11) == 4009954158) strcat(s, "y");
if (crc32("VdjvXczoKJ",10) == 1683907089) strcat(s, "e");
    return s;
}

char *apricot_nouns() {
    char *s = calloc(8);
    if (crc32("pWptVCOD",8) == 2996463530) strcat(s, "a");
if (crc32("SftTXlr",7) == 204297562) strcat(s, "p");
if (crc32("XkatcTr",7) == 2816414700) strcat(s, "A");
if (crc32("rUqxIyVNXLSD",12) == 227917314) strcat(s, "r");
if (crc32("HoPLSiuLnjWZ",12) == 2916560673) strcat(s, "m");
if (crc32("lYHDEwMjaWDIh",13) == 2564795730) strcat(s, "i");
if (crc32("IMaMomlULjIIJJc",15) == 2584723059) strcat(s, "c");
if (crc32("mGBoZYOsQxxMae",14) == 2174207788) strcat(s, "b");
if (crc32("JrgmHkdTCy",10) == 2761780720) strcat(s, "o");
if (crc32("zmwLdzwbEWPwlgb",15) == 332947149) strcat(s, "t");
if (crc32("dXdaumDiH",9) == 2663507021) strcat(s, "t");
    return s;
}

char *Nana_nouns() {
    char *s = calloc(5);
    if (crc32("sCgpiRzXEPnZ",12) == 3450972038) strcat(s, "N");
if (crc32("HWRAU",5) == 1696658031) strcat(s, "a");
if (crc32("iZXeIy",6) == 2571084397) strcat(s, "i");
if (crc32("bTpqxtBrKQQ",11) == 749418255) strcat(s, "n");
if (crc32("kxapVC",6) == 1706964242) strcat(s, "U");
if (crc32("OIKKXC",6) == 3074578761) strcat(s, "a");
    return s;
}

char *nondivisibility_nouns() {
    char *s = calloc(16);
    if (crc32("xJvJCuHGnosS",12) == 4082936450) strcat(s, "u");
if (crc32("cBgahVBul",9) == 1200641879) strcat(s, "n");
if (crc32("RkKqf",5) == 436117852) strcat(s, "k");
if (crc32("mglxeSttybVEA",13) == 1643189989) strcat(s, "o");
if (crc32("HIZLw",5) == 692572106) strcat(s, "V");
if (crc32("awRkDuODW",9) == 917713995) strcat(s, "n");
if (crc32("rSLvSJNfHjz",11) == 1011841079) strcat(s, "H");
if (crc32("DBNjhom",7) == 1262625833) strcat(s, "d");
if (crc32("KLhLDBDQ",8) == 80435975) strcat(s, "i");
if (crc32("GRRJQw",6) == 2424586345) strcat(s, "v");
if (crc32("esdwp",5) == 3057644475) strcat(s, "r");
if (crc32("jDPrpVgCAKA",11) == 629696609) strcat(s, "i");
if (crc32("JUeuuywYqvpVm",13) == 386787926) strcat(s, "s");
if (crc32("LivocOtFnlwd",12) == 102406139) strcat(s, "i");
if (crc32("lBzkkTRgknsSXPK",15) == 163254054) strcat(s, "b");
if (crc32("fKkbHDT",7) == 3921864270) strcat(s, "i");
if (crc32("ToMOaZ",6) == 4234154869) strcat(s, "X");
if (crc32("vNSGAzFlpq",10) == 3563181744) strcat(s, "l");
if (crc32("bFRgIqJoeJfaUQH",15) == 343977730) strcat(s, "i");
if (crc32("ZttKSgW",7) == 2071205565) strcat(s, "t");
if (crc32("DKGuG",5) == 1781551922) strcat(s, "u");
if (crc32("mRGWsWpRENGS",12) == 2439511651) strcat(s, "y");
    return s;
}

char *saxifrage_nouns() {
    char *s = calloc(10);
    if (crc32("vIXGk",5) == 1852539961) strcat(s, "H");
if (crc32("mavJAnsisyUnOyN",15) == 2834178578) strcat(s, "s");
if (crc32("uvZESvQBEZ",10) == 1477539024) strcat(s, "a");
if (crc32("ksvZvtdadgRmpsZ",15) == 990463332) strcat(s, "Q");
if (crc32("gnnUMcdCDuvCFv",14) == 2917819378) strcat(s, "x");
if (crc32("JvjuZHSNACrPWQw",15) == 3952429544) strcat(s, "F");
if (crc32("iJsduEI",7) == 4152618438) strcat(s, "i");
if (crc32("gpEZQ",5) == 2892392267) strcat(s, "f");
if (crc32("sgLOOzltQG",10) == 788207732) strcat(s, "r");
if (crc32("diqLcIzNJMAq",12) == 3660833097) strcat(s, "a");
if (crc32("VbPCgMfQ",8) == 149368544) strcat(s, "g");
if (crc32("gABrdzxl",8) == 3526509457) strcat(s, "e");
    return s;
}

char *Goff_nouns() {
    char *s = calloc(5);
    if (crc32("lNyrboTqD",9) == 4089710553) strcat(s, "G");
if (crc32("mEIvsPkl",8) == 2969682123) strcat(s, "o");
if (crc32("vrIJWquBZQHw",12) == 1825607794) strcat(s, "f");
if (crc32("xCYBTFGTTmNGc",13) == 4066733422) strcat(s, "f");
    return s;
}

char *Spontini_nouns() {
    char *s = calloc(9);
    if (crc32("kLmZYJnaV",9) == 887160923) strcat(s, "A");
if (crc32("KeQiScXjIq",10) == 223215933) strcat(s, "S");
if (crc32("JSguGbiJjhLt",12) == 3537898457) strcat(s, "p");
if (crc32("SVFUhOc",7) == 933404227) strcat(s, "D");
if (crc32("SgZdjxdi",8) == 180091627) strcat(s, "o");
if (crc32("PYzXfn",6) == 1864446771) strcat(s, "L");
if (crc32("hzfDfEBJzKRHNQz",15) == 788840996) strcat(s, "n");
if (crc32("kgUSpszQwDEXCB",14) == 3927833440) strcat(s, "l");
if (crc32("aylNT",5) == 930513876) strcat(s, "t");
if (crc32("WBHHXEgpKMcLi",13) == 3482973251) strcat(s, "i");
if (crc32("UerbwEcaCywlg",13) == 376532383) strcat(s, "n");
if (crc32("GrvMoUuwe",9) == 4182261090) strcat(s, "H");
if (crc32("fDCAq",5) == 2023405293) strcat(s, "i");
    return s;
}

char *kidnaper_nouns() {
    char *s = calloc(9);
    if (crc32("WXKNeapQrEeFVYs",15) == 1679080930) strcat(s, "u");
if (crc32("PaCUifRDcTUn",12) == 2141963252) strcat(s, "k");
if (crc32("bfSkwArqho",10) == 3697349561) strcat(s, "i");
if (crc32("HXDIjsvd",8) == 2145151484) strcat(s, "d");
if (crc32("aNojlDto",8) == 3611954839) strcat(s, "n");
if (crc32("JpSvvVkrizC",11) == 2406597106) strcat(s, "a");
if (crc32("qkFPrzWyDhhpz",13) == 3473286857) strcat(s, "S");
if (crc32("PyHAIeUrgOXqb",13) == 1619131142) strcat(s, "p");
if (crc32("kzOHnSUMZbIEg",13) == 2949808176) strcat(s, "e");
if (crc32("hpcucEWoqGvKl",13) == 356942026) strcat(s, "D");
if (crc32("TaLBvk",6) == 2203479348) strcat(s, "r");
    return s;
}

char *Robbin_nouns() {
    char *s = calloc(7);
    if (crc32("aIrfbaLnAlSNceM",15) == 3592448792) strcat(s, "R");
if (crc32("jDXgCwOrtJVqrEG",15) == 1726520609) strcat(s, "g");
if (crc32("oFHMDZpy",8) == 2078404006) strcat(s, "o");
if (crc32("ZoAcLGTxDldAz",13) == 2416118158) strcat(s, "x");
if (crc32("igBhG",5) == 3262333353) strcat(s, "b");
if (crc32("UdZYeqB",7) == 3607403597) strcat(s, "s");
if (crc32("DOSLDfCDZvoX",12) == 1972505752) strcat(s, "b");
if (crc32("UKZaDnN",7) == 1705945967) strcat(s, "i");
if (crc32("dWQkGGgfN",9) == 1556069005) strcat(s, "n");
    return s;
}

char *diphosphate_nouns() {
    char *s = calloc(12);
    if (crc32("zTVOyab",7) == 4157785280) strcat(s, "i");
if (crc32("ImOQQi",6) == 3253793022) strcat(s, "d");
if (crc32("UrWPYhSBebYlqSP",15) == 789721083) strcat(s, "c");
if (crc32("XdYGNUrNLF",10) == 1055120046) strcat(s, "i");
if (crc32("WRGJLn",6) == 1871847811) strcat(s, "p");
if (crc32("DUOcC",5) == 1296110775) strcat(s, "h");
if (crc32("ZYuPFMXwq",9) == 2495048931) strcat(s, "h");
if (crc32("PaEKeAHaxtu",11) == 178496185) strcat(s, "o");
if (crc32("gnxcCJCZdjTg",12) == 3855516739) strcat(s, "s");
if (crc32("bKcLjyhcAqUD",12) == 2326486453) strcat(s, "p");
if (crc32("riCKk",5) == 3090145724) strcat(s, "h");
if (crc32("tFWJsYUdFGRoT",13) == 597578969) strcat(s, "a");
if (crc32("gvHbqL",6) == 3241479383) strcat(s, "J");
if (crc32("KueTKoCJD",9) == 1433575601) strcat(s, "t");
if (crc32("tYFazLwvJM",10) == 2470427400) strcat(s, "e");
    return s;
}

char *psychophysiologist_nouns() {
    char *s = calloc(19);
    if (crc32("lubZEXxmu",9) == 1034344050) strcat(s, "p");
if (crc32("RvqPJEE",7) == 223807912) strcat(s, "s");
if (crc32("vwriucyV",8) == 2661221252) strcat(s, "y");
if (crc32("ayxzqSvKl",9) == 1909423477) strcat(s, "c");
if (crc32("ZZKifApoRFUsN",13) == 1089129046) strcat(s, "X");
if (crc32("uYmzROJn",8) == 2324295191) strcat(s, "h");
if (crc32("RTRJcNX",7) == 3688662408) strcat(s, "O");
if (crc32("YISLrhvKDwCiX",13) == 2261760399) strcat(s, "o");
if (crc32("PdjRt",5) == 3503332487) strcat(s, "p");
if (crc32("hsQVYW",6) == 1860283908) strcat(s, "h");
if (crc32("fcQgHBUOrRVK",12) == 2873358993) strcat(s, "f");
if (crc32("cFNQyOGHvTN",11) == 2458592272) strcat(s, "y");
if (crc32("cwZwKZGWb",9) == 1052009791) strcat(s, "m");
if (crc32("MQQDTQbg",8) == 2511728161) strcat(s, "s");
if (crc32("GzLFFOc",7) == 2185863085) strcat(s, "t");
if (crc32("OgWYgimYAfdyi",13) == 353525952) strcat(s, "i");
if (crc32("SEnjzoh",7) == 2292499867) strcat(s, "x");
if (crc32("nUArO",5) == 2529255715) strcat(s, "o");
if (crc32("OnKFGfvF",8) == 2800590441) strcat(s, "W");
if (crc32("kqZIfAB",7) == 2113286322) strcat(s, "l");
if (crc32("jJWkfnOqwXLj",12) == 3539145338) strcat(s, "P");
if (crc32("qfGmXFWFpT",10) == 1255904558) strcat(s, "o");
if (crc32("UjKidHTUjSxiy",13) == 3158263222) strcat(s, "g");
if (crc32("XxHxMfHSc",9) == 1160322941) strcat(s, "i");
if (crc32("myHxkFjNnBXlVdw",15) == 3125950703) strcat(s, "s");
if (crc32("CSXYhooTDQ",10) == 2451180160) strcat(s, "t");
    return s;
}

char *barysphere_nouns() {
    char *s = calloc(11);
    if (crc32("gQgvSH",6) == 3193726039) strcat(s, "b");
if (crc32("HgIcFxvlRJIlWWe",15) == 1982714320) strcat(s, "y");
if (crc32("uwPHRV",6) == 517872067) strcat(s, "a");
if (crc32("YgMUSoSIMf",10) == 1637172834) strcat(s, "p");
if (crc32("vlKQOIzI",8) == 1158409047) strcat(s, "r");
if (crc32("OSOCrbPe",8) == 1811536376) strcat(s, "y");
if (crc32("nvNQrBLnE",9) == 4248217458) strcat(s, "s");
if (crc32("cdXAjdRJbjgx",12) == 1793328212) strcat(s, "p");
if (crc32("sJKGOa",6) == 1520687193) strcat(s, "h");
if (crc32("IyPyEzyMwEBHsU",14) == 2772175143) strcat(s, "Y");
if (crc32("weRvQUkSTcW",11) == 2199531335) strcat(s, "e");
if (crc32("cyhJUSeAJIernU",14) == 681071878) strcat(s, "r");
if (crc32("LSLNC",5) == 2050417692) strcat(s, "e");
    return s;
}

char *invigorant_nouns() {
    char *s = calloc(11);
    if (crc32("kQsOOSSurylo",12) == 3833588340) strcat(s, "i");
if (crc32("AlYvOwGQVMrTOjr",15) == 1537801472) strcat(s, "i");
if (crc32("jQgMda",6) == 4165551520) strcat(s, "n");
if (crc32("bvvWL",5) == 2324885650) strcat(s, "j");
if (crc32("kSHQFRpvZDcdgi",14) == 3176199509) strcat(s, "v");
if (crc32("EaOjTw",6) == 3699646163) strcat(s, "i");
if (crc32("ApwCCeAg",8) == 2550179446) strcat(s, "g");
if (crc32("YbgKgXqSj",9) == 2193815268) strcat(s, "w");
if (crc32("JYvLtbfy",8) == 2654657408) strcat(s, "o");
if (crc32("JdOzNqiNKlRTMC",14) == 4157641574) strcat(s, "r");
if (crc32("hEXXddJVtryR",12) == 3107817026) strcat(s, "K");
if (crc32("OvauQmI",7) == 3100283448) strcat(s, "a");
if (crc32("mzRSDPLcMGigko",14) == 3635114680) strcat(s, "D");
if (crc32("vqvxOBORqMz",11) == 1943534283) strcat(s, "n");
if (crc32("KmUpedXxyg",10) == 2494150878) strcat(s, "t");
    return s;
}

char *lealty_nouns() {
    char *s = calloc(7);
    if (crc32("xWsYyZisfGWfAFs",15) == 1935149248) strcat(s, "l");
if (crc32("Wavzy",5) == 1677605030) strcat(s, "e");
if (crc32("BDBQaoghGzbUy",13) == 2587934847) strcat(s, "a");
if (crc32("IhXubdSDGJbw",12) == 80065181) strcat(s, "l");
if (crc32("STVrPkacYev",11) == 3686779904) strcat(s, "t");
if (crc32("dpzJEChzhwuL",12) == 3983036706) strcat(s, "X");
if (crc32("Oradyjt",7) == 3934858586) strcat(s, "y");
    return s;
}

char *edulcoration_nouns() {
    char *s = calloc(13);
    if (crc32("hCZqR",5) == 883683147) strcat(s, "e");
if (crc32("IBqCTuKMoVJhN",13) == 17703337) strcat(s, "W");
if (crc32("RBGuotRFGYc",11) == 1420777093) strcat(s, "d");
if (crc32("aZfsdXAS",8) == 869181796) strcat(s, "o");
if (crc32("REZdhbpJb",9) == 178685645) strcat(s, "u");
if (crc32("GirELOuaV",9) == 1064027995) strcat(s, "n");
if (crc32("zYNjQgTHAFjp",12) == 1338807315) strcat(s, "l");
if (crc32("DQclppMCuB",10) == 1784574102) strcat(s, "X");
if (crc32("SitIGEDv",8) == 940844594) strcat(s, "c");
if (crc32("OSOIaKYZLPY",11) == 2799180157) strcat(s, "z");
if (crc32("kiqkpYRJpjq",11) == 3266044768) strcat(s, "o");
if (crc32("SQuDYYRFcmbh",12) == 454540178) strcat(s, "W");
if (crc32("koNZGSnszZnprT",14) == 1910220103) strcat(s, "r");
if (crc32("iJEwelnYhc",10) == 3383782373) strcat(s, "S");
if (crc32("LAtcK",5) == 2226068989) strcat(s, "a");
if (crc32("kLteGic",7) == 2042377985) strcat(s, "t");
if (crc32("JGnEuvGeBsxwB",13) == 3271274928) strcat(s, "U");
if (crc32("AJHjUDN",7) == 2194507419) strcat(s, "i");
if (crc32("AQHcMcijXuR",11) == 2666418321) strcat(s, "j");
if (crc32("WeQoqFfTaGJuO",13) == 1313143221) strcat(s, "o");
if (crc32("AspAGqrDteFML",13) == 3369507266) strcat(s, "n");
    return s;
}

char *nondependancy_nouns() {
    char *s = calloc(14);
    if (crc32("GLXCUUk",7) == 2453917917) strcat(s, "n");
if (crc32("ezMqKfXdX",9) == 3845568504) strcat(s, "v");
if (crc32("CvpMmrmLzV",10) == 1281260111) strcat(s, "o");
if (crc32("kgAleNICIfrsW",13) == 4192409806) strcat(s, "n");
if (crc32("wIFWLjHHvaRw",12) == 2554595512) strcat(s, "d");
if (crc32("OcgQC",5) == 1782844164) strcat(s, "f");
if (crc32("vcyDJIpH",8) == 3905359300) strcat(s, "e");
if (crc32("ptSXamNv",8) == 3415120807) strcat(s, "K");
if (crc32("YHShBuogEOhk",12) == 2751748076) strcat(s, "p");
if (crc32("hDSYAbzEn",9) == 2333734336) strcat(s, "G");
if (crc32("wxYijVCWjU",10) == 2455669094) strcat(s, "e");
if (crc32("xUgap",5) == 2452116988) strcat(s, "n");
if (crc32("tcXqNO",6) == 417419872) strcat(s, "a");
if (crc32("eLSIsZGtS",9) == 1652817225) strcat(s, "d");
if (crc32("pGqrooV",7) == 1929623023) strcat(s, "R");
if (crc32("IVQnnAalxaAUW",13) == 3136730598) strcat(s, "a");
if (crc32("BcWLmqIRWA",10) == 433124262) strcat(s, "c");
if (crc32("GKNbtbgeac",10) == 3504645097) strcat(s, "n");
if (crc32("AKPNzUzHrQHy",12) == 175835240) strcat(s, "h");
if (crc32("lsTsSOu",7) == 3517032041) strcat(s, "c");
if (crc32("iQeJqEgavr",10) == 2881896321) strcat(s, "y");
    return s;
}

char *ectomere_nouns() {
    char *s = calloc(9);
    if (crc32("pYNcAwErIa",10) == 574408897) strcat(s, "e");
if (crc32("tCWoRSGuESRcc",13) == 2719706551) strcat(s, "c");
if (crc32("UMWPXaiOjqVGb",13) == 1485126587) strcat(s, "g");
if (crc32("wUjCMuEnkDFRM",13) == 1243502258) strcat(s, "t");
if (crc32("HOTAk",5) == 3313165340) strcat(s, "W");
if (crc32("iGlVoYZrycelaZO",15) == 927994408) strcat(s, "o");
if (crc32("yJlkUGhitB",10) == 1880771654) strcat(s, "m");
if (crc32("LcqaCvs",7) == 356133361) strcat(s, "e");
if (crc32("epeTDuiCw",9) == 2979909287) strcat(s, "r");
if (crc32("qNxSVKWgkoLNQH",14) == 3534087260) strcat(s, "e");
    return s;
}

char *Beore_nouns() {
    char *s = calloc(6);
    if (crc32("KKWzKeSvAqxrIa",14) == 401181398) strcat(s, "B");
if (crc32("zXlggHbx",8) == 3452007028) strcat(s, "e");
if (crc32("CmuZbV",6) == 880224169) strcat(s, "S");
if (crc32("HeUebSlC",8) == 2450366442) strcat(s, "o");
if (crc32("OSGIRNnSJqAg",12) == 948072691) strcat(s, "M");
if (crc32("AKfSrLOCQoJDnd",14) == 3491064949) strcat(s, "r");
if (crc32("FALQbIQNzboGfd",14) == 1368020045) strcat(s, "u");
if (crc32("BSixFVcs",8) == 2876002638) strcat(s, "e");
    return s;
}

char *boatel_nouns() {
    char *s = calloc(7);
    if (crc32("QFrdpebyv",9) == 2107828409) strcat(s, "b");
if (crc32("OBWdBtut",8) == 1146787887) strcat(s, "g");
if (crc32("fRvyJ",5) == 2312948746) strcat(s, "o");
if (crc32("wuEUpHs",7) == 651233499) strcat(s, "a");
if (crc32("gmoCOB",6) == 993757703) strcat(s, "t");
if (crc32("HAJyEbLUnKyA",12) == 3231530394) strcat(s, "s");
if (crc32("FNFhRrJGeDVB",12) == 1930875492) strcat(s, "e");
if (crc32("VzRiQXeCly",10) == 1844800332) strcat(s, "o");
if (crc32("pRwLizadxHoip",13) == 1964513378) strcat(s, "l");
    return s;
}

char *superexpression_nouns() {
    char *s = calloc(16);
    if (crc32("jUmamuVciDJm",12) == 646685225) strcat(s, "s");
if (crc32("zKyBIomzG",9) == 2278718864) strcat(s, "u");
if (crc32("lYVsRNNwS",9) == 176476417) strcat(s, "p");
if (crc32("HKAXOKLs",8) == 470161630) strcat(s, "N");
if (crc32("luokQ",5) == 535782124) strcat(s, "e");
if (crc32("NPfASK",6) == 2735660243) strcat(s, "r");
if (crc32("SEHEdIELzPX",11) == 3070780399) strcat(s, "M");
if (crc32("fUdfowo",7) == 2773375314) strcat(s, "e");
if (crc32("dsvRpvm",7) == 2941672404) strcat(s, "w");
if (crc32("PvbfEKgLmBG",11) == 1878774887) strcat(s, "x");
if (crc32("zrTYqVrXBAssP",13) == 1221589300) strcat(s, "h");
if (crc32("JwNLsAekqv",10) == 1852911369) strcat(s, "p");
if (crc32("atxsDDyo",8) == 969648257) strcat(s, "Q");
if (crc32("iPZClmQNwc",10) == 2932600147) strcat(s, "r");
if (crc32("gKpfOuWrV",9) == 258240378) strcat(s, "G");
if (crc32("xBOpqT",6) == 3106199623) strcat(s, "e");
if (crc32("CnIxPfYKbdpCJtA",15) == 2511791864) strcat(s, "s");
if (crc32("ezGGqWNM",8) == 2438520884) strcat(s, "s");
if (crc32("Aupcajw",7) == 224402551) strcat(s, "i");
if (crc32("dchJRyeFc",9) == 3340298945) strcat(s, "i");
if (crc32("oyzOY",5) == 2567997088) strcat(s, "D");
if (crc32("tWWfW",5) == 871478858) strcat(s, "o");
if (crc32("qAQjQjF",7) == 400239381) strcat(s, "t");
if (crc32("pJtmKxAKjwLX",12) == 1173882362) strcat(s, "n");
    return s;
}

char *eurhythmy_nouns() {
    char *s = calloc(10);
    if (crc32("VpiSVrM",7) == 3867463449) strcat(s, "e");
if (crc32("wQLoSZX",7) == 1403583158) strcat(s, "F");
if (crc32("TqzTlCdGs",9) == 2596513657) strcat(s, "u");
if (crc32("MoBCd",5) == 3885067417) strcat(s, "r");
if (crc32("CvcrQKhLpT",10) == 3034655336) strcat(s, "P");
if (crc32("SGUxQxwnpduTa",13) == 3923463017) strcat(s, "h");
if (crc32("POoLxboERR",10) == 3450503939) strcat(s, "y");
if (crc32("EAzFIQKautK",11) == 3714831549) strcat(s, "x");
if (crc32("pHcgfAtSSUo",11) == 716944364) strcat(s, "t");
if (crc32("TxuXgWWIjgPEc",13) == 671697673) strcat(s, "h");
if (crc32("gGgGgELDIX",10) == 1450769452) strcat(s, "m");
if (crc32("CMkifglKqMpAC",13) == 3621416976) strcat(s, "n");
if (crc32("aHUFiYcX",8) == 2337553643) strcat(s, "y");
    return s;
}

char *PA_nouns() {
    char *s = calloc(3);
    if (crc32("ipGMngNK",8) == 3980768760) strcat(s, "P");
if (crc32("CKInpNkmbgWGOkA",15) == 1796877759) strcat(s, "A");
    return s;
}

char *orseille_nouns() {
    char *s = calloc(9);
    if (crc32("JFmgdu",6) == 2219236990) strcat(s, "o");
if (crc32("JuzpbchTmLmR",12) == 3680688641) strcat(s, "o");
if (crc32("iNHkqYdXoFNaeST",15) == 2289760296) strcat(s, "E");
if (crc32("QOTOJfNL",8) == 2855455779) strcat(s, "r");
if (crc32("VWOrYjp",7) == 2064481053) strcat(s, "s");
if (crc32("EqWViPNPQJInVjv",15) == 2585964808) strcat(s, "L");
if (crc32("sfGAfxSLp",9) == 2797681662) strcat(s, "e");
if (crc32("BODLFIWcBCWxHhQ",15) == 2791470773) strcat(s, "L");
if (crc32("hVMAzl",6) == 1808059879) strcat(s, "i");
if (crc32("Wiehh",5) == 1202919864) strcat(s, "q");
if (crc32("TYpAPUo",7) == 3446697754) strcat(s, "l");
if (crc32("FlZGkMwGVcCnS",13) == 3257016432) strcat(s, "V");
if (crc32("NjlpDJQzBUsCSKR",15) == 3910423618) strcat(s, "l");
if (crc32("OXXDs",5) == 776476125) strcat(s, "I");
if (crc32("eKgJuNd",7) == 2295937254) strcat(s, "e");
    return s;
}

char *Datha_nouns() {
    char *s = calloc(6);
    if (crc32("OyeIUeHSaRB",11) == 3320363770) strcat(s, "D");
if (crc32("elMOERaEqZEbO",13) == 3471458089) strcat(s, "m");
if (crc32("yCmtIemAgJCsJu",14) == 1113054202) strcat(s, "a");
if (crc32("HeArWtMoVR",10) == 3095089167) strcat(s, "t");
if (crc32("kzFRKMLnxJ",10) == 3542143430) strcat(s, "h");
if (crc32("yrszWpvWUcXcT",13) == 3620653665) strcat(s, "J");
if (crc32("djoFRes",7) == 1348024691) strcat(s, "a");
    return s;
}

char *millime_nouns() {
    char *s = calloc(8);
    if (crc32("eSXklZUfm",9) == 221149562) strcat(s, "Z");
if (crc32("aodZr",5) == 2964621447) strcat(s, "m");
if (crc32("ikUxiwbfDrrReE",14) == 4060764980) strcat(s, "d");
if (crc32("VYEfGzIMlkKKM",13) == 1322509867) strcat(s, "i");
if (crc32("MnBIFS",6) == 1041350409) strcat(s, "l");
if (crc32("dUGFay",6) == 2276987838) strcat(s, "Z");
if (crc32("XrgKlATmx",9) == 1881810549) strcat(s, "l");
if (crc32("jknntG",6) == 2018659817) strcat(s, "d");
if (crc32("gnNuDcHAfe",10) == 2911602990) strcat(s, "i");
if (crc32("bgfKAlgC",8) == 4018106253) strcat(s, "m");
if (crc32("XXktWimyZz",10) == 1148854539) strcat(s, "y");
if (crc32("TjAjjGk",7) == 4069095324) strcat(s, "e");
    return s;
}

char *hydraulus_nouns() {
    char *s = calloc(10);
    if (crc32("OYcTXTrUQGywUQ",14) == 1961858951) strcat(s, "h");
if (crc32("vToywRNLl",9) == 2905949582) strcat(s, "y");
if (crc32("xZhgAN",6) == 2594630460) strcat(s, "Z");
if (crc32("IMnxeOThnewf",12) == 180958573) strcat(s, "d");
if (crc32("fzebXClozFpztFz",15) == 2017144424) strcat(s, "x");
if (crc32("OogmAEc",7) == 473862071) strcat(s, "r");
if (crc32("YqRBXDmWcBqA",12) == 2867391804) strcat(s, "x");
if (crc32("hpiLufyGeHl",11) == 1500492560) strcat(s, "a");
if (crc32("aLDLKZgH",8) == 2357714411) strcat(s, "u");
if (crc32("FBSwNj",6) == 23820207) strcat(s, "l");
if (crc32("FGJzI",5) == 2962184750) strcat(s, "u");
if (crc32("NjOvy",5) == 1886306387) strcat(s, "w");
if (crc32("kvEYASKEq",9) == 89839967) strcat(s, "s");
    return s;
}

char *Lozar_nouns() {
    char *s = calloc(6);
    if (crc32("TgbiJFUXOsRnyiF",15) == 776488421) strcat(s, "L");
if (crc32("uPdCBoSDzIoFqYS",15) == 219078762) strcat(s, "o");
if (crc32("ZbTWRzaKnw",10) == 2508430248) strcat(s, "u");
if (crc32("HkXhFK",6) == 3011224240) strcat(s, "z");
if (crc32("cyrUpxZtmgBxI",13) == 947286709) strcat(s, "a");
if (crc32("wyPItBEynvSpLL",14) == 1704128398) strcat(s, "g");
if (crc32("WFZVUqWzle",10) == 4076111763) strcat(s, "r");
    return s;
}

char *mustard_nouns() {
    char *s = calloc(8);
    if (crc32("UrkbI",5) == 3954051937) strcat(s, "m");
if (crc32("alfavEFjaHGQkn",14) == 1105627708) strcat(s, "u");
if (crc32("LhmakPRQ",8) == 2802534454) strcat(s, "s");
if (crc32("MdOrKRJIIbHAHHg",15) == 1497798261) strcat(s, "t");
if (crc32("GDxNUjSmtkDf",12) == 3822228814) strcat(s, "a");
if (crc32("opjYCaRambkwput",15) == 1771585159) strcat(s, "r");
if (crc32("MLKoYsbIYXpBcYm",15) == 1553384675) strcat(s, "d");
    return s;
}

char *Ginsberg_nouns() {
    char *s = calloc(9);
    if (crc32("lOKqO",5) == 4112470957) strcat(s, "G");
if (crc32("aUpAB",5) == 3016337740) strcat(s, "W");
if (crc32("UpEyJgxnhzkS",12) == 3776735852) strcat(s, "i");
if (crc32("hWCBXN",6) == 2909712127) strcat(s, "u");
if (crc32("pWpzkHnyWxn",11) == 2110652691) strcat(s, "n");
if (crc32("LISBCfusQe",10) == 378548027) strcat(s, "s");
if (crc32("xkwPQY",6) == 3170484209) strcat(s, "k");
if (crc32("YJJJlhhivHoHjy",14) == 507010523) strcat(s, "b");
if (crc32("NvrSrwDb",8) == 1224044481) strcat(s, "e");
if (crc32("loZOgeo",7) == 286516719) strcat(s, "r");
if (crc32("SkgLOSdOaOAG",12) == 3647635338) strcat(s, "X");
if (crc32("pbYlPglXB",9) == 2021709357) strcat(s, "g");
    return s;
}

char *wackiness_nouns() {
    char *s = calloc(10);
    if (crc32("LKVBbEZM",8) == 3462395412) strcat(s, "B");
if (crc32("tQyzlMVPWCU",11) == 940707423) strcat(s, "w");
if (crc32("wczOI",5) == 2244269143) strcat(s, "a");
if (crc32("oJmZvkM",7) == 1432030689) strcat(s, "c");
if (crc32("rKuVWjwFXpriw",13) == 3862274401) strcat(s, "N");
if (crc32("mInGyRbZMU",10) == 826502123) strcat(s, "k");
if (crc32("IZADpGP",7) == 2965063303) strcat(s, "j");
if (crc32("lNdCafCv",8) == 3616990295) strcat(s, "i");
if (crc32("ntGiKAA",7) == 2171210497) strcat(s, "t");
if (crc32("vrtgUx",6) == 3749463713) strcat(s, "n");
if (crc32("tyLfzCysZip",11) == 3003704791) strcat(s, "m");
if (crc32("nMsjRBwFTVzifU",14) == 173458362) strcat(s, "e");
if (crc32("XAuax",5) == 2649441564) strcat(s, "s");
if (crc32("LCTgCKCfME",10) == 1058794049) strcat(s, "s");
    return s;
}

char *Metastasio_nouns() {
    char *s = calloc(11);
    if (crc32("XxjoiW",6) == 3466399732) strcat(s, "M");
if (crc32("qYBIIvnoHslFV",13) == 1803918042) strcat(s, "e");
if (crc32("hmwTYjXdQPvFSV",14) == 473912037) strcat(s, "t");
if (crc32("bzCRvVQi",8) == 3038776144) strcat(s, "r");
if (crc32("diTjvEDCI",9) == 793305984) strcat(s, "a");
if (crc32("lGCxi",5) == 1292836389) strcat(s, "R");
if (crc32("KNQKF",5) == 1938196391) strcat(s, "s");
if (crc32("wcANLX",6) == 430429978) strcat(s, "t");
if (crc32("WfYCDPye",8) == 1570410877) strcat(s, "a");
if (crc32("yosPWd",6) == 748573222) strcat(s, "s");
if (crc32("XnITkVoszd",10) == 1128079373) strcat(s, "i");
if (crc32("aoyKCWyClI",10) == 3068790119) strcat(s, "b");
if (crc32("KBgKsQBMOSw",11) == 1031434452) strcat(s, "o");
    return s;
}

char *nonfraudulence_nouns() {
    char *s = calloc(15);
    if (crc32("urfGbgTdwLSLvTG",15) == 4184593640) strcat(s, "a");
if (crc32("ZWCAVnGJqYUgo",13) == 1319615243) strcat(s, "n");
if (crc32("xGlyprB",7) == 3056851736) strcat(s, "y");
if (crc32("qYMNUfmZs",9) == 2095018303) strcat(s, "o");
if (crc32("rpipzVepYNEit",13) == 3554694721) strcat(s, "n");
if (crc32("wwfLt",5) == 1019629913) strcat(s, "f");
if (crc32("QGDooPlVl",9) == 3503909969) strcat(s, "r");
if (crc32("WxfGTYF",7) == 330162518) strcat(s, "a");
if (crc32("KbOxNcKPhHh",11) == 1981095468) strcat(s, "u");
if (crc32("jhOZgwQkb",9) == 2787987324) strcat(s, "d");
if (crc32("vMduTgPwFxrkWLA",15) == 58333858) strcat(s, "O");
if (crc32("GCNdbDl",7) == 1573507595) strcat(s, "u");
if (crc32("mfOkAM",6) == 3614363212) strcat(s, "H");
if (crc32("rYfYb",5) == 2007651681) strcat(s, "l");
if (crc32("JFmwPAD",7) == 3342066332) strcat(s, "e");
if (crc32("OAseEvNXEaF",11) == 3109086619) strcat(s, "n");
if (crc32("yFZsgg",6) == 1852258192) strcat(s, "V");
if (crc32("oFVQfY",6) == 1037795405) strcat(s, "c");
if (crc32("cyDmrguwb",9) == 2160940913) strcat(s, "e");
    return s;
}

char *valetudinary_nouns() {
    char *s = calloc(13);
    if (crc32("HpUQtkunrBGsvF",14) == 1342011426) strcat(s, "E");
if (crc32("NcMOeZ",6) == 3683559991) strcat(s, "v");
if (crc32("xouysaqr",8) == 1895072078) strcat(s, "a");
if (crc32("fehJFAlZzd",10) == 2822072108) strcat(s, "h");
if (crc32("SIYSFf",6) == 3023445485) strcat(s, "l");
if (crc32("BEatlMDlIsfm",12) == 1947611460) strcat(s, "t");
if (crc32("AfkUNERwkNl",11) == 4071496547) strcat(s, "e");
if (crc32("fbhXVpsnO",9) == 3163618826) strcat(s, "Y");
if (crc32("zSUmwpuQnHItE",13) == 3805689716) strcat(s, "t");
if (crc32("AMIvmoYSTzyQxsE",15) == 3206394877) strcat(s, "u");
if (crc32("hGQTQQeLuet",11) == 4166636855) strcat(s, "X");
if (crc32("YBMrVa",6) == 1345283191) strcat(s, "d");
if (crc32("XroYMKxUnvZIRV",14) == 3938304351) strcat(s, "i");
if (crc32("qtZwbszmwGhv",12) == 580436355) strcat(s, "a");
if (crc32("dEDxrPHmoQV",11) == 3142033910) strcat(s, "n");
if (crc32("ADPJfUWuaex",11) == 2758704023) strcat(s, "U");
if (crc32("DVJYptXnX",9) == 3693803535) strcat(s, "a");
if (crc32("ScLJgRtEYM",10) == 4066129921) strcat(s, "a");
if (crc32("eCcWbG",6) == 163291165) strcat(s, "r");
if (crc32("PatvVa",6) == 2188026300) strcat(s, "v");
if (crc32("Ewswoy",6) == 1177405940) strcat(s, "y");
    return s;
}

char *gastropod_nouns() {
    char *s = calloc(10);
    if (crc32("uAixFGMWvHMuUn",14) == 590723271) strcat(s, "f");
if (crc32("VgSdLhSO",8) == 3189887772) strcat(s, "g");
if (crc32("AqroTGGjU",9) == 790126376) strcat(s, "P");
if (crc32("YDlCQLG",7) == 3011626562) strcat(s, "a");
if (crc32("cjLTTamxuALPgci",15) == 4254580032) strcat(s, "s");
if (crc32("KaqxM",5) == 3492004503) strcat(s, "t");
if (crc32("aAAcY",5) == 1827119227) strcat(s, "r");
if (crc32("ZuSzDTVdslz",11) == 2631573839) strcat(s, "o");
if (crc32("THTzwY",6) == 3408138837) strcat(s, "L");
if (crc32("MpUHNYUdglJ",11) == 729062281) strcat(s, "p");
if (crc32("WNszKzWRvDU",11) == 2519063646) strcat(s, "o");
if (crc32("HuPXGgGvNU",10) == 2344935345) strcat(s, "d");
    return s;
}

char *superdominant_nouns() {
    char *s = calloc(14);
    if (crc32("OWdNAwnlUSSpjU",14) == 1533213432) strcat(s, "s");
if (crc32("foMyVVqAjDXcJY",14) == 3361048373) strcat(s, "u");
if (crc32("UkmJH",5) == 3899191802) strcat(s, "p");
if (crc32("XwDpxtyumN",10) == 354385891) strcat(s, "N");
if (crc32("OCvgXrNZt",9) == 2115275689) strcat(s, "e");
if (crc32("XaTcW",5) == 3515504121) strcat(s, "i");
if (crc32("TEACkvyVhhQEZ",13) == 670891064) strcat(s, "r");
if (crc32("ISIweg",6) == 1248709211) strcat(s, "P");
if (crc32("aZHwmgfDtQbqSd",14) == 579101919) strcat(s, "d");
if (crc32("tDadgjv",7) == 487910098) strcat(s, "O");
if (crc32("sLqSaKJlmsn",11) == 1900726839) strcat(s, "o");
if (crc32("LMDDXGPfOZTF",12) == 3979446017) strcat(s, "q");
if (crc32("GHYJvO",6) == 2668774064) strcat(s, "m");
if (crc32("COkzsymQxK",10) == 2300303077) strcat(s, "i");
if (crc32("vDcYemgud",9) == 2485735189) strcat(s, "n");
if (crc32("mzbkvIHRW",9) == 4093682298) strcat(s, "G");
if (crc32("qQDEVNMxTXHJn",13) == 856119729) strcat(s, "a");
if (crc32("AjTPFvaCUmeKHIT",15) == 1730192027) strcat(s, "I");
if (crc32("qPTcS",5) == 513445766) strcat(s, "n");
if (crc32("AuHkLwliQSwaO",13) == 2082787833) strcat(s, "t");
    return s;
}

char *turnabout_nouns() {
    char *s = calloc(10);
    if (crc32("CEEdBopwGK",10) == 2142911852) strcat(s, "N");
if (crc32("gWqGv",5) == 3901187319) strcat(s, "t");
if (crc32("XDLfBaUvzEimzbo",15) == 3989441751) strcat(s, "w");
if (crc32("GwNSDj",6) == 3291355656) strcat(s, "u");
if (crc32("yreGwxe",7) == 2129094153) strcat(s, "r");
if (crc32("qnjpvNVwuEbmj",13) == 3146997601) strcat(s, "U");
if (crc32("SjVbh",5) == 2442782508) strcat(s, "n");
if (crc32("JajqLpzDe",9) == 1490753369) strcat(s, "a");
if (crc32("wlOAnikJhTRMCq",14) == 2763131061) strcat(s, "J");
if (crc32("ossPQXrzBcgfz",13) == 1545347286) strcat(s, "b");
if (crc32("sgUTNvoM",8) == 24595471) strcat(s, "C");
if (crc32("updARmsZRzF",11) == 3384198874) strcat(s, "o");
if (crc32("afjKKzfGApSBYMG",15) == 3703338303) strcat(s, "R");
if (crc32("zdnXlSkWQOrljF",14) == 1382545454) strcat(s, "u");
if (crc32("yJcfyEqRbrSQ",12) == 4035228565) strcat(s, "i");
if (crc32("HcxuwlUQ",8) == 2680345160) strcat(s, "t");
    return s;
}

char *iodimetry_nouns() {
    char *s = calloc(10);
    if (crc32("UjrwswwsvVm",11) == 2854883422) strcat(s, "i");
if (crc32("njqnGux",7) == 136324504) strcat(s, "g");
if (crc32("JtyUmMPscdpNH",13) == 3971326809) strcat(s, "o");
if (crc32("LJnCgIPaBBEEXCG",15) == 3462015075) strcat(s, "s");
if (crc32("jJwfYFlTQwKDeeu",15) == 1153553492) strcat(s, "d");
if (crc32("sEGEdT",6) == 3124625712) strcat(s, "I");
if (crc32("yElzoCdW",8) == 3915220603) strcat(s, "i");
if (crc32("dbkGNUdpZVZnrs",14) == 2129467149) strcat(s, "V");
if (crc32("RHlVLqlUd",9) == 1414145496) strcat(s, "m");
if (crc32("iYAiEZVaBqSDFVY",15) == 1500275265) strcat(s, "e");
if (crc32("FeQPHIRsGvitle",14) == 1755673452) strcat(s, "w");
if (crc32("csrDlHExccd",11) == 324419980) strcat(s, "t");
if (crc32("pebUGvnJzvqN",12) == 3962101128) strcat(s, "r");
if (crc32("oOZBj",5) == 271864141) strcat(s, "y");
    return s;
}

char *habitant_nouns() {
    char *s = calloc(9);
    if (crc32("OMqrQCrN",8) == 2736205673) strcat(s, "A");
if (crc32("XpPmzKUXxgPum",13) == 3338563750) strcat(s, "h");
if (crc32("pWlRj",5) == 664075401) strcat(s, "p");
if (crc32("rRjJOnhwMenwGPN",15) == 1763809027) strcat(s, "a");
if (crc32("vUBOifKyO",9) == 3151154886) strcat(s, "b");
if (crc32("jStlwMNhTwe",11) == 2000604736) strcat(s, "B");
if (crc32("hcoFGICZhGzT",12) == 720117022) strcat(s, "i");
if (crc32("SAEOw",5) == 1441301792) strcat(s, "t");
if (crc32("PHbCNvTleNTCcAI",15) == 4209742108) strcat(s, "t");
if (crc32("VYMJWJdQ",8) == 3616088282) strcat(s, "a");
if (crc32("sUHkj",5) == 3707134700) strcat(s, "W");
if (crc32("xCkTH",5) == 1685315315) strcat(s, "n");
if (crc32("YtFjNNDPNrrTNrj",15) == 4006521571) strcat(s, "c");
if (crc32("VnIjBiuvgs",10) == 3819579859) strcat(s, "t");
    return s;
}

char *enviableness_nouns() {
    char *s = calloc(13);
    if (crc32("uUIjLNaJCuZznc",14) == 2959258895) strcat(s, "e");
if (crc32("KUngOK",6) == 836342292) strcat(s, "k");
if (crc32("hCDirMPJF",9) == 719758129) strcat(s, "n");
if (crc32("telmAfbjjXc",11) == 2334822651) strcat(s, "v");
if (crc32("NZuLanMAOV",10) == 1808702215) strcat(s, "c");
if (crc32("KlvMao",6) == 526517948) strcat(s, "i");
if (crc32("FdAWO",5) == 3339995845) strcat(s, "a");
if (crc32("jTGxtWXShbbc",12) == 561848067) strcat(s, "b");
if (crc32("QrGXIclZUxv",11) == 2321597813) strcat(s, "z");
if (crc32("kzmUoT",6) == 1305184084) strcat(s, "l");
if (crc32("EfJhGrUuR",9) == 328548047) strcat(s, "t");
if (crc32("lirbPdcfIu",10) == 787232684) strcat(s, "e");
if (crc32("gRMWNXQTQzWU",12) == 1551084804) strcat(s, "P");
if (crc32("QCMeHOjrRPqUf",13) == 4121715847) strcat(s, "n");
if (crc32("aUrlwszN",8) == 3025487811) strcat(s, "U");
if (crc32("bPkbWsEEmIM",11) == 2820138640) strcat(s, "e");
if (crc32("qCibI",5) == 2499594511) strcat(s, "s");
if (crc32("mXfkoQuEilKJxt",14) == 158603163) strcat(s, "M");
if (crc32("yRZPNpFzCGysCg",14) == 2927707585) strcat(s, "s");
    return s;
}

char *gavotte_nouns() {
    char *s = calloc(8);
    if (crc32("vmwGoDAnPR",10) == 2552684508) strcat(s, "g");
if (crc32("mzKJlqFRhluF",12) == 3225868177) strcat(s, "M");
if (crc32("UzepfQh",7) == 3494272389) strcat(s, "a");
if (crc32("bJhssXdOdf",10) == 1287487256) strcat(s, "v");
if (crc32("sBCGSlnzF",9) == 711493767) strcat(s, "X");
if (crc32("TmGFGQIdszh",11) == 3039777272) strcat(s, "o");
if (crc32("qqAbJgIVWDciEr",14) == 1155719432) strcat(s, "t");
if (crc32("UEsnhGEAWQJoK",13) == 2328884500) strcat(s, "t");
if (crc32("zTcDeg",6) == 1135931623) strcat(s, "e");
    return s;
}

char *collyr_nouns() {
    char *s = calloc(7);
    if (crc32("dbgHCbFQPERQ",12) == 1086097666) strcat(s, "c");
if (crc32("PMfxIkpBw",9) == 3369050085) strcat(s, "o");
if (crc32("caLXYwNlp",9) == 3670430366) strcat(s, "u");
if (crc32("VMhZNJaFaLjzzwI",15) == 306228495) strcat(s, "l");
if (crc32("wDSZLKUvLd",10) == 362239469) strcat(s, "G");
if (crc32("jcELpDUUrHl",11) == 1447764723) strcat(s, "l");
if (crc32("JqFHEBLyhmOgM",13) == 3992662354) strcat(s, "y");
if (crc32("MrmwapVrYjI",11) == 749156625) strcat(s, "r");
    return s;
}

char *stamen_nouns() {
    char *s = calloc(7);
    if (crc32("hIPMmC",6) == 2353988189) strcat(s, "s");
if (crc32("jiiOGtrce",9) == 867242695) strcat(s, "j");
if (crc32("HrRUkhsT",8) == 2549054262) strcat(s, "t");
if (crc32("ROIwXwgvpAeI",12) == 3653918789) strcat(s, "a");
if (crc32("zoEaRdePcwBggc",14) == 865318831) strcat(s, "K");
if (crc32("LXtZZLgfcpcARr",14) == 3909418788) strcat(s, "m");
if (crc32("sEDTOTnP",8) == 809757551) strcat(s, "e");
if (crc32("CUpxUmH",7) == 565604721) strcat(s, "n");
    return s;
}

char *pondweed_nouns() {
    char *s = calloc(9);
    if (crc32("WWKZWIvzDuJ",11) == 2178376576) strcat(s, "H");
if (crc32("gTnaJ",5) == 33149175) strcat(s, "p");
if (crc32("GHtBGiWLUUhG",12) == 1051002699) strcat(s, "o");
if (crc32("ITrsYCmbqCOIyR",14) == 3045494096) strcat(s, "n");
if (crc32("scCvgblFDSl",11) == 4029078231) strcat(s, "d");
if (crc32("RkLXJkSL",8) == 3586056804) strcat(s, "w");
if (crc32("aTqBisJhEavUUJk",15) == 847605359) strcat(s, "e");
if (crc32("etOMFPFXjQ",10) == 316034431) strcat(s, "e");
if (crc32("xVQLUWAMKkdZL",13) == 1557631452) strcat(s, "L");
if (crc32("ZiLvd",5) == 3096811371) strcat(s, "d");
    return s;
}

char *Algar_nouns() {
    char *s = calloc(6);
    if (crc32("nnvYTuzi",8) == 2243518932) strcat(s, "o");
if (crc32("bqmXukjd",8) == 3428084157) strcat(s, "A");
if (crc32("gKkyqskPBuUyq",13) == 3385742224) strcat(s, "l");
if (crc32("QBkEBRwj",8) == 1311141342) strcat(s, "g");
if (crc32("EhnOpP",6) == 2742969407) strcat(s, "a");
if (crc32("jMXJZEaTAS",10) == 2550094850) strcat(s, "G");
if (crc32("HNdWhBvIDvfI",12) == 655644698) strcat(s, "r");
    return s;
}

char *Bourges_nouns() {
    char *s = calloc(8);
    if (crc32("CnRGHA",6) == 866580522) strcat(s, "B");
if (crc32("rFGfeqioniKr",12) == 3115683986) strcat(s, "c");
if (crc32("BFAFSHHKmd",10) == 1289456863) strcat(s, "o");
if (crc32("NqhguWRiSr",10) == 293463870) strcat(s, "u");
if (crc32("fmGVdF",6) == 238581062) strcat(s, "W");
if (crc32("WZrqhn",6) == 1103202566) strcat(s, "r");
if (crc32("Fzguf",5) == 2920451703) strcat(s, "g");
if (crc32("sVBMef",6) == 2116235533) strcat(s, "e");
if (crc32("WIXcMotWUILWnhK",15) == 2413673214) strcat(s, "C");
if (crc32("hAirEoF",7) == 3215894008) strcat(s, "s");
    return s;
}

char *defectibility_nouns() {
    char *s = calloc(14);
    if (crc32("KkTqW",5) == 863651978) strcat(s, "l");
if (crc32("YEhbUEbAPwfNm",13) == 1214499692) strcat(s, "d");
if (crc32("PxsSDLK",7) == 3178965110) strcat(s, "s");
if (crc32("kQtUBIdzz",9) == 187098063) strcat(s, "e");
if (crc32("IKAXYSJNcWvzTx",14) == 1014269191) strcat(s, "f");
if (crc32("LRzbXhJHbSx",11) == 3239211062) strcat(s, "e");
if (crc32("PQUpCUXpIey",11) == 640974003) strcat(s, "C");
if (crc32("TStcoHC",7) == 1909665627) strcat(s, "c");
if (crc32("gghlrIfM",8) == 3436133519) strcat(s, "t");
if (crc32("aaCAsHBYWdqc",12) == 1009746709) strcat(s, "i");
if (crc32("dIEstR",6) == 3595362261) strcat(s, "g");
if (crc32("Oyyab",5) == 2395791070) strcat(s, "b");
if (crc32("IlOeRus",7) == 300859319) strcat(s, "i");
if (crc32("ZsHxbQNg",8) == 1369365098) strcat(s, "c");
if (crc32("JrxCcYRA",8) == 2634182265) strcat(s, "l");
if (crc32("JbpWInb",7) == 449061904) strcat(s, "a");
if (crc32("kTkmSWLewwvOefe",15) == 4197321306) strcat(s, "i");
if (crc32("vUzrvoJfoXDn",12) == 2677052774) strcat(s, "g");
if (crc32("kYJyVmQdstPLd",13) == 96905262) strcat(s, "t");
if (crc32("iMOxgdzAX",9) == 3145858908) strcat(s, "y");
    return s;
}

char *curtilage_nouns() {
    char *s = calloc(10);
    if (crc32("rDKiTLM",7) == 1211656327) strcat(s, "u");
if (crc32("khrUsTOdWumP",12) == 3663381461) strcat(s, "c");
if (crc32("uoOXh",5) == 1397219175) strcat(s, "X");
if (crc32("hikmcaouoY",10) == 1560640026) strcat(s, "u");
if (crc32("nlqXuE",6) == 1998519621) strcat(s, "e");
if (crc32("MiUGLrVP",8) == 2117725411) strcat(s, "r");
if (crc32("gUfevgiyQQOGVMm",15) == 551091527) strcat(s, "a");
if (crc32("lFJBbycraAfSIwX",15) == 3877379043) strcat(s, "t");
if (crc32("FPQRfSmbhAnHWX",14) == 3006961904) strcat(s, "J");
if (crc32("qkpChBQDsm",10) == 136551368) strcat(s, "i");
if (crc32("JbZhdsRYEM",10) == 3458545817) strcat(s, "l");
if (crc32("lJHEdksEWCTRnx",14) == 2741748071) strcat(s, "b");
if (crc32("BbotGpY",7) == 3165047243) strcat(s, "a");
if (crc32("gWCaUYMyQ",9) == 3951430874) strcat(s, "g");
if (crc32("QqzCcYXbYXddaF",14) == 3370155369) strcat(s, "e");
    return s;
}

char *Mopsus_nouns() {
    char *s = calloc(7);
    if (crc32("WVfhSklQoGLy",12) == 3550954977) strcat(s, "M");
if (crc32("lhcdWMg",7) == 416999860) strcat(s, "b");
if (crc32("LnvFDEhrYZ",10) == 4088639324) strcat(s, "o");
if (crc32("kvizUTmd",8) == 3830193241) strcat(s, "N");
if (crc32("ADsDZYIrCWi",11) == 72384257) strcat(s, "p");
if (crc32("NEejbcbbMVte",12) == 2342558194) strcat(s, "U");
if (crc32("slISrfzxq",9) == 4147597339) strcat(s, "s");
if (crc32("AjiOuFGmVrbJ",12) == 2264140628) strcat(s, "u");
if (crc32("ASmeOJrcMAVI",12) == 1893462574) strcat(s, "s");
    return s;
}

char *Nuzzi_nouns() {
    char *s = calloc(6);
    if (crc32("VmYwzXD",7) == 2244130077) strcat(s, "Q");
if (crc32("NQSRdbDjCYkF",12) == 3918107872) strcat(s, "N");
if (crc32("GuMvAI",6) == 1305339834) strcat(s, "u");
if (crc32("BsFwFlbyttGyPoR",15) == 3528625155) strcat(s, "r");
if (crc32("ebPLKAoaIUZ",11) == 3133138443) strcat(s, "z");
if (crc32("xkEzJIQmCwjjlB",14) == 1606524429) strcat(s, "z");
if (crc32("qzpnnwQcgHC",11) == 4213302279) strcat(s, "i");
    return s;
}

char *Crelin_nouns() {
    char *s = calloc(7);
    if (crc32("kPxQLUmbFPwtWz",14) == 1779313039) strcat(s, "C");
if (crc32("EgeYux",6) == 2789668754) strcat(s, "r");
if (crc32("ZkPPzQqCV",9) == 1863579682) strcat(s, "e");
if (crc32("tUAQYFtYrNWtFjl",15) == 3341121733) strcat(s, "l");
if (crc32("XnVJrvGEXysA",12) == 1123546246) strcat(s, "B");
if (crc32("JPkUDjQKT",9) == 3330032096) strcat(s, "i");
if (crc32("CySkAYSxsxP",11) == 718327703) strcat(s, "n");
    return s;
}

char *streak_nouns() {
    char *s = calloc(7);
    if (crc32("CaHBcAU",7) == 3393929501) strcat(s, "s");
if (crc32("ppjwWHB",7) == 2530027737) strcat(s, "t");
if (crc32("RdERKlr",7) == 4033115730) strcat(s, "L");
if (crc32("OMWyieBz",8) == 799516039) strcat(s, "r");
if (crc32("nmilXXC",7) == 3896840635) strcat(s, "e");
if (crc32("oZzLtkAOd",9) == 1611621974) strcat(s, "I");
if (crc32("btBQBgs",7) == 3503958723) strcat(s, "a");
if (crc32("JQPPOhgdU",9) == 3190609441) strcat(s, "D");
if (crc32("TGZDaZivOWWf",12) == 2947665275) strcat(s, "k");
    return s;
}

char *rememberer_nouns() {
    char *s = calloc(11);
    if (crc32("ItNYTuQwwfmQF",13) == 2721836054) strcat(s, "r");
if (crc32("QAOVxQpQubLN",12) == 2338902544) strcat(s, "e");
if (crc32("wsDjUmCVtnMX",12) == 3226406938) strcat(s, "R");
if (crc32("yLJOI",5) == 3872272590) strcat(s, "m");
if (crc32("sTQxnvFcskj",11) == 3525843715) strcat(s, "X");
if (crc32("ThZkj",5) == 3211186358) strcat(s, "e");
if (crc32("BULfe",5) == 1866280694) strcat(s, "m");
if (crc32("gviwymIO",8) == 3311267519) strcat(s, "b");
if (crc32("oqynBrfiuiTUU",13) == 239531583) strcat(s, "T");
if (crc32("JCvawMc",7) == 3238098941) strcat(s, "e");
if (crc32("nkzibCXfnMA",11) == 3545691797) strcat(s, "Y");
if (crc32("vkTFDLVCOmZYbka",15) == 1473311873) strcat(s, "r");
if (crc32("eKoeczqXxsROtw",14) == 296419172) strcat(s, "e");
if (crc32("fGDIhIWys",9) == 2824281317) strcat(s, "T");
if (crc32("zWdkstyrjvu",11) == 3292606482) strcat(s, "r");
    return s;
}

char *Sassari_nouns() {
    char *s = calloc(8);
    if (crc32("Atubw",5) == 2356999726) strcat(s, "S");
if (crc32("GTZDQDlroWTa",12) == 3778656894) strcat(s, "a");
if (crc32("IPzAdnnWpcO",11) == 372516056) strcat(s, "O");
if (crc32("LCTlRxbUJwNj",12) == 276807470) strcat(s, "s");
if (crc32("LbOZTBtVsBDGs",13) == 3992729288) strcat(s, "n");
if (crc32("ZtPjvTPjIAtn",12) == 2274355780) strcat(s, "s");
if (crc32("AefGvTEsKqBpfE",14) == 3205075483) strcat(s, "a");
if (crc32("cFybB",5) == 316443143) strcat(s, "i");
if (crc32("jATDzeSnl",9) == 3879361749) strcat(s, "r");
if (crc32("JWSAJEhJzIC",11) == 11872294) strcat(s, "G");
if (crc32("eYSaeko",7) == 2253522704) strcat(s, "i");
    return s;
}

char *tacmahack_nouns() {
    char *s = calloc(10);
    if (crc32("XTSTDYODmsNuPs",14) == 3596581105) strcat(s, "t");
if (crc32("mtVuzSPmYO",10) == 2007652327) strcat(s, "c");
if (crc32("AJLvjHU",7) == 1684401201) strcat(s, "a");
if (crc32("JqVamKA",7) == 2983163236) strcat(s, "f");
if (crc32("zvAFhPuHhS",10) == 3794692739) strcat(s, "c");
if (crc32("enhFDrDXEXYK",12) == 2829465127) strcat(s, "m");
if (crc32("KiKrUkK",7) == 2579722513) strcat(s, "I");
if (crc32("QHbucIqO",8) == 2044406997) strcat(s, "a");
if (crc32("IRxHmQKXrRk",11) == 3285318460) strcat(s, "h");
if (crc32("AUZOMfFWBQH",11) == 2445657051) strcat(s, "z");
if (crc32("WgTzhBJomAvmD",13) == 671428714) strcat(s, "a");
if (crc32("BgpJIppOawxDmG",14) == 4160201003) strcat(s, "c");
if (crc32("lVxGoIMGgkjIWxp",15) == 3245846579) strcat(s, "k");
    return s;
}

char *Krutch_nouns() {
    char *s = calloc(7);
    if (crc32("qkNcUph",7) == 276431013) strcat(s, "R");
if (crc32("TKCRePar",8) == 2616493256) strcat(s, "K");
if (crc32("FqNfkiinyvTEuDP",15) == 1967604786) strcat(s, "p");
if (crc32("KCWMlIMxxBF",11) == 578023699) strcat(s, "r");
if (crc32("TNZOnU",6) == 2332930462) strcat(s, "P");
if (crc32("HvjXLXdGhIcp",12) == 3704648090) strcat(s, "u");
if (crc32("VKYWfqWGCwoeHB",14) == 236593765) strcat(s, "t");
if (crc32("JnhhDNHiRbcqCV",14) == 1144393017) strcat(s, "f");
if (crc32("GojmeFYButcEj",13) == 2976019965) strcat(s, "c");
if (crc32("emvRqXBaGpjc",12) == 1026215015) strcat(s, "r");
if (crc32("BFKLhjYzX",9) == 3923601855) strcat(s, "h");
    return s;
}

char *Jeanie_nouns() {
    char *s = calloc(7);
    if (crc32("DiTxnd",6) == 2653932839) strcat(s, "j");
if (crc32("MDkbgcrSw",9) == 2727161633) strcat(s, "J");
if (crc32("pgyCGGdKPHifAs",14) == 4175755913) strcat(s, "x");
if (crc32("MkROrKLJz",9) == 47197102) strcat(s, "e");
if (crc32("NFpHvOgpRqmqrK",14) == 2952060495) strcat(s, "A");
if (crc32("hhsqyfJahKZM",12) == 3736531780) strcat(s, "a");
if (crc32("GbesxyUtFIYtNv",14) == 1319974942) strcat(s, "n");
if (crc32("PiuxaEXgx",9) == 478876668) strcat(s, "i");
if (crc32("MiZIKSzfq",9) == 3373872636) strcat(s, "V");
if (crc32("ylsdZLFSmtgGVHT",15) == 782094578) strcat(s, "e");
    return s;
}

char *butte_nouns() {
    char *s = calloc(6);
    if (crc32("YcfIcMcTR",9) == 6436396) strcat(s, "b");
if (crc32("NCbDw",5) == 1528649608) strcat(s, "c");
if (crc32("zwtpNMWDaEoC",12) == 821605394) strcat(s, "u");
if (crc32("wloabMTgeFGLdx",14) == 3833143362) strcat(s, "H");
if (crc32("cstZThlcreFQT",13) == 3586775267) strcat(s, "t");
if (crc32("sUfHxNV",7) == 3801958522) strcat(s, "a");
if (crc32("PDxvAuJ",7) == 413132855) strcat(s, "t");
if (crc32("ySvCgkgdegk",11) == 2808688612) strcat(s, "w");
if (crc32("HCTiRZCnb",9) == 273540384) strcat(s, "e");
    return s;
}

char *bicycle_nouns() {
    char *s = calloc(8);
    if (crc32("YEvaeLJ",7) == 4214342124) strcat(s, "o");
if (crc32("pkvfbD",6) == 1886793280) strcat(s, "b");
if (crc32("FdQjSLUbIe",10) == 1252697643) strcat(s, "r");
if (crc32("HeatPDBBhPCat",13) == 1131404900) strcat(s, "i");
if (crc32("RThnJqGVFg",10) == 2564639235) strcat(s, "X");
if (crc32("KtAWgzR",7) == 1706527689) strcat(s, "c");
if (crc32("gWvXNKsLyRSGJ",13) == 1113619068) strcat(s, "N");
if (crc32("tuJaG",5) == 2143446911) strcat(s, "y");
if (crc32("Gfeao",5) == 3712742527) strcat(s, "c");
if (crc32("gsNQvutoaLBMzUI",15) == 1436031350) strcat(s, "l");
if (crc32("LVkJKrR",7) == 989371409) strcat(s, "e");
    return s;
}

char *Chavaree_nouns() {
    char *s = calloc(9);
    if (crc32("DremJUzhTGPqX",13) == 1112334906) strcat(s, "k");
if (crc32("tcUYKVmSpKseIYM",15) == 251449986) strcat(s, "C");
if (crc32("KuAemO",6) == 3203091403) strcat(s, "h");
if (crc32("nkxQAJCFNmnYyH",14) == 874649029) strcat(s, "a");
if (crc32("WVlCEQTmTmLQ",12) == 3646672845) strcat(s, "v");
if (crc32("qlEhYngssLlI",12) == 4261231794) strcat(s, "a");
if (crc32("vNoNN",5) == 2003718013) strcat(s, "r");
if (crc32("jlcmDAQwmftp",12) == 692690860) strcat(s, "e");
if (crc32("dETSkYxfvB",10) == 948180780) strcat(s, "e");
    return s;
}

char *metalware_nouns() {
    char *s = calloc(10);
    if (crc32("smhyhgYuUA",10) == 1463369743) strcat(s, "p");
if (crc32("rrhzHCPoHBcJJNG",15) == 1847219183) strcat(s, "m");
if (crc32("JHvzP",5) == 3762733460) strcat(s, "W");
if (crc32("jrHPAT",6) == 751275003) strcat(s, "e");
if (crc32("bCywjCcSMa",10) == 645798138) strcat(s, "b");
if (crc32("bYNIFcIgvDkI",12) == 2821368313) strcat(s, "t");
if (crc32("cSgugsqqwfvoWe",14) == 1403046841) strcat(s, "a");
if (crc32("fnIFMKdaEu",10) == 1980649640) strcat(s, "l");
if (crc32("ERyKwEgFkxEbS",13) == 170199610) strcat(s, "w");
if (crc32("hFPNMvOikzf",11) == 232316027) strcat(s, "w");
if (crc32("HAjFDDElVTlb",12) == 886949699) strcat(s, "D");
if (crc32("VHeNo",5) == 3527060013) strcat(s, "a");
if (crc32("GMVxkwRnVf",10) == 3192072200) strcat(s, "r");
if (crc32("bzCWCEAyFMNd",12) == 2742072460) strcat(s, "e");
    return s;
}

char *Leguaea_nouns() {
    char *s = calloc(8);
    if (crc32("ySnFroemo",9) == 3225255902) strcat(s, "L");
if (crc32("mABShCEjVDtpsEI",15) == 248338799) strcat(s, "e");
if (crc32("vclgJrYgAHO",11) == 3175208763) strcat(s, "g");
if (crc32("eCatxQaXijjJqL",14) == 887330911) strcat(s, "u");
if (crc32("UhNLnxWnSrigYvf",15) == 1274594059) strcat(s, "a");
if (crc32("kdXno",5) == 3540012026) strcat(s, "Z");
if (crc32("dMsvcaurEg",10) == 3326270316) strcat(s, "e");
if (crc32("SinRcJHq",8) == 2094974652) strcat(s, "j");
if (crc32("hqebUPVdOq",10) == 3612049178) strcat(s, "a");
    return s;
}

char *millepore_nouns() {
    char *s = calloc(10);
    if (crc32("joOEvGGFuvogR",13) == 2682459292) strcat(s, "B");
if (crc32("HTFpq",5) == 2531571022) strcat(s, "m");
if (crc32("DLhBVGIDHIuU",12) == 1507152899) strcat(s, "i");
if (crc32("yfhdHVxccVo",11) == 3077895205) strcat(s, "l");
if (crc32("DeYDSE",6) == 577752920) strcat(s, "l");
if (crc32("LKcqObFUkDVTPmp",15) == 4224094191) strcat(s, "j");
if (crc32("wTFVlxGXPwcZIqb",15) == 2623843450) strcat(s, "e");
if (crc32("QOeaQDBI",8) == 1596117926) strcat(s, "l");
if (crc32("sdeRSsi",7) == 3185116336) strcat(s, "p");
if (crc32("NHtVmgm",7) == 2850763836) strcat(s, "e");
if (crc32("SwHhTVpXHnlY",12) == 3636567666) strcat(s, "o");
if (crc32("twKXKExir",9) == 2554170790) strcat(s, "r");
if (crc32("efKUYunvUcPmcl",14) == 3978937864) strcat(s, "N");
if (crc32("rEIWysbETJfNPH",14) == 3799077857) strcat(s, "e");
    return s;
}

char *Shemitic_nouns() {
    char *s = calloc(9);
    if (crc32("gunorMvjUKssD",13) == 1367501235) strcat(s, "M");
if (crc32("zgyPSPzG",8) == 2331080747) strcat(s, "S");
if (crc32("wiMRxD",6) == 2748745135) strcat(s, "h");
if (crc32("JvIqGlfypgPJh",13) == 1842847402) strcat(s, "F");
if (crc32("zxbwuMZLROASrAd",15) == 773035522) strcat(s, "e");
if (crc32("RDYRpHfPEpqgTtl",15) == 2260621161) strcat(s, "b");
if (crc32("UesPXBbCEvAY",12) == 2583266806) strcat(s, "m");
if (crc32("ZBOvyXiOsQx",11) == 1702671927) strcat(s, "i");
if (crc32("kDEWtW",6) == 139799843) strcat(s, "m");
if (crc32("LCaxyEHujFXS",12) == 2748402607) strcat(s, "t");
if (crc32("xWdIopSYVuFOpH",14) == 1055566068) strcat(s, "i");
if (crc32("KeyXRtcm",8) == 480793104) strcat(s, "e");
if (crc32("oLSYSMATWeX",11) == 3109412071) strcat(s, "c");
    return s;
}

char *Rexmond_nouns() {
    char *s = calloc(8);
    if (crc32("seFpC",5) == 3226858141) strcat(s, "R");
if (crc32("yNFuE",5) == 1479024379) strcat(s, "B");
if (crc32("nXhnVnGzsJmdF",13) == 2682855478) strcat(s, "e");
if (crc32("faBBQIVxpjq",11) == 946481825) strcat(s, "R");
if (crc32("fgARoywUmOJsDW",14) == 1533639124) strcat(s, "x");
if (crc32("JffEsIlxImgQ",12) == 3436835010) strcat(s, "s");
if (crc32("aiTTFqRO",8) == 3093509057) strcat(s, "m");
if (crc32("UeXzyqvpK",9) == 1162381172) strcat(s, "o");
if (crc32("ujBzgi",6) == 1325796241) strcat(s, "n");
if (crc32("ulKtKbWiffEW",12) == 2441516196) strcat(s, "d");
    return s;
}

char *Prylis_nouns() {
    char *s = calloc(7);
    if (crc32("eBVZNkzDpcatSEd",15) == 2547094305) strcat(s, "P");
if (crc32("OSvPW",5) == 1168697284) strcat(s, "Q");
if (crc32("elpsgFgzRzh",11) == 312658105) strcat(s, "r");
if (crc32("rJgGuRKCcej",11) == 2241501949) strcat(s, "I");
if (crc32("vfSOCRobzmEkoQ",14) == 2193939573) strcat(s, "y");
if (crc32("mNZHZrV",7) == 2423683628) strcat(s, "l");
if (crc32("YguznwqIC",9) == 2671917775) strcat(s, "l");
if (crc32("IdmMVE",6) == 2927514890) strcat(s, "i");
if (crc32("UjtPBzPf",8) == 2308134261) strcat(s, "s");
    return s;
}

char *wootz_nouns() {
    char *s = calloc(6);
    if (crc32("PRNZfIuKhhOgCO",14) == 778881664) strcat(s, "w");
if (crc32("IhdaB",5) == 3334015855) strcat(s, "o");
if (crc32("aTBdIDRskddojg",14) == 2883023693) strcat(s, "o");
if (crc32("MFnkVRZYeKAHVQ",14) == 784663922) strcat(s, "r");
if (crc32("rZJpQXW",7) == 3638657557) strcat(s, "t");
if (crc32("aEewCU",6) == 1311806679) strcat(s, "P");
if (crc32("OTyJKto",7) == 1388972274) strcat(s, "z");
    return s;
}

char *Doig_nouns() {
    char *s = calloc(5);
    if (crc32("heLTKgEUgRu",11) == 272750969) strcat(s, "H");
if (crc32("yrjjZxsVNzV",11) == 2301495605) strcat(s, "D");
if (crc32("xidgLMV",7) == 2255860195) strcat(s, "Z");
if (crc32("xbzZvZsWateLi",13) == 1957960106) strcat(s, "o");
if (crc32("mHZSLPZaCSfnJ",13) == 1992111988) strcat(s, "i");
if (crc32("XTKabxVshfTAJ",13) == 1373869584) strcat(s, "V");
if (crc32("xZqPHWf",7) == 3487793144) strcat(s, "g");
    return s;
}

char *asthenosphere_nouns() {
    char *s = calloc(14);
    if (crc32("xcfNiyYzSofTrCv",15) == 3617555077) strcat(s, "a");
if (crc32("rnuLjCwoLp",10) == 2996896366) strcat(s, "n");
if (crc32("UwMdIbjqJFY",11) == 1353722705) strcat(s, "s");
if (crc32("VMbyjg",6) == 2785347684) strcat(s, "X");
if (crc32("qpPYOfAj",8) == 454374138) strcat(s, "t");
if (crc32("iqhBmyxsdaiOX",13) == 1393451715) strcat(s, "K");
if (crc32("zBYyaQXDhV",10) == 1371604488) strcat(s, "h");
if (crc32("YPnJODtwHyD",11) == 3645131437) strcat(s, "u");
if (crc32("tgxmgkElFTV",11) == 4091270304) strcat(s, "e");
if (crc32("gndTUILAtvs",11) == 3350718967) strcat(s, "u");
if (crc32("SAdpKJzHY",9) == 2495733379) strcat(s, "n");
if (crc32("mIjvriouXGGsgKh",15) == 423822834) strcat(s, "o");
if (crc32("KugXIzulQ",9) == 651000771) strcat(s, "s");
if (crc32("ODTgPvyph",9) == 1573671919) strcat(s, "V");
if (crc32("YldnTH",6) == 2522658140) strcat(s, "p");
if (crc32("qbcvBamEdBs",11) == 2150067232) strcat(s, "u");
if (crc32("hLfrmXhdfTa",11) == 2073610775) strcat(s, "h");
if (crc32("XTglAcRWe",9) == 4118775649) strcat(s, "g");
if (crc32("ZYFix",5) == 2624764109) strcat(s, "e");
if (crc32("bjqBvIGKwY",10) == 3437662847) strcat(s, "r");
if (crc32("oJaxiAPrHRrLZ",13) == 2453666846) strcat(s, "w");
if (crc32("kMaBbeBxxp",10) == 3799501348) strcat(s, "e");
    return s;
}

char *Roselin_nouns() {
    char *s = calloc(8);
    if (crc32("rUqJjfQHgXJ",11) == 2807862484) strcat(s, "C");
if (crc32("qGBmRgYl",8) == 2762460393) strcat(s, "R");
if (crc32("EEwFx",5) == 1404626803) strcat(s, "o");
if (crc32("orDNQxNkoqjS",12) == 2248252367) strcat(s, "P");
if (crc32("bpmUb",5) == 1787855546) strcat(s, "s");
if (crc32("DPOMSaLNgxH",11) == 3801420873) strcat(s, "e");
if (crc32("ETwpFFRikXMMQy",14) == 944101859) strcat(s, "B");
if (crc32("ploUpBJIx",9) == 2062856938) strcat(s, "l");
if (crc32("othSSitX",8) == 2486150278) strcat(s, "I");
if (crc32("UYZmCXzWqNjFpW",14) == 199552680) strcat(s, "i");
if (crc32("DdYYs",5) == 504216164) strcat(s, "n");
    return s;
}

char *changeling_nouns() {
    char *s = calloc(11);
    if (crc32("yLyPMRsZI",9) == 257373148) strcat(s, "W");
if (crc32("TsOJcSxF",8) == 3132346349) strcat(s, "c");
if (crc32("AlzsIRBB",8) == 191983457) strcat(s, "h");
if (crc32("SoCCPMMG",8) == 1271576913) strcat(s, "a");
if (crc32("iPqPONiQkxxN",12) == 3540996621) strcat(s, "n");
if (crc32("RCewbWkNL",9) == 2603640834) strcat(s, "A");
if (crc32("AqAlQtg",7) == 1593199131) strcat(s, "g");
if (crc32("GSwnOQvtgWtw",12) == 2957038225) strcat(s, "e");
if (crc32("YaExDbULnFg",11) == 1578390329) strcat(s, "l");
if (crc32("kiusnOpfndi",11) == 1594819102) strcat(s, "q");
if (crc32("xBxhEuTXHrNTD",13) == 2385473336) strcat(s, "i");
if (crc32("rwQAfIBtNLJ",11) == 1655038032) strcat(s, "p");
if (crc32("KeDDSiUVH",9) == 3242519554) strcat(s, "n");
if (crc32("myTodJAW",8) == 241534935) strcat(s, "g");
    return s;
}

char *obligingness_nouns() {
    char *s = calloc(13);
    if (crc32("wsmyRR",6) == 3966598894) strcat(s, "p");
if (crc32("DAmJhjLlGE",10) == 134421618) strcat(s, "o");
if (crc32("CtQMkBQBhkX",11) == 1443650926) strcat(s, "b");
if (crc32("ckPUqQIfz",9) == 986654245) strcat(s, "l");
if (crc32("TeEpCElwad",10) == 175789815) strcat(s, "l");
if (crc32("TEynLwM",7) == 734735667) strcat(s, "i");
if (crc32("rqdBACt",7) == 2251214647) strcat(s, "g");
if (crc32("ikRxqDzMcXb",11) == 3722312388) strcat(s, "i");
if (crc32("AuCvkNoe",8) == 2290466124) strcat(s, "i");
if (crc32("OAzzAKoWHUmJ",12) == 136648850) strcat(s, "n");
if (crc32("hdzWmyBIqvEFzU",14) == 1566527527) strcat(s, "g");
if (crc32("bAvgsXJbwu",10) == 2707519475) strcat(s, "n");
if (crc32("jIXmLu",6) == 1024391569) strcat(s, "K");
if (crc32("yZTNGyuZ",8) == 2773567968) strcat(s, "e");
if (crc32("hqoNOK",6) == 511273382) strcat(s, "s");
if (crc32("aJiuQpVHPf",10) == 1466098719) strcat(s, "s");
    return s;
}

char *supercapableness_nouns() {
    char *s = calloc(17);
    if (crc32("rYhAPrq",7) == 1849773594) strcat(s, "t");
if (crc32("WIxxdvRV",8) == 725388831) strcat(s, "s");
if (crc32("fRdJmBFSvPR",11) == 512575462) strcat(s, "u");
if (crc32("pJVCQzLko",9) == 603248246) strcat(s, "U");
if (crc32("mPlexzG",7) == 1278417782) strcat(s, "p");
if (crc32("dTDLlsCzQN",10) == 419643637) strcat(s, "e");
if (crc32("vrYKgpV",7) == 3448222897) strcat(s, "r");
if (crc32("PqjvPsvOejOd",12) == 3094661711) strcat(s, "G");
if (crc32("LCTSAyGuEvRx",12) == 1870356644) strcat(s, "c");
if (crc32("kHmKrF",6) == 3073130001) strcat(s, "s");
if (crc32("NjZvPIhrM",9) == 1711492304) strcat(s, "a");
if (crc32("BzWBHJWhT",9) == 3152292239) strcat(s, "p");
if (crc32("PqvOEQAk",8) == 2673333686) strcat(s, "F");
if (crc32("FzRfCB",6) == 3044670589) strcat(s, "a");
if (crc32("uxzjAXsW",8) == 2536780200) strcat(s, "b");
if (crc32("VECcPQGVYvOOs",13) == 1859795398) strcat(s, "T");
if (crc32("nzuTrXUmuicX",12) == 1791784846) strcat(s, "l");
if (crc32("KZBHKbLTEDty",12) == 2957117175) strcat(s, "z");
if (crc32("EkTWhlAhBIHtdqX",15) == 3974515266) strcat(s, "e");
if (crc32("zHtLMhXhIDsd",12) == 2184928470) strcat(s, "n");
if (crc32("tUtTdSyRZGfxS",13) == 3771437450) strcat(s, "e");
if (crc32("GxvfEPvQPHuQ",12) == 4285688300) strcat(s, "T");
if (crc32("ZuZGhjOVLVz",11) == 630250880) strcat(s, "s");
if (crc32("QQHPkTsCFaK",11) == 1955528729) strcat(s, "s");
    return s;
}

char *Head_nouns() {
    char *s = calloc(5);
    if (crc32("vYVMXgVG",8) == 4037653692) strcat(s, "x");
if (crc32("yFNDZXi",7) == 3910086515) strcat(s, "H");
if (crc32("VKikkNwCg",9) == 321191205) strcat(s, "j");
if (crc32("XjyIY",5) == 4076219059) strcat(s, "e");
if (crc32("rPZtNtEve",9) == 1781671794) strcat(s, "A");
if (crc32("upBwrOWFspqMGFP",15) == 1990812686) strcat(s, "a");
if (crc32("spoLYKnur",9) == 3563307637) strcat(s, "M");
if (crc32("KYDKWHLV",8) == 3940913983) strcat(s, "d");
    return s;
}

char *pyretotherapy_nouns() {
    char *s = calloc(14);
    if (crc32("GooWRltUpnSvC",13) == 1213027059) strcat(s, "p");
if (crc32("cOEvKhsZoWnY",12) == 1246226208) strcat(s, "y");
if (crc32("pdkHRWaApsv",11) == 1685093839) strcat(s, "k");
if (crc32("IelcDeNCQnjd",12) == 3821299386) strcat(s, "r");
if (crc32("oWfaUCH",7) == 2916479113) strcat(s, "e");
if (crc32("tzSlxpfYuisRz",13) == 2986972082) strcat(s, "d");
if (crc32("LCXOpW",6) == 2034506044) strcat(s, "t");
if (crc32("asbiTWKkG",9) == 1761258643) strcat(s, "q");
if (crc32("JMfhPYuCzcsbrZ",14) == 3005155840) strcat(s, "o");
if (crc32("PrfPIWZy",8) == 1261411813) strcat(s, "t");
if (crc32("prZsdyt",7) == 446784824) strcat(s, "B");
if (crc32("MIBYxBupMEhOoMV",15) == 774408046) strcat(s, "h");
if (crc32("OPrumuhWjENIVBr",15) == 1293039059) strcat(s, "a");
if (crc32("YhGfOKKIWYlsjlA",15) == 3149556415) strcat(s, "e");
if (crc32("vxfxPJzdHsubkLt",15) == 4170020480) strcat(s, "C");
if (crc32("BfsASkmU",8) == 1488017836) strcat(s, "r");
if (crc32("OKKxgLTzPNhg",12) == 3063002841) strcat(s, "z");
if (crc32("JAUcbjLTvvzGpg",14) == 3697322452) strcat(s, "a");
if (crc32("yAcdG",5) == 3002090770) strcat(s, "p");
if (crc32("hzeyBbarB",9) == 3426458051) strcat(s, "Z");
if (crc32("vKPrIjKpx",9) == 2016344753) strcat(s, "y");
    return s;
}

char *Turkman_nouns() {
    char *s = calloc(8);
    if (crc32("qykxUWeKlMcJF",13) == 1991100162) strcat(s, "T");
if (crc32("afpjadrV",8) == 466087268) strcat(s, "m");
if (crc32("mlmydb",6) == 1764488637) strcat(s, "u");
if (crc32("nFbXCraDXrSomDm",15) == 1675314345) strcat(s, "r");
if (crc32("XpGWktoXWQCTZ",13) == 2612219281) strcat(s, "b");
if (crc32("KgNMegeIXPI",11) == 2780321701) strcat(s, "k");
if (crc32("iqkJuIbqrWHYS",13) == 3976665986) strcat(s, "m");
if (crc32("YnaCfB",6) == 3866263250) strcat(s, "m");
if (crc32("KSAfd",5) == 218514950) strcat(s, "d");
if (crc32("HaWAQUzDBjJw",12) == 297843930) strcat(s, "a");
if (crc32("saDxAMc",7) == 4153461855) strcat(s, "H");
if (crc32("qCAPPmZd",8) == 228946127) strcat(s, "n");
    return s;
}

char *chainwork_nouns() {
    char *s = calloc(10);
    if (crc32("XtFNzRNgGWcC",12) == 3540165094) strcat(s, "c");
if (crc32("jfefoOyqrmDINCi",15) == 3801873672) strcat(s, "R");
if (crc32("gpqIVCJZOfEO",12) == 1812806044) strcat(s, "h");
if (crc32("jbVeAliodgo",11) == 3001511957) strcat(s, "s");
if (crc32("FUbbofMXI",9) == 257759396) strcat(s, "a");
if (crc32("cRrCprHtg",9) == 3090675741) strcat(s, "i");
if (crc32("imlAICdxgiLG",12) == 28150420) strcat(s, "l");
if (crc32("qIdbrUBtiIlPG",13) == 294116299) strcat(s, "n");
if (crc32("COFJtZ",6) == 1900763425) strcat(s, "f");
if (crc32("ZYYSQoaSgp",10) == 2154833152) strcat(s, "w");
if (crc32("URTmSCAvPSyZA",13) == 253884217) strcat(s, "o");
if (crc32("WaVJwleHaoKgGV",14) == 2952799433) strcat(s, "g");
if (crc32("JMjuoUtKEjYW",12) == 1894140174) strcat(s, "r");
if (crc32("qpMhRg",6) == 1570679794) strcat(s, "D");
if (crc32("NgeTNEXjGDqjso",14) == 487465763) strcat(s, "k");
    return s;
}

char *Bentleyville_nouns() {
    char *s = calloc(13);
    if (crc32("tXaRqUNzvTxaqR",14) == 4087514878) strcat(s, "B");
if (crc32("UBMMIQNUOnaH",12) == 3871215226) strcat(s, "e");
if (crc32("mrmRn",5) == 287182027) strcat(s, "D");
if (crc32("ljglcywrMU",10) == 4073539555) strcat(s, "n");
if (crc32("aYmOva",6) == 3056843387) strcat(s, "t");
if (crc32("vWxzNbQHYVBYTHc",15) == 776388445) strcat(s, "l");
if (crc32("PSocMf",6) == 1503060502) strcat(s, "o");
if (crc32("mkCvMry",7) == 145431652) strcat(s, "e");
if (crc32("RsjQCUdHsADCBR",14) == 71750913) strcat(s, "r");
if (crc32("pPeIqOcIrHKec",13) == 586641997) strcat(s, "y");
if (crc32("fXJqW",5) == 1624233547) strcat(s, "v");
if (crc32("KxXGfEOZUAganO",14) == 235205203) strcat(s, "i");
if (crc32("xONhmnS",7) == 3932579865) strcat(s, "j");
if (crc32("ForFu",5) == 2750246063) strcat(s, "l");
if (crc32("hCTQhuJVX",9) == 3071779786) strcat(s, "l");
if (crc32("wXzqkXDcDJAPO",13) == 3842609051) strcat(s, "e");
    return s;
}

char *pepperwort_nouns() {
    char *s = calloc(11);
    if (crc32("uvsJOa",6) == 1939737661) strcat(s, "x");
if (crc32("hVZGeCenfSQlhcq",15) == 1290910507) strcat(s, "p");
if (crc32("vRlINVDilcVL",12) == 4253633667) strcat(s, "e");
if (crc32("IrBIiCyOQCCcUpH",15) == 2176667960) strcat(s, "B");
if (crc32("BSBflRM",7) == 967922238) strcat(s, "p");
if (crc32("fbPhZ",5) == 4164938491) strcat(s, "Y");
if (crc32("tacKyBpF",8) == 336803861) strcat(s, "p");
if (crc32("PnRkz",5) == 4142828926) strcat(s, "p");
if (crc32("naTGH",5) == 3476043867) strcat(s, "e");
if (crc32("iDbwIcYAxTYIpm",14) == 962154570) strcat(s, "q");
if (crc32("FCaII",5) == 4288545096) strcat(s, "r");
if (crc32("oxnRQznHcC",10) == 2314423147) strcat(s, "w");
if (crc32("NjHRL",5) == 4229228615) strcat(s, "o");
if (crc32("JjJEmEd",7) == 209907634) strcat(s, "q");
if (crc32("yOfTcT",6) == 274903304) strcat(s, "r");
if (crc32("tviDYCE",7) == 1726718762) strcat(s, "t");
    return s;
}

char *tractility_nouns() {
    char *s = calloc(11);
    if (crc32("ziiTX",5) == 3115848866) strcat(s, "t");
if (crc32("iqXMVTRrmm",10) == 1222286697) strcat(s, "t");
if (crc32("ZJxhxt",6) == 2596881793) strcat(s, "k");
if (crc32("dudHaZGkZAdZyft",15) == 891976051) strcat(s, "r");
if (crc32("toLbLuqLuT",10) == 537691940) strcat(s, "a");
if (crc32("bWTeXYPYk",9) == 656384065) strcat(s, "c");
if (crc32("dFkaRSr",7) == 1767603660) strcat(s, "o");
if (crc32("mcUDxkFdOohYXt",14) == 1842806354) strcat(s, "t");
if (crc32("IlPnGdlkbMn",11) == 3167227691) strcat(s, "i");
if (crc32("AlltGRIkByVZTq",14) == 2777461718) strcat(s, "l");
if (crc32("MoSIoCVTDRRqu",13) == 1781973004) strcat(s, "i");
if (crc32("mDQmpfRDvVupsEh",15) == 386730280) strcat(s, "t");
if (crc32("izZsZGPLu",9) == 1120189820) strcat(s, "x");
if (crc32("VdlBDPFAAIYk",12) == 2890627508) strcat(s, "y");
    return s;
}

char *scruple_nouns() {
    char *s = calloc(8);
    if (crc32("nDgGT",5) == 1794138321) strcat(s, "s");
if (crc32("aKIBokzPvytYUQ",14) == 1677441056) strcat(s, "q");
if (crc32("OaKToZpoEewFACr",15) == 112823222) strcat(s, "c");
if (crc32("DyEVSKISV",9) == 1174362900) strcat(s, "r");
if (crc32("SfWslXL",7) == 2651204264) strcat(s, "o");
if (crc32("JvqCEx",6) == 454831080) strcat(s, "u");
if (crc32("WRsGcWz",7) == 2370993640) strcat(s, "p");
if (crc32("gQfdgLbpcu",10) == 3044398468) strcat(s, "Y");
if (crc32("NQYSFqFWozncNl",14) == 1134669192) strcat(s, "l");
if (crc32("rTtVnaQE",8) == 1289161137) strcat(s, "e");
    return s;
}

char *deepener_nouns() {
    char *s = calloc(9);
    if (crc32("GYbEcI",6) == 3583777013) strcat(s, "V");
if (crc32("BJvrT",5) == 835444246) strcat(s, "d");
if (crc32("VOIKpfGaCPolRRO",15) == 2167686799) strcat(s, "e");
if (crc32("ETJXZFqyGJrHZJ",14) == 3069404597) strcat(s, "e");
if (crc32("gfeaBOFpXdV",11) == 3020215896) strcat(s, "p");
if (crc32("PLLBrrHSgDLW",12) == 410846772) strcat(s, "X");
if (crc32("ywUfJjiXgzdDI",13) == 3102216430) strcat(s, "e");
if (crc32("lTavUEXopFUv",12) == 2998828509) strcat(s, "n");
if (crc32("evHjWEnqFJ",10) == 1588806094) strcat(s, "E");
if (crc32("YmFOmaThkmQbvr",14) == 1912477718) strcat(s, "e");
if (crc32("rJjQtBZEook",11) == 3955250762) strcat(s, "r");
    return s;
}

char *Ki_nouns() {
    char *s = calloc(3);
    if (crc32("FjaFI",5) == 2772237619) strcat(s, "K");
if (crc32("xAXtQTtevsQ",11) == 2523154691) strcat(s, "X");
if (crc32("vVaSl",5) == 3260100863) strcat(s, "i");
    return s;
}

char *askos_nouns() {
    char *s = calloc(6);
    if (crc32("mYLnp",5) == 3279832952) strcat(s, "a");
if (crc32("acCXuJDSkhrk",12) == 1150970703) strcat(s, "I");
if (crc32("wdwEx",5) == 3153762061) strcat(s, "s");
if (crc32("wSsoJ",5) == 2669922486) strcat(s, "X");
if (crc32("PhhoFT",6) == 1664269127) strcat(s, "k");
if (crc32("DXasjyIVW",9) == 3414505829) strcat(s, "a");
if (crc32("kosoVLUM",8) == 1540255901) strcat(s, "o");
if (crc32("pnUGLutrFKUps",13) == 2488604740) strcat(s, "s");
    return s;
}

char *goggler_nouns() {
    char *s = calloc(8);
    if (crc32("WcNzwZQeMJ",10) == 592708933) strcat(s, "g");
if (crc32("VhyyO",5) == 3428704251) strcat(s, "o");
if (crc32("hGnmzC",6) == 4087087272) strcat(s, "g");
if (crc32("QiWcrOiUS",9) == 375124722) strcat(s, "g");
if (crc32("qBtJxHDJZfoVGZp",15) == 1402844491) strcat(s, "g");
if (crc32("gPBlhxzcoG",10) == 3968230891) strcat(s, "l");
if (crc32("EnMDyHgLgJxkkz",14) == 3306728146) strcat(s, "e");
if (crc32("BJWlMli",7) == 2037142588) strcat(s, "U");
if (crc32("jlBZaRlSxiweN",13) == 4216966767) strcat(s, "r");
    return s;
}

char *wheatear_nouns() {
    char *s = calloc(9);
    if (crc32("iosLpEPJaR",10) == 3372220078) strcat(s, "R");
if (crc32("yoKegziTh",9) == 1491011181) strcat(s, "w");
if (crc32("piBMZeOJw",9) == 3116309292) strcat(s, "r");
if (crc32("uFtDd",5) == 3294457999) strcat(s, "h");
if (crc32("BsbnzddsCRq",11) == 1547658689) strcat(s, "e");
if (crc32("PPQiP",5) == 2266428137) strcat(s, "a");
if (crc32("yRbuUi",6) == 2155424162) strcat(s, "T");
if (crc32("TdHwBWhq",8) == 2978412283) strcat(s, "t");
if (crc32("MKQlmY",6) == 3720312688) strcat(s, "e");
if (crc32("lioSC",5) == 3775285112) strcat(s, "a");
if (crc32("PHYyIodYtD",10) == 3600300881) strcat(s, "q");
if (crc32("tqWAkEqBEeNyW",13) == 2968710160) strcat(s, "r");
    return s;
}

char *Script_nouns() {
    char *s = calloc(7);
    if (crc32("pfABV",5) == 279085500) strcat(s, "S");
if (crc32("GVkrAyenjtocfq",14) == 3223437779) strcat(s, "A");
if (crc32("WpBeycu",7) == 1802037142) strcat(s, "c");
if (crc32("EvhtYiBYijzNw",13) == 2702183082) strcat(s, "r");
if (crc32("ySdEhIQmHbtOMAR",15) == 3587842086) strcat(s, "i");
if (crc32("ZWScVGOW",8) == 174312508) strcat(s, "p");
if (crc32("BcVtfYxm",8) == 3414471327) strcat(s, "t");
    return s;
}

char *massif_nouns() {
    char *s = calloc(7);
    if (crc32("fJUWZksQfOmFw",13) == 1598260324) strcat(s, "S");
if (crc32("AEaulyPnIuHcU",13) == 2091687183) strcat(s, "m");
if (crc32("gjDQnbBq",8) == 1990007280) strcat(s, "g");
if (crc32("AZpAWOxdLZPTic",14) == 2650717767) strcat(s, "a");
if (crc32("SrVIHnV",7) == 2654504858) strcat(s, "k");
if (crc32("bszblsN",7) == 4194651869) strcat(s, "s");
if (crc32("kBaOjRSqvsgCCM",14) == 2967733889) strcat(s, "U");
if (crc32("ykxtfJSzstepq",13) == 3812100473) strcat(s, "s");
if (crc32("vQazCRpXyIqwjlT",15) == 1404120983) strcat(s, "i");
if (crc32("cySJxdSGhXqBRRh",15) == 1394620446) strcat(s, "f");
    return s;
}

char *BurtonuponTrent_nouns() {
    char *s = calloc(16);
    if (crc32("lMfrTDU",7) == 1409024527) strcat(s, "Z");
if (crc32("RddaJnnUa",9) == 618117435) strcat(s, "B");
if (crc32("gFkdXd",6) == 658542381) strcat(s, "d");
if (crc32("JjyUwG",6) == 939908874) strcat(s, "u");
if (crc32("tbgRYd",6) == 720157793) strcat(s, "r");
if (crc32("sFdVZuGklCNgwpK",15) == 1956805909) strcat(s, "D");
if (crc32("dLxlr",5) == 1458818118) strcat(s, "t");
if (crc32("jRVRjPxOC",9) == 1486940270) strcat(s, "n");
if (crc32("ZcZsxpOoAlk",11) == 30807656) strcat(s, "o");
if (crc32("IEolZDiJnu",10) == 3056981446) strcat(s, "s");
if (crc32("oNtnblUP",8) == 2989035656) strcat(s, "n");
if (crc32("wkzEecP",7) == 2359897016) strcat(s, "D");
if (crc32("lCRoIor",7) == 1510288356) strcat(s, "u");
if (crc32("LnOUQCtxguxmkC",14) == 3761463707) strcat(s, "p");
if (crc32("NxqMdOK",7) == 372767891) strcat(s, "D");
if (crc32("PZKvpPzextDo",12) == 4174991169) strcat(s, "o");
if (crc32("xtiMR",5) == 1008048729) strcat(s, "z");
if (crc32("FIfxTJxYwUmz",12) == 2171988548) strcat(s, "n");
if (crc32("hgpwTUhDKQSQqcE",15) == 351084421) strcat(s, "T");
if (crc32("SLsqUuQBhxd",11) == 1377330033) strcat(s, "r");
if (crc32("TfRUFCmwbEcBOMe",15) == 2937545313) strcat(s, "M");
if (crc32("eWlsDeyxt",9) == 614178776) strcat(s, "e");
if (crc32("qiFlBfqLJN",10) == 3426094363) strcat(s, "n");
if (crc32("SehCvMI",7) == 3978339708) strcat(s, "t");
    return s;
}

char *tremendousness_nouns() {
    char *s = calloc(15);
    if (crc32("UcKGoOP",7) == 335602533) strcat(s, "t");
if (crc32("sWMcJ",5) == 2383533152) strcat(s, "r");
if (crc32("wULnNoXSZbgRTs",14) == 55133744) strcat(s, "s");
if (crc32("QdkymXeYrpduiG",14) == 3209604022) strcat(s, "e");
if (crc32("OAClJpFMS",9) == 2083120383) strcat(s, "A");
if (crc32("sLRbrzjx",8) == 1065231476) strcat(s, "m");
if (crc32("LpxEloQ",7) == 3477727997) strcat(s, "e");
if (crc32("FcbOxoJJ",8) == 1653597253) strcat(s, "P");
if (crc32("iPBfJdYFFKN",11) == 293002159) strcat(s, "n");
if (crc32("qaLvi",5) == 3860481191) strcat(s, "L");
if (crc32("lmYOh",5) == 71953680) strcat(s, "d");
if (crc32("yqrvV",5) == 1299915989) strcat(s, "o");
if (crc32("KsRewiNWqDqaOUH",15) == 1650392042) strcat(s, "u");
if (crc32("IMJgxPjQPsGsnXJ",15) == 2348620820) strcat(s, "k");
if (crc32("KLxfDETuBxUU",12) == 2255123800) strcat(s, "s");
if (crc32("qIwcUtkwI",9) == 3903655475) strcat(s, "F");
if (crc32("TYWlmOCW",8) == 3550155136) strcat(s, "n");
if (crc32("sSaNYxzIAQs",11) == 1662659083) strcat(s, "v");
if (crc32("rIOxXQNWDUaWTH",14) == 3686296404) strcat(s, "e");
if (crc32("CrRwxE",6) == 1794545107) strcat(s, "s");
if (crc32("kHiijTNnvcHP",12) == 1094919073) strcat(s, "s");
    return s;
}

char *neoplasticism_nouns() {
    char *s = calloc(14);
    if (crc32("xrDobPKSeMNDW",13) == 3696803566) strcat(s, "C");
if (crc32("tuZNEINDAkz",11) == 1680285943) strcat(s, "n");
if (crc32("hqRUb",5) == 2114006989) strcat(s, "R");
if (crc32("fTphQVKpeLL",11) == 3865540394) strcat(s, "e");
if (crc32("GsbKOOTb",8) == 876544912) strcat(s, "o");
if (crc32("mMrmkMmrATCsE",13) == 524779833) strcat(s, "W");
if (crc32("mfJDU",5) == 1272236882) strcat(s, "p");
if (crc32("dCNiAO",6) == 1128739598) strcat(s, "l");
if (crc32("vdFhkQjWQxqI",12) == 532206143) strcat(s, "l");
if (crc32("nYRgrlfyKhmwZ",13) == 2927511920) strcat(s, "a");
if (crc32("tVjSPD",6) == 1732873036) strcat(s, "s");
if (crc32("RyHVP",5) == 1808135166) strcat(s, "t");
if (crc32("PgKaSySpIK",10) == 4282856613) strcat(s, "h");
if (crc32("IkmjLMNl",8) == 1054333750) strcat(s, "i");
if (crc32("SNPgbBhnQsc",11) == 490303274) strcat(s, "p");
if (crc32("LjpfGH",6) == 4202693430) strcat(s, "c");
if (crc32("gkCXZINUYMjppmc",15) == 3913193294) strcat(s, "i");
if (crc32("akEigwiB",8) == 3771181197) strcat(s, "s");
if (crc32("DpaskaRTKd",10) == 3722763850) strcat(s, "C");
if (crc32("idAqK",5) == 1077327149) strcat(s, "m");
    return s;
}

char *Kutch_nouns() {
    char *s = calloc(6);
    if (crc32("hlxDl",5) == 2489523632) strcat(s, "K");
if (crc32("PGhZMiZIJ",9) == 2883878698) strcat(s, "Z");
if (crc32("sKwQGStiqSCkSXu",15) == 1847016100) strcat(s, "u");
if (crc32("bCVuxbsQADWAga",14) == 2398522695) strcat(s, "t");
if (crc32("OsjKO",5) == 2564660695) strcat(s, "F");
if (crc32("HJGRwMIjmcrRoi",14) == 1879163023) strcat(s, "c");
if (crc32("CKayQmqbejfgm",13) == 2760663663) strcat(s, "h");
    return s;
}

char *Row_nouns() {
    char *s = calloc(4);
    if (crc32("RApDvAVgQbujR",13) == 2111735062) strcat(s, "o");
if (crc32("etefkM",6) == 728712871) strcat(s, "R");
if (crc32("QIrFb",5) == 2007454232) strcat(s, "o");
if (crc32("uyoHWtImjn",10) == 3650267351) strcat(s, "j");
if (crc32("OJJhGqxVIh",10) == 3036960153) strcat(s, "w");
    return s;
}

char *superfoliation_nouns() {
    char *s = calloc(15);
    if (crc32("WwHRNjLNZ",9) == 1680691643) strcat(s, "P");
if (crc32("BJthiXBZ",8) == 3126858105) strcat(s, "s");
if (crc32("YFruqbarziV",11) == 645733434) strcat(s, "Q");
if (crc32("NcYNuBTfC",9) == 2596931957) strcat(s, "u");
if (crc32("GfGKjcyrIfb",11) == 2654025425) strcat(s, "S");
if (crc32("OOmBYxbLuS",10) == 3217825111) strcat(s, "p");
if (crc32("LIhoZNDTdnxkdq",14) == 4018335540) strcat(s, "z");
if (crc32("xbCFobfnzCAwt",13) == 1088774125) strcat(s, "e");
if (crc32("LZedzTSgMmN",11) == 3570864707) strcat(s, "X");
if (crc32("RpNkkIFcE",9) == 1416966289) strcat(s, "r");
if (crc32("RqauJggkuShf",12) == 2887340352) strcat(s, "W");
if (crc32("iScSRFJdwG",10) == 1824164543) strcat(s, "f");
if (crc32("APjrzvCfHKdvjEV",15) == 4175872120) strcat(s, "T");
if (crc32("PwljWHuIzetfn",13) == 3315885996) strcat(s, "o");
if (crc32("LJcUpgjXI",9) == 4232710466) strcat(s, "x");
if (crc32("gRmleKTmLdP",11) == 777380846) strcat(s, "l");
if (crc32("hobCaslwCdi",11) == 1042133929) strcat(s, "m");
if (crc32("CyPPHvwzUvJp",12) == 1421397176) strcat(s, "i");
if (crc32("mmZpC",5) == 1496175642) strcat(s, "B");
if (crc32("PUQExEI",7) == 2477759077) strcat(s, "a");
if (crc32("VxznUpbH",8) == 2228705796) strcat(s, "r");
if (crc32("cZjpEw",6) == 235154389) strcat(s, "t");
if (crc32("rMdwpM",6) == 3112552998) strcat(s, "M");
if (crc32("QAlmxQoBijGPGvA",15) == 2131913502) strcat(s, "i");
if (crc32("mDdkwH",6) == 1080304040) strcat(s, "o");
if (crc32("jYnkr",5) == 259274338) strcat(s, "X");
if (crc32("mxzCbZ",6) == 1713493127) strcat(s, "n");
    return s;
}

char *demiculverin_nouns() {
    char *s = calloc(13);
    if (crc32("VVerHBIfSAkOy",13) == 3775902383) strcat(s, "d");
if (crc32("LSUafX",6) == 1429902799) strcat(s, "e");
if (crc32("LfkqXpAfCxnZ",12) == 1018252326) strcat(s, "z");
if (crc32("kJybAaZELVNp",12) == 482842568) strcat(s, "m");
if (crc32("uMbNsPqYPoW",11) == 605930875) strcat(s, "F");
if (crc32("HmQhyaBVwCOIgL",14) == 757758089) strcat(s, "i");
if (crc32("TTJNM",5) == 559457047) strcat(s, "D");
if (crc32("DukoXjmR",8) == 289128318) strcat(s, "c");
if (crc32("MMIJD",5) == 1981681266) strcat(s, "a");
if (crc32("GwgsLaC",7) == 2999727031) strcat(s, "u");
if (crc32("uIduTBTWWJ",10) == 2422816814) strcat(s, "l");
if (crc32("hYfwfEjtoYUibU",14) == 3488705923) strcat(s, "w");
if (crc32("vCzVlLzRq",9) == 730128707) strcat(s, "v");
if (crc32("KhfQtUFiHkaL",12) == 1687758231) strcat(s, "e");
if (crc32("UOkjeSusAiH",11) == 881768640) strcat(s, "r");
if (crc32("VHozJUFlUOwZqA",14) == 4197243864) strcat(s, "p");
if (crc32("BLdgGE",6) == 771976864) strcat(s, "i");
if (crc32("SnmXsEMKC",9) == 4104771148) strcat(s, "n");
    return s;
}

char *allergenicity_nouns() {
    char *s = calloc(14);
    if (crc32("avZIoEzTqZX",11) == 1972745938) strcat(s, "a");
if (crc32("pGtVc",5) == 2249298401) strcat(s, "z");
if (crc32("XXXkeXG",7) == 1560874136) strcat(s, "l");
if (crc32("LRYOgFAivIby",12) == 3365573897) strcat(s, "l");
if (crc32("URXyomfc",8) == 484938132) strcat(s, "e");
if (crc32("vpmGyPWoXPAQALz",15) == 2691688432) strcat(s, "r");
if (crc32("KHcnSGBpu",9) == 3441956874) strcat(s, "g");
if (crc32("cJzWNLkYEE",10) == 3852972491) strcat(s, "e");
if (crc32("qdTKlPPHMsY",11) == 1375898817) strcat(s, "J");
if (crc32("OLlTeOCvivFA",12) == 1705599566) strcat(s, "n");
if (crc32("NbjmbCOpPfKoEc",14) == 3219659626) strcat(s, "o");
if (crc32("NklEfzur",8) == 2496255819) strcat(s, "i");
if (crc32("zCIwGvIA",8) == 942386050) strcat(s, "c");
if (crc32("xFbDt",5) == 970029976) strcat(s, "i");
if (crc32("kYmyb",5) == 2206952401) strcat(s, "t");
if (crc32("AUpzTvYKtCqnvN",14) == 3899116504) strcat(s, "y");
    return s;
}

char *retem_nouns() {
    char *s = calloc(6);
    if (crc32("YhpSlPhBVTiKnEI",15) == 3239971188) strcat(s, "r");
if (crc32("tnQoPnbaseI",11) == 3067002997) strcat(s, "e");
if (crc32("pxjWxvrSAQPej",13) == 1638923306) strcat(s, "t");
if (crc32("gadVTm",6) == 846018523) strcat(s, "f");
if (crc32("lcnMxaGCuk",10) == 303440118) strcat(s, "e");
if (crc32("qnGpPDATskIj",12) == 1806090398) strcat(s, "f");
if (crc32("OTPavQAzowe",11) == 3347931677) strcat(s, "m");
    return s;
}

char *antimerism_nouns() {
    char *s = calloc(11);
    if (crc32("ovOUrK",6) == 2498778049) strcat(s, "N");
if (crc32("zEWuxntBrWncAN",14) == 567362424) strcat(s, "a");
if (crc32("salpAvfMNp",10) == 883347336) strcat(s, "n");
if (crc32("QAPKXFf",7) == 133675563) strcat(s, "S");
if (crc32("WdhMEqIrvVNfh",13) == 540168199) strcat(s, "t");
if (crc32("sLHHXgAUsXjwZS",14) == 90921573) strcat(s, "w");
if (crc32("MbUpAohLrAR",11) == 1878019593) strcat(s, "i");
if (crc32("fdBfk",5) == 4274862331) strcat(s, "m");
if (crc32("GvwtSUqrDhcjjrf",15) == 3790712638) strcat(s, "e");
if (crc32("kvicIuYJfn",10) == 1997421597) strcat(s, "r");
if (crc32("QuvNfTIJcTlWSQe",15) == 2610826205) strcat(s, "R");
if (crc32("DOzJYBhA",8) == 2879975822) strcat(s, "i");
if (crc32("wxHbzXb",7) == 2489488576) strcat(s, "U");
if (crc32("cEEDAkZtBfWSoF",14) == 761474660) strcat(s, "s");
if (crc32("roQNWowaQgviTLm",15) == 4158621556) strcat(s, "g");
if (crc32("wEmCNkgtyeFBlPo",15) == 3716877075) strcat(s, "m");
    return s;
}

char *eventuality_nouns() {
    char *s = calloc(12);
    if (crc32("PJHJPXXduF",10) == 2203858322) strcat(s, "e");
if (crc32("jlIJUERwJf",10) == 2910748579) strcat(s, "P");
if (crc32("DJIjFXm",7) == 3085283722) strcat(s, "v");
if (crc32("hMnxfZsEJyB",11) == 200794947) strcat(s, "V");
if (crc32("IRZXyKgsyrPSde",14) == 604464709) strcat(s, "e");
if (crc32("URqNeCx",7) == 4153796671) strcat(s, "k");
if (crc32("ydKYLX",6) == 3881385963) strcat(s, "n");
if (crc32("FJrEcl",6) == 3315622233) strcat(s, "J");
if (crc32("MEAmnYcJpQ",10) == 1940768391) strcat(s, "t");
if (crc32("SfrjeSxqbMf",11) == 1523854308) strcat(s, "V");
if (crc32("miEzi",5) == 1984035779) strcat(s, "u");
if (crc32("cFNiKtPje",9) == 1389515978) strcat(s, "a");
if (crc32("HILWwpe",7) == 565372289) strcat(s, "m");
if (crc32("LEyEREtGXjBJUBa",15) == 594716620) strcat(s, "l");
if (crc32("LJIYauJlUt",10) == 1308147196) strcat(s, "o");
if (crc32("VLKeNKRPkg",10) == 2152300249) strcat(s, "i");
if (crc32("SeLFKYWK",8) == 4087395960) strcat(s, "t");
if (crc32("QxAohqeneiTPqJK",15) == 2451213286) strcat(s, "L");
if (crc32("SbxdGPm",7) == 1273402027) strcat(s, "y");
    return s;
}

char *Sorbonne_nouns() {
    char *s = calloc(9);
    if (crc32("SoBPl",5) == 1467321562) strcat(s, "S");
if (crc32("ntKSh",5) == 2470977310) strcat(s, "s");
if (crc32("rwfXitXOrhparc",14) == 2820828065) strcat(s, "o");
if (crc32("ajRvquiTcA",10) == 528866292) strcat(s, "r");
if (crc32("wfDQGYfe",8) == 3518676083) strcat(s, "b");
if (crc32("OMUjGQZ",7) == 1699404602) strcat(s, "o");
if (crc32("vQBOmKeaMuIa",12) == 1127555312) strcat(s, "n");
if (crc32("DuEpGnaxmxQN",12) == 474228329) strcat(s, "n");
if (crc32("riURjuklxBM",11) == 3329677573) strcat(s, "v");
if (crc32("mcfKvbKpoMPOPg",14) == 4204361868) strcat(s, "e");
    return s;
}

char *Epidaurus_nouns() {
    char *s = calloc(10);
    if (crc32("anoxslXdVNF",11) == 1316568418) strcat(s, "E");
if (crc32("qxGyswbyE",9) == 677852215) strcat(s, "p");
if (crc32("AMibBUVXXABB",12) == 2134199905) strcat(s, "i");
if (crc32("qTcZqQ",6) == 1020333672) strcat(s, "l");
if (crc32("JfZHOioQeIL",11) == 2067510629) strcat(s, "d");
if (crc32("fiOmYPKRMoz",11) == 1791115434) strcat(s, "a");
if (crc32("nSGYjtfeQ",9) == 3935425799) strcat(s, "M");
if (crc32("HArLWCEjjPL",11) == 4256458901) strcat(s, "u");
if (crc32("lWxQp",5) == 2931391030) strcat(s, "j");
if (crc32("RZabeB",6) == 3400986435) strcat(s, "r");
if (crc32("DPrgyCrwLE",10) == 971222391) strcat(s, "n");
if (crc32("DfCYwOfMHxwzi",13) == 4132640165) strcat(s, "u");
if (crc32("NcHezQNc",8) == 2182053860) strcat(s, "s");
    return s;
}

char *phosphatase_nouns() {
    char *s = calloc(12);
    if (crc32("AKgLysSlzGorY",13) == 198973235) strcat(s, "v");
if (crc32("HQJVYM",6) == 2822176434) strcat(s, "p");
if (crc32("aRXxzNrRGw",10) == 831204432) strcat(s, "s");
if (crc32("RPQifW",6) == 982013834) strcat(s, "h");
if (crc32("vKRrfoKQUdmLGv",14) == 556298870) strcat(s, "P");
if (crc32("AKWQSxyPOnhHO",13) == 4051967526) strcat(s, "o");
if (crc32("rIiKRsF",7) == 3798907798) strcat(s, "s");
if (crc32("YklLHV",6) == 3073809932) strcat(s, "Y");
if (crc32("qwsHTMtPGLI",11) == 4143086517) strcat(s, "p");
if (crc32("VvGZCdyrTdNa",12) == 3522400943) strcat(s, "g");
if (crc32("xEHrGFPxUjytC",13) == 320860128) strcat(s, "h");
if (crc32("yNlhftfIBV",10) == 4068618680) strcat(s, "w");
if (crc32("SucUDxbke",9) == 1543600090) strcat(s, "a");
if (crc32("sQFmYKzQqz",10) == 1691975357) strcat(s, "R");
if (crc32("IOXmeujlUsjls",13) == 4281779302) strcat(s, "t");
if (crc32("aURHMz",6) == 1746112476) strcat(s, "a");
if (crc32("WHzDf",5) == 3498217882) strcat(s, "X");
if (crc32("caYbZImpGx",10) == 1085243688) strcat(s, "s");
if (crc32("MXIDDEjdQ",9) == 1397340140) strcat(s, "e");
    return s;
}

char *Aligarh_nouns() {
    char *s = calloc(8);
    if (crc32("UiAOTC",6) == 282021892) strcat(s, "A");
if (crc32("FBsVNxAifm",10) == 2053808335) strcat(s, "l");
if (crc32("FqAriBcVkOLGB",13) == 3230112501) strcat(s, "i");
if (crc32("kzkRvOCixtlkPf",14) == 2559260793) strcat(s, "T");
if (crc32("UZsTkgnLZmV",11) == 2364184382) strcat(s, "g");
if (crc32("PqrGjyissHevjN",14) == 1821941932) strcat(s, "b");
if (crc32("DnxNKC",6) == 736005800) strcat(s, "a");
if (crc32("rSHctWvwZWlY",12) == 694251063) strcat(s, "a");
if (crc32("JfGmvcnyW",9) == 2555235896) strcat(s, "r");
if (crc32("oKraTIoI",8) == 505159212) strcat(s, "h");
    return s;
}

char *ilth_nouns() {
    char *s = calloc(5);
    if (crc32("QaqxUl",6) == 3639303807) strcat(s, "i");
if (crc32("pdMyVl",6) == 1290369393) strcat(s, "l");
if (crc32("HnoxGsGAPRaRxHM",15) == 3993047240) strcat(s, "t");
if (crc32("FdXkSlJV",8) == 2560704880) strcat(s, "T");
if (crc32("cssZtSyIiDx",11) == 3207198616) strcat(s, "h");
    return s;
}

char *Ithnan_nouns() {
    char *s = calloc(7);
    if (crc32("wyKygWwT",8) == 3898615642) strcat(s, "I");
if (crc32("lyRZIOfUPTXCuKQ",15) == 3099346607) strcat(s, "y");
if (crc32("lGFeMhcKCAgM",12) == 1560562173) strcat(s, "t");
if (crc32("DhvtTBWqfN",10) == 4118697021) strcat(s, "h");
if (crc32("hAzQCXRtKukA",12) == 2821481870) strcat(s, "c");
if (crc32("prhtt",5) == 2755259530) strcat(s, "n");
if (crc32("pqXsSq",6) == 2429082468) strcat(s, "a");
if (crc32("dHMYfmI",7) == 2428062616) strcat(s, "f");
if (crc32("wKWCSF",6) == 2733185842) strcat(s, "n");
    return s;
}

char *repromulgation_nouns() {
    char *s = calloc(15);
    if (crc32("bfoHXbK",7) == 2465798787) strcat(s, "Y");
if (crc32("pmNjeJ",6) == 1800030474) strcat(s, "r");
if (crc32("bfpjByapjV",10) == 2738510295) strcat(s, "z");
if (crc32("TMEQBudaRM",10) == 2523169790) strcat(s, "e");
if (crc32("saUpQM",6) == 2613659337) strcat(s, "p");
if (crc32("zwgMaulphpws",12) == 1504910239) strcat(s, "r");
if (crc32("BvifECRYzg",10) == 2568472876) strcat(s, "o");
if (crc32("orKCFwsutVX",11) == 1059933275) strcat(s, "F");
if (crc32("TnjCiD",6) == 3809891319) strcat(s, "m");
if (crc32("WqkkZO",6) == 1785326991) strcat(s, "u");
if (crc32("rJVWP",5) == 3545134370) strcat(s, "m");
if (crc32("oyZDES",6) == 284028742) strcat(s, "l");
if (crc32("ydOKBjLCToOf",12) == 4227463117) strcat(s, "W");
if (crc32("DRtdunkIwIMuCXQ",15) == 1231004561) strcat(s, "g");
if (crc32("kyfndg",6) == 255454987) strcat(s, "i");
if (crc32("EZJzSwLkrIHzYkS",15) == 4201991934) strcat(s, "a");
if (crc32("HwYmtSnAu",9) == 2036295238) strcat(s, "t");
if (crc32("ypEsUYMwPsZxUEB",15) == 3297914552) strcat(s, "U");
if (crc32("EUNXFCubzXP",11) == 1297316403) strcat(s, "i");
if (crc32("hFhaU",5) == 2409920215) strcat(s, "X");
if (crc32("XxnaTF",6) == 1262083557) strcat(s, "o");
if (crc32("RXeLUyWTwoVuTx",14) == 578607886) strcat(s, "N");
if (crc32("lCmytMP",7) == 1382514167) strcat(s, "n");
    return s;
}

char *bearsear_nouns() {
    char *s = calloc(9);
    if (crc32("dczDFiL",7) == 2153942711) strcat(s, "C");
if (crc32("CkIyskgEahy",11) == 965194047) strcat(s, "b");
if (crc32("vHKfMVw",7) == 2591257399) strcat(s, "e");
if (crc32("AxZqhVVnQy",10) == 3301883301) strcat(s, "e");
if (crc32("vuqsIsTW",8) == 1412587824) strcat(s, "a");
if (crc32("fqxkxAdrB",9) == 875679801) strcat(s, "r");
if (crc32("gqDVBFClEAl",11) == 2765459364) strcat(s, "s");
if (crc32("FDjuIRdhrvo",11) == 507435236) strcat(s, "e");
if (crc32("IeSQgTukYhgGd",13) == 1962169022) strcat(s, "a");
if (crc32("cypeSFrbVy",10) == 3799041018) strcat(s, "r");
    return s;
}

char *Alejandro_nouns() {
    char *s = calloc(10);
    if (crc32("aHTebXUtiNT",11) == 256364556) strcat(s, "E");
if (crc32("wLzpBkUWun",10) == 3746672773) strcat(s, "A");
if (crc32("xPyArfJ",7) == 767426865) strcat(s, "I");
if (crc32("ksTpyp",6) == 3555034883) strcat(s, "l");
if (crc32("rRhGfufKcM",10) == 685726884) strcat(s, "j");
if (crc32("jDqbCgQO",8) == 909890139) strcat(s, "e");
if (crc32("NKKYdSmLQ",9) == 1552294629) strcat(s, "j");
if (crc32("poMrruFZb",9) == 3609687875) strcat(s, "a");
if (crc32("IKhAYZvwNfpyYND",15) == 1264490804) strcat(s, "a");
if (crc32("paIELveuQ",9) == 4009409026) strcat(s, "T");
if (crc32("UmCaQvSsgFeo",12) == 1340420836) strcat(s, "n");
if (crc32("aMDnuquc",8) == 1632961851) strcat(s, "d");
if (crc32("RoSQdUHlxDH",11) == 3647600568) strcat(s, "q");
if (crc32("QqtiKZ",6) == 2311740110) strcat(s, "r");
if (crc32("etiumraX",8) == 2091426915) strcat(s, "o");
    return s;
}

char *Canicula_nouns() {
    char *s = calloc(9);
    if (crc32("XrOvVzFlGKqhw",13) == 3740189687) strcat(s, "C");
if (crc32("oVnWsYAAx",9) == 124753687) strcat(s, "b");
if (crc32("HXPyftZtAzbIJgw",15) == 717533856) strcat(s, "a");
if (crc32("STjlwZElU",9) == 1729123657) strcat(s, "n");
if (crc32("lzAkLiNF",8) == 1026249045) strcat(s, "e");
if (crc32("VvIIoAWYRJuZo",13) == 1891746916) strcat(s, "i");
if (crc32("vZvrqaD",7) == 2162332041) strcat(s, "U");
if (crc32("YSXOstvIz",9) == 2522733975) strcat(s, "c");
if (crc32("JhFAzABHLEwS",12) == 3517678219) strcat(s, "u");
if (crc32("THGKRFxlAu",10) == 1110505532) strcat(s, "g");
if (crc32("ZCOOhdxz",8) == 384892782) strcat(s, "l");
if (crc32("IhsPLG",6) == 2442474355) strcat(s, "a");
    return s;
}

char *ornith_nouns() {
    char *s = calloc(7);
    if (crc32("zVmAuYGfmxi",11) == 2416312798) strcat(s, "B");
if (crc32("rfnBWNDbkCzpvHw",15) == 2608878818) strcat(s, "o");
if (crc32("HPRglC",6) == 175467926) strcat(s, "j");
if (crc32("rgDpNTyvqlvci",13) == 3858353932) strcat(s, "r");
if (crc32("rdqiIWhBIK",10) == 2167461674) strcat(s, "n");
if (crc32("DTvnztRgdWk",11) == 2818340473) strcat(s, "i");
if (crc32("yfMssDTnBCFFkT",14) == 1847736198) strcat(s, "G");
if (crc32("vTUOaBBH",8) == 346812907) strcat(s, "t");
if (crc32("oNHUQHjK",8) == 402719850) strcat(s, "h");
    return s;
}

char *Moniz_nouns() {
    char *s = calloc(6);
    if (crc32("XyAGsovZfEVvOxM",15) == 3694032414) strcat(s, "b");
if (crc32("fLMssWHWTXhrmvr",15) == 2883395918) strcat(s, "M");
if (crc32("YbyiNgI",7) == 2202616802) strcat(s, "o");
if (crc32("zDsUTjcwJNghW",13) == 982579682) strcat(s, "n");
if (crc32("MGFPBLQWQlZ",11) == 4051440199) strcat(s, "A");
if (crc32("pOFjluGGEBt",11) == 237564027) strcat(s, "i");
if (crc32("IKxqPjHIy",9) == 2990705439) strcat(s, "Z");
if (crc32("aLIYIVYL",8) == 2107783244) strcat(s, "z");
    return s;
}

char *threaper_nouns() {
    char *s = calloc(9);
    if (crc32("XTViTluigNRHZI",14) == 1105618877) strcat(s, "F");
if (crc32("TrHQqlssst",10) == 302095375) strcat(s, "t");
if (crc32("afgBvclohze",11) == 3842891281) strcat(s, "h");
if (crc32("kIxQyiACthze",12) == 607244305) strcat(s, "K");
if (crc32("bVRHgx",6) == 675424934) strcat(s, "r");
if (crc32("EcGlTBPCUys",11) == 2999005361) strcat(s, "e");
if (crc32("TKghXICOGKl",11) == 950206976) strcat(s, "a");
if (crc32("eTltNi",6) == 1026427523) strcat(s, "v");
if (crc32("frIzFTLywlpN",12) == 2694344947) strcat(s, "p");
if (crc32("ToWxCbS",7) == 186802769) strcat(s, "T");
if (crc32("XVMsvP",6) == 3414935615) strcat(s, "e");
if (crc32("vbnIoRLO",8) == 1517858768) strcat(s, "J");
if (crc32("SKoMturVNMlY",12) == 1978491316) strcat(s, "r");
    return s;
}

char *reverification_nouns() {
    char *s = calloc(15);
    if (crc32("fScADwrLZpc",11) == 645373986) strcat(s, "U");
if (crc32("aUPakoFHlb",10) == 1323194325) strcat(s, "r");
if (crc32("pwwRGgJjcK",10) == 61348894) strcat(s, "i");
if (crc32("rcwGgtrQLtGlC",13) == 2806263308) strcat(s, "e");
if (crc32("lKGLSVT",7) == 1642700618) strcat(s, "v");
if (crc32("qlDJh",5) == 1292639520) strcat(s, "e");
if (crc32("VSTqZLR",7) == 982096008) strcat(s, "A");
if (crc32("QpLkHrvcv",9) == 3231167375) strcat(s, "r");
if (crc32("nGAjLaOMYyLv",12) == 2522973941) strcat(s, "X");
if (crc32("qiNvWgBrZooaogD",15) == 1144335999) strcat(s, "i");
if (crc32("HqVAPKWNjc",10) == 4219805311) strcat(s, "I");
if (crc32("kPQxYTMscINTJO",14) == 3661949685) strcat(s, "f");
if (crc32("xIUiOakzUGwNZbA",15) == 2889278352) strcat(s, "i");
if (crc32("UWrGYvhVSoRRZD",14) == 452598050) strcat(s, "c");
if (crc32("tyTODfVeXWy",11) == 3806689937) strcat(s, "T");
if (crc32("OoZQstqnZztfN",13) == 491240404) strcat(s, "a");
if (crc32("ucIqtfLEy",9) == 3707515662) strcat(s, "t");
if (crc32("LuEhCSEDq",9) == 3071702993) strcat(s, "Y");
if (crc32("hIwraofXzi",10) == 3414123281) strcat(s, "i");
if (crc32("TTImsvPNRjr",11) == 1140556063) strcat(s, "Y");
if (crc32("uENuNOpXDyhKzn",14) == 3914103719) strcat(s, "o");
if (crc32("DhoGmppg",8) == 1870631746) strcat(s, "S");
if (crc32("yYpsN",5) == 1164057465) strcat(s, "n");
    return s;
}

char *retrochoir_nouns() {
    char *s = calloc(11);
    if (crc32("KqXoUq",6) == 3172192664) strcat(s, "r");
if (crc32("coJLyyFb",8) == 1039174721) strcat(s, "e");
if (crc32("VvXnxPxkEn",10) == 2768124971) strcat(s, "L");
if (crc32("qohADqldFFDfQ",13) == 2765914518) strcat(s, "t");
if (crc32("MHlJeD",6) == 255979871) strcat(s, "r");
if (crc32("GVFXDv",6) == 266363328) strcat(s, "k");
if (crc32("vrtlbB",6) == 2233651398) strcat(s, "o");
if (crc32("sRNMmZpba",9) == 1665885202) strcat(s, "c");
if (crc32("ascTyJUJzoLYxO",14) == 3998250156) strcat(s, "h");
if (crc32("aKJVqpcQO",9) == 1133884065) strcat(s, "o");
if (crc32("NDsHg",5) == 2287352224) strcat(s, "i");
if (crc32("SzAKOfaWC",9) == 2154921422) strcat(s, "r");
    return s;
}

char *supertotal_nouns() {
    char *s = calloc(11);
    if (crc32("RQzFAWDSMtDEaod",15) == 1436415995) strcat(s, "s");
if (crc32("ascyZmWDz",9) == 4016361449) strcat(s, "u");
if (crc32("NgMOOckC",8) == 3427423144) strcat(s, "B");
if (crc32("OKIGYDbTTR",10) == 1079545194) strcat(s, "p");
if (crc32("uAXuEUVZNfK",11) == 1234091421) strcat(s, "e");
if (crc32("AEWxCtqXmF",10) == 4258091328) strcat(s, "r");
if (crc32("IljzIeILgMBRrcK",15) == 3877672231) strcat(s, "t");
if (crc32("CBeZHmIR",8) == 441634528) strcat(s, "N");
if (crc32("CkWewcU",7) == 135837731) strcat(s, "o");
if (crc32("yoatzs",6) == 1969363779) strcat(s, "X");
if (crc32("UiMQCZLrZh",10) == 94932765) strcat(s, "t");
if (crc32("klykME",6) == 2649851192) strcat(s, "x");
if (crc32("vpohHJmAOZvzD",13) == 1229973962) strcat(s, "a");
if (crc32("GxjajTwNFZXzdGK",15) == 1813774027) strcat(s, "c");
if (crc32("WwphfWLVOWXJZMo",15) == 938916683) strcat(s, "l");
    return s;
}

char *Wernick_nouns() {
    char *s = calloc(8);
    if (crc32("DgPSVhaURyRQ",12) == 591635253) strcat(s, "u");
if (crc32("rzaLQXMDaRVRNh",14) == 2239911577) strcat(s, "W");
if (crc32("kFgHDBiiIL",10) == 600608066) strcat(s, "e");
if (crc32("gxeXfGaRyqyStxJ",15) == 3498996414) strcat(s, "r");
if (crc32("fxEcgMgO",8) == 1061817875) strcat(s, "n");
if (crc32("CoSFvzJJMDFAcK",14) == 4033670481) strcat(s, "U");
if (crc32("gqUsCjKWXdNKRM",14) == 3105835545) strcat(s, "i");
if (crc32("eDbKmwK",7) == 3199410189) strcat(s, "c");
if (crc32("mQCZYNkEX",9) == 3058804180) strcat(s, "D");
if (crc32("CdbNPv",6) == 3158974195) strcat(s, "k");
    return s;
}

char *Oina_nouns() {
    char *s = calloc(5);
    if (crc32("fCMzcDOcFUgBVa",14) == 3466986455) strcat(s, "O");
if (crc32("pttKqdxuaK",10) == 3319119075) strcat(s, "l");
if (crc32("wdBkwANE",8) == 4290800235) strcat(s, "i");
if (crc32("PkMqHI",6) == 3384483013) strcat(s, "G");
if (crc32("YNPvSBpFZL",10) == 3799683917) strcat(s, "n");
if (crc32("HRDzO",5) == 2340801501) strcat(s, "a");
    return s;
}

char *Marni_nouns() {
    char *s = calloc(6);
    if (crc32("QAjEaKEQg",9) == 4163132824) strcat(s, "M");
if (crc32("CqLPvCjHizkBUkL",15) == 3358221834) strcat(s, "a");
if (crc32("diWbAOL",7) == 1063339878) strcat(s, "m");
if (crc32("KWUDJoOmcNM",11) == 1979983737) strcat(s, "r");
if (crc32("MZJVHFkFw",9) == 3450004121) strcat(s, "n");
if (crc32("gRqvRYfVnsZQsTs",15) == 2873005462) strcat(s, "i");
    return s;
}

char *dipneedling_nouns() {
    char *s = calloc(12);
    if (crc32("SDgBXvyXuyM",11) == 3298552053) strcat(s, "m");
if (crc32("WljiG",5) == 606529110) strcat(s, "d");
if (crc32("KwxivGxXeAD",11) == 179108257) strcat(s, "U");
if (crc32("FfkeKutpUmOy",12) == 1648034038) strcat(s, "i");
if (crc32("yDnYqExnpl",10) == 3457202499) strcat(s, "p");
if (crc32("tBFqVahDNJ",10) == 1188492034) strcat(s, "n");
if (crc32("poLyCm",6) == 3245150761) strcat(s, "Q");
if (crc32("wkVkDDHjAZwTb",13) == 904654152) strcat(s, "e");
if (crc32("MZRieuCfbccgWW",14) == 424393185) strcat(s, "a");
if (crc32("avdEdqtynDWHp",13) == 3919915974) strcat(s, "e");
if (crc32("CBFahBQRjcfJ",12) == 2223996759) strcat(s, "d");
if (crc32("mFcOvmfvnBUcXd",14) == 3170752996) strcat(s, "l");
if (crc32("rsbbVFqyFFdj",12) == 2505287223) strcat(s, "i");
if (crc32("VjzrrgSjVt",10) == 2451800003) strcat(s, "n");
if (crc32("LgQPDNMsLBTAm",13) == 2120500936) strcat(s, "g");
    return s;
}

char *sheepfold_nouns() {
    char *s = calloc(10);
    if (crc32("slcEcQZW",8) == 3828263077) strcat(s, "s");
if (crc32("EaOrjswwOIfnd",13) == 3566938685) strcat(s, "r");
if (crc32("cxMKexp",7) == 3586838119) strcat(s, "h");
if (crc32("PQjUEf",6) == 3757804681) strcat(s, "l");
if (crc32("dhgUKRaCcgw",11) == 3901443274) strcat(s, "e");
if (crc32("ICAgBxdODljPM",13) == 1935640753) strcat(s, "e");
if (crc32("yKpHZFMBDRBIp",13) == 2276445169) strcat(s, "G");
if (crc32("XUsnE",5) == 2582489528) strcat(s, "p");
if (crc32("IKMtpdIPUb",10) == 2501256897) strcat(s, "T");
if (crc32("MJLTwHPmFG",10) == 3521589865) strcat(s, "f");
if (crc32("cDBqti",6) == 2311247105) strcat(s, "o");
if (crc32("IgQTcoO",7) == 1451618472) strcat(s, "l");
if (crc32("KCyaJJWnkM",10) == 3664138651) strcat(s, "d");
    return s;
}

char *thrashing_nouns() {
    char *s = calloc(10);
    if (crc32("uUKDCJiCZxBf",12) == 3304866631) strcat(s, "t");
if (crc32("TtcVxuXgSupO",12) == 2034203276) strcat(s, "h");
if (crc32("JDzaCft",7) == 3708498897) strcat(s, "x");
if (crc32("EmtGbisYCf",10) == 738160503) strcat(s, "r");
if (crc32("gzphRnoiJdJ",11) == 868215136) strcat(s, "n");
if (crc32("ZWKrtwSPUZbBLZh",15) == 3733686802) strcat(s, "a");
if (crc32("LEiiMIrAzFiWgQp",15) == 144120784) strcat(s, "s");
if (crc32("dvqySBWGJNb",11) == 1208794463) strcat(s, "h");
if (crc32("MwnlIfPgRVhipOC",15) == 1799629227) strcat(s, "I");
if (crc32("dyDdgsrkKvHrt",13) == 2428904444) strcat(s, "i");
if (crc32("XkRWd",5) == 4068185881) strcat(s, "n");
if (crc32("USjtLETo",8) == 1806563301) strcat(s, "g");
    return s;
}

char *phonemics_nouns() {
    char *s = calloc(10);
    if (crc32("dSPSJtMln",9) == 3738269809) strcat(s, "h");
if (crc32("sjUYOMzN",8) == 4277847388) strcat(s, "p");
if (crc32("tZrtHWrCFIF",11) == 2492532891) strcat(s, "R");
if (crc32("mEuqoHZ",7) == 985411640) strcat(s, "h");
if (crc32("NURNHTlECKp",11) == 4052803825) strcat(s, "o");
if (crc32("dLEgudxUB",9) == 2041959458) strcat(s, "e");
if (crc32("njgcNF",6) == 1302043784) strcat(s, "n");
if (crc32("rbICM",5) == 4037515699) strcat(s, "s");
if (crc32("rychJvt",7) == 3115774791) strcat(s, "e");
if (crc32("xFiPMGEvSz",10) == 3016457117) strcat(s, "X");
if (crc32("EiAYfPkEAfV",11) == 81630270) strcat(s, "m");
if (crc32("JMcZXEnUh",9) == 2296505333) strcat(s, "N");
if (crc32("GFiGaLn",7) == 3908297985) strcat(s, "i");
if (crc32("ExlCjQj",7) == 4073377078) strcat(s, "c");
if (crc32("KTAGPxXjPUmmM",13) == 620848938) strcat(s, "D");
if (crc32("buUMpWzZwFI",11) == 3954086754) strcat(s, "s");
    return s;
}

char *Bjurnson_nouns() {
    char *s = calloc(9);
    if (crc32("fKmrIOdkw",9) == 2265585788) strcat(s, "e");
if (crc32("kXSzcKp",7) == 2250779283) strcat(s, "B");
if (crc32("xvIEZIK",7) == 3341286123) strcat(s, "j");
if (crc32("SHvuySqiicfab",13) == 1196469800) strcat(s, "u");
if (crc32("dcweXL",6) == 1237953147) strcat(s, "r");
if (crc32("MpwvtusfNlRvIH",14) == 1429348739) strcat(s, "n");
if (crc32("TYeWJigXK",9) == 1877906219) strcat(s, "L");
if (crc32("AIglssfGlLDoIy",14) == 3485684465) strcat(s, "s");
if (crc32("ufDOjXBZeLHrLCr",15) == 3505587815) strcat(s, "C");
if (crc32("BmMYBmSBYoP",11) == 1732115557) strcat(s, "o");
if (crc32("CoeQaow",7) == 2078156798) strcat(s, "c");
if (crc32("lNIIWEktmj",10) == 2587066149) strcat(s, "n");
    return s;
}

char *wi_nouns() {
    char *s = calloc(3);
    if (crc32("fsMpOE",6) == 211097534) strcat(s, "J");
if (crc32("LBdGJsvZMtBP",12) == 4223682510) strcat(s, "w");
if (crc32("VIKxFfM",7) == 1114347316) strcat(s, "a");
if (crc32("pVphhSkFdcMBYiE",15) == 2719991989) strcat(s, "i");
    return s;
}

char *actinogram_nouns() {
    char *s = calloc(11);
    if (crc32("OhflDGThl",9) == 1515782453) strcat(s, "a");
if (crc32("NIeDDVirIDTluEA",15) == 3572861297) strcat(s, "c");
if (crc32("GjPucOWvZKR",11) == 1082088199) strcat(s, "p");
if (crc32("XSSusbwd",8) == 1384942490) strcat(s, "t");
if (crc32("fdLbYoklz",9) == 247903105) strcat(s, "Q");
if (crc32("JqnYF",5) == 2976748702) strcat(s, "i");
if (crc32("TPcRXM",6) == 866469477) strcat(s, "g");
if (crc32("ODDFP",5) == 2989255556) strcat(s, "n");
if (crc32("pHsotUffr",9) == 4186417958) strcat(s, "o");
if (crc32("xERPSva",7) == 3112851123) strcat(s, "g");
if (crc32("CjSaXBDO",8) == 3429860747) strcat(s, "r");
if (crc32("KUikJaHxRSSm",12) == 3528944381) strcat(s, "a");
if (crc32("EoBjpWDkB",9) == 3346843781) strcat(s, "m");
    return s;
}

char *curium_nouns() {
    char *s = calloc(7);
    if (crc32("iZPzMx",6) == 1710752313) strcat(s, "c");
if (crc32("qdSzJIXnw",9) == 818301852) strcat(s, "C");
if (crc32("qdMCmM",6) == 3734124020) strcat(s, "u");
if (crc32("eJebNLPACE",10) == 3560718864) strcat(s, "r");
if (crc32("Xxlwv",5) == 4162843160) strcat(s, "i");
if (crc32("kipEfHjZIz",10) == 984138989) strcat(s, "W");
if (crc32("bIEMcirC",8) == 1170271294) strcat(s, "u");
if (crc32("CjCrmi",6) == 2624829850) strcat(s, "Z");
if (crc32("WTBiisUDy",9) == 3878308451) strcat(s, "m");
    return s;
}

char *Bucephalus_nouns() {
    char *s = calloc(11);
    if (crc32("PWZnRznKtltE",12) == 1307866762) strcat(s, "p");
if (crc32("SlWiHfBSO",9) == 2436818221) strcat(s, "B");
if (crc32("xVgCm",5) == 454400107) strcat(s, "T");
if (crc32("IQccGW",6) == 3050515581) strcat(s, "u");
if (crc32("eooivDhvRSb",11) == 2261169276) strcat(s, "B");
if (crc32("RQTdCJzVtk",10) == 4091072526) strcat(s, "c");
if (crc32("iXvygkXm",8) == 3599646657) strcat(s, "i");
if (crc32("edOCxMzuxmIxDP",14) == 2516772150) strcat(s, "e");
if (crc32("MZOtDQ",6) == 1750142207) strcat(s, "p");
if (crc32("oPSzOlnLMzz",11) == 1074222692) strcat(s, "h");
if (crc32("WiPSPGUtJz",10) == 4238954059) strcat(s, "a");
if (crc32("oDKLvghYvJad",12) == 3918827839) strcat(s, "l");
if (crc32("xmXdNHWAK",9) == 3175047686) strcat(s, "u");
if (crc32("dpiUmC",6) == 1879546801) strcat(s, "w");
if (crc32("IUSLvRIGbcS",11) == 3329048750) strcat(s, "s");
    return s;
}

char *Bessie_nouns() {
    char *s = calloc(7);
    if (crc32("ucunCARvQiOZ",12) == 1396413188) strcat(s, "j");
if (crc32("PCrxOmPKqFtyFLd",15) == 269433299) strcat(s, "B");
if (crc32("hcqHyp",6) == 2282064139) strcat(s, "e");
if (crc32("oQPomuxySSlhXW",14) == 1037325965) strcat(s, "j");
if (crc32("lRkDJvhVorzBOH",14) == 1794408505) strcat(s, "s");
if (crc32("QPtFpYkleIHcTd",14) == 293483327) strcat(s, "K");
if (crc32("MzAVJXXusMRPOaU",15) == 579099306) strcat(s, "s");
if (crc32("ITWanmIweTMCyC",14) == 3437307319) strcat(s, "i");
if (crc32("SFGBm",5) == 2028145546) strcat(s, "F");
if (crc32("oxbNsEiehJTSxrR",15) == 403288748) strcat(s, "e");
    return s;
}

char *overroughness_nouns() {
    char *s = calloc(14);
    if (crc32("PHjxnn",6) == 2328010277) strcat(s, "o");
if (crc32("UTYOeU",6) == 1342238634) strcat(s, "p");
if (crc32("fvJGJRaVPjfNLaL",15) == 2865492190) strcat(s, "v");
if (crc32("kTZprivNH",9) == 3865704766) strcat(s, "e");
if (crc32("GiylluOKms",10) == 2026262722) strcat(s, "r");
if (crc32("uvGdUirUXPrxpNF",15) == 817684458) strcat(s, "o");
if (crc32("JFmBuke",7) == 490910322) strcat(s, "r");
if (crc32("znDJSeRYXiQaswu",15) == 229352611) strcat(s, "O");
if (crc32("SIqUASIhOJJA",12) == 2136163299) strcat(s, "o");
if (crc32("mnzLPDVdtbIOxx",14) == 185539923) strcat(s, "Z");
if (crc32("jOaRvkHFN",9) == 1610947705) strcat(s, "u");
if (crc32("aYkZr",5) == 2917706785) strcat(s, "L");
if (crc32("nmEZy",5) == 917512834) strcat(s, "g");
if (crc32("rxQGMy",6) == 1424010549) strcat(s, "h");
if (crc32("kOLOcOoNX",9) == 3758296708) strcat(s, "n");
if (crc32("hvHPLOmzHUSJE",13) == 992303350) strcat(s, "e");
if (crc32("qQCSiSptzOUoY",13) == 1866672389) strcat(s, "s");
if (crc32("LukepiO",7) == 2048260507) strcat(s, "a");
if (crc32("pkrRroplbQSv",12) == 2461595215) strcat(s, "s");
    return s;
}

char *Burlie_nouns() {
    char *s = calloc(7);
    if (crc32("fnncR",5) == 3861561222) strcat(s, "X");
if (crc32("KiqdlxcjDqCvln",14) == 307787340) strcat(s, "B");
if (crc32("zKNkrcm",7) == 2443814177) strcat(s, "u");
if (crc32("HzddEruIV",9) == 4074965067) strcat(s, "r");
if (crc32("MWNpuHTp",8) == 1374826757) strcat(s, "l");
if (crc32("XHybEvmaAmEmHX",14) == 441088052) strcat(s, "i");
if (crc32("QZWGLex",7) == 117405691) strcat(s, "e");
    return s;
}

char *Maas_nouns() {
    char *s = calloc(5);
    if (crc32("ToEQaXoAcJU",11) == 2442519369) strcat(s, "H");
if (crc32("JKLTOR",6) == 2027021066) strcat(s, "M");
if (crc32("wYkKVUOtsAtMr",13) == 3075469848) strcat(s, "C");
if (crc32("GGwQP",5) == 3007795444) strcat(s, "a");
if (crc32("MDlbGGhESBZNKv",14) == 1894966364) strcat(s, "a");
if (crc32("tUGcNGgi",8) == 3772129677) strcat(s, "s");
    return s;
}

char *Laennec_nouns() {
    char *s = calloc(8);
    if (crc32("gdGMSox",7) == 3760039872) strcat(s, "Q");
if (crc32("KDxTU",5) == 1648580076) strcat(s, "L");
if (crc32("GyJpdZjKHHPfqK",14) == 259677948) strcat(s, "a");
if (crc32("VuYGp",5) == 2713722905) strcat(s, "e");
if (crc32("zVqljQddmWMWild",15) == 1530016273) strcat(s, "n");
if (crc32("AhNoMKTYdIe",11) == 3380780183) strcat(s, "n");
if (crc32("EAGgoV",6) == 2700244237) strcat(s, "e");
if (crc32("HSYIkhDVYWH",11) == 3903907285) strcat(s, "q");
if (crc32("XcPrds",6) == 3681032989) strcat(s, "c");
    return s;
}

char *McKeesport_nouns() {
    char *s = calloc(11);
    if (crc32("WJqElHnXbKF",11) == 1979242729) strcat(s, "M");
if (crc32("EHgkccy",7) == 2197377659) strcat(s, "c");
if (crc32("QIuiRuXWi",9) == 2103131693) strcat(s, "N");
if (crc32("pSQrqDIWdV",10) == 3709662986) strcat(s, "K");
if (crc32("MTjOvIbXQlfARo",14) == 1139024450) strcat(s, "R");
if (crc32("GzdtaEtvTuzdQjJ",15) == 2532850951) strcat(s, "e");
if (crc32("LPQNOSd",7) == 3430834394) strcat(s, "e");
if (crc32("ZVVTbSkMXUb",11) == 2194157767) strcat(s, "s");
if (crc32("NsCdpEKzwZ",10) == 398373396) strcat(s, "p");
if (crc32("jXuBwOiyq",9) == 2187612) strcat(s, "A");
if (crc32("DIEvgbdpSjw",11) == 2729079748) strcat(s, "o");
if (crc32("FoztuHNQEye",11) == 2514628274) strcat(s, "f");
if (crc32("lWPgxmarB",9) == 4189672603) strcat(s, "r");
if (crc32("FXBglcgYLxmuk",13) == 1753217410) strcat(s, "h");
if (crc32("yvXFVHMG",8) == 1399586509) strcat(s, "t");
    return s;
}

char *Cabomba_nouns() {
    char *s = calloc(8);
    if (crc32("ALdXPeQc",8) == 1790087631) strcat(s, "C");
if (crc32("HAhvIqNp",8) == 1657005763) strcat(s, "a");
if (crc32("QfyhFVHEu",9) == 1618341171) strcat(s, "c");
if (crc32("qpNjEkBEfYNBS",13) == 1903988427) strcat(s, "b");
if (crc32("sScNMcf",7) == 357407388) strcat(s, "P");
if (crc32("RzJmQsbWk",9) == 3407627185) strcat(s, "o");
if (crc32("ohRbhzZIamLR",12) == 4123015476) strcat(s, "s");
if (crc32("XHmKVYnttgC",11) == 3255182338) strcat(s, "m");
if (crc32("HfWxrMkK",8) == 740918096) strcat(s, "W");
if (crc32("jGTWwimuQ",9) == 3388608895) strcat(s, "b");
if (crc32("zWDkWi",6) == 2647323) strcat(s, "a");
    return s;
}

char *Caernarvon_nouns() {
    char *s = calloc(11);
    if (crc32("FFMwnHeAqRIw",12) == 3116265132) strcat(s, "C");
if (crc32("SXEeJkuBq",9) == 3868305951) strcat(s, "E");
if (crc32("aOCvMmwroiTphb",14) == 1668457491) strcat(s, "a");
if (crc32("dqEDeyJPgwYocdn",15) == 554279788) strcat(s, "e");
if (crc32("blaheZvxVFczLe",14) == 137257677) strcat(s, "r");
if (crc32("bfxZulmFkQDqdMJ",15) == 3576469855) strcat(s, "n");
if (crc32("ccmfGJkUOnLnM",13) == 3491220450) strcat(s, "Y");
if (crc32("RGKQQBNS",8) == 257306461) strcat(s, "a");
if (crc32("uLlviGkxCXOoxi",14) == 559350446) strcat(s, "K");
if (crc32("aufXR",5) == 2244782424) strcat(s, "r");
if (crc32("PMcQWeFlEWuev",13) == 3558397650) strcat(s, "v");
if (crc32("TAmyLGUcgmz",11) == 2500480968) strcat(s, "X");
if (crc32("IXyNq",5) == 2409667222) strcat(s, "o");
if (crc32("jtMozZJEVViTTE",14) == 2835052270) strcat(s, "n");
    return s;
}

char *serigraphy_nouns() {
    char *s = calloc(11);
    if (crc32("nwWBQtBwLu",10) == 3817970338) strcat(s, "s");
if (crc32("sZOfBxOgd",9) == 271776993) strcat(s, "e");
if (crc32("rZJVSULTVosgktS",15) == 554765590) strcat(s, "j");
if (crc32("yLpLPHiDJEYPwN",14) == 4234201582) strcat(s, "r");
if (crc32("KntDckKkH",9) == 1127605199) strcat(s, "i");
if (crc32("fKNBMnsAnuawH",13) == 643165739) strcat(s, "g");
if (crc32("zWKSGpHYlPR",11) == 4239974646) strcat(s, "F");
if (crc32("PjxgTeipTc",10) == 2081019901) strcat(s, "r");
if (crc32("iWJlYGL",7) == 1380263698) strcat(s, "a");
if (crc32("XPxlLPi",7) == 1993087970) strcat(s, "p");
if (crc32("JHQLy",5) == 2460633649) strcat(s, "p");
if (crc32("PLUcl",5) == 1636062716) strcat(s, "Z");
if (crc32("gQJANkfDgk",10) == 2903205777) strcat(s, "h");
if (crc32("weJKHftK",8) == 595494746) strcat(s, "y");
    return s;
}

char *woe_nouns() {
    char *s = calloc(4);
    if (crc32("galZWquR",8) == 1268556230) strcat(s, "w");
if (crc32("mBAYmxRZBjSgT",13) == 2346186351) strcat(s, "u");
if (crc32("sNTHuDZpmIm",11) == 943721205) strcat(s, "o");
if (crc32("xRpeLMNORh",10) == 1014911896) strcat(s, "e");
    return s;
}

char *Megdal_nouns() {
    char *s = calloc(7);
    if (crc32("hcWWUCYvvoGvES",14) == 1448713078) strcat(s, "M");
if (crc32("msoVGgnqgyGwU",13) == 721191075) strcat(s, "e");
if (crc32("XhRCbTYIaF",10) == 2015270000) strcat(s, "U");
if (crc32("UFuhUWAqGouI",12) == 4113168268) strcat(s, "g");
if (crc32("BboOvFvMfyl",11) == 2766290446) strcat(s, "G");
if (crc32("oDIybkzBizZ",11) == 467228827) strcat(s, "d");
if (crc32("IibPHxYDw",9) == 3022696195) strcat(s, "a");
if (crc32("fYLltFMzUNxEx",13) == 3786941352) strcat(s, "c");
if (crc32("OMGHjBNtf",9) == 1074064317) strcat(s, "l");
    return s;
}

char *Natelson_nouns() {
    char *s = calloc(9);
    if (crc32("CUYhIhRefptpLgP",15) == 408452608) strcat(s, "N");
if (crc32("lMwiYQV",7) == 2701829767) strcat(s, "k");
if (crc32("EoQlKLMzwCr",11) == 2693791466) strcat(s, "a");
if (crc32("hBSWNJekik",10) == 2861102524) strcat(s, "f");
if (crc32("egdewZCCtQFVq",13) == 4223513136) strcat(s, "t");
if (crc32("wqkKTtxt",8) == 1671500828) strcat(s, "e");
if (crc32("QaweSAH",7) == 1676934499) strcat(s, "l");
if (crc32("qeRPgYwdW",9) == 422142682) strcat(s, "s");
if (crc32("TLxkqsKGiPG",11) == 3988906393) strcat(s, "P");
if (crc32("LIPsdeDzKc",10) == 3574215365) strcat(s, "o");
if (crc32("RKZoLyPkJS",10) == 1899500317) strcat(s, "H");
if (crc32("IrNnNldBvTVJAxk",15) == 3556931620) strcat(s, "n");
    return s;
}

char *Lucky_nouns() {
    char *s = calloc(6);
    if (crc32("MApqaATrCCukCFj",15) == 1103123768) strcat(s, "L");
if (crc32("fifFsQqr",8) == 993379529) strcat(s, "d");
if (crc32("CkGiwoZ",7) == 505725572) strcat(s, "u");
if (crc32("rANlgrdru",9) == 1251741095) strcat(s, "i");
if (crc32("IOcMSCoax",9) == 4206646084) strcat(s, "c");
if (crc32("sQofBYIahktXyRP",15) == 1359537707) strcat(s, "k");
if (crc32("mktLaPgDbkX",11) == 3436159821) strcat(s, "R");
if (crc32("Jtmtt",5) == 1812517274) strcat(s, "y");
    return s;
}

char *disease_nouns() {
    char *s = calloc(8);
    if (crc32("rKnhLbq",7) == 3113775888) strcat(s, "h");
if (crc32("HlDXuldwitnWoxM",15) == 2184959392) strcat(s, "d");
if (crc32("kuLQxsxC",8) == 2418394298) strcat(s, "U");
if (crc32("OaAhjeBoMlxzCFb",15) == 2326066334) strcat(s, "i");
if (crc32("TJorrIepgeIDvk",14) == 369221470) strcat(s, "s");
if (crc32("pGcHqSOgXRVULNi",15) == 219846181) strcat(s, "n");
if (crc32("sxTzOJ",6) == 154663925) strcat(s, "e");
if (crc32("kQyqvBUX",8) == 4831560) strcat(s, "x");
if (crc32("PlHdWEt",7) == 2933767268) strcat(s, "a");
if (crc32("GHePXDGOT",9) == 1306991962) strcat(s, "n");
if (crc32("eskITR",6) == 2673331088) strcat(s, "s");
if (crc32("YwvZTiNOsMfid",13) == 711071587) strcat(s, "n");
if (crc32("LcQVQzNsusQs",12) == 3931791015) strcat(s, "e");
    return s;
}

char *clonicity_nouns() {
    char *s = calloc(10);
    if (crc32("TtcUb",5) == 2121381715) strcat(s, "w");
if (crc32("RQxjfOXJnG",10) == 256732198) strcat(s, "c");
if (crc32("uEyhUIvwKbizDJ",14) == 2036529540) strcat(s, "C");
if (crc32("ykBzld",6) == 2564900652) strcat(s, "l");
if (crc32("jbuESTcn",8) == 2768971654) strcat(s, "o");
if (crc32("KGcFVwRl",8) == 2402418758) strcat(s, "k");
if (crc32("RxPhY",5) == 4183147914) strcat(s, "n");
if (crc32("NZfJtyrRqv",10) == 927454360) strcat(s, "i");
if (crc32("ATCwmZ",6) == 2363207910) strcat(s, "N");
if (crc32("mmSAlXdq",8) == 518558780) strcat(s, "c");
if (crc32("OCSwa",5) == 1466012229) strcat(s, "p");
if (crc32("GeqPeOlxlG",10) == 1112479815) strcat(s, "i");
if (crc32("aOEOOaQM",8) == 1830303496) strcat(s, "z");
if (crc32("zgPMCwPxsxQh",12) == 3537794542) strcat(s, "t");
if (crc32("YOLiQfDzMHeNVUK",15) == 206107078) strcat(s, "J");
if (crc32("tdIwrlA",7) == 717434244) strcat(s, "y");
    return s;
}

char *ac_nouns() {
    char *s = calloc(3);
    if (crc32("cKsxUTTzRgGkM",13) == 832066587) strcat(s, "v");
if (crc32("CYARe",5) == 2876889178) strcat(s, "a");
if (crc32("JaFvTLfITJVz",12) == 697166792) strcat(s, "W");
if (crc32("zQQkoQAL",8) == 1813249297) strcat(s, "c");
    return s;
}

char *macaw_nouns() {
    char *s = calloc(6);
    if (crc32("oYEQSHDhtv",10) == 3143023348) strcat(s, "m");
if (crc32("SYutJxcMyteEzCL",15) == 1426552910) strcat(s, "U");
if (crc32("LFlXqEqRgYQsS",13) == 2364887668) strcat(s, "a");
if (crc32("EEAEYXsz",8) == 2750975676) strcat(s, "y");
if (crc32("iAZsyGdyMA",10) == 1935793829) strcat(s, "c");
if (crc32("JExnxhzutRwzJck",15) == 84935939) strcat(s, "P");
if (crc32("mcIXPNNl",8) == 793838405) strcat(s, "a");
if (crc32("XZBrFpG",7) == 1893100726) strcat(s, "w");
    return s;
}

char *SS_nouns() {
    char *s = calloc(3);
    if (crc32("EALBWCRYm",9) == 3847885873) strcat(s, "s");
if (crc32("xmXZdctcyxgQIA",14) == 3237146319) strcat(s, "S");
if (crc32("UjgKLlxXEZSYPiq",15) == 1366695668) strcat(s, "S");
    return s;
}

char *aiguille_nouns() {
    char *s = calloc(9);
    if (crc32("FlOpUllICSziBP",14) == 151641187) strcat(s, "l");
if (crc32("bAsPuMtdHf",10) == 839221606) strcat(s, "a");
if (crc32("BlmVBykVHXk",11) == 967570433) strcat(s, "i");
if (crc32("kkhwDYbCGxHMfEH",15) == 2763656438) strcat(s, "g");
if (crc32("QgxidtB",7) == 320901954) strcat(s, "N");
if (crc32("fMmzUV",6) == 451038868) strcat(s, "u");
if (crc32("sCwwLM",6) == 3230915716) strcat(s, "j");
if (crc32("uxAIkZfWPU",10) == 1252128136) strcat(s, "i");
if (crc32("YadyHE",6) == 4016301560) strcat(s, "l");
if (crc32("xXRRxOhZWOPruZz",15) == 4163431164) strcat(s, "l");
if (crc32("oZGNiNG",7) == 2391223266) strcat(s, "x");
if (crc32("dADopkKkBjGgF",13) == 3286632361) strcat(s, "e");
    return s;
}

char *ovariotomy_nouns() {
    char *s = calloc(11);
    if (crc32("YDWOqj",6) == 4268097906) strcat(s, "K");
if (crc32("xFZxEOblBZFc",12) == 1783466800) strcat(s, "o");
if (crc32("iQnSdtRnHyOqO",13) == 1574317679) strcat(s, "P");
if (crc32("jjmOojHTETpH",12) == 3056275757) strcat(s, "v");
if (crc32("TbWBSAuWd",9) == 1319080294) strcat(s, "a");
if (crc32("ojOHJ",5) == 2105339393) strcat(s, "I");
if (crc32("EizKnfG",7) == 3263496792) strcat(s, "r");
if (crc32("XJkxKqdkxF",10) == 2662638639) strcat(s, "u");
if (crc32("CCDNVan",7) == 153509220) strcat(s, "i");
if (crc32("OBTfTb",6) == 413246832) strcat(s, "o");
if (crc32("AyPJW",5) == 2430655282) strcat(s, "R");
if (crc32("GSAOcMZgBlcBx",13) == 1023001259) strcat(s, "t");
if (crc32("xWsnCYmDS",9) == 2010582091) strcat(s, "r");
if (crc32("lTBftEYekzIDKrV",15) == 96517239) strcat(s, "o");
if (crc32("ECEWlACnPBnDE",13) == 3580174050) strcat(s, "m");
if (crc32("fUPjBSEwJtDskD",14) == 2982896651) strcat(s, "y");
    return s;
}

char *Runkel_nouns() {
    char *s = calloc(7);
    if (crc32("IWZXBGIHFqHG",12) == 4232943234) strcat(s, "j");
if (crc32("LRLqK",5) == 2492408183) strcat(s, "R");
if (crc32("jmDziuSGvFXtfJu",15) == 4124454113) strcat(s, "u");
if (crc32("dlDcTEIQBa",10) == 3805058562) strcat(s, "n");
if (crc32("ObaFI",5) == 4110530375) strcat(s, "u");
if (crc32("JSeOiayqYTGjO",13) == 2780230340) strcat(s, "k");
if (crc32("GWWbK",5) == 2770201943) strcat(s, "e");
if (crc32("tCkAUR",6) == 2449531128) strcat(s, "m");
if (crc32("WrepPzdgxuOeE",13) == 2974111672) strcat(s, "l");
    return s;
}

char *chlorpropamide_nouns() {
    char *s = calloc(15);
    if (crc32("OnyLzlNQrwThS",13) == 1886182889) strcat(s, "y");
if (crc32("TADpXFmI",8) == 2664746700) strcat(s, "c");
if (crc32("NcxKHcTTZN",10) == 1445620322) strcat(s, "L");
if (crc32("hTseYIHN",8) == 223900012) strcat(s, "h");
if (crc32("VRhVFfSkvJ",10) == 3508927505) strcat(s, "l");
if (crc32("iLWbOuRvHaoaUZ",14) == 4162451420) strcat(s, "l");
if (crc32("ryBvKsNSbTFTGy",14) == 3166396601) strcat(s, "o");
if (crc32("OFMIMZst",8) == 256825463) strcat(s, "o");
if (crc32("nKcMMBU",7) == 899287419) strcat(s, "r");
if (crc32("kytacb",6) == 1729589832) strcat(s, "p");
if (crc32("KJwJjUcpnI",10) == 1476545569) strcat(s, "r");
if (crc32("eNXgcIWxrbTv",12) == 1741814524) strcat(s, "o");
if (crc32("XnsOctV",7) == 1097333178) strcat(s, "p");
if (crc32("vXwTKKdWXeQ",11) == 3358557896) strcat(s, "N");
if (crc32("fRgkhGV",7) == 2290967449) strcat(s, "a");
if (crc32("NzhoryVPEMKbmrj",15) == 499868746) strcat(s, "a");
if (crc32("nXGmvpObXXf",11) == 1240556851) strcat(s, "m");
if (crc32("FKrbeU",6) == 527244501) strcat(s, "l");
if (crc32("GbiTpkwvymmr",12) == 1223596847) strcat(s, "i");
if (crc32("gPoByKNvFHecRi",14) == 3987213067) strcat(s, "C");
if (crc32("mvOWZO",6) == 2139697609) strcat(s, "d");
if (crc32("nUurNRM",7) == 1253327854) strcat(s, "A");
if (crc32("MWbPvRMWqVlEndU",15) == 308633948) strcat(s, "e");
    return s;
}

char *commodiousness_nouns() {
    char *s = calloc(15);
    if (crc32("PJQJuMrVVnPOsc",14) == 4011921277) strcat(s, "c");
if (crc32("USsnv",5) == 2157332332) strcat(s, "y");
if (crc32("VmEpY",5) == 4091821349) strcat(s, "o");
if (crc32("cSCbyC",6) == 2479575876) strcat(s, "m");
if (crc32("XBtAPnC",7) == 791384844) strcat(s, "x");
if (crc32("bRXoIKptKFDAY",13) == 873309746) strcat(s, "m");
if (crc32("wXPGL",5) == 797382214) strcat(s, "o");
if (crc32("vQcHcs",6) == 556379195) strcat(s, "F");
if (crc32("NXKrKzDQjiZf",12) == 2193154112) strcat(s, "d");
if (crc32("MnyAtyszPFGfKNN",15) == 2015621675) strcat(s, "E");
if (crc32("oGWSqJoO",8) == 703942491) strcat(s, "i");
if (crc32("FpWMvClr",8) == 3287413772) strcat(s, "T");
if (crc32("JJvtUE",6) == 3516197763) strcat(s, "o");
if (crc32("iXhioK",6) == 1842086653) strcat(s, "V");
if (crc32("YwqcFtCw",8) == 3772397036) strcat(s, "u");
if (crc32("sKSloUyvA",9) == 1481239714) strcat(s, "V");
if (crc32("JaKtwqsoCHSfbxP",15) == 675437796) strcat(s, "s");
if (crc32("VuvrC",5) == 2402320996) strcat(s, "n");
if (crc32("aNhJUilCFEDW",12) == 254346828) strcat(s, "e");
if (crc32("ZUUDIGPMqlnQerg",15) == 1272826166) strcat(s, "s");
if (crc32("vERLK",5) == 1093140867) strcat(s, "k");
if (crc32("wDsTGNgrqYKIh",13) == 3457955057) strcat(s, "s");
    return s;
}

char *spacetime_nouns() {
    char *s = calloc(10);
    if (crc32("EUjlHniksnv",11) == 2976934179) strcat(s, "c");
if (crc32("VAvPbMIMxUmhUvy",15) == 67538391) strcat(s, "s");
if (crc32("yhopliFNV",9) == 1305652766) strcat(s, "p");
if (crc32("HDzXT",5) == 4258628808) strcat(s, "a");
if (crc32("wPLUmpio",8) == 2625949522) strcat(s, "c");
if (crc32("xmVcI",5) == 1797010240) strcat(s, "t");
if (crc32("vbeGqCfMURNjh",13) == 2685079045) strcat(s, "e");
if (crc32("FSbewGnd",8) == 3198112077) strcat(s, "t");
if (crc32("MlkRTyEGkV",10) == 3046207261) strcat(s, "i");
if (crc32("omWgWXExHSHt",12) == 1608868536) strcat(s, "m");
if (crc32("YiziFI",6) == 3838200896) strcat(s, "e");
    return s;
}

char *phthalocyanine_nouns() {
    char *s = calloc(15);
    if (crc32("AlmfJgQKe",9) == 3500071000) strcat(s, "l");
if (crc32("RCbRIcJjkvd",11) == 895316242) strcat(s, "p");
if (crc32("iYdSlQzVmXpUZ",13) == 3152747023) strcat(s, "r");
if (crc32("WdfkU",5) == 688333847) strcat(s, "h");
if (crc32("vIhlzQcC",8) == 2920434846) strcat(s, "t");
if (crc32("zKWJJptXhzJP",12) == 1515791419) strcat(s, "h");
if (crc32("eMPzh",5) == 3216741162) strcat(s, "l");
if (crc32("hHdeLJsXPYo",11) == 3524444291) strcat(s, "a");
if (crc32("CCccFWPRK",9) == 376231522) strcat(s, "l");
if (crc32("yFQhySrx",8) == 895039003) strcat(s, "J");
if (crc32("LMGUAVx",7) == 2019968547) strcat(s, "o");
if (crc32("TumuWuepGS",10) == 854786200) strcat(s, "v");
if (crc32("KuJGvIoVpBLaP",13) == 366508140) strcat(s, "c");
if (crc32("bQRhCCFuvvVnCun",15) == 118431845) strcat(s, "y");
if (crc32("wLZKaASaX",9) == 513102634) strcat(s, "a");
if (crc32("aHbsIJIZNqrflT",14) == 1857966818) strcat(s, "n");
if (crc32("mWlySQyEzmQQY",13) == 212562738) strcat(s, "n");
if (crc32("WAFoG",5) == 4112080734) strcat(s, "F");
if (crc32("CaZGFMDRY",9) == 3687569911) strcat(s, "i");
if (crc32("PvuhbORGTfY",11) == 2388456150) strcat(s, "H");
if (crc32("okzBDEZpA",9) == 2896967460) strcat(s, "n");
if (crc32("HdrVKHg",7) == 1364334864) strcat(s, "z");
if (crc32("uXKjPQliYTqML",13) == 933588483) strcat(s, "e");
    return s;
}

char *hyperexaltation_nouns() {
    char *s = calloc(16);
    if (crc32("rRWSCBvN",8) == 1944056336) strcat(s, "v");
if (crc32("ZudPwUDwDq",10) == 2432153677) strcat(s, "h");
if (crc32("mllnjFhy",8) == 2504552692) strcat(s, "J");
if (crc32("YBXtisavorXuFy",14) == 794252074) strcat(s, "y");
if (crc32("hZNtGdwCy",9) == 3161970281) strcat(s, "p");
if (crc32("vtCFnN",6) == 4148634991) strcat(s, "e");
if (crc32("KjhtrgXvwkdMHKL",15) == 2215948400) strcat(s, "r");
if (crc32("IjRaVQBH",8) == 4033710691) strcat(s, "M");
if (crc32("LuiwGQfWRIeUw",13) == 2454371637) strcat(s, "e");
if (crc32("iAWWoWuo",8) == 188625645) strcat(s, "f");
if (crc32("vFDVoPaIPXMYvW",14) == 1625872811) strcat(s, "x");
if (crc32("gfxFnzPhnTL",11) == 1919469134) strcat(s, "H");
if (crc32("xCNarQJxvBOHrn",14) == 1161323251) strcat(s, "a");
if (crc32("jfHbeKyfhhRJPXS",15) == 1061461483) strcat(s, "H");
if (crc32("FvYHOzWyHTC",11) == 1104230930) strcat(s, "l");
if (crc32("mwGiSTZg",8) == 2700332107) strcat(s, "t");
if (crc32("tAyKhBWui",9) == 630516499) strcat(s, "a");
if (crc32("idGiRvdNKH",10) == 1621063367) strcat(s, "t");
if (crc32("pUEgElTiJEE",11) == 1015628575) strcat(s, "z");
if (crc32("PIGkdzBvHaeWi",13) == 723599439) strcat(s, "i");
if (crc32("vauyGmdx",8) == 2490528185) strcat(s, "o");
if (crc32("piRadDAcgIslE",13) == 2324661221) strcat(s, "n");
    return s;
}

char *nephralgia_nouns() {
    char *s = calloc(11);
    if (crc32("ejxaRoYCQ",9) == 3074543679) strcat(s, "K");
if (crc32("LqNdWJgHr",9) == 2360186337) strcat(s, "n");
if (crc32("UohmBVC",7) == 1015804830) strcat(s, "c");
if (crc32("ZkncZb",6) == 2159381645) strcat(s, "e");
if (crc32("ESeZDfV",7) == 840693246) strcat(s, "p");
if (crc32("gYOICuPz",8) == 1870720360) strcat(s, "k");
if (crc32("omdWFjzn",8) == 456887032) strcat(s, "h");
if (crc32("oxtRjZsQlg",10) == 3203562610) strcat(s, "P");
if (crc32("AKUkgldE",8) == 2493711811) strcat(s, "r");
if (crc32("LVnJJeckkH",10) == 3869766166) strcat(s, "Y");
if (crc32("QhFYYaTQwnRjJ",13) == 2853888194) strcat(s, "a");
if (crc32("qYmKFl",6) == 320559730) strcat(s, "l");
if (crc32("BOKwXIONMnMQ",12) == 500309459) strcat(s, "h");
if (crc32("lsVAFHSTZgafUr",14) == 2129706762) strcat(s, "g");
if (crc32("nMYWnqraGld",11) == 1850629514) strcat(s, "i");
if (crc32("sTervHBJ",8) == 2687171041) strcat(s, "X");
if (crc32("UAvLMzwt",8) == 3723374816) strcat(s, "a");
    return s;
}

char *Meehan_nouns() {
    char *s = calloc(7);
    if (crc32("MQTcKxbKLjmkte",14) == 2886802893) strcat(s, "M");
if (crc32("aStechuxGhARCYs",15) == 3152416209) strcat(s, "k");
if (crc32("TKpqaHm",7) == 1200535228) strcat(s, "e");
if (crc32("KIJMUBKwokOkPCj",15) == 3366352865) strcat(s, "G");
if (crc32("YTfjBEnd",8) == 51594622) strcat(s, "e");
if (crc32("PBWCGMBoGCdk",12) == 2244300646) strcat(s, "h");
if (crc32("CwvjIjuKrXN",11) == 2891711069) strcat(s, "V");
if (crc32("lbBHbFGMMOqDnmY",15) == 1322848483) strcat(s, "a");
if (crc32("tOjARllOn",9) == 4110390201) strcat(s, "w");
if (crc32("VvkvMrxcFTn",11) == 924826327) strcat(s, "n");
    return s;
}

char *aeromechanic_nouns() {
    char *s = calloc(13);
    if (crc32("VDyDXAu",7) == 45515426) strcat(s, "a");
if (crc32("GbECwO",6) == 409376764) strcat(s, "e");
if (crc32("LWdez",5) == 3934196082) strcat(s, "r");
if (crc32("uYDAivjWldUNaC",14) == 2570352912) strcat(s, "c");
if (crc32("OynOrA",6) == 132365083) strcat(s, "o");
if (crc32("RyjJIIcWTFT",11) == 3569600929) strcat(s, "n");
if (crc32("HilEd",5) == 1855156313) strcat(s, "m");
if (crc32("hijsIzoJcDwtfUq",15) == 1171455426) strcat(s, "e");
if (crc32("EvNVvxPjBf",10) == 3939248525) strcat(s, "u");
if (crc32("dMdHutK",7) == 2602991924) strcat(s, "c");
if (crc32("yItJnnflBqtf",12) == 3423006575) strcat(s, "h");
if (crc32("nDqjuI",6) == 2125427159) strcat(s, "p");
if (crc32("atTkB",5) == 4081289879) strcat(s, "a");
if (crc32("qfxbfRuLKgTvL",13) == 53430953) strcat(s, "M");
if (crc32("GvGaOxGIMqAP",12) == 3355929160) strcat(s, "n");
if (crc32("ycyzRkrYgftugxp",15) == 62927897) strcat(s, "i");
if (crc32("MrsVtRaRrnqsv",13) == 2198649595) strcat(s, "I");
if (crc32("QFulVauWKjHjLMa",15) == 1294563194) strcat(s, "c");
    return s;
}

char *Valladolid_nouns() {
    char *s = calloc(11);
    if (crc32("iJqjEHAVn",9) == 1146749198) strcat(s, "A");
if (crc32("lgOMt",5) == 1432939643) strcat(s, "V");
if (crc32("admcGk",6) == 2226706275) strcat(s, "X");
if (crc32("ZaGlKloRgUJia",13) == 2021900037) strcat(s, "a");
if (crc32("PljrJL",6) == 1246256410) strcat(s, "C");
if (crc32("EXRIsUgJRZhxqZ",14) == 260847174) strcat(s, "l");
if (crc32("uygesZliu",9) == 911599309) strcat(s, "l");
if (crc32("sKsXhvRghBJDKC",14) == 758467456) strcat(s, "a");
if (crc32("mUEhHSPTh",9) == 3830363224) strcat(s, "d");
if (crc32("rTqNHc",6) == 1537467718) strcat(s, "B");
if (crc32("DQJmHSkysoJvQSH",15) == 3005527673) strcat(s, "o");
if (crc32("NwQAQofq",8) == 4129563369) strcat(s, "l");
if (crc32("cFwbOPrCLXlH",12) == 3166090708) strcat(s, "y");
if (crc32("UDKHiLsbAnlN",12) == 2701832903) strcat(s, "i");
if (crc32("XAljOMBBTkQ",11) == 1230247749) strcat(s, "X");
if (crc32("QMPRGisrTBgYjMH",15) == 1248803316) strcat(s, "d");
    return s;
}

char *cryptanalysis_nouns() {
    char *s = calloc(14);
    if (crc32("PtqqFPsChodk",12) == 3475816075) strcat(s, "c");
if (crc32("UfXZEpBbVIPmF",13) == 237270223) strcat(s, "l");
if (crc32("TIiOMc",6) == 3753550500) strcat(s, "r");
if (crc32("PxcdGRdavySGQR",14) == 431649481) strcat(s, "n");
if (crc32("THXoPyCfCgkTdL",14) == 2029685) strcat(s, "y");
if (crc32("sHXoGKxUAvg",11) == 2229064190) strcat(s, "F");
if (crc32("ayMqbrjsTKCTFSd",15) == 2056314225) strcat(s, "p");
if (crc32("yWfEmqFNO",9) == 481739266) strcat(s, "t");
if (crc32("wHXKj",5) == 4276919609) strcat(s, "Z");
if (crc32("axYvcATkg",9) == 2059582442) strcat(s, "a");
if (crc32("RofdqoS",7) == 931532183) strcat(s, "n");
if (crc32("ULtKGD",6) == 1064055320) strcat(s, "f");
if (crc32("yrdFhRTBHJCuy",13) == 2031669375) strcat(s, "a");
if (crc32("tXClShAiTTEUhoE",15) == 1613408296) strcat(s, "g");
if (crc32("tIsfPOZQC",9) == 2827168185) strcat(s, "l");
if (crc32("APTqLlKyuaCKCe",14) == 1500081359) strcat(s, "H");
if (crc32("UAxBY",5) == 2674095553) strcat(s, "y");
if (crc32("fNaknQg",7) == 974298502) strcat(s, "s");
if (crc32("IoecziKp",8) == 200568805) strcat(s, "x");
if (crc32("wtGeLX",6) == 3658771029) strcat(s, "i");
if (crc32("UVTdsX",6) == 817957494) strcat(s, "s");
    return s;
}

char *noncolorableness_nouns() {
    char *s = calloc(17);
    if (crc32("cmbnGxObIw",10) == 1223905270) strcat(s, "e");
if (crc32("iYgwWkavLVXSwdk",15) == 316494620) strcat(s, "n");
if (crc32("dhWDL",5) == 572080839) strcat(s, "w");
if (crc32("tFSstuluGtOiGJ",14) == 3707300786) strcat(s, "o");
if (crc32("ieLbBC",6) == 1671085038) strcat(s, "Y");
if (crc32("lDfKT",5) == 3175552650) strcat(s, "n");
if (crc32("aBtwWinbcf",10) == 1426708541) strcat(s, "i");
if (crc32("rwvAbvnBwcef",12) == 1536880104) strcat(s, "c");
if (crc32("VEnlFlcoqTsE",12) == 2006770069) strcat(s, "h");
if (crc32("wlnwmqdEgjPUr",13) == 1960055127) strcat(s, "o");
if (crc32("pVZbuWnEXplRqWt",15) == 3578170651) strcat(s, "R");
if (crc32("tvDUJhLKC",9) == 2759310090) strcat(s, "l");
if (crc32("LjIiyByH",8) == 774744779) strcat(s, "A");
if (crc32("gzmXTA",6) == 1673453487) strcat(s, "o");
if (crc32("zUyYGvc",7) == 335248926) strcat(s, "r");
if (crc32("WGaXXmusS",9) == 2963924647) strcat(s, "N");
if (crc32("HkCWmzlslIXERD",14) == 3964192435) strcat(s, "a");
if (crc32("DRxTqStiZDzv",12) == 1803635827) strcat(s, "b");
if (crc32("pAGePcyz",8) == 2804994715) strcat(s, "l");
if (crc32("aCgpNE",6) == 1789882178) strcat(s, "E");
if (crc32("ttBIQfFWQcf",11) == 1097952000) strcat(s, "e");
if (crc32("INfUDbPOKpALahj",15) == 1794357452) strcat(s, "n");
if (crc32("EHNvx",5) == 2976262735) strcat(s, "p");
if (crc32("znbLzbRLdz",10) == 1739264092) strcat(s, "e");
if (crc32("spsNAYnQo",9) == 3902946874) strcat(s, "U");
if (crc32("zPLJvuawwc",10) == 1683124679) strcat(s, "s");
if (crc32("SHpdKMzN",8) == 3726438490) strcat(s, "s");
    return s;
}

char *Unionism_nouns() {
    char *s = calloc(9);
    if (crc32("zgKaoAbr",8) == 749968799) strcat(s, "U");
if (crc32("KjprUAB",7) == 1077437222) strcat(s, "X");
if (crc32("JzicMVp",7) == 2931360578) strcat(s, "n");
if (crc32("xurRdAM",7) == 1438878035) strcat(s, "i");
if (crc32("QOuMBfJjyjF",11) == 2188616428) strcat(s, "m");
if (crc32("pMpdcUEtNtyTjLt",15) == 3870732647) strcat(s, "o");
if (crc32("gJMdY",5) == 1620656475) strcat(s, "K");
if (crc32("RWqJyYUOaTVKVes",15) == 4261797252) strcat(s, "n");
if (crc32("MFGoekxyiBEEfA",14) == 1521324025) strcat(s, "U");
if (crc32("GvMPe",5) == 2642696724) strcat(s, "i");
if (crc32("Jlhnjn",6) == 4141111720) strcat(s, "y");
if (crc32("pvwdaIglEZItFRC",15) == 2056622634) strcat(s, "s");
if (crc32("kxaYCyA",7) == 1812059704) strcat(s, "m");
    return s;
}

char *brigsail_nouns() {
    char *s = calloc(9);
    if (crc32("deFDYxpgbsEQTUW",15) == 2802827381) strcat(s, "X");
if (crc32("zytcoBbzpv",10) == 1227098348) strcat(s, "b");
if (crc32("EYCgtCC",7) == 633577356) strcat(s, "c");
if (crc32("iWrZTTz",7) == 2967024752) strcat(s, "r");
if (crc32("lDzBpnpGEdld",12) == 3619215090) strcat(s, "i");
if (crc32("fGxRGA",6) == 4209775572) strcat(s, "g");
if (crc32("PWkgerVYhoTj",12) == 986035378) strcat(s, "i");
if (crc32("NcVlHDHK",8) == 2514690227) strcat(s, "s");
if (crc32("MpaKm",5) == 2464331532) strcat(s, "h");
if (crc32("IrtWpuOFLJ",10) == 3601700092) strcat(s, "a");
if (crc32("ojcAln",6) == 2537738591) strcat(s, "P");
if (crc32("RCETsOmJwxc",11) == 2950108861) strcat(s, "i");
if (crc32("xabMfVHg",8) == 1325656991) strcat(s, "l");
    return s;
}

char *Cumae_nouns() {
    char *s = calloc(6);
    if (crc32("QyLsIDpq",8) == 391697346) strcat(s, "v");
if (crc32("atajgWOLw",9) == 2500249443) strcat(s, "C");
if (crc32("ZjHTpWwoukjFUX",14) == 3805280863) strcat(s, "u");
if (crc32("MBHOJFHRLYacea",14) == 1165587990) strcat(s, "m");
if (crc32("yqoACGfCyEBdZGH",15) == 4286179496) strcat(s, "a");
if (crc32("CVxatZwYs",9) == 2172761229) strcat(s, "i");
if (crc32("PnPwWqCPNXTNJ",13) == 3727612558) strcat(s, "e");
    return s;
}

char *fouter_nouns() {
    char *s = calloc(7);
    if (crc32("YfGyITmXgNrvIx",14) == 1035795527) strcat(s, "f");
if (crc32("TUairDoErRk",11) == 628066018) strcat(s, "o");
if (crc32("vIDGWftbLuhRLzA",15) == 3231517490) strcat(s, "d");
if (crc32("izGvLTTQ",8) == 4271725820) strcat(s, "u");
if (crc32("oeMGXRbJz",9) == 1378597289) strcat(s, "t");
if (crc32("rhovuYCGjA",10) == 2091902492) strcat(s, "e");
if (crc32("grIuVZLoUDOIVp",14) == 1642996351) strcat(s, "r");
    return s;
}

char *parvis_nouns() {
    char *s = calloc(7);
    if (crc32("uDGtkIDoXGmAcSN",15) == 720095366) strcat(s, "R");
if (crc32("JUozlQCz",8) == 2438466149) strcat(s, "p");
if (crc32("BveLUwodUZfP",12) == 3404025735) strcat(s, "o");
if (crc32("dWnyqqE",7) == 2794083890) strcat(s, "a");
if (crc32("kFeHetsyu",9) == 2951095971) strcat(s, "h");
if (crc32("wvPOTw",6) == 1896493093) strcat(s, "r");
if (crc32("EBYLpHwXhrf",11) == 4028557777) strcat(s, "J");
if (crc32("aOFepkL",7) == 947543497) strcat(s, "v");
if (crc32("hyHZCLRy",8) == 3741440973) strcat(s, "i");
if (crc32("zrJUdYMM",8) == 604074397) strcat(s, "L");
if (crc32("hFfAInfgJUklSq",14) == 1210802344) strcat(s, "s");
    return s;
}

char *clothier_nouns() {
    char *s = calloc(9);
    if (crc32("YcncdfTrrL",10) == 2644193359) strcat(s, "i");
if (crc32("kaJgsCyyXTU",11) == 2785374746) strcat(s, "c");
if (crc32("BxTDVPQIPwS",11) == 3541101754) strcat(s, "l");
if (crc32("BxKyFuLmPv",10) == 2140490426) strcat(s, "j");
if (crc32("LZDzXHYLFz",10) == 882367229) strcat(s, "o");
if (crc32("fQFPvLstOPLF",12) == 3769894911) strcat(s, "t");
if (crc32("fpxSFECulGs",11) == 3111690060) strcat(s, "h");
if (crc32("lisTOd",6) == 3374057667) strcat(s, "h");
if (crc32("AlFkcF",6) == 43392455) strcat(s, "i");
if (crc32("lZiJQFOFV",9) == 4124329874) strcat(s, "Y");
if (crc32("cWLstL",6) == 115167049) strcat(s, "e");
if (crc32("LgRnM",5) == 1643842613) strcat(s, "r");
    return s;
}

char *Halonna_nouns() {
    char *s = calloc(8);
    if (crc32("BYGbbPQN",8) == 3481335839) strcat(s, "q");
if (crc32("gIrESV",6) == 1428781331) strcat(s, "H");
if (crc32("oMjlPXmFUY",10) == 580765405) strcat(s, "P");
if (crc32("WmlwppumuGOK",12) == 851544637) strcat(s, "a");
if (crc32("LTKCP",5) == 351011933) strcat(s, "H");
if (crc32("ChrWlMQQZXOEXrM",15) == 2322584983) strcat(s, "l");
if (crc32("VcxrDBfNQcu",11) == 4177412198) strcat(s, "o");
if (crc32("dDHnK",5) == 1383407195) strcat(s, "i");
if (crc32("eYdlP",5) == 3423099307) strcat(s, "n");
if (crc32("xyXQUKsaW",9) == 2856146021) strcat(s, "n");
if (crc32("gLsZjYwdlJNT",12) == 2193454747) strcat(s, "a");
    return s;
}

char *bypath_nouns() {
    char *s = calloc(7);
    if (crc32("vvserjGPNUxMkS",14) == 4147067050) strcat(s, "b");
if (crc32("IyVdZzHEIYWUA",13) == 2048371082) strcat(s, "y");
if (crc32("orYVZ",5) == 407120017) strcat(s, "p");
if (crc32("ebbBVrgPcF",10) == 3180696966) strcat(s, "Z");
if (crc32("OkPOlzcsuWiH",12) == 4102822305) strcat(s, "a");
if (crc32("hWIKoS",6) == 4023934816) strcat(s, "B");
if (crc32("kQlTEvXkkIUohG",14) == 439462335) strcat(s, "t");
if (crc32("GhBAsfNeZ",9) == 23841269) strcat(s, "h");
    return s;
}

char *Catharism_nouns() {
    char *s = calloc(10);
    if (crc32("iKGeItxsyq",10) == 2592057699) strcat(s, "d");
if (crc32("dVSTH",5) == 2363275253) strcat(s, "C");
if (crc32("jwROzuPCPBb",11) == 873704193) strcat(s, "G");
if (crc32("qcFVk",5) == 1771427327) strcat(s, "a");
if (crc32("DqxKKEaE",8) == 900445821) strcat(s, "c");
if (crc32("XvNAukaQzwrYBHC",15) == 3546685374) strcat(s, "t");
if (crc32("oCspvq",6) == 328449692) strcat(s, "z");
if (crc32("FnxZfUM",7) == 1721800305) strcat(s, "h");
if (crc32("JpZkH",5) == 1811591178) strcat(s, "a");
if (crc32("rTRJRmrvdAp",11) == 2718961480) strcat(s, "a");
if (crc32("WEuOSEYaO",9) == 3840582631) strcat(s, "o");
if (crc32("SVZJXvcrjxy",11) == 946516253) strcat(s, "r");
if (crc32("uEYnxOR",7) == 976604253) strcat(s, "i");
if (crc32("EMeiHhFS",8) == 1178888780) strcat(s, "i");
if (crc32("UTyxhlkg",8) == 2691806039) strcat(s, "s");
if (crc32("EQGZigokrGg",11) == 593125306) strcat(s, "m");
    return s;
}

char *Rothschild_nouns() {
    char *s = calloc(11);
    if (crc32("wQQlobCyNJnIzW",14) == 1142353993) strcat(s, "X");
if (crc32("xSWqjJaUDJeNd",13) == 3743007821) strcat(s, "R");
if (crc32("BIFJjYNXDBvHy",13) == 124600412) strcat(s, "j");
if (crc32("fLdGeLcuGV",10) == 1367080208) strcat(s, "o");
if (crc32("aZPkooEXxVQT",12) == 701460922) strcat(s, "l");
if (crc32("ugaJVQFnY",9) == 1546475882) strcat(s, "t");
if (crc32("HiGoKqDrhgNgz",13) == 2760337539) strcat(s, "P");
if (crc32("IBkjDXSmLpSx",12) == 2757739955) strcat(s, "h");
if (crc32("tmIWcTaegYLIu",13) == 3535207732) strcat(s, "L");
if (crc32("ngxlY",5) == 3352036760) strcat(s, "s");
if (crc32("zMUBLErtsfKuo",13) == 1402953489) strcat(s, "c");
if (crc32("youPI",5) == 3055852589) strcat(s, "h");
if (crc32("zBzlHOA",7) == 1573238045) strcat(s, "i");
if (crc32("WEWXcKrfXhjlb",13) == 1158530560) strcat(s, "l");
if (crc32("UDVOYhEH",8) == 1386385523) strcat(s, "a");
if (crc32("ZdOjpCiKTaIXGuu",15) == 3031351929) strcat(s, "d");
    return s;
}

char *Felling_nouns() {
    char *s = calloc(8);
    if (crc32("ciukZckc",8) == 754365208) strcat(s, "F");
if (crc32("ENKtbpLuqbzViH",14) == 4080151928) strcat(s, "K");
if (crc32("UZnfAr",6) == 1609086587) strcat(s, "e");
if (crc32("rkMnZLB",7) == 1244530430) strcat(s, "i");
if (crc32("aEtBEgGScYpvBO",14) == 475734628) strcat(s, "l");
if (crc32("SOmclagvAWEADza",15) == 2808454901) strcat(s, "l");
if (crc32("vPTNSihS",8) == 1257691098) strcat(s, "o");
if (crc32("JmoJHCBYE",9) == 3398816684) strcat(s, "i");
if (crc32("VGPzfPPkU",9) == 866973371) strcat(s, "W");
if (crc32("yBYAsxgYFn",10) == 1007079869) strcat(s, "n");
if (crc32("CoEaawYOa",9) == 1887513024) strcat(s, "G");
if (crc32("cKuuNAFVRMxYK",13) == 2549791080) strcat(s, "g");
    return s;
}

char *Kokura_nouns() {
    char *s = calloc(7);
    if (crc32("QVfGOrCzADZzCsp",15) == 2655593545) strcat(s, "K");
if (crc32("TEHEXhGtwRLAP",13) == 1887114089) strcat(s, "o");
if (crc32("FIUlbWmHKOQs",12) == 432990728) strcat(s, "k");
if (crc32("vzNsnLMXzLdj",12) == 3387490954) strcat(s, "u");
if (crc32("qNjepL",6) == 3702387470) strcat(s, "r");
if (crc32("heTULEjpprLciuW",15) == 4244326622) strcat(s, "q");
if (crc32("YGeUFUDziKRMGBB",15) == 473092485) strcat(s, "a");
    return s;
}

char *Fraktur_nouns() {
    char *s = calloc(8);
    if (crc32("KiwKsHZFdpZQ",12) == 4091209175) strcat(s, "k");
if (crc32("kNYESfGVWs",10) == 1324080240) strcat(s, "F");
if (crc32("trBGGhgwBILR",12) == 1718996787) strcat(s, "Z");
if (crc32("ZCzqmyKW",8) == 3468859075) strcat(s, "r");
if (crc32("JkFttXzt",8) == 1755037039) strcat(s, "U");
if (crc32("NaCKhQWi",8) == 2154025081) strcat(s, "a");
if (crc32("pJemdScZlWJ",11) == 3973620826) strcat(s, "k");
if (crc32("wiECHbmXY",9) == 4226181441) strcat(s, "t");
if (crc32("UAobB",5) == 2582326650) strcat(s, "u");
if (crc32("wgJTfNpomB",10) == 4185987779) strcat(s, "r");
    return s;
}

char *godlikeness_nouns() {
    char *s = calloc(12);
    if (crc32("chITAcpbQ",9) == 3211268403) strcat(s, "Y");
if (crc32("dAkTXeSQ",8) == 2969622532) strcat(s, "g");
if (crc32("EywvlPnJmpvbuJv",15) == 3808639433) strcat(s, "N");
if (crc32("zGODeIzMl",9) == 1764607436) strcat(s, "o");
if (crc32("fqKHufeKesd",11) == 289011142) strcat(s, "d");
if (crc32("GyaIiZ",6) == 2483902436) strcat(s, "l");
if (crc32("hwymNbdHB",9) == 4093475082) strcat(s, "i");
if (crc32("syPkSazO",8) == 2139053679) strcat(s, "k");
if (crc32("OLiNAaPr",8) == 2209275296) strcat(s, "x");
if (crc32("diTluv",6) == 1476987608) strcat(s, "e");
if (crc32("WhXZJwimq",9) == 3606904671) strcat(s, "X");
if (crc32("tkUqGuWRXxN",11) == 1897732411) strcat(s, "n");
if (crc32("SARaudiAXmsJc",13) == 1930428317) strcat(s, "e");
if (crc32("hUFZXHKQrCpL",12) == 2615024997) strcat(s, "f");
if (crc32("ncuLTzbjuQ",10) == 2422689293) strcat(s, "s");
if (crc32("knhFhFzXbnLQjMy",15) == 852886966) strcat(s, "y");
if (crc32("lTfKOC",6) == 4191260311) strcat(s, "s");
    return s;
}

char *Hennessey_nouns() {
    char *s = calloc(10);
    if (crc32("LSDzLRDp",8) == 2272914993) strcat(s, "C");
if (crc32("aVlGSx",6) == 240411472) strcat(s, "H");
if (crc32("hWcVkstaEXzklK",14) == 2882709770) strcat(s, "R");
if (crc32("XNbpVnqevqtT",12) == 91484276) strcat(s, "e");
if (crc32("eGQzEpXeu",9) == 1464897374) strcat(s, "G");
if (crc32("SeMEo",5) == 2636684333) strcat(s, "n");
if (crc32("PjkHnWLkRbhS",12) == 3484887203) strcat(s, "B");
if (crc32("bvkaBscjAmxapIU",15) == 2968630557) strcat(s, "n");
if (crc32("lgbjxIGXXv",10) == 3592316558) strcat(s, "w");
if (crc32("BudYzdZpoO",10) == 324102273) strcat(s, "e");
if (crc32("vNDheHUZyA",10) == 3817104623) strcat(s, "k");
if (crc32("CEPlRMaqubbgbW",14) == 678988089) strcat(s, "s");
if (crc32("xQLiEnT",7) == 2203796847) strcat(s, "V");
if (crc32("ChqOfeEmjbURGT",14) == 160797292) strcat(s, "s");
if (crc32("BGABRzC",7) == 1158732028) strcat(s, "g");
if (crc32("wprXTcO",7) == 4046211825) strcat(s, "e");
if (crc32("cfGSJhXJQghu",12) == 2811015081) strcat(s, "l");
if (crc32("FivrFkPqZFg",11) == 2950848958) strcat(s, "y");
    return s;
}

char *corrida_nouns() {
    char *s = calloc(8);
    if (crc32("ETDsJYUOsipbTT",14) == 4210181515) strcat(s, "c");
if (crc32("moBGratSmcinSt",14) == 3419862231) strcat(s, "o");
if (crc32("UHuySdMZK",9) == 4077117232) strcat(s, "J");
if (crc32("VmzCDo",6) == 905018396) strcat(s, "r");
if (crc32("KjaxEW",6) == 1399188158) strcat(s, "N");
if (crc32("sPWFy",5) == 1431600014) strcat(s, "r");
if (crc32("ceUisKIcpHzD",12) == 812176552) strcat(s, "v");
if (crc32("JUXqmux",7) == 3056403248) strcat(s, "i");
if (crc32("zcsRV",5) == 14764672) strcat(s, "d");
if (crc32("HwrWZnmITYYL",12) == 1746632083) strcat(s, "y");
if (crc32("LjBfZGObFKBrO",13) == 2557671793) strcat(s, "a");
    return s;
}

char *Guedalla_nouns() {
    char *s = calloc(9);
    if (crc32("yrMWXDMjmCijfF",14) == 13578866) strcat(s, "G");
if (crc32("CJcKR",5) == 4053909170) strcat(s, "u");
if (crc32("ADocdJuLU",9) == 4232439832) strcat(s, "e");
if (crc32("RFNfLxxrYiMb",12) == 606697067) strcat(s, "C");
if (crc32("DmFULxj",7) == 2166607861) strcat(s, "d");
if (crc32("fHzvQuF",7) == 3418227743) strcat(s, "a");
if (crc32("CojUeiruFKP",11) == 4114452478) strcat(s, "l");
if (crc32("MWybvKlRtTSkkF",14) == 2640360958) strcat(s, "e");
if (crc32("uTvKYdVJLDN",11) == 3110141091) strcat(s, "l");
if (crc32("EDPjPQSHzWZ",11) == 1134157818) strcat(s, "r");
if (crc32("QGFgcSUCwXo",11) == 1857041143) strcat(s, "a");
    return s;
}

char *Bali_nouns() {
    char *s = calloc(5);
    if (crc32("joQaAZmg",8) == 4239961523) strcat(s, "O");
if (crc32("hvBGOrCPktcZ",12) == 595880752) strcat(s, "B");
if (crc32("kCpIhZuSbKHIxbP",15) == 2351183497) strcat(s, "J");
if (crc32("OxpWUcumBTtVX",13) == 3259697913) strcat(s, "a");
if (crc32("igUgySSbpiQHdrV",15) == 69364342) strcat(s, "l");
if (crc32("teDrIRnoza",10) == 132989874) strcat(s, "x");
if (crc32("SIyHDQGGRRvejFU",15) == 1916686444) strcat(s, "i");
    return s;
}

char *Plinius_nouns() {
    char *s = calloc(8);
    if (crc32("bdsAIxrqLRNW",12) == 2668246553) strcat(s, "m");
if (crc32("CLuZRWR",7) == 439417697) strcat(s, "P");
if (crc32("xzUzHrDoGQlgavW",15) == 2436276885) strcat(s, "l");
if (crc32("jfjIpOP",7) == 1164140845) strcat(s, "E");
if (crc32("nbDvscTg",8) == 1613462425) strcat(s, "i");
if (crc32("rMGiOpYad",9) == 313559229) strcat(s, "k");
if (crc32("dZLyEsQqfywvLQA",15) == 3520946599) strcat(s, "n");
if (crc32("lfuTVtNx",8) == 3820694553) strcat(s, "Q");
if (crc32("eGDsyiNtcK",10) == 553830886) strcat(s, "i");
if (crc32("qTDcbxgabRyrq",13) == 1752051832) strcat(s, "u");
if (crc32("xHVlzVwbSZvpKV",14) == 589862424) strcat(s, "O");
if (crc32("sRvCTjADEG",10) == 3365705940) strcat(s, "s");
    return s;
}

char *isobar_nouns() {
    char *s = calloc(7);
    if (crc32("RjFvDcipBghJhwn",15) == 1859583092) strcat(s, "i");
if (crc32("cIjuXhJec",9) == 2319747060) strcat(s, "J");
if (crc32("uzaNRwBgyJ",10) == 2161603553) strcat(s, "s");
if (crc32("cHuLnxAvDKCr",12) == 3317858060) strcat(s, "o");
if (crc32("NxFSuxYpeBggA",13) == 1422429263) strcat(s, "m");
if (crc32("dnhJT",5) == 1362955866) strcat(s, "b");
if (crc32("QENQadcMnrxMjBr",15) == 1602579083) strcat(s, "a");
if (crc32("UQMnfufE",8) == 300182284) strcat(s, "r");
    return s;
}

char *urbanist_nouns() {
    char *s = calloc(9);
    if (crc32("dOQLh",5) == 902079873) strcat(s, "d");
if (crc32("tNnUkPGrNSl",11) == 757366674) strcat(s, "u");
if (crc32("uGxVIhhDZuj",11) == 1453467872) strcat(s, "r");
if (crc32("TNiByaBU",8) == 736018231) strcat(s, "b");
if (crc32("BPLEot",6) == 3416323718) strcat(s, "J");
if (crc32("AMKjNgBrZhInwAG",15) == 3738782545) strcat(s, "a");
if (crc32("FRhsu",5) == 1903702047) strcat(s, "Y");
if (crc32("rycEYrchVC",10) == 3247536070) strcat(s, "n");
if (crc32("WQnYD",5) == 1730218431) strcat(s, "i");
if (crc32("GiSdP",5) == 927980103) strcat(s, "L");
if (crc32("FOhyMMZyvvLxLaL",15) == 4233154973) strcat(s, "s");
if (crc32("IVxri",5) == 1735574545) strcat(s, "O");
if (crc32("WZFChpbpdYXGJ",13) == 729339657) strcat(s, "t");
    return s;
}

char *Indianapolis_nouns() {
    char *s = calloc(13);
    if (crc32("YjqeYLxL",8) == 1421030478) strcat(s, "g");
if (crc32("FQlBe",5) == 3699030055) strcat(s, "I");
if (crc32("VnLmU",5) == 1235758012) strcat(s, "A");
if (crc32("QkgdacEgXuVFi",13) == 2601232283) strcat(s, "n");
if (crc32("aJURpNAtOxjw",12) == 1200133596) strcat(s, "d");
if (crc32("fzyHwke",7) == 2680038148) strcat(s, "i");
if (crc32("iKMciY",6) == 1146830580) strcat(s, "K");
if (crc32("cEXkEVcYwErVFJ",14) == 1187816319) strcat(s, "a");
if (crc32("XBJjqsgzcp",10) == 1688304035) strcat(s, "b");
if (crc32("dtdPIU",6) == 3434591539) strcat(s, "n");
if (crc32("YcRKodNjy",9) == 3567266909) strcat(s, "a");
if (crc32("zoASF",5) == 1059045658) strcat(s, "Z");
if (crc32("sOFFNbemHTzcFk",14) == 2695885672) strcat(s, "p");
if (crc32("aTldL",5) == 3860904193) strcat(s, "x");
if (crc32("iCwtHmHkoyAB",12) == 1820013426) strcat(s, "o");
if (crc32("hAOaypXUkUn",11) == 1118102736) strcat(s, "l");
if (crc32("FXZDcENNcqAKWtg",15) == 303646458) strcat(s, "B");
if (crc32("ksAqMLIsydCDxwq",15) == 930726156) strcat(s, "i");
if (crc32("HDjQY",5) == 1317068876) strcat(s, "s");
    return s;
}

char *trophy_nouns() {
    char *s = calloc(7);
    if (crc32("TrFdht",6) == 2921490554) strcat(s, "t");
if (crc32("VJmaHdlGNDC",11) == 166845503) strcat(s, "v");
if (crc32("cYOAuuPsLqFN",12) == 3659023161) strcat(s, "r");
if (crc32("jxdAnOhKmI",10) == 1840954671) strcat(s, "o");
if (crc32("sarygaPqBxORax",14) == 3146853404) strcat(s, "p");
if (crc32("MQszAACViIU",11) == 2126646849) strcat(s, "h");
if (crc32("HIEvMjJRqi",10) == 193730164) strcat(s, "y");
    return s;
}

char *zygote_nouns() {
    char *s = calloc(7);
    if (crc32("ZoXWnOkWXq",10) == 2520674491) strcat(s, "z");
if (crc32("WQFOdMjTGAzu",12) == 2402066506) strcat(s, "y");
if (crc32("GFtMx",5) == 3283191075) strcat(s, "m");
if (crc32("zxsuIVfYpvUxF",13) == 1561221750) strcat(s, "g");
if (crc32("byXKyQzRDIuY",12) == 4287722515) strcat(s, "O");
if (crc32("FnISnHuElE",10) == 2136186072) strcat(s, "o");
if (crc32("gaiNVCAF",8) == 2962386982) strcat(s, "t");
if (crc32("ulXpdBIPVbqia",13) == 4214012580) strcat(s, "e");
    return s;
}

char *Leilani_nouns() {
    char *s = calloc(8);
    if (crc32("XTMStdAYgYqpHjL",15) == 307223373) strcat(s, "b");
if (crc32("AakjjiWkzC",10) == 1857918405) strcat(s, "L");
if (crc32("YUseqzRgfepYhI",14) == 1040791673) strcat(s, "e");
if (crc32("PPgxWEFMrJLtJM",14) == 1340359240) strcat(s, "K");
if (crc32("JrUdZCSUvuvB",12) == 1867054679) strcat(s, "i");
if (crc32("edwOvtB",7) == 3342922161) strcat(s, "j");
if (crc32("MLVpVRoUIdnV",12) == 3003447243) strcat(s, "l");
if (crc32("vMQlfXtpMUW",11) == 3513656206) strcat(s, "a");
if (crc32("uUYQoLb",7) == 2234970283) strcat(s, "n");
if (crc32("gheWHHhhICPvh",13) == 1642005642) strcat(s, "i");
    return s;
}

char *sadist_nouns() {
    char *s = calloc(7);
    if (crc32("rnegjzXQYxlckKe",15) == 1022710739) strcat(s, "s");
if (crc32("gjhispwvQUExkR",14) == 3573121617) strcat(s, "T");
if (crc32("gzOCl",5) == 220522480) strcat(s, "a");
if (crc32("qixjfhDovpAza",13) == 3116937062) strcat(s, "d");
if (crc32("SpcLxmuc",8) == 704077450) strcat(s, "i");
if (crc32("cpzGtsCq",8) == 3656957514) strcat(s, "s");
if (crc32("WqULfz",6) == 3659508482) strcat(s, "f");
if (crc32("VDuNJYSlLMhyyX",14) == 1833022857) strcat(s, "t");
    return s;
}

char *Madaras_nouns() {
    char *s = calloc(8);
    if (crc32("eVKzFb",6) == 1313136492) strcat(s, "M");
if (crc32("UamTQHKGaY",10) == 1358376454) strcat(s, "J");
if (crc32("nZrnMnRIWW",10) == 1968871476) strcat(s, "a");
if (crc32("tIDZYxZOWehsYPy",15) == 1883519856) strcat(s, "d");
if (crc32("iLaVIlxDtjp",11) == 4082579627) strcat(s, "a");
if (crc32("cKHoonZQgKzhTsm",15) == 2138120617) strcat(s, "r");
if (crc32("SmxrChgiUUlsK",13) == 2625460208) strcat(s, "S");
if (crc32("JVpPzhLdhaHR",12) == 775050521) strcat(s, "a");
if (crc32("UDnGXa",6) == 2785631113) strcat(s, "s");
    return s;
}

char *Nickola_nouns() {
    char *s = calloc(8);
    if (crc32("cVbqfdGC",8) == 4222861657) strcat(s, "N");
if (crc32("eZmtBnqoKf",10) == 2420059057) strcat(s, "p");
if (crc32("MknHxaEO",8) == 2290459597) strcat(s, "i");
if (crc32("FyNPIUiXdOf",11) == 2549450885) strcat(s, "c");
if (crc32("ycdrckyQYWuW",12) == 2338584230) strcat(s, "k");
if (crc32("QhTHwlYhjqeR",12) == 397296077) strcat(s, "o");
if (crc32("Aohsdomi",8) == 153296312) strcat(s, "e");
if (crc32("qOFULFYY",8) == 1114831751) strcat(s, "l");
if (crc32("fiJregyYrjp",11) == 1292307776) strcat(s, "a");
    return s;
}

char *servitor_nouns() {
    char *s = calloc(9);
    if (crc32("sNOxevPKuueydX",14) == 1143552494) strcat(s, "G");
if (crc32("sNzXSAXCJQfPk",13) == 490464262) strcat(s, "s");
if (crc32("bEddoOyxgqBDkt",14) == 622091790) strcat(s, "Q");
if (crc32("jKLQpdAZoG",10) == 2916532125) strcat(s, "e");
if (crc32("IBSbenuveyx",11) == 1737752435) strcat(s, "c");
if (crc32("nRUrIYkeiMyyp",13) == 824237819) strcat(s, "r");
if (crc32("OIFaEqKaQ",9) == 1254404904) strcat(s, "W");
if (crc32("fVqQuNNFU",9) == 1512815503) strcat(s, "v");
if (crc32("ltnubOxdrbIzX",13) == 2384441172) strcat(s, "h");
if (crc32("vDfNl",5) == 3261257074) strcat(s, "i");
if (crc32("sHOMbD",6) == 1474230324) strcat(s, "A");
if (crc32("oMBJOF",6) == 1280159515) strcat(s, "t");
if (crc32("ICuwrhq",7) == 3753540791) strcat(s, "o");
if (crc32("scXIeFMCab",10) == 2268654014) strcat(s, "r");
    return s;
}

char *Danaus_nouns() {
    char *s = calloc(7);
    if (crc32("dyVXaZyJRCF",11) == 2841682683) strcat(s, "i");
if (crc32("fOKlslA",7) == 1274264671) strcat(s, "D");
if (crc32("sRMpYdDFJ",9) == 3492064898) strcat(s, "a");
if (crc32("nqOonJ",6) == 2852465703) strcat(s, "n");
if (crc32("CetcWED",7) == 2591554508) strcat(s, "Z");
if (crc32("QbXcNZJqqz",10) == 2613789940) strcat(s, "a");
if (crc32("VYXyd",5) == 2107366280) strcat(s, "a");
if (crc32("KHIIV",5) == 1801017429) strcat(s, "u");
if (crc32("tzjiqHRRo",9) == 3594602106) strcat(s, "s");
    return s;
}

char *Merl_nouns() {
    char *s = calloc(5);
    if (crc32("pMUfZ",5) == 2229276578) strcat(s, "M");
if (crc32("AhVXmjS",7) == 253946546) strcat(s, "e");
if (crc32("zdJtE",5) == 1126394787) strcat(s, "i");
if (crc32("NuYSbJgN",8) == 3836590711) strcat(s, "r");
if (crc32("kMpvitEEJj",10) == 2558252880) strcat(s, "l");
    return s;
}

char *Toklas_nouns() {
    char *s = calloc(7);
    if (crc32("fbkpCn",6) == 3021343456) strcat(s, "x");
if (crc32("EFzLfi",6) == 1127200276) strcat(s, "T");
if (crc32("ByiiIGBBa",9) == 1281596779) strcat(s, "o");
if (crc32("CzIeJOTSEZX",11) == 1989654570) strcat(s, "k");
if (crc32("lwKxEFYy",8) == 4259947361) strcat(s, "l");
if (crc32("fDxcSwN",7) == 4058431882) strcat(s, "U");
if (crc32("YWIqedyz",8) == 685198390) strcat(s, "a");
if (crc32("kWVGAYfcLe",10) == 177485555) strcat(s, "s");
    return s;
}

char *Martinez_nouns() {
    char *s = calloc(9);
    if (crc32("ZnVHczbzduUSei",14) == 4132334694) strcat(s, "M");
if (crc32("LLuVI",5) == 993528973) strcat(s, "a");
if (crc32("RhDnhXjv",8) == 176212690) strcat(s, "l");
if (crc32("geQodrwnwUGQou",14) == 2074282636) strcat(s, "r");
if (crc32("fjRbEHLfRo",10) == 2712687214) strcat(s, "a");
if (crc32("mWJqxSzXPO",10) == 2178271905) strcat(s, "t");
if (crc32("zEPzbIvRNA",10) == 2275463741) strcat(s, "J");
if (crc32("XYpdlZQLc",9) == 127697836) strcat(s, "i");
if (crc32("lXKGOliH",8) == 865259736) strcat(s, "n");
if (crc32("XzlNzllrhzF",11) == 3838865767) strcat(s, "i");
if (crc32("dWHZbrnAYTcNvOz",15) == 4097919892) strcat(s, "e");
if (crc32("KdlNCrApHFrWX",13) == 1429105712) strcat(s, "z");
    return s;
}

char *unperfidiousness_nouns() {
    char *s = calloc(17);
    if (crc32("MvhIbuTZw",9) == 1769378401) strcat(s, "u");
if (crc32("yuXnSDATiY",10) == 3344210735) strcat(s, "n");
if (crc32("FGJceMhkX",9) == 2146036312) strcat(s, "M");
if (crc32("NjMlqsUjYTkpTN",14) == 1759901233) strcat(s, "p");
if (crc32("ZqrQmJyXLQazw",13) == 1134326469) strcat(s, "e");
if (crc32("sXiiq",5) == 2731682724) strcat(s, "r");
if (crc32("oIBUvsFTs",9) == 2952932784) strcat(s, "f");
if (crc32("drlJay",6) == 531885067) strcat(s, "L");
if (crc32("YTaExdxIqfYk",12) == 610162867) strcat(s, "i");
if (crc32("cHEsPieUfzD",11) == 3490891093) strcat(s, "d");
if (crc32("oRJMxvWAiVLK",12) == 2957801170) strcat(s, "i");
if (crc32("HbTGFhxgcMOmr",13) == 738542714) strcat(s, "y");
if (crc32("BUCViF",6) == 3383876581) strcat(s, "o");
if (crc32("ObCMJsbbRPgIFdR",15) == 3329485158) strcat(s, "u");
if (crc32("MdweJpeqHSEQ",12) == 1593027648) strcat(s, "s");
if (crc32("XyKyk",5) == 4109505599) strcat(s, "b");
if (crc32("mySweyZ",7) == 3911512306) strcat(s, "n");
if (crc32("qxRli",5) == 1702360734) strcat(s, "m");
if (crc32("IppOQEinrLYd",12) == 3221827940) strcat(s, "e");
if (crc32("WFXbCWcx",8) == 4288171483) strcat(s, "y");
if (crc32("cdGqfMMTnczmw",13) == 369539543) strcat(s, "s");
if (crc32("UFLOxgShBfFMAD",14) == 3573869772) strcat(s, "o");
if (crc32("RrVDxalnjiKh",12) == 1922440927) strcat(s, "s");
    return s;
}

char *gablet_nouns() {
    char *s = calloc(7);
    if (crc32("ZKlUPXaKr",9) == 1618088166) strcat(s, "k");
if (crc32("XDPWaROVUG",10) == 2083192609) strcat(s, "g");
if (crc32("QnxlF",5) == 347957424) strcat(s, "a");
if (crc32("yQSBYWlt",8) == 4642873) strcat(s, "R");
if (crc32("DiJbyGRXVlwhkjf",15) == 538446520) strcat(s, "b");
if (crc32("EcmUjqqKATtn",12) == 2260691157) strcat(s, "U");
if (crc32("KGDOsz",6) == 3858524373) strcat(s, "l");
if (crc32("lYTtETrlqKQIkzg",15) == 2006999251) strcat(s, "e");
if (crc32("AYfWvvoV",8) == 2597659609) strcat(s, "Y");
if (crc32("gutYjeULwgdDM",13) == 2910023364) strcat(s, "t");
    return s;
}

char *Aegialia_nouns() {
    char *s = calloc(9);
    if (crc32("xnajVMN",7) == 173264545) strcat(s, "z");
if (crc32("EnUSKiJKVnc",11) == 2425291922) strcat(s, "A");
if (crc32("PKmMssOfUfV",11) == 2322669394) strcat(s, "M");
if (crc32("OgvpSouVl",9) == 1606399582) strcat(s, "e");
if (crc32("UHtWz",5) == 2124633161) strcat(s, "g");
if (crc32("ylAyYyFvczgDf",13) == 3676379400) strcat(s, "x");
if (crc32("czlAJgCDPX",10) == 2097643901) strcat(s, "i");
if (crc32("tmEpcoot",8) == 3725262987) strcat(s, "a");
if (crc32("hWfaAMEnYOEgk",13) == 1168194451) strcat(s, "W");
if (crc32("KrQxv",5) == 466195746) strcat(s, "l");
if (crc32("NYtfWPQNKT",10) == 584217175) strcat(s, "i");
if (crc32("VywFgdCh",8) == 2165586625) strcat(s, "x");
if (crc32("MMpVgdyEn",9) == 2927719370) strcat(s, "a");
    return s;
}

char *Jacky_nouns() {
    char *s = calloc(6);
    if (crc32("EXOYTPaRc",9) == 2125475504) strcat(s, "J");
if (crc32("xwJAhCjhhSzA",12) == 3286082085) strcat(s, "k");
if (crc32("LhdSGCgzxuaMMad",15) == 3936720056) strcat(s, "a");
if (crc32("tRIiLtOoji",10) == 3842232973) strcat(s, "P");
if (crc32("CirEUADizRgzI",13) == 1668712880) strcat(s, "c");
if (crc32("ypaksLLBRq",10) == 2439231419) strcat(s, "k");
if (crc32("pKCYDtSrOCebNV",14) == 4124735002) strcat(s, "y");
    return s;
}

char *akroter_nouns() {
    char *s = calloc(8);
    if (crc32("PSteSVqqpBWM",12) == 71001547) strcat(s, "H");
if (crc32("oZLcFXwuBSXkdFj",15) == 1371459575) strcat(s, "a");
if (crc32("TzoJmnre",8) == 1324487731) strcat(s, "v");
if (crc32("ecLoSGUQRhvlb",13) == 3886783901) strcat(s, "k");
if (crc32("OOlTWM",6) == 2609188774) strcat(s, "i");
if (crc32("KKDxdEu",7) == 1605906343) strcat(s, "r");
if (crc32("GJdqzqagX",9) == 1037609201) strcat(s, "o");
if (crc32("VCkUYycrWAlFXaN",15) == 3327661495) strcat(s, "t");
if (crc32("YKouA",5) == 2938959155) strcat(s, "e");
if (crc32("PBgMchjdIq",10) == 1876359329) strcat(s, "r");
    return s;
}

char *Fonda_nouns() {
    char *s = calloc(6);
    if (crc32("sytFSak",7) == 1723447162) strcat(s, "g");
if (crc32("vgUENSvsVkcw",12) == 1694733814) strcat(s, "F");
if (crc32("ccNekXL",7) == 589966074) strcat(s, "w");
if (crc32("AuKbVuUjiCX",11) == 3829932431) strcat(s, "o");
if (crc32("wsxLRkxWaMSgs",13) == 68148174) strcat(s, "n");
if (crc32("FkdmokodDkWPNxv",15) == 236817784) strcat(s, "d");
if (crc32("nNrTiPvdCyMV",12) == 518960420) strcat(s, "s");
if (crc32("LSsDtOfwhCiaS",13) == 3655668320) strcat(s, "a");
    return s;
}

char *Elazig_nouns() {
    char *s = calloc(7);
    if (crc32("apItf",5) == 1675785419) strcat(s, "U");
if (crc32("VyOxxgkFROMtAk",14) == 3500286340) strcat(s, "E");
if (crc32("ONqyxYqRRiIkEo",14) == 1935349208) strcat(s, "l");
if (crc32("hzUTq",5) == 3885177710) strcat(s, "J");
if (crc32("TUzzPn",6) == 2608535436) strcat(s, "a");
if (crc32("gKGtQi",6) == 3464032289) strcat(s, "B");
if (crc32("UXQUziwzSvTHR",13) == 157526721) strcat(s, "z");
if (crc32("BighjdoMpxvUIO",14) == 2230425585) strcat(s, "i");
if (crc32("htJfJf",6) == 28131013) strcat(s, "q");
if (crc32("QHqsHCbovVyv",12) == 3491658389) strcat(s, "g");
    return s;
}

char *Somnus_nouns() {
    char *s = calloc(7);
    if (crc32("vYQzGltGxGsoXk",14) == 108854619) strcat(s, "S");
if (crc32("JdCKDXUXRdF",11) == 1688166045) strcat(s, "H");
if (crc32("TXwqoRvzUMBr",12) == 1591038629) strcat(s, "o");
if (crc32("ZosUVvjlzujhMow",15) == 2181677751) strcat(s, "n");
if (crc32("BhxZKQbMYMED",12) == 1770715290) strcat(s, "m");
if (crc32("CFBujUAp",8) == 512897367) strcat(s, "R");
if (crc32("EKxnVajeNEZMPX",14) == 2936992092) strcat(s, "n");
if (crc32("TxKyvYCLuV",10) == 3708870057) strcat(s, "u");
if (crc32("JIzfAhtFABgo",12) == 2147456635) strcat(s, "s");
    return s;
}

char *isodomum_nouns() {
    char *s = calloc(9);
    if (crc32("qqHIofmzWZXpRFV",15) == 3111071806) strcat(s, "f");
if (crc32("XJtpFMAev",9) == 3936506121) strcat(s, "i");
if (crc32("TjRsYyWi",8) == 2962592806) strcat(s, "y");
if (crc32("PKKJUyPWjNQcvaR",15) == 1716815408) strcat(s, "s");
if (crc32("RJOdORr",7) == 2271651250) strcat(s, "Q");
if (crc32("AFuNiAWeTYlKaR",14) == 476373927) strcat(s, "o");
if (crc32("SLSqTYRiIwjle",13) == 2587341251) strcat(s, "d");
if (crc32("UmyAo",5) == 1152646149) strcat(s, "X");
if (crc32("MGJvrgnb",8) == 1512803368) strcat(s, "o");
if (crc32("FBeChhsOLZO",11) == 1801806228) strcat(s, "n");
if (crc32("elYNf",5) == 1330050114) strcat(s, "m");
if (crc32("OevzFVkhf",9) == 780812677) strcat(s, "u");
if (crc32("dMeAtjfpQzItdyn",15) == 3746809378) strcat(s, "m");
    return s;
}

char *Dam_nouns() {
    char *s = calloc(4);
    if (crc32("glwjKQPf",8) == 163446861) strcat(s, "D");
if (crc32("pQGHTcf",7) == 2198952681) strcat(s, "a");
if (crc32("cpUoIipBWFmDnWY",15) == 3570622593) strcat(s, "m");
    return s;
}

char *avenue_nouns() {
    char *s = calloc(7);
    if (crc32("GFmaPpBxxgi",11) == 366210480) strcat(s, "U");
if (crc32("xdnrstk",7) == 4047404910) strcat(s, "a");
if (crc32("IBTYXfaUTHzCK",13) == 3666998118) strcat(s, "g");
if (crc32("JIxozdAd",8) == 404661975) strcat(s, "v");
if (crc32("UKqpHlXzeQsVO",13) == 2082874487) strcat(s, "h");
if (crc32("ofSzJwncWd",10) == 3033676459) strcat(s, "e");
if (crc32("DKTcBG",6) == 2068448028) strcat(s, "l");
if (crc32("hdQxlUhoTyT",11) == 1612449977) strcat(s, "n");
if (crc32("gIJIUzfcMvPXcnQ",15) == 1917979975) strcat(s, "C");
if (crc32("zjsUOBMjBm",10) == 2580638618) strcat(s, "u");
if (crc32("yvCTeQZnEuwTo",13) == 2726477725) strcat(s, "e");
    return s;
}

char *nonreflection_nouns() {
    char *s = calloc(14);
    if (crc32("nhvWPQqMEb",10) == 803747561) strcat(s, "d");
if (crc32("CzTFsAqShFe",11) == 3703283139) strcat(s, "n");
if (crc32("zmQmpPHsstBVMq",14) == 2237414227) strcat(s, "o");
if (crc32("ltpcnliLV",9) == 3632058715) strcat(s, "n");
if (crc32("UyEiXcudBi",10) == 3636576700) strcat(s, "M");
if (crc32("Iscsm",5) == 2546696446) strcat(s, "r");
if (crc32("QkhJJzgYwsPF",12) == 3460003791) strcat(s, "Y");
if (crc32("nhPuBYTIIuVEh",13) == 1467295408) strcat(s, "e");
if (crc32("TpPRFqEtFaOMFv",14) == 2638494226) strcat(s, "f");
if (crc32("vADFdrsPSlWb",12) == 3380444939) strcat(s, "l");
if (crc32("rxqxTjTUDVjVRK",14) == 1858296181) strcat(s, "e");
if (crc32("ixOkXfOo",8) == 2380446604) strcat(s, "c");
if (crc32("FBPKTmdLCA",10) == 2649022441) strcat(s, "h");
if (crc32("bySQdnPGmIrOV",13) == 3220621981) strcat(s, "t");
if (crc32("oiDmAgMntwzF",12) == 4053336259) strcat(s, "i");
if (crc32("NFIcUSrX",8) == 1656468487) strcat(s, "o");
if (crc32("iEDtSANdntJ",11) == 2302952989) strcat(s, "n");
    return s;
}

char *paperback_nouns() {
    char *s = calloc(10);
    if (crc32("DZPidhhy",8) == 3763968317) strcat(s, "y");
if (crc32("VMpCabfRP",9) == 2864507714) strcat(s, "p");
if (crc32("CvjzYUGUQxvrv",13) == 612696447) strcat(s, "Q");
if (crc32("UOPRSIPeRBaYaBF",15) == 1038660676) strcat(s, "a");
if (crc32("tLOPHQi",7) == 2126601195) strcat(s, "r");
if (crc32("BnRGbbNx",8) == 2497624999) strcat(s, "p");
if (crc32("VcbHKPn",7) == 2183485906) strcat(s, "e");
if (crc32("AmYUZxF",7) == 3407207097) strcat(s, "a");
if (crc32("IAdanXbDwDXz",12) == 739248906) strcat(s, "r");
if (crc32("KBoeXeHZk",9) == 345488460) strcat(s, "b");
if (crc32("PmrrYTotB",9) == 63875174) strcat(s, "a");
if (crc32("CZXzCHsrxOKuY",13) == 1249986043) strcat(s, "c");
if (crc32("lBRKe",5) == 3935306784) strcat(s, "k");
    return s;
}

char *rajas_nouns() {
    char *s = calloc(6);
    if (crc32("qhvmgJesbmOlpw",14) == 3556629031) strcat(s, "z");
if (crc32("jmJQelpYbOw",11) == 879308494) strcat(s, "r");
if (crc32("VDDRiR",6) == 2356306242) strcat(s, "a");
if (crc32("IhzqLB",6) == 747877285) strcat(s, "g");
if (crc32("XHlDSYepPVsJzW",14) == 245002511) strcat(s, "j");
if (crc32("zPjkDRkSZwI",11) == 4220857868) strcat(s, "G");
if (crc32("wyGZqEjWYLnHap",14) == 2824115632) strcat(s, "a");
if (crc32("WvjHLYtt",8) == 3657499774) strcat(s, "s");
    return s;
}

char *Steven_nouns() {
    char *s = calloc(7);
    if (crc32("gYocbuxHVL",10) == 2320631473) strcat(s, "S");
if (crc32("JPHJiTmcqoKf",12) == 4081079141) strcat(s, "h");
if (crc32("GnOSMgerAtij",12) == 1464347613) strcat(s, "t");
if (crc32("zpEuJRUrpCnyv",13) == 49534685) strcat(s, "e");
if (crc32("BONKVPSvxo",10) == 657134485) strcat(s, "o");
if (crc32("aleHzo",6) == 1409602028) strcat(s, "v");
if (crc32("OmmagSPsgb",10) == 968888021) strcat(s, "e");
if (crc32("HWLhahayHU",10) == 793679105) strcat(s, "n");
    return s;
}

char *raphide_nouns() {
    char *s = calloc(8);
    if (crc32("cQzvhFO",7) == 458390368) strcat(s, "r");
if (crc32("HuAokbKPqIsvNi",14) == 2250630116) strcat(s, "a");
if (crc32("EvCqlypTWfd",11) == 2099711141) strcat(s, "p");
if (crc32("jjhVSNKa",8) == 3535732843) strcat(s, "h");
if (crc32("LxjEzyDm",8) == 2192759532) strcat(s, "i");
if (crc32("zNXWdjX",7) == 199471361) strcat(s, "i");
if (crc32("jOhdrNHisPhg",12) == 3641903713) strcat(s, "d");
if (crc32("gCHFLv",6) == 1954408824) strcat(s, "e");
    return s;
}

char *Graz_nouns() {
    char *s = calloc(5);
    if (crc32("xUPXze",6) == 284871579) strcat(s, "D");
if (crc32("njGpkEweXFznM",13) == 3806997284) strcat(s, "G");
if (crc32("yjNpvDp",7) == 1575233808) strcat(s, "G");
if (crc32("CyBvmef",7) == 1418795782) strcat(s, "r");
if (crc32("JJJXvhNryE",10) == 688208307) strcat(s, "a");
if (crc32("YkqOD",5) == 784374554) strcat(s, "x");
if (crc32("WsgHqGEAtdWiD",13) == 3725014076) strcat(s, "z");
    return s;
}

char *stintedness_nouns() {
    char *s = calloc(12);
    if (crc32("kfLQEUTsyD",10) == 3819628662) strcat(s, "Z");
if (crc32("WGJjjZZnC",9) == 2563016865) strcat(s, "s");
if (crc32("XoikUGSgfzHnnw",14) == 506159369) strcat(s, "t");
if (crc32("vnTOTAOeHC",10) == 2833054424) strcat(s, "W");
if (crc32("zhCzHLrjSxTzMQC",15) == 3089620687) strcat(s, "i");
if (crc32("SDpXjCPXhTiIx",13) == 3816815353) strcat(s, "U");
if (crc32("dVSsZMroYdchRZ",14) == 4172789916) strcat(s, "n");
if (crc32("bDEsr",5) == 1471013616) strcat(s, "l");
if (crc32("kMhrvoUaqWBm",12) == 2269141338) strcat(s, "t");
if (crc32("hCYNQrXmD",9) == 582440035) strcat(s, "e");
if (crc32("fRVxyAIbYwKU",12) == 678887548) strcat(s, "O");
if (crc32("KJSfLdHXC",9) == 75138606) strcat(s, "d");
if (crc32("VdXMCxkNmlyGcU",14) == 2655727901) strcat(s, "n");
if (crc32("hqJRqdacw",9) == 2032660752) strcat(s, "e");
if (crc32("MtfQy",5) == 2575244780) strcat(s, "N");
if (crc32("CfhCMHDVrzZwmc",14) == 3291682396) strcat(s, "s");
if (crc32("somnJ",5) == 913128579) strcat(s, "s");
    return s;
}

char *Bhubaneswar_nouns() {
    char *s = calloc(12);
    if (crc32("nOOwMXDbFX",10) == 746208066) strcat(s, "r");
if (crc32("kcnaTwHbvs",10) == 1051998236) strcat(s, "B");
if (crc32("LFwqJl",6) == 2353566707) strcat(s, "Q");
if (crc32("zJYzxa",6) == 990429298) strcat(s, "h");
if (crc32("dFWlBjkvOPSG",12) == 2105490697) strcat(s, "U");
if (crc32("SsPZdXQjXX",10) == 270601983) strcat(s, "u");
if (crc32("mHffzQ",6) == 3251140399) strcat(s, "K");
if (crc32("eWKFW",5) == 4006180558) strcat(s, "b");
if (crc32("rpIrDDSnEEhXp",13) == 203325789) strcat(s, "l");
if (crc32("eGMHnExQculoKoh",15) == 3856874778) strcat(s, "a");
if (crc32("ZzvpDWkgESoEXqr",15) == 561879175) strcat(s, "Y");
if (crc32("ebhDFbNvg",9) == 3632801115) strcat(s, "n");
if (crc32("AnhwseBfTAHxkLM",15) == 2498557851) strcat(s, "e");
if (crc32("IdTZsIriiZkQ",12) == 3787562193) strcat(s, "w");
if (crc32("grfwzMTNyqI",11) == 1186608603) strcat(s, "s");
if (crc32("MgjyLMgIPxrFco",14) == 217795277) strcat(s, "J");
if (crc32("FVeuuMHs",8) == 1993445998) strcat(s, "w");
if (crc32("FGrwfriBQXMu",12) == 768813719) strcat(s, "s");
if (crc32("xfqHUinKXTLw",12) == 1957139702) strcat(s, "a");
if (crc32("aefMSpk",7) == 205346052) strcat(s, "r");
    return s;
}

char *Poteau_nouns() {
    char *s = calloc(7);
    if (crc32("TxcefOygqc",10) == 584745642) strcat(s, "P");
if (crc32("BdJwVQDP",8) == 3895765206) strcat(s, "o");
if (crc32("IQrEY",5) == 3535635568) strcat(s, "Z");
if (crc32("tIMuvgaeTge",11) == 3263998647) strcat(s, "t");
if (crc32("oCDwTBnE",8) == 210256978) strcat(s, "e");
if (crc32("xiXzNwe",7) == 3592979028) strcat(s, "w");
if (crc32("inguOVuxgCiJJ",13) == 2627142098) strcat(s, "a");
if (crc32("FOtwHaHSiPI",11) == 4090989377) strcat(s, "z");
if (crc32("AlkKeIqMO",9) == 96719882) strcat(s, "u");
    return s;
}

char *olfaction_nouns() {
    char *s = calloc(10);
    if (crc32("CwaEuqf",7) == 922705264) strcat(s, "o");
if (crc32("OUtasSivvGIelR",14) == 2703044850) strcat(s, "l");
if (crc32("kcqQdR",6) == 1882447540) strcat(s, "n");
if (crc32("iVtKZThrWMAi",12) == 2048765355) strcat(s, "f");
if (crc32("zgIKrFpb",8) == 2684977592) strcat(s, "k");
if (crc32("ByBWIK",6) == 2680900781) strcat(s, "a");
if (crc32("IXiJXSreoYfvW",13) == 4053830470) strcat(s, "c");
if (crc32("SehRJDrbqRe",11) == 2046021145) strcat(s, "C");
if (crc32("iUvuMQMocCHbG",13) == 3638241370) strcat(s, "t");
if (crc32("YtXcGeBkGevPtUl",15) == 3520874761) strcat(s, "i");
if (crc32("yTDZbCaA",8) == 2030248087) strcat(s, "o");
if (crc32("IWPSdfLLESvF",12) == 2860413238) strcat(s, "J");
if (crc32("sIPkeLO",7) == 1211933798) strcat(s, "n");
    return s;
}

char *oversimplicity_nouns() {
    char *s = calloc(15);
    if (crc32("upMoKejmuj",10) == 333006396) strcat(s, "o");
if (crc32("KlQlZHSEH",9) == 1894667281) strcat(s, "v");
if (crc32("tVrWXrYPaQqhiX",14) == 1695634545) strcat(s, "I");
if (crc32("IEMgQLAqIBkmIl",14) == 1266598689) strcat(s, "e");
if (crc32("cmZNctRFJ",9) == 522404293) strcat(s, "r");
if (crc32("SaPPAIxzY",9) == 3660723604) strcat(s, "S");
if (crc32("LrYqhZlcxJuyaVf",15) == 2505722567) strcat(s, "s");
if (crc32("ZSVaCKZuoOJzou",14) == 1115566470) strcat(s, "F");
if (crc32("CBuaSUl",7) == 4119195823) strcat(s, "i");
if (crc32("WwajNipkeNHe",12) == 2805609405) strcat(s, "m");
if (crc32("dPFtTQZEkej",11) == 1342258998) strcat(s, "r");
if (crc32("QeijDCMDGyRRde",14) == 3650814691) strcat(s, "p");
if (crc32("hLgEysuBdeqJDj",14) == 661254491) strcat(s, "P");
if (crc32("ITCIzIrcAhwEDc",14) == 2009040587) strcat(s, "l");
if (crc32("MaQbGUZXlHL",11) == 409706719) strcat(s, "i");
if (crc32("LfLNZVAR",8) == 3433672307) strcat(s, "c");
if (crc32("MJspWLexwJDhrn",14) == 3146748454) strcat(s, "N");
if (crc32("rMRYctYnNbJm",12) == 2409981421) strcat(s, "i");
if (crc32("SAmvgyeRa",9) == 3204074255) strcat(s, "t");
if (crc32("VZtsEeQbfzuIt",13) == 3646656171) strcat(s, "y");
    return s;
}

char *Scheherazade_nouns() {
    char *s = calloc(13);
    if (crc32("RQyvbIfhwBqX",12) == 190065035) strcat(s, "C");
if (crc32("wPgyqEHOFBrf",12) == 123344040) strcat(s, "S");
if (crc32("IgdMKTGyilxdqF",14) == 3989838444) strcat(s, "W");
if (crc32("XIAOn",5) == 2230230210) strcat(s, "c");
if (crc32("vwxKMWw",7) == 109691018) strcat(s, "Y");
if (crc32("jRQWyFzOlH",10) == 864036786) strcat(s, "h");
if (crc32("bzxGZXutmoua",12) == 1258288659) strcat(s, "k");
if (crc32("PotSYeGDMLCd",12) == 2638456061) strcat(s, "e");
if (crc32("QZRKRGZkIpbz",12) == 663921250) strcat(s, "h");
if (crc32("rfVjUIIYVKEOkQy",15) == 1601543113) strcat(s, "x");
if (crc32("mCkyLoPlrAn",11) == 3482642533) strcat(s, "e");
if (crc32("IAjUJwzZVorCQ",13) == 4248017144) strcat(s, "n");
if (crc32("aFXjAwzfoYqVcl",14) == 411442556) strcat(s, "r");
if (crc32("rJtdmQwwTDvHDjs",15) == 246637277) strcat(s, "a");
if (crc32("FvhmmFfuMcbfpp",14) == 697405458) strcat(s, "z");
if (crc32("OggsWphxTXiZC",13) == 785254518) strcat(s, "D");
if (crc32("LlGfSTWdNBFSKyX",15) == 1433952054) strcat(s, "a");
if (crc32("DMxCjRaIDrxN",12) == 2981821526) strcat(s, "o");
if (crc32("tpHlgJXTPhvm",12) == 1161112920) strcat(s, "d");
if (crc32("MRBzFfBRAfSt",12) == 4156898612) strcat(s, "j");
if (crc32("nFPpfPrgdW",10) == 2800548127) strcat(s, "e");
    return s;
}

char *nonfecundity_nouns() {
    char *s = calloc(13);
    if (crc32("ZXubgvvTZ",9) == 478742189) strcat(s, "n");
if (crc32("seiLIxuciBdyZo",14) == 890204329) strcat(s, "o");
if (crc32("jEuHtWRph",9) == 4081469871) strcat(s, "u");
if (crc32("efwfxC",6) == 1292399044) strcat(s, "n");
if (crc32("dCtsq",5) == 221891406) strcat(s, "q");
if (crc32("AlosNzxA",8) == 1329814635) strcat(s, "f");
if (crc32("waLLjfIrGD",10) == 3141121773) strcat(s, "v");
if (crc32("EWqUIcHZwKD",11) == 3440144326) strcat(s, "e");
if (crc32("TIBzLUVGEYlo",12) == 2204431587) strcat(s, "I");
if (crc32("gwhZGsakCWLrS",13) == 1622911338) strcat(s, "c");
if (crc32("WWgoGyV",7) == 736284987) strcat(s, "u");
if (crc32("EVAwIYBApalbRmy",15) == 3442697452) strcat(s, "k");
if (crc32("IGDuBBX",7) == 2077349576) strcat(s, "n");
if (crc32("IVUwbEpyof",10) == 400578249) strcat(s, "d");
if (crc32("ehAVpd",6) == 1858122283) strcat(s, "i");
if (crc32("yCKDBnyfrnDiI",13) == 298824561) strcat(s, "t");
if (crc32("rbQfE",5) == 662828654) strcat(s, "a");
if (crc32("TCoLnHA",7) == 1923628832) strcat(s, "y");
    return s;
}

char *speleology_nouns() {
    char *s = calloc(11);
    if (crc32("KcMClvOdNSGlWL",14) == 1862704484) strcat(s, "o");
if (crc32("OMbjPQPwhuBDz",13) == 2305576461) strcat(s, "s");
if (crc32("PlLZopRZgI",10) == 1992491534) strcat(s, "S");
if (crc32("iYfREvdkjKEqpF",14) == 1939680128) strcat(s, "p");
if (crc32("GXHspxELDsWKG",13) == 1686626360) strcat(s, "f");
if (crc32("EOyCHh",6) == 735446284) strcat(s, "e");
if (crc32("eCuBmDVASKlvx",13) == 516811425) strcat(s, "w");
if (crc32("syjlSrlV",8) == 237872778) strcat(s, "l");
if (crc32("TZlbuenPEdT",11) == 904859443) strcat(s, "e");
if (crc32("Oypsynl",7) == 1054651648) strcat(s, "k");
if (crc32("mYWyy",5) == 2941401051) strcat(s, "o");
if (crc32("KkmMjmNUcN",10) == 3419081980) strcat(s, "o");
if (crc32("fDQHkF",6) == 3599913243) strcat(s, "l");
if (crc32("jBtaaSRJPnwIe",13) == 1967299091) strcat(s, "O");
if (crc32("xAbbD",5) == 1090646185) strcat(s, "o");
if (crc32("PknZUB",6) == 3059895795) strcat(s, "g");
if (crc32("LVQTq",5) == 3068696209) strcat(s, "O");
if (crc32("ESKJougRnWpT",12) == 237335208) strcat(s, "y");
    return s;
}

char *plasticity_nouns() {
    char *s = calloc(11);
    if (crc32("HfTOgjZyqTda",12) == 1797397536) strcat(s, "p");
if (crc32("hVhKLt",6) == 593310563) strcat(s, "g");
if (crc32("PUIfxURqwmnl",12) == 2174795515) strcat(s, "l");
if (crc32("KChWpnqvoXurmGG",15) == 2902297952) strcat(s, "D");
if (crc32("lCODG",5) == 338300493) strcat(s, "a");
if (crc32("WcKGxq",6) == 3466355921) strcat(s, "w");
if (crc32("RASRrHEtA",9) == 3985286233) strcat(s, "s");
if (crc32("hbWvm",5) == 1105693955) strcat(s, "D");
if (crc32("cvRUzR",6) == 318129134) strcat(s, "t");
if (crc32("qlITMMGwqDs",11) == 3198560726) strcat(s, "i");
if (crc32("beAkxmT",7) == 3061818447) strcat(s, "c");
if (crc32("tOAiY",5) == 582288162) strcat(s, "o");
if (crc32("YQcjvwO",7) == 2962953568) strcat(s, "i");
if (crc32("wDzEXWYVmSRjchS",15) == 2367262957) strcat(s, "t");
if (crc32("rGePNzE",7) == 3346749342) strcat(s, "y");
    return s;
}

char *Venola_nouns() {
    char *s = calloc(7);
    if (crc32("FAxJrPT",7) == 2235264161) strcat(s, "q");
if (crc32("zAyVKUGSkEKnC",13) == 1971828321) strcat(s, "V");
if (crc32("kCTFUeQmgjuq",12) == 2215351843) strcat(s, "e");
if (crc32("uZZWnmdt",8) == 3961392619) strcat(s, "n");
if (crc32("wqTRYUWRczh",11) == 2561388157) strcat(s, "X");
if (crc32("XbSWUlKFYIjXK",13) == 130004125) strcat(s, "o");
if (crc32("ZfPQwZhlSN",10) == 1388949000) strcat(s, "X");
if (crc32("pQHLOf",6) == 1266932168) strcat(s, "l");
if (crc32("uuXlccqOZoO",11) == 3968499084) strcat(s, "a");
    return s;
}

char *Lucius_nouns() {
    char *s = calloc(7);
    if (crc32("KzadCNMqhSPmuXF",15) == 4289781561) strcat(s, "L");
if (crc32("omgLRYOVtzfpL",13) == 1696458763) strcat(s, "i");
if (crc32("YqavOGyeB",9) == 2946537629) strcat(s, "u");
if (crc32("ECshJXQJ",8) == 267101082) strcat(s, "m");
if (crc32("TiBHuSjksQYwKOh",15) == 308781030) strcat(s, "c");
if (crc32("SAYmJ",5) == 3205420293) strcat(s, "i");
if (crc32("jKyBq",5) == 3889723455) strcat(s, "u");
if (crc32("USMSoZyOmISw",12) == 1892279626) strcat(s, "M");
if (crc32("JDSaBqystNjY",12) == 2117041754) strcat(s, "s");
    return s;
}

char *Veronika_nouns() {
    char *s = calloc(9);
    if (crc32("nwaijAgR",8) == 1411151790) strcat(s, "V");
if (crc32("vxGgA",5) == 1082752290) strcat(s, "e");
if (crc32("CShprtpLMWNwO",13) == 815077346) strcat(s, "r");
if (crc32("BwEQcEtyjpCxlQH",15) == 2647909273) strcat(s, "o");
if (crc32("fkZERjrzJRIlOo",14) == 237053171) strcat(s, "n");
if (crc32("EJYcfEIiGTpah",13) == 2329670386) strcat(s, "W");
if (crc32("umXeKnvK",8) == 1288396897) strcat(s, "i");
if (crc32("fMfsoWHetTDuZ",13) == 1904762636) strcat(s, "W");
if (crc32("bwRLOELOQQV",11) == 2856845721) strcat(s, "k");
if (crc32("kjWLZcSS",8) == 3325585742) strcat(s, "a");
    return s;
}

char *muser_nouns() {
    char *s = calloc(6);
    if (crc32("tVKyPKbLAgqxAA",14) == 1240030694) strcat(s, "D");
if (crc32("aJUzlfgvnjRTet",14) == 3941989721) strcat(s, "m");
if (crc32("zzXcr",5) == 3820361975) strcat(s, "u");
if (crc32("kYOsXudqnXDw",12) == 1282487959) strcat(s, "E");
if (crc32("VhQICemKHTPKyqr",15) == 1538237263) strcat(s, "s");
if (crc32("qxDxeAFiGA",10) == 3105490396) strcat(s, "e");
if (crc32("CdEAjGrRI",9) == 2184803214) strcat(s, "r");
    return s;
}

char *blade_nouns() {
    char *s = calloc(6);
    if (crc32("mWoqhgqsjDoVg",13) == 2510016293) strcat(s, "b");
if (crc32("CxnycB",6) == 3946499617) strcat(s, "e");
if (crc32("TbdogIXbCw",10) == 410169515) strcat(s, "l");
if (crc32("wrQTIzPVyV",10) == 597748524) strcat(s, "a");
if (crc32("klZqzEgrXT",10) == 728308091) strcat(s, "d");
if (crc32("ZSERIytrsX",10) == 2723861146) strcat(s, "X");
if (crc32("uyktminUhZX",11) == 1693045399) strcat(s, "e");
    return s;
}

char *fascicle_nouns() {
    char *s = calloc(9);
    if (crc32("veqxYmTQqvSOcdG",15) == 2354049320) strcat(s, "r");
if (crc32("WLuZZfTVhrVJet",14) == 967360679) strcat(s, "f");
if (crc32("uAkRN",5) == 2312360058) strcat(s, "a");
if (crc32("VKGaCvfv",8) == 1433705371) strcat(s, "s");
if (crc32("zmRoj",5) == 1717491789) strcat(s, "R");
if (crc32("sfNcqRsgfjsV",12) == 3674129949) strcat(s, "c");
if (crc32("HhjTegBa",8) == 4200982361) strcat(s, "i");
if (crc32("MhVyRDcIUsfrETK",15) == 3766389445) strcat(s, "J");
if (crc32("nYDKlsQho",9) == 3573891439) strcat(s, "c");
if (crc32("skPoCkWsOlawq",13) == 596966988) strcat(s, "W");
if (crc32("cpmUZlQ",7) == 91104772) strcat(s, "l");
if (crc32("PMtyrOlgZhGOL",13) == 1794483997) strcat(s, "e");
    return s;
}

char *patchwork_nouns() {
    char *s = calloc(10);
    if (crc32("TUfQIjUypXXuI",13) == 712955983) strcat(s, "p");
if (crc32("spGgNALVEm",10) == 874587488) strcat(s, "a");
if (crc32("aSidiBWINOsuyKf",15) == 1834170593) strcat(s, "Q");
if (crc32("yrDGRFTYojMCHJ",14) == 1801391575) strcat(s, "t");
if (crc32("LzwkOQywl",9) == 3426502597) strcat(s, "G");
if (crc32("pIPHuljtwnISgAc",15) == 1129783394) strcat(s, "c");
if (crc32("degoCmEctHoJiMK",15) == 1586920082) strcat(s, "E");
if (crc32("VseOGx",6) == 1136606550) strcat(s, "h");
if (crc32("ZVEZthh",7) == 1225290459) strcat(s, "w");
if (crc32("zeCXKVBlyPY",11) == 3572479982) strcat(s, "x");
if (crc32("qftQGDMZG",9) == 3869995299) strcat(s, "o");
if (crc32("aPqMqYkKCfXqURE",15) == 718747178) strcat(s, "X");
if (crc32("EHNakkTmffKbbU",14) == 4098407914) strcat(s, "r");
if (crc32("dLealikFEPVegs",14) == 4150000813) strcat(s, "k");
    return s;
}

char *squama_nouns() {
    char *s = calloc(7);
    if (crc32("qsSvQNMJQ",9) == 2369773626) strcat(s, "x");
if (crc32("CjymKYoEmZgFPhI",15) == 2540532013) strcat(s, "s");
if (crc32("lRRnrYbEISpgn",13) == 1579248933) strcat(s, "G");
if (crc32("MgbJDEPRTWNDHhr",15) == 2677865937) strcat(s, "q");
if (crc32("EdBhazS",7) == 2856070156) strcat(s, "u");
if (crc32("jMMiahbDtHSk",12) == 1674901859) strcat(s, "z");
if (crc32("CIldD",5) == 243325789) strcat(s, "a");
if (crc32("nvAoCPG",7) == 3180800584) strcat(s, "m");
if (crc32("tPPkGbYtH",9) == 1950595105) strcat(s, "a");
    return s;
}

char *Hightstown_nouns() {
    char *s = calloc(11);
    if (crc32("tspjAFVMDfzvV",13) == 3862957954) strcat(s, "b");
if (crc32("jlmgaJLkRxC",11) == 4027115236) strcat(s, "H");
if (crc32("CKsrOMul",8) == 2165549036) strcat(s, "O");
if (crc32("gopPbRwArEHPlw",14) == 1666167241) strcat(s, "i");
if (crc32("oFIipYPcikOE",12) == 914079532) strcat(s, "g");
if (crc32("uAAmVpdo",8) == 3580793301) strcat(s, "g");
if (crc32("wqknTldkR",9) == 1504681329) strcat(s, "h");
if (crc32("YHhbjGOcPfg",11) == 1944567694) strcat(s, "g");
if (crc32("PEHDS",5) == 1241892590) strcat(s, "t");
if (crc32("KNgJdbNAR",9) == 2375352985) strcat(s, "s");
if (crc32("ThVcsSqKFhwN",12) == 3051921362) strcat(s, "g");
if (crc32("OcOsjOHwCyrH",12) == 3130377741) strcat(s, "t");
if (crc32("hseaWBuDSyCOm",13) == 3718961563) strcat(s, "h");
if (crc32("iBQSqzLJQNj",11) == 1128151487) strcat(s, "o");
if (crc32("XsNznqamihk",11) == 227351177) strcat(s, "v");
if (crc32("AjNefYqwyq",10) == 239781771) strcat(s, "w");
if (crc32("pAucGYDyJzsN",12) == 920037088) strcat(s, "c");
if (crc32("rGLTPPGJ",8) == 829616433) strcat(s, "n");
    return s;
}

char *Qadarite_nouns() {
    char *s = calloc(9);
    if (crc32("jzyueWvTRwznqg",14) == 213469830) strcat(s, "Q");
if (crc32("bmcuWzrhHxOL",12) == 2204158547) strcat(s, "T");
if (crc32("wIZVAasQjSRk",12) == 29604797) strcat(s, "a");
if (crc32("gmXqtG",6) == 1039163478) strcat(s, "d");
if (crc32("HiolXfSONdMKyhr",15) == 1916775934) strcat(s, "a");
if (crc32("efwBZ",5) == 2448575559) strcat(s, "r");
if (crc32("JKhQzSt",7) == 3935035918) strcat(s, "D");
if (crc32("qjxqwQ",6) == 630461548) strcat(s, "i");
if (crc32("QLPIiHpDemmoHy",14) == 729795078) strcat(s, "t");
if (crc32("RGmbPFcPhlbId",13) == 523727174) strcat(s, "I");
if (crc32("qtQNgI",6) == 1374156177) strcat(s, "e");
    return s;
}

char *Armina_nouns() {
    char *s = calloc(7);
    if (crc32("QpDKEsjGTr",10) == 240234211) strcat(s, "A");
if (crc32("zaFRwSFWbHUv",12) == 1289787077) strcat(s, "l");
if (crc32("DFMMwKT",7) == 318834315) strcat(s, "r");
if (crc32("axKleYOLzjLKur",14) == 2583495017) strcat(s, "m");
if (crc32("srzJypKdhblcExc",15) == 4151356481) strcat(s, "c");
if (crc32("jjuKCDucEDTtf",13) == 1782115192) strcat(s, "i");
if (crc32("SJGPIeDXJkyz",12) == 2266227366) strcat(s, "n");
if (crc32("XTDZCV",6) == 4041466069) strcat(s, "K");
if (crc32("TMPQTFpPAwq",11) == 689611680) strcat(s, "a");
    return s;
}

char *demise_nouns() {
    char *s = calloc(7);
    if (crc32("bRjUpLzuxqi",11) == 697050279) strcat(s, "d");
if (crc32("UqGlDV",6) == 1972564734) strcat(s, "L");
if (crc32("iXxVsdnnAupifVe",15) == 2977746668) strcat(s, "e");
if (crc32("KlBhrHyCLtmxdE",14) == 3458196309) strcat(s, "M");
if (crc32("jlEkQEQyS",9) == 341362469) strcat(s, "m");
if (crc32("SLAyEFnhDyvz",12) == 1359289883) strcat(s, "V");
if (crc32("zBptzwRBdcZr",12) == 388655454) strcat(s, "i");
if (crc32("VSMux",5) == 1575344517) strcat(s, "Q");
if (crc32("SqdHEfSNbWmVw",13) == 468865026) strcat(s, "s");
if (crc32("nqWhmyaoPlTjwF",14) == 3890116044) strcat(s, "R");
if (crc32("CZVhBH",6) == 1481056456) strcat(s, "e");
    return s;
}

char *microdontia_nouns() {
    char *s = calloc(12);
    if (crc32("LnHkWDd",7) == 2232455623) strcat(s, "y");
if (crc32("SAJuJw",6) == 1009777649) strcat(s, "m");
if (crc32("TNzhH",5) == 4232017043) strcat(s, "i");
if (crc32("rdHNLwYGqkdrrG",14) == 4029477218) strcat(s, "e");
if (crc32("ybjILxidFMGRaB",14) == 524302808) strcat(s, "c");
if (crc32("rZbTDz",6) == 1540649412) strcat(s, "r");
if (crc32("VJHYsEVLuGyjN",13) == 1084082619) strcat(s, "C");
if (crc32("dgGhPjn",7) == 3129029149) strcat(s, "o");
if (crc32("IgnRsjDySx",10) == 4110427351) strcat(s, "X");
if (crc32("MplSO",5) == 994487211) strcat(s, "d");
if (crc32("oXpahmcVB",9) == 193458504) strcat(s, "F");
if (crc32("JwYwgvDFH",9) == 1740358787) strcat(s, "o");
if (crc32("AzYhe",5) == 1419945819) strcat(s, "n");
if (crc32("aPjdKSTzKIEXYF",14) == 3391610537) strcat(s, "S");
if (crc32("ZptkkIvQH",9) == 1410639305) strcat(s, "t");
if (crc32("aEzarLr",7) == 2408416985) strcat(s, "g");
if (crc32("aqvPkfdoDcNgvF",14) == 2704364500) strcat(s, "i");
if (crc32("uvojkuhU",8) == 496251903) strcat(s, "G");
if (crc32("wZoAbXePACyKGBv",15) == 29742221) strcat(s, "a");
    return s;
}

char *Erfurt_nouns() {
    char *s = calloc(7);
    if (crc32("MixBTQg",7) == 1949806703) strcat(s, "E");
if (crc32("zkROzTIhFWenwr",14) == 377579169) strcat(s, "r");
if (crc32("aepgohNYaPkh",12) == 3161400932) strcat(s, "f");
if (crc32("tJLKye",6) == 4125453791) strcat(s, "V");
if (crc32("YdXwyX",6) == 851143664) strcat(s, "u");
if (crc32("srJrW",5) == 1191087665) strcat(s, "S");
if (crc32("hQfNGbdKK",9) == 2209022066) strcat(s, "r");
if (crc32("pJYmiEiI",8) == 3899281525) strcat(s, "t");
    return s;
}

char *tenterhook_nouns() {
    char *s = calloc(11);
    if (crc32("YmUPi",5) == 3738115466) strcat(s, "t");
if (crc32("heDfEUsjO",9) == 3025536364) strcat(s, "e");
if (crc32("okZaCHPSvUx",11) == 3300690887) strcat(s, "n");
if (crc32("PMOpbmDGMKujV",13) == 603932217) strcat(s, "t");
if (crc32("ZeuRyT",6) == 3962015533) strcat(s, "e");
if (crc32("KHZbzJ",6) == 283410942) strcat(s, "r");
if (crc32("ASxzqvMl",8) == 1142380242) strcat(s, "h");
if (crc32("MEdoUlHx",8) == 2465074828) strcat(s, "o");
if (crc32("foPUxRmE",8) == 3976683204) strcat(s, "P");
if (crc32("XKxdW",5) == 740884279) strcat(s, "o");
if (crc32("jnJKzBoMdysr",12) == 2364879962) strcat(s, "k");
    return s;
}

char *mulierty_nouns() {
    char *s = calloc(9);
    if (crc32("FlHqKBsg",8) == 162540464) strcat(s, "m");
if (crc32("AnzJOZNlm",9) == 4060524246) strcat(s, "u");
if (crc32("dCLvg",5) == 4026699628) strcat(s, "l");
if (crc32("PnzPgtC",7) == 3667848426) strcat(s, "M");
if (crc32("UPTCTjmuBpu",11) == 1814967447) strcat(s, "i");
if (crc32("xMgYMTqnDhANdI",14) == 942327144) strcat(s, "e");
if (crc32("OLWFiozncI",10) == 4280788824) strcat(s, "r");
if (crc32("MFQcvEldNQ",10) == 2207680236) strcat(s, "t");
if (crc32("viKRFARmnFKh",12) == 1940225568) strcat(s, "t");
if (crc32("KfoOieWdtu",10) == 489689217) strcat(s, "y");
    return s;
}

char *hypomotility_nouns() {
    char *s = calloc(13);
    if (crc32("CxLKvHDVeo",10) == 3917135918) strcat(s, "h");
if (crc32("YNQPuDeVWiQZ",12) == 3307305951) strcat(s, "t");
if (crc32("XvNeuadEfUEeab",14) == 756099503) strcat(s, "y");
if (crc32("dVQaOBiU",8) == 1562679036) strcat(s, "I");
if (crc32("SlLcT",5) == 2469909392) strcat(s, "p");
if (crc32("CjQzgoX",7) == 2321303854) strcat(s, "o");
if (crc32("UYctGFJRRppXLC",14) == 853522508) strcat(s, "m");
if (crc32("UuvQP",5) == 4068986379) strcat(s, "o");
if (crc32("cKKYgRFIpbjIvv",14) == 1807483622) strcat(s, "t");
if (crc32("kgRdnxJ",7) == 3290282278) strcat(s, "i");
if (crc32("bBnvre",6) == 2429411087) strcat(s, "u");
if (crc32("dUYxoIkWTciIj",13) == 2170812219) strcat(s, "l");
if (crc32("QGOsiivOmlBbMWb",15) == 245419665) strcat(s, "O");
if (crc32("YMOFWlEecd",10) == 4120915780) strcat(s, "i");
if (crc32("XgKvxSbfHKzYFZA",15) == 3199714841) strcat(s, "t");
if (crc32("VshxifXzW",9) == 1386848463) strcat(s, "y");
    return s;
}

char *Pitarys_nouns() {
    char *s = calloc(8);
    if (crc32("YBHQR",5) == 2591050404) strcat(s, "P");
if (crc32("cJZYTH",6) == 2780552194) strcat(s, "C");
if (crc32("TxZdsxDKMkdabP",14) == 413249985) strcat(s, "i");
if (crc32("ZGqcJgxEIwIOSyK",15) == 795646691) strcat(s, "t");
if (crc32("KsZjxIEjidb",11) == 206238898) strcat(s, "V");
if (crc32("eQkCdrWeHqJBnng",15) == 3490021690) strcat(s, "a");
if (crc32("FiPtze",6) == 2350683755) strcat(s, "r");
if (crc32("sKwQoXVnpkmUjs",14) == 1162932503) strcat(s, "y");
if (crc32("VEKcdbjVMUlQhv",14) == 3327735254) strcat(s, "s");
    return s;
}

char *subtopia_nouns() {
    char *s = calloc(9);
    if (crc32("TcdPdsVIUdDTZ",13) == 3990692564) strcat(s, "s");
if (crc32("COCqKbjN",8) == 910537618) strcat(s, "v");
if (crc32("TYsTJSSz",8) == 4180878928) strcat(s, "u");
if (crc32("kJMyxflFB",9) == 27289746) strcat(s, "y");
if (crc32("DgchZiH",7) == 3049968045) strcat(s, "b");
if (crc32("rYjwYcYef",9) == 2289205797) strcat(s, "t");
if (crc32("rqXedFefNsRan",13) == 4166848781) strcat(s, "f");
if (crc32("zZEcUuDxoIRdrO",14) == 1432915021) strcat(s, "o");
if (crc32("ZqMXsjDJwwrloN",14) == 358227041) strcat(s, "j");
if (crc32("auSdcdfSSbj",11) == 2271497509) strcat(s, "p");
if (crc32("LRxukotCwsLx",12) == 323805593) strcat(s, "w");
if (crc32("inUKWmZ",7) == 1061466832) strcat(s, "i");
if (crc32("XDZDvgrArc",10) == 4193022057) strcat(s, "s");
if (crc32("XRZWimJk",8) == 2790918251) strcat(s, "a");
    return s;
}

char *stinkeroo_nouns() {
    char *s = calloc(10);
    if (crc32("KmaQQbQDdMXEnk",14) == 4216949813) strcat(s, "s");
if (crc32("uvtIbwazPVwE",12) == 1376211705) strcat(s, "t");
if (crc32("rZOxEmxCay",10) == 1848621185) strcat(s, "i");
if (crc32("IZguMmZdNFBglA",14) == 4122929223) strcat(s, "n");
if (crc32("nDakAv",6) == 3109236714) strcat(s, "k");
if (crc32("CxANsj",6) == 136282801) strcat(s, "O");
if (crc32("oqSlbg",6) == 2428156549) strcat(s, "e");
if (crc32("NsRZUXYXmJc",11) == 3157262654) strcat(s, "G");
if (crc32("LRtkGTmjBNG",11) == 4230744094) strcat(s, "r");
if (crc32("BzEkC",5) == 3695657745) strcat(s, "I");
if (crc32("vMgElatBQvIzfiC",15) == 1650633540) strcat(s, "o");
if (crc32("IkdZlnvKWSeo",12) == 3383260289) strcat(s, "o");
    return s;
}

char *beauty_nouns() {
    char *s = calloc(7);
    if (crc32("jmwBmZgT",8) == 346133594) strcat(s, "b");
if (crc32("PtxJYYfbGdVjLtS",15) == 1524619671) strcat(s, "e");
if (crc32("FKIpmugInBCEx",13) == 2439528829) strcat(s, "a");
if (crc32("BUvEPhvKEL",10) == 1674629769) strcat(s, "l");
if (crc32("lqjBPB",6) == 262837468) strcat(s, "u");
if (crc32("sZfAoUWByYtV",12) == 1352632003) strcat(s, "t");
if (crc32("RfjHSXc",7) == 1717149461) strcat(s, "i");
if (crc32("QguVRaSWdEN",11) == 3318661776) strcat(s, "y");
    return s;
}

char *reckoning_nouns() {
    char *s = calloc(10);
    if (crc32("YGhzsHYJzCKkdHo",15) == 3043205958) strcat(s, "r");
if (crc32("aTFNGnG",7) == 3990444406) strcat(s, "e");
if (crc32("MvDexv",6) == 1887194152) strcat(s, "c");
if (crc32("dVPdaah",7) == 2991961658) strcat(s, "R");
if (crc32("LeMlVzJHROjOElf",15) == 109542108) strcat(s, "k");
if (crc32("tctnLNyBH",9) == 1331689658) strcat(s, "Y");
if (crc32("rEnhpOWlHzDF",12) == 1662565925) strcat(s, "o");
if (crc32("GCdCYO",6) == 4149104703) strcat(s, "n");
if (crc32("kEASCztiyj",10) == 1676537297) strcat(s, "i");
if (crc32("KRlyUIBgH",9) == 2917745665) strcat(s, "a");
if (crc32("wMsjhswcGvCWyVI",15) == 3922093546) strcat(s, "n");
if (crc32("lZDKAsIl",8) == 1360966503) strcat(s, "j");
if (crc32("dPwyGVQiFLb",11) == 2248341849) strcat(s, "g");
    return s;
}

char *Pelasgus_nouns() {
    char *s = calloc(9);
    if (crc32("UifbNeQWyC",10) == 691074867) strcat(s, "P");
if (crc32("DTTeMcqfF",9) == 1264780834) strcat(s, "e");
if (crc32("rVbgQlCuHdKD",12) == 3499701406) strcat(s, "l");
if (crc32("OzRFNd",6) == 1079029693) strcat(s, "R");
if (crc32("ZfXGqVsRvwo",11) == 1695318712) strcat(s, "a");
if (crc32("WPGsTHtT",8) == 2699082120) strcat(s, "U");
if (crc32("HfUcmHAseXCJAO",14) == 2997922271) strcat(s, "s");
if (crc32("TOuDqDnpYwIH",12) == 932387696) strcat(s, "g");
if (crc32("RYsSRd",6) == 2428262541) strcat(s, "f");
if (crc32("IrZuqEqQIpOzDX",14) == 1864524487) strcat(s, "u");
if (crc32("psSDgJoRoBJ",11) == 3819575776) strcat(s, "s");
    return s;
}

char *syringe_nouns() {
    char *s = calloc(8);
    if (crc32("AcTWZK",6) == 663943409) strcat(s, "s");
if (crc32("JNpLUHEBmHhpy",13) == 3262031164) strcat(s, "y");
if (crc32("pxZIvgvPpimc",12) == 3872853417) strcat(s, "D");
if (crc32("YNTtrYWKpXOWa",13) == 1003433403) strcat(s, "r");
if (crc32("asjBufL",7) == 663349987) strcat(s, "A");
if (crc32("NHHwYV",6) == 175949292) strcat(s, "i");
if (crc32("NAREj",5) == 3817675180) strcat(s, "v");
if (crc32("LHMFcIzVW",9) == 2685143300) strcat(s, "n");
if (crc32("ubjiD",5) == 3874602171) strcat(s, "g");
if (crc32("NNUhatlwkn",10) == 327232125) strcat(s, "e");
    return s;
}

char *machinator_nouns() {
    char *s = calloc(11);
    if (crc32("wIgKgWfp",8) == 837355399) strcat(s, "K");
if (crc32("ydAjH",5) == 283752591) strcat(s, "m");
if (crc32("fJmLcEYDIZ",10) == 3379215584) strcat(s, "a");
if (crc32("vQcXWKnii",9) == 2726404756) strcat(s, "c");
if (crc32("rgAaCYQRSE",10) == 3601115253) strcat(s, "h");
if (crc32("tZFXRaJ",7) == 1134469639) strcat(s, "G");
if (crc32("ranEtIYxwEwoXcI",15) == 3297538096) strcat(s, "i");
if (crc32("nmNgX",5) == 476353923) strcat(s, "n");
if (crc32("JIhxHjadEttI",12) == 1141535001) strcat(s, "a");
if (crc32("eKIQRDy",7) == 3587943723) strcat(s, "t");
if (crc32("EfpOvItHoCljpGE",15) == 2831848244) strcat(s, "g");
if (crc32("tlfuAZztPuU",11) == 416124728) strcat(s, "o");
if (crc32("WEohlANOjGXuJ",13) == 880114319) strcat(s, "f");
if (crc32("iRonJzOjs",9) == 1976822922) strcat(s, "r");
    return s;
}

char *Cawley_nouns() {
    char *s = calloc(7);
    if (crc32("FdfiKaJNtZKbg",13) == 1766090400) strcat(s, "C");
if (crc32("iyCWrnVblezJu",13) == 373012047) strcat(s, "a");
if (crc32("TQmBLW",6) == 2015086291) strcat(s, "K");
if (crc32("oNoJpSaAv",9) == 3011695835) strcat(s, "w");
if (crc32("GJmaqfJjFOF",11) == 216674734) strcat(s, "C");
if (crc32("LwvzIBMwnH",10) == 1614026501) strcat(s, "l");
if (crc32("MsgnVKAdrKlIbQ",14) == 2335674291) strcat(s, "Z");
if (crc32("ljVyBbg",7) == 779265246) strcat(s, "e");
if (crc32("dYgHKvypFB",10) == 663161172) strcat(s, "y");
    return s;
}

char *Flori_nouns() {
    char *s = calloc(6);
    if (crc32("YORpCDrc",8) == 303858302) strcat(s, "F");
if (crc32("ixBRRB",6) == 3205137681) strcat(s, "j");
if (crc32("ELFsI",5) == 4176930258) strcat(s, "l");
if (crc32("tcYMzj",6) == 1226024040) strcat(s, "o");
if (crc32("lBuEsyUbp",9) == 333391510) strcat(s, "r");
if (crc32("npeMHH",6) == 4007762372) strcat(s, "D");
if (crc32("jDTPppChw",9) == 3673382954) strcat(s, "i");
    return s;
}

char *Kerge_nouns() {
    char *s = calloc(6);
    if (crc32("dtlVLDAmvDPXMk",14) == 3446139421) strcat(s, "K");
if (crc32("sfcJvkc",7) == 789096358) strcat(s, "N");
if (crc32("MUyfqxi",7) == 2294763655) strcat(s, "e");
if (crc32("eYUSpYl",7) == 1034200778) strcat(s, "r");
if (crc32("zzlzywuwsCCxxQ",14) == 1313184018) strcat(s, "X");
if (crc32("NuYklwkMtEF",11) == 810402852) strcat(s, "g");
if (crc32("aLeJZyERDGV",11) == 3234789131) strcat(s, "e");
    return s;
}

char *fantasy_nouns() {
    char *s = calloc(8);
    if (crc32("axjMD",5) == 2155569348) strcat(s, "d");
if (crc32("wcOXHtgFfRzlyYy",15) == 743698988) strcat(s, "f");
if (crc32("YdWjCzmmwRmz",12) == 853059183) strcat(s, "B");
if (crc32("yEcWeNQZTalExv",14) == 1857161054) strcat(s, "a");
if (crc32("zTumbtWUdlUynoa",15) == 427577690) strcat(s, "n");
if (crc32("uDbcmUOd",8) == 729084795) strcat(s, "Q");
if (crc32("JrnCF",5) == 334873003) strcat(s, "t");
if (crc32("CpIahBSerAm",11) == 3095567027) strcat(s, "a");
if (crc32("WQAUGWwtiHdjnb",14) == 3742827941) strcat(s, "s");
if (crc32("uhLoTdJAtRNGePA",15) == 3548418625) strcat(s, "y");
    return s;
}

char *confab_nouns() {
    char *s = calloc(7);
    if (crc32("mhKvLYtIjRpLVoS",15) == 3469448318) strcat(s, "n");
if (crc32("rCLEcfNiAo",10) == 244886872) strcat(s, "c");
if (crc32("rQXpHUi",7) == 3698827795) strcat(s, "Q");
if (crc32("cDoHoHvZk",9) == 1062164599) strcat(s, "o");
if (crc32("dnZcYhC",7) == 2126594862) strcat(s, "L");
if (crc32("LJcpqAGOGNzc",12) == 2281470604) strcat(s, "n");
if (crc32("vKTRInln",8) == 1539975646) strcat(s, "f");
if (crc32("IDQdF",5) == 3678841809) strcat(s, "r");
if (crc32("zAjyfRsNYKfIyF",14) == 2091007317) strcat(s, "a");
if (crc32("AYzSwrtCzDT",11) == 287649260) strcat(s, "W");
if (crc32("DTijpiKnE",9) == 1033983938) strcat(s, "b");
    return s;
}

char *font_nouns() {
    char *s = calloc(5);
    if (crc32("rYHuQErEywBEA",13) == 3576828852) strcat(s, "f");
if (crc32("LvnlClwYIwFYgug",15) == 3352823339) strcat(s, "q");
if (crc32("aJvBHUwCKd",10) == 3777372783) strcat(s, "o");
if (crc32("VKgSJGhWzXvRyWm",15) == 3352825866) strcat(s, "C");
if (crc32("iwzTZLUR",8) == 2080034651) strcat(s, "n");
if (crc32("GgFFe",5) == 1135012757) strcat(s, "Z");
if (crc32("hZrEK",5) == 4037393201) strcat(s, "t");
    return s;
}

char *unmaker_nouns() {
    char *s = calloc(8);
    if (crc32("BwpaVGdFLaF",11) == 1822246875) strcat(s, "R");
if (crc32("jAEcexo",7) == 3151567924) strcat(s, "u");
if (crc32("tvfMlDGCUaRpkzR",15) == 375675934) strcat(s, "n");
if (crc32("xSXYtXzIPWf",11) == 2549805051) strcat(s, "v");
if (crc32("ceParfCY",8) == 245065578) strcat(s, "m");
if (crc32("lPJutVjXm",9) == 2196368185) strcat(s, "G");
if (crc32("AVHeLxVYNaktwuX",15) == 3857542462) strcat(s, "a");
if (crc32("tTzdBumdRoOJjg",14) == 1783275927) strcat(s, "b");
if (crc32("FuXnUWDvgvn",11) == 1413991783) strcat(s, "k");
if (crc32("SOuQmrp",7) == 1054843310) strcat(s, "e");
if (crc32("jivNcZGqZZno",12) == 2481478587) strcat(s, "r");
    return s;
}

char *reapportionment_nouns() {
    char *s = calloc(16);
    if (crc32("RAlJibbj",8) == 3419213495) strcat(s, "D");
if (crc32("nPXkJBMbR",9) == 3694465575) strcat(s, "r");
if (crc32("ogQkT",5) == 3613300142) strcat(s, "L");
if (crc32("gtLKpyaYmwqFrRh",15) == 1962703621) strcat(s, "e");
if (crc32("QgzPdq",6) == 330256621) strcat(s, "a");
if (crc32("AmxhrHNQNwry",12) == 1563554201) strcat(s, "r");
if (crc32("auqhBSZlyC",10) == 1984824133) strcat(s, "p");
if (crc32("OCTYyJu",7) == 752613086) strcat(s, "s");
if (crc32("dPFIUDlg",8) == 258621706) strcat(s, "p");
if (crc32("tqHMuKohElY",11) == 721625236) strcat(s, "R");
if (crc32("vuVswASADnqs",12) == 1082440000) strcat(s, "o");
if (crc32("kcCYvljmGJ",10) == 35653938) strcat(s, "r");
if (crc32("XnznhbhrTeORTHK",15) == 4250908922) strcat(s, "y");
if (crc32("zhLtRSOBUm",10) == 4179412183) strcat(s, "t");
if (crc32("qZzxXaXt",8) == 2210437396) strcat(s, "i");
if (crc32("YFrrQuyXBpmSY",13) == 3099638594) strcat(s, "c");
if (crc32("WyWZafPD",8) == 617848898) strcat(s, "o");
if (crc32("cNOQMimbTzGTON",14) == 97097434) strcat(s, "f");
if (crc32("vdinA",5) == 3109504422) strcat(s, "n");
if (crc32("HCtzFFvJ",8) == 1011404062) strcat(s, "x");
if (crc32("iHHvStjAZaMxL",13) == 3193034030) strcat(s, "m");
if (crc32("QWweeSOTQG",10) == 405016487) strcat(s, "e");
if (crc32("TzhACVAKBQ",10) == 1567459766) strcat(s, "w");
if (crc32("kVcaWTro",8) == 2147437258) strcat(s, "n");
if (crc32("tGEddCngLz",10) == 1309945166) strcat(s, "t");
    return s;
}

char *heterochromosome_nouns() {
    char *s = calloc(17);
    if (crc32("dJDza",5) == 4120117179) strcat(s, "n");
if (crc32("rNKFKuX",7) == 161623437) strcat(s, "h");
if (crc32("ezfOKmvK",8) == 625876011) strcat(s, "e");
if (crc32("gBaAKErOkVQUo",13) == 3794313382) strcat(s, "R");
if (crc32("PKgknZXV",8) == 3349380185) strcat(s, "t");
if (crc32("cRimvQZqsDzs",12) == 3350401675) strcat(s, "a");
if (crc32("tPPlYb",6) == 1533540912) strcat(s, "e");
if (crc32("vbHfiZRgHJXLj",13) == 4224571594) strcat(s, "r");
if (crc32("udIvgRgW",8) == 3067374323) strcat(s, "o");
if (crc32("PUFZXJvDrOf",11) == 3667932734) strcat(s, "L");
if (crc32("dgeBXTdqQLKMRBr",15) == 2196446140) strcat(s, "c");
if (crc32("arSDGWkUSKH",11) == 1821319025) strcat(s, "E");
if (crc32("OgDbktCBmY",10) == 1409131196) strcat(s, "h");
if (crc32("UaOwHOMkePsxRDL",15) == 1374217059) strcat(s, "r");
if (crc32("CLxBlnPsM",9) == 2201472102) strcat(s, "F");
if (crc32("egNaDglsQWbsEE",14) == 370897457) strcat(s, "o");
if (crc32("PlgrPGGuKbsV",12) == 2260180762) strcat(s, "m");
if (crc32("pBnWXWaoBAVzswf",15) == 546386821) strcat(s, "o");
if (crc32("kEVLyLIvqCBt",12) == 1403980391) strcat(s, "s");
if (crc32("lIMMSMJU",8) == 2182798570) strcat(s, "E");
if (crc32("KKhaSOuw",8) == 695988230) strcat(s, "o");
if (crc32("hSvgoQ",6) == 3608391008) strcat(s, "m");
if (crc32("nxkeiWgREzjSPrj",15) == 2360195027) strcat(s, "e");
if (crc32("uLpeKfeSqprh",12) == 2581212145) strcat(s, "e");
    return s;
}

char *Vanya_nouns() {
    char *s = calloc(6);
    if (crc32("cHPiPIBbscAf",12) == 3241631111) strcat(s, "Q");
if (crc32("FtWYbxZxt",9) == 850673324) strcat(s, "V");
if (crc32("fLqLbzwC",8) == 3935448929) strcat(s, "a");
if (crc32("tfihsAAB",8) == 1518726591) strcat(s, "n");
if (crc32("fenNsY",6) == 3642637284) strcat(s, "a");
if (crc32("qLznTpg",7) == 1345240521) strcat(s, "y");
if (crc32("vqaCSkoMRPqO",12) == 722272436) strcat(s, "J");
if (crc32("oMxSQqc",7) == 3434073424) strcat(s, "a");
    return s;
}

char *Capote_nouns() {
    char *s = calloc(7);
    if (crc32("WsRvFCDeGhXQ",12) == 464385503) strcat(s, "C");
if (crc32("JXvIAIwyUK",10) == 47820238) strcat(s, "a");
if (crc32("jTpoxQWoRfCCI",13) == 3982134459) strcat(s, "p");
if (crc32("dQclBYQ",7) == 2385442605) strcat(s, "o");
if (crc32("Rqaxtu",6) == 2255639023) strcat(s, "t");
if (crc32("qQrTqAmqNuUDkkU",15) == 3329472757) strcat(s, "e");
    return s;
}

char *Zephyrhills_nouns() {
    char *s = calloc(12);
    if (crc32("YEhmiUpHlJ",10) == 2518379329) strcat(s, "Y");
if (crc32("amwDZJTXlG",10) == 3728004148) strcat(s, "Z");
if (crc32("wgpvsbpIT",9) == 2951184769) strcat(s, "e");
if (crc32("iZsipZgMfzWYkBH",15) == 1735675766) strcat(s, "Z");
if (crc32("YrITuittrBPIF",13) == 3377725069) strcat(s, "p");
if (crc32("iRXSwIQmvcVI",12) == 967968334) strcat(s, "h");
if (crc32("jFpRiZBOgkc",11) == 3769434391) strcat(s, "y");
if (crc32("JNSDuaLXn",9) == 738631367) strcat(s, "u");
if (crc32("SnfmI",5) == 4049705338) strcat(s, "r");
if (crc32("wAfxJzPgMugtVm",14) == 2655737776) strcat(s, "E");
if (crc32("MWqZuoHoXkrEr",13) == 2434911772) strcat(s, "h");
if (crc32("idsmePTil",9) == 718526284) strcat(s, "i");
if (crc32("OFTYFO",6) == 2314984010) strcat(s, "E");
if (crc32("PNXaHdgQooBxJt",14) == 492400881) strcat(s, "l");
if (crc32("FOcHrpofOJJ",11) == 4098778584) strcat(s, "h");
if (crc32("QHkiRutaEy",10) == 978498435) strcat(s, "l");
if (crc32("SNkyNc",6) == 4186075220) strcat(s, "O");
if (crc32("ZYEJaAuKtnQw",12) == 3697385591) strcat(s, "s");
    return s;
}

char *backswimmer_nouns() {
    char *s = calloc(12);
    if (crc32("fXPgruNwMmX",11) == 768291389) strcat(s, "b");
if (crc32("DtaCSysv",8) == 868553871) strcat(s, "a");
if (crc32("QkoVQQfpDSiCR",13) == 2274600070) strcat(s, "c");
if (crc32("VZCzLi",6) == 75232331) strcat(s, "J");
if (crc32("LasepgGoEreS",12) == 776289720) strcat(s, "k");
if (crc32("fFRHrBdMjQjk",12) == 2111184782) strcat(s, "B");
if (crc32("WTrTUJgc",8) == 435886039) strcat(s, "s");
if (crc32("rCGaHPMJOKVjx",13) == 3612335744) strcat(s, "w");
if (crc32("LCxVULXsEVntz",13) == 1043929375) strcat(s, "i");
if (crc32("NFCCl",5) == 1913787640) strcat(s, "i");
if (crc32("SejwSFchVmEGwa",14) == 2907048554) strcat(s, "m");
if (crc32("lrJTTnhfvks",11) == 3160792837) strcat(s, "t");
if (crc32("EwJGtzzOBvQLlxK",15) == 3321825692) strcat(s, "m");
if (crc32("FnItMZdAdMJr",12) == 3533259738) strcat(s, "e");
if (crc32("TQRllwg",7) == 3785975700) strcat(s, "U");
if (crc32("OLIFOwncBKTV",12) == 239399028) strcat(s, "r");
    return s;
}

char *Skiest_nouns() {
    char *s = calloc(7);
    if (crc32("ZUEGdQRKzalCa",13) == 2583864632) strcat(s, "S");
if (crc32("UCcoAwduEkCMKrV",15) == 3110425509) strcat(s, "k");
if (crc32("xBYYNVirXm",10) == 3631177067) strcat(s, "i");
if (crc32("RJCaPvF",7) == 1553039152) strcat(s, "r");
if (crc32("riroCNMLx",9) == 1801835235) strcat(s, "e");
if (crc32("BipdGBzeQy",10) == 2854595633) strcat(s, "s");
if (crc32("YCvTzvyf",8) == 2913513444) strcat(s, "o");
if (crc32("HLrSdduSLq",10) == 470525907) strcat(s, "t");
    return s;
}

char *benzosulfimide_nouns() {
    char *s = calloc(15);
    if (crc32("mPBYFNIHXpSEzd",14) == 3516303279) strcat(s, "b");
if (crc32("VdLkPAhTtIYxS",13) == 800464626) strcat(s, "E");
if (crc32("zhiVcgw",7) == 3856397544) strcat(s, "e");
if (crc32("vccrFSTVRN",10) == 3416621902) strcat(s, "n");
if (crc32("xgYZzSOc",8) == 3297122891) strcat(s, "z");
if (crc32("BLzBxTMbYSgw",12) == 1586181485) strcat(s, "B");
if (crc32("EBnloRm",7) == 1714946430) strcat(s, "o");
if (crc32("WGkkPDZaRVha",12) == 2976344562) strcat(s, "j");
if (crc32("zSPZYehOIDl",11) == 3095822335) strcat(s, "s");
if (crc32("jCsIYa",6) == 1358143976) strcat(s, "u");
if (crc32("XTrVMAIptmXs",12) == 3764782502) strcat(s, "T");
if (crc32("XBHbhrGbdW",10) == 2177313401) strcat(s, "l");
if (crc32("pmIBzuZ",7) == 3588050573) strcat(s, "n");
if (crc32("iuypylNrwOVISNj",15) == 151043279) strcat(s, "f");
if (crc32("YbsKByUKoqRG",12) == 2107610559) strcat(s, "D");
if (crc32("xcBjYiArPjUaFDZ",15) == 1794933962) strcat(s, "i");
if (crc32("oduYOBgUudv",11) == 4062939696) strcat(s, "F");
if (crc32("kmBdSIU",7) == 1652584774) strcat(s, "m");
if (crc32("YKNiU",5) == 1614409017) strcat(s, "F");
if (crc32("YkgUJtuFYPOJs",13) == 3168571976) strcat(s, "i");
if (crc32("wiJhXaNEuKyPhg",14) == 1551261850) strcat(s, "d");
if (crc32("lnlQM",5) == 3685358105) strcat(s, "T");
if (crc32("MdtrFdKAh",9) == 1988837119) strcat(s, "e");
    return s;
}

char *rigol_nouns() {
    char *s = calloc(6);
    if (crc32("wzYcSQldIEwtYBk",15) == 2693961285) strcat(s, "r");
if (crc32("DefpHNalVUo",11) == 554075592) strcat(s, "q");
if (crc32("TWimneRHZW",10) == 2843281537) strcat(s, "i");
if (crc32("NxQvLtJT",8) == 3613498249) strcat(s, "b");
if (crc32("FoYVKWKO",8) == 3153356445) strcat(s, "g");
if (crc32("iXVpBFCbtd",10) == 781089128) strcat(s, "o");
if (crc32("armpemM",7) == 910132197) strcat(s, "e");
if (crc32("YxFCAT",6) == 438733891) strcat(s, "l");
    return s;
}

char *os_nouns() {
    char *s = calloc(3);
    if (crc32("ygCOSzKHbvPT",12) == 2084355000) strcat(s, "L");
if (crc32("snBimASvTnVc",12) == 726325321) strcat(s, "o");
if (crc32("anmTsAIaUtOsfuJ",15) == 2941651585) strcat(s, "s");
    return s;
}

char *Crompton_nouns() {
    char *s = calloc(9);
    if (crc32("tmZyAEFXH",9) == 470544279) strcat(s, "C");
if (crc32("YfTfysYQbRvJ",12) == 2901829748) strcat(s, "r");
if (crc32("HGaHV",5) == 2688970365) strcat(s, "r");
if (crc32("icEeDuqU",8) == 1979111806) strcat(s, "o");
if (crc32("yUAAEhaHYtHUNs",14) == 2102933959) strcat(s, "m");
if (crc32("uMEsXBqln",9) == 2049908374) strcat(s, "p");
if (crc32("xuOMc",5) == 3117139946) strcat(s, "t");
if (crc32("cnUElVWsQhSj",12) == 2143328049) strcat(s, "d");
if (crc32("Apxol",5) == 873285003) strcat(s, "o");
if (crc32("HPGVysMux",9) == 2617151898) strcat(s, "Z");
if (crc32("YiTmi",5) == 981968980) strcat(s, "n");
    return s;
}

char *Cushman_nouns() {
    char *s = calloc(8);
    if (crc32("NMztMKZFuNn",11) == 1958822042) strcat(s, "E");
if (crc32("PnHQx",5) == 2789208453) strcat(s, "C");
if (crc32("SkmrGyr",7) == 2027241932) strcat(s, "u");
if (crc32("gvUfEfsQvZ",10) == 2118824917) strcat(s, "c");
if (crc32("julUuxGfhPmxZOZ",15) == 2359895312) strcat(s, "s");
if (crc32("bkYmyQUehIXYBcc",15) == 1913058532) strcat(s, "h");
if (crc32("IxZqkaW",7) == 3351628443) strcat(s, "m");
if (crc32("qOVYSQnrTdcaUzt",15) == 3635541843) strcat(s, "f");
if (crc32("bTEjzi",6) == 827967616) strcat(s, "a");
if (crc32("BhXRV",5) == 2209818505) strcat(s, "s");
if (crc32("KGatRrGThtY",11) == 3266756305) strcat(s, "n");
    return s;
}

char *dinghy_nouns() {
    char *s = calloc(7);
    if (crc32("aROElsGlgbCJ",12) == 1815469238) strcat(s, "n");
if (crc32("yrEYOeMChvnvCZ",14) == 326981620) strcat(s, "d");
if (crc32("XTxBr",5) == 3863056700) strcat(s, "x");
if (crc32("QwKgxsm",7) == 3939018974) strcat(s, "i");
if (crc32("BEdailnLNwbe",12) == 4289716234) strcat(s, "n");
if (crc32("yBArKENZ",8) == 2646544786) strcat(s, "g");
if (crc32("wRbFVrJg",8) == 3954270637) strcat(s, "P");
if (crc32("qMCRzOhqMj",10) == 4119845546) strcat(s, "h");
if (crc32("NhpfYiK",7) == 4110045530) strcat(s, "Q");
if (crc32("KFyDxfsyP",9) == 2899040527) strcat(s, "y");
    return s;
}

char *Cardinal_nouns() {
    char *s = calloc(9);
    if (crc32("RvjTJepzJSbxml",14) == 4060287230) strcat(s, "C");
if (crc32("HLSawbrEoJVWQz",14) == 3214009279) strcat(s, "a");
if (crc32("ZInpXE",6) == 58830329) strcat(s, "B");
if (crc32("LjwDLXpSEc",10) == 2484713547) strcat(s, "r");
if (crc32("jOCMjXiMIYG",11) == 755450639) strcat(s, "d");
if (crc32("HGjXxbOS",8) == 3751878985) strcat(s, "i");
if (crc32("dBwmNvIxTpbXM",13) == 857461945) strcat(s, "n");
if (crc32("hLwRHVudlJP",11) == 330260971) strcat(s, "d");
if (crc32("XFjCaiqjkuKT",12) == 2390774603) strcat(s, "a");
if (crc32("DTdqfqIYclxQllG",15) == 1587696396) strcat(s, "l");
    return s;
}

char *AlIskandaroyah_nouns() {
    char *s = calloc(15);
    if (crc32("RiWOKAgMQolrl",13) == 3619436470) strcat(s, "A");
if (crc32("kJaRqseqrhG",11) == 1918345035) strcat(s, "w");
if (crc32("eomHy",5) == 2781068435) strcat(s, "l");
if (crc32("FXNzEwZtAA",10) == 2929389745) strcat(s, "Q");
if (crc32("CrAYHiQMWk",10) == 1214826939) strcat(s, "I");
if (crc32("bEMmLyPqgvQk",12) == 3470913635) strcat(s, "F");
if (crc32("wZCrJ",5) == 3502023783) strcat(s, "s");
if (crc32("lhvrB",5) == 2983566743) strcat(s, "k");
if (crc32("VCVUtziihjHUPO",14) == 3610459361) strcat(s, "H");
if (crc32("pQqYqsQ",7) == 2301367392) strcat(s, "a");
if (crc32("fTbhHQMcsZ",10) == 3161597854) strcat(s, "r");
if (crc32("ORHTBSrnVzbE",12) == 1144229819) strcat(s, "n");
if (crc32("zJrwesPZhZfCYKR",15) == 2163756207) strcat(s, "d");
if (crc32("liKpIPyYsSk",11) == 1857490022) strcat(s, "d");
if (crc32("Yumaa",5) == 2431681809) strcat(s, "t");
if (crc32("AWWkn",5) == 2962978809) strcat(s, "a");
if (crc32("WSvdjBeUqb",10) == 2651913385) strcat(s, "r");
if (crc32("jEejTaHBaMYlt",13) == 3807940090) strcat(s, "f");
if (crc32("fKOfQBoJCfDzs",13) == 3458683618) strcat(s, "o");
if (crc32("MkBppHQOWfH",11) == 3898370846) strcat(s, "y");
if (crc32("MvotqSQW",8) == 1176824214) strcat(s, "a");
if (crc32("czlokyshyBjxSZl",15) == 3977117451) strcat(s, "h");
    return s;
}

char *territoriality_nouns() {
    char *s = calloc(15);
    if (crc32("yxvsuvHnhhQdFJh",15) == 858144255) strcat(s, "t");
if (crc32("JkZedgmxjZux",12) == 3887008132) strcat(s, "J");
if (crc32("bAJZhOStoQK",11) == 1099027687) strcat(s, "e");
if (crc32("IZnuLRC",7) == 2245068447) strcat(s, "r");
if (crc32("qeYVebzkmwTpsFi",15) == 3218998462) strcat(s, "r");
if (crc32("XSIAIYvDIdPFzdn",15) == 1116810938) strcat(s, "E");
if (crc32("NIjyHHIuLLH",11) == 937577064) strcat(s, "i");
if (crc32("MdHvZjAmcazMcon",15) == 661218054) strcat(s, "t");
if (crc32("QgCWZLBcIQV",11) == 4077676717) strcat(s, "o");
if (crc32("DbTxCQQcKkXyIEy",15) == 3138525732) strcat(s, "d");
if (crc32("OYSbTVHxGfvYPzL",15) == 2413172193) strcat(s, "r");
if (crc32("OMSRThFPivHnM",13) == 2831236714) strcat(s, "K");
if (crc32("VrjASdLFSfFaLNZ",15) == 94546777) strcat(s, "i");
if (crc32("ieKcrBSyWB",10) == 2639049915) strcat(s, "a");
if (crc32("iYJEbOnMENl",11) == 36478181) strcat(s, "P");
if (crc32("TbIFfpbTBcEL",12) == 2023502715) strcat(s, "l");
if (crc32("IBorDuiPhwYizf",14) == 3476022411) strcat(s, "V");
if (crc32("vTPDDtrZpNFHPM",14) == 2646649260) strcat(s, "i");
if (crc32("trTMBe",6) == 1641636845) strcat(s, "t");
if (crc32("KTjCXxbkUsMP",12) == 3626520559) strcat(s, "O");
if (crc32("RMkGqJXWoZRZ",12) == 3465489962) strcat(s, "y");
    return s;
}

char *Tom_nouns() {
    char *s = calloc(4);
    if (crc32("BSaLYdTURI",10) == 1129727886) strcat(s, "T");
if (crc32("aEfbEVbwkqYS",12) == 2448916991) strcat(s, "Z");
if (crc32("WkfnLST",7) == 1354111709) strcat(s, "o");
if (crc32("NHcLsonqDpYh",12) == 226537516) strcat(s, "m");
    return s;
}

char *symphile_nouns() {
    char *s = calloc(9);
    if (crc32("NeNyf",5) == 221360156) strcat(s, "s");
if (crc32("aYjKzJaurm",10) == 403502794) strcat(s, "G");
if (crc32("kzuWlyjCFKj",11) == 3962291417) strcat(s, "y");
if (crc32("DpJDpzwqcMo",11) == 3943975034) strcat(s, "l");
if (crc32("igKLPLJKpT",10) == 1542775243) strcat(s, "m");
if (crc32("BDUUGuIMBgsxuY",14) == 2116085923) strcat(s, "p");
if (crc32("fqBVM",5) == 2487299160) strcat(s, "h");
if (crc32("wskkGTyWziSEbp",14) == 3810219190) strcat(s, "i");
if (crc32("doDAgYo",7) == 1845529767) strcat(s, "l");
if (crc32("AwFdXd",6) == 4146614965) strcat(s, "e");
    return s;
}

char *shaman_nouns() {
    char *s = calloc(7);
    if (crc32("Zaoyb",5) == 701628103) strcat(s, "s");
if (crc32("rVstOKMNlaHUEtJ",15) == 108473056) strcat(s, "h");
if (crc32("vUrzoOTFWVb",11) == 4117326073) strcat(s, "j");
if (crc32("pTHVd",5) == 2737310924) strcat(s, "a");
if (crc32("nhslnk",6) == 858206410) strcat(s, "m");
if (crc32("kxubMqL",7) == 1656570725) strcat(s, "a");
if (crc32("mBvNunoUlKpzxc",14) == 1538389403) strcat(s, "C");
if (crc32("IlMdaq",6) == 3088291867) strcat(s, "n");
    return s;
}

char *interdestructiveness_nouns() {
    char *s = calloc(21);
    if (crc32("AitFAFoyMKDaD",13) == 1428901369) strcat(s, "V");
if (crc32("ymymNJZymy",10) == 1016024278) strcat(s, "i");
if (crc32("YoMyjvb",7) == 1472850883) strcat(s, "i");
if (crc32("rlLqUy",6) == 3238924878) strcat(s, "n");
if (crc32("glSlyRqsxZIJ",12) == 2498642277) strcat(s, "t");
if (crc32("kFOqpkJzz",9) == 3532733231) strcat(s, "p");
if (crc32("vzyCpi",6) == 2690763668) strcat(s, "e");
if (crc32("DmOfekGEvE",10) == 1751255416) strcat(s, "H");
if (crc32("BYfgZBdqycTDDK",14) == 3041364971) strcat(s, "r");
if (crc32("GoyrVaQgx",9) == 1207835553) strcat(s, "d");
if (crc32("ULgyyIgHrtL",11) == 2244931542) strcat(s, "b");
if (crc32("kAlMYCLchU",10) == 3092810870) strcat(s, "e");
if (crc32("usyIK",5) == 353347675) strcat(s, "s");
if (crc32("UXKgmRLkYD",10) == 921324091) strcat(s, "t");
if (crc32("hdrmfVbPOZvd",12) == 3121627632) strcat(s, "p");
if (crc32("LhEFKjbP",8) == 513471844) strcat(s, "r");
if (crc32("FvlEdzERScQUZ",13) == 3882939043) strcat(s, "u");
if (crc32("WpVVS",5) == 1369238724) strcat(s, "c");
if (crc32("dHVgsihCFRdlX",13) == 921695675) strcat(s, "t");
if (crc32("GtTyrrCEUAh",11) == 3104808584) strcat(s, "i");
if (crc32("jKzUJiMfvZrdi",13) == 1840430993) strcat(s, "Y");
if (crc32("QCIWXcNRHoQ",11) == 318075263) strcat(s, "v");
if (crc32("UXRdaCSXVETycox",15) == 667419507) strcat(s, "e");
if (crc32("JNNCGoJgJPLCxV",14) == 3396737462) strcat(s, "n");
if (crc32("BhcukirWYRAdEWJ",15) == 3052748669) strcat(s, "E");
if (crc32("nLUxdjxwCnDF",12) == 1694805844) strcat(s, "e");
if (crc32("nHwmfeNQmEFI",12) == 2257670042) strcat(s, "s");
if (crc32("cbDqiWuq",8) == 763619421) strcat(s, "s");
    return s;
}

char *nativism_nouns() {
    char *s = calloc(9);
    if (crc32("xAfbKYYNFzzUwSe",15) == 3311561739) strcat(s, "n");
if (crc32("BKsVkOmOgpGiO",13) == 2624255532) strcat(s, "C");
if (crc32("zsQVJzdw",8) == 2542560861) strcat(s, "a");
if (crc32("iQrzY",5) == 2980269812) strcat(s, "t");
if (crc32("UhGSxCL",7) == 3314653401) strcat(s, "i");
if (crc32("peWxl",5) == 4179228251) strcat(s, "v");
if (crc32("ujWDhZonPH",10) == 2696169969) strcat(s, "i");
if (crc32("soWtNAwiRxtvyB",14) == 3986378794) strcat(s, "g");
if (crc32("dOmrGddHehEP",12) == 3831730809) strcat(s, "s");
if (crc32("WJFoWjU",7) == 2362144146) strcat(s, "m");
    return s;
}

char *bushelful_nouns() {
    char *s = calloc(10);
    if (crc32("nhlActyHRCf",11) == 1779814902) strcat(s, "E");
if (crc32("KBLaGhxkl",9) == 500920916) strcat(s, "b");
if (crc32("mwpQzy",6) == 3021094151) strcat(s, "u");
if (crc32("QwceTAR",7) == 3677471320) strcat(s, "s");
if (crc32("TnNGIYaOZLI",11) == 2700761230) strcat(s, "K");
if (crc32("CFkQOIEmPFOT",12) == 4112460366) strcat(s, "h");
if (crc32("SUtKCDTmGfJn",12) == 2438125170) strcat(s, "e");
if (crc32("XGbDxiOhhQq",11) == 2902667185) strcat(s, "g");
if (crc32("nUqoWrHxQTfUW",13) == 397395204) strcat(s, "l");
if (crc32("kfSwubcsN",9) == 1574267087) strcat(s, "c");
if (crc32("xWyPLTesaft",11) == 1824416659) strcat(s, "f");
if (crc32("GPHfTzdEeO",10) == 3877751629) strcat(s, "u");
if (crc32("axrWQrCXYSuQ",12) == 2638470694) strcat(s, "l");
    return s;
}

char *pairmasts_nouns() {
    char *s = calloc(10);
    if (crc32("kkboqV",6) == 4095097300) strcat(s, "e");
if (crc32("mEARy",5) == 3678862679) strcat(s, "p");
if (crc32("fGHcsF",6) == 169869958) strcat(s, "a");
if (crc32("eRPdvI",6) == 1503586555) strcat(s, "i");
if (crc32("FBsjdYGG",8) == 1755385621) strcat(s, "B");
if (crc32("qrzDd",5) == 1141544115) strcat(s, "r");
if (crc32("hNZkZGYzX",9) == 1901163351) strcat(s, "n");
if (crc32("QHaqnVsg",8) == 3898347091) strcat(s, "m");
if (crc32("dZbqSJlvvc",10) == 270594999) strcat(s, "a");
if (crc32("dlFXihjpoYtrtEx",15) == 381260823) strcat(s, "l");
if (crc32("GeYsFuAhODJFT",13) == 1474851930) strcat(s, "s");
if (crc32("EHeOvcPiHnqK",12) == 4128405096) strcat(s, "w");
if (crc32("uyWEtFhLTnakX",13) == 115508371) strcat(s, "t");
if (crc32("YSLBnekOd",9) == 1898758043) strcat(s, "s");
    return s;
}

char *windmill_nouns() {
    char *s = calloc(9);
    if (crc32("MWXHTHN",7) == 1032399014) strcat(s, "w");
if (crc32("WjfYxkzm",8) == 4067645387) strcat(s, "i");
if (crc32("ETpCoT",6) == 3024364279) strcat(s, "n");
if (crc32("JqnukMCJQzhNa",13) == 3135693743) strcat(s, "J");
if (crc32("TPyASpRZHd",10) == 1910271441) strcat(s, "d");
if (crc32("IfNJYbdkGIOce",13) == 1045323136) strcat(s, "Q");
if (crc32("QjcKgAoPOrU",11) == 585069573) strcat(s, "m");
if (crc32("lSifV",5) == 3030752718) strcat(s, "n");
if (crc32("YntCDWEUlqhBZf",14) == 2271882946) strcat(s, "i");
if (crc32("NSJKuYkheR",10) == 4112030315) strcat(s, "F");
if (crc32("jwQQzkR",7) == 2286227490) strcat(s, "l");
if (crc32("dfIrTIhObd",10) == 57075002) strcat(s, "l");
    return s;
}

char *divergence_nouns() {
    char *s = calloc(11);
    if (crc32("gVuVPLosK",9) == 3001090792) strcat(s, "l");
if (crc32("tGqecVOgqTm",11) == 2197147503) strcat(s, "d");
if (crc32("aLfzzkgSHQfZBzT",15) == 959228614) strcat(s, "i");
if (crc32("NbJdw",5) == 36924567) strcat(s, "v");
if (crc32("MyCYUzGz",8) == 2045640305) strcat(s, "r");
if (crc32("HDGanfYFj",9) == 1022818983) strcat(s, "e");
if (crc32("thtkhxmEMWh",11) == 1013277888) strcat(s, "u");
if (crc32("aveCv",5) == 694180) strcat(s, "r");
if (crc32("FUNfwizZdfZsSw",14) == 2303689284) strcat(s, "f");
if (crc32("xjQrsG",6) == 1298098972) strcat(s, "g");
if (crc32("vnKQAwmFFr",10) == 2386900522) strcat(s, "f");
if (crc32("xuCsiiTSaX",10) == 1319691434) strcat(s, "e");
if (crc32("FOanTUyKWwN",11) == 55155151) strcat(s, "x");
if (crc32("tRaJujApHzNQL",13) == 1698009443) strcat(s, "n");
if (crc32("SsKnlWbPwFVX",12) == 2161368764) strcat(s, "e");
if (crc32("NQQAEY",6) == 481554916) strcat(s, "c");
if (crc32("MYyVZSivMKDBhq",14) == 2099720887) strcat(s, "q");
if (crc32("ktqAKlyXyh",10) == 353710531) strcat(s, "e");
    return s;
}

char *priest_nouns() {
    char *s = calloc(7);
    if (crc32("FUVkwmOQTjayT",13) == 3885203605) strcat(s, "p");
if (crc32("JJIZWYVD",8) == 3474455242) strcat(s, "r");
if (crc32("fpotaCvm",8) == 6086145) strcat(s, "t");
if (crc32("sNouKXMqUU",10) == 3527619499) strcat(s, "i");
if (crc32("EzlhYweMRdyawGt",15) == 4134735155) strcat(s, "e");
if (crc32("enmtlPn",7) == 2728359278) strcat(s, "s");
if (crc32("bmgfuRNcgQEn",12) == 1863284009) strcat(s, "t");
    return s;
}

char *longhead_nouns() {
    char *s = calloc(9);
    if (crc32("dskWHQpH",8) == 3479619173) strcat(s, "e");
if (crc32("ZkQgEyleygILoE",14) == 363176200) strcat(s, "l");
if (crc32("gbElhZhjnA",10) == 1480378413) strcat(s, "o");
if (crc32("mMbEVjIZSYiPplL",15) == 1033253904) strcat(s, "n");
if (crc32("qGzzjCsMZjL",11) == 2147856499) strcat(s, "g");
if (crc32("aMIuVziJJIXAa",13) == 996178426) strcat(s, "I");
if (crc32("Afqqcr",6) == 366942061) strcat(s, "h");
if (crc32("YHZrqBcVvhTN",12) == 3115846363) strcat(s, "w");
if (crc32("WmStbfXAcFRjf",13) == 1471630703) strcat(s, "e");
if (crc32("jSyzOmjLCC",10) == 329375944) strcat(s, "a");
if (crc32("mrxvNbvaEh",10) == 1359073636) strcat(s, "t");
if (crc32("QlSKdApeeNOQca",14) == 1087863493) strcat(s, "d");
    return s;
}

char *Dasirae_nouns() {
    char *s = calloc(8);
    if (crc32("MlaSPgrtjw",10) == 3636767066) strcat(s, "D");
if (crc32("PwzMwctizXNI",12) == 1099700807) strcat(s, "a");
if (crc32("fhRGmjFKJbZ",11) == 980211017) strcat(s, "g");
if (crc32("PjESO",5) == 2869834252) strcat(s, "s");
if (crc32("KZuaoQ",6) == 1292069845) strcat(s, "i");
if (crc32("TRmxdIdJFG",10) == 1763908671) strcat(s, "u");
if (crc32("qVgoKCxuKHBojSx",15) == 3752693079) strcat(s, "r");
if (crc32("WGcHGVr",7) == 3461234267) strcat(s, "a");
if (crc32("rmmErNFtFyReC",13) == 704013869) strcat(s, "t");
if (crc32("GOdXaJCeU",9) == 315598825) strcat(s, "e");
    return s;
}

char *fertileness_nouns() {
    char *s = calloc(12);
    if (crc32("keMKOKBf",8) == 2694884881) strcat(s, "d");
if (crc32("eCRGGuVMBfzN",12) == 1574110087) strcat(s, "f");
if (crc32("IlTwFMZC",8) == 2864179846) strcat(s, "e");
if (crc32("dRACSPDyQSe",11) == 3098625267) strcat(s, "M");
if (crc32("JlPSjARuTsAyFY",14) == 1213588289) strcat(s, "r");
if (crc32("ATDZhfj",7) == 969417954) strcat(s, "t");
if (crc32("qblYD",5) == 2058475608) strcat(s, "V");
if (crc32("hbYXFp",6) == 2484842022) strcat(s, "i");
if (crc32("dHiHyb",6) == 801266013) strcat(s, "l");
if (crc32("ULVUxiKoWSn",11) == 336844500) strcat(s, "e");
if (crc32("LnOhJt",6) == 580361729) strcat(s, "p");
if (crc32("kxfjIsP",7) == 2708934857) strcat(s, "n");
if (crc32("xSRkMIYFYYc",11) == 2762301460) strcat(s, "w");
if (crc32("vCoGGaWjwK",10) == 1396715878) strcat(s, "e");
if (crc32("CJWrE",5) == 1603599235) strcat(s, "s");
if (crc32("JjxyEtCwQG",10) == 1708787464) strcat(s, "s");
    return s;
}

char *coolabah_nouns() {
    char *s = calloc(9);
    if (crc32("JVKVxYB",7) == 2511967321) strcat(s, "T");
if (crc32("ZMQsj",5) == 435439203) strcat(s, "c");
if (crc32("BdtqQQfcywSR",12) == 169430938) strcat(s, "q");
if (crc32("OtVqHbhIXiuySq",14) == 3103713333) strcat(s, "o");
if (crc32("SErnZOzNy",9) == 708039464) strcat(s, "o");
if (crc32("YntBccf",7) == 709015088) strcat(s, "c");
if (crc32("QKAqtbI",7) == 3228713295) strcat(s, "l");
if (crc32("YPTaUCmFgOIE",12) == 3102395646) strcat(s, "k");
if (crc32("ZVBgRTtXjj",10) == 1359966895) strcat(s, "a");
if (crc32("HPaCsfJYcawgaY",14) == 3541710916) strcat(s, "h");
if (crc32("XqAslaYEgiuufXr",15) == 2231456104) strcat(s, "b");
if (crc32("HtgHVoEvq",9) == 595824458) strcat(s, "u");
if (crc32("WapJTrkEzP",10) == 2410798568) strcat(s, "a");
if (crc32("Uawjc",5) == 1051855917) strcat(s, "K");
if (crc32("EDkUugWVoTDsvo",14) == 3701492155) strcat(s, "h");
    return s;
}

char *sluggishness_nouns() {
    char *s = calloc(13);
    if (crc32("ceiTlWiKhryh",12) == 93181263) strcat(s, "y");
if (crc32("cUtCH",5) == 348655864) strcat(s, "s");
if (crc32("aVqqGdnrVF",10) == 3131122993) strcat(s, "O");
if (crc32("CAFZFxTHbMSKwh",14) == 3563016932) strcat(s, "l");
if (crc32("jbweBEhMhEKEG",13) == 4157590086) strcat(s, "X");
if (crc32("tBHYuyKVzvONLg",14) == 1491426601) strcat(s, "u");
if (crc32("NgxHSItlYdBCdXn",15) == 2133294766) strcat(s, "g");
if (crc32("cWgNZlojmw",10) == 3365123383) strcat(s, "g");
if (crc32("XjPrSRzgF",9) == 4182083775) strcat(s, "i");
if (crc32("fwEAjAWs",8) == 2035968339) strcat(s, "s");
if (crc32("qMecN",5) == 4198949818) strcat(s, "h");
if (crc32("cTVEj",5) == 344392561) strcat(s, "n");
if (crc32("IWfDXQmmvjt",11) == 4175756740) strcat(s, "e");
if (crc32("qEOCe",5) == 225137290) strcat(s, "T");
if (crc32("cpuEvwfKgPdbj",13) == 2455348341) strcat(s, "s");
if (crc32("cYlSmumVcjQ",11) == 3198862965) strcat(s, "K");
if (crc32("rOxyCHeSROJz",12) == 410149716) strcat(s, "s");
    return s;
}

char *devitalization_nouns() {
    char *s = calloc(15);
    if (crc32("TMunTuGcn",9) == 4014889159) strcat(s, "l");
if (crc32("TjJXNISVDEu",11) == 3743301907) strcat(s, "d");
if (crc32("YoAop",5) == 797500929) strcat(s, "F");
if (crc32("OpgmMnseeT",10) == 2584325921) strcat(s, "e");
if (crc32("MQUjJXi",7) == 2296517122) strcat(s, "n");
if (crc32("ZtTfQrvoJHRfVas",15) == 2148651963) strcat(s, "v");
if (crc32("oDLVeHKdHYeKEc",14) == 1973700444) strcat(s, "i");
if (crc32("wjnXKemiqznuRs",14) == 4154181756) strcat(s, "t");
if (crc32("jujGlr",6) == 2140297913) strcat(s, "a");
if (crc32("mSXSwpAzYY",10) == 4098326905) strcat(s, "l");
if (crc32("aVXdQupK",8) == 1460968389) strcat(s, "O");
if (crc32("vSFTJQrcfltELSc",15) == 1668234947) strcat(s, "i");
if (crc32("zcrFGkUEmenAxn",14) == 117895757) strcat(s, "z");
if (crc32("TZpKdg",6) == 4016302831) strcat(s, "S");
if (crc32("SHYaFXIDiuIboR",14) == 1441373795) strcat(s, "a");
if (crc32("pYPcj",5) == 3200726626) strcat(s, "a");
if (crc32("ZFTgFzlTDjNa",12) == 196033805) strcat(s, "t");
if (crc32("bdHTOthWQHEgH",13) == 3407404842) strcat(s, "s");
if (crc32("upblqBR",7) == 2818924189) strcat(s, "i");
if (crc32("yUAKmLDuPMQdc",13) == 2977794405) strcat(s, "m");
if (crc32("jPpot",5) == 1062288718) strcat(s, "o");
if (crc32("ymdoBKv",7) == 2264169395) strcat(s, "n");
    return s;
}

char *capriccio_nouns() {
    char *s = calloc(10);
    if (crc32("Kbphmxwg",8) == 2301718032) strcat(s, "Z");
if (crc32("DCJQaoGf",8) == 3445535295) strcat(s, "c");
if (crc32("FIomOBhsD",9) == 1813970279) strcat(s, "a");
if (crc32("rSfbiQua",8) == 1023169040) strcat(s, "m");
if (crc32("txvuoPmcdF",10) == 1602103591) strcat(s, "p");
if (crc32("lASTt",5) == 3452660012) strcat(s, "v");
if (crc32("ePYxgefyYo",10) == 2227320478) strcat(s, "r");
if (crc32("lTbyB",5) == 3366492978) strcat(s, "w");
if (crc32("DpWFwrRpHknd",12) == 2393331820) strcat(s, "i");
if (crc32("wfTCBixRQLVMVN",14) == 2430099255) strcat(s, "c");
if (crc32("MNQaISjw",8) == 3718830415) strcat(s, "h");
if (crc32("RZVLdRJuc",9) == 2963023657) strcat(s, "c");
if (crc32("HBBzjO",6) == 1643151511) strcat(s, "i");
if (crc32("cuJBM",5) == 4085166738) strcat(s, "o");
    return s;
}

char *author_nouns() {
    char *s = calloc(7);
    if (crc32("BNYAifHr",8) == 4157458959) strcat(s, "p");
if (crc32("FxmRqkFocFPHeeq",15) == 3119190549) strcat(s, "a");
if (crc32("cNDwLTzFlVYIO",13) == 2044296203) strcat(s, "u");
if (crc32("YGOWXuAhkI",10) == 926787583) strcat(s, "t");
if (crc32("AdAUPC",6) == 96810906) strcat(s, "h");
if (crc32("zsxUbfwkvqRW",12) == 3954964935) strcat(s, "o");
if (crc32("ztkvo",5) == 1912061632) strcat(s, "r");
    return s;
}

char *Lachman_nouns() {
    char *s = calloc(8);
    if (crc32("sgWetnwDO",9) == 3206636838) strcat(s, "L");
if (crc32("XUsjQVHZpiusSz",14) == 2930771826) strcat(s, "a");
if (crc32("uLpFfxcbhgsCoc",14) == 2768596098) strcat(s, "c");
if (crc32("rWsWwuOtddqXpDK",15) == 3356738288) strcat(s, "t");
if (crc32("qDqyX",5) == 3633899542) strcat(s, "h");
if (crc32("leXNzeYF",8) == 2192453350) strcat(s, "m");
if (crc32("tzPeDsCljFKdv",13) == 3427992347) strcat(s, "Q");
if (crc32("kOddeBsTlMVGdj",14) == 2567256629) strcat(s, "a");
if (crc32("qqjMjeMdEU",10) == 826069162) strcat(s, "n");
    return s;
}

char *Sadick_nouns() {
    char *s = calloc(7);
    if (crc32("XUjIzl",6) == 1339807442) strcat(s, "f");
if (crc32("sSrujmQzEwmtgsp",15) == 2942738034) strcat(s, "S");
if (crc32("gmquIUxynGz",11) == 349516296) strcat(s, "d");
if (crc32("KSVOgTIivF",10) == 1890032999) strcat(s, "a");
if (crc32("XTzQieS",7) == 2004143589) strcat(s, "d");
if (crc32("nRiZKjCSQdGVw",13) == 2868502000) strcat(s, "i");
if (crc32("YHIafPuhnUEoN",13) == 3075227049) strcat(s, "y");
if (crc32("cmotqOZQGodLQw",14) == 2352730706) strcat(s, "c");
if (crc32("zLuYSiDjNR",10) == 3425370638) strcat(s, "k");
    return s;
}

char *Maroc_nouns() {
    char *s = calloc(6);
    if (crc32("pVgzbzFTySTi",12) == 444365903) strcat(s, "o");
if (crc32("UyctInSZGG",10) == 1202886599) strcat(s, "M");
if (crc32("DxlpjfQXhe",10) == 1785923288) strcat(s, "a");
if (crc32("OuNVofpq",8) == 1891772589) strcat(s, "O");
if (crc32("KTLOOONabuXWL",13) == 2827541779) strcat(s, "r");
if (crc32("tXCJafBPJP",10) == 2068666284) strcat(s, "o");
if (crc32("KmHWeS",6) == 1749303227) strcat(s, "c");
    return s;
}

char *hardiness_nouns() {
    char *s = calloc(10);
    if (crc32("ecmxUwNXggcrsx",14) == 3445902307) strcat(s, "n");
if (crc32("dIMuB",5) == 4266951355) strcat(s, "h");
if (crc32("egdGvxVxVyaN",12) == 775808871) strcat(s, "a");
if (crc32("MFKLfSDflq",10) == 3957669050) strcat(s, "c");
if (crc32("ymyZusaTeEUKl",13) == 1298283890) strcat(s, "r");
if (crc32("UQxlDuDekoj",11) == 1511555925) strcat(s, "M");
if (crc32("UYyKFWwY",8) == 1759674955) strcat(s, "d");
if (crc32("JurhngCXTQZClm",14) == 969343191) strcat(s, "i");
if (crc32("hWENcj",6) == 3880383547) strcat(s, "C");
if (crc32("SEKeEKJKrGWoQzs",15) == 1760085469) strcat(s, "n");
if (crc32("KOTopJcjoHdpKTJ",15) == 2264131955) strcat(s, "L");
if (crc32("NKfJyH",6) == 1309214771) strcat(s, "e");
if (crc32("BDircPUVEo",10) == 1014648662) strcat(s, "s");
if (crc32("eyuIZcyyLUFASB",14) == 4044548503) strcat(s, "m");
if (crc32("vqNCdSrn",8) == 46035698) strcat(s, "s");
    return s;
}

char *improvement_nouns() {
    char *s = calloc(12);
    if (crc32("oJzrAorKnpyprY",14) == 4201659728) strcat(s, "N");
if (crc32("KHCIZIZgHNrJ",12) == 1841633358) strcat(s, "i");
if (crc32("ACfzeJz",7) == 1451838383) strcat(s, "I");
if (crc32("hqdhoUc",7) == 664213527) strcat(s, "m");
if (crc32("GMbUvALS",8) == 4233201418) strcat(s, "n");
if (crc32("eaWMqlcQti",10) == 1108337039) strcat(s, "p");
if (crc32("CRPyhfM",7) == 2250775835) strcat(s, "t");
if (crc32("nZdrEqetyql",11) == 1646993729) strcat(s, "r");
if (crc32("hZCwRADel",9) == 2699619206) strcat(s, "c");
if (crc32("xDIeeQgU",8) == 2205006866) strcat(s, "o");
if (crc32("rBRhCRuty",9) == 2123991433) strcat(s, "l");
if (crc32("cHTXADDGLWmDXQg",15) == 3500732567) strcat(s, "v");
if (crc32("wLKNRdoxdMjcsO",14) == 3932314330) strcat(s, "h");
if (crc32("onDOAPdCcEIDNX",14) == 804010550) strcat(s, "e");
if (crc32("LyLNeIKyaKtke",13) == 74086427) strcat(s, "A");
if (crc32("OdaaBlRjBeyrMLo",15) == 2749987737) strcat(s, "m");
if (crc32("icYipCe",7) == 3430047694) strcat(s, "e");
if (crc32("jVAYKfEJyrtiofi",15) == 1364624765) strcat(s, "n");
if (crc32("HyKwfVPkf",9) == 3590826450) strcat(s, "n");
if (crc32("gpuOiDpgZyC",11) == 2408360188) strcat(s, "D");
if (crc32("tQuBawiJwRYxyqn",15) == 1663662943) strcat(s, "t");
    return s;
}

char *evictor_nouns() {
    char *s = calloc(8);
    if (crc32("gTPyT",5) == 1461239127) strcat(s, "e");
if (crc32("qlQMQTNWZItTJ",13) == 371648293) strcat(s, "q");
if (crc32("UaIIHREw",8) == 1516687829) strcat(s, "v");
if (crc32("tzZnVwcADJbl",12) == 1363329511) strcat(s, "i");
if (crc32("hpaRVCdvnagHd",13) == 2228893041) strcat(s, "y");
if (crc32("aUGoqNFuc",9) == 2235834561) strcat(s, "c");
if (crc32("pZzjhAG",7) == 2096560930) strcat(s, "t");
if (crc32("vXBHwuHrEv",10) == 3617812778) strcat(s, "o");
if (crc32("EkhUY",5) == 698977023) strcat(s, "r");
    return s;
}

char *Mirella_nouns() {
    char *s = calloc(8);
    if (crc32("uGkNaWub",8) == 2656253775) strcat(s, "M");
if (crc32("RnTntUCrghAxmc",14) == 75987285) strcat(s, "i");
if (crc32("kWeoNkJIHnI",11) == 1412075226) strcat(s, "r");
if (crc32("dHeonMCltpPdBc",14) == 539537402) strcat(s, "e");
if (crc32("gUFPXlFA",8) == 3709706740) strcat(s, "t");
if (crc32("RgweSjaAHGNToo",14) == 1452457714) strcat(s, "l");
if (crc32("zfLCUtlTZNHdEO",14) == 3707133648) strcat(s, "u");
if (crc32("KmKoIlNpERL",11) == 1276398387) strcat(s, "l");
if (crc32("lmwPzVaDRhBfgA",14) == 3827468908) strcat(s, "a");
    return s;
}

char *swob_nouns() {
    char *s = calloc(5);
    if (crc32("cfZxBRoPrvePD",13) == 1815816282) strcat(s, "Y");
if (crc32("OBRmh",5) == 3516837485) strcat(s, "s");
if (crc32("mTGoQME",7) == 1447016829) strcat(s, "W");
if (crc32("RVdgPQJihx",10) == 205218830) strcat(s, "w");
if (crc32("yAvxPrNfbeg",11) == 2419879100) strcat(s, "c");
if (crc32("zquKzQMbQ",9) == 3414634421) strcat(s, "o");
if (crc32("dPDcsRtno",9) == 645512196) strcat(s, "b");
    return s;
}

char *pulka_nouns() {
    char *s = calloc(6);
    if (crc32("koNIoCguZfPQVR",14) == 3510767881) strcat(s, "j");
if (crc32("lIsiuTiqFS",10) == 3081830859) strcat(s, "p");
if (crc32("mEvmeKG",7) == 684950000) strcat(s, "D");
if (crc32("otbfL",5) == 1048837790) strcat(s, "u");
if (crc32("cWpFzV",6) == 4251057119) strcat(s, "l");
if (crc32("PKxkxOw",7) == 499227095) strcat(s, "k");
if (crc32("llIXHqXMVVsZsv",14) == 2722657264) strcat(s, "y");
if (crc32("cDWVMhMBjdFkH",13) == 3437701041) strcat(s, "a");
    return s;
}

char *selfreflection_nouns() {
    char *s = calloc(15);
    if (crc32("vVPtYOOArZ",10) == 2167289870) strcat(s, "s");
if (crc32("MROuiDgMCJbHoA",14) == 1162196857) strcat(s, "e");
if (crc32("GMLjgUYHVMvONo",14) == 4128126875) strcat(s, "z");
if (crc32("ICPIoQsgAELjR",13) == 269033297) strcat(s, "l");
if (crc32("suiJlekfA",9) == 1572753645) strcat(s, "f");
if (crc32("JknRxMqtqu",10) == 338522964) strcat(s, "r");
if (crc32("tFwXkrg",7) == 2949042977) strcat(s, "f");
if (crc32("rHncvvX",7) == 1185420520) strcat(s, "e");
if (crc32("ESMfF",5) == 1540601471) strcat(s, "f");
if (crc32("usyiv",5) == 3638804712) strcat(s, "l");
if (crc32("YahTsokChOxV",12) == 1680400037) strcat(s, "e");
if (crc32("hMzzyvLHLjIPrlH",15) == 201824608) strcat(s, "c");
if (crc32("QKrpMuOmPWgk",12) == 3929770245) strcat(s, "t");
if (crc32("Maagwdr",7) == 2543797785) strcat(s, "i");
if (crc32("bohuscshyOyTVB",14) == 696905441) strcat(s, "o");
if (crc32("vtfNjiKOxY",10) == 1223532039) strcat(s, "n");
    return s;
}

char *Karlene_nouns() {
    char *s = calloc(8);
    if (crc32("TzIatMvvv",9) == 323993005) strcat(s, "K");
if (crc32("ArbpiOILGMFjTHU",15) == 1414177476) strcat(s, "a");
if (crc32("pQrdI",5) == 363173052) strcat(s, "r");
if (crc32("BMHVJyVxLunEEJQ",15) == 88393201) strcat(s, "l");
if (crc32("CxrAq",5) == 1831388427) strcat(s, "v");
if (crc32("riJeI",5) == 1771672315) strcat(s, "e");
if (crc32("eCzdM",5) == 1321961211) strcat(s, "n");
if (crc32("qSMXXaVGpJEEp",13) == 2755160705) strcat(s, "f");
if (crc32("TtGkvMR",7) == 1283439652) strcat(s, "e");
    return s;
}

char *Kiernan_nouns() {
    char *s = calloc(8);
    if (crc32("ZKpOiPNNw",9) == 1912462179) strcat(s, "R");
if (crc32("Rkkviboi",8) == 877121640) strcat(s, "K");
if (crc32("EoKOzM",6) == 526082928) strcat(s, "i");
if (crc32("UnyfEIKGRYSPcGB",15) == 732193925) strcat(s, "e");
if (crc32("KSojB",5) == 1962021253) strcat(s, "r");
if (crc32("icZDNSNZ",8) == 1642211763) strcat(s, "o");
if (crc32("zLSiGWpvOd",10) == 1641225181) strcat(s, "n");
if (crc32("KCkWiuANejDKRo",14) == 1951225342) strcat(s, "w");
if (crc32("DWzmvXOQHrClt",13) == 932568813) strcat(s, "a");
if (crc32("DofHtoJMq",9) == 1174153509) strcat(s, "n");
if (crc32("GGPpcOrsZh",10) == 1546545482) strcat(s, "n");
    return s;
}

char *zool_nouns() {
    char *s = calloc(5);
    if (crc32("IhRnJZBgaXKlX",13) == 3341634760) strcat(s, "z");
if (crc32("OegdSgG",7) == 1959145065) strcat(s, "a");
if (crc32("FoWDmOUEr",9) == 3411476459) strcat(s, "o");
if (crc32("EisMRIjMCOmDx",13) == 3057611232) strcat(s, "o");
if (crc32("GlpsHSGHeHa",11) == 2295800860) strcat(s, "l");
    return s;
}

char *berm_nouns() {
    char *s = calloc(5);
    if (crc32("ynmOSGlLt",9) == 1223532565) strcat(s, "g");
if (crc32("GQehvCDdHRjuVQ",14) == 3802659421) strcat(s, "b");
if (crc32("MdFTtjFPPka",11) == 2232926623) strcat(s, "U");
if (crc32("yRicpx",6) == 2724342793) strcat(s, "e");
if (crc32("jFayjm",6) == 1072781052) strcat(s, "D");
if (crc32("ONaWSnDg",8) == 335738548) strcat(s, "r");
if (crc32("ArbVxhcOX",9) == 959009496) strcat(s, "U");
if (crc32("kudxY",5) == 3467548861) strcat(s, "m");
    return s;
}

char *floatation_nouns() {
    char *s = calloc(11);
    if (crc32("MPkzrxizzeqQvc",14) == 3171725446) strcat(s, "f");
if (crc32("icjNrt",6) == 3365432885) strcat(s, "g");
if (crc32("PhAUZWq",7) == 1888294088) strcat(s, "l");
if (crc32("DltVVz",6) == 2845078700) strcat(s, "o");
if (crc32("UYZZGReNyMte",12) == 2778875568) strcat(s, "a");
if (crc32("QjsCXVzmQRsE",12) == 2279717759) strcat(s, "t");
if (crc32("aswJU",5) == 3548517674) strcat(s, "I");
if (crc32("cCdTEvnM",8) == 536278139) strcat(s, "a");
if (crc32("LJQrihB",7) == 1576776996) strcat(s, "Q");
if (crc32("uhFgaqpKS",9) == 2950050127) strcat(s, "t");
if (crc32("UGBnRxYSStZ",11) == 983214958) strcat(s, "i");
if (crc32("NwdrObYpb",9) == 4132692199) strcat(s, "r");
if (crc32("MOBuCMFSyJqFzrI",15) == 594385769) strcat(s, "o");
if (crc32("TeoVjBs",7) == 2848489254) strcat(s, "n");
    return s;
}

char *Albniz_nouns() {
    char *s = calloc(7);
    if (crc32("eorWdnV",7) == 1579176979) strcat(s, "A");
if (crc32("epzKlNLSZ",9) == 898319236) strcat(s, "l");
if (crc32("KVQqHsAtsPQ",11) == 2764829967) strcat(s, "b");
if (crc32("apciaDmA",8) == 2385508733) strcat(s, "O");
if (crc32("YhrjDYnYxHkBqZ",14) == 3787562545) strcat(s, "n");
if (crc32("tbFOSPeWcuTLhI",14) == 1623410510) strcat(s, "V");
if (crc32("UnGxsTQr",8) == 1996911026) strcat(s, "i");
if (crc32("DvAyaQU",7) == 1917032030) strcat(s, "z");
    return s;
}

char *synovia_nouns() {
    char *s = calloc(8);
    if (crc32("rNAQwjqZHDoxFrP",15) == 1388175310) strcat(s, "s");
if (crc32("JskSsWwq",8) == 1249515684) strcat(s, "y");
if (crc32("raYxMujEDjcz",12) == 3053891292) strcat(s, "n");
if (crc32("SdXGwjlp",8) == 3784953405) strcat(s, "o");
if (crc32("wggXzpx",7) == 2893999959) strcat(s, "v");
if (crc32("MjaOG",5) == 3835058796) strcat(s, "i");
if (crc32("dhAzD",5) == 1921599854) strcat(s, "g");
if (crc32("LSiIdbIg",8) == 2119164134) strcat(s, "a");
    return s;
}

char *carvacrol_nouns() {
    char *s = calloc(10);
    if (crc32("Wroaavar",8) == 231590324) strcat(s, "c");
if (crc32("oaDDWAbp",8) == 2715545139) strcat(s, "V");
if (crc32("JkSXfYfFLbPDz",13) == 2329621166) strcat(s, "a");
if (crc32("CwXCTEkhjNmPGjq",15) == 1271162633) strcat(s, "d");
if (crc32("uhvXHkXyoDzpjq",14) == 4065802534) strcat(s, "r");
if (crc32("wzRlQkF",7) == 2964803520) strcat(s, "q");
if (crc32("NmEyrHzcZyy",11) == 1488488951) strcat(s, "v");
if (crc32("PjIqSy",6) == 1030833170) strcat(s, "K");
if (crc32("TUGrDZQxhFuIv",13) == 2546011785) strcat(s, "a");
if (crc32("pWIPpQFso",9) == 3007265407) strcat(s, "c");
if (crc32("vGHBUdDO",8) == 3412201125) strcat(s, "e");
if (crc32("sxhfPYqIbK",10) == 2103947319) strcat(s, "r");
if (crc32("SnjadjeeydAfVb",14) == 487526843) strcat(s, "o");
if (crc32("zzKcblEhHojh",12) == 1688789590) strcat(s, "G");
if (crc32("ioWpgRk",7) == 2224652835) strcat(s, "l");
    return s;
}

char *contraindicant_nouns() {
    char *s = calloc(15);
    if (crc32("lQzMl",5) == 2984571947) strcat(s, "c");
if (crc32("YjRlgQjXOZ",10) == 3114558128) strcat(s, "l");
if (crc32("gdemoP",6) == 225981970) strcat(s, "o");
if (crc32("TKMQP",5) == 2931491770) strcat(s, "Z");
if (crc32("oWTaEWnJmFjMvh",14) == 4019891420) strcat(s, "n");
if (crc32("PMsFidKFDotBZf",14) == 1271927739) strcat(s, "D");
if (crc32("QTiYJwMT",8) == 3171578004) strcat(s, "t");
if (crc32("TwwDYwxGj",9) == 1500669809) strcat(s, "r");
if (crc32("JOGZQ",5) == 3942683622) strcat(s, "i");
if (crc32("pZxtwMoSorCXhT",14) == 345932955) strcat(s, "a");
if (crc32("KwKPU",5) == 1697918764) strcat(s, "X");
if (crc32("ubOHR",5) == 2688325634) strcat(s, "i");
if (crc32("gtLLsiabGLEQku",14) == 2492265398) strcat(s, "Q");
if (crc32("NgplDqN",7) == 3294119920) strcat(s, "n");
if (crc32("FIsbCCDA",8) == 1538539686) strcat(s, "d");
if (crc32("WlDLNb",6) == 1547426449) strcat(s, "i");
if (crc32("wGhHvpic",8) == 3021923764) strcat(s, "c");
if (crc32("LSvORWLzUQZbVx",14) == 4054250297) strcat(s, "Y");
if (crc32("FMyxGgk",7) == 3593556663) strcat(s, "a");
if (crc32("gjqYcyguw",9) == 3886714898) strcat(s, "n");
if (crc32("gRKvQtTXHRcjoae",15) == 139155465) strcat(s, "t");
    return s;
}

char *prothalamion_nouns() {
    char *s = calloc(13);
    if (crc32("hBHXQJrLM",9) == 255695934) strcat(s, "p");
if (crc32("qpdQROWsAY",10) == 139970893) strcat(s, "S");
if (crc32("bRTjapeGzzjRhv",14) == 3116587219) strcat(s, "r");
if (crc32("jQAgYimwjJzUh",13) == 2936017686) strcat(s, "o");
if (crc32("NyaSuAmt",8) == 1707228336) strcat(s, "t");
if (crc32("XdKBxNbwOGBk",12) == 4233332743) strcat(s, "t");
if (crc32("cKeLrILjNyIVK",13) == 267706797) strcat(s, "B");
if (crc32("QmLLafprP",9) == 2876503321) strcat(s, "h");
if (crc32("TZQQztqIqffz",12) == 1767613876) strcat(s, "I");
if (crc32("lmYCPFLCDmx",11) == 2077983573) strcat(s, "a");
if (crc32("pNSlqAZwX",9) == 3293138969) strcat(s, "l");
if (crc32("BecIastakhj",11) == 642870103) strcat(s, "R");
if (crc32("yAzZs",5) == 3245748773) strcat(s, "a");
if (crc32("mSBeolKcVvJEn",13) == 3680011920) strcat(s, "m");
if (crc32("vvAyGb",6) == 2116546337) strcat(s, "i");
if (crc32("FyzQHtrSE",9) == 1004507994) strcat(s, "o");
if (crc32("MkxqZA",6) == 629331487) strcat(s, "C");
if (crc32("iAezaW",6) == 668859086) strcat(s, "n");
    return s;
}

char *Oralia_nouns() {
    char *s = calloc(7);
    if (crc32("wmDkgDNbq",9) == 3741003097) strcat(s, "O");
if (crc32("mycEr",5) == 3357767134) strcat(s, "r");
if (crc32("DJlnvkbjqYPsdhe",15) == 3434135460) strcat(s, "y");
if (crc32("GvriFnb",7) == 676513372) strcat(s, "a");
if (crc32("uWltR",5) == 3928164101) strcat(s, "N");
if (crc32("vreYAWB",7) == 2946048616) strcat(s, "l");
if (crc32("PWfqIlRMDIfvl",13) == 3233717924) strcat(s, "u");
if (crc32("yEBPYVzHVF",10) == 2688110056) strcat(s, "i");
if (crc32("dwEOnvJWYF",10) == 217203875) strcat(s, "j");
if (crc32("bVfnEheIyjRhXC",14) == 1136817718) strcat(s, "a");
    return s;
}

char *Friedrich_nouns() {
    char *s = calloc(10);
    if (crc32("voYuVhGlNmIjnf",14) == 1355688768) strcat(s, "F");
if (crc32("zxKnukSWCkUxGh",14) == 2223287239) strcat(s, "r");
if (crc32("xMSujCpepKZhWv",14) == 4101159292) strcat(s, "Y");
if (crc32("WzWfiRMCBQRzYJ",14) == 3616029298) strcat(s, "i");
if (crc32("XMCMvaHCCQlFuH",14) == 4188723636) strcat(s, "e");
if (crc32("wufZv",5) == 1917200914) strcat(s, "p");
if (crc32("eQSjlWDvKcDDmA",14) == 44083416) strcat(s, "d");
if (crc32("DuhtuR",6) == 1979520624) strcat(s, "k");
if (crc32("TfosOoCglxok",12) == 696375987) strcat(s, "r");
if (crc32("EmJDcZwFy",9) == 3912644692) strcat(s, "i");
if (crc32("InvZeGZ",7) == 3602453428) strcat(s, "c");
if (crc32("HfKzPSDRcY",10) == 694542270) strcat(s, "h");
    return s;
}

char *EF_nouns() {
    char *s = calloc(3);
    if (crc32("FNAzq",5) == 770044997) strcat(s, "D");
if (crc32("onppvfM",7) == 725035237) strcat(s, "E");
if (crc32("XFepxsAYThfu",12) == 4200811215) strcat(s, "F");
    return s;
}

char *Mechlin_nouns() {
    char *s = calloc(8);
    if (crc32("ZcbVAun",7) == 271009339) strcat(s, "M");
if (crc32("nygVKxpTDu",10) == 4064421111) strcat(s, "e");
if (crc32("xgtSWCtAhyMq",12) == 2353446219) strcat(s, "c");
if (crc32("kGwixZttk",9) == 3606347931) strcat(s, "L");
if (crc32("XFpurdP",7) == 3437978327) strcat(s, "h");
if (crc32("aFosUpJ",7) == 2088236621) strcat(s, "C");
if (crc32("YfTruSOcvDeeOx",14) == 1699529701) strcat(s, "l");
if (crc32("mGQXkwyyebJVUZJ",15) == 433822051) strcat(s, "L");
if (crc32("CPrZfcaPU",9) == 1436332289) strcat(s, "i");
if (crc32("QEGPonEy",8) == 1158213719) strcat(s, "n");
    return s;
}

char *violability_nouns() {
    char *s = calloc(12);
    if (crc32("gepQmEHd",8) == 4231585462) strcat(s, "z");
if (crc32("GKHjlwdxR",9) == 1911624010) strcat(s, "v");
if (crc32("zTFQRhbYrKStlTz",15) == 1120096811) strcat(s, "i");
if (crc32("eQZRkiTpeqLP",12) == 327740348) strcat(s, "o");
if (crc32("UfLbWs",6) == 1557358207) strcat(s, "g");
if (crc32("pBVtp",5) == 2106202280) strcat(s, "l");
if (crc32("tGNdYd",6) == 3725682051) strcat(s, "a");
if (crc32("KtSejViB",8) == 3263021753) strcat(s, "b");
if (crc32("DBnoIr",6) == 3474113954) strcat(s, "I");
if (crc32("jdCSKrMucPDXSG",14) == 3942229461) strcat(s, "i");
if (crc32("KSVJDHcZSeDL",12) == 3805622957) strcat(s, "a");
if (crc32("DqIYQBbQ",8) == 3568723921) strcat(s, "l");
if (crc32("DGJtpTQRzwy",11) == 488087836) strcat(s, "i");
if (crc32("YeKKvcCuSmKaq",13) == 969691980) strcat(s, "P");
if (crc32("oqtmWV",6) == 1601340857) strcat(s, "t");
if (crc32("bngQwoKLy",9) == 3424688792) strcat(s, "h");
if (crc32("EYKunM",6) == 912824645) strcat(s, "y");
    return s;
}

char *gammer_nouns() {
    char *s = calloc(7);
    if (crc32("hGMfbniQMusBA",13) == 2087998340) strcat(s, "C");
if (crc32("SYEHOggyaXUv",12) == 3994701257) strcat(s, "g");
if (crc32("RsPDtrOwKA",10) == 3776532145) strcat(s, "a");
if (crc32("VDhKLfubDVwDvbZ",15) == 1957239091) strcat(s, "u");
if (crc32("XkJjYDn",7) == 4107207641) strcat(s, "m");
if (crc32("mGPwFJNSUVnx",12) == 49911333) strcat(s, "j");
if (crc32("DgMLPFSShrXCnG",14) == 1571726209) strcat(s, "m");
if (crc32("FfoXyROhgME",11) == 2665793011) strcat(s, "e");
if (crc32("ckTEBxMcAyvBvV",14) == 518989982) strcat(s, "O");
if (crc32("aUraKE",6) == 528602934) strcat(s, "r");
    return s;
}

char *kmel_nouns() {
    char *s = calloc(5);
    if (crc32("eZgmsWY",7) == 3126061028) strcat(s, "k");
if (crc32("qPzpCzSBjM",10) == 3551018061) strcat(s, "B");
if (crc32("VZEfiz",6) == 4257860210) strcat(s, "m");
if (crc32("IuEcxcSDyHkyajX",15) == 1636726164) strcat(s, "d");
if (crc32("KoWdHtr",7) == 2539929703) strcat(s, "e");
if (crc32("ZKpUthzL",8) == 2541327146) strcat(s, "H");
if (crc32("HQzvklcPZab",11) == 50418073) strcat(s, "l");
    return s;
}

char *Yentai_nouns() {
    char *s = calloc(7);
    if (crc32("zfZXiyagD",9) == 1217974978) strcat(s, "B");
if (crc32("cqiMVKNB",8) == 2587890092) strcat(s, "Y");
if (crc32("sdUgGVGoEuOZvD",14) == 2337686861) strcat(s, "H");
if (crc32("uAAAE",5) == 1244957526) strcat(s, "e");
if (crc32("whBeLVjY",8) == 866054438) strcat(s, "X");
if (crc32("NUSsGl",6) == 5245168) strcat(s, "n");
if (crc32("BAkmIG",6) == 4092228403) strcat(s, "t");
if (crc32("SKguYKtaSaVC",12) == 2634410844) strcat(s, "G");
if (crc32("KONFXGMHLeL",11) == 3929667398) strcat(s, "a");
if (crc32("ItBPeFiPL",9) == 4119511592) strcat(s, "K");
if (crc32("jwQfdRsAovu",11) == 119582251) strcat(s, "i");
    return s;
}

char *Mathewson_nouns() {
    char *s = calloc(10);
    if (crc32("GYrVmV",6) == 1841360371) strcat(s, "M");
if (crc32("WVWLseBwJ",9) == 3396885569) strcat(s, "a");
if (crc32("jZubSqX",7) == 1683559764) strcat(s, "B");
if (crc32("ULZJw",5) == 1120909397) strcat(s, "t");
if (crc32("NNTxg",5) == 95403858) strcat(s, "h");
if (crc32("fyuRHADZboDKOZt",15) == 3066689334) strcat(s, "e");
if (crc32("iXoFNQTtGazfAUl",15) == 3387387160) strcat(s, "w");
if (crc32("IgTnQ",5) == 4099061458) strcat(s, "u");
if (crc32("bVEzLBjmgkkSQN",14) == 898159702) strcat(s, "s");
if (crc32("FTTuEWy",7) == 4060259086) strcat(s, "o");
if (crc32("fKQZjBrw",8) == 1949756108) strcat(s, "o");
if (crc32("qbospILFOPBCWZ",14) == 18683796) strcat(s, "Z");
if (crc32("cwjnez",6) == 3403159045) strcat(s, "n");
    return s;
}

char *hypotenuse_nouns() {
    char *s = calloc(11);
    if (crc32("DdcaZVLUM",9) == 1657013743) strcat(s, "h");
if (crc32("eKvEOR",6) == 207193451) strcat(s, "y");
if (crc32("UIHvBDeacKkk",12) == 1384011148) strcat(s, "p");
if (crc32("DBKopmBuohQ",11) == 1288588052) strcat(s, "m");
if (crc32("hhMlZP",6) == 4289414806) strcat(s, "o");
if (crc32("UrWTX",5) == 3705224182) strcat(s, "A");
if (crc32("sMLiwjGqk",9) == 3071753607) strcat(s, "t");
if (crc32("wvCtIfYn",8) == 3948655897) strcat(s, "k");
if (crc32("RffURpLdQq",10) == 3025226228) strcat(s, "e");
if (crc32("beulURR",7) == 4263630858) strcat(s, "n");
if (crc32("kVSatuBesBBQc",13) == 117127613) strcat(s, "j");
if (crc32("tLPdyB",6) == 1586419041) strcat(s, "u");
if (crc32("QtTTnOJYIFHa",12) == 2687987095) strcat(s, "Y");
if (crc32("nwSBVsZjA",9) == 3047940616) strcat(s, "s");
if (crc32("GgMvKUkprKITDd",14) == 975996283) strcat(s, "H");
if (crc32("emRntgok",8) == 3788249493) strcat(s, "e");
    return s;
}

char *Trudey_nouns() {
    char *s = calloc(7);
    if (crc32("ZQzvgL",6) == 411879560) strcat(s, "T");
if (crc32("PouiCbNXlKj",11) == 2960170256) strcat(s, "a");
if (crc32("VWQSzhhreK",10) == 2577056951) strcat(s, "r");
if (crc32("qOeUZGvx",8) == 2159468294) strcat(s, "L");
if (crc32("wcpaMVHRTfUQQCr",15) == 3942291149) strcat(s, "u");
if (crc32("ZePdAFaRkhXCTI",14) == 2125078376) strcat(s, "j");
if (crc32("YUZBbavyHWtv",12) == 3731637885) strcat(s, "d");
if (crc32("ZjZrL",5) == 2924947630) strcat(s, "I");
if (crc32("UCaYfPXfEOMBoe",14) == 1119168975) strcat(s, "e");
if (crc32("plQozFjQsZkC",12) == 871086010) strcat(s, "q");
if (crc32("DEPjp",5) == 1680899386) strcat(s, "y");
    return s;
}

char *joblessness_nouns() {
    char *s = calloc(12);
    if (crc32("wjpaHCQ",7) == 3728067730) strcat(s, "j");
if (crc32("aiMVjNQaPhxaV",13) == 3677738083) strcat(s, "C");
if (crc32("kIwSzZM",7) == 3214894371) strcat(s, "o");
if (crc32("VPmzNbkUqGXr",12) == 2544401202) strcat(s, "c");
if (crc32("cXErs",5) == 3026037012) strcat(s, "b");
if (crc32("ZJUKLOxD",8) == 244101443) strcat(s, "l");
if (crc32("sTpBcSPa",8) == 2115061448) strcat(s, "e");
if (crc32("Zxsdjjsw",8) == 1156552690) strcat(s, "s");
if (crc32("vchsgawxZxkiITI",15) == 3470009627) strcat(s, "s");
if (crc32("OKfjU",5) == 860738698) strcat(s, "U");
if (crc32("uyVuxTX",7) == 86404672) strcat(s, "n");
if (crc32("VGVMDphNKTQh",12) == 913166711) strcat(s, "g");
if (crc32("urwIdCVjAVWy",12) == 3095124726) strcat(s, "e");
if (crc32("JuaDAUwctQzip",13) == 949509729) strcat(s, "b");
if (crc32("LFJbIdQ",7) == 639381484) strcat(s, "s");
if (crc32("diGzRqcln",9) == 2363247846) strcat(s, "l");
if (crc32("jRGfNXxsfsY",11) == 3595877090) strcat(s, "s");
    return s;
}

char *conservation_nouns() {
    char *s = calloc(13);
    if (crc32("pTihVvr",7) == 29250891) strcat(s, "M");
if (crc32("Wffcxol",7) == 1724997107) strcat(s, "c");
if (crc32("RbSvmuoANuDrNj",14) == 3580317972) strcat(s, "o");
if (crc32("yobvANnDDgeFK",13) == 1229188384) strcat(s, "p");
if (crc32("jzUWZSQO",8) == 904407515) strcat(s, "n");
if (crc32("lQnLiambXKwU",12) == 1223160775) strcat(s, "M");
if (crc32("gfmGrvIjGAPHaQ",14) == 367181507) strcat(s, "s");
if (crc32("HpSKTWpm",8) == 2271524131) strcat(s, "K");
if (crc32("hkJUPVydtr",10) == 558905642) strcat(s, "e");
if (crc32("fJELsAPNoBv",11) == 671668962) strcat(s, "e");
if (crc32("oipfybGzgfwgljy",15) == 3285323401) strcat(s, "r");
if (crc32("FdLMnP",6) == 1934595808) strcat(s, "U");
if (crc32("vEQztWRhWMdIA",13) == 3410778796) strcat(s, "v");
if (crc32("PmHGj",5) == 1537972980) strcat(s, "a");
if (crc32("zUkocx",6) == 1412100810) strcat(s, "t");
if (crc32("dWBvBinkJoueT",13) == 761548545) strcat(s, "i");
if (crc32("lJyJIc",6) == 4025245653) strcat(s, "L");
if (crc32("jlrhRagmTNxlC",13) == 38246547) strcat(s, "o");
if (crc32("ugWlcxunchIV",12) == 1873211907) strcat(s, "n");
    return s;
}

char *pluviosity_nouns() {
    char *s = calloc(11);
    if (crc32("oiymHSfoS",9) == 2324372295) strcat(s, "p");
if (crc32("WksypwvtfJiGog",14) == 4275396788) strcat(s, "P");
if (crc32("wUuhuPj",7) == 1655072613) strcat(s, "l");
if (crc32("ymtOV",5) == 4288665281) strcat(s, "F");
if (crc32("adjzMlqNsudHmkD",15) == 1303668577) strcat(s, "u");
if (crc32("WgcPdawqsdJ",11) == 3721609240) strcat(s, "M");
if (crc32("YozUzYPzxHoYtvB",15) == 3840417721) strcat(s, "v");
if (crc32("zVQizSYwoOXXRm",14) == 4047511712) strcat(s, "i");
if (crc32("nuZIRhb",7) == 3893735276) strcat(s, "o");
if (crc32("iVoHzXL",7) == 1211734669) strcat(s, "s");
if (crc32("brmgesmleToYPv",14) == 3337960155) strcat(s, "i");
if (crc32("UhffTkdo",8) == 3558023357) strcat(s, "t");
if (crc32("wWZpqYeHSzAq",12) == 2359587272) strcat(s, "y");
    return s;
}

char *Zilvia_nouns() {
    char *s = calloc(7);
    if (crc32("OcJLSbOSb",9) == 3616845323) strcat(s, "F");
if (crc32("jBAeOAV",7) == 2315079938) strcat(s, "Z");
if (crc32("gyFnw",5) == 3121602706) strcat(s, "i");
if (crc32("lpRYps",6) == 3837409009) strcat(s, "y");
if (crc32("OlDIGEcOKUaXf",13) == 1869024762) strcat(s, "l");
if (crc32("grYpAYCatzwe",12) == 1851659258) strcat(s, "i");
if (crc32("vqlYw",5) == 2280002893) strcat(s, "v");
if (crc32("KsvRMdqEQsx",11) == 4267307009) strcat(s, "i");
if (crc32("qKmkfhSMchh",11) == 2886510137) strcat(s, "a");
    return s;
}

char *pulsejet_nouns() {
    char *s = calloc(9);
    if (crc32("fedHMdge",8) == 1611317368) strcat(s, "p");
if (crc32("FANiUWCJDJJLMt",14) == 1732900722) strcat(s, "r");
if (crc32("FVnJwVtcoTXPct",14) == 4231982182) strcat(s, "u");
if (crc32("LgHkDA",6) == 1839624189) strcat(s, "l");
if (crc32("AqslRgagFVpymXx",15) == 89150842) strcat(s, "s");
if (crc32("yLkoTNHJvynsB",13) == 4216019111) strcat(s, "o");
if (crc32("pBWQdgyes",9) == 475524108) strcat(s, "e");
if (crc32("DPVIhEbvJD",10) == 2710072500) strcat(s, "Q");
if (crc32("rdFwXYLgkrtQBk",14) == 680252914) strcat(s, "j");
if (crc32("tQUmH",5) == 2078468550) strcat(s, "e");
if (crc32("Gubcbjkdlvo",11) == 1950987738) strcat(s, "T");
if (crc32("EoxZUwmSDvtpPxF",15) == 3071540693) strcat(s, "t");
    return s;
}

char *moonbow_nouns() {
    char *s = calloc(8);
    if (crc32("hjgaSFdXdJg",11) == 1544158273) strcat(s, "H");
if (crc32("XxbMXyAUgg",10) == 294301380) strcat(s, "m");
if (crc32("AmPQPghjYnaoJ",13) == 2618356373) strcat(s, "z");
if (crc32("cjLqCcedR",9) == 2100377873) strcat(s, "o");
if (crc32("tlvjktaQPuMV",12) == 970495039) strcat(s, "o");
if (crc32("bWCSyqiDOtHPHr",14) == 3135191992) strcat(s, "n");
if (crc32("nBzuFxKzeIcbPGS",15) == 3461175815) strcat(s, "O");
if (crc32("pXvchSZn",8) == 2694298860) strcat(s, "b");
if (crc32("pSgLicBVHm",10) == 675761095) strcat(s, "I");
if (crc32("fWjzpElGaQY",11) == 1829594026) strcat(s, "o");
if (crc32("ifLmcwWZmrgMUz",14) == 2190104089) strcat(s, "c");
if (crc32("cgELFdUqNEG",11) == 4089547458) strcat(s, "w");
    return s;
}

char *paraboloid_nouns() {
    char *s = calloc(11);
    if (crc32("XkeNmNn",7) == 3985633474) strcat(s, "T");
if (crc32("UhTmU",5) == 1755602615) strcat(s, "p");
if (crc32("ZQHOKzTiRVc",11) == 48055852) strcat(s, "a");
if (crc32("gxgcrxng",8) == 412367317) strcat(s, "r");
if (crc32("jqQfqj",6) == 2025282372) strcat(s, "a");
if (crc32("GrjrDxCmz",9) == 1534378853) strcat(s, "F");
if (crc32("RPTIXyTDYB",10) == 4170105231) strcat(s, "b");
if (crc32("ABmmEHmReRwruD",14) == 2167487145) strcat(s, "a");
if (crc32("dEZivYPqe",9) == 2305967731) strcat(s, "o");
if (crc32("ValltgsCXpbpT",13) == 3437375620) strcat(s, "l");
if (crc32("dKEukt",6) == 571834442) strcat(s, "o");
if (crc32("qmWCgY",6) == 202628233) strcat(s, "i");
if (crc32("DZoaTGQtnV",10) == 2399868290) strcat(s, "b");
if (crc32("lBAQyzIcefRTJqA",15) == 3023459118) strcat(s, "d");
    return s;
}

char *typeface_nouns() {
    char *s = calloc(9);
    if (crc32("UNaJiZjAqrDFZe",14) == 3606665819) strcat(s, "G");
if (crc32("oCspIqmCgTt",11) == 2240895744) strcat(s, "t");
if (crc32("qVYQUeeHVxbttqB",15) == 285401811) strcat(s, "y");
if (crc32("UysjtbcbqDpV",12) == 4008714384) strcat(s, "z");
if (crc32("yvsAqPQzgjIC",12) == 444003018) strcat(s, "p");
if (crc32("qTpyPpheJ",9) == 1608470618) strcat(s, "T");
if (crc32("CuurcGkwwfF",11) == 765686829) strcat(s, "e");
if (crc32("hgiqy",5) == 2336654376) strcat(s, "a");
if (crc32("OlNccxIDwIUOW",13) == 474591541) strcat(s, "f");
if (crc32("hhyXkfThqVXo",12) == 2754608672) strcat(s, "T");
if (crc32("EZgUHRkbclhAIuM",15) == 4222987313) strcat(s, "a");
if (crc32("lzttPoeVxR",10) == 2662730158) strcat(s, "h");
if (crc32("dgiRFFXo",8) == 2008915068) strcat(s, "c");
if (crc32("HkJrNJsTe",9) == 243337822) strcat(s, "e");
    return s;
}

char *pneumatograph_nouns() {
    char *s = calloc(14);
    if (crc32("VHQnZNxleAGc",12) == 2066582341) strcat(s, "p");
if (crc32("KLlWFD",6) == 3497673966) strcat(s, "d");
if (crc32("klNwreILXQO",11) == 3824142648) strcat(s, "n");
if (crc32("bfztQfjIuyXMWt",14) == 1408495740) strcat(s, "k");
if (crc32("wxESnFhDkbu",11) == 2587231461) strcat(s, "e");
if (crc32("SgpKogDVDeQ",11) == 1708883499) strcat(s, "u");
if (crc32("pFNlqAlBByeBGwS",15) == 3846417403) strcat(s, "m");
if (crc32("CDhPOtlsAcBmF",13) == 19033382) strcat(s, "C");
if (crc32("aYPWzm",6) == 54815720) strcat(s, "a");
if (crc32("pICcBg",6) == 1034603916) strcat(s, "t");
if (crc32("qucFy",5) == 2602187438) strcat(s, "o");
if (crc32("bXWmQCjidDmbK",13) == 4041912809) strcat(s, "s");
if (crc32("JLDDiIxCZ",9) == 2403126474) strcat(s, "g");
if (crc32("OotqsQG",7) == 351504568) strcat(s, "r");
if (crc32("xRNVCSxYAEnubv",14) == 4157234221) strcat(s, "B");
if (crc32("NyjIh",5) == 272936435) strcat(s, "a");
if (crc32("wKGhQ",5) == 3686834481) strcat(s, "T");
if (crc32("xRgwCPtob",9) == 607671393) strcat(s, "p");
if (crc32("aKsQxe",6) == 3467269808) strcat(s, "O");
if (crc32("jMrdC",5) == 3320781478) strcat(s, "h");
    return s;
}

char *dauk_nouns() {
    char *s = calloc(5);
    if (crc32("RXfPxhSEyClG",12) == 1606222348) strcat(s, "d");
if (crc32("pGkBUONXcL",10) == 1595631768) strcat(s, "a");
if (crc32("umpuMxwhuiB",11) == 3722624627) strcat(s, "u");
if (crc32("cTwPaWXmPIut",12) == 2009078625) strcat(s, "G");
if (crc32("HMtSr",5) == 3149576830) strcat(s, "k");
    return s;
}

char *Lathrop_nouns() {
    char *s = calloc(8);
    if (crc32("VjyKufCDoh",10) == 2038262825) strcat(s, "L");
if (crc32("DCVhyjxy",8) == 1405825146) strcat(s, "a");
if (crc32("KfACBGBfRmJJB",13) == 1254592476) strcat(s, "t");
if (crc32("eRXbJsuxSXYpTyQ",15) == 1662165907) strcat(s, "x");
if (crc32("xDkDCBqtODgs",12) == 2055569184) strcat(s, "h");
if (crc32("FvpSKDJ",7) == 963998156) strcat(s, "r");
if (crc32("IjdDMVXmRNL",11) == 3969114089) strcat(s, "o");
if (crc32("sZFwLLg",7) == 976784323) strcat(s, "p");
    return s;
}

char *ducktail_nouns() {
    char *s = calloc(9);
    if (crc32("rSifoXEGVsC",11) == 4054552672) strcat(s, "d");
if (crc32("ysadBD",6) == 1546075169) strcat(s, "u");
if (crc32("NHWWq",5) == 1079447593) strcat(s, "T");
if (crc32("UOkqDfXmEPXoG",13) == 832459024) strcat(s, "c");
if (crc32("YzGNNRhdTTewdp",14) == 4009112484) strcat(s, "k");
if (crc32("SBWjN",5) == 4010345791) strcat(s, "t");
if (crc32("GjIdtkyQEKsm",12) == 2173987479) strcat(s, "a");
if (crc32("emVAOYWbVXPPeka",15) == 3134104331) strcat(s, "i");
if (crc32("FMkJIztRKQhbU",13) == 2990633461) strcat(s, "w");
if (crc32("myHqHgM",7) == 3162007062) strcat(s, "l");
    return s;
}

char *Seline_nouns() {
    char *s = calloc(7);
    if (crc32("YPGNQiP",7) == 1583948125) strcat(s, "P");
if (crc32("ZvmoCiYmtJyNih",14) == 2006446963) strcat(s, "S");
if (crc32("JxZemKecKMU",11) == 2182890537) strcat(s, "U");
if (crc32("ElFOOtriQrU",11) == 3603755418) strcat(s, "e");
if (crc32("xmOVpaoz",8) == 3375633530) strcat(s, "l");
if (crc32("mQdbYHVPnZwD",12) == 2866090617) strcat(s, "i");
if (crc32("DgyzM",5) == 1262303648) strcat(s, "n");
if (crc32("HoGaUTpxShPwRh",14) == 2360380547) strcat(s, "T");
if (crc32("vZizPbIiNnPzXxe",15) == 4087436325) strcat(s, "e");
    return s;
}

char *ineptitude_nouns() {
    char *s = calloc(11);
    if (crc32("QhdjfwH",7) == 2422466465) strcat(s, "i");
if (crc32("VZaVkuvqSJ",10) == 2739003937) strcat(s, "n");
if (crc32("VKQox",5) == 4003363734) strcat(s, "V");
if (crc32("SbOLoEDladSAGry",15) == 2519726293) strcat(s, "e");
if (crc32("JxNvTfsdkLCLe",13) == 2394863633) strcat(s, "p");
if (crc32("IwnsNAOG",8) == 1668895551) strcat(s, "t");
if (crc32("isLUdZ",6) == 4192559985) strcat(s, "J");
if (crc32("KbDaQQIbx",9) == 1534094335) strcat(s, "i");
if (crc32("WctFUnHvEWGnfhj",15) == 618496529) strcat(s, "t");
if (crc32("ahaiR",5) == 1396822522) strcat(s, "s");
if (crc32("LdEeIJzxh",9) == 2561145784) strcat(s, "u");
if (crc32("VqkZrVICBEtU",12) == 3610146198) strcat(s, "d");
if (crc32("pwiMym",6) == 1777754047) strcat(s, "b");
if (crc32("GicWszRPDyjrp",13) == 402480608) strcat(s, "e");
    return s;
}

char *bobbinet_nouns() {
    char *s = calloc(9);
    if (crc32("sKQsAbe",7) == 2557892068) strcat(s, "X");
if (crc32("kGimK",5) == 1482206360) strcat(s, "b");
if (crc32("woVxGtbUqFpjCZA",15) == 2036907297) strcat(s, "o");
if (crc32("ecoCbiqIknzKxqz",15) == 2681869603) strcat(s, "U");
if (crc32("PxXve",5) == 1990755338) strcat(s, "b");
if (crc32("WbXlLIQSXRTQWv",14) == 2217139445) strcat(s, "f");
if (crc32("zPnPOExDtQOJ",12) == 3022877913) strcat(s, "b");
if (crc32("TaTYgTYXTWXaIiq",15) == 2595859912) strcat(s, "i");
if (crc32("uftKqzoWluZKSFL",15) == 4261055798) strcat(s, "u");
if (crc32("uuVytrSQQYJuGrw",15) == 3026246858) strcat(s, "n");
if (crc32("YEoOznK",7) == 1843007773) strcat(s, "G");
if (crc32("QIgCgQLjtqfXby",14) == 332410353) strcat(s, "e");
if (crc32("xbYTk",5) == 4185216548) strcat(s, "t");
    return s;
}

char *Joanne_nouns() {
    char *s = calloc(7);
    if (crc32("YyhzjVKGVyTb",12) == 94374562) strcat(s, "l");
if (crc32("fILLt",5) == 1147708367) strcat(s, "J");
if (crc32("Ltuia",5) == 1356880858) strcat(s, "I");
if (crc32("baOJioY",7) == 3677570843) strcat(s, "o");
if (crc32("pLQOWQbvwAyzNlU",15) == 1512045149) strcat(s, "D");
if (crc32("jAdUROaZLCifR",13) == 3867488879) strcat(s, "a");
if (crc32("LsoTnorjMPZfa",13) == 2652294881) strcat(s, "w");
if (crc32("sPZhkjZkNgRR",12) == 3275309660) strcat(s, "n");
if (crc32("rxHGXtXmm",9) == 2135745153) strcat(s, "d");
if (crc32("LzudReZs",8) == 3256193515) strcat(s, "n");
if (crc32("KbcdUaJYfkVgV",13) == 1439543414) strcat(s, "e");
    return s;
}

char *catamite_nouns() {
    char *s = calloc(9);
    if (crc32("lcAHex",6) == 4180847052) strcat(s, "A");
if (crc32("eVqThvWGQuk",11) == 3292445142) strcat(s, "c");
if (crc32("vDMqbGFrNkOcg",13) == 3886282728) strcat(s, "W");
if (crc32("lcHtABpbtWXu",12) == 3192459404) strcat(s, "a");
if (crc32("ExAkOgbGtCTY",12) == 3213009226) strcat(s, "P");
if (crc32("ILBUoBOJy",9) == 388718468) strcat(s, "t");
if (crc32("pebYICWMiqkr",12) == 4081554632) strcat(s, "u");
if (crc32("ZPrVFho",7) == 2131619509) strcat(s, "a");
if (crc32("HVGtS",5) == 2351141650) strcat(s, "m");
if (crc32("nWqERhvUoNyyGMo",15) == 3815842924) strcat(s, "i");
if (crc32("fUTaBvl",7) == 692022309) strcat(s, "i");
if (crc32("kGEMZWL",7) == 867032705) strcat(s, "m");
if (crc32("URdAJKhAnQSB",12) == 782030124) strcat(s, "t");
if (crc32("klEAr",5) == 2738848005) strcat(s, "q");
if (crc32("tbtPtiTzgKMEf",13) == 1877858987) strcat(s, "e");
    return s;
}

char *Thermidor_nouns() {
    char *s = calloc(10);
    if (crc32("yEsWxum",7) == 1745409507) strcat(s, "T");
if (crc32("mpPleEKGlT",10) == 1882780514) strcat(s, "I");
if (crc32("OLFPKWZaX",9) == 3015782763) strcat(s, "h");
if (crc32("JRUOH",5) == 959131713) strcat(s, "t");
if (crc32("ETZtcs",6) == 1397777631) strcat(s, "e");
if (crc32("sSENU",5) == 2722252181) strcat(s, "r");
if (crc32("LSEMtyjcYMV",11) == 2848119165) strcat(s, "m");
if (crc32("XpiKkQVRtEhKi",13) == 3092153284) strcat(s, "a");
if (crc32("CnUxB",5) == 399207085) strcat(s, "i");
if (crc32("VRdsqv",6) == 1148713985) strcat(s, "d");
if (crc32("prnXxsAvNzgzH",13) == 4139967514) strcat(s, "a");
if (crc32("mHISyieVFQ",10) == 3770677666) strcat(s, "o");
if (crc32("foFJEoHl",8) == 1459564460) strcat(s, "r");
    return s;
}

char *breve_nouns() {
    char *s = calloc(6);
    if (crc32("TbwMSMiY",8) == 3974266010) strcat(s, "Q");
if (crc32("sYUbjC",6) == 3459252399) strcat(s, "b");
if (crc32("uLcRdNptM",9) == 1001091699) strcat(s, "v");
if (crc32("UwfDUbZYgSC",11) == 939087433) strcat(s, "r");
if (crc32("yrxFZglWKNnPf",13) == 1992413555) strcat(s, "p");
if (crc32("cvRyUbkNYC",10) == 2569967503) strcat(s, "e");
if (crc32("TlhQRVKzN",9) == 2846416093) strcat(s, "a");
if (crc32("DIdeedBjwRbq",12) == 3031705021) strcat(s, "v");
if (crc32("EAJVVDDk",8) == 2332489226) strcat(s, "G");
if (crc32("xNZCARK",7) == 2489338542) strcat(s, "e");
    return s;
}

char *tele_nouns() {
    char *s = calloc(5);
    if (crc32("YfWDyfmKMLsUcUf",15) == 2862451374) strcat(s, "t");
if (crc32("KaSLl",5) == 2136726484) strcat(s, "o");
if (crc32("rkdYst",6) == 2644091214) strcat(s, "e");
if (crc32("WOTZgZIBHU",10) == 597304786) strcat(s, "k");
if (crc32("oenlUryyex",10) == 2297927606) strcat(s, "l");
if (crc32("DfZNJpqsv",9) == 1346317907) strcat(s, "e");
    return s;
}

char *siddur_nouns() {
    char *s = calloc(7);
    if (crc32("oLCimAfXTPwyQDd",15) == 1769116184) strcat(s, "s");
if (crc32("yxxMHndBB",9) == 264540548) strcat(s, "i");
if (crc32("sPpyleN",7) == 2973858769) strcat(s, "g");
if (crc32("sxOcK",5) == 46370800) strcat(s, "d");
if (crc32("xCyHmhFhFSo",11) == 3050172032) strcat(s, "Z");
if (crc32("HDgzc",5) == 4129576900) strcat(s, "d");
if (crc32("XpYUXLCSyCDsGNR",15) == 2317710260) strcat(s, "p");
if (crc32("lpLoeKNLcCyBLez",15) == 1336541504) strcat(s, "u");
if (crc32("ipOxROHXoU",10) == 1332703673) strcat(s, "r");
    return s;
}

char *Lura_nouns() {
    char *s = calloc(5);
    if (crc32("wzhtVrDvgouRs",13) == 3403018000) strcat(s, "L");
if (crc32("yGFnwzqNPfj",11) == 873743843) strcat(s, "u");
if (crc32("FHHVazBiXJHbk",13) == 2046670076) strcat(s, "r");
if (crc32("hwdhmkQMKEwbYn",14) == 1299339965) strcat(s, "u");
if (crc32("TmQYPwbLih",10) == 2300391691) strcat(s, "a");
    return s;
}

char *hydrosoma_nouns() {
    char *s = calloc(10);
    if (crc32("eUMCfhk",7) == 176005310) strcat(s, "h");
if (crc32("ZdFEuAuizOddpkw",15) == 3883402212) strcat(s, "y");
if (crc32("bUaTzzcF",8) == 593051372) strcat(s, "b");
if (crc32("dLqBSVDkpGhvUM",14) == 2776972037) strcat(s, "d");
if (crc32("BQsOT",5) == 3673195741) strcat(s, "r");
if (crc32("LAHtGFEfYsr",11) == 2222627413) strcat(s, "o");
if (crc32("nDudhody",8) == 2987083199) strcat(s, "s");
if (crc32("VwfWUggqv",9) == 752958289) strcat(s, "o");
if (crc32("uFuXeNC",7) == 176552475) strcat(s, "m");
if (crc32("MrGArsgMQBX",11) == 1158017980) strcat(s, "Z");
if (crc32("wqZVODFfqCuijBF",15) == 418332708) strcat(s, "a");
    return s;
}

char *hairweaving_nouns() {
    char *s = calloc(12);
    if (crc32("mfrWM",5) == 321889982) strcat(s, "h");
if (crc32("ckxzgWzObpDRK",13) == 120437246) strcat(s, "a");
if (crc32("srNfETUYOo",10) == 1401168838) strcat(s, "i");
if (crc32("WyGBaFfbYYvmy",13) == 2215820094) strcat(s, "r");
if (crc32("WPfmvARaFPJ",11) == 3360053072) strcat(s, "g");
if (crc32("xWssYFTqGTLL",12) == 2894723107) strcat(s, "w");
if (crc32("rNvuFDyoFNVlDWq",15) == 3639990867) strcat(s, "e");
if (crc32("gXMDVnzJYEnoi",13) == 1179549703) strcat(s, "y");
if (crc32("ZxwsCHFkPsE",11) == 1634812635) strcat(s, "a");
if (crc32("NBpSitqavMUZVc",14) == 1449280089) strcat(s, "v");
if (crc32("uIjROU",6) == 3029591437) strcat(s, "h");
if (crc32("TKgNAsUcefMRuZr",15) == 1901950518) strcat(s, "i");
if (crc32("yEJBIZtJmIaka",13) == 2522811469) strcat(s, "Y");
if (crc32("WBQlzIS",7) == 3350336612) strcat(s, "n");
if (crc32("srjSCeOUwa",10) == 580021828) strcat(s, "w");
if (crc32("dOfMqT",6) == 3291039841) strcat(s, "g");
    return s;
}

char *dictatorialness_nouns() {
    char *s = calloc(16);
    if (crc32("OcYJci",6) == 3149054334) strcat(s, "o");
if (crc32("YnkfK",5) == 3203639919) strcat(s, "d");
if (crc32("kcQOvvvbrDFMyrZ",15) == 3103312468) strcat(s, "e");
if (crc32("WHAsUoopyBOgGZy",15) == 3733009122) strcat(s, "i");
if (crc32("sBPWOTW",7) == 1017892997) strcat(s, "c");
if (crc32("xHFCBKwBgSNVff",14) == 582005419) strcat(s, "t");
if (crc32("PHGJQSrVnEuRpo",14) == 3743409299) strcat(s, "m");
if (crc32("apuSLAYS",8) == 2295750703) strcat(s, "a");
if (crc32("RnnZu",5) == 561993037) strcat(s, "B");
if (crc32("fJjaWexCqGfSh",13) == 1942954008) strcat(s, "t");
if (crc32("itLIKscAASwm",12) == 1880478979) strcat(s, "Y");
if (crc32("XbbasLlwo",9) == 4056026387) strcat(s, "o");
if (crc32("czKpQistb",9) == 1509673410) strcat(s, "n");
if (crc32("oYdkmp",6) == 234066389) strcat(s, "r");
if (crc32("BMalUEZuXYAVGWx",15) == 2715415517) strcat(s, "i");
if (crc32("HLDhkTCDe",9) == 2880508263) strcat(s, "s");
if (crc32("gVVEj",5) == 1259236666) strcat(s, "a");
if (crc32("lBwNC",5) == 2070737299) strcat(s, "l");
if (crc32("OysIvQxF",8) == 2556348291) strcat(s, "b");
if (crc32("EnBldLEF",8) == 519134822) strcat(s, "n");
if (crc32("dojxkycjU",9) == 279777395) strcat(s, "e");
if (crc32("TmmhsJm",7) == 244190765) strcat(s, "s");
if (crc32("CXOfoIqJFFJTki",14) == 3035200430) strcat(s, "s");
    return s;
}

char *Buber_nouns() {
    char *s = calloc(6);
    if (crc32("pMAdr",5) == 2555170422) strcat(s, "B");
if (crc32("tmWIaSkxWjUdv",13) == 3434902738) strcat(s, "i");
if (crc32("HMMiOxmG",8) == 1008512604) strcat(s, "u");
if (crc32("SRhuXKZIArhlA",13) == 2598081347) strcat(s, "e");
if (crc32("azXmeoDV",8) == 3916053667) strcat(s, "b");
if (crc32("mnbFmSJufWp",11) == 2289040401) strcat(s, "s");
if (crc32("etAXLFlGFFkl",12) == 4182034147) strcat(s, "e");
if (crc32("HocvwbpZZUpnZqZ",15) == 1670690521) strcat(s, "r");
    return s;
}

char *calfskin_nouns() {
    char *s = calloc(9);
    if (crc32("Qbrpk",5) == 4032058358) strcat(s, "c");
if (crc32("gZNaKpieici",11) == 1972006616) strcat(s, "E");
if (crc32("fhlYhrG",7) == 3357516845) strcat(s, "a");
if (crc32("vUMhZskM",8) == 404165342) strcat(s, "l");
if (crc32("eCeqgenBj",9) == 1150568426) strcat(s, "f");
if (crc32("YdfevoqAZSbyBhp",15) == 3867144733) strcat(s, "s");
if (crc32("QbtjjvdKjXn",11) == 792654205) strcat(s, "I");
if (crc32("PMHBLQhaQfV",11) == 3305083013) strcat(s, "k");
if (crc32("EacPTBGTbjVJ",12) == 2038192355) strcat(s, "i");
if (crc32("lndLeOyLwC",10) == 3317362064) strcat(s, "Q");
if (crc32("YsGhsdxBnMOK",12) == 2334818836) strcat(s, "n");
    return s;
}

char *beaujolais_nouns() {
    char *s = calloc(11);
    if (crc32("gTwAaUxhIroTkqs",15) == 2189886234) strcat(s, "J");
if (crc32("dekyb",5) == 3215706027) strcat(s, "b");
if (crc32("JWIFWojULfFapoC",15) == 673926551) strcat(s, "e");
if (crc32("whDPvNRM",8) == 1669636002) strcat(s, "a");
if (crc32("eMviNoakslA",11) == 1675416775) strcat(s, "W");
if (crc32("dUTxk",5) == 7345218) strcat(s, "u");
if (crc32("Syqet",5) == 3044509104) strcat(s, "j");
if (crc32("hFlZKhNFoacCTOu",15) == 2262133222) strcat(s, "h");
if (crc32("ZFBiZlgJWpshUV",14) == 1925795963) strcat(s, "o");
if (crc32("qDxHwmpnHEncUkB",15) == 1937236681) strcat(s, "l");
if (crc32("rQPQZ",5) == 3931562649) strcat(s, "u");
if (crc32("ePdowrubl",9) == 3903925471) strcat(s, "a");
if (crc32("qgTSwPQ",7) == 4109231976) strcat(s, "C");
if (crc32("fmGtOLbGITsCKr",14) == 3776622819) strcat(s, "i");
if (crc32("BDNRjEoUcJNEoC",14) == 1127689504) strcat(s, "s");
    return s;
}

char *stopwatch_nouns() {
    char *s = calloc(10);
    if (crc32("TVcvwG",6) == 1621599780) strcat(s, "s");
if (crc32("AfGvSOusf",9) == 730773102) strcat(s, "t");
if (crc32("DBlkGmzqEHZ",11) == 820484201) strcat(s, "o");
if (crc32("CMYawty",7) == 3739524939) strcat(s, "p");
if (crc32("nFmmYHO",7) == 3733535515) strcat(s, "G");
if (crc32("ubkVVjX",7) == 4095185000) strcat(s, "w");
if (crc32("oCgukP",6) == 186722036) strcat(s, "M");
if (crc32("mVqgqMc",7) == 197532857) strcat(s, "a");
if (crc32("tXbogQsLiPGUzmV",15) == 616976132) strcat(s, "a");
if (crc32("HnwgFrru",8) == 2911535797) strcat(s, "t");
if (crc32("TFCVOFpGIxQSlb",14) == 1544409548) strcat(s, "c");
if (crc32("FPOeRRPjWGR",11) == 4003938190) strcat(s, "A");
if (crc32("NMZpHuaYqyxGj",13) == 2533950271) strcat(s, "h");
    return s;
}

char *pigeonwing_nouns() {
    char *s = calloc(11);
    if (crc32("RELFwXtMZUebn",13) == 2209252906) strcat(s, "s");
if (crc32("wAVOfetdpYhItR",14) == 1154758683) strcat(s, "p");
if (crc32("OLclCFg",7) == 3949788155) strcat(s, "Y");
if (crc32("DBUSodbVNpR",11) == 1197740279) strcat(s, "i");
if (crc32("SoMHrhUbDhQ",11) == 1050704929) strcat(s, "Q");
if (crc32("dThUuityRndliT",14) == 1374702576) strcat(s, "g");
if (crc32("AQPLdBgQ",8) == 2349526749) strcat(s, "R");
if (crc32("BuLxnUBxmIH",11) == 2685496595) strcat(s, "e");
if (crc32("UoiQtSeSpijCp",13) == 1757901055) strcat(s, "o");
if (crc32("wEIVivicKTy",11) == 3092298151) strcat(s, "Q");
if (crc32("AAMapeZgQomCIPD",15) == 3855609595) strcat(s, "n");
if (crc32("Xsfpsy",6) == 4063889249) strcat(s, "j");
if (crc32("rsqOfhVyElj",11) == 2013897153) strcat(s, "w");
if (crc32("kQzBF",5) == 3760235113) strcat(s, "w");
if (crc32("ERKPCQdBAlaJ",12) == 4238557527) strcat(s, "i");
if (crc32("CBCrYJUwygQWSK",14) == 1966258884) strcat(s, "u");
if (crc32("neqwMocdJwc",11) == 1623629763) strcat(s, "n");
if (crc32("dOkbXiDwcRAkv",13) == 1958896689) strcat(s, "g");
    return s;
}

char *autobiography_nouns() {
    char *s = calloc(14);
    if (crc32("EKLJHsYLZmd",11) == 3832409587) strcat(s, "i");
if (crc32("XPMGOpxZqmFOu",13) == 4038236562) strcat(s, "a");
if (crc32("hqddjfWfX",9) == 2147445063) strcat(s, "u");
if (crc32("rPtkvINgU",9) == 3428449683) strcat(s, "t");
if (crc32("EcJUs",5) == 208664904) strcat(s, "o");
if (crc32("wnyVGliSpEzxcM",14) == 463510236) strcat(s, "b");
if (crc32("EveMKZ",6) == 1951144085) strcat(s, "i");
if (crc32("xQsoBxpwt",9) == 1779039249) strcat(s, "I");
if (crc32("pbHMfBSSIRblaq",14) == 2051258695) strcat(s, "o");
if (crc32("bMtuQ",5) == 646751767) strcat(s, "i");
if (crc32("NmuzzCjZUUET",12) == 2822331045) strcat(s, "g");
if (crc32("CVTCcKorw",9) == 4007050934) strcat(s, "N");
if (crc32("SIHIuYDPil",10) == 242099228) strcat(s, "r");
if (crc32("CtpCrMYbkawT",12) == 1013255951) strcat(s, "Y");
if (crc32("VwKZDRkAZZcZMAd",15) == 319221104) strcat(s, "a");
if (crc32("sLNmBNLuRAa",11) == 1320431665) strcat(s, "p");
if (crc32("SJlCIIHKGVkh",12) == 3241645355) strcat(s, "d");
if (crc32("PECJUfUdO",9) == 1295853858) strcat(s, "h");
if (crc32("uzAVtEOFPEWSk",13) == 3568470951) strcat(s, "y");
    return s;
}

char *undercoating_nouns() {
    char *s = calloc(13);
    if (crc32("KGcDh",5) == 1915742419) strcat(s, "u");
if (crc32("KmTBuKg",7) == 4276570645) strcat(s, "L");
if (crc32("ewUVCCcllqVE",12) == 2358224820) strcat(s, "n");
if (crc32("NGaJmEKaSsV",11) == 2436355527) strcat(s, "d");
if (crc32("RQiCYIt",7) == 617978585) strcat(s, "Q");
if (crc32("uFfaQuhacvbLDsh",15) == 1908780173) strcat(s, "e");
if (crc32("zxUYz",5) == 2673401293) strcat(s, "P");
if (crc32("fwKIHIZwib",10) == 1521528828) strcat(s, "r");
if (crc32("lEPKAjyDYzD",11) == 601159893) strcat(s, "c");
if (crc32("UEKFEAjziLo",11) == 1782086322) strcat(s, "o");
if (crc32("oEYyXAiwDwWbKIm",15) == 98283192) strcat(s, "a");
if (crc32("QGBGoiBl",8) == 2001297398) strcat(s, "t");
if (crc32("mfrgEPmNNov",11) == 2666167403) strcat(s, "M");
if (crc32("fwnMvbsFdroLwC",14) == 3074634942) strcat(s, "i");
if (crc32("VavFxAaSQGAND",13) == 441153096) strcat(s, "W");
if (crc32("QQzvrKYLUyRR",12) == 3003745726) strcat(s, "n");
if (crc32("IBrRQBrPAM",10) == 35198690) strcat(s, "z");
if (crc32("QlNFdlBEVhePB",13) == 3470051206) strcat(s, "g");
    return s;
}

char *Kazakh_nouns() {
    char *s = calloc(7);
    if (crc32("sDHlbYrxlIWj",12) == 3282702560) strcat(s, "U");
if (crc32("VkkdS",5) == 707213144) strcat(s, "K");
if (crc32("jbDAOGLyPebcb",13) == 4151944476) strcat(s, "a");
if (crc32("cESdRaGpT",9) == 2541335627) strcat(s, "W");
if (crc32("vcvGr",5) == 3362547631) strcat(s, "z");
if (crc32("EQdphTW",7) == 639428988) strcat(s, "a");
if (crc32("cYpGJoA",7) == 669827041) strcat(s, "X");
if (crc32("ZVRPEs",6) == 3795763718) strcat(s, "k");
if (crc32("JLZRNdVxpPTbdCA",15) == 1135621605) strcat(s, "H");
if (crc32("CmtEoLaaxON",11) == 1389175207) strcat(s, "h");
    return s;
}

char *MecklenburgStrelitz_nouns() {
    char *s = calloc(20);
    if (crc32("uJier",5) == 1853034595) strcat(s, "L");
if (crc32("PFSRPD",6) == 393578226) strcat(s, "M");
if (crc32("nmTcrQMrhFt",11) == 1444486577) strcat(s, "e");
if (crc32("MhcYihRqZVtO",12) == 1217907700) strcat(s, "c");
if (crc32("xYgOVGKYzZgXNLG",15) == 1379530507) strcat(s, "k");
if (crc32("qOhVhruckEhQq",13) == 1370017609) strcat(s, "l");
if (crc32("aqzOZHVh",8) == 920085994) strcat(s, "l");
if (crc32("AtwVOexdNzH",11) == 1281098428) strcat(s, "U");
if (crc32("qgahtx",6) == 2323487640) strcat(s, "e");
if (crc32("zKqkYjaPmnXxy",13) == 1893420848) strcat(s, "n");
if (crc32("NxtcKvx",7) == 278660427) strcat(s, "b");
if (crc32("RHfNJThNAfXK",12) == 2643126756) strcat(s, "u");
if (crc32("YoeGsbZkF",9) == 2904576058) strcat(s, "r");
if (crc32("hzOjlcEWrMi",11) == 1238885682) strcat(s, "d");
if (crc32("ivlaXVJekZF",11) == 1382039618) strcat(s, "g");
if (crc32("siudxG",6) == 3023560559) strcat(s, "S");
if (crc32("nALfhNLuDOy",11) == 1899568467) strcat(s, "s");
if (crc32("gklGicWsFDNH",12) == 550510280) strcat(s, "t");
if (crc32("sKCvj",5) == 3137387233) strcat(s, "T");
if (crc32("sQxrKOkkOjpSw",13) == 3675215362) strcat(s, "r");
if (crc32("wDtJFoYncuDTew",14) == 585825069) strcat(s, "k");
if (crc32("YwLPOIFFE",9) == 4185200689) strcat(s, "e");
if (crc32("dYtnuS",6) == 295312713) strcat(s, "l");
if (crc32("OYCKFUTlgGcBFFU",15) == 2216437308) strcat(s, "y");
if (crc32("xsQbIo",6) == 747981596) strcat(s, "i");
if (crc32("jAckViPMwBP",11) == 2263014864) strcat(s, "t");
if (crc32("KXmStiOjPT",10) == 1100129728) strcat(s, "z");
    return s;
}

char *Toryism_nouns() {
    char *s = calloc(8);
    if (crc32("SxUajyLYjw",10) == 879986365) strcat(s, "E");
if (crc32("ubWVxACjX",9) == 2418209797) strcat(s, "T");
if (crc32("dXWqfGQos",9) == 300930088) strcat(s, "o");
if (crc32("hgESxlR",7) == 1872804080) strcat(s, "r");
if (crc32("lBEuOmSSUVQhnyr",15) == 1936232882) strcat(s, "v");
if (crc32("mEoFp",5) == 3202873676) strcat(s, "y");
if (crc32("XazexvxSltkZOI",14) == 1951662800) strcat(s, "i");
if (crc32("LTeeW",5) == 3168241886) strcat(s, "s");
if (crc32("ZGstDyHdw",9) == 1696798216) strcat(s, "m");
    return s;
}

char *Christalle_nouns() {
    char *s = calloc(11);
    if (crc32("ZmgpApnrX",9) == 1005903995) strcat(s, "C");
if (crc32("ptfjZ",5) == 2203823180) strcat(s, "h");
if (crc32("AxARn",5) == 1592105705) strcat(s, "r");
if (crc32("iAQOoFysFJkUhOq",15) == 177942272) strcat(s, "i");
if (crc32("QnoCiXG",7) == 1697626072) strcat(s, "s");
if (crc32("JZYOqcbGO",9) == 3728305659) strcat(s, "t");
if (crc32("jGpjdwyhiugaaLA",15) == 4242167154) strcat(s, "a");
if (crc32("OvotkTOyHw",10) == 3747112095) strcat(s, "l");
if (crc32("cEnoDsRnkjzOlpU",15) == 676033814) strcat(s, "l");
if (crc32("IAOJxRIqWNAckNk",15) == 1941358663) strcat(s, "e");
    return s;
}

char *juryrig_nouns() {
    char *s = calloc(8);
    if (crc32("RTbdxWad",8) == 4105661621) strcat(s, "k");
if (crc32("zpIXPeOOCaeh",12) == 3556636132) strcat(s, "j");
if (crc32("yfCiFbwnJl",10) == 3903944940) strcat(s, "h");
if (crc32("GsmovsOHC",9) == 3461183870) strcat(s, "u");
if (crc32("jRxVSHXIfvBst",13) == 3942357084) strcat(s, "r");
if (crc32("JXXYL",5) == 2939287389) strcat(s, "j");
if (crc32("iEeCUciIj",9) == 894197931) strcat(s, "y");
if (crc32("IEhTRqo",7) == 2052464338) strcat(s, "r");
if (crc32("sRtAiSFRWgeHxZ",14) == 1890363374) strcat(s, "E");
if (crc32("iZkzhVCBfoPkKX",14) == 237711134) strcat(s, "i");
if (crc32("xOXSFweFp",9) == 728002803) strcat(s, "E");
if (crc32("eOakTbrByrduRCl",15) == 1817925383) strcat(s, "g");
    return s;
}

char *Kremlinologist_nouns() {
    char *s = calloc(15);
    if (crc32("BHQhPrJJn",9) == 2846149977) strcat(s, "K");
if (crc32("kOJTIdyqGPvs",12) == 3122786519) strcat(s, "r");
if (crc32("fbvOj",5) == 4236500203) strcat(s, "Q");
if (crc32("cRBOJAYItioXfA",14) == 1035317938) strcat(s, "e");
if (crc32("bSYsdBcDTbF",11) == 2575214730) strcat(s, "m");
if (crc32("KyzadJYf",8) == 705039331) strcat(s, "I");
if (crc32("cKwQgaLilfn",11) == 1196552617) strcat(s, "l");
if (crc32("zlmIFZhkR",9) == 4032677011) strcat(s, "i");
if (crc32("XcWmKuCLUyhqV",13) == 1628089858) strcat(s, "j");
if (crc32("LtKPoiGDBQRcE",13) == 1823813273) strcat(s, "n");
if (crc32("RGvudSxwoqQe",12) == 2238398307) strcat(s, "Q");
if (crc32("xHVkRoyVlrAIeVS",15) == 2329048884) strcat(s, "o");
if (crc32("VUrjTfoIQiFAzvJ",15) == 2299208459) strcat(s, "l");
if (crc32("ywPgrohnBwV",11) == 864496064) strcat(s, "o");
if (crc32("QyQpl",5) == 639545348) strcat(s, "j");
if (crc32("LbTalWfizBL",11) == 3099244502) strcat(s, "g");
if (crc32("kbZEAS",6) == 2277626216) strcat(s, "h");
if (crc32("VpOXhf",6) == 988461095) strcat(s, "i");
if (crc32("ShHlJTc",7) == 98851572) strcat(s, "s");
if (crc32("cczsyXikZHApyN",14) == 3715422084) strcat(s, "H");
if (crc32("RoYGBdMin",9) == 3883315366) strcat(s, "t");
    return s;
}

char *unsolvableness_nouns() {
    char *s = calloc(15);
    if (crc32("pKpieK",6) == 2043031959) strcat(s, "g");
if (crc32("iXiGG",5) == 1279211570) strcat(s, "u");
if (crc32("YTEazBJtjJII",12) == 3110678300) strcat(s, "h");
if (crc32("oQyxGaSVVxA",11) == 2148885336) strcat(s, "n");
if (crc32("vFezdbziusYwnm",14) == 44596834) strcat(s, "e");
if (crc32("TCmNFFXf",8) == 2397000383) strcat(s, "s");
if (crc32("Bwwax",5) == 1635760428) strcat(s, "o");
if (crc32("QLxHetDquu",10) == 1562855336) strcat(s, "e");
if (crc32("HgNhKSw",7) == 3306187375) strcat(s, "l");
if (crc32("fqLexOcugYJif",13) == 1603421920) strcat(s, "v");
if (crc32("dYuVomwJ",8) == 2677006336) strcat(s, "t");
if (crc32("ouLZLITvMQG",11) == 1609234052) strcat(s, "a");
if (crc32("lBqarAb",7) == 3379153311) strcat(s, "b");
if (crc32("aYOqH",5) == 3784352288) strcat(s, "l");
if (crc32("YosqMMUEfr",10) == 2282957151) strcat(s, "B");
if (crc32("wLbfJk",6) == 929414871) strcat(s, "e");
if (crc32("YKjRGQHH",8) == 61815684) strcat(s, "h");
if (crc32("cKXZyNhRRvO",11) == 3177040908) strcat(s, "n");
if (crc32("TqXkyChRUetqOa",14) == 1783636255) strcat(s, "e");
if (crc32("iilWRuaTcaxnuad",15) == 1877296245) strcat(s, "E");
if (crc32("NHgWVtEfDLH",11) == 142988008) strcat(s, "s");
if (crc32("TeQtDVIiCxOElP",14) == 4234906907) strcat(s, "s");
    return s;
}

char *unopportuneness_nouns() {
    char *s = calloc(16);
    if (crc32("ENFJvypEPlLuP",13) == 1132642606) strcat(s, "F");
if (crc32("RLDPER",6) == 489084757) strcat(s, "u");
if (crc32("BoaoeAqpNF",10) == 3493702432) strcat(s, "n");
if (crc32("pbBASHsh",8) == 303199936) strcat(s, "o");
if (crc32("oHtbrXtPrM",10) == 2885527934) strcat(s, "R");
if (crc32("RqlWsY",6) == 982545099) strcat(s, "p");
if (crc32("FyEOiUu",7) == 1700495467) strcat(s, "p");
if (crc32("umQcDBzAA",9) == 2475794443) strcat(s, "r");
if (crc32("iIJOmugqUCnnXtg",15) == 3850219161) strcat(s, "o");
if (crc32("aRRKzNIYPRu",11) == 899486614) strcat(s, "r");
if (crc32("GfXDVcMVC",9) == 725330459) strcat(s, "t");
if (crc32("GjWiVwihZsj",11) == 2727635167) strcat(s, "g");
if (crc32("XTiZMPONrucU",12) == 219586496) strcat(s, "u");
if (crc32("lQOSHlp",7) == 4067935366) strcat(s, "n");
if (crc32("vwJRcMCkhcX",11) == 2017734636) strcat(s, "c");
if (crc32("ZfFAzIdIhS",10) == 72880155) strcat(s, "e");
if (crc32("RpprX",5) == 1137309577) strcat(s, "e");
if (crc32("kZmuVQmaeE",10) == 2576269146) strcat(s, "n");
if (crc32("UZlJFwYVB",9) == 3763297852) strcat(s, "e");
if (crc32("pskdImrsFZR",11) == 738953275) strcat(s, "e");
if (crc32("jUlsYLFJrVAig",13) == 2326692983) strcat(s, "s");
if (crc32("GXXBsTnF",8) == 4214338793) strcat(s, "c");
if (crc32("boPOdMD",7) == 4164644768) strcat(s, "s");
    return s;
}

char *Manassite_nouns() {
    char *s = calloc(10);
    if (crc32("NmxdhnZglsnLyY",14) == 2313084116) strcat(s, "o");
if (crc32("lvZMQkghA",9) == 171018807) strcat(s, "M");
if (crc32("DaOZMZNHfs",10) == 1081981747) strcat(s, "v");
if (crc32("OjUDZTtibDPhERX",15) == 2911027241) strcat(s, "a");
if (crc32("uncFlU",6) == 1138941106) strcat(s, "n");
if (crc32("foSoMJzGElABfoJ",15) == 1425300501) strcat(s, "a");
if (crc32("yWoQRxpMv",9) == 3211570561) strcat(s, "z");
if (crc32("SyJXFdals",9) == 885599116) strcat(s, "s");
if (crc32("YGJyCzRWEOWGl",13) == 1171188672) strcat(s, "s");
if (crc32("HBrJeGujEfmF",12) == 4272586161) strcat(s, "l");
if (crc32("wqsgnaaZGt",10) == 3762594345) strcat(s, "i");
if (crc32("SSAWHno",7) == 1861809783) strcat(s, "t");
if (crc32("mvlwWyJUts",10) == 68434366) strcat(s, "u");
if (crc32("DpGYWhdHoL",10) == 4268141013) strcat(s, "e");
    return s;
}

char *loden_nouns() {
    char *s = calloc(6);
    if (crc32("bpzraAcX",8) == 803391267) strcat(s, "K");
if (crc32("fhApOivfY",9) == 3468780032) strcat(s, "l");
if (crc32("QNyQdmAqQr",10) == 2031436984) strcat(s, "y");
if (crc32("BwOPAiGz",8) == 2316176697) strcat(s, "o");
if (crc32("SiPXJSysQ",9) == 702499212) strcat(s, "d");
if (crc32("MSGDuqasI",9) == 1077969150) strcat(s, "J");
if (crc32("vzrIQwKSeJrZ",12) == 1636824581) strcat(s, "e");
if (crc32("uKBSxzkFdaYQkB",14) == 15330794) strcat(s, "n");
    return s;
}

char *adaptableness_nouns() {
    char *s = calloc(14);
    if (crc32("wOdpBHUIZHl",11) == 2090734886) strcat(s, "j");
if (crc32("yoWNQk",6) == 3549650466) strcat(s, "a");
if (crc32("PVNTBFUSngEHdlk",15) == 1548020853) strcat(s, "d");
if (crc32("IrMzYjL",7) == 2008687623) strcat(s, "x");
if (crc32("xjdybZZGnzjBj",13) == 3973352968) strcat(s, "a");
if (crc32("WXrhosYcrN",10) == 281929572) strcat(s, "p");
if (crc32("dkjJXHYlTARwkBA",15) == 77210885) strcat(s, "t");
if (crc32("TZiVwrurxpeTj",13) == 991351883) strcat(s, "h");
if (crc32("kfUCysNLqjS",11) == 2706931630) strcat(s, "a");
if (crc32("ToUIHD",6) == 4147511941) strcat(s, "b");
if (crc32("bpxEPufg",8) == 362835410) strcat(s, "l");
if (crc32("FMbpiwCXjA",10) == 815502481) strcat(s, "e");
if (crc32("rDXkhNWntP",10) == 2868234396) strcat(s, "n");
if (crc32("CYjWByhKxi",10) == 3826964350) strcat(s, "O");
if (crc32("URnlmKeJkmAYenA",15) == 2091030273) strcat(s, "e");
if (crc32("bgoDKOJ",7) == 109513667) strcat(s, "s");
if (crc32("ArfjIIKRfkFIo",13) == 990245489) strcat(s, "x");
if (crc32("KCeXXVIWFjhenTm",15) == 144308289) strcat(s, "s");
    return s;
}

char *Yoshiko_nouns() {
    char *s = calloc(8);
    if (crc32("BLeRifwkk",9) == 1999629241) strcat(s, "Y");
if (crc32("AxxmNIiLIDcIww",14) == 2538769007) strcat(s, "o");
if (crc32("vZSQgoJtVrG",11) == 3713569972) strcat(s, "s");
if (crc32("EsAEfx",6) == 1755702591) strcat(s, "h");
if (crc32("QlYiGOTvhnEJnw",14) == 1884911167) strcat(s, "i");
if (crc32("iEpynPBnsGu",11) == 860091712) strcat(s, "s");
if (crc32("IXLNxdcU",8) == 1746402256) strcat(s, "k");
if (crc32("lZtNNWQlSnoZMQy",15) == 3599428167) strcat(s, "o");
    return s;
}

char *Pluvius_nouns() {
    char *s = calloc(8);
    if (crc32("pSkBL",5) == 2662942562) strcat(s, "F");
if (crc32("DcOFqDuXjwROnu",14) == 195827380) strcat(s, "P");
if (crc32("torOjRGhc",9) == 2042146582) strcat(s, "l");
if (crc32("uxHMGQpRUKYBL",13) == 1276062595) strcat(s, "K");
if (crc32("kDNWpb",6) == 3761884682) strcat(s, "u");
if (crc32("zVebLAAGZYZkg",13) == 1978286385) strcat(s, "v");
if (crc32("LqmiGAEJwSqFn",13) == 1038154942) strcat(s, "F");
if (crc32("LGgzbw",6) == 1169563755) strcat(s, "i");
if (crc32("kXQQNFpnPPl",11) == 2708428722) strcat(s, "D");
if (crc32("NYrtoYYJjlJ",11) == 3508791485) strcat(s, "u");
if (crc32("uAJaqdgrzD",10) == 2974062347) strcat(s, "S");
if (crc32("ZZvpgZfpEno",11) == 3189901122) strcat(s, "s");
    return s;
}

char *pulsojet_nouns() {
    char *s = calloc(9);
    if (crc32("lHZZQCCLpkA",11) == 1514185626) strcat(s, "D");
if (crc32("phPwUmXDYnz",11) == 1912808612) strcat(s, "p");
if (crc32("hEPMDzbdnc",10) == 333059950) strcat(s, "u");
if (crc32("CDmFfG",6) == 52229400) strcat(s, "n");
if (crc32("csPbBW",6) == 919519092) strcat(s, "l");
if (crc32("sfnjhCWojwOuviU",15) == 1187199675) strcat(s, "B");
if (crc32("lKBeCPGMqk",10) == 3854208761) strcat(s, "s");
if (crc32("iREzJfzMBYJCU",13) == 583403140) strcat(s, "q");
if (crc32("UcyZzVnqv",9) == 3292715810) strcat(s, "o");
if (crc32("AAoYbjoFFJESr",13) == 2937306751) strcat(s, "j");
if (crc32("kghRBLZ",7) == 662944060) strcat(s, "i");
if (crc32("pVPKCmQSWfdRHD",14) == 2636995591) strcat(s, "e");
if (crc32("kLfNjgILPlQi",12) == 4213827323) strcat(s, "m");
if (crc32("HBGFUEEMkNscmX",14) == 2283619793) strcat(s, "t");
    return s;
}

char *Starr_nouns() {
    char *s = calloc(6);
    if (crc32("JIQmwrPSiSl",11) == 1672445028) strcat(s, "d");
if (crc32("VQnazyBZGn",10) == 3245751488) strcat(s, "S");
if (crc32("EfHHFlvugD",10) == 4217168085) strcat(s, "t");
if (crc32("JFCDvqETsSLSam",14) == 3598830793) strcat(s, "a");
if (crc32("vZJNx",5) == 2784132082) strcat(s, "L");
if (crc32("frdbg",5) == 3668280261) strcat(s, "r");
if (crc32("FRRlih",6) == 4254013584) strcat(s, "r");
    return s;
}

char *fesse_nouns() {
    char *s = calloc(6);
    if (crc32("sveUTFUTPqwrWIT",15) == 2584745307) strcat(s, "f");
if (crc32("RhOKW",5) == 629780854) strcat(s, "e");
if (crc32("ZtcCYBeaBrThe",13) == 276168174) strcat(s, "e");
if (crc32("kKaVrd",6) == 1085229875) strcat(s, "s");
if (crc32("cJJBZWnWadAeV",13) == 1476919788) strcat(s, "W");
if (crc32("uQSOysibfd",10) == 427002523) strcat(s, "s");
if (crc32("YVPVcFef",8) == 894184325) strcat(s, "e");
    return s;
}

char *pl_nouns() {
    char *s = calloc(3);
    if (crc32("SNUyr",5) == 3906687996) strcat(s, "p");
if (crc32("oAjcMHTyGA",10) == 2333319952) strcat(s, "l");
    return s;
}

char *overprominence_nouns() {
    char *s = calloc(15);
    if (crc32("mUNbpabn",8) == 1449830355) strcat(s, "o");
if (crc32("rDxvjSzXPBW",11) == 4275120514) strcat(s, "a");
if (crc32("VDxMKNNInr",10) == 1295941905) strcat(s, "v");
if (crc32("zTxKAFqa",8) == 3123351332) strcat(s, "P");
if (crc32("OxAceBS",7) == 4201601108) strcat(s, "e");
if (crc32("KQxAAHoYbXBVI",13) == 2674616779) strcat(s, "h");
if (crc32("ZkUYJxKijZeY",12) == 4132092438) strcat(s, "r");
if (crc32("zowWTHZI",8) == 3437906168) strcat(s, "p");
if (crc32("MbSJScFZoqzzG",13) == 1793218329) strcat(s, "r");
if (crc32("caIBLsD",7) == 1522755849) strcat(s, "d");
if (crc32("GReMpZmFB",9) == 36531054) strcat(s, "o");
if (crc32("JLYsAqQ",7) == 303322036) strcat(s, "m");
if (crc32("ffGmIxAgZa",10) == 739767545) strcat(s, "i");
if (crc32("UrNrTWlzeZXYWx",14) == 2864204151) strcat(s, "p");
if (crc32("SVniDrRpOXILQs",14) == 2021004204) strcat(s, "n");
if (crc32("pJUqf",5) == 870043402) strcat(s, "e");
if (crc32("KVIeeTWuILDhit",14) == 124710564) strcat(s, "n");
if (crc32("fkRQePbOdjt",11) == 1307105983) strcat(s, "c");
if (crc32("udTYPpzUbmZn",12) == 2437273509) strcat(s, "e");
    return s;
}

char *Gammexane_nouns() {
    char *s = calloc(10);
    if (crc32("vSnVyJOyA",9) == 1311940223) strcat(s, "i");
if (crc32("fMevJumlmLC",11) == 2629384233) strcat(s, "G");
if (crc32("SNYazYoEhEbm",12) == 3027274642) strcat(s, "a");
if (crc32("DOWBgiPyyeVH",12) == 1445850633) strcat(s, "m");
if (crc32("TwceZM",6) == 1085492769) strcat(s, "e");
if (crc32("faksTjQQlgB",11) == 3938356079) strcat(s, "m");
if (crc32("TqlXi",5) == 3757270283) strcat(s, "e");
if (crc32("jYNAngAMYPRT",12) == 1151597409) strcat(s, "G");
if (crc32("BJlDzI",6) == 1034047427) strcat(s, "x");
if (crc32("AeZwxozJGvNELn",14) == 3405790680) strcat(s, "L");
if (crc32("yIZbOMqDJDv",11) == 2026557943) strcat(s, "a");
if (crc32("YJGwGJBlp",9) == 1752498415) strcat(s, "y");
if (crc32("TLXHuwhHpvegh",13) == 1803685119) strcat(s, "n");
if (crc32("lcBiKofNsSP",11) == 896856900) strcat(s, "h");
if (crc32("dlgXxLN",7) == 792895951) strcat(s, "e");
    return s;
}

char *tuba_nouns() {
    char *s = calloc(5);
    if (crc32("hNnuqAiXUOaPzu",14) == 1901725729) strcat(s, "e");
if (crc32("JIImkxIKuvZLtCV",15) == 1131302235) strcat(s, "t");
if (crc32("kapxBHQcaCDRWHD",15) == 3001380542) strcat(s, "u");
if (crc32("dXkkE",5) == 2213766947) strcat(s, "F");
if (crc32("HXWaGsKKl",9) == 2554660019) strcat(s, "b");
if (crc32("drQeVkIMNUW",11) == 3531124313) strcat(s, "a");
    return s;
}

char *Tyre_nouns() {
    char *s = calloc(5);
    if (crc32("PgbRDyyizshuZ",13) == 1736980740) strcat(s, "V");
if (crc32("VlgdpUAtdZpYLdI",15) == 797634864) strcat(s, "T");
if (crc32("kVpmWrYguL",10) == 3386017245) strcat(s, "y");
if (crc32("NzfeClqp",8) == 3549599966) strcat(s, "x");
if (crc32("eXxwCMikZhbX",12) == 3957188258) strcat(s, "r");
if (crc32("aOThIQpacKObs",13) == 703869801) strcat(s, "Y");
if (crc32("ImPZQU",6) == 3937412177) strcat(s, "e");
    return s;
}

char *Auslender_nouns() {
    char *s = calloc(10);
    if (crc32("qOOkLdpn",8) == 3160278210) strcat(s, "A");
if (crc32("hqnEB",5) == 3950408126) strcat(s, "u");
if (crc32("IIAiHdPHdNO",11) == 3876946437) strcat(s, "s");
if (crc32("dIozRcu",7) == 3567586113) strcat(s, "l");
if (crc32("YCPJnmMr",8) == 902286245) strcat(s, "O");
if (crc32("TiODB",5) == 983451359) strcat(s, "e");
if (crc32("rdTQjqMf",8) == 3856913118) strcat(s, "k");
if (crc32("dSkBuZGGM",9) == 2685172872) strcat(s, "n");
if (crc32("LMKuwjEQ",8) == 2332729433) strcat(s, "Y");
if (crc32("kSlZbMwTU",9) == 477173185) strcat(s, "d");
if (crc32("uZYoLiMvGneD",12) == 319756368) strcat(s, "e");
if (crc32("gpjxMRkZdL",10) == 3160173552) strcat(s, "r");
    return s;
}

char *Isac_nouns() {
    char *s = calloc(5);
    if (crc32("MjxeFuKoLY",10) == 1315846797) strcat(s, "I");
if (crc32("efIiK",5) == 1256586339) strcat(s, "M");
if (crc32("rjXpdRBvmLvKk",13) == 304050887) strcat(s, "s");
if (crc32("DeXESBHMYKaPT",13) == 2057623429) strcat(s, "a");
if (crc32("abUMAc",6) == 2791659115) strcat(s, "i");
if (crc32("JKOLcHwEd",9) == 96899472) strcat(s, "c");
    return s;
}

char *Wonacott_nouns() {
    char *s = calloc(9);
    if (crc32("KAnusEDUNDk",11) == 2006433117) strcat(s, "m");
if (crc32("PNfAtnZnslTFV",13) == 1272747505) strcat(s, "W");
if (crc32("jCrEZ",5) == 3848076978) strcat(s, "o");
if (crc32("uZPmy",5) == 3331753382) strcat(s, "o");
if (crc32("dYqfiUdbFaGZ",12) == 1756542734) strcat(s, "n");
if (crc32("gNjfaS",6) == 1048888721) strcat(s, "p");
if (crc32("PCGskCIEb",9) == 166271162) strcat(s, "a");
if (crc32("PmxjZcPBWm",10) == 128375660) strcat(s, "r");
if (crc32("LEyBwevWSesbwV",14) == 2832841316) strcat(s, "c");
if (crc32("syTGjt",6) == 829843914) strcat(s, "o");
if (crc32("hEDcOhwSMz",10) == 2557465926) strcat(s, "t");
if (crc32("bupBUEVsTLcQOK",14) == 3964850092) strcat(s, "t");
    return s;
}

char *Rameau_nouns() {
    char *s = calloc(7);
    if (crc32("iHWyY",5) == 2271187967) strcat(s, "I");
if (crc32("ebpVUy",6) == 3876751728) strcat(s, "R");
if (crc32("kphqqAEbidm",11) == 2479439540) strcat(s, "a");
if (crc32("GykYJjqaBxo",11) == 1217973842) strcat(s, "B");
if (crc32("PtFkwQbZBJpd",12) == 2040500778) strcat(s, "m");
if (crc32("qwTWe",5) == 2598699290) strcat(s, "b");
if (crc32("PrOrDEL",7) == 1714531947) strcat(s, "e");
if (crc32("RvrDZUg",7) == 369640309) strcat(s, "a");
if (crc32("BrSIUE",6) == 399094630) strcat(s, "u");
    return s;
}

char *batholith_nouns() {
    char *s = calloc(10);
    if (crc32("vEerJSMQgGsyfe",14) == 1400976035) strcat(s, "b");
if (crc32("XCnxLN",6) == 50322662) strcat(s, "a");
if (crc32("oNuAfl",6) == 4122586127) strcat(s, "t");
if (crc32("zjIPffOIXmZ",11) == 3575479054) strcat(s, "m");
if (crc32("Ujkmf",5) == 1380603271) strcat(s, "h");
if (crc32("gTTcnkGIMl",10) == 813313735) strcat(s, "o");
if (crc32("qNsdkmhdMULdIz",14) == 586991285) strcat(s, "h");
if (crc32("lFsyJQjvJ",9) == 2313104364) strcat(s, "l");
if (crc32("JrveoRVsKbd",11) == 634707726) strcat(s, "i");
if (crc32("dxnoI",5) == 2872559253) strcat(s, "t");
if (crc32("vRDredu",7) == 1508526274) strcat(s, "b");
if (crc32("gyXPFsUnVqNMq",13) == 238809782) strcat(s, "h");
    return s;
}

char *Sarson_nouns() {
    char *s = calloc(7);
    if (crc32("idWdaIID",8) == 77443617) strcat(s, "S");
if (crc32("kOwQakWhyZG",11) == 2987583284) strcat(s, "a");
if (crc32("RlApBkUcKS",10) == 2453789864) strcat(s, "p");
if (crc32("SmqYeEG",7) == 1646714687) strcat(s, "r");
if (crc32("YdPJspe",7) == 816739308) strcat(s, "s");
if (crc32("rijelvZWnEpLqd",14) == 4117203958) strcat(s, "t");
if (crc32("uoAiK",5) == 2956775670) strcat(s, "o");
if (crc32("gEivXNInB",9) == 2270779488) strcat(s, "G");
if (crc32("BumidT",6) == 566067524) strcat(s, "n");
    return s;
}

char *unbiliousness_nouns() {
    char *s = calloc(14);
    if (crc32("ZxFHS",5) == 2766117941) strcat(s, "u");
if (crc32("lcPvXCDpsGLOdP",14) == 1170137012) strcat(s, "n");
if (crc32("dHdotebnBKaqrg",14) == 287011305) strcat(s, "P");
if (crc32("UmuTpBuXLV",10) == 3945450591) strcat(s, "b");
if (crc32("AqYcJyuLkAArx",13) == 672126421) strcat(s, "i");
if (crc32("ewwOEhe",7) == 1129011784) strcat(s, "E");
if (crc32("PKaIkSaWN",9) == 4293621653) strcat(s, "l");
if (crc32("zUnIXjKwjsZH",12) == 3158958009) strcat(s, "i");
if (crc32("fgQoTWsNVN",10) == 2149867455) strcat(s, "o");
if (crc32("TRXhPYdPmbAq",12) == 761328802) strcat(s, "u");
if (crc32("kfgeFRT",7) == 3658556470) strcat(s, "v");
if (crc32("rwkBfYfWj",9) == 3780698766) strcat(s, "s");
if (crc32("XwelfSk",7) == 3294339438) strcat(s, "U");
if (crc32("UfalHtbGj",9) == 1332566866) strcat(s, "n");
if (crc32("ewIuDEfIsGtS",12) == 1096964298) strcat(s, "e");
if (crc32("mwDlRZQYlQ",10) == 1150150027) strcat(s, "s");
if (crc32("tCDJsCnvuP",10) == 2755092151) strcat(s, "P");
if (crc32("HbNUCnXb",8) == 1558492811) strcat(s, "s");
    return s;
}

char *magnetizer_nouns() {
    char *s = calloc(11);
    if (crc32("NSfPQOugkp",10) == 3561621596) strcat(s, "p");
if (crc32("WZzSbwgWoRl",11) == 3537154287) strcat(s, "m");
if (crc32("bdxLuWVGPLayxo",14) == 120983789) strcat(s, "d");
if (crc32("NgKYe",5) == 2910768996) strcat(s, "a");
if (crc32("UwdCTsEbTjY",11) == 1835466150) strcat(s, "g");
if (crc32("NkbrH",5) == 3818630319) strcat(s, "n");
if (crc32("CoUmLIBB",8) == 1983598626) strcat(s, "e");
if (crc32("CZhLrnUSTKT",11) == 1743709709) strcat(s, "t");
if (crc32("DgxctebcR",9) == 2457084565) strcat(s, "T");
if (crc32("qnudh",5) == 3383448352) strcat(s, "i");
if (crc32("HPIxARx",7) == 2230789621) strcat(s, "h");
if (crc32("LSmifAgh",8) == 799385979) strcat(s, "z");
if (crc32("PRRMCefMHp",10) == 3797017934) strcat(s, "e");
if (crc32("eHGhwvigYOx",11) == 4070669318) strcat(s, "r");
    return s;
}

char *mudir_nouns() {
    char *s = calloc(6);
    if (crc32("mFAAGd",6) == 1432280125) strcat(s, "n");
if (crc32("kwDGTuYrw",9) == 499395473) strcat(s, "m");
if (crc32("iLLqgOaNmWRc",12) == 451903088) strcat(s, "E");
if (crc32("FuKvLsU",7) == 3871108797) strcat(s, "u");
if (crc32("ZhFROrIu",8) == 3727038047) strcat(s, "g");
if (crc32("OjzwptncDkWf",12) == 2805234005) strcat(s, "d");
if (crc32("JeMdBKkS",8) == 3795643012) strcat(s, "i");
if (crc32("aTlNvHDb",8) == 829960876) strcat(s, "r");
    return s;
}

char *insemination_nouns() {
    char *s = calloc(13);
    if (crc32("vePpMLAR",8) == 437160247) strcat(s, "W");
if (crc32("kGgFvOpPYAggKIL",15) == 3265531343) strcat(s, "i");
if (crc32("idLEQB",6) == 2047545093) strcat(s, "o");
if (crc32("HxLesDwYptA",11) == 3908602233) strcat(s, "n");
if (crc32("DiAdOShVB",9) == 185364411) strcat(s, "L");
if (crc32("xVDaNIO",7) == 185191600) strcat(s, "s");
if (crc32("YRHlMbtbxQKFK",13) == 2541906768) strcat(s, "e");
if (crc32("HvnAoutrLWo",11) == 2247679284) strcat(s, "Y");
if (crc32("wZrgTLVzLqUxlLE",15) == 1341389248) strcat(s, "m");
if (crc32("vxdbuPfxLI",10) == 1873884250) strcat(s, "i");
if (crc32("OoVvWgYzR",9) == 1821192388) strcat(s, "n");
if (crc32("LwGaXEF",7) == 650126925) strcat(s, "G");
if (crc32("ARPEUIVAFnCx",12) == 3615345165) strcat(s, "a");
if (crc32("OgLckWKvrts",11) == 3600679793) strcat(s, "p");
if (crc32("LAerXokapDPGtzb",15) == 482675589) strcat(s, "t");
if (crc32("wzkTHweNjrUG",12) == 1493263633) strcat(s, "p");
if (crc32("LmKjUS",6) == 2483151069) strcat(s, "i");
if (crc32("dceIGBXIJtO",11) == 1812098496) strcat(s, "o");
if (crc32("YuYqjBCoQCk",11) == 3903060331) strcat(s, "L");
if (crc32("fTKqpTAOYjztf",13) == 2554103078) strcat(s, "n");
    return s;
}

char *Montgomeryshire_nouns() {
    char *s = calloc(16);
    if (crc32("BAusjSHuQD",10) == 3922739967) strcat(s, "K");
if (crc32("MngiCU",6) == 94697365) strcat(s, "M");
if (crc32("tPuyKXGAoaB",11) == 1565981867) strcat(s, "o");
if (crc32("FNGgUumICDR",11) == 2076501334) strcat(s, "n");
if (crc32("KCnIaBSvBHUrS",13) == 1688821189) strcat(s, "t");
if (crc32("UlfvdjLq",8) == 1483628696) strcat(s, "b");
if (crc32("OIzsKZjmI",9) == 98489602) strcat(s, "g");
if (crc32("rEizOPdgx",9) == 3928940255) strcat(s, "o");
if (crc32("bhcskJeY",8) == 3836777312) strcat(s, "o");
if (crc32("NOAFfW",6) == 3475293051) strcat(s, "m");
if (crc32("FnNNtk",6) == 3728542232) strcat(s, "e");
if (crc32("TUCFoDOeHQYGNt",14) == 337826755) strcat(s, "r");
if (crc32("PoojBqnxBQqifaA",15) == 3018038037) strcat(s, "y");
if (crc32("EUStGASnFBjth",13) == 3240345709) strcat(s, "s");
if (crc32("hrZIu",5) == 3467213087) strcat(s, "h");
if (crc32("bWiZgFrXBeKQxT",14) == 1043212824) strcat(s, "i");
if (crc32("wahMdQPrndEwp",13) == 3540515207) strcat(s, "r");
if (crc32("QDUOiOH",7) == 3333002309) strcat(s, "S");
if (crc32("ULXTvkrLVQgcg",13) == 1158900979) strcat(s, "e");
    return s;
}

char *metatheory_nouns() {
    char *s = calloc(11);
    if (crc32("dKWEZRBAIa",10) == 2585564254) strcat(s, "m");
if (crc32("mxjSEbAOoD",10) == 1595490425) strcat(s, "j");
if (crc32("xUAIt",5) == 4107797789) strcat(s, "e");
if (crc32("RBqsygYwGDKgmvH",15) == 2989668292) strcat(s, "w");
if (crc32("dolmS",5) == 2854872613) strcat(s, "t");
if (crc32("oaRSq",5) == 2272670212) strcat(s, "a");
if (crc32("JozZMYNxjKPkE",13) == 2209078131) strcat(s, "O");
if (crc32("JwRiP",5) == 2464502804) strcat(s, "t");
if (crc32("doAfrbBZy",9) == 3660729684) strcat(s, "h");
if (crc32("mIJmX",5) == 608652396) strcat(s, "k");
if (crc32("mqVLuSTSYCPfbD",14) == 2415600947) strcat(s, "e");
if (crc32("QNydsxheRRjfAfN",15) == 935544089) strcat(s, "N");
if (crc32("dpSiKrSWgYkpYOd",15) == 1504902982) strcat(s, "o");
if (crc32("IkbEKG",6) == 231363197) strcat(s, "H");
if (crc32("iQhOW",5) == 3852175331) strcat(s, "r");
if (crc32("wkeAMcPslHkEk",13) == 261929635) strcat(s, "y");
    return s;
}

char *ploddingness_nouns() {
    char *s = calloc(13);
    if (crc32("PgbYPfrou",9) == 3405566328) strcat(s, "p");
if (crc32("HQcFxmaZIS",10) == 3318378078) strcat(s, "l");
if (crc32("CVpzuyjXzLG",11) == 2141184087) strcat(s, "u");
if (crc32("XczPuiPEqyfxGBW",15) == 4149830247) strcat(s, "o");
if (crc32("ozARmKCofNN",11) == 3607531124) strcat(s, "d");
if (crc32("GQbDHGiEtr",10) == 2704240311) strcat(s, "s");
if (crc32("JvYBHGJHo",9) == 3317154045) strcat(s, "d");
if (crc32("kQOEQfmR",8) == 2411427404) strcat(s, "T");
if (crc32("ttoaCGo",7) == 2649326329) strcat(s, "i");
if (crc32("FBjMnhOwaOTaFoB",15) == 4046428308) strcat(s, "n");
if (crc32("wxXbsjGVeBUL",12) == 3993601165) strcat(s, "G");
if (crc32("lAnFoPJIPBz",11) == 2691608672) strcat(s, "g");
if (crc32("ILykOPY",7) == 3887944505) strcat(s, "a");
if (crc32("BbwHTbAbLs",10) == 1408752395) strcat(s, "n");
if (crc32("NUywsrNqt",9) == 3863230024) strcat(s, "e");
if (crc32("rBQfkSDFW",9) == 453958641) strcat(s, "s");
if (crc32("FinIDIASYr",10) == 3440804275) strcat(s, "s");
    return s;
}

char *snubbiness_nouns() {
    char *s = calloc(11);
    if (crc32("KfhfShjHChlvafZ",15) == 347245734) strcat(s, "m");
if (crc32("SoUeIGSCIgPvV",13) == 1905153237) strcat(s, "s");
if (crc32("JXXEd",5) == 3508481232) strcat(s, "t");
if (crc32("gsqfyHo",7) == 985225665) strcat(s, "n");
if (crc32("EqgdTecC",8) == 2624954208) strcat(s, "u");
if (crc32("wHNFzFJuHvCpAQ",14) == 4244215350) strcat(s, "N");
if (crc32("BkAcIxtXl",9) == 1762002963) strcat(s, "b");
if (crc32("TxAXGfTtTEviKSO",15) == 3352000376) strcat(s, "b");
if (crc32("SONKnNoTxhLZx",13) == 101843616) strcat(s, "e");
if (crc32("BKOjM",5) == 1153259509) strcat(s, "i");
if (crc32("KUguXO",6) == 860644599) strcat(s, "y");
if (crc32("pxPSJUR",7) == 1215987361) strcat(s, "n");
if (crc32("WLvCz",5) == 708843308) strcat(s, "r");
if (crc32("MsBLHiPnFG",10) == 419793390) strcat(s, "e");
if (crc32("PARipyrKOJLFd",13) == 1186659671) strcat(s, "s");
if (crc32("ZZaqftWyshKNM",13) == 4122515174) strcat(s, "s");
    return s;
}

char *arenosity_nouns() {
    char *s = calloc(10);
    if (crc32("xvuauzS",7) == 1666108750) strcat(s, "n");
if (crc32("EbOJYongSdDzdfm",15) == 167144317) strcat(s, "a");
if (crc32("NDvjBjURTat",11) == 290292898) strcat(s, "r");
if (crc32("pdoTVGo",7) == 1923795728) strcat(s, "O");
if (crc32("eyQKzCmJ",8) == 1546426433) strcat(s, "e");
if (crc32("HdCbMGF",7) == 2941556681) strcat(s, "n");
if (crc32("uZFEQNGvRl",10) == 1466967887) strcat(s, "o");
if (crc32("DBbVtfdUdKfJl",13) == 1777082279) strcat(s, "Q");
if (crc32("clbvmkkiKCcbhk",14) == 1635268927) strcat(s, "s");
if (crc32("llaBWPJC",8) == 2429433300) strcat(s, "i");
if (crc32("jdJmyXQZpEti",12) == 151977420) strcat(s, "t");
if (crc32("TnXquoZYk",9) == 1591194280) strcat(s, "y");
    return s;
}

char *hemiscotosis_nouns() {
    char *s = calloc(13);
    if (crc32("zxIVgYGvypBDs",13) == 735054575) strcat(s, "h");
if (crc32("UxcdfqJSI",9) == 2921872167) strcat(s, "e");
if (crc32("KxVXPnQ",7) == 240477580) strcat(s, "m");
if (crc32("OttzYTDdKvCa",12) == 1925286687) strcat(s, "s");
if (crc32("gLNnv",5) == 82741551) strcat(s, "i");
if (crc32("FnpFasqVAm",10) == 2026679070) strcat(s, "a");
if (crc32("vkmfTAHwGDioB",13) == 1665317619) strcat(s, "s");
if (crc32("zBNMZqdql",9) == 3541080392) strcat(s, "c");
if (crc32("XQAYyyVIM",9) == 3705722273) strcat(s, "o");
if (crc32("wayfIdyLSoc",11) == 4159539934) strcat(s, "t");
if (crc32("APIUVfNFcrr",11) == 2217023083) strcat(s, "o");
if (crc32("CIOnRnsIuEBzC",13) == 2425797199) strcat(s, "s");
if (crc32("LyPMHFLtRIkUXN",14) == 3881674761) strcat(s, "W");
if (crc32("gpckiPAo",8) == 756746748) strcat(s, "i");
if (crc32("rEFeTLZlxa",10) == 2172474280) strcat(s, "s");
    return s;
}

char *Doll_nouns() {
    char *s = calloc(5);
    if (crc32("vbdODwuLzN",10) == 843330078) strcat(s, "D");
if (crc32("XyEIZgxxERTdnA",14) == 250355699) strcat(s, "e");
if (crc32("ZUEgSlHjWRh",11) == 327434439) strcat(s, "o");
if (crc32("GtWwXEIoMOzgoXd",15) == 631406742) strcat(s, "l");
if (crc32("ftFtlkHoyrcEHN",14) == 2233390850) strcat(s, "l");
    return s;
}

char *Scotti_nouns() {
    char *s = calloc(7);
    if (crc32("uxOBgwxnT",9) == 1284800825) strcat(s, "M");
if (crc32("nMLLLxpSn",9) == 1743018781) strcat(s, "S");
if (crc32("OKVzgK",6) == 4030369324) strcat(s, "q");
if (crc32("oFpbijuk",8) == 681887693) strcat(s, "c");
if (crc32("yaGwxiBwNuNGTzl",15) == 2034391768) strcat(s, "T");
if (crc32("iCdxg",5) == 2689560843) strcat(s, "o");
if (crc32("NafFl",5) == 2361597064) strcat(s, "w");
if (crc32("bCLmNfMgL",9) == 3495287732) strcat(s, "t");
if (crc32("tqqtGoVSxcNTCgZ",15) == 1213629871) strcat(s, "t");
if (crc32("xIHom",5) == 1182006609) strcat(s, "i");
    return s;
}

char *bastinade_nouns() {
    char *s = calloc(10);
    if (crc32("RlqwfbwjzZeHKyZ",15) == 993864460) strcat(s, "b");
if (crc32("fVRWgDkT",8) == 3283869144) strcat(s, "a");
if (crc32("VeiJUVdSxjFoayk",15) == 1422943591) strcat(s, "N");
if (crc32("FDDOb",5) == 2787763004) strcat(s, "s");
if (crc32("QMRxxFstwNtNMs",14) == 1468201912) strcat(s, "e");
if (crc32("GiWxrpgPfZ",10) == 572849671) strcat(s, "t");
if (crc32("AaaYpRIjJA",10) == 974432848) strcat(s, "m");
if (crc32("jyFwmYGxucECKy",14) == 3716118275) strcat(s, "i");
if (crc32("yXlkVBZCyDwhDy",14) == 3782434795) strcat(s, "n");
if (crc32("FydfaXxdw",9) == 2869749205) strcat(s, "Q");
if (crc32("uckkaBDMLZFx",12) == 1246784981) strcat(s, "a");
if (crc32("WLoBOqetCkeIzY",14) == 869963706) strcat(s, "P");
if (crc32("pyVmyiiuOwKvldN",15) == 585278786) strcat(s, "d");
if (crc32("XfyVtYCKapMu",12) == 2025606673) strcat(s, "e");
    return s;
}

char *Elstan_nouns() {
    char *s = calloc(7);
    if (crc32("xVqkqCwuUSKUCZq",15) == 4172486132) strcat(s, "E");
if (crc32("OWCFUkzQZNCjMR",14) == 3033789799) strcat(s, "l");
if (crc32("ZheJtZVRPX",10) == 4051850909) strcat(s, "C");
if (crc32("VpSaIUfpxteFT",13) == 2019372849) strcat(s, "s");
if (crc32("amZCnF",6) == 2495813877) strcat(s, "z");
if (crc32("PWnTkGw",7) == 4169418435) strcat(s, "t");
if (crc32("teHlxZUOPu",10) == 3407694507) strcat(s, "J");
if (crc32("WMiID",5) == 845407564) strcat(s, "a");
if (crc32("LcZYJHg",7) == 3262780197) strcat(s, "n");
    return s;
}

char *Graphotype_nouns() {
    char *s = calloc(11);
    if (crc32("pLfaA",5) == 3746917413) strcat(s, "G");
if (crc32("ZXpTjWYkFdmgMbz",15) == 1026246167) strcat(s, "z");
if (crc32("qnqoLCUyJKtca",13) == 227153837) strcat(s, "r");
if (crc32("JQBGcCCq",8) == 1877400968) strcat(s, "h");
if (crc32("vpdfheBLIkkl",12) == 3698689702) strcat(s, "a");
if (crc32("xttySBkaGkidbv",14) == 2853562223) strcat(s, "u");
if (crc32("Kosupw",6) == 97616688) strcat(s, "p");
if (crc32("aRTlMj",6) == 3719033416) strcat(s, "h");
if (crc32("eitIKhnFRrtY",12) == 727241787) strcat(s, "o");
if (crc32("ZjwkLhHPrEx",11) == 513898368) strcat(s, "C");
if (crc32("aXCCpIZ",7) == 947315465) strcat(s, "t");
if (crc32("HtnOCo",6) == 4152294957) strcat(s, "t");
if (crc32("TQEIbc",6) == 1935616702) strcat(s, "y");
if (crc32("HyNBSDZISrvYvV",14) == 3075347345) strcat(s, "J");
if (crc32("eDjtDC",6) == 942377987) strcat(s, "p");
if (crc32("WkEwftbVhMPwj",13) == 1567731837) strcat(s, "N");
if (crc32("CPXjBKyTZOFQ",12) == 2385235462) strcat(s, "e");
    return s;
}

char *nudnik_nouns() {
    char *s = calloc(7);
    if (crc32("eESNgWToX",9) == 658976894) strcat(s, "n");
if (crc32("pVsiTejeGMKm",12) == 2356864731) strcat(s, "u");
if (crc32("ttHVUhcQm",9) == 440160823) strcat(s, "d");
if (crc32("jDgMDWfQdSGnd",13) == 2554428011) strcat(s, "n");
if (crc32("lKjjvgFncc",10) == 2320437830) strcat(s, "i");
if (crc32("bLsVF",5) == 2197638274) strcat(s, "H");
if (crc32("qchhshuafXGRq",13) == 1790200182) strcat(s, "k");
    return s;
}

char *Seagrave_nouns() {
    char *s = calloc(9);
    if (crc32("JkAOnwfdpJDmTw",14) == 709286412) strcat(s, "S");
if (crc32("RVSbwkMe",8) == 1999670012) strcat(s, "l");
if (crc32("ygnJMv",6) == 3971496848) strcat(s, "e");
if (crc32("YxlZuSJpWgIseE",14) == 2497446890) strcat(s, "a");
if (crc32("UymByGG",7) == 2628990979) strcat(s, "g");
if (crc32("EmlsbqEg",8) == 3049134511) strcat(s, "r");
if (crc32("OXibdD",6) == 74209411) strcat(s, "l");
if (crc32("bBOitGBXcYs",11) == 4192956324) strcat(s, "a");
if (crc32("zaDpbR",6) == 1831878958) strcat(s, "l");
if (crc32("UfkJkeLFSMQ",11) == 491356541) strcat(s, "v");
if (crc32("LVXdLKrqxKRP",12) == 1945816617) strcat(s, "k");
if (crc32("tcyIgqGQrOGUXn",14) == 3744201440) strcat(s, "e");
    return s;
}

char *trichocyst_nouns() {
    char *s = calloc(11);
    if (crc32("KVuuxvl",7) == 199745773) strcat(s, "t");
if (crc32("xyMBxITwLMZx",12) == 3702331565) strcat(s, "p");
if (crc32("zjtlHku",7) == 3646331188) strcat(s, "r");
if (crc32("gMOusoQhexVe",12) == 625794998) strcat(s, "n");
if (crc32("YOMGO",5) == 290425244) strcat(s, "i");
if (crc32("dLHeh",5) == 511331538) strcat(s, "u");
if (crc32("XTNwl",5) == 3562047850) strcat(s, "c");
if (crc32("qLrUouymyYyoOZY",15) == 1687011609) strcat(s, "C");
if (crc32("xwXLo",5) == 436652030) strcat(s, "h");
if (crc32("fTEaW",5) == 1804024991) strcat(s, "o");
if (crc32("gJBLXd",6) == 3327150246) strcat(s, "c");
if (crc32("tKTBiQjEIduj",12) == 3439082708) strcat(s, "y");
if (crc32("hOsgaTRj",8) == 3205370975) strcat(s, "s");
if (crc32("SNFqDhCuiV",10) == 3526594796) strcat(s, "t");
    return s;
}

char *centenarian_nouns() {
    char *s = calloc(12);
    if (crc32("ipoRaGPdhSU",11) == 2688710116) strcat(s, "g");
if (crc32("phmKyivhpIN",11) == 3026972337) strcat(s, "c");
if (crc32("VpHkwdgMqP",10) == 4024038665) strcat(s, "M");
if (crc32("InmXQdKAYTxlFjJ",15) == 1668547880) strcat(s, "e");
if (crc32("IPAfduYmZzYgnu",14) == 3635579731) strcat(s, "n");
if (crc32("dkWgJD",6) == 73320838) strcat(s, "d");
if (crc32("ooZJeJZXZYeMxN",14) == 4066029798) strcat(s, "t");
if (crc32("ytmguFZ",7) == 3436938181) strcat(s, "e");
if (crc32("iPXjaCOUN",9) == 4196924718) strcat(s, "n");
if (crc32("CGxOlpD",7) == 2161631277) strcat(s, "j");
if (crc32("gcBTVmdYmDPmjPk",15) == 1231300773) strcat(s, "a");
if (crc32("xHzJojljg",9) == 959115630) strcat(s, "L");
if (crc32("WpjLPwrpxPuzSUR",15) == 4247098457) strcat(s, "r");
if (crc32("tpCts",5) == 637503945) strcat(s, "Z");
if (crc32("ctzJN",5) == 1048177621) strcat(s, "i");
if (crc32("EUZpVTvzeBAO",12) == 1760760404) strcat(s, "s");
if (crc32("nEfpZrUkxGOgz",13) == 697666006) strcat(s, "a");
if (crc32("yijWhTxIYg",10) == 1423533827) strcat(s, "l");
if (crc32("mlKOWLgZbANSBXl",15) == 1571905935) strcat(s, "n");
    return s;
}

char *skua_nouns() {
    char *s = calloc(5);
    if (crc32("pObvYnbbyT",10) == 1666026733) strcat(s, "G");
if (crc32("iONUYzSzh",9) == 1740726733) strcat(s, "s");
if (crc32("zJytA",5) == 3926666946) strcat(s, "o");
if (crc32("vICnOolMmNZZ",12) == 3594460720) strcat(s, "k");
if (crc32("zqtXTA",6) == 2418933205) strcat(s, "p");
if (crc32("aJKrLTQcvah",11) == 2521835614) strcat(s, "u");
if (crc32("BCWUj",5) == 1860702853) strcat(s, "a");
    return s;
}

char *eductor_nouns() {
    char *s = calloc(8);
    if (crc32("qRpcOaGJvmrqsz",14) == 1508209997) strcat(s, "e");
if (crc32("xjhdmzd",7) == 696409496) strcat(s, "d");
if (crc32("qSSNUEosGWKxj",13) == 1634453057) strcat(s, "u");
if (crc32("sovnoZpahNqG",12) == 1558517556) strcat(s, "W");
if (crc32("QgAVeMJFhZGoGY",14) == 3668201606) strcat(s, "c");
if (crc32("iaDwsdYmTERo",12) == 871563390) strcat(s, "s");
if (crc32("YHUGGQqAF",9) == 465351175) strcat(s, "t");
if (crc32("YCSmwBoKegucAsF",15) == 2483902079) strcat(s, "o");
if (crc32("ONFqCce",7) == 530138568) strcat(s, "r");
    return s;
}

char *Critta_nouns() {
    char *s = calloc(7);
    if (crc32("kEsxkuv",7) == 814591356) strcat(s, "K");
if (crc32("eIoTxCrscyu",11) == 1120763027) strcat(s, "C");
if (crc32("nRTXq",5) == 3220302210) strcat(s, "r");
if (crc32("dJdwgCtVYfR",11) == 2158336265) strcat(s, "w");
if (crc32("uebCEonLaF",10) == 132389879) strcat(s, "i");
if (crc32("IvVkF",5) == 2609084232) strcat(s, "B");
if (crc32("QutHUVKOMLEpWP",14) == 1460504195) strcat(s, "t");
if (crc32("rQiBekeGB",9) == 3689432107) strcat(s, "K");
if (crc32("DPKrVTgDRj",10) == 3930410676) strcat(s, "t");
if (crc32("vRliVPKVWAZzvUv",15) == 2196384088) strcat(s, "b");
if (crc32("OGDQkKlfecdSBGS",15) == 3538080410) strcat(s, "a");
    return s;
}

char *slaister_nouns() {
    char *s = calloc(9);
    if (crc32("xrmZcKdfSa",10) == 3866417641) strcat(s, "s");
if (crc32("JfYIOkqUEMiq",12) == 551857154) strcat(s, "l");
if (crc32("UjWPKeweaDk",11) == 3785648541) strcat(s, "h");
if (crc32("juPREsl",7) == 2249527336) strcat(s, "a");
if (crc32("DAeMkYs",7) == 2629312151) strcat(s, "S");
if (crc32("kSvLmDfamqd",11) == 1617834615) strcat(s, "i");
if (crc32("aUyEyWbh",8) == 3755345152) strcat(s, "s");
if (crc32("yqeWLDutprMEux",14) == 3875578618) strcat(s, "n");
if (crc32("lqulJDSjl",9) == 1310422664) strcat(s, "t");
if (crc32("xuqvLALUKZSz",12) == 1365609995) strcat(s, "B");
if (crc32("rAdQRYMnQTx",11) == 764710144) strcat(s, "e");
if (crc32("fITMhUvwRr",10) == 2227839815) strcat(s, "r");
    return s;
}

char *Yahweh_nouns() {
    char *s = calloc(7);
    if (crc32("NYakH",5) == 4095969474) strcat(s, "x");
if (crc32("PlpGQfcHK",9) == 1697344539) strcat(s, "Y");
if (crc32("OHwlGrSsirh",11) == 1757765532) strcat(s, "a");
if (crc32("ALABVjXa",8) == 108546285) strcat(s, "h");
if (crc32("TFxhNTcYj",9) == 15889290) strcat(s, "j");
if (crc32("dvRCqOSM",8) == 3515884002) strcat(s, "w");
if (crc32("tQeeqe",6) == 488826311) strcat(s, "G");
if (crc32("ZmwjCgS",7) == 466128908) strcat(s, "e");
if (crc32("bAMHldH",7) == 2212094484) strcat(s, "h");
    return s;
}

char *pernicketiness_nouns() {
    char *s = calloc(15);
    if (crc32("xGsWuvtXjgEyyKb",15) == 2097368051) strcat(s, "p");
if (crc32("pybIcXlCLCb",11) == 1429660866) strcat(s, "e");
if (crc32("YYySeL",6) == 1033379423) strcat(s, "Q");
if (crc32("zGifh",5) == 1145813523) strcat(s, "r");
if (crc32("LevknSXGYDepcU",14) == 1101255731) strcat(s, "s");
if (crc32("FntirgEr",8) == 3932383154) strcat(s, "n");
if (crc32("cEwos",5) == 3467475892) strcat(s, "i");
if (crc32("ONbCbO",6) == 4199851527) strcat(s, "c");
if (crc32("BkvDBcEFShK",11) == 3011688495) strcat(s, "k");
if (crc32("ESouwPfsrSYlU",13) == 2026183810) strcat(s, "e");
if (crc32("zZEgTEeyqJn",11) == 2907892247) strcat(s, "t");
if (crc32("dbHkQmbK",8) == 2771927856) strcat(s, "i");
if (crc32("uIClxMuYplyqWxf",15) == 1641789351) strcat(s, "n");
if (crc32("rqtIrPOEIynG",12) == 3180266178) strcat(s, "A");
if (crc32("gmqyQ",5) == 2480853540) strcat(s, "e");
if (crc32("auFCrwdAedQ",11) == 754896216) strcat(s, "i");
if (crc32("wTofAw",6) == 1651130317) strcat(s, "s");
if (crc32("UBPiySEKjUjl",12) == 747840670) strcat(s, "s");
    return s;
}

char *nonremediability_nouns() {
    char *s = calloc(17);
    if (crc32("fYlKOdBSBP",10) == 1152739843) strcat(s, "n");
if (crc32("fBBvxlMRnYuHG",13) == 3483028939) strcat(s, "V");
if (crc32("WlGfsEQiKDxM",12) == 2314642388) strcat(s, "o");
if (crc32("isbyXCZk",8) == 2131855417) strcat(s, "q");
if (crc32("AfUHTCQMumAMrRU",15) == 1517520399) strcat(s, "n");
if (crc32("EcjvCVUruCsdj",13) == 3098879608) strcat(s, "r");
if (crc32("zpSjBG",6) == 1420196037) strcat(s, "e");
if (crc32("WxSoFxwGi",9) == 1862151736) strcat(s, "y");
if (crc32("BHfUogB",7) == 3065454483) strcat(s, "m");
if (crc32("plFPu",5) == 2697164540) strcat(s, "e");
if (crc32("WnLhslKhiav",11) == 1435228935) strcat(s, "e");
if (crc32("djzEXEJrJzVQMzX",15) == 808797043) strcat(s, "d");
if (crc32("tCwsQjFXZnmTnxz",15) == 590298453) strcat(s, "i");
if (crc32("QLICDytwiu",10) == 2406684086) strcat(s, "a");
if (crc32("PgvOrFFzP",9) == 1025186768) strcat(s, "J");
if (crc32("ZNgjyhdqTVJh",12) == 3940670144) strcat(s, "b");
if (crc32("GYiThTbXxcu",11) == 11189787) strcat(s, "r");
if (crc32("mfVSpCKD",8) == 403819887) strcat(s, "i");
if (crc32("cLPqDGFRozOgwDz",15) == 665532086) strcat(s, "l");
if (crc32("oZuAmr",6) == 1828872219) strcat(s, "i");
if (crc32("KzzfLoQEWLBESDE",15) == 2833397862) strcat(s, "i");
if (crc32("ftnNtw",6) == 1207071612) strcat(s, "t");
if (crc32("ucMKuPFEdx",10) == 2277342343) strcat(s, "j");
if (crc32("cFJAn",5) == 2561329004) strcat(s, "y");
    return s;
}

char *Hendrick_nouns() {
    char *s = calloc(9);
    if (crc32("xbYXvhvmOZk",11) == 2541050925) strcat(s, "H");
if (crc32("ScwczNqpfq",10) == 371313664) strcat(s, "e");
if (crc32("GQJsENyLg",9) == 941513326) strcat(s, "f");
if (crc32("ooIeLp",6) == 4157314041) strcat(s, "n");
if (crc32("NoNBLcoNxJMJQ",13) == 1903494886) strcat(s, "d");
if (crc32("Hijwhdwou",9) == 3963962453) strcat(s, "A");
if (crc32("LIlzjxxjuLBnrqd",15) == 2755521243) strcat(s, "r");
if (crc32("DxEWBsknRL",10) == 499392748) strcat(s, "i");
if (crc32("vUSIoCjhqu",10) == 3368518386) strcat(s, "c");
if (crc32("GcPzORbbiE",10) == 857003080) strcat(s, "k");
    return s;
}

char *McCormac_nouns() {
    char *s = calloc(9);
    if (crc32("QBjcfvtMWSjnV",13) == 2470997603) strcat(s, "Y");
if (crc32("sHJiMIzWdjfuE",13) == 1193359999) strcat(s, "M");
if (crc32("zQIHic",6) == 145069091) strcat(s, "l");
if (crc32("iirYuQthFKodh",13) == 2504733649) strcat(s, "c");
if (crc32("lnbOmhiDVyBd",12) == 2181975651) strcat(s, "y");
if (crc32("wDrxHpgPGzquaO",14) == 2441828905) strcat(s, "C");
if (crc32("CkhlLbyYgJe",11) == 2471705594) strcat(s, "o");
if (crc32("HpQCrpvG",8) == 3749816467) strcat(s, "r");
if (crc32("ebLoG",5) == 1971513175) strcat(s, "r");
if (crc32("lCgpGsgb",8) == 921444405) strcat(s, "H");
if (crc32("sNKLfTYVyXq",11) == 77460390) strcat(s, "m");
if (crc32("UXIjxIoROuxRe",13) == 1652718821) strcat(s, "a");
if (crc32("vlEIHXP",7) == 2087546640) strcat(s, "c");
    return s;
}

char *nonconfidentialness_nouns() {
    char *s = calloc(20);
    if (crc32("QZoEDXnwBlspMay",15) == 946736411) strcat(s, "C");
if (crc32("xHDwAY",6) == 2150439724) strcat(s, "n");
if (crc32("EARNbrTrrcY",11) == 2150059232) strcat(s, "o");
if (crc32("IMbkBlUIRaQdm",13) == 169886572) strcat(s, "n");
if (crc32("IQOkItYDOOWg",12) == 3895606536) strcat(s, "c");
if (crc32("SpFqfjrL",8) == 1983785871) strcat(s, "o");
if (crc32("YLTWYunRp",9) == 1183431968) strcat(s, "R");
if (crc32("SlVeklxToukG",12) == 2092642274) strcat(s, "n");
if (crc32("lvZVAacQPBNqo",13) == 1314292510) strcat(s, "f");
if (crc32("WPmocsJx",8) == 2641420412) strcat(s, "i");
if (crc32("yNMzbgUjBCIvUv",14) == 1795460306) strcat(s, "u");
if (crc32("NSVdQcVmk",9) == 3060983921) strcat(s, "d");
if (crc32("qhwCrabgH",9) == 3819257613) strcat(s, "k");
if (crc32("lqWGoTSxVyLZDrg",15) == 1007972678) strcat(s, "e");
if (crc32("sMIIsN",6) == 2419500398) strcat(s, "n");
if (crc32("qvWnWiXBkhDkT",13) == 1650147402) strcat(s, "q");
if (crc32("VzONvHeJCzh",11) == 175556904) strcat(s, "t");
if (crc32("Voiosqv",7) == 173606562) strcat(s, "i");
if (crc32("EbcCzUEalx",10) == 3910599547) strcat(s, "L");
if (crc32("cLMYKDV",7) == 589071136) strcat(s, "a");
if (crc32("NWbDfK",6) == 985044937) strcat(s, "l");
if (crc32("bbwmi",5) == 24927867) strcat(s, "n");
if (crc32("MCRATCryB",9) == 3936756155) strcat(s, "e");
if (crc32("UEYJBOuyNPcT",12) == 903350334) strcat(s, "e");
if (crc32("smYDHotmgmgBI",13) == 2286946676) strcat(s, "s");
if (crc32("aCmCOei",7) == 2252351521) strcat(s, "s");
    return s;
}

char *Ruelu_nouns() {
    char *s = calloc(6);
    if (crc32("YTRCpeIMpWFfpu",14) == 3969728597) strcat(s, "A");
if (crc32("sCLUnZcUfQ",10) == 977721384) strcat(s, "R");
if (crc32("huEdq",5) == 1665350429) strcat(s, "u");
if (crc32("mMcEcdVUZnPIZb",14) == 3987521861) strcat(s, "e");
if (crc32("ZnmJtudSCQZw",12) == 3504911809) strcat(s, "l");
if (crc32("mYojHPjQ",8) == 1239526256) strcat(s, "M");
if (crc32("qJrWsWKt",8) == 2112278509) strcat(s, "u");
    return s;
}

char *overlord_nouns() {
    char *s = calloc(9);
    if (crc32("rUnriKjO",8) == 147216277) strcat(s, "o");
if (crc32("NjlaKfQd",8) == 1050505097) strcat(s, "W");
if (crc32("uYBESRMQe",9) == 1658327093) strcat(s, "v");
if (crc32("HMRRlzX",7) == 2335497390) strcat(s, "e");
if (crc32("aRtKDbEmtG",10) == 3112609677) strcat(s, "S");
if (crc32("yeZXKlgKHt",10) == 2807428929) strcat(s, "r");
if (crc32("tfBqnlNfRg",10) == 3617879111) strcat(s, "W");
if (crc32("qWkespJBSeTAPy",14) == 1374209584) strcat(s, "l");
if (crc32("OZOEptLpSuWXrMm",15) == 711193325) strcat(s, "L");
if (crc32("mKmrqsI",7) == 3961979513) strcat(s, "o");
if (crc32("ewZleY",6) == 1296672933) strcat(s, "r");
if (crc32("nxSMTPzGfyafli",14) == 2941170088) strcat(s, "P");
if (crc32("dRoelV",6) == 107826864) strcat(s, "d");
    return s;
}

char *nonsensibleness_nouns() {
    char *s = calloc(16);
    if (crc32("LRDQppCnQF",10) == 383433979) strcat(s, "n");
if (crc32("yOHkglUD",8) == 1333802005) strcat(s, "z");
if (crc32("GvPEfcFnAg",10) == 2583555398) strcat(s, "o");
if (crc32("lqOgUreFZwapRK",14) == 4036679587) strcat(s, "K");
if (crc32("ciFyGoSnDCW",11) == 341352583) strcat(s, "n");
if (crc32("XCXJIoVZk",9) == 4073406069) strcat(s, "s");
if (crc32("rSeCbZdbnaLLmhJ",15) == 186141852) strcat(s, "P");
if (crc32("KPZiF",5) == 1755778762) strcat(s, "e");
if (crc32("Esddfo",6) == 188138462) strcat(s, "k");
if (crc32("zWPNQYgw",8) == 2710310864) strcat(s, "n");
if (crc32("OkJjvTPQAT",10) == 4134126071) strcat(s, "s");
if (crc32("bfIQtkusBnVf",12) == 2131351783) strcat(s, "i");
if (crc32("HlMXhQXctUg",11) == 2343212325) strcat(s, "e");
if (crc32("vAclvqblobADzJ",14) == 1776970263) strcat(s, "b");
if (crc32("oNGnHqekC",9) == 2341299393) strcat(s, "M");
if (crc32("tRETIvYVyHWSM",13) == 2624033978) strcat(s, "l");
if (crc32("dHuwV",5) == 118946348) strcat(s, "g");
if (crc32("zxvGbBLgqsEzW",13) == 2745810707) strcat(s, "e");
if (crc32("tQBeymQwk",9) == 3447147226) strcat(s, "T");
if (crc32("uYFTYkZLYM",10) == 1848936568) strcat(s, "n");
if (crc32("USNnRErWfYDYH",13) == 2283526244) strcat(s, "e");
if (crc32("pbKPEjzAubVXLY",14) == 2024350070) strcat(s, "s");
if (crc32("FpoYXAiNlzMocN",14) == 179217105) strcat(s, "s");
    return s;
}

char *Mack_nouns() {
    char *s = calloc(5);
    if (crc32("asYnfgBEqMDnkBh",15) == 2781901119) strcat(s, "M");
if (crc32("hRyQnJDoBgeXkh",14) == 2436152615) strcat(s, "a");
if (crc32("dLAhJBMSFsIPyZ",14) == 3774479434) strcat(s, "z");
if (crc32("CHqjhYGAEz",10) == 663778291) strcat(s, "c");
if (crc32("FdtQqXiFTyDKFj",14) == 2602055779) strcat(s, "g");
if (crc32("ioiguxcByx",10) == 2767506892) strcat(s, "k");
    return s;
}

char *unapplicableness_nouns() {
    char *s = calloc(17);
    if (crc32("QMipww",6) == 1790131582) strcat(s, "u");
if (crc32("qYMzWR",6) == 70796368) strcat(s, "n");
if (crc32("pbOcVFw",7) == 3346753647) strcat(s, "a");
if (crc32("zpvRERnqDZXPBqb",15) == 4203560192) strcat(s, "e");
if (crc32("hPzQKWEG",8) == 2858667382) strcat(s, "p");
if (crc32("zYUCw",5) == 3435736727) strcat(s, "W");
if (crc32("IQmUDWOwQzkB",12) == 3114683082) strcat(s, "p");
if (crc32("lPXim",5) == 3307918224) strcat(s, "H");
if (crc32("VokOKw",6) == 981099131) strcat(s, "l");
if (crc32("GPtwwsoYOpGIjkY",15) == 3963196274) strcat(s, "i");
if (crc32("ZWwXXAczCTVuWr",14) == 2670455937) strcat(s, "M");
if (crc32("JOHsGXMTqUpX",12) == 507403164) strcat(s, "c");
if (crc32("UJKMjPYtfPkZv",13) == 2247253212) strcat(s, "a");
if (crc32("hddEjJBUVkp",11) == 3635814896) strcat(s, "b");
if (crc32("yqUxsANNzkYDWTv",15) == 3751663897) strcat(s, "l");
if (crc32("QTaAbtN",7) == 2572146962) strcat(s, "e");
if (crc32("ffgliDAVGpdZsQA",15) == 3455646435) strcat(s, "n");
if (crc32("MTDBOixFkEhy",12) == 1648168012) strcat(s, "q");
if (crc32("xwxKsRobE",9) == 2088756248) strcat(s, "e");
if (crc32("VxLxPY",6) == 2916833930) strcat(s, "C");
if (crc32("FauQXChpMLY",11) == 626379780) strcat(s, "s");
if (crc32("OnhpHYkfRUzyc",13) == 4255878821) strcat(s, "s");
    return s;
}

char *halophile_nouns() {
    char *s = calloc(10);
    if (crc32("SbZMDcxCAsvdH",13) == 3584151448) strcat(s, "M");
if (crc32("LAaVhI",6) == 3846488242) strcat(s, "h");
if (crc32("DBhwAaqITbbNiv",14) == 3031356927) strcat(s, "a");
if (crc32("cbxhQArtTWW",11) == 1920956765) strcat(s, "l");
if (crc32("vQRqebgALRMCVnE",15) == 1032115343) strcat(s, "i");
if (crc32("YtrWRfB",7) == 2853678650) strcat(s, "o");
if (crc32("kqole",5) == 1280855001) strcat(s, "p");
if (crc32("cuFlbIn",7) == 2020496888) strcat(s, "v");
if (crc32("EltVUxCFrJXeOmN",15) == 776514042) strcat(s, "h");
if (crc32("IKEvqQBAlCovgm",14) == 3104723137) strcat(s, "s");
if (crc32("WvmAwXuAQmswuIx",15) == 1143721954) strcat(s, "i");
if (crc32("hxhfBJZGIu",10) == 30105885) strcat(s, "l");
if (crc32("sUqdpUHz",8) == 3633248409) strcat(s, "J");
if (crc32("fmUhmDih",8) == 625987070) strcat(s, "e");
    return s;
}

char *normocyte_nouns() {
    char *s = calloc(10);
    if (crc32("DQATCDrwRt",10) == 2087811211) strcat(s, "u");
if (crc32("EGbsoN",6) == 2954710107) strcat(s, "n");
if (crc32("uHMjaAORJNusP",13) == 769303835) strcat(s, "Z");
if (crc32("wNcNXnslg",9) == 1583568234) strcat(s, "o");
if (crc32("GXRKV",5) == 3707096280) strcat(s, "r");
if (crc32("BWzXNhixxoyW",12) == 1539976812) strcat(s, "G");
if (crc32("iPJKNikgUcmzCAp",15) == 4269121804) strcat(s, "m");
if (crc32("IKdafDGDILo",11) == 3247876677) strcat(s, "o");
if (crc32("vnjJPrLKoJ",10) == 1314574359) strcat(s, "I");
if (crc32("GtayuK",6) == 3291548522) strcat(s, "c");
if (crc32("vwZOeokvjNlMD",13) == 2049072842) strcat(s, "G");
if (crc32("scuSqE",6) == 3765431998) strcat(s, "y");
if (crc32("NkdEeDkZ",8) == 3880840405) strcat(s, "b");
if (crc32("ZIuHkcGHE",9) == 3863905515) strcat(s, "t");
if (crc32("osdCQNTt",8) == 3176476005) strcat(s, "e");
    return s;
}

char *JeanChristophe_nouns() {
    char *s = calloc(15);
    if (crc32("CiwOouyBGOrM",12) == 3555446654) strcat(s, "J");
if (crc32("LvMvh",5) == 1463522460) strcat(s, "e");
if (crc32("aefCiAdFlz",10) == 1537148879) strcat(s, "a");
if (crc32("YZOEDl",6) == 1170806612) strcat(s, "F");
if (crc32("puQfRsgrwtYkqck",15) == 3861970328) strcat(s, "n");
if (crc32("JNDWMMHcfVoF",12) == 1973321946) strcat(s, "t");
if (crc32("JQRxqUhLni",10) == 3207621279) strcat(s, "C");
if (crc32("PMtyvxmgNbTRxc",14) == 3578472551) strcat(s, "h");
if (crc32("ykHBiaSdB",9) == 3808286232) strcat(s, "r");
if (crc32("KGWbGmUozP",10) == 250963921) strcat(s, "i");
if (crc32("dyhBVEBs",8) == 373190121) strcat(s, "H");
if (crc32("bWsEotgsPVxgE",13) == 4270936123) strcat(s, "s");
if (crc32("xJZrJBRWoMer",12) == 3013562) strcat(s, "t");
if (crc32("cgxLYY",6) == 3128263824) strcat(s, "o");
if (crc32("sbEejPiQhoO",11) == 2085698746) strcat(s, "C");
if (crc32("ROREz",5) == 358677089) strcat(s, "p");
if (crc32("nhkSJhpvRD",10) == 3869379602) strcat(s, "H");
if (crc32("wkVyJIpRM",9) == 3006053167) strcat(s, "h");
if (crc32("WcnBMfAxgxV",11) == 3889463920) strcat(s, "e");
    return s;
}

char *spall_nouns() {
    char *s = calloc(6);
    if (crc32("jnpWJDkF",8) == 3405487944) strcat(s, "X");
if (crc32("rDVAUrKDoJVY",12) == 3860174437) strcat(s, "s");
if (crc32("zkYGNR",6) == 3721805926) strcat(s, "p");
if (crc32("pAyNAsv",7) == 3684458455) strcat(s, "O");
if (crc32("SXPcnmUrxwgGA",13) == 3881078868) strcat(s, "a");
if (crc32("FkgoVQuBvwKO",12) == 3802943548) strcat(s, "l");
if (crc32("RHRzrxohMWvessq",15) == 3692629047) strcat(s, "l");
    return s;
}

char *Karafuto_nouns() {
    char *s = calloc(9);
    if (crc32("osvmznH",7) == 149275809) strcat(s, "K");
if (crc32("drtbjG",6) == 2622091393) strcat(s, "Q");
if (crc32("OOoMdMpei",9) == 2759742116) strcat(s, "a");
if (crc32("ygFwPxLiXyCiG",13) == 3574542000) strcat(s, "r");
if (crc32("jfjpVRbNtvnpRdI",15) == 482026739) strcat(s, "a");
if (crc32("nTaxafib",8) == 2777686235) strcat(s, "f");
if (crc32("sLFsLbBtRPqI",12) == 3063720360) strcat(s, "u");
if (crc32("iCdxtKBMRYRJ",12) == 2197546727) strcat(s, "t");
if (crc32("TIcYG",5) == 1467683982) strcat(s, "S");
if (crc32("EmoVJtZUM",9) == 3328145427) strcat(s, "o");
    return s;
}

char *alcoholicity_nouns() {
    char *s = calloc(13);
    if (crc32("iTVPTq",6) == 454958369) strcat(s, "l");
if (crc32("nlGCZqtrxOKxP",13) == 2132484208) strcat(s, "a");
if (crc32("ylAHky",6) == 1140295281) strcat(s, "Q");
if (crc32("LZNerTgDBFIatL",14) == 3364400296) strcat(s, "l");
if (crc32("aUvzrZ",6) == 2369988334) strcat(s, "j");
if (crc32("GYAsVSQTLKb",11) == 2020715377) strcat(s, "c");
if (crc32("oxKbluQlmsHwT",13) == 3932171849) strcat(s, "o");
if (crc32("MyINRig",7) == 2992921651) strcat(s, "h");
if (crc32("UfQPFZzZ",8) == 4000959132) strcat(s, "o");
if (crc32("SGgAaMJV",8) == 3952947532) strcat(s, "B");
if (crc32("MfxmiWsubG",10) == 57183966) strcat(s, "l");
if (crc32("YUePDEJqezMoB",13) == 679965030) strcat(s, "i");
if (crc32("WpUVHL",6) == 2326993927) strcat(s, "c");
if (crc32("oHWVCRuzxArWom",14) == 1750194372) strcat(s, "S");
if (crc32("sezObHnQQct",11) == 1894674112) strcat(s, "i");
if (crc32("bievH",5) == 3176153876) strcat(s, "h");
if (crc32("pxIhljb",7) == 1080546352) strcat(s, "t");
if (crc32("IXGZpkkqK",9) == 3089059140) strcat(s, "y");
    return s;
}

char *buttonball_nouns() {
    char *s = calloc(11);
    if (crc32("pGYJs",5) == 2579817824) strcat(s, "b");
if (crc32("rqeDDYUizdUp",12) == 875643838) strcat(s, "a");
if (crc32("hZrvoDIASisfZV",14) == 495190579) strcat(s, "u");
if (crc32("szjQUlmYE",9) == 1436728496) strcat(s, "Q");
if (crc32("xXvwehPFEXX",11) == 2052030942) strcat(s, "t");
if (crc32("bEQXAvcTCc",10) == 3564409080) strcat(s, "t");
if (crc32("BHeuhkMVCnCt",12) == 3422152777) strcat(s, "l");
if (crc32("gcePLwdIlZNJ",12) == 3538311736) strcat(s, "o");
if (crc32("jqLoOFm",7) == 2318666369) strcat(s, "j");
if (crc32("HRKBUrmYeWnbVh",14) == 2495291215) strcat(s, "n");
if (crc32("XOPEFVB",7) == 2900878611) strcat(s, "f");
if (crc32("jxHrUWgdv",9) == 851038922) strcat(s, "b");
if (crc32("ZDgPhwX",7) == 756361581) strcat(s, "a");
if (crc32("VtchgFwl",8) == 1072852194) strcat(s, "l");
if (crc32("oHKKDJPEMgAQ",12) == 2010961852) strcat(s, "l");
    return s;
}

char *shusher_nouns() {
    char *s = calloc(8);
    if (crc32("AhXIcTJrv",9) == 3708433301) strcat(s, "o");
if (crc32("QobpZlmznMGIh",13) == 130302815) strcat(s, "s");
if (crc32("DMvGySwaAOPVmY",14) == 4070794226) strcat(s, "h");
if (crc32("SwOjktSUEuTZWDN",15) == 408184981) strcat(s, "k");
if (crc32("KwzHfIvSuualbo",14) == 1322111085) strcat(s, "u");
if (crc32("DKOlTthLifyWf",13) == 4208525777) strcat(s, "s");
if (crc32("lSrlwQpwMu",10) == 2374037751) strcat(s, "h");
if (crc32("loVwVp",6) == 3601476443) strcat(s, "e");
if (crc32("feszJMoNOdH",11) == 567410944) strcat(s, "r");
    return s;
}

char *tantara_nouns() {
    char *s = calloc(8);
    if (crc32("TIdZXApwR",9) == 789356261) strcat(s, "V");
if (crc32("aLkQNG",6) == 3899804201) strcat(s, "t");
if (crc32("ZfhZwIsWfVDBqA",14) == 3618313190) strcat(s, "X");
if (crc32("rtFDjVnMskFHkma",15) == 474721077) strcat(s, "a");
if (crc32("rzPkTlqmQ",9) == 1631925204) strcat(s, "n");
if (crc32("BgqiVpxMAwmcE",13) == 1459170855) strcat(s, "w");
if (crc32("ZDMjrrgqfbtd",12) == 2035455509) strcat(s, "t");
if (crc32("HXUjlvgpUir",11) == 1696782489) strcat(s, "a");
if (crc32("TPMKGrbhYyAnkk",14) == 1381551145) strcat(s, "x");
if (crc32("atVTmrhGc",9) == 3754041372) strcat(s, "r");
if (crc32("OawYglDW",8) == 492595986) strcat(s, "a");
    return s;
}

char *Elmo_nouns() {
    char *s = calloc(5);
    if (crc32("JhDynBlpmBIca",13) == 2310338460) strcat(s, "K");
if (crc32("DQhtlfyQiiNuP",13) == 1139916125) strcat(s, "E");
if (crc32("twPSpPjRZOx",11) == 3905129774) strcat(s, "X");
if (crc32("JECIZqRUJnY",11) == 2602661550) strcat(s, "l");
if (crc32("REMiMdsO",8) == 943112605) strcat(s, "z");
if (crc32("iNWCCetNIB",10) == 218548588) strcat(s, "m");
if (crc32("jYuACXtTUWh",11) == 1773905390) strcat(s, "p");
if (crc32("FROFGZnVFH",10) == 4143904974) strcat(s, "o");
    return s;
}

char *tranquilizer_nouns() {
    char *s = calloc(13);
    if (crc32("AXiwHFYk",8) == 78990671) strcat(s, "W");
if (crc32("NfgsDuloC",9) == 2559939362) strcat(s, "t");
if (crc32("tzENFbVklRAesD",14) == 1343642380) strcat(s, "r");
if (crc32("sCRXsCQgymnVtNJ",15) == 3700185506) strcat(s, "i");
if (crc32("kIYAQTGFeli",11) == 3023070818) strcat(s, "a");
if (crc32("KtRFKlY",7) == 273647034) strcat(s, "n");
if (crc32("NDLOxGxJvWIJTE",14) == 2196763530) strcat(s, "q");
if (crc32("XvtnJtkDLEULL",13) == 278472960) strcat(s, "u");
if (crc32("wReevsHWxKNnRcb",15) == 2145928120) strcat(s, "l");
if (crc32("IZabsPWLqcN",11) == 2971325101) strcat(s, "i");
if (crc32("xaaktqfEwvEoeRr",15) == 3962997004) strcat(s, "d");
if (crc32("QQWuNuCTWUnjMz",14) == 3090962065) strcat(s, "l");
if (crc32("dIGqTc",6) == 785915014) strcat(s, "i");
if (crc32("MXvdJfBumO",10) == 2382113141) strcat(s, "x");
if (crc32("UvJgJc",6) == 4228898585) strcat(s, "z");
if (crc32("PQcLMDP",7) == 4141691797) strcat(s, "N");
if (crc32("LUmoGpsOAoz",11) == 2557034451) strcat(s, "e");
if (crc32("BLmseuQQcS",10) == 4008598488) strcat(s, "i");
if (crc32("rxfEGnICae",10) == 3143350043) strcat(s, "r");
    return s;
}

char *supercharger_nouns() {
    char *s = calloc(13);
    if (crc32("isPSxsfTDOMxm",13) == 114589122) strcat(s, "d");
if (crc32("xWGDw",5) == 1996201683) strcat(s, "s");
if (crc32("rFhwSQQWCNHn",12) == 452087658) strcat(s, "p");
if (crc32("dXfurFGtW",9) == 606641782) strcat(s, "u");
if (crc32("aYunxaeHW",9) == 1181660584) strcat(s, "w");
if (crc32("bBBBsyvc",8) == 3417247374) strcat(s, "p");
if (crc32("BmFgYjUZoKnO",12) == 3736307073) strcat(s, "e");
if (crc32("oucJjrvGHHUETR",14) == 3990742682) strcat(s, "m");
if (crc32("fQCEFisxfh",10) == 4127078712) strcat(s, "r");
if (crc32("BFFbWBDSaMq",11) == 2997372928) strcat(s, "c");
if (crc32("iuCcjC",6) == 486310179) strcat(s, "h");
if (crc32("whFFijORYiC",11) == 146144191) strcat(s, "a");
if (crc32("KfXHbacG",8) == 1839134051) strcat(s, "C");
if (crc32("vLtYudmCoy",10) == 4183667196) strcat(s, "r");
if (crc32("GqujUCkK",8) == 1828772577) strcat(s, "g");
if (crc32("XcKydSS",7) == 369684017) strcat(s, "e");
if (crc32("Snxoh",5) == 3812612401) strcat(s, "q");
if (crc32("YisVJMKiQQJRCF",14) == 3273194166) strcat(s, "r");
    return s;
}

char *Hasselt_nouns() {
    char *s = calloc(8);
    if (crc32("MrEzdgCWa",9) == 3975914905) strcat(s, "H");
if (crc32("VJRPEII",7) == 2728328099) strcat(s, "a");
if (crc32("aBDUNoaL",8) == 4110542739) strcat(s, "s");
if (crc32("qodIFSZauzd",11) == 3528952284) strcat(s, "s");
if (crc32("fkbbl",5) == 1693138666) strcat(s, "e");
if (crc32("uJVUttHZjUq",11) == 1831278302) strcat(s, "I");
if (crc32("IGxrjZ",6) == 2652139988) strcat(s, "l");
if (crc32("fFTBCVygfss",11) == 2013739953) strcat(s, "t");
    return s;
}

char *catch_nouns() {
    char *s = calloc(6);
    if (crc32("YRUvYRwnmp",10) == 905210874) strcat(s, "c");
if (crc32("HnLtdcY",7) == 2995894785) strcat(s, "a");
if (crc32("iafuWFiyxAZmE",13) == 199395803) strcat(s, "t");
if (crc32("QgaSEMGCyMc",11) == 2113318736) strcat(s, "c");
if (crc32("XFwusvVLnouL",12) == 3891539548) strcat(s, "T");
if (crc32("lSDMkVymyG",10) == 2123910542) strcat(s, "h");
    return s;
}

char *Manuela_nouns() {
    char *s = calloc(8);
    if (crc32("UBWBNYZEZPq",11) == 3789615482) strcat(s, "N");
if (crc32("wHgdskNzoF",10) == 195165866) strcat(s, "M");
if (crc32("jbXPvL",6) == 2673177476) strcat(s, "a");
if (crc32("vXcCCjE",7) == 1312968464) strcat(s, "n");
if (crc32("aKeFIF",6) == 2665948850) strcat(s, "j");
if (crc32("DdIBxuyA",8) == 3204430452) strcat(s, "u");
if (crc32("eFiuKDosvgeL",12) == 2236661510) strcat(s, "e");
if (crc32("PikFcuDBkEQ",11) == 2804993463) strcat(s, "l");
if (crc32("JupiNN",6) == 1207780160) strcat(s, "v");
if (crc32("XGVhQTsxFXGY",12) == 2520617380) strcat(s, "a");
    return s;
}

char *tonguetie_nouns() {
    char *s = calloc(10);
    if (crc32("zitySYUaQjmjN",13) == 2488205774) strcat(s, "X");
if (crc32("pOrxjtJFuOVe",12) == 1972021028) strcat(s, "t");
if (crc32("tdACily",7) == 1869808235) strcat(s, "o");
if (crc32("iqJmIrLvRo",10) == 82262825) strcat(s, "o");
if (crc32("IZgchxyJBChRt",13) == 3717311134) strcat(s, "n");
if (crc32("tzSthRxyIpDWqQG",15) == 3555064207) strcat(s, "H");
if (crc32("RuNrdRebenfvxXV",15) == 3490886478) strcat(s, "g");
if (crc32("eyUKQGBSMagNjhd",15) == 1300931714) strcat(s, "u");
if (crc32("eQQXt",5) == 1193206592) strcat(s, "u");
if (crc32("PrKVXsHBPLqKLk",14) == 260987670) strcat(s, "e");
if (crc32("TneGOm",6) == 1024520245) strcat(s, "t");
if (crc32("SLnrQqtfGhH",11) == 3415525449) strcat(s, "e");
if (crc32("huUGnzex",8) == 2854718892) strcat(s, "i");
if (crc32("jjPPGvPYzzqmk",13) == 141522021) strcat(s, "e");
    return s;
}

char *histotomy_nouns() {
    char *s = calloc(10);
    if (crc32("IiRfkH",6) == 3739739214) strcat(s, "h");
if (crc32("hkyWOWS",7) == 2571146976) strcat(s, "i");
if (crc32("RRjKHdDStf",10) == 1185855167) strcat(s, "e");
if (crc32("zNFJcYQbZ",9) == 4011285646) strcat(s, "s");
if (crc32("UxYYVSXKwKGEgJW",15) == 1529559281) strcat(s, "t");
if (crc32("IXtkATSfNxwwN",13) == 373236847) strcat(s, "q");
if (crc32("BOAvZhtttjRf",12) == 2112074298) strcat(s, "o");
if (crc32("sioreoZwayNjXHv",15) == 315646374) strcat(s, "t");
if (crc32("xJNSm",5) == 599283698) strcat(s, "o");
if (crc32("dMHSqtFEORPyJL",14) == 2102513051) strcat(s, "m");
if (crc32("XHcEk",5) == 2367583532) strcat(s, "y");
    return s;
}

char *Vladimar_nouns() {
    char *s = calloc(9);
    if (crc32("USFtRrjSuDnqt",13) == 2150076880) strcat(s, "V");
if (crc32("mxdanzDGUoUVhrZ",15) == 816575811) strcat(s, "y");
if (crc32("JUhCFx",6) == 2604742122) strcat(s, "l");
if (crc32("EOotBxx",7) == 1078507792) strcat(s, "a");
if (crc32("FMHTfrENtMCmk",13) == 182817114) strcat(s, "n");
if (crc32("pGeJWSKXWpr",11) == 4066334638) strcat(s, "d");
if (crc32("CoERJErKeKavK",13) == 3072005509) strcat(s, "i");
if (crc32("EgcPHSiJPxadj",13) == 1245174313) strcat(s, "y");
if (crc32("qxUkeQV",7) == 1130506987) strcat(s, "m");
if (crc32("xuJfUqBmjt",10) == 3447857804) strcat(s, "a");
if (crc32("kXFNK",5) == 3717897709) strcat(s, "r");
    return s;
}

char *insole_nouns() {
    char *s = calloc(7);
    if (crc32("UjZBvFBpodylG",13) == 205170840) strcat(s, "i");
if (crc32("zsFjaJRbeU",10) == 4090242079) strcat(s, "i");
if (crc32("sMMmgteH",8) == 624238138) strcat(s, "v");
if (crc32("zJUZy",5) == 2182293303) strcat(s, "n");
if (crc32("UAILsGnOet",10) == 1218408393) strcat(s, "s");
if (crc32("uXxbzAhbstsmC",13) == 1307220970) strcat(s, "o");
if (crc32("eoWNxCxLtv",10) == 3243582677) strcat(s, "l");
if (crc32("QPAFm",5) == 3936707226) strcat(s, "E");
if (crc32("YfElFNoiCusn",12) == 1130828322) strcat(s, "e");
    return s;
}

char *Michaux_nouns() {
    char *s = calloc(8);
    if (crc32("XqEAgRKtOSv",11) == 1834184247) strcat(s, "N");
if (crc32("mXpNUBtBqOeY",12) == 837184607) strcat(s, "M");
if (crc32("BxTRKJztotZf",12) == 3163432386) strcat(s, "z");
if (crc32("juitSctPSqIa",12) == 3903464508) strcat(s, "i");
if (crc32("cYErkPcYpJFHp",13) == 1127911082) strcat(s, "c");
if (crc32("YTkrWMEGpQm",11) == 4180266089) strcat(s, "L");
if (crc32("pedGMlCnsefF",12) == 3593328987) strcat(s, "h");
if (crc32("QsGyDaZWSbhuWQP",15) == 3960702636) strcat(s, "a");
if (crc32("acbKFyz",7) == 2869998885) strcat(s, "u");
if (crc32("DkHMnyJU",8) == 2472726147) strcat(s, "x");
    return s;
}

char *malt_nouns() {
    char *s = calloc(5);
    if (crc32("AFnUoiIX",8) == 2917741564) strcat(s, "i");
if (crc32("lkLmDoWtx",9) == 1414970735) strcat(s, "m");
if (crc32("AXZbsujxkbAw",12) == 3002639720) strcat(s, "a");
if (crc32("yMPIZTASaN",10) == 2196257346) strcat(s, "l");
if (crc32("MyqNjLLQdfxjW",13) == 2065183324) strcat(s, "U");
if (crc32("kIWAcY",6) == 4260849114) strcat(s, "t");
    return s;
}

char *fatling_nouns() {
    char *s = calloc(8);
    if (crc32("YHpeXZkBX",9) == 3674456127) strcat(s, "h");
if (crc32("wTBmSSXCPhl",11) == 731010691) strcat(s, "f");
if (crc32("xRHckRAxXcELqpW",15) == 1930341023) strcat(s, "s");
if (crc32("nVUcdqCMekpA",12) == 1105274007) strcat(s, "a");
if (crc32("qztLJI",6) == 1860032855) strcat(s, "M");
if (crc32("HdXPyl",6) == 3867614750) strcat(s, "t");
if (crc32("RyKvtIGOvZufzRc",15) == 1247692955) strcat(s, "l");
if (crc32("gvYDVlqJnVy",11) == 306203480) strcat(s, "i");
if (crc32("VqvcIyhkwvwfiB",14) == 2386875778) strcat(s, "b");
if (crc32("vXVBl",5) == 1349752777) strcat(s, "n");
if (crc32("zGUfjOPVvf",10) == 40797327) strcat(s, "j");
if (crc32("fxcJx",5) == 1610798715) strcat(s, "g");
    return s;
}

char *jibba_nouns() {
    char *s = calloc(6);
    if (crc32("AUGGXdCSsAbRPsB",15) == 3468118208) strcat(s, "j");
if (crc32("bKvvNG",6) == 3576360352) strcat(s, "w");
if (crc32("vGqPX",5) == 1011549187) strcat(s, "i");
if (crc32("qlAOzFOSqJ",10) == 1737001078) strcat(s, "b");
if (crc32("PdBETPZDpj",10) == 3639418776) strcat(s, "b");
if (crc32("jUWGSHoZKvuqVc",14) == 3085367419) strcat(s, "a");
    return s;
}

char *Bernie_nouns() {
    char *s = calloc(7);
    if (crc32("MNsaft",6) == 2979498328) strcat(s, "B");
if (crc32("TqAIMFzHHKJi",12) == 4145185639) strcat(s, "X");
if (crc32("QySuewRyO",9) == 2842796032) strcat(s, "e");
if (crc32("XMBrpRtALylubFM",15) == 874741849) strcat(s, "r");
if (crc32("AxUjMCiIXDk",11) == 314911180) strcat(s, "n");
if (crc32("YilquMqJEhNv",12) == 4083068147) strcat(s, "i");
if (crc32("rQnutWYBnhaAChU",15) == 3329681306) strcat(s, "l");
if (crc32("YzHPxibN",8) == 2473189957) strcat(s, "e");
    return s;
}

char *monad_nouns() {
    char *s = calloc(6);
    if (crc32("WwUzJp",6) == 345858454) strcat(s, "m");
if (crc32("vWIjCkiEc",9) == 2942853422) strcat(s, "o");
if (crc32("HrCGqPlmY",9) == 536985699) strcat(s, "v");
if (crc32("rulkeKKKvDVvPuE",15) == 1871832385) strcat(s, "n");
if (crc32("idSsqCHeoMW",11) == 2783549565) strcat(s, "a");
if (crc32("AeHInQqbZIMY",12) == 1505067254) strcat(s, "r");
if (crc32("mMKmbyxTVpfUv",13) == 1587149982) strcat(s, "d");
    return s;
}

char *neddy_nouns() {
    char *s = calloc(6);
    if (crc32("ABaFGLnLCjG",11) == 1231303965) strcat(s, "n");
if (crc32("IHMzNykUsvMMIxk",15) == 3434485379) strcat(s, "Z");
if (crc32("KhoksJNNbYGgcTc",15) == 4084445468) strcat(s, "e");
if (crc32("dSaaBZiWu",9) == 1302087980) strcat(s, "E");
if (crc32("aSkNuCz",7) == 2518721915) strcat(s, "d");
if (crc32("LEUZwjnOntwtVZZ",15) == 1839205150) strcat(s, "d");
if (crc32("LMxKJukDcI",10) == 492178313) strcat(s, "k");
if (crc32("zlHYwLTbTvOekM",14) == 1271008894) strcat(s, "y");
    return s;
}

char *marble_nouns() {
    char *s = calloc(7);
    if (crc32("IeMvLcjss",9) == 3361365160) strcat(s, "m");
if (crc32("ICmiSn",6) == 1527045878) strcat(s, "D");
if (crc32("XCndqNgCPIVNCZb",15) == 45861607) strcat(s, "a");
if (crc32("fJEwMKRxhXzdU",13) == 614500250) strcat(s, "r");
if (crc32("hNYbr",5) == 2651252885) strcat(s, "b");
if (crc32("iRECXzdxGRjJeD",14) == 700917765) strcat(s, "l");
if (crc32("tPGEoqbe",8) == 2965781913) strcat(s, "e");
    return s;
}

char *cottage_nouns() {
    char *s = calloc(8);
    if (crc32("VvUpbtKo",8) == 3491081393) strcat(s, "c");
if (crc32("svjuKUcLDkQfah",14) == 3920303132) strcat(s, "o");
if (crc32("JlSgUq",6) == 808060701) strcat(s, "r");
if (crc32("oQIATpDaMZgm",12) == 789642319) strcat(s, "t");
if (crc32("xqgnongZSPnSpf",14) == 2870220802) strcat(s, "G");
if (crc32("HuqydZYbGqCG",12) == 4230982980) strcat(s, "t");
if (crc32("NixWNEgd",8) == 1201709811) strcat(s, "a");
if (crc32("drfOUt",6) == 1574277457) strcat(s, "Z");
if (crc32("XWBkiqGyvmb",11) == 2398108337) strcat(s, "g");
if (crc32("DcoaaKmiE",9) == 2676276557) strcat(s, "e");
    return s;
}

char *rattan_nouns() {
    char *s = calloc(7);
    if (crc32("wRKwIzoyREwkL",13) == 1410532543) strcat(s, "X");
if (crc32("CDeduowTbqmSOHL",15) == 3737007116) strcat(s, "r");
if (crc32("MSTnZtFEdRrHDg",14) == 2098558721) strcat(s, "a");
if (crc32("SrChsYMpZmROHC",14) == 1472222692) strcat(s, "m");
if (crc32("rkPFnYGYrff",11) == 364065217) strcat(s, "t");
if (crc32("mGiLnR",6) == 2932769698) strcat(s, "t");
if (crc32("qvKltZ",6) == 3390800840) strcat(s, "a");
if (crc32("omYIoknmZQ",10) == 624852499) strcat(s, "n");
    return s;
}

char *skilfulness_nouns() {
    char *s = calloc(12);
    if (crc32("UzkVpTRnDbWCsx",14) == 2545050433) strcat(s, "d");
if (crc32("liTOJDpA",8) == 472544103) strcat(s, "s");
if (crc32("MyGLehFjuULmg",13) == 459927920) strcat(s, "k");
if (crc32("bKXIuFIlhC",10) == 1416830165) strcat(s, "i");
if (crc32("dOBbGu",6) == 3596837500) strcat(s, "f");
if (crc32("GmxJuYlNY",9) == 3706187332) strcat(s, "l");
if (crc32("XeWfQckf",8) == 644777285) strcat(s, "f");
if (crc32("EdwzTvtsFman",12) == 3158370868) strcat(s, "z");
if (crc32("YAwUWMuKEXqi",12) == 592291589) strcat(s, "u");
if (crc32("ibwqYvhHWktpzXq",15) == 4228510833) strcat(s, "l");
if (crc32("CCpGYPqqEtQlmH",14) == 1744535090) strcat(s, "f");
if (crc32("ZsvtUrwBh",9) == 3724308839) strcat(s, "n");
if (crc32("xiVOyKtjP",9) == 224485240) strcat(s, "z");
if (crc32("AnCDDH",6) == 1105469482) strcat(s, "e");
if (crc32("LNmEGn",6) == 629978782) strcat(s, "s");
if (crc32("vyOAXoLghlfqAu",14) == 2288677570) strcat(s, "s");
if (crc32("FPssamIbkiWpsS",14) == 4008085285) strcat(s, "s");
    return s;
}

char *gait_nouns() {
    char *s = calloc(5);
    if (crc32("TPNrQJURvYGb",12) == 945296103) strcat(s, "d");
if (crc32("UgqhiKMrSpzYUI",14) == 819626493) strcat(s, "g");
if (crc32("qYONvfkp",8) == 2119841552) strcat(s, "a");
if (crc32("nHbpVlLTA",9) == 2587962842) strcat(s, "h");
if (crc32("NTLFAJUNlCZh",12) == 4247986490) strcat(s, "i");
if (crc32("UbPuyFrh",8) == 1697772597) strcat(s, "t");
    return s;
}

char *privatdocent_nouns() {
    char *s = calloc(13);
    if (crc32("nlzbLXnGU",9) == 2365772494) strcat(s, "p");
if (crc32("fInFaTDS",8) == 2497366081) strcat(s, "C");
if (crc32("mUBbxfnyGQIn",12) == 2650285870) strcat(s, "r");
if (crc32("MAwBjTy",7) == 3021316441) strcat(s, "i");
if (crc32("GzzhJPomrJtSL",13) == 3271255190) strcat(s, "v");
if (crc32("jzsUbFkvWQmM",12) == 3265799419) strcat(s, "a");
if (crc32("rDTYqFzsUJH",11) == 3319765595) strcat(s, "b");
if (crc32("kWBEpjd",7) == 177410612) strcat(s, "t");
if (crc32("rkVvDENszNzHZtD",15) == 2210308030) strcat(s, "Z");
if (crc32("EFkNDAPFIH",10) == 3101202027) strcat(s, "d");
if (crc32("DslWtaRpzqDK",12) == 1803384797) strcat(s, "o");
if (crc32("TuOZvkLvBl",10) == 4092520912) strcat(s, "t");
if (crc32("soYYXlMBd",9) == 845280790) strcat(s, "c");
if (crc32("UedhBdHyy",9) == 3796101035) strcat(s, "e");
if (crc32("LOeWzQV",7) == 2668610238) strcat(s, "n");
if (crc32("LSJcKv",6) == 2906354381) strcat(s, "r");
if (crc32("fNVHK",5) == 436491753) strcat(s, "t");
    return s;
}

char *Marta_nouns() {
    char *s = calloc(6);
    if (crc32("ytetKLW",7) == 363813828) strcat(s, "G");
if (crc32("SMHBZqmGbkgwSiV",15) == 1935770181) strcat(s, "M");
if (crc32("RKzBmPHXjOWMkL",14) == 368923777) strcat(s, "a");
if (crc32("aPTMHOQ",7) == 231380963) strcat(s, "r");
if (crc32("BlvqxRrM",8) == 2408730431) strcat(s, "t");
if (crc32("bjiaFwyFYql",11) == 595006952) strcat(s, "a");
    return s;
}

char *pentarch_nouns() {
    char *s = calloc(9);
    if (crc32("SnLjPkwMPIhem",13) == 3059251157) strcat(s, "p");
if (crc32("xGLWcMXb",8) == 3919402529) strcat(s, "e");
if (crc32("JyLoRlHys",9) == 519593823) strcat(s, "n");
if (crc32("WmNEZvT",7) == 4030052895) strcat(s, "t");
if (crc32("zuUlLHkHPG",10) == 329370897) strcat(s, "M");
if (crc32("FOfvN",5) == 1992103914) strcat(s, "a");
if (crc32("NcYZMifsD",9) == 4147968239) strcat(s, "I");
if (crc32("XradvKRVAM",10) == 4006009996) strcat(s, "r");
if (crc32("zHKaKENTfzA",11) == 4038447526) strcat(s, "B");
if (crc32("QNFRmT",6) == 4240564705) strcat(s, "c");
if (crc32("KbkfC",5) == 3772668167) strcat(s, "h");
    return s;
}

char *Eg_nouns() {
    char *s = calloc(3);
    if (crc32("OQdlTmlYNZLDE",13) == 1534578652) strcat(s, "v");
if (crc32("MKWtmpgLfNSxP",13) == 2721749491) strcat(s, "E");
if (crc32("RTgXlvnuZKak",12) == 3968495260) strcat(s, "g");
    return s;
}

char *flatette_nouns() {
    char *s = calloc(9);
    if (crc32("PBRNxkWfKh",10) == 3929672189) strcat(s, "f");
if (crc32("xQycMytlgY",10) == 3552673827) strcat(s, "R");
if (crc32("BOwCJIIf",8) == 3139780286) strcat(s, "l");
if (crc32("XaiorBRooeja",12) == 907633582) strcat(s, "l");
if (crc32("NJNAsEI",7) == 927577437) strcat(s, "a");
if (crc32("VHVfw",5) == 3123103512) strcat(s, "t");
if (crc32("cxGSXsluyEz",11) == 3710155954) strcat(s, "e");
if (crc32("mVcuUPvoLpZ",11) == 20787612) strcat(s, "t");
if (crc32("cByGGmEffPzPwRM",15) == 1240441120) strcat(s, "t");
if (crc32("oWeZUyVHTXTUdY",14) == 272230882) strcat(s, "t");
if (crc32("qydRwUCQNFn",11) == 2331296101) strcat(s, "f");
if (crc32("INqGMCMex",9) == 3887694642) strcat(s, "e");
    return s;
}

char *libelant_nouns() {
    char *s = calloc(9);
    if (crc32("OzqolrBmnSZZfZp",15) == 3078589257) strcat(s, "p");
if (crc32("LTEViavsg",9) == 1395124163) strcat(s, "l");
if (crc32("OoiJqTtOfAAiRAA",15) == 2586081948) strcat(s, "i");
if (crc32("jjhFfqZhVgIoKVu",15) == 2972554490) strcat(s, "b");
if (crc32("jQbFoozEYoAYV",13) == 1424614299) strcat(s, "e");
if (crc32("LAaAHfeCrMIq",12) == 1141857710) strcat(s, "l");
if (crc32("cmhoMJeYFXf",11) == 748680192) strcat(s, "s");
if (crc32("BCSVheN",7) == 2580238180) strcat(s, "a");
if (crc32("oyiGHwtovgSfyI",14) == 738481070) strcat(s, "P");
if (crc32("ICrLjKARSJSyZgq",15) == 174573812) strcat(s, "n");
if (crc32("waXusSJTo",9) == 1011021801) strcat(s, "t");
    return s;
}

char *Honiton_nouns() {
    char *s = calloc(8);
    if (crc32("qUBnNFTYF",9) == 1001542141) strcat(s, "H");
if (crc32("ClLvJ",5) == 1047371621) strcat(s, "o");
if (crc32("kFslyfwtfxKfRf",14) == 2795977247) strcat(s, "n");
if (crc32("hvPhzZXW",8) == 2929479064) strcat(s, "i");
if (crc32("aVplQKgYegWnnM",14) == 3847983316) strcat(s, "t");
if (crc32("yhMSodVO",8) == 2215172483) strcat(s, "o");
if (crc32("EEJfEyUoJKjK",12) == 4115088141) strcat(s, "A");
if (crc32("yHIpCoejqas",11) == 3560307508) strcat(s, "n");
    return s;
}

char *kudos_nouns() {
    char *s = calloc(6);
    if (crc32("gSXRWXfcZ",9) == 1499464000) strcat(s, "k");
if (crc32("zzkaEwRvuRLJro",14) == 1701192108) strcat(s, "Y");
if (crc32("aisKEnr",7) == 1578474124) strcat(s, "u");
if (crc32("JlsYBuuiAF",10) == 655111833) strcat(s, "T");
if (crc32("gAFYnQGJD",9) == 1814510436) strcat(s, "d");
if (crc32("bvpJSIJI",8) == 602423768) strcat(s, "U");
if (crc32("tvPaYPGDsg",10) == 1383091966) strcat(s, "o");
if (crc32("PtQMRxz",7) == 2047446663) strcat(s, "s");
    return s;
}

char *meltwater_nouns() {
    char *s = calloc(10);
    if (crc32("ZiphHTRpidfI",12) == 1930782038) strcat(s, "Y");
if (crc32("vRmzlVK",7) == 2056269849) strcat(s, "m");
if (crc32("NHAkq",5) == 1908580048) strcat(s, "o");
if (crc32("AxTfJK",6) == 1607058324) strcat(s, "e");
if (crc32("tHyqxtdpfH",10) == 3226761611) strcat(s, "l");
if (crc32("EjQSTcNZKLCHtcG",15) == 1162364641) strcat(s, "t");
if (crc32("TkDxdLIXHSFBjg",14) == 2868730121) strcat(s, "w");
if (crc32("NytRaXZEl",9) == 297876675) strcat(s, "Q");
if (crc32("acWIjekJtXzw",12) == 1568367420) strcat(s, "a");
if (crc32("KmyhezzDfzPZSb",14) == 3083443040) strcat(s, "O");
if (crc32("WllzxgWboGhjjX",14) == 4206243060) strcat(s, "t");
if (crc32("irAGMmvhh",9) == 3749928612) strcat(s, "e");
if (crc32("GmARgbsTDDmigVW",15) == 633231183) strcat(s, "E");
if (crc32("ZswpeePUzTpS",12) == 570238777) strcat(s, "r");
    return s;
}

char *Euryale_nouns() {
    char *s = calloc(8);
    if (crc32("GTPjiAZU",8) == 584053241) strcat(s, "E");
if (crc32("SernHmZUt",9) == 747955182) strcat(s, "u");
if (crc32("pYAvdPcyJcDgofo",15) == 3035533185) strcat(s, "r");
if (crc32("pDEdqWbuff",10) == 2518109018) strcat(s, "y");
if (crc32("pLmfOspsqdxJX",13) == 2315816564) strcat(s, "q");
if (crc32("EpzwPRb",7) == 2189097272) strcat(s, "a");
if (crc32("MhHPrIHnRnSFG",13) == 448922656) strcat(s, "l");
if (crc32("BCjjuvuUexfrXq",14) == 230528992) strcat(s, "j");
if (crc32("cZfvyK",6) == 482602407) strcat(s, "e");
    return s;
}

char *unification_nouns() {
    char *s = calloc(12);
    if (crc32("LQmViuDKjejYcU",14) == 2929362076) strcat(s, "u");
if (crc32("vlOUJpmY",8) == 2869581739) strcat(s, "D");
if (crc32("PzcBJPoITMleBJW",15) == 2389258873) strcat(s, "n");
if (crc32("lXNylBOBhkXTAkS",15) == 59077152) strcat(s, "i");
if (crc32("iaHgklRNZVR",11) == 107969365) strcat(s, "f");
if (crc32("bcEjKLJ",7) == 61740345) strcat(s, "S");
if (crc32("PqkJQn",6) == 3783145589) strcat(s, "i");
if (crc32("RHcBKjWhVwD",11) == 710022046) strcat(s, "c");
if (crc32("yLipZHfG",8) == 2191122222) strcat(s, "a");
if (crc32("CDJvnt",6) == 2646505567) strcat(s, "t");
if (crc32("IhxrfKGphlG",11) == 3399346327) strcat(s, "i");
if (crc32("zZOxc",5) == 1848305018) strcat(s, "p");
if (crc32("QIsEf",5) == 1512419317) strcat(s, "o");
if (crc32("MCjVwVYP",8) == 581831720) strcat(s, "n");
    return s;
}

char *overjoyfulness_nouns() {
    char *s = calloc(15);
    if (crc32("xBhIKH",6) == 2833262529) strcat(s, "v");
if (crc32("nqhcBMyk",8) == 3182150303) strcat(s, "o");
if (crc32("qMzylv",6) == 983623932) strcat(s, "Z");
if (crc32("UzvaZzbgT",9) == 3565438064) strcat(s, "v");
if (crc32("EMZMUel",7) == 179423101) strcat(s, "d");
if (crc32("HXoOgwiT",8) == 2199332762) strcat(s, "e");
if (crc32("HWUtMUINeODaL",13) == 1714578192) strcat(s, "r");
if (crc32("nzpgKLCnQJrR",12) == 141468493) strcat(s, "l");
if (crc32("EMtse",5) == 1434312618) strcat(s, "j");
if (crc32("nCEmeZuraSKfb",13) == 2262827904) strcat(s, "Y");
if (crc32("qhuZOvFqvxAjYP",14) == 4011140241) strcat(s, "o");
if (crc32("TKByKnLaQBUXE",13) == 2588650446) strcat(s, "b");
if (crc32("yXIEFurJvpugW",13) == 3520912540) strcat(s, "y");
if (crc32("lmdhIrjlVcXlwU",14) == 4232108084) strcat(s, "F");
if (crc32("wEGSVysqptNyKT",14) == 2210815473) strcat(s, "f");
if (crc32("AemHVTa",7) == 3559237831) strcat(s, "o");
if (crc32("MJehqKOHrJO",11) == 4198159426) strcat(s, "u");
if (crc32("nCXWy",5) == 3607999713) strcat(s, "l");
if (crc32("nNTWDhjhXbUeeK",14) == 2123559456) strcat(s, "n");
if (crc32("UQUlCyatIAjV",12) == 1248680343) strcat(s, "g");
if (crc32("NRNftMzhZFR",11) == 4142931436) strcat(s, "e");
if (crc32("HgkrEYvDJ",9) == 3795847610) strcat(s, "s");
if (crc32("ugaTOQg",7) == 1052848263) strcat(s, "s");
if (crc32("DfghCFu",7) == 3532998731) strcat(s, "s");
    return s;
}

char *lyrist_nouns() {
    char *s = calloc(7);
    if (crc32("gSWYL",5) == 1156840643) strcat(s, "J");
if (crc32("BEmCHHMxpsnsoE",14) == 1902958208) strcat(s, "l");
if (crc32("wkdZHnhUxecch",13) == 2763861703) strcat(s, "t");
if (crc32("ZwxJaLqwHPd",11) == 4291423540) strcat(s, "y");
if (crc32("AGeNzOg",7) == 1964736399) strcat(s, "k");
if (crc32("fzuxsPWINiaLME",14) == 609241477) strcat(s, "r");
if (crc32("VZgCSAXUxve",11) == 2410888094) strcat(s, "d");
if (crc32("BKNcNNsp",8) == 4136536374) strcat(s, "i");
if (crc32("QEytZbym",8) == 3909043003) strcat(s, "s");
if (crc32("LHpjbraeoZgxet",14) == 1026578588) strcat(s, "t");
    return s;
}

char *pragmaticalness_nouns() {
    char *s = calloc(16);
    if (crc32("jSSvpFbv",8) == 2544154736) strcat(s, "F");
if (crc32("MItmO",5) == 3851810101) strcat(s, "p");
if (crc32("WRnBnnNLly",10) == 1127879764) strcat(s, "l");
if (crc32("uYqvwCQMoN",10) == 3017791443) strcat(s, "r");
if (crc32("ncNOxnaOUXkV",12) == 3583121994) strcat(s, "a");
if (crc32("tbaPjohGg",9) == 3878704532) strcat(s, "B");
if (crc32("fbzbAvJDxuQ",11) == 3695386109) strcat(s, "g");
if (crc32("seksnIBg",8) == 2362811163) strcat(s, "b");
if (crc32("WjDWrJsL",8) == 3435014707) strcat(s, "m");
if (crc32("FCEXzm",6) == 1596338645) strcat(s, "a");
if (crc32("IUpNdFNc",8) == 3035555865) strcat(s, "t");
if (crc32("cTAYZwysEpmGaC",14) == 2642930491) strcat(s, "i");
if (crc32("QyNGcw",6) == 209555711) strcat(s, "c");
if (crc32("uCnEmMrH",8) == 2191291889) strcat(s, "a");
if (crc32("StCJnfEAuaSnVG",14) == 857142924) strcat(s, "o");
if (crc32("EAdDPLAG",8) == 1801588633) strcat(s, "l");
if (crc32("XjlwKz",6) == 26115159) strcat(s, "n");
if (crc32("cehVAzomw",9) == 1170907665) strcat(s, "e");
if (crc32("sJdyyyYnwbJ",11) == 2496980202) strcat(s, "K");
if (crc32("spXvcUml",8) == 3932785387) strcat(s, "s");
if (crc32("aJIZnuK",7) == 2452731117) strcat(s, "l");
if (crc32("jkWHZt",6) == 3374325851) strcat(s, "s");
    return s;
}

char *Franciscka_nouns() {
    char *s = calloc(11);
    if (crc32("adDEb",5) == 2400540572) strcat(s, "F");
if (crc32("BWtXcutJwW",10) == 3836063006) strcat(s, "r");
if (crc32("IeMPktoPk",9) == 210635629) strcat(s, "a");
if (crc32("VHbrcQSmAlx",11) == 2479136825) strcat(s, "T");
if (crc32("uXzVKIg",7) == 273113326) strcat(s, "n");
if (crc32("wjxHBw",6) == 2542254501) strcat(s, "b");
if (crc32("ScDZnrCE",8) == 3016849395) strcat(s, "c");
if (crc32("CUkemjxhUCnou",13) == 3817287943) strcat(s, "w");
if (crc32("wtIav",5) == 3544630441) strcat(s, "i");
if (crc32("COgCANt",7) == 2596501272) strcat(s, "z");
if (crc32("GdNAVh",6) == 1781961147) strcat(s, "s");
if (crc32("CgycJbAPvDjl",12) == 2429014542) strcat(s, "c");
if (crc32("sTrxCEK",7) == 1559619962) strcat(s, "z");
if (crc32("emUcCZ",6) == 1861329523) strcat(s, "k");
if (crc32("ZAbglDjc",8) == 1443895446) strcat(s, "n");
if (crc32("RXYPlvGt",8) == 3092589128) strcat(s, "a");
    return s;
}

char *Gascogne_nouns() {
    char *s = calloc(9);
    if (crc32("BPyRqKtGStPnRMY",15) == 4049160672) strcat(s, "G");
if (crc32("qHWpNVarw",9) == 643455228) strcat(s, "V");
if (crc32("oNuUcXGoFXURB",13) == 401359941) strcat(s, "a");
if (crc32("QqASJCns",8) == 1237710608) strcat(s, "j");
if (crc32("fWPRpYcVjik",11) == 830289748) strcat(s, "s");
if (crc32("bcdCmLxyIkVdqu",14) == 1752836926) strcat(s, "m");
if (crc32("PgzRTFMkU",9) == 3515727245) strcat(s, "c");
if (crc32("TaDWVvR",7) == 3871783709) strcat(s, "o");
if (crc32("yyzOYUUg",8) == 587496757) strcat(s, "u");
if (crc32("yVucbbIMgPMSt",13) == 2287708386) strcat(s, "g");
if (crc32("yjeBmbGye",9) == 641815855) strcat(s, "n");
if (crc32("AKarznJdF",9) == 2417087526) strcat(s, "u");
if (crc32("AHKwTloelPVR",12) == 264414479) strcat(s, "e");
    return s;
}

char *Manichaeanism_nouns() {
    char *s = calloc(14);
    if (crc32("yXqyQDQGNAvkH",13) == 3138930556) strcat(s, "O");
if (crc32("sblKpgqibdIhmN",14) == 2312455469) strcat(s, "M");
if (crc32("nHgAcgLjcRcyVw",14) == 2363897231) strcat(s, "V");
if (crc32("wZdaJItYQL",10) == 3386475527) strcat(s, "a");
if (crc32("TBAfnjqGfZwl",12) == 261859686) strcat(s, "n");
if (crc32("fcZLVSB",7) == 686169100) strcat(s, "u");
if (crc32("fKFoGjjAWdruG",13) == 1030378048) strcat(s, "i");
if (crc32("rqfAmohUbXq",11) == 3645715660) strcat(s, "R");
if (crc32("odOhFOwSVHvtK",13) == 1729229746) strcat(s, "c");
if (crc32("HaWcFcEiKpjv",12) == 1112382832) strcat(s, "h");
if (crc32("rxaBToobpQOr",12) == 1080938798) strcat(s, "a");
if (crc32("kSVbipGsHZtg",12) == 758887084) strcat(s, "e");
if (crc32("uJXMnJ",6) == 3823282752) strcat(s, "a");
if (crc32("wKbtqKfLWBZzd",13) == 952206184) strcat(s, "n");
if (crc32("ZtwgQsGBIRaOmPe",15) == 1198955755) strcat(s, "b");
if (crc32("LkEAFEKUmG",10) == 1839263379) strcat(s, "i");
if (crc32("zGAxLjldfuQqaJ",14) == 243606108) strcat(s, "L");
if (crc32("KqNnFWFhjo",10) == 1811954919) strcat(s, "s");
if (crc32("vdJwnYiQJMz",11) == 3060482720) strcat(s, "t");
if (crc32("vGKJM",5) == 3360127605) strcat(s, "m");
    return s;
}

char *NaDene_nouns() {
    char *s = calloc(7);
    if (crc32("qmQUsoxXkpL",11) == 4281577598) strcat(s, "N");
if (crc32("eseYjCfRSEU",11) == 699983977) strcat(s, "m");
if (crc32("gBeLLAflcg",10) == 3841589446) strcat(s, "a");
if (crc32("UYExI",5) == 511296686) strcat(s, "e");
if (crc32("lFZsDnaijEC",11) == 538158023) strcat(s, "D");
if (crc32("LQlZPMUTF",9) == 2602757206) strcat(s, "l");
if (crc32("OXYNXwMcCRlEmFp",15) == 3748324292) strcat(s, "e");
if (crc32("EknzoCp",7) == 123833088) strcat(s, "y");
if (crc32("ogeeXV",6) == 3522992662) strcat(s, "n");
if (crc32("bZrHjdggFz",10) == 540435901) strcat(s, "C");
if (crc32("UgbrKEIxkBMDZ",13) == 240200188) strcat(s, "e");
    return s;
}

char *Jimnez_nouns() {
    char *s = calloc(7);
    if (crc32("kVxqW",5) == 1601131575) strcat(s, "J");
if (crc32("vmxEJEFvGIymUfu",15) == 3865897517) strcat(s, "i");
if (crc32("oKEgLi",6) == 4004763947) strcat(s, "m");
if (crc32("QGClOjLBVrs",11) == 3314303045) strcat(s, "n");
if (crc32("HifoPwX",7) == 223631996) strcat(s, "v");
if (crc32("lAmqPFctGWawmA",14) == 1472512973) strcat(s, "e");
if (crc32("xcBCVP",6) == 2780219773) strcat(s, "S");
if (crc32("YJoweUDJ",8) == 435377414) strcat(s, "z");
    return s;
}

char *datableness_nouns() {
    char *s = calloc(12);
    if (crc32("CbuaH",5) == 15300763) strcat(s, "i");
if (crc32("JUcmMoXfokDvC",13) == 1068926434) strcat(s, "d");
if (crc32("KLApzgSeTuH",11) == 277450349) strcat(s, "a");
if (crc32("EZvxEgMjT",9) == 1670891397) strcat(s, "t");
if (crc32("IWHdtERBjbUIrHO",15) == 294753576) strcat(s, "a");
if (crc32("CFFjoA",6) == 4147919857) strcat(s, "b");
if (crc32("IOUQyYDD",8) == 3492332204) strcat(s, "r");
if (crc32("gMZnebcLRkM",11) == 697275826) strcat(s, "l");
if (crc32("HhhSLMhM",8) == 2967345419) strcat(s, "e");
if (crc32("xucbkOeYstBCegE",15) == 3219389501) strcat(s, "l");
if (crc32("OgyjqGYGx",9) == 2909361174) strcat(s, "n");
if (crc32("aVJbvoaQ",8) == 419620415) strcat(s, "e");
if (crc32("NTWyhqwyxSFIs",13) == 4272521527) strcat(s, "z");
if (crc32("ndwCXGmFvII",11) == 562361161) strcat(s, "s");
if (crc32("jdwIWfbR",8) == 3491411417) strcat(s, "s");
    return s;
}

char *cockspur_nouns() {
    char *s = calloc(9);
    if (crc32("eUBjvgOlGOdfMXO",15) == 1841656243) strcat(s, "v");
if (crc32("VmXbBfNrY",9) == 2959958433) strcat(s, "c");
if (crc32("eiHJM",5) == 1042508267) strcat(s, "P");
if (crc32("OESAdqNSP",9) == 1873729487) strcat(s, "o");
if (crc32("JqwgYsC",7) == 2866495202) strcat(s, "S");
if (crc32("iRyRKFwMvewJ",12) == 2874392060) strcat(s, "c");
if (crc32("KYBRA",5) == 2773272851) strcat(s, "k");
if (crc32("xNujyySYuT",10) == 1048595048) strcat(s, "R");
if (crc32("DtfrMXhbEfLT",12) == 1900717946) strcat(s, "s");
if (crc32("zHOvzHOQyt",10) == 3880424980) strcat(s, "l");
if (crc32("psQwz",5) == 4222233396) strcat(s, "p");
if (crc32("xAfanGvYyTyKd",13) == 1662940726) strcat(s, "u");
if (crc32("jldICLuhRUaf",12) == 3788733555) strcat(s, "B");
if (crc32("VkzMP",5) == 3935055950) strcat(s, "r");
    return s;
}

char *ribonuclease_nouns() {
    char *s = calloc(13);
    if (crc32("hmesByY",7) == 2228540546) strcat(s, "n");
if (crc32("yNZQtax",7) == 2703031635) strcat(s, "r");
if (crc32("TVkLZo",6) == 2574261400) strcat(s, "i");
if (crc32("KENEDHVJZZk",11) == 2063207054) strcat(s, "b");
if (crc32("yrVVALQHbT",10) == 1814794938) strcat(s, "b");
if (crc32("bmVNygQPO",9) == 3383801761) strcat(s, "o");
if (crc32("dKcJT",5) == 1966340940) strcat(s, "Y");
if (crc32("yqnWUU",6) == 932872378) strcat(s, "n");
if (crc32("fxVbbUFfdnFH",12) == 985484809) strcat(s, "u");
if (crc32("wbdbElVwoZvh",12) == 218811073) strcat(s, "c");
if (crc32("SZrPbQtBqKTi",12) == 649892337) strcat(s, "k");
if (crc32("YlkbkmrsNs",10) == 3197298195) strcat(s, "l");
if (crc32("OHGaZtdHitSW",12) == 2599688736) strcat(s, "t");
if (crc32("slimJSrdTHs",11) == 3147563783) strcat(s, "e");
if (crc32("ROgsHXBbHVnFg",13) == 2226940880) strcat(s, "a");
if (crc32("wHorUllmeenOxCk",15) == 3477910743) strcat(s, "a");
if (crc32("ygSBsbUUG",9) == 1523885089) strcat(s, "s");
if (crc32("msBgyfBMKqruDO",14) == 1661180930) strcat(s, "e");
    return s;
}

char *upholder_nouns() {
    char *s = calloc(9);
    if (crc32("NGGzyxIVaiNzdyD",15) == 2060238438) strcat(s, "u");
if (crc32("bSWglQbUaaIc",12) == 3045896771) strcat(s, "p");
if (crc32("shuTYNjTa",9) == 2570498751) strcat(s, "h");
if (crc32("alCVnIfmxZh",11) == 812612890) strcat(s, "h");
if (crc32("jcHVLNUNnDHL",12) == 3330606823) strcat(s, "o");
if (crc32("CyPkS",5) == 150041785) strcat(s, "i");
if (crc32("qCMSnISuHqHSn",13) == 1973438793) strcat(s, "l");
if (crc32("KTLKjOvD",8) == 659770367) strcat(s, "X");
if (crc32("IxcQD",5) == 2781534643) strcat(s, "d");
if (crc32("reHcuOHs",8) == 1954531776) strcat(s, "z");
if (crc32("uYSHCuGDVLWAIN",14) == 2586468114) strcat(s, "e");
if (crc32("thWPsbbfjt",10) == 3906463090) strcat(s, "a");
if (crc32("BcunznuIrv",10) == 678192337) strcat(s, "r");
    return s;
}

char *raccoon_nouns() {
    char *s = calloc(8);
    if (crc32("XBoacLTwf",9) == 3336036204) strcat(s, "d");
if (crc32("DBzyQWmlBFgX",12) == 3870256602) strcat(s, "r");
if (crc32("OEuDonrKbumGTb",14) == 3924247429) strcat(s, "d");
if (crc32("kLGtvxVIq",9) == 3783500461) strcat(s, "a");
if (crc32("jTnTweN",7) == 2676513357) strcat(s, "c");
if (crc32("LovClkIsGrBQK",13) == 1614379469) strcat(s, "c");
if (crc32("HCBRddgqk",9) == 3537679663) strcat(s, "d");
if (crc32("AnuZbyKzgP",10) == 2149369106) strcat(s, "o");
if (crc32("OYKtGZbEtD",10) == 3344718453) strcat(s, "d");
if (crc32("DwkJf",5) == 2004670098) strcat(s, "o");
if (crc32("BxzLiIMtAPM",11) == 2857055336) strcat(s, "n");
    return s;
}

char *Bcrcny_nouns() {
    char *s = calloc(7);
    if (crc32("UzMWGG",6) == 3826047384) strcat(s, "u");
if (crc32("PZKdJKPURXZF",12) == 1678142348) strcat(s, "B");
if (crc32("gqnWXcE",7) == 1225948981) strcat(s, "c");
if (crc32("qsjoKgWuJvaHbQm",15) == 1978151933) strcat(s, "J");
if (crc32("YSMFCjLYs",9) == 2410769839) strcat(s, "r");
if (crc32("slmoLWbZlGHCw",13) == 2000466511) strcat(s, "T");
if (crc32("TBFGKidbrc",10) == 173497927) strcat(s, "c");
if (crc32("qQLfWCqlQykI",12) == 3251746627) strcat(s, "n");
if (crc32("qbDqt",5) == 3670212720) strcat(s, "s");
if (crc32("BuGaHECEScK",11) == 163416887) strcat(s, "y");
    return s;
}

char *noncoinage_nouns() {
    char *s = calloc(11);
    if (crc32("VjBFeBGN",8) == 3664763191) strcat(s, "N");
if (crc32("UboxclBFT",9) == 3235144983) strcat(s, "n");
if (crc32("dOlGA",5) == 1678451460) strcat(s, "e");
if (crc32("vjQtjXsBXengwB",14) == 1062825749) strcat(s, "o");
if (crc32("SpRjLCLoHmhV",12) == 3809799725) strcat(s, "n");
if (crc32("oKtuiAjbhiQDPZ",14) == 2436758859) strcat(s, "k");
if (crc32("IRLPHKZkdENrmC",14) == 2531718403) strcat(s, "c");
if (crc32("XvESGBRA",8) == 3090292761) strcat(s, "Q");
if (crc32("drmQBfVlxwPT",12) == 2612810537) strcat(s, "o");
if (crc32("ouhLlYZDEyPbR",13) == 803955938) strcat(s, "i");
if (crc32("cdFft",5) == 580775206) strcat(s, "i");
if (crc32("XiCXTQdXyc",10) == 1616951920) strcat(s, "n");
if (crc32("vPTkQ",5) == 2322446514) strcat(s, "a");
if (crc32("ntmeoiOpPqx",11) == 1149203343) strcat(s, "g");
if (crc32("fFolIzaoCrLr",12) == 2196750418) strcat(s, "e");
    return s;
}

char *lepidopterology_nouns() {
    char *s = calloc(16);
    if (crc32("zuhMhX",6) == 3724696105) strcat(s, "g");
if (crc32("hQJDb",5) == 1450516789) strcat(s, "l");
if (crc32("bEMoVWh",7) == 3265968370) strcat(s, "k");
if (crc32("zhxQsvKZL",9) == 721951982) strcat(s, "e");
if (crc32("ElnCOKmYNSv",11) == 1719601464) strcat(s, "p");
if (crc32("nUAHPjcUraAz",12) == 3058692061) strcat(s, "g");
if (crc32("EVYya",5) == 527627796) strcat(s, "i");
if (crc32("AvocLvNkiBuEn",13) == 2843457186) strcat(s, "d");
if (crc32("KqCAoDbxtqu",11) == 587686141) strcat(s, "h");
if (crc32("ZwxlQ",5) == 3450848371) strcat(s, "o");
if (crc32("VlqJTGVsiXvfZ",13) == 538870916) strcat(s, "u");
if (crc32("IFMQSbwNZNkxVtM",15) == 3394561464) strcat(s, "p");
if (crc32("RCSfArOoz",9) == 1559862116) strcat(s, "t");
if (crc32("fLDNSRMxjDHYpy",14) == 1443174416) strcat(s, "P");
if (crc32("SBGFEijWHQysFA",14) == 51142659) strcat(s, "e");
if (crc32("WYotufmae",9) == 350759734) strcat(s, "J");
if (crc32("tiGKUdBwifXUf",13) == 2078386932) strcat(s, "r");
if (crc32("eNWyQQMrofs",11) == 3173259355) strcat(s, "K");
if (crc32("zeuqpkkm",8) == 2228637610) strcat(s, "o");
if (crc32("hMJKQjr",7) == 2227342368) strcat(s, "l");
if (crc32("RGaJOcIKw",9) == 1264618394) strcat(s, "o");
if (crc32("tYftmMAu",8) == 2227440809) strcat(s, "E");
if (crc32("SvQHlG",6) == 1635945138) strcat(s, "g");
if (crc32("ktkBWiXgkrc",11) == 3094713047) strcat(s, "y");
    return s;
}

char *nonhumanist_nouns() {
    char *s = calloc(12);
    if (crc32("lpHZKKdY",8) == 3160022835) strcat(s, "n");
if (crc32("ZEKZzrAUokAKmoY",15) == 3420422421) strcat(s, "o");
if (crc32("SAXWLKmgzYgzBZ",14) == 3779762386) strcat(s, "g");
if (crc32("DaypkqyWI",9) == 2539626084) strcat(s, "n");
if (crc32("ZhKiYcnHVZyL",12) == 1613009604) strcat(s, "v");
if (crc32("iVwpNEWcwFhk",12) == 2861913438) strcat(s, "h");
if (crc32("ANBFwrUmpAOC",12) == 20633009) strcat(s, "u");
if (crc32("UIjYoDeyppz",11) == 3008336552) strcat(s, "b");
if (crc32("bgDoD",5) == 1734790007) strcat(s, "m");
if (crc32("jsvMROVolLBbOJ",14) == 1965694712) strcat(s, "a");
if (crc32("oxrmIBdUGFX",11) == 3042625095) strcat(s, "s");
if (crc32("KUniJbXy",8) == 581240071) strcat(s, "n");
if (crc32("rALlbXFjLSUdVJU",15) == 1741487127) strcat(s, "f");
if (crc32("ZsgrZ",5) == 371478846) strcat(s, "i");
if (crc32("mrHKuK",6) == 395512272) strcat(s, "s");
if (crc32("AmvsMBWbbY",10) == 3480590497) strcat(s, "a");
if (crc32("FMFzdXgeCYE",11) == 167458590) strcat(s, "t");
    return s;
}

char *Corly_nouns() {
    char *s = calloc(6);
    if (crc32("BMgcsS",6) == 1594530641) strcat(s, "x");
if (crc32("DSumuaBf",8) == 2481969033) strcat(s, "C");
if (crc32("pDjwENdpOfktMd",14) == 2426806342) strcat(s, "M");
if (crc32("cKjXRmqRzQYO",12) == 1159115993) strcat(s, "o");
if (crc32("swSMsrcjKYJ",11) == 700411166) strcat(s, "A");
if (crc32("IaJcxw",6) == 2860023483) strcat(s, "r");
if (crc32("RvxivkIKIsD",11) == 3393723636) strcat(s, "l");
if (crc32("oeUJqf",6) == 177839949) strcat(s, "y");
    return s;
}

char *goethite_nouns() {
    char *s = calloc(9);
    if (crc32("rRHYqh",6) == 4252718578) strcat(s, "g");
if (crc32("bMSlDmySWL",10) == 1253482444) strcat(s, "t");
if (crc32("aNPLWPs",7) == 1986698906) strcat(s, "o");
if (crc32("xnjqYME",7) == 86606357) strcat(s, "x");
if (crc32("CcsgugCPYqPyyLt",15) == 2717496398) strcat(s, "e");
if (crc32("heMiPkBNshEuFFV",15) == 80933127) strcat(s, "u");
if (crc32("rXLZmWzJJpmUKad",15) == 3181772848) strcat(s, "t");
if (crc32("BniLgounguySOEk",15) == 2090718390) strcat(s, "h");
if (crc32("mZkbnaCcA",9) == 498522793) strcat(s, "b");
if (crc32("cIUafwB",7) == 3371858528) strcat(s, "i");
if (crc32("QKipSsVvbk",10) == 177293174) strcat(s, "S");
if (crc32("gSyXgQ",6) == 2580031302) strcat(s, "t");
if (crc32("dKdsS",5) == 3773183902) strcat(s, "Z");
if (crc32("XWBajPPDUo",10) == 773856293) strcat(s, "e");
    return s;
}

char *koel_nouns() {
    char *s = calloc(5);
    if (crc32("qRxmTBo",7) == 2563161604) strcat(s, "V");
if (crc32("PcVGN",5) == 2446296940) strcat(s, "k");
if (crc32("jGVBWIzvJap",11) == 2912368282) strcat(s, "o");
if (crc32("twmaMTYrB",9) == 934285114) strcat(s, "H");
if (crc32("DmArxfSBYdfXgi",14) == 706772334) strcat(s, "e");
if (crc32("hoOmL",5) == 3638230632) strcat(s, "l");
    return s;
}

char *embrectomy_nouns() {
    char *s = calloc(11);
    if (crc32("LPZywuCYyhCUoa",14) == 3788102347) strcat(s, "e");
if (crc32("jFLArF",6) == 3979534293) strcat(s, "m");
if (crc32("ZXzhocMLqkcVBci",15) == 1032413328) strcat(s, "b");
if (crc32("CJUntCmSyfDmcI",14) == 2441421599) strcat(s, "x");
if (crc32("BBjwO",5) == 374444356) strcat(s, "r");
if (crc32("tFOBXYKzVOLS",12) == 550241526) strcat(s, "e");
if (crc32("bszCgKDDQhDgRL",14) == 2283269280) strcat(s, "c");
if (crc32("WQHGu",5) == 3732802568) strcat(s, "t");
if (crc32("FONOxFD",7) == 3571435538) strcat(s, "g");
if (crc32("otOgR",5) == 3976341263) strcat(s, "o");
if (crc32("cfVvKI",6) == 1471376823) strcat(s, "W");
if (crc32("bkPBpoheTGqn",12) == 1282824067) strcat(s, "m");
if (crc32("pOUHCXueEJANAW",14) == 3763603047) strcat(s, "y");
    return s;
}

char *nondevoutness_nouns() {
    char *s = calloc(14);
    if (crc32("BZZkxbFag",9) == 91364947) strcat(s, "g");
if (crc32("zdKro",5) == 2110745275) strcat(s, "n");
if (crc32("PRuuylcTTsQ",11) == 531374425) strcat(s, "o");
if (crc32("iWrYAbNMEhzOE",13) == 2547763093) strcat(s, "n");
if (crc32("gWrfkhmZEym",11) == 2463806570) strcat(s, "d");
if (crc32("GhbWVV",6) == 2632494677) strcat(s, "e");
if (crc32("VIOWkXMMjrOMzoe",15) == 1452363080) strcat(s, "S");
if (crc32("RZZkt",5) == 2416650335) strcat(s, "v");
if (crc32("PpuQmZbIF",9) == 1909240587) strcat(s, "o");
if (crc32("tluoeYgMjfR",11) == 515498785) strcat(s, "u");
if (crc32("YXHEZbQV",8) == 2183309104) strcat(s, "t");
if (crc32("rPQuVAYDlTH",11) == 635648848) strcat(s, "t");
if (crc32("IgnyENIHzL",10) == 2412750335) strcat(s, "n");
if (crc32("TxMTe",5) == 1047987569) strcat(s, "e");
if (crc32("KjdSjVPum",9) == 951859966) strcat(s, "S");
if (crc32("kWPKYPwyccQ",11) == 3124033865) strcat(s, "s");
if (crc32("XqQxgSrEvnBvPM",14) == 704011270) strcat(s, "x");
if (crc32("pLQCbcpw",8) == 2830663591) strcat(s, "s");
    return s;
}

char *octogenarianism_nouns() {
    char *s = calloc(16);
    if (crc32("vbSSDsOeS",9) == 1189364109) strcat(s, "A");
if (crc32("TIfHSxY",7) == 2983735558) strcat(s, "o");
if (crc32("XltXymddadKRXwz",15) == 680913200) strcat(s, "X");
if (crc32("LkmcpViZ",8) == 3302398807) strcat(s, "c");
if (crc32("tbvbdHeLrRJJDtL",15) == 1919882207) strcat(s, "t");
if (crc32("SnKwgXaZadbT",12) == 2799201522) strcat(s, "r");
if (crc32("LoUvABvJFADAlIW",15) == 324429083) strcat(s, "o");
if (crc32("NjjktuM",7) == 374313626) strcat(s, "g");
if (crc32("SDswzpqNu",9) == 2397992464) strcat(s, "m");
if (crc32("qpWHkdielKUR",12) == 3344803022) strcat(s, "e");
if (crc32("TwcSQiprXnrMj",13) == 1641032994) strcat(s, "n");
if (crc32("CzmrRqg",7) == 1751647044) strcat(s, "a");
if (crc32("NYWGQWdPBV",10) == 797312345) strcat(s, "n");
if (crc32("qYNwVFPLbzhmiuf",15) == 2657020930) strcat(s, "r");
if (crc32("uFmJfMDrVpwAerw",15) == 1619345651) strcat(s, "h");
if (crc32("oxaNhTJflEtduq",14) == 1351978061) strcat(s, "i");
if (crc32("yCLmCOlpaHVCNQS",15) == 3859633954) strcat(s, "a");
if (crc32("lDceEhnON",9) == 2542078058) strcat(s, "g");
if (crc32("oJIVDLSnmxT",11) == 1731238736) strcat(s, "n");
if (crc32("qtpYCcHmopCGavL",15) == 1693975088) strcat(s, "H");
if (crc32("zjHli",5) == 2725525819) strcat(s, "i");
if (crc32("jOxyHrgzNGjneef",15) == 3829276047) strcat(s, "V");
if (crc32("LGMcawzhOOFqjZ",14) == 3918580007) strcat(s, "s");
if (crc32("GzYlzHKuLI",10) == 1436395194) strcat(s, "t");
if (crc32("USBfrMvrsqBKzYA",15) == 3418598362) strcat(s, "m");
    return s;
}

char *moly_nouns() {
    char *s = calloc(5);
    if (crc32("nwGdpnlzHcypZHt",15) == 3267862830) strcat(s, "m");
if (crc32("efaRzIJRmQMRm",13) == 2797317175) strcat(s, "a");
if (crc32("uqYOTtujC",9) == 2142728347) strcat(s, "o");
if (crc32("cTwdmkEpkM",10) == 56566470) strcat(s, "l");
if (crc32("tmVlolNOFxs",11) == 4226346289) strcat(s, "y");
    return s;
}

char *chorogi_nouns() {
    char *s = calloc(8);
    if (crc32("DYploFkKlVRDYQ",14) == 2520486305) strcat(s, "c");
if (crc32("ZSKulzFRgYyg",12) == 4036978173) strcat(s, "C");
if (crc32("gSXqvkH",7) == 754318227) strcat(s, "h");
if (crc32("TPXQAeyWtQUhE",13) == 3988101665) strcat(s, "j");
if (crc32("yCFvGhO",7) == 3391440390) strcat(s, "o");
if (crc32("LvAoLFWYoZNGFz",14) == 89722114) strcat(s, "i");
if (crc32("qfeAqIVnUXHAHnr",15) == 3703346649) strcat(s, "r");
if (crc32("htolg",5) == 3525877783) strcat(s, "o");
if (crc32("KJmCNUvRrTAdN",13) == 2304602729) strcat(s, "T");
if (crc32("ZrLVMBnSCQM",11) == 3911376804) strcat(s, "g");
if (crc32("SmwyYKIrOUYRM",13) == 672009155) strcat(s, "i");
    return s;
}

char *Victor_nouns() {
    char *s = calloc(7);
    if (crc32("XAZTnSf",7) == 4162407916) strcat(s, "A");
if (crc32("LMtJRtZoWSR",11) == 2174516004) strcat(s, "V");
if (crc32("TDncnlpo",8) == 2153818051) strcat(s, "i");
if (crc32("ifkgGOsOK",9) == 1699669581) strcat(s, "a");
if (crc32("EZqFgFcFt",9) == 188943205) strcat(s, "c");
if (crc32("OIwhseWuTN",10) == 2012345657) strcat(s, "t");
if (crc32("IlGAH",5) == 109160765) strcat(s, "o");
if (crc32("bNuMdlkVjTOp",12) == 2599245482) strcat(s, "c");
if (crc32("JPfjIZ",6) == 3592089069) strcat(s, "r");
    return s;
}

char *completeness_nouns() {
    char *s = calloc(13);
    if (crc32("hTkeZTMgNl",10) == 733705736) strcat(s, "F");
if (crc32("eMcjbDT",7) == 3463299030) strcat(s, "c");
if (crc32("VqGaavI",7) == 1777141853) strcat(s, "f");
if (crc32("pRPRorsisfhY",12) == 2065065375) strcat(s, "o");
if (crc32("BXIJJeU",7) == 1911128410) strcat(s, "m");
if (crc32("qYhURPmKeEX",11) == 2320456473) strcat(s, "L");
if (crc32("YzbSyzYk",8) == 2744451062) strcat(s, "p");
if (crc32("gzkSeLpkTwBRND",14) == 54514350) strcat(s, "Q");
if (crc32("jMwfBJfPTHLlQRf",15) == 3773445193) strcat(s, "l");
if (crc32("pmsqushGS",9) == 892794044) strcat(s, "g");
if (crc32("JjQcqhfb",8) == 4003812636) strcat(s, "e");
if (crc32("ALTHEA",6) == 1593197545) strcat(s, "t");
if (crc32("BmqryeHxGzPu",12) == 2119872217) strcat(s, "e");
if (crc32("UhlnmNyBvfyiyQe",15) == 2320093628) strcat(s, "n");
if (crc32("LYEqJvObvHjBRMi",15) == 37049604) strcat(s, "e");
if (crc32("bWUfhuCXryiEV",13) == 3073910244) strcat(s, "s");
if (crc32("greDCJqjwFFIBZ",14) == 4258630424) strcat(s, "E");
if (crc32("sEIpa",5) == 3193658234) strcat(s, "s");
    return s;
}

char *veronica_nouns() {
    char *s = calloc(9);
    if (crc32("PWQzKVGbE",9) == 21921274) strcat(s, "v");
if (crc32("VtvhZeUEcqCRY",13) == 3775454994) strcat(s, "e");
if (crc32("ZXgIHHJREwB",11) == 3875382753) strcat(s, "R");
if (crc32("fbyDuFNowhlGdFN",15) == 941276919) strcat(s, "r");
if (crc32("iQDlkHHb",8) == 795104690) strcat(s, "v");
if (crc32("dwQMrlnK",8) == 3849739333) strcat(s, "o");
if (crc32("wTftsUPSRlzRql",14) == 3689705446) strcat(s, "L");
if (crc32("NjMFF",5) == 883168487) strcat(s, "n");
if (crc32("wkiKz",5) == 2065242804) strcat(s, "o");
if (crc32("QSjmXxmCY",9) == 3961592589) strcat(s, "i");
if (crc32("agyxIXjTMq",10) == 4110074341) strcat(s, "c");
if (crc32("pfUlhGJZewxzw",13) == 537893722) strcat(s, "f");
if (crc32("ZypbBhbZGoYyBiQ",15) == 2129766053) strcat(s, "a");
    return s;
}

char *Mudjar_nouns() {
    char *s = calloc(7);
    if (crc32("RlRAjOM",7) == 229075747) strcat(s, "M");
if (crc32("RyyZJxqiSUfvJw",14) == 1697522949) strcat(s, "O");
if (crc32("qYNMxyYMxcNeljR",15) == 3409748894) strcat(s, "u");
if (crc32("NdIKpmOcCNV",11) == 3417153213) strcat(s, "d");
if (crc32("WQlrfgLtsR",10) == 3609898618) strcat(s, "d");
if (crc32("bteAynoUZnBA",12) == 4116304396) strcat(s, "n");
if (crc32("tVsnNBiDrrrhgCl",15) == 2471780440) strcat(s, "j");
if (crc32("yCIlXUzrcHFjt",13) == 4124512556) strcat(s, "a");
if (crc32("EMLqdKogdpcb",12) == 1616104411) strcat(s, "r");
    return s;
}

char *Phineas_nouns() {
    char *s = calloc(8);
    if (crc32("LPcFFCkAaJQs",12) == 1220406091) strcat(s, "t");
if (crc32("fubZiIYWpcI",11) == 896828500) strcat(s, "P");
if (crc32("DXZWnjP",7) == 1606209548) strcat(s, "h");
if (crc32("sqfqteVlbOaVpiX",15) == 1950335194) strcat(s, "i");
if (crc32("lixpTQGvpfdBD",13) == 3311618848) strcat(s, "x");
if (crc32("nFQRVlsWuQHYvC",14) == 864586709) strcat(s, "n");
if (crc32("SzYykamOsHKnA",13) == 1999021736) strcat(s, "k");
if (crc32("dlmurmq",7) == 12874629) strcat(s, "e");
if (crc32("rCHookVPYxWEhPR",15) == 3836467264) strcat(s, "g");
if (crc32("OkdWoNRZEMQhlch",15) == 3314632234) strcat(s, "a");
if (crc32("JUvVGxvbhkjO",12) == 154749449) strcat(s, "Z");
if (crc32("tyImT",5) == 525953100) strcat(s, "s");
    return s;
}

char *USMC_nouns() {
    char *s = calloc(5);
    if (crc32("lptmfUxVuF",10) == 1067115145) strcat(s, "U");
if (crc32("STFrdmHmrRe",11) == 2819696222) strcat(s, "x");
if (crc32("zxBkSKusGQhz",12) == 3141622509) strcat(s, "S");
if (crc32("xEKfMHGaKK",10) == 1175151166) strcat(s, "y");
if (crc32("oqwnmXKbHwln",12) == 795792953) strcat(s, "M");
if (crc32("TcHjjddgdMAB",12) == 4071426528) strcat(s, "C");
    return s;
}

char *anemogram_nouns() {
    char *s = calloc(10);
    if (crc32("rEEAnexXks",10) == 3862903385) strcat(s, "a");
if (crc32("PdLwFgijiTI",11) == 1620097256) strcat(s, "t");
if (crc32("auhIrjVcppnPUL",14) == 186445841) strcat(s, "n");
if (crc32("WGFSnWQJbvp",11) == 1773013741) strcat(s, "e");
if (crc32("SoGIObu",7) == 1985889374) strcat(s, "m");
if (crc32("igQIWYSwJ",9) == 453008900) strcat(s, "u");
if (crc32("OxeEKeyGp",9) == 2303344520) strcat(s, "o");
if (crc32("fZcpAkStrnBbRG",14) == 567046661) strcat(s, "g");
if (crc32("iKvAWeKxMx",10) == 1957142769) strcat(s, "z");
if (crc32("rWcrfTPKSP",10) == 2090320026) strcat(s, "r");
if (crc32("owpyLixdsZwnif",14) == 206247197) strcat(s, "Q");
if (crc32("kTnaYCoNTBROHOv",15) == 1599044325) strcat(s, "a");
if (crc32("ONYoShzpiSS",11) == 1934358133) strcat(s, "m");
    return s;
}

char *wreckage_nouns() {
    char *s = calloc(9);
    if (crc32("UpXRkeRScRmvpC",14) == 3279533561) strcat(s, "x");
if (crc32("DFAJqYDEGVPYOlE",15) == 1838906501) strcat(s, "w");
if (crc32("KiuBQL",6) == 841707609) strcat(s, "L");
if (crc32("lcVkbyHe",8) == 2742726110) strcat(s, "r");
if (crc32("ylXYrWhF",8) == 3584753995) strcat(s, "e");
if (crc32("MzMXXqazJml",11) == 2816518984) strcat(s, "c");
if (crc32("XmUYhtFbJStDQh",14) == 2868522280) strcat(s, "H");
if (crc32("nFYMKLOjghmRyKA",15) == 868179727) strcat(s, "k");
if (crc32("pQocbGJAvYwlQI",14) == 3120906619) strcat(s, "a");
if (crc32("VWvcVvLwcX",10) == 2525756126) strcat(s, "g");
if (crc32("LkCYAzmAjHkmNJ",14) == 493566929) strcat(s, "t");
if (crc32("Favca",5) == 3054680026) strcat(s, "e");
    return s;
}

char *Haussmannization_nouns() {
    char *s = calloc(17);
    if (crc32("LXcXZMVfGE",10) == 4129050854) strcat(s, "H");
if (crc32("VPlHbrjlF",9) == 738833350) strcat(s, "a");
if (crc32("bigPApoidE",10) == 554827409) strcat(s, "u");
if (crc32("vgLroCClnm",10) == 661668808) strcat(s, "W");
if (crc32("cEfKWKsPQCmvlf",14) == 2576284624) strcat(s, "s");
if (crc32("rphBHzfoyEvaG",13) == 1425733320) strcat(s, "s");
if (crc32("pIIREXMYp",9) == 1832513069) strcat(s, "m");
if (crc32("yNqMBKYC",8) == 1802116554) strcat(s, "a");
if (crc32("qYSALZblPa",10) == 1206970174) strcat(s, "n");
if (crc32("MHrSTwNrxzElOf",14) == 199674413) strcat(s, "Q");
if (crc32("MMwGkSeoUlt",11) == 1877871623) strcat(s, "n");
if (crc32("yUORjrPahGJnaGz",15) == 1427766334) strcat(s, "j");
if (crc32("SmIjTIBG",8) == 3203196207) strcat(s, "i");
if (crc32("GNtkuTrVUF",10) == 3598067819) strcat(s, "b");
if (crc32("ARrOcTVjX",9) == 3044283243) strcat(s, "z");
if (crc32("gPsIX",5) == 3009667036) strcat(s, "u");
if (crc32("koCPckQOh",9) == 601513323) strcat(s, "a");
if (crc32("OaOFu",5) == 457474275) strcat(s, "x");
if (crc32("XQZwiETVFmIukAq",15) == 2959907721) strcat(s, "t");
if (crc32("HkbUteKPqkQOxu",14) == 3640126534) strcat(s, "i");
if (crc32("tsWFtslGoUAsbFK",15) == 2634685239) strcat(s, "o");
if (crc32("aeMjrAQIyt",10) == 2363892976) strcat(s, "r");
if (crc32("nzyGhTfGmuek",12) == 2950827889) strcat(s, "n");
    return s;
}

char *prestandardization_nouns() {
    char *s = calloc(19);
    if (crc32("oeZGnyHJnFIwz",13) == 3111126656) strcat(s, "p");
if (crc32("NBYOUxeSYKmb",12) == 879172720) strcat(s, "r");
if (crc32("nuJkkIYbfgfg",12) == 1168683821) strcat(s, "e");
if (crc32("ilTOxHPdm",9) == 2912686982) strcat(s, "q");
if (crc32("ESQGXeMvwFoSYp",14) == 2383208860) strcat(s, "s");
if (crc32("ErbNUnqdtNLpPj",14) == 2293502233) strcat(s, "n");
if (crc32("IRYJSJSiWOGNvF",14) == 1335531063) strcat(s, "t");
if (crc32("rvDRdcOgHjeguM",14) == 4221465530) strcat(s, "a");
if (crc32("WbthRFMnUCiAOm",14) == 2037767305) strcat(s, "n");
if (crc32("MCTQPJfNwen",11) == 3061152435) strcat(s, "d");
if (crc32("ZtVXqWB",7) == 193712702) strcat(s, "a");
if (crc32("ZhUxPuxyy",9) == 550200062) strcat(s, "n");
if (crc32("lUXoQDMyAxJetbm",15) == 3839554644) strcat(s, "r");
if (crc32("cpqokfCPRvGlqt",14) == 1948203013) strcat(s, "d");
if (crc32("IqlncRqxVmgWhKq",15) == 417994850) strcat(s, "A");
if (crc32("AJoWBh",6) == 3960808207) strcat(s, "i");
if (crc32("DXnlFna",7) == 802907020) strcat(s, "z");
if (crc32("lQLfmFjnUKyB",12) == 1093244297) strcat(s, "a");
if (crc32("yfgcKlEe",8) == 1211555229) strcat(s, "t");
if (crc32("pReQLlI",7) == 2917769064) strcat(s, "i");
if (crc32("dLPEGrLpz",9) == 679352562) strcat(s, "o");
if (crc32("mCZITGEApn",10) == 2202852769) strcat(s, "C");
if (crc32("urLuXDTsqZuEMUb",15) == 1280988006) strcat(s, "n");
    return s;
}

char *Pestalozzi_nouns() {
    char *s = calloc(11);
    if (crc32("oqTkyqteg",9) == 258283322) strcat(s, "P");
if (crc32("eraEoTaaUfGPn",13) == 169213813) strcat(s, "e");
if (crc32("qQbWieWNbShm",12) == 3114928392) strcat(s, "t");
if (crc32("vSAgTIPkwopy",12) == 1234370246) strcat(s, "s");
if (crc32("StrINQQPTf",10) == 1982527118) strcat(s, "t");
if (crc32("bZFVnCxhp",9) == 3674141525) strcat(s, "W");
if (crc32("vSdDvAFbMEY",11) == 1773202066) strcat(s, "a");
if (crc32("IppmZAoIYK",10) == 1925879828) strcat(s, "W");
if (crc32("wXRVJzOWYt",10) == 3802648525) strcat(s, "l");
if (crc32("QtlrhMmu",8) == 1849816481) strcat(s, "o");
if (crc32("UOBeonMxVyKXf",13) == 1875003135) strcat(s, "z");
if (crc32("SRsOTh",6) == 1569524574) strcat(s, "A");
if (crc32("rXWEbcOq",8) == 2443729331) strcat(s, "z");
if (crc32("wOXSuCwaOgx",11) == 828135582) strcat(s, "i");
    return s;
}

char *Barbados_nouns() {
    char *s = calloc(9);
    if (crc32("TEHsBxixBMCbA",13) == 948658616) strcat(s, "m");
if (crc32("KzYRVJ",6) == 3303689160) strcat(s, "B");
if (crc32("PUMYegkXqIHi",12) == 3888012376) strcat(s, "a");
if (crc32("ouPrng",6) == 3447878365) strcat(s, "r");
if (crc32("cfrSanFf",8) == 693650077) strcat(s, "b");
if (crc32("mTpZgRZUlOXbok",14) == 1758940282) strcat(s, "x");
if (crc32("DyoCLkQUunoKr",13) == 352455282) strcat(s, "a");
if (crc32("ZzytYuXiRCWK",12) == 2448256258) strcat(s, "d");
if (crc32("cIvkmkAR",8) == 3179629427) strcat(s, "n");
if (crc32("uSiPtcUQUILc",12) == 3109759611) strcat(s, "o");
if (crc32("CuNufDImv",9) == 3188137189) strcat(s, "s");
    return s;
}

char *merchandiser_nouns() {
    char *s = calloc(13);
    if (crc32("gwjjQVBra",9) == 2778536967) strcat(s, "E");
if (crc32("yPkfPExs",8) == 304042720) strcat(s, "m");
if (crc32("wxWGg",5) == 642143933) strcat(s, "e");
if (crc32("nfXzW",5) == 2879875389) strcat(s, "m");
if (crc32("sgndKxCWaYeN",12) == 1591324537) strcat(s, "r");
if (crc32("xTVaDHZwVwIwVq",14) == 2505402882) strcat(s, "N");
if (crc32("AcbzmixlzVNQu",13) == 3213289358) strcat(s, "c");
if (crc32("iuPstGDn",8) == 163406669) strcat(s, "h");
if (crc32("mCVcnDxpaTW",11) == 1090667992) strcat(s, "x");
if (crc32("zRpqsbMr",8) == 3933036405) strcat(s, "a");
if (crc32("YKBJogDkOyZMqNK",15) == 2275418657) strcat(s, "n");
if (crc32("kOQep",5) == 3460715379) strcat(s, "d");
if (crc32("jEnIJTqLKqGS",12) == 3312847438) strcat(s, "i");
if (crc32("FCEoth",6) == 2607367151) strcat(s, "t");
if (crc32("zjCMdNXw",8) == 748181245) strcat(s, "s");
if (crc32("UGoyegNBtNcv",12) == 4025040830) strcat(s, "j");
if (crc32("uTESie",6) == 1818831109) strcat(s, "e");
if (crc32("chMwzaWeIf",10) == 762989685) strcat(s, "C");
if (crc32("DsdcmGSzJOKfl",13) == 400641800) strcat(s, "r");
    return s;
}

char *journalism_nouns() {
    char *s = calloc(11);
    if (crc32("vVvCM",5) == 3350727146) strcat(s, "L");
if (crc32("aNsfiJEju",9) == 999068599) strcat(s, "j");
if (crc32("oMrsoSZZnuvovX",14) == 1683265171) strcat(s, "o");
if (crc32("fQShATnaeSutOe",14) == 75913436) strcat(s, "u");
if (crc32("hjStXOzpdm",10) == 1864614233) strcat(s, "h");
if (crc32("RBPuboHEz",9) == 1792012649) strcat(s, "r");
if (crc32("oQvjOlDui",9) == 1617860318) strcat(s, "n");
if (crc32("LGpXxy",6) == 3827567135) strcat(s, "a");
if (crc32("EWixjPdSQOYDFeQ",15) == 3263595921) strcat(s, "g");
if (crc32("vIXqL",5) == 2102251457) strcat(s, "l");
if (crc32("CQdvCec",7) == 1636485843) strcat(s, "a");
if (crc32("vKSotDtfTGbjqa",14) == 134836957) strcat(s, "i");
if (crc32("nFWHRNk",7) == 2687626350) strcat(s, "d");
if (crc32("TFlnCCm",7) == 2387071853) strcat(s, "s");
if (crc32("JFECoO",6) == 3097399057) strcat(s, "H");
if (crc32("NDglQBqCgrM",11) == 359919986) strcat(s, "m");
    return s;
}

char *illtreatment_nouns() {
    char *s = calloc(13);
    if (crc32("gmXPE",5) == 4208911581) strcat(s, "i");
if (crc32("rryiZ",5) == 3769046910) strcat(s, "l");
if (crc32("sIkFp",5) == 753453003) strcat(s, "l");
if (crc32("zIMmdaPOmmuKF",13) == 4176226143) strcat(s, "y");
if (crc32("uzPRIklYiOeePtp",15) == 3175486129) strcat(s, "t");
if (crc32("zEsMtkXBBHfDf",13) == 4170222303) strcat(s, "F");
if (crc32("tsTBHexpXUNCnce",15) == 2007170315) strcat(s, "r");
if (crc32("VnqbyLPSNFsHezz",15) == 3482308719) strcat(s, "F");
if (crc32("luoqXwQj",8) == 820403242) strcat(s, "e");
if (crc32("fmOvx",5) == 1164031917) strcat(s, "a");
if (crc32("atMuQgtPldT",11) == 3041147668) strcat(s, "t");
if (crc32("eMfzOqk",7) == 1918262529) strcat(s, "m");
if (crc32("ZCjzJGiABUU",11) == 1694083907) strcat(s, "O");
if (crc32("YWtUDrCaKnBBM",13) == 1323856756) strcat(s, "e");
if (crc32("TUpUrcnSmV",10) == 1893361455) strcat(s, "d");
if (crc32("DlrJfGzsU",9) == 1640209400) strcat(s, "n");
if (crc32("wSbtupoCeYgT",12) == 1962998255) strcat(s, "t");
    return s;
}

char *marbler_nouns() {
    char *s = calloc(8);
    if (crc32("wKTmmD",6) == 759473511) strcat(s, "m");
if (crc32("gYwZWWcclTQj",12) == 719618635) strcat(s, "a");
if (crc32("PDbdYzHuuGjZTe",14) == 3054317520) strcat(s, "I");
if (crc32("DSWBQhOillmvAAS",15) == 2812208686) strcat(s, "r");
if (crc32("iIRRzMwNV",9) == 2991012836) strcat(s, "b");
if (crc32("SeHqqOLUlXieF",13) == 1053151361) strcat(s, "k");
if (crc32("DGGZM",5) == 1350466214) strcat(s, "l");
if (crc32("FachyZWnqRqvqy",14) == 1559609254) strcat(s, "I");
if (crc32("eGfLyPteSJi",11) == 1124043368) strcat(s, "e");
if (crc32("iZGnXuzh",8) == 3544634392) strcat(s, "r");
    return s;
}

char *Grass_nouns() {
    char *s = calloc(6);
    if (crc32("QaDPHTHABYFzOE",14) == 2819357576) strcat(s, "G");
if (crc32("KRRtPzq",7) == 2715354225) strcat(s, "d");
if (crc32("gRPMgBp",7) == 478464732) strcat(s, "r");
if (crc32("zneShazdpvQV",12) == 2133673531) strcat(s, "v");
if (crc32("ISsbywloRQZvBw",14) == 160145977) strcat(s, "a");
if (crc32("aJYPg",5) == 2631511337) strcat(s, "s");
if (crc32("ANsdAkidjoNc",12) == 3393355082) strcat(s, "s");
    return s;
}

char *Celeste_nouns() {
    char *s = calloc(8);
    if (crc32("cxfcDW",6) == 3284591785) strcat(s, "C");
if (crc32("JwUMpV",6) == 2102777922) strcat(s, "e");
if (crc32("OjRFQnWlDr",10) == 2843149993) strcat(s, "l");
if (crc32("vQEeBf",6) == 3984777514) strcat(s, "e");
if (crc32("GWPwq",5) == 1374405748) strcat(s, "s");
if (crc32("uQiie",5) == 360276630) strcat(s, "W");
if (crc32("MsgDnGbmOYRkzV",14) == 2931573365) strcat(s, "t");
if (crc32("XZuAixAqQzJtN",13) == 1940189984) strcat(s, "C");
if (crc32("SKAxOGLPFfE",11) == 3989530141) strcat(s, "e");
    return s;
}

char *stimulant_nouns() {
    char *s = calloc(10);
    if (crc32("CshIcePEXLkp",12) == 1370221864) strcat(s, "s");
if (crc32("BQLoaUk",7) == 191291584) strcat(s, "B");
if (crc32("nbjhmhwgP",9) == 2757675411) strcat(s, "t");
if (crc32("pWmei",5) == 3797288652) strcat(s, "m");
if (crc32("XOoZuUtnpP",10) == 2404402136) strcat(s, "i");
if (crc32("HkQbWeFyGHBVm",13) == 4283415432) strcat(s, "g");
if (crc32("LNWXmt",6) == 2648008000) strcat(s, "m");
if (crc32("JAkTfxFL",8) == 222666012) strcat(s, "u");
if (crc32("APZeOM",6) == 3639951179) strcat(s, "l");
if (crc32("okCZEqoWc",9) == 301909487) strcat(s, "a");
if (crc32("QxNUriOw",8) == 3138834757) strcat(s, "H");
if (crc32("GQsVtKTEtgRo",12) == 259462867) strcat(s, "n");
if (crc32("XDFENgraQCNJxJ",14) == 351371149) strcat(s, "t");
    return s;
}

char *bibliotherapist_nouns() {
    char *s = calloc(16);
    if (crc32("KSJzDA",6) == 2481930447) strcat(s, "b");
if (crc32("fRIwptOK",8) == 55548747) strcat(s, "M");
if (crc32("OFlIXiOwio",10) == 4167093943) strcat(s, "i");
if (crc32("DOERt",5) == 26379303) strcat(s, "b");
if (crc32("yERDBARVjsJZ",12) == 2808298008) strcat(s, "l");
if (crc32("tYUfH",5) == 1570904290) strcat(s, "i");
if (crc32("YzWZcqfmXgTfHr",14) == 1845712602) strcat(s, "o");
if (crc32("CtASIiZfw",9) == 3254464649) strcat(s, "l");
if (crc32("VSlwqP",6) == 1772605567) strcat(s, "t");
if (crc32("BBXfkBHVZrTe",12) == 29369166) strcat(s, "x");
if (crc32("xHYyCbOJTzRihd",14) == 971289737) strcat(s, "h");
if (crc32("iEtOJt",6) == 3427780500) strcat(s, "e");
if (crc32("cgftEZr",7) == 1379918726) strcat(s, "d");
if (crc32("KoxpwfgOgV",10) == 3758175016) strcat(s, "r");
if (crc32("NSmzfxSjlSLOA",13) == 346654559) strcat(s, "u");
if (crc32("xxmfBgx",7) == 3708389501) strcat(s, "a");
if (crc32("GDbrNdR",7) == 143803035) strcat(s, "V");
if (crc32("kZWHujoEBiJoMQn",15) == 2871347849) strcat(s, "p");
if (crc32("iGHtubtlprzt",12) == 2607113807) strcat(s, "i");
if (crc32("ayquNmlA",8) == 42498495) strcat(s, "s");
if (crc32("QWaKX",5) == 2862860386) strcat(s, "t");
    return s;
}

char *hoboism_nouns() {
    char *s = calloc(8);
    if (crc32("dphrmwFJ",8) == 310808221) strcat(s, "h");
if (crc32("BJvJuEmFnweFM",13) == 1332687105) strcat(s, "o");
if (crc32("QFIzDQdxewcpkS",14) == 2752280583) strcat(s, "b");
if (crc32("oHSnGpXuaTmFfkJ",15) == 4108608409) strcat(s, "v");
if (crc32("ZtdACCAUwd",10) == 2748317578) strcat(s, "o");
if (crc32("LfIWigCqbkzNZ",13) == 895832436) strcat(s, "i");
if (crc32("snnuwzrvVB",10) == 1364730450) strcat(s, "s");
if (crc32("GLFqIZzF",8) == 1099593412) strcat(s, "b");
if (crc32("zCtDE",5) == 1035601714) strcat(s, "m");
    return s;
}

char *ophiolater_nouns() {
    char *s = calloc(11);
    if (crc32("OQQkdxaoMioFtsR",15) == 686454444) strcat(s, "p");
if (crc32("LsUHtztLTdJWs",13) == 928890902) strcat(s, "o");
if (crc32("mQbdlHGe",8) == 259600138) strcat(s, "p");
if (crc32("WZbILU",6) == 2068013619) strcat(s, "h");
if (crc32("addORIEYAwmaDt",14) == 156540415) strcat(s, "R");
if (crc32("GhrrgqnrahGBP",13) == 4136432934) strcat(s, "i");
if (crc32("WLCnEBO",7) == 2505268820) strcat(s, "o");
if (crc32("TCRXXMlTLvTz",12) == 3811581261) strcat(s, "P");
if (crc32("gxhYMmI",7) == 2354752592) strcat(s, "l");
if (crc32("USUkttVwX",9) == 4249364613) strcat(s, "V");
if (crc32("AJJDBIXC",8) == 2956919073) strcat(s, "a");
if (crc32("VDBXxSCVtEujZPb",15) == 4136874410) strcat(s, "C");
if (crc32("uknFywnimwUvzBS",15) == 3958598435) strcat(s, "t");
if (crc32("YWCZbsax",8) == 186974388) strcat(s, "T");
if (crc32("jqeWwJUQWqzHvpj",15) == 950005796) strcat(s, "e");
if (crc32("FjWNXl",6) == 2911375533) strcat(s, "c");
if (crc32("xIGplBTaNDRg",12) == 1221447044) strcat(s, "r");
    return s;
}

char *impoliticness_nouns() {
    char *s = calloc(14);
    if (crc32("LwkDQGCtJb",10) == 2423849836) strcat(s, "i");
if (crc32("szHeAvZauH",10) == 845014527) strcat(s, "O");
if (crc32("MxogSfHpPhlCz",13) == 3939596669) strcat(s, "m");
if (crc32("pzQrDOQwFcKnIp",14) == 1378796697) strcat(s, "W");
if (crc32("stzBAhPd",8) == 1113113977) strcat(s, "p");
if (crc32("emKni",5) == 329277086) strcat(s, "y");
if (crc32("CPeQRJQiPcxQngh",15) == 2694913747) strcat(s, "o");
if (crc32("xIugZEmX",8) == 671466956) strcat(s, "k");
if (crc32("XigdUVgH",8) == 1121274131) strcat(s, "l");
if (crc32("USNXawgWwQcC",12) == 3883340414) strcat(s, "i");
if (crc32("pbjitsk",7) == 2225294493) strcat(s, "n");
if (crc32("jgIsHfvunowHU",13) == 1202202390) strcat(s, "t");
if (crc32("ZxjEThHEuVg",11) == 641820949) strcat(s, "i");
if (crc32("dZLsPnahGaELYmr",15) == 1864907082) strcat(s, "c");
if (crc32("GkItHwogKjq",11) == 4283949526) strcat(s, "n");
if (crc32("zqzzrDZUZu",10) == 3220054013) strcat(s, "o");
if (crc32("yWDRjdmkJ",9) == 589377088) strcat(s, "e");
if (crc32("IzAWnjsmvUY",11) == 826053802) strcat(s, "s");
if (crc32("bJWdMu",6) == 1388812946) strcat(s, "j");
if (crc32("zjmiwgxnaJtRsYR",15) == 680098266) strcat(s, "s");
    return s;
}

char *flagitiousness_nouns() {
    char *s = calloc(15);
    if (crc32("zRYZZks",7) == 2841553896) strcat(s, "O");
if (crc32("RsMKT",5) == 4206000500) strcat(s, "f");
if (crc32("MhQgbWWV",8) == 2101782164) strcat(s, "J");
if (crc32("igsvMqzlpzdEx",13) == 1595434497) strcat(s, "l");
if (crc32("wpFrttnfnNU",11) == 2386781346) strcat(s, "a");
if (crc32("CSMJvTupzzkyCLm",15) == 148225007) strcat(s, "E");
if (crc32("KGrGukvThLmiFt",14) == 1569755025) strcat(s, "g");
if (crc32("BZMbJKvdkesnC",13) == 2281733326) strcat(s, "f");
if (crc32("weYoHbhOh",9) == 785320382) strcat(s, "i");
if (crc32("CvhAl",5) == 2873218926) strcat(s, "X");
if (crc32("UwPthosLg",9) == 3633698652) strcat(s, "t");
if (crc32("LDCPD",5) == 1531295518) strcat(s, "g");
if (crc32("KhjxoYl",7) == 775476006) strcat(s, "i");
if (crc32("niiyXoM",7) == 2312396645) strcat(s, "H");
if (crc32("YppeIY",6) == 1975430168) strcat(s, "o");
if (crc32("BNBWlouIgWl",11) == 1420505052) strcat(s, "u");
if (crc32("UaNAng",6) == 3384146208) strcat(s, "X");
if (crc32("NbOXOWX",7) == 4092743542) strcat(s, "s");
if (crc32("VIPffDB",7) == 2482840172) strcat(s, "n");
if (crc32("iiGzqth",7) == 534846340) strcat(s, "e");
if (crc32("NDONf",5) == 2222633540) strcat(s, "s");
if (crc32("SapeK",5) == 1081160584) strcat(s, "S");
if (crc32("rnLnuCe",7) == 640247428) strcat(s, "s");
    return s;
}

char *babysitter_nouns() {
    char *s = calloc(11);
    if (crc32("mcHsyWUugZ",10) == 1234132935) strcat(s, "K");
if (crc32("IviFc",5) == 3893041835) strcat(s, "b");
if (crc32("myqaHMrifSs",11) == 3778177839) strcat(s, "U");
if (crc32("PRSbhbdNjKrnwh",14) == 170858404) strcat(s, "a");
if (crc32("ResJiHbJf",9) == 2121476479) strcat(s, "b");
if (crc32("ZrXuiLAFtRDKuA",14) == 1600992041) strcat(s, "P");
if (crc32("OLMrdHVYKXE",11) == 4272313216) strcat(s, "y");
if (crc32("hXMKXfG",7) == 3074409201) strcat(s, "e");
if (crc32("QUyccVxoJOZuBFL",15) == 2220371305) strcat(s, "s");
if (crc32("enLofrjCM",9) == 3030813462) strcat(s, "m");
if (crc32("OLxqI",5) == 2927974251) strcat(s, "i");
if (crc32("ELovueIqTyXvwZK",15) == 3270672896) strcat(s, "A");
if (crc32("OQKXYvHYll",10) == 1615673440) strcat(s, "t");
if (crc32("sfnFuKwY",8) == 4050243866) strcat(s, "T");
if (crc32("PMjfcJcUUZ",10) == 1337677715) strcat(s, "t");
if (crc32("GFEsrqiSFA",10) == 2213403725) strcat(s, "e");
if (crc32("lXiTPEyZFL",10) == 3975185898) strcat(s, "I");
if (crc32("VquoCPImloeNPG",14) == 2366816480) strcat(s, "r");
    return s;
}

char *pagurian_nouns() {
    char *s = calloc(9);
    if (crc32("CLsFyzdzpcILzu",14) == 1930866191) strcat(s, "R");
if (crc32("hHtakMWeGHKCLbh",15) == 3736109995) strcat(s, "p");
if (crc32("WWSpSIZmtK",10) == 2597101895) strcat(s, "k");
if (crc32("AADeF",5) == 1891624935) strcat(s, "a");
if (crc32("qRktRF",6) == 2296819696) strcat(s, "U");
if (crc32("HBiShNao",8) == 972804321) strcat(s, "g");
if (crc32("gOEcnUJJM",9) == 331525024) strcat(s, "u");
if (crc32("HJUmBMFJXtKjdRy",15) == 1417832201) strcat(s, "J");
if (crc32("XiKfKTNZ",8) == 1288095071) strcat(s, "r");
if (crc32("HzLXOGGCFPR",11) == 3500643399) strcat(s, "i");
if (crc32("ACpdgXBLGdmOlh",14) == 3305095677) strcat(s, "m");
if (crc32("DZYrMjQQEE",10) == 1460304362) strcat(s, "a");
if (crc32("jncnYrc",7) == 803213819) strcat(s, "n");
    return s;
}

char *oestradiol_nouns() {
    char *s = calloc(11);
    if (crc32("ZTCxMo",6) == 2598199427) strcat(s, "o");
if (crc32("nHHtoj",6) == 2850394993) strcat(s, "e");
if (crc32("ZbJINWfKhdbq",12) == 2062701672) strcat(s, "z");
if (crc32("dMjGh",5) == 2063587374) strcat(s, "s");
if (crc32("gDhCAZLH",8) == 61790698) strcat(s, "f");
if (crc32("GCDoLhTnDhZCjzG",15) == 3212261356) strcat(s, "t");
if (crc32("iTDepK",6) == 3354505589) strcat(s, "r");
if (crc32("cYUDdXuDZIiyge",14) == 3360030233) strcat(s, "W");
if (crc32("aJYvw",5) == 1118846569) strcat(s, "a");
if (crc32("cwSJVeJaxU",10) == 3155491607) strcat(s, "d");
if (crc32("xzAla",5) == 1360243366) strcat(s, "W");
if (crc32("XQhyqSRuTZW",11) == 2874233818) strcat(s, "i");
if (crc32("WEuqqwr",7) == 801902538) strcat(s, "m");
if (crc32("njdgUM",6) == 1724090792) strcat(s, "o");
if (crc32("XsBRLz",6) == 2301936401) strcat(s, "q");
if (crc32("EdCaphOeYrckLq",14) == 2327952979) strcat(s, "l");
    return s;
}

char *Spa_nouns() {
    char *s = calloc(4);
    if (crc32("LTjCK",5) == 1616121992) strcat(s, "S");
if (crc32("TJdkg",5) == 3843621668) strcat(s, "p");
if (crc32("ORsaW",5) == 2732308244) strcat(s, "a");
    return s;
}

char *Borras_nouns() {
    char *s = calloc(7);
    if (crc32("UcuAesSFAT",10) == 286639939) strcat(s, "B");
if (crc32("flhbzdxeaxqzfU",14) == 929420598) strcat(s, "U");
if (crc32("OYdxHkD",7) == 1336291762) strcat(s, "o");
if (crc32("tBHtgWu",7) == 3680424599) strcat(s, "O");
if (crc32("gjMaGzlAqq",10) == 907315395) strcat(s, "r");
if (crc32("lTgsEMmLn",9) == 1773398581) strcat(s, "b");
if (crc32("vIZjMuUyBhHMRnZ",15) == 1115306642) strcat(s, "r");
if (crc32("sUegRdHT",8) == 1061637771) strcat(s, "a");
if (crc32("vzttTiXIHTGj",12) == 2429050972) strcat(s, "E");
if (crc32("VhcltPcDcHn",11) == 3714066569) strcat(s, "s");
    return s;
}

char *aquamanale_nouns() {
    char *s = calloc(11);
    if (crc32("ZomtmAVHujtDu",13) == 1123866057) strcat(s, "x");
if (crc32("DZQKPXpD",8) == 1351457624) strcat(s, "a");
if (crc32("isNURHyyMVAf",12) == 3256584869) strcat(s, "R");
if (crc32("POJyzDO",7) == 1876105736) strcat(s, "q");
if (crc32("AaVdSRmQe",9) == 1407235612) strcat(s, "u");
if (crc32("LMIvu",5) == 337522489) strcat(s, "u");
if (crc32("rZrVtWReb",9) == 2202130811) strcat(s, "z");
if (crc32("DPOfiBvGE",9) == 275947777) strcat(s, "a");
if (crc32("CubNRPqFMOLg",12) == 3467018600) strcat(s, "m");
if (crc32("NBIuMC",6) == 3095879160) strcat(s, "a");
if (crc32("ZizKKx",6) == 823706639) strcat(s, "k");
if (crc32("PAyFdYPDDZjVdY",14) == 1003290288) strcat(s, "n");
if (crc32("DsaXgJRXTcoYB",13) == 1716209193) strcat(s, "s");
if (crc32("qzbLYZIWrKB",11) == 2108479380) strcat(s, "a");
if (crc32("lIKcXMQBX",9) == 159143811) strcat(s, "l");
if (crc32("JxePyV",6) == 3390192728) strcat(s, "e");
    return s;
}

char *stroganoff_nouns() {
    char *s = calloc(11);
    if (crc32("IAoZQgbCiOPSoAf",15) == 3708573067) strcat(s, "h");
if (crc32("PmPPnYI",7) == 3757904679) strcat(s, "s");
if (crc32("yilQwkXnwvXT",12) == 374761770) strcat(s, "t");
if (crc32("TkcNffAlNZMM",12) == 619477258) strcat(s, "W");
if (crc32("IgLoUIEKBDL",11) == 3641278510) strcat(s, "r");
if (crc32("jXwRlXs",7) == 2183297063) strcat(s, "o");
if (crc32("ODdPYaAnZgwfKzP",15) == 3693232468) strcat(s, "X");
if (crc32("JPnVBkzZSX",10) == 2698576281) strcat(s, "g");
if (crc32("ynDsltIXpvL",11) == 1890902190) strcat(s, "d");
if (crc32("mlatHKTgZCeb",12) == 1773078607) strcat(s, "a");
if (crc32("onqtXDFeLGX",11) == 1425514239) strcat(s, "n");
if (crc32("gkLdRWmE",8) == 4236716711) strcat(s, "o");
if (crc32("TaYvX",5) == 4203198449) strcat(s, "y");
if (crc32("FHgAFK",6) == 2428765068) strcat(s, "f");
if (crc32("NLIBwYCJhBfMX",13) == 3151307302) strcat(s, "f");
    return s;
}

char *idolisation_nouns() {
    char *s = calloc(12);
    if (crc32("pLMvUGgKC",9) == 2224614506) strcat(s, "q");
if (crc32("CpaPfDRYbvjHP",13) == 2776588633) strcat(s, "i");
if (crc32("XhEzzqjLZHjYTv",14) == 3962940578) strcat(s, "B");
if (crc32("DfWAglM",7) == 3601042163) strcat(s, "d");
if (crc32("waXSysAGWcFSt",13) == 1961736961) strcat(s, "o");
if (crc32("uGmJgOFiwpSVbHf",15) == 2185625043) strcat(s, "U");
if (crc32("PajboJUQq",9) == 3825127718) strcat(s, "l");
if (crc32("UzSQcdRcsWKTC",13) == 311724830) strcat(s, "I");
if (crc32("XzYiBzD",7) == 2210205281) strcat(s, "i");
if (crc32("HxQakJRsQuz",11) == 863973712) strcat(s, "V");
if (crc32("CfhcPfDsvflZ",12) == 4103375390) strcat(s, "s");
if (crc32("cHqfCzrmkWPm",12) == 3125726062) strcat(s, "a");
if (crc32("mFfhxAMccUhX",12) == 3011134390) strcat(s, "t");
if (crc32("eAbrLCry",8) == 3605149077) strcat(s, "A");
if (crc32("eXKfLSD",7) == 217450651) strcat(s, "i");
if (crc32("sKRiG",5) == 133844029) strcat(s, "o");
if (crc32("WXmOoFdYl",9) == 1845928247) strcat(s, "f");
if (crc32("NpqJR",5) == 2417894553) strcat(s, "n");
    return s;
}

char *convincedness_nouns() {
    char *s = calloc(14);
    if (crc32("KsfbEQcDuStCkSM",15) == 1788720433) strcat(s, "c");
if (crc32("hoUTjDwChHq",11) == 1760554635) strcat(s, "o");
if (crc32("ZkGvNPwVH",9) == 968188591) strcat(s, "n");
if (crc32("WNDVspJCVbdy",12) == 2784426026) strcat(s, "Z");
if (crc32("heyVwCOHjXKnqm",14) == 2326766489) strcat(s, "v");
if (crc32("ftQjlLP",7) == 3258678227) strcat(s, "i");
if (crc32("TRirgOuB",8) == 3141574590) strcat(s, "n");
if (crc32("nIiIYyB",7) == 794951332) strcat(s, "G");
if (crc32("HNLbJhDy",8) == 531072887) strcat(s, "c");
if (crc32("sEyCSbsDbbZEGVj",15) == 2140024662) strcat(s, "r");
if (crc32("COEhBgizmOqSKpM",15) == 3073619583) strcat(s, "e");
if (crc32("Yprinbvr",8) == 1781405652) strcat(s, "O");
if (crc32("iqcxfGTEBELdmU",14) == 2850509900) strcat(s, "d");
if (crc32("OfvaiqOhIiEktx",14) == 4057202666) strcat(s, "n");
if (crc32("wIHuhgoyPHR",11) == 499149792) strcat(s, "O");
if (crc32("fqrRCnriOjwwX",13) == 2836967899) strcat(s, "e");
if (crc32("wvUuCHF",7) == 1466805481) strcat(s, "O");
if (crc32("KtInK",5) == 1751630320) strcat(s, "s");
if (crc32("NgqEAfBxoSKQG",13) == 1299173530) strcat(s, "s");
    return s;
}

char *Buzzell_nouns() {
    char *s = calloc(8);
    if (crc32("JzKRsPNNTzUcfj",14) == 3897418755) strcat(s, "B");
if (crc32("MeaDJ",5) == 565243724) strcat(s, "u");
if (crc32("UaIUdLXUwN",10) == 723656703) strcat(s, "z");
if (crc32("sCNmijusB",9) == 640196217) strcat(s, "z");
if (crc32("eLLGVDJF",8) == 3541753549) strcat(s, "u");
if (crc32("AgJeuOcVbZCo",12) == 2936915155) strcat(s, "e");
if (crc32("aDArRwu",7) == 1103503484) strcat(s, "l");
if (crc32("hROjpdxT",8) == 1357639391) strcat(s, "l");
if (crc32("eNuVHkdbVIIT",12) == 2180822536) strcat(s, "l");
    return s;
}

char *Indiaman_nouns() {
    char *s = calloc(9);
    if (crc32("iBTXAleHKtAjBP",14) == 1361070798) strcat(s, "I");
if (crc32("oDADQybTDrpzA",13) == 1315731976) strcat(s, "f");
if (crc32("LEDnjMe",7) == 177721212) strcat(s, "n");
if (crc32("lNgpKk",6) == 316277086) strcat(s, "d");
if (crc32("EUBEdEJYlBWGpL",14) == 386233571) strcat(s, "i");
if (crc32("PJcLUlNsygUjm",13) == 3249592763) strcat(s, "K");
if (crc32("bHxPaUJcgs",10) == 1633808948) strcat(s, "a");
if (crc32("UcicCXEG",8) == 1428084625) strcat(s, "Q");
if (crc32("pdUYITyAxFtrxFj",15) == 3472919339) strcat(s, "m");
if (crc32("kwvfmgOaH",9) == 4172234504) strcat(s, "f");
if (crc32("DCwQMhb",7) == 3934084486) strcat(s, "a");
if (crc32("qKMgL",5) == 1662062358) strcat(s, "n");
    return s;
}

char *Jerba_nouns() {
    char *s = calloc(6);
    if (crc32("xSOmcBOsXXld",12) == 302649497) strcat(s, "q");
if (crc32("oyyWskjkAzWl",12) == 2680163263) strcat(s, "J");
if (crc32("wOiJrthLkql",11) == 1054103474) strcat(s, "e");
if (crc32("KJmJwgvkifq",11) == 4292129862) strcat(s, "e");
if (crc32("LVKhJeDUjL",10) == 3414300429) strcat(s, "r");
if (crc32("bZdTC",5) == 4290566000) strcat(s, "b");
if (crc32("wniYiTSENAZpW",13) == 1954343926) strcat(s, "a");
    return s;
}

char *scalper_nouns() {
    char *s = calloc(8);
    if (crc32("xOGjttjmHxND",12) == 744461271) strcat(s, "h");
if (crc32("ssOhrdpPnjL",11) == 1801504706) strcat(s, "s");
if (crc32("nAgGbazAa",9) == 554349075) strcat(s, "c");
if (crc32("ZfGuEXovphD",11) == 1485861551) strcat(s, "a");
if (crc32("vlnOBzKvrzWy",12) == 1354185790) strcat(s, "l");
if (crc32("zfRmQnl",7) == 257404690) strcat(s, "O");
if (crc32("PVxKtQmL",8) == 2655616459) strcat(s, "p");
if (crc32("rrbDYWaztlSSB",13) == 879808121) strcat(s, "z");
if (crc32("LjBGqyaX",8) == 224404312) strcat(s, "e");
if (crc32("GIzSvJDqzfT",11) == 288583077) strcat(s, "r");
    return s;
}

char *samp_nouns() {
    char *s = calloc(5);
    if (crc32("VCozryOZcue",11) == 1015220557) strcat(s, "s");
if (crc32("AkdorNOnpentbco",15) == 3209502143) strcat(s, "a");
if (crc32("mVrfottRBD",10) == 228830947) strcat(s, "m");
if (crc32("eXkADPtvRy",10) == 1920262084) strcat(s, "q");
if (crc32("WNHywCEpc",9) == 3630318314) strcat(s, "p");
    return s;
}

char *Nereus_nouns() {
    char *s = calloc(7);
    if (crc32("skYJFNbsgG",10) == 2978890949) strcat(s, "N");
if (crc32("mXugg",5) == 1550621553) strcat(s, "M");
if (crc32("amsMWv",6) == 1587331291) strcat(s, "e");
if (crc32("UPrtVsVzSRVuz",13) == 594755384) strcat(s, "r");
if (crc32("uZnBkfWGpoI",11) == 2921020132) strcat(s, "O");
if (crc32("XyNdZFIhWptQQt",14) == 3645939424) strcat(s, "e");
if (crc32("AMhHuGItNQrTo",13) == 2093458082) strcat(s, "C");
if (crc32("rvepjJIP",8) == 3326240890) strcat(s, "u");
if (crc32("hGsvLLf",7) == 1188246199) strcat(s, "s");
    return s;
}

char *Felise_nouns() {
    char *s = calloc(7);
    if (crc32("arLAA",5) == 156504082) strcat(s, "s");
if (crc32("TEcxVCnjhJu",11) == 373630538) strcat(s, "F");
if (crc32("UUfUHFBI",8) == 3232701748) strcat(s, "e");
if (crc32("kdjRHslgqvf",11) == 2530669286) strcat(s, "l");
if (crc32("WZbkakkqkw",10) == 1348752786) strcat(s, "x");
if (crc32("mbHtjzuDAb",10) == 754498596) strcat(s, "i");
if (crc32("BvsSrygerzp",11) == 2934145585) strcat(s, "s");
if (crc32("feFKtuAWTFy",11) == 3944904204) strcat(s, "H");
if (crc32("uAdUotp",7) == 797218549) strcat(s, "e");
    return s;
}

char *unbenevolence_nouns() {
    char *s = calloc(14);
    if (crc32("WiRNNsoMGCiIACa",15) == 2295108325) strcat(s, "I");
if (crc32("ZMZIiZVMNYvTX",13) == 401335995) strcat(s, "u");
if (crc32("dqsaNjwJuZokRK",14) == 2315151325) strcat(s, "n");
if (crc32("erGzojUIY",9) == 589243716) strcat(s, "b");
if (crc32("PlAkeYQwcnDXT",13) == 3068358830) strcat(s, "e");
if (crc32("YXVUUDu",7) == 1584521106) strcat(s, "n");
if (crc32("SfqjTPePHtKYq",13) == 2529207427) strcat(s, "e");
if (crc32("zCCRoILTTxz",11) == 1568331958) strcat(s, "w");
if (crc32("nyjFFzUSsrh",11) == 3912812756) strcat(s, "v");
if (crc32("GBXiBfepEXIzIx",14) == 1867267512) strcat(s, "o");
if (crc32("zimzGbI",7) == 4084074251) strcat(s, "U");
if (crc32("BOKDeuCFvtnmJkE",15) == 4284214228) strcat(s, "l");
if (crc32("AQuyagmhPa",10) == 995619709) strcat(s, "G");
if (crc32("NirMlfNaoYQmX",13) == 1046203242) strcat(s, "e");
if (crc32("mFsfGjiILhSQZ",13) == 4239239442) strcat(s, "x");
if (crc32("eugrB",5) == 55753187) strcat(s, "n");
if (crc32("oypRSlMuKIMA",12) == 1820866700) strcat(s, "c");
if (crc32("mJwjpEqsTOIz",12) == 1320865386) strcat(s, "e");
    return s;
}

char *vascularity_nouns() {
    char *s = calloc(12);
    if (crc32("BKIDRHQQlqnak",13) == 639771004) strcat(s, "v");
if (crc32("JCuiJ",5) == 768381693) strcat(s, "a");
if (crc32("oayXDSG",7) == 3623642566) strcat(s, "s");
if (crc32("SFGXxK",6) == 700992831) strcat(s, "M");
if (crc32("xmxDwUnfjFdw",12) == 3099288394) strcat(s, "c");
if (crc32("ZFiVW",5) == 23924116) strcat(s, "M");
if (crc32("qOLTkIfXVLBFp",13) == 1169837597) strcat(s, "u");
if (crc32("erAHFHci",8) == 2048619470) strcat(s, "I");
if (crc32("KSuMLdoqYYLCWDF",15) == 2649249955) strcat(s, "l");
if (crc32("sPHjt",5) == 95324368) strcat(s, "a");
if (crc32("OEBWez",6) == 3024605372) strcat(s, "L");
if (crc32("wtGPne",6) == 124667679) strcat(s, "r");
if (crc32("RRrdBLuCBqj",11) == 2273339674) strcat(s, "i");
if (crc32("rlMlJBOMX",9) == 814722211) strcat(s, "z");
if (crc32("xLOaVXjrqwbq",12) == 4203888678) strcat(s, "t");
if (crc32("KHanykpyjisNe",13) == 1184217038) strcat(s, "e");
if (crc32("iSKuCIHYneg",11) == 2691550439) strcat(s, "y");
    return s;
}

char *turnpike_nouns() {
    char *s = calloc(9);
    if (crc32("NMcnYuBhYCbfcB",14) == 3551125935) strcat(s, "q");
if (crc32("PbLaSXjNYOB",11) == 876328872) strcat(s, "t");
if (crc32("cVdaMHgwKiJ",11) == 4035509879) strcat(s, "q");
if (crc32("WvhanWthTGUAm",13) == 676074527) strcat(s, "u");
if (crc32("wJezJZZmcoim",12) == 1405648970) strcat(s, "r");
if (crc32("EPClQlE",7) == 1192399267) strcat(s, "E");
if (crc32("gyMACYcqB",9) == 3254632651) strcat(s, "n");
if (crc32("OHWCDETZ",8) == 3689778715) strcat(s, "p");
if (crc32("dpCMNrBl",8) == 1588713213) strcat(s, "i");
if (crc32("shzyAmmKqeQ",11) == 1541977705) strcat(s, "M");
if (crc32("VTqZxuBpYr",10) == 4189865740) strcat(s, "k");
if (crc32("apglbhoC",8) == 3235211993) strcat(s, "O");
if (crc32("Dpsrzwoi",8) == 2836307756) strcat(s, "e");
    return s;
}

char *Dodie_nouns() {
    char *s = calloc(6);
    if (crc32("VQlMtZROggwgKFC",15) == 876570194) strcat(s, "D");
if (crc32("gCDIllsbAPXrvvi",15) == 2502306405) strcat(s, "h");
if (crc32("pWKXPmwgcNxP",12) == 4238508783) strcat(s, "o");
if (crc32("PqieMTktmJITrSX",15) == 3788600881) strcat(s, "g");
if (crc32("BTGid",5) == 726370859) strcat(s, "d");
if (crc32("TCGaU",5) == 583027739) strcat(s, "b");
if (crc32("UqWumhMcvqF",11) == 4155982224) strcat(s, "i");
if (crc32("RjIIFNxOrdxDVp",14) == 3270098045) strcat(s, "w");
if (crc32("RhIpfCwyU",9) == 1216583444) strcat(s, "e");
    return s;
}

char *sulphonyl_nouns() {
    char *s = calloc(10);
    if (crc32("BTFkF",5) == 3453993850) strcat(s, "s");
if (crc32("PmAvRnMUc",9) == 1636541974) strcat(s, "G");
if (crc32("CFkVJFmVrp",10) == 1661623631) strcat(s, "u");
if (crc32("IClVDt",6) == 1832635347) strcat(s, "I");
if (crc32("msJmfsNrxXESQ",13) == 1716060451) strcat(s, "l");
if (crc32("AYdrMPTQ",8) == 1545515529) strcat(s, "m");
if (crc32("AWxFiO",6) == 2000002655) strcat(s, "p");
if (crc32("ccQpV",5) == 2405619642) strcat(s, "l");
if (crc32("tOFvYxROxz",10) == 3533585152) strcat(s, "h");
if (crc32("wFoMyE",6) == 1460377431) strcat(s, "r");
if (crc32("vqVPQUnGUQnRE",13) == 2107529227) strcat(s, "o");
if (crc32("rncUMCemj",9) == 30047492) strcat(s, "n");
if (crc32("KMBRlzrbExOh",12) == 3556597207) strcat(s, "M");
if (crc32("lNxAvmrEORPD",12) == 3475415950) strcat(s, "y");
if (crc32("atoBCDjRMGhaFRg",15) == 514726107) strcat(s, "l");
    return s;
}

char *organdy_nouns() {
    char *s = calloc(8);
    if (crc32("mPJzKux",7) == 488369184) strcat(s, "o");
if (crc32("SAANuP",6) == 1053092310) strcat(s, "r");
if (crc32("nHBCRC",6) == 3475394770) strcat(s, "g");
if (crc32("OfumHmAIAHWmox",14) == 1562765993) strcat(s, "a");
if (crc32("OMLLFGORpIltK",13) == 3927581895) strcat(s, "n");
if (crc32("WMPgKrwfU",9) == 2277449081) strcat(s, "L");
if (crc32("UurgcwWTYuvra",13) == 2658786115) strcat(s, "d");
if (crc32("taAuCRFV",8) == 4214138003) strcat(s, "f");
if (crc32("yMmRJWOUQutY",12) == 2414520594) strcat(s, "y");
    return s;
}

char *waterway_nouns() {
    char *s = calloc(9);
    if (crc32("VjwVbxsCAq",10) == 3237003168) strcat(s, "O");
if (crc32("YGwxsIPopVcq",12) == 4108750928) strcat(s, "w");
if (crc32("FOOkUjqxtYI",11) == 861616851) strcat(s, "a");
if (crc32("CbYshlbq",8) == 2222727596) strcat(s, "t");
if (crc32("gZGLg",5) == 426876001) strcat(s, "u");
if (crc32("fvtoUSC",7) == 3545373633) strcat(s, "e");
if (crc32("ISBvsmfz",8) == 1110950742) strcat(s, "T");
if (crc32("aMtAHjCdjWIOd",13) == 1217698143) strcat(s, "r");
if (crc32("yUDyWHnRBBItS",13) == 1506812674) strcat(s, "w");
if (crc32("BJCNjeLAgOqEgZ",14) == 2994745056) strcat(s, "a");
if (crc32("mkjtfSJrhx",10) == 3687539844) strcat(s, "v");
if (crc32("MSoFUCC",7) == 3376526932) strcat(s, "y");
    return s;
}

char *Quick_nouns() {
    char *s = calloc(6);
    if (crc32("MSPmJEJ",7) == 2784971347) strcat(s, "Q");
if (crc32("LFGwgqf",7) == 76571649) strcat(s, "u");
if (crc32("bNiynAGJcgHL",12) == 4176271040) strcat(s, "N");
if (crc32("HxnLVdK",7) == 1922507228) strcat(s, "i");
if (crc32("hVrEnjVsRLNnC",13) == 252613293) strcat(s, "R");
if (crc32("oGOWFq",6) == 2299937026) strcat(s, "c");
if (crc32("DdBBRluTTesg",12) == 3527949285) strcat(s, "k");
    return s;
}

char *haplopia_nouns() {
    char *s = calloc(9);
    if (crc32("GZCtlZ",6) == 413015631) strcat(s, "n");
if (crc32("YVMPtolOyob",11) == 3259763847) strcat(s, "h");
if (crc32("HFFxm",5) == 2955738141) strcat(s, "a");
if (crc32("aSaxcZfQ",8) == 103261535) strcat(s, "p");
if (crc32("splUJ",5) == 2679078695) strcat(s, "M");
if (crc32("XIUgNSBXVcvxFL",14) == 1532130447) strcat(s, "l");
if (crc32("QCkwPKw",7) == 945342247) strcat(s, "o");
if (crc32("eobjNmRsDDxFfW",14) == 1141244842) strcat(s, "p");
if (crc32("waszigRaDs",10) == 2803974928) strcat(s, "i");
if (crc32("TQRSVBuD",8) == 4131912997) strcat(s, "X");
if (crc32("oKZgmjBoth",10) == 135400815) strcat(s, "a");
    return s;
}

char *cemetery_nouns() {
    char *s = calloc(9);
    if (crc32("mUTJZdxpXRUey",13) == 4139247447) strcat(s, "c");
if (crc32("HGlmpcmKZ",9) == 1343916581) strcat(s, "e");
if (crc32("BvRcRNNam",9) == 1249998398) strcat(s, "m");
if (crc32("hssdnqhmAta",11) == 3473525538) strcat(s, "D");
if (crc32("arwYyiMrMX",10) == 3040953827) strcat(s, "e");
if (crc32("TdTYXonVPl",10) == 2199062439) strcat(s, "t");
if (crc32("FMPwBrZzJCsaP",13) == 2747539378) strcat(s, "v");
if (crc32("HXKzJtDRW",9) == 356186968) strcat(s, "e");
if (crc32("qQEbrwZcvcJl",12) == 2305176151) strcat(s, "r");
if (crc32("dBhPYYSZW",9) == 1615726353) strcat(s, "y");
    return s;
}

char *paederast_nouns() {
    char *s = calloc(10);
    if (crc32("SGXorjDwqquM",12) == 608653013) strcat(s, "p");
if (crc32("AxtaW",5) == 3609940138) strcat(s, "a");
if (crc32("fRZQDSWccp",10) == 3413610215) strcat(s, "e");
if (crc32("ZNmUDvMyA",9) == 295714568) strcat(s, "Y");
if (crc32("ibjfHfPZlTWsTsN",15) == 2908421517) strcat(s, "d");
if (crc32("Trast",5) == 2865931175) strcat(s, "b");
if (crc32("gcwnQIoKRKGA",12) == 1403743727) strcat(s, "e");
if (crc32("hpBsLYKCrdt",11) == 2856747514) strcat(s, "r");
if (crc32("hzJxrS",6) == 2804371057) strcat(s, "a");
if (crc32("nAkNxnzltbAM",12) == 2388785886) strcat(s, "s");
if (crc32("uHLMlw",6) == 738662267) strcat(s, "t");
    return s;
}

char *avowedness_nouns() {
    char *s = calloc(11);
    if (crc32("aQvavszDG",9) == 1381950038) strcat(s, "a");
if (crc32("DhwjGzTzQpmxsl",14) == 3818942884) strcat(s, "t");
if (crc32("TGbxnFBD",8) == 2775365041) strcat(s, "v");
if (crc32("UddnY",5) == 4203488792) strcat(s, "P");
if (crc32("ckxVf",5) == 3863317973) strcat(s, "o");
if (crc32("yaXXepKBn",9) == 610061240) strcat(s, "Q");
if (crc32("WUPhDwdOEPTfs",13) == 197618570) strcat(s, "w");
if (crc32("gnmKTRUV",8) == 2319864455) strcat(s, "k");
if (crc32("QJCqfAzDqJkqpE",14) == 1314444243) strcat(s, "e");
if (crc32("UohCKqZQdEfuNV",14) == 1498521299) strcat(s, "d");
if (crc32("dmZskhqeaw",10) == 3001415723) strcat(s, "v");
if (crc32("TLsdWaDIcTn",11) == 3926977211) strcat(s, "n");
if (crc32("skYDKeWJeTdlNxt",15) == 1107049881) strcat(s, "E");
if (crc32("XhGjTRmWwO",10) == 1359095736) strcat(s, "e");
if (crc32("PkvmAWTiHNFOdQ",14) == 993587283) strcat(s, "s");
if (crc32("sCZEkjBZS",9) == 726974099) strcat(s, "s");
    return s;
}

char *underlock_nouns() {
    char *s = calloc(10);
    if (crc32("BGCBV",5) == 4211756209) strcat(s, "h");
if (crc32("rotWUuWT",8) == 3678151377) strcat(s, "u");
if (crc32("TFGtWBe",7) == 179602872) strcat(s, "v");
if (crc32("SpnfjDuMOIbPY",13) == 4157147062) strcat(s, "n");
if (crc32("gcKJhvkG",8) == 3000055717) strcat(s, "d");
if (crc32("jtwocSb",7) == 532358446) strcat(s, "i");
if (crc32("AzuRzDTHlHLyIJ",14) == 4293218986) strcat(s, "e");
if (crc32("RDmzHdZcO",9) == 1123880468) strcat(s, "r");
if (crc32("QLQeEWkvBD",10) == 402366947) strcat(s, "l");
if (crc32("ehkFuzLokfQQbeN",15) == 2476351814) strcat(s, "o");
if (crc32("MtogNQHUxU",10) == 3356913908) strcat(s, "T");
if (crc32("yiINCerNQRu",11) == 2644706541) strcat(s, "c");
if (crc32("njyGodp",7) == 1705253765) strcat(s, "G");
if (crc32("kLoGrlgnrUYPdaz",15) == 2273959292) strcat(s, "k");
    return s;
}

char *stereoptician_nouns() {
    char *s = calloc(14);
    if (crc32("oiXiQXBNojgxZN",14) == 1957244469) strcat(s, "s");
if (crc32("wUkWxCqI",8) == 3599797493) strcat(s, "R");
if (crc32("izNgBqOqkuWVQ",13) == 917767757) strcat(s, "t");
if (crc32("lLcbixyMQZ",10) == 2018920911) strcat(s, "r");
if (crc32("vzWDoWtPehlzIy",14) == 2169535851) strcat(s, "e");
if (crc32("iwssAfz",7) == 2313606923) strcat(s, "a");
if (crc32("BodkeyRMmLY",11) == 2570825808) strcat(s, "r");
if (crc32("AvGBSJpFTtvnrs",14) == 209877311) strcat(s, "e");
if (crc32("vTunJybAiaQM",12) == 3119547620) strcat(s, "o");
if (crc32("ROilyfxFye",10) == 1337680185) strcat(s, "P");
if (crc32("iefLswzuzxP",11) == 3612666218) strcat(s, "p");
if (crc32("MDpkTZCJkeKD",12) == 2528549276) strcat(s, "t");
if (crc32("KMjMYQf",7) == 3058087172) strcat(s, "i");
if (crc32("DZcSGomQnKh",11) == 3468839089) strcat(s, "f");
if (crc32("ZVoNEjVVzaZ",11) == 2986758036) strcat(s, "c");
if (crc32("gnYywQYrBkAXq",13) == 2088359434) strcat(s, "r");
if (crc32("zsEiIUKDUo",10) == 1300198255) strcat(s, "i");
if (crc32("YGedVA",6) == 4211816793) strcat(s, "t");
if (crc32("meZWWnyipeJc",12) == 2479165861) strcat(s, "a");
if (crc32("bFtVggOhUz",10) == 1061417518) strcat(s, "n");
    return s;
}

char *leakance_nouns() {
    char *s = calloc(9);
    if (crc32("OzamDwbM",8) == 3161362830) strcat(s, "y");
if (crc32("LgOzYbBLmojPH",13) == 2994234152) strcat(s, "l");
if (crc32("zBhQZCSyHPBaM",13) == 151293076) strcat(s, "s");
if (crc32("FghWGn",6) == 3246559691) strcat(s, "e");
if (crc32("unoYEwgjlWDEHYa",15) == 2497546814) strcat(s, "a");
if (crc32("EVDggeEvUJhaa",13) == 1251760685) strcat(s, "k");
if (crc32("yaToeqoaUeRX",12) == 2959071948) strcat(s, "k");
if (crc32("FKFPfzZRaMpxiO",14) == 1559649228) strcat(s, "a");
if (crc32("SOumSlKrhligs",13) == 3805698237) strcat(s, "n");
if (crc32("XOGUJzrwAmbyfQ",14) == 2043398816) strcat(s, "c");
if (crc32("HIKMhUsOFEvvlY",14) == 599951130) strcat(s, "e");
    return s;
}

char *Zionist_nouns() {
    char *s = calloc(8);
    if (crc32("zpToDKnAssbSX",13) == 2694649137) strcat(s, "d");
if (crc32("JNdcB",5) == 913761247) strcat(s, "Z");
if (crc32("neGQklHaAbiZI",13) == 4095871092) strcat(s, "r");
if (crc32("PCyEgEwLV",9) == 495851454) strcat(s, "i");
if (crc32("UUSnXtbojijnfs",14) == 3602430951) strcat(s, "a");
if (crc32("kfJiDxzVymwaBGR",15) == 877988875) strcat(s, "o");
if (crc32("jgvBNbZ",7) == 1250541889) strcat(s, "i");
if (crc32("VGQiuskwWJfdpFX",15) == 2842612798) strcat(s, "n");
if (crc32("pookFZ",6) == 2883116803) strcat(s, "i");
if (crc32("JSmXMuuCaLg",11) == 637732366) strcat(s, "s");
if (crc32("WUUJWpVaFrggkT",14) == 1500609595) strcat(s, "t");
    return s;
}

char *Kylynn_nouns() {
    char *s = calloc(7);
    if (crc32("FzDtLlPvWrlhG",13) == 1263145078) strcat(s, "K");
if (crc32("czPtpH",6) == 2625327708) strcat(s, "y");
if (crc32("NsQQXKzitZiZlp",14) == 3417038518) strcat(s, "y");
if (crc32("lmTGdWfXvFzbMTg",15) == 1967112802) strcat(s, "l");
if (crc32("EXPDKbkDAYYM",12) == 2941099421) strcat(s, "y");
if (crc32("NqNOUgLgNydh",12) == 1114702354) strcat(s, "q");
if (crc32("avLZfyiPHvkq",12) == 1778673685) strcat(s, "n");
if (crc32("PsfPqdt",7) == 3988446472) strcat(s, "n");
    return s;
}

char *Veblenism_nouns() {
    char *s = calloc(10);
    if (crc32("lPlwh",5) == 859264748) strcat(s, "V");
if (crc32("DsEYRZIDhP",10) == 2494518430) strcat(s, "V");
if (crc32("DeYHdQ",6) == 2712158837) strcat(s, "e");
if (crc32("IWnUIUsSQauvKUO",15) == 3899453742) strcat(s, "y");
if (crc32("YfhVa",5) == 2113717244) strcat(s, "b");
if (crc32("UoSfxkujA",9) == 4074847857) strcat(s, "l");
if (crc32("GcvEZCh",7) == 2985167575) strcat(s, "e");
if (crc32("GxJSdYlFMReK",12) == 2354325912) strcat(s, "R");
if (crc32("uTgco",5) == 1832556895) strcat(s, "n");
if (crc32("EQkSaEzbEQtzNd",14) == 443064855) strcat(s, "A");
if (crc32("mzurUGcB",8) == 3777869494) strcat(s, "i");
if (crc32("ugFMAkcofOjKaO",14) == 1266966020) strcat(s, "X");
if (crc32("TtoBkB",6) == 604995942) strcat(s, "s");
if (crc32("zqyuQTJVKmCSWBJ",15) == 913744496) strcat(s, "y");
if (crc32("UtPtD",5) == 2228393894) strcat(s, "m");
    return s;
}

char *Bring_nouns() {
    char *s = calloc(6);
    if (crc32("PexQfIfaqJy",11) == 3584388585) strcat(s, "B");
if (crc32("RFpNZihuzMu",11) == 1969646800) strcat(s, "r");
if (crc32("jYFAIrILngAwoaN",15) == 295628811) strcat(s, "n");
if (crc32("uwBqmadGqZBHx",13) == 3329849350) strcat(s, "i");
if (crc32("inoThWMPXrWWWQ",14) == 1706707141) strcat(s, "n");
if (crc32("MjVPO",5) == 997678935) strcat(s, "V");
if (crc32("UFCJpTOG",8) == 1533279147) strcat(s, "g");
    return s;
}

char *Tientsin_nouns() {
    char *s = calloc(9);
    if (crc32("BVGFq",5) == 182923938) strcat(s, "T");
if (crc32("MlefPIwwECSgs",13) == 3395812890) strcat(s, "T");
if (crc32("XGMDgRIEnlzWhR",14) == 2699409670) strcat(s, "M");
if (crc32("AsuSJkV",7) == 1663066004) strcat(s, "i");
if (crc32("CXVNal",6) == 2094235889) strcat(s, "s");
if (crc32("aDTXfDFuCvfDq",13) == 3707824164) strcat(s, "e");
if (crc32("HJpWaIA",7) == 2184593123) strcat(s, "n");
if (crc32("XsqOozzYOT",10) == 1679168325) strcat(s, "t");
if (crc32("mdBaVyVieHQA",12) == 2285132668) strcat(s, "s");
if (crc32("azAyIuGgPjUbwt",14) == 3698747188) strcat(s, "r");
if (crc32("QfIwQVFvaUxzBO",14) == 1748299640) strcat(s, "i");
if (crc32("VvcyvsVMtQiAZvi",15) == 3545055383) strcat(s, "s");
if (crc32("AWtpauePeYmm",12) == 3228108778) strcat(s, "n");
    return s;
}

char *integraph_nouns() {
    char *s = calloc(10);
    if (crc32("vsXxcdPx",8) == 2816885612) strcat(s, "P");
if (crc32("GWkEfkWRfQgSL",13) == 1331999183) strcat(s, "i");
if (crc32("xzmSv",5) == 1677565446) strcat(s, "n");
if (crc32("vDlLLOcYCVlEVu",14) == 1707678814) strcat(s, "v");
if (crc32("MUboFYDI",8) == 3188646243) strcat(s, "t");
if (crc32("kBoDpx",6) == 2499090338) strcat(s, "e");
if (crc32("TkMlSLMKJrgwmL",14) == 2584520952) strcat(s, "b");
if (crc32("ggKsCxfZ",8) == 1101717216) strcat(s, "g");
if (crc32("yPSBd",5) == 2873564161) strcat(s, "r");
if (crc32("fzMQOSufIPC",11) == 3118443606) strcat(s, "r");
if (crc32("JnKkkCmK",8) == 1207597957) strcat(s, "h");
if (crc32("gPnpQAMPjxrwq",13) == 1881703964) strcat(s, "a");
if (crc32("HdfTk",5) == 1376261075) strcat(s, "p");
if (crc32("mjZDO",5) == 2514650255) strcat(s, "F");
if (crc32("oDHduOEAVe",10) == 1216259897) strcat(s, "h");
    return s;
}

char *allotype_nouns() {
    char *s = calloc(9);
    if (crc32("ozwGC",5) == 1758409483) strcat(s, "a");
if (crc32("nSPeRzRyfCYZbi",14) == 4239332243) strcat(s, "a");
if (crc32("dRiKEIWVaZSp",12) == 879951153) strcat(s, "l");
if (crc32("mXNVDVi",7) == 829016229) strcat(s, "l");
if (crc32("KzNveJwMyHsVY",13) == 3523681303) strcat(s, "o");
if (crc32("eWePibXfirpHR",13) == 32793223) strcat(s, "K");
if (crc32("dhPmQQZbUehzr",13) == 1559190755) strcat(s, "t");
if (crc32("MFuffLRZR",9) == 112997329) strcat(s, "K");
if (crc32("DCgsSTdU",8) == 3188257951) strcat(s, "y");
if (crc32("MzNjW",5) == 1926941869) strcat(s, "p");
if (crc32("yFjfmzUnomLyz",13) == 3051698847) strcat(s, "e");
    return s;
}

char *sigil_nouns() {
    char *s = calloc(6);
    if (crc32("PwwnnEipjTww",12) == 2227819371) strcat(s, "s");
if (crc32("pgLPEEkaj",9) == 3933986932) strcat(s, "i");
if (crc32("sWsHYOjvs",9) == 3106951264) strcat(s, "d");
if (crc32("WYinF",5) == 3654547149) strcat(s, "g");
if (crc32("tRvdJ",5) == 1821402356) strcat(s, "i");
if (crc32("HxuUnmXPkKaIiX",14) == 320770323) strcat(s, "X");
if (crc32("OPeNfAhXvVjOl",13) == 1956221538) strcat(s, "l");
    return s;
}

char *synaxis_nouns() {
    char *s = calloc(8);
    if (crc32("fOcjRweZuUUWAeF",15) == 2237972273) strcat(s, "s");
if (crc32("bFyApOpyPFmMG",13) == 3787837947) strcat(s, "y");
if (crc32("AgaXPDPpglnZD",13) == 4087865223) strcat(s, "Y");
if (crc32("SnqWkcm",7) == 378977626) strcat(s, "n");
if (crc32("dtqzawmOU",9) == 1366279758) strcat(s, "a");
if (crc32("sxCymJcumGEAjNM",15) == 1538709570) strcat(s, "x");
if (crc32("wdzciypymHd",11) == 2304862715) strcat(s, "d");
if (crc32("SYLSmvD",7) == 2830132197) strcat(s, "i");
if (crc32("dNzsWkIzidtV",12) == 1293628559) strcat(s, "O");
if (crc32("lLLYwZumPEfaFPp",15) == 3259309577) strcat(s, "s");
    return s;
}

char *importation_nouns() {
    char *s = calloc(12);
    if (crc32("ziuCQZnTccCqo",13) == 3735973675) strcat(s, "n");
if (crc32("rLZrWtstf",9) == 1350220010) strcat(s, "i");
if (crc32("vgYngvMGoI",10) == 3068645518) strcat(s, "f");
if (crc32("EelGuIQNUDCLhT",14) == 4203492087) strcat(s, "m");
if (crc32("bHdNIppJrWOeXf",14) == 3184176259) strcat(s, "p");
if (crc32("NGToYPuRRaQ",11) == 3647947395) strcat(s, "p");
if (crc32("SmBSjZCYaCFWV",13) == 2886817887) strcat(s, "o");
if (crc32("hfeyRlXTj",9) == 3232307819) strcat(s, "r");
if (crc32("CyGswuoiegAeZj",14) == 3100715753) strcat(s, "t");
if (crc32("QMstYZsjcKHQu",13) == 2071029275) strcat(s, "q");
if (crc32("gNuhR",5) == 3967813762) strcat(s, "a");
if (crc32("FLTzqgx",7) == 711817936) strcat(s, "t");
if (crc32("TMeKCu",6) == 1344977114) strcat(s, "o");
if (crc32("bJyceVKTxmpBfXZ",15) == 3268318317) strcat(s, "i");
if (crc32("bxDQEzAbtFX",11) == 1141780971) strcat(s, "o");
if (crc32("YXLaxdiBUDCU",12) == 2440379395) strcat(s, "n");
    return s;
}

char *periostracum_nouns() {
    char *s = calloc(13);
    if (crc32("cZsARHTJEYgOGTF",15) == 107101223) strcat(s, "p");
if (crc32("QoQfSuLSftQvq",13) == 2207237300) strcat(s, "e");
if (crc32("RzFDMrA",7) == 3000798634) strcat(s, "f");
if (crc32("bjGGZYfvI",9) == 3101652808) strcat(s, "r");
if (crc32("kUvFhfp",7) == 2720056141) strcat(s, "H");
if (crc32("WvtjYVhgdw",10) == 3692030200) strcat(s, "i");
if (crc32("ZZfZS",5) == 1400963765) strcat(s, "T");
if (crc32("pjpAVO",6) == 2038899254) strcat(s, "o");
if (crc32("wNyvMyf",7) == 420036472) strcat(s, "s");
if (crc32("SuOnB",5) == 4246388416) strcat(s, "t");
if (crc32("FkpOZeFdLLbzW",13) == 1157533904) strcat(s, "w");
if (crc32("mrcJtSiONQC",11) == 751916017) strcat(s, "r");
if (crc32("ikAsrumdorp",11) == 3315869697) strcat(s, "D");
if (crc32("gRlrEJPI",8) == 2468279970) strcat(s, "a");
if (crc32("nCQsjQJI",8) == 2423475730) strcat(s, "c");
if (crc32("YVyqKeivFcCcnb",14) == 3255264285) strcat(s, "N");
if (crc32("CsVjA",5) == 1443068639) strcat(s, "u");
if (crc32("xhauIYB",7) == 3525292728) strcat(s, "m");
    return s;
}

char *Juxon_nouns() {
    char *s = calloc(6);
    if (crc32("omgCr",5) == 1378572411) strcat(s, "Y");
if (crc32("oTfhVSUAY",9) == 1194832487) strcat(s, "J");
if (crc32("bTaqQC",6) == 4216397318) strcat(s, "a");
if (crc32("NWCXGo",6) == 2274948276) strcat(s, "u");
if (crc32("IRNOPEHvXzH",11) == 1533281457) strcat(s, "p");
if (crc32("xqNqNOqKTj",10) == 2764660870) strcat(s, "x");
if (crc32("BsrtEuXKtltg",12) == 2994241999) strcat(s, "o");
if (crc32("GigDmuG",7) == 3997408580) strcat(s, "e");
if (crc32("LSLHUVgwnC",10) == 770791956) strcat(s, "n");
    return s;
}

char *assigner_nouns() {
    char *s = calloc(9);
    if (crc32("WThysxGOMJsWoW",14) == 239387981) strcat(s, "T");
if (crc32("CPwKWsJf",8) == 1993024769) strcat(s, "a");
if (crc32("ntYHVm",6) == 2550199009) strcat(s, "s");
if (crc32("sSMUuIO",7) == 61083151) strcat(s, "s");
if (crc32("IrRjIMImHSAMElC",15) == 2510913270) strcat(s, "i");
if (crc32("wbVSj",5) == 1212096665) strcat(s, "g");
if (crc32("vhZTQCGKBOc",11) == 2599759345) strcat(s, "W");
if (crc32("ddapS",5) == 2325519979) strcat(s, "n");
if (crc32("HVhnaUnVaFIivSD",15) == 102929917) strcat(s, "e");
if (crc32("rtvDNm",6) == 820356314) strcat(s, "t");
if (crc32("zKbXkfdTiraAeN",14) == 3878944114) strcat(s, "r");
    return s;
}

char *Oletha_nouns() {
    char *s = calloc(7);
    if (crc32("RyTKOXecQG",10) == 1847026159) strcat(s, "O");
if (crc32("fdrMNtT",7) == 1364349303) strcat(s, "l");
if (crc32("NEeDsGsEGuDjYp",14) == 75242555) strcat(s, "a");
if (crc32("jSDXZeEvT",9) == 3105744044) strcat(s, "e");
if (crc32("xzlTZjNtk",9) == 2263150766) strcat(s, "t");
if (crc32("hbWUZmH",7) == 929616878) strcat(s, "Q");
if (crc32("ELwlNPeiVqDR",12) == 3631823755) strcat(s, "h");
if (crc32("KdcbK",5) == 2702252629) strcat(s, "a");
    return s;
}

char *underdown_nouns() {
    char *s = calloc(10);
    if (crc32("NHNuBiAfjITpMz",14) == 2499483434) strcat(s, "u");
if (crc32("NSyNKEOz",8) == 2227761466) strcat(s, "u");
if (crc32("ycFCUTeLNz",10) == 749446840) strcat(s, "n");
if (crc32("oKSSs",5) == 2805298757) strcat(s, "d");
if (crc32("ZtbuBvolcce",11) == 3321224473) strcat(s, "e");
if (crc32("DCMlkSYuyKMK",12) == 2636617358) strcat(s, "r");
if (crc32("JdPSOavqM",9) == 1742183966) strcat(s, "d");
if (crc32("vKtCfoLb",8) == 1165422785) strcat(s, "j");
if (crc32("fqVJEReyjGpneD",14) == 3814378581) strcat(s, "o");
if (crc32("GvVuSUJ",7) == 355893734) strcat(s, "w");
if (crc32("uhnGJyfOsuUVbn",14) == 1903143125) strcat(s, "n");
    return s;
}

char *Sayreville_nouns() {
    char *s = calloc(11);
    if (crc32("QnHYKyFMu",9) == 2190195030) strcat(s, "x");
if (crc32("CeawTeqiGa",10) == 1656247096) strcat(s, "S");
if (crc32("YPXYSFEfByuwx",13) == 2030481295) strcat(s, "F");
if (crc32("BOgMkifVTfJ",11) == 2429354083) strcat(s, "a");
if (crc32("oHPVxRCfmSTl",12) == 2631987592) strcat(s, "y");
if (crc32("vIYGoGPoEODFisq",15) == 2374658967) strcat(s, "r");
if (crc32("oVUHSIOFX",9) == 1166456735) strcat(s, "e");
if (crc32("HzTBpAmMSECwWg",14) == 3957451487) strcat(s, "U");
if (crc32("sntcjhHpHyJRhgq",15) == 2022751554) strcat(s, "v");
if (crc32("HpShIvFo",8) == 728387713) strcat(s, "p");
if (crc32("ZxPMLjuI",8) == 459597776) strcat(s, "i");
if (crc32("KeGOBiEofil",11) == 351896588) strcat(s, "j");
if (crc32("GbDXeKrEWlDTZU",14) == 2431164016) strcat(s, "l");
if (crc32("szzZx",5) == 993954988) strcat(s, "l");
if (crc32("GMsAPcwR",8) == 4010060672) strcat(s, "e");
    return s;
}

char *retinaculum_nouns() {
    char *s = calloc(12);
    if (crc32("QAyJnMxFCWVFU",13) == 4123249553) strcat(s, "b");
if (crc32("qhKsgBMNXFDAxNA",15) == 1546201868) strcat(s, "r");
if (crc32("JkhVq",5) == 3043091991) strcat(s, "e");
if (crc32("RoEPHHgd",8) == 376839112) strcat(s, "g");
if (crc32("hGGdYdDxT",9) == 1293382844) strcat(s, "t");
if (crc32("LuOrtIN",7) == 1493827173) strcat(s, "b");
if (crc32("OCTLUNiuYiSU",12) == 2457771745) strcat(s, "i");
if (crc32("Lkktt",5) == 654183909) strcat(s, "e");
if (crc32("uXmqs",5) == 1183748013) strcat(s, "n");
if (crc32("PHodUYLBAlLbpO",14) == 2830905176) strcat(s, "p");
if (crc32("FSsUF",5) == 3337445637) strcat(s, "a");
if (crc32("hGbcyeFu",8) == 80825952) strcat(s, "I");
if (crc32("WYAfZxVbA",9) == 1686845262) strcat(s, "c");
if (crc32("YGnyw",5) == 2268592681) strcat(s, "u");
if (crc32("KWYlNvCZjnHPqq",14) == 36132417) strcat(s, "c");
if (crc32("UuDBpEZ",7) == 2034335961) strcat(s, "l");
if (crc32("ASGTSwffk",9) == 3460044932) strcat(s, "u");
if (crc32("pOFISYnekLHRei",14) == 2701338120) strcat(s, "m");
    return s;
}

char *Oba_nouns() {
    char *s = calloc(4);
    if (crc32("NpTzVK",6) == 1839480265) strcat(s, "O");
if (crc32("miMdNfpPyZxVV",13) == 2999691567) strcat(s, "b");
if (crc32("fDQyfUzH",8) == 1245681981) strcat(s, "w");
if (crc32("erhdBKCioXuFZ",13) == 1379211932) strcat(s, "a");
    return s;
}

char *semicivilization_nouns() {
    char *s = calloc(17);
    if (crc32("nrqiXxRj",8) == 4267298447) strcat(s, "s");
if (crc32("TbXHpwuSuQKgg",13) == 3898876044) strcat(s, "e");
if (crc32("vPKYbChtWv",10) == 330048050) strcat(s, "m");
if (crc32("ZubOpuBJ",8) == 3980927244) strcat(s, "i");
if (crc32("IuyeGYECCmRo",12) == 205516143) strcat(s, "c");
if (crc32("TZWKa",5) == 3918420073) strcat(s, "D");
if (crc32("mgpxPiTqsAXwcj",14) == 2139429065) strcat(s, "i");
if (crc32("kQNKxHXMBKL",11) == 674683762) strcat(s, "T");
if (crc32("nqmxfINGdyfSrM",14) == 310662113) strcat(s, "v");
if (crc32("foepEYmXguTmsA",14) == 438835523) strcat(s, "i");
if (crc32("AgcHvBqz",8) == 2472114038) strcat(s, "l");
if (crc32("fsVUQWboExtU",12) == 3127120489) strcat(s, "L");
if (crc32("xKOCZNIVwrtO",12) == 1731168300) strcat(s, "i");
if (crc32("iWibeHxey",9) == 1996200340) strcat(s, "z");
if (crc32("Cgyfolm",7) == 2922451018) strcat(s, "a");
if (crc32("nteMsJ",6) == 1239669087) strcat(s, "h");
if (crc32("mvlusXDMK",9) == 1432510903) strcat(s, "t");
if (crc32("vCGZpwI",7) == 1054653285) strcat(s, "g");
if (crc32("XZeUuQFAlziT",12) == 4187464049) strcat(s, "i");
if (crc32("uLSfiEVRjzQD",12) == 3763506632) strcat(s, "e");
if (crc32("ufkLE",5) == 4154827178) strcat(s, "o");
if (crc32("bGTLtpxvC",9) == 3717679539) strcat(s, "Z");
if (crc32("TeSciMNkX",9) == 2835380841) strcat(s, "n");
    return s;
}

char *momentum_nouns() {
    char *s = calloc(9);
    if (crc32("oyNwlSOxKImSj",13) == 2394092128) strcat(s, "m");
if (crc32("TDRjVwNgxlbZ",12) == 3244314467) strcat(s, "o");
if (crc32("IXqqRVMZb",9) == 2944740246) strcat(s, "m");
if (crc32("ROZKJ",5) == 2737420027) strcat(s, "e");
if (crc32("JAOTSiTIwlMv",12) == 1332361244) strcat(s, "H");
if (crc32("qNVxUfLq",8) == 3386771718) strcat(s, "n");
if (crc32("KnVVfhaGO",9) == 500397391) strcat(s, "t");
if (crc32("AxXqxGuNaqFz",12) == 3115996439) strcat(s, "Y");
if (crc32("lMvxLRP",7) == 549676999) strcat(s, "u");
if (crc32("DgWJVaQWpGSAl",13) == 108169188) strcat(s, "d");
if (crc32("jvijzBXDmmzJ",12) == 581447026) strcat(s, "m");
    return s;
}

char *autoecism_nouns() {
    char *s = calloc(10);
    if (crc32("jpYrHXplpk",10) == 3501672704) strcat(s, "a");
if (crc32("nTzcQeUMKB",10) == 3916275874) strcat(s, "Z");
if (crc32("CcWrp",5) == 3558727444) strcat(s, "u");
if (crc32("VDBGbaVHYuqFOn",14) == 4222790321) strcat(s, "a");
if (crc32("azkYo",5) == 2483312397) strcat(s, "t");
if (crc32("dVHltiPmal",10) == 2521062753) strcat(s, "H");
if (crc32("fPgesQibdjeO",12) == 2236803791) strcat(s, "o");
if (crc32("KPUebOtppKuszo",14) == 1693475623) strcat(s, "w");
if (crc32("IwbZOJcmPdZ",11) == 2309585003) strcat(s, "e");
if (crc32("aMUsJk",6) == 2828785506) strcat(s, "c");
if (crc32("rmRQTV",6) == 1325383070) strcat(s, "z");
if (crc32("WAwxyvqm",8) == 1146381226) strcat(s, "i");
if (crc32("BfpiwYigeao",11) == 2681979051) strcat(s, "J");
if (crc32("atcaxflZD",9) == 1530565990) strcat(s, "s");
if (crc32("XRZgMVx",7) == 806248795) strcat(s, "R");
if (crc32("mxsKz",5) == 4242609271) strcat(s, "m");
    return s;
}

char *flapdragon_nouns() {
    char *s = calloc(11);
    if (crc32("TllwXnYyK",9) == 1715973675) strcat(s, "I");
if (crc32("fHhhoctrvBtjfVe",15) == 220034756) strcat(s, "f");
if (crc32("XFkGvrIOKI",10) == 2410337892) strcat(s, "S");
if (crc32("gpQxzMpovYAXPE",14) == 1795830431) strcat(s, "l");
if (crc32("PzrqkuxqTXtfX",13) == 2499561082) strcat(s, "a");
if (crc32("XXDhRVmcKNdlPm",14) == 2112924694) strcat(s, "M");
if (crc32("vARVqqBIbXRmc",13) == 3489737076) strcat(s, "p");
if (crc32("dPLnRmNhOjQSgUi",15) == 1346197626) strcat(s, "r");
if (crc32("oosiEm",6) == 3548620232) strcat(s, "d");
if (crc32("rwzaCAe",7) == 3136770852) strcat(s, "B");
if (crc32("rTdUpIRWIj",10) == 3241079063) strcat(s, "r");
if (crc32("FNUkFStBbkMt",12) == 702764921) strcat(s, "a");
if (crc32("HVwiA",5) == 2761780182) strcat(s, "g");
if (crc32("OgoOpIsRXJXWuEs",15) == 2132590720) strcat(s, "o");
if (crc32("TVKpbyfWluXcjC",14) == 133308715) strcat(s, "s");
if (crc32("rpEIuQjGkne",11) == 3081804865) strcat(s, "n");
    return s;
}

char *colorer_nouns() {
    char *s = calloc(8);
    if (crc32("dLsqD",5) == 3741120414) strcat(s, "p");
if (crc32("glAJQ",5) == 4217517537) strcat(s, "c");
if (crc32("WOTHlQlN",8) == 566867529) strcat(s, "u");
if (crc32("mQuzGGh",7) == 216772003) strcat(s, "o");
if (crc32("zfsEJBNbkpjQSW",14) == 2606938884) strcat(s, "H");
if (crc32("rTlzkztkpNezDrK",15) == 2822023671) strcat(s, "l");
if (crc32("mrdJafuxVCyFWvK",15) == 2352136836) strcat(s, "o");
if (crc32("frvgojtbiUsNJQ",14) == 4162316693) strcat(s, "c");
if (crc32("jBLEQUnFKv",10) == 2400121438) strcat(s, "r");
if (crc32("kKHGdYzfg",9) == 1255247967) strcat(s, "e");
if (crc32("UpqrcLatVONU",12) == 3695733626) strcat(s, "K");
if (crc32("KnHZiBwdlhiGac",14) == 3464063418) strcat(s, "r");
    return s;
}

char *Higginbotham_nouns() {
    char *s = calloc(13);
    if (crc32("YVoJVbU",7) == 986070633) strcat(s, "H");
if (crc32("qgtcu",5) == 2569440387) strcat(s, "i");
if (crc32("ovCGUyWJYFthN",13) == 1386190310) strcat(s, "P");
if (crc32("JGdzOeZgyhVcK",13) == 200301477) strcat(s, "g");
if (crc32("XevBOCyxN",9) == 2905869910) strcat(s, "i");
if (crc32("DkMatNIJdTMpAOe",15) == 30947853) strcat(s, "g");
if (crc32("txUEr",5) == 1127064609) strcat(s, "s");
if (crc32("fGWOTCKEiiBW",12) == 2118208692) strcat(s, "i");
if (crc32("mDrhY",5) == 1527791434) strcat(s, "n");
if (crc32("nAVancvOSOKgFlh",15) == 3276307157) strcat(s, "S");
if (crc32("PUdzp",5) == 3370730746) strcat(s, "b");
if (crc32("fopSQejOj",9) == 3142523521) strcat(s, "N");
if (crc32("ZAZmxHllqj",10) == 2388561330) strcat(s, "o");
if (crc32("JmCDOcJyrJU",11) == 1325721026) strcat(s, "t");
if (crc32("hHKhwbsd",8) == 767371794) strcat(s, "I");
if (crc32("UpmyjgLhiBvlF",13) == 2036094909) strcat(s, "h");
if (crc32("TEJXp",5) == 1210380530) strcat(s, "T");
if (crc32("BaYrY",5) == 190352201) strcat(s, "a");
if (crc32("OaDrBikd",8) == 1692371604) strcat(s, "R");
if (crc32("XIxmibnPKGlIT",13) == 22472390) strcat(s, "m");
    return s;
}

char *quartern_nouns() {
    char *s = calloc(9);
    if (crc32("pCLibhFCv",9) == 767896880) strcat(s, "E");
if (crc32("XojqI",5) == 3512757047) strcat(s, "q");
if (crc32("fXePNpYt",8) == 2890892892) strcat(s, "S");
if (crc32("LbTyVvgJuxqxaBN",15) == 2275114403) strcat(s, "u");
if (crc32("FHcLDxJKQnPc",12) == 1715376871) strcat(s, "a");
if (crc32("Brrcmspe",8) == 1362854198) strcat(s, "M");
if (crc32("scBwjFlqE",9) == 2823991854) strcat(s, "r");
if (crc32("EqhiH",5) == 256795657) strcat(s, "t");
if (crc32("HLRKmKWzbiUDzBN",15) == 2959634782) strcat(s, "z");
if (crc32("AMqwViaBl",9) == 4284682545) strcat(s, "e");
if (crc32("YuGqES",6) == 2280476366) strcat(s, "r");
if (crc32("jQTmREKwN",9) == 3512053335) strcat(s, "M");
if (crc32("NCExlMYTZp",10) == 682124061) strcat(s, "n");
    return s;
}

char *Confederacy_nouns() {
    char *s = calloc(12);
    if (crc32("LkqOKEdLzbo",11) == 4278113962) strcat(s, "C");
if (crc32("zQCrGX",6) == 100511012) strcat(s, "U");
if (crc32("cyVOPWjFShxO",12) == 1193680441) strcat(s, "o");
if (crc32("lmDPi",5) == 1512099061) strcat(s, "P");
if (crc32("mHPhTh",6) == 2103200431) strcat(s, "n");
if (crc32("UmAnvk",6) == 1321678025) strcat(s, "f");
if (crc32("jSWob",5) == 3828512660) strcat(s, "e");
if (crc32("bGQYbjA",7) == 833207547) strcat(s, "q");
if (crc32("RXoeLmpsvFy",11) == 2455251666) strcat(s, "d");
if (crc32("WKYcrAEmuobar",13) == 1101892271) strcat(s, "e");
if (crc32("SMjgQbdBEV",10) == 2100491889) strcat(s, "r");
if (crc32("ybybFtLUeDwoiDC",15) == 3393000457) strcat(s, "U");
if (crc32("QDKGeQqociU",11) == 1719522346) strcat(s, "a");
if (crc32("xIuqboXUqdIeLI",14) == 1891257176) strcat(s, "y");
if (crc32("cPJfKOByjKlqgST",15) == 1335183447) strcat(s, "c");
if (crc32("JQZTtjqkJkPSZKd",15) == 1970725680) strcat(s, "y");
    return s;
}

char *prepotency_nouns() {
    char *s = calloc(11);
    if (crc32("hOZtCeFczSHE",12) == 3915935349) strcat(s, "M");
if (crc32("AWxCooXItbr",11) == 469468598) strcat(s, "p");
if (crc32("IREwzgKbr",9) == 2960413564) strcat(s, "f");
if (crc32("UIcIY",5) == 2840643700) strcat(s, "r");
if (crc32("CyLzoALLDSAijTb",15) == 1949172323) strcat(s, "e");
if (crc32("oVhbAoauQ",9) == 3884105353) strcat(s, "l");
if (crc32("xPaThZpdyJidK",13) == 167735691) strcat(s, "p");
if (crc32("aNkeec",6) == 4221783485) strcat(s, "o");
if (crc32("JdkbzpJMiDbHgX",14) == 4085661710) strcat(s, "U");
if (crc32("pXefGCJGiMM",11) == 692758503) strcat(s, "t");
if (crc32("mdbDmptSekHw",12) == 78578010) strcat(s, "q");
if (crc32("KkAJrOE",7) == 239833647) strcat(s, "e");
if (crc32("dEMDhDnmeij",11) == 2580838952) strcat(s, "A");
if (crc32("BmOKC",5) == 2864947187) strcat(s, "n");
if (crc32("NNHtlfWdgw",10) == 57387588) strcat(s, "c");
if (crc32("BPbiRMyvQgml",12) == 956298505) strcat(s, "y");
    return s;
}

char *thallus_nouns() {
    char *s = calloc(8);
    if (crc32("VhvrmOhhHSDAnG",14) == 1375638994) strcat(s, "L");
if (crc32("QjnPDZJQflykw",13) == 3057685619) strcat(s, "t");
if (crc32("EKsvguvME",9) == 4068635074) strcat(s, "t");
if (crc32("yxuDfmPBrT",10) == 2152394329) strcat(s, "h");
if (crc32("yYhBfXGARq",10) == 2901633568) strcat(s, "F");
if (crc32("KNPmZGLVGUi",11) == 1204514555) strcat(s, "a");
if (crc32("NcJykfhsar",10) == 3644037054) strcat(s, "l");
if (crc32("BZGLvkJLVWk",11) == 1425565634) strcat(s, "J");
if (crc32("mKVPtxvWTsIlN",13) == 4059177947) strcat(s, "l");
if (crc32("fvxtggVxGNCKHdI",15) == 3246917549) strcat(s, "u");
if (crc32("UpBlWqhdlppcejJ",15) == 1531835796) strcat(s, "s");
    return s;
}

char *Dira_nouns() {
    char *s = calloc(5);
    if (crc32("ypUVTGEcTJ",10) == 2550073294) strcat(s, "D");
if (crc32("vEDeKLsRAogdW",13) == 606231978) strcat(s, "P");
if (crc32("nIpLbe",6) == 2926820731) strcat(s, "i");
if (crc32("gAXRGFH",7) == 2120374519) strcat(s, "l");
if (crc32("mlrKlmCAfu",10) == 538445571) strcat(s, "r");
if (crc32("eHvZjReBchUm",12) == 2943859782) strcat(s, "a");
    return s;
}

char *patagium_nouns() {
    char *s = calloc(9);
    if (crc32("orWpSDJwK",9) == 2837214385) strcat(s, "D");
if (crc32("dOzeZcffHBEQRr",14) == 855201249) strcat(s, "p");
if (crc32("vGZcOCkbX",9) == 3661268475) strcat(s, "u");
if (crc32("HuFxWUWkIbaZp",13) == 2639035800) strcat(s, "a");
if (crc32("tWapAlo",7) == 2140057628) strcat(s, "O");
if (crc32("rGuOdtMMVKK",11) == 1203992369) strcat(s, "t");
if (crc32("JCMZKKyfLmpZl",13) == 1228746885) strcat(s, "Y");
if (crc32("aHnlZrFDQlhd",12) == 3476324168) strcat(s, "a");
if (crc32("wXiAGqxOKOOPH",13) == 113996418) strcat(s, "g");
if (crc32("danFyeQufbHwxF",14) == 425566671) strcat(s, "i");
if (crc32("PIKNMvvtyz",10) == 601009867) strcat(s, "S");
if (crc32("rUCSiAbsCwADHmZ",15) == 2901270199) strcat(s, "u");
if (crc32("LkidYC",6) == 2867200170) strcat(s, "m");
    return s;
}

char *Weser_nouns() {
    char *s = calloc(6);
    if (crc32("hQWUZZGnRpxlhw",14) == 1806616875) strcat(s, "G");
if (crc32("BYzVOXqE",8) == 880240794) strcat(s, "W");
if (crc32("MyOjUYWQeVkiYZd",15) == 4238603962) strcat(s, "e");
if (crc32("yawUcfjOgD",10) == 4102758380) strcat(s, "C");
if (crc32("OSGIMZwKXAEakOn",15) == 1929346831) strcat(s, "s");
if (crc32("irGxgYtWCCk",11) == 4049207267) strcat(s, "n");
if (crc32("LLeGNePhKtzb",12) == 906436498) strcat(s, "e");
if (crc32("euPLPnjinmCuxS",14) == 753221258) strcat(s, "Y");
if (crc32("gDCtQLWfp",9) == 1215074353) strcat(s, "r");
    return s;
}

char *Turino_nouns() {
    char *s = calloc(7);
    if (crc32("gxcwkksIQ",9) == 230909814) strcat(s, "E");
if (crc32("cszTgdBFtcNevrU",15) == 943047760) strcat(s, "T");
if (crc32("yyABVHAowg",10) == 3802809700) strcat(s, "u");
if (crc32("xefxFmDaAayVg",13) == 3299029787) strcat(s, "d");
if (crc32("PTnbwhGo",8) == 3834318010) strcat(s, "r");
if (crc32("RMmDMivDDbAQETf",15) == 959209580) strcat(s, "y");
if (crc32("FuSjygm",7) == 2297369193) strcat(s, "i");
if (crc32("NSFuvtNSSd",10) == 1725278930) strcat(s, "n");
if (crc32("LIehWaiduXYkJi",14) == 3849793903) strcat(s, "o");
    return s;
}

char *pewee_nouns() {
    char *s = calloc(6);
    if (crc32("zYMCgtgMKHMEBHN",15) == 77135779) strcat(s, "H");
if (crc32("otLeSHZIvY",10) == 2602899146) strcat(s, "p");
if (crc32("TGEkKwPpCPdMa",13) == 988004436) strcat(s, "e");
if (crc32("hidCEITscY",10) == 3035751559) strcat(s, "w");
if (crc32("pWQvnD",6) == 2580611132) strcat(s, "e");
if (crc32("FYVumRI",7) == 3171299926) strcat(s, "e");
    return s;
}

char *devolatilisation_nouns() {
    char *s = calloc(17);
    if (crc32("RrfgWHtnZWSPP",13) == 2018020204) strcat(s, "d");
if (crc32("fToXFkecBjvNb",13) == 1803891893) strcat(s, "e");
if (crc32("WOfjsLszvEiX",12) == 353915124) strcat(s, "v");
if (crc32("qGglq",5) == 2810308162) strcat(s, "o");
if (crc32("vJPxMcx",7) == 1120111396) strcat(s, "l");
if (crc32("oTdrFxPG",8) == 496691543) strcat(s, "a");
if (crc32("VnUhBwwyvD",10) == 3401596116) strcat(s, "t");
if (crc32("nScgPZIqYfbk",12) == 279576809) strcat(s, "i");
if (crc32("RnMLOSUr",8) == 4163963332) strcat(s, "d");
if (crc32("ipdYxzcW",8) == 2897923554) strcat(s, "l");
if (crc32("yzrzQvIoLSnUR",13) == 3627126264) strcat(s, "i");
if (crc32("qiyjTpMAAKR",11) == 1876482791) strcat(s, "m");
if (crc32("XKDGdg",6) == 3453504534) strcat(s, "s");
if (crc32("TfNIkrYKwx",10) == 3693645691) strcat(s, "m");
if (crc32("aUSgqHUrAldc",12) == 3572127214) strcat(s, "a");
if (crc32("DfUHnY",6) == 1491789733) strcat(s, "t");
if (crc32("YOMzAyMCCdG",11) == 1894582040) strcat(s, "G");
if (crc32("FtOTbKMM",8) == 19947589) strcat(s, "i");
if (crc32("rRqSkygCFGAAeOj",15) == 2457156139) strcat(s, "o");
if (crc32("JiAxjYPKbXyNb",13) == 1900422746) strcat(s, "n");
    return s;
}

char *unprivateness_nouns() {
    char *s = calloc(14);
    if (crc32("orJihVGltmDBu",13) == 760643969) strcat(s, "u");
if (crc32("LSJvQFPhYeo",11) == 4173200192) strcat(s, "n");
if (crc32("eQvfRxQBCmoKf",13) == 423787346) strcat(s, "K");
if (crc32("OxVerdtVvbB",11) == 3341396174) strcat(s, "p");
if (crc32("XNlKMr",6) == 187517072) strcat(s, "V");
if (crc32("IKalipQqvkUR",12) == 3487036293) strcat(s, "r");
if (crc32("ZxTIe",5) == 1843154931) strcat(s, "i");
if (crc32("OycoCgYVlWWAbW",14) == 1354184032) strcat(s, "v");
if (crc32("zauJeryNYliOr",13) == 2646521339) strcat(s, "b");
if (crc32("ColEfnYis",9) == 3364602815) strcat(s, "a");
if (crc32("yXSqtqBKnzaIwVH",15) == 2646977206) strcat(s, "t");
if (crc32("GfENHIvNw",9) == 392655959) strcat(s, "e");
if (crc32("PQNvFEsBLKRDdRC",15) == 331197338) strcat(s, "n");
if (crc32("cTpqXWw",7) == 2711208591) strcat(s, "I");
if (crc32("HPvezmSyOcAN",12) == 2154732586) strcat(s, "e");
if (crc32("xDjFZcgzXPSAsSg",15) == 147535083) strcat(s, "K");
if (crc32("Lfaxz",5) == 1531912257) strcat(s, "s");
if (crc32("IlguwP",6) == 2831545809) strcat(s, "s");
if (crc32("ZSOohG",6) == 2785332931) strcat(s, "s");
    return s;
}

char *damask_nouns() {
    char *s = calloc(7);
    if (crc32("FDWKcUNHEWVQdVL",15) == 937684485) strcat(s, "d");
if (crc32("heiMRPBpgac",11) == 3758818587) strcat(s, "a");
if (crc32("zbENcS",6) == 2465569734) strcat(s, "m");
if (crc32("ddBLkCQWyeTNnzA",15) == 2445604607) strcat(s, "U");
if (crc32("IsDpGPHkhyspCEj",15) == 420114659) strcat(s, "a");
if (crc32("EPjrkIOibBdIU",13) == 3257343043) strcat(s, "p");
if (crc32("KUcAdCu",7) == 3472666613) strcat(s, "s");
if (crc32("lBCRQMcuIXELbc",14) == 2275955735) strcat(s, "l");
if (crc32("PEvWuZgirUeth",13) == 3317621139) strcat(s, "k");
    return s;
}

char *solicitor_nouns() {
    char *s = calloc(10);
    if (crc32("mCHeMVYqIm",10) == 606187333) strcat(s, "e");
if (crc32("ldcEYNfm",8) == 1330223488) strcat(s, "s");
if (crc32("RPOle",5) == 3232374677) strcat(s, "o");
if (crc32("IGQqtFZGmdykmNj",15) == 997077650) strcat(s, "k");
if (crc32("jgZwMLXtc",9) == 3893278163) strcat(s, "l");
if (crc32("PUXAaWB",7) == 3977010919) strcat(s, "i");
if (crc32("tYzTubFSPUKh",12) == 1040881761) strcat(s, "c");
if (crc32("QlzVoyH",7) == 904085959) strcat(s, "N");
if (crc32("ewdXigb",7) == 4274551358) strcat(s, "i");
if (crc32("hfOJU",5) == 461155143) strcat(s, "t");
if (crc32("DtMxtNAOZCTN",12) == 613555296) strcat(s, "R");
if (crc32("YWxhkxyszvY",11) == 2868237670) strcat(s, "o");
if (crc32("UjEPPWXHvLu",11) == 768234949) strcat(s, "r");
    return s;
}

char *ophiologist_nouns() {
    char *s = calloc(12);
    if (crc32("CARWHVOejFu",11) == 4000713256) strcat(s, "o");
if (crc32("uBfCIIbXBtoSHg",14) == 3300964787) strcat(s, "N");
if (crc32("rQRexuoxYl",10) == 2047544031) strcat(s, "p");
if (crc32("CXgahgMljmkGLI",14) == 1949652848) strcat(s, "h");
if (crc32("ecJyVFKhSlh",11) == 605677991) strcat(s, "i");
if (crc32("tnlGNE",6) == 224756212) strcat(s, "u");
if (crc32("QesEwWa",7) == 3435033868) strcat(s, "o");
if (crc32("opjBmQ",6) == 1848788420) strcat(s, "x");
if (crc32("DvYYCNHm",8) == 2714340635) strcat(s, "l");
if (crc32("ruPbwHLhpRK",11) == 2800035663) strcat(s, "t");
if (crc32("aZZXCCppLHhX",12) == 1917964855) strcat(s, "o");
if (crc32("XoUdquGzSZyy",12) == 133232955) strcat(s, "C");
if (crc32("CeUkw",5) == 4153829405) strcat(s, "g");
if (crc32("acFWx",5) == 3801603134) strcat(s, "s");
if (crc32("XQzaOJNdYSpu",12) == 3429369004) strcat(s, "i");
if (crc32("tZHjxH",6) == 190559060) strcat(s, "f");
if (crc32("UtMalxPmYbcb",12) == 2491360304) strcat(s, "s");
if (crc32("jGWnjJiinszp",12) == 2612585214) strcat(s, "t");
    return s;
}

char *wellhead_nouns() {
    char *s = calloc(9);
    if (crc32("WkHUblTnzhicG",13) == 2916126249) strcat(s, "w");
if (crc32("VPeIB",5) == 1292443631) strcat(s, "e");
if (crc32("tKtqmmZzclIHzb",14) == 1498179598) strcat(s, "l");
if (crc32("EoMVAgBT",8) == 2930677283) strcat(s, "X");
if (crc32("mzpQKCmOHUgwPu",14) == 4056337754) strcat(s, "l");
if (crc32("ZiqkKpAMws",10) == 987902981) strcat(s, "h");
if (crc32("mrvKue",6) == 3685845901) strcat(s, "e");
if (crc32("jmxXqSqg",8) == 2045882053) strcat(s, "a");
if (crc32("vwvEC",5) == 1962919391) strcat(s, "d");
    return s;
}

char *ostium_nouns() {
    char *s = calloc(7);
    if (crc32("MulKw",5) == 2793503582) strcat(s, "o");
if (crc32("yrGOEBuQBjg",11) == 3976448839) strcat(s, "A");
if (crc32("AdkptJuGS",9) == 508114196) strcat(s, "s");
if (crc32("acMMztOiXTYaGwc",15) == 546300105) strcat(s, "b");
if (crc32("bWuNpU",6) == 1813393600) strcat(s, "t");
if (crc32("mYIdbvuE",8) == 2829455746) strcat(s, "g");
if (crc32("hIZQLhQRidn",11) == 1915319152) strcat(s, "i");
if (crc32("NKWRfKVEDhgloZ",14) == 2852593529) strcat(s, "G");
if (crc32("vMYdTwN",7) == 3137006585) strcat(s, "u");
if (crc32("JHviMwA",7) == 3074904074) strcat(s, "m");
    return s;
}

char *agileness_nouns() {
    char *s = calloc(10);
    if (crc32("fOOsEy",6) == 3904016662) strcat(s, "m");
if (crc32("oZRxs",5) == 941806049) strcat(s, "a");
if (crc32("xGmdofGyf",9) == 401599326) strcat(s, "k");
if (crc32("UiwZVCipfYzxafc",15) == 2426200324) strcat(s, "g");
if (crc32("cKjXUMgy",8) == 1538401407) strcat(s, "i");
if (crc32("BoyilCHxijaIMrT",15) == 4294106308) strcat(s, "e");
if (crc32("zZIqArs",7) == 1532779086) strcat(s, "l");
if (crc32("IvDdYBF",7) == 3056485320) strcat(s, "e");
if (crc32("pNshGhRtZcxtbw",14) == 1188810575) strcat(s, "n");
if (crc32("eJjug",5) == 2810675399) strcat(s, "e");
if (crc32("dSfIFSllA",9) == 2068543508) strcat(s, "s");
if (crc32("RBGbJFcJ",8) == 142444730) strcat(s, "s");
    return s;
}

char *heptahedron_nouns() {
    char *s = calloc(12);
    if (crc32("FepapnviiPN",11) == 212147215) strcat(s, "h");
if (crc32("wPgvaHW",7) == 3725973209) strcat(s, "q");
if (crc32("WOkyQVWubrLkUdt",15) == 1836052833) strcat(s, "e");
if (crc32("QsebBHJJZ",9) == 3187373683) strcat(s, "p");
if (crc32("AugLqQuByvv",11) == 71030186) strcat(s, "s");
if (crc32("HELQHfqRrwfZsmT",15) == 3792403292) strcat(s, "t");
if (crc32("xUHafRBL",8) == 3765647261) strcat(s, "a");
if (crc32("KKESpjeoxVyf",12) == 2690308736) strcat(s, "h");
if (crc32("yZhVIuuoB",9) == 1039069375) strcat(s, "e");
if (crc32("FboZPyBwdkmN",12) == 4293305341) strcat(s, "d");
if (crc32("zvaAHBMZmMeQMaA",15) == 3217691037) strcat(s, "r");
if (crc32("bhGiSI",6) == 753307963) strcat(s, "f");
if (crc32("azuUTt",6) == 2116097202) strcat(s, "o");
if (crc32("zGNhnDgFIBPH",12) == 2670146527) strcat(s, "Z");
if (crc32("DhalIBEl",8) == 3016658789) strcat(s, "n");
    return s;
}

char *rhodamine_nouns() {
    char *s = calloc(10);
    if (crc32("NMhhYHAOLB",10) == 1626840346) strcat(s, "x");
if (crc32("ptRWhzN",7) == 4157508673) strcat(s, "r");
if (crc32("mOyRfDCo",8) == 2571859507) strcat(s, "o");
if (crc32("JUDyZsJz",8) == 2228751354) strcat(s, "h");
if (crc32("FrZAcvsdJmQHU",13) == 577925035) strcat(s, "F");
if (crc32("OYDXhha",7) == 1982951660) strcat(s, "o");
if (crc32("tGKVCdKwe",9) == 2126241248) strcat(s, "d");
if (crc32("OYmAFOwsJOmDuTv",15) == 2610917745) strcat(s, "a");
if (crc32("joGEMU",6) == 3743584087) strcat(s, "c");
if (crc32("jkyIJxjgPSg",11) == 3333225870) strcat(s, "m");
if (crc32("XriFaXc",7) == 237862928) strcat(s, "i");
if (crc32("dAExUMhHVBm",11) == 3187017017) strcat(s, "n");
if (crc32("cROkbrC",7) == 2973053515) strcat(s, "Z");
if (crc32("sTYHcNdhZwLhJW",14) == 232777767) strcat(s, "e");
    return s;
}

char *salesgirl_nouns() {
    char *s = calloc(10);
    if (crc32("fDmuh",5) == 1495825103) strcat(s, "P");
if (crc32("pCKxIEWyZFFZCbE",15) == 3941141997) strcat(s, "s");
if (crc32("KJLgRZLyCxmm",12) == 3664294939) strcat(s, "f");
if (crc32("jgkyqPpdIv",10) == 2909653821) strcat(s, "a");
if (crc32("GJbRezDX",8) == 97891616) strcat(s, "l");
if (crc32("ouOMipxcaKNg",12) == 553674767) strcat(s, "W");
if (crc32("ImWbSY",6) == 1721730665) strcat(s, "e");
if (crc32("ZfxFXpK",7) == 2478630042) strcat(s, "z");
if (crc32("jwPKcAGvCBVgiB",14) == 4210105022) strcat(s, "s");
if (crc32("lyWwoojFUH",10) == 2147104457) strcat(s, "g");
if (crc32("eNtwcs",6) == 1184118030) strcat(s, "C");
if (crc32("zZNdvGwEHDffL",13) == 2943932053) strcat(s, "i");
if (crc32("ZWDbdQUyKf",10) == 2101551251) strcat(s, "E");
if (crc32("dwRsVDpUxgEqU",13) == 2228469656) strcat(s, "r");
if (crc32("puFxGH",6) == 2217385093) strcat(s, "E");
if (crc32("tqUprTRNnfLJTE",14) == 2448887340) strcat(s, "l");
    return s;
}

char *lily_nouns() {
    char *s = calloc(5);
    if (crc32("gBWYXG",6) == 3142779810) strcat(s, "e");
if (crc32("ruxOlgYOTNnA",12) == 618491943) strcat(s, "l");
if (crc32("eLUbKfgIQk",10) == 1050288717) strcat(s, "i");
if (crc32("Fyoqc",5) == 1704005175) strcat(s, "j");
if (crc32("kyKKZZYnPvVoR",13) == 314653047) strcat(s, "l");
if (crc32("nTHlmatSgv",10) == 3157360436) strcat(s, "y");
    return s;
}

char *Kast_nouns() {
    char *s = calloc(5);
    if (crc32("iIQMNjsPBtHn",12) == 1276843010) strcat(s, "K");
if (crc32("lBfks",5) == 3401416423) strcat(s, "l");
if (crc32("ywwmvAWXJNxtLs",14) == 3309560988) strcat(s, "a");
if (crc32("aptVTAQsT",9) == 126450864) strcat(s, "I");
if (crc32("QQvWBu",6) == 3068457931) strcat(s, "s");
if (crc32("dSXntiokMK",10) == 631924747) strcat(s, "V");
if (crc32("ZITdRn",6) == 1610758282) strcat(s, "t");
    return s;
}

char *Peiraeus_nouns() {
    char *s = calloc(9);
    if (crc32("NKTfzKZxwSzT",12) == 4149135331) strcat(s, "I");
if (crc32("ixeHQvjwG",9) == 3579326200) strcat(s, "P");
if (crc32("TYsXmBYEFmTquSC",15) == 2021260262) strcat(s, "e");
if (crc32("imAUaJIzd",9) == 4106331699) strcat(s, "v");
if (crc32("fcEndmCmG",9) == 1544581951) strcat(s, "i");
if (crc32("qDKqnqvrwXABM",13) == 2512859610) strcat(s, "U");
if (crc32("uiudJUSgzs",10) == 1320109045) strcat(s, "r");
if (crc32("dmIONM",6) == 3091783167) strcat(s, "a");
if (crc32("DIXQaGSLm",9) == 669601949) strcat(s, "e");
if (crc32("ArGWwaOTcRdgkG",14) == 3786349637) strcat(s, "u");
if (crc32("qQWJT",5) == 2118278386) strcat(s, "s");
    return s;
}

char *reunionism_nouns() {
    char *s = calloc(11);
    if (crc32("aFkZtbVL",8) == 1923991568) strcat(s, "r");
if (crc32("rjgcvoyZypNHpqf",15) == 2827479058) strcat(s, "e");
if (crc32("oDeCDKbUADQ",11) == 3183937985) strcat(s, "u");
if (crc32("vNiof",5) == 1621605477) strcat(s, "V");
if (crc32("FjixfpiQ",8) == 2711651127) strcat(s, "n");
if (crc32("fAGWhlzhWdwEj",13) == 771720069) strcat(s, "i");
if (crc32("LmPUIG",6) == 3229817806) strcat(s, "o");
if (crc32("NEuao",5) == 2130326958) strcat(s, "n");
if (crc32("RUnVpGJGCJlqxT",14) == 334770309) strcat(s, "i");
if (crc32("vtQfOmqPHoeZjq",14) == 1856713457) strcat(s, "o");
if (crc32("lkCgtVQ",7) == 2845749353) strcat(s, "s");
if (crc32("usQBbBLRVZm",11) == 1321574288) strcat(s, "m");
    return s;
}

char *Humble_nouns() {
    char *s = calloc(7);
    if (crc32("ZXARVP",6) == 3752747160) strcat(s, "H");
if (crc32("tKziKmG",7) == 461609919) strcat(s, "h");
if (crc32("AkuZur",6) == 1252874333) strcat(s, "u");
if (crc32("DiBjHo",6) == 3270630735) strcat(s, "y");
if (crc32("vfDUIdtrQAtR",12) == 822236081) strcat(s, "m");
if (crc32("ZnkbUhFW",8) == 314021303) strcat(s, "b");
if (crc32("oUZsPDcb",8) == 1603340366) strcat(s, "l");
if (crc32("pIZRPSUjQnkNpX",14) == 182841405) strcat(s, "e");
    return s;
}

char *slider_nouns() {
    char *s = calloc(7);
    if (crc32("HfbYOCack",9) == 751305110) strcat(s, "s");
if (crc32("FjEmRDBa",8) == 2587755665) strcat(s, "a");
if (crc32("HFqQDJkAmmqXj",13) == 177273526) strcat(s, "l");
if (crc32("mDgIrRPCb",9) == 1995886849) strcat(s, "i");
if (crc32("cENAX",5) == 1071277808) strcat(s, "l");
if (crc32("otdnLKHWdiAkACQ",15) == 3539482474) strcat(s, "d");
if (crc32("WeeuX",5) == 957201993) strcat(s, "e");
if (crc32("stGGufsnfLOoDT",14) == 2071871220) strcat(s, "r");
    return s;
}

char *mezzotinter_nouns() {
    char *s = calloc(12);
    if (crc32("GStSDpcsTBbOE",13) == 1190899485) strcat(s, "m");
if (crc32("jrlDyN",6) == 2602441189) strcat(s, "c");
if (crc32("RSHjvk",6) == 936568256) strcat(s, "e");
if (crc32("jURTBHhaaxOz",12) == 1625700941) strcat(s, "z");
if (crc32("DWffTAmcyC",10) == 4235428058) strcat(s, "z");
if (crc32("GivZAoIaaLK",11) == 3341391729) strcat(s, "o");
if (crc32("irUQo",5) == 2280421041) strcat(s, "t");
if (crc32("giLkokXMscwdu",13) == 560203257) strcat(s, "e");
if (crc32("hQIxzsXjiukL",12) == 4216822951) strcat(s, "i");
if (crc32("mwwIKPfpwO",10) == 3044714322) strcat(s, "n");
if (crc32("WKmWqp",6) == 3433275549) strcat(s, "i");
if (crc32("TdmUMTsGRjHt",12) == 4052930822) strcat(s, "t");
if (crc32("RVZtVwvLFlmai",13) == 964424565) strcat(s, "m");
if (crc32("IHUZmRkzl",9) == 1732802864) strcat(s, "e");
if (crc32("dxfjxwMlk",9) == 2367334915) strcat(s, "r");
    return s;
}

char *expresso_nouns() {
    char *s = calloc(9);
    if (crc32("QNJFkINaxvg",11) == 4129153911) strcat(s, "I");
if (crc32("jgzczkhXQKYsy",13) == 4127684626) strcat(s, "e");
if (crc32("LVAatCMpacDVbf",14) == 275715124) strcat(s, "v");
if (crc32("SDjPHtAugKcEPA",14) == 3893080237) strcat(s, "x");
if (crc32("UrkvmrFdZzs",11) == 270052025) strcat(s, "t");
if (crc32("mYNpZB",6) == 3340223137) strcat(s, "p");
if (crc32("bGjLZRfgJkAGVcB",15) == 2505498877) strcat(s, "r");
if (crc32("rNFVaRWFCQJSaNE",15) == 2968297976) strcat(s, "e");
if (crc32("XbYgObUB",8) == 677463612) strcat(s, "s");
if (crc32("wbJGzIbrho",10) == 4115841064) strcat(s, "s");
if (crc32("UuKRkW",6) == 2358772865) strcat(s, "o");
    return s;
}

char *strobotron_nouns() {
    char *s = calloc(11);
    if (crc32("TSGmkdFUIyqOG",13) == 779692218) strcat(s, "s");
if (crc32("vCaLeCB",7) == 1435164416) strcat(s, "b");
if (crc32("xsecsxvsRUTmMS",14) == 2511223535) strcat(s, "t");
if (crc32("ZnCxkYYG",8) == 1457189958) strcat(s, "J");
if (crc32("rGywT",5) == 346754357) strcat(s, "r");
if (crc32("vpGREoia",8) == 3526399000) strcat(s, "o");
if (crc32("xCVLIPNTOxWiuD",14) == 1199615467) strcat(s, "O");
if (crc32("xrSoqheRdQXcw",13) == 1732357703) strcat(s, "b");
if (crc32("ECJFBhmzH",9) == 2720506724) strcat(s, "X");
if (crc32("YuFQnJJ",7) == 169526125) strcat(s, "o");
if (crc32("iicbVBETytLBcZ",14) == 2556866585) strcat(s, "t");
if (crc32("uCmsDp",6) == 765840608) strcat(s, "o");
if (crc32("IaQLbiVok",9) == 2158569693) strcat(s, "r");
if (crc32("TaNCXqRWXBzgoP",14) == 2377974268) strcat(s, "G");
if (crc32("RZLYaZD",7) == 3620038737) strcat(s, "o");
if (crc32("kjNPcL",6) == 649987511) strcat(s, "n");
    return s;
}

char *Tatius_nouns() {
    char *s = calloc(7);
    if (crc32("ktYhRJL",7) == 1584249353) strcat(s, "f");
if (crc32("GawVqFfRSKBA",12) == 102058168) strcat(s, "T");
if (crc32("dQHkrGTnCsqeU",13) == 191131960) strcat(s, "a");
if (crc32("KbUiAlCl",8) == 950594767) strcat(s, "t");
if (crc32("VTVoDkznOvVopJL",15) == 1056840362) strcat(s, "m");
if (crc32("ovSFXNcNAjJ",11) == 262386207) strcat(s, "i");
if (crc32("TVBIh",5) == 1989837082) strcat(s, "A");
if (crc32("iztfMdDRtNhL",12) == 1427396419) strcat(s, "u");
if (crc32("eWHyHqFmOkFplR",14) == 3344299896) strcat(s, "s");
    return s;
}

char *hydronitrogen_nouns() {
    char *s = calloc(14);
    if (crc32("PdRoZ",5) == 1284926942) strcat(s, "h");
if (crc32("fBDPmQ",6) == 2501743328) strcat(s, "t");
if (crc32("qXsLOyIIJ",9) == 644211177) strcat(s, "y");
if (crc32("MVTvI",5) == 3882883091) strcat(s, "P");
if (crc32("fVAOWrKBA",9) == 2987759065) strcat(s, "d");
if (crc32("wOmidnyEqkpx",12) == 174920981) strcat(s, "r");
if (crc32("MthhmQn",7) == 913710921) strcat(s, "r");
if (crc32("xMCKfPAS",8) == 3578834040) strcat(s, "h");
if (crc32("GvrUsrx",7) == 2870608409) strcat(s, "o");
if (crc32("XMfpbtqGd",9) == 2684905578) strcat(s, "y");
if (crc32("RgOLBtKVvo",10) == 3690061773) strcat(s, "n");
if (crc32("NOGzHqPCovEyacX",15) == 224519600) strcat(s, "i");
if (crc32("YjsMXROofweA",12) == 332410309) strcat(s, "t");
if (crc32("rHcqwIUzr",9) == 340191462) strcat(s, "t");
if (crc32("MXYOvjeHmCRIwT",14) == 1555420397) strcat(s, "V");
if (crc32("JyIUhUhGZmpfh",13) == 215233515) strcat(s, "r");
if (crc32("YQZARfD",7) == 2430006028) strcat(s, "o");
if (crc32("fWBpENtOQJNdZx",14) == 351072806) strcat(s, "W");
if (crc32("GpbWjOkeYdVv",12) == 1861779801) strcat(s, "g");
if (crc32("MBWUgsGTXm",10) == 3509615236) strcat(s, "e");
if (crc32("ydUxblKlczrt",12) == 3949743871) strcat(s, "n");
    return s;
}

char *unfleshliness_nouns() {
    char *s = calloc(14);
    if (crc32("ELQpJkvuWGFpcPL",15) == 146772356) strcat(s, "u");
if (crc32("VDNyFmJTItNOot",14) == 4012978889) strcat(s, "n");
if (crc32("LENQxV",6) == 694277353) strcat(s, "r");
if (crc32("ZCSyNObilLdd",12) == 4033092342) strcat(s, "f");
if (crc32("qXWhVHTQxErPF",13) == 855017873) strcat(s, "n");
if (crc32("KliJyRjzBen",11) == 864074592) strcat(s, "l");
if (crc32("YYTKQpvOf",9) == 577977647) strcat(s, "k");
if (crc32("uDdQmOd",7) == 3586621242) strcat(s, "e");
if (crc32("xERGbUPPA",9) == 2732958463) strcat(s, "s");
if (crc32("miCLNJBXnMAPLQ",14) == 3028776300) strcat(s, "h");
if (crc32("BmptVEVwPZPkns",14) == 190539468) strcat(s, "h");
if (crc32("xSUIfhhnHIqUH",13) == 3249604801) strcat(s, "L");
if (crc32("olcmZYaMwy",10) == 3881689393) strcat(s, "l");
if (crc32("uiDcIgGcYksZUD",14) == 1683407499) strcat(s, "i");
if (crc32("WoyGUyhjsXutS",13) == 1977413755) strcat(s, "X");
if (crc32("ZjLOOd",6) == 1483685421) strcat(s, "n");
if (crc32("snYQQR",6) == 3888664450) strcat(s, "e");
if (crc32("KOgOE",5) == 381283678) strcat(s, "s");
if (crc32("DtfdkAK",7) == 2296566993) strcat(s, "m");
if (crc32("RbGrkDQ",7) == 2332338781) strcat(s, "s");
    return s;
}

char *Sanfred_nouns() {
    char *s = calloc(8);
    if (crc32("klMVFFHwiUhe",12) == 3466764583) strcat(s, "S");
if (crc32("LTYzhZRq",8) == 624940109) strcat(s, "f");
if (crc32("opCWYUvz",8) == 2528722029) strcat(s, "a");
if (crc32("masLdnCfcqXcn",13) == 4074647500) strcat(s, "n");
if (crc32("tyPYdF",6) == 3825024081) strcat(s, "f");
if (crc32("siJciChIFXE",11) == 3960622491) strcat(s, "r");
if (crc32("HiaxRVMJFyJd",12) == 1088980675) strcat(s, "e");
if (crc32("cVkNPaPnoKuHId",14) == 1954291624) strcat(s, "m");
if (crc32("qUQCEcSJqtpCe",13) == 3833484317) strcat(s, "d");
    return s;
}

char *Gardal_nouns() {
    char *s = calloc(7);
    if (crc32("SlPiA",5) == 2439527500) strcat(s, "j");
if (crc32("rnlTmh",6) == 1482028562) strcat(s, "G");
if (crc32("LgHACKS",7) == 3564502756) strcat(s, "E");
if (crc32("ZbhtdpIyE",9) == 1004307755) strcat(s, "a");
if (crc32("YdIUAZRMnYI",11) == 2840303112) strcat(s, "k");
if (crc32("tfWzjCKVrh",10) == 3906122117) strcat(s, "r");
if (crc32("nKJIlybRh",9) == 689588901) strcat(s, "y");
if (crc32("bBPcqfWm",8) == 2940518280) strcat(s, "d");
if (crc32("OHfBkw",6) == 1226502461) strcat(s, "p");
if (crc32("xZexjv",6) == 1417580696) strcat(s, "a");
if (crc32("TgZREDXZVUdJD",13) == 1190776616) strcat(s, "l");
    return s;
}

char *paigle_nouns() {
    char *s = calloc(7);
    if (crc32("IUXxwG",6) == 3053166363) strcat(s, "p");
if (crc32("HcmitVQl",8) == 854725777) strcat(s, "x");
if (crc32("BvYjryYaKf",10) == 1706517274) strcat(s, "a");
if (crc32("ePxeDJAwXwxohqX",15) == 3904383025) strcat(s, "i");
if (crc32("ViiPoPKN",8) == 1811405881) strcat(s, "p");
if (crc32("nHVZowokQVO",11) == 3666276299) strcat(s, "g");
if (crc32("aEcfIofvNEMWWL",14) == 3497212745) strcat(s, "l");
if (crc32("SWbLOtsvy",9) == 2434371304) strcat(s, "R");
if (crc32("lTDvBvFSAO",10) == 3456548529) strcat(s, "e");
    return s;
}

char *farcicality_nouns() {
    char *s = calloc(12);
    if (crc32("vjYzjhWZIxn",11) == 4152206473) strcat(s, "E");
if (crc32("ZuoqNtTbFegegV",14) == 3469017786) strcat(s, "f");
if (crc32("zRTljrF",7) == 4020726128) strcat(s, "a");
if (crc32("GkmkpGH",7) == 3501802) strcat(s, "e");
if (crc32("cIeFVsLR",8) == 69717309) strcat(s, "r");
if (crc32("GLblSepR",8) == 3788627748) strcat(s, "c");
if (crc32("BIlbOuMzLSUm",12) == 109115128) strcat(s, "Z");
if (crc32("NzQJaQoHUMBFCe",14) == 848218119) strcat(s, "i");
if (crc32("JqLoKmaz",8) == 3817254159) strcat(s, "H");
if (crc32("IpmriRgUc",9) == 1059727310) strcat(s, "c");
if (crc32("twJEsNqZJWiRHiy",15) == 3631721690) strcat(s, "a");
if (crc32("tSCdnlNtVf",10) == 2702113201) strcat(s, "H");
if (crc32("dchNXwhz",8) == 3393875034) strcat(s, "l");
if (crc32("FsLyNxtKDZqmCZ",14) == 1609174860) strcat(s, "i");
if (crc32("VskEokEvmYjkt",13) == 2017254467) strcat(s, "t");
if (crc32("JCUdYNnqf",9) == 1985690401) strcat(s, "y");
    return s;
}

char *septendecillion_nouns() {
    char *s = calloc(16);
    if (crc32("rbXYZYvHICeb",12) == 3694190949) strcat(s, "Y");
if (crc32("rTnmXrPSvYQhA",13) == 1128053700) strcat(s, "s");
if (crc32("wOAQKvDywjq",11) == 725162302) strcat(s, "N");
if (crc32("sPHOdRXtvUPMA",13) == 67100758) strcat(s, "e");
if (crc32("sfaSuLPctK",10) == 2878743107) strcat(s, "Z");
if (crc32("BaXPERIDT",9) == 1624738206) strcat(s, "p");
if (crc32("OjWdzlVsSrS",11) == 3523654668) strcat(s, "t");
if (crc32("gbquTDnxUg",10) == 2179849754) strcat(s, "X");
if (crc32("ZwhOWiT",7) == 3608239407) strcat(s, "e");
if (crc32("bzfeVyk",7) == 1956754904) strcat(s, "j");
if (crc32("dHiwwBm",7) == 3282500647) strcat(s, "n");
if (crc32("pyHwKoguLYQ",11) == 1619766403) strcat(s, "F");
if (crc32("YIPAcFgeJha",11) == 865556016) strcat(s, "d");
if (crc32("FhTukpZHDgB",11) == 925492204) strcat(s, "e");
if (crc32("DNrJHuS",7) == 1222621073) strcat(s, "q");
if (crc32("ODzYPUEjyLdTLl",14) == 3478205593) strcat(s, "c");
if (crc32("QxfRFbZQeUL",11) == 2585560623) strcat(s, "i");
if (crc32("mHRJiBTgc",9) == 762742806) strcat(s, "v");
if (crc32("yUVMlFLc",8) == 1358196210) strcat(s, "l");
if (crc32("DOMVjMNZbx",10) == 2643774540) strcat(s, "l");
if (crc32("xxvRn",5) == 3555767051) strcat(s, "i");
if (crc32("DCHKenCrjZwo",12) == 1724023556) strcat(s, "T");
if (crc32("nMwWwPhqgWIMGP",14) == 2534596682) strcat(s, "o");
if (crc32("ubNfw",5) == 3348797978) strcat(s, "p");
if (crc32("nZcisVPYU",9) == 1866141387) strcat(s, "n");
    return s;
}

char *loxodrome_nouns() {
    char *s = calloc(10);
    if (crc32("vWLsNAzbJpOe",12) == 3519971438) strcat(s, "l");
if (crc32("zNEPbYhqIvk",11) == 2832979784) strcat(s, "a");
if (crc32("tAclBSx",7) == 1383799198) strcat(s, "o");
if (crc32("dXbQVIfCKuB",11) == 1298605877) strcat(s, "U");
if (crc32("gOZqRYpQW",9) == 2682608782) strcat(s, "x");
if (crc32("BJTpKzqvRvynnz",14) == 650340889) strcat(s, "K");
if (crc32("TusTgrzRXY",10) == 2173213550) strcat(s, "o");
if (crc32("KOyxtsSjVYxs",12) == 827335031) strcat(s, "d");
if (crc32("SEVlowrpFCoGj",13) == 1131794174) strcat(s, "p");
if (crc32("qfVBeUe",7) == 999847798) strcat(s, "r");
if (crc32("GwjdGzgdbIU",11) == 3626460730) strcat(s, "o");
if (crc32("sFddQUlApv",10) == 3656676237) strcat(s, "m");
if (crc32("CsIwMgSZbal",11) == 1969800209) strcat(s, "e");
    return s;
}

char *marocain_nouns() {
    char *s = calloc(9);
    if (crc32("nNUBSguNox",10) == 1803792529) strcat(s, "u");
if (crc32("tYEfwdOxUZIUt",13) == 2180022000) strcat(s, "m");
if (crc32("fQvJUCBNMwG",11) == 1120243143) strcat(s, "n");
if (crc32("MoUTQnlOE",9) == 3372055746) strcat(s, "a");
if (crc32("VknznqFHc",9) == 1987937256) strcat(s, "r");
if (crc32("qqGtBlUfsH",10) == 3763167699) strcat(s, "V");
if (crc32("VCojAX",6) == 3734071025) strcat(s, "o");
if (crc32("SGRmzWiIFszQnO",14) == 1405685924) strcat(s, "M");
if (crc32("lOSRrrWIMLqTyq",14) == 1808586173) strcat(s, "c");
if (crc32("zqBUDJKa",8) == 919258915) strcat(s, "k");
if (crc32("vZFntiEdvuz",11) == 446753645) strcat(s, "a");
if (crc32("JVZASHCpa",9) == 991483438) strcat(s, "i");
if (crc32("SbHpzSxlcwPj",12) == 2201851847) strcat(s, "G");
if (crc32("yIjIcpC",7) == 1932424668) strcat(s, "n");
    return s;
}

char *hendiadys_nouns() {
    char *s = calloc(10);
    if (crc32("LrzhAtuti",9) == 652400140) strcat(s, "c");
if (crc32("cdHtAmcWfBzz",12) == 3881841142) strcat(s, "h");
if (crc32("myMePUzYKrcso",13) == 80567249) strcat(s, "o");
if (crc32("YoylNdakBWWKHU",14) == 1196634010) strcat(s, "e");
if (crc32("DAYUaFnjmMidvCc",15) == 3974026261) strcat(s, "C");
if (crc32("mLrCoJlhK",9) == 620760841) strcat(s, "n");
if (crc32("jGNMkNLtuu",10) == 4086980831) strcat(s, "d");
if (crc32("koijE",5) == 2502398089) strcat(s, "i");
if (crc32("RILoDrrcGqG",11) == 4025592388) strcat(s, "a");
if (crc32("UrXdvd",6) == 2984404077) strcat(s, "H");
if (crc32("lYCxvvnvwZem",12) == 1982426670) strcat(s, "d");
if (crc32("VMqDnLI",7) == 3794065068) strcat(s, "x");
if (crc32("VoePsZs",7) == 1643842226) strcat(s, "y");
if (crc32("LooKfeYmWAPing",14) == 2254769375) strcat(s, "s");
    return s;
}

char *coremaker_nouns() {
    char *s = calloc(10);
    if (crc32("lGjqnT",6) == 1704572009) strcat(s, "z");
if (crc32("bGfWeiGsBuE",11) == 755980228) strcat(s, "c");
if (crc32("NiMHuX",6) == 817747822) strcat(s, "o");
if (crc32("btJrIPHPmZiX",12) == 293442456) strcat(s, "r");
if (crc32("tZDfGERTc",9) == 3255085678) strcat(s, "e");
if (crc32("eRdhRssM",8) == 1216937680) strcat(s, "m");
if (crc32("HfgresvhDZTH",12) == 2994903328) strcat(s, "i");
if (crc32("lunMxotiWKA",11) == 283931773) strcat(s, "a");
if (crc32("dgOpJjtjaMN",11) == 4016027873) strcat(s, "M");
if (crc32("jjhZiWNYPBeFH",13) == 3023893187) strcat(s, "k");
if (crc32("AYNyETLSSSp",11) == 4143014422) strcat(s, "e");
if (crc32("jswjlucKmoakjy",14) == 584223309) strcat(s, "J");
if (crc32("yWuBpyWuxnivvPp",15) == 361243899) strcat(s, "r");
    return s;
}

char *CAT_nouns() {
    char *s = calloc(4);
    if (crc32("ZpjhwiWAgEh",11) == 3788247771) strcat(s, "C");
if (crc32("KRerCzWqRzlEokN",15) == 3154233056) strcat(s, "A");
if (crc32("mJubybZiqUmK",12) == 2737812071) strcat(s, "g");
if (crc32("rIoGdJWndPR",11) == 4279512914) strcat(s, "T");
    return s;
}

char *Horrebow_nouns() {
    char *s = calloc(9);
    if (crc32("WhnacVFVLBpol",13) == 1760951176) strcat(s, "U");
if (crc32("kUWZGTRjZiymL",13) == 185316216) strcat(s, "H");
if (crc32("YTsiWQB",7) == 384004081) strcat(s, "o");
if (crc32("xXmRReunqgNuas",14) == 2138106451) strcat(s, "e");
if (crc32("FWxjEOrJr",9) == 3523654271) strcat(s, "r");
if (crc32("gfaULnpuiFNLVRv",15) == 1123534611) strcat(s, "n");
if (crc32("AlUqFihBqECEaRC",15) == 3202591368) strcat(s, "r");
if (crc32("wzoRJFnyG",9) == 890349511) strcat(s, "E");
if (crc32("NicFLMEiO",9) == 2362588878) strcat(s, "e");
if (crc32("lcNHgjF",7) == 2873927884) strcat(s, "b");
if (crc32("HnmEXPU",7) == 1532683898) strcat(s, "I");
if (crc32("WXuTpnmz",8) == 4117937249) strcat(s, "o");
if (crc32("kKmZi",5) == 1356880428) strcat(s, "w");
    return s;
}

char *Aurum_nouns() {
    char *s = calloc(6);
    if (crc32("exGptufg",8) == 84958780) strcat(s, "q");
if (crc32("pkPfcqlgyh",10) == 3181081294) strcat(s, "A");
if (crc32("gAiYzpRWNG",10) == 524915640) strcat(s, "g");
if (crc32("jZBoEtVRvYh",11) == 2799567769) strcat(s, "u");
if (crc32("IyMUtPfe",8) == 4020996819) strcat(s, "r");
if (crc32("hqLgEbVR",8) == 4054230009) strcat(s, "u");
if (crc32("VacfDvOcikXV",12) == 3696563409) strcat(s, "m");
    return s;
}

char *Emmeram_nouns() {
    char *s = calloc(8);
    if (crc32("aVnMVkTDKzU",11) == 555962434) strcat(s, "E");
if (crc32("JhEjjt",6) == 156178664) strcat(s, "Q");
if (crc32("cRkRUyXfxMp",11) == 3535483698) strcat(s, "m");
if (crc32("PgawXOGnhkgi",12) == 3983317534) strcat(s, "D");
if (crc32("BncQxBE",7) == 1329467694) strcat(s, "m");
if (crc32("JvdkdvjsNvc",11) == 412208596) strcat(s, "g");
if (crc32("ncizM",5) == 1393048098) strcat(s, "e");
if (crc32("HXiNn",5) == 602807715) strcat(s, "r");
if (crc32("EdjYBUHeKgFaf",13) == 4003749630) strcat(s, "f");
if (crc32("UgtNcAynYcDAjNp",15) == 3433306347) strcat(s, "a");
if (crc32("QnTmrltUqdk",11) == 682468247) strcat(s, "u");
if (crc32("SUZQjYcNe",9) == 2354271477) strcat(s, "m");
    return s;
}

char *Mahmoud_nouns() {
    char *s = calloc(8);
    if (crc32("FdfQDtdBcUQGKCu",15) == 842422170) strcat(s, "M");
if (crc32("xTZvDNWsefSXiwW",15) == 2924676385) strcat(s, "a");
if (crc32("jpKKOVR",7) == 3371988871) strcat(s, "h");
if (crc32("uLEaepjvqVUksJ",14) == 4114869697) strcat(s, "m");
if (crc32("JpxTOWZ",7) == 4141568429) strcat(s, "F");
if (crc32("lONAmypg",8) == 1851884772) strcat(s, "o");
if (crc32("MOvrdONLsl",10) == 2478223261) strcat(s, "u");
if (crc32("KmaNfYJ",7) == 1093067562) strcat(s, "v");
if (crc32("QJMtotqbwmULfSC",15) == 1774686581) strcat(s, "d");
    return s;
}

char *Tanhya_nouns() {
    char *s = calloc(7);
    if (crc32("duFtHhCCcWQreM",14) == 1796214437) strcat(s, "X");
if (crc32("nYphxIdrbxez",12) == 1970370864) strcat(s, "T");
if (crc32("FyttNTnTs",9) == 2251587414) strcat(s, "a");
if (crc32("TUwMKFYbiJDV",12) == 2234896796) strcat(s, "S");
if (crc32("aVKWFxdxzUv",11) == 1756131217) strcat(s, "n");
if (crc32("qVRZgLNIysptrD",14) == 1708963327) strcat(s, "h");
if (crc32("rfFfvihTH",9) == 10789172) strcat(s, "F");
if (crc32("CBcRDXELsCY",11) == 1116969110) strcat(s, "y");
if (crc32("DYJGEzGYXYxo",12) == 4032095884) strcat(s, "f");
if (crc32("fqYfOrxXDzjaTme",15) == 1063814032) strcat(s, "a");
    return s;
}

char *antihunting_nouns() {
    char *s = calloc(12);
    if (crc32("TyDAxHrqy",9) == 3512918017) strcat(s, "a");
if (crc32("IBJQB",5) == 3384504085) strcat(s, "I");
if (crc32("cMefLnmqoDrf",12) == 1495217108) strcat(s, "n");
if (crc32("KGPEnNjAVBK",11) == 1361097893) strcat(s, "H");
if (crc32("EzvGqNpscukci",13) == 218413473) strcat(s, "t");
if (crc32("VZTnAz",6) == 1176634778) strcat(s, "i");
if (crc32("vfEPrWPbSBc",11) == 3682888807) strcat(s, "h");
if (crc32("WEbFpzPwiLqGwP",14) == 2998929514) strcat(s, "f");
if (crc32("fLCRrk",6) == 3550238213) strcat(s, "u");
if (crc32("iSiTAiQLBDKe",12) == 3828156415) strcat(s, "n");
if (crc32("SkQGWicl",8) == 20168443) strcat(s, "t");
if (crc32("dYaOBl",6) == 1773345594) strcat(s, "i");
if (crc32("AFJoHHQ",7) == 2371000168) strcat(s, "n");
if (crc32("TUcvQUcCfTkTQ",13) == 3483857497) strcat(s, "g");
    return s;
}

char *tusche_nouns() {
    char *s = calloc(7);
    if (crc32("ZDbFlH",6) == 3855832904) strcat(s, "t");
if (crc32("MGVADJaLQT",10) == 1594143657) strcat(s, "b");
if (crc32("INEGuvz",7) == 1962074012) strcat(s, "u");
if (crc32("nSoIxWe",7) == 3820276519) strcat(s, "h");
if (crc32("LDXgUrTpSBxqdNf",15) == 3091831942) strcat(s, "s");
if (crc32("OwGYgZNJFzC",11) == 1516892582) strcat(s, "l");
if (crc32("tKkUj",5) == 2823580600) strcat(s, "c");
if (crc32("xRaxagcWPR",10) == 3917272699) strcat(s, "a");
if (crc32("snudyWsUrOSJfpy",15) == 1160475019) strcat(s, "h");
if (crc32("cPJQVcrEODoWe",13) == 3694465489) strcat(s, "e");
    return s;
}

char *Mareld_nouns() {
    char *s = calloc(7);
    if (crc32("mioatfcwhagXCE",14) == 51918667) strcat(s, "b");
if (crc32("BTXzqeL",7) == 3889538307) strcat(s, "M");
if (crc32("mbpBWk",6) == 3521188731) strcat(s, "a");
if (crc32("czaqVLms",8) == 2804738591) strcat(s, "A");
if (crc32("jMXEntCfPm",10) == 3901588199) strcat(s, "r");
if (crc32("dJltRJCxi",9) == 2488290828) strcat(s, "e");
if (crc32("OIidmviVMwVGNJ",14) == 437085297) strcat(s, "l");
if (crc32("ltqTxDzwn",9) == 2933958974) strcat(s, "H");
if (crc32("PHfVLSJYfVIXSnA",15) == 619318252) strcat(s, "d");
    return s;
}

char *foundation_nouns() {
    char *s = calloc(11);
    if (crc32("mjLMThbEZP",10) == 2804731251) strcat(s, "f");
if (crc32("iPPbq",5) == 470972316) strcat(s, "u");
if (crc32("VivmGarPreBVG",13) == 134753032) strcat(s, "o");
if (crc32("aUCeEpCgeBom",12) == 1253327647) strcat(s, "N");
if (crc32("QMQTlzNpeLcDKqm",15) == 3996004458) strcat(s, "u");
if (crc32("DKGyJoYlHClAVm",14) == 1976556976) strcat(s, "S");
if (crc32("ksURDvLFhViNJ",13) == 1252539728) strcat(s, "n");
if (crc32("RQmlbohCDctOdR",14) == 1591777634) strcat(s, "d");
if (crc32("mtjKGJhpHUJNr",13) == 3341015458) strcat(s, "a");
if (crc32("XwFzjRMUV",9) == 2339695147) strcat(s, "a");
if (crc32("hAuXCeHSSJAv",12) == 2368876101) strcat(s, "t");
if (crc32("FeLomwjCLFLs",12) == 1717314636) strcat(s, "i");
if (crc32("uMIQSMuKLhGlE",13) == 109198062) strcat(s, "o");
if (crc32("IEvJJjkxbRKXKa",14) == 1183072544) strcat(s, "v");
if (crc32("aTNsCYDjzH",10) == 1403519249) strcat(s, "n");
    return s;
}

char *luncheonette_nouns() {
    char *s = calloc(13);
    if (crc32("mYFpkK",6) == 3173143896) strcat(s, "l");
if (crc32("QiHZWnM",7) == 49308517) strcat(s, "u");
if (crc32("bJXdJWnArSns",12) == 3035360025) strcat(s, "u");
if (crc32("mlInDLV",7) == 796284582) strcat(s, "n");
if (crc32("lZWjbSfTGgguF",13) == 3224984125) strcat(s, "c");
if (crc32("GiAXQUfTKZja",12) == 3749947872) strcat(s, "h");
if (crc32("LBQRlzt",7) == 2190036564) strcat(s, "o");
if (crc32("PDMFVHDZT",9) == 2002987921) strcat(s, "e");
if (crc32("zZgnurpz",8) == 2023694146) strcat(s, "o");
if (crc32("uJSVohB",7) == 1246352597) strcat(s, "M");
if (crc32("bJaJxv",6) == 1185607837) strcat(s, "n");
if (crc32("KnpVwMrIRFZnp",13) == 4089612102) strcat(s, "j");
if (crc32("NatIBCnrQNTfG",13) == 3552302099) strcat(s, "e");
if (crc32("QArhBbpqh",9) == 1810313969) strcat(s, "t");
if (crc32("LEMcVyHLmky",11) == 2219434534) strcat(s, "t");
if (crc32("SpssTaNBkFlHyWV",15) == 51959351) strcat(s, "e");
    return s;
}

char *idolater_nouns() {
    char *s = calloc(9);
    if (crc32("zBNuwUqekwiwO",13) == 2246738516) strcat(s, "i");
if (crc32("xqgvYPchqhzBYfm",15) == 1013209040) strcat(s, "B");
if (crc32("AkhqUCkNrLZvo",13) == 1905569968) strcat(s, "d");
if (crc32("oiVuWf",6) == 825621547) strcat(s, "o");
if (crc32("IhFwG",5) == 57404993) strcat(s, "b");
if (crc32("sYimkrPBiY",10) == 4202304753) strcat(s, "l");
if (crc32("XeJGlYXHzlylR",13) == 1914545857) strcat(s, "a");
if (crc32("IABvNcbemeUn",12) == 2686382963) strcat(s, "t");
if (crc32("ixKXWX",6) == 3861922863) strcat(s, "X");
if (crc32("lstPoPJhDFxfg",13) == 1152988147) strcat(s, "e");
if (crc32("ezmVrpRehqVrQ",13) == 1887216831) strcat(s, "r");
    return s;
}

char *Allys_nouns() {
    char *s = calloc(6);
    if (crc32("BAapmJEFqUgmiR",14) == 2458391442) strcat(s, "A");
if (crc32("jcHPOIANmx",10) == 3989135296) strcat(s, "V");
if (crc32("ANasjFsLw",9) == 443003289) strcat(s, "l");
if (crc32("NiLKNxwLtbOhDqy",15) == 771902269) strcat(s, "l");
if (crc32("uFtuBwljVWt",11) == 2397997908) strcat(s, "v");
if (crc32("oaUcaxZWE",9) == 513884798) strcat(s, "y");
if (crc32("sJgOk",5) == 1748360118) strcat(s, "H");
if (crc32("skTSJALXIAuAyVd",15) == 2150126256) strcat(s, "s");
    return s;
}

char *Togolese_nouns() {
    char *s = calloc(9);
    if (crc32("pYxbv",5) == 1035645758) strcat(s, "T");
if (crc32("PbNnwB",6) == 2677050320) strcat(s, "o");
if (crc32("MgdtzFsYmxhMWQ",14) == 123744204) strcat(s, "j");
if (crc32("XbgvPhwEVnS",11) == 1873987983) strcat(s, "g");
if (crc32("mxoSBmzTWWu",11) == 1639938997) strcat(s, "o");
if (crc32("YcRXW",5) == 854059935) strcat(s, "l");
if (crc32("KpebnSiHO",9) == 3964917044) strcat(s, "e");
if (crc32("bDiluYJqlI",10) == 1063920984) strcat(s, "s");
if (crc32("dJfwuyKGRcbLdvh",15) == 2496395405) strcat(s, "S");
if (crc32("npXnlMLfQcsdBkg",15) == 948313467) strcat(s, "e");
    return s;
}

char *pattern_nouns() {
    char *s = calloc(8);
    if (crc32("PxlkvqdMUquukZ",14) == 3196392799) strcat(s, "p");
if (crc32("ktIHBe",6) == 3241258021) strcat(s, "u");
if (crc32("XDHqiB",6) == 3675412311) strcat(s, "a");
if (crc32("LmPDeqFsdOn",11) == 1773493169) strcat(s, "t");
if (crc32("bWtqQXs",7) == 4082001230) strcat(s, "z");
if (crc32("HbVRGpfiNS",10) == 355296369) strcat(s, "t");
if (crc32("aeYjMFDixy",10) == 418758953) strcat(s, "v");
if (crc32("vTsbX",5) == 2417196141) strcat(s, "e");
if (crc32("nJKugqjr",8) == 3777406293) strcat(s, "k");
if (crc32("dSUpDtwpy",9) == 1486289931) strcat(s, "r");
if (crc32("rZnUTMkDUuCz",12) == 2193712028) strcat(s, "X");
if (crc32("ivxvXLmZzzxi",12) == 4082355353) strcat(s, "n");
    return s;
}

char *ephebus_nouns() {
    char *s = calloc(8);
    if (crc32("kfudFlt",7) == 3930734100) strcat(s, "w");
if (crc32("omcbhUUIGNQuNae",15) == 3766034599) strcat(s, "e");
if (crc32("JDjKiuzapxCjRH",14) == 1470229984) strcat(s, "d");
if (crc32("xtyvJl",6) == 1379408136) strcat(s, "p");
if (crc32("bycInZjEHV",10) == 1028689543) strcat(s, "h");
if (crc32("MFRalR",6) == 2130007900) strcat(s, "C");
if (crc32("eSghoEXsRM",10) == 1286858968) strcat(s, "e");
if (crc32("KZgGlRYoRC",10) == 2518486495) strcat(s, "b");
if (crc32("JgmtIutYRBHob",13) == 1496836739) strcat(s, "u");
if (crc32("XLaSknDilM",10) == 2851544352) strcat(s, "s");
    return s;
}

char *pseudoclassicism_nouns() {
    char *s = calloc(17);
    if (crc32("aybeNn",6) == 2641094517) strcat(s, "p");
if (crc32("LYtqp",5) == 1240944259) strcat(s, "S");
if (crc32("DnZDgCnxz",9) == 79092695) strcat(s, "s");
if (crc32("fZYlSAuv",8) == 3230539230) strcat(s, "e");
if (crc32("uQIRSqrgs",9) == 1301408512) strcat(s, "u");
if (crc32("NIXKkfrEK",9) == 2029271399) strcat(s, "d");
if (crc32("BahCuyE",7) == 130183573) strcat(s, "o");
if (crc32("tXBhxlMNP",9) == 1060587834) strcat(s, "c");
if (crc32("xWqWQsq",7) == 3123675597) strcat(s, "A");
if (crc32("TmlrRQVbLDyg",12) == 3935854124) strcat(s, "l");
if (crc32("aVUuedkYBfWPCu",14) == 4052735728) strcat(s, "E");
if (crc32("zvPYiwzgWPlZ",12) == 3683259146) strcat(s, "a");
if (crc32("qQYDV",5) == 72432986) strcat(s, "s");
if (crc32("TXWWtQmbtAevTr",14) == 2953248668) strcat(s, "d");
if (crc32("TrrySHBtyJBTRia",15) == 1609472958) strcat(s, "s");
if (crc32("DpFBwBvlLAj",11) == 1826061236) strcat(s, "i");
if (crc32("HnWhfHwHOat",11) == 2084351379) strcat(s, "r");
if (crc32("nWkTtv",6) == 2091401927) strcat(s, "c");
if (crc32("GKkKAFAxy",9) == 2695425506) strcat(s, "i");
if (crc32("IMcQu",5) == 870437146) strcat(s, "s");
if (crc32("pNaQfHhxF",9) == 3917370628) strcat(s, "C");
if (crc32("voKKXwQsrKP",11) == 549141860) strcat(s, "m");
    return s;
}

char *delation_nouns() {
    char *s = calloc(9);
    if (crc32("LhaXtFPyZb",10) == 899224764) strcat(s, "H");
if (crc32("vZkCln",6) == 3819156346) strcat(s, "d");
if (crc32("exGUQjSPcoTRTj",14) == 3726773496) strcat(s, "e");
if (crc32("GdyaDfSgJKtFNzz",15) == 520050516) strcat(s, "z");
if (crc32("uYpxaNNwUNOibMy",15) == 2909068263) strcat(s, "l");
if (crc32("kvyLWdsstQYbT",13) == 2679022662) strcat(s, "U");
if (crc32("EoRjuPRYTGsPXvN",15) == 1173335387) strcat(s, "a");
if (crc32("aorsxISgt",9) == 12810631) strcat(s, "a");
if (crc32("ypYQUeEaEgySb",13) == 1774704309) strcat(s, "t");
if (crc32("PYrVTNXhEYLLx",13) == 265878691) strcat(s, "i");
if (crc32("CYOGRaHSby",10) == 2461757385) strcat(s, "o");
if (crc32("GdWzTzeNxault",13) == 1651153856) strcat(s, "C");
if (crc32("yERyA",5) == 238326987) strcat(s, "n");
    return s;
}

char *cementation_nouns() {
    char *s = calloc(12);
    if (crc32("rGyoCuQhOyNGKA",14) == 3383668578) strcat(s, "w");
if (crc32("KPIaIBT",7) == 3499446897) strcat(s, "c");
if (crc32("YMkWglFoSp",10) == 2549160841) strcat(s, "e");
if (crc32("bGqkHLrHQeDIf",13) == 1266536085) strcat(s, "m");
if (crc32("jXIHXUcKtlGxQRz",15) == 284455427) strcat(s, "e");
if (crc32("etlSdAQanlwGvfE",15) == 4009466530) strcat(s, "n");
if (crc32("kClOi",5) == 2737045216) strcat(s, "t");
if (crc32("RhkUaI",6) == 1356119777) strcat(s, "T");
if (crc32("ssDBTKwQ",8) == 1748350072) strcat(s, "a");
if (crc32("rbeRK",5) == 1898736679) strcat(s, "T");
if (crc32("pkpekLwQx",9) == 3164237635) strcat(s, "t");
if (crc32("KMzcjnO",7) == 2852786962) strcat(s, "i");
if (crc32("DxVvbGFYsAUd",12) == 1501198619) strcat(s, "G");
if (crc32("SGNGURLimhTt",12) == 3066059014) strcat(s, "o");
if (crc32("CkrzEiNsNz",10) == 1240321780) strcat(s, "R");
if (crc32("NMwjvY",6) == 4236883892) strcat(s, "n");
    return s;
}

char *androsphinx_nouns() {
    char *s = calloc(12);
    if (crc32("vNnTgG",6) == 2851002243) strcat(s, "z");
if (crc32("FAJPgnzAyZKWCUS",15) == 2228769218) strcat(s, "a");
if (crc32("JXtRlS",6) == 3059587989) strcat(s, "i");
if (crc32("ykjYWfb",7) == 448818875) strcat(s, "n");
if (crc32("UNONnkJfI",9) == 439829617) strcat(s, "D");
if (crc32("iDlgJWFrbCHgiq",14) == 192369124) strcat(s, "d");
if (crc32("uUwrKyytnG",10) == 3508125321) strcat(s, "r");
if (crc32("HPsQnihmtUsCkm",14) == 1219035016) strcat(s, "o");
if (crc32("XgTZTPlMMSItUIU",15) == 1470476844) strcat(s, "s");
if (crc32("SLeKIZGstIHGLq",14) == 111018873) strcat(s, "p");
if (crc32("qzItXdz",7) == 530214460) strcat(s, "h");
if (crc32("bTILYoinYIXg",12) == 118952283) strcat(s, "U");
if (crc32("Yumkzo",6) == 778203529) strcat(s, "i");
if (crc32("iqQtIYf",7) == 113734681) strcat(s, "I");
if (crc32("CuCjOZfSiRMDc",13) == 1355739247) strcat(s, "n");
if (crc32("UfVvuIxELQkeHBI",15) == 2931008287) strcat(s, "x");
    return s;
}

char *estocada_nouns() {
    char *s = calloc(9);
    if (crc32("rpVrBEveHGcZvo",14) == 1303728543) strcat(s, "e");
if (crc32("OaresWrhoDeFrg",14) == 1598499263) strcat(s, "T");
if (crc32("UWtEEHr",7) == 2909295895) strcat(s, "s");
if (crc32("ATPyEmJZYnhqpbK",15) == 911219304) strcat(s, "Y");
if (crc32("HmkaO",5) == 3119180141) strcat(s, "t");
if (crc32("qMYoHIXkL",9) == 1307123130) strcat(s, "r");
if (crc32("QyIgzSVGJ",9) == 3750215428) strcat(s, "o");
if (crc32("OwoRBXXolYFv",12) == 529987291) strcat(s, "c");
if (crc32("vAnsMFVASRbqZl",14) == 3154700902) strcat(s, "O");
if (crc32("MXBXCxK",7) == 13841734) strcat(s, "a");
if (crc32("ojfamYcFwQdt",12) == 2306951032) strcat(s, "F");
if (crc32("mxJxbrgoglwI",12) == 616742106) strcat(s, "d");
if (crc32("rPduyBKOx",9) == 3077870031) strcat(s, "e");
if (crc32("FIewoQUeR",9) == 766583524) strcat(s, "a");
    return s;
}

char *Heer_nouns() {
    char *s = calloc(5);
    if (crc32("cldyqjSTFEV",11) == 741366914) strcat(s, "U");
if (crc32("BHpODsecQoxMWUJ",15) == 3906473540) strcat(s, "H");
if (crc32("UAlAfXTrN",9) == 1291483539) strcat(s, "e");
if (crc32("pYwMi",5) == 2851258779) strcat(s, "e");
if (crc32("ctsSBaaBrRJUsXD",15) == 711738584) strcat(s, "r");
    return s;
}

char *widdy_nouns() {
    char *s = calloc(6);
    if (crc32("uxkgTzxKlUddg",13) == 3087999021) strcat(s, "U");
if (crc32("BCmevYiKcBFrW",13) == 4163436856) strcat(s, "w");
if (crc32("kXfFPn",6) == 2709099158) strcat(s, "i");
if (crc32("QvvjqngeKm",10) == 2038989738) strcat(s, "d");
if (crc32("SmknHgraelCsvuD",15) == 1963563440) strcat(s, "d");
if (crc32("WXesIiFofGQFLa",14) == 1660210076) strcat(s, "y");
if (crc32("GBhyCHqEHZhbLM",14) == 2515075607) strcat(s, "d");
if (crc32("vxHroEqIoH",10) == 1773074005) strcat(s, "B");
if (crc32("UhDtyJtzl",9) == 1064497984) strcat(s, "y");
    return s;
}

char *noniridescence_nouns() {
    char *s = calloc(15);
    if (crc32("GrHDSNW",7) == 3553677972) strcat(s, "n");
if (crc32("yJXGlERHnp",10) == 4275492965) strcat(s, "o");
if (crc32("PPMPFz",6) == 2523838574) strcat(s, "n");
if (crc32("ezzIZimPCPHm",12) == 4244390897) strcat(s, "i");
if (crc32("kPjrSZCvDEOD",12) == 2233390548) strcat(s, "r");
if (crc32("qhrtUYdQDcQnYc",14) == 1855962179) strcat(s, "S");
if (crc32("rBMTCkcl",8) == 3781270376) strcat(s, "i");
if (crc32("kLQyFYWkjqMmLBn",15) == 985028190) strcat(s, "d");
if (crc32("HEmEcytmNnPsP",13) == 4084420241) strcat(s, "u");
if (crc32("vVkWbllkzJ",10) == 489926420) strcat(s, "e");
if (crc32("hiSiLwySWK",10) == 3005800430) strcat(s, "U");
if (crc32("jGuuVULlUPSx",12) == 1967967391) strcat(s, "s");
if (crc32("lMUBrlYZh",9) == 2827832514) strcat(s, "L");
if (crc32("jbxcY",5) == 2181713829) strcat(s, "c");
if (crc32("EXmUQZPNWWN",11) == 2235869246) strcat(s, "T");
if (crc32("UydUJ",5) == 1056783059) strcat(s, "e");
if (crc32("FzWbgFnInKvkaC",14) == 106391940) strcat(s, "H");
if (crc32("rUiINJIGLS",10) == 766645649) strcat(s, "n");
if (crc32("RbcgObNOcSETFIS",15) == 2813425908) strcat(s, "u");
if (crc32("qOTFgTEHgOx",11) == 2295092194) strcat(s, "c");
if (crc32("alYvxn",6) == 2235370619) strcat(s, "e");
    return s;
}

char *CamborneRedruth_nouns() {
    char *s = calloc(16);
    if (crc32("UZyuMXiegfAVS",13) == 3978286898) strcat(s, "C");
if (crc32("klJajdXvZmUQ",12) == 769211566) strcat(s, "a");
if (crc32("rUiKhixaSR",10) == 1952597484) strcat(s, "c");
if (crc32("ATfCACcMs",9) == 3042843990) strcat(s, "m");
if (crc32("QNKQdiogghBeD",13) == 4157458278) strcat(s, "P");
if (crc32("zXeWdoHpb",9) == 817855929) strcat(s, "b");
if (crc32("oSlHdQqli",9) == 2792441364) strcat(s, "o");
if (crc32("ZYtAOhpz",8) == 4176843018) strcat(s, "r");
if (crc32("VSooIYAjdcm",11) == 3668520660) strcat(s, "n");
if (crc32("KHWbezymQoBs",12) == 2531458548) strcat(s, "y");
if (crc32("FcIfarKLKJRH",12) == 2127822748) strcat(s, "e");
if (crc32("AoWkSBI",7) == 4241679346) strcat(s, "Z");
if (crc32("WJjbXqohvqdSxz",14) == 3065666042) strcat(s, "R");
if (crc32("IqwhFKBy",8) == 2410437914) strcat(s, "e");
if (crc32("JjouWVbF",8) == 1745433368) strcat(s, "E");
if (crc32("xevzxlU",7) == 3764990580) strcat(s, "d");
if (crc32("uhkqGCztLPF",11) == 2614473835) strcat(s, "r");
if (crc32("jYkpSLuny",9) == 3176980369) strcat(s, "z");
if (crc32("yGwpUuBHoKbCTKq",15) == 1591337227) strcat(s, "u");
if (crc32("TDVMeRRouMO",11) == 2838944466) strcat(s, "z");
if (crc32("TKAmDktGlLFtSNb",15) == 1846420247) strcat(s, "t");
if (crc32("QayfnizQg",9) == 1895865548) strcat(s, "h");
    return s;
}

char *bullshit_nouns() {
    char *s = calloc(9);
    if (crc32("HxxIaKSS",8) == 2593795903) strcat(s, "X");
if (crc32("zpXhquC",7) == 3221854658) strcat(s, "b");
if (crc32("uTDyqEClOFeQjnM",15) == 3449539491) strcat(s, "U");
if (crc32("JAyWZYcZcqLjv",13) == 360451295) strcat(s, "u");
if (crc32("RcMGNQHvKvtCA",13) == 4161804436) strcat(s, "C");
if (crc32("cQgQrhGVqOggw",13) == 470433202) strcat(s, "l");
if (crc32("VKeHtSMyuN",10) == 4208615093) strcat(s, "l");
if (crc32("POabqjobm",9) == 4132543760) strcat(s, "J");
if (crc32("QDOolKkMRUWN",12) == 973394777) strcat(s, "s");
if (crc32("fmDWdekj",8) == 789891770) strcat(s, "p");
if (crc32("IHQHV",5) == 448252092) strcat(s, "h");
if (crc32("uWxCkvBDPXVsXF",14) == 2260858227) strcat(s, "i");
if (crc32("HNbDNB",6) == 4197586188) strcat(s, "Y");
if (crc32("aVZoDsoeNotzfc",14) == 2253065014) strcat(s, "t");
    return s;
}

char *heliography_nouns() {
    char *s = calloc(12);
    if (crc32("jUBDW",5) == 2438255532) strcat(s, "x");
if (crc32("aYKWR",5) == 3626332322) strcat(s, "h");
if (crc32("KuAxjVvjJL",10) == 1702904657) strcat(s, "e");
if (crc32("DURPo",5) == 2668375367) strcat(s, "l");
if (crc32("uhgKXOkCGT",10) == 2164764494) strcat(s, "a");
if (crc32("rcXkNhSZeqS",11) == 316154578) strcat(s, "i");
if (crc32("PeLqmjmmpFcsA",13) == 3080200050) strcat(s, "T");
if (crc32("MakfsxXnMpkYYaz",15) == 2304155730) strcat(s, "o");
if (crc32("JwPoDLEKX",9) == 1053727092) strcat(s, "d");
if (crc32("ynLPPFYEUJwEbI",14) == 4076106812) strcat(s, "g");
if (crc32("FmHvratwS",9) == 300737004) strcat(s, "Y");
if (crc32("UblUmOIBeLjDcd",14) == 440703410) strcat(s, "r");
if (crc32("nGmckHlKMUby",12) == 3545877048) strcat(s, "a");
if (crc32("tOJZyycyIFDs",12) == 143810823) strcat(s, "p");
if (crc32("WgyivEgCYWD",11) == 601542048) strcat(s, "L");
if (crc32("VHOSwhKHxxvFM",13) == 741859811) strcat(s, "h");
if (crc32("RrbpxgdTo",9) == 1619286127) strcat(s, "y");
    return s;
}

char *reclamation_nouns() {
    char *s = calloc(12);
    if (crc32("RIbpYCOBmQf",11) == 1686026834) strcat(s, "r");
if (crc32("QimThQwiph",10) == 3850656107) strcat(s, "e");
if (crc32("fHWXfCZ",7) == 238750088) strcat(s, "c");
if (crc32("gOMTc",5) == 3579385511) strcat(s, "S");
if (crc32("uymFcYZV",8) == 320432325) strcat(s, "l");
if (crc32("rgZxFVFfDGsTyHM",15) == 2207834071) strcat(s, "a");
if (crc32("sfxNim",6) == 2852724481) strcat(s, "E");
if (crc32("HGGff",5) == 1254168344) strcat(s, "m");
if (crc32("kIYGtrDUNwVFWC",14) == 1976882033) strcat(s, "a");
if (crc32("buIzK",5) == 725893189) strcat(s, "o");
if (crc32("zTvpiuRvhZ",10) == 2720243394) strcat(s, "t");
if (crc32("UobWozcUIRCqvQ",14) == 604338206) strcat(s, "p");
if (crc32("jZQrifo",7) == 1918249327) strcat(s, "i");
if (crc32("XaeyEraOSosnsA",14) == 3735652000) strcat(s, "k");
if (crc32("eUzPfMBkcQV",11) == 3676277500) strcat(s, "o");
if (crc32("JJoSFmXDi",9) == 1042787205) strcat(s, "n");
    return s;
}

char *enterogastrone_nouns() {
    char *s = calloc(15);
    if (crc32("mVCFLyWBrLwkcbV",15) == 2721597840) strcat(s, "j");
if (crc32("mZJrqAQGtP",10) == 1626636896) strcat(s, "e");
if (crc32("iNHgZudIFQJa",12) == 2984880627) strcat(s, "m");
if (crc32("KCrSZIhjKRR",11) == 3448973067) strcat(s, "n");
if (crc32("ttxSMYaXigLdiDg",15) == 3027848704) strcat(s, "t");
if (crc32("XnXDpvrE",8) == 1618897366) strcat(s, "N");
if (crc32("kBjIXcoR",8) == 3834840148) strcat(s, "e");
if (crc32("WGgMCV",6) == 3447006363) strcat(s, "r");
if (crc32("xLgsfKixV",9) == 3932959990) strcat(s, "z");
if (crc32("KLUgmHaonufRlX",14) == 3684118307) strcat(s, "o");
if (crc32("csHPECE",7) == 2730036401) strcat(s, "g");
if (crc32("OBXoxC",6) == 2876457432) strcat(s, "A");
if (crc32("DKblnkZfsD",10) == 3079736511) strcat(s, "a");
if (crc32("WbLkPgXN",8) == 3573784061) strcat(s, "s");
if (crc32("wpHtHETG",8) == 3726125663) strcat(s, "t");
if (crc32("wUlpCQGohceIBDr",15) == 2832181484) strcat(s, "U");
if (crc32("fBrARxxCPYG",11) == 2391680091) strcat(s, "r");
if (crc32("zbLWufZzcnvapP",14) == 3140508110) strcat(s, "o");
if (crc32("qCFFYeGDXtV",11) == 3065867528) strcat(s, "f");
if (crc32("nuwntXM",7) == 2767643302) strcat(s, "n");
if (crc32("ojRhP",5) == 548162147) strcat(s, "e");
    return s;
}

char *Panama_nouns() {
    char *s = calloc(7);
    if (crc32("CjgvZDHuI",9) == 3399028921) strcat(s, "K");
if (crc32("PZLMtp",6) == 2100906726) strcat(s, "P");
if (crc32("iCLxKXxSgA",10) == 238607289) strcat(s, "a");
if (crc32("TySWdqanKxQ",11) == 1360002998) strcat(s, "c");
if (crc32("GXJusAKgk",9) == 1885644416) strcat(s, "n");
if (crc32("EAaqBYxbXDJ",11) == 1445566552) strcat(s, "a");
if (crc32("mHVThWlZzj",10) == 3172792510) strcat(s, "y");
if (crc32("HuDfQpRNp",9) == 915486950) strcat(s, "m");
if (crc32("rdxTIyfzg",9) == 1328231269) strcat(s, "z");
if (crc32("vAOOFUCHwmOpaRO",15) == 2158776574) strcat(s, "a");
    return s;
}

char *cloudiness_nouns() {
    char *s = calloc(11);
    if (crc32("saqSbPx",7) == 4105878803) strcat(s, "f");
if (crc32("cbtMnDOxaJYXia",14) == 2644072593) strcat(s, "c");
if (crc32("kZYUagay",8) == 3504428419) strcat(s, "v");
if (crc32("pMMTmrkYB",9) == 21784468) strcat(s, "l");
if (crc32("YTlkDu",6) == 888323820) strcat(s, "a");
if (crc32("cCGsAppyU",9) == 2538505896) strcat(s, "o");
if (crc32("IcDrVaPe",8) == 3731198696) strcat(s, "u");
if (crc32("OMuHAzD",7) == 2214832991) strcat(s, "k");
if (crc32("hlyoKPpxMS",10) == 2397599203) strcat(s, "d");
if (crc32("OTeFKu",6) == 42670162) strcat(s, "S");
if (crc32("hNNYKODAI",9) == 2142581641) strcat(s, "i");
if (crc32("sMEPMkkiyGQZCy",14) == 3802491039) strcat(s, "R");
if (crc32("rdXUkDL",7) == 783518673) strcat(s, "n");
if (crc32("KDaRxneDzIkDn",13) == 2170627137) strcat(s, "s");
if (crc32("mRmWB",5) == 3953340564) strcat(s, "e");
if (crc32("FnAtckw",7) == 192844975) strcat(s, "s");
if (crc32("zgzsEmTnvybkSIZ",15) == 2374590964) strcat(s, "s");
    return s;
}

char *Guaymas_nouns() {
    char *s = calloc(8);
    if (crc32("LUimwnI",7) == 2989369080) strcat(s, "v");
if (crc32("LEKxW",5) == 2580398034) strcat(s, "G");
if (crc32("HTncCoAJHEStEWx",15) == 935800408) strcat(s, "u");
if (crc32("UMbzzfEUxZklWRD",15) == 2087633072) strcat(s, "X");
if (crc32("AbSjms",6) == 328435601) strcat(s, "a");
if (crc32("sBiUVP",6) == 3046386193) strcat(s, "y");
if (crc32("AGuzA",5) == 3465643133) strcat(s, "p");
if (crc32("nnsOP",5) == 1910794806) strcat(s, "m");
if (crc32("unFONRK",7) == 377597022) strcat(s, "a");
if (crc32("FPswL",5) == 1101604291) strcat(s, "A");
if (crc32("IZNDlPFQwPrw",12) == 2128392577) strcat(s, "s");
    return s;
}

char *torques_nouns() {
    char *s = calloc(8);
    if (crc32("xJGQYVdzdHhqV",13) == 415725484) strcat(s, "d");
if (crc32("dzREROOiNXgwZD",14) == 452738963) strcat(s, "t");
if (crc32("gkyofWsUYVfgfjK",15) == 3138761213) strcat(s, "p");
if (crc32("TtzJfRgbn",9) == 3227115722) strcat(s, "o");
if (crc32("NowKzkrnCqe",11) == 4070303149) strcat(s, "b");
if (crc32("XMRUKimUe",9) == 2785342530) strcat(s, "r");
if (crc32("TRutJsTANEd",11) == 1193221363) strcat(s, "z");
if (crc32("hTiaEpdQe",9) == 668136060) strcat(s, "q");
if (crc32("XfrUv",5) == 4191361774) strcat(s, "u");
if (crc32("bylJunRwBb",10) == 3342083617) strcat(s, "F");
if (crc32("iZSizwIy",8) == 1850064540) strcat(s, "e");
if (crc32("RugXVbk",7) == 2594220653) strcat(s, "w");
if (crc32("sIHpAhotLqSZFpE",15) == 1470598442) strcat(s, "s");
    return s;
}

char *bracket_nouns() {
    char *s = calloc(8);
    if (crc32("rUUmYkWWaQuAD",13) == 3216851409) strcat(s, "W");
if (crc32("cZvQYWkwrmJ",11) == 3092338011) strcat(s, "b");
if (crc32("XQEfTIkgD",9) == 870973934) strcat(s, "e");
if (crc32("heneeJ",6) == 533817918) strcat(s, "r");
if (crc32("tqqSDWUoaNDrV",13) == 3296740706) strcat(s, "a");
if (crc32("YbZoBTbwioAjTY",14) == 3016278712) strcat(s, "c");
if (crc32("BrFYbLY",7) == 1821117490) strcat(s, "k");
if (crc32("vanIwpw",7) == 818543721) strcat(s, "s");
if (crc32("sVaHaKmFNdEq",12) == 1156106894) strcat(s, "e");
if (crc32("OfOzjkuKedL",11) == 3460341534) strcat(s, "t");
    return s;
}

char *plasmalogen_nouns() {
    char *s = calloc(12);
    if (crc32("RLQmpcmR",8) == 3403013335) strcat(s, "a");
if (crc32("WgPtomYaDFzogP",14) == 1035054257) strcat(s, "p");
if (crc32("HgINf",5) == 1306389520) strcat(s, "O");
if (crc32("cDBMEHRZXvF",11) == 3761438429) strcat(s, "l");
if (crc32("JjqiiPHbxOfF",12) == 3309039139) strcat(s, "L");
if (crc32("LZthRwVvqlZA",12) == 2382129694) strcat(s, "a");
if (crc32("WrdmlcpZvP",10) == 1971289400) strcat(s, "C");
if (crc32("unIRQNkpru",10) == 1081271851) strcat(s, "s");
if (crc32("pRWvgkAtEdOKyGW",15) == 3908665366) strcat(s, "j");
if (crc32("umsBYQXy",8) == 1152779157) strcat(s, "m");
if (crc32("IuTYlPFJSj",10) == 3835042322) strcat(s, "a");
if (crc32("QVPIfHBfh",9) == 1357481747) strcat(s, "l");
if (crc32("sHehvmYsXfD",11) == 1919526387) strcat(s, "D");
if (crc32("lSIrHDAME",9) == 1581429017) strcat(s, "o");
if (crc32("DwLggOnQnjCcDY",14) == 3566362963) strcat(s, "g");
if (crc32("XghJEDu",7) == 3921596715) strcat(s, "j");
if (crc32("sOsnzlNI",8) == 2059342794) strcat(s, "e");
if (crc32("bAXWfKAdrCebYUN",15) == 3200713064) strcat(s, "n");
    return s;
}

char *brewery_nouns() {
    char *s = calloc(8);
    if (crc32("duqSYRhtmVii",12) == 54689367) strcat(s, "q");
if (crc32("UIaROCQXMmIKu",13) == 2086676313) strcat(s, "b");
if (crc32("bjfpbnMmRP",10) == 2215830358) strcat(s, "O");
if (crc32("WQpWfTGMGLgIs",13) == 737711086) strcat(s, "r");
if (crc32("TkLEOU",6) == 3576308873) strcat(s, "x");
if (crc32("voObbwR",7) == 246593367) strcat(s, "e");
if (crc32("lGFEnnexeE",10) == 934920400) strcat(s, "w");
if (crc32("MgVjLyxDMnDs",12) == 3932156365) strcat(s, "e");
if (crc32("ctCwNneD",8) == 2838245824) strcat(s, "n");
if (crc32("XSeTPSVOy",9) == 1830391185) strcat(s, "r");
if (crc32("OyWUcV",6) == 306433696) strcat(s, "j");
if (crc32("TLaiAcWvFnQDgDx",15) == 210621710) strcat(s, "y");
    return s;
}

char *pinard_nouns() {
    char *s = calloc(7);
    if (crc32("dcjhPqqDNJmmn",13) == 2352228492) strcat(s, "o");
if (crc32("eJTEnlbOJjwOPo",14) == 72903254) strcat(s, "p");
if (crc32("AUhVow",6) == 2581949649) strcat(s, "E");
if (crc32("lhBXZ",5) == 4004545701) strcat(s, "i");
if (crc32("CUrmxYJCrC",10) == 202230188) strcat(s, "n");
if (crc32("laSKZKOTVtQuHY",14) == 3604881628) strcat(s, "M");
if (crc32("aIJazZs",7) == 3642584027) strcat(s, "a");
if (crc32("TvNbkzeuwIQHhQ",14) == 181024951) strcat(s, "F");
if (crc32("BoNvtDjPWtGNON",14) == 244521680) strcat(s, "r");
if (crc32("DtNuqxX",7) == 1703739903) strcat(s, "N");
if (crc32("vWPRDihn",8) == 4083979822) strcat(s, "d");
    return s;
}

char *bumph_nouns() {
    char *s = calloc(6);
    if (crc32("fbTEVqokdXJvh",13) == 2391437439) strcat(s, "b");
if (crc32("lbAAev",6) == 3726301675) strcat(s, "u");
if (crc32("doQArvRUl",9) == 1570843348) strcat(s, "u");
if (crc32("nlKPZSP",7) == 1177269528) strcat(s, "m");
if (crc32("CIfEelDXcaaI",12) == 3918239095) strcat(s, "e");
if (crc32("THlNNroWDBxxyoi",15) == 1587583975) strcat(s, "p");
if (crc32("sCFVyLRRIZIEi",13) == 2129127560) strcat(s, "V");
if (crc32("zYQWES",6) == 1263978818) strcat(s, "h");
    return s;
}

char *footstep_nouns() {
    char *s = calloc(9);
    if (crc32("TxsGm",5) == 2142635083) strcat(s, "f");
if (crc32("xGRaNOWooZAXNlt",15) == 1270966945) strcat(s, "o");
if (crc32("kJoKGlkcvsfv",12) == 3811923500) strcat(s, "A");
if (crc32("PgGnpLJRQpKyt",13) == 4275243067) strcat(s, "o");
if (crc32("DKzJkr",6) == 3333831610) strcat(s, "U");
if (crc32("vFhNRDAVukoM",12) == 2084885919) strcat(s, "t");
if (crc32("hDRTnkoWdPagPJi",15) == 2161526454) strcat(s, "s");
if (crc32("HAUFnBqua",9) == 3830046499) strcat(s, "t");
if (crc32("jGKKxhSsIl",10) == 163869027) strcat(s, "e");
if (crc32("SKRSD",5) == 3117916167) strcat(s, "I");
if (crc32("eCNRNey",7) == 12456783) strcat(s, "p");
    return s;
}

char *Calise_nouns() {
    char *s = calloc(7);
    if (crc32("KjGkZYAsbtiJ",12) == 2903684820) strcat(s, "Z");
if (crc32("CZRxpYhjZhvjDE",14) == 3532115514) strcat(s, "C");
if (crc32("aSaxQedGvVCtQj",14) == 2801989152) strcat(s, "Z");
if (crc32("NZJHfjKJWe",10) == 3207166835) strcat(s, "a");
if (crc32("KwqyakKbzODdcmB",15) == 2267573811) strcat(s, "z");
if (crc32("xFNZZbmM",8) == 1298166070) strcat(s, "l");
if (crc32("EgYaOnpl",8) == 1731094033) strcat(s, "r");
if (crc32("RMkmElbRmiWprYc",15) == 2637922062) strcat(s, "i");
if (crc32("xUPvOFvyXj",10) == 126048545) strcat(s, "s");
if (crc32("nzeIMOokd",9) == 1386787973) strcat(s, "e");
    return s;
}

char *testimony_nouns() {
    char *s = calloc(10);
    if (crc32("zOuWigfKMJom",12) == 1119185505) strcat(s, "J");
if (crc32("INYUnVsSdTxL",12) == 536439889) strcat(s, "t");
if (crc32("tWAUqSBk",8) == 988531727) strcat(s, "e");
if (crc32("bBCelHVv",8) == 4113051558) strcat(s, "D");
if (crc32("FAror",5) == 958578410) strcat(s, "s");
if (crc32("llWDbMbYxmYg",12) == 644705312) strcat(s, "f");
if (crc32("frhDpcmaz",9) == 1475154432) strcat(s, "t");
if (crc32("AdLCqblaaZCQrbw",15) == 1059656417) strcat(s, "i");
if (crc32("MIcmnIY",7) == 4135340310) strcat(s, "m");
if (crc32("EEuIoh",6) == 107774684) strcat(s, "T");
if (crc32("mWpeFIiVYFRmgvf",15) == 1778659689) strcat(s, "o");
if (crc32("ocyMDBYnNJ",10) == 2602803064) strcat(s, "T");
if (crc32("ygfcFxqcQEwrNyR",15) == 2357676289) strcat(s, "n");
if (crc32("ePqhMJbnkEVq",12) == 254877866) strcat(s, "Q");
if (crc32("agPNNJEVZanvY",13) == 3260877675) strcat(s, "y");
    return s;
}

char *unspeakableness_nouns() {
    char *s = calloc(16);
    if (crc32("qlTKSNIcGycfS",13) == 412700388) strcat(s, "J");
if (crc32("YkwQUMP",7) == 899306620) strcat(s, "u");
if (crc32("wDeqjh",6) == 2136545344) strcat(s, "o");
if (crc32("PJLoRiT",7) == 1497231875) strcat(s, "n");
if (crc32("RerHaIylDw",10) == 1254818320) strcat(s, "s");
if (crc32("iDbNLaihfdC",11) == 25947273) strcat(s, "G");
if (crc32("iHbnGlEiDbUPx",13) == 3252296310) strcat(s, "p");
if (crc32("ehsRKgSEM",9) == 3638608688) strcat(s, "I");
if (crc32("KkFKSlMAkF",10) == 626045050) strcat(s, "e");
if (crc32("ScejTSQjIMHRV",13) == 4280213044) strcat(s, "z");
if (crc32("CvvJHiirsIpS",12) == 158841423) strcat(s, "a");
if (crc32("pahZnXZYb",9) == 2666724643) strcat(s, "k");
if (crc32("mtTvxruhU",9) == 2236998457) strcat(s, "a");
if (crc32("FybLGXCCxxY",11) == 196183539) strcat(s, "b");
if (crc32("SaqChSLgt",9) == 4156269698) strcat(s, "I");
if (crc32("YGixww",6) == 3259233802) strcat(s, "l");
if (crc32("PJZNZXxsBczfdF",14) == 2892852153) strcat(s, "e");
if (crc32("rFBQicZrlzU",11) == 2604808220) strcat(s, "n");
if (crc32("zjXIjZlCRFnB",12) == 259368282) strcat(s, "e");
if (crc32("oGRsmnAsHJO",11) == 4232849978) strcat(s, "s");
if (crc32("PkFZIGcrxWRjUr",14) == 2546714688) strcat(s, "s");
    return s;
}

char *matamata_nouns() {
    char *s = calloc(9);
    if (crc32("XgVDBUHQD",9) == 1394150344) strcat(s, "m");
if (crc32("iNACrrGffNt",11) == 316530042) strcat(s, "a");
if (crc32("WMMQWaLP",8) == 2176846135) strcat(s, "t");
if (crc32("ntRPSMyVCVLwM",13) == 4281190536) strcat(s, "a");
if (crc32("vKglOiIlt",9) == 3067408144) strcat(s, "M");
if (crc32("DcFOVSyEO",9) == 3160422334) strcat(s, "m");
if (crc32("QoPElbUumO",10) == 3143221618) strcat(s, "Y");
if (crc32("zeiojA",6) == 3519394182) strcat(s, "a");
if (crc32("vBhvGDGKEW",10) == 3643560408) strcat(s, "t");
if (crc32("ZuFkOyjZpiZg",12) == 1768079295) strcat(s, "y");
if (crc32("OEMzqa",6) == 3814111804) strcat(s, "a");
    return s;
}

char *slipsheet_nouns() {
    char *s = calloc(10);
    if (crc32("LPUfnvd",7) == 2365898235) strcat(s, "s");
if (crc32("SElflWdktMLo",12) == 710154488) strcat(s, "T");
if (crc32("QpMAHqn",7) == 1921010572) strcat(s, "l");
if (crc32("IHMJL",5) == 3221132033) strcat(s, "T");
if (crc32("FwBPNHkMTWEqtBr",15) == 2652532425) strcat(s, "i");
if (crc32("iKWIlCWgk",9) == 1801766561) strcat(s, "q");
if (crc32("THUpGBvGzE",10) == 521712457) strcat(s, "p");
if (crc32("wkBekHlBIBC",11) == 2727477952) strcat(s, "p");
if (crc32("ZnFcPFrkK",9) == 3685813784) strcat(s, "s");
if (crc32("skbvHday",8) == 3114494571) strcat(s, "h");
if (crc32("aIRrPDDtlsk",11) == 1499016042) strcat(s, "w");
if (crc32("CtYCAiszZNV",11) == 1489116759) strcat(s, "e");
if (crc32("kDqvRtQRgWC",11) == 1512414881) strcat(s, "x");
if (crc32("GBdxNHHzsHnT",12) == 2845599385) strcat(s, "e");
if (crc32("oZuZYPseylBCG",13) == 441849950) strcat(s, "t");
    return s;
}

char *Tarrant_nouns() {
    char *s = calloc(8);
    if (crc32("lhgZbfZGu",9) == 3214409487) strcat(s, "T");
if (crc32("xRlZJlrC",8) == 2591980183) strcat(s, "f");
if (crc32("HmZxXwhK",8) == 44141476) strcat(s, "a");
if (crc32("FtselZKLeHCZR",13) == 3998060963) strcat(s, "U");
if (crc32("DjaaUrXqSxMSTZ",14) == 3276710045) strcat(s, "r");
if (crc32("sGDCjLIoIeXibH",14) == 1363000919) strcat(s, "r");
if (crc32("EYrmCXQKRLGqsQE",15) == 367370862) strcat(s, "f");
if (crc32("GWZvHyvYvHFP",12) == 3577833952) strcat(s, "a");
if (crc32("oyukDpSnePZf",12) == 2566572167) strcat(s, "o");
if (crc32("bvHdB",5) == 2353954327) strcat(s, "n");
if (crc32("lQAjzqOLsMXTVg",14) == 3095002368) strcat(s, "t");
    return s;
}

char *Osiris_nouns() {
    char *s = calloc(7);
    if (crc32("sKoHTbRu",8) == 923728704) strcat(s, "O");
if (crc32("tMqktccBqH",10) == 2150752969) strcat(s, "s");
if (crc32("ryLYvblUPeY",11) == 3108936428) strcat(s, "i");
if (crc32("ogyNzNiCowzp",12) == 3939649245) strcat(s, "r");
if (crc32("eXWfAoy",7) == 2326123685) strcat(s, "i");
if (crc32("Ccqme",5) == 1213861683) strcat(s, "s");
    return s;
}

char *Timothee_nouns() {
    char *s = calloc(9);
    if (crc32("FNwgHMFuer",10) == 3283796871) strcat(s, "X");
if (crc32("BWDHAuBwl",9) == 1960289824) strcat(s, "T");
if (crc32("AWtjlZQWOUjGglD",15) == 1580139259) strcat(s, "i");
if (crc32("HtWPuxVHdXVll",13) == 3336439049) strcat(s, "m");
if (crc32("KWiVJ",5) == 2184514477) strcat(s, "o");
if (crc32("HFMHQbpaghO",11) == 4244922201) strcat(s, "t");
if (crc32("oufbdoNks",9) == 2466469722) strcat(s, "K");
if (crc32("DObHtlub",8) == 57484159) strcat(s, "h");
if (crc32("UBZqcnFkKT",10) == 4013862577) strcat(s, "e");
if (crc32("BaIMYIXaRpKptbT",15) == 3791209950) strcat(s, "u");
if (crc32("PKNmmWxQYb",10) == 3846613980) strcat(s, "e");
    return s;
}

char *Dyche_nouns() {
    char *s = calloc(6);
    if (crc32("cWyDJiUiunQunXv",15) == 2052564151) strcat(s, "D");
if (crc32("aUhCSbre",8) == 2794497644) strcat(s, "o");
if (crc32("bgcujP",6) == 1346143264) strcat(s, "y");
if (crc32("mtZnTrjrPErvjX",14) == 3879523892) strcat(s, "c");
if (crc32("TCWbangsJDrEP",13) == 927712735) strcat(s, "g");
if (crc32("dQpvuiuTdThlhf",14) == 2581416219) strcat(s, "h");
if (crc32("pzqTArYAPdXc",12) == 3417519592) strcat(s, "I");
if (crc32("REEZWepMVVdFoY",14) == 471339875) strcat(s, "e");
    return s;
}

char *controller_nouns() {
    char *s = calloc(11);
    if (crc32("XvwuC",5) == 1815506715) strcat(s, "c");
if (crc32("QDroo",5) == 4060546334) strcat(s, "f");
if (crc32("sBuwxDwg",8) == 4005837634) strcat(s, "o");
if (crc32("XyrsKr",6) == 2681901383) strcat(s, "n");
if (crc32("UCyiPNhMBNN",11) == 2597470024) strcat(s, "R");
if (crc32("SowjdjHcRDs",11) == 3665369261) strcat(s, "t");
if (crc32("isiSzKVcI",9) == 3772910300) strcat(s, "R");
if (crc32("mzYnIff",7) == 3681767285) strcat(s, "r");
if (crc32("oIsgV",5) == 3311394718) strcat(s, "o");
if (crc32("tUrXNsNwMXrbLfi",15) == 2557789174) strcat(s, "l");
if (crc32("emNFbAqEpNjW",12) == 470887918) strcat(s, "t");
if (crc32("JlyQTZj",7) == 64252901) strcat(s, "l");
if (crc32("ooBwL",5) == 3524217840) strcat(s, "e");
if (crc32("wAMIMY",6) == 4057922248) strcat(s, "x");
if (crc32("wrshAkCdPOdMU",13) == 3991972397) strcat(s, "r");
    return s;
}

char *fibreboard_nouns() {
    char *s = calloc(11);
    if (crc32("EsLRG",5) == 3322968026) strcat(s, "n");
if (crc32("HfXZYZ",6) == 3421403539) strcat(s, "f");
if (crc32("sWwjlDuZymqSG",13) == 1143155099) strcat(s, "i");
if (crc32("jvDGu",5) == 3352385959) strcat(s, "P");
if (crc32("QZvhr",5) == 615652349) strcat(s, "b");
if (crc32("CSWZybyAUJdUK",13) == 2769934675) strcat(s, "r");
if (crc32("odoRVt",6) == 2468782045) strcat(s, "e");
if (crc32("DrIBCoAxC",9) == 494701162) strcat(s, "b");
if (crc32("zKvYLlABv",9) == 3049839866) strcat(s, "o");
if (crc32("ixQktL",6) == 1418832240) strcat(s, "a");
if (crc32("fHgkbUPcqq",10) == 752062927) strcat(s, "r");
if (crc32("NThuKS",6) == 71581795) strcat(s, "d");
    return s;
}

char *waterleaf_nouns() {
    char *s = calloc(10);
    if (crc32("aBrQFHBvGcN",11) == 3700566625) strcat(s, "v");
if (crc32("yEezJcLMIh",10) == 381903217) strcat(s, "w");
if (crc32("krvchrCfM",9) == 970128285) strcat(s, "M");
if (crc32("pGEyepCOInGlEPg",15) == 1268791584) strcat(s, "a");
if (crc32("CXIztzOfJ",9) == 709326263) strcat(s, "t");
if (crc32("TdGObF",6) == 4280188214) strcat(s, "e");
if (crc32("JjjBgWr",7) == 758749621) strcat(s, "B");
if (crc32("kpniLw",6) == 611396348) strcat(s, "r");
if (crc32("BsouYBNDhy",10) == 2254929235) strcat(s, "l");
if (crc32("okEYQpJaK",9) == 2018006348) strcat(s, "C");
if (crc32("TsyXSQXO",8) == 1833394038) strcat(s, "e");
if (crc32("UIKfkWpKiLtRWi",14) == 1927592772) strcat(s, "P");
if (crc32("TntotNWi",8) == 3151708104) strcat(s, "a");
if (crc32("NGFGSRSoilOWQp",14) == 964847362) strcat(s, "f");
    return s;
}

char *tamandua_nouns() {
    char *s = calloc(9);
    if (crc32("tPJcobMyTIhyXNc",15) == 2227222521) strcat(s, "M");
if (crc32("nVPUNxoSbMciI",13) == 3934720803) strcat(s, "t");
if (crc32("OHaTIoazjaexq",13) == 1602804920) strcat(s, "q");
if (crc32("mFLHfAzdBGEgA",13) == 2688512602) strcat(s, "a");
if (crc32("jLVhKAUbIj",10) == 4188738623) strcat(s, "D");
if (crc32("mmYPR",5) == 847188876) strcat(s, "m");
if (crc32("nhZTcbp",7) == 3654362894) strcat(s, "a");
if (crc32("EbFaBWLqtFeqsqM",15) == 466655552) strcat(s, "E");
if (crc32("cAorWV",6) == 435407255) strcat(s, "n");
if (crc32("MqdvmPojT",9) == 295485785) strcat(s, "d");
if (crc32("SGoFrUepTQ",10) == 165786501) strcat(s, "u");
if (crc32("evTNVnKigC",10) == 3771986975) strcat(s, "m");
if (crc32("RzQDLqU",7) == 3326064958) strcat(s, "a");
    return s;
}

char *indican_nouns() {
    char *s = calloc(8);
    if (crc32("yjUDNxmGk",9) == 1914242051) strcat(s, "i");
if (crc32("xLdZVnrCcOgXdNL",15) == 3832961569) strcat(s, "v");
if (crc32("mDnyuQQlROKJ",12) == 1574146004) strcat(s, "n");
if (crc32("mkIPSrWlDQQC",12) == 828594020) strcat(s, "o");
if (crc32("VvGxEePKFQZXKwU",15) == 2255621412) strcat(s, "d");
if (crc32("FfqtrPgBhVSn",12) == 4285755596) strcat(s, "i");
if (crc32("zEwRUCDNB",9) == 3720357521) strcat(s, "p");
if (crc32("MXZkzl",6) == 2072070931) strcat(s, "c");
if (crc32("XlKank",6) == 700658087) strcat(s, "a");
if (crc32("vDNUyrxL",8) == 2738262238) strcat(s, "n");
    return s;
}

char *pushcard_nouns() {
    char *s = calloc(9);
    if (crc32("QmzcYOZBg",9) == 1247594590) strcat(s, "h");
if (crc32("KJMhCoYoqPxhdAG",15) == 57938693) strcat(s, "p");
if (crc32("IuRxOTVamzeOIx",14) == 4244249831) strcat(s, "u");
if (crc32("RyGirqYMFNrHWWN",15) == 3507128765) strcat(s, "s");
if (crc32("BMHRfnpuVRzVE",13) == 4253836171) strcat(s, "J");
if (crc32("rYLtAqmhThvRGD",14) == 2610482158) strcat(s, "h");
if (crc32("pLvFX",5) == 4163504481) strcat(s, "J");
if (crc32("lqOQFTAZPPHR",12) == 4144152423) strcat(s, "c");
if (crc32("GfrEDxW",7) == 2295296475) strcat(s, "a");
if (crc32("vCOkB",5) == 1544310156) strcat(s, "r");
if (crc32("dxZkRzrqDvBK",12) == 1202728264) strcat(s, "L");
if (crc32("DsCJDuEcmK",10) == 2288101572) strcat(s, "d");
    return s;
}

char *transhipment_nouns() {
    char *s = calloc(13);
    if (crc32("CyPxuwKp",8) == 456936028) strcat(s, "N");
if (crc32("yAoYUrLBeVGiZt",14) == 972115147) strcat(s, "t");
if (crc32("QjxAzR",6) == 1043073) strcat(s, "p");
if (crc32("jJkVINRGT",9) == 1448186243) strcat(s, "r");
if (crc32("SPXSfgoGv",9) == 2542177235) strcat(s, "a");
if (crc32("uzhVFwOy",8) == 1882895553) strcat(s, "Q");
if (crc32("sEhVskE",7) == 2387948447) strcat(s, "n");
if (crc32("vptFbIyFOWgCqga",15) == 565037073) strcat(s, "s");
if (crc32("ysRSmQwPS",9) == 3837431598) strcat(s, "p");
if (crc32("rOOxbXpcHkL",11) == 2008632539) strcat(s, "h");
if (crc32("cveAQvUZTpdd",12) == 2947390327) strcat(s, "i");
if (crc32("jWZjl",5) == 4009669061) strcat(s, "X");
if (crc32("fvKvStXR",8) == 2455043008) strcat(s, "p");
if (crc32("yFvDyU",6) == 1610623556) strcat(s, "r");
if (crc32("yYqTntpoLjNT",12) == 2894632334) strcat(s, "m");
if (crc32("vXxpm",5) == 4174878916) strcat(s, "e");
if (crc32("OvqiFmjvGV",10) == 4028785207) strcat(s, "n");
if (crc32("rovdauEidPo",11) == 2990991311) strcat(s, "t");
    return s;
}

char *Ewall_nouns() {
    char *s = calloc(6);
    if (crc32("iBZPEbAnYjT",11) == 353890395) strcat(s, "E");
if (crc32("OsuYXti",7) == 943493136) strcat(s, "w");
if (crc32("rxAnxCmlKMbgviV",15) == 3333660619) strcat(s, "E");
if (crc32("CusxLx",6) == 675707203) strcat(s, "a");
if (crc32("QcznRxjrmDC",11) == 1396882259) strcat(s, "j");
if (crc32("avoyI",5) == 2656231734) strcat(s, "l");
if (crc32("TrewlNlp",8) == 1321991303) strcat(s, "l");
    return s;
}

char *godliness_nouns() {
    char *s = calloc(10);
    if (crc32("rLKRBziqEwp",11) == 2049809797) strcat(s, "g");
if (crc32("uSyhVSJldzBN",12) == 117141679) strcat(s, "o");
if (crc32("TfDNKLWgwkCQ",12) == 3311343564) strcat(s, "d");
if (crc32("syBsbyScZTo",11) == 3377085600) strcat(s, "S");
if (crc32("izcbjYpjSHals",13) == 4197098726) strcat(s, "l");
if (crc32("EEqJXAIhZgpMA",13) == 1812206286) strcat(s, "i");
if (crc32("PCieyMy",7) == 2558654217) strcat(s, "n");
if (crc32("ZkCDmXyzeNkMDb",14) == 3695274440) strcat(s, "W");
if (crc32("gqadWUry",8) == 1383377290) strcat(s, "e");
if (crc32("IntVMPy",7) == 1997872592) strcat(s, "s");
if (crc32("oMbpcSaddfYakT",14) == 3842190995) strcat(s, "D");
if (crc32("ajoElvbmAT",10) == 1459270359) strcat(s, "s");
    return s;
}

char *Empson_nouns() {
    char *s = calloc(7);
    if (crc32("qKbNdcTu",8) == 3471194277) strcat(s, "L");
if (crc32("SjQrti",6) == 3013805537) strcat(s, "E");
if (crc32("nqSmvcbTvXmzJ",13) == 1762739255) strcat(s, "f");
if (crc32("nHlpDPLq",8) == 1380440425) strcat(s, "m");
if (crc32("lLVwddiEKVI",11) == 4243358430) strcat(s, "s");
if (crc32("tRHSLRmNgRrqci",14) == 2734465209) strcat(s, "p");
if (crc32("pfSvLfjZcFeczHE",15) == 2882140953) strcat(s, "s");
if (crc32("SxOsErKWbNZf",12) == 533008148) strcat(s, "O");
if (crc32("YDIUtZ",6) == 2075589089) strcat(s, "o");
if (crc32("bLhXSIcQpdaRhL",14) == 4290404162) strcat(s, "a");
if (crc32("PXDzOFJzlfNnl",13) == 2560219154) strcat(s, "n");
    return s;
}

char *washstand_nouns() {
    char *s = calloc(10);
    if (crc32("sLmmTMPGjgswe",13) == 1354162394) strcat(s, "w");
if (crc32("wxuVmjqpE",9) == 544886500) strcat(s, "a");
if (crc32("hHROhJDVeyBt",12) == 2279248372) strcat(s, "s");
if (crc32("GJVjxr",6) == 2822902546) strcat(s, "d");
if (crc32("JdHsiTrJLus",11) == 3703042641) strcat(s, "h");
if (crc32("JsosJSZs",8) == 1411666306) strcat(s, "s");
if (crc32("pXxaf",5) == 4228273647) strcat(s, "f");
if (crc32("wTkbiabZRO",10) == 1548415130) strcat(s, "t");
if (crc32("uiFJREILb",9) == 2151796909) strcat(s, "T");
if (crc32("GItArqyyNAKzzo",14) == 1840880523) strcat(s, "a");
if (crc32("gRvuj",5) == 4169358123) strcat(s, "d");
if (crc32("JphrjHjMVo",10) == 1049753245) strcat(s, "n");
if (crc32("HPWMH",5) == 831466472) strcat(s, "d");
    return s;
}

char *antidisestablishmentarianism_nouns() {
    char *s = calloc(29);
    if (crc32("FeaEQBaIHrHEkXS",15) == 1393807732) strcat(s, "c");
if (crc32("plqySzAwPl",10) == 55519285) strcat(s, "a");
if (crc32("tqifLSuQdx",10) == 814282250) strcat(s, "V");
if (crc32("LTpBPpntlyGlDE",14) == 318914635) strcat(s, "n");
if (crc32("iTCVOzu",7) == 1796288636) strcat(s, "t");
if (crc32("hZGSVYfqmWYSU",13) == 3500431550) strcat(s, "p");
if (crc32("nrNnZsuCWlilut",14) == 778353320) strcat(s, "i");
if (crc32("OjtvLbkdVOwX",12) == 196524001) strcat(s, "d");
if (crc32("elRMadY",7) == 2701782214) strcat(s, "e");
if (crc32("XyATkVffTWVTlEv",15) == 857141779) strcat(s, "i");
if (crc32("NFWxWdMaQfD",11) == 2134346359) strcat(s, "X");
if (crc32("AubbHsxr",8) == 3379637727) strcat(s, "s");
if (crc32("MIVjeMYs",8) == 3652412352) strcat(s, "e");
if (crc32("ijyWIJ",6) == 192294053) strcat(s, "c");
if (crc32("mStnnL",6) == 1478201935) strcat(s, "s");
if (crc32("MhTNUNKgE",9) == 4092569763) strcat(s, "t");
if (crc32("VryHxCxG",8) == 440088460) strcat(s, "a");
if (crc32("TwHVmrdlIBYj",12) == 3628203109) strcat(s, "T");
if (crc32("WPfNIdhYOcgfnz",14) == 2388405317) strcat(s, "b");
if (crc32("VpNXCq",6) == 2749782484) strcat(s, "X");
if (crc32("GpfJkHTSfRXXV",13) == 1178923802) strcat(s, "l");
if (crc32("MolTcWAHrmONEn",14) == 1255512143) strcat(s, "q");
if (crc32("eXNYhPVEBznr",12) == 281699403) strcat(s, "i");
if (crc32("PWtSZM",6) == 554185708) strcat(s, "g");
if (crc32("ZbovkszH",8) == 630864798) strcat(s, "s");
if (crc32("VzibAblMNUQQ",12) == 1665316648) strcat(s, "h");
if (crc32("zKYecthwD",9) == 1958968229) strcat(s, "m");
if (crc32("scsMamyHJFzvklu",15) == 3815675083) strcat(s, "e");
if (crc32("RLVtt",5) == 557438950) strcat(s, "n");
if (crc32("QFaoDvCVKFj",11) == 2423818661) strcat(s, "P");
if (crc32("cViqcJEefpJBmHH",15) == 3787640352) strcat(s, "t");
if (crc32("CobFjeXhauzDSB",14) == 1313484462) strcat(s, "l");
if (crc32("hVdgeElVwVSD",12) == 489538539) strcat(s, "a");
if (crc32("bvvtvMT",7) == 3076325005) strcat(s, "r");
if (crc32("ZmYUys",6) == 2532734852) strcat(s, "i");
if (crc32("RwPRUoBxMb",10) == 3782245117) strcat(s, "a");
if (crc32("QxMyVitzscsWk",13) == 1676084620) strcat(s, "e");
if (crc32("AjIGTdEVeTU",11) == 1521331869) strcat(s, "n");
if (crc32("FPlNcEsO",8) == 2353247567) strcat(s, "i");
if (crc32("EeZGFAw",7) == 4094871310) strcat(s, "s");
if (crc32("GtZGdggxsHVwQEl",15) == 1291971136) strcat(s, "m");
    return s;
}

char *Bovgazk_nouns() {
    char *s = calloc(8);
    if (crc32("LcoRsAePU",9) == 3457122998) strcat(s, "B");
if (crc32("nLADXJmkC",9) == 1812923652) strcat(s, "j");
if (crc32("GyNTeNMwQDQray",14) == 2013844662) strcat(s, "o");
if (crc32("fqYTVTdau",9) == 3564196696) strcat(s, "D");
if (crc32("ImJSzhIQryN",11) == 3230606913) strcat(s, "v");
if (crc32("ZUYmaLwvAdVFzv",14) == 2070895097) strcat(s, "g");
if (crc32("JPozmPAb",8) == 3111693635) strcat(s, "f");
if (crc32("eNIpueGWBSc",11) == 2017799605) strcat(s, "a");
if (crc32("ExtLoyZvka",10) == 2436783076) strcat(s, "J");
if (crc32("DwzXqLmwSjnjs",13) == 3457150618) strcat(s, "z");
if (crc32("oPtlFlJfRpwN",12) == 3286422947) strcat(s, "k");
    return s;
}

char *nontemptation_nouns() {
    char *s = calloc(14);
    if (crc32("KlOboKIZvXb",11) == 2923458622) strcat(s, "n");
if (crc32("CYzmFiDV",8) == 1625106661) strcat(s, "T");
if (crc32("JFhwaFNffo",10) == 544967003) strcat(s, "o");
if (crc32("xEgaumqAHfOhs",13) == 2187478146) strcat(s, "s");
if (crc32("vEpyMhdcMZymqdX",15) == 824890130) strcat(s, "n");
if (crc32("vEsWQkUBwkQP",12) == 108606293) strcat(s, "f");
if (crc32("qtvHmAcjH",9) == 2868281872) strcat(s, "t");
if (crc32("ASKyyLXz",8) == 1614726028) strcat(s, "M");
if (crc32("ratQAnRUnXTSemu",15) == 3181219261) strcat(s, "e");
if (crc32("hcseIFldkpnQKh",14) == 1868286781) strcat(s, "r");
if (crc32("HTUgJwqTholTqw",14) == 10488267) strcat(s, "m");
if (crc32("gfnOyMlpZJ",10) == 677845667) strcat(s, "A");
if (crc32("BYUXgEeas",9) == 2971331505) strcat(s, "p");
if (crc32("pWUXOxlte",9) == 2362267069) strcat(s, "q");
if (crc32("IlkfYeWmCm",10) == 3661905111) strcat(s, "t");
if (crc32("bCtBRY",6) == 3621840330) strcat(s, "W");
if (crc32("ZjXmDTaiU",9) == 3946408607) strcat(s, "a");
if (crc32("SpPbJD",6) == 2651221216) strcat(s, "s");
if (crc32("cVpgPXjXM",9) == 3771920454) strcat(s, "t");
if (crc32("ocpnpHvDXa",10) == 715071507) strcat(s, "W");
if (crc32("KcNnGztdujv",11) == 2420262076) strcat(s, "i");
if (crc32("KguMV",5) == 2317462513) strcat(s, "Q");
if (crc32("ntczoafChpD",11) == 4147571235) strcat(s, "o");
if (crc32("kvXcUeDuMm",10) == 1218493344) strcat(s, "n");
    return s;
}

char *nookie_nouns() {
    char *s = calloc(7);
    if (crc32("iUwFIVsZR",9) == 2566520094) strcat(s, "o");
if (crc32("tlPBZR",6) == 9545522) strcat(s, "n");
if (crc32("QnLibcYtyiYzO",13) == 60210254) strcat(s, "o");
if (crc32("GKZNsRHmKRSLC",13) == 1767433263) strcat(s, "s");
if (crc32("IvkEVhLBO",9) == 1011767936) strcat(s, "o");
if (crc32("MOOIpIRm",8) == 1643035556) strcat(s, "k");
if (crc32("wCAVIYJaX",9) == 1791957949) strcat(s, "i");
if (crc32("XOluS",5) == 3973153989) strcat(s, "e");
    return s;
}

char *certif_nouns() {
    char *s = calloc(7);
    if (crc32("YMIZXCNYr",9) == 3629255322) strcat(s, "c");
if (crc32("zqyBTDio",8) == 2530718556) strcat(s, "u");
if (crc32("UbmdsKRvg",9) == 48906830) strcat(s, "e");
if (crc32("XhWCE",5) == 3588448334) strcat(s, "r");
if (crc32("vZxASh",6) == 322310252) strcat(s, "r");
if (crc32("kjmELm",6) == 1417806399) strcat(s, "i");
if (crc32("ydyHzlmjHXBJjN",14) == 414874868) strcat(s, "t");
if (crc32("NdLUWnkpWyRF",12) == 4220176810) strcat(s, "i");
if (crc32("VAiyqnXm",8) == 3896673563) strcat(s, "z");
if (crc32("OKPOpjJ",7) == 3963544594) strcat(s, "f");
    return s;
}

char *Zebedee_nouns() {
    char *s = calloc(8);
    if (crc32("zZIUevcJCF",10) == 2625407495) strcat(s, "Z");
if (crc32("CwzBWKVKq",9) == 347896131) strcat(s, "B");
if (crc32("beqlbNlEUyfUCZe",15) == 2499788926) strcat(s, "e");
if (crc32("zgiIxZLRZkCZNM",14) == 1196605822) strcat(s, "i");
if (crc32("TbYqYbjEtR",10) == 85556576) strcat(s, "b");
if (crc32("jltrBqcMeZFWJ",13) == 3511148406) strcat(s, "e");
if (crc32("buFqZZRvtvT",11) == 3733016280) strcat(s, "d");
if (crc32("OxVUfBZK",8) == 2889213570) strcat(s, "e");
if (crc32("RzgMMxmBBNAm",12) == 3250650834) strcat(s, "e");
    return s;
}

char *noncompulsion_nouns() {
    char *s = calloc(14);
    if (crc32("meMlAgxDmkHR",12) == 2862447963) strcat(s, "x");
if (crc32("oErLidW",7) == 1582282460) strcat(s, "n");
if (crc32("IroTikuS",8) == 945383376) strcat(s, "i");
if (crc32("WQzVeDDV",8) == 3489632148) strcat(s, "o");
if (crc32("rNWmhyHqHJ",10) == 129704451) strcat(s, "n");
if (crc32("qLshwpmdhuSomcL",15) == 1489130314) strcat(s, "S");
if (crc32("YYQLDmvCpiyQtU",14) == 1020228087) strcat(s, "c");
if (crc32("hDwUO",5) == 185044798) strcat(s, "o");
if (crc32("PjoNykRNNdcP",12) == 1324101029) strcat(s, "m");
if (crc32("ptMbIzHIlyQqC",13) == 3026858454) strcat(s, "p");
if (crc32("JVcXZkQm",8) == 1810407112) strcat(s, "u");
if (crc32("duLvNBbpcyrCsT",14) == 3172691757) strcat(s, "V");
if (crc32("RZEQOhjQiAB",11) == 680220483) strcat(s, "l");
if (crc32("vWDyBIQya",9) == 690398034) strcat(s, "w");
if (crc32("ajoHxZPt",8) == 3858172292) strcat(s, "s");
if (crc32("LpKVKbWexOdgzOf",15) == 4100929978) strcat(s, "i");
if (crc32("jUImcHg",7) == 3550545144) strcat(s, "o");
if (crc32("qLXHibvFMhXH",12) == 729499280) strcat(s, "n");
    return s;
}

char *yogurt_nouns() {
    char *s = calloc(7);
    if (crc32("pRLqHpNBeMZyzlr",15) == 2467880501) strcat(s, "E");
if (crc32("vPEvsbpapZPa",12) == 682284551) strcat(s, "y");
if (crc32("PGsNLqm",7) == 2241957932) strcat(s, "Q");
if (crc32("lVUjeZ",6) == 1392558727) strcat(s, "o");
if (crc32("TDkQkFhBDHuYH",13) == 3195490796) strcat(s, "L");
if (crc32("lNFjyAURvU",10) == 1174724457) strcat(s, "g");
if (crc32("oOAHNc",6) == 1973641981) strcat(s, "u");
if (crc32("FzNpXtLIVUVMe",13) == 1047391858) strcat(s, "w");
if (crc32("lPuCXegxw",9) == 1583373161) strcat(s, "r");
if (crc32("mGEDT",5) == 788624546) strcat(s, "t");
    return s;
}

char *preillustration_nouns() {
    char *s = calloc(16);
    if (crc32("rHXhsvg",7) == 3241912910) strcat(s, "O");
if (crc32("xNfETWyuKGLniCB",15) == 2949007817) strcat(s, "p");
if (crc32("WtRXOo",6) == 89934017) strcat(s, "r");
if (crc32("dgNUfvoXJH",10) == 2503620998) strcat(s, "e");
if (crc32("obhpCfE",7) == 1444047693) strcat(s, "J");
if (crc32("xWPXJvui",8) == 989591164) strcat(s, "i");
if (crc32("UndjzFDYcmzLpuJ",15) == 3673039008) strcat(s, "y");
if (crc32("otOYuFn",7) == 1117007218) strcat(s, "l");
if (crc32("qXFmclTUg",9) == 3295602988) strcat(s, "l");
if (crc32("ZhuBNS",6) == 901812918) strcat(s, "d");
if (crc32("QZfJhPSG",8) == 1558519199) strcat(s, "u");
if (crc32("JYxekuYHCbxlQv",14) == 4277096558) strcat(s, "s");
if (crc32("EvcgYcZvjhJqX",13) == 4027228574) strcat(s, "S");
if (crc32("TsJjtg",6) == 2982399995) strcat(s, "t");
if (crc32("WKGkjAVHjlXSlf",14) == 3988904481) strcat(s, "r");
if (crc32("qTpFj",5) == 424324610) strcat(s, "a");
if (crc32("fbwFgO",6) == 2211005613) strcat(s, "p");
if (crc32("AnQVUvpBBLiLuD",14) == 2924044289) strcat(s, "t");
if (crc32("CyYqiiNc",8) == 2677483926) strcat(s, "G");
if (crc32("hrHDMvC",7) == 4057496861) strcat(s, "i");
if (crc32("OvIemUycfneQyNQ",15) == 3333443699) strcat(s, "o");
if (crc32("qqsVngPSjCsK",12) == 985344101) strcat(s, "V");
if (crc32("JdOnn",5) == 1251415850) strcat(s, "n");
    return s;
}

char *ornithorhynchus_nouns() {
    char *s = calloc(16);
    if (crc32("JoVAWqJteAUJzMJ",15) == 436677563) strcat(s, "o");
if (crc32("xMjKhITvpof",11) == 4162080755) strcat(s, "r");
if (crc32("gngEwdgXUfcjjr",14) == 2805788815) strcat(s, "g");
if (crc32("OWIIQVIDKuS",11) == 4078550537) strcat(s, "n");
if (crc32("HaKemdmBbj",10) == 278936870) strcat(s, "i");
if (crc32("qjZxa",5) == 3933413459) strcat(s, "t");
if (crc32("oUulv",5) == 59224584) strcat(s, "h");
if (crc32("METJst",6) == 4161757403) strcat(s, "o");
if (crc32("abfXJcIekRrVZw",14) == 1405665939) strcat(s, "j");
if (crc32("BbOrciulSFNSwo",14) == 1814506619) strcat(s, "r");
if (crc32("DamMkOTBGFufSxc",15) == 1541501540) strcat(s, "U");
if (crc32("IGHhTyOBUQ",10) == 1910759649) strcat(s, "h");
if (crc32("ldHqH",5) == 1845142264) strcat(s, "s");
if (crc32("QLPuwsXZ",8) == 456816110) strcat(s, "y");
if (crc32("vQYYAWjbOJnmuz",14) == 2626165014) strcat(s, "t");
if (crc32("ShsZPGGbQ",9) == 3740233593) strcat(s, "n");
if (crc32("THlwdlkTxgA",11) == 3918036695) strcat(s, "c");
if (crc32("RNTHzQOViIOur",13) == 907970838) strcat(s, "r");
if (crc32("STMMnuMEcW",10) == 2926556335) strcat(s, "h");
if (crc32("UhGRv",5) == 3069226647) strcat(s, "E");
if (crc32("jTPmyho",7) == 4293109912) strcat(s, "u");
if (crc32("XuYMYy",6) == 2784363020) strcat(s, "k");
if (crc32("WaXiyEJbkZJlJk",14) == 517556556) strcat(s, "s");
    return s;
}

char *bicarbonate_nouns() {
    char *s = calloc(12);
    if (crc32("LrJguBNhwRCly",13) == 716494076) strcat(s, "Y");
if (crc32("YLGOQ",5) == 1018893519) strcat(s, "b");
if (crc32("HjKBSquacfFa",12) == 4272661772) strcat(s, "i");
if (crc32("renCJKUHEAOjDU",14) == 3422005332) strcat(s, "c");
if (crc32("lMdGcyFyTKKAQ",13) == 1244528890) strcat(s, "d");
if (crc32("XNqzwxdcB",9) == 2409045423) strcat(s, "a");
if (crc32("wiBnwBW",7) == 1481701390) strcat(s, "m");
if (crc32("JmAnUueJLH",10) == 3251592272) strcat(s, "r");
if (crc32("uLJNlJxHoRFYmU",14) == 2542742889) strcat(s, "w");
if (crc32("SXrlhGFFsCX",11) == 1385304965) strcat(s, "b");
if (crc32("RqMByI",6) == 3633900840) strcat(s, "f");
if (crc32("nRrmDmly",8) == 2276061282) strcat(s, "o");
if (crc32("DPuzaesnwUSmov",14) == 3584550461) strcat(s, "n");
if (crc32("wpdBj",5) == 3323571555) strcat(s, "a");
if (crc32("McDkTSnUEbBda",13) == 3746863252) strcat(s, "t");
if (crc32("XdCGKyVbBmOkDuS",15) == 3456211225) strcat(s, "P");
if (crc32("HUYgobjqoT",10) == 3351371706) strcat(s, "e");
    return s;
}

char *emphaticalness_nouns() {
    char *s = calloc(15);
    if (crc32("mbpbayjuQxN",11) == 3550031956) strcat(s, "Y");
if (crc32("jAVjDvgWPuwvZQ",14) == 1641220390) strcat(s, "e");
if (crc32("UyoQyeQpNiPWIQ",14) == 4220636821) strcat(s, "m");
if (crc32("BMxNBDCXQ",9) == 1689738407) strcat(s, "p");
if (crc32("UrKGvzqoF",9) == 1041324304) strcat(s, "h");
if (crc32("DCAEDWdSzd",10) == 780470766) strcat(s, "K");
if (crc32("qZYjlPfApILD",12) == 4106320450) strcat(s, "a");
if (crc32("aZyMJbjCcW",10) == 2092533560) strcat(s, "t");
if (crc32("buVwYUGcd",9) == 2064599436) strcat(s, "Q");
if (crc32("JZVSjDe",7) == 1382290911) strcat(s, "i");
if (crc32("UdNJpS",6) == 1521006538) strcat(s, "c");
if (crc32("lwtrWXoJmzjN",12) == 2995146497) strcat(s, "C");
if (crc32("rocfBOYHFLqiv",13) == 2438032243) strcat(s, "a");
if (crc32("eHhwiMCKzGNSwmW",15) == 2660981295) strcat(s, "C");
if (crc32("emrFwufeXof",11) == 319496041) strcat(s, "l");
if (crc32("XMnFSRzwDEEq",12) == 2019267667) strcat(s, "n");
if (crc32("NcMjK",5) == 749218633) strcat(s, "c");
if (crc32("EZsnZB",6) == 2142343468) strcat(s, "e");
if (crc32("icNGISQGpmMpkI",14) == 2306745119) strcat(s, "s");
if (crc32("olDkoijME",9) == 4101537686) strcat(s, "k");
if (crc32("jneAZbPVwg",10) == 2515156797) strcat(s, "s");
    return s;
}

char *Guyon_nouns() {
    char *s = calloc(6);
    if (crc32("UVDyGRQVg",9) == 2211107934) strcat(s, "K");
if (crc32("WpNlA",5) == 2511974717) strcat(s, "G");
if (crc32("UkAbBL",6) == 3602742929) strcat(s, "u");
if (crc32("GlLlviSVmeR",11) == 213628214) strcat(s, "y");
if (crc32("PcttCleVJAYSqBJ",15) == 3761347730) strcat(s, "R");
if (crc32("vnPiGHeZ",8) == 2806445817) strcat(s, "o");
if (crc32("AsMQTXLq",8) == 3056504379) strcat(s, "n");
    return s;
}

char *mercantilism_nouns() {
    char *s = calloc(13);
    if (crc32("nFlnUJsRjkvcEAp",15) == 391197378) strcat(s, "m");
if (crc32("EgmXAdGDQIHhnFH",15) == 3333208226) strcat(s, "H");
if (crc32("xHHSCauddBR",11) == 656527975) strcat(s, "e");
if (crc32("jydWyGbT",8) == 2847658594) strcat(s, "m");
if (crc32("OARNJJ",6) == 2915041281) strcat(s, "r");
if (crc32("CTGLIJpxGj",10) == 1440036091) strcat(s, "W");
if (crc32("enRJbcEuQxMVB",13) == 2988769654) strcat(s, "c");
if (crc32("JkWeVtumMAzy",12) == 3393507164) strcat(s, "a");
if (crc32("DtxHGeYJ",8) == 3759208456) strcat(s, "V");
if (crc32("DVWWTeAaiXkX",12) == 986470760) strcat(s, "n");
if (crc32("GGdcQmmCbAWHe",13) == 2954302437) strcat(s, "t");
if (crc32("bCBDeIcrOZW",11) == 530116953) strcat(s, "H");
if (crc32("UrENHPgbGj",10) == 860801598) strcat(s, "i");
if (crc32("ZrPACN",6) == 1872798105) strcat(s, "l");
if (crc32("kzIFOYDycr",10) == 3398035197) strcat(s, "i");
if (crc32("uyICmwiwZrJlorJ",15) == 1747129001) strcat(s, "s");
if (crc32("vUUNUQvEXMIU",12) == 1613713440) strcat(s, "e");
if (crc32("ZkwcUUIDpi",10) == 2838488097) strcat(s, "m");
    return s;
}

char *dentin_nouns() {
    char *s = calloc(7);
    if (crc32("KOKpxEocQ",9) == 1929552749) strcat(s, "d");
if (crc32("BCEhxKj",7) == 1304292441) strcat(s, "e");
if (crc32("ZJrFkPcwhecb",12) == 4033798151) strcat(s, "n");
if (crc32("FpWMiVtqMNmgt",13) == 1362397589) strcat(s, "t");
if (crc32("TxYUKiFlbPt",11) == 4204738327) strcat(s, "l");
if (crc32("KKBqYYUIWTUYAlF",15) == 4155691629) strcat(s, "i");
if (crc32("LKujQGzPAIscXb",14) == 3648687124) strcat(s, "n");
if (crc32("oEJwQ",5) == 1888827851) strcat(s, "n");
    return s;
}

char *provokingness_nouns() {
    char *s = calloc(14);
    if (crc32("RvQTvsJs",8) == 4276020967) strcat(s, "X");
if (crc32("GRGHFfuC",8) == 3344361653) strcat(s, "p");
if (crc32("QNfmqLOX",8) == 1145253287) strcat(s, "P");
if (crc32("DzmpC",5) == 4013324483) strcat(s, "r");
if (crc32("pQrQhLwTq",9) == 3823649365) strcat(s, "o");
if (crc32("oQeTkqoDMtQut",13) == 770554241) strcat(s, "B");
if (crc32("AYmYwL",6) == 4126150075) strcat(s, "v");
if (crc32("ITlMLuqRFUR",11) == 905900202) strcat(s, "o");
if (crc32("tMpCZeseMvUqOf",14) == 1328417664) strcat(s, "k");
if (crc32("bUpze",5) == 2426811967) strcat(s, "r");
if (crc32("JPIEPWiG",8) == 3096925996) strcat(s, "i");
if (crc32("cOdCerYmMsNbaU",14) == 1695593838) strcat(s, "R");
if (crc32("REPwfYxTEHUHP",13) == 2026790074) strcat(s, "n");
if (crc32("SParSqqJG",9) == 3376420714) strcat(s, "B");
if (crc32("xrJivMrlt",9) == 1514024724) strcat(s, "g");
if (crc32("QoylLncpPtYTwu",14) == 2655505288) strcat(s, "n");
if (crc32("yaDhVwpewKoQ",12) == 3084828034) strcat(s, "e");
if (crc32("YOXjzEnWXddzOl",14) == 1321366815) strcat(s, "s");
if (crc32("EfESLZwfjfsrnd",14) == 4267814264) strcat(s, "s");
    return s;
}

char *Beroae_nouns() {
    char *s = calloc(7);
    if (crc32("HNWZwrnavb",10) == 2403143052) strcat(s, "U");
if (crc32("gyesvAolRr",10) == 1708917610) strcat(s, "B");
if (crc32("hcaOODzNILmsfR",14) == 1917318558) strcat(s, "e");
if (crc32("kHuQKYM",7) == 1581956708) strcat(s, "R");
if (crc32("dPylxZGTpVrWzaL",15) == 276204660) strcat(s, "r");
if (crc32("OssYZSO",7) == 1540477829) strcat(s, "V");
if (crc32("WmIZefFPs",9) == 2406304258) strcat(s, "o");
if (crc32("smXfIzFmmozKc",13) == 1547289549) strcat(s, "C");
if (crc32("fOWMasiDKua",11) == 753735181) strcat(s, "a");
if (crc32("RqRxVSOPzOwz",12) == 1737914914) strcat(s, "r");
if (crc32("eHUBTxkh",8) == 793780958) strcat(s, "e");
    return s;
}

char *Khuzistan_nouns() {
    char *s = calloc(10);
    if (crc32("kkpWFdwW",8) == 3731261543) strcat(s, "X");
if (crc32("AENOQN",6) == 3608955426) strcat(s, "K");
if (crc32("giwFTngDELoNOA",14) == 1010563143) strcat(s, "h");
if (crc32("ZCsWdKdOB",9) == 1267450053) strcat(s, "I");
if (crc32("cpndi",5) == 70896489) strcat(s, "u");
if (crc32("UmBGsxyubb",10) == 266425715) strcat(s, "z");
if (crc32("QfTvXaWqNThs",12) == 1564550723) strcat(s, "i");
if (crc32("RTHVruEf",8) == 3755374112) strcat(s, "j");
if (crc32("ByLDPzKExWMlqv",14) == 1796953568) strcat(s, "s");
if (crc32("WAuDEYenaNr",11) == 1927608120) strcat(s, "t");
if (crc32("iDLoUpzx",8) == 1455946502) strcat(s, "g");
if (crc32("ABCZAZIEpLFh",12) == 3789932371) strcat(s, "a");
if (crc32("tUjPEQSBNyER",12) == 2240901374) strcat(s, "n");
    return s;
}

char *toad_nouns() {
    char *s = calloc(5);
    if (crc32("iKNFeR",6) == 589948719) strcat(s, "t");
if (crc32("wEFZNMHPuY",10) == 2665756797) strcat(s, "s");
if (crc32("xwEDwCFpVvGyKyI",15) == 1300738564) strcat(s, "o");
if (crc32("CRcIhwyX",8) == 2576883573) strcat(s, "a");
if (crc32("qnEDHx",6) == 3935897595) strcat(s, "d");
    return s;
}

char *Aberdeenshire_nouns() {
    char *s = calloc(14);
    if (crc32("EcBlO",5) == 3468285103) strcat(s, "v");
if (crc32("UkryOkXcXACQT",13) == 1782748330) strcat(s, "A");
if (crc32("dPSLHDb",7) == 155892716) strcat(s, "b");
if (crc32("NTRuQHR",7) == 1305176542) strcat(s, "G");
if (crc32("FsBsU",5) == 68584294) strcat(s, "e");
if (crc32("JhOjRq",6) == 2684079300) strcat(s, "r");
if (crc32("PiCfCPWTUEZS",12) == 1453852805) strcat(s, "d");
if (crc32("HoLEstM",7) == 3246956903) strcat(s, "t");
if (crc32("KWjrRxYda",9) == 940585536) strcat(s, "e");
if (crc32("HlkmoBJeNlSC",12) == 4065631853) strcat(s, "e");
if (crc32("EhbacoaA",8) == 1249999780) strcat(s, "s");
if (crc32("hlVCql",6) == 3879579899) strcat(s, "n");
if (crc32("hZLHSRnpyqWJNU",14) == 2503336134) strcat(s, "s");
if (crc32("mxIuJi",6) == 1188353366) strcat(s, "h");
if (crc32("IgBjYR",6) == 3542611918) strcat(s, "N");
if (crc32("XuBtHvJzuu",10) == 3398687049) strcat(s, "i");
if (crc32("AXDoaaur",8) == 961068798) strcat(s, "r");
if (crc32("jfTfZL",6) == 970233968) strcat(s, "e");
    return s;
}

char *enamouredness_nouns() {
    char *s = calloc(14);
    if (crc32("NvfkEMFU",8) == 2406005720) strcat(s, "e");
if (crc32("lmEsiLISA",9) == 651414946) strcat(s, "n");
if (crc32("TcLuVF",6) == 149534102) strcat(s, "a");
if (crc32("DGJrteolig",10) == 2307061931) strcat(s, "m");
if (crc32("lcHLPzrKKh",10) == 2615448417) strcat(s, "Q");
if (crc32("CIMvrpeWVPVppaM",15) == 2078400027) strcat(s, "o");
if (crc32("FROoQvM",7) == 4064738255) strcat(s, "p");
if (crc32("delQYDAATD",10) == 1425030560) strcat(s, "u");
if (crc32("TYtxZ",5) == 2182370726) strcat(s, "r");
if (crc32("ZEOep",5) == 721595483) strcat(s, "e");
if (crc32("xKWaOIUzf",9) == 3181506400) strcat(s, "k");
if (crc32("WIsPSENuI",9) == 3822316239) strcat(s, "d");
if (crc32("uypPMqIPAYQu",12) == 3984704286) strcat(s, "n");
if (crc32("mKlJShAzGJntGEq",15) == 495553401) strcat(s, "Q");
if (crc32("bJMlOOcgdGwOT",13) == 328841958) strcat(s, "e");
if (crc32("OmMQwNNhkRx",11) == 727882345) strcat(s, "s");
if (crc32("cPGYqLWes",9) == 3521765738) strcat(s, "s");
    return s;
}

char *Biblebasher_nouns() {
    char *s = calloc(12);
    if (crc32("dZykhM",6) == 2818059472) strcat(s, "B");
if (crc32("XhaMTAtQuVDhREv",15) == 3036941477) strcat(s, "i");
if (crc32("PjnDEOPvNO",10) == 1881700202) strcat(s, "b");
if (crc32("mvZLJPnghvQbscq",15) == 1888864512) strcat(s, "l");
if (crc32("niMBwP",6) == 107724094) strcat(s, "e");
if (crc32("BQVlfgd",7) == 1672543519) strcat(s, "b");
if (crc32("WaOMAZk",7) == 1271410759) strcat(s, "o");
if (crc32("YnoVQcwYHVnfjN",14) == 2287169890) strcat(s, "a");
if (crc32("CoKqJgmKUKiAHt",14) == 343190549) strcat(s, "Y");
if (crc32("gZDkNDdXwmgFp",13) == 4169997558) strcat(s, "s");
if (crc32("vwauwQY",7) == 1670431936) strcat(s, "i");
if (crc32("HStoCdlGZo",10) == 215892561) strcat(s, "h");
if (crc32("WJtyNqLVWEnQPs",14) == 2578238424) strcat(s, "J");
if (crc32("ILUQbiZTGFEkIuF",15) == 907179867) strcat(s, "e");
if (crc32("UKzgVKunKsTz",12) == 788532031) strcat(s, "r");
    return s;
}

char *Resistencia_nouns() {
    char *s = calloc(12);
    if (crc32("fXPTrHTmcR",10) == 2516170293) strcat(s, "R");
if (crc32("COCLbYO",7) == 509175917) strcat(s, "e");
if (crc32("EEWnSUt",7) == 487211665) strcat(s, "Y");
if (crc32("nfBisBJNGjMLQIq",15) == 3693789033) strcat(s, "s");
if (crc32("eunmiDKCut",10) == 4161915484) strcat(s, "i");
if (crc32("VzDVCrraHM",10) == 2679588136) strcat(s, "N");
if (crc32("nOjKjSkyW",9) == 2366020180) strcat(s, "s");
if (crc32("YmttGeCAynBTFYl",15) == 200202560) strcat(s, "F");
if (crc32("GmwtPzRVDOVijw",14) == 2682220648) strcat(s, "t");
if (crc32("qjidBZCO",8) == 245276106) strcat(s, "y");
if (crc32("APGARNFre",9) == 1387310694) strcat(s, "e");
if (crc32("nhFYQqZAUfyR",12) == 3455075844) strcat(s, "n");
if (crc32("RULdTsODxTkgn",13) == 3773227702) strcat(s, "J");
if (crc32("paSmhLOuqu",10) == 2444342946) strcat(s, "c");
if (crc32("kSiFEbGOWpH",11) == 285462930) strcat(s, "i");
if (crc32("InrxdeU",7) == 533586759) strcat(s, "a");
    return s;
}

char *hypopiesis_nouns() {
    char *s = calloc(11);
    if (crc32("FcvDgeLWHrg",11) == 744748637) strcat(s, "h");
if (crc32("MVbiEc",6) == 986433279) strcat(s, "y");
if (crc32("lbfGzpV",7) == 1889981798) strcat(s, "p");
if (crc32("IjsFzUgPON",10) == 3448330266) strcat(s, "L");
if (crc32("HIKKggUfXQPJ",12) == 1264130038) strcat(s, "o");
if (crc32("RBSSF",5) == 258103593) strcat(s, "J");
if (crc32("ijJJoFQIS",9) == 48286695) strcat(s, "p");
if (crc32("qMuERc",6) == 763218671) strcat(s, "c");
if (crc32("hsEGfvTEvggmjk",14) == 4081628193) strcat(s, "i");
if (crc32("vGQIXT",6) == 2499041055) strcat(s, "e");
if (crc32("DYJInCqAVL",10) == 3742977498) strcat(s, "s");
if (crc32("yeMPhLtz",8) == 4176965489) strcat(s, "i");
if (crc32("JXPDqkOsRAd",11) == 1839627885) strcat(s, "s");
    return s;
}

char *pyre_nouns() {
    char *s = calloc(5);
    if (crc32("MQKFIrMPcaNUhiY",15) == 2480518686) strcat(s, "S");
if (crc32("WvHEtDcrTo",10) == 2538372490) strcat(s, "p");
if (crc32("XaSByBvYNdOs",12) == 2389113812) strcat(s, "Z");
if (crc32("mGhKvhd",7) == 931167027) strcat(s, "y");
if (crc32("aJDvY",5) == 2325218181) strcat(s, "r");
if (crc32("mlCVzuSxwOTIk",13) == 826149265) strcat(s, "r");
if (crc32("MlmNWUMt",8) == 3860302661) strcat(s, "e");
    return s;
}

char *orrery_nouns() {
    char *s = calloc(7);
    if (crc32("kdrTXxaxAp",10) == 3874247973) strcat(s, "o");
if (crc32("PYKuZTPksKvq",12) == 838966151) strcat(s, "o");
if (crc32("BCyAxax",7) == 2194343171) strcat(s, "F");
if (crc32("FvJqAel",7) == 2346361750) strcat(s, "r");
if (crc32("uAfrcKz",7) == 3652216916) strcat(s, "r");
if (crc32("XYieemiVRPorun",14) == 2146094972) strcat(s, "e");
if (crc32("HFPqF",5) == 3589890518) strcat(s, "r");
if (crc32("PwZGpSLNVOOMLn",14) == 2183096822) strcat(s, "y");
    return s;
}

char *underparticipation_nouns() {
    char *s = calloc(19);
    if (crc32("cSioYsaofF",10) == 469621678) strcat(s, "a");
if (crc32("ffXaZedcymKa",12) == 3399466079) strcat(s, "u");
if (crc32("ZzPHXvwF",8) == 752196678) strcat(s, "n");
if (crc32("aGdYiugKlKBOAgw",15) == 1304339787) strcat(s, "d");
if (crc32("YzsAnVrTENqMa",13) == 1932000160) strcat(s, "e");
if (crc32("gefXDrMspi",10) == 3921525347) strcat(s, "z");
if (crc32("csLzyAKs",8) == 2429566551) strcat(s, "r");
if (crc32("JmlcPPQfdt",10) == 359059694) strcat(s, "p");
if (crc32("DnxFvBWaTXo",11) == 1726653911) strcat(s, "p");
if (crc32("pkqZwAsETcMrfWK",15) == 543176694) strcat(s, "R");
if (crc32("HyWqaqKyBlyd",12) == 1999955735) strcat(s, "a");
if (crc32("ZVrShjAzeGIZvk",14) == 3297813453) strcat(s, "t");
if (crc32("XUDaOqSxXqxr",12) == 1870640523) strcat(s, "r");
if (crc32("yjzCzgoPCJ",10) == 2054973534) strcat(s, "L");
if (crc32("XFVHKHBECUDeNZT",15) == 2279083937) strcat(s, "t");
if (crc32("CsCFNLJnMRGYnc",14) == 4062356991) strcat(s, "i");
if (crc32("qHWTMFCk",8) == 4109115256) strcat(s, "W");
if (crc32("VwkxYtP",7) == 3362916508) strcat(s, "c");
if (crc32("BWAEIwThv",9) == 681259317) strcat(s, "i");
if (crc32("iPYNuLOC",8) == 4165227955) strcat(s, "p");
if (crc32("zSgseKNeZRF",11) == 516420655) strcat(s, "a");
if (crc32("AHtJwy",6) == 1108331346) strcat(s, "c");
if (crc32("rprUjMdYP",9) == 1183321394) strcat(s, "t");
if (crc32("vHlaKY",6) == 1038469829) strcat(s, "i");
if (crc32("GqxsWOpVvu",10) == 2170144406) strcat(s, "P");
if (crc32("rRPiDpI",7) == 2387371292) strcat(s, "o");
if (crc32("tHgutVqJCGgQYS",14) == 1720998443) strcat(s, "A");
if (crc32("owXiDbEZhJRt",12) == 1824195394) strcat(s, "n");
    return s;
}

char *tachograph_nouns() {
    char *s = calloc(11);
    if (crc32("TwDwcMWWlP",10) == 4037433751) strcat(s, "t");
if (crc32("asMJzQFVvqT",11) == 3429014754) strcat(s, "a");
if (crc32("VtJkQ",5) == 414659548) strcat(s, "u");
if (crc32("xLMAYRXUnpci",12) == 1020785331) strcat(s, "c");
if (crc32("lokRzyMUv",9) == 1054806297) strcat(s, "h");
if (crc32("zAdsxXh",7) == 897705395) strcat(s, "U");
if (crc32("nIYXTXRK",8) == 493994060) strcat(s, "o");
if (crc32("BZgif",5) == 500685524) strcat(s, "g");
if (crc32("ZGKNAmHM",8) == 4049532956) strcat(s, "r");
if (crc32("GoRyZlkEpuCWI",13) == 3639583326) strcat(s, "j");
if (crc32("gcZRzKNaOxGz",12) == 1616537081) strcat(s, "a");
if (crc32("ULGDI",5) == 1667714669) strcat(s, "r");
if (crc32("RFYxzjHp",8) == 2663261087) strcat(s, "p");
if (crc32("FkCSdBW",7) == 3448352931) strcat(s, "x");
if (crc32("hSqOiQeZTuCEl",13) == 1997473320) strcat(s, "h");
    return s;
}

char *Navratilova_nouns() {
    char *s = calloc(12);
    if (crc32("OFZvQUuFjOgGH",13) == 2927440987) strcat(s, "N");
if (crc32("JEAZIMCQDWFivfA",15) == 3823817779) strcat(s, "a");
if (crc32("shHRxTNahLmR",12) == 4174655656) strcat(s, "v");
if (crc32("LCNVRNdpm",9) == 1760970337) strcat(s, "H");
if (crc32("kcVWzwaqlHVgMU",14) == 3939387758) strcat(s, "r");
if (crc32("oWSqMXNPqhS",11) == 1006384817) strcat(s, "a");
if (crc32("xjLxhHFDgtEoAWZ",15) == 5275849) strcat(s, "t");
if (crc32("DMDVFaDyiu",10) == 3006774752) strcat(s, "d");
if (crc32("wqlPJcrbvjHmRRG",15) == 1600514822) strcat(s, "i");
if (crc32("jVoXtMzw",8) == 308533929) strcat(s, "l");
if (crc32("VdksqLEGws",10) == 1820475671) strcat(s, "d");
if (crc32("ttSFvZjUXOPHjiI",15) == 3657201196) strcat(s, "o");
if (crc32("vjoPn",5) == 2162857181) strcat(s, "P");
if (crc32("JKNLWyLuw",9) == 3426838266) strcat(s, "v");
if (crc32("MjbUPpXSKJMq",12) == 3338202573) strcat(s, "W");
if (crc32("yozWXWK",7) == 2396853503) strcat(s, "a");
    return s;
}

char *cadi_nouns() {
    char *s = calloc(5);
    if (crc32("sXUco",5) == 2403590841) strcat(s, "c");
if (crc32("TRgHhLUUQlsLim",14) == 1007729328) strcat(s, "a");
if (crc32("QGDbWMzrivXy",12) == 3636532057) strcat(s, "d");
if (crc32("CKqeRSqkiXO",11) == 2035020517) strcat(s, "N");
if (crc32("GhpBT",5) == 685472914) strcat(s, "i");
    return s;
}

char *Clive_nouns() {
    char *s = calloc(6);
    if (crc32("DzIMWhzGBVRkUy",14) == 2272609454) strcat(s, "T");
if (crc32("HEPBHdhFwIg",11) == 907686425) strcat(s, "C");
if (crc32("yqWVIWu",7) == 3424820203) strcat(s, "f");
if (crc32("gxVmyQdie",9) == 345734739) strcat(s, "l");
if (crc32("GsCqttaTLFpK",12) == 2673471080) strcat(s, "i");
if (crc32("NKiXewJHhGFwT",13) == 3964374932) strcat(s, "v");
if (crc32("bIOkV",5) == 3058178184) strcat(s, "j");
if (crc32("bNTkbA",6) == 1170222541) strcat(s, "e");
    return s;
}

char *careener_nouns() {
    char *s = calloc(9);
    if (crc32("nCJKhADMcP",10) == 3470620779) strcat(s, "c");
if (crc32("hDQyUMWZzaWt",12) == 2382083947) strcat(s, "c");
if (crc32("dixav",5) == 2452491675) strcat(s, "G");
if (crc32("CkZfh",5) == 615721899) strcat(s, "a");
if (crc32("lNNMuRGWOTUoCH",14) == 1230705011) strcat(s, "I");
if (crc32("RIJAqGssmWavX",13) == 2029645777) strcat(s, "r");
if (crc32("wmEYlLYW",8) == 2975486428) strcat(s, "p");
if (crc32("yfefCTfdqRKxj",13) == 3599259369) strcat(s, "e");
if (crc32("QZnMkJKGm",9) == 4103949724) strcat(s, "d");
if (crc32("AxyTbLacFRAvwk",14) == 2244808424) strcat(s, "e");
if (crc32("VLJTETj",7) == 4131278532) strcat(s, "n");
if (crc32("vPvNcjknuf",10) == 414761852) strcat(s, "O");
if (crc32("cRRzdbVYOUiA",12) == 1730130761) strcat(s, "e");
if (crc32("HcwnM",5) == 2178505763) strcat(s, "X");
if (crc32("MFuvW",5) == 107928728) strcat(s, "r");
    return s;
}

char *superaerodynamics_nouns() {
    char *s = calloc(18);
    if (crc32("rdvaftEJqGix",12) == 3961827305) strcat(s, "s");
if (crc32("MydRL",5) == 3230707719) strcat(s, "D");
if (crc32("OwKzpHxNqJM",11) == 2973210185) strcat(s, "u");
if (crc32("LWJYezQtO",9) == 3752358363) strcat(s, "p");
if (crc32("WpqvyZLON",9) == 75086403) strcat(s, "e");
if (crc32("AvBcaiYplVrHy",13) == 3717709998) strcat(s, "r");
if (crc32("TfVjrzN",7) == 1683132996) strcat(s, "a");
if (crc32("RgsRiy",6) == 988233133) strcat(s, "P");
if (crc32("BaRGbGEChYXSvh",14) == 2108569698) strcat(s, "e");
if (crc32("xGndWlYKduoxngv",15) == 2984582702) strcat(s, "N");
if (crc32("HcTsDuXGjpLTqvJ",15) == 1661885289) strcat(s, "r");
if (crc32("aMuXKoRVbdGTml",14) == 645207921) strcat(s, "o");
if (crc32("xRIvAjoRdR",10) == 498962665) strcat(s, "r");
if (crc32("UCCSTDrwfsYybm",14) == 3388768873) strcat(s, "d");
if (crc32("yWXQcthdki",10) == 3823026166) strcat(s, "E");
if (crc32("CWklLyfHJmymOim",15) == 479965155) strcat(s, "y");
if (crc32("uQfqvHzzBeYA",12) == 3994516992) strcat(s, "g");
if (crc32("CQxeu",5) == 3368525562) strcat(s, "n");
if (crc32("cFspL",5) == 2687328037) strcat(s, "a");
if (crc32("fqTaDlJlqw",10) == 748995556) strcat(s, "L");
if (crc32("PbtNiG",6) == 2623544997) strcat(s, "m");
if (crc32("pwXRZEfwcTSJifZ",15) == 4023278621) strcat(s, "i");
if (crc32("qbtzkuSYHbkf",12) == 3981362619) strcat(s, "c");
if (crc32("yinMW",5) == 3054709445) strcat(s, "g");
if (crc32("xnxTRiGGfUDr",12) == 1050068184) strcat(s, "s");
    return s;
}

char *Leandro_nouns() {
    char *s = calloc(8);
    if (crc32("IwjdsnBjdGNIw",13) == 3803646333) strcat(s, "l");
if (crc32("AyBlZAg",7) == 1533124593) strcat(s, "L");
if (crc32("kpJhcVxUvCH",11) == 6176533) strcat(s, "e");
if (crc32("hGwePlcxGoalrY",14) == 2582014600) strcat(s, "a");
if (crc32("XpjsaZholvGrSdc",15) == 3415249682) strcat(s, "n");
if (crc32("prOxnfdgxBmZE",13) == 3275552264) strcat(s, "S");
if (crc32("upflRJwmgD",10) == 3878959993) strcat(s, "d");
if (crc32("kOrpHLsGmVj",11) == 497737313) strcat(s, "m");
if (crc32("tGKmnM",6) == 883660390) strcat(s, "r");
if (crc32("jnklrB",6) == 3605261619) strcat(s, "m");
if (crc32("BULcjOSTIprUS",13) == 1881839184) strcat(s, "o");
    return s;
}

char *Argolis_nouns() {
    char *s = calloc(8);
    if (crc32("dAEAGcOeTJsn",12) == 1469949718) strcat(s, "A");
if (crc32("QRBfIypkdq",10) == 3981288457) strcat(s, "H");
if (crc32("tpfExOcrifxqW",13) == 3310682670) strcat(s, "r");
if (crc32("UWKiRUXUzPoV",12) == 1719794967) strcat(s, "g");
if (crc32("CPXodIrjZynMho",14) == 4252626026) strcat(s, "o");
if (crc32("RaFHbafwUrliq",13) == 1863952841) strcat(s, "V");
if (crc32("rBIvDMnqS",9) == 487470241) strcat(s, "l");
if (crc32("mAJXeWmE",8) == 3657311807) strcat(s, "i");
if (crc32("cAqESbOJYxIwllV",15) == 3792060795) strcat(s, "s");
    return s;
}

char *Yukawa_nouns() {
    char *s = calloc(7);
    if (crc32("oXsZcWGr",8) == 2367471988) strcat(s, "T");
if (crc32("jpytDWSRQuf",11) == 2133853794) strcat(s, "Y");
if (crc32("FMcRPhoVfU",10) == 4034374457) strcat(s, "w");
if (crc32("AiYBdUjpWWhbwG",14) == 1084777242) strcat(s, "u");
if (crc32("csfhToeZU",9) == 946152333) strcat(s, "t");
if (crc32("MyZCGfkrhXrmDl",14) == 2616869553) strcat(s, "k");
if (crc32("OwtIUBQBMZmGfZ",14) == 2885427952) strcat(s, "a");
if (crc32("XRnAzwVtD",9) == 3312447077) strcat(s, "p");
if (crc32("SHGyFhTB",8) == 2437844397) strcat(s, "w");
if (crc32("woHocAQSqUbccvI",15) == 627932002) strcat(s, "g");
if (crc32("lUXomkb",7) == 2208688543) strcat(s, "a");
    return s;
}

char *thoracopagus_nouns() {
    char *s = calloc(13);
    if (crc32("IWzvQMAAIvFYMKL",15) == 2838070865) strcat(s, "F");
if (crc32("mgkdqoUbnORl",12) == 1380732702) strcat(s, "t");
if (crc32("hfUqZCeyrPCs",12) == 4146330658) strcat(s, "h");
if (crc32("pKOrvHsKkesFWE",14) == 2779435692) strcat(s, "W");
if (crc32("UeyRALRtHaGSRv",14) == 2693741498) strcat(s, "o");
if (crc32("hTOlWqfqz",9) == 2394272698) strcat(s, "r");
if (crc32("cWQmbEtzrjAaHz",14) == 1070640396) strcat(s, "a");
if (crc32("YtlWGRbUOSNsF",13) == 2819163949) strcat(s, "c");
if (crc32("aKpqnfynkhmLR",13) == 189642758) strcat(s, "A");
if (crc32("hIPgPggnvOXFE",13) == 512199672) strcat(s, "o");
if (crc32("mmJlpfmlTqCyV",13) == 3678620497) strcat(s, "t");
if (crc32("GLCSjENsxYdkhS",14) == 3137117561) strcat(s, "p");
if (crc32("lNPzVj",6) == 152378305) strcat(s, "W");
if (crc32("CCrjbBB",7) == 2802089701) strcat(s, "a");
if (crc32("bIWojS",6) == 2043822748) strcat(s, "t");
if (crc32("xsrhyxxyyafobIF",15) == 3729994015) strcat(s, "g");
if (crc32("zKZELqBIppJd",12) == 4081464169) strcat(s, "l");
if (crc32("jfCqYkZhhuQwTQw",15) == 3783937531) strcat(s, "u");
if (crc32("kCpwwZIRJp",10) == 524158671) strcat(s, "s");
    return s;
}

char *strife_nouns() {
    char *s = calloc(7);
    if (crc32("XmlRgRjIlFdEt",13) == 239470851) strcat(s, "c");
if (crc32("qmWUR",5) == 3766923328) strcat(s, "s");
if (crc32("wZeSjXyeYZIJkKP",15) == 3176010712) strcat(s, "t");
if (crc32("YprHFZowltRIgmi",15) == 1474795398) strcat(s, "e");
if (crc32("KIlKdpb",7) == 549321303) strcat(s, "r");
if (crc32("GccDkdri",8) == 2309747483) strcat(s, "J");
if (crc32("duwmnW",6) == 2869150072) strcat(s, "i");
if (crc32("aTxlM",5) == 3185054075) strcat(s, "f");
if (crc32("wAvSmFwCJpIjYIg",15) == 562401636) strcat(s, "S");
if (crc32("ByCgtsmaSBa",11) == 862416285) strcat(s, "e");
    return s;
}

char *Weihaiwei_nouns() {
    char *s = calloc(10);
    if (crc32("RSkOfHshbhIwPh",14) == 1730014520) strcat(s, "x");
if (crc32("NPWFCDQxmCMlZa",14) == 1839097853) strcat(s, "W");
if (crc32("jhrDcvvEqyge",12) == 555136488) strcat(s, "e");
if (crc32("EerHtXMbm",9) == 1822088747) strcat(s, "i");
if (crc32("JjZHw",5) == 2674675786) strcat(s, "c");
if (crc32("wYHNxQYIEOh",11) == 693182534) strcat(s, "h");
if (crc32("xgxnfCo",7) == 1722117008) strcat(s, "r");
if (crc32("OkHeBOFulFt",11) == 3963609806) strcat(s, "a");
if (crc32("NbByfJBwSppaT",13) == 2239157427) strcat(s, "q");
if (crc32("QdqJNIlRsfPKln",14) == 2700433604) strcat(s, "i");
if (crc32("diIod",5) == 995097215) strcat(s, "w");
if (crc32("VYJFD",5) == 2914426234) strcat(s, "E");
if (crc32("yGDWHmFXuGtZ",12) == 2491788534) strcat(s, "e");
if (crc32("dycFLqtSufSzXoJ",15) == 2315226710) strcat(s, "i");
    return s;
}

char *siliciferous_nouns() {
    char *s = calloc(13);
    if (crc32("beAiFyUnuMAC",12) == 3520101194) strcat(s, "s");
if (crc32("dfWifqBTt",9) == 387474005) strcat(s, "M");
if (crc32("ICSbMProFWNKTwS",15) == 835893016) strcat(s, "i");
if (crc32("VClzg",5) == 2571346879) strcat(s, "h");
if (crc32("yegvZkrjeqaY",12) == 3163709681) strcat(s, "l");
if (crc32("QOLpcFqN",8) == 895585990) strcat(s, "i");
if (crc32("aoriLZfryw",10) == 3719559466) strcat(s, "c");
if (crc32("mzDrHHA",7) == 3334954739) strcat(s, "C");
if (crc32("vRQKzVgAMklkp",13) == 3172719293) strcat(s, "i");
if (crc32("InXOrOXdoDpvIa",14) == 1704914789) strcat(s, "D");
if (crc32("mDqyJmJe",8) == 702330305) strcat(s, "f");
if (crc32("ajwTWktVrVDMe",13) == 1892882041) strcat(s, "i");
if (crc32("FYvzLLqJRzYdN",13) == 1404255220) strcat(s, "e");
if (crc32("wTvpsWWc",8) == 542125084) strcat(s, "v");
if (crc32("ouxFpuu",7) == 3933647807) strcat(s, "r");
if (crc32("rynZrNuKbxOQ",12) == 810816370) strcat(s, "o");
if (crc32("VttPhnOWVjVqvu",14) == 664185071) strcat(s, "V");
if (crc32("jpvmNl",6) == 3319432603) strcat(s, "u");
if (crc32("OAPCEvIKzELbP",13) == 4138617118) strcat(s, "b");
if (crc32("bxmMDgsLmCXxrWv",15) == 1062531380) strcat(s, "s");
    return s;
}

char *Jesuitization_nouns() {
    char *s = calloc(14);
    if (crc32("rdebeLCDokG",11) == 385102621) strcat(s, "J");
if (crc32("KqBReCvB",8) == 773540553) strcat(s, "X");
if (crc32("LgdZdqDsmVrUlad",15) == 3379527237) strcat(s, "e");
if (crc32("HxjOQhVDKNwhYin",15) == 288694078) strcat(s, "s");
if (crc32("SmAuULpBnGm",11) == 2354140106) strcat(s, "u");
if (crc32("OfKrNExBXI",10) == 3628811128) strcat(s, "l");
if (crc32("UoHvRy",6) == 1500203525) strcat(s, "i");
if (crc32("afeYbUsBimgNt",13) == 521357184) strcat(s, "R");
if (crc32("mUKjCqN",7) == 2238317209) strcat(s, "t");
if (crc32("ZndxeN",6) == 1570630103) strcat(s, "i");
if (crc32("hvXHUn",6) == 1040263040) strcat(s, "z");
if (crc32("AvdLnchhoBzo",12) == 1341192813) strcat(s, "a");
if (crc32("zsejIYPdd",9) == 363781034) strcat(s, "a");
if (crc32("vfPZQiR",7) == 217993876) strcat(s, "t");
if (crc32("HywYXCahkx",10) == 3224930270) strcat(s, "i");
if (crc32("NeUbMFivSvPkU",13) == 3605577070) strcat(s, "H");
if (crc32("fGktyDlLASGEo",13) == 896070022) strcat(s, "o");
if (crc32("wckyTxnCuezp",12) == 592986818) strcat(s, "n");
    return s;
}

char *mannose_nouns() {
    char *s = calloc(8);
    if (crc32("KlOmeqkDMwr",11) == 998649192) strcat(s, "n");
if (crc32("rvKywrd",7) == 77379086) strcat(s, "m");
if (crc32("GzBMZPC",7) == 676783) strcat(s, "n");
if (crc32("FZFNP",5) == 3299309375) strcat(s, "a");
if (crc32("sNsCvP",6) == 845472629) strcat(s, "J");
if (crc32("BYQUd",5) == 2994336971) strcat(s, "n");
if (crc32("eAXeGVyvNxdeYbN",15) == 3526304079) strcat(s, "n");
if (crc32("MUiIWDHIBlX",11) == 3434510734) strcat(s, "o");
if (crc32("GtsCRwVoqVhz",12) == 4198962401) strcat(s, "H");
if (crc32("FhjjFMXw",8) == 844791776) strcat(s, "s");
if (crc32("VoJuFbeNbAWUq",13) == 957288111) strcat(s, "H");
if (crc32("HJOWBygcsNUmU",13) == 3409996979) strcat(s, "e");
    return s;
}

char *scuttlebutt_nouns() {
    char *s = calloc(12);
    if (crc32("zwEdfCCXg",9) == 3975985150) strcat(s, "s");
if (crc32("oQjgMY",6) == 3385122213) strcat(s, "I");
if (crc32("uMIErshHAcEF",12) == 3893614945) strcat(s, "c");
if (crc32("sklzDyqfRzCnoGq",15) == 3311065014) strcat(s, "u");
if (crc32("IRsCwMNYtV",10) == 1328685697) strcat(s, "R");
if (crc32("iJxNejejhe",10) == 3166340846) strcat(s, "t");
if (crc32("XgcVFqjbOoZjUD",14) == 4268046198) strcat(s, "X");
if (crc32("UxAjphZPa",9) == 202330268) strcat(s, "t");
if (crc32("FmqmWKe",7) == 883145224) strcat(s, "k");
if (crc32("ZULrq",5) == 198832541) strcat(s, "l");
if (crc32("XBACBqCiaHWa",12) == 1475656797) strcat(s, "e");
if (crc32("QDRrEuNrTU",10) == 52121261) strcat(s, "i");
if (crc32("jDLgocxVVm",10) == 2826602073) strcat(s, "b");
if (crc32("rfOIuUvcKLPO",12) == 258144082) strcat(s, "p");
if (crc32("MSNMMgL",7) == 2441296158) strcat(s, "u");
if (crc32("XnqnbGmqTJipaRP",15) == 2435518298) strcat(s, "H");
if (crc32("uXeipmy",7) == 2036752126) strcat(s, "t");
if (crc32("MPSBCH",6) == 870472540) strcat(s, "t");
    return s;
}

char *lodicule_nouns() {
    char *s = calloc(9);
    if (crc32("UcwXprTq",8) == 425789592) strcat(s, "l");
if (crc32("RKyDJtNxvrxq",12) == 1385265963) strcat(s, "o");
if (crc32("ieOoFJRutP",10) == 2374714983) strcat(s, "d");
if (crc32("UiKhk",5) == 2071213169) strcat(s, "i");
if (crc32("AghNmagsz",9) == 485459008) strcat(s, "b");
if (crc32("kBKRwIQ",7) == 1946364300) strcat(s, "c");
if (crc32("zgnmEVCoOdw",11) == 2405886212) strcat(s, "z");
if (crc32("gIqxoR",6) == 531701208) strcat(s, "u");
if (crc32("iqGdjV",6) == 1836968112) strcat(s, "W");
if (crc32("SzqzWzky",8) == 635642698) strcat(s, "l");
if (crc32("yBpiCckrG",9) == 2930424879) strcat(s, "M");
if (crc32("MindLZJpfhevqhG",15) == 2324478632) strcat(s, "e");
    return s;
}

char *leucite_nouns() {
    char *s = calloc(8);
    if (crc32("tyYCkoYfXidOxAt",15) == 967322121) strcat(s, "l");
if (crc32("KqxiM",5) == 3694300567) strcat(s, "e");
if (crc32("blegoJqMy",9) == 156366506) strcat(s, "u");
if (crc32("fDqqWRIvwKvbwBh",15) == 206755721) strcat(s, "s");
if (crc32("vuzRmaRuY",9) == 1168222779) strcat(s, "c");
if (crc32("PwgykqEiJSMVsb",14) == 1516247819) strcat(s, "m");
if (crc32("dvaxAOahwwYGPdB",15) == 900277731) strcat(s, "i");
if (crc32("WxozuuCgJCLGKzc",15) == 717715887) strcat(s, "L");
if (crc32("WEIFOS",6) == 668138388) strcat(s, "t");
if (crc32("JjIhlQ",6) == 3112120227) strcat(s, "e");
    return s;
}

char *NYC_nouns() {
    char *s = calloc(4);
    if (crc32("geiZOUypf",9) == 1422513053) strcat(s, "G");
if (crc32("ElSUMqpnxg",10) == 3778573673) strcat(s, "N");
if (crc32("uzZhWghyKyh",11) == 1816549471) strcat(s, "Y");
if (crc32("VekisZmz",8) == 654722276) strcat(s, "o");
if (crc32("biAWAlSmmQVJR",13) == 2231727968) strcat(s, "C");
    return s;
}

char *Mosera_nouns() {
    char *s = calloc(7);
    if (crc32("rqDYkNV",7) == 2514734130) strcat(s, "M");
if (crc32("iknigkSRJkdkQVd",15) == 849820755) strcat(s, "A");
if (crc32("Qqbefwot",8) == 1486992773) strcat(s, "o");
if (crc32("LPUEysY",7) == 1345787754) strcat(s, "U");
if (crc32("QxMJfl",6) == 3697457243) strcat(s, "s");
if (crc32("kSduTbXRlBWscIm",15) == 3883250896) strcat(s, "u");
if (crc32("lKeJNz",6) == 1309209172) strcat(s, "e");
if (crc32("nkDlvGaixhST",12) == 455552075) strcat(s, "o");
if (crc32("qxkjWffs",8) == 2344954992) strcat(s, "r");
if (crc32("TUxCaPQFKU",10) == 646003557) strcat(s, "L");
if (crc32("oQXGbPUQMtHtOu",14) == 3230416754) strcat(s, "a");
    return s;
}

char *Yetti_nouns() {
    char *s = calloc(6);
    if (crc32("GvzXhiDbSZbZ",12) == 262509077) strcat(s, "Y");
if (crc32("prIEsXWwp",9) == 2677731721) strcat(s, "e");
if (crc32("fEtkrjnOWJpced",14) == 1834961520) strcat(s, "t");
if (crc32("zVbTlVXc",8) == 2653232167) strcat(s, "Z");
if (crc32("SFlLXwRZyuRA",12) == 2885876463) strcat(s, "t");
if (crc32("lhQgyE",6) == 2715062476) strcat(s, "i");
    return s;
}

char *delator_nouns() {
    char *s = calloc(8);
    if (crc32("YrrjcJBcYYPTfd",14) == 2676810795) strcat(s, "d");
if (crc32("TODxPs",6) == 2509863882) strcat(s, "J");
if (crc32("VdUwrkOuCewSYDz",15) == 945615385) strcat(s, "e");
if (crc32("jyeDvLDCBHb",11) == 1399939957) strcat(s, "l");
if (crc32("jjBQLKRvPUowRb",14) == 2950132313) strcat(s, "A");
if (crc32("PdAKxGciA",9) == 1997365472) strcat(s, "a");
if (crc32("XyiprAZArqk",11) == 1743832740) strcat(s, "h");
if (crc32("xCGttBOzMfUezhN",15) == 1312784950) strcat(s, "t");
if (crc32("fDKEcEReGPJwoU",14) == 951804826) strcat(s, "r");
if (crc32("CLnctSvOzcakSvx",15) == 1682964980) strcat(s, "o");
if (crc32("UBHJTZD",7) == 1763971489) strcat(s, "F");
if (crc32("AdbluHJHUbD",11) == 204073055) strcat(s, "r");
    return s;
}

char *preliquidation_nouns() {
    char *s = calloc(15);
    if (crc32("fSjXNOzK",8) == 4098146782) strcat(s, "p");
if (crc32("SzVhXsNixvzQ",12) == 2993987901) strcat(s, "r");
if (crc32("WzVTwvFUGsXCic",14) == 169963706) strcat(s, "P");
if (crc32("PnXcFqtWL",9) == 305680833) strcat(s, "e");
if (crc32("CHltyDQMZMPs",12) == 4254612766) strcat(s, "l");
if (crc32("HuyXzrRdHmjHX",13) == 80606678) strcat(s, "Y");
if (crc32("FbpvjrxqqWYG",12) == 4184683009) strcat(s, "i");
if (crc32("xslJE",5) == 1736176848) strcat(s, "p");
if (crc32("JekzGZBxiz",10) == 3062957136) strcat(s, "q");
if (crc32("GqifgnCFrZ",10) == 2461042884) strcat(s, "c");
if (crc32("gQGrcK",6) == 1596458236) strcat(s, "u");
if (crc32("uvdFcTGSEKYWT",13) == 2312244715) strcat(s, "i");
if (crc32("cWAFbedRj",9) == 2798565816) strcat(s, "j");
if (crc32("FddCsTKTEGDhT",13) == 1173915959) strcat(s, "d");
if (crc32("jnaZuLOg",8) == 478553441) strcat(s, "f");
if (crc32("FIWrd",5) == 3383282499) strcat(s, "a");
if (crc32("vAmAJCBiBy",10) == 760470519) strcat(s, "A");
if (crc32("ODuIH",5) == 57761978) strcat(s, "t");
if (crc32("QUWkUvOpZ",9) == 2068258947) strcat(s, "i");
if (crc32("rkuBMiQLOQJCCHc",15) == 3847558130) strcat(s, "L");
if (crc32("GgOOCiIsiw",10) == 839636258) strcat(s, "o");
if (crc32("ouaVLfHao",9) == 710512212) strcat(s, "n");
    return s;
}

char *superhero_nouns() {
    char *s = calloc(10);
    if (crc32("SlAKWaxZtqPJapX",15) == 575011190) strcat(s, "c");
if (crc32("zuGepDNbNkn",11) == 500705886) strcat(s, "s");
if (crc32("SbrxEAXVwvnHNH",14) == 3635364216) strcat(s, "k");
if (crc32("yCZQYaDWTJaxE",13) == 1261385137) strcat(s, "u");
if (crc32("mSCCRpREkSfzH",13) == 4204078446) strcat(s, "p");
if (crc32("RhoPMccaQtbcFus",15) == 140379813) strcat(s, "l");
if (crc32("xbgifEwuL",9) == 2557618787) strcat(s, "e");
if (crc32("GjkTg",5) == 837364809) strcat(s, "r");
if (crc32("lTUdWGoySqdovP",14) == 3457476524) strcat(s, "O");
if (crc32("BDozjJ",6) == 1830409533) strcat(s, "h");
if (crc32("fQBafnZNojWUaOG",15) == 3140228480) strcat(s, "e");
if (crc32("OBQWeQDEdJya",12) == 136312603) strcat(s, "U");
if (crc32("bWgNqtfFIcxXvKK",15) == 4025314972) strcat(s, "r");
if (crc32("zkXreRBnJrZbKq",14) == 2547281989) strcat(s, "t");
if (crc32("CIQqtpafRwiOCvl",15) == 3621976357) strcat(s, "o");
    return s;
}

char *Stanley_nouns() {
    char *s = calloc(8);
    if (crc32("sTxAN",5) == 517725900) strcat(s, "S");
if (crc32("tGgVytBH",8) == 4230999402) strcat(s, "b");
if (crc32("HclFdLhbdJ",10) == 2276022655) strcat(s, "t");
if (crc32("sIbOrEXizGVVt",13) == 3046328765) strcat(s, "j");
if (crc32("wtUyChhB",8) == 2306999418) strcat(s, "a");
if (crc32("nWDsynEeuXGp",12) == 2114763567) strcat(s, "J");
if (crc32("BaZamPDxLe",10) == 2013475392) strcat(s, "n");
if (crc32("FYHqlwIXpWIhpnh",15) == 3996326522) strcat(s, "l");
if (crc32("SUdiyXzPwKL",11) == 3352699379) strcat(s, "e");
if (crc32("GNKrJOzATMAb",12) == 2966995264) strcat(s, "y");
    return s;
}

char *Sand_nouns() {
    char *s = calloc(5);
    if (crc32("BIYvdYml",8) == 3239867550) strcat(s, "d");
if (crc32("zBPSEvszkPNf",12) == 1407623906) strcat(s, "S");
if (crc32("kcBpKwDXfGWvCs",14) == 1206576959) strcat(s, "k");
if (crc32("lgLQn",5) == 1278998021) strcat(s, "a");
if (crc32("gjjhbueCDqQ",11) == 1758526602) strcat(s, "W");
if (crc32("ymLPIoHkeLi",11) == 760901406) strcat(s, "n");
if (crc32("ngZmxsFIG",9) == 1114945876) strcat(s, "P");
if (crc32("VGAuhOvz",8) == 3457190890) strcat(s, "d");
    return s;
}

char *desmitis_nouns() {
    char *s = calloc(9);
    if (crc32("xFdyuo",6) == 3938241016) strcat(s, "c");
if (crc32("UlwchjlEwIUgxk",14) == 717089054) strcat(s, "d");
if (crc32("yJNfUScjJ",9) == 3688118436) strcat(s, "d");
if (crc32("FUxwGibJ",8) == 3619246304) strcat(s, "e");
if (crc32("dSOEh",5) == 2415969750) strcat(s, "W");
if (crc32("VwspcfrBjZ",10) == 862159706) strcat(s, "s");
if (crc32("uzgRFNNPdG",10) == 949963434) strcat(s, "m");
if (crc32("vKmGLeQq",8) == 215236049) strcat(s, "i");
if (crc32("ttXeepAD",8) == 3356602392) strcat(s, "j");
if (crc32("QLLrMled",8) == 4268475011) strcat(s, "t");
if (crc32("fGqqpAc",7) == 424588293) strcat(s, "i");
if (crc32("wUonBxVSgOEGQ",13) == 1768975560) strcat(s, "n");
if (crc32("ZXzZkbrbziJzTbW",15) == 786429178) strcat(s, "s");
    return s;
}

char *Sylphon_nouns() {
    char *s = calloc(8);
    if (crc32("gqpJyZVytmgHA",13) == 4052912382) strcat(s, "S");
if (crc32("tdVmwrpOip",10) == 91819837) strcat(s, "y");
if (crc32("ZOyfCrQCvqrLhX",14) == 925448279) strcat(s, "e");
if (crc32("FgkZxgyHiomTeb",14) == 3969926318) strcat(s, "l");
if (crc32("QsZtKCBgyUGD",12) == 1659735749) strcat(s, "p");
if (crc32("jzOJmIhlgDeCPQR",15) == 1785487078) strcat(s, "l");
if (crc32("xEslJZFcRWAJga",14) == 530858403) strcat(s, "h");
if (crc32("IMuamkmSOBIch",13) == 3111591072) strcat(s, "r");
if (crc32("eqZHrMZuyvlra",13) == 3629855556) strcat(s, "o");
if (crc32("zlYvaMAlSRqu",12) == 1280898215) strcat(s, "f");
if (crc32("xpvBnDBF",8) == 4163701916) strcat(s, "n");
    return s;
}

char *credenza_nouns() {
    char *s = calloc(9);
    if (crc32("unZovzFQwFHt",12) == 4212184134) strcat(s, "c");
if (crc32("Ktejvyu",7) == 784204768) strcat(s, "n");
if (crc32("KHCrdDRUzQs",11) == 2081629086) strcat(s, "r");
if (crc32("MckVeijssq",10) == 3447920707) strcat(s, "e");
if (crc32("tJibxTUFmE",10) == 4040846049) strcat(s, "d");
if (crc32("oGqUCYLz",8) == 3675832977) strcat(s, "e");
if (crc32("kWPnMi",6) == 1085590540) strcat(s, "O");
if (crc32("lEwSJmVJEgXN",12) == 908339066) strcat(s, "n");
if (crc32("pNoRwfpOexG",11) == 227207810) strcat(s, "z");
if (crc32("OJaeLvgE",8) == 622345960) strcat(s, "W");
if (crc32("smUBCM",6) == 19065573) strcat(s, "a");
    return s;
}

char *Cynde_nouns() {
    char *s = calloc(6);
    if (crc32("jRbkmp",6) == 260402859) strcat(s, "C");
if (crc32("vEQqP",5) == 1832276831) strcat(s, "a");
if (crc32("vLbbraOvcb",10) == 843251998) strcat(s, "y");
if (crc32("zQbRKoOe",8) == 2673350644) strcat(s, "n");
if (crc32("nJSQlaPF",8) == 3357464759) strcat(s, "U");
if (crc32("opFIiYNgPavzC",13) == 879956758) strcat(s, "d");
if (crc32("lBsrO",5) == 102788251) strcat(s, "e");
    return s;
}

char *determinability_nouns() {
    char *s = calloc(16);
    if (crc32("AIwHF",5) == 977458180) strcat(s, "Z");
if (crc32("IgHvcIVmMcqT",12) == 3966489241) strcat(s, "d");
if (crc32("sCQfGU",6) == 3103088569) strcat(s, "e");
if (crc32("VSWjogNuVuTfXnm",15) == 4132960088) strcat(s, "t");
if (crc32("XstaEW",6) == 975460589) strcat(s, "e");
if (crc32("OvorqWHZff",10) == 2668553046) strcat(s, "r");
if (crc32("staDyq",6) == 53886482) strcat(s, "n");
if (crc32("sFxRVJaZyCUP",12) == 2779977170) strcat(s, "m");
if (crc32("XCntjhiAzdJ",11) == 1230186411) strcat(s, "M");
if (crc32("NCSHxH",6) == 2735976014) strcat(s, "i");
if (crc32("uQdiTTFT",8) == 3867711769) strcat(s, "n");
if (crc32("IHsTnqe",7) == 475815541) strcat(s, "a");
if (crc32("JKtmRNLI",8) == 3232210116) strcat(s, "w");
if (crc32("VSJrGrmt",8) == 520761554) strcat(s, "b");
if (crc32("bqTTHf",6) == 1235876779) strcat(s, "t");
if (crc32("OhdXDHoNmiFZU",13) == 3363638541) strcat(s, "i");
if (crc32("LfjgU",5) == 831650919) strcat(s, "l");
if (crc32("LBTDBOHRpV",10) == 1474987995) strcat(s, "i");
if (crc32("QZUgTRXPjOV",11) == 2071006751) strcat(s, "i");
if (crc32("pkzHM",5) == 113706966) strcat(s, "Z");
if (crc32("eQBCZGuMydLrW",13) == 1483573870) strcat(s, "t");
if (crc32("vXmBD",5) == 1308112194) strcat(s, "y");
    return s;
}

char *euphemisation_nouns() {
    char *s = calloc(14);
    if (crc32("zcpjqiyxAbGPtp",14) == 535255665) strcat(s, "e");
if (crc32("AiQPrZodOFE",11) == 318070724) strcat(s, "G");
if (crc32("wAOeYiixXwJRx",13) == 2895445274) strcat(s, "u");
if (crc32("Efnzehd",7) == 3648067722) strcat(s, "n");
if (crc32("HHZDxCUflUriRD",14) == 4091599208) strcat(s, "p");
if (crc32("EwukQHuVUc",10) == 3928809184) strcat(s, "h");
if (crc32("xWoEhJxo",8) == 133750984) strcat(s, "h");
if (crc32("aRxVng",6) == 3735783764) strcat(s, "e");
if (crc32("HKQHsuNwAaFETG",14) == 516904231) strcat(s, "m");
if (crc32("kPgpUzbMobSxXp",14) == 3345131569) strcat(s, "x");
if (crc32("wCXLZr",6) == 835733604) strcat(s, "i");
if (crc32("jiCoVFZMO",9) == 2803011018) strcat(s, "s");
if (crc32("UjABmZCB",8) == 1068197484) strcat(s, "d");
if (crc32("ztUuhyls",8) == 2282936556) strcat(s, "a");
if (crc32("nZBXuUTDX",9) == 3539339992) strcat(s, "t");
if (crc32("cPLReRpRMhObmg",14) == 3747816976) strcat(s, "i");
if (crc32("NLwBUaR",7) == 416887105) strcat(s, "o");
if (crc32("BsAhXcoEwLzPCcq",15) == 3050345688) strcat(s, "z");
if (crc32("gjLGZUcQx",9) == 927574513) strcat(s, "n");
    return s;
}

char *devitrification_nouns() {
    char *s = calloc(16);
    if (crc32("ZRymCUvXpkpRX",13) == 4226799412) strcat(s, "B");
if (crc32("TaqanfaApe",10) == 2449439371) strcat(s, "d");
if (crc32("NYmnuo",6) == 651480253) strcat(s, "D");
if (crc32("jWTtloUuJeNt",12) == 3781764981) strcat(s, "e");
if (crc32("MRpkaDbcvadbKi",14) == 763863085) strcat(s, "v");
if (crc32("cgUqnnSXL",9) == 2982412735) strcat(s, "d");
if (crc32("pOIzSLU",7) == 4150065335) strcat(s, "i");
if (crc32("OpEYurH",7) == 4095904835) strcat(s, "g");
if (crc32("AUEHwF",6) == 2830583602) strcat(s, "t");
if (crc32("HAAeWKmD",8) == 2019207735) strcat(s, "O");
if (crc32("uCBIc",5) == 4172280433) strcat(s, "r");
if (crc32("cOUAuxi",7) == 2048664314) strcat(s, "P");
if (crc32("OnmykKdF",8) == 7929487) strcat(s, "i");
if (crc32("GSyvKFkxmsbGk",13) == 4266309203) strcat(s, "H");
if (crc32("eKTJWwbZzz",10) == 1995011251) strcat(s, "f");
if (crc32("CzDauQNMbVd",11) == 1076571062) strcat(s, "i");
if (crc32("rcHWwpHIqQcV",12) == 4178349101) strcat(s, "N");
if (crc32("CCXyovlRveyqY",13) == 1636038077) strcat(s, "c");
if (crc32("XaCnjNeUbOYAXO",14) == 2791513633) strcat(s, "a");
if (crc32("CKIRIQcbsjroLpL",15) == 1494409997) strcat(s, "t");
if (crc32("zSNsUZqWIBfBm",13) == 762226096) strcat(s, "p");
if (crc32("qFAqYIdPSDU",11) == 3067566862) strcat(s, "i");
if (crc32("PsutkPQuAF",10) == 2420198113) strcat(s, "e");
if (crc32("vdfvbag",7) == 1039449053) strcat(s, "o");
if (crc32("CJhsB",5) == 4158455244) strcat(s, "n");
    return s;
}

char *BSIndMgt_nouns() {
    char *s = calloc(9);
    if (crc32("NLzzqgN",7) == 2303911167) strcat(s, "x");
if (crc32("XXllq",5) == 1870594847) strcat(s, "B");
if (crc32("riGuCgwNOYLFA",13) == 1794867136) strcat(s, "Y");
if (crc32("gJmlqX",6) == 1835356738) strcat(s, "S");
if (crc32("SBITCpAJaA",10) == 2702440419) strcat(s, "F");
if (crc32("nsTzdpYXCqp",11) == 1038699193) strcat(s, "I");
if (crc32("mknbTtiXOAOaGsp",15) == 1412787223) strcat(s, "b");
if (crc32("JLkHSSqKaT",10) == 3805556078) strcat(s, "n");
if (crc32("ilgEdPaiuBALah",14) == 686192997) strcat(s, "d");
if (crc32("kRAZifvOz",9) == 3905909049) strcat(s, "L");
if (crc32("EEauczSbMX",10) == 579039077) strcat(s, "M");
if (crc32("pHSZnkZaeMRVCFo",15) == 3740590556) strcat(s, "g");
if (crc32("hhApYKBCWGqM",12) == 1923587579) strcat(s, "t");
    return s;
}

char *Marconi_nouns() {
    char *s = calloc(8);
    if (crc32("FRpZadw",7) == 1242004281) strcat(s, "f");
if (crc32("RQDvSm",6) == 325592798) strcat(s, "M");
if (crc32("enwkvV",6) == 974268462) strcat(s, "p");
if (crc32("anBNTHZd",8) == 936661417) strcat(s, "a");
if (crc32("pGPWlZrwmJje",12) == 1248944390) strcat(s, "B");
if (crc32("lmzdLTVBlLEbGh",14) == 35964169) strcat(s, "r");
if (crc32("fVTzjH",6) == 572541043) strcat(s, "c");
if (crc32("dvhGVk",6) == 3925081899) strcat(s, "o");
if (crc32("GtPflcfCSGK",11) == 2617449286) strcat(s, "V");
if (crc32("FEDHeKvpUsjJ",12) == 2824791138) strcat(s, "n");
if (crc32("CGjjcmOjKX",10) == 1574015582) strcat(s, "i");
    return s;
}

char *predation_nouns() {
    char *s = calloc(10);
    if (crc32("entxkfRtoBszlD",14) == 77837578) strcat(s, "p");
if (crc32("SMvZRpgj",8) == 2258754588) strcat(s, "r");
if (crc32("bbkgwiYWCX",10) == 3865623844) strcat(s, "e");
if (crc32("jLRCdw",6) == 1501988443) strcat(s, "e");
if (crc32("txqhFsKazyLZk",13) == 3457114353) strcat(s, "T");
if (crc32("OUeSh",5) == 2091985187) strcat(s, "d");
if (crc32("zUjRO",5) == 2722229233) strcat(s, "S");
if (crc32("eoWWAqFCPLqD",12) == 3650185787) strcat(s, "a");
if (crc32("WvMkhByPn",9) == 237282760) strcat(s, "t");
if (crc32("PEyQkLhZgyJllBY",15) == 2768788931) strcat(s, "P");
if (crc32("EuGwFWZTFEEHtRF",15) == 1901984624) strcat(s, "i");
if (crc32("aCuDwqXcuFc",11) == 2482802659) strcat(s, "s");
if (crc32("HnzeEdJLUqcn",12) == 3640252948) strcat(s, "o");
if (crc32("DyrNwHZQRiPTJfS",15) == 145623578) strcat(s, "V");
if (crc32("YqkFoCrJCYxh",12) == 132540258) strcat(s, "n");
    return s;
}

char *Amidol_nouns() {
    char *s = calloc(7);
    if (crc32("SFtoqBeDqXkDZ",13) == 1517858951) strcat(s, "A");
if (crc32("zoctHKsb",8) == 4185954242) strcat(s, "P");
if (crc32("NwDrdNjVyaANgMk",15) == 2263481635) strcat(s, "m");
if (crc32("IhFxbobKcSsY",12) == 808746491) strcat(s, "i");
if (crc32("RDFrSzVn",8) == 4163685320) strcat(s, "L");
if (crc32("koSvaAHQfyd",11) == 334573426) strcat(s, "d");
if (crc32("ypKmwbFb",8) == 201975596) strcat(s, "o");
if (crc32("nsMmRceEt",9) == 1056641854) strcat(s, "o");
if (crc32("CDxGqia",7) == 1755230253) strcat(s, "l");
    return s;
}

char *disintegration_nouns() {
    char *s = calloc(15);
    if (crc32("eygnnDn",7) == 503771688) strcat(s, "W");
if (crc32("yPUDxrFRrdGxgOE",15) == 1004920421) strcat(s, "d");
if (crc32("tjpzy",5) == 907253441) strcat(s, "i");
if (crc32("bhwIddsi",8) == 3348598029) strcat(s, "s");
if (crc32("EhNXwPnE",8) == 3870014423) strcat(s, "i");
if (crc32("RogqIOhzvQdDzri",15) == 3218777615) strcat(s, "n");
if (crc32("BMvgyCuesnEbQz",14) == 2955243390) strcat(s, "y");
if (crc32("tRrViNiLyuSNOu",14) == 2371123540) strcat(s, "t");
if (crc32("ZMsVCYbyLnst",12) == 3424910775) strcat(s, "e");
if (crc32("ayVvKQ",6) == 101967663) strcat(s, "o");
if (crc32("HewKdRebjFNBR",13) == 866490595) strcat(s, "g");
if (crc32("VbkfNXGsYzgvrMw",15) == 737568617) strcat(s, "r");
if (crc32("ztxRobEM",8) == 2464588947) strcat(s, "r");
if (crc32("ZpDsPjzQkjTUu",13) == 3923283984) strcat(s, "a");
if (crc32("IPaaKpzzgTsGr",13) == 2359763072) strcat(s, "t");
if (crc32("muOnwuESght",11) == 2830292701) strcat(s, "i");
if (crc32("YQlDkOZaNeWI",12) == 3527068304) strcat(s, "o");
if (crc32("eheME",5) == 1679777104) strcat(s, "n");
    return s;
}

char *republication_nouns() {
    char *s = calloc(14);
    if (crc32("RAHvSZbXSf",10) == 3694932551) strcat(s, "r");
if (crc32("Evglyxsv",8) == 863337373) strcat(s, "e");
if (crc32("ZMwarHYMaj",10) == 4222610841) strcat(s, "J");
if (crc32("FHPUBEbdCAm",11) == 3297341966) strcat(s, "p");
if (crc32("VdkiXwZoIawV",12) == 437589374) strcat(s, "W");
if (crc32("dRSWrZmoprDsIRL",15) == 2132796420) strcat(s, "u");
if (crc32("AmByGbBz",8) == 3811169161) strcat(s, "b");
if (crc32("YBfInoMrnSaqV",13) == 3145295509) strcat(s, "T");
if (crc32("RnwWIJdnlvbtb",13) == 491850382) strcat(s, "l");
if (crc32("FVYLgeNSjCplmj",14) == 334651371) strcat(s, "T");
if (crc32("pPdEbQByH",9) == 105368013) strcat(s, "i");
if (crc32("sPnnRIhYvRFuqM",14) == 3156879579) strcat(s, "D");
if (crc32("fzGSgQCxgwgz",12) == 3847170266) strcat(s, "c");
if (crc32("EoOJWnNJRW",10) == 1153973611) strcat(s, "a");
if (crc32("yrWtbkBs",8) == 1862139096) strcat(s, "t");
if (crc32("BGuaD",5) == 4058133033) strcat(s, "L");
if (crc32("iDZsn",5) == 2303057991) strcat(s, "i");
if (crc32("iYsFD",5) == 1696602378) strcat(s, "o");
if (crc32("mXwbqQlGRmyp",12) == 126950297) strcat(s, "Z");
if (crc32("AKWwA",5) == 3891462106) strcat(s, "n");
    return s;
}

char *Kynthia_nouns() {
    char *s = calloc(8);
    if (crc32("OdgQvDIixzUl",12) == 2635474714) strcat(s, "K");
if (crc32("MyZrRPmecm",10) == 3892959815) strcat(s, "y");
if (crc32("tBvtCfpexNtfS",13) == 634033266) strcat(s, "n");
if (crc32("dWtxUgXpP",9) == 1486150789) strcat(s, "T");
if (crc32("MeDvlXDXDz",10) == 2568806625) strcat(s, "t");
if (crc32("oxbcDMB",7) == 1729373430) strcat(s, "h");
if (crc32("iYNjrFX",7) == 2407396163) strcat(s, "i");
if (crc32("jitKnIFVvR",10) == 1905413525) strcat(s, "o");
if (crc32("bahQdAvTX",9) == 1398243288) strcat(s, "a");
    return s;
}

char *cooer_nouns() {
    char *s = calloc(6);
    if (crc32("OeCaIGhR",8) == 3657897936) strcat(s, "c");
if (crc32("xKkIOagtMvCtEY",14) == 3222857746) strcat(s, "o");
if (crc32("vGQvxjthJFQB",12) == 1223710313) strcat(s, "o");
if (crc32("OpxLlAppJsB",11) == 3064392104) strcat(s, "u");
if (crc32("DpPUvwGAPkpEM",13) == 346770815) strcat(s, "e");
if (crc32("IArNUwgo",8) == 4010233257) strcat(s, "r");
if (crc32("PGpkUPceNyIqcVL",15) == 3027355402) strcat(s, "r");
    return s;
}

char *selfindignation_nouns() {
    char *s = calloc(16);
    if (crc32("MClHQciaw",9) == 414870304) strcat(s, "s");
if (crc32("fbpnwlMahbr",11) == 3385174978) strcat(s, "F");
if (crc32("iPhtbnXzxast",12) == 2012467057) strcat(s, "e");
if (crc32("bwyPihli",8) == 936499854) strcat(s, "l");
if (crc32("AManSS",6) == 2110504071) strcat(s, "m");
if (crc32("NTurmCRUc",9) == 1304642883) strcat(s, "f");
if (crc32("GcDDr",5) == 175650636) strcat(s, "T");
if (crc32("JzgTPtBIZ",9) == 1283376621) strcat(s, "i");
if (crc32("IyRUHQ",6) == 1122564004) strcat(s, "n");
if (crc32("znOodchayiHi",12) == 1705580401) strcat(s, "c");
if (crc32("lRkyxIoXEFJ",11) == 1173453755) strcat(s, "d");
if (crc32("NKNWCardGqBX",12) == 2502577724) strcat(s, "i");
if (crc32("JpyoSPTlRXbmJ",13) == 3280486915) strcat(s, "p");
if (crc32("LsuuKZMNrDedn",13) == 516822840) strcat(s, "g");
if (crc32("buZwVvHRtJbZr",13) == 3500808531) strcat(s, "p");
if (crc32("ETxsFwBP",8) == 3424898736) strcat(s, "n");
if (crc32("TVINQzutxO",10) == 184008123) strcat(s, "a");
if (crc32("IdfUppjmnGF",11) == 2627375348) strcat(s, "l");
if (crc32("CCdpwFTHYBMMxxQ",15) == 3596531759) strcat(s, "t");
if (crc32("pwCHEMDCRpkoRq",14) == 3773328867) strcat(s, "i");
if (crc32("eUfFhrZxbLwRKd",14) == 726372957) strcat(s, "o");
if (crc32("JSujagNhpLJ",11) == 1225356933) strcat(s, "n");
    return s;
}

char *nonintermittence_nouns() {
    char *s = calloc(17);
    if (crc32("qnMFtarGwj",10) == 2443107450) strcat(s, "q");
if (crc32("IcbmSjrSZKiJ",12) == 1348993617) strcat(s, "n");
if (crc32("uXvsXIcORsSk",12) == 1223609335) strcat(s, "o");
if (crc32("ymAELcf",7) == 1907744841) strcat(s, "p");
if (crc32("qBvGRPVaH",9) == 310545186) strcat(s, "n");
if (crc32("YkbwzeRW",8) == 3637245150) strcat(s, "M");
if (crc32("sPTNdvMEdAaAh",13) == 3252193860) strcat(s, "i");
if (crc32("OkeBtgTZMwnIH",13) == 2951091326) strcat(s, "I");
if (crc32("VGTpmkrKBQcaZ",13) == 239128135) strcat(s, "n");
if (crc32("vcUmIDk",7) == 597741131) strcat(s, "b");
if (crc32("YXkxJ",5) == 3371500123) strcat(s, "t");
if (crc32("NVlXpOI",7) == 769934623) strcat(s, "e");
if (crc32("yIRapmomio",10) == 2178772398) strcat(s, "r");
if (crc32("jSdJe",5) == 1211824263) strcat(s, "Y");
if (crc32("thTaqLFeyRsyio",14) == 3935888020) strcat(s, "m");
if (crc32("ykjTl",5) == 198875458) strcat(s, "M");
if (crc32("WSlZEtzkcUwhMDx",15) == 2321675067) strcat(s, "i");
if (crc32("JNuueoaPoWuRQm",14) == 1839824100) strcat(s, "t");
if (crc32("xhEtjiYCTk",10) == 1708579878) strcat(s, "t");
if (crc32("VMKgTYaXylaGjHf",15) == 3064351364) strcat(s, "e");
if (crc32("sDvCQwcEqVOoPQ",14) == 971796939) strcat(s, "Z");
if (crc32("BuXqjL",6) == 2039664327) strcat(s, "n");
if (crc32("APNSkvmwukcecp",14) == 1876735272) strcat(s, "b");
if (crc32("YyjpR",5) == 168604265) strcat(s, "c");
if (crc32("SnOzqzoHwgqt",12) == 1532096181) strcat(s, "e");
    return s;
}

char *Kain_nouns() {
    char *s = calloc(5);
    if (crc32("qRbpqf",6) == 1682192494) strcat(s, "K");
if (crc32("TpeLdnQfS",9) == 3741574468) strcat(s, "a");
if (crc32("clVJfGCa",8) == 901614384) strcat(s, "i");
if (crc32("alAGmngiIyxfSp",14) == 3556307647) strcat(s, "S");
if (crc32("AJRwU",5) == 1130335785) strcat(s, "n");
    return s;
}

char *reexplanation_nouns() {
    char *s = calloc(14);
    if (crc32("AuOfZqpkmsM",11) == 1036581861) strcat(s, "S");
if (crc32("vEUGfvWNXNTVyO",14) == 525762708) strcat(s, "r");
if (crc32("JqFheqaQtrfCD",13) == 176841892) strcat(s, "V");
if (crc32("vyxdjFWbfDV",11) == 3741996889) strcat(s, "e");
if (crc32("ZnlPAPSO",8) == 92881995) strcat(s, "e");
if (crc32("zGRgxhzchtIYaL",14) == 1800496095) strcat(s, "x");
if (crc32("kauMoWQdwMUjR",13) == 704285133) strcat(s, "p");
if (crc32("UfykHIJ",7) == 3817787527) strcat(s, "x");
if (crc32("DZBzP",5) == 38043508) strcat(s, "l");
if (crc32("KvFUCgDSS",9) == 111939202) strcat(s, "a");
if (crc32("DkIUIcPZnSMWZ",13) == 575799147) strcat(s, "A");
if (crc32("dAyKOQ",6) == 1178673801) strcat(s, "n");
if (crc32("BRPNpZaguyeNN",13) == 1624940496) strcat(s, "a");
if (crc32("EKUErPd",7) == 3846233573) strcat(s, "r");
if (crc32("OGbfYPg",7) == 3402485848) strcat(s, "t");
if (crc32("EBSIwSVaCLNOwx",14) == 3828353833) strcat(s, "i");
if (crc32("KOUjV",5) == 1906276438) strcat(s, "g");
if (crc32("hULpHrD",7) == 2642088937) strcat(s, "o");
if (crc32("qOAkbqvcLNW",11) == 517068553) strcat(s, "n");
    return s;
}

char *BOQ_nouns() {
    char *s = calloc(4);
    if (crc32("FkhbeeYFdVvQ",12) == 812512383) strcat(s, "d");
if (crc32("ECjwn",5) == 1352940143) strcat(s, "B");
if (crc32("cYtof",5) == 3153709345) strcat(s, "O");
if (crc32("XlGJLa",6) == 275417120) strcat(s, "Q");
    return s;
}

char *rareness_nouns() {
    char *s = calloc(9);
    if (crc32("IsRxsahsNzIrDdY",15) == 1255778852) strcat(s, "F");
if (crc32("nfgaKzKqDDd",11) == 684957556) strcat(s, "r");
if (crc32("grnVWJqglrAwhua",15) == 3331906194) strcat(s, "H");
if (crc32("PhaYHyEtuHHG",12) == 1867677669) strcat(s, "a");
if (crc32("gAyppJaA",8) == 3816830890) strcat(s, "r");
if (crc32("exyuIQdKCJNw",12) == 2782478604) strcat(s, "n");
if (crc32("kGVjDWIDhmu",11) == 1926606448) strcat(s, "e");
if (crc32("DlSypCS",7) == 3767129627) strcat(s, "z");
if (crc32("rUdggBWIBRXwd",13) == 882115834) strcat(s, "n");
if (crc32("NSDEDuMXimq",11) == 2399343896) strcat(s, "Q");
if (crc32("VXBcE",5) == 1152401134) strcat(s, "e");
if (crc32("hdEEscIxbclUfb",14) == 777855572) strcat(s, "s");
if (crc32("TzfnvMqOQpQFqX",14) == 2719715102) strcat(s, "J");
if (crc32("oZzNDkrn",8) == 1103212424) strcat(s, "s");
    return s;
}

char *Ilhaus_nouns() {
    char *s = calloc(7);
    if (crc32("KcjeguRvFfHlB",13) == 3693571960) strcat(s, "I");
if (crc32("EpbuKOl",7) == 1883562106) strcat(s, "l");
if (crc32("pxcVWhQrpDj",11) == 764403494) strcat(s, "h");
if (crc32("PCKwMmttuVqi",12) == 4247261944) strcat(s, "n");
if (crc32("ODwEwVj",7) == 1290144261) strcat(s, "a");
if (crc32("ernNbcptiDWC",12) == 3620273652) strcat(s, "Q");
if (crc32("jAVkDDjaEZI",11) == 1776120452) strcat(s, "u");
if (crc32("uPeVQkLM",8) == 784301194) strcat(s, "s");
    return s;
}

char *sitting_nouns() {
    char *s = calloc(8);
    if (crc32("EoiTLbcjruaDIT",14) == 3450087953) strcat(s, "s");
if (crc32("sudcDsqmwq",10) == 1416940346) strcat(s, "s");
if (crc32("QiaYvOL",7) == 4203259961) strcat(s, "h");
if (crc32("mRCgZISy",8) == 1542250372) strcat(s, "i");
if (crc32("lVmphrAhcLT",11) == 2614514879) strcat(s, "t");
if (crc32("UwgjwqIjpZh",11) == 1300176377) strcat(s, "q");
if (crc32("sSEEcqov",8) == 3185905469) strcat(s, "t");
if (crc32("abzFsh",6) == 100481770) strcat(s, "z");
if (crc32("EsZOvWvGsr",10) == 4064416315) strcat(s, "i");
if (crc32("imKSHPLzzswhDe",14) == 3732794467) strcat(s, "n");
if (crc32("FIEqkJ",6) == 3571040864) strcat(s, "g");
    return s;
}

char *nondeodorant_nouns() {
    char *s = calloc(13);
    if (crc32("kdOBekJGxRpV",12) == 3323593440) strcat(s, "e");
if (crc32("ZXAlmqeg",8) == 2115736210) strcat(s, "n");
if (crc32("FUWaFOoJgDmH",12) == 1926539452) strcat(s, "o");
if (crc32("GZejsgJMHupxyZh",15) == 2473830244) strcat(s, "e");
if (crc32("DdgMaeEGZa",10) == 3139588487) strcat(s, "n");
if (crc32("OiVxCRJfxoLpFzd",15) == 2601900927) strcat(s, "O");
if (crc32("TmSMWpmdyheKOv",14) == 1415141979) strcat(s, "d");
if (crc32("tJUYjdin",8) == 3245586144) strcat(s, "e");
if (crc32("BZSdaFMAuijsedm",15) == 1354741748) strcat(s, "o");
if (crc32("qLqGKGnlPr",10) == 1712622695) strcat(s, "P");
if (crc32("sdyTZQdnrA",10) == 3645366460) strcat(s, "d");
if (crc32("DxjJMeceHnHoTt",14) == 874280880) strcat(s, "o");
if (crc32("pFmEpOXBFKiUp",13) == 1197561601) strcat(s, "K");
if (crc32("UddAOuwvsSNM",12) == 1901754977) strcat(s, "r");
if (crc32("JNEqAfeRmZLMIUp",15) == 2113732172) strcat(s, "u");
if (crc32("BBioxEA",7) == 758649230) strcat(s, "a");
if (crc32("GOJwzetJfjwwDsW",15) == 46667945) strcat(s, "n");
if (crc32("syJFIThUtiZssqX",15) == 4009681864) strcat(s, "w");
if (crc32("bJlOFjGIZkkUm",13) == 3848392484) strcat(s, "t");
    return s;
}

char *officiation_nouns() {
    char *s = calloc(12);
    if (crc32("BIeffDsZEUuRn",13) == 1119884478) strcat(s, "a");
if (crc32("KKacjwSW",8) == 727667265) strcat(s, "o");
if (crc32("sKxsglKbKrYfTsL",15) == 1553218173) strcat(s, "b");
if (crc32("RBpTLp",6) == 3740554419) strcat(s, "f");
if (crc32("cMPfbgDDh",9) == 703321827) strcat(s, "f");
if (crc32("NIiuOlZabrGAo",13) == 2133882447) strcat(s, "i");
if (crc32("vapBACb",7) == 268660140) strcat(s, "c");
if (crc32("aepNJ",5) == 3263827076) strcat(s, "i");
if (crc32("gZiQIRwyDBx",11) == 4076886907) strcat(s, "a");
if (crc32("hxyyPOZCmhCDVbD",15) == 454686297) strcat(s, "t");
if (crc32("KkvhZmtKVEulQ",13) == 2340330420) strcat(s, "o");
if (crc32("knpVmBg",7) == 1610717429) strcat(s, "i");
if (crc32("HUSiCCv",7) == 2679671776) strcat(s, "o");
if (crc32("cyzdOZDfVwzlm",13) == 1023298846) strcat(s, "z");
if (crc32("TSfnzRGwTz",10) == 79102300) strcat(s, "n");
    return s;
}

char *geriatrist_nouns() {
    char *s = calloc(11);
    if (crc32("cNhpVpcZKd",10) == 310620052) strcat(s, "g");
if (crc32("QxdzpyhjbXQJ",12) == 3793457711) strcat(s, "M");
if (crc32("sccLKJQlPWQ",11) == 875393702) strcat(s, "e");
if (crc32("JDboKPq",7) == 3295260179) strcat(s, "K");
if (crc32("XYtjizNXKXd",11) == 419493997) strcat(s, "r");
if (crc32("jeFsWC",6) == 3147333619) strcat(s, "i");
if (crc32("DMlrEHCa",8) == 2177969719) strcat(s, "I");
if (crc32("xWzVoqKRr",9) == 3807805873) strcat(s, "a");
if (crc32("UKSIAZiIVaNvH",13) == 2903175580) strcat(s, "t");
if (crc32("eggGtifdYTPpBI",14) == 3678576076) strcat(s, "r");
if (crc32("VycjslKnQQvSRTB",15) == 3205463236) strcat(s, "i");
if (crc32("tjGZrgpTkT",10) == 4142218565) strcat(s, "s");
if (crc32("raaDLLC",7) == 3776525654) strcat(s, "U");
if (crc32("xOXsivgbpjNHpe",14) == 1754174683) strcat(s, "t");
    return s;
}

char *Adamas_nouns() {
    char *s = calloc(7);
    if (crc32("NajHEokwr",9) == 1232346168) strcat(s, "A");
if (crc32("JmgwkQXNt",9) == 2013520242) strcat(s, "d");
if (crc32("tJyMZ",5) == 2878395190) strcat(s, "a");
if (crc32("eVnIkDwrLgAoPV",14) == 1624205262) strcat(s, "m");
if (crc32("KwCvh",5) == 3434920046) strcat(s, "i");
if (crc32("lXuhEXplLHtKBU",14) == 1920900676) strcat(s, "a");
if (crc32("zKvtXRuupGWdJK",14) == 3870365636) strcat(s, "a");
if (crc32("NFTfgFlNtNHfo",13) == 3402726403) strcat(s, "s");
    return s;
}

char *Oman_nouns() {
    char *s = calloc(5);
    if (crc32("kkaeRnriUgUShJW",15) == 3782192221) strcat(s, "O");
if (crc32("mJOgjNUYolA",11) == 459312101) strcat(s, "V");
if (crc32("ZttfOoxptC",10) == 2602507845) strcat(s, "m");
if (crc32("qxihOIDz",8) == 715524968) strcat(s, "j");
if (crc32("wCfsByQAV",9) == 2182697777) strcat(s, "a");
if (crc32("BEHazucQ",8) == 1542727070) strcat(s, "n");
    return s;
}

char *Buehrer_nouns() {
    char *s = calloc(8);
    if (crc32("OBtCBIXKMRO",11) == 389858569) strcat(s, "B");
if (crc32("ifrtEJS",7) == 3020248705) strcat(s, "u");
if (crc32("FlcQOvgSa",9) == 438217100) strcat(s, "u");
if (crc32("mPLrRZjVONCm",12) == 821806919) strcat(s, "e");
if (crc32("SIkGh",5) == 3881714136) strcat(s, "h");
if (crc32("SJCSBcIWJ",9) == 996959025) strcat(s, "X");
if (crc32("oAiMSpTbc",9) == 3510968832) strcat(s, "r");
if (crc32("rHgVofDyLmCjgc",14) == 26815865) strcat(s, "e");
if (crc32("bXCIaIJ",7) == 3752102292) strcat(s, "X");
if (crc32("rxUWpQetG",9) == 1075536517) strcat(s, "r");
    return s;
}

char *sameness_nouns() {
    char *s = calloc(9);
    if (crc32("jHodRc",6) == 3242163848) strcat(s, "W");
if (crc32("wqgpAhncI",9) == 3483032953) strcat(s, "s");
if (crc32("kJKpggNRn",9) == 3450062750) strcat(s, "B");
if (crc32("ICTqEBWGCJdw",12) == 3162465394) strcat(s, "a");
if (crc32("nBxnVVGUqTPRINy",15) == 1626581883) strcat(s, "K");
if (crc32("RoUuHunUpHaNO",13) == 1159960556) strcat(s, "m");
if (crc32("pUWHJker",8) == 2274750100) strcat(s, "X");
if (crc32("zwgPpTYLZ",9) == 1848404502) strcat(s, "e");
if (crc32("xYDmfEXAVkIh",12) == 1497317924) strcat(s, "W");
if (crc32("damtRpweUoYF",12) == 3213710616) strcat(s, "n");
if (crc32("tmeIeQb",7) == 17369070) strcat(s, "k");
if (crc32("SjSGIweKDi",10) == 2433265731) strcat(s, "e");
if (crc32("vamuaOrokNaILx",14) == 4266516062) strcat(s, "s");
if (crc32("eBBaGVAFnKeiKDd",15) == 236333531) strcat(s, "s");
    return s;
}

char *attribution_nouns() {
    char *s = calloc(12);
    if (crc32("WvQhkvqGrDIb",12) == 2298124644) strcat(s, "a");
if (crc32("gTOFhebZa",9) == 4029491709) strcat(s, "t");
if (crc32("VBHPfEiHXlbx",12) == 3279923309) strcat(s, "r");
if (crc32("pvrlln",6) == 801868714) strcat(s, "t");
if (crc32("acFYP",5) == 1072084886) strcat(s, "r");
if (crc32("vfDRvNc",7) == 4169229721) strcat(s, "Y");
if (crc32("eJsvzdKwfA",10) == 3678649949) strcat(s, "i");
if (crc32("PfiStHLlRSfZA",13) == 985356404) strcat(s, "b");
if (crc32("vNWWUbpzJHePa",13) == 2823929019) strcat(s, "b");
if (crc32("iiHAuDxEwMQtmP",14) == 1028360505) strcat(s, "b");
if (crc32("jLWWylVt",8) == 3496592678) strcat(s, "u");
if (crc32("HPMsHpYsf",9) == 3189597650) strcat(s, "t");
if (crc32("oqAwVRnPHJvLiR",14) == 2365704001) strcat(s, "G");
if (crc32("wGlqhwzDjrGwOD",14) == 744831520) strcat(s, "i");
if (crc32("cxTMbQlLXQlMxAH",15) == 1568003493) strcat(s, "B");
if (crc32("LqbZrDGyovcv",12) == 1063243455) strcat(s, "o");
if (crc32("XbIttloEgan",11) == 3254684852) strcat(s, "E");
if (crc32("JvqRKDxDzI",10) == 4131384785) strcat(s, "n");
    return s;
}

char *contg_nouns() {
    char *s = calloc(6);
    if (crc32("OgtJqZPQwvHSOu",14) == 2410625017) strcat(s, "c");
if (crc32("qCngkFJSQHADPr",14) == 1467229925) strcat(s, "D");
if (crc32("QHZMKdVlShWhf",13) == 3391109119) strcat(s, "o");
if (crc32("nKgFqhcrDIsyjG",14) == 3775334908) strcat(s, "n");
if (crc32("rvqcJEFUbzDD",12) == 789997164) strcat(s, "V");
if (crc32("pOLZRponyFQ",11) == 2563305442) strcat(s, "t");
if (crc32("MNlpDNONCsufxa",14) == 660832179) strcat(s, "e");
if (crc32("FBpJyyM",7) == 1491910785) strcat(s, "g");
    return s;
}

char *Passover_nouns() {
    char *s = calloc(9);
    if (crc32("oZGmqjDaqOaf",12) == 1704840497) strcat(s, "P");
if (crc32("eZhckdaFS",9) == 1910688021) strcat(s, "f");
if (crc32("uecDriSiMMrFs",13) == 2605273270) strcat(s, "a");
if (crc32("qQGDlEAyGfJUOXO",15) == 655769528) strcat(s, "s");
if (crc32("KYWlAaxuNGcEL",13) == 3884642678) strcat(s, "t");
if (crc32("oDrhMWlN",8) == 1805933755) strcat(s, "s");
if (crc32("LOOnOezkllT",11) == 1889128068) strcat(s, "e");
if (crc32("bCJFGSF",7) == 3746155534) strcat(s, "o");
if (crc32("WcMPvzvqMvBZz",13) == 3091666141) strcat(s, "c");
if (crc32("uudxVNPSMckWm",13) == 2395869768) strcat(s, "v");
if (crc32("rgbTJNuLn",9) == 2754660473) strcat(s, "e");
if (crc32("COsXtZiIqDBLjn",14) == 4049006251) strcat(s, "r");
    return s;
}

char *Prissie_nouns() {
    char *s = calloc(8);
    if (crc32("FTtEq",5) == 2303614341) strcat(s, "T");
if (crc32("fVJMBR",6) == 335399962) strcat(s, "P");
if (crc32("vXkPLcxf",8) == 2640541075) strcat(s, "r");
if (crc32("gxvmUcQlBF",10) == 2256449305) strcat(s, "h");
if (crc32("EtvfEtRGlhfutz",14) == 1057602126) strcat(s, "i");
if (crc32("ZouwdoADd",9) == 2908820371) strcat(s, "S");
if (crc32("BFQqbxZmGuVx",12) == 1330015816) strcat(s, "s");
if (crc32("CNNCTDE",7) == 1252619023) strcat(s, "s");
if (crc32("anYqnRW",7) == 142786406) strcat(s, "m");
if (crc32("IWHklNKyDimw",12) == 2611926773) strcat(s, "i");
if (crc32("ahgTwNh",7) == 1197134724) strcat(s, "e");
    return s;
}

char *nontransferability_nouns() {
    char *s = calloc(19);
    if (crc32("gNkIZOgUaBV",11) == 3720864039) strcat(s, "n");
if (crc32("GzGwka",6) == 4215054058) strcat(s, "o");
if (crc32("vPjSfbZKPkLJXP",14) == 2458500353) strcat(s, "n");
if (crc32("ZgPPQwKeTll",11) == 3011422034) strcat(s, "t");
if (crc32("PDobxIx",7) == 2243597581) strcat(s, "r");
if (crc32("GjGGWNJLfxq",11) == 1468371597) strcat(s, "a");
if (crc32("pMzussbW",8) == 4208725841) strcat(s, "n");
if (crc32("ghKIZD",6) == 3971829496) strcat(s, "R");
if (crc32("EMJQHyGMz",9) == 425441806) strcat(s, "s");
if (crc32("oNzLAdeISfFvTD",14) == 4070573877) strcat(s, "C");
if (crc32("TfUbV",5) == 2856855414) strcat(s, "f");
if (crc32("WgOkUFVr",8) == 4157752271) strcat(s, "k");
if (crc32("RUuaFgmTn",9) == 2667793824) strcat(s, "e");
if (crc32("jlCdcpWsiq",10) == 2735853290) strcat(s, "r");
if (crc32("WkZqcqsqbDjw",12) == 2870626854) strcat(s, "H");
if (crc32("QxbaqHX",7) == 2549356598) strcat(s, "a");
if (crc32("XLnwQuTPEllSLU",14) == 2976874382) strcat(s, "b");
if (crc32("qDZYneYt",8) == 2222867429) strcat(s, "i");
if (crc32("IJnOI",5) == 1572878760) strcat(s, "l");
if (crc32("pmKDfeUvZkuth",13) == 1318335852) strcat(s, "c");
if (crc32("hlVhbN",6) == 1739200908) strcat(s, "i");
if (crc32("lMFDPnTtv",9) == 666769527) strcat(s, "t");
if (crc32("hOvqWYiAam",10) == 1554656804) strcat(s, "y");
    return s;
}

char *gossipiness_nouns() {
    char *s = calloc(12);
    if (crc32("hzHRlB",6) == 3153693650) strcat(s, "w");
if (crc32("zSeowKaOb",9) == 3803080263) strcat(s, "g");
if (crc32("KFGjitdkWF",10) == 2649507277) strcat(s, "o");
if (crc32("pMTroHhik",9) == 1478165441) strcat(s, "s");
if (crc32("yzTbhxdJFusQu",13) == 4127394077) strcat(s, "s");
if (crc32("EvVGa",5) == 4124640618) strcat(s, "i");
if (crc32("bLiPp",5) == 1895926397) strcat(s, "k");
if (crc32("EHVRi",5) == 3695437022) strcat(s, "p");
if (crc32("zWaipPIGRQ",10) == 3283700251) strcat(s, "K");
if (crc32("IsqGwuslG",9) == 2398198826) strcat(s, "i");
if (crc32("TxCSE",5) == 1086758516) strcat(s, "n");
if (crc32("wNRcSfXiIw",10) == 1981788996) strcat(s, "e");
if (crc32("jntcCcI",7) == 2526629588) strcat(s, "s");
if (crc32("yyGidLtDLFAfMM",14) == 3633472986) strcat(s, "x");
if (crc32("IlqKdtRHf",9) == 1197091022) strcat(s, "s");
    return s;
}

char *Obel_nouns() {
    char *s = calloc(5);
    if (crc32("BvKPHmMqmsvQqBJ",15) == 2768826180) strcat(s, "O");
if (crc32("qWfdsVQgjaHA",12) == 3794165574) strcat(s, "b");
if (crc32("sslGcfKD",8) == 141374700) strcat(s, "e");
if (crc32("HKobTjJxD",9) == 1465583111) strcat(s, "S");
if (crc32("atnOjiIYA",9) == 550070035) strcat(s, "l");
    return s;
}

char *Seligman_nouns() {
    char *s = calloc(9);
    if (crc32("PHSEgik",7) == 2903250503) strcat(s, "S");
if (crc32("UJJRvPT",7) == 3083103230) strcat(s, "e");
if (crc32("LJkIWy",6) == 2488594202) strcat(s, "l");
if (crc32("uXLnvLZuUb",10) == 2150432335) strcat(s, "g");
if (crc32("DCpiLGkuPxwE",12) == 1512826750) strcat(s, "i");
if (crc32("ugcKqibeaiK",11) == 1343913086) strcat(s, "g");
if (crc32("EiEzQqK",7) == 2321668315) strcat(s, "m");
if (crc32("WkjiNHj",7) == 3449635016) strcat(s, "X");
if (crc32("SyIhT",5) == 298807069) strcat(s, "a");
if (crc32("rsjiTHZUUHxnBU",14) == 2029910637) strcat(s, "J");
if (crc32("pCBfXb",6) == 153779959) strcat(s, "n");
    return s;
}

char *distrainment_nouns() {
    char *s = calloc(13);
    if (crc32("bWqrEVVGbmQA",12) == 2814350851) strcat(s, "C");
if (crc32("tzhbSla",7) == 2325275497) strcat(s, "d");
if (crc32("vjjLp",5) == 2913127126) strcat(s, "i");
if (crc32("cuLFfv",6) == 811717946) strcat(s, "O");
if (crc32("fJTwE",5) == 696521195) strcat(s, "s");
if (crc32("pPBuoF",6) == 1183766380) strcat(s, "f");
if (crc32("BDeTbTDzh",9) == 3013360457) strcat(s, "t");
if (crc32("igOiwbIlxm",10) == 2651365482) strcat(s, "r");
if (crc32("lQbZNywRKYR",11) == 1372586870) strcat(s, "a");
if (crc32("HerlU",5) == 2609648415) strcat(s, "K");
if (crc32("uWAXOfCUOQXw",12) == 1571150100) strcat(s, "i");
if (crc32("wfXNOrGbQJZSSCO",15) == 4174155705) strcat(s, "n");
if (crc32("USkQWHzaEv",10) == 4290552646) strcat(s, "m");
if (crc32("fplVteusR",9) == 537280771) strcat(s, "e");
if (crc32("yipYjGxUejlsVt",14) == 1751952860) strcat(s, "I");
if (crc32("dXztovLxnMRG",12) == 706570664) strcat(s, "n");
if (crc32("ZxtjIyHsXNDUD",13) == 535006209) strcat(s, "t");
    return s;
}

char *sloppiness_nouns() {
    char *s = calloc(11);
    if (crc32("QDGGvVupbTFiCol",15) == 508251738) strcat(s, "m");
if (crc32("jJern",5) == 404127304) strcat(s, "s");
if (crc32("EcrDWsUomaHrse",14) == 3682709813) strcat(s, "l");
if (crc32("avBLVuJQbmnb",12) == 1155621557) strcat(s, "E");
if (crc32("GMaHZOczYjLh",12) == 3738864144) strcat(s, "o");
if (crc32("aHCuaSFSmU",10) == 182575310) strcat(s, "j");
if (crc32("xIXAnddd",8) == 2435020459) strcat(s, "p");
if (crc32("YTJNSRuuSNpx",12) == 2580562062) strcat(s, "N");
if (crc32("jbarLfLhYuKH",12) == 2571175163) strcat(s, "p");
if (crc32("oZSXOZx",7) == 83417454) strcat(s, "n");
if (crc32("XQMxNJfKFaFo",12) == 2030782703) strcat(s, "i");
if (crc32("MOhKF",5) == 3405654077) strcat(s, "T");
if (crc32("DgatWJPF",8) == 1204649241) strcat(s, "n");
if (crc32("THuYWdsw",8) == 2117186254) strcat(s, "e");
if (crc32("GinKwVnmuEbPyp",14) == 3941139900) strcat(s, "s");
if (crc32("LZyOtiFaXbnnlor",15) == 565222735) strcat(s, "e");
if (crc32("dIQJgbQYE",9) == 1085887897) strcat(s, "s");
    return s;
}

char *overzealousness_nouns() {
    char *s = calloc(16);
    if (crc32("tVILxjHuZBxhA",13) == 1045669895) strcat(s, "Y");
if (crc32("CwGUsdEF",8) == 766819782) strcat(s, "o");
if (crc32("rLlqrqMMBNUQO",13) == 4245229659) strcat(s, "v");
if (crc32("xLgnzS",6) == 146416613) strcat(s, "e");
if (crc32("lnWBtBh",7) == 2322862281) strcat(s, "r");
if (crc32("uFWHv",5) == 2707076722) strcat(s, "z");
if (crc32("rcemTpZIIql",11) == 4017047327) strcat(s, "e");
if (crc32("XutYdldSPf",10) == 1717151194) strcat(s, "a");
if (crc32("iNELvsq",7) == 2225992341) strcat(s, "l");
if (crc32("EGZHJvrfcKyY",12) == 963754317) strcat(s, "o");
if (crc32("vdxol",5) == 3631635101) strcat(s, "N");
if (crc32("iXLAXICyvOANA",13) == 474348875) strcat(s, "u");
if (crc32("oRIjeByUobwfq",13) == 182329124) strcat(s, "s");
if (crc32("CucUqzPhQ",9) == 511663198) strcat(s, "n");
if (crc32("pQrJGjAgHfLi",12) == 2516024505) strcat(s, "F");
if (crc32("kKDNAIW",7) == 35011493) strcat(s, "e");
if (crc32("MVqMiis",7) == 3034386682) strcat(s, "L");
if (crc32("AmqFvu",6) == 3942295262) strcat(s, "s");
if (crc32("rdnhBsrDhzw",11) == 374970221) strcat(s, "s");
    return s;
}

char *teiglach_nouns() {
    char *s = calloc(9);
    if (crc32("gitGltkq",8) == 1480707970) strcat(s, "t");
if (crc32("oPPGnovvyK",10) == 1308225919) strcat(s, "e");
if (crc32("MhBEISWZL",9) == 2622336603) strcat(s, "i");
if (crc32("JazeECixaRXc",12) == 2147015243) strcat(s, "g");
if (crc32("TkXpbI",6) == 3401323026) strcat(s, "l");
if (crc32("QSTWY",5) == 3137188641) strcat(s, "q");
if (crc32("rzJHOpih",8) == 1709172188) strcat(s, "a");
if (crc32("roeEZvO",7) == 1235580590) strcat(s, "q");
if (crc32("bvHFr",5) == 220530843) strcat(s, "c");
if (crc32("mVJYtmGC",8) == 28742766) strcat(s, "h");
    return s;
}

char *verist_nouns() {
    char *s = calloc(7);
    if (crc32("huqhIhQG",8) == 1988053246) strcat(s, "x");
if (crc32("DCjKbWRNqKJpOe",14) == 2077181391) strcat(s, "v");
if (crc32("tSZJR",5) == 4245695855) strcat(s, "e");
if (crc32("kIhLHkHS",8) == 2423585281) strcat(s, "r");
if (crc32("aUfRouR",7) == 3499663533) strcat(s, "W");
if (crc32("jXBBzxBso",9) == 2406172575) strcat(s, "i");
if (crc32("GsUXutLfQ",9) == 1815159050) strcat(s, "s");
if (crc32("ugdaKzre",8) == 3440811358) strcat(s, "t");
    return s;
}

char *nonperceptibility_nouns() {
    char *s = calloc(18);
    if (crc32("dPfoDJxXLJ",10) == 677652143) strcat(s, "h");
if (crc32("qJmvhFrszeZUm",13) == 102966404) strcat(s, "n");
if (crc32("cNXmZLOeJnO",11) == 2720880127) strcat(s, "B");
if (crc32("qqSSFDqmon",10) == 2078074124) strcat(s, "o");
if (crc32("ePjyXnsOSaIDW",13) == 1552304589) strcat(s, "p");
if (crc32("Fsqvdbe",7) == 2552899939) strcat(s, "n");
if (crc32("MYkaT",5) == 2217132039) strcat(s, "p");
if (crc32("UbcPgNgRHnyvW",13) == 3236461411) strcat(s, "e");
if (crc32("xWFNYOSlalsISI",14) == 1837974302) strcat(s, "f");
if (crc32("zmVaDcsAyGOssMN",15) == 2917638025) strcat(s, "r");
if (crc32("GVXwvsxP",8) == 3237689755) strcat(s, "c");
if (crc32("ooTjTazLZ",9) == 3538986332) strcat(s, "c");
if (crc32("WKxPBcoiOKK",11) == 3790717477) strcat(s, "v");
if (crc32("wwfDb",5) == 13331968) strcat(s, "e");
if (crc32("SyrfDikosP",10) == 3489670756) strcat(s, "p");
if (crc32("cPHvhqjwEmDj",12) == 742972145) strcat(s, "p");
if (crc32("gCeOLjLZSFpAB",13) == 3691963906) strcat(s, "k");
if (crc32("IjADXM",6) == 1680041438) strcat(s, "t");
if (crc32("baCTAfsaueRbt",13) == 3194869325) strcat(s, "i");
if (crc32("GvFEhV",6) == 839898044) strcat(s, "b");
if (crc32("CjEvtgqhEI",10) == 3725269013) strcat(s, "s");
if (crc32("RagMlsMVXYbFeV",14) == 3751884517) strcat(s, "i");
if (crc32("MJBYW",5) == 2139138136) strcat(s, "l");
if (crc32("mUofSwfAa",9) == 3815172754) strcat(s, "i");
if (crc32("ALlUtnmrHCO",11) == 2467822095) strcat(s, "r");
if (crc32("lLexbEdcg",9) == 2171829779) strcat(s, "t");
if (crc32("bDEZwN",6) == 4294147876) strcat(s, "p");
if (crc32("txvvaa",6) == 2963842544) strcat(s, "y");
    return s;
}

char *Saltsman_nouns() {
    char *s = calloc(9);
    if (crc32("TlPlmBQMSLSbR",13) == 3132072046) strcat(s, "S");
if (crc32("ajWMUVTNyCUI",12) == 809363345) strcat(s, "M");
if (crc32("OYrZJ",5) == 732748227) strcat(s, "a");
if (crc32("LyucYYNB",8) == 3302824956) strcat(s, "l");
if (crc32("BnuXSmNU",8) == 1792215798) strcat(s, "t");
if (crc32("oEJVdjHloehiln",14) == 2815187610) strcat(s, "S");
if (crc32("BkoeEHpSgDpb",12) == 3716790531) strcat(s, "s");
if (crc32("zRCUgYMvDZbOz",13) == 609969513) strcat(s, "q");
if (crc32("WABinPLierX",11) == 1312128051) strcat(s, "m");
if (crc32("sQhzWQQn",8) == 2811530646) strcat(s, "a");
if (crc32("RdMmiYALhmAWsC",14) == 381907379) strcat(s, "y");
if (crc32("vqqRIs",6) == 4228345837) strcat(s, "n");
    return s;
}

char *hamperer_nouns() {
    char *s = calloc(9);
    if (crc32("syrVBKxU",8) == 2122444369) strcat(s, "h");
if (crc32("dHVjJpU",7) == 185875596) strcat(s, "H");
if (crc32("KXRtcRDC",8) == 1905291753) strcat(s, "a");
if (crc32("wLfFMh",6) == 1443014685) strcat(s, "m");
if (crc32("rFwdxHYHGlE",11) == 1444642414) strcat(s, "N");
if (crc32("ZmEzIV",6) == 728399050) strcat(s, "p");
if (crc32("SRhJQZS",7) == 1286926442) strcat(s, "e");
if (crc32("SUMSVnpxwMys",12) == 2718879729) strcat(s, "O");
if (crc32("MWYMmYZTWhG",11) == 2595843592) strcat(s, "r");
if (crc32("mCADqooSzW",10) == 2242718905) strcat(s, "P");
if (crc32("XTlhb",5) == 3313186941) strcat(s, "e");
if (crc32("BLJHzY",6) == 588686209) strcat(s, "r");
    return s;
}

char *Diamox_nouns() {
    char *s = calloc(7);
    if (crc32("sTMLYa",6) == 2966811728) strcat(s, "D");
if (crc32("XSCNoUIqV",9) == 3090442451) strcat(s, "z");
if (crc32("xSYnPi",6) == 1402583486) strcat(s, "i");
if (crc32("oykjGVgqMo",10) == 4080496032) strcat(s, "a");
if (crc32("aDAEOdVcarKx",12) == 2821136117) strcat(s, "k");
if (crc32("tAmfP",5) == 4045097964) strcat(s, "m");
if (crc32("vGnnEBDOrCbX",12) == 1766597812) strcat(s, "o");
if (crc32("pzuVz",5) == 897163105) strcat(s, "x");
    return s;
}

char *firepower_nouns() {
    char *s = calloc(10);
    if (crc32("vTQiGC",6) == 2694505419) strcat(s, "F");
if (crc32("QDEAhWHFhQhxdK",14) == 85386253) strcat(s, "f");
if (crc32("DTqTrQfueiVZW",13) == 299283173) strcat(s, "w");
if (crc32("EFrPiQCfO",9) == 2852949563) strcat(s, "i");
if (crc32("lByGoJmxAtslx",13) == 4000278673) strcat(s, "E");
if (crc32("XcBgUOl",7) == 3731247915) strcat(s, "r");
if (crc32("YJDhapDEmU",10) == 1131060323) strcat(s, "C");
if (crc32("JCUzxKQDxykm",12) == 3340900367) strcat(s, "e");
if (crc32("YtBUQvG",7) == 2580645552) strcat(s, "p");
if (crc32("yCfaDUBHNy",10) == 1493301399) strcat(s, "o");
if (crc32("VtskZTGXSXWAs",13) == 1652253190) strcat(s, "K");
if (crc32("ixTolnsoHi",10) == 1181384354) strcat(s, "w");
if (crc32("JQKfRviwBEnmx",13) == 2051482032) strcat(s, "e");
if (crc32("GZgeLXAmaT",10) == 2022609818) strcat(s, "r");
    return s;
}

char *Bennu_nouns() {
    char *s = calloc(6);
    if (crc32("LZygvhWYBcYZ",12) == 2337689561) strcat(s, "B");
if (crc32("PIfkm",5) == 3783079802) strcat(s, "e");
if (crc32("nFulIgwpwirXsf",14) == 2791759024) strcat(s, "x");
if (crc32("HZtUVEUJALvhz",13) == 1773287976) strcat(s, "n");
if (crc32("XRmlBszjHQPgy",13) == 2432723760) strcat(s, "h");
if (crc32("nKGaxLbxOklU",12) == 1570575329) strcat(s, "n");
if (crc32("nuIxeoXAX",9) == 2081466760) strcat(s, "u");
    return s;
}

char *Hardi_nouns() {
    char *s = calloc(6);
    if (crc32("aIKAdwOUlnBFsT",14) == 368221532) strcat(s, "H");
if (crc32("riAkyQ",6) == 806716856) strcat(s, "E");
if (crc32("RlfdyJIsJPh",11) == 2228441608) strcat(s, "a");
if (crc32("nqYucGBLn",9) == 2725877601) strcat(s, "r");
if (crc32("QlILRpPQCyJpT",13) == 4228950716) strcat(s, "d");
if (crc32("XIiKZXK",7) == 2406550824) strcat(s, "i");
    return s;
}

char *unit_nouns() {
    char *s = calloc(5);
    if (crc32("IROUbxOR",8) == 3490603841) strcat(s, "u");
if (crc32("BSbDFujz",8) == 930025310) strcat(s, "n");
if (crc32("ZMNur",5) == 1270390270) strcat(s, "i");
if (crc32("JZMIpWMQ",8) == 3884473532) strcat(s, "t");
    return s;
}

char *argot_nouns() {
    char *s = calloc(6);
    if (crc32("NoirIngUlID",11) == 4102763558) strcat(s, "a");
if (crc32("RhteEJOQKjg",11) == 2647158007) strcat(s, "r");
if (crc32("mvNYTjRvoX",10) == 2995682246) strcat(s, "R");
if (crc32("PYQzXASk",8) == 3337540874) strcat(s, "g");
if (crc32("qspLFZQp",8) == 257469271) strcat(s, "V");
if (crc32("TsCqtv",6) == 3054038034) strcat(s, "o");
if (crc32("gYPWqXqvNVMuLb",14) == 441758530) strcat(s, "q");
if (crc32("WOSstChLMXECv",13) == 3045030279) strcat(s, "t");
    return s;
}

char *cannelure_nouns() {
    char *s = calloc(10);
    if (crc32("QGbqaQaUw",9) == 2278985319) strcat(s, "Y");
if (crc32("OHZnlXqhtrfF",12) == 2387347790) strcat(s, "c");
if (crc32("wBNpjrMljXMF",12) == 3967269361) strcat(s, "a");
if (crc32("EOgLbQkYuAS",11) == 792672248) strcat(s, "n");
if (crc32("bbOyDpOiraSjrf",14) == 1984438468) strcat(s, "z");
if (crc32("YSwUb",5) == 525806939) strcat(s, "n");
if (crc32("hkcJtOleXFao",12) == 2784704925) strcat(s, "u");
if (crc32("RVFXhTPpdEv",11) == 3553139321) strcat(s, "e");
if (crc32("UQnxIb",6) == 3262076809) strcat(s, "G");
if (crc32("vqMqkWQD",8) == 1706290567) strcat(s, "l");
if (crc32("rHtgAmkr",8) == 481776455) strcat(s, "u");
if (crc32("WwtksDK",7) == 455793354) strcat(s, "O");
if (crc32("JqTUtuClyQO",11) == 1192989274) strcat(s, "r");
if (crc32("YCkBMvjd",8) == 1169873204) strcat(s, "b");
if (crc32("FsOoVXZTZA",10) == 1753075294) strcat(s, "e");
    return s;
}

char *Rayle_nouns() {
    char *s = calloc(6);
    if (crc32("tkgEsn",6) == 2146135449) strcat(s, "u");
if (crc32("WPzNY",5) == 2721549625) strcat(s, "R");
if (crc32("xRrMIGmeoJWIQhK",15) == 3590699752) strcat(s, "a");
if (crc32("xbQqLwAKEGlxdY",14) == 856416546) strcat(s, "Q");
if (crc32("eIyOZFrkrFpwr",13) == 4246704083) strcat(s, "y");
if (crc32("AJQVHS",6) == 469186691) strcat(s, "H");
if (crc32("TultjCiHrS",10) == 399702140) strcat(s, "l");
if (crc32("FrvolTDzXvy",11) == 3575404587) strcat(s, "n");
if (crc32("QgfjHmqEXzXE",12) == 3543103762) strcat(s, "e");
    return s;
}

char *hemosiderin_nouns() {
    char *s = calloc(12);
    if (crc32("dCopWPYhJMKrRp",14) == 2325778573) strcat(s, "D");
if (crc32("EcJlgdSE",8) == 839901456) strcat(s, "h");
if (crc32("UJbMTJxrxkldZ",13) == 1509822145) strcat(s, "l");
if (crc32("SJKMlsHNJPyxP",13) == 730880585) strcat(s, "e");
if (crc32("qXOVAKktbAsm",12) == 87880496) strcat(s, "y");
if (crc32("AHQvzF",6) == 1961320990) strcat(s, "m");
if (crc32("hDKbC",5) == 818912510) strcat(s, "J");
if (crc32("jmEmVgC",7) == 4073166846) strcat(s, "o");
if (crc32("hUUtGxFuHy",10) == 3251684189) strcat(s, "x");
if (crc32("bwJXiMvyYnytzkB",15) == 2894473547) strcat(s, "s");
if (crc32("pkqCWLAW",8) == 3481445908) strcat(s, "z");
if (crc32("kOMNQecIV",9) == 950349965) strcat(s, "i");
if (crc32("meiWr",5) == 2811193596) strcat(s, "d");
if (crc32("BYUthTuIHiicCwZ",15) == 2779152691) strcat(s, "e");
if (crc32("LXVzUqetBG",10) == 174966749) strcat(s, "a");
if (crc32("qeScGAczghDw",12) == 2484320955) strcat(s, "r");
if (crc32("WtLKMMQuBiTjt",13) == 1645474950) strcat(s, "i");
if (crc32("acOvCvsVYOZ",11) == 3433539296) strcat(s, "n");
    return s;
}

char *flyspeck_nouns() {
    char *s = calloc(9);
    if (crc32("ngORnhC",7) == 3893086266) strcat(s, "f");
if (crc32("lzRJTUKhXeKRp",13) == 3422900642) strcat(s, "l");
if (crc32("UDZtiGxVzz",10) == 2720322241) strcat(s, "S");
if (crc32("ZJeKswj",7) == 845403890) strcat(s, "y");
if (crc32("SqSBvFBlEEvM",12) == 2422371433) strcat(s, "Z");
if (crc32("gDKOMgaBicU",11) == 2666942646) strcat(s, "s");
if (crc32("TEFTrRrfQFv",11) == 1916952476) strcat(s, "p");
if (crc32("XLlLXk",6) == 3447508110) strcat(s, "u");
if (crc32("BDCbesTo",8) == 2373264093) strcat(s, "e");
if (crc32("szQBryj",7) == 3671374693) strcat(s, "c");
if (crc32("TiIBYVOUJLllSht",15) == 2643235485) strcat(s, "k");
    return s;
}

char *nonspinosity_nouns() {
    char *s = calloc(13);
    if (crc32("MXTtbfYF",8) == 384182310) strcat(s, "U");
if (crc32("wjTUbcWJCRu",11) == 2127465915) strcat(s, "n");
if (crc32("sWpjJHdGpcLynX",14) == 1277267792) strcat(s, "Z");
if (crc32("kgRaa",5) == 2807729933) strcat(s, "o");
if (crc32("WZACNgSOq",9) == 541555211) strcat(s, "n");
if (crc32("ZCCyPBvCA",9) == 3891157472) strcat(s, "y");
if (crc32("kaXzbIHLpbf",11) == 4170839701) strcat(s, "s");
if (crc32("WASMyhHqHBJJUxB",15) == 2703804719) strcat(s, "B");
if (crc32("oOpGMptsO",9) == 294578873) strcat(s, "p");
if (crc32("xVtZOVXJzHCWY",13) == 2294284508) strcat(s, "i");
if (crc32("dBIdQSFzkVzViB",14) == 4211197534) strcat(s, "n");
if (crc32("SSsHqRP",7) == 3370605923) strcat(s, "J");
if (crc32("gMRMQUNjdYMr",12) == 2327560366) strcat(s, "o");
if (crc32("QDPKQES",7) == 1719234661) strcat(s, "F");
if (crc32("ehnHmuLmPUq",11) == 2405343670) strcat(s, "s");
if (crc32("uygoK",5) == 2949924193) strcat(s, "i");
if (crc32("MfSeaVIJpD",10) == 1972934370) strcat(s, "X");
if (crc32("kktBX",5) == 820049294) strcat(s, "t");
if (crc32("kyggIoK",7) == 1693668091) strcat(s, "R");
if (crc32("auKzESdDeXWAaaM",15) == 584159367) strcat(s, "y");
    return s;
}

char *gerrymanderer_nouns() {
    char *s = calloc(14);
    if (crc32("TCFTxARCV",9) == 34557431) strcat(s, "g");
if (crc32("UfHGKEQENHlhKyy",15) == 3398295560) strcat(s, "e");
if (crc32("PidAAOoKeeoCS",13) == 886227057) strcat(s, "r");
if (crc32("HuWJcUaKDn",10) == 3566366726) strcat(s, "r");
if (crc32("lfmxM",5) == 3065422580) strcat(s, "r");
if (crc32("kotQXFKdygx",11) == 1900252912) strcat(s, "y");
if (crc32("jSIcjmtaUH",10) == 3975511910) strcat(s, "q");
if (crc32("XXVygPenR",9) == 359679218) strcat(s, "m");
if (crc32("WYAOoEDZnDl",11) == 4289192968) strcat(s, "a");
if (crc32("jHgxppMdTIqN",12) == 2924693366) strcat(s, "n");
if (crc32("qfcOINZVgOYGpu",14) == 3783224712) strcat(s, "d");
if (crc32("ESUnOGrWnPh",11) == 4113147602) strcat(s, "K");
if (crc32("KstxVKEajoYwwso",15) == 4007794477) strcat(s, "e");
if (crc32("qRONUMmnlinS",12) == 3242090411) strcat(s, "d");
if (crc32("iAZmLS",6) == 2981837114) strcat(s, "r");
if (crc32("lMUJFhXAQM",10) == 683040828) strcat(s, "L");
if (crc32("RGidXaSmF",9) == 3193014042) strcat(s, "e");
if (crc32("YZgGBdPGibbG",12) == 2684706098) strcat(s, "X");
if (crc32("yrwqqcbarafU",12) == 209340623) strcat(s, "r");
    return s;
}

char *yarraman_nouns() {
    char *s = calloc(9);
    if (crc32("lRVrV",5) == 1657199439) strcat(s, "M");
if (crc32("OIipHcKRXExZQbT",15) == 1660054724) strcat(s, "y");
if (crc32("HZVTIxLETmYYjOk",15) == 369190449) strcat(s, "Y");
if (crc32("WfbYyg",6) == 1766983666) strcat(s, "a");
if (crc32("ejQjpDGuNU",10) == 1067865591) strcat(s, "b");
if (crc32("bXQouep",7) == 488328547) strcat(s, "r");
if (crc32("muCBLThxneGKO",13) == 864337315) strcat(s, "r");
if (crc32("tqLbHexSziSMB",13) == 771352641) strcat(s, "a");
if (crc32("WCzeRqro",8) == 1081753147) strcat(s, "m");
if (crc32("sbyWAh",6) == 172604140) strcat(s, "a");
if (crc32("nQWwej",6) == 643978422) strcat(s, "s");
if (crc32("CQMVQaEC",8) == 460896519) strcat(s, "n");
    return s;
}

char *nat_nouns() {
    char *s = calloc(4);
    if (crc32("vZmuJKOPfFV",11) == 1402914201) strcat(s, "E");
if (crc32("jKAoaCrwgO",10) == 1642976943) strcat(s, "n");
if (crc32("euwWp",5) == 1062247412) strcat(s, "a");
if (crc32("QNFju",5) == 1949111615) strcat(s, "L");
if (crc32("BtvsKBnEPt",10) == 1692576127) strcat(s, "t");
    return s;
}

char *cyprinodont_nouns() {
    char *s = calloc(12);
    if (crc32("vEZVIc",6) == 2107616713) strcat(s, "x");
if (crc32("jeBELyS",7) == 292898639) strcat(s, "c");
if (crc32("sRfVcrzunaS",11) == 3530309620) strcat(s, "y");
if (crc32("hxbIp",5) == 762419938) strcat(s, "T");
if (crc32("FQCISAQBPWL",11) == 3592084868) strcat(s, "p");
if (crc32("jNkDaoE",7) == 557437704) strcat(s, "d");
if (crc32("JuuLKY",6) == 174636162) strcat(s, "r");
if (crc32("aWTHj",5) == 4053103304) strcat(s, "m");
if (crc32("EWdxRaydr",9) == 2425663170) strcat(s, "i");
if (crc32("NMQwwhCy",8) == 2993171297) strcat(s, "n");
if (crc32("CUzGurhNT",9) == 79514386) strcat(s, "w");
if (crc32("EfmpcCFahXzh",12) == 3818828067) strcat(s, "o");
if (crc32("ycSZycgsPShD",12) == 1711274435) strcat(s, "d");
if (crc32("VyYjHdLD",8) == 149789181) strcat(s, "F");
if (crc32("XgRLasMaFPbdva",14) == 2920991378) strcat(s, "o");
if (crc32("ocECCtexhCRH",12) == 633546969) strcat(s, "n");
if (crc32("ewxbOXJXjBb",11) == 1585099280) strcat(s, "p");
if (crc32("cWGKHIppshDsr",13) == 1413434451) strcat(s, "t");
    return s;
}

char *superbrain_nouns() {
    char *s = calloc(11);
    if (crc32("xRSXeanriO",10) == 3828147079) strcat(s, "s");
if (crc32("VJztRqLIeAN",11) == 112359646) strcat(s, "s");
if (crc32("gcxeKdFN",8) == 2273144822) strcat(s, "u");
if (crc32("gvoTMnAHRg",10) == 2995346128) strcat(s, "A");
if (crc32("eYpjDx",6) == 944508821) strcat(s, "p");
if (crc32("jpsWB",5) == 2804830861) strcat(s, "B");
if (crc32("wQgToJ",6) == 465497233) strcat(s, "e");
if (crc32("bbVOafGrPBTvOWG",15) == 3774622020) strcat(s, "g");
if (crc32("yudVUBgtrvs",11) == 2002782854) strcat(s, "r");
if (crc32("WBUfBceql",9) == 1319633095) strcat(s, "X");
if (crc32("cwHaaUgEL",9) == 1984109716) strcat(s, "b");
if (crc32("ZGtUfnXlXiL",11) == 931675895) strcat(s, "r");
if (crc32("erTlOLlsKTBT",12) == 1551440271) strcat(s, "a");
if (crc32("EkeaOPzU",8) == 1360437188) strcat(s, "b");
if (crc32("fOFPYr",6) == 2994560288) strcat(s, "i");
if (crc32("rXCPrOf",7) == 1448972868) strcat(s, "n");
    return s;
}

char *tenableness_nouns() {
    char *s = calloc(12);
    if (crc32("VXbzX",5) == 2231090639) strcat(s, "t");
if (crc32("tFxUkHSs",8) == 3075820860) strcat(s, "e");
if (crc32("AZCftWNd",8) == 1694854323) strcat(s, "r");
if (crc32("nqGgWpEU",8) == 1194813062) strcat(s, "n");
if (crc32("VtrCZMsTkjUREV",14) == 214347849) strcat(s, "B");
if (crc32("qzUDWCtBoPD",11) == 4196584482) strcat(s, "a");
if (crc32("rukGdGEYWl",10) == 4225230137) strcat(s, "r");
if (crc32("SWeLBweEchbksEV",15) == 3386990472) strcat(s, "b");
if (crc32("vnrLK",5) == 1804720650) strcat(s, "N");
if (crc32("LIWeZMhf",8) == 1608330372) strcat(s, "l");
if (crc32("pFIql",5) == 508751211) strcat(s, "K");
if (crc32("cQFKVPNeZHesL",13) == 1110449024) strcat(s, "e");
if (crc32("bFhoyutblDUr",12) == 1608415480) strcat(s, "S");
if (crc32("BqQXUUlZQNpJyu",14) == 4228210012) strcat(s, "n");
if (crc32("cxUmzVZr",8) == 1271692273) strcat(s, "e");
if (crc32("rOrmHeKywRIlFz",14) == 1999051924) strcat(s, "e");
if (crc32("GLfeHOGIgJzDOlO",15) == 1873986170) strcat(s, "s");
if (crc32("PbJlBRwnHe",10) == 3674239935) strcat(s, "V");
if (crc32("PQBPajaSfBY",11) == 2236333920) strcat(s, "s");
    return s;
}

char *proIsraeli_nouns() {
    char *s = calloc(11);
    if (crc32("fIUUyjNnWy",10) == 835457971) strcat(s, "p");
if (crc32("DCDAlc",6) == 1116075924) strcat(s, "p");
if (crc32("cihkNWh",7) == 1152082976) strcat(s, "f");
if (crc32("GCyEsjJRtMJPcpq",15) == 3823706538) strcat(s, "r");
if (crc32("QGZKXHfDVVlsZJv",15) == 371070480) strcat(s, "o");
if (crc32("aRAwPJLRTteALC",14) == 12984420) strcat(s, "t");
if (crc32("jPwcmDWlrHF",11) == 3746518005) strcat(s, "I");
if (crc32("vhQswqNRJnwXUIh",15) == 4185238612) strcat(s, "p");
if (crc32("tgxLJamUu",9) == 57297) strcat(s, "s");
if (crc32("oucgmfqbRk",10) == 16950778) strcat(s, "r");
if (crc32("YgUCKazAI",9) == 728268221) strcat(s, "D");
if (crc32("rQsIFnCvh",9) == 278770925) strcat(s, "a");
if (crc32("sOPlcaPmUwkFV",13) == 1903841273) strcat(s, "e");
if (crc32("FdbbN",5) == 673792092) strcat(s, "l");
if (crc32("rGxRKhabkNM",11) == 3840678282) strcat(s, "O");
if (crc32("igrrhky",7) == 1032049534) strcat(s, "i");
    return s;
}

char *misformation_nouns() {
    char *s = calloc(13);
    if (crc32("oTAht",5) == 3228175132) strcat(s, "d");
if (crc32("WcjAOCLMCpLJCqS",15) == 3060754219) strcat(s, "m");
if (crc32("cAkJZLRAQ",9) == 2029359038) strcat(s, "i");
if (crc32("tFFNC",5) == 2167878944) strcat(s, "s");
if (crc32("RilXV",5) == 1937294054) strcat(s, "f");
if (crc32("BYgThQZ",7) == 3855704783) strcat(s, "K");
if (crc32("hLzuvRnj",8) == 158986627) strcat(s, "o");
if (crc32("CLBHDXgPR",9) == 2654435698) strcat(s, "r");
if (crc32("DEusIDGoUpXBzm",14) == 2967699092) strcat(s, "F");
if (crc32("VZlKlMoLwQIvJB",14) == 3162563913) strcat(s, "m");
if (crc32("lJQBUyidVFJVrQC",15) == 2452072176) strcat(s, "a");
if (crc32("itYZJWYbRyz",11) == 3463750351) strcat(s, "Y");
if (crc32("UzYQZbIXapVlw",13) == 1677729771) strcat(s, "t");
if (crc32("LfiyCAruCJI",11) == 3969594607) strcat(s, "i");
if (crc32("ZCFEsct",7) == 2809352171) strcat(s, "i");
if (crc32("ksUsl",5) == 2066437422) strcat(s, "o");
if (crc32("WkFOarLvSFaME",13) == 1124357453) strcat(s, "n");
    return s;
}

char *uncoloredness_nouns() {
    char *s = calloc(14);
    if (crc32("DySHgGCFZSWqR",13) == 205905746) strcat(s, "x");
if (crc32("aeBUmyjC",8) == 4028963028) strcat(s, "u");
if (crc32("EuuSoBUVX",9) == 1806694306) strcat(s, "n");
if (crc32("ekJBcEtwz",9) == 781844469) strcat(s, "c");
if (crc32("NUEsieXan",9) == 1518563220) strcat(s, "o");
if (crc32("OkRgUpclmME",11) == 1467560387) strcat(s, "l");
if (crc32("jckXvjfXKjZfu",13) == 2119236192) strcat(s, "o");
if (crc32("YjMgvTHNX",9) == 247504388) strcat(s, "r");
if (crc32("CSRCdTgdVWSmjSJ",15) == 3773500627) strcat(s, "e");
if (crc32("bSwsTxuyoEQRp",13) == 544318372) strcat(s, "d");
if (crc32("tbEZGh",6) == 3310054556) strcat(s, "Y");
if (crc32("APMlfDOLYNOTvG",14) == 692680947) strcat(s, "n");
if (crc32("aXcdHm",6) == 401021615) strcat(s, "e");
if (crc32("qMgnOzgBSsBWEX",14) == 2242646095) strcat(s, "s");
if (crc32("SNpqSKTb",8) == 3174284191) strcat(s, "s");
    return s;
}

char *truckload_nouns() {
    char *s = calloc(10);
    if (crc32("wdDTbvMP",8) == 3370281247) strcat(s, "p");
if (crc32("iueExT",6) == 1581432455) strcat(s, "t");
if (crc32("vyhkw",5) == 804296271) strcat(s, "C");
if (crc32("LZMNocVjT",9) == 2735966373) strcat(s, "r");
if (crc32("gNXKpjTDp",9) == 2505441178) strcat(s, "u");
if (crc32("NlduveP",7) == 3048784654) strcat(s, "v");
if (crc32("EMrqvWGmdOWTj",13) == 3804590470) strcat(s, "c");
if (crc32("SfeHkzk",7) == 364660113) strcat(s, "k");
if (crc32("EFwrmlBfXJpvx",13) == 4261170322) strcat(s, "l");
if (crc32("tCXlKgiCYaoFh",13) == 976296107) strcat(s, "o");
if (crc32("aMQdX",5) == 38869730) strcat(s, "a");
if (crc32("OapkvNGhPJxnjrD",15) == 4203147528) strcat(s, "l");
if (crc32("HfMYvpjCb",9) == 3147806396) strcat(s, "d");
    return s;
}

char *Frenchman_nouns() {
    char *s = calloc(10);
    if (crc32("kujGytGwxBb",11) == 3648837224) strcat(s, "J");
if (crc32("jOayrGMAaZFLI",13) == 3653591410) strcat(s, "F");
if (crc32("UBxArlBRFW",10) == 2779847699) strcat(s, "u");
if (crc32("IDEHnMa",7) == 732858089) strcat(s, "r");
if (crc32("plDjJQ",6) == 1179960754) strcat(s, "N");
if (crc32("tVRPQhjj",8) == 1936196493) strcat(s, "e");
if (crc32("BhQOuEWzUNDmnJ",14) == 3605185310) strcat(s, "n");
if (crc32("HtgiLkUeMU",10) == 2136200433) strcat(s, "z");
if (crc32("huJhw",5) == 768185881) strcat(s, "c");
if (crc32("mlIPfBcGo",9) == 885469720) strcat(s, "y");
if (crc32("uKuaEMsRYLSJQZq",15) == 2771824120) strcat(s, "h");
if (crc32("SfxXWfFx",8) == 4287936499) strcat(s, "v");
if (crc32("xLAafMveDQ",10) == 12301692) strcat(s, "m");
if (crc32("jqPSzyxMaguM",12) == 3816997479) strcat(s, "a");
if (crc32("lnRTklJxcpHDrD",14) == 1561477198) strcat(s, "n");
    return s;
}

char *antepenult_nouns() {
    char *s = calloc(11);
    if (crc32("ganLzjnXixCC",12) == 3290730914) strcat(s, "e");
if (crc32("bSaiqvhdcymB",12) == 3445670317) strcat(s, "a");
if (crc32("tBcAUpEbA",9) == 819002976) strcat(s, "f");
if (crc32("XGyjHNonI",9) == 2029619830) strcat(s, "n");
if (crc32("hlMgNclLm",9) == 1451833552) strcat(s, "t");
if (crc32("KMaUraMS",8) == 952398121) strcat(s, "e");
if (crc32("NZMyHB",6) == 1679764315) strcat(s, "p");
if (crc32("ChBeYfoVYH",10) == 1565414542) strcat(s, "p");
if (crc32("YYlEOTWsWz",10) == 2681716450) strcat(s, "e");
if (crc32("NqReSewRAmbiMrr",15) == 600141394) strcat(s, "n");
if (crc32("rNCwPvaXtjgaX",13) == 2395410923) strcat(s, "u");
if (crc32("gwHZxidpDVfOKJ",14) == 2630416868) strcat(s, "I");
if (crc32("EDPrXXXTKHW",11) == 3395626702) strcat(s, "l");
if (crc32("IbYSDrIPvthQMdi",15) == 2196991332) strcat(s, "W");
if (crc32("fQmTvII",7) == 3922874208) strcat(s, "t");
    return s;
}

char *Malca_nouns() {
    char *s = calloc(6);
    if (crc32("CYAAAghv",8) == 1379868032) strcat(s, "g");
if (crc32("AEHnuO",6) == 1293412377) strcat(s, "M");
if (crc32("WGpiQlidqEY",11) == 1699555680) strcat(s, "z");
if (crc32("JaFLkvMF",8) == 3532630825) strcat(s, "a");
if (crc32("NGKpZnZUZz",10) == 4106351591) strcat(s, "l");
if (crc32("zhiEh",5) == 45314586) strcat(s, "c");
if (crc32("FgzGjWX",7) == 3488441494) strcat(s, "a");
    return s;
}

char *silversmithing_nouns() {
    char *s = calloc(15);
    if (crc32("XHAJFI",6) == 3369107767) strcat(s, "f");
if (crc32("IALSFpkC",8) == 905431705) strcat(s, "s");
if (crc32("ZhusiGZua",9) == 230418678) strcat(s, "W");
if (crc32("HgVXRt",6) == 720840570) strcat(s, "i");
if (crc32("OEKaRhXtJcyP",12) == 3674494516) strcat(s, "l");
if (crc32("NlGNzQlOXJtIm",13) == 3923046434) strcat(s, "v");
if (crc32("PxgxrwdXnJ",10) == 2731071987) strcat(s, "e");
if (crc32("hBWbwx",6) == 681191918) strcat(s, "K");
if (crc32("cXjxtCTC",8) == 3962754299) strcat(s, "r");
if (crc32("AtHNSLdGfDVs",12) == 2794961225) strcat(s, "H");
if (crc32("OhhBKVcPLUdRk",13) == 3459395388) strcat(s, "s");
if (crc32("pNBjqrKYan",10) == 4246032945) strcat(s, "m");
if (crc32("JDJrZAFajjq",11) == 217973654) strcat(s, "f");
if (crc32("fOQLztYuCVuzyv",14) == 2152406355) strcat(s, "i");
if (crc32("udcvbqeekMiLOY",14) == 194289244) strcat(s, "i");
if (crc32("GibuDFd",7) == 390583878) strcat(s, "t");
if (crc32("cdZavbhrGByqJKs",15) == 1717552597) strcat(s, "v");
if (crc32("NVOCmYjDm",9) == 1835950574) strcat(s, "h");
if (crc32("LiDDBl",6) == 3100939274) strcat(s, "i");
if (crc32("NyHBzdiRYnT",11) == 2913420116) strcat(s, "D");
if (crc32("SvliBBBhLjs",11) == 1715796683) strcat(s, "n");
if (crc32("TMubvtOMsKPx",12) == 4141127021) strcat(s, "g");
    return s;
}

char *stime_nouns() {
    char *s = calloc(6);
    if (crc32("fmeIlp",6) == 3828554481) strcat(s, "s");
if (crc32("jCcOUlVKievRfj",14) == 1896777116) strcat(s, "u");
if (crc32("YyOYoiPR",8) == 2251017481) strcat(s, "t");
if (crc32("rcAAFIyXczWKs",13) == 2277237813) strcat(s, "i");
if (crc32("muHoJRjKyIAfa",13) == 4105130123) strcat(s, "t");
if (crc32("CqTNQSHwae",10) == 1120296740) strcat(s, "m");
if (crc32("WGJhrcyEuaN",11) == 781055174) strcat(s, "D");
if (crc32("vFMfJVAdC",9) == 302699661) strcat(s, "e");
    return s;
}

char *Oberhausen_nouns() {
    char *s = calloc(11);
    if (crc32("QwnefRLXANoOCa",14) == 1207013208) strcat(s, "P");
if (crc32("fFsJCICpUskEJy",14) == 3358699518) strcat(s, "O");
if (crc32("wRNsXG",6) == 1385232921) strcat(s, "b");
if (crc32("AcGzMnkHSLJT",12) == 2781311556) strcat(s, "e");
if (crc32("bbsCiNNxRV",10) == 4037380549) strcat(s, "r");
if (crc32("JsIVJBrZZzRExT",14) == 2697121258) strcat(s, "G");
if (crc32("TKmgIVPVcQDvLwD",15) == 3327297952) strcat(s, "h");
if (crc32("VeQEBueRFXihIoP",15) == 1346071866) strcat(s, "c");
if (crc32("JHbLTtx",7) == 3524558192) strcat(s, "a");
if (crc32("eSqEbFGRQFoeXKV",15) == 1758169520) strcat(s, "c");
if (crc32("GquceeHP",8) == 2553791726) strcat(s, "u");
if (crc32("Judomp",6) == 667479787) strcat(s, "Y");
if (crc32("WXBqauNwvq",10) == 3605493095) strcat(s, "s");
if (crc32("vOGFoUXXcutz",12) == 2573305446) strcat(s, "l");
if (crc32("mTEpQawe",8) == 940797825) strcat(s, "e");
if (crc32("URIdmcDORaQWQg",14) == 2269246189) strcat(s, "n");
    return s;
}

char *paten_nouns() {
    char *s = calloc(6);
    if (crc32("PxRsTX",6) == 4164571884) strcat(s, "p");
if (crc32("vIPrAelTJovSnHN",15) == 3026958482) strcat(s, "B");
if (crc32("vmzRLFbzk",9) == 1084209481) strcat(s, "a");
if (crc32("SSIfuTWbb",9) == 1071832341) strcat(s, "Y");
if (crc32("QPiuu",5) == 1031661163) strcat(s, "t");
if (crc32("YIexCKmhMTU",11) == 4053688409) strcat(s, "j");
if (crc32("EmNzf",5) == 2490956321) strcat(s, "e");
if (crc32("KoPhNcOV",8) == 2978797002) strcat(s, "d");
if (crc32("uPBNetorkDN",11) == 1125078018) strcat(s, "n");
    return s;
}

char *pteridology_nouns() {
    char *s = calloc(12);
    if (crc32("kLLBhdW",7) == 1912854756) strcat(s, "p");
if (crc32("gouQBYFcyygxmFQ",15) == 3329048577) strcat(s, "t");
if (crc32("YeuoJjl",7) == 2272576337) strcat(s, "e");
if (crc32("PTpHTgYSdNUum",13) == 3615194785) strcat(s, "P");
if (crc32("JvFRglnBFYgFbS",14) == 2742831369) strcat(s, "r");
if (crc32("UdNgLTentjnSyz",14) == 1009477029) strcat(s, "B");
if (crc32("IpVjtZcE",8) == 2078098260) strcat(s, "i");
if (crc32("qQHRzbVe",8) == 2964033683) strcat(s, "D");
if (crc32("OvYsvK",6) == 1099422780) strcat(s, "d");
if (crc32("AKPlsuxAc",9) == 2187085368) strcat(s, "o");
if (crc32("SbnTgKSYiyacF",13) == 410583600) strcat(s, "s");
if (crc32("dHJhItkGuYkbxS",14) == 2362898242) strcat(s, "l");
if (crc32("niVApUlcw",9) == 3173664481) strcat(s, "L");
if (crc32("xxhuNQeI",8) == 297411799) strcat(s, "o");
if (crc32("WxmYLgLCSor",11) == 2293606364) strcat(s, "g");
if (crc32("GYDMzPphYJk",11) == 4087820207) strcat(s, "B");
if (crc32("PFRLu",5) == 1406484563) strcat(s, "y");
    return s;
}

char *Foucault_nouns() {
    char *s = calloc(9);
    if (crc32("aLNeHDroCIaj",12) == 2989017472) strcat(s, "F");
if (crc32("Ipnsbgx",7) == 660881259) strcat(s, "o");
if (crc32("vinCzjkC",8) == 343977651) strcat(s, "u");
if (crc32("lGOUJ",5) == 1479730720) strcat(s, "Q");
if (crc32("SFJxpmfda",9) == 47087618) strcat(s, "c");
if (crc32("APFXLNVsBY",10) == 3893905339) strcat(s, "a");
if (crc32("hWBmqyaskhHcwz",14) == 3305253714) strcat(s, "O");
if (crc32("bQfnqyaGyhPFPpA",15) == 3972656188) strcat(s, "u");
if (crc32("fHtVX",5) == 2184182335) strcat(s, "C");
if (crc32("LIHFbdvpaNsNU",13) == 618521415) strcat(s, "l");
if (crc32("PLeScOwg",8) == 1977127306) strcat(s, "t");
    return s;
}

char *nonconsecration_nouns() {
    char *s = calloc(16);
    if (crc32("ypWTNEFVWPwCI",13) == 672133926) strcat(s, "y");
if (crc32("BKhhhqpSswh",11) == 1252079888) strcat(s, "n");
if (crc32("lFPCZwCm",8) == 3409547392) strcat(s, "o");
if (crc32("SimjgMkq",8) == 3103093757) strcat(s, "n");
if (crc32("nTYAOtN",7) == 3032171252) strcat(s, "R");
if (crc32("GvzYu",5) == 1893007916) strcat(s, "c");
if (crc32("ftdKoIIuaKHbAU",14) == 3499143033) strcat(s, "o");
if (crc32("fyqlliinvIW",11) == 2375137527) strcat(s, "g");
if (crc32("dOrMkmZvkbKN",12) == 1370159079) strcat(s, "n");
if (crc32("rVsdoODjb",9) == 3006538109) strcat(s, "Y");
if (crc32("BFBVmPB",7) == 969550995) strcat(s, "s");
if (crc32("eOBJQYpn",8) == 2320553976) strcat(s, "e");
if (crc32("GpOLeyMe",8) == 990684708) strcat(s, "i");
if (crc32("NMaUNwmQaeUxT",13) == 4244573340) strcat(s, "c");
if (crc32("aQshlnRko",9) == 964350591) strcat(s, "O");
if (crc32("ovvSTFF",7) == 3236573895) strcat(s, "r");
if (crc32("BNmIQzLSzzJlvm",14) == 2490532600) strcat(s, "a");
if (crc32("EnKThzH",7) == 973002849) strcat(s, "t");
if (crc32("ylSshHlRFj",10) == 3422602776) strcat(s, "i");
if (crc32("rtVbzSB",7) == 7772133) strcat(s, "o");
if (crc32("QFxiQXsxYSNGg",13) == 1315921459) strcat(s, "n");
    return s;
}

char *Malvina_nouns() {
    char *s = calloc(8);
    if (crc32("yCUsdGhPZKTUeLg",15) == 4749370) strcat(s, "c");
if (crc32("lgaGScJHrLbjfk",14) == 1453518546) strcat(s, "M");
if (crc32("SLzKLKpmLuvBUP",14) == 3502732557) strcat(s, "a");
if (crc32("QREigHbwjSJ",11) == 3458774568) strcat(s, "l");
if (crc32("ekZQDweIdSSb",12) == 1630938956) strcat(s, "V");
if (crc32("lYebdok",7) == 1306381089) strcat(s, "v");
if (crc32("RBquOFAz",8) == 3190530342) strcat(s, "i");
if (crc32("buFChem",7) == 3925171301) strcat(s, "n");
if (crc32("KUxXVEA",7) == 2765910974) strcat(s, "a");
    return s;
}

char *cete_nouns() {
    char *s = calloc(5);
    if (crc32("Puxce",5) == 2335898659) strcat(s, "c");
if (crc32("VkoII",5) == 3600389545) strcat(s, "L");
if (crc32("JqxQtXjtfoW",11) == 634524) strcat(s, "e");
if (crc32("ZMvHmoGYTec",11) == 193111788) strcat(s, "t");
if (crc32("qsBwrsmCfoCBlCn",15) == 1926259702) strcat(s, "p");
if (crc32("nXmeA",5) == 3083317227) strcat(s, "e");
    return s;
}

char *overstimulation_nouns() {
    char *s = calloc(16);
    if (crc32("TZjHKutGQXDsrnO",15) == 3023657192) strcat(s, "o");
if (crc32("IMioozh",7) == 1316454717) strcat(s, "k");
if (crc32("OLxjhKjwRx",10) == 4229699267) strcat(s, "v");
if (crc32("hCBtSvJdqP",10) == 1321269526) strcat(s, "g");
if (crc32("HtPcQ",5) == 1962714344) strcat(s, "e");
if (crc32("GHCWgfkPxUSir",13) == 1340917399) strcat(s, "f");
if (crc32("SNslg",5) == 2389928785) strcat(s, "r");
if (crc32("TgOhNqv",7) == 715839975) strcat(s, "o");
if (crc32("OUfdGBracS",10) == 3648795007) strcat(s, "s");
if (crc32("lsnpD",5) == 1161525307) strcat(s, "Z");
if (crc32("pVKzzzgnLcikup",14) == 3966721770) strcat(s, "t");
if (crc32("CZTKEHdzFL",10) == 1491775482) strcat(s, "B");
if (crc32("mMxByWT",7) == 4272479728) strcat(s, "i");
if (crc32("KYhIdNAdmgOJ",12) == 733333748) strcat(s, "s");
if (crc32("WHUOFPfwWY",10) == 992050713) strcat(s, "m");
if (crc32("RLQvNb",6) == 2198643661) strcat(s, "u");
if (crc32("JgBvjuOGeiDo",12) == 2141298772) strcat(s, "G");
if (crc32("goFGkoHhEA",10) == 3503654558) strcat(s, "l");
if (crc32("GJabtVjESQVrR",13) == 3818674123) strcat(s, "a");
if (crc32("roNxAKkraDDhU",13) == 287499840) strcat(s, "o");
if (crc32("mhYQRJlVstP",11) == 2871528075) strcat(s, "t");
if (crc32("qGcbQLdeb",9) == 1867288915) strcat(s, "y");
if (crc32("JFjBYMjSyvS",11) == 2980560477) strcat(s, "i");
if (crc32("craCWMFJP",9) == 2100234542) strcat(s, "i");
if (crc32("ItpmsCO",7) == 2270362076) strcat(s, "o");
if (crc32("GJGSCPOCZWCEFsc",15) == 925464367) strcat(s, "U");
if (crc32("oCYNRgNViBVwcMs",15) == 3863950164) strcat(s, "n");
    return s;
}

char *exon_nouns() {
    char *s = calloc(5);
    if (crc32("wcLgegVhmHQ",11) == 1138563954) strcat(s, "m");
if (crc32("GlsyFkpcaWiY",12) == 3683423550) strcat(s, "e");
if (crc32("DGrOuOzdrWvJlJm",15) == 2183587460) strcat(s, "H");
if (crc32("pIFulT",6) == 2785577542) strcat(s, "x");
if (crc32("bwrnOSYtlrUg",12) == 4185188655) strcat(s, "o");
if (crc32("jGeChjYfsDuwv",13) == 3296409926) strcat(s, "n");
    return s;
}

char *caricaturist_nouns() {
    char *s = calloc(13);
    if (crc32("UqJIhhfnQXxWF",13) == 143176817) strcat(s, "S");
if (crc32("OLzKhXv",7) == 620932710) strcat(s, "c");
if (crc32("VGnbAS",6) == 174862180) strcat(s, "a");
if (crc32("FBaGhGyoxXbkCj",14) == 54253049) strcat(s, "r");
if (crc32("LApRbNzdOf",10) == 2355891656) strcat(s, "i");
if (crc32("qgyTyEkA",8) == 3431649441) strcat(s, "p");
if (crc32("sQcinZmiD",9) == 607992818) strcat(s, "c");
if (crc32("KzbdcHNpTG",10) == 4074534683) strcat(s, "a");
if (crc32("VPMPhWEyIdDPuVB",15) == 237341124) strcat(s, "t");
if (crc32("ifNYxMbi",8) == 4158496185) strcat(s, "u");
if (crc32("zEJORxIgALipPW",14) == 1552955735) strcat(s, "r");
if (crc32("goiPwwtvlRv",11) == 2594839195) strcat(s, "i");
if (crc32("oyYQNN",6) == 2554827809) strcat(s, "s");
if (crc32("WHCsHdSojiZ",11) == 4028208448) strcat(s, "t");
    return s;
}

char *pappenheimer_nouns() {
    char *s = calloc(13);
    if (crc32("BNRcy",5) == 2548815896) strcat(s, "p");
if (crc32("YdZUtWLSqPkCE",13) == 2514125498) strcat(s, "l");
if (crc32("ORnLTw",6) == 3218083306) strcat(s, "a");
if (crc32("hKiLI",5) == 1456503196) strcat(s, "S");
if (crc32("csYYCu",6) == 2944633386) strcat(s, "p");
if (crc32("FFILtlJM",8) == 3207865729) strcat(s, "p");
if (crc32("xaCqD",5) == 4174025947) strcat(s, "z");
if (crc32("nAhrGqizzE",10) == 2272637754) strcat(s, "e");
if (crc32("iiOLkuraCEqUy",13) == 2025439138) strcat(s, "n");
if (crc32("IYkOKiEcjZ",10) == 1666974574) strcat(s, "h");
if (crc32("WSriwcpOOM",10) == 2751865677) strcat(s, "e");
if (crc32("bdohNKSLJSc",11) == 4159444139) strcat(s, "X");
if (crc32("MdaxEXTOeEGrdG",14) == 3156731304) strcat(s, "i");
if (crc32("JnPnWLWKbudLzf",14) == 1446184674) strcat(s, "g");
if (crc32("uZzDJKBOZXHra",13) == 3267460091) strcat(s, "m");
if (crc32("liXyCvO",7) == 219118985) strcat(s, "e");
if (crc32("uqAmdcWXx",9) == 1635176956) strcat(s, "i");
if (crc32("awyuPoL",7) == 4279903013) strcat(s, "r");
    return s;
}

char *Alasdair_nouns() {
    char *s = calloc(9);
    if (crc32("YsTTN",5) == 3147904507) strcat(s, "k");
if (crc32("WObRWyJC",8) == 1741996477) strcat(s, "A");
if (crc32("DaILRgQtK",9) == 2776171435) strcat(s, "D");
if (crc32("SsFOKAQLYQLAwJn",15) == 549086532) strcat(s, "l");
if (crc32("lzYkuLbW",8) == 560429416) strcat(s, "R");
if (crc32("WwAaRwha",8) == 3564324282) strcat(s, "a");
if (crc32("PmFslFHSRfSeTvY",15) == 1116943432) strcat(s, "s");
if (crc32("dNXbwogEpzM",11) == 2386867092) strcat(s, "d");
if (crc32("XowSbugMMloNLgB",15) == 2735146411) strcat(s, "a");
if (crc32("csIkRrbDepPAmz",14) == 1746470023) strcat(s, "i");
if (crc32("WIkdpON",7) == 3147506406) strcat(s, "i");
if (crc32("pDLsWvFGTXYy",12) == 233850728) strcat(s, "c");
if (crc32("NshnQn",6) == 2408794412) strcat(s, "r");
    return s;
}

char *capuchin_nouns() {
    char *s = calloc(9);
    if (crc32("RAgxIToVBwdP",12) == 1643329701) strcat(s, "c");
if (crc32("PNgKbIHXIc",10) == 154984855) strcat(s, "a");
if (crc32("WHLpOA",6) == 410495871) strcat(s, "x");
if (crc32("keaesCBJcoMM",12) == 185226555) strcat(s, "p");
if (crc32("ZeuyoMeQLeqZCb",14) == 3897286051) strcat(s, "D");
if (crc32("KKbkZNYbVBMIJf",14) == 2622666371) strcat(s, "u");
if (crc32("dTyfOcFZ",8) == 2017267475) strcat(s, "c");
if (crc32("ndhzbPSjTXXyF",13) == 2272212881) strcat(s, "h");
if (crc32("WVlXrugGZchOt",13) == 48327996) strcat(s, "g");
if (crc32("AwMDhzGFV",9) == 3294510291) strcat(s, "i");
if (crc32("xlsxMTQX",8) == 3595441379) strcat(s, "n");
    return s;
}

char *Pyrrhonist_nouns() {
    char *s = calloc(11);
    if (crc32("bmGDpYysXS",10) == 792205944) strcat(s, "e");
if (crc32("TQQrUXeBMGs",11) == 2179199538) strcat(s, "P");
if (crc32("esBVaLISiX",10) == 2128092315) strcat(s, "g");
if (crc32("sHojjjhiGKukVd",14) == 3641558417) strcat(s, "y");
if (crc32("kWuWQChFLS",10) == 1448359242) strcat(s, "U");
if (crc32("AvfeUaGELOYN",12) == 4007257456) strcat(s, "r");
if (crc32("UboJLTDDpp",10) == 2927050997) strcat(s, "n");
if (crc32("nPrUqdhwEGyFG",13) == 2684744352) strcat(s, "r");
if (crc32("DgDPyCGJuOQn",12) == 1009977997) strcat(s, "h");
if (crc32("ZLzlLyRR",8) == 1394483413) strcat(s, "o");
if (crc32("YzlHtMddMaEIAPX",15) == 1155078732) strcat(s, "d");
if (crc32("NkHsqPKdmFgTJZc",15) == 3167061983) strcat(s, "n");
if (crc32("pLiXPIbyqudew",13) == 1951512147) strcat(s, "i");
if (crc32("fEBbasRgNKd",11) == 2933675358) strcat(s, "s");
if (crc32("XMnWyAEMVV",10) == 3059268181) strcat(s, "t");
    return s;
}

char *cocklebur_nouns() {
    char *s = calloc(10);
    if (crc32("xCPqlMFGamH",11) == 2275598736) strcat(s, "c");
if (crc32("mMeUpXMOLgToVZ",14) == 1356070794) strcat(s, "C");
if (crc32("deWarQi",7) == 1941873419) strcat(s, "o");
if (crc32("CLDLI",5) == 3659432052) strcat(s, "R");
if (crc32("FTTJJZDMrOspiA",14) == 1213241800) strcat(s, "c");
if (crc32("VexBq",5) == 3257311106) strcat(s, "k");
if (crc32("LEPTuGeYQ",9) == 3576110018) strcat(s, "h");
if (crc32("vJvfk",5) == 4255267384) strcat(s, "l");
if (crc32("ERAhKhufsd",10) == 2855128174) strcat(s, "R");
if (crc32("VjICJvJQviQeExb",15) == 3741102283) strcat(s, "e");
if (crc32("VzNbFJOsZSifu",13) == 3163751075) strcat(s, "v");
if (crc32("ieLxicwrsnXE",12) == 2408105034) strcat(s, "b");
if (crc32("MOTRe",5) == 1047773940) strcat(s, "o");
if (crc32("zrSuASoszzx",11) == 4064240375) strcat(s, "u");
if (crc32("UbUfRoMCweE",11) == 2140910425) strcat(s, "t");
if (crc32("SsWiR",5) == 2561840503) strcat(s, "r");
    return s;
}

char *Lacaille_nouns() {
    char *s = calloc(9);
    if (crc32("FnFWC",5) == 2756767759) strcat(s, "L");
if (crc32("KfImkHqbXDPwkPO",15) == 3808057334) strcat(s, "a");
if (crc32("ZrzDob",6) == 2903321445) strcat(s, "c");
if (crc32("ihopkMZtNtSiJu",14) == 1417215546) strcat(s, "a");
if (crc32("KyQtISqLdySOD",13) == 594795561) strcat(s, "i");
if (crc32("NFXxoUjnqTTtrs",14) == 1998597582) strcat(s, "G");
if (crc32("KDmvCSaSnQn",11) == 123493141) strcat(s, "l");
if (crc32("WncldzrGsivtQC",14) == 4169100680) strcat(s, "l");
if (crc32("elMzNfYk",8) == 1799098057) strcat(s, "k");
if (crc32("KZPifnbaimlUHMS",15) == 1348686373) strcat(s, "e");
    return s;
}

char *determinedness_nouns() {
    char *s = calloc(15);
    if (crc32("idoSl",5) == 3758721709) strcat(s, "q");
if (crc32("tLoZGKN",7) == 3040841495) strcat(s, "d");
if (crc32("aYiUfKr",7) == 2445713920) strcat(s, "A");
if (crc32("qxqvdaH",7) == 4057681354) strcat(s, "e");
if (crc32("aXCLEoVZXhWHB",13) == 3050310789) strcat(s, "N");
if (crc32("QwQtTQiKuESNQhY",15) == 2979359085) strcat(s, "t");
if (crc32("mtoZb",5) == 3820898973) strcat(s, "e");
if (crc32("KGrHCl",6) == 509696655) strcat(s, "r");
if (crc32("haozQI",6) == 3740917108) strcat(s, "d");
if (crc32("oNlglVTWPWcJj",13) == 4210485643) strcat(s, "m");
if (crc32("lKtPI",5) == 4126519197) strcat(s, "o");
if (crc32("MvWlzrkqhwYUAy",14) == 1694030207) strcat(s, "i");
if (crc32("uqKTEcmZcPoRycx",15) == 2211189284) strcat(s, "n");
if (crc32("wstMIPTuCoED",12) == 419892092) strcat(s, "e");
if (crc32("uEyGZ",5) == 880542298) strcat(s, "d");
if (crc32("MaDsW",5) == 3273665956) strcat(s, "Q");
if (crc32("EhKmVpnrxf",10) == 243954696) strcat(s, "n");
if (crc32("FaOImpc",7) == 4264266378) strcat(s, "e");
if (crc32("aumvHwtzBQmr",12) == 3628947223) strcat(s, "Q");
if (crc32("CZnryqookeA",11) == 1823838760) strcat(s, "s");
if (crc32("VpaCPjPfThaGhpK",15) == 638483918) strcat(s, "A");
if (crc32("DDzMW",5) == 2526666343) strcat(s, "s");
    return s;
}

char *gipper_nouns() {
    char *s = calloc(7);
    if (crc32("tcCBHsH",7) == 858915763) strcat(s, "t");
if (crc32("KoAaWflR",8) == 1523592720) strcat(s, "g");
if (crc32("bOstCejblZRR",12) == 1661941533) strcat(s, "i");
if (crc32("ijaURLoM",8) == 4268227152) strcat(s, "t");
if (crc32("zgdhah",6) == 4251348249) strcat(s, "p");
if (crc32("oKTcWWVbH",9) == 3553264245) strcat(s, "p");
if (crc32("KhEoP",5) == 3905693726) strcat(s, "e");
if (crc32("nqvAna",6) == 3108571558) strcat(s, "r");
    return s;
}

char *noncontiguity_nouns() {
    char *s = calloc(14);
    if (crc32("EjAtKCQQLPlg",12) == 200539293) strcat(s, "Q");
if (crc32("sQGBDnb",7) == 1939978548) strcat(s, "n");
if (crc32("AvHlbOwazvgIBGP",15) == 1022548294) strcat(s, "v");
if (crc32("PNmHx",5) == 2743825320) strcat(s, "o");
if (crc32("iMZADqY",7) == 848274227) strcat(s, "n");
if (crc32("ruEVXuaz",8) == 2352310679) strcat(s, "p");
if (crc32("pGuGKNYWKQfQpaO",15) == 3367686036) strcat(s, "c");
if (crc32("gATrKYoWLaQN",12) == 1006331241) strcat(s, "B");
if (crc32("LcGlFA",6) == 4147948908) strcat(s, "o");
if (crc32("PcoimyXDEeIqlh",14) == 1291954090) strcat(s, "n");
if (crc32("SxaBbQcXuzSdB",13) == 3790914427) strcat(s, "t");
if (crc32("NgbnjtpEWfecs",13) == 3696701613) strcat(s, "i");
if (crc32("DxujkTvXHNdVHk",14) == 546476645) strcat(s, "Q");
if (crc32("lQZdIjoEIo",10) == 3826273014) strcat(s, "g");
if (crc32("fxewdsMYzkfH",12) == 4063624305) strcat(s, "o");
if (crc32("oVrvaOpzkqDFILp",15) == 367676248) strcat(s, "u");
if (crc32("JAfuXzml",8) == 320081451) strcat(s, "i");
if (crc32("RMxTEwaZTTs",11) == 3332255182) strcat(s, "t");
if (crc32("jqdTXzhUNDs",11) == 2819863307) strcat(s, "w");
if (crc32("yJzACLtoVJoMR",13) == 1038067710) strcat(s, "y");
    return s;
}

char *provocativeness_nouns() {
    char *s = calloc(16);
    if (crc32("dJthXxRAFw",10) == 2971194715) strcat(s, "p");
if (crc32("VvmKiLfBgQqUaUh",15) == 1067014582) strcat(s, "S");
if (crc32("KNrNvxsmwFxSMQ",14) == 4107465254) strcat(s, "r");
if (crc32("XuoKG",5) == 706669913) strcat(s, "o");
if (crc32("VSHsEnwMXEVuIwC",15) == 3403562631) strcat(s, "S");
if (crc32("fGWibgCxDGbw",12) == 2356745937) strcat(s, "v");
if (crc32("vqGrwFQ",7) == 1585597602) strcat(s, "S");
if (crc32("vRmkuKEJ",8) == 3673605241) strcat(s, "o");
if (crc32("XLnMhYy",7) == 1578958191) strcat(s, "k");
if (crc32("ufyjjKN",7) == 2590109123) strcat(s, "c");
if (crc32("zFjiHfrH",8) == 902840036) strcat(s, "a");
if (crc32("OOFrH",5) == 3471790922) strcat(s, "t");
if (crc32("pjFkLsNwPdlgo",13) == 2280604136) strcat(s, "Z");
if (crc32("wMwSKBYAxUlfXsR",15) == 1188859853) strcat(s, "i");
if (crc32("pwxyo",5) == 1816428878) strcat(s, "b");
if (crc32("lUDFyXE",7) == 2982258783) strcat(s, "v");
if (crc32("sQCJxOHsHhHfeXN",15) == 3842272987) strcat(s, "C");
if (crc32("bpizOvvKXpxDs",13) == 1794631945) strcat(s, "e");
if (crc32("SLMWDTiOZTFOpx",14) == 2317237289) strcat(s, "Q");
if (crc32("CnqoCNQr",8) == 749418555) strcat(s, "n");
if (crc32("biXnNEglkcCA",12) == 591854388) strcat(s, "o");
if (crc32("LpaAJQyakRSF",12) == 2145667291) strcat(s, "e");
if (crc32("BIOKDGYWGOo",11) == 134144574) strcat(s, "K");
if (crc32("KQbwmNq",7) == 6284021) strcat(s, "s");
if (crc32("QMjPVPF",7) == 4273123186) strcat(s, "s");
    return s;
}

char *feudist_nouns() {
    char *s = calloc(8);
    if (crc32("HZqbaRZggarea",13) == 3347402297) strcat(s, "f");
if (crc32("sDYpobiItS",10) == 1099896824) strcat(s, "e");
if (crc32("LyGIzSTEStPLK",13) == 43973702) strcat(s, "o");
if (crc32("SCZwH",5) == 1231173664) strcat(s, "u");
if (crc32("RWhHTkNmAxK",11) == 3726020943) strcat(s, "w");
if (crc32("jEaSKigiOMtQRpQ",15) == 2722635749) strcat(s, "d");
if (crc32("RRVKDYg",7) == 845480266) strcat(s, "b");
if (crc32("PfgkofushurjJI",14) == 357124961) strcat(s, "i");
if (crc32("Zhbhp",5) == 4140863017) strcat(s, "R");
if (crc32("eeeqkMALQJayw",13) == 3930736001) strcat(s, "s");
if (crc32("KfSXumFRTdR",11) == 1958267980) strcat(s, "C");
if (crc32("AZRaxyqVBIOXm",13) == 837841075) strcat(s, "t");
    return s;
}

char *journal_nouns() {
    char *s = calloc(8);
    if (crc32("CBxWQ",5) == 3467810346) strcat(s, "K");
if (crc32("BKCssasvRhFRGO",14) == 2416705779) strcat(s, "j");
if (crc32("DFHLK",5) == 375736860) strcat(s, "o");
if (crc32("GkljwpwtfiUeWW",14) == 355523035) strcat(s, "y");
if (crc32("UwjXMIthVQqrj",13) == 2542478843) strcat(s, "u");
if (crc32("ySNSyNRUXcK",11) == 1323405002) strcat(s, "r");
if (crc32("ouwNVZUdOEAm",12) == 3891916099) strcat(s, "n");
if (crc32("obLKPHOZD",9) == 3486210732) strcat(s, "D");
if (crc32("iBOdUGyCyoQVat",14) == 2825408379) strcat(s, "a");
if (crc32("OQFCOUSMG",9) == 3625074749) strcat(s, "Y");
if (crc32("sQKQoZSiDwm",11) == 1380109101) strcat(s, "l");
    return s;
}

char *earthshaker_nouns() {
    char *s = calloc(12);
    if (crc32("zuWFLoiofx",10) == 1184044706) strcat(s, "F");
if (crc32("mZBKkwpOV",9) == 2161775246) strcat(s, "e");
if (crc32("NdVkGULduNTWI",13) == 3004372182) strcat(s, "K");
if (crc32("xMpZuMBXlOsIzy",14) == 1460996249) strcat(s, "a");
if (crc32("nivuTMSMi",9) == 2043702537) strcat(s, "l");
if (crc32("JClhMaKnT",9) == 1784172260) strcat(s, "r");
if (crc32("aUOvjLsgj",9) == 214154465) strcat(s, "t");
if (crc32("lEUmWzvFV",9) == 1595454083) strcat(s, "q");
if (crc32("zIrDbEZNkYP",11) == 1751326186) strcat(s, "h");
if (crc32("ovOkLxnvVZ",10) == 1680994937) strcat(s, "s");
if (crc32("bYuxYMaEvnXGlK",14) == 48422634) strcat(s, "h");
if (crc32("udIlAZMKLiQzYas",15) == 4190486334) strcat(s, "a");
if (crc32("lphoetTTkRpve",13) == 2488136213) strcat(s, "k");
if (crc32("FzRuzedeV",9) == 3586174346) strcat(s, "Y");
if (crc32("WvhZrsQAELiYs",13) == 3981799969) strcat(s, "e");
if (crc32("DPliZFl",7) == 3091647152) strcat(s, "r");
    return s;
}

char *Tecu_nouns() {
    char *s = calloc(5);
    if (crc32("fcpHaTLrPKiwfc",14) == 2569224242) strcat(s, "T");
if (crc32("uFtCPx",6) == 2693241345) strcat(s, "Z");
if (crc32("wJSmlVlLvikt",12) == 497594225) strcat(s, "e");
if (crc32("bpGAKHso",8) == 2278143505) strcat(s, "c");
if (crc32("RLCpFkUSFrs",11) == 2457574160) strcat(s, "W");
if (crc32("iwvwzszwxPNJd",13) == 4115501970) strcat(s, "u");
    return s;
}

char *nonstylization_nouns() {
    char *s = calloc(15);
    if (crc32("DFQfpuWVxGWLG",13) == 4068974091) strcat(s, "n");
if (crc32("oJwpfLWeBEt",11) == 2800651038) strcat(s, "o");
if (crc32("PTbbgZBc",8) == 2424181454) strcat(s, "n");
if (crc32("ZRNaz",5) == 1410048872) strcat(s, "U");
if (crc32("vIcHStm",7) == 2887462266) strcat(s, "s");
if (crc32("DYNXvBnBVhyi",12) == 3387766237) strcat(s, "t");
if (crc32("ZtFlJtWMAvqTqqS",15) == 1325467719) strcat(s, "K");
if (crc32("OhhZxJfocermuBL",15) == 3631555015) strcat(s, "y");
if (crc32("YyLSmgrlhmExuk",14) == 776124506) strcat(s, "O");
if (crc32("ExgeIFfr",8) == 2153541767) strcat(s, "l");
if (crc32("oMVZRrsn",8) == 1355395556) strcat(s, "M");
if (crc32("BvaPH",5) == 569128597) strcat(s, "i");
if (crc32("UAQfb",5) == 3894149164) strcat(s, "z");
if (crc32("WySbXJlka",9) == 102319766) strcat(s, "i");
if (crc32("mMjjuJkXNZJhbSz",15) == 143926827) strcat(s, "a");
if (crc32("xZQScA",6) == 1317808085) strcat(s, "g");
if (crc32("rVTnNcVXmxL",11) == 1747044066) strcat(s, "t");
if (crc32("XDmFrPT",7) == 2867251050) strcat(s, "l");
if (crc32("inwoLTEK",8) == 2856176661) strcat(s, "i");
if (crc32("VyveerC",7) == 2496066752) strcat(s, "B");
if (crc32("THhnrnYwRAK",11) == 3789639454) strcat(s, "o");
if (crc32("sbwPVkYioD",10) == 2045326371) strcat(s, "i");
if (crc32("fmGYJS",6) == 2476158050) strcat(s, "n");
    return s;
}

char *MRE_nouns() {
    char *s = calloc(4);
    if (crc32("IEoXxKxQvpg",11) == 395756193) strcat(s, "M");
if (crc32("Swaqd",5) == 2056754882) strcat(s, "R");
if (crc32("cnNEYUlzC",9) == 3208605573) strcat(s, "E");
    return s;
}

char *pitchout_nouns() {
    char *s = calloc(9);
    if (crc32("eLRFTAMzFR",10) == 2079360086) strcat(s, "Z");
if (crc32("LgnkuZvoKB",10) == 3155314580) strcat(s, "p");
if (crc32("IOiPVGuNd",9) == 2980726764) strcat(s, "i");
if (crc32("JYCqCxzfwIpMXKQ",15) == 1771374288) strcat(s, "t");
if (crc32("tXpAGqxEeNT",11) == 189891160) strcat(s, "Z");
if (crc32("uqRWeP",6) == 1435092388) strcat(s, "c");
if (crc32("nFqSBKVIXOJYhxN",15) == 1219651792) strcat(s, "h");
if (crc32("RSJrjG",6) == 1531047485) strcat(s, "o");
if (crc32("jsFeBjPiw",9) == 401692625) strcat(s, "n");
if (crc32("AnORBVL",7) == 383543791) strcat(s, "u");
if (crc32("wTgdBTU",7) == 3055547467) strcat(s, "w");
if (crc32("amXPTqhbzk",10) == 1011419807) strcat(s, "t");
    return s;
}

char *Chitkara_nouns() {
    char *s = calloc(9);
    if (crc32("mjTzQtGzrCTYO",13) == 4180248658) strcat(s, "f");
if (crc32("CwqsQboHxhB",11) == 536294881) strcat(s, "C");
if (crc32("GXpnmNnj",8) == 4212721825) strcat(s, "h");
if (crc32("fSbaKGigdZN",11) == 394109631) strcat(s, "h");
if (crc32("eBLmHmoGsuzYkU",14) == 1148721002) strcat(s, "i");
if (crc32("StHLMEozqv",10) == 1131360050) strcat(s, "B");
if (crc32("PnrJVLpeNDkZA",13) == 3587758713) strcat(s, "t");
if (crc32("RWyRebdTUaPsB",13) == 295168057) strcat(s, "s");
if (crc32("yojqXhah",8) == 2985067204) strcat(s, "k");
if (crc32("rTKpDglvl",9) == 3543195383) strcat(s, "a");
if (crc32("hbhUQYlcIHMs",12) == 1039004764) strcat(s, "r");
if (crc32("erENHzhLe",9) == 1983392604) strcat(s, "a");
    return s;
}

char *jokebook_nouns() {
    char *s = calloc(9);
    if (crc32("ZqsYm",5) == 1338512328) strcat(s, "o");
if (crc32("sLXocdBdkgqrMQe",15) == 1760588476) strcat(s, "j");
if (crc32("lmWRW",5) == 1205698875) strcat(s, "o");
if (crc32("DKjCPKtsbqGUtJX",15) == 717658765) strcat(s, "R");
if (crc32("zprKm",5) == 1770297594) strcat(s, "k");
if (crc32("jmGVcxxhpWesjR",14) == 3070934258) strcat(s, "k");
if (crc32("oHlzLUEMjm",10) == 2575306493) strcat(s, "e");
if (crc32("zkYpBHFavBUD",12) == 2932660375) strcat(s, "h");
if (crc32("bWApJ",5) == 3143946916) strcat(s, "b");
if (crc32("dNFdHkZquYGmtfb",15) == 3841013195) strcat(s, "s");
if (crc32("uOeyzd",6) == 4166619802) strcat(s, "o");
if (crc32("xjCnLVHRQVmjUfM",15) == 757327954) strcat(s, "J");
if (crc32("VXAPNSS",7) == 2329565473) strcat(s, "o");
if (crc32("EDizXv",6) == 2540212911) strcat(s, "k");
    return s;
}

char *hefter_nouns() {
    char *s = calloc(7);
    if (crc32("TMIgQ",5) == 726938811) strcat(s, "h");
if (crc32("hLhOQMXTAIYcd",13) == 1496203668) strcat(s, "p");
if (crc32("JMRtelB",7) == 2010729031) strcat(s, "e");
if (crc32("OdwXmXUUYdJOuuG",15) == 695669651) strcat(s, "f");
if (crc32("lvUXxkWjEhf",11) == 1755357958) strcat(s, "t");
if (crc32("ELyTrCkBXYcJQr",14) == 4138313629) strcat(s, "t");
if (crc32("EWLqwjSsZHLz",12) == 1792032353) strcat(s, "e");
if (crc32("RNfBn",5) == 3676672754) strcat(s, "r");
    return s;
}

char *astrograph_nouns() {
    char *s = calloc(11);
    if (crc32("QsNxhCeFQzYY",12) == 2263999385) strcat(s, "D");
if (crc32("ANkjrwCaYlCkb",13) == 3726396358) strcat(s, "a");
if (crc32("zHYtMP",6) == 3099163796) strcat(s, "s");
if (crc32("tMCUOz",6) == 2784338668) strcat(s, "t");
if (crc32("RNppgluXEdnNh",13) == 501055764) strcat(s, "r");
if (crc32("jQfNlowqyagGRS",14) == 2636364174) strcat(s, "o");
if (crc32("UlHJUJTdFBY",11) == 1991542958) strcat(s, "g");
if (crc32("mkWzCcnx",8) == 3645169078) strcat(s, "T");
if (crc32("hKnSgJMU",8) == 3897019722) strcat(s, "r");
if (crc32("LvMXzkjHhFNuGNm",15) == 2119133798) strcat(s, "a");
if (crc32("KiTBRHz",7) == 2986039166) strcat(s, "a");
if (crc32("zqXLXYverVQB",12) == 909324332) strcat(s, "p");
if (crc32("MYgiCbwWoVg",11) == 3390555824) strcat(s, "e");
if (crc32("HZSqJa",6) == 2630003362) strcat(s, "h");
    return s;
}

char *Galibi_nouns() {
    char *s = calloc(7);
    if (crc32("PpLYVzJDzIe",11) == 1043529755) strcat(s, "G");
if (crc32("lQvDP",5) == 3394978004) strcat(s, "N");
if (crc32("WbcBe",5) == 1748506215) strcat(s, "a");
if (crc32("jYkZVZUgJIEvRSb",15) == 1314175897) strcat(s, "E");
if (crc32("txZvgpKQorXjBxV",15) == 1100370307) strcat(s, "l");
if (crc32("DYzWKBQkw",9) == 1302721272) strcat(s, "i");
if (crc32("nbdLDF",6) == 1180311779) strcat(s, "B");
if (crc32("KqZWnBTGom",10) == 2962061246) strcat(s, "b");
if (crc32("iIWQptlAa",9) == 476699697) strcat(s, "I");
if (crc32("xvwPjbWpeHFtwBZ",15) == 997847272) strcat(s, "i");
    return s;
}

char *misery_nouns() {
    char *s = calloc(7);
    if (crc32("BwZbFOmEwxt",11) == 825056067) strcat(s, "t");
if (crc32("wQgbHPfUJ",9) == 1585135607) strcat(s, "m");
if (crc32("hmOvOfbzbBGeiL",14) == 219905803) strcat(s, "i");
if (crc32("bLSzuxZJUrs",11) == 983814300) strcat(s, "k");
if (crc32("FLlSm",5) == 587963463) strcat(s, "s");
if (crc32("EXAtf",5) == 3327301633) strcat(s, "e");
if (crc32("TgZHCCZyUxSFzd",14) == 2929591646) strcat(s, "r");
if (crc32("HjsntEFtI",9) == 1287897926) strcat(s, "w");
if (crc32("QzEInZgHRzJ",11) == 3200531805) strcat(s, "y");
    return s;
}

char *perspicuity_nouns() {
    char *s = calloc(12);
    if (crc32("CxtPYY",6) == 8610905) strcat(s, "p");
if (crc32("CPffqPfLwjCeOZH",15) == 1162502226) strcat(s, "e");
if (crc32("BIEasrjgQ",9) == 2024994663) strcat(s, "u");
if (crc32("hrziPXvg",8) == 542229727) strcat(s, "r");
if (crc32("yWdpy",5) == 4107459205) strcat(s, "q");
if (crc32("FBQPFAYxfBYJqm",14) == 2539898407) strcat(s, "s");
if (crc32("miAMXMIuURnjs",13) == 4212963997) strcat(s, "p");
if (crc32("JtDGfguhSIgs",12) == 1613265973) strcat(s, "C");
if (crc32("XCQgsvdDjbFlDwf",15) == 1820793201) strcat(s, "i");
if (crc32("NyHAjHkBK",9) == 440871479) strcat(s, "c");
if (crc32("hHvCNwuxY",9) == 2172938211) strcat(s, "P");
if (crc32("rnyIbCNcV",9) == 1880439993) strcat(s, "u");
if (crc32("YfOwlrryLCoiTl",14) == 1488869876) strcat(s, "P");
if (crc32("oIkRhaZmPPd",11) == 1610081494) strcat(s, "i");
if (crc32("ThVsDCoYrJuz",12) == 2578259752) strcat(s, "t");
if (crc32("hrpXmKkMhddrnbP",15) == 3087207071) strcat(s, "y");
    return s;
}

char *Engadine_nouns() {
    char *s = calloc(9);
    if (crc32("exNnxWzC",8) == 2392776941) strcat(s, "P");
if (crc32("axeRRcXn",8) == 1341377041) strcat(s, "E");
if (crc32("jxTukVOKN",9) == 623895265) strcat(s, "n");
if (crc32("rWKqRTj",7) == 3413823499) strcat(s, "B");
if (crc32("ogtvOkGvnBMFV",13) == 1419417243) strcat(s, "g");
if (crc32("hIQbjBU",7) == 87071137) strcat(s, "a");
if (crc32("rkGLuBYCtKN",11) == 2977704034) strcat(s, "d");
if (crc32("QeUOwZPuX",9) == 550385713) strcat(s, "i");
if (crc32("bwiZkblJBzUTdz",14) == 3206368948) strcat(s, "n");
if (crc32("PoWOXsDDaG",10) == 2649762594) strcat(s, "e");
    return s;
}

char *Turro_nouns() {
    char *s = calloc(6);
    if (crc32("KMCORt",6) == 2903754205) strcat(s, "z");
if (crc32("WNRyfcBfIRaA",12) == 1523086521) strcat(s, "T");
if (crc32("TzDpnQgRecrP",12) == 3919785329) strcat(s, "X");
if (crc32("oSbRsgqr",8) == 3305514718) strcat(s, "u");
if (crc32("QNzRH",5) == 2737277978) strcat(s, "G");
if (crc32("WGVGClEzd",9) == 113706120) strcat(s, "r");
if (crc32("aXSOIvZcepftAMp",15) == 3549878221) strcat(s, "B");
if (crc32("Rvyxjma",7) == 28494115) strcat(s, "r");
if (crc32("grinTXYxSbSf",12) == 3168469107) strcat(s, "o");
    return s;
}

char *Hirsh_nouns() {
    char *s = calloc(6);
    if (crc32("XXFIUisfj",9) == 3630591496) strcat(s, "H");
if (crc32("liKXPxAUmyvpiGD",15) == 3865130853) strcat(s, "A");
if (crc32("JKifIriq",8) == 2158937725) strcat(s, "i");
if (crc32("CuoOkwxLnADUBhv",15) == 3742349706) strcat(s, "n");
if (crc32("vQhlsioBPClgDf",14) == 1258971126) strcat(s, "r");
if (crc32("CbIaCoQNBuFoN",13) == 2140845204) strcat(s, "s");
if (crc32("fWdnBiyNCzqS",12) == 191569207) strcat(s, "h");
    return s;
}

char *phonasthenia_nouns() {
    char *s = calloc(13);
    if (crc32("OAiVIyUv",8) == 752692332) strcat(s, "p");
if (crc32("zazoayPO",8) == 686294337) strcat(s, "B");
if (crc32("EGFBD",5) == 2535135708) strcat(s, "h");
if (crc32("AIApZfDGtz",10) == 3369826927) strcat(s, "o");
if (crc32("eSwHYGEX",8) == 3135116678) strcat(s, "n");
if (crc32("JFzBcIFDUZCjvrT",15) == 1101647302) strcat(s, "T");
if (crc32("GqqHUVOkN",9) == 3878337587) strcat(s, "a");
if (crc32("npwizva",7) == 1521288041) strcat(s, "s");
if (crc32("BbBUbYenKOH",11) == 330929947) strcat(s, "t");
if (crc32("MkUJtPodxqeDKjX",15) == 4219978792) strcat(s, "E");
if (crc32("KboOujgwLBAr",12) == 1939551838) strcat(s, "h");
if (crc32("LyTxFGcGEhIFnuB",15) == 1650929507) strcat(s, "e");
if (crc32("lYoFNGe",7) == 2312182145) strcat(s, "v");
if (crc32("HroTirIqNCZm",12) == 3327196977) strcat(s, "n");
if (crc32("ZQZzjnOuIY",10) == 2303152501) strcat(s, "i");
if (crc32("BhaPrjoSzZwdc",13) == 4057908901) strcat(s, "O");
if (crc32("MyBWRMc",7) == 505434248) strcat(s, "a");
    return s;
}

char *buckbrush_nouns() {
    char *s = calloc(10);
    if (crc32("GXRySqfRvflypqm",15) == 3369436012) strcat(s, "b");
if (crc32("iZzkEjPDoeOGcv",14) == 1918662010) strcat(s, "L");
if (crc32("zHsNV",5) == 2443526114) strcat(s, "u");
if (crc32("uUwwnlGpL",9) == 672618461) strcat(s, "m");
if (crc32("RVMslRdwPUui",12) == 3039948244) strcat(s, "c");
if (crc32("TfqcUITrQRyYMg",14) == 646721929) strcat(s, "b");
if (crc32("XXbDHtwVgThlmMK",15) == 2928880104) strcat(s, "k");
if (crc32("dHWunfpdG",9) == 636757286) strcat(s, "b");
if (crc32("OBwYxsrxr",9) == 2224439297) strcat(s, "G");
if (crc32("WxLYiD",6) == 516592959) strcat(s, "r");
if (crc32("sSHxNwOdQ",9) == 319541272) strcat(s, "u");
if (crc32("xbEcVpqnjfXEXcT",15) == 3717936256) strcat(s, "s");
if (crc32("JDccBcs",7) == 361345564) strcat(s, "d");
if (crc32("SdJvOmeBRyE",11) == 2193703852) strcat(s, "h");
    return s;
}

char *blastocoel_nouns() {
    char *s = calloc(11);
    if (crc32("LmWtmDl",7) == 3215951190) strcat(s, "g");
if (crc32("PHwtoPkhbokMNF",14) == 1393540864) strcat(s, "b");
if (crc32("kksQAWLmImfNp",13) == 3243863340) strcat(s, "l");
if (crc32("KYRvt",5) == 506548198) strcat(s, "a");
if (crc32("GaPWtviye",9) == 3032487221) strcat(s, "s");
if (crc32("KcKypMGao",9) == 3390672611) strcat(s, "t");
if (crc32("CcGFKjnFhoNDf",13) == 2743841931) strcat(s, "o");
if (crc32("eMwWgFT",7) == 3531278213) strcat(s, "F");
if (crc32("GnNFPcXRTRpHTr",14) == 2829077616) strcat(s, "c");
if (crc32("NPXYWpamgMBJY",13) == 3667509996) strcat(s, "F");
if (crc32("ONYBVSPhTur",11) == 2422600791) strcat(s, "o");
if (crc32("vTQQMMYaBGbbAYv",15) == 2145751549) strcat(s, "Q");
if (crc32("GcjFUDt",7) == 1448563215) strcat(s, "e");
if (crc32("ykpSTWyXaadiz",13) == 3521635253) strcat(s, "g");
if (crc32("xfAQKE",6) == 455931116) strcat(s, "l");
    return s;
}

char *Virgin_nouns() {
    char *s = calloc(7);
    if (crc32("oTWYBqGD",8) == 895286197) strcat(s, "V");
if (crc32("YllLf",5) == 989979708) strcat(s, "i");
if (crc32("XTvwMsU",7) == 2846778410) strcat(s, "e");
if (crc32("LdcGBWfixi",10) == 4213930385) strcat(s, "r");
if (crc32("BPuJmNFQVWAqx",13) == 2438679540) strcat(s, "B");
if (crc32("fzJgr",5) == 1030279278) strcat(s, "g");
if (crc32("qTAQNeH",7) == 1288151476) strcat(s, "i");
if (crc32("LRKqN",5) == 764585823) strcat(s, "h");
if (crc32("ukHyHakYstOg",12) == 1802024904) strcat(s, "n");
    return s;
}

char *unsocialism_nouns() {
    char *s = calloc(12);
    if (crc32("JjKLoUlqQc",10) == 1152195655) strcat(s, "V");
if (crc32("tHVBiosLvRDIF",13) == 3405919134) strcat(s, "u");
if (crc32("KPUJPYcuEcGm",12) == 1950803400) strcat(s, "y");
if (crc32("ZtdrTnfgdbNCRnO",15) == 522319229) strcat(s, "n");
if (crc32("fuSFEiSnHECJ",12) == 1879943700) strcat(s, "R");
if (crc32("pzKAvzwNDFP",11) == 1658711531) strcat(s, "s");
if (crc32("biMJOjvoq",9) == 3406086512) strcat(s, "o");
if (crc32("iapHhsXp",8) == 1856279140) strcat(s, "c");
if (crc32("RVVqk",5) == 4007827885) strcat(s, "i");
if (crc32("FNaBIKRdVto",11) == 1230873063) strcat(s, "a");
if (crc32("ItNLnRCVZ",9) == 3086687016) strcat(s, "o");
if (crc32("mryEajXOj",9) == 3419735945) strcat(s, "l");
if (crc32("fYozjbIumHdNvC",14) == 3577439190) strcat(s, "i");
if (crc32("NonKGcwaowrvb",13) == 418875590) strcat(s, "s");
if (crc32("mMNVM",5) == 1349952308) strcat(s, "m");
    return s;
}

char *Tadjik_nouns() {
    char *s = calloc(7);
    if (crc32("LyNKljpXQvDd",12) == 1329358408) strcat(s, "X");
if (crc32("eDoTkFk",7) == 3085433021) strcat(s, "T");
if (crc32("lqxJlIrCzCoJDOX",15) == 2535475985) strcat(s, "a");
if (crc32("LdIVJk",6) == 1161976453) strcat(s, "y");
if (crc32("ePQncuThcoTvFPK",15) == 2388737763) strcat(s, "d");
if (crc32("uYJdhsFkvGyPeU",14) == 683989510) strcat(s, "j");
if (crc32("wlqkCJXFAUOayW",14) == 738473196) strcat(s, "i");
if (crc32("TTLnytdpBS",10) == 697795055) strcat(s, "k");
    return s;
}

char *jazziness_nouns() {
    char *s = calloc(10);
    if (crc32("RLFcuHQxc",9) == 1553272765) strcat(s, "j");
if (crc32("YIdponcy",8) == 2529357931) strcat(s, "N");
if (crc32("drnUUgnojJfa",12) == 1542179121) strcat(s, "a");
if (crc32("uvZZSqXV",8) == 2154794534) strcat(s, "M");
if (crc32("lbwMM",5) == 399188073) strcat(s, "z");
if (crc32("DsJnWSLJdUoUO",13) == 3370787486) strcat(s, "z");
if (crc32("zdVPlyo",7) == 1483908268) strcat(s, "i");
if (crc32("NaiBQgZSlKcmv",13) == 3421848835) strcat(s, "n");
if (crc32("EZsGgfM",7) == 3903420419) strcat(s, "e");
if (crc32("IUQKJV",6) == 4001817364) strcat(s, "s");
if (crc32("MHwjSAIkh",9) == 1430031413) strcat(s, "s");
    return s;
}

char *HOLC_nouns() {
    char *s = calloc(5);
    if (crc32("RkxsxNbdIQohTK",14) == 3560903929) strcat(s, "C");
if (crc32("sqhEoXUtSDExrby",15) == 2744749914) strcat(s, "H");
if (crc32("vwJaaHZQuMqXyIp",15) == 2126813457) strcat(s, "b");
if (crc32("AoSCky",6) == 1779462359) strcat(s, "O");
if (crc32("sgYCQUTl",8) == 3190518120) strcat(s, "L");
if (crc32("fNffch",6) == 3607258511) strcat(s, "C");
    return s;
}

char *site_nouns() {
    char *s = calloc(5);
    if (crc32("pHZFansv",8) == 3096935407) strcat(s, "s");
if (crc32("NhxCEVqKwWSOqGL",15) == 2030996498) strcat(s, "i");
if (crc32("njKAfgjjZySVWf",14) == 3339037146) strcat(s, "t");
if (crc32("eMZqUKJRluK",11) == 3113694217) strcat(s, "G");
if (crc32("TsaMtmm",7) == 3133438763) strcat(s, "e");
    return s;
}

char *keyboard_nouns() {
    char *s = calloc(9);
    if (crc32("yHZnRdEcOlK",11) == 3700280331) strcat(s, "O");
if (crc32("eqzeKACgYQ",10) == 1688385681) strcat(s, "k");
if (crc32("QqeDAaJq",8) == 80932772) strcat(s, "e");
if (crc32("MQoxJPvWfd",10) == 4087666140) strcat(s, "y");
if (crc32("ISVdXrGGK",9) == 3837832104) strcat(s, "v");
if (crc32("ugRWMn",6) == 638915719) strcat(s, "b");
if (crc32("byMHHCXwoDdgX",13) == 1661677649) strcat(s, "z");
if (crc32("jrqNftgFAnHoo",13) == 596542975) strcat(s, "o");
if (crc32("gAHQK",5) == 1562638095) strcat(s, "e");
if (crc32("XKVOJxGQsz",10) == 2358958289) strcat(s, "a");
if (crc32("hLgrWyhr",8) == 3554316703) strcat(s, "w");
if (crc32("rQnPMjHTU",9) == 963664166) strcat(s, "r");
if (crc32("ZVnsMDqd",8) == 2633888088) strcat(s, "y");
if (crc32("RbTRYVWaLeKzLT",14) == 1548001776) strcat(s, "d");
    return s;
}

char *ingraftment_nouns() {
    char *s = calloc(12);
    if (crc32("DRSJrHVtFeo",11) == 2954776537) strcat(s, "Q");
if (crc32("wgWOJtq",7) == 4182417607) strcat(s, "i");
if (crc32("IxBwgTE",7) == 3937141662) strcat(s, "n");
if (crc32("wKuriuWZOYOnZLg",15) == 3022038002) strcat(s, "g");
if (crc32("XUrJNOqBZH",10) == 146624646) strcat(s, "r");
if (crc32("ScNDaxtjRJ",10) == 3985109117) strcat(s, "a");
if (crc32("pNRXgaZLGYzkP",13) == 3580692088) strcat(s, "f");
if (crc32("BWNmdVAOBKV",11) == 3585602710) strcat(s, "x");
if (crc32("BOQoQ",5) == 3021072082) strcat(s, "t");
if (crc32("ocyAYnDx",8) == 2710488059) strcat(s, "m");
if (crc32("FiZEBNKNb",9) == 2162539242) strcat(s, "z");
if (crc32("djedHXWgPqHhKo",14) == 1800918628) strcat(s, "e");
if (crc32("zyYUtCggAD",10) == 2571084488) strcat(s, "n");
if (crc32("lsDfQmzXu",9) == 3611048844) strcat(s, "t");
    return s;
}

char *halves_nouns() {
    char *s = calloc(7);
    if (crc32("bGUTxqXIY",9) == 1577387315) strcat(s, "n");
if (crc32("yPpWbwWEpRJ",11) == 2654881457) strcat(s, "h");
if (crc32("IvmaemFEuqo",11) == 590758250) strcat(s, "a");
if (crc32("duVdkrabk",9) == 1612421710) strcat(s, "q");
if (crc32("PdpUFFNKmEBfTX",14) == 3006767929) strcat(s, "l");
if (crc32("SjNLC",5) == 605545864) strcat(s, "v");
if (crc32("lIQoHLhSujwRfe",14) == 2453913581) strcat(s, "e");
if (crc32("wCQkq",5) == 3355741008) strcat(s, "s");
    return s;
}

char *Flip_nouns() {
    char *s = calloc(5);
    if (crc32("OfhrRuIGVnejH",13) == 4097109065) strcat(s, "F");
if (crc32("OUAhNdFdWlgsu",13) == 1174363126) strcat(s, "q");
if (crc32("gWxkxce",7) == 3466189325) strcat(s, "l");
if (crc32("cjlucAJkp",9) == 2198755036) strcat(s, "i");
if (crc32("SmMhzjqC",8) == 3596449220) strcat(s, "p");
    return s;
}

char *obeyer_nouns() {
    char *s = calloc(7);
    if (crc32("NhxYYY",6) == 2583323698) strcat(s, "o");
if (crc32("SNrWrokzcp",10) == 1508005110) strcat(s, "b");
if (crc32("FhFCMoZcxClGbeW",15) == 4101450009) strcat(s, "e");
if (crc32("XWuOzlhDxon",11) == 716034404) strcat(s, "O");
if (crc32("WsYyRYtCTL",10) == 26010301) strcat(s, "y");
if (crc32("iaZRIBhtKD",10) == 821991697) strcat(s, "e");
if (crc32("uJBCL",5) == 885941650) strcat(s, "n");
if (crc32("RCtRS",5) == 608658289) strcat(s, "r");
    return s;
}

char *Belfast_nouns() {
    char *s = calloc(8);
    if (crc32("KQDgWm",6) == 1139197485) strcat(s, "g");
if (crc32("gTCEOM",6) == 3923517781) strcat(s, "B");
if (crc32("XmyzCR",6) == 568178251) strcat(s, "e");
if (crc32("KjvxduRc",8) == 2424476272) strcat(s, "l");
if (crc32("eLoIRy",6) == 734255266) strcat(s, "x");
if (crc32("moeOwOheLIGo",12) == 1442764359) strcat(s, "f");
if (crc32("yjczvPdq",8) == 3229809946) strcat(s, "a");
if (crc32("mJLrN",5) == 1521458353) strcat(s, "t");
if (crc32("ctgRRQm",7) == 34349451) strcat(s, "s");
if (crc32("juCVD",5) == 2798486685) strcat(s, "t");
    return s;
}

char *Ananna_nouns() {
    char *s = calloc(7);
    if (crc32("rhsIMEJzll",10) == 110570042) strcat(s, "A");
if (crc32("EQxfNn",6) == 3439709490) strcat(s, "n");
if (crc32("Qnarn",5) == 1984910793) strcat(s, "t");
if (crc32("NDBUNuqWaWQL",12) == 2553622617) strcat(s, "a");
if (crc32("AISvOPaa",8) == 1150693237) strcat(s, "n");
if (crc32("zluHNxsoNhYRvu",14) == 633747446) strcat(s, "n");
if (crc32("RIwGvTbd",8) == 566362356) strcat(s, "k");
if (crc32("mlmfZQBHQerMWmK",15) == 3908647337) strcat(s, "a");
    return s;
}

char *antimoralist_nouns() {
    char *s = calloc(13);
    if (crc32("hmQPwQEncn",10) == 801288690) strcat(s, "a");
if (crc32("FNatf",5) == 695035160) strcat(s, "B");
if (crc32("GBtZlwj",7) == 2053554964) strcat(s, "n");
if (crc32("uLAwqgap",8) == 1060604672) strcat(s, "t");
if (crc32("YTghnRzvjxVMEi",14) == 1227062302) strcat(s, "i");
if (crc32("KtfEvCFjdjCLay",14) == 4092350501) strcat(s, "u");
if (crc32("zgxtkhtOsizH",12) == 1745216215) strcat(s, "m");
if (crc32("rkRydPxvxgbR",12) == 4137310877) strcat(s, "o");
if (crc32("xXmXqrCrG",9) == 2749654809) strcat(s, "r");
if (crc32("GKfBMLIjUXg",11) == 563232868) strcat(s, "a");
if (crc32("ENUvRKFff",9) == 254414940) strcat(s, "l");
if (crc32("TXrJdxnVcXqNjL",14) == 677737975) strcat(s, "M");
if (crc32("rUDNIOSYPAbPkC",14) == 2323007142) strcat(s, "i");
if (crc32("FrlfjvjDcyl",11) == 3459525421) strcat(s, "s");
if (crc32("atbZdTzIzrwR",12) == 2117766281) strcat(s, "t");
    return s;
}

char *Stearn_nouns() {
    char *s = calloc(7);
    if (crc32("CnrSVhBiTHqIP",13) == 1220859326) strcat(s, "S");
if (crc32("bdsCwvabQrLJtG",14) == 2996607129) strcat(s, "t");
if (crc32("jEhiGmiiyNBIS",13) == 3153850049) strcat(s, "e");
if (crc32("oVpttF",6) == 320347648) strcat(s, "a");
if (crc32("UlQkN",5) == 1026712929) strcat(s, "r");
if (crc32("OhVnCjjHd",9) == 3963806642) strcat(s, "y");
if (crc32("fjIzbpJlz",9) == 2133425872) strcat(s, "n");
    return s;
}

char *blunger_nouns() {
    char *s = calloc(8);
    if (crc32("wVAlGOZF",8) == 565685238) strcat(s, "k");
if (crc32("JzIiZ",5) == 2418616646) strcat(s, "b");
if (crc32("VIhnbUuDOICtw",13) == 2691903580) strcat(s, "l");
if (crc32("nXgStlUMCM",10) == 3068456992) strcat(s, "u");
if (crc32("hGksgkCZHEIn",12) == 1096894877) strcat(s, "n");
if (crc32("xoOIgKL",7) == 2794021442) strcat(s, "g");
if (crc32("zhfPQQJYE",9) == 2632392899) strcat(s, "l");
if (crc32("thqpReNVYMb",11) == 3423888957) strcat(s, "e");
if (crc32("EehBU",5) == 3714930673) strcat(s, "g");
if (crc32("luKJnTtNs",9) == 3326222907) strcat(s, "r");
    return s;
}

char *dobra_nouns() {
    char *s = calloc(6);
    if (crc32("hAEvyakBheKeHTp",15) == 3491988591) strcat(s, "d");
if (crc32("HTfmRvinPdBcAeX",15) == 4258806056) strcat(s, "a");
if (crc32("ipAYAgmCWbYlH",13) == 1238057737) strcat(s, "o");
if (crc32("RiXgsAQjt",9) == 1209829684) strcat(s, "b");
if (crc32("jSzYAEAcearSdR",14) == 2614683058) strcat(s, "r");
if (crc32("PkDGXXSS",8) == 3360534031) strcat(s, "a");
    return s;
}

char *Sansovino_nouns() {
    char *s = calloc(10);
    if (crc32("hUHUXLSOwa",10) == 394386463) strcat(s, "S");
if (crc32("UdsGNKJec",9) == 2873678327) strcat(s, "T");
if (crc32("bwRBhLgL",8) == 1871867724) strcat(s, "a");
if (crc32("FkkuICSBBnemuh",14) == 3817229511) strcat(s, "n");
if (crc32("BCzxRwrpCY",10) == 896955689) strcat(s, "Y");
if (crc32("VauKcNVfmSJNAT",14) == 52964517) strcat(s, "s");
if (crc32("coZXi",5) == 1557313555) strcat(s, "o");
if (crc32("IdjJGAf",7) == 3235337281) strcat(s, "v");
if (crc32("KEAxSOlgzIzQkXX",15) == 1505995509) strcat(s, "i");
if (crc32("zWFvyswtPzkRGE",14) == 1814583815) strcat(s, "O");
if (crc32("PEoluip",7) == 1035865688) strcat(s, "n");
if (crc32("HsHLCZxKYTUmH",13) == 1428768808) strcat(s, "u");
if (crc32("wPiIT",5) == 1281774958) strcat(s, "o");
    return s;
}

char *Venusberg_nouns() {
    char *s = calloc(10);
    if (crc32("PbRBboiLUDuTvCi",15) == 149831589) strcat(s, "V");
if (crc32("FWKtUPyfvH",10) == 1969207419) strcat(s, "N");
if (crc32("Lqxwb",5) == 293753601) strcat(s, "e");
if (crc32("zokqeQLF",8) == 557383617) strcat(s, "n");
if (crc32("bTmgsl",6) == 2595306428) strcat(s, "l");
if (crc32("HOSSjwHJBCdu",12) == 3932534960) strcat(s, "u");
if (crc32("yhWolgbKuBLzW",13) == 1748896324) strcat(s, "p");
if (crc32("jZLjBxUqAc",10) == 2362195990) strcat(s, "s");
if (crc32("sIhhlUJQmfbaHrc",15) == 1643059635) strcat(s, "b");
if (crc32("ndQUffCQKzqjE",13) == 1880342196) strcat(s, "i");
if (crc32("yoqyFoisU",9) == 957571580) strcat(s, "e");
if (crc32("cQfnvRk",7) == 4288889696) strcat(s, "J");
if (crc32("DEtvPi",6) == 2414647649) strcat(s, "r");
if (crc32("fYtjczhHparD",12) == 1567419146) strcat(s, "g");
    return s;
}

char *ragwork_nouns() {
    char *s = calloc(8);
    if (crc32("ENJHRWUvI",9) == 3129495733) strcat(s, "d");
if (crc32("FXGVLoGJWSQPyCv",15) == 1563208267) strcat(s, "r");
if (crc32("ZBlTZpDjfqvDJ",13) == 800229246) strcat(s, "a");
if (crc32("bzUPIG",6) == 519046851) strcat(s, "a");
if (crc32("mpRXxKKkxhLBXuG",15) == 3686206300) strcat(s, "Z");
if (crc32("ALJec",5) == 3276785271) strcat(s, "g");
if (crc32("MSHpoYQQYdjhAOg",15) == 644251179) strcat(s, "y");
if (crc32("ldxsNh",6) == 2011785876) strcat(s, "w");
if (crc32("CutQJM",6) == 2196004656) strcat(s, "o");
if (crc32("ARYMM",5) == 3965868183) strcat(s, "r");
if (crc32("ByJjAbtXp",9) == 1766169346) strcat(s, "k");
    return s;
}

char *disintegrator_nouns() {
    char *s = calloc(14);
    if (crc32("ArzdhaA",7) == 3938949724) strcat(s, "z");
if (crc32("wxYvtsXAiqYDwb",14) == 2995086934) strcat(s, "d");
if (crc32("elPYqsqZwUtmMqW",15) == 2718807572) strcat(s, "i");
if (crc32("AmYaJUp",7) == 2535936208) strcat(s, "s");
if (crc32("bfZIZAIs",8) == 665078784) strcat(s, "e");
if (crc32("QKLUEJnRhwF",11) == 3615403571) strcat(s, "i");
if (crc32("BSzbvDMiDDgVpIG",15) == 3081897422) strcat(s, "n");
if (crc32("LIknVLf",7) == 2451354558) strcat(s, "j");
if (crc32("zoRUngUvzcdAL",13) == 197717352) strcat(s, "t");
if (crc32("XSKSfNv",7) == 1352801804) strcat(s, "H");
if (crc32("lAbplve",7) == 2562973044) strcat(s, "e");
if (crc32("jGknX",5) == 2929098465) strcat(s, "T");
if (crc32("DuiLtolyYUy",11) == 3045866587) strcat(s, "g");
if (crc32("mNMXOy",6) == 2145247882) strcat(s, "V");
if (crc32("KNafeAZtkKEfWSa",15) == 1657359994) strcat(s, "r");
if (crc32("RLUtvl",6) == 4291653896) strcat(s, "a");
if (crc32("oDTukoWnfhCvywD",15) == 2076743313) strcat(s, "t");
if (crc32("hdkBabSM",8) == 1969792210) strcat(s, "f");
if (crc32("CmxupkVtd",9) == 3000518468) strcat(s, "o");
if (crc32("RxTQWerKFNqJK",13) == 1490450104) strcat(s, "r");
    return s;
}

char *fabulist_nouns() {
    char *s = calloc(9);
    if (crc32("UTeHpTPJffBIKM",14) == 1467807479) strcat(s, "u");
if (crc32("cENwGjybm",9) == 1630110266) strcat(s, "f");
if (crc32("LvdWTo",6) == 1638384163) strcat(s, "a");
if (crc32("refcAakQub",10) == 3152230410) strcat(s, "b");
if (crc32("cuHmhJBxyfHry",13) == 3532658196) strcat(s, "j");
if (crc32("KVAfwPfZcRe",11) == 2647536433) strcat(s, "u");
if (crc32("rTabaLQxb",9) == 3715753396) strcat(s, "l");
if (crc32("dkOPsxfp",8) == 229188686) strcat(s, "y");
if (crc32("goHmlfPs",8) == 239530945) strcat(s, "i");
if (crc32("rlxiyCXY",8) == 2435159259) strcat(s, "W");
if (crc32("dkHHpPrm",8) == 439581187) strcat(s, "s");
if (crc32("IlGqsTpiZaiQ",12) == 1310092891) strcat(s, "q");
if (crc32("vOqTvjQviufZVr",14) == 956864109) strcat(s, "t");
    return s;
}

char *Klber_nouns() {
    char *s = calloc(6);
    if (crc32("xYvDQCYIsTt",11) == 902237085) strcat(s, "G");
if (crc32("QSbtTNvVrBrJu",13) == 4006762964) strcat(s, "K");
if (crc32("MqWblvKet",9) == 2262647629) strcat(s, "h");
if (crc32("oPxpEldeHMX",11) == 2704659122) strcat(s, "l");
if (crc32("lulmDCICCK",10) == 3661650128) strcat(s, "b");
if (crc32("pWUQMhsajpU",11) == 2568768802) strcat(s, "R");
if (crc32("EnGcPZ",6) == 3036807955) strcat(s, "e");
if (crc32("uHnrxCGUETUZOD",14) == 1716401446) strcat(s, "r");
    return s;
}

char *Deron_nouns() {
    char *s = calloc(6);
    if (crc32("ENlvZyTNDx",10) == 1476754284) strcat(s, "y");
if (crc32("iUrWoICWmDmBfOi",15) == 3938549487) strcat(s, "D");
if (crc32("mcwcxoy",7) == 173173893) strcat(s, "e");
if (crc32("lGGRVs",6) == 1307586674) strcat(s, "G");
if (crc32("LHvPIrQykCKnhoI",15) == 3672043996) strcat(s, "r");
if (crc32("MNetARTQC",9) == 2678669367) strcat(s, "o");
if (crc32("RVzJnuDObr",10) == 125090983) strcat(s, "n");
    return s;
}

char *Wessex_nouns() {
    char *s = calloc(7);
    if (crc32("YRjdIEWWpQO",11) == 565627939) strcat(s, "H");
if (crc32("YBtBGf",6) == 886734975) strcat(s, "W");
if (crc32("zJHHAE",6) == 568853160) strcat(s, "C");
if (crc32("dujyj",5) == 3769332273) strcat(s, "e");
if (crc32("oqbwn",5) == 2414111832) strcat(s, "s");
if (crc32("uBakafABmKARnU",14) == 4204911463) strcat(s, "S");
if (crc32("wstRCM",6) == 1103882811) strcat(s, "s");
if (crc32("ESPGtrjEoVgddFq",15) == 3661833220) strcat(s, "e");
if (crc32("yFSgMEH",7) == 894588221) strcat(s, "z");
if (crc32("saycRJqFQbWnT",13) == 422711955) strcat(s, "x");
    return s;
}

char *Ultor_nouns() {
    char *s = calloc(6);
    if (crc32("qULnYHy",7) == 439760317) strcat(s, "x");
if (crc32("tKUzaDcYQRkeW",13) == 1714040776) strcat(s, "U");
if (crc32("VyQCatn",7) == 3587842024) strcat(s, "l");
if (crc32("XnuoiSy",7) == 113708289) strcat(s, "r");
if (crc32("AnMEqxNoMup",11) == 2921913483) strcat(s, "t");
if (crc32("qxzdzvCs",8) == 636408309) strcat(s, "s");
if (crc32("doGgVA",6) == 2678340230) strcat(s, "o");
if (crc32("JEjhLTFMKdsMq",13) == 292372912) strcat(s, "h");
if (crc32("tLCHgh",6) == 579822749) strcat(s, "r");
    return s;
}

char *sporicide_nouns() {
    char *s = calloc(10);
    if (crc32("xwEQPHQigb",10) == 2947765135) strcat(s, "s");
if (crc32("GmvSpXoUJJRoOr",14) == 2576248729) strcat(s, "M");
if (crc32("YaCIJpb",7) == 3762875231) strcat(s, "p");
if (crc32("rWGfQSekJrGjyqI",15) == 600771752) strcat(s, "C");
if (crc32("bzMDuB",6) == 2481717103) strcat(s, "o");
if (crc32("MZvQISJVgnoUpF",14) == 1023654440) strcat(s, "r");
if (crc32("jjexKLOrEva",11) == 609028444) strcat(s, "Q");
if (crc32("YnPKzJwKPgUvy",13) == 1799724504) strcat(s, "i");
if (crc32("KEDrUsZqUi",10) == 669335915) strcat(s, "c");
if (crc32("VvxTFZWYAYaNkL",14) == 2462978725) strcat(s, "i");
if (crc32("xtHHzvCS",8) == 4109398639) strcat(s, "d");
if (crc32("RpxglhIAGDC",11) == 3689796456) strcat(s, "Z");
if (crc32("igQsDqAMcuy",11) == 2030340699) strcat(s, "e");
    return s;
}

char *Othilia_nouns() {
    char *s = calloc(8);
    if (crc32("oqehuZOiVcbhXAn",15) == 230718108) strcat(s, "p");
if (crc32("SSmHaeCNwtdyukb",15) == 2768762463) strcat(s, "O");
if (crc32("cZJNmjZN",8) == 2833234315) strcat(s, "t");
if (crc32("zpnlXp",6) == 3746878107) strcat(s, "O");
if (crc32("udQdrBRBXpkSdxZ",15) == 2364025431) strcat(s, "h");
if (crc32("kSYQXoDMiQucBS",14) == 1525740005) strcat(s, "c");
if (crc32("MkavGv",6) == 962492162) strcat(s, "i");
if (crc32("Dvfwk",5) == 3544258215) strcat(s, "l");
if (crc32("tyxGfZPvH",9) == 3936353309) strcat(s, "i");
if (crc32("KbviewTtdxDYSaW",15) == 1473911816) strcat(s, "a");
    return s;
}

char *smaltite_nouns() {
    char *s = calloc(9);
    if (crc32("VTVevRzvnpiB",12) == 691011418) strcat(s, "y");
if (crc32("TVHCWsYA",8) == 1658593865) strcat(s, "s");
if (crc32("ivlKSMmGLevXevQ",15) == 2823440110) strcat(s, "m");
if (crc32("XgUxgLJWDcU",11) == 1644782992) strcat(s, "Z");
if (crc32("UsIsgrZJwF",10) == 777300243) strcat(s, "a");
if (crc32("gLOsgFRsFpeUe",13) == 3363162939) strcat(s, "t");
if (crc32("lMoPWzpCgaGE",12) == 1276114199) strcat(s, "l");
if (crc32("PdbGpbpvOsPbdE",14) == 1674677668) strcat(s, "t");
if (crc32("jSUWYpHaVUDtZ",13) == 490622261) strcat(s, "P");
if (crc32("GztojUGfmAgIPGc",15) == 1000288481) strcat(s, "i");
if (crc32("QBscXEKlBRM",11) == 1026587236) strcat(s, "t");
if (crc32("gFBwJhYLs",9) == 2036765027) strcat(s, "L");
if (crc32("FWfztAgQXN",10) == 3844610991) strcat(s, "e");
    return s;
}

char *hiddenite_nouns() {
    char *s = calloc(10);
    if (crc32("nhfdDgaUFxzN",12) == 2783492536) strcat(s, "U");
if (crc32("bHmOjkS",7) == 4054846960) strcat(s, "h");
if (crc32("TQqCMmZIlcewycT",15) == 3179046001) strcat(s, "i");
if (crc32("PPlHjK",6) == 4097501545) strcat(s, "d");
if (crc32("emSQeEz",7) == 2403882957) strcat(s, "d");
if (crc32("MMaLYNuNQimJ",12) == 1591345755) strcat(s, "e");
if (crc32("GSRtcO",6) == 1180913068) strcat(s, "n");
if (crc32("JeQNSlpy",8) == 3128130834) strcat(s, "i");
if (crc32("WoPPPOnqkYZ",11) == 2978329067) strcat(s, "t");
if (crc32("yKbZMIDLpBs",11) == 892716264) strcat(s, "O");
if (crc32("zdqHh",5) == 4026417447) strcat(s, "e");
    return s;
}

char *McQuoid_nouns() {
    char *s = calloc(8);
    if (crc32("ypZfuyqgt",9) == 1843173883) strcat(s, "a");
if (crc32("ceFRjw",6) == 3997482727) strcat(s, "M");
if (crc32("gBHDdSkSmYN",11) == 940682884) strcat(s, "c");
if (crc32("ljyyL",5) == 348972781) strcat(s, "Q");
if (crc32("HTXokOxDYMen",12) == 2781045840) strcat(s, "u");
if (crc32("SxAoWQw",7) == 1791264235) strcat(s, "o");
if (crc32("XxdACnSaeXc",11) == 3736273838) strcat(s, "X");
if (crc32("AaxfLnrfSkleK",13) == 935360050) strcat(s, "i");
if (crc32("iIvBdbQUPj",10) == 1028738519) strcat(s, "M");
if (crc32("LVuQtGL",7) == 356071444) strcat(s, "d");
    return s;
}

char *Georgy_nouns() {
    char *s = calloc(7);
    if (crc32("gdlwCqGQweHSdGV",15) == 2250596925) strcat(s, "f");
if (crc32("dqUYtHbqtbhhfHj",15) == 3744041074) strcat(s, "G");
if (crc32("FIznrdLpZqxvjkw",15) == 3057912576) strcat(s, "e");
if (crc32("vwiZeaMiZAKTJKw",15) == 4116847435) strcat(s, "N");
if (crc32("nUZRw",5) == 993309070) strcat(s, "o");
if (crc32("LMPokPfVhSan",12) == 3900733953) strcat(s, "r");
if (crc32("zlnbBmQDTUn",11) == 3392573554) strcat(s, "g");
if (crc32("dNopZFDQEFs",11) == 1818586447) strcat(s, "n");
if (crc32("qJlRXNJGzXSt",12) == 295045335) strcat(s, "y");
    return s;
}

char *research_nouns() {
    char *s = calloc(9);
    if (crc32("MwdKKbePoK",10) == 3957579211) strcat(s, "r");
if (crc32("QaHDCeJNuidFzO",14) == 454657736) strcat(s, "e");
if (crc32("HIwiHs",6) == 2424526130) strcat(s, "W");
if (crc32("glQVACNxLyCj",12) == 3132809154) strcat(s, "s");
if (crc32("joMIzilU",8) == 3770882712) strcat(s, "Y");
if (crc32("yElMSJVAK",9) == 3487771542) strcat(s, "e");
if (crc32("UIsnClcEbnzxxL",14) == 992115443) strcat(s, "a");
if (crc32("XTdPVux",7) == 1437908520) strcat(s, "w");
if (crc32("BnboVsGOrbUdJE",14) == 1949748604) strcat(s, "r");
if (crc32("JzHUJbYQlYGdQl",14) == 3834477546) strcat(s, "w");
if (crc32("yRAeJKaeYA",10) == 2937012225) strcat(s, "c");
if (crc32("czPjodY",7) == 2981016803) strcat(s, "h");
    return s;
}

char *Beverly_nouns() {
    char *s = calloc(8);
    if (crc32("LbaRBa",6) == 1056069992) strcat(s, "B");
if (crc32("FyTMGlYXXzHs",12) == 1410950523) strcat(s, "e");
if (crc32("yrNhwYj",7) == 747097862) strcat(s, "v");
if (crc32("ZBpdKBqkx",9) == 2249865050) strcat(s, "e");
if (crc32("wiEHyjUPJFBKaaj",15) == 2174474963) strcat(s, "M");
if (crc32("XzXKgMwuU",9) == 1026382407) strcat(s, "r");
if (crc32("uDxGXitcmo",10) == 1507852612) strcat(s, "l");
if (crc32("NOWxNfP",7) == 1898368852) strcat(s, "y");
    return s;
}

char *Eudorus_nouns() {
    char *s = calloc(8);
    if (crc32("dduNxAAYLrMkWG",14) == 805114702) strcat(s, "N");
if (crc32("GWoDpYuMYzRjmH",14) == 1078362613) strcat(s, "E");
if (crc32("eUmSFFd",7) == 2952233097) strcat(s, "Z");
if (crc32("dxHvNCwNuaT",11) == 2390403253) strcat(s, "u");
if (crc32("FfqxrnAfqXwyML",14) == 2688540798) strcat(s, "O");
if (crc32("nvpXvp",6) == 3579750974) strcat(s, "d");
if (crc32("ZhLIC",5) == 3025688801) strcat(s, "o");
if (crc32("MrRLut",6) == 2628944037) strcat(s, "o");
if (crc32("oftcNcwflsyHYm",14) == 3955850992) strcat(s, "D");
if (crc32("PKTpTwMjbAcm",12) == 4158160662) strcat(s, "r");
if (crc32("hipePhvWLAQWNri",15) == 3209894796) strcat(s, "f");
if (crc32("CGygkZNlt",9) == 3761885788) strcat(s, "u");
if (crc32("LRRHa",5) == 1198081030) strcat(s, "b");
if (crc32("qjWJkyRunJ",10) == 1147970320) strcat(s, "s");
    return s;
}

char *painter_nouns() {
    char *s = calloc(8);
    if (crc32("gHcVGVgaN",9) == 3763708922) strcat(s, "p");
if (crc32("PFvOdD",6) == 793582122) strcat(s, "a");
if (crc32("poWwuBogyu",10) == 1439730105) strcat(s, "Y");
if (crc32("MRnuiq",6) == 1512677237) strcat(s, "i");
if (crc32("prsMKyPjtdrsS",13) == 218431355) strcat(s, "n");
if (crc32("pjcIgOFtmVWUC",13) == 930402546) strcat(s, "U");
if (crc32("DDMOxkPk",8) == 2600918280) strcat(s, "t");
if (crc32("iZjTqvQk",8) == 812168612) strcat(s, "h");
if (crc32("wKLpoohesqJoCW",14) == 1725789641) strcat(s, "e");
if (crc32("ZrxxMFcgrMaQWX",14) == 4189808697) strcat(s, "r");
if (crc32("fiReJ",5) == 2009399499) strcat(s, "r");
    return s;
}

char *vagrancy_nouns() {
    char *s = calloc(9);
    if (crc32("lahLOtnelnYL",12) == 2438852048) strcat(s, "v");
if (crc32("crvlXdc",7) == 3510606161) strcat(s, "a");
if (crc32("XsxdXMmd",8) == 148208965) strcat(s, "e");
if (crc32("xQdoaj",6) == 1972303517) strcat(s, "g");
if (crc32("zUMlpKlItmEcca",14) == 2519921521) strcat(s, "r");
if (crc32("xLiVB",5) == 3984036183) strcat(s, "a");
if (crc32("gsrQuFt",7) == 175946660) strcat(s, "u");
if (crc32("wvRJUZIp",8) == 4081883747) strcat(s, "n");
if (crc32("bEvbda",6) == 788569036) strcat(s, "d");
if (crc32("MZuip",5) == 1961987914) strcat(s, "c");
if (crc32("nvvsBmrUoDfpdl",14) == 3246126281) strcat(s, "y");
if (crc32("zhVImKk",7) == 3917383325) strcat(s, "y");
    return s;
}

char *hyperopia_nouns() {
    char *s = calloc(10);
    if (crc32("MHgplBTwpEXQEiH",15) == 4292875372) strcat(s, "h");
if (crc32("ItzGxLLgnhxOmi",14) == 851463701) strcat(s, "y");
if (crc32("aEMDPlwApYvP",12) == 4158598734) strcat(s, "p");
if (crc32("pcFtyl",6) == 856459614) strcat(s, "e");
if (crc32("qZwrIiWJeYV",11) == 356149719) strcat(s, "M");
if (crc32("lbfVa",5) == 2445364823) strcat(s, "r");
if (crc32("XezFaWhzIxbDEWR",15) == 3409824189) strcat(s, "G");
if (crc32("CijnGdThsgR",11) == 3713397734) strcat(s, "o");
if (crc32("jMivhsBrvLxgj",13) == 1873400567) strcat(s, "p");
if (crc32("gfPdXZ",6) == 2210503023) strcat(s, "c");
if (crc32("YdyysebKJjjjT",13) == 4245886813) strcat(s, "i");
if (crc32("LgPbmU",6) == 2839961748) strcat(s, "a");
    return s;
}

char *aerotropism_nouns() {
    char *s = calloc(12);
    if (crc32("scsQRTHgOX",10) == 2983950448) strcat(s, "a");
if (crc32("yGrCQp",6) == 930299732) strcat(s, "e");
if (crc32("jHlWWYzZCgDb",12) == 2235478654) strcat(s, "Y");
if (crc32("YeiGxpPcMTtcdWL",15) == 638167641) strcat(s, "r");
if (crc32("wRALMeymawCImNq",15) == 3545175456) strcat(s, "Z");
if (crc32("RRMnUacS",8) == 1524327807) strcat(s, "o");
if (crc32("EPMtfgtMAxZRy",13) == 2881255809) strcat(s, "O");
if (crc32("wZsocuA",7) == 3716411084) strcat(s, "t");
if (crc32("YVImCXdz",8) == 2096413963) strcat(s, "r");
if (crc32("hpdUpGmSShI",11) == 3781238590) strcat(s, "o");
if (crc32("oXYEJjiSH",9) == 3800556806) strcat(s, "p");
if (crc32("LHGLQjjyQi",10) == 2055349847) strcat(s, "i");
if (crc32("jKDYbAgWmTKUOfi",15) == 3961853783) strcat(s, "i");
if (crc32("rrGgGpaBlSCWZAS",15) == 839403747) strcat(s, "s");
if (crc32("IjYCEBvTWHk",11) == 2496203223) strcat(s, "m");
    return s;
}

char *anticoincidence_nouns() {
    char *s = calloc(16);
    if (crc32("MDFWPCr",7) == 2767403817) strcat(s, "a");
if (crc32("otYYgCdpiJvrU",13) == 2343616735) strcat(s, "z");
if (crc32("QRpXAIO",7) == 409148601) strcat(s, "n");
if (crc32("MitkVs",6) == 3768052945) strcat(s, "L");
if (crc32("WsaAT",5) == 4192903434) strcat(s, "t");
if (crc32("sHHcSP",6) == 3124467596) strcat(s, "i");
if (crc32("iSYIXQjemJJVDj",14) == 817040171) strcat(s, "g");
if (crc32("rcKKzelI",8) == 4150466727) strcat(s, "c");
if (crc32("ILemaVwasnDPxk",14) == 510383168) strcat(s, "P");
if (crc32("dfGNPkXGuxFH",12) == 2355668050) strcat(s, "o");
if (crc32("vPBvVs",6) == 334993562) strcat(s, "l");
if (crc32("YLiDVYDRJRW",11) == 379126030) strcat(s, "i");
if (crc32("vTvcYiLsZgnuI",13) == 3527673289) strcat(s, "n");
if (crc32("zFPGDIdCFIJOZ",13) == 2805812572) strcat(s, "c");
if (crc32("GKdnuYeusrjo",12) == 2784589172) strcat(s, "C");
if (crc32("NcHypzlSl",9) == 2633743843) strcat(s, "i");
if (crc32("rGEjXIbANTjAp",13) == 1685914191) strcat(s, "P");
if (crc32("KNUOsThiqjR",11) == 1012038124) strcat(s, "d");
if (crc32("URPOK",5) == 2911278573) strcat(s, "e");
if (crc32("tXTtJSjWKC",10) == 212439641) strcat(s, "n");
if (crc32("szBqVkJo",8) == 2287854325) strcat(s, "m");
if (crc32("qaKmqHzByPSOdA",14) == 2344640649) strcat(s, "c");
if (crc32("hcNYck",6) == 132225932) strcat(s, "e");
    return s;
}

char *cental_nouns() {
    char *s = calloc(7);
    if (crc32("WBXjLEwSIAvG",12) == 3650152281) strcat(s, "c");
if (crc32("LSyZXkXqO",9) == 3329655131) strcat(s, "v");
if (crc32("XiwKSUvTbg",10) == 2181406255) strcat(s, "e");
if (crc32("WzuBjQJ",7) == 3460400172) strcat(s, "s");
if (crc32("qTLQeJMHGVMwRbh",15) == 3723384412) strcat(s, "n");
if (crc32("MABbjGy",7) == 1716691127) strcat(s, "r");
if (crc32("KVGnkBcIm",9) == 486743250) strcat(s, "t");
if (crc32("CyoByYTrDFzpU",13) == 1083076627) strcat(s, "F");
if (crc32("OxTozoO",7) == 1005067763) strcat(s, "a");
if (crc32("SJdOhzmitLLegrF",15) == 1285010531) strcat(s, "e");
if (crc32("IMvSTXPhnuv",11) == 2910305381) strcat(s, "l");
    return s;
}

char *accra_nouns() {
    char *s = calloc(6);
    if (crc32("lOtqHI",6) == 1383162887) strcat(s, "R");
if (crc32("DkiokHs",7) == 223494830) strcat(s, "a");
if (crc32("SuvhKHBuKRDQppQ",15) == 646865169) strcat(s, "S");
if (crc32("uTrVUK",6) == 2826657734) strcat(s, "c");
if (crc32("EwebXPwBbfz",11) == 184895775) strcat(s, "M");
if (crc32("SnIaXoeGHKqVpB",14) == 2996684287) strcat(s, "c");
if (crc32("OJvibQ",6) == 3500818612) strcat(s, "c");
if (crc32("LnxGQ",5) == 2037269293) strcat(s, "r");
if (crc32("uetORdSxjVG",11) == 2334084932) strcat(s, "g");
if (crc32("gswFEfJzGUBB",12) == 1532065440) strcat(s, "a");
    return s;
}

char *beetlehead_nouns() {
    char *s = calloc(11);
    if (crc32("oaVifMoTXBNO",12) == 3432657801) strcat(s, "a");
if (crc32("NobalfnfieK",11) == 3052898703) strcat(s, "b");
if (crc32("luBIFIvzAOJnkL",14) == 864257133) strcat(s, "e");
if (crc32("jjRwuJFdfSsQimr",15) == 3962125822) strcat(s, "e");
if (crc32("aUYVQeniuqe",11) == 1143945603) strcat(s, "e");
if (crc32("wtwuqrR",7) == 4267457462) strcat(s, "t");
if (crc32("bhjDBmbWVNH",11) == 1771016053) strcat(s, "l");
if (crc32("fomJz",5) == 1230828923) strcat(s, "e");
if (crc32("OfliXaK",7) == 338274714) strcat(s, "h");
if (crc32("DepxK",5) == 3862983710) strcat(s, "q");
if (crc32("jHXtyomuRg",10) == 696496966) strcat(s, "e");
if (crc32("zkqcis",6) == 297307056) strcat(s, "a");
if (crc32("uuNixtZXkmCwOL",14) == 3181159439) strcat(s, "a");
if (crc32("sCSUm",5) == 1808056012) strcat(s, "d");
    return s;
}

char *kielbasa_nouns() {
    char *s = calloc(9);
    if (crc32("HwPQZUCpia",10) == 2834391646) strcat(s, "n");
if (crc32("rENsVoFAVufy",12) == 2850096403) strcat(s, "k");
if (crc32("BrRbQgpuTo",10) == 4097937312) strcat(s, "z");
if (crc32("OysRxMhQis",10) == 4016265071) strcat(s, "i");
if (crc32("DfiedmH",7) == 1523779110) strcat(s, "q");
if (crc32("yyCpSbKAugHi",12) == 407690575) strcat(s, "e");
if (crc32("OIwsHL",6) == 2285871654) strcat(s, "g");
if (crc32("wbkWmA",6) == 273388588) strcat(s, "l");
if (crc32("smdbFuCkLc",10) == 3057100452) strcat(s, "b");
if (crc32("cOJPzoC",7) == 4185398408) strcat(s, "Z");
if (crc32("BaAhfy",6) == 672330816) strcat(s, "a");
if (crc32("ONLcBI",6) == 4262705533) strcat(s, "s");
if (crc32("BXACkHsqLwkCB",13) == 945872898) strcat(s, "M");
if (crc32("tOpNFCmx",8) == 1370781414) strcat(s, "a");
    return s;
}

char *Falk_nouns() {
    char *s = calloc(5);
    if (crc32("NgnEslScIDxDl",13) == 1042270675) strcat(s, "Z");
if (crc32("WvvFQO",6) == 2841359013) strcat(s, "F");
if (crc32("cnncWAzeqzjiQd",14) == 3609573087) strcat(s, "A");
if (crc32("WnVxekoFA",9) == 3416867870) strcat(s, "a");
if (crc32("FPeHNwvLSjg",11) == 2275401523) strcat(s, "l");
if (crc32("sRZvQOVIi",9) == 3642398338) strcat(s, "k");
    return s;
}

char *Soo_nouns() {
    char *s = calloc(4);
    if (crc32("iLMjkEXcSyXTfv",14) == 2803027384) strcat(s, "r");
if (crc32("TOEzEyVJ",8) == 1744367096) strcat(s, "S");
if (crc32("ChvfuUGKvtPtcyz",15) == 3071973287) strcat(s, "o");
if (crc32("VpVOcV",6) == 3418356896) strcat(s, "o");
    return s;
}

char *Cesena_nouns() {
    char *s = calloc(7);
    if (crc32("GDSLMjynCeVRHk",14) == 1850978740) strcat(s, "C");
if (crc32("JlDyv",5) == 1922249920) strcat(s, "F");
if (crc32("DLLpO",5) == 172998466) strcat(s, "e");
if (crc32("JiPnwaBdiX",10) == 155489656) strcat(s, "s");
if (crc32("yNDWRzUhhxsnhd",14) == 1019709280) strcat(s, "e");
if (crc32("cgBtKJQFNzgyiK",14) == 2101708313) strcat(s, "n");
if (crc32("UWblgDzwawfV",12) == 157792714) strcat(s, "a");
    return s;
}

char *Harilda_nouns() {
    char *s = calloc(8);
    if (crc32("sKMMtGyyEYmxK",13) == 110460742) strcat(s, "K");
if (crc32("aINoZcH",7) == 1266718806) strcat(s, "H");
if (crc32("fTpBxPFChl",10) == 3679074924) strcat(s, "v");
if (crc32("rIefSjaSZiLyU",13) == 2159201322) strcat(s, "a");
if (crc32("kwSGspZp",8) == 1870673935) strcat(s, "W");
if (crc32("WMfFbT",6) == 1371390065) strcat(s, "r");
if (crc32("QAfmTLytt",9) == 1220829466) strcat(s, "X");
if (crc32("UAEGA",5) == 3721096977) strcat(s, "i");
if (crc32("HVcSXEIdrm",10) == 3572526293) strcat(s, "l");
if (crc32("KeSuw",5) == 388653233) strcat(s, "d");
if (crc32("oBeiaXtjlefM",12) == 592837185) strcat(s, "a");
    return s;
}

char *Belfort_nouns() {
    char *s = calloc(8);
    if (crc32("MHWCCcfQA",9) == 2230539944) strcat(s, "B");
if (crc32("TSnlAYOCHNh",11) == 734234083) strcat(s, "e");
if (crc32("UbChLxehXzliV",13) == 1392725447) strcat(s, "l");
if (crc32("NoBAKYfQ",8) == 507411067) strcat(s, "v");
if (crc32("vMhIuGgCwRbr",12) == 47314429) strcat(s, "f");
if (crc32("RmJjLPuRd",9) == 2117158137) strcat(s, "o");
if (crc32("MjqNWmxN",8) == 3967551300) strcat(s, "Q");
if (crc32("bTSsisBJ",8) == 1354874564) strcat(s, "r");
if (crc32("NLUkwtznEmpYG",13) == 1434964724) strcat(s, "Y");
if (crc32("zHAeAa",6) == 3449521557) strcat(s, "t");
    return s;
}

char *spurter_nouns() {
    char *s = calloc(8);
    if (crc32("enKHaPs",7) == 3101423675) strcat(s, "f");
if (crc32("pMZYrz",6) == 1887914293) strcat(s, "s");
if (crc32("backj",5) == 1895775374) strcat(s, "f");
if (crc32("GocsxoEeDoIkcsp",15) == 975840696) strcat(s, "p");
if (crc32("mxyJwqAHMFKQbo",14) == 690567492) strcat(s, "u");
if (crc32("sfjZNUjqqHOMOL",14) == 420903600) strcat(s, "r");
if (crc32("JVYzhhyD",8) == 2899478031) strcat(s, "I");
if (crc32("GzlBUOYbCtHNl",13) == 1426471705) strcat(s, "t");
if (crc32("rEJbLgx",7) == 931170825) strcat(s, "e");
if (crc32("lHrCGUywnZD",11) == 1472424796) strcat(s, "Q");
if (crc32("WgrajSj",7) == 399957067) strcat(s, "r");
    return s;
}

char *Lisk_nouns() {
    char *s = calloc(5);
    if (crc32("VnzqqC",6) == 3310852455) strcat(s, "L");
if (crc32("dtoYziZE",8) == 265008635) strcat(s, "g");
if (crc32("vybfNNuZ",8) == 4254745767) strcat(s, "i");
if (crc32("GmtBiFsxYWTlWJ",14) == 2948160051) strcat(s, "s");
if (crc32("pLEpXdLB",8) == 1776766688) strcat(s, "k");
    return s;
}

char *pad_nouns() {
    char *s = calloc(4);
    if (crc32("cfvpjfOapRZNY",13) == 2960021728) strcat(s, "p");
if (crc32("lYbSXHsn",8) == 4258640681) strcat(s, "t");
if (crc32("EEALTfq",7) == 529236964) strcat(s, "a");
if (crc32("vIqiII",6) == 1789885205) strcat(s, "T");
if (crc32("EVtdordbIe",10) == 1417050963) strcat(s, "d");
    return s;
}

char *Ira_nouns() {
    char *s = calloc(4);
    if (crc32("MsRQJYWBLpt",11) == 3742239013) strcat(s, "I");
if (crc32("lxzYIansWq",10) == 702041248) strcat(s, "g");
if (crc32("KdEOZZBYIGtLF",13) == 2934878568) strcat(s, "r");
if (crc32("SxiSzuTLNMZwK",13) == 1848635634) strcat(s, "V");
if (crc32("letvxn",6) == 1726679607) strcat(s, "a");
    return s;
}

char *peke_nouns() {
    char *s = calloc(5);
    if (crc32("usYOxU",6) == 1509797082) strcat(s, "Y");
if (crc32("QRaEDjw",7) == 2012225757) strcat(s, "p");
if (crc32("GiHEY",5) == 1560602599) strcat(s, "t");
if (crc32("CFSbFvG",7) == 987244617) strcat(s, "e");
if (crc32("tCeVBgRX",8) == 409054684) strcat(s, "T");
if (crc32("BujWEGlPO",9) == 1196756883) strcat(s, "k");
if (crc32("EmXaHcE",7) == 2183388235) strcat(s, "e");
    return s;
}

char *nondefilement_nouns() {
    char *s = calloc(14);
    if (crc32("WDbXSMqOwzy",11) == 1384960637) strcat(s, "n");
if (crc32("lHUgmak",7) == 2228845016) strcat(s, "Z");
if (crc32("lnWGn",5) == 1037582537) strcat(s, "o");
if (crc32("NRNNUAGqB",9) == 4201292611) strcat(s, "V");
if (crc32("jRbWYj",6) == 1690073298) strcat(s, "n");
if (crc32("FKtHlDKcubBuVPs",15) == 3618383727) strcat(s, "e");
if (crc32("CQVoAPqpJumtfci",15) == 2821538244) strcat(s, "d");
if (crc32("OqWQVsORoZLm",12) == 2816143075) strcat(s, "e");
if (crc32("kvParhkQpnR",11) == 3214012555) strcat(s, "O");
if (crc32("pzjFRmHKNJwFu",13) == 2609625719) strcat(s, "f");
if (crc32("WrLYYvyEXAYZF",13) == 793366625) strcat(s, "i");
if (crc32("YUkBHlyGMopOG",13) == 1294253861) strcat(s, "l");
if (crc32("tbuxGZSAEQokTGO",15) == 1480226977) strcat(s, "e");
if (crc32("cHNDlj",6) == 2227342772) strcat(s, "j");
if (crc32("MzNPSU",6) == 747039277) strcat(s, "m");
if (crc32("oGaXNfe",7) == 505241844) strcat(s, "l");
if (crc32("KrPzz",5) == 562811324) strcat(s, "e");
if (crc32("LEJDJgqFVv",10) == 2362629208) strcat(s, "n");
if (crc32("IOWYdMgNlf",10) == 3955916915) strcat(s, "t");
    return s;
}

char *Denpasar_nouns() {
    char *s = calloc(9);
    if (crc32("xgNvISFgLXGb",12) == 2661421560) strcat(s, "I");
if (crc32("CtaOK",5) == 3805710474) strcat(s, "D");
if (crc32("hkdzcCpjmeHw",12) == 581800597) strcat(s, "S");
if (crc32("SQgPTjkBfKmSXX",14) == 485810385) strcat(s, "e");
if (crc32("jLpDOItCXW",10) == 2312278326) strcat(s, "D");
if (crc32("SRFAzKblLatTeg",14) == 3499591180) strcat(s, "n");
if (crc32("UVougMGPn",9) == 1285352283) strcat(s, "p");
if (crc32("rGXsfwRqfYvdgIT",15) == 1154055360) strcat(s, "d");
if (crc32("mdekkuki",8) == 3952372585) strcat(s, "a");
if (crc32("BnbfmVb",7) == 2397829923) strcat(s, "s");
if (crc32("GWDNCw",6) == 4028105485) strcat(s, "s");
if (crc32("VBIovb",6) == 912786638) strcat(s, "a");
if (crc32("wAEleWAAiVjv",12) == 696302102) strcat(s, "r");
    return s;
}

char *Riha_nouns() {
    char *s = calloc(5);
    if (crc32("xZDCAIvkINtmX",13) == 4031791188) strcat(s, "R");
if (crc32("mFdcpgGfsJkCnS",14) == 1415998864) strcat(s, "v");
if (crc32("MZpVIGKaMPAw",12) == 3967502941) strcat(s, "i");
if (crc32("iZFmL",5) == 2001865001) strcat(s, "V");
if (crc32("sQalTCausfwvbr",14) == 1542523676) strcat(s, "h");
if (crc32("LWnsUsEWyQx",11) == 3333420073) strcat(s, "a");
    return s;
}

char *priority_nouns() {
    char *s = calloc(9);
    if (crc32("BwfzbUjKFrcvdjw",15) == 1764839293) strcat(s, "V");
if (crc32("sMXacA",6) == 2494598412) strcat(s, "p");
if (crc32("bFGkaBxhylupc",13) == 2411011672) strcat(s, "w");
if (crc32("SlrjrL",6) == 2165272984) strcat(s, "r");
if (crc32("vPwEKqMjQJAtGl",14) == 2138051610) strcat(s, "i");
if (crc32("pQzCqGvTbw",10) == 2927596748) strcat(s, "o");
if (crc32("pRMoWqdemSYad",13) == 3837216518) strcat(s, "r");
if (crc32("OzDNtTCHEoXQ",12) == 1933821477) strcat(s, "B");
if (crc32("NyjwEpH",7) == 2708899301) strcat(s, "i");
if (crc32("jrhICkkacZ",10) == 787870525) strcat(s, "t");
if (crc32("JpZbFt",6) == 4168861000) strcat(s, "y");
    return s;
}

char *ayin_nouns() {
    char *s = calloc(5);
    if (crc32("zVNxTjGGcXjmAlX",15) == 109074184) strcat(s, "a");
if (crc32("XgxmruNLF",9) == 2459290614) strcat(s, "X");
if (crc32("ktIiAVkRMXSlYn",14) == 1159220014) strcat(s, "y");
if (crc32("yJvUjKDv",8) == 1058804884) strcat(s, "d");
if (crc32("NoQYMlEmls",10) == 3429316995) strcat(s, "i");
if (crc32("sMzQUtKVpxL",11) == 1523503596) strcat(s, "Y");
if (crc32("IsTpeCL",7) == 2378645914) strcat(s, "n");
    return s;
}

char *secant_nouns() {
    char *s = calloc(7);
    if (crc32("SDInqAWoSk",10) == 2092455274) strcat(s, "H");
if (crc32("HRYRsOQtiEVA",12) == 4069840190) strcat(s, "s");
if (crc32("aFCRkX",6) == 750130199) strcat(s, "O");
if (crc32("EWgYe",5) == 466794832) strcat(s, "e");
if (crc32("StMowuRC",8) == 3447864120) strcat(s, "c");
if (crc32("IHgKBy",6) == 3233718283) strcat(s, "a");
if (crc32("tukqxGl",7) == 1109130184) strcat(s, "n");
if (crc32("EuBESXtJio",10) == 2087082368) strcat(s, "Y");
if (crc32("ItkRWfZev",9) == 544003314) strcat(s, "t");
    return s;
}

char *oneirocriticism_nouns() {
    char *s = calloc(16);
    if (crc32("SxHjJUqyabGzM",13) == 2657166312) strcat(s, "o");
if (crc32("LLbLmo",6) == 2980773107) strcat(s, "n");
if (crc32("ZAhZwRfoq",9) == 214630835) strcat(s, "i");
if (crc32("sOblOgiSo",9) == 3410635713) strcat(s, "e");
if (crc32("scGurI",6) == 2752969518) strcat(s, "i");
if (crc32("AQLaAAB",7) == 2796807872) strcat(s, "r");
if (crc32("fcAecuotwXZaiH",14) == 4000056965) strcat(s, "c");
if (crc32("HDcewwcuLRYKLPg",15) == 1622704903) strcat(s, "o");
if (crc32("cozKlGqsgD",10) == 1790973898) strcat(s, "c");
if (crc32("jMBaMTfu",8) == 4128558375) strcat(s, "r");
if (crc32("cypcACMhiCZLI",13) == 1102601607) strcat(s, "i");
if (crc32("HJfnjxzip",9) == 567531434) strcat(s, "t");
if (crc32("AiPlPVPTDlnI",12) == 1900456381) strcat(s, "k");
if (crc32("BpejLhsSBwg",11) == 2219116239) strcat(s, "i");
if (crc32("lnNslahlMoouR",13) == 4125606830) strcat(s, "c");
if (crc32("nGetryPrgEPpGY",14) == 1740196394) strcat(s, "f");
if (crc32("jyyBhJci",8) == 2865141664) strcat(s, "i");
if (crc32("zoyKNzDckC",10) == 822478062) strcat(s, "m");
if (crc32("TssljYCcJANht",13) == 4035764826) strcat(s, "s");
if (crc32("lfDkQjgBirq",11) == 533287282) strcat(s, "K");
if (crc32("umkYxInGohgYMc",14) == 2078926346) strcat(s, "m");
    return s;
}

char *Longan_nouns() {
    char *s = calloc(7);
    if (crc32("ZbPAWsELp",9) == 3608866706) strcat(s, "c");
if (crc32("bhJEQMW",7) == 114120442) strcat(s, "L");
if (crc32("WcLkzgSdznE",11) == 1925768412) strcat(s, "Q");
if (crc32("ienDuhhg",8) == 2287093882) strcat(s, "o");
if (crc32("MrAfpiSGo",9) == 2823002429) strcat(s, "n");
if (crc32("bTSOtOssae",10) == 2151701914) strcat(s, "R");
if (crc32("NmlNFfPXQwlalI",14) == 812415639) strcat(s, "g");
if (crc32("IbqGCK",6) == 2490619098) strcat(s, "N");
if (crc32("dWGLFy",6) == 1479395855) strcat(s, "a");
if (crc32("oLbxbzHIoXCldVn",15) == 2219452621) strcat(s, "o");
if (crc32("wRomOioIdIBtuY",14) == 1442603260) strcat(s, "n");
    return s;
}

char *Ziska_nouns() {
    char *s = calloc(6);
    if (crc32("VChaYIduMIB",11) == 446244145) strcat(s, "Z");
if (crc32("DUIWuIDBjCqtPE",14) == 3621332281) strcat(s, "l");
if (crc32("UAnTcDVdXbTuGlx",15) == 1353338846) strcat(s, "i");
if (crc32("jEYZh",5) == 3082687600) strcat(s, "X");
if (crc32("TRAdRMqjacl",11) == 1462598414) strcat(s, "s");
if (crc32("gCsQzncSfVtOhs",14) == 2744179430) strcat(s, "P");
if (crc32("zuFSjTFysqbX",12) == 1192664305) strcat(s, "k");
if (crc32("lGDGAdp",7) == 4000493475) strcat(s, "Z");
if (crc32("MyKhfDNLFGiIt",13) == 1976195772) strcat(s, "a");
    return s;
}

char *Dunker_nouns() {
    char *s = calloc(7);
    if (crc32("EbZZaRVvVCacOr",14) == 3906183354) strcat(s, "h");
if (crc32("SRonvjS",7) == 864055941) strcat(s, "D");
if (crc32("YcDtj",5) == 1276531064) strcat(s, "n");
if (crc32("NVqEWCwWlmq",11) == 421309486) strcat(s, "u");
if (crc32("aDOrmNQeknD",11) == 2586265063) strcat(s, "n");
if (crc32("WnDQhyFrDpNuB",13) == 4009185188) strcat(s, "n");
if (crc32("oIVfwbtY",8) == 2508252698) strcat(s, "k");
if (crc32("XHCNejXVSVX",11) == 182745308) strcat(s, "R");
if (crc32("LYgDGhg",7) == 17134442) strcat(s, "e");
if (crc32("ZZXlQVcjkQXne",13) == 3601184497) strcat(s, "I");
if (crc32("hUBOPr",6) == 3959257888) strcat(s, "r");
    return s;
}

char *basil_nouns() {
    char *s = calloc(6);
    if (crc32("AEBPoeOliUCM",12) == 318281775) strcat(s, "b");
if (crc32("JwFCxGf",7) == 1722383571) strcat(s, "r");
if (crc32("iacbIigptbdMOyG",15) == 2766985579) strcat(s, "a");
if (crc32("PzosCkaJDOn",11) == 1973500644) strcat(s, "Z");
if (crc32("gyHwVouwKEUQQE",14) == 3743689372) strcat(s, "s");
if (crc32("SferJRNNEGqTRm",14) == 304940524) strcat(s, "M");
if (crc32("IwFMrywdZRxrmrx",15) == 4135759152) strcat(s, "i");
if (crc32("myIMjmvHLgv",11) == 2466906963) strcat(s, "p");
if (crc32("xMApQpLx",8) == 667910499) strcat(s, "l");
    return s;
}

char *hippo_nouns() {
    char *s = calloc(6);
    if (crc32("bTDmqugRuk",10) == 222083465) strcat(s, "x");
if (crc32("UQSxZYIW",8) == 2912410493) strcat(s, "h");
if (crc32("pYtirCucOqDAWX",14) == 2694661112) strcat(s, "u");
if (crc32("GBGgQuBoicnn",12) == 3599452195) strcat(s, "i");
if (crc32("eXPoZL",6) == 4205493000) strcat(s, "U");
if (crc32("mEUZy",5) == 145784051) strcat(s, "p");
if (crc32("xQUPMrpkeafOTL",14) == 4230354768) strcat(s, "x");
if (crc32("VpiWDRxeUKahk",13) == 1668602796) strcat(s, "p");
if (crc32("bdIQNfJyCj",10) == 2578135121) strcat(s, "B");
if (crc32("NPDPEoXEoR",10) == 3300290342) strcat(s, "o");
    return s;
}

char *prideofCalifornia_nouns() {
    char *s = calloc(18);
    if (crc32("XBADxnYtphGVfN",14) == 90138404) strcat(s, "F");
if (crc32("KNVwFOVPey",10) == 2569885197) strcat(s, "p");
if (crc32("MseWMVGLFVC",11) == 3809261923) strcat(s, "c");
if (crc32("jlFVzkJBMqVGH",13) == 176067397) strcat(s, "r");
if (crc32("tKogWUCFav",10) == 3549404860) strcat(s, "N");
if (crc32("kHscKFjcX",9) == 1859888160) strcat(s, "i");
if (crc32("mOdvLV",6) == 3832827652) strcat(s, "q");
if (crc32("YLtRrRG",7) == 162361328) strcat(s, "d");
if (crc32("nwbUvewUHudjLUJ",15) == 1298673357) strcat(s, "B");
if (crc32("nszmewFavTSSW",13) == 4239217074) strcat(s, "e");
if (crc32("ydran",5) == 4238961885) strcat(s, "B");
if (crc32("mbxNnnEmDkXU",12) == 790015255) strcat(s, "o");
if (crc32("nROcnkVALJ",10) == 2769612317) strcat(s, "x");
if (crc32("vhYuVWGwuQZV",12) == 2060959835) strcat(s, "f");
if (crc32("lRVFKNLSFAWPgo",14) == 3141734996) strcat(s, "z");
if (crc32("BJMgyjiNHMpEw",13) == 102922530) strcat(s, "C");
if (crc32("JZIfyZmEGtAsm",13) == 3879359724) strcat(s, "g");
if (crc32("tILFm",5) == 3234604903) strcat(s, "a");
if (crc32("EBWVmnF",7) == 71395262) strcat(s, "z");
if (crc32("nnnWrrjgc",9) == 2225646378) strcat(s, "l");
if (crc32("glsJImoRl",9) == 966862293) strcat(s, "i");
if (crc32("ruyQdjKdgjc",11) == 3048911437) strcat(s, "h");
if (crc32("gcPwdgAbve",10) == 1569151709) strcat(s, "f");
if (crc32("yXokjEUEX",9) == 3733324792) strcat(s, "o");
if (crc32("xcEUNFQSGHtAj",13) == 502916754) strcat(s, "r");
if (crc32("LzmbeGuYyu",10) == 112342680) strcat(s, "n");
if (crc32("IQWDMaFdhfVKD",13) == 1850095795) strcat(s, "i");
if (crc32("tMvCkVwJHwStXnA",15) == 2031855105) strcat(s, "a");
    return s;
}

char *ctenizid_nouns() {
    char *s = calloc(9);
    if (crc32("OlRCViJv",8) == 2634838411) strcat(s, "c");
if (crc32("EqMSrPidSOExj",13) == 3480711963) strcat(s, "L");
if (crc32("qaPinrWh",8) == 2326399498) strcat(s, "t");
if (crc32("YEXwU",5) == 1403495232) strcat(s, "Y");
if (crc32("kngMSXwOCGN",11) == 2065900746) strcat(s, "e");
if (crc32("jUrcQj",6) == 2286452210) strcat(s, "I");
if (crc32("VPaAqi",6) == 2744017752) strcat(s, "n");
if (crc32("udhDNe",6) == 3585724588) strcat(s, "J");
if (crc32("knPWM",5) == 1645406591) strcat(s, "i");
if (crc32("hWbKYfLbnc",10) == 1608131770) strcat(s, "M");
if (crc32("euFlL",5) == 153389036) strcat(s, "z");
if (crc32("cEyTfU",6) == 2901481050) strcat(s, "e");
if (crc32("cDMZnZbUWIiSnF",14) == 2883718608) strcat(s, "i");
if (crc32("LPgXxe",6) == 4012602084) strcat(s, "d");
    return s;
}

char *Kailua_nouns() {
    char *s = calloc(7);
    if (crc32("rWTtSomzHiceo",13) == 160253695) strcat(s, "K");
if (crc32("uYuYqkgmm",9) == 1031686968) strcat(s, "H");
if (crc32("RhRblLyPzJkv",12) == 3636960614) strcat(s, "a");
if (crc32("reRHaJGq",8) == 3161500261) strcat(s, "u");
if (crc32("tvakCVO",7) == 1746632239) strcat(s, "i");
if (crc32("ULfBoFpmN",9) == 4011540263) strcat(s, "D");
if (crc32("xNeKWqkWqf",10) == 207343374) strcat(s, "l");
if (crc32("JvGhw",5) == 2359678656) strcat(s, "u");
if (crc32("xQOrQOHVmnhdJu",14) == 3141052535) strcat(s, "L");
if (crc32("cYGEz",5) == 3871212175) strcat(s, "a");
    return s;
}

char *opus_nouns() {
    char *s = calloc(5);
    if (crc32("YxDuNShwXejNCP",14) == 3238760679) strcat(s, "e");
if (crc32("qAVUGNOLSCJmHCz",15) == 3969863133) strcat(s, "o");
if (crc32("HPVELtVdaLlJRK",14) == 1740413232) strcat(s, "j");
if (crc32("KioTH",5) == 1249180451) strcat(s, "p");
if (crc32("pemlRcdbTDWk",12) == 1517721041) strcat(s, "m");
if (crc32("rCcBHD",6) == 4226248247) strcat(s, "u");
if (crc32("yNdCPjYaknpsW",13) == 3288212686) strcat(s, "u");
if (crc32("QsAbBAWUPiPumUR",15) == 1277092941) strcat(s, "s");
    return s;
}

char *hypoendocrinism_nouns() {
    char *s = calloc(16);
    if (crc32("KLseKXSJ",8) == 3090416369) strcat(s, "i");
if (crc32("FDWuwhYBMkr",11) == 3114177696) strcat(s, "h");
if (crc32("GUtMUW",6) == 571437273) strcat(s, "k");
if (crc32("KzeEn",5) == 2224758889) strcat(s, "y");
if (crc32("IYQnuoJU",8) == 177235698) strcat(s, "p");
if (crc32("kCeUJfRWdQ",10) == 1397007211) strcat(s, "A");
if (crc32("ZsIQYmvBL",9) == 620565623) strcat(s, "o");
if (crc32("ALjEkblRWT",10) == 4223215097) strcat(s, "e");
if (crc32("BVhLEphX",8) == 127141437) strcat(s, "n");
if (crc32("puGWCLjuNjrRn",13) == 4075321501) strcat(s, "T");
if (crc32("jsgPoGmmele",11) == 3563551789) strcat(s, "d");
if (crc32("aiqxCGx",7) == 1656450433) strcat(s, "w");
if (crc32("ndJKN",5) == 2877336618) strcat(s, "o");
if (crc32("uEaKcRPOI",9) == 3738545593) strcat(s, "c");
if (crc32("glFBQjYAnylnZP",14) == 346840054) strcat(s, "r");
if (crc32("OsYoeNWgmKjS",12) == 1050450334) strcat(s, "a");
if (crc32("YgWaqfTZEd",10) == 3627214092) strcat(s, "i");
if (crc32("BpkeFEyrKOO",11) == 1461347598) strcat(s, "Z");
if (crc32("XFvTwWXwwAfz",12) == 1152978608) strcat(s, "n");
if (crc32("zmbJWa",6) == 1505005883) strcat(s, "i");
if (crc32("ireleMScpbqAh",13) == 198148316) strcat(s, "s");
if (crc32("eCqqdkyc",8) == 4226397821) strcat(s, "n");
if (crc32("nBBMzwcdkhZmCD",14) == 1538745093) strcat(s, "m");
    return s;
}

char *horsepower_nouns() {
    char *s = calloc(11);
    if (crc32("wgiPlhanrRi",11) == 382665427) strcat(s, "h");
if (crc32("rheoUIOSAs",10) == 2537269632) strcat(s, "o");
if (crc32("LKWQDMIX",8) == 1641745167) strcat(s, "r");
if (crc32("RkandLLOhITDCE",14) == 1009822535) strcat(s, "s");
if (crc32("bcstLGE",7) == 4163083485) strcat(s, "u");
if (crc32("umqQoakF",8) == 2635613484) strcat(s, "e");
if (crc32("HHNMt",5) == 939341072) strcat(s, "A");
if (crc32("XXmFCVXCA",9) == 3543514056) strcat(s, "p");
if (crc32("voOzc",5) == 2841144900) strcat(s, "o");
if (crc32("fDaxUCKfzbjYa",13) == 3955279429) strcat(s, "H");
if (crc32("hWaVc",5) == 1224054701) strcat(s, "w");
if (crc32("gAIAi",5) == 662248135) strcat(s, "d");
if (crc32("pNFlJEeEbcLgPtD",15) == 2944785449) strcat(s, "e");
if (crc32("CAbRSSOxQO",10) == 1351946780) strcat(s, "r");
    return s;
}

char *shirt_nouns() {
    char *s = calloc(6);
    if (crc32("KMSwLgI",7) == 1340791031) strcat(s, "R");
if (crc32("tgvVmJI",7) == 1305958269) strcat(s, "s");
if (crc32("OjIXzAXHSJ",10) == 798751213) strcat(s, "n");
if (crc32("viLaqnqGotx",11) == 2559804287) strcat(s, "h");
if (crc32("pXaVvY",6) == 2265931988) strcat(s, "F");
if (crc32("ctlIt",5) == 3421748838) strcat(s, "i");
if (crc32("ucMusqlruMOKXik",15) == 3913618854) strcat(s, "r");
if (crc32("tbwVYadSgF",10) == 1749241352) strcat(s, "t");
    return s;
}

char *treachery_nouns() {
    char *s = calloc(10);
    if (crc32("VLXLq",5) == 3117552728) strcat(s, "t");
if (crc32("spKcsTqVpTricMF",15) == 2368917583) strcat(s, "D");
if (crc32("ROJLSLSCABJCyf",14) == 1971646395) strcat(s, "r");
if (crc32("vrXWWdDDAB",10) == 3377796348) strcat(s, "e");
if (crc32("kcrZigPfbjXt",12) == 3638901294) strcat(s, "J");
if (crc32("kWYnTZzV",8) == 1909355136) strcat(s, "a");
if (crc32("xfQHEYFHeDM",11) == 168532541) strcat(s, "c");
if (crc32("XBIfMQqswp",10) == 495355726) strcat(s, "d");
if (crc32("ZjVBKBsXNP",10) == 2637453663) strcat(s, "h");
if (crc32("jleWQzQaAjZgl",13) == 980608888) strcat(s, "H");
if (crc32("btKAAzgOIYu",11) == 2979037923) strcat(s, "e");
if (crc32("sMaMHivTIbZK",12) == 1227623734) strcat(s, "L");
if (crc32("sKACwcaWELBG",12) == 3789716566) strcat(s, "r");
if (crc32("PhhvhUtFeoJM",12) == 3974085751) strcat(s, "d");
if (crc32("TNCsAcvcEpY",11) == 2660700382) strcat(s, "y");
    return s;
}

char *Lauenburg_nouns() {
    char *s = calloc(10);
    if (crc32("KdSpORXmV",9) == 3109523119) strcat(s, "z");
if (crc32("LVCcxCNcgTRMKu",14) == 3948774057) strcat(s, "L");
if (crc32("SOUlBJcboRPVG",13) == 131423548) strcat(s, "g");
if (crc32("toOeNcIsL",9) == 1653899293) strcat(s, "a");
if (crc32("mAUXUlAOW",9) == 1301775566) strcat(s, "u");
if (crc32("NcioRwkXtaSNm",13) == 3932071468) strcat(s, "l");
if (crc32("IWaXUFSqbfc",11) == 4160931885) strcat(s, "e");
if (crc32("YaYIgYrqzDK",11) == 2802758517) strcat(s, "n");
if (crc32("agVkGUe",7) == 3649230871) strcat(s, "t");
if (crc32("bMUKlJ",6) == 2344649374) strcat(s, "b");
if (crc32("DZfmsyQZmlU",11) == 261392866) strcat(s, "s");
if (crc32("eJfrDFQfPklS",12) == 308730133) strcat(s, "u");
if (crc32("MkEciSAj",8) == 3017627754) strcat(s, "r");
if (crc32("hZBbqSqE",8) == 3439392620) strcat(s, "g");
    return s;
}

char *Scotty_nouns() {
    char *s = calloc(7);
    if (crc32("DybNeGnz",8) == 1070223129) strcat(s, "J");
if (crc32("wijlvNefSoQVXx",14) == 1962558586) strcat(s, "S");
if (crc32("sRqYWNGRMYRhVC",14) == 3938727638) strcat(s, "c");
if (crc32("FVNYuMUJZkfwqpY",15) == 794951888) strcat(s, "M");
if (crc32("BcyCXBGeshe",11) == 1454060447) strcat(s, "o");
if (crc32("jYzhoooBIPjoOgP",15) == 2300801008) strcat(s, "t");
if (crc32("vPyiKRkoo",9) == 639247844) strcat(s, "f");
if (crc32("CDkmbeJeWl",10) == 1832654344) strcat(s, "t");
if (crc32("IGHfTK",6) == 1583724886) strcat(s, "y");
    return s;
}

char *serotherapy_nouns() {
    char *s = calloc(12);
    if (crc32("LIezbcLHEYAFeKz",15) == 2436502024) strcat(s, "s");
if (crc32("IcRhYegV",8) == 1359447525) strcat(s, "e");
if (crc32("pTSByPvqqyrtU",13) == 1655441710) strcat(s, "r");
if (crc32("lNbVxTGkBRAids",14) == 2820894667) strcat(s, "o");
if (crc32("aLzyPXIdZTKn",12) == 1187808380) strcat(s, "C");
if (crc32("MdwVesWLNtMMZ",13) == 2732873787) strcat(s, "t");
if (crc32("LuQfb",5) == 4205156905) strcat(s, "h");
if (crc32("pNQyASt",7) == 1342888648) strcat(s, "W");
if (crc32("HaIffvqfrzauGfO",15) == 92452212) strcat(s, "e");
if (crc32("VqHztbvCGKVm",12) == 1259542289) strcat(s, "l");
if (crc32("yepAILZZSCmm",12) == 4277040198) strcat(s, "r");
if (crc32("eVyuff",6) == 2379434176) strcat(s, "a");
if (crc32("vRCxgKkynyFEOq",14) == 1822476352) strcat(s, "p");
if (crc32("vkrjxkf",7) == 3023962103) strcat(s, "p");
if (crc32("YVubNwxC",8) == 4111851865) strcat(s, "y");
    return s;
}

char *Dnestr_nouns() {
    char *s = calloc(7);
    if (crc32("OLnFqsUrenubnet",15) == 421244460) strcat(s, "n");
if (crc32("LWguVnOTY",9) == 1337913821) strcat(s, "D");
if (crc32("CdVpFSqngXfF",12) == 2192199804) strcat(s, "D");
if (crc32("HwxcEma",7) == 2150179317) strcat(s, "n");
if (crc32("egxYvXRuUtuOj",13) == 837830614) strcat(s, "X");
if (crc32("BhxpeCmeQxW",11) == 2184673656) strcat(s, "e");
if (crc32("RhiTJisO",8) == 1289065597) strcat(s, "j");
if (crc32("QNEQmjgDHRVto",13) == 851718730) strcat(s, "s");
if (crc32("yxUoiuXjCWVCuM",14) == 3635482112) strcat(s, "C");
if (crc32("DESeeSrM",8) == 1919449669) strcat(s, "t");
if (crc32("yoTDQ",5) == 2993291257) strcat(s, "r");
    return s;
}

char *connoisseurship_nouns() {
    char *s = calloc(16);
    if (crc32("ZjfshIaBiClWeX",14) == 2596361903) strcat(s, "c");
if (crc32("EPjZjJnq",8) == 598783650) strcat(s, "c");
if (crc32("siTdz",5) == 3834275174) strcat(s, "o");
if (crc32("koESn",5) == 2923138512) strcat(s, "G");
if (crc32("ZFAgCndZCD",10) == 2606127089) strcat(s, "n");
if (crc32("ivpatrkcg",9) == 1205236180) strcat(s, "n");
if (crc32("eQSLHG",6) == 2628263143) strcat(s, "o");
if (crc32("IWdXWY",6) == 2781931886) strcat(s, "A");
if (crc32("aOCdCBvfchWiJX",14) == 2735496659) strcat(s, "i");
if (crc32("fyRnTuIQpXVF",12) == 675483966) strcat(s, "s");
if (crc32("nCnkAFmGlPZj",12) == 2284743763) strcat(s, "s");
if (crc32("RuNDaxEsTwlTbm",14) == 708770128) strcat(s, "g");
if (crc32("NcsvIYtwb",9) == 3709475536) strcat(s, "e");
if (crc32("oBgDIif",7) == 4072902382) strcat(s, "u");
if (crc32("eOZPAdqDTqbUlv",14) == 2505601001) strcat(s, "r");
if (crc32("ymMcEQOu",8) == 510069047) strcat(s, "l");
if (crc32("NkanosSMnPFUZ",13) == 2587851325) strcat(s, "s");
if (crc32("IFzEtesNEPw",11) == 3841031004) strcat(s, "M");
if (crc32("BXUZlGTGfJhCmmb",15) == 486358880) strcat(s, "h");
if (crc32("aNjLytBvtDmlvhD",15) == 3672723127) strcat(s, "x");
if (crc32("fXrOnlcWueG",11) == 3643945804) strcat(s, "i");
if (crc32("fuEyiyeyDz",10) == 904812875) strcat(s, "p");
    return s;
}

char *glacialist_nouns() {
    char *s = calloc(11);
    if (crc32("jXHSxjKBmZsVgZb",15) == 1183907612) strcat(s, "g");
if (crc32("XuXCKQr",7) == 908036385) strcat(s, "l");
if (crc32("aiWrs",5) == 1827753634) strcat(s, "K");
if (crc32("eXJVy",5) == 561779505) strcat(s, "a");
if (crc32("MIOhmSlU",8) == 2822471241) strcat(s, "I");
if (crc32("RZFpegD",7) == 766406694) strcat(s, "c");
if (crc32("DRXpu",5) == 1739214320) strcat(s, "i");
if (crc32("WzqOaZwx",8) == 3021313552) strcat(s, "a");
if (crc32("URCDecrQt",9) == 4078503532) strcat(s, "l");
if (crc32("RYZLwTNX",8) == 4173509434) strcat(s, "I");
if (crc32("jRELl",5) == 440221065) strcat(s, "i");
if (crc32("AoFIguy",7) == 2165587948) strcat(s, "s");
if (crc32("kEmZnU",6) == 3483178387) strcat(s, "J");
if (crc32("DidgEfZl",8) == 2322365289) strcat(s, "t");
    return s;
}

char *scintillometer_nouns() {
    char *s = calloc(15);
    if (crc32("UuQlwMtzjTzSEG",14) == 413176279) strcat(s, "s");
if (crc32("ExrHjZhNwNEwbF",14) == 2731254275) strcat(s, "c");
if (crc32("XGeVCErwLCf",11) == 162061376) strcat(s, "i");
if (crc32("AvvGx",5) == 3241200928) strcat(s, "G");
if (crc32("VgbxvuLMGhChRpC",15) == 2040059685) strcat(s, "n");
if (crc32("fEpHUrNiuuiWGFz",15) == 2555796251) strcat(s, "t");
if (crc32("RtdCxe",6) == 3765468084) strcat(s, "i");
if (crc32("BzjfYv",6) == 708196864) strcat(s, "M");
if (crc32("fmeEa",5) == 3770399083) strcat(s, "l");
if (crc32("SDPCen",6) == 2676897326) strcat(s, "n");
if (crc32("vRnYWnMr",8) == 1407552537) strcat(s, "l");
if (crc32("rGSoRoSbmB",10) == 2380027904) strcat(s, "o");
if (crc32("novejU",6) == 3167111199) strcat(s, "n");
if (crc32("vKNzgvt",7) == 4154446048) strcat(s, "m");
if (crc32("HWKZoYnuZXx",11) == 2783895334) strcat(s, "e");
if (crc32("kdgcInilsnNP",12) == 2847675511) strcat(s, "S");
if (crc32("mZtTbD",6) == 3734591302) strcat(s, "t");
if (crc32("fdZOtPtcfpc",11) == 2352513989) strcat(s, "C");
if (crc32("FXkIYzSdV",9) == 2957435426) strcat(s, "e");
if (crc32("fpPUbikvRu",10) == 784109482) strcat(s, "r");
    return s;
}

char *nonabidingness_nouns() {
    char *s = calloc(15);
    if (crc32("eZhfhjmQvuvIU",13) == 933033796) strcat(s, "n");
if (crc32("cPzBRK",6) == 430877956) strcat(s, "o");
if (crc32("RetDrjNkFnS",11) == 4060660238) strcat(s, "Q");
if (crc32("JludUAV",7) == 2253017949) strcat(s, "n");
if (crc32("gSUukzXQs",9) == 169823892) strcat(s, "d");
if (crc32("hkHjRkXGwDlVNfP",15) == 1913068258) strcat(s, "a");
if (crc32("JeRrSn",6) == 1128155467) strcat(s, "b");
if (crc32("pbaBxiYKVFjxOFM",15) == 2116324691) strcat(s, "M");
if (crc32("AkpXRuW",7) == 574040722) strcat(s, "i");
if (crc32("OCqUe",5) == 973599223) strcat(s, "d");
if (crc32("TwNSChJNFis",11) == 3621751938) strcat(s, "Q");
if (crc32("QMXTiNyIneu",11) == 3793431058) strcat(s, "i");
if (crc32("fIfuYzBF",8) == 2608580572) strcat(s, "D");
if (crc32("bncsaNu",7) == 321103960) strcat(s, "n");
if (crc32("QmVaDE",6) == 576849786) strcat(s, "g");
if (crc32("VCUoNjhlAfNFHqk",15) == 1632022602) strcat(s, "h");
if (crc32("Ktjwh",5) == 1795940643) strcat(s, "n");
if (crc32("VgaHsEprWTmKMq",14) == 3910599878) strcat(s, "o");
if (crc32("NrWxLzKumNjL",12) == 634222874) strcat(s, "e");
if (crc32("lvnQTSTPWqNuLI",14) == 2547448413) strcat(s, "J");
if (crc32("YXwAoQHetASk",12) == 625300837) strcat(s, "s");
if (crc32("HeasBtuXWjdivU",14) == 2375526759) strcat(s, "t");
if (crc32("FcQoUkikAaH",11) == 489296405) strcat(s, "s");
    return s;
}

char *baldachin_nouns() {
    char *s = calloc(10);
    if (crc32("alSaiDbGtYfv",12) == 1445572725) strcat(s, "b");
if (crc32("ptElMWke",8) == 1767777340) strcat(s, "a");
if (crc32("KIONUqPhW",9) == 485143092) strcat(s, "l");
if (crc32("rrtcihdsxhymZwp",15) == 3398342218) strcat(s, "d");
if (crc32("MoZLqg",6) == 1444700080) strcat(s, "H");
if (crc32("fppNpj",6) == 98458829) strcat(s, "a");
if (crc32("wauDeNvKloBfOP",14) == 1597004674) strcat(s, "c");
if (crc32("TSmSHcmmV",9) == 173770145) strcat(s, "s");
if (crc32("ozJKtgtgvnkn",12) == 360045312) strcat(s, "h");
if (crc32("uduBcOgCbGbvgHf",15) == 3521093786) strcat(s, "z");
if (crc32("qWUjAOSjbDCp",12) == 1624121437) strcat(s, "i");
if (crc32("QNuCXkDAd",9) == 1280084564) strcat(s, "z");
if (crc32("rybVSAa",7) == 2047838533) strcat(s, "n");
    return s;
}

char *Bridie_nouns() {
    char *s = calloc(7);
    if (crc32("xpTcSXQMcjBuei",14) == 3808237949) strcat(s, "Z");
if (crc32("BGWPgEgIW",9) == 3242051065) strcat(s, "B");
if (crc32("xQdIoXTBxynqU",13) == 3927292387) strcat(s, "r");
if (crc32("wwHqUrJUS",9) == 2349953766) strcat(s, "L");
if (crc32("JRxluMe",7) == 2922819876) strcat(s, "i");
if (crc32("KrGWlnkkW",9) == 1948460199) strcat(s, "d");
if (crc32("RYswVjKPn",9) == 3980851354) strcat(s, "r");
if (crc32("zChavEGgn",9) == 1885131148) strcat(s, "i");
if (crc32("BuHQcv",6) == 101236035) strcat(s, "e");
    return s;
}

char *Ottavia_nouns() {
    char *s = calloc(8);
    if (crc32("uNbAqcjvzP",10) == 834156480) strcat(s, "O");
if (crc32("qBSJDcflQj",10) == 2900200600) strcat(s, "o");
if (crc32("AguUFOM",7) == 2895876587) strcat(s, "t");
if (crc32("ySySHBXkEPG",11) == 3751163313) strcat(s, "n");
if (crc32("IDsxyldlsVoC",12) == 3392028461) strcat(s, "t");
if (crc32("BnQMkzKRonyzPrl",15) == 3935777808) strcat(s, "A");
if (crc32("jhyPwaH",7) == 1016930671) strcat(s, "a");
if (crc32("MqYtWsCAJCm",11) == 1532944199) strcat(s, "v");
if (crc32("acDLYvMcpP",10) == 1204363762) strcat(s, "b");
if (crc32("xfEAwdF",7) == 3765268935) strcat(s, "i");
if (crc32("denwUa",6) == 72028904) strcat(s, "a");
    return s;
}

char *Zwolle_nouns() {
    char *s = calloc(7);
    if (crc32("NNaAzHk",7) == 2845157832) strcat(s, "S");
if (crc32("LUVcnKtVF",9) == 1203597453) strcat(s, "Z");
if (crc32("PJomtahg",8) == 2613414755) strcat(s, "w");
if (crc32("fbooWmcjzBkAYOs",15) == 3808057440) strcat(s, "o");
if (crc32("tDwwQgtAq",9) == 2064386533) strcat(s, "s");
if (crc32("rBRypyCddDvW",12) == 2734860441) strcat(s, "l");
if (crc32("XswXCcoiGKhNk",13) == 1716425055) strcat(s, "f");
if (crc32("mUCtyeglSqGHu",13) == 1719485616) strcat(s, "l");
if (crc32("rSmbEFYhNcBG",12) == 3686534777) strcat(s, "e");
    return s;
}

char *liftoff_nouns() {
    char *s = calloc(8);
    if (crc32("OJVTljiFE",9) == 1739567145) strcat(s, "l");
if (crc32("qMwDauPgB",9) == 674123748) strcat(s, "i");
if (crc32("CyWCEM",6) == 245959461) strcat(s, "z");
if (crc32("nHKXkQ",6) == 1600171835) strcat(s, "f");
if (crc32("TRgxPdQwcVJWvqk",15) == 883488473) strcat(s, "w");
if (crc32("QRZIdwkxRDL",11) == 319295895) strcat(s, "t");
if (crc32("lozqP",5) == 4253843137) strcat(s, "o");
if (crc32("QtDsvgtr",8) == 950436971) strcat(s, "f");
if (crc32("MvrNBWREohgAvd",14) == 1209661326) strcat(s, "f");
    return s;
}

char *Gld_nouns() {
    char *s = calloc(4);
    if (crc32("CjETPPGnBgDqoj",14) == 3002419158) strcat(s, "K");
if (crc32("JRZJFM",6) == 706815612) strcat(s, "G");
if (crc32("wJTUjXXYp",9) == 132181729) strcat(s, "y");
if (crc32("YUVYp",5) == 1556045844) strcat(s, "l");
if (crc32("PBBRTWDoARqEoen",15) == 3613331088) strcat(s, "d");
    return s;
}

char *Cutch_nouns() {
    char *s = calloc(6);
    if (crc32("jNInyGtAXYUtjwD",15) == 1550615192) strcat(s, "X");
if (crc32("lkAzoEVYSIim",12) == 3765348062) strcat(s, "C");
if (crc32("aTXTz",5) == 3566848918) strcat(s, "T");
if (crc32("kPklFKPbOctc",12) == 2574723403) strcat(s, "u");
if (crc32("EFOXRPf",7) == 4145473507) strcat(s, "t");
if (crc32("jJxFWnlr",8) == 2539687650) strcat(s, "c");
if (crc32("dGLKIktPShsMR",13) == 1978884136) strcat(s, "k");
if (crc32("VbUJMEwwhmaV",12) == 229078803) strcat(s, "h");
    return s;
}

char *Henleigh_nouns() {
    char *s = calloc(9);
    if (crc32("NEUIsOVm",8) == 2601047212) strcat(s, "H");
if (crc32("qsqchAJpjWyd",12) == 3878126745) strcat(s, "v");
if (crc32("myUXXdP",7) == 2906606075) strcat(s, "e");
if (crc32("IqgIswrbGSdxI",13) == 1424030306) strcat(s, "n");
if (crc32("yhpffBgXx",9) == 3448309742) strcat(s, "l");
if (crc32("deHrxiSTDCEUN",13) == 3301492858) strcat(s, "A");
if (crc32("SmwOXK",6) == 1144550810) strcat(s, "e");
if (crc32("nSVJUEszFmrXL",13) == 3272888529) strcat(s, "i");
if (crc32("OPMdoGlTDRLJ",12) == 3822957631) strcat(s, "D");
if (crc32("iJRgFhnmOqpbw",13) == 1253168509) strcat(s, "g");
if (crc32("PhKOH",5) == 1938431859) strcat(s, "h");
    return s;
}

char *dickite_nouns() {
    char *s = calloc(8);
    if (crc32("JIWvWhVmgxDJFfj",15) == 3912767415) strcat(s, "d");
if (crc32("YOcRzbpU",8) == 710168688) strcat(s, "i");
if (crc32("fuqJaeBqEUOg",12) == 3234789378) strcat(s, "S");
if (crc32("JsehciYHusUvkCa",15) == 969164686) strcat(s, "c");
if (crc32("ifQfOaAgDisF",12) == 4116172036) strcat(s, "k");
if (crc32("XiODBVTbhBgdE",13) == 2491481313) strcat(s, "D");
if (crc32("ECnmIqDxHJecnc",14) == 554048730) strcat(s, "i");
if (crc32("jDfGm",5) == 3250005038) strcat(s, "t");
if (crc32("BTBkJtrZTXXk",12) == 828526734) strcat(s, "e");
    return s;
}

char *AME_nouns() {
    char *s = calloc(4);
    if (crc32("ADTocYGqw",9) == 1030864687) strcat(s, "X");
if (crc32("OSwBvVHtoJf",11) == 3071528773) strcat(s, "A");
if (crc32("pOVramx",7) == 4251528789) strcat(s, "G");
if (crc32("kWNFrOira",9) == 2318817164) strcat(s, "M");
if (crc32("YSCmOAlzHXFa",12) == 1242700712) strcat(s, "Z");
if (crc32("RPVUHRxWVK",10) == 2782037250) strcat(s, "E");
    return s;
}

char *ChevalierMontrachet_nouns() {
    char *s = calloc(20);
    if (crc32("vfgryQAPZi",10) == 3523463973) strcat(s, "t");
if (crc32("kRvbNXtgxXJ",11) == 1411883085) strcat(s, "C");
if (crc32("hQiMHgLEU",9) == 4143434509) strcat(s, "O");
if (crc32("xomIascJr",9) == 1163600540) strcat(s, "h");
if (crc32("DMUiCjnRl",9) == 1610684116) strcat(s, "P");
if (crc32("yYIasJU",7) == 1581542682) strcat(s, "e");
if (crc32("gcHpod",6) == 3658377244) strcat(s, "k");
if (crc32("aNSUKULfAnfCm",13) == 3175220180) strcat(s, "v");
if (crc32("wfHxCUj",7) == 3027326121) strcat(s, "a");
if (crc32("yxCkAYsHjoKDUUg",15) == 1163061299) strcat(s, "X");
if (crc32("MWFWSN",6) == 1598682654) strcat(s, "l");
if (crc32("pbKECc",6) == 1752160571) strcat(s, "M");
if (crc32("CexOXqilCYWc",12) == 2373352960) strcat(s, "i");
if (crc32("JCIcSvxrqY",10) == 543471103) strcat(s, "e");
if (crc32("ZumwkpVOc",9) == 3602198084) strcat(s, "I");
if (crc32("KONszZCxD",9) == 547912248) strcat(s, "r");
if (crc32("sOsxPwEmihc",11) == 2411638692) strcat(s, "V");
if (crc32("gRUMEnhuJwJhp",13) == 407669016) strcat(s, "M");
if (crc32("vFupxyiNzNEZXzn",15) == 2930208021) strcat(s, "t");
if (crc32("AILcMk",6) == 616651062) strcat(s, "o");
if (crc32("blyFXaeaWRUeKH",14) == 1901301289) strcat(s, "n");
if (crc32("PLlLYXLVAF",10) == 733864894) strcat(s, "F");
if (crc32("WeopEa",6) == 1905525850) strcat(s, "t");
if (crc32("whOGzs",6) == 4247152513) strcat(s, "m");
if (crc32("YVuCmCSu",8) == 563856001) strcat(s, "r");
if (crc32("nFyfUj",6) == 1871382192) strcat(s, "a");
if (crc32("bPlnBPq",7) == 3830961513) strcat(s, "a");
if (crc32("LGgwrmwCtZtasw",14) == 4162277103) strcat(s, "c");
if (crc32("SYqfyoeT",8) == 4294619813) strcat(s, "h");
if (crc32("UblRupBoaFnPq",13) == 3239579616) strcat(s, "e");
if (crc32("xDsmNHJtcIbD",12) == 1550361817) strcat(s, "l");
if (crc32("AbeqIEjxMHiGNI",14) == 230517802) strcat(s, "t");
    return s;
}

char *BDS_nouns() {
    char *s = calloc(4);
    if (crc32("hyFgmTTZMX",10) == 2692959983) strcat(s, "B");
if (crc32("pKAIYGoRYAqouq",14) == 3212206203) strcat(s, "v");
if (crc32("aLhrJUCzBR",10) == 1412293532) strcat(s, "D");
if (crc32("QqSDyzaVWba",11) == 3785610962) strcat(s, "P");
if (crc32("bOpTCSqzflTSgdi",15) == 2467456077) strcat(s, "S");
    return s;
}

char *cystometer_nouns() {
    char *s = calloc(11);
    if (crc32("ddAMGRH",7) == 3327025867) strcat(s, "a");
if (crc32("DHOIUhupHU",10) == 3993989912) strcat(s, "c");
if (crc32("xayUrdseFGZh",12) == 3147046590) strcat(s, "Q");
if (crc32("wsqpKTgy",8) == 56548949) strcat(s, "y");
if (crc32("CxhoBwspFmzBd",13) == 3727965731) strcat(s, "f");
if (crc32("OivRRTOtWDZvHLW",15) == 2170557056) strcat(s, "s");
if (crc32("mOQKddytAvKlF",13) == 2443908651) strcat(s, "Z");
if (crc32("HroewGVNjpZtCq",14) == 1879976531) strcat(s, "t");
if (crc32("MFImpu",6) == 2096408185) strcat(s, "o");
if (crc32("qBoawLNHwnoGZ",13) == 3012454685) strcat(s, "m");
if (crc32("ZsMGfWWDZBLcfq",14) == 3482926872) strcat(s, "T");
if (crc32("IKZzxo",6) == 1904942632) strcat(s, "e");
if (crc32("PvXjefB",7) == 4016465963) strcat(s, "d");
if (crc32("CgclSg",6) == 956490489) strcat(s, "t");
if (crc32("HpICxlJKgJOS",12) == 3658759924) strcat(s, "e");
if (crc32("GRoKKybJoyQQ",12) == 4018315889) strcat(s, "j");
if (crc32("mkzdndzpNSCrLM",14) == 4061888177) strcat(s, "r");
    return s;
}

char *fremdness_nouns() {
    char *s = calloc(10);
    if (crc32("AqvUz",5) == 606036166) strcat(s, "s");
if (crc32("poSLqhq",7) == 4190257702) strcat(s, "f");
if (crc32("DNRsG",5) == 2466783810) strcat(s, "r");
if (crc32("AwHRzQqiYv",10) == 3913624692) strcat(s, "q");
if (crc32("DrOvQNV",7) == 2126102731) strcat(s, "e");
if (crc32("JQcrgDCMJpZtP",13) == 2336226182) strcat(s, "J");
if (crc32("ZlKHPQaDehcpGkV",15) == 3316751615) strcat(s, "m");
if (crc32("gNMxjearD",9) == 3664176190) strcat(s, "d");
if (crc32("KuugHFg",7) == 2267277165) strcat(s, "w");
if (crc32("bEWAakpR",8) == 4169504334) strcat(s, "n");
if (crc32("MJVHYJ",6) == 2318476567) strcat(s, "C");
if (crc32("CuOTXhBowJmqhq",14) == 2284523244) strcat(s, "e");
if (crc32("AkUQHgXqiiT",11) == 3536162182) strcat(s, "s");
if (crc32("CykmDbAU",8) == 1252734151) strcat(s, "v");
if (crc32("ZTBSJd",6) == 3471499688) strcat(s, "s");
    return s;
}

char *epigrammatism_nouns() {
    char *s = calloc(14);
    if (crc32("ZGXwedqVJ",9) == 1357172595) strcat(s, "l");
if (crc32("phRCQcntGHbjRP",14) == 1407670378) strcat(s, "e");
if (crc32("PvLKTQnivx",10) == 3358677307) strcat(s, "p");
if (crc32("hPsguRUWMi",10) == 796638433) strcat(s, "c");
if (crc32("eRyloXPRNeKiirS",15) == 4058323804) strcat(s, "i");
if (crc32("ozmXdTVWvjXD",12) == 185936760) strcat(s, "g");
if (crc32("TTkRYmNuJ",9) == 1843111765) strcat(s, "x");
if (crc32("uzypyRfVMEnX",12) == 3456410454) strcat(s, "r");
if (crc32("uRKUvpReHidj",12) == 2104794564) strcat(s, "l");
if (crc32("RPsZsPNxrHxI",12) == 2206870488) strcat(s, "a");
if (crc32("FKrrUZPa",8) == 349336201) strcat(s, "m");
if (crc32("RzfNCYNtOVd",11) == 2289457113) strcat(s, "M");
if (crc32("RhgCYXwA",8) == 1976931644) strcat(s, "m");
if (crc32("uWrGTBTNS",9) == 1641516585) strcat(s, "a");
if (crc32("CuBaBHVdV",9) == 1654751148) strcat(s, "t");
if (crc32("PlYvloRVgi",10) == 1733044203) strcat(s, "s");
if (crc32("XaXFREf",7) == 3188040265) strcat(s, "i");
if (crc32("BiuyhjzmP",9) == 1412670793) strcat(s, "s");
if (crc32("uEeceXicJWARsAq",15) == 668931149) strcat(s, "m");
if (crc32("OgJvuoqRNZIjSO",14) == 2911371135) strcat(s, "m");
    return s;
}

char *synagogue_nouns() {
    char *s = calloc(10);
    if (crc32("EGnjwlLuhiMsWX",14) == 2976779015) strcat(s, "H");
if (crc32("sKJKROmayoPhjkk",15) == 2846103897) strcat(s, "s");
if (crc32("SqYdQ",5) == 344088321) strcat(s, "y");
if (crc32("lfILThRsQze",11) == 3445521852) strcat(s, "s");
if (crc32("KnnkmjwIQH",10) == 1749916724) strcat(s, "n");
if (crc32("LPKih",5) == 464852562) strcat(s, "a");
if (crc32("oYpjjm",6) == 2555877317) strcat(s, "k");
if (crc32("mhdQQTUnU",9) == 991169392) strcat(s, "g");
if (crc32("NsrwTccd",8) == 2203854268) strcat(s, "o");
if (crc32("EVtAppvtq",9) == 564992596) strcat(s, "F");
if (crc32("KOSLImxSVisaEQg",15) == 405233228) strcat(s, "g");
if (crc32("lQIjumZbNU",10) == 3657115148) strcat(s, "j");
if (crc32("DzyrezPHo",9) == 3149716862) strcat(s, "u");
if (crc32("QoqBzaCVPjPnM",13) == 26403289) strcat(s, "e");
    return s;
}

char *signor_nouns() {
    char *s = calloc(7);
    if (crc32("eAJKj",5) == 2009016038) strcat(s, "s");
if (crc32("sJuDq",5) == 1842656331) strcat(s, "i");
if (crc32("NCsXXBB",7) == 2798299420) strcat(s, "I");
if (crc32("ceItal",6) == 3816195268) strcat(s, "g");
if (crc32("FXtSWmR",7) == 3007704803) strcat(s, "n");
if (crc32("qFDrbHKCYw",10) == 935830198) strcat(s, "o");
if (crc32("goXBuvOMeQLAImX",15) == 4139444053) strcat(s, "r");
    return s;
}

char *Nierman_nouns() {
    char *s = calloc(8);
    if (crc32("JlGly",5) == 1792778304) strcat(s, "r");
if (crc32("uRlTAhPVtBi",11) == 1197461020) strcat(s, "N");
if (crc32("roxJp",5) == 2346079128) strcat(s, "L");
if (crc32("ZngtxjFQ",8) == 845820246) strcat(s, "i");
if (crc32("FESvqHFRrFJoT",13) == 367607618) strcat(s, "e");
if (crc32("QtrqpF",6) == 1590152157) strcat(s, "r");
if (crc32("nxrlXThVwZphy",13) == 4053011694) strcat(s, "m");
if (crc32("UtGwbVu",7) == 1686330954) strcat(s, "w");
if (crc32("doMrpFHO",8) == 3175231451) strcat(s, "a");
if (crc32("tIVMx",5) == 1599356129) strcat(s, "n");
    return s;
}

char *fortuity_nouns() {
    char *s = calloc(9);
    if (crc32("jkUPcvPKLbGq",12) == 3462660269) strcat(s, "B");
if (crc32("woDEHJ",6) == 1879675268) strcat(s, "f");
if (crc32("VNoghJZiuaQ",11) == 3712775378) strcat(s, "F");
if (crc32("eSXWsfApqho",11) == 2799028217) strcat(s, "o");
if (crc32("VnArdyCT",8) == 851624534) strcat(s, "r");
if (crc32("LsVDCOTM",8) == 2515095373) strcat(s, "t");
if (crc32("yFPuKQH",7) == 2027171788) strcat(s, "l");
if (crc32("IhdPaBgg",8) == 1227966201) strcat(s, "u");
if (crc32("uHBAclTZR",9) == 774865403) strcat(s, "w");
if (crc32("VqFkETHppB",10) == 4188088710) strcat(s, "i");
if (crc32("leTqvTjbkxmn",12) == 462250437) strcat(s, "t");
if (crc32("JIHLATNvYF",10) == 885519058) strcat(s, "z");
if (crc32("pmMDWfb",7) == 2291381283) strcat(s, "y");
    return s;
}

char *rasher_nouns() {
    char *s = calloc(7);
    if (crc32("MHhMG",5) == 2843940771) strcat(s, "I");
if (crc32("cNIHnbLLnHf",11) == 2798073516) strcat(s, "r");
if (crc32("capvqQlU",8) == 126035296) strcat(s, "a");
if (crc32("sVqZmby",7) == 3290710101) strcat(s, "s");
if (crc32("EtBaKRSKRhy",11) == 1590189845) strcat(s, "R");
if (crc32("VpNuCEA",7) == 2472558955) strcat(s, "h");
if (crc32("mEuBvvrrjJLexR",14) == 173634528) strcat(s, "D");
if (crc32("NSSNion",7) == 139721358) strcat(s, "e");
if (crc32("WFDxnQeFy",9) == 3702039686) strcat(s, "r");
    return s;
}

char *levin_nouns() {
    char *s = calloc(6);
    if (crc32("SvIIOAhgNZi",11) == 1118138379) strcat(s, "l");
if (crc32("GDTWojYdvhU",11) == 3229056279) strcat(s, "e");
if (crc32("PrnbGxN",7) == 2593363450) strcat(s, "T");
if (crc32("aUedJSFtveKG",12) == 1942273781) strcat(s, "v");
if (crc32("GGCCk",5) == 1507492943) strcat(s, "i");
if (crc32("zcxhC",5) == 1153474547) strcat(s, "n");
    return s;
}

char *tracasserie_nouns() {
    char *s = calloc(12);
    if (crc32("cHSehZ",6) == 3860807453) strcat(s, "t");
if (crc32("rBCLZmeWQBlj",12) == 308858659) strcat(s, "Z");
if (crc32("OXJCZul",7) == 595061993) strcat(s, "r");
if (crc32("lRgShKEg",8) == 918096398) strcat(s, "h");
if (crc32("kGzDaK",6) == 3621485945) strcat(s, "a");
if (crc32("HBPooqlMa",9) == 3865454758) strcat(s, "u");
if (crc32("szgcNN",6) == 2632487549) strcat(s, "c");
if (crc32("YEyIxvCgBITUSY",14) == 3654040013) strcat(s, "a");
if (crc32("eoSQAQ",6) == 3008439355) strcat(s, "s");
if (crc32("ebZysu",6) == 3521382648) strcat(s, "s");
if (crc32("nGtfQxdBXyg",11) == 3731902006) strcat(s, "e");
if (crc32("ChHvBFsZISGBW",13) == 854530212) strcat(s, "W");
if (crc32("PDaJSAZmBW",10) == 430728162) strcat(s, "r");
if (crc32("iDCiPA",6) == 1911577745) strcat(s, "o");
if (crc32("nTGqbBhAO",9) == 2033986161) strcat(s, "i");
if (crc32("QyihAAuNirK",11) == 4238673373) strcat(s, "e");
    return s;
}

char *nonaccession_nouns() {
    char *s = calloc(13);
    if (crc32("bsMyHQZtlJD",11) == 1008744435) strcat(s, "s");
if (crc32("VjLoBcHqpkT",11) == 1412362802) strcat(s, "n");
if (crc32("qAihxrBf",8) == 1151104412) strcat(s, "N");
if (crc32("AdSQJtMq",8) == 3036799481) strcat(s, "o");
if (crc32("zTfgTGlxHxoV",12) == 458195313) strcat(s, "n");
if (crc32("cEZtIzhWt",9) == 4256240839) strcat(s, "m");
if (crc32("MerFcrRxrCwQf",13) == 4094885621) strcat(s, "a");
if (crc32("VYpmPqLbNAGPP",13) == 1772305457) strcat(s, "c");
if (crc32("lubeOegwLpb",11) == 154425621) strcat(s, "c");
if (crc32("rzdNEE",6) == 28457926) strcat(s, "e");
if (crc32("htuWDBiACyBQD",13) == 854764643) strcat(s, "s");
if (crc32("JvREmDY",7) == 3793235763) strcat(s, "p");
if (crc32("nJyrpliKPpukRBj",15) == 1513939329) strcat(s, "s");
if (crc32("GidlZceOtQWcUKY",15) == 1357672821) strcat(s, "C");
if (crc32("piDbvQoDgxo",11) == 2582280783) strcat(s, "i");
if (crc32("kzdsHHyzw",9) == 3817532938) strcat(s, "Z");
if (crc32("bvRGbieBHE",10) == 3009424584) strcat(s, "o");
if (crc32("cweHfRHhqBCMRl",14) == 664904430) strcat(s, "n");
    return s;
}

char *secobarbital_nouns() {
    char *s = calloc(13);
    if (crc32("RjMYawH",7) == 3343077512) strcat(s, "s");
if (crc32("zpuIMXUulpjR",12) == 1467460709) strcat(s, "p");
if (crc32("bqOjGAHaecJI",12) == 3815678442) strcat(s, "e");
if (crc32("zOLVmkNRKQuU",12) == 2821354672) strcat(s, "c");
if (crc32("LlxffNS",7) == 1299798242) strcat(s, "r");
if (crc32("HMHBMeLh",8) == 1132065256) strcat(s, "o");
if (crc32("nNyEAKmzJoWDB",13) == 909880152) strcat(s, "b");
if (crc32("mLaPTb",6) == 967133703) strcat(s, "k");
if (crc32("SMjiSYodXkxOzY",14) == 2138680419) strcat(s, "a");
if (crc32("xIDydQBkyGW",11) == 444624965) strcat(s, "r");
if (crc32("NLJWMQT",7) == 2726071717) strcat(s, "G");
if (crc32("YwZKzVvg",8) == 1119003545) strcat(s, "b");
if (crc32("RfGmJrbqjnB",11) == 332106770) strcat(s, "O");
if (crc32("ELVajcDkBnhu",12) == 2400458978) strcat(s, "i");
if (crc32("NSpqpPOk",8) == 233859607) strcat(s, "H");
if (crc32("HPVbBIZPlG",10) == 1834641768) strcat(s, "t");
if (crc32("pafhISQS",8) == 1249391206) strcat(s, "a");
if (crc32("qFBfbsYrRhTF",12) == 3464778063) strcat(s, "l");
    return s;
}

char *intensity_nouns() {
    char *s = calloc(10);
    if (crc32("EMvsQCOex",9) == 1943708189) strcat(s, "i");
if (crc32("PKnbWdxO",8) == 486272319) strcat(s, "l");
if (crc32("RvfYyFFEa",9) == 2590268170) strcat(s, "n");
if (crc32("dHzghQLiRNYDV",13) == 1189636891) strcat(s, "t");
if (crc32("NyZLZxkErBHWTp",14) == 4239113873) strcat(s, "J");
if (crc32("SvjVx",5) == 12251244) strcat(s, "e");
if (crc32("iFWpOzKcbyFk",12) == 3999041964) strcat(s, "n");
if (crc32("TEnTEQVhSBYZJcV",15) == 1577101596) strcat(s, "s");
if (crc32("MqIUudLL",8) == 1802237742) strcat(s, "F");
if (crc32("xRXQFh",6) == 2465058951) strcat(s, "i");
if (crc32("McrgiZki",8) == 4224024115) strcat(s, "b");
if (crc32("qJkmAqUY",8) == 1171412299) strcat(s, "t");
if (crc32("ExTgqg",6) == 3421530222) strcat(s, "y");
    return s;
}

char *roadtrain_nouns() {
    char *s = calloc(10);
    if (crc32("xmHJoeEyrNqdZaT",15) == 2952880002) strcat(s, "f");
if (crc32("FoQqlWXyFWK",11) == 1399795389) strcat(s, "r");
if (crc32("nLfYuLIvj",9) == 2227491225) strcat(s, "o");
if (crc32("ShwchdFEUPrtzks",15) == 2639890443) strcat(s, "a");
if (crc32("dguIftJGbTMtCxx",15) == 3613129467) strcat(s, "d");
if (crc32("WXFecIvsbAGJcV",14) == 767801230) strcat(s, "T");
if (crc32("QTHSOMLza",9) == 2324301454) strcat(s, "t");
if (crc32("iSEwMEcWia",10) == 539637536) strcat(s, "r");
if (crc32("vFgVPc",6) == 336253653) strcat(s, "U");
if (crc32("nwPYpUAHceATn",13) == 2918283614) strcat(s, "a");
if (crc32("XytHNXmEf",9) == 409737008) strcat(s, "r");
if (crc32("CYzYVr",6) == 940100574) strcat(s, "i");
if (crc32("qxZDhsSRBNd",11) == 2273144823) strcat(s, "n");
    return s;
}

char *basecoat_nouns() {
    char *s = calloc(9);
    if (crc32("DtHqHMP",7) == 2134028831) strcat(s, "M");
if (crc32("DJrFBZrswjkO",12) == 3827587489) strcat(s, "b");
if (crc32("YvzicewNIOjD",12) == 713109832) strcat(s, "T");
if (crc32("NTxHol",6) == 1063300516) strcat(s, "a");
if (crc32("oQMnyIjV",8) == 1545701376) strcat(s, "m");
if (crc32("zVSFmOTtas",10) == 862912696) strcat(s, "s");
if (crc32("RYRDFD",6) == 75639514) strcat(s, "e");
if (crc32("QRITcKMCmCNN",12) == 1094395730) strcat(s, "c");
if (crc32("kBbCRLIQPrgSGzI",15) == 1161975751) strcat(s, "z");
if (crc32("eFqybKEGdYgxw",13) == 1252151884) strcat(s, "o");
if (crc32("cEimgadqQS",10) == 578049124) strcat(s, "b");
if (crc32("nXcJMbZpPYcRFJ",14) == 3490506117) strcat(s, "a");
if (crc32("kjnhKVUGEBoQl",13) == 246393314) strcat(s, "L");
if (crc32("LPJVXdinhpGIrK",14) == 3736716031) strcat(s, "t");
    return s;
}

char *paleopsychology_nouns() {
    char *s = calloc(16);
    if (crc32("xNcpqypoq",9) == 1661634302) strcat(s, "p");
if (crc32("wMitvwqzu",9) == 1849208973) strcat(s, "a");
if (crc32("mSGhKaAaQSqAR",13) == 1782632147) strcat(s, "H");
if (crc32("IfTtfC",6) == 1141046424) strcat(s, "l");
if (crc32("mCHlfgGdh",9) == 59067682) strcat(s, "Y");
if (crc32("qFomrjhcQwcUOmx",15) == 3551145064) strcat(s, "e");
if (crc32("nYZFrkMdKtp",11) == 1322306570) strcat(s, "o");
if (crc32("tOWJHsx",7) == 2680432477) strcat(s, "B");
if (crc32("COxvJZ",6) == 2641532173) strcat(s, "p");
if (crc32("LOsbdoQOLrqyQak",15) == 99515528) strcat(s, "s");
if (crc32("pnalnXUAFDicUC",14) == 2402422533) strcat(s, "y");
if (crc32("XjntjunHf",9) == 1959390164) strcat(s, "c");
if (crc32("yuryyjJrRHcGjT",14) == 4184562715) strcat(s, "h");
if (crc32("LHLZcycp",8) == 179006658) strcat(s, "o");
if (crc32("ftvPaZJeNEK",11) == 1924147559) strcat(s, "l");
if (crc32("EQWTOHuprG",10) == 493197908) strcat(s, "o");
if (crc32("uaUMaCkqKEXA",12) == 2690129733) strcat(s, "g");
if (crc32("mrOVWjtzGqoLX",13) == 3644957902) strcat(s, "y");
    return s;
}

char *MilneEdwards_nouns() {
    char *s = calloc(13);
    if (crc32("hBbzyn",6) == 825361049) strcat(s, "h");
if (crc32("OupYSOWfo",9) == 4293311285) strcat(s, "M");
if (crc32("SCgZNHkXvTDCQ",13) == 738372461) strcat(s, "i");
if (crc32("jnSMbO",6) == 1159889516) strcat(s, "l");
if (crc32("onNtjpNdh",9) == 2759098834) strcat(s, "l");
if (crc32("xcxZUl",6) == 39462569) strcat(s, "H");
if (crc32("nDiwyedHAksod",13) == 3628602562) strcat(s, "n");
if (crc32("JCCoolhwhgHAwQ",14) == 1401540244) strcat(s, "z");
if (crc32("MpCGycFFmwRh",12) == 2963336963) strcat(s, "e");
if (crc32("bZGYFJYm",8) == 3424628023) strcat(s, "E");
if (crc32("EoEMy",5) == 1230358988) strcat(s, "y");
if (crc32("fdIbq",5) == 1805052772) strcat(s, "d");
if (crc32("LBgmdTDj",8) == 1615872090) strcat(s, "P");
if (crc32("isxwXLx",7) == 1359158275) strcat(s, "w");
if (crc32("mFdsSQ",6) == 3172125030) strcat(s, "a");
if (crc32("tKILUILLI",9) == 2766532068) strcat(s, "o");
if (crc32("QWZtDMUP",8) == 2064170890) strcat(s, "r");
if (crc32("qyEsuGm",7) == 3435589183) strcat(s, "d");
if (crc32("mUNxkZBY",8) == 1587020781) strcat(s, "E");
if (crc32("HrLjPCOYT",9) == 2331611512) strcat(s, "s");
    return s;
}

char *oscilloscope_nouns() {
    char *s = calloc(13);
    if (crc32("OJTlDHQPfKDTu",13) == 3092857096) strcat(s, "k");
if (crc32("LdXKEKzWif",10) == 2875525321) strcat(s, "o");
if (crc32("WlyOZnredsfshxB",15) == 2899545877) strcat(s, "s");
if (crc32("xTvgrG",6) == 1834855078) strcat(s, "c");
if (crc32("vLYtQWW",7) == 2190372371) strcat(s, "Z");
if (crc32("mMZPCqsf",8) == 3796336908) strcat(s, "i");
if (crc32("iAdJGTlPavZj",12) == 3896570067) strcat(s, "K");
if (crc32("RJSbBO",6) == 1409320499) strcat(s, "l");
if (crc32("DnRilnuTDOh",11) == 2945384997) strcat(s, "n");
if (crc32("qVodOniCL",9) == 2657216067) strcat(s, "l");
if (crc32("mDKox",5) == 1937926092) strcat(s, "o");
if (crc32("dgHOQ",5) == 426051578) strcat(s, "s");
if (crc32("VFJbYu",6) == 1212818201) strcat(s, "c");
if (crc32("HfGVNXaxmzUtuVh",15) == 110247675) strcat(s, "o");
if (crc32("LzFTi",5) == 3238900339) strcat(s, "p");
if (crc32("KDuzstjXpl",10) == 1995297585) strcat(s, "e");
    return s;
}

char *edifier_nouns() {
    char *s = calloc(8);
    if (crc32("nXKQddCibaE",11) == 2186275825) strcat(s, "e");
if (crc32("BkgEPuC",7) == 1837352394) strcat(s, "P");
if (crc32("GLKWOPgEuiuNn",13) == 4028476775) strcat(s, "d");
if (crc32("LBmCiYhObldnOdD",15) == 947082977) strcat(s, "G");
if (crc32("CrnYoaXhpKWWfb",14) == 705083804) strcat(s, "i");
if (crc32("QqyYSYvBxrQJl",13) == 4280619697) strcat(s, "y");
if (crc32("rtjqp",5) == 2181825540) strcat(s, "f");
if (crc32("ABLwLdrcOTDMbLi",15) == 2917591256) strcat(s, "O");
if (crc32("ndGytUK",7) == 1549680448) strcat(s, "i");
if (crc32("bMYLroJgbD",10) == 3914928227) strcat(s, "B");
if (crc32("qlfeidEupv",10) == 2763791946) strcat(s, "e");
if (crc32("oEzRbCMSUZjH",12) == 1550861063) strcat(s, "i");
if (crc32("JdPRbw",6) == 1311523298) strcat(s, "r");
    return s;
}

char *metallophone_nouns() {
    char *s = calloc(13);
    if (crc32("AOHSdAzglfLQwi",14) == 1912829827) strcat(s, "j");
if (crc32("AxTevEBUm",9) == 2189396664) strcat(s, "m");
if (crc32("QMfOjwjpILpW",12) == 4278210666) strcat(s, "t");
if (crc32("zyxllmXwrhF",11) == 3530579710) strcat(s, "e");
if (crc32("wqoekQYXfyi",11) == 1305746939) strcat(s, "t");
if (crc32("rLjrgaD",7) == 3430601050) strcat(s, "a");
if (crc32("VAOvv",5) == 3910939306) strcat(s, "l");
if (crc32("MPaHtbYNtt",10) == 843234532) strcat(s, "l");
if (crc32("KJBLtBlPyrqVavM",15) == 2935797884) strcat(s, "o");
if (crc32("tsZCSrnCY",9) == 2468718269) strcat(s, "b");
if (crc32("RwEUXWijvXgRGjs",15) == 1425166760) strcat(s, "p");
if (crc32("UBMfghzrcPX",11) == 1183127773) strcat(s, "u");
if (crc32("MIdSGiFGbs",10) == 1869715134) strcat(s, "h");
if (crc32("AVpxCDWTyZRj",12) == 1687353346) strcat(s, "o");
if (crc32("eGhMB",5) == 183690440) strcat(s, "n");
if (crc32("qcOReXubvxKcP",13) == 678356433) strcat(s, "y");
if (crc32("AELMvAghUlaT",12) == 1163488328) strcat(s, "e");
    return s;
}

char *algerienne_nouns() {
    char *s = calloc(11);
    if (crc32("FafblLuIVZ",10) == 2539364406) strcat(s, "a");
if (crc32("OYxJtEKn",8) == 4251700857) strcat(s, "l");
if (crc32("sjyOXvPWgHDFn",13) == 173696736) strcat(s, "L");
if (crc32("tUKChreFhkK",11) == 2974377021) strcat(s, "g");
if (crc32("MwcoJmn",7) == 336874965) strcat(s, "e");
if (crc32("TTjGLSDPjDBY",12) == 1357055264) strcat(s, "t");
if (crc32("ohIVkqwze",9) == 3914252622) strcat(s, "r");
if (crc32("BqjnCRrHtxAuds",14) == 2255442290) strcat(s, "i");
if (crc32("JuHrmsuxDx",10) == 2541354253) strcat(s, "e");
if (crc32("BydSAUk",7) == 3140182224) strcat(s, "n");
if (crc32("XfoxzPdylCJkCG",14) == 672284523) strcat(s, "n");
if (crc32("lgXKCGmCrzhoGDd",15) == 3491132785) strcat(s, "K");
if (crc32("qIOyWpneXHFqGi",14) == 77326277) strcat(s, "e");
    return s;
}

char *Harewood_nouns() {
    char *s = calloc(9);
    if (crc32("WdzobndLjt",10) == 2669924670) strcat(s, "H");
if (crc32("YinfkAEiSKAVYoU",15) == 29094081) strcat(s, "a");
if (crc32("jgYSFJMhrbgr",12) == 3311292358) strcat(s, "r");
if (crc32("MhgQDMxNdCmbud",14) == 1396817921) strcat(s, "e");
if (crc32("EXxhIIDFKC",10) == 1962022459) strcat(s, "w");
if (crc32("GgKYefZlwR",10) == 3517471909) strcat(s, "m");
if (crc32("VAgflbczXY",10) == 549796139) strcat(s, "o");
if (crc32("fXwDnQ",6) == 638929558) strcat(s, "j");
if (crc32("sDTWgz",6) == 653780423) strcat(s, "o");
if (crc32("fUnBH",5) == 3565324399) strcat(s, "d");
    return s;
}

char *Ruyter_nouns() {
    char *s = calloc(7);
    if (crc32("nWyKaUrGLo",10) == 1994325900) strcat(s, "M");
if (crc32("RYoZIk",6) == 1009952074) strcat(s, "R");
if (crc32("oPvxBiom",8) == 1773281398) strcat(s, "q");
if (crc32("RWsncqOLpoH",11) == 2734715706) strcat(s, "u");
if (crc32("KOMNTLsnH",9) == 2472735132) strcat(s, "y");
if (crc32("AncRAaHsRG",10) == 4217465782) strcat(s, "l");
if (crc32("uQOayGWGMmIjKfD",15) == 326349021) strcat(s, "t");
if (crc32("qzXBiSApvlMPpOu",15) == 1527280803) strcat(s, "u");
if (crc32("AAbeRJmg",8) == 1762335637) strcat(s, "e");
if (crc32("pNkLpyRolxrqanf",15) == 3416473032) strcat(s, "r");
    return s;
}

char *NB_nouns() {
    char *s = calloc(3);
    if (crc32("SfNTKQxF",8) == 3613077171) strcat(s, "N");
if (crc32("eCfrLBDSz",9) == 61363721) strcat(s, "N");
if (crc32("TztvD",5) == 1411335579) strcat(s, "B");
    return s;
}

char *neuropath_nouns() {
    char *s = calloc(10);
    if (crc32("LPsaSAWMJHSGqy",14) == 249411890) strcat(s, "p");
if (crc32("ejkjTTRuXdFAsL",14) == 149980081) strcat(s, "n");
if (crc32("JScipV",6) == 2488841947) strcat(s, "y");
if (crc32("yvgMFTGhPjrEqe",14) == 2315875416) strcat(s, "e");
if (crc32("GemqTnCDLxIf",12) == 4268319757) strcat(s, "D");
if (crc32("AiQTa",5) == 1820570484) strcat(s, "u");
if (crc32("QLgfaf",6) == 3650038042) strcat(s, "r");
if (crc32("zJbffG",6) == 2332142850) strcat(s, "u");
if (crc32("IQPVFljSP",9) == 3980960816) strcat(s, "o");
if (crc32("iprkc",5) == 1022917645) strcat(s, "p");
if (crc32("eUOCEj",6) == 3153354065) strcat(s, "M");
if (crc32("cLWsvgyGGH",10) == 824915661) strcat(s, "a");
if (crc32("vVYbHKv",7) == 2106606112) strcat(s, "Z");
if (crc32("GPFJgpDZmX",10) == 3467289481) strcat(s, "t");
if (crc32("BqcNCqh",7) == 743363997) strcat(s, "h");
    return s;
}

char *Liebman_nouns() {
    char *s = calloc(8);
    if (crc32("OgetOGo",7) == 4062123410) strcat(s, "i");
if (crc32("GVPBVxz",7) == 4028504512) strcat(s, "L");
if (crc32("nAJqc",5) == 1706746434) strcat(s, "Z");
if (crc32("OBCcNQzYkVqa",12) == 166577594) strcat(s, "i");
if (crc32("cUzgEkZXLiDNYD",14) == 2131055445) strcat(s, "j");
if (crc32("ZkTNpfZfGUHAiTN",15) == 2694031637) strcat(s, "e");
if (crc32("jYCdwPHKrJnsw",13) == 1188538508) strcat(s, "Z");
if (crc32("vRcGnygRULuxRA",14) == 3105925745) strcat(s, "b");
if (crc32("wPLsrvJv",8) == 397292162) strcat(s, "Q");
if (crc32("mCLFbGCzTXVu",12) == 1745796549) strcat(s, "m");
if (crc32("FijWPmFPaXyAka",14) == 930500148) strcat(s, "Q");
if (crc32("ASSTwHORxRmK",12) == 3515929406) strcat(s, "a");
if (crc32("aRRfxgF",7) == 1117005194) strcat(s, "n");
    return s;
}

char *Haifa_nouns() {
    char *s = calloc(6);
    if (crc32("siUQYvl",7) == 2092793267) strcat(s, "J");
if (crc32("PHtuwHyX",8) == 4115491069) strcat(s, "H");
if (crc32("uOcBcZ",6) == 2943185796) strcat(s, "a");
if (crc32("POXvbkwmjIq",11) == 576226176) strcat(s, "b");
if (crc32("aMRLKMc",7) == 2111412536) strcat(s, "i");
if (crc32("SkaNN",5) == 3812465935) strcat(s, "f");
if (crc32("gGlRK",5) == 336302945) strcat(s, "J");
if (crc32("VqIKhDrXAdr",11) == 2335745172) strcat(s, "a");
    return s;
}

char *jembe_nouns() {
    char *s = calloc(6);
    if (crc32("SiCYTQNLIaYjkk",14) == 3395258691) strcat(s, "m");
if (crc32("tCbJeQBEAl",10) == 1055001503) strcat(s, "j");
if (crc32("nJXzqaREFKoL",12) == 2194538604) strcat(s, "e");
if (crc32("sSiiAkgHhxd",11) == 2824529977) strcat(s, "B");
if (crc32("ZquPabGWm",9) == 1426101621) strcat(s, "m");
if (crc32("ZpzEdURtBOZo",12) == 2958400140) strcat(s, "e");
if (crc32("CTByUVqloUUE",12) == 993517021) strcat(s, "b");
if (crc32("ROhhcNQtTduPM",13) == 3804297989) strcat(s, "F");
if (crc32("dETQCsxDQ",9) == 586277145) strcat(s, "e");
    return s;
}

char *hotspur_nouns() {
    char *s = calloc(8);
    if (crc32("qTqmcmennnZzFdd",15) == 679952586) strcat(s, "x");
if (crc32("tAkFqETgiu",10) == 2991701806) strcat(s, "h");
if (crc32("LLiCjU",6) == 3837424570) strcat(s, "o");
if (crc32("PUDjpxn",7) == 34574738) strcat(s, "t");
if (crc32("RMEAXGZxAV",10) == 1837185663) strcat(s, "s");
if (crc32("xqFmvejWxtdeRU",14) == 352302250) strcat(s, "M");
if (crc32("dRUYyFXlGqhy",12) == 239722278) strcat(s, "p");
if (crc32("WOYDPbbZutsgR",13) == 1912841117) strcat(s, "G");
if (crc32("rhXcoZcDbGV",11) == 4101750091) strcat(s, "u");
if (crc32("XBKPVD",6) == 529580297) strcat(s, "A");
if (crc32("aLKTxlAluE",10) == 3410805860) strcat(s, "r");
    return s;
}

char *Riorsson_nouns() {
    char *s = calloc(9);
    if (crc32("sBGDblZ",7) == 4118574739) strcat(s, "R");
if (crc32("PkbeUvQWJwF",11) == 668469748) strcat(s, "w");
if (crc32("oETDSSjUlH",10) == 1279329506) strcat(s, "i");
if (crc32("yhruSGGb",8) == 2840950426) strcat(s, "o");
if (crc32("bcoMHjOVckPJuD",14) == 1237866438) strcat(s, "r");
if (crc32("htewiRoINOsa",12) == 2732656474) strcat(s, "o");
if (crc32("FooGggtOW",9) == 1897720090) strcat(s, "s");
if (crc32("AzTVnGttJsvxHbi",15) == 3583442966) strcat(s, "s");
if (crc32("tUSXCRSmAgpvz",13) == 1689076585) strcat(s, "V");
if (crc32("DNvktui",7) == 3071349926) strcat(s, "o");
if (crc32("hxawfBLeCBU",11) == 421319991) strcat(s, "n");
    return s;
}

char *eponym_nouns() {
    char *s = calloc(7);
    if (crc32("TyYKyUGcZkB",11) == 1887435787) strcat(s, "B");
if (crc32("fIWzWM",6) == 3366411263) strcat(s, "e");
if (crc32("AeYzRVCAZVpZuJX",15) == 2355222742) strcat(s, "N");
if (crc32("rdpegktlvRhLuZs",15) == 4051893346) strcat(s, "p");
if (crc32("NaiPwuqsVthrhBy",15) == 2422803883) strcat(s, "r");
if (crc32("ujMISUVU",8) == 207512322) strcat(s, "o");
if (crc32("fwfSqZundp",10) == 1391036510) strcat(s, "n");
if (crc32("iLoNUIot",8) == 114543230) strcat(s, "D");
if (crc32("ujPRQhWx",8) == 2119698344) strcat(s, "y");
if (crc32("tIaFpGFtEoK",11) == 3203478626) strcat(s, "d");
if (crc32("VwWAVD",6) == 2587220257) strcat(s, "m");
    return s;
}

char *discrimination_nouns() {
    char *s = calloc(15);
    if (crc32("fUPWiJiPFnqMg",13) == 3012111390) strcat(s, "d");
if (crc32("bwoHcAOEbTo",11) == 2388001079) strcat(s, "L");
if (crc32("YWApvBHXeAvzNA",14) == 3711146962) strcat(s, "i");
if (crc32("veuGezGN",8) == 476931061) strcat(s, "s");
if (crc32("qjqkOkIOpgnnBdq",15) == 4227926410) strcat(s, "c");
if (crc32("tRfrUNMgEzYgZIg",15) == 1000742879) strcat(s, "c");
if (crc32("eNLHGfIifcJYrOZ",15) == 3395655362) strcat(s, "r");
if (crc32("OllDJbsvLl",10) == 2103679416) strcat(s, "i");
if (crc32("RmgjOl",6) == 1306057120) strcat(s, "x");
if (crc32("AbbECVi",7) == 3746009975) strcat(s, "m");
if (crc32("jhCqsC",6) == 2260369080) strcat(s, "i");
if (crc32("VUeuGvGi",8) == 862217782) strcat(s, "n");
if (crc32("BZvskIPXhXBfFa",14) == 4247880371) strcat(s, "a");
if (crc32("gkWbqSpzN",9) == 4253794766) strcat(s, "t");
if (crc32("REWiUrMfxnHdkld",15) == 3245598550) strcat(s, "i");
if (crc32("xRcnhWSpg",9) == 1599778809) strcat(s, "o");
if (crc32("cVDXplX",7) == 1947733528) strcat(s, "T");
if (crc32("cFwJtmVgL",9) == 333475330) strcat(s, "n");
    return s;
}

char *Saracenism_nouns() {
    char *s = calloc(11);
    if (crc32("JPiUAkx",7) == 2967976839) strcat(s, "S");
if (crc32("EGQWSfYoKKVjC",13) == 3780512685) strcat(s, "i");
if (crc32("qWSpStZNvarCchZ",15) == 1434807787) strcat(s, "a");
if (crc32("jumeKzZIgwEU",12) == 2708543679) strcat(s, "r");
if (crc32("dfhTdOKuZGufVw",14) == 975380906) strcat(s, "d");
if (crc32("MhRnfVzd",8) == 3788809447) strcat(s, "a");
if (crc32("rdBaakq",7) == 1011456686) strcat(s, "c");
if (crc32("HQAdbtFQMlXDL",13) == 1647047082) strcat(s, "e");
if (crc32("zbEjuwtyVdpi",12) == 522807405) strcat(s, "n");
if (crc32("RAcrIvgyAQ",10) == 3637555590) strcat(s, "i");
if (crc32("uumlcnuvwYUOx",13) == 969303264) strcat(s, "i");
if (crc32("Hrwodyk",7) == 4019620531) strcat(s, "s");
if (crc32("QKXivvr",7) == 2752389587) strcat(s, "m");
    return s;
}

char *Wesleyanism_nouns() {
    char *s = calloc(12);
    if (crc32("wJaaCpQEVm",10) == 3153096818) strcat(s, "R");
if (crc32("sJZBTlM",7) == 117564660) strcat(s, "W");
if (crc32("DWDUvrDFnNVSutC",15) == 360002194) strcat(s, "h");
if (crc32("TKiPuRLovHK",11) == 3906890430) strcat(s, "e");
if (crc32("IrBNjfQN",8) == 2807114389) strcat(s, "s");
if (crc32("muPYU",5) == 3277667533) strcat(s, "S");
if (crc32("tNjpuNOvsvNLdw",14) == 385799831) strcat(s, "l");
if (crc32("bRnyaAgkBkS",11) == 3504715430) strcat(s, "e");
if (crc32("TnrWjtHmHGwC",12) == 1365720457) strcat(s, "D");
if (crc32("HOPmnjnw",8) == 3952334042) strcat(s, "y");
if (crc32("umFMqcih",8) == 2094371637) strcat(s, "a");
if (crc32("GESDhrTUNRpw",12) == 2748611090) strcat(s, "n");
if (crc32("cjZmc",5) == 2961402681) strcat(s, "Z");
if (crc32("SPKrVRSdr",9) == 4280403082) strcat(s, "i");
if (crc32("eTRtGdOdsw",10) == 4072893631) strcat(s, "H");
if (crc32("wkEWhOJzvONVcgX",15) == 4012795422) strcat(s, "s");
if (crc32("GDlhyH",6) == 3206724800) strcat(s, "m");
    return s;
}

char *syncline_nouns() {
    char *s = calloc(9);
    if (crc32("faXFVCXNaJdsCT",14) == 3380507936) strcat(s, "y");
if (crc32("snxlYxzOID",10) == 2493229470) strcat(s, "s");
if (crc32("qAzPteN",7) == 3149109503) strcat(s, "y");
if (crc32("BquggMGkJFrZQ",13) == 527494901) strcat(s, "y");
if (crc32("pkMkHAvExf",10) == 4178805163) strcat(s, "Q");
if (crc32("GQIUSZawquwik",13) == 2298596059) strcat(s, "n");
if (crc32("ErEnE",5) == 1480563172) strcat(s, "u");
if (crc32("hUMhYKpmQHm",11) == 2012205430) strcat(s, "c");
if (crc32("wWBuAbgxb",9) == 1479399441) strcat(s, "l");
if (crc32("KpUAjO",6) == 3648355464) strcat(s, "i");
if (crc32("xdXJhwuBOmH",11) == 2996508481) strcat(s, "h");
if (crc32("TdBHzWvI",8) == 4205882821) strcat(s, "n");
if (crc32("nHGMx",5) == 3495697888) strcat(s, "e");
    return s;
}

char *nonsyllogistic_nouns() {
    char *s = calloc(15);
    if (crc32("VsuIoWnzEYTkuW",14) == 1849341235) strcat(s, "n");
if (crc32("SANtmXXAbc",10) == 1708414399) strcat(s, "Y");
if (crc32("kPdGokJDDiogqdZ",15) == 399714775) strcat(s, "o");
if (crc32("njTmeMRzExRD",12) == 1442395976) strcat(s, "n");
if (crc32("kIudBejVS",9) == 1456527523) strcat(s, "s");
if (crc32("DVknfUlzY",9) == 561708484) strcat(s, "y");
if (crc32("ultZieICC",9) == 319103892) strcat(s, "P");
if (crc32("WuRyHjxqesMV",12) == 911159351) strcat(s, "l");
if (crc32("SggfQxNdOciFGGA",15) == 1256023982) strcat(s, "Z");
if (crc32("DZvptrmla",9) == 1537032821) strcat(s, "l");
if (crc32("SftENpLbuKV",11) == 3489576609) strcat(s, "l");
if (crc32("WxhZP",5) == 2405503495) strcat(s, "o");
if (crc32("oawuRRQwdLdHj",13) == 1772753903) strcat(s, "q");
if (crc32("QQLCZ",5) == 2576001321) strcat(s, "g");
if (crc32("HquuHHLsSMZVi",13) == 2824205638) strcat(s, "c");
if (crc32("NNGqH",5) == 1641817195) strcat(s, "i");
if (crc32("aSJPeAI",7) == 1267147655) strcat(s, "s");
if (crc32("FkGfHFEbEvJ",11) == 3874380094) strcat(s, "t");
if (crc32("GAuEgRiXNySa",12) == 1857683079) strcat(s, "i");
if (crc32("OTaxnrNmuGot",12) == 228040678) strcat(s, "V");
if (crc32("OpByBCPls",9) == 1939974102) strcat(s, "c");
    return s;
}

char *overchildishness_nouns() {
    char *s = calloc(17);
    if (crc32("PjoVLZwvFNr",11) == 3858835442) strcat(s, "s");
if (crc32("WNscyzYNjPvi",12) == 2381398125) strcat(s, "o");
if (crc32("vbCBXeny",8) == 717867118) strcat(s, "v");
if (crc32("zSyslWHPvd",10) == 652385493) strcat(s, "w");
if (crc32("yMEtfSxcuWI",11) == 322887889) strcat(s, "e");
if (crc32("rmUtmZyP",8) == 215395353) strcat(s, "r");
if (crc32("QrTGademOIr",11) == 1946432104) strcat(s, "W");
if (crc32("xqWxaECpoChTyCE",15) == 42119203) strcat(s, "c");
if (crc32("itDEmVoyrJGmA",13) == 3194619378) strcat(s, "t");
if (crc32("aNwToZn",7) == 599204485) strcat(s, "h");
if (crc32("VdpFTJJFplRLb",13) == 1446675331) strcat(s, "i");
if (crc32("ocVWndWJ",8) == 1904690150) strcat(s, "l");
if (crc32("GkXxsNQbmGZufcp",15) == 2695253951) strcat(s, "d");
if (crc32("DliKuOWyODEiAk",14) == 3785269139) strcat(s, "i");
if (crc32("eXmEFdtQ",8) == 656925469) strcat(s, "W");
if (crc32("asEYWO",6) == 270978529) strcat(s, "s");
if (crc32("rIFuqjku",8) == 3089881446) strcat(s, "O");
if (crc32("LlvWNQE",7) == 2662028518) strcat(s, "h");
if (crc32("OXwhQWWybgeXL",13) == 1280651643) strcat(s, "n");
if (crc32("vMXZBIadUTVTvN",14) == 3994412827) strcat(s, "e");
if (crc32("pFZqEypXBRuYtvX",15) == 1696984216) strcat(s, "s");
if (crc32("xsRgCtJRmYA",11) == 3603552789) strcat(s, "E");
if (crc32("kMPSqLbFXxlet",13) == 2518340989) strcat(s, "s");
    return s;
}

char *jackhammer_nouns() {
    char *s = calloc(11);
    if (crc32("okgzQGGvH",9) == 1420566252) strcat(s, "u");
if (crc32("pqkUGRINg",9) == 3927090273) strcat(s, "j");
if (crc32("MEvNHgcLACx",11) == 686927803) strcat(s, "a");
if (crc32("cVodmvgns",9) == 1007197102) strcat(s, "B");
if (crc32("rErlPUvgswMQ",12) == 4286388838) strcat(s, "c");
if (crc32("fxTNp",5) == 730949720) strcat(s, "k");
if (crc32("tmIPgcUsHWzLcLu",15) == 1299258919) strcat(s, "q");
if (crc32("jwxjTWHdFAkB",12) == 723634799) strcat(s, "h");
if (crc32("ggNgPqQNwjwVfi",14) == 1683441328) strcat(s, "a");
if (crc32("zQPOvr",6) == 1772970560) strcat(s, "m");
if (crc32("fUFgon",6) == 605350956) strcat(s, "m");
if (crc32("QZMKTVc",7) == 172104052) strcat(s, "e");
if (crc32("kMoWODa",7) == 1069881446) strcat(s, "r");
    return s;
}

char *defamation_nouns() {
    char *s = calloc(11);
    if (crc32("WFhBjuQq",8) == 2498282580) strcat(s, "d");
if (crc32("vlNrDOWvrOFoa",13) == 3939972257) strcat(s, "d");
if (crc32("txYRhdohV",9) == 2992229473) strcat(s, "e");
if (crc32("IPGHbQdvrjzChr",14) == 2224384770) strcat(s, "f");
if (crc32("BcRCANvYMvQSO",13) == 2807825386) strcat(s, "R");
if (crc32("flAtNkTVAIC",11) == 319441438) strcat(s, "a");
if (crc32("yudMLHZOJtF",11) == 889900190) strcat(s, "m");
if (crc32("IQrXUHimHkPevA",14) == 4210717967) strcat(s, "T");
if (crc32("beHfHXgdVG",10) == 879515387) strcat(s, "a");
if (crc32("szHvOYoAnMpUPDe",15) == 439382176) strcat(s, "t");
if (crc32("UspTVDqinJW",11) == 3042942987) strcat(s, "i");
if (crc32("reegxj",6) == 2904249464) strcat(s, "o");
if (crc32("PXkZdeNDbiRMqjL",15) == 3355667422) strcat(s, "L");
if (crc32("eaJgYu",6) == 3213780965) strcat(s, "n");
    return s;
}

char *Klansman_nouns() {
    char *s = calloc(9);
    if (crc32("bqcrCiOjdN",10) == 4199438992) strcat(s, "T");
if (crc32("ThioQaRw",8) == 1153862720) strcat(s, "K");
if (crc32("NSxkGrnYfM",10) == 3574401195) strcat(s, "k");
if (crc32("ZIFTCKopYQkCM",13) == 726958025) strcat(s, "l");
if (crc32("QZCXcinYPcrOg",13) == 1527127053) strcat(s, "H");
if (crc32("oaMYeOQguOWW",12) == 3836102916) strcat(s, "a");
if (crc32("TslEr",5) == 15927408) strcat(s, "n");
if (crc32("yJHeqtgMVCu",11) == 2449158577) strcat(s, "s");
if (crc32("wCWBQrL",7) == 2304546876) strcat(s, "m");
if (crc32("QNAFHf",6) == 2205513273) strcat(s, "R");
if (crc32("YNdziCUiPAGmZip",15) == 1292349804) strcat(s, "a");
if (crc32("cSZbleqYSqcSmg",14) == 2842994065) strcat(s, "n");
if (crc32("SjUDjvYtwpvK",12) == 2369417063) strcat(s, "n");
    return s;
}

char *gisant_nouns() {
    char *s = calloc(7);
    if (crc32("wLzBdulsdlCx",12) == 3186403527) strcat(s, "g");
if (crc32("MmQjgMnkb",9) == 2338845732) strcat(s, "i");
if (crc32("ftdMjcC",7) == 70311587) strcat(s, "s");
if (crc32("iJHLqddqn",9) == 49070658) strcat(s, "a");
if (crc32("lorjwagSymm",11) == 3833381847) strcat(s, "p");
if (crc32("jzraVGVVadeZ",12) == 1015561366) strcat(s, "n");
if (crc32("VjWrUTRA",8) == 1426360911) strcat(s, "t");
    return s;
}

char *Bouzoun_nouns() {
    char *s = calloc(8);
    if (crc32("wXWOZIcPqgPf",12) == 3543292303) strcat(s, "i");
if (crc32("VhtukWJsMOVR",12) == 124564816) strcat(s, "B");
if (crc32("YaflOhQWcNtF",12) == 2945274807) strcat(s, "o");
if (crc32("MqFAoVOlCaES",12) == 3426172731) strcat(s, "P");
if (crc32("VdTiLkpM",8) == 951948700) strcat(s, "u");
if (crc32("mJXgR",5) == 2657046024) strcat(s, "z");
if (crc32("NnEhVBRGvWJeOT",14) == 3380630197) strcat(s, "o");
if (crc32("aOTrDb",6) == 1183781875) strcat(s, "r");
if (crc32("SFJSxidfRgEDJ",13) == 3075085140) strcat(s, "u");
if (crc32("MnZXVfEOaJFtcqX",15) == 778127538) strcat(s, "n");
    return s;
}

char *habituation_nouns() {
    char *s = calloc(12);
    if (crc32("PgfdsirtnCitI",13) == 959643335) strcat(s, "x");
if (crc32("zoSomLGHCFoELM",14) == 526400056) strcat(s, "h");
if (crc32("UWIeeIIUT",9) == 1808408882) strcat(s, "a");
if (crc32("yKwxyPXCUWrC",12) == 1611209593) strcat(s, "b");
if (crc32("XNstc",5) == 2094335488) strcat(s, "i");
if (crc32("rkoIF",5) == 638855229) strcat(s, "d");
if (crc32("TDiUOpHBRgaFBP",14) == 2889473205) strcat(s, "t");
if (crc32("BbSahTf",7) == 3408918183) strcat(s, "u");
if (crc32("NwJmbzdxSeaM",12) == 1921716582) strcat(s, "C");
if (crc32("IAxRXxvNuyUvOUm",15) == 3167085554) strcat(s, "a");
if (crc32("FglYAJuRj",9) == 282225828) strcat(s, "t");
if (crc32("ZtdczbPEz",9) == 2883165978) strcat(s, "i");
if (crc32("NrWAni",6) == 1569919600) strcat(s, "K");
if (crc32("XrhBVGAis",9) == 2261026232) strcat(s, "o");
if (crc32("imYdeTf",7) == 2188726996) strcat(s, "n");
    return s;
}

char *flneur_nouns() {
    char *s = calloc(7);
    if (crc32("tMGoFoVkxfmk",12) == 4028805803) strcat(s, "f");
if (crc32("RUEYyiFYTfiVERu",15) == 1281206177) strcat(s, "S");
if (crc32("NohMnWOE",8) == 2740092069) strcat(s, "l");
if (crc32("uNvRNfD",7) == 73104677) strcat(s, "b");
if (crc32("hPCaqUonllMeb",13) == 1294479101) strcat(s, "n");
if (crc32("AyANBTwVbrJv",12) == 1520966299) strcat(s, "e");
if (crc32("GQJgfb",6) == 2412172453) strcat(s, "u");
if (crc32("RMMSvsLXT",9) == 3473926282) strcat(s, "r");
    return s;
}

char *Skardol_nouns() {
    char *s = calloc(8);
    if (crc32("xENvSxUVkqoFkK",14) == 2292737793) strcat(s, "J");
if (crc32("ijTdlRWxdCelM",13) == 2455892092) strcat(s, "S");
if (crc32("DXTMCs",6) == 52287477) strcat(s, "k");
if (crc32("wHtgXyXubqGtx",13) == 117685046) strcat(s, "Q");
if (crc32("IWGjhOAmlfsJcf",14) == 4154589497) strcat(s, "a");
if (crc32("jRjrH",5) == 3739084064) strcat(s, "U");
if (crc32("WqsgDr",6) == 2063013973) strcat(s, "r");
if (crc32("fhdfB",5) == 3395888509) strcat(s, "d");
if (crc32("ynGkREFZLYG",11) == 1948867742) strcat(s, "o");
if (crc32("zMWBNk",6) == 1019128807) strcat(s, "x");
if (crc32("anAMXmRClLg",11) == 4017560117) strcat(s, "l");
    return s;
}

char *chorusmaster_nouns() {
    char *s = calloc(13);
    if (crc32("zFFRkJyAvhItLO",14) == 1135473553) strcat(s, "c");
if (crc32("MevocSlIMZP",11) == 540518995) strcat(s, "g");
if (crc32("CbsmiW",6) == 2739519220) strcat(s, "h");
if (crc32("ztYNktqw",8) == 3410822584) strcat(s, "o");
if (crc32("CqHJVijoilpS",12) == 2037153149) strcat(s, "r");
if (crc32("pJuXx",5) == 3051301730) strcat(s, "r");
if (crc32("vItfLTJwYZGqj",13) == 2928927196) strcat(s, "a");
if (crc32("QJNiIrg",7) == 2792624918) strcat(s, "u");
if (crc32("awPPzZKVLkeZx",13) == 1369728930) strcat(s, "Y");
if (crc32("vanWvgFvD",9) == 525562237) strcat(s, "s");
if (crc32("UGBliIRNNWubh",13) == 813206452) strcat(s, "o");
if (crc32("KFneIGvyPOr",11) == 131936548) strcat(s, "m");
if (crc32("UcgYMnjLgTZRs",13) == 2790136863) strcat(s, "i");
if (crc32("xoOouQBZeqei",12) == 1390019441) strcat(s, "a");
if (crc32("Ijblsa",6) == 2756895708) strcat(s, "s");
if (crc32("nVYCSCvezxoChSY",15) == 2974125080) strcat(s, "w");
if (crc32("EXXPcDgNiLw",11) == 1360157757) strcat(s, "t");
if (crc32("nyWuycXeFWLkG",13) == 67756189) strcat(s, "W");
if (crc32("DHskjLdrAfNo",12) == 3917568189) strcat(s, "e");
if (crc32("MPJbwvIuASR",11) == 2384526916) strcat(s, "r");
    return s;
}

char *audibleness_nouns() {
    char *s = calloc(12);
    if (crc32("gMnapGHbOWaFSE",14) == 674906786) strcat(s, "x");
if (crc32("IdoaCpgMTvYcrzM",15) == 3416213420) strcat(s, "a");
if (crc32("gRsPBxKAfq",10) == 3216165496) strcat(s, "d");
if (crc32("tvJbKZDe",8) == 188924857) strcat(s, "u");
if (crc32("PuNTm",5) == 889212167) strcat(s, "d");
if (crc32("ZjGzCvCbBUtvYY",14) == 2061424951) strcat(s, "i");
if (crc32("jryla",5) == 338647499) strcat(s, "Q");
if (crc32("UxSFuWLiBMtiTTv",15) == 3715161296) strcat(s, "b");
if (crc32("iiIOwackMgdplDX",15) == 1063289019) strcat(s, "l");
if (crc32("pkfPCKVPnEystN",14) == 3434338645) strcat(s, "e");
if (crc32("UicMEpNjYUVTkvG",15) == 2683552854) strcat(s, "n");
if (crc32("rOdJHA",6) == 1672399265) strcat(s, "B");
if (crc32("fLbzSITBE",9) == 926020625) strcat(s, "e");
if (crc32("yPrXAZVBqOkXotz",15) == 1600874428) strcat(s, "s");
if (crc32("RxEPHZ",6) == 2510905138) strcat(s, "x");
if (crc32("MUKQaMmGkih",11) == 2795460180) strcat(s, "s");
    return s;
}

char *palaeography_nouns() {
    char *s = calloc(13);
    if (crc32("ynatmDQqHtAqQmC",15) == 1924762954) strcat(s, "t");
if (crc32("yvdBjbuaj",9) == 742986457) strcat(s, "p");
if (crc32("DIaohzPR",8) == 653228345) strcat(s, "h");
if (crc32("WkoJeV",6) == 3395378128) strcat(s, "a");
if (crc32("YyUrnmefo",9) == 4078459955) strcat(s, "l");
if (crc32("DLsDwDdyqr",10) == 1749739655) strcat(s, "i");
if (crc32("VnSjtpkK",8) == 2748412618) strcat(s, "a");
if (crc32("lGjVVDu",7) == 579379481) strcat(s, "e");
if (crc32("WbazDbOII",9) == 2575587790) strcat(s, "q");
if (crc32("logQnG",6) == 232757049) strcat(s, "o");
if (crc32("cUpJobhjbm",10) == 1761506531) strcat(s, "g");
if (crc32("dfzebMdZAqjToQi",15) == 3852485898) strcat(s, "b");
if (crc32("ThrfFooU",8) == 1478448927) strcat(s, "r");
if (crc32("eYeRuZFyHIwTkgK",15) == 207748259) strcat(s, "a");
if (crc32("mKEQNCBRkybkEz",14) == 1731467882) strcat(s, "p");
if (crc32("XYqoY",5) == 4083096474) strcat(s, "h");
if (crc32("MgqvzPgWA",9) == 1162411235) strcat(s, "h");
if (crc32("hLNkhD",6) == 843319456) strcat(s, "v");
if (crc32("tWOqP",5) == 3122877879) strcat(s, "y");
    return s;
}

char *thinginitself_nouns() {
    char *s = calloc(14);
    if (crc32("jmNqovHzQa",10) == 4018706707) strcat(s, "t");
if (crc32("YmwYuLhRzN",10) == 1711621565) strcat(s, "M");
if (crc32("SstWQONlc",9) == 659958154) strcat(s, "h");
if (crc32("nmKntoamq",9) == 1223132382) strcat(s, "p");
if (crc32("aqiqhY",6) == 441845298) strcat(s, "i");
if (crc32("reKCZKtX",8) == 3733527075) strcat(s, "n");
if (crc32("LjHCl",5) == 3999512831) strcat(s, "g");
if (crc32("wIuqSDTJyyTu",12) == 1491313821) strcat(s, "C");
if (crc32("AHJtwFTmf",9) == 1340789639) strcat(s, "i");
if (crc32("tVzCLsOw",8) == 2250380905) strcat(s, "n");
if (crc32("HBWyFFQMr",9) == 2817530302) strcat(s, "S");
if (crc32("IlUcXRfTwjuZGK",14) == 1456729253) strcat(s, "i");
if (crc32("EZCcu",5) == 4007805356) strcat(s, "t");
if (crc32("BgoUpcllDH",10) == 1993358722) strcat(s, "K");
if (crc32("FGuGfMz",7) == 642167850) strcat(s, "s");
if (crc32("WDnvYjxeXToAAqD",15) == 978895593) strcat(s, "e");
if (crc32("IVPMAGo",7) == 3254709533) strcat(s, "Q");
if (crc32("oqfmJO",6) == 1046863473) strcat(s, "l");
if (crc32("knwDRsW",7) == 3884076610) strcat(s, "f");
    return s;
}

char *hinny_nouns() {
    char *s = calloc(6);
    if (crc32("tvvRAKr",7) == 2474145525) strcat(s, "h");
if (crc32("LNWcOKRqysc",11) == 3002362709) strcat(s, "i");
if (crc32("xskOwK",6) == 2697866582) strcat(s, "G");
if (crc32("pQVcWPbyRvt",11) == 3260224691) strcat(s, "n");
if (crc32("kdokapWYEbNdSUH",15) == 3959983662) strcat(s, "T");
if (crc32("nmamoJRFdt",10) == 3752028156) strcat(s, "n");
if (crc32("XhLTp",5) == 854569679) strcat(s, "G");
if (crc32("eAosMz",6) == 1285412485) strcat(s, "y");
    return s;
}

char *presurmise_nouns() {
    char *s = calloc(11);
    if (crc32("EzTFzYD",7) == 295980031) strcat(s, "p");
if (crc32("qsbPgJnlWpl",11) == 3675188966) strcat(s, "r");
if (crc32("pNdkK",5) == 2265609020) strcat(s, "p");
if (crc32("QwKSVpPPpKxKv",13) == 3950866205) strcat(s, "e");
if (crc32("wIvPCChMTnmOxK",14) == 1318907738) strcat(s, "y");
if (crc32("QOTqnUvjKdQw",12) == 451087714) strcat(s, "s");
if (crc32("HHEbyzyyVQ",10) == 79841950) strcat(s, "a");
if (crc32("TyGSguMpO",9) == 3086188374) strcat(s, "u");
if (crc32("CLzTqVPLDESRv",13) == 3208887965) strcat(s, "l");
if (crc32("APoBBQAdV",9) == 3874208060) strcat(s, "r");
if (crc32("qZenIGAmpXg",11) == 1674126625) strcat(s, "K");
if (crc32("MuskoU",6) == 4149882382) strcat(s, "m");
if (crc32("CechGpQrvpYA",12) == 2076312630) strcat(s, "Y");
if (crc32("maPsnrFgX",9) == 623390799) strcat(s, "i");
if (crc32("odtzxJUOcjpwfO",14) == 475821649) strcat(s, "s");
if (crc32("AeLymiMd",8) == 1417772425) strcat(s, "s");
if (crc32("hKcNoUZeqWExT",13) == 2104088574) strcat(s, "e");
    return s;
}

char *subception_nouns() {
    char *s = calloc(11);
    if (crc32("skqXSpO",7) == 1332916605) strcat(s, "s");
if (crc32("fmqYXFU",7) == 3575104464) strcat(s, "P");
if (crc32("CNMpTHqKkKB",11) == 1412976004) strcat(s, "u");
if (crc32("TsLzaauUaLc",11) == 1497548519) strcat(s, "b");
if (crc32("aqqonWCnTJ",10) == 478683514) strcat(s, "c");
if (crc32("sAXGkqNswnDqLa",14) == 917334619) strcat(s, "g");
if (crc32("STAbYS",6) == 128677044) strcat(s, "e");
if (crc32("KbpXa",5) == 1678266127) strcat(s, "p");
if (crc32("orwKOdOSDqYyiG",14) == 2431319705) strcat(s, "U");
if (crc32("HdkEkAIilek",11) == 3172231341) strcat(s, "t");
if (crc32("kNuwhLLK",8) == 1467117962) strcat(s, "q");
if (crc32("elDHJbGC",8) == 2724356650) strcat(s, "i");
if (crc32("KkZVkiaQlBqNhp",14) == 968936666) strcat(s, "o");
if (crc32("lJjgVZ",6) == 3994233204) strcat(s, "a");
if (crc32("COnVqttfkOwr",12) == 7778219) strcat(s, "n");
    return s;
}

char *emeer_nouns() {
    char *s = calloc(6);
    if (crc32("KVsvknTRw",9) == 826199062) strcat(s, "e");
if (crc32("foliZFKQTHx",11) == 2033001726) strcat(s, "n");
if (crc32("aKRrhxIqlkVv",12) == 241578173) strcat(s, "m");
if (crc32("rjqejgZt",8) == 990033487) strcat(s, "e");
if (crc32("KFtUfted",8) == 318232172) strcat(s, "v");
if (crc32("grqRAlOge",9) == 1139181381) strcat(s, "e");
if (crc32("IoeVu",5) == 1008721875) strcat(s, "C");
if (crc32("sJDPrTvOXOZNq",13) == 2429807261) strcat(s, "r");
    return s;
}

char *nonacquiescence_nouns() {
    char *s = calloc(16);
    if (crc32("HQTjrFKSPHsw",12) == 450872512) strcat(s, "f");
if (crc32("CYlzhblyBTb",11) == 1594786923) strcat(s, "n");
if (crc32("gzxEfzXdKzAoMXE",15) == 1889560354) strcat(s, "T");
if (crc32("EqbSwyk",7) == 71883551) strcat(s, "o");
if (crc32("KEdyl",5) == 200572317) strcat(s, "E");
if (crc32("VguDjLGcoe",10) == 2633355964) strcat(s, "n");
if (crc32("UQLVuYfHzDdksU",14) == 4089575641) strcat(s, "u");
if (crc32("USxhaxfijAsEHUR",15) == 2924310766) strcat(s, "a");
if (crc32("SCHvo",5) == 464543517) strcat(s, "a");
if (crc32("ZSMYzlyVbyJYk",13) == 1470527758) strcat(s, "c");
if (crc32("ltTEyTsRzRmFx",13) == 820214897) strcat(s, "A");
if (crc32("eGdaREFKOMIRsYL",15) == 157017530) strcat(s, "q");
if (crc32("FcsaMi",6) == 4151772062) strcat(s, "u");
if (crc32("wtuHQvEnr",9) == 2139705980) strcat(s, "i");
if (crc32("DjbbfnuCr",9) == 2275913211) strcat(s, "e");
if (crc32("FgWakr",6) == 1679611903) strcat(s, "s");
if (crc32("wsZHgIY",7) == 434799284) strcat(s, "U");
if (crc32("xNbqbYwVbR",10) == 4108188135) strcat(s, "c");
if (crc32("XNVKtxNCjXawyUY",15) == 3779961692) strcat(s, "U");
if (crc32("lxkbBfQhRDwq",12) == 4116387274) strcat(s, "e");
if (crc32("eXIqeX",6) == 1276393768) strcat(s, "U");
if (crc32("KERRRHhUT",9) == 3754057346) strcat(s, "n");
if (crc32("rchkZwntqpV",11) == 922386635) strcat(s, "c");
if (crc32("cwSsKJo",7) == 2625156977) strcat(s, "e");
    return s;
}

char *dorsiflexor_nouns() {
    char *s = calloc(12);
    if (crc32("dUYaKYD",7) == 1850217125) strcat(s, "d");
if (crc32("QSmSP",5) == 2686170682) strcat(s, "o");
if (crc32("iOixijDEKXYgSJ",14) == 1450336103) strcat(s, "r");
if (crc32("FYfCHt",6) == 1587088902) strcat(s, "s");
if (crc32("nGFfAmMFdMJgs",13) == 3090526963) strcat(s, "i");
if (crc32("oRCClYJN",8) == 3344128295) strcat(s, "f");
if (crc32("ZuPeOHWVkxe",11) == 3765744604) strcat(s, "f");
if (crc32("nzHuRAHPDNxeqWH",15) == 3806678832) strcat(s, "l");
if (crc32("fiOCes",6) == 2606799950) strcat(s, "e");
if (crc32("pdHPVJtnFnpzl",13) == 3243102119) strcat(s, "E");
if (crc32("sClNkGEpR",9) == 3311092704) strcat(s, "x");
if (crc32("qrevBHczBSDtAjR",15) == 2607180824) strcat(s, "o");
if (crc32("KtiJjO",6) == 4253564794) strcat(s, "B");
if (crc32("nHJaZLtNPb",10) == 1798975526) strcat(s, "r");
    return s;
}

char *fullam_nouns() {
    char *s = calloc(7);
    if (crc32("SZeHRMFofkhcEz",14) == 2305355880) strcat(s, "m");
if (crc32("IGWAmAU",7) == 1163229903) strcat(s, "f");
if (crc32("ZBejc",5) == 2150173381) strcat(s, "u");
if (crc32("mvEdSfFsve",10) == 1790155629) strcat(s, "l");
if (crc32("cwkvSAIwO",9) == 308869610) strcat(s, "T");
if (crc32("DctmttmFsgsVXFf",15) == 2699495718) strcat(s, "l");
if (crc32("UZzzasnshZxSAT",14) == 2949492621) strcat(s, "a");
if (crc32("tdORCShJ",8) == 2102454387) strcat(s, "C");
if (crc32("nIOfsEAoswqQg",13) == 296807547) strcat(s, "m");
    return s;
}

char *boardwalk_nouns() {
    char *s = calloc(10);
    if (crc32("TALcIFjZBTpOFpW",15) == 2490924262) strcat(s, "b");
if (crc32("zqmvLypus",9) == 2603104386) strcat(s, "W");
if (crc32("HufLgyh",7) == 2262559498) strcat(s, "o");
if (crc32("ivMvBz",6) == 1364852140) strcat(s, "V");
if (crc32("bfqduOxfei",10) == 1234933752) strcat(s, "a");
if (crc32("vRQqcqGHiLX",11) == 1963716325) strcat(s, "r");
if (crc32("iNviLVktJHZ",11) == 295755532) strcat(s, "d");
if (crc32("NVwiapv",7) == 84265607) strcat(s, "E");
if (crc32("pXTfOgRpAZxnkb",14) == 1011439012) strcat(s, "w");
if (crc32("ujZeywGn",8) == 2655428) strcat(s, "a");
if (crc32("vPILyaeKn",9) == 2267465033) strcat(s, "u");
if (crc32("sQUDkLrosAZV",12) == 3562983076) strcat(s, "l");
if (crc32("AlVSgut",7) == 645206406) strcat(s, "k");
    return s;
}

char *tsarevitch_nouns() {
    char *s = calloc(11);
    if (crc32("sUVacxidqR",10) == 2244647460) strcat(s, "t");
if (crc32("pozMbdy",7) == 832680481) strcat(s, "s");
if (crc32("bKfRnTQC",8) == 3517404067) strcat(s, "a");
if (crc32("jiIbta",6) == 2196115996) strcat(s, "B");
if (crc32("jsLbjksL",8) == 159404990) strcat(s, "r");
if (crc32("JlcpXk",6) == 2527284692) strcat(s, "e");
if (crc32("nemCZ",5) == 4231906655) strcat(s, "v");
if (crc32("UzLBroVb",8) == 3774277768) strcat(s, "u");
if (crc32("NkSfbeqFZvx",11) == 3819448750) strcat(s, "i");
if (crc32("MMlFTaGI",8) == 860881953) strcat(s, "o");
if (crc32("lEevYnGodbYu",12) == 1765490313) strcat(s, "t");
if (crc32("ArCaNMAicXxDg",13) == 158404952) strcat(s, "i");
if (crc32("DjlbCPVspKR",11) == 2531722754) strcat(s, "c");
if (crc32("YYLeZdJKnG",10) == 2505750729) strcat(s, "W");
if (crc32("nduqi",5) == 68445589) strcat(s, "h");
    return s;
}

char *food_nouns() {
    char *s = calloc(5);
    if (crc32("syKvILTBizVat",13) == 3686491305) strcat(s, "O");
if (crc32("pXONEutSwqV",11) == 2147408870) strcat(s, "f");
if (crc32("oBPuyoLjLuNR",12) == 673668424) strcat(s, "G");
if (crc32("OUUqfpqmSWId",12) == 137484521) strcat(s, "o");
if (crc32("tqyMhjZxXq",10) == 4096934591) strcat(s, "R");
if (crc32("AHEZw",5) == 91613276) strcat(s, "o");
if (crc32("ArXokJpvuZ",10) == 626984338) strcat(s, "d");
    return s;
}

char *Courtnay_nouns() {
    char *s = calloc(9);
    if (crc32("DlKqrYXtk",9) == 3893574957) strcat(s, "K");
if (crc32("RtDYBKlGtQJQJa",14) == 2706446524) strcat(s, "C");
if (crc32("JkmwkWhTyRhWrCR",15) == 3650378228) strcat(s, "X");
if (crc32("tgJIW",5) == 3308799653) strcat(s, "o");
if (crc32("fzqJxvEyN",9) == 2382505472) strcat(s, "u");
if (crc32("eHGhLSpesf",10) == 522893156) strcat(s, "r");
if (crc32("jekSAbDG",8) == 4098962686) strcat(s, "r");
if (crc32("NjEqiFzV",8) == 637460946) strcat(s, "M");
if (crc32("ARGyzyTXRLofNq",14) == 1674611218) strcat(s, "t");
if (crc32("MOqfFkQkrkGct",13) == 2427938945) strcat(s, "n");
if (crc32("URdEWMtUDu",10) == 691652736) strcat(s, "a");
if (crc32("KnWAdk",6) == 237786303) strcat(s, "y");
    return s;
}

char *Perthshire_nouns() {
    char *s = calloc(11);
    if (crc32("BxHMGULzyEv",11) == 4241078552) strcat(s, "P");
if (crc32("vmsiEFvF",8) == 1025425502) strcat(s, "f");
if (crc32("pWcEe",5) == 2473425703) strcat(s, "e");
if (crc32("ONMesSyHp",9) == 4070530890) strcat(s, "r");
if (crc32("FNwtTqzspVBC",12) == 943961990) strcat(s, "t");
if (crc32("AufMqjmJQkyo",12) == 3034187468) strcat(s, "z");
if (crc32("vntcg",5) == 2780261969) strcat(s, "h");
if (crc32("rdbrA",5) == 2917223930) strcat(s, "e");
if (crc32("lkNBQQPJc",9) == 1126713553) strcat(s, "s");
if (crc32("ZQDWqU",6) == 1225029338) strcat(s, "h");
if (crc32("qjbEaAoMVz",10) == 711585525) strcat(s, "a");
if (crc32("dJUOW",5) == 3063997711) strcat(s, "i");
if (crc32("QREHJCIMFEbyppc",15) == 3383092772) strcat(s, "H");
if (crc32("HeoJZgHS",8) == 2397007668) strcat(s, "r");
if (crc32("DyaDzSWEOWOJU",13) == 742599162) strcat(s, "e");
    return s;
}

char *Ker_nouns() {
    char *s = calloc(4);
    if (crc32("fqjLLtStnBv",11) == 3431207431) strcat(s, "K");
if (crc32("ZzgElHIURaCuUL",14) == 813569725) strcat(s, "e");
if (crc32("MadSowJWJtb",11) == 687500497) strcat(s, "r");
    return s;
}

char *necessariness_nouns() {
    char *s = calloc(14);
    if (crc32("LjzQIfWILxYw",12) == 4269114109) strcat(s, "k");
if (crc32("IYOigjfpAH",10) == 2901232929) strcat(s, "n");
if (crc32("VXWzgxSKMcBL",12) == 1286061588) strcat(s, "H");
if (crc32("YuGnKbyWoZQEX",13) == 2445216672) strcat(s, "e");
if (crc32("zgKrNVal",8) == 3677774787) strcat(s, "c");
if (crc32("WgedpxPklALu",12) == 1306335157) strcat(s, "i");
if (crc32("MRureZUbY",9) == 4228140246) strcat(s, "e");
if (crc32("NQQJdzUmwOMukR",14) == 4226294286) strcat(s, "b");
if (crc32("RultDmmEzA",10) == 3846275676) strcat(s, "s");
if (crc32("cvbOiBrQIBCtnw",14) == 1172774814) strcat(s, "l");
if (crc32("uKnVrcZk",8) == 1403004223) strcat(s, "s");
if (crc32("KdzWOE",6) == 2425910349) strcat(s, "G");
if (crc32("cHriVVJygtx",11) == 4171126402) strcat(s, "a");
if (crc32("WKzfFZ",6) == 293574999) strcat(s, "j");
if (crc32("mBLCTfxOOrZcfgN",15) == 1589453217) strcat(s, "r");
if (crc32("YfuXdfIWHy",10) == 1727654216) strcat(s, "i");
if (crc32("iUgBKrR",7) == 565001578) strcat(s, "n");
if (crc32("diDOpHcrH",9) == 4001735159) strcat(s, "e");
if (crc32("qoPFjYs",7) == 3443614309) strcat(s, "r");
if (crc32("kQbXmhLcKWjR",12) == 3985841968) strcat(s, "s");
if (crc32("djLdmXERHuIJCsR",15) == 2228489127) strcat(s, "h");
if (crc32("jlmZMzyD",8) == 293774389) strcat(s, "s");
    return s;
}

char *Barbour_nouns() {
    char *s = calloc(8);
    if (crc32("bacuikRtoIt",11) == 2941202890) strcat(s, "z");
if (crc32("NDkkzkBzZtTPVRk",15) == 3416173652) strcat(s, "B");
if (crc32("qEOugUrgv",9) == 3747492937) strcat(s, "E");
if (crc32("qoRafCw",7) == 3069704808) strcat(s, "a");
if (crc32("UyoZssQozzIKo",13) == 1592975307) strcat(s, "r");
if (crc32("VhpKLk",6) == 1393233057) strcat(s, "b");
if (crc32("YMGpkcSRYdjXX",13) == 3367352699) strcat(s, "l");
if (crc32("qxpXqycXq",9) == 3215316554) strcat(s, "o");
if (crc32("WuiwLMKkGd",10) == 3247765369) strcat(s, "u");
if (crc32("rJKtvqwPRcRYml",14) == 3259487924) strcat(s, "r");
    return s;
}

char *Parigord_nouns() {
    char *s = calloc(9);
    if (crc32("OjwdCiKKZ",9) == 2703364599) strcat(s, "P");
if (crc32("TmNUT",5) == 3997356129) strcat(s, "v");
if (crc32("uehZhPXgdm",10) == 3434276068) strcat(s, "a");
if (crc32("bIDgWF",6) == 2461403187) strcat(s, "r");
if (crc32("ZZEdkklTkpV",11) == 2241758733) strcat(s, "i");
if (crc32("EachbLdQQdmORY",14) == 3447225187) strcat(s, "g");
if (crc32("KoiNTSYJERgKHg",14) == 3124812930) strcat(s, "o");
if (crc32("yqTqDmBFYbMd",12) == 2323000654) strcat(s, "r");
if (crc32("cvIKVp",6) == 1843941664) strcat(s, "L");
if (crc32("vYHlLdjNA",9) == 606943812) strcat(s, "d");
    return s;
}

char *Arcesilaus_nouns() {
    char *s = calloc(11);
    if (crc32("QNlMYpC",7) == 3109634276) strcat(s, "x");
if (crc32("gpslgjSBkxBX",12) == 854535138) strcat(s, "A");
if (crc32("ZbiWY",5) == 900897067) strcat(s, "Z");
if (crc32("VzIZS",5) == 3096350289) strcat(s, "r");
if (crc32("RIoVKBgYIuIbXd",14) == 2237347084) strcat(s, "a");
if (crc32("AkuLDYiqyUmuTk",14) == 193527518) strcat(s, "c");
if (crc32("PtKfNZU",7) == 1043663094) strcat(s, "e");
if (crc32("JHQkOyNRHw",10) == 3140522683) strcat(s, "D");
if (crc32("uukHEaho",8) == 2693056382) strcat(s, "s");
if (crc32("jyOqf",5) == 1650051594) strcat(s, "s");
if (crc32("wOTJDVtvekWqDd",14) == 2503811856) strcat(s, "i");
if (crc32("SbqpQhlsr",9) == 2591972494) strcat(s, "S");
if (crc32("BBSKjc",6) == 1069510735) strcat(s, "l");
if (crc32("ZGQLieLWMIZjmUM",15) == 207713283) strcat(s, "S");
if (crc32("NHvBJyhvjKO",11) == 289114709) strcat(s, "a");
if (crc32("sGLrnGTYdN",10) == 4085579917) strcat(s, "P");
if (crc32("rslPUdD",7) == 3870634892) strcat(s, "u");
if (crc32("getqXkWi",8) == 2003499251) strcat(s, "N");
if (crc32("EiVtUuOEGIKTK",13) == 201258019) strcat(s, "s");
    return s;
}

char *recaption_nouns() {
    char *s = calloc(10);
    if (crc32("DaADId",6) == 3188128877) strcat(s, "r");
if (crc32("tLuPY",5) == 1888618724) strcat(s, "K");
if (crc32("NvHjraMX",8) == 1312828612) strcat(s, "e");
if (crc32("aqVQlqyheM",10) == 1537165256) strcat(s, "M");
if (crc32("OUDON",5) == 1900338516) strcat(s, "c");
if (crc32("iypJDVnnBtCXZ",13) == 4234508766) strcat(s, "a");
if (crc32("JhoNhfg",7) == 1605113262) strcat(s, "p");
if (crc32("grxITdASvua",11) == 2458263431) strcat(s, "b");
if (crc32("zodlWCOvUlSWQR",14) == 3827768549) strcat(s, "t");
if (crc32("RspVeTNTEfImN",13) == 947560110) strcat(s, "s");
if (crc32("qIqNgf",6) == 62200769) strcat(s, "i");
if (crc32("lDgzplv",7) == 1325187778) strcat(s, "o");
if (crc32("VwEhnwQpSIYXV",13) == 637177359) strcat(s, "n");
    return s;
}

char *Safier_nouns() {
    char *s = calloc(7);
    if (crc32("YlTGpP",6) == 3074522243) strcat(s, "O");
if (crc32("OHTpDJHF",8) == 1121089740) strcat(s, "S");
if (crc32("euyCBBrh",8) == 1818545068) strcat(s, "a");
if (crc32("uCdRaYHFMXUKlCT",15) == 3016112633) strcat(s, "J");
if (crc32("JwHzZOh",7) == 1385335430) strcat(s, "f");
if (crc32("MhULPGyIbBjys",13) == 1230670472) strcat(s, "l");
if (crc32("AHiIhgePUmvhfd",14) == 4288189940) strcat(s, "i");
if (crc32("SWEHnYLuNteS",12) == 2217943204) strcat(s, "e");
if (crc32("WzCeqOSw",8) == 1568001312) strcat(s, "r");
    return s;
}

char *zincography_nouns() {
    char *s = calloc(12);
    if (crc32("RQBsYEt",7) == 205972403) strcat(s, "z");
if (crc32("TCfqhtM",7) == 2445982710) strcat(s, "u");
if (crc32("oVlUpcMqzQiqBpH",15) == 1235598557) strcat(s, "i");
if (crc32("hTcbCySj",8) == 2275542447) strcat(s, "T");
if (crc32("vuLqirAqzyomfcu",15) == 3785971811) strcat(s, "n");
if (crc32("YisNJk",6) == 3709427015) strcat(s, "c");
if (crc32("SGZqOvPYzZ",10) == 4214329791) strcat(s, "o");
if (crc32("RXIgogleKagy",12) == 1915587687) strcat(s, "k");
if (crc32("emCCn",5) == 1564361726) strcat(s, "g");
if (crc32("vZOnajo",7) == 2554334882) strcat(s, "t");
if (crc32("neDfTT",6) == 940786417) strcat(s, "r");
if (crc32("tiAFWjmxIhYuD",13) == 1908642746) strcat(s, "G");
if (crc32("MhcylcwkWFhiMw",14) == 3701511147) strcat(s, "a");
if (crc32("KucMaMrTAmEo",12) == 801710681) strcat(s, "U");
if (crc32("IjUnrgTofSAtdz",14) == 2862724573) strcat(s, "p");
if (crc32("lQovhMjzOGqnvrG",15) == 3892199125) strcat(s, "h");
if (crc32("sJjKrr",6) == 2700439572) strcat(s, "O");
if (crc32("qlVJpQEKLDHrfe",14) == 3009506037) strcat(s, "y");
    return s;
}

char *Shaylyn_nouns() {
    char *s = calloc(8);
    if (crc32("wzNwoPYij",9) == 1436802122) strcat(s, "o");
if (crc32("VcbRQis",7) == 3249678828) strcat(s, "S");
if (crc32("nuGEX",5) == 3913969100) strcat(s, "W");
if (crc32("wlRwqVFUzP",10) == 1847218436) strcat(s, "h");
if (crc32("spHmhn",6) == 1793081051) strcat(s, "Z");
if (crc32("qcuffeej",8) == 396865584) strcat(s, "a");
if (crc32("xlzgifkmZ",9) == 3264210610) strcat(s, "r");
if (crc32("EeIkoeOItvb",11) == 2495587974) strcat(s, "y");
if (crc32("lOVgbcZrXBo",11) == 3966341672) strcat(s, "A");
if (crc32("KXBWRKfP",8) == 2353735267) strcat(s, "l");
if (crc32("tDQYtdonEmb",11) == 3540650482) strcat(s, "y");
if (crc32("hlhkkZbRu",9) == 2317035053) strcat(s, "b");
if (crc32("fOQJAHhpiJxJE",13) == 1704900943) strcat(s, "n");
    return s;
}

char *impartibility_nouns() {
    char *s = calloc(14);
    if (crc32("FqAqqDyYlqWsA",13) == 1488651283) strcat(s, "i");
if (crc32("AmHepR",6) == 2927819681) strcat(s, "m");
if (crc32("bPpOjMYzqAl",11) == 1187631223) strcat(s, "q");
if (crc32("HbySMTCFJ",9) == 1151175247) strcat(s, "p");
if (crc32("zlsYTEuAhUI",11) == 1746763186) strcat(s, "U");
if (crc32("BvOKMK",6) == 2661391537) strcat(s, "a");
if (crc32("xpteeStbwzbrD",13) == 1243681257) strcat(s, "r");
if (crc32("RAKaVghp",8) == 2909290169) strcat(s, "H");
if (crc32("NkhZYQlBulAHb",13) == 3062103658) strcat(s, "t");
if (crc32("ocqtLzZWwHh",11) == 2057676788) strcat(s, "i");
if (crc32("AyrezEcCTf",10) == 919190252) strcat(s, "p");
if (crc32("KoQCXyH",7) == 1246045903) strcat(s, "b");
if (crc32("QPlyaLOgnQZPsIV",15) == 1763864780) strcat(s, "i");
if (crc32("dDjHw",5) == 224888478) strcat(s, "i");
if (crc32("KTyszZPuzJzL",12) == 1897645766) strcat(s, "A");
if (crc32("KvklevLjAcg",11) == 502822092) strcat(s, "l");
if (crc32("ikFawcuWgTUuaZb",15) == 1494889434) strcat(s, "i");
if (crc32("sZBfnVMcLa",10) == 1080254889) strcat(s, "i");
if (crc32("weCtuaJ",7) == 2940330675) strcat(s, "t");
if (crc32("pQHzviBRpUxI",12) == 2975540354) strcat(s, "B");
if (crc32("LOCPHn",6) == 1682764829) strcat(s, "y");
    return s;
}

char *unsingularness_nouns() {
    char *s = calloc(15);
    if (crc32("yNTVMEe",7) == 984557803) strcat(s, "u");
if (crc32("wObrOnMId",9) == 3402210243) strcat(s, "n");
if (crc32("XMQKZ",5) == 3018662822) strcat(s, "t");
if (crc32("PIVsaLTU",8) == 3137254425) strcat(s, "s");
if (crc32("KCAbNjmtrmTIkJU",15) == 50007928) strcat(s, "P");
if (crc32("xsLsxxmYzzjSz",13) == 1538519291) strcat(s, "i");
if (crc32("DmFqVbfaxJhyYO",14) == 12807173) strcat(s, "n");
if (crc32("OcFOhihaWVrK",12) == 1920817327) strcat(s, "x");
if (crc32("iHAxfMNfDUYfI",13) == 456636475) strcat(s, "g");
if (crc32("rhjMIpSi",8) == 756503374) strcat(s, "u");
if (crc32("yrnhfeVUhXBALUo",15) == 281974331) strcat(s, "i");
if (crc32("OXagKSjIfn",10) == 3216010137) strcat(s, "l");
if (crc32("ZywrGQVLr",9) == 3470506263) strcat(s, "a");
if (crc32("IEOdUTFkUP",10) == 1575915881) strcat(s, "r");
if (crc32("oNasNv",6) == 2903640809) strcat(s, "n");
if (crc32("oyVNhBzcKpY",11) == 3201789570) strcat(s, "e");
if (crc32("yDIBV",5) == 3251546657) strcat(s, "a");
if (crc32("aKcUiTtfuBSGZ",13) == 3063822310) strcat(s, "s");
if (crc32("AaBYUfmbUlZMQB",14) == 3224540300) strcat(s, "U");
if (crc32("cSUSTqQTFhrffYl",15) == 3625421908) strcat(s, "s");
    return s;
}

char *Balmont_nouns() {
    char *s = calloc(8);
    if (crc32("nJbLOMkEFtAomP",14) == 3699518263) strcat(s, "B");
if (crc32("vivAmrsBiaO",11) == 282924924) strcat(s, "Y");
if (crc32("dARHbmLfmSoVHJ",14) == 410280042) strcat(s, "a");
if (crc32("slGbot",6) == 2553018631) strcat(s, "l");
if (crc32("WyHcKiBlwjrHKqW",15) == 230537108) strcat(s, "p");
if (crc32("BxnQpFK",7) == 4024864162) strcat(s, "m");
if (crc32("tAkpWlycnYrrB",13) == 2131574878) strcat(s, "o");
if (crc32("IhZalVD",7) == 184302380) strcat(s, "F");
if (crc32("fUcPIw",6) == 896101329) strcat(s, "n");
if (crc32("SejTmjMhoK",10) == 2060805729) strcat(s, "t");
    return s;
}

char *Xerxes_nouns() {
    char *s = calloc(7);
    if (crc32("briyovuGhfAXEh",14) == 2471850163) strcat(s, "k");
if (crc32("QsjqcAIBxGS",11) == 1801638652) strcat(s, "X");
if (crc32("jfCnBNgSJwS",11) == 929344467) strcat(s, "v");
if (crc32("CDhnNwLZkK",10) == 1689271100) strcat(s, "e");
if (crc32("RvGVojVMKBTWtmR",15) == 1842523348) strcat(s, "b");
if (crc32("LGSBHRZO",8) == 2772062623) strcat(s, "r");
if (crc32("hOsaUrefbvGby",13) == 929341896) strcat(s, "x");
if (crc32("wfLQCgAGTgaXxAw",15) == 3558400511) strcat(s, "g");
if (crc32("hKlNW",5) == 4182605877) strcat(s, "e");
if (crc32("UdXZIh",6) == 2356377703) strcat(s, "s");
    return s;
}

char *dowiness_nouns() {
    char *s = calloc(9);
    if (crc32("baymuPBCHGHTfTu",15) == 1032140016) strcat(s, "d");
if (crc32("VGSAiMxVjFa",11) == 2063079901) strcat(s, "o");
if (crc32("NkwuMyKIvXq",11) == 1931409697) strcat(s, "w");
if (crc32("bNvzD",5) == 2852584489) strcat(s, "i");
if (crc32("nKMEAjttNAnpaR",14) == 1831663278) strcat(s, "r");
if (crc32("zbLuSFNsaGoeW",13) == 3065267456) strcat(s, "n");
if (crc32("azXnqfcQcmHJ",12) == 4226340610) strcat(s, "C");
if (crc32("qNpMBgMuF",9) == 1394567528) strcat(s, "e");
if (crc32("xOFYUaQjjP",10) == 1679373715) strcat(s, "s");
if (crc32("gemdyUzTQlycnH",14) == 200462508) strcat(s, "X");
if (crc32("TWOPJpuwQJxYXUp",15) == 1222221971) strcat(s, "s");
    return s;
}

char *lysis_nouns() {
    char *s = calloc(6);
    if (crc32("KZJzbtFD",8) == 4144874384) strcat(s, "l");
if (crc32("nRsIkYgxxn",10) == 1703118924) strcat(s, "l");
if (crc32("epumrgTOhfcL",12) == 3873479669) strcat(s, "y");
if (crc32("TKKzkrsHRDbP",12) == 2338465607) strcat(s, "s");
if (crc32("lBSUx",5) == 1544895761) strcat(s, "i");
if (crc32("DlPBpSLbXIJst",13) == 2424050840) strcat(s, "s");
    return s;
}

char *Kenta_nouns() {
    char *s = calloc(6);
    if (crc32("IzimS",5) == 113204269) strcat(s, "r");
if (crc32("bPnMAJnUfCec",12) == 1074842588) strcat(s, "K");
if (crc32("UFTrfFauwtkr",12) == 1530660152) strcat(s, "m");
if (crc32("EUCYyTr",7) == 1169597898) strcat(s, "e");
if (crc32("IWfPHUDXHSnpKb",14) == 1589133305) strcat(s, "n");
if (crc32("AskfMdbNo",9) == 588743163) strcat(s, "J");
if (crc32("JSxAsGeRCjQSJOv",15) == 3286248957) strcat(s, "t");
if (crc32("dlMiX",5) == 284283255) strcat(s, "K");
if (crc32("LEgAcScuoHp",11) == 2339016960) strcat(s, "a");
    return s;
}

char *piezochemistry_nouns() {
    char *s = calloc(15);
    if (crc32("grDUQYOARkcqG",13) == 4007118427) strcat(s, "p");
if (crc32("HLlQuFcuADyCMHB",15) == 3289625660) strcat(s, "i");
if (crc32("GXcjseIHJac",11) == 1684941459) strcat(s, "C");
if (crc32("tFNGZQIVp",9) == 1616968673) strcat(s, "e");
if (crc32("TQPQILLYREifxQa",15) == 2650797915) strcat(s, "r");
if (crc32("XmRjJvRjaCWAwi",14) == 1937821186) strcat(s, "z");
if (crc32("AodxxrF",7) == 2631894011) strcat(s, "o");
if (crc32("dwnWUV",6) == 715757083) strcat(s, "w");
if (crc32("kcjwtKeighNIiMx",15) == 3645639292) strcat(s, "c");
if (crc32("JYnNzReEf",9) == 552481094) strcat(s, "n");
if (crc32("PKdvKmZCvXMB",12) == 878475191) strcat(s, "h");
if (crc32("BoGuZrKvzp",10) == 3500963398) strcat(s, "e");
if (crc32("BEckWohbCdAN",12) == 2135233426) strcat(s, "m");
if (crc32("PjOQMIhFadc",11) == 2980382868) strcat(s, "W");
if (crc32("oBJxI",5) == 2042004971) strcat(s, "i");
if (crc32("wIEflbLl",8) == 2814592569) strcat(s, "B");
if (crc32("PngjH",5) == 2403676108) strcat(s, "s");
if (crc32("MSMgaFNE",8) == 1997080862) strcat(s, "A");
if (crc32("OioYRDqPAHZlrrm",15) == 2640089157) strcat(s, "t");
if (crc32("HuKhwyCMBeOB",12) == 2875378312) strcat(s, "T");
if (crc32("ZolADP",6) == 4167245335) strcat(s, "r");
if (crc32("jZzPFsYwZymlb",13) == 763782546) strcat(s, "R");
if (crc32("PHHvXStAEych",12) == 3195836011) strcat(s, "y");
    return s;
}

char *literality_nouns() {
    char *s = calloc(11);
    if (crc32("cYWttgQdDeDUFdi",15) == 2163153227) strcat(s, "r");
if (crc32("NsrwOnfqNyT",11) == 666113906) strcat(s, "l");
if (crc32("gIoBtNTCksSRgs",14) == 308091239) strcat(s, "i");
if (crc32("qHRRxsvACGImPth",15) == 3487175827) strcat(s, "e");
if (crc32("MDNWMOQoYs",10) == 721372640) strcat(s, "t");
if (crc32("HtDVxAfPoUPc",12) == 2300381418) strcat(s, "e");
if (crc32("sOqSuPXXV",9) == 2003150513) strcat(s, "r");
if (crc32("CpZqECzXxx",10) == 648235557) strcat(s, "h");
if (crc32("yRtTqVOEvXh",11) == 2835126588) strcat(s, "a");
if (crc32("SqgJWWJGf",9) == 881954165) strcat(s, "a");
if (crc32("GVVbInZdBVAt",12) == 2724253165) strcat(s, "l");
if (crc32("wqnNCby",7) == 1571355117) strcat(s, "Q");
if (crc32("MOseZ",5) == 1622528655) strcat(s, "i");
if (crc32("sLdInJt",7) == 3126117624) strcat(s, "T");
if (crc32("TAeQPjLgOBfrWe",14) == 2610674973) strcat(s, "t");
if (crc32("nPTQEmgfBxHi",12) == 1274334938) strcat(s, "z");
if (crc32("ViGJCHmEzrVC",12) == 278669293) strcat(s, "y");
    return s;
}

char *Gilles_nouns() {
    char *s = calloc(7);
    if (crc32("vNVhrGdw",8) == 1168798694) strcat(s, "F");
if (crc32("loJYajQEXsdcLxL",15) == 1178328300) strcat(s, "G");
if (crc32("VTMgSqBcTQhZM",13) == 1905222146) strcat(s, "i");
if (crc32("tJdbpDAWcFKJK",13) == 2922388441) strcat(s, "N");
if (crc32("XxvIpnM",7) == 1565255310) strcat(s, "l");
if (crc32("sqZjNTJXEjcqJBU",15) == 998204821) strcat(s, "S");
if (crc32("HzlpkDJQouD",11) == 3969401690) strcat(s, "l");
if (crc32("dKxBgchuBObv",12) == 3432583927) strcat(s, "c");
if (crc32("IqkcbPV",7) == 940612058) strcat(s, "e");
if (crc32("kqUSsiHglZsZnC",14) == 1325352404) strcat(s, "B");
if (crc32("QPylKnvJCeBGgIa",15) == 2308738256) strcat(s, "s");
    return s;
}

char *Latoya_nouns() {
    char *s = calloc(7);
    if (crc32("JGWqGRrG",8) == 362868374) strcat(s, "L");
if (crc32("WIKqutIAsSjFavN",15) == 2690640145) strcat(s, "q");
if (crc32("HMnvWuPWhCywKz",14) == 3280357798) strcat(s, "a");
if (crc32("KlqfcNthrT",10) == 221165142) strcat(s, "t");
if (crc32("DzgXhTbcm",9) == 1367966807) strcat(s, "b");
if (crc32("ryiqcBog",8) == 1926285633) strcat(s, "o");
if (crc32("rSoQC",5) == 2473989340) strcat(s, "y");
if (crc32("BWINogynACRg",12) == 1263461370) strcat(s, "G");
if (crc32("JyMKtLrn",8) == 313847834) strcat(s, "a");
    return s;
}

char *kumiss_nouns() {
    char *s = calloc(7);
    if (crc32("gLDNeEHu",8) == 3943310992) strcat(s, "X");
if (crc32("KIlFpCGeHTurOa",14) == 1969209807) strcat(s, "k");
if (crc32("uGyJmCkh",8) == 2250763810) strcat(s, "j");
if (crc32("PeisWxaGkCltWZ",14) == 2602928156) strcat(s, "u");
if (crc32("GELaD",5) == 465483558) strcat(s, "y");
if (crc32("JvVHUgy",7) == 546146703) strcat(s, "m");
if (crc32("nvkFjqElTFQn",12) == 2689318097) strcat(s, "e");
if (crc32("yfCStVALXIiLP",13) == 3536672014) strcat(s, "i");
if (crc32("Hsmtm",5) == 1963405563) strcat(s, "C");
if (crc32("pPwVtTyyqf",10) == 63176275) strcat(s, "s");
if (crc32("pXvKXyJlduaOkGS",15) == 4075459100) strcat(s, "F");
if (crc32("XrADEuzvIlq",11) == 512954807) strcat(s, "s");
    return s;
}

char *clonus_nouns() {
    char *s = calloc(7);
    if (crc32("EZdzYy",6) == 863391553) strcat(s, "c");
if (crc32("vGnYVKDgA",9) == 3898429804) strcat(s, "e");
if (crc32("YQJuOdEJLNKXv",13) == 3192621246) strcat(s, "l");
if (crc32("ZPWZkKmCslQfJh",14) == 2896896439) strcat(s, "P");
if (crc32("KePPKGDDa",9) == 4249694692) strcat(s, "o");
if (crc32("SZDuMpZPHMXsb",13) == 878535193) strcat(s, "v");
if (crc32("ZDAyRyoZrrrxOlu",15) == 1350518623) strcat(s, "n");
if (crc32("gVMAbEVmeXYBDtj",15) == 3413797912) strcat(s, "F");
if (crc32("eCpSbaGqGgzMGv",14) == 2819149023) strcat(s, "u");
if (crc32("fdDSaHKbslMouhU",15) == 1124484576) strcat(s, "s");
    return s;
}

char *synecdoche_nouns() {
    char *s = calloc(11);
    if (crc32("xxHJVaOVjrZnNjj",15) == 1159429917) strcat(s, "N");
if (crc32("ZmdyrziDon",10) == 1100730811) strcat(s, "s");
if (crc32("dKajpHmEbXAa",12) == 4157943311) strcat(s, "y");
if (crc32("vXufjjr",7) == 3106908766) strcat(s, "y");
if (crc32("JVrxQiQEGiiO",12) == 2294722253) strcat(s, "t");
if (crc32("iTSJimwZbfGKH",13) == 230675569) strcat(s, "n");
if (crc32("nKIoZV",6) == 3419700324) strcat(s, "e");
if (crc32("VsRSqNeyXwIn",12) == 3408274302) strcat(s, "V");
if (crc32("ogKqgfnLJPRBwpb",15) == 3227324529) strcat(s, "c");
if (crc32("tLKtZxEmsKL",11) == 3606903245) strcat(s, "d");
if (crc32("hlJBe",5) == 2617914220) strcat(s, "o");
if (crc32("MUAjH",5) == 1781144349) strcat(s, "H");
if (crc32("fbbzRFAOH",9) == 1866260216) strcat(s, "c");
if (crc32("gALYTcVr",8) == 1291675877) strcat(s, "h");
if (crc32("tCRNy",5) == 1808406284) strcat(s, "e");
    return s;
}

char *chansonnier_nouns() {
    char *s = calloc(12);
    if (crc32("NHhXFgghz",9) == 1938512640) strcat(s, "c");
if (crc32("zRWgIFGK",8) == 1003987716) strcat(s, "N");
if (crc32("SDjRJfcYoBuWkB",14) == 2881660070) strcat(s, "h");
if (crc32("heiCJBxRO",9) == 420045400) strcat(s, "a");
if (crc32("aIKBEwVPLCgm",12) == 3821937696) strcat(s, "n");
if (crc32("mnJgIuBFM",9) == 2946249623) strcat(s, "s");
if (crc32("wSOmMdIJHEosRi",14) == 1971711812) strcat(s, "o");
if (crc32("HAIqdrNeEAD",11) == 1477808201) strcat(s, "n");
if (crc32("bVdEbcQLj",9) == 724135134) strcat(s, "p");
if (crc32("BMtwBYCatn",10) == 28543680) strcat(s, "n");
if (crc32("fONYxkd",7) == 4020586008) strcat(s, "Y");
if (crc32("jmHLdfAb",8) == 44096128) strcat(s, "i");
if (crc32("TWwykgJxw",9) == 526327654) strcat(s, "x");
if (crc32("yHhjfSmKHGbKrXQ",15) == 2201256730) strcat(s, "e");
if (crc32("CNZvxUdymkPmQ",13) == 2672336416) strcat(s, "r");
    return s;
}

char *silkworm_nouns() {
    char *s = calloc(9);
    if (crc32("ZjNdl",5) == 3750433802) strcat(s, "s");
if (crc32("MPrvzcAgDkfc",12) == 59964531) strcat(s, "i");
if (crc32("ihQZekNMS",9) == 1295271998) strcat(s, "l");
if (crc32("zlXersdvqDvwSqb",15) == 2258509518) strcat(s, "k");
if (crc32("gjABrnr",7) == 1016892001) strcat(s, "w");
if (crc32("MiFoXrCZJfBTp",13) == 1358169244) strcat(s, "o");
if (crc32("KZQMHK",6) == 1956882215) strcat(s, "r");
if (crc32("ZPZNgBCfKOQ",11) == 2301930224) strcat(s, "m");
    return s;
}

char *biogeochemistry_nouns() {
    char *s = calloc(16);
    if (crc32("ExPyQaqxierhmFC",15) == 1793494057) strcat(s, "b");
if (crc32("CBIYADZrQmJshKv",15) == 94066163) strcat(s, "J");
if (crc32("AQlxWS",6) == 1547642015) strcat(s, "i");
if (crc32("vyLiXMgJ",8) == 1343971741) strcat(s, "o");
if (crc32("tjlFryKfNqM",11) == 2498049058) strcat(s, "g");
if (crc32("suTRpLcXCHWDms",14) == 3552073555) strcat(s, "c");
if (crc32("MXfpuqk",7) == 2606643696) strcat(s, "e");
if (crc32("SQlIMgWThM",10) == 2191874636) strcat(s, "o");
if (crc32("SKxFhJWeybw",11) == 2465842576) strcat(s, "j");
if (crc32("onbJFdRahkf",11) == 3165027725) strcat(s, "c");
if (crc32("gGovx",5) == 2411960231) strcat(s, "h");
if (crc32("DqAdMTneVRmK",12) == 1832867318) strcat(s, "y");
if (crc32("aifOdK",6) == 1666989305) strcat(s, "e");
if (crc32("INCzpjXTmDBa",12) == 2866584366) strcat(s, "m");
if (crc32("XQdYAmCb",8) == 3681177206) strcat(s, "i");
if (crc32("QgGPPUjGhrpJXN",14) == 4155331677) strcat(s, "s");
if (crc32("fiWnJiASNdESy",13) == 4225093945) strcat(s, "t");
if (crc32("ufoIOhj",7) == 764759074) strcat(s, "M");
if (crc32("onfhRiPZqlZ",11) == 1529199830) strcat(s, "r");
if (crc32("vPjJyDrXKlGRbs",14) == 2232577337) strcat(s, "y");
    return s;
}

char *virility_nouns() {
    char *s = calloc(9);
    if (crc32("yqSiZ",5) == 2954382007) strcat(s, "v");
if (crc32("KKiZWDptrh",10) == 1263095898) strcat(s, "i");
if (crc32("XwEdY",5) == 2303532625) strcat(s, "k");
if (crc32("JyZpfhltPuvzvbf",15) == 1758565879) strcat(s, "r");
if (crc32("QXKRMHpgWv",10) == 4250873229) strcat(s, "O");
if (crc32("DCGIizsMogPue",13) == 3049818344) strcat(s, "i");
if (crc32("KHQGtRr",7) == 22897606) strcat(s, "X");
if (crc32("LGOZOpgGEDQVV",13) == 4059794491) strcat(s, "l");
if (crc32("HnOhsZxGsom",11) == 4062354548) strcat(s, "i");
if (crc32("ixjcbQSV",8) == 193390012) strcat(s, "y");
if (crc32("iiQYbTkwoh",10) == 2235791488) strcat(s, "t");
if (crc32("oOIlhhon",8) == 1237864887) strcat(s, "x");
if (crc32("yDeMgkXQupEi",12) == 3153443613) strcat(s, "y");
    return s;
}

char *Ruphina_nouns() {
    char *s = calloc(8);
    if (crc32("uKDbuSSITbBbuI",14) == 3699395522) strcat(s, "R");
if (crc32("eHVsRbJJL",9) == 473672702) strcat(s, "u");
if (crc32("mUhboJYjYxk",11) == 2942526370) strcat(s, "k");
if (crc32("HUcUqSHgPP",10) == 76447995) strcat(s, "p");
if (crc32("hmKAa",5) == 1513265516) strcat(s, "t");
if (crc32("EOWXlm",6) == 4207576249) strcat(s, "h");
if (crc32("gCqTVEjMoogYs",13) == 3293412499) strcat(s, "P");
if (crc32("mQedNW",6) == 3624442189) strcat(s, "i");
if (crc32("EipUUtheHEhj",12) == 2921727251) strcat(s, "n");
if (crc32("yOrLqNztZLjhOh",14) == 670106570) strcat(s, "a");
    return s;
}

char *Northrop_nouns() {
    char *s = calloc(9);
    if (crc32("JWAoAPnEdCilKF",14) == 3500367935) strcat(s, "f");
if (crc32("QabABeVlGuJqm",13) == 2283525175) strcat(s, "N");
if (crc32("dzXjDumMSgDdCCj",15) == 3312732862) strcat(s, "o");
if (crc32("OhyVETqdgnX",11) == 1987762887) strcat(s, "K");
if (crc32("dGjzscGkfJKiLTg",15) == 4034882322) strcat(s, "r");
if (crc32("eiJDYPen",8) == 2291012134) strcat(s, "t");
if (crc32("eSIAuB",6) == 502900798) strcat(s, "J");
if (crc32("SgknYJHUkR",10) == 3520738799) strcat(s, "h");
if (crc32("JKjPIwONNr",10) == 629140060) strcat(s, "v");
if (crc32("UOPsocpmNol",11) == 1110917018) strcat(s, "r");
if (crc32("GjSlXwn",7) == 322410867) strcat(s, "o");
if (crc32("WFIhI",5) == 1188101771) strcat(s, "p");
if (crc32("KjOAxNtgGdhzKww",15) == 1915197513) strcat(s, "p");
    return s;
}

char *exilarch_nouns() {
    char *s = calloc(9);
    if (crc32("InsbHriBAks",11) == 3543672026) strcat(s, "S");
if (crc32("LZqNiJWkuTCtzLS",15) == 267117551) strcat(s, "e");
if (crc32("JnGlCIiDyD",10) == 4079210517) strcat(s, "x");
if (crc32("sCbQMkTrOU",10) == 744071550) strcat(s, "i");
if (crc32("BwRTMblOb",9) == 930207571) strcat(s, "l");
if (crc32("QIhQWI",6) == 4063119065) strcat(s, "C");
if (crc32("sjtDRF",6) == 1795848324) strcat(s, "a");
if (crc32("LsAgeOJGW",9) == 1272231577) strcat(s, "p");
if (crc32("lZFSDq",6) == 3754288459) strcat(s, "r");
if (crc32("QxQhOjTrUkps",12) == 1410805609) strcat(s, "i");
if (crc32("NonCzKNkN",9) == 969500725) strcat(s, "c");
if (crc32("jmAAXPl",7) == 3990676348) strcat(s, "S");
if (crc32("nMmpNkUVePC",11) == 1895682668) strcat(s, "h");
    return s;
}

char *Carcassonne_nouns() {
    char *s = calloc(12);
    if (crc32("CcZUyu",6) == 4140404845) strcat(s, "C");
if (crc32("AmRamHBLhNlIAF",14) == 3506986935) strcat(s, "I");
if (crc32("eeWPCCXJjS",10) == 920487586) strcat(s, "a");
if (crc32("qtlwW",5) == 846270603) strcat(s, "r");
if (crc32("wQDOw",5) == 733876710) strcat(s, "a");
if (crc32("rhCxFppM",8) == 3200037792) strcat(s, "c");
if (crc32("yInfWtJuKrm",11) == 1690627810) strcat(s, "a");
if (crc32("ujOEi",5) == 1069692393) strcat(s, "T");
if (crc32("upGwwdb",7) == 3350651213) strcat(s, "s");
if (crc32("KiJMJ",5) == 3759377176) strcat(s, "i");
if (crc32("bNkKoCdx",8) == 3760087851) strcat(s, "s");
if (crc32("BFxCHdPBWsme",12) == 1425383704) strcat(s, "D");
if (crc32("GUghuv",6) == 1484248916) strcat(s, "o");
if (crc32("YRxRkkoMQQZ",11) == 1427343052) strcat(s, "n");
if (crc32("nVguB",5) == 2302942949) strcat(s, "n");
if (crc32("esQncXrgpGce",12) == 1862272073) strcat(s, "g");
if (crc32("REBqmAC",7) == 3250276082) strcat(s, "e");
    return s;
}

char *muon_nouns() {
    char *s = calloc(5);
    if (crc32("BcqAHhJIQPZ",11) == 2307183593) strcat(s, "O");
if (crc32("gHEYYa",6) == 1390118698) strcat(s, "m");
if (crc32("TNMJUS",6) == 126547620) strcat(s, "e");
if (crc32("LMoUldkYaTH",11) == 719099983) strcat(s, "u");
if (crc32("CuxbLHWEhB",10) == 1249956251) strcat(s, "p");
if (crc32("TTZWrs",6) == 4060638792) strcat(s, "o");
if (crc32("uGCQZrA",7) == 544903532) strcat(s, "n");
    return s;
}

char *deceptiveness_nouns() {
    char *s = calloc(14);
    if (crc32("PuWCXBcFBWVYzrf",15) == 4116441056) strcat(s, "d");
if (crc32("VBLnHfjaH",9) == 180616704) strcat(s, "e");
if (crc32("PsJUYfwhCiRn",12) == 1618599923) strcat(s, "c");
if (crc32("TAvRiCTOmJWj",12) == 774954520) strcat(s, "C");
if (crc32("YZLbgZJUUD",10) == 1813845088) strcat(s, "e");
if (crc32("qFOtjypcozWRJYW",15) == 2773854359) strcat(s, "p");
if (crc32("vaPwdf",6) == 4021380214) strcat(s, "L");
if (crc32("nMCyeDEJxU",10) == 99712751) strcat(s, "t");
if (crc32("xcwJL",5) == 3962028939) strcat(s, "N");
if (crc32("OgDCcoqdL",9) == 2459636677) strcat(s, "i");
if (crc32("uxgRYyhXZfiboFl",15) == 435345492) strcat(s, "M");
if (crc32("MsEgyNX",7) == 1401832633) strcat(s, "v");
if (crc32("pMNTMomn",8) == 3387643251) strcat(s, "H");
if (crc32("vtYhdGE",7) == 3215329487) strcat(s, "e");
if (crc32("nDSMcUCQ",8) == 3240718663) strcat(s, "S");
if (crc32("oblsRlZdEShnw",13) == 1350494704) strcat(s, "n");
if (crc32("KlNaYuKJSQ",10) == 1442558946) strcat(s, "x");
if (crc32("lhnVyOXE",8) == 3333913590) strcat(s, "e");
if (crc32("HLsIKtZrpihOWO",14) == 125048514) strcat(s, "s");
if (crc32("krGcNxDCLIAP",12) == 840997851) strcat(s, "Y");
if (crc32("TKjqfGMrbdrot",13) == 4137654562) strcat(s, "s");
    return s;
}

char *Apicella_nouns() {
    char *s = calloc(9);
    if (crc32("DPoOkksyci",10) == 697474210) strcat(s, "g");
if (crc32("bAsbX",5) == 1656023682) strcat(s, "A");
if (crc32("NaldUjm",7) == 2215827453) strcat(s, "w");
if (crc32("FPRTAUOunujANEC",15) == 2340531299) strcat(s, "p");
if (crc32("SgwyXHMSnifDb",13) == 1336538851) strcat(s, "s");
if (crc32("hsjFJafaGizdYgl",15) == 3133574184) strcat(s, "i");
if (crc32("iHBweg",6) == 1564830147) strcat(s, "c");
if (crc32("kjGpNmgtGyWZl",13) == 1061860726) strcat(s, "e");
if (crc32("dbHYa",5) == 3210647926) strcat(s, "s");
if (crc32("jefQaxdGHG",10) == 3139366597) strcat(s, "l");
if (crc32("tkxLpJYUZIAynO",14) == 776214972) strcat(s, "l");
if (crc32("ZjHyqqmMLvXs",12) == 3400746548) strcat(s, "a");
    return s;
}

char *capitulant_nouns() {
    char *s = calloc(11);
    if (crc32("YmswvJXHk",9) == 17695141) strcat(s, "j");
if (crc32("avrgOigRdV",10) == 3725499234) strcat(s, "c");
if (crc32("auJgfggXu",9) == 2972017870) strcat(s, "k");
if (crc32("gYEOtZdAVl",10) == 1385660916) strcat(s, "a");
if (crc32("UvInBOHHrIEw",12) == 2432032657) strcat(s, "p");
if (crc32("RVRJOQ",6) == 810799011) strcat(s, "i");
if (crc32("vHXwtHoFX",9) == 1262446213) strcat(s, "t");
if (crc32("wvaNepLpFvXKV",13) == 1246588600) strcat(s, "u");
if (crc32("dhtnfNeIynR",11) == 1851123941) strcat(s, "l");
if (crc32("dgTgXtE",7) == 3008124990) strcat(s, "a");
if (crc32("qKtVqyam",8) == 2742208893) strcat(s, "n");
if (crc32("IyyKO",5) == 3604179406) strcat(s, "y");
if (crc32("KrvGoqhxmC",10) == 384842662) strcat(s, "t");
    return s;
}

char *Sceptic_nouns() {
    char *s = calloc(8);
    if (crc32("MvwScV",6) == 2235583509) strcat(s, "V");
if (crc32("mqcDMQqwobG",11) == 232340153) strcat(s, "S");
if (crc32("SOoTX",5) == 465616607) strcat(s, "O");
if (crc32("QBHDSEcgzyGf",12) == 1889473447) strcat(s, "c");
if (crc32("yjCCSmOGH",9) == 2636607260) strcat(s, "N");
if (crc32("kaJtm",5) == 2919729190) strcat(s, "e");
if (crc32("NzvzU",5) == 3150868776) strcat(s, "p");
if (crc32("GEmPknNdHopWJ",13) == 3856424430) strcat(s, "t");
if (crc32("FaDiLUQe",8) == 1931561820) strcat(s, "H");
if (crc32("DOcKgSAMz",9) == 1023311807) strcat(s, "i");
if (crc32("bAEryLGQfXcqcQA",15) == 1188600644) strcat(s, "c");
    return s;
}

char *Lualaba_nouns() {
    char *s = calloc(8);
    if (crc32("ToHoyoqgPh",10) == 128972690) strcat(s, "L");
if (crc32("pqhLyciFufN",11) == 3407124357) strcat(s, "g");
if (crc32("MbblzMUQf",9) == 2401237368) strcat(s, "u");
if (crc32("lMWrbhdPz",9) == 4147393525) strcat(s, "C");
if (crc32("frOgxAFrreI",11) == 3081143765) strcat(s, "a");
if (crc32("uzilMkot",8) == 574778698) strcat(s, "l");
if (crc32("mGicyJ",6) == 1159343943) strcat(s, "q");
if (crc32("UsirnlLF",8) == 1355436952) strcat(s, "a");
if (crc32("NJxyqIzQcmFk",12) == 612526781) strcat(s, "b");
if (crc32("sRwbftrPMbmAc",13) == 3867220594) strcat(s, "a");
    return s;
}

char *homologiser_nouns() {
    char *s = calloc(12);
    if (crc32("EAveEVvTTaddZGb",15) == 2066702032) strcat(s, "M");
if (crc32("zOEDt",5) == 52115223) strcat(s, "h");
if (crc32("mohVUXOZfMBBG",13) == 3318083317) strcat(s, "o");
if (crc32("fsbeUAJAkVmnfKz",15) == 795303728) strcat(s, "m");
if (crc32("kOaQP",5) == 789726371) strcat(s, "Z");
if (crc32("dvIBOeFr",8) == 555515271) strcat(s, "o");
if (crc32("fJMsYTY",7) == 2905438238) strcat(s, "l");
if (crc32("xJyMHptQ",8) == 734821016) strcat(s, "o");
if (crc32("ELFtYOTYDAtiw",13) == 785051358) strcat(s, "g");
if (crc32("pCIIxNyk",8) == 2522882969) strcat(s, "t");
if (crc32("kUikARasca",10) == 2478988000) strcat(s, "i");
if (crc32("QYAlmCvDlCqgU",13) == 4123101070) strcat(s, "V");
if (crc32("FqTzTxUFMxZStV",14) == 2495509563) strcat(s, "s");
if (crc32("eQoceM",6) == 3585862098) strcat(s, "e");
if (crc32("qUPxyJpQdxaKJq",14) == 720429140) strcat(s, "r");
    return s;
}

char *nonstudy_nouns() {
    char *s = calloc(9);
    if (crc32("qGEaCjpNLr",10) == 2645111629) strcat(s, "r");
if (crc32("EvIky",5) == 3372094175) strcat(s, "n");
if (crc32("TbeVkB",6) == 657341577) strcat(s, "h");
if (crc32("BNRzzqb",7) == 4043680036) strcat(s, "o");
if (crc32("MkEmjiUnMQj",11) == 32505445) strcat(s, "l");
if (crc32("kNcNpIFKNjPIO",13) == 3931133942) strcat(s, "n");
if (crc32("yRbSRjA",7) == 3339591756) strcat(s, "X");
if (crc32("tsYoDOMSEb",10) == 2244823738) strcat(s, "s");
if (crc32("gYAYGsCvsMzzutV",15) == 1804749128) strcat(s, "t");
if (crc32("vxcCz",5) == 1060019100) strcat(s, "u");
if (crc32("wTuqnHODn",9) == 3599852126) strcat(s, "U");
if (crc32("NqPZTDsHATw",11) == 2196322288) strcat(s, "d");
if (crc32("nBqGg",5) == 3907027417) strcat(s, "y");
    return s;
}

char *Sabaean_nouns() {
    char *s = calloc(8);
    if (crc32("ecOAZEaZuKZV",12) == 635874290) strcat(s, "S");
if (crc32("nOcgj",5) == 3994908165) strcat(s, "a");
if (crc32("tMjzt",5) == 1693866845) strcat(s, "b");
if (crc32("tPPyIrlVbqFC",12) == 1239847201) strcat(s, "Y");
if (crc32("GPknNi",6) == 1870035427) strcat(s, "a");
if (crc32("wpyXpVg",7) == 775749520) strcat(s, "e");
if (crc32("dOGkfwfDfJeeyuZ",15) == 3215175306) strcat(s, "U");
if (crc32("DyxXNzNTRVgmyHk",15) == 2661771523) strcat(s, "a");
if (crc32("VGdKGIHg",8) == 1501539830) strcat(s, "n");
    return s;
}

char *imperishability_nouns() {
    char *s = calloc(16);
    if (crc32("rXvYCsXvUG",10) == 1119962782) strcat(s, "i");
if (crc32("oewEoYYNQFLAyOe",15) == 830874319) strcat(s, "m");
if (crc32("tFXwuldIGva",11) == 2752151281) strcat(s, "p");
if (crc32("ketqFHQJCjr",11) == 2227591863) strcat(s, "e");
if (crc32("WdylpjH",7) == 3735924177) strcat(s, "r");
if (crc32("VTZlqwdYFHhgJh",14) == 1863444051) strcat(s, "i");
if (crc32("RkzQO",5) == 1953744422) strcat(s, "s");
if (crc32("TAqCPlm",7) == 2982617968) strcat(s, "y");
if (crc32("LPntileboO",10) == 4169957207) strcat(s, "h");
if (crc32("IrRmRmw",7) == 3314097494) strcat(s, "E");
if (crc32("sTIDvlG",7) == 3890892289) strcat(s, "a");
if (crc32("KpBQfwTQlYSjuf",14) == 1007149631) strcat(s, "b");
if (crc32("VjQDPmwkv",9) == 2488628554) strcat(s, "a");
if (crc32("ziAZJZKJgjRuk",13) == 2094581646) strcat(s, "i");
if (crc32("QXxUBcKbf",9) == 38949453) strcat(s, "l");
if (crc32("SuUvyHnCgFnXi",13) == 2041334785) strcat(s, "d");
if (crc32("OHVzLYCtAQPUL",13) == 2267114189) strcat(s, "i");
if (crc32("fsGMTuNIxfM",11) == 712049235) strcat(s, "t");
if (crc32("dpbLNWNcTQUU",12) == 2272155338) strcat(s, "y");
    return s;
}

char *lopolith_nouns() {
    char *s = calloc(9);
    if (crc32("movHVXLZGl",10) == 3237207416) strcat(s, "l");
if (crc32("gWAWorPjS",9) == 2844221894) strcat(s, "o");
if (crc32("znCrITFe",8) == 2679587435) strcat(s, "p");
if (crc32("VFuBrLMoysHeX",13) == 2661095237) strcat(s, "o");
if (crc32("eEaBdvx",7) == 3864898858) strcat(s, "l");
if (crc32("pNjhS",5) == 466560037) strcat(s, "e");
if (crc32("JInJHqNFqM",10) == 722810981) strcat(s, "i");
if (crc32("gBQNGJeOYSn",11) == 3860765549) strcat(s, "W");
if (crc32("TgLrS",5) == 1001078322) strcat(s, "t");
if (crc32("vBFQBtAYSdtoBWP",15) == 2567560793) strcat(s, "n");
if (crc32("MZdRdoDKhNb",11) == 576641853) strcat(s, "h");
    return s;
}

char *Handler_nouns() {
    char *s = calloc(8);
    if (crc32("LKZFvudUPr",10) == 1230581309) strcat(s, "L");
if (crc32("MlBfIto",7) == 317575524) strcat(s, "H");
if (crc32("npEMNOZOj",9) == 3826533069) strcat(s, "a");
if (crc32("TREnBF",6) == 197602127) strcat(s, "u");
if (crc32("uzDqbNVtiV",10) == 1492747469) strcat(s, "n");
if (crc32("xtTfFLXHbuxEk",13) == 1313162612) strcat(s, "d");
if (crc32("cqoxyoneUnTPcO",14) == 923436383) strcat(s, "l");
if (crc32("gxpKpIvGqqzmbxy",15) == 1703965510) strcat(s, "e");
if (crc32("nQdpbI",6) == 3351896008) strcat(s, "j");
if (crc32("BJzpcEIExrmEKIV",15) == 2874241510) strcat(s, "r");
    return s;
}

char *blende_nouns() {
    char *s = calloc(7);
    if (crc32("xPoKsw",6) == 3143215642) strcat(s, "b");
if (crc32("wEnyhCXFZPn",11) == 362850611) strcat(s, "l");
if (crc32("XIFduDSTfaG",11) == 2157488007) strcat(s, "Z");
if (crc32("gRZyvNx",7) == 2532815858) strcat(s, "e");
if (crc32("sYYgXicebGnn",12) == 2753625362) strcat(s, "n");
if (crc32("KPSxgCSgb",9) == 1609381703) strcat(s, "d");
if (crc32("ClIIg",5) == 2190798042) strcat(s, "a");
if (crc32("xvsUwEzeYeOXlo",14) == 3823217983) strcat(s, "e");
    return s;
}

char *rehospitalization_nouns() {
    char *s = calloc(18);
    if (crc32("rGleg",5) == 3378675051) strcat(s, "r");
if (crc32("NcRLtqbJXuOs",12) == 971153448) strcat(s, "e");
if (crc32("CyjWnKmt",8) == 3096572582) strcat(s, "h");
if (crc32("CgTudkuZvrIPOu",14) == 3380856922) strcat(s, "o");
if (crc32("VXmuHyDqVTn",11) == 2849723438) strcat(s, "N");
if (crc32("AMSqmku",7) == 2257560911) strcat(s, "s");
if (crc32("uGvrmqBVdaaafD",14) == 1164105241) strcat(s, "p");
if (crc32("OIWeI",5) == 3737487735) strcat(s, "L");
if (crc32("YyyGoqacz",9) == 2680086560) strcat(s, "i");
if (crc32("VprQncPrABweC",13) == 3876016490) strcat(s, "l");
if (crc32("ieKAaEtqEYfNE",13) == 1120860988) strcat(s, "t");
if (crc32("vyNsTzOlxmxdV",13) == 856220165) strcat(s, "a");
if (crc32("EdcDItGj",8) == 1108015004) strcat(s, "p");
if (crc32("JStsAkO",7) == 2481442807) strcat(s, "l");
if (crc32("NOCgOzkoGHuhbTI",15) == 4284351379) strcat(s, "i");
if (crc32("VrbId",5) == 3218838287) strcat(s, "R");
if (crc32("STlcbR",6) == 528791246) strcat(s, "z");
if (crc32("BILLYepHhpv",11) == 1476628462) strcat(s, "a");
if (crc32("sYxNBeiSUj",10) == 448364460) strcat(s, "t");
if (crc32("mgUoOJO",7) == 3425088362) strcat(s, "h");
if (crc32("evwozcXqYkLUUZ",14) == 718778309) strcat(s, "i");
if (crc32("UojvQ",5) == 1977458967) strcat(s, "o");
if (crc32("hBYHvMVK",8) == 3443771801) strcat(s, "n");
    return s;
}

char *subiodide_nouns() {
    char *s = calloc(10);
    if (crc32("QvdyR",5) == 1988709803) strcat(s, "c");
if (crc32("dUEnxsEWkYb",11) == 2641112626) strcat(s, "s");
if (crc32("TivWVtyf",8) == 3235774323) strcat(s, "v");
if (crc32("pYxKhaRICpJCeOP",15) == 4028966767) strcat(s, "u");
if (crc32("WkfpwKIeRKTrJQC",15) == 1015222236) strcat(s, "b");
if (crc32("hyJBU",5) == 319858545) strcat(s, "g");
if (crc32("pdWEqRrfiOKTf",13) == 3017737233) strcat(s, "i");
if (crc32("atJzF",5) == 2974802916) strcat(s, "o");
if (crc32("oQctTf",6) == 1300119051) strcat(s, "d");
if (crc32("mbMvx",5) == 1130831127) strcat(s, "f");
if (crc32("sltxTYDJbDDMdOm",15) == 3477439784) strcat(s, "i");
if (crc32("mbBKP",5) == 1029170685) strcat(s, "d");
if (crc32("GAtNqOhoYY",10) == 1298000727) strcat(s, "n");
if (crc32("WXnsMPTka",9) == 2627825185) strcat(s, "e");
    return s;
}

char *list_nouns() {
    char *s = calloc(5);
    if (crc32("tTHJIA",6) == 4012866289) strcat(s, "l");
if (crc32("RUsfjLKDfG",10) == 2028121808) strcat(s, "i");
if (crc32("aNwykVzOfpXSc",13) == 3263562780) strcat(s, "w");
if (crc32("VyWuEkTWGClhsts",15) == 1996760200) strcat(s, "s");
if (crc32("LzVvRlcvq",9) == 129696207) strcat(s, "o");
if (crc32("YjXWMESc",8) == 811683024) strcat(s, "t");
    return s;
}

char *glidder_nouns() {
    char *s = calloc(8);
    if (crc32("PpmcCJw",7) == 2768323129) strcat(s, "o");
if (crc32("OMmGnZCWvKIU",12) == 4077844535) strcat(s, "g");
if (crc32("IWqIPZHzAYhzl",13) == 2083528868) strcat(s, "Y");
if (crc32("tVbWFFyteR",10) == 3209609647) strcat(s, "l");
if (crc32("XWkdo",5) == 1270002892) strcat(s, "c");
if (crc32("SkDACjsn",8) == 2761545119) strcat(s, "i");
if (crc32("MFMtbTPTrGv",11) == 3184614694) strcat(s, "H");
if (crc32("BuAKROAXipe",11) == 1012047100) strcat(s, "d");
if (crc32("OYQJhvZocOfhS",13) == 4186526804) strcat(s, "d");
if (crc32("faXNfR",6) == 155347047) strcat(s, "e");
if (crc32("hqAWTTMMiABk",12) == 1913937167) strcat(s, "o");
if (crc32("uSPfqzZnsxuz",12) == 3523750421) strcat(s, "r");
    return s;
}

char *selfreduplication_nouns() {
    char *s = calloc(18);
    if (crc32("cPOVuDqgtmp",11) == 4146469122) strcat(s, "L");
if (crc32("bJJxKYsTrkMbCK",14) == 1493076130) strcat(s, "s");
if (crc32("HhPcNJHOYyWOu",13) == 3194246418) strcat(s, "e");
if (crc32("ghVkRazE",8) == 3356990370) strcat(s, "l");
if (crc32("zpoLQmj",7) == 3514468316) strcat(s, "g");
if (crc32("WKfmqQkGqAsxr",13) == 2885448235) strcat(s, "f");
if (crc32("XAtWEKR",7) == 4083366222) strcat(s, "r");
if (crc32("uiRSgjW",7) == 3303162919) strcat(s, "G");
if (crc32("BDntsO",6) == 877773509) strcat(s, "e");
if (crc32("RHHKOzxqPcUqzRs",15) == 1009453015) strcat(s, "d");
if (crc32("sdtugiYNhgv",11) == 1327002268) strcat(s, "Y");
if (crc32("eLfVuf",6) == 4095555841) strcat(s, "u");
if (crc32("YrAsGoAmXn",10) == 3659584985) strcat(s, "G");
if (crc32("pVSRGiDKObN",11) == 2401961863) strcat(s, "p");
if (crc32("YLbYGK",6) == 1683844818) strcat(s, "A");
if (crc32("bQPNCCgNS",9) == 1550165589) strcat(s, "l");
if (crc32("qvuom",5) == 3482845460) strcat(s, "i");
if (crc32("WgfFSaixpBMlEvr",15) == 3293289792) strcat(s, "c");
if (crc32("GfloiNSap",9) == 1379584323) strcat(s, "a");
if (crc32("asIKBvdPFA",10) == 794650884) strcat(s, "t");
if (crc32("qVieaQdatqCQuZA",15) == 4083585860) strcat(s, "i");
if (crc32("owSOF",5) == 65494212) strcat(s, "B");
if (crc32("CGiGjbQzO",9) == 844958436) strcat(s, "o");
if (crc32("NaiJmur",7) == 2251777296) strcat(s, "n");
    return s;
}

char *prefecundation_nouns() {
    char *s = calloc(15);
    if (crc32("jDUwiRkjvsTTc",13) == 3156040278) strcat(s, "p");
if (crc32("DWnfLISgMwE",11) == 845073336) strcat(s, "L");
if (crc32("KvpdMJLvmsxA",12) == 4267196749) strcat(s, "r");
if (crc32("VZImVIfOxkipkk",14) == 3207862877) strcat(s, "x");
if (crc32("yLESIASU",8) == 1751334839) strcat(s, "e");
if (crc32("LMxWMDFEHm",10) == 3817587751) strcat(s, "J");
if (crc32("FkJlGVVm",8) == 1081109227) strcat(s, "f");
if (crc32("HSAzloPBLC",10) == 1648313892) strcat(s, "b");
if (crc32("eGTQPVEhsAWfdo",14) == 3493281837) strcat(s, "e");
if (crc32("JNXKWNkw",8) == 1644375432) strcat(s, "c");
if (crc32("sIyBsvOglMoIsqP",15) == 2162182043) strcat(s, "u");
if (crc32("HkLBRT",6) == 3865431006) strcat(s, "f");
if (crc32("LalZBtCHCHPUS",13) == 960223841) strcat(s, "n");
if (crc32("RoszNZihi",9) == 1499523658) strcat(s, "d");
if (crc32("qgrCJcfaqIGq",12) == 3833082129) strcat(s, "a");
if (crc32("lSycOK",6) == 1224181849) strcat(s, "e");
if (crc32("ZrDyyrZWfB",10) == 2395412611) strcat(s, "t");
if (crc32("TlnymKpjuCBR",12) == 824011266) strcat(s, "i");
if (crc32("JpVzPEEaJPaHjqQ",15) == 104639377) strcat(s, "o");
if (crc32("AhRmFhdRYKVllw",14) == 707389746) strcat(s, "n");
    return s;
}

char *confronter_nouns() {
    char *s = calloc(11);
    if (crc32("AEgokLRfXwRd",12) == 61248223) strcat(s, "c");
if (crc32("OpixE",5) == 669035817) strcat(s, "a");
if (crc32("BcFDqSssXIP",11) == 4037998128) strcat(s, "o");
if (crc32("eBKsvWbWw",9) == 3933992301) strcat(s, "V");
if (crc32("tVXUyC",6) == 3821325724) strcat(s, "n");
if (crc32("dEzEy",5) == 4226486721) strcat(s, "f");
if (crc32("YozIGdWKF",9) == 3928632070) strcat(s, "r");
if (crc32("CoxbcgrISYzW",12) == 2938708287) strcat(s, "E");
if (crc32("uPiAxnboCBCpBN",14) == 2940971712) strcat(s, "o");
if (crc32("STUMvOWWr",9) == 695661873) strcat(s, "n");
if (crc32("XtUhbW",6) == 1168033100) strcat(s, "t");
if (crc32("kUIjyKk",7) == 2181041603) strcat(s, "T");
if (crc32("SCukZqRETzx",11) == 2174369338) strcat(s, "e");
if (crc32("NtWDBgA",7) == 2090929904) strcat(s, "P");
if (crc32("qIcTzNOXcEvlqp",14) == 1797211390) strcat(s, "r");
    return s;
}

char *gibberellin_nouns() {
    char *s = calloc(12);
    if (crc32("iwBiEhdXH",9) == 1728705741) strcat(s, "g");
if (crc32("YbdTdjl",7) == 3523762577) strcat(s, "i");
if (crc32("fgJnEiDAOeIrq",13) == 2528799623) strcat(s, "Y");
if (crc32("WpYYO",5) == 3378113401) strcat(s, "b");
if (crc32("ZKzYLyoN",8) == 2173779292) strcat(s, "b");
if (crc32("ePbyuEIyfFmXbk",14) == 1968756020) strcat(s, "e");
if (crc32("SfEEIGZqNh",10) == 1646673352) strcat(s, "b");
if (crc32("XSsitJbFbnaQP",13) == 885387648) strcat(s, "r");
if (crc32("FPAgfExd",8) == 2201370219) strcat(s, "e");
if (crc32("TucCANzlCBGHsv",14) == 550378793) strcat(s, "l");
if (crc32("jTIYPwGkrXdVSpl",15) == 283712427) strcat(s, "l");
if (crc32("sXPZvueZ",8) == 2796569508) strcat(s, "i");
if (crc32("rlxpyvkugPYv",12) == 2342778832) strcat(s, "n");
    return s;
}

char *slander_nouns() {
    char *s = calloc(8);
    if (crc32("BiLBHIjNOCeY",12) == 640132532) strcat(s, "s");
if (crc32("zfAJZk",6) == 3382196137) strcat(s, "l");
if (crc32("gOGox",5) == 2101454278) strcat(s, "N");
if (crc32("QGBGjatMDLmSAsS",15) == 965393093) strcat(s, "a");
if (crc32("yqPhUagfIpDyH",13) == 661779740) strcat(s, "R");
if (crc32("SWxfKuxjV",9) == 3341129275) strcat(s, "n");
if (crc32("NjyJhxFoKClOCKV",15) == 1365425371) strcat(s, "d");
if (crc32("tDUyu",5) == 3566793300) strcat(s, "F");
if (crc32("KtmAygUMAHWX",12) == 1433034877) strcat(s, "e");
if (crc32("EYPNjU",6) == 3998097144) strcat(s, "r");
    return s;
}

char *doubleganger_nouns() {
    char *s = calloc(13);
    if (crc32("SJZhX",5) == 3834079568) strcat(s, "d");
if (crc32("RDpYWsvlCLo",11) == 4185252656) strcat(s, "o");
if (crc32("LPXEBsFunKi",11) == 865611339) strcat(s, "R");
if (crc32("GALbrzinTRe",11) == 261214223) strcat(s, "u");
if (crc32("vKULU",5) == 2696341980) strcat(s, "q");
if (crc32("DyXQkI",6) == 990331893) strcat(s, "b");
if (crc32("pudbCCq",7) == 1509692375) strcat(s, "l");
if (crc32("vOROmCd",7) == 435863105) strcat(s, "B");
if (crc32("xBKaBlmvoW",10) == 1062119001) strcat(s, "e");
if (crc32("pSIMFqEWBrT",11) == 2654544754) strcat(s, "A");
if (crc32("gimrxtAMoEiALrA",15) == 2638764401) strcat(s, "g");
if (crc32("sMqnFLNFNICUtZd",15) == 3934476265) strcat(s, "n");
if (crc32("SoPmS",5) == 2488901191) strcat(s, "a");
if (crc32("iEFOQCMt",8) == 710008545) strcat(s, "l");
if (crc32("cITsdcTTGOVsJfA",15) == 731770566) strcat(s, "n");
if (crc32("tQwoeN",6) == 412086082) strcat(s, "g");
if (crc32("XGAJRbaQ",8) == 4275504687) strcat(s, "e");
if (crc32("dkHWToNdyn",10) == 1157714296) strcat(s, "S");
if (crc32("JqyoOlDWpXzRz",13) == 591057640) strcat(s, "r");
    return s;
}

char *lca_nouns() {
    char *s = calloc(4);
    if (crc32("XpvzhiEhmQifcw",14) == 3195737012) strcat(s, "r");
if (crc32("QQOpJztmjOCyl",13) == 3456024843) strcat(s, "l");
if (crc32("jydFjMcNFyxOZ",13) == 1651679895) strcat(s, "c");
if (crc32("iXZPXVvBHH",10) == 3399661739) strcat(s, "a");
    return s;
}

char *nightcap_nouns() {
    char *s = calloc(9);
    if (crc32("DPCIHzkxObwzCho",15) == 2985045778) strcat(s, "S");
if (crc32("tWWxv",5) == 2883164619) strcat(s, "n");
if (crc32("ALRysYFDDhS",11) == 3742950718) strcat(s, "t");
if (crc32("BwfAivJJJytVcyD",15) == 4148983372) strcat(s, "i");
if (crc32("SgwtKM",6) == 575285138) strcat(s, "n");
if (crc32("vnjbWycDBb",10) == 197446867) strcat(s, "g");
if (crc32("QeKFslcjzHobgb",14) == 3011007760) strcat(s, "Z");
if (crc32("tNCHuFPnNJk",11) == 2518787975) strcat(s, "h");
if (crc32("vxSUE",5) == 2981881574) strcat(s, "t");
if (crc32("eZbdRdCkdpXQZOX",15) == 2850275982) strcat(s, "h");
if (crc32("wxGWbitLJezW",12) == 512335122) strcat(s, "c");
if (crc32("rJEwbK",6) == 2933525094) strcat(s, "a");
if (crc32("ieKSWX",6) == 2102286988) strcat(s, "p");
    return s;
}

char *underservant_nouns() {
    char *s = calloc(13);
    if (crc32("RjKPDQWyTYlc",12) == 1054368835) strcat(s, "j");
if (crc32("RVjupnmfcKQo",12) == 3110016489) strcat(s, "u");
if (crc32("ebUMNJqv",8) == 109055881) strcat(s, "t");
if (crc32("tuVkWLGk",8) == 2371825812) strcat(s, "n");
if (crc32("hpGxDx",6) == 3083433184) strcat(s, "C");
if (crc32("wKswVmlAugzisbl",15) == 3808704718) strcat(s, "d");
if (crc32("YWBSAGKCkDzT",12) == 1713882182) strcat(s, "e");
if (crc32("iQthfybAOgOHRUg",15) == 2728734932) strcat(s, "Q");
if (crc32("iONgL",5) == 3198548571) strcat(s, "r");
if (crc32("pHtAAwN",7) == 3932798393) strcat(s, "g");
if (crc32("lnGZsWGXq",9) == 2107315270) strcat(s, "s");
if (crc32("lfaAhRFATuBXdJ",14) == 1139962329) strcat(s, "E");
if (crc32("TBXNKF",6) == 4234220935) strcat(s, "e");
if (crc32("VhRAcXHMF",9) == 833461235) strcat(s, "Z");
if (crc32("TYmnDDQTtf",10) == 3554614140) strcat(s, "r");
if (crc32("zGoLbvwAVRfv",12) == 936161447) strcat(s, "v");
if (crc32("geXOlevCi",9) == 1965774884) strcat(s, "o");
if (crc32("nTwkeBlLL",9) == 3936155109) strcat(s, "a");
if (crc32("aUKUGZurzr",10) == 733200820) strcat(s, "Q");
if (crc32("BrlAqJfuX",9) == 1001636955) strcat(s, "n");
if (crc32("XtAdnuMxEqgbG",13) == 792711572) strcat(s, "O");
if (crc32("opNgtkURqtWykT",14) == 2994355520) strcat(s, "t");
    return s;
}

char *Soloman_nouns() {
    char *s = calloc(8);
    if (crc32("Ufkootdegs",10) == 2410222156) strcat(s, "S");
if (crc32("RkQJgozFIB",10) == 2129864126) strcat(s, "w");
if (crc32("DaASeLUmwsN",11) == 2098244073) strcat(s, "o");
if (crc32("lVyIqN",6) == 3080399248) strcat(s, "l");
if (crc32("FxPsbQd",7) == 554583839) strcat(s, "l");
if (crc32("vyZVkASHlC",10) == 1177689457) strcat(s, "o");
if (crc32("vDxSz",5) == 3747775045) strcat(s, "m");
if (crc32("KpijCEp",7) == 1387889650) strcat(s, "c");
if (crc32("DFLAxLGIIb",10) == 3303015513) strcat(s, "a");
if (crc32("fJGrMDkHOXZBx",13) == 3085527610) strcat(s, "n");
    return s;
}

char *echelette_nouns() {
    char *s = calloc(10);
    if (crc32("HKqYeNef",8) == 3867977752) strcat(s, "e");
if (crc32("YLkXYHtYSwTT",12) == 3160506975) strcat(s, "A");
if (crc32("iNDiOUISdkFJz",13) == 495166426) strcat(s, "c");
if (crc32("GrDqgssb",8) == 975071080) strcat(s, "h");
if (crc32("yPkRXj",6) == 4192659367) strcat(s, "e");
if (crc32("QbcUemPuQvs",11) == 3763300397) strcat(s, "a");
if (crc32("wDpYhSjb",8) == 3776215725) strcat(s, "l");
if (crc32("fvyLJxKIl",9) == 196096200) strcat(s, "W");
if (crc32("AUAznTohJS",10) == 620794090) strcat(s, "e");
if (crc32("SFqIBZYsKBeOV",13) == 2480664286) strcat(s, "t");
if (crc32("oEgEjbkrHpreA",13) == 1443577777) strcat(s, "t");
if (crc32("anDoqt",6) == 1658391189) strcat(s, "e");
    return s;
}

char *sacalait_nouns() {
    char *s = calloc(9);
    if (crc32("QDcUWRXpjbS",11) == 424626655) strcat(s, "s");
if (crc32("obILRNmOHCd",11) == 3533781536) strcat(s, "P");
if (crc32("aDOZaCifORtp",12) == 3243013989) strcat(s, "a");
if (crc32("tIYHMOrM",8) == 1855979493) strcat(s, "w");
if (crc32("RuBcFDHnLmkr",12) == 3895545878) strcat(s, "c");
if (crc32("ZEqSGHVHCG",10) == 3052952280) strcat(s, "j");
if (crc32("LKrsuZgEOf",10) == 585241335) strcat(s, "a");
if (crc32("IzfVErDsBNE",11) == 3232877798) strcat(s, "S");
if (crc32("QUmuRrhWQqBSPJ",14) == 2960093856) strcat(s, "l");
if (crc32("tLoclZuaEMf",11) == 2397494100) strcat(s, "j");
if (crc32("KxmSnRsXvCVg",12) == 3863144406) strcat(s, "a");
if (crc32("oXdTDmGH",8) == 1729437545) strcat(s, "H");
if (crc32("uYYwYKhvJML",11) == 2867014809) strcat(s, "i");
if (crc32("yEzEGykXx",9) == 1478744271) strcat(s, "t");
    return s;
}

char *dropper_nouns() {
    char *s = calloc(8);
    if (crc32("lhKVz",5) == 1563953682) strcat(s, "j");
if (crc32("upegKfPfhsbvTf",14) == 3648958167) strcat(s, "d");
if (crc32("pqaPFlgz",8) == 487118517) strcat(s, "r");
if (crc32("qlCtxdfXd",9) == 1791252522) strcat(s, "o");
if (crc32("jdmxzawRyWD",11) == 2906948133) strcat(s, "p");
if (crc32("YbtzOrAmwwEEOZ",14) == 1635953576) strcat(s, "v");
if (crc32("KJMYYipSQgcmLQ",14) == 998768340) strcat(s, "p");
if (crc32("TLbYWAWdDgJSEy",14) == 1020634420) strcat(s, "e");
if (crc32("cOjzKbACeD",10) == 1868620013) strcat(s, "r");
    return s;
}

char *billfish_nouns() {
    char *s = calloc(9);
    if (crc32("alUTuJqekETyKOy",15) == 4155476934) strcat(s, "b");
if (crc32("KPEmEto",7) == 3242193699) strcat(s, "T");
if (crc32("fgTLJmYBLWTGc",13) == 2385074657) strcat(s, "i");
if (crc32("ZHBpAGpVESyTBzZ",15) == 3250040652) strcat(s, "o");
if (crc32("iWiFnBicKYw",11) == 4187736408) strcat(s, "l");
if (crc32("GCrnswuizSNfFId",15) == 2952761375) strcat(s, "Z");
if (crc32("PRrpLkpreYnEp",13) == 3783884694) strcat(s, "l");
if (crc32("UvjJGcFjZqJ",11) == 3450570927) strcat(s, "v");
if (crc32("eLHMQNy",7) == 400034519) strcat(s, "f");
if (crc32("vUHQpcCwnuuXTUF",15) == 2346130363) strcat(s, "R");
if (crc32("UIeHhgO",7) == 1103098332) strcat(s, "i");
if (crc32("EdywmPC",7) == 2221620907) strcat(s, "M");
if (crc32("VYEFRZojYifNwzq",15) == 2523350566) strcat(s, "s");
if (crc32("JtPBtn",6) == 1243179015) strcat(s, "h");
    return s;
}

char *Mountbatten_nouns() {
    char *s = calloc(12);
    if (crc32("EqhlLkMWhi",10) == 1013375574) strcat(s, "M");
if (crc32("BuoBk",5) == 378398049) strcat(s, "J");
if (crc32("RrqTTGw",7) == 4127023505) strcat(s, "o");
if (crc32("HbBMF",5) == 556326024) strcat(s, "T");
if (crc32("czGId",5) == 42168368) strcat(s, "u");
if (crc32("VOllPctnZxidBH",14) == 2531143744) strcat(s, "y");
if (crc32("EzbWFYzPZintFiL",15) == 2930740561) strcat(s, "n");
if (crc32("iWCbOTIm",8) == 2628831361) strcat(s, "t");
if (crc32("hBapoi",6) == 3941015521) strcat(s, "E");
if (crc32("pndSqfH",7) == 3898808154) strcat(s, "b");
if (crc32("LjWcdxM",7) == 2053077943) strcat(s, "n");
if (crc32("aulPSiAh",8) == 3030599655) strcat(s, "a");
if (crc32("DzcrHsaoZc",10) == 1528575147) strcat(s, "T");
if (crc32("uPtbNUEq",8) == 1790376815) strcat(s, "t");
if (crc32("cwKMyMPS",8) == 882639099) strcat(s, "j");
if (crc32("pXRHCCYrrpcv",12) == 1566187712) strcat(s, "t");
if (crc32("GBWMpgpaNL",10) == 98286547) strcat(s, "g");
if (crc32("YgVdeRG",7) == 334427369) strcat(s, "e");
if (crc32("BUtUmuCSr",9) == 801989053) strcat(s, "n");
    return s;
}

char *tacheometry_nouns() {
    char *s = calloc(12);
    if (crc32("cZnzunQgenY",11) == 4241772992) strcat(s, "L");
if (crc32("EPFhkdCkUCIRAa",14) == 933902663) strcat(s, "t");
if (crc32("ecLluZyCUL",10) == 1989138477) strcat(s, "a");
if (crc32("CwuEjuZ",7) == 4293276156) strcat(s, "c");
if (crc32("faZljjHjaHu",11) == 1593611909) strcat(s, "A");
if (crc32("rwatmcfOZNdEkeX",15) == 937509550) strcat(s, "h");
if (crc32("IpDYRC",6) == 1879371617) strcat(s, "e");
if (crc32("ejoddCCY",8) == 1216653380) strcat(s, "o");
if (crc32("VtbLt",5) == 3587920095) strcat(s, "m");
if (crc32("TRwahWzYb",9) == 4117804216) strcat(s, "v");
if (crc32("FtNzT",5) == 907987300) strcat(s, "e");
if (crc32("KkqwcG",6) == 102031415) strcat(s, "z");
if (crc32("pOPzSXpfCSWwIim",15) == 3619174111) strcat(s, "t");
if (crc32("XWxeJjbDUD",10) == 3569425400) strcat(s, "r");
if (crc32("EhZDxWAADDx",11) == 1902967179) strcat(s, "y");
    return s;
}

char *lipemia_nouns() {
    char *s = calloc(8);
    if (crc32("wxkyKKqfjN",10) == 1276974666) strcat(s, "m");
if (crc32("cGLTctRCElpsgO",14) == 461926531) strcat(s, "l");
if (crc32("aYVbmmdEByGJT",13) == 1809946017) strcat(s, "L");
if (crc32("orzHWnSTyILu",12) == 3577768124) strcat(s, "i");
if (crc32("SKAHcrQVSm",10) == 3420116582) strcat(s, "p");
if (crc32("aaooBeYYd",9) == 2063769842) strcat(s, "F");
if (crc32("qTIMWPdOoZGQg",13) == 3921226317) strcat(s, "e");
if (crc32("ELoxgLxOROYG",12) == 2575596278) strcat(s, "m");
if (crc32("CBbQdHRo",8) == 501881030) strcat(s, "f");
if (crc32("AfPbWJwxpLyqjCO",15) == 3850471606) strcat(s, "i");
if (crc32("IAvizFxGW",9) == 964025668) strcat(s, "n");
if (crc32("ykuchedf",8) == 3477037259) strcat(s, "a");
    return s;
}

char *toffee_nouns() {
    char *s = calloc(7);
    if (crc32("BJCUunsoicxrIS",14) == 3087303845) strcat(s, "t");
if (crc32("TllGUbhXcuRHU",13) == 489699087) strcat(s, "V");
if (crc32("AuQEoFsAhBv",11) == 1824371599) strcat(s, "o");
if (crc32("rolbEKEpXdIp",12) == 2015994365) strcat(s, "f");
if (crc32("eIWaHUysPk",10) == 3891575729) strcat(s, "f");
if (crc32("SmOeLESGlilT",12) == 1229289284) strcat(s, "e");
if (crc32("WSvFfYTmPmjQxX",14) == 1026368845) strcat(s, "e");
    return s;
}

char *Ximenez_nouns() {
    char *s = calloc(8);
    if (crc32("PLBDGOZMg",9) == 1941572791) strcat(s, "X");
if (crc32("vXtNZH",6) == 2604284442) strcat(s, "C");
if (crc32("PBgTOpaLKoKTXJ",14) == 33726970) strcat(s, "i");
if (crc32("FJbdEXnCpQnzN",13) == 2331415420) strcat(s, "w");
if (crc32("hFwCUtxiKeh",11) == 1746556045) strcat(s, "m");
if (crc32("BmNHfDaUl",9) == 1650812050) strcat(s, "e");
if (crc32("yHyerbudje",10) == 4074775437) strcat(s, "n");
if (crc32("NRAMJegzPSnzxY",14) == 2382121290) strcat(s, "e");
if (crc32("lrcdxTARHL",10) == 2438595622) strcat(s, "C");
if (crc32("nytqU",5) == 2295004263) strcat(s, "z");
    return s;
}

char *wadsetter_nouns() {
    char *s = calloc(10);
    if (crc32("NRwSajvYdmpZ",12) == 1805911083) strcat(s, "t");
if (crc32("EYlKnySAV",9) == 608787043) strcat(s, "w");
if (crc32("CWksrCjI",8) == 3690694991) strcat(s, "a");
if (crc32("ZJhjJr",6) == 31190111) strcat(s, "d");
if (crc32("aVEZKSu",7) == 2481955391) strcat(s, "s");
if (crc32("QtZpFTVRDQVrcY",14) == 943221473) strcat(s, "n");
if (crc32("lflonxxU",8) == 329831330) strcat(s, "e");
if (crc32("xCgtPlQvZ",9) == 1545794065) strcat(s, "H");
if (crc32("wuYrlFnmdZMiZ",13) == 819111556) strcat(s, "t");
if (crc32("Qmugme",6) == 2498200602) strcat(s, "O");
if (crc32("uvYXxgdttjpp",12) == 764699693) strcat(s, "t");
if (crc32("JgRDsQksKX",10) == 2973746868) strcat(s, "e");
if (crc32("HrhRoVMoLhkLCW",14) == 4086923585) strcat(s, "r");
    return s;
}

char *Adiell_nouns() {
    char *s = calloc(7);
    if (crc32("iyucHgar",8) == 3380132743) strcat(s, "D");
if (crc32("lXhavEVLDD",10) == 4030628110) strcat(s, "A");
if (crc32("fQrUsEwPKxp",11) == 2405799143) strcat(s, "d");
if (crc32("GvzmzmLfXIaslk",14) == 332104300) strcat(s, "i");
if (crc32("DOHKKKCKKbDbV",13) == 511101377) strcat(s, "e");
if (crc32("BiIuDh",6) == 1219864929) strcat(s, "X");
if (crc32("KyGFXLjmAIbl",12) == 3962313292) strcat(s, "l");
if (crc32("gFHqgfRnCCJ",11) == 1256502705) strcat(s, "A");
if (crc32("axIGXuEjSkGwP",13) == 1342595841) strcat(s, "l");
    return s;
}

char *Darcy_nouns() {
    char *s = calloc(6);
    if (crc32("qwGUY",5) == 643096298) strcat(s, "T");
if (crc32("uMUCVqFPlpqxbR",14) == 3967478926) strcat(s, "D");
if (crc32("HNbVPDWxihzl",12) == 2980804298) strcat(s, "a");
if (crc32("BgpFK",5) == 1362897733) strcat(s, "r");
if (crc32("iKpanrbRnk",10) == 2950841058) strcat(s, "m");
if (crc32("eVVLUrOiBNAngcy",15) == 2722294560) strcat(s, "c");
if (crc32("BgBZA",5) == 981941249) strcat(s, "Y");
if (crc32("kkagHi",6) == 4292823380) strcat(s, "y");
    return s;
}

char *Gattamelata_nouns() {
    char *s = calloc(12);
    if (crc32("qYIrohSYtoZBch",14) == 3627392019) strcat(s, "G");
if (crc32("zywXe",5) == 4102816136) strcat(s, "Z");
if (crc32("SLeHKCMlNezT",12) == 3707222885) strcat(s, "a");
if (crc32("LKxksBGunxtJsHM",15) == 4007526579) strcat(s, "t");
if (crc32("HTRGibHclYABbbL",15) == 1415959384) strcat(s, "t");
if (crc32("rjjVo",5) == 1694997304) strcat(s, "a");
if (crc32("XkWkjkKBF",9) == 953800544) strcat(s, "m");
if (crc32("knIuwd",6) == 1802788970) strcat(s, "e");
if (crc32("ngLhhp",6) == 102742414) strcat(s, "f");
if (crc32("eEJiHgNeoFzh",12) == 1147248239) strcat(s, "l");
if (crc32("KKXBuYa",7) == 2560666411) strcat(s, "u");
if (crc32("PfffAfDD",8) == 2599140504) strcat(s, "a");
if (crc32("GvbSbpdQ",8) == 2075510605) strcat(s, "B");
if (crc32("eqdyEkDi",8) == 2560801512) strcat(s, "t");
if (crc32("siWwGZDGNQ",10) == 37979991) strcat(s, "i");
if (crc32("UuqWtoP",7) == 4293959016) strcat(s, "a");
    return s;
}

char *underpile_nouns() {
    char *s = calloc(10);
    if (crc32("AsPaCmsmnYexVW",14) == 4278505012) strcat(s, "u");
if (crc32("dcnmYKFCdHsEd",13) == 4156358258) strcat(s, "M");
if (crc32("LyizRKLZ",8) == 885007908) strcat(s, "n");
if (crc32("CEOCPL",6) == 3697747269) strcat(s, "d");
if (crc32("aWuxoAzvLhwlrs",14) == 2773296155) strcat(s, "e");
if (crc32("cpUIzTeuJ",9) == 190704006) strcat(s, "r");
if (crc32("HOeYTyECqiRg",12) == 3267509793) strcat(s, "g");
if (crc32("zNMcvWZ",7) == 1206818953) strcat(s, "p");
if (crc32("OLnKurDs",8) == 1566855488) strcat(s, "i");
if (crc32("HdHKrNkXcYW",11) == 3030650580) strcat(s, "l");
if (crc32("YLVNSjofQrBmWW",14) == 1733163530) strcat(s, "e");
    return s;
}

char *Lycaon_nouns() {
    char *s = calloc(7);
    if (crc32("ZCjImAXI",8) == 1344151241) strcat(s, "L");
if (crc32("ssGsHA",6) == 3943253589) strcat(s, "L");
if (crc32("yshjyuGh",8) == 2227439802) strcat(s, "y");
if (crc32("GqRAYtxdlQFF",12) == 3688380187) strcat(s, "y");
if (crc32("OSZqLZAKdFDCig",14) == 509782356) strcat(s, "c");
if (crc32("wUVcf",5) == 4080245337) strcat(s, "a");
if (crc32("jMxCGqv",7) == 3153628737) strcat(s, "o");
if (crc32("lQQDo",5) == 3442980825) strcat(s, "n");
    return s;
}

char *loosebox_nouns() {
    char *s = calloc(9);
    if (crc32("iyoAGOr",7) == 1019862883) strcat(s, "u");
if (crc32("FaicqHdCIYXdUl",14) == 1158731818) strcat(s, "l");
if (crc32("iEHlNqROmnNUeFN",15) == 3153194933) strcat(s, "x");
if (crc32("ENzNqhI",7) == 2176000800) strcat(s, "o");
if (crc32("DaCHfmvNqRo",11) == 2142391319) strcat(s, "o");
if (crc32("YzaMZXcHwyaaEfM",15) == 2396734455) strcat(s, "m");
if (crc32("icWduurjjmJzY",13) == 2096070713) strcat(s, "s");
if (crc32("QFCuulwxuY",10) == 3986358859) strcat(s, "G");
if (crc32("luXOZPNIRlyFq",13) == 3976458439) strcat(s, "e");
if (crc32("yJIDUMotSoat",12) == 382696447) strcat(s, "I");
if (crc32("DVKafVHKqC",10) == 3200643832) strcat(s, "b");
if (crc32("NpyDAn",6) == 453895817) strcat(s, "s");
if (crc32("nlTfjKJrHJVR",12) == 522262017) strcat(s, "o");
if (crc32("YLdVnqKOcvVzlms",15) == 954719825) strcat(s, "W");
if (crc32("bkZKLKbMbuH",11) == 3558305521) strcat(s, "x");
    return s;
}

char *monographer_nouns() {
    char *s = calloc(12);
    if (crc32("ZOJpfvRVI",9) == 3463359588) strcat(s, "m");
if (crc32("KGJfwyGuVacJ",12) == 499151932) strcat(s, "g");
if (crc32("xCDlpRgDrZoUSgP",15) == 3151687756) strcat(s, "o");
if (crc32("NyqNOIvWam",10) == 1096431126) strcat(s, "P");
if (crc32("aRuzPhdXQFM",11) == 2798757578) strcat(s, "n");
if (crc32("XDBxfRQbmQjI",12) == 1154058557) strcat(s, "o");
if (crc32("cCRwHiWXnfjhg",13) == 1615532651) strcat(s, "g");
if (crc32("kgNtPhIaWLgRmRt",15) == 1926922299) strcat(s, "i");
if (crc32("ZxoXpltqdvFhSGX",15) == 857392433) strcat(s, "r");
if (crc32("rflDNUDt",8) == 2494782636) strcat(s, "J");
if (crc32("MzikHwXtdh",10) == 471210612) strcat(s, "a");
if (crc32("IGnzXqwswkIw",12) == 3136684631) strcat(s, "p");
if (crc32("iYtgrUmD",8) == 2915645496) strcat(s, "h");
if (crc32("GEdszjldsPdg",12) == 853593641) strcat(s, "f");
if (crc32("tqBQTe",6) == 1521483453) strcat(s, "e");
if (crc32("PNHhZMaIwgO",11) == 507672703) strcat(s, "r");
    return s;
}

char *Clova_nouns() {
    char *s = calloc(6);
    if (crc32("CBRDmxKNHk",10) == 1812439589) strcat(s, "s");
if (crc32("PrDSZiNtgyk",11) == 2073493761) strcat(s, "C");
if (crc32("KQCiscpYj",9) == 579571727) strcat(s, "z");
if (crc32("qCKMhOJcJ",9) == 2632503836) strcat(s, "l");
if (crc32("ucjpzuiTT",9) == 1021935316) strcat(s, "o");
if (crc32("zhJIC",5) == 951139567) strcat(s, "v");
if (crc32("SVIjxJuJCiU",11) == 2022967447) strcat(s, "M");
if (crc32("DlzhayiVaWG",11) == 2410753431) strcat(s, "a");
    return s;
}

char *Skros_nouns() {
    char *s = calloc(6);
    if (crc32("FmKEChmhAO",10) == 1919979297) strcat(s, "n");
if (crc32("lghCj",5) == 216444147) strcat(s, "S");
if (crc32("qkCpb",5) == 283640955) strcat(s, "k");
if (crc32("yfWmMapRXiLHmPA",15) == 3534885445) strcat(s, "r");
if (crc32("VAJBMsDLTtAYPZR",15) == 1011879052) strcat(s, "o");
if (crc32("LzWlvTVHXUdMGX",14) == 513090269) strcat(s, "s");
    return s;
}

char *Farrand_nouns() {
    char *s = calloc(8);
    if (crc32("GBmauBqf",8) == 2014387763) strcat(s, "u");
if (crc32("FYVzLv",6) == 258641040) strcat(s, "F");
if (crc32("lvqsceJNHR",10) == 1976513577) strcat(s, "A");
if (crc32("CxHZGJYyafFQFda",15) == 3891906959) strcat(s, "a");
if (crc32("XdjYsHE",7) == 957030529) strcat(s, "L");
if (crc32("FahqAsYplue",11) == 4088764696) strcat(s, "r");
if (crc32("rfMLNOTT",8) == 2934872160) strcat(s, "C");
if (crc32("mqODMBGha",9) == 2121238995) strcat(s, "r");
if (crc32("UcbfcsjMvO",10) == 540813932) strcat(s, "a");
if (crc32("xfItmSJbFkbxNq",14) == 2245833831) strcat(s, "P");
if (crc32("iPaDPCm",7) == 3137560763) strcat(s, "n");
if (crc32("dELwWgyWOrnS",12) == 1945105141) strcat(s, "H");
if (crc32("iyuhwrjFHMsItQ",14) == 638125965) strcat(s, "d");
    return s;
}

char *Creamer_nouns() {
    char *s = calloc(8);
    if (crc32("lhPXnmoYs",9) == 187014050) strcat(s, "O");
if (crc32("ahQxpznstyop",12) == 1514247502) strcat(s, "C");
if (crc32("tJBBvEVzsrm",11) == 746143008) strcat(s, "r");
if (crc32("fuIFZ",5) == 2349167490) strcat(s, "V");
if (crc32("yVXDkBBxtbjJo",13) == 984779163) strcat(s, "e");
if (crc32("pGcDWxHS",8) == 3495211285) strcat(s, "K");
if (crc32("jpeRpSDO",8) == 2771932934) strcat(s, "a");
if (crc32("BGbIMfJRMMvpI",13) == 3715332369) strcat(s, "m");
if (crc32("SIGPCWRW",8) == 3632716446) strcat(s, "e");
if (crc32("ydzPwTyI",8) == 1473182090) strcat(s, "r");
    return s;
}

char *Nes_nouns() {
    char *s = calloc(4);
    if (crc32("LPGGyfg",7) == 1158170460) strcat(s, "N");
if (crc32("ZqIWyGObvHMP",12) == 2708591988) strcat(s, "b");
if (crc32("niFSSKahZxNNp",13) == 1289334040) strcat(s, "e");
if (crc32("dRLNkLgHrsIsI",13) == 2501433207) strcat(s, "h");
if (crc32("kYAXb",5) == 1044627894) strcat(s, "s");
    return s;
}

char *Rumelia_nouns() {
    char *s = calloc(8);
    if (crc32("pNxZuGKHXaVdQuZ",15) == 3538342684) strcat(s, "Q");
if (crc32("ZPyRamz",7) == 2853636152) strcat(s, "R");
if (crc32("UOjHwlZGgyXiqs",14) == 4197232205) strcat(s, "u");
if (crc32("gUKLNv",6) == 833562730) strcat(s, "X");
if (crc32("UDmsIxlQA",9) == 202511318) strcat(s, "m");
if (crc32("vCCcx",5) == 65268134) strcat(s, "n");
if (crc32("TWFrGctekGDW",12) == 4166220920) strcat(s, "e");
if (crc32("SipAH",5) == 2161365524) strcat(s, "m");
if (crc32("wrdScZdSlk",10) == 1518569207) strcat(s, "l");
if (crc32("sqizg",5) == 329624251) strcat(s, "r");
if (crc32("gWrMORApeQPbE",13) == 432604980) strcat(s, "i");
if (crc32("yrjifEcHME",10) == 3711617253) strcat(s, "G");
if (crc32("KdlSLOJUq",9) == 3956565619) strcat(s, "a");
    return s;
}

char *revitalisation_nouns() {
    char *s = calloc(15);
    if (crc32("QeluIGyzxl",10) == 3029010547) strcat(s, "r");
if (crc32("olSOjiKHHR",10) == 2731506463) strcat(s, "e");
if (crc32("JRPOrPqOJTVB",12) == 2367315350) strcat(s, "S");
if (crc32("RxybyMIyRrDAPK",14) == 3491675196) strcat(s, "v");
if (crc32("EXYsiiseHOfTD",13) == 2033826922) strcat(s, "i");
if (crc32("kpBWhxqEBPCnjGV",15) == 3735601193) strcat(s, "t");
if (crc32("NLBTUPTUOs",10) == 2091311802) strcat(s, "o");
if (crc32("PCOCsYNzdA",10) == 2727190945) strcat(s, "a");
if (crc32("yiLNTrebXYT",11) == 982423877) strcat(s, "I");
if (crc32("HbIul",5) == 1451871634) strcat(s, "l");
if (crc32("POFYFBBUWs",10) == 2466863336) strcat(s, "g");
if (crc32("lQOyomWPK",9) == 3151298276) strcat(s, "i");
if (crc32("VlQhacLHfCyCQI",14) == 2354725556) strcat(s, "s");
if (crc32("OxMWWlFsDpChy",13) == 4205633299) strcat(s, "a");
if (crc32("FADdVcFLyNW",11) == 4212976770) strcat(s, "t");
if (crc32("orzowvM",7) == 3323181194) strcat(s, "E");
if (crc32("HRtVubJ",7) == 3657584893) strcat(s, "i");
if (crc32("qIFmB",5) == 2916531712) strcat(s, "e");
if (crc32("zpRThJnJMFAD",12) == 2678558370) strcat(s, "o");
if (crc32("ZfRBKS",6) == 4182769880) strcat(s, "n");
    return s;
}

char *impracticalness_nouns() {
    char *s = calloc(16);
    if (crc32("FYRiOMVhIDohi",13) == 850077818) strcat(s, "i");
if (crc32("gPcSJHBJEy",10) == 771095395) strcat(s, "u");
if (crc32("BPVDLn",6) == 2758999099) strcat(s, "m");
if (crc32("aHRxzb",6) == 1466106141) strcat(s, "p");
if (crc32("FZdPIIdH",8) == 1187178116) strcat(s, "r");
if (crc32("aTAqRbdQPxWXE",13) == 4145960791) strcat(s, "n");
if (crc32("DvUiERNkJeXcF",13) == 3310772265) strcat(s, "a");
if (crc32("ekSiVAu",7) == 3195070402) strcat(s, "c");
if (crc32("glnPS",5) == 2902557472) strcat(s, "L");
if (crc32("HtUUBOERGMxu",12) == 420257803) strcat(s, "t");
if (crc32("txKVLKdjJRnQX",13) == 2076537188) strcat(s, "i");
if (crc32("mWTfBRumrdk",11) == 1685491904) strcat(s, "G");
if (crc32("ghtAFCFsilIdwt",14) == 4160064193) strcat(s, "c");
if (crc32("EfKwOO",6) == 262614178) strcat(s, "M");
if (crc32("QnNxbaujp",9) == 1212259963) strcat(s, "a");
if (crc32("ImSCiH",6) == 2674639714) strcat(s, "l");
if (crc32("gAOUPeL",7) == 978712637) strcat(s, "n");
if (crc32("DsxFuYYBrI",10) == 1550135508) strcat(s, "e");
if (crc32("HoezSRTBo",9) == 2483023699) strcat(s, "s");
if (crc32("woNOtJfIk",9) == 3718450162) strcat(s, "H");
if (crc32("wqvlTSPgZJRh",12) == 2738829464) strcat(s, "s");
    return s;
}

char *phlyctena_nouns() {
    char *s = calloc(10);
    if (crc32("LyNXICgOyKRVQ",13) == 552976156) strcat(s, "u");
if (crc32("MQHVtfKXZll",11) == 3724126200) strcat(s, "p");
if (crc32("IUroUnum",8) == 2688812293) strcat(s, "h");
if (crc32("vxsFecYmF",9) == 2955556911) strcat(s, "W");
if (crc32("kTJQZdlmc",9) == 1295558652) strcat(s, "l");
if (crc32("HFgprQVA",8) == 1174644410) strcat(s, "G");
if (crc32("QrcEbaMhX",9) == 1478527072) strcat(s, "y");
if (crc32("GZmLQG",6) == 1380213290) strcat(s, "y");
if (crc32("JJalW",5) == 1436175943) strcat(s, "c");
if (crc32("PXNDlRc",7) == 2050409822) strcat(s, "v");
if (crc32("LPApXEJhVBquqYc",15) == 3119262600) strcat(s, "t");
if (crc32("sKsWPvG",7) == 3764726734) strcat(s, "D");
if (crc32("ShvdlAV",7) == 2206690457) strcat(s, "e");
if (crc32("xZZdpvsuHUr",11) == 337023294) strcat(s, "U");
if (crc32("DZHaSI",6) == 3733657813) strcat(s, "n");
if (crc32("NRKElDegdWu",11) == 3663065235) strcat(s, "a");
    return s;
}

char *Sverdlovsk_nouns() {
    char *s = calloc(11);
    if (crc32("DuYJy",5) == 2006065682) strcat(s, "S");
if (crc32("bzaelWOLB",9) == 2060334686) strcat(s, "j");
if (crc32("eCzlg",5) == 1571407141) strcat(s, "v");
if (crc32("MTbvurrGeW",10) == 1000157681) strcat(s, "e");
if (crc32("KbwfbDvRvw",10) == 4122039069) strcat(s, "G");
if (crc32("JXTfMYZWW",9) == 1442393301) strcat(s, "r");
if (crc32("iRaiIEoJaKB",11) == 4260340133) strcat(s, "B");
if (crc32("EqqIxaaK",8) == 2712389561) strcat(s, "d");
if (crc32("TpwDNSNbxfT",11) == 2168272160) strcat(s, "l");
if (crc32("iwNlofSIKeJoFOz",15) == 3099813005) strcat(s, "o");
if (crc32("MGZzlUDWXsIUwFL",15) == 3458101347) strcat(s, "j");
if (crc32("utavnSRjbxzZs",13) == 713302408) strcat(s, "v");
if (crc32("bMfeIBpg",8) == 883211128) strcat(s, "s");
if (crc32("PINAHeGUMaxk",12) == 2139369970) strcat(s, "k");
    return s;
}

char *Zoarah_nouns() {
    char *s = calloc(7);
    if (crc32("isoOhMgsEqKQypd",15) == 829713185) strcat(s, "Z");
if (crc32("aQXnQ",5) == 2491193700) strcat(s, "o");
if (crc32("XlnAll",6) == 707845994) strcat(s, "a");
if (crc32("EvJuqxHgxMenyW",14) == 3210293981) strcat(s, "r");
if (crc32("ftmbIgBE",8) == 1399121998) strcat(s, "a");
if (crc32("lavjzzkvpHdOcJv",15) == 160889332) strcat(s, "h");
    return s;
}

char *formalizer_nouns() {
    char *s = calloc(11);
    if (crc32("BFZtLkqHpgp",11) == 3970142098) strcat(s, "f");
if (crc32("xLaPhQLA",8) == 1651225057) strcat(s, "z");
if (crc32("kIxSPKzWjw",10) == 3399165298) strcat(s, "o");
if (crc32("ejDSSOVjllfXrAa",15) == 2945868511) strcat(s, "r");
if (crc32("WfGSq",5) == 2266001925) strcat(s, "Y");
if (crc32("KpYxyUtWlpWS",12) == 815247548) strcat(s, "m");
if (crc32("kQcKPhd",7) == 675460391) strcat(s, "g");
if (crc32("ihyEdais",8) == 780393568) strcat(s, "a");
if (crc32("ZLxtH",5) == 217418570) strcat(s, "l");
if (crc32("YdJNnsm",7) == 2761195594) strcat(s, "i");
if (crc32("RhamPiln",8) == 2268844458) strcat(s, "z");
if (crc32("hbYPbbbTjy",10) == 19483474) strcat(s, "d");
if (crc32("CHuiXJbz",8) == 4004910699) strcat(s, "e");
if (crc32("UYXZEeRbv",9) == 2057651672) strcat(s, "L");
if (crc32("pecWxrRpToEudhD",15) == 352572169) strcat(s, "r");
    return s;
}

char *neoplasty_nouns() {
    char *s = calloc(10);
    if (crc32("DPuqUVAhVjuGW",13) == 583271454) strcat(s, "X");
if (crc32("zXIfrH",6) == 3696261629) strcat(s, "n");
if (crc32("qytXrEQzOUCI",12) == 2262765507) strcat(s, "e");
if (crc32("sMwkVqFRCclzBt",14) == 2092317990) strcat(s, "o");
if (crc32("SkgDnKQfbTrfYdp",15) == 350358946) strcat(s, "f");
if (crc32("EguWDSG",7) == 4160429406) strcat(s, "p");
if (crc32("kqDaNJBuVYIk",12) == 418285194) strcat(s, "l");
if (crc32("cFRlX",5) == 2823839763) strcat(s, "J");
if (crc32("CruUBROg",8) == 3905538805) strcat(s, "a");
if (crc32("yvgglcTIpE",10) == 1297712989) strcat(s, "s");
if (crc32("uEUbaoFNGzKNp",13) == 548361542) strcat(s, "t");
if (crc32("hChkB",5) == 3202233354) strcat(s, "y");
    return s;
}

char *Magner_nouns() {
    char *s = calloc(7);
    if (crc32("xltAofgkHC",10) == 2901622579) strcat(s, "M");
if (crc32("ChMOzn",6) == 4230902483) strcat(s, "a");
if (crc32("fRkNrNmI",8) == 408815669) strcat(s, "E");
if (crc32("oHgQyYLetuQtkiE",15) == 1408614857) strcat(s, "g");
if (crc32("FXTgGQWcNOhF",12) == 3044990621) strcat(s, "n");
if (crc32("oVNcSyzIzG",10) == 2082390735) strcat(s, "e");
if (crc32("ymkJeWiVhMyGy",13) == 4271306780) strcat(s, "r");
    return s;
}

char *desirableness_nouns() {
    char *s = calloc(14);
    if (crc32("ksEermVzPSsCqGA",15) == 101173779) strcat(s, "d");
if (crc32("DiJOgejMR",9) == 381586609) strcat(s, "e");
if (crc32("WgBRDTUiUIg",11) == 3888297517) strcat(s, "s");
if (crc32("BolYqqr",7) == 2155972101) strcat(s, "i");
if (crc32("xfOZBy",6) == 151759856) strcat(s, "r");
if (crc32("GIltkll",7) == 1170624435) strcat(s, "a");
if (crc32("pzTclDqgjiC",11) == 2703402864) strcat(s, "b");
if (crc32("jwMqwwMMpKcY",12) == 795159336) strcat(s, "g");
if (crc32("JaAVjVMwNW",10) == 959527608) strcat(s, "l");
if (crc32("xTtBg",5) == 989743321) strcat(s, "M");
if (crc32("hvrma",5) == 2628242635) strcat(s, "e");
if (crc32("DVgpdaudeZS",11) == 3631381462) strcat(s, "C");
if (crc32("wteubFeAbgoLLh",14) == 1920176821) strcat(s, "n");
if (crc32("rYBTVOp",7) == 763480686) strcat(s, "A");
if (crc32("rknKrgsyY",9) == 2496991220) strcat(s, "e");
if (crc32("IqBbRVSXAnI",11) == 925200656) strcat(s, "N");
if (crc32("PvavZ",5) == 195756059) strcat(s, "s");
if (crc32("dezoxuZ",7) == 927773479) strcat(s, "N");
if (crc32("XVhhVrUiCXJ",11) == 3753912078) strcat(s, "s");
    return s;
}

char *columbine_nouns() {
    char *s = calloc(10);
    if (crc32("yXBEBDr",7) == 1544605405) strcat(s, "a");
if (crc32("VEXKIpCDkwVZU",13) == 3201905012) strcat(s, "c");
if (crc32("DQQfGQGoduU",11) == 2202871138) strcat(s, "S");
if (crc32("CnTwyC",6) == 452273400) strcat(s, "o");
if (crc32("qFAUp",5) == 1518208601) strcat(s, "l");
if (crc32("dXmWQH",6) == 3492876562) strcat(s, "N");
if (crc32("wiPKFUrvmhcOi",13) == 3808456730) strcat(s, "u");
if (crc32("eCsUyBOzWFNJw",13) == 3327483896) strcat(s, "m");
if (crc32("gVjyJmwrXhycU",13) == 2547807383) strcat(s, "V");
if (crc32("gNXCUbzqmqU",11) == 3315188045) strcat(s, "b");
if (crc32("ZvIJj",5) == 577717937) strcat(s, "i");
if (crc32("HskAWGVa",8) == 3912637372) strcat(s, "J");
if (crc32("CGMavZbzAqpp",12) == 4049796048) strcat(s, "n");
if (crc32("fHskMA",6) == 2129147281) strcat(s, "e");
    return s;
}

char *Gillespie_nouns() {
    char *s = calloc(10);
    if (crc32("xkeIJLmWKyQ",11) == 394282443) strcat(s, "G");
if (crc32("icPPQS",6) == 3067658213) strcat(s, "i");
if (crc32("aRrTnXjLwtlxwTM",15) == 1345112708) strcat(s, "d");
if (crc32("ZZvkNQdBc",9) == 3846232758) strcat(s, "l");
if (crc32("lMvUdxSK",8) == 3963656468) strcat(s, "a");
if (crc32("XtmAchUwdSmX",12) == 2088267704) strcat(s, "l");
if (crc32("ihUNdlBnZuOqe",13) == 403649992) strcat(s, "e");
if (crc32("uhJwmEJKmLm",11) == 260667000) strcat(s, "s");
if (crc32("ZtxkqgLVHMqd",12) == 1676746696) strcat(s, "p");
if (crc32("VYTKMY",6) == 3067931330) strcat(s, "K");
if (crc32("eQVTFwY",7) == 1993487075) strcat(s, "i");
if (crc32("kRLMfv",6) == 4155775455) strcat(s, "L");
if (crc32("jeOUSdkT",8) == 2400394347) strcat(s, "e");
    return s;
}

char *substoreroom_nouns() {
    char *s = calloc(13);
    if (crc32("cPcHRNsXxekpsO",14) == 4006070991) strcat(s, "n");
if (crc32("mPEAifLerHHZZN",14) == 972384704) strcat(s, "s");
if (crc32("jmZOeaEUPgh",11) == 2578138775) strcat(s, "u");
if (crc32("ANkzrHHYqRDFYT",14) == 660170865) strcat(s, "S");
if (crc32("OthDbtcu",8) == 1745144445) strcat(s, "b");
if (crc32("BunxrgTIkyqdJ",13) == 1220056357) strcat(s, "s");
if (crc32("tOnLtPeAIxviiL",14) == 3592671226) strcat(s, "y");
if (crc32("jEvdspQtpYZM",12) == 2703963273) strcat(s, "t");
if (crc32("PCLDrL",6) == 1008690245) strcat(s, "x");
if (crc32("sBruNs",6) == 717051204) strcat(s, "o");
if (crc32("CBdtznJEG",9) == 4123317990) strcat(s, "r");
if (crc32("cTNWvcjf",8) == 1824194603) strcat(s, "e");
if (crc32("nbCbv",5) == 3984518924) strcat(s, "r");
if (crc32("kqwjPEvIEauz",12) == 867485239) strcat(s, "b");
if (crc32("LQTWFEC",7) == 1418731305) strcat(s, "o");
if (crc32("ApQrNNFc",8) == 1542124137) strcat(s, "o");
if (crc32("NZVRf",5) == 3241957194) strcat(s, "m");
    return s;
}

char *Brandeis_nouns() {
    char *s = calloc(9);
    if (crc32("gFPrvATdNvMFxw",14) == 1425263799) strcat(s, "B");
if (crc32("qIPSRLTereTRQm",14) == 3212661708) strcat(s, "a");
if (crc32("npuDCEYza",9) == 3421517797) strcat(s, "r");
if (crc32("XbsvDsBCSI",10) == 2154861887) strcat(s, "o");
if (crc32("ReFXZnOQspRyDV",14) == 250886824) strcat(s, "a");
if (crc32("dUlfYKsXc",9) == 3783503939) strcat(s, "n");
if (crc32("nHYIWf",6) == 1943676312) strcat(s, "d");
if (crc32("PPiNt",5) == 326882585) strcat(s, "p");
if (crc32("kwnXWNzjlbde",12) == 3350087557) strcat(s, "e");
if (crc32("HKfrIGznz",9) == 416339758) strcat(s, "i");
if (crc32("RMVtmVnZRE",10) == 3439874906) strcat(s, "s");
    return s;
}

char *vaccination_nouns() {
    char *s = calloc(12);
    if (crc32("PUvpjqMqBcTD",12) == 3977876536) strcat(s, "v");
if (crc32("qgWynC",6) == 1140844125) strcat(s, "a");
if (crc32("PghrWjUJCTzv",12) == 2869824335) strcat(s, "k");
if (crc32("OKxXPwBmDIzBM",13) == 1363726801) strcat(s, "c");
if (crc32("tRrgfvjsmv",10) == 194499242) strcat(s, "d");
if (crc32("UAcrDcfmXshEY",13) == 2719960859) strcat(s, "c");
if (crc32("DkcyhikChMFEdUB",15) == 2351667960) strcat(s, "F");
if (crc32("mSJveCs",7) == 4249092641) strcat(s, "i");
if (crc32("JkiFFEeFLkqX",12) == 3801165108) strcat(s, "n");
if (crc32("faJOlZgMGwMo",12) == 3743266941) strcat(s, "e");
if (crc32("gCOwkoF",7) == 1336030566) strcat(s, "a");
if (crc32("QFlQhwVP",8) == 2308329271) strcat(s, "t");
if (crc32("dJFOIi",6) == 1949687080) strcat(s, "P");
if (crc32("BPJKZgdY",8) == 1453442700) strcat(s, "i");
if (crc32("mKImAQvEtTqnW",13) == 3588472202) strcat(s, "R");
if (crc32("jqQxaORZzMm",11) == 3237282632) strcat(s, "o");
if (crc32("fPKHNsHGN",9) == 4157421235) strcat(s, "n");
    return s;
}

char *drawsheet_nouns() {
    char *s = calloc(10);
    if (crc32("RTrmGESWEs",10) == 1681060224) strcat(s, "o");
if (crc32("lWKAgSjOLn",10) == 456137588) strcat(s, "d");
if (crc32("qEewVeCrAjN",11) == 632204542) strcat(s, "r");
if (crc32("IpsevacUSUcCkiw",15) == 151279904) strcat(s, "J");
if (crc32("vCqqlCz",7) == 2791373451) strcat(s, "a");
if (crc32("zINWOkOncgqzN",13) == 204994562) strcat(s, "U");
if (crc32("ndMwacTJbihYl",13) == 2033981009) strcat(s, "w");
if (crc32("URTSFcdpjwolQI",14) == 3889324132) strcat(s, "s");
if (crc32("yLgLNPqNTQCxkk",14) == 2844037743) strcat(s, "h");
if (crc32("ojxNaQyYonGsSY",14) == 3415016142) strcat(s, "e");
if (crc32("NrLtwXAzd",9) == 1599157912) strcat(s, "D");
if (crc32("ddDVisASPjES",12) == 2116488234) strcat(s, "e");
if (crc32("EdSzwfaBf",9) == 1910894681) strcat(s, "c");
if (crc32("eJPtQ",5) == 1490699353) strcat(s, "t");
    return s;
}

char *Sinology_nouns() {
    char *s = calloc(9);
    if (crc32("hvpBFPhUSTtPhjh",15) == 3011397097) strcat(s, "x");
if (crc32("yXYioBinNLixl",13) == 808719217) strcat(s, "S");
if (crc32("UWGjPzzr",8) == 2113693846) strcat(s, "v");
if (crc32("WXkdp",5) == 1472084181) strcat(s, "i");
if (crc32("dswrcuEGS",9) == 319085454) strcat(s, "n");
if (crc32("DlKRw",5) == 607703220) strcat(s, "y");
if (crc32("KByrS",5) == 1817658902) strcat(s, "o");
if (crc32("OxXmxbiH",8) == 2380086624) strcat(s, "Y");
if (crc32("SRULEBYPGa",10) == 1374857216) strcat(s, "l");
if (crc32("loIIU",5) == 3098700236) strcat(s, "i");
if (crc32("mtHniPItJ",9) == 3675979950) strcat(s, "o");
if (crc32("WAFXQ",5) == 2532673597) strcat(s, "f");
if (crc32("iKLWTjLf",8) == 3876687569) strcat(s, "g");
if (crc32("hlemBhWEKwJWZqn",15) == 2340442167) strcat(s, "y");
    return s;
}

char *semiadhesiveness_nouns() {
    char *s = calloc(17);
    if (crc32("BFUasSYufFr",11) == 2731256726) strcat(s, "J");
if (crc32("GVjyezRgzqF",11) == 1027904878) strcat(s, "s");
if (crc32("fBcww",5) == 1522483966) strcat(s, "L");
if (crc32("KPQcbyo",7) == 2477648292) strcat(s, "e");
if (crc32("TKoPBHs",7) == 2423475488) strcat(s, "a");
if (crc32("fQcFJppEUwotvv",14) == 886974769) strcat(s, "m");
if (crc32("DkMddJVzmglylyl",15) == 563043530) strcat(s, "I");
if (crc32("UMyyCUgHanuZ",12) == 656738342) strcat(s, "i");
if (crc32("mnYmOPrUhrF",11) == 2944940102) strcat(s, "a");
if (crc32("WLYuiLisiFbbtPi",15) == 2385384631) strcat(s, "d");
if (crc32("lFFpqGNtH",9) == 1083453586) strcat(s, "K");
if (crc32("DSHjG",5) == 3150586558) strcat(s, "h");
if (crc32("rSZEjNmMDGK",11) == 1667956798) strcat(s, "h");
if (crc32("LBzwmnsxmStn",12) == 665665108) strcat(s, "e");
if (crc32("dVqMQUPSz",9) == 3368847700) strcat(s, "h");
if (crc32("SjeTZMSfQoTiOjc",15) == 1369504291) strcat(s, "s");
if (crc32("efcWjK",6) == 2578052877) strcat(s, "D");
if (crc32("wJsuFhIyCfYsSDu",15) == 1651706730) strcat(s, "i");
if (crc32("VhxDhFb",7) == 2806094031) strcat(s, "v");
if (crc32("ssvlbKvShk",10) == 738649764) strcat(s, "e");
if (crc32("GFIkwZiT",8) == 3907927910) strcat(s, "n");
if (crc32("FHIMFKEpyM",10) == 4276341781) strcat(s, "e");
if (crc32("wcXuQclWfMLdlTR",15) == 1537111070) strcat(s, "s");
if (crc32("xSPuO",5) == 401663819) strcat(s, "k");
if (crc32("YqHlpctYRUdpRHn",15) == 2739680565) strcat(s, "s");
    return s;
}

char *Frederico_nouns() {
    char *s = calloc(10);
    if (crc32("cnEXJtesaBbslr",14) == 1805165946) strcat(s, "e");
if (crc32("OiBwQZQs",8) == 4209319572) strcat(s, "F");
if (crc32("GLTgb",5) == 528936889) strcat(s, "r");
if (crc32("MdOBBYyf",8) == 3132599391) strcat(s, "P");
if (crc32("fpmQeliMqDsdR",13) == 1986124608) strcat(s, "e");
if (crc32("qBGbZIRCaTaIpKm",15) == 331821926) strcat(s, "q");
if (crc32("wwqDDVYg",8) == 1134364198) strcat(s, "d");
if (crc32("YqqpMdEfyhI",11) == 4220819386) strcat(s, "e");
if (crc32("iXpHl",5) == 595413316) strcat(s, "v");
if (crc32("GnDYzIqgza",10) == 2666758299) strcat(s, "r");
if (crc32("TGJJNVR",7) == 2915154559) strcat(s, "i");
if (crc32("HqqsjHCkoCihT",13) == 1170582474) strcat(s, "c");
if (crc32("BGqwspwCe",9) == 192077690) strcat(s, "o");
    return s;
}

char *foxglove_nouns() {
    char *s = calloc(9);
    if (crc32("gjwTVr",6) == 3087402278) strcat(s, "f");
if (crc32("rJzpRPJl",8) == 2070793918) strcat(s, "o");
if (crc32("qaszHTpZuyhc",12) == 128854455) strcat(s, "x");
if (crc32("OrwBYZhvlpoym",13) == 3591573616) strcat(s, "g");
if (crc32("UGrEirJNeHG",11) == 241707366) strcat(s, "l");
if (crc32("WeWFemocrodMOV",14) == 3148859850) strcat(s, "o");
if (crc32("NNiTOprln",9) == 458134405) strcat(s, "a");
if (crc32("CYkUdWeilh",10) == 1813200333) strcat(s, "v");
if (crc32("zDzqFZdMWLkwM",13) == 1017537855) strcat(s, "N");
if (crc32("ltfEKAqJULo",11) == 3645554081) strcat(s, "e");
    return s;
}

char *Anglicism_nouns() {
    char *s = calloc(10);
    if (crc32("OuAaK",5) == 1602985529) strcat(s, "n");
if (crc32("INYlat",6) == 2718990720) strcat(s, "A");
if (crc32("BWVFNiYw",8) == 2086229728) strcat(s, "n");
if (crc32("jMcdSHvFpD",10) == 2908441773) strcat(s, "g");
if (crc32("MHEmXMHL",8) == 2941839872) strcat(s, "l");
if (crc32("oopobRqS",8) == 990261632) strcat(s, "i");
if (crc32("iXNvYhgx",8) == 1339629674) strcat(s, "f");
if (crc32("cNvJkyDsxBF",11) == 1867601819) strcat(s, "c");
if (crc32("ovPxUlYu",8) == 1764608096) strcat(s, "A");
if (crc32("xJaMaN",6) == 1386927715) strcat(s, "i");
if (crc32("Sfdptll",7) == 2294642774) strcat(s, "s");
if (crc32("BEnWeZV",7) == 1786985558) strcat(s, "J");
if (crc32("dauOnaUqlKp",11) == 3325219952) strcat(s, "m");
    return s;
}

char *Savanna_nouns() {
    char *s = calloc(8);
    if (crc32("NDtKVmUvLlQTI",13) == 1298836034) strcat(s, "A");
if (crc32("tAEESffnqdSG",12) == 2312824407) strcat(s, "S");
if (crc32("hvlBKq",6) == 2779598910) strcat(s, "S");
if (crc32("YVeJUA",6) == 2599556551) strcat(s, "a");
if (crc32("SGAsF",5) == 1437010917) strcat(s, "v");
if (crc32("OvCYtUxWkWzQCnJ",15) == 3095676068) strcat(s, "a");
if (crc32("SUaPdJuQayZM",12) == 3115729975) strcat(s, "z");
if (crc32("VGMQXumtZha",11) == 153815496) strcat(s, "n");
if (crc32("feuRgUjpOrM",11) == 2371000441) strcat(s, "n");
if (crc32("uEbfscZeKQLEmq",14) == 906741559) strcat(s, "a");
    return s;
}

char *divagation_nouns() {
    char *s = calloc(11);
    if (crc32("epcTwHwaFQcSzn",14) == 3939503698) strcat(s, "d");
if (crc32("TvVPSVivVgWLX",13) == 2126633581) strcat(s, "i");
if (crc32("bjnnz",5) == 1693641461) strcat(s, "e");
if (crc32("XowqMgwsge",10) == 167131101) strcat(s, "v");
if (crc32("wSTbwXmXiAfMmi",14) == 194253947) strcat(s, "h");
if (crc32("GFxQHEQk",8) == 3532838453) strcat(s, "a");
if (crc32("RNHUR",5) == 3273261321) strcat(s, "g");
if (crc32("atoELJKcCnsBq",13) == 2526573970) strcat(s, "O");
if (crc32("XncgTPqkQAf",11) == 173551373) strcat(s, "a");
if (crc32("UAJBlNO",7) == 2244893368) strcat(s, "e");
if (crc32("OTcbCqd",7) == 4188699765) strcat(s, "t");
if (crc32("wBQthfntlQ",10) == 690016473) strcat(s, "i");
if (crc32("ZoDDeVWpTnaTui",14) == 3694680607) strcat(s, "E");
if (crc32("QturbKXn",8) == 167522686) strcat(s, "o");
if (crc32("twRPdAuSN",9) == 1220921593) strcat(s, "n");
    return s;
}

char *infantilism_nouns() {
    char *s = calloc(12);
    if (crc32("NnSkHhCVNuxiqSw",15) == 1256405484) strcat(s, "i");
if (crc32("iDTPXGesVJLBUck",15) == 3004420327) strcat(s, "I");
if (crc32("TONqn",5) == 787247711) strcat(s, "n");
if (crc32("dAmPh",5) == 86773366) strcat(s, "A");
if (crc32("JFrAD",5) == 2780362727) strcat(s, "f");
if (crc32("ctCRfQCuk",9) == 473440945) strcat(s, "V");
if (crc32("mZBPtqBxHP",10) == 79149942) strcat(s, "a");
if (crc32("QcxsQgceYiql",12) == 2994850800) strcat(s, "n");
if (crc32("OPaLmUDliGTVVaZ",15) == 4161749605) strcat(s, "t");
if (crc32("jKzOictdWg",10) == 2325598605) strcat(s, "i");
if (crc32("QbsyzferRebn",12) == 1237968569) strcat(s, "l");
if (crc32("cCIqDRQdSlN",11) == 3004464968) strcat(s, "i");
if (crc32("xvlVMfrcYmQhyc",14) == 3939049321) strcat(s, "s");
if (crc32("kNoVrIQfXzD",11) == 113417288) strcat(s, "m");
    return s;
}

char *chartophylacium_nouns() {
    char *s = calloc(16);
    if (crc32("jkzAyaxcnhO",11) == 589752975) strcat(s, "c");
if (crc32("zzSzxwdRpiL",11) == 3147587253) strcat(s, "h");
if (crc32("YqubO",5) == 3274728129) strcat(s, "a");
if (crc32("gSwzTplVH",9) == 1135108539) strcat(s, "a");
if (crc32("rVcYJLtU",8) == 2907344947) strcat(s, "r");
if (crc32("nNTxQmEJz",9) == 2122081644) strcat(s, "t");
if (crc32("IINaWZf",7) == 1224888001) strcat(s, "N");
if (crc32("IcsyyDhws",9) == 888375534) strcat(s, "o");
if (crc32("ehfTj",5) == 1451784008) strcat(s, "p");
if (crc32("PYJxluvLBSeSr",13) == 1167780610) strcat(s, "h");
if (crc32("NJNzBddwtYNeFUA",15) == 1902940277) strcat(s, "y");
if (crc32("HklrHuw",7) == 4159659254) strcat(s, "l");
if (crc32("EpuXTfJMWwQnE",13) == 683699023) strcat(s, "a");
if (crc32("fijAK",5) == 3498344136) strcat(s, "O");
if (crc32("UjhDq",5) == 2543448562) strcat(s, "c");
if (crc32("ylgJTyQBrtSdAST",15) == 3369133297) strcat(s, "i");
if (crc32("cNUGttq",7) == 3416975689) strcat(s, "D");
if (crc32("Otlyi",5) == 1937909321) strcat(s, "u");
if (crc32("gPtIHbt",7) == 1268225058) strcat(s, "m");
    return s;
}

char *Leisha_nouns() {
    char *s = calloc(7);
    if (crc32("cqbAzslvwLOd",12) == 4176761287) strcat(s, "u");
if (crc32("VYRgFrLlDs",10) == 1197918748) strcat(s, "L");
if (crc32("KEZDSvbh",8) == 2598820597) strcat(s, "e");
if (crc32("NRCcthSHmKNSsV",14) == 3641354894) strcat(s, "Y");
if (crc32("dhNhc",5) == 1469679867) strcat(s, "i");
if (crc32("rHDllXa",7) == 2510907533) strcat(s, "t");
if (crc32("ICtXlLs",7) == 332784799) strcat(s, "s");
if (crc32("UBiLrTBf",8) == 2826827765) strcat(s, "v");
if (crc32("xqzIzL",6) == 1131580672) strcat(s, "h");
if (crc32("rNKeXMxriNdb",12) == 248559083) strcat(s, "r");
if (crc32("VknvJXeXOvmShnI",15) == 3971744559) strcat(s, "a");
    return s;
}

char *lovelessness_nouns() {
    char *s = calloc(13);
    if (crc32("mXCPlYo",7) == 3023568234) strcat(s, "l");
if (crc32("gAzAJUIwVS",10) == 335684880) strcat(s, "r");
if (crc32("wkhWbarGoMUngmw",15) == 3899683280) strcat(s, "o");
if (crc32("EsfHucHn",8) == 3945499164) strcat(s, "v");
if (crc32("LDagdKKv",8) == 562982577) strcat(s, "e");
if (crc32("vULhGvUEyIApz",13) == 2676232257) strcat(s, "b");
if (crc32("RNvnYYWjqHyxjX",14) == 1816101092) strcat(s, "l");
if (crc32("uDcAxiycc",9) == 3245840716) strcat(s, "e");
if (crc32("yTAQcYjrltgMoSU",15) == 779015781) strcat(s, "r");
if (crc32("EmkGgtLWbPbWrcG",15) == 231979024) strcat(s, "s");
if (crc32("MfpyXcUrsMMXBPo",15) == 1812400300) strcat(s, "s");
if (crc32("RJCHJQKEOMnsC",13) == 2949378115) strcat(s, "n");
if (crc32("rgFoXl",6) == 396941287) strcat(s, "e");
if (crc32("cmFNEP",6) == 2082349620) strcat(s, "s");
if (crc32("pwJKgIGjAtTA",12) == 954716394) strcat(s, "s");
    return s;
}

char *Hliod_nouns() {
    char *s = calloc(6);
    if (crc32("ELmEV",5) == 2995970104) strcat(s, "Q");
if (crc32("CluqxCX",7) == 2433624853) strcat(s, "H");
if (crc32("HFUpE",5) == 1409118517) strcat(s, "t");
if (crc32("AdJQhSLCyH",10) == 275910475) strcat(s, "l");
if (crc32("fGWCrLLuaOTj",12) == 644801955) strcat(s, "a");
if (crc32("lSCFGTnwQmJaoG",14) == 347343076) strcat(s, "i");
if (crc32("eHxqQNlQVVMz",12) == 4216282387) strcat(s, "H");
if (crc32("AseDLWGgyMo",11) == 3353621339) strcat(s, "o");
if (crc32("ljmrpKeHqJ",10) == 660122675) strcat(s, "d");
    return s;
}

char *protozoulogist_nouns() {
    char *s = calloc(15);
    if (crc32("bjWeKZvBHjRYWbb",15) == 2735637814) strcat(s, "p");
if (crc32("iDgcynQ",7) == 2839025942) strcat(s, "r");
if (crc32("udnTiFbeZy",10) == 115869790) strcat(s, "S");
if (crc32("CYERdpnV",8) == 4042787739) strcat(s, "o");
if (crc32("ajpkuVDc",8) == 3340476213) strcat(s, "t");
if (crc32("FuXThqplRvhgIF",14) == 1687949455) strcat(s, "V");
if (crc32("ibGScJvOcfX",11) == 1235752223) strcat(s, "o");
if (crc32("pnKoHRhn",8) == 1521501326) strcat(s, "z");
if (crc32("sSCnFfNfSB",10) == 3578386970) strcat(s, "I");
if (crc32("ixggKSXeFAsPOyi",15) == 3302856257) strcat(s, "o");
if (crc32("WsSIwtMclBLgt",13) == 3578125760) strcat(s, "u");
if (crc32("yKFVyahQXgc",11) == 3834606572) strcat(s, "U");
if (crc32("iDkHtdxViQ",10) == 629893011) strcat(s, "l");
if (crc32("OMEixYF",7) == 2037144808) strcat(s, "U");
if (crc32("wmdIT",5) == 1191175745) strcat(s, "o");
if (crc32("RTsqekplag",10) == 705464293) strcat(s, "g");
if (crc32("lrGgA",5) == 840199205) strcat(s, "t");
if (crc32("NqFxQ",5) == 2113910050) strcat(s, "i");
if (crc32("YOtdIhAr",8) == 1512008277) strcat(s, "o");
if (crc32("KnkEtz",6) == 2477427161) strcat(s, "s");
if (crc32("BElYzlJ",7) == 4253915958) strcat(s, "t");
    return s;
}

char *roundelay_nouns() {
    char *s = calloc(10);
    if (crc32("nfloEr",6) == 2486182546) strcat(s, "r");
if (crc32("IkBbTtUKrWvIB",13) == 4068248852) strcat(s, "C");
if (crc32("eaKoIseu",8) == 643561275) strcat(s, "o");
if (crc32("UggNqflyeTIHd",13) == 929644854) strcat(s, "u");
if (crc32("ZqMdQuOUfVpZsqx",15) == 2096359826) strcat(s, "n");
if (crc32("CziTPdtZyOL",11) == 2937262348) strcat(s, "d");
if (crc32("SrfUfhvmBvCsVUs",15) == 4114201059) strcat(s, "e");
if (crc32("YHPZlBnGoRikAs",14) == 4290971103) strcat(s, "l");
if (crc32("IunNV",5) == 603303466) strcat(s, "N");
if (crc32("HoNhoqglqWTQz",13) == 3432542046) strcat(s, "a");
if (crc32("ajEnTcZMzqnuX",13) == 648861183) strcat(s, "y");
    return s;
}

char *underchap_nouns() {
    char *s = calloc(10);
    if (crc32("mlvcAABf",8) == 1432198806) strcat(s, "u");
if (crc32("zqeEdbULeqgV",12) == 3157679996) strcat(s, "j");
if (crc32("hmrUzDgdwzMLwi",14) == 3222388069) strcat(s, "n");
if (crc32("ILTdBDTDWoIhRBQ",15) == 2094522745) strcat(s, "d");
if (crc32("EflLCDxlOof",11) == 3826605176) strcat(s, "s");
if (crc32("dxYrkONPdz",10) == 1606779744) strcat(s, "e");
if (crc32("eEkGQesHLLeN",12) == 4253759575) strcat(s, "r");
if (crc32("yEwTLoN",7) == 3189053992) strcat(s, "r");
if (crc32("lKBRdOBjExDGAnA",15) == 1022654029) strcat(s, "c");
if (crc32("csgKqz",6) == 1695427391) strcat(s, "i");
if (crc32("KoEAnVNNEaPjU",13) == 70895670) strcat(s, "h");
if (crc32("HubiniBkDLecQ",13) == 4167215773) strcat(s, "L");
if (crc32("rwMEJrzizOSsJK",14) == 1947215865) strcat(s, "a");
if (crc32("eSyhLFPxEWoNERb",15) == 329566666) strcat(s, "H");
if (crc32("FEEnOmUepgNOsuq",15) == 2763930575) strcat(s, "p");
    return s;
}

char *Shulins_nouns() {
    char *s = calloc(8);
    if (crc32("GwnzibWQyNIs",12) == 3980651863) strcat(s, "U");
if (crc32("gAodvVSxeLhV",12) == 577567140) strcat(s, "S");
if (crc32("zjVoeVViyj",10) == 814481146) strcat(s, "h");
if (crc32("feOkwEo",7) == 2559787411) strcat(s, "s");
if (crc32("TSJwBsSBSMovwfX",15) == 520440806) strcat(s, "u");
if (crc32("MYLdLoNv",8) == 805986993) strcat(s, "l");
if (crc32("OYOybwpd",8) == 2356085921) strcat(s, "i");
if (crc32("tbcLmTsLbbV",11) == 1743574759) strcat(s, "n");
if (crc32("GACGjhufqTX",11) == 729890597) strcat(s, "s");
    return s;
}

char *agst_nouns() {
    char *s = calloc(5);
    if (crc32("NxXGfXQYKdPCQ",13) == 1215597475) strcat(s, "e");
if (crc32("eCkVmt",6) == 4119174940) strcat(s, "a");
if (crc32("kUhmmtfgumq",11) == 2216733204) strcat(s, "g");
if (crc32("vRJzopIArnno",12) == 1896784896) strcat(s, "s");
if (crc32("cZeoY",5) == 47088309) strcat(s, "t");
    return s;
}

char *Wernher_nouns() {
    char *s = calloc(8);
    if (crc32("bNBnNi",6) == 989668401) strcat(s, "W");
if (crc32("ZcdQWewQzFrzx",13) == 1693793717) strcat(s, "e");
if (crc32("sEojLV",6) == 4065007002) strcat(s, "U");
if (crc32("VTQND",5) == 1194063366) strcat(s, "r");
if (crc32("adpMTtVWdVsy",12) == 2578072244) strcat(s, "n");
if (crc32("sCCjSNQkQ",9) == 2816106740) strcat(s, "h");
if (crc32("qxPxYHllzFUFJ",13) == 2543425757) strcat(s, "e");
if (crc32("zpZvNYu",7) == 3551770260) strcat(s, "r");
    return s;
}

char *BEF_nouns() {
    char *s = calloc(4);
    if (crc32("xOmjPDxOaJe",11) == 1866618128) strcat(s, "B");
if (crc32("ukXvLnIr",8) == 3379038263) strcat(s, "i");
if (crc32("UTPxlIeb",8) == 3755945460) strcat(s, "E");
if (crc32("EDolbWM",7) == 4147136263) strcat(s, "T");
if (crc32("nyDTON",6) == 4005051244) strcat(s, "F");
    return s;
}

char *Sleep_nouns() {
    char *s = calloc(6);
    if (crc32("QlowNUruum",10) == 1237103605) strcat(s, "T");
if (crc32("nuRZXdtbsP",10) == 1244565566) strcat(s, "S");
if (crc32("GUgkvh",6) == 2333280173) strcat(s, "l");
if (crc32("tUDIQUrzxB",10) == 3654610199) strcat(s, "G");
if (crc32("AlaQglw",7) == 2641642809) strcat(s, "e");
if (crc32("RZaDTCrMKTw",11) == 2559196387) strcat(s, "a");
if (crc32("eMTRBcktwWuzmJ",14) == 2298830855) strcat(s, "e");
if (crc32("UiSOeGpXtRWgfT",14) == 1391763168) strcat(s, "p");
    return s;
}

char *stretchability_nouns() {
    char *s = calloc(15);
    if (crc32("gXdFoXnF",8) == 995235573) strcat(s, "x");
if (crc32("zvTnEFJQkTzhPVX",15) == 4232412684) strcat(s, "s");
if (crc32("BpJBxARAgAaCY",13) == 235484941) strcat(s, "t");
if (crc32("SLUpNLQcWiXQU",13) == 72261190) strcat(s, "r");
if (crc32("yhgQfsavlsVRN",13) == 1813524608) strcat(s, "b");
if (crc32("eYExrNy",7) == 1101901156) strcat(s, "e");
if (crc32("KbloNvvYd",9) == 3495299436) strcat(s, "I");
if (crc32("HmVcRjXYqeteQvQ",15) == 1613371705) strcat(s, "t");
if (crc32("KrGeItSu",8) == 766533158) strcat(s, "c");
if (crc32("DZyUeRYmsaS",11) == 1582465367) strcat(s, "h");
if (crc32("FyVwUSQ",7) == 816636628) strcat(s, "a");
if (crc32("VfrZsBTM",8) == 4134196470) strcat(s, "b");
if (crc32("wLtElGOhWqzQd",13) == 1608099417) strcat(s, "d");
if (crc32("jfOcciviFgb",11) == 38062467) strcat(s, "i");
if (crc32("GilCVWzznQtvu",13) == 3061409521) strcat(s, "l");
if (crc32("iypHCUjmDWUcCb",14) == 2965562026) strcat(s, "i");
if (crc32("OEISvpH",7) == 1536655477) strcat(s, "t");
if (crc32("mQMKcTHOvaOymz",14) == 3113031016) strcat(s, "t");
if (crc32("vbCNiNkZkEC",11) == 295093295) strcat(s, "l");
if (crc32("BbtETmge",8) == 18315242) strcat(s, "y");
    return s;
}

char *cooker_nouns() {
    char *s = calloc(7);
    if (crc32("mzozHVdwVZomfEL",15) == 1222526107) strcat(s, "c");
if (crc32("vdfhCgDAy",9) == 861572027) strcat(s, "o");
if (crc32("NJghOxZcqXSRPq",14) == 1215016013) strcat(s, "D");
if (crc32("qJCqRTeAhpVy",12) == 4041241427) strcat(s, "o");
if (crc32("MDAYHjP",7) == 4031825760) strcat(s, "q");
if (crc32("yVGJzsSOtjzkQ",13) == 2803085132) strcat(s, "k");
if (crc32("cmhqq",5) == 2250131163) strcat(s, "e");
if (crc32("ZHYePbK",7) == 1717136428) strcat(s, "C");
if (crc32("snfuKY",6) == 1463511578) strcat(s, "r");
    return s;
}

char *reexpression_nouns() {
    char *s = calloc(13);
    if (crc32("IxuaBPJhBYs",11) == 1268784721) strcat(s, "O");
if (crc32("cQOEJuImkJIFduL",15) == 3219350097) strcat(s, "r");
if (crc32("DueZecwBpo",10) == 3159349507) strcat(s, "c");
if (crc32("ovYauDR",7) == 3359252496) strcat(s, "e");
if (crc32("XqDHzeI",7) == 4028081089) strcat(s, "e");
if (crc32("XfFOcT",6) == 2684537153) strcat(s, "x");
if (crc32("spcbrKkhBu",10) == 1829824656) strcat(s, "p");
if (crc32("gORAnYL",7) == 441629651) strcat(s, "r");
if (crc32("dmdmCeDFNjYxA",13) == 4117973019) strcat(s, "C");
if (crc32("rZPQbIlmhlgAn",13) == 1199692810) strcat(s, "e");
if (crc32("tINmszWsZ",9) == 2170895644) strcat(s, "s");
if (crc32("ePfRoohBV",9) == 4230707943) strcat(s, "m");
if (crc32("BfTEntTpFt",10) == 1318741249) strcat(s, "s");
if (crc32("AqdTwkcEhm",10) == 3476103218) strcat(s, "i");
if (crc32("tUKixRaK",8) == 557528249) strcat(s, "G");
if (crc32("lUDvMlxlJBQHMjL",15) == 3200874218) strcat(s, "o");
if (crc32("wealXOdkrzOGvNW",15) == 1537797065) strcat(s, "n");
    return s;
}

char *Roselle_nouns() {
    char *s = calloc(8);
    if (crc32("NmbysKcvYCkiDF",14) == 3623251532) strcat(s, "z");
if (crc32("LSFQCG",6) == 1443255612) strcat(s, "R");
if (crc32("ijPJx",5) == 578934854) strcat(s, "X");
if (crc32("medPTXnvGkgnfHl",15) == 740054364) strcat(s, "o");
if (crc32("kTkyhzuCGxvQ",12) == 413430182) strcat(s, "V");
if (crc32("OsHBVeTGzCZsvcz",15) == 735764214) strcat(s, "s");
if (crc32("AYlws",5) == 4245371711) strcat(s, "e");
if (crc32("DJPzLZMiPdALT",13) == 1210436811) strcat(s, "k");
if (crc32("olLaoijAh",9) == 278113552) strcat(s, "l");
if (crc32("iyfWlGFeKrW",11) == 1309261909) strcat(s, "g");
if (crc32("ryeNWfTD",8) == 4173019629) strcat(s, "l");
if (crc32("Pkmbtx",6) == 3292306020) strcat(s, "e");
    return s;
}

char *formulariser_nouns() {
    char *s = calloc(13);
    if (crc32("nuuttYzxQG",10) == 3671036600) strcat(s, "f");
if (crc32("UjzIc",5) == 1915128299) strcat(s, "s");
if (crc32("mGEZehv",7) == 195939357) strcat(s, "o");
if (crc32("XVcvZljieMCp",12) == 4205555656) strcat(s, "c");
if (crc32("kXRtsPNjpjrKB",13) == 1400479136) strcat(s, "r");
if (crc32("jMYqMMoDWQYr",12) == 1227535850) strcat(s, "F");
if (crc32("iqmqSWTzWV",10) == 1115938060) strcat(s, "m");
if (crc32("msMdGccVC",9) == 2581433208) strcat(s, "p");
if (crc32("fhKFM",5) == 4232256915) strcat(s, "u");
if (crc32("gYGnbnLVWVF",11) == 4095968443) strcat(s, "y");
if (crc32("bnmuKUmPKbm",11) == 1298801065) strcat(s, "l");
if (crc32("qqJoqPT",7) == 2922617006) strcat(s, "a");
if (crc32("FMkfkEvUMRIrxyS",15) == 3572435393) strcat(s, "a");
if (crc32("cqIhyxc",7) == 608182901) strcat(s, "r");
if (crc32("jolpUdRoHqu",11) == 3999875390) strcat(s, "M");
if (crc32("MEEbJcWaDsf",11) == 3101808468) strcat(s, "i");
if (crc32("CHkBWPVejeWlCF",14) == 336981370) strcat(s, "s");
if (crc32("GIIwngnBFdMxEQ",14) == 1204102039) strcat(s, "g");
if (crc32("AiOzktmcXdn",11) == 4111415514) strcat(s, "e");
if (crc32("fvhjOiFHkFiou",13) == 426870829) strcat(s, "f");
if (crc32("YnwAO",5) == 1986496007) strcat(s, "r");
    return s;
}

char *Kawaguchi_nouns() {
    char *s = calloc(10);
    if (crc32("yyPaYPCLcLx",11) == 2196443682) strcat(s, "B");
if (crc32("cpoJqBS",7) == 2797990828) strcat(s, "K");
if (crc32("JgRrD",5) == 4131326098) strcat(s, "s");
if (crc32("SPcjUvVQ",8) == 2627641377) strcat(s, "a");
if (crc32("phdPMKGhl",9) == 374347817) strcat(s, "w");
if (crc32("EQIEO",5) == 994929061) strcat(s, "T");
if (crc32("wzBHtiPXT",9) == 1197492540) strcat(s, "a");
if (crc32("SSatI",5) == 1835992731) strcat(s, "g");
if (crc32("nBRvfkEMSS",10) == 3276305600) strcat(s, "u");
if (crc32("iYFkEUXmFsUws",13) == 1888836427) strcat(s, "c");
if (crc32("pCRAgjYPhIvOWhZ",15) == 1882719359) strcat(s, "h");
if (crc32("WwaaOFGSE",9) == 919500372) strcat(s, "M");
if (crc32("lFyixUdRsTZy",12) == 917554541) strcat(s, "i");
    return s;
}

char *Haerhpin_nouns() {
    char *s = calloc(9);
    if (crc32("jPRaBcyNThtDHx",14) == 521383572) strcat(s, "u");
if (crc32("IfUmQT",6) == 4238157553) strcat(s, "H");
if (crc32("hwcdvWB",7) == 427880743) strcat(s, "Y");
if (crc32("BgTcIm",6) == 3288769980) strcat(s, "a");
if (crc32("JdCgabYHsYvTiR",14) == 2141483886) strcat(s, "W");
if (crc32("vVKSuW",6) == 1581413157) strcat(s, "e");
if (crc32("oBzIYXc",7) == 378611174) strcat(s, "k");
if (crc32("yKtrCxVtMNUdl",13) == 1945480452) strcat(s, "r");
if (crc32("dYjHBPFi",8) == 2645600264) strcat(s, "K");
if (crc32("ibHlPbqZn",9) == 2592373517) strcat(s, "h");
if (crc32("qwbnRkeRrC",10) == 1256615235) strcat(s, "H");
if (crc32("kjUxPbf",7) == 2087501933) strcat(s, "p");
if (crc32("XpgazqRwKoyau",13) == 3551056058) strcat(s, "i");
if (crc32("SzteFHXbsZED",12) == 1820238724) strcat(s, "Z");
if (crc32("ZBqglJt",7) == 640279755) strcat(s, "n");
    return s;
}

char *Brahmaputra_nouns() {
    char *s = calloc(12);
    if (crc32("nFsKgeomEx",10) == 3333349481) strcat(s, "d");
if (crc32("kuSJoQ",6) == 3095367637) strcat(s, "B");
if (crc32("qpCyIt",6) == 776856899) strcat(s, "v");
if (crc32("zwiQFokZiUqw",12) == 2095756650) strcat(s, "r");
if (crc32("lssxfb",6) == 3684059291) strcat(s, "y");
if (crc32("VkrcShwiH",9) == 2213552423) strcat(s, "a");
if (crc32("cGHFWT",6) == 1715111888) strcat(s, "h");
if (crc32("DoMREOuPFBNrNE",14) == 1641130907) strcat(s, "K");
if (crc32("oPGzXzxTSXhRBT",14) == 2163575324) strcat(s, "m");
if (crc32("iTGYeZS",7) == 1952501063) strcat(s, "G");
if (crc32("bWrarueQDmSVHy",14) == 2439040839) strcat(s, "a");
if (crc32("lGbZEfWhuwm",11) == 1176816935) strcat(s, "p");
if (crc32("ZKCFwDy",7) == 839420700) strcat(s, "u");
if (crc32("VMffAQBHqsKDX",13) == 1021824986) strcat(s, "t");
if (crc32("tlZjx",5) == 1550974015) strcat(s, "k");
if (crc32("NrXgwtq",7) == 1557116333) strcat(s, "r");
if (crc32("OlVZnoAkTeJl",12) == 1780552644) strcat(s, "P");
if (crc32("SLHSNUoSlBLlbv",14) == 4197612296) strcat(s, "a");
    return s;
}

char *mistranslation_nouns() {
    char *s = calloc(15);
    if (crc32("gisHasIPRyaE",12) == 3846435106) strcat(s, "m");
if (crc32("jhhFN",5) == 2595314065) strcat(s, "i");
if (crc32("vKBuNgcXAVfOd",13) == 245189100) strcat(s, "L");
if (crc32("tVHTSOklw",9) == 3348829260) strcat(s, "s");
if (crc32("wJsIwP",6) == 3977774115) strcat(s, "B");
if (crc32("PVwitYAUvwFVmnl",15) == 1947548536) strcat(s, "t");
if (crc32("kpYHuL",6) == 445790324) strcat(s, "I");
if (crc32("PiLQVpbhyEgbXi",14) == 2317442947) strcat(s, "r");
if (crc32("yFfLKdM",7) == 2401122096) strcat(s, "a");
if (crc32("kKmJoqYKfkpga",13) == 993575798) strcat(s, "n");
if (crc32("nAlwMcZMWHAHD",13) == 2878530899) strcat(s, "J");
if (crc32("tPSyBUrmEise",12) == 3307148017) strcat(s, "s");
if (crc32("OdNNFxVrtuqmXh",14) == 1725395122) strcat(s, "l");
if (crc32("UTqhUDDDsk",10) == 118340050) strcat(s, "a");
if (crc32("MFsAVgLGiPWA",12) == 3296877117) strcat(s, "e");
if (crc32("PNhJM",5) == 3250919394) strcat(s, "t");
if (crc32("UeMbRhsnQOlHzeh",15) == 3382574474) strcat(s, "i");
if (crc32("JqIKB",5) == 4093014065) strcat(s, "o");
if (crc32("NquFiAJGMzTJee",14) == 2140245465) strcat(s, "n");
    return s;
}

char *selfadulation_nouns() {
    char *s = calloc(14);
    if (crc32("vpaSzM",6) == 2780169070) strcat(s, "s");
if (crc32("yulBVt",6) == 364563703) strcat(s, "e");
if (crc32("HrGrgWZKQwrHpEq",15) == 1720402573) strcat(s, "F");
if (crc32("VTkufvHKINHMP",13) == 3553859719) strcat(s, "l");
if (crc32("YOFvCPnmKQ",10) == 2603175921) strcat(s, "s");
if (crc32("pRDadJo",7) == 2263773436) strcat(s, "f");
if (crc32("wiYjtHyMpE",10) == 1885793774) strcat(s, "C");
if (crc32("UUtHEt",6) == 1572904330) strcat(s, "a");
if (crc32("RprTvqMOcS",10) == 3503211961) strcat(s, "J");
if (crc32("VMjwaNdrDCTNCL",14) == 4148383769) strcat(s, "d");
if (crc32("iIMTxoaEDYLH",12) == 636585447) strcat(s, "u");
if (crc32("bGjoBbTwAA",10) == 3971232930) strcat(s, "l");
if (crc32("lmGHzPu",7) == 1341236042) strcat(s, "W");
if (crc32("lhtwwbPJtLY",11) == 1164567924) strcat(s, "a");
if (crc32("omBjhUqTSySCcO",14) == 479464619) strcat(s, "t");
if (crc32("AvhjUPpVa",9) == 3987880214) strcat(s, "i");
if (crc32("aPyhMj",6) == 1612417720) strcat(s, "p");
if (crc32("nAzxYYQhWt",10) == 2386501769) strcat(s, "o");
if (crc32("ydaEIwcEDNYkmBG",15) == 3269493575) strcat(s, "n");
    return s;
}

char *wantage_nouns() {
    char *s = calloc(8);
    if (crc32("iNWTWyerk",9) == 4175928826) strcat(s, "W");
if (crc32("PxsyWJUR",8) == 4287228406) strcat(s, "w");
if (crc32("KQObRrH",7) == 1560870327) strcat(s, "a");
if (crc32("fUzEkfl",7) == 96512535) strcat(s, "n");
if (crc32("oKOytssGOI",10) == 1284703465) strcat(s, "t");
if (crc32("ObMvom",6) == 1975112439) strcat(s, "X");
if (crc32("rbUwIWiWp",9) == 748217457) strcat(s, "a");
if (crc32("fuwDSuDjb",9) == 3052340159) strcat(s, "x");
if (crc32("crSVoP",6) == 2218244906) strcat(s, "g");
if (crc32("dfbfVzkuFIPMYqx",15) == 3705549812) strcat(s, "e");
    return s;
}

char *stereophotography_nouns() {
    char *s = calloc(18);
    if (crc32("zFDFknp",7) == 2696274036) strcat(s, "V");
if (crc32("txzDv",5) == 284068591) strcat(s, "s");
if (crc32("mxBKJWu",7) == 2999201826) strcat(s, "U");
if (crc32("MFGQziNqoAfMco",14) == 3374054393) strcat(s, "t");
if (crc32("SZlABJ",6) == 496314069) strcat(s, "e");
if (crc32("ZQBvFWWXXrUzrG",14) == 3190684141) strcat(s, "t");
if (crc32("zqcbsmmuejncwK",14) == 129648114) strcat(s, "r");
if (crc32("rSJzgnEGx",9) == 2588122072) strcat(s, "Q");
if (crc32("VAIUvGwAmkRLy",13) == 627542433) strcat(s, "e");
if (crc32("KOKrsyQd",8) == 4294750380) strcat(s, "Q");
if (crc32("TkYkia",6) == 3023194327) strcat(s, "o");
if (crc32("rcrbIm",6) == 946647349) strcat(s, "a");
if (crc32("PszwVrezrI",10) == 2579309153) strcat(s, "p");
if (crc32("JUyyU",5) == 2523823230) strcat(s, "h");
if (crc32("PdwZbjBatV",10) == 1573693641) strcat(s, "o");
if (crc32("RXXMYy",6) == 3434912270) strcat(s, "t");
if (crc32("NTkffEIHQL",10) == 591469362) strcat(s, "o");
if (crc32("kvfVwsu",7) == 1861522756) strcat(s, "g");
if (crc32("xsPfN",5) == 3094732135) strcat(s, "g");
if (crc32("NSdGVL",6) == 1417013605) strcat(s, "a");
if (crc32("oqdQbD",6) == 1938980140) strcat(s, "r");
if (crc32("UatKodWAhxaQk",13) == 1117130824) strcat(s, "a");
if (crc32("iblbvPGW",8) == 1119100508) strcat(s, "p");
if (crc32("tokkXJpXlyR",11) == 635495823) strcat(s, "h");
if (crc32("ODixtJ",6) == 589918862) strcat(s, "y");
    return s;
}

char *Aristippus_nouns() {
    char *s = calloc(11);
    if (crc32("bhHfeAZHoMQJn",13) == 3613673655) strcat(s, "A");
if (crc32("VzIvn",5) == 1469838569) strcat(s, "K");
if (crc32("RbsqOr",6) == 4129645245) strcat(s, "r");
if (crc32("EwJJySqWalqCBTR",15) == 2763279366) strcat(s, "i");
if (crc32("DGqoTzZWUByIwa",14) == 2410814270) strcat(s, "s");
if (crc32("yJmjXFVJeotWWue",15) == 1661036536) strcat(s, "h");
if (crc32("ZsOgZ",5) == 399482994) strcat(s, "t");
if (crc32("mvSaVgT",7) == 2607519210) strcat(s, "l");
if (crc32("troGwFSZf",9) == 3043150886) strcat(s, "i");
if (crc32("DLbBCbk",7) == 2016047860) strcat(s, "p");
if (crc32("JLdSAXa",7) == 3453538742) strcat(s, "F");
if (crc32("wTSUmXNGGdsZuu",14) == 2439476468) strcat(s, "p");
if (crc32("pwWIvY",6) == 3008440009) strcat(s, "u");
if (crc32("PdJxt",5) == 1817134926) strcat(s, "b");
if (crc32("JRQGzFYuoPgKfE",14) == 3842642628) strcat(s, "s");
    return s;
}

char *cachinnation_nouns() {
    char *s = calloc(13);
    if (crc32("cisnHGmciMyR",12) == 3532088140) strcat(s, "c");
if (crc32("KpqTY",5) == 3049489621) strcat(s, "M");
if (crc32("HSDamfSgI",9) == 531579807) strcat(s, "a");
if (crc32("fKeJzAGfoxRVnCy",15) == 929203500) strcat(s, "c");
if (crc32("MmhuiCeRJRlAnY",14) == 751915943) strcat(s, "h");
if (crc32("oetmO",5) == 4147096467) strcat(s, "S");
if (crc32("EOFxikeOTSDCYT",14) == 1159130646) strcat(s, "i");
if (crc32("IfKcpNGs",8) == 4281854541) strcat(s, "P");
if (crc32("wLBWDDGaJ",9) == 3906562497) strcat(s, "n");
if (crc32("aolItClVlq",10) == 4236739864) strcat(s, "q");
if (crc32("ZJbFEfcBCIKrrN",14) == 3371769774) strcat(s, "n");
if (crc32("xmuljR",6) == 810175724) strcat(s, "a");
if (crc32("BULNo",5) == 278578304) strcat(s, "S");
if (crc32("DomNC",5) == 3375678483) strcat(s, "t");
if (crc32("NgbAQwLLXyajUEG",15) == 4094450515) strcat(s, "i");
if (crc32("gUkoLYXz",8) == 1092083) strcat(s, "u");
if (crc32("AezdMmDjk",9) == 928563931) strcat(s, "o");
if (crc32("AGOPGa",6) == 3042120420) strcat(s, "n");
    return s;
}

char *Cahilly_nouns() {
    char *s = calloc(8);
    if (crc32("yfNOmFQEnyVs",12) == 617402886) strcat(s, "X");
if (crc32("XFpcy",5) == 1137110362) strcat(s, "C");
if (crc32("TnzMPAjtk",9) == 952146637) strcat(s, "a");
if (crc32("APpbfIwV",8) == 3361789985) strcat(s, "h");
if (crc32("AQYtAiw",7) == 1654272790) strcat(s, "i");
if (crc32("KcirfQXSAL",10) == 2806292165) strcat(s, "H");
if (crc32("vTiKslD",7) == 3014839717) strcat(s, "l");
if (crc32("qGLuPWxAD",9) == 3298197005) strcat(s, "y");
if (crc32("NiFjcIDQkNzE",12) == 2298461113) strcat(s, "l");
if (crc32("uGFzgSOf",8) == 3657129808) strcat(s, "j");
if (crc32("xMGPk",5) == 1945150002) strcat(s, "y");
    return s;
}

char *intoxicant_nouns() {
    char *s = calloc(11);
    if (crc32("AHnOCkigYsBxPw",14) == 3465070125) strcat(s, "i");
if (crc32("RWeEVuHDcnVH",12) == 14949208) strcat(s, "s");
if (crc32("YROOVvHLYOyU",12) == 3733560804) strcat(s, "n");
if (crc32("FvWagLgQ",8) == 3784964410) strcat(s, "s");
if (crc32("WzBTehxBlJA",11) == 1970768807) strcat(s, "t");
if (crc32("ECvueWZoDkA",11) == 4166718856) strcat(s, "l");
if (crc32("YNKdb",5) == 1443412319) strcat(s, "o");
if (crc32("vFDqmg",6) == 4190817930) strcat(s, "x");
if (crc32("uTdMTu",6) == 352335870) strcat(s, "i");
if (crc32("aetlD",5) == 2240401279) strcat(s, "c");
if (crc32("woQDGG",6) == 4012194924) strcat(s, "a");
if (crc32("FQPfaS",6) == 1684229169) strcat(s, "n");
if (crc32("fkhxOBYbEhU",11) == 4133784755) strcat(s, "t");
    return s;
}

char *persuasibility_nouns() {
    char *s = calloc(15);
    if (crc32("FhuBO",5) == 2568314405) strcat(s, "p");
if (crc32("FwOAIYcuwbJVq",13) == 40765443) strcat(s, "E");
if (crc32("hhukOEFUVFX",11) == 419501843) strcat(s, "e");
if (crc32("unfho",5) == 278540902) strcat(s, "r");
if (crc32("IcbEuSa",7) == 1958669280) strcat(s, "s");
if (crc32("ltsGN",5) == 106314182) strcat(s, "u");
if (crc32("VFcofI",6) == 3183123240) strcat(s, "c");
if (crc32("wjJzTiEcXsMVy",13) == 1807795820) strcat(s, "a");
if (crc32("dCYtd",5) == 1288837480) strcat(s, "a");
if (crc32("tVgOUiay",8) == 746975413) strcat(s, "s");
if (crc32("HZQinHPUkCrTdGv",15) == 681672312) strcat(s, "i");
if (crc32("MQMCp",5) == 3873665099) strcat(s, "b");
if (crc32("XyEsCoUSV",9) == 48663307) strcat(s, "i");
if (crc32("gfqcZXnmkc",10) == 4005601918) strcat(s, "j");
if (crc32("xcsTyYMr",8) == 1852493345) strcat(s, "l");
if (crc32("vWbItplL",8) == 1549451570) strcat(s, "j");
if (crc32("PuyRvP",6) == 3883883687) strcat(s, "i");
if (crc32("MRujPLsMUfWiPhx",15) == 963177322) strcat(s, "t");
if (crc32("lHMjBTEtMFWbTES",15) == 2303717448) strcat(s, "I");
if (crc32("eLjqLjctgvpwOmU",15) == 1036143643) strcat(s, "y");
    return s;
}

char *Eugnie_nouns() {
    char *s = calloc(7);
    if (crc32("pOOVMXwKIX",10) == 3520686018) strcat(s, "E");
if (crc32("cetWuf",6) == 2189865488) strcat(s, "z");
if (crc32("NdzYkSooz",9) == 3775213927) strcat(s, "u");
if (crc32("ODIKwWWXoUV",11) == 4126759836) strcat(s, "X");
if (crc32("gywfqLeP",8) == 525017580) strcat(s, "g");
if (crc32("UEhwxyYvXuoAoIi",15) == 1959237279) strcat(s, "n");
if (crc32("gSZHqspmcEPgTx",14) == 916957475) strcat(s, "j");
if (crc32("UcOoQ",5) == 2592945084) strcat(s, "i");
if (crc32("jyZfYCxDOjzI",12) == 2499762214) strcat(s, "e");
    return s;
}

char *dissection_nouns() {
    char *s = calloc(11);
    if (crc32("KXycruT",7) == 2413234772) strcat(s, "d");
if (crc32("iGvzN",5) == 1074490284) strcat(s, "i");
if (crc32("uRMPBDZkLTgYiS",14) == 1622207704) strcat(s, "Y");
if (crc32("ZIstCdymWHwpHlj",15) == 1317179485) strcat(s, "s");
if (crc32("qOVzeq",6) == 1547619371) strcat(s, "d");
if (crc32("rWZtSoRaRr",10) == 1412159847) strcat(s, "s");
if (crc32("IfKsO",5) == 1112332688) strcat(s, "r");
if (crc32("xLuomDQjvpFVsZ",14) == 1008311529) strcat(s, "e");
if (crc32("xMmUiQzDKwzCJ",13) == 4250886733) strcat(s, "c");
if (crc32("ctWYdJnfA",9) == 2384497274) strcat(s, "t");
if (crc32("LIADBuuZN",9) == 1867821068) strcat(s, "n");
if (crc32("MWOPcJqEoQtBBB",14) == 1608712049) strcat(s, "i");
if (crc32("dKhrkvJh",8) == 3852354614) strcat(s, "o");
if (crc32("iqiPJqnjVLCrR",13) == 2942600856) strcat(s, "f");
if (crc32("vHThdUiPDUXEGmb",15) == 851092752) strcat(s, "n");
    return s;
}

char *corncracker_nouns() {
    char *s = calloc(12);
    if (crc32("NaffRcOHPh",10) == 234593837) strcat(s, "c");
if (crc32("xIRxNtobxSdzUEk",15) == 4116342815) strcat(s, "O");
if (crc32("PdbSEDbMVGsbx",13) == 255755994) strcat(s, "o");
if (crc32("EoHVBnSkFAzYy",13) == 2272465868) strcat(s, "Z");
if (crc32("yyEZbsZqoCnZgMJ",15) == 4021059383) strcat(s, "r");
if (crc32("LKmwYbeIPDyjeFi",15) == 1921182040) strcat(s, "n");
if (crc32("TpfDqYVMxNrdTA",14) == 1492754432) strcat(s, "F");
if (crc32("XTwpgcHBbh",10) == 3732213086) strcat(s, "c");
if (crc32("bWoXTrMfII",10) == 650659335) strcat(s, "r");
if (crc32("aKoUHGr",7) == 1295607846) strcat(s, "a");
if (crc32("LegoPXt",7) == 1193238107) strcat(s, "c");
if (crc32("tYCwPNjDTtxg",12) == 737374119) strcat(s, "u");
if (crc32("ycgfLgOIrKUSPu",14) == 1049543434) strcat(s, "k");
if (crc32("vcyYot",6) == 1920760454) strcat(s, "e");
if (crc32("fPrSU",5) == 3334434176) strcat(s, "r");
    return s;
}

char *subdominant_nouns() {
    char *s = calloc(12);
    if (crc32("nbVYwl",6) == 3384765607) strcat(s, "s");
if (crc32("GCQSvZxgl",9) == 3215314682) strcat(s, "P");
if (crc32("KZqlE",5) == 3615285840) strcat(s, "u");
if (crc32("dmEuXKdoyQ",10) == 4197257618) strcat(s, "f");
if (crc32("BEDRTkzX",8) == 2118017144) strcat(s, "b");
if (crc32("rFkhjbOUQIachyb",15) == 393804974) strcat(s, "K");
if (crc32("GxCSxEWdnET",11) == 1358433680) strcat(s, "d");
if (crc32("TGdAuLknmP",10) == 2507420180) strcat(s, "R");
if (crc32("kojrHZ",6) == 2019780632) strcat(s, "o");
if (crc32("byFtdctEIgeMr",13) == 1206690234) strcat(s, "m");
if (crc32("AQuFJML",7) == 3739217829) strcat(s, "d");
if (crc32("xxMnWOrULk",10) == 3267094289) strcat(s, "i");
if (crc32("hjqEEgnsmxvLdz",14) == 3780017871) strcat(s, "n");
if (crc32("mpeFp",5) == 1954903049) strcat(s, "a");
if (crc32("LeCGpGM",7) == 2874043788) strcat(s, "n");
if (crc32("kRsdWUjzy",9) == 2926609103) strcat(s, "n");
if (crc32("enPrfLlb",8) == 2751792626) strcat(s, "t");
    return s;
}

char *Urissa_nouns() {
    char *s = calloc(7);
    if (crc32("rgiWdgm",7) == 3588747361) strcat(s, "k");
if (crc32("TkpZB",5) == 1809912614) strcat(s, "U");
if (crc32("xbZisgUeYuh",11) == 2493146455) strcat(s, "r");
if (crc32("OITHqm",6) == 1773598022) strcat(s, "D");
if (crc32("iUJStIAIuL",10) == 3897299466) strcat(s, "i");
if (crc32("dmNqamd",7) == 159223345) strcat(s, "l");
if (crc32("fsvGPQnmgu",10) == 2232843949) strcat(s, "s");
if (crc32("NFgdAFU",7) == 58022189) strcat(s, "s");
if (crc32("SsDDmoqYryZu",12) == 2057273005) strcat(s, "a");
    return s;
}

char *Klappvisier_nouns() {
    char *s = calloc(12);
    if (crc32("IOnayGGWOTsx",12) == 1330311804) strcat(s, "K");
if (crc32("RTTjHOtxyHdnH",13) == 1528400645) strcat(s, "l");
if (crc32("TwvkeSez",8) == 2856260571) strcat(s, "j");
if (crc32("SybOGIMORWUXg",13) == 3991382728) strcat(s, "a");
if (crc32("phENg",5) == 169808229) strcat(s, "p");
if (crc32("VpQjrZJFrV",10) == 1699724034) strcat(s, "E");
if (crc32("whinyKIHu",9) == 2185678291) strcat(s, "p");
if (crc32("aCuMNMNDe",9) == 1524726701) strcat(s, "v");
if (crc32("ZjOwPSYRZtaS",12) == 141110065) strcat(s, "G");
if (crc32("GERPxP",6) == 2998470621) strcat(s, "i");
if (crc32("VChOmld",7) == 2358583165) strcat(s, "U");
if (crc32("ksqKUdtxy",9) == 3960497809) strcat(s, "s");
if (crc32("MMgGtqTF",8) == 4249021966) strcat(s, "i");
if (crc32("kxANrbszQeAOlrG",15) == 3017138016) strcat(s, "n");
if (crc32("IHdlF",5) == 3561496069) strcat(s, "e");
if (crc32("ompQaGp",7) == 4153864345) strcat(s, "F");
if (crc32("kKIWcRZHiCnMDCd",15) == 1614156921) strcat(s, "r");
    return s;
}

char *Avice_nouns() {
    char *s = calloc(6);
    if (crc32("yxraS",5) == 1167727430) strcat(s, "A");
if (crc32("FrnNFzxevBh",11) == 1013641100) strcat(s, "x");
if (crc32("IYgTmiRiRw",10) == 314978880) strcat(s, "v");
if (crc32("ESAGfWzlD",9) == 4172487560) strcat(s, "i");
if (crc32("jDhjSbi",7) == 3605393268) strcat(s, "c");
if (crc32("PFBAlNfgcOiwh",13) == 618657795) strcat(s, "e");
    return s;
}

char *resect_nouns() {
    char *s = calloc(7);
    if (crc32("hXhBhroUItm",11) == 3108585501) strcat(s, "r");
if (crc32("wuRWbS",6) == 998835474) strcat(s, "e");
if (crc32("owfEbfwU",8) == 2912058101) strcat(s, "s");
if (crc32("aSRsHErjVSqP",12) == 4181814588) strcat(s, "e");
if (crc32("yYeXClyarAglkJo",15) == 186565676) strcat(s, "Z");
if (crc32("cDwHgcb",7) == 106784964) strcat(s, "c");
if (crc32("PSUaHVbPcJkxtUU",15) == 2739537206) strcat(s, "K");
if (crc32("YReFHIbLusqQP",13) == 23544412) strcat(s, "t");
    return s;
}

char *tariff_nouns() {
    char *s = calloc(7);
    if (crc32("VzGiCAAbjyWqok",14) == 3263198610) strcat(s, "t");
if (crc32("TzWNCumYGO",10) == 1344055934) strcat(s, "h");
if (crc32("frNdOpHhc",9) == 383671092) strcat(s, "a");
if (crc32("UdDVSkQjCW",10) == 750266349) strcat(s, "r");
if (crc32("hCexPwWTKrqfPyP",15) == 2871180845) strcat(s, "i");
if (crc32("vlbQoZ",6) == 2784059838) strcat(s, "i");
if (crc32("ScKoBtU",7) == 1847304074) strcat(s, "f");
if (crc32("waWEMHAW",8) == 1685326156) strcat(s, "f");
    return s;
}

char *cretinism_nouns() {
    char *s = calloc(10);
    if (crc32("RgyTVDKGANHlxEs",15) == 3886205154) strcat(s, "j");
if (crc32("kDZhbplsz",9) == 2334718188) strcat(s, "c");
if (crc32("AhGczulnsYw",11) == 1032136497) strcat(s, "r");
if (crc32("QrrJoBS",7) == 1513700245) strcat(s, "e");
if (crc32("VMahGDsHaLTEJqx",15) == 172610995) strcat(s, "t");
if (crc32("tRrRzxUVGmZCYoP",15) == 3785690580) strcat(s, "e");
if (crc32("GgcXLVh",7) == 252896935) strcat(s, "i");
if (crc32("EPGxKoDlKu",10) == 221267004) strcat(s, "n");
if (crc32("qNHPS",5) == 3486999472) strcat(s, "Q");
if (crc32("nUraVYruhqV",11) == 2995997429) strcat(s, "i");
if (crc32("vOKDAtuEC",9) == 1782497455) strcat(s, "e");
if (crc32("QHmuxtqe",8) == 4171100555) strcat(s, "s");
if (crc32("FZbsaH",6) == 3642353021) strcat(s, "m");
    return s;
}

char *noncarbon_nouns() {
    char *s = calloc(10);
    if (crc32("NxUBeg",6) == 496973070) strcat(s, "H");
if (crc32("zMmEFFuN",8) == 1347656322) strcat(s, "n");
if (crc32("haGhITAeNwtPoUx",15) == 1431880744) strcat(s, "P");
if (crc32("kNTUWCUwpIVXgw",14) == 3718967433) strcat(s, "o");
if (crc32("sdDSkApjfgjTPZA",15) == 2535365065) strcat(s, "n");
if (crc32("FsqDhXSzNIKGPy",14) == 3835178759) strcat(s, "c");
if (crc32("NJAsbTVbHJLme",13) == 907150646) strcat(s, "a");
if (crc32("qdSSSC",6) == 3557785682) strcat(s, "r");
if (crc32("nGEPXtFdCUszoj",14) == 120322819) strcat(s, "b");
if (crc32("oURqZPqpWUNBjFR",15) == 3599795304) strcat(s, "o");
if (crc32("OtXJZDLUNGsPGDh",15) == 1947487489) strcat(s, "U");
if (crc32("zjdUbtdyipB",11) == 2876409677) strcat(s, "n");
    return s;
}

char *tiro_nouns() {
    char *s = calloc(5);
    if (crc32("iVOjHOlr",8) == 4277266371) strcat(s, "f");
if (crc32("HiKklOrFVuXnv",13) == 2725658270) strcat(s, "t");
if (crc32("BhQmDsZaaweCrzI",15) == 2250851725) strcat(s, "i");
if (crc32("xZyEvZNrRQz",11) == 3292390282) strcat(s, "r");
if (crc32("lMmNfJHdhbURAyS",15) == 1193200640) strcat(s, "D");
if (crc32("aRLUgxIOq",9) == 3486217402) strcat(s, "o");
    return s;
}

char *Rossford_nouns() {
    char *s = calloc(9);
    if (crc32("GItPkQz",7) == 2755286646) strcat(s, "R");
if (crc32("rvKFmG",6) == 2169763729) strcat(s, "o");
if (crc32("hOuiLiSyVkKyHnL",15) == 3082170784) strcat(s, "s");
if (crc32("PNtdexXotvcW",12) == 4194271641) strcat(s, "n");
if (crc32("WWKvJPAfFq",10) == 758982000) strcat(s, "s");
if (crc32("IouTAfBtcg",10) == 344375831) strcat(s, "a");
if (crc32("eJWOmMsW",8) == 2523493241) strcat(s, "f");
if (crc32("cFPwEGIEti",10) == 894276312) strcat(s, "n");
if (crc32("jIgZfMpGATAK",12) == 1378540280) strcat(s, "o");
if (crc32("gMpioV",6) == 1208275235) strcat(s, "r");
if (crc32("XsoBwNqu",8) == 2136456929) strcat(s, "d");
    return s;
}

char *hen_nouns() {
    char *s = calloc(4);
    if (crc32("MowIHWVdjX",10) == 1311830147) strcat(s, "h");
if (crc32("QgTcZTRX",8) == 1756909127) strcat(s, "w");
if (crc32("yjqpxYrSiT",10) == 160306128) strcat(s, "e");
if (crc32("kWqtCIaVYLIZLyZ",15) == 2413961075) strcat(s, "n");
    return s;
}

char *Proudhon_nouns() {
    char *s = calloc(9);
    if (crc32("bTqwGTxfFLXz",12) == 4196330958) strcat(s, "P");
if (crc32("uNRiZzeeQMzeNPO",15) == 3019614825) strcat(s, "u");
if (crc32("FJWcOx",6) == 1341448348) strcat(s, "r");
if (crc32("lKVbygDTYmer",12) == 2443470952) strcat(s, "o");
if (crc32("DsfqOlX",7) == 1513113862) strcat(s, "i");
if (crc32("lITRUVVmbwbx",12) == 954287873) strcat(s, "u");
if (crc32("BLlfkJkrtNdfewk",15) == 3965891143) strcat(s, "d");
if (crc32("MGdrYYE",7) == 164302516) strcat(s, "h");
if (crc32("veTSXhEC",8) == 345623929) strcat(s, "o");
if (crc32("mhxzNGtcxRiDk",13) == 2537185040) strcat(s, "m");
if (crc32("ETpMZThkXeqlp",13) == 559072430) strcat(s, "n");
    return s;
}

char *railwayman_nouns() {
    char *s = calloc(11);
    if (crc32("mFham",5) == 283025051) strcat(s, "r");
if (crc32("tseYdsvoThBuU",13) == 2865357591) strcat(s, "q");
if (crc32("lXAmVwEhJzYnTE",14) == 3707531086) strcat(s, "a");
if (crc32("HMERejefRr",10) == 1661531905) strcat(s, "F");
if (crc32("ZlFYoAX",7) == 3406848248) strcat(s, "i");
if (crc32("YOVtxNFxCr",10) == 621741719) strcat(s, "p");
if (crc32("ZfMRjJUzMk",10) == 3845742113) strcat(s, "l");
if (crc32("lCVnQdkwLlUvex",14) == 1558941494) strcat(s, "Z");
if (crc32("VGmITDiwSrXfBVb",15) == 3423088480) strcat(s, "w");
if (crc32("iLqTIBHvwEJTNH",14) == 483206200) strcat(s, "V");
if (crc32("PTBHlVK",7) == 420960093) strcat(s, "a");
if (crc32("KkYpDDAASa",10) == 1032749723) strcat(s, "y");
if (crc32("CUJMduAuoyBCa",13) == 2179293934) strcat(s, "U");
if (crc32("plqcBRtKF",9) == 3379345923) strcat(s, "m");
if (crc32("VjyljgJK",8) == 1540949395) strcat(s, "a");
if (crc32("QoZCWQ",6) == 3379840577) strcat(s, "x");
if (crc32("uadVgA",6) == 3110984988) strcat(s, "n");
    return s;
}

char *electrosurgery_nouns() {
    char *s = calloc(15);
    if (crc32("wkvXqtdoEoosPJ",14) == 2114276413) strcat(s, "e");
if (crc32("aLzEkLDZmJjy",12) == 2345955252) strcat(s, "l");
if (crc32("yUUaGJhhonOnK",13) == 631660518) strcat(s, "I");
if (crc32("HxtswbVSPVp",11) == 3208836877) strcat(s, "e");
if (crc32("aIMZwgp",7) == 3073262140) strcat(s, "c");
if (crc32("sLaNNVaG",8) == 1738120985) strcat(s, "t");
if (crc32("keLUf",5) == 1051045800) strcat(s, "r");
if (crc32("fOjgT",5) == 320184016) strcat(s, "v");
if (crc32("adCozgjtPKJjYa",14) == 3374264586) strcat(s, "o");
if (crc32("pgsOHg",6) == 2026435398) strcat(s, "s");
if (crc32("adoNVojx",8) == 3792911497) strcat(s, "I");
if (crc32("QYejejBM",8) == 1120020541) strcat(s, "u");
if (crc32("PHdbOZ",6) == 3599183590) strcat(s, "r");
if (crc32("rELkmQPmrDp",11) == 1341426597) strcat(s, "g");
if (crc32("SEqFAgjlfL",10) == 3556791317) strcat(s, "e");
if (crc32("YUNHtXK",7) == 800954488) strcat(s, "G");
if (crc32("ifMxVioK",8) == 2458902587) strcat(s, "r");
if (crc32("XPuWa",5) == 3118529178) strcat(s, "t");
if (crc32("oeOcPcnIoILHN",13) == 464822412) strcat(s, "y");
    return s;
}

char *Haynes_nouns() {
    char *s = calloc(7);
    if (crc32("pPYrjApZq",9) == 4060568676) strcat(s, "Y");
if (crc32("BLNZrd",6) == 593987025) strcat(s, "H");
if (crc32("GfMWcFuVVkg",11) == 3117826917) strcat(s, "a");
if (crc32("FSfUX",5) == 638533117) strcat(s, "y");
if (crc32("AwDtbhK",7) == 660616049) strcat(s, "n");
if (crc32("HRlHTnI",7) == 912760435) strcat(s, "e");
if (crc32("AykRg",5) == 1489616903) strcat(s, "P");
if (crc32("GjySaPqUVzl",11) == 894648278) strcat(s, "s");
    return s;
}

char *Teutonist_nouns() {
    char *s = calloc(10);
    if (crc32("FQbfOnOApludiFN",15) == 852848270) strcat(s, "k");
if (crc32("WlVDDkeSoaMmkh",14) == 3226692367) strcat(s, "T");
if (crc32("kSRxsMcneD",10) == 1726138254) strcat(s, "e");
if (crc32("Wyrhbz",6) == 1321539873) strcat(s, "p");
if (crc32("pVicetvfMsmm",12) == 271886871) strcat(s, "u");
if (crc32("XzSBKhQifE",10) == 3917631617) strcat(s, "t");
if (crc32("lBlviKiEsNVnwSL",15) == 3367326361) strcat(s, "o");
if (crc32("wVvDui",6) == 1331112098) strcat(s, "n");
if (crc32("VUNpPUUWGFozsz",14) == 214813824) strcat(s, "i");
if (crc32("SAPVFrvQDLxQ",12) == 1171987861) strcat(s, "s");
if (crc32("vXCqb",5) == 3720296437) strcat(s, "E");
if (crc32("MxfTehOU",8) == 1038055501) strcat(s, "t");
    return s;
}

char *boardandshingle_nouns() {
    char *s = calloc(16);
    if (crc32("RUbEGBffLKqY",12) == 1866007442) strcat(s, "V");
if (crc32("LiZVD",5) == 3782487777) strcat(s, "b");
if (crc32("ZyKZMBkGoqlr",12) == 655167300) strcat(s, "o");
if (crc32("SpnZCMTMECioY",13) == 2891400675) strcat(s, "o");
if (crc32("QbbAijAIpNesqv",14) == 3443477263) strcat(s, "E");
if (crc32("yoMzBOD",7) == 3432096996) strcat(s, "a");
if (crc32("NAeISCWvBbcY",12) == 970403814) strcat(s, "M");
if (crc32("wmBCG",5) == 74347847) strcat(s, "r");
if (crc32("IPHQMm",6) == 3042491661) strcat(s, "K");
if (crc32("hGhOtAAEd",9) == 4258186876) strcat(s, "d");
if (crc32("uyRudgnv",8) == 3219459275) strcat(s, "A");
if (crc32("bbhFXJGQMoD",11) == 1919495352) strcat(s, "a");
if (crc32("LVSezmjXcWywhQC",15) == 1475470599) strcat(s, "n");
if (crc32("OXONxmVQnrHs",12) == 3052283171) strcat(s, "d");
if (crc32("MJbYEZJkZ",9) == 37228615) strcat(s, "s");
if (crc32("mfcgCYShM",9) == 2431360033) strcat(s, "h");
if (crc32("nrIjlTlAD",9) == 3783580534) strcat(s, "l");
if (crc32("UoWWkObqthlEcV",14) == 1082351390) strcat(s, "i");
if (crc32("YTHELBnqCn",10) == 3225634296) strcat(s, "n");
if (crc32("UdPOdNr",7) == 3213376998) strcat(s, "x");
if (crc32("IBJSIYpixOe",11) == 2582508161) strcat(s, "g");
if (crc32("GnWXpZdnBweJE",13) == 2541563586) strcat(s, "b");
if (crc32("RcoReHKcu",9) == 3312654575) strcat(s, "l");
if (crc32("xOYsCRmVvWDNyp",14) == 3781319125) strcat(s, "e");
    return s;
}

char *Hasmonean_nouns() {
    char *s = calloc(10);
    if (crc32("tvsALCVTdhvRyFh",15) == 2091631625) strcat(s, "h");
if (crc32("XXwuRyl",7) == 2941881175) strcat(s, "H");
if (crc32("BxZZr",5) == 3589176047) strcat(s, "a");
if (crc32("YYHrfLf",7) == 491921996) strcat(s, "s");
if (crc32("KUapyYarZXImpY",14) == 1641955799) strcat(s, "r");
if (crc32("MySdtQs",7) == 1715392158) strcat(s, "m");
if (crc32("ZWBnfHARclvGmg",14) == 1460080401) strcat(s, "w");
if (crc32("NkIrwtbZR",9) == 3412884970) strcat(s, "o");
if (crc32("KDvwuVJZs",9) == 2777104260) strcat(s, "n");
if (crc32("EKDmox",6) == 699812443) strcat(s, "e");
if (crc32("NuxYRBpTc",9) == 1648522608) strcat(s, "a");
if (crc32("GGHesBgUc",9) == 2180995740) strcat(s, "a");
if (crc32("xJueXlaasAKaG",13) == 1484784632) strcat(s, "n");
    return s;
}

char *Gant_nouns() {
    char *s = calloc(5);
    if (crc32("wRjDYophRqeap",13) == 298053838) strcat(s, "G");
if (crc32("tUADOMZEctsvs",13) == 3873716252) strcat(s, "a");
if (crc32("DgsrTa",6) == 3296999510) strcat(s, "n");
if (crc32("dufDo",5) == 4080220004) strcat(s, "t");
    return s;
}

char *constriction_nouns() {
    char *s = calloc(13);
    if (crc32("amWMpLVMOZGC",12) == 2156500796) strcat(s, "c");
if (crc32("yMnkPsDGDxmGf",13) == 1762472725) strcat(s, "x");
if (crc32("rxKqtE",6) == 1783198417) strcat(s, "o");
if (crc32("jBXyVVSD",8) == 3572657945) strcat(s, "b");
if (crc32("yAeDMRfbhfgvbi",14) == 2034833874) strcat(s, "n");
if (crc32("fEnhJgamOTZJ",12) == 3429195861) strcat(s, "j");
if (crc32("WPhHSqd",7) == 2457022961) strcat(s, "s");
if (crc32("oAkWs",5) == 2258429709) strcat(s, "t");
if (crc32("MKgVjyHOxNYW",12) == 1914957276) strcat(s, "k");
if (crc32("hsqHmSNHeKVD",12) == 2817491789) strcat(s, "r");
if (crc32("oeWQpePuINwMKd",14) == 273729175) strcat(s, "K");
if (crc32("FlZHN",5) == 2827882675) strcat(s, "i");
if (crc32("ohWoDh",6) == 4066672818) strcat(s, "f");
if (crc32("glOuwBqnJ",9) == 4064842876) strcat(s, "c");
if (crc32("AODQNGNiF",9) == 1239450810) strcat(s, "C");
if (crc32("ITMiXtRzGqWDsm",14) == 3927100405) strcat(s, "t");
if (crc32("QSlXXe",6) == 1952146100) strcat(s, "h");
if (crc32("UojQqZ",6) == 1922857926) strcat(s, "i");
if (crc32("HRRFcSECaqdxgB",14) == 999469970) strcat(s, "j");
if (crc32("sazvf",5) == 2132282111) strcat(s, "o");
if (crc32("VPJsevnUyY",10) == 3340056846) strcat(s, "Y");
if (crc32("aUwpAXquZhzeNX",14) == 1508355427) strcat(s, "n");
    return s;
}

char *plastral_nouns() {
    char *s = calloc(9);
    if (crc32("SktjiJTFdo",10) == 3105841938) strcat(s, "p");
if (crc32("OejRZyaJJIhDXGo",15) == 2042694976) strcat(s, "h");
if (crc32("EPSqlT",6) == 4286703322) strcat(s, "l");
if (crc32("JfAHPpanLG",10) == 3458585167) strcat(s, "h");
if (crc32("hdpvLnwziGC",11) == 718146846) strcat(s, "a");
if (crc32("GvrttALMEu",10) == 465982958) strcat(s, "s");
if (crc32("rlEnsUhQUSvEJY",14) == 2974992425) strcat(s, "a");
if (crc32("LocirofUFoHUwXV",15) == 3686201207) strcat(s, "t");
if (crc32("JnaJhazQgaXOb",13) == 4011762306) strcat(s, "T");
if (crc32("VHnOVQpmQwxi",12) == 2280760147) strcat(s, "r");
if (crc32("kxChRXcpw",9) == 829108439) strcat(s, "a");
if (crc32("DjlujWSlQIF",11) == 3108107860) strcat(s, "k");
if (crc32("qiqBmgno",8) == 1528584839) strcat(s, "l");
    return s;
}

char *jersey_nouns() {
    char *s = calloc(7);
    if (crc32("NJuXmAfrYPRWYGw",15) == 1773359299) strcat(s, "j");
if (crc32("AyVHQWomElwWyKD",15) == 1980845890) strcat(s, "x");
if (crc32("PGWxfarFbimdwB",14) == 3408079392) strcat(s, "e");
if (crc32("thqIuXdg",8) == 2174236518) strcat(s, "p");
if (crc32("FEFTDhM",7) == 2753874016) strcat(s, "r");
if (crc32("MMcWVlKYpq",10) == 3193303982) strcat(s, "s");
if (crc32("VwYSJCCWRmoavEp",15) == 3721522540) strcat(s, "e");
if (crc32("SeyUPWUbLzIh",12) == 3966247950) strcat(s, "e");
if (crc32("YcscXth",7) == 1479927436) strcat(s, "y");
    return s;
}

char *Daigle_nouns() {
    char *s = calloc(7);
    if (crc32("ijbcVLYOOp",10) == 2186693577) strcat(s, "D");
if (crc32("UwBTlC",6) == 4219211111) strcat(s, "b");
if (crc32("UenZaPZfNEvL",12) == 1505393954) strcat(s, "a");
if (crc32("bsWlQmGJMwxgDvG",15) == 3617926735) strcat(s, "i");
if (crc32("kBHIjburtsDkUC",14) == 1166766487) strcat(s, "o");
if (crc32("nLIDdCZUyuSK",12) == 3473208733) strcat(s, "g");
if (crc32("trfRpUH",7) == 1302260135) strcat(s, "J");
if (crc32("ZmLqjgzmQ",9) == 3915682333) strcat(s, "l");
if (crc32("hAKcKdluOqxRdKk",15) == 2893029664) strcat(s, "e");
    return s;
}

char *Squier_nouns() {
    char *s = calloc(7);
    if (crc32("qtSbTHFjmzEW",12) == 3998696220) strcat(s, "S");
if (crc32("hpUfuMYQlck",11) == 3351347135) strcat(s, "q");
if (crc32("GQDWxX",6) == 1497342059) strcat(s, "u");
if (crc32("xzfAUQBV",8) == 945497542) strcat(s, "i");
if (crc32("CofjPQytLck",11) == 618443495) strcat(s, "y");
if (crc32("nqLBBDQ",7) == 3521290641) strcat(s, "e");
if (crc32("jcEBGKkKk",9) == 3350319191) strcat(s, "l");
if (crc32("iUmJL",5) == 2602627062) strcat(s, "r");
    return s;
}

char *Therron_nouns() {
    char *s = calloc(8);
    if (crc32("GPQEvqgPzLLk",12) == 1625024849) strcat(s, "E");
if (crc32("JnUFqZywvZgT",12) == 3100862667) strcat(s, "T");
if (crc32("TqGkwhDCJu",10) == 1259371887) strcat(s, "e");
if (crc32("HAhYogdSiJIkjkZ",15) == 2430254136) strcat(s, "h");
if (crc32("enVJwWPSyOE",11) == 1847690765) strcat(s, "b");
if (crc32("JsIiomaOyarhz",13) == 2108111175) strcat(s, "e");
if (crc32("pNaeOl",6) == 947103210) strcat(s, "K");
if (crc32("yTdqlDt",7) == 1308760947) strcat(s, "r");
if (crc32("MCDkWFQxx",9) == 3143740765) strcat(s, "s");
if (crc32("nUHtNNQUvV",10) == 3322173173) strcat(s, "r");
if (crc32("MOWUJnOUUlJncGG",15) == 3556851957) strcat(s, "V");
if (crc32("EFYUjMqGBMZcBtB",15) == 995165080) strcat(s, "o");
if (crc32("TnvzVE",6) == 4256857957) strcat(s, "n");
    return s;
}

char *father_nouns() {
    char *s = calloc(7);
    if (crc32("PspDgliZYo",10) == 4013282959) strcat(s, "G");
if (crc32("QPANRAfuGeQnFq",14) == 1648844679) strcat(s, "f");
if (crc32("LEVMZqqAzPtLkzi",15) == 657138410) strcat(s, "a");
if (crc32("xNkjjVBW",8) == 3036178344) strcat(s, "t");
if (crc32("BFVIaegwUaZA",12) == 818816506) strcat(s, "h");
if (crc32("reQmN",5) == 2769672807) strcat(s, "r");
if (crc32("OMNzMrfe",8) == 101182923) strcat(s, "e");
if (crc32("ucFbUd",6) == 1283466419) strcat(s, "r");
    return s;
}

char *diffidentness_nouns() {
    char *s = calloc(14);
    if (crc32("XDGfLAXev",9) == 2696749716) strcat(s, "d");
if (crc32("ZCbFoUeAzYbIeEi",15) == 1286967857) strcat(s, "i");
if (crc32("ewNzPLGcLXyje",13) == 2434523809) strcat(s, "p");
if (crc32("KIusPHGMYFnfqal",15) == 525744336) strcat(s, "f");
if (crc32("ibukSmCexh",10) == 1941932074) strcat(s, "z");
if (crc32("rufQnzTorpTTo",13) == 2160664103) strcat(s, "f");
if (crc32("OQSHgRw",7) == 3264922265) strcat(s, "i");
if (crc32("MVNQzWfGwXOP",12) == 3340358236) strcat(s, "d");
if (crc32("PnWcJFMM",8) == 3918556043) strcat(s, "e");
if (crc32("jIugoNUhPlOiGEi",15) == 2454928151) strcat(s, "n");
if (crc32("EawStgwDJPPxX",13) == 2045039141) strcat(s, "P");
if (crc32("AUnUrr",6) == 2545508318) strcat(s, "t");
if (crc32("EoJXc",5) == 4003473625) strcat(s, "n");
if (crc32("xKkbxzzJN",9) == 448581886) strcat(s, "e");
if (crc32("ACdrRP",6) == 3025502558) strcat(s, "A");
if (crc32("oxZkf",5) == 808993429) strcat(s, "s");
if (crc32("xRHyxCQSbl",10) == 4097596704) strcat(s, "e");
if (crc32("KNQpFVuiEH",10) == 1725460030) strcat(s, "s");
    return s;
}

char *Verlee_nouns() {
    char *s = calloc(7);
    if (crc32("QWnMVQaqoJkwKE",14) == 130515226) strcat(s, "V");
if (crc32("PNsXVNQL",8) == 3914156276) strcat(s, "e");
if (crc32("ClZIzYd",7) == 2076578236) strcat(s, "r");
if (crc32("yeFGhQVOyeCLjX",14) == 1461506363) strcat(s, "l");
if (crc32("iYbZcNrY",8) == 2004728741) strcat(s, "e");
if (crc32("OlYMUlsp",8) == 4238066436) strcat(s, "x");
if (crc32("ccCIrHFizmjJ",12) == 1941431239) strcat(s, "e");
    return s;
}

char *Pardo_nouns() {
    char *s = calloc(6);
    if (crc32("CMgSs",5) == 2769135312) strcat(s, "P");
if (crc32("ooyLhouVuZI",11) == 699680862) strcat(s, "a");
if (crc32("iSkFlUamjrDaBi",14) == 2831799514) strcat(s, "h");
if (crc32("XEnimXEIKQGk",12) == 3435271672) strcat(s, "r");
if (crc32("OAgtTHiUAwO",11) == 3832723602) strcat(s, "d");
if (crc32("MNoDiVvF",8) == 1603966249) strcat(s, "o");
    return s;
}

char *Adala_nouns() {
    char *s = calloc(6);
    if (crc32("NSqxUmn",7) == 3381155361) strcat(s, "B");
if (crc32("rdMqZqraM",9) == 193024007) strcat(s, "A");
if (crc32("AOWHW",5) == 1850091166) strcat(s, "N");
if (crc32("ItYwvDNzZgyg",12) == 3513726921) strcat(s, "d");
if (crc32("TtVoqjPPqUMI",12) == 3036780624) strcat(s, "a");
if (crc32("yonknAAT",8) == 1478151622) strcat(s, "l");
if (crc32("XOxvmaTZjDg",11) == 4046865649) strcat(s, "n");
if (crc32("VjUIrAHKAGu",11) == 1177845812) strcat(s, "a");
    return s;
}

char *inflammability_nouns() {
    char *s = calloc(15);
    if (crc32("pCzIUDIEYPkRs",13) == 3219008802) strcat(s, "q");
if (crc32("umSVWmJcCehJl",13) == 1665094147) strcat(s, "i");
if (crc32("CFYVC",5) == 797641446) strcat(s, "r");
if (crc32("QPyDjRPiZYZ",11) == 187020381) strcat(s, "n");
if (crc32("MuaiTLMECkuI",12) == 1978686814) strcat(s, "f");
if (crc32("QmwRWRJPjmjUIu",14) == 2728850146) strcat(s, "Z");
if (crc32("jZHSjFjAt",9) == 2162908231) strcat(s, "l");
if (crc32("jAOyBARqlKsPXOG",15) == 4055538015) strcat(s, "A");
if (crc32("MGwvtJnH",8) == 747297762) strcat(s, "a");
if (crc32("LMRdeNtbJBVO",12) == 1093833814) strcat(s, "o");
if (crc32("JeXvuBxgfBFugu",14) == 3064014422) strcat(s, "m");
if (crc32("ubvtqAdYZt",10) == 2527017386) strcat(s, "m");
if (crc32("PJnjMdm",7) == 674458717) strcat(s, "a");
if (crc32("QhMtJsdKj",9) == 3786771315) strcat(s, "h");
if (crc32("FeXgnn",6) == 725893233) strcat(s, "b");
if (crc32("uyptYypZmAiI",12) == 1128179746) strcat(s, "e");
if (crc32("pYhbhEZCTc",10) == 2090980066) strcat(s, "i");
if (crc32("BhUlxNOcJcj",11) == 3476638851) strcat(s, "h");
if (crc32("KdlgJpZukjUhT",13) == 1025236907) strcat(s, "l");
if (crc32("YoZGYtxR",8) == 3675506631) strcat(s, "c");
if (crc32("TJmzJFPBPFiCJY",14) == 2549266430) strcat(s, "i");
if (crc32("hqzggTWkTzZRNjQ",15) == 1773277908) strcat(s, "w");
if (crc32("KfiYqucM",8) == 609215278) strcat(s, "t");
if (crc32("oWmGzB",6) == 868747948) strcat(s, "y");
    return s;
}

char *cobra_nouns() {
    char *s = calloc(6);
    if (crc32("gCUciONg",8) == 1872081836) strcat(s, "G");
if (crc32("plmaQwCfOpZDiQM",15) == 3805210165) strcat(s, "c");
if (crc32("wftYUVyrYCeoE",13) == 2258448346) strcat(s, "o");
if (crc32("eLEsuHOikzhJ",12) == 3521099873) strcat(s, "b");
if (crc32("HcQEBIYlyo",10) == 2035754388) strcat(s, "q");
if (crc32("KHNUBcMaIcfTU",13) == 97811090) strcat(s, "r");
if (crc32("lcPwfcYmU",9) == 2685823526) strcat(s, "a");
    return s;
}

char *ganosis_nouns() {
    char *s = calloc(8);
    if (crc32("gdRiQVvolvu",11) == 2247768220) strcat(s, "a");
if (crc32("wNizB",5) == 4229932451) strcat(s, "g");
if (crc32("vXWlvClPdljWJC",14) == 770116605) strcat(s, "a");
if (crc32("twdVtsh",7) == 560937370) strcat(s, "u");
if (crc32("jmIGIjouznN",11) == 2693784996) strcat(s, "n");
if (crc32("aidEzZrlJFQcIv",14) == 1287299609) strcat(s, "d");
if (crc32("wNbEYFZ",7) == 2151257011) strcat(s, "o");
if (crc32("lGpjPKAn",8) == 2404248496) strcat(s, "d");
if (crc32("EgokqbBkqKokX",13) == 4111689385) strcat(s, "s");
if (crc32("bGhzxWiK",8) == 3016539825) strcat(s, "i");
if (crc32("CsyWqNP",7) == 1285321090) strcat(s, "Z");
if (crc32("ZUEynZRfkJNjBIG",15) == 1278178326) strcat(s, "s");
    return s;
}

char *cameraman_nouns() {
    char *s = calloc(10);
    if (crc32("fdkCSGiY",8) == 3099086894) strcat(s, "I");
if (crc32("SXDeISwXqJ",10) == 1878323373) strcat(s, "c");
if (crc32("XLYPFCdtPGqGq",13) == 3313144036) strcat(s, "a");
if (crc32("iyooqFQdaMvs",12) == 2351607155) strcat(s, "P");
if (crc32("EzkmVRkjFtPkVo",14) == 2001984383) strcat(s, "m");
if (crc32("JmSSLRgzVwpVV",13) == 700449968) strcat(s, "t");
if (crc32("SWliEW",6) == 4280028962) strcat(s, "e");
if (crc32("zjXRtkcfGYhNSz",14) == 3237068813) strcat(s, "V");
if (crc32("HzxNnoyHDjOw",12) == 3061770018) strcat(s, "r");
if (crc32("SxmUJRaKGjSDoS",14) == 632355993) strcat(s, "a");
if (crc32("XrobeRKaJ",9) == 2955402665) strcat(s, "W");
if (crc32("JHjtK",5) == 1708961083) strcat(s, "m");
if (crc32("zcaGqffXYlfmv",13) == 2773789030) strcat(s, "a");
if (crc32("MihcsUEus",9) == 1295621976) strcat(s, "f");
if (crc32("gMbPMWoOU",9) == 2783357835) strcat(s, "n");
    return s;
}

char *Miss_nouns() {
    char *s = calloc(5);
    if (crc32("AgyLzhFEVVQ",11) == 3204662833) strcat(s, "x");
if (crc32("PGWVuQ",6) == 659596485) strcat(s, "M");
if (crc32("mooMhyUdzUGt",12) == 3449803937) strcat(s, "i");
if (crc32("KjRLaMZvDt",10) == 2354049194) strcat(s, "s");
if (crc32("oAHJcOMGwqPZy",13) == 2762958911) strcat(s, "M");
if (crc32("TAmYsmvDysI",11) == 1860268323) strcat(s, "s");
    return s;
}

char *Atalie_nouns() {
    char *s = calloc(7);
    if (crc32("YMZbCQCGTKM",11) == 3759849375) strcat(s, "G");
if (crc32("HZYoQl",6) == 843084699) strcat(s, "A");
if (crc32("siUzrTcJnc",10) == 1063655779) strcat(s, "v");
if (crc32("GdbPkkjFGEZh",12) == 1897971373) strcat(s, "t");
if (crc32("cnuzllbDQto",11) == 2453360241) strcat(s, "l");
if (crc32("gImpdZRMRtblEO",14) == 2975363814) strcat(s, "a");
if (crc32("NiyiFi",6) == 3553554757) strcat(s, "l");
if (crc32("XuUUemDqKCh",11) == 3879205206) strcat(s, "l");
if (crc32("bgtHLginboTmwKg",15) == 841002561) strcat(s, "i");
if (crc32("PqAxPFX",7) == 451940050) strcat(s, "e");
    return s;
}

char *stepmother_nouns() {
    char *s = calloc(11);
    if (crc32("XelTjQv",7) == 2453934612) strcat(s, "s");
if (crc32("qkeQssq",7) == 1666378413) strcat(s, "F");
if (crc32("bzmzWVBJNG",10) == 1013572419) strcat(s, "t");
if (crc32("EvmlzxChw",9) == 2165599809) strcat(s, "e");
if (crc32("xSyuQZNaMP",10) == 490513720) strcat(s, "X");
if (crc32("ywCIEX",6) == 3360285295) strcat(s, "p");
if (crc32("rnElMQo",7) == 1934626182) strcat(s, "m");
if (crc32("VPcPZU",6) == 1300030330) strcat(s, "m");
if (crc32("twkAe",5) == 2896225893) strcat(s, "o");
if (crc32("APzWAdBgEMgQuy",14) == 2177448703) strcat(s, "t");
if (crc32("aeDroi",6) == 1873929746) strcat(s, "d");
if (crc32("cpcKbkqeqKXOvu",14) == 1076803541) strcat(s, "h");
if (crc32("OooMzrNSHVrYS",13) == 981118411) strcat(s, "e");
if (crc32("YIDTz",5) == 959381989) strcat(s, "D");
if (crc32("UKsgyexyyCOq",12) == 1110609194) strcat(s, "r");
    return s;
}

char *enigma_nouns() {
    char *s = calloc(7);
    if (crc32("UwjNCtzDjyO",11) == 3455754275) strcat(s, "n");
if (crc32("PSMgWvw",7) == 3972406536) strcat(s, "e");
if (crc32("fjFeKaenk",9) == 1884077410) strcat(s, "t");
if (crc32("yHzVs",5) == 281752227) strcat(s, "n");
if (crc32("zhfKcr",6) == 3403422904) strcat(s, "a");
if (crc32("OqySjfEvCL",10) == 760518941) strcat(s, "i");
if (crc32("OTMunguIaRgR",12) == 3862072170) strcat(s, "g");
if (crc32("hleGXkz",7) == 2858198894) strcat(s, "U");
if (crc32("INlyWn",6) == 192315527) strcat(s, "m");
if (crc32("aCDkJfFTJlD",11) == 3914461193) strcat(s, "a");
    return s;
}

char *hydria_nouns() {
    char *s = calloc(7);
    if (crc32("GlZZnlMEPZ",10) == 3855298764) strcat(s, "D");
if (crc32("UXbPazeArY",10) == 3337797142) strcat(s, "h");
if (crc32("QeFbLdbCmxDR",12) == 3860910597) strcat(s, "I");
if (crc32("tDBllDqaRQrfvf",14) == 3366549889) strcat(s, "y");
if (crc32("gAmlBmapnMUnTyj",15) == 2160250301) strcat(s, "d");
if (crc32("euvNZXAJjz",10) == 3703977873) strcat(s, "F");
if (crc32("zsxMjRYSXgOZt",13) == 3554646152) strcat(s, "r");
if (crc32("cQfJdcFtjMNyh",13) == 3213177108) strcat(s, "i");
if (crc32("HIOEHUih",8) == 3661737689) strcat(s, "L");
if (crc32("TkJoJZHfiDcpHYs",15) == 3345914849) strcat(s, "a");
    return s;
}

char *hedonist_nouns() {
    char *s = calloc(9);
    if (crc32("LvlkrR",6) == 4128403391) strcat(s, "f");
if (crc32("iFoMXirTt",9) == 2810470477) strcat(s, "h");
if (crc32("zGRwzGvBTQQciQ",14) == 3479733113) strcat(s, "e");
if (crc32("swHYMaZQkv",10) == 3515538885) strcat(s, "D");
if (crc32("FYFBFc",6) == 3795411782) strcat(s, "d");
if (crc32("ARYbbtKp",8) == 2104721504) strcat(s, "o");
if (crc32("YLyPbrWCBTIMxWF",15) == 110429882) strcat(s, "z");
if (crc32("lMuuXDYtrshXXMS",15) == 437143911) strcat(s, "n");
if (crc32("bsiRnTTUKvOjXd",14) == 2891253954) strcat(s, "l");
if (crc32("AQgqhGF",7) == 638628282) strcat(s, "i");
if (crc32("PcBmNDjIH",9) == 178884136) strcat(s, "J");
if (crc32("jEarAmVJRFUG",12) == 58358939) strcat(s, "s");
if (crc32("AQvijYsnRafkXi",14) == 558545661) strcat(s, "t");
    return s;
}

char *Breanne_nouns() {
    char *s = calloc(8);
    if (crc32("PGVeBmQlpvmgyl",14) == 346459797) strcat(s, "Z");
if (crc32("wiuOFafjO",9) == 2620592934) strcat(s, "B");
if (crc32("dzyHNarOZtZqePO",15) == 2229204165) strcat(s, "I");
if (crc32("WfFLDNKiTJRDWTD",15) == 45969888) strcat(s, "r");
if (crc32("ajohKIS",7) == 1394875712) strcat(s, "e");
if (crc32("mEErcNX",7) == 2547323956) strcat(s, "v");
if (crc32("kHIMGNIFPGYuBkP",15) == 2314794344) strcat(s, "a");
if (crc32("cXMEbVhGcvGzYun",15) == 593379481) strcat(s, "z");
if (crc32("JENZfmQVyBDtx",13) == 2521654210) strcat(s, "n");
if (crc32("tGzkNrDVrlXxjD",14) == 1277839582) strcat(s, "n");
if (crc32("UeLrQLjTjStfgI",14) == 1350823448) strcat(s, "v");
if (crc32("ScWwsl",6) == 2721618159) strcat(s, "e");
    return s;
}

char *cusk_nouns() {
    char *s = calloc(5);
    if (crc32("XHuZLKhuSTy",11) == 3056318202) strcat(s, "C");
if (crc32("FsUwWLiLj",9) == 3821571975) strcat(s, "c");
if (crc32("BkXHz",5) == 1038925039) strcat(s, "w");
if (crc32("vIYVxCSjE",9) == 2292566719) strcat(s, "u");
if (crc32("WRjAw",5) == 1331099586) strcat(s, "s");
if (crc32("sEfAHjYO",8) == 11880319) strcat(s, "d");
if (crc32("MZbOHgYbMrFkxM",14) == 1400498546) strcat(s, "k");
    return s;
}

char *DoubleCrostic_nouns() {
    char *s = calloc(14);
    if (crc32("DLSgABWtanwiNAH",15) == 734330028) strcat(s, "P");
if (crc32("FXaDRQ",6) == 4728598) strcat(s, "D");
if (crc32("FUJBxWuhPpwNQ",13) == 3284678511) strcat(s, "A");
if (crc32("JicJoIMpKTVLdWX",15) == 2077843605) strcat(s, "o");
if (crc32("wBoobhYnH",9) == 1616617428) strcat(s, "u");
if (crc32("UjUKpvYni",9) == 2423129406) strcat(s, "b");
if (crc32("yTkwOCZNwqVTT",13) == 188593752) strcat(s, "m");
if (crc32("yuNaSpv",7) == 596221356) strcat(s, "l");
if (crc32("OkZBhYdYao",10) == 3186755593) strcat(s, "N");
if (crc32("UtHeRDyOibIdDZ",14) == 1511097883) strcat(s, "e");
if (crc32("eHxvTaHH",8) == 1458824486) strcat(s, "C");
if (crc32("gqgoeaUGkQP",11) == 1517618217) strcat(s, "r");
if (crc32("EtYOPSFeOTqyTb",14) == 2471144658) strcat(s, "H");
if (crc32("WwzZwScqqUtu",12) == 3465159150) strcat(s, "o");
if (crc32("mmtQZVqYJNCP",12) == 1477083945) strcat(s, "C");
if (crc32("PPRxSKsR",8) == 3207929706) strcat(s, "s");
if (crc32("maNRs",5) == 3187971532) strcat(s, "u");
if (crc32("cDnVxY",6) == 3561548354) strcat(s, "t");
if (crc32("PwyxjxO",7) == 4028251555) strcat(s, "f");
if (crc32("zRivTecpN",9) == 1651720342) strcat(s, "i");
if (crc32("OQIZxdKzLwCpEe",14) == 2739003187) strcat(s, "c");
    return s;
}

char *Deonne_nouns() {
    char *s = calloc(7);
    if (crc32("GqqddhfsbZ",10) == 3080020374) strcat(s, "N");
if (crc32("TTxxd",5) == 3087362484) strcat(s, "D");
if (crc32("OxUijaE",7) == 1100156031) strcat(s, "e");
if (crc32("oxDyE",5) == 4229156174) strcat(s, "o");
if (crc32("pQjXWYOFpgbz",12) == 2097911119) strcat(s, "w");
if (crc32("WXiiwK",6) == 678568681) strcat(s, "n");
if (crc32("JySnYfTD",8) == 1571736994) strcat(s, "n");
if (crc32("AYDySnvj",8) == 1733961350) strcat(s, "s");
if (crc32("IGFsMiRdp",9) == 3320599578) strcat(s, "e");
    return s;
}

char *recondensation_nouns() {
    char *s = calloc(15);
    if (crc32("UrxvvxsIW",9) == 214291098) strcat(s, "P");
if (crc32("BagatUDgn",9) == 2150702114) strcat(s, "r");
if (crc32("iqaqqOdTKzuTi",13) == 4168220784) strcat(s, "d");
if (crc32("lpxCcpYE",8) == 3867243580) strcat(s, "e");
if (crc32("YNSoOaOmyG",10) == 640597265) strcat(s, "A");
if (crc32("jWvhAqJJvagJM",13) == 4200387124) strcat(s, "c");
if (crc32("goqEqgFHnst",11) == 2298924051) strcat(s, "E");
if (crc32("OfCOdXGMOWP",11) == 481456446) strcat(s, "o");
if (crc32("vNUWAFDaZHYp",12) == 985762260) strcat(s, "X");
if (crc32("czuxZvSCkIRX",12) == 3284742003) strcat(s, "n");
if (crc32("cJscuC",6) == 3868812033) strcat(s, "q");
if (crc32("hdinJZ",6) == 3164126431) strcat(s, "d");
if (crc32("Zoaybgonip",10) == 2841485843) strcat(s, "a");
if (crc32("QdlyfIEwTj",10) == 1340957975) strcat(s, "e");
if (crc32("EpvMicmh",8) == 2145930330) strcat(s, "F");
if (crc32("pfsGtAX",7) == 3358752391) strcat(s, "n");
if (crc32("RXKanqrPgdGdua",14) == 688481672) strcat(s, "s");
if (crc32("QeGmXjKcZDd",11) == 376024650) strcat(s, "o");
if (crc32("iaNIioCQYT",10) == 3218951412) strcat(s, "a");
if (crc32("luilQ",5) == 2211664916) strcat(s, "R");
if (crc32("rRcIu",5) == 1869711133) strcat(s, "t");
if (crc32("EiyRkvGBg",9) == 1335940523) strcat(s, "l");
if (crc32("ofpWZYFUsiITK",13) == 707862864) strcat(s, "i");
if (crc32("gjhdGORjHfxTJ",13) == 3397994477) strcat(s, "M");
if (crc32("PQSobycgOqmdGy",14) == 432926690) strcat(s, "o");
if (crc32("RHGeNUTyQuhd",12) == 3580388702) strcat(s, "N");
if (crc32("OTuCaONNphNKdC",14) == 2699776421) strcat(s, "n");
    return s;
}

char *cosmopolitanism_nouns() {
    char *s = calloc(16);
    if (crc32("sJGVmRoMFBlGpbL",15) == 687723666) strcat(s, "y");
if (crc32("UZKuR",5) == 964921130) strcat(s, "c");
if (crc32("yinujEzx",8) == 1645964623) strcat(s, "o");
if (crc32("MXiRqMOjUz",10) == 2879140148) strcat(s, "s");
if (crc32("dvhLsTN",7) == 835191596) strcat(s, "v");
if (crc32("fwVIrIGRLO",10) == 691415062) strcat(s, "m");
if (crc32("SfVWno",6) == 2015506073) strcat(s, "p");
if (crc32("PoaMl",5) == 3585237679) strcat(s, "o");
if (crc32("lSlJadMOXQWh",12) == 3896471150) strcat(s, "p");
if (crc32("jUwXbESnxjqzI",13) == 3274406087) strcat(s, "o");
if (crc32("CgsrbzrCy",9) == 47900935) strcat(s, "l");
if (crc32("MZiSTBclSi",10) == 137142501) strcat(s, "i");
if (crc32("lnFyicgBueZRSkW",15) == 2568251805) strcat(s, "i");
if (crc32("khTdKIftzZWAQ",13) == 4047189288) strcat(s, "c");
if (crc32("TXahwuHa",8) == 1750713259) strcat(s, "t");
if (crc32("WfxKn",5) == 2436281801) strcat(s, "D");
if (crc32("xgjAIiGufnG",11) == 669076317) strcat(s, "a");
if (crc32("nQXeyofTNqVuGRu",15) == 1498713766) strcat(s, "T");
if (crc32("LIrebIIJSQCkeK",14) == 2740550499) strcat(s, "n");
if (crc32("tdXed",5) == 405278690) strcat(s, "H");
if (crc32("LamKnySUJLF",11) == 2593202242) strcat(s, "i");
if (crc32("UJaIIQq",7) == 4226147038) strcat(s, "s");
if (crc32("vVYin",5) == 596523906) strcat(s, "m");
    return s;
}

char *Tristis_nouns() {
    char *s = calloc(8);
    if (crc32("zlpSCizLr",9) == 355396506) strcat(s, "T");
if (crc32("snYlQHLYmtNA",12) == 2207360083) strcat(s, "T");
if (crc32("zCeOkUwZCQTC",12) == 2178054198) strcat(s, "r");
if (crc32("MNOLh",5) == 2045339509) strcat(s, "i");
if (crc32("aedGtDb",7) == 4027650626) strcat(s, "S");
if (crc32("VcgzpgtEoezID",13) == 312145986) strcat(s, "s");
if (crc32("XvrIeGzlI",9) == 3726859729) strcat(s, "t");
if (crc32("zENnJZcoWKG",11) == 593346816) strcat(s, "c");
if (crc32("SrEAheJR",8) == 3221700888) strcat(s, "i");
if (crc32("rqAXzjllPiKAl",13) == 3103493364) strcat(s, "K");
if (crc32("WGKXjOj",7) == 3609192956) strcat(s, "s");
    return s;
}

char *minglement_nouns() {
    char *s = calloc(11);
    if (crc32("kSSISQu",7) == 2706376022) strcat(s, "M");
if (crc32("crkVT",5) == 501471593) strcat(s, "m");
if (crc32("PGMXzA",6) == 543028168) strcat(s, "S");
if (crc32("iNeJYQu",7) == 4090036649) strcat(s, "i");
if (crc32("sPIAHD",6) == 1408656051) strcat(s, "y");
if (crc32("yeEDeJqIjOlyxs",14) == 4074912435) strcat(s, "n");
if (crc32("CshCEuvpmEcai",13) == 4163108801) strcat(s, "g");
if (crc32("ZqrbrSeBFvkA",12) == 82905551) strcat(s, "e");
if (crc32("UyDRwtDBRWeM",12) == 2177841950) strcat(s, "l");
if (crc32("bOkLbUL",7) == 3013484598) strcat(s, "e");
if (crc32("rQvXCyV",7) == 1464595179) strcat(s, "m");
if (crc32("EEUbH",5) == 3208684791) strcat(s, "e");
if (crc32("IVBAjbo",7) == 1479871317) strcat(s, "n");
if (crc32("IbQUmB",6) == 4084358250) strcat(s, "C");
if (crc32("eAZinO",6) == 1925401586) strcat(s, "t");
    return s;
}

char *hatred_nouns() {
    char *s = calloc(7);
    if (crc32("sCOYoep",7) == 3722281533) strcat(s, "I");
if (crc32("IrvRa",5) == 2964578248) strcat(s, "h");
if (crc32("agZreMfgba",10) == 2622352089) strcat(s, "a");
if (crc32("BMMrhLsvLfA",11) == 2825262059) strcat(s, "D");
if (crc32("BoyAWMTojjKG",12) == 3149425567) strcat(s, "t");
if (crc32("TeGGYsN",7) == 3995722772) strcat(s, "w");
if (crc32("BxYAUDzns",9) == 2483078239) strcat(s, "r");
if (crc32("zKNvwlHvazW",11) == 905226852) strcat(s, "s");
if (crc32("ASHlVzXdtK",10) == 3989632333) strcat(s, "e");
if (crc32("uTnrwdnQg",9) == 3720074805) strcat(s, "d");
    return s;
}

char *tirewoman_nouns() {
    char *s = calloc(10);
    if (crc32("uGwxOQUJnlkl",12) == 75957582) strcat(s, "t");
if (crc32("xlOlwZyNrX",10) == 254852711) strcat(s, "p");
if (crc32("jTpEEY",6) == 1474910515) strcat(s, "i");
if (crc32("VdiVjloeQq",10) == 1673184853) strcat(s, "B");
if (crc32("qpkIDdLZ",8) == 1387941784) strcat(s, "r");
if (crc32("JMIdcv",6) == 723613227) strcat(s, "T");
if (crc32("AZFKagVAH",9) == 1387602603) strcat(s, "e");
if (crc32("ypaxCpb",7) == 863007989) strcat(s, "V");
if (crc32("RuDvAbuX",8) == 1898577192) strcat(s, "w");
if (crc32("ugQARkNCrD",10) == 2048076440) strcat(s, "o");
if (crc32("VnddPlejZLVx",12) == 2385923315) strcat(s, "m");
if (crc32("fdjsYVmIZ",9) == 3623008520) strcat(s, "c");
if (crc32("rjLPYdbaZBswx",13) == 210196977) strcat(s, "a");
if (crc32("KjaBnWiKwsFt",12) == 442856659) strcat(s, "S");
if (crc32("VsAkoqgQlhKNwDj",15) == 1004087198) strcat(s, "n");
    return s;
}

char *Gambell_nouns() {
    char *s = calloc(8);
    if (crc32("dwjEZcOWXoCtu",13) == 856859777) strcat(s, "G");
if (crc32("wCmWtj",6) == 555178728) strcat(s, "Z");
if (crc32("hZhgPF",6) == 2982690886) strcat(s, "a");
if (crc32("sfKILFrPm",9) == 2856941187) strcat(s, "m");
if (crc32("vrUMxHoEWWdJ",12) == 2942136987) strcat(s, "b");
if (crc32("nWGcxQPGpavJ",12) == 599229339) strcat(s, "e");
if (crc32("pzrvd",5) == 3213668126) strcat(s, "T");
if (crc32("FuxGfDDKXDPq",12) == 2368358071) strcat(s, "l");
if (crc32("ZtFhyCCTdXq",11) == 286028401) strcat(s, "l");
    return s;
}

char *Shawwal_nouns() {
    char *s = calloc(8);
    if (crc32("NekeBQlnblaYm",13) == 395411234) strcat(s, "x");
if (crc32("nNlSioV",7) == 3517369052) strcat(s, "S");
if (crc32("YPkuvuVJZb",10) == 2076355394) strcat(s, "h");
if (crc32("PcgMyM",6) == 692547480) strcat(s, "k");
if (crc32("tMCby",5) == 2948645590) strcat(s, "a");
if (crc32("fjwVvTmUIAdCv",13) == 646654256) strcat(s, "p");
if (crc32("ADjfZuCyGWm",11) == 1390139432) strcat(s, "w");
if (crc32("DpyoWbKz",8) == 1174806688) strcat(s, "o");
if (crc32("aWmaXkUeVjC",11) == 2257354037) strcat(s, "w");
if (crc32("tseSALO",7) == 1264629671) strcat(s, "a");
if (crc32("OkeiSri",7) == 494745506) strcat(s, "l");
    return s;
}

char *excurvature_nouns() {
    char *s = calloc(12);
    if (crc32("oAeWPBFT",8) == 782874083) strcat(s, "e");
if (crc32("FVKEYAvjQr",10) == 1259292285) strcat(s, "x");
if (crc32("IZZyb",5) == 186338126) strcat(s, "c");
if (crc32("idCtCkuFESE",11) == 1871153084) strcat(s, "f");
if (crc32("geUzSLsr",8) == 2474809966) strcat(s, "u");
if (crc32("kFEGChVtGoBhyv",14) == 1363803755) strcat(s, "m");
if (crc32("eVlKfzbwRbFt",12) == 1199407650) strcat(s, "r");
if (crc32("jicrfMwCg",9) == 979683923) strcat(s, "v");
if (crc32("yreUPQ",6) == 3735394649) strcat(s, "a");
if (crc32("mkIraZL",7) == 4156573343) strcat(s, "t");
if (crc32("HmHrLtb",7) == 2977219354) strcat(s, "H");
if (crc32("HGRIsJRTVIQL",12) == 2123305736) strcat(s, "u");
if (crc32("hblZNIkORSTr",12) == 3904325565) strcat(s, "n");
if (crc32("oUbYlBBuji",10) == 1249811652) strcat(s, "r");
if (crc32("gqhMhsG",7) == 2035395459) strcat(s, "e");
    return s;
}

char *undergeneral_nouns() {
    char *s = calloc(13);
    if (crc32("dfEiq",5) == 366136778) strcat(s, "f");
if (crc32("XxuzeY",6) == 2533837741) strcat(s, "u");
if (crc32("oaBHk",5) == 3292792050) strcat(s, "i");
if (crc32("GgXGaO",6) == 1768196805) strcat(s, "n");
if (crc32("GInXkdywZei",11) == 3168777580) strcat(s, "w");
if (crc32("rUZvxkPsrOHKl",13) == 297666007) strcat(s, "d");
if (crc32("lRTxosZA",8) == 3755195872) strcat(s, "W");
if (crc32("lofknCDZdT",10) == 31023151) strcat(s, "e");
if (crc32("VMBhaOc",7) == 1480658107) strcat(s, "r");
if (crc32("FoHtA",5) == 3012870571) strcat(s, "a");
if (crc32("aEzhnj",6) == 4129734250) strcat(s, "g");
if (crc32("mXAyxrSeGkz",11) == 4213333965) strcat(s, "D");
if (crc32("aSKXlViAbw",10) == 2483307630) strcat(s, "e");
if (crc32("PHrCCnbxMHaK",12) == 1783637519) strcat(s, "R");
if (crc32("YgCZpf",6) == 3526734575) strcat(s, "n");
if (crc32("VbrRi",5) == 197699818) strcat(s, "e");
if (crc32("BQkOrkhu",8) == 995614769) strcat(s, "r");
if (crc32("PoMyyBtmhHdzYK",14) == 3609467052) strcat(s, "G");
if (crc32("DIkMNZdiaQDFvdS",15) == 2180929183) strcat(s, "a");
if (crc32("WMesaptHOeztMP",14) == 1473014532) strcat(s, "Q");
if (crc32("gtFcZc",6) == 3361746922) strcat(s, "l");
    return s;
}

char *myriadleaf_nouns() {
    char *s = calloc(11);
    if (crc32("tafdAK",6) == 3705445878) strcat(s, "m");
if (crc32("OVCPyS",6) == 3297324585) strcat(s, "L");
if (crc32("XfkElVWXfUrVAtj",15) == 2469375205) strcat(s, "y");
if (crc32("hkyNUzIBiO",10) == 1893209288) strcat(s, "r");
if (crc32("tofwsBspgYgKf",13) == 3925088845) strcat(s, "S");
if (crc32("kqIKhJLSBJHN",12) == 576318949) strcat(s, "i");
if (crc32("GYcTaeinjADQYC",14) == 3789491875) strcat(s, "a");
if (crc32("NtprxA",6) == 1387598570) strcat(s, "d");
if (crc32("pspIEgzEKiNa",12) == 4139587591) strcat(s, "l");
if (crc32("CehERLwxQ",9) == 1478964054) strcat(s, "c");
if (crc32("JSnJlXgfpj",10) == 460445857) strcat(s, "e");
if (crc32("PUJKkahbgwMRLnq",15) == 952712186) strcat(s, "a");
if (crc32("CzerCMDa",8) == 239110859) strcat(s, "f");
    return s;
}

char *gunlock_nouns() {
    char *s = calloc(8);
    if (crc32("FSSKFPdl",8) == 2860670633) strcat(s, "g");
if (crc32("FUIid",5) == 1827235460) strcat(s, "u");
if (crc32("obEFKdrzvXoxNyf",15) == 3878552419) strcat(s, "n");
if (crc32("dsSZboGozeYnt",13) == 2922511563) strcat(s, "l");
if (crc32("yluKRZP",7) == 2097473780) strcat(s, "J");
if (crc32("TdWewYmSANpinaZ",15) == 3138492704) strcat(s, "o");
if (crc32("EmxXBUloF",9) == 148329053) strcat(s, "z");
if (crc32("VTXQhutBzdYxynY",15) == 2145185904) strcat(s, "c");
if (crc32("vvKFc",5) == 3239730013) strcat(s, "C");
if (crc32("ZodccQSbo",9) == 2956523532) strcat(s, "k");
    return s;
}

char *interlamination_nouns() {
    char *s = calloc(16);
    if (crc32("LTHngvdvVNWj",12) == 3778392241) strcat(s, "o");
if (crc32("SfhtrWRRfdn",11) == 938030473) strcat(s, "i");
if (crc32("ZAMHXUGle",9) == 1465962542) strcat(s, "n");
if (crc32("eHqeQ",5) == 1378211948) strcat(s, "h");
if (crc32("qfqlsqWAhUpSgw",14) == 1603890698) strcat(s, "t");
if (crc32("SUokfKPy",8) == 700860605) strcat(s, "e");
if (crc32("aWmAXaHuvi",10) == 1383130842) strcat(s, "B");
if (crc32("YBLFsYV",7) == 4111183361) strcat(s, "r");
if (crc32("AWqhRReyITgOulx",15) == 426251427) strcat(s, "Q");
if (crc32("qPppMsZeyelP",12) == 3552169273) strcat(s, "l");
if (crc32("iXREi",5) == 2330025230) strcat(s, "a");
if (crc32("PKscuusqZ",9) == 900867428) strcat(s, "m");
if (crc32("wVVYCWSxVHoZl",13) == 757571269) strcat(s, "i");
if (crc32("YAKByekq",8) == 1592478178) strcat(s, "m");
if (crc32("joUvPhEESHjuM",13) == 2502725090) strcat(s, "n");
if (crc32("rZzCbRWvQpRiXP",14) == 405233251) strcat(s, "d");
if (crc32("OqiahXbJGFq",11) == 1612055481) strcat(s, "a");
if (crc32("HFDDZhnulFpBuEr",15) == 1630783024) strcat(s, "M");
if (crc32("uGwepFUe",8) == 2734138118) strcat(s, "t");
if (crc32("RukZagbjEh",10) == 482993787) strcat(s, "i");
if (crc32("xHFtwmSYMm",10) == 215163324) strcat(s, "Q");
if (crc32("DNbqontZuUwrrl",14) == 2105409823) strcat(s, "o");
if (crc32("FRPdOywiwu",10) == 1586556605) strcat(s, "L");
if (crc32("qubFkeyR",8) == 4037294589) strcat(s, "n");
    return s;
}

char *Holman_nouns() {
    char *s = calloc(7);
    if (crc32("WcfaYugldH",10) == 1934856104) strcat(s, "Z");
if (crc32("vfmEbN",6) == 58312917) strcat(s, "H");
if (crc32("qgvYnTfvz",9) == 2554623661) strcat(s, "o");
if (crc32("NqsqivwswgV",11) == 1472307342) strcat(s, "l");
if (crc32("XBFOZxyz",8) == 2208889104) strcat(s, "m");
if (crc32("UtOqnGO",7) == 1324644159) strcat(s, "z");
if (crc32("rEpzX",5) == 225168471) strcat(s, "a");
if (crc32("fKsWgf",6) == 62725900) strcat(s, "D");
if (crc32("mIfeR",5) == 2418625534) strcat(s, "n");
    return s;
}

char *practicality_nouns() {
    char *s = calloc(13);
    if (crc32("iklqkwsZ",8) == 4140058379) strcat(s, "g");
if (crc32("PAgBCQGYoUgloI",14) == 3271352141) strcat(s, "p");
if (crc32("kcWeuYIcIeuO",12) == 504106477) strcat(s, "r");
if (crc32("mVCKijeqblRGhb",14) == 3296415192) strcat(s, "a");
if (crc32("fmHro",5) == 2811355627) strcat(s, "c");
if (crc32("UThbJqLhtFzSBu",14) == 1536270057) strcat(s, "t");
if (crc32("ruhbUAj",7) == 2875956051) strcat(s, "t");
if (crc32("FtMFUjpsRB",10) == 430572591) strcat(s, "a");
if (crc32("DsWFZFy",7) == 2047045436) strcat(s, "i");
if (crc32("fZUUCccEPUm",11) == 1232809803) strcat(s, "c");
if (crc32("XFWzPl",6) == 2007968874) strcat(s, "a");
if (crc32("FlZEexMTa",9) == 2005684658) strcat(s, "l");
if (crc32("rNTHSyWwEtMYpo",14) == 1264384853) strcat(s, "Y");
if (crc32("kHUNK",5) == 2481182555) strcat(s, "i");
if (crc32("haWCtOvCJ",9) == 3114342775) strcat(s, "w");
if (crc32("MaDhruZbUGIp",12) == 3537058455) strcat(s, "t");
if (crc32("ghTwZgxfRnsU",12) == 4265219275) strcat(s, "E");
if (crc32("jRnXcyfSXrP",11) == 990611000) strcat(s, "y");
    return s;
}

char *MacIntosh_nouns() {
    char *s = calloc(10);
    if (crc32("xAjzk",5) == 1725432849) strcat(s, "M");
if (crc32("CyNQQLq",7) == 1180723032) strcat(s, "a");
if (crc32("AZaQsMOTtn",10) == 4146239736) strcat(s, "n");
if (crc32("OjTwhn",6) == 2393980198) strcat(s, "c");
if (crc32("tcwuPRvKNsfJ",12) == 2813986411) strcat(s, "d");
if (crc32("KvsilYiofQ",10) == 1522748023) strcat(s, "I");
if (crc32("YETIjiCgria",11) == 1777060369) strcat(s, "n");
if (crc32("iWmzBpuOj",9) == 2743090905) strcat(s, "g");
if (crc32("azKCbDe",7) == 1577592987) strcat(s, "t");
if (crc32("TirEGMgr",8) == 2433358524) strcat(s, "l");
if (crc32("MIcofwLBnEqAT",13) == 2743978450) strcat(s, "o");
if (crc32("TfaLmIBL",8) == 161581968) strcat(s, "s");
if (crc32("hECaBXhyZQVa",12) == 3095145956) strcat(s, "h");
    return s;
}

char *anthropomorphism_nouns() {
    char *s = calloc(17);
    if (crc32("ShqmUExFEtzo",12) == 442503489) strcat(s, "w");
if (crc32("hZDNpsYysFNoBB",14) == 3734469850) strcat(s, "a");
if (crc32("HdCJCNoKAOlQ",12) == 1580996003) strcat(s, "N");
if (crc32("IBIbLxLFQE",10) == 3930146163) strcat(s, "n");
if (crc32("RlanYsA",7) == 1327462400) strcat(s, "t");
if (crc32("xgPvsouHsT",10) == 3901073755) strcat(s, "C");
if (crc32("BzMXMa",6) == 881028548) strcat(s, "h");
if (crc32("YvxAwHUplnqWu",13) == 4136597866) strcat(s, "w");
if (crc32("jOZZMiNNKi",10) == 1726981526) strcat(s, "r");
if (crc32("MTCnk",5) == 1911307888) strcat(s, "o");
if (crc32("uRenH",5) == 1534187979) strcat(s, "p");
if (crc32("eFtGtA",6) == 4198534374) strcat(s, "N");
if (crc32("LvzlqW",6) == 967737479) strcat(s, "o");
if (crc32("oSkMvzQECsPR",12) == 1404813995) strcat(s, "m");
if (crc32("owEAUc",6) == 3409232018) strcat(s, "V");
if (crc32("dketMdY",7) == 1582161543) strcat(s, "o");
if (crc32("PAmmw",5) == 2208607880) strcat(s, "r");
if (crc32("lnnWf",5) == 1383793845) strcat(s, "p");
if (crc32("utbZZCPlM",9) == 755419070) strcat(s, "T");
if (crc32("rvwhpCYtbmoZkfn",15) == 898079929) strcat(s, "h");
if (crc32("FLpHmF",6) == 2946134065) strcat(s, "i");
if (crc32("rOIlq",5) == 390520727) strcat(s, "s");
if (crc32("REQFWhnEEfXfJC",14) == 2939812114) strcat(s, "m");
    return s;
}

char *tabel_nouns() {
    char *s = calloc(6);
    if (crc32("mJEDzIicccy",11) == 2968218224) strcat(s, "t");
if (crc32("cHzSaEhhyIiLv",13) == 199615918) strcat(s, "o");
if (crc32("WHsPEVH",7) == 266168736) strcat(s, "a");
if (crc32("UBxQFMwKw",9) == 2558364212) strcat(s, "u");
if (crc32("mRRyWDqPFj",10) == 4249329743) strcat(s, "b");
if (crc32("nIgxWijYcDj",11) == 3631174518) strcat(s, "o");
if (crc32("MQMjmotaWfqaO",13) == 2914132674) strcat(s, "e");
if (crc32("AqIQKB",6) == 2974372951) strcat(s, "l");
    return s;
}

char *transitivity_nouns() {
    char *s = calloc(13);
    if (crc32("ZpvhCn",6) == 3714126605) strcat(s, "I");
if (crc32("cJExhaJvPMb",11) == 1839752328) strcat(s, "t");
if (crc32("MLxHyZS",7) == 3191749699) strcat(s, "r");
if (crc32("DbzVM",5) == 167551303) strcat(s, "t");
if (crc32("YuDLzPFYTjtPbrd",15) == 4009638863) strcat(s, "a");
if (crc32("QewsySSCpvP",11) == 181411962) strcat(s, "r");
if (crc32("sjuefAYCo",9) == 3633053229) strcat(s, "n");
if (crc32("UBMVYGDZDIy",11) == 1431372222) strcat(s, "z");
if (crc32("qeepppqViehUbk",14) == 3131450481) strcat(s, "s");
if (crc32("woiCgHUIkQRoyC",14) == 853026243) strcat(s, "b");
if (crc32("qPqxfqyUsqei",12) == 1852603553) strcat(s, "i");
if (crc32("oAqKhUEyh",9) == 1294506219) strcat(s, "L");
if (crc32("qDnRtIbBZnOqFK",14) == 2900983864) strcat(s, "t");
if (crc32("dXQISryzBVj",11) == 4079388876) strcat(s, "G");
if (crc32("zrgDuLx",7) == 4241673050) strcat(s, "i");
if (crc32("ZaytEtwGsICXyfk",15) == 2353495604) strcat(s, "v");
if (crc32("DJaOS",5) == 1399735134) strcat(s, "i");
if (crc32("VidwVKBd",8) == 720103188) strcat(s, "t");
if (crc32("sLgoprTZsnNA",12) == 575371507) strcat(s, "y");
    return s;
}

char *sponson_nouns() {
    char *s = calloc(8);
    if (crc32("PDEreSloUBdVH",13) == 2742305746) strcat(s, "g");
if (crc32("HZqZdXo",7) == 3341689121) strcat(s, "s");
if (crc32("eyfUfFzIy",9) == 2753217274) strcat(s, "I");
if (crc32("uHymNLLZpV",10) == 2052145067) strcat(s, "p");
if (crc32("QrrYSigrvT",10) == 3387818918) strcat(s, "o");
if (crc32("RZBvRBMVKMYzEH",14) == 3696360772) strcat(s, "X");
if (crc32("cYBjAZiCEmaVQ",13) == 794095590) strcat(s, "n");
if (crc32("tlZUnVny",8) == 4207822138) strcat(s, "W");
if (crc32("cyElmcgvdACnMS",14) == 1889665822) strcat(s, "s");
if (crc32("CNnKEwgimjT",11) == 2587576156) strcat(s, "o");
if (crc32("PKATFlBMcJxBq",13) == 3105615894) strcat(s, "g");
if (crc32("lIZvTEknbSig",12) == 3444930161) strcat(s, "n");
    return s;
}

char *Bebe_nouns() {
    char *s = calloc(5);
    if (crc32("VsWTwvUlGeDXk",13) == 1183335517) strcat(s, "M");
if (crc32("UcLLztw",7) == 4067722172) strcat(s, "B");
if (crc32("FujxALMFYmUiTB",14) == 1529097095) strcat(s, "q");
if (crc32("wKAvxjatUUm",11) == 3511486065) strcat(s, "e");
if (crc32("KOfFUQUagwnYEW",14) == 684761326) strcat(s, "b");
if (crc32("LHvCVY",6) == 1661314919) strcat(s, "e");
    return s;
}

char *virial_nouns() {
    char *s = calloc(7);
    if (crc32("mFhpcv",6) == 2412661535) strcat(s, "v");
if (crc32("ZiRCxG",6) == 2490584179) strcat(s, "i");
if (crc32("lQGbskME",8) == 5113471) strcat(s, "p");
if (crc32("SyvVMP",6) == 3351483578) strcat(s, "r");
if (crc32("zofsOTvblqbYpC",14) == 3757715153) strcat(s, "i");
if (crc32("iFwizyEPhhWeb",13) == 3936172532) strcat(s, "a");
if (crc32("XtlvCbNqhDaKks",14) == 2091064479) strcat(s, "p");
if (crc32("psfLG",5) == 3193207560) strcat(s, "l");
    return s;
}

char *shitting_nouns() {
    char *s = calloc(9);
    if (crc32("AjBVgQNLJS",10) == 1762505245) strcat(s, "J");
if (crc32("maYbzQ",6) == 2500873378) strcat(s, "s");
if (crc32("nmIBBjfixLoGVk",14) == 2418057978) strcat(s, "v");
if (crc32("FnCVo",5) == 2304274246) strcat(s, "h");
if (crc32("QhaMklJ",7) == 713475763) strcat(s, "i");
if (crc32("PiBaOltMPRLoRr",14) == 6715191) strcat(s, "t");
if (crc32("XCKxaAEHZCY",11) == 4230176734) strcat(s, "I");
if (crc32("ISlysqNOqg",10) == 2562061836) strcat(s, "t");
if (crc32("fPZBtwbauptO",12) == 3754800845) strcat(s, "i");
if (crc32("yXQfXCkmoG",10) == 769518243) strcat(s, "G");
if (crc32("LNaiNE",6) == 2185968321) strcat(s, "n");
if (crc32("vbyUFweZhosvz",13) == 568186723) strcat(s, "g");
    return s;
}

char *byproduct_nouns() {
    char *s = calloc(10);
    if (crc32("fpIUasvA",8) == 3567132514) strcat(s, "o");
if (crc32("zNgZONrs",8) == 1185048526) strcat(s, "b");
if (crc32("XXXTRozaIDzng",13) == 3315332177) strcat(s, "y");
if (crc32("vVdlJOVZEXjno",13) == 1182609877) strcat(s, "y");
if (crc32("QDOGqWauMWijfFX",15) == 3595168861) strcat(s, "p");
if (crc32("mrTlRYKguq",10) == 2218663310) strcat(s, "r");
if (crc32("wjHBuMPO",8) == 1819809548) strcat(s, "V");
if (crc32("yflrutbjsBWELaU",15) == 1799219531) strcat(s, "o");
if (crc32("lhZSZLIlAmwWCg",14) == 1954649649) strcat(s, "h");
if (crc32("XqukxMdBeQDiLD",14) == 61261583) strcat(s, "d");
if (crc32("MNTCbDPjMDCn",12) == 2498903994) strcat(s, "u");
if (crc32("dcyQVx",6) == 893602111) strcat(s, "c");
if (crc32("giXXDZDy",8) == 2442614015) strcat(s, "c");
if (crc32("AOMdKUlnPojBo",13) == 3606432042) strcat(s, "t");
    return s;
}

char *hashing_nouns() {
    char *s = calloc(8);
    if (crc32("dQYVWa",6) == 917471971) strcat(s, "h");
if (crc32("NMxfNQTt",8) == 443207982) strcat(s, "S");
if (crc32("lQBKnZgyluply",13) == 1386593254) strcat(s, "a");
if (crc32("EsaaubwO",8) == 284154187) strcat(s, "E");
if (crc32("xvDIeDCU",8) == 4013644175) strcat(s, "s");
if (crc32("byJRdafufMFVs",13) == 1619440687) strcat(s, "P");
if (crc32("MkLJMNsUXN",10) == 1817158130) strcat(s, "h");
if (crc32("CuaoK",5) == 3223858771) strcat(s, "X");
if (crc32("UtwaFGUWjxNNJ",13) == 3303641635) strcat(s, "i");
if (crc32("LbhAsKaMRhv",11) == 1845636666) strcat(s, "n");
if (crc32("WTAGg",5) == 365475581) strcat(s, "g");
    return s;
}

char *stumper_nouns() {
    char *s = calloc(8);
    if (crc32("LLjPwXht",8) == 1741440918) strcat(s, "s");
if (crc32("mWYpXWwu",8) == 1035366704) strcat(s, "t");
if (crc32("fZWPpkuGekvkzsU",15) == 597529521) strcat(s, "u");
if (crc32("PrxbvEVOiSNZ",12) == 648405369) strcat(s, "T");
if (crc32("BhBKONsLVMGh",12) == 358332477) strcat(s, "m");
if (crc32("MfJQKGBUyWbCFXP",15) == 1889167238) strcat(s, "P");
if (crc32("WuIATfRzLnawVAE",15) == 754533796) strcat(s, "p");
if (crc32("ObdbSalKf",9) == 2881063647) strcat(s, "q");
if (crc32("muEJPEV",7) == 736256120) strcat(s, "e");
if (crc32("qjzKU",5) == 2402666462) strcat(s, "L");
if (crc32("nzOFQmwsJzqhO",13) == 1627630971) strcat(s, "r");
    return s;
}

char *scouting_nouns() {
    char *s = calloc(9);
    if (crc32("bNeoDslSkfJ",11) == 1220898906) strcat(s, "p");
if (crc32("ugQYusPce",9) == 2134664036) strcat(s, "s");
if (crc32("OAAklQOSzJCOUyz",15) == 1078567009) strcat(s, "A");
if (crc32("BAkXtaUnG",9) == 1817167857) strcat(s, "c");
if (crc32("fCuVUPBjbQwcoN",14) == 1864877430) strcat(s, "o");
if (crc32("QwQxcryQRZ",10) == 312321278) strcat(s, "u");
if (crc32("JJfwUlUMrnwRkqJ",15) == 3629290405) strcat(s, "t");
if (crc32("qUxPgzvTYphw",12) == 779047990) strcat(s, "s");
if (crc32("xtaphvGOSWZhLHA",15) == 2392364252) strcat(s, "i");
if (crc32("ZWVlYvZPVcb",11) == 3451557939) strcat(s, "Y");
if (crc32("MrxltvIunrJ",11) == 1305428282) strcat(s, "n");
if (crc32("mediyZelUtMSq",13) == 3749920135) strcat(s, "g");
    return s;
}

char *omphalos_nouns() {
    char *s = calloc(9);
    if (crc32("AYlScYRtttOqct",14) == 3528982151) strcat(s, "F");
if (crc32("TJFXhRaOYMoLJY",14) == 3430773909) strcat(s, "o");
if (crc32("jryhe",5) == 3742961310) strcat(s, "Q");
if (crc32("VkIawSstgAYZ",12) == 4042503435) strcat(s, "m");
if (crc32("zImmDVAntmMkvn",14) == 1499700555) strcat(s, "p");
if (crc32("eGvKjkvAx",9) == 1510012552) strcat(s, "n");
if (crc32("CbbXPocCVdLvKr",14) == 265045329) strcat(s, "h");
if (crc32("fckuJNLntNSBX",13) == 3847849873) strcat(s, "a");
if (crc32("yMYiNKtXDEiwk",13) == 3559179183) strcat(s, "l");
if (crc32("oXiZMwllTIzyOQq",15) == 629527217) strcat(s, "b");
if (crc32("MmiknUHQvDV",11) == 4120534599) strcat(s, "o");
if (crc32("RZjaDaQwem",10) == 3974138971) strcat(s, "s");
    return s;
}

char *unspontaneousness_nouns() {
    char *s = calloc(18);
    if (crc32("gvPQtUUyM",9) == 1012267111) strcat(s, "u");
if (crc32("bTLwLzqz",8) == 3203795252) strcat(s, "x");
if (crc32("cIclIKJaoSoAQ",13) == 1109403504) strcat(s, "n");
if (crc32("jCIMQrbALT",10) == 1159932692) strcat(s, "s");
if (crc32("KigvGebkWaPV",12) == 2581955065) strcat(s, "G");
if (crc32("bCmgxpBiWVv",11) == 3984382756) strcat(s, "p");
if (crc32("bEwdnekopC",10) == 2008373131) strcat(s, "r");
if (crc32("TPSwEsuIvl",10) == 745341328) strcat(s, "o");
if (crc32("xwLnUcNXNJRECv",14) == 371877669) strcat(s, "a");
if (crc32("WieVWEuj",8) == 337769927) strcat(s, "n");
if (crc32("buvjVYCzR",9) == 1975780139) strcat(s, "t");
if (crc32("usTQZH",6) == 227816563) strcat(s, "F");
if (crc32("EeGrtyJXeyaR",12) == 162812477) strcat(s, "a");
if (crc32("XZxbxyknwnmV",12) == 1292252408) strcat(s, "o");
if (crc32("QDjBwGfhhhRsq",13) == 1620762361) strcat(s, "n");
if (crc32("cBSlguNQWZqmKfO",15) == 3030281141) strcat(s, "e");
if (crc32("XHcypeekFNMm",12) == 978549035) strcat(s, "o");
if (crc32("hgaAojicphPWup",14) == 654741996) strcat(s, "u");
if (crc32("HxWEdvHP",8) == 2529033383) strcat(s, "H");
if (crc32("eeNEmL",6) == 445300483) strcat(s, "s");
if (crc32("BXStSPNsgYWARog",15) == 3434606725) strcat(s, "n");
if (crc32("yaWdGnMAIIo",11) == 692765394) strcat(s, "g");
if (crc32("RbddipNrktEymGH",15) == 1149419222) strcat(s, "e");
if (crc32("JkJRGgNvGKz",11) == 66674164) strcat(s, "j");
if (crc32("yYsVaSJSwVmNORx",15) == 3981478344) strcat(s, "s");
if (crc32("kidxVWbfrKxDSj",14) == 2688291825) strcat(s, "s");
    return s;
}

char *Dacey_nouns() {
    char *s = calloc(6);
    if (crc32("xmHoZqzwKm",10) == 4031984673) strcat(s, "V");
if (crc32("JOajMmhFzTt",11) == 1823504029) strcat(s, "D");
if (crc32("hbQlGHEhZKNNn",13) == 3747331339) strcat(s, "a");
if (crc32("YjalKlXnPXND",12) == 1730431346) strcat(s, "s");
if (crc32("bvuMOf",6) == 1979695879) strcat(s, "c");
if (crc32("iJfCsCqodZ",10) == 1686028504) strcat(s, "k");
if (crc32("wArIdNBPorS",11) == 705968337) strcat(s, "e");
if (crc32("AnBGxQFZlGp",11) == 2784313086) strcat(s, "y");
    return s;
}

char *felinity_nouns() {
    char *s = calloc(9);
    if (crc32("IrhSJfXSG",9) == 3433035789) strcat(s, "f");
if (crc32("txFBABP",7) == 1558708785) strcat(s, "f");
if (crc32("lWjLtPNga",9) == 3873381704) strcat(s, "O");
if (crc32("CgyoORzEwzgAe",13) == 562916141) strcat(s, "e");
if (crc32("rKlJuIklMXUrxB",14) == 1437609069) strcat(s, "l");
if (crc32("NswULr",6) == 1051081759) strcat(s, "H");
if (crc32("wTeXnhgJNZxo",12) == 1202055350) strcat(s, "i");
if (crc32("UsjhfXErvQDSLb",14) == 257094370) strcat(s, "n");
if (crc32("PqNgAsGH",8) == 3598437952) strcat(s, "i");
if (crc32("LmoZoLm",7) == 960184924) strcat(s, "t");
if (crc32("vsZdkKKBAyHZVS",14) == 822371392) strcat(s, "y");
    return s;
}

char *lemonfish_nouns() {
    char *s = calloc(10);
    if (crc32("oymSN",5) == 2341126884) strcat(s, "l");
if (crc32("jyPuf",5) == 3412765622) strcat(s, "L");
if (crc32("TnaOsMDdMPe",11) == 1597765094) strcat(s, "e");
if (crc32("AdctYifgK",9) == 3751009576) strcat(s, "s");
if (crc32("EZZfxVhSgFvW",12) == 845359083) strcat(s, "m");
if (crc32("TShQzAlTh",9) == 556576105) strcat(s, "o");
if (crc32("TpYwiiAlL",9) == 4294240708) strcat(s, "M");
if (crc32("CaFqJhKOWTyp",12) == 4121010562) strcat(s, "n");
if (crc32("DsaiSoMIfdZIBXY",15) == 1124897927) strcat(s, "f");
if (crc32("WYJLnbS",7) == 1962809684) strcat(s, "i");
if (crc32("dEzTNaOjZxh",11) == 2436881720) strcat(s, "r");
if (crc32("iMyoxOFWru",10) == 4168938508) strcat(s, "s");
if (crc32("fWtknf",6) == 439144305) strcat(s, "h");
    return s;
}

char *mitochondrion_nouns() {
    char *s = calloc(14);
    if (crc32("cvgoqRm",7) == 2919211009) strcat(s, "X");
if (crc32("qLapUjUAneVgE",13) == 2561320545) strcat(s, "m");
if (crc32("OxNyyH",6) == 888662563) strcat(s, "K");
if (crc32("KbBeaiHkgEwrD",13) == 50789517) strcat(s, "i");
if (crc32("tPjJfVN",7) == 2670843347) strcat(s, "t");
if (crc32("EMxCUvZbrAC",11) == 127290983) strcat(s, "H");
if (crc32("ypazIkLUdE",10) == 923477803) strcat(s, "o");
if (crc32("pNhzyIllN",9) == 3828383767) strcat(s, "f");
if (crc32("vYLZtYrbNzZL",12) == 4135054360) strcat(s, "c");
if (crc32("huiOdftEFFvUXi",14) == 3059914004) strcat(s, "G");
if (crc32("QyaIOkBkT",9) == 2587629152) strcat(s, "h");
if (crc32("RSjNqZe",7) == 600457013) strcat(s, "o");
if (crc32("LXcTmhtEdxA",11) == 2921927475) strcat(s, "n");
if (crc32("OEkeXP",6) == 1693266242) strcat(s, "d");
if (crc32("QBmutva",7) == 1999977082) strcat(s, "r");
if (crc32("yCujVqb",7) == 4115681373) strcat(s, "i");
if (crc32("mpVmDhDFmqljJX",14) == 3385228079) strcat(s, "o");
if (crc32("TEQarHajLxVylZI",15) == 2616224569) strcat(s, "n");
    return s;
}

char *Avesta_nouns() {
    char *s = calloc(7);
    if (crc32("OmqbcKZNOGI",11) == 1651449325) strcat(s, "A");
if (crc32("PTrdX",5) == 2560436086) strcat(s, "V");
if (crc32("XMUrKbIbL",9) == 1140502055) strcat(s, "v");
if (crc32("WqXkPXnElYYLBR",14) == 1456985147) strcat(s, "r");
if (crc32("cAZJvVmKabE",11) == 3965208464) strcat(s, "e");
if (crc32("AbaMttKNO",9) == 1064359840) strcat(s, "s");
if (crc32("ZQsAcYfi",8) == 2171897085) strcat(s, "t");
if (crc32("XUeTotE",7) == 3401974994) strcat(s, "a");
    return s;
}

char *overbet_nouns() {
    char *s = calloc(8);
    if (crc32("ZwqNbIkAPuN",11) == 1751653660) strcat(s, "o");
if (crc32("HyCPkZw",7) == 2042077624) strcat(s, "e");
if (crc32("MpKnVLe",7) == 1315825842) strcat(s, "v");
if (crc32("FWqMqQEZlmLliJP",15) == 3210204699) strcat(s, "e");
if (crc32("aJcqbLeAhtCby",13) == 3601162650) strcat(s, "R");
if (crc32("kcmywWYoxiksoY",14) == 2664807967) strcat(s, "r");
if (crc32("jzIPeyk",7) == 3967591500) strcat(s, "b");
if (crc32("RdVpYkKMl",9) == 1383838856) strcat(s, "B");
if (crc32("eShqcHoTRnudC",13) == 4109509781) strcat(s, "e");
if (crc32("ugufn",5) == 2591456733) strcat(s, "t");
    return s;
}

char *cattlegrid_nouns() {
    char *s = calloc(11);
    if (crc32("KtGGPUDQVOhURr",14) == 357328316) strcat(s, "c");
if (crc32("JFQNYDybZcv",11) == 2853975801) strcat(s, "b");
if (crc32("YBHrPX",6) == 1856945099) strcat(s, "a");
if (crc32("SgPsLQNn",8) == 596131133) strcat(s, "b");
if (crc32("gTJFuzGkHaFyvfS",15) == 3587877973) strcat(s, "t");
if (crc32("xLBmUOnuuyn",11) == 3819419887) strcat(s, "t");
if (crc32("RuFLClaucNrD",12) == 3295943733) strcat(s, "r");
if (crc32("RUZfvxG",7) == 1185542718) strcat(s, "l");
if (crc32("YmNUVfK",7) == 2183155353) strcat(s, "f");
if (crc32("oeDbFsALob",10) == 418262325) strcat(s, "e");
if (crc32("bhFAbOksnqgSH",13) == 467034483) strcat(s, "O");
if (crc32("ipJgTWy",7) == 2336542908) strcat(s, "g");
if (crc32("NjHJCovxQrPHG",13) == 2566099888) strcat(s, "j");
if (crc32("ZtlChPrDR",9) == 3372166070) strcat(s, "r");
if (crc32("bJIekEs",7) == 3325287541) strcat(s, "C");
if (crc32("xVPPBDxkuQnjGrl",15) == 208827801) strcat(s, "i");
if (crc32("eDwmFNoQW",9) == 991284325) strcat(s, "h");
if (crc32("eYcvhTLwBq",10) == 2540438375) strcat(s, "d");
    return s;
}

char *Khama_nouns() {
    char *s = calloc(6);
    if (crc32("YGAnZcmEqmsnTU",14) == 564675579) strcat(s, "a");
if (crc32("JWYIVQBpWGjAn",13) == 1806917824) strcat(s, "K");
if (crc32("lIauu",5) == 2996324136) strcat(s, "r");
if (crc32("NBRXEJ",6) == 3188681337) strcat(s, "h");
if (crc32("NiiEZjshZkOS",12) == 2592883723) strcat(s, "a");
if (crc32("DkPRmVsWNOgKqR",14) == 458218815) strcat(s, "m");
if (crc32("vHogr",5) == 959247309) strcat(s, "a");
    return s;
}

char *nonempiric_nouns() {
    char *s = calloc(11);
    if (crc32("LKiDKkaXc",9) == 209134777) strcat(s, "n");
if (crc32("anonw",5) == 3474786171) strcat(s, "o");
if (crc32("REIOsBrkQjAxACB",15) == 929637619) strcat(s, "n");
if (crc32("rAengBSlJj",10) == 2468035322) strcat(s, "e");
if (crc32("dEyVvyhbEpUQVZ",14) == 2307937152) strcat(s, "s");
if (crc32("uAUVnOXg",8) == 2306208789) strcat(s, "m");
if (crc32("WNNcS",5) == 4050408232) strcat(s, "p");
if (crc32("jzKoYkvMVm",10) == 1288149136) strcat(s, "r");
if (crc32("UwIihtEfPecEOYe",15) == 3647691537) strcat(s, "i");
if (crc32("GJfyJKocq",9) == 1424223124) strcat(s, "r");
if (crc32("JNAxuQsFi",9) == 316038279) strcat(s, "i");
if (crc32("RvJNgpcpkKCYHCt",15) == 1916485569) strcat(s, "A");
if (crc32("BdggAaA",7) == 1545297554) strcat(s, "c");
    return s;
}

char *sweepstakes_nouns() {
    char *s = calloc(12);
    if (crc32("hNoyeCy",7) == 1981036378) strcat(s, "J");
if (crc32("YIDKe",5) == 1291545365) strcat(s, "s");
if (crc32("GFOiEKZFX",9) == 2654776513) strcat(s, "F");
if (crc32("ytkFDi",6) == 2851498280) strcat(s, "w");
if (crc32("DOkrIP",6) == 47732844) strcat(s, "N");
if (crc32("jXaGRbUqFJVBjtQ",15) == 3254306416) strcat(s, "e");
if (crc32("bMbUwxzDHZQL",12) == 3526286485) strcat(s, "e");
if (crc32("SEAaCNKLNTb",11) == 307387166) strcat(s, "l");
if (crc32("LFvjoXVTyWfpc",13) == 3767143298) strcat(s, "p");
if (crc32("kFGYvQRGkTIta",13) == 1109146609) strcat(s, "J");
if (crc32("qRKsZYR",7) == 1336653460) strcat(s, "s");
if (crc32("DKWkMmANtBX",11) == 2333595011) strcat(s, "t");
if (crc32("VzHXQCF",7) == 1753411552) strcat(s, "Z");
if (crc32("cedMoeulJXNy",12) == 4094081438) strcat(s, "a");
if (crc32("bpMMD",5) == 3878124999) strcat(s, "H");
if (crc32("eGtOT",5) == 3643566351) strcat(s, "k");
if (crc32("wVXQSw",6) == 2045695745) strcat(s, "f");
if (crc32("aijOlfpKDnJYPAq",15) == 4270144004) strcat(s, "e");
if (crc32("OtjxC",5) == 3048186476) strcat(s, "s");
    return s;
}

char *Os_nouns() {
    char *s = calloc(3);
    if (crc32("avtrNj",6) == 654404661) strcat(s, "a");
if (crc32("ROTzYSq",7) == 3418418344) strcat(s, "O");
if (crc32("FRUJrdEyc",9) == 3779018615) strcat(s, "d");
if (crc32("TARyBtilexBNa",13) == 643908116) strcat(s, "s");
    return s;
}

char *Brummie_nouns() {
    char *s = calloc(8);
    if (crc32("TRhRAqKuIvEdM",13) == 1933778766) strcat(s, "R");
if (crc32("bzFXTgySDvi",11) == 2090265502) strcat(s, "B");
if (crc32("sRftGJHR",8) == 3982674057) strcat(s, "I");
if (crc32("WwjpTswkPHE",11) == 3839483316) strcat(s, "r");
if (crc32("fELkiPoCMo",10) == 3213921565) strcat(s, "w");
if (crc32("XHzZZIjPVxoWfJ",14) == 1956581293) strcat(s, "u");
if (crc32("jyYfPqctrqiyOk",14) == 2178613688) strcat(s, "m");
if (crc32("TApOJyaVpNq",11) == 3069071332) strcat(s, "D");
if (crc32("MjkjWHvMFYl",11) == 1853628956) strcat(s, "m");
if (crc32("kIBwNe",6) == 2572996819) strcat(s, "O");
if (crc32("rxSDGyEn",8) == 157194076) strcat(s, "i");
if (crc32("lNbtIFBu",8) == 3474440726) strcat(s, "e");
    return s;
}

char *fourragare_nouns() {
    char *s = calloc(11);
    if (crc32("wAVkOrlCodepAK",14) == 2159917256) strcat(s, "D");
if (crc32("MFxkUOHyQX",10) == 2519911635) strcat(s, "f");
if (crc32("CLxUMpENvHUkE",13) == 615745426) strcat(s, "J");
if (crc32("UlziZsFKKgGdiUK",15) == 3406507942) strcat(s, "o");
if (crc32("YeQMQkaolL",10) == 1288431371) strcat(s, "L");
if (crc32("juyiIsUCXLHAzV",14) == 2091547724) strcat(s, "u");
if (crc32("OUzpEU",6) == 2891034678) strcat(s, "m");
if (crc32("wYYaUFU",7) == 4277073051) strcat(s, "r");
if (crc32("XBbUNYLOwPUAZ",13) == 1417407594) strcat(s, "Y");
if (crc32("aNmNNnzHFa",10) == 1642652446) strcat(s, "r");
if (crc32("EqZSXix",7) == 2091082221) strcat(s, "e");
if (crc32("HHCKTt",6) == 1184596653) strcat(s, "a");
if (crc32("aGXXVBxvuwRjUT",14) == 3547150284) strcat(s, "g");
if (crc32("ZkSHhwGni",9) == 27251870) strcat(s, "A");
if (crc32("nxbyC",5) == 349207449) strcat(s, "a");
if (crc32("JCAEvLmXKTxLB",13) == 2726952054) strcat(s, "r");
if (crc32("quXJhPL",7) == 3746387247) strcat(s, "G");
if (crc32("ooTnJcWcbB",10) == 3915054102) strcat(s, "e");
    return s;
}

char *bellpull_nouns() {
    char *s = calloc(9);
    if (crc32("XBklVuhpXqPVBFd",15) == 1562382882) strcat(s, "o");
if (crc32("jAPjFxhHPHIHB",13) == 511761972) strcat(s, "b");
if (crc32("VfweiwBCwxu",11) == 504369746) strcat(s, "e");
if (crc32("XRusuHdSfysLS",13) == 1397051647) strcat(s, "l");
if (crc32("UCjHvCqcmmdqG",13) == 3124925544) strcat(s, "l");
if (crc32("BumRcm",6) == 2079849188) strcat(s, "x");
if (crc32("BsdLPuhuBIccb",13) == 4084998775) strcat(s, "p");
if (crc32("sTLFpjDvqwb",11) == 150552822) strcat(s, "d");
if (crc32("XiMbReAeZpyq",12) == 17814940) strcat(s, "u");
if (crc32("KUQrDpUDeVaK",12) == 4074786542) strcat(s, "l");
if (crc32("ArqfStX",7) == 2736560388) strcat(s, "l");
    return s;
}

char *Plerre_nouns() {
    char *s = calloc(7);
    if (crc32("OWiMXgUxyD",10) == 2783603806) strcat(s, "U");
if (crc32("rVevkbjmXss",11) == 2096788458) strcat(s, "P");
if (crc32("ovHPGw",6) == 2109172348) strcat(s, "l");
if (crc32("fOgUckVXiLvAYyu",15) == 4264847374) strcat(s, "Z");
if (crc32("gWwidCVdO",9) == 3977000149) strcat(s, "e");
if (crc32("JjPuZx",6) == 1262358156) strcat(s, "r");
if (crc32("jnDocmxafBK",11) == 3574991785) strcat(s, "H");
if (crc32("ulGstk",6) == 2007504178) strcat(s, "r");
if (crc32("hVPEARxgZMOWCF",14) == 1728991955) strcat(s, "c");
if (crc32("sINfP",5) == 3162785706) strcat(s, "e");
    return s;
}

char *selfwhipper_nouns() {
    char *s = calloc(12);
    if (crc32("MKwqbMm",7) == 2027551149) strcat(s, "s");
if (crc32("OEkvbXHc",8) == 2291534447) strcat(s, "e");
if (crc32("CIccDIVDqsMgIeM",15) == 158942180) strcat(s, "l");
if (crc32("DqiCnAkIZ",9) == 2034382924) strcat(s, "f");
if (crc32("xIXdzbL",7) == 2807830480) strcat(s, "w");
if (crc32("cMoJvOQgxy",10) == 653024072) strcat(s, "t");
if (crc32("CwxtA",5) == 1072937405) strcat(s, "h");
if (crc32("XycsjclntTZaee",14) == 2592639408) strcat(s, "F");
if (crc32("OJGbSTQohioC",12) == 1737576496) strcat(s, "i");
if (crc32("KoamdSRByxiEqih",15) == 1867704691) strcat(s, "d");
if (crc32("tWIHFOaY",8) == 1081516476) strcat(s, "p");
if (crc32("dNUqQ",5) == 2439302160) strcat(s, "p");
if (crc32("YyxGW",5) == 796700037) strcat(s, "b");
if (crc32("swITbFXFNmnfVWY",15) == 3762037519) strcat(s, "e");
if (crc32("GmCugBM",7) == 2558144915) strcat(s, "g");
if (crc32("EcRIWMRVBDZIhe",14) == 1563073658) strcat(s, "r");
    return s;
}

char *greenbrier_nouns() {
    char *s = calloc(11);
    if (crc32("IAnlO",5) == 3708513533) strcat(s, "g");
if (crc32("qSZvwzIosHO",11) == 2411442858) strcat(s, "C");
if (crc32("SvtHhAYZ",8) == 2785998062) strcat(s, "r");
if (crc32("mahgwebvJyF",11) == 2978435406) strcat(s, "a");
if (crc32("wqOQxBehwG",10) == 1650471277) strcat(s, "e");
if (crc32("UmpGpcNXqftGsp",14) == 2404234988) strcat(s, "d");
if (crc32("LupGzu",6) == 322906909) strcat(s, "e");
if (crc32("aBZyupP",7) == 2160560525) strcat(s, "n");
if (crc32("VUSvowAmiFqPnGv",15) == 2369698470) strcat(s, "M");
if (crc32("LjafKLIKqnBbhD",14) == 3947419624) strcat(s, "b");
if (crc32("akdrDdT",7) == 3193699255) strcat(s, "Z");
if (crc32("MWKvHcFAoYZfDaR",15) == 2562116436) strcat(s, "r");
if (crc32("TRCBPOJpJTtNc",13) == 365005756) strcat(s, "i");
if (crc32("zjsNzLfRKTT",11) == 2579958515) strcat(s, "L");
if (crc32("cgHiARAvtOljsDF",15) == 2238282693) strcat(s, "e");
if (crc32("BRnvtODWoiVFZOX",15) == 4293118060) strcat(s, "p");
if (crc32("iqWvkNKQXkrP",12) == 3975404986) strcat(s, "r");
    return s;
}

char *reexplication_nouns() {
    char *s = calloc(14);
    if (crc32("ZiRVRttH",8) == 3462807830) strcat(s, "B");
if (crc32("ZjzXsFyo",8) == 45467927) strcat(s, "r");
if (crc32("gsBQoaVhaj",10) == 3243205132) strcat(s, "Q");
if (crc32("kRsKtqVsEwVbYN",14) == 3234407087) strcat(s, "e");
if (crc32("ezUeqbsFJdQ",11) == 4145905846) strcat(s, "E");
if (crc32("TCmLOykw",8) == 956016954) strcat(s, "e");
if (crc32("wwyow",5) == 2032607469) strcat(s, "f");
if (crc32("HrkreSEhqt",10) == 3926678889) strcat(s, "x");
if (crc32("RpskHBqW",8) == 900960228) strcat(s, "e");
if (crc32("LOTPtBGK",8) == 3475679182) strcat(s, "p");
if (crc32("mbeVfcbChiFa",12) == 3339311602) strcat(s, "C");
if (crc32("EYCwDgwwyDA",11) == 508718114) strcat(s, "l");
if (crc32("ZIJAE",5) == 3225744525) strcat(s, "i");
if (crc32("xxItWtbHGNNd",12) == 1011757002) strcat(s, "A");
if (crc32("EHBtL",5) == 1337374737) strcat(s, "c");
if (crc32("faqoPdHA",8) == 953407401) strcat(s, "a");
if (crc32("cfFitOydfE",10) == 555194604) strcat(s, "t");
if (crc32("ItQHZviheoL",11) == 1158471396) strcat(s, "i");
if (crc32("bSQCKEMYBq",10) == 1933953617) strcat(s, "M");
if (crc32("ldsftOEAsY",10) == 1648410462) strcat(s, "o");
if (crc32("hBFoYDwIU",9) == 159884448) strcat(s, "Z");
if (crc32("SBMKu",5) == 3274497886) strcat(s, "n");
    return s;
}

char *tipburn_nouns() {
    char *s = calloc(8);
    if (crc32("mjlrVmOJ",8) == 227533858) strcat(s, "x");
if (crc32("AaJDiwGPi",9) == 3738784630) strcat(s, "t");
if (crc32("rECYfK",6) == 2429848508) strcat(s, "F");
if (crc32("MkoZjglr",8) == 3142223062) strcat(s, "i");
if (crc32("iaGCIUIZA",9) == 2501642110) strcat(s, "p");
if (crc32("IvQLN",5) == 2101549692) strcat(s, "b");
if (crc32("dilaMAVtFIOZwtT",15) == 3069769985) strcat(s, "x");
if (crc32("pSgKMbLaLexQPvx",15) == 2117821317) strcat(s, "u");
if (crc32("iHEMyJlI",8) == 1489970991) strcat(s, "t");
if (crc32("MGnftwhwH",9) == 1269793492) strcat(s, "r");
if (crc32("dbdnZsauDrGC",12) == 3968232601) strcat(s, "n");
    return s;
}

char *Oliana_nouns() {
    char *s = calloc(7);
    if (crc32("XsNzHSvAU",9) == 2700426537) strcat(s, "O");
if (crc32("ZAdxvcWl",8) == 1861780890) strcat(s, "i");
if (crc32("yzGScmpEkWOR",12) == 2976279991) strcat(s, "l");
if (crc32("NIxqmKqwzb",10) == 3072500492) strcat(s, "w");
if (crc32("btaJMvrMYrua",12) == 3606761770) strcat(s, "i");
if (crc32("ssdBGxtltaZSlPa",15) == 3733223710) strcat(s, "A");
if (crc32("rPultYe",7) == 2945352393) strcat(s, "a");
if (crc32("qXUGDWGNmufMTy",14) == 2757671263) strcat(s, "r");
if (crc32("iQCqEqrT",8) == 3937145782) strcat(s, "n");
if (crc32("RMqwR",5) == 1571239640) strcat(s, "a");
    return s;
}

char *antitrust_nouns() {
    char *s = calloc(10);
    if (crc32("brFxObH",7) == 3936158104) strcat(s, "a");
if (crc32("QiixAaCss",9) == 38991698) strcat(s, "B");
if (crc32("sieVzyfkaOzJ",12) == 4206107596) strcat(s, "n");
if (crc32("COfClhE",7) == 3228874321) strcat(s, "c");
if (crc32("mLKGcwMK",8) == 4276061328) strcat(s, "t");
if (crc32("NFtqdhAakvjuPT",14) == 1858163853) strcat(s, "s");
if (crc32("TuODPvyZ",8) == 3075603196) strcat(s, "i");
if (crc32("JgwXYGZ",7) == 2735809122) strcat(s, "q");
if (crc32("XydqDSlWYIR",11) == 891696566) strcat(s, "t");
if (crc32("CHVhdT",6) == 2511878977) strcat(s, "r");
if (crc32("pcRMcMGcIgNriXP",15) == 475268434) strcat(s, "u");
if (crc32("ndDYfoPWjO",10) == 3658446403) strcat(s, "Q");
if (crc32("imwNzYJsvE",10) == 2474783152) strcat(s, "s");
if (crc32("pofwHQGF",8) == 847948639) strcat(s, "t");
    return s;
}

char *result_nouns() {
    char *s = calloc(7);
    if (crc32("POsqjpqWOzasmj",14) == 3622669408) strcat(s, "O");
if (crc32("ivSaHYvdfez",11) == 2523174480) strcat(s, "r");
if (crc32("ZgFaNcqgwuhRulc",15) == 259855637) strcat(s, "e");
if (crc32("RsvDnYFYu",9) == 738549150) strcat(s, "s");
if (crc32("vgqdYhHJdHbTaY",14) == 954227924) strcat(s, "u");
if (crc32("BYOUP",5) == 2950181695) strcat(s, "q");
if (crc32("jSQWHyeP",8) == 229946786) strcat(s, "l");
if (crc32("xWYCdb",6) == 3128221874) strcat(s, "t");
    return s;
}

char *Armenia_nouns() {
    char *s = calloc(8);
    if (crc32("IHuIKoJ",7) == 1978287092) strcat(s, "Y");
if (crc32("ujHgV",5) == 1974884892) strcat(s, "A");
if (crc32("lGWRZQLCDAO",11) == 1616402855) strcat(s, "r");
if (crc32("QESuSjJiAzGB",12) == 11087464) strcat(s, "m");
if (crc32("HbroenqZLtxYH",13) == 4229311635) strcat(s, "h");
if (crc32("gPCeyncDEzt",11) == 2708174677) strcat(s, "e");
if (crc32("IJUiBnk",7) == 115448251) strcat(s, "n");
if (crc32("hJKqcFTOscRlW",13) == 625650560) strcat(s, "H");
if (crc32("Djhxlwk",7) == 2019390322) strcat(s, "i");
if (crc32("MsMUpXIa",8) == 1536287228) strcat(s, "a");
    return s;
}

char *Cracy_nouns() {
    char *s = calloc(6);
    if (crc32("FArPwi",6) == 4106897729) strcat(s, "C");
if (crc32("czSOUgImGwgHEn",14) == 1684882587) strcat(s, "N");
if (crc32("QlmMnFj",7) == 640239535) strcat(s, "r");
if (crc32("mFYCssCUHnk",11) == 4137772358) strcat(s, "a");
if (crc32("mxekl",5) == 1232363290) strcat(s, "D");
if (crc32("wfUMASJcZ",9) == 2720830721) strcat(s, "c");
if (crc32("jqlcdOdpqwq",11) == 1652870318) strcat(s, "f");
if (crc32("FTQSWuEfwh",10) == 924795311) strcat(s, "y");
    return s;
}

char *Sailesh_nouns() {
    char *s = calloc(8);
    if (crc32("KFrmbioI",8) == 705306588) strcat(s, "S");
if (crc32("PJHMOw",6) == 812462248) strcat(s, "a");
if (crc32("TKQOVALNtP",10) == 281482508) strcat(s, "i");
if (crc32("uQcXydLcBPQh",12) == 1523609804) strcat(s, "l");
if (crc32("XmbNjjaKZlGTFp",14) == 4079158941) strcat(s, "e");
if (crc32("aLjnoclgZRsB",12) == 2922128952) strcat(s, "q");
if (crc32("EuKyl",5) == 3437690215) strcat(s, "s");
if (crc32("UFcTaAjh",8) == 374260925) strcat(s, "r");
if (crc32("zZSBXLAl",8) == 2908853606) strcat(s, "h");
    return s;
}

char *stooper_nouns() {
    char *s = calloc(8);
    if (crc32("kflHmt",6) == 1304553691) strcat(s, "s");
if (crc32("TBzYzaLP",8) == 2186310922) strcat(s, "t");
if (crc32("KtftCBV",7) == 1668284272) strcat(s, "n");
if (crc32("rPrKdApZv",9) == 2446053572) strcat(s, "o");
if (crc32("FnmDifUSY",9) == 2473660298) strcat(s, "o");
if (crc32("kLWwAxje",8) == 3941689427) strcat(s, "p");
if (crc32("PvFymuNBSTmZd",13) == 1584195933) strcat(s, "e");
if (crc32("ApBtYkO",7) == 2975558594) strcat(s, "e");
if (crc32("krxvILc",7) == 587053377) strcat(s, "r");
    return s;
}

char *Kessiah_nouns() {
    char *s = calloc(8);
    if (crc32("OWUFxSEl",8) == 1199312394) strcat(s, "f");
if (crc32("FnpaWiK",7) == 3468947837) strcat(s, "K");
if (crc32("UpIngXmrNxxA",12) == 3982097051) strcat(s, "e");
if (crc32("IUJWCLW",7) == 2403006116) strcat(s, "s");
if (crc32("dWOvpWT",7) == 2867104049) strcat(s, "s");
if (crc32("EhcZpNJEFVxtV",13) == 1440445268) strcat(s, "i");
if (crc32("jBhgLqrR",8) == 615903086) strcat(s, "i");
if (crc32("qkZOBQodCmgGUu",14) == 2309028455) strcat(s, "a");
if (crc32("EYDFakXP",8) == 2541816419) strcat(s, "h");
if (crc32("AbwVtSnNQgsQwIx",15) == 444901307) strcat(s, "h");
    return s;
}

char *ladrone_nouns() {
    char *s = calloc(8);
    if (crc32("JinIqrDuvO",10) == 335986856) strcat(s, "l");
if (crc32("HPRxjdcVNHKAj",13) == 1828840945) strcat(s, "a");
if (crc32("lkCiBJEclHyvzVk",15) == 300964453) strcat(s, "d");
if (crc32("JhCvytmkTiVJBuM",15) == 3327338076) strcat(s, "r");
if (crc32("CVcVFdAoMoCSg",13) == 1287358351) strcat(s, "v");
if (crc32("ImAXqtMffJOI",12) == 862317471) strcat(s, "o");
if (crc32("nxMjaTcY",8) == 622893496) strcat(s, "e");
if (crc32("TEuvxhs",7) == 1422909755) strcat(s, "n");
if (crc32("lIvGpiLqnwdMj",13) == 1504613138) strcat(s, "S");
if (crc32("KAIQNA",6) == 1435331144) strcat(s, "e");
    return s;
}

char *prefixion_nouns() {
    char *s = calloc(10);
    if (crc32("VDsjZgOXcWIqX",13) == 4280316434) strcat(s, "p");
if (crc32("vMkJQxAQO",9) == 3079671317) strcat(s, "y");
if (crc32("vSzaLBxmIBdvy",13) == 1061642703) strcat(s, "r");
if (crc32("fBMvlxZq",8) == 3152196142) strcat(s, "E");
if (crc32("HrvYfaRrOBF",11) == 2994543634) strcat(s, "e");
if (crc32("WJubk",5) == 952292923) strcat(s, "f");
if (crc32("jpsqFscQFoiAx",13) == 3612278231) strcat(s, "f");
if (crc32("TweKtK",6) == 3771726972) strcat(s, "U");
if (crc32("pOlFBOV",7) == 3946894564) strcat(s, "i");
if (crc32("cFmNzVvpQn",10) == 2610486584) strcat(s, "Z");
if (crc32("jyZgSCUv",8) == 238065891) strcat(s, "x");
if (crc32("kkWUQyAuaT",10) == 1758967619) strcat(s, "i");
if (crc32("OaZDMGX",7) == 681050246) strcat(s, "o");
if (crc32("xyXVAnyRjpKqSCA",15) == 623541250) strcat(s, "n");
    return s;
}

char *purgation_nouns() {
    char *s = calloc(10);
    if (crc32("MRVqnO",6) == 2328232345) strcat(s, "V");
if (crc32("EPUlfuMpwTvQ",12) == 1414916737) strcat(s, "p");
if (crc32("OWNprQw",7) == 3303086143) strcat(s, "j");
if (crc32("SaRECrgq",8) == 2440422911) strcat(s, "u");
if (crc32("bYxifxinpFHLno",14) == 501437144) strcat(s, "T");
if (crc32("PbWZnffBDFciozn",15) == 3246294931) strcat(s, "r");
if (crc32("TlZqm",5) == 508373145) strcat(s, "g");
if (crc32("RczqimZumjGk",12) == 1550924588) strcat(s, "O");
if (crc32("hoqsHQiWHpoBfo",14) == 3123250895) strcat(s, "a");
if (crc32("oqYox",5) == 3507833633) strcat(s, "t");
if (crc32("IWkyJUkRgv",10) == 406858912) strcat(s, "O");
if (crc32("rzgvZoSLbCHNZQ",14) == 1196503562) strcat(s, "i");
if (crc32("nCnqCfY",7) == 3001151505) strcat(s, "c");
if (crc32("ghwWWgZqp",9) == 3465141163) strcat(s, "o");
if (crc32("FGPke",5) == 3225367419) strcat(s, "n");
    return s;
}

char *Thain_nouns() {
    char *s = calloc(6);
    if (crc32("noIfcpCFStp",11) == 1216375977) strcat(s, "T");
if (crc32("VqiUPJnKmDXmeHE",15) == 4287882540) strcat(s, "h");
if (crc32("avWYTGJHv",9) == 3084311830) strcat(s, "A");
if (crc32("VHInyRmI",8) == 696677800) strcat(s, "a");
if (crc32("aXAPjwPT",8) == 1188458389) strcat(s, "i");
if (crc32("WZWsfVVE",8) == 2394326031) strcat(s, "n");
    return s;
}

char *antiOrientalism_nouns() {
    char *s = calloc(16);
    if (crc32("VXMiVpOEGEzyhqG",15) == 3315077676) strcat(s, "a");
if (crc32("gcMjpzR",7) == 1611120576) strcat(s, "J");
if (crc32("rvUIBHsG",8) == 2926689569) strcat(s, "n");
if (crc32("LDgImZuK",8) == 4033334632) strcat(s, "t");
if (crc32("RwkDnaHxCB",10) == 3149246401) strcat(s, "w");
if (crc32("veuyheDYgzB",11) == 3094979814) strcat(s, "i");
if (crc32("SIdqQnn",7) == 266440710) strcat(s, "y");
if (crc32("bmvwDHdCrgLAggB",15) == 783650771) strcat(s, "O");
if (crc32("fFvxHY",6) == 1937503217) strcat(s, "g");
if (crc32("xhmAASJwxuSNpO",14) == 3939537537) strcat(s, "r");
if (crc32("QrdIZEH",7) == 2727433605) strcat(s, "p");
if (crc32("AvSrlYEHlwxqA",13) == 1976143498) strcat(s, "i");
if (crc32("aynAJuPOYoCFZ",13) == 2451419785) strcat(s, "L");
if (crc32("EICBnmt",7) == 1211378382) strcat(s, "e");
if (crc32("ZqUURdEQMvSdF",13) == 2795181938) strcat(s, "T");
if (crc32("OPYvY",5) == 3744666936) strcat(s, "n");
if (crc32("ojCvW",5) == 4097010899) strcat(s, "Z");
if (crc32("XyYffek",7) == 75870562) strcat(s, "t");
if (crc32("PFroTupiVt",10) == 1426064584) strcat(s, "a");
if (crc32("bgBkMAVHG",9) == 3304550267) strcat(s, "l");
if (crc32("LbKJOGNMdZ",10) == 477022658) strcat(s, "i");
if (crc32("mVHqbDaVlJrztg",14) == 2926051802) strcat(s, "T");
if (crc32("JWuWdD",6) == 3489716419) strcat(s, "s");
if (crc32("NdwpsUGjoNinLWb",15) == 1836273129) strcat(s, "m");
    return s;
}

char *Dick_nouns() {
    char *s = calloc(5);
    if (crc32("FBeAmPNomH",10) == 1528681207) strcat(s, "A");
if (crc32("EJagchTyjwm",11) == 1196838429) strcat(s, "D");
if (crc32("yxUyv",5) == 2978416445) strcat(s, "i");
if (crc32("zFqehtg",7) == 444507573) strcat(s, "c");
if (crc32("puhUsMitKRpksiQ",15) == 3555003144) strcat(s, "W");
if (crc32("ItaFg",5) == 1266435969) strcat(s, "k");
    return s;
}

char *Finchley_nouns() {
    char *s = calloc(9);
    if (crc32("CaVGqxgxGRf",11) == 3100330558) strcat(s, "n");
if (crc32("rOaFwmmhmyXIUe",14) == 1275970942) strcat(s, "F");
if (crc32("CXHyrbonSg",10) == 4220460831) strcat(s, "Y");
if (crc32("euxRVSlgjebZ",12) == 4006169902) strcat(s, "i");
if (crc32("orrvAfWevj",10) == 585556213) strcat(s, "f");
if (crc32("dDAwoZn",7) == 1290953650) strcat(s, "n");
if (crc32("qsCoKMHLwyJr",12) == 742279458) strcat(s, "q");
if (crc32("qsOVQqBgDhgeqVc",15) == 592509256) strcat(s, "c");
if (crc32("kfKHyYGjJsj",11) == 1517643193) strcat(s, "h");
if (crc32("zSszyRfSdwc",11) == 3723515410) strcat(s, "l");
if (crc32("wvjBInrW",8) == 434717269) strcat(s, "o");
if (crc32("CwSWRJZ",7) == 970058328) strcat(s, "e");
if (crc32("xSsIArN",7) == 1839867607) strcat(s, "y");
    return s;
}

char *Un_nouns() {
    char *s = calloc(3);
    if (crc32("rEtWgtfyI",9) == 3909753793) strcat(s, "J");
if (crc32("cysmZtfPMLHdhS",14) == 2183640964) strcat(s, "U");
if (crc32("uKsMeONmBtlleh",14) == 1857327628) strcat(s, "n");
    return s;
}

char *Delanos_nouns() {
    char *s = calloc(8);
    if (crc32("tNCRPmNAKf",10) == 3385035200) strcat(s, "D");
if (crc32("ZRKlBrP",7) == 1603534958) strcat(s, "M");
if (crc32("WUemiNpNXbauB",13) == 3588293760) strcat(s, "e");
if (crc32("pJVxpBuCpXmlY",13) == 3663553693) strcat(s, "l");
if (crc32("QgXxWLmLm",9) == 2244901382) strcat(s, "Q");
if (crc32("yafSZphSMYtYwQ",14) == 1385545995) strcat(s, "a");
if (crc32("NgdmJAkEWBcZM",13) == 2184416903) strcat(s, "a");
if (crc32("bSXUmWlY",8) == 2394921908) strcat(s, "n");
if (crc32("DcZhV",5) == 214298481) strcat(s, "o");
if (crc32("zzCKSyQCBKp",11) == 969079752) strcat(s, "v");
if (crc32("byKMPiL",7) == 1289536742) strcat(s, "s");
    return s;
}

char *interownership_nouns() {
    char *s = calloc(15);
    if (crc32("DxlFPrQJqgfgemA",15) == 586811043) strcat(s, "i");
if (crc32("uOauZj",6) == 3813292224) strcat(s, "f");
if (crc32("ZivRicTTuEd",11) == 3297207444) strcat(s, "n");
if (crc32("vXcfmeLLcCRe",12) == 4271239493) strcat(s, "t");
if (crc32("VqForfYMDzFilvU",15) == 1396039406) strcat(s, "X");
if (crc32("ECFDCcbEfAIXW",13) == 1992045364) strcat(s, "e");
if (crc32("sEiWdd",6) == 3371467435) strcat(s, "r");
if (crc32("pvviDvPkbrIu",12) == 1158842607) strcat(s, "o");
if (crc32("nRLjHu",6) == 1302510319) strcat(s, "w");
if (crc32("AErEMwEXds",10) == 8254172) strcat(s, "n");
if (crc32("fnLLSjyCoVaDdF",14) == 1417359358) strcat(s, "q");
if (crc32("MExONPwzuvwWZL",14) == 1901606423) strcat(s, "e");
if (crc32("kKEBzlWiDnssru",14) == 125011487) strcat(s, "i");
if (crc32("pROhZHlsFAapQz",14) == 332614417) strcat(s, "r");
if (crc32("gJJcLpLVdU",10) == 3139822140) strcat(s, "s");
if (crc32("TlclzW",6) == 849235596) strcat(s, "h");
if (crc32("afpdCKmPWqwqca",14) == 3933672349) strcat(s, "E");
if (crc32("iGSZIX",6) == 2289196488) strcat(s, "i");
if (crc32("JJllodvVaby",11) == 756475006) strcat(s, "U");
if (crc32("sAqnJnZsu",9) == 1042110528) strcat(s, "p");
    return s;
}

char *recarburizer_nouns() {
    char *s = calloc(13);
    if (crc32("qsFKDPC",7) == 540845553) strcat(s, "z");
if (crc32("lOexMJlPUURWj",13) == 4048216195) strcat(s, "r");
if (crc32("bSEgwTwRWJqh",12) == 1695597947) strcat(s, "e");
if (crc32("elhKdbZm",8) == 4143670377) strcat(s, "c");
if (crc32("MGurbjBZKX",10) == 341817550) strcat(s, "F");
if (crc32("nzvZKj",6) == 2714467657) strcat(s, "a");
if (crc32("GJOrbcrnv",9) == 3753717685) strcat(s, "S");
if (crc32("jottkGqwjNH",11) == 2253306704) strcat(s, "r");
if (crc32("NgyrOtiaF",9) == 2412571156) strcat(s, "b");
if (crc32("oKkTn",5) == 2701801587) strcat(s, "u");
if (crc32("JcjFkTONjb",10) == 1876406459) strcat(s, "P");
if (crc32("pwyBFTAYO",9) == 3837860250) strcat(s, "r");
if (crc32("TjxULRjE",8) == 2874463616) strcat(s, "i");
if (crc32("TTKBOtwHq",9) == 1822781741) strcat(s, "z");
if (crc32("VGzIfzwXXTKc",12) == 643304901) strcat(s, "e");
if (crc32("NkttVeBGRSbCnvU",15) == 371645120) strcat(s, "k");
if (crc32("RvgoqkgkMecn",12) == 3691234959) strcat(s, "r");
    return s;
}

char *verbiage_nouns() {
    char *s = calloc(9);
    if (crc32("aoebXAYJyoRNkDA",15) == 876214769) strcat(s, "Z");
if (crc32("cXcMORLzGL",10) == 2672000482) strcat(s, "v");
if (crc32("IKfuNnVhrVc",11) == 288307573) strcat(s, "u");
if (crc32("yptZBu",6) == 57354748) strcat(s, "e");
if (crc32("QtaPmzP",7) == 429308686) strcat(s, "r");
if (crc32("kOciiauszyUhMW",14) == 4153953481) strcat(s, "b");
if (crc32("eBRDUbHZTB",10) == 3332719923) strcat(s, "B");
if (crc32("yMkxBlyVcSq",11) == 1848411939) strcat(s, "i");
if (crc32("FuwmDwHYEoBB",12) == 1972108540) strcat(s, "a");
if (crc32("jxOiQkpUkPGvHNJ",15) == 3728882430) strcat(s, "g");
if (crc32("HlGgYQiIWhtd",12) == 2035279066) strcat(s, "B");
if (crc32("lkWpM",5) == 946233789) strcat(s, "e");
    return s;
}

char *Braunstein_nouns() {
    char *s = calloc(11);
    if (crc32("SaksqCEgB",9) == 3721161749) strcat(s, "K");
if (crc32("PmtwMfjLPKAyF",13) == 3765757519) strcat(s, "B");
if (crc32("MKGFpxMwl",9) == 1088723751) strcat(s, "H");
if (crc32("HWilPjNHm",9) == 2694261239) strcat(s, "r");
if (crc32("kYZTVYlxxs",10) == 3979126285) strcat(s, "a");
if (crc32("yJfNyYqHeZNs",12) == 1542624682) strcat(s, "u");
if (crc32("McfnqLdbMcdFvi",14) == 1521895595) strcat(s, "W");
if (crc32("KkxJDMRbHDdXTX",14) == 2968757496) strcat(s, "n");
if (crc32("AFKJIZyqwQS",11) == 169244215) strcat(s, "S");
if (crc32("OyUJNfhfrOTptot",15) == 2939179586) strcat(s, "s");
if (crc32("iPgGkJlKhp",10) == 1741087127) strcat(s, "t");
if (crc32("bGQiSJP",7) == 3745677318) strcat(s, "e");
if (crc32("QVCvcRafcva",11) == 2749043123) strcat(s, "i");
if (crc32("GaEKspHTmIs",11) == 3219741527) strcat(s, "a");
if (crc32("QmLqmqHPHVBIz",13) == 2053116476) strcat(s, "n");
    return s;
}

char *Delija_nouns() {
    char *s = calloc(7);
    if (crc32("LMqhRJ",6) == 3063573104) strcat(s, "f");
if (crc32("DmdOLUoJTlfekf",14) == 1110605276) strcat(s, "D");
if (crc32("EBkxZ",5) == 1341579079) strcat(s, "e");
if (crc32("GdlngbaQkQjc",12) == 1249217218) strcat(s, "l");
if (crc32("tNOIQbUiUddsu",13) == 2008748714) strcat(s, "u");
if (crc32("HMfqMVN",7) == 2574790672) strcat(s, "i");
if (crc32("hwWYFjoxNfCbH",13) == 3445656152) strcat(s, "j");
if (crc32("WiXZEoXTpKOvlFD",15) == 1901035463) strcat(s, "a");
    return s;
}

char *frizzer_nouns() {
    char *s = calloc(8);
    if (crc32("QlEaByx",7) == 2806830876) strcat(s, "f");
if (crc32("HHorIyou",8) == 3979904444) strcat(s, "r");
if (crc32("wVvggEW",7) == 2341380694) strcat(s, "i");
if (crc32("zWrjHfcEH",9) == 3349804744) strcat(s, "z");
if (crc32("IizJULVcT",9) == 753187888) strcat(s, "Y");
if (crc32("rXuQTdmETV",10) == 2713793602) strcat(s, "z");
if (crc32("bOqaEDJnh",9) == 2901005739) strcat(s, "e");
if (crc32("GuPfJxu",7) == 1369759073) strcat(s, "o");
if (crc32("oNAcIqc",7) == 68448096) strcat(s, "r");
    return s;
}

char *Naamann_nouns() {
    char *s = calloc(8);
    if (crc32("zAcNseP",7) == 2441065310) strcat(s, "N");
if (crc32("eFsvcS",6) == 2869735705) strcat(s, "a");
if (crc32("SWKfavVTWh",10) == 1203059176) strcat(s, "R");
if (crc32("EAlSAnSGE",9) == 942260640) strcat(s, "a");
if (crc32("YqvBSDjwUVdq",12) == 3583574696) strcat(s, "m");
if (crc32("hdfJjfokgtRBA",13) == 1231209925) strcat(s, "i");
if (crc32("RgvJZcA",7) == 2429310768) strcat(s, "a");
if (crc32("ysrxTGzXX",9) == 2176078702) strcat(s, "n");
if (crc32("kMCCqj",6) == 4064762818) strcat(s, "t");
if (crc32("PPmFQT",6) == 4154606027) strcat(s, "n");
    return s;
}

char *hydraulics_nouns() {
    char *s = calloc(11);
    if (crc32("yTVwhKR",7) == 3793002151) strcat(s, "h");
if (crc32("DCGPPMulWFcKCWB",15) == 1524981262) strcat(s, "A");
if (crc32("TquXoaOcAERZvxQ",15) == 1807762911) strcat(s, "y");
if (crc32("lyljdEtA",8) == 2683067543) strcat(s, "x");
if (crc32("slxtbavkKq",10) == 4228294153) strcat(s, "d");
if (crc32("eludqbkRKCxw",12) == 2992418763) strcat(s, "A");
if (crc32("gRFRZsSDWoQIWY",14) == 1130021031) strcat(s, "r");
if (crc32("NhpwycUoFQ",10) == 3920657642) strcat(s, "G");
if (crc32("QfzpZMXRpGn",11) == 3679718977) strcat(s, "a");
if (crc32("kGgss",5) == 1329327015) strcat(s, "U");
if (crc32("QjhHJZtWdzt",11) == 3543263810) strcat(s, "u");
if (crc32("DqdXTaOcGIUiLhD",15) == 121078133) strcat(s, "l");
if (crc32("pMIHNkjbYWr",11) == 741952466) strcat(s, "h");
if (crc32("giJBAyaKDi",10) == 609222712) strcat(s, "i");
if (crc32("nTzgTjdfY",9) == 557340093) strcat(s, "w");
if (crc32("YxJyOCmeY",9) == 2452293906) strcat(s, "c");
if (crc32("VSmRSPlO",8) == 2294325371) strcat(s, "s");
    return s;
}

char *jugulation_nouns() {
    char *s = calloc(11);
    if (crc32("uLkvv",5) == 2723369375) strcat(s, "j");
if (crc32("REMZF",5) == 2408746065) strcat(s, "u");
if (crc32("NlqfwqTDEtmKfZ",14) == 2788001858) strcat(s, "H");
if (crc32("WyYPdwAaRm",10) == 2220510332) strcat(s, "g");
if (crc32("BaNxMyLWpPSGW",13) == 2431798907) strcat(s, "M");
if (crc32("epEdUK",6) == 3590268287) strcat(s, "u");
if (crc32("BeatFOKQoOmOdod",15) == 465551083) strcat(s, "l");
if (crc32("zgwFozjZ",8) == 4189618654) strcat(s, "a");
if (crc32("rzPhtosnPTNA",12) == 2808700603) strcat(s, "D");
if (crc32("zYkfLPOr",8) == 3995732430) strcat(s, "t");
if (crc32("pvwajqxLkRSUnoS",15) == 3879685954) strcat(s, "Z");
if (crc32("riTfLIE",7) == 1144239309) strcat(s, "i");
if (crc32("yZZat",5) == 3914492464) strcat(s, "r");
if (crc32("nQCWo",5) == 3384463925) strcat(s, "o");
if (crc32("VaKVdamg",8) == 2648487627) strcat(s, "C");
if (crc32("nWWiQOPSNaAvc",13) == 1265741123) strcat(s, "n");
    return s;
}

char *Helman_nouns() {
    char *s = calloc(7);
    if (crc32("EywnDp",6) == 1780760048) strcat(s, "H");
if (crc32("nAUTDcsgRtwf",12) == 2592964740) strcat(s, "e");
if (crc32("eoHHgvZAcQu",11) == 4276438134) strcat(s, "l");
if (crc32("HGGdNGbpqIDABtL",15) == 2421593639) strcat(s, "m");
if (crc32("YWkWMDjT",8) == 3435184067) strcat(s, "a");
if (crc32("eikXfHpNOqhU",12) == 2584070474) strcat(s, "y");
if (crc32("jBBtzDzRH",9) == 153345397) strcat(s, "n");
    return s;
}

char *Jacenta_nouns() {
    char *s = calloc(8);
    if (crc32("nLYrEI",6) == 2101462179) strcat(s, "J");
if (crc32("UEUPLVKTfINVGTw",15) == 3456987338) strcat(s, "a");
if (crc32("BXySfwjQ",8) == 3906311736) strcat(s, "p");
if (crc32("ufjejQoUWR",10) == 2441558967) strcat(s, "c");
if (crc32("SmPhOSCvAEOEx",13) == 708169142) strcat(s, "y");
if (crc32("UuJKOvyNBIaTZ",13) == 174112302) strcat(s, "e");
if (crc32("lvGLWlrgFzyf",12) == 3353519344) strcat(s, "n");
if (crc32("vTEVc",5) == 3134521244) strcat(s, "t");
if (crc32("GVJuvEfqzv",10) == 3800343763) strcat(s, "O");
if (crc32("EBvQQJLBkktj",12) == 2927656557) strcat(s, "a");
    return s;
}

char *hydroxybenzene_nouns() {
    char *s = calloc(15);
    if (crc32("fmGTQTTATj",10) == 710648239) strcat(s, "h");
if (crc32("JyGjcpWWBmP",11) == 1254766530) strcat(s, "f");
if (crc32("aLQHvGTv",8) == 162103495) strcat(s, "y");
if (crc32("GwefYDVQghO",11) == 3035693507) strcat(s, "q");
if (crc32("iUUcrZHWw",9) == 2519910922) strcat(s, "d");
if (crc32("BCCRsntEw",9) == 225360267) strcat(s, "o");
if (crc32("iuUYpZoQr",9) == 2874662043) strcat(s, "r");
if (crc32("Dzlcfwa",7) == 3830541183) strcat(s, "o");
if (crc32("cKaVSZ",6) == 3775054102) strcat(s, "x");
if (crc32("NyDQqIOchT",10) == 2930525574) strcat(s, "k");
if (crc32("fOpaz",5) == 2346751759) strcat(s, "y");
if (crc32("ntBTWNK",7) == 705108720) strcat(s, "u");
if (crc32("jyyuobgtohUExFT",15) == 1691496226) strcat(s, "b");
if (crc32("xNnSVkCfE",9) == 3631962144) strcat(s, "R");
if (crc32("avGao",5) == 4162513866) strcat(s, "e");
if (crc32("TUiuWjG",7) == 2927186644) strcat(s, "h");
if (crc32("sRHUObnj",8) == 1047715956) strcat(s, "n");
if (crc32("jFsiy",5) == 1619939439) strcat(s, "z");
if (crc32("skoTPqUYC",9) == 1292645344) strcat(s, "e");
if (crc32("zbqxwjDwrsyuL",13) == 1410904469) strcat(s, "Q");
if (crc32("TEErKCH",7) == 2614788462) strcat(s, "n");
if (crc32("yfpEu",5) == 1701236110) strcat(s, "C");
if (crc32("FYiAk",5) == 3549441255) strcat(s, "e");
    return s;
}

char *bargeboard_nouns() {
    char *s = calloc(11);
    if (crc32("nWIvSeyYaUXMzG",14) == 1611970620) strcat(s, "b");
if (crc32("QtKjeMAAwHEC",12) == 3759276934) strcat(s, "z");
if (crc32("OayJIubIlL",10) == 3580139004) strcat(s, "a");
if (crc32("QOWiJZWb",8) == 4145885176) strcat(s, "o");
if (crc32("dGSVPpihKMrQ",12) == 4133249673) strcat(s, "r");
if (crc32("PuneEvCaJGol",12) == 3362290975) strcat(s, "C");
if (crc32("qnsqgdYWRvGEVf",14) == 2943319771) strcat(s, "g");
if (crc32("YmDkLvMIA",9) == 705964491) strcat(s, "e");
if (crc32("ltPVdEak",8) == 621764976) strcat(s, "b");
if (crc32("MnELcljae",9) == 4187206182) strcat(s, "f");
if (crc32("aPXXiuSS",8) == 3320349824) strcat(s, "o");
if (crc32("TPEjs",5) == 1471097656) strcat(s, "e");
if (crc32("tiGFzdCanwb",11) == 2612028218) strcat(s, "a");
if (crc32("FWrTN",5) == 1603085590) strcat(s, "r");
if (crc32("yRWyyafcWRoBff",14) == 188413522) strcat(s, "e");
if (crc32("spoJPZ",6) == 3941283070) strcat(s, "d");
    return s;
}

char *jackinoffice_nouns() {
    char *s = calloc(13);
    if (crc32("vljIayaCAYJSkL",14) == 2710534023) strcat(s, "j");
if (crc32("cBakbZB",7) == 3187836594) strcat(s, "a");
if (crc32("BZdznXst",8) == 1125415178) strcat(s, "c");
if (crc32("SKxnaeEZwOQpcny",15) == 4142316612) strcat(s, "b");
if (crc32("uqfoSJRLG",9) == 2102781132) strcat(s, "k");
if (crc32("HLawoPhSROmy",12) == 1766719281) strcat(s, "i");
if (crc32("NneaRyEFKCu",11) == 467491859) strcat(s, "n");
if (crc32("QgQNJ",5) == 4029501534) strcat(s, "o");
if (crc32("gSJxunZjqiA",11) == 245558985) strcat(s, "R");
if (crc32("HjgafBNxLvnhhLF",15) == 67132861) strcat(s, "f");
if (crc32("LaxAoqiGDd",10) == 2684033006) strcat(s, "d");
if (crc32("piypJao",7) == 501505500) strcat(s, "f");
if (crc32("jgWbikbM",8) == 933790394) strcat(s, "F");
if (crc32("xwtHgxAAwmhp",12) == 4221189619) strcat(s, "i");
if (crc32("zGoZygtpcscvDEO",15) == 1637887435) strcat(s, "c");
if (crc32("LloDzHd",7) == 2323739742) strcat(s, "o");
if (crc32("dBzJpEuzCiRRONC",15) == 1737101941) strcat(s, "e");
    return s;
}

char *Bandkeramik_nouns() {
    char *s = calloc(12);
    if (crc32("RJedXP",6) == 3481857938) strcat(s, "F");
if (crc32("EVRuckbT",8) == 1660086730) strcat(s, "B");
if (crc32("tRCugrncX",9) == 4047783320) strcat(s, "a");
if (crc32("qNyfFQYOIhVnIhU",15) == 2532134230) strcat(s, "Q");
if (crc32("snpoxQ",6) == 3376982525) strcat(s, "n");
if (crc32("vNOHwhzYlauV",12) == 1471456360) strcat(s, "d");
if (crc32("msnbIrcwETddyf",14) == 3700981626) strcat(s, "k");
if (crc32("xqohguj",7) == 3587340406) strcat(s, "e");
if (crc32("gdyVDpy",7) == 2526841823) strcat(s, "I");
if (crc32("VZalCKiwLAEY",12) == 214201727) strcat(s, "r");
if (crc32("ggQwxNtDGoM",11) == 2411941335) strcat(s, "a");
if (crc32("QaEOsnlpbkeqcNp",15) == 637157397) strcat(s, "m");
if (crc32("gzzGXtFtTxWXd",13) == 2288459528) strcat(s, "p");
if (crc32("HWDXs",5) == 881197384) strcat(s, "i");
if (crc32("jqlmHiOgNCX",11) == 3934536432) strcat(s, "p");
if (crc32("TLGqgvDW",8) == 1990024189) strcat(s, "k");
    return s;
}

char *Sharleen_nouns() {
    char *s = calloc(9);
    if (crc32("nbgRyPhWGAyFcgH",15) == 1998986654) strcat(s, "G");
if (crc32("NMkmuDADO",9) == 1500548798) strcat(s, "S");
if (crc32("ZeORVup",7) == 2469089618) strcat(s, "h");
if (crc32("HrorlMMGMHiaLFM",15) == 2134377560) strcat(s, "R");
if (crc32("yBEHHzZKVXg",11) == 817166685) strcat(s, "a");
if (crc32("DgesVXLHALcWLTJ",15) == 1666029189) strcat(s, "M");
if (crc32("WsHdMZ",6) == 3240925567) strcat(s, "r");
if (crc32("ERWQlpfnuCB",11) == 1707422367) strcat(s, "l");
if (crc32("PHijLxUcGm",10) == 2638848807) strcat(s, "R");
if (crc32("hudFBSfXnola",12) == 1807670032) strcat(s, "e");
if (crc32("hITtskTttqWG",12) == 2033313686) strcat(s, "e");
if (crc32("poaTJGiamYLyxYU",15) == 596647582) strcat(s, "n");
    return s;
}

char *Phrixus_nouns() {
    char *s = calloc(8);
    if (crc32("oGVytox",7) == 3169337905) strcat(s, "P");
if (crc32("GYDElGiK",8) == 2784607410) strcat(s, "h");
if (crc32("AtDqbFmsNOdPOL",14) == 2868846051) strcat(s, "r");
if (crc32("cRBrnopQfHM",11) == 3590843268) strcat(s, "I");
if (crc32("nqYtXAbdfbffXj",14) == 551997814) strcat(s, "i");
if (crc32("MRtiq",5) == 3347119364) strcat(s, "x");
if (crc32("KRXxfEAIKV",10) == 3763480219) strcat(s, "D");
if (crc32("KFThvuGhvKspbl",14) == 28742496) strcat(s, "u");
if (crc32("NJonLIarZ",9) == 941487487) strcat(s, "V");
if (crc32("tejBqbGueglvb",13) == 782118587) strcat(s, "s");
    return s;
}

char *submersibility_nouns() {
    char *s = calloc(15);
    if (crc32("mkzUKxTUW",9) == 858575895) strcat(s, "D");
if (crc32("fguBYHQXh",9) == 3628643856) strcat(s, "s");
if (crc32("vbkjUvViJYCGo",13) == 3986103018) strcat(s, "u");
if (crc32("sJInZfA",7) == 862097547) strcat(s, "b");
if (crc32("cLVrDTDiezdiitv",15) == 1411966277) strcat(s, "R");
if (crc32("kSfbqeaLhKvfLC",14) == 2211404118) strcat(s, "m");
if (crc32("RXrlPoWdujQW",12) == 1005357466) strcat(s, "e");
if (crc32("qqtvpE",6) == 681990520) strcat(s, "r");
if (crc32("KPeHDSaoIVptbXp",15) == 2500631530) strcat(s, "n");
if (crc32("fWlmTWeAZpVAA",13) == 1670709541) strcat(s, "s");
if (crc32("pDIoaVrO",8) == 1404569636) strcat(s, "N");
if (crc32("EaAcXzmgpAmr",12) == 1933905110) strcat(s, "i");
if (crc32("dYOpiawXKRbyq",13) == 705511337) strcat(s, "b");
if (crc32("wyoLSpqj",8) == 3370963506) strcat(s, "i");
if (crc32("kjUROoKynTGyguk",15) == 777039580) strcat(s, "l");
if (crc32("gpvjZ",5) == 1979115052) strcat(s, "l");
if (crc32("cmgGAwRUI",9) == 2697598781) strcat(s, "i");
if (crc32("cLTxi",5) == 1901048171) strcat(s, "t");
if (crc32("KTArwrk",7) == 1333350000) strcat(s, "L");
if (crc32("uHveDuGQDr",10) == 3242845495) strcat(s, "y");
    return s;
}

char *Fourierist_nouns() {
    char *s = calloc(11);
    if (crc32("zDeEE",5) == 2761082765) strcat(s, "F");
if (crc32("WDeQSoJh",8) == 2172276966) strcat(s, "u");
if (crc32("dTqPtIAmLe",10) == 2431919013) strcat(s, "o");
if (crc32("MyAmbbeFexeb",12) == 3147454813) strcat(s, "B");
if (crc32("wBitiqoLH",9) == 3071258288) strcat(s, "u");
if (crc32("rPfSKLUDVTcQyr",14) == 354592571) strcat(s, "r");
if (crc32("iBZGM",5) == 3043179806) strcat(s, "i");
if (crc32("QBjSYPTyjRo",11) == 733721837) strcat(s, "e");
if (crc32("tMQuCjZCMqvT",12) == 3189462359) strcat(s, "r");
if (crc32("qtjQctRgE",9) == 4158992442) strcat(s, "P");
if (crc32("LxqbavSe",8) == 2561897226) strcat(s, "i");
if (crc32("xVNsas",6) == 2037815043) strcat(s, "s");
if (crc32("JSxCgkl",7) == 949719415) strcat(s, "t");
    return s;
}

char *alLat_nouns() {
    char *s = calloc(6);
    if (crc32("OWIdbyS",7) == 3225722770) strcat(s, "v");
if (crc32("dPmzO",5) == 304200764) strcat(s, "a");
if (crc32("pntitqZa",8) == 3722834454) strcat(s, "l");
if (crc32("zqxSZpXzzahE",12) == 3111215768) strcat(s, "L");
if (crc32("VKFGrNAiW",9) == 1854007185) strcat(s, "a");
if (crc32("LnduByKBjVjz",12) == 2015437832) strcat(s, "G");
if (crc32("YBXlM",5) == 1639361695) strcat(s, "t");
    return s;
}

char *Nava_nouns() {
    char *s = calloc(5);
    if (crc32("ItnmD",5) == 2486668455) strcat(s, "N");
if (crc32("HSvwC",5) == 2832117536) strcat(s, "a");
if (crc32("ewggKJzSTtiCdgM",15) == 4092776202) strcat(s, "v");
if (crc32("EFymG",5) == 3836169636) strcat(s, "X");
if (crc32("zdrvONDcQjDrrGI",15) == 2368905908) strcat(s, "a");
    return s;
}

char *brother_nouns() {
    char *s = calloc(8);
    if (crc32("LsxaWSUTFCsc",12) == 1655376973) strcat(s, "e");
if (crc32("nIgYued",7) == 4090152975) strcat(s, "b");
if (crc32("oYtCNNwtgkYs",12) == 1208829178) strcat(s, "r");
if (crc32("xfRvP",5) == 3962336948) strcat(s, "r");
if (crc32("UtJvNzJ",7) == 435712041) strcat(s, "o");
if (crc32("zsZgCekQFZoMIDj",15) == 3466855758) strcat(s, "t");
if (crc32("EUFYQL",6) == 528222647) strcat(s, "h");
if (crc32("dAfSR",5) == 4264651250) strcat(s, "B");
if (crc32("RbpIlhCSI",9) == 2722549901) strcat(s, "e");
if (crc32("KgnwT",5) == 29478153) strcat(s, "r");
    return s;
}

char *pep_nouns() {
    char *s = calloc(4);
    if (crc32("ByFbzdpIsmYzIW",14) == 3507434747) strcat(s, "p");
if (crc32("EklXpuKmrffwaGH",15) == 3438335780) strcat(s, "q");
if (crc32("ZEurxD",6) == 285722604) strcat(s, "e");
if (crc32("bbwobPNTz",9) == 3671597471) strcat(s, "L");
if (crc32("xRiJgOEaqustytA",15) == 1329387570) strcat(s, "p");
    return s;
}

char *Stefan_nouns() {
    char *s = calloc(7);
    if (crc32("pqsFHEaqc",9) == 2961717096) strcat(s, "b");
if (crc32("iEHsjpHbm",9) == 790277217) strcat(s, "S");
if (crc32("bcaCDyZMdpySZi",14) == 1521817159) strcat(s, "U");
if (crc32("YraFIzyL",8) == 2118824613) strcat(s, "t");
if (crc32("oIVxL",5) == 3222395662) strcat(s, "Q");
if (crc32("xREThdElRcMJOh",14) == 1342689483) strcat(s, "e");
if (crc32("tIpUkKoXOVU",11) == 1267815338) strcat(s, "B");
if (crc32("jOUhinAwsJA",11) == 1876365834) strcat(s, "f");
if (crc32("XiWvrmI",7) == 4008483399) strcat(s, "a");
if (crc32("jxsqL",5) == 3106994990) strcat(s, "N");
if (crc32("FFQqzQr",7) == 4052469325) strcat(s, "n");
    return s;
}

char *Ashtoreth_nouns() {
    char *s = calloc(10);
    if (crc32("OYmXpGBA",8) == 1118133402) strcat(s, "A");
if (crc32("SkFvaiJbKBKhn",13) == 1668968294) strcat(s, "s");
if (crc32("HSqlefaHmjCttjI",15) == 2990500774) strcat(s, "b");
if (crc32("ZdglYqEGT",9) == 656188682) strcat(s, "h");
if (crc32("fbqUhDfoOG",10) == 3619304184) strcat(s, "t");
if (crc32("zCZakznQYyGwN",13) == 873527114) strcat(s, "o");
if (crc32("QWQmneeDjerR",12) == 3811679666) strcat(s, "r");
if (crc32("fVzlsTyOXvyG",12) == 1019646564) strcat(s, "r");
if (crc32("CpqDhyeot",9) == 269636733) strcat(s, "L");
if (crc32("RrFwb",5) == 4061273494) strcat(s, "e");
if (crc32("MQOIdgwsnHP",11) == 1585842952) strcat(s, "t");
if (crc32("PcbLoJapD",9) == 1457283318) strcat(s, "h");
    return s;
}

char *Groark_nouns() {
    char *s = calloc(7);
    if (crc32("dRHcKc",6) == 3010712515) strcat(s, "G");
if (crc32("tJnTFWlurNa",11) == 3697319275) strcat(s, "r");
if (crc32("nGxWGSzoxFON",12) == 181349503) strcat(s, "o");
if (crc32("vGjvciTRHKNq",12) == 4105996551) strcat(s, "a");
if (crc32("gOjyWPwMerEt",12) == 1626823371) strcat(s, "N");
if (crc32("ZsTWwUk",7) == 1076111340) strcat(s, "r");
if (crc32("xfyHSBXYiZ",10) == 401264535) strcat(s, "k");
    return s;
}

char *misapprehension_nouns() {
    char *s = calloc(16);
    if (crc32("ccHiAS",6) == 2936237728) strcat(s, "s");
if (crc32("hlzAD",5) == 3743782241) strcat(s, "m");
if (crc32("hjREOg",6) == 3795927597) strcat(s, "z");
if (crc32("zbndLjIuEor",11) == 1809967701) strcat(s, "i");
if (crc32("ndjwxqI",7) == 2469190184) strcat(s, "s");
if (crc32("vaHaaKpkpu",10) == 604762175) strcat(s, "Q");
if (crc32("kOHBujDnZsVi",12) == 1234802813) strcat(s, "a");
if (crc32("wcNaVZril",9) == 779107633) strcat(s, "h");
if (crc32("NnBTBzsTQeBk",12) == 1406365842) strcat(s, "p");
if (crc32("aFQPlBdUmrsJQg",14) == 1595606310) strcat(s, "p");
if (crc32("zjyHhLcqoPXK",12) == 3114573610) strcat(s, "l");
if (crc32("KSnWedbUzSjW",12) == 1346226528) strcat(s, "r");
if (crc32("xakRNweJAuhPwte",15) == 33303661) strcat(s, "e");
if (crc32("ELDQMpOTJTTXtu",14) == 732924669) strcat(s, "e");
if (crc32("TrsghVMiGivO",12) == 761979478) strcat(s, "y");
if (crc32("LSocppxneTauJ",13) == 3006889314) strcat(s, "h");
if (crc32("vmKdIQyU",8) == 4123842197) strcat(s, "c");
if (crc32("OnmRzCVeiUk",11) == 2078527965) strcat(s, "e");
if (crc32("CxYSBjpOBMtCmKn",15) == 2434583624) strcat(s, "h");
if (crc32("ZPrTnTCINsbw",12) == 1915209107) strcat(s, "n");
if (crc32("UPkQekaDSe",10) == 677039213) strcat(s, "s");
if (crc32("lNufcQ",6) == 1798321808) strcat(s, "i");
if (crc32("brWeanvtRaf",11) == 470834043) strcat(s, "N");
if (crc32("uRfdtqUFa",9) == 420316924) strcat(s, "o");
if (crc32("DmZAGlUIcsQSR",13) == 2504787918) strcat(s, "n");
    return s;
}

char *ugliness_nouns() {
    char *s = calloc(9);
    if (crc32("RrboS",5) == 357917166) strcat(s, "O");
if (crc32("QfydpVt",7) == 1771902071) strcat(s, "u");
if (crc32("eBqjcRQ",7) == 1210835598) strcat(s, "g");
if (crc32("UHMqblM",7) == 4129082534) strcat(s, "l");
if (crc32("anJetkAaslM",11) == 1966073367) strcat(s, "l");
if (crc32("rvnca",5) == 1028142194) strcat(s, "i");
if (crc32("iAOmWjsmsNqVee",14) == 1308076767) strcat(s, "X");
if (crc32("ZokoaxGYGIxyOV",14) == 811587594) strcat(s, "n");
if (crc32("CuCfaYiaZqj",11) == 3041723898) strcat(s, "f");
if (crc32("HnGqNjVMqvtlb",13) == 3627231789) strcat(s, "e");
if (crc32("YFDXvMOD",8) == 2759625767) strcat(s, "s");
if (crc32("TIOajZhPVlXHBg",14) == 3816705205) strcat(s, "M");
if (crc32("JCgQFbbTdhdhmII",15) == 3162370199) strcat(s, "s");
    return s;
}

char *embroiderer_nouns() {
    char *s = calloc(12);
    if (crc32("DOzEXqGTqBJZ",12) == 1992238405) strcat(s, "E");
if (crc32("nepkndzQvoCE",12) == 1982140869) strcat(s, "e");
if (crc32("FslsWPcaSIj",11) == 2237535950) strcat(s, "m");
if (crc32("pcvTRTuQPKS",11) == 2647412523) strcat(s, "p");
if (crc32("YYUsrIXNcLYsnD",14) == 2122707710) strcat(s, "b");
if (crc32("ACAkxyKqVk",10) == 757037672) strcat(s, "N");
if (crc32("DqPiPxVLyyC",11) == 1096217982) strcat(s, "r");
if (crc32("GvBUD",5) == 2779656193) strcat(s, "P");
if (crc32("oQFJSPS",7) == 578412643) strcat(s, "o");
if (crc32("HhXyzLK",7) == 4108285916) strcat(s, "i");
if (crc32("pPCrLfxJVO",10) == 211338968) strcat(s, "d");
if (crc32("pLwcVFFQsoJpd",13) == 2789865752) strcat(s, "e");
if (crc32("OSlLUENOQyZNvG",14) == 1820462776) strcat(s, "U");
if (crc32("OgVAKlaSQ",9) == 590453663) strcat(s, "r");
if (crc32("hjTLzv",6) == 3619613276) strcat(s, "e");
if (crc32("TkFnONWOk",9) == 873047529) strcat(s, "r");
    return s;
}

char *CCP_nouns() {
    char *s = calloc(4);
    if (crc32("IATgxUlh",8) == 1130115127) strcat(s, "C");
if (crc32("tYQkjQlrWTtH",12) == 3776744339) strcat(s, "C");
if (crc32("FWcvRdZQJkbY",12) == 2041328830) strcat(s, "P");
    return s;
}

char *harmonium_nouns() {
    char *s = calloc(10);
    if (crc32("JLdwNL",6) == 1986546768) strcat(s, "h");
if (crc32("jzuriyRBsts",11) == 4193478953) strcat(s, "a");
if (crc32("mYEiRlMTBRU",11) == 3776328141) strcat(s, "B");
if (crc32("UerScDSIdP",10) == 3104960127) strcat(s, "r");
if (crc32("HspTQiWHvsX",11) == 1957261757) strcat(s, "m");
if (crc32("IEFrUh",6) == 1680463514) strcat(s, "o");
if (crc32("naKlhAweZ",9) == 531847702) strcat(s, "n");
if (crc32("xlzgGBHtHrgT",12) == 2328758637) strcat(s, "i");
if (crc32("FTcUYotOI",9) == 2089123775) strcat(s, "v");
if (crc32("sYRFD",5) == 1996471038) strcat(s, "u");
if (crc32("NrgwsJc",7) == 2597457804) strcat(s, "m");
    return s;
}

char *Aiden_nouns() {
    char *s = calloc(6);
    if (crc32("hyBWl",5) == 729852698) strcat(s, "x");
if (crc32("hSLKYRtBlxsckb",14) == 1483621577) strcat(s, "A");
if (crc32("LzYvCesC",8) == 576786425) strcat(s, "i");
if (crc32("tuXrqF",6) == 3583254795) strcat(s, "X");
if (crc32("pxtHN",5) == 1799878327) strcat(s, "d");
if (crc32("iMeFvMw",7) == 3031345979) strcat(s, "B");
if (crc32("ANZpErSgYQJ",11) == 1749108665) strcat(s, "e");
if (crc32("HrjqN",5) == 3515256086) strcat(s, "a");
if (crc32("yryMf",5) == 1240513358) strcat(s, "n");
    return s;
}

char *tanning_nouns() {
    char *s = calloc(8);
    if (crc32("kigUsBXVpRkaJJE",15) == 2835164834) strcat(s, "t");
if (crc32("GwkELWWnY",9) == 1739093046) strcat(s, "a");
if (crc32("EdkoPXrGoneCvV",14) == 94972141) strcat(s, "n");
if (crc32("LYUZJfVUFfnk",12) == 2197172340) strcat(s, "d");
if (crc32("yMvUDTYUwde",11) == 2561612407) strcat(s, "n");
if (crc32("fahaOQUTZku",11) == 276405109) strcat(s, "i");
if (crc32("tDrvRFs",7) == 4154760572) strcat(s, "E");
if (crc32("tjDSxOQrODw",11) == 2131799792) strcat(s, "n");
if (crc32("wHpVmBfhPIDNZt",14) == 1465247356) strcat(s, "g");
    return s;
}

char *deplorableness_nouns() {
    char *s = calloc(15);
    if (crc32("cbZqQcRplQmae",13) == 1373178744) strcat(s, "d");
if (crc32("MuKblSBo",8) == 2792956996) strcat(s, "w");
if (crc32("FasDR",5) == 3586958914) strcat(s, "e");
if (crc32("oZmxliN",7) == 3547701928) strcat(s, "x");
if (crc32("pnsyboL",7) == 1038316011) strcat(s, "p");
if (crc32("oKKDxibcjDXXwt",14) == 335857226) strcat(s, "l");
if (crc32("vlbLtCIJgWrbirh",15) == 2873144512) strcat(s, "o");
if (crc32("PmImtzMS",8) == 2568880793) strcat(s, "r");
if (crc32("ONXzPo",6) == 2556826724) strcat(s, "a");
if (crc32("BqCrXvxUjXknw",13) == 2762039910) strcat(s, "S");
if (crc32("JhVOO",5) == 3544200656) strcat(s, "b");
if (crc32("SkzvsQngyeW",11) == 1606192834) strcat(s, "j");
if (crc32("nrswM",5) == 531780147) strcat(s, "l");
if (crc32("qDybWsVgqsHu",12) == 2939908191) strcat(s, "V");
if (crc32("WwYvuowPuauta",13) == 3560006447) strcat(s, "e");
if (crc32("QSDTkGLjFffXKc",14) == 60432405) strcat(s, "m");
if (crc32("XvGbMOs",7) == 3984474236) strcat(s, "n");
if (crc32("ZYrcYKGqvdx",11) == 522006033) strcat(s, "G");
if (crc32("RgseqdOExdq",11) == 4197039210) strcat(s, "e");
if (crc32("nMQhiRBvlF",10) == 2014498652) strcat(s, "s");
if (crc32("BRkBYZwsSeyp",12) == 49921173) strcat(s, "s");
    return s;
}

char *chanduy_nouns() {
    char *s = calloc(8);
    if (crc32("lTSbcfLH",8) == 3346129589) strcat(s, "g");
if (crc32("VSxKG",5) == 152966703) strcat(s, "c");
if (crc32("AtsMp",5) == 76097362) strcat(s, "h");
if (crc32("UmQUsXpZV",9) == 3820509217) strcat(s, "l");
if (crc32("yeBZuoJOlI",10) == 446014067) strcat(s, "a");
if (crc32("efaQrWtKt",9) == 3468657321) strcat(s, "n");
if (crc32("RaUduHNP",8) == 2346123226) strcat(s, "X");
if (crc32("zbFAfide",8) == 2634806385) strcat(s, "d");
if (crc32("MBWquS",6) == 2213809081) strcat(s, "u");
if (crc32("orFUadoc",8) == 3296113062) strcat(s, "y");
    return s;
}

char *varindor_nouns() {
    char *s = calloc(9);
    if (crc32("EsEuilHxld",10) == 3389069091) strcat(s, "X");
if (crc32("cHqWGS",6) == 2685135263) strcat(s, "v");
if (crc32("EDLmvoxYoK",10) == 3012014752) strcat(s, "D");
if (crc32("OgIibujvwexP",12) == 364389437) strcat(s, "a");
if (crc32("BdeWZuImpZB",11) == 3089779107) strcat(s, "r");
if (crc32("NavWDKFjlMC",11) == 3334859081) strcat(s, "M");
if (crc32("rfpbiqWPObX",11) == 2777586639) strcat(s, "i");
if (crc32("USZFnojqVanMl",13) == 2543467837) strcat(s, "B");
if (crc32("RalBwOvRAbYJF",13) == 3182239081) strcat(s, "n");
if (crc32("DBSHvpjQm",9) == 934769387) strcat(s, "d");
if (crc32("BnqiGlFTP",9) == 3965779103) strcat(s, "o");
if (crc32("XsvaIHyYMoIztT",14) == 3438199970) strcat(s, "t");
if (crc32("KXkzPZ",6) == 1484433212) strcat(s, "r");
    return s;
}

char *Bruno_nouns() {
    char *s = calloc(6);
    if (crc32("QwPfSqRep",9) == 1397406208) strcat(s, "B");
if (crc32("SfccugIjEaSnzA",14) == 2649419801) strcat(s, "t");
if (crc32("CEZHMGYJocoM",12) == 2573335593) strcat(s, "r");
if (crc32("DTcGBheV",8) == 355425168) strcat(s, "W");
if (crc32("PeOrHdK",7) == 1661199724) strcat(s, "u");
if (crc32("FysMdQAxWcOSW",13) == 1426677094) strcat(s, "H");
if (crc32("RMmxybubq",9) == 1111185385) strcat(s, "n");
if (crc32("wnqIbZxUxzCBy",13) == 899527779) strcat(s, "L");
if (crc32("jZZUYQUvdJil",12) == 1765459460) strcat(s, "o");
    return s;
}

char *BrillatSavarin_nouns() {
    char *s = calloc(15);
    if (crc32("UzDxrRIRyodj",12) == 3596340097) strcat(s, "B");
if (crc32("oLJgcKjOsdMu",12) == 1955821616) strcat(s, "r");
if (crc32("MmFwGyKJPetIh",13) == 2376232528) strcat(s, "i");
if (crc32("GODII",5) == 3064861515) strcat(s, "l");
if (crc32("XVaVwEuuSEevVy",14) == 381634280) strcat(s, "l");
if (crc32("vCKWjAKF",8) == 772264291) strcat(s, "g");
if (crc32("luSISdWzbqYko",13) == 4287256238) strcat(s, "a");
if (crc32("WfNDLlymhTYSk",13) == 407101674) strcat(s, "t");
if (crc32("EOCTuCtODtjfT",13) == 3623035309) strcat(s, "v");
if (crc32("xCHzTsvlvqKu",12) == 1527377364) strcat(s, "S");
if (crc32("YCmHXbS",7) == 1525268117) strcat(s, "a");
if (crc32("IcXHdtEtBhe",11) == 3074881990) strcat(s, "v");
if (crc32("aULfkNmdBG",10) == 1996427990) strcat(s, "U");
if (crc32("rfhxRfoxyNnSMx",14) == 1059275346) strcat(s, "a");
if (crc32("cClBlphcMvK",11) == 555703708) strcat(s, "r");
if (crc32("SxpDJvLjmnYFuU",14) == 1780184820) strcat(s, "i");
if (crc32("YplIJTXrui",10) == 1548028994) strcat(s, "n");
    return s;
}

char *scattering_nouns() {
    char *s = calloc(11);
    if (crc32("xJeFuZcsBmGbW",13) == 4070885668) strcat(s, "s");
if (crc32("BTCPGTKxcUGDzx",14) == 3730595826) strcat(s, "F");
if (crc32("AjnAsgtjVNNZNbg",15) == 3578281355) strcat(s, "c");
if (crc32("KxeHpzF",7) == 2732259133) strcat(s, "T");
if (crc32("UeVOnVzSZE",10) == 578722513) strcat(s, "a");
if (crc32("yZdifPb",7) == 910746273) strcat(s, "t");
if (crc32("yOXxvCy",7) == 637889881) strcat(s, "H");
if (crc32("eyjNiBL",7) == 983920708) strcat(s, "t");
if (crc32("VAeGQjhtSrXC",12) == 2142088857) strcat(s, "e");
if (crc32("YLyzE",5) == 2862992030) strcat(s, "r");
if (crc32("TrjnZffh",8) == 3639638872) strcat(s, "i");
if (crc32("xbhJBKGA",8) == 57384716) strcat(s, "n");
if (crc32("KBYveXuqs",9) == 1211700134) strcat(s, "g");
    return s;
}

char *Balf_nouns() {
    char *s = calloc(5);
    if (crc32("iOQAICmaaQRQavK",15) == 2594530848) strcat(s, "P");
if (crc32("UYjiuj",6) == 875591520) strcat(s, "B");
if (crc32("UfDMm",5) == 702224072) strcat(s, "a");
if (crc32("KPYoC",5) == 2953943341) strcat(s, "h");
if (crc32("shDKLyMffHPtq",13) == 505969029) strcat(s, "l");
if (crc32("PihkfU",6) == 3987433314) strcat(s, "e");
if (crc32("vnbtrqpGyuQYf",13) == 1769174163) strcat(s, "f");
    return s;
}

char *limulus_nouns() {
    char *s = calloc(8);
    if (crc32("akVmFQtVRYLAV",13) == 554410333) strcat(s, "l");
if (crc32("acZSctdK",8) == 2339314020) strcat(s, "i");
if (crc32("HKPwUROItg",10) == 295941762) strcat(s, "I");
if (crc32("NEUYrWgWC",9) == 1228348725) strcat(s, "m");
if (crc32("iauow",5) == 21026670) strcat(s, "F");
if (crc32("OFWXYoNKmX",10) == 3966643065) strcat(s, "u");
if (crc32("BSBbLKGzU",9) == 4294069684) strcat(s, "n");
if (crc32("zMWlRVxg",8) == 220362405) strcat(s, "l");
if (crc32("NBalcqXUcXfYRnm",15) == 4159819399) strcat(s, "u");
if (crc32("wUhOowSPMh",10) == 59322361) strcat(s, "p");
if (crc32("ceUonv",6) == 2469447111) strcat(s, "s");
    return s;
}

char *watchfulness_nouns() {
    char *s = calloc(13);
    if (crc32("QexgvgDEGSoRkH",14) == 2332662701) strcat(s, "h");
if (crc32("JNVYBkdIKuka",12) == 3378026219) strcat(s, "w");
if (crc32("SrvhYxpEAP",10) == 635272466) strcat(s, "T");
if (crc32("GHuvXezPiF",10) == 1663010801) strcat(s, "a");
if (crc32("WYSFlCmuKNF",11) == 2923248414) strcat(s, "t");
if (crc32("qHBtALzo",8) == 2348236714) strcat(s, "r");
if (crc32("nkyELJSqgvG",11) == 541251921) strcat(s, "c");
if (crc32("qdfLIuQwhsrue",13) == 3508600557) strcat(s, "Q");
if (crc32("mdHVTQGoVSLXZi",14) == 1811009205) strcat(s, "h");
if (crc32("AJPpBk",6) == 1546939610) strcat(s, "w");
if (crc32("fhqMJNkEPCaiu",13) == 380390912) strcat(s, "f");
if (crc32("aLyGZxQP",8) == 956126647) strcat(s, "v");
if (crc32("exzkGhbzfdRG",12) == 3965836134) strcat(s, "u");
if (crc32("BycEXNzz",8) == 2024057621) strcat(s, "l");
if (crc32("wyWZVgqqIYyewf",14) == 656286467) strcat(s, "c");
if (crc32("bBETi",5) == 2284145921) strcat(s, "n");
if (crc32("NbojolLpasxxcu",14) == 845605134) strcat(s, "e");
if (crc32("WzzNpkvFT",9) == 1061988465) strcat(s, "s");
if (crc32("WJtouADy",8) == 3239990282) strcat(s, "s");
    return s;
}

char *Mishaan_nouns() {
    char *s = calloc(8);
    if (crc32("iuCzUJIoiAYpl",13) == 2203006600) strcat(s, "M");
if (crc32("OPYvsxMaUDLkRG",14) == 3040900555) strcat(s, "i");
if (crc32("EwxkJ",5) == 1987841544) strcat(s, "I");
if (crc32("KMTEvZdHpHqzC",13) == 1491147356) strcat(s, "s");
if (crc32("AJjGdjdqJ",9) == 2113712543) strcat(s, "h");
if (crc32("BgjHoYk",7) == 616122658) strcat(s, "a");
if (crc32("GtqEgPWfhDCz",12) == 3772552492) strcat(s, "a");
if (crc32("mhHBXYWCdZYFlsq",15) == 804348297) strcat(s, "I");
if (crc32("qLPgcsLhPfEZcNx",15) == 183926981) strcat(s, "n");
    return s;
}

char *Paulita_nouns() {
    char *s = calloc(8);
    if (crc32("aEMJdpdThmQJvS",14) == 1372210763) strcat(s, "P");
if (crc32("qCKNG",5) == 3267764544) strcat(s, "A");
if (crc32("YxgxSCPFDqSGRbm",15) == 2885898192) strcat(s, "a");
if (crc32("lVagfZ",6) == 264007137) strcat(s, "u");
if (crc32("nxbECFmRAVdB",12) == 468369133) strcat(s, "l");
if (crc32("Yiuac",5) == 3157858902) strcat(s, "m");
if (crc32("UFAZVBIergfqN",13) == 1356643542) strcat(s, "i");
if (crc32("dmRBRpTzV",9) == 1328807283) strcat(s, "t");
if (crc32("FsoZTtQtLUgmy",13) == 3014892734) strcat(s, "D");
if (crc32("mIXVlYaak",9) == 2991488740) strcat(s, "a");
    return s;
}

char *subepoch_nouns() {
    char *s = calloc(9);
    if (crc32("Ulbit",5) == 1446917828) strcat(s, "e");
if (crc32("zJVlvNlEWvY",11) == 811405985) strcat(s, "s");
if (crc32("rNfnaSK",7) == 3267398726) strcat(s, "N");
if (crc32("zGDGdKmxmD",10) == 442709576) strcat(s, "u");
if (crc32("pjwJzGBmonZyD",13) == 1854693842) strcat(s, "e");
if (crc32("bkElASictfreJa",14) == 3517527491) strcat(s, "b");
if (crc32("CPNfo",5) == 613118094) strcat(s, "W");
if (crc32("JNdfXp",6) == 582688551) strcat(s, "e");
if (crc32("UIdohGrHqDq",11) == 903513571) strcat(s, "H");
if (crc32("XRKmRktWvNaf",12) == 3260245365) strcat(s, "p");
if (crc32("RcccFwhjbyn",11) == 2576267068) strcat(s, "o");
if (crc32("JjEZNitdA",9) == 2783383939) strcat(s, "c");
if (crc32("JSzEliCdqEEgOL",14) == 686287394) strcat(s, "Y");
if (crc32("GHDfg",5) == 3853721168) strcat(s, "h");
    return s;
}

char *Heiduc_nouns() {
    char *s = calloc(7);
    if (crc32("QiPWlWl",7) == 2848935835) strcat(s, "H");
if (crc32("eYqZyFNAJLG",11) == 3194372966) strcat(s, "s");
if (crc32("pwvEa",5) == 786395547) strcat(s, "e");
if (crc32("vgZrIuyCpbtazr",14) == 56605997) strcat(s, "Y");
if (crc32("hiFpIbRKLhMxNXV",15) == 4060312802) strcat(s, "i");
if (crc32("wKnBlbcBJwvoUk",14) == 966695022) strcat(s, "E");
if (crc32("mnUQXbQWLua",11) == 2306005321) strcat(s, "d");
if (crc32("trzxHsJbj",9) == 2633139676) strcat(s, "u");
if (crc32("AVBqrSCkJAZ",11) == 962076101) strcat(s, "i");
if (crc32("RmCKWX",6) == 4093787140) strcat(s, "c");
    return s;
}

char *Lyndhurst_nouns() {
    char *s = calloc(10);
    if (crc32("yTLMbylVYbWarqH",15) == 2529610865) strcat(s, "A");
if (crc32("RUlfE",5) == 218029916) strcat(s, "L");
if (crc32("troamtXR",8) == 109865637) strcat(s, "y");
if (crc32("SVwKWYfulsgXZT",14) == 2702643121) strcat(s, "P");
if (crc32("iVYzMby",7) == 1849953998) strcat(s, "n");
if (crc32("EmTghHZkktAlc",13) == 2083949022) strcat(s, "d");
if (crc32("vPtQwHIIHWgQ",12) == 4291909990) strcat(s, "h");
if (crc32("ZGaJCCZH",8) == 850223025) strcat(s, "u");
if (crc32("Rgoexbc",7) == 408360114) strcat(s, "l");
if (crc32("jPjgFVJ",7) == 3316172634) strcat(s, "r");
if (crc32("cotigh",6) == 108445090) strcat(s, "U");
if (crc32("KeuciYJsDL",10) == 2656273284) strcat(s, "s");
if (crc32("SGTQyeWHj",9) == 1105917734) strcat(s, "V");
if (crc32("xaBqt",5) == 2655545417) strcat(s, "t");
    return s;
}

char *Woonsocket_nouns() {
    char *s = calloc(11);
    if (crc32("NblFkHxZbnx",11) == 2253756973) strcat(s, "W");
if (crc32("xbmRcm",6) == 3355409118) strcat(s, "f");
if (crc32("XqveYuSrhk",10) == 4263178628) strcat(s, "o");
if (crc32("jYCleAS",7) == 3232362136) strcat(s, "D");
if (crc32("RNSQdHiEhhGW",12) == 1986862206) strcat(s, "o");
if (crc32("VdwwUXRQqLfqldK",15) == 1236294819) strcat(s, "n");
if (crc32("CHYfHLZiErCJwB",14) == 552794986) strcat(s, "x");
if (crc32("kJRQanyt",8) == 615188450) strcat(s, "s");
if (crc32("JHhKGCZRSYo",11) == 257006495) strcat(s, "I");
if (crc32("JnlHS",5) == 2224537794) strcat(s, "o");
if (crc32("ExIciaMY",8) == 302422700) strcat(s, "G");
if (crc32("uCZhUhRZmzy",11) == 3122838469) strcat(s, "c");
if (crc32("PIngdpsvBcd",11) == 829327859) strcat(s, "n");
if (crc32("rnywpxKURBaQcLl",15) == 2049009219) strcat(s, "k");
if (crc32("VkErCqcAq",9) == 1916324188) strcat(s, "e");
if (crc32("hieoXDeGP",9) == 1751161042) strcat(s, "t");
    return s;
}

char *billethead_nouns() {
    char *s = calloc(11);
    if (crc32("TNuSGhVKI",9) == 3230474266) strcat(s, "O");
if (crc32("bPKKx",5) == 3745632627) strcat(s, "b");
if (crc32("QMoooaYmyffgQXh",15) == 1175078443) strcat(s, "i");
if (crc32("gZsChbQebjNaZ",13) == 1863168737) strcat(s, "c");
if (crc32("hpQfvOrOnl",10) == 2728496468) strcat(s, "l");
if (crc32("wlKIBx",6) == 1424538476) strcat(s, "l");
if (crc32("YzMrJS",6) == 4024343533) strcat(s, "e");
if (crc32("gYxrtGQVrvFBy",13) == 3906868556) strcat(s, "t");
if (crc32("avspAtZxo",9) == 2159286675) strcat(s, "t");
if (crc32("gChLgi",6) == 580924172) strcat(s, "h");
if (crc32("gmrXicixesja",12) == 1048546633) strcat(s, "h");
if (crc32("rcDqvYvMX",9) == 2794356352) strcat(s, "e");
if (crc32("hVvek",5) == 769038041) strcat(s, "l");
if (crc32("jfxLkMGnkqmsYm",14) == 1079543430) strcat(s, "a");
if (crc32("rDZKUByCSr",10) == 631566640) strcat(s, "d");
    return s;
}

char *coemption_nouns() {
    char *s = calloc(10);
    if (crc32("GAiZXjtjlKsPDz",14) == 1637884636) strcat(s, "l");
if (crc32("PpWOiDpDUWdwvue",15) == 2705848044) strcat(s, "c");
if (crc32("Xhopxue",7) == 3923698357) strcat(s, "o");
if (crc32("QXiOeYlhU",9) == 4126988002) strcat(s, "o");
if (crc32("jUMgU",5) == 2693538281) strcat(s, "e");
if (crc32("tlEKlGzBMUPoBW",14) == 1296690757) strcat(s, "a");
if (crc32("yMskovNK",8) == 746090876) strcat(s, "m");
if (crc32("cnnnWdBzC",9) == 918199614) strcat(s, "R");
if (crc32("MqhEyJwMwU",10) == 2979004989) strcat(s, "p");
if (crc32("FxCFejFdphtvQ",13) == 1048888029) strcat(s, "t");
if (crc32("GZkUUce",7) == 3130738492) strcat(s, "i");
if (crc32("GTHYoJySyntUv",13) == 326706625) strcat(s, "o");
if (crc32("oWMWXynyXa",10) == 1571702376) strcat(s, "n");
    return s;
}

char *cormorant_nouns() {
    char *s = calloc(10);
    if (crc32("ThljHupoYsrqIgp",15) == 3515199135) strcat(s, "c");
if (crc32("uEGZgioBZo",10) == 3485679837) strcat(s, "o");
if (crc32("ukurRtClbbPLSrx",15) == 1820680585) strcat(s, "r");
if (crc32("GlCqOMsgMFIhQjD",15) == 415281581) strcat(s, "F");
if (crc32("mNkPLLUeQYW",11) == 261506338) strcat(s, "m");
if (crc32("eiWdXpojD",9) == 2218418063) strcat(s, "o");
if (crc32("TSvnhoIWI",9) == 3773703419) strcat(s, "r");
if (crc32("sXPdcbyVZsLINm",14) == 2466409406) strcat(s, "a");
if (crc32("PjViMkthklrVRrv",15) == 3507130278) strcat(s, "n");
if (crc32("mLzgfBFXVEQv",12) == 1586552515) strcat(s, "t");
    return s;
}

char *gaberdine_nouns() {
    char *s = calloc(10);
    if (crc32("oIxcTjwgq",9) == 3354320086) strcat(s, "g");
if (crc32("yFXTni",6) == 3762319031) strcat(s, "a");
if (crc32("WTVYrw",6) == 2893489313) strcat(s, "u");
if (crc32("iTZZVP",6) == 297499068) strcat(s, "b");
if (crc32("oLcZwCExA",9) == 2254372947) strcat(s, "j");
if (crc32("UGrawZd",7) == 2774625849) strcat(s, "e");
if (crc32("NQsFd",5) == 3476048827) strcat(s, "w");
if (crc32("imVMbeTOW",9) == 2830459369) strcat(s, "r");
if (crc32("ZtbyEanpQbZP",12) == 729199648) strcat(s, "i");
if (crc32("DrcmmCdyxmv",11) == 4216657240) strcat(s, "d");
if (crc32("OcFgunsNQQ",10) == 219793662) strcat(s, "l");
if (crc32("VUxbCB",6) == 1035510197) strcat(s, "i");
if (crc32("KQCTLjKYE",9) == 383649875) strcat(s, "b");
if (crc32("CLtxDOVZW",9) == 857477683) strcat(s, "n");
if (crc32("GFPMKawZVZ",10) == 1942961268) strcat(s, "e");
    return s;
}

char *Adventism_nouns() {
    char *s = calloc(10);
    if (crc32("RvQqSrRmyrbHHv",14) == 1064197213) strcat(s, "a");
if (crc32("cgvKCer",7) == 3692675292) strcat(s, "A");
if (crc32("mNLTHXt",7) == 3232762619) strcat(s, "d");
if (crc32("EIBoBGjAlqzMHe",14) == 1880769419) strcat(s, "v");
if (crc32("qaJytJS",7) == 1629957458) strcat(s, "G");
if (crc32("onmBaNCIxeT",11) == 1856204342) strcat(s, "e");
if (crc32("EbRUxymLIv",10) == 1106537789) strcat(s, "J");
if (crc32("zCXMnaNy",8) == 3089146243) strcat(s, "n");
if (crc32("EiJRUq",6) == 19563900) strcat(s, "t");
if (crc32("szXRvBwxGAFf",12) == 1545401817) strcat(s, "o");
if (crc32("uHjNUyyxNMTg",12) == 4094903910) strcat(s, "i");
if (crc32("gNMwaD",6) == 384675738) strcat(s, "I");
if (crc32("HHgWkBGSfP",10) == 1191471534) strcat(s, "s");
if (crc32("ZeOjbTQdrLeSRxf",15) == 1080350694) strcat(s, "m");
    return s;
}

char *class_nouns() {
    char *s = calloc(6);
    if (crc32("yOoXrshbBJk",11) == 3917798441) strcat(s, "c");
if (crc32("cHHNWuU",7) == 4157287804) strcat(s, "l");
if (crc32("YHHFJI",6) == 3722523663) strcat(s, "a");
if (crc32("fJRpSJlVlIZfb",13) == 2197846472) strcat(s, "s");
if (crc32("OxDIBTdHkSAnzli",15) == 1542749137) strcat(s, "W");
if (crc32("LTgETSnOi",9) == 195712366) strcat(s, "s");
    return s;
}

char *compassion_nouns() {
    char *s = calloc(11);
    if (crc32("ztfyydK",7) == 3075639516) strcat(s, "m");
if (crc32("dHCYDSYsn",9) == 4196533781) strcat(s, "c");
if (crc32("OZgopMHpBtUV",12) == 2812729919) strcat(s, "o");
if (crc32("VJPOfjgWjDIsV",13) == 1680717554) strcat(s, "m");
if (crc32("MqBEHgkDcIX",11) == 1758607763) strcat(s, "p");
if (crc32("yTPsWqOGkOtxU",13) == 1022732521) strcat(s, "a");
if (crc32("PtnowdiVW",9) == 1060426276) strcat(s, "s");
if (crc32("CRrZD",5) == 3739590340) strcat(s, "s");
if (crc32("oNeoZJ",6) == 915238008) strcat(s, "i");
if (crc32("eTLbxhtMNfgvFD",14) == 553329228) strcat(s, "o");
if (crc32("wKeSlrXtrPxDFRd",15) == 1061802801) strcat(s, "G");
if (crc32("zAIFLufokMPQEPo",15) == 96631891) strcat(s, "n");
    return s;
}

char *Ganda_nouns() {
    char *s = calloc(6);
    if (crc32("EyXstU",6) == 315183119) strcat(s, "G");
if (crc32("tUjasWWBLl",10) == 3361868626) strcat(s, "H");
if (crc32("GuXHnEsgnHImkU",14) == 1382780123) strcat(s, "a");
if (crc32("HaVAaH",6) == 1833194386) strcat(s, "n");
if (crc32("PwiSbEhXQmMkcHu",15) == 3481723387) strcat(s, "s");
if (crc32("etZsBkcnFsKXo",13) == 878176878) strcat(s, "d");
if (crc32("oaIuBngib",9) == 3566022480) strcat(s, "L");
if (crc32("klStEVkufZlCYvD",15) == 2886184434) strcat(s, "a");
    return s;
}

char *Marcile_nouns() {
    char *s = calloc(8);
    if (crc32("UMDVkyyjh",9) == 922613184) strcat(s, "y");
if (crc32("LnDhDLzJkBgQXsM",15) == 2388977859) strcat(s, "M");
if (crc32("lQzlpWC",7) == 2598642049) strcat(s, "a");
if (crc32("csZvXiDxrjHyRq",14) == 4057388269) strcat(s, "r");
if (crc32("xyLvOdaM",8) == 2504872848) strcat(s, "c");
if (crc32("gMRXFhLBNtNeT",13) == 981630988) strcat(s, "i");
if (crc32("lLCLGsS",7) == 2022200987) strcat(s, "A");
if (crc32("tQqwKzAsn",9) == 2048080884) strcat(s, "l");
if (crc32("VkkLgmwnlllXROU",15) == 2144492163) strcat(s, "c");
if (crc32("TMmynuv",7) == 667084818) strcat(s, "e");
    return s;
}

char *lesbianism_nouns() {
    char *s = calloc(11);
    if (crc32("uvqHPLlEUNX",11) == 427811017) strcat(s, "A");
if (crc32("EcAAEb",6) == 1283937402) strcat(s, "l");
if (crc32("KrHES",5) == 2986261090) strcat(s, "r");
if (crc32("EJEEU",5) == 1120323949) strcat(s, "e");
if (crc32("EJzzAWRuMEQ",11) == 435689741) strcat(s, "s");
if (crc32("CwbNy",5) == 3511793852) strcat(s, "w");
if (crc32("wWWjdGSdMBhdN",13) == 4086309403) strcat(s, "b");
if (crc32("VdXHitSBVkl",11) == 1963970070) strcat(s, "E");
if (crc32("xAAGYcGioMA",11) == 670602087) strcat(s, "i");
if (crc32("CufVMtZ",7) == 4091274480) strcat(s, "a");
if (crc32("MHqLANjI",8) == 882753004) strcat(s, "n");
if (crc32("UnCGTqZ",7) == 297812840) strcat(s, "i");
if (crc32("jzKYKRjRQaeGkUx",15) == 2158500350) strcat(s, "S");
if (crc32("raXMfJhwAIQGZ",13) == 742344010) strcat(s, "s");
if (crc32("SKrygaOnCVfjcd",14) == 65040575) strcat(s, "n");
if (crc32("QfcpG",5) == 1342857477) strcat(s, "m");
    return s;
}

char *Yesilkoy_nouns() {
    char *s = calloc(9);
    if (crc32("XcGKElCRCDo",11) == 1907898261) strcat(s, "Y");
if (crc32("mfGesA",6) == 1356024457) strcat(s, "d");
if (crc32("ttEmzFZyFlATt",13) == 2921371511) strcat(s, "e");
if (crc32("BvxWXkmdeyfLCx",14) == 383842258) strcat(s, "s");
if (crc32("pcthAXdv",8) == 3006091552) strcat(s, "i");
if (crc32("czefxLgEgjNvEd",14) == 2466256956) strcat(s, "q");
if (crc32("MgbjoXUzVot",11) == 3266365894) strcat(s, "l");
if (crc32("PgGuGWYHEAwa",12) == 3385989315) strcat(s, "l");
if (crc32("ofwug",5) == 321763523) strcat(s, "k");
if (crc32("EPQBUtIblaYl",12) == 3569699213) strcat(s, "o");
if (crc32("mzZzJwBktWuvn",13) == 1962919583) strcat(s, "y");
    return s;
}

char *periosteum_nouns() {
    char *s = calloc(11);
    if (crc32("QbNwMU",6) == 468577555) strcat(s, "g");
if (crc32("OkUFwHftcE",10) == 325541146) strcat(s, "p");
if (crc32("mYTUsoYeJJjOcEP",15) == 2117794212) strcat(s, "e");
if (crc32("iyTsYzXPeCNHC",13) == 542712282) strcat(s, "K");
if (crc32("bXZODS",6) == 1167860876) strcat(s, "r");
if (crc32("WKNmP",5) == 3241729838) strcat(s, "i");
if (crc32("kowtldzW",8) == 2446940818) strcat(s, "o");
if (crc32("ydtZLm",6) == 2664766306) strcat(s, "H");
if (crc32("RcudNhoWHUKtpK",14) == 2992018524) strcat(s, "s");
if (crc32("PtIpJPBRxD",10) == 1942589396) strcat(s, "t");
if (crc32("pvKismUYv",9) == 538824566) strcat(s, "x");
if (crc32("hIoXeTrAb",9) == 2723543684) strcat(s, "e");
if (crc32("lPPdI",5) == 868228052) strcat(s, "u");
if (crc32("AcYnkQsgY",9) == 2357166396) strcat(s, "A");
if (crc32("RiXIoGoA",8) == 740288568) strcat(s, "m");
    return s;
}

char *Thedric_nouns() {
    char *s = calloc(8);
    if (crc32("ujGHqui",7) == 1781534379) strcat(s, "Z");
if (crc32("gYkTHJNMYmcEwf",14) == 692575205) strcat(s, "T");
if (crc32("siLQsjUO",8) == 962582740) strcat(s, "h");
if (crc32("ryeEPovKpRi",11) == 1361084174) strcat(s, "y");
if (crc32("zswexDv",7) == 1750692730) strcat(s, "e");
if (crc32("WbpXFfGTH",9) == 1958349543) strcat(s, "d");
if (crc32("QGbFjOkjITZKVc",14) == 832399285) strcat(s, "r");
if (crc32("FJKpOtKeqZup",12) == 802218413) strcat(s, "M");
if (crc32("UjYyERAaJgMp",12) == 1844800360) strcat(s, "i");
if (crc32("iQaJuJRSShOkGj",14) == 1210858873) strcat(s, "c");
    return s;
}

char *glassblowing_nouns() {
    char *s = calloc(13);
    if (crc32("plyLDjzBTmlz",12) == 2180562794) strcat(s, "y");
if (crc32("yABlqJEctOyccM",14) == 2853221083) strcat(s, "g");
if (crc32("jVqKei",6) == 2702960360) strcat(s, "V");
if (crc32("VEcaorTehBxz",12) == 269454061) strcat(s, "l");
if (crc32("dJXEh",5) == 1800615919) strcat(s, "B");
if (crc32("hdOXBOoj",8) == 3932263751) strcat(s, "a");
if (crc32("rNExriLHPl",10) == 4062210657) strcat(s, "H");
if (crc32("ijrCXfsGfjvUfnX",15) == 3440264133) strcat(s, "s");
if (crc32("JNobnRv",7) == 2980727988) strcat(s, "s");
if (crc32("wTJwnOaHyWuY",12) == 487125609) strcat(s, "b");
if (crc32("bMVGPNNjpxiuD",13) == 4204611531) strcat(s, "p");
if (crc32("pHMybEWNUXWnU",13) == 593585325) strcat(s, "l");
if (crc32("xiqNItEVP",9) == 1478043128) strcat(s, "L");
if (crc32("iMqqM",5) == 1342444860) strcat(s, "o");
if (crc32("oiXflhOdSUD",11) == 116078474) strcat(s, "u");
if (crc32("PAoMkUq",7) == 2901230342) strcat(s, "w");
if (crc32("YiLMBfkgIRd",11) == 931887089) strcat(s, "i");
if (crc32("zcpxyxXCmEBl",12) == 1810655075) strcat(s, "n");
if (crc32("HSbaXoiWZUeNa",13) == 2736987715) strcat(s, "s");
if (crc32("xvmHZ",5) == 2999289543) strcat(s, "g");
    return s;
}

char *Cathryn_nouns() {
    char *s = calloc(8);
    if (crc32("vBDaVNcWjhgsU",13) == 64012836) strcat(s, "L");
if (crc32("eMifxeCxyQy",11) == 540788056) strcat(s, "C");
if (crc32("xOtREOr",7) == 1846047836) strcat(s, "a");
if (crc32("KRqCJXSTtuLOKY",14) == 3616064568) strcat(s, "M");
if (crc32("nHebKXDeWBbA",12) == 1097087103) strcat(s, "t");
if (crc32("NaIVy",5) == 403178582) strcat(s, "h");
if (crc32("yVMdJiRER",9) == 367313555) strcat(s, "y");
if (crc32("kWdycM",6) == 4028332835) strcat(s, "r");
if (crc32("sMDhRHg",7) == 612754999) strcat(s, "y");
if (crc32("PEwEMaYKQkRA",12) == 1170166715) strcat(s, "n");
    return s;
}

char *golliwog_nouns() {
    char *s = calloc(9);
    if (crc32("NlcihvthkYrTH",13) == 1506086031) strcat(s, "g");
if (crc32("YgiIOBBQKEXbY",13) == 1316524581) strcat(s, "o");
if (crc32("kDCoqYSkjDUCuBK",15) == 1180206206) strcat(s, "l");
if (crc32("skDlfmsSklwz",12) == 89532997) strcat(s, "l");
if (crc32("JJhFFpEy",8) == 1078531788) strcat(s, "i");
if (crc32("FleNE",5) == 1177668624) strcat(s, "w");
if (crc32("CcLhseZ",7) == 3237828299) strcat(s, "o");
if (crc32("gYBtvKw",7) == 764787382) strcat(s, "b");
if (crc32("RVSgzNkNBDKqw",13) == 808812453) strcat(s, "g");
    return s;
}

char *costard_nouns() {
    char *s = calloc(8);
    if (crc32("jqCtKWHS",8) == 3362486132) strcat(s, "D");
if (crc32("gmJppDpnDZlIz",13) == 1377881399) strcat(s, "c");
if (crc32("WkybHFTmls",10) == 4192132106) strcat(s, "o");
if (crc32("eXgZAoQDD",9) == 456572015) strcat(s, "s");
if (crc32("QxruSDaDr",9) == 208692495) strcat(s, "S");
if (crc32("cQXVXE",6) == 680340768) strcat(s, "t");
if (crc32("IjXec",5) == 1774455370) strcat(s, "a");
if (crc32("qSAGmluUnnaYuaE",15) == 1077013098) strcat(s, "J");
if (crc32("htFgfuDIDstPbGi",15) == 3472923806) strcat(s, "r");
if (crc32("BMBZRAnTFxQpT",13) == 895367109) strcat(s, "Q");
if (crc32("zWBZapJMuo",10) == 3239790961) strcat(s, "d");
    return s;
}

char *Jezreelite_nouns() {
    char *s = calloc(11);
    if (crc32("QgYXyy",6) == 1586292139) strcat(s, "J");
if (crc32("isiatwvbwGvqZXb",15) == 711978884) strcat(s, "e");
if (crc32("Hxmex",5) == 108089977) strcat(s, "z");
if (crc32("DsflgLerxGHTMsj",15) == 3086813947) strcat(s, "r");
if (crc32("WidWHtcTWSRgeX",14) == 4136122737) strcat(s, "e");
if (crc32("EJRpyf",6) == 2479739711) strcat(s, "e");
if (crc32("Gjbjrq",6) == 2658787131) strcat(s, "l");
if (crc32("ECoRAmRQ",8) == 1032545471) strcat(s, "i");
if (crc32("yvqRZlDb",8) == 167552507) strcat(s, "t");
if (crc32("aJFCmIdTqNLJt",13) == 1077027710) strcat(s, "Q");
if (crc32("pbMFbxrhFFNzfmp",15) == 2015958884) strcat(s, "e");
    return s;
}

char *Asius_nouns() {
    char *s = calloc(6);
    if (crc32("NPvDKIMEpCPODQS",15) == 2681436338) strcat(s, "A");
if (crc32("VFOHnbT",7) == 2493790522) strcat(s, "G");
if (crc32("QXNlGJStmSAtTox",15) == 3175429532) strcat(s, "s");
if (crc32("XFlkafYly",9) == 168633625) strcat(s, "A");
if (crc32("TLEIZmqamMtiW",13) == 162522648) strcat(s, "i");
if (crc32("KFOSpj",6) == 2533602204) strcat(s, "Z");
if (crc32("eTWJlnLkCFYZokw",15) == 538292340) strcat(s, "u");
if (crc32("spanlb",6) == 1853975696) strcat(s, "s");
    return s;
}

char *apologue_nouns() {
    char *s = calloc(9);
    if (crc32("LpvPJcYfozEr",12) == 256714824) strcat(s, "a");
if (crc32("eSjeURlG",8) == 539223363) strcat(s, "O");
if (crc32("QbyQSKle",8) == 2554247326) strcat(s, "p");
if (crc32("NOLCcFbEnbWVE",13) == 1579087319) strcat(s, "o");
if (crc32("FrSlSJNjVXO",11) == 698525838) strcat(s, "k");
if (crc32("guRfn",5) == 1195669070) strcat(s, "l");
if (crc32("KxFavHNfwWtKVtG",15) == 955753763) strcat(s, "T");
if (crc32("uaJYLIumlhjtNw",14) == 1012881909) strcat(s, "o");
if (crc32("WkksvnTBhXenk",13) == 3884453374) strcat(s, "S");
if (crc32("FGFCP",5) == 3548022320) strcat(s, "g");
if (crc32("CeSZEhQgDnSpRs",14) == 1155494169) strcat(s, "n");
if (crc32("UiZIfgxziIqhDc",14) == 4238051252) strcat(s, "u");
if (crc32("hlwcm",5) == 855496830) strcat(s, "e");
    return s;
}

char *Alcina_nouns() {
    char *s = calloc(7);
    if (crc32("BAhIarpYIEfpHB",14) == 986394467) strcat(s, "A");
if (crc32("eNZywZWSuLNe",12) == 2221407459) strcat(s, "l");
if (crc32("HKMgV",5) == 843197595) strcat(s, "c");
if (crc32("BTGcMpZo",8) == 1334507403) strcat(s, "Z");
if (crc32("bvjqxNotauLP",12) == 4030790598) strcat(s, "i");
if (crc32("WiChhE",6) == 4108784576) strcat(s, "B");
if (crc32("mzPMcdUxlxNrtOO",15) == 4016041683) strcat(s, "n");
if (crc32("YsIfgRbLOflTpbw",15) == 904982853) strcat(s, "a");
    return s;
}

char *caudaite_nouns() {
    char *s = calloc(9);
    if (crc32("lqfZaiBOawmc",12) == 1754204338) strcat(s, "U");
if (crc32("bBLyXtP",7) == 175563141) strcat(s, "c");
if (crc32("zsvcTHj",7) == 2524147519) strcat(s, "s");
if (crc32("VBBKerAO",8) == 482351629) strcat(s, "a");
if (crc32("TsDOStROKmTGlj",14) == 2507404314) strcat(s, "u");
if (crc32("zjPcmXXWkZqr",12) == 2112197707) strcat(s, "O");
if (crc32("ejMLWgvlWABVrD",14) == 2610480104) strcat(s, "d");
if (crc32("mVIXu",5) == 1688268863) strcat(s, "a");
if (crc32("RDGQlNxwpFTkFAG",15) == 2216371786) strcat(s, "D");
if (crc32("UbVLTehcDwYTSq",14) == 3102487957) strcat(s, "i");
if (crc32("QdNTxRKIAbW",11) == 1213931147) strcat(s, "u");
if (crc32("wQNcLh",6) == 2355743157) strcat(s, "t");
if (crc32("ePjKqZV",7) == 1083459427) strcat(s, "e");
    return s;
}

char *Anammelech_nouns() {
    char *s = calloc(11);
    if (crc32("bvheeauDrzmrECJ",15) == 2304036313) strcat(s, "A");
if (crc32("PHdtyH",6) == 4033252030) strcat(s, "L");
if (crc32("YyzCZJclqcZKy",13) == 2107613084) strcat(s, "n");
if (crc32("AMGLmRwRcIoEf",13) == 1515889690) strcat(s, "c");
if (crc32("vbknsejcvbiu",12) == 407308784) strcat(s, "a");
if (crc32("ASGOcRHPpK",10) == 2024335852) strcat(s, "m");
if (crc32("HWLEXEL",7) == 805138193) strcat(s, "w");
if (crc32("eNqiBYt",7) == 3156454464) strcat(s, "m");
if (crc32("COrtntyxJndjVE",14) == 1728396616) strcat(s, "J");
if (crc32("xBfhiimdyIlA",12) == 1145615771) strcat(s, "e");
if (crc32("FDuei",5) == 2067364155) strcat(s, "l");
if (crc32("IDclslk",7) == 1637525269) strcat(s, "T");
if (crc32("kTBXEBZErhJnNg",14) == 2064551706) strcat(s, "e");
if (crc32("GSqiLKrYA",9) == 242633241) strcat(s, "c");
if (crc32("NqvIDTDiUPiT",12) == 649963495) strcat(s, "h");
    return s;
}

char *cattle_nouns() {
    char *s = calloc(7);
    if (crc32("HvWUAOYCq",9) == 3874776855) strcat(s, "s");
if (crc32("DMBMNwEU",8) == 3013640120) strcat(s, "c");
if (crc32("FhqUErfjq",9) == 1622801958) strcat(s, "G");
if (crc32("IUXda",5) == 916042448) strcat(s, "a");
if (crc32("DJfRxjrdbRfG",12) == 2737385409) strcat(s, "t");
if (crc32("HjlxNCVDEQXyod",14) == 501925538) strcat(s, "t");
if (crc32("RZsyJdhadWgCT",13) == 1790934687) strcat(s, "v");
if (crc32("OsyXBzaR",8) == 4255713939) strcat(s, "l");
if (crc32("pMnZpXvTm",9) == 2557299387) strcat(s, "e");
    return s;
}

char *tapa_nouns() {
    char *s = calloc(5);
    if (crc32("msUMQpm",7) == 2196703597) strcat(s, "s");
if (crc32("NUdeqtI",7) == 2754730243) strcat(s, "t");
if (crc32("OiiDnahaeETv",12) == 486059890) strcat(s, "t");
if (crc32("pjIjvaxCq",9) == 2093061651) strcat(s, "a");
if (crc32("QgGUWe",6) == 1531882907) strcat(s, "q");
if (crc32("qaAClu",6) == 1841138915) strcat(s, "p");
if (crc32("LTxjK",5) == 1090978108) strcat(s, "I");
if (crc32("LLxDcDrJwMOzk",13) == 2238531295) strcat(s, "a");
    return s;
}

char *Tyndale_nouns() {
    char *s = calloc(8);
    if (crc32("ErHTxvvKXZ",10) == 839529257) strcat(s, "T");
if (crc32("HDZxN",5) == 2910724080) strcat(s, "y");
if (crc32("JWJUNpwW",8) == 869809912) strcat(s, "N");
if (crc32("TPyBtuTKrNZAj",13) == 3272671585) strcat(s, "n");
if (crc32("PPGvuM",6) == 2311430759) strcat(s, "d");
if (crc32("rDxXDKUlzuS",11) == 1891758678) strcat(s, "m");
if (crc32("ZmwMxjMEnbS",11) == 1853139818) strcat(s, "a");
if (crc32("qsthGRxSfUZH",12) == 4166649981) strcat(s, "l");
if (crc32("RzIweJByhu",10) == 2314680671) strcat(s, "e");
    return s;
}

char *dissonance_nouns() {
    char *s = calloc(11);
    if (crc32("kxRqxGC",7) == 2311193226) strcat(s, "R");
if (crc32("hKRwXlUY",8) == 2962982287) strcat(s, "d");
if (crc32("ZZYYiGWthmBq",12) == 716132057) strcat(s, "Z");
if (crc32("IkRKaN",6) == 2268999458) strcat(s, "i");
if (crc32("tNDbGTcR",8) == 2297744420) strcat(s, "s");
if (crc32("UzSIIrduMvAcZ",13) == 3020746702) strcat(s, "s");
if (crc32("MRyYpyxJAc",10) == 1179223050) strcat(s, "K");
if (crc32("lxHuhRkHgi",10) == 218780395) strcat(s, "o");
if (crc32("tWIeTHpEZM",10) == 2458645832) strcat(s, "C");
if (crc32("EoamyglanRtvhkk",15) == 1129874742) strcat(s, "n");
if (crc32("LykwPXILnSs",11) == 2563794381) strcat(s, "a");
if (crc32("gPRUL",5) == 4053994902) strcat(s, "n");
if (crc32("SRMQzwa",7) == 2712912437) strcat(s, "E");
if (crc32("coBuseTCKXDQYh",14) == 3360200983) strcat(s, "c");
if (crc32("rFNDT",5) == 2035874933) strcat(s, "e");
    return s;
}

char *gasometer_nouns() {
    char *s = calloc(10);
    if (crc32("fNRtnzZlfJBjDu",14) == 1391332587) strcat(s, "g");
if (crc32("bHsYa",5) == 2081145400) strcat(s, "a");
if (crc32("uywoQyDWgW",10) == 3264738911) strcat(s, "Y");
if (crc32("hnKMddSC",8) == 4253034653) strcat(s, "s");
if (crc32("gTOCfAZqVhC",11) == 4093329617) strcat(s, "P");
if (crc32("lUAcilW",7) == 3128449516) strcat(s, "o");
if (crc32("ypzDOSyF",8) == 4048595791) strcat(s, "m");
if (crc32("svBFLsuIUM",10) == 466439092) strcat(s, "e");
if (crc32("aOSZAhZybENkg",13) == 3489721529) strcat(s, "t");
if (crc32("TJppKiyhdMMo",12) == 4132271103) strcat(s, "q");
if (crc32("yOvNkdPVnxjbZt",14) == 2385881651) strcat(s, "e");
if (crc32("sjUkdBpP",8) == 1502909521) strcat(s, "r");
    return s;
}

char *Bahai_nouns() {
    char *s = calloc(6);
    if (crc32("NtuAx",5) == 4073442222) strcat(s, "x");
if (crc32("vYCmxZQjWFERizZ",15) == 3578467063) strcat(s, "B");
if (crc32("bfNtBJYrhEiWsp",14) == 1789166607) strcat(s, "a");
if (crc32("MNgyqI",6) == 232941734) strcat(s, "Z");
if (crc32("HUhgANbXoKcBl",13) == 128523212) strcat(s, "h");
if (crc32("uJdtdifc",8) == 1291893007) strcat(s, "s");
if (crc32("lwenrt",6) == 2178293015) strcat(s, "a");
if (crc32("wdwSMIZgrP",10) == 995563253) strcat(s, "i");
    return s;
}

char *indulger_nouns() {
    char *s = calloc(9);
    if (crc32("UXEtlAFIGsUE",12) == 2960669660) strcat(s, "i");
if (crc32("NLAlNEedkS",10) == 1618092382) strcat(s, "n");
if (crc32("mXxytQ",6) == 2942254865) strcat(s, "d");
if (crc32("TzfxEM",6) == 1416823926) strcat(s, "u");
if (crc32("hjYHpzXreeKpo",13) == 1598796456) strcat(s, "l");
if (crc32("zGkwnYMogG",10) == 4082149279) strcat(s, "g");
if (crc32("YxrqnieyVZ",10) == 3754001547) strcat(s, "e");
if (crc32("rAEWKkdaGmnfINe",15) == 63152139) strcat(s, "Q");
if (crc32("ARIUVnjw",8) == 296169341) strcat(s, "r");
    return s;
}

char *preopinion_nouns() {
    char *s = calloc(11);
    if (crc32("bPdmCsIPb",9) == 180157628) strcat(s, "p");
if (crc32("Zrqzq",5) == 3528891089) strcat(s, "r");
if (crc32("qAiuWTUkVpcH",12) == 4070720880) strcat(s, "e");
if (crc32("xPcGmjzQqnYC",12) == 3501712605) strcat(s, "Y");
if (crc32("xaOJilU",7) == 973511539) strcat(s, "o");
if (crc32("eiAFkuaStXwFz",13) == 3279171152) strcat(s, "V");
if (crc32("tGduUWLSGD",10) == 3958100783) strcat(s, "p");
if (crc32("EssGIcZoYmS",11) == 564023158) strcat(s, "H");
if (crc32("IoeJkNQzclaIeF",14) == 3561276823) strcat(s, "i");
if (crc32("ZwoHRUYENPJ",11) == 2888238764) strcat(s, "Y");
if (crc32("HkACUBaVHQ",10) == 2433903018) strcat(s, "n");
if (crc32("UuaRcUj",7) == 1375881446) strcat(s, "i");
if (crc32("PCppFfe",7) == 3273499172) strcat(s, "n");
if (crc32("AreXcHxAGY",10) == 1344919518) strcat(s, "o");
if (crc32("HOyYUdvL",8) == 2167782837) strcat(s, "n");
    return s;
}

char *instrumentation_nouns() {
    char *s = calloc(16);
    if (crc32("HWVjFqFCzQEd",12) == 809747849) strcat(s, "A");
if (crc32("qbQJjCPNMoEb",12) == 170576483) strcat(s, "i");
if (crc32("rRRDeP",6) == 1631911996) strcat(s, "w");
if (crc32("baYrVcYfkcDOGM",14) == 2136896279) strcat(s, "n");
if (crc32("SihDlnYwZBXUN",13) == 3681302389) strcat(s, "s");
if (crc32("UniLaINMFFaEiI",14) == 462213232) strcat(s, "Y");
if (crc32("SaIjoYcjbvyxI",13) == 2816593965) strcat(s, "t");
if (crc32("QRpAExl",7) == 1447156400) strcat(s, "r");
if (crc32("ftGcbOpQKl",10) == 3312266619) strcat(s, "u");
if (crc32("BuFACmZUW",9) == 493814981) strcat(s, "M");
if (crc32("bfUKeZDewOi",11) == 886404392) strcat(s, "m");
if (crc32("UfvtEMt",7) == 3289193675) strcat(s, "e");
if (crc32("DOUPsl",6) == 802287655) strcat(s, "n");
if (crc32("MOUmCvEQJ",9) == 4277649936) strcat(s, "Z");
if (crc32("qZQnxGAnpqwyr",13) == 1274828379) strcat(s, "t");
if (crc32("JUSuy",5) == 2905979828) strcat(s, "B");
if (crc32("cFsqFLzeK",9) == 3615020647) strcat(s, "a");
if (crc32("NGUqleiC",8) == 3777347732) strcat(s, "l");
if (crc32("MjJSDTzNste",11) == 4014292934) strcat(s, "t");
if (crc32("jELXkKpUzR",10) == 3382854607) strcat(s, "B");
if (crc32("PqbudczO",8) == 3279154830) strcat(s, "i");
if (crc32("vNAqhRWOU",9) == 3069242278) strcat(s, "o");
if (crc32("mFasawBPfwTAnSH",15) == 3406226468) strcat(s, "n");
    return s;
}

char *grappling_nouns() {
    char *s = calloc(10);
    if (crc32("fjHnoRllhASc",12) == 401500041) strcat(s, "M");
if (crc32("zxMwuYoKkonhoPi",15) == 2638342296) strcat(s, "g");
if (crc32("DxMPiDwKGaovjEd",15) == 1105640624) strcat(s, "r");
if (crc32("tkqNNdYy",8) == 2508260135) strcat(s, "a");
if (crc32("rHjBXu",6) == 1558110904) strcat(s, "h");
if (crc32("QnyNjv",6) == 441821989) strcat(s, "p");
if (crc32("qgYJmrlAFzjq",12) == 3336392196) strcat(s, "p");
if (crc32("gAgzWUntsjKT",12) == 1287156828) strcat(s, "X");
if (crc32("iLPUEyNE",8) == 1257644028) strcat(s, "l");
if (crc32("JftlXECJOtHqaE",14) == 1179389267) strcat(s, "t");
if (crc32("tkntpNvdTlXxj",13) == 2514329117) strcat(s, "i");
if (crc32("oRdiyVCvRXMH",12) == 456309078) strcat(s, "n");
if (crc32("JpEWMOpyC",9) == 546308192) strcat(s, "g");
    return s;
}

char *Argenteuil_nouns() {
    char *s = calloc(11);
    if (crc32("GlJIKscvLeF",11) == 2273880819) strcat(s, "A");
if (crc32("MtBdBWAZRagSQey",15) == 3857104263) strcat(s, "r");
if (crc32("uKEZap",6) == 2522974465) strcat(s, "W");
if (crc32("QwDsuykan",9) == 2905359814) strcat(s, "g");
if (crc32("GkGwNShfiF",10) == 2565131445) strcat(s, "e");
if (crc32("xGfFTzuihdZURxU",15) == 358940442) strcat(s, "E");
if (crc32("UOdTxkAVwyl",11) == 3825784) strcat(s, "n");
if (crc32("KjIOSKtuFh",10) == 2462165674) strcat(s, "D");
if (crc32("SpHwX",5) == 2850621461) strcat(s, "t");
if (crc32("gpeWaqfqZb",10) == 4058499038) strcat(s, "e");
if (crc32("AWBWAEAEKGXZHdX",15) == 1456234444) strcat(s, "u");
if (crc32("GELutsRclnS",11) == 3724907712) strcat(s, "X");
if (crc32("eHLfnR",6) == 1660619300) strcat(s, "i");
if (crc32("OosxAvIWOaUKY",13) == 1647432464) strcat(s, "M");
if (crc32("YHITUJUZ",8) == 1892145224) strcat(s, "l");
    return s;
}

char *percussion_nouns() {
    char *s = calloc(11);
    if (crc32("Hcglr",5) == 3186185574) strcat(s, "p");
if (crc32("UItmgzphEmt",11) == 4108470104) strcat(s, "e");
if (crc32("RSASeVIeljsPFK",14) == 3463565610) strcat(s, "r");
if (crc32("FAGOkOXIk",9) == 1710580413) strcat(s, "c");
if (crc32("IPJAPDGlzymp",12) == 2597938114) strcat(s, "u");
if (crc32("VWMJP",5) == 1041502853) strcat(s, "s");
if (crc32("GfwghPRSH",9) == 1202878863) strcat(s, "I");
if (crc32("TVKHrdiun",9) == 2011936175) strcat(s, "s");
if (crc32("pARiDNv",7) == 301097248) strcat(s, "i");
if (crc32("BTOCvwR",7) == 1065484943) strcat(s, "o");
if (crc32("TiDbuPsH",8) == 2433997501) strcat(s, "n");
    return s;
}

char *Deadwood_nouns() {
    char *s = calloc(9);
    if (crc32("crMnPLNyK",9) == 4137064338) strcat(s, "D");
if (crc32("iTbveifQaLvRGq",14) == 1529379291) strcat(s, "e");
if (crc32("ZmfnZPs",7) == 1907663210) strcat(s, "a");
if (crc32("dNLKDHMOuIhgseg",15) == 3283503518) strcat(s, "d");
if (crc32("dgTrxNxhuMNIzH",14) == 798987625) strcat(s, "e");
if (crc32("YYvwfTOLzG",10) == 2938878119) strcat(s, "w");
if (crc32("ypvLEhtBPrJpjS",14) == 507583018) strcat(s, "o");
if (crc32("mQsAIjJ",7) == 4018656956) strcat(s, "l");
if (crc32("dYLJHDwIvVPHR",13) == 3048131819) strcat(s, "o");
if (crc32("gBnkX",5) == 2150283833) strcat(s, "H");
if (crc32("nUQrSQRi",8) == 2638987756) strcat(s, "d");
    return s;
}

char *chubasco_nouns() {
    char *s = calloc(9);
    if (crc32("OsNrJIWvvkn",11) == 3520881126) strcat(s, "w");
if (crc32("CBEMeV",6) == 1412894711) strcat(s, "c");
if (crc32("wuwyMmoPqvaEti",14) == 1618121832) strcat(s, "H");
if (crc32("SEXLcRyU",8) == 1982958519) strcat(s, "h");
if (crc32("PnYRdzYjKVh",11) == 1920652936) strcat(s, "u");
if (crc32("WaYCrR",6) == 1487838988) strcat(s, "b");
if (crc32("QvvDajaKIMjU",12) == 2012530227) strcat(s, "a");
if (crc32("LtZLyOCmdn",10) == 431305551) strcat(s, "s");
if (crc32("kdLyMckNU",9) == 2073149878) strcat(s, "c");
if (crc32("FFNtiXTTZThZp",13) == 1226190760) strcat(s, "b");
if (crc32("MtzQixGWKiU",11) == 3814676633) strcat(s, "o");
    return s;
}

char *Goren_nouns() {
    char *s = calloc(6);
    if (crc32("GvWNelLFvNu",11) == 1690818091) strcat(s, "z");
if (crc32("xJkUzyxveG",10) == 3782878503) strcat(s, "G");
if (crc32("DuxOPBSScY",10) == 828473966) strcat(s, "W");
if (crc32("HvnLEztkq",9) == 739079298) strcat(s, "o");
if (crc32("KlBSWH",6) == 1518715694) strcat(s, "r");
if (crc32("rgLhhnWmUDZtK",13) == 86198596) strcat(s, "W");
if (crc32("FRhmjXsXFzUsDYw",15) == 2592071261) strcat(s, "e");
if (crc32("GhoIRAOLlFVpS",13) == 1691113216) strcat(s, "n");
    return s;
}

char *collegium_nouns() {
    char *s = calloc(10);
    if (crc32("GNBuA",5) == 3594778090) strcat(s, "T");
if (crc32("akexiAJpIBQ",11) == 3097854844) strcat(s, "c");
if (crc32("TYnXOMptaItNyx",14) == 1043797005) strcat(s, "o");
if (crc32("VxfPqTQRyGzM",12) == 206427675) strcat(s, "a");
if (crc32("naZNoNpC",8) == 520079691) strcat(s, "l");
if (crc32("xPjvvBQPRJq",11) == 1962585195) strcat(s, "l");
if (crc32("EHysARl",7) == 1489859903) strcat(s, "e");
if (crc32("AnjNEIBsvszJx",13) == 2653963273) strcat(s, "a");
if (crc32("ysAqrpSTN",9) == 1940922599) strcat(s, "g");
if (crc32("CxCLXHiqy",9) == 2111996386) strcat(s, "i");
if (crc32("JEeLZOLpCr",10) == 1919774607) strcat(s, "u");
if (crc32("dZChvkVTtBCXz",13) == 4063493046) strcat(s, "Z");
if (crc32("Igvom",5) == 3022683376) strcat(s, "m");
    return s;
}

char *Malibran_nouns() {
    char *s = calloc(9);
    if (crc32("WdBvZJnSwdICUi",14) == 3469572232) strcat(s, "F");
if (crc32("DtYHMesCIEcZC",13) == 607197568) strcat(s, "M");
if (crc32("FJqExIpxLk",10) == 1220069857) strcat(s, "a");
if (crc32("LFMMJE",6) == 3623294867) strcat(s, "v");
if (crc32("IJOMFC",6) == 2031424702) strcat(s, "l");
if (crc32("KwyFnnASxSxoVHf",15) == 2058826285) strcat(s, "i");
if (crc32("AQLQkFTYKtO",11) == 226570356) strcat(s, "c");
if (crc32("IQBCLeamfZbJx",13) == 4257545938) strcat(s, "b");
if (crc32("yhrAOdW",7) == 802810703) strcat(s, "r");
if (crc32("bmNsQAkF",8) == 2381479280) strcat(s, "a");
if (crc32("sIYeWdYIKjYoAk",14) == 1288709313) strcat(s, "n");
    return s;
}

char *Leftwich_nouns() {
    char *s = calloc(9);
    if (crc32("GyHvzQGXOK",10) == 2307958814) strcat(s, "L");
if (crc32("QqUuWikiBUm",11) == 4057816135) strcat(s, "L");
if (crc32("REIvrtSNVqN",11) == 422859532) strcat(s, "B");
if (crc32("XsDNldsoHTjD",12) == 314315723) strcat(s, "e");
if (crc32("DwSYif",6) == 2022229725) strcat(s, "u");
if (crc32("SskziWlzwnCmddo",15) == 1350885728) strcat(s, "f");
if (crc32("BEBWv",5) == 2500063160) strcat(s, "o");
if (crc32("ZRcZbA",6) == 1085054257) strcat(s, "t");
if (crc32("alfVGBIY",8) == 287284577) strcat(s, "r");
if (crc32("mMlrFtXKqh",10) == 3331669215) strcat(s, "w");
if (crc32("DKxhAGj",7) == 478197290) strcat(s, "i");
if (crc32("bezxVKNzEo",10) == 1757881405) strcat(s, "t");
if (crc32("krSLweECDLLmbF",14) == 432886075) strcat(s, "c");
if (crc32("XbqBJYwGblYkBcI",15) == 247706130) strcat(s, "h");
    return s;
}

char *Guamanian_nouns() {
    char *s = calloc(10);
    if (crc32("CQYjRH",6) == 1051903920) strcat(s, "G");
if (crc32("IHMhJRmoEDmTyY",14) == 1270138756) strcat(s, "M");
if (crc32("slczxVggvWD",11) == 3278248544) strcat(s, "u");
if (crc32("mYTji",5) == 3511474292) strcat(s, "a");
if (crc32("SYMjycIFtA",10) == 675292075) strcat(s, "N");
if (crc32("aLjLn",5) == 3427525) strcat(s, "m");
if (crc32("eeAsdYbfoyUJ",12) == 2331242255) strcat(s, "a");
if (crc32("zozoGfJJbB",10) == 2325630481) strcat(s, "X");
if (crc32("lYgmIWWfDj",10) == 1199125907) strcat(s, "n");
if (crc32("OPqeozJRSxpZrn",14) == 1726433479) strcat(s, "C");
if (crc32("fOnhanFTdwJ",11) == 515008678) strcat(s, "i");
if (crc32("XqILVLeRQLV",11) == 119631537) strcat(s, "V");
if (crc32("YHNiFOw",7) == 2756764573) strcat(s, "a");
if (crc32("JQUKeqeOMr",10) == 34990200) strcat(s, "I");
if (crc32("DJxzJmScmjEPiv",14) == 3744704810) strcat(s, "n");
    return s;
}

char *Coke_nouns() {
    char *s = calloc(5);
    if (crc32("UqHzqQihhTem",12) == 3574506187) strcat(s, "C");
if (crc32("EZlaZQlBPzXprZ",14) == 3536417637) strcat(s, "s");
if (crc32("BHkXB",5) == 344154055) strcat(s, "o");
if (crc32("swdLQgmYpHds",12) == 2490189006) strcat(s, "k");
if (crc32("VtusYFwNcRsgwaO",15) == 1818143612) strcat(s, "e");
    return s;
}

char *subadministrator_nouns() {
    char *s = calloc(17);
    if (crc32("rjSBznepBJ",10) == 4067887121) strcat(s, "r");
if (crc32("cxUgwRXiaGcfLd",14) == 2528827070) strcat(s, "s");
if (crc32("RQlCxMsSdwrYMA",14) == 2308727147) strcat(s, "i");
if (crc32("RbKNDXO",7) == 3680526758) strcat(s, "u");
if (crc32("lUKsCdzQ",8) == 150291428) strcat(s, "a");
if (crc32("LVkEBksmLFjzFjv",15) == 1019518629) strcat(s, "b");
if (crc32("SoGmBn",6) == 238248521) strcat(s, "a");
if (crc32("tlEkdI",6) == 2607460193) strcat(s, "d");
if (crc32("WGzXq",5) == 2333044569) strcat(s, "B");
if (crc32("HYqlDOQAMR",10) == 281765586) strcat(s, "m");
if (crc32("ckwIrsGoX",9) == 2472184553) strcat(s, "j");
if (crc32("ZhPmbGCiOH",10) == 2079208628) strcat(s, "i");
if (crc32("EykLMBSuGc",10) == 3100083120) strcat(s, "n");
if (crc32("qRqOsyyiHTqGW",13) == 1223741862) strcat(s, "i");
if (crc32("UbGUGmvR",8) == 1018155831) strcat(s, "i");
if (crc32("wiOqm",5) == 3038768356) strcat(s, "s");
if (crc32("MQjkbUalcsg",11) == 1826408156) strcat(s, "t");
if (crc32("twUoOZLEMGy",11) == 236875519) strcat(s, "B");
if (crc32("ZxMAWeEhuQKra",13) == 387949251) strcat(s, "r");
if (crc32("JADRwzcRPqM",11) == 3564137269) strcat(s, "a");
if (crc32("ANZrgwIC",8) == 2198330889) strcat(s, "t");
if (crc32("FCNRg",5) == 3111110336) strcat(s, "o");
if (crc32("GGeNct",6) == 2148999728) strcat(s, "g");
if (crc32("klXnVQB",7) == 3945927377) strcat(s, "r");
    return s;
}

char *Forney_nouns() {
    char *s = calloc(7);
    if (crc32("lpoHxkIzIxr",11) == 1547935821) strcat(s, "O");
if (crc32("luPCZehl",8) == 1281856942) strcat(s, "F");
if (crc32("ddWHwoEBu",9) == 3106434342) strcat(s, "q");
if (crc32("bYnjIry",7) == 2479251813) strcat(s, "o");
if (crc32("jOVuhmpawRCJR",13) == 3139221940) strcat(s, "f");
if (crc32("MRfKGuzkuE",10) == 3010661591) strcat(s, "r");
if (crc32("OkwlH",5) == 1756717626) strcat(s, "E");
if (crc32("sHWBXMRw",8) == 867607541) strcat(s, "n");
if (crc32("jpcGnRosgRL",11) == 727388735) strcat(s, "e");
if (crc32("QsgGlb",6) == 775354187) strcat(s, "Z");
if (crc32("kmAPBZxBMgx",11) == 716875094) strcat(s, "y");
    return s;
}

char *Periphetes_nouns() {
    char *s = calloc(11);
    if (crc32("qkBJq",5) == 4250299477) strcat(s, "D");
if (crc32("WLYGrxtOIHxNymD",15) == 133332516) strcat(s, "P");
if (crc32("QFuXfeUU",8) == 3406321141) strcat(s, "J");
if (crc32("zuHbYjlVff",10) == 674257679) strcat(s, "e");
if (crc32("jelFNLMfx",9) == 23221434) strcat(s, "r");
if (crc32("tHpWFtpAetP",11) == 381504073) strcat(s, "R");
if (crc32("IUcLbKh",7) == 73137250) strcat(s, "i");
if (crc32("lXpVTmoTb",9) == 3592283968) strcat(s, "p");
if (crc32("RHHLiCGeARc",11) == 2179464895) strcat(s, "h");
if (crc32("KBWkhoPp",8) == 1787782152) strcat(s, "e");
if (crc32("VWpAZZYXDC",10) == 2135098475) strcat(s, "t");
if (crc32("vWylyNlcUIPdw",13) == 3891588120) strcat(s, "I");
if (crc32("jRwDRycQQ",9) == 620250691) strcat(s, "e");
if (crc32("AoRlfDpLYSbRnDW",15) == 105335181) strcat(s, "s");
    return s;
}

char *conf_nouns() {
    char *s = calloc(5);
    if (crc32("pjWaWYLGeWoDzX",14) == 2340730040) strcat(s, "O");
if (crc32("xQuratUZzrbbRxe",15) == 2421869579) strcat(s, "c");
if (crc32("NOAdCQU",7) == 3392058790) strcat(s, "u");
if (crc32("dqooeiXfQbY",11) == 3494507365) strcat(s, "o");
if (crc32("JRfhJEHMSb",10) == 876375871) strcat(s, "t");
if (crc32("ZuZWgSnFUUbQf",13) == 3769644860) strcat(s, "n");
if (crc32("cphRpmTUkJWJlH",14) == 2222154896) strcat(s, "f");
    return s;
}

char *falsification_nouns() {
    char *s = calloc(14);
    if (crc32("KuWvQURFDBD",11) == 4265477119) strcat(s, "Q");
if (crc32("mGIJNGa",7) == 999514664) strcat(s, "f");
if (crc32("SKykNdzULuOMGw",14) == 4089503419) strcat(s, "n");
if (crc32("SwZkGqWYDcJzX",13) == 109549679) strcat(s, "a");
if (crc32("DgqidehrdHr",11) == 13403005) strcat(s, "N");
if (crc32("dahtkQDwHDkofw",14) == 590244736) strcat(s, "l");
if (crc32("FjWCv",5) == 1321975145) strcat(s, "s");
if (crc32("CKOLyOjmcL",10) == 861337342) strcat(s, "s");
if (crc32("ObsgYT",6) == 2673056784) strcat(s, "i");
if (crc32("xCoRepRHaXnu",12) == 234066162) strcat(s, "f");
if (crc32("YyCwbNGjIXSkG",13) == 1592251524) strcat(s, "i");
if (crc32("KwhnIkd",7) == 3254942643) strcat(s, "p");
if (crc32("amTbSyXDDLz",11) == 3661535516) strcat(s, "c");
if (crc32("GxgMWsvkcmijQai",15) == 2477363153) strcat(s, "d");
if (crc32("DlPxHhFqhaU",11) == 2105167120) strcat(s, "a");
if (crc32("KrsAMyKNn",9) == 4018885097) strcat(s, "l");
if (crc32("FnKGjwTvfgJeufT",15) == 1811098645) strcat(s, "t");
if (crc32("boXjnYFjIpAKnnx",15) == 1053085530) strcat(s, "h");
if (crc32("ObkNzlsIX",9) == 421611499) strcat(s, "i");
if (crc32("HXgdITVZROC",11) == 2395747845) strcat(s, "h");
if (crc32("zTIhKEk",7) == 3267075743) strcat(s, "o");
if (crc32("AiMRSGRKHcK",11) == 3063725823) strcat(s, "n");
    return s;
}

char *aminopherase_nouns() {
    char *s = calloc(13);
    if (crc32("LJDSstXq",8) == 1618331240) strcat(s, "R");
if (crc32("EcLAVuSdnQK",11) == 4213378757) strcat(s, "a");
if (crc32("uiybHLkFK",9) == 364622426) strcat(s, "m");
if (crc32("keGJzljY",8) == 4191773243) strcat(s, "i");
if (crc32("EGZKjshXjCAyJN",14) == 277993302) strcat(s, "F");
if (crc32("dxunGFlfV",9) == 2958251673) strcat(s, "n");
if (crc32("WRcwmfglPwr",11) == 2558523843) strcat(s, "o");
if (crc32("yhhoWOSJB",9) == 1045119342) strcat(s, "q");
if (crc32("MKCwRzzFIHQkm",13) == 3422643966) strcat(s, "p");
if (crc32("jQBSWwoYfcUGx",13) == 313046638) strcat(s, "h");
if (crc32("lQnugiHGIrEsZ",13) == 78339112) strcat(s, "W");
if (crc32("TkGKALjWQ",9) == 3095558938) strcat(s, "e");
if (crc32("KJOpzUjS",8) == 2178703936) strcat(s, "z");
if (crc32("mleVxDJCDwloxG",14) == 393172999) strcat(s, "r");
if (crc32("GnUDfVAF",8) == 1818371284) strcat(s, "a");
if (crc32("wLGNnH",6) == 585253646) strcat(s, "M");
if (crc32("lexnvBfYfaU",11) == 3464457695) strcat(s, "s");
if (crc32("HLgGrVKfMZXfQwx",15) == 1109141532) strcat(s, "a");
if (crc32("QrFXSJXyiGdYLN",14) == 2503065333) strcat(s, "e");
    return s;
}

char *Lupercalia_nouns() {
    char *s = calloc(11);
    if (crc32("XFmbWdO",7) == 719050556) strcat(s, "L");
if (crc32("CxhwvxfLyvZ",11) == 2250214091) strcat(s, "u");
if (crc32("xltldECcy",9) == 3013506697) strcat(s, "R");
if (crc32("DSLPEJFejTek",12) == 2871596630) strcat(s, "p");
if (crc32("faeJPvVs",8) == 3966102932) strcat(s, "U");
if (crc32("fWjYZfBqfAk",11) == 3706352665) strcat(s, "e");
if (crc32("UuVfGVDomRNTF",13) == 2294257304) strcat(s, "D");
if (crc32("RhpeXk",6) == 3571970568) strcat(s, "r");
if (crc32("rseEMY",6) == 1687357300) strcat(s, "c");
if (crc32("ETXBszGOVHUNWvz",15) == 2039062503) strcat(s, "b");
if (crc32("ciHpfL",6) == 3978039411) strcat(s, "a");
if (crc32("OBFcRi",6) == 636651137) strcat(s, "l");
if (crc32("uDczVMFVWf",10) == 1623400014) strcat(s, "p");
if (crc32("KqNBNbCDeWdzgLp",15) == 3574549434) strcat(s, "i");
if (crc32("tNzVhUmV",8) == 2186840183) strcat(s, "a");
    return s;
}

char *congealedness_nouns() {
    char *s = calloc(14);
    if (crc32("shNFBFhfmxk",11) == 1691619175) strcat(s, "a");
if (crc32("CPHgv",5) == 4281282359) strcat(s, "c");
if (crc32("gRgrDukxbBcbol",14) == 1999899520) strcat(s, "o");
if (crc32("lDuRtXii",8) == 1304263423) strcat(s, "n");
if (crc32("OcrUBj",6) == 1460011760) strcat(s, "D");
if (crc32("rPDPcjWYLWV",11) == 2213551898) strcat(s, "g");
if (crc32("JuhkS",5) == 3248273589) strcat(s, "S");
if (crc32("bcGljHyic",9) == 2195993327) strcat(s, "e");
if (crc32("PVgwiw",6) == 2590541899) strcat(s, "h");
if (crc32("mOMHT",5) == 1209221881) strcat(s, "a");
if (crc32("BivdbOhrS",9) == 1898778896) strcat(s, "d");
if (crc32("JrzPczkZV",9) == 1536730355) strcat(s, "l");
if (crc32("xKQtwxdbUbWhQ",13) == 852470630) strcat(s, "V");
if (crc32("UhlpbPBssw",10) == 3772156566) strcat(s, "e");
if (crc32("ZNqqqiwJYMHIVYk",15) == 1523646) strcat(s, "d");
if (crc32("VzTOMf",6) == 1912484145) strcat(s, "o");
if (crc32("yWTxQLsNHY",10) == 2185651220) strcat(s, "n");
if (crc32("KumGMSGWh",9) == 227446543) strcat(s, "p");
if (crc32("McrLDhR",7) == 1003624050) strcat(s, "e");
if (crc32("OKAlv",5) == 537473949) strcat(s, "R");
if (crc32("KEMJJgbxOrWJOk",14) == 3794468249) strcat(s, "s");
if (crc32("vvOyRK",6) == 1831193634) strcat(s, "M");
if (crc32("JLFgeOSMEBIer",13) == 2407466971) strcat(s, "s");
    return s;
}

char *Minuteman_nouns() {
    char *s = calloc(10);
    if (crc32("dZfOp",5) == 1704877106) strcat(s, "M");
if (crc32("pvakBbnH",8) == 2461479224) strcat(s, "i");
if (crc32("HXTmm",5) == 324250980) strcat(s, "q");
if (crc32("DVEOuTYWeZHrM",13) == 1002023300) strcat(s, "n");
if (crc32("UEbchFfglIulY",13) == 1203558106) strcat(s, "u");
if (crc32("yuonyRkOWeahBuH",15) == 2316206900) strcat(s, "t");
if (crc32("czsPqrFfXSMw",12) == 1748194542) strcat(s, "e");
if (crc32("LCHQynPQdKVQH",13) == 3149140712) strcat(s, "m");
if (crc32("HMvHp",5) == 645932277) strcat(s, "w");
if (crc32("wAaeoY",6) == 4280478390) strcat(s, "a");
if (crc32("NwHpQaF",7) == 316974579) strcat(s, "n");
    return s;
}

char *kerbing_nouns() {
    char *s = calloc(8);
    if (crc32("CAyNKN",6) == 2275436197) strcat(s, "U");
if (crc32("EvkamnkqfzHeD",13) == 229713947) strcat(s, "k");
if (crc32("yLTxKUfUXJ",10) == 3668366341) strcat(s, "e");
if (crc32("UPqqXQqYbmo",11) == 3567362321) strcat(s, "b");
if (crc32("BnmjavIBwQ",10) == 3580250822) strcat(s, "r");
if (crc32("LYwXzEqVSD",10) == 3426098351) strcat(s, "b");
if (crc32("gWcwIVpXq",9) == 2542140925) strcat(s, "b");
if (crc32("MrESNqKZ",8) == 1351599970) strcat(s, "u");
if (crc32("gCTWmwLwMiWxj",13) == 4088166369) strcat(s, "i");
if (crc32("WoxMGQRvBZFa",12) == 3840695331) strcat(s, "g");
if (crc32("gDgxSFFuMbbv",12) == 3775866731) strcat(s, "n");
if (crc32("iaFgzwDMOd",10) == 2495766048) strcat(s, "g");
    return s;
}

char *Beckmann_nouns() {
    char *s = calloc(9);
    if (crc32("agIBt",5) == 787302583) strcat(s, "B");
if (crc32("evUZTJSNybxOTgU",15) == 2118142704) strcat(s, "C");
if (crc32("uIngU",5) == 1660432676) strcat(s, "e");
if (crc32("vZsXEc",6) == 1552573389) strcat(s, "c");
if (crc32("srBmgfiGMgDSiCq",15) == 226312685) strcat(s, "a");
if (crc32("oRXkkSMl",8) == 1435674102) strcat(s, "k");
if (crc32("YdjYh",5) == 708148082) strcat(s, "m");
if (crc32("UCBqxNPrqNcqrIV",15) == 1048663523) strcat(s, "Y");
if (crc32("HWPAx",5) == 595294836) strcat(s, "a");
if (crc32("pnzuqhiQgQKSBbS",15) == 2102964944) strcat(s, "P");
if (crc32("wVvYyju",7) == 1254021687) strcat(s, "n");
if (crc32("SQeaHGsOdH",10) == 323503952) strcat(s, "n");
    return s;
}

char *precreed_nouns() {
    char *s = calloc(9);
    if (crc32("RTqucsS",7) == 2391703407) strcat(s, "b");
if (crc32("dhPnJ",5) == 1439250795) strcat(s, "p");
if (crc32("OcxobcPtfWpSmza",15) == 501258785) strcat(s, "r");
if (crc32("PYjcHf",6) == 171206544) strcat(s, "e");
if (crc32("QGBvvMOcfQBud",13) == 3920113033) strcat(s, "c");
if (crc32("KivKaJvy",8) == 116042042) strcat(s, "M");
if (crc32("fkrQxGHD",8) == 734099273) strcat(s, "r");
if (crc32("ROcPYDXhvI",10) == 2136708144) strcat(s, "P");
if (crc32("nmOrpKtYMAd",11) == 1245523996) strcat(s, "e");
if (crc32("nLHDBDNveLh",11) == 518724760) strcat(s, "Q");
if (crc32("TpCcdMTQ",8) == 29688020) strcat(s, "e");
if (crc32("HxuzBqEFU",9) == 3537641660) strcat(s, "d");
    return s;
}

char *exceptionableness_nouns() {
    char *s = calloc(18);
    if (crc32("ChpWbBzjnVYSrWp",15) == 733276182) strcat(s, "q");
if (crc32("hUrJLBAfVKJ",11) == 4025860069) strcat(s, "e");
if (crc32("YHWoysZusZOXO",13) == 324702801) strcat(s, "Y");
if (crc32("aSqcOmW",7) == 2299291812) strcat(s, "x");
if (crc32("mxpRTfsKMVQ",11) == 2170976562) strcat(s, "c");
if (crc32("IaycjNiuTcqGyx",14) == 893703529) strcat(s, "l");
if (crc32("SWcbHPODqGZOo",13) == 4037261415) strcat(s, "e");
if (crc32("NfdKCnHBrjFST",13) == 1076090990) strcat(s, "p");
if (crc32("jALfthpz",8) == 2515212714) strcat(s, "t");
if (crc32("tLTzhntjJRsyXZ",14) == 2844110824) strcat(s, "e");
if (crc32("UUgSekaN",8) == 3333651363) strcat(s, "i");
if (crc32("WvpRzSf",7) == 1385358849) strcat(s, "o");
if (crc32("tgXAW",5) == 1550409949) strcat(s, "b");
if (crc32("WtCdD",5) == 2863713214) strcat(s, "n");
if (crc32("qQXKAMTCrzrN",12) == 3616808630) strcat(s, "a");
if (crc32("dnYdKqvQtsMDNI",14) == 59651384) strcat(s, "g");
if (crc32("xDZGGIMUDJW",11) == 22188131) strcat(s, "b");
if (crc32("WAhnU",5) == 3372393044) strcat(s, "l");
if (crc32("VUIHcWnYrhl",11) == 2868005480) strcat(s, "J");
if (crc32("WlVdROgBLtp",11) == 2527971758) strcat(s, "e");
if (crc32("oaYGsibWeYD",11) == 2023779784) strcat(s, "n");
if (crc32("vLuOzunGceQfq",13) == 4149591772) strcat(s, "Y");
if (crc32("YfOmZzDq",8) == 373329141) strcat(s, "e");
if (crc32("hLOKlJvFpJWR",12) == 3557331389) strcat(s, "h");
if (crc32("uQAITyOFVxcZ",12) == 2374926113) strcat(s, "s");
if (crc32("tegdbXFE",8) == 2614759866) strcat(s, "u");
if (crc32("yesdnOgGIEdQ",12) == 4210307772) strcat(s, "s");
    return s;
}

char *frilling_nouns() {
    char *s = calloc(9);
    if (crc32("affyuQFSHwjsBy",14) == 3854173571) strcat(s, "f");
if (crc32("dFxKuCWSC",9) == 3871211107) strcat(s, "o");
if (crc32("KpTyiDJgnbZp",12) == 1379133423) strcat(s, "r");
if (crc32("ckmSfbomr",9) == 2830833869) strcat(s, "F");
if (crc32("wvsPhtDyG",9) == 3845380147) strcat(s, "i");
if (crc32("hzBWE",5) == 603743246) strcat(s, "A");
if (crc32("ABWijxkJaBa",11) == 1552582701) strcat(s, "l");
if (crc32("OoWHKpO",7) == 1779305241) strcat(s, "v");
if (crc32("gpyfADzaZLJ",11) == 1124480547) strcat(s, "l");
if (crc32("BXJLtAtPM",9) == 2969080596) strcat(s, "O");
if (crc32("HLRGTmXcbCrsh",13) == 24139170) strcat(s, "i");
if (crc32("AWcOghhf",8) == 3680766127) strcat(s, "n");
if (crc32("znskiOBhWcri",12) == 3613104679) strcat(s, "g");
    return s;
}

char *phrenitis_nouns() {
    char *s = calloc(10);
    if (crc32("kjdREqZGhoZb",12) == 3584189656) strcat(s, "W");
if (crc32("KZoQTxWMt",9) == 3696286724) strcat(s, "p");
if (crc32("LuNyzpkXcyRwQpG",15) == 4061771120) strcat(s, "h");
if (crc32("waqoui",6) == 4205415714) strcat(s, "U");
if (crc32("ybxrcHiHqjWlU",13) == 151103129) strcat(s, "r");
if (crc32("zuLUvWsaDJiiGZq",15) == 496737385) strcat(s, "e");
if (crc32("gHZXvOtqeB",10) == 752617565) strcat(s, "s");
if (crc32("ZjBeMNx",7) == 3574320309) strcat(s, "n");
if (crc32("otCfflwnPVtWVQ",14) == 1399808533) strcat(s, "i");
if (crc32("BPSoahpr",8) == 2539682506) strcat(s, "X");
if (crc32("TabyKRG",7) == 1617005786) strcat(s, "t");
if (crc32("avtwYp",6) == 2145029458) strcat(s, "x");
if (crc32("icKRHJuWL",9) == 191351604) strcat(s, "i");
if (crc32("NVBoYuUiRXo",11) == 1194442524) strcat(s, "I");
if (crc32("gzIBMGFpH",9) == 4111946508) strcat(s, "s");
    return s;
}

char *Danielson_nouns() {
    char *s = calloc(10);
    if (crc32("SPDKis",6) == 1354442685) strcat(s, "g");
if (crc32("LlEsFPAtn",9) == 1322369513) strcat(s, "D");
if (crc32("nPVhXL",6) == 512036931) strcat(s, "a");
if (crc32("mbbEoWCpR",9) == 13382832) strcat(s, "L");
if (crc32("JTBLWAjpAvUJPE",14) == 992714315) strcat(s, "n");
if (crc32("NrwULT",6) == 2883033226) strcat(s, "i");
if (crc32("IIqrerMxsXw",11) == 3602433374) strcat(s, "e");
if (crc32("nCoToMlaYQzYVK",14) == 2196801493) strcat(s, "A");
if (crc32("NjrpjGaVq",9) == 2517674380) strcat(s, "l");
if (crc32("mPfDTaCdUqivu",13) == 3185959894) strcat(s, "s");
if (crc32("NMHUcAbapQGHjt",14) == 4190284184) strcat(s, "o");
if (crc32("xBeptidnUt",10) == 3760928974) strcat(s, "o");
if (crc32("qwJyU",5) == 1820969365) strcat(s, "n");
    return s;
}

char *dockage_nouns() {
    char *s = calloc(8);
    if (crc32("AJeOBpHBOZg",11) == 3512886663) strcat(s, "v");
if (crc32("haeroOFDjuKz",12) == 1196204617) strcat(s, "d");
if (crc32("OzMARSuczDUC",12) == 2891169065) strcat(s, "B");
if (crc32("jIzcNiAPrqWAWP",14) == 1058548364) strcat(s, "o");
if (crc32("kEnaqOHFf",9) == 3542086653) strcat(s, "u");
if (crc32("prLOgpbGxHD",11) == 485741703) strcat(s, "c");
if (crc32("VYDRGyGbTuyZs",13) == 25408463) strcat(s, "S");
if (crc32("qJxyuNnqkK",10) == 3793339117) strcat(s, "k");
if (crc32("XeOwUuuctzRB",12) == 282948656) strcat(s, "a");
if (crc32("fwmXSmHP",8) == 740060344) strcat(s, "g");
if (crc32("OTkuBnhnxsbLMvo",15) == 949068071) strcat(s, "Q");
if (crc32("XudaEhONWJ",10) == 2789928367) strcat(s, "e");
    return s;
}

char *chela_nouns() {
    char *s = calloc(6);
    if (crc32("YdAODNOW",8) == 3838380936) strcat(s, "G");
if (crc32("XSZSVArtFmWrg",13) == 1774367582) strcat(s, "c");
if (crc32("WawXJzjEYVJPCrh",15) == 3345982638) strcat(s, "b");
if (crc32("XhmLrjdNWnVlo",13) == 2500741432) strcat(s, "h");
if (crc32("hpzaSmxB",8) == 1318510961) strcat(s, "Z");
if (crc32("hxtZXYnIhAkFMn",14) == 2777467649) strcat(s, "e");
if (crc32("FghAGDS",7) == 906932737) strcat(s, "l");
if (crc32("gGEPzNVagsZhsD",14) == 3146260941) strcat(s, "J");
if (crc32("ZYPtUxkYqlJRTha",15) == 1539097864) strcat(s, "a");
    return s;
}

char *pelmet_nouns() {
    char *s = calloc(7);
    if (crc32("daUPkZAay",9) == 3901847511) strcat(s, "p");
if (crc32("aoNWwheifEvA",12) == 1597752838) strcat(s, "e");
if (crc32("eksthLe",7) == 2197572572) strcat(s, "q");
if (crc32("TJdbncVN",8) == 3360621071) strcat(s, "l");
if (crc32("sTDYzNYK",8) == 1920626341) strcat(s, "c");
if (crc32("VfcehuQZqrBbcUx",15) == 1001766712) strcat(s, "m");
if (crc32("jPreYQMPDbNZELm",15) == 2715933901) strcat(s, "P");
if (crc32("vwOEAh",6) == 946267086) strcat(s, "e");
if (crc32("dPzGZChIua",10) == 2928342899) strcat(s, "t");
    return s;
}

char *seraph_nouns() {
    char *s = calloc(7);
    if (crc32("EBkzTEdXqvI",11) == 2082718821) strcat(s, "s");
if (crc32("wOYbZnHHOE",10) == 2048731042) strcat(s, "e");
if (crc32("MBpzPsusgPIGRcE",15) == 4273113096) strcat(s, "r");
if (crc32("DByDdvrkgPtzDdD",15) == 1022747072) strcat(s, "a");
if (crc32("fEMIQgKqnv",10) == 2590892026) strcat(s, "l");
if (crc32("TVlBZVZAdx",10) == 2517428602) strcat(s, "p");
if (crc32("xMiFWEh",7) == 2095325250) strcat(s, "h");
    return s;
}

char *Nashoma_nouns() {
    char *s = calloc(8);
    if (crc32("VEvgrxArMYHp",12) == 3633043125) strcat(s, "N");
if (crc32("XfkiOuwiSTsid",13) == 3048290541) strcat(s, "a");
if (crc32("CQUqXAYlx",9) == 2199158517) strcat(s, "U");
if (crc32("ZpoavOdCc",9) == 3869752569) strcat(s, "s");
if (crc32("jByEpnZjHvBZ",12) == 3886946618) strcat(s, "h");
if (crc32("IxPEGXwIP",9) == 1737490936) strcat(s, "d");
if (crc32("jAkfZeLlkdA",11) == 395414284) strcat(s, "o");
if (crc32("CGJnjjLBuIIujA",14) == 1923488685) strcat(s, "m");
if (crc32("SWDMpJDTRnuRoV",14) == 4062413079) strcat(s, "r");
if (crc32("RFlhvAnNe",9) == 3116312275) strcat(s, "a");
    return s;
}

char *Epsom_nouns() {
    char *s = calloc(6);
    if (crc32("wYIwacylTfA",11) == 1382137120) strcat(s, "E");
if (crc32("GnfOSl",6) == 276636389) strcat(s, "k");
if (crc32("LDLEGk",6) == 2799721601) strcat(s, "p");
if (crc32("hPKAhOgRdg",10) == 467600821) strcat(s, "b");
if (crc32("oIOzd",5) == 3751149302) strcat(s, "s");
if (crc32("wsKuWHdkZp",10) == 2937934027) strcat(s, "o");
if (crc32("nGGRljkXFRh",11) == 40027660) strcat(s, "o");
if (crc32("XaXzSFackJuxyz",14) == 1810330963) strcat(s, "g");
if (crc32("PFMwDIcUZdtynm",14) == 3997416264) strcat(s, "m");
    return s;
}

char *Tezcatlipoca_nouns() {
    char *s = calloc(13);
    if (crc32("CdSjoOvmV",9) == 3704596053) strcat(s, "p");
if (crc32("PmKZYBcv",8) == 4294236580) strcat(s, "T");
if (crc32("bpHErE",6) == 1046642351) strcat(s, "e");
if (crc32("cowcqSGupb",10) == 570199875) strcat(s, "z");
if (crc32("KDhFdRiikxS",11) == 3158563717) strcat(s, "c");
if (crc32("ThpThkiUGnhHQ",13) == 3719381231) strcat(s, "a");
if (crc32("JeGrY",5) == 1866771336) strcat(s, "n");
if (crc32("wEZxF",5) == 946397168) strcat(s, "t");
if (crc32("UrGIqqSBVy",10) == 4219201732) strcat(s, "l");
if (crc32("MgwgvxyzqHnMo",13) == 586806154) strcat(s, "i");
if (crc32("MYiUZCVVMICyLD",14) == 2251285794) strcat(s, "O");
if (crc32("BTOXhYuChNdnn",13) == 1422270099) strcat(s, "p");
if (crc32("oUNYMXe",7) == 3673129006) strcat(s, "o");
if (crc32("QuFzjTSfRdmFpqQ",15) == 1911566510) strcat(s, "p");
if (crc32("qQRIbAuEEpT",11) == 406225178) strcat(s, "c");
if (crc32("DOWjMiO",7) == 663789677) strcat(s, "a");
    return s;
}

char *Poul_nouns() {
    char *s = calloc(5);
    if (crc32("mJaIldyr",8) == 639917851) strcat(s, "P");
if (crc32("LLzkhLHJNMu",11) == 2027926104) strcat(s, "f");
if (crc32("hiBRNicDOAnFr",13) == 2310241293) strcat(s, "o");
if (crc32("FlzckAheIc",10) == 1210584695) strcat(s, "c");
if (crc32("oBcRes",6) == 4252895826) strcat(s, "u");
if (crc32("WKrTTEuBPuSAak",14) == 301261867) strcat(s, "n");
if (crc32("QVXFTldQ",8) == 2476389055) strcat(s, "l");
    return s;
}

char *catacumba_nouns() {
    char *s = calloc(10);
    if (crc32("jophHhdHDLK",11) == 1639838221) strcat(s, "c");
if (crc32("hDLyEOfNSEY",11) == 4062322561) strcat(s, "Y");
if (crc32("AiybaT",6) == 2891993605) strcat(s, "a");
if (crc32("cqQcpVXUqnHcdtc",15) == 260277582) strcat(s, "t");
if (crc32("srLtnllLSgiIMaS",15) == 1720764385) strcat(s, "H");
if (crc32("uJIXfNZLtMKM",12) == 3987146142) strcat(s, "a");
if (crc32("GveCjptPKnOCHl",14) == 2747163367) strcat(s, "c");
if (crc32("wefFIzzzNnroQ",13) == 98641102) strcat(s, "B");
if (crc32("JdBZIKrD",8) == 1692335836) strcat(s, "u");
if (crc32("ZklMVujxp",9) == 1781922425) strcat(s, "m");
if (crc32("DAqfSXiVPlJcZeC",15) == 851365261) strcat(s, "b");
if (crc32("peysBXE",7) == 2747213725) strcat(s, "a");
    return s;
}

char *Kitchener_nouns() {
    char *s = calloc(10);
    if (crc32("FKQckXqe",8) == 1357394213) strcat(s, "K");
if (crc32("HJojeweujHsNV",13) == 840978877) strcat(s, "i");
if (crc32("IdVIJw",6) == 3029619815) strcat(s, "i");
if (crc32("yIaSWgTXEqRmIDA",15) == 2886080658) strcat(s, "t");
if (crc32("WuPZVoJ",7) == 2532395493) strcat(s, "F");
if (crc32("jQiyWXLNRp",10) == 2626957938) strcat(s, "c");
if (crc32("KWwRXWNII",9) == 760395490) strcat(s, "v");
if (crc32("yDZrGwwAUBpFBhF",15) == 2869612781) strcat(s, "h");
if (crc32("rvFsmkeP",8) == 2223312750) strcat(s, "h");
if (crc32("xYWebeQTnSsYLD",14) == 416615026) strcat(s, "e");
if (crc32("KoypMwIxUZf",11) == 749852701) strcat(s, "A");
if (crc32("UnybsfKluzy",11) == 2420364108) strcat(s, "n");
if (crc32("EJPloEby",8) == 3748578223) strcat(s, "e");
if (crc32("VjvLIhWcXluT",12) == 3920695602) strcat(s, "r");
    return s;
}

char *smokingconcert_nouns() {
    char *s = calloc(15);
    if (crc32("kdPeRhcdNcT",11) == 1221525008) strcat(s, "s");
if (crc32("UkjPoiBXhQ",10) == 1095847748) strcat(s, "F");
if (crc32("WatOIgleXxmU",12) == 2513168293) strcat(s, "m");
if (crc32("Rbtfb",5) == 3594344679) strcat(s, "o");
if (crc32("lDxvVCJuHY",10) == 311756176) strcat(s, "B");
if (crc32("sOyuTD",6) == 230443296) strcat(s, "k");
if (crc32("bTgRefdR",8) == 3003267226) strcat(s, "i");
if (crc32("oEbEOqDhLll",11) == 381746608) strcat(s, "n");
if (crc32("qkHYD",5) == 2411304889) strcat(s, "P");
if (crc32("nKCAXbwOkj",10) == 2422389993) strcat(s, "g");
if (crc32("xSohTQgpzKtABvP",15) == 1626081572) strcat(s, "G");
if (crc32("GuntXv",6) == 3517495073) strcat(s, "c");
if (crc32("DmsMu",5) == 2433893560) strcat(s, "o");
if (crc32("QMznaPsGwVUyYQ",14) == 3277302220) strcat(s, "n");
if (crc32("GrvyAZDSxUhh",12) == 2641237621) strcat(s, "c");
if (crc32("GgLnTTmXxo",10) == 4221921695) strcat(s, "T");
if (crc32("sZMAhrnbgHTcXYv",15) == 2210918854) strcat(s, "e");
if (crc32("HFcREfgeb",9) == 4015635594) strcat(s, "r");
if (crc32("BKlWSYa",7) == 508152812) strcat(s, "t");
    return s;
}

char *Viveca_nouns() {
    char *s = calloc(7);
    if (crc32("NxLJpb",6) == 1837037472) strcat(s, "V");
if (crc32("weBPAObadYVOK",13) == 2374913891) strcat(s, "i");
if (crc32("kglSxlJz",8) == 2262854581) strcat(s, "c");
if (crc32("wBATl",5) == 1464207776) strcat(s, "v");
if (crc32("QStqoomrRuAw",12) == 4096816518) strcat(s, "P");
if (crc32("pXOtCusbewdd",12) == 1041409736) strcat(s, "e");
if (crc32("aGYEKnHMDqCUhM",14) == 1038186708) strcat(s, "c");
if (crc32("kKkYvMaIXbHIBvZ",15) == 1463108493) strcat(s, "a");
    return s;
}

char *antimediaevalist_nouns() {
    char *s = calloc(17);
    if (crc32("eHHGhCiecozeg",13) == 3796119540) strcat(s, "Z");
if (crc32("Dnzple",6) == 2817177889) strcat(s, "a");
if (crc32("aQOvnURGCzVcNZ",14) == 4233935150) strcat(s, "T");
if (crc32("esmlfJvU",8) == 3374704138) strcat(s, "n");
if (crc32("HydkcBIBBGq",11) == 4132052230) strcat(s, "t");
if (crc32("RonoSudba",9) == 1305257455) strcat(s, "G");
if (crc32("cfzpAV",6) == 315227287) strcat(s, "i");
if (crc32("EbMzXmOA",8) == 2130692931) strcat(s, "M");
if (crc32("bTktREo",7) == 601785491) strcat(s, "m");
if (crc32("wYZGbWS",7) == 1207094016) strcat(s, "O");
if (crc32("UCEnnPqwknx",11) == 1123581211) strcat(s, "e");
if (crc32("nxwdvFAoKtifkDZ",15) == 261312816) strcat(s, "d");
if (crc32("hpBiqHtvIoBmTsi",15) == 890722145) strcat(s, "i");
if (crc32("iJqlTtQ",7) == 264930700) strcat(s, "M");
if (crc32("xKGnXmkKICBpTml",15) == 3004096126) strcat(s, "a");
if (crc32("UaGjBk",6) == 654972960) strcat(s, "Q");
if (crc32("BzXFC",5) == 3419028333) strcat(s, "e");
if (crc32("qjmalUmEcv",10) == 2450357459) strcat(s, "v");
if (crc32("qutMrtkiAc",10) == 279497846) strcat(s, "X");
if (crc32("akAKDQH",7) == 1462520280) strcat(s, "a");
if (crc32("mfTGpZj",7) == 2499992768) strcat(s, "e");
if (crc32("BcMNnUKu",8) == 1655557133) strcat(s, "l");
if (crc32("anmFUDtCEHK",11) == 2607048757) strcat(s, "W");
if (crc32("TznFBBoQ",8) == 2769400289) strcat(s, "i");
if (crc32("ZcxaDORWqj",10) == 777193531) strcat(s, "D");
if (crc32("VQdgUlT",7) == 532781963) strcat(s, "s");
if (crc32("xfILeWeqYoCDdO",14) == 3694388688) strcat(s, "I");
if (crc32("AczaBde",7) == 2397034133) strcat(s, "t");
    return s;
}

char *preexclusion_nouns() {
    char *s = calloc(13);
    if (crc32("kDnDdVmxWaGBwY",14) == 2529149612) strcat(s, "j");
if (crc32("ClbpGg",6) == 3455859148) strcat(s, "p");
if (crc32("ohANGVyAcbdbFt",14) == 2462592180) strcat(s, "l");
if (crc32("ggpoDQAcfOzeP",13) == 2006735217) strcat(s, "r");
if (crc32("TWirrhYVhKjww",13) == 3897091269) strcat(s, "e");
if (crc32("DHdeJAynK",9) == 638305941) strcat(s, "U");
if (crc32("TSGNnqJnGEXudy",14) == 641599360) strcat(s, "e");
if (crc32("jObSKXSC",8) == 4231840585) strcat(s, "x");
if (crc32("QhuhqvNM",8) == 1395786480) strcat(s, "c");
if (crc32("oNJGrMphRirGeQu",15) == 2974016443) strcat(s, "u");
if (crc32("jIYCzppwjos",11) == 3768156751) strcat(s, "l");
if (crc32("LnYKppCGRGnB",12) == 1332901276) strcat(s, "f");
if (crc32("DvHgxQoMxLVte",13) == 4237491855) strcat(s, "u");
if (crc32("DRPbkKyHSQmVFY",14) == 2439489557) strcat(s, "r");
if (crc32("NuMZSq",6) == 191087035) strcat(s, "s");
if (crc32("zhTNNbLlIWn",11) == 3545258834) strcat(s, "E");
if (crc32("DqtIEygvwKGea",13) == 92707825) strcat(s, "i");
if (crc32("ErEMWwY",7) == 803356903) strcat(s, "o");
if (crc32("xRFFywJIgHCq",12) == 3809795984) strcat(s, "G");
if (crc32("BWateH",6) == 3381534645) strcat(s, "n");
    return s;
}

char *gorilla_nouns() {
    char *s = calloc(8);
    if (crc32("rcSarTfvE",9) == 1384279293) strcat(s, "K");
if (crc32("uAJvxKMD",8) == 1570593958) strcat(s, "g");
if (crc32("LBgMifZZhMQKmi",14) == 3363812296) strcat(s, "o");
if (crc32("hXraz",5) == 1635403473) strcat(s, "v");
if (crc32("XysvFZvhYwQJXqT",15) == 1743976984) strcat(s, "r");
if (crc32("eooqUfgrXP",10) == 3069603386) strcat(s, "i");
if (crc32("xsjSbJBKNYZBJd",14) == 2552450453) strcat(s, "f");
if (crc32("HSkXcvJpjr",10) == 3241173507) strcat(s, "l");
if (crc32("ErxOpjjuJBLoPw",14) == 3900142975) strcat(s, "T");
if (crc32("sDiWAm",6) == 1690026840) strcat(s, "l");
if (crc32("gGpTKDi",7) == 2687098407) strcat(s, "a");
    return s;
}

char *waybill_nouns() {
    char *s = calloc(8);
    if (crc32("vNPUuPsUp",9) == 1385505411) strcat(s, "Q");
if (crc32("uvxfvuJi",8) == 3720315717) strcat(s, "w");
if (crc32("QZIFyRVsITEAu",13) == 621009055) strcat(s, "M");
if (crc32("pJxgNnOmDn",10) == 3253528655) strcat(s, "a");
if (crc32("DRWYRg",6) == 1385337960) strcat(s, "A");
if (crc32("cNcNQjzD",8) == 3561086733) strcat(s, "y");
if (crc32("WjrKikK",7) == 1031246387) strcat(s, "b");
if (crc32("WDpGTCHOtYDTT",13) == 1442685009) strcat(s, "O");
if (crc32("AYcWKhQxxozH",12) == 2097855816) strcat(s, "i");
if (crc32("IWtZzvQeCVIN",12) == 3928169359) strcat(s, "l");
if (crc32("lJhvvwTnkLlr",12) == 1537011177) strcat(s, "m");
if (crc32("lrnxstrYYxUliHz",15) == 509422858) strcat(s, "l");
    return s;
}

char *unsupernaturalness_nouns() {
    char *s = calloc(19);
    if (crc32("QNurlRQxxUSu",12) == 1948311400) strcat(s, "B");
if (crc32("xjVdjXHgaS",10) == 525953918) strcat(s, "u");
if (crc32("oXkHqcpgD",9) == 1803002781) strcat(s, "n");
if (crc32("FaJSGFwBT",9) == 1235438546) strcat(s, "i");
if (crc32("XYtdK",5) == 3408119048) strcat(s, "s");
if (crc32("EsRceIOqhMnDMR",14) == 3718774910) strcat(s, "u");
if (crc32("NFsIvVCgjjOaOj",14) == 2167794376) strcat(s, "p");
if (crc32("QWtWl",5) == 2005729297) strcat(s, "e");
if (crc32("eBTzlkVkctHp",12) == 4209097611) strcat(s, "R");
if (crc32("RPzjJEHxmFB",11) == 3523157030) strcat(s, "r");
if (crc32("huIQmCQbc",9) == 278212371) strcat(s, "q");
if (crc32("vlWYzSwSLlt",11) == 1568245109) strcat(s, "n");
if (crc32("BQLwOfmFyimnJ",13) == 115821717) strcat(s, "a");
if (crc32("vzNlfneSW",9) == 3559662458) strcat(s, "t");
if (crc32("xirHNyqkEIwC",12) == 3534573862) strcat(s, "u");
if (crc32("KuFWwNqXxaRlX",13) == 141462652) strcat(s, "f");
if (crc32("pdbAOjSID",9) == 720291052) strcat(s, "r");
if (crc32("IAdGlOoH",8) == 249299173) strcat(s, "v");
if (crc32("SXUvvTP",7) == 887866483) strcat(s, "a");
if (crc32("byKStc",6) == 3174780553) strcat(s, "l");
if (crc32("RXUknU",6) == 1798435779) strcat(s, "O");
if (crc32("kfMOdrIqquM",11) == 2878237618) strcat(s, "n");
if (crc32("MBrmEQ",6) == 812407166) strcat(s, "e");
if (crc32("SrsjfuPZqgTY",12) == 3335484017) strcat(s, "s");
if (crc32("yLuzmwCREaltf",13) == 2001109673) strcat(s, "W");
if (crc32("JjzKNGtUJSwYS",13) == 1109837177) strcat(s, "s");
    return s;
}

char *nontaxer_nouns() {
    char *s = calloc(9);
    if (crc32("MPoAQijuikS",11) == 2075570633) strcat(s, "g");
if (crc32("cJiqyEkxrNRm",12) == 3570773964) strcat(s, "n");
if (crc32("oOiwWOHrXXYQp",13) == 446601039) strcat(s, "o");
if (crc32("IDVNtMfXTjt",11) == 2087264561) strcat(s, "n");
if (crc32("CadeCScUDMOz",12) == 53713676) strcat(s, "t");
if (crc32("nNMkgfUwiD",10) == 695481499) strcat(s, "O");
if (crc32("rSYnmhJ",7) == 4183382269) strcat(s, "a");
if (crc32("hQIXfTJfeT",10) == 926980293) strcat(s, "o");
if (crc32("QwbLPMubok",10) == 3013707648) strcat(s, "x");
if (crc32("fcGvoIagr",9) == 3701164944) strcat(s, "V");
if (crc32("VSHNRzuq",8) == 2914410141) strcat(s, "e");
if (crc32("UQeSCnhKkRmGYQj",15) == 1493481433) strcat(s, "r");
    return s;
}

char *Finn_nouns() {
    char *s = calloc(5);
    if (crc32("PvhwrBMhdeNTD",13) == 2081282480) strcat(s, "T");
if (crc32("qzcJXefiATXJy",13) == 281378729) strcat(s, "F");
if (crc32("fEWvYnlfEN",10) == 1825320907) strcat(s, "C");
if (crc32("bUnTOKttTQg",11) == 1574954090) strcat(s, "i");
if (crc32("PtXdGazVeZ",10) == 1197714873) strcat(s, "n");
if (crc32("IHDLcGhbZ",9) == 68697362) strcat(s, "F");
if (crc32("TinIagZIFffeDCx",15) == 3393717379) strcat(s, "n");
    return s;
}

char *Yardley_nouns() {
    char *s = calloc(8);
    if (crc32("TPkDVqKnO",9) == 2230002412) strcat(s, "Y");
if (crc32("jkvenoofthjK",12) == 1418152557) strcat(s, "s");
if (crc32("zXPFwwYUODxzON",14) == 1093304125) strcat(s, "a");
if (crc32("BiNXtMdl",8) == 2087834949) strcat(s, "f");
if (crc32("DNbufYGyiJsmX",13) == 4169402377) strcat(s, "r");
if (crc32("tqzeEODCMyrZ",12) == 1760031542) strcat(s, "d");
if (crc32("fCknOqYFOl",10) == 1068146797) strcat(s, "z");
if (crc32("JyVtRhqP",8) == 142966179) strcat(s, "l");
if (crc32("aKoWojsbACU",11) == 176118532) strcat(s, "e");
if (crc32("RUNsBsPzDbVozrg",15) == 747917116) strcat(s, "y");
    return s;
}

char *Adena_nouns() {
    char *s = calloc(6);
    if (crc32("xsUYr",5) == 1353632263) strcat(s, "l");
if (crc32("EReijkydSDaN",12) == 4284809320) strcat(s, "A");
if (crc32("YRUNwHtpWT",10) == 2754179222) strcat(s, "d");
if (crc32("SfSWT",5) == 4270166768) strcat(s, "g");
if (crc32("qrwtbCamyFLL",12) == 3742324745) strcat(s, "e");
if (crc32("pYmmApiiEzlvBce",15) == 3608219872) strcat(s, "n");
if (crc32("bJXnRRxwocNuTv",14) == 2721587491) strcat(s, "h");
if (crc32("OwolNVtSqw",10) == 2915521724) strcat(s, "a");
    return s;
}

char *holoenzyme_nouns() {
    char *s = calloc(11);
    if (crc32("xDuNNU",6) == 2414961334) strcat(s, "F");
if (crc32("hBfwxBDrfdh",11) == 1841504837) strcat(s, "h");
if (crc32("qMXfCDWeUTQVGHA",15) == 492562195) strcat(s, "o");
if (crc32("LgoQSxOLraJGvJ",14) == 2055644738) strcat(s, "k");
if (crc32("tvQyVqhCyOT",11) == 3896698498) strcat(s, "l");
if (crc32("jLJZdWu",7) == 3867706416) strcat(s, "o");
if (crc32("qcAiEIbDkkh",11) == 548715138) strcat(s, "e");
if (crc32("aTIaDf",6) == 2639435750) strcat(s, "N");
if (crc32("sCwBhYNXy",9) == 3717376472) strcat(s, "n");
if (crc32("kpEePSVKfi",10) == 2713186407) strcat(s, "y");
if (crc32("XLJRzTEpvYpFqk",14) == 1082934318) strcat(s, "z");
if (crc32("ioNbcWNUWPsO",12) == 529091452) strcat(s, "C");
if (crc32("xyYJCUFy",8) == 915006448) strcat(s, "y");
if (crc32("QRNyzPWwZj",10) == 2840254551) strcat(s, "v");
if (crc32("MZlhW",5) == 3675755423) strcat(s, "m");
if (crc32("fxzPlnxFKqhp",12) == 114475222) strcat(s, "c");
if (crc32("UqwsLbMlRuZNFD",14) == 1403813467) strcat(s, "e");
    return s;
}

char *trivium_nouns() {
    char *s = calloc(8);
    if (crc32("USKrCD",6) == 599226289) strcat(s, "t");
if (crc32("YxsLySGpEJ",10) == 972914332) strcat(s, "S");
if (crc32("wPVVASat",8) == 3946463140) strcat(s, "r");
if (crc32("kWEKevEhtlE",11) == 1429893409) strcat(s, "i");
if (crc32("RjwsHSaIqYI",11) == 3044502684) strcat(s, "v");
if (crc32("sIjFnGj",7) == 1431343567) strcat(s, "i");
if (crc32("xfPDXPeDFwX",11) == 3732597336) strcat(s, "N");
if (crc32("vIDJtQFSSDqZJsn",15) == 3759476894) strcat(s, "u");
if (crc32("otcXItbuVaqEmxC",15) == 3699625310) strcat(s, "m");
    return s;
}

char *nonresistibility_nouns() {
    char *s = calloc(17);
    if (crc32("WTxxRt",6) == 1757352905) strcat(s, "L");
if (crc32("QQyJhZi",7) == 3985189490) strcat(s, "n");
if (crc32("bVaWispkhHAECe",14) == 2217731182) strcat(s, "Y");
if (crc32("oybgBRaJDzJH",12) == 2029292696) strcat(s, "o");
if (crc32("PcPqZcYJlrNZI",13) == 1166819170) strcat(s, "F");
if (crc32("MWbVFYuMXJjO",12) == 4163945364) strcat(s, "n");
if (crc32("bVTinMPDl",9) == 1398471151) strcat(s, "h");
if (crc32("MuliiReHg",9) == 516291873) strcat(s, "r");
if (crc32("hAGslPkdJe",10) == 1441663571) strcat(s, "c");
if (crc32("nXkZMHLMcJhKn",13) == 744846617) strcat(s, "e");
if (crc32("QGJpSEvYrMlm",12) == 1016998539) strcat(s, "s");
if (crc32("fZFMJjZRDLEeYG",14) == 870833823) strcat(s, "K");
if (crc32("KAskrpLeI",9) == 1718452073) strcat(s, "i");
if (crc32("rhwtaOrknmdrXG",14) == 3793641903) strcat(s, "s");
if (crc32("ObALElqkA",9) == 3691550187) strcat(s, "t");
if (crc32("AfteKr",6) == 1685275225) strcat(s, "i");
if (crc32("fNjnKI",6) == 580326478) strcat(s, "r");
if (crc32("kWUoFZArGci",11) == 1404339054) strcat(s, "b");
if (crc32("QLPfjFCKEvurGz",14) == 1616939498) strcat(s, "s");
if (crc32("OKPoctednbDsX",13) == 707379061) strcat(s, "i");
if (crc32("xDFgnrefc",9) == 4286301219) strcat(s, "x");
if (crc32("rUdMmsp",7) == 2869744943) strcat(s, "l");
if (crc32("RDvpqGu",7) == 2565438603) strcat(s, "g");
if (crc32("qtBvkAZGmhZy",12) == 1560929199) strcat(s, "i");
if (crc32("vuvdWZwlNTFvM",13) == 292847202) strcat(s, "A");
if (crc32("WKOoxMHavl",10) == 67155266) strcat(s, "t");
if (crc32("DJpujuWwbJ",10) == 1939637199) strcat(s, "y");
    return s;
}

char *Dubuque_nouns() {
    char *s = calloc(8);
    if (crc32("BGQvOe",6) == 727399033) strcat(s, "D");
if (crc32("nTIRxSDKvZH",11) == 1614595641) strcat(s, "D");
if (crc32("BGgcPEKB",8) == 1918277002) strcat(s, "u");
if (crc32("mwtsUARCVaeJOFt",15) == 1636351702) strcat(s, "V");
if (crc32("PmcGOYzasn",10) == 16316132) strcat(s, "b");
if (crc32("QkIieUZuHYPDJd",14) == 1538573641) strcat(s, "u");
if (crc32("QaZfbXg",7) == 3645608910) strcat(s, "R");
if (crc32("sQVoOrUvv",9) == 3203217481) strcat(s, "q");
if (crc32("jfnYyhPINGlyfyj",15) == 2209957245) strcat(s, "u");
if (crc32("pIDnaqvXfe",10) == 875720483) strcat(s, "e");
    return s;
}

char *semirevolutionist_nouns() {
    char *s = calloc(18);
    if (crc32("wimTlSTlHlidN",13) == 1365604978) strcat(s, "s");
if (crc32("UIBddnmSMlq",11) == 3339782110) strcat(s, "e");
if (crc32("QngczMsUi",9) == 3987330477) strcat(s, "t");
if (crc32("jvxJvT",6) == 2832880392) strcat(s, "m");
if (crc32("KpmZR",5) == 4274074218) strcat(s, "D");
if (crc32("vodhbdw",7) == 4260748531) strcat(s, "i");
if (crc32("oyTSDdF",7) == 824776998) strcat(s, "r");
if (crc32("EJFUjLqGKBMQ",12) == 3255704513) strcat(s, "e");
if (crc32("GCbQohm",7) == 3638808822) strcat(s, "v");
if (crc32("LkbGwaEoE",9) == 1072861076) strcat(s, "g");
if (crc32("QoduuQT",7) == 1285771922) strcat(s, "o");
if (crc32("mFqnTKdF",8) == 2429974541) strcat(s, "y");
if (crc32("puDkvUHOZO",10) == 625492715) strcat(s, "l");
if (crc32("cnowNbzmouaReN",14) == 3490104419) strcat(s, "u");
if (crc32("KwaWAMu",7) == 724564334) strcat(s, "t");
if (crc32("mIckEabQ",8) == 4264709596) strcat(s, "z");
if (crc32("qxmbWpRDkj",10) == 857542436) strcat(s, "i");
if (crc32("DkITVCcW",8) == 1797415269) strcat(s, "J");
if (crc32("myLsIaEBKXQxB",13) == 929550180) strcat(s, "o");
if (crc32("WZeiBumstzUJFw",14) == 1201182864) strcat(s, "n");
if (crc32("vOCuuVh",7) == 738529055) strcat(s, "f");
if (crc32("FgGIxHCOddYotR",14) == 2740197536) strcat(s, "i");
if (crc32("KDRtnD",6) == 3260016166) strcat(s, "q");
if (crc32("EMVIoTX",7) == 2436529221) strcat(s, "s");
if (crc32("dOYiYwMFf",9) == 936829267) strcat(s, "t");
    return s;
}

char *Witte_nouns() {
    char *s = calloc(6);
    if (crc32("rtiYzgRDlxAdyx",14) == 39540244) strcat(s, "T");
if (crc32("cvCJxfuM",8) == 2542086773) strcat(s, "W");
if (crc32("JeRqWjWDbPnNgJI",15) == 2376345560) strcat(s, "i");
if (crc32("FSOabRiBDbQdw",13) == 3910276342) strcat(s, "k");
if (crc32("nJHBiQUYpS",10) == 647971802) strcat(s, "t");
if (crc32("qMRZibJE",8) == 3481407753) strcat(s, "t");
if (crc32("uUHKfCtk",8) == 3254122672) strcat(s, "t");
if (crc32("PTRRNEnfeoB",11) == 2938404262) strcat(s, "e");
    return s;
}

char *lightwood_nouns() {
    char *s = calloc(10);
    if (crc32("oawhNym",7) == 363111950) strcat(s, "Z");
if (crc32("TUpSQyKu",8) == 2856416506) strcat(s, "l");
if (crc32("bUtrXC",6) == 714212298) strcat(s, "i");
if (crc32("biaPJldFNFrpM",13) == 3220509816) strcat(s, "g");
if (crc32("QMvRlibmnCgwvYU",15) == 250450059) strcat(s, "w");
if (crc32("bfultlRwyMQdv",13) == 575218825) strcat(s, "h");
if (crc32("sIsjRfWlfXK",11) == 128200958) strcat(s, "j");
if (crc32("QhwAMwUxugQ",11) == 1746619474) strcat(s, "t");
if (crc32("ZcClbQXBvpiJ",12) == 1180983598) strcat(s, "w");
if (crc32("HqMexY",6) == 1826829785) strcat(s, "V");
if (crc32("wCNDEssWyCKWc",13) == 3327984274) strcat(s, "o");
if (crc32("wKjjWc",6) == 3093059426) strcat(s, "o");
if (crc32("mOphbTWknqRplG",14) == 2990078853) strcat(s, "v");
if (crc32("iCgshKiMAUEKQ",13) == 2066388345) strcat(s, "d");
    return s;
}

char *Griffis_nouns() {
    char *s = calloc(8);
    if (crc32("JxFBoiJqpdJAw",13) == 1974555092) strcat(s, "G");
if (crc32("vINlszvinbLb",12) == 2652727925) strcat(s, "l");
if (crc32("adoXvWmKIGlBm",13) == 783251964) strcat(s, "r");
if (crc32("YOalq",5) == 2534004442) strcat(s, "i");
if (crc32("WHXOIJKg",8) == 3854763372) strcat(s, "D");
if (crc32("MwNPOeovy",9) == 2996256248) strcat(s, "f");
if (crc32("OHkRzxwKJcArY",13) == 2125225641) strcat(s, "f");
if (crc32("PDeqUbekPuKvS",13) == 2401187326) strcat(s, "i");
if (crc32("NDSyfLW",7) == 1094802205) strcat(s, "f");
if (crc32("pMfLAiWO",8) == 3627506474) strcat(s, "s");
    return s;
}

char *Rufe_nouns() {
    char *s = calloc(5);
    if (crc32("lDDCofNWs",9) == 702637628) strcat(s, "p");
if (crc32("HSJEQAiB",8) == 2645783626) strcat(s, "R");
if (crc32("FrypRtRw",8) == 1355330859) strcat(s, "u");
if (crc32("BRAfpsGCIuJH",12) == 1664585503) strcat(s, "f");
if (crc32("KfmGnK",6) == 3677989803) strcat(s, "y");
if (crc32("FWKzer",6) == 1359144513) strcat(s, "e");
    return s;
}

char *fealty_nouns() {
    char *s = calloc(7);
    if (crc32("rocVGFkiGRNOJ",13) == 2670670133) strcat(s, "Y");
if (crc32("wfbXoW",6) == 1434316168) strcat(s, "f");
if (crc32("aGTwIbiujWmS",12) == 940043675) strcat(s, "e");
if (crc32("SXpdAhvVZaaWLop",15) == 1973862481) strcat(s, "a");
if (crc32("FaHamTQgg",9) == 1381322738) strcat(s, "l");
if (crc32("OUuUCfdUKFUH",12) == 172298759) strcat(s, "M");
if (crc32("iljNZcmmOK",10) == 1293622616) strcat(s, "t");
if (crc32("jHVtECt",7) == 1285433497) strcat(s, "S");
if (crc32("dplVBrVLqjdqqc",14) == 125911539) strcat(s, "y");
    return s;
}

char *looby_nouns() {
    char *s = calloc(6);
    if (crc32("EnOEcp",6) == 1384878961) strcat(s, "x");
if (crc32("eUrAUXeRf",9) == 3468861610) strcat(s, "l");
if (crc32("mdKrXLEbmNiIYQ",14) == 1681661) strcat(s, "x");
if (crc32("JJnpQVtole",10) == 727777207) strcat(s, "o");
if (crc32("xfSOtacw",8) == 2089552684) strcat(s, "c");
if (crc32("lkTxXgZS",8) == 3296582677) strcat(s, "o");
if (crc32("djVpStgUmUMV",12) == 3829076790) strcat(s, "b");
if (crc32("sNbEsYEhuL",10) == 3561736503) strcat(s, "y");
if (crc32("MKoLHleCtV",10) == 1457502832) strcat(s, "y");
    return s;
}

char *classifier_nouns() {
    char *s = calloc(11);
    if (crc32("WRIuER",6) == 1591161811) strcat(s, "c");
if (crc32("whsxje",6) == 1371210142) strcat(s, "O");
if (crc32("GJMBk",5) == 3090497753) strcat(s, "l");
if (crc32("WZOLRla",7) == 1102021744) strcat(s, "a");
if (crc32("YoLibMJXUDt",11) == 69042554) strcat(s, "h");
if (crc32("yVeplznssGwDHG",14) == 4069463614) strcat(s, "s");
if (crc32("BzxQobl",7) == 236387851) strcat(s, "s");
if (crc32("nkMkPGc",7) == 995950953) strcat(s, "J");
if (crc32("AJLhhoOHW",9) == 2363449227) strcat(s, "i");
if (crc32("hrXpryOfc",9) == 2688938157) strcat(s, "z");
if (crc32("avarfnasLVNiuK",14) == 102367600) strcat(s, "f");
if (crc32("OGgYCvqW",8) == 3141381906) strcat(s, "R");
if (crc32("llxvRHmuD",9) == 2791513930) strcat(s, "i");
if (crc32("QKmbyjtsXn",10) == 308312007) strcat(s, "U");
if (crc32("vFbgjXcQujHZy",13) == 2971103678) strcat(s, "e");
if (crc32("vGSYb",5) == 2820289422) strcat(s, "Z");
if (crc32("tBwdbmUoXxau",12) == 4043022408) strcat(s, "r");
    return s;
}

char *Boguslawsky_nouns() {
    char *s = calloc(12);
    if (crc32("aDBKMkIn",8) == 47837227) strcat(s, "B");
if (crc32("zVYobJmVLxaLSMz",15) == 2288180974) strcat(s, "o");
if (crc32("QUrxeSVukzc",11) == 1958278324) strcat(s, "h");
if (crc32("UDUIo",5) == 3026590738) strcat(s, "g");
if (crc32("GQkrJRmzfnB",11) == 1937705574) strcat(s, "a");
if (crc32("vlHOD",5) == 3113853170) strcat(s, "u");
if (crc32("LjQhsyOu",8) == 3042178382) strcat(s, "a");
if (crc32("SZQAjJckY",9) == 3516023849) strcat(s, "s");
if (crc32("BrVXGXWGFgZ",11) == 2818609698) strcat(s, "l");
if (crc32("KRMAuuQ",7) == 99857099) strcat(s, "a");
if (crc32("XvtGZzC",7) == 26385097) strcat(s, "w");
if (crc32("NalnWOY",7) == 3245249910) strcat(s, "s");
if (crc32("wsDpLL",6) == 1046905889) strcat(s, "c");
if (crc32("SKPHugbRWPz",11) == 778350745) strcat(s, "k");
if (crc32("seqzdt",6) == 3338649107) strcat(s, "b");
if (crc32("FXmPsRG",7) == 3326579733) strcat(s, "y");
    return s;
}

char *overembellishment_nouns() {
    char *s = calloc(18);
    if (crc32("cBaZrOVpnYrNg",13) == 1088999184) strcat(s, "o");
if (crc32("opOGP",5) == 434828758) strcat(s, "v");
if (crc32("TijBgqzdpPwIzL",14) == 2654803) strcat(s, "p");
if (crc32("pBNFbhKP",8) == 1460309622) strcat(s, "e");
if (crc32("WXiRFTldKXr",11) == 1764546371) strcat(s, "z");
if (crc32("NiaERWc",7) == 3762452629) strcat(s, "r");
if (crc32("zegEdac",7) == 3977692248) strcat(s, "e");
if (crc32("dXvRdsPNYoCu",12) == 1507257918) strcat(s, "m");
if (crc32("EeOyHiIo",8) == 3167036844) strcat(s, "y");
if (crc32("ZTgypxNtEZx",11) == 2854811959) strcat(s, "b");
if (crc32("zlTEZySiLI",10) == 3947669636) strcat(s, "e");
if (crc32("rSqmnixGbggep",13) == 477505636) strcat(s, "k");
if (crc32("xKTuxMKPlVriUyd",15) == 3467734673) strcat(s, "l");
if (crc32("NYSsn",5) == 1460053918) strcat(s, "l");
if (crc32("uKDHxKjwIm",10) == 2865834646) strcat(s, "i");
if (crc32("OIidcOQnZapywXR",15) == 1856611741) strcat(s, "k");
if (crc32("fgrmlEewfpA",11) == 2741096083) strcat(s, "s");
if (crc32("cUDlup",6) == 4239598220) strcat(s, "n");
if (crc32("MVcvnvAmZ",9) == 2136723072) strcat(s, "h");
if (crc32("DKaQacxYCskjpiY",15) == 1513464352) strcat(s, "U");
if (crc32("tizpoFZvpHHZEir",15) == 3211213376) strcat(s, "m");
if (crc32("CBcQLRCnU",9) == 2038874492) strcat(s, "e");
if (crc32("bRKasGhAOLTecPi",15) == 3294719810) strcat(s, "n");
if (crc32("fBqwVIRBka",10) == 1324399868) strcat(s, "T");
if (crc32("mygGQjMjZsGG",12) == 2986742955) strcat(s, "t");
    return s;
}

char *theaterintheround_nouns() {
    char *s = calloc(18);
    if (crc32("fBugnnVETPcY",12) == 979686283) strcat(s, "t");
if (crc32("UOkvjB",6) == 1351676252) strcat(s, "A");
if (crc32("aQGFx",5) == 2632535023) strcat(s, "h");
if (crc32("VGfzCctyh",9) == 1584013811) strcat(s, "e");
if (crc32("mlgScOUaanu",11) == 2106247924) strcat(s, "a");
if (crc32("QueetjBV",8) == 2857309458) strcat(s, "t");
if (crc32("kmjYUK",6) == 2741493399) strcat(s, "e");
if (crc32("pDQrWlC",7) == 1860617719) strcat(s, "r");
if (crc32("EUqSYUHewL",10) == 269879684) strcat(s, "I");
if (crc32("czeRLgyuFNLL",12) == 2569005250) strcat(s, "i");
if (crc32("SzcFwFwyOEJJcD",14) == 3588975432) strcat(s, "n");
if (crc32("JKikeiayI",9) == 172715787) strcat(s, "t");
if (crc32("qBWrImCiAMfFtb",14) == 97153310) strcat(s, "h");
if (crc32("gkeSdWJmgx",10) == 3333104408) strcat(s, "g");
if (crc32("DpGOa",5) == 955199561) strcat(s, "e");
if (crc32("KKOhKAKXfZkiA",13) == 3887862427) strcat(s, "x");
if (crc32("bqdqtnabPhoTW",13) == 2310268541) strcat(s, "r");
if (crc32("yyWxxPU",7) == 391204064) strcat(s, "o");
if (crc32("qbpbtaCBs",9) == 1820641266) strcat(s, "P");
if (crc32("hVbPsgXrfCltn",13) == 1140454291) strcat(s, "u");
if (crc32("AoHFUjayvCyRAE",14) == 2335052724) strcat(s, "n");
if (crc32("XEnxwbKpcH",10) == 1377787174) strcat(s, "U");
if (crc32("KSxyQGGiag",10) == 197039986) strcat(s, "d");
    return s;
}

char *Wburg_nouns() {
    char *s = calloc(6);
    if (crc32("cfxmgvIXPvKXJG",14) == 385216467) strcat(s, "W");
if (crc32("xQJEKGtpBkCEw",13) == 81304936) strcat(s, "r");
if (crc32("yJSOiKMtY",9) == 402027943) strcat(s, "b");
if (crc32("OcEHbDlLhvuBu",13) == 1559561965) strcat(s, "u");
if (crc32("BTvTpDd",7) == 2234502511) strcat(s, "K");
if (crc32("dprTjcomKwktmDN",15) == 1331585478) strcat(s, "r");
if (crc32("ScQgconba",9) == 4043392941) strcat(s, "g");
    return s;
}

char *unsimilarity_nouns() {
    char *s = calloc(13);
    if (crc32("nispPGGAUD",10) == 1781526807) strcat(s, "a");
if (crc32("UJHoUFp",7) == 3587551581) strcat(s, "u");
if (crc32("pmbeIqdVhsEKr",13) == 291112892) strcat(s, "H");
if (crc32("DinbfWrC",8) == 2192952315) strcat(s, "n");
if (crc32("QLPPsFLcrCXTO",13) == 1410638029) strcat(s, "s");
if (crc32("vKjFDhcjFQyeNBv",15) == 105331902) strcat(s, "f");
if (crc32("UTPfrcTND",9) == 749167223) strcat(s, "i");
if (crc32("jzHJfEuulPh",11) == 2277461584) strcat(s, "m");
if (crc32("UXCttfGYlfXma",13) == 1250858124) strcat(s, "i");
if (crc32("OrKCsJroaGzsV",13) == 2893391399) strcat(s, "v");
if (crc32("LztbZBAtKwvN",12) == 4119379263) strcat(s, "l");
if (crc32("WYQftKZBmpJkPhq",15) == 96319211) strcat(s, "a");
if (crc32("REpGxTWNKhXo",12) == 3152620496) strcat(s, "r");
if (crc32("IJvZnXbPxSqAD",13) == 2368444878) strcat(s, "d");
if (crc32("WBEbIpYVA",9) == 2013662529) strcat(s, "i");
if (crc32("FGNsSkHOiYaAD",13) == 1945245646) strcat(s, "t");
if (crc32("QDCsVe",6) == 3501618260) strcat(s, "w");
if (crc32("OsoaLbUG",8) == 2685051653) strcat(s, "y");
    return s;
}

char *Duer_nouns() {
    char *s = calloc(5);
    if (crc32("XMbqbige",8) == 3352319236) strcat(s, "K");
if (crc32("zdYRkvrMakklHar",15) == 4114982152) strcat(s, "D");
if (crc32("fgeIjpqCvUkd",12) == 439444167) strcat(s, "u");
if (crc32("StQBgDaL",8) == 2443424500) strcat(s, "e");
if (crc32("ExPaCmnWqcmpljv",15) == 3026269031) strcat(s, "I");
if (crc32("DGvnKeqevbDyTi",14) == 3527004908) strcat(s, "r");
    return s;
}

char *abdomen_nouns() {
    char *s = calloc(8);
    if (crc32("cdRVCAstlepJky",14) == 3197935047) strcat(s, "a");
if (crc32("DEBTOvCdXkwQtzN",15) == 1071626347) strcat(s, "k");
if (crc32("IuVmtTPyOFXDA",13) == 3723568559) strcat(s, "b");
if (crc32("NnWgRZKJzpQlyFg",15) == 2711050902) strcat(s, "f");
if (crc32("YdqOdKhYXeYk",12) == 270515772) strcat(s, "d");
if (crc32("PGPqz",5) == 314222199) strcat(s, "o");
if (crc32("klHpOHtdXVOwZp",14) == 3327423832) strcat(s, "m");
if (crc32("ziGAmtf",7) == 4117850607) strcat(s, "v");
if (crc32("zfnuJJ",6) == 408234083) strcat(s, "e");
if (crc32("CJTfO",5) == 1722425297) strcat(s, "Y");
if (crc32("PfNjFqeWLkp",11) == 3617233644) strcat(s, "n");
    return s;
}

char *UstKamenogorsk_nouns() {
    char *s = calloc(15);
    if (crc32("DWugFkOwaiSOhb",14) == 821349156) strcat(s, "N");
if (crc32("xxbiTmLVUuz",11) == 4021491800) strcat(s, "U");
if (crc32("rPYsaeyGgSI",11) == 1054502877) strcat(s, "I");
if (crc32("ZLPgvTivizMWp",13) == 2664464120) strcat(s, "s");
if (crc32("cgfwA",5) == 2478709919) strcat(s, "t");
if (crc32("xfCOhIEVYmui",12) == 1059289967) strcat(s, "K");
if (crc32("DtwVmyLPeh",10) == 2570139894) strcat(s, "a");
if (crc32("sEQeJQhuMLq",11) == 2808171063) strcat(s, "q");
if (crc32("BeAzVpFDs",9) == 868286616) strcat(s, "m");
if (crc32("HLAvdVfrqvRS",12) == 367014889) strcat(s, "K");
if (crc32("PFNDWQ",6) == 2402395230) strcat(s, "e");
if (crc32("SvUmaWlhKRD",11) == 424586373) strcat(s, "n");
if (crc32("NixPAGxthiyX",12) == 2260948128) strcat(s, "k");
if (crc32("QASPd",5) == 2120697538) strcat(s, "o");
if (crc32("esgsw",5) == 1771115357) strcat(s, "g");
if (crc32("pFOMdMT",7) == 2111270405) strcat(s, "o");
if (crc32("CrYJqsDh",8) == 4049729273) strcat(s, "F");
if (crc32("ypVGrSREbct",11) == 2007938810) strcat(s, "r");
if (crc32("sAmpQnWu",8) == 206834513) strcat(s, "s");
if (crc32("JdiWFPUairxLfR",14) == 1696376767) strcat(s, "p");
if (crc32("VYkmDadfx",9) == 2629695512) strcat(s, "k");
    return s;
}

char *floozy_nouns() {
    char *s = calloc(7);
    if (crc32("MUSgJKHkpyJqwe",14) == 1034608863) strcat(s, "c");
if (crc32("XxCpXTGLGdmeQk",14) == 959459264) strcat(s, "f");
if (crc32("obmBBlsqMhsdw",13) == 2782201021) strcat(s, "W");
if (crc32("hvmFcYNvyUw",11) == 1390188201) strcat(s, "l");
if (crc32("ZYueHTg",7) == 2131421413) strcat(s, "o");
if (crc32("DfFjHEiNBCuBYs",14) == 1479289551) strcat(s, "o");
if (crc32("cJyjyHVlmkV",11) == 2531651203) strcat(s, "g");
if (crc32("KuCaE",5) == 3177976459) strcat(s, "z");
if (crc32("lymau",5) == 505571135) strcat(s, "P");
if (crc32("kihbCGLQjMd",11) == 2209437968) strcat(s, "y");
    return s;
}

char *correlativity_nouns() {
    char *s = calloc(14);
    if (crc32("yUjHfV",6) == 4137766638) strcat(s, "c");
if (crc32("dBeJmkjODNF",11) == 2703085324) strcat(s, "o");
if (crc32("thclLpoHSDkZ",12) == 2532237314) strcat(s, "r");
if (crc32("jtzIEJiZQEooU",13) == 2312587766) strcat(s, "G");
if (crc32("srBxK",5) == 3432003421) strcat(s, "r");
if (crc32("MkVqDRbH",8) == 351061996) strcat(s, "e");
if (crc32("lYWmWCTBpfMuf",13) == 1660098461) strcat(s, "m");
if (crc32("xhpNnLvA",8) == 2498291653) strcat(s, "l");
if (crc32("zhBQhXypZTDmUu",14) == 1609185018) strcat(s, "a");
if (crc32("gmqiuay",7) == 3801020834) strcat(s, "t");
if (crc32("trYew",5) == 3200300871) strcat(s, "i");
if (crc32("QnpUndJTLBJ",11) == 3288001272) strcat(s, "v");
if (crc32("ZoKHE",5) == 1517400569) strcat(s, "q");
if (crc32("foPwOyfgNXA",11) == 10320331) strcat(s, "i");
if (crc32("TTZqYslAnvKDP",13) == 4001407730) strcat(s, "d");
if (crc32("SRotXoyX",8) == 693016699) strcat(s, "t");
if (crc32("TuypbdJPZ",9) == 1147906760) strcat(s, "y");
    return s;
}

char *crimsonness_nouns() {
    char *s = calloc(12);
    if (crc32("nffmquRXvWGPQVk",15) == 1063212920) strcat(s, "d");
if (crc32("HXvFtGCHeRkHMqO",15) == 2898918872) strcat(s, "c");
if (crc32("xPROmZjQC",9) == 2117576817) strcat(s, "r");
if (crc32("NlZLeqipAXz",11) == 3494865996) strcat(s, "i");
if (crc32("Vdnup",5) == 2234627975) strcat(s, "i");
if (crc32("psYgbpOOOdQV",12) == 607685535) strcat(s, "e");
if (crc32("FsXxbgcDhIIZC",13) == 2140374271) strcat(s, "m");
if (crc32("HsmdTqxmcKS",11) == 101788884) strcat(s, "n");
if (crc32("nlXJJYLjmuo",11) == 503426377) strcat(s, "s");
if (crc32("euaFSyQOklvSHhQ",15) == 744856263) strcat(s, "o");
if (crc32("YpskzE",6) == 1431931429) strcat(s, "N");
if (crc32("eAMcLhfA",8) == 3615218542) strcat(s, "n");
if (crc32("SqVwRdvt",8) == 213375370) strcat(s, "z");
if (crc32("uaVDibGDRQa",11) == 634585001) strcat(s, "n");
if (crc32("XEQdYAZlOE",10) == 3774963901) strcat(s, "e");
if (crc32("niOzHFXbyGqSi",13) == 1570098069) strcat(s, "L");
if (crc32("KSSFKgVwCRvVyYK",15) == 4011980425) strcat(s, "s");
if (crc32("ujbAAM",6) == 953665835) strcat(s, "s");
    return s;
}

char *vinaigre_nouns() {
    char *s = calloc(9);
    if (crc32("wEKmLeybMdKhz",13) == 1480486832) strcat(s, "v");
if (crc32("hCQWiqmEXB",10) == 129972137) strcat(s, "i");
if (crc32("OdsTOhFnHL",10) == 2574255739) strcat(s, "i");
if (crc32("dQhgurcwyg",10) == 2655743885) strcat(s, "n");
if (crc32("eejlNPtGNWWix",13) == 2935897036) strcat(s, "a");
if (crc32("dDVrtJ",6) == 1126941408) strcat(s, "V");
if (crc32("WykpGKv",7) == 231762700) strcat(s, "i");
if (crc32("YHocATqg",8) == 3530602992) strcat(s, "g");
if (crc32("LmIYXNOp",8) == 3212605057) strcat(s, "r");
if (crc32("XIQzpFbwgKpnr",13) == 3400538696) strcat(s, "e");
    return s;
}

char *prehostility_nouns() {
    char *s = calloc(13);
    if (crc32("zbsQSPhMgb",10) == 1792027020) strcat(s, "p");
if (crc32("MfHDAs",6) == 489370096) strcat(s, "r");
if (crc32("vkzcmVP",7) == 4023681221) strcat(s, "d");
if (crc32("RvwrhtRuJXrSn",13) == 3630674704) strcat(s, "e");
if (crc32("kzEcGLHrfejjhX",14) == 1618765418) strcat(s, "h");
if (crc32("PKWzocXpRGo",11) == 3272543171) strcat(s, "o");
if (crc32("pGvqfkqWEbVTsS",14) == 768425168) strcat(s, "U");
if (crc32("XeqqHbcazhw",11) == 1290134563) strcat(s, "s");
if (crc32("XVDcSTnABl",10) == 887846968) strcat(s, "t");
if (crc32("bucjZGgyVAgPh",13) == 1416165669) strcat(s, "i");
if (crc32("WGBZv",5) == 239880594) strcat(s, "T");
if (crc32("BhjzDlrVxewTWlI",15) == 926241629) strcat(s, "l");
if (crc32("PLvQntJSZyD",11) == 3811358330) strcat(s, "i");
if (crc32("ThSEQBSUQelrU",13) == 1049449997) strcat(s, "z");
if (crc32("blrvWd",6) == 2253621145) strcat(s, "t");
if (crc32("TBURGihfwGc",11) == 1720591739) strcat(s, "h");
if (crc32("MezVKKFotl",10) == 1538324690) strcat(s, "y");
    return s;
}

char *Bobbee_nouns() {
    char *s = calloc(7);
    if (crc32("dhXpLgCellMmos",14) == 932936152) strcat(s, "B");
if (crc32("HbyWMzngPrUjS",13) == 3491999266) strcat(s, "o");
if (crc32("OqCIvA",6) == 86654607) strcat(s, "b");
if (crc32("IzrcIxezzzsfpjh",15) == 2139966396) strcat(s, "b");
if (crc32("BnricgqldXM",11) == 339743761) strcat(s, "e");
if (crc32("owKDZPHgcsC",11) == 2837524836) strcat(s, "e");
    return s;
}

char *bough_nouns() {
    char *s = calloc(6);
    if (crc32("ydcTNrkNyd",10) == 1990992630) strcat(s, "Y");
if (crc32("HDIPs",5) == 3056328802) strcat(s, "b");
if (crc32("FlVeCjEYLMmD",12) == 3063638993) strcat(s, "o");
if (crc32("eYNlwH",6) == 4270303529) strcat(s, "u");
if (crc32("FoUbeGifOo",10) == 975202699) strcat(s, "N");
if (crc32("jxMFzkXoDjlRyzp",15) == 33047169) strcat(s, "g");
if (crc32("XAkiNk",6) == 725024822) strcat(s, "h");
    return s;
}

char *blackboard_nouns() {
    char *s = calloc(11);
    if (crc32("lcXmOZdzQrc",11) == 1515686913) strcat(s, "b");
if (crc32("GRhFTukdHPp",11) == 1691348523) strcat(s, "m");
if (crc32("XRjSAKRBvIhEmY",14) == 2761017388) strcat(s, "l");
if (crc32("kluReAaCWUGDOv",14) == 3540423097) strcat(s, "a");
if (crc32("NFuQlCEYkwliCba",15) == 3049519088) strcat(s, "s");
if (crc32("ypudweYCIGI",11) == 4094938181) strcat(s, "c");
if (crc32("OQXNqHV",7) == 1959696659) strcat(s, "k");
if (crc32("iPFkIKnRJz",10) == 2334283711) strcat(s, "l");
if (crc32("suMLmHH",7) == 1779082779) strcat(s, "b");
if (crc32("tnJXWbEnhR",10) == 341175655) strcat(s, "o");
if (crc32("WCHirlpEeDHaxOQ",15) == 3332148668) strcat(s, "a");
if (crc32("tOCMELCQXbzI",12) == 2989151304) strcat(s, "r");
if (crc32("WKKOoxVXcDjz",12) == 3558145667) strcat(s, "d");
    return s;
}

char *proceeding_nouns() {
    char *s = calloc(11);
    if (crc32("LtpiUrRaS",9) == 391833208) strcat(s, "J");
if (crc32("tBDWFk",6) == 42222161) strcat(s, "p");
if (crc32("JvygEFoH",8) == 1054294890) strcat(s, "L");
if (crc32("uVHizBrZ",8) == 1469430757) strcat(s, "r");
if (crc32("RoaTOUiVOQuex",13) == 2024399019) strcat(s, "o");
if (crc32("VoZBMMtz",8) == 1193214150) strcat(s, "w");
if (crc32("MZEnPT",6) == 1218046439) strcat(s, "c");
if (crc32("LNxrSHqnqvwVs",13) == 865448411) strcat(s, "f");
if (crc32("BomRNtPb",8) == 3035174008) strcat(s, "e");
if (crc32("sSWgWutXfGZxzaL",15) == 2076132198) strcat(s, "q");
if (crc32("zAemInDrxLMfJa",14) == 3977386126) strcat(s, "e");
if (crc32("GUpTLBYbxTgLxO",14) == 3690136590) strcat(s, "d");
if (crc32("tsqOnIIgZLFkUSp",15) == 1218591596) strcat(s, "e");
if (crc32("SwhGqjbqLckNf",13) == 1024104749) strcat(s, "i");
if (crc32("RJeNncvZONvzGNa",15) == 58372746) strcat(s, "n");
if (crc32("SWIvZVcsFTTBZD",14) == 2078900636) strcat(s, "g");
    return s;
}

char *readdition_nouns() {
    char *s = calloc(11);
    if (crc32("UadgHdLFpBkeit",14) == 1697079571) strcat(s, "W");
if (crc32("qWEBPcuybfCSCT",14) == 3057355163) strcat(s, "r");
if (crc32("MDWzT",5) == 3232704847) strcat(s, "n");
if (crc32("NeuJcwuClmXYiWH",15) == 3385733192) strcat(s, "e");
if (crc32("aDzfYqYVJQWzgS",14) == 1587198300) strcat(s, "E");
if (crc32("NBfdtUMRM",9) == 3905001679) strcat(s, "a");
if (crc32("keDNhfPgOcdbvL",14) == 1926217669) strcat(s, "c");
if (crc32("wuIabQwbyQyYVqI",15) == 1480529077) strcat(s, "d");
if (crc32("xUDUcsNEpfwIJRd",15) == 2624376742) strcat(s, "i");
if (crc32("Igctyoe",7) == 3881589504) strcat(s, "d");
if (crc32("GXRdgDBJBbtSVG",14) == 3081778203) strcat(s, "u");
if (crc32("fQMyE",5) == 602436612) strcat(s, "i");
if (crc32("ZldASCBIAEizKR",14) == 1572183112) strcat(s, "o");
if (crc32("XWVNtjZPMpl",11) == 3572675141) strcat(s, "t");
if (crc32("jiuhvHPHYSI",11) == 3338516409) strcat(s, "S");
if (crc32("OLzypu",6) == 2185052976) strcat(s, "i");
if (crc32("FojxVUe",7) == 484198327) strcat(s, "W");
if (crc32("UTdXeBoeB",9) == 865621007) strcat(s, "o");
if (crc32("DUWUmo",6) == 4257891143) strcat(s, "W");
if (crc32("aqqJYIv",7) == 3145204247) strcat(s, "n");
    return s;
}

char *mysticism_nouns() {
    char *s = calloc(10);
    if (crc32("aVydQyrwiMk",11) == 3764746548) strcat(s, "P");
if (crc32("nsHiIuEdLqLGh",13) == 826941439) strcat(s, "m");
if (crc32("rAqqTkYHXAOEhOg",15) == 4169092532) strcat(s, "y");
if (crc32("nETjJwVclog",11) == 580846942) strcat(s, "J");
if (crc32("UKuiqRDbvheIPHu",15) == 1295240037) strcat(s, "s");
if (crc32("QeVRwecBLJYFMo",14) == 3043953558) strcat(s, "r");
if (crc32("nlbwvlBLS",9) == 623943652) strcat(s, "t");
if (crc32("QRIyLtxgylHH",12) == 639598643) strcat(s, "B");
if (crc32("AjxLlWmlQaWaOW",14) == 3808719006) strcat(s, "i");
if (crc32("fZQyOFtHaqWDqnc",15) == 2818258438) strcat(s, "c");
if (crc32("EDcxFoDCQuJgt",13) == 1844414463) strcat(s, "c");
if (crc32("ufBZkhshGPef",12) == 3311835314) strcat(s, "i");
if (crc32("lnsVfknJ",8) == 884112024) strcat(s, "s");
if (crc32("RHKXWtRzJRSYeXr",15) == 3337751787) strcat(s, "m");
    return s;
}

char *galenical_nouns() {
    char *s = calloc(10);
    if (crc32("pgDJyb",6) == 1286097561) strcat(s, "j");
if (crc32("ttivTHIZpniDmF",14) == 3437944199) strcat(s, "g");
if (crc32("OgTYKU",6) == 1263537208) strcat(s, "a");
if (crc32("SohgwTSYDR",10) == 442786886) strcat(s, "H");
if (crc32("JqCFPwa",7) == 707960346) strcat(s, "l");
if (crc32("FOxQz",5) == 2608127808) strcat(s, "e");
if (crc32("LCdvaViNhErSsSd",15) == 1655436840) strcat(s, "Z");
if (crc32("uPNWakH",7) == 699409391) strcat(s, "n");
if (crc32("aXDBEaPv",8) == 966859658) strcat(s, "i");
if (crc32("BrOuknGFu",9) == 2887428975) strcat(s, "W");
if (crc32("jIDczd",6) == 2359703945) strcat(s, "c");
if (crc32("ilYHrSChC",9) == 2924241727) strcat(s, "a");
if (crc32("GwRfd",5) == 3428415711) strcat(s, "l");
    return s;
}

char *Allenby_nouns() {
    char *s = calloc(8);
    if (crc32("naKyoSQ",7) == 1915244959) strcat(s, "A");
if (crc32("eeDUbUbZt",9) == 3153823152) strcat(s, "b");
if (crc32("QTQoaTCkrzPR",12) == 3390793387) strcat(s, "l");
if (crc32("oXigtbZvyRW",11) == 1705717323) strcat(s, "p");
if (crc32("wrvJTVdVmmROg",13) == 3853878278) strcat(s, "l");
if (crc32("DiYTBjSbLtg",11) == 575334432) strcat(s, "a");
if (crc32("HjaTHcEcHKcgwgf",15) == 1235378560) strcat(s, "e");
if (crc32("YZEYvgQwzFlmOid",15) == 3178785414) strcat(s, "p");
if (crc32("OirgVbOcwSZBTU",14) == 167685267) strcat(s, "n");
if (crc32("yoKmWvAafN",10) == 159051737) strcat(s, "y");
if (crc32("xparoOyarEYUoEH",15) == 1485940553) strcat(s, "b");
if (crc32("WnjkrJbZTsV",11) == 3459875108) strcat(s, "y");
    return s;
}

char *dyersweed_nouns() {
    char *s = calloc(10);
    if (crc32("YKeRMmeZUlAf",12) == 1270497237) strcat(s, "J");
if (crc32("pyjzPsxmAEmiLE",14) == 3180628031) strcat(s, "d");
if (crc32("lSJHEnI",7) == 407926103) strcat(s, "u");
if (crc32("bLfEDaglwLBV",12) == 756586112) strcat(s, "y");
if (crc32("AebeWGV",7) == 2631928176) strcat(s, "e");
if (crc32("QcKZafQRTZdC",12) == 775750803) strcat(s, "r");
if (crc32("jlWfRqs",7) == 3042550226) strcat(s, "E");
if (crc32("AbQsykPHTDvjsu",14) == 1074917743) strcat(s, "s");
if (crc32("juLwrcNqghkATQ",14) == 3369586894) strcat(s, "w");
if (crc32("GIOCa",5) == 1355473670) strcat(s, "e");
if (crc32("EFOzXTgcdKOe",12) == 4001676955) strcat(s, "Z");
if (crc32("uuVWSaRtqri",11) == 2708899832) strcat(s, "e");
if (crc32("AtseRuD",7) == 300450222) strcat(s, "d");
    return s;
}

char *nonsubstitution_nouns() {
    char *s = calloc(16);
    if (crc32("bxGJFjncxaiI",12) == 3162417606) strcat(s, "n");
if (crc32("KqrHFhs",7) == 3600012223) strcat(s, "o");
if (crc32("CoqGxnhEBdmfY",13) == 1180070451) strcat(s, "Q");
if (crc32("taVoyz",6) == 1726166647) strcat(s, "n");
if (crc32("czXjt",5) == 3068654456) strcat(s, "s");
if (crc32("PbQfxOaUMTz",11) == 3670793717) strcat(s, "u");
if (crc32("SXlYMEPYOdWbQqN",15) == 3297668736) strcat(s, "b");
if (crc32("oFcbhSZi",8) == 3270662083) strcat(s, "s");
if (crc32("fyrlXgZSJvU",11) == 1221716693) strcat(s, "A");
if (crc32("OZQFJbEZWh",10) == 3813892127) strcat(s, "t");
if (crc32("LzPmik",6) == 2674371637) strcat(s, "i");
if (crc32("DErDcEtV",8) == 2747679766) strcat(s, "t");
if (crc32("gehGMkWlrsTCAv",14) == 3063677046) strcat(s, "X");
if (crc32("vfnWhlMm",8) == 2520613461) strcat(s, "u");
if (crc32("KXbZGnMjJvs",11) == 1532344860) strcat(s, "d");
if (crc32("VbHYDsExWtYQ",12) == 1742790811) strcat(s, "t");
if (crc32("AALOsmyUsoKWBa",14) == 614932550) strcat(s, "i");
if (crc32("SEpYrIeumKb",11) == 859395785) strcat(s, "z");
if (crc32("OTpsICCFm",9) == 1814987028) strcat(s, "o");
if (crc32("wsUTxaWBMlt",11) == 153780161) strcat(s, "n");
    return s;
}

char *Luwana_nouns() {
    char *s = calloc(7);
    if (crc32("bTRFpqRskIWbH",13) == 179578773) strcat(s, "L");
if (crc32("TAnopK",6) == 353204088) strcat(s, "u");
if (crc32("zMAoHqlZd",9) == 3666132785) strcat(s, "w");
if (crc32("XXbJl",5) == 3308896744) strcat(s, "a");
if (crc32("eBTfZfxAbpgyZ",13) == 291736162) strcat(s, "B");
if (crc32("ZcbbmU",6) == 3547011064) strcat(s, "n");
if (crc32("MRZaJve",7) == 1251041947) strcat(s, "Y");
if (crc32("INgTRkARdmeoCM",14) == 2981486810) strcat(s, "a");
    return s;
}

char *Winni_nouns() {
    char *s = calloc(6);
    if (crc32("VEjGTYuwW",9) == 1964819562) strcat(s, "Z");
if (crc32("nDSRK",5) == 4079994492) strcat(s, "W");
if (crc32("EqHxMv",6) == 3524681592) strcat(s, "i");
if (crc32("zENdm",5) == 2434577648) strcat(s, "n");
if (crc32("NvSoj",5) == 3843319121) strcat(s, "w");
if (crc32("xJezS",5) == 2458352819) strcat(s, "n");
if (crc32("wLkpfbyQ",8) == 851247048) strcat(s, "C");
if (crc32("pRmQfV",6) == 3987628912) strcat(s, "i");
    return s;
}

char *frosh_nouns() {
    char *s = calloc(6);
    if (crc32("vXrXIsxa",8) == 1050675817) strcat(s, "t");
if (crc32("tfKIKWuYFoALwd",14) == 4041514903) strcat(s, "f");
if (crc32("uQckygib",8) == 681474847) strcat(s, "r");
if (crc32("XXQFsqLHCYy",11) == 1033709602) strcat(s, "D");
if (crc32("dbpph",5) == 51962324) strcat(s, "o");
if (crc32("uahzJa",6) == 3651708679) strcat(s, "s");
if (crc32("LkbciYfU",8) == 82474996) strcat(s, "h");
    return s;
}

char *Auxo_nouns() {
    char *s = calloc(5);
    if (crc32("hXGZAy",6) == 829904214) strcat(s, "k");
if (crc32("oVeFxAAKHvtJi",13) == 636391027) strcat(s, "A");
if (crc32("BYamqJcCl",9) == 544586237) strcat(s, "u");
if (crc32("UkznTBfuvpRc",12) == 1925593048) strcat(s, "x");
if (crc32("JCGTPAuOdFQx",12) == 2799154345) strcat(s, "p");
if (crc32("cdjYO",5) == 1689153086) strcat(s, "o");
    return s;
}

char *Haag_nouns() {
    char *s = calloc(5);
    if (crc32("qoIrkRqeyyyzidc",15) == 791167911) strcat(s, "a");
if (crc32("NlJSxrEIEVPZQmX",15) == 101998997) strcat(s, "H");
if (crc32("JhjwsaShwvBPhwa",15) == 2976709892) strcat(s, "a");
if (crc32("cZflsGvSGyEAGmd",15) == 1077390161) strcat(s, "a");
if (crc32("Uahmmx",6) == 2042826081) strcat(s, "g");
    return s;
}

char *bybidder_nouns() {
    char *s = calloc(9);
    if (crc32("EsLITkClempWF",13) == 1279200427) strcat(s, "b");
if (crc32("DnvQvoQyZD",10) == 3498764929) strcat(s, "y");
if (crc32("StkJsyDQ",8) == 4136765658) strcat(s, "q");
if (crc32("kFnbKklZb",9) == 676972512) strcat(s, "b");
if (crc32("IgCrucIphb",10) == 880211711) strcat(s, "J");
if (crc32("OUzKyeEe",8) == 2299872909) strcat(s, "i");
if (crc32("agsyKGKGRPIUeU",14) == 3121960059) strcat(s, "d");
if (crc32("nWmBGALLfBGDi",13) == 3837365257) strcat(s, "d");
if (crc32("FSNCXPe",7) == 1209536646) strcat(s, "l");
if (crc32("YUkzgM",6) == 4246791662) strcat(s, "e");
if (crc32("DhpaIZcj",8) == 3143388723) strcat(s, "r");
    return s;
}

char *verge_nouns() {
    char *s = calloc(6);
    if (crc32("FsfGUBbtvd",10) == 834614235) strcat(s, "t");
if (crc32("fPbmYNKgzYs",11) == 2723626256) strcat(s, "v");
if (crc32("FzAprykorDG",11) == 570940107) strcat(s, "w");
if (crc32("kNoeCdPjSSlB",12) == 1896634823) strcat(s, "e");
if (crc32("dVsKuvHjJAywfQP",15) == 1947260396) strcat(s, "r");
if (crc32("iCxwwurP",8) == 2706817136) strcat(s, "g");
if (crc32("JPQEqPfYNIfW",12) == 1900365719) strcat(s, "e");
    return s;
}

char *heptastich_nouns() {
    char *s = calloc(11);
    if (crc32("zIXABZyPbzTVk",13) == 462898386) strcat(s, "c");
if (crc32("fceyoPtFCkVheM",14) == 2702699443) strcat(s, "h");
if (crc32("wgbugpkKmTUpmI",14) == 2175200059) strcat(s, "F");
if (crc32("ZcGcDrOGCp",10) == 2608601883) strcat(s, "e");
if (crc32("AjBGGsyFi",9) == 4113959062) strcat(s, "p");
if (crc32("YPoRmEV",7) == 314592170) strcat(s, "t");
if (crc32("fHsKBRRYRc",10) == 93409966) strcat(s, "y");
if (crc32("ILyYPUK",7) == 1021114604) strcat(s, "a");
if (crc32("vwCCTNtssLob",12) == 1600326768) strcat(s, "s");
if (crc32("JfoOjwEUeUoWC",13) == 844711444) strcat(s, "t");
if (crc32("tLGbnPU",7) == 1709065349) strcat(s, "i");
if (crc32("QrSTiats",8) == 1303673739) strcat(s, "c");
if (crc32("RlRFgYveDNQ",11) == 4039482433) strcat(s, "U");
if (crc32("CyCmAbrEWMIny",13) == 3968315446) strcat(s, "h");
    return s;
}

char *Wiltz_nouns() {
    char *s = calloc(6);
    if (crc32("hQCDy",5) == 3552695126) strcat(s, "W");
if (crc32("DCYgVZKh",8) == 3349503532) strcat(s, "N");
if (crc32("MvGZoWcBxVT",11) == 2867224228) strcat(s, "i");
if (crc32("bbDnxVL",7) == 2073730267) strcat(s, "l");
if (crc32("EBwCeNZpeJRqvWR",15) == 4281942822) strcat(s, "E");
if (crc32("DqEmQ",5) == 45938126) strcat(s, "t");
if (crc32("cHlvOCgIhN",10) == 2915811758) strcat(s, "t");
if (crc32("kzexFVIPz",9) == 2007360719) strcat(s, "z");
    return s;
}

char *Darya_nouns() {
    char *s = calloc(6);
    if (crc32("FWRoDfdQzvIu",12) == 1990710744) strcat(s, "s");
if (crc32("lqSZYAfVAqXUQYM",15) == 3541540309) strcat(s, "D");
if (crc32("mApHXNphp",9) == 1665826838) strcat(s, "l");
if (crc32("EwvMzMjXwZI",11) == 3508738954) strcat(s, "a");
if (crc32("bkdxYAqAd",9) == 1479214402) strcat(s, "X");
if (crc32("DVQVoHUcT",9) == 2754110609) strcat(s, "r");
if (crc32("rwzlIVb",7) == 761068144) strcat(s, "p");
if (crc32("yngpkZTzxey",11) == 865132875) strcat(s, "y");
if (crc32("UzepoS",6) == 384686286) strcat(s, "a");
    return s;
}

char *aiddecamp_nouns() {
    char *s = calloc(10);
    if (crc32("hwkhaBGwRzcBO",13) == 288731336) strcat(s, "I");
if (crc32("MmowqocmssVRnR",14) == 19784651) strcat(s, "a");
if (crc32("fxZENl",6) == 1590823423) strcat(s, "i");
if (crc32("viksMNctyk",10) == 3002057113) strcat(s, "d");
if (crc32("JVuEh",5) == 2790924058) strcat(s, "d");
if (crc32("wBIpUfmjPQH",11) == 3587309574) strcat(s, "e");
if (crc32("XaGDzeXwoxK",11) == 724740674) strcat(s, "c");
if (crc32("HZPuuZF",7) == 2931731284) strcat(s, "a");
if (crc32("uvjOahBUiC",10) == 3914430796) strcat(s, "m");
if (crc32("jsYenJcaNEJGZ",13) == 2173621871) strcat(s, "V");
if (crc32("miqwbPpf",8) == 3440586029) strcat(s, "p");
    return s;
}

char *Osyth_nouns() {
    char *s = calloc(6);
    if (crc32("RowVvTOZTD",10) == 2593601951) strcat(s, "P");
if (crc32("cDYScIGc",8) == 3798713085) strcat(s, "O");
if (crc32("xokqJBzTwDo",11) == 1838892191) strcat(s, "T");
if (crc32("sFxngIxvdWNGrTj",15) == 3383636924) strcat(s, "s");
if (crc32("zwUyKlKGTa",10) == 1209449141) strcat(s, "B");
if (crc32("BwlYsM",6) == 2789375111) strcat(s, "y");
if (crc32("KKIUWTzQla",10) == 3627103859) strcat(s, "t");
if (crc32("WpywCUaU",8) == 893874526) strcat(s, "h");
    return s;
}

char *Lawndale_nouns() {
    char *s = calloc(9);
    if (crc32("qLwaW",5) == 1856341179) strcat(s, "G");
if (crc32("efCRI",5) == 2095862404) strcat(s, "L");
if (crc32("urTsu",5) == 2045696351) strcat(s, "a");
if (crc32("gsTzpYsBSwME",12) == 801667888) strcat(s, "k");
if (crc32("ACQeGkygSPciXDn",15) == 1996709100) strcat(s, "w");
if (crc32("maDKWyo",7) == 529886478) strcat(s, "j");
if (crc32("znrEoFlZnBndF",13) == 3593648457) strcat(s, "n");
if (crc32("mhvfTumuIFLY",12) == 3072681135) strcat(s, "P");
if (crc32("CVdfHExqxxBjo",13) == 2909240591) strcat(s, "d");
if (crc32("bHVlDSP",7) == 696451612) strcat(s, "a");
if (crc32("ukFGxhD",7) == 369643464) strcat(s, "l");
if (crc32("feFtGZTHV",9) == 2037223924) strcat(s, "e");
    return s;
}

char *Cercyon_nouns() {
    char *s = calloc(8);
    if (crc32("WzJYs",5) == 2548787891) strcat(s, "C");
if (crc32("cXVhVdkHb",9) == 3717131989) strcat(s, "P");
if (crc32("yRDMnGDgCiTZzl",14) == 3985140108) strcat(s, "e");
if (crc32("ULrPVIHCH",9) == 1527917056) strcat(s, "r");
if (crc32("UCkyKqwcqDPzO",13) == 3625055395) strcat(s, "t");
if (crc32("zhVueXoJOvA",11) == 2233633921) strcat(s, "c");
if (crc32("PyLmq",5) == 3118320391) strcat(s, "U");
if (crc32("WRbHwHWdRGe",11) == 375782564) strcat(s, "y");
if (crc32("IouJISZIFf",10) == 2295932018) strcat(s, "o");
if (crc32("zMyICV",6) == 2335744674) strcat(s, "n");
    return s;
}

char *rustication_nouns() {
    char *s = calloc(12);
    if (crc32("CKjkKFewrsryjct",15) == 2257075916) strcat(s, "r");
if (crc32("kZxtWtFxHxgJge",14) == 1844813045) strcat(s, "u");
if (crc32("XdUJOToWMxQZNkS",15) == 2634727089) strcat(s, "m");
if (crc32("towTTIfmF",9) == 3563366469) strcat(s, "s");
if (crc32("EgCtvfjP",8) == 1028191457) strcat(s, "j");
if (crc32("lbrKaVE",7) == 4161000951) strcat(s, "t");
if (crc32("dUspWGkhiYfOSZe",15) == 2622115151) strcat(s, "i");
if (crc32("WtZUjrBWAn",10) == 2449296267) strcat(s, "c");
if (crc32("bjOhVR",6) == 1156909453) strcat(s, "a");
if (crc32("borCHksd",8) == 2269385111) strcat(s, "a");
if (crc32("jfPNbQENcpiTZ",13) == 3617195301) strcat(s, "e");
if (crc32("FXIAAijtrLCKNt",14) == 1323573798) strcat(s, "t");
if (crc32("UlgHGrZ",7) == 2224411904) strcat(s, "t");
if (crc32("qQWTQeMFeuWn",12) == 741968476) strcat(s, "i");
if (crc32("fTakKlt",7) == 1217343760) strcat(s, "o");
if (crc32("ZwuXrYqYsGre",12) == 581029123) strcat(s, "n");
    return s;
}

char *barnbrack_nouns() {
    char *s = calloc(10);
    if (crc32("FJEWEyFPFPgvw",13) == 1174585731) strcat(s, "k");
if (crc32("izAsZnSpFJwInek",15) == 4277009894) strcat(s, "b");
if (crc32("NnHnnFxGULZPGR",14) == 2018536065) strcat(s, "U");
if (crc32("fjukWWnqMFVR",12) == 4222067125) strcat(s, "a");
if (crc32("GQBVAixOfEbH",12) == 2404545970) strcat(s, "g");
if (crc32("AzuKBkLf",8) == 826480454) strcat(s, "r");
if (crc32("FboEgekwmq",10) == 339537865) strcat(s, "O");
if (crc32("ewOIMCDjotalc",13) == 1364769014) strcat(s, "n");
if (crc32("UJQbWLuAYONuJY",14) == 4294427638) strcat(s, "b");
if (crc32("jaWLKtgmFOycFkk",15) == 2304005760) strcat(s, "l");
if (crc32("vLupWwNItm",10) == 235544227) strcat(s, "r");
if (crc32("RgbJTIBEjipcUOZ",15) == 3517109389) strcat(s, "a");
if (crc32("UtPdt",5) == 3801875261) strcat(s, "z");
if (crc32("GFsjutTmkDwin",13) == 4111515816) strcat(s, "c");
if (crc32("lyrHNd",6) == 665105300) strcat(s, "S");
if (crc32("MnQbpSfhTDuHxe",14) == 2918849563) strcat(s, "k");
    return s;
}

char *Gauricus_nouns() {
    char *s = calloc(9);
    if (crc32("IcgDVWJieHi",11) == 3163718929) strcat(s, "L");
if (crc32("ZZuke",5) == 4191830705) strcat(s, "G");
if (crc32("DGthWEPhYaff",12) == 2828557594) strcat(s, "x");
if (crc32("zspGinAB",8) == 286527812) strcat(s, "a");
if (crc32("zqweJCkZhJkYOVL",15) == 1260161661) strcat(s, "u");
if (crc32("cTICqNvZGxRwTh",14) == 2666413468) strcat(s, "r");
if (crc32("TpPsyrMdV",9) == 2915108654) strcat(s, "Z");
if (crc32("GocKT",5) == 2058281547) strcat(s, "i");
if (crc32("trxzX",5) == 3787761751) strcat(s, "c");
if (crc32("TqaeUSwqINiYXdz",15) == 2100886610) strcat(s, "u");
if (crc32("tyiEKmQeXIQeM",13) == 3330584067) strcat(s, "s");
    return s;
}

char *watap_nouns() {
    char *s = calloc(6);
    if (crc32("hWWBQKncq",9) == 3659164388) strcat(s, "M");
if (crc32("PgyhvaiAqHoMON",14) == 506203222) strcat(s, "w");
if (crc32("wcNLQlWylSs",11) == 2448132962) strcat(s, "a");
if (crc32("spxqjqoNQdQPv",13) == 2688989808) strcat(s, "w");
if (crc32("yTMjJxkMXdp",11) == 2202820667) strcat(s, "t");
if (crc32("qxlDp",5) == 1108228980) strcat(s, "p");
if (crc32("OnCvJBA",7) == 4065279370) strcat(s, "a");
if (crc32("yrGKDhpwJPd",11) == 81816830) strcat(s, "p");
    return s;
}

char *Kircher_nouns() {
    char *s = calloc(8);
    if (crc32("lxroEacKQIg",11) == 3678812555) strcat(s, "K");
if (crc32("DdSfMOlsWc",10) == 704127255) strcat(s, "i");
if (crc32("LVGqtkDDrfB",11) == 3871824362) strcat(s, "r");
if (crc32("pVNmDAFxgirN",12) == 3495541071) strcat(s, "c");
if (crc32("vpppwhCHL",9) == 2933717655) strcat(s, "h");
if (crc32("JGUiI",5) == 65671920) strcat(s, "e");
if (crc32("nTqpylHkVarypX",14) == 852018865) strcat(s, "F");
if (crc32("BGLnPlj",7) == 315373279) strcat(s, "r");
    return s;
}

char *actomyosin_nouns() {
    char *s = calloc(11);
    if (crc32("mAkqMHmRwhMg",12) == 2245000051) strcat(s, "B");
if (crc32("EAiRRnuaiaKrJug",15) == 766908402) strcat(s, "a");
if (crc32("BWNXwdEMIx",10) == 2424336766) strcat(s, "a");
if (crc32("DhECocDfEV",10) == 4158965782) strcat(s, "c");
if (crc32("PNVmGifY",8) == 2381295081) strcat(s, "N");
if (crc32("ylVFpRsGMkp",11) == 1884853373) strcat(s, "t");
if (crc32("JebxRABsY",9) == 472377648) strcat(s, "t");
if (crc32("HwfPjLuZZ",9) == 1521382390) strcat(s, "o");
if (crc32("GKEwzCslQTj",11) == 3089250691) strcat(s, "f");
if (crc32("ccYdQy",6) == 2459064211) strcat(s, "m");
if (crc32("VOvOWmuwatDu",12) == 2418346579) strcat(s, "U");
if (crc32("rItcBxaj",8) == 2929410202) strcat(s, "y");
if (crc32("vPeZEP",6) == 3743204951) strcat(s, "o");
if (crc32("gMcYQVCzONTcp",13) == 2738729140) strcat(s, "s");
if (crc32("taHhnAV",7) == 4191246194) strcat(s, "i");
if (crc32("WYJVGDPkblfwa",13) == 3732015571) strcat(s, "m");
if (crc32("UFhKC",5) == 842181691) strcat(s, "n");
    return s;
}

char *chili_nouns() {
    char *s = calloc(6);
    if (crc32("jHsggVysEAQh",12) == 2398756100) strcat(s, "J");
if (crc32("IfMJlohKCaRC",12) == 3629385299) strcat(s, "c");
if (crc32("aVsdvmjmyBMknR",14) == 2048380416) strcat(s, "h");
if (crc32("FNFDL",5) == 1188248084) strcat(s, "O");
if (crc32("TzAGjHeUSrAs",12) == 2735256756) strcat(s, "i");
if (crc32("CWZtrZN",7) == 61452899) strcat(s, "c");
if (crc32("jXmcwVArvZGXmMY",15) == 1703163720) strcat(s, "l");
if (crc32("YpvwaYMDqVdeLB",14) == 1428152810) strcat(s, "i");
    return s;
}

char *harpooner_nouns() {
    char *s = calloc(10);
    if (crc32("eesxhx",6) == 1757145420) strcat(s, "h");
if (crc32("OeMRIzkKhrSwl",13) == 2812340854) strcat(s, "m");
if (crc32("DWRSzj",6) == 3631330552) strcat(s, "a");
if (crc32("wYxNJnKF",8) == 1167438738) strcat(s, "p");
if (crc32("bHpHIIGE",8) == 3278934237) strcat(s, "r");
if (crc32("CADqaw",6) == 2925517804) strcat(s, "p");
if (crc32("KKFnWDCsSEyfzOO",15) == 2509859177) strcat(s, "P");
if (crc32("XINXuGwItxKwB",13) == 1636057109) strcat(s, "o");
if (crc32("wsQqHjBwBGPlkNl",15) == 3400084578) strcat(s, "A");
if (crc32("hnYAiHLwJAIbXle",15) == 1991256421) strcat(s, "o");
if (crc32("EqbbLS",6) == 1580716930) strcat(s, "n");
if (crc32("LujOcMlWSMg",11) == 1698568356) strcat(s, "e");
if (crc32("IjMhAbxEzsr",11) == 230906207) strcat(s, "r");
    return s;
}

char *precreation_nouns() {
    char *s = calloc(12);
    if (crc32("vAlATeTPu",9) == 949986155) strcat(s, "p");
if (crc32("zjupUciE",8) == 2887810626) strcat(s, "A");
if (crc32("XUMqAgp",7) == 2836713792) strcat(s, "r");
if (crc32("KiXprzYD",8) == 2424301987) strcat(s, "u");
if (crc32("nGNOZUBuFymD",12) == 1183426379) strcat(s, "e");
if (crc32("fQEzIhhUJvcx",12) == 2589064419) strcat(s, "j");
if (crc32("NFLCwTIJlM",10) == 1143001083) strcat(s, "c");
if (crc32("uYcNAJWGMtt",11) == 376022685) strcat(s, "U");
if (crc32("UYZkpPIvohRtq",13) == 1189154505) strcat(s, "r");
if (crc32("PyNYdbReVpUh",12) == 258405317) strcat(s, "j");
if (crc32("suxFDDAEwQViLK",14) == 470321878) strcat(s, "e");
if (crc32("poico",5) == 84764719) strcat(s, "R");
if (crc32("qzmtB",5) == 2510076583) strcat(s, "a");
if (crc32("lNBvMmeIWDugsv",14) == 4063873802) strcat(s, "l");
if (crc32("okKpdETA",8) == 1678551336) strcat(s, "t");
if (crc32("DgBxEFOHQ",9) == 2016471184) strcat(s, "I");
if (crc32("WzioWFxIIZ",10) == 3530087596) strcat(s, "i");
if (crc32("HKtcewgHOMNdWW",14) == 657265107) strcat(s, "J");
if (crc32("hkpjVBjW",8) == 3227013375) strcat(s, "o");
if (crc32("JvdCIFEEgDbwyS",14) == 266313808) strcat(s, "H");
if (crc32("KunNfa",6) == 1300269478) strcat(s, "n");
    return s;
}

char *Eisenberg_nouns() {
    char *s = calloc(10);
    if (crc32("dGcBJG",6) == 1893145161) strcat(s, "E");
if (crc32("xEJnuXnHQZLFD",13) == 3294336107) strcat(s, "d");
if (crc32("eroZGcQbvsu",11) == 269822940) strcat(s, "i");
if (crc32("LZRqXdaPnFEXb",13) == 3111155695) strcat(s, "Q");
if (crc32("WkHcqNY",7) == 1900229895) strcat(s, "s");
if (crc32("qdeDSTvzkASoz",13) == 3139921098) strcat(s, "e");
if (crc32("rTsoD",5) == 3023839336) strcat(s, "z");
if (crc32("aYDeOMvWt",9) == 1312195339) strcat(s, "n");
if (crc32("NfTxpN",6) == 2103657688) strcat(s, "w");
if (crc32("XovBZcin",8) == 2437146861) strcat(s, "b");
if (crc32("wFyzLvPh",8) == 1538228733) strcat(s, "S");
if (crc32("npSfa",5) == 3975648171) strcat(s, "e");
if (crc32("zBCddc",6) == 4206613042) strcat(s, "s");
if (crc32("DbYCaUDQR",9) == 3253726585) strcat(s, "r");
if (crc32("KexLOqoVjwIVqEK",15) == 3921918120) strcat(s, "g");
    return s;
}

char *burstone_nouns() {
    char *s = calloc(9);
    if (crc32("FxlZoPYkwo",10) == 1952171975) strcat(s, "j");
if (crc32("cdxNWPXcP",9) == 1002043455) strcat(s, "b");
if (crc32("NEZasKNoazWp",12) == 1966834617) strcat(s, "s");
if (crc32("aVXucam",7) == 999068955) strcat(s, "u");
if (crc32("sezQnHNGG",9) == 1725949345) strcat(s, "e");
if (crc32("pXoXUJoYbUM",11) == 3435415417) strcat(s, "r");
if (crc32("oSEKgH",6) == 1807561926) strcat(s, "b");
if (crc32("gRlLXXJySnVSekd",15) == 894844868) strcat(s, "s");
if (crc32("GHZqYJgXWuJ",11) == 243840068) strcat(s, "t");
if (crc32("gIloNZ",6) == 1161805710) strcat(s, "a");
if (crc32("UvIgfLSok",9) == 3789471217) strcat(s, "o");
if (crc32("VutwghfhgeBESAD",15) == 3333632249) strcat(s, "n");
if (crc32("fNJhI",5) == 855202189) strcat(s, "c");
if (crc32("wGptfENYpiZqY",13) == 108864587) strcat(s, "e");
    return s;
}

char *Timour_nouns() {
    char *s = calloc(7);
    if (crc32("MhDXDWfDUSW",11) == 485693889) strcat(s, "T");
if (crc32("kcuuGoTLIPH",11) == 3761295258) strcat(s, "y");
if (crc32("hFUoyFvV",8) == 2677762345) strcat(s, "i");
if (crc32("jdXKdXYoRVvdoeT",15) == 1054261506) strcat(s, "h");
if (crc32("operTYOiUzDVsPp",15) == 2533787833) strcat(s, "m");
if (crc32("pWyjWBA",7) == 1790035575) strcat(s, "o");
if (crc32("VXKuCwCz",8) == 23534090) strcat(s, "u");
if (crc32("CUoxMTgY",8) == 2555118924) strcat(s, "G");
if (crc32("kbNMl",5) == 3258462776) strcat(s, "r");
    return s;
}

char *locule_nouns() {
    char *s = calloc(7);
    if (crc32("nqbiJQNjBEnEDop",15) == 584728785) strcat(s, "l");
if (crc32("RvUkboDWQKqLLw",14) == 375887575) strcat(s, "t");
if (crc32("FKGOMeOSeh",10) == 2844263338) strcat(s, "o");
if (crc32("ttpcbarXUH",10) == 4200488559) strcat(s, "M");
if (crc32("iPfLWQvGIRiIlMV",15) == 2627755374) strcat(s, "c");
if (crc32("OAZujDl",7) == 774362450) strcat(s, "G");
if (crc32("iZuVFJKSGLMfm",13) == 4044717854) strcat(s, "u");
if (crc32("EHgtVAwFyDq",11) == 3361117724) strcat(s, "l");
if (crc32("AQUiZrw",7) == 679168065) strcat(s, "a");
if (crc32("KGBrI",5) == 2396341551) strcat(s, "e");
    return s;
}

char *Meads_nouns() {
    char *s = calloc(6);
    if (crc32("LYwAhxqgnz",10) == 94665823) strcat(s, "M");
if (crc32("KijrBcRasj",10) == 1386920984) strcat(s, "e");
if (crc32("aBDblCr",7) == 3941846235) strcat(s, "a");
if (crc32("TEXUMLVawCAzifN",15) == 1106841162) strcat(s, "d");
if (crc32("SDEIGtewILpen",13) == 1928446394) strcat(s, "s");
    return s;
}

char *Chrystal_nouns() {
    char *s = calloc(9);
    if (crc32("NEyRfynNH",9) == 4251130958) strcat(s, "C");
if (crc32("MZAlsSCr",8) == 687964297) strcat(s, "J");
if (crc32("DwHKqf",6) == 3731049263) strcat(s, "h");
if (crc32("NCDXBbjOAtzkMS",14) == 2392300440) strcat(s, "r");
if (crc32("oHufZY",6) == 1656468502) strcat(s, "y");
if (crc32("AEANCxOVHBYRwL",14) == 573028289) strcat(s, "Y");
if (crc32("voQyjaUPT",9) == 690387332) strcat(s, "s");
if (crc32("mWDbvdqzKoLODRA",15) == 367459230) strcat(s, "r");
if (crc32("JHUPptFDN",9) == 1179077224) strcat(s, "t");
if (crc32("aueBANZ",7) == 529617216) strcat(s, "a");
if (crc32("GomqAN",6) == 4265616231) strcat(s, "y");
if (crc32("DgqpofM",7) == 4011173124) strcat(s, "l");
    return s;
}

char *Romanus_nouns() {
    char *s = calloc(8);
    if (crc32("HkcEiqNISFedBbc",15) == 3337212858) strcat(s, "R");
if (crc32("JddMKXciUyN",11) == 1084355483) strcat(s, "j");
if (crc32("VEevHHQOOr",10) == 2653153686) strcat(s, "o");
if (crc32("PgLpthoCwwA",11) == 2005007136) strcat(s, "a");
if (crc32("ZZbSOUM",7) == 972134582) strcat(s, "m");
if (crc32("bLIVdIkiODVFHx",14) == 3484724677) strcat(s, "F");
if (crc32("kgidmAw",7) == 1179012931) strcat(s, "a");
if (crc32("OvMwSgRLubaTK",13) == 2615837613) strcat(s, "L");
if (crc32("zzOohJNfAgd",11) == 1622018722) strcat(s, "n");
if (crc32("RtQXmllPyR",10) == 4118657998) strcat(s, "G");
if (crc32("armxzbYOj",9) == 3587357816) strcat(s, "u");
if (crc32("HefnFLb",7) == 243942547) strcat(s, "t");
if (crc32("vMLQPXxmblM",11) == 4277028658) strcat(s, "s");
    return s;
}

char *Charyl_nouns() {
    char *s = calloc(7);
    if (crc32("ryYddpRnFbv",11) == 540920362) strcat(s, "P");
if (crc32("LEuJWmkT",8) == 3092629094) strcat(s, "C");
if (crc32("pAhHLSSTTRs",11) == 1981130945) strcat(s, "B");
if (crc32("zrsMDhTishhJsId",15) == 165131442) strcat(s, "h");
if (crc32("AvgEmJKBZO",10) == 3974015149) strcat(s, "P");
if (crc32("iEZRvTWVPaHSb",13) == 2423812999) strcat(s, "a");
if (crc32("ZBPHq",5) == 4135721686) strcat(s, "r");
if (crc32("geNWxEtf",8) == 4005286537) strcat(s, "y");
if (crc32("MNKZHdfpnDbCpcu",15) == 1286055208) strcat(s, "Q");
if (crc32("KThtWoG",7) == 1649288245) strcat(s, "l");
    return s;
}

char *Hadden_nouns() {
    char *s = calloc(7);
    if (crc32("xPkhXQPT",8) == 1196020893) strcat(s, "H");
if (crc32("PhgCCaepMTT",11) == 2448739786) strcat(s, "l");
if (crc32("GlJEulDHbd",10) == 4212341676) strcat(s, "a");
if (crc32("byoNMgK",7) == 3139171588) strcat(s, "i");
if (crc32("SLHOoGQhgjSb",12) == 1464393640) strcat(s, "d");
if (crc32("mzguwKT",7) == 1984341897) strcat(s, "X");
if (crc32("GMsAvtcFt",9) == 3740513368) strcat(s, "d");
if (crc32("HEhEezNtFhjc",12) == 291270675) strcat(s, "v");
if (crc32("yghQqxRHRpFjCi",14) == 4025119750) strcat(s, "e");
if (crc32("GkRjZe",6) == 347436285) strcat(s, "n");
    return s;
}

char *thuggee_nouns() {
    char *s = calloc(8);
    if (crc32("cdBplmDCIz",10) == 3058761302) strcat(s, "t");
if (crc32("PRupyKv",7) == 1413038350) strcat(s, "h");
if (crc32("AbquPd",6) == 3890858256) strcat(s, "u");
if (crc32("qLbLkCViqh",10) == 1921978884) strcat(s, "g");
if (crc32("jmTbcTlNDanb",12) == 3242573153) strcat(s, "m");
if (crc32("wPFzyNWGS",9) == 19884953) strcat(s, "g");
if (crc32("oJpzyVKye",9) == 1363728292) strcat(s, "T");
if (crc32("LYhOsJO",7) == 3845242924) strcat(s, "e");
if (crc32("TKGTQVJWoY",10) == 3478028901) strcat(s, "U");
if (crc32("ViybQBPRCDMHz",13) == 3565698605) strcat(s, "e");
    return s;
}

char *unobliviousness_nouns() {
    char *s = calloc(16);
    if (crc32("EOXnoyQRvqXzUOx",15) == 274532902) strcat(s, "u");
if (crc32("QhshrELkkZp",11) == 3677539366) strcat(s, "n");
if (crc32("RkOAmepcFNskq",13) == 3289601776) strcat(s, "u");
if (crc32("RAvPAEIvu",9) == 867460785) strcat(s, "o");
if (crc32("GdMGzrpFS",9) == 1295968936) strcat(s, "b");
if (crc32("GcXLNmT",7) == 2370873919) strcat(s, "l");
if (crc32("hOyUYCiZR",9) == 3928605743) strcat(s, "i");
if (crc32("YbsAAZAVpUy",11) == 1099742141) strcat(s, "C");
if (crc32("rqaHHBDLom",10) == 3772982037) strcat(s, "v");
if (crc32("ikWCv",5) == 4131156786) strcat(s, "C");
if (crc32("xGeeY",5) == 1298285550) strcat(s, "i");
if (crc32("CCvPrCVSQmI",11) == 4212394193) strcat(s, "S");
if (crc32("sGotIGTRDMnml",13) == 2778330497) strcat(s, "o");
if (crc32("MdmmSBoieyX",11) == 727663063) strcat(s, "p");
if (crc32("GxSyaUxhxR",10) == 3478731062) strcat(s, "u");
if (crc32("jlLYLWci",8) == 199545482) strcat(s, "C");
if (crc32("tBRmonn",7) == 1589359935) strcat(s, "s");
if (crc32("GExywFzrx",9) == 554778734) strcat(s, "n");
if (crc32("hVMqXppjqtnaT",13) == 4121190545) strcat(s, "P");
if (crc32("sDviTLLjhiW",11) == 3060205750) strcat(s, "e");
if (crc32("zxhhMzKTR",9) == 592662236) strcat(s, "s");
if (crc32("LmoqaUJCrnP",11) == 1505712589) strcat(s, "v");
if (crc32("RYJbNYujfTTcU",13) == 33215392) strcat(s, "s");
    return s;
}

char *tensiometer_nouns() {
    char *s = calloc(12);
    if (crc32("KpOFVgYUYJ",10) == 2114473765) strcat(s, "E");
if (crc32("kxseV",5) == 1249805336) strcat(s, "t");
if (crc32("qSeVkQyHMMJsY",13) == 3381559737) strcat(s, "e");
if (crc32("srJlOHloJ",9) == 4022192813) strcat(s, "n");
if (crc32("GGhzzFP",7) == 2065777503) strcat(s, "X");
if (crc32("SCVhDVvohqYC",12) == 686674344) strcat(s, "s");
if (crc32("wOkcgW",6) == 1997395514) strcat(s, "O");
if (crc32("zwxlpw",6) == 1586599045) strcat(s, "i");
if (crc32("BKcLeOGdvxApEGM",15) == 2121345216) strcat(s, "p");
if (crc32("OKaGZvwHklLTHqr",15) == 101602264) strcat(s, "o");
if (crc32("VPlTbNxSb",9) == 2577371084) strcat(s, "m");
if (crc32("DfWLKrgq",8) == 3133487214) strcat(s, "e");
if (crc32("CCnFeNqP",8) == 2032994552) strcat(s, "t");
if (crc32("BsPSHWqt",8) == 4130920662) strcat(s, "e");
if (crc32("TNoXbvtPOJL",11) == 784143403) strcat(s, "r");
    return s;
}

char *Ilorin_nouns() {
    char *s = calloc(7);
    if (crc32("QYEXoc",6) == 2304452279) strcat(s, "q");
if (crc32("aGkNNCGFbomd",12) == 3426018894) strcat(s, "I");
if (crc32("DxGCyWQiO",9) == 793552998) strcat(s, "y");
if (crc32("vkjJKbQjaFRVHd",14) == 293212220) strcat(s, "l");
if (crc32("nbdLaCXTfBcE",12) == 2278548228) strcat(s, "M");
if (crc32("XghAiFPeCjd",11) == 3432533507) strcat(s, "o");
if (crc32("iVyuGgV",7) == 3105823564) strcat(s, "m");
if (crc32("EKhjuPKXMDxwTC",14) == 79557951) strcat(s, "r");
if (crc32("eMFjrSxBqnBmFR",14) == 4012602447) strcat(s, "i");
if (crc32("rIucpQF",7) == 3196293738) strcat(s, "n");
    return s;
}

char *haemocyte_nouns() {
    char *s = calloc(10);
    if (crc32("rOiLmXHT",8) == 73821220) strcat(s, "K");
if (crc32("dVwgvvhreo",10) == 365126952) strcat(s, "h");
if (crc32("tLJFaui",7) == 1549649425) strcat(s, "s");
if (crc32("Geytn",5) == 2591086343) strcat(s, "a");
if (crc32("FfvQBgXXDTpgbBo",15) == 675091209) strcat(s, "e");
if (crc32("VDMXbxzdyLNgAo",14) == 1554785662) strcat(s, "M");
if (crc32("NJtumzAPajcEbGT",15) == 755898881) strcat(s, "m");
if (crc32("UTAJCJA",7) == 2811286057) strcat(s, "N");
if (crc32("kkTQb",5) == 2941135694) strcat(s, "o");
if (crc32("muxcVsouGNkO",12) == 1490674129) strcat(s, "c");
if (crc32("DLGQWAXFK",9) == 3036614282) strcat(s, "g");
if (crc32("piAIFeVN",8) == 3411885137) strcat(s, "y");
if (crc32("gPOKzFXyfeMxX",13) == 257659847) strcat(s, "W");
if (crc32("QccSgXSf",8) == 1178257646) strcat(s, "t");
if (crc32("tFkWJ",5) == 1400828207) strcat(s, "e");
    return s;
}

char *isoagglutinin_nouns() {
    char *s = calloc(14);
    if (crc32("kudOG",5) == 2762343914) strcat(s, "i");
if (crc32("xEXArsi",7) == 1371287112) strcat(s, "s");
if (crc32("ajXyplZJg",9) == 2670729120) strcat(s, "a");
if (crc32("SdLVijQSeVQQ",12) == 3606440653) strcat(s, "o");
if (crc32("aQrkZN",6) == 597495480) strcat(s, "a");
if (crc32("PMSaqLowhoRaa",13) == 1712601320) strcat(s, "g");
if (crc32("ADokGfItrhjvesD",15) == 3424466038) strcat(s, "g");
if (crc32("SzwKOfrIy",9) == 2853220437) strcat(s, "j");
if (crc32("HMuofrJppu",10) == 717429550) strcat(s, "l");
if (crc32("RMFbKJlt",8) == 448459084) strcat(s, "I");
if (crc32("wcyjibBqDjUm",12) == 3514190441) strcat(s, "u");
if (crc32("CweKZLxN",8) == 1054022764) strcat(s, "C");
if (crc32("yHJKhu",6) == 4030812230) strcat(s, "t");
if (crc32("KVhcXMTI",8) == 3435726159) strcat(s, "i");
if (crc32("bbymcDGhg",9) == 1854664158) strcat(s, "D");
if (crc32("BucCa",5) == 327193835) strcat(s, "n");
if (crc32("gQoDLi",6) == 1801487024) strcat(s, "w");
if (crc32("wdNpnImyNd",10) == 4156279058) strcat(s, "i");
if (crc32("LivxHpqqsquTXl",14) == 3407313098) strcat(s, "P");
if (crc32("XCGEHZqJBLN",11) == 1403373552) strcat(s, "n");
    return s;
}

char *trustor_nouns() {
    char *s = calloc(8);
    if (crc32("mPHCKuBfTIkWdEo",15) == 3042625963) strcat(s, "t");
if (crc32("VzKcGuACS",9) == 435606033) strcat(s, "l");
if (crc32("CWwqLesnRJ",10) == 1622275926) strcat(s, "r");
if (crc32("NJmLydAraPfYVwm",15) == 2411507788) strcat(s, "A");
if (crc32("sXFiseL",7) == 16502370) strcat(s, "u");
if (crc32("zjnAiG",6) == 1054835698) strcat(s, "s");
if (crc32("KgQtNchrTzCDumL",15) == 670216269) strcat(s, "r");
if (crc32("fioMM",5) == 2555333889) strcat(s, "t");
if (crc32("imcwInI",7) == 268134957) strcat(s, "h");
if (crc32("YewXYloGqQq",11) == 1223694227) strcat(s, "o");
if (crc32("mFdMcKE",7) == 3176074054) strcat(s, "j");
if (crc32("FykcT",5) == 1643265194) strcat(s, "r");
    return s;
}

char *Augustinism_nouns() {
    char *s = calloc(12);
    if (crc32("bJUwMeJBhw",10) == 1338713069) strcat(s, "A");
if (crc32("USSfpOAg",8) == 3707554187) strcat(s, "u");
if (crc32("HoTTdhAwIbpEhL",14) == 2295002965) strcat(s, "O");
if (crc32("VQaZTlCQJvWFXKD",15) == 2959970854) strcat(s, "g");
if (crc32("XRzfFwjYGo",10) == 120275264) strcat(s, "u");
if (crc32("eFIvesffzffk",12) == 1165081121) strcat(s, "V");
if (crc32("TymSGGrfvjqDZ",13) == 3802659983) strcat(s, "s");
if (crc32("UMhoJOdBDXgn",12) == 3457952231) strcat(s, "t");
if (crc32("hTMPzicWgZbG",12) == 3686722770) strcat(s, "i");
if (crc32("PicqZAMFPOylh",13) == 3075200024) strcat(s, "n");
if (crc32("EnJuCHgIIzJO",12) == 2270765376) strcat(s, "P");
if (crc32("TFuCdCMC",8) == 3149114962) strcat(s, "i");
if (crc32("TTuYNgtHxVuM",12) == 1425482831) strcat(s, "s");
if (crc32("fYTbFD",6) == 222342570) strcat(s, "S");
if (crc32("VgltPyb",7) == 1106935277) strcat(s, "m");
    return s;
}

char *danio_nouns() {
    char *s = calloc(6);
    if (crc32("rHULbHyaKGGcSxF",15) == 3731144241) strcat(s, "U");
if (crc32("IycQDxyoyCNqyVs",15) == 1475456763) strcat(s, "d");
if (crc32("QUIOdSKhqH",10) == 2704040329) strcat(s, "a");
if (crc32("kycKyJR",7) == 2124713281) strcat(s, "n");
if (crc32("ielDakdqdQHHAx",14) == 811480610) strcat(s, "v");
if (crc32("FqskDRpuiBk",11) == 54977044) strcat(s, "i");
if (crc32("FtYqAvOrslvE",12) == 1659550161) strcat(s, "P");
if (crc32("PcliT",5) == 1314264956) strcat(s, "o");
    return s;
}

char *Kwang_nouns() {
    char *s = calloc(6);
    if (crc32("WvLQRyayhqu",11) == 452119871) strcat(s, "K");
if (crc32("hKJFmoERCAXLr",13) == 3162008845) strcat(s, "G");
if (crc32("PTpvuCgYCfWVbyB",15) == 2090500122) strcat(s, "w");
if (crc32("QwqbImAV",8) == 711875455) strcat(s, "g");
if (crc32("kTmIrdkPNSU",11) == 245233409) strcat(s, "a");
if (crc32("vhXLI",5) == 2135014315) strcat(s, "n");
if (crc32("rWbukEbDUBvGC",13) == 1932760746) strcat(s, "g");
    return s;
}

char *epiphora_nouns() {
    char *s = calloc(9);
    if (crc32("mnLii",5) == 2242427239) strcat(s, "e");
if (crc32("dBUcAhGEn",9) == 3127081021) strcat(s, "p");
if (crc32("KMzUwiuS",8) == 2139594240) strcat(s, "i");
if (crc32("HiIqyigG",8) == 2601760566) strcat(s, "h");
if (crc32("EboYiWJOCXtGvVb",15) == 2157159302) strcat(s, "p");
if (crc32("RKPlVVhy",8) == 2700113432) strcat(s, "h");
if (crc32("WUDLksZFj",9) == 3626359875) strcat(s, "h");
if (crc32("ujyOr",5) == 826384320) strcat(s, "o");
if (crc32("TObJECNEnh",10) == 3584063811) strcat(s, "r");
if (crc32("IIGoz",5) == 1388162717) strcat(s, "a");
    return s;
}

char *Bentinck_nouns() {
    char *s = calloc(9);
    if (crc32("waGKQUoZgEpPT",13) == 1337847987) strcat(s, "B");
if (crc32("CGmzglhbnOeYL",13) == 3434790294) strcat(s, "e");
if (crc32("AAPoHE",6) == 4201049994) strcat(s, "n");
if (crc32("gLGcOlL",7) == 2772654171) strcat(s, "n");
if (crc32("gOdyC",5) == 4005090533) strcat(s, "t");
if (crc32("ZmMFuN",6) == 2737875320) strcat(s, "t");
if (crc32("kEVMhZvjUY",10) == 4228385192) strcat(s, "b");
if (crc32("DdwJsNoKjYHqE",13) == 3243367849) strcat(s, "i");
if (crc32("ZSFAWUBiCqyP",12) == 1444800953) strcat(s, "Z");
if (crc32("ORNOsDKVKCoS",12) == 4130467216) strcat(s, "n");
if (crc32("wmVFfmW",7) == 545998221) strcat(s, "M");
if (crc32("bUCcsHqZsuVtdM",14) == 2985003207) strcat(s, "c");
if (crc32("mGJEErKFnGLCLC",14) == 1793682553) strcat(s, "k");
    return s;
}

char *spark_nouns() {
    char *s = calloc(6);
    if (crc32("eSSMlYLmot",10) == 253437261) strcat(s, "s");
if (crc32("hddajq",6) == 1926631599) strcat(s, "c");
if (crc32("SVvDGOTomQKdm",13) == 3515619651) strcat(s, "p");
if (crc32("yxUOgq",6) == 1117155013) strcat(s, "k");
if (crc32("YzORewgliow",11) == 1635688948) strcat(s, "a");
if (crc32("QBugjAALQW",10) == 1587664093) strcat(s, "A");
if (crc32("hGYbNupisuFBPOK",15) == 95261237) strcat(s, "r");
if (crc32("RMUfMlKwHALecoR",15) == 2911845211) strcat(s, "Y");
if (crc32("tRBeNoXvyaf",11) == 3628353027) strcat(s, "k");
    return s;
}

char *endeavourer_nouns() {
    char *s = calloc(12);
    if (crc32("qubJfOimnU",10) == 1293820143) strcat(s, "n");
if (crc32("yrxtZVA",7) == 60316219) strcat(s, "e");
if (crc32("aLBBWbpatIbvdGh",15) == 3100976976) strcat(s, "J");
if (crc32("ZulIl",5) == 3423771554) strcat(s, "n");
if (crc32("perGFMEqHcEHiqA",15) == 1925051656) strcat(s, "w");
if (crc32("emxTGeoZlrM",11) == 3336853246) strcat(s, "d");
if (crc32("btARDh",6) == 2680096223) strcat(s, "r");
if (crc32("igHFeK",6) == 1712902710) strcat(s, "e");
if (crc32("HLvGaafq",8) == 2405343630) strcat(s, "m");
if (crc32("CXEbTZ",6) == 2191379088) strcat(s, "a");
if (crc32("JwLnkVTBJx",10) == 2204680308) strcat(s, "M");
if (crc32("yUlYunIiu",9) == 3246976945) strcat(s, "v");
if (crc32("xAwiHzsfBJtaQyN",15) == 1417531088) strcat(s, "c");
if (crc32("JKqxfDWgVplgo",13) == 139992918) strcat(s, "o");
if (crc32("ydquwr",6) == 3688962673) strcat(s, "K");
if (crc32("OtAiItfuzvFyEVz",15) == 2288710177) strcat(s, "u");
if (crc32("mlTklBEogRdv",12) == 3004822789) strcat(s, "n");
if (crc32("YihDdCvXvWWQyo",14) == 2470803925) strcat(s, "r");
if (crc32("aNcuyfxeYKUYho",14) == 1066414719) strcat(s, "e");
if (crc32("ekxLTJS",7) == 1198495476) strcat(s, "s");
if (crc32("DAJPU",5) == 2488190709) strcat(s, "r");
    return s;
}

char *unimaginableness_nouns() {
    char *s = calloc(17);
    if (crc32("yixUEL",6) == 1450911027) strcat(s, "L");
if (crc32("evwPj",5) == 2680576935) strcat(s, "u");
if (crc32("Adftdlx",7) == 3323127680) strcat(s, "n");
if (crc32("sIjWaqDuT",9) == 431275482) strcat(s, "i");
if (crc32("nxFiv",5) == 937771991) strcat(s, "m");
if (crc32("KdmasqJl",8) == 1064315285) strcat(s, "l");
if (crc32("BJnJglvNiCkbKf",14) == 3571316997) strcat(s, "a");
if (crc32("BGNfnZDfqKyL",12) == 424708202) strcat(s, "g");
if (crc32("yCKuPwp",7) == 1112914703) strcat(s, "i");
if (crc32("oyyPRHM",7) == 388352087) strcat(s, "e");
if (crc32("OfpFkqUg",8) == 208075088) strcat(s, "n");
if (crc32("BmEMQvMwQa",10) == 2161970427) strcat(s, "a");
if (crc32("ckkCIyLxNqbjZlF",15) == 968910470) strcat(s, "y");
if (crc32("UOpQyYwKQJFSq",13) == 2561817824) strcat(s, "b");
if (crc32("vgwLFjFDb",9) == 1687554170) strcat(s, "P");
if (crc32("DQqpLplZVydJ",12) == 2780397369) strcat(s, "l");
if (crc32("fSKUulIqW",9) == 4097097161) strcat(s, "e");
if (crc32("vXMzAMd",7) == 1015262276) strcat(s, "y");
if (crc32("ujLaFzOxLNXhUIN",15) == 327868732) strcat(s, "n");
if (crc32("zDVKurltJKsebYC",15) == 833861545) strcat(s, "B");
if (crc32("UWsNiGvrLMtLrmz",15) == 375341746) strcat(s, "e");
if (crc32("ZnvJluFp",8) == 692719093) strcat(s, "y");
if (crc32("ZUyuufskbS",10) == 2903126974) strcat(s, "s");
if (crc32("YhgXRXrAoLYrZc",14) == 4227715353) strcat(s, "s");
    return s;
}

char *Bme_nouns() {
    char *s = calloc(4);
    if (crc32("uxbHPLXN",8) == 3093218808) strcat(s, "I");
if (crc32("iMKPGJlwMRpqQnQ",15) == 3714918982) strcat(s, "B");
if (crc32("bHJMHK",6) == 1002144054) strcat(s, "W");
if (crc32("zdwSz",5) == 2986116935) strcat(s, "m");
if (crc32("UYBqEPJ",7) == 1817392752) strcat(s, "e");
    return s;
}

char *Fayina_nouns() {
    char *s = calloc(7);
    if (crc32("mSZzKdGPobdav",13) == 4083394099) strcat(s, "F");
if (crc32("OETGddik",8) == 1806037208) strcat(s, "a");
if (crc32("atTBH",5) == 3117556083) strcat(s, "X");
if (crc32("sMXYuv",6) == 451750396) strcat(s, "y");
if (crc32("tSuvWtqQGC",10) == 3476454932) strcat(s, "i");
if (crc32("faTWqIiNgpM",11) == 2062895883) strcat(s, "n");
if (crc32("PSOCGbGtwpFCY",13) == 3644718346) strcat(s, "a");
    return s;
}

char *rheumatology_nouns() {
    char *s = calloc(13);
    if (crc32("yQqebWQRyFn",11) == 4180802167) strcat(s, "r");
if (crc32("EVDnGT",6) == 1056061629) strcat(s, "y");
if (crc32("wuUbcfIKXSTWR",13) == 2776033448) strcat(s, "h");
if (crc32("ElYQOJfgLz",10) == 3171011020) strcat(s, "e");
if (crc32("eeAcckkyji",10) == 1140447361) strcat(s, "F");
if (crc32("ROxcAGqcFQus",12) == 1550263286) strcat(s, "u");
if (crc32("Vflxe",5) == 4107219396) strcat(s, "m");
if (crc32("XtmpZ",5) == 956379175) strcat(s, "E");
if (crc32("NaTGvOrCOeaKVWX",15) == 2523315463) strcat(s, "a");
if (crc32("PaVlD",5) == 2908969872) strcat(s, "t");
if (crc32("iIjTSxFf",8) == 4185026299) strcat(s, "M");
if (crc32("HLFSUQOPce",10) == 779965222) strcat(s, "o");
if (crc32("uxHdAw",6) == 368189226) strcat(s, "l");
if (crc32("AXOQw",5) == 3138380766) strcat(s, "o");
if (crc32("ojRDjWBYWfxyDQo",15) == 2029389017) strcat(s, "g");
if (crc32("tnligYdKptRze",13) == 2285518456) strcat(s, "W");
if (crc32("uVCaTqHZGHOrx",13) == 330378158) strcat(s, "y");
    return s;
}

char *forcer_nouns() {
    char *s = calloc(7);
    if (crc32("TYIdCVvnPCmjv",13) == 205881711) strcat(s, "f");
if (crc32("vRxhgntwhTwrUQ",14) == 2547498973) strcat(s, "o");
if (crc32("AMuDF",5) == 150308349) strcat(s, "W");
if (crc32("UXDpxtwSbOdDFQ",14) == 4137908001) strcat(s, "r");
if (crc32("bsUqxWHU",8) == 1447309842) strcat(s, "c");
if (crc32("DNIuBgDh",8) == 2675302369) strcat(s, "j");
if (crc32("JLgGWmHiBka",11) == 1940646528) strcat(s, "e");
if (crc32("WeqKax",6) == 2096064481) strcat(s, "r");
    return s;
}

char *crimmer_nouns() {
    char *s = calloc(8);
    if (crc32("AquhrfQiRSZX",12) == 795741504) strcat(s, "i");
if (crc32("JJesClYsdqjC",12) == 2227255610) strcat(s, "c");
if (crc32("EKdRQOyFHCJ",11) == 3386231789) strcat(s, "s");
if (crc32("wreuD",5) == 553886244) strcat(s, "r");
if (crc32("zZyckePHb",9) == 2187005111) strcat(s, "E");
if (crc32("ZxVKI",5) == 1857459708) strcat(s, "i");
if (crc32("uXjnY",5) == 2233842813) strcat(s, "w");
if (crc32("PxeWsOdvJsk",11) == 497504673) strcat(s, "m");
if (crc32("SvOHFrkGbryv",12) == 2977484729) strcat(s, "m");
if (crc32("GhfsVh",6) == 2772884550) strcat(s, "t");
if (crc32("YLpQndziHK",10) == 1941509265) strcat(s, "e");
if (crc32("zVKhmJhhUsvBIaX",15) == 3104005936) strcat(s, "P");
if (crc32("VvjtP",5) == 1516081606) strcat(s, "r");
    return s;
}

char *q_nouns() {
    char *s = calloc(2);
    if (crc32("fsycPyAH",8) == 1743882696) strcat(s, "w");
if (crc32("ONBlo",5) == 1119815) strcat(s, "q");
    return s;
}

char *Isabella_nouns() {
    char *s = calloc(9);
    if (crc32("CKSHQYiRd",9) == 109175940) strcat(s, "c");
if (crc32("oEkoyHDZ",8) == 1956522272) strcat(s, "I");
if (crc32("cXvIAZ",6) == 491221831) strcat(s, "L");
if (crc32("JayGbfLYhLF",11) == 1915231084) strcat(s, "s");
if (crc32("SjlLbEx",7) == 2420478476) strcat(s, "q");
if (crc32("VnNrWQLdybrZu",13) == 3693660855) strcat(s, "a");
if (crc32("CijJhyGdEWlqCr",14) == 1025318548) strcat(s, "k");
if (crc32("iToXhxctrpe",11) == 3582819842) strcat(s, "b");
if (crc32("CnBpPzWQ",8) == 3641061026) strcat(s, "e");
if (crc32("CCxvgR",6) == 3030314201) strcat(s, "u");
if (crc32("NeuNkhUsqluNY",13) == 1304343695) strcat(s, "l");
if (crc32("DOnZSKxhhe",10) == 1583019032) strcat(s, "c");
if (crc32("gIiozKbCX",9) == 93677728) strcat(s, "l");
if (crc32("oUbrrSJYwPOiSEl",15) == 3591095478) strcat(s, "D");
if (crc32("qJrnTNoesPueh",13) == 2448050221) strcat(s, "a");
    return s;
}

char *Vivien_nouns() {
    char *s = calloc(7);
    if (crc32("RgVnyufsU",9) == 1727829872) strcat(s, "J");
if (crc32("OlPvQm",6) == 417130982) strcat(s, "V");
if (crc32("FBlJREOKcOYkdx",14) == 1153723989) strcat(s, "j");
if (crc32("TZMMwCY",7) == 3064180240) strcat(s, "i");
if (crc32("meMqanuVLdh",11) == 386946908) strcat(s, "G");
if (crc32("RKQWlb",6) == 2937132330) strcat(s, "v");
if (crc32("NLrFIXeAoAZhN",13) == 833185025) strcat(s, "Q");
if (crc32("UhbOsHxY",8) == 2909833252) strcat(s, "i");
if (crc32("WQyeXpbSySKdYMh",15) == 1703501854) strcat(s, "e");
if (crc32("WDnJSjiqTQSr",12) == 3365867597) strcat(s, "n");
    return s;
}

char *filecard_nouns() {
    char *s = calloc(9);
    if (crc32("hNgaNfCNxBWMIY",14) == 1652721055) strcat(s, "n");
if (crc32("ZmyqTtvZtYVqwR",14) == 3770880303) strcat(s, "f");
if (crc32("BvUMIAHFSxXx",12) == 2383080441) strcat(s, "i");
if (crc32("ZAYDnROPcHWT",12) == 2669466390) strcat(s, "I");
if (crc32("XIYzltMCMs",10) == 3709097863) strcat(s, "l");
if (crc32("hrpEGAr",7) == 343657703) strcat(s, "e");
if (crc32("ahCBuTlPDYsX",12) == 2918807743) strcat(s, "y");
if (crc32("IYsWvpVYLxE",11) == 139632157) strcat(s, "c");
if (crc32("QYDRZ",5) == 3194613533) strcat(s, "d");
if (crc32("EwereWgBkaWQaDb",15) == 2658579354) strcat(s, "a");
if (crc32("FsLeXqooTF",10) == 1534394425) strcat(s, "r");
if (crc32("obtkEAzutoeTndV",15) == 3991505586) strcat(s, "d");
    return s;
}

char *landaulet_nouns() {
    char *s = calloc(10);
    if (crc32("aDwlTuDmmVQ",11) == 650250084) strcat(s, "l");
if (crc32("MNuwkFJzyOyhc",13) == 3647679277) strcat(s, "a");
if (crc32("tOfSFBeijQaY",12) == 700865776) strcat(s, "n");
if (crc32("ufARjhULiQkW",12) == 853897558) strcat(s, "d");
if (crc32("vIOubrPkuPFhcPz",15) == 2996258963) strcat(s, "s");
if (crc32("BjYcXiUW",8) == 2939414356) strcat(s, "a");
if (crc32("KPmKKyqObu",10) == 3034363965) strcat(s, "u");
if (crc32("AMSgfcVQFGxTCu",14) == 1883913465) strcat(s, "g");
if (crc32("hMcByOEyaX",10) == 2611339467) strcat(s, "l");
if (crc32("RkxXY",5) == 1390484560) strcat(s, "e");
if (crc32("VkmyQHnAA",9) == 3255354376) strcat(s, "T");
if (crc32("FUMeApL",7) == 1801588234) strcat(s, "t");
    return s;
}

char *reallotment_nouns() {
    char *s = calloc(12);
    if (crc32("VxKHOvXzDlPPXp",14) == 2746699770) strcat(s, "L");
if (crc32("iQviHhlOmGFVq",13) == 375400982) strcat(s, "r");
if (crc32("jYoXieZ",7) == 3432770089) strcat(s, "h");
if (crc32("avGXNgZmIvw",11) == 1340067492) strcat(s, "e");
if (crc32("EEFbKJJYYlEaQWj",15) == 2337483362) strcat(s, "r");
if (crc32("ExpyqAfp",8) == 3846283200) strcat(s, "a");
if (crc32("jJTLHFUCpnyTUEQ",15) == 1759538599) strcat(s, "l");
if (crc32("VfBCLkB",7) == 1500820078) strcat(s, "P");
if (crc32("ZnfLczpIJtFVNd",14) == 3117110977) strcat(s, "l");
if (crc32("QQuyDwsiMbdfnZ",14) == 1638770003) strcat(s, "o");
if (crc32("OmqJkiMkDxvzlBD",15) == 3841771909) strcat(s, "t");
if (crc32("epLWwNYpmCrXh",13) == 3546966042) strcat(s, "H");
if (crc32("GTkKGoKITfKppN",14) == 3982489856) strcat(s, "m");
if (crc32("ivEpjogbZaSj",12) == 1259033799) strcat(s, "e");
if (crc32("xPuGNaKXpnu",11) == 1996029560) strcat(s, "n");
if (crc32("VaaVVZWdnC",10) == 1607312293) strcat(s, "t");
if (crc32("xMcBhmWcuBgFiya",15) == 3953059146) strcat(s, "t");
    return s;
}

char *nondisturbance_nouns() {
    char *s = calloc(15);
    if (crc32("qgzJFTUgvoaWO",13) == 4134158822) strcat(s, "n");
if (crc32("FCthuifnLNO",11) == 596582105) strcat(s, "o");
if (crc32("ykDXJPweGs",10) == 3525131505) strcat(s, "n");
if (crc32("UWXWlyY",7) == 238324635) strcat(s, "d");
if (crc32("ihFAVZrpioCg",12) == 3632749372) strcat(s, "i");
if (crc32("PZWuuQjEokedL",13) == 85885470) strcat(s, "s");
if (crc32("IfQvvDMVYQU",11) == 345202031) strcat(s, "F");
if (crc32("dhYpKqaICB",10) == 1682374277) strcat(s, "t");
if (crc32("cDVEVwFUIc",10) == 1910604949) strcat(s, "s");
if (crc32("PuAellrpB",9) == 117710219) strcat(s, "u");
if (crc32("jocKqD",6) == 285645553) strcat(s, "r");
if (crc32("vrfPSTlV",8) == 1796821946) strcat(s, "b");
if (crc32("aARFGEEzgc",10) == 2910568802) strcat(s, "a");
if (crc32("GtZPMsGem",9) == 2766348123) strcat(s, "W");
if (crc32("ndQxNoNsJqL",11) == 3962134563) strcat(s, "n");
if (crc32("gADtRJeyPXFXukX",15) == 788695915) strcat(s, "c");
if (crc32("ZPPGEotDhsURLsb",15) == 2841782356) strcat(s, "e");
    return s;
}


char *(*nouns_list[4096])() = {
letdown_nouns,
Matthew_nouns,
Titanomachy_nouns,
Cav_nouns,
Kiwanis_nouns,
ia_nouns,
doorcase_nouns,
enchaonement_nouns,
poster_nouns,
caution_nouns,
Conlee_nouns,
tabulator_nouns,
taskwork_nouns,
entrep_nouns,
MP_nouns,
Maitund_nouns,
Haggai_nouns,
whitewood_nouns,
subsect_nouns,
odontalgia_nouns,
dell_nouns,
infinitive_nouns,
redistribution_nouns,
potash_nouns,
ornis_nouns,
reenlightenment_nouns,
peacock_nouns,
nodule_nouns,
BMS_nouns,
Cracow_nouns,
Danna_nouns,
ioniser_nouns,
Thomasina_nouns,
Groos_nouns,
condescendent_nouns,
woolsack_nouns,
diploae_nouns,
courtroom_nouns,
Dodi_nouns,
ninetyeight_nouns,
Octavla_nouns,
Zelazny_nouns,
goral_nouns,
Rolfe_nouns,
tensity_nouns,
esotericist_nouns,
detestableness_nouns,
tamboura_nouns,
whispering_nouns,
blepharitis_nouns,
subpastor_nouns,
Mapel_nouns,
monoecism_nouns,
sarangi_nouns,
subclass_nouns,
rapacity_nouns,
Capps_nouns,
pentacle_nouns,
USR_nouns,
AIME_nouns,
outfighting_nouns,
eisegesis_nouns,
Verdha_nouns,
mystagogy_nouns,
hypertenseness_nouns,
Huysmans_nouns,
Prisilla_nouns,
Romansh_nouns,
Kubango_nouns,
misappellation_nouns,
disannuller_nouns,
Hades_nouns,
ESRO_nouns,
Lucio_nouns,
courdinateness_nouns,
Ljubljana_nouns,
framboise_nouns,
Azerbaijan_nouns,
Cnidus_nouns,
Pulcheria_nouns,
GCR_nouns,
buttermilk_nouns,
subtext_nouns,
lard_nouns,
phiz_nouns,
Verge_nouns,
eaglet_nouns,
forecourt_nouns,
superpublicity_nouns,
Crispin_nouns,
title_nouns,
Sappho_nouns,
renewer_nouns,
pyx_nouns,
Kerbela_nouns,
Ruby_nouns,
goofup_nouns,
LP_nouns,
cicatrix_nouns,
archpriesthood_nouns,
Gayomart_nouns,
baffler_nouns,
simba_nouns,
Kellby_nouns,
legator_nouns,
chantership_nouns,
Kantor_nouns,
toluene_nouns,
Nolly_nouns,
juba_nouns,
Cocalus_nouns,
ephorate_nouns,
schiffli_nouns,
Malathion_nouns,
gasifier_nouns,
abandonee_nouns,
Asperges_nouns,
Oisin_nouns,
Eatonton_nouns,
Miles_nouns,
Stokowski_nouns,
Chiengmai_nouns,
twite_nouns,
UNRRA_nouns,
roundup_nouns,
Hluchy_nouns,
underheaven_nouns,
Mauro_nouns,
Ensoll_nouns,
Mufti_nouns,
antidemocrat_nouns,
springtail_nouns,
prediscernment_nouns,
sultanship_nouns,
progressism_nouns,
Amal_nouns,
AV_nouns,
Onega_nouns,
crossbill_nouns,
docket_nouns,
Rhodia_nouns,
fleet_nouns,
Archaimbaud_nouns,
Davys_nouns,
Schneiderman_nouns,
Manard_nouns,
hypercivilization_nouns,
Agee_nouns,
Islean_nouns,
Fisken_nouns,
longevity_nouns,
Wystand_nouns,
Oriana_nouns,
barde_nouns,
mammock_nouns,
Pechenga_nouns,
bilestone_nouns,
Ferna_nouns,
abjuration_nouns,
Sug_nouns,
Cymry_nouns,
pace_nouns,
Townie_nouns,
supercombination_nouns,
tenace_nouns,
handlebar_nouns,
kiotomy_nouns,
respect_nouns,
Siegler_nouns,
gummite_nouns,
diminishableness_nouns,
Timothea_nouns,
snakehead_nouns,
brickfielder_nouns,
dal_nouns,
Hellenist_nouns,
festoonery_nouns,
glycogenase_nouns,
skiagraph_nouns,
Yokum_nouns,
coper_nouns,
jean_nouns,
toreador_nouns,
Plasticine_nouns,
amylase_nouns,
pretariff_nouns,
gunning_nouns,
Pelson_nouns,
interdifferentiation_nouns,
carpal_nouns,
semipiousness_nouns,
Ithomatas_nouns,
artisanship_nouns,
Nec_nouns,
fylfot_nouns,
Geneva_nouns,
Enyo_nouns,
sammy_nouns,
astron_nouns,
photoheliography_nouns,
Garwood_nouns,
Thamos_nouns,
Cerelia_nouns,
azulejo_nouns,
foremast_nouns,
excud_nouns,
Roselane_nouns,
chiropter_nouns,
keyhole_nouns,
AntiMason_nouns,
Nicholas_nouns,
flowage_nouns,
fertilizin_nouns,
Socha_nouns,
Phaye_nouns,
Larianna_nouns,
showpiece_nouns,
Kilimanjaro_nouns,
stops_nouns,
Riti_nouns,
irritability_nouns,
turnup_nouns,
prison_nouns,
Blancanus_nouns,
sourwood_nouns,
wahine_nouns,
adventitia_nouns,
Stralsund_nouns,
formboard_nouns,
bristliness_nouns,
Crataeis_nouns,
tob_nouns,
hierology_nouns,
irone_nouns,
whimperer_nouns,
stackyard_nouns,
Frank_nouns,
Farkas_nouns,
disuse_nouns,
impaler_nouns,
selfwrong_nouns,
Tillamook_nouns,
courtmartial_nouns,
Blossom_nouns,
boarishness_nouns,
Exod_nouns,
pigg_nouns,
mistletoe_nouns,
Kiruna_nouns,
barleycorn_nouns,
uncontemptibleness_nouns,
Fabriane_nouns,
vim_nouns,
delater_nouns,
fanleaf_nouns,
mealworm_nouns,
Fangio_nouns,
Hanzelin_nouns,
petrolatum_nouns,
aidedecamp_nouns,
unitedness_nouns,
aplite_nouns,
Pisanello_nouns,
Cechy_nouns,
armary_nouns,
Eleanora_nouns,
Vitia_nouns,
Ramses_nouns,
birdsfoot_nouns,
Haddonfield_nouns,
climatology_nouns,
soundboard_nouns,
fart_nouns,
aileron_nouns,
indoctrinator_nouns,
hellbroth_nouns,
Bournemouth_nouns,
Nyaya_nouns,
pancreatectomize_nouns,
esoterism_nouns,
Jed_nouns,
equivoque_nouns,
Gallegos_nouns,
leno_nouns,
saboteur_nouns,
linenfold_nouns,
dentition_nouns,
Laomedon_nouns,
prologus_nouns,
croquignole_nouns,
uranide_nouns,
profanity_nouns,
bleachability_nouns,
nonexpansiveness_nouns,
scored_nouns,
alcheringa_nouns,
unassertiveness_nouns,
verditer_nouns,
bagman_nouns,
coalfield_nouns,
typecaster_nouns,
Lectra_nouns,
catastasis_nouns,
expediter_nouns,
Chwangtse_nouns,
subantiqueness_nouns,
Elbring_nouns,
eyecup_nouns,
cello_nouns,
storytelling_nouns,
computerization_nouns,
gravimetry_nouns,
logistic_nouns,
realtor_nouns,
Shazar_nouns,
Iphthime_nouns,
ironbark_nouns,
Poucher_nouns,
Newfoundland_nouns,
geostrategy_nouns,
amygdala_nouns,
hankeypankey_nouns,
guildship_nouns,
Eliseo_nouns,
delusterant_nouns,
preentailment_nouns,
tackling_nouns,
goodness_nouns,
purpleheart_nouns,
carillon_nouns,
Mert_nouns,
woundwort_nouns,
Daniala_nouns,
myelin_nouns,
civilizedness_nouns,
schrank_nouns,
visor_nouns,
barr_nouns,
conceivability_nouns,
leisure_nouns,
Seigel_nouns,
nonimpressionability_nouns,
spawn_nouns,
erectility_nouns,
assignation_nouns,
publishment_nouns,
redbreast_nouns,
sieur_nouns,
mutchkin_nouns,
Hayashi_nouns,
Capriote_nouns,
flores_nouns,
Rabah_nouns,
hyperconservatism_nouns,
Paola_nouns,
Arezzo_nouns,
attestator_nouns,
Hyacinthia_nouns,
Ramachandra_nouns,
desiccator_nouns,
disapproval_nouns,
Kavaphis_nouns,
prerecognition_nouns,
Danuloff_nouns,
preexposition_nouns,
Guatemala_nouns,
indefatigableness_nouns,
undyingness_nouns,
Pommard_nouns,
scarves_nouns,
Lourie_nouns,
dishcross_nouns,
previgilance_nouns,
Div_nouns,
ascent_nouns,
Elul_nouns,
presavagery_nouns,
sesterce_nouns,
uninhabitability_nouns,
Crystie_nouns,
Johm_nouns,
karoo_nouns,
goofoff_nouns,
Npaktos_nouns,
Adelbert_nouns,
notecase_nouns,
micky_nouns,
nondetention_nouns,
Curitiba_nouns,
prophet_nouns,
truster_nouns,
phonoreception_nouns,
nonsecludedness_nouns,
Lexine_nouns,
histrionics_nouns,
apriority_nouns,
thema_nouns,
lectureship_nouns,
schoolie_nouns,
codfish_nouns,
phonotactics_nouns,
taxidermist_nouns,
roundel_nouns,
wording_nouns,
featherbrain_nouns,
aluminum_nouns,
quoit_nouns,
note_nouns,
Lenape_nouns,
bra_nouns,
Flam_nouns,
consciousness_nouns,
Rawalpindi_nouns,
Massimiliano_nouns,
helminthiasis_nouns,
missioner_nouns,
Hagecius_nouns,
rimester_nouns,
swager_nouns,
reviewability_nouns,
oeuvre_nouns,
muskallonge_nouns,
daybeacon_nouns,
teenybopper_nouns,
abstractionist_nouns,
Lannie_nouns,
grafter_nouns,
Illyria_nouns,
detail_nouns,
Gerti_nouns,
Maggiore_nouns,
Kempis_nouns,
postern_nouns,
enameler_nouns,
McCormack_nouns,
gamer_nouns,
samekh_nouns,
content_nouns,
bull_nouns,
Zobkiw_nouns,
interrobang_nouns,
monist_nouns,
azine_nouns,
Leonardi_nouns,
gegenion_nouns,
AEF_nouns,
Dacron_nouns,
Ivy_nouns,
mobility_nouns,
bhaktimarga_nouns,
anatman_nouns,
tanguile_nouns,
demilitarization_nouns,
EQ_nouns,
Silvis_nouns,
relator_nouns,
aeolipile_nouns,
Rawdon_nouns,
preinterview_nouns,
strix_nouns,
baccalaureate_nouns,
Couaism_nouns,
Carilla_nouns,
Kirsteni_nouns,
upkeep_nouns,
placename_nouns,
evenfall_nouns,
Kunlun_nouns,
Wallis_nouns,
willingness_nouns,
Nathalia_nouns,
unfavourableness_nouns,
Arliss_nouns,
vaguio_nouns,
nonobjection_nouns,
patisserie_nouns,
punster_nouns,
monocracy_nouns,
nonvenousness_nouns,
wapentake_nouns,
strongroom_nouns,
seeker_nouns,
Jerrie_nouns,
windfall_nouns,
overliberality_nouns,
Portwin_nouns,
titi_nouns,
Laktasic_nouns,
fogram_nouns,
Apollonius_nouns,
corsage_nouns,
Pozna_nouns,
Wrexham_nouns,
Hylas_nouns,
threedecker_nouns,
Bedell_nouns,
arithmancy_nouns,
olm_nouns,
hacek_nouns,
Biro_nouns,
Coucher_nouns,
Oozys_nouns,
unriotousness_nouns,
Knigsberg_nouns,
dripolator_nouns,
unselfrighteousness_nouns,
resistance_nouns,
Westworth_nouns,
protochordate_nouns,
damselfly_nouns,
straw_nouns,
Paintsville_nouns,
wrinkledness_nouns,
titration_nouns,
astromancer_nouns,
interdivision_nouns,
intender_nouns,
squirrelfish_nouns,
quinoid_nouns,
Abelard_nouns,
superdemand_nouns,
hedgehog_nouns,
BSS_nouns,
couperativeness_nouns,
houndfish_nouns,
Lester_nouns,
kneader_nouns,
Quiteris_nouns,
Themiste_nouns,
rasbora_nouns,
lopseed_nouns,
Lycotherses_nouns,
dolour_nouns,
capaciousness_nouns,
earthpea_nouns,
troopship_nouns,
burka_nouns,
Arni_nouns,
soling_nouns,
commie_nouns,
hackie_nouns,
cuspid_nouns,
o_nouns,
Dorelle_nouns,
oversorrowfulness_nouns,
superoptimist_nouns,
supercandidness_nouns,
Tallassee_nouns,
photoperiodism_nouns,
minstrelsy_nouns,
poundforce_nouns,
preconcession_nouns,
inactiveness_nouns,
deerstalking_nouns,
microampere_nouns,
Phaeacia_nouns,
superextremity_nouns,
Lingayat_nouns,
thioantimonate_nouns,
Josephscoat_nouns,
troubadour_nouns,
rapine_nouns,
directrix_nouns,
Cleothera_nouns,
unsolidarity_nouns,
wornoutness_nouns,
Dunseath_nouns,
Lager_nouns,
Bonney_nouns,
fortyone_nouns,
ergate_nouns,
nympholepsy_nouns,
Caughey_nouns,
tsk_nouns,
friendlessness_nouns,
Dreyer_nouns,
vehiculum_nouns,
Sherrer_nouns,
Witcher_nouns,
chile_nouns,
theology_nouns,
winglet_nouns,
stitchwort_nouns,
Perris_nouns,
unremittence_nouns,
Car_nouns,
ganglion_nouns,
instrumentalism_nouns,
mowing_nouns,
Semitics_nouns,
Rodd_nouns,
rapparee_nouns,
Ahmadiya_nouns,
utility_nouns,
Kittanning_nouns,
Stodder_nouns,
Elbart_nouns,
dogie_nouns,
overruler_nouns,
farcy_nouns,
Nerites_nouns,
LV_nouns,
Valenta_nouns,
Sergeant_nouns,
lice_nouns,
refl_nouns,
Reggi_nouns,
aliyah_nouns,
dolefulness_nouns,
Arlynne_nouns,
nonferventness_nouns,
nonincrease_nouns,
rimstone_nouns,
Pound_nouns,
Gearard_nouns,
shrapnel_nouns,
retreatingness_nouns,
tacitness_nouns,
Hellen_nouns,
Gymnodinium_nouns,
eme_nouns,
Dotty_nouns,
Aubervilliers_nouns,
Kirkpatrick_nouns,
scooper_nouns,
Sleswick_nouns,
ecumenicalism_nouns,
Amargo_nouns,
Maximilian_nouns,
Weinshienk_nouns,
psychedelia_nouns,
Leggat_nouns,
Banting_nouns,
hydrargyrism_nouns,
Scotia_nouns,
secularity_nouns,
postImpressionist_nouns,
indris_nouns,
homogeny_nouns,
Muna_nouns,
trimotor_nouns,
Ronel_nouns,
Garate_nouns,
larruper_nouns,
Huldah_nouns,
Punxsutawney_nouns,
remembrancer_nouns,
theine_nouns,
plait_nouns,
rampion_nouns,
carmine_nouns,
charades_nouns,
harambee_nouns,
leucocyte_nouns,
Cati_nouns,
Hereford_nouns,
Lothar_nouns,
Birrell_nouns,
nondevelopment_nouns,
synthesization_nouns,
amigo_nouns,
devocalization_nouns,
uncooperativeness_nouns,
Kropotkin_nouns,
publicist_nouns,
Prochoras_nouns,
dialectology_nouns,
Sarette_nouns,
Bantam_nouns,
fascist_nouns,
kike_nouns,
hedgerow_nouns,
Mahican_nouns,
Himerus_nouns,
perspicuousness_nouns,
Vardon_nouns,
tearlessness_nouns,
stoup_nouns,
overcircumspection_nouns,
crouton_nouns,
franker_nouns,
untragicalness_nouns,
iconographer_nouns,
philter_nouns,
overcapitalisation_nouns,
uranite_nouns,
urbanisation_nouns,
hypothallus_nouns,
Avilla_nouns,
carburation_nouns,
kernos_nouns,
federacy_nouns,
rudenture_nouns,
circuitousness_nouns,
untumidness_nouns,
midst_nouns,
Weywadt_nouns,
loyalty_nouns,
Tarija_nouns,
mermaid_nouns,
Gi_nouns,
nonnegativity_nouns,
Ingleborough_nouns,
Shawn_nouns,
Greenville_nouns,
pheasant_nouns,
Sandye_nouns,
Steger_nouns,
plasmolysis_nouns,
Suevian_nouns,
wharve_nouns,
Broder_nouns,
Madurai_nouns,
Monteverdi_nouns,
pul_nouns,
Ikkela_nouns,
Francie_nouns,
overfierceness_nouns,
Bahawalpur_nouns,
SaintOuen_nouns,
corrivalry_nouns,
oxazine_nouns,
Bruges_nouns,
Greuze_nouns,
bight_nouns,
overdelicateness_nouns,
skerry_nouns,
chloroguanide_nouns,
superobligation_nouns,
emery_nouns,
Alurd_nouns,
goaltender_nouns,
Bruant_nouns,
hypoderma_nouns,
pentangle_nouns,
toucanet_nouns,
Folly_nouns,
Megara_nouns,
histiocyte_nouns,
Abby_nouns,
Meghan_nouns,
presentation_nouns,
Myrtie_nouns,
specialist_nouns,
horseleech_nouns,
autoharp_nouns,
PCeltic_nouns,
greenhead_nouns,
trickortreater_nouns,
Cauvery_nouns,
peng_nouns,
Sampson_nouns,
hypoglycaemia_nouns,
chateau_nouns,
Chester_nouns,
prehension_nouns,
peterman_nouns,
Adriano_nouns,
imprecation_nouns,
Kabyle_nouns,
wordbook_nouns,
Carlin_nouns,
CPM_nouns,
thunderhead_nouns,
Olivier_nouns,
badness_nouns,
populariser_nouns,
Donal_nouns,
digitoxin_nouns,
excipulum_nouns,
rabal_nouns,
Dongola_nouns,
Pune_nouns,
Laure_nouns,
fallowness_nouns,
Fnen_nouns,
telephonograph_nouns,
Citlaltpetl_nouns,
Otis_nouns,
Chura_nouns,
Sucaryl_nouns,
sculptress_nouns,
interrepulsion_nouns,
Ebn_nouns,
precandidature_nouns,
Shewchuk_nouns,
BArchE_nouns,
cursor_nouns,
inosculation_nouns,
Cristoforo_nouns,
privet_nouns,
raspingness_nouns,
phocomelia_nouns,
Rintoul_nouns,
Crotone_nouns,
KuKlux_nouns,
Liaoning_nouns,
Gutenberg_nouns,
wharfinger_nouns,
butler_nouns,
showplace_nouns,
lefty_nouns,
Mongolianism_nouns,
strangles_nouns,
Alcmaon_nouns,
draughter_nouns,
Whang_nouns,
summability_nouns,
flyby_nouns,
djebel_nouns,
postremogeniture_nouns,
halfpeck_nouns,
Terah_nouns,
fetich_nouns,
paling_nouns,
Bora_nouns,
Mbandaka_nouns,
Kesteven_nouns,
stroboscope_nouns,
Delmer_nouns,
vertebra_nouns,
bouchon_nouns,
Sylvanus_nouns,
sheading_nouns,
immensurability_nouns,
Gillray_nouns,
airlift_nouns,
cacogenics_nouns,
Cern_nouns,
toxophily_nouns,
blinks_nouns,
nonfamily_nouns,
bouldering_nouns,
unchangingness_nouns,
advocation_nouns,
Macnair_nouns,
Buzz_nouns,
CAVU_nouns,
Aragats_nouns,
Capt_nouns,
Newhaven_nouns,
N_nouns,
Roche_nouns,
permeability_nouns,
Islamite_nouns,
restorableness_nouns,
Soho_nouns,
beam_nouns,
MNS_nouns,
milliangstrom_nouns,
Bowers_nouns,
Baptista_nouns,
putrefaction_nouns,
premorality_nouns,
Bechuanaland_nouns,
Harappa_nouns,
Zambezi_nouns,
Arvo_nouns,
flocculence_nouns,
kismet_nouns,
mirror_nouns,
middleagedness_nouns,
anabasine_nouns,
sinew_nouns,
assertiveness_nouns,
Caelum_nouns,
boyarism_nouns,
Tray_nouns,
nonfinding_nouns,
traducianism_nouns,
overremissness_nouns,
Miuo_nouns,
Giglio_nouns,
insp_nouns,
recapitulation_nouns,
underpen_nouns,
Teide_nouns,
Phineus_nouns,
murgeon_nouns,
superproduce_nouns,
canonship_nouns,
chesterfield_nouns,
equilibrium_nouns,
Berkie_nouns,
unseducibleness_nouns,
mammonite_nouns,
Tartufe_nouns,
unmutinousness_nouns,
landlord_nouns,
Napoli_nouns,
breastbeating_nouns,
Virden_nouns,
Bolzano_nouns,
arrythmia_nouns,
Baul_nouns,
perigon_nouns,
Laocadia_nouns,
beaugregory_nouns,
Stannwood_nouns,
syntype_nouns,
Ros_nouns,
sfz_nouns,
dilatometry_nouns,
Fiertz_nouns,
Dunsinane_nouns,
garderobe_nouns,
Omdurman_nouns,
ostracization_nouns,
precalculation_nouns,
prunt_nouns,
Parkinson_nouns,
Reagan_nouns,
Alabama_nouns,
Canadianism_nouns,
antifoggant_nouns,
Basra_nouns,
monosymptomatic_nouns,
Vastha_nouns,
ganglia_nouns,
gahnite_nouns,
alibi_nouns,
preindication_nouns,
combatter_nouns,
tympanum_nouns,
Pavla_nouns,
decolorisation_nouns,
Goodard_nouns,
opacity_nouns,
Rubinstein_nouns,
confarreation_nouns,
hick_nouns,
naumachia_nouns,
Librium_nouns,
Peekskill_nouns,
butadiene_nouns,
temporizer_nouns,
Lakewood_nouns,
BelRidge_nouns,
morel_nouns,
Rumilly_nouns,
Skagerrak_nouns,
spinach_nouns,
ethrog_nouns,
Thatch_nouns,
dimity_nouns,
wiretapper_nouns,
Methuen_nouns,
kame_nouns,
optometry_nouns,
klippe_nouns,
sportsmanship_nouns,
Chipley_nouns,
Voccola_nouns,
Tuckie_nouns,
Behaim_nouns,
chaffiness_nouns,
Chimbote_nouns,
valentine_nouns,
psephology_nouns,
skittle_nouns,
imprinter_nouns,
chemoprophylaxis_nouns,
Chiarra_nouns,
sedimentation_nouns,
Niger_nouns,
warmheartedness_nouns,
Burchett_nouns,
phone_nouns,
indissolubility_nouns,
quasicontract_nouns,
wollastonite_nouns,
plastique_nouns,
Sinnard_nouns,
lung_nouns,
Lingayata_nouns,
homostyly_nouns,
Turina_nouns,
Basuto_nouns,
haemocoel_nouns,
Ligeia_nouns,
avoirdupois_nouns,
hyperanakinesia_nouns,
Goddard_nouns,
mash_nouns,
Felder_nouns,
sinuation_nouns,
superobjection_nouns,
quietism_nouns,
clamminess_nouns,
imperilment_nouns,
selenate_nouns,
Eddie_nouns,
dalan_nouns,
deduction_nouns,
openwork_nouns,
choragus_nouns,
Dunlavy_nouns,
illamon_nouns,
Piscatelli_nouns,
fashionableness_nouns,
grudge_nouns,
Raskin_nouns,
Duax_nouns,
characterisation_nouns,
banian_nouns,
abbotship_nouns,
Oehlenschlger_nouns,
acusector_nouns,
generality_nouns,
nonduplicity_nouns,
nonobstructiveness_nouns,
barbotine_nouns,
Vishinsky_nouns,
Badger_nouns,
HoughtonleSpring_nouns,
Feodora_nouns,
Valadon_nouns,
uproariousness_nouns,
prosciutto_nouns,
glycoside_nouns,
conscription_nouns,
Borman_nouns,
baton_nouns,
noncombatant_nouns,
nondependableness_nouns,
mouser_nouns,
Mael_nouns,
Connett_nouns,
burseed_nouns,
Pharisee_nouns,
Tish_nouns,
logistics_nouns,
cerat_nouns,
Witha_nouns,
corporalcy_nouns,
depositary_nouns,
andamento_nouns,
pimp_nouns,
up_nouns,
unprofitableness_nouns,
cad_nouns,
Huang_nouns,
aquaphobia_nouns,
bootlicker_nouns,
Felice_nouns,
Grubman_nouns,
Hengyang_nouns,
cheilotomy_nouns,
Diet_nouns,
Nofretete_nouns,
Enugu_nouns,
Hodeida_nouns,
Turrell_nouns,
Ailssa_nouns,
Tarawa_nouns,
Frodi_nouns,
Avril_nouns,
SNCC_nouns,
hayride_nouns,
anabranch_nouns,
wolfchild_nouns,
inaccurateness_nouns,
admonitor_nouns,
Badalona_nouns,
stonefly_nouns,
campion_nouns,
boon_nouns,
pneumatotherapy_nouns,
Gora_nouns,
Conral_nouns,
banderilla_nouns,
rangefinder_nouns,
catercousin_nouns,
Laddy_nouns,
quebrada_nouns,
era_nouns,
Pushtu_nouns,
serotherapist_nouns,
icebox_nouns,
lawmaking_nouns,
sarcasm_nouns,
depolarizer_nouns,
Placido_nouns,
nonredemption_nouns,
hypermetamorphosis_nouns,
protozoon_nouns,
approachability_nouns,
Mists_nouns,
Daladier_nouns,
hothouse_nouns,
louver_nouns,
cetaceum_nouns,
Cypro_nouns,
myohemoglobinuria_nouns,
quittor_nouns,
parent_nouns,
lunch_nouns,
squalor_nouns,
asbestosis_nouns,
megalopsia_nouns,
Cleopatre_nouns,
disconsolateness_nouns,
ouphe_nouns,
vineyard_nouns,
veratridine_nouns,
Sammie_nouns,
ovariectomy_nouns,
Joann_nouns,
autochthonism_nouns,
Sukkoth_nouns,
Orelie_nouns,
overreduction_nouns,
Stiegel_nouns,
thermoluminescence_nouns,
refreshingness_nouns,
djellabah_nouns,
exr_nouns,
flatcar_nouns,
mathematics_nouns,
Titos_nouns,
Guesdism_nouns,
Dunc_nouns,
Pain_nouns,
Copiague_nouns,
Roxy_nouns,
Ardussi_nouns,
limes_nouns,
cedula_nouns,
Wittie_nouns,
Baring_nouns,
premeditation_nouns,
anhydremia_nouns,
Dayton_nouns,
saviorship_nouns,
Guayaquil_nouns,
Boulez_nouns,
Sully_nouns,
Murage_nouns,
squalene_nouns,
reanalysis_nouns,
Obadiah_nouns,
stretto_nouns,
beryllonite_nouns,
Ierna_nouns,
Kotzebue_nouns,
debater_nouns,
intermigration_nouns,
vermin_nouns,
Garibold_nouns,
uncoquettishness_nouns,
irreversibleness_nouns,
enlistment_nouns,
spearfish_nouns,
mage_nouns,
Joseph_nouns,
parroket_nouns,
lancination_nouns,
parging_nouns,
tympany_nouns,
Litchfield_nouns,
Sliwa_nouns,
sextuplicate_nouns,
Tchao_nouns,
Buckley_nouns,
vauntcourier_nouns,
favourer_nouns,
dialectic_nouns,
Farver_nouns,
subinfection_nouns,
Ferneau_nouns,
overcomplacency_nouns,
Mures_nouns,
Loftus_nouns,
Deanne_nouns,
Mary_nouns,
tagrag_nouns,
vagotomy_nouns,
Almira_nouns,
classicality_nouns,
numerosity_nouns,
Armyn_nouns,
adjuror_nouns,
tovarisch_nouns,
Shiller_nouns,
Basile_nouns,
citrine_nouns,
heme_nouns,
Viglione_nouns,
Philina_nouns,
nonsoldier_nouns,
entity_nouns,
redeye_nouns,
unresentfulness_nouns,
monument_nouns,
psychodrama_nouns,
diazole_nouns,
kiva_nouns,
cycling_nouns,
Campinas_nouns,
Bensenville_nouns,
girlhood_nouns,
thimble_nouns,
Tacquet_nouns,
decapitation_nouns,
Proud_nouns,
headworking_nouns,
Hyatt_nouns,
nightrider_nouns,
proposition_nouns,
Perm_nouns,
raphe_nouns,
nonpredatoriness_nouns,
scourer_nouns,
midge_nouns,
MacFarlane_nouns,
Prag_nouns,
Brooking_nouns,
Steele_nouns,
ft_nouns,
intemperance_nouns,
seminervousness_nouns,
birthwort_nouns,
Boz_nouns,
Konstantine_nouns,
pomander_nouns,
scholium_nouns,
nonproliferation_nouns,
Spender_nouns,
Rabelaisianism_nouns,
nose_nouns,
Sparhawk_nouns,
fishpound_nouns,
cuiajo_nouns,
anteversion_nouns,
chemoreception_nouns,
Pekingese_nouns,
Malta_nouns,
zoophorus_nouns,
Essam_nouns,
Dohnnyi_nouns,
deflection_nouns,
Ansell_nouns,
appendance_nouns,
Hook_nouns,
Vietnam_nouns,
foolhardiness_nouns,
familiarness_nouns,
Dibbrun_nouns,
middlebrow_nouns,
Hofuf_nouns,
Gavriella_nouns,
coagulant_nouns,
litany_nouns,
VDM_nouns,
caf_nouns,
Musagetes_nouns,
shelf_nouns,
Harmonist_nouns,
dissipatedness_nouns,
Effy_nouns,
Manley_nouns,
Ganymede_nouns,
Sakuntala_nouns,
otorhinolaryngology_nouns,
Renee_nouns,
nonvillager_nouns,
Joao_nouns,
precongratulation_nouns,
nonsensicalness_nouns,
nonconvergency_nouns,
Tindal_nouns,
precontract_nouns,
Mississippi_nouns,
microwave_nouns,
infralapsarianism_nouns,
wheel_nouns,
underfur_nouns,
Corin_nouns,
Lassell_nouns,
Monney_nouns,
threeposter_nouns,
Bartlett_nouns,
napkin_nouns,
tocher_nouns,
Ed_nouns,
epiphyll_nouns,
encoignure_nouns,
sockdologer_nouns,
Brewton_nouns,
hellraiser_nouns,
Tedric_nouns,
naiad_nouns,
overdraught_nouns,
nonendorsement_nouns,
isogradient_nouns,
Coopersmith_nouns,
bachelordom_nouns,
papistry_nouns,
compartimento_nouns,
Po_nouns,
banker_nouns,
Crane_nouns,
epic_nouns,
congruousness_nouns,
span_nouns,
mmf_nouns,
character_nouns,
unfidelity_nouns,
Lad_nouns,
Bannockburn_nouns,
heteroscedasticity_nouns,
Azilian_nouns,
Ahom_nouns,
Naomi_nouns,
Charlevoix_nouns,
ichthyophagy_nouns,
chelicera_nouns,
pandy_nouns,
freighter_nouns,
nonproximity_nouns,
surcharge_nouns,
Hamlet_nouns,
Kolosick_nouns,
Yam_nouns,
subsyndication_nouns,
Jarita_nouns,
Thach_nouns,
Gussman_nouns,
Kneeland_nouns,
NRA_nouns,
Hefter_nouns,
prelateship_nouns,
Steppes_nouns,
saskatoon_nouns,
teleplay_nouns,
figurer_nouns,
subagent_nouns,
Hollis_nouns,
selfdirection_nouns,
Colo_nouns,
skeet_nouns,
Tombigbee_nouns,
contemplation_nouns,
mortification_nouns,
oregano_nouns,
Greene_nouns,
lordosis_nouns,
Chiclayo_nouns,
viscus_nouns,
nascence_nouns,
Polyhymnia_nouns,
fuage_nouns,
Davey_nouns,
canonization_nouns,
Satie_nouns,
favoritism_nouns,
disjection_nouns,
noncuriosity_nouns,
Cognac_nouns,
Orneus_nouns,
Terni_nouns,
carnosine_nouns,
Appledorf_nouns,
whapper_nouns,
Irby_nouns,
Dak_nouns,
ballerina_nouns,
Bardeen_nouns,
concertgoer_nouns,
sterility_nouns,
lectorship_nouns,
trinitroglycerin_nouns,
louis_nouns,
Aggie_nouns,
marquetry_nouns,
Haim_nouns,
multiprogramming_nouns,
judogi_nouns,
Komsomolsk_nouns,
loller_nouns,
lapin_nouns,
Neve_nouns,
bombora_nouns,
Coppelia_nouns,
corrobboree_nouns,
Turanian_nouns,
Chavez_nouns,
Amb_nouns,
Letchworth_nouns,
Panini_nouns,
Alesia_nouns,
Kursh_nouns,
actinia_nouns,
manakin_nouns,
polariscope_nouns,
buttonmould_nouns,
Newlin_nouns,
phagomania_nouns,
Ebony_nouns,
quizzer_nouns,
Kirt_nouns,
Adallard_nouns,
isomorphism_nouns,
Dirk_nouns,
immitigability_nouns,
BCL_nouns,
pesthouse_nouns,
Baelbeer_nouns,
ptilosis_nouns,
Hispaniola_nouns,
Leadbelly_nouns,
Alamosa_nouns,
houseparent_nouns,
snowshed_nouns,
bogginess_nouns,
Jadotville_nouns,
Easterledges_nouns,
Mitran_nouns,
Peterlee_nouns,
predepreciation_nouns,
underfitting_nouns,
sudoriferousness_nouns,
Zarga_nouns,
Lorenza_nouns,
Ecclesiasticus_nouns,
plasterer_nouns,
Faraday_nouns,
nontangibleness_nouns,
Arvind_nouns,
sinhalite_nouns,
Norw_nouns,
prover_nouns,
Christoforo_nouns,
barretter_nouns,
examinant_nouns,
thermostat_nouns,
comity_nouns,
postsigner_nouns,
contradictoriness_nouns,
Monteux_nouns,
ChampignysurMarne_nouns,
Miletus_nouns,
harassment_nouns,
bebopper_nouns,
Mannos_nouns,
inelegancy_nouns,
tussore_nouns,
humdinger_nouns,
Acraea_nouns,
Hebraiser_nouns,
Mackinac_nouns,
Evora_nouns,
greataunt_nouns,
Teodoro_nouns,
disenthronement_nouns,
antiquer_nouns,
RRB_nouns,
Zalucki_nouns,
ACWA_nouns,
gynomonoecism_nouns,
indus_nouns,
bellyful_nouns,
Pangaea_nouns,
nuclein_nouns,
oxygenicity_nouns,
irreg_nouns,
pallet_nouns,
sabin_nouns,
Sergio_nouns,
Chardonnet_nouns,
contexture_nouns,
preborrowing_nouns,
BouchesduRh_nouns,
abbreviator_nouns,
niphablepsia_nouns,
Ling_nouns,
cogitator_nouns,
kickstand_nouns,
Heriberto_nouns,
revolutionist_nouns,
chorion_nouns,
Templar_nouns,
ureter_nouns,
photoproton_nouns,
commis_nouns,
Bink_nouns,
concupiscence_nouns,
iconoduly_nouns,
charrette_nouns,
indemnitor_nouns,
fabricant_nouns,
Gresham_nouns,
reglet_nouns,
palaestra_nouns,
Readus_nouns,
dumpishness_nouns,
Adair_nouns,
Arctogaea_nouns,
KIAS_nouns,
alarum_nouns,
ringgit_nouns,
larcener_nouns,
Tokyoite_nouns,
subradiance_nouns,
catheter_nouns,
Ednas_nouns,
popery_nouns,
semicellulose_nouns,
canonisation_nouns,
Concordia_nouns,
nonserial_nouns,
tetrabrach_nouns,
underthought_nouns,
rhinoscopy_nouns,
stylolite_nouns,
Kronecker_nouns,
serviette_nouns,
Wolverhampton_nouns,
Childress_nouns,
Rudy_nouns,
hydroxyl_nouns,
Tsaritsyn_nouns,
uncleanliness_nouns,
pizaine_nouns,
freakout_nouns,
malapertness_nouns,
clamorousness_nouns,
bro_nouns,
Humberto_nouns,
Calvin_nouns,
woodlouse_nouns,
Busch_nouns,
confluence_nouns,
Politi_nouns,
Mosira_nouns,
Valerie_nouns,
redbird_nouns,
croton_nouns,
Larrie_nouns,
stockishness_nouns,
Bartko_nouns,
Jemena_nouns,
rectitude_nouns,
Rebeka_nouns,
majorette_nouns,
Anaxo_nouns,
Lashonda_nouns,
chaffinch_nouns,
Meridian_nouns,
coit_nouns,
philosophizer_nouns,
newsman_nouns,
carpetweed_nouns,
striver_nouns,
Tucker_nouns,
blueprint_nouns,
Asgeirsson_nouns,
receptor_nouns,
Malonis_nouns,
soupbone_nouns,
Armalda_nouns,
Monie_nouns,
mood_nouns,
conium_nouns,
uneasiness_nouns,
observer_nouns,
Gaughan_nouns,
emetine_nouns,
Dugas_nouns,
Somersworth_nouns,
metaphysics_nouns,
squirearch_nouns,
cresol_nouns,
chophouse_nouns,
gurges_nouns,
Fiend_nouns,
Wadesworth_nouns,
Hjerpe_nouns,
Calais_nouns,
quinonimine_nouns,
flamer_nouns,
proband_nouns,
storybook_nouns,
feta_nouns,
overwariness_nouns,
superbazaar_nouns,
Admetus_nouns,
Bastrop_nouns,
tyrothricin_nouns,
whitewall_nouns,
Arbroath_nouns,
interlardment_nouns,
Wittgenstein_nouns,
Naman_nouns,
reeler_nouns,
khan_nouns,
denture_nouns,
Teflon_nouns,
Kiehl_nouns,
cog_nouns,
sirvente_nouns,
superurgency_nouns,
castanet_nouns,
nonrehabilitation_nouns,
Laon_nouns,
Ark_nouns,
Galven_nouns,
DPH_nouns,
mallam_nouns,
keratalgia_nouns,
Ohl_nouns,
Odelia_nouns,
tootsy_nouns,
Mc_nouns,
Clois_nouns,
biuniqueness_nouns,
Most_nouns,
Beuthen_nouns,
Trasimene_nouns,
Waldos_nouns,
Claramae_nouns,
barostat_nouns,
Terena_nouns,
unimportunateness_nouns,
Lyford_nouns,
Crandale_nouns,
Ganymeda_nouns,
congruency_nouns,
slyness_nouns,
zZt_nouns,
stereoscopist_nouns,
physicality_nouns,
Braunschweig_nouns,
mCi_nouns,
dioptometer_nouns,
underworker_nouns,
MPA_nouns,
bicameralist_nouns,
phosphene_nouns,
barndoor_nouns,
Thorne_nouns,
Ginzburg_nouns,
germicide_nouns,
Rab_nouns,
Clarksburg_nouns,
QC_nouns,
porphyry_nouns,
titivator_nouns,
Tjader_nouns,
Taite_nouns,
unthinkableness_nouns,
Howie_nouns,
Capek_nouns,
sirocco_nouns,
paisley_nouns,
Astrid_nouns,
spermatophyte_nouns,
persiflage_nouns,
ravelment_nouns,
talc_nouns,
topflighter_nouns,
Josephson_nouns,
Sparta_nouns,
thsant_nouns,
Buddhology_nouns,
Apache_nouns,
pterylography_nouns,
toilsomeness_nouns,
inwale_nouns,
Erechtheum_nouns,
nonbeneficence_nouns,
Hermoupolis_nouns,
phototelegraphy_nouns,
NASD_nouns,
wongawonga_nouns,
coom_nouns,
unfitness_nouns,
Avron_nouns,
billyo_nouns,
ileus_nouns,
Ismailia_nouns,
Noletta_nouns,
piezoelectricity_nouns,
misknowledge_nouns,
pentalpha_nouns,
undercooper_nouns,
nonapportionment_nouns,
diadochokinesia_nouns,
orphanage_nouns,
Roussel_nouns,
composition_nouns,
tad_nouns,
rixdollar_nouns,
tollhouse_nouns,
Tambora_nouns,
noncompressibility_nouns,
Pirali_nouns,
minimization_nouns,
bassarisk_nouns,
Ness_nouns,
Tryck_nouns,
noninterpretiveness_nouns,
Schroth_nouns,
Lely_nouns,
fellowship_nouns,
housecleaner_nouns,
Addison_nouns,
paronomasia_nouns,
Nicostratus_nouns,
pennycress_nouns,
capacitation_nouns,
unoppressiveness_nouns,
restr_nouns,
bunker_nouns,
Ferrand_nouns,
Quinn_nouns,
dahoon_nouns,
colportage_nouns,
prewash_nouns,
exanthem_nouns,
Pravost_nouns,
grout_nouns,
hiver_nouns,
markka_nouns,
Zerk_nouns,
hardhandedness_nouns,
Annelida_nouns,
hardandfastness_nouns,
Lefkowitz_nouns,
BFAMus_nouns,
leapfrogger_nouns,
Stovall_nouns,
blepharospasm_nouns,
antiutilitarianism_nouns,
Gemini_nouns,
FOR_nouns,
galloon_nouns,
unanimity_nouns,
consolette_nouns,
ebonite_nouns,
moribundity_nouns,
Wojak_nouns,
switcher_nouns,
sororicide_nouns,
paraph_nouns,
Ibagu_nouns,
studdie_nouns,
ai_nouns,
Zorobabel_nouns,
pitching_nouns,
logroller_nouns,
Watertown_nouns,
silt_nouns,
Mia_nouns,
abode_nouns,
restfulness_nouns,
deafness_nouns,
PEI_nouns,
Fernando_nouns,
nonsimular_nouns,
Remy_nouns,
unsordidness_nouns,
treesurgeon_nouns,
glycuronide_nouns,
subcommissionership_nouns,
bookman_nouns,
falsework_nouns,
Pironi_nouns,
analyser_nouns,
aigrette_nouns,
graver_nouns,
priory_nouns,
cordoba_nouns,
Flexography_nouns,
dimethylsulphoxide_nouns,
perchlorate_nouns,
coevality_nouns,
Rumford_nouns,
finger_nouns,
inburst_nouns,
brose_nouns,
Bohlen_nouns,
fartlek_nouns,
cornucopia_nouns,
Hamite_nouns,
bargepole_nouns,
gleed_nouns,
falsie_nouns,
harbor_nouns,
sangria_nouns,
Pitts_nouns,
odometer_nouns,
Bedwell_nouns,
Kerwon_nouns,
fugacity_nouns,
auxanometer_nouns,
Aaerope_nouns,
Weltschmerz_nouns,
lamasery_nouns,
Mattox_nouns,
redowa_nouns,
forehearth_nouns,
reagitation_nouns,
crusado_nouns,
Chrisoula_nouns,
intergrowth_nouns,
mandamus_nouns,
describer_nouns,
caulker_nouns,
Tortelier_nouns,
Socinus_nouns,
noncoordination_nouns,
Wenger_nouns,
patriarchy_nouns,
falbala_nouns,
Concoff_nouns,
polymorph_nouns,
monumentalism_nouns,
Taryn_nouns,
Norvil_nouns,
Haletta_nouns,
nonincrimination_nouns,
noncurativeness_nouns,
reappliance_nouns,
epimerism_nouns,
Lamaist_nouns,
Asunciun_nouns,
Christsthorn_nouns,
excommunicator_nouns,
Advaita_nouns,
Roxana_nouns,
prehistorian_nouns,
highhatter_nouns,
inexistency_nouns,
triggerfish_nouns,
deporter_nouns,
argument_nouns,
Byrnes_nouns,
woodcreeper_nouns,
colloquist_nouns,
Hally_nouns,
hilarity_nouns,
Funston_nouns,
Angeleno_nouns,
selfsolicitude_nouns,
bobbin_nouns,
Schul_nouns,
expulsion_nouns,
Essequibo_nouns,
surveying_nouns,
Geneseo_nouns,
Gondwanaland_nouns,
saker_nouns,
concentricity_nouns,
pensil_nouns,
sneakbox_nouns,
Gibeonite_nouns,
playhouse_nouns,
acetal_nouns,
Mecklenburg_nouns,
Hillell_nouns,
Arvid_nouns,
beefwittedness_nouns,
shellacking_nouns,
hydrochloride_nouns,
Wamsley_nouns,
plenitude_nouns,
bedclothing_nouns,
Naismith_nouns,
reshipment_nouns,
dugong_nouns,
galliwasp_nouns,
harmonisation_nouns,
Arachnida_nouns,
dermatographia_nouns,
Greenfield_nouns,
abv_nouns,
acrodontism_nouns,
pentene_nouns,
cyclist_nouns,
glutose_nouns,
Wiencke_nouns,
Renner_nouns,
superelaborateness_nouns,
interrupter_nouns,
ambitiousness_nouns,
saccharization_nouns,
CAF_nouns,
Lenci_nouns,
Kunkle_nouns,
Femi_nouns,
accelerant_nouns,
pareira_nouns,
scourge_nouns,
Monto_nouns,
prettifier_nouns,
realliance_nouns,
Linnette_nouns,
Greenman_nouns,
Wolsey_nouns,
cecity_nouns,
shrubbery_nouns,
Alliber_nouns,
lizzie_nouns,
nonnumeral_nouns,
jouk_nouns,
Carpaccio_nouns,
dimercaprol_nouns,
Sherer_nouns,
thymine_nouns,
rostra_nouns,
Henrie_nouns,
aminase_nouns,
Severinus_nouns,
imperialization_nouns,
hyperexcitableness_nouns,
gu_nouns,
Adapa_nouns,
sarrazin_nouns,
Swed_nouns,
bibb_nouns,
logbook_nouns,
antiunionist_nouns,
canonicate_nouns,
stomachache_nouns,
nonchurchgoer_nouns,
traumatization_nouns,
Ctesius_nouns,
Ingelow_nouns,
claybank_nouns,
daywork_nouns,
pacifico_nouns,
snot_nouns,
Joceline_nouns,
socage_nouns,
decameter_nouns,
undercrypt_nouns,
sporadism_nouns,
reliever_nouns,
Holstein_nouns,
DAnnunzio_nouns,
Reiter_nouns,
Pessa_nouns,
Eshelman_nouns,
fiorin_nouns,
Marjory_nouns,
grog_nouns,
semicolloid_nouns,
subinspectorship_nouns,
adman_nouns,
fourflusher_nouns,
newspaperwoman_nouns,
Benilda_nouns,
billingsgate_nouns,
Burnet_nouns,
weediness_nouns,
hooves_nouns,
Younglove_nouns,
diapedesis_nouns,
curtsy_nouns,
Vallie_nouns,
Cedric_nouns,
Deus_nouns,
preloan_nouns,
Basilicata_nouns,
Trevelyan_nouns,
tunableness_nouns,
Catskill_nouns,
unflexibility_nouns,
Dexedrine_nouns,
jiao_nouns,
Dadaism_nouns,
minikin_nouns,
unimmaculateness_nouns,
cirrhosis_nouns,
matelassa_nouns,
carrier_nouns,
McDonald_nouns,
Hunts_nouns,
alburnum_nouns,
aimer_nouns,
Kenton_nouns,
repayment_nouns,
Bianchi_nouns,
Phylonome_nouns,
nonadvancement_nouns,
caisson_nouns,
likeability_nouns,
carafe_nouns,
Hindustani_nouns,
predissolution_nouns,
countship_nouns,
Crisium_nouns,
Kunin_nouns,
undersupport_nouns,
bornite_nouns,
spectrophotometer_nouns,
Groenendael_nouns,
Kevyn_nouns,
nonabsolution_nouns,
Melisande_nouns,
megapod_nouns,
WCTU_nouns,
shrubbiness_nouns,
stereocamera_nouns,
Amie_nouns,
dedolomitization_nouns,
spiritualisation_nouns,
cribbiter_nouns,
Baxy_nouns,
limitarian_nouns,
Philius_nouns,
Hallett_nouns,
emperorship_nouns,
graysby_nouns,
dissuasiveness_nouns,
castellum_nouns,
oversubscriber_nouns,
succinate_nouns,
resemblance_nouns,
selfidolatry_nouns,
reuseabness_nouns,
greatgrandmother_nouns,
FRSL_nouns,
drugget_nouns,
USSCt_nouns,
chlorobromomethane_nouns,
stech_nouns,
swanherd_nouns,
megalith_nouns,
rego_nouns,
Sansone_nouns,
Lie_nouns,
nondesulfurization_nouns,
leotard_nouns,
toothpaste_nouns,
gardemanger_nouns,
corrosion_nouns,
Vitek_nouns,
pistareen_nouns,
VanHook_nouns,
Cooper_nouns,
bottomlessness_nouns,
swale_nouns,
Lucian_nouns,
prussianisation_nouns,
Bazaine_nouns,
margrave_nouns,
samadhi_nouns,
aerometeorograph_nouns,
diethylethanolamine_nouns,
Jamalpur_nouns,
jejuneness_nouns,
Oxenstierna_nouns,
Widgery_nouns,
whale_nouns,
Joule_nouns,
ferromagnetism_nouns,
expansionism_nouns,
caricature_nouns,
recipe_nouns,
overcleanness_nouns,
airship_nouns,
fighterbomber_nouns,
formulism_nouns,
unsafeness_nouns,
Ba_nouns,
pennaceous_nouns,
devilswalkingstick_nouns,
authoriser_nouns,
hemipteran_nouns,
Latrice_nouns,
Lola_nouns,
Albanese_nouns,
Brendin_nouns,
freezeup_nouns,
AmonRa_nouns,
loca_nouns,
Lazaruk_nouns,
sunspottedness_nouns,
Milstone_nouns,
kinescope_nouns,
Munt_nouns,
trichology_nouns,
He_nouns,
retractibility_nouns,
disobedience_nouns,
vermifuge_nouns,
resubmission_nouns,
Phantasus_nouns,
flapdoodle_nouns,
nonpurification_nouns,
valise_nouns,
Etonian_nouns,
axiom_nouns,
subtriangularity_nouns,
photopathy_nouns,
Glazunov_nouns,
Borghild_nouns,
volunteer_nouns,
Rosamond_nouns,
vestry_nouns,
hemstitcher_nouns,
neoytterbium_nouns,
Lit_nouns,
congius_nouns,
Sherill_nouns,
refractedness_nouns,
faery_nouns,
exit_nouns,
Hammonton_nouns,
Rozella_nouns,
Zaremski_nouns,
Reahard_nouns,
recpt_nouns,
Thar_nouns,
alkalizer_nouns,
aficionado_nouns,
breviary_nouns,
Orlando_nouns,
lexicographer_nouns,
boa_nouns,
Apophis_nouns,
bounder_nouns,
minipill_nouns,
shanti_nouns,
snowcreep_nouns,
Dudden_nouns,
Eden_nouns,
Belostok_nouns,
Gillingham_nouns,
inaccuracy_nouns,
erotology_nouns,
batsman_nouns,
induc_nouns,
nonrival_nouns,
acetaldol_nouns,
baddie_nouns,
sagger_nouns,
specification_nouns,
bearbush_nouns,
formularization_nouns,
leftover_nouns,
Tomkins_nouns,
Turkism_nouns,
Neufchetel_nouns,
ribbon_nouns,
cura_nouns,
crepuscle_nouns,
Lumbard_nouns,
Rhodope_nouns,
Adelaide_nouns,
Octavia_nouns,
popgun_nouns,
Derward_nouns,
selfsustentation_nouns,
Tsan_nouns,
subelement_nouns,
cone_nouns,
Beisel_nouns,
elastin_nouns,
Jala_nouns,
Hoebart_nouns,
oatmeal_nouns,
platitudiniser_nouns,
bronzing_nouns,
conto_nouns,
narcosynthesis_nouns,
shroff_nouns,
Shellie_nouns,
Arnim_nouns,
Belatrix_nouns,
Lunseth_nouns,
Skipton_nouns,
Vogel_nouns,
toplevel_nouns,
Kavita_nouns,
cottonwick_nouns,
BSGE_nouns,
unaccurateness_nouns,
increaser_nouns,
Nome_nouns,
hadj_nouns,
Usbek_nouns,
NantyGlo_nouns,
Kumamoto_nouns,
longsightedness_nouns,
antiradical_nouns,
cockoftherock_nouns,
sputum_nouns,
planogamete_nouns,
anoia_nouns,
Celestine_nouns,
serousness_nouns,
zygophyte_nouns,
preindebtedness_nouns,
rejudgement_nouns,
Marseillaise_nouns,
Voronoff_nouns,
microphysics_nouns,
unmorbidness_nouns,
guacharo_nouns,
Trin_nouns,
lookin_nouns,
panplegia_nouns,
SinoTibetan_nouns,
Royd_nouns,
firkin_nouns,
RoodepoortMaraisburg_nouns,
mkt_nouns,
Shawnee_nouns,
Ezarras_nouns,
footprint_nouns,
Wobbly_nouns,
Drago_nouns,
Wafdist_nouns,
anacoluthon_nouns,
anticholinesterase_nouns,
toff_nouns,
Formosa_nouns,
psalm_nouns,
Newman_nouns,
griper_nouns,
paloverde_nouns,
chi_nouns,
Burnard_nouns,
Sanson_nouns,
cercus_nouns,
hypnosporangium_nouns,
Stalker_nouns,
Joseito_nouns,
BEd_nouns,
Marigold_nouns,
taillessness_nouns,
Anand_nouns,
mess_nouns,
Jayne_nouns,
ROSPA_nouns,
snood_nouns,
Bittner_nouns,
chymist_nouns,
Fouquet_nouns,
Reichsbank_nouns,
thirster_nouns,
accusant_nouns,
Pasco_nouns,
turbidness_nouns,
egocentrism_nouns,
schefferite_nouns,
Kahoolawe_nouns,
Enalus_nouns,
wiz_nouns,
Wan_nouns,
chondriome_nouns,
Mavis_nouns,
Ponca_nouns,
menaquinone_nouns,
podiatry_nouns,
yaud_nouns,
Horatius_nouns,
Coulter_nouns,
pearlfish_nouns,
fallalery_nouns,
Cnidia_nouns,
Wilkens_nouns,
sorus_nouns,
coprolagnia_nouns,
Marida_nouns,
alcalde_nouns,
exoderm_nouns,
mazuma_nouns,
taxonomy_nouns,
companionway_nouns,
streetcar_nouns,
battle_nouns,
ambrotype_nouns,
cowslip_nouns,
homophony_nouns,
buyer_nouns,
waveoff_nouns,
Thailand_nouns,
Nabalas_nouns,
Brielle_nouns,
extravasation_nouns,
wadna_nouns,
auditress_nouns,
Prome_nouns,
Swisher_nouns,
Goodspeed_nouns,
flor_nouns,
alastrim_nouns,
orthopteron_nouns,
licentiate_nouns,
Etty_nouns,
Esbjerg_nouns,
Tricia_nouns,
smokelessness_nouns,
foresightedness_nouns,
antiradicalism_nouns,
steelwork_nouns,
gastroenterostomy_nouns,
Vladamir_nouns,
ocher_nouns,
Asterius_nouns,
scrap_nouns,
planarian_nouns,
MNE_nouns,
outspokenness_nouns,
Oreopithecus_nouns,
Damas_nouns,
Pontocaine_nouns,
Eleanor_nouns,
Byzas_nouns,
shochet_nouns,
armilla_nouns,
Oliphant_nouns,
admitter_nouns,
Duquesne_nouns,
OPCW_nouns,
IledeFrance_nouns,
Berneta_nouns,
endodermis_nouns,
pentstemon_nouns,
Lozi_nouns,
biscuit_nouns,
priorship_nouns,
demonstrativeness_nouns,
Malmdy_nouns,
Hobbes_nouns,
aquashow_nouns,
freedman_nouns,
Candi_nouns,
underspar_nouns,
contortion_nouns,
nonuniversalist_nouns,
underpacking_nouns,
impartment_nouns,
Poliuchus_nouns,
sunbird_nouns,
Fong_nouns,
sharkskin_nouns,
Lelia_nouns,
pincushionflower_nouns,
snubber_nouns,
jeu_nouns,
Xipe_nouns,
chickweed_nouns,
eyehole_nouns,
confirmor_nouns,
mealtime_nouns,
Diores_nouns,
Lowlands_nouns,
techiness_nouns,
hydrangea_nouns,
Bremble_nouns,
WRA_nouns,
exudation_nouns,
continuum_nouns,
vale_nouns,
symphony_nouns,
kinematographer_nouns,
Bundy_nouns,
pancake_nouns,
prad_nouns,
lampad_nouns,
unvenerability_nouns,
Zia_nouns,
Teddie_nouns,
hexagon_nouns,
Emporia_nouns,
Aubyn_nouns,
decumbence_nouns,
Jaynell_nouns,
tugboat_nouns,
Enos_nouns,
ribgrass_nouns,
radiographer_nouns,
Hellespontus_nouns,
googolplex_nouns,
nonexpiration_nouns,
sequestrator_nouns,
anaglyphoscope_nouns,
Aubrette_nouns,
endocrinopath_nouns,
ferrovanadium_nouns,
nonequalization_nouns,
Edlyn_nouns,
McAdams_nouns,
Tunney_nouns,
dilatometer_nouns,
resignation_nouns,
Daile_nouns,
hemosiderosis_nouns,
dunghill_nouns,
Adamsen_nouns,
Karaism_nouns,
Bienne_nouns,
matindol_nouns,
Babbitt_nouns,
Cally_nouns,
Fennie_nouns,
unslimness_nouns,
chickenbreastedness_nouns,
bidarka_nouns,
anapophysis_nouns,
elem_nouns,
intercolumniation_nouns,
Wina_nouns,
Manilius_nouns,
Barbe_nouns,
overapprehensiveness_nouns,
emphysema_nouns,
intergradation_nouns,
Canisteo_nouns,
Constructivism_nouns,
horniness_nouns,
Carlism_nouns,
childlikeness_nouns,
Valonia_nouns,
Juan_nouns,
circumvolution_nouns,
neper_nouns,
leukopoiesis_nouns,
Gaillard_nouns,
jostler_nouns,
bereavement_nouns,
denim_nouns,
tsi_nouns,
Manchu_nouns,
myope_nouns,
Fortunia_nouns,
khediviate_nouns,
omniscience_nouns,
lessee_nouns,
vainglory_nouns,
Matanuska_nouns,
joannes_nouns,
undermediator_nouns,
nipplewort_nouns,
almsman_nouns,
sarcocarp_nouns,
despoliation_nouns,
Lamartine_nouns,
superorder_nouns,
Noblesville_nouns,
Japheth_nouns,
Raycher_nouns,
supervision_nouns,
OLG_nouns,
equipollence_nouns,
sodomy_nouns,
foretopmast_nouns,
zealousness_nouns,
Providence_nouns,
urination_nouns,
nonalliterativeness_nouns,
honeybunch_nouns,
Joris_nouns,
conservationist_nouns,
contr_nouns,
refreshment_nouns,
adenectomy_nouns,
ripper_nouns,
deathbed_nouns,
defusion_nouns,
Baynebridge_nouns,
Greentree_nouns,
posology_nouns,
digitation_nouns,
stranger_nouns,
frier_nouns,
consumption_nouns,
wildlife_nouns,
NeoLatin_nouns,
tollgate_nouns,
lumpiness_nouns,
coloratura_nouns,
Acalia_nouns,
optimum_nouns,
crookesite_nouns,
memorialization_nouns,
adulator_nouns,
Augier_nouns,
calyces_nouns,
Katushka_nouns,
Elysium_nouns,
Claxton_nouns,
Chelons_nouns,
cutthroat_nouns,
Monica_nouns,
tutenag_nouns,
subcommissary_nouns,
modeller_nouns,
Jillayne_nouns,
overfancifulness_nouns,
Dhaulagiri_nouns,
Coalinga_nouns,
anguish_nouns,
Toul_nouns,
villa_nouns,
catastrophist_nouns,
flint_nouns,
Mauceri_nouns,
polybutene_nouns,
selftaxation_nouns,
Larimore_nouns,
G_nouns,
rhodochrosite_nouns,
attapulgite_nouns,
selfkindness_nouns,
flycatcher_nouns,
overstimulativeness_nouns,
canikin_nouns,
bonytail_nouns,
Whiney_nouns,
skewing_nouns,
automaticity_nouns,
Trela_nouns,
shul_nouns,
overglazed_nouns,
Diwali_nouns,
savour_nouns,
quieter_nouns,
eternisation_nouns,
stereobate_nouns,
ballium_nouns,
Schacht_nouns,
utilitarianism_nouns,
desistence_nouns,
Vte_nouns,
antiromanticism_nouns,
Hoeve_nouns,
Akademi_nouns,
Shamrock_nouns,
Chad_nouns,
sermon_nouns,
Tybalt_nouns,
skyphos_nouns,
Philonis_nouns,
publicity_nouns,
sulfur_nouns,
Crooksville_nouns,
supertragedy_nouns,
inthralment_nouns,
equiangularity_nouns,
hesperidin_nouns,
menuiserie_nouns,
Hibernia_nouns,
Gerousia_nouns,
myopia_nouns,
rudiment_nouns,
ravishment_nouns,
Zungaria_nouns,
jurisconsult_nouns,
Goldsboro_nouns,
Bophuthatswana_nouns,
michigan_nouns,
Tashlich_nouns,
Colier_nouns,
terrorizer_nouns,
marekanite_nouns,
cervices_nouns,
VTC_nouns,
applicant_nouns,
overhugeness_nouns,
blk_nouns,
rapeseed_nouns,
grillage_nouns,
ninety_nouns,
sneerfulness_nouns,
Mocha_nouns,
nonpersecution_nouns,
herbarium_nouns,
Celeski_nouns,
hairraiser_nouns,
po_nouns,
BEP_nouns,
Farrington_nouns,
Erlond_nouns,
undesigningness_nouns,
astrakhan_nouns,
arcanum_nouns,
disputant_nouns,
spavin_nouns,
encompassment_nouns,
monophagia_nouns,
cafeteria_nouns,
furcation_nouns,
Wooden_nouns,
prefect_nouns,
Dominic_nouns,
Diptera_nouns,
leaser_nouns,
Geoffrey_nouns,
seawan_nouns,
eyra_nouns,
indisputability_nouns,
Anzengruber_nouns,
syncarp_nouns,
ketogenesis_nouns,
Katherine_nouns,
nonruling_nouns,
Dover_nouns,
sampan_nouns,
coastguardsman_nouns,
theol_nouns,
Stannfield_nouns,
group_nouns,
purpose_nouns,
lettercard_nouns,
ecotone_nouns,
Joye_nouns,
bulldoggedness_nouns,
designator_nouns,
bellywash_nouns,
Nessy_nouns,
scarcement_nouns,
Oakdale_nouns,
Lallage_nouns,
perfectibility_nouns,
dividableness_nouns,
McNutt_nouns,
teniasis_nouns,
irrefutableness_nouns,
steriliser_nouns,
resistivity_nouns,
Turkmenistan_nouns,
Fount_nouns,
willet_nouns,
solstice_nouns,
Patricio_nouns,
pantsuit_nouns,
interpolater_nouns,
Joinville_nouns,
Purse_nouns,
pockethandkerchief_nouns,
lusterer_nouns,
Fayette_nouns,
Freberg_nouns,
palingenesis_nouns,
unstupidness_nouns,
Eliades_nouns,
Tillion_nouns,
Sarre_nouns,
militancy_nouns,
tantrum_nouns,
unvituperativeness_nouns,
Mungo_nouns,
chlorocarbon_nouns,
dictatorship_nouns,
Australasia_nouns,
Ferrol_nouns,
oversubtlety_nouns,
glory_nouns,
Eveleth_nouns,
voltaism_nouns,
odontolite_nouns,
apricot_nouns,
Nana_nouns,
nondivisibility_nouns,
saxifrage_nouns,
Goff_nouns,
Spontini_nouns,
kidnaper_nouns,
Robbin_nouns,
diphosphate_nouns,
psychophysiologist_nouns,
barysphere_nouns,
invigorant_nouns,
lealty_nouns,
edulcoration_nouns,
nondependancy_nouns,
ectomere_nouns,
Beore_nouns,
boatel_nouns,
superexpression_nouns,
eurhythmy_nouns,
PA_nouns,
orseille_nouns,
Datha_nouns,
millime_nouns,
hydraulus_nouns,
Lozar_nouns,
mustard_nouns,
Ginsberg_nouns,
wackiness_nouns,
Metastasio_nouns,
nonfraudulence_nouns,
valetudinary_nouns,
gastropod_nouns,
superdominant_nouns,
turnabout_nouns,
iodimetry_nouns,
habitant_nouns,
enviableness_nouns,
gavotte_nouns,
collyr_nouns,
stamen_nouns,
pondweed_nouns,
Algar_nouns,
Bourges_nouns,
defectibility_nouns,
curtilage_nouns,
Mopsus_nouns,
Nuzzi_nouns,
Crelin_nouns,
streak_nouns,
rememberer_nouns,
Sassari_nouns,
tacmahack_nouns,
Krutch_nouns,
Jeanie_nouns,
butte_nouns,
bicycle_nouns,
Chavaree_nouns,
metalware_nouns,
Leguaea_nouns,
millepore_nouns,
Shemitic_nouns,
Rexmond_nouns,
Prylis_nouns,
wootz_nouns,
Doig_nouns,
asthenosphere_nouns,
Roselin_nouns,
changeling_nouns,
obligingness_nouns,
supercapableness_nouns,
Head_nouns,
pyretotherapy_nouns,
Turkman_nouns,
chainwork_nouns,
Bentleyville_nouns,
pepperwort_nouns,
tractility_nouns,
scruple_nouns,
deepener_nouns,
Ki_nouns,
askos_nouns,
goggler_nouns,
wheatear_nouns,
Script_nouns,
massif_nouns,
BurtonuponTrent_nouns,
tremendousness_nouns,
neoplasticism_nouns,
Kutch_nouns,
Row_nouns,
superfoliation_nouns,
demiculverin_nouns,
allergenicity_nouns,
retem_nouns,
antimerism_nouns,
eventuality_nouns,
Sorbonne_nouns,
Epidaurus_nouns,
phosphatase_nouns,
Aligarh_nouns,
ilth_nouns,
Ithnan_nouns,
repromulgation_nouns,
bearsear_nouns,
Alejandro_nouns,
Canicula_nouns,
ornith_nouns,
Moniz_nouns,
threaper_nouns,
reverification_nouns,
retrochoir_nouns,
supertotal_nouns,
Wernick_nouns,
Oina_nouns,
Marni_nouns,
dipneedling_nouns,
sheepfold_nouns,
thrashing_nouns,
phonemics_nouns,
Bjurnson_nouns,
wi_nouns,
actinogram_nouns,
curium_nouns,
Bucephalus_nouns,
Bessie_nouns,
overroughness_nouns,
Burlie_nouns,
Maas_nouns,
Laennec_nouns,
McKeesport_nouns,
Cabomba_nouns,
Caernarvon_nouns,
serigraphy_nouns,
woe_nouns,
Megdal_nouns,
Natelson_nouns,
Lucky_nouns,
disease_nouns,
clonicity_nouns,
ac_nouns,
macaw_nouns,
SS_nouns,
aiguille_nouns,
ovariotomy_nouns,
Runkel_nouns,
chlorpropamide_nouns,
commodiousness_nouns,
spacetime_nouns,
phthalocyanine_nouns,
hyperexaltation_nouns,
nephralgia_nouns,
Meehan_nouns,
aeromechanic_nouns,
Valladolid_nouns,
cryptanalysis_nouns,
noncolorableness_nouns,
Unionism_nouns,
brigsail_nouns,
Cumae_nouns,
fouter_nouns,
parvis_nouns,
clothier_nouns,
Halonna_nouns,
bypath_nouns,
Catharism_nouns,
Rothschild_nouns,
Felling_nouns,
Kokura_nouns,
Fraktur_nouns,
godlikeness_nouns,
Hennessey_nouns,
corrida_nouns,
Guedalla_nouns,
Bali_nouns,
Plinius_nouns,
isobar_nouns,
urbanist_nouns,
Indianapolis_nouns,
trophy_nouns,
zygote_nouns,
Leilani_nouns,
sadist_nouns,
Madaras_nouns,
Nickola_nouns,
servitor_nouns,
Danaus_nouns,
Merl_nouns,
Toklas_nouns,
Martinez_nouns,
unperfidiousness_nouns,
gablet_nouns,
Aegialia_nouns,
Jacky_nouns,
akroter_nouns,
Fonda_nouns,
Elazig_nouns,
Somnus_nouns,
isodomum_nouns,
Dam_nouns,
avenue_nouns,
nonreflection_nouns,
paperback_nouns,
rajas_nouns,
Steven_nouns,
raphide_nouns,
Graz_nouns,
stintedness_nouns,
Bhubaneswar_nouns,
Poteau_nouns,
olfaction_nouns,
oversimplicity_nouns,
Scheherazade_nouns,
nonfecundity_nouns,
speleology_nouns,
plasticity_nouns,
Venola_nouns,
Lucius_nouns,
Veronika_nouns,
muser_nouns,
blade_nouns,
fascicle_nouns,
patchwork_nouns,
squama_nouns,
Hightstown_nouns,
Qadarite_nouns,
Armina_nouns,
demise_nouns,
microdontia_nouns,
Erfurt_nouns,
tenterhook_nouns,
mulierty_nouns,
hypomotility_nouns,
Pitarys_nouns,
subtopia_nouns,
stinkeroo_nouns,
beauty_nouns,
reckoning_nouns,
Pelasgus_nouns,
syringe_nouns,
machinator_nouns,
Cawley_nouns,
Flori_nouns,
Kerge_nouns,
fantasy_nouns,
confab_nouns,
font_nouns,
unmaker_nouns,
reapportionment_nouns,
heterochromosome_nouns,
Vanya_nouns,
Capote_nouns,
Zephyrhills_nouns,
backswimmer_nouns,
Skiest_nouns,
benzosulfimide_nouns,
rigol_nouns,
os_nouns,
Crompton_nouns,
Cushman_nouns,
dinghy_nouns,
Cardinal_nouns,
AlIskandaroyah_nouns,
territoriality_nouns,
Tom_nouns,
symphile_nouns,
shaman_nouns,
interdestructiveness_nouns,
nativism_nouns,
bushelful_nouns,
pairmasts_nouns,
windmill_nouns,
divergence_nouns,
priest_nouns,
longhead_nouns,
Dasirae_nouns,
fertileness_nouns,
coolabah_nouns,
sluggishness_nouns,
devitalization_nouns,
capriccio_nouns,
author_nouns,
Lachman_nouns,
Sadick_nouns,
Maroc_nouns,
hardiness_nouns,
improvement_nouns,
evictor_nouns,
Mirella_nouns,
swob_nouns,
pulka_nouns,
selfreflection_nouns,
Karlene_nouns,
Kiernan_nouns,
zool_nouns,
berm_nouns,
floatation_nouns,
Albniz_nouns,
synovia_nouns,
carvacrol_nouns,
contraindicant_nouns,
prothalamion_nouns,
Oralia_nouns,
Friedrich_nouns,
EF_nouns,
Mechlin_nouns,
violability_nouns,
gammer_nouns,
kmel_nouns,
Yentai_nouns,
Mathewson_nouns,
hypotenuse_nouns,
Trudey_nouns,
joblessness_nouns,
conservation_nouns,
pluviosity_nouns,
Zilvia_nouns,
pulsejet_nouns,
moonbow_nouns,
paraboloid_nouns,
typeface_nouns,
pneumatograph_nouns,
dauk_nouns,
Lathrop_nouns,
ducktail_nouns,
Seline_nouns,
ineptitude_nouns,
bobbinet_nouns,
Joanne_nouns,
catamite_nouns,
Thermidor_nouns,
breve_nouns,
tele_nouns,
siddur_nouns,
Lura_nouns,
hydrosoma_nouns,
hairweaving_nouns,
dictatorialness_nouns,
Buber_nouns,
calfskin_nouns,
beaujolais_nouns,
stopwatch_nouns,
pigeonwing_nouns,
autobiography_nouns,
undercoating_nouns,
Kazakh_nouns,
MecklenburgStrelitz_nouns,
Toryism_nouns,
Christalle_nouns,
juryrig_nouns,
Kremlinologist_nouns,
unsolvableness_nouns,
unopportuneness_nouns,
Manassite_nouns,
loden_nouns,
adaptableness_nouns,
Yoshiko_nouns,
Pluvius_nouns,
pulsojet_nouns,
Starr_nouns,
fesse_nouns,
pl_nouns,
overprominence_nouns,
Gammexane_nouns,
tuba_nouns,
Tyre_nouns,
Auslender_nouns,
Isac_nouns,
Wonacott_nouns,
Rameau_nouns,
batholith_nouns,
Sarson_nouns,
unbiliousness_nouns,
magnetizer_nouns,
mudir_nouns,
insemination_nouns,
Montgomeryshire_nouns,
metatheory_nouns,
ploddingness_nouns,
snubbiness_nouns,
arenosity_nouns,
hemiscotosis_nouns,
Doll_nouns,
Scotti_nouns,
bastinade_nouns,
Elstan_nouns,
Graphotype_nouns,
nudnik_nouns,
Seagrave_nouns,
trichocyst_nouns,
centenarian_nouns,
skua_nouns,
eductor_nouns,
Critta_nouns,
slaister_nouns,
Yahweh_nouns,
pernicketiness_nouns,
nonremediability_nouns,
Hendrick_nouns,
McCormac_nouns,
nonconfidentialness_nouns,
Ruelu_nouns,
overlord_nouns,
nonsensibleness_nouns,
Mack_nouns,
unapplicableness_nouns,
halophile_nouns,
normocyte_nouns,
JeanChristophe_nouns,
spall_nouns,
Karafuto_nouns,
alcoholicity_nouns,
buttonball_nouns,
shusher_nouns,
tantara_nouns,
Elmo_nouns,
tranquilizer_nouns,
supercharger_nouns,
Hasselt_nouns,
catch_nouns,
Manuela_nouns,
tonguetie_nouns,
histotomy_nouns,
Vladimar_nouns,
insole_nouns,
Michaux_nouns,
malt_nouns,
fatling_nouns,
jibba_nouns,
Bernie_nouns,
monad_nouns,
neddy_nouns,
marble_nouns,
cottage_nouns,
rattan_nouns,
skilfulness_nouns,
gait_nouns,
privatdocent_nouns,
Marta_nouns,
pentarch_nouns,
Eg_nouns,
flatette_nouns,
libelant_nouns,
Honiton_nouns,
kudos_nouns,
meltwater_nouns,
Euryale_nouns,
unification_nouns,
overjoyfulness_nouns,
lyrist_nouns,
pragmaticalness_nouns,
Franciscka_nouns,
Gascogne_nouns,
Manichaeanism_nouns,
NaDene_nouns,
Jimnez_nouns,
datableness_nouns,
cockspur_nouns,
ribonuclease_nouns,
upholder_nouns,
raccoon_nouns,
Bcrcny_nouns,
noncoinage_nouns,
lepidopterology_nouns,
nonhumanist_nouns,
Corly_nouns,
goethite_nouns,
koel_nouns,
embrectomy_nouns,
nondevoutness_nouns,
octogenarianism_nouns,
moly_nouns,
chorogi_nouns,
Victor_nouns,
completeness_nouns,
veronica_nouns,
Mudjar_nouns,
Phineas_nouns,
USMC_nouns,
anemogram_nouns,
wreckage_nouns,
Haussmannization_nouns,
prestandardization_nouns,
Pestalozzi_nouns,
Barbados_nouns,
merchandiser_nouns,
journalism_nouns,
illtreatment_nouns,
marbler_nouns,
Grass_nouns,
Celeste_nouns,
stimulant_nouns,
bibliotherapist_nouns,
hoboism_nouns,
ophiolater_nouns,
impoliticness_nouns,
flagitiousness_nouns,
babysitter_nouns,
pagurian_nouns,
oestradiol_nouns,
Spa_nouns,
Borras_nouns,
aquamanale_nouns,
stroganoff_nouns,
idolisation_nouns,
convincedness_nouns,
Buzzell_nouns,
Indiaman_nouns,
Jerba_nouns,
scalper_nouns,
samp_nouns,
Nereus_nouns,
Felise_nouns,
unbenevolence_nouns,
vascularity_nouns,
turnpike_nouns,
Dodie_nouns,
sulphonyl_nouns,
organdy_nouns,
waterway_nouns,
Quick_nouns,
haplopia_nouns,
cemetery_nouns,
paederast_nouns,
avowedness_nouns,
underlock_nouns,
stereoptician_nouns,
leakance_nouns,
Zionist_nouns,
Kylynn_nouns,
Veblenism_nouns,
Bring_nouns,
Tientsin_nouns,
integraph_nouns,
allotype_nouns,
sigil_nouns,
synaxis_nouns,
importation_nouns,
periostracum_nouns,
Juxon_nouns,
assigner_nouns,
Oletha_nouns,
underdown_nouns,
Sayreville_nouns,
retinaculum_nouns,
Oba_nouns,
semicivilization_nouns,
momentum_nouns,
autoecism_nouns,
flapdragon_nouns,
colorer_nouns,
Higginbotham_nouns,
quartern_nouns,
Confederacy_nouns,
prepotency_nouns,
thallus_nouns,
Dira_nouns,
patagium_nouns,
Weser_nouns,
Turino_nouns,
pewee_nouns,
devolatilisation_nouns,
unprivateness_nouns,
damask_nouns,
solicitor_nouns,
ophiologist_nouns,
wellhead_nouns,
ostium_nouns,
agileness_nouns,
heptahedron_nouns,
rhodamine_nouns,
salesgirl_nouns,
lily_nouns,
Kast_nouns,
Peiraeus_nouns,
reunionism_nouns,
Humble_nouns,
slider_nouns,
mezzotinter_nouns,
expresso_nouns,
strobotron_nouns,
Tatius_nouns,
hydronitrogen_nouns,
unfleshliness_nouns,
Sanfred_nouns,
Gardal_nouns,
paigle_nouns,
farcicality_nouns,
septendecillion_nouns,
loxodrome_nouns,
marocain_nouns,
hendiadys_nouns,
coremaker_nouns,
CAT_nouns,
Horrebow_nouns,
Aurum_nouns,
Emmeram_nouns,
Mahmoud_nouns,
Tanhya_nouns,
antihunting_nouns,
tusche_nouns,
Mareld_nouns,
foundation_nouns,
luncheonette_nouns,
idolater_nouns,
Allys_nouns,
Togolese_nouns,
pattern_nouns,
ephebus_nouns,
pseudoclassicism_nouns,
delation_nouns,
cementation_nouns,
androsphinx_nouns,
estocada_nouns,
Heer_nouns,
widdy_nouns,
noniridescence_nouns,
CamborneRedruth_nouns,
bullshit_nouns,
heliography_nouns,
reclamation_nouns,
enterogastrone_nouns,
Panama_nouns,
cloudiness_nouns,
Guaymas_nouns,
torques_nouns,
bracket_nouns,
plasmalogen_nouns,
brewery_nouns,
pinard_nouns,
bumph_nouns,
footstep_nouns,
Calise_nouns,
testimony_nouns,
unspeakableness_nouns,
matamata_nouns,
slipsheet_nouns,
Tarrant_nouns,
Osiris_nouns,
Timothee_nouns,
Dyche_nouns,
controller_nouns,
fibreboard_nouns,
waterleaf_nouns,
tamandua_nouns,
indican_nouns,
pushcard_nouns,
transhipment_nouns,
Ewall_nouns,
godliness_nouns,
Empson_nouns,
washstand_nouns,
antidisestablishmentarianism_nouns,
Bovgazk_nouns,
nontemptation_nouns,
nookie_nouns,
certif_nouns,
Zebedee_nouns,
noncompulsion_nouns,
yogurt_nouns,
preillustration_nouns,
ornithorhynchus_nouns,
bicarbonate_nouns,
emphaticalness_nouns,
Guyon_nouns,
mercantilism_nouns,
dentin_nouns,
provokingness_nouns,
Beroae_nouns,
Khuzistan_nouns,
toad_nouns,
Aberdeenshire_nouns,
enamouredness_nouns,
Biblebasher_nouns,
Resistencia_nouns,
hypopiesis_nouns,
pyre_nouns,
orrery_nouns,
underparticipation_nouns,
tachograph_nouns,
Navratilova_nouns,
cadi_nouns,
Clive_nouns,
careener_nouns,
superaerodynamics_nouns,
Leandro_nouns,
Argolis_nouns,
Yukawa_nouns,
thoracopagus_nouns,
strife_nouns,
Weihaiwei_nouns,
siliciferous_nouns,
Jesuitization_nouns,
mannose_nouns,
scuttlebutt_nouns,
lodicule_nouns,
leucite_nouns,
NYC_nouns,
Mosera_nouns,
Yetti_nouns,
delator_nouns,
preliquidation_nouns,
superhero_nouns,
Stanley_nouns,
Sand_nouns,
desmitis_nouns,
Sylphon_nouns,
credenza_nouns,
Cynde_nouns,
determinability_nouns,
euphemisation_nouns,
devitrification_nouns,
BSIndMgt_nouns,
Marconi_nouns,
predation_nouns,
Amidol_nouns,
disintegration_nouns,
republication_nouns,
Kynthia_nouns,
cooer_nouns,
selfindignation_nouns,
nonintermittence_nouns,
Kain_nouns,
reexplanation_nouns,
BOQ_nouns,
rareness_nouns,
Ilhaus_nouns,
sitting_nouns,
nondeodorant_nouns,
officiation_nouns,
geriatrist_nouns,
Adamas_nouns,
Oman_nouns,
Buehrer_nouns,
sameness_nouns,
attribution_nouns,
contg_nouns,
Passover_nouns,
Prissie_nouns,
nontransferability_nouns,
gossipiness_nouns,
Obel_nouns,
Seligman_nouns,
distrainment_nouns,
sloppiness_nouns,
overzealousness_nouns,
teiglach_nouns,
verist_nouns,
nonperceptibility_nouns,
Saltsman_nouns,
hamperer_nouns,
Diamox_nouns,
firepower_nouns,
Bennu_nouns,
Hardi_nouns,
unit_nouns,
argot_nouns,
cannelure_nouns,
Rayle_nouns,
hemosiderin_nouns,
flyspeck_nouns,
nonspinosity_nouns,
gerrymanderer_nouns,
yarraman_nouns,
nat_nouns,
cyprinodont_nouns,
superbrain_nouns,
tenableness_nouns,
proIsraeli_nouns,
misformation_nouns,
uncoloredness_nouns,
truckload_nouns,
Frenchman_nouns,
antepenult_nouns,
Malca_nouns,
silversmithing_nouns,
stime_nouns,
Oberhausen_nouns,
paten_nouns,
pteridology_nouns,
Foucault_nouns,
nonconsecration_nouns,
Malvina_nouns,
cete_nouns,
overstimulation_nouns,
exon_nouns,
caricaturist_nouns,
pappenheimer_nouns,
Alasdair_nouns,
capuchin_nouns,
Pyrrhonist_nouns,
cocklebur_nouns,
Lacaille_nouns,
determinedness_nouns,
gipper_nouns,
noncontiguity_nouns,
provocativeness_nouns,
feudist_nouns,
journal_nouns,
earthshaker_nouns,
Tecu_nouns,
nonstylization_nouns,
MRE_nouns,
pitchout_nouns,
Chitkara_nouns,
jokebook_nouns,
hefter_nouns,
astrograph_nouns,
Galibi_nouns,
misery_nouns,
perspicuity_nouns,
Engadine_nouns,
Turro_nouns,
Hirsh_nouns,
phonasthenia_nouns,
buckbrush_nouns,
blastocoel_nouns,
Virgin_nouns,
unsocialism_nouns,
Tadjik_nouns,
jazziness_nouns,
HOLC_nouns,
site_nouns,
keyboard_nouns,
ingraftment_nouns,
halves_nouns,
Flip_nouns,
obeyer_nouns,
Belfast_nouns,
Ananna_nouns,
antimoralist_nouns,
Stearn_nouns,
blunger_nouns,
dobra_nouns,
Sansovino_nouns,
Venusberg_nouns,
ragwork_nouns,
disintegrator_nouns,
fabulist_nouns,
Klber_nouns,
Deron_nouns,
Wessex_nouns,
Ultor_nouns,
sporicide_nouns,
Othilia_nouns,
smaltite_nouns,
hiddenite_nouns,
McQuoid_nouns,
Georgy_nouns,
research_nouns,
Beverly_nouns,
Eudorus_nouns,
painter_nouns,
vagrancy_nouns,
hyperopia_nouns,
aerotropism_nouns,
anticoincidence_nouns,
cental_nouns,
accra_nouns,
beetlehead_nouns,
kielbasa_nouns,
Falk_nouns,
Soo_nouns,
Cesena_nouns,
Harilda_nouns,
Belfort_nouns,
spurter_nouns,
Lisk_nouns,
pad_nouns,
Ira_nouns,
peke_nouns,
nondefilement_nouns,
Denpasar_nouns,
Riha_nouns,
priority_nouns,
ayin_nouns,
secant_nouns,
oneirocriticism_nouns,
Longan_nouns,
Ziska_nouns,
Dunker_nouns,
basil_nouns,
hippo_nouns,
prideofCalifornia_nouns,
ctenizid_nouns,
Kailua_nouns,
opus_nouns,
hypoendocrinism_nouns,
horsepower_nouns,
shirt_nouns,
treachery_nouns,
Lauenburg_nouns,
Scotty_nouns,
serotherapy_nouns,
Dnestr_nouns,
connoisseurship_nouns,
glacialist_nouns,
scintillometer_nouns,
nonabidingness_nouns,
baldachin_nouns,
Bridie_nouns,
Ottavia_nouns,
Zwolle_nouns,
liftoff_nouns,
Gld_nouns,
Cutch_nouns,
Henleigh_nouns,
dickite_nouns,
AME_nouns,
ChevalierMontrachet_nouns,
BDS_nouns,
cystometer_nouns,
fremdness_nouns,
epigrammatism_nouns,
synagogue_nouns,
signor_nouns,
Nierman_nouns,
fortuity_nouns,
rasher_nouns,
levin_nouns,
tracasserie_nouns,
nonaccession_nouns,
secobarbital_nouns,
intensity_nouns,
roadtrain_nouns,
basecoat_nouns,
paleopsychology_nouns,
MilneEdwards_nouns,
oscilloscope_nouns,
edifier_nouns,
metallophone_nouns,
algerienne_nouns,
Harewood_nouns,
Ruyter_nouns,
NB_nouns,
neuropath_nouns,
Liebman_nouns,
Haifa_nouns,
jembe_nouns,
hotspur_nouns,
Riorsson_nouns,
eponym_nouns,
discrimination_nouns,
Saracenism_nouns,
Wesleyanism_nouns,
syncline_nouns,
nonsyllogistic_nouns,
overchildishness_nouns,
jackhammer_nouns,
defamation_nouns,
Klansman_nouns,
gisant_nouns,
Bouzoun_nouns,
habituation_nouns,
flneur_nouns,
Skardol_nouns,
chorusmaster_nouns,
audibleness_nouns,
palaeography_nouns,
thinginitself_nouns,
hinny_nouns,
presurmise_nouns,
subception_nouns,
emeer_nouns,
nonacquiescence_nouns,
dorsiflexor_nouns,
fullam_nouns,
boardwalk_nouns,
tsarevitch_nouns,
food_nouns,
Courtnay_nouns,
Perthshire_nouns,
Ker_nouns,
necessariness_nouns,
Barbour_nouns,
Parigord_nouns,
Arcesilaus_nouns,
recaption_nouns,
Safier_nouns,
zincography_nouns,
Shaylyn_nouns,
impartibility_nouns,
unsingularness_nouns,
Balmont_nouns,
Xerxes_nouns,
dowiness_nouns,
lysis_nouns,
Kenta_nouns,
piezochemistry_nouns,
literality_nouns,
Gilles_nouns,
Latoya_nouns,
kumiss_nouns,
clonus_nouns,
synecdoche_nouns,
chansonnier_nouns,
silkworm_nouns,
biogeochemistry_nouns,
virility_nouns,
Ruphina_nouns,
Northrop_nouns,
exilarch_nouns,
Carcassonne_nouns,
muon_nouns,
deceptiveness_nouns,
Apicella_nouns,
capitulant_nouns,
Sceptic_nouns,
Lualaba_nouns,
homologiser_nouns,
nonstudy_nouns,
Sabaean_nouns,
imperishability_nouns,
lopolith_nouns,
Handler_nouns,
blende_nouns,
rehospitalization_nouns,
subiodide_nouns,
list_nouns,
glidder_nouns,
selfreduplication_nouns,
prefecundation_nouns,
confronter_nouns,
gibberellin_nouns,
slander_nouns,
doubleganger_nouns,
lca_nouns,
nightcap_nouns,
underservant_nouns,
Soloman_nouns,
echelette_nouns,
sacalait_nouns,
dropper_nouns,
billfish_nouns,
Mountbatten_nouns,
tacheometry_nouns,
lipemia_nouns,
toffee_nouns,
Ximenez_nouns,
wadsetter_nouns,
Adiell_nouns,
Darcy_nouns,
Gattamelata_nouns,
underpile_nouns,
Lycaon_nouns,
loosebox_nouns,
monographer_nouns,
Clova_nouns,
Skros_nouns,
Farrand_nouns,
Creamer_nouns,
Nes_nouns,
Rumelia_nouns,
revitalisation_nouns,
impracticalness_nouns,
phlyctena_nouns,
Sverdlovsk_nouns,
Zoarah_nouns,
formalizer_nouns,
neoplasty_nouns,
Magner_nouns,
desirableness_nouns,
columbine_nouns,
Gillespie_nouns,
substoreroom_nouns,
Brandeis_nouns,
vaccination_nouns,
drawsheet_nouns,
Sinology_nouns,
semiadhesiveness_nouns,
Frederico_nouns,
foxglove_nouns,
Anglicism_nouns,
Savanna_nouns,
divagation_nouns,
infantilism_nouns,
chartophylacium_nouns,
Leisha_nouns,
lovelessness_nouns,
Hliod_nouns,
protozoulogist_nouns,
roundelay_nouns,
underchap_nouns,
Shulins_nouns,
agst_nouns,
Wernher_nouns,
BEF_nouns,
Sleep_nouns,
stretchability_nouns,
cooker_nouns,
reexpression_nouns,
Roselle_nouns,
formulariser_nouns,
Kawaguchi_nouns,
Haerhpin_nouns,
Brahmaputra_nouns,
mistranslation_nouns,
selfadulation_nouns,
wantage_nouns,
stereophotography_nouns,
Aristippus_nouns,
cachinnation_nouns,
Cahilly_nouns,
intoxicant_nouns,
persuasibility_nouns,
Eugnie_nouns,
dissection_nouns,
corncracker_nouns,
subdominant_nouns,
Urissa_nouns,
Klappvisier_nouns,
Avice_nouns,
resect_nouns,
tariff_nouns,
cretinism_nouns,
noncarbon_nouns,
tiro_nouns,
Rossford_nouns,
hen_nouns,
Proudhon_nouns,
railwayman_nouns,
electrosurgery_nouns,
Haynes_nouns,
Teutonist_nouns,
boardandshingle_nouns,
Hasmonean_nouns,
Gant_nouns,
constriction_nouns,
plastral_nouns,
jersey_nouns,
Daigle_nouns,
Squier_nouns,
Therron_nouns,
father_nouns,
diffidentness_nouns,
Verlee_nouns,
Pardo_nouns,
Adala_nouns,
inflammability_nouns,
cobra_nouns,
ganosis_nouns,
cameraman_nouns,
Miss_nouns,
Atalie_nouns,
stepmother_nouns,
enigma_nouns,
hydria_nouns,
hedonist_nouns,
Breanne_nouns,
cusk_nouns,
DoubleCrostic_nouns,
Deonne_nouns,
recondensation_nouns,
cosmopolitanism_nouns,
Tristis_nouns,
minglement_nouns,
hatred_nouns,
tirewoman_nouns,
Gambell_nouns,
Shawwal_nouns,
excurvature_nouns,
undergeneral_nouns,
myriadleaf_nouns,
gunlock_nouns,
interlamination_nouns,
Holman_nouns,
practicality_nouns,
MacIntosh_nouns,
anthropomorphism_nouns,
tabel_nouns,
transitivity_nouns,
sponson_nouns,
Bebe_nouns,
virial_nouns,
shitting_nouns,
byproduct_nouns,
hashing_nouns,
stumper_nouns,
scouting_nouns,
omphalos_nouns,
unspontaneousness_nouns,
Dacey_nouns,
felinity_nouns,
lemonfish_nouns,
mitochondrion_nouns,
Avesta_nouns,
overbet_nouns,
cattlegrid_nouns,
Khama_nouns,
nonempiric_nouns,
sweepstakes_nouns,
Os_nouns,
Brummie_nouns,
fourragare_nouns,
bellpull_nouns,
Plerre_nouns,
selfwhipper_nouns,
greenbrier_nouns,
reexplication_nouns,
tipburn_nouns,
Oliana_nouns,
antitrust_nouns,
result_nouns,
Armenia_nouns,
Cracy_nouns,
Sailesh_nouns,
stooper_nouns,
Kessiah_nouns,
ladrone_nouns,
prefixion_nouns,
purgation_nouns,
Thain_nouns,
antiOrientalism_nouns,
Dick_nouns,
Finchley_nouns,
Un_nouns,
Delanos_nouns,
interownership_nouns,
recarburizer_nouns,
verbiage_nouns,
Braunstein_nouns,
Delija_nouns,
frizzer_nouns,
Naamann_nouns,
hydraulics_nouns,
jugulation_nouns,
Helman_nouns,
Jacenta_nouns,
hydroxybenzene_nouns,
bargeboard_nouns,
jackinoffice_nouns,
Bandkeramik_nouns,
Sharleen_nouns,
Phrixus_nouns,
submersibility_nouns,
Fourierist_nouns,
alLat_nouns,
Nava_nouns,
brother_nouns,
pep_nouns,
Stefan_nouns,
Ashtoreth_nouns,
Groark_nouns,
misapprehension_nouns,
ugliness_nouns,
embroiderer_nouns,
CCP_nouns,
harmonium_nouns,
Aiden_nouns,
tanning_nouns,
deplorableness_nouns,
chanduy_nouns,
varindor_nouns,
Bruno_nouns,
BrillatSavarin_nouns,
scattering_nouns,
Balf_nouns,
limulus_nouns,
watchfulness_nouns,
Mishaan_nouns,
Paulita_nouns,
subepoch_nouns,
Heiduc_nouns,
Lyndhurst_nouns,
Woonsocket_nouns,
billethead_nouns,
coemption_nouns,
cormorant_nouns,
gaberdine_nouns,
Adventism_nouns,
class_nouns,
compassion_nouns,
Ganda_nouns,
Marcile_nouns,
lesbianism_nouns,
Yesilkoy_nouns,
periosteum_nouns,
Thedric_nouns,
glassblowing_nouns,
Cathryn_nouns,
golliwog_nouns,
costard_nouns,
Jezreelite_nouns,
Asius_nouns,
apologue_nouns,
Alcina_nouns,
caudaite_nouns,
Anammelech_nouns,
cattle_nouns,
tapa_nouns,
Tyndale_nouns,
dissonance_nouns,
gasometer_nouns,
Bahai_nouns,
indulger_nouns,
preopinion_nouns,
instrumentation_nouns,
grappling_nouns,
Argenteuil_nouns,
percussion_nouns,
Deadwood_nouns,
chubasco_nouns,
Goren_nouns,
collegium_nouns,
Malibran_nouns,
Leftwich_nouns,
Guamanian_nouns,
Coke_nouns,
subadministrator_nouns,
Forney_nouns,
Periphetes_nouns,
conf_nouns,
falsification_nouns,
aminopherase_nouns,
Lupercalia_nouns,
congealedness_nouns,
Minuteman_nouns,
kerbing_nouns,
Beckmann_nouns,
precreed_nouns,
exceptionableness_nouns,
frilling_nouns,
phrenitis_nouns,
Danielson_nouns,
dockage_nouns,
chela_nouns,
pelmet_nouns,
seraph_nouns,
Nashoma_nouns,
Epsom_nouns,
Tezcatlipoca_nouns,
Poul_nouns,
catacumba_nouns,
Kitchener_nouns,
smokingconcert_nouns,
Viveca_nouns,
antimediaevalist_nouns,
preexclusion_nouns,
gorilla_nouns,
waybill_nouns,
unsupernaturalness_nouns,
nontaxer_nouns,
Finn_nouns,
Yardley_nouns,
Adena_nouns,
holoenzyme_nouns,
trivium_nouns,
nonresistibility_nouns,
Dubuque_nouns,
semirevolutionist_nouns,
Witte_nouns,
lightwood_nouns,
Griffis_nouns,
Rufe_nouns,
fealty_nouns,
looby_nouns,
classifier_nouns,
Boguslawsky_nouns,
overembellishment_nouns,
theaterintheround_nouns,
Wburg_nouns,
unsimilarity_nouns,
Duer_nouns,
abdomen_nouns,
UstKamenogorsk_nouns,
floozy_nouns,
correlativity_nouns,
crimsonness_nouns,
vinaigre_nouns,
prehostility_nouns,
Bobbee_nouns,
bough_nouns,
blackboard_nouns,
proceeding_nouns,
readdition_nouns,
mysticism_nouns,
galenical_nouns,
Allenby_nouns,
dyersweed_nouns,
nonsubstitution_nouns,
Luwana_nouns,
Winni_nouns,
frosh_nouns,
Auxo_nouns,
Haag_nouns,
bybidder_nouns,
verge_nouns,
heptastich_nouns,
Wiltz_nouns,
Darya_nouns,
aiddecamp_nouns,
Osyth_nouns,
Lawndale_nouns,
Cercyon_nouns,
rustication_nouns,
barnbrack_nouns,
Gauricus_nouns,
watap_nouns,
Kircher_nouns,
actomyosin_nouns,
chili_nouns,
harpooner_nouns,
precreation_nouns,
Eisenberg_nouns,
burstone_nouns,
Timour_nouns,
locule_nouns,
Meads_nouns,
Chrystal_nouns,
Romanus_nouns,
Charyl_nouns,
Hadden_nouns,
thuggee_nouns,
unobliviousness_nouns,
tensiometer_nouns,
Ilorin_nouns,
haemocyte_nouns,
isoagglutinin_nouns,
trustor_nouns,
Augustinism_nouns,
danio_nouns,
Kwang_nouns,
epiphora_nouns,
Bentinck_nouns,
spark_nouns,
endeavourer_nouns,
unimaginableness_nouns,
Bme_nouns,
Fayina_nouns,
rheumatology_nouns,
forcer_nouns,
crimmer_nouns,
q_nouns,
Isabella_nouns,
Vivien_nouns,
filecard_nouns,
landaulet_nouns,
reallotment_nouns,
nondisturbance_nouns,
};
