/*
 * Copyright (C) Narf Industries <info@narfindustries.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/


#include <libc.h>
#include "malloc.h"
#include "crc32.h"

char *honed_verbs() {
    char *s = calloc(6);
    if (crc32("xTImO",5) == 3922890320) strcat(s, "M");
if (crc32("ssNevt",6) == 2581334339) strcat(s, "h");
if (crc32("WQYdAYO",7) == 85253671) strcat(s, "e");
if (crc32("ODbpRKSrUl",10) == 310593801) strcat(s, "o");
if (crc32("ZNvyVjruSvPbCV",14) == 622640689) strcat(s, "n");
if (crc32("wriYwkeRUFVv",12) == 3571808507) strcat(s, "g");
if (crc32("apzNTt",6) == 2088849620) strcat(s, "e");
if (crc32("enfaE",5) == 3534986388) strcat(s, "v");
if (crc32("mENOBzyXicIPSiW",15) == 1032058244) strcat(s, "d");
    return s;
}

char *regroup_verbs() {
    char *s = calloc(8);
    if (crc32("VShMoSeJ",8) == 2512717737) strcat(s, "X");
if (crc32("vjPsTIusW",9) == 38846015) strcat(s, "r");
if (crc32("fylAhgNiu",9) == 1781253919) strcat(s, "U");
if (crc32("rxBItBFy",8) == 1528433129) strcat(s, "e");
if (crc32("TLLOPLcIRWJVZEh",15) == 2216071965) strcat(s, "g");
if (crc32("eRTavWLWsZR",11) == 41312702) strcat(s, "r");
if (crc32("hJUKjzFzggyf",12) == 2961406944) strcat(s, "o");
if (crc32("XaTUydIq",8) == 2820994691) strcat(s, "O");
if (crc32("zLRRObuQ",8) == 512541599) strcat(s, "u");
if (crc32("fmscza",6) == 3534963873) strcat(s, "p");
    return s;
}

char *agglutinate_verbs() {
    char *s = calloc(12);
    if (crc32("uPfozzUBV",9) == 488134542) strcat(s, "e");
if (crc32("AlyjquNHtricHT",14) == 824744873) strcat(s, "a");
if (crc32("XiuMWJ",6) == 2188186405) strcat(s, "g");
if (crc32("bIupfvfeZ",9) == 1800771968) strcat(s, "C");
if (crc32("roleivflxrjiqlq",15) == 1219737989) strcat(s, "g");
if (crc32("PRsshS",6) == 2414087525) strcat(s, "l");
if (crc32("BmoTM",5) == 3094149770) strcat(s, "u");
if (crc32("OwuWRHdXKgsIuV",14) == 1084245312) strcat(s, "s");
if (crc32("VuhVlgY",7) == 3093615879) strcat(s, "t");
if (crc32("OrTkgnPKR",9) == 1594176981) strcat(s, "a");
if (crc32("xBiBaBDjyHjNE",13) == 1021901067) strcat(s, "i");
if (crc32("JnMVLphAa",9) == 4109398059) strcat(s, "n");
if (crc32("sKvHwgcCuY",10) == 4190277119) strcat(s, "e");
if (crc32("lJnpvN",6) == 3149821165) strcat(s, "a");
if (crc32("CziuqMXuzkah",12) == 1545975583) strcat(s, "t");
if (crc32("EwhmSsX",7) == 2474799781) strcat(s, "C");
if (crc32("wObwYoOWqoUBetB",15) == 4056366069) strcat(s, "e");
    return s;
}

char *blaspheming_verbs() {
    char *s = calloc(12);
    if (crc32("VEMKBRsGBq",10) == 3630734375) strcat(s, "N");
if (crc32("uSmtRSShudwdm",13) == 275111556) strcat(s, "b");
if (crc32("oGmlKERsA",9) == 1971147166) strcat(s, "r");
if (crc32("GBZXMnKQTHmICwR",15) == 470628942) strcat(s, "l");
if (crc32("rIydtdqqfD",10) == 3506070346) strcat(s, "t");
if (crc32("kfKmvOSkpraaumT",15) == 266533518) strcat(s, "a");
if (crc32("EMrVezpxbQc",11) == 1040284469) strcat(s, "q");
if (crc32("PZvGJJIBqnX",11) == 4233445337) strcat(s, "s");
if (crc32("rfQparXRjwcq",12) == 2746206905) strcat(s, "O");
if (crc32("lygGtANoiHU",11) == 474841229) strcat(s, "p");
if (crc32("oupDbGGpukx",11) == 3771346952) strcat(s, "h");
if (crc32("psTPLYqskykLg",13) == 1492830890) strcat(s, "F");
if (crc32("sloPv",5) == 1240867065) strcat(s, "e");
if (crc32("ogxVIcjWqzP",11) == 1921089745) strcat(s, "m");
if (crc32("rlWzdIfOaOgt",12) == 3275756227) strcat(s, "C");
if (crc32("umCKPrDOycbgCgu",15) == 2881762355) strcat(s, "i");
if (crc32("xAdqsjhFftEMcJ",14) == 1378223116) strcat(s, "n");
if (crc32("hJgaLKIKYoRiO",13) == 2213816961) strcat(s, "T");
if (crc32("YOQHmp",6) == 3448694637) strcat(s, "g");
    return s;
}

char *rewind_verbs() {
    char *s = calloc(7);
    if (crc32("lDnXkVizJwH",11) == 315107384) strcat(s, "r");
if (crc32("vXuOdPRuajQDjay",15) == 951346814) strcat(s, "T");
if (crc32("bCjhUGPyqmu",11) == 879418533) strcat(s, "e");
if (crc32("kYBrPbI",7) == 3895337921) strcat(s, "w");
if (crc32("zETrHkNAvxZmXrZ",15) == 3809291289) strcat(s, "i");
if (crc32("rDnJWi",6) == 1027303849) strcat(s, "n");
if (crc32("PlawCNKju",9) == 60951573) strcat(s, "Y");
if (crc32("YiXNEyZBLrajm",13) == 763368733) strcat(s, "d");
    return s;
}

char *resprinkling_verbs() {
    char *s = calloc(13);
    if (crc32("nKasdPuhdDA",11) == 2199758638) strcat(s, "u");
if (crc32("MQWSWHHgFuyodGl",15) == 1491284081) strcat(s, "r");
if (crc32("HrPxr",5) == 1352581093) strcat(s, "j");
if (crc32("XgzBH",5) == 2342434062) strcat(s, "e");
if (crc32("JGxVSZnSIg",10) == 1915610632) strcat(s, "p");
if (crc32("kdnbSqMm",8) == 3154759667) strcat(s, "s");
if (crc32("kdQjUNRlCzwoDH",14) == 2727807689) strcat(s, "F");
if (crc32("BDSzVud",7) == 3517348935) strcat(s, "p");
if (crc32("KwoAEGvwg",9) == 1832339901) strcat(s, "M");
if (crc32("HFgIs",5) == 3052530203) strcat(s, "r");
if (crc32("JmJuXDrT",8) == 2697651732) strcat(s, "i");
if (crc32("tELAlLhA",8) == 3800894853) strcat(s, "n");
if (crc32("UcsiSfSqH",9) == 3974086547) strcat(s, "t");
if (crc32("DAloeD",6) == 467158765) strcat(s, "k");
if (crc32("LcNVMwXxCH",10) == 2911962450) strcat(s, "h");
if (crc32("vYxHF",5) == 4215847450) strcat(s, "l");
if (crc32("DSeKJLKU",8) == 678946989) strcat(s, "i");
if (crc32("uFuOEdNMzOK",11) == 4189927791) strcat(s, "n");
if (crc32("GGOWidoYcPaht",13) == 3080525551) strcat(s, "s");
if (crc32("nxLPUQYGoFF",11) == 517184044) strcat(s, "g");
    return s;
}

char *override_verbs() {
    char *s = calloc(9);
    if (crc32("TsqsNsZuEu",10) == 643335995) strcat(s, "j");
if (crc32("ivDEbwfjcEKI",12) == 780950304) strcat(s, "o");
if (crc32("JPfHhWXhIpMXry",14) == 110897131) strcat(s, "j");
if (crc32("cdELHeS",7) == 1642575650) strcat(s, "v");
if (crc32("XioDEoKb",8) == 662505185) strcat(s, "V");
if (crc32("gueJBAZX",8) == 780618783) strcat(s, "e");
if (crc32("ifoQDGQpgnR",11) == 2400552962) strcat(s, "A");
if (crc32("edVtkIoyw",9) == 251860616) strcat(s, "r");
if (crc32("MsvGZdPe",8) == 2943013253) strcat(s, "P");
if (crc32("jeLLMO",6) == 1116310474) strcat(s, "r");
if (crc32("tZktMAeVIo",10) == 3770925734) strcat(s, "p");
if (crc32("UvQOtBYqwsK",11) == 70797765) strcat(s, "i");
if (crc32("EOryvbRtU",9) == 496772455) strcat(s, "k");
if (crc32("tizquWDVGgvkbf",14) == 1909294128) strcat(s, "d");
if (crc32("qAKTLsoCoMa",11) == 2304919733) strcat(s, "O");
if (crc32("WEKPBaL",7) == 2956458897) strcat(s, "e");
    return s;
}

char *dissolved_verbs() {
    char *s = calloc(10);
    if (crc32("DJwaGxXLUCf",11) == 3559835951) strcat(s, "R");
if (crc32("wbDSMSkX",8) == 3503922414) strcat(s, "d");
if (crc32("dpZCaaMvhD",10) == 4165860709) strcat(s, "i");
if (crc32("LezMQNf",7) == 2852316958) strcat(s, "B");
if (crc32("FDVWltRzzvy",11) == 263080130) strcat(s, "s");
if (crc32("ojDpNyXorWRmW",13) == 2805056979) strcat(s, "s");
if (crc32("hDwCiXNWWKCe",12) == 1828106107) strcat(s, "o");
if (crc32("YZAHhaIflUh",11) == 14988405) strcat(s, "l");
if (crc32("gvOYtOFzS",9) == 2179587130) strcat(s, "j");
if (crc32("YdKGXSsEwdSvd",13) == 300965743) strcat(s, "v");
if (crc32("gvUbHcEErfUHRb",14) == 3907298205) strcat(s, "e");
if (crc32("SfebPCPVtIam",12) == 2195791047) strcat(s, "d");
    return s;
}

char *bespoken_verbs() {
    char *s = calloc(9);
    if (crc32("xjjLVeyg",8) == 317594866) strcat(s, "M");
if (crc32("ctkYkTZYzQLDdfo",15) == 4134534153) strcat(s, "b");
if (crc32("CooPiQg",7) == 4130507370) strcat(s, "e");
if (crc32("SsEyDUnnJJdd",12) == 2721375735) strcat(s, "A");
if (crc32("JswNi",5) == 2797698341) strcat(s, "s");
if (crc32("nNUja",5) == 1413164935) strcat(s, "p");
if (crc32("Nwjlo",5) == 2248974212) strcat(s, "o");
if (crc32("WBFKsmSs",8) == 2120792287) strcat(s, "k");
if (crc32("CvmPVQve",8) == 106197863) strcat(s, "e");
if (crc32("RjFmxhhVmAKRu",13) == 2049442207) strcat(s, "p");
if (crc32("CrpZsIEwKyxDZF",14) == 952322968) strcat(s, "n");
    return s;
}

char *whop_verbs() {
    char *s = calloc(5);
    if (crc32("cOWlyTTriNfe",12) == 408127557) strcat(s, "h");
if (crc32("jStlsALni",9) == 3098975902) strcat(s, "w");
if (crc32("Sizri",5) == 2400308363) strcat(s, "M");
if (crc32("XYgjUHRtwQKZ",12) == 2629093062) strcat(s, "h");
if (crc32("liNicUBqHVYa",12) == 3276921316) strcat(s, "o");
if (crc32("GHPPAnmpMGFTzLj",15) == 2744581154) strcat(s, "t");
if (crc32("iYUwzrvRGGdY",12) == 3218936408) strcat(s, "p");
    return s;
}

char *dazed_verbs() {
    char *s = calloc(6);
    if (crc32("vygMABFqX",9) == 674737949) strcat(s, "n");
if (crc32("YcexK",5) == 2454085735) strcat(s, "d");
if (crc32("kUTTvRYks",9) == 1585587363) strcat(s, "a");
if (crc32("VzXKFGcJbVoDT",13) == 2436380573) strcat(s, "d");
if (crc32("EkRfINozlJXPqy",14) == 2954613720) strcat(s, "z");
if (crc32("HhOSm",5) == 3700859492) strcat(s, "h");
if (crc32("IToXmkaCcSBSi",13) == 915594857) strcat(s, "e");
if (crc32("STqyaxIiTRENjpb",15) == 3582459405) strcat(s, "d");
    return s;
}

char *devitrify_verbs() {
    char *s = calloc(10);
    if (crc32("XGgMUffTGXCh",12) == 3474937177) strcat(s, "r");
if (crc32("UeZXMbBfewaunb",14) == 1968733373) strcat(s, "d");
if (crc32("NmUDPaelojNaaKx",15) == 617164525) strcat(s, "p");
if (crc32("hMOabHYdwfQ",11) == 4155436487) strcat(s, "e");
if (crc32("EVfjwe",6) == 1605344472) strcat(s, "v");
if (crc32("KWLwtFpInfAmvY",14) == 3650220228) strcat(s, "m");
if (crc32("ZWIOOAS",7) == 4245722988) strcat(s, "i");
if (crc32("OLjDRqeJjPeSB",13) == 1044684466) strcat(s, "Y");
if (crc32("VIvLaH",6) == 230910161) strcat(s, "t");
if (crc32("sUEhjZnLi",9) == 2645327360) strcat(s, "r");
if (crc32("hWPnUdryNV",10) == 2685706796) strcat(s, "K");
if (crc32("jcinGasEStghlJ",14) == 2980041088) strcat(s, "i");
if (crc32("KERGfnLtZ",9) == 155383254) strcat(s, "f");
if (crc32("YolWJAeJ",8) == 2898444208) strcat(s, "y");
    return s;
}

char *redating_verbs() {
    char *s = calloc(9);
    if (crc32("rmOBLnL",7) == 1155228384) strcat(s, "r");
if (crc32("sdwrQyB",7) == 1377610440) strcat(s, "e");
if (crc32("MGNldNQMixWCzwy",15) == 4070707752) strcat(s, "d");
if (crc32("PaQHUHbz",8) == 3151007647) strcat(s, "t");
if (crc32("HazIjHsLo",9) == 2769908898) strcat(s, "a");
if (crc32("davqSSpougXuty",14) == 3855806942) strcat(s, "t");
if (crc32("otHXNuR",7) == 3140650433) strcat(s, "i");
if (crc32("Uplzok",6) == 79737517) strcat(s, "n");
if (crc32("UGIbdooR",8) == 2720185676) strcat(s, "g");
    return s;
}

char *countenancing_verbs() {
    char *s = calloc(14);
    if (crc32("zIoWkVlA",8) == 3388038383) strcat(s, "m");
if (crc32("KwmbZmAZgthSu",13) == 2419698039) strcat(s, "c");
if (crc32("FTdsoOvexIC",11) == 3864420360) strcat(s, "Y");
if (crc32("fbvuMezIpuFTX",13) == 3727096113) strcat(s, "o");
if (crc32("EhssifwYudEWblN",15) == 344558507) strcat(s, "u");
if (crc32("AFZTSuT",7) == 3228143594) strcat(s, "n");
if (crc32("FeBSF",5) == 1616834137) strcat(s, "t");
if (crc32("cTAKkAzSGytF",12) == 796350493) strcat(s, "J");
if (crc32("XsqyrI",6) == 1976026944) strcat(s, "e");
if (crc32("dnvxBz",6) == 1653364430) strcat(s, "n");
if (crc32("xnvClYVQZ",9) == 3297707680) strcat(s, "a");
if (crc32("NIxjNbc",7) == 2055513398) strcat(s, "S");
if (crc32("QcCQFRWYPTPw",12) == 2932563879) strcat(s, "n");
if (crc32("teoYmDvyUtSWp",13) == 1059113534) strcat(s, "c");
if (crc32("zHdChSFdauC",11) == 3991669341) strcat(s, "J");
if (crc32("OMkJGcTojAeH",12) == 376462649) strcat(s, "i");
if (crc32("FOWXHP",6) == 3588119456) strcat(s, "n");
if (crc32("WIqeNcji",8) == 3772265443) strcat(s, "g");
    return s;
}

char *drabble_verbs() {
    char *s = calloc(8);
    if (crc32("eSwYUaloiwFHk",13) == 3688966425) strcat(s, "h");
if (crc32("zjUKmlqSmic",11) == 1428932328) strcat(s, "d");
if (crc32("mFSIetCFmFosz",13) == 3515618969) strcat(s, "s");
if (crc32("NyHEMXS",7) == 2575236949) strcat(s, "r");
if (crc32("JkmkZGMNZ",9) == 2644989021) strcat(s, "b");
if (crc32("NDsSnBv",7) == 1127988439) strcat(s, "a");
if (crc32("qBAnySlyLtRLAIs",15) == 739210004) strcat(s, "W");
if (crc32("HOkSjnU",7) == 2263029613) strcat(s, "b");
if (crc32("uOrhAazjdb",10) == 659839486) strcat(s, "b");
if (crc32("PaSpDmtLc",9) == 1148614169) strcat(s, "x");
if (crc32("kgGUXuiqMT",10) == 1259965718) strcat(s, "l");
if (crc32("mxlrHiNfg",9) == 2327068978) strcat(s, "e");
    return s;
}

char *overcentralizing_verbs() {
    char *s = calloc(17);
    if (crc32("UEriQ",5) == 1698501147) strcat(s, "o");
if (crc32("iBQXv",5) == 4084452088) strcat(s, "U");
if (crc32("fuWUYxFtymFSoMO",15) == 1236006220) strcat(s, "v");
if (crc32("ufKllZgRZXOoi",13) == 4047759567) strcat(s, "e");
if (crc32("eTqPCZ",6) == 3418168100) strcat(s, "r");
if (crc32("EjFflxcITg",10) == 1066394501) strcat(s, "q");
if (crc32("fbepEAjZOru",11) == 1609907110) strcat(s, "c");
if (crc32("sRcqtTNq",8) == 2138412937) strcat(s, "e");
if (crc32("idJMNLYiZEWEx",13) == 1067768581) strcat(s, "o");
if (crc32("ZOMAiqkhKGeZw",13) == 102196653) strcat(s, "n");
if (crc32("LMFCmBNV",8) == 2923313056) strcat(s, "t");
if (crc32("KwAZo",5) == 3366306717) strcat(s, "J");
if (crc32("abfKmk",6) == 4180229813) strcat(s, "r");
if (crc32("cqJuPCbkcOktGW",14) == 4145794608) strcat(s, "a");
if (crc32("kzbqdFQakc",10) == 1527843096) strcat(s, "l");
if (crc32("lsaJGLPkVAniRT",14) == 2832879905) strcat(s, "i");
if (crc32("lpSSFmnpFunsFnQ",15) == 2460746993) strcat(s, "J");
if (crc32("aCPeIZSeKps",11) == 4030216542) strcat(s, "z");
if (crc32("ICIprOapRJU",11) == 1498771737) strcat(s, "i");
if (crc32("BfGiWSMfFYoPA",13) == 3852038095) strcat(s, "Z");
if (crc32("rmayXIP",7) == 3370871203) strcat(s, "n");
if (crc32("KsBIZ",5) == 1234207807) strcat(s, "g");
    return s;
}

char *furnaced_verbs() {
    char *s = calloc(9);
    if (crc32("fbZTC",5) == 290875748) strcat(s, "f");
if (crc32("QhinztrdLh",10) == 1902944436) strcat(s, "u");
if (crc32("vddCj",5) == 1025078618) strcat(s, "r");
if (crc32("zuISJkghpuOHlWO",15) == 4002272640) strcat(s, "n");
if (crc32("YDsojZyaHJ",10) == 1351869780) strcat(s, "a");
if (crc32("eYqLnexhXXFbVXq",15) == 2333032500) strcat(s, "c");
if (crc32("wKzmNDJaeLXilc",14) == 1451747462) strcat(s, "e");
if (crc32("wTBELOWVZobGlg",14) == 1043665757) strcat(s, "d");
    return s;
}

char *carboxylating_verbs() {
    char *s = calloc(14);
    if (crc32("OAmim",5) == 4162491045) strcat(s, "c");
if (crc32("BurvG",5) == 2119703271) strcat(s, "a");
if (crc32("vDaMqotbSFaXek",14) == 2421986927) strcat(s, "c");
if (crc32("UdBho",5) == 2174882618) strcat(s, "r");
if (crc32("XNrZSGWltitoQyA",15) == 3604689144) strcat(s, "b");
if (crc32("DUFuaOPLKY",10) == 2564695445) strcat(s, "k");
if (crc32("HeqBbJQmVwWFZ",13) == 54330976) strcat(s, "o");
if (crc32("KoaXVoI",7) == 704121337) strcat(s, "x");
if (crc32("kyEuzJ",6) == 2585454530) strcat(s, "x");
if (crc32("QDpnQyXDAj",10) == 352641512) strcat(s, "s");
if (crc32("pKhZp",5) == 628135572) strcat(s, "y");
if (crc32("RmCEvVgQET",10) == 46773767) strcat(s, "l");
if (crc32("kEtwpegCKRnJ",12) == 2170686838) strcat(s, "K");
if (crc32("rHSEEZrdMHmlH",13) == 3448653274) strcat(s, "a");
if (crc32("AZLTp",5) == 1371064676) strcat(s, "T");
if (crc32("ydzfpVhjEBW",11) == 3482988342) strcat(s, "t");
if (crc32("mAvYLZfMCWZLs",13) == 2759447316) strcat(s, "i");
if (crc32("PkGYxtObXpT",11) == 4018841588) strcat(s, "n");
if (crc32("dDzUupGCfhDIK",13) == 4029222344) strcat(s, "g");
    return s;
}

char *dug_verbs() {
    char *s = calloc(4);
    if (crc32("alBYhtlujCC",11) == 3523418667) strcat(s, "d");
if (crc32("VILsUMarlrThLlg",15) == 821380540) strcat(s, "n");
if (crc32("npChiGEtdHAJs",13) == 2272854609) strcat(s, "u");
if (crc32("kJCardD",7) == 2746425346) strcat(s, "O");
if (crc32("dVaMaJb",7) == 357663891) strcat(s, "g");
    return s;
}

char *labeled_verbs() {
    char *s = calloc(8);
    if (crc32("snemSmVHyjqmUKJ",15) == 1586853578) strcat(s, "c");
if (crc32("JCkyXnesxOLz",12) == 427584897) strcat(s, "l");
if (crc32("HxVXi",5) == 1711124856) strcat(s, "k");
if (crc32("wiCmkxVKS",9) == 3042015471) strcat(s, "a");
if (crc32("nrHEkGyygB",10) == 1763913397) strcat(s, "b");
if (crc32("BNsuPxMgAKmg",12) == 3396208357) strcat(s, "e");
if (crc32("UUrVTMWkpMUvTqo",15) == 2874667891) strcat(s, "U");
if (crc32("ujmxPTIDTxOUU",13) == 912519258) strcat(s, "l");
if (crc32("QKTEVnRDLa",10) == 131870930) strcat(s, "b");
if (crc32("KSrdec",6) == 3912715004) strcat(s, "e");
if (crc32("WyRQpcO",7) == 2956824639) strcat(s, "t");
if (crc32("Vavzv",5) == 3458272391) strcat(s, "d");
    return s;
}

char *rerisen_verbs() {
    char *s = calloc(8);
    if (crc32("jtAezW",6) == 1502914600) strcat(s, "r");
if (crc32("XfQvapg",7) == 2904596936) strcat(s, "e");
if (crc32("OTyDiJldAywGyl",14) == 1193704149) strcat(s, "r");
if (crc32("ZZoelHsJrOakUqQ",15) == 2036887522) strcat(s, "i");
if (crc32("pRKPzbRGvBtx",12) == 1295421426) strcat(s, "u");
if (crc32("IutTD",5) == 868106462) strcat(s, "s");
if (crc32("oFSsgieKnB",10) == 4203698894) strcat(s, "e");
if (crc32("PUiWzzhSAWBNTi",14) == 2083063802) strcat(s, "n");
    return s;
}

char *flung_verbs() {
    char *s = calloc(6);
    if (crc32("tCVBBMszIMq",11) == 4248678650) strcat(s, "f");
if (crc32("saorbioYGTzpRTO",15) == 247958893) strcat(s, "y");
if (crc32("nEmTShXaFtOL",12) == 3565021362) strcat(s, "l");
if (crc32("xvnFI",5) == 2864600270) strcat(s, "u");
if (crc32("TeDGWjGeDSn",11) == 2074489701) strcat(s, "K");
if (crc32("aPLbMwjmNFJyq",13) == 109074700) strcat(s, "n");
if (crc32("CMnTFWNhGWL",11) == 3672177085) strcat(s, "g");
    return s;
}

char *adulterating_verbs() {
    char *s = calloc(13);
    if (crc32("mIOnv",5) == 38826463) strcat(s, "A");
if (crc32("MJvHFFIMfprzE",13) == 1829377521) strcat(s, "a");
if (crc32("ddeErpqFxAIBg",13) == 3602506987) strcat(s, "d");
if (crc32("SXKAcnIaAJIM",12) == 593883767) strcat(s, "u");
if (crc32("NRoGoqL",7) == 2102327611) strcat(s, "Z");
if (crc32("zbwEXr",6) == 3025779563) strcat(s, "l");
if (crc32("nqIMkfcAQgSc",12) == 4209805321) strcat(s, "r");
if (crc32("RPtvK",5) == 2221925104) strcat(s, "t");
if (crc32("GdhtDSEsB",9) == 3203105299) strcat(s, "e");
if (crc32("cItrYpriwUgdQ",13) == 107715292) strcat(s, "W");
if (crc32("EVYWpLlEM",9) == 2856161263) strcat(s, "r");
if (crc32("NOdUPsjwzAhjTu",14) == 3896253293) strcat(s, "T");
if (crc32("SYbKzAKGEkDesN",14) == 2524712189) strcat(s, "a");
if (crc32("xCoJUEUbuDgpQ",13) == 3559701737) strcat(s, "t");
if (crc32("NlxWEvGPKymYjrZ",15) == 270790345) strcat(s, "Y");
if (crc32("CUZQkZRo",8) == 3275196902) strcat(s, "i");
if (crc32("DGzghffKVqT",11) == 4282578936) strcat(s, "F");
if (crc32("ZcqDGXUtQe",10) == 3548478450) strcat(s, "n");
if (crc32("AUaeBTFlbzIZ",12) == 3093912936) strcat(s, "U");
if (crc32("DsRJbSAjlWEvGQg",15) == 3875068485) strcat(s, "g");
    return s;
}

char *mistuning_verbs() {
    char *s = calloc(10);
    if (crc32("TgclpZpy",8) == 3684240910) strcat(s, "X");
if (crc32("DYDpJM",6) == 1383365115) strcat(s, "m");
if (crc32("DKHBUsHIhC",10) == 1199616263) strcat(s, "d");
if (crc32("GlqmysOxlsjjWV",14) == 235699525) strcat(s, "i");
if (crc32("ddXJD",5) == 4027244956) strcat(s, "k");
if (crc32("OsELExhRvOYoD",13) == 2990005842) strcat(s, "s");
if (crc32("YKXwDGgKRnvBYGb",15) == 3392285511) strcat(s, "t");
if (crc32("tlgxAHur",8) == 3078904368) strcat(s, "o");
if (crc32("WMfDMFIDV",9) == 1229425950) strcat(s, "u");
if (crc32("rOtaPqlYeXu",11) == 101417628) strcat(s, "n");
if (crc32("dGYZFwPkyEh",11) == 3006732076) strcat(s, "l");
if (crc32("cDTNKvIU",8) == 3708624763) strcat(s, "i");
if (crc32("kapChXlmcrFK",12) == 2692700330) strcat(s, "f");
if (crc32("YGSNEXbUlC",10) == 1507240380) strcat(s, "n");
if (crc32("kLDZInbfwEm",11) == 705556665) strcat(s, "g");
    return s;
}

char *rettore_verbs() {
    char *s = calloc(8);
    if (crc32("YHqLanFnEFIS",12) == 1599448016) strcat(s, "n");
if (crc32("BQqDCZYHq",9) == 2518352725) strcat(s, "r");
if (crc32("qnwBnHd",7) == 2941534404) strcat(s, "e");
if (crc32("KeDCY",5) == 1535724030) strcat(s, "t");
if (crc32("QDZBWZnno",9) == 2709237957) strcat(s, "t");
if (crc32("wlUxn",5) == 3217813286) strcat(s, "U");
if (crc32("CDZDrJCPgkrLR",13) == 1738150087) strcat(s, "o");
if (crc32("ZcDFDWukXrybPn",14) == 673613093) strcat(s, "q");
if (crc32("tnDgNt",6) == 1729094201) strcat(s, "r");
if (crc32("HzTiLtbBWpN",11) == 3877614969) strcat(s, "y");
if (crc32("PrexBkc",7) == 648425837) strcat(s, "e");
    return s;
}

char *turnin_verbs() {
    char *s = calloc(7);
    if (crc32("yZabnBECwXa",11) == 13286728) strcat(s, "t");
if (crc32("kHVPkXYgoK",10) == 973747619) strcat(s, "L");
if (crc32("AJqLAuZMY",9) == 2852232814) strcat(s, "u");
if (crc32("XXchuZVavmyv",12) == 182740908) strcat(s, "r");
if (crc32("HJbXc",5) == 3078792252) strcat(s, "n");
if (crc32("tLQOX",5) == 196123470) strcat(s, "Z");
if (crc32("urVYYge",7) == 277449715) strcat(s, "i");
if (crc32("zZHtSBeEurskX",13) == 701286832) strcat(s, "n");
    return s;
}

char *battledored_verbs() {
    char *s = calloc(12);
    if (crc32("XrFCWVhQyDwcv",13) == 4031952772) strcat(s, "e");
if (crc32("wynQVomiPiEJ",12) == 1570537634) strcat(s, "b");
if (crc32("tVjcMXaoAHDom",13) == 2024498231) strcat(s, "y");
if (crc32("sGpvNJVSrGfZ",12) == 3614475584) strcat(s, "a");
if (crc32("pySPxpQn",8) == 1795429767) strcat(s, "w");
if (crc32("wBWtIzqXiHuO",12) == 1778366556) strcat(s, "t");
if (crc32("wBzREKsSSraz",12) == 956922269) strcat(s, "e");
if (crc32("zKcekjnIJt",10) == 2435944519) strcat(s, "t");
if (crc32("DLPZPF",6) == 3879775391) strcat(s, "m");
if (crc32("OmaomPtY",8) == 1528842914) strcat(s, "l");
if (crc32("jctRXY",6) == 764375835) strcat(s, "e");
if (crc32("zUdPlu",6) == 3663142979) strcat(s, "d");
if (crc32("QhTuArBJtDi",11) == 1637808908) strcat(s, "k");
if (crc32("WTOuBhWFf",9) == 2136644817) strcat(s, "o");
if (crc32("xJbWlKJslJ",10) == 3217676154) strcat(s, "B");
if (crc32("kVazA",5) == 1538826322) strcat(s, "r");
if (crc32("cajdLQEFzH",10) == 2759048104) strcat(s, "e");
if (crc32("pKKHTJVpato",11) == 792609983) strcat(s, "d");
    return s;
}

char *decline_verbs() {
    char *s = calloc(8);
    if (crc32("GEszxyfiXGZ",11) == 3976652077) strcat(s, "d");
if (crc32("QVHOwlchpNw",11) == 1910057448) strcat(s, "e");
if (crc32("FSUGOWlLZJpHoT",14) == 1505974775) strcat(s, "Y");
if (crc32("TZZSWUpjoy",10) == 1718202854) strcat(s, "c");
if (crc32("ensQAVEu",8) == 1218284723) strcat(s, "l");
if (crc32("PrfcXKqbXXGsz",13) == 1072604905) strcat(s, "u");
if (crc32("upjSXYPdGytb",12) == 1371183554) strcat(s, "i");
if (crc32("DWYOZ",5) == 31944992) strcat(s, "R");
if (crc32("BmqoMpbQpM",10) == 1492824755) strcat(s, "n");
if (crc32("akYaHfVmbaFQZ",13) == 3313009542) strcat(s, "e");
if (crc32("febPEaJEpsIpcB",14) == 1190516415) strcat(s, "e");
    return s;
}

char *unclog_verbs() {
    char *s = calloc(7);
    if (crc32("hkgsLysuhTdd",12) == 2714259341) strcat(s, "O");
if (crc32("BYEbF",5) == 3962642103) strcat(s, "u");
if (crc32("KLvQDRlYGzEh",12) == 2237592181) strcat(s, "w");
if (crc32("rpOKpy",6) == 3081009026) strcat(s, "n");
if (crc32("GBxfzSNqk",9) == 1857325561) strcat(s, "v");
if (crc32("oAQYvxJTrQcf",12) == 777224097) strcat(s, "c");
if (crc32("wAAtASkZyhoM",12) == 3180834845) strcat(s, "l");
if (crc32("dcJFdOpvmdYotD",14) == 2524947008) strcat(s, "o");
if (crc32("RqcOOGfSoowDlyU",15) == 3314368555) strcat(s, "o");
if (crc32("FjToFfvKm",9) == 2644392068) strcat(s, "g");
    return s;
}

char *sulfonated_verbs() {
    char *s = calloc(11);
    if (crc32("PFQlPSSW",8) == 1302427769) strcat(s, "s");
if (crc32("vzZSDWdZF",9) == 1101511953) strcat(s, "f");
if (crc32("CxXJa",5) == 628544702) strcat(s, "u");
if (crc32("CPEzEuutz",9) == 1653911133) strcat(s, "p");
if (crc32("FdrHwzbNqBXqYO",14) == 3243222714) strcat(s, "l");
if (crc32("vTwQpjzWgdK",11) == 1254344057) strcat(s, "f");
if (crc32("CSuNtrWxqg",10) == 3610736241) strcat(s, "f");
if (crc32("uljTUBMgswH",11) == 3243190114) strcat(s, "x");
if (crc32("cWekQDUsC",9) == 4144771230) strcat(s, "o");
if (crc32("GfIoRNdG",8) == 1862322953) strcat(s, "n");
if (crc32("tPxoq",5) == 1768429111) strcat(s, "V");
if (crc32("TPrTrxC",7) == 3728961181) strcat(s, "a");
if (crc32("wumNJEH",7) == 2099334063) strcat(s, "t");
if (crc32("OxxZtoD",7) == 1700799463) strcat(s, "e");
if (crc32("KQXusTwyjQGnSJQ",15) == 3345238660) strcat(s, "d");
    return s;
}

char *alliterate_verbs() {
    char *s = calloc(11);
    if (crc32("qEUpZLZtkKCd",12) == 3759529850) strcat(s, "Q");
if (crc32("QuHCUSc",7) == 2371458938) strcat(s, "a");
if (crc32("VfSJeP",6) == 1338658806) strcat(s, "Z");
if (crc32("HnZvVpAlPaK",11) == 3950062138) strcat(s, "l");
if (crc32("hayHXXITCUN",11) == 3733516220) strcat(s, "s");
if (crc32("cyEfw",5) == 2232447491) strcat(s, "l");
if (crc32("LBixTDCrnSmpuF",14) == 1053900547) strcat(s, "s");
if (crc32("QRtQmuFfbZ",10) == 4014531358) strcat(s, "i");
if (crc32("qNIoD",5) == 624510069) strcat(s, "I");
if (crc32("mBgws",5) == 1920452165) strcat(s, "t");
if (crc32("ghOqR",5) == 2038247842) strcat(s, "e");
if (crc32("BrVFVX",6) == 1667251059) strcat(s, "e");
if (crc32("gfUdAtqXl",9) == 3260139408) strcat(s, "Z");
if (crc32("qvWgFXkKMlvLuSm",15) == 1627392663) strcat(s, "r");
if (crc32("pSnyqG",6) == 3233943447) strcat(s, "q");
if (crc32("KjiLPvWCpk",10) == 2883052474) strcat(s, "a");
if (crc32("TtiqBBSnoqOwkX",14) == 963503772) strcat(s, "t");
if (crc32("pmWYbTFy",8) == 1929080534) strcat(s, "e");
    return s;
}

char *shuffle_verbs() {
    char *s = calloc(8);
    if (crc32("vlILLMZMws",10) == 3129623007) strcat(s, "s");
if (crc32("jWrUHUC",7) == 2322652646) strcat(s, "h");
if (crc32("MXPXZtALDgiz",12) == 3208447106) strcat(s, "u");
if (crc32("NAuoFHkjVrtalTP",15) == 3954540636) strcat(s, "J");
if (crc32("PsrDPtOYqGeaK",13) == 3057290850) strcat(s, "f");
if (crc32("RYgHxvcBM",9) == 1520131652) strcat(s, "f");
if (crc32("bVALntKnfaqNXjO",15) == 1545572635) strcat(s, "l");
if (crc32("wzTLpXxiUhGcSB",14) == 190656021) strcat(s, "e");
if (crc32("TSmLSKuYPsvQa",13) == 2959950771) strcat(s, "e");
    return s;
}

char *Graecize_verbs() {
    char *s = calloc(9);
    if (crc32("qorgPiI",7) == 3702637073) strcat(s, "G");
if (crc32("mcHHdOPELMRb",12) == 1392142797) strcat(s, "X");
if (crc32("DiBOUw",6) == 4066372384) strcat(s, "r");
if (crc32("BYOtRFWOUGhMfs",14) == 3294469504) strcat(s, "a");
if (crc32("ZYDNvO",6) == 2913185087) strcat(s, "k");
if (crc32("gRJDRFzSple",11) == 3994202445) strcat(s, "e");
if (crc32("erlyMQgAG",9) == 2202597010) strcat(s, "h");
if (crc32("KaptsFko",8) == 1845313000) strcat(s, "c");
if (crc32("oxkUX",5) == 2503330788) strcat(s, "i");
if (crc32("NuKtkNeq",8) == 3381520720) strcat(s, "f");
if (crc32("nhDMRPnHXKmC",12) == 3413536140) strcat(s, "z");
if (crc32("XiXBgV",6) == 2974079980) strcat(s, "d");
if (crc32("ygVOSSFixG",10) == 4082158169) strcat(s, "e");
    return s;
}

char *petrolling_verbs() {
    char *s = calloc(11);
    if (crc32("asfXpr",6) == 1213787582) strcat(s, "y");
if (crc32("oLVCOclnpFQ",11) == 3755035239) strcat(s, "p");
if (crc32("eIpdf",5) == 2153585161) strcat(s, "e");
if (crc32("LxoMwMbb",8) == 3206968350) strcat(s, "E");
if (crc32("vGtKATyDxJHMN",13) == 464700296) strcat(s, "t");
if (crc32("hIwUfYoNlw",10) == 1899299169) strcat(s, "r");
if (crc32("QGBIssnAFW",10) == 3337237221) strcat(s, "l");
if (crc32("JFNWicTkRVhtYc",14) == 603364194) strcat(s, "o");
if (crc32("vOOwFVJjdpa",11) == 498290325) strcat(s, "I");
if (crc32("Maqhp",5) == 1305045367) strcat(s, "l");
if (crc32("HEmaDADpCujnJr",14) == 568880043) strcat(s, "l");
if (crc32("INKRvyeQh",9) == 1628802975) strcat(s, "i");
if (crc32("PAPYvlAMno",10) == 1895292691) strcat(s, "P");
if (crc32("dpBwDwyQydXJv",13) == 1976902461) strcat(s, "n");
if (crc32("jASYXyhgAM",10) == 3344497358) strcat(s, "g");
    return s;
}

char *disembogue_verbs() {
    char *s = calloc(11);
    if (crc32("lzYcVkkx",8) == 761171591) strcat(s, "d");
if (crc32("fjfFNUZayZ",10) == 2586239271) strcat(s, "i");
if (crc32("kIpmJlEDZstP",12) == 327325432) strcat(s, "F");
if (crc32("SOoZPOyNgADR",12) == 1480780108) strcat(s, "s");
if (crc32("jHjMCurJevujqyQ",15) == 4116613131) strcat(s, "e");
if (crc32("OnRWQcUMKxw",11) == 626643397) strcat(s, "m");
if (crc32("NEwOVfx",7) == 1526749468) strcat(s, "b");
if (crc32("fBlAvQrzMeR",11) == 1017050740) strcat(s, "o");
if (crc32("jflsqydkBAO",11) == 1061393625) strcat(s, "s");
if (crc32("OTzlAjhOhsoEGA",14) == 1665975525) strcat(s, "g");
if (crc32("cWvCOxyepnzTb",13) == 3469033277) strcat(s, "u");
if (crc32("sUSRTFcK",8) == 1635753987) strcat(s, "e");
    return s;
}

char *overcontributed_verbs() {
    char *s = calloc(16);
    if (crc32("EscGQfnntIKI",12) == 3598393407) strcat(s, "o");
if (crc32("CeDSAsdbVFMSw",13) == 3278890016) strcat(s, "T");
if (crc32("ihyuPReKZ",9) == 3101736664) strcat(s, "v");
if (crc32("MxcyqhqVqmhUO",13) == 175295474) strcat(s, "e");
if (crc32("vofSMS",6) == 3501760275) strcat(s, "j");
if (crc32("OfqxIFA",7) == 1124620399) strcat(s, "r");
if (crc32("uYFyeOiJaoNwLa",14) == 652382539) strcat(s, "E");
if (crc32("yWnqRDBOc",9) == 2029788004) strcat(s, "c");
if (crc32("eUJuMkNaMqX",11) == 2991964795) strcat(s, "o");
if (crc32("lrzGPb",6) == 3074989243) strcat(s, "C");
if (crc32("pSsavgBavHPaGU",14) == 1542406122) strcat(s, "n");
if (crc32("VlTWnaIwDl",10) == 3179127533) strcat(s, "j");
if (crc32("wwqNHaYsHE",10) == 2398025582) strcat(s, "t");
if (crc32("UZuEIXF",7) == 1325035769) strcat(s, "r");
if (crc32("LhiPAiU",7) == 2058616915) strcat(s, "K");
if (crc32("VFfckag",7) == 3493575262) strcat(s, "i");
if (crc32("HxXDOvDGl",9) == 1747840293) strcat(s, "P");
if (crc32("HbcvRcUdoeMy",12) == 546361840) strcat(s, "b");
if (crc32("PtQcYyNwPOsB",12) == 1606143802) strcat(s, "f");
if (crc32("GeLDVlUwtHJyB",13) == 2624474162) strcat(s, "u");
if (crc32("WpjXRYrgIW",10) == 3998452426) strcat(s, "B");
if (crc32("NztdIOhSOr",10) == 4209080657) strcat(s, "t");
if (crc32("KzMfnxxKoB",10) == 1403490599) strcat(s, "j");
if (crc32("peVBNoyPrbu",11) == 974380888) strcat(s, "e");
if (crc32("KXikvGhcradANp",14) == 2870085222) strcat(s, "d");
    return s;
}

char *assimilated_verbs() {
    char *s = calloc(12);
    if (crc32("jjOUwRjvauYOopA",15) == 4271128067) strcat(s, "q");
if (crc32("xyKJOzPQkfExvlg",15) == 3058437542) strcat(s, "a");
if (crc32("jBpIQ",5) == 2564197712) strcat(s, "v");
if (crc32("tQTkmh",6) == 3084208315) strcat(s, "s");
if (crc32("MhZPQIOg",8) == 1378391860) strcat(s, "s");
if (crc32("CZIoGsqRDqazd",13) == 1907283503) strcat(s, "Z");
if (crc32("ccdynew",7) == 1198872382) strcat(s, "i");
if (crc32("GtAKNgeyP",9) == 1058207246) strcat(s, "H");
if (crc32("msrdtJYJC",9) == 4290589868) strcat(s, "m");
if (crc32("nJsOuk",6) == 454786957) strcat(s, "i");
if (crc32("CliZmMVRKvitWZ",14) == 3153785150) strcat(s, "k");
if (crc32("LARVqgB",7) == 2435517140) strcat(s, "l");
if (crc32("hAsmmmT",7) == 1783982464) strcat(s, "a");
if (crc32("YgeRGOLnlN",10) == 1477646224) strcat(s, "C");
if (crc32("bACrmuL",7) == 4127836558) strcat(s, "t");
if (crc32("IhxKX",5) == 1099719721) strcat(s, "e");
if (crc32("UTPdIyLxfRmBDr",14) == 2102476194) strcat(s, "X");
if (crc32("hKueveFzrN",10) == 2812200699) strcat(s, "d");
    return s;
}

char *gargle_verbs() {
    char *s = calloc(7);
    if (crc32("rgJcOhnep",9) == 1437729743) strcat(s, "W");
if (crc32("wrdJRwxIhw",10) == 631322525) strcat(s, "g");
if (crc32("rVjbJJgTpUmGwVb",15) == 2735514510) strcat(s, "y");
if (crc32("JKSUE",5) == 938796078) strcat(s, "a");
if (crc32("XWdFQRhgoe",10) == 237226834) strcat(s, "B");
if (crc32("hziEtpBWDY",10) == 713941053) strcat(s, "r");
if (crc32("uFOmO",5) == 2961563642) strcat(s, "U");
if (crc32("BBDpFjtixm",10) == 3038980020) strcat(s, "g");
if (crc32("ejhdJpPA",8) == 1723385997) strcat(s, "l");
if (crc32("GejyZssBKLHLzrX",15) == 2162761935) strcat(s, "l");
if (crc32("CdQFhOaFYddhbbe",15) == 3951960421) strcat(s, "J");
if (crc32("nldYvnPsLenP",12) == 3926190709) strcat(s, "e");
    return s;
}

char *immingle_verbs() {
    char *s = calloc(9);
    if (crc32("ULNXHzAXYyyg",12) == 572108706) strcat(s, "S");
if (crc32("VYGZVcYjzpZUEUA",15) == 2891119692) strcat(s, "i");
if (crc32("FhVPcCOkr",9) == 284398488) strcat(s, "m");
if (crc32("xgyGxxTfRol",11) == 3446003888) strcat(s, "c");
if (crc32("dVdsbBRyqpDuImM",15) == 928038238) strcat(s, "m");
if (crc32("Latmq",5) == 2081572607) strcat(s, "i");
if (crc32("HVmoMrFZ",8) == 1673611795) strcat(s, "n");
if (crc32("wkhYVYOS",8) == 3630610120) strcat(s, "X");
if (crc32("xxgXz",5) == 773932731) strcat(s, "g");
if (crc32("zfqppw",6) == 1169139327) strcat(s, "H");
if (crc32("QYtEmhCLdnkXW",13) == 2603432711) strcat(s, "l");
if (crc32("KyWTzYT",7) == 1728624556) strcat(s, "e");
    return s;
}

char *chored_verbs() {
    char *s = calloc(7);
    if (crc32("cajVOxXkjHae",12) == 4190631820) strcat(s, "u");
if (crc32("pyHbeIuYGzQAvqQ",15) == 1926945852) strcat(s, "c");
if (crc32("mdAaoAWzx",9) == 3832017325) strcat(s, "h");
if (crc32("XYYiaSOav",9) == 1072715640) strcat(s, "o");
if (crc32("dBmCkVwBTldRi",13) == 2597698597) strcat(s, "r");
if (crc32("uXUMVKdnqwurT",13) == 996802602) strcat(s, "V");
if (crc32("xEmkuVieAceDuw",14) == 2549201713) strcat(s, "e");
if (crc32("XUyXMnCr",8) == 959026867) strcat(s, "P");
if (crc32("DTZzUoVjdrd",11) == 344600665) strcat(s, "d");
    return s;
}

char *arrived_verbs() {
    char *s = calloc(8);
    if (crc32("LYzaqBumsrp",11) == 1616048880) strcat(s, "a");
if (crc32("knaFotBJWKEKJ",13) == 3333915583) strcat(s, "r");
if (crc32("RejxLQPCtfbOlU",14) == 4253925315) strcat(s, "r");
if (crc32("fokxlHAhw",9) == 3187982717) strcat(s, "i");
if (crc32("yGsCaPEFwDDqtz",14) == 1111557636) strcat(s, "v");
if (crc32("kMAckeCdWgUADhC",15) == 1622318572) strcat(s, "e");
if (crc32("FKRxpDUd",8) == 3582443170) strcat(s, "d");
    return s;
}

char *averaging_verbs() {
    char *s = calloc(10);
    if (crc32("duQvjlwFQ",9) == 4142902531) strcat(s, "k");
if (crc32("NqDUhyYZiXmmje",14) == 1503287183) strcat(s, "a");
if (crc32("RttcvAXu",8) == 1227282424) strcat(s, "v");
if (crc32("DovgzoEE",8) == 2413013065) strcat(s, "e");
if (crc32("NrbWeuirLvl",11) == 2378530430) strcat(s, "J");
if (crc32("aJfOKXXEyf",10) == 2112631324) strcat(s, "r");
if (crc32("emQLkY",6) == 3568675320) strcat(s, "x");
if (crc32("QSqMTKJXoQVi",12) == 3967127708) strcat(s, "a");
if (crc32("KxCblKrPHQxMANt",15) == 822306595) strcat(s, "g");
if (crc32("uhakbanbvIPgFY",14) == 3596498200) strcat(s, "i");
if (crc32("iGdQyKDvV",9) == 3113421102) strcat(s, "n");
if (crc32("OwfwUdFfnKQDVY",14) == 2951264446) strcat(s, "g");
    return s;
}

char *fluking_verbs() {
    char *s = calloc(8);
    if (crc32("QuCJsKNU",8) == 1321818927) strcat(s, "n");
if (crc32("beAjh",5) == 2215336369) strcat(s, "f");
if (crc32("sXAWAZGRdUXs",12) == 3665182731) strcat(s, "l");
if (crc32("yoPcGfanlqjaBq",14) == 2665234421) strcat(s, "u");
if (crc32("jdrIhqGZtPINJ",13) == 1064472038) strcat(s, "k");
if (crc32("RoszgD",6) == 569579746) strcat(s, "Z");
if (crc32("ovrSPNqCAzKusKM",15) == 2362626176) strcat(s, "i");
if (crc32("VSrzlZEbQmK",11) == 4134981903) strcat(s, "n");
if (crc32("XqqGYktsoJ",10) == 4088642705) strcat(s, "m");
if (crc32("axAxRysLdflUVl",14) == 3109676605) strcat(s, "g");
    return s;
}

char *forbbore_verbs() {
    char *s = calloc(9);
    if (crc32("aSKum",5) == 2790063067) strcat(s, "f");
if (crc32("OkrFNTupkwcJHYW",15) == 4165253469) strcat(s, "o");
if (crc32("CtHsyNhZK",9) == 132456989) strcat(s, "p");
if (crc32("FWXOGGlUSCFs",12) == 3080471291) strcat(s, "r");
if (crc32("nObqfr",6) == 271573455) strcat(s, "b");
if (crc32("BrhcziDR",8) == 2411849073) strcat(s, "e");
if (crc32("HtfueSDygr",10) == 2534912380) strcat(s, "b");
if (crc32("YEHCXkZEPtscDs",14) == 1233068835) strcat(s, "o");
if (crc32("pOBjSijjSHFP",12) == 2371192133) strcat(s, "l");
if (crc32("DQRuMxhaebZYqU",14) == 1564764552) strcat(s, "r");
if (crc32("ghpQzUuMvN",10) == 1643092657) strcat(s, "t");
if (crc32("whbsUtKmza",10) == 3968082157) strcat(s, "e");
    return s;
}

char *slated_verbs() {
    char *s = calloc(7);
    if (crc32("sttNcKt",7) == 2646704696) strcat(s, "p");
if (crc32("ZjJLmNlE",8) == 3245646126) strcat(s, "s");
if (crc32("BViJurIHfLofGqN",15) == 4203693257) strcat(s, "X");
if (crc32("KorVSa",6) == 3441155804) strcat(s, "l");
if (crc32("ZxhcPixZ",8) == 2753927832) strcat(s, "a");
if (crc32("IqNegzgtYEmq",12) == 3282317740) strcat(s, "t");
if (crc32("glcKuHFAV",9) == 4102438051) strcat(s, "p");
if (crc32("ZwkPGKpIrcjpqfJ",15) == 2252948433) strcat(s, "e");
if (crc32("FAhtQqZlHGBTk",13) == 1220941365) strcat(s, "d");
    return s;
}

char *gie_verbs() {
    char *s = calloc(4);
    if (crc32("nSIAitnEWqwxjDA",15) == 2151072523) strcat(s, "g");
if (crc32("tLjKKvyhq",9) == 915687585) strcat(s, "S");
if (crc32("JSDnddq",7) == 3905584476) strcat(s, "i");
if (crc32("JAEyfNCfDOaRIrN",15) == 241420011) strcat(s, "e");
    return s;
}

char *getback_verbs() {
    char *s = calloc(8);
    if (crc32("mQglhROszv",10) == 2489589010) strcat(s, "d");
if (crc32("ZOnChoV",7) == 1842214640) strcat(s, "g");
if (crc32("dvfoNoQYjrSV",12) == 1339938232) strcat(s, "u");
if (crc32("ATyTzbXzzsqHkdm",15) == 2353110727) strcat(s, "e");
if (crc32("vqSnjBzqfvWC",12) == 2988908733) strcat(s, "X");
if (crc32("xmDxi",5) == 1658289363) strcat(s, "t");
if (crc32("QbvAteLqn",9) == 2456299115) strcat(s, "w");
if (crc32("pUkONMOYUZVB",12) == 1163352657) strcat(s, "b");
if (crc32("MsdishbCfS",10) == 229457820) strcat(s, "a");
if (crc32("AGZfvjiUBuxt",12) == 3133499724) strcat(s, "z");
if (crc32("yiqqX",5) == 1919508028) strcat(s, "c");
if (crc32("aSryCQRtxd",10) == 3043087785) strcat(s, "c");
if (crc32("vucJDNfooDxod",13) == 3133404892) strcat(s, "k");
    return s;
}

char *read_verbs() {
    char *s = calloc(5);
    if (crc32("NoukkafLiVGhh",13) == 182570781) strcat(s, "y");
if (crc32("kWYthN",6) == 2155823229) strcat(s, "r");
if (crc32("CfXuhrlQPCHLW",13) == 4273170462) strcat(s, "e");
if (crc32("SQgDSiK",7) == 1277971246) strcat(s, "a");
if (crc32("fzoPg",5) == 4183021292) strcat(s, "A");
if (crc32("pNcFKlL",7) == 3998622980) strcat(s, "d");
    return s;
}

char *miscut_verbs() {
    char *s = calloc(7);
    if (crc32("ZyRgeX",6) == 2738361813) strcat(s, "a");
if (crc32("kVHbyhwQvfNh",12) == 2053728112) strcat(s, "m");
if (crc32("INJaBybdq",9) == 2508845610) strcat(s, "K");
if (crc32("SQNnEMVSbQxGfgm",15) == 603875885) strcat(s, "i");
if (crc32("UCPLdycTCRYVZkp",15) == 2579118786) strcat(s, "x");
if (crc32("GmDrSfwTZvujiQ",14) == 1327233033) strcat(s, "s");
if (crc32("duIlIo",6) == 1223831078) strcat(s, "c");
if (crc32("bcgFvO",6) == 1737277142) strcat(s, "u");
if (crc32("RBOAyNLLQU",10) == 1740856160) strcat(s, "t");
    return s;
}

char *kickup_verbs() {
    char *s = calloc(7);
    if (crc32("tULBGLnNURhPW",13) == 358976931) strcat(s, "U");
if (crc32("dcDGr",5) == 4121137843) strcat(s, "k");
if (crc32("BDlIFE",6) == 2805186961) strcat(s, "J");
if (crc32("EgQftX",6) == 3561827136) strcat(s, "i");
if (crc32("TupfKvxqugBrNes",15) == 2284239263) strcat(s, "f");
if (crc32("SXHBmGevNM",10) == 895868915) strcat(s, "c");
if (crc32("ZgtdAN",6) == 3829426059) strcat(s, "k");
if (crc32("sQWenxHJ",8) == 1755954220) strcat(s, "Z");
if (crc32("osqufTYqTNqJI",13) == 875869385) strcat(s, "u");
if (crc32("rXPKea",6) == 40572562) strcat(s, "e");
if (crc32("gGtjFBzKULT",11) == 1122743789) strcat(s, "p");
    return s;
}

char *flimflamming_verbs() {
    char *s = calloc(13);
    if (crc32("ZDPSw",5) == 2478582693) strcat(s, "f");
if (crc32("RxlrOwiUIj",10) == 2860939141) strcat(s, "f");
if (crc32("QVjcITZ",7) == 304772963) strcat(s, "l");
if (crc32("GAnoIsS",7) == 347668237) strcat(s, "i");
if (crc32("fxkctsEtsTM",11) == 3623389195) strcat(s, "m");
if (crc32("gdWcwFsksR",10) == 2595032889) strcat(s, "u");
if (crc32("oVwwpp",6) == 660588669) strcat(s, "f");
if (crc32("kXLqlpMWlfRfP",13) == 1530295511) strcat(s, "m");
if (crc32("PEQeSRo",7) == 3554516906) strcat(s, "l");
if (crc32("tkPZNbSBKgYXCxs",15) == 48932608) strcat(s, "a");
if (crc32("MYcKQVPcutWrl",13) == 1160754901) strcat(s, "m");
if (crc32("cUIbgZm",7) == 2171756652) strcat(s, "m");
if (crc32("ylVbavdiMF",10) == 1089576863) strcat(s, "i");
if (crc32("PpyQLHM",7) == 2074435061) strcat(s, "n");
if (crc32("XaZKy",5) == 379852609) strcat(s, "g");
    return s;
}

char *prebenefited_verbs() {
    char *s = calloc(13);
    if (crc32("eTIfEhrMHnAVOM",14) == 2696952802) strcat(s, "p");
if (crc32("MEppNznwTpt",11) == 699494857) strcat(s, "f");
if (crc32("KORSNqtIPcOh",12) == 2414259626) strcat(s, "r");
if (crc32("Magnbab",7) == 536508809) strcat(s, "e");
if (crc32("TzKHHFeFw",9) == 3167183685) strcat(s, "d");
if (crc32("ZVCVKoT",7) == 3280433198) strcat(s, "b");
if (crc32("xiKwYPRexwbU",12) == 1246085616) strcat(s, "e");
if (crc32("SiraoglaPzhn",12) == 630476784) strcat(s, "b");
if (crc32("CsuQM",5) == 1493967221) strcat(s, "n");
if (crc32("zSyZqV",6) == 2818097689) strcat(s, "e");
if (crc32("QlCFlRJKunIpeTh",15) == 540326679) strcat(s, "f");
if (crc32("rzxucyrZXl",10) == 1502070565) strcat(s, "i");
if (crc32("TDIEYzxHV",9) == 1001227984) strcat(s, "t");
if (crc32("mRyJfNA",7) == 97788427) strcat(s, "B");
if (crc32("DUECqotprIw",11) == 222509477) strcat(s, "e");
if (crc32("NUwOhHDEzjZwTmW",15) == 3499874549) strcat(s, "f");
if (crc32("rGjHDr",6) == 502782014) strcat(s, "d");
    return s;
}

char *marshaling_verbs() {
    char *s = calloc(11);
    if (crc32("kqvbjmdFmwkrc",13) == 2751838528) strcat(s, "m");
if (crc32("svyqA",5) == 1311052507) strcat(s, "d");
if (crc32("UWWeBol",7) == 2931701374) strcat(s, "a");
if (crc32("wdgZUMVDr",9) == 109565163) strcat(s, "N");
if (crc32("baNDHRFbI",9) == 763072053) strcat(s, "r");
if (crc32("eLVNnBePABguqc",14) == 4216063623) strcat(s, "S");
if (crc32("iLlFuxWuHsFvGCI",15) == 2576918267) strcat(s, "s");
if (crc32("PlBxmvpGj",9) == 1054699236) strcat(s, "C");
if (crc32("JFNLanvaMMGgyL",14) == 1850665036) strcat(s, "h");
if (crc32("woeycLsNS",9) == 1272736058) strcat(s, "a");
if (crc32("tijGOQYBDLx",11) == 980719200) strcat(s, "P");
if (crc32("JJqbF",5) == 3180322891) strcat(s, "l");
if (crc32("JhzBKbLjSPkUY",13) == 3786449159) strcat(s, "i");
if (crc32("KMblh",5) == 1091423274) strcat(s, "n");
if (crc32("jfnQn",5) == 3563144542) strcat(s, "o");
if (crc32("GpYTjKJ",7) == 2789924017) strcat(s, "g");
    return s;
}

char *organizing_verbs() {
    char *s = calloc(11);
    if (crc32("HKBJtTeNThJdiBm",15) == 741519589) strcat(s, "o");
if (crc32("DzkepiFvRjEwhqy",15) == 3225883928) strcat(s, "r");
if (crc32("nbFZSpHHFAmgAdy",15) == 1479107972) strcat(s, "j");
if (crc32("AZlbuaJbFq",10) == 797305737) strcat(s, "g");
if (crc32("svfGMsXATEZ",11) == 1770491167) strcat(s, "l");
if (crc32("ZKOLCQvN",8) == 2283478438) strcat(s, "a");
if (crc32("HMrHk",5) == 2850984174) strcat(s, "H");
if (crc32("URZgMW",6) == 4137837360) strcat(s, "n");
if (crc32("mVkkDqSUn",9) == 1310860109) strcat(s, "i");
if (crc32("qhCSiHy",7) == 3969167949) strcat(s, "U");
if (crc32("ClBQRfQNNfvlg",13) == 3005551776) strcat(s, "z");
if (crc32("xJAhivlUT",9) == 595967096) strcat(s, "i");
if (crc32("QBmRNnLVFru",11) == 1553556861) strcat(s, "K");
if (crc32("zeNGTiwbwQnG",12) == 476868539) strcat(s, "n");
if (crc32("UjzlvxCtTVjCz",13) == 1541861950) strcat(s, "s");
if (crc32("iHJuWVZUOPipvVs",15) == 2167457622) strcat(s, "g");
    return s;
}

char *decrepitated_verbs() {
    char *s = calloc(13);
    if (crc32("tuYjZFz",7) == 2544570661) strcat(s, "U");
if (crc32("dzqIUYFGIZwH",12) == 547448377) strcat(s, "d");
if (crc32("eeYLtJFzHI",10) == 3108582679) strcat(s, "j");
if (crc32("MPiVDJm",7) == 2155616516) strcat(s, "e");
if (crc32("hVODDiXZKur",11) == 981904361) strcat(s, "c");
if (crc32("eUyEQqhb",8) == 417380333) strcat(s, "r");
if (crc32("rPogi",5) == 3546604433) strcat(s, "e");
if (crc32("ByTbEoevECbVg",13) == 2195647392) strcat(s, "p");
if (crc32("qUZRjDcWd",9) == 3904150194) strcat(s, "i");
if (crc32("oybZHnsxs",9) == 2899783924) strcat(s, "t");
if (crc32("GJBOldfKkO",10) == 482805513) strcat(s, "a");
if (crc32("jaMdeZfplkOkk",13) == 3313819930) strcat(s, "D");
if (crc32("PaaussSlDUIOqy",14) == 3164940492) strcat(s, "t");
if (crc32("IkZtdm",6) == 1131287573) strcat(s, "W");
if (crc32("XaSqlpaSxxyHSRB",15) == 1555652483) strcat(s, "e");
if (crc32("jtyeHCQrFJDTH",13) == 4249263252) strcat(s, "L");
if (crc32("axAeEIraxsIBYUm",15) == 2198035326) strcat(s, "d");
    return s;
}

char *relacing_verbs() {
    char *s = calloc(9);
    if (crc32("rBzqICO",7) == 2258009092) strcat(s, "r");
if (crc32("soxhTJungPAyV",13) == 1413147471) strcat(s, "D");
if (crc32("pCifacsYRllCGK",14) == 3117341813) strcat(s, "e");
if (crc32("IfFacHFSizQYH",13) == 774686740) strcat(s, "l");
if (crc32("bMGbhodgp",9) == 3676043131) strcat(s, "F");
if (crc32("zKQlWX",6) == 2523836042) strcat(s, "a");
if (crc32("ickhxRZ",7) == 1149471960) strcat(s, "c");
if (crc32("oOklZNthhG",10) == 2919838807) strcat(s, "i");
if (crc32("sYwbN",5) == 1497642573) strcat(s, "n");
if (crc32("lBYAClAHMmhLg",13) == 2949247440) strcat(s, "G");
if (crc32("eGuso",5) == 437687267) strcat(s, "g");
    return s;
}

char *broadcast_verbs() {
    char *s = calloc(10);
    if (crc32("FLckwWYErexrT",13) == 1102749100) strcat(s, "b");
if (crc32("BnFyzHlx",8) == 357369771) strcat(s, "r");
if (crc32("hHWLmnru",8) == 723748173) strcat(s, "o");
if (crc32("sUsHufJcdMZhYcP",15) == 310863532) strcat(s, "a");
if (crc32("TFEqVtn",7) == 1834029745) strcat(s, "h");
if (crc32("XKIXZft",7) == 3061271830) strcat(s, "d");
if (crc32("PHsgAqoB",8) == 954534137) strcat(s, "q");
if (crc32("WEaDKNOKjJvZbl",14) == 2812197260) strcat(s, "c");
if (crc32("pbRNBFroZxImEc",14) == 1045958885) strcat(s, "a");
if (crc32("ODswGXbnRNGaX",13) == 2462399003) strcat(s, "s");
if (crc32("qJPAeLfd",8) == 2159937451) strcat(s, "t");
    return s;
}

char *handselled_verbs() {
    char *s = calloc(11);
    if (crc32("StqRy",5) == 2846589412) strcat(s, "h");
if (crc32("ULGZGrVcNvNGh",13) == 1449975205) strcat(s, "p");
if (crc32("wGRAfFqndfnZGO",14) == 4127013941) strcat(s, "a");
if (crc32("TjNAlc",6) == 1995402811) strcat(s, "i");
if (crc32("ESuFMWuKXGUSMCx",15) == 1400103552) strcat(s, "n");
if (crc32("HnnFDANsGInKGoQ",15) == 83904406) strcat(s, "Z");
if (crc32("FEbsb",5) == 1369884660) strcat(s, "d");
if (crc32("sjmsAa",6) == 2748999549) strcat(s, "s");
if (crc32("YXmhzevbRSUDPQi",15) == 3511891596) strcat(s, "j");
if (crc32("yfvohWFT",8) == 2768681210) strcat(s, "e");
if (crc32("lCprgaIzjwnvLY",14) == 3562684741) strcat(s, "l");
if (crc32("BkDxfXOozGk",11) == 3492661540) strcat(s, "C");
if (crc32("YmQscWL",7) == 598947270) strcat(s, "l");
if (crc32("smspNFdVxqp",11) == 1040319131) strcat(s, "e");
if (crc32("TqcoiIaKyyFR",12) == 2660653156) strcat(s, "O");
if (crc32("bVBiNUE",7) == 2230412860) strcat(s, "d");
    return s;
}

char *gapped_verbs() {
    char *s = calloc(7);
    if (crc32("hMlxXQTqx",9) == 3800210860) strcat(s, "a");
if (crc32("NDtlOSdTMSIXh",13) == 4221910192) strcat(s, "g");
if (crc32("fvzWbuaTQV",10) == 1004195655) strcat(s, "a");
if (crc32("krvXImxdFx",10) == 1048596799) strcat(s, "a");
if (crc32("YcKuUVpweonkpHS",15) == 2798031969) strcat(s, "p");
if (crc32("kzwud",5) == 1701554078) strcat(s, "p");
if (crc32("GLszrTN",7) == 2689305309) strcat(s, "T");
if (crc32("RbMyDvqC",8) == 3036114439) strcat(s, "e");
if (crc32("aFexKacX",8) == 505533599) strcat(s, "C");
if (crc32("iRxDC",5) == 304514763) strcat(s, "d");
    return s;
}

char *pedestaling_verbs() {
    char *s = calloc(12);
    if (crc32("UmtUoSzm",8) == 3742287397) strcat(s, "S");
if (crc32("YghpSrkxM",9) == 1143042684) strcat(s, "p");
if (crc32("zFRslkR",7) == 3598999860) strcat(s, "Q");
if (crc32("oKQxhXzA",8) == 1822653503) strcat(s, "e");
if (crc32("OPaVelO",7) == 3400854039) strcat(s, "F");
if (crc32("swHgTrr",7) == 1343125899) strcat(s, "d");
if (crc32("eYlnWYseaaFOt",13) == 2184132197) strcat(s, "e");
if (crc32("YSBZNrMaibZs",12) == 2453235119) strcat(s, "s");
if (crc32("GPtWU",5) == 94366071) strcat(s, "D");
if (crc32("shoDZwlFLWh",11) == 1549140872) strcat(s, "t");
if (crc32("auIqyyliGEcmx",13) == 343720028) strcat(s, "w");
if (crc32("wzqRNEZz",8) == 4095526803) strcat(s, "a");
if (crc32("dJsoMQtD",8) == 2043558384) strcat(s, "l");
if (crc32("hnPDjjdY",8) == 525215115) strcat(s, "z");
if (crc32("XjjzgFTZx",9) == 193269951) strcat(s, "i");
if (crc32("QmpXVzfSTgQxny",14) == 3666202365) strcat(s, "q");
if (crc32("NIqUvb",6) == 2992506145) strcat(s, "n");
if (crc32("FNrUSX",6) == 834421455) strcat(s, "x");
if (crc32("GhDBlDWxz",9) == 3679534508) strcat(s, "g");
    return s;
}

char *regave_verbs() {
    char *s = calloc(7);
    if (crc32("BrOnzst",7) == 55847642) strcat(s, "r");
if (crc32("uPgqUUlmYE",10) == 4272373025) strcat(s, "O");
if (crc32("lBVtKCu",7) == 1192273020) strcat(s, "e");
if (crc32("vXTNifGA",8) == 2238071616) strcat(s, "P");
if (crc32("sshyPnyy",8) == 3564662410) strcat(s, "g");
if (crc32("ToFzghVzDNozKWh",15) == 231159515) strcat(s, "a");
if (crc32("CZWLNeJGxpEQ",12) == 264662818) strcat(s, "v");
if (crc32("UnYKRBQgeMTs",12) == 1208640186) strcat(s, "g");
if (crc32("vQbgiLuoaLJuPe",14) == 1506660715) strcat(s, "e");
    return s;
}

char *invent_verbs() {
    char *s = calloc(7);
    if (crc32("xvGiBBzelmaOws",14) == 3161553624) strcat(s, "i");
if (crc32("AWgyVLIolCrmNXQ",15) == 3633284760) strcat(s, "n");
if (crc32("NTXgOFHay",9) == 1485841905) strcat(s, "C");
if (crc32("wLxPIlLmEHpVh",13) == 4145097971) strcat(s, "v");
if (crc32("dxMbBzvCp",9) == 89114114) strcat(s, "e");
if (crc32("tZhPGklChKVhZDu",15) == 1277363002) strcat(s, "n");
if (crc32("PNUQWIagKSmpqP",14) == 222620643) strcat(s, "t");
    return s;
}

char *overmultiplying_verbs() {
    char *s = calloc(16);
    if (crc32("BTpoOGTwUWyRfpX",15) == 682874649) strcat(s, "o");
if (crc32("bFHrErmCLOkkE",13) == 2737229147) strcat(s, "v");
if (crc32("VdTOVKhJqQtoc",13) == 591228166) strcat(s, "W");
if (crc32("lxnbBHl",7) == 2392600887) strcat(s, "e");
if (crc32("fLjjLspGnjXvXQ",14) == 1409460422) strcat(s, "F");
if (crc32("NirVSVgRPngz",12) == 2773246030) strcat(s, "r");
if (crc32("xrhFx",5) == 2902909732) strcat(s, "M");
if (crc32("BWUxCcJoiGyun",13) == 3876621634) strcat(s, "m");
if (crc32("MxiPxChGoSTRenK",15) == 4175985927) strcat(s, "I");
if (crc32("iHdbFRAeIBOoWAd",15) == 2835977857) strcat(s, "u");
if (crc32("mVbVadl",7) == 2237556913) strcat(s, "m");
if (crc32("kOVPMPMl",8) == 3157651550) strcat(s, "l");
if (crc32("fXrkHMXASrj",11) == 462218928) strcat(s, "t");
if (crc32("MBxvaHcxKDl",11) == 3747431598) strcat(s, "i");
if (crc32("bLCtOr",6) == 3049537608) strcat(s, "P");
if (crc32("tZpwoLUco",9) == 1189424068) strcat(s, "p");
if (crc32("cgsSQwgGOZbxLQ",14) == 3240164224) strcat(s, "C");
if (crc32("xfyfxmy",7) == 3584123534) strcat(s, "l");
if (crc32("dYWWqL",6) == 1640172407) strcat(s, "y");
if (crc32("dPvopWTJozBOMCM",15) == 3611088854) strcat(s, "i");
if (crc32("MOJSQJiWzFX",11) == 4203999608) strcat(s, "n");
if (crc32("WorLQzonfN",10) == 319466714) strcat(s, "P");
if (crc32("hNdrfUiOeJXWml",14) == 2230517352) strcat(s, "g");
    return s;
}

char *copyread_verbs() {
    char *s = calloc(9);
    if (crc32("XLtNzOOfhlYS",12) == 904471973) strcat(s, "c");
if (crc32("BljLUDQSIqtOTwx",15) == 3114702419) strcat(s, "o");
if (crc32("lNNxQLdudrFbK",13) == 1351290884) strcat(s, "p");
if (crc32("jmjXpTmQFTjLW",13) == 3871270966) strcat(s, "p");
if (crc32("CGcsVQWnpGC",11) == 3447442501) strcat(s, "y");
if (crc32("CVIOXwmqfn",10) == 603937191) strcat(s, "V");
if (crc32("dFDOnrhSw",9) == 3090757396) strcat(s, "r");
if (crc32("amjdKBjFfBHetwy",15) == 2884945916) strcat(s, "G");
if (crc32("jIxtXsZCMWuCjr",14) == 1036853864) strcat(s, "e");
if (crc32("sOZPRNrJuYQgDPv",15) == 43429790) strcat(s, "w");
if (crc32("ONdfbRpNmiO",11) == 1953168687) strcat(s, "a");
if (crc32("xZuwDiixle",10) == 3298851576) strcat(s, "d");
    return s;
}

char *allot_verbs() {
    char *s = calloc(6);
    if (crc32("wNRUvzKja",9) == 1121691588) strcat(s, "b");
if (crc32("iixKoDcgts",10) == 3045360047) strcat(s, "a");
if (crc32("nTqLqyNv",8) == 1973152204) strcat(s, "l");
if (crc32("olmtSSqYFn",10) == 1670823217) strcat(s, "l");
if (crc32("UtlLYxWnw",9) == 88005681) strcat(s, "o");
if (crc32("FAmVEfLiz",9) == 1831938321) strcat(s, "t");
    return s;
}

char *articling_verbs() {
    char *s = calloc(10);
    if (crc32("fiBFmcRuMtMpxS",14) == 2975656454) strcat(s, "a");
if (crc32("DoTiG",5) == 1059482736) strcat(s, "r");
if (crc32("YsMqqchlKkKNEG",14) == 622789715) strcat(s, "t");
if (crc32("TLmAZi",6) == 2012281345) strcat(s, "i");
if (crc32("oVhllTXyjgGD",12) == 1513419448) strcat(s, "c");
if (crc32("TLJbPPEqDLFKr",13) == 4058497437) strcat(s, "l");
if (crc32("nUMkXSB",7) == 1024052315) strcat(s, "l");
if (crc32("cpvhWdWgANCHo",13) == 1956123485) strcat(s, "i");
if (crc32("rUFFr",5) == 3588010691) strcat(s, "n");
if (crc32("JfNYBWrupELDV",13) == 4276518061) strcat(s, "V");
if (crc32("AOZKD",5) == 1674671790) strcat(s, "g");
    return s;
}

char *tomcatting_verbs() {
    char *s = calloc(11);
    if (crc32("cRMON",5) == 2478503767) strcat(s, "d");
if (crc32("LJVqet",6) == 799822722) strcat(s, "t");
if (crc32("oKcwK",5) == 1610662180) strcat(s, "W");
if (crc32("YXgAFKeF",8) == 177651912) strcat(s, "o");
if (crc32("unPejL",6) == 2839968770) strcat(s, "m");
if (crc32("gucDPUC",7) == 4104845468) strcat(s, "v");
if (crc32("uniBkgrqdPNrSAT",15) == 2953684454) strcat(s, "c");
if (crc32("YTAQtZKW",8) == 1515326374) strcat(s, "a");
if (crc32("PDnxkbCLQfhH",12) == 3401939187) strcat(s, "t");
if (crc32("wCgTZCea",8) == 3055761397) strcat(s, "Y");
if (crc32("jmFuUjBuBEXvG",13) == 799448169) strcat(s, "t");
if (crc32("AHQHtehyHWfDNMv",15) == 1845964559) strcat(s, "c");
if (crc32("wixrbatikv",10) == 2127027170) strcat(s, "i");
if (crc32("xjKqXul",7) == 1673993319) strcat(s, "n");
if (crc32("SWGcIz",6) == 3313229157) strcat(s, "V");
if (crc32("tzkWFItnh",9) == 883752686) strcat(s, "g");
    return s;
}

char *gormandize_verbs() {
    char *s = calloc(11);
    if (crc32("yVJTP",5) == 339207279) strcat(s, "g");
if (crc32("vlqeHsOActc",11) == 3427480921) strcat(s, "P");
if (crc32("nyaInBBlGW",10) == 2539414480) strcat(s, "o");
if (crc32("rldpRgdrpixel",13) == 522828069) strcat(s, "k");
if (crc32("exGHk",5) == 2926469579) strcat(s, "r");
if (crc32("DriLWnrCuDBy",12) == 3152913735) strcat(s, "E");
if (crc32("bJxEVqdDpbQ",11) == 659077153) strcat(s, "m");
if (crc32("RMhuaHeBMdFcRD",14) == 3631053782) strcat(s, "v");
if (crc32("mYNCBkZHrqWwYL",14) == 2486139653) strcat(s, "a");
if (crc32("fwOOtjsgWjVNX",13) == 1115139187) strcat(s, "n");
if (crc32("uZVmuZwufoXTj",13) == 705148985) strcat(s, "u");
if (crc32("gtinByrnBC",10) == 1902441415) strcat(s, "d");
if (crc32("AqJhhNiQ",8) == 730996225) strcat(s, "Q");
if (crc32("ZceGOgSSbXZXO",13) == 1707819218) strcat(s, "i");
if (crc32("CbUzYhlpJBzNy",13) == 3499545588) strcat(s, "e");
if (crc32("VANtstQzsEbKk",13) == 677965092) strcat(s, "z");
if (crc32("TwWdJLYB",8) == 784246617) strcat(s, "M");
if (crc32("juuEH",5) == 4000452614) strcat(s, "e");
    return s;
}

char *demobbing_verbs() {
    char *s = calloc(10);
    if (crc32("bFbyiKITDMo",11) == 3026580386) strcat(s, "d");
if (crc32("sYlhPmNCaqY",11) == 1899270359) strcat(s, "e");
if (crc32("SWYnXHvY",8) == 1318625395) strcat(s, "e");
if (crc32("ZTHXyUpBViHH",12) == 591239331) strcat(s, "m");
if (crc32("WpXAqbXBJ",9) == 3944799086) strcat(s, "o");
if (crc32("hdoNHcy",7) == 2245270865) strcat(s, "z");
if (crc32("wgJVPAoEg",9) == 2493637112) strcat(s, "b");
if (crc32("mzplslDgKXd",11) == 2332896571) strcat(s, "b");
if (crc32("PTXMYDZ",7) == 880631574) strcat(s, "i");
if (crc32("fqsYir",6) == 3399676071) strcat(s, "H");
if (crc32("msvXfRV",7) == 3293561747) strcat(s, "n");
if (crc32("XyIiGQYHh",9) == 3811755653) strcat(s, "g");
    return s;
}

char *diverged_verbs() {
    char *s = calloc(9);
    if (crc32("cFpfjb",6) == 4091209193) strcat(s, "d");
if (crc32("YbjWAqfBMFTXW",13) == 1569751181) strcat(s, "i");
if (crc32("ggcAOvgeXjRHrG",14) == 904586509) strcat(s, "v");
if (crc32("DktqcDkwhH",10) == 2202087815) strcat(s, "e");
if (crc32("RufvXPUeJAND",12) == 1235085876) strcat(s, "r");
if (crc32("GWXccq",6) == 72786774) strcat(s, "g");
if (crc32("ZKtsGeDpIOLaUUy",15) == 1269314277) strcat(s, "e");
if (crc32("vRKdbbP",7) == 562476155) strcat(s, "a");
if (crc32("PXuBNQFWkpkz",12) == 23019317) strcat(s, "d");
    return s;
}

char *Damascening_verbs() {
    char *s = calloc(12);
    if (crc32("kIYkbR",6) == 1351586614) strcat(s, "N");
if (crc32("ynQHZTqHmepxX",13) == 3822213543) strcat(s, "D");
if (crc32("PrCmdXwMFFn",11) == 2296559672) strcat(s, "a");
if (crc32("xWxEiJMZeKWkp",13) == 1026204512) strcat(s, "F");
if (crc32("fTKmm",5) == 195069739) strcat(s, "m");
if (crc32("tlNNZYTpwKTIH",13) == 3680436055) strcat(s, "U");
if (crc32("xDXGzX",6) == 818684980) strcat(s, "a");
if (crc32("pIHsvZ",6) == 697244810) strcat(s, "q");
if (crc32("QhWhEbFRbZTdB",13) == 3009541386) strcat(s, "s");
if (crc32("kAzJpto",7) == 1438512884) strcat(s, "c");
if (crc32("NkXoIcdnWQXWaHX",15) == 47594448) strcat(s, "e");
if (crc32("zcfKjGONCIdkYT",14) == 1437214057) strcat(s, "b");
if (crc32("LRyNblO",7) == 3035669467) strcat(s, "n");
if (crc32("YANCuAwr",8) == 351946932) strcat(s, "i");
if (crc32("iyuDZTpliaMXcng",15) == 2138317330) strcat(s, "n");
if (crc32("ogoyMTuoyqTfGa",14) == 1417574421) strcat(s, "K");
if (crc32("cWydSmrwNo",10) == 3410548946) strcat(s, "g");
    return s;
}

char *hiking_verbs() {
    char *s = calloc(7);
    if (crc32("nItxYvRoBJ",10) == 2498853083) strcat(s, "M");
if (crc32("MmbVOkDTCrAAjO",14) == 3503304628) strcat(s, "h");
if (crc32("jKJdAbljItYQ",12) == 3373712735) strcat(s, "i");
if (crc32("ONkxJ",5) == 1378314298) strcat(s, "i");
if (crc32("LFXrYoSvNL",10) == 764783940) strcat(s, "l");
if (crc32("KGOAe",5) == 1086250927) strcat(s, "k");
if (crc32("WceGKV",6) == 2524146186) strcat(s, "i");
if (crc32("obwczEnQBeAyWa",14) == 1838224220) strcat(s, "n");
if (crc32("qAWNu",5) == 441369698) strcat(s, "h");
if (crc32("HBViqGlkYgaky",13) == 382298239) strcat(s, "g");
    return s;
}

char *dissipate_verbs() {
    char *s = calloc(10);
    if (crc32("aTryLNzedZp",11) == 603495513) strcat(s, "V");
if (crc32("BqMAXxirywelSq",14) == 1720801494) strcat(s, "d");
if (crc32("wmevycmrl",9) == 4186125921) strcat(s, "i");
if (crc32("XoCvXRPfV",9) == 3810123198) strcat(s, "y");
if (crc32("YIcLtm",6) == 3890434042) strcat(s, "s");
if (crc32("WdGJEogky",9) == 885827874) strcat(s, "n");
if (crc32("BqyBFOGjpFFkz",13) == 50324743) strcat(s, "s");
if (crc32("PEooblf",7) == 3217118551) strcat(s, "i");
if (crc32("WIRIJmpbcDeAtQA",15) == 3012344578) strcat(s, "d");
if (crc32("NHGeOrtF",8) == 766532163) strcat(s, "p");
if (crc32("AAySbUrp",8) == 3203939483) strcat(s, "B");
if (crc32("ADvRScPyDgUzy",13) == 1891870271) strcat(s, "a");
if (crc32("HtUtlgFtIxJyJvI",15) == 1053732050) strcat(s, "T");
if (crc32("SMzCveiPWyjvm",13) == 3871897880) strcat(s, "t");
if (crc32("KeAEzJ",6) == 819365183) strcat(s, "r");
if (crc32("wvwqsMn",7) == 1220775743) strcat(s, "e");
    return s;
}

char *overmoralizing_verbs() {
    char *s = calloc(15);
    if (crc32("pHIih",5) == 1876629293) strcat(s, "t");
if (crc32("fjuIRtJG",8) == 2193536941) strcat(s, "o");
if (crc32("xdgXTsNuVlAV",12) == 2812378117) strcat(s, "w");
if (crc32("EWiSSHnsFa",10) == 2750563890) strcat(s, "v");
if (crc32("MehBbUa",7) == 4042534405) strcat(s, "o");
if (crc32("QCqjEpymjz",10) == 3267555101) strcat(s, "e");
if (crc32("ZsdqNMWqz",9) == 4254560719) strcat(s, "r");
if (crc32("tPHpdegSVdLYwO",14) == 3300537351) strcat(s, "z");
if (crc32("wrGvUdTeFUPe",12) == 2232411921) strcat(s, "m");
if (crc32("VhpylADnjIXXJcP",15) == 800561287) strcat(s, "G");
if (crc32("MkUCJHF",7) == 2042866312) strcat(s, "o");
if (crc32("iJvKfZVRiHh",11) == 2435029272) strcat(s, "r");
if (crc32("enZDXTXZ",8) == 3122027905) strcat(s, "a");
if (crc32("HdkYS",5) == 761264231) strcat(s, "X");
if (crc32("GcXTJaNDTU",10) == 1749331159) strcat(s, "l");
if (crc32("VwTRhdOJlB",10) == 3277251171) strcat(s, "w");
if (crc32("bRsxYOLQ",8) == 2329001966) strcat(s, "i");
if (crc32("HPspEzVNQAqJT",13) == 2360507013) strcat(s, "z");
if (crc32("etXWGFXLtVj",11) == 2965226708) strcat(s, "i");
if (crc32("lNSJSe",6) == 567065520) strcat(s, "n");
if (crc32("aTJZDi",6) == 587066424) strcat(s, "g");
if (crc32("yScYoWsej",9) == 1587383400) strcat(s, "g");
    return s;
}

char *formalized_verbs() {
    char *s = calloc(11);
    if (crc32("oOVZiGZC",8) == 3936670294) strcat(s, "f");
if (crc32("dWKDoiyHsxLI",12) == 2155537885) strcat(s, "Q");
if (crc32("rPmLxEZ",7) == 103250096) strcat(s, "o");
if (crc32("PfXLYHwL",8) == 1906726297) strcat(s, "y");
if (crc32("VTvvIxSQ",8) == 3139195541) strcat(s, "r");
if (crc32("TCeauJM",7) == 1102262874) strcat(s, "m");
if (crc32("XoiXbww",7) == 2542426399) strcat(s, "k");
if (crc32("goYZnMcGQPW",11) == 3125275422) strcat(s, "a");
if (crc32("oWojtcF",7) == 4266481539) strcat(s, "Y");
if (crc32("aPBeM",5) == 3397672227) strcat(s, "l");
if (crc32("hzliLcUfKteF",12) == 1266847258) strcat(s, "U");
if (crc32("zHSYxHtZ",8) == 2158030559) strcat(s, "i");
if (crc32("awoIBSEWDWZq",12) == 4212586060) strcat(s, "z");
if (crc32("LALlOWX",7) == 4202880767) strcat(s, "i");
if (crc32("aujYNzOo",8) == 3542019277) strcat(s, "e");
if (crc32("rUHGtTeF",8) == 518939470) strcat(s, "D");
if (crc32("lMyPBrPl",8) == 1263776073) strcat(s, "d");
    return s;
}

char *unstick_verbs() {
    char *s = calloc(8);
    if (crc32("VPmYbkqXtdcNV",13) == 3375819946) strcat(s, "b");
if (crc32("KtWhWoaTYPfWvYV",15) == 3267567935) strcat(s, "u");
if (crc32("ntASVYafHWTXbH",14) == 1763670337) strcat(s, "x");
if (crc32("eXkcCEVW",8) == 3081544223) strcat(s, "n");
if (crc32("TmIImvzhTMBljfZ",15) == 3012631290) strcat(s, "s");
if (crc32("OGRgJmw",7) == 4117201508) strcat(s, "P");
if (crc32("BabbjI",6) == 493752038) strcat(s, "t");
if (crc32("YItefgqmjgR",11) == 4089969267) strcat(s, "G");
if (crc32("HsSSjMIoVfWrRH",14) == 2439525094) strcat(s, "i");
if (crc32("AIOCEGNLUQto",12) == 2864226587) strcat(s, "B");
if (crc32("SiXjnlPACKQMKHP",15) == 4130947709) strcat(s, "c");
if (crc32("ztpBFX",6) == 257184654) strcat(s, "Z");
if (crc32("ZPEoTVeACmy",11) == 556615835) strcat(s, "k");
    return s;
}

char *spraddled_verbs() {
    char *s = calloc(10);
    if (crc32("YrEZvXP",7) == 270366053) strcat(s, "s");
if (crc32("hfhZEpACuOtDZp",14) == 1291312521) strcat(s, "p");
if (crc32("QYeaaYl",7) == 2272224864) strcat(s, "p");
if (crc32("YYBnVX",6) == 1430585518) strcat(s, "r");
if (crc32("QpGAhPwVyKLWwV",14) == 2379024159) strcat(s, "a");
if (crc32("ahxuIfB",7) == 360166506) strcat(s, "d");
if (crc32("cLMwkUzZvcJyYH",14) == 2191000820) strcat(s, "g");
if (crc32("JojbQZhGczsjO",13) == 1259642538) strcat(s, "d");
if (crc32("PFUPGwazVTcA",12) == 3286132396) strcat(s, "E");
if (crc32("PqMXnnPfcgFHWjV",15) == 368308750) strcat(s, "l");
if (crc32("QcxfEfougR",10) == 2418037503) strcat(s, "e");
if (crc32("XgMnyMoMroD",11) == 217474740) strcat(s, "d");
    return s;
}

char *mummified_verbs() {
    char *s = calloc(10);
    if (crc32("ErBzJwhp",8) == 3597457396) strcat(s, "m");
if (crc32("BEDvWkETnZ",10) == 2729141058) strcat(s, "f");
if (crc32("JDcMyyfRGSm",11) == 3937155330) strcat(s, "u");
if (crc32("vQNKEwNxpVHkVj",14) == 3542460611) strcat(s, "m");
if (crc32("IISmpNbkevooH",13) == 27632207) strcat(s, "R");
if (crc32("oQPmBkOECNf",11) == 3103302489) strcat(s, "m");
if (crc32("SjXiaP",6) == 3086795755) strcat(s, "W");
if (crc32("sucyW",5) == 1708281405) strcat(s, "i");
if (crc32("FUwvRHIHLrUHzO",14) == 3923522486) strcat(s, "f");
if (crc32("qEviz",5) == 1316754171) strcat(s, "X");
if (crc32("jQZrUf",6) == 2366002528) strcat(s, "i");
if (crc32("UHetxuBLwqB",11) == 1497113619) strcat(s, "e");
if (crc32("wXIACo",6) == 3395897569) strcat(s, "g");
if (crc32("nThCYQSSeP",10) == 2678512082) strcat(s, "d");
    return s;
}

char *readvising_verbs() {
    char *s = calloc(11);
    if (crc32("XzVvmroPA",9) == 3949327925) strcat(s, "K");
if (crc32("vrXAEfJXpTGVK",13) == 699491363) strcat(s, "r");
if (crc32("UvJDjAwkH",9) == 2681978722) strcat(s, "e");
if (crc32("EQnvUfYhYcyiy",13) == 1459620112) strcat(s, "a");
if (crc32("gZKepUoKi",9) == 11447817) strcat(s, "Q");
if (crc32("dwDZa",5) == 1359642553) strcat(s, "d");
if (crc32("MYERJQLoG",9) == 3328644321) strcat(s, "v");
if (crc32("TSQFZTVgtoPct",13) == 3737203082) strcat(s, "i");
if (crc32("dfDdEKYtUtPoj",13) == 3564199416) strcat(s, "G");
if (crc32("zDlVlWq",7) == 1613523502) strcat(s, "s");
if (crc32("YWfuOGmGYl",10) == 2673212654) strcat(s, "i");
if (crc32("LwOViE",6) == 3822201833) strcat(s, "S");
if (crc32("LKTHdsfuNZeUR",13) == 4087852612) strcat(s, "n");
if (crc32("rHMzSqQCIGCJtLo",15) == 2242804745) strcat(s, "i");
if (crc32("DckpGVnh",8) == 1068484501) strcat(s, "g");
    return s;
}

char *coinsure_verbs() {
    char *s = calloc(9);
    if (crc32("pzGFIGjrORVpnCu",15) == 2520242902) strcat(s, "c");
if (crc32("tuMbBtcJghHid",13) == 1648706487) strcat(s, "w");
if (crc32("ZHwDKQfMgVD",11) == 1811172145) strcat(s, "o");
if (crc32("uDoyQwwJJfUiy",13) == 1492583014) strcat(s, "h");
if (crc32("WAfYoNzjLZZkQa",14) == 1611565255) strcat(s, "i");
if (crc32("nXBPovVpE",9) == 2418702990) strcat(s, "I");
if (crc32("ZGvrwCPbhIa",11) == 3033095449) strcat(s, "n");
if (crc32("fOKXbSHnvYLGmR",14) == 447777747) strcat(s, "s");
if (crc32("HvTNNnYLhXMk",12) == 2937340698) strcat(s, "u");
if (crc32("YEhiJ",5) == 2360298664) strcat(s, "V");
if (crc32("MTgFG",5) == 556601861) strcat(s, "r");
if (crc32("lNxQaqrOA",9) == 780334121) strcat(s, "e");
    return s;
}

char *quaver_verbs() {
    char *s = calloc(7);
    if (crc32("xNMbp",5) == 1718764363) strcat(s, "i");
if (crc32("AGgZHreCu",9) == 4079909573) strcat(s, "q");
if (crc32("zWsLlIBtRatwIm",14) == 2594623136) strcat(s, "u");
if (crc32("jaudiFvSHqMLQ",13) == 3867649454) strcat(s, "X");
if (crc32("JvmKOBcNUCP",11) == 4063137821) strcat(s, "a");
if (crc32("DwSnWfY",7) == 3618020098) strcat(s, "v");
if (crc32("KuCFQVZ",7) == 729956680) strcat(s, "e");
if (crc32("AGiMjSOqyrWdHm",14) == 4082625061) strcat(s, "A");
if (crc32("TlBTyyBho",9) == 3954849521) strcat(s, "r");
    return s;
}

char *medalling_verbs() {
    char *s = calloc(10);
    if (crc32("szwMFIlrc",9) == 829305469) strcat(s, "m");
if (crc32("TLYXpFkfM",9) == 1972390008) strcat(s, "g");
if (crc32("PEnKywPicJwg",12) == 2517807667) strcat(s, "e");
if (crc32("zEjhjnEffoLYfv",14) == 1206737957) strcat(s, "d");
if (crc32("aZlScdaoFyDwFs",14) == 1652309476) strcat(s, "a");
if (crc32("mGUyL",5) == 4246380520) strcat(s, "z");
if (crc32("vRTUgKfTLHJQa",13) == 1179136861) strcat(s, "l");
if (crc32("aemYG",5) == 2907096204) strcat(s, "l");
if (crc32("VLODYhkC",8) == 3049320606) strcat(s, "v");
if (crc32("aFcxXogSFapKt",13) == 1871727971) strcat(s, "i");
if (crc32("hmNoyrXrRVrVWnl",15) == 4188206089) strcat(s, "n");
if (crc32("VoEAialk",8) == 2910877415) strcat(s, "g");
    return s;
}

char *drugging_verbs() {
    char *s = calloc(9);
    if (crc32("cBhzD",5) == 3585104968) strcat(s, "l");
if (crc32("vBnPqlWFStUsT",13) == 3035200187) strcat(s, "d");
if (crc32("GTIEKhnbYqpqA",13) == 1637080851) strcat(s, "r");
if (crc32("mtkWdAOGoscr",12) == 3687754884) strcat(s, "u");
if (crc32("lHHJPGH",7) == 98100463) strcat(s, "g");
if (crc32("cprTDDovSbbjx",13) == 293402163) strcat(s, "c");
if (crc32("WJEyQRtPOJgdWeI",15) == 1234423942) strcat(s, "g");
if (crc32("OnIJZ",5) == 958075295) strcat(s, "i");
if (crc32("XSgZdrdK",8) == 2103183953) strcat(s, "s");
if (crc32("wUZBeTxdguRZUUB",15) == 1324949727) strcat(s, "n");
if (crc32("TBEiuOOVqE",10) == 465453079) strcat(s, "w");
if (crc32("PHvFBsTnCNjQ",12) == 168088102) strcat(s, "g");
    return s;
}

char *garaging_verbs() {
    char *s = calloc(9);
    if (crc32("cUBzWhukl",9) == 60483337) strcat(s, "g");
if (crc32("EYZnowU",7) == 2218384294) strcat(s, "e");
if (crc32("AZnbGZSC",8) == 3474404539) strcat(s, "a");
if (crc32("uUXZSripYSK",11) == 245131201) strcat(s, "r");
if (crc32("ZhipjF",6) == 2816934383) strcat(s, "a");
if (crc32("HpQLFjY",7) == 1523364587) strcat(s, "x");
if (crc32("ihxuGZofhpygu",13) == 2986710847) strcat(s, "g");
if (crc32("XehlJdxclJPs",12) == 1591555158) strcat(s, "O");
if (crc32("YKzbk",5) == 1811536360) strcat(s, "i");
if (crc32("tsAaNBkiqkNfmSC",15) == 4182061094) strcat(s, "T");
if (crc32("oTUWlsrUW",9) == 2485591550) strcat(s, "n");
if (crc32("vyCJcvaK",8) == 157639773) strcat(s, "g");
    return s;
}

char *handseled_verbs() {
    char *s = calloc(10);
    if (crc32("VVKfLcYmfp",10) == 4193870637) strcat(s, "h");
if (crc32("FlAyQDthbFQIEJC",15) == 1970761777) strcat(s, "a");
if (crc32("UoXFyKIX",8) == 2996993652) strcat(s, "R");
if (crc32("dHKCL",5) == 750855454) strcat(s, "n");
if (crc32("VvbWdC",6) == 999480108) strcat(s, "n");
if (crc32("YgNFByuPsVDBHg",14) == 2065174584) strcat(s, "d");
if (crc32("YjKdTBKoQ",9) == 3729428622) strcat(s, "D");
if (crc32("hhyOLFDCbyOzo",13) == 4144405438) strcat(s, "s");
if (crc32("LTfvmDVE",8) == 809335112) strcat(s, "e");
if (crc32("QdjmRC",6) == 1768868756) strcat(s, "l");
if (crc32("YbfMlUiS",8) == 276197047) strcat(s, "e");
if (crc32("vLsabP",6) == 2401438735) strcat(s, "H");
if (crc32("BZMxedegRrynRD",14) == 668562556) strcat(s, "d");
    return s;
}

char *reswear_verbs() {
    char *s = calloc(8);
    if (crc32("pxnUN",5) == 3208568568) strcat(s, "y");
if (crc32("vNPhx",5) == 1413348205) strcat(s, "r");
if (crc32("ZRzGSpu",7) == 2190217800) strcat(s, "p");
if (crc32("PwrpwXNpeSe",11) == 3524606186) strcat(s, "e");
if (crc32("MxWRKTIem",9) == 786153979) strcat(s, "s");
if (crc32("ABFgeWsrcjCBZRH",15) == 2286639579) strcat(s, "H");
if (crc32("ggLpn",5) == 3077886711) strcat(s, "w");
if (crc32("lDPtUuPc",8) == 2451000722) strcat(s, "e");
if (crc32("fQgKIrtWxNkYTPG",15) == 419828578) strcat(s, "R");
if (crc32("CiDkCzHIuoBaAfv",15) == 3937494340) strcat(s, "a");
if (crc32("KyQLRLydmNKw",12) == 1469464050) strcat(s, "q");
if (crc32("MMCGWMqGd",9) == 1600888621) strcat(s, "r");
    return s;
}

char *officiating_verbs() {
    char *s = calloc(12);
    if (crc32("LihTYVpcEYEB",12) == 1656652887) strcat(s, "J");
if (crc32("HPywcSw",7) == 4048185725) strcat(s, "o");
if (crc32("kwuLpcNnQxbr",12) == 403167764) strcat(s, "f");
if (crc32("Ymtuz",5) == 1943500642) strcat(s, "a");
if (crc32("xtFjXNLLDWXxEz",14) == 697347818) strcat(s, "f");
if (crc32("KLhTWfHOAI",10) == 451393714) strcat(s, "F");
if (crc32("vGNxRjzj",8) == 783441022) strcat(s, "i");
if (crc32("ZGUNBFjQLbpl",12) == 2945323581) strcat(s, "z");
if (crc32("vjZFMAcBPCMEN",13) == 957069717) strcat(s, "c");
if (crc32("fIejjJRXLmyL",12) == 658256208) strcat(s, "X");
if (crc32("CJTifPmZrQgxYo",14) == 340493643) strcat(s, "i");
if (crc32("tGQXpjkNStH",11) == 930103806) strcat(s, "a");
if (crc32("LLviYU",6) == 762417781) strcat(s, "t");
if (crc32("YgjRCyRRslmeIzp",15) == 3006820480) strcat(s, "b");
if (crc32("AsTiNhimhHgKS",13) == 1034005990) strcat(s, "i");
if (crc32("FNKJSqqwjo",10) == 2088289894) strcat(s, "n");
if (crc32("vCWLUUNZmGJeKYt",15) == 199175203) strcat(s, "P");
if (crc32("SZvdNiQECxPA",12) == 1294129583) strcat(s, "g");
    return s;
}

char *cadenced_verbs() {
    char *s = calloc(9);
    if (crc32("KpDfkPXhCQoMaX",14) == 3040631685) strcat(s, "N");
if (crc32("KiSsSWPARffhrNM",15) == 2564270567) strcat(s, "c");
if (crc32("mszwjJseFxPX",12) == 2581827515) strcat(s, "a");
if (crc32("iBtLAdE",7) == 1782391022) strcat(s, "d");
if (crc32("xigXdtMvQOr",11) == 431778362) strcat(s, "e");
if (crc32("eWMUm",5) == 1302827612) strcat(s, "n");
if (crc32("iPsjO",5) == 561601788) strcat(s, "U");
if (crc32("ybMYBetmbBEvR",13) == 842875881) strcat(s, "c");
if (crc32("TIkjYXxobIE",11) == 3464209554) strcat(s, "e");
if (crc32("KppnFU",6) == 4220817973) strcat(s, "d");
if (crc32("guvrxFrM",8) == 2429389676) strcat(s, "d");
    return s;
}

char *vernalize_verbs() {
    char *s = calloc(10);
    if (crc32("ImljDvtSVYtL",12) == 2602234946) strcat(s, "H");
if (crc32("WfcFBJVIe",9) == 657043149) strcat(s, "v");
if (crc32("AmACgoCdwISkX",13) == 1278981439) strcat(s, "e");
if (crc32("NseIZ",5) == 3161611050) strcat(s, "r");
if (crc32("HfnOROYAveoFx",13) == 3972478104) strcat(s, "v");
if (crc32("rJUqZXSzzDuCR",13) == 1842217131) strcat(s, "n");
if (crc32("wRpUvhmGJcLfmAI",15) == 2753544981) strcat(s, "I");
if (crc32("VEqyCuh",7) == 864348421) strcat(s, "a");
if (crc32("qIdYtKR",7) == 1084775052) strcat(s, "G");
if (crc32("wOCVG",5) == 941792977) strcat(s, "l");
if (crc32("dDgMxKOPNwhPY",13) == 2656212974) strcat(s, "i");
if (crc32("bLUAUDE",7) == 3528516611) strcat(s, "z");
if (crc32("KoieLCKVu",9) == 2725215018) strcat(s, "j");
if (crc32("CNjoMPZBtbPxRu",14) == 3999887756) strcat(s, "e");
    return s;
}

char *helpout_verbs() {
    char *s = calloc(8);
    if (crc32("UaUbZHDp",8) == 2956148735) strcat(s, "c");
if (crc32("QtDFhLxZ",8) == 1287249350) strcat(s, "h");
if (crc32("UwczmBNUjM",10) == 375369635) strcat(s, "y");
if (crc32("HtalvfxB",8) == 1697460010) strcat(s, "e");
if (crc32("KJpEpsQe",8) == 3379527242) strcat(s, "l");
if (crc32("hKTLoTtF",8) == 742791542) strcat(s, "M");
if (crc32("jZlOZbZosR",10) == 3751801289) strcat(s, "p");
if (crc32("XigfoTLJGaURch",14) == 1081257969) strcat(s, "D");
if (crc32("XcpjmSprqTbHA",13) == 354733780) strcat(s, "o");
if (crc32("bCagDp",6) == 3787430805) strcat(s, "u");
if (crc32("hUBZgJZNMLgV",12) == 3919053379) strcat(s, "t");
    return s;
}

char *quoted_verbs() {
    char *s = calloc(7);
    if (crc32("cegbIDBzdYy",11) == 1717489011) strcat(s, "I");
if (crc32("JLTHvEJ",7) == 3720683947) strcat(s, "q");
if (crc32("dcWXUDqBkhNEy",13) == 915060189) strcat(s, "u");
if (crc32("BQfge",5) == 3432926166) strcat(s, "o");
if (crc32("sJQLZ",5) == 2125268488) strcat(s, "t");
if (crc32("DUWlOB",6) == 769449803) strcat(s, "t");
if (crc32("sZvAJhhyVBK",11) == 874936500) strcat(s, "e");
if (crc32("ppXDJuJ",7) == 3365696796) strcat(s, "R");
if (crc32("TxOZazXKTdjWg",13) == 370223814) strcat(s, "d");
    return s;
}

char *stropping_verbs() {
    char *s = calloc(10);
    if (crc32("CWERzlcrPBLigKR",15) == 3883329069) strcat(s, "n");
if (crc32("gizVMfP",7) == 2165102801) strcat(s, "s");
if (crc32("QsnqKbPDcx",10) == 3024456284) strcat(s, "n");
if (crc32("MhEWq",5) == 1014657307) strcat(s, "t");
if (crc32("uHfgeil",7) == 2609865133) strcat(s, "z");
if (crc32("sLPLLnTWhhr",11) == 4216762612) strcat(s, "r");
if (crc32("scKTC",5) == 470736820) strcat(s, "o");
if (crc32("iUJOQnkqVKgbp",13) == 554420034) strcat(s, "p");
if (crc32("DKBmgRrO",8) == 246648008) strcat(s, "n");
if (crc32("BsrnylBbq",9) == 4217298256) strcat(s, "p");
if (crc32("KJwFtyqwZAqF",12) == 298531996) strcat(s, "i");
if (crc32("ZKzrpIBmgdaunB",14) == 3625889336) strcat(s, "n");
if (crc32("gDirXfCmfl",10) == 2940082531) strcat(s, "g");
    return s;
}

char *confining_verbs() {
    char *s = calloc(10);
    if (crc32("YJWsAFOvsUdC",12) == 81996856) strcat(s, "q");
if (crc32("afwMebYGwv",10) == 3499895223) strcat(s, "c");
if (crc32("LbJhTTIPAb",10) == 703828496) strcat(s, "M");
if (crc32("gYHgpfHykYi",11) == 3219737786) strcat(s, "o");
if (crc32("qAsnNY",6) == 3556186860) strcat(s, "M");
if (crc32("kuaiwPTmiPyVhNq",15) == 1311663616) strcat(s, "n");
if (crc32("fkpMMl",6) == 2468587916) strcat(s, "f");
if (crc32("KnKdidQq",8) == 1310976898) strcat(s, "i");
if (crc32("PRlNFxLCcRgbrzr",15) == 1202754978) strcat(s, "A");
if (crc32("rXRIwHWas",9) == 3955866348) strcat(s, "n");
if (crc32("JIkcKWjVNM",10) == 2590856033) strcat(s, "i");
if (crc32("skAFN",5) == 3459536414) strcat(s, "l");
if (crc32("yKhrXQ",6) == 1965375774) strcat(s, "n");
if (crc32("piexFWcTMJJsh",13) == 1978720426) strcat(s, "g");
    return s;
}

char *reexperiencing_verbs() {
    char *s = calloc(15);
    if (crc32("bNyYTdXpQxBcVc",14) == 3608045309) strcat(s, "r");
if (crc32("qtIHSwsLV",9) == 2375350040) strcat(s, "h");
if (crc32("ulpMhxfFNFnwDFv",15) == 3927154113) strcat(s, "e");
if (crc32("lHpIfoJvCrow",12) == 4286930631) strcat(s, "e");
if (crc32("SiCLjEoApEeq",12) == 3209540026) strcat(s, "x");
if (crc32("hGgcMRPdIVGiQ",13) == 1110591620) strcat(s, "c");
if (crc32("pNZPQ",5) == 2210901900) strcat(s, "p");
if (crc32("umOqHmUyeHYnI",13) == 2842446813) strcat(s, "e");
if (crc32("QJABxQZ",7) == 2424248367) strcat(s, "r");
if (crc32("bsOjJxkmwKTg",12) == 2649607614) strcat(s, "i");
if (crc32("PudcVOLZymkH",12) == 4131149246) strcat(s, "e");
if (crc32("jABaSbMwhmFGsT",14) == 3223823446) strcat(s, "D");
if (crc32("oxHVWzKyxzsnHw",14) == 3878820777) strcat(s, "n");
if (crc32("xDeOxzitXI",10) == 4135547227) strcat(s, "W");
if (crc32("abrNsHCQiRxWeLA",15) == 91914350) strcat(s, "c");
if (crc32("FzBpyQja",8) == 2808392124) strcat(s, "i");
if (crc32("sTOyxUdQmyeMt",13) == 4026919067) strcat(s, "m");
if (crc32("IwvunSmaoWcjUFN",15) == 413143960) strcat(s, "n");
if (crc32("aqNoB",5) == 1730227243) strcat(s, "R");
if (crc32("sfUIjVpXM",9) == 1929601669) strcat(s, "g");
    return s;
}

char *bulkup_verbs() {
    char *s = calloc(7);
    if (crc32("SQLJqQfvw",9) == 2673304439) strcat(s, "d");
if (crc32("oKVePvmY",8) == 4168464592) strcat(s, "b");
if (crc32("tEEQthQjIt",10) == 3950695740) strcat(s, "w");
if (crc32("ckxtJELon",9) == 3459539917) strcat(s, "u");
if (crc32("HHXFLcWLCoi",11) == 494430216) strcat(s, "G");
if (crc32("hVhmFadE",8) == 1398881131) strcat(s, "l");
if (crc32("bxeIgnvp",8) == 3899245806) strcat(s, "k");
if (crc32("kRUEMvi",7) == 1022074678) strcat(s, "u");
if (crc32("TtPfcaUBmeCQMv",14) == 1392979182) strcat(s, "p");
    return s;
}

char *cravatted_verbs() {
    char *s = calloc(10);
    if (crc32("qvmwgivlBgiWpGH",15) == 807024346) strcat(s, "o");
if (crc32("QHSETxKXSg",10) == 801845587) strcat(s, "c");
if (crc32("IeJQVdDKgQ",10) == 608074943) strcat(s, "m");
if (crc32("IZlAscGxYZSCISd",15) == 1895256327) strcat(s, "r");
if (crc32("YPfFjnf",7) == 2504864339) strcat(s, "a");
if (crc32("ITsySDNOT",9) == 1759897344) strcat(s, "h");
if (crc32("eviPwyMNshMi",12) == 1199875262) strcat(s, "v");
if (crc32("mqFZru",6) == 589841944) strcat(s, "a");
if (crc32("FasWQN",6) == 3561553566) strcat(s, "c");
if (crc32("bvhlqDP",7) == 784449995) strcat(s, "t");
if (crc32("JiWWqtuavMwExP",14) == 364026570) strcat(s, "k");
if (crc32("DzWZKxKLRERBZ",13) == 2528816496) strcat(s, "t");
if (crc32("XgnbRxGUkulFW",13) == 3672755985) strcat(s, "m");
if (crc32("GEdoKcHGbQju",12) == 1203388104) strcat(s, "e");
if (crc32("hhgqpy",6) == 151219627) strcat(s, "d");
    return s;
}

char *wish_verbs() {
    char *s = calloc(5);
    if (crc32("jLKtkIGzxjAxzb",14) == 2899267352) strcat(s, "w");
if (crc32("qMtbnRIhfU",10) == 1582283049) strcat(s, "i");
if (crc32("mEqzBNHzcGvT",12) == 1894877735) strcat(s, "i");
if (crc32("UjgCHiwjhT",10) == 2564315102) strcat(s, "i");
if (crc32("TTrCofAlGYsWNJ",14) == 3365153086) strcat(s, "s");
if (crc32("YsrqIhZgKRSAVs",14) == 229090896) strcat(s, "h");
    return s;
}

char *sledding_verbs() {
    char *s = calloc(9);
    if (crc32("yBWWiZmkmCazEj",14) == 4224716623) strcat(s, "C");
if (crc32("tSPSuZErDGPwu",13) == 3176627644) strcat(s, "s");
if (crc32("WQahD",5) == 2737579208) strcat(s, "N");
if (crc32("OhfAuoINiRB",11) == 415931116) strcat(s, "l");
if (crc32("ZWssMUYenJQx",12) == 3403731005) strcat(s, "e");
if (crc32("QSeUVrW",7) == 2627963876) strcat(s, "F");
if (crc32("XjXelfMQ",8) == 423229717) strcat(s, "d");
if (crc32("xbrOUuVJtq",10) == 1227403442) strcat(s, "P");
if (crc32("FoYVtzC",7) == 4052590252) strcat(s, "d");
if (crc32("CmlVrIln",8) == 1024160932) strcat(s, "i");
if (crc32("msdPssX",7) == 3024136763) strcat(s, "R");
if (crc32("ukxaAMCEOAACK",13) == 1755658817) strcat(s, "n");
if (crc32("JzGuFC",6) == 1200688170) strcat(s, "X");
if (crc32("CncWQq",6) == 3670957354) strcat(s, "g");
    return s;
}

char *forecasting_verbs() {
    char *s = calloc(12);
    if (crc32("ElryZwCnFA",10) == 1012685695) strcat(s, "j");
if (crc32("nCIOjbkYl",9) == 3547708494) strcat(s, "f");
if (crc32("ZuHPmjt",7) == 1792903076) strcat(s, "o");
if (crc32("skcycWO",7) == 4066563548) strcat(s, "m");
if (crc32("ZRPtGFTSZvgJbvX",15) == 2630210564) strcat(s, "r");
if (crc32("xSrmW",5) == 2752614876) strcat(s, "e");
if (crc32("VRAULlRgQdEhh",13) == 27876269) strcat(s, "X");
if (crc32("SDDHdcMVBOronkD",15) == 1158468209) strcat(s, "c");
if (crc32("aHJFG",5) == 1518529099) strcat(s, "R");
if (crc32("iTdtt",5) == 1166676223) strcat(s, "a");
if (crc32("ZdjsfWYZtsQr",12) == 2211740201) strcat(s, "k");
if (crc32("TVLYevPVOQxAtTw",15) == 1828767765) strcat(s, "s");
if (crc32("eiEJIprlaNi",11) == 1887232094) strcat(s, "t");
if (crc32("SjMPSPk",7) == 1131538015) strcat(s, "i");
if (crc32("EhYDWjCTKrZ",11) == 2211969833) strcat(s, "n");
if (crc32("eJjqRupiiHfkkyG",15) == 3836065775) strcat(s, "g");
    return s;
}

char *unman_verbs() {
    char *s = calloc(6);
    if (crc32("lTFTEnV",7) == 3667819473) strcat(s, "u");
if (crc32("EdtkzRTZIp",10) == 1398457603) strcat(s, "A");
if (crc32("WkNdaT",6) == 1784568905) strcat(s, "n");
if (crc32("ziGqyWHlbBLOaCn",15) == 4013265398) strcat(s, "m");
if (crc32("eZMXdf",6) == 902397190) strcat(s, "a");
if (crc32("PBDwLxhjKfLCoR",14) == 2614860013) strcat(s, "n");
    return s;
}

char *overbalancing_verbs() {
    char *s = calloc(14);
    if (crc32("ApgZgNsETzhoUD",14) == 340828289) strcat(s, "E");
if (crc32("Jucsfp",6) == 850777327) strcat(s, "o");
if (crc32("weCjVR",6) == 2380096058) strcat(s, "o");
if (crc32("xIUGgYobZQUxRFf",15) == 4287132601) strcat(s, "v");
if (crc32("qCgRlWWI",8) == 1809745888) strcat(s, "T");
if (crc32("nfXiQNOVgNbARw",14) == 2375205233) strcat(s, "e");
if (crc32("zgUKHWGgbaE",11) == 1950242324) strcat(s, "d");
if (crc32("IrjGzYHiOT",10) == 34381196) strcat(s, "r");
if (crc32("yYiuxNIdJGP",11) == 981321380) strcat(s, "M");
if (crc32("ewbheydLEpn",11) == 2495444122) strcat(s, "b");
if (crc32("hpDZcUzyC",9) == 311587910) strcat(s, "F");
if (crc32("lrhISzMkwO",10) == 3053484377) strcat(s, "a");
if (crc32("xsEfJfgbp",9) == 1979172902) strcat(s, "t");
if (crc32("NSnaJcJbv",9) == 2611027558) strcat(s, "l");
if (crc32("DFeGDPkWHuxwF",13) == 802716107) strcat(s, "a");
if (crc32("hVkfIBUtCxTAw",13) == 578263616) strcat(s, "n");
if (crc32("RVAHFmzsDHnCLis",15) == 2966198998) strcat(s, "P");
if (crc32("IZGwxvy",7) == 4153407033) strcat(s, "c");
if (crc32("BCtBBDXzeZswgV",14) == 2780003934) strcat(s, "i");
if (crc32("PgRjCiiyJhp",11) == 1705833883) strcat(s, "n");
if (crc32("XSJkvo",6) == 988782595) strcat(s, "g");
    return s;
}

char *rave_verbs() {
    char *s = calloc(5);
    if (crc32("TcUXRQqytLf",11) == 674760211) strcat(s, "m");
if (crc32("zgwRFdS",7) == 1838664592) strcat(s, "r");
if (crc32("srBkddjUJKp",11) == 2119572981) strcat(s, "a");
if (crc32("zzPJGjbFiS",10) == 2961942271) strcat(s, "v");
if (crc32("LiSsQ",5) == 3392346924) strcat(s, "Z");
if (crc32("KHdEUGTzDrGoHLo",15) == 812091650) strcat(s, "e");
    return s;
}

char *counterpoising_verbs() {
    char *s = calloc(15);
    if (crc32("BYVAwdmvC",9) == 4044101668) strcat(s, "c");
if (crc32("EfsvGeJbgsUOAlN",15) == 1583444424) strcat(s, "o");
if (crc32("QbDoeyQvePTAV",13) == 3150759390) strcat(s, "d");
if (crc32("RZWpQ",5) == 2061608145) strcat(s, "u");
if (crc32("VsOUXxXZPzfRUz",14) == 453630481) strcat(s, "n");
if (crc32("mlMKPmovkQ",10) == 2687298816) strcat(s, "Z");
if (crc32("qqChurdzv",9) == 587436484) strcat(s, "t");
if (crc32("nWCDTzPDQnEX",12) == 4228855610) strcat(s, "e");
if (crc32("gITxVJnGC",9) == 2277108621) strcat(s, "c");
if (crc32("NSjdoiNlHVlOeM",14) == 588639605) strcat(s, "r");
if (crc32("NkgVeoZMlRuFo",13) == 3820280840) strcat(s, "p");
if (crc32("KfbqZfGAlyJtSM",14) == 4117863435) strcat(s, "b");
if (crc32("wZzIe",5) == 1818601497) strcat(s, "o");
if (crc32("lZuBqYa",7) == 2025822403) strcat(s, "i");
if (crc32("Misumv",6) == 3567503623) strcat(s, "s");
if (crc32("daILvmeKAJNpfL",14) == 848797725) strcat(s, "b");
if (crc32("AZguDkoILTDH",12) == 491737142) strcat(s, "i");
if (crc32("tOjZJjd",7) == 2763472303) strcat(s, "n");
if (crc32("SsbbUHHpbAwWwK",14) == 1179845277) strcat(s, "s");
if (crc32("hPpDdslVvUdMpvr",15) == 1698392525) strcat(s, "g");
    return s;
}

char *intertrafficked_verbs() {
    char *s = calloc(16);
    if (crc32("ptQeqpOC",8) == 3462519720) strcat(s, "c");
if (crc32("NgYEYI",6) == 196047304) strcat(s, "i");
if (crc32("OckZBQfFdUQ",11) == 498823596) strcat(s, "h");
if (crc32("rDNyjGLZFVDKDb",14) == 1330680450) strcat(s, "n");
if (crc32("FWTpJxGSDJAdRND",15) == 3739789651) strcat(s, "q");
if (crc32("DBXLlaf",7) == 803465779) strcat(s, "t");
if (crc32("TLUeSr",6) == 646756054) strcat(s, "e");
if (crc32("uszFMfNiJfQKB",13) == 2343214804) strcat(s, "W");
if (crc32("ZKVSCrk",7) == 2752026930) strcat(s, "r");
if (crc32("rgOVwy",6) == 1054579444) strcat(s, "t");
if (crc32("WzHLUTghxEAjK",13) == 1959720992) strcat(s, "r");
if (crc32("HXAUDk",6) == 4210955860) strcat(s, "D");
if (crc32("rOewOVt",7) == 2145403863) strcat(s, "a");
if (crc32("ucqYs",5) == 478308059) strcat(s, "V");
if (crc32("GTPOwCSn",8) == 4167431970) strcat(s, "f");
if (crc32("CAeEenM",7) == 4176699107) strcat(s, "a");
if (crc32("dQNbRfILW",9) == 2769604942) strcat(s, "f");
if (crc32("wXZZrAPuAnz",11) == 3559959188) strcat(s, "i");
if (crc32("vSGiqhubzUMR",12) == 1616226439) strcat(s, "h");
if (crc32("qMrHSjyLkhhjupB",15) == 37965130) strcat(s, "c");
if (crc32("QOjLXHNZUkcBuK",14) == 244691901) strcat(s, "o");
if (crc32("IZyyiwkbfBoix",13) == 2026767126) strcat(s, "k");
if (crc32("XdrqUbfhrVbYFw",14) == 2014167686) strcat(s, "J");
if (crc32("rBzycicujHX",11) == 2391951703) strcat(s, "e");
if (crc32("pbDWxMoZXxP",11) == 2711341600) strcat(s, "d");
    return s;
}

char *manufacture_verbs() {
    char *s = calloc(12);
    if (crc32("VjPntyRYC",9) == 1022899647) strcat(s, "B");
if (crc32("nazlZSlFUvuvuC",14) == 260834980) strcat(s, "m");
if (crc32("tgAUDN",6) == 258690162) strcat(s, "b");
if (crc32("kbLGrHfF",8) == 1969548525) strcat(s, "a");
if (crc32("AixMkxevS",9) == 158803550) strcat(s, "n");
if (crc32("fPfqfruWmZY",11) == 4038922168) strcat(s, "A");
if (crc32("SMUSzQNzkLo",11) == 2872826915) strcat(s, "u");
if (crc32("nkccvtUu",8) == 2198804216) strcat(s, "f");
if (crc32("EYRkucKydNmt",12) == 599075187) strcat(s, "C");
if (crc32("hWrPHHTFheTedUh",15) == 900451621) strcat(s, "a");
if (crc32("uFDgXaDhDCerXYF",15) == 966843173) strcat(s, "c");
if (crc32("PJoeNtmRCnh",11) == 2943189830) strcat(s, "r");
if (crc32("vQDIk",5) == 1330242357) strcat(s, "t");
if (crc32("QiplrgmsTxK",11) == 1982237359) strcat(s, "p");
if (crc32("qGAYsZfUU",9) == 1629610271) strcat(s, "u");
if (crc32("yTVxPNzfDKfKI",13) == 644462777) strcat(s, "C");
if (crc32("vTCkkWtNUrYNT",13) == 2957096118) strcat(s, "r");
if (crc32("ltuEMVBR",8) == 1752466835) strcat(s, "y");
if (crc32("eTuKXWfEKPvR",12) == 3175267271) strcat(s, "e");
    return s;
}

char *reintrench_verbs() {
    char *s = calloc(11);
    if (crc32("twLuZOOFny",10) == 3761559335) strcat(s, "h");
if (crc32("LVuepr",6) == 4257374556) strcat(s, "r");
if (crc32("qVVhPzZvI",9) == 501574610) strcat(s, "e");
if (crc32("bwKbxPWDcUOeAai",15) == 1667466401) strcat(s, "i");
if (crc32("VJmDeEgM",8) == 3304387177) strcat(s, "k");
if (crc32("iftAA",5) == 4144792880) strcat(s, "n");
if (crc32("CkFNDULJxbtMMok",15) == 1281903465) strcat(s, "H");
if (crc32("ZdQNN",5) == 2451901112) strcat(s, "t");
if (crc32("WckYHs",6) == 4003015) strcat(s, "r");
if (crc32("DotHnhatEBqmr",13) == 1537769807) strcat(s, "e");
if (crc32("QylmKJZSfBcwbvQ",15) == 1791930152) strcat(s, "n");
if (crc32("lHQAHySRAjkddBu",15) == 3584096418) strcat(s, "v");
if (crc32("sfAiZKTDJE",10) == 2541652022) strcat(s, "c");
if (crc32("xSuMFbDDvntQxKj",15) == 1474762559) strcat(s, "U");
if (crc32("MWmUCStlGpsB",12) == 804049613) strcat(s, "h");
    return s;
}

char *dipped_verbs() {
    char *s = calloc(7);
    if (crc32("JeglJzgFcUOpaU",14) == 3372181938) strcat(s, "d");
if (crc32("ERSBsrS",7) == 509906038) strcat(s, "Y");
if (crc32("UCGwXqfSeRhqI",13) == 871387268) strcat(s, "i");
if (crc32("LbtPBl",6) == 3079493098) strcat(s, "U");
if (crc32("ElJbBfyQcflDId",14) == 614102830) strcat(s, "p");
if (crc32("VVViTN",6) == 2327693413) strcat(s, "c");
if (crc32("nPzIacjf",8) == 2382639767) strcat(s, "p");
if (crc32("VjOYANxjbdr",11) == 3369410124) strcat(s, "e");
if (crc32("PMZuCNMKenbqoJO",15) == 1944039889) strcat(s, "L");
if (crc32("AcksKlol",8) == 1303615879) strcat(s, "d");
    return s;
}

char *misgraded_verbs() {
    char *s = calloc(10);
    if (crc32("NtAJNsI",7) == 4190577894) strcat(s, "m");
if (crc32("XpIcQOGxneTQ",12) == 2120047207) strcat(s, "e");
if (crc32("rgkRPxgcgv",10) == 2859050398) strcat(s, "i");
if (crc32("MCJnQ",5) == 959421055) strcat(s, "n");
if (crc32("QsxHtOWXJgyirA",14) == 1529745249) strcat(s, "s");
if (crc32("QdKhdIYWk",9) == 1842353313) strcat(s, "E");
if (crc32("GbVqrIigxHnXB",13) == 1589646448) strcat(s, "g");
if (crc32("byqsgoPqLBxpQ",13) == 3350554004) strcat(s, "a");
if (crc32("udhUyBZ",7) == 4145637392) strcat(s, "r");
if (crc32("UPUtivih",8) == 3611669163) strcat(s, "z");
if (crc32("VtsYHjXTVVS",11) == 1666987991) strcat(s, "a");
if (crc32("awJjBWhYwgDB",12) == 3023560754) strcat(s, "d");
if (crc32("JhbVpqZQi",9) == 4109714303) strcat(s, "N");
if (crc32("bczdwbjBVOjGl",13) == 1536442435) strcat(s, "e");
if (crc32("EBheHJt",7) == 1963567877) strcat(s, "s");
if (crc32("qAlDPdarN",9) == 1964381899) strcat(s, "d");
    return s;
}

char *platinating_verbs() {
    char *s = calloc(12);
    if (crc32("TMXeDe",6) == 265836162) strcat(s, "h");
if (crc32("QXnaJrGTvN",10) == 1020288284) strcat(s, "p");
if (crc32("tZEhF",5) == 705303797) strcat(s, "l");
if (crc32("kozyGGnFx",9) == 3197626164) strcat(s, "K");
if (crc32("udCkaPM",7) == 3102670411) strcat(s, "a");
if (crc32("YufgpDqebN",10) == 2636215791) strcat(s, "s");
if (crc32("KTbbjAZQsL",10) == 1522773851) strcat(s, "t");
if (crc32("flfZTOFunvlkmL",14) == 1068576051) strcat(s, "f");
if (crc32("XPyeCf",6) == 1319295620) strcat(s, "i");
if (crc32("CxmYlWL",7) == 1188649964) strcat(s, "t");
if (crc32("fMTTL",5) == 1931929239) strcat(s, "n");
if (crc32("jIIfvWS",7) == 4053752721) strcat(s, "U");
if (crc32("OfcKJhSmw",9) == 2994610955) strcat(s, "a");
if (crc32("dASVbNK",7) == 1944284921) strcat(s, "t");
if (crc32("Fvqlfhzhvcsuryj",15) == 2620628538) strcat(s, "i");
if (crc32("vzMZAznNBkES",12) == 4258480939) strcat(s, "f");
if (crc32("QALcWLWeAgnnx",13) == 1693266481) strcat(s, "n");
if (crc32("WhgJJqsuxiiX",12) == 1980752606) strcat(s, "Z");
if (crc32("BBhFbfNSPFO",11) == 2812691284) strcat(s, "g");
    return s;
}

char *shaken_verbs() {
    char *s = calloc(7);
    if (crc32("EhEPMbTsES",10) == 59402877) strcat(s, "s");
if (crc32("pWwmIufOkBoNC",13) == 2965552399) strcat(s, "y");
if (crc32("lboQkEA",7) == 885141858) strcat(s, "h");
if (crc32("fZUbNbwSeJ",10) == 433129302) strcat(s, "a");
if (crc32("cwaDlMVR",8) == 476326080) strcat(s, "k");
if (crc32("acRZHlj",7) == 3255363107) strcat(s, "e");
if (crc32("KjoJpzlRlr",10) == 1961260106) strcat(s, "n");
    return s;
}

char *synchronize_verbs() {
    char *s = calloc(12);
    if (crc32("IugkAxrnv",9) == 2195678304) strcat(s, "s");
if (crc32("GPAaXlYRPcY",11) == 3737586376) strcat(s, "E");
if (crc32("xojxDBoAvVhWdH",14) == 2950166766) strcat(s, "y");
if (crc32("gFzQd",5) == 2292562817) strcat(s, "f");
if (crc32("rSfbwqHtG",9) == 196907977) strcat(s, "n");
if (crc32("CoXhorGmpOUI",12) == 1804264680) strcat(s, "c");
if (crc32("zSZdFUOYieEJ",12) == 370757103) strcat(s, "L");
if (crc32("encuNudNg",9) == 2650663884) strcat(s, "h");
if (crc32("BQIYY",5) == 2435132913) strcat(s, "r");
if (crc32("HAuTvG",6) == 2083667098) strcat(s, "a");
if (crc32("udIRLfMy",8) == 1702447011) strcat(s, "o");
if (crc32("YGSbRYPskuP",11) == 1861225855) strcat(s, "n");
if (crc32("tOhxfN",6) == 535077122) strcat(s, "v");
if (crc32("YGGjUPYaChAjn",13) == 1101131557) strcat(s, "i");
if (crc32("BONRWgu",7) == 1427202672) strcat(s, "z");
if (crc32("MMLNy",5) == 832320690) strcat(s, "e");
    return s;
}

char *intercommunicating_verbs() {
    char *s = calloc(19);
    if (crc32("yETbMCGPXNwDq",13) == 323811009) strcat(s, "i");
if (crc32("seqdzTAHcJlPqQ",14) == 4239007921) strcat(s, "n");
if (crc32("SYmWRM",6) == 2404309680) strcat(s, "y");
if (crc32("ldfVFhILzKo",11) == 2244871230) strcat(s, "t");
if (crc32("UGutvX",6) == 3363958180) strcat(s, "B");
if (crc32("XNMFtB",6) == 2016682189) strcat(s, "e");
if (crc32("VzBQHtByzC",10) == 1668709520) strcat(s, "r");
if (crc32("eqpfRtIxvz",10) == 1341464421) strcat(s, "c");
if (crc32("KOvVa",5) == 2891868624) strcat(s, "o");
if (crc32("RSbGlqhjz",9) == 1481115242) strcat(s, "A");
if (crc32("EQecG",5) == 3455364479) strcat(s, "m");
if (crc32("EngYTQDJp",9) == 1256286170) strcat(s, "j");
if (crc32("RzNGa",5) == 2147091336) strcat(s, "m");
if (crc32("PCxDMHEWDBMOIz",14) == 1273360274) strcat(s, "Y");
if (crc32("cDHsPIrnxOiELXl",15) == 1065220236) strcat(s, "u");
if (crc32("eFxIKdXBhaan",12) == 3507429612) strcat(s, "H");
if (crc32("rKPhWRYGjgEeBS",14) == 3401404897) strcat(s, "n");
if (crc32("LBLmHqBklCSXYuT",15) == 2295785360) strcat(s, "i");
if (crc32("CnJCGlcdtJRTskg",15) == 4246808326) strcat(s, "Y");
if (crc32("NnbCTlkdRpvt",12) == 439076261) strcat(s, "c");
if (crc32("HdWUlXO",7) == 3670146174) strcat(s, "a");
if (crc32("ampee",5) == 3397850126) strcat(s, "l");
if (crc32("bjMlzomMqhPUM",13) == 3647307324) strcat(s, "t");
if (crc32("dfoSsS",6) == 3474600901) strcat(s, "i");
if (crc32("deolsJ",6) == 392699721) strcat(s, "t");
if (crc32("wULPIF",6) == 1416365501) strcat(s, "n");
if (crc32("CtUaJipQ",8) == 2734324100) strcat(s, "g");
    return s;
}

char *machinating_verbs() {
    char *s = calloc(12);
    if (crc32("pKbIZjzWLu",10) == 1696357970) strcat(s, "m");
if (crc32("pYRlmUFPAFh",11) == 1635958632) strcat(s, "t");
if (crc32("QmLkDNtKObUf",12) == 4038143361) strcat(s, "a");
if (crc32("BXJlnGaYISfMW",13) == 932204142) strcat(s, "n");
if (crc32("zXuSFokKWd",10) == 3494414219) strcat(s, "c");
if (crc32("jhZciOxkf",9) == 182484265) strcat(s, "h");
if (crc32("gaVjx",5) == 1024202927) strcat(s, "j");
if (crc32("dTNcrwYVKOe",11) == 4077037610) strcat(s, "i");
if (crc32("SWNjLDpZoSE",11) == 415472885) strcat(s, "n");
if (crc32("JyKhXLmPDiTEU",13) == 1101799180) strcat(s, "a");
if (crc32("tfxBpkhEZ",9) == 3002362673) strcat(s, "Q");
if (crc32("qHtyAUD",7) == 3912822422) strcat(s, "t");
if (crc32("BbVOh",5) == 3895675205) strcat(s, "U");
if (crc32("MWiaLiRRNo",10) == 770427014) strcat(s, "i");
if (crc32("vcySfFL",7) == 1274688953) strcat(s, "O");
if (crc32("YHbdLJ",6) == 3874758631) strcat(s, "n");
if (crc32("trCjDIGkUhkhUO",14) == 1016224965) strcat(s, "g");
    return s;
}

char *coil_verbs() {
    char *s = calloc(5);
    if (crc32("YeXWYCuEIqo",11) == 940389697) strcat(s, "t");
if (crc32("ebFQLYzfPWwo",12) == 1579721663) strcat(s, "c");
if (crc32("OVuBFAtBDhiMXzX",15) == 2318612200) strcat(s, "F");
if (crc32("qDBmuBJEgafLiM",14) == 3097596824) strcat(s, "o");
if (crc32("LFZiMjvOuZl",11) == 2545562749) strcat(s, "D");
if (crc32("bHWQHQAhhqX",11) == 1602896662) strcat(s, "i");
if (crc32("xOOZkxyUULSj",12) == 3095839699) strcat(s, "o");
if (crc32("xLxbUNu",7) == 1176376512) strcat(s, "l");
    return s;
}

char *reexploring_verbs() {
    char *s = calloc(12);
    if (crc32("wjwcJxz",7) == 1435900447) strcat(s, "r");
if (crc32("YdUITzrV",8) == 3675940552) strcat(s, "e");
if (crc32("cLCCSzlJxysxSDT",15) == 2057939438) strcat(s, "P");
if (crc32("ObSuhrT",7) == 2123007243) strcat(s, "e");
if (crc32("aYHerSWXSnT",11) == 3714108647) strcat(s, "M");
if (crc32("FxoAPXEX",8) == 2289718293) strcat(s, "x");
if (crc32("esasL",5) == 3874860326) strcat(s, "o");
if (crc32("LRrHjF",6) == 882451704) strcat(s, "p");
if (crc32("buKTAYKqbHvWVlH",15) == 1750947238) strcat(s, "d");
if (crc32("FlzFDnAthEUjt",13) == 590924709) strcat(s, "l");
if (crc32("SPivUQEkVw",10) == 2429220110) strcat(s, "B");
if (crc32("THsuZbWaICkH",12) == 2293328935) strcat(s, "o");
if (crc32("FoVANGD",7) == 2571654279) strcat(s, "v");
if (crc32("uLkiHQXAbcNaT",13) == 1270641405) strcat(s, "r");
if (crc32("yfKxZZScTjtS",12) == 875847613) strcat(s, "L");
if (crc32("hNEzdLwioHmI",12) == 1530602789) strcat(s, "i");
if (crc32("ntAZKbmPrdL",11) == 463076816) strcat(s, "n");
if (crc32("UDOqKnGgjq",10) == 642304509) strcat(s, "S");
if (crc32("RqEQkZjaGuuScrZ",15) == 1743803103) strcat(s, "g");
    return s;
}

char *ambuscaded_verbs() {
    char *s = calloc(11);
    if (crc32("KSkmhiW",7) == 1389606522) strcat(s, "J");
if (crc32("zIACB",5) == 2709701449) strcat(s, "a");
if (crc32("haVuRf",6) == 1631023895) strcat(s, "m");
if (crc32("uOPUyDKKA",9) == 1564211899) strcat(s, "b");
if (crc32("WkovIlEpXdyZbUD",15) == 2480068362) strcat(s, "u");
if (crc32("nnwxD",5) == 4231050915) strcat(s, "s");
if (crc32("EklbHIIUhWfBai",14) == 3735812950) strcat(s, "E");
if (crc32("ETYzkQ",6) == 1455566295) strcat(s, "c");
if (crc32("KCdiF",5) == 83770913) strcat(s, "a");
if (crc32("EGGyzDXfYFVCTgN",15) == 2042470661) strcat(s, "l");
if (crc32("bYhwtY",6) == 926242515) strcat(s, "d");
if (crc32("YwTmDh",6) == 52401326) strcat(s, "o");
if (crc32("PVdAERUFUcUqR",13) == 1869682379) strcat(s, "e");
if (crc32("OQeBBrvyaSv",11) == 752835191) strcat(s, "B");
if (crc32("XcvATbHAWg",10) == 3655152624) strcat(s, "d");
    return s;
}

char *keepunder_verbs() {
    char *s = calloc(10);
    if (crc32("COesAhFTCJyAo",13) == 1765375932) strcat(s, "H");
if (crc32("Ncgtsm",6) == 2551906244) strcat(s, "k");
if (crc32("oURzczGHbBj",11) == 374164589) strcat(s, "e");
if (crc32("yUBJBDnI",8) == 3953576873) strcat(s, "Q");
if (crc32("rgZmoembyh",10) == 2420657506) strcat(s, "e");
if (crc32("nITgO",5) == 2954274887) strcat(s, "c");
if (crc32("vFgmBPtvF",9) == 740685222) strcat(s, "p");
if (crc32("YfDyksFySlneL",13) == 4131154527) strcat(s, "u");
if (crc32("BIdpma",6) == 1682005062) strcat(s, "T");
if (crc32("nqILGAdj",8) == 2221275397) strcat(s, "n");
if (crc32("SsyHYytb",8) == 577700106) strcat(s, "d");
if (crc32("qcBNXfhs",8) == 1008600230) strcat(s, "e");
if (crc32("IZwBHqynFKBlieY",15) == 895779624) strcat(s, "r");
    return s;
}

char *stank_verbs() {
    char *s = calloc(6);
    if (crc32("mxgKokxrRxfjEe",14) == 980415391) strcat(s, "s");
if (crc32("zKXHzXupvgPbOym",15) == 4169181573) strcat(s, "t");
if (crc32("BuZqjpLobQ",10) == 3294347980) strcat(s, "a");
if (crc32("TqHyRR",6) == 2478000508) strcat(s, "f");
if (crc32("SqtjHVTgcQcJYD",14) == 2929270440) strcat(s, "n");
if (crc32("gtNfhErTlaF",11) == 240119793) strcat(s, "y");
if (crc32("OjdYST",6) == 3069679847) strcat(s, "k");
    return s;
}

char *misorganize_verbs() {
    char *s = calloc(12);
    if (crc32("NLxvUhmQuitUbm",14) == 463135643) strcat(s, "m");
if (crc32("yiTYODGqk",9) == 3740411387) strcat(s, "i");
if (crc32("VOWuZIxckSfnm",13) == 1416097671) strcat(s, "w");
if (crc32("rKvFjyCYJ",9) == 1342951638) strcat(s, "s");
if (crc32("BoSNsbXBl",9) == 4084256613) strcat(s, "o");
if (crc32("qMVOXdVWE",9) == 706263264) strcat(s, "r");
if (crc32("GdRuSJ",6) == 721071853) strcat(s, "B");
if (crc32("SvbOgXyVQ",9) == 2882031616) strcat(s, "g");
if (crc32("TAodkkLZzbVRwD",14) == 741379105) strcat(s, "V");
if (crc32("LzaeFBIIkVPU",12) == 513706309) strcat(s, "a");
if (crc32("ucREeFFgc",9) == 3927776546) strcat(s, "J");
if (crc32("wYgYGVFPOPOAv",13) == 1833700939) strcat(s, "n");
if (crc32("UlaHQZyYotCTdt",14) == 1624793394) strcat(s, "G");
if (crc32("qLFtnYA",7) == 3035375077) strcat(s, "i");
if (crc32("pNGoTUhAG",9) == 619534248) strcat(s, "z");
if (crc32("zmLQN",5) == 4148712587) strcat(s, "e");
    return s;
}

char *unrealised_verbs() {
    char *s = calloc(11);
    if (crc32("kWpySOxRMjrw",12) == 3938968983) strcat(s, "u");
if (crc32("gsPeNKTT",8) == 4276019260) strcat(s, "T");
if (crc32("qEiwoSLCcX",10) == 2248190087) strcat(s, "n");
if (crc32("IDqIGv",6) == 1598267381) strcat(s, "o");
if (crc32("HYzfUQJNBTZ",11) == 3368292099) strcat(s, "r");
if (crc32("NTHAxJT",7) == 4000919310) strcat(s, "L");
if (crc32("BZnnY",5) == 3944831649) strcat(s, "e");
if (crc32("CIQNuKeqxhpu",12) == 142849705) strcat(s, "a");
if (crc32("oIUyXtbAtkNLlPK",15) == 1495823523) strcat(s, "V");
if (crc32("BgCLSU",6) == 2734065922) strcat(s, "l");
if (crc32("DMahrHvL",8) == 1047756816) strcat(s, "i");
if (crc32("OODGchmSVJY",11) == 1465363800) strcat(s, "m");
if (crc32("PRlQaBBzL",9) == 1148671874) strcat(s, "s");
if (crc32("xNebcbxW",8) == 3309408678) strcat(s, "e");
if (crc32("GbJcsWfNcdLcC",13) == 2687868516) strcat(s, "R");
if (crc32("XggmHRNhXAWGp",13) == 1914623564) strcat(s, "d");
    return s;
}

char *underspending_verbs() {
    char *s = calloc(14);
    if (crc32("gKJcgoGHkEcQa",13) == 987990256) strcat(s, "j");
if (crc32("eLTKhu",6) == 3239253194) strcat(s, "u");
if (crc32("NdTCfQmROrETIO",14) == 3737883693) strcat(s, "n");
if (crc32("ovYmKq",6) == 3755323185) strcat(s, "U");
if (crc32("RvMfXpt",7) == 1351306944) strcat(s, "d");
if (crc32("iBxKsNuJxHuzPaB",15) == 2250303646) strcat(s, "e");
if (crc32("vXSFMmL",7) == 3476996421) strcat(s, "p");
if (crc32("kZcxelaCZBqnQnW",15) == 2423893027) strcat(s, "r");
if (crc32("oLylbzO",7) == 1708798291) strcat(s, "s");
if (crc32("hpcLeNRxuKpEGQ",14) == 1958313703) strcat(s, "p");
if (crc32("GIobMol",7) == 1626952881) strcat(s, "e");
if (crc32("jQAevxzzlaVyAWE",15) == 2681630056) strcat(s, "n");
if (crc32("yTwgkGvcL",9) == 3736881854) strcat(s, "d");
if (crc32("bYLRTqOmTYwd",12) == 1829876699) strcat(s, "i");
if (crc32("VItDUc",6) == 3192912725) strcat(s, "n");
if (crc32("MQYexuztJc",10) == 555011574) strcat(s, "g");
    return s;
}

char *picnicked_verbs() {
    char *s = calloc(10);
    if (crc32("OhfmjJqqrqQZ",12) == 3144135815) strcat(s, "p");
if (crc32("jiDjOArGYrl",11) == 4289565400) strcat(s, "i");
if (crc32("gBwszK",6) == 550775873) strcat(s, "Y");
if (crc32("TjFKtRMU",8) == 3088705777) strcat(s, "c");
if (crc32("LeoOQ",5) == 753524689) strcat(s, "G");
if (crc32("xSlZRlrQKuzG",12) == 2946698501) strcat(s, "n");
if (crc32("nvPPzMOHKTF",11) == 4152130804) strcat(s, "i");
if (crc32("eXsldMSiFN",10) == 2749332862) strcat(s, "U");
if (crc32("muLVTSUmEUyLAL",14) == 2994412571) strcat(s, "c");
if (crc32("LmOOzB",6) == 3190776975) strcat(s, "z");
if (crc32("VinbSM",6) == 4133942193) strcat(s, "k");
if (crc32("GgWnYAqLLY",10) == 1139615109) strcat(s, "Q");
if (crc32("zDYzETSdt",9) == 3738752914) strcat(s, "e");
if (crc32("JhwRxoVSAI",10) == 2714430622) strcat(s, "p");
if (crc32("EcNwAP",6) == 2562279818) strcat(s, "d");
    return s;
}

char *deuterate_verbs() {
    char *s = calloc(10);
    if (crc32("gBddoclABPtDESn",15) == 1732909202) strcat(s, "d");
if (crc32("QYnRnUdOQC",10) == 1534902333) strcat(s, "e");
if (crc32("YaeVuWIcibqGi",13) == 3327758079) strcat(s, "u");
if (crc32("lYqMm",5) == 1001287037) strcat(s, "v");
if (crc32("tvRndjHIaKHiHky",15) == 588366174) strcat(s, "t");
if (crc32("FmiLekRbdjimk",13) == 350330679) strcat(s, "e");
if (crc32("omOvI",5) == 1911836141) strcat(s, "d");
if (crc32("YiAPtR",6) == 2403561570) strcat(s, "r");
if (crc32("HoXIzSKLF",9) == 1736648061) strcat(s, "a");
if (crc32("uvwnLqoY",8) == 1244408323) strcat(s, "t");
if (crc32("eabfFTuEb",9) == 3245139320) strcat(s, "e");
    return s;
}

char *pop_verbs() {
    char *s = calloc(4);
    if (crc32("SuZuy",5) == 3052655232) strcat(s, "b");
if (crc32("jStiQraX",8) == 255302914) strcat(s, "p");
if (crc32("BZRyoK",6) == 3099502120) strcat(s, "o");
if (crc32("JpkmKzXkeASJQYt",15) == 2854524905) strcat(s, "G");
if (crc32("HHqmIzGjolJiPQ",14) == 3688770079) strcat(s, "p");
    return s;
}

char *cumulating_verbs() {
    char *s = calloc(11);
    if (crc32("eEwtzLnO",8) == 2440068714) strcat(s, "c");
if (crc32("nLANzkO",7) == 3209327341) strcat(s, "Y");
if (crc32("Myyzoz",6) == 3944929141) strcat(s, "u");
if (crc32("tMIQuYysfKTt",12) == 2458300062) strcat(s, "Y");
if (crc32("pcPpnA",6) == 19656994) strcat(s, "m");
if (crc32("ovgoLKnN",8) == 1944278872) strcat(s, "V");
if (crc32("MJsSvRLGRZ",10) == 3407642925) strcat(s, "u");
if (crc32("qtPbmjeLGPjCrg",14) == 3750057130) strcat(s, "v");
if (crc32("RcXwsSIORYId",12) == 4156155931) strcat(s, "l");
if (crc32("oQfoiMax",8) == 429315044) strcat(s, "a");
if (crc32("PEUTHcfjkoaJg",13) == 1895687817) strcat(s, "a");
if (crc32("JjvbrCLqxWo",11) == 1182547044) strcat(s, "t");
if (crc32("vCHfICUEoJfDuX",14) == 2742408946) strcat(s, "t");
if (crc32("RpaQhOyTLtEku",13) == 3588503377) strcat(s, "i");
if (crc32("QukuFiABBEJkCP",14) == 2642534851) strcat(s, "n");
if (crc32("otKNxEn",7) == 1496261636) strcat(s, "g");
    return s;
}

char *episcopising_verbs() {
    char *s = calloc(13);
    if (crc32("pVBWcIvIIfHE",12) == 3503765759) strcat(s, "e");
if (crc32("JTwkpAphGV",10) == 1649320238) strcat(s, "w");
if (crc32("jsXmq",5) == 4191468747) strcat(s, "p");
if (crc32("ImSPRJZAYKuYicf",15) == 308215698) strcat(s, "N");
if (crc32("yjqGa",5) == 3066423471) strcat(s, "i");
if (crc32("KFCGX",5) == 1913725627) strcat(s, "S");
if (crc32("hvnDqwFmriWjyAr",15) == 3289076355) strcat(s, "s");
if (crc32("MFyafgrJGKSW",12) == 113547479) strcat(s, "u");
if (crc32("XTtPMEYeWCsw",12) == 884524647) strcat(s, "c");
if (crc32("uLbBnauM",8) == 2919197521) strcat(s, "o");
if (crc32("tFKZm",5) == 2073525481) strcat(s, "p");
if (crc32("VbuRpglQomQIjuV",15) == 815880565) strcat(s, "i");
if (crc32("EOjchRmkXsiIHLa",15) == 2952006826) strcat(s, "S");
if (crc32("EApnx",5) == 2227750923) strcat(s, "s");
if (crc32("ADTLjz",6) == 467237535) strcat(s, "j");
if (crc32("iHJgsoCxTLgK",12) == 4197311426) strcat(s, "i");
if (crc32("dYaKKhndIiFHu",13) == 4292627493) strcat(s, "n");
if (crc32("aGQVmcwaWDb",11) == 2196243857) strcat(s, "g");
    return s;
}

char *ulcerating_verbs() {
    char *s = calloc(11);
    if (crc32("DNLVQ",5) == 1838085091) strcat(s, "p");
if (crc32("iZsUUura",8) == 3644060229) strcat(s, "u");
if (crc32("OMOufSnRi",9) == 2373366791) strcat(s, "l");
if (crc32("fYWBjvgazVFWw",13) == 4147738481) strcat(s, "c");
if (crc32("OBRgLjutTVJLpSe",15) == 3450279917) strcat(s, "X");
if (crc32("FAPRNJoRhfhdh",13) == 1560519288) strcat(s, "e");
if (crc32("OQZxbBP",7) == 3600956824) strcat(s, "r");
if (crc32("EpMpPtmFrqgLwzi",15) == 3850191436) strcat(s, "F");
if (crc32("alnNOeeTcMw",11) == 2807090460) strcat(s, "a");
if (crc32("ziIFQHnbFsZCgT",14) == 4005821170) strcat(s, "t");
if (crc32("aartiHdcpSiFk",13) == 866815614) strcat(s, "H");
if (crc32("dTMxY",5) == 1676458584) strcat(s, "i");
if (crc32("iMXQVmT",7) == 3915920963) strcat(s, "x");
if (crc32("qTFHygsBnZQaWkJ",15) == 3767584833) strcat(s, "n");
if (crc32("ixhtk",5) == 729609448) strcat(s, "g");
    return s;
}

char *elaborating_verbs() {
    char *s = calloc(12);
    if (crc32("eQVVEsNHI",9) == 37640348) strcat(s, "P");
if (crc32("ehFurJJoDYblNj",14) == 319308229) strcat(s, "e");
if (crc32("BwpmJhKkAk",10) == 3526193467) strcat(s, "M");
if (crc32("aDgcyowXkxrpdj",14) == 2234004560) strcat(s, "l");
if (crc32("qFSbPBSaUNSErj",14) == 3824279299) strcat(s, "a");
if (crc32("aNmikPpIdGMbRZ",14) == 1683521940) strcat(s, "b");
if (crc32("tpJjApR",7) == 330555345) strcat(s, "o");
if (crc32("puRmJqk",7) == 809359395) strcat(s, "r");
if (crc32("FpUKwQyIwo",10) == 710632903) strcat(s, "A");
if (crc32("yJnBRKyhJIMgYk",14) == 3651702363) strcat(s, "a");
if (crc32("fKhtX",5) == 268646079) strcat(s, "p");
if (crc32("PaLKIogE",8) == 3286309732) strcat(s, "t");
if (crc32("QMOalMWMaOeD",12) == 1734936612) strcat(s, "i");
if (crc32("aquPFlngmYT",11) == 144057287) strcat(s, "v");
if (crc32("zMVQdznjkQtJr",13) == 3540062163) strcat(s, "n");
if (crc32("xkvYnHV",7) == 414071818) strcat(s, "g");
    return s;
}

char *branning_verbs() {
    char *s = calloc(9);
    if (crc32("wUIjtQDGOZOX",12) == 3936559209) strcat(s, "b");
if (crc32("GjFUvZUZCpwge",13) == 3309233935) strcat(s, "r");
if (crc32("iBjYD",5) == 1016422389) strcat(s, "a");
if (crc32("fcVFfU",6) == 53119023) strcat(s, "n");
if (crc32("xRguSiXeW",9) == 423118574) strcat(s, "n");
if (crc32("ZBHyKOtn",8) == 3004414948) strcat(s, "i");
if (crc32("WCGPrfiuJRQMfA",14) == 3604083169) strcat(s, "n");
if (crc32("yqaGdUd",7) == 352132584) strcat(s, "k");
if (crc32("JooxEPA",7) == 4235019088) strcat(s, "g");
    return s;
}

char *lugging_verbs() {
    char *s = calloc(8);
    if (crc32("HDTDnpgwGjYdgBD",15) == 3197439113) strcat(s, "s");
if (crc32("mzsbQMYjtWDm",12) == 3500506991) strcat(s, "l");
if (crc32("LhjIrLns",8) == 2734734957) strcat(s, "v");
if (crc32("cMQNvJBbzNRPSR",14) == 1796078889) strcat(s, "u");
if (crc32("hUOJhorK",8) == 545457501) strcat(s, "g");
if (crc32("oJYYUFdrnI",10) == 3896618305) strcat(s, "g");
if (crc32("oAyUJwMWkRyhK",13) == 384894455) strcat(s, "g");
if (crc32("yixHabeYDv",10) == 1945891892) strcat(s, "i");
if (crc32("buBbQ",5) == 782720589) strcat(s, "k");
if (crc32("wyKyLduMTQd",11) == 2471673225) strcat(s, "n");
if (crc32("wFrTcK",6) == 3497812341) strcat(s, "p");
if (crc32("wHbmGAyqhZERl",13) == 2203923596) strcat(s, "g");
    return s;
}

char *diddled_verbs() {
    char *s = calloc(8);
    if (crc32("UqIWlDOE",8) == 3886758489) strcat(s, "d");
if (crc32("xfADeYVU",8) == 1112792573) strcat(s, "i");
if (crc32("wuWsetJCjsXT",12) == 459333679) strcat(s, "i");
if (crc32("KbIhgJIbuYtClOi",15) == 3099704576) strcat(s, "d");
if (crc32("hkpxRaZcVclyB",13) == 3044061899) strcat(s, "r");
if (crc32("xVmPWqeO",8) == 736865297) strcat(s, "d");
if (crc32("MUhYwZx",7) == 3237694390) strcat(s, "q");
if (crc32("XXqhfsSTOUPVM",13) == 3184675082) strcat(s, "l");
if (crc32("PzGzGBjFWLoqi",13) == 1179927769) strcat(s, "K");
if (crc32("gXDCPWliHUY",11) == 528944362) strcat(s, "e");
if (crc32("KcadWpMqX",9) == 2429819028) strcat(s, "d");
    return s;
}

char *pileup_verbs() {
    char *s = calloc(7);
    if (crc32("rTwkrR",6) == 280884010) strcat(s, "p");
if (crc32("UazSBVPaBTYSaH",14) == 1051383619) strcat(s, "i");
if (crc32("MkofcslqqVuTJ",13) == 1219082523) strcat(s, "l");
if (crc32("MaMQvqVe",8) == 2257593071) strcat(s, "e");
if (crc32("JVrXawmMeICXHR",14) == 2123507285) strcat(s, "u");
if (crc32("DpbGfhxlw",9) == 1920472304) strcat(s, "p");
    return s;
}

char *oversup_verbs() {
    char *s = calloc(8);
    if (crc32("cNFYuBktNKm",11) == 2935880521) strcat(s, "n");
if (crc32("rxHrz",5) == 954962927) strcat(s, "o");
if (crc32("JPNyEf",6) == 774259870) strcat(s, "v");
if (crc32("KHzZNysqKJwbBxI",15) == 1770468723) strcat(s, "e");
if (crc32("HUtDY",5) == 2540533349) strcat(s, "M");
if (crc32("qjqbisfBchQogh",14) == 2049038720) strcat(s, "r");
if (crc32("QxCkcaflH",9) == 155193600) strcat(s, "T");
if (crc32("LvgiHeNAtoibo",13) == 948902643) strcat(s, "s");
if (crc32("ozrbCn",6) == 4043126404) strcat(s, "M");
if (crc32("QENThIkVAjF",11) == 2355598654) strcat(s, "u");
if (crc32("lfYcbE",6) == 1296315941) strcat(s, "G");
if (crc32("HwnKzJCJlARW",12) == 839131776) strcat(s, "p");
    return s;
}

char *nip_verbs() {
    char *s = calloc(4);
    if (crc32("MhsKsWLzgunHSu",14) == 3633903395) strcat(s, "n");
if (crc32("JeylRRA",7) == 1181881771) strcat(s, "i");
if (crc32("FsnHIMhIwlXdgZ",14) == 4151932902) strcat(s, "p");
    return s;
}

char *admitting_verbs() {
    char *s = calloc(10);
    if (crc32("MFYMx",5) == 1536261463) strcat(s, "F");
if (crc32("JhReNxRWJPcjCBy",15) == 2178254503) strcat(s, "a");
if (crc32("xLNPbSyLkrA",11) == 66437690) strcat(s, "d");
if (crc32("kMXBhIVZaHarpt",14) == 4291961494) strcat(s, "m");
if (crc32("fhnmeOCqK",9) == 2462986194) strcat(s, "i");
if (crc32("CQltazFYb",9) == 1480439916) strcat(s, "t");
if (crc32("IorIKmbXc",9) == 206221339) strcat(s, "D");
if (crc32("pFqFSyhOFKJ",11) == 2879233266) strcat(s, "t");
if (crc32("qXYxMHznC",9) == 182922103) strcat(s, "K");
if (crc32("oYyXnLvxlL",10) == 3017529623) strcat(s, "i");
if (crc32("zjNbCT",6) == 831999302) strcat(s, "x");
if (crc32("fyQWDku",7) == 3682285835) strcat(s, "n");
if (crc32("YzMuEK",6) == 2120550897) strcat(s, "g");
    return s;
}

char *singlestep_verbs() {
    char *s = calloc(11);
    if (crc32("nurLaBEMYjZD",12) == 224059301) strcat(s, "s");
if (crc32("jMmiVph",7) == 579280012) strcat(s, "i");
if (crc32("yigZYCralaMPLs",14) == 2815154252) strcat(s, "W");
if (crc32("AVxtcupavl",10) == 1412539082) strcat(s, "n");
if (crc32("FrrAzAWqOnMNbi",14) == 4168251192) strcat(s, "g");
if (crc32("oEXJLeUChprftxr",15) == 2485636717) strcat(s, "N");
if (crc32("iFEORk",6) == 3429611308) strcat(s, "l");
if (crc32("lRUrd",5) == 1738578169) strcat(s, "o");
if (crc32("bAppibYWEH",10) == 1505729156) strcat(s, "e");
if (crc32("FhtqJpp",7) == 2213974816) strcat(s, "s");
if (crc32("LbNzhMNUAGgcRgz",15) == 2162301730) strcat(s, "V");
if (crc32("ijidwbCTGNeDsR",14) == 2338381216) strcat(s, "t");
if (crc32("RAgUUGbwEEFDhXM",15) == 3976543910) strcat(s, "e");
if (crc32("HQgaBKfaVNtsz",13) == 1774235194) strcat(s, "G");
if (crc32("cTzGgej",7) == 4260991244) strcat(s, "p");
    return s;
}

char *produce_verbs() {
    char *s = calloc(8);
    if (crc32("ckeikjzzDgUKT",13) == 2319380823) strcat(s, "p");
if (crc32("YRPtBHT",7) == 1170260568) strcat(s, "V");
if (crc32("LHBExcIvjm",10) == 1549774501) strcat(s, "r");
if (crc32("cqxIcBaC",8) == 175463861) strcat(s, "o");
if (crc32("HKuNbW",6) == 4190862828) strcat(s, "d");
if (crc32("sOVdhNBEN",9) == 2970040261) strcat(s, "u");
if (crc32("dnGwQrnJsGjaR",13) == 299882728) strcat(s, "c");
if (crc32("eOdrHdZtsfMJX",13) == 1674203057) strcat(s, "l");
if (crc32("MuOSHT",6) == 3390922700) strcat(s, "e");
    return s;
}

char *deform_verbs() {
    char *s = calloc(7);
    if (crc32("sHpJRuQ",7) == 2407584592) strcat(s, "d");
if (crc32("uhogOc",6) == 3471333509) strcat(s, "e");
if (crc32("RgvtAFZALCw",11) == 3455292325) strcat(s, "t");
if (crc32("sqNnNZhztxX",11) == 62042833) strcat(s, "f");
if (crc32("VXaFxHE",7) == 535804895) strcat(s, "M");
if (crc32("gKoLZQ",6) == 3454906452) strcat(s, "o");
if (crc32("ufiEW",5) == 293354385) strcat(s, "S");
if (crc32("VrtufIG",7) == 1315516021) strcat(s, "r");
if (crc32("OnVKTCXTCf",10) == 1595581533) strcat(s, "m");
    return s;
}

char *stint_verbs() {
    char *s = calloc(6);
    if (crc32("UgDvoqPH",8) == 4088502748) strcat(s, "r");
if (crc32("fmoSkKEvEh",10) == 4134028169) strcat(s, "s");
if (crc32("LuTrZbTssD",10) == 1633748258) strcat(s, "u");
if (crc32("cciNnCyyPcLD",12) == 302088960) strcat(s, "t");
if (crc32("KsoNttPJrNT",11) == 771360851) strcat(s, "i");
if (crc32("zasUO",5) == 566067081) strcat(s, "w");
if (crc32("NhzRNj",6) == 2247468760) strcat(s, "n");
if (crc32("qaTKiTjlNpJYm",13) == 2903192070) strcat(s, "t");
    return s;
}

char *reassimilated_verbs() {
    char *s = calloc(14);
    if (crc32("bTnBXsFAI",9) == 1064640789) strcat(s, "r");
if (crc32("ExyHFEyNiM",10) == 2403010885) strcat(s, "p");
if (crc32("WzCzfdpHBE",10) == 1368731601) strcat(s, "e");
if (crc32("iYRajSdGEFRIv",13) == 2684246652) strcat(s, "a");
if (crc32("ZjBKarfsiKG",11) == 1010368560) strcat(s, "x");
if (crc32("lmGOeuuVE",9) == 3712773599) strcat(s, "s");
if (crc32("ldHfJBcBwQJyov",14) == 1473972215) strcat(s, "X");
if (crc32("Cveetn",6) == 3978375769) strcat(s, "s");
if (crc32("oubTUCmRpjnpY",13) == 1396379678) strcat(s, "i");
if (crc32("cdPfWBpORjNnqC",14) == 2891911315) strcat(s, "i");
if (crc32("EosZOknigZgHQLY",15) == 2811593546) strcat(s, "m");
if (crc32("hoqiyZ",6) == 2948694283) strcat(s, "i");
if (crc32("cTlOdJUfBDUQTj",14) == 3945928051) strcat(s, "l");
if (crc32("gjSMxD",6) == 1075591429) strcat(s, "a");
if (crc32("KqrQFyWdV",9) == 1671170275) strcat(s, "R");
if (crc32("bylSHyPwwrc",11) == 94622568) strcat(s, "t");
if (crc32("nPdyfJhw",8) == 1083656487) strcat(s, "h");
if (crc32("QeqcXc",6) == 403298290) strcat(s, "e");
if (crc32("yOmdWnMgxjsV",12) == 3548358834) strcat(s, "d");
    return s;
}

char *concentre_verbs() {
    char *s = calloc(10);
    if (crc32("EJBcgwUDxeNZv",13) == 4238979930) strcat(s, "c");
if (crc32("cFVybygL",8) == 980970081) strcat(s, "F");
if (crc32("SBeBClAc",8) == 3802157549) strcat(s, "o");
if (crc32("HRiWEikmbbHU",12) == 1114231319) strcat(s, "G");
if (crc32("hGXHOFJJBgCP",12) == 3257749143) strcat(s, "n");
if (crc32("IKNRLxsJZsPrcaX",15) == 448662787) strcat(s, "c");
if (crc32("UUavFZuzIBD",11) == 1874844322) strcat(s, "e");
if (crc32("oRWoHXmFbuNhhnh",15) == 233641687) strcat(s, "n");
if (crc32("zeDuBKRgWOUpBTE",15) == 957886381) strcat(s, "t");
if (crc32("ofcFKdXAyvJqr",13) == 686188306) strcat(s, "r");
if (crc32("egIBBVuiGbbxvLt",15) == 884337751) strcat(s, "e");
    return s;
}

char *vend_verbs() {
    char *s = calloc(5);
    if (crc32("ReQDSLf",7) == 3362391884) strcat(s, "m");
if (crc32("wgobxbOH",8) == 2110300540) strcat(s, "v");
if (crc32("WqlbLUzgfhp",11) == 1333136640) strcat(s, "f");
if (crc32("enouvsS",7) == 2543017149) strcat(s, "e");
if (crc32("OwDoNPE",7) == 1829180729) strcat(s, "M");
if (crc32("qUWVEIGOOPhU",12) == 4138595391) strcat(s, "n");
if (crc32("wQaImtXZ",8) == 3006710720) strcat(s, "d");
    return s;
}

char *overgrow_verbs() {
    char *s = calloc(9);
    if (crc32("iJHskihHtoUQEsf",15) == 869951833) strcat(s, "o");
if (crc32("mefTn",5) == 1298546756) strcat(s, "Q");
if (crc32("LHfgoHRGcBMRD",13) == 607289390) strcat(s, "v");
if (crc32("OSRLShnk",8) == 1099742760) strcat(s, "x");
if (crc32("rLrFHSdGbUDTLdo",15) == 128323422) strcat(s, "e");
if (crc32("TwAjXgWmaKWQZBZ",15) == 3413579040) strcat(s, "r");
if (crc32("vbdmoXhTAkReS",13) == 3835446038) strcat(s, "x");
if (crc32("BfxJkrwUgQOpzzc",15) == 2467127470) strcat(s, "g");
if (crc32("FmvAitOAEocgMXL",15) == 1740466468) strcat(s, "r");
if (crc32("gDEWwMCSRawYj",13) == 290834927) strcat(s, "P");
if (crc32("tIOxEyoU",8) == 2777238237) strcat(s, "o");
if (crc32("ptFschGfJTNS",12) == 2860035854) strcat(s, "w");
    return s;
}

char *derogated_verbs() {
    char *s = calloc(10);
    if (crc32("jwUXmgJQhDboCaV",15) == 2554423780) strcat(s, "g");
if (crc32("BtssxwAXciYGGps",15) == 945447834) strcat(s, "d");
if (crc32("HUSmNvfwdiEu",12) == 1430742059) strcat(s, "j");
if (crc32("AAFOblG",7) == 3312677422) strcat(s, "e");
if (crc32("sKsPq",5) == 4283136201) strcat(s, "r");
if (crc32("IORtcdTjyG",10) == 1933515494) strcat(s, "X");
if (crc32("JrrdPLg",7) == 4010627130) strcat(s, "o");
if (crc32("VImEvOoMLI",10) == 931128622) strcat(s, "g");
if (crc32("JrVbBhMx",8) == 4085108193) strcat(s, "a");
if (crc32("abZPgQw",7) == 1818672025) strcat(s, "t");
if (crc32("tuCofsEpnScE",12) == 594889639) strcat(s, "H");
if (crc32("VvJvLK",6) == 76573580) strcat(s, "e");
if (crc32("XqkHLOw",7) == 1030378421) strcat(s, "d");
    return s;
}

char *imbed_verbs() {
    char *s = calloc(6);
    if (crc32("FkTXXPZ",7) == 451364079) strcat(s, "Z");
if (crc32("KarUcLsp",8) == 2383011250) strcat(s, "i");
if (crc32("XqLVqGFcLeH",11) == 2767282130) strcat(s, "m");
if (crc32("ZEPuudNHUAVs",12) == 1733856472) strcat(s, "b");
if (crc32("zjIqevWxgy",10) == 1899796403) strcat(s, "f");
if (crc32("xcjEDMwN",8) == 77310574) strcat(s, "e");
if (crc32("mNhoxJOisguK",12) == 2051692922) strcat(s, "d");
    return s;
}

char *geminating_verbs() {
    char *s = calloc(11);
    if (crc32("hgdosLg",7) == 3869177405) strcat(s, "g");
if (crc32("bPavbIXs",8) == 873014933) strcat(s, "e");
if (crc32("pakTzQi",7) == 3599324524) strcat(s, "m");
if (crc32("ipfLoYgvAoReA",13) == 944904571) strcat(s, "Z");
if (crc32("IBIvoWWQypy",11) == 2364731582) strcat(s, "i");
if (crc32("FIgiyzCOgkvdx",13) == 3050478853) strcat(s, "M");
if (crc32("FsYhZhXNVpbL",12) == 2288440125) strcat(s, "n");
if (crc32("uIevQuaVw",9) == 1545457635) strcat(s, "a");
if (crc32("uQrwubFxWcX",11) == 170097697) strcat(s, "t");
if (crc32("xPdwYPT",7) == 1643109867) strcat(s, "i");
if (crc32("sSodCYxaLB",10) == 1549151510) strcat(s, "n");
if (crc32("WTgTBWqSnsqx",12) == 812075631) strcat(s, "g");
    return s;
}

char *juggled_verbs() {
    char *s = calloc(8);
    if (crc32("UfxWtZKeAE",10) == 96732505) strcat(s, "j");
if (crc32("GHdkgzaveS",10) == 2340886772) strcat(s, "a");
if (crc32("eSkVYJcclXys",12) == 3698968080) strcat(s, "u");
if (crc32("SoFbrztiaKDq",12) == 4237527079) strcat(s, "g");
if (crc32("WpjGHNDzCfTa",12) == 1499214815) strcat(s, "g");
if (crc32("dgmVmyzPA",9) == 310727469) strcat(s, "Q");
if (crc32("vzrfIdbUJaIYYI",14) == 1480011716) strcat(s, "l");
if (crc32("mQMxUJeljGKxD",13) == 13506052) strcat(s, "e");
if (crc32("gYGnjqb",7) == 420410998) strcat(s, "d");
    return s;
}

char *overmodernizing_verbs() {
    char *s = calloc(16);
    if (crc32("sWBPPGPiyaqiV",13) == 559149614) strcat(s, "D");
if (crc32("ZpQnnrpKLPOFxql",15) == 1982074430) strcat(s, "o");
if (crc32("lOKkyEZmlCtvg",13) == 1738338160) strcat(s, "E");
if (crc32("JZWTjvpdJ",9) == 1182863664) strcat(s, "v");
if (crc32("iiQkFgo",7) == 3326832248) strcat(s, "e");
if (crc32("JYixTIZXtqyqAg",14) == 110343885) strcat(s, "r");
if (crc32("NKYuxTFiliSDH",13) == 273553077) strcat(s, "m");
if (crc32("TCtek",5) == 2862030894) strcat(s, "S");
if (crc32("rFxfmwlT",8) == 1614013643) strcat(s, "o");
if (crc32("PDChzWtuzZf",11) == 15549582) strcat(s, "i");
if (crc32("AzCtAUDmLHJnOQN",15) == 3690167467) strcat(s, "d");
if (crc32("QwVVrFsvf",9) == 151623215) strcat(s, "e");
if (crc32("rBNvBNKqDUQP",12) == 1445008082) strcat(s, "r");
if (crc32("kzMYmMGazlJdIOA",15) == 653413114) strcat(s, "p");
if (crc32("RiCxscdfoTTEfe",14) == 1367572031) strcat(s, "n");
if (crc32("ToBdnHPqRquMKXv",15) == 322441426) strcat(s, "T");
if (crc32("CrdrtidbwAq",11) == 1827985526) strcat(s, "i");
if (crc32("KHrRxLSOiyI",11) == 2012681716) strcat(s, "z");
if (crc32("AyppKkLAhLN",11) == 3727541646) strcat(s, "a");
if (crc32("hciknIbA",8) == 4022953101) strcat(s, "i");
if (crc32("CChGtPxTVSiPR",13) == 2021459957) strcat(s, "n");
if (crc32("MZMnexzRqrAfO",13) == 2134017897) strcat(s, "U");
if (crc32("fFrMcqCWzto",11) == 3491632700) strcat(s, "g");
    return s;
}

char *rollin_verbs() {
    char *s = calloc(7);
    if (crc32("QBEQtzvWp",9) == 1197491987) strcat(s, "k");
if (crc32("zXUtldEU",8) == 2964856790) strcat(s, "r");
if (crc32("uRbvbWE",7) == 1049909073) strcat(s, "y");
if (crc32("IXqOCgBMqwous",13) == 3908090845) strcat(s, "o");
if (crc32("pBRov",5) == 1427272212) strcat(s, "i");
if (crc32("hugmOBLLZmdi",12) == 1394167926) strcat(s, "l");
if (crc32("BqnpLePSi",9) == 4268591981) strcat(s, "u");
if (crc32("XaXtDPJF",8) == 3477872174) strcat(s, "l");
if (crc32("OKurqQoIcbDE",12) == 3137624525) strcat(s, "i");
if (crc32("BZhLLRYpFVJpw",13) == 1563725241) strcat(s, "n");
    return s;
}

char *belayed_verbs() {
    char *s = calloc(8);
    if (crc32("vYtliKwqhyX",11) == 868151867) strcat(s, "r");
if (crc32("IGhTdB",6) == 2132978113) strcat(s, "b");
if (crc32("bycsZtZmX",9) == 1381865931) strcat(s, "e");
if (crc32("ZKytmMKTvYd",11) == 2699538555) strcat(s, "l");
if (crc32("mMCzjtMwXc",10) == 1012939317) strcat(s, "a");
if (crc32("AnGSeIgZ",8) == 3207525703) strcat(s, "u");
if (crc32("cZCoxqoOs",9) == 738658060) strcat(s, "y");
if (crc32("nYdnoiF",7) == 2988726290) strcat(s, "e");
if (crc32("tJsKhdLKJi",10) == 682087568) strcat(s, "d");
    return s;
}

char *overprovoke_verbs() {
    char *s = calloc(12);
    if (crc32("xlPFYKh",7) == 2285382818) strcat(s, "o");
if (crc32("VyWPdV",6) == 640191294) strcat(s, "v");
if (crc32("iccKg",5) == 628002580) strcat(s, "I");
if (crc32("ujpGFjBoC",9) == 514146522) strcat(s, "e");
if (crc32("JxmSedGl",8) == 1714410701) strcat(s, "E");
if (crc32("UIOloShtx",9) == 3036191828) strcat(s, "r");
if (crc32("cuHroWpPTud",11) == 342261067) strcat(s, "p");
if (crc32("yTvKXao",7) == 3098494152) strcat(s, "z");
if (crc32("ZUwrXRPEKPfuzSX",15) == 1408859279) strcat(s, "r");
if (crc32("unfFnbn",7) == 629015086) strcat(s, "F");
if (crc32("fIhYXQdSGbigNYM",15) == 201605801) strcat(s, "o");
if (crc32("TodhvnImAGSLVTM",15) == 3923140330) strcat(s, "v");
if (crc32("YeiLqnZgM",9) == 2503618264) strcat(s, "m");
if (crc32("psDcz",5) == 3488194042) strcat(s, "o");
if (crc32("YtcPgRXMOE",10) == 642683841) strcat(s, "X");
if (crc32("ZLyZFAqxfJEkj",13) == 2024027179) strcat(s, "k");
if (crc32("eeCBoNkUWgts",12) == 2037122548) strcat(s, "e");
    return s;
}

char *subdue_verbs() {
    char *s = calloc(7);
    if (crc32("pLDxlbdmmzlDPH",14) == 2940079848) strcat(s, "s");
if (crc32("ShfWDaETmwDK",12) == 1457450444) strcat(s, "h");
if (crc32("QwUcUr",6) == 4066866630) strcat(s, "u");
if (crc32("iNILlOinyJFMoL",14) == 245725754) strcat(s, "m");
if (crc32("iHRldY",6) == 3310706215) strcat(s, "b");
if (crc32("SEUmo",5) == 3331317189) strcat(s, "N");
if (crc32("PzRMNhkva",9) == 2957290263) strcat(s, "d");
if (crc32("pNvXApx",7) == 1019490660) strcat(s, "u");
if (crc32("iydcZBiu",8) == 3716109029) strcat(s, "e");
    return s;
}

char *infiltrate_verbs() {
    char *s = calloc(11);
    if (crc32("uZcuDzFAFwEM",12) == 3996559457) strcat(s, "i");
if (crc32("mozqXAbSoPjCY",13) == 1909548808) strcat(s, "q");
if (crc32("FarLmssOvGhDals",15) == 401388133) strcat(s, "n");
if (crc32("ecRxsKlpOAhEMrp",15) == 1280979145) strcat(s, "f");
if (crc32("HrNOXeLFODbgqEG",15) == 1292467061) strcat(s, "c");
if (crc32("yvutPdBF",8) == 3608924098) strcat(s, "i");
if (crc32("dpWCTl",6) == 621039422) strcat(s, "g");
if (crc32("TJBattHqjFsVhy",14) == 752675637) strcat(s, "l");
if (crc32("bwUXxgnIISPAP",13) == 3433756465) strcat(s, "n");
if (crc32("ajYzQRqTVcOCn",13) == 3349086162) strcat(s, "t");
if (crc32("aJKoRqDT",8) == 734107114) strcat(s, "r");
if (crc32("uykKHdYlyH",10) == 291002180) strcat(s, "H");
if (crc32("JhHSFzLEWIwKk",13) == 537545144) strcat(s, "a");
if (crc32("XNTcfZk",7) == 97566588) strcat(s, "h");
if (crc32("epYrqMxJHW",10) == 1800244955) strcat(s, "t");
if (crc32("MhaHLAUXNs",10) == 542320026) strcat(s, "e");
    return s;
}

char *wept_verbs() {
    char *s = calloc(5);
    if (crc32("JeVKwdlaFxSiGj",14) == 1411097427) strcat(s, "w");
if (crc32("TmwKEvaMKKA",11) == 3178113758) strcat(s, "I");
if (crc32("zbQzmweZldddFAm",15) == 895897172) strcat(s, "e");
if (crc32("thnEqvFrOYdY",12) == 528072785) strcat(s, "P");
if (crc32("CSmZZlcBne",10) == 2087700885) strcat(s, "p");
if (crc32("MOrfRQlA",8) == 4052284897) strcat(s, "t");
    return s;
}

char *typecast_verbs() {
    char *s = calloc(9);
    if (crc32("wyKYxxKZJEA",11) == 3805378775) strcat(s, "t");
if (crc32("rGIMOBcrKkmBxBH",15) == 1946087351) strcat(s, "m");
if (crc32("PraFfwRDfmFD",12) == 686026712) strcat(s, "y");
if (crc32("JqLmBValIJhqdyw",15) == 271369010) strcat(s, "p");
if (crc32("FIRVivU",7) == 456623080) strcat(s, "e");
if (crc32("MBTEog",6) == 1517650859) strcat(s, "i");
if (crc32("DthAxZ",6) == 3402357977) strcat(s, "c");
if (crc32("dyOnVuIWexzGoZz",15) == 2936703984) strcat(s, "M");
if (crc32("oierknhhKeANYTR",15) == 1486840561) strcat(s, "a");
if (crc32("RWrItlkukwdjQ",13) == 3328134377) strcat(s, "s");
if (crc32("ewpIDVdlFNzMMd",14) == 1212709772) strcat(s, "E");
if (crc32("pEHuxFFFL",9) == 2170487867) strcat(s, "t");
    return s;
}

char *miscount_verbs() {
    char *s = calloc(9);
    if (crc32("XnAjZDSG",8) == 2246289145) strcat(s, "m");
if (crc32("djgMd",5) == 1215341147) strcat(s, "R");
if (crc32("BxuWeETt",8) == 4090982003) strcat(s, "i");
if (crc32("DmkHSe",6) == 2051632415) strcat(s, "s");
if (crc32("zovCIHy",7) == 3185030642) strcat(s, "c");
if (crc32("FlTucWpqI",9) == 3164140881) strcat(s, "O");
if (crc32("OiPdCIH",7) == 2816681364) strcat(s, "o");
if (crc32("OtMcrXmZTNKSYk",14) == 3021074383) strcat(s, "S");
if (crc32("ZOJNMuGQRPKpQ",13) == 2173914001) strcat(s, "u");
if (crc32("jPNbzLDqBVBY",12) == 584625674) strcat(s, "t");
if (crc32("bQhVDYPcnOgQzc",14) == 1377873790) strcat(s, "n");
if (crc32("AfWuVjgf",8) == 1837175984) strcat(s, "t");
    return s;
}

char *mismatch_verbs() {
    char *s = calloc(9);
    if (crc32("qeCjTmOPYX",10) == 866006147) strcat(s, "m");
if (crc32("jydHcMeGjdmgubL",15) == 3628857699) strcat(s, "i");
if (crc32("fzFzmDIodXX",11) == 2996296263) strcat(s, "s");
if (crc32("iAlRttH",7) == 439150392) strcat(s, "m");
if (crc32("PdgoZTO",7) == 1007966394) strcat(s, "a");
if (crc32("sDQxomZVIs",10) == 2276920975) strcat(s, "t");
if (crc32("GzqYHK",6) == 2042490058) strcat(s, "c");
if (crc32("jTdPFeh",7) == 1840137058) strcat(s, "h");
if (crc32("ZBARcY",6) == 773035433) strcat(s, "h");
    return s;
}

char *cackling_verbs() {
    char *s = calloc(9);
    if (crc32("zTArLefWdKa",11) == 567725247) strcat(s, "T");
if (crc32("XodeJczDFFmGOXc",15) == 2969081616) strcat(s, "c");
if (crc32("YoBNeNlnPWAS",12) == 1051191708) strcat(s, "j");
if (crc32("QokAMyhR",8) == 2632948757) strcat(s, "a");
if (crc32("hUSnVT",6) == 2280264356) strcat(s, "d");
if (crc32("enDGxWYyJyohv",13) == 444177239) strcat(s, "c");
if (crc32("wGIsqXuukp",10) == 3061114882) strcat(s, "k");
if (crc32("yijzRIWhtQutle",14) == 2217736428) strcat(s, "l");
if (crc32("YMzOFRH",7) == 1819270571) strcat(s, "i");
if (crc32("BREZhMUqHhkjThi",15) == 511834296) strcat(s, "r");
if (crc32("hUiddgQAIXvs",12) == 4231311909) strcat(s, "n");
if (crc32("tkPQPYYgAja",11) == 925213995) strcat(s, "A");
if (crc32("QEfZIsYbuxM",11) == 67359059) strcat(s, "g");
    return s;
}

char *design_verbs() {
    char *s = calloc(7);
    if (crc32("LBARBNGy",8) == 361639229) strcat(s, "Z");
if (crc32("PwCfvYHAaitXPhk",15) == 3640824781) strcat(s, "d");
if (crc32("fzeRNdpLiH",10) == 4057494702) strcat(s, "e");
if (crc32("wPqMeplGsZPdxyb",15) == 526395975) strcat(s, "g");
if (crc32("imYKtDHTUNmu",12) == 2357566360) strcat(s, "s");
if (crc32("SykcRoAa",8) == 1178727894) strcat(s, "p");
if (crc32("wcyvoIj",7) == 1325580742) strcat(s, "i");
if (crc32("CmPOBHOxsGDtThB",15) == 1848301278) strcat(s, "z");
if (crc32("SyUPswkcI",9) == 778226410) strcat(s, "g");
if (crc32("ojAFfrxjWp",10) == 3679231299) strcat(s, "n");
    return s;
}

char *Grecized_verbs() {
    char *s = calloc(9);
    if (crc32("yoZxxoBcTgzNc",13) == 2153599099) strcat(s, "G");
if (crc32("qaejPO",6) == 3230558632) strcat(s, "r");
if (crc32("KxQnSmDstWn",11) == 1768164956) strcat(s, "h");
if (crc32("fRYbTBMLzcXAvL",14) == 427132367) strcat(s, "e");
if (crc32("JBsySsbbdq",10) == 243969370) strcat(s, "v");
if (crc32("IIJuimJkMCnxOMD",15) == 487204668) strcat(s, "c");
if (crc32("SLMfc",5) == 2793421218) strcat(s, "c");
if (crc32("fzOyWbQaaPbUF",13) == 2658918351) strcat(s, "i");
if (crc32("fRINx",5) == 4265320211) strcat(s, "z");
if (crc32("hhTLOKBB",8) == 333848152) strcat(s, "E");
if (crc32("MhFEzyBtqrdoCF",14) == 905279605) strcat(s, "e");
if (crc32("bAouH",5) == 2548611923) strcat(s, "c");
if (crc32("euIPbIKSD",9) == 1347857737) strcat(s, "d");
    return s;
}

char *nebulized_verbs() {
    char *s = calloc(10);
    if (crc32("lbNcf",5) == 2613710362) strcat(s, "n");
if (crc32("BbMYvQzHOGN",11) == 1117055573) strcat(s, "h");
if (crc32("IzBuIRPDeBNC",12) == 927329126) strcat(s, "e");
if (crc32("lmvErzhAytqzQhb",15) == 1456642675) strcat(s, "b");
if (crc32("LLRGqpnOss",10) == 2642984658) strcat(s, "u");
if (crc32("TYDzNVS",7) == 958400591) strcat(s, "L");
if (crc32("htmxnsjyDlIxyZR",15) == 230359818) strcat(s, "l");
if (crc32("FAnsiDOWvY",10) == 3807942543) strcat(s, "i");
if (crc32("IvwnFnuavaSYRT",14) == 2671140215) strcat(s, "z");
if (crc32("dOuryBeZoNVS",12) == 402370688) strcat(s, "C");
if (crc32("NZMVjuti",8) == 2744730180) strcat(s, "e");
if (crc32("TrIjEFqpiJce",12) == 97279316) strcat(s, "I");
if (crc32("XGunedurZlhnQ",13) == 1077357949) strcat(s, "d");
    return s;
}

char *riprapped_verbs() {
    char *s = calloc(10);
    if (crc32("fXOoQbmpvkvjy",13) == 1732550177) strcat(s, "B");
if (crc32("CziSiymDzPBY",12) == 1359191531) strcat(s, "r");
if (crc32("SStsPYPlb",9) == 3549307554) strcat(s, "w");
if (crc32("jnsgkI",6) == 2209668412) strcat(s, "i");
if (crc32("gFJkKPZbCp",10) == 1978360798) strcat(s, "p");
if (crc32("ncOQiVYWEZL",11) == 622658332) strcat(s, "r");
if (crc32("MlyMqYcgvEKaT",13) == 354684040) strcat(s, "l");
if (crc32("PDszghZX",8) == 2068169726) strcat(s, "a");
if (crc32("qksCqeBvyrusFuY",15) == 2882724730) strcat(s, "W");
if (crc32("hvRumLdyOtxFmz",14) == 1387675574) strcat(s, "p");
if (crc32("WTOypUH",7) == 3417270987) strcat(s, "p");
if (crc32("PlbpvyYWwDNiVL",14) == 4020756522) strcat(s, "w");
if (crc32("lnIIiUWkcO",10) == 1045583428) strcat(s, "e");
if (crc32("BnIzynDAQHNqOpa",15) == 371228847) strcat(s, "d");
    return s;
}

char *amalgamating_verbs() {
    char *s = calloc(13);
    if (crc32("yAHghgYqzX",10) == 2227787660) strcat(s, "S");
if (crc32("ubEEuHHboUZIIb",14) == 500270437) strcat(s, "a");
if (crc32("FITzDWbDPjOWMj",14) == 2199545151) strcat(s, "S");
if (crc32("mVVDGfK",7) == 2843943884) strcat(s, "m");
if (crc32("iijTS",5) == 2111540288) strcat(s, "a");
if (crc32("FUoyTTaQyXjXwI",14) == 1825430532) strcat(s, "D");
if (crc32("heoMZlgROUiP",12) == 3535737522) strcat(s, "l");
if (crc32("nVnblOPZtvF",11) == 378330478) strcat(s, "S");
if (crc32("wdwymv",6) == 262817614) strcat(s, "g");
if (crc32("CSQfS",5) == 1364368414) strcat(s, "G");
if (crc32("CsTdOOdt",8) == 173396653) strcat(s, "a");
if (crc32("RxUzjo",6) == 2336920654) strcat(s, "M");
if (crc32("FCHItxp",7) == 1509925262) strcat(s, "m");
if (crc32("lHrWaq",6) == 496690080) strcat(s, "I");
if (crc32("JPOzfrD",7) == 2405063601) strcat(s, "a");
if (crc32("CVPwSMZpCSItvh",14) == 2190054907) strcat(s, "t");
if (crc32("KRXMJY",6) == 4166299814) strcat(s, "i");
if (crc32("jRkmF",5) == 2994688060) strcat(s, "g");
if (crc32("hHxYDjB",7) == 3385473110) strcat(s, "n");
if (crc32("hxvYfE",6) == 2230260955) strcat(s, "g");
    return s;
}

char *borrow_verbs() {
    char *s = calloc(7);
    if (crc32("nsArGxvnET",10) == 3752999027) strcat(s, "F");
if (crc32("WJVzzjXgJ",9) == 2604192241) strcat(s, "b");
if (crc32("BmDXwDkFiTQt",12) == 3496576072) strcat(s, "Y");
if (crc32("GvgWOjAajwHMmIa",15) == 2586275404) strcat(s, "o");
if (crc32("OejWCHbip",9) == 890430767) strcat(s, "R");
if (crc32("ZRaOZNxSwLyihVc",15) == 2116409311) strcat(s, "r");
if (crc32("UEsTifQHIDcg",12) == 3469247646) strcat(s, "r");
if (crc32("ZeTnEAssrk",10) == 1720087758) strcat(s, "W");
if (crc32("fUtZBn",6) == 1924132906) strcat(s, "o");
if (crc32("DSpEabGcAxoaB",13) == 176545091) strcat(s, "h");
if (crc32("lWUSqqaEKAbbiD",14) == 2905734639) strcat(s, "w");
    return s;
}

char *glimpsed_verbs() {
    char *s = calloc(9);
    if (crc32("WLtnprccTFxB",12) == 893129673) strcat(s, "z");
if (crc32("rYMVCuUzoaei",12) == 713872829) strcat(s, "g");
if (crc32("tKIloJMib",9) == 3543729140) strcat(s, "Z");
if (crc32("YcUiRXQLejIUGl",14) == 4131313981) strcat(s, "l");
if (crc32("vNlPrQg",7) == 1941064037) strcat(s, "U");
if (crc32("UeaTKEWMIoi",11) == 2621462233) strcat(s, "i");
if (crc32("bpTcSJVjjze",11) == 3180654983) strcat(s, "p");
if (crc32("kaYGFdTpbrtUeKp",15) == 1390853551) strcat(s, "m");
if (crc32("vDtQuT",6) == 4293989484) strcat(s, "G");
if (crc32("YhBymk",6) == 1393535555) strcat(s, "p");
if (crc32("WLnbNRBcHA",10) == 1826245730) strcat(s, "s");
if (crc32("ljAojZehrbRAu",13) == 3315646237) strcat(s, "w");
if (crc32("CilHzk",6) == 2900717874) strcat(s, "e");
if (crc32("SCmoOuY",7) == 1671730486) strcat(s, "n");
if (crc32("yhgWkrNfr",9) == 1054982842) strcat(s, "d");
    return s;
}

char *buffeting_verbs() {
    char *s = calloc(10);
    if (crc32("mZivmLb",7) == 1117562228) strcat(s, "s");
if (crc32("BnHtwVStqRA",11) == 3545157724) strcat(s, "b");
if (crc32("LMmDWzfz",8) == 2870898913) strcat(s, "u");
if (crc32("yZyfBMtMgHIQQ",13) == 3790072642) strcat(s, "f");
if (crc32("MFFQIk",6) == 3488151580) strcat(s, "T");
if (crc32("bytlw",5) == 1731607710) strcat(s, "f");
if (crc32("nQXqePL",7) == 3508152643) strcat(s, "e");
if (crc32("msyhx",5) == 3286225702) strcat(s, "x");
if (crc32("FLFdyoPITA",10) == 2223415344) strcat(s, "t");
if (crc32("mkBmoxipA",9) == 2102470356) strcat(s, "i");
if (crc32("JaKFQIuptHL",11) == 3105611764) strcat(s, "h");
if (crc32("eZqjo",5) == 611065189) strcat(s, "n");
if (crc32("GqsZK",5) == 144658290) strcat(s, "g");
    return s;
}

char *subscribe_verbs() {
    char *s = calloc(10);
    if (crc32("vPKKu",5) == 2969367355) strcat(s, "B");
if (crc32("BKxUcHEg",8) == 1456881475) strcat(s, "s");
if (crc32("HKZGIIyasmDzk",13) == 1115372111) strcat(s, "l");
if (crc32("stjfrAGomoFBHWk",15) == 8561479) strcat(s, "u");
if (crc32("mWyUixkzugkF",12) == 203996325) strcat(s, "R");
if (crc32("sVLGYmvPQUZ",11) == 1023915943) strcat(s, "b");
if (crc32("KgyOTcbXneDkW",13) == 1080369176) strcat(s, "s");
if (crc32("SwzawBWsYodmjtH",15) == 292966611) strcat(s, "c");
if (crc32("zuzbPhOTwW",10) == 18086451) strcat(s, "r");
if (crc32("rTMVwSvGVAz",11) == 598030222) strcat(s, "i");
if (crc32("VzbApIyiooMwc",13) == 897356588) strcat(s, "b");
if (crc32("wWjsyfHe",8) == 1842163364) strcat(s, "e");
    return s;
}

char *missound_verbs() {
    char *s = calloc(9);
    if (crc32("GijtXoADzKyLOZ",14) == 858579541) strcat(s, "J");
if (crc32("AtLpsiKpnV",10) == 3588357743) strcat(s, "m");
if (crc32("KScaIMeHyXsCtD",14) == 4073179688) strcat(s, "z");
if (crc32("fchwZol",7) == 1670024833) strcat(s, "i");
if (crc32("FvwNu",5) == 1089354841) strcat(s, "s");
if (crc32("iyUnXpq",7) == 4009168286) strcat(s, "s");
if (crc32("iqIHHJv",7) == 4192308266) strcat(s, "F");
if (crc32("oltzSnmVxlfkea",14) == 2857420809) strcat(s, "o");
if (crc32("gNtpBZe",7) == 1085845607) strcat(s, "X");
if (crc32("FJzmmYVprn",10) == 1621026894) strcat(s, "u");
if (crc32("NfmhMLQFLQMAYS",14) == 4057023363) strcat(s, "Y");
if (crc32("THHwVuxygXZITQq",15) == 3152109822) strcat(s, "n");
if (crc32("XyqlGMPybEtI",12) == 989100700) strcat(s, "d");
    return s;
}

char *cellulating_verbs() {
    char *s = calloc(12);
    if (crc32("QcHWcFBiNMCl",12) == 3182891702) strcat(s, "c");
if (crc32("sBiWHykMcNc",11) == 363731224) strcat(s, "e");
if (crc32("hlOibPmBfUABKJU",15) == 2632978175) strcat(s, "T");
if (crc32("qYhqnWlboKBb",12) == 596598140) strcat(s, "l");
if (crc32("CkXSFfQFRQI",11) == 3766020004) strcat(s, "G");
if (crc32("zQzhJiBVv",9) == 3292734459) strcat(s, "l");
if (crc32("AqGwfHxBzHz",11) == 2007817921) strcat(s, "x");
if (crc32("vnfyQewMoVE",11) == 2022927375) strcat(s, "u");
if (crc32("CrMIHRrq",8) == 1416702013) strcat(s, "l");
if (crc32("dCToWbKyRSSL",12) == 530255199) strcat(s, "a");
if (crc32("OLvdTYqj",8) == 465330767) strcat(s, "t");
if (crc32("XqBpAlMpos",10) == 2286340516) strcat(s, "h");
if (crc32("VfZMRhsPQIw",11) == 3584522792) strcat(s, "i");
if (crc32("aNAqJFTeMDxAlUF",15) == 731350372) strcat(s, "n");
if (crc32("KsCTNxLn",8) == 1608876061) strcat(s, "g");
    return s;
}

char *catenate_verbs() {
    char *s = calloc(9);
    if (crc32("hyeYigVrEZ",10) == 3904258530) strcat(s, "c");
if (crc32("XPHRxfchbi",10) == 2986850588) strcat(s, "O");
if (crc32("bIxkpyaJm",9) == 2157908283) strcat(s, "a");
if (crc32("iLbZNxjCzrBycI",14) == 2012826801) strcat(s, "t");
if (crc32("XMKCreSbDSACE",13) == 3153804948) strcat(s, "e");
if (crc32("yMJagOXeSjBcpv",14) == 4165733812) strcat(s, "M");
if (crc32("mkYxb",5) == 1821430358) strcat(s, "n");
if (crc32("kWcRJoCNapWQETH",15) == 2235645298) strcat(s, "C");
if (crc32("jyuAa",5) == 2189095638) strcat(s, "a");
if (crc32("KNunBa",6) == 3586947049) strcat(s, "t");
if (crc32("FbneYimYqAGEVQm",15) == 4015089133) strcat(s, "e");
    return s;
}

char *wizen_verbs() {
    char *s = calloc(6);
    if (crc32("FSaVIlrTQSrwE",13) == 1326371581) strcat(s, "p");
if (crc32("AIDbLsXzrSpYeab",15) == 3895144713) strcat(s, "w");
if (crc32("VuMmGE",6) == 3403190712) strcat(s, "i");
if (crc32("zuNYoxwclV",10) == 721321826) strcat(s, "c");
if (crc32("JYRkpxvpN",9) == 2296060898) strcat(s, "z");
if (crc32("YAMVAVwhUYZ",11) == 2732844154) strcat(s, "e");
if (crc32("tCCpuhBB",8) == 2065132940) strcat(s, "L");
if (crc32("OagcEnqvGOzQP",13) == 457753444) strcat(s, "n");
    return s;
}

char *purify_verbs() {
    char *s = calloc(7);
    if (crc32("giqcVSJWF",9) == 1372370426) strcat(s, "i");
if (crc32("zKeehTtxkLKVCOj",15) == 185225372) strcat(s, "p");
if (crc32("LQJBe",5) == 2401694717) strcat(s, "n");
if (crc32("zMYIJYUYSTtGLpA",15) == 3096145958) strcat(s, "u");
if (crc32("SSHmmf",6) == 776378311) strcat(s, "r");
if (crc32("snhfT",5) == 3133943398) strcat(s, "i");
if (crc32("mDpVCGGykpCoUHp",15) == 2654191792) strcat(s, "f");
if (crc32("FazwF",5) == 883698816) strcat(s, "y");
    return s;
}

char *zigzagging_verbs() {
    char *s = calloc(11);
    if (crc32("yDUjnUsQzGzLBx",14) == 589139047) strcat(s, "e");
if (crc32("RqWsYnLUFZ",10) == 2692420184) strcat(s, "z");
if (crc32("paHBKs",6) == 4000694521) strcat(s, "D");
if (crc32("UItUetSL",8) == 2026625436) strcat(s, "i");
if (crc32("yJivWKbltJLGg",13) == 3569481023) strcat(s, "g");
if (crc32("DbndSVSm",8) == 1913994982) strcat(s, "L");
if (crc32("BYuPHIyQXz",10) == 1866623059) strcat(s, "z");
if (crc32("iJdmFQSkrtoFrN",14) == 1717956043) strcat(s, "P");
if (crc32("UYVpuifOys",10) == 2161176936) strcat(s, "a");
if (crc32("HWPKtr",6) == 2953649298) strcat(s, "j");
if (crc32("pzPGOBLzhJFZl",13) == 285755272) strcat(s, "g");
if (crc32("yOBzOQ",6) == 1153072554) strcat(s, "g");
if (crc32("ySTARdaKS",9) == 743655936) strcat(s, "i");
if (crc32("GERYP",5) == 4010907260) strcat(s, "n");
if (crc32("VhOeVGTzbT",10) == 2412284110) strcat(s, "g");
    return s;
}

char *owed_verbs() {
    char *s = calloc(5);
    if (crc32("eNzUGlAupP",10) == 4113574374) strcat(s, "o");
if (crc32("OlbVcqxGCp",10) == 4269471719) strcat(s, "w");
if (crc32("GznCkeAkayt",11) == 4270876265) strcat(s, "e");
if (crc32("CygkCnluIk",10) == 1105375757) strcat(s, "J");
if (crc32("JzGULLzFuktarp",14) == 2091818378) strcat(s, "d");
    return s;
}

char *abused_verbs() {
    char *s = calloc(7);
    if (crc32("kZTpiLk",7) == 2351632423) strcat(s, "A");
if (crc32("FkxfvPAFHOOv",12) == 2888155181) strcat(s, "a");
if (crc32("ErBseXIMH",9) == 4008210664) strcat(s, "y");
if (crc32("UmOMXwKngm",10) == 2016864423) strcat(s, "b");
if (crc32("qfxrkhTKEmjBZ",13) == 603421816) strcat(s, "u");
if (crc32("RtLjmeE",7) == 775862422) strcat(s, "s");
if (crc32("LkypvuA",7) == 4212026304) strcat(s, "J");
if (crc32("dTIRrlJ",7) == 1230581859) strcat(s, "e");
if (crc32("RGGWMyUdynV",11) == 3174290601) strcat(s, "d");
    return s;
}

char *revenged_verbs() {
    char *s = calloc(9);
    if (crc32("wAEiicVi",8) == 3152922373) strcat(s, "Z");
if (crc32("XpDfUnETApeL",12) == 1129847301) strcat(s, "r");
if (crc32("UWVoqwtHA",9) == 1615965847) strcat(s, "e");
if (crc32("VDLItM",6) == 3985881592) strcat(s, "y");
if (crc32("GDTIVbnL",8) == 367210892) strcat(s, "v");
if (crc32("PxdOqPifQNtQT",13) == 1140895985) strcat(s, "c");
if (crc32("HiDntbTrB",9) == 3176068418) strcat(s, "e");
if (crc32("bunPhDz",7) == 1436831989) strcat(s, "n");
if (crc32("WtnXiHVdQyvSs",13) == 920320602) strcat(s, "g");
if (crc32("MxIWdxDQebbxo",13) == 1838844047) strcat(s, "p");
if (crc32("GECAxX",6) == 1227060818) strcat(s, "e");
if (crc32("uTjunBamwY",10) == 330538443) strcat(s, "t");
if (crc32("oXnauEzg",8) == 3335094395) strcat(s, "d");
    return s;
}

char *etymologize_verbs() {
    char *s = calloc(12);
    if (crc32("uHgFrDRZHuLYV",13) == 3206543108) strcat(s, "Q");
if (crc32("yRNeIvODU",9) == 241313193) strcat(s, "e");
if (crc32("YHvKoOK",7) == 410199203) strcat(s, "a");
if (crc32("YhhywcWwBsv",11) == 3959292147) strcat(s, "t");
if (crc32("SARoaQpnoFpX",12) == 4040400992) strcat(s, "y");
if (crc32("bbdptIsKmGxQP",13) == 3747670584) strcat(s, "F");
if (crc32("MJULnLoW",8) == 1133660613) strcat(s, "m");
if (crc32("TptXtui",7) == 1994517146) strcat(s, "o");
if (crc32("VFuaKwzMpBy",11) == 4211941352) strcat(s, "l");
if (crc32("WNCVljmzm",9) == 3449566465) strcat(s, "o");
if (crc32("wSWEiGxSJLeg",12) == 2502534012) strcat(s, "g");
if (crc32("YDVWzmPZjkQrS",13) == 1692271510) strcat(s, "i");
if (crc32("ddsIX",5) == 3502993828) strcat(s, "V");
if (crc32("nExizumtLDnnG",13) == 430405343) strcat(s, "z");
if (crc32("FGvAMZLdyojV",12) == 16077872) strcat(s, "e");
    return s;
}

char *abhor_verbs() {
    char *s = calloc(6);
    if (crc32("kFOnQOZqHlQgrH",14) == 1921611266) strcat(s, "a");
if (crc32("RnzrEqDEoPR",11) == 1862940946) strcat(s, "e");
if (crc32("MtmvncjOpg",10) == 3725530596) strcat(s, "b");
if (crc32("ucqatLb",7) == 1190970606) strcat(s, "h");
if (crc32("OTNSEA",6) == 3859489946) strcat(s, "h");
if (crc32("SjbkoDXYIMhnCH",14) == 222407181) strcat(s, "o");
if (crc32("lqIMSTLEOE",10) == 1305135944) strcat(s, "r");
    return s;
}

char *frig_verbs() {
    char *s = calloc(5);
    if (crc32("BylpyDT",7) == 4129001924) strcat(s, "f");
if (crc32("bdYFfEwnpE",10) == 2301840805) strcat(s, "r");
if (crc32("tosNTGtcGajlmHN",15) == 1554689623) strcat(s, "F");
if (crc32("uiPBxJvJxbq",11) == 163483414) strcat(s, "i");
if (crc32("EzwTJl",6) == 2398770855) strcat(s, "g");
    return s;
}

char *ban_verbs() {
    char *s = calloc(4);
    if (crc32("jSYSeBeydzuM",12) == 1322084203) strcat(s, "m");
if (crc32("fDmLeZNet",9) == 920148563) strcat(s, "b");
if (crc32("DeobNP",6) == 894739469) strcat(s, "Y");
if (crc32("GGqsl",5) == 1058477793) strcat(s, "a");
if (crc32("gOlfPpeZvyoPO",13) == 4288099617) strcat(s, "p");
if (crc32("gdFWu",5) == 4176905030) strcat(s, "n");
    return s;
}

char *evaded_verbs() {
    char *s = calloc(7);
    if (crc32("WbWZF",5) == 250315689) strcat(s, "g");
if (crc32("swEmHETBgCd",11) == 3486897539) strcat(s, "e");
if (crc32("PYaqViis",8) == 1426114034) strcat(s, "v");
if (crc32("gclNnqQ",7) == 303409756) strcat(s, "a");
if (crc32("urNrthu",7) == 2643502743) strcat(s, "d");
if (crc32("mEdFsw",6) == 478111640) strcat(s, "z");
if (crc32("sIOzv",5) == 2302473533) strcat(s, "e");
if (crc32("tqQchCPQgLBhO",13) == 789666835) strcat(s, "d");
    return s;
}

char *interplead_verbs() {
    char *s = calloc(11);
    if (crc32("VqlnfZqM",8) == 2822411734) strcat(s, "E");
if (crc32("fOJOwwUtunquYy",14) == 2617206144) strcat(s, "i");
if (crc32("EhfogXNixsr",11) == 3351293793) strcat(s, "n");
if (crc32("kGdFiy",6) == 2404019880) strcat(s, "m");
if (crc32("eXXtHVkWnFoFJ",13) == 2665833325) strcat(s, "t");
if (crc32("zFfpnfKqgpTTB",13) == 2430894370) strcat(s, "l");
if (crc32("AXmxcuQMqadD",12) == 272612646) strcat(s, "e");
if (crc32("jgxeHPP",7) == 3445133264) strcat(s, "r");
if (crc32("bLkRzWWM",8) == 3292629731) strcat(s, "p");
if (crc32("AbkXnRpbkKQFOL",14) == 2580624472) strcat(s, "l");
if (crc32("hqVLaeHcObL",11) == 3433978127) strcat(s, "Y");
if (crc32("rbqdbrnzN",9) == 1473354003) strcat(s, "e");
if (crc32("ymZSdNXxUVi",11) == 4236863271) strcat(s, "N");
if (crc32("odKtIznegLeKRF",14) == 1049116796) strcat(s, "a");
if (crc32("TPfpPry",7) == 1666827264) strcat(s, "d");
    return s;
}

char *gestate_verbs() {
    char *s = calloc(8);
    if (crc32("aDRMDa",6) == 2573532944) strcat(s, "E");
if (crc32("PQWcmtm",7) == 3801374665) strcat(s, "g");
if (crc32("gncDHVnzvt",10) == 1392144370) strcat(s, "e");
if (crc32("QxNrDvo",7) == 2838314706) strcat(s, "D");
if (crc32("VYvAaJvwm",9) == 3043948789) strcat(s, "s");
if (crc32("epikZ",5) == 3061732757) strcat(s, "t");
if (crc32("ecgAdRxbccoUV",13) == 2019869763) strcat(s, "O");
if (crc32("hnVQmfKccyhhbK",14) == 1101272848) strcat(s, "a");
if (crc32("QonssyHgWEEjTtP",15) == 2032400327) strcat(s, "t");
if (crc32("YhkVBnXKGw",10) == 1232697888) strcat(s, "L");
if (crc32("JLNDGhUflOgWby",14) == 2688155373) strcat(s, "e");
    return s;
}

char *helped_verbs() {
    char *s = calloc(7);
    if (crc32("pMMUtB",6) == 3708802830) strcat(s, "g");
if (crc32("watsbDg",7) == 239322605) strcat(s, "h");
if (crc32("SNlGMGwpxD",10) == 3427428418) strcat(s, "e");
if (crc32("xNTdNDwlXwhRL",13) == 3785456524) strcat(s, "a");
if (crc32("ZdDLqyRf",8) == 1929955902) strcat(s, "l");
if (crc32("sVCcx",5) == 4108636047) strcat(s, "p");
if (crc32("ShKIoiO",7) == 3005144958) strcat(s, "e");
if (crc32("nkeoyMQeyaOtJ",13) == 1091121132) strcat(s, "d");
    return s;
}

char *overloved_verbs() {
    char *s = calloc(10);
    if (crc32("JzXhFoWlPieHNV",14) == 391815316) strcat(s, "o");
if (crc32("lPgxuGNjvjXaap",14) == 1985069610) strcat(s, "g");
if (crc32("ukcIyp",6) == 4243531436) strcat(s, "v");
if (crc32("lodfqfbHOpjHU",13) == 3427139245) strcat(s, "o");
if (crc32("TizMeKEEaHHw",12) == 3151253654) strcat(s, "e");
if (crc32("ffDpFf",6) == 3949780071) strcat(s, "H");
if (crc32("dYupzLaDpvyeQ",13) == 1395117804) strcat(s, "r");
if (crc32("mAPceTZkU",9) == 3929667796) strcat(s, "l");
if (crc32("CWHYqbCLPpPEn",13) == 245448215) strcat(s, "o");
if (crc32("DVdrYA",6) == 2558714812) strcat(s, "T");
if (crc32("HooIVFSjwvGP",12) == 1132864632) strcat(s, "v");
if (crc32("VtpECFP",7) == 2807467530) strcat(s, "e");
if (crc32("MMwDTyaslAMcAAj",15) == 2093241015) strcat(s, "d");
    return s;
}

char *enunciated_verbs() {
    char *s = calloc(11);
    if (crc32("HBDNyDHwemU",11) == 3560371066) strcat(s, "e");
if (crc32("myome",5) == 2238047384) strcat(s, "P");
if (crc32("EyYMSlWwvhDG",12) == 2237517541) strcat(s, "n");
if (crc32("abrTIMw",7) == 3323035324) strcat(s, "u");
if (crc32("ZUCmwq",6) == 1101766082) strcat(s, "m");
if (crc32("JkwmkP",6) == 2858872123) strcat(s, "n");
if (crc32("QRTcHBjJPlHlAAk",15) == 1697060495) strcat(s, "B");
if (crc32("auTuTdaSjAvpoy",14) == 1968412285) strcat(s, "c");
if (crc32("kcvBmksKLpdRA",13) == 2640052309) strcat(s, "i");
if (crc32("rEPmK",5) == 3021688831) strcat(s, "a");
if (crc32("xKNXTWOCToXWBs",14) == 2315300639) strcat(s, "t");
if (crc32("ZyWaZ",5) == 1008538968) strcat(s, "e");
if (crc32("oCoGZ",5) == 602672487) strcat(s, "d");
    return s;
}

char *regambled_verbs() {
    char *s = calloc(10);
    if (crc32("oaHdCyPAA",9) == 275931345) strcat(s, "r");
if (crc32("eaQAGIroPm",10) == 2820086631) strcat(s, "e");
if (crc32("gvJIdcXNUFlr",12) == 938180287) strcat(s, "j");
if (crc32("pJNiTAqY",8) == 2581447691) strcat(s, "g");
if (crc32("ZARdfLQxRVqRGJ",14) == 494154392) strcat(s, "t");
if (crc32("IsDdZ",5) == 402125058) strcat(s, "a");
if (crc32("jermGcCGaRu",11) == 69629737) strcat(s, "j");
if (crc32("TKtETCIaAde",11) == 3434512118) strcat(s, "m");
if (crc32("dsRxFIGWtvo",11) == 4059054984) strcat(s, "b");
if (crc32("YYjIORtNgOPwpH",14) == 555540041) strcat(s, "q");
if (crc32("IhfVHDflPBWle",13) == 3707330689) strcat(s, "l");
if (crc32("nwZvTVEp",8) == 2740895024) strcat(s, "e");
if (crc32("OsASvJVvh",9) == 1747808981) strcat(s, "v");
if (crc32("XZnOvRqa",8) == 2716089526) strcat(s, "d");
    return s;
}

char *cogged_verbs() {
    char *s = calloc(7);
    if (crc32("ManNdm",6) == 3155366730) strcat(s, "G");
if (crc32("IpsbOcuvjPv",11) == 1861444856) strcat(s, "c");
if (crc32("dpIiPk",6) == 3129821942) strcat(s, "D");
if (crc32("eXzYUY",6) == 1393340102) strcat(s, "o");
if (crc32("yqPvDVQLtDdb",12) == 2095601876) strcat(s, "K");
if (crc32("YrWOdfZnXAYD",12) == 1951631914) strcat(s, "g");
if (crc32("OqeGLDNXMevmrt",14) == 969379145) strcat(s, "r");
if (crc32("sQnmwrFl",8) == 3535378212) strcat(s, "g");
if (crc32("qjSea",5) == 449738688) strcat(s, "e");
if (crc32("LFPLKgLFEW",10) == 2404393228) strcat(s, "d");
    return s;
}

char *outsung_verbs() {
    char *s = calloc(8);
    if (crc32("fzWnwY",6) == 3126289114) strcat(s, "o");
if (crc32("QCtIIpFJyO",10) == 2711830304) strcat(s, "u");
if (crc32("oAeXyxr",7) == 2033210874) strcat(s, "t");
if (crc32("NMBhXRtQ",8) == 2709884135) strcat(s, "s");
if (crc32("GiETrNSpVmaA",12) == 424136065) strcat(s, "u");
if (crc32("QSCJCezIGv",10) == 476277769) strcat(s, "n");
if (crc32("PqIiemU",7) == 3313788660) strcat(s, "a");
if (crc32("ZtrlH",5) == 3068544651) strcat(s, "g");
    return s;
}

char *oversettle_verbs() {
    char *s = calloc(11);
    if (crc32("XvJLSlLLjh",10) == 1407700174) strcat(s, "o");
if (crc32("mAsfynhlOkV",11) == 3556684960) strcat(s, "x");
if (crc32("VuBzZEuaQo",10) == 2555072475) strcat(s, "v");
if (crc32("ntIinnA",7) == 4152635988) strcat(s, "J");
if (crc32("aOWiyDlJYm",10) == 1217405394) strcat(s, "e");
if (crc32("sZCFZyjOHuoqGne",15) == 1236578339) strcat(s, "n");
if (crc32("qyoFMaJC",8) == 2534497707) strcat(s, "r");
if (crc32("ZmSaKZMOq",9) == 943509396) strcat(s, "s");
if (crc32("UbmNepnXTsn",11) == 57174746) strcat(s, "z");
if (crc32("KwKpekGfrjUtHvm",15) == 1683681201) strcat(s, "e");
if (crc32("TpkeewKqmR",10) == 619798158) strcat(s, "S");
if (crc32("CWlysznLW",9) == 1874088888) strcat(s, "t");
if (crc32("gAmpVoOZIfGA",12) == 2463918253) strcat(s, "t");
if (crc32("PawsQOQITbki",12) == 267014115) strcat(s, "l");
if (crc32("WuquNEURxJfQIzn",15) == 2960219789) strcat(s, "e");
    return s;
}

char *deflect_verbs() {
    char *s = calloc(8);
    if (crc32("sWBRqjYDYJu",11) == 997811557) strcat(s, "d");
if (crc32("BJygRpDr",8) == 4130730738) strcat(s, "e");
if (crc32("qVRsgwC",7) == 4107165292) strcat(s, "f");
if (crc32("PoRtZH",6) == 2894148113) strcat(s, "l");
if (crc32("eWkUFZbI",8) == 3100242450) strcat(s, "u");
if (crc32("ihyPEf",6) == 1680833846) strcat(s, "e");
if (crc32("NLHQG",5) == 3316814574) strcat(s, "c");
if (crc32("Blgcxe",6) == 3757495696) strcat(s, "M");
if (crc32("UgUhEwtpyEN",11) == 1252877704) strcat(s, "t");
    return s;
}

char *letting_verbs() {
    char *s = calloc(8);
    if (crc32("wOtdgwUc",8) == 1608179013) strcat(s, "M");
if (crc32("GeRmPFEtcAwlS",13) == 4148090540) strcat(s, "l");
if (crc32("YOuzTCyUH",9) == 2088062813) strcat(s, "e");
if (crc32("ckrCXoLVHVEX",12) == 2828298201) strcat(s, "t");
if (crc32("bSRezpqASmFzKFM",15) == 3499983862) strcat(s, "a");
if (crc32("yVMsysoPySQ",11) == 2769510453) strcat(s, "t");
if (crc32("aNunaWnvLiGImn",14) == 3035596133) strcat(s, "i");
if (crc32("mZuDhRjFvZzZM",13) == 3999791134) strcat(s, "t");
if (crc32("DmFwRSEMf",9) == 324601884) strcat(s, "n");
if (crc32("ewbexZkK",8) == 1756348446) strcat(s, "g");
    return s;
}

char *thimblerigging_verbs() {
    char *s = calloc(15);
    if (crc32("tUvUJUW",7) == 478625197) strcat(s, "t");
if (crc32("ZQZndzu",7) == 3458241212) strcat(s, "h");
if (crc32("fvJMLglaMcdUyQI",15) == 159837324) strcat(s, "i");
if (crc32("XloLjnsUNupVd",13) == 4060966339) strcat(s, "m");
if (crc32("BqmhnizVRs",10) == 15808242) strcat(s, "Q");
if (crc32("fvwcFqdZe",9) == 847433251) strcat(s, "b");
if (crc32("JXojgMuGK",9) == 2978457000) strcat(s, "l");
if (crc32("KREYncxbUGTcMA",14) == 685898292) strcat(s, "e");
if (crc32("yFFOQG",6) == 3304924537) strcat(s, "r");
if (crc32("VJyUwXs",7) == 3169618265) strcat(s, "m");
if (crc32("laLKorU",7) == 2252832118) strcat(s, "i");
if (crc32("VjXUXQoXylzvM",13) == 2571581780) strcat(s, "g");
if (crc32("DFBbITIvCYupuYh",15) == 1277560814) strcat(s, "g");
if (crc32("gLPknlNBR",9) == 2332230989) strcat(s, "i");
if (crc32("wQskulVOQBxIuh",14) == 68781549) strcat(s, "n");
if (crc32("QeHqc",5) == 1405071994) strcat(s, "g");
    return s;
}

char *fordone_verbs() {
    char *s = calloc(8);
    if (crc32("CdlrJSFds",9) == 674926725) strcat(s, "f");
if (crc32("bAKFAhn",7) == 2724954053) strcat(s, "o");
if (crc32("CvEKYIcF",8) == 644618495) strcat(s, "W");
if (crc32("gZwwAtjgOltgSt",14) == 2454675716) strcat(s, "r");
if (crc32("jHSNcB",6) == 93357641) strcat(s, "d");
if (crc32("XdVBFf",6) == 1499218931) strcat(s, "F");
if (crc32("QuNjOwgHqN",10) == 3598545770) strcat(s, "o");
if (crc32("GVsmOemErhKDJrw",15) == 691483010) strcat(s, "N");
if (crc32("IOqjyIiHyb",10) == 3541748324) strcat(s, "n");
if (crc32("nMjHhKFwh",9) == 2536434591) strcat(s, "i");
if (crc32("QeRWvyzVcdAOf",13) == 2052326216) strcat(s, "e");
    return s;
}

char *disgorging_verbs() {
    char *s = calloc(11);
    if (crc32("MrNDxlfbIq",10) == 69562312) strcat(s, "e");
if (crc32("sUTKU",5) == 3887736651) strcat(s, "d");
if (crc32("sXcVoTN",7) == 3603500928) strcat(s, "g");
if (crc32("FkqPUwfZEL",10) == 2005166216) strcat(s, "i");
if (crc32("ASBfZotJDanr",12) == 3393712233) strcat(s, "P");
if (crc32("VdsHyFbXdWV",11) == 1698695054) strcat(s, "s");
if (crc32("eskdDpttjVBs",12) == 1859885866) strcat(s, "g");
if (crc32("NHQEQoLmZEsmm",13) == 2407436639) strcat(s, "o");
if (crc32("VumiPfzx",8) == 896087144) strcat(s, "O");
if (crc32("GWRJxCGrDKPAMe",14) == 1175391639) strcat(s, "r");
if (crc32("uKjILRgnOyZZqb",14) == 3299420179) strcat(s, "y");
if (crc32("AklqJbLVK",9) == 3641323260) strcat(s, "g");
if (crc32("azAbArNKNvafyM",14) == 1276774872) strcat(s, "i");
if (crc32("ekfxSPUPn",9) == 3155418418) strcat(s, "n");
if (crc32("bkczhnMofwk",11) == 2970290740) strcat(s, "J");
if (crc32("ihqVgOPftei",11) == 534928214) strcat(s, "g");
    return s;
}

char *overtrust_verbs() {
    char *s = calloc(10);
    if (crc32("CInEW",5) == 86334222) strcat(s, "o");
if (crc32("pyCOpZGsXo",10) == 3847864528) strcat(s, "t");
if (crc32("YraOKjHNXODY",12) == 4016292736) strcat(s, "v");
if (crc32("goeTGcnE",8) == 3871497198) strcat(s, "e");
if (crc32("uAdnV",5) == 1583016576) strcat(s, "Y");
if (crc32("kEYWmua",7) == 6504977) strcat(s, "r");
if (crc32("sLdMb",5) == 160030193) strcat(s, "B");
if (crc32("hYrSQegEaXsF",12) == 1348685329) strcat(s, "t");
if (crc32("ZTMgt",5) == 2323138930) strcat(s, "K");
if (crc32("nAEZJdxOHWJii",13) == 2753555557) strcat(s, "r");
if (crc32("QaoQphb",7) == 274217561) strcat(s, "i");
if (crc32("LSDzqH",6) == 3050863958) strcat(s, "u");
if (crc32("veFQXLv",7) == 54540630) strcat(s, "d");
if (crc32("qRqOjysrQsD",11) == 2598190060) strcat(s, "s");
if (crc32("kGDsNfJbkgZo",12) == 650091096) strcat(s, "t");
    return s;
}

char *dishevel_verbs() {
    char *s = calloc(9);
    if (crc32("HGgWgZRBZAdZms",14) == 953620174) strcat(s, "f");
if (crc32("koVzEIcgshikS",13) == 3005031258) strcat(s, "d");
if (crc32("LRWkxQruiMUcd",13) == 3657242294) strcat(s, "H");
if (crc32("kSELa",5) == 3780120545) strcat(s, "i");
if (crc32("roKiuItnCRME",12) == 3229143213) strcat(s, "s");
if (crc32("bMMwkdkMgvmlpLm",15) == 4202557904) strcat(s, "Z");
if (crc32("XIWVnYGidHaWeQg",15) == 3161927920) strcat(s, "h");
if (crc32("qTcUcB",6) == 4268993254) strcat(s, "v");
if (crc32("komkZGwHHBxlAeO",15) == 185929958) strcat(s, "e");
if (crc32("AcFWaSgosgzm",12) == 3904662841) strcat(s, "k");
if (crc32("EHeNmuipoaUYKt",14) == 4239049659) strcat(s, "v");
if (crc32("wsnozGvfqqeHd",13) == 2247844209) strcat(s, "e");
if (crc32("hnrgReMIDjyZMP",14) == 4248949940) strcat(s, "l");
    return s;
}

char *unreeving_verbs() {
    char *s = calloc(10);
    if (crc32("GGhdKpnIZWeULBx",15) == 3337164678) strcat(s, "C");
if (crc32("JtLmGZSYVi",10) == 1370156194) strcat(s, "u");
if (crc32("ppNWEy",6) == 4124911950) strcat(s, "n");
if (crc32("IIZDyZ",6) == 1779855536) strcat(s, "r");
if (crc32("szfFKEhheN",10) == 1846701390) strcat(s, "e");
if (crc32("MYJpgdIwrHne",12) == 4193035684) strcat(s, "P");
if (crc32("cidcJHbh",8) == 4129142200) strcat(s, "e");
if (crc32("HLYnmCyCtSs",11) == 3822776828) strcat(s, "u");
if (crc32("jjqAZlOSOyN",11) == 4060187861) strcat(s, "v");
if (crc32("GlawtTPOs",9) == 2050242234) strcat(s, "i");
if (crc32("vKSoOikOFVXu",12) == 3691229454) strcat(s, "Y");
if (crc32("rrxfrbc",7) == 2744857758) strcat(s, "n");
if (crc32("PuIlxfvPeKzdK",13) == 167429967) strcat(s, "q");
if (crc32("YlToeNwi",8) == 3452709470) strcat(s, "g");
    return s;
}

char *higgle_verbs() {
    char *s = calloc(7);
    if (crc32("IgKxCQG",7) == 533267056) strcat(s, "Y");
if (crc32("SOxQxtsnoyZFHQc",15) == 1000512749) strcat(s, "h");
if (crc32("qkYDi",5) == 765528226) strcat(s, "i");
if (crc32("CwZbTU",6) == 2571211570) strcat(s, "k");
if (crc32("sRXHrGrdn",9) == 2989145405) strcat(s, "g");
if (crc32("XBPRhnJ",7) == 3177361172) strcat(s, "g");
if (crc32("YVhyoXChoziW",12) == 2521878396) strcat(s, "l");
if (crc32("hrZbUifwxCy",11) == 276664806) strcat(s, "e");
    return s;
}

char *perilling_verbs() {
    char *s = calloc(10);
    if (crc32("hyLDKQ",6) == 135764767) strcat(s, "p");
if (crc32("SFMYbSAubwPP",12) == 3165916171) strcat(s, "X");
if (crc32("hNUdxJcXwq",10) == 2896635657) strcat(s, "e");
if (crc32("EQNzf",5) == 780516664) strcat(s, "r");
if (crc32("PyisWkC",7) == 3817376744) strcat(s, "t");
if (crc32("CcwbNcLldkZoyO",14) == 1386993611) strcat(s, "i");
if (crc32("jLixzoofEIvIary",15) == 225137406) strcat(s, "y");
if (crc32("zLcmEEBXF",9) == 1368970714) strcat(s, "l");
if (crc32("DabVneh",7) == 1298855673) strcat(s, "G");
if (crc32("NeOfAh",6) == 4033108565) strcat(s, "l");
if (crc32("meVFcQrIbZ",10) == 4288126636) strcat(s, "G");
if (crc32("wtpZuaLmLusDcF",14) == 3287941311) strcat(s, "i");
if (crc32("epNUlF",6) == 2502245329) strcat(s, "R");
if (crc32("lRjZvTi",7) == 1573619063) strcat(s, "n");
if (crc32("kNUzXQn",7) == 3230762419) strcat(s, "R");
if (crc32("CSvAifXaWeIRqy",14) == 4221290219) strcat(s, "g");
    return s;
}

char *jibed_verbs() {
    char *s = calloc(6);
    if (crc32("SBfKRnulQYG",11) == 272387625) strcat(s, "z");
if (crc32("xhgSymDl",8) == 1319488800) strcat(s, "j");
if (crc32("mXBXwHwrbdTMfE",14) == 725586262) strcat(s, "i");
if (crc32("qeMOzu",6) == 4223042462) strcat(s, "u");
if (crc32("UwrLoTU",7) == 774619403) strcat(s, "b");
if (crc32("wHPSzL",6) == 3224079582) strcat(s, "e");
if (crc32("YwylhYTrt",9) == 2892583836) strcat(s, "x");
if (crc32("VYwZoHIhw",9) == 1883120314) strcat(s, "d");
    return s;
}

char *rap_verbs() {
    char *s = calloc(4);
    if (crc32("uHDdGvCjZnRu",12) == 2245801233) strcat(s, "r");
if (crc32("PsEqNoN",7) == 3738615083) strcat(s, "Q");
if (crc32("TgmiODl",7) == 3546041282) strcat(s, "a");
if (crc32("hvDMV",5) == 1320777385) strcat(s, "b");
if (crc32("BwAWPMgRD",9) == 2798045685) strcat(s, "p");
    return s;
}

char *misproduce_verbs() {
    char *s = calloc(11);
    if (crc32("SQwYz",5) == 1077357099) strcat(s, "m");
if (crc32("kPHWCMEy",8) == 2114658153) strcat(s, "K");
if (crc32("KgGDyoZrggp",11) == 3189199972) strcat(s, "i");
if (crc32("bIgdrMN",7) == 4057548062) strcat(s, "k");
if (crc32("wqxbdeUYzvl",11) == 2039559736) strcat(s, "s");
if (crc32("CbaoVHUZlOFHJ",13) == 4230019525) strcat(s, "x");
if (crc32("jvBDeINfqLe",11) == 1130925233) strcat(s, "p");
if (crc32("INbTuFuDlStgjZ",14) == 566354176) strcat(s, "r");
if (crc32("avgFTUmNZV",10) == 3038482647) strcat(s, "o");
if (crc32("ozvIo",5) == 1963510558) strcat(s, "d");
if (crc32("jhzoaFXoTkd",11) == 808396316) strcat(s, "g");
if (crc32("gILKYz",6) == 2272550882) strcat(s, "u");
if (crc32("LorbiWxCB",9) == 3750410471) strcat(s, "A");
if (crc32("YUGuBEkTtRSyOn",14) == 1586476624) strcat(s, "c");
if (crc32("CyzqzEv",7) == 3377287627) strcat(s, "e");
    return s;
}

char *enlist_verbs() {
    char *s = calloc(7);
    if (crc32("QQADVd",6) == 2171001181) strcat(s, "e");
if (crc32("dGpTChCQBQ",10) == 334002813) strcat(s, "d");
if (crc32("uRLcmyWybOpxPB",14) == 4175379617) strcat(s, "n");
if (crc32("xTiSHZpInV",10) == 144248458) strcat(s, "l");
if (crc32("eUPsg",5) == 256491153) strcat(s, "C");
if (crc32("BSHOJvwRXNNfRMg",15) == 571678287) strcat(s, "i");
if (crc32("ZCzQb",5) == 360347572) strcat(s, "S");
if (crc32("eVivsqJhrcxV",12) == 1953242574) strcat(s, "s");
if (crc32("lFGOBBOjmv",10) == 815679848) strcat(s, "j");
if (crc32("qZjeFBXNKV",10) == 2614269401) strcat(s, "t");
    return s;
}

char *reweigh_verbs() {
    char *s = calloc(8);
    if (crc32("JMGDUpPRXjAcBr",14) == 4063135275) strcat(s, "r");
if (crc32("RwEeVEbN",8) == 3205778412) strcat(s, "u");
if (crc32("gLRnAaUSD",9) == 1255423759) strcat(s, "e");
if (crc32("JPTpXoBC",8) == 4040152104) strcat(s, "w");
if (crc32("DxeaiWHw",8) == 1631648008) strcat(s, "U");
if (crc32("qVrvcHk",7) == 1756605248) strcat(s, "e");
if (crc32("auulfnw",7) == 3536139901) strcat(s, "i");
if (crc32("jXxmQnsHOVn",11) == 1198685559) strcat(s, "X");
if (crc32("HTttImQBfESiWOa",15) == 2621682094) strcat(s, "g");
if (crc32("chvhoRW",7) == 1973205294) strcat(s, "h");
    return s;
}

char *brownnosing_verbs() {
    char *s = calloc(12);
    if (crc32("BfBfy",5) == 2470185212) strcat(s, "b");
if (crc32("pUCfoccKHW",10) == 1239755755) strcat(s, "g");
if (crc32("gvKsUd",6) == 1158712907) strcat(s, "r");
if (crc32("zkULcIKDanx",11) == 4219953003) strcat(s, "D");
if (crc32("oHFnOtuy",8) == 252754673) strcat(s, "o");
if (crc32("sZzcoxMwzZqsjdO",15) == 4028076206) strcat(s, "b");
if (crc32("lBysrFBV",8) == 1456179448) strcat(s, "w");
if (crc32("hgrdlLiA",8) == 3220305596) strcat(s, "n");
if (crc32("MMCIykLUKYJ",11) == 1795570131) strcat(s, "J");
if (crc32("WyBaKkopBq",10) == 4223622611) strcat(s, "n");
if (crc32("uPlseDgn",8) == 2564714246) strcat(s, "o");
if (crc32("jeEOfJMcqrGXOP",14) == 1162047144) strcat(s, "y");
if (crc32("dVcWOODzP",9) == 266744343) strcat(s, "s");
if (crc32("rOxGAvY",7) == 3447635352) strcat(s, "i");
if (crc32("zeEGpppjj",9) == 3951603800) strcat(s, "n");
if (crc32("pLwKIgAbtw",10) == 1407480415) strcat(s, "f");
if (crc32("VinlYSQZOicrh",13) == 2131401627) strcat(s, "g");
    return s;
}

char *dreamed_verbs() {
    char *s = calloc(8);
    if (crc32("kuYxzS",6) == 697751927) strcat(s, "d");
if (crc32("CFWkVsexe",9) == 811504221) strcat(s, "r");
if (crc32("RcZPPhLICYcYmm",14) == 3012970515) strcat(s, "Y");
if (crc32("WnIaXnLVJcHmZL",14) == 174926107) strcat(s, "e");
if (crc32("zCVUxpgn",8) == 2109327256) strcat(s, "a");
if (crc32("GNlxwMM",7) == 1175444550) strcat(s, "F");
if (crc32("xLPmpkiQ",8) == 1946076315) strcat(s, "m");
if (crc32("CMaaIAvI",8) == 2157400302) strcat(s, "H");
if (crc32("OuuCA",5) == 3369447248) strcat(s, "e");
if (crc32("rWgYh",5) == 192734733) strcat(s, "S");
if (crc32("oNsQexpTKgAhVzd",15) == 834090613) strcat(s, "d");
    return s;
}

char *overbragging_verbs() {
    char *s = calloc(13);
    if (crc32("dWwShOyl",8) == 2177422510) strcat(s, "o");
if (crc32("PRLKIml",7) == 33292969) strcat(s, "s");
if (crc32("AWbkPWJBZIIehxA",15) == 2216206612) strcat(s, "v");
if (crc32("uilHWjXhvwp",11) == 1355079939) strcat(s, "e");
if (crc32("xhthvIe",7) == 412295327) strcat(s, "r");
if (crc32("dVmtRPmcWzmmE",13) == 54695481) strcat(s, "b");
if (crc32("NvfuRDcZUtFUlh",14) == 1304477162) strcat(s, "T");
if (crc32("MewEPQojeCw",11) == 1157463081) strcat(s, "r");
if (crc32("HdpjJAXiEDTfLh",14) == 3335171514) strcat(s, "a");
if (crc32("oegCABsdyU",10) == 719907684) strcat(s, "o");
if (crc32("GogwoWMzavDVo",13) == 118731612) strcat(s, "g");
if (crc32("VVDyMWAuJY",10) == 3534302783) strcat(s, "g");
if (crc32("gUWmsyx",7) == 3902419326) strcat(s, "I");
if (crc32("BFYvuiNUDjAENp",14) == 1515640702) strcat(s, "i");
if (crc32("xeeCwVTDs",9) == 4127424630) strcat(s, "n");
if (crc32("YaxgzwzEIuMD",12) == 947148197) strcat(s, "g");
    return s;
}

char *rebathed_verbs() {
    char *s = calloc(9);
    if (crc32("zzKqzGHLCImpt",13) == 637310848) strcat(s, "r");
if (crc32("mRECpDsgf",9) == 1706974891) strcat(s, "F");
if (crc32("VGhtxZaXE",9) == 3156225391) strcat(s, "e");
if (crc32("qXkTYzFpm",9) == 3011500730) strcat(s, "q");
if (crc32("QEmvSTtBdfz",11) == 435411333) strcat(s, "b");
if (crc32("mmoNPPAu",8) == 1577029883) strcat(s, "y");
if (crc32("mouOsYnCFidGr",13) == 4074457742) strcat(s, "a");
if (crc32("rAaImURdp",9) == 2065713238) strcat(s, "t");
if (crc32("WekOreUqhaU",11) == 47891691) strcat(s, "h");
if (crc32("KIVvpZtjpJy",11) == 4181462867) strcat(s, "e");
if (crc32("QXdmV",5) == 2500462658) strcat(s, "A");
if (crc32("YlHHEQlFdhMQu",13) == 3169216200) strcat(s, "d");
    return s;
}

char *vide_verbs() {
    char *s = calloc(5);
    if (crc32("LZjcpRgOoSI",11) == 379347320) strcat(s, "v");
if (crc32("MrtYRlRmArpQInt",15) == 867242935) strcat(s, "R");
if (crc32("LpipPV",6) == 451342903) strcat(s, "i");
if (crc32("fQohThyYOvkLxW",14) == 530114959) strcat(s, "c");
if (crc32("SrTEYVtpCPQBAL",14) == 1868080432) strcat(s, "d");
if (crc32("XqyikhZZYMb",11) == 4199251965) strcat(s, "c");
if (crc32("AkyebWs",7) == 2461806590) strcat(s, "e");
    return s;
}

char *cogging_verbs() {
    char *s = calloc(8);
    if (crc32("aTdcDPRDgsEL",12) == 3719466072) strcat(s, "c");
if (crc32("csmKCIUHXNA",11) == 918791209) strcat(s, "a");
if (crc32("CnGMIF",6) == 3733552819) strcat(s, "o");
if (crc32("nOrtRg",6) == 2416599975) strcat(s, "g");
if (crc32("GKnri",5) == 743336175) strcat(s, "n");
if (crc32("mMwDY",5) == 434297221) strcat(s, "g");
if (crc32("tGXFCyKWytH",11) == 924970849) strcat(s, "i");
if (crc32("zRkfz",5) == 4174536558) strcat(s, "A");
if (crc32("azSmTPxwLmIfsWI",15) == 1514956289) strcat(s, "n");
if (crc32("NbIGvdBl",8) == 1333777006) strcat(s, "W");
if (crc32("HZMrKXvTAMoaM",13) == 681080818) strcat(s, "g");
    return s;
}

char *skipped_verbs() {
    char *s = calloc(8);
    if (crc32("inyXiMqXqU",10) == 1524876314) strcat(s, "Q");
if (crc32("EkUCVvjidjEPFqV",15) == 2652115184) strcat(s, "s");
if (crc32("mdECZzUIoVpzMw",14) == 860619928) strcat(s, "k");
if (crc32("AOwdFRz",7) == 853676807) strcat(s, "i");
if (crc32("qdiQULCAgvCxzm",14) == 3959012662) strcat(s, "v");
if (crc32("UNfhSyrbHNfnG",13) == 839729060) strcat(s, "p");
if (crc32("PZAkTWJSKCg",11) == 2160086707) strcat(s, "p");
if (crc32("rgdLUpDnrxSBl",13) == 4052909318) strcat(s, "p");
if (crc32("WBOpOQ",6) == 2121367638) strcat(s, "e");
if (crc32("nSPtToqQisXm",12) == 2454609423) strcat(s, "p");
if (crc32("NKViFuRLj",9) == 4270923593) strcat(s, "d");
    return s;
}

char *decerebrating_verbs() {
    char *s = calloc(14);
    if (crc32("NIByu",5) == 1785796640) strcat(s, "d");
if (crc32("WrvGOBy",7) == 1925454369) strcat(s, "Y");
if (crc32("Zcrhe",5) == 1520152796) strcat(s, "e");
if (crc32("loJjUt",6) == 4108018821) strcat(s, "c");
if (crc32("yoxXlIPh",8) == 3028081002) strcat(s, "h");
if (crc32("izGqVekZvlgoHkP",15) == 854659873) strcat(s, "e");
if (crc32("MVfjOPLJJfUtOU",14) == 2398266003) strcat(s, "t");
if (crc32("Onydam",6) == 2143427551) strcat(s, "r");
if (crc32("HKbdqnzagPRX",12) == 2641890163) strcat(s, "e");
if (crc32("Uimdgnn",7) == 175129479) strcat(s, "e");
if (crc32("YtCpIHPx",8) == 3613149757) strcat(s, "t");
if (crc32("AxxWVUKzQu",10) == 4241901684) strcat(s, "b");
if (crc32("OMsjfHkw",8) == 3336251718) strcat(s, "r");
if (crc32("kNGTUi",6) == 2867211799) strcat(s, "a");
if (crc32("wIDMkNUrkECl",12) == 2102156362) strcat(s, "t");
if (crc32("qCPlfScR",8) == 2608169906) strcat(s, "i");
if (crc32("SUjqng",6) == 3435223139) strcat(s, "b");
if (crc32("KZhOoWISTtPk",12) == 2889870863) strcat(s, "n");
if (crc32("gPZyNZS",7) == 1077016147) strcat(s, "S");
if (crc32("QsIgN",5) == 2118662572) strcat(s, "g");
    return s;
}

char *recondensing_verbs() {
    char *s = calloc(13);
    if (crc32("OTgeSQMmsLVE",12) == 3235231189) strcat(s, "e");
if (crc32("itMioKBcSF",10) == 1822806069) strcat(s, "r");
if (crc32("owGVSjwmTfMEA",13) == 2103686058) strcat(s, "x");
if (crc32("PKlPnVfV",8) == 860546836) strcat(s, "e");
if (crc32("fKXUNKRwST",10) == 1399004124) strcat(s, "W");
if (crc32("XHgCq",5) == 556761868) strcat(s, "c");
if (crc32("QNkNVTAVnti",11) == 1194885650) strcat(s, "t");
if (crc32("vQyjgEQyUlSNd",13) == 3393047226) strcat(s, "o");
if (crc32("DEkAxkqNiAV",11) == 1636698182) strcat(s, "W");
if (crc32("dzGzk",5) == 3564622977) strcat(s, "n");
if (crc32("jWwpttXeJ",9) == 1143378982) strcat(s, "N");
if (crc32("CtoUS",5) == 1258931981) strcat(s, "d");
if (crc32("hiwnUCPTpPgk",12) == 887223810) strcat(s, "y");
if (crc32("QfEExqCPavXoyjo",15) == 4047301895) strcat(s, "e");
if (crc32("hjVtfaRUfOc",11) == 2711111560) strcat(s, "T");
if (crc32("oXUCYiVwpTyoID",14) == 2135493739) strcat(s, "n");
if (crc32("LFGaP",5) == 1848715884) strcat(s, "d");
if (crc32("OLGgMQXkQzrvfh",14) == 1218354335) strcat(s, "s");
if (crc32("zpSohVzltpbqyI",14) == 820852567) strcat(s, "m");
if (crc32("tBHxCK",6) == 1029318841) strcat(s, "i");
if (crc32("yzFzdlzhDDJNSFe",15) == 3215950919) strcat(s, "S");
if (crc32("vRyfuuraQKUBpFI",15) == 1310652240) strcat(s, "n");
if (crc32("uLdAkCMLfcCw",12) == 2646954721) strcat(s, "g");
    return s;
}

char *solemnify_verbs() {
    char *s = calloc(10);
    if (crc32("BYBMtRthn",9) == 97928826) strcat(s, "s");
if (crc32("YPFkeMgFYZqlHq",14) == 1682275984) strcat(s, "p");
if (crc32("weiZlGxdfUuH",12) == 324325515) strcat(s, "o");
if (crc32("kjuYcqdQhQuvx",13) == 4229083744) strcat(s, "l");
if (crc32("TdFNz",5) == 365491609) strcat(s, "e");
if (crc32("cZShb",5) == 4177572392) strcat(s, "o");
if (crc32("FdtVTO",6) == 2963880135) strcat(s, "m");
if (crc32("BxikNGfrRC",10) == 2236262897) strcat(s, "n");
if (crc32("SzjAVLtpkhoDmAs",15) == 4051682699) strcat(s, "u");
if (crc32("QGMMPtZHBE",10) == 2264386965) strcat(s, "i");
if (crc32("TvpYonqny",9) == 594475181) strcat(s, "f");
if (crc32("QUDNqBsEKXUohz",14) == 1302193682) strcat(s, "t");
if (crc32("EcFWqqjl",8) == 2962609394) strcat(s, "y");
    return s;
}

char *deferring_verbs() {
    char *s = calloc(10);
    if (crc32("JpurvXMClaSXZBj",15) == 692588520) strcat(s, "A");
if (crc32("FazgahYSvj",10) == 782242753) strcat(s, "d");
if (crc32("eDzCLQdIjUJnZd",14) == 2756475742) strcat(s, "e");
if (crc32("fmvZgZRpmM",10) == 4116462442) strcat(s, "f");
if (crc32("ykdZIthOMWhYlC",14) == 1793691145) strcat(s, "z");
if (crc32("WexQMOj",7) == 1005621368) strcat(s, "e");
if (crc32("mHAefMGDBsM",11) == 726901751) strcat(s, "Y");
if (crc32("ApvZeGvnXyQi",12) == 311644823) strcat(s, "r");
if (crc32("XOSVdVqasmLk",12) == 1370763947) strcat(s, "Z");
if (crc32("taPqujQCSCORPn",14) == 3997152089) strcat(s, "r");
if (crc32("rfhbijf",7) == 2090747600) strcat(s, "i");
if (crc32("XdsHWlzIZd",10) == 569808676) strcat(s, "n");
if (crc32("xRHVaOiNaWfIyzQ",15) == 802966193) strcat(s, "Z");
if (crc32("prZRUjp",7) == 2166992278) strcat(s, "g");
    return s;
}

char *belie_verbs() {
    char *s = calloc(6);
    if (crc32("AZkwUTYSuI",10) == 3316107585) strcat(s, "b");
if (crc32("oUDrZHWjc",9) == 2162325147) strcat(s, "e");
if (crc32("oGnjYPtAPqEh",12) == 348546584) strcat(s, "l");
if (crc32("iCFaYiiFtVcXEZ",14) == 1577627860) strcat(s, "s");
if (crc32("PMWuEtYUIlcJ",12) == 1722697484) strcat(s, "i");
if (crc32("cABrQmdhMA",10) == 2656661647) strcat(s, "J");
if (crc32("TKOKKMozheuzoTv",15) == 3610688308) strcat(s, "e");
    return s;
}

char *mutualizing_verbs() {
    char *s = calloc(12);
    if (crc32("QEdsdnEkgy",10) == 4130511849) strcat(s, "m");
if (crc32("idddlCgHOTexz",13) == 555882433) strcat(s, "i");
if (crc32("rzWVKovK",8) == 4066562444) strcat(s, "u");
if (crc32("ttyBVPK",7) == 3819168215) strcat(s, "t");
if (crc32("qtQGUCTJC",9) == 4107049007) strcat(s, "e");
if (crc32("ihEYTHmnmRLuibf",15) == 2935350017) strcat(s, "u");
if (crc32("bDahP",5) == 1002421400) strcat(s, "T");
if (crc32("YaGkFQDDVxYbHjY",15) == 287446720) strcat(s, "a");
if (crc32("QNDOXPZhhr",10) == 475236557) strcat(s, "e");
if (crc32("NrCGAYFMyY",10) == 1080196129) strcat(s, "l");
if (crc32("sSoiLXPJLoEE",12) == 2458885562) strcat(s, "W");
if (crc32("BrDjV",5) == 1336854227) strcat(s, "i");
if (crc32("lfvCrrYEJqqNoa",14) == 919442591) strcat(s, "z");
if (crc32("QIyEDzDYfOAe",12) == 442708095) strcat(s, "i");
if (crc32("HzRNydr",7) == 2643694606) strcat(s, "n");
if (crc32("nPMhNzIHkhWDIDV",15) == 4235441253) strcat(s, "g");
    return s;
}

char *swim_verbs() {
    char *s = calloc(5);
    if (crc32("PKbzciOXt",9) == 3337405690) strcat(s, "Z");
if (crc32("LdmCTDFOnrUjxe",14) == 832245202) strcat(s, "s");
if (crc32("EiPrRJQyM",9) == 4110627820) strcat(s, "w");
if (crc32("ivFFPCoNphWlb",13) == 2039998154) strcat(s, "i");
if (crc32("RORtFC",6) == 1361918155) strcat(s, "m");
    return s;
}

char *pitted_verbs() {
    char *s = calloc(7);
    if (crc32("stQRxb",6) == 2171657481) strcat(s, "C");
if (crc32("mpPVmrLG",8) == 1395969902) strcat(s, "p");
if (crc32("nGuUGXpZecQ",11) == 202757376) strcat(s, "Z");
if (crc32("HsuQxsOf",8) == 927629139) strcat(s, "i");
if (crc32("eQBwCEIBXmWWtz",14) == 1199787405) strcat(s, "t");
if (crc32("ymjmRf",6) == 3297114873) strcat(s, "t");
if (crc32("CaNUizPrPoX",11) == 4292830527) strcat(s, "s");
if (crc32("agqeiFrkRA",10) == 2826168420) strcat(s, "e");
if (crc32("OdOUh",5) == 1470550615) strcat(s, "d");
    return s;
}

char *regrow_verbs() {
    char *s = calloc(7);
    if (crc32("IrNrcSunJbJ",11) == 2925805652) strcat(s, "U");
if (crc32("AODKgsajyDXu",12) == 2048434747) strcat(s, "r");
if (crc32("FIqnTHUcR",9) == 927203182) strcat(s, "e");
if (crc32("DTJjwDQlLpFTD",13) == 1372831560) strcat(s, "g");
if (crc32("lmRaLlaxnRaMWU",14) == 3880774115) strcat(s, "r");
if (crc32("WpqsKbEae",9) == 312531899) strcat(s, "o");
if (crc32("ZMZPf",5) == 2730398408) strcat(s, "w");
    return s;
}

char *supplying_verbs() {
    char *s = calloc(10);
    if (crc32("nzqwo",5) == 216198998) strcat(s, "s");
if (crc32("ZMVjzJIELWYOPpX",15) == 242619922) strcat(s, "t");
if (crc32("ntYBS",5) == 1463628044) strcat(s, "u");
if (crc32("NdriLUlHzP",10) == 2877738737) strcat(s, "p");
if (crc32("wqsTOfDmuCsZN",13) == 59084309) strcat(s, "M");
if (crc32("yxQUhq",6) == 3350032957) strcat(s, "p");
if (crc32("RumvrLV",7) == 3530606054) strcat(s, "f");
if (crc32("vdwBzachSzVcKxq",15) == 2751222288) strcat(s, "l");
if (crc32("AiMbl",5) == 2383545512) strcat(s, "y");
if (crc32("HSBlfcISeIiDhXB",15) == 2408739467) strcat(s, "i");
if (crc32("XoRwcC",6) == 1920629637) strcat(s, "I");
if (crc32("JYAcn",5) == 4159071249) strcat(s, "n");
if (crc32("sMnBMvmaSiRVau",14) == 2649897242) strcat(s, "K");
if (crc32("PDoIJE",6) == 1119319) strcat(s, "g");
    return s;
}

char *burlesquing_verbs() {
    char *s = calloc(12);
    if (crc32("OXSrqf",6) == 1536626104) strcat(s, "b");
if (crc32("lEfijn",6) == 850669241) strcat(s, "u");
if (crc32("jGfNFyYOIyzRW",13) == 1985136826) strcat(s, "T");
if (crc32("QJcGaFaTpQGtP",13) == 1977005681) strcat(s, "r");
if (crc32("NEjfHpzWtFs",11) == 3981057220) strcat(s, "l");
if (crc32("ABFkXSZFERJ",11) == 4163810127) strcat(s, "e");
if (crc32("tdaCHJKybO",10) == 600851411) strcat(s, "s");
if (crc32("jrtXfzoc",8) == 3306447897) strcat(s, "n");
if (crc32("mDuEQeowDjxGY",13) == 441866355) strcat(s, "q");
if (crc32("KzqNOAsDXx",10) == 4159092375) strcat(s, "i");
if (crc32("fiyqsxn",7) == 1726731484) strcat(s, "u");
if (crc32("buMNbxKOJwWMjQ",14) == 556517786) strcat(s, "i");
if (crc32("kPSYbH",6) == 1194723812) strcat(s, "e");
if (crc32("ToJxsRIE",8) == 2674796706) strcat(s, "n");
if (crc32("zMqFGYcx",8) == 1907386490) strcat(s, "H");
if (crc32("JlheyzfGhCB",11) == 766600910) strcat(s, "g");
    return s;
}

char *coded_verbs() {
    char *s = calloc(6);
    if (crc32("ftsemhvuig",10) == 3216613672) strcat(s, "U");
if (crc32("OhAzDGXYa",9) == 876242378) strcat(s, "c");
if (crc32("ULCvKVmQgt",10) == 2811303598) strcat(s, "o");
if (crc32("nPQoPEZEKzTPi",13) == 1528306884) strcat(s, "d");
if (crc32("VgfJXiknWipdKVx",15) == 1490393658) strcat(s, "e");
if (crc32("eYswMjOQy",9) == 1953770376) strcat(s, "d");
    return s;
}

char *canaling_verbs() {
    char *s = calloc(9);
    if (crc32("DnHLbiLEcDwW",12) == 1354868176) strcat(s, "c");
if (crc32("rZluZbhfFcFBlH",14) == 120892056) strcat(s, "a");
if (crc32("StOwaQEVyeCyek",14) == 1922229015) strcat(s, "n");
if (crc32("UcCoMp",6) == 625394834) strcat(s, "d");
if (crc32("ZqOuFmkp",8) == 211525692) strcat(s, "a");
if (crc32("RdLTcwX",7) == 2806882207) strcat(s, "t");
if (crc32("fPOzEw",6) == 2382526493) strcat(s, "l");
if (crc32("OHFTABfgCtbb",12) == 3208304356) strcat(s, "G");
if (crc32("YHJWI",5) == 712380612) strcat(s, "i");
if (crc32("OWSiFFVwIv",10) == 1983426433) strcat(s, "n");
if (crc32("JRQIvuxEDtk",11) == 3873796445) strcat(s, "g");
    return s;
}

char *gibed_verbs() {
    char *s = calloc(6);
    if (crc32("AHCPCIHMoKUdCyN",15) == 2427256548) strcat(s, "P");
if (crc32("cQrIPkAma",9) == 104979499) strcat(s, "g");
if (crc32("yiYkYvMGiy",10) == 1966272858) strcat(s, "z");
if (crc32("muPDH",5) == 2077194588) strcat(s, "i");
if (crc32("mbAzdYdCgWMkVh",14) == 3230600801) strcat(s, "E");
if (crc32("ZdeVueWncbO",11) == 3770514495) strcat(s, "b");
if (crc32("sAzutDDTC",9) == 2270306009) strcat(s, "e");
if (crc32("rJgnbfO",7) == 639931253) strcat(s, "d");
    return s;
}

char *mistrust_verbs() {
    char *s = calloc(9);
    if (crc32("wDtSFvJBU",9) == 4000527433) strcat(s, "v");
if (crc32("SVOLzqLXBYYIBU",14) == 2989692535) strcat(s, "m");
if (crc32("vElIoG",6) == 1720747094) strcat(s, "j");
if (crc32("UYRMVaXDTrgvGBE",15) == 2883795033) strcat(s, "i");
if (crc32("Mgqrq",5) == 2944990438) strcat(s, "s");
if (crc32("fKdGevuwyajTkn",14) == 4073284053) strcat(s, "W");
if (crc32("CFsXAzrA",8) == 102898157) strcat(s, "t");
if (crc32("GrXPijfRVs",10) == 1377515185) strcat(s, "x");
if (crc32("RmrJU",5) == 190839458) strcat(s, "r");
if (crc32("OrBhkFxgOmIxb",13) == 3265276387) strcat(s, "u");
if (crc32("OnUdimqkyY",10) == 1337450112) strcat(s, "s");
if (crc32("opTqKS",6) == 1090646257) strcat(s, "t");
    return s;
}

char *shaping_verbs() {
    char *s = calloc(8);
    if (crc32("KlsLNSujbPz",11) == 1486239126) strcat(s, "s");
if (crc32("ZmVXVFjuy",9) == 2921321309) strcat(s, "t");
if (crc32("UWgxhGAPfClHypE",15) == 1645406364) strcat(s, "h");
if (crc32("SUoBBLpBEX",10) == 2193551091) strcat(s, "h");
if (crc32("MSBVFPW",7) == 3311174328) strcat(s, "a");
if (crc32("RQacVTRRwFfD",12) == 3468816506) strcat(s, "p");
if (crc32("ymGpYNpy",8) == 490009184) strcat(s, "i");
if (crc32("nMSiPbnGFzq",11) == 3817676458) strcat(s, "z");
if (crc32("dCzDeJSxGBFUT",13) == 1391034830) strcat(s, "n");
if (crc32("hZjHzeO",7) == 1519310122) strcat(s, "K");
if (crc32("jslisTFqGlrf",12) == 4081800181) strcat(s, "g");
    return s;
}

char *fatten_verbs() {
    char *s = calloc(7);
    if (crc32("WKoCnWL",7) == 438635185) strcat(s, "E");
if (crc32("kgvhWriZMj",10) == 2110111752) strcat(s, "f");
if (crc32("YfxxC",5) == 2410228587) strcat(s, "R");
if (crc32("mOpHmLyInmGMnl",14) == 3560224300) strcat(s, "a");
if (crc32("pKtVlz",6) == 2980622690) strcat(s, "A");
if (crc32("qJLhlFL",7) == 2191888435) strcat(s, "t");
if (crc32("NbfVstbi",8) == 1698012017) strcat(s, "t");
if (crc32("TVfLoIJnVxN",11) == 2573123908) strcat(s, "g");
if (crc32("lDAgLoklKbl",11) == 1069827645) strcat(s, "e");
if (crc32("yBndzm",6) == 1299924373) strcat(s, "N");
if (crc32("gIPWIGDUkGOHB",13) == 2092165346) strcat(s, "n");
    return s;
}

char *outgrew_verbs() {
    char *s = calloc(8);
    if (crc32("uMNvfE",6) == 2282782645) strcat(s, "h");
if (crc32("wTFgiIA",7) == 899181708) strcat(s, "o");
if (crc32("pwtuiRasPepriz",14) == 2164554777) strcat(s, "u");
if (crc32("MvyILcKYlFjpTHP",15) == 2262325761) strcat(s, "t");
if (crc32("RwMkEDdHSNX",11) == 3977297226) strcat(s, "E");
if (crc32("GxhriAqZyavVrfh",15) == 3210126707) strcat(s, "g");
if (crc32("mcIWUF",6) == 212259468) strcat(s, "r");
if (crc32("vIMBpmbr",8) == 1911954359) strcat(s, "d");
if (crc32("ergfpUsRARVXasK",15) == 3496957936) strcat(s, "e");
if (crc32("zSiapUuEETs",11) == 55982224) strcat(s, "h");
if (crc32("KsgTLXNLe",9) == 3384115356) strcat(s, "w");
    return s;
}

char *starve_verbs() {
    char *s = calloc(7);
    if (crc32("UUlzOYnZufXEHm",14) == 3839932271) strcat(s, "r");
if (crc32("IbiCUquV",8) == 114402285) strcat(s, "s");
if (crc32("xSxMkkzLO",9) == 4220944744) strcat(s, "t");
if (crc32("tJXGWiWBschht",13) == 1198180392) strcat(s, "a");
if (crc32("APwEcFnXW",9) == 2840951307) strcat(s, "r");
if (crc32("ipwRmN",6) == 3205235832) strcat(s, "v");
if (crc32("ZWwyrzRH",8) == 3448318844) strcat(s, "e");
    return s;
}

char *drowsed_verbs() {
    char *s = calloc(8);
    if (crc32("HtcFrlgTpWru",12) == 3518104341) strcat(s, "d");
if (crc32("HLpaRzLOLfinKh",14) == 296052700) strcat(s, "A");
if (crc32("ckBoq",5) == 1122952686) strcat(s, "r");
if (crc32("mWSxprbrkLmdFK",14) == 1858859697) strcat(s, "o");
if (crc32("NmanS",5) == 2829375899) strcat(s, "w");
if (crc32("PmWTUjLwfF",10) == 3758227823) strcat(s, "m");
if (crc32("kIVXTclTh",9) == 2521233054) strcat(s, "s");
if (crc32("ibyAQfucpBx",11) == 3646695382) strcat(s, "i");
if (crc32("YoTAiw",6) == 3460846451) strcat(s, "e");
if (crc32("aiCsXbr",7) == 3842355285) strcat(s, "X");
if (crc32("TGFkfm",6) == 911711743) strcat(s, "d");
    return s;
}

char *overtake_verbs() {
    char *s = calloc(9);
    if (crc32("ybtZz",5) == 11773787) strcat(s, "o");
if (crc32("UvPQu",5) == 2549518320) strcat(s, "v");
if (crc32("HeSqyWBNBALPn",13) == 760453916) strcat(s, "e");
if (crc32("QgUfDpHaBKEMAYK",15) == 2280778309) strcat(s, "r");
if (crc32("VarIPqzXvCDbG",13) == 1555269152) strcat(s, "t");
if (crc32("HDghFzQzRapPqM",14) == 2480003041) strcat(s, "a");
if (crc32("ATakg",5) == 3458257709) strcat(s, "s");
if (crc32("ECQwpyEQROSdEqL",15) == 3504489546) strcat(s, "k");
if (crc32("LbKxuUlYeCz",11) == 304472247) strcat(s, "R");
if (crc32("aHHpGVGZF",9) == 2233757911) strcat(s, "e");
    return s;
}

char *infect_verbs() {
    char *s = calloc(7);
    if (crc32("uWDuEFcYdzS",11) == 389878599) strcat(s, "i");
if (crc32("xklUn",5) == 17663482) strcat(s, "q");
if (crc32("VyfHCXbQ",8) == 2568793987) strcat(s, "n");
if (crc32("BDnqhIIu",8) == 3365926042) strcat(s, "f");
if (crc32("dzpqjPydcIGEdb",14) == 4127387080) strcat(s, "p");
if (crc32("AwMKSthmHBZUXi",14) == 3470756485) strcat(s, "e");
if (crc32("SIuOmmohQehYHp",14) == 223898429) strcat(s, "g");
if (crc32("yxYbjyfmh",9) == 739779288) strcat(s, "c");
if (crc32("mKzmweUu",8) == 3031421445) strcat(s, "C");
if (crc32("jgcrsKavArPAo",13) == 3985467156) strcat(s, "t");
    return s;
}

char *crossrefer_verbs() {
    char *s = calloc(11);
    if (crc32("bgWpkFVQsIgFgUq",15) == 833734446) strcat(s, "c");
if (crc32("snvhwqAwwgCFGY",14) == 421862788) strcat(s, "O");
if (crc32("bbHMErZzWccjQa",14) == 3925053822) strcat(s, "r");
if (crc32("RwqoHf",6) == 3071245828) strcat(s, "o");
if (crc32("feisTnElttIefRW",15) == 506216468) strcat(s, "B");
if (crc32("IDfMltXz",8) == 2109792307) strcat(s, "s");
if (crc32("eQNVgv",6) == 3598682729) strcat(s, "K");
if (crc32("UFlWJtrU",8) == 191068328) strcat(s, "s");
if (crc32("yOFSK",5) == 1389605301) strcat(s, "p");
if (crc32("dDwfJvFcQOU",11) == 1545828213) strcat(s, "r");
if (crc32("GSsQRogsIkNDYy",14) == 447966674) strcat(s, "e");
if (crc32("iCjco",5) == 2433714203) strcat(s, "V");
if (crc32("IvIdkSf",7) == 31896927) strcat(s, "f");
if (crc32("QGhxCV",6) == 2965469048) strcat(s, "E");
if (crc32("jBjuTnBSESf",11) == 867676473) strcat(s, "e");
if (crc32("adUYH",5) == 2940013136) strcat(s, "r");
    return s;
}

char *toning_verbs() {
    char *s = calloc(7);
    if (crc32("sBUfcmOul",9) == 2441825287) strcat(s, "t");
if (crc32("ljoRnGaiYUY",11) == 717941627) strcat(s, "W");
if (crc32("DpqxoRgOIYqYzcW",15) == 3832612199) strcat(s, "o");
if (crc32("WETXVbvK",8) == 2256927449) strcat(s, "R");
if (crc32("XrSZR",5) == 2763788015) strcat(s, "n");
if (crc32("nPmRbIS",7) == 3009564058) strcat(s, "u");
if (crc32("GgukBxePShfPkwl",15) == 4065792582) strcat(s, "i");
if (crc32("TJSUVn",6) == 1973167907) strcat(s, "B");
if (crc32("DehlQrTmrujR",12) == 2364144816) strcat(s, "n");
if (crc32("GNDBIOY",7) == 1940257579) strcat(s, "Z");
if (crc32("LWCRuZ",6) == 2080653371) strcat(s, "g");
    return s;
}

char *backlit_verbs() {
    char *s = calloc(8);
    if (crc32("awMptVxcNEoX",12) == 2180176952) strcat(s, "s");
if (crc32("QLMQKJ",6) == 1788294558) strcat(s, "b");
if (crc32("UCIcRkDnuMQ",11) == 1633169032) strcat(s, "T");
if (crc32("ufXIQmDefFoKdg",14) == 3445821606) strcat(s, "a");
if (crc32("dfCOmOLGyh",10) == 1994682565) strcat(s, "c");
if (crc32("OtpmpXKUb",9) == 2028898171) strcat(s, "k");
if (crc32("OOZgZQAYM",9) == 1529188889) strcat(s, "N");
if (crc32("kFzHbdn",7) == 3235273502) strcat(s, "l");
if (crc32("eFymJhdyrjbWou",14) == 180490115) strcat(s, "i");
if (crc32("TLCmf",5) == 3693976461) strcat(s, "t");
    return s;
}

char *exsanguinating_verbs() {
    char *s = calloc(15);
    if (crc32("Yrvrbef",7) == 761783913) strcat(s, "e");
if (crc32("IfsiKuofC",9) == 2633823498) strcat(s, "x");
if (crc32("uiTDhs",6) == 2059984576) strcat(s, "g");
if (crc32("OMlfpxEloIh",11) == 570645095) strcat(s, "s");
if (crc32("QtvsZLPBCGO",11) == 1371877135) strcat(s, "a");
if (crc32("bOjipIgFH",9) == 3171920997) strcat(s, "R");
if (crc32("NQEXNjp",7) == 1697884327) strcat(s, "n");
if (crc32("TsCenc",6) == 2098494281) strcat(s, "m");
if (crc32("cSIIkpqRJ",9) == 1876968731) strcat(s, "g");
if (crc32("EcjHldMx",8) == 1523226925) strcat(s, "u");
if (crc32("JSoItaXNWKIpmm",14) == 2678232848) strcat(s, "d");
if (crc32("ALkQUvfEmQ",10) == 746960194) strcat(s, "i");
if (crc32("rPSeXRTUvSbCOp",14) == 2305780376) strcat(s, "n");
if (crc32("TCypPlJxMJDT",12) == 1397674722) strcat(s, "M");
if (crc32("ICWCaYI",7) == 3956133152) strcat(s, "a");
if (crc32("boVbFAJhEcJM",12) == 1419833054) strcat(s, "t");
if (crc32("PHOArLsaYXXHb",13) == 1674240233) strcat(s, "D");
if (crc32("fCltUkpOvOi",11) == 246330135) strcat(s, "i");
if (crc32("CmiGiZTEfKHeLYH",15) == 3003108677) strcat(s, "n");
if (crc32("azHPUGYYbHGP",12) == 3096109319) strcat(s, "P");
if (crc32("mvqIl",5) == 3646447865) strcat(s, "g");
    return s;
}

char *misqualifying_verbs() {
    char *s = calloc(14);
    if (crc32("LUYRnDki",8) == 3852661932) strcat(s, "d");
if (crc32("yuUwgYmFGAkPc",13) == 829561647) strcat(s, "m");
if (crc32("DQGAC",5) == 2902432955) strcat(s, "i");
if (crc32("GedrqyjJg",9) == 3009882984) strcat(s, "i");
if (crc32("suPCeZaV",8) == 1741909406) strcat(s, "L");
if (crc32("hpXDRDrDedAZ",12) == 4012920620) strcat(s, "s");
if (crc32("YHTvaadxqomwkEC",15) == 2356666071) strcat(s, "q");
if (crc32("VcOdeGDFFGwo",12) == 597641944) strcat(s, "u");
if (crc32("MyqQfPpOw",9) == 933714983) strcat(s, "G");
if (crc32("xpAoJdAsW",9) == 1019088536) strcat(s, "a");
if (crc32("LkTJPyUG",8) == 1450788656) strcat(s, "I");
if (crc32("tKlHxx",6) == 3088259359) strcat(s, "l");
if (crc32("DjGYtgSuKOzw",12) == 3552762331) strcat(s, "Z");
if (crc32("WVwFBlHFfyBqRZ",14) == 3841199299) strcat(s, "i");
if (crc32("MdNLOTpwGYmMLb",14) == 1073886303) strcat(s, "f");
if (crc32("SXDHVtYz",8) == 1449738119) strcat(s, "D");
if (crc32("bbVLTmTTiE",10) == 1057059360) strcat(s, "y");
if (crc32("ELJiTyTZz",9) == 2958917479) strcat(s, "e");
if (crc32("FcJAFWutolvPm",13) == 1737578372) strcat(s, "i");
if (crc32("fgOrhaa",7) == 212387764) strcat(s, "q");
if (crc32("chPaVsMTlzfqo",13) == 3136286977) strcat(s, "n");
if (crc32("IGmISqVeInQdXm",14) == 1765117149) strcat(s, "g");
    return s;
}

char *requalify_verbs() {
    char *s = calloc(10);
    if (crc32("FObMJUjHjPRJ",12) == 889946181) strcat(s, "r");
if (crc32("TPaRoPbPyvIdVf",14) == 760946138) strcat(s, "e");
if (crc32("mTxfdAWmrwPHwIg",15) == 2043270851) strcat(s, "m");
if (crc32("AYbNKC",6) == 1471597686) strcat(s, "q");
if (crc32("esHtbEU",7) == 2564220517) strcat(s, "u");
if (crc32("bAhRLZhwAehVrRc",15) == 940077963) strcat(s, "d");
if (crc32("PHdDmokQ",8) == 1767167161) strcat(s, "a");
if (crc32("GCOlth",6) == 910988889) strcat(s, "l");
if (crc32("dbhUFeNotJDTK",13) == 3638133335) strcat(s, "i");
if (crc32("pWawDqx",7) == 1286623012) strcat(s, "c");
if (crc32("sBirlJgYPEaSQ",13) == 983280728) strcat(s, "f");
if (crc32("pkkOMKFizypNf",13) == 2558608037) strcat(s, "y");
    return s;
}

char *equipoised_verbs() {
    char *s = calloc(11);
    if (crc32("MFOuqtndLPqNT",13) == 3476960521) strcat(s, "O");
if (crc32("zzNPiiG",7) == 1216504644) strcat(s, "e");
if (crc32("TpOSC",5) == 2088543367) strcat(s, "O");
if (crc32("cbzpfLUHA",9) == 3333403029) strcat(s, "q");
if (crc32("KZcNe",5) == 3447782419) strcat(s, "m");
if (crc32("VENLrhkXZoFJQ",13) == 3378478705) strcat(s, "u");
if (crc32("SpOeUAIHqoOBh",13) == 1602084879) strcat(s, "i");
if (crc32("tYpNXgimGTM",11) == 508563267) strcat(s, "h");
if (crc32("NTAwkVQ",7) == 959696150) strcat(s, "p");
if (crc32("eYegTxvVayG",11) == 881916895) strcat(s, "o");
if (crc32("ARsbq",5) == 3838566219) strcat(s, "i");
if (crc32("UJCNzlHMFjvftgu",15) == 348620078) strcat(s, "V");
if (crc32("gReQUCztxaNTeF",14) == 289525554) strcat(s, "s");
if (crc32("iSlphfcM",8) == 3391804682) strcat(s, "e");
if (crc32("AxypYVcNVGVx",12) == 609125530) strcat(s, "d");
    return s;
}

char *incrust_verbs() {
    char *s = calloc(8);
    if (crc32("GBRUcXHh",8) == 346984968) strcat(s, "i");
if (crc32("RsehHf",6) == 1025170307) strcat(s, "b");
if (crc32("PxijxJUnuwlRH",13) == 256679557) strcat(s, "n");
if (crc32("VdJIgdm",7) == 3310974723) strcat(s, "c");
if (crc32("kUdPMXpJPghN",12) == 2611563102) strcat(s, "B");
if (crc32("ogfSmSmrVSnx",12) == 2219649522) strcat(s, "r");
if (crc32("SIPel",5) == 1874839952) strcat(s, "u");
if (crc32("BhGPpBUdXB",10) == 3999257456) strcat(s, "s");
if (crc32("ZLZRubvDXtLl",12) == 1312921741) strcat(s, "t");
    return s;
}

char *circumambulate_verbs() {
    char *s = calloc(15);
    if (crc32("nucDpaIXUMKN",12) == 732985477) strcat(s, "c");
if (crc32("UaEvdI",6) == 3153366368) strcat(s, "i");
if (crc32("qxmTpeIZseg",11) == 1323457382) strcat(s, "X");
if (crc32("BpbHUhTqKfqZyvl",15) == 494807906) strcat(s, "r");
if (crc32("IWWmBZrR",8) == 2890083307) strcat(s, "n");
if (crc32("xVrodMSHseJ",11) == 2045442297) strcat(s, "c");
if (crc32("jTjWNIfHJiaYTF",14) == 2404653211) strcat(s, "M");
if (crc32("DCYZWjxeSsh",11) == 3242883981) strcat(s, "u");
if (crc32("wOxBUoWvvKm",11) == 3476424225) strcat(s, "m");
if (crc32("PuIhbWFPDLLlbe",14) == 3932613119) strcat(s, "a");
if (crc32("LpdPMYzGKzw",11) == 3384237724) strcat(s, "m");
if (crc32("JPMlFd",6) == 3814569988) strcat(s, "b");
if (crc32("TvVxhRxVBAJQyU",14) == 1283540485) strcat(s, "m");
if (crc32("QPKOYmfwVG",10) == 3345781) strcat(s, "u");
if (crc32("jFMtkDBIlCsPL",13) == 3370098179) strcat(s, "l");
if (crc32("aLCnyVGE",8) == 686249774) strcat(s, "w");
if (crc32("TBeTFoL",7) == 4106441428) strcat(s, "a");
if (crc32("vOHXUD",6) == 3896962272) strcat(s, "c");
if (crc32("pCmjQQyzZ",9) == 2168121241) strcat(s, "t");
if (crc32("wxddiz",6) == 546931289) strcat(s, "a");
if (crc32("WnsvTEg",7) == 2360068837) strcat(s, "e");
    return s;
}

char *payfor_verbs() {
    char *s = calloc(7);
    if (crc32("NHZAsxKCJAzzx",13) == 664601543) strcat(s, "I");
if (crc32("TlEtXjwKpaw",11) == 2363530416) strcat(s, "p");
if (crc32("ZuiwEitZbZHjfRY",15) == 2146306007) strcat(s, "C");
if (crc32("dpEOqaIIqwr",11) == 2826276974) strcat(s, "a");
if (crc32("vcdtVQT",7) == 3016493607) strcat(s, "y");
if (crc32("ufQMqo",6) == 1288724094) strcat(s, "P");
if (crc32("NIeSctuy",8) == 2933311652) strcat(s, "f");
if (crc32("jsnVFLnTB",9) == 2121414629) strcat(s, "U");
if (crc32("CAXCUlWjdpHW",12) == 3639679472) strcat(s, "o");
if (crc32("cBDKoBiutZiI",12) == 775452736) strcat(s, "U");
if (crc32("TBPzmBNoyECpcz",14) == 415348157) strcat(s, "r");
    return s;
}

char *graven_verbs() {
    char *s = calloc(7);
    if (crc32("fhrRJz",6) == 3529890828) strcat(s, "g");
if (crc32("TsBBx",5) == 2645826627) strcat(s, "r");
if (crc32("bQmKPvov",8) == 695555921) strcat(s, "a");
if (crc32("CgLpwV",6) == 930181073) strcat(s, "G");
if (crc32("GKbTD",5) == 2228334319) strcat(s, "v");
if (crc32("RHqPCQCgtd",10) == 822364889) strcat(s, "e");
if (crc32("IkNhUtRCjSHsrbz",15) == 3368877207) strcat(s, "n");
    return s;
}

char *consecrating_verbs() {
    char *s = calloc(13);
    if (crc32("SFffF",5) == 3180490125) strcat(s, "I");
if (crc32("BOLHtOA",7) == 1452745805) strcat(s, "c");
if (crc32("mfNBqcYqCtmTdDz",15) == 2520672869) strcat(s, "o");
if (crc32("ryHICn",6) == 1398741459) strcat(s, "n");
if (crc32("gWdBeXeNPXdid",13) == 132067791) strcat(s, "J");
if (crc32("LIaYjtFTQuxm",12) == 3147654977) strcat(s, "s");
if (crc32("wWxkXVI",7) == 2849875072) strcat(s, "t");
if (crc32("iBCtwd",6) == 1290963255) strcat(s, "e");
if (crc32("zbozLwQQW",9) == 2520197408) strcat(s, "c");
if (crc32("smiEJVE",7) == 1530196900) strcat(s, "r");
if (crc32("ttOKj",5) == 1900197327) strcat(s, "G");
if (crc32("APdKNjXDG",9) == 3455758848) strcat(s, "a");
if (crc32("kmrCy",5) == 2319982389) strcat(s, "f");
if (crc32("IJIbT",5) == 602824699) strcat(s, "t");
if (crc32("wFXDhgDQVlGQm",13) == 727133622) strcat(s, "i");
if (crc32("vBGXPiywifHfxUC",15) == 2441718036) strcat(s, "u");
if (crc32("ZXrnSOerkM",10) == 882556227) strcat(s, "n");
if (crc32("IJIEqxYcCjOnFq",14) == 1179208902) strcat(s, "O");
if (crc32("JwmpDGRDMGdHUhx",15) == 4018835270) strcat(s, "g");
    return s;
}

char *withdraw_verbs() {
    char *s = calloc(9);
    if (crc32("kQUNVZjL",8) == 2734214824) strcat(s, "T");
if (crc32("JJlbDTzeSxJMpA",14) == 1564576647) strcat(s, "w");
if (crc32("eMbjZEVPynQEcxV",15) == 2278019527) strcat(s, "i");
if (crc32("eXqFdb",6) == 1414756504) strcat(s, "i");
if (crc32("yfpEyPnL",8) == 1542814913) strcat(s, "t");
if (crc32("coinQcejRDter",13) == 1614211603) strcat(s, "H");
if (crc32("oBUTISraPTvf",12) == 1693418310) strcat(s, "h");
if (crc32("HbnNMeEWlqxdma",14) == 3256977492) strcat(s, "d");
if (crc32("xVdYwYzrz",9) == 2192266262) strcat(s, "K");
if (crc32("dYldRuCQqYStA",13) == 3201212634) strcat(s, "r");
if (crc32("QgTYPJYk",8) == 398123128) strcat(s, "a");
if (crc32("tJWsWGooKbS",11) == 1314744580) strcat(s, "K");
if (crc32("hInbQk",6) == 3924581655) strcat(s, "w");
    return s;
}

char *materialized_verbs() {
    char *s = calloc(13);
    if (crc32("SlxOx",5) == 3149699473) strcat(s, "m");
if (crc32("IvSidNiXaBGSHLI",15) == 952394546) strcat(s, "g");
if (crc32("iLldFFPBF",9) == 4010332852) strcat(s, "a");
if (crc32("AnKKgfUVjriGI",13) == 1560898639) strcat(s, "t");
if (crc32("dxlPQb",6) == 4132785547) strcat(s, "e");
if (crc32("HaZORlLXS",9) == 3137449265) strcat(s, "S");
if (crc32("mitGaFZGrSMZhGf",15) == 454524253) strcat(s, "r");
if (crc32("GeZxUNoHcgCGf",13) == 2340750943) strcat(s, "i");
if (crc32("eZQzLxpSj",9) == 1082662997) strcat(s, "a");
if (crc32("avVHzHJQ",8) == 679360594) strcat(s, "l");
if (crc32("DwtQpFOtC",9) == 2231005261) strcat(s, "i");
if (crc32("ckUWs",5) == 2916184543) strcat(s, "T");
if (crc32("tJCyq",5) == 2516236743) strcat(s, "z");
if (crc32("FhjtdPbQpWB",11) == 2901417216) strcat(s, "e");
if (crc32("EFmWt",5) == 181600512) strcat(s, "d");
    return s;
}

char *rerose_verbs() {
    char *s = calloc(7);
    if (crc32("yNdkUQWln",9) == 420068572) strcat(s, "d");
if (crc32("yEIgdgfETg",10) == 3631892111) strcat(s, "r");
if (crc32("tWqtDjJIZ",9) == 3773384126) strcat(s, "e");
if (crc32("YekhzPC",7) == 1868616891) strcat(s, "r");
if (crc32("VsiKcVGqcMHjOgk",15) == 3807754166) strcat(s, "J");
if (crc32("YECYr",5) == 4165285692) strcat(s, "o");
if (crc32("sQtyMRa",7) == 1461786376) strcat(s, "s");
if (crc32("LyNZyz",6) == 1767323647) strcat(s, "e");
    return s;
}

char *overcondensed_verbs() {
    char *s = calloc(14);
    if (crc32("WnuYgwMxvoPH",12) == 3118687027) strcat(s, "o");
if (crc32("BWQSwLNRm",9) == 495715337) strcat(s, "v");
if (crc32("pcuVBh",6) == 840607989) strcat(s, "M");
if (crc32("WMvYUYv",7) == 2955385597) strcat(s, "e");
if (crc32("GLTqVLsHRPC",11) == 243708390) strcat(s, "H");
if (crc32("duIya",5) == 1299337984) strcat(s, "r");
if (crc32("dZZWsuQkIv",10) == 3976479536) strcat(s, "c");
if (crc32("uJdZvSKOPyIeWk",14) == 2148152708) strcat(s, "o");
if (crc32("WfmQuyAAd",9) == 2866914004) strcat(s, "C");
if (crc32("pnwEEtkqULE",11) == 618166440) strcat(s, "n");
if (crc32("VOaQSwwXhYCSeIt",15) == 1566715632) strcat(s, "S");
if (crc32("pdmYZDyOmr",10) == 3928019265) strcat(s, "d");
if (crc32("bEVeQwwUtaf",11) == 763660000) strcat(s, "e");
if (crc32("mxtVHtXdBsuFVor",15) == 3339386470) strcat(s, "J");
if (crc32("UHWanp",6) == 834046582) strcat(s, "n");
if (crc32("uQUOknM",7) == 1627106485) strcat(s, "s");
if (crc32("FtaTznxvdESi",12) == 3959181837) strcat(s, "e");
if (crc32("UhTJmDXxok",10) == 3750337383) strcat(s, "p");
if (crc32("agjzFTcdcXmULQ",14) == 2501818019) strcat(s, "d");
    return s;
}

char *dwell_verbs() {
    char *s = calloc(6);
    if (crc32("EylRExQnuMSx",12) == 3274508324) strcat(s, "d");
if (crc32("smRSiaDWccPMWaj",15) == 3454445459) strcat(s, "d");
if (crc32("oIhcB",5) == 2879029878) strcat(s, "w");
if (crc32("FKgGOntONP",10) == 896393154) strcat(s, "e");
if (crc32("jGbVUgUnxjjgV",13) == 1987265978) strcat(s, "X");
if (crc32("wVSDOlSPBFX",11) == 668641748) strcat(s, "l");
if (crc32("ZDtKHXqhwwhqfca",15) == 340764319) strcat(s, "D");
if (crc32("yrqdOZWSqrsqH",13) == 2842787440) strcat(s, "l");
    return s;
}

char *misusing_verbs() {
    char *s = calloc(9);
    if (crc32("snPnTiISAYBnX",13) == 2737286630) strcat(s, "f");
if (crc32("cnTftuAQyxRJZBC",15) == 2805874951) strcat(s, "m");
if (crc32("GnadOJd",7) == 94833721) strcat(s, "i");
if (crc32("ReOPEoNxIvCiLJ",14) == 2083899181) strcat(s, "s");
if (crc32("CxPIcpOZTsCrVXq",15) == 847867720) strcat(s, "u");
if (crc32("UuxNhpkbv",9) == 3103465422) strcat(s, "s");
if (crc32("rOaXMTnmn",9) == 1902535196) strcat(s, "N");
if (crc32("CuqNR",5) == 993842462) strcat(s, "i");
if (crc32("GRTqekvcTbU",11) == 2777846250) strcat(s, "n");
if (crc32("HdamJpjo",8) == 2699963945) strcat(s, "g");
    return s;
}

char *repremise_verbs() {
    char *s = calloc(10);
    if (crc32("rakPZBYiLHHTGkn",15) == 1013927799) strcat(s, "J");
if (crc32("gAXBYG",6) == 1069982581) strcat(s, "r");
if (crc32("nJcdtSjKx",9) == 2171625858) strcat(s, "z");
if (crc32("pWFjJ",5) == 338098712) strcat(s, "e");
if (crc32("mtttaqQxjxVcFJ",14) == 2457877673) strcat(s, "p");
if (crc32("OqhEaAne",8) == 1373348838) strcat(s, "o");
if (crc32("TzWhlRjJ",8) == 1397502005) strcat(s, "r");
if (crc32("LJUre",5) == 3845036276) strcat(s, "e");
if (crc32("mslxmcRrgZFwUv",14) == 1703579399) strcat(s, "X");
if (crc32("XfFbASZg",8) == 4020530445) strcat(s, "m");
if (crc32("VFhRL",5) == 3477440817) strcat(s, "E");
if (crc32("pbVWVQ",6) == 772438964) strcat(s, "i");
if (crc32("eXYVNydLktUmT",13) == 4019714967) strcat(s, "s");
if (crc32("OLGnJDaKO",9) == 3494465745) strcat(s, "q");
if (crc32("SCDkyTj",7) == 1868143060) strcat(s, "e");
    return s;
}

char *pay_verbs() {
    char *s = calloc(4);
    if (crc32("IFVtWRpnzEjtF",13) == 251166050) strcat(s, "a");
if (crc32("XpiIRwY",7) == 3921382235) strcat(s, "p");
if (crc32("atJVWzBTBbdnDJW",15) == 3008266208) strcat(s, "a");
if (crc32("CxAHeZkeNQOqZm",14) == 2215391472) strcat(s, "U");
if (crc32("CcFXgTKTzaryIA",14) == 1225580984) strcat(s, "y");
    return s;
}

char *misprize_verbs() {
    char *s = calloc(9);
    if (crc32("HIGTyYjisTNPk",13) == 4230624389) strcat(s, "m");
if (crc32("Iqzcmb",6) == 444901588) strcat(s, "s");
if (crc32("smdzBAtuTiMKvXI",15) == 1950924536) strcat(s, "i");
if (crc32("niyKqqKeLBG",11) == 1952904411) strcat(s, "v");
if (crc32("xzOWGTcmARlSOM",14) == 2597870393) strcat(s, "s");
if (crc32("KKcmRoffPH",10) == 1500557991) strcat(s, "U");
if (crc32("EPZnZ",5) == 2362931747) strcat(s, "p");
if (crc32("IupSf",5) == 2929082145) strcat(s, "r");
if (crc32("NCTFLIe",7) == 379310669) strcat(s, "i");
if (crc32("QZftl",5) == 619501747) strcat(s, "z");
if (crc32("muxrgGVT",8) == 2805764684) strcat(s, "e");
    return s;
}

char *requicken_verbs() {
    char *s = calloc(10);
    if (crc32("OBeeCETthhUIQ",13) == 2862118629) strcat(s, "A");
if (crc32("KcMSHK",6) == 3571784589) strcat(s, "r");
if (crc32("hpVNRdep",8) == 2625918841) strcat(s, "w");
if (crc32("nLCWvlYDoFMj",12) == 1516491860) strcat(s, "e");
if (crc32("DgHuLbaHsQ",10) == 1995762790) strcat(s, "q");
if (crc32("DwTyXqxkkxoUXx",14) == 3241903151) strcat(s, "u");
if (crc32("LlJyhLg",7) == 2891697862) strcat(s, "i");
if (crc32("WReLNSGgebOzrtx",15) == 2292969271) strcat(s, "w");
if (crc32("SwjlWaYhQ",9) == 2151627601) strcat(s, "c");
if (crc32("sjSvsJ",6) == 4096362293) strcat(s, "k");
if (crc32("ZUfarUJ",7) == 1597624672) strcat(s, "u");
if (crc32("BsOaPDSpKyIRxr",14) == 3921722739) strcat(s, "e");
if (crc32("cVjDcHFtM",9) == 2441006962) strcat(s, "g");
if (crc32("OGDwA",5) == 208986922) strcat(s, "n");
    return s;
}

char *clutter_verbs() {
    char *s = calloc(8);
    if (crc32("emAHt",5) == 1722280046) strcat(s, "A");
if (crc32("wpSvqh",6) == 2730387814) strcat(s, "c");
if (crc32("tmDtiOgPxtj",11) == 384354832) strcat(s, "l");
if (crc32("kBRAETHiMA",10) == 3107349554) strcat(s, "D");
if (crc32("eSsgXP",6) == 3142835758) strcat(s, "u");
if (crc32("JYCjFFl",7) == 2339286282) strcat(s, "t");
if (crc32("MHBWhwsZLrlZkQ",14) == 3474316826) strcat(s, "t");
if (crc32("ETfQtMGGafS",11) == 1947327439) strcat(s, "H");
if (crc32("XIdpb",5) == 3942678238) strcat(s, "e");
if (crc32("gVwFTHatJNFU",12) == 1425324378) strcat(s, "r");
    return s;
}

char *cleanup_verbs() {
    char *s = calloc(8);
    if (crc32("wylWw",5) == 3786488220) strcat(s, "c");
if (crc32("YJqdSNxrcgTb",12) == 1196162995) strcat(s, "K");
if (crc32("dfWCij",6) == 160117288) strcat(s, "l");
if (crc32("ueKawiiIMIz",11) == 244940247) strcat(s, "e");
if (crc32("mUcQQOCFAwJCNtY",15) == 1285134989) strcat(s, "a");
if (crc32("EyzdY",5) == 172385607) strcat(s, "n");
if (crc32("sdedZCZ",7) == 3337964407) strcat(s, "l");
if (crc32("RQxjmJEy",8) == 3555097729) strcat(s, "u");
if (crc32("szhdCuqi",8) == 1579243238) strcat(s, "p");
    return s;
}

char *misadjust_verbs() {
    char *s = calloc(10);
    if (crc32("sldezAK",7) == 244975503) strcat(s, "m");
if (crc32("yvJzELcc",8) == 184923530) strcat(s, "i");
if (crc32("XntQyPGjcm",10) == 1514017188) strcat(s, "s");
if (crc32("ayVdCkrVJMm",11) == 3558184940) strcat(s, "a");
if (crc32("ZKRZwM",6) == 1539857721) strcat(s, "d");
if (crc32("VPCeMnyIMvDeakK",15) == 2115487415) strcat(s, "S");
if (crc32("QuEUYtb",7) == 2757959711) strcat(s, "j");
if (crc32("PzTPrWMFFe",10) == 2279669801) strcat(s, "u");
if (crc32("jphmPYCMprlnY",13) == 3210889627) strcat(s, "s");
if (crc32("YgkQJNiAeDt",11) == 4080532677) strcat(s, "t");
    return s;
}

char *effeminated_verbs() {
    char *s = calloc(12);
    if (crc32("qaXuKCEPVkM",11) == 901739410) strcat(s, "e");
if (crc32("PkDbnk",6) == 954552826) strcat(s, "H");
if (crc32("LMXiVz",6) == 2092253790) strcat(s, "f");
if (crc32("HJcLjdrSWhUvv",13) == 3452598519) strcat(s, "f");
if (crc32("xWwsFyzJpubV",12) == 3796365854) strcat(s, "F");
if (crc32("DgiqWAzEDBOyxov",15) == 1398883532) strcat(s, "e");
if (crc32("KalQjj",6) == 1593049766) strcat(s, "m");
if (crc32("CqWDdgz",7) == 3819607411) strcat(s, "a");
if (crc32("XnjvKanKOAgL",12) == 2775496858) strcat(s, "i");
if (crc32("NqvazhKevgbEZ",13) == 2107092) strcat(s, "G");
if (crc32("pMxsHlvbo",9) == 902486873) strcat(s, "n");
if (crc32("kSmGMtb",7) == 3757055409) strcat(s, "u");
if (crc32("svWrDlLJux",10) == 822845047) strcat(s, "a");
if (crc32("TzVliY",6) == 2603264005) strcat(s, "p");
if (crc32("EtRdhFfNEkpbHRW",15) == 3938802320) strcat(s, "t");
if (crc32("ZpvFmfNLc",9) == 4641365) strcat(s, "h");
if (crc32("CKSgVbU",7) == 1890176712) strcat(s, "e");
if (crc32("vjvSDx",6) == 1432239157) strcat(s, "d");
    return s;
}

char *disposing_verbs() {
    char *s = calloc(10);
    if (crc32("RJJhJOzsmGgYg",13) == 2799184687) strcat(s, "d");
if (crc32("HaHIjhzGE",9) == 1774571271) strcat(s, "E");
if (crc32("criEYAX",7) == 3062835778) strcat(s, "i");
if (crc32("nexsozBFMxvy",12) == 5631075) strcat(s, "s");
if (crc32("ZKlnGehfVnm",11) == 640434337) strcat(s, "p");
if (crc32("obHevWiYmC",10) == 3089024929) strcat(s, "b");
if (crc32("vdWhIJyoRNBfB",13) == 113867543) strcat(s, "o");
if (crc32("fsXpPPD",7) == 1012271925) strcat(s, "s");
if (crc32("YXXrtfNXKNe",11) == 3847597333) strcat(s, "i");
if (crc32("FPrlwYRgAOfOOtm",15) == 1102964035) strcat(s, "I");
if (crc32("MSYagcKxBEnlax",14) == 874120170) strcat(s, "n");
if (crc32("EYAzN",5) == 83343408) strcat(s, "X");
if (crc32("mnhEoxwoRCI",11) == 2960901667) strcat(s, "g");
    return s;
}

char *rewash_verbs() {
    char *s = calloc(7);
    if (crc32("ULGroIwnO",9) == 3596989406) strcat(s, "r");
if (crc32("lulsPeSWiJ",10) == 125855107) strcat(s, "e");
if (crc32("IEXlTZIVhGmO",12) == 355364327) strcat(s, "w");
if (crc32("tpzNiEKY",8) == 3043287873) strcat(s, "Z");
if (crc32("fslQbWjFVq",10) == 3504034881) strcat(s, "a");
if (crc32("kIRhyV",6) == 121172431) strcat(s, "c");
if (crc32("UlZPgoap",8) == 1752008829) strcat(s, "s");
if (crc32("ZxXsxOc",7) == 3616480045) strcat(s, "e");
if (crc32("gyLLpc",6) == 53987018) strcat(s, "h");
    return s;
}

char *outgrown_verbs() {
    char *s = calloc(9);
    if (crc32("yQrRkcwkGrKtRcw",15) == 2764491494) strcat(s, "o");
if (crc32("rfxpSOyoacs",11) == 1130776889) strcat(s, "u");
if (crc32("QGBwAjM",7) == 1722101642) strcat(s, "o");
if (crc32("xMuLmOgsU",9) == 696139448) strcat(s, "t");
if (crc32("JfSkl",5) == 3062541833) strcat(s, "A");
if (crc32("upxWwnAZTu",10) == 378586603) strcat(s, "g");
if (crc32("ujjxarzljnAyNnC",15) == 2059080143) strcat(s, "A");
if (crc32("JoRgXFReiidkH",13) == 1751040622) strcat(s, "r");
if (crc32("cbutbvaY",8) == 3754977116) strcat(s, "o");
if (crc32("MtxVqkpctX",10) == 35283279) strcat(s, "R");
if (crc32("NMEdsElukkIoOo",14) == 3660591358) strcat(s, "w");
if (crc32("kXniRsJCSJTc",12) == 1947468617) strcat(s, "e");
if (crc32("UFfQBGQvBJc",11) == 1625437543) strcat(s, "n");
    return s;
}

char *accommodated_verbs() {
    char *s = calloc(13);
    if (crc32("MVhXLQDNtoI",11) == 2406843340) strcat(s, "a");
if (crc32("pRIHwBxMSE",10) == 3063322995) strcat(s, "r");
if (crc32("frtLnB",6) == 302832561) strcat(s, "c");
if (crc32("YNcMAz",6) == 1718326753) strcat(s, "I");
if (crc32("INFTCZF",7) == 1195823926) strcat(s, "c");
if (crc32("XNurJclSBJrqKia",15) == 3271687007) strcat(s, "o");
if (crc32("Gzqogh",6) == 3006411303) strcat(s, "P");
if (crc32("BCizwywQ",8) == 909809224) strcat(s, "m");
if (crc32("sSoYkPysqagX",12) == 2808381530) strcat(s, "p");
if (crc32("osttQJMsTtjgdw",14) == 1521958109) strcat(s, "m");
if (crc32("utuNuMFLqH",10) == 3698448249) strcat(s, "o");
if (crc32("SQwONsKSKLL",11) == 2861511528) strcat(s, "J");
if (crc32("WvyZJLh",7) == 2495572630) strcat(s, "d");
if (crc32("cfkBYJEgZ",9) == 1220259017) strcat(s, "a");
if (crc32("joxkZyTLIAGn",12) == 1950882415) strcat(s, "t");
if (crc32("ZcyjrPYEuUtq",12) == 1548584188) strcat(s, "q");
if (crc32("SmEqoCgbFyEFI",13) == 2186174706) strcat(s, "e");
if (crc32("JCtzvofxEqA",11) == 1916931832) strcat(s, "G");
if (crc32("vRQNt",5) == 2237183602) strcat(s, "d");
    return s;
}

char *disbud_verbs() {
    char *s = calloc(7);
    if (crc32("rNqJLWI",7) == 808601192) strcat(s, "l");
if (crc32("mEADouiIjbh",11) == 3920064808) strcat(s, "d");
if (crc32("GqMkQFejwWExy",13) == 465705005) strcat(s, "i");
if (crc32("atNquUEiQ",9) == 849721204) strcat(s, "t");
if (crc32("GNHatNFp",8) == 2104017659) strcat(s, "s");
if (crc32("XvodCxM",7) == 1650256880) strcat(s, "b");
if (crc32("NUXcwVAWm",9) == 1491996515) strcat(s, "S");
if (crc32("dYYzHK",6) == 560574958) strcat(s, "u");
if (crc32("aoUbJu",6) == 4101070626) strcat(s, "d");
    return s;
}

char *modulating_verbs() {
    char *s = calloc(11);
    if (crc32("kqDDlAPzjyWREh",14) == 2515284116) strcat(s, "m");
if (crc32("EkzksYHKOMHNYr",14) == 2421411446) strcat(s, "o");
if (crc32("ylWqOvZMzVyN",12) == 3648974395) strcat(s, "Y");
if (crc32("wLtdpv",6) == 121426010) strcat(s, "d");
if (crc32("lNtCBivgbnW",11) == 30933126) strcat(s, "m");
if (crc32("myfhiAJwCyPy",12) == 4195315772) strcat(s, "u");
if (crc32("YsfYpYGpraRRs",13) == 3243071364) strcat(s, "X");
if (crc32("sETQDLanP",9) == 4221804039) strcat(s, "l");
if (crc32("oUsIUCwTAKJEcGH",15) == 3312664398) strcat(s, "f");
if (crc32("YOObrlp",7) == 1352389146) strcat(s, "a");
if (crc32("YluJOW",6) == 2692477260) strcat(s, "C");
if (crc32("xxDoLBZsCyHQKv",14) == 2441933013) strcat(s, "t");
if (crc32("hLyNG",5) == 1673578867) strcat(s, "i");
if (crc32("PaaDUnixQqHI",12) == 2629471225) strcat(s, "m");
if (crc32("zuEEGHJ",7) == 1765688729) strcat(s, "n");
if (crc32("nphxRQADeCUCYtR",15) == 1916171312) strcat(s, "g");
    return s;
}

char *revalue_verbs() {
    char *s = calloc(8);
    if (crc32("zSchLEVl",8) == 1658560364) strcat(s, "r");
if (crc32("rqAEZXX",7) == 3062391145) strcat(s, "c");
if (crc32("wssFqkxF",8) == 2875894707) strcat(s, "e");
if (crc32("rNcjloOr",8) == 598509298) strcat(s, "q");
if (crc32("HZKGGnzsbbBXQYN",15) == 2899387151) strcat(s, "v");
if (crc32("BaXxITy",7) == 2751302703) strcat(s, "a");
if (crc32("GRFgrw",6) == 3250791027) strcat(s, "l");
if (crc32("tAKkVzXYtunqGV",14) == 2199223130) strcat(s, "u");
if (crc32("GAsSnIwEQH",10) == 2071638094) strcat(s, "u");
if (crc32("gMNRLhsBjyRA",12) == 152560365) strcat(s, "e");
    return s;
}

char *arousing_verbs() {
    char *s = calloc(9);
    if (crc32("FnMMkas",7) == 4041485482) strcat(s, "i");
if (crc32("RFxAvDZK",8) == 1334141534) strcat(s, "a");
if (crc32("jTlrDboq",8) == 2500613812) strcat(s, "H");
if (crc32("lfZjUQj",7) == 1298128301) strcat(s, "r");
if (crc32("oTCqPu",6) == 3946690797) strcat(s, "u");
if (crc32("ZFrzYdOry",9) == 4053282422) strcat(s, "o");
if (crc32("bOeRePzGFxtszM",14) == 813846049) strcat(s, "u");
if (crc32("YzGJNSVaBiTdU",13) == 1653709661) strcat(s, "s");
if (crc32("bglEB",5) == 3610293554) strcat(s, "i");
if (crc32("BkuAh",5) == 4207531420) strcat(s, "K");
if (crc32("nAGCPfUKaeNB",12) == 3280420306) strcat(s, "n");
if (crc32("lvHEEOqJaq",10) == 1937931996) strcat(s, "W");
if (crc32("aUguSYN",7) == 268099835) strcat(s, "g");
    return s;
}

char *fizzled_verbs() {
    char *s = calloc(8);
    if (crc32("ESYBmJBtCgsjmC",14) == 1980526027) strcat(s, "X");
if (crc32("MKIFgPZf",8) == 1083854626) strcat(s, "f");
if (crc32("MvOhSyBCAotKvl",14) == 2452991137) strcat(s, "x");
if (crc32("UndBtEdAmXZtn",13) == 945188804) strcat(s, "i");
if (crc32("vPjrxgEwk",9) == 4205223464) strcat(s, "z");
if (crc32("LVamzP",6) == 52779330) strcat(s, "z");
if (crc32("UvkSHhuNdH",10) == 3045651210) strcat(s, "l");
if (crc32("SKEwa",5) == 3642649838) strcat(s, "e");
if (crc32("uYNMRsgcFLmd",12) == 938659829) strcat(s, "d");
    return s;
}

char *understudying_verbs() {
    char *s = calloc(14);
    if (crc32("qmVvs",5) == 308002548) strcat(s, "X");
if (crc32("dNTmoDma",8) == 758775932) strcat(s, "u");
if (crc32("oilJWWOIL",9) == 2975660314) strcat(s, "n");
if (crc32("opTQWaLn",8) == 3922008988) strcat(s, "C");
if (crc32("REyIJjoWAZfoAF",14) == 2437579197) strcat(s, "d");
if (crc32("JXTnPOw",7) == 1587285773) strcat(s, "e");
if (crc32("kBOWs",5) == 2005039493) strcat(s, "D");
if (crc32("KhybhINbxhUweE",14) == 1473006631) strcat(s, "r");
if (crc32("bLKCinA",7) == 3808301486) strcat(s, "s");
if (crc32("HYwBiuMhqTSiA",13) == 2327225658) strcat(s, "t");
if (crc32("cETbgdjX",8) == 2364217907) strcat(s, "q");
if (crc32("ZUrtyfZqiKpbcO",14) == 2507365417) strcat(s, "u");
if (crc32("ggHpxktAGVtk",12) == 2335189238) strcat(s, "o");
if (crc32("VHOVaGiYK",9) == 441297827) strcat(s, "d");
if (crc32("QvGicgOFMZBt",12) == 2550203453) strcat(s, "v");
if (crc32("Fonmqnqs",8) == 3398483003) strcat(s, "y");
if (crc32("MlzAL",5) == 3638541607) strcat(s, "i");
if (crc32("QgSgHSViaf",10) == 2356153958) strcat(s, "H");
if (crc32("NBTdwYmW",8) == 3252005933) strcat(s, "n");
if (crc32("eJnuSZMOIAqrOxX",15) == 76661908) strcat(s, "g");
    return s;
}

char *pick_verbs() {
    char *s = calloc(5);
    if (crc32("QGgHaOSO",8) == 2413380513) strcat(s, "p");
if (crc32("VKLKMYqXve",10) == 3858625165) strcat(s, "i");
if (crc32("nMrkAouIbF",10) == 1342506019) strcat(s, "i");
if (crc32("MgJcNIKlf",9) == 2299273382) strcat(s, "w");
if (crc32("vmwiaXNZ",8) == 1661499153) strcat(s, "c");
if (crc32("RFaiEXZOsfv",11) == 2151593248) strcat(s, "m");
if (crc32("cSyiUPATYkSuhMD",15) == 2056677257) strcat(s, "k");
    return s;
}

char *reshutting_verbs() {
    char *s = calloc(11);
    if (crc32("bLknRLxlmt",10) == 3918850516) strcat(s, "W");
if (crc32("LbzOOpXAJZUfQHa",15) == 2764953843) strcat(s, "r");
if (crc32("Fprmky",6) == 3220759437) strcat(s, "e");
if (crc32("WXynkIaHBSLfn",13) == 909333948) strcat(s, "s");
if (crc32("WHqTCIDQdjS",11) == 537089572) strcat(s, "h");
if (crc32("PFhkHloTRgRMJ",13) == 2776849795) strcat(s, "v");
if (crc32("lhOynSbAyGSnU",13) == 288278333) strcat(s, "u");
if (crc32("uwVLBsCOVNQ",11) == 398204612) strcat(s, "t");
if (crc32("nIpGFZn",7) == 267008986) strcat(s, "t");
if (crc32("HuDcpuS",7) == 3244047323) strcat(s, "i");
if (crc32("sCXiVOKKhfaJdaq",15) == 253986405) strcat(s, "Q");
if (crc32("prNFWxXyXiITja",14) == 3047352806) strcat(s, "n");
if (crc32("cYRZFwNRX",9) == 1723064635) strcat(s, "g");
    return s;
}

char *cashin_verbs() {
    char *s = calloc(7);
    if (crc32("HnPzBkyKG",9) == 494495549) strcat(s, "V");
if (crc32("IBxzdTJVsq",10) == 2811416414) strcat(s, "c");
if (crc32("AsWwxpjGXDjpAyw",15) == 868318035) strcat(s, "a");
if (crc32("yveDHRWOYYN",11) == 1208645214) strcat(s, "s");
if (crc32("vECbZyMjkl",10) == 1952316612) strcat(s, "V");
if (crc32("vscSzlZIU",9) == 3995622951) strcat(s, "h");
if (crc32("YVOEVhglNVY",11) == 4013414791) strcat(s, "T");
if (crc32("sUXnTN",6) == 3485772759) strcat(s, "i");
if (crc32("CJbjJgQfDgZtD",13) == 1805164369) strcat(s, "v");
if (crc32("Ogyyq",5) == 951003125) strcat(s, "n");
    return s;
}

char *Grecize_verbs() {
    char *s = calloc(8);
    if (crc32("XxSkEcFWc",9) == 3438212225) strcat(s, "G");
if (crc32("admPPZjPdPwbq",13) == 3815911691) strcat(s, "T");
if (crc32("wKlgPUwGGpmn",12) == 3722700219) strcat(s, "r");
if (crc32("ZrXPeaLofRej",12) == 2825303031) strcat(s, "W");
if (crc32("HZKQcNQS",8) == 2051422304) strcat(s, "e");
if (crc32("AEKxvBtNlEd",11) == 842133649) strcat(s, "G");
if (crc32("SdcGvhtA",8) == 3889762875) strcat(s, "c");
if (crc32("SSEoYpRPVdAk",12) == 1741413568) strcat(s, "i");
if (crc32("iweWWFulKL",10) == 584195660) strcat(s, "s");
if (crc32("wotfQE",6) == 2979407125) strcat(s, "z");
if (crc32("pMYoWfyvWwmPFf",14) == 384178833) strcat(s, "e");
    return s;
}

char *pulverized_verbs() {
    char *s = calloc(11);
    if (crc32("TXqtkLHZVmdKb",13) == 3342575585) strcat(s, "p");
if (crc32("OkKwBuY",7) == 3973298504) strcat(s, "z");
if (crc32("ytMoVWOFinIrp",13) == 1612506809) strcat(s, "u");
if (crc32("UzyyBMWTJJt",11) == 3806840478) strcat(s, "l");
if (crc32("sQXayzj",7) == 488473402) strcat(s, "v");
if (crc32("opxqS",5) == 685491724) strcat(s, "v");
if (crc32("sdPuCFL",7) == 485364032) strcat(s, "e");
if (crc32("uDAdCaF",7) == 4154979583) strcat(s, "r");
if (crc32("LTjdsQQkV",9) == 400340884) strcat(s, "i");
if (crc32("LBZWBCPRzxkJggJ",15) == 3210712640) strcat(s, "q");
if (crc32("ftfDOLT",7) == 2897345512) strcat(s, "z");
if (crc32("prfCPHmxQL",10) == 2207820930) strcat(s, "e");
if (crc32("tTQOt",5) == 1255086334) strcat(s, "i");
if (crc32("jOJQGYm",7) == 16334078) strcat(s, "d");
    return s;
}

char *fusillading_verbs() {
    char *s = calloc(12);
    if (crc32("zilluJRZolfbzM",14) == 4054473949) strcat(s, "f");
if (crc32("osVpdFbRa",9) == 663599838) strcat(s, "u");
if (crc32("tKfDCIXJQPcs",12) == 534650379) strcat(s, "L");
if (crc32("WWPaXSa",7) == 412110836) strcat(s, "s");
if (crc32("mSluUfCkcxPAr",13) == 3329637473) strcat(s, "i");
if (crc32("JPDpDJXpnJk",11) == 641601751) strcat(s, "i");
if (crc32("LbdtNJgcDOb",11) == 1357513591) strcat(s, "l");
if (crc32("FLfTxuYFltd",11) == 1622934510) strcat(s, "l");
if (crc32("BZChGixpRhTKtX",14) == 242184713) strcat(s, "a");
if (crc32("jPsvbrHomRrWY",13) == 957100717) strcat(s, "d");
if (crc32("vNJaucUQYZkJ",12) == 3144676781) strcat(s, "Z");
if (crc32("bBTaHme",7) == 517901565) strcat(s, "i");
if (crc32("DWxJUyvRalosv",13) == 900334784) strcat(s, "q");
if (crc32("hAnINdFS",8) == 2199513735) strcat(s, "n");
if (crc32("YwPpGXYNFp",10) == 2870906758) strcat(s, "g");
    return s;
}

char *bayonetting_verbs() {
    char *s = calloc(12);
    if (crc32("jBegZXImqeFw",12) == 1097531449) strcat(s, "F");
if (crc32("opcFGRS",7) == 2221359122) strcat(s, "b");
if (crc32("uiIgwBvRgOScD",13) == 185601724) strcat(s, "a");
if (crc32("oAoVdHhgn",9) == 2102387910) strcat(s, "Y");
if (crc32("QUPZTyhcwfxBeF",14) == 3593118502) strcat(s, "y");
if (crc32("NQejUCeJZUnlT",13) == 2305464272) strcat(s, "o");
if (crc32("lisdpsTYbFcPXAr",15) == 2010524169) strcat(s, "t");
if (crc32("vayCZMmtrE",10) == 423893825) strcat(s, "n");
if (crc32("BVXcOlwkGx",10) == 3041953729) strcat(s, "e");
if (crc32("TcIEXfKnvWczOz",14) == 1328535840) strcat(s, "T");
if (crc32("XVgNmao",7) == 3871107403) strcat(s, "t");
if (crc32("fOxdecxc",8) == 3509188294) strcat(s, "E");
if (crc32("yDkbg",5) == 3859375062) strcat(s, "t");
if (crc32("NwkPsnQa",8) == 2282489282) strcat(s, "i");
if (crc32("KPdJhxtC",8) == 3016797981) strcat(s, "n");
if (crc32("HnmZybMCZzX",11) == 3579297276) strcat(s, "X");
if (crc32("sNaEJQIWmQKbPd",14) == 1847388595) strcat(s, "g");
    return s;
}

char *behooved_verbs() {
    char *s = calloc(9);
    if (crc32("fMbZkGSj",8) == 3303437889) strcat(s, "b");
if (crc32("VxBBoGn",7) == 2140081728) strcat(s, "e");
if (crc32("jXMcvZvhj",9) == 2149980424) strcat(s, "h");
if (crc32("EUmrvKag",8) == 3747695015) strcat(s, "o");
if (crc32("NhPWsNEJbc",10) == 74114273) strcat(s, "s");
if (crc32("uJSgSqCdEGB",11) == 3564426739) strcat(s, "o");
if (crc32("tuqaztKOXYKMGm",14) == 1278505062) strcat(s, "v");
if (crc32("uWzrLcDwgm",10) == 1005708978) strcat(s, "h");
if (crc32("IunUcgGqQPvsIX",14) == 2579047358) strcat(s, "e");
if (crc32("yavBeWsyU",9) == 3743674776) strcat(s, "d");
    return s;
}

char *repromising_verbs() {
    char *s = calloc(12);
    if (crc32("IjinwQJBZzzGZ",13) == 3824003527) strcat(s, "i");
if (crc32("VTgLzeRmwXX",11) == 3499190720) strcat(s, "r");
if (crc32("omafFFLVDD",10) == 4122850076) strcat(s, "n");
if (crc32("orohIxIPtO",10) == 1791247635) strcat(s, "e");
if (crc32("IXOJjQBmSMEW",12) == 237970936) strcat(s, "p");
if (crc32("MHweqGTqN",9) == 1289638493) strcat(s, "r");
if (crc32("BGxTqSIL",8) == 1182538062) strcat(s, "o");
if (crc32("nVbmWaMDGBUXbX",14) == 4007562604) strcat(s, "m");
if (crc32("nSCDBTxqxl",10) == 2809406359) strcat(s, "i");
if (crc32("epHEcnyN",8) == 1713040970) strcat(s, "s");
if (crc32("uaemvMQuzM",10) == 1270230206) strcat(s, "i");
if (crc32("HPWaf",5) == 3563605385) strcat(s, "n");
if (crc32("UcNEsmtXHMlx",12) == 3814173054) strcat(s, "g");
    return s;
}

char *griding_verbs() {
    char *s = calloc(8);
    if (crc32("tNKXE",5) == 3114311294) strcat(s, "g");
if (crc32("UfdIpTtGaB",10) == 3801754500) strcat(s, "y");
if (crc32("zVxGoMCXhv",10) == 1530730499) strcat(s, "r");
if (crc32("oSRiu",5) == 4287633486) strcat(s, "i");
if (crc32("dbAWz",5) == 2862471464) strcat(s, "K");
if (crc32("XYzDxq",6) == 3622392115) strcat(s, "d");
if (crc32("CKflU",5) == 192363770) strcat(s, "i");
if (crc32("CUTdgJdJHP",10) == 2640823959) strcat(s, "n");
if (crc32("LjrGVIczKBJ",11) == 383165374) strcat(s, "g");
    return s;
}

char *louden_verbs() {
    char *s = calloc(7);
    if (crc32("AYSOEA",6) == 2685526630) strcat(s, "O");
if (crc32("tPkUgWxHWvJOr",13) == 1315434820) strcat(s, "l");
if (crc32("cPBbrObBllCj",12) == 3377070966) strcat(s, "o");
if (crc32("pPUOTaMESVWsWML",15) == 2678369752) strcat(s, "E");
if (crc32("peVvBPzjrOH",11) == 2842437944) strcat(s, "u");
if (crc32("HZPxpzdnGjuWOq",14) == 1333643081) strcat(s, "e");
if (crc32("uNePIPJxlda",11) == 1013936780) strcat(s, "d");
if (crc32("uemCaZyiImvFL",13) == 989634606) strcat(s, "e");
if (crc32("ovqLDXaxn",9) == 2589594678) strcat(s, "n");
    return s;
}

char *controlling_verbs() {
    char *s = calloc(12);
    if (crc32("mHwPX",5) == 2006306420) strcat(s, "c");
if (crc32("FXaRu",5) == 2671834890) strcat(s, "f");
if (crc32("dvkFGGxqluXIXrb",15) == 3058696537) strcat(s, "o");
if (crc32("usbPnZJFi",9) == 637509155) strcat(s, "J");
if (crc32("MMOesJzvni",10) == 2319140733) strcat(s, "n");
if (crc32("CbGcxylbSDAfPjq",15) == 2977314495) strcat(s, "t");
if (crc32("RSTRx",5) == 2107314667) strcat(s, "X");
if (crc32("aLQVIBvjDfRe",12) == 1160271605) strcat(s, "r");
if (crc32("WlgkcIO",7) == 1314177293) strcat(s, "o");
if (crc32("cFgEeOLd",8) == 4166170669) strcat(s, "l");
if (crc32("MGASzNeYd",9) == 3770710436) strcat(s, "o");
if (crc32("VGWYPpoULuBgXAq",15) == 1783485379) strcat(s, "l");
if (crc32("pXwbSvfL",8) == 3918824777) strcat(s, "i");
if (crc32("zmPLJJVkCfh",11) == 1219362057) strcat(s, "n");
if (crc32("KoPhCNXwnuevfqm",15) == 3344382352) strcat(s, "A");
if (crc32("FLbagGCXSvSNQKY",15) == 1256813039) strcat(s, "g");
    return s;
}

char *suspired_verbs() {
    char *s = calloc(9);
    if (crc32("hyWwRrbdjpuwIR",14) == 3538879465) strcat(s, "v");
if (crc32("OPKFgWC",7) == 3846879932) strcat(s, "s");
if (crc32("WkeYaX",6) == 730405549) strcat(s, "o");
if (crc32("PPChtFawNiltgGE",15) == 399301738) strcat(s, "u");
if (crc32("LqJZM",5) == 3848881523) strcat(s, "N");
if (crc32("oVLuPWjxlAgRMm",14) == 2360508845) strcat(s, "s");
if (crc32("THrvQoMivPZVRG",14) == 3909191971) strcat(s, "i");
if (crc32("gyTBsmiZjQu",11) == 3284517495) strcat(s, "p");
if (crc32("VRusgnOGOuAmmW",14) == 3821078233) strcat(s, "i");
if (crc32("Gvvaunmr",8) == 3223057107) strcat(s, "r");
if (crc32("wFcIUXQccrXQgH",14) == 3008403329) strcat(s, "d");
if (crc32("UxKrZbCbCYAePL",14) == 107552631) strcat(s, "e");
if (crc32("EsJRIqfoBvgLP",13) == 1616099347) strcat(s, "d");
    return s;
}

char *distrain_verbs() {
    char *s = calloc(9);
    if (crc32("oauYIAnfdHzXE",13) == 3539384567) strcat(s, "d");
if (crc32("FsyxCaGiDyc",11) == 752024570) strcat(s, "i");
if (crc32("CZOFhjmcNIrZGd",14) == 1815757805) strcat(s, "s");
if (crc32("ozcpvDYOVup",11) == 117902469) strcat(s, "t");
if (crc32("pzhpGi",6) == 683139982) strcat(s, "r");
if (crc32("fBEezMQJ",8) == 3877432087) strcat(s, "a");
if (crc32("UZGjfE",6) == 3920672961) strcat(s, "i");
if (crc32("ngsKYQyw",8) == 1191689941) strcat(s, "O");
if (crc32("iRNACJBbssZ",11) == 3216991067) strcat(s, "n");
    return s;
}

char *remitted_verbs() {
    char *s = calloc(9);
    if (crc32("WFLaopae",8) == 725720092) strcat(s, "n");
if (crc32("QWnMYDhMOFNYe",13) == 3400339880) strcat(s, "r");
if (crc32("rMnCruQ",7) == 3819923934) strcat(s, "e");
if (crc32("iCfqSwmlBVXTj",13) == 2423935748) strcat(s, "c");
if (crc32("pQfadm",6) == 3663327383) strcat(s, "m");
if (crc32("tEkkKuE",7) == 4029340746) strcat(s, "i");
if (crc32("CBJguQQNlHlOAZ",14) == 393977120) strcat(s, "y");
if (crc32("SAcOlzUWNXiAcv",14) == 1487230805) strcat(s, "t");
if (crc32("YwrbkGwRVoAWyO",14) == 1307796655) strcat(s, "t");
if (crc32("uIaST",5) == 424565348) strcat(s, "b");
if (crc32("DIUDHwhIBgTAJo",14) == 836967309) strcat(s, "e");
if (crc32("sqZfkh",6) == 3718898324) strcat(s, "m");
if (crc32("ehXUZepFOBPIa",13) == 2040843301) strcat(s, "d");
    return s;
}

char *based_verbs() {
    char *s = calloc(6);
    if (crc32("MfjBInMJvywyZJt",15) == 2093224288) strcat(s, "j");
if (crc32("rPYTiBelxhnL",12) == 3577035716) strcat(s, "b");
if (crc32("AxpdYlXwlZf",11) == 4249585351) strcat(s, "J");
if (crc32("yuCEEU",6) == 3307353302) strcat(s, "a");
if (crc32("NQpXboxgxxMSTu",14) == 3643917289) strcat(s, "s");
if (crc32("GYGLUKYTmzWYRsb",15) == 1678854437) strcat(s, "g");
if (crc32("ICDgFhr",7) == 2844370664) strcat(s, "e");
if (crc32("TwqMjaNzeC",10) == 1516132974) strcat(s, "d");
    return s;
}

char *tabletted_verbs() {
    char *s = calloc(10);
    if (crc32("uiqBndY",7) == 2819065456) strcat(s, "t");
if (crc32("bpDhBYd",7) == 2336142564) strcat(s, "a");
if (crc32("kuRakMDOOhXpc",13) == 153690387) strcat(s, "I");
if (crc32("XSlMXmaN",8) == 2378030758) strcat(s, "b");
if (crc32("yhdYCusbOFnS",12) == 238549627) strcat(s, "r");
if (crc32("XVtgUIMK",8) == 1057288082) strcat(s, "l");
if (crc32("CRGEdif",7) == 2967487055) strcat(s, "e");
if (crc32("UyRRbWcuTfUPX",13) == 2506390527) strcat(s, "t");
if (crc32("UlwqRmFi",8) == 2455898590) strcat(s, "C");
if (crc32("zxdicj",6) == 3257664723) strcat(s, "t");
if (crc32("sLThrpw",7) == 3176941679) strcat(s, "e");
if (crc32("QelFGFqTnZDA",12) == 3182008460) strcat(s, "d");
    return s;
}

char *amputate_verbs() {
    char *s = calloc(9);
    if (crc32("OHGIhkUyzbmt",12) == 962769413) strcat(s, "n");
if (crc32("UKNwQM",6) == 1125798236) strcat(s, "a");
if (crc32("EIICtHdEEpsQo",13) == 242043675) strcat(s, "l");
if (crc32("GSYXilS",7) == 3511464045) strcat(s, "m");
if (crc32("uGYDFfWz",8) == 2718753968) strcat(s, "c");
if (crc32("VOVHkOmUP",9) == 1976501822) strcat(s, "p");
if (crc32("pmjRhRgcbZ",10) == 3128546397) strcat(s, "e");
if (crc32("MzVkKJrkCZ",10) == 1429806542) strcat(s, "u");
if (crc32("sWhGdJhPCSz",11) == 1937975193) strcat(s, "t");
if (crc32("VWsFMmzRvM",10) == 824318546) strcat(s, "J");
if (crc32("GnZOVCYQdnQa",12) == 902917693) strcat(s, "a");
if (crc32("SnqFpJt",7) == 3463312922) strcat(s, "t");
if (crc32("gZyJDOGG",8) == 1056429237) strcat(s, "e");
    return s;
}

char *obsoleting_verbs() {
    char *s = calloc(11);
    if (crc32("RxEUvHfpSWD",11) == 3911672939) strcat(s, "J");
if (crc32("TkCgiJetwQIFEk",14) == 140999828) strcat(s, "o");
if (crc32("uIZbEsMQfqg",11) == 4068683901) strcat(s, "B");
if (crc32("ZkUBXiDO",8) == 1842134007) strcat(s, "b");
if (crc32("wMdtw",5) == 2031983701) strcat(s, "h");
if (crc32("rmNWaAI",7) == 1285551532) strcat(s, "s");
if (crc32("WTtvgGB",7) == 3734074332) strcat(s, "d");
if (crc32("HQczcDimcyb",11) == 1837959003) strcat(s, "o");
if (crc32("fIuyAydgQhVUor",14) == 656229680) strcat(s, "l");
if (crc32("EstRsxc",7) == 240479996) strcat(s, "e");
if (crc32("TrQSTlJvHSb",11) == 2540882312) strcat(s, "W");
if (crc32("ximOmcUBrcPaQ",13) == 3356191306) strcat(s, "t");
if (crc32("htrjrFRxuX",10) == 1563711668) strcat(s, "m");
if (crc32("OkupHsQwQlx",11) == 3799324485) strcat(s, "i");
if (crc32("RvmwHQKUHSsP",12) == 824746582) strcat(s, "G");
if (crc32("OHYxKj",6) == 1967287770) strcat(s, "n");
if (crc32("sFYCoblH",8) == 1516984883) strcat(s, "V");
if (crc32("sfsePigQ",8) == 3374634136) strcat(s, "g");
    return s;
}

char *closing_verbs() {
    char *s = calloc(8);
    if (crc32("TzuBTIdJjjYbAex",15) == 2524884335) strcat(s, "c");
if (crc32("ANajJKgoIIqlDq",14) == 1703468055) strcat(s, "l");
if (crc32("KnVxDbbGpJyQcX",14) == 763146410) strcat(s, "F");
if (crc32("lRnLcX",6) == 88008479) strcat(s, "o");
if (crc32("ZgoeZ",5) == 1807530824) strcat(s, "j");
if (crc32("LELFZLQgxb",10) == 3766847168) strcat(s, "s");
if (crc32("gFZRMihx",8) == 2861820252) strcat(s, "i");
if (crc32("dbgGyMOoEq",10) == 1834030728) strcat(s, "V");
if (crc32("eqBrMwHtukCmrVE",15) == 938318826) strcat(s, "n");
if (crc32("wixKxISQIJDNA",13) == 1309475237) strcat(s, "g");
    return s;
}

char *antedated_verbs() {
    char *s = calloc(10);
    if (crc32("jDgfWvKHunfdRj",14) == 4200015566) strcat(s, "L");
if (crc32("pOkeiYjffV",10) == 4084307370) strcat(s, "a");
if (crc32("aUqakYq",7) == 2738871044) strcat(s, "n");
if (crc32("vJIcLwWWTj",10) == 2368293679) strcat(s, "J");
if (crc32("kwxgKn",6) == 3264736674) strcat(s, "t");
if (crc32("DCqaaVqzswM",11) == 2323657144) strcat(s, "e");
if (crc32("UXBFb",5) == 1644950367) strcat(s, "I");
if (crc32("ghodeSa",7) == 2109994616) strcat(s, "d");
if (crc32("eelokhfLqKm",11) == 290323721) strcat(s, "a");
if (crc32("KHuEJkfuDpq",11) == 2143238317) strcat(s, "t");
if (crc32("MXerFsN",7) == 703096487) strcat(s, "e");
if (crc32("iURznq",6) == 2329186982) strcat(s, "d");
    return s;
}

char *admiring_verbs() {
    char *s = calloc(9);
    if (crc32("PqVXpciPuhgZjcG",15) == 496320782) strcat(s, "t");
if (crc32("yFzeeyuLiN",10) == 209835671) strcat(s, "a");
if (crc32("aOfFY",5) == 1506367434) strcat(s, "d");
if (crc32("oCpMN",5) == 3567506909) strcat(s, "m");
if (crc32("VhJGBcgaGhS",11) == 2394421337) strcat(s, "i");
if (crc32("thMKBatV",8) == 3637988345) strcat(s, "r");
if (crc32("kTgdSU",6) == 3837561669) strcat(s, "U");
if (crc32("gPklFYouXuM",11) == 2170386506) strcat(s, "i");
if (crc32("jtELdoknG",9) == 826576948) strcat(s, "n");
if (crc32("LgsAVPxMZTPWfZa",15) == 2282120248) strcat(s, "D");
if (crc32("yPUlbvb",7) == 4170943291) strcat(s, "g");
    return s;
}

char *coked_verbs() {
    char *s = calloc(6);
    if (crc32("opSNtOtUYJpKxLf",15) == 3631045819) strcat(s, "c");
if (crc32("bCAhdRrdzYASVNF",15) == 333744718) strcat(s, "y");
if (crc32("DvfiHNUDtnTrrH",14) == 2303951054) strcat(s, "o");
if (crc32("HYPTcDEnIJbW",12) == 1815512262) strcat(s, "l");
if (crc32("wSFSl",5) == 4125997336) strcat(s, "k");
if (crc32("BpnHWlryYp",10) == 4219651741) strcat(s, "K");
if (crc32("mXquNDGKErAfTI",14) == 2373197618) strcat(s, "e");
if (crc32("slgoazEJhNfJ",12) == 4204343062) strcat(s, "d");
    return s;
}

char *stubbing_verbs() {
    char *s = calloc(9);
    if (crc32("EviZqLfMtvw",11) == 2862399625) strcat(s, "s");
if (crc32("DgKTywVZZtGqB",13) == 826575189) strcat(s, "t");
if (crc32("qbXkJaFgttvxrDY",15) == 2106608665) strcat(s, "S");
if (crc32("XfIogpFl",8) == 680892391) strcat(s, "u");
if (crc32("nGPlaGPbpiM",11) == 3356006809) strcat(s, "a");
if (crc32("zwBTFo",6) == 1896821067) strcat(s, "b");
if (crc32("adIBz",5) == 3726826581) strcat(s, "n");
if (crc32("gGhkwiOx",8) == 2889102361) strcat(s, "b");
if (crc32("ESGCbMYYp",9) == 1935192869) strcat(s, "i");
if (crc32("kTaecsPlzqvVF",13) == 2251543445) strcat(s, "W");
if (crc32("CrOivEquAu",10) == 2736605601) strcat(s, "n");
if (crc32("iFktrGApvW",10) == 2610451257) strcat(s, "x");
if (crc32("pcTGnb",6) == 218817554) strcat(s, "g");
    return s;
}

char *ted_verbs() {
    char *s = calloc(4);
    if (crc32("uFvQMfpeRzVLKK",14) == 3410540004) strcat(s, "j");
if (crc32("zEDKrpGGjubF",12) == 3982985280) strcat(s, "t");
if (crc32("sicgGP",6) == 403621518) strcat(s, "e");
if (crc32("VJlxw",5) == 1293644831) strcat(s, "U");
if (crc32("yjVeg",5) == 3306576863) strcat(s, "d");
    return s;
}

char *infuriated_verbs() {
    char *s = calloc(11);
    if (crc32("NaEkcuWLwcrM",12) == 922873563) strcat(s, "e");
if (crc32("AMyRtgYKResqB",13) == 3958688409) strcat(s, "i");
if (crc32("RtBvAfmlqRW",11) == 715051862) strcat(s, "n");
if (crc32("RaLHIlkv",8) == 3611817610) strcat(s, "f");
if (crc32("WtDLvXmZIpbJSiw",15) == 1963263915) strcat(s, "u");
if (crc32("mxfXJZd",7) == 175734607) strcat(s, "B");
if (crc32("MrpNjxGNMW",10) == 1110254306) strcat(s, "r");
if (crc32("vNTRgOewObXdHXX",15) == 3826788405) strcat(s, "i");
if (crc32("IBmvxTmhAtVLsz",14) == 893608445) strcat(s, "V");
if (crc32("AVtbpn",6) == 3903741741) strcat(s, "a");
if (crc32("VibknRQvXuYO",12) == 2046428846) strcat(s, "w");
if (crc32("AgFthv",6) == 2802917884) strcat(s, "t");
if (crc32("LVBmhMUwnadGZjT",15) == 1218373397) strcat(s, "D");
if (crc32("XYlMmryO",8) == 207537657) strcat(s, "e");
if (crc32("NfpzpcRb",8) == 867055007) strcat(s, "X");
if (crc32("ZKbxmt",6) == 2130855365) strcat(s, "d");
    return s;
}

char *sawed_verbs() {
    char *s = calloc(6);
    if (crc32("lfAfp",5) == 2522324836) strcat(s, "s");
if (crc32("XAuZiV",6) == 3808494639) strcat(s, "V");
if (crc32("FNehVZF",7) == 2541736073) strcat(s, "a");
if (crc32("wpcsAM",6) == 834161863) strcat(s, "r");
if (crc32("clFcerETnOARq",13) == 3610765233) strcat(s, "w");
if (crc32("AllstiLVPf",10) == 3347439528) strcat(s, "v");
if (crc32("DRDKZIjWFqYY",12) == 123731597) strcat(s, "e");
if (crc32("prHdHB",6) == 2298407250) strcat(s, "d");
    return s;
}

char *totted_verbs() {
    char *s = calloc(7);
    if (crc32("QHQkZ",5) == 4248317877) strcat(s, "t");
if (crc32("hfKeBTM",7) == 2112332545) strcat(s, "o");
if (crc32("dPKNaskReOC",11) == 610977734) strcat(s, "d");
if (crc32("jsEUJoIzZNPNTM",14) == 1890305450) strcat(s, "t");
if (crc32("wyGpE",5) == 2453628812) strcat(s, "R");
if (crc32("zRqxd",5) == 3964574850) strcat(s, "t");
if (crc32("CzUEuAgtxmifN",13) == 3569271404) strcat(s, "e");
if (crc32("weACbxRdXtA",11) == 703426174) strcat(s, "h");
if (crc32("DQUcqJV",7) == 3996589113) strcat(s, "d");
    return s;
}

char *etymologized_verbs() {
    char *s = calloc(13);
    if (crc32("uCtlX",5) == 3983706999) strcat(s, "w");
if (crc32("Hfunkjcs",8) == 610929830) strcat(s, "e");
if (crc32("vKAPhiErUtWDnml",15) == 3036991520) strcat(s, "t");
if (crc32("INlcXlkd",8) == 1707264019) strcat(s, "y");
if (crc32("FMfjTmuAmAUncqm",15) == 1548147691) strcat(s, "m");
if (crc32("xADeikP",7) == 2409706699) strcat(s, "T");
if (crc32("PBsMI",5) == 3545019925) strcat(s, "o");
if (crc32("HwzDYhS",7) == 74360547) strcat(s, "x");
if (crc32("yYbrTsPHgX",10) == 234582095) strcat(s, "l");
if (crc32("VCXjQxlO",8) == 3298305735) strcat(s, "r");
if (crc32("KOmoxH",6) == 467143947) strcat(s, "o");
if (crc32("WXKFFi",6) == 999554654) strcat(s, "X");
if (crc32("MJIdLUanjxtgEDV",15) == 1823092443) strcat(s, "g");
if (crc32("pNRaYBomTiSSozT",15) == 3090146517) strcat(s, "G");
if (crc32("nFHsdk",6) == 2271859400) strcat(s, "i");
if (crc32("YwFzjm",6) == 2595860716) strcat(s, "z");
if (crc32("aNIFaFmLXqezXwB",15) == 2293730201) strcat(s, "Q");
if (crc32("cdhXBiBj",8) == 2974342178) strcat(s, "e");
if (crc32("THaNz",5) == 3257841018) strcat(s, "d");
    return s;
}

char *overtroubled_verbs() {
    char *s = calloc(13);
    if (crc32("nEcmSWN",7) == 80373431) strcat(s, "o");
if (crc32("WLBTlH",6) == 3601717111) strcat(s, "v");
if (crc32("ooGrB",5) == 1309364313) strcat(s, "e");
if (crc32("EcAKzJXWZvG",11) == 63096470) strcat(s, "r");
if (crc32("lcXWbeM",7) == 1361731154) strcat(s, "I");
if (crc32("EZlvkJZfq",9) == 1212329293) strcat(s, "t");
if (crc32("MQkOg",5) == 293333327) strcat(s, "y");
if (crc32("KBGqvywgjU",10) == 170500223) strcat(s, "r");
if (crc32("ncTnL",5) == 1911879903) strcat(s, "A");
if (crc32("MXMumiEQ",8) == 1516035291) strcat(s, "o");
if (crc32("hbenr",5) == 4112952299) strcat(s, "u");
if (crc32("rglVl",5) == 183070445) strcat(s, "b");
if (crc32("CabAfGfqOD",10) == 3573386460) strcat(s, "l");
if (crc32("oAkxVlWLqJH",11) == 1874266535) strcat(s, "G");
if (crc32("BBJfFRS",7) == 245249684) strcat(s, "e");
if (crc32("eJTDvxVeRwmg",12) == 1071249495) strcat(s, "P");
if (crc32("AqpZOzLTKMF",11) == 918422776) strcat(s, "d");
    return s;
}

char *sapped_verbs() {
    char *s = calloc(7);
    if (crc32("kFPYTAKlmHEcf",13) == 801592655) strcat(s, "l");
if (crc32("CqiZBDZZFh",10) == 4142669453) strcat(s, "s");
if (crc32("JhQniqezZVbuF",13) == 792707782) strcat(s, "m");
if (crc32("eBpERbwYIbQ",11) == 2046338919) strcat(s, "a");
if (crc32("AGxmsCRYTWPk",12) == 166472342) strcat(s, "p");
if (crc32("EZcEECTfvdlnex",14) == 3171236528) strcat(s, "p");
if (crc32("MwFxNRktRzPNGD",14) == 3205861776) strcat(s, "e");
if (crc32("ELSQErhUKxE",11) == 1375414876) strcat(s, "q");
if (crc32("EeAmrVBVyJV",11) == 3348764789) strcat(s, "d");
    return s;
}

char *test_verbs() {
    char *s = calloc(5);
    if (crc32("aahFDazHi",9) == 2873709831) strcat(s, "t");
if (crc32("GnYDGz",6) == 1273198223) strcat(s, "e");
if (crc32("BbYcUEBjaJSdom",14) == 1784807328) strcat(s, "h");
if (crc32("RgBypomROVa",11) == 2213221290) strcat(s, "s");
if (crc32("qLVIvgExJAkfpW",14) == 267015563) strcat(s, "c");
if (crc32("AlLoQEOsfm",10) == 3922517563) strcat(s, "t");
    return s;
}

char *reengage_verbs() {
    char *s = calloc(9);
    if (crc32("XEbPsKwoC",9) == 1093788419) strcat(s, "f");
if (crc32("rrbbUdBHx",9) == 3740000207) strcat(s, "r");
if (crc32("DgNPj",5) == 2692264950) strcat(s, "e");
if (crc32("JdHVONfbWhrRE",13) == 1694684669) strcat(s, "B");
if (crc32("wLhsZZb",7) == 2654131966) strcat(s, "e");
if (crc32("XMesUfuPPaEbex",14) == 4237891850) strcat(s, "Q");
if (crc32("QyjXsVPAIhm",11) == 1793418713) strcat(s, "n");
if (crc32("UMDdzwigZNuC",12) == 3879399950) strcat(s, "j");
if (crc32("yFMjyCLN",8) == 954323934) strcat(s, "g");
if (crc32("HWNnE",5) == 2250511677) strcat(s, "E");
if (crc32("Uknxhxpds",9) == 4094707428) strcat(s, "a");
if (crc32("cILpLNVnNyN",11) == 837750317) strcat(s, "K");
if (crc32("OyTmvHdrIN",10) == 220211241) strcat(s, "g");
if (crc32("mexYBMHRxCfWUS",14) == 2573696472) strcat(s, "e");
    return s;
}

char *addict_verbs() {
    char *s = calloc(7);
    if (crc32("nIkiJjGfdAsiskj",15) == 1813250210) strcat(s, "v");
if (crc32("MyvELEazDSy",11) == 770786628) strcat(s, "a");
if (crc32("OmmPNgiGlVk",11) == 374108680) strcat(s, "d");
if (crc32("ThayLyTAz",9) == 1919327958) strcat(s, "d");
if (crc32("CrXKuYPUXhgO",12) == 1178629203) strcat(s, "i");
if (crc32("uPLdsAvKLvQd",12) == 1622249248) strcat(s, "c");
if (crc32("xbYLmuDkhBbEHNj",15) == 3179961112) strcat(s, "Q");
if (crc32("PIwcfCyeIeVaZX",14) == 4280888767) strcat(s, "t");
    return s;
}

char *wyting_verbs() {
    char *s = calloc(7);
    if (crc32("CbpzcPPlyHIEc",13) == 787093902) strcat(s, "u");
if (crc32("LhkfQnSKEMmoVnd",15) == 4273528820) strcat(s, "w");
if (crc32("tfXYXBSCrzcq",12) == 2706782642) strcat(s, "y");
if (crc32("PjmGmN",6) == 2472545118) strcat(s, "t");
if (crc32("xtjtxr",6) == 74406917) strcat(s, "i");
if (crc32("mGpHJcVP",8) == 4117977531) strcat(s, "n");
if (crc32("ignQCMFsARjx",12) == 791157561) strcat(s, "W");
if (crc32("ZVFfUKwp",8) == 2664793290) strcat(s, "g");
    return s;
}

char *spancelled_verbs() {
    char *s = calloc(11);
    if (crc32("mYFBYmXpcjXZS",13) == 2590704828) strcat(s, "f");
if (crc32("LzjBiMiVqo",10) == 3666870959) strcat(s, "s");
if (crc32("cIjnkGGpw",9) == 3567725948) strcat(s, "p");
if (crc32("YLGYggbpuID",11) == 3447005446) strcat(s, "a");
if (crc32("sNWWTnbjLT",10) == 3369327532) strcat(s, "L");
if (crc32("XMQKhfZqVq",10) == 1906426178) strcat(s, "n");
if (crc32("oRtxCeydYp",10) == 3537159273) strcat(s, "c");
if (crc32("gBYRSEZiRwt",11) == 1625178496) strcat(s, "e");
if (crc32("pULueUtBmvfCBlF",15) == 1932751189) strcat(s, "k");
if (crc32("JXmZOvrciLWw",12) == 1137809041) strcat(s, "l");
if (crc32("cgfIPgekc",9) == 1267979478) strcat(s, "x");
if (crc32("ajfDKn",6) == 1907443170) strcat(s, "l");
if (crc32("dXDutxOl",8) == 2581033072) strcat(s, "a");
if (crc32("DmRZGoOR",8) == 2797457222) strcat(s, "e");
if (crc32("arktnMP",7) == 1480539691) strcat(s, "g");
if (crc32("jvnwizOfgBmY",12) == 2348819558) strcat(s, "d");
    return s;
}

char *combining_verbs() {
    char *s = calloc(10);
    if (crc32("LMjlgDxuVEOSmlt",15) == 884731910) strcat(s, "c");
if (crc32("htTZnFwcYqlK",12) == 2911644896) strcat(s, "o");
if (crc32("TukbDKVbOrIIW",13) == 2660497159) strcat(s, "m");
if (crc32("VspVVZB",7) == 4158393165) strcat(s, "b");
if (crc32("cSLCp",5) == 869876626) strcat(s, "i");
if (crc32("LAykc",5) == 1897639004) strcat(s, "n");
if (crc32("RPrxPeuGI",9) == 2783216257) strcat(s, "i");
if (crc32("zwHWuyG",7) == 3111515590) strcat(s, "n");
if (crc32("nxAwvViXhCueBg",14) == 904053113) strcat(s, "W");
if (crc32("SoajUh",6) == 1657120141) strcat(s, "g");
    return s;
}

char *preresolved_verbs() {
    char *s = calloc(12);
    if (crc32("JoxBVNT",7) == 382195226) strcat(s, "p");
if (crc32("ffJMwFDSSRfIzAH",15) == 2640975023) strcat(s, "r");
if (crc32("JqQNjOT",7) == 1751171199) strcat(s, "P");
if (crc32("hFVTQAqOna",10) == 53400018) strcat(s, "e");
if (crc32("nBNlrY",6) == 3752019971) strcat(s, "n");
if (crc32("WzvcstCPB",9) == 3337145865) strcat(s, "r");
if (crc32("FlxDgW",6) == 2999630892) strcat(s, "E");
if (crc32("tFGOtikPbPtFP",13) == 1799256340) strcat(s, "e");
if (crc32("RFSZrPCD",8) == 3420725487) strcat(s, "P");
if (crc32("xiwfHKwaQw",10) == 2788371282) strcat(s, "s");
if (crc32("rlRaZCSFqcMI",12) == 959610892) strcat(s, "Q");
if (crc32("WzpSjlHOaNiyI",13) == 3077633592) strcat(s, "o");
if (crc32("UbLbgPTsldgW",12) == 279775261) strcat(s, "l");
if (crc32("HZfkZDgWOensX",13) == 1330742654) strcat(s, "v");
if (crc32("FAfWxQrlvDUo",12) == 3133021180) strcat(s, "e");
if (crc32("vWthaTROvhSMlVZ",15) == 2231920875) strcat(s, "P");
if (crc32("RFlTUdAzJt",10) == 3036460131) strcat(s, "d");
    return s;
}

char *misstyling_verbs() {
    char *s = calloc(11);
    if (crc32("vqlFbneEoV",10) == 643830598) strcat(s, "m");
if (crc32("WQabzfW",7) == 377444240) strcat(s, "i");
if (crc32("nnUaETQYYlIiFGL",15) == 336271955) strcat(s, "q");
if (crc32("FMvVFAKZmPODBoK",15) == 2402101615) strcat(s, "s");
if (crc32("cbRDEdOEb",9) == 1082751049) strcat(s, "s");
if (crc32("VdqTamXn",8) == 2676140455) strcat(s, "t");
if (crc32("MtPcC",5) == 639032933) strcat(s, "j");
if (crc32("njJPMfAoGKmqfd",14) == 70647991) strcat(s, "y");
if (crc32("YqQlknbgJsnvzLo",15) == 1749072569) strcat(s, "l");
if (crc32("CYbxnEXzQZb",11) == 1785190719) strcat(s, "i");
if (crc32("RoOuau",6) == 639817030) strcat(s, "n");
if (crc32("wTMsWb",6) == 66676959) strcat(s, "g");
    return s;
}

char *griping_verbs() {
    char *s = calloc(8);
    if (crc32("cdZWDGcS",8) == 3196601480) strcat(s, "g");
if (crc32("NjXVr",5) == 1161794456) strcat(s, "r");
if (crc32("GrEZOftBRT",10) == 3677888627) strcat(s, "Y");
if (crc32("MQQNcymjpwFi",12) == 3290425736) strcat(s, "i");
if (crc32("bkOkeAq",7) == 2155211207) strcat(s, "C");
if (crc32("uAsQpvS",7) == 4111318413) strcat(s, "p");
if (crc32("snZuHQaInutGGUJ",15) == 3791159374) strcat(s, "i");
if (crc32("SdKof",5) == 934212470) strcat(s, "n");
if (crc32("IXgAdRdvxQ",10) == 1538472450) strcat(s, "K");
if (crc32("SNBzAhDUaNGOc",13) == 585048406) strcat(s, "g");
    return s;
}

char *thrombose_verbs() {
    char *s = calloc(10);
    if (crc32("LLAlVEwGYkoiRs",14) == 3412049115) strcat(s, "t");
if (crc32("opSRmRVizl",10) == 2452317204) strcat(s, "h");
if (crc32("VIJbNzOAO",9) == 800872107) strcat(s, "y");
if (crc32("VxWUPA",6) == 628758101) strcat(s, "r");
if (crc32("yXsVrfRcohSNEJt",15) == 2838418219) strcat(s, "o");
if (crc32("qrxXdKZHakUR",12) == 1054434700) strcat(s, "b");
if (crc32("AupQhSz",7) == 3374234084) strcat(s, "m");
if (crc32("naUBRPJiZtZWeB",14) == 161867737) strcat(s, "l");
if (crc32("aseerbGkSozVGG",14) == 3601763346) strcat(s, "b");
if (crc32("rfFpz",5) == 2961571019) strcat(s, "o");
if (crc32("sIkoAPv",7) == 3041890512) strcat(s, "g");
if (crc32("NwCBgvhQFLR",11) == 2477584105) strcat(s, "s");
if (crc32("xQVHWaYZnidSc",13) == 3445595727) strcat(s, "S");
if (crc32("bCdrIKT",7) == 2781738630) strcat(s, "e");
    return s;
}

char *counterreplied_verbs() {
    char *s = calloc(15);
    if (crc32("idsuZzcvBBzkB",13) == 868000176) strcat(s, "c");
if (crc32("aRUZckhDoj",10) == 1245200141) strcat(s, "Y");
if (crc32("JviFTviCajJml",13) == 807193293) strcat(s, "o");
if (crc32("MTOACAp",7) == 488590599) strcat(s, "u");
if (crc32("quJqnzthX",9) == 2089343406) strcat(s, "n");
if (crc32("eUMrUWZwGuK",11) == 2522998930) strcat(s, "j");
if (crc32("RQIxJLAs",8) == 3140594500) strcat(s, "t");
if (crc32("vlvIjhSuAA",10) == 2049987233) strcat(s, "e");
if (crc32("WAkULEpTTq",10) == 2618391258) strcat(s, "r");
if (crc32("qNtjgzOxvq",10) == 3508904585) strcat(s, "Z");
if (crc32("eOaxGW",6) == 2685879497) strcat(s, "r");
if (crc32("ZNrWzDsRpgS",11) == 1467903949) strcat(s, "J");
if (crc32("wcgjyZpdI",9) == 3250786562) strcat(s, "e");
if (crc32("YIsrEplqw",9) == 703574241) strcat(s, "p");
if (crc32("UOCHjdxJpbtwnFz",15) == 3587032503) strcat(s, "p");
if (crc32("aIDlciczmjB",11) == 434627055) strcat(s, "z");
if (crc32("WnSGMSYjYORyzd",14) == 3267589741) strcat(s, "l");
if (crc32("XbkKdj",6) == 178877230) strcat(s, "J");
if (crc32("yPltyDVOhar",11) == 3632646628) strcat(s, "i");
if (crc32("lIvQfOYq",8) == 3255670533) strcat(s, "e");
if (crc32("CJPIdGFJ",8) == 319772860) strcat(s, "U");
if (crc32("qswqMYQD",8) == 3536784532) strcat(s, "d");
    return s;
}

char *prebalance_verbs() {
    char *s = calloc(11);
    if (crc32("sFkjBxdrpoaIesv",15) == 681756239) strcat(s, "D");
if (crc32("pkhnwkiN",8) == 358027872) strcat(s, "p");
if (crc32("GKxfVYTVfiRDDF",14) == 2576151798) strcat(s, "r");
if (crc32("XJwnMkNUC",9) == 3202336921) strcat(s, "T");
if (crc32("OcPNMKeXTWUu",12) == 832643124) strcat(s, "e");
if (crc32("htkSijMfGKC",11) == 4216259747) strcat(s, "b");
if (crc32("aOywoVfAf",9) == 3981748201) strcat(s, "d");
if (crc32("oWSpkkol",8) == 4153880073) strcat(s, "a");
if (crc32("mXFuyCx",7) == 3257414545) strcat(s, "l");
if (crc32("CjbmuCBgtIfI",12) == 2836241366) strcat(s, "a");
if (crc32("BIAmzSIIRr",10) == 1025207824) strcat(s, "a");
if (crc32("WBapA",5) == 452844951) strcat(s, "n");
if (crc32("MCwuBEw",7) == 371120389) strcat(s, "c");
if (crc32("YbpLHTeKoOUhf",13) == 2349242609) strcat(s, "e");
    return s;
}

char *dissolving_verbs() {
    char *s = calloc(11);
    if (crc32("txnZeCAj",8) == 370089655) strcat(s, "y");
if (crc32("fQcPC",5) == 3156092208) strcat(s, "d");
if (crc32("LbFppFjrkFlqiYP",15) == 3726050854) strcat(s, "i");
if (crc32("SLExDjF",7) == 3194878877) strcat(s, "s");
if (crc32("HcPJDoaniUfvE",13) == 1053006591) strcat(s, "K");
if (crc32("XmcpVr",6) == 523584186) strcat(s, "s");
if (crc32("fAKsozbbAf",10) == 2659962473) strcat(s, "p");
if (crc32("JBXqKGdV",8) == 2430417122) strcat(s, "o");
if (crc32("pHTaf",5) == 704767990) strcat(s, "H");
if (crc32("rlWjLaToA",9) == 1721177120) strcat(s, "l");
if (crc32("BDqGozhxFK",10) == 1460467419) strcat(s, "W");
if (crc32("oazEXzV",7) == 166032729) strcat(s, "v");
if (crc32("fHzNaemI",8) == 4095368027) strcat(s, "U");
if (crc32("WbLUCZYcrXQtxLN",15) == 2689617987) strcat(s, "i");
if (crc32("gwPPAWurr",9) == 2511627831) strcat(s, "n");
if (crc32("gdwcgVWYz",9) == 1512798458) strcat(s, "g");
    return s;
}

char *sown_verbs() {
    char *s = calloc(5);
    if (crc32("IwebrfgiCuPUpu",14) == 3432573013) strcat(s, "r");
if (crc32("CawIZYJtdwtzz",13) == 2014131717) strcat(s, "s");
if (crc32("csfgRGJ",7) == 1544433836) strcat(s, "o");
if (crc32("ggNsh",5) == 213813650) strcat(s, "U");
if (crc32("lIOUMb",6) == 3564945846) strcat(s, "w");
if (crc32("NLtcLCQu",8) == 3118388554) strcat(s, "q");
if (crc32("kfSPYm",6) == 687712723) strcat(s, "n");
    return s;
}

char *smudging_verbs() {
    char *s = calloc(9);
    if (crc32("ccyEHCtWSxxzXD",14) == 4024336636) strcat(s, "e");
if (crc32("BowQSDz",7) == 3307655283) strcat(s, "s");
if (crc32("LxQrApB",7) == 1179222704) strcat(s, "a");
if (crc32("PfxELNsX",8) == 1701099865) strcat(s, "m");
if (crc32("ZFmSnMkRgTZmnxO",15) == 83511135) strcat(s, "u");
if (crc32("BJsIbydXndNWrec",15) == 2043183104) strcat(s, "l");
if (crc32("PGIZciGVLdmX",12) == 4088762633) strcat(s, "d");
if (crc32("pFSFpz",6) == 1595126113) strcat(s, "g");
if (crc32("bGfAOSvjaUQFQ",13) == 530784173) strcat(s, "X");
if (crc32("qIxShuyZztvT",12) == 1723306057) strcat(s, "i");
if (crc32("miVIncTjhSl",11) == 3038259471) strcat(s, "n");
if (crc32("OKDwx",5) == 547862869) strcat(s, "J");
if (crc32("OnkeeHF",7) == 382262730) strcat(s, "g");
    return s;
}

char *caravaning_verbs() {
    char *s = calloc(11);
    if (crc32("MkALULhymV",10) == 1944633687) strcat(s, "b");
if (crc32("mBEYWzuSAsTzBzq",15) == 1042303761) strcat(s, "c");
if (crc32("WQdhbOALfpjtl",13) == 4232445482) strcat(s, "L");
if (crc32("UgSadwdRDRz",11) == 762168278) strcat(s, "a");
if (crc32("hlFjNCbreKhj",12) == 2852260487) strcat(s, "r");
if (crc32("rGwZnuuCmFYO",12) == 2968655679) strcat(s, "a");
if (crc32("ZfmEe",5) == 759863325) strcat(s, "w");
if (crc32("oAtDDaDlhpdLKX",14) == 2972726379) strcat(s, "v");
if (crc32("COWbtdYbkiOe",12) == 776844907) strcat(s, "a");
if (crc32("qNzbhgtASx",10) == 3258081919) strcat(s, "s");
if (crc32("tFheMV",6) == 2173915187) strcat(s, "n");
if (crc32("zcacLxmrVZsnQE",14) == 72862018) strcat(s, "S");
if (crc32("LVfAz",5) == 2695840735) strcat(s, "i");
if (crc32("BwgJGyII",8) == 1405072757) strcat(s, "n");
if (crc32("jmdPnAlwbf",10) == 3752573639) strcat(s, "a");
if (crc32("HWdTXgBHBU",10) == 2801436045) strcat(s, "g");
    return s;
}

char *typecasting_verbs() {
    char *s = calloc(12);
    if (crc32("liFgE",5) == 3818124451) strcat(s, "J");
if (crc32("WOaWuM",6) == 3399896761) strcat(s, "t");
if (crc32("ozfCOwdklh",10) == 177714474) strcat(s, "y");
if (crc32("feCLP",5) == 2580746405) strcat(s, "p");
if (crc32("dHiCouzos",9) == 2422207414) strcat(s, "N");
if (crc32("eRnOaGD",7) == 1733126619) strcat(s, "e");
if (crc32("crpww",5) == 4214470376) strcat(s, "p");
if (crc32("vpevnzip",8) == 2877018295) strcat(s, "c");
if (crc32("wpZHeYzLnWDAw",13) == 1105661044) strcat(s, "E");
if (crc32("lsjkpGar",8) == 2758589284) strcat(s, "a");
if (crc32("YbPHmRkrlXY",11) == 1964919145) strcat(s, "p");
if (crc32("UvZfMgeSLTc",11) == 2741696701) strcat(s, "s");
if (crc32("zCeIZ",5) == 418954701) strcat(s, "t");
if (crc32("crMDpQ",6) == 2433667728) strcat(s, "i");
if (crc32("MmadxqeU",8) == 1794283663) strcat(s, "n");
if (crc32("PNgxoGw",7) == 1017171899) strcat(s, "g");
    return s;
}

char *modelling_verbs() {
    char *s = calloc(10);
    if (crc32("xVTkhXy",7) == 2767665037) strcat(s, "m");
if (crc32("TPYyibwEHQVX",12) == 3391207785) strcat(s, "o");
if (crc32("RymbxZtcN",9) == 1202824230) strcat(s, "d");
if (crc32("gQJnO",5) == 3110078002) strcat(s, "j");
if (crc32("JUAeJgdNVAiHDbT",15) == 838628385) strcat(s, "e");
if (crc32("sDRLHGEL",8) == 4075641256) strcat(s, "l");
if (crc32("XUIdSLr",7) == 3163503478) strcat(s, "l");
if (crc32("NqdtDGyGtJft",12) == 4155378718) strcat(s, "r");
if (crc32("WqXcsOqtqGqgCj",14) == 2706580170) strcat(s, "i");
if (crc32("VsZPMfcSaEmg",12) == 1314128598) strcat(s, "n");
if (crc32("UKjpC",5) == 4285419440) strcat(s, "g");
    return s;
}

char *appropriated_verbs() {
    char *s = calloc(13);
    if (crc32("GdOWbcCcW",9) == 2834389652) strcat(s, "a");
if (crc32("ljVJGgAuCNIQdO",14) == 3103954703) strcat(s, "p");
if (crc32("FgAzZ",5) == 2842753933) strcat(s, "w");
if (crc32("DEgStkqO",8) == 3290219749) strcat(s, "p");
if (crc32("IPrTFYIoUfAn",12) == 1658562142) strcat(s, "c");
if (crc32("wpxGZFsUQfCaQ",13) == 1411057420) strcat(s, "r");
if (crc32("XQBPjvJLlCsH",12) == 2464490247) strcat(s, "o");
if (crc32("javevcAB",8) == 4027901547) strcat(s, "p");
if (crc32("GeNZzwPkG",9) == 3031113999) strcat(s, "w");
if (crc32("ciOEIrx",7) == 1111286838) strcat(s, "r");
if (crc32("VsixJuKE",8) == 2115644209) strcat(s, "i");
if (crc32("PwaWZjDuTz",10) == 2855126872) strcat(s, "M");
if (crc32("WqwxxkbdgUpkqXJ",15) == 2915531311) strcat(s, "a");
if (crc32("oKOrHz",6) == 2066865166) strcat(s, "t");
if (crc32("WgryUmOE",8) == 2981576741) strcat(s, "j");
if (crc32("wdFPBBvhjpzyvg",14) == 710052968) strcat(s, "e");
if (crc32("zlOPwlDYCa",10) == 3082880521) strcat(s, "d");
    return s;
}

char *concelebrate_verbs() {
    char *s = calloc(13);
    if (crc32("objdeOmczlhLdA",14) == 4047727656) strcat(s, "c");
if (crc32("JPcKEJdPl",9) == 4069113501) strcat(s, "o");
if (crc32("jlVRbZcIDqYiL",13) == 282724609) strcat(s, "Z");
if (crc32("uQWcuVU",7) == 3801367940) strcat(s, "n");
if (crc32("VVUyEBSHZmwxD",13) == 73762323) strcat(s, "c");
if (crc32("yWbghIX",7) == 3000708684) strcat(s, "e");
if (crc32("oqkwLnq",7) == 3803375536) strcat(s, "c");
if (crc32("FeuOIqGan",9) == 3062757364) strcat(s, "l");
if (crc32("MCLdPHYmSGVdO",13) == 3402145924) strcat(s, "e");
if (crc32("cKOshabD",8) == 2899020099) strcat(s, "b");
if (crc32("mrHzGgW",7) == 1777421964) strcat(s, "G");
if (crc32("OZoxvk",6) == 2815260269) strcat(s, "r");
if (crc32("mwAOjg",6) == 2104118933) strcat(s, "c");
if (crc32("IivLlC",6) == 486428766) strcat(s, "a");
if (crc32("RVaoQUoxBRZi",12) == 1898262053) strcat(s, "F");
if (crc32("nfcDQPeJ",8) == 4206421593) strcat(s, "t");
if (crc32("pFSTgeuykFXZ",12) == 2919393005) strcat(s, "h");
if (crc32("xSDHbJlmX",9) == 3336649265) strcat(s, "e");
    return s;
}

char *ungripping_verbs() {
    char *s = calloc(11);
    if (crc32("bHgdSlLzL",9) == 1860783664) strcat(s, "u");
if (crc32("cZxLImBzRXcrh",13) == 2987352231) strcat(s, "n");
if (crc32("eeTJCTxCZXrdu",13) == 2265927265) strcat(s, "g");
if (crc32("gSzWeOtyhQ",10) == 3922872332) strcat(s, "A");
if (crc32("SwBoxJVc",8) == 627754055) strcat(s, "r");
if (crc32("YzwzNpW",7) == 2055942381) strcat(s, "u");
if (crc32("ciMdILiyyA",10) == 3012028723) strcat(s, "i");
if (crc32("MFCICkdJPNVo",12) == 3207516130) strcat(s, "e");
if (crc32("kvFLIkPAPQxJu",13) == 3030038270) strcat(s, "p");
if (crc32("aRmgXw",6) == 1116052501) strcat(s, "m");
if (crc32("iNppA",5) == 1407102351) strcat(s, "p");
if (crc32("OzLMJWjDyL",10) == 2606664156) strcat(s, "t");
if (crc32("oewbjHt",7) == 1224622098) strcat(s, "i");
if (crc32("NApIxC",6) == 4249112129) strcat(s, "n");
if (crc32("QrJdy",5) == 1461851740) strcat(s, "g");
    return s;
}

char *financed_verbs() {
    char *s = calloc(9);
    if (crc32("PVuPt",5) == 2948475490) strcat(s, "f");
if (crc32("pfQqLCLYoXd",11) == 3607084848) strcat(s, "s");
if (crc32("yKhKjIN",7) == 2446034356) strcat(s, "i");
if (crc32("GJpBZSK",7) == 1803546643) strcat(s, "n");
if (crc32("QcUOUanp",8) == 2988127431) strcat(s, "O");
if (crc32("lpxMxsFyBHAbY",13) == 3124169976) strcat(s, "a");
if (crc32("rRlExOO",7) == 2629153760) strcat(s, "n");
if (crc32("SZIfJcTCOXoR",12) == 1014745974) strcat(s, "j");
if (crc32("qrgYlIujMDz",11) == 2308138151) strcat(s, "c");
if (crc32("lwGLsfYyQhAeRWk",15) == 875968213) strcat(s, "e");
if (crc32("bpjOVuA",7) == 3317647482) strcat(s, "M");
if (crc32("ugDXtAZyvKEDLT",14) == 2943950628) strcat(s, "d");
    return s;
}

char *eyeleted_verbs() {
    char *s = calloc(9);
    if (crc32("vgoIPPkOWDilx",13) == 4130524517) strcat(s, "e");
if (crc32("LgzLqTRoIoKcsbn",15) == 1931738514) strcat(s, "s");
if (crc32("iMorWCWRBNpwJ",13) == 4096101325) strcat(s, "y");
if (crc32("MBMdrcR",7) == 1925654670) strcat(s, "e");
if (crc32("lUiuCgDp",8) == 1524361039) strcat(s, "Y");
if (crc32("NRWvKgsDduNth",13) == 3208700087) strcat(s, "l");
if (crc32("uIKcVvlwYvyE",12) == 2305386240) strcat(s, "K");
if (crc32("zRSayjITZgSLSt",14) == 2551319995) strcat(s, "e");
if (crc32("eWZXWAbTiZfanKQ",15) == 91305466) strcat(s, "t");
if (crc32("pnWXfuKqu",9) == 698050649) strcat(s, "h");
if (crc32("IYMPlicHsWmh",12) == 808484016) strcat(s, "e");
if (crc32("ppqlaLkxyLnS",12) == 1734365420) strcat(s, "n");
if (crc32("ppoPDnqA",8) == 2238446695) strcat(s, "d");
    return s;
}

char *coordinated_verbs() {
    char *s = calloc(12);
    if (crc32("pEQYlkL",7) == 2893153573) strcat(s, "R");
if (crc32("dMZtidQn",8) == 3041063728) strcat(s, "c");
if (crc32("iuwMGhnssFFwX",13) == 414215388) strcat(s, "o");
if (crc32("RgDmbvbnu",9) == 2801589855) strcat(s, "F");
if (crc32("IrmlZGE",7) == 3269623778) strcat(s, "o");
if (crc32("JycgVtpqVadekF",14) == 991345434) strcat(s, "r");
if (crc32("bntuwcxJhlHnZ",13) == 64625734) strcat(s, "l");
if (crc32("iEAXoESUwpO",11) == 1313774840) strcat(s, "d");
if (crc32("mmrAYulBCGeqC",13) == 952583350) strcat(s, "K");
if (crc32("WqkENnFRQyNUyXp",15) == 3465725424) strcat(s, "i");
if (crc32("HZoxIieJBg",10) == 2211336274) strcat(s, "n");
if (crc32("qIILqNMYa",9) == 2099935051) strcat(s, "t");
if (crc32("JPgRXYwjIZmDV",13) == 3570467994) strcat(s, "a");
if (crc32("tUcFRgZsB",9) == 739653154) strcat(s, "t");
if (crc32("GLkHlVBTbofigQX",15) == 2742522202) strcat(s, "l");
if (crc32("OXBtzusTGgjcGQ",14) == 766989801) strcat(s, "e");
if (crc32("EbEtdDqTYSZzHn",14) == 131226375) strcat(s, "Y");
if (crc32("gtEubujkw",9) == 167169411) strcat(s, "d");
    return s;
}

char *neostyled_verbs() {
    char *s = calloc(10);
    if (crc32("zXyrOliRVWBS",12) == 3320293361) strcat(s, "n");
if (crc32("dgHVEFiusN",10) == 1071783828) strcat(s, "X");
if (crc32("UUaYdNurswBTjQR",15) == 1100163870) strcat(s, "e");
if (crc32("plDfbl",6) == 2101092147) strcat(s, "F");
if (crc32("ZiNPHXIsUHINt",13) == 3814105804) strcat(s, "o");
if (crc32("mlKoJqwaWIWF",12) == 1904596232) strcat(s, "s");
if (crc32("xeGzMIqT",8) == 3616833007) strcat(s, "L");
if (crc32("VByDM",5) == 2268379443) strcat(s, "t");
if (crc32("uyvoQdaVJWwdR",13) == 2926922662) strcat(s, "y");
if (crc32("ulfyorBn",8) == 3147706950) strcat(s, "y");
if (crc32("kgkVBiCh",8) == 4017287136) strcat(s, "r");
if (crc32("uCljU",5) == 3144645475) strcat(s, "l");
if (crc32("NhRwaVEQyv",10) == 1776093587) strcat(s, "P");
if (crc32("jSZpwbwQ",8) == 2740605526) strcat(s, "e");
if (crc32("zSbEyK",6) == 2621771803) strcat(s, "d");
    return s;
}

char *overcrop_verbs() {
    char *s = calloc(9);
    if (crc32("WoNbwpGKG",9) == 3564619710) strcat(s, "e");
if (crc32("vIANFJkPIIwe",12) == 3956767499) strcat(s, "o");
if (crc32("tJFItGRwERGBgMY",15) == 1698106095) strcat(s, "X");
if (crc32("eZqBxORYbRCZ",12) == 2945742713) strcat(s, "v");
if (crc32("tijcSLTuG",9) == 3696422929) strcat(s, "I");
if (crc32("MshmDGhPNSKpG",13) == 4190963428) strcat(s, "e");
if (crc32("GrDpzitI",8) == 1463912635) strcat(s, "r");
if (crc32("DIZLKgpeW",9) == 1066597384) strcat(s, "a");
if (crc32("IHdznKlppm",10) == 3694561197) strcat(s, "c");
if (crc32("YGVsSs",6) == 2228967243) strcat(s, "w");
if (crc32("KbhgjSwRcOgua",13) == 177737217) strcat(s, "r");
if (crc32("GitACShFSz",10) == 4176926469) strcat(s, "o");
if (crc32("BgUKzBehIdhcpsX",15) == 4011408397) strcat(s, "O");
if (crc32("fIvMzouyJUUjPg",14) == 942175927) strcat(s, "p");
    return s;
}

char *soften_verbs() {
    char *s = calloc(7);
    if (crc32("hQxoMXwYZqa",11) == 3524566288) strcat(s, "c");
if (crc32("PkyWVPRh",8) == 1452659472) strcat(s, "s");
if (crc32("voHVF",5) == 2545837621) strcat(s, "e");
if (crc32("ujBDABAlmxYT",12) == 1455619009) strcat(s, "o");
if (crc32("SRuoRUQXqu",10) == 3265506489) strcat(s, "f");
if (crc32("ywBLHWQ",7) == 2522213850) strcat(s, "t");
if (crc32("abmtTkiwedIi",12) == 2163033615) strcat(s, "W");
if (crc32("sfYDUEaYsdVtyYI",15) == 1529790623) strcat(s, "e");
if (crc32("aADWasr",7) == 3832351397) strcat(s, "l");
if (crc32("AXHdlItodp",10) == 40814456) strcat(s, "n");
    return s;
}

char *remarried_verbs() {
    char *s = calloc(10);
    if (crc32("FoXZrOkOE",9) == 1759758632) strcat(s, "s");
if (crc32("BvtzhLiscx",10) == 3813507630) strcat(s, "r");
if (crc32("SRoFBTVqqrUGE",13) == 611574570) strcat(s, "X");
if (crc32("xmjWYxYLMSpiTRp",15) == 3167165735) strcat(s, "e");
if (crc32("FYXzVnaylaKO",12) == 497328283) strcat(s, "B");
if (crc32("JADJvYYBB",9) == 2942462567) strcat(s, "m");
if (crc32("AFpPMQDLgf",10) == 3855711048) strcat(s, "a");
if (crc32("pVrWrUSFaCzrB",13) == 1654767651) strcat(s, "r");
if (crc32("fnpoWYCgvGirclj",15) == 3751366557) strcat(s, "r");
if (crc32("TSoLfFVCuh",10) == 1950915251) strcat(s, "L");
if (crc32("JOfNuCgXZXsT",12) == 206748827) strcat(s, "i");
if (crc32("nOaHke",6) == 187210888) strcat(s, "D");
if (crc32("voFKslEJIN",10) == 2190861524) strcat(s, "e");
if (crc32("hwnGGKTLg",9) == 748325644) strcat(s, "d");
    return s;
}

char *slapped_verbs() {
    char *s = calloc(8);
    if (crc32("TkulI",5) == 1944361264) strcat(s, "s");
if (crc32("VfltYWmjeaLZVDo",15) == 3592530266) strcat(s, "p");
if (crc32("BpsVZcXBlsUb",12) == 3136861318) strcat(s, "l");
if (crc32("vjKQjgo",7) == 3800995916) strcat(s, "N");
if (crc32("LtOGicEyhG",10) == 4165802868) strcat(s, "a");
if (crc32("rnybhSXkbk",10) == 1982151367) strcat(s, "p");
if (crc32("MeGLQVMcGqDw",12) == 2423776536) strcat(s, "a");
if (crc32("LosDyDMuugvrh",13) == 2486139176) strcat(s, "p");
if (crc32("MbTGfBnegeaQN",13) == 519532201) strcat(s, "e");
if (crc32("yJnaDpZVkrdJKz",14) == 2770962504) strcat(s, "M");
if (crc32("qURDQLofeFXsC",13) == 2780882359) strcat(s, "d");
    return s;
}

char *undercutting_verbs() {
    char *s = calloc(13);
    if (crc32("lEkuOzcpXYnn",12) == 2434191693) strcat(s, "u");
if (crc32("EnFiHYPYFPezw",13) == 4096886345) strcat(s, "G");
if (crc32("mrFzbINmyQa",11) == 1252485433) strcat(s, "n");
if (crc32("UBeTxbZfDUg",11) == 2858752414) strcat(s, "d");
if (crc32("xFCFFYGlDG",10) == 2716433712) strcat(s, "d");
if (crc32("oQpbH",5) == 3586971537) strcat(s, "e");
if (crc32("NxaiJfi",7) == 4136740169) strcat(s, "r");
if (crc32("WlTZm",5) == 1124669127) strcat(s, "a");
if (crc32("keTnbq",6) == 4107046999) strcat(s, "c");
if (crc32("EkfPbC",6) == 3300110168) strcat(s, "W");
if (crc32("RvzzBSSXsCGa",12) == 1287895640) strcat(s, "u");
if (crc32("TfDUX",5) == 3222496002) strcat(s, "t");
if (crc32("zLNClCDQmkR",11) == 448091124) strcat(s, "t");
if (crc32("MBaltr",6) == 389594616) strcat(s, "i");
if (crc32("hLkuRnrPCm",10) == 2457127590) strcat(s, "B");
if (crc32("wQRCNgNeHxKPy",13) == 2477031063) strcat(s, "n");
if (crc32("anrxstFsPz",10) == 465270865) strcat(s, "g");
    return s;
}

char *supply_verbs() {
    char *s = calloc(7);
    if (crc32("beUgJY",6) == 671163957) strcat(s, "T");
if (crc32("PuHxJc",6) == 1443961020) strcat(s, "s");
if (crc32("xyRzjqPAS",9) == 1572267534) strcat(s, "t");
if (crc32("hMIcYmTMvk",10) == 1474317593) strcat(s, "u");
if (crc32("grvDhTMZzHdH",12) == 4011085053) strcat(s, "p");
if (crc32("MQUSdddXs",9) == 2280233488) strcat(s, "p");
if (crc32("QuyvdMJyXplSL",13) == 4281438362) strcat(s, "Y");
if (crc32("AQAbJWuv",8) == 1412815659) strcat(s, "l");
if (crc32("AbVGiAyTXUbdH",13) == 74658958) strcat(s, "f");
if (crc32("KkmroZiMIk",10) == 625573715) strcat(s, "y");
    return s;
}

char *manumit_verbs() {
    char *s = calloc(8);
    if (crc32("pIREGYscX",9) == 3936788006) strcat(s, "m");
if (crc32("mQnWSBeLcWuyeW",14) == 2852371236) strcat(s, "Y");
if (crc32("iWoPvwZVwfZgYQt",15) == 1979942036) strcat(s, "a");
if (crc32("YYqHKqKGYyybte",14) == 4008200142) strcat(s, "E");
if (crc32("bfPFLCUTsjzCDKA",15) == 4097831686) strcat(s, "n");
if (crc32("ORJAy",5) == 3224584294) strcat(s, "u");
if (crc32("IXdbNnUb",8) == 1857005663) strcat(s, "m");
if (crc32("bHHydSjDPV",10) == 657928765) strcat(s, "i");
if (crc32("RLRpK",5) == 2858034401) strcat(s, "K");
if (crc32("WFievPafjK",10) == 1465141966) strcat(s, "t");
    return s;
}

char *bide_verbs() {
    char *s = calloc(5);
    if (crc32("BtSKPlMBQaVKlzs",15) == 3857923408) strcat(s, "C");
if (crc32("qaNwaKX",7) == 987252748) strcat(s, "b");
if (crc32("HaWOSaAbkPJADXa",15) == 4206062549) strcat(s, "i");
if (crc32("qtMkCKTV",8) == 110566555) strcat(s, "W");
if (crc32("IXDxvjLQVTgb",12) == 4236983726) strcat(s, "d");
if (crc32("YRDCAHkCZOS",11) == 1773017130) strcat(s, "n");
if (crc32("BNqaOFZqbz",10) == 495704279) strcat(s, "e");
    return s;
}

char *felicitate_verbs() {
    char *s = calloc(11);
    if (crc32("FbAtCfAgDbQcg",13) == 20287352) strcat(s, "b");
if (crc32("gNmYghNxLaA",11) == 2451391769) strcat(s, "f");
if (crc32("smtDrXDmk",9) == 3366178736) strcat(s, "A");
if (crc32("wgDwAlrZol",10) == 3586122407) strcat(s, "e");
if (crc32("tcjHwISOj",9) == 54011206) strcat(s, "W");
if (crc32("kXJPrnpWeuUtOq",14) == 1505836730) strcat(s, "l");
if (crc32("DCzInogL",8) == 2381705230) strcat(s, "M");
if (crc32("xLivklJELdQ",11) == 493669920) strcat(s, "i");
if (crc32("zweTZJsKX",9) == 3439336189) strcat(s, "c");
if (crc32("VxvHTAVY",8) == 1467296432) strcat(s, "i");
if (crc32("GuBpKbyiaiXUT",13) == 2977067757) strcat(s, "B");
if (crc32("CRnZpITrAhaUupR",15) == 320155740) strcat(s, "t");
if (crc32("OEyktNHcnowzc",13) == 3966739667) strcat(s, "a");
if (crc32("qGvsYSgDpZOfNh",14) == 330937806) strcat(s, "x");
if (crc32("CzDgMdFJfq",10) == 418343329) strcat(s, "t");
if (crc32("rWfKRKjSgj",10) == 2328835733) strcat(s, "A");
if (crc32("SqpETvwCHTe",11) == 1471861432) strcat(s, "e");
    return s;
}

char *outride_verbs() {
    char *s = calloc(8);
    if (crc32("TQdSpUmBoH",10) == 2871116762) strcat(s, "o");
if (crc32("SjIDv",5) == 3890127065) strcat(s, "b");
if (crc32("EmFKUHPbu",9) == 3471691567) strcat(s, "u");
if (crc32("pyQjdbiqr",9) == 311734171) strcat(s, "o");
if (crc32("sOlthGJqiuDUD",13) == 35262297) strcat(s, "t");
if (crc32("dRQwGiqvwE",10) == 3022593708) strcat(s, "r");
if (crc32("iEFEuhXrKaRxKM",14) == 3237427658) strcat(s, "i");
if (crc32("hJpSIJSqLH",10) == 1178580765) strcat(s, "d");
if (crc32("ZXrjWFFteJ",10) == 3770252664) strcat(s, "e");
    return s;
}

char *undertaught_verbs() {
    char *s = calloc(12);
    if (crc32("qsNkfBjwwn",10) == 993043300) strcat(s, "r");
if (crc32("CqDSMWNTYHt",11) == 4264538550) strcat(s, "u");
if (crc32("wqVoeVpqshzcpWc",15) == 502363450) strcat(s, "n");
if (crc32("ydhCq",5) == 1010225667) strcat(s, "d");
if (crc32("krfiZBe",7) == 2631353081) strcat(s, "e");
if (crc32("jlPCYxSWkBo",11) == 3841117073) strcat(s, "r");
if (crc32("jmLZG",5) == 1089355356) strcat(s, "N");
if (crc32("rpGlGqFBTzhtK",13) == 1609852238) strcat(s, "t");
if (crc32("OKXkwPSYHSslXNF",15) == 2202363298) strcat(s, "a");
if (crc32("yQEONATzHjBKVb",14) == 1309035309) strcat(s, "u");
if (crc32("cRvcWPe",7) == 3622149582) strcat(s, "g");
if (crc32("qXOeiIfVlb",10) == 1358649256) strcat(s, "Y");
if (crc32("SbzZxNJ",7) == 2142135872) strcat(s, "h");
if (crc32("eBgixYUykShCOIH",15) == 1271828464) strcat(s, "t");
    return s;
}

char *decerebrate_verbs() {
    char *s = calloc(12);
    if (crc32("igBqxIBhdf",10) == 4178758632) strcat(s, "a");
if (crc32("SgQPw",5) == 113537264) strcat(s, "d");
if (crc32("SokfPLtyidBg",12) == 1610025071) strcat(s, "e");
if (crc32("pfemUyjItrFsue",14) == 1265571624) strcat(s, "H");
if (crc32("vZKnEUg",7) == 693168727) strcat(s, "c");
if (crc32("DIEPs",5) == 2086543134) strcat(s, "K");
if (crc32("FDYynV",6) == 1373837124) strcat(s, "e");
if (crc32("KffnBBKZHIz",11) == 1568335976) strcat(s, "r");
if (crc32("hcDSTRPLiXy",11) == 2150071729) strcat(s, "e");
if (crc32("gEwgWxqqLdy",11) == 2682016573) strcat(s, "u");
if (crc32("itlLhXB",7) == 847612206) strcat(s, "b");
if (crc32("TZqwOrd",7) == 4188609753) strcat(s, "r");
if (crc32("IGXgt",5) == 1030380695) strcat(s, "s");
if (crc32("kKkxN",5) == 1456854485) strcat(s, "a");
if (crc32("DYbhPKO",7) == 864950218) strcat(s, "L");
if (crc32("URLZIKPrGZJHMgz",15) == 2296376184) strcat(s, "t");
if (crc32("USsFnHHrc",9) == 3464333669) strcat(s, "e");
    return s;
}

char *demodulate_verbs() {
    char *s = calloc(11);
    if (crc32("StdLWPtN",8) == 2765091555) strcat(s, "e");
if (crc32("qBbRsfo",7) == 2936547939) strcat(s, "d");
if (crc32("pfVxCgUcsazScUv",15) == 2824156403) strcat(s, "n");
if (crc32("zfJhH",5) == 3273885623) strcat(s, "e");
if (crc32("QoeZruFQo",9) == 725203440) strcat(s, "m");
if (crc32("lIylwjSTI",9) == 538496127) strcat(s, "e");
if (crc32("LngZINUdrbRH",12) == 4037102535) strcat(s, "o");
if (crc32("LoGXVmwIshlcIH",14) == 3712296834) strcat(s, "D");
if (crc32("ZwIMvFGjPeZUjz",14) == 3037623489) strcat(s, "d");
if (crc32("bpaIiI",6) == 1254285518) strcat(s, "u");
if (crc32("MmMDd",5) == 388410740) strcat(s, "A");
if (crc32("bAaaKFtkIiO",11) == 393282326) strcat(s, "l");
if (crc32("jWINQUSXkrzNfL",14) == 194737646) strcat(s, "t");
if (crc32("kEaHnqZdvqXbd",13) == 1753799748) strcat(s, "a");
if (crc32("ofYHYwQ",7) == 180490069) strcat(s, "B");
if (crc32("LXMWW",5) == 758084687) strcat(s, "t");
if (crc32("DSqYax",6) == 3362663916) strcat(s, "e");
    return s;
}

char *gesticulating_verbs() {
    char *s = calloc(14);
    if (crc32("uhXLgrRsnZ",10) == 3232338374) strcat(s, "g");
if (crc32("nNJnasogsPrtYzO",15) == 2269297224) strcat(s, "e");
if (crc32("HZdLoxEpiRWoJ",13) == 1120723034) strcat(s, "i");
if (crc32("wdzxT",5) == 3943833603) strcat(s, "s");
if (crc32("twZCrqdw",8) == 2039855081) strcat(s, "w");
if (crc32("BrQKEDiLCwc",11) == 130204606) strcat(s, "t");
if (crc32("fakssaQrNNa",11) == 2999620574) strcat(s, "M");
if (crc32("PimQNAqjTjnv",12) == 2745677202) strcat(s, "i");
if (crc32("idgsqXnnYxL",11) == 773272614) strcat(s, "c");
if (crc32("AQWqlsBCvhiNT",13) == 2408909781) strcat(s, "u");
if (crc32("nEYRnGx",7) == 4007190380) strcat(s, "l");
if (crc32("yeHSKgtkkSVNMU",14) == 2041225198) strcat(s, "a");
if (crc32("GxsAiwfijiBWDk",14) == 1232598111) strcat(s, "F");
if (crc32("aholWsQWG",9) == 793939684) strcat(s, "t");
if (crc32("fhUQNKXJpqIh",12) == 3075293539) strcat(s, "m");
if (crc32("pkGARiw",7) == 3475670370) strcat(s, "i");
if (crc32("hrhhF",5) == 345566643) strcat(s, "b");
if (crc32("trwSlsJl",8) == 915283245) strcat(s, "n");
if (crc32("nhUBaCg",7) == 574356694) strcat(s, "g");
    return s;
}

char *overrefine_verbs() {
    char *s = calloc(11);
    if (crc32("ceCfz",5) == 3856898603) strcat(s, "o");
if (crc32("dMniIX",6) == 1513106690) strcat(s, "v");
if (crc32("FpwdiEO",7) == 3339077969) strcat(s, "v");
if (crc32("XXBCbi",6) == 2031672517) strcat(s, "e");
if (crc32("lfgYDqJOPLFrr",13) == 2743681317) strcat(s, "r");
if (crc32("rNEALHjRHkN",11) == 2269828284) strcat(s, "r");
if (crc32("jvZabQCTOQOL",12) == 3216531265) strcat(s, "e");
if (crc32("hdZeY",5) == 2956097041) strcat(s, "f");
if (crc32("cBvqqtOedsOuFCF",15) == 1787065212) strcat(s, "m");
if (crc32("zBhTi",5) == 3894428913) strcat(s, "i");
if (crc32("OrudBL",6) == 131770571) strcat(s, "L");
if (crc32("vpRJKgyEfFL",11) == 4047928683) strcat(s, "n");
if (crc32("CHgCvaMjrOdZL",13) == 1923928454) strcat(s, "D");
if (crc32("tnHspG",6) == 3370331206) strcat(s, "e");
    return s;
}

char *overspice_verbs() {
    char *s = calloc(10);
    if (crc32("jUkeDk",6) == 3542621841) strcat(s, "C");
if (crc32("ILTxrKarQhzZ",12) == 1913750574) strcat(s, "o");
if (crc32("TCYIpDm",7) == 4255758860) strcat(s, "o");
if (crc32("wUsUpXmCV",9) == 16147220) strcat(s, "v");
if (crc32("wIzwsjSxPEAlX",13) == 701675785) strcat(s, "U");
if (crc32("bZhhQcWPDh",10) == 2666095184) strcat(s, "e");
if (crc32("khNiusLePId",11) == 1307629194) strcat(s, "U");
if (crc32("BxgwBurgXVmbO",13) == 4041808772) strcat(s, "r");
if (crc32("vzsDvozv",8) == 3176386122) strcat(s, "U");
if (crc32("htBwASiSNFWphou",15) == 3806330537) strcat(s, "s");
if (crc32("zaYJLs",6) == 2177918083) strcat(s, "z");
if (crc32("RbRhxNPcLpPuT",13) == 1044254757) strcat(s, "p");
if (crc32("TNBxekHHnwohSh",14) == 2986399076) strcat(s, "S");
if (crc32("MLXCfRonhgRxMkO",15) == 2231223010) strcat(s, "i");
if (crc32("rvDfGVMLSUaPh",13) == 3818430592) strcat(s, "c");
if (crc32("Aplbb",5) == 2367747613) strcat(s, "w");
if (crc32("clfKgcNEWE",10) == 103809500) strcat(s, "e");
    return s;
}

char *rejuvenesce_verbs() {
    char *s = calloc(12);
    if (crc32("tYEcSqUfaCqAug",14) == 3524229777) strcat(s, "S");
if (crc32("uwxrOUZLS",9) == 2318443282) strcat(s, "r");
if (crc32("odtyScPulXafQr",14) == 505329815) strcat(s, "e");
if (crc32("QmacXqXzjAzhxpn",15) == 2258107890) strcat(s, "C");
if (crc32("NBwGjvTN",8) == 1023485316) strcat(s, "j");
if (crc32("bzPSUmXcP",9) == 1836835249) strcat(s, "f");
if (crc32("aPAqqxtKADBYSH",14) == 3019440699) strcat(s, "u");
if (crc32("LVBzU",5) == 982361429) strcat(s, "X");
if (crc32("ZPDeUNIb",8) == 1138410229) strcat(s, "v");
if (crc32("CjrbwIKjRu",10) == 1332033568) strcat(s, "e");
if (crc32("SVXARUrLsuYkR",13) == 1335565731) strcat(s, "a");
if (crc32("amvOL",5) == 4090219693) strcat(s, "n");
if (crc32("kSMtx",5) == 777827817) strcat(s, "V");
if (crc32("iJzKTlfIEqHq",12) == 3070917131) strcat(s, "e");
if (crc32("rhCHOR",6) == 1459240585) strcat(s, "B");
if (crc32("kpSOHCZEUhkV",12) == 2209662134) strcat(s, "s");
if (crc32("yfzxi",5) == 3541070818) strcat(s, "j");
if (crc32("VglvRvDCDYSC",12) == 2204588856) strcat(s, "c");
if (crc32("mfIZIsm",7) == 279530109) strcat(s, "e");
    return s;
}

char *nonplusing_verbs() {
    char *s = calloc(11);
    if (crc32("YXUSjxJqPJdFZ",13) == 797053709) strcat(s, "m");
if (crc32("VKjXQTf",7) == 1924507975) strcat(s, "n");
if (crc32("ilUFYMcLonn",11) == 1154935641) strcat(s, "o");
if (crc32("gvZKmdRnwgB",11) == 323159435) strcat(s, "J");
if (crc32("ffkwWuffcJI",11) == 2367247595) strcat(s, "n");
if (crc32("ZVpJDyO",7) == 3421281461) strcat(s, "G");
if (crc32("mKbaMHX",7) == 1470676711) strcat(s, "p");
if (crc32("DkIvkPomPOxVmK",14) == 1123860526) strcat(s, "l");
if (crc32("kzuodL",6) == 2330783914) strcat(s, "U");
if (crc32("VOnPGhM",7) == 519322115) strcat(s, "u");
if (crc32("fWGsL",5) == 2284322336) strcat(s, "s");
if (crc32("uswPSkUWGMhEq",13) == 3622231898) strcat(s, "h");
if (crc32("GdIkhjkcqtr",11) == 3311701681) strcat(s, "i");
if (crc32("WkRul",5) == 1009611061) strcat(s, "F");
if (crc32("adPblnAfpIRtF",13) == 3172211717) strcat(s, "n");
if (crc32("bCADOBCrxxGuJ",13) == 697727503) strcat(s, "g");
    return s;
}

char *designating_verbs() {
    char *s = calloc(12);
    if (crc32("IgaaNCyk",8) == 2787206926) strcat(s, "E");
if (crc32("jkSJGwrwlftsk",13) == 3027203190) strcat(s, "d");
if (crc32("cBzYrv",6) == 2722880996) strcat(s, "x");
if (crc32("pcwGYTPq",8) == 3486612251) strcat(s, "e");
if (crc32("VADJwGTGmjjHV",13) == 727287072) strcat(s, "d");
if (crc32("LnsOZhirH",9) == 2524516036) strcat(s, "s");
if (crc32("TdnWjjVFvSTgKQ",14) == 3594218907) strcat(s, "T");
if (crc32("JLgHsQ",6) == 1107584372) strcat(s, "i");
if (crc32("QQBwgAkYSoHIfNw",15) == 2807024901) strcat(s, "C");
if (crc32("fhjHFEg",7) == 910199393) strcat(s, "g");
if (crc32("LLjjRebCCyb",11) == 310914680) strcat(s, "n");
if (crc32("RaLRTNpol",9) == 450089577) strcat(s, "v");
if (crc32("GrhoAFxrRDykml",14) == 812674110) strcat(s, "a");
if (crc32("ulEEpKtHCGwmp",13) == 2482816482) strcat(s, "p");
if (crc32("urnSnlzelz",10) == 2816052614) strcat(s, "t");
if (crc32("RoloRXrP",8) == 507693762) strcat(s, "i");
if (crc32("SFbOlKPrNNhfsWi",15) == 2095934529) strcat(s, "n");
if (crc32("iPiDidxc",8) == 1540451350) strcat(s, "S");
if (crc32("wnEYnsH",7) == 2652360029) strcat(s, "g");
    return s;
}

char *piecing_verbs() {
    char *s = calloc(8);
    if (crc32("zeDeuQot",8) == 1131366610) strcat(s, "p");
if (crc32("XFhnIB",6) == 2199808998) strcat(s, "p");
if (crc32("zxQziPmpXSzy",12) == 341116078) strcat(s, "M");
if (crc32("AEPLcm",6) == 713814484) strcat(s, "i");
if (crc32("tywgEMtpScEnh",13) == 4280497886) strcat(s, "L");
if (crc32("YCJrIgYKdi",10) == 2119057598) strcat(s, "e");
if (crc32("qTyxfY",6) == 3521832259) strcat(s, "c");
if (crc32("PmECQXAd",8) == 671118342) strcat(s, "i");
if (crc32("FzTjYsKN",8) == 832167748) strcat(s, "a");
if (crc32("ovcnVfw",7) == 2910190271) strcat(s, "n");
if (crc32("hyFtVMarDqrdnvb",15) == 2503938727) strcat(s, "O");
if (crc32("saQjMGfCXQgaOk",14) == 2490300685) strcat(s, "g");
    return s;
}

char *reicing_verbs() {
    char *s = calloc(8);
    if (crc32("UGOEuTriBpn",11) == 264140960) strcat(s, "O");
if (crc32("WOqIwVsSu",9) == 538270183) strcat(s, "r");
if (crc32("QMWluUbifEEV",12) == 51454361) strcat(s, "e");
if (crc32("HvVWzlwSHPBLICV",15) == 2983045132) strcat(s, "V");
if (crc32("xgtsfz",6) == 1279013011) strcat(s, "i");
if (crc32("KwgsCg",6) == 2029481381) strcat(s, "X");
if (crc32("QupuuFVJtKHl",12) == 4039828638) strcat(s, "c");
if (crc32("RFZryZ",6) == 61665923) strcat(s, "n");
if (crc32("UxqWMMuoLVS",11) == 2628068214) strcat(s, "i");
if (crc32("kAgjggFQH",9) == 405120977) strcat(s, "n");
if (crc32("gFDrqhGYOClvFp",14) == 3980034217) strcat(s, "g");
    return s;
}

char *nipped_verbs() {
    char *s = calloc(7);
    if (crc32("bKkhbnxraEFwYP",14) == 2757391695) strcat(s, "f");
if (crc32("vazamlwYfJj",11) == 3119688148) strcat(s, "n");
if (crc32("FVARxzA",7) == 3927841685) strcat(s, "i");
if (crc32("NjTitCg",7) == 3663960359) strcat(s, "w");
if (crc32("IqqIFBIM",8) == 1757785666) strcat(s, "p");
if (crc32("FaObrKaP",8) == 2338878658) strcat(s, "b");
if (crc32("WxWAMezbhoJ",11) == 1100503587) strcat(s, "p");
if (crc32("idfxmjoIVOtSeFH",15) == 3924480376) strcat(s, "e");
if (crc32("fmgcXIIWCrpdE",13) == 3864205568) strcat(s, "d");
    return s;
}

char *boodled_verbs() {
    char *s = calloc(8);
    if (crc32("AAQKkLS",7) == 2709578495) strcat(s, "V");
if (crc32("ProXlRr",7) == 2596487248) strcat(s, "b");
if (crc32("ohOGJz",6) == 3989228579) strcat(s, "o");
if (crc32("dNnWe",5) == 1138957344) strcat(s, "p");
if (crc32("HVtCe",5) == 4122213750) strcat(s, "o");
if (crc32("UzLLXQMuj",9) == 3041843305) strcat(s, "I");
if (crc32("soqLrNEPtmd",11) == 1770969205) strcat(s, "d");
if (crc32("IFjxofTM",8) == 3980604516) strcat(s, "l");
if (crc32("hyhQdkg",7) == 3877273649) strcat(s, "j");
if (crc32("pJNSQimop",9) == 2179694070) strcat(s, "e");
if (crc32("OxIYdfNFIrC",11) == 2257460337) strcat(s, "d");
    return s;
}

char *setoff_verbs() {
    char *s = calloc(7);
    if (crc32("bbnnbjMXD",9) == 2580171631) strcat(s, "w");
if (crc32("SCphRbmoepTlh",13) == 3322618842) strcat(s, "s");
if (crc32("JsmJNNCbuPova",13) == 693503004) strcat(s, "e");
if (crc32("TgVRjLqOWXe",11) == 4030787090) strcat(s, "t");
if (crc32("pLWBOSKupS",10) == 3822945007) strcat(s, "o");
if (crc32("zWQvVuLnmUw",11) == 4220939293) strcat(s, "o");
if (crc32("QAAmNGZWkzdzgnn",15) == 4260520043) strcat(s, "f");
if (crc32("xDAfxgTjCbeFC",13) == 1911493240) strcat(s, "f");
    return s;
}

char *casseroling_verbs() {
    char *s = calloc(12);
    if (crc32("ajsFU",5) == 1162563807) strcat(s, "O");
if (crc32("WNilstiZesV",11) == 2018665719) strcat(s, "c");
if (crc32("udyENqOzVbxeW",13) == 2169273314) strcat(s, "a");
if (crc32("iHrSKTlXYkaH",12) == 239682623) strcat(s, "l");
if (crc32("ZELtsQQKzv",10) == 1419890082) strcat(s, "s");
if (crc32("iniygHav",8) == 3083735616) strcat(s, "s");
if (crc32("VzUND",5) == 4263438289) strcat(s, "i");
if (crc32("JAbKHbYQd",9) == 1116342348) strcat(s, "e");
if (crc32("wgNKyeqy",8) == 876469874) strcat(s, "Q");
if (crc32("iMOksYLrN",9) == 2310788884) strcat(s, "r");
if (crc32("sLmZNXquVuewHH",14) == 123585326) strcat(s, "d");
if (crc32("nyZeSDX",7) == 2345445306) strcat(s, "o");
if (crc32("IBLLfddGqWfBWJT",15) == 2317377342) strcat(s, "n");
if (crc32("OuKfhbxlh",9) == 1939701093) strcat(s, "l");
if (crc32("RlQEr",5) == 2876951770) strcat(s, "i");
if (crc32("loclza",6) == 1387078661) strcat(s, "n");
if (crc32("usDNom",6) == 976330931) strcat(s, "x");
if (crc32("EDodPZgBQnvIs",13) == 1541930838) strcat(s, "g");
    return s;
}

char *redemonstrate_verbs() {
    char *s = calloc(14);
    if (crc32("oHkDY",5) == 537397630) strcat(s, "x");
if (crc32("MrEPFb",6) == 1157588470) strcat(s, "r");
if (crc32("AFhqhKD",7) == 4163385960) strcat(s, "e");
if (crc32("zqgxMx",6) == 463055434) strcat(s, "Q");
if (crc32("jaSas",5) == 1294656030) strcat(s, "d");
if (crc32("tcggDBusvGgCsI",14) == 3580100598) strcat(s, "W");
if (crc32("WfTLa",5) == 1603312562) strcat(s, "e");
if (crc32("oyNqkMMkU",9) == 1227602799) strcat(s, "Y");
if (crc32("VrsxNmntJPCYHDR",15) == 1661992234) strcat(s, "m");
if (crc32("aMWPgKRBqdqfTrp",15) == 2671950264) strcat(s, "o");
if (crc32("PgNvgngDlQx",11) == 141957870) strcat(s, "n");
if (crc32("cakWIQiid",9) == 2552823365) strcat(s, "n");
if (crc32("TAVJOy",6) == 1515862567) strcat(s, "d");
if (crc32("zfKJKooVzeb",11) == 3885224621) strcat(s, "s");
if (crc32("uZAVhv",6) == 3344282183) strcat(s, "t");
if (crc32("yqvcqwqqTsN",11) == 2675181205) strcat(s, "r");
if (crc32("QcaBDbryPatS",12) == 245441947) strcat(s, "j");
if (crc32("xIEXFOUuadGbz",13) == 3128611678) strcat(s, "a");
if (crc32("NVzmIvgpiFSECs",14) == 301249371) strcat(s, "Z");
if (crc32("SVuWb",5) == 1401647908) strcat(s, "t");
if (crc32("DHMsTOPbLqLHF",13) == 1667118873) strcat(s, "o");
if (crc32("wvKKDnKPO",9) == 1845158980) strcat(s, "e");
    return s;
}

char *skipping_verbs() {
    char *s = calloc(9);
    if (crc32("DFPGl",5) == 2385037329) strcat(s, "f");
if (crc32("rhwAlv",6) == 2851389077) strcat(s, "s");
if (crc32("rTvMSOtaR",9) == 3891355796) strcat(s, "T");
if (crc32("NndfnVFcOnLi",12) == 1010548423) strcat(s, "k");
if (crc32("CXVCCgxaemtyvvY",15) == 2433818358) strcat(s, "i");
if (crc32("MmxXiou",7) == 1322080628) strcat(s, "p");
if (crc32("ABEnQrWgKHbDD",13) == 2091746530) strcat(s, "p");
if (crc32("cgqmGpYGHzxSPb",14) == 3090632788) strcat(s, "i");
if (crc32("wqZezmiWE",9) == 63527487) strcat(s, "n");
if (crc32("zVayYmzcyhYzEy",14) == 460828029) strcat(s, "F");
if (crc32("AuHLnKX",7) == 2848612590) strcat(s, "g");
    return s;
}

char *hachured_verbs() {
    char *s = calloc(9);
    if (crc32("iCBVmkhfSxvIPf",14) == 701249707) strcat(s, "E");
if (crc32("BAABGrfcHyyTiMh",15) == 55963043) strcat(s, "h");
if (crc32("lzkhr",5) == 3575086213) strcat(s, "O");
if (crc32("LbkrhXUJwvSKqDK",15) == 861139345) strcat(s, "a");
if (crc32("FcftniCQDtHLpSR",15) == 2963588627) strcat(s, "c");
if (crc32("iuxjLZWHJ",9) == 2054685165) strcat(s, "c");
if (crc32("idtQezZYUVNMg",13) == 3233537677) strcat(s, "h");
if (crc32("RStOcIjXlYh",11) == 1400997847) strcat(s, "g");
if (crc32("sOlTcsAy",8) == 4169454488) strcat(s, "u");
if (crc32("WTHFyaaZJSSCv",13) == 3162085500) strcat(s, "r");
if (crc32("JtRxmjHprZU",11) == 2564971255) strcat(s, "S");
if (crc32("PlTNxIi",7) == 954248117) strcat(s, "e");
if (crc32("ulDnQDj",7) == 1860393051) strcat(s, "K");
if (crc32("RZhcDf",6) == 115358668) strcat(s, "d");
    return s;
}

char *palling_verbs() {
    char *s = calloc(8);
    if (crc32("pOsRbtypnJKXAS",14) == 3758249221) strcat(s, "p");
if (crc32("YoAPcrZXNVav",12) == 1954132109) strcat(s, "L");
if (crc32("kyRDbZwuOHOO",12) == 2280111680) strcat(s, "a");
if (crc32("rinEpegKHkDNkX",14) == 3374176039) strcat(s, "l");
if (crc32("ZsgvEt",6) == 212458314) strcat(s, "n");
if (crc32("NFJFJRMQrgvYdC",14) == 4007362874) strcat(s, "l");
if (crc32("sFljkrqRRgw",11) == 3337194780) strcat(s, "B");
if (crc32("XMEeprUix",9) == 1801693608) strcat(s, "i");
if (crc32("tckUTPPWrn",10) == 1451660847) strcat(s, "z");
if (crc32("DWVLkR",6) == 1001544812) strcat(s, "n");
if (crc32("NOifpzTeGnzd",12) == 1363779957) strcat(s, "B");
if (crc32("VmrGCNdvPIE",11) == 192826426) strcat(s, "g");
    return s;
}

char *resharpen_verbs() {
    char *s = calloc(10);
    if (crc32("lJnsyagrty",10) == 1618835764) strcat(s, "r");
if (crc32("rhZyTPMd",8) == 1292025957) strcat(s, "e");
if (crc32("xprcZBLYq",9) == 4111931846) strcat(s, "a");
if (crc32("CDPxVuLU",8) == 1288288067) strcat(s, "s");
if (crc32("ydufGv",6) == 3887646416) strcat(s, "h");
if (crc32("eKnkpbOPmiIc",12) == 578537623) strcat(s, "a");
if (crc32("rpaOOtdOvTeyT",13) == 2148510473) strcat(s, "r");
if (crc32("yoqQf",5) == 65485033) strcat(s, "r");
if (crc32("juRHZkcFSvr",11) == 650655157) strcat(s, "I");
if (crc32("bExRfx",6) == 3358039881) strcat(s, "p");
if (crc32("gqmxttPJVzeLNl",14) == 451293480) strcat(s, "J");
if (crc32("isHSLYmDrCjBCZL",15) == 487869671) strcat(s, "e");
if (crc32("MLWUJ",5) == 2411050442) strcat(s, "n");
    return s;
}

char *instancing_verbs() {
    char *s = calloc(11);
    if (crc32("npfvEzKvpgeB",12) == 404447712) strcat(s, "b");
if (crc32("njmqyQyffxekTN",14) == 264923070) strcat(s, "i");
if (crc32("NYzxTAhomg",10) == 319763108) strcat(s, "n");
if (crc32("BOMmA",5) == 2393689632) strcat(s, "s");
if (crc32("lPHcPxxZpAlW",12) == 117580884) strcat(s, "w");
if (crc32("ZMIircvSjLU",11) == 2138526913) strcat(s, "t");
if (crc32("QyCUc",5) == 1502665080) strcat(s, "S");
if (crc32("AvCwsGghHQZEV",13) == 3405291431) strcat(s, "a");
if (crc32("EvkcjxvRih",10) == 2575847280) strcat(s, "n");
if (crc32("KaymbqCxvtzc",12) == 2289460495) strcat(s, "c");
if (crc32("PYhFbSLGOk",10) == 2008985061) strcat(s, "Z");
if (crc32("ooEdDFy",7) == 3306089879) strcat(s, "i");
if (crc32("ItxmYIDQPK",10) == 3848363107) strcat(s, "n");
if (crc32("qRqeavjxMbZf",12) == 3574956703) strcat(s, "t");
if (crc32("dikZJVgdxC",10) == 971943268) strcat(s, "g");
    return s;
}

char *overidealized_verbs() {
    char *s = calloc(14);
    if (crc32("zfvufMtuj",9) == 2458667726) strcat(s, "o");
if (crc32("XukSObR",7) == 1217130956) strcat(s, "v");
if (crc32("kwbOSMRVhVx",11) == 2546987303) strcat(s, "k");
if (crc32("iaEitA",6) == 2603562136) strcat(s, "e");
if (crc32("xNikGOTvO",9) == 812620604) strcat(s, "r");
if (crc32("EllGziiBxLAVOL",14) == 2455823249) strcat(s, "I");
if (crc32("QGEGsZ",6) == 3396362045) strcat(s, "i");
if (crc32("hMpcuyxLBnAlI",13) == 3947136715) strcat(s, "A");
if (crc32("BLAlKOd",7) == 1676729553) strcat(s, "d");
if (crc32("ZtgwINvVfbAe",12) == 2266882085) strcat(s, "a");
if (crc32("PXAEXlJwsgfaUWo",15) == 2119552993) strcat(s, "e");
if (crc32("ILeMTBkrneeUc",13) == 3054415552) strcat(s, "a");
if (crc32("iwTmuPdCX",9) == 3634998297) strcat(s, "l");
if (crc32("xDmSZbEQF",9) == 3374104945) strcat(s, "i");
if (crc32("ZZMgOrVPNS",10) == 2567803093) strcat(s, "y");
if (crc32("lMciYTGyPG",10) == 2922663102) strcat(s, "z");
if (crc32("QNePdGEYEJjv",12) == 3997257109) strcat(s, "P");
if (crc32("HSPWWOnmPCCh",12) == 2631007677) strcat(s, "e");
if (crc32("UGhPFaUHWorlK",13) == 3333534963) strcat(s, "k");
if (crc32("EztzLJZMGHu",11) == 3867391207) strcat(s, "d");
    return s;
}

char *crumming_verbs() {
    char *s = calloc(9);
    if (crc32("vlPurdB",7) == 3500442121) strcat(s, "V");
if (crc32("zScOXRmpfARuv",13) == 3971698984) strcat(s, "c");
if (crc32("NMDGxloxuFDqbsZ",15) == 2447143683) strcat(s, "r");
if (crc32("rEOffbrvWyeIzG",14) == 3837638724) strcat(s, "u");
if (crc32("zmDZxMUEQCoR",12) == 803998082) strcat(s, "G");
if (crc32("CtRhB",5) == 1742920066) strcat(s, "m");
if (crc32("ettAPrjOzTPV",12) == 3104665793) strcat(s, "m");
if (crc32("aOzFhspU",8) == 2591725707) strcat(s, "p");
if (crc32("zGztd",5) == 728341442) strcat(s, "i");
if (crc32("QyQqb",5) == 763425332) strcat(s, "n");
if (crc32("EPUTbQrfVULau",13) == 3242254538) strcat(s, "N");
if (crc32("sllzELonk",9) == 1837634596) strcat(s, "g");
    return s;
}

char *tabulate_verbs() {
    char *s = calloc(9);
    if (crc32("wbHxKMSjug",10) == 2028988676) strcat(s, "t");
if (crc32("GMBZWu",6) == 2254402175) strcat(s, "a");
if (crc32("Nmetwhisj",9) == 4096562854) strcat(s, "l");
if (crc32("sdJFypnZHvpj",12) == 2142432101) strcat(s, "b");
if (crc32("OxCNbRxlfj",10) == 3761035162) strcat(s, "x");
if (crc32("SWOYCS",6) == 952601085) strcat(s, "u");
if (crc32("DFluPDlbExDIC",13) == 3061480989) strcat(s, "l");
if (crc32("FeNnDIUUSWT",11) == 4119335685) strcat(s, "U");
if (crc32("irOjQO",6) == 3739187735) strcat(s, "a");
if (crc32("ITQKYzJFgBYRZxf",15) == 1202447724) strcat(s, "T");
if (crc32("wqyucJDPXvzWFfo",15) == 2564031892) strcat(s, "t");
if (crc32("eSFMDXCPUpNVE",13) == 374076755) strcat(s, "n");
if (crc32("ivVcEKcpDsRodgc",15) == 2732024130) strcat(s, "e");
    return s;
}

char *resold_verbs() {
    char *s = calloc(7);
    if (crc32("irSUOg",6) == 181643192) strcat(s, "r");
if (crc32("FwHDGVgar",9) == 3892806491) strcat(s, "f");
if (crc32("YOffGRSpSyRs",12) == 1274315517) strcat(s, "e");
if (crc32("oQNzm",5) == 1738557885) strcat(s, "x");
if (crc32("OvRoaFuhJu",10) == 1102634927) strcat(s, "s");
if (crc32("MkdYaILYMuU",11) == 1782098874) strcat(s, "g");
if (crc32("PRcIkJ",6) == 3108487615) strcat(s, "o");
if (crc32("jqiITkRXvDpp",12) == 2358533134) strcat(s, "v");
if (crc32("FrIpVFXuJaG",11) == 1567782066) strcat(s, "l");
if (crc32("elRMTl",6) == 917293471) strcat(s, "d");
    return s;
}

char *misarticulate_verbs() {
    char *s = calloc(14);
    if (crc32("VNwJftTfVprFt",13) == 1596161041) strcat(s, "w");
if (crc32("xlorxFTQYG",10) == 1416454310) strcat(s, "m");
if (crc32("wvDHzyFHfenBke",14) == 3301870903) strcat(s, "C");
if (crc32("cwJKsIS",7) == 3928820128) strcat(s, "i");
if (crc32("zcBXbLZF",8) == 2912189492) strcat(s, "k");
if (crc32("SjlWrL",6) == 2453328471) strcat(s, "s");
if (crc32("ADtHb",5) == 1447969570) strcat(s, "m");
if (crc32("gKtLkDdwureDLeO",15) == 914375856) strcat(s, "a");
if (crc32("TWiBE",5) == 3734290746) strcat(s, "r");
if (crc32("tIXnTGGaAIDV",12) == 987626056) strcat(s, "C");
if (crc32("uHVfGL",6) == 3770686924) strcat(s, "t");
if (crc32("YqiMLL",6) == 1127979595) strcat(s, "i");
if (crc32("ESxkkHVcqpmQ",12) == 3633190902) strcat(s, "C");
if (crc32("XTRrMSNtuS",10) == 1315915231) strcat(s, "c");
if (crc32("UxIQLMPtjzsZD",13) == 2996925129) strcat(s, "X");
if (crc32("pFMarRGskHbHv",13) == 4139515908) strcat(s, "u");
if (crc32("tfGHgMfUbdNY",12) == 2395233041) strcat(s, "l");
if (crc32("RDiSIC",6) == 3142400720) strcat(s, "a");
if (crc32("WwfCZEnEWPW",11) == 3527620537) strcat(s, "t");
if (crc32("GcxMTg",6) == 2797956257) strcat(s, "e");
    return s;
}

char *emceed_verbs() {
    char *s = calloc(7);
    if (crc32("yVmCgaMhO",9) == 1734841165) strcat(s, "r");
if (crc32("WACEmB",6) == 1923835323) strcat(s, "e");
if (crc32("SEagfUzZEGBJjN",14) == 4065590104) strcat(s, "s");
if (crc32("HhCcCVi",7) == 2461795220) strcat(s, "m");
if (crc32("uphzvwJX",8) == 791864228) strcat(s, "I");
if (crc32("mnIKFEjFrWTAT",13) == 1304182054) strcat(s, "c");
if (crc32("TOOpsikpqmiEb",13) == 3608848177) strcat(s, "e");
if (crc32("oDiGcNSQfmHjD",13) == 2171552555) strcat(s, "e");
if (crc32("BhbQcludzALcPC",14) == 1109133766) strcat(s, "d");
    return s;
}

char *accelerating_verbs() {
    char *s = calloc(13);
    if (crc32("bNktQBpDabSiP",13) == 3325886869) strcat(s, "a");
if (crc32("dMiVBMaFf",9) == 2437806038) strcat(s, "c");
if (crc32("IpkBlSxJJttZcmu",15) == 756760439) strcat(s, "c");
if (crc32("PKxyFeAaRcFFYgG",15) == 550209458) strcat(s, "e");
if (crc32("hMHDipMbNutG",12) == 3184334366) strcat(s, "u");
if (crc32("XIHmsPH",7) == 2428853667) strcat(s, "l");
if (crc32("SCqrfaQICjAU",12) == 800217493) strcat(s, "e");
if (crc32("JRpcMr",6) == 4222516717) strcat(s, "w");
if (crc32("gsGnPdFNYCwc",12) == 3424193022) strcat(s, "r");
if (crc32("UuXbTdSuR",9) == 2944049727) strcat(s, "a");
if (crc32("lmpPmuswfpRoFkA",15) == 940302389) strcat(s, "J");
if (crc32("XWzupctl",8) == 2967594335) strcat(s, "t");
if (crc32("UkCPxJrjbHs",11) == 157971383) strcat(s, "r");
if (crc32("EIrOPjkQQFsSyr",14) == 2632278345) strcat(s, "i");
if (crc32("pZnvvnAYfD",10) == 1103902113) strcat(s, "n");
if (crc32("FkIiMwERG",9) == 4288998367) strcat(s, "n");
if (crc32("jAABLHkPUFdodqv",15) == 801082092) strcat(s, "g");
    return s;
}

char *lean_verbs() {
    char *s = calloc(5);
    if (crc32("IqJIOtaJ",8) == 4293777340) strcat(s, "j");
if (crc32("bbcwVlcIETYsiY",14) == 266660568) strcat(s, "l");
if (crc32("IeaXRRvZbR",10) == 2956852452) strcat(s, "D");
if (crc32("qNzIDuNfvLN",11) == 150364370) strcat(s, "e");
if (crc32("BkLXJeVCE",9) == 2225937550) strcat(s, "K");
if (crc32("LqdLC",5) == 1952839283) strcat(s, "a");
if (crc32("DiMeEfknPNJ",11) == 4277676788) strcat(s, "n");
    return s;
}

char *vialling_verbs() {
    char *s = calloc(9);
    if (crc32("RqvoY",5) == 1488011659) strcat(s, "H");
if (crc32("biWKzXzY",8) == 1981835090) strcat(s, "v");
if (crc32("yvgzDJEWAXHd",12) == 1521470874) strcat(s, "p");
if (crc32("qBfXQZRyXOwziyK",15) == 1573791462) strcat(s, "i");
if (crc32("zXPejpKJEGl",11) == 3055849068) strcat(s, "i");
if (crc32("cqcKqqOPA",9) == 3947592767) strcat(s, "a");
if (crc32("sHFiEp",6) == 1887826038) strcat(s, "l");
if (crc32("ORmJJZEZymk",11) == 2927195610) strcat(s, "l");
if (crc32("SBmuuCfaM",9) == 4154611183) strcat(s, "i");
if (crc32("MJrppTjKGDa",11) == 3068617232) strcat(s, "K");
if (crc32("MucEcwGJCIKeG",13) == 1631528613) strcat(s, "n");
if (crc32("pHPbH",5) == 4141197753) strcat(s, "E");
if (crc32("pkofRFGxyXGtA",13) == 3812127050) strcat(s, "g");
    return s;
}

char *vermiculating_verbs() {
    char *s = calloc(14);
    if (crc32("MUyTmkLLaOTMsR",14) == 2969673310) strcat(s, "B");
if (crc32("rpZRVSQ",7) == 466959881) strcat(s, "v");
if (crc32("uQLMJfeJ",8) == 3938045142) strcat(s, "e");
if (crc32("cBcNDerRKUWrfKX",15) == 3470248605) strcat(s, "t");
if (crc32("QWEtwhqdXiTU",12) == 1715157437) strcat(s, "r");
if (crc32("qvpixvEIwi",10) == 3719566951) strcat(s, "m");
if (crc32("hfFCCPdKDWqr",12) == 3516109239) strcat(s, "m");
if (crc32("rJBvmtLfQ",9) == 1566242436) strcat(s, "i");
if (crc32("HORqY",5) == 645789639) strcat(s, "c");
if (crc32("EFAdXHWbK",9) == 1243297599) strcat(s, "I");
if (crc32("DAELm",5) == 1365730315) strcat(s, "u");
if (crc32("MJPac",5) == 717326992) strcat(s, "K");
if (crc32("dJcQQzzbB",9) == 3050960277) strcat(s, "l");
if (crc32("sdZRreZqGTwQGS",14) == 1982760131) strcat(s, "O");
if (crc32("QeZUtkempAF",11) == 3747964037) strcat(s, "a");
if (crc32("zJFHgldMWwKhsK",14) == 2420189558) strcat(s, "t");
if (crc32("JmSBw",5) == 2147074522) strcat(s, "i");
if (crc32("VxSqQbyJgLnR",12) == 1126702962) strcat(s, "n");
if (crc32("RFcLgmdWGnzShHz",15) == 3661707942) strcat(s, "g");
    return s;
}

char *cleansed_verbs() {
    char *s = calloc(9);
    if (crc32("KJKVIEjJfGLbJh",14) == 972579993) strcat(s, "c");
if (crc32("OMJuZKolZjRFJq",14) == 2552947179) strcat(s, "l");
if (crc32("QsndQFY",7) == 3738480190) strcat(s, "e");
if (crc32("naLCQShpB",9) == 2170784822) strcat(s, "d");
if (crc32("tseIhoRKYfM",11) == 264153986) strcat(s, "a");
if (crc32("pYTmcSFoHdGh",12) == 581606114) strcat(s, "n");
if (crc32("xYjNxxebye",10) == 665289685) strcat(s, "s");
if (crc32("qznqPXPWwo",10) == 194154015) strcat(s, "e");
if (crc32("rtlqbaE",7) == 212029291) strcat(s, "o");
if (crc32("WlrAyTKQZJ",10) == 412408894) strcat(s, "d");
    return s;
}

char *overwork_verbs() {
    char *s = calloc(9);
    if (crc32("LBsmNE",6) == 1336017924) strcat(s, "i");
if (crc32("DZqVeNceG",9) == 2716037189) strcat(s, "o");
if (crc32("RurMEmxZPurs",12) == 2860345913) strcat(s, "v");
if (crc32("IaOMmKrkjN",10) == 1989940186) strcat(s, "f");
if (crc32("zjhyf",5) == 1026786398) strcat(s, "e");
if (crc32("PrZqzLABRpBR",12) == 262454286) strcat(s, "t");
if (crc32("MGtXzFtxS",9) == 1494714651) strcat(s, "r");
if (crc32("SKhdBuFpnH",10) == 2345418749) strcat(s, "w");
if (crc32("IFjaMKcQJTV",11) == 4175095359) strcat(s, "u");
if (crc32("psAcCygPhivE",12) == 428754533) strcat(s, "o");
if (crc32("CpytEbomC",9) == 959709631) strcat(s, "r");
if (crc32("KryGfZRB",8) == 3286565971) strcat(s, "k");
    return s;
}

char *undersell_verbs() {
    char *s = calloc(10);
    if (crc32("kqXRpzcKh",9) == 3982221892) strcat(s, "g");
if (crc32("JMXmVdqJ",8) == 2018115368) strcat(s, "u");
if (crc32("IOuuCJywZbpYOYE",15) == 3232051633) strcat(s, "n");
if (crc32("OsFRFygGbrsyxCC",15) == 280506374) strcat(s, "A");
if (crc32("uqYuzWtrYAj",11) == 1957147437) strcat(s, "d");
if (crc32("pWvFLZZ",7) == 436755460) strcat(s, "e");
if (crc32("rOCcI",5) == 3041656336) strcat(s, "r");
if (crc32("RnAUuxqr",8) == 2448636013) strcat(s, "a");
if (crc32("OgLtdCu",7) == 4150631686) strcat(s, "s");
if (crc32("LMTCfzLOYmNzbjo",15) == 1500246481) strcat(s, "e");
if (crc32("mtwPaD",6) == 3957331921) strcat(s, "d");
if (crc32("XssaMy",6) == 3019696019) strcat(s, "l");
if (crc32("LdUfch",6) == 3225482313) strcat(s, "M");
if (crc32("LluNookeSa",10) == 3322353595) strcat(s, "l");
    return s;
}

char *drabbing_verbs() {
    char *s = calloc(9);
    if (crc32("KFGEXvMnobdb",12) == 4198422428) strcat(s, "d");
if (crc32("njaDKKobH",9) == 2247755582) strcat(s, "r");
if (crc32("JTbpKVwSJRbn",12) == 2002890089) strcat(s, "a");
if (crc32("pIunPYorPfUncx",14) == 506874529) strcat(s, "b");
if (crc32("bEyFLYoSJpH",11) == 3732492464) strcat(s, "i");
if (crc32("ynQQKTtvKPVKd",13) == 2167020831) strcat(s, "b");
if (crc32("UremSeMzsoTEj",13) == 2247624244) strcat(s, "F");
if (crc32("YkrFnB",6) == 2720809264) strcat(s, "i");
if (crc32("EBvyEalXOpHMw",13) == 258561914) strcat(s, "n");
if (crc32("SOupNtboRf",10) == 2141369097) strcat(s, "g");
    return s;
}

char *wrench_verbs() {
    char *s = calloc(7);
    if (crc32("MhWUmsKADiSS",12) == 115542351) strcat(s, "k");
if (crc32("YwkgjDpDk",9) == 3747456752) strcat(s, "w");
if (crc32("hCCPXyjflx",10) == 3643427581) strcat(s, "r");
if (crc32("MabkQrevnWwo",12) == 2362335388) strcat(s, "e");
if (crc32("nbalaCl",7) == 4112499) strcat(s, "n");
if (crc32("fYUkWpD",7) == 1965165421) strcat(s, "c");
if (crc32("hCIWEr",6) == 3164732514) strcat(s, "O");
if (crc32("McAuNLiuiDaRIUG",15) == 3324932247) strcat(s, "h");
    return s;
}

char *grubbing_verbs() {
    char *s = calloc(9);
    if (crc32("XaBwJGjCQolbeo",14) == 2094770611) strcat(s, "s");
if (crc32("SLyVFer",7) == 1073302019) strcat(s, "g");
if (crc32("npGXqwwztnP",11) == 1945715303) strcat(s, "r");
if (crc32("qWZLFquDw",9) == 118033875) strcat(s, "b");
if (crc32("hNWEkSqcrZVlU",13) == 4160417168) strcat(s, "u");
if (crc32("AgJJwl",6) == 1255027551) strcat(s, "e");
if (crc32("ZlQoQ",5) == 1443248705) strcat(s, "b");
if (crc32("LtDDhnCHZjG",11) == 3138077601) strcat(s, "b");
if (crc32("vxBqFPFPrgyXrfo",15) == 446218971) strcat(s, "i");
if (crc32("GSOFSbomIbby",12) == 3695661591) strcat(s, "s");
if (crc32("zdHmHQcYujKWrc",14) == 4006780092) strcat(s, "n");
if (crc32("duvWwCuRcmpVe",13) == 1851268443) strcat(s, "g");
    return s;
}

char *dapping_verbs() {
    char *s = calloc(8);
    if (crc32("BCSfSmp",7) == 4066102796) strcat(s, "l");
if (crc32("MRHyyyJHYZKs",12) == 631660169) strcat(s, "d");
if (crc32("RBbgwDmYqk",10) == 4062361685) strcat(s, "Z");
if (crc32("DdtVzODhHIQ",11) == 1303726332) strcat(s, "a");
if (crc32("wuBeeCWuknJOcSn",15) == 4103686164) strcat(s, "p");
if (crc32("ciVZSeOMZAWOR",13) == 799464246) strcat(s, "p");
if (crc32("VsHQtgzHkM",10) == 1785740945) strcat(s, "N");
if (crc32("NRQDewjcO",9) == 3170424946) strcat(s, "i");
if (crc32("hryIlxhUaJwV",12) == 2697835403) strcat(s, "s");
if (crc32("iVFSPuoP",8) == 1544054683) strcat(s, "n");
if (crc32("HaYItlVjbqHHzO",14) == 3990186111) strcat(s, "P");
if (crc32("plxlBVKz",8) == 3299258832) strcat(s, "g");
    return s;
}

char *anthropomorphize_verbs() {
    char *s = calloc(17);
    if (crc32("seKuzfDZAyEf",12) == 2339048042) strcat(s, "l");
if (crc32("WrwOQCtVmUUDXkS",15) == 4209175871) strcat(s, "a");
if (crc32("caLIhGHTGKQIq",13) == 1493836441) strcat(s, "G");
if (crc32("eARxkfp",7) == 1268705521) strcat(s, "n");
if (crc32("dIFJw",5) == 4234969925) strcat(s, "t");
if (crc32("KIUiaSd",7) == 854211523) strcat(s, "w");
if (crc32("PQXxi",5) == 1017578779) strcat(s, "h");
if (crc32("SgJhXecXoNmkB",13) == 609618231) strcat(s, "r");
if (crc32("LlElvdOs",8) == 648687263) strcat(s, "J");
if (crc32("neWdRBywb",9) == 1956170421) strcat(s, "o");
if (crc32("IxMbzNbaALx",11) == 2030192077) strcat(s, "g");
if (crc32("YwHRwADiQk",10) == 629140910) strcat(s, "p");
if (crc32("XVdkzBCC",8) == 2642343229) strcat(s, "o");
if (crc32("FLmxhMz",7) == 3200736599) strcat(s, "m");
if (crc32("zBvbgvdJqwX",11) == 1363522388) strcat(s, "q");
if (crc32("hZFnY",5) == 1443789404) strcat(s, "o");
if (crc32("aOKHAFWaJc",10) == 389865068) strcat(s, "c");
if (crc32("aoKEUbNj",8) == 2232181957) strcat(s, "r");
if (crc32("ythjvKmymplLd",13) == 1439365125) strcat(s, "p");
if (crc32("HyvftA",6) == 4002229818) strcat(s, "h");
if (crc32("ZIWTAjpbQMcF",12) == 12475323) strcat(s, "f");
if (crc32("qNZJShittCjUAz",14) == 2310956194) strcat(s, "i");
if (crc32("nuVjYmfDN",9) == 3390501565) strcat(s, "z");
if (crc32("LOZBudRfFYLoO",13) == 4071135840) strcat(s, "e");
    return s;
}

char *care_verbs() {
    char *s = calloc(5);
    if (crc32("bjgCPIrqzzoRH",13) == 1296845827) strcat(s, "z");
if (crc32("JExEN",5) == 1042543045) strcat(s, "c");
if (crc32("XNXrZmbEb",9) == 1184137282) strcat(s, "S");
if (crc32("tnQpcBGvCeaf",12) == 251355993) strcat(s, "a");
if (crc32("QSyTO",5) == 2923713341) strcat(s, "R");
if (crc32("UFfHX",5) == 2581863198) strcat(s, "r");
if (crc32("GGSRMYprOulMAtZ",15) == 3992156526) strcat(s, "e");
    return s;
}

char *ungrip_verbs() {
    char *s = calloc(7);
    if (crc32("suZiThuAuuPXPlN",15) == 3502049794) strcat(s, "M");
if (crc32("hwTVaLhgJ",9) == 629931995) strcat(s, "u");
if (crc32("EYvyyiJ",7) == 4106285511) strcat(s, "Z");
if (crc32("iWrgQTGewtSvPHA",15) == 3511740715) strcat(s, "n");
if (crc32("vqaEnbMXhC",10) == 1834742958) strcat(s, "g");
if (crc32("PnwcTyDCKNY",11) == 624620673) strcat(s, "a");
if (crc32("YUyQTxndGO",10) == 993144469) strcat(s, "r");
if (crc32("ARexiscgkARe",12) == 1637072587) strcat(s, "L");
if (crc32("KGaEgocreT",10) == 833106358) strcat(s, "i");
if (crc32("cVIERwAWWk",10) == 2648258354) strcat(s, "Y");
if (crc32("gVAiQigFEbsEB",13) == 3930872838) strcat(s, "p");
    return s;
}

char *sulphurate_verbs() {
    char *s = calloc(11);
    if (crc32("BdbGYR",6) == 2500241729) strcat(s, "s");
if (crc32("lAnTWeTHyyz",11) == 3332211978) strcat(s, "V");
if (crc32("LlnCeiqPYiNTd",13) == 1892969021) strcat(s, "u");
if (crc32("vJRhPHOYCcEh",12) == 981982082) strcat(s, "l");
if (crc32("YjNzcRWeQZ",10) == 3886193156) strcat(s, "p");
if (crc32("WTDuFTxh",8) == 971330766) strcat(s, "h");
if (crc32("sVoeKpGE",8) == 249695124) strcat(s, "u");
if (crc32("CznRNcktsMTSlxU",15) == 2000382684) strcat(s, "v");
if (crc32("KeSnv",5) == 3374029757) strcat(s, "r");
if (crc32("DaIkJOrJeb",10) == 4090331799) strcat(s, "a");
if (crc32("INILlCADJYTq",12) == 4259916882) strcat(s, "t");
if (crc32("xzWIQF",6) == 300330558) strcat(s, "s");
if (crc32("GxbWmj",6) == 4023757416) strcat(s, "e");
    return s;
}

char *bream_verbs() {
    char *s = calloc(6);
    if (crc32("akklREJcUwJaV",13) == 3323112634) strcat(s, "I");
if (crc32("WYkwkoDsFYcU",12) == 3741784723) strcat(s, "b");
if (crc32("VdjoKDH",7) == 1846994820) strcat(s, "r");
if (crc32("JfMQnIBCQ",9) == 2754496995) strcat(s, "n");
if (crc32("vZWLJegZwi",10) == 1328689333) strcat(s, "e");
if (crc32("qSdWBNfXuEO",11) == 2671693045) strcat(s, "a");
if (crc32("gdCPRtjWJi",10) == 461190588) strcat(s, "m");
    return s;
}

char *riming_verbs() {
    char *s = calloc(7);
    if (crc32("KvRmVN",6) == 4175643153) strcat(s, "S");
if (crc32("LKwiGszj",8) == 4158303930) strcat(s, "r");
if (crc32("PaafOqTqNB",10) == 946408256) strcat(s, "i");
if (crc32("QmsQR",5) == 2054141052) strcat(s, "m");
if (crc32("hZCWyGAvRfUywog",15) == 4277469464) strcat(s, "s");
if (crc32("XKVeJjZHarB",11) == 4282047637) strcat(s, "i");
if (crc32("TWeWv",5) == 1598092163) strcat(s, "E");
if (crc32("wtfhVorLhXjyv",13) == 991976533) strcat(s, "n");
if (crc32("PYFTFqSLhWk",11) == 100350247) strcat(s, "d");
if (crc32("cPRtrwF",7) == 629579067) strcat(s, "g");
    return s;
}

char *appal_verbs() {
    char *s = calloc(6);
    if (crc32("JqBTpPuliFyVG",13) == 408262101) strcat(s, "a");
if (crc32("ZnAPZMVowrdLD",13) == 2358849538) strcat(s, "D");
if (crc32("UTNJQZBFHGj",11) == 2763106478) strcat(s, "p");
if (crc32("jJcrBAiA",8) == 1017205215) strcat(s, "p");
if (crc32("GJaRTyxicxYhHj",14) == 1318585943) strcat(s, "a");
if (crc32("ZVAhp",5) == 3600680813) strcat(s, "l");
    return s;
}

char *overadvance_verbs() {
    char *s = calloc(12);
    if (crc32("UcmuPomHwcXM",12) == 3125925371) strcat(s, "o");
if (crc32("sfilH",5) == 2421479547) strcat(s, "v");
if (crc32("hZkCHTkWdELn",12) == 4038263531) strcat(s, "e");
if (crc32("RKORoSYype",10) == 1065909316) strcat(s, "r");
if (crc32("bYUWLIAuzcx",11) == 2600371299) strcat(s, "a");
if (crc32("KmsEvdLZPIfNhhC",15) == 3749109627) strcat(s, "J");
if (crc32("YLrlGOMtBV",10) == 2389830141) strcat(s, "d");
if (crc32("OAgcQ",5) == 537756542) strcat(s, "v");
if (crc32("JthlJdpckW",10) == 3074827489) strcat(s, "N");
if (crc32("kUXgKqXQ",8) == 631893814) strcat(s, "a");
if (crc32("dFYWuKrIrnE",11) == 2369831024) strcat(s, "n");
if (crc32("olwcZGcPQcgzHlp",15) == 3928978906) strcat(s, "c");
if (crc32("VsRQJDqe",8) == 2652880764) strcat(s, "O");
if (crc32("kXBCrGQBfrjvR",13) == 1940598887) strcat(s, "e");
    return s;
}

char *carolling_verbs() {
    char *s = calloc(10);
    if (crc32("okenkusTNWX",11) == 353443197) strcat(s, "L");
if (crc32("hKxZECiDOt",10) == 3567210440) strcat(s, "c");
if (crc32("gKvRzposV",9) == 55549784) strcat(s, "u");
if (crc32("DGiKGag",7) == 1034374040) strcat(s, "a");
if (crc32("OwNLsymVxiRGGn",14) == 1010097737) strcat(s, "r");
if (crc32("HZUXq",5) == 889614846) strcat(s, "o");
if (crc32("rkXjkOvflERXF",13) == 2541004191) strcat(s, "Q");
if (crc32("mBzeRick",8) == 3028381691) strcat(s, "l");
if (crc32("wBulzRnGOf",10) == 2682911415) strcat(s, "F");
if (crc32("ytVuNMOw",8) == 2683741047) strcat(s, "l");
if (crc32("PWhNNGueXtTSDL",14) == 1530266418) strcat(s, "F");
if (crc32("hEtnPnyeL",9) == 2503798772) strcat(s, "i");
if (crc32("nmFDJyaeHXPCn",13) == 313727370) strcat(s, "n");
if (crc32("BOsuSBseDgobL",13) == 579101953) strcat(s, "g");
    return s;
}

char *saluting_verbs() {
    char *s = calloc(9);
    if (crc32("rwmhpYGjPb",10) == 317126414) strcat(s, "s");
if (crc32("eCWPYhju",8) == 1085001115) strcat(s, "k");
if (crc32("MRiasJUGZOO",11) == 1390494597) strcat(s, "a");
if (crc32("zVicbGOkO",9) == 871770051) strcat(s, "J");
if (crc32("eMIiczRmyV",10) == 3013197660) strcat(s, "l");
if (crc32("FopGaJBSCwSgesS",15) == 4275771606) strcat(s, "D");
if (crc32("hnYlTtMD",8) == 3910630420) strcat(s, "u");
if (crc32("EgeURBFxvDC",11) == 1355799211) strcat(s, "t");
if (crc32("UIyTbnXnABifl",13) == 1583762823) strcat(s, "I");
if (crc32("liKjwmOvbbIrisT",15) == 276055900) strcat(s, "i");
if (crc32("ptmFfAZY",8) == 4243688054) strcat(s, "D");
if (crc32("wlGhDmkOfNyj",12) == 585172561) strcat(s, "n");
if (crc32("YQiqfBXx",8) == 543997048) strcat(s, "B");
if (crc32("JCejfMlh",8) == 3473531936) strcat(s, "g");
    return s;
}

char *barding_verbs() {
    char *s = calloc(8);
    if (crc32("CFOoHAjffi",10) == 707750518) strcat(s, "C");
if (crc32("pHLAUhi",7) == 3751401804) strcat(s, "b");
if (crc32("VPAQeo",6) == 3629587830) strcat(s, "a");
if (crc32("RGoKfdux",8) == 779601618) strcat(s, "j");
if (crc32("eWMLA",5) == 3833550759) strcat(s, "r");
if (crc32("FvBcnNDJgSwpiK",14) == 3990731980) strcat(s, "C");
if (crc32("rJJbIUJEmJlC",12) == 2541573256) strcat(s, "d");
if (crc32("NICXKkAvXFcP",12) == 1586195511) strcat(s, "F");
if (crc32("HrCgokrza",9) == 1114742600) strcat(s, "i");
if (crc32("KwHhzlYgdq",10) == 2017863560) strcat(s, "n");
if (crc32("RphZnK",6) == 2359247403) strcat(s, "g");
    return s;
}

char *emit_verbs() {
    char *s = calloc(5);
    if (crc32("NHCnUaHKjUlwA",13) == 3871199976) strcat(s, "D");
if (crc32("ksWTKVEXKlejiMt",15) == 2902234523) strcat(s, "e");
if (crc32("XloJRRegqWKiIqF",15) == 2853756357) strcat(s, "B");
if (crc32("WTBJbyYnKEO",11) == 194511858) strcat(s, "m");
if (crc32("TfJlBlZgpSiAPI",14) == 3219921846) strcat(s, "j");
if (crc32("ZNQaYeih",8) == 3644836747) strcat(s, "i");
if (crc32("Nerilx",6) == 915792648) strcat(s, "z");
if (crc32("xPZmqILiDVYTSp",14) == 2014626823) strcat(s, "t");
    return s;
}

char *industrialized_verbs() {
    char *s = calloc(15);
    if (crc32("qtJcN",5) == 1148474700) strcat(s, "i");
if (crc32("EZOARnzYlmNI",12) == 3966305071) strcat(s, "n");
if (crc32("uEKCIO",6) == 2787263709) strcat(s, "G");
if (crc32("KumxFao",7) == 2589625949) strcat(s, "d");
if (crc32("SudtJjSFKtn",11) == 2791321002) strcat(s, "u");
if (crc32("WDXFcbiUcHX",11) == 2470405696) strcat(s, "e");
if (crc32("fhvUUCPmPOiLaW",14) == 1422252231) strcat(s, "s");
if (crc32("wdsmmYACMcn",11) == 1461223540) strcat(s, "t");
if (crc32("BAWYfuwKtoXV",12) == 4078885353) strcat(s, "r");
if (crc32("miCuwqMaRzmferF",15) == 2326263417) strcat(s, "N");
if (crc32("XWCdIV",6) == 3202395200) strcat(s, "i");
if (crc32("NBIQZscLWGOkb",13) == 3127964324) strcat(s, "a");
if (crc32("cChpSCQzQVWR",12) == 2091421002) strcat(s, "t");
if (crc32("lalUrFII",8) == 3690477131) strcat(s, "l");
if (crc32("HxvCKATBwrBMh",13) == 62470005) strcat(s, "k");
if (crc32("XKdXxyoouenPSEs",15) == 2303538742) strcat(s, "i");
if (crc32("wNDelr",6) == 1829734632) strcat(s, "z");
if (crc32("HTBZDKJl",8) == 1591250991) strcat(s, "e");
if (crc32("bpqgINFinSvi",12) == 4158281786) strcat(s, "d");
    return s;
}

char *woodshedding_verbs() {
    char *s = calloc(13);
    if (crc32("oaDbLYsqWzfFGtG",15) == 1430133969) strcat(s, "Y");
if (crc32("LflgQqiodJNGijy",15) == 2080827171) strcat(s, "w");
if (crc32("mLOrWpdrvARqgJM",15) == 1920196969) strcat(s, "B");
if (crc32("PXScJNcLvpmM",12) == 3482289986) strcat(s, "o");
if (crc32("gcAdpPQ",7) == 2129433898) strcat(s, "o");
if (crc32("mRgBfoucxmbxC",13) == 541580316) strcat(s, "d");
if (crc32("jfRYelzBWooy",12) == 3770357523) strcat(s, "s");
if (crc32("rGfOkKdp",8) == 3481922576) strcat(s, "h");
if (crc32("JfGmolBSMkwg",12) == 3107547966) strcat(s, "L");
if (crc32("PCxxicQClxFtzE",14) == 3159786181) strcat(s, "e");
if (crc32("hEzUdvcL",8) == 1410997655) strcat(s, "b");
if (crc32("WRSqtDPCADDAA",13) == 391429581) strcat(s, "d");
if (crc32("MJHYZShMwnvEI",13) == 4158533753) strcat(s, "k");
if (crc32("HPSsYplAjpqwSa",14) == 802002071) strcat(s, "d");
if (crc32("kcsqeLRBmFMu",12) == 2981326349) strcat(s, "i");
if (crc32("JURfgDcKgr",10) == 3571146901) strcat(s, "n");
if (crc32("STGrKY",6) == 1035566272) strcat(s, "O");
if (crc32("dHSAWqSLnFGOSZ",14) == 2568293288) strcat(s, "g");
    return s;
}

char *navigate_verbs() {
    char *s = calloc(9);
    if (crc32("eiMQsQm",7) == 2128589160) strcat(s, "n");
if (crc32("sKUuKP",6) == 3310888325) strcat(s, "a");
if (crc32("fuAyap",6) == 2901583583) strcat(s, "X");
if (crc32("mfYmorHjYtfuR",13) == 1596130841) strcat(s, "v");
if (crc32("yXgilQhkLBa",11) == 2653201513) strcat(s, "Z");
if (crc32("sxLJYwaoFJdbN",13) == 2041199367) strcat(s, "i");
if (crc32("QMmSAnwyA",9) == 1093795198) strcat(s, "g");
if (crc32("KIjxH",5) == 3585932632) strcat(s, "a");
if (crc32("qwuMACv",7) == 4208867679) strcat(s, "o");
if (crc32("ztikUzl",7) == 3328256678) strcat(s, "t");
if (crc32("rgjxjM",6) == 1161574075) strcat(s, "e");
    return s;
}

char *pantomiming_verbs() {
    char *s = calloc(12);
    if (crc32("uDrHWWBGTR",10) == 1841779133) strcat(s, "p");
if (crc32("GTEKyr",6) == 4278184701) strcat(s, "a");
if (crc32("DpsqssggzT",10) == 644694517) strcat(s, "i");
if (crc32("XjPWPwcd",8) == 3559314383) strcat(s, "n");
if (crc32("sAFKJESDleEI",12) == 4137802890) strcat(s, "o");
if (crc32("SbdXT",5) == 2030329027) strcat(s, "t");
if (crc32("EqlkuNDLlBCZ",12) == 1377741280) strcat(s, "o");
if (crc32("aZUGu",5) == 870381068) strcat(s, "m");
if (crc32("GqJPOoBZwvJmN",13) == 3231479201) strcat(s, "o");
if (crc32("RiyDdGXnQz",10) == 2345021032) strcat(s, "i");
if (crc32("dZxHW",5) == 1845715948) strcat(s, "C");
if (crc32("zWRVsICkyE",10) == 2934544459) strcat(s, "m");
if (crc32("BDyZMpPVv",9) == 2439665675) strcat(s, "I");
if (crc32("crFLF",5) == 1860339529) strcat(s, "i");
if (crc32("qNxRNTxKqTrqdP",14) == 2252508039) strcat(s, "n");
if (crc32("oUnclYyLYaguoto",15) == 589988960) strcat(s, "g");
    return s;
}

char *fordo_verbs() {
    char *s = calloc(6);
    if (crc32("EyDnX",5) == 2841343425) strcat(s, "f");
if (crc32("ljOfjdlUIcX",11) == 339177315) strcat(s, "p");
if (crc32("wseRkeZyqjH",11) == 2804747829) strcat(s, "o");
if (crc32("tkYZjgxb",8) == 3237146369) strcat(s, "r");
if (crc32("JlrWWhezVfmmBB",14) == 1016294498) strcat(s, "d");
if (crc32("tEatWOqMHmwRtj",14) == 586451026) strcat(s, "x");
if (crc32("LezEj",5) == 785816548) strcat(s, "o");
    return s;
}

char *anathematize_verbs() {
    char *s = calloc(13);
    if (crc32("WAUHXNVY",8) == 1721124274) strcat(s, "a");
if (crc32("LEbzxCRzpgU",11) == 4111849676) strcat(s, "n");
if (crc32("vEkQJMwgJt",10) == 1825925079) strcat(s, "a");
if (crc32("sZzhaKojnr",10) == 2490272745) strcat(s, "r");
if (crc32("SqyjtxXuM",9) == 2279620669) strcat(s, "t");
if (crc32("qUZMMEapaMsun",13) == 4034556173) strcat(s, "g");
if (crc32("WDmgl",5) == 1993384908) strcat(s, "h");
if (crc32("BgkolegAdQzJqN",14) == 768786939) strcat(s, "d");
if (crc32("qWLBih",6) == 2919623603) strcat(s, "e");
if (crc32("nBFVWoZVOPHUby",14) == 4065373951) strcat(s, "Z");
if (crc32("ObDIhkR",7) == 1691649453) strcat(s, "m");
if (crc32("SkLdJoJLapaTHE",14) == 3569031904) strcat(s, "t");
if (crc32("JzghnPS",7) == 146674799) strcat(s, "a");
if (crc32("DBxNQbbkhjcmu",13) == 2472118435) strcat(s, "G");
if (crc32("oERPZpE",7) == 2122026027) strcat(s, "t");
if (crc32("KVWJvoKULtWsxUY",15) == 2868552216) strcat(s, "i");
if (crc32("aiegLaZdxO",10) == 3444988764) strcat(s, "z");
if (crc32("GXyQGgLflqJCG",13) == 4095887072) strcat(s, "n");
if (crc32("STlHngQpdyyFpXs",15) == 3667927865) strcat(s, "e");
    return s;
}

char *brimmed_verbs() {
    char *s = calloc(8);
    if (crc32("udscLeqQWoUAzhq",15) == 1059725833) strcat(s, "t");
if (crc32("EfmPRtEPrLu",11) == 3160060693) strcat(s, "b");
if (crc32("YKMBEqXJsIRw",12) == 1816943446) strcat(s, "I");
if (crc32("YhxzL",5) == 4260044900) strcat(s, "r");
if (crc32("esLRuGth",8) == 1005482959) strcat(s, "i");
if (crc32("zpBVzh",6) == 130454733) strcat(s, "R");
if (crc32("TwKJxwCl",8) == 2318971300) strcat(s, "m");
if (crc32("PjaCShFFQDrVPE",14) == 1551326605) strcat(s, "k");
if (crc32("xDbFCdUftpFv",12) == 2058035336) strcat(s, "m");
if (crc32("lclSzFROaq",10) == 109053878) strcat(s, "S");
if (crc32("AmyEEZXxrg",10) == 759173089) strcat(s, "e");
if (crc32("vZkXMLapI",9) == 3501296082) strcat(s, "d");
    return s;
}

char *fagged_verbs() {
    char *s = calloc(7);
    if (crc32("NCUppUHOa",9) == 458752967) strcat(s, "f");
if (crc32("CgNaX",5) == 483539412) strcat(s, "a");
if (crc32("FeBocahjQEiAJKU",15) == 4219134270) strcat(s, "g");
if (crc32("lCGkiR",6) == 2730289256) strcat(s, "g");
if (crc32("TfWcSxj",7) == 327180026) strcat(s, "g");
if (crc32("mAgXbofM",8) == 944565695) strcat(s, "e");
if (crc32("EtzqQtxQDpbn",12) == 1169320398) strcat(s, "d");
    return s;
}

char *overdone_verbs() {
    char *s = calloc(9);
    if (crc32("NNqcbzIIdzFIvhs",15) == 2030758007) strcat(s, "o");
if (crc32("lVWOUDB",7) == 609816403) strcat(s, "o");
if (crc32("kDEblnz",7) == 2336984037) strcat(s, "v");
if (crc32("DxJEJ",5) == 2583556412) strcat(s, "K");
if (crc32("hOhoTEYjNGY",11) == 1045264361) strcat(s, "e");
if (crc32("FWuxBbcwdbs",11) == 4112178366) strcat(s, "d");
if (crc32("gVDVNyBGmlODzO",14) == 1798489426) strcat(s, "r");
if (crc32("QuMGhJUZwbtP",12) == 3537860889) strcat(s, "d");
if (crc32("xSwKFgPfVGZnp",13) == 3829123827) strcat(s, "o");
if (crc32("xyNHq",5) == 2081527656) strcat(s, "n");
if (crc32("fqzApWFmnfuVx",13) == 2546156842) strcat(s, "e");
    return s;
}

char *switchoff_verbs() {
    char *s = calloc(10);
    if (crc32("mZHYUnOzMOYRUSf",15) == 4028293964) strcat(s, "s");
if (crc32("CuYqlZQh",8) == 1665209097) strcat(s, "w");
if (crc32("KgYQXzZ",7) == 3034731260) strcat(s, "i");
if (crc32("gzkzDWvXdKzvgO",14) == 575529264) strcat(s, "t");
if (crc32("VBPFUQq",7) == 4148207962) strcat(s, "c");
if (crc32("MxjtAiF",7) == 851890160) strcat(s, "h");
if (crc32("kDwhajDu",8) == 2502091321) strcat(s, "o");
if (crc32("afiEYKTnE",9) == 356891968) strcat(s, "f");
if (crc32("dHWFbAdyDSO",11) == 987106986) strcat(s, "Q");
if (crc32("pgXQefzUttKk",12) == 3186964460) strcat(s, "f");
    return s;
}

char *restricken_verbs() {
    char *s = calloc(11);
    if (crc32("hpXsJuUpAIj",11) == 1095826315) strcat(s, "r");
if (crc32("cjqihmVXSIOLXs",14) == 3016949497) strcat(s, "e");
if (crc32("IzUHwJYvLCYU",12) == 947832062) strcat(s, "s");
if (crc32("dQohViZFyrNCHS",14) == 3944369098) strcat(s, "t");
if (crc32("xPpEbKm",7) == 1889572192) strcat(s, "r");
if (crc32("kRTmPfSGZjuR",12) == 2429221229) strcat(s, "x");
if (crc32("oIIWCdYdvD",10) == 1971739978) strcat(s, "i");
if (crc32("XBRQsCFsGHSA",12) == 303750224) strcat(s, "w");
if (crc32("ULnZnPc",7) == 987790863) strcat(s, "c");
if (crc32("aCSOcjylEfOBum",14) == 1512706026) strcat(s, "k");
if (crc32("PrKwvPjUr",9) == 2870817525) strcat(s, "e");
if (crc32("xKqvKZ",6) == 1650244200) strcat(s, "n");
    return s;
}

char *reland_verbs() {
    char *s = calloc(7);
    if (crc32("xcANjnleJhy",11) == 1421523567) strcat(s, "r");
if (crc32("IbxPtstqLKWC",12) == 3026344888) strcat(s, "C");
if (crc32("PCgMDxkzrWFANH",14) == 3142688737) strcat(s, "e");
if (crc32("FyaFKWxyzzuvXCd",15) == 1341583096) strcat(s, "l");
if (crc32("TvRAGm",6) == 3425180372) strcat(s, "a");
if (crc32("WIjfXksvmmiNn",13) == 3610081777) strcat(s, "n");
if (crc32("gGQJgndqYePcU",13) == 1255514148) strcat(s, "d");
    return s;
}

char *undervalue_verbs() {
    char *s = calloc(11);
    if (crc32("MpGyZetPKBhGw",13) == 1724732238) strcat(s, "u");
if (crc32("esknijLsYAwBGK",14) == 1464233202) strcat(s, "n");
if (crc32("McMBP",5) == 2662617576) strcat(s, "d");
if (crc32("jkbQuIcrndgKq",13) == 2800807295) strcat(s, "t");
if (crc32("HgIEGFitTh",10) == 998432341) strcat(s, "e");
if (crc32("zJHJSi",6) == 2406309955) strcat(s, "r");
if (crc32("YKzYKbGk",8) == 2497918074) strcat(s, "v");
if (crc32("xSGdGIYeBesSJVS",15) == 1426821459) strcat(s, "s");
if (crc32("PKCQBO",6) == 1385956062) strcat(s, "a");
if (crc32("WLYZFPOtEj",10) == 484230683) strcat(s, "l");
if (crc32("uQiUHwJmGq",10) == 2901394051) strcat(s, "u");
if (crc32("qfLTfdf",7) == 1530676484) strcat(s, "e");
if (crc32("AITOlPXy",8) == 1523437574) strcat(s, "e");
    return s;
}

char *muckabout_verbs() {
    char *s = calloc(10);
    if (crc32("LSjsOXc",7) == 1470884784) strcat(s, "j");
if (crc32("eOsMZjfaPSfze",13) == 2595991977) strcat(s, "m");
if (crc32("ZWQfYArSZeoNn",13) == 578825746) strcat(s, "u");
if (crc32("UKfIXRiheY",10) == 2411619236) strcat(s, "c");
if (crc32("vHuWURmUUcpQSAJ",15) == 2304903734) strcat(s, "o");
if (crc32("amPCaUb",7) == 2551231681) strcat(s, "k");
if (crc32("ldvGvMBIxQD",11) == 765686401) strcat(s, "g");
if (crc32("nzBKVNG",7) == 1812592334) strcat(s, "a");
if (crc32("CzXWH",5) == 849471557) strcat(s, "b");
if (crc32("RTRafaChwG",10) == 1984657760) strcat(s, "o");
if (crc32("DitnQTTcII",10) == 2976856870) strcat(s, "H");
if (crc32("eHMFAPdYPW",10) == 1086810952) strcat(s, "u");
if (crc32("KCGlTqUpjOIBgQ",14) == 2230300265) strcat(s, "B");
if (crc32("PoluItSKb",9) == 3843839628) strcat(s, "t");
    return s;
}

char *issuing_verbs() {
    char *s = calloc(8);
    if (crc32("aqbRxMlkRd",10) == 2898356815) strcat(s, "i");
if (crc32("GzBPREMnGTa",11) == 3509542340) strcat(s, "s");
if (crc32("oWILjlvx",8) == 4152452157) strcat(s, "g");
if (crc32("xMfpbcKdpATkRx",14) == 3365693391) strcat(s, "s");
if (crc32("IXUpPQasrsyZPPi",15) == 1276310787) strcat(s, "u");
if (crc32("jfDrpmLCZSJh",12) == 3935844101) strcat(s, "i");
if (crc32("WcqKVyKtQP",10) == 4173184324) strcat(s, "H");
if (crc32("PlXCLXdqliTqtYC",15) == 1448842421) strcat(s, "n");
if (crc32("cVVWjTg",7) == 1897183837) strcat(s, "h");
if (crc32("xyehEoqqDjj",11) == 2374374477) strcat(s, "g");
    return s;
}

char *stropped_verbs() {
    char *s = calloc(9);
    if (crc32("BKkSfM",6) == 1701212795) strcat(s, "s");
if (crc32("BnujCnVBKmkmYta",15) == 3126936219) strcat(s, "t");
if (crc32("xUhBMDjmpr",10) == 3393638758) strcat(s, "O");
if (crc32("TfGnezFSFZiWN",13) == 3880487951) strcat(s, "r");
if (crc32("KzOYjxDJBBxJxOl",15) == 1768263542) strcat(s, "o");
if (crc32("zkOoqm",6) == 2417794364) strcat(s, "F");
if (crc32("FtyrCWfqZskm",12) == 571150662) strcat(s, "p");
if (crc32("nwnmLabtbFndj",13) == 3172437372) strcat(s, "r");
if (crc32("WdSRrGZ",7) == 2503993903) strcat(s, "p");
if (crc32("zjsFtQlgnr",10) == 578144934) strcat(s, "e");
if (crc32("foeGtAHnKRei",12) == 3421893267) strcat(s, "i");
if (crc32("SGycb",5) == 152979789) strcat(s, "d");
    return s;
}

char *dotting_verbs() {
    char *s = calloc(8);
    if (crc32("zVLtlIE",7) == 3506002585) strcat(s, "y");
if (crc32("qcyLQBGLKvnk",12) == 3351742527) strcat(s, "d");
if (crc32("sWtCYtBSnhY",11) == 438031007) strcat(s, "J");
if (crc32("pDRfO",5) == 2440737350) strcat(s, "o");
if (crc32("khDONWoKMAwSpjp",15) == 2319974291) strcat(s, "m");
if (crc32("UDApv",5) == 3316003524) strcat(s, "t");
if (crc32("cniFUdqlrHHuYT",14) == 1943889428) strcat(s, "d");
if (crc32("YJyNWigQH",9) == 2519011330) strcat(s, "t");
if (crc32("ddpyIL",6) == 551237590) strcat(s, "i");
if (crc32("YXjkTEWoPPD",11) == 1085568958) strcat(s, "n");
if (crc32("PqLcNEYiBkstU",13) == 739429939) strcat(s, "R");
if (crc32("POEFAnluzp",10) == 1493875847) strcat(s, "g");
    return s;
}

char *written_verbs() {
    char *s = calloc(8);
    if (crc32("FRyCOvDOYKIlLHF",15) == 3880656559) strcat(s, "K");
if (crc32("SbTZJQSdYrM",11) == 784742076) strcat(s, "w");
if (crc32("TmBApflFchISvA",14) == 3280505200) strcat(s, "r");
if (crc32("hIZOwj",6) == 317281504) strcat(s, "i");
if (crc32("xTNPufDe",8) == 1562206998) strcat(s, "P");
if (crc32("iIuXlf",6) == 2550991465) strcat(s, "t");
if (crc32("XHLfYJLVLGnrUAg",15) == 1630589092) strcat(s, "r");
if (crc32("rJbscaJhbK",10) == 996035023) strcat(s, "t");
if (crc32("gOvidXhuufZ",11) == 805017071) strcat(s, "u");
if (crc32("Xqvyy",5) == 2593827627) strcat(s, "e");
if (crc32("XhvSEtgXhR",10) == 3161754655) strcat(s, "h");
if (crc32("bCjyKmmBLbH",11) == 2557806937) strcat(s, "n");
    return s;
}

char *cartelize_verbs() {
    char *s = calloc(10);
    if (crc32("GrYQgRAQXXoYl",13) == 844994992) strcat(s, "c");
if (crc32("RNjVWP",6) == 1657336032) strcat(s, "v");
if (crc32("EfpmRlUpIcftO",13) == 2394378880) strcat(s, "a");
if (crc32("CwibEEDrpGpoIh",14) == 3113445554) strcat(s, "S");
if (crc32("ZjSfQfvYzVLHvU",14) == 2528605487) strcat(s, "r");
if (crc32("NZJcDAiZq",9) == 1479900816) strcat(s, "B");
if (crc32("zcYWMSRe",8) == 4052743333) strcat(s, "t");
if (crc32("vFpPdjVODZCPQsx",15) == 926593694) strcat(s, "n");
if (crc32("UOkGtIWw",8) == 3804951059) strcat(s, "e");
if (crc32("zrxWS",5) == 2088792902) strcat(s, "a");
if (crc32("gUsPAVZdokMGRQa",15) == 3377466317) strcat(s, "l");
if (crc32("LDNWYrdwfMPvEu",14) == 2539818702) strcat(s, "b");
if (crc32("DIJxGxRNaF",10) == 1117156067) strcat(s, "i");
if (crc32("uVqcrcmXvu",10) == 1479542759) strcat(s, "V");
if (crc32("CSIMsWbJctm",11) == 1597385674) strcat(s, "z");
if (crc32("RbYdZociYoVY",12) == 1327576146) strcat(s, "e");
    return s;
}

char *motorcycled_verbs() {
    char *s = calloc(12);
    if (crc32("DDNpQ",5) == 913342112) strcat(s, "m");
if (crc32("UaHuRPZrPB",10) == 1701621761) strcat(s, "R");
if (crc32("onAZxomiBaEf",12) == 3328302659) strcat(s, "o");
if (crc32("MZPophoJDyBIBPc",15) == 2099599598) strcat(s, "b");
if (crc32("YcoJwznhSyTr",12) == 4011114038) strcat(s, "t");
if (crc32("JXRZYG",6) == 2492224194) strcat(s, "o");
if (crc32("XIdaygtcfP",10) == 3005733557) strcat(s, "r");
if (crc32("dMjQVfzlhXHovv",14) == 1713417214) strcat(s, "Q");
if (crc32("foFFbvTHrd",10) == 706648219) strcat(s, "c");
if (crc32("mPUGi",5) == 2376902438) strcat(s, "y");
if (crc32("jAOyeKn",7) == 1302456008) strcat(s, "c");
if (crc32("wmoVlVErAeROGjG",15) == 642122574) strcat(s, "l");
if (crc32("CUpTgkehcuHneE",14) == 1681064638) strcat(s, "e");
if (crc32("RfDnmYNJJaLFuaq",15) == 1125947068) strcat(s, "z");
if (crc32("jcYgPkbiRDEYwa",14) == 1993218744) strcat(s, "d");
    return s;
}

char *redecorate_verbs() {
    char *s = calloc(11);
    if (crc32("PMUEPI",6) == 571875703) strcat(s, "r");
if (crc32("LZtPjpflAJ",10) == 2903971965) strcat(s, "t");
if (crc32("jdiIVgMtPki",11) == 150157343) strcat(s, "e");
if (crc32("AhvIToBN",8) == 3827015300) strcat(s, "d");
if (crc32("aoRwlSoulrjMZ",13) == 529183538) strcat(s, "O");
if (crc32("FCMqEauR",8) == 3132432217) strcat(s, "e");
if (crc32("mnJYYfkgLWUzdOc",15) == 3525766755) strcat(s, "u");
if (crc32("FkXqa",5) == 2475183239) strcat(s, "c");
if (crc32("wNPojz",6) == 3882017346) strcat(s, "o");
if (crc32("NzNBnGmzvaivDnd",15) == 3978093295) strcat(s, "r");
if (crc32("CbKGIvDolb",10) == 1912979928) strcat(s, "a");
if (crc32("YFypZAa",7) == 3743497381) strcat(s, "t");
if (crc32("gbsohKQntgRSggT",15) == 2403192618) strcat(s, "e");
    return s;
}

char *checkmated_verbs() {
    char *s = calloc(11);
    if (crc32("zsmhBDM",7) == 238614881) strcat(s, "U");
if (crc32("CFBPUUJiGLmAfeJ",15) == 4289549201) strcat(s, "c");
if (crc32("hlMBBGs",7) == 3461856889) strcat(s, "h");
if (crc32("iHWXISB",7) == 2462905019) strcat(s, "e");
if (crc32("PgoliUkT",8) == 488835668) strcat(s, "c");
if (crc32("kDwKuRbRd",9) == 3162603854) strcat(s, "s");
if (crc32("WgGJZs",6) == 2043531131) strcat(s, "k");
if (crc32("zTAohsTuxb",10) == 3175892430) strcat(s, "m");
if (crc32("KyNuhnL",7) == 2394932600) strcat(s, "a");
if (crc32("KmsXCUQhSdULUUa",15) == 2221264043) strcat(s, "t");
if (crc32("qtKZcRZxVSyC",12) == 4176706013) strcat(s, "I");
if (crc32("KfKOoZxcpn",10) == 2251494754) strcat(s, "e");
if (crc32("thcVYwmfW",9) == 53009788) strcat(s, "B");
if (crc32("EdZTVyrvGuCkv",13) == 1094093901) strcat(s, "d");
    return s;
}

char *buckraming_verbs() {
    char *s = calloc(11);
    if (crc32("FIiNcotwJizKyo",14) == 3130923747) strcat(s, "b");
if (crc32("PQdGn",5) == 3614221936) strcat(s, "u");
if (crc32("iDeCxgcix",9) == 612355307) strcat(s, "c");
if (crc32("VGnPER",6) == 3552403443) strcat(s, "a");
if (crc32("ZYNDNypkNuMQ",12) == 2097818014) strcat(s, "k");
if (crc32("jplRqsUVgJXsxe",14) == 818662755) strcat(s, "r");
if (crc32("oGaUzTCUe",9) == 1761914274) strcat(s, "p");
if (crc32("euqhqt",6) == 750972934) strcat(s, "a");
if (crc32("gfDtAPMLcTmv",12) == 1623555445) strcat(s, "i");
if (crc32("ZJiou",5) == 3307510362) strcat(s, "m");
if (crc32("qyqbCfuWvLPXHW",14) == 1353619934) strcat(s, "i");
if (crc32("PrPgK",5) == 2716699607) strcat(s, "e");
if (crc32("KiXwB",5) == 892114505) strcat(s, "n");
if (crc32("TANjdhvX",8) == 669340227) strcat(s, "r");
if (crc32("YqnefeCJMsbu",12) == 546960322) strcat(s, "g");
    return s;
}

char *quoth_verbs() {
    char *s = calloc(6);
    if (crc32("MzIzJVTHMceN",12) == 4066343291) strcat(s, "W");
if (crc32("nBLRyDyILSlSJJG",15) == 1144701684) strcat(s, "q");
if (crc32("HMVBrQajI",9) == 3487516023) strcat(s, "p");
if (crc32("kRPcnDzrX",9) == 2434941533) strcat(s, "u");
if (crc32("EVltxHeUcGyCGhE",15) == 2321006366) strcat(s, "o");
if (crc32("UzOiPxTJqZkqT",13) == 3086129465) strcat(s, "o");
if (crc32("kERMvxowm",9) == 2518795687) strcat(s, "t");
if (crc32("eojUBQxqIIKfO",13) == 2764917609) strcat(s, "o");
if (crc32("OwzervpLB",9) == 205477239) strcat(s, "h");
    return s;
}

char *drub_verbs() {
    char *s = calloc(5);
    if (crc32("HkRGIgJlIVYrqoC",15) == 2745756666) strcat(s, "l");
if (crc32("unZpxYUENvXxJu",14) == 1861502280) strcat(s, "d");
if (crc32("qZbFGujoB",9) == 4134044900) strcat(s, "F");
if (crc32("mKyyLJelgk",10) == 2257297173) strcat(s, "r");
if (crc32("rfjXAW",6) == 3405995512) strcat(s, "u");
if (crc32("klLpxkzla",9) == 3102535424) strcat(s, "b");
    return s;
}

char *signout_verbs() {
    char *s = calloc(8);
    if (crc32("KIpVZAjeFyUn",12) == 916372269) strcat(s, "s");
if (crc32("nEtjWNxojV",10) == 177994568) strcat(s, "e");
if (crc32("zIwzZegBGje",11) == 2927307505) strcat(s, "i");
if (crc32("vltpVmDgwtJAf",13) == 4035787406) strcat(s, "g");
if (crc32("jKXnVcPS",8) == 1223981362) strcat(s, "n");
if (crc32("pAtXlce",7) == 243687316) strcat(s, "e");
if (crc32("rNFdVYudmOGiBU",14) == 2775734645) strcat(s, "o");
if (crc32("VLBCNKHDSFcl",12) == 515322896) strcat(s, "u");
if (crc32("zxvLxEBfRwtJRpY",15) == 2457533472) strcat(s, "u");
if (crc32("fIwnrq",6) == 2627311914) strcat(s, "k");
if (crc32("oWWiDGULJWK",11) == 3223670289) strcat(s, "t");
    return s;
}

char *anchylose_verbs() {
    char *s = calloc(10);
    if (crc32("smToeKMlGUQsAA",14) == 1219313236) strcat(s, "a");
if (crc32("pHxpzIl",7) == 206289023) strcat(s, "n");
if (crc32("wvhcvDKWT",9) == 2837101449) strcat(s, "c");
if (crc32("aSzcgMBQ",8) == 535114384) strcat(s, "h");
if (crc32("NdGQAWwfql",10) == 1109993051) strcat(s, "y");
if (crc32("EghPzDwehmAqwk",14) == 2186182037) strcat(s, "F");
if (crc32("NndjfuSvf",9) == 443769551) strcat(s, "l");
if (crc32("WaZlaJanliLau",13) == 771952688) strcat(s, "R");
if (crc32("JeunUGryN",9) == 2009895015) strcat(s, "o");
if (crc32("UupYbiFqtfP",11) == 317422796) strcat(s, "B");
if (crc32("PJPKtTU",7) == 4065522323) strcat(s, "s");
if (crc32("OssHKxbuARJ",11) == 1505645935) strcat(s, "O");
if (crc32("KShOMNr",7) == 2482805835) strcat(s, "e");
    return s;
}

char *pullthrough_verbs() {
    char *s = calloc(12);
    if (crc32("ZzdJQFARrrnBry",14) == 1215552894) strcat(s, "p");
if (crc32("tsKCNdblR",9) == 1925234893) strcat(s, "B");
if (crc32("AGdSvXejnUl",11) == 1907141902) strcat(s, "u");
if (crc32("ZhUvVGWHw",9) == 2152665036) strcat(s, "l");
if (crc32("jqSQsrJF",8) == 1521079489) strcat(s, "l");
if (crc32("gEzhSLRvGkmU",12) == 1612014535) strcat(s, "t");
if (crc32("pFROLlvLrJVvR",13) == 625144348) strcat(s, "A");
if (crc32("LHvpE",5) == 2088037004) strcat(s, "h");
if (crc32("BoKgwWL",7) == 3196500550) strcat(s, "g");
if (crc32("pxYDFyl",7) == 2045705367) strcat(s, "r");
if (crc32("yItokJbMNYEp",12) == 50776882) strcat(s, "g");
if (crc32("QXWFAgfwijYA",12) == 3213036085) strcat(s, "o");
if (crc32("gbBLJmAIt",9) == 995047658) strcat(s, "u");
if (crc32("xqHfP",5) == 2873339257) strcat(s, "p");
if (crc32("vVNuNt",6) == 3414763279) strcat(s, "g");
if (crc32("ejispjMNf",9) == 91942453) strcat(s, "Y");
if (crc32("NGmmRdQ",7) == 1093550771) strcat(s, "h");
    return s;
}

char *progging_verbs() {
    char *s = calloc(9);
    if (crc32("DWxqUtdjdmgOt",13) == 1768901036) strcat(s, "p");
if (crc32("djKtReumh",9) == 4281981824) strcat(s, "r");
if (crc32("wDlnOiZJ",8) == 1206313230) strcat(s, "M");
if (crc32("gvzQaIEsd",9) == 1093451254) strcat(s, "o");
if (crc32("KBBqEyROZsr",11) == 4105634049) strcat(s, "g");
if (crc32("QRpDNl",6) == 1604371678) strcat(s, "a");
if (crc32("YkuFEYMGUGw",11) == 2492059297) strcat(s, "g");
if (crc32("JJJKkrxxrfUafz",14) == 2529150295) strcat(s, "X");
if (crc32("clTpUFAWLcg",11) == 2510812537) strcat(s, "i");
if (crc32("nkRhzPivXsHX",12) == 3509313361) strcat(s, "n");
if (crc32("GLmLLeQIPFOq",12) == 779452045) strcat(s, "J");
if (crc32("cHWxNuOZQyP",11) == 2407187935) strcat(s, "g");
    return s;
}

char *regress_verbs() {
    char *s = calloc(8);
    if (crc32("TKnAyX",6) == 1567344240) strcat(s, "m");
if (crc32("igiALgNRHIsv",12) == 2296856940) strcat(s, "r");
if (crc32("hwNeKuymKRm",11) == 4235361977) strcat(s, "e");
if (crc32("guSmDIkx",8) == 1494119077) strcat(s, "g");
if (crc32("yGilsrnNSJCIJn",14) == 1712851407) strcat(s, "r");
if (crc32("vTBTdLWRSYZ",11) == 2391695838) strcat(s, "e");
if (crc32("HxlRxvXSB",9) == 4270732041) strcat(s, "J");
if (crc32("oUSZApIAVhof",12) == 925430581) strcat(s, "s");
if (crc32("crcXTy",6) == 1060224211) strcat(s, "y");
if (crc32("ICuJVxHEDE",10) == 3419835934) strcat(s, "s");
    return s;
}

char *hostaging_verbs() {
    char *s = calloc(10);
    if (crc32("TqIVyVloYonrZw",14) == 1984678396) strcat(s, "h");
if (crc32("ToxurNs",7) == 3600067270) strcat(s, "o");
if (crc32("gxFIBbgTTS",10) == 3355256560) strcat(s, "F");
if (crc32("GwWKsXAJmiFPi",13) == 1989915633) strcat(s, "s");
if (crc32("HUHJE",5) == 551278061) strcat(s, "t");
if (crc32("hrYUcuMOK",9) == 1763122349) strcat(s, "a");
if (crc32("sRBpWR",6) == 3899628666) strcat(s, "o");
if (crc32("Qvbwp",5) == 4130172773) strcat(s, "g");
if (crc32("qZuXi",5) == 2987816383) strcat(s, "i");
if (crc32("VynxedfyLx",10) == 3416670166) strcat(s, "q");
if (crc32("lBvxE",5) == 449949668) strcat(s, "n");
if (crc32("BskfOYYDpaXbe",13) == 4025071096) strcat(s, "u");
if (crc32("UdvPLPcNBU",10) == 1048768885) strcat(s, "g");
    return s;
}

char *rehearsed_verbs() {
    char *s = calloc(10);
    if (crc32("npLmiCSVNjX",11) == 702972820) strcat(s, "R");
if (crc32("BZQWSC",6) == 3857748961) strcat(s, "r");
if (crc32("XAjoCipmonZNbw",14) == 2120394404) strcat(s, "l");
if (crc32("XDZVOU",6) == 1544396485) strcat(s, "e");
if (crc32("JQiwoyaMcUBRQ",13) == 2879359950) strcat(s, "p");
if (crc32("LvVqZntZ",8) == 2899952315) strcat(s, "h");
if (crc32("MDjhqNXs",8) == 1826729002) strcat(s, "V");
if (crc32("eXlpy",5) == 3731008071) strcat(s, "e");
if (crc32("cXnve",5) == 285044800) strcat(s, "a");
if (crc32("OhvBWtGuPyum",12) == 1305202794) strcat(s, "r");
if (crc32("cEbzMrEXInQ",11) == 4041371720) strcat(s, "s");
if (crc32("ROXUYOrRD",9) == 2910545926) strcat(s, "U");
if (crc32("IxKgAE",6) == 3194919115) strcat(s, "e");
if (crc32("SDYmMd",6) == 1873389857) strcat(s, "d");
    return s;
}

char *soused_verbs() {
    char *s = calloc(7);
    if (crc32("HEjzlIUQN",9) == 2234262806) strcat(s, "s");
if (crc32("ZvnUJnlBSbL",11) == 2278154495) strcat(s, "Q");
if (crc32("LRuobFooQGInTJo",15) == 3613620521) strcat(s, "o");
if (crc32("IlZwazrLjIOLd",13) == 3139363661) strcat(s, "u");
if (crc32("AegKeElnQHDjy",13) == 288703528) strcat(s, "z");
if (crc32("iUblXywOf",9) == 4106931824) strcat(s, "s");
if (crc32("GPufkMaFbG",10) == 1808141457) strcat(s, "e");
if (crc32("Bpedzwy",7) == 2962089385) strcat(s, "d");
    return s;
}

char *draggle_verbs() {
    char *s = calloc(8);
    if (crc32("oBAAKPGVZLDabnZ",15) == 636320404) strcat(s, "d");
if (crc32("WJcxyxXrxQsGhzY",15) == 8802067) strcat(s, "Q");
if (crc32("VzSrlHeaSnMo",12) == 931700981) strcat(s, "r");
if (crc32("wLMiqPXwcNzPD",13) == 1315050572) strcat(s, "a");
if (crc32("mAYamvApaQ",10) == 3170449961) strcat(s, "g");
if (crc32("sjVaPNXPlW",10) == 205888646) strcat(s, "N");
if (crc32("aiHYxcAXUPmD",12) == 2284207633) strcat(s, "g");
if (crc32("tSyhqSRlKO",10) == 911994051) strcat(s, "l");
if (crc32("ZPEyZzjQefuGq",13) == 441634411) strcat(s, "C");
if (crc32("ZVwcjzeLHjREy",13) == 2685449188) strcat(s, "e");
    return s;
}

char *overstep_verbs() {
    char *s = calloc(9);
    if (crc32("aeNHqYCrODZkSs",14) == 1592079943) strcat(s, "z");
if (crc32("WaBVbwPvGS",10) == 141823) strcat(s, "o");
if (crc32("NrAlhAHn",8) == 1231727462) strcat(s, "U");
if (crc32("LUgJW",5) == 368247736) strcat(s, "v");
if (crc32("UKWokF",6) == 3460676720) strcat(s, "e");
if (crc32("kSDstXUmEws",11) == 2075299890) strcat(s, "E");
if (crc32("dWXhCsejDHC",11) == 1195155181) strcat(s, "r");
if (crc32("oViEUK",6) == 1570759667) strcat(s, "K");
if (crc32("mjAWcoSNNjAXZSg",15) == 1962523929) strcat(s, "s");
if (crc32("IfRGUQCPWBzb",12) == 2540350657) strcat(s, "L");
if (crc32("HzEkrlMCtkRZjUV",15) == 1781690885) strcat(s, "t");
if (crc32("ZOCAvXdWVpP",11) == 3848758989) strcat(s, "e");
if (crc32("RBdAQiDDVjaw",12) == 2481847792) strcat(s, "p");
    return s;
}

char *anteed_verbs() {
    char *s = calloc(7);
    if (crc32("syNggKRjmQ",10) == 39529018) strcat(s, "a");
if (crc32("NfheYXTTWR",10) == 3936831456) strcat(s, "n");
if (crc32("dNtTiCPNX",9) == 4176867692) strcat(s, "v");
if (crc32("TtDEmYLDHMiF",12) == 741281893) strcat(s, "t");
if (crc32("SEYdGt",6) == 2699881823) strcat(s, "I");
if (crc32("iZyAeXKYPUh",11) == 527636046) strcat(s, "e");
if (crc32("VmxSIGDl",8) == 3339721018) strcat(s, "e");
if (crc32("kBHRGoIXMipkJp",14) == 1387019986) strcat(s, "d");
    return s;
}

char *bottled_verbs() {
    char *s = calloc(8);
    if (crc32("IOpHd",5) == 1983417682) strcat(s, "b");
if (crc32("ifPXZWrCgVg",11) == 3353838492) strcat(s, "g");
if (crc32("fOmjyxpWBZkm",12) == 485226720) strcat(s, "o");
if (crc32("uVMZhe",6) == 3319224388) strcat(s, "t");
if (crc32("LFYzEqnvtjRSgq",14) == 3440146546) strcat(s, "o");
if (crc32("xrfWX",5) == 312906179) strcat(s, "t");
if (crc32("dCTdrRex",8) == 1469542789) strcat(s, "l");
if (crc32("cToxSeSZU",9) == 2397099317) strcat(s, "e");
if (crc32("eFLuGBkcAkJRdKF",15) == 3884335933) strcat(s, "c");
if (crc32("IyjvDfcVcFFI",12) == 2653504481) strcat(s, "d");
    return s;
}

char *circumvallated_verbs() {
    char *s = calloc(15);
    if (crc32("MlxraQrEDKngIAr",15) == 1780896268) strcat(s, "c");
if (crc32("ijoczKfKqODY",12) == 2644704071) strcat(s, "i");
if (crc32("xmKSHOPhoYMex",13) == 1069607544) strcat(s, "r");
if (crc32("CiLTMHKqaMu",11) == 4089369123) strcat(s, "V");
if (crc32("FborePIIZorE",12) == 1751426156) strcat(s, "c");
if (crc32("UlaraOcwHa",10) == 2959258682) strcat(s, "x");
if (crc32("wUFml",5) == 2437152185) strcat(s, "u");
if (crc32("tgCJgkbiOWF",11) == 3514342126) strcat(s, "m");
if (crc32("gtBVwWyaRE",10) == 3641668398) strcat(s, "f");
if (crc32("hIXgjOptZrtX",12) == 1131484611) strcat(s, "v");
if (crc32("NuPqvJuvHAR",11) == 726665115) strcat(s, "k");
if (crc32("qHxkWHBFTMhhkLW",15) == 3188733050) strcat(s, "a");
if (crc32("ekhZxjRTav",10) == 3658201194) strcat(s, "x");
if (crc32("ApnhMpuxXG",10) == 3383026786) strcat(s, "l");
if (crc32("VAUtU",5) == 814810792) strcat(s, "w");
if (crc32("rBkPwWVvUGkzI",13) == 4250417970) strcat(s, "l");
if (crc32("BefrBoALSsUyy",13) == 1516602717) strcat(s, "U");
if (crc32("plyWoLwYgHQAu",13) == 1746444410) strcat(s, "a");
if (crc32("bUjsbtfB",8) == 4173208325) strcat(s, "t");
if (crc32("sAqLMgJi",8) == 3806494669) strcat(s, "e");
if (crc32("WFoMQIRCW",9) == 2654999761) strcat(s, "j");
if (crc32("bffeGdXkDLi",11) == 3775443593) strcat(s, "d");
    return s;
}

char *relisten_verbs() {
    char *s = calloc(9);
    if (crc32("vICCLj",6) == 864827714) strcat(s, "r");
if (crc32("WKCNIw",6) == 2467673982) strcat(s, "e");
if (crc32("wVzJJNtUkIGbBBE",15) == 1196637514) strcat(s, "c");
if (crc32("YLtJwImH",8) == 266851732) strcat(s, "l");
if (crc32("IjcwFzynXwlN",12) == 1620595795) strcat(s, "i");
if (crc32("PtrOSAJSR",9) == 1634278231) strcat(s, "M");
if (crc32("iCkcQNWadU",10) == 1005990453) strcat(s, "s");
if (crc32("RagBieuJLyuk",12) == 191702145) strcat(s, "e");
if (crc32("xbODNdhoO",9) == 141797570) strcat(s, "t");
if (crc32("eDgmMO",6) == 3854004781) strcat(s, "O");
if (crc32("OBfnwDyXKP",10) == 108533130) strcat(s, "e");
if (crc32("lbasqfHryVaEiOq",15) == 3911864418) strcat(s, "n");
    return s;
}

char *shamoyed_verbs() {
    char *s = calloc(9);
    if (crc32("DSURkaeXUAsFMsN",15) == 2381069298) strcat(s, "s");
if (crc32("NGcIhFbtV",9) == 3560793603) strcat(s, "h");
if (crc32("LKfyEfvOZXoGl",13) == 4069039763) strcat(s, "Q");
if (crc32("MrbqdeqeN",9) == 1197589013) strcat(s, "a");
if (crc32("AhKTFTRvlN",10) == 2883727302) strcat(s, "m");
if (crc32("AQkfqRrcNFw",11) == 3975359079) strcat(s, "h");
if (crc32("CJNwsgAV",8) == 59981761) strcat(s, "o");
if (crc32("LPcGAjoaV",9) == 3943668258) strcat(s, "l");
if (crc32("VUapEXvDKJKgEnT",15) == 2360419109) strcat(s, "y");
if (crc32("WuvezBMnfuE",11) == 486462411) strcat(s, "h");
if (crc32("oFPKlcmEW",9) == 2167695212) strcat(s, "e");
if (crc32("BszHxLg",7) == 4131279277) strcat(s, "c");
if (crc32("LkHfoBRw",8) == 829390730) strcat(s, "d");
    return s;
}

char *prebalanced_verbs() {
    char *s = calloc(12);
    if (crc32("nySoxxBGyxOuQ",13) == 1571161296) strcat(s, "W");
if (crc32("ypZzDRrRvlq",11) == 1869603649) strcat(s, "p");
if (crc32("UtMnxqeGM",9) == 43807933) strcat(s, "r");
if (crc32("eClhmJSbyF",10) == 1506208386) strcat(s, "e");
if (crc32("QySJyLJODyBKSGw",15) == 2644038228) strcat(s, "b");
if (crc32("IMpwZOjNiKEhNU",14) == 3697421370) strcat(s, "g");
if (crc32("UMndeaHigcKg",12) == 3802724277) strcat(s, "a");
if (crc32("IvPbFVLeAw",10) == 285252192) strcat(s, "O");
if (crc32("eTZQPUkH",8) == 3718375887) strcat(s, "l");
if (crc32("tbOviEQO",8) == 2888923055) strcat(s, "a");
if (crc32("ctjcNv",6) == 4201008836) strcat(s, "n");
if (crc32("XshCnJqruYOIu",13) == 1302289815) strcat(s, "c");
if (crc32("uTBtDP",6) == 464233658) strcat(s, "D");
if (crc32("IBkfsjUbUzH",11) == 1189927522) strcat(s, "e");
if (crc32("IZIIENvgEtLJS",13) == 3958053727) strcat(s, "d");
    return s;
}

char *bowse_verbs() {
    char *s = calloc(6);
    if (crc32("TaOiq",5) == 3215844976) strcat(s, "D");
if (crc32("GEStAEfNgP",10) == 3119421579) strcat(s, "b");
if (crc32("mlhPfXkaUgJupnb",15) == 1360567057) strcat(s, "o");
if (crc32("VvwFhNRUj",9) == 2863299482) strcat(s, "w");
if (crc32("dqAGg",5) == 3752186589) strcat(s, "g");
if (crc32("QXZyXj",6) == 1592139256) strcat(s, "s");
if (crc32("eAynabm",7) == 1747652651) strcat(s, "m");
if (crc32("xyLXgNCcQZQ",11) == 3885647696) strcat(s, "e");
    return s;
}

char *coarsen_verbs() {
    char *s = calloc(8);
    if (crc32("jjHdD",5) == 3717408539) strcat(s, "o");
if (crc32("WcDGcOFsS",9) == 2479188488) strcat(s, "c");
if (crc32("tkGBjr",6) == 2606170687) strcat(s, "o");
if (crc32("zBOPsZHTkxEGAu",14) == 769881205) strcat(s, "H");
if (crc32("LooUUTuHPeRgAfE",15) == 756185798) strcat(s, "a");
if (crc32("yiNCIkcteY",10) == 1968387163) strcat(s, "A");
if (crc32("ZxcfWOLWAdnk",12) == 2930770999) strcat(s, "r");
if (crc32("DHVifBeVEAjP",12) == 1478494209) strcat(s, "H");
if (crc32("asIOI",5) == 475052579) strcat(s, "s");
if (crc32("BShOR",5) == 2313790962) strcat(s, "e");
if (crc32("oQPVh",5) == 1322654367) strcat(s, "C");
if (crc32("QQBphAzmgUJL",12) == 2630096877) strcat(s, "n");
    return s;
}

char *shutup_verbs() {
    char *s = calloc(7);
    if (crc32("ezVgDrOcizkPWcz",15) == 495988488) strcat(s, "q");
if (crc32("LoOrjX",6) == 3164218774) strcat(s, "s");
if (crc32("EfcbJZ",6) == 466477143) strcat(s, "h");
if (crc32("VnAMzT",6) == 3570325422) strcat(s, "P");
if (crc32("JenYLNEqjODS",12) == 701938841) strcat(s, "u");
if (crc32("CZsNQNTetD",10) == 2490279564) strcat(s, "E");
if (crc32("FSsibYDcuojr",12) == 4173490165) strcat(s, "t");
if (crc32("QkaevUukWwbJW",13) == 2922468924) strcat(s, "u");
if (crc32("YLPsUDbcSM",10) == 3521044267) strcat(s, "O");
if (crc32("mTIEw",5) == 3754636676) strcat(s, "p");
    return s;
}

char *culminated_verbs() {
    char *s = calloc(11);
    if (crc32("bhBYOh",6) == 994315351) strcat(s, "c");
if (crc32("hJntJkFdWbgj",12) == 486578269) strcat(s, "u");
if (crc32("xXvGQgdDR",9) == 1266201137) strcat(s, "l");
if (crc32("avIKUENNtSDAdmc",15) == 1237274926) strcat(s, "m");
if (crc32("HanwSiJcOHww",12) == 557552255) strcat(s, "i");
if (crc32("NmHALQJpHOHGnO",14) == 2310368388) strcat(s, "n");
if (crc32("aRuJNBYfyQwI",12) == 1969985377) strcat(s, "a");
if (crc32("kbVaqOhUY",9) == 1591568129) strcat(s, "s");
if (crc32("popcdJBR",8) == 4015982516) strcat(s, "t");
if (crc32("iQpQUImPYy",10) == 4025281569) strcat(s, "W");
if (crc32("DKHgeBdZjnUiN",13) == 2230760448) strcat(s, "e");
if (crc32("lMIrZHN",7) == 3601738907) strcat(s, "l");
if (crc32("EIPuEfE",7) == 2226812788) strcat(s, "d");
    return s;
}

char *guillotining_verbs() {
    char *s = calloc(13);
    if (crc32("VUuZUS",6) == 2474793061) strcat(s, "g");
if (crc32("dAlBR",5) == 2413770451) strcat(s, "u");
if (crc32("XpxMGMfgNKmo",12) == 3177529158) strcat(s, "f");
if (crc32("GRnxuPPXdp",10) == 1113902358) strcat(s, "i");
if (crc32("ZqDzbEXXMSPlWz",14) == 1389952179) strcat(s, "v");
if (crc32("ZGXquMD",7) == 3039301338) strcat(s, "l");
if (crc32("uADsotyMXJYVX",13) == 1492622510) strcat(s, "n");
if (crc32("CKDToQMPJnWRZ",13) == 147995380) strcat(s, "l");
if (crc32("DSnKFxFK",8) == 1688578484) strcat(s, "o");
if (crc32("rKlxxqeWUWPGp",13) == 3981510400) strcat(s, "t");
if (crc32("oeXXOobxDWQ",11) == 800035549) strcat(s, "n");
if (crc32("TWIOGkEKDA",10) == 2024010508) strcat(s, "i");
if (crc32("kFQypyCYbEHitY",14) == 66899115) strcat(s, "n");
if (crc32("GHVcMsFbJni",11) == 2726769620) strcat(s, "c");
if (crc32("XTEui",5) == 2589585542) strcat(s, "i");
if (crc32("OhNTDNtmXAIUiNw",15) == 350380471) strcat(s, "n");
if (crc32("wElKhUa",7) == 1383975694) strcat(s, "n");
if (crc32("UAeQIBRyEwtb",12) == 3749006293) strcat(s, "g");
    return s;
}

char *guesstimated_verbs() {
    char *s = calloc(13);
    if (crc32("pUTGdKg",7) == 1771216471) strcat(s, "g");
if (crc32("snPPvcwkQi",10) == 988544230) strcat(s, "u");
if (crc32("NFfKAyPDOs",10) == 2890706898) strcat(s, "e");
if (crc32("ahHdrdBFtw",10) == 3903018719) strcat(s, "Y");
if (crc32("ockbnIMjr",9) == 1853823224) strcat(s, "s");
if (crc32("HfXZEKyDUT",10) == 348368120) strcat(s, "Z");
if (crc32("JCmVgLF",7) == 4126430976) strcat(s, "s");
if (crc32("dHZzrskIQuL",11) == 1659403963) strcat(s, "t");
if (crc32("HsFayL",6) == 4061703939) strcat(s, "Z");
if (crc32("RemmgJT",7) == 4076456684) strcat(s, "i");
if (crc32("ZaxTBtltIVFF",12) == 1101601273) strcat(s, "m");
if (crc32("UhyNGkdQlJuaO",13) == 3720245608) strcat(s, "q");
if (crc32("rmRSMJPVUnrYcKy",15) == 327390282) strcat(s, "a");
if (crc32("Mcauco",6) == 2666253308) strcat(s, "t");
if (crc32("UhGwtHgR",8) == 2509103737) strcat(s, "s");
if (crc32("qqWKtxM",7) == 1834489917) strcat(s, "e");
if (crc32("AKdRvdx",7) == 403312375) strcat(s, "d");
    return s;
}

char *yipping_verbs() {
    char *s = calloc(8);
    if (crc32("kpAHtQpOwjlQJYc",15) == 2184047607) strcat(s, "y");
if (crc32("bUTJRA",6) == 2579203678) strcat(s, "s");
if (crc32("KiJiLYnAnhUDvO",14) == 1426146397) strcat(s, "i");
if (crc32("KOoUEzjPD",9) == 751159548) strcat(s, "H");
if (crc32("xnzHhhPyLBP",11) == 3720544565) strcat(s, "p");
if (crc32("rQBYfC",6) == 2086253200) strcat(s, "p");
if (crc32("eYJQlYMkzKOPQT",14) == 2624046255) strcat(s, "i");
if (crc32("chMVIPvK",8) == 2504074757) strcat(s, "i");
if (crc32("sDxVbHQE",8) == 3368744009) strcat(s, "k");
if (crc32("pFaKRqQtvtvkg",13) == 603830338) strcat(s, "n");
if (crc32("SPKWTZpwOYY",11) == 1196863723) strcat(s, "g");
    return s;
}

char *attrited_verbs() {
    char *s = calloc(9);
    if (crc32("bwgDam",6) == 1926182745) strcat(s, "z");
if (crc32("IvdxWb",6) == 1474788659) strcat(s, "a");
if (crc32("VugspuRPQRIekOa",15) == 1187100455) strcat(s, "t");
if (crc32("BkrFGxQIhQF",11) == 2231781263) strcat(s, "H");
if (crc32("hUQwSPmUcZazZW",14) == 2202768409) strcat(s, "t");
if (crc32("PhXoqyH",7) == 3807498715) strcat(s, "r");
if (crc32("XxYfXRGpznz",11) == 2659179492) strcat(s, "e");
if (crc32("GahtZtu",7) == 2556481814) strcat(s, "i");
if (crc32("eAKLcYSAj",9) == 1765069564) strcat(s, "t");
if (crc32("YtwmyitVqXzzH",13) == 3520420256) strcat(s, "E");
if (crc32("WywAjrHJmh",10) == 977370458) strcat(s, "e");
if (crc32("IedRFqBVFhXaJQY",15) == 1093693641) strcat(s, "B");
if (crc32("yRwUWpf",7) == 4041647515) strcat(s, "d");
    return s;
}

char *desegregate_verbs() {
    char *s = calloc(12);
    if (crc32("uNQkWkDmdxyz",12) == 1213262346) strcat(s, "d");
if (crc32("hktjrOVw",8) == 886890724) strcat(s, "e");
if (crc32("NTNDqEQHdjLBNs",14) == 188888828) strcat(s, "s");
if (crc32("xeYXaNmTOxgGtc",14) == 2211474948) strcat(s, "T");
if (crc32("MsuvF",5) == 2871784697) strcat(s, "e");
if (crc32("WarGMeRh",8) == 1760299350) strcat(s, "H");
if (crc32("MGrqGGipLTEVKHn",15) == 4214545649) strcat(s, "g");
if (crc32("DyzJJs",6) == 1809622144) strcat(s, "r");
if (crc32("lEKYdld",7) == 1757668013) strcat(s, "c");
if (crc32("odJSZnCJ",8) == 1774462013) strcat(s, "e");
if (crc32("FxCHDAvpKA",10) == 1958913602) strcat(s, "D");
if (crc32("OpbDbX",6) == 1658401698) strcat(s, "g");
if (crc32("FhWEWaWsufJhlOp",15) == 3978710502) strcat(s, "a");
if (crc32("KIiRI",5) == 3749782977) strcat(s, "X");
if (crc32("tgMQQkc",7) == 2091132562) strcat(s, "t");
if (crc32("rcYexTuTMmf",11) == 2162577580) strcat(s, "e");
    return s;
}

char *fiddlefaddled_verbs() {
    char *s = calloc(14);
    if (crc32("NngCKnDnVQZtiB",14) == 1011382390) strcat(s, "f");
if (crc32("mXafKzmlQngfjvo",15) == 996685978) strcat(s, "R");
if (crc32("cmxij",5) == 2454107166) strcat(s, "i");
if (crc32("BukczCLOMTyUbj",14) == 3065315763) strcat(s, "P");
if (crc32("IlZYSpgULdtnN",13) == 576515144) strcat(s, "d");
if (crc32("awStDmIKe",9) == 1355770797) strcat(s, "W");
if (crc32("szmlNUp",7) == 399161551) strcat(s, "d");
if (crc32("Dubjvs",6) == 1883179502) strcat(s, "l");
if (crc32("JxoCrQaUxxJBzV",14) == 581744666) strcat(s, "t");
if (crc32("MZtHYbT",7) == 536305532) strcat(s, "e");
if (crc32("oSrVT",5) == 2860039990) strcat(s, "h");
if (crc32("KWrtLIVUY",9) == 3359395266) strcat(s, "f");
if (crc32("XDdyWsNVXhYR",12) == 3743426669) strcat(s, "R");
if (crc32("EUEmKkPnxDuxTVd",15) == 3917043305) strcat(s, "a");
if (crc32("DRKkaTz",7) == 2289606615) strcat(s, "d");
if (crc32("kryOEDZ",7) == 3399367313) strcat(s, "e");
if (crc32("YFyjOSVoNePE",12) == 2365863589) strcat(s, "d");
if (crc32("pwkSSFCYSGFfcp",14) == 637725434) strcat(s, "l");
if (crc32("DrSiyTrpWoVe",12) == 1405645951) strcat(s, "e");
if (crc32("oXRQu",5) == 1057891252) strcat(s, "d");
    return s;
}

char *sparring_verbs() {
    char *s = calloc(9);
    if (crc32("MSfbVez",7) == 1973180729) strcat(s, "s");
if (crc32("AdLjhsEWimYEe",13) == 3682169052) strcat(s, "Z");
if (crc32("jxIloAqu",8) == 2337141016) strcat(s, "p");
if (crc32("tbhXOIyVWd",10) == 3501015837) strcat(s, "L");
if (crc32("veEzPnbuOGJa",12) == 4028595537) strcat(s, "a");
if (crc32("DFkhIGUVecDJT",13) == 1842802088) strcat(s, "o");
if (crc32("KLByEounqo",10) == 508087779) strcat(s, "r");
if (crc32("gkQpPWpaRBnpRpg",15) == 3674078373) strcat(s, "r");
if (crc32("yIhlV",5) == 340654297) strcat(s, "l");
if (crc32("OtOIdXpoTG",10) == 2240278477) strcat(s, "i");
if (crc32("CosbyQe",7) == 2251934657) strcat(s, "s");
if (crc32("RBHXahngRClGRy",14) == 2543291837) strcat(s, "n");
if (crc32("HAAyu",5) == 862564952) strcat(s, "I");
if (crc32("JjpqMK",6) == 1448537326) strcat(s, "g");
    return s;
}

char *trimmest_verbs() {
    char *s = calloc(9);
    if (crc32("QoZruk",6) == 379583734) strcat(s, "t");
if (crc32("GfmEOOB",7) == 3846374672) strcat(s, "x");
if (crc32("BMlXJLilc",9) == 2437547923) strcat(s, "r");
if (crc32("noqWxPaDwcwbEn",14) == 682607315) strcat(s, "l");
if (crc32("cMGTaOAokxdN",12) == 1028208610) strcat(s, "i");
if (crc32("pJtAwcKTimV",11) == 2382059428) strcat(s, "m");
if (crc32("ynyJZng",7) == 1478596714) strcat(s, "b");
if (crc32("XkQtHCdjYvi",11) == 631844816) strcat(s, "m");
if (crc32("NgpSc",5) == 1695280499) strcat(s, "h");
if (crc32("edfGuxg",7) == 2705112743) strcat(s, "e");
if (crc32("ZiKmGbSRibS",11) == 3670856883) strcat(s, "B");
if (crc32("pjjQWQlMdRxEmR",14) == 3020860083) strcat(s, "s");
if (crc32("BWLCixLrXXMzYA",14) == 186000828) strcat(s, "t");
if (crc32("KPLSuXh",7) == 4033116035) strcat(s, "t");
    return s;
}

char *allegorizing_verbs() {
    char *s = calloc(13);
    if (crc32("ceEsw",5) == 594289706) strcat(s, "B");
if (crc32("wGtISIHaEVP",11) == 2077060663) strcat(s, "a");
if (crc32("DDzWLRBhDuvnqqn",15) == 437116712) strcat(s, "l");
if (crc32("ErKeamFt",8) == 2033927619) strcat(s, "l");
if (crc32("AwQQxQpywzp",11) == 3081411357) strcat(s, "e");
if (crc32("eDhTgMWj",8) == 1354674642) strcat(s, "h");
if (crc32("yrUZTKzxsp",10) == 531326860) strcat(s, "g");
if (crc32("BKkLCLVnX",9) == 3488087042) strcat(s, "P");
if (crc32("oNchTAWhep",10) == 2568368769) strcat(s, "o");
if (crc32("WBgLnBiOIZUPD",13) == 363590912) strcat(s, "r");
if (crc32("qDWlDNIYdoluG",13) == 1889334536) strcat(s, "i");
if (crc32("uMRhocYiLFQjHyA",15) == 830964023) strcat(s, "z");
if (crc32("mPtFjNzcfyyqhLZ",15) == 2426842817) strcat(s, "i");
if (crc32("zDPDxfHeGdDs",12) == 3629988845) strcat(s, "n");
if (crc32("imCstJVPe",9) == 3000754791) strcat(s, "g");
    return s;
}

char *geld_verbs() {
    char *s = calloc(5);
    if (crc32("CONJfdwPPwnawRb",15) == 3442211382) strcat(s, "g");
if (crc32("cEJLPzbwEjtviF",14) == 3273274625) strcat(s, "C");
if (crc32("uWqJxhSPPhf",11) == 174618991) strcat(s, "e");
if (crc32("MtIcrwKgDkA",11) == 2985258509) strcat(s, "l");
if (crc32("ZQnhqtmRdcL",11) == 2491518652) strcat(s, "d");
    return s;
}

char *rethaw_verbs() {
    char *s = calloc(7);
    if (crc32("CMkqOFbSAkCfKdf",15) == 2335570203) strcat(s, "r");
if (crc32("SfbqVZUnvNBfBt",14) == 1274002176) strcat(s, "F");
if (crc32("uiMMhvmgydTCO",13) == 266111577) strcat(s, "e");
if (crc32("HRtyCUxAKALW",12) == 2210971938) strcat(s, "d");
if (crc32("sezztNLjBnlqKYI",15) == 1203917188) strcat(s, "t");
if (crc32("AzuclWHgGzBkV",13) == 173568458) strcat(s, "h");
if (crc32("ZkkEnRREQP",10) == 2996883695) strcat(s, "l");
if (crc32("rUkuiRkaNbbkEK",14) == 2796647980) strcat(s, "a");
if (crc32("zqKEkCBZZyjg",12) == 1541831410) strcat(s, "o");
if (crc32("XvyNRObWUzrEv",13) == 2755777257) strcat(s, "w");
    return s;
}

char *traverse_verbs() {
    char *s = calloc(9);
    if (crc32("MOIfRlhMZKK",11) == 3927611572) strcat(s, "c");
if (crc32("QtSTxqUO",8) == 2031596639) strcat(s, "t");
if (crc32("osbnPxuxOm",10) == 3066789822) strcat(s, "k");
if (crc32("LFGmnfStViBB",12) == 4189704050) strcat(s, "r");
if (crc32("aJcbfsJoQ",9) == 114439366) strcat(s, "a");
if (crc32("yXTwCwbTyyeEq",13) == 3001300539) strcat(s, "k");
if (crc32("grbaCPYPeXKoODE",15) == 965484287) strcat(s, "v");
if (crc32("lkiFowSkXYq",11) == 394716190) strcat(s, "g");
if (crc32("DmvvNlNHP",9) == 3282461346) strcat(s, "e");
if (crc32("TSraeteGBYoOe",13) == 1179641406) strcat(s, "y");
if (crc32("WPUTCUgvy",9) == 3175764066) strcat(s, "r");
if (crc32("YANJm",5) == 2467856223) strcat(s, "s");
if (crc32("LBcuI",5) == 4220366545) strcat(s, "X");
if (crc32("AcBiqz",6) == 1539032443) strcat(s, "e");
    return s;
}

char *edify_verbs() {
    char *s = calloc(6);
    if (crc32("jcxuXCpAnnwYvK",14) == 2360324768) strcat(s, "n");
if (crc32("atwrhpeYGKobrD",14) == 700265027) strcat(s, "e");
if (crc32("dxHPrPCmph",10) == 1917960547) strcat(s, "d");
if (crc32("HBqWRk",6) == 2556910145) strcat(s, "i");
if (crc32("HaVuFb",6) == 3094610817) strcat(s, "T");
if (crc32("gSCZOngoHOtRXp",14) == 2641188968) strcat(s, "f");
if (crc32("gvFKIPd",7) == 1534406119) strcat(s, "k");
if (crc32("PFYFAFD",7) == 1242496798) strcat(s, "y");
    return s;
}

char *eulogize_verbs() {
    char *s = calloc(9);
    if (crc32("pZFgsTJobuW",11) == 2612549617) strcat(s, "e");
if (crc32("CPszRpXZGoHzAE",14) == 129598082) strcat(s, "u");
if (crc32("KUDxic",6) == 180227385) strcat(s, "l");
if (crc32("eIAvQRV",7) == 545908401) strcat(s, "o");
if (crc32("vqsuUrB",7) == 3751147817) strcat(s, "g");
if (crc32("MghxFLkPzIvq",12) == 912939995) strcat(s, "i");
if (crc32("hLRnkCkALj",10) == 3290619224) strcat(s, "z");
if (crc32("Himdjx",6) == 2176125599) strcat(s, "e");
    return s;
}

char *follow_verbs() {
    char *s = calloc(7);
    if (crc32("VKnlLuHgxCt",11) == 1323006552) strcat(s, "f");
if (crc32("oolIaZEmZwpE",12) == 234827008) strcat(s, "q");
if (crc32("zgIGGWzMajIFqo",14) == 3553330493) strcat(s, "o");
if (crc32("PorFuAaJM",9) == 1712497902) strcat(s, "l");
if (crc32("HQdlMgwmDo",10) == 1951561398) strcat(s, "l");
if (crc32("oeYlXyAqMJS",11) == 1839097140) strcat(s, "Y");
if (crc32("YLXZXCrroXsOq",13) == 2554586010) strcat(s, "o");
if (crc32("wcSTqhw",7) == 929654422) strcat(s, "w");
    return s;
}

char *dissociating_verbs() {
    char *s = calloc(13);
    if (crc32("RgUrenoVRiq",11) == 1286573764) strcat(s, "d");
if (crc32("UUIVegadEgswQ",13) == 2092067821) strcat(s, "O");
if (crc32("vXTnLkPPZzQQEud",15) == 139365831) strcat(s, "i");
if (crc32("tlITm",5) == 3711494693) strcat(s, "v");
if (crc32("hwcixMYY",8) == 4205214631) strcat(s, "s");
if (crc32("LehIGtYTeCpZX",13) == 181875290) strcat(s, "s");
if (crc32("XGoLFyrlp",9) == 2119915273) strcat(s, "u");
if (crc32("DIKfxPeaV",9) == 2035896807) strcat(s, "o");
if (crc32("LyjrqOZ",7) == 97892582) strcat(s, "Z");
if (crc32("QVjgHifIlm",10) == 1464518919) strcat(s, "c");
if (crc32("uoIGr",5) == 3190159685) strcat(s, "H");
if (crc32("dlBdFXPxdGuWnMj",15) == 1985004821) strcat(s, "i");
if (crc32("bqXOGNmQyKrZq",13) == 3377646949) strcat(s, "e");
if (crc32("amYNgbcaQXqf",12) == 1877804114) strcat(s, "a");
if (crc32("GmcdZCTID",9) == 4270981934) strcat(s, "t");
if (crc32("TelscwuHS",9) == 547228085) strcat(s, "i");
if (crc32("NLckyXauui",10) == 2298969610) strcat(s, "S");
if (crc32("JcStSsDOZ",9) == 4239061703) strcat(s, "n");
if (crc32("UQnsytdyBeSmODA",15) == 1812968542) strcat(s, "g");
    return s;
}

char *molder_verbs() {
    char *s = calloc(7);
    if (crc32("tLnGqOg",7) == 739569071) strcat(s, "m");
if (crc32("XbDPgW",6) == 362076153) strcat(s, "o");
if (crc32("kisCF",5) == 2598931783) strcat(s, "Y");
if (crc32("qOTMl",5) == 2877418590) strcat(s, "l");
if (crc32("zfVsmaJTTLDTH",13) == 239016269) strcat(s, "u");
if (crc32("eOCffDxQaqWq",12) == 2499018090) strcat(s, "d");
if (crc32("wPGmxDgOF",9) == 4251431368) strcat(s, "O");
if (crc32("aVXuT",5) == 3505888968) strcat(s, "e");
if (crc32("dTDUGr",6) == 3346849311) strcat(s, "y");
if (crc32("pclZeD",6) == 496130121) strcat(s, "r");
    return s;
}

char *leveeing_verbs() {
    char *s = calloc(9);
    if (crc32("gsYQUBtsAnLx",12) == 3818382306) strcat(s, "l");
if (crc32("RbDbXUOnzK",10) == 2600201508) strcat(s, "T");
if (crc32("ZprgTOgMiAT",11) == 2856236675) strcat(s, "e");
if (crc32("dpXDIOC",7) == 1067877969) strcat(s, "g");
if (crc32("SAGFKPWklzDxhZ",14) == 4140602645) strcat(s, "v");
if (crc32("bvdPNFb",7) == 425952808) strcat(s, "k");
if (crc32("FVxrsTr",7) == 1587538311) strcat(s, "e");
if (crc32("PVPfYt",6) == 2975430711) strcat(s, "e");
if (crc32("qJyVZkg",7) == 615255129) strcat(s, "p");
if (crc32("zSsfhMSTRe",10) == 3223024342) strcat(s, "i");
if (crc32("tWeymNKB",8) == 1548708545) strcat(s, "h");
if (crc32("pfcvB",5) == 2325427384) strcat(s, "n");
if (crc32("HcatMxePE",9) == 3859247476) strcat(s, "p");
if (crc32("wQHRBBkmgw",10) == 4099019684) strcat(s, "g");
    return s;
}

char *appareling_verbs() {
    char *s = calloc(11);
    if (crc32("AiDwBopJyMHngqh",15) == 202490356) strcat(s, "a");
if (crc32("uKTSkbjAiiobFUX",15) == 2891583113) strcat(s, "w");
if (crc32("XWTKtsKGMlEryV",14) == 3499986066) strcat(s, "p");
if (crc32("sMeOxSof",8) == 3031368710) strcat(s, "K");
if (crc32("JdsSf",5) == 64342866) strcat(s, "p");
if (crc32("fBWEjjSbXQbTl",13) == 555336383) strcat(s, "a");
if (crc32("FzNozlGZjcUh",12) == 3007796303) strcat(s, "D");
if (crc32("fEuEYPvzFfrD",12) == 116952024) strcat(s, "r");
if (crc32("JcBeQ",5) == 2315929654) strcat(s, "e");
if (crc32("FKjujdRfyqGv",12) == 3805271179) strcat(s, "S");
if (crc32("elEoM",5) == 2052670197) strcat(s, "l");
if (crc32("UpQtlJP",7) == 649920800) strcat(s, "i");
if (crc32("cwaKWVA",7) == 1704994684) strcat(s, "m");
if (crc32("aryMuwxfcrGFGY",14) == 2141605343) strcat(s, "n");
if (crc32("NhadOYBcAHdAIXB",15) == 3267965080) strcat(s, "g");
    return s;
}

char *spoked_verbs() {
    char *s = calloc(7);
    if (crc32("gSdJjfW",7) == 2665438589) strcat(s, "s");
if (crc32("nqFVMdgZWKtgKIW",15) == 2043787328) strcat(s, "s");
if (crc32("eaKNJ",5) == 2421569378) strcat(s, "p");
if (crc32("HYiKnRGTFQBY",12) == 557903156) strcat(s, "y");
if (crc32("MogInpr",7) == 1600210286) strcat(s, "o");
if (crc32("UCymZ",5) == 3216883370) strcat(s, "k");
if (crc32("ufZgdwJAxpm",11) == 1592561411) strcat(s, "m");
if (crc32("clcOPDzmePyRLJ",14) == 2437511954) strcat(s, "e");
if (crc32("mEzMsUngvS",10) == 2979266475) strcat(s, "s");
if (crc32("oIHRzvrEhYqcO",13) == 2470509424) strcat(s, "d");
    return s;
}

char *deescalate_verbs() {
    char *s = calloc(11);
    if (crc32("QQhAvanP",8) == 1869380470) strcat(s, "d");
if (crc32("fVEGoKkGrUe",11) == 3457314001) strcat(s, "U");
if (crc32("OyJOzAyz",8) == 2750972368) strcat(s, "e");
if (crc32("oDgJTxPhzlmsrl",14) == 949858377) strcat(s, "e");
if (crc32("BQUeRvANh",9) == 4135164787) strcat(s, "s");
if (crc32("AiImeEvSUJFJyXQ",15) == 2714478224) strcat(s, "k");
if (crc32("qBAAjw",6) == 1343015923) strcat(s, "c");
if (crc32("CzfGAkzDuLGVC",13) == 2205667154) strcat(s, "u");
if (crc32("vvUPOCpGnYDrGjz",15) == 3969518300) strcat(s, "a");
if (crc32("vYYRDPbfpBG",11) == 3465593795) strcat(s, "l");
if (crc32("FzyCMDzRdhW",11) == 998629905) strcat(s, "a");
if (crc32("vGUgsJDmI",9) == 3236919155) strcat(s, "t");
if (crc32("pIcJFdAvFJKbs",13) == 2472793151) strcat(s, "l");
if (crc32("MKjAxviGGjIPP",13) == 1254352226) strcat(s, "e");
    return s;
}

char *ratify_verbs() {
    char *s = calloc(7);
    if (crc32("uGIIFUn",7) == 839070240) strcat(s, "s");
if (crc32("VAXsqVFmnei",11) == 2168171902) strcat(s, "r");
if (crc32("ZPsmdwNbsvyN",12) == 3942346352) strcat(s, "U");
if (crc32("QlArwJieLaS",11) == 3592564209) strcat(s, "a");
if (crc32("UhrhvPzgqrHMvc",14) == 911285136) strcat(s, "t");
if (crc32("WxMKZUxTjggd",12) == 2799536842) strcat(s, "i");
if (crc32("GeASPggtbHE",11) == 2471181271) strcat(s, "Y");
if (crc32("UBolEbRNY",9) == 2784346014) strcat(s, "f");
if (crc32("qdvjvD",6) == 516834309) strcat(s, "y");
    return s;
}

char *rouletted_verbs() {
    char *s = calloc(10);
    if (crc32("IfWyoDrHtZO",11) == 173956267) strcat(s, "h");
if (crc32("WndBDdCIylrHkQk",15) == 511306242) strcat(s, "r");
if (crc32("Hgfaamlabh",10) == 3823979458) strcat(s, "o");
if (crc32("JOOdkbr",7) == 1086119880) strcat(s, "u");
if (crc32("zZJgn",5) == 743135644) strcat(s, "l");
if (crc32("VjEUekNznVFl",12) == 2631601554) strcat(s, "e");
if (crc32("vlrZzKm",7) == 866701194) strcat(s, "t");
if (crc32("cAngf",5) == 444035317) strcat(s, "I");
if (crc32("oSugMal",7) == 3186315304) strcat(s, "t");
if (crc32("sMLckp",6) == 3807318519) strcat(s, "a");
if (crc32("NazAc",5) == 3334742643) strcat(s, "e");
if (crc32("faOOaYMcVDizEbP",15) == 2511707902) strcat(s, "E");
if (crc32("CdAfUVrK",8) == 123340619) strcat(s, "d");
    return s;
}

char *curvetted_verbs() {
    char *s = calloc(10);
    if (crc32("NGBcNtNZrHOI",12) == 113918481) strcat(s, "c");
if (crc32("aAfxOzYECdRK",12) == 3165018283) strcat(s, "z");
if (crc32("nmkTSLTXNQqN",12) == 1371809745) strcat(s, "u");
if (crc32("jUmIjEGev",9) == 3848254177) strcat(s, "Z");
if (crc32("OTgxcwRp",8) == 1056128690) strcat(s, "r");
if (crc32("AQDTff",6) == 2985776421) strcat(s, "H");
if (crc32("gdeyFpFxOttFIiS",15) == 2195738846) strcat(s, "v");
if (crc32("qIXhGYpdVWH",11) == 4269247157) strcat(s, "e");
if (crc32("bCpzLgh",7) == 3684454069) strcat(s, "z");
if (crc32("JNTxvOHVdCUk",12) == 2301329673) strcat(s, "t");
if (crc32("FJlizHzccFy",11) == 1570295692) strcat(s, "t");
if (crc32("olfnKRIbnDMuX",13) == 2511828764) strcat(s, "p");
if (crc32("bzsPyBIxXzno",12) == 1020243720) strcat(s, "e");
if (crc32("ceGpEKeYisRjpY",14) == 173357189) strcat(s, "d");
    return s;
}

char *fossilizing_verbs() {
    char *s = calloc(12);
    if (crc32("IWwQfRe",7) == 2620956176) strcat(s, "f");
if (crc32("dFFLzDGtWdoqPpe",15) == 1416825007) strcat(s, "o");
if (crc32("euzlAKsD",8) == 3533490801) strcat(s, "c");
if (crc32("NasmPvu",7) == 142134551) strcat(s, "s");
if (crc32("nbxXGrtsWbm",11) == 4007772975) strcat(s, "V");
if (crc32("CloIsT",6) == 282504687) strcat(s, "s");
if (crc32("xYWtHYCmJhoTRW",14) == 3969297587) strcat(s, "i");
if (crc32("LXlmSdaoJwmc",12) == 2811792862) strcat(s, "F");
if (crc32("VtjRVpsfKVxiYYo",15) == 322561348) strcat(s, "l");
if (crc32("ZALORH",6) == 600449223) strcat(s, "i");
if (crc32("nHawfGrsUEQ",11) == 3797377111) strcat(s, "H");
if (crc32("DjRhH",5) == 2245119008) strcat(s, "z");
if (crc32("NcZOAOWAP",9) == 3541253110) strcat(s, "J");
if (crc32("FghoCuQflr",10) == 3330967661) strcat(s, "i");
if (crc32("LjkTltPjWdvi",12) == 3994970339) strcat(s, "n");
if (crc32("shVWj",5) == 3060704057) strcat(s, "g");
    return s;
}

char *imbibe_verbs() {
    char *s = calloc(7);
    if (crc32("SYGrrpYSdfTNhW",14) == 1600602244) strcat(s, "i");
if (crc32("lrPQUTSsKmuV",12) == 244380116) strcat(s, "m");
if (crc32("ryYhTfwLpM",10) == 1580918456) strcat(s, "w");
if (crc32("xFbDuBSCclFE",12) == 1537536222) strcat(s, "b");
if (crc32("ofHaqgND",8) == 2990058466) strcat(s, "W");
if (crc32("GlDNClBPKa",10) == 1037000612) strcat(s, "i");
if (crc32("rrDqgRZAHv",10) == 2103480168) strcat(s, "S");
if (crc32("ozbRpqaDCBjSa",13) == 3031410560) strcat(s, "b");
if (crc32("arfpoxjABgZpfYK",15) == 1635567442) strcat(s, "v");
if (crc32("FVeTXJMdSJj",11) == 1161650382) strcat(s, "e");
    return s;
}

char *regurgitated_verbs() {
    char *s = calloc(13);
    if (crc32("bIUxhJJJRehpKJ",14) == 3375755639) strcat(s, "j");
if (crc32("MIFMNIdsqsAOSP",14) == 2023631827) strcat(s, "r");
if (crc32("XZtiDdN",7) == 4193266465) strcat(s, "S");
if (crc32("ZIIoSxvspCEpM",13) == 194417447) strcat(s, "e");
if (crc32("sNsVNvSJoSp",11) == 371108176) strcat(s, "g");
if (crc32("GlITlTioHJdJrIq",15) == 648955529) strcat(s, "u");
if (crc32("oKtHXRJLzTRGH",13) == 3186770402) strcat(s, "r");
if (crc32("GjYAxccjNPNxcZ",14) == 1873002621) strcat(s, "g");
if (crc32("ZCzHGphqMxCr",12) == 2002423490) strcat(s, "n");
if (crc32("KnDJkEbxw",9) == 1104455137) strcat(s, "i");
if (crc32("XVqQENaN",8) == 1571155260) strcat(s, "t");
if (crc32("DDMKzbIZFgHM",12) == 2714062713) strcat(s, "a");
if (crc32("RCgzJkvPdDEwQb",14) == 2330260652) strcat(s, "t");
if (crc32("tkhIRe",6) == 1311201712) strcat(s, "i");
if (crc32("eLAaTtiD",8) == 3436045457) strcat(s, "e");
if (crc32("PswLhknicrV",11) == 2338405791) strcat(s, "d");
    return s;
}

char *supplied_verbs() {
    char *s = calloc(9);
    if (crc32("jWoDuOCnSZz",11) == 522094215) strcat(s, "Z");
if (crc32("GeNrOEhTDVb",11) == 1663752512) strcat(s, "s");
if (crc32("cxyfKIdTXx",10) == 671322955) strcat(s, "K");
if (crc32("KSAMZ",5) == 2408075356) strcat(s, "u");
if (crc32("WatjpNkx",8) == 2648508904) strcat(s, "p");
if (crc32("uBRCMGtWY",9) == 1224212148) strcat(s, "P");
if (crc32("DLoDbfxNUe",10) == 2284315649) strcat(s, "p");
if (crc32("dBDfgRdu",8) == 482439319) strcat(s, "z");
if (crc32("UzCEcVgaJuI",11) == 3978550440) strcat(s, "l");
if (crc32("LVDdJgYeFyU",11) == 2308577641) strcat(s, "i");
if (crc32("DstWuWDOhiT",11) == 3185976230) strcat(s, "e");
if (crc32("VTuTes",6) == 1079266020) strcat(s, "d");
    return s;
}

char *rationalize_verbs() {
    char *s = calloc(12);
    if (crc32("PHlMvlXXAJy",11) == 853053063) strcat(s, "r");
if (crc32("yJvHbkQXGBN",11) == 1302302914) strcat(s, "a");
if (crc32("egaHQnGQxDMwKKO",15) == 584104371) strcat(s, "u");
if (crc32("YdYmE",5) == 4075654969) strcat(s, "t");
if (crc32("HkpuJXjILeeXP",13) == 1400423570) strcat(s, "i");
if (crc32("rQgfe",5) == 1969661990) strcat(s, "o");
if (crc32("ElEqowv",7) == 761982308) strcat(s, "n");
if (crc32("GFQJGKLedPH",11) == 152332034) strcat(s, "J");
if (crc32("GVByQybjvVH",11) == 3120119911) strcat(s, "a");
if (crc32("YFTPeSL",7) == 913879251) strcat(s, "z");
if (crc32("geKelaGnuk",10) == 2096770172) strcat(s, "l");
if (crc32("utVrXQ",6) == 3283149655) strcat(s, "U");
if (crc32("YlMxmItFICkthq",14) == 2107025172) strcat(s, "i");
if (crc32("ZQBlpojObO",10) == 2954056436) strcat(s, "s");
if (crc32("xyLauIgBKF",10) == 1580599890) strcat(s, "z");
if (crc32("tKdlJMFaS",9) == 3201340617) strcat(s, "e");
    return s;
}

char *interworked_verbs() {
    char *s = calloc(12);
    if (crc32("gBewOs",6) == 1705746368) strcat(s, "i");
if (crc32("eVcmW",5) == 375126938) strcat(s, "n");
if (crc32("loqqoyvSUT",10) == 124445704) strcat(s, "t");
if (crc32("ZLoEMh",6) == 3195896765) strcat(s, "u");
if (crc32("wHHFEnaZyf",10) == 2398921138) strcat(s, "e");
if (crc32("Laptkn",6) == 1916667841) strcat(s, "m");
if (crc32("isdYpTALuQaQ",12) == 3704350779) strcat(s, "r");
if (crc32("HYhGeJfTWXEjQ",13) == 2133639039) strcat(s, "w");
if (crc32("KPRDDLpPrHacN",13) == 2289146453) strcat(s, "o");
if (crc32("YEmzGxpFVZu",11) == 2837525528) strcat(s, "r");
if (crc32("HiCfmQNfO",9) == 4204523564) strcat(s, "x");
if (crc32("iJBOpJoYCJeNwn",14) == 3363706024) strcat(s, "k");
if (crc32("lhBJfvMTcrlcaY",14) == 1689748010) strcat(s, "h");
if (crc32("eptpk",5) == 1516809750) strcat(s, "e");
if (crc32("uXQGZVKKGlbf",12) == 2469376174) strcat(s, "d");
    return s;
}

char *scrupled_verbs() {
    char *s = calloc(9);
    if (crc32("DlKHCm",6) == 2206933792) strcat(s, "T");
if (crc32("oMnop",5) == 1142388511) strcat(s, "s");
if (crc32("nsAnoOxz",8) == 3497062855) strcat(s, "c");
if (crc32("JclCXYQ",7) == 867048789) strcat(s, "r");
if (crc32("kKlWNrtvz",9) == 98677457) strcat(s, "V");
if (crc32("efZxAWTBUnrcFE",14) == 3518911756) strcat(s, "u");
if (crc32("SOCHZS",6) == 2758117977) strcat(s, "p");
if (crc32("iehGzF",6) == 2196128354) strcat(s, "t");
if (crc32("VncFlTXg",8) == 3485478909) strcat(s, "l");
if (crc32("nnygeZja",8) == 3028407224) strcat(s, "e");
if (crc32("YzRukdWgCwmf",12) == 2770559970) strcat(s, "d");
    return s;
}

char *stooging_verbs() {
    char *s = calloc(9);
    if (crc32("QPAWOriVtam",11) == 1868149580) strcat(s, "s");
if (crc32("rtuUx",5) == 1782942173) strcat(s, "t");
if (crc32("pbhAALDX",8) == 4293064640) strcat(s, "o");
if (crc32("BEGGriddVhGIT",13) == 3030803631) strcat(s, "v");
if (crc32("jZYYBSR",7) == 4216614199) strcat(s, "o");
if (crc32("kdCWGEH",7) == 1324185096) strcat(s, "g");
if (crc32("pkcDkqMKHea",11) == 2375350789) strcat(s, "i");
if (crc32("zimzFI",6) == 3058715095) strcat(s, "n");
if (crc32("gZXuy",5) == 2959953202) strcat(s, "f");
if (crc32("CTbUK",5) == 4035928886) strcat(s, "g");
    return s;
}

char *trod_verbs() {
    char *s = calloc(5);
    if (crc32("FdTeZsyuy",9) == 3139132611) strcat(s, "t");
if (crc32("xepXAqfulLS",11) == 1740223009) strcat(s, "E");
if (crc32("uxcgjbk",7) == 1959105146) strcat(s, "r");
if (crc32("unuZlnXzWOdypr",14) == 2701371353) strcat(s, "k");
if (crc32("WCghMHM",7) == 1876812423) strcat(s, "o");
if (crc32("JSONXJ",6) == 4066196599) strcat(s, "f");
if (crc32("UULODJG",7) == 2064329641) strcat(s, "d");
    return s;
}

char *getdown_verbs() {
    char *s = calloc(8);
    if (crc32("CxkuRbA",7) == 903473092) strcat(s, "t");
if (crc32("TSZJCCzyeHRdieY",15) == 205648682) strcat(s, "g");
if (crc32("pRVBfbPymEhN",12) == 1251962244) strcat(s, "e");
if (crc32("yFUvCa",6) == 118683193) strcat(s, "t");
if (crc32("XcOjZt",6) == 3160029962) strcat(s, "k");
if (crc32("EOKlwVu",7) == 3065126222) strcat(s, "d");
if (crc32("LPFONK",6) == 1713146642) strcat(s, "Q");
if (crc32("oZKYfyDnsrWRrU",14) == 3184305676) strcat(s, "o");
if (crc32("cxOCJjCKkiJcflR",15) == 2088855890) strcat(s, "w");
if (crc32("UKMjzOHGiYESe",13) == 2307393776) strcat(s, "n");
    return s;
}

char *fatting_verbs() {
    char *s = calloc(8);
    if (crc32("FvICgyYwYL",10) == 2721938411) strcat(s, "f");
if (crc32("IJuQuMzmoMAahx",14) == 2492850067) strcat(s, "a");
if (crc32("WGKAWCReMLjQO",13) == 410827833) strcat(s, "G");
if (crc32("GAjMzbPVZKGtH",13) == 3406127825) strcat(s, "t");
if (crc32("mYlboaiydW",10) == 3695968896) strcat(s, "u");
if (crc32("appNHdqtNJ",10) == 1650053029) strcat(s, "t");
if (crc32("cKSqXqQxf",9) == 3691109618) strcat(s, "K");
if (crc32("iFzLaeXyM",9) == 4113331231) strcat(s, "i");
if (crc32("Ifznlzn",7) == 1352912884) strcat(s, "i");
if (crc32("tCtheOhLSkTlUIP",15) == 155817039) strcat(s, "n");
if (crc32("RrcQxZUBrTEtkW",14) == 3765915435) strcat(s, "g");
    return s;
}

char *laded_verbs() {
    char *s = calloc(6);
    if (crc32("uEEnG",5) == 4006119565) strcat(s, "b");
if (crc32("enHuCjJ",7) == 968460554) strcat(s, "l");
if (crc32("oNmxFVhCornjMs",14) == 90020863) strcat(s, "c");
if (crc32("ZqOmRuyImhLgGuY",15) == 1062945471) strcat(s, "a");
if (crc32("OrhkovTY",8) == 460621814) strcat(s, "d");
if (crc32("RLUPNZMoz",9) == 4011324268) strcat(s, "n");
if (crc32("UZqumgEx",8) == 1493800412) strcat(s, "e");
if (crc32("DNGckRHUsp",10) == 4041278033) strcat(s, "w");
if (crc32("uscDpDL",7) == 3688919680) strcat(s, "d");
    return s;
}

char *splining_verbs() {
    char *s = calloc(9);
    if (crc32("lfPQFhyipBwboa",14) == 3382331995) strcat(s, "s");
if (crc32("fnWmvAmomErP",12) == 2440304800) strcat(s, "L");
if (crc32("QbuiHZHqXSIWzsA",15) == 2644072082) strcat(s, "p");
if (crc32("aGeArmyOI",9) == 1055038392) strcat(s, "w");
if (crc32("nTAgeCloNfPWY",13) == 2530013254) strcat(s, "l");
if (crc32("VqdgvRW",7) == 1275442631) strcat(s, "u");
if (crc32("JmMtfQKDDFFjb",13) == 3818931247) strcat(s, "i");
if (crc32("eNtNHDtuGyLnm",13) == 2653500085) strcat(s, "Z");
if (crc32("NzAgRRaytEzUwLD",15) == 3844504088) strcat(s, "n");
if (crc32("tPsElfPTSjL",11) == 3536321990) strcat(s, "v");
if (crc32("NfeBUerQO",9) == 2474534530) strcat(s, "i");
if (crc32("TDzivYUdAwR",11) == 232384930) strcat(s, "U");
if (crc32("jslKSfVzPXwdU",13) == 2667309688) strcat(s, "n");
if (crc32("errmkHAXF",9) == 4258429358) strcat(s, "g");
    return s;
}

char *pressuring_verbs() {
    char *s = calloc(11);
    if (crc32("pWZgGJFwmkuEY",13) == 1534988715) strcat(s, "q");
if (crc32("xoOcIhJMXybmRxV",15) == 2333140213) strcat(s, "p");
if (crc32("Fblfs",5) == 143591981) strcat(s, "J");
if (crc32("NsetEXGo",8) == 2089709546) strcat(s, "r");
if (crc32("GRUUrvkFQflAg",13) == 3981049152) strcat(s, "V");
if (crc32("dBfHTOdSDDFSVOs",15) == 2794796875) strcat(s, "e");
if (crc32("aWnAtFo",7) == 2354709202) strcat(s, "s");
if (crc32("YLMYIPa",7) == 2653702106) strcat(s, "G");
if (crc32("AgylHiMYe",9) == 4081465033) strcat(s, "s");
if (crc32("lbDpwjSQckzjeVH",15) == 3258253276) strcat(s, "u");
if (crc32("iVuBCpfLa",9) == 655354283) strcat(s, "r");
if (crc32("jTFdqfrOZomeV",13) == 1570433105) strcat(s, "i");
if (crc32("IeWYnmmAlrQBUqW",15) == 2783178899) strcat(s, "I");
if (crc32("gdYtNnMKOQpvsS",14) == 3485529687) strcat(s, "n");
if (crc32("ceLqUFbMyysAFV",14) == 4050208452) strcat(s, "D");
if (crc32("iXFKiuf",7) == 1235654518) strcat(s, "g");
    return s;
}

char *foozling_verbs() {
    char *s = calloc(9);
    if (crc32("yZftcH",6) == 2486088533) strcat(s, "f");
if (crc32("BMjiDTZUAr",10) == 2729440751) strcat(s, "P");
if (crc32("iMuRZDJRJiZEbhX",15) == 2711006842) strcat(s, "o");
if (crc32("YoCwY",5) == 2423359498) strcat(s, "o");
if (crc32("TpOEQQGvr",9) == 1279840402) strcat(s, "z");
if (crc32("MGUnLdPJgs",10) == 2813570548) strcat(s, "x");
if (crc32("avWSqYXvycuegDP",15) == 2684551632) strcat(s, "l");
if (crc32("qBvuBDCfBOzpt",13) == 3830154475) strcat(s, "L");
if (crc32("WhAJtDwE",8) == 2715416300) strcat(s, "i");
if (crc32("jOvlzouBvEuvUR",14) == 1418613684) strcat(s, "y");
if (crc32("ANiZRbzUXECFcB",14) == 3187660455) strcat(s, "n");
if (crc32("vJJGldXDIvu",11) == 2034970985) strcat(s, "g");
    return s;
}

char *welch_verbs() {
    char *s = calloc(6);
    if (crc32("tLaTYBTjhQcwVm",14) == 1930109407) strcat(s, "w");
if (crc32("zqEfdV",6) == 1549528027) strcat(s, "W");
if (crc32("FHHRFjCcPEgQVGR",15) == 1294997151) strcat(s, "e");
if (crc32("MofGcUMNToNBLC",14) == 2775554606) strcat(s, "l");
if (crc32("ONrYG",5) == 182549359) strcat(s, "q");
if (crc32("nSlws",5) == 3509019534) strcat(s, "c");
if (crc32("uuJTwYvlTDJWRI",14) == 3887607399) strcat(s, "V");
if (crc32("hhHQDKnFs",9) == 2122998730) strcat(s, "h");
    return s;
}

char *throb_verbs() {
    char *s = calloc(6);
    if (crc32("vfcSM",5) == 2107051118) strcat(s, "t");
if (crc32("TnvyFa",6) == 2302490556) strcat(s, "h");
if (crc32("nmjOHhgpbzWL",12) == 180611832) strcat(s, "r");
if (crc32("UBdxFHVaZnIZDe",14) == 771503684) strcat(s, "o");
if (crc32("BfbbMijI",8) == 1264771780) strcat(s, "z");
if (crc32("lpsCVkHK",8) == 4020358890) strcat(s, "b");
    return s;
}

char *heathenizing_verbs() {
    char *s = calloc(13);
    if (crc32("fAmXm",5) == 4069972066) strcat(s, "h");
if (crc32("DrepBTNCtxWgX",13) == 3982322122) strcat(s, "G");
if (crc32("Izfvpz",6) == 4213792640) strcat(s, "e");
if (crc32("DEsxZXkZtg",10) == 479145345) strcat(s, "m");
if (crc32("JsTOz",5) == 24114435) strcat(s, "a");
if (crc32("SfpyldyIWPxJ",12) == 3907132182) strcat(s, "t");
if (crc32("tcZpOnJrITSpKt",14) == 2689891830) strcat(s, "j");
if (crc32("csaUTNKM",8) == 4028022047) strcat(s, "h");
if (crc32("EsirKnVtXhorSa",14) == 2939377542) strcat(s, "e");
if (crc32("DQLawqCbnXolgdA",15) == 516364786) strcat(s, "n");
if (crc32("aoGAFTUuwjg",11) == 2890255150) strcat(s, "L");
if (crc32("xOyzkRQi",8) == 592104334) strcat(s, "i");
if (crc32("pJfZMcAXsLujYte",15) == 261395625) strcat(s, "r");
if (crc32("qRVxI",5) == 3812860291) strcat(s, "z");
if (crc32("NDrBMpgwpvgKbdT",15) == 902577339) strcat(s, "p");
if (crc32("lJkmi",5) == 3472244191) strcat(s, "i");
if (crc32("YdkpSyMvXwX",11) == 1968766410) strcat(s, "n");
if (crc32("GKIFEUtFof",10) == 2881150504) strcat(s, "g");
    return s;
}

char *stuck_verbs() {
    char *s = calloc(6);
    if (crc32("KaelgnAtxcNzN",13) == 1571968853) strcat(s, "s");
if (crc32("gciTsffki",9) == 1465709198) strcat(s, "t");
if (crc32("CuLlz",5) == 1819728614) strcat(s, "X");
if (crc32("bCYGNDMxBsBd",12) == 384398634) strcat(s, "u");
if (crc32("YRyDvuOOATnOcA",14) == 1858974968) strcat(s, "l");
if (crc32("cLYVhHMXWihIzwM",15) == 3410176468) strcat(s, "c");
if (crc32("GgsDDZzPwvPcggc",15) == 1603376085) strcat(s, "p");
if (crc32("TatvcGOdQUiO",12) == 2936536241) strcat(s, "k");
    return s;
}

char *unsnap_verbs() {
    char *s = calloc(7);
    if (crc32("VBxtkOivHDU",11) == 97884683) strcat(s, "y");
if (crc32("PxgOAqCaiXFL",12) == 1310843232) strcat(s, "u");
if (crc32("ftzTwcUZAx",10) == 2422951103) strcat(s, "X");
if (crc32("fUaImxbXGDn",11) == 1518342216) strcat(s, "n");
if (crc32("kpBkHp",6) == 924434099) strcat(s, "s");
if (crc32("bqszuKTGpIu",11) == 1360035947) strcat(s, "F");
if (crc32("WHJainwTSuk",11) == 621637919) strcat(s, "n");
if (crc32("hoeWIMViDCHaLsN",15) == 1904584087) strcat(s, "Q");
if (crc32("AkLtqBurygLUCK",14) == 1876767288) strcat(s, "a");
if (crc32("MAegDWPzYU",10) == 696066787) strcat(s, "u");
if (crc32("CzfQgMcji",9) == 2964521132) strcat(s, "p");
    return s;
}

char *rode_verbs() {
    char *s = calloc(5);
    if (crc32("RTBIgdNMzsm",11) == 4178135747) strcat(s, "e");
if (crc32("mnnxBsQn",8) == 1612316266) strcat(s, "r");
if (crc32("TzhaSDSyFlNSTU",14) == 4136864641) strcat(s, "o");
if (crc32("DcrCxIaWliki",12) == 2949621979) strcat(s, "x");
if (crc32("DCGamdFB",8) == 3011157166) strcat(s, "d");
if (crc32("MEsNlVOBBdZsO",13) == 2943931491) strcat(s, "b");
if (crc32("nUPwjYhYKjYjX",13) == 3239671604) strcat(s, "e");
    return s;
}

char *refrying_verbs() {
    char *s = calloc(9);
    if (crc32("DHuHmXSADh",10) == 1095792135) strcat(s, "r");
if (crc32("LRjcYqhbrUpyHBA",15) == 1624477395) strcat(s, "b");
if (crc32("xNImKCbmSsZOuw",14) == 4155636438) strcat(s, "e");
if (crc32("XmTeIleK",8) == 2434304746) strcat(s, "f");
if (crc32("fqoSXt",6) == 2256043068) strcat(s, "N");
if (crc32("XwVWLrozuyXBXy",14) == 312258079) strcat(s, "r");
if (crc32("VIMPYCzBXihHUbR",15) == 2483797790) strcat(s, "p");
if (crc32("lPZfCQQ",7) == 2081075267) strcat(s, "y");
if (crc32("KvHsfaDpWuFFaCW",15) == 2136891198) strcat(s, "i");
if (crc32("gaHMlcPrepAlWg",14) == 2483718456) strcat(s, "X");
if (crc32("IzMVWNfQVmDip",13) == 3135363365) strcat(s, "n");
if (crc32("djuMfBi",7) == 2545548258) strcat(s, "r");
if (crc32("DQYZicwtzatD",12) == 1258774628) strcat(s, "g");
    return s;
}

char *materializing_verbs() {
    char *s = calloc(14);
    if (crc32("wpaIkc",6) == 4032092338) strcat(s, "m");
if (crc32("OodRxoKuFV",10) == 509903595) strcat(s, "h");
if (crc32("ksNZMUmtzns",11) == 1087253363) strcat(s, "a");
if (crc32("BLGoGKi",7) == 3988964930) strcat(s, "t");
if (crc32("XMSMIYrPmb",10) == 4099357577) strcat(s, "X");
if (crc32("ATBnjkY",7) == 3225122177) strcat(s, "e");
if (crc32("kLONWmGeVsxPB",13) == 880230501) strcat(s, "j");
if (crc32("FRrlcF",6) == 2072269547) strcat(s, "r");
if (crc32("qAKOcf",6) == 3388860406) strcat(s, "i");
if (crc32("wkMdxISqnBGQzyN",15) == 2434212252) strcat(s, "v");
if (crc32("saUEStcbjXBd",12) == 1658547898) strcat(s, "a");
if (crc32("zHNbj",5) == 2873646600) strcat(s, "l");
if (crc32("soWcfFopS",9) == 2153665570) strcat(s, "K");
if (crc32("VaNTtBwOgyD",11) == 309550356) strcat(s, "i");
if (crc32("ocZAXBpxWQfVMj",14) == 2542475237) strcat(s, "N");
if (crc32("TKUMsaQcxGT",11) == 4109626624) strcat(s, "z");
if (crc32("SYrlDLdvIFe",11) == 201239024) strcat(s, "B");
if (crc32("QzzsMNaG",8) == 660191507) strcat(s, "i");
if (crc32("bFvhS",5) == 2492801490) strcat(s, "n");
if (crc32("YtfkrAVNy",9) == 354389833) strcat(s, "g");
    return s;
}

char *outgrowing_verbs() {
    char *s = calloc(11);
    if (crc32("sqHzJDXoITLnbA",14) == 2297297689) strcat(s, "T");
if (crc32("ACpVOqyt",8) == 1985378498) strcat(s, "o");
if (crc32("VwIfPaViqwOZTSe",15) == 1412206284) strcat(s, "j");
if (crc32("qZfhpBYLmEv",11) == 3895750455) strcat(s, "u");
if (crc32("TbUcxXFiYgDqAG",14) == 1905917495) strcat(s, "t");
if (crc32("fnkTLwqyYqn",11) == 2883071707) strcat(s, "g");
if (crc32("lEwkFjo",7) == 523378811) strcat(s, "r");
if (crc32("tmZmUUEx",8) == 2608608548) strcat(s, "g");
if (crc32("qpUUvfjywaINOdq",15) == 457209606) strcat(s, "o");
if (crc32("OHxuuCwbOfPOjRT",15) == 2917911231) strcat(s, "w");
if (crc32("VMsWOOW",7) == 2356890123) strcat(s, "d");
if (crc32("FmGhdfl",7) == 585194146) strcat(s, "i");
if (crc32("RyHhYxvBEbCK",12) == 3605031975) strcat(s, "P");
if (crc32("sbQrQxbFNk",10) == 835234152) strcat(s, "n");
if (crc32("kNYiiASYnr",10) == 1028809374) strcat(s, "g");
    return s;
}

char *acupunctured_verbs() {
    char *s = calloc(13);
    if (crc32("INIbsZfym",9) == 2816930503) strcat(s, "a");
if (crc32("FITddg",6) == 50132863) strcat(s, "h");
if (crc32("bNlLgqEMubxTzkn",15) == 1398030794) strcat(s, "c");
if (crc32("mIePCCmMdYw",11) == 3482268880) strcat(s, "u");
if (crc32("jmrYIi",6) == 3464589051) strcat(s, "p");
if (crc32("ZOnUQRyqrL",10) == 1551727359) strcat(s, "u");
if (crc32("wRnhhY",6) == 2432496760) strcat(s, "y");
if (crc32("YAUMlGgdNTvL",12) == 3573261124) strcat(s, "n");
if (crc32("YwKXqAtLvELOv",13) == 2166238906) strcat(s, "c");
if (crc32("kxpeCJyRpqNzGZD",15) == 1750110153) strcat(s, "q");
if (crc32("OtzBSEMsqOIh",12) == 1819266107) strcat(s, "t");
if (crc32("CKwhcyQ",7) == 1836640554) strcat(s, "o");
if (crc32("ASkbMqvZw",9) == 2506972963) strcat(s, "u");
if (crc32("teyAoUGwu",9) == 3167521362) strcat(s, "r");
if (crc32("OXWnho",6) == 3557639084) strcat(s, "C");
if (crc32("oPGCpNdsYbwaE",13) == 558605479) strcat(s, "e");
if (crc32("DNaNHx",6) == 1562903390) strcat(s, "d");
    return s;
}

char *bodge_verbs() {
    char *s = calloc(6);
    if (crc32("EYEQHYRDWwlkZD",14) == 167367232) strcat(s, "c");
if (crc32("uvFNouDzGnVl",12) == 671132617) strcat(s, "b");
if (crc32("PQYfQEnW",8) == 2210705644) strcat(s, "o");
if (crc32("NAPucKOdx",9) == 3680121980) strcat(s, "d");
if (crc32("hGESL",5) == 4159200084) strcat(s, "O");
if (crc32("ZmsVODTsPzkx",12) == 164057545) strcat(s, "g");
if (crc32("DEgxIKI",7) == 2497900368) strcat(s, "e");
    return s;
}

char *distancing_verbs() {
    char *s = calloc(11);
    if (crc32("OsksQFg",7) == 1169111030) strcat(s, "k");
if (crc32("msmZddGypfJYtr",14) == 1034541759) strcat(s, "d");
if (crc32("JEPHDDq",7) == 523204525) strcat(s, "r");
if (crc32("EauHk",5) == 1699833636) strcat(s, "i");
if (crc32("aoSSxVNPEyFyaRD",15) == 4057220346) strcat(s, "s");
if (crc32("ZKQORZ",6) == 951109228) strcat(s, "t");
if (crc32("lPggWiEeDHr",11) == 3458981686) strcat(s, "a");
if (crc32("eOiYCcOlUUWPC",13) == 1953798714) strcat(s, "n");
if (crc32("PDJQkgxD",8) == 471361892) strcat(s, "c");
if (crc32("daiUxeLlu",9) == 3965160914) strcat(s, "i");
if (crc32("SzaMIWTGQYePmW",14) == 935641446) strcat(s, "n");
if (crc32("HxvlPuRit",9) == 780137275) strcat(s, "L");
if (crc32("VamDZJetGbQMXr",14) == 1592301474) strcat(s, "g");
    return s;
}

char *clack_verbs() {
    char *s = calloc(6);
    if (crc32("NqaMz",5) == 1316019889) strcat(s, "c");
if (crc32("VMlQoAblNhqJwta",15) == 422687265) strcat(s, "l");
if (crc32("zhVfWYhS",8) == 1186986609) strcat(s, "a");
if (crc32("jKHJeSqw",8) == 151695744) strcat(s, "c");
if (crc32("dAWmzpYL",8) == 2432765245) strcat(s, "c");
if (crc32("DMhoiXpjFOj",11) == 1963563200) strcat(s, "k");
    return s;
}

char *dogging_verbs() {
    char *s = calloc(8);
    if (crc32("ixkAZqhT",8) == 514884800) strcat(s, "Z");
if (crc32("tvkFIJGeF",9) == 576949613) strcat(s, "d");
if (crc32("IfcMxjqXKf",10) == 3882288577) strcat(s, "o");
if (crc32("emxqwBxbbHcZi",13) == 1165918030) strcat(s, "j");
if (crc32("adTqWdMT",8) == 1709335654) strcat(s, "g");
if (crc32("teGhPsbf",8) == 1091121658) strcat(s, "g");
if (crc32("GFyfEhd",7) == 3202636892) strcat(s, "i");
if (crc32("eTnpoydJqfJMEc",14) == 2215077271) strcat(s, "w");
if (crc32("CjuBQmYJWm",10) == 3287274157) strcat(s, "n");
if (crc32("MkvbGoWeFBbCz",13) == 2761556048) strcat(s, "g");
    return s;
}

char *finalized_verbs() {
    char *s = calloc(10);
    if (crc32("vNzFnoIOwFv",11) == 189279171) strcat(s, "O");
if (crc32("AwpaGwDmzS",10) == 2915400725) strcat(s, "f");
if (crc32("SfErIGFZXShPmoI",15) == 3804956630) strcat(s, "z");
if (crc32("KtaRoYMXy",9) == 1892505680) strcat(s, "i");
if (crc32("BEbhrkGMWiYiI",13) == 3622375773) strcat(s, "A");
if (crc32("CqXvxA",6) == 1145348425) strcat(s, "n");
if (crc32("RWmfZkTUkuRl",12) == 3186687018) strcat(s, "N");
if (crc32("pdAeUpjEIkUNH",13) == 2673112319) strcat(s, "a");
if (crc32("WSswqHKnQvC",11) == 2711229362) strcat(s, "l");
if (crc32("wTZTnRFJDJYc",12) == 2753515562) strcat(s, "d");
if (crc32("kpAlLrnx",8) == 3206157494) strcat(s, "i");
if (crc32("ddzPxIzhQLAp",12) == 1027513146) strcat(s, "z");
if (crc32("rCMYiO",6) == 2956211904) strcat(s, "e");
if (crc32("ChxLuWWnFi",10) == 3667922342) strcat(s, "d");
    return s;
}

char *glued_verbs() {
    char *s = calloc(6);
    if (crc32("DgYXIoxYG",9) == 105652050) strcat(s, "g");
if (crc32("fgQjeH",6) == 302094024) strcat(s, "l");
if (crc32("CpgBpmCd",8) == 2736898031) strcat(s, "u");
if (crc32("aAqQOH",6) == 2799834547) strcat(s, "e");
if (crc32("dihvhz",6) == 2421072159) strcat(s, "K");
if (crc32("QkEosZe",7) == 2727347336) strcat(s, "d");
    return s;
}

char *chitchatting_verbs() {
    char *s = calloc(13);
    if (crc32("UStRFjEz",8) == 2119723240) strcat(s, "c");
if (crc32("GgASkaqvtdUzWUI",15) == 182952181) strcat(s, "K");
if (crc32("beIwQ",5) == 712109085) strcat(s, "h");
if (crc32("YwjhRv",6) == 4080647110) strcat(s, "M");
if (crc32("bhbmoizu",8) == 3134678197) strcat(s, "i");
if (crc32("zkxvhVnAy",9) == 2229568201) strcat(s, "Q");
if (crc32("NnitCjCjIISFhz",14) == 2910278307) strcat(s, "t");
if (crc32("uGbnNxy",7) == 3927418763) strcat(s, "D");
if (crc32("xZrzVYdIrGwRB",13) == 2790651058) strcat(s, "c");
if (crc32("dtbRLrQFOUA",11) == 4199320062) strcat(s, "G");
if (crc32("hNgWurJy",8) == 3305227517) strcat(s, "h");
if (crc32("spqZRXNMGIIsujw",15) == 3864483232) strcat(s, "M");
if (crc32("KpXJeKEloLVsdi",14) == 3300124127) strcat(s, "a");
if (crc32("jOjaHnacPFaDtw",14) == 3542305171) strcat(s, "X");
if (crc32("gZqAjfgCCW",10) == 4028684599) strcat(s, "t");
if (crc32("kIUPMjBL",8) == 3430673291) strcat(s, "t");
if (crc32("bYZFqJcA",8) == 3044802715) strcat(s, "S");
if (crc32("MEzUZJidvZinR",13) == 670047628) strcat(s, "i");
if (crc32("zLNQzWXEhUVsv",13) == 2638977399) strcat(s, "n");
if (crc32("NTjbnkias",9) == 1929821980) strcat(s, "g");
    return s;
}

char *winterfeeding_verbs() {
    char *s = calloc(14);
    if (crc32("uXDwCQOJHZk",11) == 324817250) strcat(s, "w");
if (crc32("otYaIde",7) == 4241882081) strcat(s, "X");
if (crc32("VpwKPSttmtxtgUY",15) == 2007983951) strcat(s, "i");
if (crc32("zfmYUltb",8) == 1682762626) strcat(s, "n");
if (crc32("wBIbl",5) == 3494496621) strcat(s, "t");
if (crc32("VEhmlHYEU",9) == 2098143047) strcat(s, "e");
if (crc32("gcMeVsqdVN",10) == 1620154263) strcat(s, "V");
if (crc32("CuzGwvcdbiK",11) == 4070062185) strcat(s, "r");
if (crc32("rkuALsKII",9) == 2037690422) strcat(s, "f");
if (crc32("MKeYOnBXopaNOG",14) == 3989935020) strcat(s, "Y");
if (crc32("VioRRcNMzOGSS",13) == 2922066075) strcat(s, "e");
if (crc32("eNlWtVCQPg",10) == 2364021101) strcat(s, "O");
if (crc32("DJvBcMWz",8) == 3275606387) strcat(s, "e");
if (crc32("SpSrfRLIQCWcDX",14) == 360532854) strcat(s, "O");
if (crc32("dliMVHDmC",9) == 1825311507) strcat(s, "d");
if (crc32("FMddxQy",7) == 18656051) strcat(s, "i");
if (crc32("sNHOnbXMWU",10) == 3918745473) strcat(s, "n");
if (crc32("WYBAAri",7) == 2360104997) strcat(s, "i");
if (crc32("hciUhjMuZpUaW",13) == 1380779744) strcat(s, "g");
    return s;
}

char *hiring_verbs() {
    char *s = calloc(7);
    if (crc32("wiYSyTh",7) == 2977775706) strcat(s, "h");
if (crc32("JhWAsIUtD",9) == 2218160193) strcat(s, "i");
if (crc32("jhXbeozmjGBLrQ",14) == 2841803499) strcat(s, "V");
if (crc32("eykmqBPjYiHak",13) == 1600124646) strcat(s, "r");
if (crc32("NbocQevbdR",10) == 4207913552) strcat(s, "Y");
if (crc32("JiDIIcNRxjL",11) == 2760937425) strcat(s, "i");
if (crc32("VgwsafIHpDdyEc",14) == 168445882) strcat(s, "n");
if (crc32("bUuDc",5) == 2187514461) strcat(s, "B");
if (crc32("vqLqpbYQBN",10) == 2879924817) strcat(s, "g");
    return s;
}

char *abdicating_verbs() {
    char *s = calloc(11);
    if (crc32("DGGxZ",5) == 1948236097) strcat(s, "a");
if (crc32("sBvBHlBlKfL",11) == 354040154) strcat(s, "b");
if (crc32("SDtHPAqV",8) == 1648783388) strcat(s, "u");
if (crc32("ATWpcXUBLjay",12) == 1116497242) strcat(s, "d");
if (crc32("iSGyWbf",7) == 3568723852) strcat(s, "q");
if (crc32("FCHdIvN",7) == 2029424779) strcat(s, "i");
if (crc32("JpKajfxezVF",11) == 4154910914) strcat(s, "c");
if (crc32("TGvcoRAjyG",10) == 4063996131) strcat(s, "a");
if (crc32("HwPmmFMeuczMWgw",15) == 130391460) strcat(s, "j");
if (crc32("OMLcF",5) == 3708817408) strcat(s, "t");
if (crc32("zJBBq",5) == 2049616420) strcat(s, "R");
if (crc32("kUBlPPSt",8) == 3864202783) strcat(s, "i");
if (crc32("wAROa",5) == 2350124096) strcat(s, "n");
if (crc32("hjCMhmTjYFZm",12) == 2315629098) strcat(s, "A");
if (crc32("iNFUKNShQQa",11) == 1983377497) strcat(s, "g");
    return s;
}

char *textured_verbs() {
    char *s = calloc(9);
    if (crc32("HjCxfMPJEdXh",12) == 1052579052) strcat(s, "t");
if (crc32("BfWIuTPFqkbSJC",14) == 1135982126) strcat(s, "e");
if (crc32("iXvTRxd",7) == 3261472808) strcat(s, "w");
if (crc32("nCSgAWTAyGFBhB",14) == 3464679824) strcat(s, "x");
if (crc32("plDpvSDNtlnyGQJ",15) == 3260864596) strcat(s, "t");
if (crc32("vJFUujzEhm",10) == 2850494797) strcat(s, "u");
if (crc32("RhygrBm",7) == 435320343) strcat(s, "V");
if (crc32("jiASEqi",7) == 1432460690) strcat(s, "r");
if (crc32("XaAaILmj",8) == 1289619904) strcat(s, "e");
if (crc32("bNDsKTJJTzJs",12) == 2760103516) strcat(s, "d");
    return s;
}

char *wigwag_verbs() {
    char *s = calloc(7);
    if (crc32("UNRuOjLu",8) == 2254735814) strcat(s, "L");
if (crc32("ZaixPHU",7) == 2899666673) strcat(s, "w");
if (crc32("YdiBtnLIO",9) == 1494545733) strcat(s, "i");
if (crc32("ruMTxyrO",8) == 1167284840) strcat(s, "g");
if (crc32("CailDheEKddwxe",14) == 203393532) strcat(s, "C");
if (crc32("wJNcRpjVg",9) == 56191919) strcat(s, "w");
if (crc32("pZXoXNc",7) == 3656627450) strcat(s, "v");
if (crc32("QoBshLQoYXqG",12) == 442869270) strcat(s, "a");
if (crc32("lazRVAmoSg",10) == 2639310613) strcat(s, "g");
    return s;
}

char *incinerate_verbs() {
    char *s = calloc(11);
    if (crc32("LRzsAXjBZ",9) == 1805217059) strcat(s, "i");
if (crc32("hulfnaO",7) == 3835270096) strcat(s, "n");
if (crc32("KlBBvhCmA",9) == 3068898998) strcat(s, "s");
if (crc32("vFuqYJjQrjqSrLK",15) == 2914361210) strcat(s, "c");
if (crc32("JtMYqFvjGj",10) == 2548157950) strcat(s, "t");
if (crc32("NIDBjoBbuvH",11) == 1408245528) strcat(s, "i");
if (crc32("fNecyyDGE",9) == 2388723328) strcat(s, "n");
if (crc32("vxcdr",5) == 3945832907) strcat(s, "e");
if (crc32("BoevAbLCBjc",11) == 852585125) strcat(s, "r");
if (crc32("BrhbMBysnNAtm",13) == 3241391532) strcat(s, "a");
if (crc32("zFNSN",5) == 2628012281) strcat(s, "g");
if (crc32("TyLasNeUWDM",11) == 1023658032) strcat(s, "t");
if (crc32("yCWFvlCGTsVIFo",14) == 1191904155) strcat(s, "e");
    return s;
}

char *proselytize_verbs() {
    char *s = calloc(12);
    if (crc32("kCdEXdpkFTfjLz",14) == 1312639398) strcat(s, "f");
if (crc32("eXMFKjN",7) == 3365543972) strcat(s, "p");
if (crc32("mgXBeszav",9) == 3672485820) strcat(s, "v");
if (crc32("qxqqKthaHySZWi",14) == 1299924382) strcat(s, "r");
if (crc32("DiUjPMCT",8) == 2973507780) strcat(s, "E");
if (crc32("uXrLCHB",7) == 1134504042) strcat(s, "o");
if (crc32("YIvATzHJQzvpzZQ",15) == 2379022227) strcat(s, "D");
if (crc32("WkzBacGIbnmEI",13) == 3791847089) strcat(s, "s");
if (crc32("GfUHhwuQnvDdK",13) == 1268225163) strcat(s, "e");
if (crc32("SzaDk",5) == 3128135992) strcat(s, "l");
if (crc32("ckLXTjKPMbKON",13) == 3132861700) strcat(s, "z");
if (crc32("EMWbVGISI",9) == 865593265) strcat(s, "y");
if (crc32("atVQbRSEg",9) == 2643254443) strcat(s, "Q");
if (crc32("XAvFXIoqv",9) == 3199974093) strcat(s, "t");
if (crc32("yAgjNbXeySfFQwd",15) == 3594211203) strcat(s, "i");
if (crc32("ZPDEUXAtySKkAw",14) == 2933552783) strcat(s, "z");
if (crc32("DvaufgSyLXJS",12) == 3085051768) strcat(s, "e");
    return s;
}

char *queued_verbs() {
    char *s = calloc(7);
    if (crc32("PCRtxg",6) == 2765327213) strcat(s, "q");
if (crc32("MThmkDOTMrmKUH",14) == 1057268996) strcat(s, "o");
if (crc32("WwtcHT",6) == 298956641) strcat(s, "u");
if (crc32("umNeUbdNhAoKfm",14) == 4006746664) strcat(s, "M");
if (crc32("ZfyQavQiVdWrUnf",15) == 3185109187) strcat(s, "e");
if (crc32("XhxKFac",7) == 4129153858) strcat(s, "y");
if (crc32("HXhvBsqTvVERNf",14) == 1340842749) strcat(s, "u");
if (crc32("pSBAsojfp",9) == 4043395193) strcat(s, "D");
if (crc32("tffgAKotMaiVheW",15) == 807231485) strcat(s, "e");
if (crc32("nIgcVZYwCV",10) == 678886473) strcat(s, "d");
    return s;
}

char *discountenanced_verbs() {
    char *s = calloc(16);
    if (crc32("sZBGoSEHqiPfgV",14) == 1561827789) strcat(s, "t");
if (crc32("eDdYRdJ",7) == 4064057616) strcat(s, "d");
if (crc32("gXvxeNYLHeVaCRN",15) == 1408993826) strcat(s, "i");
if (crc32("vDJZe",5) == 2191967807) strcat(s, "T");
if (crc32("hATUMk",6) == 2170134619) strcat(s, "s");
if (crc32("rjwnGbmkNUkyo",13) == 3548635180) strcat(s, "c");
if (crc32("wcBHQYPf",8) == 1565281718) strcat(s, "o");
if (crc32("JdVAlOu",7) == 1825200395) strcat(s, "u");
if (crc32("hCtnM",5) == 1177192394) strcat(s, "n");
if (crc32("LGfVQWV",7) == 3692364812) strcat(s, "F");
if (crc32("ZLEbLGHnmtR",11) == 3748548820) strcat(s, "t");
if (crc32("DWPEnW",6) == 471152885) strcat(s, "e");
if (crc32("miXiePhuPNqD",12) == 1598829872) strcat(s, "x");
if (crc32("lejenmQddjsm",12) == 3846832591) strcat(s, "n");
if (crc32("tVHiV",5) == 1822955835) strcat(s, "a");
if (crc32("KjKwRDi",7) == 1686604447) strcat(s, "n");
if (crc32("uPYOrU",6) == 435537600) strcat(s, "c");
if (crc32("QVZeY",5) == 1176607948) strcat(s, "e");
if (crc32("bdBIBjSrylZBbO",14) == 3869917191) strcat(s, "d");
    return s;
}

char *misconjugate_verbs() {
    char *s = calloc(13);
    if (crc32("befsJZsgBs",10) == 1692554425) strcat(s, "a");
if (crc32("IaweEhIpXQVBj",13) == 1463660225) strcat(s, "m");
if (crc32("EnayEOL",7) == 2952501122) strcat(s, "g");
if (crc32("SjOpENsOfxtK",12) == 3522680912) strcat(s, "i");
if (crc32("FuxQEpC",7) == 3991987825) strcat(s, "s");
if (crc32("OImCdPEfSZQVCHk",15) == 343598878) strcat(s, "Z");
if (crc32("rkhMufYCH",9) == 1359175451) strcat(s, "c");
if (crc32("VzZmI",5) == 348539525) strcat(s, "c");
if (crc32("jVTxlO",6) == 2656595523) strcat(s, "o");
if (crc32("QGrfF",5) == 1056957784) strcat(s, "n");
if (crc32("fuVTOEKrhCVG",12) == 544151112) strcat(s, "j");
if (crc32("sUkwBEfnAFhcI",13) == 1552623972) strcat(s, "u");
if (crc32("lZsKgnONmW",10) == 69353282) strcat(s, "g");
if (crc32("sjFsiQTUzBviXX",14) == 3333325332) strcat(s, "D");
if (crc32("wXHoOO",6) == 590343124) strcat(s, "a");
if (crc32("ppOdpkHh",8) == 1262108142) strcat(s, "R");
if (crc32("LMejNwRLW",9) == 3406183538) strcat(s, "t");
if (crc32("fAlNhXFCBK",10) == 1724659727) strcat(s, "e");
    return s;
}

char *subscribing_verbs() {
    char *s = calloc(12);
    if (crc32("objzUcWqugSQL",13) == 2704344103) strcat(s, "f");
if (crc32("UZxDzatwo",9) == 2400654035) strcat(s, "s");
if (crc32("fCdtZxtybv",10) == 2710388829) strcat(s, "u");
if (crc32("KXzMZPJ",7) == 2525944243) strcat(s, "Z");
if (crc32("zYDRHVvvCxJ",11) == 816898715) strcat(s, "b");
if (crc32("beGujndLYgsDVOm",15) == 1853968493) strcat(s, "s");
if (crc32("DXpBURef",8) == 2176674994) strcat(s, "B");
if (crc32("mFIDvh",6) == 2040010111) strcat(s, "c");
if (crc32("QHzXPFq",7) == 2877550022) strcat(s, "r");
if (crc32("ZstrcFkhcXQS",12) == 1134486001) strcat(s, "i");
if (crc32("CRQZtPXowjxVidg",15) == 3454739476) strcat(s, "b");
if (crc32("INgLSrVRkgOt",12) == 3771768787) strcat(s, "i");
if (crc32("KIhJbPApCdByBP",14) == 1706199979) strcat(s, "A");
if (crc32("LEZRBNKcTmLHFu",14) == 1908917040) strcat(s, "n");
if (crc32("nyuwK",5) == 776409285) strcat(s, "f");
if (crc32("EdHvQOlLJb",10) == 1400751965) strcat(s, "g");
    return s;
}

char *recirculate_verbs() {
    char *s = calloc(12);
    if (crc32("PFcMcGI",7) == 2355625035) strcat(s, "q");
if (crc32("oUNgOoOsizB",11) == 3643070131) strcat(s, "r");
if (crc32("wwpSMEy",7) == 2799053415) strcat(s, "U");
if (crc32("UuxMOQqedSLkhe",14) == 2966684797) strcat(s, "e");
if (crc32("bvLMKGgnciJEK",13) == 1171774290) strcat(s, "c");
if (crc32("vngpjzq",7) == 3616915876) strcat(s, "c");
if (crc32("LxHLDWPH",8) == 94816359) strcat(s, "i");
if (crc32("WwYwLylk",8) == 1833234909) strcat(s, "N");
if (crc32("nFHiFkPNvDLnH",13) == 3419746445) strcat(s, "r");
if (crc32("EJrvsqCCj",9) == 96688610) strcat(s, "c");
if (crc32("dWPixUsiH",9) == 4188938924) strcat(s, "L");
if (crc32("BjCdRdON",8) == 209533845) strcat(s, "u");
if (crc32("HvUhT",5) == 1268810700) strcat(s, "l");
if (crc32("hHeCmJEKQIjSURC",15) == 611257868) strcat(s, "a");
if (crc32("QxGMzLaElExghK",14) == 2624530145) strcat(s, "K");
if (crc32("OfWyecfbnr",10) == 328323470) strcat(s, "t");
if (crc32("slgpzvTJCbM",11) == 2368436595) strcat(s, "s");
if (crc32("TUNTTSz",7) == 4293584282) strcat(s, "e");
    return s;
}

char *takeup_verbs() {
    char *s = calloc(7);
    if (crc32("iHyxsxV",7) == 2556325156) strcat(s, "K");
if (crc32("ZQEqvgSW",8) == 3625216225) strcat(s, "t");
if (crc32("QFoHbnX",7) == 1368442083) strcat(s, "a");
if (crc32("nNcmbiJqJbQUy",13) == 1378825972) strcat(s, "k");
if (crc32("CttJbJEPTbmM",12) == 1484222498) strcat(s, "y");
if (crc32("cuGXiybdMbMCxNJ",15) == 4229392886) strcat(s, "e");
if (crc32("oxMcrXi",7) == 2674530901) strcat(s, "u");
if (crc32("JmghDzV",7) == 22770912) strcat(s, "J");
if (crc32("omtvVtmjxeiEO",13) == 2798382591) strcat(s, "p");
    return s;
}

char *obligate_verbs() {
    char *s = calloc(9);
    if (crc32("YSnzYPQcHUPZfa",14) == 1938659683) strcat(s, "A");
if (crc32("HbYUTPaKvnpzk",13) == 3031552671) strcat(s, "o");
if (crc32("XWeZqQGHc",9) == 787392770) strcat(s, "l");
if (crc32("bkqgsAWtHi",10) == 663528919) strcat(s, "b");
if (crc32("OBWQnxgzje",10) == 3460709453) strcat(s, "n");
if (crc32("hdVFoiUmizpXxG",14) == 4027748976) strcat(s, "l");
if (crc32("iTlhTPKc",8) == 2255553036) strcat(s, "d");
if (crc32("WtBit",5) == 939913064) strcat(s, "i");
if (crc32("SivbNAwqedSwGf",14) == 3255608265) strcat(s, "g");
if (crc32("HTAtLQpJwk",10) == 1837947412) strcat(s, "a");
if (crc32("nfLupVKMqNzM",12) == 1643553950) strcat(s, "t");
if (crc32("HDwEN",5) == 4144202493) strcat(s, "e");
    return s;
}

char *nominated_verbs() {
    char *s = calloc(10);
    if (crc32("njIywqyHrkPJr",13) == 3809107838) strcat(s, "U");
if (crc32("okcKNAICVYbW",12) == 4065417695) strcat(s, "n");
if (crc32("tYUSRB",6) == 3492652773) strcat(s, "q");
if (crc32("bMuyIsdgfRbGqI",14) == 2411607030) strcat(s, "o");
if (crc32("YmJKVtJMjofo",12) == 3899451239) strcat(s, "m");
if (crc32("RuNWgVgVIXwZGN",14) == 153165387) strcat(s, "i");
if (crc32("KzggGvVBPB",10) == 2948357408) strcat(s, "n");
if (crc32("catgSSeobPu",11) == 2428650578) strcat(s, "a");
if (crc32("UHzPS",5) == 2043574248) strcat(s, "t");
if (crc32("GKDTrtr",7) == 846076038) strcat(s, "e");
if (crc32("KsJrqcMrmzgfw",13) == 3477856738) strcat(s, "d");
    return s;
}

char *litigating_verbs() {
    char *s = calloc(11);
    if (crc32("rmlvtg",6) == 3073134718) strcat(s, "g");
if (crc32("VrOMXs",6) == 3898366148) strcat(s, "l");
if (crc32("NbLiWHokrfSO",12) == 463989416) strcat(s, "i");
if (crc32("GMyfGRlqvcLq",12) == 1414161450) strcat(s, "t");
if (crc32("yUQySxjAw",9) == 2465426105) strcat(s, "w");
if (crc32("ZLfVJrVByax",11) == 2431061274) strcat(s, "i");
if (crc32("EurvMBjcPFvt",12) == 2860716172) strcat(s, "g");
if (crc32("pTjdDh",6) == 955239103) strcat(s, "D");
if (crc32("paUMktIIYJEaQYe",15) == 2186815504) strcat(s, "a");
if (crc32("xcHVPs",6) == 891802138) strcat(s, "z");
if (crc32("oBWnnHj",7) == 608596127) strcat(s, "t");
if (crc32("zXhnCEstqeT",11) == 3906626611) strcat(s, "U");
if (crc32("anHwo",5) == 2054383184) strcat(s, "i");
if (crc32("smfBXPvSFWTSWH",14) == 1161169483) strcat(s, "F");
if (crc32("yJxLvZ",6) == 2860263183) strcat(s, "n");
if (crc32("TWjuaWBJHR",10) == 2106935217) strcat(s, "C");
if (crc32("jctcZdfujnLooYF",15) == 4198030915) strcat(s, "g");
    return s;
}

char *reapproach_verbs() {
    char *s = calloc(11);
    if (crc32("tnYbivOXHIN",11) == 2138357545) strcat(s, "r");
if (crc32("JssrOKxkKrfB",12) == 1479069335) strcat(s, "X");
if (crc32("RMwPKenm",8) == 3015524578) strcat(s, "e");
if (crc32("hlNjyiXraWBSzRl",15) == 1126194064) strcat(s, "u");
if (crc32("HNiVAkDi",8) == 3566675080) strcat(s, "a");
if (crc32("ijaeDZGwRJRn",12) == 433534396) strcat(s, "p");
if (crc32("vgCvUT",6) == 3928178137) strcat(s, "n");
if (crc32("jujyTDGHu",9) == 2095100504) strcat(s, "p");
if (crc32("ZHAjxIENPqNBGM",14) == 1664291190) strcat(s, "F");
if (crc32("ONkIBSGvK",9) == 1827028308) strcat(s, "r");
if (crc32("XBnMfGjPIturYC",14) == 3547540623) strcat(s, "r");
if (crc32("IXAVAtckZfEF",12) == 60500319) strcat(s, "o");
if (crc32("IGSzqog",7) == 1091805463) strcat(s, "a");
if (crc32("kXdGovXSL",9) == 3896149031) strcat(s, "O");
if (crc32("URTPE",5) == 2154634920) strcat(s, "c");
if (crc32("JIVameeYPieaxX",14) == 1540601014) strcat(s, "V");
if (crc32("cFlhC",5) == 2784181920) strcat(s, "h");
    return s;
}

char *was_verbs() {
    char *s = calloc(4);
    if (crc32("RDYxfbV",7) == 2836371746) strcat(s, "c");
if (crc32("saOQDpBOiVM",11) == 1399717223) strcat(s, "w");
if (crc32("emQBOQZmnwhyh",13) == 167305959) strcat(s, "a");
if (crc32("TPTWgJjZsSosEOT",15) == 3505750436) strcat(s, "s");
    return s;
}

char *blaming_verbs() {
    char *s = calloc(8);
    if (crc32("tYnTPEqxOnDv",12) == 1746157930) strcat(s, "d");
if (crc32("ymBkmCndju",10) == 647013911) strcat(s, "b");
if (crc32("ituYKTYFpOX",11) == 1395552673) strcat(s, "l");
if (crc32("dmgWTPIo",8) == 468585633) strcat(s, "a");
if (crc32("GkyQVuJH",8) == 676864536) strcat(s, "a");
if (crc32("zxBmOfVFczwiDda",15) == 1018624240) strcat(s, "o");
if (crc32("ObgvRUFfJ",9) == 2302612975) strcat(s, "m");
if (crc32("pJKYSdlxswWHr",13) == 3076371629) strcat(s, "j");
if (crc32("HuWzsKShIwX",11) == 2138340395) strcat(s, "i");
if (crc32("eKVwZkrjxI",10) == 2576949929) strcat(s, "U");
if (crc32("cfHUmAoRPvyX",12) == 990874939) strcat(s, "n");
if (crc32("lMCqmFSD",8) == 955537971) strcat(s, "n");
if (crc32("cLmUxIHUeMkEaRa",15) == 2404664656) strcat(s, "g");
    return s;
}

char *kindled_verbs() {
    char *s = calloc(8);
    if (crc32("PZWirszMqNFxsdD",15) == 565424775) strcat(s, "k");
if (crc32("rRwcu",5) == 2687603632) strcat(s, "e");
if (crc32("XNwRXLuX",8) == 3823148912) strcat(s, "i");
if (crc32("QOaAIWRChHqR",12) == 3550001998) strcat(s, "n");
if (crc32("ZuUYmA",6) == 1674800078) strcat(s, "d");
if (crc32("xoRZYXdaO",9) == 1393032087) strcat(s, "l");
if (crc32("WDiORkCX",8) == 3837772606) strcat(s, "e");
if (crc32("ljlYkwMcZ",9) == 2522313170) strcat(s, "c");
if (crc32("JdMVOfXE",8) == 1575671769) strcat(s, "d");
    return s;
}

char *discolor_verbs() {
    char *s = calloc(9);
    if (crc32("uUHgptAPGdb",11) == 888398207) strcat(s, "X");
if (crc32("JtWOQk",6) == 1200613253) strcat(s, "d");
if (crc32("qOQchCq",7) == 3205481786) strcat(s, "i");
if (crc32("otmCBAEXu",9) == 195279331) strcat(s, "s");
if (crc32("NauiOvEMIXQwiMW",15) == 3445616688) strcat(s, "G");
if (crc32("xUEMtyB",7) == 3524439328) strcat(s, "c");
if (crc32("QiaYVM",6) == 1074935397) strcat(s, "y");
if (crc32("bjffJXXcMap",11) == 3924824765) strcat(s, "o");
if (crc32("SHQkAO",6) == 3220211709) strcat(s, "U");
if (crc32("sqRipfxezBZik",13) == 1444352448) strcat(s, "l");
if (crc32("IqxyQyZjZlERFKQ",15) == 577215857) strcat(s, "o");
if (crc32("pdwtbjQzIOeOeZ",14) == 813887218) strcat(s, "r");
    return s;
}

char *rechoosing_verbs() {
    char *s = calloc(11);
    if (crc32("ggNqfTfhvgSI",12) == 317735363) strcat(s, "r");
if (crc32("SYLEtbNnCsBLq",13) == 3215373813) strcat(s, "W");
if (crc32("KlRVsjxOLhiwn",13) == 2883553050) strcat(s, "e");
if (crc32("xNBEmf",6) == 2193540669) strcat(s, "c");
if (crc32("kWgeMYoGtC",10) == 3956086126) strcat(s, "h");
if (crc32("WunZFDMGeLPU",12) == 1181808679) strcat(s, "o");
if (crc32("ZBRPOKKDgVm",11) == 480778872) strcat(s, "o");
if (crc32("GymeeasW",8) == 255785107) strcat(s, "N");
if (crc32("zBqpfWPRAWD",11) == 4079274655) strcat(s, "s");
if (crc32("PqYPD",5) == 2245341901) strcat(s, "i");
if (crc32("HKIwmNDdWO",10) == 1794213335) strcat(s, "H");
if (crc32("AuaTl",5) == 748077694) strcat(s, "n");
if (crc32("RUdFUZ",6) == 228646522) strcat(s, "Y");
if (crc32("EMlumGKktAqQMR",14) == 2767082972) strcat(s, "g");
    return s;
}

char *cellulated_verbs() {
    char *s = calloc(11);
    if (crc32("mvGWoFh",7) == 2281961195) strcat(s, "h");
if (crc32("mKVBobtSYAp",11) == 3410953649) strcat(s, "c");
if (crc32("owkbw",5) == 53135209) strcat(s, "z");
if (crc32("OimTZpaEbNh",11) == 2639933909) strcat(s, "e");
if (crc32("UYjaWmnZHsPQfPX",15) == 1173406127) strcat(s, "B");
if (crc32("fXWCVAVoBUpP",12) == 1840138752) strcat(s, "l");
if (crc32("qSxOu",5) == 4087903801) strcat(s, "W");
if (crc32("GzlvQ",5) == 213368554) strcat(s, "l");
if (crc32("VBSBGBqXn",9) == 2327919620) strcat(s, "u");
if (crc32("XEklZxcnvshuwA",14) == 2238534677) strcat(s, "f");
if (crc32("bslGxCyHgu",10) == 1662081952) strcat(s, "l");
if (crc32("hvHwrWAw",8) == 680673147) strcat(s, "C");
if (crc32("qAKjyPTA",8) == 4097740057) strcat(s, "a");
if (crc32("RosZMQXTnO",10) == 3964060023) strcat(s, "p");
if (crc32("UsvOAofEgOO",11) == 1902686145) strcat(s, "t");
if (crc32("HbycHNyU",8) == 2962537909) strcat(s, "e");
if (crc32("YqJVNqxtqFw",11) == 3013805582) strcat(s, "U");
if (crc32("ijGsSlYLKn",10) == 1496794044) strcat(s, "d");
    return s;
}

char *roquet_verbs() {
    char *s = calloc(7);
    if (crc32("KLNjteTjtCjJHO",14) == 3542480833) strcat(s, "T");
if (crc32("WqEoxTx",7) == 2464005881) strcat(s, "r");
if (crc32("lkSZJuwU",8) == 188175888) strcat(s, "k");
if (crc32("aUdfxm",6) == 2925659194) strcat(s, "o");
if (crc32("ptBTTSeldxP",11) == 1853358772) strcat(s, "D");
if (crc32("hTbDMIYz",8) == 2489692555) strcat(s, "q");
if (crc32("HQPFr",5) == 783123443) strcat(s, "m");
if (crc32("BHgwt",5) == 3225357143) strcat(s, "u");
if (crc32("JDneFGlqJRTwKT",14) == 1655071200) strcat(s, "p");
if (crc32("gnMGwnQNr",9) == 24112852) strcat(s, "e");
if (crc32("bjZhJSJ",7) == 4011473116) strcat(s, "f");
if (crc32("frigpKRRqYAF",12) == 553576961) strcat(s, "t");
    return s;
}

char *disengaged_verbs() {
    char *s = calloc(11);
    if (crc32("mkCzIBTA",8) == 3621606911) strcat(s, "d");
if (crc32("dphFQDIP",8) == 2685233598) strcat(s, "i");
if (crc32("noEUFEkGqjm",11) == 4238236508) strcat(s, "s");
if (crc32("ylrcU",5) == 1102322745) strcat(s, "s");
if (crc32("GwXOueXVG",9) == 643734142) strcat(s, "N");
if (crc32("tQHnYElHgBXFB",13) == 662868850) strcat(s, "e");
if (crc32("HWGiolmlnFPa",12) == 302812022) strcat(s, "n");
if (crc32("IxlUr",5) == 2875573160) strcat(s, "P");
if (crc32("IopmKhurAHqd",12) == 2078226345) strcat(s, "g");
if (crc32("UxotqnIOGDmsliE",15) == 825456022) strcat(s, "a");
if (crc32("QprrLDdhzkoD",12) == 692411865) strcat(s, "g");
if (crc32("sDUoVpoD",8) == 1402745577) strcat(s, "r");
if (crc32("VFvHmGvujtG",11) == 621659756) strcat(s, "e");
if (crc32("drWAUc",6) == 2504005215) strcat(s, "d");
    return s;
}

char *escaping_verbs() {
    char *s = calloc(9);
    if (crc32("xMEkdeoRhFh",11) == 2744008244) strcat(s, "e");
if (crc32("XSWxcfz",7) == 380905460) strcat(s, "e");
if (crc32("rdwKPzaHgGK",11) == 2512452403) strcat(s, "s");
if (crc32("zgUeRZf",7) == 3073614622) strcat(s, "c");
if (crc32("mwwcPICVWl",10) == 3733302656) strcat(s, "a");
if (crc32("nPZSizmfSJcjDh",14) == 1617328338) strcat(s, "a");
if (crc32("EgFYSc",6) == 818463617) strcat(s, "I");
if (crc32("oqjCX",5) == 4117191566) strcat(s, "p");
if (crc32("FmVXRuV",7) == 139402547) strcat(s, "i");
if (crc32("CcwfrngiRMBreTS",15) == 3840381166) strcat(s, "n");
if (crc32("jVkoWL",6) == 1864978025) strcat(s, "k");
if (crc32("RvxxWeKXKzpWChw",15) == 3485166135) strcat(s, "g");
    return s;
}

char *preadjourn_verbs() {
    char *s = calloc(11);
    if (crc32("qyloZkm",7) == 284696862) strcat(s, "p");
if (crc32("MnecxnmxnVS",11) == 2407490859) strcat(s, "r");
if (crc32("seHZeftsMdTY",12) == 3731669562) strcat(s, "w");
if (crc32("MFuUUTc",7) == 3427530352) strcat(s, "e");
if (crc32("IUvOUR",6) == 509417160) strcat(s, "a");
if (crc32("Bhorwy",6) == 663178122) strcat(s, "d");
if (crc32("jXMjXTvpv",9) == 3131868201) strcat(s, "g");
if (crc32("ebDxns",6) == 1995410250) strcat(s, "j");
if (crc32("fbEEzp",6) == 1288237769) strcat(s, "a");
if (crc32("FTNSvkA",7) == 3296543792) strcat(s, "o");
if (crc32("ZsCkkOFruYhXQB",14) == 1702439354) strcat(s, "L");
if (crc32("upAOftXlWfiVz",13) == 330609677) strcat(s, "u");
if (crc32("SZgoisbdXcjoKy",14) == 1006796062) strcat(s, "r");
if (crc32("LAmTrQCixsLEEPh",15) == 3756571309) strcat(s, "U");
if (crc32("DrEpYrOH",8) == 4224962322) strcat(s, "n");
    return s;
}

char *keynoting_verbs() {
    char *s = calloc(10);
    if (crc32("caycGwZfpIrq",12) == 56596601) strcat(s, "Z");
if (crc32("sJojP",5) == 990612383) strcat(s, "k");
if (crc32("kFbcvRCDgk",10) == 3778875140) strcat(s, "Z");
if (crc32("WrfFErjhI",9) == 2573850385) strcat(s, "e");
if (crc32("UBnEPg",6) == 1829057557) strcat(s, "g");
if (crc32("mSkLwOzZXowN",12) == 1295078170) strcat(s, "y");
if (crc32("cwTeXzAwQ",9) == 347222940) strcat(s, "b");
if (crc32("vcsRByVChYpIk",13) == 2857854137) strcat(s, "n");
if (crc32("tzZPpWWL",8) == 410678717) strcat(s, "o");
if (crc32("UXMhpPcMvO",10) == 2093069923) strcat(s, "R");
if (crc32("lMPEZ",5) == 2576531627) strcat(s, "t");
if (crc32("aSibqxjeiDx",11) == 615786911) strcat(s, "p");
if (crc32("RawhO",5) == 496122027) strcat(s, "i");
if (crc32("olQpFGgJLSfHh",13) == 3503900022) strcat(s, "G");
if (crc32("dXVDjRJNL",9) == 1804760929) strcat(s, "n");
if (crc32("GOLyvqqTDM",10) == 1863345915) strcat(s, "S");
if (crc32("oHzAPMrDJQK",11) == 2645061541) strcat(s, "g");
    return s;
}

char *pencilling_verbs() {
    char *s = calloc(11);
    if (crc32("COiHSjYxWwOi",12) == 1694363033) strcat(s, "l");
if (crc32("zMYJvaKel",9) == 4242233870) strcat(s, "p");
if (crc32("amvEZNCpc",9) == 1691272566) strcat(s, "a");
if (crc32("Vncpazen",8) == 841753078) strcat(s, "e");
if (crc32("afpJLVWP",8) == 2353254369) strcat(s, "V");
if (crc32("giYUPlNGKmVtq",13) == 2226211614) strcat(s, "n");
if (crc32("mqnUDDGAO",9) == 2830554112) strcat(s, "s");
if (crc32("OftdthJeuRiX",12) == 4067076184) strcat(s, "c");
if (crc32("RsTzY",5) == 1861841991) strcat(s, "F");
if (crc32("HZGpfXgifKRnfq",14) == 1027789697) strcat(s, "i");
if (crc32("eKsgJbBrM",9) == 2842557245) strcat(s, "l");
if (crc32("cgjEYsxMnF",10) == 1821280403) strcat(s, "Q");
if (crc32("zEXDy",5) == 115973101) strcat(s, "l");
if (crc32("znXfFWvxY",9) == 259109709) strcat(s, "F");
if (crc32("bfomIu",6) == 3222422470) strcat(s, "i");
if (crc32("MetKlPTG",8) == 1355477924) strcat(s, "Z");
if (crc32("ZMzdW",5) == 1879517157) strcat(s, "n");
if (crc32("zBepSoeHiXI",11) == 2305303024) strcat(s, "g");
    return s;
}

char *noosed_verbs() {
    char *s = calloc(7);
    if (crc32("hZaEBQScffoClS",14) == 905941555) strcat(s, "n");
if (crc32("iqCEMjF",7) == 2286615457) strcat(s, "o");
if (crc32("BXYceyiaAuMq",12) == 1007295947) strcat(s, "o");
if (crc32("zHmgQjAZCcm",11) == 1870951814) strcat(s, "s");
if (crc32("YOaBR",5) == 3919847474) strcat(s, "A");
if (crc32("xDvtLlgNlZE",11) == 3103778383) strcat(s, "e");
if (crc32("nZvrt",5) == 1586326340) strcat(s, "d");
    return s;
}

char *reannotating_verbs() {
    char *s = calloc(13);
    if (crc32("JKCIqRi",7) == 135782021) strcat(s, "r");
if (crc32("woYqkZVuK",9) == 3370171046) strcat(s, "l");
if (crc32("WtQwCv",6) == 3961913662) strcat(s, "e");
if (crc32("UaMGpGcTttqKw",13) == 1475788796) strcat(s, "a");
if (crc32("pCTahbOAtGM",11) == 856987539) strcat(s, "n");
if (crc32("cuZcmr",6) == 2397645997) strcat(s, "n");
if (crc32("xSQpbRnA",8) == 2720669111) strcat(s, "r");
if (crc32("esyvKOZw",8) == 3287332582) strcat(s, "o");
if (crc32("FdparcLjKDbBXST",15) == 3651588488) strcat(s, "t");
if (crc32("zIKicEsQUKw",11) == 2048765429) strcat(s, "b");
if (crc32("mMCqIpoc",8) == 3260938090) strcat(s, "a");
if (crc32("qtbzCAuva",9) == 729556816) strcat(s, "Z");
if (crc32("opwrbW",6) == 3001750922) strcat(s, "t");
if (crc32("bYQpkbWWqhC",11) == 2522813038) strcat(s, "s");
if (crc32("aQNJX",5) == 81993636) strcat(s, "i");
if (crc32("gkopFvUtKaxa",12) == 2701220188) strcat(s, "D");
if (crc32("EBDGYxEWpJGGEt",14) == 1006775082) strcat(s, "n");
if (crc32("MIQEVYNjVxkzpKG",15) == 313822488) strcat(s, "g");
    return s;
}

char *tided_verbs() {
    char *s = calloc(6);
    if (crc32("ToVTdFFjQq",10) == 2939663321) strcat(s, "t");
if (crc32("huvPHG",6) == 3585232983) strcat(s, "P");
if (crc32("lhhWaUcNaPnpYb",14) == 2893964183) strcat(s, "i");
if (crc32("DWRgBlSKHq",10) == 2675773986) strcat(s, "d");
if (crc32("ssDFQtqP",8) == 2751584055) strcat(s, "e");
if (crc32("ckqVSOlHf",9) == 4292274947) strcat(s, "d");
    return s;
}

char *cyaniding_verbs() {
    char *s = calloc(10);
    if (crc32("PSttddeTI",9) == 3463854186) strcat(s, "u");
if (crc32("SKhaiMTnRNUc",12) == 526635951) strcat(s, "c");
if (crc32("KOFLCttUVOpBYu",14) == 2495455635) strcat(s, "y");
if (crc32("ztnKyFYmB",9) == 1960422062) strcat(s, "a");
if (crc32("Duduena",7) == 3376647529) strcat(s, "n");
if (crc32("pzLSKeu",7) == 1453438741) strcat(s, "V");
if (crc32("hofCxPV",7) == 555058480) strcat(s, "i");
if (crc32("EqFzWGmHLwO",11) == 3855732566) strcat(s, "A");
if (crc32("hRxBcdlXjpqd",12) == 1257914581) strcat(s, "d");
if (crc32("HFWYL",5) == 1832792295) strcat(s, "i");
if (crc32("uQBvFFiqEv",10) == 3250299651) strcat(s, "E");
if (crc32("ljjzhFLrKhsE",12) == 2425793747) strcat(s, "n");
if (crc32("xtbBLmteNztUR",13) == 1714018442) strcat(s, "h");
if (crc32("EaEuTU",6) == 1898142494) strcat(s, "g");
    return s;
}

char *het_verbs() {
    char *s = calloc(4);
    if (crc32("ByYROzae",8) == 104080254) strcat(s, "W");
if (crc32("EpYWpgJuzpYiUKH",15) == 1371767929) strcat(s, "h");
if (crc32("KWkpMZXBF",9) == 1546822497) strcat(s, "e");
if (crc32("UFWCLWyUWY",10) == 1385902734) strcat(s, "t");
    return s;
}

char *satiated_verbs() {
    char *s = calloc(9);
    if (crc32("YFcAmKwuZh",10) == 4194982897) strcat(s, "m");
if (crc32("UpRxVksSPSf",11) == 2872138698) strcat(s, "s");
if (crc32("aiiLdW",6) == 762891961) strcat(s, "a");
if (crc32("JJHXaoRNNDP",11) == 1567628486) strcat(s, "t");
if (crc32("rbnPdsLx",8) == 272746230) strcat(s, "F");
if (crc32("xiJYRcR",7) == 1843129602) strcat(s, "i");
if (crc32("BztHNGMpev",10) == 5512906) strcat(s, "a");
if (crc32("jhqNSUEzIdp",11) == 2493078838) strcat(s, "J");
if (crc32("XlgOkcowDoVaJm",14) == 897211094) strcat(s, "t");
if (crc32("HAZVVXo",7) == 1964458794) strcat(s, "e");
if (crc32("EGUAKzgVXaXo",12) == 3426494771) strcat(s, "d");
    return s;
}

char *scintillated_verbs() {
    char *s = calloc(13);
    if (crc32("VvwswwLCWjAcbF",14) == 3775585888) strcat(s, "T");
if (crc32("GNnokjXePybD",12) == 1392237951) strcat(s, "s");
if (crc32("ebqqgtPe",8) == 2544303316) strcat(s, "c");
if (crc32("nandrI",6) == 3303717441) strcat(s, "e");
if (crc32("Yqbwb",5) == 2821942613) strcat(s, "i");
if (crc32("aVyoVyTCfhnwQfh",15) == 1192767678) strcat(s, "n");
if (crc32("VUwVCgfEIoxgnVd",15) == 1560828672) strcat(s, "f");
if (crc32("HJgyby",6) == 3276354962) strcat(s, "t");
if (crc32("LVQdB",5) == 1098569907) strcat(s, "i");
if (crc32("UNKMjAoevqjda",13) == 1926619323) strcat(s, "h");
if (crc32("fiqzHiDSQ",9) == 850805696) strcat(s, "l");
if (crc32("wdEKdRlhxp",10) == 16479860) strcat(s, "Y");
if (crc32("bxIPwOa",7) == 3828368469) strcat(s, "l");
if (crc32("YEIhWyVTl",9) == 500788625) strcat(s, "Y");
if (crc32("zitgEbDP",8) == 3856323385) strcat(s, "a");
if (crc32("rdqCyfJGMwo",11) == 2485849694) strcat(s, "U");
if (crc32("zzyPsXhOda",10) == 3422766713) strcat(s, "t");
if (crc32("eBzaWR",6) == 2230112268) strcat(s, "B");
if (crc32("LJrOlEF",7) == 2736619292) strcat(s, "e");
if (crc32("aItXdiZQnU",10) == 2975357122) strcat(s, "Z");
if (crc32("LAUJdlJ",7) == 3456503425) strcat(s, "d");
    return s;
}

char *compartmentalize_verbs() {
    char *s = calloc(17);
    if (crc32("gaYWBtGp",8) == 3198649274) strcat(s, "c");
if (crc32("HHNnDxExg",9) == 510145075) strcat(s, "o");
if (crc32("lGESeitGV",9) == 2585469014) strcat(s, "m");
if (crc32("seTsnzsgcNPuK",13) == 1335635126) strcat(s, "A");
if (crc32("WGvoubDFPJFOY",13) == 2504608676) strcat(s, "p");
if (crc32("oOccndUSsAWf",12) == 4211919734) strcat(s, "a");
if (crc32("PBhlGVb",7) == 504596602) strcat(s, "r");
if (crc32("gPpTvCXQ",8) == 149848401) strcat(s, "t");
if (crc32("OrMGBkAzADLY",12) == 798597396) strcat(s, "H");
if (crc32("IDmisYlRmVuj",12) == 2473756904) strcat(s, "m");
if (crc32("XxBtvziXZQ",10) == 2997194315) strcat(s, "u");
if (crc32("gZHVrinrFic",11) == 3992342621) strcat(s, "e");
if (crc32("pQhzGjakRZ",10) == 2210754308) strcat(s, "B");
if (crc32("rwEgdz",6) == 3972625053) strcat(s, "n");
if (crc32("ynMBmkMUyfX",11) == 2880982036) strcat(s, "j");
if (crc32("BMJfrHKJyrImPk",14) == 2205547892) strcat(s, "t");
if (crc32("tBiYyI",6) == 3623646048) strcat(s, "a");
if (crc32("lRgPXnd",7) == 3967485178) strcat(s, "y");
if (crc32("frKIlDhyLouujlq",15) == 1853094449) strcat(s, "l");
if (crc32("MNDArcAfYEAQ",12) == 3164109202) strcat(s, "i");
if (crc32("oUiBsPhmbzGcuWe",15) == 3712702941) strcat(s, "n");
if (crc32("PjQUxlFAgAE",11) == 1542817220) strcat(s, "z");
if (crc32("phSVycAh",8) == 3134128392) strcat(s, "e");
    return s;
}

char *unsling_verbs() {
    char *s = calloc(8);
    if (crc32("nYdZmdw",7) == 714710525) strcat(s, "u");
if (crc32("KlZrIof",7) == 917495969) strcat(s, "b");
if (crc32("EnMufjPN",8) == 770737599) strcat(s, "n");
if (crc32("HtFLNabNaokIhCk",15) == 1721208229) strcat(s, "s");
if (crc32("WkkrZdSfVGU",11) == 1582504508) strcat(s, "v");
if (crc32("pnuUcArBlJ",10) == 312827821) strcat(s, "l");
if (crc32("WyeZcFTFygZkmD",14) == 2751210751) strcat(s, "i");
if (crc32("EAbGKlEV",8) == 1796678209) strcat(s, "j");
if (crc32("PxPvN",5) == 3557240050) strcat(s, "n");
if (crc32("iPVgufZW",8) == 3715521356) strcat(s, "g");
    return s;
}

char *advancing_verbs() {
    char *s = calloc(10);
    if (crc32("VvjDAW",6) == 3416340737) strcat(s, "E");
if (crc32("IpVFBVugl",9) == 1371219041) strcat(s, "a");
if (crc32("FdnQPilAqLbmbKI",15) == 1454385969) strcat(s, "v");
if (crc32("WyVsTWeHmJipgYd",15) == 3563789872) strcat(s, "d");
if (crc32("frUaznEokcmbSR",14) == 3815397917) strcat(s, "U");
if (crc32("HteMGjliaSQF",12) == 765953801) strcat(s, "v");
if (crc32("TZUfjeirNHzlFUG",15) == 967680) strcat(s, "a");
if (crc32("wxxjahq",7) == 3985764794) strcat(s, "j");
if (crc32("vDoZNo",6) == 1884545927) strcat(s, "n");
if (crc32("oproMoHNWIrBIX",14) == 3374386384) strcat(s, "R");
if (crc32("SolZOanyw",9) == 1861372414) strcat(s, "c");
if (crc32("rDZilsIJ",8) == 2463228979) strcat(s, "i");
if (crc32("tBGLQmNES",9) == 3912105194) strcat(s, "I");
if (crc32("NfZwuNUKlKzelX",14) == 525562727) strcat(s, "n");
if (crc32("BdKZtnP",7) == 2084867342) strcat(s, "S");
if (crc32("COFjAPrAlgfdK",13) == 3224829157) strcat(s, "g");
    return s;
}

char *domesticating_verbs() {
    char *s = calloc(14);
    if (crc32("EIIvBv",6) == 1996356255) strcat(s, "d");
if (crc32("HTsPHQtiQun",11) == 1465115199) strcat(s, "v");
if (crc32("reGBMvHjx",9) == 840528977) strcat(s, "o");
if (crc32("cqdGYp",6) == 291218596) strcat(s, "A");
if (crc32("JsmvWS",6) == 1071374935) strcat(s, "m");
if (crc32("RyNjCJC",7) == 2418733354) strcat(s, "G");
if (crc32("hznITrPFxRXyGO",14) == 935720628) strcat(s, "e");
if (crc32("VacNpID",7) == 3202846914) strcat(s, "O");
if (crc32("WHHdY",5) == 2132676511) strcat(s, "s");
if (crc32("yEyRiHNr",8) == 59821882) strcat(s, "W");
if (crc32("cqjsG",5) == 1658424713) strcat(s, "t");
if (crc32("mRirn",5) == 914433100) strcat(s, "i");
if (crc32("invwMzLbsVCZO",13) == 358016768) strcat(s, "c");
if (crc32("LiFpWbkfO",9) == 3417824203) strcat(s, "B");
if (crc32("FvIbeGfiKPXDVd",14) == 3500977431) strcat(s, "a");
if (crc32("wsDNAtrUIM",10) == 148739552) strcat(s, "B");
if (crc32("EjdiMwnn",8) == 1164618872) strcat(s, "t");
if (crc32("RJgJxLkpkagA",12) == 241107466) strcat(s, "i");
if (crc32("iOKZOOxqwq",10) == 2758324470) strcat(s, "n");
if (crc32("gunGECPGJvbE",12) == 3671906326) strcat(s, "g");
    return s;
}

char *muting_verbs() {
    char *s = calloc(7);
    if (crc32("nPcstHmhlSOxh",13) == 277873976) strcat(s, "m");
if (crc32("JtbHbrlfJNdZ",12) == 3688753167) strcat(s, "u");
if (crc32("gqXmBBvNUDlfQ",13) == 2395640948) strcat(s, "t");
if (crc32("koFPWsMevsjKzL",14) == 2217363009) strcat(s, "i");
if (crc32("dggGuEOPxqED",12) == 2470405601) strcat(s, "n");
if (crc32("CQASt",5) == 877496905) strcat(s, "S");
if (crc32("bxuKeHXgGV",10) == 2448701707) strcat(s, "g");
    return s;
}

char *cuebidding_verbs() {
    char *s = calloc(11);
    if (crc32("QEduiyxpDQIEnaS",15) == 3549737394) strcat(s, "c");
if (crc32("nyufNrRndDMjLnm",15) == 492907589) strcat(s, "u");
if (crc32("dvNgjuMyUBzWIH",14) == 54704720) strcat(s, "e");
if (crc32("rVVUtAOC",8) == 2054843513) strcat(s, "Q");
if (crc32("AxlaKzATJC",10) == 145726416) strcat(s, "b");
if (crc32("pmvTc",5) == 4018076002) strcat(s, "O");
if (crc32("mSFbgEsy",8) == 4217976649) strcat(s, "i");
if (crc32("mhlxjpIBwpPs",12) == 3141716666) strcat(s, "R");
if (crc32("ZJSMW",5) == 2651520472) strcat(s, "d");
if (crc32("LdLoNA",6) == 1484964396) strcat(s, "d");
if (crc32("afWwQGq",7) == 3885966201) strcat(s, "i");
if (crc32("keBHs",5) == 2794064469) strcat(s, "n");
if (crc32("ayDiJfY",7) == 3174972592) strcat(s, "A");
if (crc32("YoZVFEbTXtj",11) == 1743065313) strcat(s, "g");
    return s;
}

char *standardized_verbs() {
    char *s = calloc(13);
    if (crc32("VaLpdtUqWob",11) == 3039100458) strcat(s, "Y");
if (crc32("MzXzUuMGdbRon",13) == 696282558) strcat(s, "s");
if (crc32("zeSakJGkDIbD",12) == 3970067107) strcat(s, "d");
if (crc32("wLEoSDdpWcYBLCl",15) == 2326326875) strcat(s, "t");
if (crc32("WcHBUFqzUqHki",13) == 3921924107) strcat(s, "F");
if (crc32("ANNomxwcz",9) == 2666956162) strcat(s, "a");
if (crc32("xCCyxho",7) == 947359655) strcat(s, "Q");
if (crc32("zZWrmOmqhzRhpE",14) == 1238683677) strcat(s, "n");
if (crc32("yuWhfz",6) == 1068788629) strcat(s, "d");
if (crc32("tOQCNOfIkqn",11) == 1534740791) strcat(s, "W");
if (crc32("toEURZxPcNNREoP",15) == 3823967726) strcat(s, "a");
if (crc32("yYWyGVtqc",9) == 1721965514) strcat(s, "Y");
if (crc32("PpdJJtC",7) == 4094424594) strcat(s, "r");
if (crc32("imFbBmbmQA",10) == 1307364675) strcat(s, "Z");
if (crc32("CvwAVKRmW",9) == 935348771) strcat(s, "d");
if (crc32("gGnJUHnYrE",10) == 2380642222) strcat(s, "y");
if (crc32("ECIRYsjrvBF",11) == 4175753269) strcat(s, "i");
if (crc32("YQuoDGvZQ",9) == 1097993355) strcat(s, "z");
if (crc32("ZBLMcKEyNfHmE",13) == 755658485) strcat(s, "e");
if (crc32("SaOLwC",6) == 1615729722) strcat(s, "R");
if (crc32("qkcLZfNqyt",10) == 3321025139) strcat(s, "d");
    return s;
}

char *holystoned_verbs() {
    char *s = calloc(11);
    if (crc32("HlxKvCMHiSf",11) == 1060235390) strcat(s, "c");
if (crc32("MElQPPuh",8) == 224149018) strcat(s, "h");
if (crc32("EhsIUafUxdCR",12) == 405388258) strcat(s, "v");
if (crc32("ahCWUag",7) == 3636740828) strcat(s, "o");
if (crc32("nHfieuVxQXJvMM",14) == 3513365187) strcat(s, "A");
if (crc32("FBTVgpANt",9) == 630437477) strcat(s, "l");
if (crc32("sqcZSiErpP",10) == 1631503244) strcat(s, "y");
if (crc32("uNBulbeuCuTt",12) == 851096686) strcat(s, "h");
if (crc32("ZBTWKbUXdyWYj",13) == 4177990478) strcat(s, "s");
if (crc32("qvMVDeFWSJZQDPN",15) == 296394800) strcat(s, "t");
if (crc32("IZgETMJWPoT",11) == 4090613555) strcat(s, "o");
if (crc32("ienOGVZhJqDOi",13) == 3172806728) strcat(s, "P");
if (crc32("mTbgwLg",7) == 2075515146) strcat(s, "n");
if (crc32("ZYKxtH",6) == 209171468) strcat(s, "e");
if (crc32("UfarsyGYO",9) == 4092135008) strcat(s, "d");
    return s;
}

char *doubleup_verbs() {
    char *s = calloc(9);
    if (crc32("VcNREoMRN",9) == 3598487640) strcat(s, "n");
if (crc32("vgvEfElET",9) == 1976455062) strcat(s, "d");
if (crc32("QkwQG",5) == 902866839) strcat(s, "o");
if (crc32("mJLZDsLAd",9) == 1752280415) strcat(s, "g");
if (crc32("VmVyexNP",8) == 1637117183) strcat(s, "u");
if (crc32("eURnO",5) == 419827782) strcat(s, "b");
if (crc32("iZrjLVBiWeZgGeN",15) == 4097244969) strcat(s, "t");
if (crc32("sjooHiFJBnTLlS",14) == 4202756527) strcat(s, "l");
if (crc32("uLzdlNnm",8) == 512760912) strcat(s, "z");
if (crc32("jfpQyT",6) == 2590358587) strcat(s, "e");
if (crc32("bhyREkcRVfIsM",13) == 2776178923) strcat(s, "y");
if (crc32("tmCulyAVVsxOhVd",15) == 4057238271) strcat(s, "u");
if (crc32("fBaCXSuzdBahvCD",15) == 1230025019) strcat(s, "E");
if (crc32("ANvmQaNwHHF",11) == 3134386884) strcat(s, "p");
    return s;
}

char *poeticizing_verbs() {
    char *s = calloc(12);
    if (crc32("BFmkIXmNUxLU",12) == 3933215685) strcat(s, "a");
if (crc32("BXdMLUkojhfH",12) == 3176142320) strcat(s, "p");
if (crc32("zXmMlbowczHQ",12) == 18186343) strcat(s, "o");
if (crc32("tGJTdeoT",8) == 1408270346) strcat(s, "w");
if (crc32("hqzWOELqwe",10) == 2865385857) strcat(s, "e");
if (crc32("wREwdv",6) == 3631680058) strcat(s, "O");
if (crc32("JJacqcKKYpF",11) == 3072380210) strcat(s, "t");
if (crc32("ApZMjoLVpxLp",12) == 1641153936) strcat(s, "i");
if (crc32("sdKCrUmQ",8) == 164088062) strcat(s, "K");
if (crc32("ycHMPsMxJ",9) == 1752916366) strcat(s, "c");
if (crc32("QNLFjIauxN",10) == 738415698) strcat(s, "t");
if (crc32("qhRksi",6) == 3439612778) strcat(s, "i");
if (crc32("DeudRSttvmdMg",13) == 4233119448) strcat(s, "z");
if (crc32("zujLmkqNiZ",10) == 824468381) strcat(s, "y");
if (crc32("boBpUMesKtyHDGY",15) == 4009643782) strcat(s, "i");
if (crc32("ymEOakCXlBouRRe",15) == 879114170) strcat(s, "n");
if (crc32("SuafEglcvvPPBv",14) == 3651942181) strcat(s, "t");
if (crc32("oLCiKHOhA",9) == 3879993297) strcat(s, "g");
    return s;
}

char *retighten_verbs() {
    char *s = calloc(10);
    if (crc32("QXjYSDTiXOhmh",13) == 384200529) strcat(s, "r");
if (crc32("bFIynkJcFAmJJGP",15) == 887584649) strcat(s, "c");
if (crc32("yUeAkxjxrLff",12) == 687039856) strcat(s, "e");
if (crc32("IdpTvxRbjjNaIQU",15) == 1675351842) strcat(s, "t");
if (crc32("WsTCR",5) == 2048454) strcat(s, "i");
if (crc32("apEOhcb",7) == 1128507444) strcat(s, "g");
if (crc32("FzCPC",5) == 1769101727) strcat(s, "u");
if (crc32("rKyDiiDGPc",10) == 4207938031) strcat(s, "h");
if (crc32("WnNrEqiYe",9) == 900905939) strcat(s, "t");
if (crc32("GXTAYBK",7) == 1376446688) strcat(s, "e");
if (crc32("tdWKjSxiXzL",11) == 2308588771) strcat(s, "c");
if (crc32("YctsENRVVLNsZv",14) == 17600454) strcat(s, "n");
    return s;
}

char *misunderstand_verbs() {
    char *s = calloc(14);
    if (crc32("eUkPltkSuvuN",12) == 749971052) strcat(s, "t");
if (crc32("CqyrdTHXvsOr",12) == 1859612192) strcat(s, "m");
if (crc32("QLjtmBSuLdTEm",13) == 1868594140) strcat(s, "j");
if (crc32("cOcsgYMqaJb",11) == 2088648787) strcat(s, "i");
if (crc32("hTrdLaIKEv",10) == 3992669350) strcat(s, "s");
if (crc32("hasUFLTaAVB",11) == 2036198757) strcat(s, "e");
if (crc32("LKuWWkqITmHTpuG",15) == 2985374603) strcat(s, "u");
if (crc32("GxZDjuYbGJKJkec",15) == 3453874077) strcat(s, "n");
if (crc32("VqpIiHZww",9) == 2495145778) strcat(s, "j");
if (crc32("jOqWUq",6) == 2561693040) strcat(s, "d");
if (crc32("CtbFUjLbl",9) == 2605392840) strcat(s, "Y");
if (crc32("UKaGNPltZ",9) == 944335999) strcat(s, "e");
if (crc32("pKjlXyo",7) == 4223499112) strcat(s, "V");
if (crc32("XfDljyzDgXUMwj",14) == 1096753414) strcat(s, "r");
if (crc32("JYjRfuLuKJy",11) == 1127594593) strcat(s, "S");
if (crc32("MdZGIDJJVqjgEJK",15) == 2718761091) strcat(s, "s");
if (crc32("XEiNud",6) == 3853634737) strcat(s, "t");
if (crc32("rYbFtMfxKIGr",12) == 3765041246) strcat(s, "a");
if (crc32("xQTztQblxmFyu",13) == 2632353085) strcat(s, "n");
if (crc32("lgApNNs",7) == 3456130727) strcat(s, "r");
if (crc32("ACsPGynx",8) == 3088076326) strcat(s, "d");
    return s;
}

char *reengaging_verbs() {
    char *s = calloc(11);
    if (crc32("owWTVykNWuyPdw",14) == 3531374681) strcat(s, "h");
if (crc32("fAZVvSBEcE",10) == 3751489959) strcat(s, "r");
if (crc32("KifZCuCTnbHEtSi",15) == 1548279718) strcat(s, "e");
if (crc32("qBxyxHqKk",9) == 2451518280) strcat(s, "e");
if (crc32("aiKeYH",6) == 97294855) strcat(s, "w");
if (crc32("xrjNuSQxnL",10) == 71681994) strcat(s, "n");
if (crc32("CJyIm",5) == 1681971115) strcat(s, "g");
if (crc32("hCiqbWJZxjWkObE",15) == 4246699202) strcat(s, "n");
if (crc32("cJmeXCggICnDGz",14) == 2093927522) strcat(s, "a");
if (crc32("YIXbgEdkRuRV",12) == 2831779204) strcat(s, "d");
if (crc32("daklXnPa",8) == 3998064209) strcat(s, "g");
if (crc32("ZaCqyXiegrQx",12) == 1293637189) strcat(s, "Z");
if (crc32("EmVnve",6) == 1734833267) strcat(s, "i");
if (crc32("PoVAML",6) == 61719218) strcat(s, "n");
if (crc32("RCtYZhkRP",9) == 88889138) strcat(s, "g");
    return s;
}

char *vitriolled_verbs() {
    char *s = calloc(11);
    if (crc32("ieugFxCZlD",10) == 855494992) strcat(s, "v");
if (crc32("KxdqE",5) == 1793130915) strcat(s, "Z");
if (crc32("HHBSTR",6) == 1042256637) strcat(s, "i");
if (crc32("fZQmlASunDqOG",13) == 78323723) strcat(s, "t");
if (crc32("YxudLrFY",8) == 4122132063) strcat(s, "r");
if (crc32("gvaqLHNOzX",10) == 1595469608) strcat(s, "W");
if (crc32("vJxJpdGzGupjUH",14) == 2084047563) strcat(s, "i");
if (crc32("Zsrys",5) == 2835585359) strcat(s, "p");
if (crc32("EGyEc",5) == 1382521053) strcat(s, "o");
if (crc32("yUBiTvo",7) == 3355655959) strcat(s, "M");
if (crc32("hwRRraJMU",9) == 1903706389) strcat(s, "l");
if (crc32("QMTQwPeD",8) == 3094427884) strcat(s, "l");
if (crc32("hQABjwZa",8) == 2055067942) strcat(s, "e");
if (crc32("xowxfYitVD",10) == 2683609865) strcat(s, "d");
    return s;
}

char *Kodaking_verbs() {
    char *s = calloc(9);
    if (crc32("GOlwvL",6) == 1602072906) strcat(s, "K");
if (crc32("vIBKq",5) == 2727888376) strcat(s, "B");
if (crc32("rJprY",5) == 3939919519) strcat(s, "o");
if (crc32("RoEIYSwRpLPpv",13) == 1190162002) strcat(s, "d");
if (crc32("pOtXdKQuj",9) == 2887464539) strcat(s, "a");
if (crc32("EtqiyJtXdFJhAc",14) == 4237406131) strcat(s, "I");
if (crc32("uGRtNMfabKChec",14) == 479391378) strcat(s, "k");
if (crc32("zOOcuwhzhTZc",12) == 323808973) strcat(s, "W");
if (crc32("VrsmSH",6) == 940796370) strcat(s, "i");
if (crc32("NHOBbLQFpLxGJ",13) == 4093072029) strcat(s, "C");
if (crc32("uEPgdCIKpuRupG",14) == 3676675652) strcat(s, "n");
if (crc32("CtCQhtIoNMN",11) == 1943021160) strcat(s, "k");
if (crc32("XfXLvzQxkopKYe",14) == 1829466567) strcat(s, "g");
    return s;
}

char *feezing_verbs() {
    char *s = calloc(8);
    if (crc32("sKlTyYxP",8) == 1250137744) strcat(s, "f");
if (crc32("QsZevUBnzTrF",12) == 2445816733) strcat(s, "e");
if (crc32("JgOpN",5) == 3071125459) strcat(s, "e");
if (crc32("nUlSeM",6) == 135982187) strcat(s, "F");
if (crc32("GLwmny",6) == 1524392408) strcat(s, "z");
if (crc32("zsuBtdcyxprUt",13) == 3331160009) strcat(s, "x");
if (crc32("HeNKtGO",7) == 331613906) strcat(s, "i");
if (crc32("IvjOMydXYypbKdm",15) == 1366231022) strcat(s, "g");
if (crc32("dtRUHW",6) == 3895034056) strcat(s, "n");
if (crc32("FVqQHfzbW",9) == 504011386) strcat(s, "x");
if (crc32("dBHMCofeJKCFs",13) == 126330164) strcat(s, "g");
    return s;
}

char *wag_verbs() {
    char *s = calloc(4);
    if (crc32("scEuPrmfVJJULi",14) == 689496259) strcat(s, "w");
if (crc32("XjOexgcliaR",11) == 2539379948) strcat(s, "u");
if (crc32("UjOFPKamX",9) == 2085961161) strcat(s, "a");
if (crc32("dvLRxOKxng",10) == 1909083437) strcat(s, "g");
    return s;
}

char *parries_verbs() {
    char *s = calloc(8);
    if (crc32("hsECDGm",7) == 565162942) strcat(s, "U");
if (crc32("IkQGKgtFjtbpp",13) == 3984813416) strcat(s, "p");
if (crc32("uaAfMilCwtiVhw",14) == 1102706146) strcat(s, "a");
if (crc32("AafSYGQO",8) == 3206670796) strcat(s, "N");
if (crc32("luooGwA",7) == 3871500070) strcat(s, "r");
if (crc32("FARkL",5) == 2757894309) strcat(s, "r");
if (crc32("nmihSZGIQ",9) == 1355688773) strcat(s, "i");
if (crc32("HBvIkHuGlHosCl",14) == 2361319749) strcat(s, "e");
if (crc32("CfmaLqdfZJjq",12) == 3567243611) strcat(s, "f");
if (crc32("yfTyDdmph",9) == 1649676163) strcat(s, "s");
    return s;
}

char *adjudicating_verbs() {
    char *s = calloc(13);
    if (crc32("DtQEvvz",7) == 2520192845) strcat(s, "y");
if (crc32("DCZjqq",6) == 3398329197) strcat(s, "a");
if (crc32("HBWpS",5) == 722613678) strcat(s, "d");
if (crc32("uqgkkXfnTdPQane",15) == 1131501066) strcat(s, "L");
if (crc32("gtlMJIoetobYYml",15) == 3380292932) strcat(s, "j");
if (crc32("cMdKJUKtDpHYOe",14) == 3271121322) strcat(s, "u");
if (crc32("OPYzJudBDUrFyr",14) == 4037912284) strcat(s, "l");
if (crc32("NkzKldL",7) == 724211917) strcat(s, "d");
if (crc32("ZnIAKk",6) == 1685888320) strcat(s, "i");
if (crc32("VrsaAKVlooZh",12) == 1583799399) strcat(s, "c");
if (crc32("gCoSBhIVbqwe",12) == 3604610972) strcat(s, "a");
if (crc32("pTaToYPvjuIq",12) == 2026561729) strcat(s, "w");
if (crc32("gdbRnvSUVX",10) == 2303257801) strcat(s, "t");
if (crc32("GPpSKdKRQBiz",12) == 3523482867) strcat(s, "i");
if (crc32("jlnpDaBYEcx",11) == 3270882855) strcat(s, "U");
if (crc32("gJTlaBNGxr",10) == 2954863928) strcat(s, "n");
if (crc32("eebrCWOiJeh",11) == 1059136841) strcat(s, "g");
    return s;
}

char *spoke_verbs() {
    char *s = calloc(6);
    if (crc32("nXAlyFrvGhXeTn",14) == 282025163) strcat(s, "O");
if (crc32("enNauykrVI",10) == 2796403692) strcat(s, "s");
if (crc32("VGLfe",5) == 97301588) strcat(s, "a");
if (crc32("oOVMZcoGh",9) == 2185723031) strcat(s, "p");
if (crc32("ZstMgyUbwrMIWr",14) == 1616390079) strcat(s, "F");
if (crc32("DOVvXvLE",8) == 3528224466) strcat(s, "o");
if (crc32("EJEQdNTE",8) == 4010437379) strcat(s, "D");
if (crc32("fwPmJvmv",8) == 4205137571) strcat(s, "k");
if (crc32("eDtqL",5) == 2570077642) strcat(s, "e");
    return s;
}

char *regraft_verbs() {
    char *s = calloc(8);
    if (crc32("nnDYB",5) == 1878720208) strcat(s, "K");
if (crc32("pxRTBk",6) == 1641862014) strcat(s, "r");
if (crc32("qnlQB",5) == 1820011480) strcat(s, "x");
if (crc32("kQuvfbUX",8) == 3072249820) strcat(s, "e");
if (crc32("miMMRHjwqQzcNu",14) == 2771319791) strcat(s, "g");
if (crc32("ypeMXlPt",8) == 1621654160) strcat(s, "r");
if (crc32("ZnDRQSyw",8) == 2872994382) strcat(s, "E");
if (crc32("BMqAORllppTFN",13) == 3651839527) strcat(s, "a");
if (crc32("HwavbPS",7) == 1037569912) strcat(s, "V");
if (crc32("wEstSfg",7) == 1066577891) strcat(s, "f");
if (crc32("qRdlFwphekaja",13) == 1098646143) strcat(s, "M");
if (crc32("ttzAlBM",7) == 249397577) strcat(s, "t");
    return s;
}

char *winced_verbs() {
    char *s = calloc(7);
    if (crc32("MjHWomglPKQmOja",15) == 446179533) strcat(s, "O");
if (crc32("KizTpkKhPehXig",14) == 304058557) strcat(s, "w");
if (crc32("NPafMYmjFToXTN",14) == 1891372209) strcat(s, "a");
if (crc32("oWfjotWrKqCq",12) == 52940612) strcat(s, "i");
if (crc32("lcGGuKPVhKf",11) == 1987160404) strcat(s, "C");
if (crc32("hudrjJdKVIsDIT",14) == 398103541) strcat(s, "n");
if (crc32("SAyoddp",7) == 3264752661) strcat(s, "c");
if (crc32("KXdCviAxuXoPI",13) == 2061951718) strcat(s, "E");
if (crc32("wOlgmaBQQgOJk",13) == 1315474078) strcat(s, "e");
if (crc32("hiwlwXKth",9) == 1009450884) strcat(s, "M");
if (crc32("YYhajKP",7) == 400428803) strcat(s, "d");
    return s;
}

char *telephoning_verbs() {
    char *s = calloc(12);
    if (crc32("qJfvKknYOig",11) == 820146809) strcat(s, "t");
if (crc32("zHpsbKrqTNQ",11) == 555721424) strcat(s, "W");
if (crc32("AMxqQMEbuiPiLj",14) == 1551139523) strcat(s, "e");
if (crc32("WhPNNQwC",8) == 4039859577) strcat(s, "l");
if (crc32("GYiGx",5) == 3333489039) strcat(s, "c");
if (crc32("rTMdGMDT",8) == 86715876) strcat(s, "e");
if (crc32("rezAQQ",6) == 1827430188) strcat(s, "p");
if (crc32("GcXsjI",6) == 3037797815) strcat(s, "h");
if (crc32("HpZKjrggDoAg",12) == 673185487) strcat(s, "o");
if (crc32("pIbhqubCFACLLD",14) == 183429706) strcat(s, "n");
if (crc32("HKyoimMQhZiT",12) == 3852804376) strcat(s, "i");
if (crc32("GkfuseU",7) == 1633441219) strcat(s, "n");
if (crc32("HQrARjJoio",10) == 2578645645) strcat(s, "l");
if (crc32("bEZgDO",6) == 4289936552) strcat(s, "g");
    return s;
}

char *swaddled_verbs() {
    char *s = calloc(9);
    if (crc32("QSACjx",6) == 862704448) strcat(s, "C");
if (crc32("CgOMJv",6) == 467228482) strcat(s, "s");
if (crc32("wIZreBofvfv",11) == 2478050143) strcat(s, "w");
if (crc32("BMMxWIHAXXlbbm",14) == 3871898811) strcat(s, "a");
if (crc32("KDmHLnt",7) == 2772300289) strcat(s, "d");
if (crc32("mHLFihmHj",9) == 1418691217) strcat(s, "d");
if (crc32("PYFwikwXlknk",12) == 252063302) strcat(s, "l");
if (crc32("vVHeqQTHhjD",11) == 4229488854) strcat(s, "J");
if (crc32("KXzqHtglOaBHJ",13) == 2461550661) strcat(s, "e");
if (crc32("woDURRReo",9) == 1372560958) strcat(s, "h");
if (crc32("WiiSuOIinoS",11) == 1027916195) strcat(s, "d");
    return s;
}

char *grooved_verbs() {
    char *s = calloc(8);
    if (crc32("RmdDFApSrM",10) == 2921092091) strcat(s, "d");
if (crc32("nUQJbEIDfAYybAS",15) == 632705868) strcat(s, "g");
if (crc32("JyhwcKCurzDrvm",14) == 3755104829) strcat(s, "g");
if (crc32("uYhdJwpn",8) == 2682798950) strcat(s, "r");
if (crc32("vafIwvdKeQbWZ",13) == 309356120) strcat(s, "x");
if (crc32("kLfDX",5) == 1157477009) strcat(s, "o");
if (crc32("LTmYTJpXJpiqC",13) == 3047335348) strcat(s, "o");
if (crc32("wqbxTY",6) == 2227888652) strcat(s, "v");
if (crc32("KitcXuHIt",9) == 3220566685) strcat(s, "v");
if (crc32("ABJHpIPDqYq",11) == 2799230561) strcat(s, "e");
if (crc32("ihpQIlooX",9) == 3526120676) strcat(s, "E");
if (crc32("ObnLdKrDEVloapM",15) == 2375994196) strcat(s, "d");
    return s;
}

char *strung_verbs() {
    char *s = calloc(7);
    if (crc32("LQrHgqL",7) == 3387976428) strcat(s, "G");
if (crc32("CWVKi",5) == 3229220783) strcat(s, "s");
if (crc32("UVzUWK",6) == 550763940) strcat(s, "t");
if (crc32("rDzwiGFAnvlQaRe",15) == 3805802313) strcat(s, "z");
if (crc32("nvISCP",6) == 3447132298) strcat(s, "r");
if (crc32("tZbfggHy",8) == 158380000) strcat(s, "w");
if (crc32("pADfRFAkFeHcEcB",15) == 3739060110) strcat(s, "u");
if (crc32("hYOhEf",6) == 3505355995) strcat(s, "t");
if (crc32("GNdvSlVad",9) == 2451864720) strcat(s, "n");
if (crc32("SyphGIrsGaYxUY",14) == 1782185238) strcat(s, "y");
if (crc32("vkeqtLYVztwiIq",14) == 2040866487) strcat(s, "g");
    return s;
}

char *awaking_verbs() {
    char *s = calloc(8);
    if (crc32("gQpCJ",5) == 4266611075) strcat(s, "F");
if (crc32("qlAimRfARphg",12) == 282148365) strcat(s, "a");
if (crc32("PidSNfTn",8) == 3456806916) strcat(s, "c");
if (crc32("PTzTLpNZnHcBntd",15) == 3026074786) strcat(s, "w");
if (crc32("NEDvvB",6) == 2271398297) strcat(s, "h");
if (crc32("sVnqEhiX",8) == 3392473469) strcat(s, "a");
if (crc32("XkCSddB",7) == 4279494657) strcat(s, "k");
if (crc32("TZRvtIHYMS",10) == 1671083266) strcat(s, "i");
if (crc32("YhXmmzppOmYI",12) == 569944560) strcat(s, "n");
if (crc32("GuwAGVSrkvJ",11) == 3144790045) strcat(s, "g");
    return s;
}

char *sleaving_verbs() {
    char *s = calloc(9);
    if (crc32("ZHIVaUL",7) == 2986880472) strcat(s, "P");
if (crc32("tjQLjdryF",9) == 2795800460) strcat(s, "s");
if (crc32("NULqmyKj",8) == 2405409790) strcat(s, "l");
if (crc32("BxTxYSL",7) == 1191232489) strcat(s, "l");
if (crc32("icrzpcZzs",9) == 4029802680) strcat(s, "A");
if (crc32("UvQVjKsUk",9) == 1057683057) strcat(s, "e");
if (crc32("jMlBoojYxKHo",12) == 1080264090) strcat(s, "a");
if (crc32("PXocMJQZqS",10) == 3133446751) strcat(s, "u");
if (crc32("dSzFPpIgJFQ",11) == 1332837183) strcat(s, "v");
if (crc32("CBefnj",6) == 210152580) strcat(s, "i");
if (crc32("dOrIZEhub",9) == 1958828611) strcat(s, "T");
if (crc32("QYgrRkWpqHcqROZ",15) == 1456039364) strcat(s, "n");
if (crc32("qIAsflQEXTQx",12) == 1160699545) strcat(s, "M");
if (crc32("ZjFsd",5) == 3670034710) strcat(s, "g");
    return s;
}

char *don_verbs() {
    char *s = calloc(4);
    if (crc32("PNnKVr",6) == 1279848857) strcat(s, "o");
if (crc32("KxeoaQyWgq",10) == 2684302930) strcat(s, "d");
if (crc32("LHNPLtU",7) == 4174433493) strcat(s, "o");
if (crc32("lOhjEmyLnReEh",13) == 3974371147) strcat(s, "n");
    return s;
}

char *diverging_verbs() {
    char *s = calloc(10);
    if (crc32("GdYmKKoJhB",10) == 3658643966) strcat(s, "B");
if (crc32("waqOLL",6) == 2287256209) strcat(s, "d");
if (crc32("dqgpAdTPo",9) == 530291966) strcat(s, "i");
if (crc32("dJrqZOZFcgjD",12) == 4155096394) strcat(s, "v");
if (crc32("waWlfbpHfMOWIY",14) == 2254028984) strcat(s, "d");
if (crc32("xJpQAvCoK",9) == 1692791407) strcat(s, "e");
if (crc32("OoLkPcRLglUDOgq",15) == 4153838670) strcat(s, "s");
if (crc32("qnTxJYt",7) == 3347697821) strcat(s, "r");
if (crc32("XFwWbYv",7) == 3493050177) strcat(s, "g");
if (crc32("XyeHKynEUBrw",12) == 3264711668) strcat(s, "v");
if (crc32("jNodvYF",7) == 2355376475) strcat(s, "i");
if (crc32("khNJSmJpDA",10) == 34330973) strcat(s, "T");
if (crc32("AGZMPBBwMeWeW",13) == 779451621) strcat(s, "n");
if (crc32("RvMIqHA",7) == 3731551263) strcat(s, "g");
    return s;
}

char *misbehave_verbs() {
    char *s = calloc(10);
    if (crc32("jLuTRGkisdiMuk",14) == 4241939184) strcat(s, "X");
if (crc32("LniAohaKiY",10) == 3611843273) strcat(s, "m");
if (crc32("IEDJrdviAt",10) == 1148665811) strcat(s, "K");
if (crc32("ZNkszphdfb",10) == 2043768340) strcat(s, "i");
if (crc32("GnJGEnOHsmc",11) == 3249517457) strcat(s, "s");
if (crc32("gsrQBHSazfTCB",13) == 2662774941) strcat(s, "l");
if (crc32("DhhOWNjEbe",10) == 2629584983) strcat(s, "b");
if (crc32("UtFRLsDkSSZYES",14) == 3540319827) strcat(s, "e");
if (crc32("zDunCEtS",8) == 3554300481) strcat(s, "h");
if (crc32("JSFSVdxesdunz",13) == 1852362743) strcat(s, "a");
if (crc32("zFZQcWkCpWHQ",12) == 686143459) strcat(s, "M");
if (crc32("NQJarS",6) == 3543412400) strcat(s, "v");
if (crc32("qHxjYkTKqv",10) == 3951579636) strcat(s, "r");
if (crc32("OQeBUAEBHqZwGH",14) == 501898654) strcat(s, "e");
    return s;
}

char *enthral_verbs() {
    char *s = calloc(8);
    if (crc32("IPJACMGUY",9) == 165888053) strcat(s, "Z");
if (crc32("pZJFIgjSnxlWrT",14) == 2000921477) strcat(s, "e");
if (crc32("VSjKWUaC",8) == 4128603707) strcat(s, "S");
if (crc32("RdtLYFZ",7) == 690196080) strcat(s, "n");
if (crc32("TKoHcTlmfVB",11) == 3018911910) strcat(s, "U");
if (crc32("YeLMUKXsiH",10) == 214424080) strcat(s, "t");
if (crc32("IrdIYssvxBgaXJ",14) == 44084443) strcat(s, "y");
if (crc32("HaJpKS",6) == 3073126870) strcat(s, "h");
if (crc32("oJXmzWVYiG",10) == 2660781779) strcat(s, "G");
if (crc32("ZkxamhPRYu",10) == 871701024) strcat(s, "r");
if (crc32("WkiheiXL",8) == 1157174471) strcat(s, "C");
if (crc32("plqiTsqOAA",10) == 3100759518) strcat(s, "a");
if (crc32("rOwVNOcn",8) == 2092423886) strcat(s, "l");
    return s;
}

char *aspirated_verbs() {
    char *s = calloc(10);
    if (crc32("rLBUE",5) == 647423639) strcat(s, "a");
if (crc32("ZXcmxXUnK",9) == 2011204797) strcat(s, "j");
if (crc32("gOgVnqCaj",9) == 3970719471) strcat(s, "s");
if (crc32("neCbbhshSCXm",12) == 2018240841) strcat(s, "p");
if (crc32("magUGOgXvMrpiIO",15) == 3588704352) strcat(s, "i");
if (crc32("XEVvPZgdqmGBxW",14) == 2647459431) strcat(s, "r");
if (crc32("yvIUwgrhJq",10) == 3120816419) strcat(s, "a");
if (crc32("ALUtteNXpynTO",13) == 4177016131) strcat(s, "t");
if (crc32("RsfLudXgOQWN",12) == 1713386567) strcat(s, "V");
if (crc32("ElYDMD",6) == 1197830597) strcat(s, "e");
if (crc32("lPqhT",5) == 2120917757) strcat(s, "E");
if (crc32("JrUyltvEJv",10) == 685782741) strcat(s, "d");
    return s;
}

char *hying_verbs() {
    char *s = calloc(6);
    if (crc32("lIIZK",5) == 1027021823) strcat(s, "h");
if (crc32("KbOTIhexq",9) == 685064072) strcat(s, "h");
if (crc32("gXoHrUfup",9) == 48571867) strcat(s, "m");
if (crc32("ZPdjdQ",6) == 3359483034) strcat(s, "y");
if (crc32("cviNtHsiViHZC",13) == 2822249519) strcat(s, "L");
if (crc32("OzKuAi",6) == 1066218315) strcat(s, "i");
if (crc32("VynOoKNhCSHZ",12) == 1326157406) strcat(s, "z");
if (crc32("nrqSxCO",7) == 2060473360) strcat(s, "n");
if (crc32("UugHMMPoI",9) == 4249173663) strcat(s, "I");
if (crc32("sNRpY",5) == 1361782900) strcat(s, "g");
    return s;
}

char *humbugging_verbs() {
    char *s = calloc(11);
    if (crc32("gFiNg",5) == 2841984382) strcat(s, "h");
if (crc32("yEXYeWs",7) == 3943678920) strcat(s, "L");
if (crc32("AGNoGQRPoSt",11) == 1432958363) strcat(s, "u");
if (crc32("xqjXCoLzlzY",11) == 3926483462) strcat(s, "m");
if (crc32("vyEeHabuHONb",12) == 272433461) strcat(s, "b");
if (crc32("olpsU",5) == 3880957988) strcat(s, "u");
if (crc32("LfgKyaBZnqe",11) == 2879945353) strcat(s, "Y");
if (crc32("zZgyFxe",7) == 3949832346) strcat(s, "g");
if (crc32("zBVAQKf",7) == 969791853) strcat(s, "I");
if (crc32("LZvNQ",5) == 3715873432) strcat(s, "g");
if (crc32("VilLAJfAKiNkP",13) == 1846927506) strcat(s, "i");
if (crc32("wHAFl",5) == 3816310346) strcat(s, "R");
if (crc32("xBkpCZPL",8) == 2142839312) strcat(s, "n");
if (crc32("mVyAodrXPf",10) == 3210463512) strcat(s, "g");
    return s;
}

char *rummaging_verbs() {
    char *s = calloc(10);
    if (crc32("EuzEGMnhDb",10) == 559695153) strcat(s, "G");
if (crc32("wwnvjpBY",8) == 2122738144) strcat(s, "r");
if (crc32("TLdQdH",6) == 2539208174) strcat(s, "G");
if (crc32("UwFbnroDuM",10) == 615625362) strcat(s, "u");
if (crc32("VUwnmEgMJg",10) == 1335113049) strcat(s, "R");
if (crc32("lYmSZyR",7) == 1481828961) strcat(s, "m");
if (crc32("cJonnLfxgcLuCk",14) == 2308260360) strcat(s, "m");
if (crc32("bSZltrus",8) == 1933588855) strcat(s, "b");
if (crc32("Dyqvhpcm",8) == 3495550896) strcat(s, "a");
if (crc32("SzIjafoCpid",11) == 2467608337) strcat(s, "g");
if (crc32("LttsoXGDLfC",11) == 26431110) strcat(s, "i");
if (crc32("nnMMiWHi",8) == 1266434911) strcat(s, "n");
if (crc32("NfLBxUwwSoaMCf",14) == 3886748849) strcat(s, "H");
if (crc32("gcXyLbOnxnUZuoi",15) == 3829122715) strcat(s, "g");
    return s;
}

char *subliming_verbs() {
    char *s = calloc(10);
    if (crc32("TzsTItFvIn",10) == 266208108) strcat(s, "N");
if (crc32("BEForv",6) == 987404668) strcat(s, "s");
if (crc32("sVFeqIOxsw",10) == 263953740) strcat(s, "u");
if (crc32("pbyugrqDYGbQQhl",15) == 1290112473) strcat(s, "b");
if (crc32("mFTqGMnmAyfKRJK",15) == 2698068283) strcat(s, "r");
if (crc32("uRjKGPNHWEnBS",13) == 3770225783) strcat(s, "l");
if (crc32("TNdHHHNejeL",11) == 2232463104) strcat(s, "i");
if (crc32("OuBNG",5) == 2938773386) strcat(s, "Z");
if (crc32("QvpOOMVzwCDnZp",14) == 3295912883) strcat(s, "m");
if (crc32("PrXxvScGOI",10) == 3111612295) strcat(s, "b");
if (crc32("OEyRYndELbthVp",14) == 3911322708) strcat(s, "i");
if (crc32("NuqxgIZFa",9) == 2301929789) strcat(s, "n");
if (crc32("RoZtYnTSLFZrbiI",15) == 3964373894) strcat(s, "w");
if (crc32("BLHMw",5) == 3236696606) strcat(s, "g");
    return s;
}

char *owe_verbs() {
    char *s = calloc(4);
    if (crc32("lirNYHdie",9) == 840523831) strcat(s, "E");
if (crc32("BrYAUd",6) == 974000868) strcat(s, "o");
if (crc32("eeVZHkii",8) == 1479022250) strcat(s, "N");
if (crc32("pvwfv",5) == 2866515567) strcat(s, "w");
if (crc32("EPssGflkMcI",11) == 2086028912) strcat(s, "g");
if (crc32("QRiPLYJgehNwP",13) == 3232855781) strcat(s, "e");
    return s;
}

char *degenerated_verbs() {
    char *s = calloc(12);
    if (crc32("ELGWirv",7) == 2041218812) strcat(s, "o");
if (crc32("tpojGoxgPD",10) == 3953162430) strcat(s, "d");
if (crc32("BxkNgamoAbG",11) == 924662099) strcat(s, "J");
if (crc32("rXvsJwwRA",9) == 2161272120) strcat(s, "e");
if (crc32("FEpGWVzsDkqr",12) == 2631445346) strcat(s, "g");
if (crc32("vyXOvjzqq",9) == 4043065168) strcat(s, "n");
if (crc32("uzuVmtmRjGHZiV",14) == 801921245) strcat(s, "e");
if (crc32("ecoDZHgiFWoQd",13) == 967997874) strcat(s, "s");
if (crc32("lnqcWiUptZRz",12) == 1899870244) strcat(s, "n");
if (crc32("UKVFKUj",7) == 2522258749) strcat(s, "e");
if (crc32("EWGzccuuJCUWxya",15) == 2663153858) strcat(s, "r");
if (crc32("HclfYnZBzQTtjyT",15) == 3182687139) strcat(s, "O");
if (crc32("wgNbkaAELmUi",12) == 909543881) strcat(s, "a");
if (crc32("ZfrqLPiitopj",12) == 3065789603) strcat(s, "v");
if (crc32("chCEjDFbypy",11) == 1186389019) strcat(s, "t");
if (crc32("rmoyJm",6) == 2541400181) strcat(s, "e");
if (crc32("JulHJOEGzcN",11) == 1258285802) strcat(s, "n");
if (crc32("AUXVzNjnWBKpx",13) == 1331850367) strcat(s, "d");
    return s;
}

char *shampooing_verbs() {
    char *s = calloc(11);
    if (crc32("tDrygp",6) == 3677880944) strcat(s, "g");
if (crc32("BeOQJPOzg",9) == 1601810178) strcat(s, "s");
if (crc32("FZwDSNMdv",9) == 4138523102) strcat(s, "h");
if (crc32("mMAUQatmFho",11) == 3364239132) strcat(s, "a");
if (crc32("uCkHkkYHGJqyTl",14) == 1386807570) strcat(s, "m");
if (crc32("HasGIXHPZEm",11) == 2662971701) strcat(s, "p");
if (crc32("XsIXwucSxDqIYR",14) == 1196332921) strcat(s, "o");
if (crc32("WwrPGwVUXtJXo",13) == 175755622) strcat(s, "o");
if (crc32("ikmOci",6) == 1559120354) strcat(s, "r");
if (crc32("SMocIQpUDFCGb",13) == 3402001026) strcat(s, "i");
if (crc32("PRkROuLSdIu",11) == 2230341530) strcat(s, "n");
if (crc32("qLEzvAhjmb",10) == 3144044611) strcat(s, "t");
if (crc32("dFbBxxmMgTNSY",13) == 2007414756) strcat(s, "g");
    return s;
}

char *munch_verbs() {
    char *s = calloc(6);
    if (crc32("jzTPCvftanKp",12) == 1573126069) strcat(s, "s");
if (crc32("glwrXDgoFwEjD",13) == 508441862) strcat(s, "m");
if (crc32("rwXtALBTAjTOsj",14) == 488090519) strcat(s, "u");
if (crc32("QIpHcJRw",8) == 1559136608) strcat(s, "n");
if (crc32("LfvECVdXyO",10) == 3297998580) strcat(s, "c");
if (crc32("oOYgqwBRRXzFO",13) == 3491658713) strcat(s, "N");
if (crc32("JnGdLziAKaQ",11) == 4240524960) strcat(s, "h");
    return s;
}

char *recoagulating_verbs() {
    char *s = calloc(14);
    if (crc32("VFCUlD",6) == 1763678176) strcat(s, "F");
if (crc32("IhUSmTcIaDzY",12) == 1551105688) strcat(s, "r");
if (crc32("EjzehlyyvJpeYj",14) == 3518513424) strcat(s, "W");
if (crc32("dnFhzWDbqM",10) == 3110782816) strcat(s, "e");
if (crc32("VfgVXPA",7) == 430967566) strcat(s, "C");
if (crc32("PDNPEUvKP",9) == 1701602413) strcat(s, "c");
if (crc32("UVCuZNAYoepMAt",14) == 1505680978) strcat(s, "H");
if (crc32("XVaUngHuXOPDaDR",15) == 350231908) strcat(s, "o");
if (crc32("szBAPPgSeEwHi",13) == 2054978425) strcat(s, "a");
if (crc32("dtwlulCZDEC",11) == 3872026955) strcat(s, "x");
if (crc32("KaUNLPobbKMRli",14) == 1592827926) strcat(s, "g");
if (crc32("GGovj",5) == 3183200747) strcat(s, "u");
if (crc32("XcXaGfcNQdUO",12) == 1961930867) strcat(s, "x");
if (crc32("nDUwxM",6) == 1823047318) strcat(s, "l");
if (crc32("CDQslHyW",8) == 257923179) strcat(s, "a");
if (crc32("TLayDnTSHRW",11) == 1257977542) strcat(s, "t");
if (crc32("rxULUBMH",8) == 3697811606) strcat(s, "r");
if (crc32("hvBDKiTAT",9) == 2869706555) strcat(s, "i");
if (crc32("TAGVBEjI",8) == 610466211) strcat(s, "n");
if (crc32("GGaBTzo",7) == 2640318578) strcat(s, "F");
if (crc32("CvSfjFcypadLpw",14) == 3401964034) strcat(s, "g");
    return s;
}

char *dieted_verbs() {
    char *s = calloc(7);
    if (crc32("cvZoeIGuZzu",11) == 1680776781) strcat(s, "d");
if (crc32("XOqYcqYKf",9) == 1736452313) strcat(s, "i");
if (crc32("uOehCQgdNjuzl",13) == 3669674796) strcat(s, "e");
if (crc32("eVnFqqEbfOkxwh",14) == 592552992) strcat(s, "j");
if (crc32("soRuutBZlrQI",12) == 2860077343) strcat(s, "t");
if (crc32("pbYrQJAXUsXfB",13) == 832576611) strcat(s, "N");
if (crc32("puIPJdFbUTzDVgJ",15) == 4293869855) strcat(s, "e");
if (crc32("kdyCgQuXLywXTc",14) == 2595671150) strcat(s, "d");
    return s;
}

char *jigsawing_verbs() {
    char *s = calloc(10);
    if (crc32("rhqQmaieZyiLiY",14) == 3196564332) strcat(s, "Z");
if (crc32("WwxKtnT",7) == 739136068) strcat(s, "j");
if (crc32("bmNtPw",6) == 1219780424) strcat(s, "Y");
if (crc32("dGSOYLOkFYgKYV",14) == 1367860624) strcat(s, "i");
if (crc32("GwbjUWFAmIqp",12) == 2949592923) strcat(s, "U");
if (crc32("UCArvybwQmgYo",13) == 3022908143) strcat(s, "g");
if (crc32("FmBKBH",6) == 616991571) strcat(s, "i");
if (crc32("lZzFAhZwdwX",11) == 3716204557) strcat(s, "s");
if (crc32("pxUMldSa",8) == 3150691972) strcat(s, "x");
if (crc32("wuMIUFAeqghtczB",15) == 2917458772) strcat(s, "a");
if (crc32("IrvAOEOwr",9) == 3794491788) strcat(s, "w");
if (crc32("QbnZzbmff",9) == 689389822) strcat(s, "n");
if (crc32("GmoZGelkxTimO",13) == 3830143822) strcat(s, "i");
if (crc32("GCPcratFQm",10) == 2340085859) strcat(s, "i");
if (crc32("xXABPWsw",8) == 2216155457) strcat(s, "n");
if (crc32("tkxEoQAkVuZ",11) == 3107127317) strcat(s, "L");
if (crc32("VOeuVrXVF",9) == 4060688416) strcat(s, "g");
    return s;
}

char *muted_verbs() {
    char *s = calloc(6);
    if (crc32("veJtITmJuJlWD",13) == 2312317544) strcat(s, "M");
if (crc32("gpUAQLaHyasF",12) == 980084960) strcat(s, "m");
if (crc32("IrCXK",5) == 3007830511) strcat(s, "u");
if (crc32("jmCnnOxRuL",10) == 4029954973) strcat(s, "t");
if (crc32("yWVTTDdI",8) == 1900554864) strcat(s, "L");
if (crc32("tVDdpZsCALX",11) == 2015572630) strcat(s, "e");
if (crc32("uOnppXf",7) == 307071642) strcat(s, "d");
    return s;
}

char *brining_verbs() {
    char *s = calloc(8);
    if (crc32("qnhuCJwqUmYm",12) == 3485873136) strcat(s, "b");
if (crc32("rlHdiYViS",9) == 1473440749) strcat(s, "r");
if (crc32("BMHoOG",6) == 2672170610) strcat(s, "H");
if (crc32("gABVQNL",7) == 2814510140) strcat(s, "i");
if (crc32("OUTuXby",7) == 4272145850) strcat(s, "n");
if (crc32("AeMJuCGysDIndY",14) == 2345864180) strcat(s, "s");
if (crc32("VGcpVQJc",8) == 1564504176) strcat(s, "i");
if (crc32("SlHwePdjvfHE",12) == 3027303980) strcat(s, "n");
if (crc32("hAvgJ",5) == 3495211244) strcat(s, "a");
if (crc32("GVbLNp",6) == 3265067399) strcat(s, "g");
    return s;
}

char *staned_verbs() {
    char *s = calloc(7);
    if (crc32("roDATsIHp",9) == 3860898126) strcat(s, "s");
if (crc32("JitegCvzJU",10) == 1732327809) strcat(s, "t");
if (crc32("thrfIEeaZwB",11) == 3931386291) strcat(s, "a");
if (crc32("xmvXlxeTWNwX",12) == 590239499) strcat(s, "O");
if (crc32("XVIowMYUf",9) == 3053929688) strcat(s, "n");
if (crc32("SBvMX",5) == 4170657500) strcat(s, "e");
if (crc32("AUSTpI",6) == 386375219) strcat(s, "d");
    return s;
}

char *interweaved_verbs() {
    char *s = calloc(12);
    if (crc32("bOMak",5) == 1093591366) strcat(s, "N");
if (crc32("TuThClhp",8) == 17759920) strcat(s, "i");
if (crc32("wsBWQSlsYwW",11) == 2104090085) strcat(s, "M");
if (crc32("LfYnKVsLIV",10) == 2833257404) strcat(s, "n");
if (crc32("YvHkFamHVUu",11) == 75522945) strcat(s, "s");
if (crc32("zVEcLQpAk",9) == 31454149) strcat(s, "t");
if (crc32("nAXArX",6) == 3791109240) strcat(s, "e");
if (crc32("xDiEVDdp",8) == 895898760) strcat(s, "J");
if (crc32("xTTMhJBUXFDkP",13) == 2399268684) strcat(s, "r");
if (crc32("xXJHtZISAdmTeX",14) == 2795484327) strcat(s, "w");
if (crc32("rnixFCLNXwlOndX",15) == 1701708749) strcat(s, "e");
if (crc32("DDXdqmXIkFomsd",14) == 2868211382) strcat(s, "q");
if (crc32("iPXUeRhiUmZ",11) == 1803062837) strcat(s, "a");
if (crc32("evPnIo",6) == 3936045864) strcat(s, "v");
if (crc32("FRTVTBhO",8) == 1658904802) strcat(s, "e");
if (crc32("TqDLxu",6) == 2529694056) strcat(s, "v");
if (crc32("HcjGYtkx",8) == 1536308202) strcat(s, "d");
    return s;
}

char *dight_verbs() {
    char *s = calloc(6);
    if (crc32("nZWqugNT",8) == 3780792388) strcat(s, "d");
if (crc32("lghLfARtQ",9) == 1265540562) strcat(s, "i");
if (crc32("baxaaHidEp",10) == 2947073695) strcat(s, "O");
if (crc32("gyNFaX",6) == 1182482851) strcat(s, "g");
if (crc32("WAwasU",6) == 205662705) strcat(s, "m");
if (crc32("eUrMkNmpVNiUBrE",15) == 4133181786) strcat(s, "h");
if (crc32("MpjScoLLWGVF",12) == 2752573372) strcat(s, "T");
if (crc32("sfcUivGa",8) == 1121397229) strcat(s, "t");
    return s;
}

char *bromating_verbs() {
    char *s = calloc(10);
    if (crc32("XpZNZji",7) == 1162575036) strcat(s, "b");
if (crc32("qmhJUy",6) == 489851587) strcat(s, "q");
if (crc32("nHSboEqeGdWe",12) == 4192241174) strcat(s, "r");
if (crc32("mDIXtzkuWszus",13) == 3887939456) strcat(s, "I");
if (crc32("hYPKcTyrgPU",11) == 916662116) strcat(s, "o");
if (crc32("fkHhMKSKz",9) == 968204820) strcat(s, "G");
if (crc32("esoPnothJbB",11) == 3816372965) strcat(s, "m");
if (crc32("mdqQYwmiPF",10) == 494466003) strcat(s, "l");
if (crc32("zxUSKiRHpxR",11) == 839825141) strcat(s, "a");
if (crc32("ZklYBifFumPlG",13) == 3241928792) strcat(s, "t");
if (crc32("UwcsqshmOizgO",13) == 1598750764) strcat(s, "i");
if (crc32("sGwFWcfo",8) == 4112802039) strcat(s, "n");
if (crc32("etyfvlFdZnXRp",13) == 1148929375) strcat(s, "D");
if (crc32("FwcmMyccmB",10) == 1013889086) strcat(s, "g");
    return s;
}

char *divorced_verbs() {
    char *s = calloc(9);
    if (crc32("ugPcn",5) == 2186730488) strcat(s, "p");
if (crc32("MZNpRLLb",8) == 2070644367) strcat(s, "d");
if (crc32("xGvTuPgOqICWZ",13) == 1712269022) strcat(s, "g");
if (crc32("ZECXPOPEKMrUNyV",15) == 1236614276) strcat(s, "i");
if (crc32("WuDVai",6) == 1516503440) strcat(s, "f");
if (crc32("qMkizdYXswS",11) == 177300878) strcat(s, "v");
if (crc32("QVMonRSkvtNHU",13) == 1009551677) strcat(s, "T");
if (crc32("NnCCwcN",7) == 2740863004) strcat(s, "o");
if (crc32("MIhZclPXFjyWqJ",14) == 4190635282) strcat(s, "l");
if (crc32("WgWvMEWfVEiT",12) == 1911864367) strcat(s, "r");
if (crc32("DtdyWfJiTRullK",14) == 1874630177) strcat(s, "c");
if (crc32("FJgiGrOgRg",10) == 3144278276) strcat(s, "e");
if (crc32("QVmPJTKRY",9) == 1180693170) strcat(s, "d");
    return s;
}

char *Judaized_verbs() {
    char *s = calloc(9);
    if (crc32("vmKppS",6) == 3366072919) strcat(s, "J");
if (crc32("SfoRAiieret",11) == 2402377883) strcat(s, "u");
if (crc32("HozkwliEffHGvZT",15) == 2996728205) strcat(s, "R");
if (crc32("qOxyxDcvTm",10) == 592899396) strcat(s, "d");
if (crc32("SmJALE",6) == 2768919249) strcat(s, "z");
if (crc32("IZTTCY",6) == 219137634) strcat(s, "a");
if (crc32("REyZiouJgC",10) == 784879605) strcat(s, "i");
if (crc32("yxRxcE",6) == 667755806) strcat(s, "z");
if (crc32("YSSRaGimSkcn",12) == 2155398074) strcat(s, "p");
if (crc32("JntyYczwOdkVF",13) == 2331244073) strcat(s, "e");
if (crc32("UfqGgxMpcHwF",12) == 216645941) strcat(s, "z");
if (crc32("UQkFLSnDTcaS",12) == 2437574546) strcat(s, "d");
    return s;
}

char *overregulate_verbs() {
    char *s = calloc(13);
    if (crc32("hiEElVukXokW",12) == 3741094068) strcat(s, "o");
if (crc32("OXVuSv",6) == 186973808) strcat(s, "y");
if (crc32("JeHpxuQXh",9) == 2152629286) strcat(s, "v");
if (crc32("trtFbXiJhsWzn",13) == 2437870578) strcat(s, "F");
if (crc32("qygHswkC",8) == 1085416468) strcat(s, "e");
if (crc32("zwhCvu",6) == 2244805741) strcat(s, "r");
if (crc32("EPklCrd",7) == 1036586524) strcat(s, "r");
if (crc32("sAIXbHrfF",9) == 687324646) strcat(s, "X");
if (crc32("NSHAfMbAmbHvQN",14) == 644256351) strcat(s, "e");
if (crc32("egcMy",5) == 4015278431) strcat(s, "E");
if (crc32("XglIMQhnnBriHP",14) == 635980376) strcat(s, "g");
if (crc32("lHYIJOcMmW",10) == 3591144577) strcat(s, "u");
if (crc32("McsHYJSccbn",11) == 2607723645) strcat(s, "Q");
if (crc32("UoxnHAKUckP",11) == 192655053) strcat(s, "l");
if (crc32("ukCbaPfhKc",10) == 2708632035) strcat(s, "k");
if (crc32("qCvJMGhFVcU",11) == 119422491) strcat(s, "a");
if (crc32("TslDyGbaAcOTu",13) == 833300999) strcat(s, "t");
if (crc32("FNPnOJBHgna",11) == 2390375311) strcat(s, "e");
    return s;
}

char *overeaten_verbs() {
    char *s = calloc(10);
    if (crc32("GXPZeYjay",9) == 300005299) strcat(s, "f");
if (crc32("oHRsJMLyqeKgK",13) == 77661743) strcat(s, "o");
if (crc32("HLbgmiSyzGrKhRD",15) == 4013998651) strcat(s, "v");
if (crc32("COsNRYVHFKhC",12) == 3790445744) strcat(s, "e");
if (crc32("uVFMC",5) == 4204714001) strcat(s, "S");
if (crc32("ZWFyAgIrTId",11) == 3611335978) strcat(s, "r");
if (crc32("NOnxRuKhCquEb",13) == 1931917162) strcat(s, "s");
if (crc32("KZMotfL",7) == 2858856407) strcat(s, "e");
if (crc32("uWRdr",5) == 3426351602) strcat(s, "T");
if (crc32("LADmETlv",8) == 3142996801) strcat(s, "a");
if (crc32("oKhsuwHBOlrcgMJ",15) == 2757784317) strcat(s, "t");
if (crc32("xxWRc",5) == 1496418872) strcat(s, "f");
if (crc32("EmLBBoeL",8) == 2715906313) strcat(s, "e");
if (crc32("xxcDvTGpY",9) == 4281309762) strcat(s, "y");
if (crc32("afwWjhnppjxTHZb",15) == 3397154700) strcat(s, "n");
    return s;
}

char *spying_verbs() {
    char *s = calloc(7);
    if (crc32("fQntO",5) == 821774865) strcat(s, "j");
if (crc32("VydwZM",6) == 840195717) strcat(s, "s");
if (crc32("JWUnh",5) == 2982302656) strcat(s, "h");
if (crc32("dpTVGHTGRglK",12) == 851330376) strcat(s, "p");
if (crc32("mlwpsEJzWb",10) == 3507874762) strcat(s, "y");
if (crc32("doSCubRJekUCd",13) == 534769661) strcat(s, "N");
if (crc32("OiyNtVKWgOkjKR",14) == 4003405822) strcat(s, "i");
if (crc32("iqaBXxzghgdUZ",13) == 3575749943) strcat(s, "n");
if (crc32("nqNnZOWJPyh",11) == 3334103313) strcat(s, "A");
if (crc32("PyWNIOAlVyqNutR",15) == 1939629956) strcat(s, "g");
    return s;
}

char *occupy_verbs() {
    char *s = calloc(7);
    if (crc32("WEwDI",5) == 711999785) strcat(s, "o");
if (crc32("cjrlochMueQvUX",14) == 1867010383) strcat(s, "c");
if (crc32("vEZdLglTuXK",11) == 1285685088) strcat(s, "Y");
if (crc32("ugJySO",6) == 423833500) strcat(s, "c");
if (crc32("NHjljy",6) == 1855188035) strcat(s, "S");
if (crc32("tcDPfKooyy",10) == 4053807141) strcat(s, "u");
if (crc32("ckNTMAjGr",9) == 1266600532) strcat(s, "l");
if (crc32("pbjzdalgGZ",10) == 1371312221) strcat(s, "p");
if (crc32("BZecvpm",7) == 3622584478) strcat(s, "y");
    return s;
}

char *produced_verbs() {
    char *s = calloc(9);
    if (crc32("MnoeLywHi",9) == 3099269947) strcat(s, "t");
if (crc32("sqQowycPDOthnR",14) == 3823748869) strcat(s, "p");
if (crc32("BUnvTNhDKj",10) == 2653920663) strcat(s, "W");
if (crc32("JzsjzncVkD",10) == 942139661) strcat(s, "r");
if (crc32("JoNeGfpZqsanfn",14) == 2762504599) strcat(s, "K");
if (crc32("BjWcuLCaJHvLMv",14) == 1797643758) strcat(s, "o");
if (crc32("VtmKmwBg",8) == 2286051875) strcat(s, "I");
if (crc32("imQhJwDvPTyi",12) == 4259412507) strcat(s, "d");
if (crc32("PjtgvmC",7) == 3532620386) strcat(s, "u");
if (crc32("xIaZgwXUPDagSO",14) == 2122421110) strcat(s, "Y");
if (crc32("LEpsWZ",6) == 445102433) strcat(s, "c");
if (crc32("noBiCUkX",8) == 190881685) strcat(s, "e");
if (crc32("IAlFvkZfEZ",10) == 2329029686) strcat(s, "O");
if (crc32("FdmpAjM",7) == 3311966438) strcat(s, "d");
    return s;
}

char *ammoniating_verbs() {
    char *s = calloc(12);
    if (crc32("YXdSpaHGGG",10) == 1286811872) strcat(s, "g");
if (crc32("ZpqpCDtc",8) == 366641208) strcat(s, "a");
if (crc32("VKjIROsT",8) == 1044226211) strcat(s, "m");
if (crc32("XGiUUn",6) == 4199751420) strcat(s, "m");
if (crc32("NzeDqrgJ",8) == 3693399706) strcat(s, "o");
if (crc32("jTSMjaeKtUfo",12) == 2002342480) strcat(s, "n");
if (crc32("kjCle",5) == 2421606712) strcat(s, "r");
if (crc32("DYnEoFvCiYB",11) == 1386930547) strcat(s, "i");
if (crc32("EhOBKcptyq",10) == 177036637) strcat(s, "l");
if (crc32("wgYLETpNT",9) == 3829638553) strcat(s, "a");
if (crc32("wWQgEPFAkz",10) == 2057249077) strcat(s, "v");
if (crc32("VkxPbbLZWGUkw",13) == 1646567513) strcat(s, "t");
if (crc32("rfNurDw",7) == 2383779357) strcat(s, "i");
if (crc32("QibwCZtVBXS",11) == 29625597) strcat(s, "E");
if (crc32("SrJsKgBp",8) == 1175062393) strcat(s, "n");
if (crc32("QxaujUoiTLdJZ",13) == 742211145) strcat(s, "g");
    return s;
}

char *rivalling_verbs() {
    char *s = calloc(10);
    if (crc32("zkeKwFz",7) == 3989669623) strcat(s, "r");
if (crc32("DhBthlQkCubmlPc",15) == 2321283151) strcat(s, "q");
if (crc32("TiUbh",5) == 860498571) strcat(s, "i");
if (crc32("lMxlGDsEJUI",11) == 512663250) strcat(s, "o");
if (crc32("FFUyFBeVL",9) == 3263888557) strcat(s, "v");
if (crc32("ICqzjkWvEfK",11) == 678067461) strcat(s, "s");
if (crc32("rbvbBXvIZyfjLw",14) == 264527113) strcat(s, "a");
if (crc32("TcRygu",6) == 1113899701) strcat(s, "K");
if (crc32("hAeenLHegMQtX",13) == 581985037) strcat(s, "l");
if (crc32("ZAGYTSU",7) == 1664702911) strcat(s, "l");
if (crc32("FnKEElmUgny",11) == 3433401431) strcat(s, "i");
if (crc32("OXaWxLr",7) == 3943371701) strcat(s, "d");
if (crc32("VSldlJXVeZAvBx",14) == 4095314249) strcat(s, "n");
if (crc32("fVELW",5) == 3785666299) strcat(s, "g");
    return s;
}

char *broadsided_verbs() {
    char *s = calloc(11);
    if (crc32("oXLoEEikeqjd",12) == 3731033487) strcat(s, "b");
if (crc32("JqFxp",5) == 3267886671) strcat(s, "z");
if (crc32("fRMGuCaAt",9) == 2793325644) strcat(s, "r");
if (crc32("FvySytvB",8) == 775857896) strcat(s, "c");
if (crc32("QHustYpbF",9) == 1819057111) strcat(s, "o");
if (crc32("IHudyUkAQVKQLPJ",15) == 582183850) strcat(s, "a");
if (crc32("argOJtyyf",9) == 1873487813) strcat(s, "h");
if (crc32("cIgGYWpesU",10) == 1802235121) strcat(s, "d");
if (crc32("AGKBMPNbMVjuHX",14) == 471177772) strcat(s, "o");
if (crc32("tASfdVwZ",8) == 77177847) strcat(s, "s");
if (crc32("etmDUAnm",8) == 3118539816) strcat(s, "i");
if (crc32("rYzhPWkMBalKTvE",15) == 99927263) strcat(s, "d");
if (crc32("JCiwkrxYEhqBiS",14) == 3947146462) strcat(s, "q");
if (crc32("fZtDxcjqC",9) == 4260911684) strcat(s, "e");
if (crc32("GOJfL",5) == 2285777062) strcat(s, "t");
if (crc32("ofGoefqvJAwYxAp",15) == 1708301785) strcat(s, "d");
    return s;
}

char *overdebated_verbs() {
    char *s = calloc(12);
    if (crc32("OFuGpy",6) == 358676601) strcat(s, "Z");
if (crc32("IFhqXK",6) == 1995162913) strcat(s, "o");
if (crc32("xmQRInkUAbOEqDO",15) == 1992970951) strcat(s, "v");
if (crc32("OwgCprtgVSN",11) == 3161307271) strcat(s, "U");
if (crc32("hPhhuvwskkbUxAi",15) == 3065234353) strcat(s, "e");
if (crc32("qjtfCrrS",8) == 2504512568) strcat(s, "d");
if (crc32("POwVOoY",7) == 1849144852) strcat(s, "r");
if (crc32("abKhMuGoCS",10) == 2630749602) strcat(s, "Z");
if (crc32("whVQUcSfavaftHl",15) == 4028683334) strcat(s, "d");
if (crc32("PJyohZyjWHlbBI",14) == 600755532) strcat(s, "l");
if (crc32("RXPlfhZr",8) == 2491517232) strcat(s, "e");
if (crc32("FAGthEP",7) == 3499918666) strcat(s, "b");
if (crc32("NWwzWZd",7) == 370638668) strcat(s, "z");
if (crc32("XyNvPiprmbSW",12) == 3803821417) strcat(s, "a");
if (crc32("aFSdirbsgwL",11) == 3862424973) strcat(s, "t");
if (crc32("MErBsjLdqxdPgT",14) == 1955969566) strcat(s, "X");
if (crc32("nvZupAtmwrkYDW",14) == 1399572933) strcat(s, "e");
if (crc32("GuUKYVVrUCQhaXh",15) == 2662047471) strcat(s, "d");
    return s;
}

char *decreeing_verbs() {
    char *s = calloc(10);
    if (crc32("kZhYGI",6) == 2358600565) strcat(s, "d");
if (crc32("qCuevyMxHS",10) == 4260518934) strcat(s, "j");
if (crc32("urBZtDkR",8) == 1525968369) strcat(s, "e");
if (crc32("ZkWsyYw",7) == 1971051498) strcat(s, "c");
if (crc32("NtfJAbzK",8) == 3520691795) strcat(s, "r");
if (crc32("BLuowuEKYneQjfL",15) == 2871648190) strcat(s, "e");
if (crc32("DQUmNhzlkunrKU",14) == 2347925742) strcat(s, "Z");
if (crc32("HvXfuQcplMGWSw",14) == 327929386) strcat(s, "e");
if (crc32("TdaaqRTtsTO",11) == 1612820601) strcat(s, "i");
if (crc32("fqIEnFkoEkA",11) == 2811070821) strcat(s, "n");
if (crc32("AbKCohEHJEysrO",14) == 957179850) strcat(s, "g");
    return s;
}

char *overcropping_verbs() {
    char *s = calloc(13);
    if (crc32("slgDpbKge",9) == 605606351) strcat(s, "S");
if (crc32("HMLShZcKcZ",10) == 721620965) strcat(s, "o");
if (crc32("jbowqtSqaWS",11) == 3900604349) strcat(s, "x");
if (crc32("UpqfJIlAJyOorDI",15) == 2421672648) strcat(s, "v");
if (crc32("aJTwbFOrx",9) == 2976752890) strcat(s, "e");
if (crc32("YKlbOsh",7) == 1392228502) strcat(s, "S");
if (crc32("EXEUZ",5) == 1655396793) strcat(s, "r");
if (crc32("Gxwgt",5) == 2920336807) strcat(s, "c");
if (crc32("GpEestmojVmjfYc",15) == 3216967605) strcat(s, "z");
if (crc32("biEQVgnz",8) == 1534353389) strcat(s, "r");
if (crc32("lgrzwUksxpW",11) == 2574073252) strcat(s, "A");
if (crc32("WgIVa",5) == 1140799023) strcat(s, "o");
if (crc32("RSYKzf",6) == 888982108) strcat(s, "p");
if (crc32("beelX",5) == 3468136656) strcat(s, "A");
if (crc32("pGcpDZ",6) == 855255661) strcat(s, "p");
if (crc32("aizDUmAOwkaJdx",14) == 4227851914) strcat(s, "G");
if (crc32("ocwEkVNygtUyev",14) == 1024603467) strcat(s, "i");
if (crc32("gBdaMLaH",8) == 1336960554) strcat(s, "n");
if (crc32("QlPjmItWrwvqKEw",15) == 1901337953) strcat(s, "g");
    return s;
}

char *elapsed_verbs() {
    char *s = calloc(8);
    if (crc32("Lgfuq",5) == 3300980324) strcat(s, "e");
if (crc32("EnDnjK",6) == 3765879077) strcat(s, "l");
if (crc32("RQVMATiZg",9) == 2997455070) strcat(s, "I");
if (crc32("VWUzdGj",7) == 1695680903) strcat(s, "a");
if (crc32("utkTHOobKeOwsse",15) == 2292290328) strcat(s, "p");
if (crc32("QQKpBeODqCT",11) == 3555664691) strcat(s, "s");
if (crc32("IsZkkhFr",8) == 2135733213) strcat(s, "e");
if (crc32("BGlVVR",6) == 1774476846) strcat(s, "d");
    return s;
}

char *swindle_verbs() {
    char *s = calloc(8);
    if (crc32("eBDgmZ",6) == 3385559980) strcat(s, "s");
if (crc32("pQvkXJKHV",9) == 2264052333) strcat(s, "H");
if (crc32("nJOpYysKtmWXGw",14) == 1679149064) strcat(s, "w");
if (crc32("VLPgZXbDW",9) == 4177824922) strcat(s, "i");
if (crc32("CNXEVjai",8) == 3825846284) strcat(s, "p");
if (crc32("QEXhaK",6) == 865522403) strcat(s, "n");
if (crc32("nTEkuEh",7) == 831782285) strcat(s, "d");
if (crc32("heUrixRsnR",10) == 353592883) strcat(s, "C");
if (crc32("YziFPy",6) == 2289753541) strcat(s, "l");
if (crc32("OLlOnVkpASBe",12) == 2394473762) strcat(s, "H");
if (crc32("usSIcCqWiem",11) == 1240758213) strcat(s, "e");
    return s;
}

char *reinfiltrate_verbs() {
    char *s = calloc(13);
    if (crc32("JRjbW",5) == 3483058227) strcat(s, "d");
if (crc32("ivXuLImWEt",10) == 586286029) strcat(s, "r");
if (crc32("dTKUHGQklZVrr",13) == 3335855875) strcat(s, "e");
if (crc32("QjHrAUmN",8) == 3147411018) strcat(s, "i");
if (crc32("qqvFFZsZ",8) == 284107143) strcat(s, "p");
if (crc32("iFBzmDENZp",10) == 2681624990) strcat(s, "n");
if (crc32("VMXMRNyuPOOODFV",15) == 1830882061) strcat(s, "f");
if (crc32("cRayIpW",7) == 1902811903) strcat(s, "f");
if (crc32("sexzyim",7) == 166329859) strcat(s, "i");
if (crc32("suXmTadWq",9) == 3169378230) strcat(s, "l");
if (crc32("zAqPHrlYTBqtoey",15) == 677367554) strcat(s, "C");
if (crc32("AWTsOsHFG",9) == 3105123292) strcat(s, "t");
if (crc32("KyMVW",5) == 2660913477) strcat(s, "r");
if (crc32("WDbSgMtOzukxvUx",15) == 3933534200) strcat(s, "E");
if (crc32("wmiVhUFtBG",10) == 112591916) strcat(s, "a");
if (crc32("VThgtS",6) == 2638831685) strcat(s, "E");
if (crc32("FvGjOxOYasRIh",13) == 3618838558) strcat(s, "t");
if (crc32("YMvCZfajZs",10) == 1476363282) strcat(s, "H");
if (crc32("tYgXMnfRK",9) == 4053834495) strcat(s, "e");
    return s;
}

char *conned_verbs() {
    char *s = calloc(7);
    if (crc32("muxBXfbjxXWirqK",15) == 1705173428) strcat(s, "c");
if (crc32("bEhoWcpbTcRie",13) == 3762076267) strcat(s, "o");
if (crc32("QFjsHcw",7) == 2231888859) strcat(s, "L");
if (crc32("aobyeeeOAFHwQ",13) == 4097548919) strcat(s, "n");
if (crc32("QUsry",5) == 2150952463) strcat(s, "N");
if (crc32("lsZKHFZuiLmMDN",14) == 257706517) strcat(s, "n");
if (crc32("gbqyOtXvDKiT",12) == 2759435517) strcat(s, "e");
if (crc32("msqvI",5) == 4250693296) strcat(s, "d");
    return s;
}

char *overdecorated_verbs() {
    char *s = calloc(14);
    if (crc32("LWbnxqVO",8) == 1868993608) strcat(s, "o");
if (crc32("vvbNIglMTPfMZ",13) == 175684557) strcat(s, "D");
if (crc32("rKiWXkLU",8) == 1701151664) strcat(s, "v");
if (crc32("HRUwfuytHjeRUV",14) == 1647621034) strcat(s, "e");
if (crc32("ShTtqNlVubj",11) == 1981077468) strcat(s, "y");
if (crc32("yLMdmggnNAsQH",13) == 2151302051) strcat(s, "r");
if (crc32("pyuzlxumNOk",11) == 2629952515) strcat(s, "d");
if (crc32("RZivCdZudoZiTK",14) == 1707787963) strcat(s, "W");
if (crc32("VlsfkvfFFkjcSyg",15) == 2848460048) strcat(s, "e");
if (crc32("EOXRolXddLDWDTB",15) == 3804993589) strcat(s, "c");
if (crc32("KCbClnWKDwMEAJS",15) == 51698865) strcat(s, "o");
if (crc32("cYRgKbVSLEzgLEe",15) == 2356955874) strcat(s, "d");
if (crc32("NfuJY",5) == 1974951310) strcat(s, "r");
if (crc32("MyUmWBJWZgNL",12) == 2868542378) strcat(s, "R");
if (crc32("lWKGqj",6) == 3863280081) strcat(s, "a");
if (crc32("oWyzkvvFqyEou",13) == 2390660058) strcat(s, "t");
if (crc32("fRjtaRzgbx",10) == 4222554328) strcat(s, "e");
if (crc32("BwINMAJzmeZbfA",14) == 4124110029) strcat(s, "d");
    return s;
}

char *brangling_verbs() {
    char *s = calloc(10);
    if (crc32("NmvGWy",6) == 42999629) strcat(s, "b");
if (crc32("MjFvna",6) == 4266578713) strcat(s, "r");
if (crc32("pboDSQB",7) == 1052678815) strcat(s, "v");
if (crc32("DbVSrvIhhQk",11) == 807159618) strcat(s, "a");
if (crc32("bmcZqDAYHUpW",12) == 1422134533) strcat(s, "L");
if (crc32("PTzpnOAHQyFPi",13) == 1605017443) strcat(s, "n");
if (crc32("KosfSfVAfHqHoP",14) == 2202613492) strcat(s, "g");
if (crc32("sjpNwmiN",8) == 392613239) strcat(s, "l");
if (crc32("gfOQOVeZhFQsgcx",15) == 609218954) strcat(s, "i");
if (crc32("xoJFGDJvVXkbZ",13) == 423608964) strcat(s, "n");
if (crc32("TNAAgrGoaF",10) == 1922888952) strcat(s, "g");
    return s;
}

char *aerify_verbs() {
    char *s = calloc(7);
    if (crc32("jgWhLhzLoiF",11) == 847087607) strcat(s, "G");
if (crc32("YEgBDhqoYNJIe",13) == 3596651505) strcat(s, "a");
if (crc32("SmNZXCDVuVO",11) == 4112052634) strcat(s, "g");
if (crc32("SiSwiomGeQIPKvx",15) == 3504954515) strcat(s, "e");
if (crc32("iEFrM",5) == 620728083) strcat(s, "E");
if (crc32("QJcQsYCWvoasu",13) == 21780053) strcat(s, "r");
if (crc32("eDzlhT",6) == 3236284221) strcat(s, "i");
if (crc32("byrQfF",6) == 7113048) strcat(s, "f");
if (crc32("EwUTQfi",7) == 1296754406) strcat(s, "g");
if (crc32("hehtTwK",7) == 3671505175) strcat(s, "y");
    return s;
}

char *reengaged_verbs() {
    char *s = calloc(10);
    if (crc32("FMGATElrjiUVHb",14) == 732359010) strcat(s, "r");
if (crc32("INLFqrnsonJpf",13) == 3391265133) strcat(s, "e");
if (crc32("YcMEXEp",7) == 374116205) strcat(s, "e");
if (crc32("FbkZoqHxwpZYB",13) == 3394136019) strcat(s, "n");
if (crc32("eIjJxMVJ",8) == 41566106) strcat(s, "q");
if (crc32("rbYVREGyC",9) == 1290560193) strcat(s, "g");
if (crc32("JVpCvgeXjxKy",12) == 422692096) strcat(s, "x");
if (crc32("rpDmHpuJuSflLe",14) == 2879795829) strcat(s, "a");
if (crc32("PzVpegzAu",9) == 2242127930) strcat(s, "g");
if (crc32("BuVRZneqoIaAJ",13) == 3008074021) strcat(s, "e");
if (crc32("gLLebTv",7) == 385779308) strcat(s, "d");
    return s;
}

char *hurrying_verbs() {
    char *s = calloc(9);
    if (crc32("OQUuOUFnr",9) == 1136584193) strcat(s, "h");
if (crc32("XNdPjHLNxgJhQ",13) == 306028947) strcat(s, "i");
if (crc32("ogkjNGesqRvNP",13) == 1583771436) strcat(s, "u");
if (crc32("TCnlU",5) == 2717587510) strcat(s, "Y");
if (crc32("AaKVTgWUMF",10) == 3083893800) strcat(s, "r");
if (crc32("uoNpmEsBo",9) == 831887048) strcat(s, "Z");
if (crc32("ugaJYhk",7) == 1914680820) strcat(s, "r");
if (crc32("fbclw",5) == 214433589) strcat(s, "y");
if (crc32("ZVUOXxIvV",9) == 240834713) strcat(s, "B");
if (crc32("STaXK",5) == 663172256) strcat(s, "i");
if (crc32("JDXlOFMAtFVMVCS",15) == 1347841494) strcat(s, "C");
if (crc32("pwRxZ",5) == 3396877885) strcat(s, "n");
if (crc32("zgBfuyFOaFRUgC",14) == 1346040418) strcat(s, "N");
if (crc32("jnZUSGwGrjv",11) == 3493331814) strcat(s, "g");
    return s;
}

char *wainscotted_verbs() {
    char *s = calloc(12);
    if (crc32("zoaYzoRR",8) == 3511992460) strcat(s, "B");
if (crc32("meHSHKtLXE",10) == 470010202) strcat(s, "w");
if (crc32("ukaFLJVb",8) == 4289346721) strcat(s, "a");
if (crc32("pFUKCEt",7) == 3775228562) strcat(s, "f");
if (crc32("sGTUoBUTnETZ",12) == 3959845541) strcat(s, "i");
if (crc32("JrmkZrw",7) == 71028464) strcat(s, "n");
if (crc32("dacch",5) == 3753346418) strcat(s, "E");
if (crc32("WHDfOvJNa",9) == 3642644463) strcat(s, "s");
if (crc32("grgaj",5) == 683661932) strcat(s, "o");
if (crc32("RbmRQDjrIUGizF",14) == 3542363136) strcat(s, "c");
if (crc32("aaxKBudYRi",10) == 3076943584) strcat(s, "o");
if (crc32("dYpUkwquPVrBl",13) == 801236241) strcat(s, "G");
if (crc32("FCUflwKtMF",10) == 2479922573) strcat(s, "t");
if (crc32("Ebdpm",5) == 2499549251) strcat(s, "t");
if (crc32("vRueCV",6) == 1707827894) strcat(s, "e");
if (crc32("NDbeLme",7) == 3151201781) strcat(s, "a");
if (crc32("ukUnmhtgItsOae",14) == 854132568) strcat(s, "d");
    return s;
}

char *reapprove_verbs() {
    char *s = calloc(10);
    if (crc32("JCeoMshKtLW",11) == 2194978412) strcat(s, "r");
if (crc32("SuupTgtiQ",9) == 3133813733) strcat(s, "J");
if (crc32("jfEHyzBr",8) == 3362565525) strcat(s, "e");
if (crc32("aCbNpgbQlInP",12) == 2020267974) strcat(s, "a");
if (crc32("MBRNCUEAXDUWCl",14) == 145162477) strcat(s, "s");
if (crc32("UBdPhbGH",8) == 1928860894) strcat(s, "p");
if (crc32("iWtaJcMxtgkTJ",13) == 2773794865) strcat(s, "f");
if (crc32("DvzpNOL",7) == 1518454401) strcat(s, "p");
if (crc32("qJEbLvqGJlL",11) == 3898428034) strcat(s, "i");
if (crc32("dxBKuoYiccz",11) == 1791616527) strcat(s, "r");
if (crc32("pTVvqtybXOsU",12) == 4117782120) strcat(s, "V");
if (crc32("kAFPlDLjNM",10) == 4011025685) strcat(s, "o");
if (crc32("WDbyae",6) == 2201017343) strcat(s, "k");
if (crc32("oomTXnZX",8) == 33196418) strcat(s, "v");
if (crc32("SwysVyWt",8) == 1921219356) strcat(s, "c");
if (crc32("PJEWFfu",7) == 2976663297) strcat(s, "e");
    return s;
}

char *negativing_verbs() {
    char *s = calloc(11);
    if (crc32("hmpxZrutMQlZVyP",15) == 150602869) strcat(s, "B");
if (crc32("FfZDYw",6) == 143262311) strcat(s, "n");
if (crc32("XFDHQEfY",8) == 1156617655) strcat(s, "A");
if (crc32("vMnfbyOHlqocV",13) == 4112656841) strcat(s, "e");
if (crc32("KycGfwOZVaO",11) == 3954057161) strcat(s, "V");
if (crc32("AjlGSP",6) == 1486658331) strcat(s, "g");
if (crc32("TZjlbbSjQqf",11) == 3462999737) strcat(s, "a");
if (crc32("NdHqGLHoIE",10) == 1606952724) strcat(s, "o");
if (crc32("pZpiBdRdwLVIL",13) == 2670114207) strcat(s, "t");
if (crc32("GFPihjfq",8) == 1450857860) strcat(s, "i");
if (crc32("UIBHOc",6) == 2839823891) strcat(s, "h");
if (crc32("UZdtGcIahYmkU",13) == 3873351382) strcat(s, "v");
if (crc32("cFXozmaQKeTe",12) == 3285279355) strcat(s, "i");
if (crc32("nbxcOqotLrVaZRb",15) == 3867106170) strcat(s, "n");
if (crc32("zcGJkGaLBpQ",11) == 177377302) strcat(s, "Y");
if (crc32("qntQGSmcuubgsg",14) == 1796540451) strcat(s, "g");
    return s;
}

char *quaked_verbs() {
    char *s = calloc(7);
    if (crc32("hQhEziero",9) == 78017414) strcat(s, "q");
if (crc32("ReNaomrmAPiXF",13) == 1873025427) strcat(s, "u");
if (crc32("TvBGSNmNFOO",11) == 1394143389) strcat(s, "a");
if (crc32("IbRuczbdM",9) == 3378610577) strcat(s, "l");
if (crc32("HluUUtqLsUKYLxi",15) == 2865117190) strcat(s, "k");
if (crc32("uMgttFBiVUpzUax",15) == 188869165) strcat(s, "e");
if (crc32("nhxADpsDXx",10) == 1854131609) strcat(s, "v");
if (crc32("bpxlLwsiQv",10) == 3803865683) strcat(s, "d");
    return s;
}

char *complotted_verbs() {
    char *s = calloc(11);
    if (crc32("ajwMfD",6) == 1834278318) strcat(s, "c");
if (crc32("WTCoK",5) == 623921003) strcat(s, "k");
if (crc32("OgQcyM",6) == 2876133483) strcat(s, "o");
if (crc32("weQRyxXGdKC",11) == 2948512534) strcat(s, "M");
if (crc32("lVwDhaAq",8) == 1624257781) strcat(s, "m");
if (crc32("dzbQgV",6) == 3307234863) strcat(s, "p");
if (crc32("lvvGfaydidfPOTz",15) == 2606976628) strcat(s, "Y");
if (crc32("PbZsgbuWF",9) == 2395220688) strcat(s, "l");
if (crc32("cTRwzVXXLVOozCw",15) == 3358899242) strcat(s, "o");
if (crc32("xSiLL",5) == 2996306242) strcat(s, "t");
if (crc32("LiLakEgXJCTvA",13) == 3135657150) strcat(s, "K");
if (crc32("dVjDXEJnpBcSYUF",15) == 1634653752) strcat(s, "t");
if (crc32("uoioowaay",9) == 2719936115) strcat(s, "r");
if (crc32("TQlVq",5) == 4063133677) strcat(s, "e");
if (crc32("FGwbo",5) == 3425317193) strcat(s, "d");
    return s;
}

char *splicing_verbs() {
    char *s = calloc(9);
    if (crc32("fpysWl",6) == 960755910) strcat(s, "u");
if (crc32("vaUyw",5) == 1774303343) strcat(s, "s");
if (crc32("dObMzOPizccWza",14) == 2011446067) strcat(s, "p");
if (crc32("vpevyKLC",8) == 2277175475) strcat(s, "a");
if (crc32("DKCZKnV",7) == 4142754093) strcat(s, "l");
if (crc32("yNDHfrnp",8) == 1798812296) strcat(s, "R");
if (crc32("cUimCe",6) == 805106951) strcat(s, "i");
if (crc32("zWVgRnMkifgmcl",14) == 4034511014) strcat(s, "c");
if (crc32("TARRrD",6) == 561694976) strcat(s, "b");
if (crc32("PYKNNjrz",8) == 2538045154) strcat(s, "i");
if (crc32("ORrfSJwaIhag",12) == 1115339044) strcat(s, "n");
if (crc32("uFaqDtG",7) == 1502879066) strcat(s, "g");
    return s;
}

char *decontrolling_verbs() {
    char *s = calloc(14);
    if (crc32("EbHTGRlwecGIlLr",15) == 883548274) strcat(s, "H");
if (crc32("AhbBtqhFtm",10) == 2462576099) strcat(s, "d");
if (crc32("stnEQJoATiLqg",13) == 3863994798) strcat(s, "C");
if (crc32("ytnSm",5) == 912373552) strcat(s, "e");
if (crc32("GfxEzTcFKPgpwRC",15) == 2686907844) strcat(s, "c");
if (crc32("IIjsnSdhAhUmKrX",15) == 2329894887) strcat(s, "o");
if (crc32("UODITLMkbSvIG",13) == 3897438306) strcat(s, "n");
if (crc32("IBxtdx",6) == 1450516049) strcat(s, "f");
if (crc32("SOHlCtPuwxKuc",13) == 4142503769) strcat(s, "t");
if (crc32("bqAgwmybeau",11) == 2209241052) strcat(s, "r");
if (crc32("vjTKZUwPxanPYb",14) == 3947907934) strcat(s, "X");
if (crc32("pdxbIwCa",8) == 3830163940) strcat(s, "o");
if (crc32("BSWqRfyn",8) == 2956453560) strcat(s, "l");
if (crc32("ugICpFiSJZMmc",13) == 2327449571) strcat(s, "x");
if (crc32("VLzDnNjNYjinO",13) == 2433702902) strcat(s, "l");
if (crc32("Godjyr",6) == 152012774) strcat(s, "i");
if (crc32("CwOGmozxxMn",11) == 2849960841) strcat(s, "n");
if (crc32("LRBLuRfVI",9) == 2637144739) strcat(s, "g");
    return s;
}

char *preextend_verbs() {
    char *s = calloc(10);
    if (crc32("hLwRRwLCO",9) == 4232757313) strcat(s, "u");
if (crc32("vcuWn",5) == 2498336744) strcat(s, "p");
if (crc32("gJpDgvrEsvysTOq",15) == 2676422763) strcat(s, "r");
if (crc32("ZzyrKMFIdzkZxpU",15) == 129245508) strcat(s, "e");
if (crc32("GNEQQkajuFnA",12) == 2396885527) strcat(s, "V");
if (crc32("OKIQMaSKhvxfZ",13) == 1853364449) strcat(s, "e");
if (crc32("blWpuhymsGy",11) == 4244625325) strcat(s, "e");
if (crc32("HFKQonqAnLHKsip",15) == 2913285417) strcat(s, "x");
if (crc32("YjMlhgoz",8) == 238439122) strcat(s, "t");
if (crc32("pFKKDAtoMKFzEhn",15) == 572628763) strcat(s, "e");
if (crc32("kAMsmWBVBXQO",12) == 3650590643) strcat(s, "n");
if (crc32("LZnYj",5) == 4148690193) strcat(s, "I");
if (crc32("IjaqAp",6) == 634980498) strcat(s, "d");
    return s;
}

char *ruddling_verbs() {
    char *s = calloc(9);
    if (crc32("NZQxFkWbB",9) == 3715502817) strcat(s, "o");
if (crc32("YKlJRPQKRGA",11) == 744331707) strcat(s, "r");
if (crc32("uTFsG",5) == 734138147) strcat(s, "u");
if (crc32("cStFwpZDg",9) == 2672626044) strcat(s, "d");
if (crc32("xSHNMezaTdfq",12) == 1788404361) strcat(s, "o");
if (crc32("cXoUVAAXnh",10) == 782382444) strcat(s, "d");
if (crc32("OtvMP",5) == 2250013456) strcat(s, "l");
if (crc32("ZXDddTtoJk",10) == 2039954084) strcat(s, "F");
if (crc32("LVcUoMfQYMi",11) == 3268984343) strcat(s, "i");
if (crc32("gvkDSrYAL",9) == 3802958717) strcat(s, "n");
if (crc32("tZTDoKl",7) == 3907445497) strcat(s, "F");
if (crc32("ppqUZ",5) == 1301193938) strcat(s, "g");
    return s;
}

char *incubate_verbs() {
    char *s = calloc(9);
    if (crc32("PTFpvc",6) == 1733942775) strcat(s, "C");
if (crc32("rLmGMuqHjdo",11) == 3133586701) strcat(s, "i");
if (crc32("pHmIWSfrDSvt",12) == 803082945) strcat(s, "o");
if (crc32("rFbSi",5) == 367299446) strcat(s, "n");
if (crc32("GAWDWqSt",8) == 251078301) strcat(s, "q");
if (crc32("cSLamIdJbHvsl",13) == 4062389530) strcat(s, "c");
if (crc32("sglJPIkjmqTMXTL",15) == 292598775) strcat(s, "U");
if (crc32("scYdB",5) == 2884480719) strcat(s, "u");
if (crc32("aHQZzpLvISIqd",13) == 3244732965) strcat(s, "X");
if (crc32("PDwnRXJhARvgpb",14) == 2751720347) strcat(s, "b");
if (crc32("jkvuCPZeYxycLw",14) == 3442303412) strcat(s, "J");
if (crc32("EWwTIyqsPWJdNow",15) == 882161223) strcat(s, "a");
if (crc32("TrRYFrF",7) == 241921072) strcat(s, "t");
if (crc32("DZILcHtbQ",9) == 1164958254) strcat(s, "z");
if (crc32("NSRgAsTUu",9) == 440675111) strcat(s, "e");
    return s;
}

char *hurtle_verbs() {
    char *s = calloc(7);
    if (crc32("WrHTtCdN",8) == 1939541173) strcat(s, "n");
if (crc32("sgTJt",5) == 3907663486) strcat(s, "h");
if (crc32("xGrftAgkOg",10) == 160456322) strcat(s, "u");
if (crc32("eydXfIQtLrsR",12) == 1044108533) strcat(s, "A");
if (crc32("dhYlcMHedyQAip",14) == 1554584717) strcat(s, "r");
if (crc32("GPeFmGQFH",9) == 3714626891) strcat(s, "t");
if (crc32("kjsZHiucJIm",11) == 1078351643) strcat(s, "J");
if (crc32("UUXRIASdjhBLU",13) == 3473408125) strcat(s, "l");
if (crc32("wkpfiVuDmyLnudP",15) == 3304510078) strcat(s, "e");
    return s;
}

char *clewup_verbs() {
    char *s = calloc(7);
    if (crc32("uBxXIToXZB",10) == 1353260878) strcat(s, "c");
if (crc32("KXHCdMTxB",9) == 2151697829) strcat(s, "C");
if (crc32("vXCbgtDHrAZuM",13) == 1833525225) strcat(s, "l");
if (crc32("DFHhPz",6) == 452471695) strcat(s, "G");
if (crc32("neKuWECjw",9) == 4061573705) strcat(s, "e");
if (crc32("wBcwLNgCNZ",10) == 3739262614) strcat(s, "w");
if (crc32("qAfwMR",6) == 1181031938) strcat(s, "O");
if (crc32("VLanxLp",7) == 2356371444) strcat(s, "u");
if (crc32("PZJyTInhSOJXd",13) == 979846514) strcat(s, "i");
if (crc32("UatirbHow",9) == 3051477424) strcat(s, "p");
    return s;
}

char *brocading_verbs() {
    char *s = calloc(10);
    if (crc32("zjJFMGUsich",11) == 3787861460) strcat(s, "b");
if (crc32("fVnWmN",6) == 3884735755) strcat(s, "G");
if (crc32("YsLoHehAN",9) == 982993792) strcat(s, "r");
if (crc32("LRryZYIddg",10) == 4121627890) strcat(s, "W");
if (crc32("jxzSta",6) == 3398507452) strcat(s, "o");
if (crc32("ogPBqLdlnS",10) == 3695063851) strcat(s, "c");
if (crc32("eUZzMIAwuGkapB",14) == 1909399829) strcat(s, "a");
if (crc32("pJfpdc",6) == 926265924) strcat(s, "d");
if (crc32("OQhsKDpnTBE",11) == 2667633093) strcat(s, "A");
if (crc32("qDjXx",5) == 2132447660) strcat(s, "i");
if (crc32("JEMpaSHcAI",10) == 2332617325) strcat(s, "V");
if (crc32("GXPDhKvnpfBVYhM",15) == 1521824943) strcat(s, "n");
if (crc32("qoGEWSGJVCtap",13) == 2806945295) strcat(s, "c");
if (crc32("VGfUWu",6) == 543802548) strcat(s, "g");
    return s;
}

char *resymbolizing_verbs() {
    char *s = calloc(14);
    if (crc32("RPcGa",5) == 656412311) strcat(s, "D");
if (crc32("EMKvtcpvFQEQoEM",15) == 1647026424) strcat(s, "r");
if (crc32("zORJrjAWsklwd",13) == 2472185470) strcat(s, "s");
if (crc32("iEroKzAynHCwnM",14) == 3064871860) strcat(s, "e");
if (crc32("hyICxplIKnS",11) == 2043286268) strcat(s, "c");
if (crc32("hyNSs",5) == 1539943004) strcat(s, "s");
if (crc32("zCPgaCBGtxsNcBd",15) == 2607498307) strcat(s, "r");
if (crc32("QvTsJRcpWCrxrS",14) == 876903437) strcat(s, "y");
if (crc32("lBVgTi",6) == 2776672732) strcat(s, "m");
if (crc32("RQruov",6) == 1039699945) strcat(s, "b");
if (crc32("BILsLEIcuTcBtpF",15) == 2746030546) strcat(s, "H");
if (crc32("UcXHbdWELJXwwU",14) == 1144685366) strcat(s, "o");
if (crc32("fLSzNGZM",8) == 2404571095) strcat(s, "l");
if (crc32("pcRSEStJ",8) == 368456912) strcat(s, "g");
if (crc32("cwPAMn",6) == 567834058) strcat(s, "i");
if (crc32("RkZQEuagXOA",11) == 1195907089) strcat(s, "z");
if (crc32("NmailchjtqYFna",14) == 2367621009) strcat(s, "i");
if (crc32("tIABeAzDcvzDXyC",15) == 591930461) strcat(s, "i");
if (crc32("QsRIJdrTeScqr",13) == 1119116291) strcat(s, "b");
if (crc32("PMRIGvAfIU",10) == 2186557497) strcat(s, "n");
if (crc32("gSzHZsnaPSoW",12) == 2053769062) strcat(s, "X");
if (crc32("bWdAKVnAydpgvM",14) == 2740750653) strcat(s, "g");
    return s;
}

char *hath_verbs() {
    char *s = calloc(5);
    if (crc32("JFeQaj",6) == 2025174102) strcat(s, "h");
if (crc32("BpMlSDo",7) == 3014329485) strcat(s, "a");
if (crc32("GEJrFSNKFNba",12) == 2168951875) strcat(s, "t");
if (crc32("aVmIo",5) == 1997605725) strcat(s, "s");
if (crc32("PHPZJdFqzKIiYdH",15) == 4047765673) strcat(s, "h");
    return s;
}

char *sited_verbs() {
    char *s = calloc(6);
    if (crc32("mjGSMAnL",8) == 922999408) strcat(s, "k");
if (crc32("iujKVieKStSP",12) == 1369005121) strcat(s, "s");
if (crc32("bvPSvdRqC",9) == 594764045) strcat(s, "i");
if (crc32("cOKca",5) == 3547183456) strcat(s, "t");
if (crc32("quRkjxr",7) == 1053153570) strcat(s, "e");
if (crc32("XaRTNNkKOC",10) == 411426501) strcat(s, "d");
    return s;
}

char *sonnetizing_verbs() {
    char *s = calloc(12);
    if (crc32("ySVehEwxEE",10) == 114415042) strcat(s, "K");
if (crc32("PjUmLdlOIyhL",12) == 3437784753) strcat(s, "s");
if (crc32("WWQGCCqJqwKog",13) == 768565924) strcat(s, "o");
if (crc32("ykQTAWeWBR",10) == 367005672) strcat(s, "n");
if (crc32("BEPrilwFWszq",12) == 3720381997) strcat(s, "P");
if (crc32("YkSGeXRz",8) == 2419658326) strcat(s, "n");
if (crc32("PpCIE",5) == 3235900032) strcat(s, "e");
if (crc32("UMqXRWq",7) == 1659092780) strcat(s, "y");
if (crc32("KfojjrAAVjs",11) == 2447288607) strcat(s, "t");
if (crc32("lSUcOKuNICTjqxw",15) == 2113747398) strcat(s, "w");
if (crc32("oqdclvE",7) == 1540615517) strcat(s, "i");
if (crc32("fQaUhJAe",8) == 2457482363) strcat(s, "z");
if (crc32("nmLflYv",7) == 3792955781) strcat(s, "i");
if (crc32("DYYamiDEKyRLJ",13) == 2539099556) strcat(s, "H");
if (crc32("oVsVOj",6) == 873373883) strcat(s, "n");
if (crc32("ISKZndC",7) == 3782953904) strcat(s, "g");
    return s;
}

char *vary_verbs() {
    char *s = calloc(5);
    if (crc32("CyooNsP",7) == 4003963819) strcat(s, "z");
if (crc32("dXRRoINwogKdnR",14) == 263468455) strcat(s, "v");
if (crc32("gWJQlwffmWBJFiJ",15) == 516642923) strcat(s, "b");
if (crc32("oOpvcZquJFKX",12) == 3478995361) strcat(s, "a");
if (crc32("qMDOxMkJ",8) == 1230657318) strcat(s, "H");
if (crc32("KWYPC",5) == 2312696095) strcat(s, "r");
if (crc32("xULscukHs",9) == 2314499290) strcat(s, "y");
    return s;
}

char *presignify_verbs() {
    char *s = calloc(11);
    if (crc32("UNlUuAcpMwtz",12) == 437297082) strcat(s, "p");
if (crc32("PDLqinTbEf",10) == 3268927264) strcat(s, "r");
if (crc32("YdrhjADhket",11) == 2075726417) strcat(s, "v");
if (crc32("tqcnjeFJZC",10) == 3931337952) strcat(s, "e");
if (crc32("wXYJM",5) == 392078283) strcat(s, "F");
if (crc32("VlKKBlKckrsz",12) == 1542665961) strcat(s, "s");
if (crc32("jLgHMES",7) == 2077343780) strcat(s, "y");
if (crc32("aVnohRwI",8) == 3995999808) strcat(s, "i");
if (crc32("KcbQO",5) == 3456297458) strcat(s, "g");
if (crc32("YgjunICtctR",11) == 4207237527) strcat(s, "n");
if (crc32("iQVOvcic",8) == 1259456701) strcat(s, "i");
if (crc32("mfnsAiq",7) == 4169626407) strcat(s, "m");
if (crc32("MnNkdJqcXHpUXAM",15) == 494046160) strcat(s, "f");
if (crc32("sAdxkibFNoHTr",13) == 3900098704) strcat(s, "y");
    return s;
}

char *clop_verbs() {
    char *s = calloc(5);
    if (crc32("vDLmoxXFoT",10) == 3409778462) strcat(s, "c");
if (crc32("IIxuOLpPl",9) == 3020202309) strcat(s, "Z");
if (crc32("bJBeGnHmXzDYW",13) == 1534927205) strcat(s, "l");
if (crc32("EvAZlBKCcmk",11) == 3529949930) strcat(s, "o");
if (crc32("uRTAfWq",7) == 62582948) strcat(s, "f");
if (crc32("LNozif",6) == 72782796) strcat(s, "p");
    return s;
}

char *pursuing_verbs() {
    char *s = calloc(9);
    if (crc32("kaFVJvH",7) == 2463103437) strcat(s, "p");
if (crc32("HHhIHvNjuKcz",12) == 3023548493) strcat(s, "q");
if (crc32("iMqRWoL",7) == 1640923978) strcat(s, "u");
if (crc32("hbbpOYQlwrmVQ",13) == 2137658376) strcat(s, "T");
if (crc32("jlXGIErphiOVs",13) == 2051398257) strcat(s, "r");
if (crc32("imDie",5) == 1698213338) strcat(s, "s");
if (crc32("zfKPQyxrBuW",11) == 842011065) strcat(s, "B");
if (crc32("fmvhDHGMHGYQv",13) == 2680157674) strcat(s, "u");
if (crc32("qtvAVgdAXJL",11) == 1710576602) strcat(s, "B");
if (crc32("XSVFrZY",7) == 200728525) strcat(s, "i");
if (crc32("UbPIaC",6) == 1838482212) strcat(s, "e");
if (crc32("GEYTJI",6) == 3953841329) strcat(s, "n");
if (crc32("kJrETxP",7) == 504944315) strcat(s, "M");
if (crc32("NuuRPj",6) == 2443696738) strcat(s, "g");
    return s;
}

char *overfeminized_verbs() {
    char *s = calloc(14);
    if (crc32("WKaeVnAG",8) == 3021652803) strcat(s, "j");
if (crc32("SCCjds",6) == 553111139) strcat(s, "o");
if (crc32("TtJDL",5) == 2040407665) strcat(s, "v");
if (crc32("AHmqzTcLHBLgIw",14) == 3262175734) strcat(s, "e");
if (crc32("WiGZWUAQbojcRD",14) == 1082807575) strcat(s, "S");
if (crc32("unhaT",5) == 2060274945) strcat(s, "r");
if (crc32("yeoAKGVdSu",10) == 2341996613) strcat(s, "f");
if (crc32("evLQYoBKGQUD",12) == 4044884090) strcat(s, "g");
if (crc32("KaXNMrgYPu",10) == 866340846) strcat(s, "e");
if (crc32("jAbdXlApj",9) == 1806917799) strcat(s, "V");
if (crc32("ljUbZGsF",8) == 953777740) strcat(s, "m");
if (crc32("IisaUSNQQE",10) == 4196023844) strcat(s, "T");
if (crc32("bCBvOfo",7) == 4051858444) strcat(s, "i");
if (crc32("uUApacUmptEKH",13) == 1029163222) strcat(s, "n");
if (crc32("LIXUDlOp",8) == 2834443672) strcat(s, "i");
if (crc32("yMslHEM",7) == 1525379530) strcat(s, "f");
if (crc32("VBsLza",6) == 2789865988) strcat(s, "z");
if (crc32("sghhoSaxFdif",12) == 2228631482) strcat(s, "e");
if (crc32("YimAnsKqD",9) == 3967627731) strcat(s, "K");
if (crc32("tWTRGkzHGjsCw",13) == 704082921) strcat(s, "d");
    return s;
}

char *somnambulated_verbs() {
    char *s = calloc(14);
    if (crc32("HRXHEAQ",7) == 652456403) strcat(s, "Q");
if (crc32("UeRKKmQDGu",10) == 1678011472) strcat(s, "s");
if (crc32("LejGcCBIZoUJnmX",15) == 3608065394) strcat(s, "o");
if (crc32("eCLfL",5) == 3363948818) strcat(s, "z");
if (crc32("RZWucMFMSRC",11) == 2836901141) strcat(s, "m");
if (crc32("jFaRMyicjIQpAT",14) == 551156973) strcat(s, "Y");
if (crc32("JUOvdrz",7) == 1470413951) strcat(s, "n");
if (crc32("NJUei",5) == 2076393885) strcat(s, "w");
if (crc32("seQPRhfb",8) == 3597250341) strcat(s, "a");
if (crc32("ggPaXoiYzoPn",12) == 444672325) strcat(s, "m");
if (crc32("bkPHVXHEkMKUM",13) == 3203518557) strcat(s, "m");
if (crc32("TJSAaRySlaqR",12) == 2612325394) strcat(s, "b");
if (crc32("DbPkfWJRccSOuXk",15) == 1735984809) strcat(s, "u");
if (crc32("EYKZYv",6) == 611701128) strcat(s, "l");
if (crc32("zjmsMBZbJKzTL",13) == 1628374398) strcat(s, "P");
if (crc32("hAgadCYPT",9) == 973053997) strcat(s, "a");
if (crc32("jEzinl",6) == 1950384555) strcat(s, "t");
if (crc32("kzgzKnW",7) == 1501100904) strcat(s, "q");
if (crc32("NqWCblVwCKaq",12) == 3230356893) strcat(s, "e");
if (crc32("BQroirbyeSHwL",13) == 882837146) strcat(s, "d");
    return s;
}

char *dreamt_verbs() {
    char *s = calloc(7);
    if (crc32("xDIdFKzPGJB",11) == 1126035403) strcat(s, "d");
if (crc32("PmXcDmvUubexFG",14) == 3441291689) strcat(s, "r");
if (crc32("FJmNJUi",7) == 1285367702) strcat(s, "C");
if (crc32("OqrLCkEmcQGr",12) == 2581522145) strcat(s, "e");
if (crc32("yCNIOeHVBja",11) == 29438888) strcat(s, "a");
if (crc32("GGHrhAbAcmRE",12) == 1810977636) strcat(s, "H");
if (crc32("BIyajIRTIFDdQl",14) == 1414012930) strcat(s, "m");
if (crc32("hSejYcoNzK",10) == 3893426321) strcat(s, "m");
if (crc32("ziSmufBBv",9) == 3443486363) strcat(s, "t");
    return s;
}

char *misbehaved_verbs() {
    char *s = calloc(11);
    if (crc32("nuwXTEXKf",9) == 3953154556) strcat(s, "m");
if (crc32("qWUBwVmBjUwI",12) == 1251647118) strcat(s, "F");
if (crc32("ikQDxHvTzMX",11) == 3600277803) strcat(s, "i");
if (crc32("dHRaKeJZGJJFCrP",15) == 2101347096) strcat(s, "s");
if (crc32("uhCoVs",6) == 3253316096) strcat(s, "w");
if (crc32("xwlnPNFLiZVz",12) == 2949912601) strcat(s, "b");
if (crc32("FBzgLM",6) == 1464591234) strcat(s, "e");
if (crc32("FjArbyxeKQkoqu",14) == 2139263976) strcat(s, "k");
if (crc32("AgBjYnqvc",9) == 2569151323) strcat(s, "h");
if (crc32("ifEprGMfLWXks",13) == 2428144029) strcat(s, "x");
if (crc32("XNkPKXBYlAoI",12) == 1616525347) strcat(s, "a");
if (crc32("UcsuHNHiBI",10) == 2594626189) strcat(s, "l");
if (crc32("unBblokRbw",10) == 1849404443) strcat(s, "v");
if (crc32("okQmJwvU",8) == 1594556113) strcat(s, "l");
if (crc32("dJFoxSC",7) == 3691115371) strcat(s, "e");
if (crc32("yorVtlyLHTQo",12) == 2297643087) strcat(s, "S");
if (crc32("wivVxnUUWSC",11) == 2004218109) strcat(s, "d");
    return s;
}

char *scuttling_verbs() {
    char *s = calloc(10);
    if (crc32("vVQbk",5) == 1078058990) strcat(s, "b");
if (crc32("dXjHZDRgCFygtjk",15) == 1787910514) strcat(s, "s");
if (crc32("RKxpqGMXlqSLeXQ",15) == 1091231256) strcat(s, "E");
if (crc32("FoMcTxDyB",9) == 2605880094) strcat(s, "c");
if (crc32("bPWYwfcJ",8) == 745038508) strcat(s, "o");
if (crc32("PUwzxtnJSwFUZd",14) == 3706332828) strcat(s, "u");
if (crc32("RRJbq",5) == 3459036683) strcat(s, "l");
if (crc32("GjoMrtj",7) == 1995591747) strcat(s, "t");
if (crc32("XJREApBxrHu",11) == 2842955547) strcat(s, "C");
if (crc32("qIsPVYmfFUVjG",13) == 1344182862) strcat(s, "t");
if (crc32("XVZTUZ",6) == 1698392323) strcat(s, "l");
if (crc32("CzHNmXvF",8) == 3285815592) strcat(s, "i");
if (crc32("atbawkgnm",9) == 745521954) strcat(s, "J");
if (crc32("aArZwMCdWom",11) == 412972981) strcat(s, "n");
if (crc32("RUhrQiGIOhINwT",14) == 412773138) strcat(s, "g");
    return s;
}

char *smite_verbs() {
    char *s = calloc(6);
    if (crc32("XZtIvt",6) == 469033945) strcat(s, "x");
if (crc32("zbZhoNaFvsd",11) == 173705898) strcat(s, "s");
if (crc32("YodMcOHzn",9) == 3743450579) strcat(s, "p");
if (crc32("wCrIt",5) == 634896710) strcat(s, "m");
if (crc32("VSPNKlO",7) == 1196393444) strcat(s, "i");
if (crc32("BncBEllDPEHrldi",15) == 1191849797) strcat(s, "t");
if (crc32("AXGKndjBVu",10) == 960645758) strcat(s, "C");
if (crc32("upfyfwwXO",9) == 285460786) strcat(s, "e");
    return s;
}

char *horsewhipping_verbs() {
    char *s = calloc(14);
    if (crc32("VQgukMXvAtS",11) == 3317766600) strcat(s, "h");
if (crc32("nRuUF",5) == 2643346398) strcat(s, "q");
if (crc32("AFyuQ",5) == 147471883) strcat(s, "o");
if (crc32("FXedfoUVqLKdRsl",15) == 2797952795) strcat(s, "r");
if (crc32("uCCVHBkXTz",10) == 3827952545) strcat(s, "Q");
if (crc32("wKEqZWyL",8) == 1380461620) strcat(s, "s");
if (crc32("APwSkKrMlGa",11) == 429705238) strcat(s, "G");
if (crc32("XBEnFUlI",8) == 1537357724) strcat(s, "e");
if (crc32("pOovqYEMdmTcop",14) == 553267462) strcat(s, "w");
if (crc32("vjjoYihsPXpHWD",14) == 145526301) strcat(s, "h");
if (crc32("mwVgrxylh",9) == 1155312761) strcat(s, "i");
if (crc32("yjLIowtskPV",11) == 2175436593) strcat(s, "u");
if (crc32("xeXNJOI",7) == 1821824567) strcat(s, "p");
if (crc32("SiDTDYJ",7) == 261992546) strcat(s, "O");
if (crc32("UGFNYJdM",8) == 92192213) strcat(s, "p");
if (crc32("PJErD",5) == 4162872775) strcat(s, "m");
if (crc32("lNCJLj",6) == 741408544) strcat(s, "i");
if (crc32("OTdpqVRSqEWqOze",15) == 1314419296) strcat(s, "n");
if (crc32("XgcUNSmMXpTuyyO",15) == 4229980026) strcat(s, "C");
if (crc32("RiFLcmchNRppE",13) == 3798265951) strcat(s, "g");
    return s;
}

char *reshaving_verbs() {
    char *s = calloc(10);
    if (crc32("aARiRezfqVd",11) == 779638742) strcat(s, "G");
if (crc32("gylcbPMcD",9) == 3233718764) strcat(s, "r");
if (crc32("cmDnyUqXTnKRv",13) == 323320502) strcat(s, "e");
if (crc32("nXTkDEiruwWodNT",15) == 4037786433) strcat(s, "s");
if (crc32("GaSgEihYlyx",11) == 4232148930) strcat(s, "h");
if (crc32("wIwbjgsmMmw",11) == 4081362242) strcat(s, "a");
if (crc32("pryJJILzJSYD",12) == 909762509) strcat(s, "w");
if (crc32("HrTHd",5) == 1985833634) strcat(s, "v");
if (crc32("WuLEbtiBUgrWKD",14) == 2376876377) strcat(s, "j");
if (crc32("aDAzHfO",7) == 3996691724) strcat(s, "i");
if (crc32("DTNbXGFZJlUkbNY",15) == 1224983282) strcat(s, "n");
if (crc32("XAsFNd",6) == 1907910706) strcat(s, "p");
if (crc32("DBftSIAYzF",10) == 1599055606) strcat(s, "g");
    return s;
}

char *redeposit_verbs() {
    char *s = calloc(10);
    if (crc32("YIbqgkQdink",11) == 1103081266) strcat(s, "r");
if (crc32("REVDRW",6) == 2229293445) strcat(s, "r");
if (crc32("IKmaaGzstYZjOr",14) == 1976562912) strcat(s, "j");
if (crc32("ABLYkbUrTsQbqL",14) == 2200230414) strcat(s, "e");
if (crc32("EhDRsrBM",8) == 1788005758) strcat(s, "H");
if (crc32("NIcozGdnqvVHUH",14) == 2954451243) strcat(s, "d");
if (crc32("lkdKIZLyinr",11) == 2566366068) strcat(s, "e");
if (crc32("ZhgOZMF",7) == 2907207949) strcat(s, "p");
if (crc32("YLPynPkRma",10) == 3522116800) strcat(s, "o");
if (crc32("OyAQMVHNtDhld",13) == 1311723044) strcat(s, "s");
if (crc32("zSViDVQsRW",10) == 3209151677) strcat(s, "i");
if (crc32("MddPqGTck",9) == 3547763101) strcat(s, "t");
    return s;
}

char *urged_verbs() {
    char *s = calloc(6);
    if (crc32("ULMbIzmI",8) == 3411154614) strcat(s, "u");
if (crc32("dNHsZhrLQGIWx",13) == 1499016523) strcat(s, "r");
if (crc32("WseYqiu",7) == 597013971) strcat(s, "k");
if (crc32("TodNOrkSVGBMMK",14) == 2586830795) strcat(s, "g");
if (crc32("ZakukodhaN",10) == 1395030985) strcat(s, "e");
if (crc32("LxWLzoFercvMcOU",15) == 1305692595) strcat(s, "r");
if (crc32("UlTwUpi",7) == 3656018736) strcat(s, "d");
    return s;
}

char *compromised_verbs() {
    char *s = calloc(12);
    if (crc32("gtkAF",5) == 1517399206) strcat(s, "j");
if (crc32("MgbHgEMidFL",11) == 2899558774) strcat(s, "c");
if (crc32("agmANsRZPu",10) == 3258920224) strcat(s, "b");
if (crc32("DrNMiDq",7) == 292454162) strcat(s, "o");
if (crc32("AmMkYRxJpwx",11) == 235578765) strcat(s, "F");
if (crc32("ySJkvsGHEZU",11) == 3784303838) strcat(s, "m");
if (crc32("XnPUObZVlxPHY",13) == 3228085105) strcat(s, "p");
if (crc32("VPClrrQSIZfJZb",14) == 3217104070) strcat(s, "a");
if (crc32("HGdsBAfmvb",10) == 4272804141) strcat(s, "r");
if (crc32("PZezGdqmbSVFpV",14) == 2605653503) strcat(s, "Q");
if (crc32("mIZnglawGpWblu",14) == 2812895946) strcat(s, "o");
if (crc32("xARCdVVEEv",10) == 628368954) strcat(s, "m");
if (crc32("UtsArbY",7) == 2462845528) strcat(s, "V");
if (crc32("phOEH",5) == 1336766497) strcat(s, "i");
if (crc32("OndSTConelcgI",13) == 476639500) strcat(s, "O");
if (crc32("DuknZuIt",8) == 2999836243) strcat(s, "s");
if (crc32("Ijfabhg",7) == 1171905401) strcat(s, "e");
if (crc32("RNotUbGCpD",10) == 1592335125) strcat(s, "H");
if (crc32("gFqRnRwjWcjmepb",15) == 3663525721) strcat(s, "d");
    return s;
}

char *realter_verbs() {
    char *s = calloc(8);
    if (crc32("peHFAgZAtdEjBU",14) == 2210353154) strcat(s, "r");
if (crc32("EFriAHpiVnztjS",14) == 2326949133) strcat(s, "e");
if (crc32("AOQnHWaV",8) == 3386515404) strcat(s, "v");
if (crc32("wGMcj",5) == 283510263) strcat(s, "a");
if (crc32("xcrWHjUkNwkAUIJ",15) == 1902635893) strcat(s, "l");
if (crc32("pAIfjiETQR",10) == 1476107484) strcat(s, "T");
if (crc32("bstBwUowLt",10) == 3686001023) strcat(s, "t");
if (crc32("YusqlXjjCqSbmRw",15) == 3702275424) strcat(s, "e");
if (crc32("lpuNIjH",7) == 927662341) strcat(s, "F");
if (crc32("qJNwTrwImF",10) == 1982273368) strcat(s, "r");
    return s;
}

char *restructuring_verbs() {
    char *s = calloc(14);
    if (crc32("UmKqIMOjN",9) == 1518192005) strcat(s, "r");
if (crc32("UgupoIkBumRBxQ",14) == 2622338479) strcat(s, "e");
if (crc32("LBpvplNcK",9) == 3657217816) strcat(s, "s");
if (crc32("ALMJAWbJNb",10) == 527103318) strcat(s, "X");
if (crc32("AlarsKW",7) == 3581402344) strcat(s, "t");
if (crc32("QGIOANaqYHEiF",13) == 3623788495) strcat(s, "O");
if (crc32("xdDIQZSlsDla",12) == 1777024230) strcat(s, "r");
if (crc32("AxDva",5) == 2993957002) strcat(s, "Y");
if (crc32("dXdNo",5) == 1476426851) strcat(s, "u");
if (crc32("UJyzOuxIGbvhDT",14) == 706780765) strcat(s, "c");
if (crc32("KqWWQtseexUodG",14) == 1713167770) strcat(s, "t");
if (crc32("DoqCiVVHDlSxpb",14) == 5549376) strcat(s, "f");
if (crc32("QiRxriCXi",9) == 3998464806) strcat(s, "u");
if (crc32("flHrcQq",7) == 1840925401) strcat(s, "r");
if (crc32("olelhtLBwO",10) == 1628965718) strcat(s, "i");
if (crc32("AxcvKmpz",8) == 882216278) strcat(s, "n");
if (crc32("DBhbvXPbgely",12) == 3946069815) strcat(s, "g");
    return s;
}

char *reinflame_verbs() {
    char *s = calloc(10);
    if (crc32("QBNQVhnA",8) == 3037645316) strcat(s, "d");
if (crc32("bQeXofoLUQcZZG",14) == 638131294) strcat(s, "r");
if (crc32("MJRwijI",7) == 1968991477) strcat(s, "e");
if (crc32("YvYgmOnnSVDRIr",14) == 3141446439) strcat(s, "O");
if (crc32("twCicUQUtKgl",12) == 3763326864) strcat(s, "i");
if (crc32("YumZIwf",7) == 238562881) strcat(s, "n");
if (crc32("MZTXHYiEuu",10) == 984919931) strcat(s, "f");
if (crc32("JaodNhCyt",9) == 3662635827) strcat(s, "p");
if (crc32("UQPdRXkLivss",12) == 4259512341) strcat(s, "l");
if (crc32("SUQmf",5) == 829278897) strcat(s, "a");
if (crc32("enrTgqkWYK",10) == 2817156754) strcat(s, "a");
if (crc32("LwfxH",5) == 3456150601) strcat(s, "J");
if (crc32("LwrnVFtiC",9) == 806219486) strcat(s, "m");
if (crc32("aDehWWM",7) == 1544659742) strcat(s, "k");
if (crc32("GKDWVJnHJaPEsF",14) == 2889367865) strcat(s, "e");
    return s;
}

char *burring_verbs() {
    char *s = calloc(8);
    if (crc32("dhWxHyODYjUe",12) == 383204818) strcat(s, "X");
if (crc32("ohfzOJyEHBMN",12) == 663059186) strcat(s, "b");
if (crc32("SdpQsGXeea",10) == 2620124570) strcat(s, "u");
if (crc32("BOawCQbejqXJd",13) == 2631368544) strcat(s, "i");
if (crc32("vVxfktmfKh",10) == 903153873) strcat(s, "r");
if (crc32("DUHXOlLlemRTF",13) == 3706476147) strcat(s, "r");
if (crc32("DBSZLtWuktlSBX",14) == 2607140272) strcat(s, "i");
if (crc32("JNpPflEtl",9) == 1874887112) strcat(s, "n");
if (crc32("ZNjMBQQfNZluEaM",15) == 1048593458) strcat(s, "g");
    return s;
}

char *lit_verbs() {
    char *s = calloc(4);
    if (crc32("IvWLBZCUCzyhcI",14) == 3961198651) strcat(s, "m");
if (crc32("QcTKvwTrKM",10) == 3651254773) strcat(s, "l");
if (crc32("BBkoqiZG",8) == 2553689879) strcat(s, "i");
if (crc32("ZBbLYTZojDeo",12) == 462153351) strcat(s, "a");
if (crc32("uNZwRxLDG",9) == 417199909) strcat(s, "t");
    return s;
}

char *trekking_verbs() {
    char *s = calloc(9);
    if (crc32("ztLwlSSQOj",10) == 4053562672) strcat(s, "s");
if (crc32("VLElupebbbE",11) == 65676437) strcat(s, "t");
if (crc32("imyHHWqBsbuvH",13) == 387614623) strcat(s, "i");
if (crc32("qIuzr",5) == 3714908674) strcat(s, "r");
if (crc32("WSoxMVYMXxM",11) == 3122455426) strcat(s, "e");
if (crc32("BeiMtyLwyZugTI",14) == 2699571136) strcat(s, "k");
if (crc32("nlrIRsdOeIbS",12) == 1689250741) strcat(s, "E");
if (crc32("MTRJcjuJR",9) == 1441921856) strcat(s, "k");
if (crc32("APwcbVOrbHdWWP",14) == 3438703542) strcat(s, "W");
if (crc32("EquseRuLLthEadR",15) == 785764019) strcat(s, "i");
if (crc32("ZVojNjuVWA",10) == 3076302004) strcat(s, "q");
if (crc32("SkYDCAid",8) == 3083989358) strcat(s, "n");
if (crc32("lEayGehqOy",10) == 3806719143) strcat(s, "Y");
if (crc32("otzTFgogniNl",12) == 1685029368) strcat(s, "g");
    return s;
}

char *gangrening_verbs() {
    char *s = calloc(11);
    if (crc32("UpJMcYJtp",9) == 804076271) strcat(s, "g");
if (crc32("efPvCSkVx",9) == 2653676659) strcat(s, "j");
if (crc32("VTXqiMGoUuUG",12) == 1328929639) strcat(s, "a");
if (crc32("NHUwAvQSwSNwo",13) == 2589937080) strcat(s, "n");
if (crc32("xalPBfOL",8) == 96431010) strcat(s, "g");
if (crc32("eEgHxhf",7) == 1037230150) strcat(s, "r");
if (crc32("pFMyZzHGAFD",11) == 3466657494) strcat(s, "p");
if (crc32("egEEVYsXWmDiGb",14) == 3260640393) strcat(s, "e");
if (crc32("pADsD",5) == 510173738) strcat(s, "n");
if (crc32("jQnvKFzqynt",11) == 833112647) strcat(s, "J");
if (crc32("UOTGOgbdO",9) == 994433640) strcat(s, "i");
if (crc32("cALNyrMRxl",10) == 1927230838) strcat(s, "a");
if (crc32("DUrFDwpJYHS",11) == 1631277645) strcat(s, "n");
if (crc32("apGEKgVP",8) == 2437081909) strcat(s, "g");
    return s;
}

char *reice_verbs() {
    char *s = calloc(6);
    if (crc32("wvZHiptJ",8) == 3593754750) strcat(s, "Z");
if (crc32("mnqcLKHL",8) == 24036176) strcat(s, "r");
if (crc32("tuPGUYdiQbHp",12) == 746627293) strcat(s, "e");
if (crc32("fVzQyTzNarCMnt",14) == 194320504) strcat(s, "u");
if (crc32("olATDyIxFDdV",12) == 1522310359) strcat(s, "i");
if (crc32("wyRyU",5) == 287553998) strcat(s, "c");
if (crc32("lijWQqRzIqh",11) == 18818327) strcat(s, "z");
if (crc32("UUBNFGdQN",9) == 2309377130) strcat(s, "e");
    return s;
}

char *crave_verbs() {
    char *s = calloc(6);
    if (crc32("hibnC",5) == 1991653973) strcat(s, "c");
if (crc32("lpHapIiqxq",10) == 3802475396) strcat(s, "B");
if (crc32("KYtzxguwAzRNoXs",15) == 485670810) strcat(s, "r");
if (crc32("dMRmjfUFkYJ",11) == 1487197903) strcat(s, "S");
if (crc32("OsPkof",6) == 948247395) strcat(s, "a");
if (crc32("JzlGweHP",8) == 3955081286) strcat(s, "v");
if (crc32("EVozzshgx",9) == 3461141478) strcat(s, "e");
    return s;
}

char *pictured_verbs() {
    char *s = calloc(9);
    if (crc32("OXnoXbjTm",9) == 1913834237) strcat(s, "p");
if (crc32("yamerGL",7) == 2496819970) strcat(s, "U");
if (crc32("hIwSlPfYeM",10) == 3452038600) strcat(s, "i");
if (crc32("wfFGsiEnYfIYB",13) == 1889727823) strcat(s, "r");
if (crc32("nYydmgSIG",9) == 3003036177) strcat(s, "c");
if (crc32("JIKrZUrn",8) == 2477075536) strcat(s, "t");
if (crc32("OjqwfJLfnW",10) == 1396981260) strcat(s, "u");
if (crc32("xeUAfmmxEaciGuM",15) == 2942184811) strcat(s, "W");
if (crc32("tsVSKpHEONBbLUd",15) == 3908968090) strcat(s, "r");
if (crc32("pdnuPazDh",9) == 4160619440) strcat(s, "e");
if (crc32("pOlvBRpZraS",11) == 1535118621) strcat(s, "H");
if (crc32("edTMScWn",8) == 2037751200) strcat(s, "d");
    return s;
}

char *tap_verbs() {
    char *s = calloc(4);
    if (crc32("rffBdpjioQdyHFC",15) == 2552474933) strcat(s, "t");
if (crc32("aglWXddACKtCpg",14) == 123660784) strcat(s, "b");
if (crc32("BvQYOCwaks",10) == 3289934704) strcat(s, "a");
if (crc32("hRCkePikDuBU",12) == 992454957) strcat(s, "p");
    return s;
}

char *muster_verbs() {
    char *s = calloc(7);
    if (crc32("ElzeqPtAX",9) == 905729869) strcat(s, "m");
if (crc32("jqAqIZDkG",9) == 3192591401) strcat(s, "W");
if (crc32("JQJpQPRRotjFFhz",15) == 3245069264) strcat(s, "u");
if (crc32("VfVVBfIMbTqGY",13) == 2665587494) strcat(s, "s");
if (crc32("WBnmVuYOmxI",11) == 2678138762) strcat(s, "E");
if (crc32("IfuWocs",7) == 837668808) strcat(s, "t");
if (crc32("EDQOsnEsvOrCjIQ",15) == 1049526917) strcat(s, "Z");
if (crc32("wAjlajy",7) == 755705063) strcat(s, "e");
if (crc32("kuyFgnSIANWEHWb",15) == 3496297646) strcat(s, "t");
if (crc32("EErEezZK",8) == 810677692) strcat(s, "r");
    return s;
}

char *hyperbolize_verbs() {
    char *s = calloc(12);
    if (crc32("brfcuuUmqX",10) == 3822439375) strcat(s, "a");
if (crc32("QxrZccubxCeABBQ",15) == 1735635034) strcat(s, "h");
if (crc32("ZRFJckHsO",9) == 4151168381) strcat(s, "H");
if (crc32("QtDCrllyN",9) == 1308921889) strcat(s, "y");
if (crc32("HekHiR",6) == 1027364561) strcat(s, "u");
if (crc32("yzISAFD",7) == 1689547944) strcat(s, "p");
if (crc32("nTyOl",5) == 2247266743) strcat(s, "m");
if (crc32("avCNtKsX",8) == 1642373806) strcat(s, "e");
if (crc32("GWWCJpZw",8) == 3453315538) strcat(s, "Y");
if (crc32("YgUHATujLfuLQ",13) == 3343591201) strcat(s, "r");
if (crc32("pySEam",6) == 753603852) strcat(s, "M");
if (crc32("gycyBmXYnNECLm",14) == 3160409037) strcat(s, "b");
if (crc32("CtWkU",5) == 3386363245) strcat(s, "o");
if (crc32("RAJEIqhmJvivlyR",15) == 3348153856) strcat(s, "l");
if (crc32("YwekwgpQ",8) == 3845675652) strcat(s, "A");
if (crc32("yzxhpkcBsf",10) == 1413063502) strcat(s, "i");
if (crc32("sarFoBR",7) == 3129535547) strcat(s, "z");
if (crc32("BtPMxwlNifQxk",13) == 2821623646) strcat(s, "e");
    return s;
}

char *focalize_verbs() {
    char *s = calloc(9);
    if (crc32("iiFeJLIq",8) == 3085632920) strcat(s, "f");
if (crc32("CZJcaRWz",8) == 2341884528) strcat(s, "D");
if (crc32("NGWFsxugacKhP",13) == 3837680535) strcat(s, "o");
if (crc32("omDloNl",7) == 185877725) strcat(s, "z");
if (crc32("JJFuvFCMAV",10) == 3763167888) strcat(s, "c");
if (crc32("AOTtaFCSsLAOlLp",15) == 758352035) strcat(s, "a");
if (crc32("XrOlwmgdnTC",11) == 2895246962) strcat(s, "l");
if (crc32("kGOXzW",6) == 3089479723) strcat(s, "i");
if (crc32("kayBWYAckaUXa",13) == 889701227) strcat(s, "z");
if (crc32("XkgutGnTwHgYT",13) == 2632658963) strcat(s, "A");
if (crc32("nSZuMRWmO",9) == 3958356537) strcat(s, "e");
    return s;
}

char *redriven_verbs() {
    char *s = calloc(9);
    if (crc32("hRLkUqke",8) == 4220454392) strcat(s, "E");
if (crc32("cMWibtXOnpVaDS",14) == 4264126314) strcat(s, "r");
if (crc32("QCotUwjNDoE",11) == 2730074578) strcat(s, "E");
if (crc32("okDZflnmi",9) == 888503463) strcat(s, "e");
if (crc32("cXrOXaQMzBjXKS",14) == 829042684) strcat(s, "h");
if (crc32("KuxvMVlfINrPrhT",15) == 3105676829) strcat(s, "d");
if (crc32("EQcVlRJix",9) == 555966655) strcat(s, "r");
if (crc32("dsDpCRIFtFnCL",13) == 2934369952) strcat(s, "i");
if (crc32("ZosiYQNkdDa",11) == 2085098502) strcat(s, "K");
if (crc32("zDkcm",5) == 1483194713) strcat(s, "v");
if (crc32("VFRsofpDUBAIM",13) == 2134347410) strcat(s, "g");
if (crc32("qyccMFdkEnUfvcx",15) == 1221525660) strcat(s, "e");
if (crc32("iYizn",5) == 3705245573) strcat(s, "n");
    return s;
}

char *objectify_verbs() {
    char *s = calloc(10);
    if (crc32("wTKoXzaUvMqH",12) == 2395382677) strcat(s, "M");
if (crc32("syBzAEx",7) == 3908609961) strcat(s, "o");
if (crc32("BjSSPaRpR",9) == 2978670194) strcat(s, "b");
if (crc32("dBYLFBIIMt",10) == 1929041872) strcat(s, "j");
if (crc32("JgyRwc",6) == 4191807983) strcat(s, "e");
if (crc32("OZCvDOkNDikwCtK",15) == 3813368002) strcat(s, "d");
if (crc32("cGgxwpr",7) == 1887209423) strcat(s, "c");
if (crc32("MxdUaGVaW",9) == 2761261131) strcat(s, "X");
if (crc32("zVkmdLuI",8) == 2343215790) strcat(s, "t");
if (crc32("DygvjnZjolLReho",15) == 1885483499) strcat(s, "i");
if (crc32("vwIuHqcmfdk",11) == 3370908621) strcat(s, "f");
if (crc32("hIoNOtweWzYU",12) == 513344605) strcat(s, "y");
    return s;
}

char *kill_verbs() {
    char *s = calloc(5);
    if (crc32("wiyUQHDkQCU",11) == 4008285324) strcat(s, "H");
if (crc32("qMJQNrhaX",9) == 3985076966) strcat(s, "k");
if (crc32("TouzoremebF",11) == 1471632159) strcat(s, "V");
if (crc32("olfPKjcQl",9) == 3505574951) strcat(s, "i");
if (crc32("QUyWQhbzuczLAY",14) == 4285362242) strcat(s, "l");
if (crc32("CCYMh",5) == 889450314) strcat(s, "l");
    return s;
}

char *dimpled_verbs() {
    char *s = calloc(8);
    if (crc32("lSBYC",5) == 1680692784) strcat(s, "A");
if (crc32("vXCUXdT",7) == 514927034) strcat(s, "d");
if (crc32("QGKGMP",6) == 3202861156) strcat(s, "r");
if (crc32("ONptszgKiZutIQX",15) == 1265349955) strcat(s, "i");
if (crc32("BuLeKy",6) == 1743443043) strcat(s, "m");
if (crc32("BkswJvaEQenCuNM",15) == 661841154) strcat(s, "I");
if (crc32("RgxjpfeSEekOwv",14) == 3889910049) strcat(s, "p");
if (crc32("GKtNWcoMblbc",12) == 3428532759) strcat(s, "l");
if (crc32("xjZbmoe",7) == 2545565472) strcat(s, "e");
if (crc32("lPmmHr",6) == 4178510841) strcat(s, "d");
    return s;
}

char *solvate_verbs() {
    char *s = calloc(8);
    if (crc32("cZpuNRjIHaYEt",13) == 3499336389) strcat(s, "s");
if (crc32("JfwypcSZAnUbi",13) == 3146353477) strcat(s, "L");
if (crc32("cSgBZhUXnAZ",11) == 519383519) strcat(s, "o");
if (crc32("OCEDIrPbDk",10) == 1994587458) strcat(s, "G");
if (crc32("ohYGfopgqeYAD",13) == 2615355691) strcat(s, "l");
if (crc32("SfOgdttKBdI",11) == 1604692897) strcat(s, "v");
if (crc32("lbJLKeqAcIlL",12) == 124091059) strcat(s, "a");
if (crc32("LYejHviielqzyl",14) == 3294306631) strcat(s, "Q");
if (crc32("yVaXzJo",7) == 442363420) strcat(s, "t");
if (crc32("ocHkhdXboOCne",13) == 2702390495) strcat(s, "a");
if (crc32("mdxiAhlc",8) == 1526278636) strcat(s, "e");
    return s;
}

char *overbborne_verbs() {
    char *s = calloc(11);
    if (crc32("QhWxItjSwzQylT",14) == 1777804811) strcat(s, "k");
if (crc32("psZFJLCZKnlCU",13) == 2010899354) strcat(s, "o");
if (crc32("vQRAZspozrrcdW",14) == 157776629) strcat(s, "b");
if (crc32("hvFjwptVHl",10) == 2097815149) strcat(s, "v");
if (crc32("VcNDMlZkEPmqb",13) == 3562099613) strcat(s, "Q");
if (crc32("ymdLktYqQAj",11) == 1672862302) strcat(s, "e");
if (crc32("OGDgmVAML",9) == 3538807048) strcat(s, "v");
if (crc32("eueJeUGylhAr",12) == 1460079033) strcat(s, "r");
if (crc32("aYHyfUx",7) == 1388287673) strcat(s, "S");
if (crc32("zUqbzyN",7) == 3931470854) strcat(s, "b");
if (crc32("nLcTzlUPrBLaTxQ",15) == 2464329091) strcat(s, "b");
if (crc32("pJsJtzDw",8) == 1370746778) strcat(s, "o");
if (crc32("vIFaIhxJP",9) == 662684108) strcat(s, "r");
if (crc32("rELWPrDhuZsOE",13) == 1161456407) strcat(s, "w");
if (crc32("cqCzEAFPjjxaI",13) == 1494841608) strcat(s, "n");
if (crc32("GCMaotQnXQWDS",13) == 3276049494) strcat(s, "e");
    return s;
}

char *breakdown_verbs() {
    char *s = calloc(10);
    if (crc32("XsMywRUvONQ",11) == 4147702859) strcat(s, "b");
if (crc32("tiLUiW",6) == 1339483183) strcat(s, "r");
if (crc32("VMWnbBJNMUJePs",14) == 3969476526) strcat(s, "u");
if (crc32("sfkrbGlugfsYr",13) == 3200393290) strcat(s, "e");
if (crc32("pGqAmSPc",8) == 612726802) strcat(s, "a");
if (crc32("adXhM",5) == 299002430) strcat(s, "k");
if (crc32("PkQMqSnbU",9) == 722213203) strcat(s, "a");
if (crc32("rvJATlP",7) == 3281878051) strcat(s, "d");
if (crc32("rexbGSYCU",9) == 2864703912) strcat(s, "o");
if (crc32("rXdirWiSoGoHbRB",15) == 2976413771) strcat(s, "w");
if (crc32("aXvyV",5) == 3520176218) strcat(s, "G");
if (crc32("nXJpAr",6) == 2087646686) strcat(s, "n");
    return s;
}

char *affirm_verbs() {
    char *s = calloc(7);
    if (crc32("axvWQbtsMKC",11) == 2173000063) strcat(s, "D");
if (crc32("IiDKwrYn",8) == 2530910434) strcat(s, "a");
if (crc32("RZJSrvQXGMQ",11) == 4099840947) strcat(s, "f");
if (crc32("AcQOH",5) == 2020276368) strcat(s, "u");
if (crc32("zMjeKEJrbAlk",12) == 3289379204) strcat(s, "f");
if (crc32("EJsdsGWs",8) == 898230295) strcat(s, "i");
if (crc32("JxiPEbBP",8) == 1977715021) strcat(s, "k");
if (crc32("TjQeDracKNR",11) == 1949875163) strcat(s, "r");
if (crc32("GHXTvHdSQiwgD",13) == 1319838538) strcat(s, "m");
    return s;
}

char *caprioled_verbs() {
    char *s = calloc(10);
    if (crc32("DCWYe",5) == 3072435438) strcat(s, "i");
if (crc32("yhctphEHOVKgM",13) == 1183934541) strcat(s, "c");
if (crc32("AAgkkdjXL",9) == 116786857) strcat(s, "V");
if (crc32("TUaqfTOQ",8) == 3704417758) strcat(s, "a");
if (crc32("lMHnG",5) == 3015153738) strcat(s, "q");
if (crc32("glLXduSaPOr",11) == 448754266) strcat(s, "p");
if (crc32("LVJgTugs",8) == 723630521) strcat(s, "r");
if (crc32("VradroRjak",10) == 891787846) strcat(s, "i");
if (crc32("WLPpmGGCtNkZ",12) == 4067541006) strcat(s, "o");
if (crc32("vcgELBn",7) == 3045032243) strcat(s, "j");
if (crc32("vpdpXZltNorQjh",14) == 541817339) strcat(s, "l");
if (crc32("afaFnYBialudB",13) == 1038067111) strcat(s, "X");
if (crc32("FywsZgxp",8) == 96376380) strcat(s, "e");
if (crc32("lcKtupERIcJq",12) == 4182972086) strcat(s, "V");
if (crc32("nXsWEHzybIYNYKf",15) == 1903614554) strcat(s, "d");
    return s;
}

char *precirculate_verbs() {
    char *s = calloc(13);
    if (crc32("FtEsFXBsYe",10) == 2180371321) strcat(s, "p");
if (crc32("eoQczTORVxzyjSH",15) == 3814279918) strcat(s, "r");
if (crc32("LLUtQ",5) == 3081475099) strcat(s, "e");
if (crc32("dCXUFenIl",9) == 3889161099) strcat(s, "Y");
if (crc32("khwsXhayDgv",11) == 3471723266) strcat(s, "c");
if (crc32("mKXfgoLdDjcVV",13) == 103625586) strcat(s, "D");
if (crc32("WdrDZPHEQqA",11) == 2221900474) strcat(s, "i");
if (crc32("WVXbeTpjbNbCnA",14) == 680713487) strcat(s, "r");
if (crc32("tbSnvQfeVITKb",13) == 3213082330) strcat(s, "c");
if (crc32("MraKIlKTqyJKaN",14) == 2432922744) strcat(s, "u");
if (crc32("TsimPlsyDsnYoPh",15) == 2757458475) strcat(s, "l");
if (crc32("IkuPLDwwi",9) == 1712686763) strcat(s, "J");
if (crc32("qiZVhyLqNWhJbSd",15) == 3660931685) strcat(s, "a");
if (crc32("gSXswr",6) == 1576740159) strcat(s, "t");
if (crc32("ccYQkpCO",8) == 705415576) strcat(s, "e");
    return s;
}

char *nidnod_verbs() {
    char *s = calloc(7);
    if (crc32("GtGCUcLEIjU",11) == 833404294) strcat(s, "D");
if (crc32("FivfCYMPCl",10) == 619348795) strcat(s, "n");
if (crc32("rLEJDC",6) == 3224142355) strcat(s, "i");
if (crc32("yFkuFaZxKhNG",12) == 1128394467) strcat(s, "o");
if (crc32("VooVcbjxx",9) == 4201004976) strcat(s, "d");
if (crc32("JGYdgxkFFqPH",12) == 2208635990) strcat(s, "n");
if (crc32("PTpUDGiAnIS",11) == 2492562001) strcat(s, "S");
if (crc32("iMwQKpXezHxijWu",15) == 2473523401) strcat(s, "o");
if (crc32("yUJUpPb",7) == 3923975899) strcat(s, "M");
if (crc32("SVQynowUTuGz",12) == 3977986533) strcat(s, "d");
    return s;
}

char *fill_verbs() {
    char *s = calloc(5);
    if (crc32("COFxmWai",8) == 307543124) strcat(s, "d");
if (crc32("hNjgJxySJSo",11) == 157724219) strcat(s, "f");
if (crc32("qrznrfmcVGlar",13) == 3987010239) strcat(s, "i");
if (crc32("ALGwGKXeNpNC",12) == 2662050098) strcat(s, "l");
if (crc32("DmGFcYLFNbOKo",13) == 518910328) strcat(s, "l");
    return s;
}

char *funneled_verbs() {
    char *s = calloc(9);
    if (crc32("fqmrvRYnsfRKr",13) == 612090120) strcat(s, "Z");
if (crc32("mcmpB",5) == 2045844789) strcat(s, "f");
if (crc32("tiFHXnNctoxpjB",14) == 3599468865) strcat(s, "u");
if (crc32("aFdEzNQNacXZVU",14) == 2927724908) strcat(s, "n");
if (crc32("uyFFtYb",7) == 3391508887) strcat(s, "k");
if (crc32("QBGkIPlFg",9) == 2714840003) strcat(s, "n");
if (crc32("aPsXs",5) == 1151633297) strcat(s, "e");
if (crc32("oHJPEmptR",9) == 2965814750) strcat(s, "l");
if (crc32("mEwtG",5) == 4179622650) strcat(s, "e");
if (crc32("ayoqOE",6) == 3247045637) strcat(s, "d");
    return s;
}

char *scrupling_verbs() {
    char *s = calloc(10);
    if (crc32("KSbQUfKeI",9) == 2156604843) strcat(s, "i");
if (crc32("LAoztYdnCKP",11) == 4130381166) strcat(s, "s");
if (crc32("cCQFOnkfJRfK",12) == 1709509044) strcat(s, "d");
if (crc32("QKLfJYQuD",9) == 1074798615) strcat(s, "c");
if (crc32("KqvypOfocBfdNk",14) == 891939546) strcat(s, "R");
if (crc32("FBFODZZoZPnCwUY",15) == 1187463861) strcat(s, "r");
if (crc32("VFRxQbedMnUSN",13) == 709737520) strcat(s, "M");
if (crc32("DuBjnIcKm",9) == 1362997748) strcat(s, "u");
if (crc32("PeJCJzKc",8) == 853784461) strcat(s, "p");
if (crc32("OSbBnFA",7) == 2411763537) strcat(s, "u");
if (crc32("UBxKuVb",7) == 918656550) strcat(s, "l");
if (crc32("KCvvZiuCStah",12) == 651914848) strcat(s, "i");
if (crc32("EXGkNE",6) == 1888869365) strcat(s, "W");
if (crc32("fALhFcz",7) == 1485325560) strcat(s, "n");
if (crc32("pFeLxLWkFNm",11) == 2250260015) strcat(s, "g");
    return s;
}

char *frizzling_verbs() {
    char *s = calloc(10);
    if (crc32("PyblGKAa",8) == 3055906860) strcat(s, "b");
if (crc32("vkoRmmhYU",9) == 1255916080) strcat(s, "f");
if (crc32("vIHkb",5) == 3357550487) strcat(s, "z");
if (crc32("YzdGxByIjWVOJC",14) == 681790110) strcat(s, "r");
if (crc32("AclStVVdVYR",11) == 2575526368) strcat(s, "q");
if (crc32("YyFYUVByVGk",11) == 396268714) strcat(s, "i");
if (crc32("cBdjOIznnBeWv",13) == 3027178363) strcat(s, "r");
if (crc32("VDzOzc",6) == 3091832667) strcat(s, "z");
if (crc32("VxnvBdyjhTThz",13) == 2459858521) strcat(s, "z");
if (crc32("EybTdYEZg",9) == 3331369740) strcat(s, "D");
if (crc32("Nppgjclxug",10) == 2892650225) strcat(s, "l");
if (crc32("PSQWP",5) == 3563472506) strcat(s, "i");
if (crc32("xTdoolkOaewKAVg",15) == 3593706818) strcat(s, "e");
if (crc32("MLEwNUJ",7) == 2366697369) strcat(s, "n");
if (crc32("SYtfhkJniRGiit",14) == 730581329) strcat(s, "g");
    return s;
}

char *crayoned_verbs() {
    char *s = calloc(9);
    if (crc32("PpHBJkfDOJvO",12) == 2815145149) strcat(s, "c");
if (crc32("yNBCGGhdNhjUA",13) == 511509541) strcat(s, "W");
if (crc32("PkTWHFNTuyAV",12) == 3680408938) strcat(s, "r");
if (crc32("eNMMVqZWVrzOK",13) == 774009750) strcat(s, "D");
if (crc32("PlNCTV",6) == 3024503582) strcat(s, "a");
if (crc32("UZfIIPgurgk",11) == 1432646873) strcat(s, "T");
if (crc32("AFBRpFzkh",9) == 2305512578) strcat(s, "y");
if (crc32("SOlsHyA",7) == 3585633810) strcat(s, "o");
if (crc32("iXXSBQvBrlmbMYK",15) == 3643488374) strcat(s, "n");
if (crc32("uTguzSltuNOM",12) == 332247894) strcat(s, "J");
if (crc32("PPtLkuPn",8) == 2966287413) strcat(s, "e");
if (crc32("XxtUiDGnyL",10) == 475037644) strcat(s, "d");
    return s;
}

char *brutalize_verbs() {
    char *s = calloc(10);
    if (crc32("IUJIOvb",7) == 482328980) strcat(s, "y");
if (crc32("iyvVoJZow",9) == 1381877573) strcat(s, "b");
if (crc32("qxyWVWZOGqYBHT",14) == 2610893654) strcat(s, "U");
if (crc32("WbNWGMonK",9) == 3172859689) strcat(s, "r");
if (crc32("xVxtCaza",8) == 2540721569) strcat(s, "V");
if (crc32("xEpAltTw",8) == 1353418578) strcat(s, "u");
if (crc32("hESembTPmN",10) == 3404820742) strcat(s, "v");
if (crc32("mEqKZFMUxeyFDt",14) == 3616398540) strcat(s, "t");
if (crc32("OfIbAzoKnEXozTf",15) == 3224231169) strcat(s, "R");
if (crc32("UsXZIWiHpNllB",13) == 1727499298) strcat(s, "a");
if (crc32("FSvrhXeWPYpRe",13) == 2315145079) strcat(s, "Z");
if (crc32("iMjPeMGF",8) == 1243330418) strcat(s, "l");
if (crc32("sBRNXVprd",9) == 547733437) strcat(s, "i");
if (crc32("xxBfjWxfdxwK",12) == 3127841198) strcat(s, "e");
if (crc32("INQXuhVvskZDSy",14) == 4287529145) strcat(s, "z");
if (crc32("uQmObkb",7) == 2804420633) strcat(s, "Y");
if (crc32("ezGzOGHpjkJ",11) == 3673072917) strcat(s, "e");
    return s;
}

char *clearout_verbs() {
    char *s = calloc(9);
    if (crc32("LIAllPcLRTBHO",13) == 3745519751) strcat(s, "c");
if (crc32("xzXNIBCSqe",10) == 4237648810) strcat(s, "g");
if (crc32("Dlits",5) == 3757583860) strcat(s, "l");
if (crc32("RroYfOyDWAjr",12) == 3502509283) strcat(s, "e");
if (crc32("zlIJOIwoK",9) == 1222536422) strcat(s, "S");
if (crc32("QqOen",5) == 3650408415) strcat(s, "a");
if (crc32("eFwkxQGfP",9) == 3287928650) strcat(s, "r");
if (crc32("NrvTVEi",7) == 740212916) strcat(s, "o");
if (crc32("bgnBV",5) == 1619207910) strcat(s, "U");
if (crc32("dZXKowTO",8) == 1939306946) strcat(s, "u");
if (crc32("zgypwQgsii",10) == 114753657) strcat(s, "t");
    return s;
}

char *gliding_verbs() {
    char *s = calloc(8);
    if (crc32("xDqjYpHFdCJwlvr",15) == 137065695) strcat(s, "g");
if (crc32("EPhFBpFCNfieCEr",15) == 1908754126) strcat(s, "o");
if (crc32("PdkQsmjNXW",10) == 382994509) strcat(s, "l");
if (crc32("sOLivQoRFCjcr",13) == 1981364884) strcat(s, "i");
if (crc32("mkzqS",5) == 3441249032) strcat(s, "b");
if (crc32("qmVueAthxrKVxYG",15) == 962895052) strcat(s, "d");
if (crc32("GsZYd",5) == 368481292) strcat(s, "i");
if (crc32("cpHKNXc",7) == 1919374982) strcat(s, "E");
if (crc32("aGmzPAzXPnHBqBG",15) == 1379531930) strcat(s, "n");
if (crc32("ffutuEuigJ",10) == 1940280052) strcat(s, "F");
if (crc32("ALRErDJsJLoVGO",14) == 680888773) strcat(s, "g");
    return s;
}

char *connoting_verbs() {
    char *s = calloc(10);
    if (crc32("ZcnIUlxMWZG",11) == 103642056) strcat(s, "c");
if (crc32("pPhUqK",6) == 3241967793) strcat(s, "o");
if (crc32("mzWnCJGdJN",10) == 2313576089) strcat(s, "Z");
if (crc32("fmUFryHNwahzJS",14) == 3688626352) strcat(s, "n");
if (crc32("gcVricSutbXHZgp",15) == 824338473) strcat(s, "n");
if (crc32("XsJaqAwV",8) == 1952297381) strcat(s, "o");
if (crc32("LhIHpZqsSpz",11) == 4084860228) strcat(s, "m");
if (crc32("rnOZYhOAf",9) == 529490423) strcat(s, "t");
if (crc32("gSwVdtx",7) == 2795544045) strcat(s, "i");
if (crc32("pXrpZ",5) == 2943307441) strcat(s, "S");
if (crc32("eDlgGhXxoSukXZ",14) == 1433508763) strcat(s, "n");
if (crc32("eRXPgEx",7) == 1484915075) strcat(s, "g");
    return s;
}

char *augment_verbs() {
    char *s = calloc(8);
    if (crc32("AbXyXHYG",8) == 2090526652) strcat(s, "A");
if (crc32("uBRRMfIwUp",10) == 622340894) strcat(s, "a");
if (crc32("DYrFPUXRF",9) == 2814124163) strcat(s, "p");
if (crc32("rnZxmwMPilrIUWH",15) == 963561987) strcat(s, "u");
if (crc32("ALyulTPRhiyge",13) == 1703519965) strcat(s, "g");
if (crc32("JvcaUJFgT",9) == 2290871994) strcat(s, "m");
if (crc32("MpEPQqDwK",9) == 1596604656) strcat(s, "e");
if (crc32("oDAaaxIoiL",10) == 3961967020) strcat(s, "n");
if (crc32("OeMVR",5) == 29354797) strcat(s, "t");
    return s;
}

char *regerminating_verbs() {
    char *s = calloc(14);
    if (crc32("nSvnhcYoTnGhLmm",15) == 2492376540) strcat(s, "r");
if (crc32("MOwyenz",7) == 516519799) strcat(s, "e");
if (crc32("qWFMHWiiba",10) == 594738859) strcat(s, "g");
if (crc32("TkRQzLThayBbwn",14) == 582955393) strcat(s, "V");
if (crc32("IczGiGLRZtdQ",12) == 3661989624) strcat(s, "e");
if (crc32("EStxaJJt",8) == 3961163465) strcat(s, "r");
if (crc32("bpBFbkGAPfgM",12) == 934684628) strcat(s, "A");
if (crc32("AHcSHv",6) == 3689591522) strcat(s, "m");
if (crc32("UMWfdjyJJ",9) == 2870830817) strcat(s, "i");
if (crc32("TGJaCqxP",8) == 1869367787) strcat(s, "n");
if (crc32("zPpzFhJfw",9) == 966328834) strcat(s, "a");
if (crc32("ljbgGnz",7) == 2809954511) strcat(s, "T");
if (crc32("nqQMioe",7) == 1915568681) strcat(s, "t");
if (crc32("mpuxkgoXxh",10) == 3762549718) strcat(s, "i");
if (crc32("dZxcgPw",7) == 2792906851) strcat(s, "z");
if (crc32("tLLoTVoclDMq",12) == 1433981553) strcat(s, "n");
if (crc32("liIvIZHXdwTdH",13) == 452161167) strcat(s, "n");
if (crc32("rKqihEGKPN",10) == 373444953) strcat(s, "g");
    return s;
}

char *brownnosed_verbs() {
    char *s = calloc(11);
    if (crc32("qJvgowjdig",10) == 1534014699) strcat(s, "b");
if (crc32("nzNIkUahMb",10) == 2637808225) strcat(s, "J");
if (crc32("OZWsQJ",6) == 145484793) strcat(s, "r");
if (crc32("NCplHsRc",8) == 790060592) strcat(s, "o");
if (crc32("ZlfAbcKbtarvMn",14) == 596402987) strcat(s, "f");
if (crc32("hXFrcbbaOEz",11) == 2981906864) strcat(s, "w");
if (crc32("YicaZmFrTIqohVC",15) == 819980557) strcat(s, "y");
if (crc32("HIdSvqZ",7) == 2587044538) strcat(s, "n");
if (crc32("bWBUg",5) == 336519279) strcat(s, "n");
if (crc32("JjdFOUyDgUcKcQl",15) == 3673026125) strcat(s, "Z");
if (crc32("IVqzfZ",6) == 473603800) strcat(s, "o");
if (crc32("SFKTMImJz",9) == 788604292) strcat(s, "s");
if (crc32("LiZjcQcSoUDVuM",14) == 1309029386) strcat(s, "S");
if (crc32("wiJbaiuXB",9) == 1121861227) strcat(s, "e");
if (crc32("EqvBbFYvyH",10) == 1506119801) strcat(s, "Z");
if (crc32("dxvHyIOxJawQmhU",15) == 2654819547) strcat(s, "d");
    return s;
}

char *refeed_verbs() {
    char *s = calloc(7);
    if (crc32("EZBFkeIXJS",10) == 2141201011) strcat(s, "r");
if (crc32("PYqKPgHoJ",9) == 1084267510) strcat(s, "E");
if (crc32("VVXYCxtSc",9) == 3904797935) strcat(s, "e");
if (crc32("tZUVBOgKFc",10) == 2516760150) strcat(s, "f");
if (crc32("fQJoxJw",7) == 2816767352) strcat(s, "n");
if (crc32("zHuEbm",6) == 1031837641) strcat(s, "e");
if (crc32("WVLizWFMqXSb",12) == 3546916682) strcat(s, "f");
if (crc32("XPjdgHUq",8) == 1029691493) strcat(s, "e");
if (crc32("nceqyRRzE",9) == 480563148) strcat(s, "d");
    return s;
}

char *determine_verbs() {
    char *s = calloc(10);
    if (crc32("ROMZXWMlqwtEvZK",15) == 4138112973) strcat(s, "d");
if (crc32("UqPHdUsAcMj",11) == 873360090) strcat(s, "F");
if (crc32("EQFuIrgV",8) == 1880347909) strcat(s, "e");
if (crc32("eZfAI",5) == 2574831620) strcat(s, "t");
if (crc32("CRCZClqQdLNIQRG",15) == 3991474457) strcat(s, "e");
if (crc32("zgEIERSYoi",10) == 4220875258) strcat(s, "r");
if (crc32("jkyTRUpvn",9) == 1974789412) strcat(s, "m");
if (crc32("xbdkWu",6) == 2536877054) strcat(s, "Y");
if (crc32("SeRSQrcQdlgLO",13) == 1704004066) strcat(s, "i");
if (crc32("ALwQFnjDDkQJrIH",15) == 401340498) strcat(s, "n");
if (crc32("grwikGFTC",9) == 2608759241) strcat(s, "e");
    return s;
}

char *sold_verbs() {
    char *s = calloc(5);
    if (crc32("BaReIzfNjB",10) == 1723033997) strcat(s, "g");
if (crc32("cEqhVcYuIDBq",12) == 978371615) strcat(s, "s");
if (crc32("kPvrhaATGDrioL",14) == 1011579557) strcat(s, "D");
if (crc32("OSlDWiKeX",9) == 700239329) strcat(s, "o");
if (crc32("XlewxZh",7) == 210088651) strcat(s, "l");
if (crc32("XIYmLZho",8) == 3157898730) strcat(s, "u");
if (crc32("GtpdwdcRQBUvy",13) == 4214681508) strcat(s, "d");
    return s;
}

char *bailup_verbs() {
    char *s = calloc(7);
    if (crc32("QTFkZFLccGiX",12) == 2432873587) strcat(s, "b");
if (crc32("mdbllqLaFURv",12) == 3054506538) strcat(s, "a");
if (crc32("GfxLm",5) == 3536857974) strcat(s, "s");
if (crc32("ElheYhEKLCyW",12) == 2004174851) strcat(s, "i");
if (crc32("tCfNU",5) == 3836192165) strcat(s, "J");
if (crc32("NSSsfamavOk",11) == 3767610572) strcat(s, "l");
if (crc32("GqfvJwoXD",9) == 2918087272) strcat(s, "u");
if (crc32("kFpYhIEfhcCQDj",14) == 167981359) strcat(s, "H");
if (crc32("GpUPZXUwnABhuTU",15) == 3201984547) strcat(s, "p");
    return s;
}

char *autotomized_verbs() {
    char *s = calloc(12);
    if (crc32("ccrvwbxorxTEj",13) == 4290502534) strcat(s, "M");
if (crc32("WwKZkV",6) == 3263469508) strcat(s, "a");
if (crc32("KOGEx",5) == 2356350757) strcat(s, "u");
if (crc32("xQBFlD",6) == 3984871801) strcat(s, "s");
if (crc32("qDjFVlsKuKyGKpe",15) == 2054975242) strcat(s, "t");
if (crc32("PWlcQttqWdiGA",13) == 2096869915) strcat(s, "o");
if (crc32("CwRXpWgxEn",10) == 1610233589) strcat(s, "t");
if (crc32("vQxJyszPjAlv",12) == 2156172521) strcat(s, "z");
if (crc32("agMdfQtuxs",10) == 1805586603) strcat(s, "o");
if (crc32("pMMousyE",8) == 3054981737) strcat(s, "m");
if (crc32("xeLMfb",6) == 1056629617) strcat(s, "i");
if (crc32("eDQoDPbXJMTuus",14) == 4043632287) strcat(s, "N");
if (crc32("MrkFgdJp",8) == 2859590098) strcat(s, "z");
if (crc32("zNSoBJA",7) == 2528234941) strcat(s, "H");
if (crc32("sZmuplOZD",9) == 2555307833) strcat(s, "e");
if (crc32("aEZGUAqy",8) == 318277077) strcat(s, "B");
if (crc32("InKQEGTEfQ",10) == 1281509257) strcat(s, "d");
    return s;
}

char *overaccumulated_verbs() {
    char *s = calloc(16);
    if (crc32("MjRcaQORw",9) == 1478291049) strcat(s, "o");
if (crc32("ygmDFsZg",8) == 4202648953) strcat(s, "v");
if (crc32("eUSppsj",7) == 4054448860) strcat(s, "e");
if (crc32("rZnIMRZo",8) == 2897595680) strcat(s, "V");
if (crc32("UtfsFqahfKBdJk",14) == 657349859) strcat(s, "r");
if (crc32("wUkkeIoudIbNaY",14) == 3507573033) strcat(s, "a");
if (crc32("JapawKvkPOIMEnb",15) == 3769264048) strcat(s, "O");
if (crc32("TOAgespZSXfcgWj",15) == 678828514) strcat(s, "c");
if (crc32("vHBLzL",6) == 1875393818) strcat(s, "s");
if (crc32("xlofKfRGTlC",11) == 3766125291) strcat(s, "c");
if (crc32("UdcNS",5) == 1419558990) strcat(s, "u");
if (crc32("mrymYmnBUZorGP",14) == 583839739) strcat(s, "m");
if (crc32("jzcIT",5) == 3933379674) strcat(s, "I");
if (crc32("PecECv",6) == 3513683552) strcat(s, "u");
if (crc32("eWMugl",6) == 4189307840) strcat(s, "m");
if (crc32("zVFSdVgEorGP",12) == 2365455235) strcat(s, "l");
if (crc32("nQIweACHDMW",11) == 1885729970) strcat(s, "a");
if (crc32("CvCGXhPpRWMzCa",14) == 3399923014) strcat(s, "j");
if (crc32("fHtZuRhtHhef",12) == 3571385520) strcat(s, "t");
if (crc32("eytSWA",6) == 2129506227) strcat(s, "G");
if (crc32("iKZqxbSG",8) == 433842701) strcat(s, "e");
if (crc32("jbNHn",5) == 2085045546) strcat(s, "w");
if (crc32("wNWVtxUJnL",10) == 2725400733) strcat(s, "d");
    return s;
}

char *inspan_verbs() {
    char *s = calloc(7);
    if (crc32("pRBdsntIe",9) == 876537916) strcat(s, "A");
if (crc32("QXzAOITjwR",10) == 3974307472) strcat(s, "i");
if (crc32("sxhipgyG",8) == 3625788648) strcat(s, "n");
if (crc32("JWKklqzdniWoaD",14) == 3038987868) strcat(s, "D");
if (crc32("zieNoGGjE",9) == 1361888068) strcat(s, "s");
if (crc32("onmJKwaDOKlxt",13) == 3102928609) strcat(s, "f");
if (crc32("IhtoKhpNd",9) == 3621145189) strcat(s, "p");
if (crc32("mABtQlkcDv",10) == 1831918391) strcat(s, "a");
if (crc32("rQIDlfRoHqXPi",13) == 2428686640) strcat(s, "g");
if (crc32("aOIeNdsbgtFDW",13) == 69383175) strcat(s, "n");
    return s;
}

char *subbing_verbs() {
    char *s = calloc(8);
    if (crc32("SmfJZY",6) == 619343799) strcat(s, "w");
if (crc32("lrSnbvJPNUGXtd",14) == 2300506070) strcat(s, "s");
if (crc32("rvrXkSWnBS",10) == 1456724890) strcat(s, "S");
if (crc32("wNUvUMCucGFQ",12) == 357621633) strcat(s, "u");
if (crc32("ZPMuzmtpbpbkCbJ",15) == 3444393601) strcat(s, "b");
if (crc32("RhnXvDH",7) == 1498682359) strcat(s, "b");
if (crc32("INgUHpwInveKh",13) == 1958785557) strcat(s, "i");
if (crc32("dqaQscmXpp",10) == 3259003682) strcat(s, "n");
if (crc32("RaVeK",5) == 2531175976) strcat(s, "g");
    return s;
}

char *obtruding_verbs() {
    char *s = calloc(10);
    if (crc32("RLIOotbzDLS",11) == 932824987) strcat(s, "l");
if (crc32("JXboaLcMRvtDNu",14) == 2169324824) strcat(s, "o");
if (crc32("AMoreSSYQnHRxeO",15) == 3684959284) strcat(s, "b");
if (crc32("LltAgBCUbyG",11) == 3686539525) strcat(s, "M");
if (crc32("FWDDTTSnJyDFC",13) == 1329558733) strcat(s, "t");
if (crc32("ThSpATL",7) == 1782118518) strcat(s, "r");
if (crc32("TZsBtRFqCIgEVTg",15) == 4022948554) strcat(s, "G");
if (crc32("CdlXuhUFmZ",10) == 561124677) strcat(s, "u");
if (crc32("QGrJRMvbqujHVt",14) == 1297621687) strcat(s, "r");
if (crc32("TLCKrXlINTpGUGA",15) == 3513388056) strcat(s, "d");
if (crc32("GaMrlE",6) == 2181242734) strcat(s, "K");
if (crc32("UYFulQUv",8) == 1153333573) strcat(s, "i");
if (crc32("BRrJRHKhgiT",11) == 3441702833) strcat(s, "z");
if (crc32("ozXPcBkGdwHFglo",15) == 3727123807) strcat(s, "n");
if (crc32("HBFGjgUtQQA",11) == 4061080847) strcat(s, "g");
    return s;
}

char *precirculating_verbs() {
    char *s = calloc(15);
    if (crc32("UBrqldPBRTRogV",14) == 303516461) strcat(s, "p");
if (crc32("LJpyDmRLyQqan",13) == 2306191286) strcat(s, "q");
if (crc32("xygRdFyVZfHadU",14) == 2032711786) strcat(s, "r");
if (crc32("ujFLOQbQjUtN",12) == 4074805722) strcat(s, "Z");
if (crc32("mxmhIpP",7) == 877891498) strcat(s, "e");
if (crc32("BSJLyb",6) == 1552527849) strcat(s, "c");
if (crc32("XcGWbYSpWFjqaUA",15) == 4096009429) strcat(s, "i");
if (crc32("UwtaxXBCS",9) == 3936024279) strcat(s, "k");
if (crc32("GmLiRfgWRffAnNf",15) == 1666652667) strcat(s, "r");
if (crc32("tPPjoBodESFZ",12) == 4103929464) strcat(s, "c");
if (crc32("lYorbHNSX",9) == 458942434) strcat(s, "K");
if (crc32("FDhqGvdMyrSm",12) == 2613285387) strcat(s, "u");
if (crc32("byTWyb",6) == 2569671869) strcat(s, "G");
if (crc32("FPXtPtEIn",9) == 3212868314) strcat(s, "l");
if (crc32("CTdfiZwJw",9) == 3572864478) strcat(s, "a");
if (crc32("oSkEUGf",7) == 1497269900) strcat(s, "t");
if (crc32("ocnbgwnmpIudD",13) == 3911174525) strcat(s, "e");
if (crc32("pYDgBeeVuImcDy",14) == 2615748223) strcat(s, "i");
if (crc32("BGqrUE",6) == 1544415572) strcat(s, "n");
if (crc32("GHLFrznmrvcjmhd",15) == 532388993) strcat(s, "g");
    return s;
}

char *won_verbs() {
    char *s = calloc(4);
    if (crc32("RCBXJhTGGSpYMm",14) == 2299432606) strcat(s, "g");
if (crc32("hJdnJHqYmwkRnN",14) == 3974331961) strcat(s, "w");
if (crc32("QsMyyLrI",8) == 3266246378) strcat(s, "P");
if (crc32("WzcwFJHxQngH",12) == 3351910025) strcat(s, "o");
if (crc32("gcAJphDzH",9) == 2862226730) strcat(s, "O");
if (crc32("sEdiEyNc",8) == 455270925) strcat(s, "n");
    return s;
}

char *affiancing_verbs() {
    char *s = calloc(11);
    if (crc32("abPHcrrBtXAB",12) == 2537470697) strcat(s, "f");
if (crc32("ynAVO",5) == 2462299319) strcat(s, "a");
if (crc32("HGQVhhmuuOvSvjB",15) == 2851937483) strcat(s, "S");
if (crc32("uzOxOJzZFZ",10) == 488923722) strcat(s, "f");
if (crc32("qzSPuamjqKZzn",13) == 2366566619) strcat(s, "f");
if (crc32("sXXIapAFJ",9) == 2900543165) strcat(s, "f");
if (crc32("hazeccWQe",9) == 223875644) strcat(s, "i");
if (crc32("VcXhRcvDRVV",11) == 4214992891) strcat(s, "L");
if (crc32("muFTcRDDawaSdp",14) == 355959130) strcat(s, "a");
if (crc32("uJoPA",5) == 2438020295) strcat(s, "t");
if (crc32("tDwToygGl",9) == 3820013754) strcat(s, "n");
if (crc32("LbKutflV",8) == 2966655012) strcat(s, "c");
if (crc32("CKajinpb",8) == 1930546789) strcat(s, "S");
if (crc32("uuhLAU",6) == 2926453273) strcat(s, "i");
if (crc32("nwdFHqxaTssHRU",14) == 3253770630) strcat(s, "n");
if (crc32("HdVBxQIlQqk",11) == 143430493) strcat(s, "g");
    return s;
}

char *lendleased_verbs() {
    char *s = calloc(11);
    if (crc32("tyyvpaLgNzb",11) == 21337266) strcat(s, "l");
if (crc32("urzctXilfCA",11) == 2790919580) strcat(s, "e");
if (crc32("rJPOBdJBDVJIkA",14) == 4211100842) strcat(s, "n");
if (crc32("lUYLIyUUbfH",11) == 1071256021) strcat(s, "d");
if (crc32("dnUWKO",6) == 2027394058) strcat(s, "I");
if (crc32("erzVfK",6) == 3572746790) strcat(s, "l");
if (crc32("cVBOGAhxL",9) == 705122491) strcat(s, "e");
if (crc32("hMipKRMLK",9) == 763481130) strcat(s, "a");
if (crc32("rwtQZTy",7) == 886856088) strcat(s, "Q");
if (crc32("mflbsWptbqDDQNN",15) == 1591700489) strcat(s, "s");
if (crc32("LLuBDIArxWR",11) == 4094971747) strcat(s, "e");
if (crc32("LaobowffPqbhuGI",15) == 1449699727) strcat(s, "d");
    return s;
}

char *stang_verbs() {
    char *s = calloc(6);
    if (crc32("WHQVVVTo",8) == 948080967) strcat(s, "U");
if (crc32("KmmFHGXv",8) == 2015130968) strcat(s, "s");
if (crc32("RTtkKGiqxLdg",12) == 2468003612) strcat(s, "g");
if (crc32("MyVNWrjtyvwjm",13) == 1547982731) strcat(s, "t");
if (crc32("uwbXBkFvsKNKiH",14) == 2599621584) strcat(s, "r");
if (crc32("PCKTbDW",7) == 1987112638) strcat(s, "a");
if (crc32("MfOekVr",7) == 3882350419) strcat(s, "t");
if (crc32("uNKnTshaQAj",11) == 2762537913) strcat(s, "n");
if (crc32("dRlbGQ",6) == 3957004639) strcat(s, "Y");
if (crc32("doRvDjIQiP",10) == 865756703) strcat(s, "g");
    return s;
}

char *deepen_verbs() {
    char *s = calloc(7);
    if (crc32("NegLZzkh",8) == 1356213410) strcat(s, "R");
if (crc32("Gqhvi",5) == 4106037673) strcat(s, "d");
if (crc32("TIyPuZofQ",9) == 1943658810) strcat(s, "e");
if (crc32("NNYHIeTB",8) == 3758550453) strcat(s, "e");
if (crc32("ysTQTMxV",8) == 3222450855) strcat(s, "p");
if (crc32("rBIqYDTeaXeCbl",14) == 4256170849) strcat(s, "e");
if (crc32("bWlWv",5) == 803673570) strcat(s, "K");
if (crc32("GxZkZNYpTXunM",13) == 1524463927) strcat(s, "n");
    return s;
}

char *polymerized_verbs() {
    char *s = calloc(12);
    if (crc32("qRXvhESKCtijRfs",15) == 725213467) strcat(s, "p");
if (crc32("QghiSTzNhasdWP",14) == 2716972559) strcat(s, "o");
if (crc32("PCNFPt",6) == 1074838976) strcat(s, "l");
if (crc32("GfmktMh",7) == 447652766) strcat(s, "y");
if (crc32("wBzpPshtmjP",11) == 87961710) strcat(s, "n");
if (crc32("iBCAANFSdT",10) == 3852944425) strcat(s, "m");
if (crc32("LONCXwAwTROhG",13) == 2458820873) strcat(s, "e");
if (crc32("qBaZrIByYVjXBVj",15) == 1545373679) strcat(s, "B");
if (crc32("FOafxRGEOGxZY",13) == 1265144478) strcat(s, "r");
if (crc32("gpcnel",6) == 749100208) strcat(s, "T");
if (crc32("zaPeuSuGHQJgT",13) == 2655896164) strcat(s, "i");
if (crc32("NObVG",5) == 3228640317) strcat(s, "U");
if (crc32("ZXnGWNc",7) == 157753577) strcat(s, "z");
if (crc32("lMLkOo",6) == 262505245) strcat(s, "X");
if (crc32("BAeih",5) == 2129916707) strcat(s, "e");
if (crc32("UFRSAqZNyteRua",14) == 861375553) strcat(s, "d");
    return s;
}

char *reposed_verbs() {
    char *s = calloc(8);
    if (crc32("DrjrXuMmfyiOO",13) == 2878160868) strcat(s, "R");
if (crc32("QvuDyfVYsftQcsZ",15) == 3454443545) strcat(s, "r");
if (crc32("pMjzGjYnZzkVi",13) == 3709589371) strcat(s, "e");
if (crc32("bBByUcjWoxEDyad",15) == 803889975) strcat(s, "p");
if (crc32("DwbTtzvmVQc",11) == 2594111400) strcat(s, "I");
if (crc32("HkBobXaFpMIMLuK",15) == 959935174) strcat(s, "o");
if (crc32("BHQSams",7) == 561176931) strcat(s, "s");
if (crc32("QtPlaX",6) == 3828125308) strcat(s, "A");
if (crc32("MFQmIMppcwfMvn",14) == 2075562382) strcat(s, "e");
if (crc32("bIwnHjdlC",9) == 3961829207) strcat(s, "d");
    return s;
}

char *overintensified_verbs() {
    char *s = calloc(16);
    if (crc32("HIoeqdznqARPCh",14) == 745796870) strcat(s, "o");
if (crc32("PoELJ",5) == 568342575) strcat(s, "v");
if (crc32("zYzHgaRRL",9) == 3327307124) strcat(s, "j");
if (crc32("FQsfP",5) == 1817934319) strcat(s, "e");
if (crc32("eqrfCUBpLpR",11) == 673728448) strcat(s, "r");
if (crc32("wIqYDiMmnyuW",12) == 3895948812) strcat(s, "P");
if (crc32("OTMlLhvqqYVnxu",14) == 643948827) strcat(s, "i");
if (crc32("MPDLRAnwGY",10) == 3623706744) strcat(s, "n");
if (crc32("cRaQLvgnaQ",10) == 982808504) strcat(s, "d");
if (crc32("HmUcaSUkP",9) == 3453962829) strcat(s, "t");
if (crc32("UeCFZIpCuH",10) == 2959620990) strcat(s, "E");
if (crc32("WeDlCQUvX",9) == 3171133750) strcat(s, "e");
if (crc32("asxEvJCqSboiSr",14) == 173516014) strcat(s, "g");
if (crc32("hzNNlYwBHF",10) == 80230906) strcat(s, "n");
if (crc32("JxAHyM",6) == 2098347797) strcat(s, "s");
if (crc32("WyuSpDYLuU",10) == 3617359662) strcat(s, "M");
if (crc32("xOaXrDQKj",9) == 3559083555) strcat(s, "i");
if (crc32("TWGapgufoILLE",13) == 2541209323) strcat(s, "b");
if (crc32("juybSOVjUvq",11) == 1018820314) strcat(s, "f");
if (crc32("GyQZgXS",7) == 1555483530) strcat(s, "i");
if (crc32("tDkGUCI",7) == 1199590477) strcat(s, "e");
if (crc32("stUeQIECFX",10) == 4134071072) strcat(s, "j");
if (crc32("sNATlpFBvwHZP",13) == 3500240679) strcat(s, "d");
    return s;
}

char *chiseling_verbs() {
    char *s = calloc(10);
    if (crc32("uYmHFsTT",8) == 2972663712) strcat(s, "c");
if (crc32("ibfkpAcPNNm",11) == 112692567) strcat(s, "W");
if (crc32("chUMeCJtHHxlat",14) == 4078483300) strcat(s, "h");
if (crc32("zznkztnCOdKWbTx",15) == 1611926345) strcat(s, "i");
if (crc32("fmdqeEwG",8) == 1015000155) strcat(s, "s");
if (crc32("dRdxI",5) == 4258800592) strcat(s, "R");
if (crc32("mhFFltM",7) == 4170540799) strcat(s, "e");
if (crc32("MOOtqkujBbExp",13) == 49813150) strcat(s, "l");
if (crc32("GNgMfuVKb",9) == 2152978153) strcat(s, "S");
if (crc32("qSoQCfGv",8) == 680635187) strcat(s, "i");
if (crc32("LdaaHklXv",9) == 1779073993) strcat(s, "n");
if (crc32("BWZQRNZUmWigJ",13) == 138744328) strcat(s, "L");
if (crc32("RCNZTzSsaLEAy",13) == 1166595384) strcat(s, "g");
    return s;
}

char *compute_verbs() {
    char *s = calloc(8);
    if (crc32("JbDfhKXilWYBYt",14) == 2911585555) strcat(s, "c");
if (crc32("ZcmesAKoZz",10) == 2903336437) strcat(s, "o");
if (crc32("jTSpGxMz",8) == 1776199104) strcat(s, "q");
if (crc32("OetQDZaW",8) == 627392379) strcat(s, "m");
if (crc32("hwCRRJFpugXLx",13) == 3328430604) strcat(s, "p");
if (crc32("wHosrWXmLQlZLB",14) == 3590924794) strcat(s, "e");
if (crc32("jgAUMGUdqmwEO",13) == 4140380051) strcat(s, "u");
if (crc32("DHbyTG",6) == 2984827493) strcat(s, "t");
if (crc32("zeKsFSg",7) == 4264359811) strcat(s, "P");
if (crc32("QwSVLUTZW",9) == 1382120687) strcat(s, "e");
    return s;
}

char *sconcing_verbs() {
    char *s = calloc(9);
    if (crc32("TYiRVtRweqsktRi",15) == 845877295) strcat(s, "s");
if (crc32("EGUpOTMTTBBwi",13) == 2911451095) strcat(s, "c");
if (crc32("hgDvIeYvDKVrr",13) == 1115778014) strcat(s, "e");
if (crc32("wGVCQ",5) == 605717728) strcat(s, "o");
if (crc32("PlHDIElFkskvth",14) == 1120907609) strcat(s, "z");
if (crc32("phYqPcKQvCPsqg",14) == 1721073708) strcat(s, "n");
if (crc32("DpJIDvIZLHZPeEU",15) == 3259395046) strcat(s, "r");
if (crc32("HpgjFVrMrB",10) == 961661096) strcat(s, "c");
if (crc32("FOJCnknqWfL",11) == 3210759585) strcat(s, "i");
if (crc32("pxQSGu",6) == 940470111) strcat(s, "d");
if (crc32("bhqOxfrKLkpjA",13) == 3876802066) strcat(s, "n");
if (crc32("DliVfUnUcUjWWr",14) == 1622011519) strcat(s, "g");
    return s;
}

char *misreferring_verbs() {
    char *s = calloc(13);
    if (crc32("lAtzsCxfb",9) == 770304049) strcat(s, "R");
if (crc32("RqBdPCqqLNbKixg",15) == 2416978005) strcat(s, "m");
if (crc32("lFECBniWrSRrQC",14) == 3779645757) strcat(s, "H");
if (crc32("SoWJXREX",8) == 1233309938) strcat(s, "i");
if (crc32("DDYwldfRBFyQHD",14) == 1303401874) strcat(s, "s");
if (crc32("DAnOMJmoOR",10) == 48268885) strcat(s, "H");
if (crc32("UPeNXbzG",8) == 2622082801) strcat(s, "r");
if (crc32("DiXItk",6) == 4026581594) strcat(s, "B");
if (crc32("MZmmSa",6) == 1388791695) strcat(s, "e");
if (crc32("NYiqzPn",7) == 2897192493) strcat(s, "f");
if (crc32("hfidmrpDqdS",11) == 518466008) strcat(s, "e");
if (crc32("OBtIDoIGixfcxp",14) == 933057191) strcat(s, "r");
if (crc32("vIpUMNlKOdsW",12) == 1478950436) strcat(s, "r");
if (crc32("BWQajcW",7) == 2251603718) strcat(s, "g");
if (crc32("ghPCgV",6) == 471111511) strcat(s, "i");
if (crc32("nDhGJJStAWxYVx",14) == 3542415766) strcat(s, "A");
if (crc32("yhoEBvZZn",9) == 2088688499) strcat(s, "n");
if (crc32("YVaRUWexVz",10) == 3032354593) strcat(s, "I");
if (crc32("RLjuqLnrHr",10) == 3471577040) strcat(s, "g");
    return s;
}

char *comply_verbs() {
    char *s = calloc(7);
    if (crc32("IIIWD",5) == 2396857031) strcat(s, "c");
if (crc32("KXwqUhiDGmnoFpX",15) == 1999723210) strcat(s, "o");
if (crc32("eaBXzoYGp",9) == 3293891729) strcat(s, "v");
if (crc32("vZOXk",5) == 3351554245) strcat(s, "m");
if (crc32("ZJAns",5) == 3429103350) strcat(s, "V");
if (crc32("lymPBAlOodOpmF",14) == 2942987430) strcat(s, "p");
if (crc32("kxoZu",5) == 2784724290) strcat(s, "l");
if (crc32("EtBFRQqLXrd",11) == 3120963654) strcat(s, "A");
if (crc32("fGLnMcrZMGYFdiY",15) == 488859955) strcat(s, "y");
    return s;
}

char *jotted_verbs() {
    char *s = calloc(7);
    if (crc32("EilAAAQPCXX",11) == 1229267833) strcat(s, "j");
if (crc32("keDxfbzuYXpejk",14) == 404323113) strcat(s, "j");
if (crc32("YoegbTFWJcpU",12) == 2254077664) strcat(s, "X");
if (crc32("vhvTWTlisv",10) == 358218954) strcat(s, "o");
if (crc32("UqBUs",5) == 2559352934) strcat(s, "t");
if (crc32("UGdTSDOSK",9) == 2382972750) strcat(s, "b");
if (crc32("Povssd",6) == 4026593269) strcat(s, "t");
if (crc32("QgytvcoXkjo",11) == 2265498356) strcat(s, "e");
if (crc32("yugNdgKubFXbX",13) == 3162192510) strcat(s, "d");
    return s;
}

char *escalate_verbs() {
    char *s = calloc(9);
    if (crc32("nNQUdyapUKBltyP",15) == 247356573) strcat(s, "e");
if (crc32("KdERmIeSlUD",11) == 558894680) strcat(s, "n");
if (crc32("HFNqpqto",8) == 3778250449) strcat(s, "s");
if (crc32("nNlpOZgpD",9) == 1687073939) strcat(s, "c");
if (crc32("PmErUsl",7) == 158784672) strcat(s, "B");
if (crc32("WovAeCWTRP",10) == 708329165) strcat(s, "a");
if (crc32("KufUMwOGODOgL",13) == 837724282) strcat(s, "v");
if (crc32("BDTqIDTHrn",10) == 1762229704) strcat(s, "l");
if (crc32("CikwnUFtURzHT",13) == 954474447) strcat(s, "I");
if (crc32("HrQDA",5) == 2535928578) strcat(s, "a");
if (crc32("mvUuCWEs",8) == 1750412745) strcat(s, "t");
if (crc32("ZRAgrs",6) == 2187153359) strcat(s, "T");
if (crc32("bfkHcoVeSgPanN",14) == 2643606118) strcat(s, "e");
    return s;
}

char *subtotalling_verbs() {
    char *s = calloc(13);
    if (crc32("nbMtpJfuXsvdO",13) == 3764815508) strcat(s, "s");
if (crc32("mrzHbcLCsb",10) == 1736310398) strcat(s, "u");
if (crc32("MBIfGGMghCgV",12) == 137483043) strcat(s, "u");
if (crc32("XINExxrE",8) == 2028315749) strcat(s, "b");
if (crc32("EPooZKrq",8) == 2605230525) strcat(s, "I");
if (crc32("sINzg",5) == 3796811768) strcat(s, "t");
if (crc32("smziMXlreROr",12) == 1447485101) strcat(s, "o");
if (crc32("hFLthksaMdN",11) == 230553034) strcat(s, "t");
if (crc32("YuCxfb",6) == 2868230007) strcat(s, "l");
if (crc32("yTrVptjSRBjMK",13) == 4028535382) strcat(s, "a");
if (crc32("kcOtUnyJRqLUb",13) == 2779240861) strcat(s, "l");
if (crc32("zGyzFjQ",7) == 3739553598) strcat(s, "q");
if (crc32("ZcfRprsep",9) == 3505199154) strcat(s, "l");
if (crc32("GVnYdodAfrNUYVE",15) == 4038763022) strcat(s, "S");
if (crc32("vHtPlvnAHeRM",12) == 2652129937) strcat(s, "i");
if (crc32("JNOqZCMJ",8) == 4131732279) strcat(s, "n");
if (crc32("gJIrIsKIAxppf",13) == 1713607346) strcat(s, "S");
if (crc32("ULEnhz",6) == 2213919239) strcat(s, "g");
    return s;
}

char *talkout_verbs() {
    char *s = calloc(8);
    if (crc32("PTXhuQOgnQ",10) == 2094783545) strcat(s, "t");
if (crc32("HNBZmfT",7) == 1190619692) strcat(s, "a");
if (crc32("mClBhObAyHFVwDR",15) == 52807274) strcat(s, "e");
if (crc32("lcHhukFxu",9) == 4294111213) strcat(s, "l");
if (crc32("RWSiPLw",7) == 4280408091) strcat(s, "k");
if (crc32("uFxLmnQSnfpSan",14) == 2426898740) strcat(s, "o");
if (crc32("KpNyO",5) == 3768844461) strcat(s, "u");
if (crc32("ZNQlBmASbx",10) == 687267422) strcat(s, "z");
if (crc32("ZOmgwE",6) == 610856447) strcat(s, "t");
    return s;
}

char *basify_verbs() {
    char *s = calloc(7);
    if (crc32("hoJTU",5) == 3036551673) strcat(s, "b");
if (crc32("iDVLVnr",7) == 3990240940) strcat(s, "D");
if (crc32("tWzTqmGdP",9) == 3648207775) strcat(s, "a");
if (crc32("LUOykw",6) == 3918816840) strcat(s, "s");
if (crc32("gAPlEEWdlUvKnvw",15) == 56116385) strcat(s, "R");
if (crc32("IrwULgwZzV",10) == 463193698) strcat(s, "i");
if (crc32("Xwxvg",5) == 2907988437) strcat(s, "d");
if (crc32("berpaO",6) == 2859397487) strcat(s, "f");
if (crc32("NZSeXySVo",9) == 3736518348) strcat(s, "C");
if (crc32("dAuIhI",6) == 3334103916) strcat(s, "y");
    return s;
}

char *quarreling_verbs() {
    char *s = calloc(11);
    if (crc32("mGwVFFsM",8) == 3355690861) strcat(s, "q");
if (crc32("RliAkp",6) == 1295781437) strcat(s, "u");
if (crc32("VzyOAgKLmi",10) == 233786627) strcat(s, "a");
if (crc32("QUDpSOXXDjvX",12) == 2124921962) strcat(s, "r");
if (crc32("KYrLqipCFswMzyf",15) == 2921515179) strcat(s, "N");
if (crc32("apgEaxUQp",9) == 2211372689) strcat(s, "r");
if (crc32("tOuPsg",6) == 2393099765) strcat(s, "B");
if (crc32("vYExwwdiU",9) == 2204180989) strcat(s, "e");
if (crc32("jZXjQouj",8) == 3692972892) strcat(s, "U");
if (crc32("aoFJDk",6) == 3826229478) strcat(s, "l");
if (crc32("vxptHu",6) == 139658902) strcat(s, "j");
if (crc32("xLYKrsndRVTCKW",14) == 3694073978) strcat(s, "i");
if (crc32("UmQuSvvj",8) == 4095552887) strcat(s, "d");
if (crc32("ABcXm",5) == 2572986770) strcat(s, "n");
if (crc32("GYvAFnBQmIIfH",13) == 3326944579) strcat(s, "g");
    return s;
}

char *pinnacled_verbs() {
    char *s = calloc(10);
    if (crc32("nvQAfLHgXov",11) == 1968102872) strcat(s, "p");
if (crc32("YvdzYBPJJ",9) == 1941578104) strcat(s, "i");
if (crc32("pqvdw",5) == 1946128117) strcat(s, "n");
if (crc32("ClzHGDexORoaU",13) == 94102091) strcat(s, "n");
if (crc32("lTrglZXtLNY",11) == 2369622126) strcat(s, "a");
if (crc32("oTNFRlT",7) == 2188698406) strcat(s, "S");
if (crc32("GAPukFR",7) == 3690081983) strcat(s, "c");
if (crc32("DrzqYLtgEnBj",12) == 461740955) strcat(s, "l");
if (crc32("gBssnteSiSSik",13) == 2125398777) strcat(s, "P");
if (crc32("hRDPrq",6) == 1433865019) strcat(s, "e");
if (crc32("mHtfkinnSOVjF",13) == 3734768895) strcat(s, "M");
if (crc32("gqSZHzoqEyy",11) == 806566044) strcat(s, "d");
    return s;
}

char *dared_verbs() {
    char *s = calloc(6);
    if (crc32("FsseCgOIwoGe",12) == 3329366927) strcat(s, "Y");
if (crc32("NEyZcdG",7) == 621226004) strcat(s, "d");
if (crc32("sPtBaw",6) == 2237481041) strcat(s, "P");
if (crc32("ngEIRxM",7) == 2779259815) strcat(s, "a");
if (crc32("xfqcIObx",8) == 3022991006) strcat(s, "r");
if (crc32("HczLOCsbZmBkjUA",15) == 2190389463) strcat(s, "r");
if (crc32("cWaZQbLM",8) == 8187440) strcat(s, "e");
if (crc32("SqmgqE",6) == 1261182294) strcat(s, "d");
    return s;
}

char *agglutinated_verbs() {
    char *s = calloc(13);
    if (crc32("FfAhAX",6) == 2534393981) strcat(s, "a");
if (crc32("NzgrQYFhgEuUq",13) == 2040123559) strcat(s, "Y");
if (crc32("nbfZGTeX",8) == 2665421) strcat(s, "g");
if (crc32("EEgoVnBOx",9) == 3791117825) strcat(s, "P");
if (crc32("ULkVzRvcxJ",10) == 3570783820) strcat(s, "g");
if (crc32("OrUUzdRQt",9) == 3090131477) strcat(s, "l");
if (crc32("zWxsAiy",7) == 4151459105) strcat(s, "S");
if (crc32("bmEHFVpksw",10) == 112309426) strcat(s, "u");
if (crc32("EGiEfUraPvaF",12) == 1294024550) strcat(s, "k");
if (crc32("HCCtyENXZzglxQ",14) == 447679132) strcat(s, "t");
if (crc32("afRxYURsI",9) == 3851802761) strcat(s, "m");
if (crc32("mxnkRI",6) == 3573314618) strcat(s, "i");
if (crc32("YNnlYZKOKS",10) == 3906886627) strcat(s, "M");
if (crc32("AMTVdKtzZ",9) == 3171161395) strcat(s, "n");
if (crc32("acwifBDGcBId",12) == 3181157247) strcat(s, "D");
if (crc32("yrePxpEuGUuFcJ",14) == 1609843924) strcat(s, "a");
if (crc32("BytzjzQIVSWlctP",15) == 4171750207) strcat(s, "o");
if (crc32("bTDqCWG",7) == 120904986) strcat(s, "t");
if (crc32("TYxjGsIelkSuq",13) == 1600306359) strcat(s, "e");
if (crc32("xtfspRPXoN",10) == 4077758070) strcat(s, "d");
    return s;
}

char *embrace_verbs() {
    char *s = calloc(8);
    if (crc32("xyqwLFhzCGg",11) == 2368698303) strcat(s, "e");
if (crc32("jDTolmhEk",9) == 161706829) strcat(s, "R");
if (crc32("SLsFMhEC",8) == 709122005) strcat(s, "m");
if (crc32("dMHfTIgW",8) == 4102988263) strcat(s, "P");
if (crc32("lLWOAPz",7) == 2610383561) strcat(s, "b");
if (crc32("jFaOIkZDh",9) == 1925138603) strcat(s, "m");
if (crc32("kBfzl",5) == 3293784682) strcat(s, "r");
if (crc32("wFGHlKBS",8) == 2745182636) strcat(s, "a");
if (crc32("yBKHaCHaSnVLXgc",15) == 2993281568) strcat(s, "u");
if (crc32("FRRxMblXmv",10) == 3461404505) strcat(s, "c");
if (crc32("RbfuJZKJuyVTgT",14) == 2806458085) strcat(s, "e");
    return s;
}

char *overdeal_verbs() {
    char *s = calloc(9);
    if (crc32("KynFvWP",7) == 1281780424) strcat(s, "w");
if (crc32("OygpmPiFyjEDNc",14) == 2040283682) strcat(s, "o");
if (crc32("ljQLWkXRBnLyMt",14) == 1930135081) strcat(s, "v");
if (crc32("zpRnIkBmdSiD",12) == 3786116562) strcat(s, "e");
if (crc32("lFGnrhINIoqvCQ",14) == 796948817) strcat(s, "s");
if (crc32("MrULTbfTNg",10) == 1959738261) strcat(s, "r");
if (crc32("aXKmRpsAhGvUgV",14) == 1179866511) strcat(s, "d");
if (crc32("VYLFI",5) == 400025677) strcat(s, "e");
if (crc32("YuxTHQtx",8) == 221017172) strcat(s, "m");
if (crc32("vKzlUmRtO",9) == 3722331462) strcat(s, "a");
if (crc32("sUHmbVrD",8) == 1310936114) strcat(s, "C");
if (crc32("hNqaLySwL",9) == 1321781392) strcat(s, "l");
    return s;
}

char *doubledated_verbs() {
    char *s = calloc(12);
    if (crc32("JJZmqJvWrooJZA",14) == 1423869358) strcat(s, "d");
if (crc32("nYIGlpmAiTjdjj",14) == 334084895) strcat(s, "o");
if (crc32("RxpzBcYEo",9) == 1608590101) strcat(s, "G");
if (crc32("xQwDPabU",8) == 3937629780) strcat(s, "u");
if (crc32("smwcfOtbqPPOfuN",15) == 3108814675) strcat(s, "b");
if (crc32("APOEsRZYix",10) == 3833069532) strcat(s, "l");
if (crc32("foRIlOZibxyRN",13) == 1423777453) strcat(s, "e");
if (crc32("kSdSNgnxJu",10) == 1919741068) strcat(s, "d");
if (crc32("hlbOyjOKVJwk",12) == 3221063557) strcat(s, "a");
if (crc32("GfJyCmZKNS",10) == 3719422784) strcat(s, "t");
if (crc32("ArTmgBAeP",9) == 2859718707) strcat(s, "C");
if (crc32("YBBduHv",7) == 742000831) strcat(s, "e");
if (crc32("BGeSRs",6) == 1371338700) strcat(s, "q");
if (crc32("ISjhTkT",7) == 1783596128) strcat(s, "d");
    return s;
}

char *jackup_verbs() {
    char *s = calloc(7);
    if (crc32("SNMtUaXhaiwz",12) == 946960750) strcat(s, "v");
if (crc32("TlzJYhfqN",9) == 2292446891) strcat(s, "j");
if (crc32("tskFJXWxbmKga",13) == 1287166220) strcat(s, "a");
if (crc32("PqHmejf",7) == 2866256496) strcat(s, "c");
if (crc32("KNMNfSqGukGNLUP",15) == 1527954059) strcat(s, "C");
if (crc32("VjSgGkDaz",9) == 485969770) strcat(s, "k");
if (crc32("UGujVK",6) == 1764620139) strcat(s, "E");
if (crc32("AEofoecCpJem",12) == 72649531) strcat(s, "u");
if (crc32("oFAyCzyJi",9) == 1259956823) strcat(s, "x");
if (crc32("uMWKSYVEDelCfS",14) == 4127593953) strcat(s, "p");
    return s;
}

char *situated_verbs() {
    char *s = calloc(9);
    if (crc32("FbtvoIfa",8) == 918003800) strcat(s, "s");
if (crc32("iAoth",5) == 974718204) strcat(s, "s");
if (crc32("iEyiQaMzsufiQ",13) == 4197763875) strcat(s, "O");
if (crc32("PCyKSuyMgSvMp",13) == 1886106968) strcat(s, "i");
if (crc32("HxWMMnDffvngz",13) == 2747108774) strcat(s, "V");
if (crc32("KJSrxy",6) == 2263629296) strcat(s, "t");
if (crc32("PDQyADulbSgm",12) == 4061366695) strcat(s, "m");
if (crc32("QFQLPhNoGFMi",12) == 1285823811) strcat(s, "u");
if (crc32("LllnOKM",7) == 203318778) strcat(s, "A");
if (crc32("aQsDrm",6) == 1460320216) strcat(s, "a");
if (crc32("nRzxxBNDl",9) == 1114847764) strcat(s, "w");
if (crc32("orlOtvGceiJ",11) == 2060161981) strcat(s, "t");
if (crc32("pJqdiDGMfWJ",11) == 2309463259) strcat(s, "e");
if (crc32("PBprS",5) == 1207468137) strcat(s, "S");
if (crc32("NNrxYVPes",9) == 915881562) strcat(s, "d");
    return s;
}

char *awaked_verbs() {
    char *s = calloc(7);
    if (crc32("taMubdH",7) == 2603442459) strcat(s, "M");
if (crc32("mvXHHLPOQvTbS",13) == 2169770508) strcat(s, "a");
if (crc32("HlDxCYapapL",11) == 3092473974) strcat(s, "w");
if (crc32("COFmWDKVIDcy",12) == 2634370846) strcat(s, "J");
if (crc32("CqsRPCOiOcaRRja",15) == 1545423685) strcat(s, "a");
if (crc32("dwPptOeTpjAi",12) == 1672274822) strcat(s, "n");
if (crc32("AfhwFOkcNCTBEzl",15) == 2198031738) strcat(s, "k");
if (crc32("ShAdEkAlaKMKKwU",15) == 4160882071) strcat(s, "U");
if (crc32("JoMmWgt",7) == 4189948816) strcat(s, "e");
if (crc32("YvjHjxHhz",9) == 3492906523) strcat(s, "J");
if (crc32("zERWpJW",7) == 897608700) strcat(s, "d");
    return s;
}

char *enervating_verbs() {
    char *s = calloc(11);
    if (crc32("jpYDtKX",7) == 3379244183) strcat(s, "n");
if (crc32("YhERSanUJFZYZ",13) == 1213154247) strcat(s, "e");
if (crc32("JDApxcUlZYefLr",14) == 3209526712) strcat(s, "T");
if (crc32("jbEhrWbw",8) == 4288160797) strcat(s, "n");
if (crc32("DTgSQPilwmDVL",13) == 3649462372) strcat(s, "P");
if (crc32("BPCOQwcdyeOH",12) == 2932445024) strcat(s, "e");
if (crc32("wXRaatdccLAoxn",14) == 2399518619) strcat(s, "e");
if (crc32("gPxiQHGXolFGai",14) == 507653336) strcat(s, "r");
if (crc32("QJlNWWQZSa",10) == 1334902821) strcat(s, "v");
if (crc32("vxwyjXp",7) == 3477573276) strcat(s, "a");
if (crc32("ZjFtnhfs",8) == 2208080618) strcat(s, "n");
if (crc32("YTXRckvyU",9) == 1071455786) strcat(s, "t");
if (crc32("hALwxQ",6) == 1258313377) strcat(s, "i");
if (crc32("iXtSLT",6) == 3076768554) strcat(s, "o");
if (crc32("yGGtHHv",7) == 117444284) strcat(s, "n");
if (crc32("GfFBjUVrFDQHL",13) == 2537714885) strcat(s, "g");
    return s;
}

char *illused_verbs() {
    char *s = calloc(8);
    if (crc32("JniKpOQYVftnXcr",15) == 2421296866) strcat(s, "i");
if (crc32("HTcsJc",6) == 208319777) strcat(s, "S");
if (crc32("gJfPVv",6) == 2433119773) strcat(s, "l");
if (crc32("RPwNnGw",7) == 646047665) strcat(s, "l");
if (crc32("LOCoRPEKROmx",12) == 762588506) strcat(s, "u");
if (crc32("xqHkCwKI",8) == 886576812) strcat(s, "z");
if (crc32("AQbBN",5) == 3363352701) strcat(s, "s");
if (crc32("myVTmrVr",8) == 2089869112) strcat(s, "v");
if (crc32("vlzgWd",6) == 3326355132) strcat(s, "e");
if (crc32("xMqgXeftidATho",14) == 741796580) strcat(s, "Z");
if (crc32("VoxNs",5) == 4011872710) strcat(s, "d");
    return s;
}

char *laving_verbs() {
    char *s = calloc(7);
    if (crc32("irhnKkF",7) == 2280555187) strcat(s, "a");
if (crc32("AefsEIyfv",9) == 1976901884) strcat(s, "l");
if (crc32("EKwlnNshbpohL",13) == 2518933362) strcat(s, "d");
if (crc32("rozIODPAtngCf",13) == 1604561319) strcat(s, "a");
if (crc32("zVysXTgXRKetOKc",15) == 2110456760) strcat(s, "z");
if (crc32("CCgIDeM",7) == 3409572705) strcat(s, "v");
if (crc32("pTlrGfDhdh",10) == 201677271) strcat(s, "C");
if (crc32("wYUHYnumLeZSZX",14) == 29551637) strcat(s, "i");
if (crc32("rJPqhpVmhjn",11) == 3896595155) strcat(s, "n");
if (crc32("nOeAfWTqxQ",10) == 3920672739) strcat(s, "g");
    return s;
}

char *anticking_verbs() {
    char *s = calloc(10);
    if (crc32("NTmlooXuFQJ",11) == 1876837551) strcat(s, "c");
if (crc32("NjKlxLSfPIt",11) == 779295188) strcat(s, "a");
if (crc32("nZuOn",5) == 3410060505) strcat(s, "n");
if (crc32("dOKZVqZkNZPL",12) == 3515339546) strcat(s, "t");
if (crc32("iVUImIbUqUVN",12) == 670620912) strcat(s, "i");
if (crc32("zkmwpgBs",8) == 58661453) strcat(s, "i");
if (crc32("sHEDkGVku",9) == 2979503088) strcat(s, "H");
if (crc32("hpwnHaZaIJlvpO",14) == 2066569495) strcat(s, "c");
if (crc32("GvDpLytMTCnW",12) == 1100733640) strcat(s, "k");
if (crc32("btBiIupxsS",10) == 814310736) strcat(s, "i");
if (crc32("KdaEbliYpIRre",13) == 133461307) strcat(s, "n");
if (crc32("MwLIzQqeekhVLtu",15) == 3518751270) strcat(s, "a");
if (crc32("OsxaYjyZrvbXMj",14) == 3775549097) strcat(s, "g");
    return s;
}

char *convening_verbs() {
    char *s = calloc(10);
    if (crc32("XMWQEVfc",8) == 2862624496) strcat(s, "i");
if (crc32("kdfRua",6) == 2798322123) strcat(s, "c");
if (crc32("lSJBOainyPUE",12) == 3560904745) strcat(s, "C");
if (crc32("aBHuiXhVGgfCIPf",15) == 1218544435) strcat(s, "o");
if (crc32("OiLGglkAZwrfN",13) == 55052540) strcat(s, "n");
if (crc32("ITBCQVwfA",9) == 2547725739) strcat(s, "v");
if (crc32("nitAio",6) == 123889127) strcat(s, "v");
if (crc32("YYSTaI",6) == 1856753876) strcat(s, "e");
if (crc32("PVyDWTIG",8) == 3467527104) strcat(s, "O");
if (crc32("BbDkpH",6) == 392983830) strcat(s, "n");
if (crc32("dfyUpkv",7) == 1605839060) strcat(s, "i");
if (crc32("oAtQI",5) == 1539936199) strcat(s, "T");
if (crc32("gcvZqaImbofiUHo",15) == 810983211) strcat(s, "n");
if (crc32("LYqyMCpNVIX",11) == 2753566297) strcat(s, "g");
    return s;
}

char *reprobing_verbs() {
    char *s = calloc(10);
    if (crc32("jkdJnvbHXLpov",13) == 2845912067) strcat(s, "i");
if (crc32("vsbHspfiEVLDE",13) == 4107361090) strcat(s, "r");
if (crc32("hUXWddJrwBwbj",13) == 1152084022) strcat(s, "e");
if (crc32("QZHjk",5) == 1463520033) strcat(s, "x");
if (crc32("pMGBLheESH",10) == 2285035438) strcat(s, "p");
if (crc32("XizPjbQl",8) == 2533987855) strcat(s, "r");
if (crc32("yUoTUwbRhG",10) == 2742610175) strcat(s, "o");
if (crc32("ojHllVaV",8) == 466212870) strcat(s, "b");
if (crc32("cWXIgt",6) == 3115783883) strcat(s, "i");
if (crc32("PWhBSTf",7) == 596733544) strcat(s, "n");
if (crc32("lOPrhmNknJV",11) == 266273773) strcat(s, "g");
    return s;
}

char *opaqued_verbs() {
    char *s = calloc(8);
    if (crc32("ZcbJkwdEI",9) == 941749033) strcat(s, "o");
if (crc32("pzGIFg",6) == 100638399) strcat(s, "p");
if (crc32("UtIPmzQvLM",10) == 1956323897) strcat(s, "a");
if (crc32("GWkUQF",6) == 2302335601) strcat(s, "r");
if (crc32("zYjLkoodz",9) == 3789322017) strcat(s, "q");
if (crc32("MPWKIW",6) == 3300266747) strcat(s, "u");
if (crc32("tBVkWTTNkO",10) == 3675828810) strcat(s, "p");
if (crc32("pwokHTyySgH",11) == 2971940634) strcat(s, "e");
if (crc32("ZLfPR",5) == 3299941191) strcat(s, "b");
if (crc32("kOSLFADUOxoqUgX",15) == 3028842252) strcat(s, "d");
    return s;
}

char *admitted_verbs() {
    char *s = calloc(9);
    if (crc32("LdNteI",6) == 2589143917) strcat(s, "a");
if (crc32("WaAkUxlhtMrhidv",15) == 2533126336) strcat(s, "d");
if (crc32("zrDCIyeMVyLnphx",15) == 1834388225) strcat(s, "T");
if (crc32("bImRERRZUSZ",11) == 2063006302) strcat(s, "m");
if (crc32("pEUJBJCbHbTa",12) == 3688007837) strcat(s, "I");
if (crc32("xmZNeXDLqZcMDE",14) == 2998362430) strcat(s, "i");
if (crc32("tPHrd",5) == 2399650072) strcat(s, "o");
if (crc32("XGZlDCy",7) == 424029673) strcat(s, "t");
if (crc32("mFhEZZy",7) == 2736937097) strcat(s, "t");
if (crc32("EQCoNMaIkM",10) == 1624859141) strcat(s, "C");
if (crc32("WTPCMqvR",8) == 1053535827) strcat(s, "e");
if (crc32("BJWXNwOKyOqIk",13) == 234031333) strcat(s, "d");
    return s;
}

char *spindled_verbs() {
    char *s = calloc(9);
    if (crc32("PDPkTh",6) == 1444323010) strcat(s, "v");
if (crc32("hQRSVybcKMgpOC",14) == 3832383992) strcat(s, "s");
if (crc32("anHZUM",6) == 1436543859) strcat(s, "o");
if (crc32("ZRVvBanCut",10) == 1194227442) strcat(s, "p");
if (crc32("ejfiYTxRbTT",11) == 476759232) strcat(s, "i");
if (crc32("ppFjAWahxaA",11) == 27751906) strcat(s, "n");
if (crc32("nPFyvAK",7) == 3556724848) strcat(s, "d");
if (crc32("ltJoITUnIANEA",13) == 3366850188) strcat(s, "l");
if (crc32("JIDPcXoMDDYDG",13) == 1899616777) strcat(s, "e");
if (crc32("xiHDvVEGwCOg",12) == 1098729211) strcat(s, "Y");
if (crc32("wZictlipwsqSys",14) == 1441118483) strcat(s, "d");
    return s;
}

char *underlining_verbs() {
    char *s = calloc(12);
    if (crc32("cveTCpPnxMQuaGz",15) == 3345089765) strcat(s, "u");
if (crc32("RvgWKnbsYkwEFX",14) == 998025911) strcat(s, "n");
if (crc32("YFoyXZVpMVvmeW",14) == 2448035139) strcat(s, "g");
if (crc32("MsICws",6) == 2177157527) strcat(s, "d");
if (crc32("NeFOmXyzBmwO",12) == 572518114) strcat(s, "e");
if (crc32("XlvklsHUqVnh",12) == 1955891588) strcat(s, "r");
if (crc32("zrLZigSvtDFxNK",14) == 2340094240) strcat(s, "l");
if (crc32("TBrTKqoIBsiCDEz",15) == 3325165894) strcat(s, "i");
if (crc32("qYnuCUBGAUCx",12) == 3817703) strcat(s, "n");
if (crc32("DDepagUMf",9) == 2480827400) strcat(s, "i");
if (crc32("WXzcuUcuHc",10) == 3895197931) strcat(s, "S");
if (crc32("IAVttTXZ",8) == 289213334) strcat(s, "n");
if (crc32("cgINHsrM",8) == 2819058407) strcat(s, "a");
if (crc32("vMyKWu",6) == 1941377168) strcat(s, "g");
    return s;
}

char *slaking_verbs() {
    char *s = calloc(8);
    if (crc32("rBlwVPyQgNNJg",13) == 1578028609) strcat(s, "s");
if (crc32("uxdqLr",6) == 1639658900) strcat(s, "M");
if (crc32("kKomVlSa",8) == 841445655) strcat(s, "l");
if (crc32("ZApeLTsMmppnxkm",15) == 4047598668) strcat(s, "K");
if (crc32("WQJbiDCkSNo",11) == 288892702) strcat(s, "a");
if (crc32("VXXgfKvcONpaeM",14) == 1698457838) strcat(s, "k");
if (crc32("txyeioYRSR",10) == 3298164503) strcat(s, "i");
if (crc32("qcxRZv",6) == 831202151) strcat(s, "Z");
if (crc32("NVEOOrPhBHJ",11) == 3499388499) strcat(s, "n");
if (crc32("cnBXaBuQJ",9) == 2266191335) strcat(s, "g");
    return s;
}

char *weighdown_verbs() {
    char *s = calloc(10);
    if (crc32("PFHbudZrSH",10) == 1011796245) strcat(s, "w");
if (crc32("TKSEwHELVyeHCJ",14) == 4038073421) strcat(s, "t");
if (crc32("amkZnhfwGSw",11) == 830625449) strcat(s, "e");
if (crc32("xZmSBIj",7) == 2821086391) strcat(s, "i");
if (crc32("Ukzngi",6) == 1534786805) strcat(s, "g");
if (crc32("HbNeVYShSW",10) == 3990520793) strcat(s, "h");
if (crc32("oagKmTJI",8) == 3700788124) strcat(s, "d");
if (crc32("BHrIuj",6) == 1786630117) strcat(s, "g");
if (crc32("yGBrZQZNpDjQwR",14) == 1309195699) strcat(s, "o");
if (crc32("MAZFEKZuW",9) == 1747814274) strcat(s, "w");
if (crc32("rsfLtVZ",7) == 4066276002) strcat(s, "m");
if (crc32("KMdVNcCyEWT",11) == 468788916) strcat(s, "n");
    return s;
}

char *accompany_verbs() {
    char *s = calloc(10);
    if (crc32("wFznsmWBZGXF",12) == 2811166101) strcat(s, "a");
if (crc32("osQUOjclYM",10) == 3304037151) strcat(s, "c");
if (crc32("HSFwBgIKoOJd",12) == 3516387294) strcat(s, "c");
if (crc32("DzlDxDesVw",10) == 3473385412) strcat(s, "D");
if (crc32("pArXFKgtzQFv",12) == 3045825678) strcat(s, "o");
if (crc32("xMKETnsUpAixQK",14) == 1400743425) strcat(s, "m");
if (crc32("hlfNU",5) == 2429351770) strcat(s, "P");
if (crc32("jDagqcQV",8) == 3293409158) strcat(s, "p");
if (crc32("uRXypn",6) == 2705787196) strcat(s, "p");
if (crc32("EmGebSqVEMm",11) == 1981519490) strcat(s, "a");
if (crc32("HJuwZuKNTcVWyl",14) == 2096158164) strcat(s, "J");
if (crc32("uKPIjSwTpCL",11) == 2628165455) strcat(s, "n");
if (crc32("cbGHdpBdUJwhH",13) == 1741918115) strcat(s, "y");
    return s;
}

char *gelatinized_verbs() {
    char *s = calloc(12);
    if (crc32("yZbTIZfROdpkXrG",15) == 2784590317) strcat(s, "g");
if (crc32("yZNIGspaXfwX",12) == 3168833203) strcat(s, "g");
if (crc32("XkWas",5) == 1086710028) strcat(s, "F");
if (crc32("JPEiUAbMVDiKDh",14) == 1931038230) strcat(s, "e");
if (crc32("kuWriJhRrfgbrhD",15) == 3743600399) strcat(s, "h");
if (crc32("GmbdvNhrmAgZq",13) == 2149209817) strcat(s, "l");
if (crc32("RkcQJ",5) == 401517142) strcat(s, "a");
if (crc32("SPSPIMVxHJp",11) == 1923191615) strcat(s, "t");
if (crc32("IXYEVZXtPztXXpp",15) == 3569685968) strcat(s, "H");
if (crc32("uMWKjGRa",8) == 160491273) strcat(s, "i");
if (crc32("LzHIbQzpGBoR",12) == 4223086934) strcat(s, "n");
if (crc32("SKVTOfYodZ",10) == 1046486826) strcat(s, "i");
if (crc32("mvyfSLODGR",10) == 2264131057) strcat(s, "z");
if (crc32("ZGpCc",5) == 3915121799) strcat(s, "e");
if (crc32("mwVLHpYsFwd",11) == 4124128377) strcat(s, "d");
    return s;
}

char *grouch_verbs() {
    char *s = calloc(7);
    if (crc32("PZBZbAInYHHAfeK",15) == 2947226816) strcat(s, "V");
if (crc32("ylSnNvmfjVSYhB",14) == 2043756651) strcat(s, "g");
if (crc32("jOrlrbR",7) == 1000147643) strcat(s, "r");
if (crc32("jCaMyhhF",8) == 1346976893) strcat(s, "o");
if (crc32("tVpmQ",5) == 3102756358) strcat(s, "J");
if (crc32("VNItHzBXwisx",12) == 4043077432) strcat(s, "u");
if (crc32("rdpjhASCBwMUgUB",15) == 3170634853) strcat(s, "X");
if (crc32("bUbHckZHqxhYGT",14) == 280378256) strcat(s, "c");
if (crc32("COyabEjT",8) == 3966139232) strcat(s, "h");
    return s;
}

char *quadrupled_verbs() {
    char *s = calloc(11);
    if (crc32("WUGBOkHNLGNKhOm",15) == 1890146487) strcat(s, "q");
if (crc32("zaWzKBbFxMeNOs",14) == 1710010995) strcat(s, "T");
if (crc32("mlNzYIWnS",9) == 3239846773) strcat(s, "u");
if (crc32("YyMngBwlJQjKMx",14) == 2027473079) strcat(s, "a");
if (crc32("KlGBSIS",7) == 729423610) strcat(s, "Q");
if (crc32("SntPD",5) == 4204452455) strcat(s, "d");
if (crc32("zqqMItGerDeNJ",13) == 3337474235) strcat(s, "r");
if (crc32("PfogEHUAAfc",11) == 638798112) strcat(s, "u");
if (crc32("tfBUfCopUCAJhjU",15) == 525305290) strcat(s, "p");
if (crc32("LGcVirxY",8) == 1199905466) strcat(s, "l");
if (crc32("yDCzyeNStj",10) == 2410114857) strcat(s, "R");
if (crc32("sqSatDKwKc",10) == 135890068) strcat(s, "e");
if (crc32("LiHyPyPHaGZP",12) == 389624517) strcat(s, "w");
if (crc32("OOUJONoGDDI",11) == 3072877129) strcat(s, "d");
    return s;
}

char *crinkle_verbs() {
    char *s = calloc(8);
    if (crc32("odKCc",5) == 72712569) strcat(s, "v");
if (crc32("cWfjFgsOOMUA",12) == 3959179300) strcat(s, "c");
if (crc32("pPjUUaYAFZJ",11) == 2419485728) strcat(s, "P");
if (crc32("ZWiMJJKkqwM",11) == 1486521250) strcat(s, "r");
if (crc32("dNJnvGtO",8) == 748542614) strcat(s, "d");
if (crc32("EgqGv",5) == 2746081330) strcat(s, "i");
if (crc32("oqWhZsZegO",10) == 4163581573) strcat(s, "f");
if (crc32("UtgLkeMs",8) == 3335599198) strcat(s, "n");
if (crc32("ZTqSFByEDbPf",12) == 4139590822) strcat(s, "k");
if (crc32("DxzdrtFncjBZhc",14) == 1491788224) strcat(s, "l");
if (crc32("tUUrLQToPVbO",12) == 2975939717) strcat(s, "e");
    return s;
}

char *unjoin_verbs() {
    char *s = calloc(7);
    if (crc32("ZPCcHAVw",8) == 230782805) strcat(s, "Y");
if (crc32("AipBSdR",7) == 1915388362) strcat(s, "u");
if (crc32("QiHLPED",7) == 511149979) strcat(s, "n");
if (crc32("RPdqwzEM",8) == 751744408) strcat(s, "j");
if (crc32("VlgNKZUZYmaVHu",14) == 3771546074) strcat(s, "o");
if (crc32("XSTFSU",6) == 3563168569) strcat(s, "u");
if (crc32("sNWSGXgaQAHRN",13) == 579647993) strcat(s, "i");
if (crc32("OyvAfxtMiJshEik",15) == 492011445) strcat(s, "d");
if (crc32("BiReziLy",8) == 917584840) strcat(s, "n");
    return s;
}

char *freeze_verbs() {
    char *s = calloc(7);
    if (crc32("vBvmqcU",7) == 4017632449) strcat(s, "f");
if (crc32("wuEaoxfmMAy",11) == 1552296897) strcat(s, "u");
if (crc32("EvCSLrVZn",9) == 965781904) strcat(s, "r");
if (crc32("rlKVkU",6) == 314969356) strcat(s, "e");
if (crc32("hlsPcZ",6) == 3657373588) strcat(s, "e");
if (crc32("yYppGGwXeSJykHb",15) == 3369753832) strcat(s, "f");
if (crc32("vWOGxaMBgaOhjyw",15) == 2369805579) strcat(s, "z");
if (crc32("KxUAXPeBk",9) == 3855551420) strcat(s, "e");
    return s;
}

char *decompress_verbs() {
    char *s = calloc(11);
    if (crc32("RqWlnLyzOscUZk",14) == 2629284358) strcat(s, "C");
if (crc32("mtroPucM",8) == 3035198013) strcat(s, "d");
if (crc32("bzHiKSCsHNwO",12) == 592799791) strcat(s, "R");
if (crc32("uTyDlcycaWCwC",13) == 2578496330) strcat(s, "e");
if (crc32("nqPcaaqdIO",10) == 3687244830) strcat(s, "N");
if (crc32("MYnaKnkyU",9) == 3459799353) strcat(s, "c");
if (crc32("TMIpb",5) == 3186600162) strcat(s, "L");
if (crc32("SVKthldBSWZk",12) == 3206511095) strcat(s, "o");
if (crc32("TBsuR",5) == 3140904386) strcat(s, "m");
if (crc32("FgqewXbG",8) == 3827114843) strcat(s, "P");
if (crc32("sGMOeKJ",7) == 4198353924) strcat(s, "p");
if (crc32("FSEEXCr",7) == 193259916) strcat(s, "r");
if (crc32("fwaJKpyB",8) == 1043192192) strcat(s, "x");
if (crc32("NRrzSAp",7) == 2551387232) strcat(s, "e");
if (crc32("HBLXvQsXLS",10) == 2634550347) strcat(s, "s");
if (crc32("VZNaumaDPIOA",12) == 3276157079) strcat(s, "H");
if (crc32("ROvlBn",6) == 1308322587) strcat(s, "s");
    return s;
}

char *dehydrated_verbs() {
    char *s = calloc(11);
    if (crc32("MyPOYbgwHanm",12) == 2291766098) strcat(s, "q");
if (crc32("DbBcOAyC",8) == 3956905281) strcat(s, "d");
if (crc32("rqEMOL",6) == 4019793147) strcat(s, "e");
if (crc32("JfqXGef",7) == 1578481149) strcat(s, "w");
if (crc32("VWgcGsX",7) == 3658784954) strcat(s, "h");
if (crc32("CjlzvkKJY",9) == 505116624) strcat(s, "O");
if (crc32("nTiADL",6) == 2460384838) strcat(s, "y");
if (crc32("rvwRgETZmX",10) == 2501243135) strcat(s, "d");
if (crc32("fubSSjHoxWZUm",13) == 3376309121) strcat(s, "r");
if (crc32("znBSyJiso",9) == 2165927377) strcat(s, "a");
if (crc32("eWApWzNps",9) == 1422324495) strcat(s, "t");
if (crc32("sqkRWM",6) == 2253286353) strcat(s, "e");
if (crc32("gALaiwptbFP",11) == 3563735949) strcat(s, "d");
    return s;
}

char *regripped_verbs() {
    char *s = calloc(10);
    if (crc32("EQPPeTkStjLzF",13) == 1723278001) strcat(s, "r");
if (crc32("EkQshEQE",8) == 3650814847) strcat(s, "e");
if (crc32("ZVwzzGOq",8) == 460288649) strcat(s, "I");
if (crc32("VXtBKRPlgw",10) == 752206896) strcat(s, "g");
if (crc32("PfplaNNjLl",10) == 2542393156) strcat(s, "r");
if (crc32("QkVLgNxGQVIflm",14) == 3886987556) strcat(s, "C");
if (crc32("TSeZmKswZxn",11) == 3362965651) strcat(s, "i");
if (crc32("PhLGb",5) == 1705462312) strcat(s, "p");
if (crc32("GpPdjsupV",9) == 354355225) strcat(s, "p");
if (crc32("yRdYsq",6) == 3568508599) strcat(s, "K");
if (crc32("DlOdHcOVIQPdI",13) == 3579909872) strcat(s, "e");
if (crc32("jJwLi",5) == 3625289608) strcat(s, "d");
    return s;
}

char *purposing_verbs() {
    char *s = calloc(10);
    if (crc32("ERbdSKJsz",9) == 591897834) strcat(s, "g");
if (crc32("JuSmKMVCXK",10) == 734325361) strcat(s, "p");
if (crc32("UCYpCvh",7) == 3236847820) strcat(s, "c");
if (crc32("VzcOmqFvrRMgM",13) == 1091737749) strcat(s, "u");
if (crc32("wMEpgiKAZNdrYa",14) == 1593912580) strcat(s, "r");
if (crc32("lAlIZWvOWS",10) == 3357334531) strcat(s, "m");
if (crc32("gqxcCEIIYkVcw",13) == 4079522014) strcat(s, "p");
if (crc32("IRHbFehAbN",10) == 1590783230) strcat(s, "Q");
if (crc32("RSnVpEfsnvWZX",13) == 1268804824) strcat(s, "o");
if (crc32("TazYq",5) == 3519990298) strcat(s, "H");
if (crc32("VkthibAH",8) == 3660799565) strcat(s, "s");
if (crc32("nGtmt",5) == 840974070) strcat(s, "i");
if (crc32("PXSNtjWuU",9) == 3919495240) strcat(s, "Z");
if (crc32("gaDIOobg",8) == 1460042352) strcat(s, "n");
if (crc32("bVZGPI",6) == 2148855407) strcat(s, "P");
if (crc32("wKiNmPeQp",9) == 978759327) strcat(s, "g");
    return s;
}

char *triturated_verbs() {
    char *s = calloc(11);
    if (crc32("HkbIf",5) == 1689421410) strcat(s, "E");
if (crc32("SkgFTksEdWme",12) == 2821893954) strcat(s, "t");
if (crc32("BjDjZDxm",8) == 2399342386) strcat(s, "h");
if (crc32("DdSnon",6) == 2586264837) strcat(s, "r");
if (crc32("WmTezqMWbjFZ",12) == 3119854003) strcat(s, "i");
if (crc32("MGmOmsxkzmz",11) == 740009575) strcat(s, "t");
if (crc32("VNCxy",5) == 3070734648) strcat(s, "a");
if (crc32("BuMYE",5) == 2910707979) strcat(s, "u");
if (crc32("FHRanaXvkXeG",12) == 1051509169) strcat(s, "r");
if (crc32("FidpdMP",7) == 4087591934) strcat(s, "a");
if (crc32("UKoryocRfHFcoAW",15) == 1269761743) strcat(s, "q");
if (crc32("NobGQlh",7) == 1922343226) strcat(s, "t");
if (crc32("qqdlPR",6) == 1207347252) strcat(s, "t");
if (crc32("avhldMIVQXtzaW",14) == 3566072957) strcat(s, "e");
if (crc32("aEbhVbIQndKdEeS",15) == 279630900) strcat(s, "O");
if (crc32("rokHbvYklBiyj",13) == 3289774200) strcat(s, "d");
    return s;
}

char *misfocusing_verbs() {
    char *s = calloc(12);
    if (crc32("EJKnuy",6) == 4283038902) strcat(s, "a");
if (crc32("KzkPorrVsgbg",12) == 1316400042) strcat(s, "m");
if (crc32("qKUkU",5) == 3120175634) strcat(s, "i");
if (crc32("hwbkDHOqhrMKP",13) == 1224878625) strcat(s, "s");
if (crc32("ZdxjnebywONEVe",14) == 1479794280) strcat(s, "f");
if (crc32("UcGvFqDCpXdPvp",14) == 1685741585) strcat(s, "M");
if (crc32("ObeyZnGB",8) == 3831414305) strcat(s, "o");
if (crc32("NMyYvnt",7) == 2217995664) strcat(s, "c");
if (crc32("wPFoE",5) == 3592025957) strcat(s, "u");
if (crc32("uPNax",5) == 585185909) strcat(s, "w");
if (crc32("EodnpbrXg",9) == 2835130099) strcat(s, "s");
if (crc32("LBMRWtphNfGUQ",13) == 893105704) strcat(s, "i");
if (crc32("YJTzUqEtfPrb",12) == 4090031714) strcat(s, "n");
if (crc32("OZgGoFWU",8) == 1911889416) strcat(s, "v");
if (crc32("ndGvMIuyOkw",11) == 2026180027) strcat(s, "g");
    return s;
}

char *misdeal_verbs() {
    char *s = calloc(8);
    if (crc32("zBuAVyFMbOQ",11) == 1081976964) strcat(s, "m");
if (crc32("taSTcTkCeIofm",13) == 3614670643) strcat(s, "i");
if (crc32("GsgCHh",6) == 2986987820) strcat(s, "s");
if (crc32("spVLHnFXusH",11) == 174780170) strcat(s, "h");
if (crc32("RrHkYXrdjXRBLIm",15) == 2963981122) strcat(s, "d");
if (crc32("xxAMXHWlprg",11) == 592835616) strcat(s, "e");
if (crc32("WTEWGemETcNnvb",14) == 3255654858) strcat(s, "b");
if (crc32("liBiiMAeZ",9) == 1889907311) strcat(s, "a");
if (crc32("nCTnA",5) == 4170283169) strcat(s, "l");
    return s;
}

char *bethink_verbs() {
    char *s = calloc(8);
    if (crc32("TNfWeUvBZw",10) == 2925969705) strcat(s, "b");
if (crc32("viKaLDXYh",9) == 3967476288) strcat(s, "e");
if (crc32("olOPTtXYaovkqh",14) == 798843611) strcat(s, "t");
if (crc32("SxYzupDTfeGTjJn",15) == 205460857) strcat(s, "N");
if (crc32("qRbHrG",6) == 695783387) strcat(s, "h");
if (crc32("rsLPwzdUN",9) == 3282084905) strcat(s, "i");
if (crc32("ysSJsyKo",8) == 2144211839) strcat(s, "n");
if (crc32("ECQMQtcS",8) == 3524166123) strcat(s, "B");
if (crc32("huSkWLNMrIRZ",12) == 2732346184) strcat(s, "k");
    return s;
}

char *make_verbs() {
    char *s = calloc(5);
    if (crc32("KpRKPsjlgJSx",12) == 3988962191) strcat(s, "o");
if (crc32("zqTHXGBJUl",10) == 2254929554) strcat(s, "m");
if (crc32("rlPJsqadaHczDl",14) == 3811215966) strcat(s, "T");
if (crc32("MfbJKmDowY",10) == 4094402044) strcat(s, "a");
if (crc32("RGYlfHpUfUT",11) == 2272980710) strcat(s, "k");
if (crc32("MypZrYyMGwRREU",14) == 1447894103) strcat(s, "G");
if (crc32("YaUEXaPLee",10) == 892752443) strcat(s, "e");
    return s;
}

char *aquaplaning_verbs() {
    char *s = calloc(12);
    if (crc32("cFQMRzITcryBrV",14) == 2275219644) strcat(s, "c");
if (crc32("JirGudhMkpRKGSU",15) == 3081906830) strcat(s, "a");
if (crc32("uCLREjiyFk",10) == 869759330) strcat(s, "q");
if (crc32("MasgcBm",7) == 3628468102) strcat(s, "u");
if (crc32("gMLCbuDYzkB",11) == 4254436115) strcat(s, "a");
if (crc32("vQCpqYyLHgU",11) == 110945940) strcat(s, "T");
if (crc32("xehblkinwsrri",13) == 924562713) strcat(s, "p");
if (crc32("umkSFgG",7) == 371130951) strcat(s, "l");
if (crc32("fwIczneoSIX",11) == 1855944564) strcat(s, "P");
if (crc32("INAOd",5) == 2758603607) strcat(s, "a");
if (crc32("fFqNvGXVATxYuFM",15) == 750605733) strcat(s, "n");
if (crc32("iwUIsZVx",8) == 544706280) strcat(s, "n");
if (crc32("zybnzVRw",8) == 1747151111) strcat(s, "i");
if (crc32("MXisCUNvUcGWvT",14) == 3598776592) strcat(s, "B");
if (crc32("RoWouZvbaCVntK",14) == 3994125526) strcat(s, "n");
if (crc32("VHNDrB",6) == 1983736598) strcat(s, "n");
if (crc32("HxdxBrikN",9) == 3608188324) strcat(s, "g");
    return s;
}

char *saponify_verbs() {
    char *s = calloc(9);
    if (crc32("aEIehXwe",8) == 2785126884) strcat(s, "M");
if (crc32("nbbPMvtmwtpQdGq",15) == 2737337478) strcat(s, "s");
if (crc32("amZCWeWDys",10) == 3733872011) strcat(s, "e");
if (crc32("ViWwDDqiHIWysQH",15) == 3926611044) strcat(s, "a");
if (crc32("xGvLvQGqljm",11) == 846045713) strcat(s, "p");
if (crc32("tYfTXT",6) == 3591853288) strcat(s, "U");
if (crc32("VFGCNitXeUsl",12) == 2439460652) strcat(s, "o");
if (crc32("arbmS",5) == 3391408925) strcat(s, "n");
if (crc32("CnfEF",5) == 3253002319) strcat(s, "i");
if (crc32("dGEpQofVzaQt",12) == 319927266) strcat(s, "i");
if (crc32("PQnFJrljCqk",11) == 250403018) strcat(s, "f");
if (crc32("OAMHmHycZcB",11) == 3925393818) strcat(s, "y");
    return s;
}

char *coft_verbs() {
    char *s = calloc(5);
    if (crc32("CPmOFm",6) == 357043418) strcat(s, "s");
if (crc32("AnQMwtKSRdt",11) == 318261303) strcat(s, "c");
if (crc32("moxUlQcw",8) == 609181480) strcat(s, "z");
if (crc32("YiCCPydqqtMvpi",14) == 3422727481) strcat(s, "o");
if (crc32("CQVAJvBeHZfDEK",14) == 3500017358) strcat(s, "f");
if (crc32("xiWpzGIgXRYTmZ",14) == 807553077) strcat(s, "t");
    return s;
}

char *disfrock_verbs() {
    char *s = calloc(9);
    if (crc32("lTquTiUKjs",10) == 209359799) strcat(s, "d");
if (crc32("cZCSXVLHEIcrzAs",15) == 3597630579) strcat(s, "i");
if (crc32("gtZoZIvxsq",10) == 93721180) strcat(s, "U");
if (crc32("KziykpaH",8) == 1053022605) strcat(s, "s");
if (crc32("XvAuklXtWK",10) == 1991864163) strcat(s, "S");
if (crc32("doQJx",5) == 4041464771) strcat(s, "f");
if (crc32("rwBodYbcI",9) == 279793842) strcat(s, "d");
if (crc32("HEUwqi",6) == 1845358229) strcat(s, "r");
if (crc32("qQDJsaCxoVUcA",13) == 3074728514) strcat(s, "o");
if (crc32("pTnAtR",6) == 333721220) strcat(s, "c");
if (crc32("ZNbxZSIWcbeUth",14) == 4072218681) strcat(s, "N");
if (crc32("URTqDZpnswh",11) == 3658603997) strcat(s, "k");
    return s;
}

char *chagrinning_verbs() {
    char *s = calloc(12);
    if (crc32("HzapEfv",7) == 1666784510) strcat(s, "A");
if (crc32("MGCKOwbXKuU",11) == 3850136004) strcat(s, "c");
if (crc32("UKIUqZOiT",9) == 3826699909) strcat(s, "h");
if (crc32("olBcesKcJASkb",13) == 2495966046) strcat(s, "z");
if (crc32("xAwWISOrvmKIrb",14) == 4207498127) strcat(s, "a");
if (crc32("eJkymXDQiHLWoRG",15) == 4108981878) strcat(s, "d");
if (crc32("lUrAcM",6) == 3369378960) strcat(s, "g");
if (crc32("VNijyEpJwcm",11) == 97232735) strcat(s, "t");
if (crc32("FncyLCDporl",11) == 2584273561) strcat(s, "r");
if (crc32("mhNQuQV",7) == 1475529020) strcat(s, "C");
if (crc32("AhqoFogSt",9) == 2697196127) strcat(s, "i");
if (crc32("vIAwdikWRK",10) == 2537532699) strcat(s, "M");
if (crc32("EbcKkjbG",8) == 2938222946) strcat(s, "n");
if (crc32("chvkJRjz",8) == 81103803) strcat(s, "n");
if (crc32("QUshsoEPvkMn",12) == 4069254320) strcat(s, "i");
if (crc32("hdhazMryuaQbwc",14) == 1011082458) strcat(s, "c");
if (crc32("xMBqxdXm",8) == 425525979) strcat(s, "n");
if (crc32("iOvQf",5) == 4224472004) strcat(s, "z");
if (crc32("mkLoKPmCwYVvIJo",15) == 3257794371) strcat(s, "g");
    return s;
}

char *flush_verbs() {
    char *s = calloc(6);
    if (crc32("DkpqDc",6) == 3041638301) strcat(s, "f");
if (crc32("YBvHMuTLyyHGKN",14) == 3490681478) strcat(s, "l");
if (crc32("zzfWujGY",8) == 4028238850) strcat(s, "u");
if (crc32("qWGwmdTgQGcng",13) == 2440870189) strcat(s, "s");
if (crc32("nCHrzuCH",8) == 1750699426) strcat(s, "o");
if (crc32("FWdIiChwZcm",11) == 3982470565) strcat(s, "h");
    return s;
}

char *reaggregating_verbs() {
    char *s = calloc(14);
    if (crc32("IgCoPyo",7) == 1783924028) strcat(s, "r");
if (crc32("MOIOJfJxeXG",11) == 1055336585) strcat(s, "d");
if (crc32("NbvyDkkssbHc",12) == 730683764) strcat(s, "e");
if (crc32("jVtPXsyjUoYXBNo",15) == 3660155556) strcat(s, "a");
if (crc32("FtTyg",5) == 1639503609) strcat(s, "x");
if (crc32("kcWPXQbakmQ",11) == 1586124826) strcat(s, "g");
if (crc32("YEgkCqaSMSvOYA",14) == 3625438572) strcat(s, "g");
if (crc32("RLkSUVzssTmQSO",14) == 2784112689) strcat(s, "r");
if (crc32("ZyoZFIyr",8) == 3539446907) strcat(s, "e");
if (crc32("NbzaUJmi",8) == 2312272504) strcat(s, "E");
if (crc32("OIruONbTUUea",12) == 68345443) strcat(s, "g");
if (crc32("DrGtmc",6) == 4157267830) strcat(s, "a");
if (crc32("cLeFxmUuMYe",11) == 908941054) strcat(s, "t");
if (crc32("pYPvnVQgKcrzmD",14) == 2734581589) strcat(s, "H");
if (crc32("yJwPCa",6) == 4095297247) strcat(s, "i");
if (crc32("Yhlwex",6) == 2381916829) strcat(s, "e");
if (crc32("JqxUNeWdwKqpdb",14) == 2755543886) strcat(s, "n");
if (crc32("rjFFVIE",7) == 2206821967) strcat(s, "Y");
if (crc32("YfbuLbUgmfvTuIe",15) == 715315442) strcat(s, "g");
    return s;
}

char *outlining_verbs() {
    char *s = calloc(10);
    if (crc32("tUkvwYS",7) == 2971374488) strcat(s, "o");
if (crc32("AvzrsfPFaWvkaf",14) == 2762977696) strcat(s, "u");
if (crc32("hcTMZ",5) == 3811548338) strcat(s, "t");
if (crc32("hdqfdenaMK",10) == 3093214766) strcat(s, "D");
if (crc32("MybcZqZYwoDtE",13) == 1195237091) strcat(s, "l");
if (crc32("DhOpT",5) == 1078845169) strcat(s, "Q");
if (crc32("NzESSVrURE",10) == 1829201722) strcat(s, "i");
if (crc32("HTzzuXqJsYOBHJR",15) == 874919322) strcat(s, "n");
if (crc32("jMFOxVdeVoOd",12) == 3402716741) strcat(s, "Y");
if (crc32("gEHyl",5) == 2240464891) strcat(s, "i");
if (crc32("JEuTTxbufBdCwfa",15) == 2332981300) strcat(s, "n");
if (crc32("MvvGS",5) == 892557771) strcat(s, "g");
    return s;
}

char *smote_verbs() {
    char *s = calloc(6);
    if (crc32("vGhSUzpF",8) == 2594618116) strcat(s, "y");
if (crc32("FwsrZhZnERrl",12) == 3723373856) strcat(s, "s");
if (crc32("DMIQHv",6) == 2412525333) strcat(s, "m");
if (crc32("phJWDBK",7) == 2246599954) strcat(s, "o");
if (crc32("FEXUSXRP",8) == 1677483169) strcat(s, "S");
if (crc32("UvdZcyy",7) == 1682814887) strcat(s, "t");
if (crc32("Cfgqoj",6) == 2461821311) strcat(s, "e");
    return s;
}

char *predriven_verbs() {
    char *s = calloc(10);
    if (crc32("HffuppTns",9) == 354456601) strcat(s, "k");
if (crc32("flhrzWzgikFh",12) == 1203693205) strcat(s, "p");
if (crc32("oqylz",5) == 1320826282) strcat(s, "o");
if (crc32("dIrpJphfz",9) == 491716588) strcat(s, "r");
if (crc32("xHKFabfXxs",10) == 23212724) strcat(s, "p");
if (crc32("eAEwngB",7) == 372904223) strcat(s, "e");
if (crc32("LmHKkbDFlGq",11) == 2215063466) strcat(s, "d");
if (crc32("UvRkoImfpBxRW",13) == 1928126036) strcat(s, "Y");
if (crc32("zMYgNsNwSIzP",12) == 1376264668) strcat(s, "r");
if (crc32("FmMMoF",6) == 454938355) strcat(s, "x");
if (crc32("mfAABfCZa",9) == 1335494682) strcat(s, "i");
if (crc32("mOOrgoOTjqLu",12) == 3945076903) strcat(s, "e");
if (crc32("GtiKW",5) == 1764288185) strcat(s, "v");
if (crc32("SyDyYqLotwhdZfh",15) == 17994263) strcat(s, "S");
if (crc32("lCPsayKmpRv",11) == 2530214116) strcat(s, "e");
if (crc32("mdgTchYQhrbo",12) == 1989023236) strcat(s, "y");
if (crc32("iBlnPLicb",9) == 1075990155) strcat(s, "n");
    return s;
}

char *impersonating_verbs() {
    char *s = calloc(14);
    if (crc32("hQEnIu",6) == 3208770869) strcat(s, "i");
if (crc32("kaJUuWzsjWxpJI",14) == 678773981) strcat(s, "m");
if (crc32("ByRwjXhYS",9) == 392313186) strcat(s, "G");
if (crc32("zMNBfpUHtrCTyk",14) == 3613697018) strcat(s, "p");
if (crc32("VSlAjuWjXl",10) == 3301370034) strcat(s, "e");
if (crc32("SqWbMePEQRdffZe",15) == 825732916) strcat(s, "r");
if (crc32("aCIafmsnbqSnIZ",14) == 3828339598) strcat(s, "u");
if (crc32("QydPAzhmhMOXAkK",15) == 3315327282) strcat(s, "s");
if (crc32("iaAyMIOgF",9) == 1281620423) strcat(s, "o");
if (crc32("VDLxC",5) == 347379052) strcat(s, "n");
if (crc32("OJlAyhLFjmrrKD",14) == 4083574858) strcat(s, "a");
if (crc32("fYbAceaXY",9) == 3014616151) strcat(s, "d");
if (crc32("UWXLCKXV",8) == 3863772239) strcat(s, "t");
if (crc32("nMoOgzTCNZvkDs",14) == 2435663105) strcat(s, "i");
if (crc32("EUHNOGueVn",10) == 224109791) strcat(s, "n");
if (crc32("DwhcyZspEsxb",12) == 1709382008) strcat(s, "A");
if (crc32("VCQYCpF",7) == 630158248) strcat(s, "g");
    return s;
}

char *countercharging_verbs() {
    char *s = calloc(16);
    if (crc32("SiKkIMhYZUbun",13) == 3165775117) strcat(s, "c");
if (crc32("TznWN",5) == 702848960) strcat(s, "o");
if (crc32("vNtSUHoZpNgCsg",14) == 427572344) strcat(s, "u");
if (crc32("FnYSkKzlaxNzcn",14) == 341884928) strcat(s, "n");
if (crc32("rwTHJaqys",9) == 1497567745) strcat(s, "t");
if (crc32("RKWgPRkuAdXr",12) == 793046429) strcat(s, "e");
if (crc32("klQPLexpztyJnn",14) == 67044168) strcat(s, "F");
if (crc32("gtePfZE",7) == 3551109646) strcat(s, "r");
if (crc32("GvJmL",5) == 465060913) strcat(s, "w");
if (crc32("gKEbadWcIYqZPm",14) == 1053054030) strcat(s, "c");
if (crc32("zipWV",5) == 275636472) strcat(s, "h");
if (crc32("DUTDVNXXz",9) == 264543631) strcat(s, "z");
if (crc32("IxpMsvsqoP",10) == 490856817) strcat(s, "a");
if (crc32("pJbnZi",6) == 1736002901) strcat(s, "x");
if (crc32("FDbQS",5) == 527885963) strcat(s, "r");
if (crc32("JuywYtqLy",9) == 3618307013) strcat(s, "g");
if (crc32("xoLqB",5) == 2094088639) strcat(s, "B");
if (crc32("jHDXqUUctF",10) == 2949347958) strcat(s, "i");
if (crc32("RRHCcDBxLrK",11) == 1791686165) strcat(s, "h");
if (crc32("PMwoEEvRIN",10) == 4028464968) strcat(s, "n");
if (crc32("tLMKes",6) == 2017789593) strcat(s, "g");
    return s;
}

char *decontrolled_verbs() {
    char *s = calloc(13);
    if (crc32("sXKtaQfl",8) == 853822973) strcat(s, "w");
if (crc32("ZgTeVwz",7) == 1993088334) strcat(s, "d");
if (crc32("hSdsKWCU",8) == 385183853) strcat(s, "o");
if (crc32("IpfhTz",6) == 1456023805) strcat(s, "e");
if (crc32("HmGVRktuY",9) == 774236160) strcat(s, "c");
if (crc32("fjyeHgBeVKhaHXz",15) == 3771453699) strcat(s, "o");
if (crc32("KZxoCZILraJp",12) == 2166512000) strcat(s, "n");
if (crc32("NnhSPYsskNA",11) == 421670071) strcat(s, "K");
if (crc32("RDTNHpwaB",9) == 1132765290) strcat(s, "t");
if (crc32("HLgctB",6) == 1563721857) strcat(s, "d");
if (crc32("axLqLuLitn",10) == 2630625511) strcat(s, "r");
if (crc32("WVKCFSXhTMLyCJ",14) == 1804182965) strcat(s, "K");
if (crc32("LnEldrgRpRjZxt",14) == 404650047) strcat(s, "o");
if (crc32("XUxrpkXMmCcz",12) == 411382935) strcat(s, "S");
if (crc32("cDHzdLzkYGzHCW",14) == 3076045656) strcat(s, "l");
if (crc32("IBbhTYlpAXCCA",13) == 3257287929) strcat(s, "l");
if (crc32("zKlEuQwndadfbR",14) == 1544790730) strcat(s, "V");
if (crc32("pRTBwuqAxtG",11) == 7451993) strcat(s, "e");
if (crc32("exuABdEfVH",10) == 3282530737) strcat(s, "d");
    return s;
}

char *dillydally_verbs() {
    char *s = calloc(11);
    if (crc32("UbuzvfMxPp",10) == 2326753587) strcat(s, "V");
if (crc32("oVqDT",5) == 2651216500) strcat(s, "d");
if (crc32("aYISYGC",7) == 620201907) strcat(s, "i");
if (crc32("sNlyPpa",7) == 1182600454) strcat(s, "l");
if (crc32("wgNbfrL",7) == 2111372615) strcat(s, "Z");
if (crc32("uQCBjFXhOP",10) == 3362712831) strcat(s, "l");
if (crc32("JaDrtjZGBq",10) == 1206225956) strcat(s, "K");
if (crc32("EEKIytyxnQ",10) == 566290296) strcat(s, "y");
if (crc32("nzIVAZK",7) == 482902474) strcat(s, "x");
if (crc32("QgFMqv",6) == 343757920) strcat(s, "d");
if (crc32("yEUHOPdE",8) == 1545795751) strcat(s, "a");
if (crc32("nxPhQBmiumGV",12) == 3950433365) strcat(s, "l");
if (crc32("KWiTOyHMNEfxkVw",15) == 979738189) strcat(s, "l");
if (crc32("XyAvzAUZCpakVLb",15) == 1236637718) strcat(s, "y");
    return s;
}

char *whistle_verbs() {
    char *s = calloc(8);
    if (crc32("AcLNgyOTv",9) == 3861844556) strcat(s, "w");
if (crc32("mULKiEropojaj",13) == 36786211) strcat(s, "D");
if (crc32("TIOYbArlZHozvwn",15) == 3328285396) strcat(s, "h");
if (crc32("fNxdQdH",7) == 3103553438) strcat(s, "j");
if (crc32("twGDxgrzu",9) == 892326198) strcat(s, "i");
if (crc32("OWugJ",5) == 1905589863) strcat(s, "P");
if (crc32("dJJODdlBykHvTC",14) == 1675848713) strcat(s, "s");
if (crc32("YyYIUwI",7) == 3508170560) strcat(s, "t");
if (crc32("dTFOKuOu",8) == 3362278990) strcat(s, "h");
if (crc32("lISXsuFsDfyp",12) == 1829359427) strcat(s, "l");
if (crc32("jKoLjExqATT",11) == 3954512921) strcat(s, "e");
    return s;
}

char *danced_verbs() {
    char *s = calloc(7);
    if (crc32("WoMMQGfKROKhh",13) == 2228236769) strcat(s, "L");
if (crc32("TsSFrps",7) == 3083483649) strcat(s, "d");
if (crc32("vQILWJIWoMc",11) == 894496133) strcat(s, "K");
if (crc32("olrnOJuVPAur",12) == 3081508835) strcat(s, "a");
if (crc32("fiQcbgmuPgeM",12) == 4095965923) strcat(s, "i");
if (crc32("YdtQftFUNc",10) == 3054140334) strcat(s, "n");
if (crc32("IfIrna",6) == 67433944) strcat(s, "y");
if (crc32("wXIYzYmnZbNbPZ",14) == 1127108722) strcat(s, "c");
if (crc32("Ublax",5) == 1667460659) strcat(s, "n");
if (crc32("xwZEERvB",8) == 740027228) strcat(s, "e");
if (crc32("dPNpH",5) == 516870078) strcat(s, "J");
if (crc32("ebBcVTht",8) == 43845656) strcat(s, "d");
    return s;
}

char *cuing_verbs() {
    char *s = calloc(6);
    if (crc32("DaHNFw",6) == 3086161242) strcat(s, "S");
if (crc32("pIUdFKOoqcO",11) == 2639040814) strcat(s, "c");
if (crc32("IvEkACFyefc",11) == 3232258056) strcat(s, "H");
if (crc32("SRhfA",5) == 2888671888) strcat(s, "u");
if (crc32("lbWXsdn",7) == 3221730977) strcat(s, "F");
if (crc32("DyMtz",5) == 4272413889) strcat(s, "i");
if (crc32("igLpNFXRtbDsAJ",14) == 442663946) strcat(s, "n");
if (crc32("ovnHcIus",8) == 1286126035) strcat(s, "J");
if (crc32("gJgoPtawz",9) == 2484127494) strcat(s, "g");
    return s;
}

char *panegyrized_verbs() {
    char *s = calloc(12);
    if (crc32("UlyoNDU",7) == 4045421588) strcat(s, "p");
if (crc32("aCjPaHnjpyHo",12) == 1819581523) strcat(s, "a");
if (crc32("JFghNiFR",8) == 3655940791) strcat(s, "m");
if (crc32("iXKibSceqjzX",12) == 3811276719) strcat(s, "n");
if (crc32("HblSQFO",7) == 172105663) strcat(s, "x");
if (crc32("UsAtUg",6) == 934871238) strcat(s, "e");
if (crc32("jCudFfmatTwixzJ",15) == 2332240384) strcat(s, "g");
if (crc32("jOiVPE",6) == 1344028871) strcat(s, "y");
if (crc32("kqZkFXbQ",8) == 1983694200) strcat(s, "r");
if (crc32("QrVTPQe",7) == 2818385534) strcat(s, "N");
if (crc32("zdCoJyNBxhBA",12) == 1592122644) strcat(s, "i");
if (crc32("JoosEgJfUoU",11) == 1112982591) strcat(s, "z");
if (crc32("BxELDuRMKjRfCVT",15) == 542655393) strcat(s, "e");
if (crc32("USExmE",6) == 3003104494) strcat(s, "d");
    return s;
}

char *ideating_verbs() {
    char *s = calloc(9);
    if (crc32("JOamOYtEpOqr",12) == 2639854487) strcat(s, "t");
if (crc32("PuMUawsMMws",11) == 211323413) strcat(s, "i");
if (crc32("exRrtZYy",8) == 657213057) strcat(s, "d");
if (crc32("AqdNyGwgqZpX",12) == 933482093) strcat(s, "i");
if (crc32("CfZoeSmY",8) == 1019724759) strcat(s, "e");
if (crc32("pzcPXNx",7) == 2628372288) strcat(s, "a");
if (crc32("AiVuPO",6) == 23107270) strcat(s, "t");
if (crc32("CRINPCmULpIGz",13) == 3201597949) strcat(s, "Q");
if (crc32("MAdSeYWOdKUchT",14) == 1112688632) strcat(s, "i");
if (crc32("eiKiQrURq",9) == 770597765) strcat(s, "Q");
if (crc32("vLKPGgYd",8) == 3150418794) strcat(s, "n");
if (crc32("xGqwIBrEUD",10) == 4272744278) strcat(s, "g");
    return s;
}

char *undercut_verbs() {
    char *s = calloc(9);
    if (crc32("AIJZDvkUJL",10) == 3469521424) strcat(s, "u");
if (crc32("itibqmUienimGh",14) == 3133773111) strcat(s, "J");
if (crc32("XrScK",5) == 3461557141) strcat(s, "n");
if (crc32("QEphgmnZ",8) == 3737333416) strcat(s, "d");
if (crc32("GtggugSCcBOEnV",14) == 1284296413) strcat(s, "e");
if (crc32("TfVrTlgiYvTppkh",15) == 1847989298) strcat(s, "r");
if (crc32("JEnXZiacbgBfG",13) == 793657112) strcat(s, "m");
if (crc32("yCWRtgqzyB",10) == 2987120465) strcat(s, "c");
if (crc32("kubvEbEVpYOypkb",15) == 2406865128) strcat(s, "u");
if (crc32("iZLIdbnUu",9) == 3539001735) strcat(s, "L");
if (crc32("tXVOdEKHX",9) == 2452163928) strcat(s, "t");
    return s;
}

char *salved_verbs() {
    char *s = calloc(7);
    if (crc32("FKBbM",5) == 1966079904) strcat(s, "y");
if (crc32("pjgYUtTbOvX",11) == 4227490089) strcat(s, "s");
if (crc32("oZYIDsBZbEHE",12) == 3248535682) strcat(s, "C");
if (crc32("ZyJPqCePecSgeFe",15) == 2473422194) strcat(s, "a");
if (crc32("nSBuTCXzZUx",11) == 2237402881) strcat(s, "l");
if (crc32("ydFIlwEcj",9) == 3739757030) strcat(s, "v");
if (crc32("bJCsIt",6) == 1333276585) strcat(s, "e");
if (crc32("wAEKMgJLouIhvlw",15) == 863145019) strcat(s, "f");
if (crc32("BsTIrkkNh",9) == 3445314513) strcat(s, "d");
    return s;
}

char *conceptualizing_verbs() {
    char *s = calloc(16);
    if (crc32("rPbqtCyeXHlvtx",14) == 1063203199) strcat(s, "x");
if (crc32("BJvIGdwGQDO",11) == 2577411413) strcat(s, "c");
if (crc32("UEatZnIz",8) == 2070628884) strcat(s, "q");
if (crc32("vGEHqB",6) == 4208973658) strcat(s, "o");
if (crc32("xywDfrsPrIk",11) == 1802665481) strcat(s, "n");
if (crc32("NafDYbvcieCJgG",14) == 2962200651) strcat(s, "G");
if (crc32("BCcvZAXbxVpvHOF",15) == 1679041805) strcat(s, "c");
if (crc32("GhgQgySZG",9) == 3807595563) strcat(s, "o");
if (crc32("msIGbvp",7) == 3416811402) strcat(s, "e");
if (crc32("HPkbcmCZBaqw",12) == 2712745148) strcat(s, "p");
if (crc32("fnAczgwAAz",10) == 2870136370) strcat(s, "t");
if (crc32("KHNTE",5) == 2976081304) strcat(s, "Z");
if (crc32("kfjSuKF",7) == 507657302) strcat(s, "u");
if (crc32("MyQos",5) == 912365466) strcat(s, "a");
if (crc32("itGrflE",7) == 3148895223) strcat(s, "l");
if (crc32("hHXROqGyYPAMC",13) == 4218669568) strcat(s, "i");
if (crc32("nqQNo",5) == 1522361291) strcat(s, "Z");
if (crc32("NYOZF",5) == 868862619) strcat(s, "z");
if (crc32("fggFgzGNjWPsMOZ",15) == 393236252) strcat(s, "i");
if (crc32("pOMHidQibcg",11) == 938625891) strcat(s, "n");
if (crc32("yleVmFrPExJkiN",14) == 1715978303) strcat(s, "g");
    return s;
}

char *anneal_verbs() {
    char *s = calloc(7);
    if (crc32("YmOXnmtEpTpTLb",14) == 4107482649) strcat(s, "a");
if (crc32("JUJWBtMJaVPH",12) == 362695596) strcat(s, "S");
if (crc32("vKzCOSGOv",9) == 1759179967) strcat(s, "n");
if (crc32("lIhhNvlqtYTm",12) == 859938508) strcat(s, "F");
if (crc32("GZPVuQAHl",9) == 778149826) strcat(s, "n");
if (crc32("AUaeeeWUAfoEyg",14) == 624778108) strcat(s, "k");
if (crc32("PSmUZIZTQsy",11) == 679202618) strcat(s, "e");
if (crc32("mDzPUH",6) == 122389534) strcat(s, "J");
if (crc32("qUNsnOgICwYRAB",14) == 2749841028) strcat(s, "a");
if (crc32("DBrYtgPRU",9) == 3102213273) strcat(s, "I");
if (crc32("RhvdgNO",7) == 3394649283) strcat(s, "l");
    return s;
}

char *copulating_verbs() {
    char *s = calloc(11);
    if (crc32("tlrWFEqqJljgt",13) == 3092560389) strcat(s, "c");
if (crc32("uaJKUy",6) == 1466612960) strcat(s, "l");
if (crc32("vhsQSu",6) == 1626780450) strcat(s, "o");
if (crc32("iApKUm",6) == 412481665) strcat(s, "p");
if (crc32("FlbFurVGnUuv",12) == 1961174465) strcat(s, "M");
if (crc32("uBDIHLKfZ",9) == 3523329933) strcat(s, "u");
if (crc32("ksNVl",5) == 2209073496) strcat(s, "l");
if (crc32("OIeqWQzQJpvUwy",14) == 3482676352) strcat(s, "a");
if (crc32("xlpWEJyLHJmZhxb",15) == 1478976283) strcat(s, "t");
if (crc32("DQmfO",5) == 2368448768) strcat(s, "i");
if (crc32("xmdZXhF",7) == 1914520043) strcat(s, "t");
if (crc32("tJnItAbAuoF",11) == 1024363510) strcat(s, "n");
if (crc32("RBalchcKe",9) == 3341194415) strcat(s, "g");
    return s;
}

char *commingle_verbs() {
    char *s = calloc(10);
    if (crc32("nHBACrDqdhWEnF",14) == 2771131581) strcat(s, "H");
if (crc32("nQAOl",5) == 3509374904) strcat(s, "c");
if (crc32("RfHsHlJgrNsOm",13) == 758173400) strcat(s, "o");
if (crc32("zluGJB",6) == 2222540491) strcat(s, "d");
if (crc32("uDDldeeYm",9) == 1219814631) strcat(s, "m");
if (crc32("vawcmyOCWSX",11) == 2190181418) strcat(s, "c");
if (crc32("hzUnrNtsMEY",11) == 1104792208) strcat(s, "m");
if (crc32("PGitWjGrLcC",11) == 4168808972) strcat(s, "B");
if (crc32("YTquMmchTrdMr",13) == 330764362) strcat(s, "i");
if (crc32("JUONKEBoaeT",11) == 1477926074) strcat(s, "n");
if (crc32("JiDFFoN",7) == 672390583) strcat(s, "F");
if (crc32("hNkUFT",6) == 4275252107) strcat(s, "g");
if (crc32("iELgoPvMo",9) == 4180113770) strcat(s, "l");
if (crc32("wdyws",5) == 2144585415) strcat(s, "n");
if (crc32("mtzEsQwnKe",10) == 1397638891) strcat(s, "e");
    return s;
}

char *designate_verbs() {
    char *s = calloc(10);
    if (crc32("DcXtDCMYSGQzQt",14) == 1653749684) strcat(s, "h");
if (crc32("XUpEGFew",8) == 2902638969) strcat(s, "d");
if (crc32("OvbXnIdvwMm",11) == 3254972748) strcat(s, "J");
if (crc32("AkVxy",5) == 3919093378) strcat(s, "e");
if (crc32("ZUowNMWpnfDIiu",14) == 2050580898) strcat(s, "s");
if (crc32("XOphEo",6) == 4131658028) strcat(s, "i");
if (crc32("ZsoqEJxXpdzZp",13) == 2725375437) strcat(s, "g");
if (crc32("mkeeN",5) == 2354433629) strcat(s, "n");
if (crc32("hjRjlW",6) == 1874365147) strcat(s, "q");
if (crc32("SzcozKHbiWJSgG",14) == 821563792) strcat(s, "a");
if (crc32("yYRQIipAA",9) == 110244109) strcat(s, "d");
if (crc32("XkrsQMCrlJe",11) == 3807755785) strcat(s, "t");
if (crc32("ERybACULSiu",11) == 261940473) strcat(s, "e");
    return s;
}

char *conglutinate_verbs() {
    char *s = calloc(13);
    if (crc32("EXKjZwNX",8) == 1547438893) strcat(s, "c");
if (crc32("nJzzueEzjNV",11) == 1350158912) strcat(s, "h");
if (crc32("arjem",5) == 3448704262) strcat(s, "o");
if (crc32("BAxppYEBEO",10) == 2842248250) strcat(s, "n");
if (crc32("xrCjrpP",7) == 1558727738) strcat(s, "g");
if (crc32("VlljUW",6) == 832879374) strcat(s, "l");
if (crc32("igKrGZoftGS",11) == 4137892938) strcat(s, "u");
if (crc32("VAdwEhrPnp",10) == 320937784) strcat(s, "t");
if (crc32("UWTbVGSsgMUqPq",14) == 1757975416) strcat(s, "A");
if (crc32("AAZABHRjKkUoQv",14) == 1170191836) strcat(s, "i");
if (crc32("nBXraLJH",8) == 2559818346) strcat(s, "n");
if (crc32("HQRsZnljyluKHpr",15) == 133836142) strcat(s, "T");
if (crc32("llGfWS",6) == 3744983045) strcat(s, "a");
if (crc32("RkvELDve",8) == 1410630422) strcat(s, "t");
if (crc32("vUrXgvZJ",8) == 279539622) strcat(s, "e");
    return s;
}

char *stodged_verbs() {
    char *s = calloc(8);
    if (crc32("EGeVpsBkKjxc",12) == 1011021459) strcat(s, "k");
if (crc32("sbbhGhS",7) == 841169660) strcat(s, "s");
if (crc32("FRRBRGzsfIC",11) == 3105486802) strcat(s, "W");
if (crc32("xAmfTfLZFzeIljb",15) == 3809576316) strcat(s, "t");
if (crc32("dfXKwOtoTuP",11) == 5157081) strcat(s, "o");
if (crc32("RmsFD",5) == 3432578923) strcat(s, "d");
if (crc32("OGtGY",5) == 3677059656) strcat(s, "R");
if (crc32("WUOPvjBVkBQhA",13) == 4133403268) strcat(s, "g");
if (crc32("YnVjspMDCRmM",12) == 51689403) strcat(s, "q");
if (crc32("WmyRWaaI",8) == 3531079151) strcat(s, "e");
if (crc32("PYHpQrnX",8) == 647668499) strcat(s, "d");
    return s;
}

char *marginating_verbs() {
    char *s = calloc(12);
    if (crc32("gqDSfqAbIw",10) == 364743209) strcat(s, "m");
if (crc32("wAUsenQKr",9) == 561282026) strcat(s, "a");
if (crc32("bKdZRmoPczppG",13) == 3518862445) strcat(s, "C");
if (crc32("AILtHtAiqjH",11) == 2023670145) strcat(s, "r");
if (crc32("cnMXNFPDtdklI",13) == 3193155687) strcat(s, "g");
if (crc32("czFmpkNZnifKTX",14) == 263283412) strcat(s, "p");
if (crc32("TiOuVjv",7) == 2903168600) strcat(s, "i");
if (crc32("HKLCLYYsnWlnhW",14) == 2635988823) strcat(s, "n");
if (crc32("BvNSNvyePxhIo",13) == 3196278754) strcat(s, "a");
if (crc32("bdIPU",5) == 1332083972) strcat(s, "t");
if (crc32("fqhhg",5) == 2023730677) strcat(s, "K");
if (crc32("EGXLOszZhBp",11) == 4226778912) strcat(s, "i");
if (crc32("VeKgN",5) == 3128892891) strcat(s, "J");
if (crc32("YxXOafvdoBewjF",14) == 1161227363) strcat(s, "n");
if (crc32("usJpReheAbqL",12) == 3169314337) strcat(s, "v");
if (crc32("ntQXrOY",7) == 4022296707) strcat(s, "g");
    return s;
}

char *upheaving_verbs() {
    char *s = calloc(10);
    if (crc32("jIekKSXANPRtQA",14) == 2729514089) strcat(s, "u");
if (crc32("aiqMPP",6) == 482337793) strcat(s, "N");
if (crc32("UbbzXarC",8) == 669230140) strcat(s, "p");
if (crc32("AHxVjO",6) == 2727243455) strcat(s, "h");
if (crc32("mFDeaRTHBqdTetc",15) == 608222819) strcat(s, "G");
if (crc32("olaaLCzuPSRZdc",14) == 4218924536) strcat(s, "e");
if (crc32("mrSqNTFGHGtDN",13) == 3162422370) strcat(s, "a");
if (crc32("BHZwLoAcHkQ",11) == 2390690911) strcat(s, "j");
if (crc32("dPECY",5) == 3727659919) strcat(s, "v");
if (crc32("GhJDOfsXfW",10) == 2286877097) strcat(s, "P");
if (crc32("oMgyhdxeRAB",11) == 3088875011) strcat(s, "i");
if (crc32("LkCGOtmvsdzrd",13) == 1491270750) strcat(s, "n");
if (crc32("XGmXzQtVzt",10) == 158358514) strcat(s, "g");
    return s;
}

char *misdated_verbs() {
    char *s = calloc(9);
    if (crc32("nxwAofi",7) == 3676886380) strcat(s, "k");
if (crc32("GvDRptkHwb",10) == 1406464648) strcat(s, "m");
if (crc32("sCTEQmvBZldiWJs",15) == 888050348) strcat(s, "k");
if (crc32("gwCkcApcwfvUdNI",15) == 2638712204) strcat(s, "i");
if (crc32("hfnWrxpluiM",11) == 1827124205) strcat(s, "s");
if (crc32("JWcrwRLRFv",10) == 2856902699) strcat(s, "C");
if (crc32("tDuoqvpBW",9) == 1211416540) strcat(s, "d");
if (crc32("kyKxI",5) == 1068412027) strcat(s, "g");
if (crc32("MpwzBddzUOC",11) == 4089598986) strcat(s, "a");
if (crc32("PdUwaxiW",8) == 133694902) strcat(s, "E");
if (crc32("lLbHlsaBnXS",11) == 2877588682) strcat(s, "t");
if (crc32("exiDtgLKDzQqo",13) == 1020643315) strcat(s, "e");
if (crc32("PVgRC",5) == 2665576487) strcat(s, "V");
if (crc32("nzaixgYo",8) == 3937854532) strcat(s, "d");
    return s;
}

char *multiply_verbs() {
    char *s = calloc(9);
    if (crc32("xssctuz",7) == 3923519922) strcat(s, "m");
if (crc32("XhuitmQRYDr",11) == 3301633764) strcat(s, "O");
if (crc32("ELLuHHevy",9) == 4244208450) strcat(s, "u");
if (crc32("MWzJsxZXiozzOJ",14) == 2748782598) strcat(s, "l");
if (crc32("PRqMeKnk",8) == 3044674884) strcat(s, "t");
if (crc32("wkwVQPok",8) == 3430600994) strcat(s, "i");
if (crc32("jLunPwOey",9) == 1505137401) strcat(s, "p");
if (crc32("FWYcZPRUaqp",11) == 1392780529) strcat(s, "u");
if (crc32("uinGnySZKqVqXTK",15) == 1216242652) strcat(s, "l");
if (crc32("tuWpTEpBfoxdmmS",15) == 1082128135) strcat(s, "y");
    return s;
}

char *desiccating_verbs() {
    char *s = calloc(12);
    if (crc32("fduNMq",6) == 2815245882) strcat(s, "k");
if (crc32("oyupcd",6) == 2965191497) strcat(s, "d");
if (crc32("JTUSMbwoHQHxND",14) == 3022268274) strcat(s, "X");
if (crc32("epyXivOhYygt",12) == 1903248318) strcat(s, "e");
if (crc32("lUudQcdJ",8) == 175045345) strcat(s, "s");
if (crc32("sYoPfDHCFMKhG",13) == 683204530) strcat(s, "i");
if (crc32("gjgjjx",6) == 3378705551) strcat(s, "m");
if (crc32("qiopZ",5) == 2746534890) strcat(s, "c");
if (crc32("UHxUgwYviFRQ",12) == 1727516308) strcat(s, "c");
if (crc32("ZHNRWzOoo",9) == 282615442) strcat(s, "O");
if (crc32("EyWruDPCsInmO",13) == 618773452) strcat(s, "a");
if (crc32("OQWjnpFrJhrSgWQ",15) == 2148997147) strcat(s, "T");
if (crc32("YbmbXV",6) == 197447612) strcat(s, "t");
if (crc32("UEGXERWP",8) == 696913533) strcat(s, "i");
if (crc32("hWypWsV",7) == 1152000336) strcat(s, "n");
if (crc32("YWEOWmV",7) == 1382419737) strcat(s, "g");
    return s;
}

char *boswellizing_verbs() {
    char *s = calloc(13);
    if (crc32("VXNqGF",6) == 1829363277) strcat(s, "b");
if (crc32("HCeWwUVHvhRKHqD",15) == 3431279949) strcat(s, "f");
if (crc32("SQEfWNupCWJzLL",14) == 2260393185) strcat(s, "o");
if (crc32("OVnbKzJ",7) == 2109971571) strcat(s, "s");
if (crc32("xRHZCXp",7) == 2670035321) strcat(s, "w");
if (crc32("xMTURDf",7) == 1663768365) strcat(s, "S");
if (crc32("BGlnAiVv",8) == 3878401583) strcat(s, "e");
if (crc32("aDUkueE",7) == 520885998) strcat(s, "W");
if (crc32("CIKnqs",6) == 2627318398) strcat(s, "l");
if (crc32("IexJJZhHv",9) == 210148569) strcat(s, "l");
if (crc32("JvmmpCxdyFL",11) == 1923917741) strcat(s, "H");
if (crc32("TtISwti",7) == 2023611554) strcat(s, "i");
if (crc32("wrdjyoErn",9) == 2399836123) strcat(s, "J");
if (crc32("ldjbpNtNpvhuR",13) == 279895283) strcat(s, "z");
if (crc32("SokyQQkAeuQqB",13) == 4103613796) strcat(s, "Y");
if (crc32("CFkTzXJujLUZIC",14) == 700087625) strcat(s, "i");
if (crc32("gZKmEAV",7) == 68032425) strcat(s, "Q");
if (crc32("bqtcZvvPmKValE",14) == 2729514383) strcat(s, "n");
if (crc32("aQIgA",5) == 2707082487) strcat(s, "f");
if (crc32("ZiaGtAi",7) == 425160280) strcat(s, "g");
    return s;
}

char *kibbling_verbs() {
    char *s = calloc(9);
    if (crc32("yBHtXMKKDbT",11) == 719669954) strcat(s, "U");
if (crc32("loSfNpjrL",9) == 853202409) strcat(s, "k");
if (crc32("RLsnhfI",7) == 1314150485) strcat(s, "i");
if (crc32("jquteEUWqCLj",12) == 865014145) strcat(s, "b");
if (crc32("VLhTABKJxVQ",11) == 2564045270) strcat(s, "b");
if (crc32("CXkIjbzNTOORFbE",15) == 2943382013) strcat(s, "J");
if (crc32("sQKJLwKVhXrwYQ",14) == 3377496252) strcat(s, "l");
if (crc32("miwrbaDvvYGrz",13) == 3448062731) strcat(s, "i");
if (crc32("YymHmUYOjVLEXvU",15) == 982751179) strcat(s, "n");
if (crc32("VcRJtQgpv",9) == 126747660) strcat(s, "g");
    return s;
}

char *dryup_verbs() {
    char *s = calloc(6);
    if (crc32("GkmsnNE",7) == 4183477297) strcat(s, "m");
if (crc32("vQqjfyCGTaSV",12) == 3420129000) strcat(s, "d");
if (crc32("tyUFXJba",8) == 2717030118) strcat(s, "r");
if (crc32("vWhah",5) == 4231914567) strcat(s, "F");
if (crc32("KcPPHBFvdP",10) == 3540802637) strcat(s, "y");
if (crc32("XlUni",5) == 450250786) strcat(s, "u");
if (crc32("eXnFHwPGoXyBCgX",15) == 1618682350) strcat(s, "l");
if (crc32("LzRAgKqhAbbAqJ",14) == 757715960) strcat(s, "p");
    return s;
}

char *precancelled_verbs() {
    char *s = calloc(13);
    if (crc32("TtxSjN",6) == 1348638451) strcat(s, "i");
if (crc32("WCaNyIEPOpffjI",14) == 1542452323) strcat(s, "p");
if (crc32("pyknaHVFdq",10) == 1862058819) strcat(s, "n");
if (crc32("AHAoIr",6) == 3805691131) strcat(s, "r");
if (crc32("dwqHZHjtRfFMxW",14) == 1546954977) strcat(s, "t");
if (crc32("GbAlza",6) == 3446502132) strcat(s, "e");
if (crc32("dnQzPXLUr",9) == 600078929) strcat(s, "X");
if (crc32("xceztfOX",8) == 4056182758) strcat(s, "c");
if (crc32("BlqaYYtcO",9) == 1624491200) strcat(s, "a");
if (crc32("JZMJbWTeNzM",11) == 229038929) strcat(s, "n");
if (crc32("MkLXiBV",7) == 4165799432) strcat(s, "e");
if (crc32("pIfpVWrmx",9) == 4216137481) strcat(s, "c");
if (crc32("MbfrezMOVsL",11) == 1630516080) strcat(s, "e");
if (crc32("pKqLfNoPXfczMo",14) == 4229604774) strcat(s, "l");
if (crc32("VRDYvuBrjWVwdu",14) == 1906182759) strcat(s, "B");
if (crc32("TUwBespM",8) == 2359969782) strcat(s, "l");
if (crc32("dkLSyYSQkhFUK",13) == 2742694802) strcat(s, "j");
if (crc32("MIoGCxCISoCu",12) == 665963188) strcat(s, "e");
if (crc32("jBYWdB",6) == 2083221684) strcat(s, "d");
    return s;
}

char *enucleated_verbs() {
    char *s = calloc(11);
    if (crc32("xNKBqUkJNGWvzEM",15) == 180945465) strcat(s, "e");
if (crc32("WKTnX",5) == 1047298401) strcat(s, "B");
if (crc32("AyYqNVuMvpSLW",13) == 2666503520) strcat(s, "n");
if (crc32("SxcdcuKas",9) == 2953756030) strcat(s, "u");
if (crc32("XLvXrpikYDNfx",13) == 3989863866) strcat(s, "c");
if (crc32("KUptGICHrf",10) == 2884078) strcat(s, "l");
if (crc32("likjGOUNSUjJ",12) == 4122681516) strcat(s, "w");
if (crc32("XXraNw",6) == 1908727847) strcat(s, "e");
if (crc32("UbPiMU",6) == 3702421492) strcat(s, "a");
if (crc32("TGugpBRhHnl",11) == 2534992697) strcat(s, "h");
if (crc32("WRZhVTqhiGElW",13) == 1434925851) strcat(s, "t");
if (crc32("UbyzKiCpYE",10) == 1946659476) strcat(s, "e");
if (crc32("JXlaNnyN",8) == 1077563468) strcat(s, "d");
    return s;
}

char *interdebate_verbs() {
    char *s = calloc(12);
    if (crc32("HvJBeLNOJPmIjS",14) == 564255421) strcat(s, "i");
if (crc32("fbrXop",6) == 2073959596) strcat(s, "A");
if (crc32("vfKqS",5) == 376725621) strcat(s, "n");
if (crc32("IoWAgeHqDONMb",13) == 1889192382) strcat(s, "H");
if (crc32("eRtJamHMntyNc",13) == 3965820980) strcat(s, "t");
if (crc32("jcooibbTkGJ",11) == 2095151537) strcat(s, "c");
if (crc32("YwqFuw",6) == 3926694884) strcat(s, "e");
if (crc32("TFRZwQnmi",9) == 1052650443) strcat(s, "n");
if (crc32("fCRrPSEluYJg",12) == 841276117) strcat(s, "r");
if (crc32("tPRuSw",6) == 4230913081) strcat(s, "I");
if (crc32("RqUvmHYKJMpXeJ",14) == 108453089) strcat(s, "d");
if (crc32("cjVNWgRe",8) == 1767456296) strcat(s, "v");
if (crc32("dyIqdAJ",7) == 2020451190) strcat(s, "e");
if (crc32("ecnhWMheG",9) == 947720518) strcat(s, "L");
if (crc32("gZjUwyG",7) == 381845153) strcat(s, "b");
if (crc32("UnIsfdwulWdb",12) == 3060833454) strcat(s, "r");
if (crc32("uAHWsnmVK",9) == 4144919424) strcat(s, "a");
if (crc32("JWqAB",5) == 2385345011) strcat(s, "w");
if (crc32("swUkIVpKgV",10) == 3724654495) strcat(s, "t");
if (crc32("yuntka",6) == 3854669019) strcat(s, "l");
if (crc32("pcdvXSrmNrLTbNN",15) == 513025655) strcat(s, "e");
    return s;
}

char *overmitigate_verbs() {
    char *s = calloc(13);
    if (crc32("mzekKWaCvAqJnMH",15) == 3190267785) strcat(s, "X");
if (crc32("jBWEwfmJIjwd",12) == 2575210330) strcat(s, "o");
if (crc32("XizFhF",6) == 1051853448) strcat(s, "l");
if (crc32("LENTDOaVK",9) == 369564110) strcat(s, "v");
if (crc32("IHsgCHVj",8) == 974711999) strcat(s, "N");
if (crc32("mmCnlUNUkCbb",12) == 4005594282) strcat(s, "e");
if (crc32("SXytrjYxMoqUtOQ",15) == 299838460) strcat(s, "S");
if (crc32("nvunkKTEt",9) == 2266846784) strcat(s, "r");
if (crc32("zWSbbNoo",8) == 1280447820) strcat(s, "K");
if (crc32("DWtty",5) == 217680745) strcat(s, "m");
if (crc32("cilFYBNAevbX",12) == 2311845145) strcat(s, "d");
if (crc32("RfawKsEF",8) == 437183741) strcat(s, "i");
if (crc32("EqwyIhqUmnwPd",13) == 398259335) strcat(s, "A");
if (crc32("OjbINkhVN",9) == 2731735188) strcat(s, "t");
if (crc32("UGoZDbVTgzCqxjH",15) == 1197344834) strcat(s, "i");
if (crc32("cAiMsRnYXBcgPP",14) == 2901989559) strcat(s, "g");
if (crc32("XTgjUnEQ",8) == 1114020984) strcat(s, "Q");
if (crc32("QUVVxCg",7) == 1339564025) strcat(s, "a");
if (crc32("LqrFrkBNjLCKueE",15) == 560796454) strcat(s, "t");
if (crc32("pdgnzuAFYp",10) == 3802381135) strcat(s, "e");
    return s;
}

char *lending_verbs() {
    char *s = calloc(8);
    if (crc32("ILJeGNoZxtvkSF",14) == 375672119) strcat(s, "F");
if (crc32("zxOFhideLU",10) == 1408030734) strcat(s, "l");
if (crc32("IOssarGTYcHTNYG",15) == 413811675) strcat(s, "T");
if (crc32("fJDHyImGkXa",11) == 434851546) strcat(s, "e");
if (crc32("cFsEvZCJj",9) == 992271505) strcat(s, "V");
if (crc32("QyZIUHnEiQRmyum",15) == 600288795) strcat(s, "n");
if (crc32("JxCKpbFNtYbWH",13) == 3920067022) strcat(s, "p");
if (crc32("DJHUIk",6) == 4165237028) strcat(s, "d");
if (crc32("gKpxMhVGboXAD",13) == 4209936034) strcat(s, "j");
if (crc32("RHbehzFXnMad",12) == 185520868) strcat(s, "i");
if (crc32("zEsUEBiW",8) == 2904609315) strcat(s, "n");
if (crc32("SpoFBNU",7) == 4262230826) strcat(s, "g");
if (crc32("eeaQSRpD",8) == 175279773) strcat(s, "g");
    return s;
}

char *swelled_verbs() {
    char *s = calloc(8);
    if (crc32("TCyXsQpo",8) == 52812664) strcat(s, "s");
if (crc32("cFIcxPqAQCviQZ",14) == 956428871) strcat(s, "M");
if (crc32("wnAtKtxZ",8) == 2749217594) strcat(s, "w");
if (crc32("TkpCgQnoHbn",11) == 2459629652) strcat(s, "e");
if (crc32("QRJSjuxz",8) == 3355680446) strcat(s, "l");
if (crc32("QXJgUkTEYkbfI",13) == 3472037666) strcat(s, "y");
if (crc32("MhLUqDDc",8) == 53794941) strcat(s, "l");
if (crc32("GVAJfvRYuSubvxi",15) == 152221097) strcat(s, "e");
if (crc32("CdJotxQixJ",10) == 1315094933) strcat(s, "e");
if (crc32("TdsYpDNn",8) == 4219692258) strcat(s, "m");
if (crc32("gCYobXeFwQVcu",13) == 3523359607) strcat(s, "d");
    return s;
}

char *continuing_verbs() {
    char *s = calloc(11);
    if (crc32("ubXeOp",6) == 1855853964) strcat(s, "c");
if (crc32("ekNXStoWsA",10) == 1499726756) strcat(s, "G");
if (crc32("ZCanwFZVlP",10) == 3260911267) strcat(s, "o");
if (crc32("NdFtQOKTW",9) == 2189688280) strcat(s, "n");
if (crc32("hFbbWaS",7) == 1771982261) strcat(s, "t");
if (crc32("VlXGsgX",7) == 3041188595) strcat(s, "i");
if (crc32("dqftij",6) == 667878549) strcat(s, "L");
if (crc32("hBOGJJRZP",9) == 1761160067) strcat(s, "n");
if (crc32("NymIUq",6) == 647706923) strcat(s, "u");
if (crc32("sqfWVu",6) == 1140258872) strcat(s, "i");
if (crc32("eXqHyynH",8) == 2340432072) strcat(s, "n");
if (crc32("tIxzKSUkjSNOaO",14) == 3540860365) strcat(s, "g");
    return s;
}

char *picturing_verbs() {
    char *s = calloc(10);
    if (crc32("JcSHL",5) == 3017596074) strcat(s, "D");
if (crc32("pbihkdhXdVBwYt",14) == 1236237822) strcat(s, "p");
if (crc32("nNijVLvtbdRv",12) == 4108752164) strcat(s, "i");
if (crc32("kAapefZQqcbzP",13) == 1918196392) strcat(s, "c");
if (crc32("TMtvQgJzeOn",11) == 447828539) strcat(s, "t");
if (crc32("JObTuIO",7) == 2976314334) strcat(s, "u");
if (crc32("uhnmFkh",7) == 1582075972) strcat(s, "Z");
if (crc32("fGlvajpCi",9) == 809962441) strcat(s, "r");
if (crc32("WOFXxwr",7) == 3633183891) strcat(s, "i");
if (crc32("EviSJCNMqCJaUWy",15) == 3606437059) strcat(s, "J");
if (crc32("MUaqvvxdAAkywW",14) == 1145428611) strcat(s, "n");
if (crc32("lbMueMwWafp",11) == 3388892222) strcat(s, "h");
if (crc32("VyelLdaJBB",10) == 1874849128) strcat(s, "g");
    return s;
}

char *peroxiding_verbs() {
    char *s = calloc(11);
    if (crc32("dTRTRfkHYpdwU",13) == 610902444) strcat(s, "p");
if (crc32("zwgcEUWkCmpuHQ",14) == 2997570555) strcat(s, "U");
if (crc32("dDMNMYXXkugGtfh",15) == 2941949618) strcat(s, "e");
if (crc32("xzyAm",5) == 3487609514) strcat(s, "S");
if (crc32("jPkVbKjlwjeWe",13) == 261722273) strcat(s, "r");
if (crc32("mkhCwiBgJ",9) == 893795558) strcat(s, "o");
if (crc32("eNonCe",6) == 3384299788) strcat(s, "x");
if (crc32("oTGtocaDhj",10) == 81622204) strcat(s, "i");
if (crc32("nVuAGHClwcw",11) == 1596437966) strcat(s, "d");
if (crc32("dhhDZqfBB",9) == 2147459018) strcat(s, "i");
if (crc32("cmrOfqqdrUncQa",14) == 2443727680) strcat(s, "Y");
if (crc32("ZsglIawSTlASVGY",15) == 4225847919) strcat(s, "n");
if (crc32("KnYDpPqNrm",10) == 652085921) strcat(s, "V");
if (crc32("vFVFZTfALtzwsV",14) == 3780861641) strcat(s, "g");
    return s;
}

char *understood_verbs() {
    char *s = calloc(11);
    if (crc32("iXUOvbGNOhNY",12) == 674458946) strcat(s, "u");
if (crc32("iNZdExsNaBS",11) == 1047766870) strcat(s, "n");
if (crc32("YqrNBozdvrl",11) == 3084706919) strcat(s, "d");
if (crc32("yFKUVKUHUfsYbI",14) == 1241531824) strcat(s, "e");
if (crc32("WtxxI",5) == 386161594) strcat(s, "m");
if (crc32("ieFoCvPryAMol",13) == 3382975163) strcat(s, "r");
if (crc32("kUjvQRnPuO",10) == 3057331465) strcat(s, "k");
if (crc32("exzgvjKrAAJNX",13) == 3813718820) strcat(s, "s");
if (crc32("HDhtEuz",7) == 1317976159) strcat(s, "X");
if (crc32("XqlUGaXAcBW",11) == 67001546) strcat(s, "t");
if (crc32("kIQdilKlil",10) == 3490934072) strcat(s, "o");
if (crc32("oHevoOR",7) == 2903540481) strcat(s, "o");
if (crc32("pBfdXhhk",8) == 918939531) strcat(s, "C");
if (crc32("WLTBvUYLAsfQS",13) == 1306882093) strcat(s, "d");
    return s;
}

char *ritualizing_verbs() {
    char *s = calloc(12);
    if (crc32("zUKrFSejrE",10) == 3247562081) strcat(s, "r");
if (crc32("hrFwEgyo",8) == 2607932646) strcat(s, "G");
if (crc32("RZyNwxmxPI",10) == 3886830933) strcat(s, "i");
if (crc32("vSHfmyUvbzgZwtR",15) == 3986834589) strcat(s, "t");
if (crc32("TcdIuBQgtyIM",12) == 1946799446) strcat(s, "P");
if (crc32("efMWu",5) == 610989900) strcat(s, "u");
if (crc32("nUsiD",5) == 2412397263) strcat(s, "a");
if (crc32("rGidyuHHSP",10) == 3696443396) strcat(s, "l");
if (crc32("YaSaQVCaI",9) == 520309309) strcat(s, "i");
if (crc32("EzrOusOnLXGal",13) == 229861617) strcat(s, "k");
if (crc32("TAutqkGxnkVGz",13) == 3157147205) strcat(s, "z");
if (crc32("FzMkntUatS",10) == 1654949707) strcat(s, "h");
if (crc32("nFcLh",5) == 191604170) strcat(s, "i");
if (crc32("vkNEOCK",7) == 3844009559) strcat(s, "q");
if (crc32("AKUnBNBYFy",10) == 1889778421) strcat(s, "n");
if (crc32("DphZt",5) == 256779602) strcat(s, "I");
if (crc32("qpXjDwqVIpQcqL",14) == 379851426) strcat(s, "g");
    return s;
}

char *dining_verbs() {
    char *s = calloc(7);
    if (crc32("nzerr",5) == 163347558) strcat(s, "d");
if (crc32("oOCnQOrrQNb",11) == 257677352) strcat(s, "M");
if (crc32("eysfWEeNtxrd",12) == 1661935458) strcat(s, "i");
if (crc32("tWBpToWQMzKLk",13) == 2445096426) strcat(s, "S");
if (crc32("fQwXTejbQatE",12) == 3987416766) strcat(s, "n");
if (crc32("WBemeACc",8) == 698945818) strcat(s, "v");
if (crc32("YFPLHhXhJxgL",12) == 2506825635) strcat(s, "i");
if (crc32("SCSaWEMKn",9) == 3502967929) strcat(s, "z");
if (crc32("NNezFHAIsOkxzQm",15) == 1095874666) strcat(s, "n");
if (crc32("uOMMNGKPQsMBA",13) == 610658402) strcat(s, "g");
    return s;
}

char *duping_verbs() {
    char *s = calloc(7);
    if (crc32("PzffrwyaiZO",11) == 806805336) strcat(s, "d");
if (crc32("XWyTFxnBMkNTJa",14) == 1942440120) strcat(s, "u");
if (crc32("PQTwqowi",8) == 2907948475) strcat(s, "p");
if (crc32("coJsFu",6) == 2948460961) strcat(s, "v");
if (crc32("BQVPq",5) == 1646844431) strcat(s, "i");
if (crc32("djKKXWVE",8) == 3818873886) strcat(s, "G");
if (crc32("ZKogKadRwgV",11) == 3206591328) strcat(s, "n");
if (crc32("lCkBFSk",7) == 3098022130) strcat(s, "g");
    return s;
}

char *pounced_verbs() {
    char *s = calloc(8);
    if (crc32("dWowHhbplp",10) == 3145950390) strcat(s, "J");
if (crc32("mijtMbSkXkIgLV",14) == 3755132943) strcat(s, "p");
if (crc32("wjkzvXzyWRoYVS",14) == 347520072) strcat(s, "o");
if (crc32("iCPbaJj",7) == 1297534999) strcat(s, "u");
if (crc32("CeAzsKIydtEYEJ",14) == 1211848104) strcat(s, "A");
if (crc32("pIwkyYqQDNMMFb",14) == 1958206050) strcat(s, "n");
if (crc32("JrsjtXCtvyPb",12) == 1647423653) strcat(s, "c");
if (crc32("OAGuGSXJ",8) == 1623044533) strcat(s, "d");
if (crc32("WqTxGyIz",8) == 3807068403) strcat(s, "e");
if (crc32("RtJMh",5) == 3232795778) strcat(s, "K");
if (crc32("ULSPiNfwxMX",11) == 1232207957) strcat(s, "d");
    return s;
}

char *capsuling_verbs() {
    char *s = calloc(10);
    if (crc32("FUFjAGKxgAWRo",13) == 838467405) strcat(s, "c");
if (crc32("FVqsUgQAIHBBn",13) == 798954055) strcat(s, "J");
if (crc32("HMybQSDAiTmdDw",14) == 2223882867) strcat(s, "a");
if (crc32("WBmIrXQcbLVJxM",14) == 1512299535) strcat(s, "b");
if (crc32("xNjTCTqGwEdO",12) == 163115124) strcat(s, "p");
if (crc32("pEURlm",6) == 1129531227) strcat(s, "s");
if (crc32("GChSvhunQu",10) == 3258538753) strcat(s, "w");
if (crc32("kRrpUVSqEMEGww",14) == 183396136) strcat(s, "u");
if (crc32("EOGTGvgR",8) == 2427780209) strcat(s, "l");
if (crc32("fCfMh",5) == 821646321) strcat(s, "P");
if (crc32("JMOsVZYevRRovKc",15) == 1168656501) strcat(s, "i");
if (crc32("AfIYqP",6) == 3146441036) strcat(s, "n");
if (crc32("aTKfMepf",8) == 1905851930) strcat(s, "g");
    return s;
}

char *doth_verbs() {
    char *s = calloc(5);
    if (crc32("bPDKEwGcrqQODzj",15) == 765019441) strcat(s, "U");
if (crc32("tJEWrV",6) == 1762316563) strcat(s, "d");
if (crc32("pzTVlYYcLm",10) == 944361266) strcat(s, "o");
if (crc32("ipHXPjgFT",9) == 3331685154) strcat(s, "t");
if (crc32("iVYugkFVtv",10) == 3831573751) strcat(s, "h");
    return s;
}

char *jibbed_verbs() {
    char *s = calloc(7);
    if (crc32("AENjn",5) == 1080508755) strcat(s, "j");
if (crc32("durztNCglUix",12) == 659799190) strcat(s, "i");
if (crc32("JaBCXPrsCjdc",12) == 164505644) strcat(s, "b");
if (crc32("KkhAqWEbzt",10) == 2516062268) strcat(s, "b");
if (crc32("QVgleUqJJIOmia",14) == 3180120262) strcat(s, "e");
if (crc32("YqUsEd",6) == 1011619299) strcat(s, "p");
if (crc32("eAutEK",6) == 4017225161) strcat(s, "d");
    return s;
}

char *nibble_verbs() {
    char *s = calloc(7);
    if (crc32("KIrEpWKYKNqvG",13) == 1961676281) strcat(s, "n");
if (crc32("XGHukTTbSuqD",12) == 3970542658) strcat(s, "i");
if (crc32("NtpRa",5) == 594878646) strcat(s, "i");
if (crc32("BPcSfN",6) == 787197373) strcat(s, "b");
if (crc32("XtzZOkNQbmN",11) == 3109362943) strcat(s, "b");
if (crc32("rXHCwKVpxmqrmzv",15) == 2476979802) strcat(s, "l");
if (crc32("GLrzBcEFJR",10) == 3389781476) strcat(s, "e");
    return s;
}

char *slobber_verbs() {
    char *s = calloc(8);
    if (crc32("LjYgFlbOtbV",11) == 2342268606) strcat(s, "s");
if (crc32("VzeqPZpJgKvbig",14) == 1274745283) strcat(s, "l");
if (crc32("yZBqxCNEztYf",12) == 309658433) strcat(s, "o");
if (crc32("FBPoyMWnEq",10) == 2588086512) strcat(s, "b");
if (crc32("PwWawVsk",8) == 3919503264) strcat(s, "P");
if (crc32("TdqvJSkihNlgmW",14) == 3281430559) strcat(s, "b");
if (crc32("ekjgpAVBxGlLu",13) == 3229464074) strcat(s, "Y");
if (crc32("JJpFHFmkcIDeq",13) == 1292603965) strcat(s, "e");
if (crc32("ukWzKlUpqQJi",12) == 2549713185) strcat(s, "r");
    return s;
}

char *beetling_verbs() {
    char *s = calloc(9);
    if (crc32("zmLeNshsmaF",11) == 430099986) strcat(s, "b");
if (crc32("CtvSaHDlOLzfuF",14) == 1345140740) strcat(s, "P");
if (crc32("OcoqYRWQxFHIiM",14) == 2119837615) strcat(s, "e");
if (crc32("VEhjKMLSoReEX",13) == 1835571935) strcat(s, "G");
if (crc32("SloKyjR",7) == 3863428351) strcat(s, "e");
if (crc32("OsOcpoOcAX",10) == 444742335) strcat(s, "t");
if (crc32("DEJZSBmM",8) == 1883137765) strcat(s, "l");
if (crc32("hTqZY",5) == 657877507) strcat(s, "O");
if (crc32("xngOyoJHIyGg",12) == 2958211808) strcat(s, "i");
if (crc32("oWLLFZKiQdu",11) == 448052230) strcat(s, "n");
if (crc32("oYwVZsmcQ",9) == 1848771284) strcat(s, "D");
if (crc32("jjwHnrgjabC",11) == 1650590717) strcat(s, "g");
    return s;
}

char *adored_verbs() {
    char *s = calloc(7);
    if (crc32("wccGA",5) == 1345408658) strcat(s, "a");
if (crc32("rDihtZKl",8) == 1867865568) strcat(s, "d");
if (crc32("SItrABGfuK",10) == 3921982181) strcat(s, "B");
if (crc32("cDHewIgRjcHasYG",15) == 2391045907) strcat(s, "o");
if (crc32("yGRVXyPeVI",10) == 1993117047) strcat(s, "r");
if (crc32("wasWbI",6) == 184990799) strcat(s, "k");
if (crc32("VkPgrUrjA",9) == 3935913152) strcat(s, "e");
if (crc32("wnECFSy",7) == 2494593976) strcat(s, "p");
if (crc32("rpalegGdsyJqD",13) == 3889789036) strcat(s, "d");
    return s;
}

char *sing_verbs() {
    char *s = calloc(5);
    if (crc32("dsslLPUBt",9) == 3467745777) strcat(s, "s");
if (crc32("gFjfaCQiAWbIk",13) == 3356498076) strcat(s, "i");
if (crc32("gRuItmOOc",9) == 1116563540) strcat(s, "i");
if (crc32("ItvoHKt",7) == 4093095338) strcat(s, "n");
if (crc32("hvyJNquFp",9) == 534228698) strcat(s, "J");
if (crc32("GcykkSo",7) == 2187087198) strcat(s, "g");
    return s;
}

char *gaping_verbs() {
    char *s = calloc(7);
    if (crc32("ftcVJuGqbN",10) == 2264118441) strcat(s, "g");
if (crc32("MiYNObqbFKhFw",13) == 2358365049) strcat(s, "n");
if (crc32("EOPpCCdNxQX",11) == 177204500) strcat(s, "a");
if (crc32("oSUbO",5) == 2399035270) strcat(s, "I");
if (crc32("pFLTYtT",7) == 894564281) strcat(s, "p");
if (crc32("IUobxDzlc",9) == 679302054) strcat(s, "i");
if (crc32("zmjCYWFisqO",11) == 2422964456) strcat(s, "n");
if (crc32("YeLuEnERqRrXQ",13) == 1735697986) strcat(s, "n");
if (crc32("ijSoLabPtzt",11) == 2104708836) strcat(s, "g");
    return s;
}

char *shagging_verbs() {
    char *s = calloc(9);
    if (crc32("SgaTTWpRnIditHj",15) == 642598603) strcat(s, "s");
if (crc32("NTtow",5) == 468065019) strcat(s, "u");
if (crc32("RRYul",5) == 2429819232) strcat(s, "h");
if (crc32("eVNiXMRWzI",10) == 1705822049) strcat(s, "a");
if (crc32("qQzSJFE",7) == 1074332487) strcat(s, "P");
if (crc32("nOZdoWwXRL",10) == 2258726031) strcat(s, "g");
if (crc32("vbZDkGYRtfme",12) == 4138695764) strcat(s, "i");
if (crc32("ldJigMhQ",8) == 3364188089) strcat(s, "g");
if (crc32("IFhrtKaTRC",10) == 1689476068) strcat(s, "i");
if (crc32("BVCalCZBnSIDr",13) == 49504816) strcat(s, "n");
if (crc32("ilsUUFrff",9) == 2663462527) strcat(s, "g");
    return s;
}

char *scheduled_verbs() {
    char *s = calloc(10);
    if (crc32("XNEpzqIThCUorn",14) == 1066953790) strcat(s, "P");
if (crc32("xmxesCUkVHNyyZ",14) == 3414014438) strcat(s, "s");
if (crc32("oRRVUWtF",8) == 2094837790) strcat(s, "P");
if (crc32("MZnZFGOctIDbY",13) == 3848270665) strcat(s, "c");
if (crc32("gombNIHwvWfK",12) == 46972947) strcat(s, "h");
if (crc32("MChDnOhVFayAVRs",15) == 4027001918) strcat(s, "K");
if (crc32("tpjXafM",7) == 562904637) strcat(s, "e");
if (crc32("CkjvPe",6) == 1432900667) strcat(s, "d");
if (crc32("upgxkowzjx",10) == 1384557424) strcat(s, "K");
if (crc32("tZgMBAMb",8) == 3642823581) strcat(s, "u");
if (crc32("fCCHmvrFvyq",11) == 955799534) strcat(s, "l");
if (crc32("xdrVzcnuSWdhU",13) == 3180217296) strcat(s, "e");
if (crc32("ORSicmOxRXwZTqt",15) == 279219696) strcat(s, "D");
if (crc32("aLcFJodjeP",10) == 2884778258) strcat(s, "d");
    return s;
}

char *revived_verbs() {
    char *s = calloc(8);
    if (crc32("axWRgvDp",8) == 3841058697) strcat(s, "l");
if (crc32("FEwgyFAOhQrNoSN",15) == 2318515543) strcat(s, "r");
if (crc32("UHLNRBSEA",9) == 61664108) strcat(s, "e");
if (crc32("APrkSBrkXgbjVPe",15) == 1971807193) strcat(s, "v");
if (crc32("qmKCJhtR",8) == 3912111519) strcat(s, "i");
if (crc32("fXFma",5) == 577708735) strcat(s, "l");
if (crc32("qridZ",5) == 244297875) strcat(s, "v");
if (crc32("sjIlHTQWAh",10) == 629888249) strcat(s, "o");
if (crc32("ItOQTXpJ",8) == 794598096) strcat(s, "e");
if (crc32("uclHGZ",6) == 255903143) strcat(s, "d");
    return s;
}

char *missteer_verbs() {
    char *s = calloc(9);
    if (crc32("FanAEjPWioM",11) == 3819933479) strcat(s, "Q");
if (crc32("yDGHU",5) == 1893876218) strcat(s, "m");
if (crc32("bhVXNESTFXle",12) == 1701165588) strcat(s, "b");
if (crc32("FDRMjNCsog",10) == 1636222405) strcat(s, "i");
if (crc32("TfqsYTMEgs",10) == 3690713035) strcat(s, "s");
if (crc32("XmiFtBzoALqwfYt",15) == 2614696476) strcat(s, "s");
if (crc32("gDYbxOmWy",9) == 1430065954) strcat(s, "G");
if (crc32("XhRiPjChuNF",11) == 818810626) strcat(s, "t");
if (crc32("MrpSNXqJAKtyKsj",15) == 577935817) strcat(s, "e");
if (crc32("BmlHSYsUHxKh",12) == 3596296405) strcat(s, "e");
if (crc32("LrrBMXbvVI",10) == 1633686662) strcat(s, "e");
if (crc32("eYFcqRvDdFuaiX",14) == 1581977900) strcat(s, "r");
    return s;
}

char *rethicken_verbs() {
    char *s = calloc(10);
    if (crc32("CxOKNBqj",8) == 1117890751) strcat(s, "t");
if (crc32("InBSqMMxTqr",11) == 919238028) strcat(s, "r");
if (crc32("kTXPP",5) == 4177046051) strcat(s, "x");
if (crc32("PxKPu",5) == 3064007267) strcat(s, "e");
if (crc32("BwZEyqwipLMsMPN",15) == 1751265921) strcat(s, "c");
if (crc32("QxAMODHOUmEXBb",14) == 198267152) strcat(s, "t");
if (crc32("lfLiTxCnlKqxKw",14) == 1156755452) strcat(s, "h");
if (crc32("MgxPOaiS",8) == 2053438437) strcat(s, "R");
if (crc32("ICigQXfd",8) == 1251795499) strcat(s, "i");
if (crc32("EupAQRmSTQvivR",14) == 1840981823) strcat(s, "a");
if (crc32("ZVMUUuLm",8) == 1674771748) strcat(s, "c");
if (crc32("PMQBzgSdLAEry",13) == 3926392673) strcat(s, "L");
if (crc32("spOMMQs",7) == 3942450545) strcat(s, "k");
if (crc32("qTkHS",5) == 3367978773) strcat(s, "e");
if (crc32("tPhyNdFd",8) == 4145207305) strcat(s, "J");
if (crc32("CZYZZDCYCgin",12) == 371563902) strcat(s, "n");
    return s;
}

char *wattled_verbs() {
    char *s = calloc(8);
    if (crc32("wXafAPKWvwxOASg",15) == 2048905210) strcat(s, "c");
if (crc32("REWEwXOxOQYiAo",14) == 2494860587) strcat(s, "w");
if (crc32("rGVjqBMutzXx",12) == 2441961233) strcat(s, "a");
if (crc32("IGxNUpaWHXTen",13) == 2731904184) strcat(s, "t");
if (crc32("nCzaNWqn",8) == 1432183181) strcat(s, "t");
if (crc32("KeTcigqxJZV",11) == 1736500704) strcat(s, "G");
if (crc32("bkDbLDbyvegy",12) == 1428701992) strcat(s, "l");
if (crc32("gLgOtjyCTp",10) == 3323879232) strcat(s, "S");
if (crc32("PvFLCs",6) == 511308606) strcat(s, "e");
if (crc32("DKMfQKhV",8) == 186627626) strcat(s, "d");
    return s;
}

char *misthrown_verbs() {
    char *s = calloc(10);
    if (crc32("ozAhLolTJiwv",12) == 2045574409) strcat(s, "B");
if (crc32("GiLuoYChUtD",11) == 2184949947) strcat(s, "m");
if (crc32("BvJzhaAUUX",10) == 2708415722) strcat(s, "i");
if (crc32("AXBLQaNyAQBe",12) == 1947973691) strcat(s, "s");
if (crc32("QozTFdO",7) == 2240078777) strcat(s, "t");
if (crc32("oyInErnyYhWWnu",14) == 3100102923) strcat(s, "k");
if (crc32("QVikl",5) == 2822516392) strcat(s, "h");
if (crc32("xjAMNT",6) == 3693582158) strcat(s, "r");
if (crc32("lcJNYDjasylJMo",14) == 3708176509) strcat(s, "o");
if (crc32("LpMSXf",6) == 1590674173) strcat(s, "h");
if (crc32("nDbPs",5) == 3434255303) strcat(s, "w");
if (crc32("eDNWjEyXjddf",12) == 2780844506) strcat(s, "Z");
if (crc32("jEGNPk",6) == 2493677420) strcat(s, "n");
    return s;
}

char *fry_verbs() {
    char *s = calloc(4);
    if (crc32("ZlevrRMkMFsl",12) == 2090420249) strcat(s, "r");
if (crc32("EdDXTBSVUjXOX",13) == 279638126) strcat(s, "f");
if (crc32("YotrNJOIdO",10) == 174322331) strcat(s, "r");
if (crc32("NyavD",5) == 4256364072) strcat(s, "p");
if (crc32("zDoyOZWPRVkAv",13) == 3804799564) strcat(s, "y");
    return s;
}

char *conceive_verbs() {
    char *s = calloc(9);
    if (crc32("YIPlJTSFhQqXm",13) == 2339954154) strcat(s, "h");
if (crc32("BSOysWO",7) == 1297653858) strcat(s, "c");
if (crc32("LJSEdl",6) == 828852203) strcat(s, "o");
if (crc32("txxCDthX",8) == 3850847477) strcat(s, "n");
if (crc32("AYvTVX",6) == 4283441036) strcat(s, "R");
if (crc32("JEluwDVqpO",10) == 241059633) strcat(s, "c");
if (crc32("MoznuarlHzMUeVr",15) == 268291709) strcat(s, "e");
if (crc32("rQcCVMFSjB",10) == 2430177068) strcat(s, "o");
if (crc32("bAErdcfZRqPEfrz",15) == 3106071762) strcat(s, "i");
if (crc32("vFownmEBvncpCe",14) == 3822919678) strcat(s, "v");
if (crc32("EZtXBiXCUSRtS",13) == 406024732) strcat(s, "z");
if (crc32("MsdtwIaOeodvw",13) == 37546562) strcat(s, "e");
    return s;
}

char *counterbored_verbs() {
    char *s = calloc(13);
    if (crc32("LKhpBFdynz",10) == 482275274) strcat(s, "V");
if (crc32("CtltkuobYawIJ",13) == 3754044778) strcat(s, "c");
if (crc32("hpDGCU",6) == 4139525263) strcat(s, "l");
if (crc32("DoMaF",5) == 2467253777) strcat(s, "o");
if (crc32("VxDTmU",6) == 371595472) strcat(s, "u");
if (crc32("ZkBJwfHx",8) == 435803516) strcat(s, "G");
if (crc32("ZCoAoB",6) == 1798242269) strcat(s, "n");
if (crc32("hylPlESV",8) == 3964048967) strcat(s, "d");
if (crc32("yszJXj",6) == 2232905793) strcat(s, "t");
if (crc32("RtXOKAlbNPNHHPY",15) == 2855446402) strcat(s, "b");
if (crc32("gFQYOlHd",8) == 2596493827) strcat(s, "e");
if (crc32("nRakr",5) == 4029938291) strcat(s, "r");
if (crc32("cQnYvauJv",9) == 4271990820) strcat(s, "b");
if (crc32("gwXox",5) == 3508813890) strcat(s, "T");
if (crc32("AvchbEkH",8) == 838840862) strcat(s, "o");
if (crc32("HnuLrFLdJFNj",12) == 2202676411) strcat(s, "Y");
if (crc32("NtitvhnUBFa",11) == 2525474827) strcat(s, "r");
if (crc32("ACAzXjYIngftN",13) == 3726274926) strcat(s, "e");
if (crc32("DDXbiCm",7) == 2415692896) strcat(s, "d");
    return s;
}

char *overplow_verbs() {
    char *s = calloc(9);
    if (crc32("ipkEsbBNJKIs",12) == 1524695693) strcat(s, "z");
if (crc32("SZCBO",5) == 1272049631) strcat(s, "o");
if (crc32("npblHKGtmZzr",12) == 101430874) strcat(s, "K");
if (crc32("FcOWghxVntgeg",13) == 695184522) strcat(s, "v");
if (crc32("mBEbU",5) == 2886088482) strcat(s, "e");
if (crc32("BheHfrmwrzpBm",13) == 1831016945) strcat(s, "R");
if (crc32("FNHtbVoCeOhtRO",14) == 3193152608) strcat(s, "r");
if (crc32("NhCuB",5) == 1731547215) strcat(s, "p");
if (crc32("UAhBFCGJaQe",11) == 4162131564) strcat(s, "l");
if (crc32("gAbVOzNGEwH",11) == 3580274325) strcat(s, "G");
if (crc32("SVeAcpMoKMRS",12) == 168620526) strcat(s, "o");
if (crc32("eSyArBggYHzH",12) == 2408873416) strcat(s, "w");
    return s;
}

char *regaled_verbs() {
    char *s = calloc(8);
    if (crc32("jwlWyhBfWBA",11) == 947212804) strcat(s, "A");
if (crc32("FKHKhUv",7) == 3285208742) strcat(s, "r");
if (crc32("ATeYnzErLvohnvH",15) == 2407206595) strcat(s, "a");
if (crc32("mntGeKCdjvRg",12) == 3994989344) strcat(s, "e");
if (crc32("THjnVbUvQa",10) == 2245700161) strcat(s, "K");
if (crc32("EXevGPAwWcTLegB",15) == 1132243806) strcat(s, "g");
if (crc32("LDNecQGQB",9) == 952301187) strcat(s, "O");
if (crc32("jAAHa",5) == 1162204317) strcat(s, "a");
if (crc32("eSwlNLhlxdl",11) == 2697635593) strcat(s, "l");
if (crc32("UgSxgtha",8) == 399851168) strcat(s, "e");
if (crc32("bWBEBklc",8) == 2876339190) strcat(s, "d");
    return s;
}

char *disgorged_verbs() {
    char *s = calloc(10);
    if (crc32("bAgHLPOYZn",10) == 4033576623) strcat(s, "s");
if (crc32("FEVnDPnlujSP",12) == 542989590) strcat(s, "d");
if (crc32("XDBcPNWVGMzUVp",14) == 396947176) strcat(s, "l");
if (crc32("FzMZYGVvUCrWep",14) == 2632922529) strcat(s, "i");
if (crc32("RpeOfmUSOQLx",12) == 96905488) strcat(s, "d");
if (crc32("fJAGWqnOcdLI",12) == 2348158562) strcat(s, "s");
if (crc32("VQbFWfy",7) == 884721377) strcat(s, "g");
if (crc32("UQSrKhkajuKf",12) == 1366928813) strcat(s, "o");
if (crc32("Veeav",5) == 4128591203) strcat(s, "r");
if (crc32("yVUZbnjRfpElj",13) == 3590185093) strcat(s, "b");
if (crc32("GjnRXtheIpYdhGs",15) == 3590273014) strcat(s, "g");
if (crc32("VNJkpiknY",9) == 2080957957) strcat(s, "N");
if (crc32("CYksrMGUoxYdI",13) == 2841456646) strcat(s, "e");
if (crc32("OcVqSNGM",8) == 625844140) strcat(s, "d");
    return s;
}

char *singletongue_verbs() {
    char *s = calloc(13);
    if (crc32("OwTARj",6) == 3171769977) strcat(s, "W");
if (crc32("hLkzZGrnR",9) == 25602857) strcat(s, "s");
if (crc32("InSsDC",6) == 45464879) strcat(s, "C");
if (crc32("xbtHvukSZHvZnyO",15) == 3500411041) strcat(s, "i");
if (crc32("TImjMuAUfWmCn",13) == 849606835) strcat(s, "n");
if (crc32("hVhDFkfnYTBN",12) == 2495196219) strcat(s, "g");
if (crc32("WKQhCAtwpXa",11) == 902397811) strcat(s, "i");
if (crc32("WisVGS",6) == 1753876524) strcat(s, "l");
if (crc32("zQpFsYVerIA",11) == 259743331) strcat(s, "u");
if (crc32("KBsccayCSKx",11) == 3034030161) strcat(s, "e");
if (crc32("BhZdyXESEHcGms",14) == 3788284746) strcat(s, "T");
if (crc32("Pujwl",5) == 3286951116) strcat(s, "t");
if (crc32("NLcjMglHEHJX",12) == 2641224027) strcat(s, "v");
if (crc32("BPShfURRvBW",11) == 3836221212) strcat(s, "o");
if (crc32("sUEXKy",6) == 3589246543) strcat(s, "x");
if (crc32("XwaNcqLJcKsGACZ",15) == 97677532) strcat(s, "n");
if (crc32("mHpsjmqq",8) == 2989881331) strcat(s, "P");
if (crc32("fAKxkeQ",7) == 1891779586) strcat(s, "g");
if (crc32("GFoDDUlSPmashDs",15) == 744258932) strcat(s, "u");
if (crc32("dBxULQNZrDi",11) == 3078372822) strcat(s, "e");
    return s;
}

char *levy_verbs() {
    char *s = calloc(5);
    if (crc32("ZrKMFWWJND",10) == 2775350531) strcat(s, "l");
if (crc32("haBYjj",6) == 3943329401) strcat(s, "y");
if (crc32("iDtMXaMsR",9) == 1647514334) strcat(s, "e");
if (crc32("ujiATDByBdmYTWf",15) == 801628743) strcat(s, "v");
if (crc32("OeEXODmgvCywrA",14) == 982448979) strcat(s, "R");
if (crc32("dmJHhW",6) == 2433621706) strcat(s, "y");
    return s;
}

char *ejaculating_verbs() {
    char *s = calloc(12);
    if (crc32("azMtduvGnxweQbH",15) == 1826546717) strcat(s, "x");
if (crc32("elnNQFEAbssw",12) == 3241036744) strcat(s, "e");
if (crc32("AZieqxWoU",9) == 1472188433) strcat(s, "j");
if (crc32("OoUREPgDGP",10) == 3302640022) strcat(s, "a");
if (crc32("PAVnMT",6) == 1562495580) strcat(s, "c");
if (crc32("VChzwXU",7) == 3250064311) strcat(s, "u");
if (crc32("NKsaVH",6) == 264912626) strcat(s, "l");
if (crc32("UyKQJAQlJ",9) == 4024031215) strcat(s, "a");
if (crc32("yYcYbwpccW",10) == 2177005683) strcat(s, "R");
if (crc32("SEfGfMYEPsfAza",14) == 2409451419) strcat(s, "t");
if (crc32("zBDxvwvpf",9) == 3905357279) strcat(s, "U");
if (crc32("FYFjaz",6) == 1791585979) strcat(s, "i");
if (crc32("dNTNc",5) == 11525531) strcat(s, "n");
if (crc32("PSGNRYuuxCOEHFd",15) == 835749414) strcat(s, "H");
if (crc32("HWxMqnfrM",9) == 4136898580) strcat(s, "g");
    return s;
}

char *duelled_verbs() {
    char *s = calloc(8);
    if (crc32("mZwOBS",6) == 3389527388) strcat(s, "d");
if (crc32("XerSiOyHL",9) == 232399994) strcat(s, "u");
if (crc32("iGwWGThQG",9) == 2931097693) strcat(s, "e");
if (crc32("FwUWjCxFHQdYrx",14) == 1243260297) strcat(s, "V");
if (crc32("lLoYXQwsubACR",13) == 1399982600) strcat(s, "l");
if (crc32("WGiaviJV",8) == 4057046005) strcat(s, "c");
if (crc32("NrDjBLBEjF",10) == 2815413680) strcat(s, "l");
if (crc32("dyCoaXoU",8) == 866818290) strcat(s, "B");
if (crc32("JRakGkcP",8) == 595938980) strcat(s, "e");
if (crc32("nEOSOYX",7) == 1827780066) strcat(s, "B");
if (crc32("BMBPYmaNX",9) == 3321830538) strcat(s, "d");
    return s;
}

char *abate_verbs() {
    char *s = calloc(6);
    if (crc32("XzsGzQKhTZ",10) == 4266492587) strcat(s, "F");
if (crc32("WUgpxeN",7) == 3028045919) strcat(s, "a");
if (crc32("OylxZ",5) == 656649923) strcat(s, "b");
if (crc32("yYCoZ",5) == 3239931410) strcat(s, "E");
if (crc32("IiPsn",5) == 390806902) strcat(s, "a");
if (crc32("JVgUcBrynvqMp",13) == 467099882) strcat(s, "N");
if (crc32("BUXvevAXWxNpCwC",15) == 1804488386) strcat(s, "t");
if (crc32("eaUjKV",6) == 1928404337) strcat(s, "m");
if (crc32("ukiylNrbvm",10) == 3279850110) strcat(s, "e");
    return s;
}

char *finagled_verbs() {
    char *s = calloc(9);
    if (crc32("qmVXHEQtRx",10) == 3235601346) strcat(s, "k");
if (crc32("NVHwEFdmhrXrpw",14) == 2809968875) strcat(s, "f");
if (crc32("ADdSTir",7) == 1062395546) strcat(s, "i");
if (crc32("lEpOrbWWoK",10) == 991770233) strcat(s, "n");
if (crc32("JNfpcXcBUymbQ",13) == 3914546070) strcat(s, "a");
if (crc32("pPDccolNiSSH",12) == 1590861099) strcat(s, "Z");
if (crc32("VtYvEdsdHuZkf",13) == 2149839721) strcat(s, "g");
if (crc32("ZjgeqHiX",8) == 3064264378) strcat(s, "l");
if (crc32("TKpvwkDfKLWwLK",14) == 2924015702) strcat(s, "w");
if (crc32("tqaod",5) == 4166780373) strcat(s, "e");
if (crc32("zFNTUFsJQJ",10) == 4265274755) strcat(s, "d");
    return s;
}

char *hydroplaned_verbs() {
    char *s = calloc(12);
    if (crc32("jrbDHVHWHYQNMLD",15) == 837012034) strcat(s, "h");
if (crc32("APcrljo",7) == 826022321) strcat(s, "u");
if (crc32("uytnRt",6) == 1730077821) strcat(s, "y");
if (crc32("exPvCPdYtwJ",11) == 2980242974) strcat(s, "d");
if (crc32("sVXmnDNHLaOhjY",14) == 4027837701) strcat(s, "a");
if (crc32("eLLoqCqWeJqGZvp",15) == 3216686650) strcat(s, "r");
if (crc32("ruAsiE",6) == 40432281) strcat(s, "z");
if (crc32("ozwkpr",6) == 3629920576) strcat(s, "o");
if (crc32("hzwuPZJ",7) == 578727114) strcat(s, "p");
if (crc32("ZNRdi",5) == 2509079288) strcat(s, "l");
if (crc32("PMUghlHKoKBzd",13) == 1526901832) strcat(s, "a");
if (crc32("HJOVAGSQFZx",11) == 2320026847) strcat(s, "n");
if (crc32("hVdFWRXighDfWu",14) == 2087888029) strcat(s, "e");
if (crc32("dKFqBSWlpjo",11) == 2483130719) strcat(s, "d");
    return s;
}

char *bulleted_verbs() {
    char *s = calloc(9);
    if (crc32("ifXsGPHqkHm",11) == 246510371) strcat(s, "b");
if (crc32("gzsNaaOuTEapG",13) == 2796631958) strcat(s, "Z");
if (crc32("mQaTgEs",7) == 1501079906) strcat(s, "u");
if (crc32("wTezk",5) == 2282976080) strcat(s, "l");
if (crc32("MSmxahry",8) == 3560337034) strcat(s, "C");
if (crc32("zHqefuSdI",9) == 1092801782) strcat(s, "l");
if (crc32("VyDDaBF",7) == 672968966) strcat(s, "H");
if (crc32("lefEe",5) == 1788146533) strcat(s, "e");
if (crc32("oZKexBczF",9) == 1840852739) strcat(s, "B");
if (crc32("xhCoarbFwCsJVMf",15) == 1718478812) strcat(s, "t");
if (crc32("ZaKSr",5) == 1682558135) strcat(s, "e");
if (crc32("UpLXeEBvBW",10) == 3155669641) strcat(s, "d");
    return s;
}

char *clubhaul_verbs() {
    char *s = calloc(9);
    if (crc32("pHSwVYnxFgn",11) == 204819084) strcat(s, "i");
if (crc32("muilOSBEqFeoxfu",15) == 3443028617) strcat(s, "c");
if (crc32("myCxdT",6) == 3737905157) strcat(s, "Q");
if (crc32("SsfvfTd",7) == 2190713877) strcat(s, "l");
if (crc32("acDjdCIjeAQ",11) == 847106471) strcat(s, "X");
if (crc32("OfTdPJwJufJJsQ",14) == 3757171554) strcat(s, "u");
if (crc32("BSfEMXQNdoWgQaU",15) == 2788378514) strcat(s, "b");
if (crc32("tYpUUcOGIoL",11) == 3634652105) strcat(s, "H");
if (crc32("pdgIzjFCSZvD",12) == 2598047164) strcat(s, "h");
if (crc32("exeFYLplZ",9) == 2097245821) strcat(s, "a");
if (crc32("SZGGqUeZXmk",11) == 550449162) strcat(s, "C");
if (crc32("vEZwkT",6) == 3819646676) strcat(s, "u");
if (crc32("osEwVFhk",8) == 1211889851) strcat(s, "l");
    return s;
}

char *moil_verbs() {
    char *s = calloc(5);
    if (crc32("ZFLGUDXU",8) == 2485493334) strcat(s, "j");
if (crc32("ojmOJeftWZhRCen",15) == 3549449400) strcat(s, "m");
if (crc32("mJIXlvhCQ",9) == 2445847653) strcat(s, "x");
if (crc32("buNALOHQbbrE",12) == 2459556091) strcat(s, "o");
if (crc32("DXlgeuwX",8) == 3622259631) strcat(s, "i");
if (crc32("kuhJKjQEZ",9) == 3663955641) strcat(s, "l");
    return s;
}

char *atoned_verbs() {
    char *s = calloc(7);
    if (crc32("pRvrO",5) == 4125262700) strcat(s, "a");
if (crc32("lmemUwNBciW",11) == 4076840805) strcat(s, "t");
if (crc32("iGnCOwHku",9) == 2473597893) strcat(s, "o");
if (crc32("kLvST",5) == 2963722115) strcat(s, "V");
if (crc32("hVOGaG",6) == 3234482948) strcat(s, "n");
if (crc32("ivYPwIoW",8) == 335933035) strcat(s, "x");
if (crc32("ZdhSqp",6) == 2251042097) strcat(s, "e");
if (crc32("NLgKhnO",7) == 3141496728) strcat(s, "u");
if (crc32("sOoQjSfn",8) == 2862813326) strcat(s, "d");
    return s;
}

char *eavesdropped_verbs() {
    char *s = calloc(13);
    if (crc32("myNpIdpfCAJ",11) == 409557046) strcat(s, "b");
if (crc32("hHIbRmfHwS",10) == 3157755967) strcat(s, "e");
if (crc32("rZKLy",5) == 3100181546) strcat(s, "c");
if (crc32("BIgRLuJjfBeLwRk",15) == 378609122) strcat(s, "a");
if (crc32("ugylLEaqhTVn",12) == 1871756220) strcat(s, "m");
if (crc32("sAjgbyMRb",9) == 1452404622) strcat(s, "v");
if (crc32("lYHijNzUMERq",12) == 2535856400) strcat(s, "e");
if (crc32("RksnroJhkh",10) == 2891587000) strcat(s, "H");
if (crc32("Pyhpdy",6) == 3416652653) strcat(s, "s");
if (crc32("PeYQmvYgYGjiEDK",15) == 785072611) strcat(s, "d");
if (crc32("oQjZcaYTwSr",11) == 2238645706) strcat(s, "r");
if (crc32("dOpRVUPNfOTRSe",14) == 2489650458) strcat(s, "o");
if (crc32("XAZAXFQ",7) == 3233398716) strcat(s, "p");
if (crc32("AupyY",5) == 3487776999) strcat(s, "c");
if (crc32("elNDWA",6) == 1296045441) strcat(s, "p");
if (crc32("xKTFyPZbLCewZKR",15) == 3464520387) strcat(s, "P");
if (crc32("LHeOJHOitD",10) == 1356676661) strcat(s, "e");
if (crc32("SddyZegglgYlbWA",15) == 4254506710) strcat(s, "h");
if (crc32("UpLbGgttnjVHGd",14) == 85663646) strcat(s, "d");
    return s;
}

char *rated_verbs() {
    char *s = calloc(6);
    if (crc32("PAdNkp",6) == 3230915427) strcat(s, "r");
if (crc32("ZYQiR",5) == 4077370899) strcat(s, "p");
if (crc32("SaUSJRJw",8) == 4024189397) strcat(s, "a");
if (crc32("WsBTgOzu",8) == 1825905901) strcat(s, "v");
if (crc32("dtnNrXUvlVwFB",13) == 1296601560) strcat(s, "t");
if (crc32("URZHgKB",7) == 1191410941) strcat(s, "e");
if (crc32("DGjgomPKP",9) == 3127674832) strcat(s, "d");
    return s;
}

char *celebrate_verbs() {
    char *s = calloc(10);
    if (crc32("tYwxHwtRWcMu",12) == 2023780977) strcat(s, "c");
if (crc32("OeVgzgyY",8) == 411343471) strcat(s, "e");
if (crc32("CnjoaZaNDUCUUL",14) == 4149814992) strcat(s, "l");
if (crc32("PInsrvB",7) == 1508633594) strcat(s, "Q");
if (crc32("CMXDpA",6) == 3483586360) strcat(s, "e");
if (crc32("xUdBpkJMDQQbUH",14) == 439701193) strcat(s, "b");
if (crc32("CtJMsiPScn",10) == 3427109084) strcat(s, "q");
if (crc32("BllKjR",6) == 3101166055) strcat(s, "r");
if (crc32("knrSjiLzDCMjR",13) == 1938421090) strcat(s, "u");
if (crc32("ruaaaQHYltAA",12) == 3434495476) strcat(s, "a");
if (crc32("uygLmqpIH",9) == 607152454) strcat(s, "m");
if (crc32("iZQZgvrYBUNxch",14) == 2338552017) strcat(s, "t");
if (crc32("AouNqRsOL",9) == 1453564739) strcat(s, "e");
    return s;
}

char *entertain_verbs() {
    char *s = calloc(10);
    if (crc32("qJPzDEEyu",9) == 4022833471) strcat(s, "v");
if (crc32("aYHoWJV",7) == 1904697014) strcat(s, "e");
if (crc32("ZwlrHRkk",8) == 433988348) strcat(s, "n");
if (crc32("kBiVw",5) == 2086391573) strcat(s, "t");
if (crc32("ZFPQvb",6) == 3083776762) strcat(s, "e");
if (crc32("SVrjCgeVLVTC",12) == 357706097) strcat(s, "r");
if (crc32("aTGFfw",6) == 820751647) strcat(s, "t");
if (crc32("PCDTRRoapPlO",12) == 1727679996) strcat(s, "a");
if (crc32("AKkMlkGmr",9) == 2147061409) strcat(s, "I");
if (crc32("LAQFcAf",7) == 1726822256) strcat(s, "i");
if (crc32("SEdhZcttlCtP",12) == 3570446406) strcat(s, "L");
if (crc32("qfbUlaMWI",9) == 182421650) strcat(s, "n");
    return s;
}

char *overrationalize_verbs() {
    char *s = calloc(16);
    if (crc32("HnNySgahJ",9) == 2742966136) strcat(s, "a");
if (crc32("dEHZZgCDh",9) == 771248162) strcat(s, "o");
if (crc32("YiViamRP",8) == 500394024) strcat(s, "e");
if (crc32("WFvVuayMRXL",11) == 992104358) strcat(s, "v");
if (crc32("shSAll",6) == 2962926627) strcat(s, "e");
if (crc32("uTLiNTPKRJLOnm",14) == 2437940137) strcat(s, "Z");
if (crc32("cChRwfB",7) == 2624821289) strcat(s, "r");
if (crc32("FBFQV",5) == 1966318564) strcat(s, "r");
if (crc32("LvbvSIZVmIKpB",13) == 79787717) strcat(s, "h");
if (crc32("WJjQTmX",7) == 2880990246) strcat(s, "a");
if (crc32("XTyhIm",6) == 3380116583) strcat(s, "s");
if (crc32("ucKHYtErR",9) == 2554159640) strcat(s, "t");
if (crc32("vBRhYuRQAVGdKtY",15) == 4086483385) strcat(s, "I");
if (crc32("ZnZQjw",6) == 2724761581) strcat(s, "i");
if (crc32("lIiWgT",6) == 4245792327) strcat(s, "G");
if (crc32("XyGbUNhPAxfd",12) == 525004218) strcat(s, "o");
if (crc32("waECEzbnAVjVZK",14) == 384961645) strcat(s, "G");
if (crc32("rGeZbiW",7) == 197605540) strcat(s, "n");
if (crc32("JdythRuy",8) == 1757549221) strcat(s, "a");
if (crc32("rTQxnXWq",8) == 3995303273) strcat(s, "Z");
if (crc32("NZDAvQWEkEEKa",13) == 925437086) strcat(s, "l");
if (crc32("SreYNjFFHbPjr",13) == 2808328077) strcat(s, "b");
if (crc32("VfgTCNMKnGKdNg",14) == 3309995268) strcat(s, "i");
if (crc32("qPLFFGCrBiz",11) == 2792988821) strcat(s, "z");
if (crc32("wJVsQWV",7) == 612098414) strcat(s, "d");
if (crc32("rQkWgFXsrnygJs",14) == 1003386727) strcat(s, "e");
    return s;
}

char *poled_verbs() {
    char *s = calloc(6);
    if (crc32("OnlaQ",5) == 3862933877) strcat(s, "p");
if (crc32("PXHwBJnatiTwBIi",15) == 1987931521) strcat(s, "j");
if (crc32("tTgyzAHYO",9) == 2605708411) strcat(s, "o");
if (crc32("xredHDjRbNpJ",12) == 71397541) strcat(s, "p");
if (crc32("dZPHuiJnAwtu",12) == 2109423047) strcat(s, "l");
if (crc32("sKBYsuuBaAW",11) == 3390052162) strcat(s, "f");
if (crc32("gUkDNAh",7) == 2779089539) strcat(s, "e");
if (crc32("HXuQrcplEmiPQFO",15) == 4257691363) strcat(s, "d");
    return s;
}

char *ceasing_verbs() {
    char *s = calloc(8);
    if (crc32("dFlnwKq",7) == 3651071284) strcat(s, "c");
if (crc32("HkJFbq",6) == 1281125978) strcat(s, "e");
if (crc32("TGMmPmmDHOf",11) == 2202547075) strcat(s, "d");
if (crc32("TyQyXdlvAhRMXEp",15) == 2721821483) strcat(s, "a");
if (crc32("tCKJbRRaDwlvfl",14) == 1833512336) strcat(s, "s");
if (crc32("tgKvUIItqRHtUqC",15) == 2600797881) strcat(s, "v");
if (crc32("gDqAKNunZ",9) == 2346001580) strcat(s, "i");
if (crc32("YjDRGxaB",8) == 1819073512) strcat(s, "O");
if (crc32("wGILcmLMqVt",11) == 3624450687) strcat(s, "n");
if (crc32("ZMWBXKpWxfvp",12) == 2441531677) strcat(s, "g");
    return s;
}

char *exsiccating_verbs() {
    char *s = calloc(12);
    if (crc32("KdePzIS",7) == 1483038122) strcat(s, "e");
if (crc32("SwCBJNSuOBpeokn",15) == 1778446139) strcat(s, "x");
if (crc32("rCSPsmgdLfjR",12) == 605133232) strcat(s, "t");
if (crc32("ORjxIUNKkqTjHI",14) == 2579204854) strcat(s, "s");
if (crc32("CJMGDZZpB",9) == 1372534855) strcat(s, "i");
if (crc32("RRoESXqaJeIn",12) == 769135895) strcat(s, "u");
if (crc32("SZkpvY",6) == 2592023522) strcat(s, "c");
if (crc32("BUjQjSTUBwcZ",12) == 2629792772) strcat(s, "c");
if (crc32("QezUtFUUksmzjB",14) == 3164777104) strcat(s, "W");
if (crc32("fqOzhAsqyZrop",13) == 272848109) strcat(s, "a");
if (crc32("vqFQkEC",7) == 1358016142) strcat(s, "t");
if (crc32("FPnoPlQCEVNp",12) == 2876552907) strcat(s, "i");
if (crc32("UNzbTOuyi",9) == 2041737700) strcat(s, "n");
if (crc32("CZREwpl",7) == 2433123839) strcat(s, "g");
    return s;
}

char *whetted_verbs() {
    char *s = calloc(8);
    if (crc32("NbqAzwnpWrbAWA",14) == 1198559218) strcat(s, "w");
if (crc32("ryWpTlJOKHx",11) == 517938567) strcat(s, "h");
if (crc32("EjMEGPVijxuCXkh",15) == 2101644219) strcat(s, "e");
if (crc32("astibYmHKCfOPUn",15) == 1962683920) strcat(s, "t");
if (crc32("habxWVUq",8) == 2919813749) strcat(s, "W");
if (crc32("LdHltL",6) == 2394835430) strcat(s, "t");
if (crc32("YtTuiIX",7) == 703453261) strcat(s, "e");
if (crc32("IuTZESwstMuW",12) == 81564282) strcat(s, "W");
if (crc32("BPpSbEQhdZPUSe",14) == 834717307) strcat(s, "d");
    return s;
}

char *outwear_verbs() {
    char *s = calloc(8);
    if (crc32("jLxdECE",7) == 4092030730) strcat(s, "L");
if (crc32("SRgic",5) == 4119443590) strcat(s, "o");
if (crc32("xVNUpzXCY",9) == 542126827) strcat(s, "u");
if (crc32("xythOXVWn",9) == 3083129667) strcat(s, "Y");
if (crc32("hUzKpHKd",8) == 3737103075) strcat(s, "t");
if (crc32("MJMDHHAV",8) == 4224092058) strcat(s, "R");
if (crc32("ryBpiyIeCukS",12) == 1007076225) strcat(s, "w");
if (crc32("AgZpXNsBpE",10) == 2793218343) strcat(s, "e");
if (crc32("xsTrrtxQx",9) == 3725503209) strcat(s, "a");
if (crc32("bPUsenVucjLg",12) == 3199457985) strcat(s, "Q");
if (crc32("OIDRr",5) == 3146261992) strcat(s, "r");
    return s;
}

char *paganizing_verbs() {
    char *s = calloc(11);
    if (crc32("ZXxmDepj",8) == 1959373140) strcat(s, "u");
if (crc32("lWItDyQHh",9) == 4017003203) strcat(s, "p");
if (crc32("iCzNpSGmDvy",11) == 1178624527) strcat(s, "c");
if (crc32("ULYiNIlvQpcKu",13) == 2791906679) strcat(s, "a");
if (crc32("mfmcBfSPTbmxy",13) == 1953771919) strcat(s, "N");
if (crc32("oImgb",5) == 4065568081) strcat(s, "g");
if (crc32("ExzNmoaDMpygEL",14) == 4146677419) strcat(s, "q");
if (crc32("TMoUD",5) == 2537143923) strcat(s, "a");
if (crc32("fZbVeF",6) == 1676119107) strcat(s, "n");
if (crc32("ZItSxJPEITArCv",14) == 2732947415) strcat(s, "e");
if (crc32("rIuzGIOlXSuLXp",14) == 1783794497) strcat(s, "i");
if (crc32("COUofZQIJS",10) == 2937363401) strcat(s, "z");
if (crc32("OBCPtEJmg",9) == 736591356) strcat(s, "i");
if (crc32("jtcircUniLCZrTl",15) == 2682453686) strcat(s, "x");
if (crc32("qVZhRZhqZWClNWJ",15) == 1122578108) strcat(s, "n");
if (crc32("kyepClHTeXv",11) == 195787423) strcat(s, "g");
    return s;
}

char *crossfertilize_verbs() {
    char *s = calloc(15);
    if (crc32("TgpyfWgGixG",11) == 1325601798) strcat(s, "c");
if (crc32("inHccCStZFX",11) == 3201965468) strcat(s, "r");
if (crc32("keYQGy",6) == 865213613) strcat(s, "t");
if (crc32("rpUzS",5) == 1674221895) strcat(s, "o");
if (crc32("JNlPtubqt",9) == 3085896788) strcat(s, "s");
if (crc32("GkBRdFcoPPRgxh",14) == 183471734) strcat(s, "s");
if (crc32("ufjGY",5) == 26365465) strcat(s, "s");
if (crc32("ZJjlBtvWA",9) == 500460588) strcat(s, "X");
if (crc32("rXNBI",5) == 4240578438) strcat(s, "f");
if (crc32("HxjQW",5) == 1119497866) strcat(s, "F");
if (crc32("jbVBYXqGeHpeS",13) == 1156467089) strcat(s, "e");
if (crc32("icaxvRfndrhy",12) == 860938227) strcat(s, "r");
if (crc32("lfMLyc",6) == 3795774070) strcat(s, "t");
if (crc32("xXdsExgCouCve",13) == 1963462768) strcat(s, "i");
if (crc32("OPtcfMucdNfqs",13) == 3556985432) strcat(s, "l");
if (crc32("cvZjoMqJBWZVUc",14) == 3351548066) strcat(s, "i");
if (crc32("TsYmGxwzS",9) == 2138205428) strcat(s, "w");
if (crc32("zJLsOdiLHwEFGv",14) == 1758716263) strcat(s, "z");
if (crc32("TcMkE",5) == 2549234276) strcat(s, "r");
if (crc32("mHfqB",5) == 462220202) strcat(s, "e");
    return s;
}

char *devolatilized_verbs() {
    char *s = calloc(14);
    if (crc32("cZzvvx",6) == 2717578295) strcat(s, "I");
if (crc32("zhbBy",5) == 722938830) strcat(s, "d");
if (crc32("cPaVn",5) == 3695436472) strcat(s, "e");
if (crc32("VereaGYBHfcFKMD",15) == 1669782582) strcat(s, "g");
if (crc32("AFLIALjiYHzCFyg",15) == 876988225) strcat(s, "v");
if (crc32("LFIicUxGghb",11) == 4086856487) strcat(s, "o");
if (crc32("zlHCrPkvv",9) == 3661465777) strcat(s, "b");
if (crc32("BKSYe",5) == 2422194219) strcat(s, "l");
if (crc32("ZAsgYFvhOORu",12) == 2533040854) strcat(s, "a");
if (crc32("HNQtaTy",7) == 3136698890) strcat(s, "F");
if (crc32("gyGIygLeFm",10) == 1941640659) strcat(s, "t");
if (crc32("fWsmbBiQaYSxUj",14) == 3668580834) strcat(s, "W");
if (crc32("cyZyeAsEpa",10) == 532111116) strcat(s, "i");
if (crc32("DGSnPuzk",8) == 3497153513) strcat(s, "u");
if (crc32("rClkErzEzEZK",12) == 441092973) strcat(s, "l");
if (crc32("nofAM",5) == 774909343) strcat(s, "i");
if (crc32("owSFzdhiqN",10) == 1930025400) strcat(s, "z");
if (crc32("YYEYGsHFZBF",11) == 1925639) strcat(s, "A");
if (crc32("FoEucsUvF",9) == 606326521) strcat(s, "e");
if (crc32("TWQwcEDIts",10) == 34877594) strcat(s, "d");
    return s;
}

char *linger_verbs() {
    char *s = calloc(7);
    if (crc32("mPtmAexsTTzp",12) == 1231814438) strcat(s, "e");
if (crc32("FIKtHetiRmVzEEi",15) == 3898318227) strcat(s, "l");
if (crc32("zuDqVpxgWTXhIu",14) == 2722991816) strcat(s, "i");
if (crc32("MYOwzYQkV",9) == 2511176531) strcat(s, "S");
if (crc32("iQruHzXkFta",11) == 281378175) strcat(s, "n");
if (crc32("NKlcQWzkr",9) == 1947588479) strcat(s, "g");
if (crc32("xwEJibMhTzE",11) == 2862301866) strcat(s, "e");
if (crc32("XTgDjSrdMyeFK",13) == 4158808350) strcat(s, "x");
if (crc32("UujUcUJngs",10) == 495347545) strcat(s, "r");
    return s;
}

char *pigeonholing_verbs() {
    char *s = calloc(13);
    if (crc32("xdohIla",7) == 1042242033) strcat(s, "K");
if (crc32("Lzant",5) == 3131068598) strcat(s, "p");
if (crc32("QECvKJ",6) == 2141096253) strcat(s, "Q");
if (crc32("CIkhb",5) == 1970734889) strcat(s, "i");
if (crc32("FZgSFlmebfIIclx",15) == 975715266) strcat(s, "Q");
if (crc32("atOTY",5) == 831202774) strcat(s, "g");
if (crc32("EAxvVlWpzE",10) == 189578878) strcat(s, "L");
if (crc32("mYFgGumCfce",11) == 3480395253) strcat(s, "e");
if (crc32("huxjtjKqY",9) == 2474608696) strcat(s, "o");
if (crc32("pAoEeHezPmuUM",13) == 1534279332) strcat(s, "J");
if (crc32("LzCGbUyhmGGt",12) == 2949266731) strcat(s, "n");
if (crc32("dcVxvObiKKmj",12) == 818115624) strcat(s, "A");
if (crc32("xBfOIi",6) == 81685172) strcat(s, "h");
if (crc32("BXVQWOvnvf",10) == 2780075604) strcat(s, "o");
if (crc32("RPNZBEMzndzSZ",13) == 3215299913) strcat(s, "o");
if (crc32("soVitSqNzqkti",13) == 3179296075) strcat(s, "l");
if (crc32("eTxgK",5) == 1120914245) strcat(s, "i");
if (crc32("qdQDYMcCoQJtp",13) == 2998038995) strcat(s, "e");
if (crc32("sppjU",5) == 3280831384) strcat(s, "n");
if (crc32("IRapAWD",7) == 4283712375) strcat(s, "Q");
if (crc32("BELgeonuTkcWZzY",15) == 3785000692) strcat(s, "g");
    return s;
}

char *sophisticate_verbs() {
    char *s = calloc(13);
    if (crc32("SqTfHVtMiFp",11) == 3545571874) strcat(s, "s");
if (crc32("kaehQOWChtSAEH",14) == 2189750420) strcat(s, "B");
if (crc32("fepoAW",6) == 174334795) strcat(s, "o");
if (crc32("iTlEWGWdbLoukS",14) == 3345781567) strcat(s, "e");
if (crc32("HiYLVhSGjigBg",13) == 301977570) strcat(s, "p");
if (crc32("bxXEX",5) == 3498112631) strcat(s, "u");
if (crc32("HRjwX",5) == 2401983421) strcat(s, "h");
if (crc32("rtTRwDTcykiEuee",15) == 4134071716) strcat(s, "i");
if (crc32("eadmpESL",8) == 3518833868) strcat(s, "s");
if (crc32("JAiWxVMgT",9) == 4001436605) strcat(s, "X");
if (crc32("BNMWJMZPYNY",11) == 3772599799) strcat(s, "t");
if (crc32("QMaErumitRlp",12) == 162682297) strcat(s, "i");
if (crc32("neJIiNvrI",9) == 2400410948) strcat(s, "c");
if (crc32("hIeUul",6) == 1355448489) strcat(s, "n");
if (crc32("bYvlXYTSFXM",11) == 55251095) strcat(s, "a");
if (crc32("SFIlyVxR",8) == 2733544671) strcat(s, "q");
if (crc32("bmRzJXZETvbnXHn",15) == 2066551489) strcat(s, "t");
if (crc32("fCUJuY",6) == 2404451668) strcat(s, "d");
if (crc32("zWIqPLXUT",9) == 3980272206) strcat(s, "e");
    return s;
}

char *reinquiring_verbs() {
    char *s = calloc(12);
    if (crc32("lJuNYvDl",8) == 2710114942) strcat(s, "r");
if (crc32("oeWhibVWVVSD",12) == 1509566190) strcat(s, "r");
if (crc32("sVARp",5) == 450140643) strcat(s, "i");
if (crc32("nymZGPjnXWpExSN",15) == 3888555289) strcat(s, "e");
if (crc32("dhoblJwGeiWI",12) == 2755463331) strcat(s, "z");
if (crc32("oImZPKRUTLBWM",13) == 3258963647) strcat(s, "i");
if (crc32("ADgdmeLnu",9) == 2424894249) strcat(s, "n");
if (crc32("SnCBPJcaO",9) == 2007860700) strcat(s, "N");
if (crc32("SMyLeKWwCno",11) == 1472741279) strcat(s, "q");
if (crc32("XnKTVlv",7) == 3439019401) strcat(s, "u");
if (crc32("BQvtx",5) == 761252771) strcat(s, "S");
if (crc32("WqmVFkE",7) == 3222061984) strcat(s, "i");
if (crc32("sCwKIpTRj",9) == 3035009506) strcat(s, "r");
if (crc32("IHjlBDlmGbN",11) == 4127528765) strcat(s, "Q");
if (crc32("fFxgxw",6) == 1917362874) strcat(s, "i");
if (crc32("dtQYQDOIgg",10) == 1447589774) strcat(s, "O");
if (crc32("pIdQpFfr",8) == 477321403) strcat(s, "n");
if (crc32("PqWDnkDkpNYSUxX",15) == 2437731517) strcat(s, "g");
    return s;
}

char *preinvestigate_verbs() {
    char *s = calloc(15);
    if (crc32("gsXyUjJFcoQDlnE",15) == 1778405397) strcat(s, "h");
if (crc32("FlRhgbiUphato",13) == 3977022666) strcat(s, "p");
if (crc32("ahAhtmZDavxW",12) == 3085175341) strcat(s, "r");
if (crc32("aMKacCaDHJi",11) == 316167389) strcat(s, "e");
if (crc32("AFmALYfMuTUb",12) == 3707003119) strcat(s, "m");
if (crc32("ShaOkjnlbhba",12) == 2479307949) strcat(s, "i");
if (crc32("KKLmxTieA",9) == 661688985) strcat(s, "Y");
if (crc32("LSHZRPFIgToXhvJ",15) == 1435802952) strcat(s, "n");
if (crc32("VLPomEibrS",10) == 2173818592) strcat(s, "v");
if (crc32("CgsqIz",6) == 3034369165) strcat(s, "r");
if (crc32("qSkIRsGtTn",10) == 857616576) strcat(s, "e");
if (crc32("ynSYfKL",7) == 1063910776) strcat(s, "s");
if (crc32("TkTyjA",6) == 1236898847) strcat(s, "t");
if (crc32("BhMpAIlQ",8) == 3901428965) strcat(s, "Z");
if (crc32("qamOFjBKnTVZ",12) == 180772736) strcat(s, "i");
if (crc32("PlFsUBMxBbdN",12) == 426211049) strcat(s, "g");
if (crc32("VIJuTFwy",8) == 386452775) strcat(s, "w");
if (crc32("mSbxdTNhmCG",11) == 764477386) strcat(s, "a");
if (crc32("YkfKfa",6) == 3311025924) strcat(s, "Y");
if (crc32("QaUdmx",6) == 4022490244) strcat(s, "t");
if (crc32("InlwcIxCZ",9) == 971935613) strcat(s, "e");
    return s;
}

char *engage_verbs() {
    char *s = calloc(7);
    if (crc32("OWaFINy",7) == 484550369) strcat(s, "e");
if (crc32("HEjfGwfWLR",10) == 2752973558) strcat(s, "n");
if (crc32("LKuyOHkLiIqgv",13) == 1703883962) strcat(s, "B");
if (crc32("nDxNgMCPaeCd",12) == 1036592341) strcat(s, "g");
if (crc32("lHmtHL",6) == 2064210670) strcat(s, "a");
if (crc32("MIRNU",5) == 2594062716) strcat(s, "g");
if (crc32("ptSZHEolIzDWOC",14) == 2992395043) strcat(s, "e");
    return s;
}

char *presumed_verbs() {
    char *s = calloc(9);
    if (crc32("abqeZuNEhQlZZLA",15) == 58210636) strcat(s, "M");
if (crc32("QyvsuCk",7) == 1760916932) strcat(s, "p");
if (crc32("tkoARCHke",9) == 999286449) strcat(s, "G");
if (crc32("eORdMZgIDgDT",12) == 3861438399) strcat(s, "r");
if (crc32("KdeUEC",6) == 3166423681) strcat(s, "e");
if (crc32("FIUmpUEKjH",10) == 3932579365) strcat(s, "o");
if (crc32("BaBEysuW",8) == 371151117) strcat(s, "s");
if (crc32("gkoLtet",7) == 4083098870) strcat(s, "U");
if (crc32("EcWzMFWo",8) == 695616369) strcat(s, "u");
if (crc32("PBdPfFZmA",9) == 303653678) strcat(s, "b");
if (crc32("AZhLdvLclgaCGb",14) == 3941281395) strcat(s, "m");
if (crc32("kyetBBP",7) == 46381625) strcat(s, "W");
if (crc32("VBCOMmuYIQz",11) == 215743303) strcat(s, "e");
if (crc32("xIwImhCJUqi",11) == 169066775) strcat(s, "i");
if (crc32("CtFPfG",6) == 1031843373) strcat(s, "d");
    return s;
}

char *overstraighten_verbs() {
    char *s = calloc(15);
    if (crc32("HAULDOkW",8) == 251047850) strcat(s, "Q");
if (crc32("xlBXKuyNStdaNh",14) == 2939038393) strcat(s, "o");
if (crc32("bAmoIBVnjTJgTRb",15) == 3574628682) strcat(s, "m");
if (crc32("BPCrnb",6) == 1297598655) strcat(s, "v");
if (crc32("XHavsBaz",8) == 1180503732) strcat(s, "y");
if (crc32("XSgZtCCEhquj",12) == 1678836306) strcat(s, "e");
if (crc32("YPvKwGsTf",9) == 3249668318) strcat(s, "t");
if (crc32("UEJJPNc",7) == 2198013657) strcat(s, "r");
if (crc32("OnOqRCm",7) == 1525279740) strcat(s, "f");
if (crc32("TmGLUCcDHw",10) == 3044744176) strcat(s, "s");
if (crc32("FDXainJRDlBHMaz",15) == 1635870982) strcat(s, "Y");
if (crc32("UJfyBgwDv",9) == 1523912490) strcat(s, "t");
if (crc32("syMtqo",6) == 1425012644) strcat(s, "I");
if (crc32("wWEsbr",6) == 1047259186) strcat(s, "r");
if (crc32("sgcLmyDd",8) == 429236176) strcat(s, "C");
if (crc32("DJzQWEScP",9) == 1062768154) strcat(s, "a");
if (crc32("zUTMnniNVRlzueo",15) == 1098334448) strcat(s, "q");
if (crc32("ILmPYBZng",9) == 1098413882) strcat(s, "i");
if (crc32("yVIouShpbqDpUp",14) == 2818572128) strcat(s, "o");
if (crc32("YAyTFfo",7) == 3308646658) strcat(s, "g");
if (crc32("TYIXVSLumoTv",12) == 2848709897) strcat(s, "w");
if (crc32("XxhPhgDba",9) == 4055890257) strcat(s, "h");
if (crc32("LreKdr",6) == 1761296535) strcat(s, "K");
if (crc32("OWfnSRSKEEU",11) == 526707378) strcat(s, "t");
if (crc32("VAYVhbPJyQxau",13) == 1655996211) strcat(s, "c");
if (crc32("AUBzjwAwjLOs",12) == 1390179599) strcat(s, "e");
if (crc32("huSxBjDvYDxIp",13) == 905326864) strcat(s, "n");
    return s;
}

char *retrieving_verbs() {
    char *s = calloc(11);
    if (crc32("onJIpilCRWFW",12) == 1373113547) strcat(s, "r");
if (crc32("SvCSfcgHy",9) == 1244335329) strcat(s, "N");
if (crc32("mosGrqFTEVrVU",13) == 3611309023) strcat(s, "e");
if (crc32("VOnWdZInn",9) == 3363639614) strcat(s, "h");
if (crc32("wZvHJYhsddgXvQU",15) == 111446016) strcat(s, "t");
if (crc32("tTAqLtZpFqiFskJ",15) == 1496566200) strcat(s, "r");
if (crc32("QvAHnmgA",8) == 3662603065) strcat(s, "P");
if (crc32("ZulZyRrXpYlXSAU",15) == 2074071235) strcat(s, "i");
if (crc32("RwhejABsqyFPrL",14) == 3661897582) strcat(s, "Y");
if (crc32("gpJMazzjyLPGDsE",15) == 3548862671) strcat(s, "e");
if (crc32("MNUgfOTwzaMcGVt",15) == 2978767514) strcat(s, "v");
if (crc32("uXbZIUVScY",10) == 726982215) strcat(s, "i");
if (crc32("KIGynjtcqKN",11) == 1968183808) strcat(s, "n");
if (crc32("ApDdQf",6) == 3792010079) strcat(s, "v");
if (crc32("pufzAcwrvoIS",12) == 2110003668) strcat(s, "g");
    return s;
}

char *mimic_verbs() {
    char *s = calloc(6);
    if (crc32("potAbdQgd",9) == 2582188098) strcat(s, "m");
if (crc32("IwkCDIzNQcnDdZa",15) == 454211395) strcat(s, "i");
if (crc32("XLTilwbYsYwP",12) == 311004234) strcat(s, "m");
if (crc32("SPoaEsVxJnyF",12) == 1531995935) strcat(s, "i");
if (crc32("AUkjk",5) == 1586652744) strcat(s, "c");
    return s;
}

char *intwine_verbs() {
    char *s = calloc(8);
    if (crc32("kHCguQQxyT",10) == 2730035360) strcat(s, "O");
if (crc32("MOmTwkCtYdgI",12) == 3990068025) strcat(s, "i");
if (crc32("UROOs",5) == 2466171198) strcat(s, "n");
if (crc32("DGAdLiQGRwTQvu",14) == 965635194) strcat(s, "Y");
if (crc32("JIyzhOhUTn",10) == 1025043082) strcat(s, "t");
if (crc32("xqZRYKb",7) == 2704904235) strcat(s, "Y");
if (crc32("pqFMrRuaMoClJ",13) == 96686251) strcat(s, "w");
if (crc32("luFjodKbZkwOtL",14) == 238089862) strcat(s, "i");
if (crc32("NjGshovKrCRXShx",15) == 595539872) strcat(s, "n");
if (crc32("dREHdE",6) == 878620568) strcat(s, "g");
if (crc32("njOOZpLTZmQ",11) == 2794048919) strcat(s, "e");
    return s;
}

char *ceased_verbs() {
    char *s = calloc(7);
    if (crc32("HDXyX",5) == 1532708117) strcat(s, "u");
if (crc32("PrINFtQBOisv",12) == 3190696575) strcat(s, "c");
if (crc32("HkFIiFpY",8) == 2511868986) strcat(s, "e");
if (crc32("qxSeNre",7) == 429659918) strcat(s, "a");
if (crc32("tcFqshTTo",9) == 3657996302) strcat(s, "s");
if (crc32("TlWeflQZKY",10) == 3108455846) strcat(s, "t");
if (crc32("tisEcnJhzPzTj",13) == 695950507) strcat(s, "e");
if (crc32("YBZiStoHmrkB",12) == 2644618423) strcat(s, "P");
if (crc32("sXXHDJuP",8) == 2411818211) strcat(s, "d");
    return s;
}

char *backslid_verbs() {
    char *s = calloc(9);
    if (crc32("tDjVyj",6) == 4093536674) strcat(s, "I");
if (crc32("stJAmSSKck",10) == 4085551002) strcat(s, "b");
if (crc32("GQwCO",5) == 868820369) strcat(s, "a");
if (crc32("rBwSVzj",7) == 1412337561) strcat(s, "o");
if (crc32("HNeOGl",6) == 956888823) strcat(s, "c");
if (crc32("xxKNDUpaXVlvIq",14) == 1930130982) strcat(s, "k");
if (crc32("lYNMy",5) == 3697194752) strcat(s, "e");
if (crc32("AkGfjuEcItEwd",13) == 1304757693) strcat(s, "s");
if (crc32("feKvXTKbIIRMt",13) == 3389256145) strcat(s, "l");
if (crc32("getHNATINhiK",12) == 3261440248) strcat(s, "A");
if (crc32("YVWAJvOPUjI",11) == 4189181981) strcat(s, "i");
if (crc32("KXRYNVlZCXJIN",13) == 2998286290) strcat(s, "d");
    return s;
}

char *tranced_verbs() {
    char *s = calloc(8);
    if (crc32("xpVzkFkddvJRP",13) == 3296227943) strcat(s, "r");
if (crc32("JHJmPmBNdA",10) == 2065430994) strcat(s, "t");
if (crc32("vRxwcg",6) == 1072487934) strcat(s, "C");
if (crc32("UMIxVgnFP",9) == 3289764385) strcat(s, "r");
if (crc32("pOUcO",5) == 1044633479) strcat(s, "a");
if (crc32("dbcQSXoTPXEiTl",14) == 4079555440) strcat(s, "i");
if (crc32("tYFAXdCDhNefx",13) == 377735912) strcat(s, "n");
if (crc32("efkNBQ",6) == 3350541839) strcat(s, "D");
if (crc32("DFzRxtBGRHrnTF",14) == 863949637) strcat(s, "c");
if (crc32("oaaCxClPLF",10) == 3351331391) strcat(s, "e");
if (crc32("QJiGxvSXJZWelFC",15) == 261526422) strcat(s, "d");
    return s;
}

char *gumshoed_verbs() {
    char *s = calloc(9);
    if (crc32("hgvvvcd",7) == 1550942710) strcat(s, "g");
if (crc32("plvGTFs",7) == 2063203318) strcat(s, "u");
if (crc32("MCalTfbjnGcKOdN",15) == 3295191185) strcat(s, "g");
if (crc32("eGVqIggLawHN",12) == 3964966572) strcat(s, "m");
if (crc32("wpSFsZHyQChC",12) == 3684776911) strcat(s, "s");
if (crc32("DSuTIdOrRw",10) == 2586133882) strcat(s, "h");
if (crc32("BinNBjGbcCkkHo",14) == 220196647) strcat(s, "o");
if (crc32("rzpMsxPtMEjSXf",14) == 3078931213) strcat(s, "e");
if (crc32("QXqlXR",6) == 3366240206) strcat(s, "F");
if (crc32("XGpxSxb",7) == 3807529381) strcat(s, "d");
    return s;
}

char *whizzing_verbs() {
    char *s = calloc(9);
    if (crc32("WVqJGSaPrr",10) == 1705076399) strcat(s, "y");
if (crc32("QATLDbv",7) == 1504023050) strcat(s, "w");
if (crc32("NUBehCfUdUmYe",13) == 661559826) strcat(s, "h");
if (crc32("SScbk",5) == 2803050182) strcat(s, "i");
if (crc32("KnYEHBWIAKA",11) == 3375017222) strcat(s, "G");
if (crc32("IqKBfNFhqbVIhS",14) == 3859218292) strcat(s, "z");
if (crc32("iNZGo",5) == 718652226) strcat(s, "z");
if (crc32("hvLqQJLk",8) == 3719059990) strcat(s, "i");
if (crc32("MDLQocijwg",10) == 2799732552) strcat(s, "R");
if (crc32("LdaPS",5) == 4004109836) strcat(s, "n");
if (crc32("IQiXEm",6) == 2469331621) strcat(s, "L");
if (crc32("XwKVwkPiFuaPta",14) == 617380965) strcat(s, "g");
    return s;
}

char *determining_verbs() {
    char *s = calloc(12);
    if (crc32("hCmeABQTU",9) == 3906918707) strcat(s, "d");
if (crc32("SBwTEJ",6) == 2679233876) strcat(s, "e");
if (crc32("JtqchfOf",8) == 3600487438) strcat(s, "z");
if (crc32("LulpF",5) == 4136484332) strcat(s, "t");
if (crc32("WyFXxUPhOFTzdW",14) == 1127316033) strcat(s, "e");
if (crc32("ZsKULhZriaKLg",13) == 3685471697) strcat(s, "r");
if (crc32("GoTjmbyNOmZYhi",14) == 1641476032) strcat(s, "m");
if (crc32("jWKObBcEtaLssC",14) == 3399220088) strcat(s, "i");
if (crc32("lnatbpEjIHYvq",13) == 1668708468) strcat(s, "n");
if (crc32("ZdnwNCHSfnXk",12) == 157107032) strcat(s, "Z");
if (crc32("dzXYiETHJ",9) == 475652461) strcat(s, "i");
if (crc32("xtSbjLtr",8) == 1166161139) strcat(s, "b");
if (crc32("PzGhQAmOFfMira",14) == 2027067995) strcat(s, "n");
if (crc32("blauNsQFxxMcXz",14) == 1733852685) strcat(s, "c");
if (crc32("hrqOSvMrfifg",12) == 916115032) strcat(s, "g");
    return s;
}

char *wrapped_verbs() {
    char *s = calloc(8);
    if (crc32("IgbJHbDeEAmqid",14) == 3232886985) strcat(s, "a");
if (crc32("wzqcfAQUu",9) == 874726417) strcat(s, "w");
if (crc32("COowM",5) == 832488430) strcat(s, "r");
if (crc32("nUnzAIeFQnusx",13) == 2145681720) strcat(s, "d");
if (crc32("qzpQvibCvTEHdk",14) == 1323982231) strcat(s, "a");
if (crc32("dsbWnDCaMdoMr",13) == 3805766485) strcat(s, "p");
if (crc32("rmMPg",5) == 2082903043) strcat(s, "X");
if (crc32("dJsHJjmmlJ",10) == 2386712038) strcat(s, "p");
if (crc32("JqYvwI",6) == 1387528985) strcat(s, "e");
if (crc32("nxAaZrNmOfzJNMU",15) == 491580085) strcat(s, "d");
if (crc32("uaZJaWgXE",9) == 2732489698) strcat(s, "d");
    return s;
}

char *remodified_verbs() {
    char *s = calloc(11);
    if (crc32("hUWtSNDPFUgtJq",14) == 3813555288) strcat(s, "x");
if (crc32("aAZYGckfmRaK",12) == 2046310029) strcat(s, "r");
if (crc32("eqrimKPkiX",10) == 2077091494) strcat(s, "b");
if (crc32("eXVWW",5) == 4052579755) strcat(s, "e");
if (crc32("qQHUXtSPjxpNDEN",15) == 3961824757) strcat(s, "i");
if (crc32("BMtrTLy",7) == 788185977) strcat(s, "m");
if (crc32("ZtgUnat",7) == 3585191210) strcat(s, "g");
if (crc32("ZsStZYo",7) == 3687753098) strcat(s, "o");
if (crc32("MACmxrMasvlW",12) == 822509271) strcat(s, "e");
if (crc32("rRoJnMMmyrQTP",13) == 361848052) strcat(s, "d");
if (crc32("qMfdJdT",7) == 1120606138) strcat(s, "n");
if (crc32("SANKd",5) == 3111120411) strcat(s, "i");
if (crc32("ZINsBVxhaUzX",12) == 2577243408) strcat(s, "M");
if (crc32("LCKIGsaMLq",10) == 156119318) strcat(s, "f");
if (crc32("KLoyKbfHKa",10) == 47984376) strcat(s, "i");
if (crc32("huUPIfOWVVl",11) == 3941567781) strcat(s, "d");
if (crc32("KVwvBXmqhhJAHGB",15) == 3449963755) strcat(s, "e");
if (crc32("hyxnwLFM",8) == 894319336) strcat(s, "O");
if (crc32("KdawMetWM",9) == 3615355110) strcat(s, "d");
    return s;
}

char *flaking_verbs() {
    char *s = calloc(8);
    if (crc32("AINkvPni",8) == 803453903) strcat(s, "d");
if (crc32("HlAaiYV",7) == 3720358061) strcat(s, "f");
if (crc32("NmZEJbjAQ",9) == 1353022151) strcat(s, "l");
if (crc32("mSytdOLAKuv",11) == 3567613514) strcat(s, "l");
if (crc32("vwXhaAUGmwyrBl",14) == 2277907903) strcat(s, "a");
if (crc32("edNVxeBGxgv",11) == 3627070790) strcat(s, "E");
if (crc32("XbnbhJaWJog",11) == 3526061531) strcat(s, "k");
if (crc32("logObEDksBkHkuN",15) == 3977166841) strcat(s, "i");
if (crc32("gKnDSspRdgV",11) == 353902525) strcat(s, "q");
if (crc32("txVuTAzvC",9) == 250886434) strcat(s, "n");
if (crc32("dgjMOjDXXe",10) == 1939647847) strcat(s, "g");
    return s;
}

char *gutturalizing_verbs() {
    char *s = calloc(14);
    if (crc32("ApQVADa",7) == 1088366159) strcat(s, "g");
if (crc32("BuhmvldvEhmJJy",14) == 2557044342) strcat(s, "u");
if (crc32("wircO",5) == 876129040) strcat(s, "t");
if (crc32("GINrUa",6) == 2459794998) strcat(s, "G");
if (crc32("zhhedFTqgVByF",13) == 1391030794) strcat(s, "t");
if (crc32("FgIqdEEtzvJXnR",14) == 266987008) strcat(s, "q");
if (crc32("CyNHzwR",7) == 3250341894) strcat(s, "u");
if (crc32("NkutNmAkcWcKnu",14) == 1523488548) strcat(s, "G");
if (crc32("wrEKjsk",7) == 3044886791) strcat(s, "r");
if (crc32("CRwyFSYl",8) == 365385954) strcat(s, "K");
if (crc32("iIGJAtQhhBmF",12) == 85034052) strcat(s, "a");
if (crc32("spMHZdD",7) == 851231788) strcat(s, "U");
if (crc32("mRDtWixJb",9) == 1124379930) strcat(s, "l");
if (crc32("pZLEgFbO",8) == 654126159) strcat(s, "d");
if (crc32("AheNpTQKV",9) == 2171923976) strcat(s, "i");
if (crc32("YvKuBuZAFToDJJ",14) == 43646769) strcat(s, "f");
if (crc32("pwQgvYFb",8) == 618386139) strcat(s, "z");
if (crc32("spYIXABmC",9) == 4000275008) strcat(s, "T");
if (crc32("CzBEedN",7) == 304543460) strcat(s, "i");
if (crc32("zZlNsCQFyLHOtaR",15) == 2530478752) strcat(s, "n");
if (crc32("mDPydgBeaZgBv",13) == 158792281) strcat(s, "L");
if (crc32("jBfgtMlzXvJ",11) == 3364276105) strcat(s, "g");
    return s;
}

char *depreciating_verbs() {
    char *s = calloc(13);
    if (crc32("qwpRQdtRG",9) == 4062270901) strcat(s, "Z");
if (crc32("dbwFup",6) == 1105681690) strcat(s, "d");
if (crc32("gDhoFBSe",8) == 3805637130) strcat(s, "C");
if (crc32("NujuvRK",7) == 1680589126) strcat(s, "e");
if (crc32("KAbUOdPAwplof",13) == 1016905227) strcat(s, "p");
if (crc32("QkeFu",5) == 3878028703) strcat(s, "r");
if (crc32("AJyBQ",5) == 3524993415) strcat(s, "e");
if (crc32("mmFOYIU",7) == 2389987157) strcat(s, "c");
if (crc32("bmXoiWhPgo",10) == 4031165337) strcat(s, "J");
if (crc32("RAjfvSH",7) == 2566974157) strcat(s, "i");
if (crc32("ufnKsdPD",8) == 2306312803) strcat(s, "a");
if (crc32("VkdrUpfK",8) == 354811949) strcat(s, "t");
if (crc32("rAAkAhekTnBx",12) == 4244638217) strcat(s, "G");
if (crc32("qNECAdfZt",9) == 680040255) strcat(s, "i");
if (crc32("XFBNrvBsrqOovn",14) == 668915734) strcat(s, "T");
if (crc32("znJbNMArnhfm",12) == 2403551715) strcat(s, "n");
if (crc32("zhWzBK",6) == 2663701642) strcat(s, "g");
    return s;
}

char *semaphoring_verbs() {
    char *s = calloc(12);
    if (crc32("IaphvcmjlFsz",12) == 1343951371) strcat(s, "s");
if (crc32("MvIKyG",6) == 4160802404) strcat(s, "e");
if (crc32("JcFPijmglKhJMUq",15) == 2086458505) strcat(s, "q");
if (crc32("rCTMbvBPI",9) == 2417084486) strcat(s, "m");
if (crc32("FKVBehVWyo",10) == 2386568177) strcat(s, "t");
if (crc32("QAPbKZtorUgDyp",14) == 572936058) strcat(s, "a");
if (crc32("NoUCOWEmxq",10) == 1666247039) strcat(s, "A");
if (crc32("IpYWxTgxTUXyk",13) == 219730031) strcat(s, "p");
if (crc32("aWXUeHSJEU",10) == 1051868900) strcat(s, "h");
if (crc32("UCgUpJsP",8) == 364593333) strcat(s, "Z");
if (crc32("lBbNnmo",7) == 1153750690) strcat(s, "o");
if (crc32("Juuuo",5) == 1921118499) strcat(s, "C");
if (crc32("sEsfpShTHpq",11) == 1452668409) strcat(s, "r");
if (crc32("FpfBbJflBJs",11) == 1455065375) strcat(s, "u");
if (crc32("volAMKtgxGrLbiQ",15) == 1717461992) strcat(s, "i");
if (crc32("OeZZv",5) == 3018587052) strcat(s, "g");
if (crc32("eLQcRT",6) == 2840804743) strcat(s, "n");
if (crc32("ccSnnfETdjrAaID",15) == 4111337652) strcat(s, "g");
    return s;
}

char *advocate_verbs() {
    char *s = calloc(9);
    if (crc32("ISLopiScwGswW",13) == 2946160199) strcat(s, "a");
if (crc32("SdLHgThk",8) == 3544767925) strcat(s, "B");
if (crc32("xfUrMYUAWRU",11) == 39220292) strcat(s, "d");
if (crc32("yoqdAjPsVlhZpn",14) == 2664339800) strcat(s, "l");
if (crc32("MQffvFyFyVn",11) == 415184141) strcat(s, "v");
if (crc32("exyJLWVuRHYqgFp",15) == 3240452973) strcat(s, "X");
if (crc32("mHqoORfHRzncN",13) == 2842511451) strcat(s, "o");
if (crc32("MvqNsJIlyNDsxj",14) == 3918541545) strcat(s, "c");
if (crc32("gYsWJvokyYWnm",13) == 1009328302) strcat(s, "a");
if (crc32("LZTnBNeZTgmxr",13) == 3537655657) strcat(s, "g");
if (crc32("IAqoQoqsummDjJ",14) == 3346227305) strcat(s, "t");
if (crc32("fxlGtALJw",9) == 3530262646) strcat(s, "z");
if (crc32("VeeHAECt",8) == 3331986075) strcat(s, "e");
    return s;
}

char *geologize_verbs() {
    char *s = calloc(10);
    if (crc32("yZCNhgvasKO",11) == 1613725865) strcat(s, "g");
if (crc32("fJJRTnsUJeAjIv",14) == 2931350810) strcat(s, "e");
if (crc32("CCNOBmII",8) == 227764793) strcat(s, "v");
if (crc32("WRqZSQUDKk",10) == 3464352752) strcat(s, "o");
if (crc32("avZQcF",6) == 1801962555) strcat(s, "q");
if (crc32("MBfwkOYHOLs",11) == 2548221314) strcat(s, "l");
if (crc32("AhIcssAiBAWE",12) == 1826966428) strcat(s, "H");
if (crc32("ljgPCNd",7) == 3472065919) strcat(s, "o");
if (crc32("PQrNO",5) == 1382863525) strcat(s, "g");
if (crc32("obWRHkYY",8) == 516212629) strcat(s, "V");
if (crc32("GHQTJVpG",8) == 1623251524) strcat(s, "i");
if (crc32("HEiNFOPxobCwm",13) == 3652028804) strcat(s, "z");
if (crc32("NfgrfmI",7) == 92876980) strcat(s, "V");
if (crc32("PpkYiudziFPhRn",14) == 3389946037) strcat(s, "e");
    return s;
}

char *dissimilate_verbs() {
    char *s = calloc(12);
    if (crc32("dLSRomf",7) == 3014742583) strcat(s, "d");
if (crc32("nnGCSplkSLZTsMR",15) == 285377785) strcat(s, "H");
if (crc32("rDhVvcxasnp",11) == 2554750568) strcat(s, "i");
if (crc32("RnQJVJ",6) == 2731734014) strcat(s, "s");
if (crc32("ZQbOKgMsReo",11) == 96678983) strcat(s, "s");
if (crc32("XuwxLzXZbBuVhn",14) == 897173902) strcat(s, "X");
if (crc32("MtVtt",5) == 4128638971) strcat(s, "i");
if (crc32("XddUltkOqkBN",12) == 2208075166) strcat(s, "M");
if (crc32("yVtegMzhMzhg",12) == 159931494) strcat(s, "m");
if (crc32("aeAFMHBVIZ",10) == 2063030676) strcat(s, "P");
if (crc32("eqSaVocNcrb",11) == 3972765006) strcat(s, "i");
if (crc32("RxnlhxEm",8) == 3655795033) strcat(s, "l");
if (crc32("suFqErUtJHkp",12) == 3317677594) strcat(s, "a");
if (crc32("aVlvCpGU",8) == 1235983029) strcat(s, "t");
if (crc32("aoLoqy",6) == 2550028624) strcat(s, "U");
if (crc32("xUiyfPdWeSQeLsZ",15) == 2114008449) strcat(s, "e");
    return s;
}

char *inspired_verbs() {
    char *s = calloc(9);
    if (crc32("vIBrZrfSgDisC",13) == 1021799733) strcat(s, "i");
if (crc32("AwoTCvCAjWv",11) == 747937855) strcat(s, "b");
if (crc32("cAOORKtxgtIVext",15) == 2414595649) strcat(s, "n");
if (crc32("wgxFnXtrg",9) == 2472400450) strcat(s, "e");
if (crc32("qEVGIvVoepzE",12) == 2657901115) strcat(s, "s");
if (crc32("xKWYoF",6) == 838727358) strcat(s, "p");
if (crc32("gFMKKUTFEX",10) == 4130138011) strcat(s, "s");
if (crc32("qSJemVLtqKP",11) == 2978129859) strcat(s, "i");
if (crc32("hxocoHHolJhL",12) == 3290935076) strcat(s, "d");
if (crc32("wZFbjPjeOU",10) == 77832243) strcat(s, "r");
if (crc32("PwiKXgStCfJXAi",14) == 3494505810) strcat(s, "z");
if (crc32("gYTXixfHVyracA",14) == 2774534598) strcat(s, "e");
if (crc32("hNitXw",6) == 460554618) strcat(s, "d");
    return s;
}

char *basseted_verbs() {
    char *s = calloc(9);
    if (crc32("BMLedmEASTrdRct",15) == 3973838081) strcat(s, "H");
if (crc32("IgMHSPUnIAAZx",13) == 3177497586) strcat(s, "b");
if (crc32("wvNEgKxNRKqcy",13) == 1710592461) strcat(s, "a");
if (crc32("NdMIuFybltZjX",13) == 1445256767) strcat(s, "s");
if (crc32("gThrtlCffRlWPxV",15) == 1914379338) strcat(s, "s");
if (crc32("HsBfCfJIVbferj",14) == 712811197) strcat(s, "e");
if (crc32("fBVLaAsZQ",9) == 2279701694) strcat(s, "P");
if (crc32("mLBMGJoiko",10) == 3456656879) strcat(s, "t");
if (crc32("YfesNviUMES",11) == 1772712752) strcat(s, "X");
if (crc32("DdCyu",5) == 1935351125) strcat(s, "e");
if (crc32("DvreSkqcMON",11) == 522953557) strcat(s, "J");
if (crc32("dHthuxSphd",10) == 913328901) strcat(s, "d");
    return s;
}

char *dedicating_verbs() {
    char *s = calloc(11);
    if (crc32("qWFvQn",6) == 472276821) strcat(s, "d");
if (crc32("CObsKSKpUSkB",12) == 2986142555) strcat(s, "Z");
if (crc32("sIClJRWvO",9) == 2526195512) strcat(s, "e");
if (crc32("fpyEyjOCa",9) == 2033934619) strcat(s, "d");
if (crc32("CEgUhqrpqzrgkL",14) == 2456941087) strcat(s, "R");
if (crc32("ghjpVkeboF",10) == 2483887775) strcat(s, "i");
if (crc32("fxSbtmP",7) == 959351925) strcat(s, "M");
if (crc32("rFpWTK",6) == 495859809) strcat(s, "c");
if (crc32("VqnpzxHNxeE",11) == 3264714435) strcat(s, "Z");
if (crc32("hATgki",6) == 2338747309) strcat(s, "a");
if (crc32("BdzTkWx",7) == 4229080484) strcat(s, "S");
if (crc32("qbnRyls",7) == 2385376071) strcat(s, "t");
if (crc32("VtPcqH",6) == 2834888584) strcat(s, "i");
if (crc32("AqgHZqSIMALnI",13) == 2547752361) strcat(s, "n");
if (crc32("zqbCCCnwAg",10) == 2744684450) strcat(s, "h");
if (crc32("ojeIut",6) == 3983669800) strcat(s, "g");
    return s;
}

char *igniting_verbs() {
    char *s = calloc(9);
    if (crc32("VeRqmWXRoI",10) == 1728541514) strcat(s, "n");
if (crc32("OxZOcY",6) == 92227099) strcat(s, "i");
if (crc32("onQqnNYuvxX",11) == 927317120) strcat(s, "g");
if (crc32("ZuJShgxr",8) == 801392401) strcat(s, "c");
if (crc32("waMPh",5) == 2413490441) strcat(s, "n");
if (crc32("lIAkIas",7) == 3124260767) strcat(s, "i");
if (crc32("rbjNK",5) == 514576223) strcat(s, "t");
if (crc32("ovngxGhourdQTd",14) == 68769320) strcat(s, "T");
if (crc32("qeLmlxaLBaJylrS",15) == 3243514792) strcat(s, "i");
if (crc32("CQRbyuspTokFc",13) == 2353816041) strcat(s, "v");
if (crc32("lKofPFyNdyrDd",13) == 3877763341) strcat(s, "n");
if (crc32("INkscGBpASB",11) == 4241778974) strcat(s, "Y");
if (crc32("meAGJEJwcK",10) == 2179281434) strcat(s, "g");
    return s;
}

char *determinating_verbs() {
    char *s = calloc(14);
    if (crc32("LPmUPpOHmuZ",11) == 2334527947) strcat(s, "d");
if (crc32("NnAMjHL",7) == 3049375785) strcat(s, "e");
if (crc32("oOcTIW",6) == 2122951979) strcat(s, "p");
if (crc32("rjAdoyhviRWu",12) == 1873090638) strcat(s, "t");
if (crc32("xMeoSpMDEqG",11) == 1591379552) strcat(s, "e");
if (crc32("SDftZvHtXBmKZnm",15) == 3828477102) strcat(s, "W");
if (crc32("zOLjPXqvJvyPfrp",15) == 419203927) strcat(s, "r");
if (crc32("wbgWsvT",7) == 3481509464) strcat(s, "m");
if (crc32("IvxfudzVTOKWTUK",15) == 3804791949) strcat(s, "i");
if (crc32("fFqzQRe",7) == 2531415876) strcat(s, "V");
if (crc32("czmBDwOwog",10) == 1491898108) strcat(s, "n");
if (crc32("qsgqxaESzKWG",12) == 1755622197) strcat(s, "C");
if (crc32("tXLfzcrao",9) == 4243367900) strcat(s, "a");
if (crc32("gBZxB",5) == 3258102994) strcat(s, "t");
if (crc32("jdGWtBAStB",10) == 3451471787) strcat(s, "i");
if (crc32("lYShz",5) == 2602331663) strcat(s, "b");
if (crc32("liLQxyoIMC",10) == 2260661180) strcat(s, "n");
if (crc32("VYutGCen",8) == 614334299) strcat(s, "z");
if (crc32("SLFvjDr",7) == 24272909) strcat(s, "g");
    return s;
}

char *recoagulate_verbs() {
    char *s = calloc(12);
    if (crc32("ThoukEy",7) == 2316341702) strcat(s, "L");
if (crc32("frNWgcWWRfaJXg",14) == 277399446) strcat(s, "r");
if (crc32("YXZiysDt",8) == 2243668162) strcat(s, "e");
if (crc32("DwJQEOw",7) == 2581089188) strcat(s, "K");
if (crc32("eDxzGogAcmxtnp",14) == 3827215074) strcat(s, "c");
if (crc32("IImCJwjsTArehvo",15) == 1232661474) strcat(s, "K");
if (crc32("mETDhgfHtQKQ",12) == 608557143) strcat(s, "o");
if (crc32("iXOcenMgt",9) == 1524731868) strcat(s, "c");
if (crc32("nQCUvUjX",8) == 2187329130) strcat(s, "a");
if (crc32("kmwOGDWjxeP",11) == 3134890434) strcat(s, "g");
if (crc32("VWxnxfnBgJocPa",14) == 2410008403) strcat(s, "x");
if (crc32("wwxde",5) == 496193915) strcat(s, "u");
if (crc32("XRxxJYRtxoiQYv",14) == 2542381831) strcat(s, "l");
if (crc32("lyMHiROOjI",10) == 1802777096) strcat(s, "y");
if (crc32("sEdnQnNAZwA",11) == 3280161747) strcat(s, "a");
if (crc32("jxRxOIyNkNYj",12) == 461754550) strcat(s, "X");
if (crc32("GUkVq",5) == 1598231405) strcat(s, "t");
if (crc32("bVjagcgVtKWLsD",14) == 1875839669) strcat(s, "e");
    return s;
}

char *ligatured_verbs() {
    char *s = calloc(10);
    if (crc32("PPTFNRq",7) == 340823650) strcat(s, "l");
if (crc32("wYlbquSACjWt",12) == 3471483608) strcat(s, "i");
if (crc32("WBOuhVzuCWWt",12) == 4074215614) strcat(s, "g");
if (crc32("WJGEPYDaIwxDb",13) == 2746146108) strcat(s, "a");
if (crc32("FOrfDjUHuic",11) == 2010938250) strcat(s, "t");
if (crc32("NNEDNakKF",9) == 3999480776) strcat(s, "j");
if (crc32("CdaRbakYAfjYgC",14) == 874756786) strcat(s, "u");
if (crc32("yJPfKcbduyCUpMv",15) == 55374544) strcat(s, "A");
if (crc32("ypMrrpYzhkzk",12) == 2791013804) strcat(s, "r");
if (crc32("obfttLDQYchj",12) == 2663485151) strcat(s, "e");
if (crc32("leFgdRedVjEwQB",14) == 4073718016) strcat(s, "n");
if (crc32("lmFJWKU",7) == 662043483) strcat(s, "d");
    return s;
}

char *carburet_verbs() {
    char *s = calloc(9);
    if (crc32("IAahxuamj",9) == 420179708) strcat(s, "c");
if (crc32("PgLjtyCwZqJuwlN",15) == 1355679839) strcat(s, "a");
if (crc32("zwDDPEvzDOmlgk",14) == 885357461) strcat(s, "u");
if (crc32("BdWmjSa",7) == 1887558600) strcat(s, "r");
if (crc32("QOveNP",6) == 3465850308) strcat(s, "n");
if (crc32("pZInexX",7) == 2655108415) strcat(s, "b");
if (crc32("jWJYkatk",8) == 4079085339) strcat(s, "M");
if (crc32("ZitusVAXPNJ",11) == 1839826310) strcat(s, "u");
if (crc32("AUXIeaGUslb",11) == 3963696837) strcat(s, "r");
if (crc32("ZKnwDFH",7) == 101434908) strcat(s, "e");
if (crc32("HDLDAKHQ",8) == 4101839393) strcat(s, "V");
if (crc32("iXTFsGEOIy",10) == 1229897165) strcat(s, "t");
    return s;
}

char *fluked_verbs() {
    char *s = calloc(7);
    if (crc32("okuzwZNhSSWkXE",14) == 2788090617) strcat(s, "f");
if (crc32("NpRptYJHncBnJ",13) == 2275580073) strcat(s, "b");
if (crc32("XWnnUD",6) == 4108415584) strcat(s, "l");
if (crc32("yNhcIJcpHJXPrX",14) == 1164612400) strcat(s, "u");
if (crc32("wXbaeDmYDhFap",13) == 3050297136) strcat(s, "k");
if (crc32("tUCXsEfI",8) == 2382761879) strcat(s, "e");
if (crc32("KYkLdns",7) == 2993488712) strcat(s, "d");
    return s;
}

char *mediate_verbs() {
    char *s = calloc(8);
    if (crc32("bXJuik",6) == 877785380) strcat(s, "m");
if (crc32("PBrsJi",6) == 2495092763) strcat(s, "A");
if (crc32("BPJsTvOIswUpt",13) == 1114157941) strcat(s, "e");
if (crc32("PqJSnbvRt",9) == 244908561) strcat(s, "t");
if (crc32("fPxQkHCvvXHLia",14) == 789442240) strcat(s, "d");
if (crc32("lHasRiq",7) == 330058747) strcat(s, "i");
if (crc32("YgISmERmRdQk",12) == 2696671540) strcat(s, "a");
if (crc32("HVCXmcIlyp",10) == 76965523) strcat(s, "B");
if (crc32("lDXlBpIj",8) == 118337485) strcat(s, "t");
if (crc32("JVtyrOidHAdY",12) == 167712767) strcat(s, "q");
if (crc32("HOOyizmDVRjtWCn",15) == 44718611) strcat(s, "e");
    return s;
}

char *veer_verbs() {
    char *s = calloc(5);
    if (crc32("nzQfqle",7) == 1455504350) strcat(s, "v");
if (crc32("ExbadaXgjb",10) == 4014244138) strcat(s, "t");
if (crc32("DgFvhGPGITiuxg",14) == 1515119208) strcat(s, "e");
if (crc32("VgJLOGsBx",9) == 1124405750) strcat(s, "P");
if (crc32("cfocOkAMhOIKu",13) == 2035426022) strcat(s, "e");
if (crc32("YrxBEsHGsseJf",13) == 1668558574) strcat(s, "r");
    return s;
}

char *interdebating_verbs() {
    char *s = calloc(14);
    if (crc32("GbXqqoZzrQS",11) == 1154876746) strcat(s, "z");
if (crc32("mFvKZkN",7) == 3805127908) strcat(s, "i");
if (crc32("XhDVO",5) == 1304571700) strcat(s, "n");
if (crc32("vvZPCiwL",8) == 3289424835) strcat(s, "t");
if (crc32("wbVdnsjEGa",10) == 1123150199) strcat(s, "e");
if (crc32("TdGwRTGQNOyhSV",14) == 1274211241) strcat(s, "b");
if (crc32("mbrHxBO",7) == 2437797657) strcat(s, "r");
if (crc32("qgPKrPgpk",9) == 1778529351) strcat(s, "A");
if (crc32("WdWVUQjcCHO",11) == 2269481833) strcat(s, "d");
if (crc32("uKxyQiqy",8) == 4236897492) strcat(s, "K");
if (crc32("BxRHMJX",7) == 2728310817) strcat(s, "e");
if (crc32("DFAYQRePmNjPniT",15) == 4113133551) strcat(s, "b");
if (crc32("VNKeBugI",8) == 1679077726) strcat(s, "B");
if (crc32("loJrvuBjpMp",11) == 1471199379) strcat(s, "a");
if (crc32("lMKMJihUTa",10) == 482436293) strcat(s, "t");
if (crc32("SVlgxImb",8) == 142981151) strcat(s, "i");
if (crc32("QACDU",5) == 4206640156) strcat(s, "X");
if (crc32("DtrJWZNqSJZ",11) == 71932384) strcat(s, "n");
if (crc32("Qrwsn",5) == 4257309134) strcat(s, "g");
    return s;
}

char *miscomputed_verbs() {
    char *s = calloc(12);
    if (crc32("DsSEU",5) == 3928918068) strcat(s, "m");
if (crc32("JnfybfZovJLMNp",14) == 4011105321) strcat(s, "i");
if (crc32("hEeBkcURHLoXV",13) == 4073844470) strcat(s, "s");
if (crc32("ggiGfXKyxUK",11) == 2317693610) strcat(s, "v");
if (crc32("eVwmedlwNeEZvw",14) == 1033317633) strcat(s, "c");
if (crc32("bmakPqfPPKgRMK",14) == 2595272020) strcat(s, "O");
if (crc32("wehWePjKOxyd",12) == 3466782756) strcat(s, "o");
if (crc32("ngCYEAqUNYilPFg",15) == 334976545) strcat(s, "F");
if (crc32("SnHonP",6) == 2430925252) strcat(s, "m");
if (crc32("sFXvbVu",7) == 1846636881) strcat(s, "L");
if (crc32("rqXdWiVygjHZq",13) == 2745915680) strcat(s, "p");
if (crc32("GqvbkfQs",8) == 4164783856) strcat(s, "u");
if (crc32("hwslt",5) == 3187979062) strcat(s, "x");
if (crc32("IPkEbksfNYy",11) == 643620068) strcat(s, "t");
if (crc32("BQGSykGjKEauja",14) == 2674206437) strcat(s, "m");
if (crc32("lXfvDK",6) == 4257039532) strcat(s, "e");
if (crc32("oAdhvJDSJe",10) == 3460076946) strcat(s, "b");
if (crc32("kChNBIQOhxB",11) == 2992912238) strcat(s, "d");
    return s;
}

char *servoing_verbs() {
    char *s = calloc(9);
    if (crc32("PuluYr",6) == 2718678775) strcat(s, "P");
if (crc32("kBHLTXkTYoqnk",13) == 1201867026) strcat(s, "s");
if (crc32("uhmZZrgpwrA",11) == 2118850467) strcat(s, "A");
if (crc32("lkkZQ",5) == 1853746478) strcat(s, "e");
if (crc32("VRmfdmib",8) == 1496389344) strcat(s, "k");
if (crc32("bWKTGpc",7) == 1976801537) strcat(s, "r");
if (crc32("lUuAfR",6) == 995625664) strcat(s, "s");
if (crc32("WXEdtVEwWUje",12) == 1783135388) strcat(s, "v");
if (crc32("XalNRzIS",8) == 3178137583) strcat(s, "o");
if (crc32("VYUtarfTZNGYO",13) == 3660673854) strcat(s, "i");
if (crc32("TEVvXErhmplr",12) == 1101139775) strcat(s, "n");
if (crc32("opBTNPEC",8) == 2003842987) strcat(s, "W");
if (crc32("iPoWlUSnVJU",11) == 3901419963) strcat(s, "g");
    return s;
}

char *televise_verbs() {
    char *s = calloc(9);
    if (crc32("etsRMV",6) == 885279072) strcat(s, "t");
if (crc32("eQxzROrZcQZ",11) == 1663120976) strcat(s, "P");
if (crc32("GNIPwjnNZyN",11) == 3763072508) strcat(s, "e");
if (crc32("aLXda",5) == 3929656832) strcat(s, "l");
if (crc32("fqElIXtXhe",10) == 1363152054) strcat(s, "R");
if (crc32("CqeXujHwQuqmqz",14) == 277848188) strcat(s, "e");
if (crc32("hTnvjmQOd",9) == 4187225416) strcat(s, "Z");
if (crc32("ujgVGDXfs",9) == 4017188698) strcat(s, "v");
if (crc32("AwmYDuEQXAC",11) == 2278967440) strcat(s, "v");
if (crc32("syUlkEcKy",9) == 2685316168) strcat(s, "i");
if (crc32("oayGpYHJS",9) == 3574554234) strcat(s, "k");
if (crc32("RLsMGptvLL",10) == 499562586) strcat(s, "s");
if (crc32("nRwvQQU",7) == 746374763) strcat(s, "o");
if (crc32("eLcyMqYy",8) == 2060270835) strcat(s, "e");
    return s;
}

char *filtrated_verbs() {
    char *s = calloc(10);
    if (crc32("dFnmasxjvHiVqj",14) == 2757594452) strcat(s, "f");
if (crc32("KWZkpIfHBeqCgne",15) == 4009997257) strcat(s, "i");
if (crc32("oRXbBo",6) == 2463114145) strcat(s, "S");
if (crc32("daXwiAqjh",9) == 3273178318) strcat(s, "l");
if (crc32("BxKZUcvkZ",9) == 2682149366) strcat(s, "f");
if (crc32("ZBOtzdKFuLjcNgh",15) == 2073893149) strcat(s, "t");
if (crc32("pAsCxLkPsUcF",12) == 1158355899) strcat(s, "K");
if (crc32("IPdvlSHGhhLvC",13) == 2934589801) strcat(s, "r");
if (crc32("hLiaaJUYW",9) == 2232836660) strcat(s, "g");
if (crc32("WyZhsTndi",9) == 2911640315) strcat(s, "a");
if (crc32("GjsBotwuWuWl",12) == 3819449375) strcat(s, "t");
if (crc32("WyGInzEoSCuUHe",14) == 1466248705) strcat(s, "e");
if (crc32("eKnSgSoJnwBYZ",13) == 2122180442) strcat(s, "d");
    return s;
}

char *frivoled_verbs() {
    char *s = calloc(9);
    if (crc32("jVPzteh",7) == 1395178872) strcat(s, "P");
if (crc32("NyCIldgiyoDG",12) == 1881869805) strcat(s, "f");
if (crc32("dPCzidgLbfvYgX",14) == 1387498027) strcat(s, "r");
if (crc32("vFuBdCAJIn",10) == 3679714312) strcat(s, "i");
if (crc32("UGRjZqNNh",9) == 3212008400) strcat(s, "y");
if (crc32("TXmGyOl",7) == 2777638494) strcat(s, "v");
if (crc32("yKaQHcbMMv",10) == 79124510) strcat(s, "o");
if (crc32("SJapTyIJFIXdUs",14) == 3116739770) strcat(s, "l");
if (crc32("wgSNhi",6) == 3053522770) strcat(s, "e");
if (crc32("BUMxQbRw",8) == 3630862366) strcat(s, "X");
if (crc32("mDqdqZlk",8) == 2479146084) strcat(s, "d");
    return s;
}

char *cockling_verbs() {
    char *s = calloc(9);
    if (crc32("OaFJMzSWcUHZlzX",15) == 1714163910) strcat(s, "Z");
if (crc32("SPBgPwsBuCuB",12) == 3708292954) strcat(s, "c");
if (crc32("CrnrAUthFrN",11) == 404822958) strcat(s, "b");
if (crc32("NPwKxtEgiA",10) == 1319615224) strcat(s, "o");
if (crc32("RhYDyztOXKGRX",13) == 4186082796) strcat(s, "y");
if (crc32("xZRod",5) == 1823644450) strcat(s, "c");
if (crc32("IezIELMyFoXqx",13) == 1614924724) strcat(s, "p");
if (crc32("PZdmrIeIBz",10) == 285684891) strcat(s, "k");
if (crc32("zLFHyZimIPqDGb",14) == 2863670884) strcat(s, "u");
if (crc32("PHWER",5) == 3238656937) strcat(s, "l");
if (crc32("NcVJrBMReUcd",12) == 2346209522) strcat(s, "H");
if (crc32("HqGTGx",6) == 451618553) strcat(s, "i");
if (crc32("XxiKeZwwQW",10) == 1358516773) strcat(s, "n");
if (crc32("zhOaeOs",7) == 3348441109) strcat(s, "T");
if (crc32("MXCuFIcrbY",10) == 4018072165) strcat(s, "g");
    return s;
}

char *sow_verbs() {
    char *s = calloc(4);
    if (crc32("pKPVgSOdWMwyLP",14) == 298274140) strcat(s, "s");
if (crc32("mWLjiRQO",8) == 259222146) strcat(s, "o");
if (crc32("hWDsyVXDpYpu",12) == 3821479735) strcat(s, "w");
    return s;
}

char *merengued_verbs() {
    char *s = calloc(10);
    if (crc32("DwidG",5) == 865475470) strcat(s, "m");
if (crc32("BlBsWzRRlaJv",12) == 827922869) strcat(s, "e");
if (crc32("NMeeprX",7) == 1274846470) strcat(s, "r");
if (crc32("TUYDIvfkTDGdIV",14) == 2181457771) strcat(s, "J");
if (crc32("SsRCnRuccoBDf",13) == 4028647296) strcat(s, "e");
if (crc32("wlSFOL",6) == 1577257433) strcat(s, "n");
if (crc32("InLhPhDmVzca",12) == 2226563560) strcat(s, "w");
if (crc32("lUxcbJ",6) == 467628696) strcat(s, "g");
if (crc32("KlKcgY",6) == 1862362473) strcat(s, "u");
if (crc32("DTuFxJa",7) == 1606116098) strcat(s, "u");
if (crc32("fwUdzXcQCMHPk",13) == 3605547393) strcat(s, "e");
if (crc32("BXeUsKj",7) == 3950640792) strcat(s, "d");
    return s;
}

char *retrade_verbs() {
    char *s = calloc(8);
    if (crc32("OJNuutJKKsEU",12) == 2080624148) strcat(s, "C");
if (crc32("kxzJfW",6) == 2775889324) strcat(s, "r");
if (crc32("bdfeMCdUchIETX",14) == 833745640) strcat(s, "e");
if (crc32("mVcbyklasAB",11) == 3865913686) strcat(s, "p");
if (crc32("jWBQhkOrKS",10) == 2731433565) strcat(s, "t");
if (crc32("mhMQQldSL",9) == 2139408552) strcat(s, "r");
if (crc32("kJrps",5) == 1831857238) strcat(s, "a");
if (crc32("PlLQCKXjDPxnpr",14) == 2698473275) strcat(s, "J");
if (crc32("DUZTGVdms",9) == 977257896) strcat(s, "d");
if (crc32("ecnpaIXMYJkzkLD",15) == 1740831947) strcat(s, "J");
if (crc32("jPMKF",5) == 719190955) strcat(s, "e");
    return s;
}

char *snoring_verbs() {
    char *s = calloc(8);
    if (crc32("bDBlyh",6) == 2496231516) strcat(s, "s");
if (crc32("obEKLCRElPdrj",13) == 1070580216) strcat(s, "n");
if (crc32("wWBLfoGh",8) == 1539414684) strcat(s, "o");
if (crc32("mAGtnVys",8) == 1451644958) strcat(s, "r");
if (crc32("DGMJDmHgRXqDLfP",15) == 1421817728) strcat(s, "p");
if (crc32("thdfDYcGYUxj",12) == 2820741544) strcat(s, "i");
if (crc32("iuVwSLhFzKkGn",13) == 1142374074) strcat(s, "n");
if (crc32("xOZqTj",6) == 237181984) strcat(s, "g");
    return s;
}

char *bumble_verbs() {
    char *s = calloc(7);
    if (crc32("tLCWn",5) == 1177088296) strcat(s, "l");
if (crc32("eihdAsp",7) == 1397752456) strcat(s, "b");
if (crc32("trMBkmk",7) == 476971577) strcat(s, "u");
if (crc32("QSIMUeqMCl",10) == 4270540361) strcat(s, "N");
if (crc32("WqPpPAfttQR",11) == 2638765586) strcat(s, "m");
if (crc32("OEpJxDxiG",9) == 837145470) strcat(s, "g");
if (crc32("hgmukBoNOvU",11) == 1226698115) strcat(s, "b");
if (crc32("wEsMunhbWZj",11) == 2411234651) strcat(s, "l");
if (crc32("aJzzGHXiJjKP",12) == 2440013216) strcat(s, "e");
    return s;
}

char *shock_verbs() {
    char *s = calloc(6);
    if (crc32("JINutAQ",7) == 1217710017) strcat(s, "s");
if (crc32("gBVnWXpUHcdm",12) == 564965855) strcat(s, "i");
if (crc32("tzHuU",5) == 4180804954) strcat(s, "h");
if (crc32("WHmLGybHeOLzyJ",14) == 3753054740) strcat(s, "G");
if (crc32("axPyrFCG",8) == 3630512857) strcat(s, "o");
if (crc32("hAEcRQ",6) == 3546749494) strcat(s, "i");
if (crc32("GyKUObYdaOthokd",15) == 2284627362) strcat(s, "c");
if (crc32("MOfsZXt",7) == 1895548510) strcat(s, "X");
if (crc32("hFRsmTXlUElYtSM",15) == 2999990512) strcat(s, "k");
    return s;
}

char *revictualed_verbs() {
    char *s = calloc(12);
    if (crc32("IVntxQCRUKESFUm",15) == 1491081294) strcat(s, "r");
if (crc32("UrVOitQRzwcXi",13) == 2033413689) strcat(s, "e");
if (crc32("QfDrjNgGzwC",11) == 3474921489) strcat(s, "w");
if (crc32("GRmoB",5) == 2001583050) strcat(s, "v");
if (crc32("FHjSTSpDjhQLh",13) == 391535591) strcat(s, "i");
if (crc32("TadkvfTtrs",10) == 3454427719) strcat(s, "c");
if (crc32("eELsSwAf",8) == 3896975312) strcat(s, "t");
if (crc32("edbOP",5) == 1953329668) strcat(s, "u");
if (crc32("QHieCFxrwIxtD",13) == 3245471708) strcat(s, "H");
if (crc32("YECzebQZPHCZIyf",15) == 790410670) strcat(s, "a");
if (crc32("RFYtlELZpsqi",12) == 90666136) strcat(s, "d");
if (crc32("mdxuYW",6) == 199060520) strcat(s, "l");
if (crc32("oLWdB",5) == 3638269817) strcat(s, "K");
if (crc32("GpMDa",5) == 2435585668) strcat(s, "e");
if (crc32("IdfQlTC",7) == 3398890124) strcat(s, "d");
    return s;
}

char *interwreathed_verbs() {
    char *s = calloc(14);
    if (crc32("QhhVLfaCNJpd",12) == 1323309370) strcat(s, "e");
if (crc32("uEhfrjw",7) == 3449877746) strcat(s, "i");
if (crc32("PxtdZZNzs",9) == 3496431381) strcat(s, "n");
if (crc32("xqgZgODOPlhAq",13) == 3887773063) strcat(s, "W");
if (crc32("MJYUDx",6) == 117319557) strcat(s, "t");
if (crc32("LedIKWYuSDmx",12) == 3698291689) strcat(s, "o");
if (crc32("SHVHCknZ",8) == 3336095201) strcat(s, "e");
if (crc32("WgucZP",6) == 3054826316) strcat(s, "r");
if (crc32("hoqwVUBrvmgwSEl",15) == 1135366331) strcat(s, "l");
if (crc32("fRHHAHjpGPw",11) == 1240520855) strcat(s, "w");
if (crc32("QVDrZtvaMkk",11) == 3447974377) strcat(s, "r");
if (crc32("jMEVmHJgg",9) == 811701951) strcat(s, "X");
if (crc32("qgBSmJvcAl",10) == 3020740965) strcat(s, "e");
if (crc32("MtleSjdxxxYWFr",14) == 2821411292) strcat(s, "a");
if (crc32("RErHV",5) == 4155487862) strcat(s, "f");
if (crc32("sDYqdfy",7) == 1728401844) strcat(s, "t");
if (crc32("YjIbvKCPYaXluP",14) == 1976398419) strcat(s, "Z");
if (crc32("IdQuyDdNanuap",13) == 224797521) strcat(s, "h");
if (crc32("ibVQhh",6) == 3672998014) strcat(s, "t");
if (crc32("jcSxdzsOyhdhhWD",15) == 1632968899) strcat(s, "e");
if (crc32("wvyBhw",6) == 3608885821) strcat(s, "d");
    return s;
}

char *topple_verbs() {
    char *s = calloc(7);
    if (crc32("hEWHOMK",7) == 1218793211) strcat(s, "U");
if (crc32("oPWyRlbbvXlikB",14) == 3146789953) strcat(s, "t");
if (crc32("vnGllzNACpAKHh",14) == 858294627) strcat(s, "z");
if (crc32("YcNQCyU",7) == 2786317404) strcat(s, "o");
if (crc32("QLgDPkWmsRL",11) == 1613609491) strcat(s, "p");
if (crc32("bAPNCtIcpywWfNw",15) == 2633256165) strcat(s, "p");
if (crc32("eUObDxai",8) == 3165888992) strcat(s, "P");
if (crc32("YDLliAm",7) == 3464254877) strcat(s, "l");
if (crc32("KcRnnMK",7) == 3972200274) strcat(s, "u");
if (crc32("iCPeBxBSbms",11) == 1118314720) strcat(s, "e");
    return s;
}

char *stetted_verbs() {
    char *s = calloc(8);
    if (crc32("oFhmyqEGnqqXzby",15) == 1809101107) strcat(s, "z");
if (crc32("UDmGgWmXxZSO",12) == 527890310) strcat(s, "s");
if (crc32("VohKAF",6) == 2230816249) strcat(s, "t");
if (crc32("HebxlVbTEBooOme",15) == 1640159000) strcat(s, "e");
if (crc32("peubrVs",7) == 4223182817) strcat(s, "t");
if (crc32("BmsorLEC",8) == 2822905846) strcat(s, "t");
if (crc32("bbzDIuFZwQd",11) == 1394726613) strcat(s, "A");
if (crc32("dJJzFbcyxGm",11) == 145045160) strcat(s, "e");
if (crc32("RQEqzwV",7) == 376707588) strcat(s, "d");
    return s;
}

char *fusilladed_verbs() {
    char *s = calloc(11);
    if (crc32("oYeYMcGiIu",10) == 3781444392) strcat(s, "c");
if (crc32("UqfGKrtOSuxQmlx",15) == 2302668864) strcat(s, "f");
if (crc32("CdsmeHJbLBuTvvs",15) == 2938661450) strcat(s, "F");
if (crc32("ymozsZzk",8) == 1636675758) strcat(s, "u");
if (crc32("XhHfTh",6) == 1998168527) strcat(s, "s");
if (crc32("JlEQxWY",7) == 1618484981) strcat(s, "o");
if (crc32("dIggtaj",7) == 3310918375) strcat(s, "i");
if (crc32("zRdGQ",5) == 4174254854) strcat(s, "l");
if (crc32("QNMKwA",6) == 3855081519) strcat(s, "l");
if (crc32("mpLGr",5) == 1323379373) strcat(s, "d");
if (crc32("XzskUbnIPYJhUp",14) == 1074842906) strcat(s, "a");
if (crc32("cVAGLbJe",8) == 4165678015) strcat(s, "d");
if (crc32("PXeJgvKN",8) == 505443455) strcat(s, "e");
if (crc32("AhQbEOkIC",9) == 905489219) strcat(s, "d");
    return s;
}

char *cleft_verbs() {
    char *s = calloc(6);
    if (crc32("CsOuMmtxPIseC",13) == 525991052) strcat(s, "k");
if (crc32("gdjerfPENjkxXBv",15) == 2464978439) strcat(s, "c");
if (crc32("EbjQaJNGo",9) == 1075633852) strcat(s, "l");
if (crc32("KeotgYJhuQ",10) == 1584614061) strcat(s, "e");
if (crc32("dezLsN",6) == 3057606687) strcat(s, "o");
if (crc32("QIuONyBL",8) == 834605980) strcat(s, "f");
if (crc32("rUfGAnzl",8) == 1056015095) strcat(s, "t");
    return s;
}

char *dragged_verbs() {
    char *s = calloc(8);
    if (crc32("fccIFfkXjDKFBXs",15) == 1473625569) strcat(s, "g");
if (crc32("TLdxP",5) == 421574757) strcat(s, "d");
if (crc32("ZXCyJdFVviXGz",13) == 3172941251) strcat(s, "E");
if (crc32("vbIPvegB",8) == 2975245706) strcat(s, "r");
if (crc32("dlXAsAHRwdWX",12) == 560091527) strcat(s, "a");
if (crc32("arkqNP",6) == 1308463081) strcat(s, "g");
if (crc32("xrpTPIsxpDbEr",13) == 563364671) strcat(s, "f");
if (crc32("WXZHjFgMcFPMEfp",15) == 1596402979) strcat(s, "g");
if (crc32("ZbhItHSEmSfkNUg",15) == 4282027856) strcat(s, "z");
if (crc32("GsAVCJbTigPLl",13) == 2906758611) strcat(s, "e");
if (crc32("KZdNCzmrjLc",11) == 2865311593) strcat(s, "D");
if (crc32("SNrvhQzWPAViR",13) == 1510687319) strcat(s, "d");
    return s;
}

char *shanghai_verbs() {
    char *s = calloc(9);
    if (crc32("zXUAKfb",7) == 2542446850) strcat(s, "p");
if (crc32("iLJRUTvSNVKVa",13) == 1967678077) strcat(s, "s");
if (crc32("uOuBg",5) == 1736751773) strcat(s, "G");
if (crc32("ZhtXnx",6) == 2529640794) strcat(s, "h");
if (crc32("NbyFkO",6) == 1697128091) strcat(s, "a");
if (crc32("aHDxfxVbu",9) == 296488427) strcat(s, "M");
if (crc32("iOLuQtUjmuAO",12) == 791759491) strcat(s, "n");
if (crc32("tTKqudSbXvXfQts",15) == 987309785) strcat(s, "g");
if (crc32("QOkNaosKSTLST",13) == 3179830991) strcat(s, "G");
if (crc32("gTstLjNDbkL",11) == 685952757) strcat(s, "h");
if (crc32("qKJSOQPS",8) == 2682300670) strcat(s, "r");
if (crc32("jZBmH",5) == 1784345297) strcat(s, "a");
if (crc32("cjGbuLJyFDls",12) == 1066882685) strcat(s, "U");
if (crc32("TylBln",6) == 3014856733) strcat(s, "i");
    return s;
}

char *jag_verbs() {
    char *s = calloc(4);
    if (crc32("WYCWFPqV",8) == 2350595107) strcat(s, "J");
if (crc32("zXfvxQVoOu",10) == 1245098409) strcat(s, "j");
if (crc32("LLHNIGF",7) == 3417445425) strcat(s, "k");
if (crc32("wAfGSXViKU",10) == 2320199215) strcat(s, "a");
if (crc32("FBwgm",5) == 1754092562) strcat(s, "g");
    return s;
}

char *inflect_verbs() {
    char *s = calloc(8);
    if (crc32("aJLPqg",6) == 950356173) strcat(s, "i");
if (crc32("xkqBOTLzjpTBYZ",14) == 559061811) strcat(s, "n");
if (crc32("GMevsgGUX",9) == 4005518959) strcat(s, "O");
if (crc32("PxFXiXFLFJYC",12) == 2233664229) strcat(s, "f");
if (crc32("ZZPLdrteaSvGVYy",15) == 1479705111) strcat(s, "x");
if (crc32("rIvNO",5) == 2076801389) strcat(s, "l");
if (crc32("JFRVLyXXFWrG",12) == 4002715778) strcat(s, "e");
if (crc32("oSbGjOYEfpj",11) == 759587850) strcat(s, "c");
if (crc32("BauvHBpQaZGoy",13) == 2751771984) strcat(s, "j");
if (crc32("HBPotGidQk",10) == 3154841431) strcat(s, "t");
    return s;
}

char *outtrading_verbs() {
    char *s = calloc(11);
    if (crc32("SXrpDwBmmqA",11) == 1760665488) strcat(s, "o");
if (crc32("HYSBK",5) == 957957492) strcat(s, "J");
if (crc32("AfOhFbRJ",8) == 3566694151) strcat(s, "u");
if (crc32("HAZKloF",7) == 741184630) strcat(s, "t");
if (crc32("wULwBbHPmwVj",12) == 1196911177) strcat(s, "t");
if (crc32("htZDY",5) == 1823749229) strcat(s, "r");
if (crc32("UlpNUuMNxwGeqPk",15) == 2023074571) strcat(s, "W");
if (crc32("XsnxEEzYQ",9) == 588172392) strcat(s, "a");
if (crc32("cHrsHnWDDljJtT",14) == 611427446) strcat(s, "p");
if (crc32("LijcMbT",7) == 2292329403) strcat(s, "d");
if (crc32("pvPvU",5) == 1331843782) strcat(s, "y");
if (crc32("INUtOmXQvTtHu",13) == 4271039805) strcat(s, "i");
if (crc32("JjEVEZVe",8) == 3836950010) strcat(s, "s");
if (crc32("MvXMcUTOHJF",11) == 4115092871) strcat(s, "n");
if (crc32("gYeUrJfjS",9) == 1195300143) strcat(s, "g");
    return s;
}

char *underspent_verbs() {
    char *s = calloc(11);
    if (crc32("WeuuO",5) == 2801309950) strcat(s, "u");
if (crc32("bUVCsWqGUeBEnGh",15) == 2448181045) strcat(s, "n");
if (crc32("nJsJGGTRpdfyj",13) == 3245742912) strcat(s, "u");
if (crc32("fShBVbisnp",10) == 653338878) strcat(s, "d");
if (crc32("vFnXdevXdcYfxlX",15) == 3498938497) strcat(s, "m");
if (crc32("nabRkmrT",8) == 1464516259) strcat(s, "e");
if (crc32("SEKLXNzTsgHWy",13) == 4071152059) strcat(s, "r");
if (crc32("nsrKdcnKdpxo",12) == 1517419916) strcat(s, "s");
if (crc32("DpkpMQjiyd",10) == 2713434512) strcat(s, "v");
if (crc32("ieSwjsFjUJ",10) == 2534237964) strcat(s, "p");
if (crc32("gwoOUAiVoIEt",12) == 2340315756) strcat(s, "l");
if (crc32("ildxzYDWlUIAwF",14) == 2612200406) strcat(s, "e");
if (crc32("vgXGaKQim",9) == 3635295132) strcat(s, "M");
if (crc32("CuoubXj",7) == 1622531214) strcat(s, "n");
if (crc32("KyAfwbjRP",9) == 3918437896) strcat(s, "o");
if (crc32("eyoBeFJkUh",10) == 3911183208) strcat(s, "t");
    return s;
}

char *inhale_verbs() {
    char *s = calloc(7);
    if (crc32("UeOzvp",6) == 858292949) strcat(s, "z");
if (crc32("pbGZoaDkZswoyaM",15) == 1417114127) strcat(s, "i");
if (crc32("LuIYEvIEDplLq",13) == 4041034246) strcat(s, "n");
if (crc32("lALAC",5) == 3330230467) strcat(s, "h");
if (crc32("uHNhxPALUsco",12) == 4037131945) strcat(s, "a");
if (crc32("ROQYNVuL",8) == 208381358) strcat(s, "l");
if (crc32("hCIzjWkZeMeQGf",14) == 1912241913) strcat(s, "X");
if (crc32("DQKSut",6) == 129464545) strcat(s, "e");
    return s;
}

char *impersonated_verbs() {
    char *s = calloc(13);
    if (crc32("xbaMoPHmBWKjf",13) == 4150484334) strcat(s, "i");
if (crc32("FXdmQRJbcKpbaS",14) == 720395117) strcat(s, "m");
if (crc32("JjlzdURk",8) == 2609781563) strcat(s, "H");
if (crc32("fjXUYPdiOgq",11) == 659086402) strcat(s, "p");
if (crc32("fGypoUgmOlPEE",13) == 707871287) strcat(s, "E");
if (crc32("BgzYqzmwnRtOn",13) == 955833246) strcat(s, "e");
if (crc32("hDcXTW",6) == 2566040063) strcat(s, "r");
if (crc32("XJyHGHHMoPNC",12) == 2139977410) strcat(s, "f");
if (crc32("pdEvR",5) == 31839749) strcat(s, "s");
if (crc32("PNjnXNaCmSvquJ",14) == 2966599291) strcat(s, "o");
if (crc32("qukcytvGlDpL",12) == 1296775148) strcat(s, "U");
if (crc32("CjFfM",5) == 3258434205) strcat(s, "n");
if (crc32("XtOcYmLcZ",9) == 2065393280) strcat(s, "a");
if (crc32("HozVnI",6) == 321812419) strcat(s, "v");
if (crc32("hcgtNjsbdpnq",12) == 1133852353) strcat(s, "t");
if (crc32("ZnPES",5) == 2091398649) strcat(s, "e");
if (crc32("Sszdyu",6) == 274998765) strcat(s, "d");
    return s;
}

char *decrease_verbs() {
    char *s = calloc(9);
    if (crc32("MIMSLicKMEmyOa",14) == 3266547345) strcat(s, "d");
if (crc32("DjmVLUeWrtsKb",13) == 538379899) strcat(s, "h");
if (crc32("JMNyhZmCKnaTp",13) == 3689260012) strcat(s, "e");
if (crc32("AFxXaYFajYwIn",13) == 77160706) strcat(s, "c");
if (crc32("WjpTucxkT",9) == 697452330) strcat(s, "F");
if (crc32("gFeVGYHWTYn",11) == 985882991) strcat(s, "r");
if (crc32("tRVQPliIPe",10) == 3089983704) strcat(s, "e");
if (crc32("UwZhPPHecHHdmHg",15) == 3940850678) strcat(s, "a");
if (crc32("WyjAQa",6) == 3246350508) strcat(s, "n");
if (crc32("JaqiwtAnqBuZJB",14) == 3481362965) strcat(s, "s");
if (crc32("CXfaHrqsotzE",12) == 3643092945) strcat(s, "m");
if (crc32("ZfsPy",5) == 1863961197) strcat(s, "e");
    return s;
}

char *initiate_verbs() {
    char *s = calloc(9);
    if (crc32("FAdAXymvP",9) == 3808191607) strcat(s, "L");
if (crc32("WKyXqzK",7) == 2232900632) strcat(s, "i");
if (crc32("wlxIeL",6) == 4033398006) strcat(s, "k");
if (crc32("yvQAVbLZqn",10) == 75331106) strcat(s, "n");
if (crc32("kodEXpB",7) == 2533376958) strcat(s, "b");
if (crc32("IfiDmNuX",8) == 3182298122) strcat(s, "i");
if (crc32("yFcYAMsYLYXuZbx",15) == 1732128887) strcat(s, "t");
if (crc32("BQSXXPUaVu",10) == 1996086684) strcat(s, "i");
if (crc32("uUiaAEnvddqjD",13) == 11411316) strcat(s, "i");
if (crc32("wBNokwuiPGuyP",13) == 2685257844) strcat(s, "a");
if (crc32("WrmOd",5) == 4027982377) strcat(s, "t");
if (crc32("hidpFmFmUj",10) == 1170948399) strcat(s, "e");
    return s;
}

char *apply_verbs() {
    char *s = calloc(6);
    if (crc32("jXIMyzmpvrIpW",13) == 2313051317) strcat(s, "E");
if (crc32("kjKRAqTYT",9) == 2760145991) strcat(s, "a");
if (crc32("ouwqKJRdlG",10) == 3599054019) strcat(s, "p");
if (crc32("UyyNW",5) == 3761483187) strcat(s, "p");
if (crc32("JiysWDkR",8) == 2838244879) strcat(s, "p");
if (crc32("fPXEQW",6) == 2033926667) strcat(s, "p");
if (crc32("atEGneMjaRL",11) == 1776619911) strcat(s, "x");
if (crc32("koWqJm",6) == 4075762096) strcat(s, "l");
if (crc32("WylFWCzIZ",9) == 3747002971) strcat(s, "D");
if (crc32("kOlLTKCyWRoTWn",14) == 1328253491) strcat(s, "y");
    return s;
}

char *hector_verbs() {
    char *s = calloc(7);
    if (crc32("kzMiJDfzHhqTS",13) == 1396602195) strcat(s, "h");
if (crc32("jRseZ",5) == 1877627818) strcat(s, "c");
if (crc32("zyZGwjddq",9) == 3544710206) strcat(s, "e");
if (crc32("uUfyQla",7) == 1682632375) strcat(s, "Q");
if (crc32("AjsRuwuPIgnnuDa",15) == 2629173301) strcat(s, "c");
if (crc32("tftLVAvpU",9) == 3452361784) strcat(s, "t");
if (crc32("qukAmDcRJL",10) == 3179841655) strcat(s, "k");
if (crc32("jzTPhEWpibT",11) == 939839424) strcat(s, "o");
if (crc32("jnxCGRHNHqZd",12) == 713863009) strcat(s, "d");
if (crc32("AKeCR",5) == 4287200269) strcat(s, "r");
    return s;
}

char *misconjecture_verbs() {
    char *s = calloc(14);
    if (crc32("XHVzpCjdmuLX",12) == 1120596508) strcat(s, "m");
if (crc32("VHRIpDR",7) == 3744256615) strcat(s, "i");
if (crc32("nmdEHrEV",8) == 2565555479) strcat(s, "C");
if (crc32("ziKlYhyNjJ",10) == 757838654) strcat(s, "s");
if (crc32("HLNbKxkrEjiUvWx",15) == 917427503) strcat(s, "c");
if (crc32("QZquzOIFjCi",11) == 799806672) strcat(s, "h");
if (crc32("ntXkuxInj",9) == 2656048727) strcat(s, "o");
if (crc32("ZeFHzY",6) == 514986971) strcat(s, "J");
if (crc32("vpozH",5) == 903058989) strcat(s, "n");
if (crc32("hMREKxLvUT",10) == 2300508413) strcat(s, "j");
if (crc32("EaabJNqXnB",10) == 1273617882) strcat(s, "e");
if (crc32("gPHInKF",7) == 2669098396) strcat(s, "c");
if (crc32("eAfdolq",7) == 2536630935) strcat(s, "F");
if (crc32("JXGKNAcndeCA",12) == 360921609) strcat(s, "t");
if (crc32("oSINGeV",7) == 3071214590) strcat(s, "n");
if (crc32("ilGTzlkRH",9) == 4054119891) strcat(s, "u");
if (crc32("vvfrAiXDVK",10) == 3539264422) strcat(s, "r");
if (crc32("PMJCdxQdtEvGg",13) == 498014268) strcat(s, "e");
    return s;
}

char *compress_verbs() {
    char *s = calloc(9);
    if (crc32("qCkCyk",6) == 3565773994) strcat(s, "c");
if (crc32("oIHZafSQvZL",11) == 1524286192) strcat(s, "h");
if (crc32("zmmgS",5) == 618497520) strcat(s, "o");
if (crc32("yLeOAMhKSy",10) == 1081536963) strcat(s, "s");
if (crc32("HKwRYlZJapZ",11) == 1081246667) strcat(s, "m");
if (crc32("LOHujqNHGot",11) == 4036917021) strcat(s, "e");
if (crc32("wZiMNgbVD",9) == 2364804287) strcat(s, "p");
if (crc32("oGhDLsFpCZU",11) == 96038475) strcat(s, "r");
if (crc32("OhhaLZcBL",9) == 3842610141) strcat(s, "s");
if (crc32("KpeUeVjZvIRERiT",15) == 4167185661) strcat(s, "e");
if (crc32("gKxhFiBtnUjF",12) == 3731758916) strcat(s, "s");
if (crc32("SVWFOHoIiMRXzW",14) == 4165882680) strcat(s, "x");
if (crc32("XiTdSZ",6) == 3567547249) strcat(s, "s");
    return s;
}

char *strive_verbs() {
    char *s = calloc(7);
    if (crc32("wPKKpxY",7) == 2059140534) strcat(s, "s");
if (crc32("OfFUv",5) == 141630512) strcat(s, "t");
if (crc32("OsIzUeiaFBVLsm",14) == 1748850200) strcat(s, "P");
if (crc32("GLrHSCY",7) == 519174300) strcat(s, "r");
if (crc32("FVlVdbiiYt",10) == 466301362) strcat(s, "o");
if (crc32("ymBLdTquQtdTBma",15) == 2211224843) strcat(s, "i");
if (crc32("lzTMTHoZsRw",11) == 3592167611) strcat(s, "v");
if (crc32("FCmlCeUzRoa",11) == 1692147922) strcat(s, "e");
    return s;
}

char *sueded_verbs() {
    char *s = calloc(7);
    if (crc32("qUNcrKEoeoM",11) == 4057542531) strcat(s, "r");
if (crc32("hVpsChIoKfKypV",14) == 2486154801) strcat(s, "s");
if (crc32("guzmgX",6) == 2659241427) strcat(s, "u");
if (crc32("hqBcnDYFZKp",11) == 3498327523) strcat(s, "e");
if (crc32("yxWbzALDh",9) == 1489257108) strcat(s, "d");
if (crc32("TIXIGGljIIXESOP",15) == 2515462352) strcat(s, "e");
if (crc32("sbTvh",5) == 4261109551) strcat(s, "J");
if (crc32("FgLcqkFe",8) == 1848852366) strcat(s, "d");
    return s;
}

char *overurging_verbs() {
    char *s = calloc(11);
    if (crc32("vXjmPTJ",7) == 1240607888) strcat(s, "b");
if (crc32("MLgBG",5) == 3505170545) strcat(s, "o");
if (crc32("kDeaZZloASqu",12) == 1146890792) strcat(s, "v");
if (crc32("ZtVVKEjvHi",10) == 875805852) strcat(s, "d");
if (crc32("jStEgv",6) == 1724410125) strcat(s, "e");
if (crc32("yXPxcYdMmcywW",13) == 60711017) strcat(s, "b");
if (crc32("wwfKjgGpGm",10) == 1864473510) strcat(s, "r");
if (crc32("fjXNIThVua",10) == 3297463755) strcat(s, "A");
if (crc32("plhQciqAyKTSBe",14) == 2791920487) strcat(s, "u");
if (crc32("zwsacxH",7) == 734734398) strcat(s, "r");
if (crc32("fRnfG",5) == 671239393) strcat(s, "g");
if (crc32("lyDESOiNx",9) == 1716072183) strcat(s, "h");
if (crc32("WNUsnxSpyZDYWvD",15) == 2703190701) strcat(s, "i");
if (crc32("ZyerDjOaimENy",13) == 2313104034) strcat(s, "n");
if (crc32("dFiPcNskMxHiYu",14) == 3869445274) strcat(s, "x");
if (crc32("dojioROvXnJXRRI",15) == 2279407728) strcat(s, "g");
    return s;
}

char *remingling_verbs() {
    char *s = calloc(11);
    if (crc32("gvXgVaqXjkyIh",13) == 1097585754) strcat(s, "l");
if (crc32("OEvPiCZ",7) == 3670609791) strcat(s, "r");
if (crc32("LcMyUaG",7) == 1219135340) strcat(s, "V");
if (crc32("ewkHamMBEed",11) == 1443819845) strcat(s, "e");
if (crc32("zIvdlfXYagezCY",14) == 1483373232) strcat(s, "m");
if (crc32("TRdPUqHj",8) == 2587473988) strcat(s, "a");
if (crc32("YMIWzB",6) == 4174248486) strcat(s, "i");
if (crc32("zMBROPwbIEKdd",13) == 2106666011) strcat(s, "b");
if (crc32("ZWEKNvshKV",10) == 2448766676) strcat(s, "n");
if (crc32("lhWIW",5) == 1929938676) strcat(s, "L");
if (crc32("GYmkoyvudVT",11) == 1170334491) strcat(s, "g");
if (crc32("bUcLRYfKG",9) == 136836525) strcat(s, "l");
if (crc32("hjcPVrICt",9) == 1935382590) strcat(s, "i");
if (crc32("oqEStF",6) == 3483012084) strcat(s, "q");
if (crc32("nCHZoMZ",7) == 2398644725) strcat(s, "n");
if (crc32("AwYpeywQ",8) == 1346605298) strcat(s, "g");
    return s;
}

char *glissading_verbs() {
    char *s = calloc(11);
    if (crc32("hvvrIexA",8) == 4190126209) strcat(s, "g");
if (crc32("kVtNwZVuxnZOVB",14) == 1406550647) strcat(s, "G");
if (crc32("BNCZJignlDB",11) == 877146412) strcat(s, "l");
if (crc32("pXsDosGLHjiQKj",14) == 1227465468) strcat(s, "F");
if (crc32("WkmyETgVcNJeHm",14) == 1550198752) strcat(s, "i");
if (crc32("qQTjzIqWe",9) == 210676799) strcat(s, "k");
if (crc32("YegilPQ",7) == 4181651541) strcat(s, "s");
if (crc32("NvokZbeFXdGlJBf",15) == 1960288119) strcat(s, "i");
if (crc32("NfjJmxICvre",11) == 3819951886) strcat(s, "s");
if (crc32("yLpBc",5) == 2703746835) strcat(s, "a");
if (crc32("euVZcgvap",9) == 4255204786) strcat(s, "d");
if (crc32("zVtrWCCGJWlRbiI",15) == 123786420) strcat(s, "i");
if (crc32("XLNrnHKsudzit",13) == 706096415) strcat(s, "C");
if (crc32("jIrkivlQ",8) == 2665762948) strcat(s, "n");
if (crc32("QkYEp",5) == 258728434) strcat(s, "O");
if (crc32("ndmjqf",6) == 4051170294) strcat(s, "g");
    return s;
}

char *preresembling_verbs() {
    char *s = calloc(14);
    if (crc32("gVOrR",5) == 3774672239) strcat(s, "p");
if (crc32("DXxMGh",6) == 133221275) strcat(s, "r");
if (crc32("xEkwrldHJNPgg",13) == 4211604267) strcat(s, "K");
if (crc32("KRctiwvymlZz",12) == 985568751) strcat(s, "e");
if (crc32("KhXjJfsic",9) == 1651248485) strcat(s, "N");
if (crc32("fJscH",5) == 1150937702) strcat(s, "r");
if (crc32("IMkKizWhA",9) == 2669832486) strcat(s, "e");
if (crc32("Mweje",5) == 3993079910) strcat(s, "Y");
if (crc32("RvVUhZVRDYyQ",12) == 3102239556) strcat(s, "s");
if (crc32("hylFMihI",8) == 2413032213) strcat(s, "X");
if (crc32("zKuXAxiGBY",10) == 1141460229) strcat(s, "e");
if (crc32("PatMdn",6) == 781859853) strcat(s, "m");
if (crc32("rxUFhEgD",8) == 642906231) strcat(s, "y");
if (crc32("kLMnIyW",7) == 1667539225) strcat(s, "b");
if (crc32("FgOMsRiuaG",10) == 3484047485) strcat(s, "b");
if (crc32("YlWjCooDVUVGw",13) == 1853379979) strcat(s, "l");
if (crc32("kvoadLxTCiRfYa",14) == 3928649173) strcat(s, "i");
if (crc32("MRRZRHKBn",9) == 3480303818) strcat(s, "n");
if (crc32("fwIAJshTPxcj",12) == 4266919198) strcat(s, "g");
    return s;
}

char *vellicate_verbs() {
    char *s = calloc(10);
    if (crc32("fNLSDpbtxYHd",12) == 1083551377) strcat(s, "v");
if (crc32("ZEwpbWgO",8) == 2978050225) strcat(s, "U");
if (crc32("NXPRZGHiPMOPy",13) == 2462386352) strcat(s, "e");
if (crc32("GocHKE",6) == 999692573) strcat(s, "M");
if (crc32("jOQAlSBcR",9) == 2744033037) strcat(s, "l");
if (crc32("EdPGyxW",7) == 3479267873) strcat(s, "T");
if (crc32("nEICaJceIw",10) == 2720952637) strcat(s, "l");
if (crc32("qZUrSt",6) == 1850167473) strcat(s, "i");
if (crc32("Ovjqcrv",7) == 1175862863) strcat(s, "B");
if (crc32("UtWoiMBetPQto",13) == 3095279706) strcat(s, "c");
if (crc32("HinxAlU",7) == 3809837593) strcat(s, "J");
if (crc32("IdlihibQdARzYf",14) == 3531557470) strcat(s, "a");
if (crc32("kOFUQafdMhaAel",14) == 4133132640) strcat(s, "m");
if (crc32("SIIeyems",8) == 1474915278) strcat(s, "t");
if (crc32("fPPpUe",6) == 848615707) strcat(s, "e");
    return s;
}

char *emasculated_verbs() {
    char *s = calloc(12);
    if (crc32("VsUBmcmRdZBna",13) == 3631426602) strcat(s, "b");
if (crc32("ymQPwWRQRoy",11) == 1465684481) strcat(s, "e");
if (crc32("wORMIqLI",8) == 1882364825) strcat(s, "m");
if (crc32("PtTQHORw",8) == 3439206001) strcat(s, "Z");
if (crc32("ESyWmVrPUyBoZ",13) == 2408149319) strcat(s, "a");
if (crc32("XQigOhDEiQqGl",13) == 143722707) strcat(s, "P");
if (crc32("jBWHrUGKKQnbGb",14) == 889692747) strcat(s, "s");
if (crc32("YBpGaZlDkSW",11) == 919345744) strcat(s, "a");
if (crc32("gbSbm",5) == 1982719969) strcat(s, "c");
if (crc32("SxaxU",5) == 3051043186) strcat(s, "e");
if (crc32("geLbHCEJgcGJTIp",15) == 345153146) strcat(s, "u");
if (crc32("fEtyem",6) == 1804106958) strcat(s, "l");
if (crc32("SBlhCVg",7) == 578486051) strcat(s, "a");
if (crc32("xAoqhyCHmak",11) == 2796508038) strcat(s, "z");
if (crc32("UVELXKON",8) == 1854188256) strcat(s, "t");
if (crc32("PvBWkbjoJZ",10) == 2039990252) strcat(s, "H");
if (crc32("WznHW",5) == 3346350926) strcat(s, "e");
if (crc32("oeyNR",5) == 1627853116) strcat(s, "d");
    return s;
}

char *remit_verbs() {
    char *s = calloc(6);
    if (crc32("uOUuhknxdO",10) == 2522793099) strcat(s, "o");
if (crc32("yYsptdTHhTH",11) == 921859423) strcat(s, "r");
if (crc32("LZcduDPKQpsd",12) == 4045862583) strcat(s, "e");
if (crc32("lAbwZ",5) == 2889081121) strcat(s, "n");
if (crc32("nDaXKsvTV",9) == 1214861597) strcat(s, "m");
if (crc32("vqRXBk",6) == 958181201) strcat(s, "a");
if (crc32("SyDencvO",8) == 202275275) strcat(s, "i");
if (crc32("ldPNCFMZZbVvpW",14) == 39048789) strcat(s, "E");
if (crc32("FgzPHgz",7) == 869068329) strcat(s, "t");
    return s;
}

char *outbulged_verbs() {
    char *s = calloc(10);
    if (crc32("oajrkrXGGV",10) == 3486129754) strcat(s, "U");
if (crc32("dTzYvYJB",8) == 3336458973) strcat(s, "o");
if (crc32("SrInuAhmle",10) == 4141255544) strcat(s, "u");
if (crc32("BBOYsSAttpNikkZ",15) == 26990300) strcat(s, "t");
if (crc32("xhDTmhVwFNbfF",13) == 2968561921) strcat(s, "l");
if (crc32("RLbPIZCXmHgGro",14) == 1896663046) strcat(s, "b");
if (crc32("hIbbLfljXKbVwKD",15) == 2938727122) strcat(s, "u");
if (crc32("IORQQXaCctd",11) == 1871379838) strcat(s, "l");
if (crc32("dCxqIedj",8) == 4110796576) strcat(s, "t");
if (crc32("xZGayIDzwhIwbk",14) == 4130804602) strcat(s, "g");
if (crc32("QUksPOhrX",9) == 1610089667) strcat(s, "e");
if (crc32("fiYeEFiFpCggArJ",15) == 948960596) strcat(s, "r");
if (crc32("QSXPcnNtSo",10) == 2539638899) strcat(s, "d");
    return s;
}

char *showup_verbs() {
    char *s = calloc(7);
    if (crc32("dEeQJPvZLbR",11) == 3919067697) strcat(s, "s");
if (crc32("pkALlZanyIhIW",13) == 188590859) strcat(s, "n");
if (crc32("AEUWKdEDRpJm",12) == 3414831078) strcat(s, "h");
if (crc32("wyjnbOryqBjZh",13) == 1785057959) strcat(s, "o");
if (crc32("oDitoS",6) == 1624423545) strcat(s, "K");
if (crc32("mFsaSXub",8) == 1779456337) strcat(s, "w");
if (crc32("WsmvRSFDfuDmI",13) == 3496990546) strcat(s, "P");
if (crc32("ZjTfHuI",7) == 1136209040) strcat(s, "u");
if (crc32("OynTsTiYtg",10) == 1500258912) strcat(s, "e");
if (crc32("XnjiyjagxQOS",12) == 1192264999) strcat(s, "p");
    return s;
}

char *overregulated_verbs() {
    char *s = calloc(14);
    if (crc32("IOeRmdV",7) == 3943349301) strcat(s, "Y");
if (crc32("pkSFmJKgdlUOKq",14) == 2391305135) strcat(s, "o");
if (crc32("pvtpLcyge",9) == 490688002) strcat(s, "c");
if (crc32("wqZDelSYk",9) == 4271680413) strcat(s, "v");
if (crc32("IYIcQPNQmIIpjpf",15) == 980405946) strcat(s, "e");
if (crc32("LfyjUtpJpxl",11) == 3335274599) strcat(s, "O");
if (crc32("pEptcuaGnY",10) == 2506455071) strcat(s, "r");
if (crc32("ODSubsy",7) == 4264332226) strcat(s, "r");
if (crc32("URtLADk",7) == 1333445694) strcat(s, "e");
if (crc32("MBxRVA",6) == 213797441) strcat(s, "g");
if (crc32("rEsQp",5) == 1290282909) strcat(s, "u");
if (crc32("BKVryxsYFJIPa",13) == 4161335321) strcat(s, "l");
if (crc32("SlPTzja",7) == 3170544394) strcat(s, "r");
if (crc32("qVbbnjNUXBFqG",13) == 1760751540) strcat(s, "a");
if (crc32("hoBCOdgqrD",10) == 2986210023) strcat(s, "t");
if (crc32("tdXeqbWy",8) == 1234331452) strcat(s, "b");
if (crc32("OOrLf",5) == 1889405108) strcat(s, "e");
if (crc32("VtobUV",6) == 3162165034) strcat(s, "P");
if (crc32("xzRoZbAnFjWHeci",15) == 943726164) strcat(s, "d");
    return s;
}

char *intrench_verbs() {
    char *s = calloc(9);
    if (crc32("XoFqoLrFsupw",12) == 4276795067) strcat(s, "A");
if (crc32("FmKWPOr",7) == 3530731664) strcat(s, "i");
if (crc32("MdBrTMUF",8) == 228570041) strcat(s, "n");
if (crc32("mFNNdoOy",8) == 3473049287) strcat(s, "R");
if (crc32("tzqxbUGXZU",10) == 1278143070) strcat(s, "t");
if (crc32("jxCXqno",7) == 930184746) strcat(s, "r");
if (crc32("VjSYOuzrtRXuHf",14) == 3914047108) strcat(s, "v");
if (crc32("mYzGpvHwyhwfH",13) == 1820586288) strcat(s, "e");
if (crc32("yeKXmAasRTCHLMa",15) == 671837625) strcat(s, "n");
if (crc32("giRBMCgAcNwLdC",14) == 806340211) strcat(s, "d");
if (crc32("tepeviGRX",9) == 3477649113) strcat(s, "c");
if (crc32("mSVMlws",7) == 3077550912) strcat(s, "W");
if (crc32("wlalu",5) == 1544717174) strcat(s, "h");
    return s;
}

char *diapausing_verbs() {
    char *s = calloc(11);
    if (crc32("YLuijh",6) == 3235678098) strcat(s, "d");
if (crc32("LcGcgetWKb",10) == 3797479726) strcat(s, "i");
if (crc32("cNclh",5) == 3341216389) strcat(s, "F");
if (crc32("aUYwCSfalgu",11) == 4237006621) strcat(s, "a");
if (crc32("ePeOVzIsLmVEEQv",15) == 2970301725) strcat(s, "p");
if (crc32("boRfJir",7) == 1396753313) strcat(s, "a");
if (crc32("bjkOkqMgcRTRmDF",15) == 1273707010) strcat(s, "u");
if (crc32("TFFAhVo",7) == 281310617) strcat(s, "s");
if (crc32("MbWFyRSFekIrxq",14) == 1385513979) strcat(s, "i");
if (crc32("zajETNGMj",9) == 3660217513) strcat(s, "T");
if (crc32("BzDQPKgbX",9) == 1468933630) strcat(s, "n");
if (crc32("uuJFifjSyX",10) == 819016572) strcat(s, "H");
if (crc32("htgrARk",7) == 2081894800) strcat(s, "g");
    return s;
}

char *clepe_verbs() {
    char *s = calloc(6);
    if (crc32("LUrSzcxZVa",10) == 3462284693) strcat(s, "c");
if (crc32("jcfnBRPcLalF",12) == 4212138694) strcat(s, "l");
if (crc32("pjVKqCZhy",9) == 3672043735) strcat(s, "e");
if (crc32("gjbRZJq",7) == 722012633) strcat(s, "l");
if (crc32("axwQwVX",7) == 3077578330) strcat(s, "p");
if (crc32("JMVCAbDIkd",10) == 3283352840) strcat(s, "O");
if (crc32("bWEySvKUKq",10) == 3594732224) strcat(s, "e");
    return s;
}

char *rinsed_verbs() {
    char *s = calloc(7);
    if (crc32("EVbgvNiLhuUa",12) == 858577321) strcat(s, "r");
if (crc32("JFDWnLjzUzbEhDU",15) == 4189376449) strcat(s, "d");
if (crc32("yasRsuPtlcMbx",13) == 3242039443) strcat(s, "i");
if (crc32("qefIUGi",7) == 1159671595) strcat(s, "L");
if (crc32("oPoJSnlfJNdFb",13) == 1878263667) strcat(s, "n");
if (crc32("sLdrYoxSjWURxWm",15) == 1329169597) strcat(s, "i");
if (crc32("xQdbwNHWoqE",11) == 3140241629) strcat(s, "s");
if (crc32("dLXjpMUzu",9) == 797245683) strcat(s, "e");
if (crc32("dQQkiz",6) == 1049739247) strcat(s, "v");
if (crc32("CPVvJnV",7) == 427673528) strcat(s, "d");
    return s;
}

char *decreased_verbs() {
    char *s = calloc(10);
    if (crc32("gvTJmJgIGMlV",12) == 344801289) strcat(s, "d");
if (crc32("sFwsQVjMyQeT",12) == 336009657) strcat(s, "e");
if (crc32("MOMVwlNPnnX",11) == 3065084487) strcat(s, "g");
if (crc32("pHxfCYLvBKjY",12) == 651406475) strcat(s, "c");
if (crc32("LcFHPnf",7) == 2400065885) strcat(s, "p");
if (crc32("WZOTORkfnYSZK",13) == 1176368835) strcat(s, "r");
if (crc32("WipfgFpCAQGkO",13) == 1476120189) strcat(s, "O");
if (crc32("vLWmiZxhW",9) == 2076267524) strcat(s, "e");
if (crc32("lrblYUtuWAB",11) == 2497362220) strcat(s, "a");
if (crc32("vETMAgKGXKXElK",14) == 1650767039) strcat(s, "s");
if (crc32("gsVqlscGzFuuR",13) == 505499761) strcat(s, "e");
if (crc32("oLKqmBOBl",9) == 3592069299) strcat(s, "i");
if (crc32("AlKkRrg",7) == 1657103001) strcat(s, "d");
    return s;
}

char *mensed_verbs() {
    char *s = calloc(7);
    if (crc32("KgGdACOSvjWSey",14) == 1444989743) strcat(s, "t");
if (crc32("TskfaYa",7) == 792106482) strcat(s, "m");
if (crc32("lSTpvuusZzFk",12) == 1206553281) strcat(s, "e");
if (crc32("ofnWIK",6) == 793323841) strcat(s, "x");
if (crc32("KsycavMRp",9) == 625805007) strcat(s, "n");
if (crc32("sykDfSHfZKZ",11) == 2555430321) strcat(s, "s");
if (crc32("tNnOdtCGwJoIFg",14) == 696038717) strcat(s, "F");
if (crc32("dpXpKWMFgxg",11) == 673905477) strcat(s, "e");
if (crc32("PQMgQuoQM",9) == 942179614) strcat(s, "c");
if (crc32("lwtdWH",6) == 2742551643) strcat(s, "d");
    return s;
}

char *travel_verbs() {
    char *s = calloc(7);
    if (crc32("cVIqh",5) == 2446747783) strcat(s, "J");
if (crc32("SvcSletePArTMW",14) == 1907199826) strcat(s, "t");
if (crc32("juthxzHRl",9) == 1213520964) strcat(s, "r");
if (crc32("kqXGkGh",7) == 1108320968) strcat(s, "a");
if (crc32("ilPfswExbtjFcAZ",15) == 3667729993) strcat(s, "a");
if (crc32("RORRhdCOzQGe",12) == 2938067778) strcat(s, "c");
if (crc32("kwSYd",5) == 2440362705) strcat(s, "v");
if (crc32("acHKSWW",7) == 3540945819) strcat(s, "i");
if (crc32("TWdUXOKPBRhCRt",14) == 377112149) strcat(s, "e");
if (crc32("rdcgGrwwc",9) == 231503214) strcat(s, "l");
    return s;
}

char *lined_verbs() {
    char *s = calloc(6);
    if (crc32("Nvvvgrh",7) == 2132670994) strcat(s, "l");
if (crc32("awhnw",5) == 2593036024) strcat(s, "u");
if (crc32("WAJDRYwy",8) == 2428729415) strcat(s, "i");
if (crc32("AnbFXYq",7) == 1517571202) strcat(s, "T");
if (crc32("dFYwoc",6) == 611399793) strcat(s, "n");
if (crc32("wExQbDr",7) == 1914034183) strcat(s, "D");
if (crc32("bMqZbywWwZzkH",13) == 4016682009) strcat(s, "e");
if (crc32("KZTBVTosEe",10) == 3621723622) strcat(s, "x");
if (crc32("jEBDnKbPdbsjOP",14) == 3877601404) strcat(s, "d");
    return s;
}

char *bedim_verbs() {
    char *s = calloc(6);
    if (crc32("qArZE",5) == 816823749) strcat(s, "b");
if (crc32("HQZHres",7) == 2276105168) strcat(s, "e");
if (crc32("LabSozCRId",10) == 1079510294) strcat(s, "i");
if (crc32("itqXOOGeF",9) == 2133166799) strcat(s, "d");
if (crc32("VIaIQRGQEQ",10) == 4244183147) strcat(s, "o");
if (crc32("aIttPZuIXGBxIVa",15) == 3814108720) strcat(s, "i");
if (crc32("MbpGSWFuOlEinm",14) == 111220843) strcat(s, "m");
    return s;
}

char *vocalizing_verbs() {
    char *s = calloc(11);
    if (crc32("TFluefszsMY",11) == 3534216730) strcat(s, "v");
if (crc32("WIEjyX",6) == 2231303476) strcat(s, "e");
if (crc32("YUtyvUtmHpaDo",13) == 1352110766) strcat(s, "o");
if (crc32("vzGeP",5) == 171439079) strcat(s, "p");
if (crc32("vICvvKfOrC",10) == 659154450) strcat(s, "c");
if (crc32("lLDQWIs",7) == 2155104484) strcat(s, "b");
if (crc32("VjiRUdfsk",9) == 798831987) strcat(s, "a");
if (crc32("AiwonLInpVzzDTz",15) == 1418708396) strcat(s, "N");
if (crc32("AMKRy",5) == 391418475) strcat(s, "l");
if (crc32("JClrL",5) == 2121163949) strcat(s, "i");
if (crc32("cwOgzXunXH",10) == 2771109161) strcat(s, "F");
if (crc32("ylXouHYYJWiAjGF",15) == 3181849325) strcat(s, "z");
if (crc32("Bngkugs",7) == 179927302) strcat(s, "i");
if (crc32("LoWVXrfnK",9) == 1163853541) strcat(s, "S");
if (crc32("DgdBspzkwg",10) == 1277168003) strcat(s, "n");
if (crc32("UNyiHa",6) == 1499878837) strcat(s, "g");
    return s;
}

char *domiciling_verbs() {
    char *s = calloc(11);
    if (crc32("aRTitEx",7) == 4202586771) strcat(s, "d");
if (crc32("XuihLdyDUz",10) == 2249224673) strcat(s, "o");
if (crc32("mazTD",5) == 3524928728) strcat(s, "m");
if (crc32("FnoYutRaHh",10) == 1600965616) strcat(s, "i");
if (crc32("oObvFrdSbJUQTkp",15) == 2126725414) strcat(s, "l");
if (crc32("BqwuQt",6) == 1744447509) strcat(s, "c");
if (crc32("uCYwwfx",7) == 3450135590) strcat(s, "V");
if (crc32("baOESUfUlCrZ",12) == 3302170896) strcat(s, "i");
if (crc32("UmnfsvIkB",9) == 28327874) strcat(s, "l");
if (crc32("fMsTJXnPBkop",12) == 4141031353) strcat(s, "i");
if (crc32("LRCElX",6) == 3438359561) strcat(s, "A");
if (crc32("QPRReXfedFwKJr",14) == 3649408817) strcat(s, "n");
if (crc32("yfkdnvrX",8) == 3286652025) strcat(s, "g");
    return s;
}

char *visualizing_verbs() {
    char *s = calloc(12);
    if (crc32("AzBWmNMfr",9) == 1072205053) strcat(s, "v");
if (crc32("QbTMEtR",7) == 1098430918) strcat(s, "i");
if (crc32("AevYeGIolVaLtCj",15) == 2588240303) strcat(s, "j");
if (crc32("zxiykZdc",8) == 69883252) strcat(s, "s");
if (crc32("LZiEYZZoWjUTL",13) == 876803800) strcat(s, "C");
if (crc32("fcxFJdYNrnFIjsH",15) == 939327353) strcat(s, "u");
if (crc32("MZRaRx",6) == 2397425565) strcat(s, "a");
if (crc32("misrTgetxqm",11) == 4245783428) strcat(s, "S");
if (crc32("eZxjzuSafhMcaUd",15) == 1803601550) strcat(s, "l");
if (crc32("EkkEV",5) == 4052892518) strcat(s, "i");
if (crc32("zVsMSISbWDYsTQ",14) == 2011658098) strcat(s, "z");
if (crc32("BlbiA",5) == 1800800809) strcat(s, "i");
if (crc32("UdDwXx",6) == 3896997511) strcat(s, "n");
if (crc32("woltOF",6) == 1993425694) strcat(s, "g");
    return s;
}

char *shuttling_verbs() {
    char *s = calloc(10);
    if (crc32("OgUXmRwT",8) == 1276926640) strcat(s, "c");
if (crc32("nmelVWqsDLl",11) == 1600247972) strcat(s, "s");
if (crc32("BiQad",5) == 4185456541) strcat(s, "h");
if (crc32("mcDESgXbLN",10) == 1086406246) strcat(s, "y");
if (crc32("aVsvmOVi",8) == 2823229388) strcat(s, "u");
if (crc32("ukOemkosjOJS",12) == 2678737295) strcat(s, "t");
if (crc32("WxJdjNFOYR",10) == 1368716180) strcat(s, "t");
if (crc32("rxBPUXLlMaTM",12) == 3224204026) strcat(s, "l");
if (crc32("VBPOzh",6) == 1199365144) strcat(s, "X");
if (crc32("FBbhFr",6) == 2234719864) strcat(s, "i");
if (crc32("KIBKSxz",7) == 3953074974) strcat(s, "B");
if (crc32("iPcpvaxiNAPKWR",14) == 488422866) strcat(s, "n");
if (crc32("DLokKilzlG",10) == 886845313) strcat(s, "g");
    return s;
}

char *yodelled_verbs() {
    char *s = calloc(9);
    if (crc32("twvQyyAi",8) == 132031748) strcat(s, "J");
if (crc32("Onmvop",6) == 1117711710) strcat(s, "y");
if (crc32("hmfYuU",6) == 3713035052) strcat(s, "O");
if (crc32("GcGDwJ",6) == 4197094605) strcat(s, "o");
if (crc32("pUFVQu",6) == 1806236530) strcat(s, "O");
if (crc32("bCyWnCnY",8) == 1694319689) strcat(s, "d");
if (crc32("jhVTjXNh",8) == 1108342633) strcat(s, "G");
if (crc32("XGmFBkxHfUHMwy",14) == 2149849118) strcat(s, "e");
if (crc32("IxluXgzz",8) == 3830631371) strcat(s, "l");
if (crc32("AocgTVfhBY",10) == 2042500582) strcat(s, "c");
if (crc32("WVPyARoUabr",11) == 2870686870) strcat(s, "l");
if (crc32("MfsAaOLYMcHkrp",14) == 16227567) strcat(s, "e");
if (crc32("eZcfXRnjeOI",11) == 2185296408) strcat(s, "d");
    return s;
}

char *overdebating_verbs() {
    char *s = calloc(13);
    if (crc32("liKlM",5) == 1629793919) strcat(s, "o");
if (crc32("eFNntGBi",8) == 1952262085) strcat(s, "o");
if (crc32("iHCGIrSdP",9) == 467309224) strcat(s, "v");
if (crc32("jUTbaRBfD",9) == 1417283601) strcat(s, "e");
if (crc32("UdXsO",5) == 38526670) strcat(s, "r");
if (crc32("xEeIVSpI",8) == 2715675414) strcat(s, "d");
if (crc32("CJsCHTf",7) == 2302732625) strcat(s, "g");
if (crc32("OpwjuZVta",9) == 1200075830) strcat(s, "e");
if (crc32("TwVLML",6) == 917528504) strcat(s, "A");
if (crc32("HjJTIwrbM",9) == 517227327) strcat(s, "b");
if (crc32("jZrwmUk",7) == 937854332) strcat(s, "a");
if (crc32("fxUtXDZPf",9) == 192494124) strcat(s, "D");
if (crc32("mRAbqPjvicDRXu",14) == 1565790735) strcat(s, "t");
if (crc32("ibeGBHNbtgfPu",13) == 3079872799) strcat(s, "N");
if (crc32("MEvgHIi",7) == 1545239301) strcat(s, "i");
if (crc32("BLwdKOjtlciY",12) == 250474720) strcat(s, "j");
if (crc32("JofOv",5) == 905535729) strcat(s, "n");
if (crc32("TPBNCNUCKKAaX",13) == 1009793259) strcat(s, "C");
if (crc32("ZCpHLDlt",8) == 2415334109) strcat(s, "g");
    return s;
}

char *prognosticating_verbs() {
    char *s = calloc(16);
    if (crc32("EbfsgxwRTJaj",12) == 2512684687) strcat(s, "Z");
if (crc32("ExsfkfUBPn",10) == 4058439858) strcat(s, "p");
if (crc32("irLSXlcnbi",10) == 3359831775) strcat(s, "r");
if (crc32("kwDay",5) == 1204303110) strcat(s, "Y");
if (crc32("XlLZPCfDheNuuO",14) == 784126153) strcat(s, "o");
if (crc32("HTucqofBqRLoHQw",15) == 2848397832) strcat(s, "g");
if (crc32("nScNtZdcdYPS",12) == 2841653119) strcat(s, "Y");
if (crc32("EFEvifw",7) == 920231097) strcat(s, "n");
if (crc32("voMJQia",7) == 1548248806) strcat(s, "o");
if (crc32("ZEnpuNDVUC",10) == 4154565527) strcat(s, "q");
if (crc32("CBHcG",5) == 814576925) strcat(s, "s");
if (crc32("siRHuohfRumlmI",14) == 762115753) strcat(s, "t");
if (crc32("orHSgJESUjNNZ",13) == 4151356635) strcat(s, "i");
if (crc32("kOOQLOYCuigj",12) == 161650411) strcat(s, "c");
if (crc32("AiAQgdfnGRbeiHb",15) == 4187755649) strcat(s, "a");
if (crc32("KJWPRKTsAiqgFS",14) == 520351408) strcat(s, "t");
if (crc32("ShFvSDQkkEP",11) == 1109086091) strcat(s, "i");
if (crc32("FPqSOUELCriYcr",14) == 1427980656) strcat(s, "n");
if (crc32("PnWgqkEELkG",11) == 332305629) strcat(s, "g");
    return s;
}

char *wabble_verbs() {
    char *s = calloc(7);
    if (crc32("TRmVEILVwu",10) == 4155388081) strcat(s, "w");
if (crc32("SXYJkeQYcD",10) == 3463295800) strcat(s, "a");
if (crc32("OwUFDuwECxa",11) == 698175047) strcat(s, "S");
if (crc32("UfeEgJnuoPwAmsN",15) == 3925593297) strcat(s, "b");
if (crc32("anFXATOFhpBFt",13) == 3131273694) strcat(s, "b");
if (crc32("bygxCYBFlzhbQvk",15) == 872800401) strcat(s, "A");
if (crc32("ymSvcyIl",8) == 3621307852) strcat(s, "l");
if (crc32("tPjtaTqdDsoYk",13) == 1742644020) strcat(s, "x");
if (crc32("lIOIrmFKsbarYD",14) == 4101258842) strcat(s, "e");
    return s;
}

char *cooing_verbs() {
    char *s = calloc(7);
    if (crc32("FqJJrtZymgxRsPd",15) == 2506160198) strcat(s, "i");
if (crc32("xWeXV",5) == 3878437214) strcat(s, "c");
if (crc32("LkJzHV",6) == 2181279877) strcat(s, "Q");
if (crc32("pjAQiSrYylsPLPd",15) == 1601898281) strcat(s, "o");
if (crc32("jBvHXglIU",9) == 611225711) strcat(s, "T");
if (crc32("mFblAuPiNUxGk",13) == 1598774114) strcat(s, "o");
if (crc32("xFPdlHWLwe",10) == 3116238413) strcat(s, "c");
if (crc32("rXfvWSjWGEdD",12) == 1084823962) strcat(s, "i");
if (crc32("sTSkkNDJjs",10) == 969398219) strcat(s, "n");
if (crc32("RLtyuSpLX",9) == 4245142792) strcat(s, "o");
if (crc32("VUgJCsG",7) == 3236381740) strcat(s, "g");
    return s;
}

char *warehousing_verbs() {
    char *s = calloc(12);
    if (crc32("YgdirIRkzjJeIwt",15) == 533473692) strcat(s, "w");
if (crc32("mVjZKwxEMrkKt",13) == 3239445204) strcat(s, "R");
if (crc32("ictBypM",7) == 1277127169) strcat(s, "a");
if (crc32("sZsXkio",7) == 1887570925) strcat(s, "r");
if (crc32("QeBooBVqavbOlP",14) == 602964227) strcat(s, "I");
if (crc32("qzESnfGMLcCyzV",14) == 2859360008) strcat(s, "e");
if (crc32("LancPkZT",8) == 1673637446) strcat(s, "R");
if (crc32("PoXjVgMVxElsBvT",15) == 3463194782) strcat(s, "h");
if (crc32("uTBrBDRXqtap",12) == 1962948416) strcat(s, "o");
if (crc32("CCRdrcQk",8) == 1749075033) strcat(s, "u");
if (crc32("gXJZTaM",7) == 2590861574) strcat(s, "s");
if (crc32("FrUPYn",6) == 1798430412) strcat(s, "r");
if (crc32("XnptGL",6) == 2408076924) strcat(s, "i");
if (crc32("wIgxQobbjFh",11) == 1791201180) strcat(s, "c");
if (crc32("IosFvxRpKsb",11) == 1526129643) strcat(s, "n");
if (crc32("eZrvWMjppaoSG",13) == 1465860278) strcat(s, "g");
    return s;
}

char *resuspend_verbs() {
    char *s = calloc(10);
    if (crc32("ILLxJX",6) == 2358054353) strcat(s, "x");
if (crc32("KksCcL",6) == 5444708) strcat(s, "r");
if (crc32("qJMhMApb",8) == 1803706363) strcat(s, "e");
if (crc32("BRPUIxsAdrnz",12) == 1118893474) strcat(s, "g");
if (crc32("RHbFcdHVyi",10) == 2430922099) strcat(s, "s");
if (crc32("QLPGUEilezK",11) == 432884834) strcat(s, "l");
if (crc32("esARlKzCHaIMVr",14) == 23968049) strcat(s, "u");
if (crc32("rrdZlAYwBMC",11) == 1761182422) strcat(s, "s");
if (crc32("ImtoU",5) == 4027707492) strcat(s, "p");
if (crc32("COLNuQw",7) == 3265810927) strcat(s, "f");
if (crc32("bTXZevCtoDz",11) == 1176089269) strcat(s, "e");
if (crc32("pENUERbDc",9) == 3309975855) strcat(s, "n");
if (crc32("ehCpiyCaQZ",10) == 1259786188) strcat(s, "d");
    return s;
}

char *advocating_verbs() {
    char *s = calloc(11);
    if (crc32("GbEMFjttRxuh",12) == 382391388) strcat(s, "a");
if (crc32("YxNGQxaBLVPG",12) == 3892759227) strcat(s, "d");
if (crc32("KhbZNLDmf",9) == 1038922001) strcat(s, "v");
if (crc32("QMzNemwEr",9) == 3067572408) strcat(s, "o");
if (crc32("fpXJPVP",7) == 360295910) strcat(s, "x");
if (crc32("AOmXHCsqjhp",11) == 329737521) strcat(s, "c");
if (crc32("izBitiZSkyMm",12) == 2641198405) strcat(s, "a");
if (crc32("WtKHBKIYT",9) == 1615555970) strcat(s, "P");
if (crc32("hPDiHxm",7) == 1753915752) strcat(s, "t");
if (crc32("zQCOAEVKZ",9) == 2152266162) strcat(s, "A");
if (crc32("QcvTWHOdzpOdO",13) == 2882041242) strcat(s, "i");
if (crc32("jFrUKCuJAR",10) == 1831753322) strcat(s, "E");
if (crc32("mTtHorwRSsH",11) == 335683374) strcat(s, "n");
if (crc32("eVaEEwjgZ",9) == 2472129258) strcat(s, "g");
    return s;
}

char *tidied_verbs() {
    char *s = calloc(7);
    if (crc32("rrnUfqfeCDaKICq",15) == 3190640016) strcat(s, "t");
if (crc32("ZUiGZb",6) == 1291440433) strcat(s, "y");
if (crc32("xecGhPspkQdipJT",15) == 2170123177) strcat(s, "i");
if (crc32("WdGDQpmQrhWm",12) == 2849317873) strcat(s, "d");
if (crc32("NsHCELpwwvRpJ",13) == 2914199681) strcat(s, "r");
if (crc32("wEnbvcY",7) == 1342216566) strcat(s, "i");
if (crc32("oMrKXbGRzjG",11) == 1694748299) strcat(s, "J");
if (crc32("INjosOOVuFmiAll",15) == 2848468842) strcat(s, "e");
if (crc32("rVrjkJXp",8) == 3984033883) strcat(s, "d");
    return s;
}

char *preconcentrating_verbs() {
    char *s = calloc(17);
    if (crc32("KbLBM",5) == 4044894086) strcat(s, "o");
if (crc32("YYeHZUIzBktbGk",14) == 2224976774) strcat(s, "p");
if (crc32("iCVwsUp",7) == 409015029) strcat(s, "i");
if (crc32("fhKdKu",6) == 4127514325) strcat(s, "r");
if (crc32("DMPBSw",6) == 1653393701) strcat(s, "e");
if (crc32("iTvNedruX",9) == 4166262850) strcat(s, "c");
if (crc32("zjzqTVJ",7) == 229087104) strcat(s, "o");
if (crc32("OXeLBtpKSFiJzGT",15) == 2944037797) strcat(s, "n");
if (crc32("TfLJl",5) == 586074257) strcat(s, "c");
if (crc32("swRURGkNPVFcOp",14) == 2951465200) strcat(s, "e");
if (crc32("lJCyEvZtGvmDRSn",15) == 1100288800) strcat(s, "i");
if (crc32("evcPDOS",7) == 2115380807) strcat(s, "n");
if (crc32("OfWsgsSXgIDPB",13) == 1859443320) strcat(s, "t");
if (crc32("TzmjaUyKrVkHVmA",15) == 782192744) strcat(s, "r");
if (crc32("rcEFZOKTKAhyNUu",15) == 871546582) strcat(s, "W");
if (crc32("WcIzUkTUuOBgvf",14) == 2431927457) strcat(s, "a");
if (crc32("iHFCL",5) == 1146175512) strcat(s, "o");
if (crc32("OCFsrEjEik",10) == 3275375044) strcat(s, "t");
if (crc32("rsqjSyhVSoxqNX",14) == 4239563160) strcat(s, "i");
if (crc32("wzrVfBA",7) == 1382171560) strcat(s, "a");
if (crc32("IvcQockYhkQsF",13) == 2915273230) strcat(s, "n");
if (crc32("ztKZHrbcmmeE",12) == 4146814962) strcat(s, "g");
    return s;
}

char *interdebated_verbs() {
    char *s = calloc(13);
    if (crc32("hqYjhw",6) == 30928389) strcat(s, "i");
if (crc32("GxLkg",5) == 3572995707) strcat(s, "M");
if (crc32("KBrNRT",6) == 2849452739) strcat(s, "n");
if (crc32("gVXSbAdelSKqdZ",14) == 1674702822) strcat(s, "H");
if (crc32("PhUHwbNL",8) == 280382650) strcat(s, "t");
if (crc32("LYtZBUqAxhINHkw",15) == 2375955933) strcat(s, "e");
if (crc32("ZWPOJBAQxWyQlIO",15) == 3987520187) strcat(s, "s");
if (crc32("FEgsiAqKDFGI",12) == 3948801348) strcat(s, "r");
if (crc32("PAZwW",5) == 700680078) strcat(s, "d");
if (crc32("NdIMGujymxYT",12) == 208807253) strcat(s, "K");
if (crc32("TahoxXJo",8) == 2113217682) strcat(s, "e");
if (crc32("hORMwVu",7) == 347586746) strcat(s, "y");
if (crc32("JOpXjUQAxaJ",11) == 2749505344) strcat(s, "b");
if (crc32("CKgbod",6) == 1379250916) strcat(s, "a");
if (crc32("UIBoIfpgoVCSPk",14) == 2886157399) strcat(s, "a");
if (crc32("nsoVmxM",7) == 2446569963) strcat(s, "t");
if (crc32("iEJIWxHymFh",11) == 2668722299) strcat(s, "e");
if (crc32("TLrOawhhL",9) == 4098628249) strcat(s, "d");
    return s;
}

char *respond_verbs() {
    char *s = calloc(8);
    if (crc32("qojzQvrbWAl",11) == 241897146) strcat(s, "r");
if (crc32("HFKSVIATdVfB",12) == 2452496688) strcat(s, "Q");
if (crc32("bFKzD",5) == 1124180485) strcat(s, "e");
if (crc32("WRibSasDzy",10) == 1355158544) strcat(s, "O");
if (crc32("eBjsEPILi",9) == 1975701040) strcat(s, "s");
if (crc32("ISmYLpMhc",9) == 2039544775) strcat(s, "p");
if (crc32("YRFvCqKJf",9) == 2782436741) strcat(s, "S");
if (crc32("jeOxIglOsPnj",12) == 578814245) strcat(s, "o");
if (crc32("nutvpFoOvU",10) == 1618634669) strcat(s, "g");
if (crc32("UZmtEhnP",8) == 1029893107) strcat(s, "n");
if (crc32("VGLYllDpNI",10) == 663085721) strcat(s, "d");
    return s;
}

char *reaggregated_verbs() {
    char *s = calloc(13);
    if (crc32("UweFgyvEEx",10) == 4115812701) strcat(s, "L");
if (crc32("ZwsPajfCz",9) == 2717515618) strcat(s, "r");
if (crc32("yfaCf",5) == 440247488) strcat(s, "e");
if (crc32("HSGZUr",6) == 618075618) strcat(s, "l");
if (crc32("YPZMx",5) == 1108227621) strcat(s, "a");
if (crc32("lZADv",5) == 1302122312) strcat(s, "m");
if (crc32("jymSz",5) == 1658763553) strcat(s, "g");
if (crc32("iEYhnHKAauNIZ",13) == 3216040925) strcat(s, "Q");
if (crc32("eOLlkPTgZPL",11) == 3505446796) strcat(s, "g");
if (crc32("MnZMAdogFWN",11) == 3561348306) strcat(s, "X");
if (crc32("SgKLY",5) == 768870084) strcat(s, "r");
if (crc32("ubPDKnTMAPrNlH",14) == 1970607391) strcat(s, "d");
if (crc32("PxtwEqM",7) == 3949616638) strcat(s, "e");
if (crc32("WIhjU",5) == 2470430053) strcat(s, "i");
if (crc32("mFdpyrEcydYlIr",14) == 89065731) strcat(s, "g");
if (crc32("uDxaeFFz",8) == 485049924) strcat(s, "a");
if (crc32("MVIrlUtJSugpWc",14) == 1244761682) strcat(s, "h");
if (crc32("sQkawwfDDVqo",12) == 2562994203) strcat(s, "t");
if (crc32("gUalOMA",7) == 2855300828) strcat(s, "f");
if (crc32("qJDnhPJGT",9) == 4148843850) strcat(s, "e");
if (crc32("LeLbyz",6) == 1371684461) strcat(s, "K");
if (crc32("LgIsRCKJDmwRbKq",15) == 952162651) strcat(s, "d");
    return s;
}

char *discard_verbs() {
    char *s = calloc(8);
    if (crc32("swieE",5) == 3615633269) strcat(s, "d");
if (crc32("QVLgoMRokqQqBJ",14) == 2841859506) strcat(s, "X");
if (crc32("snlpJO",6) == 3548564613) strcat(s, "i");
if (crc32("FlKzSCbQOjIYz",13) == 917146667) strcat(s, "s");
if (crc32("LanjejCh",8) == 3438359737) strcat(s, "N");
if (crc32("aMISvVGlfvQUynS",15) == 2852333356) strcat(s, "c");
if (crc32("kasOrTCH",8) == 1892896097) strcat(s, "e");
if (crc32("JWgjVrOKz",9) == 3151409106) strcat(s, "a");
if (crc32("hkIjIdTHnaKvXD",14) == 3557449156) strcat(s, "r");
if (crc32("ktMmHSluIyIh",12) == 2654853838) strcat(s, "W");
if (crc32("gnGTuOwuhxsNvCk",15) == 3980820104) strcat(s, "d");
    return s;
}

char *overrationalizing_verbs() {
    char *s = calloc(18);
    if (crc32("zjhkrH",6) == 1839221530) strcat(s, "G");
if (crc32("uzTZsntkqRcsTI",14) == 2660897801) strcat(s, "o");
if (crc32("OnafiHVX",8) == 708452711) strcat(s, "v");
if (crc32("LFKWrwajop",10) == 3817037393) strcat(s, "E");
if (crc32("utRiqY",6) == 3840863679) strcat(s, "e");
if (crc32("xPdcRmDgN",9) == 773453175) strcat(s, "Y");
if (crc32("CaAUrzgnYLTf",12) == 3302098375) strcat(s, "r");
if (crc32("ebdzRDjjeJgy",12) == 3509043729) strcat(s, "r");
if (crc32("xLyIV",5) == 2238584754) strcat(s, "D");
if (crc32("gfHGT",5) == 1590322376) strcat(s, "a");
if (crc32("QKHqe",5) == 4197568322) strcat(s, "t");
if (crc32("lAOrLcpQpefsL",13) == 3192968703) strcat(s, "M");
if (crc32("kJgZxO",6) == 133027313) strcat(s, "i");
if (crc32("vvTyWNHPltocZa",14) == 3614549297) strcat(s, "o");
if (crc32("PTFSEaXi",8) == 783312272) strcat(s, "j");
if (crc32("rBliFWKQHI",10) == 1036122040) strcat(s, "n");
if (crc32("gntNddPAUTJNyU",14) == 4220810259) strcat(s, "a");
if (crc32("fRFxHUWEba",10) == 229624054) strcat(s, "l");
if (crc32("BgYKp",5) == 3821864311) strcat(s, "T");
if (crc32("wIIxRcUTI",9) == 2719716619) strcat(s, "i");
if (crc32("oqcQXRQleCmwxV",14) == 2979366218) strcat(s, "i");
if (crc32("PfBAmEiOAL",10) == 1941596027) strcat(s, "z");
if (crc32("RjTiDl",6) == 1081966680) strcat(s, "Q");
if (crc32("sRgZc",5) == 3223581362) strcat(s, "i");
if (crc32("rqCNFEvTT",9) == 147998453) strcat(s, "S");
if (crc32("AXkjpDBIhKwYw",13) == 1466828874) strcat(s, "n");
if (crc32("eWYzy",5) == 3152069839) strcat(s, "L");
if (crc32("usWiKGApMbpvPCh",15) == 2052451379) strcat(s, "g");
    return s;
}

char *crossbreeding_verbs() {
    char *s = calloc(14);
    if (crc32("stRtvsckou",10) == 2425175683) strcat(s, "c");
if (crc32("iqCccXgfeIapcp",14) == 535797833) strcat(s, "r");
if (crc32("apuDm",5) == 4234359843) strcat(s, "o");
if (crc32("pfWvGw",6) == 3053908006) strcat(s, "S");
if (crc32("iTijaQbw",8) == 4130054520) strcat(s, "s");
if (crc32("doAxTNWfANoJ",12) == 1188034427) strcat(s, "s");
if (crc32("xNtVw",5) == 87272924) strcat(s, "b");
if (crc32("jnzHrHXNohEu",12) == 693946633) strcat(s, "r");
if (crc32("GSUKkwDkIgvK",12) == 734922643) strcat(s, "L");
if (crc32("PeOFeLM",7) == 2564904118) strcat(s, "e");
if (crc32("fHjcripWcS",10) == 1827957668) strcat(s, "g");
if (crc32("GxonpKZSLb",10) == 401509126) strcat(s, "e");
if (crc32("OlHeUinwbcqHDDd",15) == 864191255) strcat(s, "b");
if (crc32("RAAvXnDD",8) == 2342475606) strcat(s, "d");
if (crc32("fhBCbAWvpX",10) == 3906744157) strcat(s, "H");
if (crc32("SoCYdExGaMS",11) == 384576169) strcat(s, "i");
if (crc32("PoWtvQzXdHF",11) == 277619668) strcat(s, "n");
if (crc32("MUraJCFRAqJ",11) == 3842497669) strcat(s, "g");
    return s;
}

char *believing_verbs() {
    char *s = calloc(10);
    if (crc32("OXyLnIm",7) == 562508946) strcat(s, "T");
if (crc32("JlvmArnzka",10) == 690937071) strcat(s, "b");
if (crc32("rxUgO",5) == 1293124091) strcat(s, "e");
if (crc32("aKgEYK",6) == 1171232569) strcat(s, "N");
if (crc32("sCeBSxIox",9) == 31712212) strcat(s, "l");
if (crc32("GnbqkXtrAkhbe",13) == 2881152383) strcat(s, "R");
if (crc32("PMroRPxuNIAST",13) == 778921528) strcat(s, "i");
if (crc32("dycElzBqOdwc",12) == 493206782) strcat(s, "E");
if (crc32("aeVrDFfjWY",10) == 3705657833) strcat(s, "e");
if (crc32("LUmvuTpau",9) == 236397406) strcat(s, "t");
if (crc32("vIdWs",5) == 629439788) strcat(s, "v");
if (crc32("XCxXomY",7) == 1122958472) strcat(s, "i");
if (crc32("RxAwXavcDCjMcK",14) == 3000056750) strcat(s, "n");
if (crc32("PZUApX",6) == 3815553845) strcat(s, "H");
if (crc32("OOjdAdzlTlhGR",13) == 3616926552) strcat(s, "g");
    return s;
}

char *invoicing_verbs() {
    char *s = calloc(10);
    if (crc32("iIZxUVaDJ",9) == 3188319254) strcat(s, "Z");
if (crc32("VgNuWkWcJczIu",13) == 4266518911) strcat(s, "i");
if (crc32("vHUZLkQYovxFm",13) == 2047874387) strcat(s, "y");
if (crc32("sowFVPxlXyf",11) == 2613178752) strcat(s, "n");
if (crc32("qarmFssbKa",10) == 3443768476) strcat(s, "P");
if (crc32("HprtNTwAholQoW",14) == 2149630235) strcat(s, "v");
if (crc32("ekNkL",5) == 2525689110) strcat(s, "s");
if (crc32("PBrzFQ",6) == 3177229837) strcat(s, "o");
if (crc32("yxgNITSmaAc",11) == 2346462075) strcat(s, "i");
if (crc32("AnrHtPfblRodIMS",15) == 797049127) strcat(s, "c");
if (crc32("JFKBULyPw",9) == 1426811531) strcat(s, "l");
if (crc32("XeKkeYlqB",9) == 2606458207) strcat(s, "i");
if (crc32("ObIsWfSn",8) == 664806072) strcat(s, "d");
if (crc32("ozPZouyyRnyh",12) == 2455497531) strcat(s, "n");
if (crc32("yXQJjbGhtlreSY",14) == 3156914152) strcat(s, "J");
if (crc32("DBTsNTQK",8) == 1625094847) strcat(s, "g");
    return s;
}

char *undershoot_verbs() {
    char *s = calloc(11);
    if (crc32("kmVxyhVo",8) == 3591712717) strcat(s, "b");
if (crc32("vudTYi",6) == 3714971929) strcat(s, "u");
if (crc32("CKgNul",6) == 3382033233) strcat(s, "A");
if (crc32("ptRQUpcEOT",10) == 3415851493) strcat(s, "n");
if (crc32("ZeWmqjmL",8) == 832129480) strcat(s, "d");
if (crc32("oAvpcFxUI",9) == 4139586505) strcat(s, "e");
if (crc32("XrBXLQyrXFGnAIp",15) == 924547272) strcat(s, "n");
if (crc32("WWgPzGDSJO",10) == 2174326558) strcat(s, "r");
if (crc32("bUHZmE",6) == 3982701576) strcat(s, "s");
if (crc32("dIgxGecSzw",10) == 2144627061) strcat(s, "j");
if (crc32("HDhagO",6) == 2229405873) strcat(s, "h");
if (crc32("Mhhxgf",6) == 3016909870) strcat(s, "y");
if (crc32("JBReXTO",7) == 733445869) strcat(s, "o");
if (crc32("IbmCYinvkV",10) == 1348556079) strcat(s, "K");
if (crc32("WNCzXjzmyPi",11) == 1987082217) strcat(s, "o");
if (crc32("QtHul",5) == 1338595861) strcat(s, "t");
    return s;
}

char *spruceup_verbs() {
    char *s = calloc(9);
    if (crc32("WhvWgDvrFQeF",12) == 2343562463) strcat(s, "U");
if (crc32("iJCkmB",6) == 165173661) strcat(s, "s");
if (crc32("dDDEwALds",9) == 2516052681) strcat(s, "R");
if (crc32("CpxZRRNXjQS",11) == 1426946035) strcat(s, "p");
if (crc32("ZQkVoPzPq",9) == 3744448941) strcat(s, "r");
if (crc32("DsRsNyB",7) == 578746747) strcat(s, "q");
if (crc32("oLVUjVA",7) == 2079467964) strcat(s, "u");
if (crc32("gHgPSPO",7) == 3796570199) strcat(s, "c");
if (crc32("RzNXJtkPPCP",11) == 3003760418) strcat(s, "e");
if (crc32("MlkbQVjSnvH",11) == 2984375010) strcat(s, "z");
if (crc32("akzSYaDDEna",11) == 377791305) strcat(s, "u");
if (crc32("zonpxtRwBZVlqe",14) == 2571361013) strcat(s, "N");
if (crc32("YXuzXMJcIyTBr",13) == 2486088013) strcat(s, "p");
    return s;
}

char *preconsolidate_verbs() {
    char *s = calloc(15);
    if (crc32("ihWNDVOt",8) == 1907165531) strcat(s, "o");
if (crc32("cdFkoZeoXVsOf",13) == 2222022946) strcat(s, "p");
if (crc32("XaGAOFyAknyY",12) == 3112937677) strcat(s, "r");
if (crc32("LMDeufBrHlVQZ",13) == 69606930) strcat(s, "T");
if (crc32("jIMxs",5) == 2769568429) strcat(s, "e");
if (crc32("LUXUV",5) == 2448171450) strcat(s, "W");
if (crc32("RClzDoNU",8) == 3918591998) strcat(s, "c");
if (crc32("HCtNZg",6) == 1078058271) strcat(s, "o");
if (crc32("UeCLqTf",7) == 1353174082) strcat(s, "a");
if (crc32("lGbiqZKVyuQn",12) == 4095249132) strcat(s, "n");
if (crc32("tUwLQ",5) == 2732057882) strcat(s, "U");
if (crc32("ImVuXwrzScugZok",15) == 577110081) strcat(s, "s");
if (crc32("osgVEzcKcjOZ",12) == 1812630634) strcat(s, "o");
if (crc32("lHTVfWGkjoD",11) == 694030752) strcat(s, "l");
if (crc32("bUYzsQIFLD",10) == 1000285659) strcat(s, "i");
if (crc32("BUUeOaKhIv",10) == 1293461143) strcat(s, "d");
if (crc32("pKfUR",5) == 2098652853) strcat(s, "a");
if (crc32("ACItWFdNxpD",11) == 41638644) strcat(s, "F");
if (crc32("EQCGABj",7) == 1265458905) strcat(s, "t");
if (crc32("dAJKnNgfPYa",11) == 3397658475) strcat(s, "a");
if (crc32("eVgxeaxbS",9) == 3889663771) strcat(s, "e");
    return s;
}

char *scragging_verbs() {
    char *s = calloc(10);
    if (crc32("prFICoMMnF",10) == 312760796) strcat(s, "s");
if (crc32("bsZmAFXpxNc",11) == 1783695015) strcat(s, "c");
if (crc32("rtzxzttsjNkI",12) == 304521864) strcat(s, "M");
if (crc32("fBueRiK",7) == 811194208) strcat(s, "r");
if (crc32("czkMEk",6) == 2079049218) strcat(s, "g");
if (crc32("SnjWup",6) == 587186443) strcat(s, "a");
if (crc32("UCOVe",5) == 361751949) strcat(s, "g");
if (crc32("iLWQhqTFL",9) == 3035878698) strcat(s, "q");
if (crc32("mkRKqtLSiQKcyn",14) == 2260696523) strcat(s, "g");
if (crc32("KjxgHeRXOLbwPLS",15) == 1168254268) strcat(s, "t");
if (crc32("jQLVA",5) == 4071296838) strcat(s, "i");
if (crc32("kPxujviBkdbIfd",14) == 1983302748) strcat(s, "n");
if (crc32("pMyJidvngc",10) == 3626627781) strcat(s, "g");
    return s;
}

char *lie_verbs() {
    char *s = calloc(4);
    if (crc32("gtYUhJTiU",9) == 3989297939) strcat(s, "N");
if (crc32("hRpGZj",6) == 3832526462) strcat(s, "l");
if (crc32("EubLeQKuAtBlQwI",15) == 1628345820) strcat(s, "v");
if (crc32("TFjGwNh",7) == 983237111) strcat(s, "i");
if (crc32("aUZyQQ",6) == 2533543244) strcat(s, "F");
if (crc32("rVOZTXfYQfhGx",13) == 999991056) strcat(s, "e");
    return s;
}

char *embarrass_verbs() {
    char *s = calloc(10);
    if (crc32("tmwVZCheCSgUi",13) == 2355260827) strcat(s, "o");
if (crc32("rHlYFxgXk",9) == 957468344) strcat(s, "e");
if (crc32("EmhbQj",6) == 888384881) strcat(s, "m");
if (crc32("sPsEhx",6) == 1521557336) strcat(s, "R");
if (crc32("MMOUbJWbEUasWj",14) == 1777693254) strcat(s, "b");
if (crc32("YMTilghPC",9) == 3524483266) strcat(s, "I");
if (crc32("mayycuN",7) == 3756906321) strcat(s, "a");
if (crc32("ptAnX",5) == 876304385) strcat(s, "r");
if (crc32("DQYHOPa",7) == 1412763442) strcat(s, "I");
if (crc32("sWgxDJVPSDwDUB",14) == 3189401008) strcat(s, "r");
if (crc32("mwURtN",6) == 2780951889) strcat(s, "P");
if (crc32("DqEhuculLaFvy",13) == 3078902742) strcat(s, "a");
if (crc32("OJZVjRwOTsWTq",13) == 4272045778) strcat(s, "h");
if (crc32("krNtbkyfuSPEI",13) == 198370392) strcat(s, "s");
if (crc32("wFRCTMr",7) == 2701654483) strcat(s, "B");
if (crc32("NnSltQdqIIM",11) == 3663018417) strcat(s, "s");
    return s;
}

char *dowith_verbs() {
    char *s = calloc(7);
    if (crc32("YpPzexN",7) == 2677403994) strcat(s, "e");
if (crc32("vDZWdeOVCFKyaP",14) == 426524212) strcat(s, "d");
if (crc32("IudKwL",6) == 2134406471) strcat(s, "o");
if (crc32("UjBQAXKNhYromN",14) == 1487616813) strcat(s, "R");
if (crc32("PuToRptyw",9) == 341532828) strcat(s, "w");
if (crc32("uXCpT",5) == 213519410) strcat(s, "T");
if (crc32("fDMfKAM",7) == 3257793460) strcat(s, "i");
if (crc32("KSMvLSCy",8) == 2332646423) strcat(s, "t");
if (crc32("wTZhNzzrbAXXgT",14) == 48965079) strcat(s, "h");
    return s;
}

char *telephoned_verbs() {
    char *s = calloc(11);
    if (crc32("DkHqPGlGnES",11) == 1997365400) strcat(s, "t");
if (crc32("ZZSgEFqaQpfby",13) == 2638872329) strcat(s, "E");
if (crc32("vjKDguEIfFQHuO",14) == 1496712652) strcat(s, "e");
if (crc32("NgZIIElY",8) == 2389456549) strcat(s, "t");
if (crc32("HXrxymsxEopXCoP",15) == 3403217958) strcat(s, "l");
if (crc32("XBJvLY",6) == 2575459826) strcat(s, "e");
if (crc32("SPSeCGQ",7) == 2164299294) strcat(s, "v");
if (crc32("sDAZxhcbSC",10) == 1302895186) strcat(s, "p");
if (crc32("HtjzWdgfiUN",11) == 1118061201) strcat(s, "l");
if (crc32("nSTcYHaAMlXh",12) == 217426792) strcat(s, "h");
if (crc32("YkAQY",5) == 3746121751) strcat(s, "o");
if (crc32("cQutRtmmO",9) == 156580191) strcat(s, "g");
if (crc32("fyZpgHxFmxVZmI",14) == 2472738710) strcat(s, "n");
if (crc32("kDGyFbrit",9) == 2605838152) strcat(s, "Z");
if (crc32("YqcYqhii",8) == 3407964198) strcat(s, "e");
if (crc32("CzfchRTid",9) == 714203297) strcat(s, "U");
if (crc32("JSfQxk",6) == 772250308) strcat(s, "d");
    return s;
}

char *slaying_verbs() {
    char *s = calloc(8);
    if (crc32("eLECZ",5) == 654194756) strcat(s, "T");
if (crc32("KEEUHqtTBFxvh",13) == 1945689145) strcat(s, "s");
if (crc32("ZXIoHIVJdGRRKLK",15) == 58393850) strcat(s, "f");
if (crc32("LXUfXf",6) == 2801906829) strcat(s, "l");
if (crc32("EgobVP",6) == 3361215719) strcat(s, "o");
if (crc32("vaBucRKp",8) == 1415414070) strcat(s, "a");
if (crc32("UwDXg",5) == 1180509398) strcat(s, "F");
if (crc32("mdOESAgjdMXZzQ",14) == 976525014) strcat(s, "y");
if (crc32("lFKPDOfEBctGJWc",15) == 1182219717) strcat(s, "n");
if (crc32("hMiyQEKjyMf",11) == 2996983516) strcat(s, "i");
if (crc32("rAsSlGNmcabiSq",14) == 3858266873) strcat(s, "n");
if (crc32("DAmwhQoFx",9) == 495148369) strcat(s, "g");
    return s;
}

char *retelephone_verbs() {
    char *s = calloc(12);
    if (crc32("lJPHWbxLAT",10) == 3778660053) strcat(s, "r");
if (crc32("vZuSKu",6) == 2647216463) strcat(s, "m");
if (crc32("eCHtgQtt",8) == 2955367094) strcat(s, "e");
if (crc32("SEiFhhKpHhbB",12) == 1549930064) strcat(s, "z");
if (crc32("qWjLgtymRPf",11) == 719490637) strcat(s, "t");
if (crc32("ltqLTLJHGOm",11) == 2245358118) strcat(s, "e");
if (crc32("OuHBEuIRONtNaz",14) == 3533435909) strcat(s, "l");
if (crc32("qzHhoHvjjwCZt",13) == 389000339) strcat(s, "e");
if (crc32("ZdeDEEwkFFQ",11) == 2995940853) strcat(s, "p");
if (crc32("DDbumX",6) == 4270739023) strcat(s, "h");
if (crc32("VhXJgXiOPLrvBS",14) == 2339405116) strcat(s, "h");
if (crc32("VnIktrvHd",9) == 2129070942) strcat(s, "o");
if (crc32("OiZzixan",8) == 3931317798) strcat(s, "y");
if (crc32("DSBCfQNdOcC",11) == 2931019271) strcat(s, "n");
if (crc32("elsfjCCGeCG",11) == 2619330830) strcat(s, "e");
    return s;
}

char *cosmolining_verbs() {
    char *s = calloc(12);
    if (crc32("BbhcxhdEbnqSl",13) == 1059802264) strcat(s, "w");
if (crc32("JAQgOHCbKphtK",13) == 3395482864) strcat(s, "c");
if (crc32("CrZHuwisselGT",13) == 2139024759) strcat(s, "o");
if (crc32("xwHfBOVnDcBfemQ",15) == 343933754) strcat(s, "s");
if (crc32("dciyczYZa",9) == 287606706) strcat(s, "i");
if (crc32("XATcKXIehfJgwFY",15) == 1584825295) strcat(s, "m");
if (crc32("ftuDJFH",7) == 1674862740) strcat(s, "o");
if (crc32("VyPmL",5) == 3264523723) strcat(s, "T");
if (crc32("WxrsZMvt",8) == 4011923247) strcat(s, "l");
if (crc32("dxlZFz",6) == 4017239292) strcat(s, "Z");
if (crc32("opGzQMdOoceIfAh",15) == 2765015145) strcat(s, "i");
if (crc32("CekhDieq",8) == 392902237) strcat(s, "N");
if (crc32("SxRzlR",6) == 2251640360) strcat(s, "n");
if (crc32("TJAkBVBfxAxhR",13) == 3626672700) strcat(s, "L");
if (crc32("LdcdtNuPpmPFrJH",15) == 2412872963) strcat(s, "i");
if (crc32("jbObQr",6) == 677049940) strcat(s, "G");
if (crc32("vVbhxh",6) == 2827930256) strcat(s, "n");
if (crc32("ydjvp",5) == 912033654) strcat(s, "F");
if (crc32("yKYxkTUwhiRaRo",14) == 357665073) strcat(s, "g");
    return s;
}

char *subinferred_verbs() {
    char *s = calloc(12);
    if (crc32("BImYgOdsFZf",11) == 4031504553) strcat(s, "r");
if (crc32("IzeweIrtSubRxFc",15) == 1177618657) strcat(s, "s");
if (crc32("OObvijgVVEdFJnZ",15) == 2110979778) strcat(s, "u");
if (crc32("vjCmSlNOsE",10) == 1217586292) strcat(s, "b");
if (crc32("ZloDnG",6) == 975135059) strcat(s, "Y");
if (crc32("yvkvYlrJY",9) == 2405111828) strcat(s, "i");
if (crc32("FHfMC",5) == 1650649012) strcat(s, "z");
if (crc32("LInUTDn",7) == 3119246681) strcat(s, "n");
if (crc32("zzVihwHGoFh",11) == 1047719077) strcat(s, "f");
if (crc32("ScUZoXdjDAsDE",13) == 209182050) strcat(s, "l");
if (crc32("JsDXEukwZcfEF",13) == 4258846192) strcat(s, "e");
if (crc32("ihplPxhAzqATLl",14) == 1733892087) strcat(s, "f");
if (crc32("wDarhsim",8) == 475053364) strcat(s, "r");
if (crc32("ixACZCuFjpNTj",13) == 540865081) strcat(s, "v");
if (crc32("GHnsDXsmgpnB",12) == 2515586370) strcat(s, "r");
if (crc32("SSSpgLJExCGVRUB",15) == 3958519527) strcat(s, "A");
if (crc32("DDHgeHiKZgihrJM",15) == 4055257967) strcat(s, "e");
if (crc32("hyFPyuzDFasnae",14) == 1307952294) strcat(s, "b");
if (crc32("wLkUFtktzZQnn",13) == 1713008937) strcat(s, "d");
    return s;
}

char *reliving_verbs() {
    char *s = calloc(9);
    if (crc32("pJrgYLLjTD",10) == 3683557998) strcat(s, "K");
if (crc32("zHzEh",5) == 3168911373) strcat(s, "r");
if (crc32("YMpKFyqEduRsguB",15) == 1659254055) strcat(s, "T");
if (crc32("qXavfzNXgjyOheS",15) == 3511294141) strcat(s, "e");
if (crc32("LyOLsBSoei",10) == 2547348967) strcat(s, "J");
if (crc32("RYMZAyamUa",10) == 3146629974) strcat(s, "l");
if (crc32("ucPIryyTSAElH",13) == 3645161751) strcat(s, "z");
if (crc32("fnVfhfVlHZiqkJZ",15) == 1984503479) strcat(s, "i");
if (crc32("QnJuFxWTGE",10) == 3014811978) strcat(s, "v");
if (crc32("MmZtqwTLqulN",12) == 1305015043) strcat(s, "u");
if (crc32("kKkkCaBwpALCs",13) == 1912770503) strcat(s, "i");
if (crc32("osNSgIGSh",9) == 3003545735) strcat(s, "n");
if (crc32("eepTmtLUFMsLCsl",15) == 2742609892) strcat(s, "g");
    return s;
}

char *featuring_verbs() {
    char *s = calloc(10);
    if (crc32("gjBwmkHsmXE",11) == 803004816) strcat(s, "f");
if (crc32("QAsrjyUETWwm",12) == 2190276105) strcat(s, "e");
if (crc32("UgNRqpKa",8) == 4013871038) strcat(s, "a");
if (crc32("lxtHYj",6) == 1042038612) strcat(s, "n");
if (crc32("JXPbUusbn",9) == 1258009028) strcat(s, "t");
if (crc32("MTiNo",5) == 3604946429) strcat(s, "u");
if (crc32("tfJqfYELIW",10) == 725818701) strcat(s, "r");
if (crc32("vKlsxhcOvFWoy",13) == 1973644296) strcat(s, "i");
if (crc32("iclZLmdxTzWRnl",14) == 4146708183) strcat(s, "n");
if (crc32("tjyIXf",6) == 2618746731) strcat(s, "z");
if (crc32("fFTbDMFgoB",10) == 3796148014) strcat(s, "g");
    return s;
}

char *feminize_verbs() {
    char *s = calloc(9);
    if (crc32("VAPjIhf",7) == 56332571) strcat(s, "f");
if (crc32("WQvzfFzUEgPTWt",14) == 970936137) strcat(s, "D");
if (crc32("jgUXghNcJe",10) == 2853577105) strcat(s, "e");
if (crc32("jZOdaWgtIVwZS",13) == 143301532) strcat(s, "e");
if (crc32("PhmTVf",6) == 4274455253) strcat(s, "m");
if (crc32("AvOCrNBzyyDYD",13) == 2162434409) strcat(s, "i");
if (crc32("VttkHDzKviVK",12) == 377444945) strcat(s, "X");
if (crc32("LHApID",6) == 2257084145) strcat(s, "n");
if (crc32("iwxNtnR",7) == 1817550908) strcat(s, "i");
if (crc32("gMxmrfhxFAUxFNJ",15) == 2103398418) strcat(s, "i");
if (crc32("VBOIwJPbREF",11) == 92534481) strcat(s, "z");
if (crc32("sMNaLdTXelm",11) == 178347324) strcat(s, "e");
    return s;
}

char *reshew_verbs() {
    char *s = calloc(7);
    if (crc32("UFBTSoaz",8) == 3931626154) strcat(s, "W");
if (crc32("rvnvAyQoQZkHpM",14) == 3738744845) strcat(s, "r");
if (crc32("lLadED",6) == 1955806687) strcat(s, "k");
if (crc32("QoPTzmVubJiCQ",13) == 3942845880) strcat(s, "e");
if (crc32("noiFuQGjRaX",11) == 3881787812) strcat(s, "s");
if (crc32("xxQGEsfNdlLyDVr",15) == 3460385447) strcat(s, "V");
if (crc32("MgiZXcndcNHFEjn",15) == 1963496341) strcat(s, "h");
if (crc32("eqoPxBnat",9) == 1880049633) strcat(s, "e");
if (crc32("shSKIT",6) == 2113683852) strcat(s, "w");
    return s;
}

char *sideswiping_verbs() {
    char *s = calloc(12);
    if (crc32("RRtFcvnJsyUy",12) == 3836963289) strcat(s, "s");
if (crc32("fhWDVbkCCsGC",12) == 4091553151) strcat(s, "i");
if (crc32("rZYLpzW",7) == 118604335) strcat(s, "n");
if (crc32("ZvTjmjoAUPDG",12) == 3597083679) strcat(s, "d");
if (crc32("ATISuVZYSAPc",12) == 3410439632) strcat(s, "e");
if (crc32("xFIBbybLISfeot",14) == 482616163) strcat(s, "s");
if (crc32("DbeIFKIHMlWeXyT",15) == 3093960326) strcat(s, "w");
if (crc32("dENgkJKsuvG",11) == 703966869) strcat(s, "Y");
if (crc32("OtVrmldcI",9) == 3616239294) strcat(s, "i");
if (crc32("kqoktdmTcOUhmxB",15) == 4089604988) strcat(s, "G");
if (crc32("zNnkvLoD",8) == 882511206) strcat(s, "p");
if (crc32("JBNtZPUgAgbuPnu",15) == 347532501) strcat(s, "R");
if (crc32("FpSxmwMexTakE",13) == 11474684) strcat(s, "i");
if (crc32("LxudZNF",7) == 1477019177) strcat(s, "H");
if (crc32("aNUkCfZ",7) == 1408140504) strcat(s, "n");
if (crc32("XwosbZL",7) == 2381581586) strcat(s, "g");
    return s;
}

char *preresembled_verbs() {
    char *s = calloc(13);
    if (crc32("ScRTWGOaPi",10) == 3945857153) strcat(s, "p");
if (crc32("FskDHZdDV",9) == 3788917063) strcat(s, "r");
if (crc32("qMaiClU",7) == 643582318) strcat(s, "e");
if (crc32("mqxApgwTOLrWji",14) == 2318816297) strcat(s, "Q");
if (crc32("WTtWtTPyVI",10) == 2004407337) strcat(s, "r");
if (crc32("TvLznQiGluTRtz",14) == 2788563434) strcat(s, "e");
if (crc32("ztrJR",5) == 2813223141) strcat(s, "N");
if (crc32("GtkTRWdleE",10) == 1215845877) strcat(s, "s");
if (crc32("cEYnwoyq",8) == 1282024913) strcat(s, "e");
if (crc32("UUCrf",5) == 3347353205) strcat(s, "P");
if (crc32("yUerfYJpctwVf",13) == 3908714276) strcat(s, "m");
if (crc32("kyBuOIlb",8) == 267070823) strcat(s, "O");
if (crc32("ikcqhaMrRezf",12) == 550577374) strcat(s, "b");
if (crc32("ksNGZZabs",9) == 491264332) strcat(s, "l");
if (crc32("IsqynmPDDM",10) == 582746046) strcat(s, "e");
if (crc32("EClDGiYc",8) == 1576930168) strcat(s, "d");
    return s;
}

char *caravaned_verbs() {
    char *s = calloc(10);
    if (crc32("TURsqG",6) == 3786529392) strcat(s, "z");
if (crc32("EHYXS",5) == 3959198427) strcat(s, "c");
if (crc32("QfgjSCkvTlwKFLO",15) == 65467288) strcat(s, "n");
if (crc32("WtszLjqITRMr",12) == 299647083) strcat(s, "a");
if (crc32("XdvcWQDAkvvBQo",14) == 165153675) strcat(s, "k");
if (crc32("ojASkfvsepU",11) == 1577623497) strcat(s, "r");
if (crc32("NUzSVFrkUl",10) == 2139728793) strcat(s, "a");
if (crc32("eVJOVbEVSu",10) == 2469788389) strcat(s, "v");
if (crc32("NaJBzC",6) == 2641425635) strcat(s, "a");
if (crc32("ofoLjtFAaLzwwh",14) == 1844764108) strcat(s, "n");
if (crc32("qJWJGeaVRONkUmw",15) == 2390822927) strcat(s, "u");
if (crc32("HVeJOlUwvtVf",12) == 1598358675) strcat(s, "e");
if (crc32("UyussdfV",8) == 3882593686) strcat(s, "S");
if (crc32("bCgyhJ",6) == 760346671) strcat(s, "d");
    return s;
}

char *quintuplicated_verbs() {
    char *s = calloc(15);
    if (crc32("GKTojVFOiqFcsl",14) == 1783238916) strcat(s, "d");
if (crc32("BlHREpCkfWZv",12) == 1211962970) strcat(s, "q");
if (crc32("oPwXSCsUzJZ",11) == 1655280480) strcat(s, "m");
if (crc32("GAKOheuitfXPSne",15) == 1205678605) strcat(s, "u");
if (crc32("GXVjA",5) == 3877815158) strcat(s, "K");
if (crc32("JrsVUGwMDGrDY",13) == 1760433441) strcat(s, "i");
if (crc32("dBenPMtB",8) == 162849355) strcat(s, "g");
if (crc32("JBhZjrzghiHBw",13) == 4156900777) strcat(s, "n");
if (crc32("STxvEymYcCWN",12) == 944094009) strcat(s, "t");
if (crc32("CmNeqHCsCtNIaBc",15) == 210199962) strcat(s, "u");
if (crc32("zlVWv",5) == 1970550525) strcat(s, "E");
if (crc32("GmJhluNHLP",10) == 1311100142) strcat(s, "p");
if (crc32("xqJtRejaB",9) == 1019052379) strcat(s, "w");
if (crc32("DsODduDM",8) == 1007608379) strcat(s, "l");
if (crc32("TjXbIgDOUQ",10) == 153461167) strcat(s, "l");
if (crc32("RAKJmhihcPFJfI",14) == 4281004543) strcat(s, "i");
if (crc32("RfEyhbxBTnvRC",13) == 3841447673) strcat(s, "b");
if (crc32("emGZg",5) == 3102472862) strcat(s, "c");
if (crc32("SxLoipXjotau",12) == 121498531) strcat(s, "g");
if (crc32("tMKUmpvE",8) == 535216719) strcat(s, "a");
if (crc32("BQTalPvjjrLb",12) == 3014404198) strcat(s, "t");
if (crc32("RoWvnOxYDWAALW",14) == 3331096453) strcat(s, "r");
if (crc32("OUXDxTjXpUpN",12) == 2940648750) strcat(s, "e");
if (crc32("vuHgpfVd",8) == 4161786675) strcat(s, "d");
    return s;
}

char *defied_verbs() {
    char *s = calloc(7);
    if (crc32("BvopTvyfptTq",12) == 3851780421) strcat(s, "f");
if (crc32("QtvoplaaN",9) == 4053121405) strcat(s, "d");
if (crc32("aaBMF",5) == 3397728340) strcat(s, "x");
if (crc32("DmJhKaurjWsfNV",14) == 3091838442) strcat(s, "e");
if (crc32("gTZbYxVsNXu",11) == 977543565) strcat(s, "H");
if (crc32("zaQucRHFTZlpsgy",15) == 694689855) strcat(s, "f");
if (crc32("USfonqPbMvUt",12) == 349992893) strcat(s, "G");
if (crc32("rFQkI",5) == 523783308) strcat(s, "i");
if (crc32("FlrKzAkyBD",10) == 721867199) strcat(s, "J");
if (crc32("bdniSiR",7) == 766299780) strcat(s, "e");
if (crc32("ujraQLtGRC",10) == 1427247428) strcat(s, "d");
    return s;
}

char *scurrying_verbs() {
    char *s = calloc(10);
    if (crc32("iqROPWXWyKqbC",13) == 258212283) strcat(s, "s");
if (crc32("APYBGhstqu",10) == 1476891985) strcat(s, "r");
if (crc32("LMNwHGDnIIL",11) == 1593689603) strcat(s, "c");
if (crc32("PLbVBQt",7) == 1281427475) strcat(s, "u");
if (crc32("pErMXXX",7) == 3650539695) strcat(s, "D");
if (crc32("TlJxeq",6) == 3957075703) strcat(s, "r");
if (crc32("ePmIe",5) == 9517418) strcat(s, "r");
if (crc32("yDlbZBN",7) == 1402007865) strcat(s, "c");
if (crc32("XnwREZigLDl",11) == 3312557046) strcat(s, "y");
if (crc32("QUFNEGN",7) == 2969099424) strcat(s, "i");
if (crc32("UiwIBfV",7) == 2888109530) strcat(s, "n");
if (crc32("zRUQVUrb",8) == 698480510) strcat(s, "k");
if (crc32("eaMAviLHJe",10) == 518285585) strcat(s, "g");
    return s;
}

char *voting_verbs() {
    char *s = calloc(7);
    if (crc32("pcEdpvnKjGc",11) == 437664596) strcat(s, "v");
if (crc32("wRjlrT",6) == 2171579339) strcat(s, "o");
if (crc32("hApkNH",6) == 1141181876) strcat(s, "w");
if (crc32("XqwnINm",7) == 4287746820) strcat(s, "t");
if (crc32("xUBnFqyqBqd",11) == 2321529190) strcat(s, "i");
if (crc32("UaFRF",5) == 3597536705) strcat(s, "n");
if (crc32("cuEzRMKA",8) == 1660017278) strcat(s, "g");
    return s;
}

char *rerating_verbs() {
    char *s = calloc(9);
    if (crc32("ZXattRRhD",9) == 3829342317) strcat(s, "r");
if (crc32("CLhdtXeqUyu",11) == 1341662804) strcat(s, "t");
if (crc32("znaQRgUAAYxqko",14) == 1020521921) strcat(s, "e");
if (crc32("pYhCsJ",6) == 3679339818) strcat(s, "X");
if (crc32("DDZUrkkFs",9) == 1474202214) strcat(s, "r");
if (crc32("uRgQbAJKJdWWO",13) == 1342676537) strcat(s, "a");
if (crc32("GRowYbjIT",9) == 2364617419) strcat(s, "a");
if (crc32("PyxkdAmkoMkb",12) == 4160327834) strcat(s, "b");
if (crc32("ZMPPWiafJvUlAt",14) == 512317400) strcat(s, "t");
if (crc32("HFpICEpfJdRExs",14) == 1762445745) strcat(s, "i");
if (crc32("rIkQSfuu",8) == 3661725458) strcat(s, "n");
if (crc32("zMEbppAH",8) == 1872922192) strcat(s, "g");
    return s;
}

char *scanning_verbs() {
    char *s = calloc(9);
    if (crc32("BtDCCdZ",7) == 4165485684) strcat(s, "j");
if (crc32("JnIRjCYdMzWK",12) == 3393127570) strcat(s, "s");
if (crc32("MpfcgZE",7) == 3866058416) strcat(s, "w");
if (crc32("BWVLSXMDK",9) == 222449078) strcat(s, "c");
if (crc32("rKZCvfpYOqus",12) == 3197945958) strcat(s, "a");
if (crc32("EBYCBuqU",8) == 2904284119) strcat(s, "n");
if (crc32("hnWITLBFKXAa",12) == 1146692299) strcat(s, "n");
if (crc32("DjVYxUIoGiaPdYo",15) == 1609609055) strcat(s, "a");
if (crc32("XpSPwkHSzYZ",11) == 36476905) strcat(s, "i");
if (crc32("ODOaGe",6) == 3929883386) strcat(s, "n");
if (crc32("ULAZd",5) == 2629871435) strcat(s, "g");
    return s;
}

char *corrade_verbs() {
    char *s = calloc(8);
    if (crc32("kpWBcw",6) == 564193893) strcat(s, "J");
if (crc32("iWzUcjUhpLsA",12) == 3587233545) strcat(s, "c");
if (crc32("WVGGPOJZaQHo",12) == 1441035663) strcat(s, "o");
if (crc32("NdTVcNrK",8) == 2836425857) strcat(s, "r");
if (crc32("Yhbuj",5) == 543391757) strcat(s, "u");
if (crc32("JFLJyyzD",8) == 2030789580) strcat(s, "r");
if (crc32("ARKiUwTiH",9) == 1242888863) strcat(s, "u");
if (crc32("srULLe",6) == 1528918921) strcat(s, "a");
if (crc32("xaEHyztpjvV",11) == 1604949193) strcat(s, "L");
if (crc32("jNbbYss",7) == 1532404704) strcat(s, "d");
if (crc32("YMakDG",6) == 2174062321) strcat(s, "e");
    return s;
}

char *gilt_verbs() {
    char *s = calloc(5);
    if (crc32("pRGvzYDFC",9) == 1719460632) strcat(s, "g");
if (crc32("qelueli",7) == 1012114550) strcat(s, "i");
if (crc32("hSCZXzPlHzmds",13) == 1717753719) strcat(s, "t");
if (crc32("OvyexgRCr",9) == 3386956226) strcat(s, "l");
if (crc32("FRskh",5) == 1274520232) strcat(s, "L");
if (crc32("hCMOyWlTekq",11) == 3032226592) strcat(s, "t");
    return s;
}

char *rabbeted_verbs() {
    char *s = calloc(9);
    if (crc32("cuIhqhBvesi",11) == 1440334043) strcat(s, "H");
if (crc32("kxFpPSl",7) == 4128131308) strcat(s, "r");
if (crc32("jFPLkHhU",8) == 77709395) strcat(s, "r");
if (crc32("kGxahjzZSXCvOo",14) == 566010492) strcat(s, "a");
if (crc32("UWOhvSwZxwKW",12) == 62093652) strcat(s, "b");
if (crc32("nLfPZHOAT",9) == 986935038) strcat(s, "b");
if (crc32("zUfIKaZa",8) == 891053485) strcat(s, "x");
if (crc32("XgHEvss",7) == 3247235738) strcat(s, "e");
if (crc32("wMwTkuC",7) == 1091051367) strcat(s, "j");
if (crc32("EcAIYLgIcByWX",13) == 1729357158) strcat(s, "t");
if (crc32("IgKQFXoXjRbDga",14) == 3955440521) strcat(s, "e");
if (crc32("uPWYwSUlBn",10) == 756137807) strcat(s, "D");
if (crc32("aWzKMBLMUmld",12) == 2729797038) strcat(s, "d");
    return s;
}

char *rerun_verbs() {
    char *s = calloc(6);
    if (crc32("mtzbFwlh",8) == 1984937529) strcat(s, "X");
if (crc32("TQpVI",5) == 3473972583) strcat(s, "r");
if (crc32("RnwOlvpmSbUF",12) == 260685137) strcat(s, "K");
if (crc32("XhvjcUOjdfc",11) == 1774143449) strcat(s, "e");
if (crc32("qQqGOkPdqpt",11) == 2955220950) strcat(s, "y");
if (crc32("LmUTgpTtQlQERyB",15) == 2585409957) strcat(s, "r");
if (crc32("gPwwaJiO",8) == 2727927485) strcat(s, "g");
if (crc32("gNeBRRbTu",9) == 4013865238) strcat(s, "u");
if (crc32("cImTQmhKoa",10) == 3420645714) strcat(s, "n");
    return s;
}

char *falsify_verbs() {
    char *s = calloc(8);
    if (crc32("oxNnP",5) == 2581211365) strcat(s, "f");
if (crc32("bkPQqUJYMxn",11) == 641658479) strcat(s, "u");
if (crc32("qwRbQLPBpyGW",12) == 2464526990) strcat(s, "a");
if (crc32("JmXJhegYEHObGDn",15) == 2450621038) strcat(s, "l");
if (crc32("hcYKCoMIb",9) == 173533670) strcat(s, "s");
if (crc32("hNCCyjw",7) == 2361808839) strcat(s, "i");
if (crc32("pSmrQdgSXJr",11) == 3061858947) strcat(s, "f");
if (crc32("welsoE",6) == 2417800715) strcat(s, "b");
if (crc32("xEbRgJ",6) == 2214750606) strcat(s, "y");
    return s;
}

char *moderating_verbs() {
    char *s = calloc(11);
    if (crc32("LNGRGpWZiS",10) == 831006182) strcat(s, "i");
if (crc32("QRxSVyshKUZ",11) == 3824272952) strcat(s, "m");
if (crc32("WXFbuEOlrOJdIt",14) == 225505520) strcat(s, "i");
if (crc32("rYzcYz",6) == 1469180781) strcat(s, "o");
if (crc32("zyiXbDJKUKYtLl",14) == 2898683023) strcat(s, "z");
if (crc32("AtqvvLSAeUTYWOt",15) == 1893585816) strcat(s, "d");
if (crc32("DHYNAclxIlPdu",13) == 2629308334) strcat(s, "Y");
if (crc32("sYOFPyRvxTyqzV",14) == 4130448874) strcat(s, "e");
if (crc32("tXDEaFb",7) == 646452170) strcat(s, "q");
if (crc32("zDBIzJv",7) == 1862572799) strcat(s, "r");
if (crc32("NwgmsVxRsbf",11) == 2191266521) strcat(s, "a");
if (crc32("hyftubtIZkX",11) == 522178350) strcat(s, "t");
if (crc32("aJqjc",5) == 3081809256) strcat(s, "V");
if (crc32("xySpDHIQ",8) == 1200086046) strcat(s, "i");
if (crc32("hNJELqGUzoIhac",14) == 3702164403) strcat(s, "n");
if (crc32("NsHTHCkIWRgJ",12) == 1518873195) strcat(s, "g");
    return s;
}

char *rewarm_verbs() {
    char *s = calloc(7);
    if (crc32("mAUBW",5) == 3450771894) strcat(s, "Y");
if (crc32("kgJfkPoghGon",12) == 1121443459) strcat(s, "r");
if (crc32("KUEBHSDMTQIn",12) == 2158894690) strcat(s, "D");
if (crc32("UGVdIuKUVkOACgk",15) == 1775966087) strcat(s, "e");
if (crc32("fuPEHMPhbw",10) == 2657188861) strcat(s, "j");
if (crc32("RBKITmHZEOa",11) == 801711817) strcat(s, "w");
if (crc32("nLeYsb",6) == 3590603406) strcat(s, "a");
if (crc32("ItfXDNeISudpuz",14) == 904199068) strcat(s, "V");
if (crc32("CofVbA",6) == 50379523) strcat(s, "r");
if (crc32("hMkMCvSGTKC",11) == 3953598597) strcat(s, "U");
if (crc32("bmYYJaSrZbMEN",13) == 358243752) strcat(s, "m");
    return s;
}

char *buried_verbs() {
    char *s = calloc(7);
    if (crc32("cQTlmEA",7) == 1965700546) strcat(s, "i");
if (crc32("ndcHgmGSpOfY",12) == 1768539895) strcat(s, "b");
if (crc32("QQPMoy",6) == 1188481763) strcat(s, "f");
if (crc32("gUSprYw",7) == 1776263018) strcat(s, "u");
if (crc32("JooTwIDNjRvw",12) == 3479483530) strcat(s, "H");
if (crc32("awHEgftFWkyN",12) == 249180117) strcat(s, "r");
if (crc32("zzTEmgRQJw",10) == 4157007081) strcat(s, "i");
if (crc32("dIfmdBMzuJokUx",14) == 124545186) strcat(s, "e");
if (crc32("GJPeDC",6) == 1326270429) strcat(s, "d");
    return s;
}

char *drowse_verbs() {
    char *s = calloc(7);
    if (crc32("NBqwqtXMtyT",11) == 1309220091) strcat(s, "d");
if (crc32("eOoYjDehFMDdKU",14) == 3866736705) strcat(s, "E");
if (crc32("oDmPmlfZc",9) == 3859577591) strcat(s, "r");
if (crc32("rPKfgUfUyYnQbC",14) == 1367355084) strcat(s, "o");
if (crc32("KoAjdQwvLOXf",12) == 1930808460) strcat(s, "i");
if (crc32("MeFAOGwVjjaW",12) == 3867177260) strcat(s, "w");
if (crc32("HUIhd",5) == 2628522548) strcat(s, "t");
if (crc32("eGkUmXNShJBlvI",14) == 2063249698) strcat(s, "s");
if (crc32("ZLjdHxhJhIS",11) == 3077898142) strcat(s, "S");
if (crc32("TGvwiSFoZHLRG",13) == 1075332516) strcat(s, "e");
    return s;
}

char *kerneling_verbs() {
    char *s = calloc(10);
    if (crc32("XnurllfK",8) == 33620409) strcat(s, "k");
if (crc32("qxyVRinnqv",10) == 2180446031) strcat(s, "e");
if (crc32("NohYNiCNGnmxb",13) == 993965054) strcat(s, "d");
if (crc32("IxJFcRT",7) == 2846423091) strcat(s, "r");
if (crc32("FcJnjaVvZY",10) == 3157451595) strcat(s, "F");
if (crc32("WMRoVccWBwQVF",13) == 3950887618) strcat(s, "n");
if (crc32("NDVTa",5) == 3116647875) strcat(s, "e");
if (crc32("wDyPus",6) == 942723649) strcat(s, "r");
if (crc32("wGQEy",5) == 1119526169) strcat(s, "l");
if (crc32("ZDwDTrWDV",9) == 3351579267) strcat(s, "Q");
if (crc32("aKtSq",5) == 3406428525) strcat(s, "i");
if (crc32("OatJdmeGgFZv",12) == 999869862) strcat(s, "n");
if (crc32("ssjTxIxmPQYzji",14) == 84941599) strcat(s, "g");
    return s;
}

char *teheeing_verbs() {
    char *s = calloc(9);
    if (crc32("aByJId",6) == 1342685304) strcat(s, "t");
if (crc32("EuFOMKQlF",9) == 2560029349) strcat(s, "e");
if (crc32("EcxGgJtspqDXif",14) == 44905892) strcat(s, "w");
if (crc32("bGsjdaVrdVsQ",12) == 1884472673) strcat(s, "h");
if (crc32("LbYrYNscLN",10) == 1604494510) strcat(s, "O");
if (crc32("wUUTjfLvCV",10) == 1652127513) strcat(s, "e");
if (crc32("inFmPsPCbRZ",11) == 1055380679) strcat(s, "e");
if (crc32("YrFiKi",6) == 1772354930) strcat(s, "d");
if (crc32("JJFGbkZPGppFZ",13) == 2631309014) strcat(s, "i");
if (crc32("RJLUbJKgUzNQ",12) == 3358223740) strcat(s, "n");
if (crc32("TzDzAdxhLBpnhbC",15) == 3260192292) strcat(s, "g");
    return s;
}

char *hybridized_verbs() {
    char *s = calloc(11);
    if (crc32("NxLppcAiKOdMt",13) == 526485452) strcat(s, "h");
if (crc32("LEzfqTaHGMy",11) == 2187774611) strcat(s, "h");
if (crc32("dxpZwAAXZ",9) == 2230140601) strcat(s, "P");
if (crc32("IYoGVqzmgtFskR",14) == 1675237551) strcat(s, "y");
if (crc32("YuVzpNbpx",9) == 3220393593) strcat(s, "z");
if (crc32("BzfnDy",6) == 2717450182) strcat(s, "b");
if (crc32("TPzskcjqlowAwOn",15) == 3351806354) strcat(s, "Y");
if (crc32("IuoUzPMPTFiH",12) == 680733734) strcat(s, "r");
if (crc32("tmMDXePiLKonSGb",15) == 3045391330) strcat(s, "i");
if (crc32("JaEUFoq",7) == 1933373100) strcat(s, "m");
if (crc32("qLUjcVAZlFh",11) == 2892919739) strcat(s, "d");
if (crc32("DrJzTjQRPR",10) == 1290282659) strcat(s, "e");
if (crc32("nMvPrj",6) == 2983793075) strcat(s, "i");
if (crc32("EBgnuWlKdVlBO",13) == 1493160377) strcat(s, "m");
if (crc32("OBrloTszS",9) == 2790468761) strcat(s, "z");
if (crc32("acFLSoVHXvjB",12) == 3876598192) strcat(s, "e");
if (crc32("LZflofPmg",9) == 777511648) strcat(s, "B");
if (crc32("LdBnvxXWYWrxA",13) == 1831970506) strcat(s, "d");
    return s;
}

char *praised_verbs() {
    char *s = calloc(8);
    if (crc32("zPptPEQgqI",10) == 1599374038) strcat(s, "p");
if (crc32("mJJPwmYOvlu",11) == 955396870) strcat(s, "e");
if (crc32("DePMPNIb",8) == 2392375139) strcat(s, "r");
if (crc32("RvUBf",5) == 2776009182) strcat(s, "L");
if (crc32("BxkZeNbRNICK",12) == 2552096583) strcat(s, "a");
if (crc32("HKcVomEyykRs",12) == 3632417937) strcat(s, "i");
if (crc32("qIZCZsvblXboEQ",14) == 548959202) strcat(s, "s");
if (crc32("OSsRRPmja",9) == 3426440846) strcat(s, "e");
if (crc32("MOKCDolh",8) == 222915611) strcat(s, "Z");
if (crc32("XPzHxCWloQbuIA",14) == 1615161167) strcat(s, "d");
    return s;
}

char *rewear_verbs() {
    char *s = calloc(7);
    if (crc32("KniUdNjFFsKU",12) == 4089217217) strcat(s, "r");
if (crc32("FhRnnA",6) == 409559666) strcat(s, "e");
if (crc32("VnuMorvrko",10) == 987286777) strcat(s, "w");
if (crc32("XvHtAuDWyDOIAUf",15) == 1810789462) strcat(s, "d");
if (crc32("DMQItDExWOSEx",13) == 44509060) strcat(s, "e");
if (crc32("EWGalQFrDdm",11) == 1318427560) strcat(s, "J");
if (crc32("ISSFFIaewN",10) == 2264286347) strcat(s, "a");
if (crc32("ofgXmChsPUF",11) == 1295623718) strcat(s, "r");
    return s;
}

char *wiseup_verbs() {
    char *s = calloc(7);
    if (crc32("esvPectCTSFQcRg",15) == 1328810872) strcat(s, "D");
if (crc32("LUPVHFaidBD",11) == 3108647702) strcat(s, "w");
if (crc32("UraBnVYqoYIPe",13) == 2753604875) strcat(s, "U");
if (crc32("yyjReVYffwZrj",13) == 1492012887) strcat(s, "i");
if (crc32("skDXXqfW",8) == 3221195939) strcat(s, "G");
if (crc32("DyzUVXLVCR",10) == 1372587795) strcat(s, "s");
if (crc32("pHrlPaqtfY",10) == 3680340099) strcat(s, "e");
if (crc32("TfkDaLCtgqMfSwP",15) == 4060157729) strcat(s, "u");
if (crc32("DvQVInWHo",9) == 2482949965) strcat(s, "m");
if (crc32("SbjFyhHkDjLBdE",14) == 1685611001) strcat(s, "p");
    return s;
}

char *trindled_verbs() {
    char *s = calloc(9);
    if (crc32("zprir",5) == 1128190767) strcat(s, "t");
if (crc32("qcQfgpmMm",9) == 1917588795) strcat(s, "r");
if (crc32("pSQHEXmSz",9) == 3832959595) strcat(s, "d");
if (crc32("POIIyywH",8) == 2862469881) strcat(s, "i");
if (crc32("uBqtTeZH",8) == 2886357476) strcat(s, "n");
if (crc32("RYiGvRscSi",10) == 3352946270) strcat(s, "d");
if (crc32("mMzHFc",6) == 3490613495) strcat(s, "B");
if (crc32("CdTNJROZptvTJh",14) == 1344318617) strcat(s, "l");
if (crc32("DKZYqcGvOZ",10) == 1895327959) strcat(s, "b");
if (crc32("fVoGl",5) == 2256624930) strcat(s, "e");
if (crc32("KVukUTwPPV",10) == 3668886649) strcat(s, "d");
    return s;
}

char *drown_verbs() {
    char *s = calloc(6);
    if (crc32("fOdlnvNpJUD",11) == 2085501928) strcat(s, "I");
if (crc32("THydMgZgLQdCBj",14) == 1553204768) strcat(s, "d");
if (crc32("iOTGbEOc",8) == 556645466) strcat(s, "r");
if (crc32("TOlWTjYIhWIB",12) == 1915763917) strcat(s, "o");
if (crc32("OmNruj",6) == 4261362723) strcat(s, "w");
if (crc32("kfVKIQxXmKwt",12) == 2890800719) strcat(s, "n");
    return s;
}

char *divining_verbs() {
    char *s = calloc(9);
    if (crc32("QpNqx",5) == 3130040457) strcat(s, "d");
if (crc32("VbSLbqydzGdwzl",14) == 1971599006) strcat(s, "i");
if (crc32("ytDdn",5) == 179668360) strcat(s, "i");
if (crc32("lRDMLKyuMmPosR",14) == 1046937921) strcat(s, "v");
if (crc32("ZypLSVtIv",9) == 2681991454) strcat(s, "m");
if (crc32("qhOPFrH",7) == 862153288) strcat(s, "i");
if (crc32("pBWDCRVAfSAz",12) == 680140642) strcat(s, "l");
if (crc32("xxPqoNoWYyIek",13) == 3789382875) strcat(s, "n");
if (crc32("WOLJxgwVK",9) == 551234790) strcat(s, "f");
if (crc32("qbPoFggLVkxvvj",14) == 3686807079) strcat(s, "i");
if (crc32("HXPZwB",6) == 136365793) strcat(s, "n");
if (crc32("AbFJzKDCa",9) == 1563656739) strcat(s, "g");
    return s;
}

char *relapsing_verbs() {
    char *s = calloc(10);
    if (crc32("vCryC",5) == 2135718666) strcat(s, "r");
if (crc32("oRKMyLQZfrWZzx",14) == 4086970163) strcat(s, "e");
if (crc32("kXphLXUS",8) == 980235079) strcat(s, "i");
if (crc32("AvCohVpblSS",11) == 1099433339) strcat(s, "l");
if (crc32("FzpTegpH",8) == 2603939261) strcat(s, "o");
if (crc32("USOjFnvE",8) == 3299904528) strcat(s, "a");
if (crc32("JhSUL",5) == 2181868930) strcat(s, "N");
if (crc32("ZoWfqQLSDkNnBTQ",15) == 2181518809) strcat(s, "p");
if (crc32("rDWdwSvJjmPLXnb",15) == 2290054683) strcat(s, "s");
if (crc32("AmKBEDMK",8) == 1381557754) strcat(s, "i");
if (crc32("PVxYpSG",7) == 907445489) strcat(s, "n");
if (crc32("rflBzngFcX",10) == 2321589169) strcat(s, "a");
if (crc32("OUAfZ",5) == 689132585) strcat(s, "g");
    return s;
}

char *homologizing_verbs() {
    char *s = calloc(13);
    if (crc32("ympWGzw",7) == 2442817392) strcat(s, "h");
if (crc32("QOCvhamiBjLAPD",14) == 238561962) strcat(s, "f");
if (crc32("humvkLgGAWZZzf",14) == 3640714363) strcat(s, "o");
if (crc32("zuoGpFKL",8) == 2717930290) strcat(s, "m");
if (crc32("dxAAyjtnHWhaPvV",15) == 4254617216) strcat(s, "m");
if (crc32("zaZTzWSEqureD",13) == 3377745638) strcat(s, "B");
if (crc32("LmZlkdbsCUN",11) == 1462518539) strcat(s, "o");
if (crc32("DsUTclI",7) == 2564522451) strcat(s, "l");
if (crc32("xLdjctDsBJ",10) == 3512747890) strcat(s, "o");
if (crc32("AGGhfaGLWKE",11) == 3587007426) strcat(s, "g");
if (crc32("AmRdTKHbQfehm",13) == 2211988238) strcat(s, "i");
if (crc32("UDpBwMmGmj",10) == 937691655) strcat(s, "z");
if (crc32("BxaIvpybNasLsUk",15) == 3473952043) strcat(s, "i");
if (crc32("CWlnoygtjMjpXtC",15) == 541394463) strcat(s, "n");
if (crc32("jgabIkIkyDho",12) == 4226203025) strcat(s, "w");
if (crc32("FnFhEejEoPegkW",14) == 1664370250) strcat(s, "g");
    return s;
}

char *expectorating_verbs() {
    char *s = calloc(14);
    if (crc32("PDDNtp",6) == 103175605) strcat(s, "P");
if (crc32("wilxwEDJbBbkEA",14) == 1301112885) strcat(s, "e");
if (crc32("LSMzhlcH",8) == 1738671140) strcat(s, "y");
if (crc32("BBmftkZFXs",10) == 1068611642) strcat(s, "x");
if (crc32("IGQOWNbirDtm",12) == 716031304) strcat(s, "p");
if (crc32("LFFAkkRUepUu",12) == 2545592781) strcat(s, "J");
if (crc32("EJzpAyQjioIotij",15) == 3151102182) strcat(s, "e");
if (crc32("CbAfltdVrh",10) == 414355261) strcat(s, "c");
if (crc32("aQFTA",5) == 3834735591) strcat(s, "H");
if (crc32("nhLwHXaMVR",10) == 3856011002) strcat(s, "t");
if (crc32("xlASl",5) == 3669676219) strcat(s, "o");
if (crc32("hpiWkhDl",8) == 221015982) strcat(s, "E");
if (crc32("qVwuP",5) == 2221657230) strcat(s, "r");
if (crc32("JelSnCkyzstjT",13) == 3432081885) strcat(s, "a");
if (crc32("tOudUhVBdGkrHM",14) == 1265334106) strcat(s, "v");
if (crc32("eCRtuh",6) == 3581247151) strcat(s, "t");
if (crc32("jOsvOvWqlo",10) == 3491828832) strcat(s, "S");
if (crc32("uHCpiXZlCbYEHs",14) == 3597165302) strcat(s, "i");
if (crc32("Fbqod",5) == 2100802866) strcat(s, "n");
if (crc32("EfWSAFni",8) == 664005408) strcat(s, "I");
if (crc32("oMHXGgqP",8) == 3024736686) strcat(s, "g");
    return s;
}

char *hypnotized_verbs() {
    char *s = calloc(11);
    if (crc32("KUezOWqGEl",10) == 1636999366) strcat(s, "r");
if (crc32("ylyElt",6) == 1063999061) strcat(s, "h");
if (crc32("cwoeby",6) == 656133803) strcat(s, "y");
if (crc32("kgaxxaDjJqrf",12) == 601427092) strcat(s, "p");
if (crc32("whXVanLyKiSt",12) == 3974523964) strcat(s, "n");
if (crc32("ezEfW",5) == 596314245) strcat(s, "o");
if (crc32("qduEDI",6) == 2896937722) strcat(s, "t");
if (crc32("GrXFJMUL",8) == 1051652236) strcat(s, "i");
if (crc32("LCNKWt",6) == 1661217157) strcat(s, "K");
if (crc32("sLgrHCeXotxqR",13) == 1541890494) strcat(s, "z");
if (crc32("lntQXQRvxm",10) == 293337830) strcat(s, "e");
if (crc32("yJHjdWtbAlBPpMj",15) == 1575554124) strcat(s, "d");
    return s;
}

char *darken_verbs() {
    char *s = calloc(7);
    if (crc32("EBjqRrpJwIusivJ",15) == 4173735532) strcat(s, "i");
if (crc32("jAPUWyAiedonXM",14) == 1233242273) strcat(s, "d");
if (crc32("zTbSaWYBSnYpbr",14) == 321014072) strcat(s, "a");
if (crc32("ignubAq",7) == 4104596848) strcat(s, "S");
if (crc32("qoCzbNNtWG",10) == 23018133) strcat(s, "r");
if (crc32("xYtsyJHppSZwbP",14) == 751909108) strcat(s, "k");
if (crc32("aliwtPUDrQ",10) == 1661813614) strcat(s, "L");
if (crc32("SvZkr",5) == 2934748252) strcat(s, "e");
if (crc32("xoyXuPe",7) == 624858205) strcat(s, "v");
if (crc32("kRVdrbrPYBKYSh",14) == 4051675482) strcat(s, "n");
    return s;
}

char *require_verbs() {
    char *s = calloc(8);
    if (crc32("zkDKiwigEmJao",13) == 3008489003) strcat(s, "l");
if (crc32("KSTuGo",6) == 3750656338) strcat(s, "r");
if (crc32("djHtl",5) == 2428846559) strcat(s, "h");
if (crc32("VvUIVNlyzgPhFTI",15) == 4159318558) strcat(s, "e");
if (crc32("mTyOLpO",7) == 1736123196) strcat(s, "q");
if (crc32("VGLxk",5) == 2032051102) strcat(s, "U");
if (crc32("oOfUTOQKviqAM",13) == 954352736) strcat(s, "u");
if (crc32("XjVnaJSQqd",10) == 2443877962) strcat(s, "h");
if (crc32("tnTJBJoRmPbdS",13) == 2469116896) strcat(s, "i");
if (crc32("ODuPG",5) == 3308754802) strcat(s, "v");
if (crc32("uIPlLzRA",8) == 29337183) strcat(s, "r");
if (crc32("UQCNvCjSU",9) == 924180625) strcat(s, "e");
    return s;
}

char *spicing_verbs() {
    char *s = calloc(8);
    if (crc32("bFtVVm",6) == 1828948009) strcat(s, "b");
if (crc32("mgqzZvRHiQOe",12) == 3409118631) strcat(s, "s");
if (crc32("JiNHnfNOBIzxcO",14) == 3217921505) strcat(s, "C");
if (crc32("KBraWAKvMN",10) == 180531627) strcat(s, "p");
if (crc32("QOZjrrMynznUpFY",15) == 2241346648) strcat(s, "i");
if (crc32("pQGHLO",6) == 444078169) strcat(s, "w");
if (crc32("nRqhStwjgK",10) == 1458645300) strcat(s, "c");
if (crc32("kjJzpshoyL",10) == 3019343352) strcat(s, "D");
if (crc32("yNPNtjNCwIIial",14) == 3482043923) strcat(s, "i");
if (crc32("ktvQOUdCwpOS",12) == 3630978439) strcat(s, "n");
if (crc32("ReGuIEQIXgt",11) == 2706468255) strcat(s, "g");
if (crc32("YstQtNa",7) == 3737375092) strcat(s, "g");
    return s;
}

char *hurrah_verbs() {
    char *s = calloc(7);
    if (crc32("dhhbTnTfwe",10) == 4290728858) strcat(s, "B");
if (crc32("ZBzAGejWi",9) == 2217644939) strcat(s, "h");
if (crc32("TaOvTcq",7) == 533594463) strcat(s, "u");
if (crc32("PNkYXBdeOzDIsBt",15) == 2472921085) strcat(s, "I");
if (crc32("neHohe",6) == 1597619971) strcat(s, "r");
if (crc32("ojsUvf",6) == 1437305588) strcat(s, "r");
if (crc32("rFWkqZ",6) == 2213645722) strcat(s, "x");
if (crc32("BpPAoAMNwPad",12) == 982341261) strcat(s, "a");
if (crc32("FBqQmh",6) == 607859045) strcat(s, "a");
if (crc32("NZvEUZo",7) == 154886887) strcat(s, "h");
    return s;
}

char *fimbriating_verbs() {
    char *s = calloc(12);
    if (crc32("VbsyTXoLppO",11) == 887425773) strcat(s, "f");
if (crc32("dqWoZrF",7) == 671140309) strcat(s, "i");
if (crc32("DLghIOFNnW",10) == 1927812754) strcat(s, "N");
if (crc32("IcxSW",5) == 2217305824) strcat(s, "m");
if (crc32("ElPJEYwEohMysLC",15) == 2254163632) strcat(s, "b");
if (crc32("udyiCdksSP",10) == 4198966696) strcat(s, "r");
if (crc32("bXWQU",5) == 4006700247) strcat(s, "A");
if (crc32("nRIVSrFmQrHOvHs",15) == 1800401098) strcat(s, "i");
if (crc32("uOvbFfYDba",10) == 2382293685) strcat(s, "Z");
if (crc32("bXrSk",5) == 938147332) strcat(s, "a");
if (crc32("NllcArdVM",9) == 1894142144) strcat(s, "p");
if (crc32("QZmVKQdjFh",10) == 761861264) strcat(s, "t");
if (crc32("iAOmmyfb",8) == 2478158602) strcat(s, "O");
if (crc32("QhGQjbOaCxOZc",13) == 671793954) strcat(s, "i");
if (crc32("ANErGJR",7) == 234821537) strcat(s, "w");
if (crc32("rguulfFch",9) == 1022109518) strcat(s, "n");
if (crc32("MITmLE",6) == 167638969) strcat(s, "g");
    return s;
}

char *burglarized_verbs() {
    char *s = calloc(12);
    if (crc32("euQQXCDVLcfgp",13) == 3386866738) strcat(s, "b");
if (crc32("IBrVukSAlzbWz",13) == 2995420686) strcat(s, "M");
if (crc32("FLNxQr",6) == 3376584569) strcat(s, "u");
if (crc32("iGqhHiYR",8) == 3047988062) strcat(s, "r");
if (crc32("IOMfRX",6) == 507206761) strcat(s, "c");
if (crc32("keuni",5) == 3104998174) strcat(s, "g");
if (crc32("cioShCUucrhZLJ",14) == 3444318433) strcat(s, "l");
if (crc32("lHAEVXjjqULfpNq",15) == 1352072262) strcat(s, "a");
if (crc32("bDXtjDrCbCSpMOB",15) == 910183743) strcat(s, "O");
if (crc32("KFFqDNaMaSzwlg",14) == 1770334404) strcat(s, "r");
if (crc32("JywIZJhdtOeFc",13) == 55567549) strcat(s, "i");
if (crc32("pdFTSyItRKUteKf",15) == 2111088740) strcat(s, "s");
if (crc32("DHCfWzlBSzALlv",14) == 3898033703) strcat(s, "z");
if (crc32("lhaCwh",6) == 3051878314) strcat(s, "e");
if (crc32("jDtVrZdtMlk",11) == 2688985442) strcat(s, "J");
if (crc32("yjSITwEr",8) == 14044008) strcat(s, "d");
    return s;
}

char *ammonolyzed_verbs() {
    char *s = calloc(12);
    if (crc32("mPTvz",5) == 3465382781) strcat(s, "a");
if (crc32("UKQGDzghlmbLFF",14) == 1778972242) strcat(s, "m");
if (crc32("uywnADHDAT",10) == 399926578) strcat(s, "m");
if (crc32("ecQlqNOfcLWdyL",14) == 186445949) strcat(s, "m");
if (crc32("AVSUvzTZSzuyDO",14) == 1655889505) strcat(s, "o");
if (crc32("ZpbctpgmXHXE",12) == 1468143092) strcat(s, "n");
if (crc32("HEatPOVMQHC",11) == 2944600515) strcat(s, "X");
if (crc32("inYxhdTsc",9) == 613315187) strcat(s, "o");
if (crc32("hRWNaYdB",8) == 1570392536) strcat(s, "l");
if (crc32("UiAlaMccQbzhl",13) == 2322891122) strcat(s, "v");
if (crc32("WRNHylnPZgitph",14) == 3863669101) strcat(s, "y");
if (crc32("bwndZprUjIpJrhu",15) == 3867408164) strcat(s, "y");
if (crc32("QONlUBgMG",9) == 965130252) strcat(s, "z");
if (crc32("UmVMyveETzDNtC",14) == 469916904) strcat(s, "e");
if (crc32("JeEsW",5) == 1562450138) strcat(s, "p");
if (crc32("mYhQsoDMEZP",11) == 1991292388) strcat(s, "d");
    return s;
}

char *carnified_verbs() {
    char *s = calloc(10);
    if (crc32("KrsEaxsAa",9) == 1971083361) strcat(s, "d");
if (crc32("LLceBbtwQhOAzfg",15) == 1101803185) strcat(s, "c");
if (crc32("XXDOoQneLRHcCvM",15) == 2754313076) strcat(s, "a");
if (crc32("IalrC",5) == 2739561561) strcat(s, "r");
if (crc32("kkxBPMRBFwneLx",14) == 2703519794) strcat(s, "u");
if (crc32("KrPiUAWnVuXYk",13) == 4185370918) strcat(s, "n");
if (crc32("wSRcLLhVF",9) == 3192949708) strcat(s, "w");
if (crc32("ImEjcUr",7) == 256638838) strcat(s, "i");
if (crc32("MIzCRVz",7) == 2569865200) strcat(s, "f");
if (crc32("hoEcvwafNEiPvPV",15) == 3310078549) strcat(s, "b");
if (crc32("pPxpUB",6) == 664209959) strcat(s, "i");
if (crc32("atBWHMquQxww",12) == 433588459) strcat(s, "E");
if (crc32("BmkqP",5) == 881913448) strcat(s, "e");
if (crc32("xDKFfo",6) == 761810464) strcat(s, "d");
    return s;
}

char *inherit_verbs() {
    char *s = calloc(8);
    if (crc32("DuwrXiWOyIh",11) == 3284760278) strcat(s, "r");
if (crc32("rNUhWEqVnWr",11) == 3975822004) strcat(s, "i");
if (crc32("uODTDJt",7) == 3549964550) strcat(s, "m");
if (crc32("nyWZzYKopIRzk",13) == 1379789967) strcat(s, "n");
if (crc32("zPtuQ",5) == 2744200332) strcat(s, "h");
if (crc32("hZvFvLeLZyRIb",13) == 4289785331) strcat(s, "x");
if (crc32("tUWrNuxHhYHL",12) == 124635890) strcat(s, "e");
if (crc32("dCuuozgeso",10) == 2714145471) strcat(s, "L");
if (crc32("NgcKK",5) == 1057137952) strcat(s, "r");
if (crc32("HOkafIhUSB",10) == 3647198123) strcat(s, "i");
if (crc32("hGkfHkOEqywZ",12) == 3526474342) strcat(s, "t");
    return s;
}

char *occur_verbs() {
    char *s = calloc(6);
    if (crc32("meviDiKZf",9) == 8008339) strcat(s, "o");
if (crc32("GTgdagP",7) == 474683618) strcat(s, "c");
if (crc32("wrpGJ",5) == 824621769) strcat(s, "c");
if (crc32("vEsUxcsKgY",10) == 3678892240) strcat(s, "u");
if (crc32("BUPEanLepw",10) == 2760546291) strcat(s, "v");
if (crc32("JzfEGWWhHGA",11) == 3571653186) strcat(s, "r");
    return s;
}

char *sculpt_verbs() {
    char *s = calloc(7);
    if (crc32("bkIIXHiN",8) == 1451378272) strcat(s, "s");
if (crc32("TrpUsenRDBlNf",13) == 1934307047) strcat(s, "c");
if (crc32("RFhjHUVtdZ",10) == 4217545258) strcat(s, "u");
if (crc32("RogelbRVoqZVx",13) == 800338579) strcat(s, "l");
if (crc32("FZYbwlQNNcnzDi",14) == 404853332) strcat(s, "p");
if (crc32("kIIki",5) == 66091817) strcat(s, "t");
    return s;
}

char *varityped_verbs() {
    char *s = calloc(10);
    if (crc32("IevXvPFgvohq",12) == 4181821201) strcat(s, "v");
if (crc32("GhGfK",5) == 1964991444) strcat(s, "a");
if (crc32("UTHnwKVgjyO",11) == 3841428675) strcat(s, "U");
if (crc32("MdKoHS",6) == 2884304894) strcat(s, "r");
if (crc32("kaSmGkuOunQq",12) == 4260300563) strcat(s, "i");
if (crc32("lQtGrGdZWxg",11) == 2407866389) strcat(s, "J");
if (crc32("WqjxmMYkWScobW",14) == 476284400) strcat(s, "t");
if (crc32("PhaZnRHvtMP",11) == 2678816793) strcat(s, "y");
if (crc32("CbflZelM",8) == 2013253163) strcat(s, "p");
if (crc32("IQOzuwhDNquo",12) == 1074102896) strcat(s, "e");
if (crc32("KAyKGqz",7) == 1418867046) strcat(s, "d");
    return s;
}

char *giftwrapt_verbs() {
    char *s = calloc(10);
    if (crc32("viQVakNyA",9) == 1292651376) strcat(s, "B");
if (crc32("MRHOFRVJHl",10) == 3897332882) strcat(s, "g");
if (crc32("WzgcltazY",9) == 993447530) strcat(s, "i");
if (crc32("VpZbwqNgdALmlw",14) == 2334896200) strcat(s, "f");
if (crc32("INRNvjkoiCAvPk",14) == 2120814520) strcat(s, "i");
if (crc32("sLHraBHAXOvAD",13) == 871338072) strcat(s, "t");
if (crc32("HkKkJmmtVZY",11) == 2697892618) strcat(s, "G");
if (crc32("QUXZMiXRKxEnei",14) == 405507204) strcat(s, "w");
if (crc32("PDyvYGsR",8) == 2555966755) strcat(s, "r");
if (crc32("cEbVNJngFHmsJGy",15) == 2287869836) strcat(s, "a");
if (crc32("vhjIm",5) == 2717541474) strcat(s, "k");
if (crc32("noxjXVFgyHd",11) == 3513357163) strcat(s, "p");
if (crc32("FRvOEuKm",8) == 2363063626) strcat(s, "J");
if (crc32("CCRcJqqWnOry",12) == 2272094129) strcat(s, "t");
    return s;
}

char *cloturing_verbs() {
    char *s = calloc(10);
    if (crc32("vdRngf",6) == 2029852584) strcat(s, "e");
if (crc32("gtmKJPPyB",9) == 2855416794) strcat(s, "c");
if (crc32("BmHTKlaSgTI",11) == 2902683379) strcat(s, "l");
if (crc32("iNwbEIhUhQ",10) == 1297041537) strcat(s, "o");
if (crc32("hbOOeaucGgO",11) == 513391744) strcat(s, "t");
if (crc32("lWvvkvXFOIvyrQ",14) == 1792037806) strcat(s, "u");
if (crc32("snjmOcZ",7) == 3597955491) strcat(s, "r");
if (crc32("SrLdQctnmfTKE",13) == 2554715390) strcat(s, "Z");
if (crc32("ZBqoOyj",7) == 3622989006) strcat(s, "i");
if (crc32("mQvxfdAvvnY",11) == 3010246254) strcat(s, "n");
if (crc32("ZZBPJdYy",8) == 2771719698) strcat(s, "g");
    return s;
}

char *stooged_verbs() {
    char *s = calloc(8);
    if (crc32("XYifrsR",7) == 4206508705) strcat(s, "s");
if (crc32("hlPqC",5) == 4181058688) strcat(s, "h");
if (crc32("EseNjxROjoZEC",13) == 309949402) strcat(s, "t");
if (crc32("vawkovTEAz",10) == 3735482659) strcat(s, "V");
if (crc32("CBAphAflgwZvRSE",15) == 1196988466) strcat(s, "o");
if (crc32("hfFVlOPxjsXNV",13) == 3154636492) strcat(s, "o");
if (crc32("OWoiRxhDODw",11) == 3159008476) strcat(s, "V");
if (crc32("icGJASoPXRl",11) == 1850708174) strcat(s, "g");
if (crc32("EKUTv",5) == 400711450) strcat(s, "e");
if (crc32("JDnYPXeMaVAIK",13) == 1354629746) strcat(s, "D");
if (crc32("vAXyHRQQbKZQboR",15) == 3163622597) strcat(s, "d");
    return s;
}

char *deputizing_verbs() {
    char *s = calloc(11);
    if (crc32("tOQDOy",6) == 2714302053) strcat(s, "d");
if (crc32("oYyaRBuwyYlg",12) == 2447445926) strcat(s, "M");
if (crc32("vsysWSfANqWdgrd",15) == 844476833) strcat(s, "e");
if (crc32("OKFPnLbPJ",9) == 681675338) strcat(s, "p");
if (crc32("YEWvrmQQKiseZpF",15) == 744912409) strcat(s, "Z");
if (crc32("nxcmBqVNYuhm",12) == 251663963) strcat(s, "u");
if (crc32("CynWyjOcjhVq",12) == 1842866690) strcat(s, "H");
if (crc32("VJVQyepJJ",9) == 3902740342) strcat(s, "t");
if (crc32("BnVNbLav",8) == 531093760) strcat(s, "m");
if (crc32("xzWuTYfvtjYeTr",14) == 1668743054) strcat(s, "i");
if (crc32("BgljXeafCP",10) == 3503528912) strcat(s, "P");
if (crc32("FmOtSAWMMre",11) == 901093332) strcat(s, "z");
if (crc32("tSKseAbUndbLD",13) == 2433387002) strcat(s, "i");
if (crc32("CtvTZNxPjYMv",12) == 1771925235) strcat(s, "X");
if (crc32("dEWUmaIWEh",10) == 3493693738) strcat(s, "n");
if (crc32("KWRKCPypzVE",11) == 3100959303) strcat(s, "g");
    return s;
}

char *knockoff_verbs() {
    char *s = calloc(9);
    if (crc32("mndsWu",6) == 3171593191) strcat(s, "T");
if (crc32("HXJzGwMyWPyElMo",15) == 2476444018) strcat(s, "k");
if (crc32("mmxkg",5) == 2024279712) strcat(s, "H");
if (crc32("hjRgzPqMfAlQ",12) == 2793047215) strcat(s, "n");
if (crc32("McdSuzQHihw",11) == 4258581735) strcat(s, "o");
if (crc32("TuOseW",6) == 610050007) strcat(s, "J");
if (crc32("GLAofx",6) == 868657237) strcat(s, "c");
if (crc32("xcOYCq",6) == 3563922346) strcat(s, "k");
if (crc32("ErJGVRA",7) == 2992130700) strcat(s, "T");
if (crc32("bwLjaBwsQfDwWM",14) == 540439580) strcat(s, "o");
if (crc32("UfcjnQwyYJgIL",13) == 157369851) strcat(s, "f");
if (crc32("TBPfT",5) == 404170767) strcat(s, "o");
if (crc32("FUxZs",5) == 1056442836) strcat(s, "f");
    return s;
}

char *checkmating_verbs() {
    char *s = calloc(12);
    if (crc32("nsWXPKmqGSP",11) == 3085273968) strcat(s, "i");
if (crc32("trPBvIKdgtTMxlu",15) == 821304888) strcat(s, "c");
if (crc32("XvDya",5) == 1492204297) strcat(s, "D");
if (crc32("UkTLXP",6) == 663032898) strcat(s, "h");
if (crc32("RgOTJshLpOd",11) == 3568036704) strcat(s, "e");
if (crc32("QGEMRNW",7) == 120786034) strcat(s, "c");
if (crc32("mmajF",5) == 2091282277) strcat(s, "J");
if (crc32("fyfuZc",6) == 1127565314) strcat(s, "k");
if (crc32("GjvEo",5) == 2014689096) strcat(s, "m");
if (crc32("UQNDw",5) == 3396979436) strcat(s, "E");
if (crc32("jFTRQ",5) == 1418414024) strcat(s, "a");
if (crc32("lleiaboOgd",10) == 1285149834) strcat(s, "t");
if (crc32("nKhCmwZao",9) == 3489659793) strcat(s, "o");
if (crc32("OvTAONXDwr",10) == 2181082644) strcat(s, "i");
if (crc32("IixaCEnMvsIV",12) == 3421304830) strcat(s, "n");
if (crc32("TSODsDnVFi",10) == 1494470775) strcat(s, "g");
    return s;
}

char *handled_verbs() {
    char *s = calloc(8);
    if (crc32("uknbaDhZjPgSt",13) == 1186291418) strcat(s, "h");
if (crc32("jxXjea",6) == 351242819) strcat(s, "V");
if (crc32("ETdfkh",6) == 515563447) strcat(s, "a");
if (crc32("mtJUJaOcVYhitf",14) == 1926048619) strcat(s, "n");
if (crc32("CSqJDUfiQrEZb",13) == 4198225224) strcat(s, "d");
if (crc32("txINS",5) == 2267606507) strcat(s, "l");
if (crc32("jrrcwD",6) == 2604393692) strcat(s, "h");
if (crc32("szJZePwT",8) == 3216599874) strcat(s, "e");
if (crc32("uGkuPVvtBjAh",12) == 2971699980) strcat(s, "d");
    return s;
}

char *archaized_verbs() {
    char *s = calloc(10);
    if (crc32("PlxXIFWBUX",10) == 4145699156) strcat(s, "a");
if (crc32("LnPyLsORNsC",11) == 2647603148) strcat(s, "r");
if (crc32("KfxfQfKMGV",10) == 1932812869) strcat(s, "q");
if (crc32("EVtwKbTWkpwk",12) == 1598296040) strcat(s, "c");
if (crc32("tTnbcNgZ",8) == 2374881577) strcat(s, "a");
if (crc32("AaCBZi",6) == 1595008200) strcat(s, "h");
if (crc32("bLUGhvshWsXl",12) == 409574099) strcat(s, "a");
if (crc32("OcewSQESJdn",11) == 3998485043) strcat(s, "i");
if (crc32("LkvOzhRAOX",10) == 1622193503) strcat(s, "z");
if (crc32("POsnOGDtN",9) == 4200364896) strcat(s, "e");
if (crc32("mFQIa",5) == 1871684101) strcat(s, "d");
    return s;
}

char *horsewhipped_verbs() {
    char *s = calloc(13);
    if (crc32("kNmIJxJlxkg",11) == 1083826275) strcat(s, "h");
if (crc32("BNNYzodvvD",10) == 3103324849) strcat(s, "h");
if (crc32("KjsUuIGgtK",10) == 4037406969) strcat(s, "o");
if (crc32("KbivJGAosZDgp",13) == 1654266035) strcat(s, "c");
if (crc32("lNAdTm",6) == 2828358075) strcat(s, "r");
if (crc32("CiTAiEsRU",9) == 2116971001) strcat(s, "P");
if (crc32("hCPcCpYEe",9) == 2898452466) strcat(s, "s");
if (crc32("xvvMtLFYv",9) == 1595086225) strcat(s, "A");
if (crc32("CLCuGpHAAMyUzlz",15) == 732290680) strcat(s, "e");
if (crc32("GsWAzfBPKIeIT",13) == 1401909162) strcat(s, "d");
if (crc32("NNHjvSDNC",9) == 1263790424) strcat(s, "w");
if (crc32("TczrCT",6) == 485135154) strcat(s, "h");
if (crc32("UBfkRd",6) == 1462707527) strcat(s, "i");
if (crc32("kCkJZbOOPe",10) == 828209984) strcat(s, "p");
if (crc32("USFnNscyoalRtH",14) == 1282753861) strcat(s, "R");
if (crc32("FLtRGgUaqKVyeK",14) == 2677394078) strcat(s, "p");
if (crc32("oBtxG",5) == 3889135118) strcat(s, "t");
if (crc32("qTnqHiBGLO",10) == 3549377914) strcat(s, "e");
if (crc32("wwXuzLn",7) == 1504082390) strcat(s, "d");
    return s;
}

char *expatriating_verbs() {
    char *s = calloc(13);
    if (crc32("JxjoS",5) == 636660748) strcat(s, "g");
if (crc32("CzpXMMVCoVDI",12) == 3720807290) strcat(s, "e");
if (crc32("BEdlGJdzBX",10) == 3216274140) strcat(s, "x");
if (crc32("bWnaeQJk",8) == 910345128) strcat(s, "p");
if (crc32("DzndSGC",7) == 734023882) strcat(s, "a");
if (crc32("HRsUbvIqCBkQCE",14) == 3988038565) strcat(s, "H");
if (crc32("Vqamke",6) == 3622005912) strcat(s, "t");
if (crc32("gGaNG",5) == 614738795) strcat(s, "r");
if (crc32("xSzFkrkVvP",10) == 1576445742) strcat(s, "A");
if (crc32("WJihIGSsBt",10) == 1555035350) strcat(s, "i");
if (crc32("UnUtHwUFFsS",11) == 3926744938) strcat(s, "f");
if (crc32("KgcQoZmiJ",9) == 3230106293) strcat(s, "a");
if (crc32("ynhEZ",5) == 1582885315) strcat(s, "l");
if (crc32("pKoCzD",6) == 540738819) strcat(s, "t");
if (crc32("BQUua",5) == 2081168311) strcat(s, "T");
if (crc32("jPbQmxH",7) == 4052347623) strcat(s, "i");
if (crc32("cICxzYSe",8) == 3171011737) strcat(s, "G");
if (crc32("FOWPKCrrqDkRy",13) == 1268813596) strcat(s, "n");
if (crc32("SiMcEjQZeA",10) == 3463658224) strcat(s, "g");
    return s;
}

char *wrung_verbs() {
    char *s = calloc(6);
    if (crc32("jWNjZCePgVU",11) == 2078884318) strcat(s, "Q");
if (crc32("hvrQWd",6) == 815430585) strcat(s, "w");
if (crc32("GmyklR",6) == 313574733) strcat(s, "i");
if (crc32("OaRymmusr",9) == 600428662) strcat(s, "r");
if (crc32("kjLGnwTlKvTv",12) == 4071637555) strcat(s, "u");
if (crc32("ehpqocbR",8) == 485967187) strcat(s, "D");
if (crc32("jOojwyzHqmVz",12) == 3343070924) strcat(s, "n");
if (crc32("ElQeMlKASvCoPaF",15) == 3207105167) strcat(s, "g");
    return s;
}

char *attenuating_verbs() {
    char *s = calloc(12);
    if (crc32("gfCHYKPFghsYw",13) == 262267580) strcat(s, "a");
if (crc32("SfhwgmEGWEycnqm",15) == 2786401738) strcat(s, "A");
if (crc32("aIhavf",6) == 1304044418) strcat(s, "t");
if (crc32("yHcOiTpso",9) == 1501750748) strcat(s, "t");
if (crc32("jDQBzQLwHNdbSl",14) == 4086207638) strcat(s, "C");
if (crc32("yINVOrrmqaHG",12) == 142879786) strcat(s, "e");
if (crc32("sFZNNElgo",9) == 2379558264) strcat(s, "K");
if (crc32("emYJaOpMxRz",11) == 695020677) strcat(s, "n");
if (crc32("tAhXKpWYC",9) == 1605815258) strcat(s, "u");
if (crc32("PtWLyMESvPy",11) == 1549677516) strcat(s, "K");
if (crc32("nltzERwh",8) == 794929218) strcat(s, "a");
if (crc32("JzKyDc",6) == 4227352263) strcat(s, "t");
if (crc32("YFxFnUwNBF",10) == 2942741464) strcat(s, "K");
if (crc32("vYjcaXhuzeVIEvt",15) == 820515014) strcat(s, "i");
if (crc32("bzVBpVabwMzqQ",13) == 169206607) strcat(s, "H");
if (crc32("WmARCwkFnomiDx",14) == 2009002265) strcat(s, "n");
if (crc32("mxHFYh",6) == 2618420032) strcat(s, "x");
if (crc32("SFShU",5) == 3744567770) strcat(s, "g");
    return s;
}

char *seized_verbs() {
    char *s = calloc(7);
    if (crc32("yGiUiDnAmANaFn",14) == 2414965635) strcat(s, "s");
if (crc32("oxEHqfBXlK",10) == 1446114175) strcat(s, "j");
if (crc32("HKUsTqmfMigelyn",15) == 3387062859) strcat(s, "e");
if (crc32("OOwPh",5) == 3506698602) strcat(s, "k");
if (crc32("RnisfXxu",8) == 2202696061) strcat(s, "i");
if (crc32("CCARsPNDlRYf",12) == 370516907) strcat(s, "z");
if (crc32("FluJlzO",7) == 1919187139) strcat(s, "e");
if (crc32("znyNa",5) == 2715217881) strcat(s, "d");
    return s;
}

char *tissued_verbs() {
    char *s = calloc(8);
    if (crc32("bYwJau",6) == 378662190) strcat(s, "t");
if (crc32("SaSkiKoCPN",10) == 2453143077) strcat(s, "i");
if (crc32("zWzncj",6) == 2636820566) strcat(s, "b");
if (crc32("qHFdNDlUCsCDcp",14) == 1560015150) strcat(s, "s");
if (crc32("DazRe",5) == 83418741) strcat(s, "s");
if (crc32("zCyOSiqBKA",10) == 3992971856) strcat(s, "q");
if (crc32("ChOzwLjwNv",10) == 2424635212) strcat(s, "u");
if (crc32("xXwOdYZF",8) == 3471516781) strcat(s, "e");
if (crc32("LDQtUaS",7) == 3826421139) strcat(s, "V");
if (crc32("RfXmNJEagthmW",13) == 2431183315) strcat(s, "d");
    return s;
}

char *whipin_verbs() {
    char *s = calloc(7);
    if (crc32("bmuXWLjxfbmjjYO",15) == 2820850411) strcat(s, "w");
if (crc32("fiINCVXCI",9) == 2782651579) strcat(s, "h");
if (crc32("vFieUbwUhv",10) == 3111101220) strcat(s, "p");
if (crc32("lDOOJjE",7) == 3100510274) strcat(s, "i");
if (crc32("RWpCAYbGr",9) == 3869145098) strcat(s, "q");
if (crc32("FgReaJIkWHNI",12) == 89596524) strcat(s, "p");
if (crc32("hqrAkMZzj",9) == 1854248526) strcat(s, "T");
if (crc32("xdQxGHbFFVoZvY",14) == 2385458147) strcat(s, "i");
if (crc32("vTFdhkjWjeDbTN",14) == 4106612786) strcat(s, "e");
if (crc32("LmNRbrb",7) == 3649894840) strcat(s, "n");
    return s;
}

char *retestifying_verbs() {
    char *s = calloc(13);
    if (crc32("vWftpCSY",8) == 2706525901) strcat(s, "r");
if (crc32("BaNFFMdqedsrc",13) == 940178951) strcat(s, "C");
if (crc32("XyJbyWwh",8) == 2347990717) strcat(s, "e");
if (crc32("TnoNnXooBxkCG",13) == 1455576619) strcat(s, "t");
if (crc32("jzUgKWHsBJCKzy",14) == 3706224111) strcat(s, "t");
if (crc32("xjJMqwrgJW",10) == 1553857828) strcat(s, "t");
if (crc32("yxcvKnYavB",10) == 776718800) strcat(s, "e");
if (crc32("sogUuXrZkm",10) == 2423653290) strcat(s, "s");
if (crc32("yiMijAZrGxDOPMa",15) == 1910433742) strcat(s, "g");
if (crc32("jmVsZl",6) == 3314426041) strcat(s, "t");
if (crc32("pUEMviRUmheHKB",14) == 319973200) strcat(s, "i");
if (crc32("BoeyAU",6) == 1300981129) strcat(s, "f");
if (crc32("ESyBMRYs",8) == 3020081075) strcat(s, "d");
if (crc32("hpwCjvAaPThCR",13) == 997582129) strcat(s, "y");
if (crc32("PdVaseakHTjIWOW",15) == 2118933484) strcat(s, "i");
if (crc32("cjoRv",5) == 1045137957) strcat(s, "n");
if (crc32("PKbcpfFIkre",11) == 1051439797) strcat(s, "g");
    return s;
}

char *reknot_verbs() {
    char *s = calloc(7);
    if (crc32("YlROKyZGuIYKnwz",15) == 455445281) strcat(s, "J");
if (crc32("PjtsuVxgCjsUj",13) == 63042981) strcat(s, "r");
if (crc32("aPGAcvYwPloJ",12) == 1242625304) strcat(s, "e");
if (crc32("HFYefGE",7) == 4289101013) strcat(s, "k");
if (crc32("zKVjTV",6) == 4018533900) strcat(s, "X");
if (crc32("APlAM",5) == 3363764331) strcat(s, "n");
if (crc32("aklWxfCflGItClL",15) == 1409658216) strcat(s, "Z");
if (crc32("RDvtxHmQvUeI",12) == 301805982) strcat(s, "o");
if (crc32("IzxeUPMC",8) == 2535853593) strcat(s, "t");
    return s;
}

char *unbalancing_verbs() {
    char *s = calloc(12);
    if (crc32("oPzOVPEUzYnyqE",14) == 1874220145) strcat(s, "k");
if (crc32("tihOpMXxYMen",12) == 1747940784) strcat(s, "u");
if (crc32("IdzDdAtasrnDNN",14) == 2383662085) strcat(s, "e");
if (crc32("DXLPUGwluKdUck",14) == 2800920111) strcat(s, "n");
if (crc32("LSqNym",6) == 3532809926) strcat(s, "b");
if (crc32("FqQshXBuICjHyv",14) == 3135410284) strcat(s, "Y");
if (crc32("OBIrJicvFHwnoY",14) == 1303806050) strcat(s, "a");
if (crc32("LuxLFlCbR",9) == 2756983342) strcat(s, "P");
if (crc32("niOoLKLxapt",11) == 2831804660) strcat(s, "l");
if (crc32("EdAsVQLDpAfk",12) == 1949450096) strcat(s, "S");
if (crc32("fjsskSzOuGPRwnr",15) == 3894465633) strcat(s, "a");
if (crc32("sfONRLcOcg",10) == 638726813) strcat(s, "n");
if (crc32("ysHsoAOrFVl",11) == 3399397620) strcat(s, "c");
if (crc32("PUNxAjFO",8) == 2612129665) strcat(s, "i");
if (crc32("jfIoqVqSpFQ",11) == 3784126407) strcat(s, "G");
if (crc32("bQZkGlYSjddrc",13) == 2505641734) strcat(s, "n");
if (crc32("yXFwq",5) == 254938375) strcat(s, "g");
    return s;
}

char *outswum_verbs() {
    char *s = calloc(8);
    if (crc32("sUPLLkeT",8) == 1179778046) strcat(s, "o");
if (crc32("jOGjvBpFKQv",11) == 34714543) strcat(s, "r");
if (crc32("xdGPrZbHcWsQo",13) == 3346209275) strcat(s, "u");
if (crc32("PAWTthwkP",9) == 1310527197) strcat(s, "t");
if (crc32("oObOLEcnUoTJBok",15) == 759096226) strcat(s, "l");
if (crc32("VDslQmwTvCFw",12) == 2511885583) strcat(s, "s");
if (crc32("uPvBflGMxQgx",12) == 3684345226) strcat(s, "h");
if (crc32("qhKrLIVJI",9) == 344021817) strcat(s, "w");
if (crc32("eobTlBLdjUhxlI",14) == 2678398124) strcat(s, "F");
if (crc32("ygrqn",5) == 1598685903) strcat(s, "u");
if (crc32("YaaZsYYhmF",10) == 1911537637) strcat(s, "m");
    return s;
}

char *respread_verbs() {
    char *s = calloc(9);
    if (crc32("WYtULMbveE",10) == 3963785736) strcat(s, "l");
if (crc32("mPTnFgC",7) == 3700887471) strcat(s, "r");
if (crc32("clmyUEq",7) == 4025093244) strcat(s, "e");
if (crc32("bYeMRYoblgZT",12) == 4222199113) strcat(s, "W");
if (crc32("JSsMFlTvKh",10) == 3891953896) strcat(s, "s");
if (crc32("DlnbxrGCphBxR",13) == 3379322296) strcat(s, "Y");
if (crc32("cCtiQmS",7) == 2882362977) strcat(s, "p");
if (crc32("YUKWXkDySN",10) == 2686142281) strcat(s, "P");
if (crc32("QrznpUvvAPiOkC",14) == 4276122847) strcat(s, "r");
if (crc32("ixGostqnVFFGP",13) == 1266066350) strcat(s, "e");
if (crc32("BlnrgeTasGIxf",13) == 1058374622) strcat(s, "a");
if (crc32("LUXvoxjlGXETtT",14) == 2399364330) strcat(s, "u");
if (crc32("fRLVBf",6) == 4073819426) strcat(s, "d");
    return s;
}

char *allying_verbs() {
    char *s = calloc(8);
    if (crc32("XjHabVfU",8) == 1522988701) strcat(s, "a");
if (crc32("zbrwPAMBSc",10) == 2174628472) strcat(s, "l");
if (crc32("YVIxOtm",7) == 151535953) strcat(s, "l");
if (crc32("pOoAqETpZoJrZD",14) == 4126727458) strcat(s, "I");
if (crc32("PGcicYRqf",9) == 3086790007) strcat(s, "y");
if (crc32("klJBqwjiN",9) == 304165894) strcat(s, "Z");
if (crc32("BNCaAuvnpk",10) == 3912403739) strcat(s, "i");
if (crc32("LwbhrQgkgCDi",12) == 1335766545) strcat(s, "n");
if (crc32("ETjaZ",5) == 2688947243) strcat(s, "g");
    return s;
}

char *podsolized_verbs() {
    char *s = calloc(11);
    if (crc32("rQCJprkQff",10) == 2150252297) strcat(s, "E");
if (crc32("wlrDCXhng",9) == 1698147232) strcat(s, "p");
if (crc32("RjOJwvBGoi",10) == 1972781630) strcat(s, "o");
if (crc32("CbHRnDiNI",9) == 2695195600) strcat(s, "n");
if (crc32("MrIzMzt",7) == 1438721799) strcat(s, "d");
if (crc32("arHTqWykUHSlEv",14) == 1005436514) strcat(s, "S");
if (crc32("TWYEsxQHV",9) == 3097734807) strcat(s, "s");
if (crc32("nGORHUElCenyFzr",15) == 3189798128) strcat(s, "J");
if (crc32("oqUsXPUXgKNcLy",14) == 75032083) strcat(s, "o");
if (crc32("DNtHiOvertKT",12) == 543704588) strcat(s, "V");
if (crc32("CxrYceWHSytDet",14) == 1640071776) strcat(s, "l");
if (crc32("VVoCx",5) == 1494676701) strcat(s, "i");
if (crc32("pgZwB",5) == 2236354546) strcat(s, "b");
if (crc32("vAJBODzLSjNk",12) == 2176431769) strcat(s, "z");
if (crc32("eGKhQOGWXZfDeY",14) == 1794575230) strcat(s, "x");
if (crc32("HlAVDoHH",8) == 3074526426) strcat(s, "e");
if (crc32("pPBioQXJ",8) == 3594896661) strcat(s, "d");
    return s;
}

char *recelebrate_verbs() {
    char *s = calloc(12);
    if (crc32("FrJQqMuXY",9) == 494851203) strcat(s, "r");
if (crc32("jRzqFkuhSNYWTtp",15) == 1545002147) strcat(s, "T");
if (crc32("wyHymkJgboWIed",14) == 4186010267) strcat(s, "e");
if (crc32("eYipNmg",7) == 3925807480) strcat(s, "c");
if (crc32("gMUHlmi",7) == 3869394762) strcat(s, "Z");
if (crc32("YcJyMufHSBlyK",13) == 814542318) strcat(s, "e");
if (crc32("ykoCd",5) == 1067018319) strcat(s, "U");
if (crc32("DBkplOIWRHqgQOa",15) == 4151766308) strcat(s, "l");
if (crc32("uXhuofiMf",9) == 456708263) strcat(s, "C");
if (crc32("RMywjAUAw",9) == 3669763287) strcat(s, "e");
if (crc32("amvSeIsGQdXbG",13) == 3921871582) strcat(s, "k");
if (crc32("QaLRTMQPntT",11) == 201927188) strcat(s, "b");
if (crc32("MDPpIgBnqqs",11) == 2830859327) strcat(s, "r");
if (crc32("VtXGzFjSK",9) == 4126738890) strcat(s, "a");
if (crc32("EMgsYaEcs",9) == 2546461848) strcat(s, "s");
if (crc32("AVPzmhXy",8) == 2882509452) strcat(s, "t");
if (crc32("OynGlJpi",8) == 3565582138) strcat(s, "v");
if (crc32("wGSxfgX",7) == 1955636563) strcat(s, "e");
    return s;
}

char *unplug_verbs() {
    char *s = calloc(7);
    if (crc32("VpMoA",5) == 3632041097) strcat(s, "n");
if (crc32("alUtXd",6) == 3107891729) strcat(s, "u");
if (crc32("dHuyLgcFptBe",12) == 3737845620) strcat(s, "n");
if (crc32("rEwghvtIXjvecNx",15) == 993511942) strcat(s, "S");
if (crc32("UVscPyJ",7) == 2784982263) strcat(s, "p");
if (crc32("NsjOMNKLoy",10) == 2959524450) strcat(s, "M");
if (crc32("hnPYMB",6) == 100855505) strcat(s, "l");
if (crc32("cptWwTxXGkSWpj",14) == 1999793074) strcat(s, "u");
if (crc32("PNsOBP",6) == 3506333166) strcat(s, "u");
if (crc32("JzdSay",6) == 602018564) strcat(s, "g");
    return s;
}

char *tripled_verbs() {
    char *s = calloc(8);
    if (crc32("FaeUKiKlwkE",11) == 267606641) strcat(s, "f");
if (crc32("WwoCIBcT",8) == 1110161301) strcat(s, "t");
if (crc32("mfQxl",5) == 3072892882) strcat(s, "t");
if (crc32("nRZDxRpYQz",10) == 3122846130) strcat(s, "r");
if (crc32("AiezepxUugsllDx",15) == 1929317483) strcat(s, "h");
if (crc32("vzMlGtMSlyQ",11) == 4286235812) strcat(s, "i");
if (crc32("DKyJO",5) == 2425454329) strcat(s, "p");
if (crc32("DWLNdJviLEuf",12) == 661267226) strcat(s, "l");
if (crc32("iIsACDyUinm",11) == 1760098699) strcat(s, "e");
if (crc32("rowFIKX",7) == 3821166986) strcat(s, "d");
    return s;
}

char *tore_verbs() {
    char *s = calloc(5);
    if (crc32("dScQYXBoKnR",11) == 879575141) strcat(s, "R");
if (crc32("eXDayDnozNsaJhR",15) == 3863077522) strcat(s, "t");
if (crc32("TaLUjZ",6) == 764839334) strcat(s, "o");
if (crc32("IVKTorIMqFku",12) == 3162821195) strcat(s, "r");
if (crc32("hLRDtLm",7) == 926783818) strcat(s, "r");
if (crc32("bDYkpZYlqb",10) == 1844444870) strcat(s, "e");
    return s;
}

char *consubstantiating_verbs() {
    char *s = calloc(18);
    if (crc32("UNFFSt",6) == 114594798) strcat(s, "c");
if (crc32("YebxejjXdpG",11) == 1998157720) strcat(s, "o");
if (crc32("FXgjPr",6) == 2275475664) strcat(s, "n");
if (crc32("WkGoeXPOskBMs",13) == 497955799) strcat(s, "s");
if (crc32("XtbbxKEbr",9) == 85759101) strcat(s, "F");
if (crc32("sNenKNKozZtOvu",14) == 3573894441) strcat(s, "u");
if (crc32("kmReWH",6) == 280371477) strcat(s, "b");
if (crc32("rotqEjfO",8) == 2665907705) strcat(s, "s");
if (crc32("IxeHDGoSkuxv",12) == 187307242) strcat(s, "h");
if (crc32("nwOJhluePKPfY",13) == 3634851404) strcat(s, "t");
if (crc32("BKeFmQzc",8) == 1648739005) strcat(s, "a");
if (crc32("isdBUl",6) == 1691998390) strcat(s, "n");
if (crc32("JLTpLMzpclLSuT",14) == 2279121877) strcat(s, "b");
if (crc32("uYFkI",5) == 3154862752) strcat(s, "t");
if (crc32("UvIRRtMZoeOSA",13) == 3223587992) strcat(s, "i");
if (crc32("cRPvpDM",7) == 2097091998) strcat(s, "Z");
if (crc32("XrxvqmdAKGz",11) == 3091868669) strcat(s, "a");
if (crc32("jmhlFmag",8) == 659400907) strcat(s, "t");
if (crc32("dDypvPFVxtG",11) == 2385388389) strcat(s, "B");
if (crc32("WMVdLcfsev",10) == 875655447) strcat(s, "i");
if (crc32("OudkkdDF",8) == 1188889700) strcat(s, "o");
if (crc32("wZfHx",5) == 54833045) strcat(s, "n");
if (crc32("Dnmqhz",6) == 2189587649) strcat(s, "g");
    return s;
}

char *overmodernized_verbs() {
    char *s = calloc(15);
    if (crc32("WZeQG",5) == 3987061485) strcat(s, "o");
if (crc32("lBrLDEqRe",9) == 3504404212) strcat(s, "o");
if (crc32("RbvuJPdEOUigNt",14) == 3102911303) strcat(s, "v");
if (crc32("VgHUMNtjlwDq",12) == 2227414933) strcat(s, "g");
if (crc32("yiCHHI",6) == 3376807684) strcat(s, "e");
if (crc32("kdreAUNpiLh",11) == 3963681255) strcat(s, "r");
if (crc32("IGpVC",5) == 3974535479) strcat(s, "Y");
if (crc32("BTorte",6) == 2088374657) strcat(s, "m");
if (crc32("wNiGnfaZko",10) == 847169287) strcat(s, "o");
if (crc32("TicTXQbXwlkDr",13) == 4061763107) strcat(s, "d");
if (crc32("ivdCGCGCzMPQgZ",14) == 1303820693) strcat(s, "e");
if (crc32("LJjZztVSN",9) == 1447660334) strcat(s, "t");
if (crc32("tssYCSxP",8) == 1138466128) strcat(s, "r");
if (crc32("sDwhDTJ",7) == 1577626435) strcat(s, "n");
if (crc32("RAteGudcd",9) == 3798466514) strcat(s, "i");
if (crc32("voLmxv",6) == 2504250374) strcat(s, "X");
if (crc32("ETSRhkCTuTJN",12) == 2008241040) strcat(s, "z");
if (crc32("QktMImHTL",9) == 3941240117) strcat(s, "T");
if (crc32("lzUlFtvpzM",10) == 239569615) strcat(s, "e");
if (crc32("cwIobvGuQ",9) == 2601783450) strcat(s, "d");
    return s;
}

char *forsaken_verbs() {
    char *s = calloc(9);
    if (crc32("uHkrfPWOhPJEXBB",15) == 1681146621) strcat(s, "f");
if (crc32("GWesjHAYPbtvFP",14) == 62841455) strcat(s, "c");
if (crc32("IbDajKbnBsy",11) == 2686994431) strcat(s, "o");
if (crc32("cxNOqtwuO",9) == 3541222564) strcat(s, "r");
if (crc32("CwYJxXpstPn",11) == 2871693456) strcat(s, "M");
if (crc32("jxvlbXt",7) == 1021338522) strcat(s, "s");
if (crc32("gLnuRBIc",8) == 3039672948) strcat(s, "v");
if (crc32("DYfDgkxRhMIMn",13) == 2269787783) strcat(s, "a");
if (crc32("OHBITmMyd",9) == 2725526460) strcat(s, "R");
if (crc32("XThPPhqwt",9) == 4003219677) strcat(s, "k");
if (crc32("kgmKHLfyUARzQkD",15) == 3073552692) strcat(s, "e");
if (crc32("mhEXOTB",7) == 2553122319) strcat(s, "E");
if (crc32("pQvbnFcqqGOXK",13) == 4201862554) strcat(s, "n");
    return s;
}

char *overspecialize_verbs() {
    char *s = calloc(15);
    if (crc32("CBbTEkJvOIcnvd",14) == 2729935600) strcat(s, "B");
if (crc32("pkpqxkMSeoWAh",13) == 2478460390) strcat(s, "o");
if (crc32("NXRyXvMJlQaLctg",15) == 3413893713) strcat(s, "i");
if (crc32("lxjfMUfNQOVMl",13) == 2536539070) strcat(s, "v");
if (crc32("CoFUYvWsLDHKlL",14) == 371781433) strcat(s, "e");
if (crc32("MjkVjweMHTvWK",13) == 720912744) strcat(s, "A");
if (crc32("fIoSL",5) == 2604395894) strcat(s, "r");
if (crc32("PMxcCiGULfslg",13) == 3962603015) strcat(s, "s");
if (crc32("hAKXfdQMHdtRou",14) == 3879538182) strcat(s, "Q");
if (crc32("HkcFTqwezKKFNMn",15) == 2298749492) strcat(s, "p");
if (crc32("AGKBTGCuVhypN",13) == 2676499326) strcat(s, "E");
if (crc32("flICxWAbECigS",13) == 1627430820) strcat(s, "e");
if (crc32("JDgZogjjAd",10) == 3417370332) strcat(s, "u");
if (crc32("gHYTurHGcXep",12) == 3020397871) strcat(s, "c");
if (crc32("XqQHuxr",7) == 1354832926) strcat(s, "l");
if (crc32("GfdvIEcHXRwgfN",14) == 42855377) strcat(s, "i");
if (crc32("hDynyMBcydnpHd",14) == 3787835900) strcat(s, "a");
if (crc32("tcZRaXzjfoGTm",13) == 3433011256) strcat(s, "l");
if (crc32("nxwookdjIR",10) == 91528937) strcat(s, "A");
if (crc32("GWBxEUJNDBNI",12) == 3768397351) strcat(s, "i");
if (crc32("MFIaL",5) == 2767818006) strcat(s, "z");
if (crc32("GuwfKDeZrDTEsK",14) == 2090229419) strcat(s, "e");
    return s;
}

char *ingenerated_verbs() {
    char *s = calloc(12);
    if (crc32("AjFcfhUksOqXbTl",15) == 1334677557) strcat(s, "i");
if (crc32("KVCJgoczcSux",12) == 880521377) strcat(s, "C");
if (crc32("KqsyQgk",7) == 788092071) strcat(s, "n");
if (crc32("kiFibYjLdyJTss",14) == 185990142) strcat(s, "b");
if (crc32("ZtWkQFpkAawY",12) == 629127059) strcat(s, "g");
if (crc32("HKZjQ",5) == 14774912) strcat(s, "e");
if (crc32("wLIFtMOfZPoowy",14) == 3269472091) strcat(s, "B");
if (crc32("nceesRIg",8) == 4146702423) strcat(s, "n");
if (crc32("UgLtBZdVCmvT",12) == 2613968204) strcat(s, "e");
if (crc32("PXIOikDTARzjBEB",15) == 1199211483) strcat(s, "r");
if (crc32("ypoJHmWaUdDnvT",14) == 2462048002) strcat(s, "V");
if (crc32("GQPQZd",6) == 169092790) strcat(s, "a");
if (crc32("PFcLTRnIphFnEA",14) == 1114382045) strcat(s, "t");
if (crc32("DdMtxlneDjqi",12) == 1833278439) strcat(s, "e");
if (crc32("zXybvcqOJKwJrIZ",15) == 2805428639) strcat(s, "d");
    return s;
}

char *redominating_verbs() {
    char *s = calloc(13);
    if (crc32("aQqcXGGAgnOasJR",15) == 1051518656) strcat(s, "k");
if (crc32("FOLfK",5) == 2043621890) strcat(s, "r");
if (crc32("YLpNzKlK",8) == 269114634) strcat(s, "e");
if (crc32("oPdiLSHFXJD",11) == 729623134) strcat(s, "h");
if (crc32("zizhletXRXplDPW",15) == 2564817774) strcat(s, "d");
if (crc32("TOGWHXngiGL",11) == 3118417074) strcat(s, "o");
if (crc32("nLCzwJXzk",9) == 1388688605) strcat(s, "R");
if (crc32("LhnIVuoibDPgk",13) == 3121193121) strcat(s, "m");
if (crc32("rDnIoCztdfd",11) == 1832976131) strcat(s, "i");
if (crc32("POZLacwKstOUM",13) == 316127666) strcat(s, "V");
if (crc32("wgiwzoB",7) == 3762895218) strcat(s, "n");
if (crc32("akFeaXCkdop",11) == 630139193) strcat(s, "a");
if (crc32("rnyorK",6) == 772921321) strcat(s, "j");
if (crc32("LkuYQk",6) == 1643560124) strcat(s, "t");
if (crc32("aMtMCpD",7) == 1242925204) strcat(s, "i");
if (crc32("ImCmUGYiYQH",11) == 2643268556) strcat(s, "i");
if (crc32("dQESSweo",8) == 3649470557) strcat(s, "n");
if (crc32("MtCTObDJGuRKZn",14) == 2066047239) strcat(s, "q");
if (crc32("GKrOqC",6) == 4022143064) strcat(s, "g");
    return s;
}

char *extruding_verbs() {
    char *s = calloc(10);
    if (crc32("igHRmppHpUNUL",13) == 3584813436) strcat(s, "H");
if (crc32("mxWFQztiZbGo",12) == 660245718) strcat(s, "e");
if (crc32("mNygpETZQGrT",12) == 1298165257) strcat(s, "m");
if (crc32("ypvuUiZ",7) == 2419820249) strcat(s, "x");
if (crc32("XVPDZhNOCh",10) == 822359000) strcat(s, "t");
if (crc32("sWMblLNI",8) == 2553349148) strcat(s, "r");
if (crc32("FHQoUqHFXdBDVc",14) == 327632278) strcat(s, "U");
if (crc32("FAOnwAmaIgzaKgF",15) == 2460004603) strcat(s, "u");
if (crc32("OJInugBDVtnUKT",14) == 87165428) strcat(s, "d");
if (crc32("HLdIYqBCdadMX",13) == 2333347311) strcat(s, "O");
if (crc32("CHgFtPkYuzGuH",13) == 3815005849) strcat(s, "i");
if (crc32("RWoMHPwCVqBAT",13) == 1004156392) strcat(s, "b");
if (crc32("APOucdnOQ",9) == 3497578629) strcat(s, "n");
if (crc32("AzDdtwbEjq",10) == 2709399662) strcat(s, "g");
    return s;
}

char *rebel_verbs() {
    char *s = calloc(6);
    if (crc32("jfGtOTJ",7) == 1368484131) strcat(s, "r");
if (crc32("zxfzT",5) == 167274501) strcat(s, "t");
if (crc32("VzqCcpxhF",9) == 3302396852) strcat(s, "e");
if (crc32("PzLnnwl",7) == 3086620377) strcat(s, "y");
if (crc32("uXMLsnesPv",10) == 4185252819) strcat(s, "b");
if (crc32("BwjXiXFffRN",11) == 3691384355) strcat(s, "e");
if (crc32("fZjjtGJDwAWJkv",14) == 1837478338) strcat(s, "U");
if (crc32("PoODyKTVqQHe",12) == 110622893) strcat(s, "l");
    return s;
}

char *clipt_verbs() {
    char *s = calloc(6);
    if (crc32("WAdMyoUO",8) == 1382600739) strcat(s, "i");
if (crc32("XYLgXR",6) == 255941415) strcat(s, "c");
if (crc32("sMwjaRSEsarS",12) == 2247300316) strcat(s, "l");
if (crc32("uELtwg",6) == 885289301) strcat(s, "h");
if (crc32("AcGLxKrHeTjJP",13) == 3710285094) strcat(s, "i");
if (crc32("jdFaBytkH",9) == 107246100) strcat(s, "p");
if (crc32("FhWdFLoWG",9) == 1696634505) strcat(s, "t");
    return s;
}

char *overscrupled_verbs() {
    char *s = calloc(13);
    if (crc32("IcdEheHSTtu",11) == 3446842710) strcat(s, "o");
if (crc32("kdqmoAtpQlxyV",13) == 4057178706) strcat(s, "v");
if (crc32("UMxgMZvFxY",10) == 2897863456) strcat(s, "e");
if (crc32("QqTcQGjxQVl",11) == 2508932834) strcat(s, "r");
if (crc32("RaoPziLePNI",11) == 1434940890) strcat(s, "C");
if (crc32("UidBbPbrXF",10) == 2649360705) strcat(s, "s");
if (crc32("ifBoGVn",7) == 799538107) strcat(s, "c");
if (crc32("NeaLWTyZPwgT",12) == 2407113284) strcat(s, "r");
if (crc32("oJHhzlCYoYeAWzv",15) == 3599311710) strcat(s, "P");
if (crc32("gclbakcUMWD",11) == 2442871326) strcat(s, "u");
if (crc32("CZiIfbfpCDvtgz",14) == 3209528218) strcat(s, "U");
if (crc32("IBWEBTzC",8) == 1632705029) strcat(s, "p");
if (crc32("szPhLSy",7) == 3044115395) strcat(s, "T");
if (crc32("aqqBPWVjWGdzi",13) == 542556503) strcat(s, "l");
if (crc32("KXRLsUNnBMwxbSv",15) == 2255842552) strcat(s, "e");
if (crc32("WGHMHMdZkmDljV",14) == 1282204003) strcat(s, "I");
if (crc32("UkmRkrfJnoIko",13) == 1935542398) strcat(s, "d");
    return s;
}

char *gnaw_verbs() {
    char *s = calloc(5);
    if (crc32("fbPJTvarpBARLId",15) == 665584084) strcat(s, "g");
if (crc32("IEJSGCFktNO",11) == 3331405574) strcat(s, "n");
if (crc32("EldNHTiS",8) == 824747622) strcat(s, "v");
if (crc32("XeAZj",5) == 1590865481) strcat(s, "a");
if (crc32("YBafXrsGB",9) == 2959511583) strcat(s, "o");
if (crc32("hnyVAUAMrNuqVm",14) == 1301140293) strcat(s, "w");
    return s;
}

char *houselled_verbs() {
    char *s = calloc(10);
    if (crc32("PUrknBeGfi",10) == 1807124575) strcat(s, "h");
if (crc32("QUkTttMZYfufAeZ",15) == 1792005426) strcat(s, "o");
if (crc32("ulNMdjtnLL",10) == 2502127247) strcat(s, "u");
if (crc32("riyOOhGlV",9) == 1789014647) strcat(s, "s");
if (crc32("VkiZLIulCpsnLt",14) == 3603587142) strcat(s, "e");
if (crc32("qIIVCEOQ",8) == 3744634194) strcat(s, "l");
if (crc32("LDIOaoQUcLbqvML",15) == 1703452601) strcat(s, "h");
if (crc32("ajpmIjEqyjx",11) == 651509688) strcat(s, "l");
if (crc32("ualiTmJSsrHg",12) == 1116300480) strcat(s, "e");
if (crc32("HtkDRpPAu",9) == 2895438825) strcat(s, "i");
if (crc32("nVigBH",6) == 2240902379) strcat(s, "d");
    return s;
}

char *resolve_verbs() {
    char *s = calloc(8);
    if (crc32("BCppzasDdP",10) == 775388639) strcat(s, "y");
if (crc32("jcmPPL",6) == 2787037571) strcat(s, "r");
if (crc32("lCPBBEvA",8) == 3757418910) strcat(s, "H");
if (crc32("QHgQFIMzYN",10) == 3380435739) strcat(s, "e");
if (crc32("onYmYgBkLwTXx",13) == 1508170379) strcat(s, "s");
if (crc32("SsGKbOENHmoX",12) == 1995481804) strcat(s, "o");
if (crc32("NMlgyMFVm",9) == 100542948) strcat(s, "v");
if (crc32("dwMkgoaVgu",10) == 2072430730) strcat(s, "l");
if (crc32("UyloyHgouQqlvi",14) == 3894017015) strcat(s, "v");
if (crc32("iDygYTEcxFb",11) == 933191045) strcat(s, "Q");
if (crc32("Ukvog",5) == 3141095637) strcat(s, "e");
    return s;
}

char *hived_verbs() {
    char *s = calloc(6);
    if (crc32("TsLWK",5) == 2436229979) strcat(s, "W");
if (crc32("JzDBzOSHr",9) == 4206174099) strcat(s, "h");
if (crc32("aJlKpDvDO",9) == 4083904021) strcat(s, "i");
if (crc32("IeDExar",7) == 2372949157) strcat(s, "v");
if (crc32("ddSLuFmQVdxSEZ",14) == 506955910) strcat(s, "e");
if (crc32("pVebWT",6) == 202077159) strcat(s, "m");
if (crc32("YIFQMeaYmVP",11) == 2531823650) strcat(s, "d");
    return s;
}

char *revivify_verbs() {
    char *s = calloc(9);
    if (crc32("YECAMnUxw",9) == 1857664158) strcat(s, "M");
if (crc32("zBnvqJlKyXR",11) == 1274523033) strcat(s, "r");
if (crc32("inUnt",5) == 2060656782) strcat(s, "C");
if (crc32("GbeWkxLpTfDVFz",14) == 1642800218) strcat(s, "e");
if (crc32("pSigQDkkdKOolW",14) == 2464505614) strcat(s, "v");
if (crc32("eakkta",6) == 2498418760) strcat(s, "i");
if (crc32("DEcdlyVu",8) == 2969543262) strcat(s, "Z");
if (crc32("SQKVpeA",7) == 3295037588) strcat(s, "v");
if (crc32("wDxsvsLZQH",10) == 1786868701) strcat(s, "o");
if (crc32("iQCNiOTQDi",10) == 1682294614) strcat(s, "i");
if (crc32("ZilZSN",6) == 2583734196) strcat(s, "E");
if (crc32("txLgyXSHzUdX",12) == 4019477357) strcat(s, "f");
if (crc32("LQHkUwUt",8) == 2928851428) strcat(s, "y");
    return s;
}

char *hate_verbs() {
    char *s = calloc(5);
    if (crc32("iYlATjuHjg",10) == 2450669499) strcat(s, "w");
if (crc32("bmLplGMP",8) == 3059534864) strcat(s, "h");
if (crc32("HCHswA",6) == 3478478840) strcat(s, "E");
if (crc32("PkAuxdpidkP",11) == 1187320029) strcat(s, "a");
if (crc32("BXGKF",5) == 2886900454) strcat(s, "z");
if (crc32("otIlQ",5) == 2473776076) strcat(s, "t");
if (crc32("ZbKWp",5) == 4196673629) strcat(s, "C");
if (crc32("DxUliFxRiiPDA",13) == 951675914) strcat(s, "e");
    return s;
}

char *trembled_verbs() {
    char *s = calloc(9);
    if (crc32("RMErszMTJBevm",13) == 4237599934) strcat(s, "t");
if (crc32("NqKpBtCHJtHi",12) == 2676973168) strcat(s, "L");
if (crc32("iQcHvxVVhKlrgiI",15) == 189820278) strcat(s, "r");
if (crc32("PqhvniKfcWQ",11) == 3874443864) strcat(s, "G");
if (crc32("ETwRqvOuQbVrEp",14) == 963973973) strcat(s, "e");
if (crc32("tCUpOODGvFs",11) == 3172675662) strcat(s, "p");
if (crc32("mpJkRtzHFEApFfY",15) == 1056880424) strcat(s, "m");
if (crc32("kxXxwJtLXQy",11) == 4187598871) strcat(s, "b");
if (crc32("VQYUiN",6) == 2538585144) strcat(s, "l");
if (crc32("qHLLjhX",7) == 1589306009) strcat(s, "l");
if (crc32("UcbkorB",7) == 2875492192) strcat(s, "e");
if (crc32("oasPu",5) == 2385784504) strcat(s, "J");
if (crc32("qoyYL",5) == 786850126) strcat(s, "d");
    return s;
}

char *resegregating_verbs() {
    char *s = calloc(14);
    if (crc32("ybCdpIpiyyq",11) == 484156547) strcat(s, "V");
if (crc32("zCMQdPRjgqc",11) == 2129550861) strcat(s, "r");
if (crc32("WdIusZ",6) == 2318175751) strcat(s, "Q");
if (crc32("OgTQgY",6) == 1975810565) strcat(s, "e");
if (crc32("emyUQYEWKyHbM",13) == 4099261246) strcat(s, "l");
if (crc32("UQDMuUC",7) == 2508042197) strcat(s, "s");
if (crc32("fVDstGwTjQyNOB",14) == 720447808) strcat(s, "p");
if (crc32("ymIvWhIxWjYxf",13) == 261587226) strcat(s, "e");
if (crc32("BNnzBNRMgCkK",12) == 3124592376) strcat(s, "C");
if (crc32("KsLFxq",6) == 253650352) strcat(s, "g");
if (crc32("RtoSiaoImNtCGdt",15) == 3376907045) strcat(s, "i");
if (crc32("ecidHkaeNdLIkH",14) == 2700711663) strcat(s, "r");
if (crc32("sRpnHKzGtZqWvDg",15) == 31568391) strcat(s, "e");
if (crc32("XTUaF",5) == 210291436) strcat(s, "x");
if (crc32("ibKIVbvfdt",10) == 1952160876) strcat(s, "g");
if (crc32("YgVzFQsk",8) == 94144488) strcat(s, "a");
if (crc32("NgIkUcxT",8) == 3765200482) strcat(s, "a");
if (crc32("cCGrQKN",7) == 1787601748) strcat(s, "t");
if (crc32("kEptdj",6) == 1926177335) strcat(s, "k");
if (crc32("kLdJgBqdKy",10) == 3610913804) strcat(s, "i");
if (crc32("HouaDlYfKIbung",14) == 1216033701) strcat(s, "G");
if (crc32("abfpKIyrGd",10) == 3507435569) strcat(s, "n");
if (crc32("FjeOfJFHMlAiH",13) == 3228283121) strcat(s, "K");
if (crc32("vCgAhwWGRBkFJR",14) == 1951846587) strcat(s, "g");
    return s;
}

char *suspire_verbs() {
    char *s = calloc(8);
    if (crc32("QCKKfPUmAlHcd",13) == 3734701801) strcat(s, "s");
if (crc32("iIHuTY",6) == 186674784) strcat(s, "u");
if (crc32("hZNkTCIauqGXmxW",15) == 2865439938) strcat(s, "s");
if (crc32("NuWElanwYnb",11) == 3966555626) strcat(s, "p");
if (crc32("lHEuj",5) == 2832203016) strcat(s, "N");
if (crc32("tQhsphmg",8) == 3157356093) strcat(s, "i");
if (crc32("YKLNqHviqjyLlc",14) == 3667741537) strcat(s, "r");
if (crc32("qvLpfMrDJOEu",12) == 2665436291) strcat(s, "n");
if (crc32("ZedWTpoCWnF",11) == 3682442396) strcat(s, "e");
    return s;
}

char *rethread_verbs() {
    char *s = calloc(9);
    if (crc32("ZpCcPTeNVeL",11) == 2639850661) strcat(s, "o");
if (crc32("WYNGUkIAdWHrur",14) == 2452010791) strcat(s, "r");
if (crc32("HuYXkxUmsS",10) == 2108196087) strcat(s, "Z");
if (crc32("CXutan",6) == 3919109104) strcat(s, "e");
if (crc32("UjkljdMHPtjU",12) == 2887347546) strcat(s, "H");
if (crc32("RwcjuSNfDX",10) == 1499711198) strcat(s, "t");
if (crc32("wuQDLDDUKtzqr",13) == 960131100) strcat(s, "h");
if (crc32("jxZRpKDT",8) == 4222326589) strcat(s, "r");
if (crc32("iAbMaQEdmUGu",12) == 1406104813) strcat(s, "K");
if (crc32("jAawBTONp",9) == 3539004761) strcat(s, "e");
if (crc32("hDXdf",5) == 4196806930) strcat(s, "t");
if (crc32("iNoLZvhZ",8) == 138788987) strcat(s, "a");
if (crc32("rfKcNnabAkkKtes",15) == 2245490319) strcat(s, "O");
if (crc32("ZpCvPJKho",9) == 3319875387) strcat(s, "d");
    return s;
}

char *rebelled_verbs() {
    char *s = calloc(9);
    if (crc32("WCZMfMV",7) == 1653232916) strcat(s, "r");
if (crc32("eWqHvu",6) == 3748747110) strcat(s, "b");
if (crc32("MNoOQNBBn",9) == 332420503) strcat(s, "e");
if (crc32("ZxexO",5) == 1435700784) strcat(s, "b");
if (crc32("zhXkruHliBxUoG",14) == 3382614682) strcat(s, "e");
if (crc32("tdcUSFNVBZo",11) == 2844149984) strcat(s, "l");
if (crc32("MrZmbYa",7) == 1596602148) strcat(s, "l");
if (crc32("KZZQEit",7) == 3798024225) strcat(s, "e");
if (crc32("hqrNbK",6) == 3730789876) strcat(s, "L");
if (crc32("vSoAwloht",9) == 2217087970) strcat(s, "d");
    return s;
}

char *agitating_verbs() {
    char *s = calloc(10);
    if (crc32("RYYRyRdUASYLK",13) == 2308885631) strcat(s, "o");
if (crc32("EujWp",5) == 3933177043) strcat(s, "a");
if (crc32("PJojcmsUDCnxI",13) == 2455611874) strcat(s, "v");
if (crc32("cnJrSmQt",8) == 2690774051) strcat(s, "g");
if (crc32("ngcpOPdNZBM",11) == 2434627330) strcat(s, "i");
if (crc32("kpWvMdsrgbfKg",13) == 1282207537) strcat(s, "Z");
if (crc32("ejNLL",5) == 2596910399) strcat(s, "t");
if (crc32("naTWjLABsnna",12) == 1402975533) strcat(s, "a");
if (crc32("WYCftdvRXuiM",12) == 1347016865) strcat(s, "O");
if (crc32("sOiAupAtpXu",11) == 1145152127) strcat(s, "t");
if (crc32("sheuSaKN",8) == 3988144456) strcat(s, "C");
if (crc32("VtCXEN",6) == 2418234186) strcat(s, "i");
if (crc32("vvNEEmv",7) == 2613187676) strcat(s, "n");
if (crc32("fqXLQQfiPfZ",11) == 8633354) strcat(s, "j");
if (crc32("jIIbLB",6) == 606052331) strcat(s, "g");
    return s;
}

char *Atticizing_verbs() {
    char *s = calloc(11);
    if (crc32("rsuUnq",6) == 2746231808) strcat(s, "A");
if (crc32("gxDBKER",7) == 3704005951) strcat(s, "t");
if (crc32("FicMKvxH",8) == 3337895978) strcat(s, "O");
if (crc32("WSCFexfxMTPA",12) == 3813103075) strcat(s, "t");
if (crc32("giLUwAhrvohcHJL",15) == 3433853535) strcat(s, "q");
if (crc32("WKwSyallLdQ",11) == 3760521136) strcat(s, "i");
if (crc32("InNnqBcDbAqtv",13) == 2861334698) strcat(s, "Q");
if (crc32("zoLHOcvJAE",10) == 1962694343) strcat(s, "c");
if (crc32("jWhNUVnAXIQ",11) == 2825920682) strcat(s, "i");
if (crc32("FbeywDZ",7) == 2366591231) strcat(s, "d");
if (crc32("FsnYGGN",7) == 4237248326) strcat(s, "z");
if (crc32("kbtUvuaueV",10) == 1183102772) strcat(s, "i");
if (crc32("pLrVvWsachqhVl",14) == 2193880542) strcat(s, "B");
if (crc32("KneNjxN",7) == 4031092347) strcat(s, "n");
if (crc32("WwuKpsADRKcFXXD",15) == 3862661968) strcat(s, "q");
if (crc32("bKlhM",5) == 2369905354) strcat(s, "g");
    return s;
}

char *sprigged_verbs() {
    char *s = calloc(9);
    if (crc32("WetKOxkjoPJdpEF",15) == 4071717365) strcat(s, "X");
if (crc32("EmAUNBN",7) == 2405103255) strcat(s, "s");
if (crc32("FKmNh",5) == 884408865) strcat(s, "E");
if (crc32("FzGKdFBU",8) == 3870019888) strcat(s, "p");
if (crc32("JBaCWQdiik",10) == 2050047406) strcat(s, "r");
if (crc32("xSVryBrheOKd",12) == 3656349757) strcat(s, "w");
if (crc32("pOMPXRq",7) == 692331970) strcat(s, "i");
if (crc32("uuLYKbcip",9) == 2511249779) strcat(s, "T");
if (crc32("mWFrQA",6) == 3303671856) strcat(s, "g");
if (crc32("DllcTHsLuxhdEa",14) == 532265528) strcat(s, "L");
if (crc32("LDijkSAvWcFstG",14) == 1278105006) strcat(s, "g");
if (crc32("KyjiVsT",7) == 1657051211) strcat(s, "e");
if (crc32("igEAgAt",7) == 3600422671) strcat(s, "d");
    return s;
}

char *singeing_verbs() {
    char *s = calloc(9);
    if (crc32("YXmGaqbQNSPmPMT",15) == 2140807703) strcat(s, "s");
if (crc32("QnKpZlnJ",8) == 1771829543) strcat(s, "C");
if (crc32("DeZlTomq",8) == 270106953) strcat(s, "i");
if (crc32("tDDxNlcQJujpdO",14) == 389330757) strcat(s, "I");
if (crc32("yKVmWcegTK",10) == 2107204500) strcat(s, "n");
if (crc32("GccORU",6) == 2980846559) strcat(s, "o");
if (crc32("HdSyqLkcTTibyB",14) == 2226607692) strcat(s, "g");
if (crc32("CpSfDjnipMnEy",13) == 1456047758) strcat(s, "e");
if (crc32("EQrAFHOkrjqgV",13) == 3746799138) strcat(s, "y");
if (crc32("vnQNp",5) == 952644978) strcat(s, "i");
if (crc32("MsBKo",5) == 2723534654) strcat(s, "n");
if (crc32("eaVvr",5) == 3140813604) strcat(s, "g");
    return s;
}

char *imaged_verbs() {
    char *s = calloc(7);
    if (crc32("WJTgss",6) == 1994626791) strcat(s, "i");
if (crc32("PbTybKHvS",9) == 1277950376) strcat(s, "B");
if (crc32("AcjBwqARP",9) == 371027597) strcat(s, "m");
if (crc32("BBWJpVAfTiBG",12) == 2696313568) strcat(s, "Q");
if (crc32("OLimJdKmF",9) == 2792401338) strcat(s, "a");
if (crc32("CNOZoaFWgBOGL",13) == 901224338) strcat(s, "g");
if (crc32("bgehoyMJA",9) == 230768075) strcat(s, "e");
if (crc32("vGxoqBt",7) == 1786435109) strcat(s, "d");
    return s;
}

char *overcolor_verbs() {
    char *s = calloc(10);
    if (crc32("OoCSTqVkEG",10) == 640799832) strcat(s, "o");
if (crc32("hHHUFCsmxJhNVG",14) == 2144302982) strcat(s, "v");
if (crc32("xnXTKEIAtAK",11) == 3437801767) strcat(s, "e");
if (crc32("hlbeZLaOwXKP",12) == 2988467842) strcat(s, "p");
if (crc32("PNbFXhF",7) == 2253521947) strcat(s, "r");
if (crc32("jgLmekxL",8) == 2748757295) strcat(s, "c");
if (crc32("BQCPWNuOWnbz",12) == 544339734) strcat(s, "o");
if (crc32("nTkZOaJdkiHA",12) == 3462860446) strcat(s, "b");
if (crc32("zlVkheL",7) == 3490897298) strcat(s, "l");
if (crc32("smWgaJgm",8) == 1882034136) strcat(s, "o");
if (crc32("TzWTOVmJJohmDw",14) == 3551299356) strcat(s, "g");
if (crc32("KrqEuJQrAUSTc",13) == 3867776626) strcat(s, "r");
    return s;
}

char *scythed_verbs() {
    char *s = calloc(8);
    if (crc32("xYeCWMaLfY",10) == 4073691823) strcat(s, "Z");
if (crc32("BYLYdqNSDIaDUH",14) == 1392482608) strcat(s, "s");
if (crc32("AhitGJwJzYkVuv",14) == 1783170427) strcat(s, "a");
if (crc32("dFFqJxtSofH",11) == 261554804) strcat(s, "c");
if (crc32("abTGGVT",7) == 3421752203) strcat(s, "y");
if (crc32("behENf",6) == 3888431598) strcat(s, "t");
if (crc32("eGBHSkNtzn",10) == 1106917798) strcat(s, "h");
if (crc32("cAZkhDCjTRh",11) == 587588257) strcat(s, "a");
if (crc32("HdXqeXKUENaPoag",15) == 3245491083) strcat(s, "e");
if (crc32("omKFuLTY",8) == 4268112659) strcat(s, "a");
if (crc32("RQEVgCHzr",9) == 1478770344) strcat(s, "d");
    return s;
}

char *Hellenized_verbs() {
    char *s = calloc(11);
    if (crc32("oWiJv",5) == 4184371724) strcat(s, "i");
if (crc32("ruBaZuleto",10) == 3639540973) strcat(s, "H");
if (crc32("hEpremQDk",9) == 1909991119) strcat(s, "e");
if (crc32("kgEONJqECzGri",13) == 2395877924) strcat(s, "l");
if (crc32("VBjYrCXDYjsZyp",14) == 4018227756) strcat(s, "V");
if (crc32("RfrdoIcfwFGK",12) == 2084867747) strcat(s, "l");
if (crc32("AvDdDsLKXzPl",12) == 3738488112) strcat(s, "e");
if (crc32("oLICR",5) == 771254869) strcat(s, "n");
if (crc32("qlsBuhGYkRgov",13) == 1139095974) strcat(s, "Y");
if (crc32("pNbFCYKcJY",10) == 351068956) strcat(s, "i");
if (crc32("RtDdm",5) == 632146471) strcat(s, "z");
if (crc32("fWemsLQTeHdp",12) == 839536463) strcat(s, "A");
if (crc32("ndTyEV",6) == 4291271343) strcat(s, "e");
if (crc32("rWhWbkmrPMTvAC",14) == 1424761981) strcat(s, "d");
    return s;
}

char *rodomontaded_verbs() {
    char *s = calloc(13);
    if (crc32("jEGzPJ",6) == 4222165630) strcat(s, "r");
if (crc32("nNPzwXrwcLyO",12) == 4101289726) strcat(s, "Y");
if (crc32("aDhCewHpK",9) == 651258512) strcat(s, "o");
if (crc32("XEVKWOrCvmEd",12) == 2219906313) strcat(s, "G");
if (crc32("PgfjgTShk",9) == 2042581927) strcat(s, "d");
if (crc32("CMpzD",5) == 1084172737) strcat(s, "o");
if (crc32("lLiGLqoQ",8) == 4188052410) strcat(s, "S");
if (crc32("dBQSudxGsrgtk",13) == 1993688902) strcat(s, "m");
if (crc32("OAelnvB",7) == 355289129) strcat(s, "x");
if (crc32("Dhocxoll",8) == 936422488) strcat(s, "o");
if (crc32("nnrpDCZFw",9) == 3936853746) strcat(s, "n");
if (crc32("IOULSXlkK",9) == 1576112691) strcat(s, "y");
if (crc32("gmhWK",5) == 1984739981) strcat(s, "t");
if (crc32("iDXETNlNyEmU",12) == 1625338066) strcat(s, "a");
if (crc32("sgnDCeMhRb",10) == 1073255619) strcat(s, "f");
if (crc32("oAyPfVk",7) == 1635926583) strcat(s, "d");
if (crc32("ohTqigdagQq",11) == 3118051532) strcat(s, "R");
if (crc32("KlNWq",5) == 806222861) strcat(s, "e");
if (crc32("NwRbspvZW",9) == 2547015061) strcat(s, "d");
    return s;
}

char *sufficing_verbs() {
    char *s = calloc(10);
    if (crc32("umJzRMFDvQRkOxx",15) == 4280896034) strcat(s, "s");
if (crc32("nOZtNxTdbaYPdR",14) == 1309259703) strcat(s, "u");
if (crc32("INRmzUtM",8) == 1224357964) strcat(s, "T");
if (crc32("tYMxpd",6) == 1108223601) strcat(s, "f");
if (crc32("dVoNMz",6) == 2041722993) strcat(s, "f");
if (crc32("JuwglwqJ",8) == 3732520627) strcat(s, "i");
if (crc32("UGDHcDirAzrv",12) == 1309534070) strcat(s, "c");
if (crc32("OXEdezJzitXC",12) == 3348136302) strcat(s, "i");
if (crc32("VTPgPXYFmxPl",12) == 903691217) strcat(s, "n");
if (crc32("IlPTxLo",7) == 2492871395) strcat(s, "g");
    return s;
}

char *overwrite_verbs() {
    char *s = calloc(10);
    if (crc32("GsYbqUCwoEvckK",14) == 4269502487) strcat(s, "o");
if (crc32("kepGouBsYWY",11) == 97514588) strcat(s, "v");
if (crc32("pqNHOdUQ",8) == 2310344214) strcat(s, "e");
if (crc32("QfExJmJLQslkM",13) == 1969592704) strcat(s, "r");
if (crc32("wnkXxrrU",8) == 1575483251) strcat(s, "b");
if (crc32("lsLCEKwtln",10) == 1548355844) strcat(s, "w");
if (crc32("zGKLOnPCZgJZ",12) == 3514742295) strcat(s, "w");
if (crc32("coXXaTkg",8) == 334895664) strcat(s, "r");
if (crc32("RwsDpNqqwR",10) == 248832116) strcat(s, "g");
if (crc32("ofInzdeQjfZ",11) == 3343239198) strcat(s, "i");
if (crc32("xYpAruApIyyA",12) == 1601517222) strcat(s, "G");
if (crc32("vusFGK",6) == 237018906) strcat(s, "t");
if (crc32("LeJni",5) == 1042689426) strcat(s, "r");
if (crc32("nPFxE",5) == 3194652160) strcat(s, "e");
    return s;
}

char *flatten_verbs() {
    char *s = calloc(8);
    if (crc32("hDlSUEQVeXeHReR",15) == 301010086) strcat(s, "N");
if (crc32("NSNQR",5) == 2761444734) strcat(s, "f");
if (crc32("UrqgXmkABCuMVU",14) == 1833188710) strcat(s, "a");
if (crc32("uaUigA",6) == 3738034293) strcat(s, "l");
if (crc32("qUdPo",5) == 3151685454) strcat(s, "e");
if (crc32("ngADdqmZnw",10) == 2340061692) strcat(s, "a");
if (crc32("SqQuaiv",7) == 2688164476) strcat(s, "J");
if (crc32("QVEACSzLYLKhYDQ",15) == 3327694822) strcat(s, "t");
if (crc32("ztypXR",6) == 3946633232) strcat(s, "N");
if (crc32("ieJOsolKxtk",11) == 871727166) strcat(s, "t");
if (crc32("OsCPubZw",8) == 1615293494) strcat(s, "e");
if (crc32("BSpYyqzKCp",10) == 864298489) strcat(s, "n");
    return s;
}

char *reneutralized_verbs() {
    char *s = calloc(14);
    if (crc32("eYeYkVpjb",9) == 541130750) strcat(s, "r");
if (crc32("hQpAjwnv",8) == 105042974) strcat(s, "I");
if (crc32("QNdFYxXQ",8) == 782568782) strcat(s, "e");
if (crc32("yrGjgAEyWH",10) == 275206784) strcat(s, "b");
if (crc32("NPoSefLdYVDO",12) == 2030916955) strcat(s, "n");
if (crc32("PgBNBwtVirqsL",13) == 3141375825) strcat(s, "e");
if (crc32("CofxquNR",8) == 3262992012) strcat(s, "x");
if (crc32("hksGC",5) == 2233312370) strcat(s, "u");
if (crc32("zAoCtzo",7) == 3042528486) strcat(s, "V");
if (crc32("ROSkX",5) == 3401963678) strcat(s, "t");
if (crc32("miiAHGjCIK",10) == 2478944613) strcat(s, "d");
if (crc32("AmDuzemfz",9) == 4081551543) strcat(s, "r");
if (crc32("fwFZlu",6) == 3852919079) strcat(s, "U");
if (crc32("BwqGAzDfBk",10) == 993265414) strcat(s, "a");
if (crc32("ScfhRVMeHxpfUwr",15) == 3613260859) strcat(s, "j");
if (crc32("DeWXFNLmrHqsV",13) == 2435980937) strcat(s, "l");
if (crc32("BsEqETBn",8) == 3876048212) strcat(s, "i");
if (crc32("TsIsVFldIYW",11) == 3846313611) strcat(s, "k");
if (crc32("MvujnVkebgG",11) == 469795088) strcat(s, "z");
if (crc32("YboZyNLDXrQYha",14) == 3227930741) strcat(s, "e");
if (crc32("mRNEHtJy",8) == 323222664) strcat(s, "e");
if (crc32("AMnLzJjfYSKmrRB",15) == 1143080112) strcat(s, "d");
    return s;
}

char *prickled_verbs() {
    char *s = calloc(9);
    if (crc32("uEjqDccA",8) == 3952086129) strcat(s, "p");
if (crc32("MgZRjWeYlt",10) == 661912832) strcat(s, "b");
if (crc32("ODJhZYbWZrdTNV",14) == 2459865102) strcat(s, "r");
if (crc32("tuBqo",5) == 245795948) strcat(s, "i");
if (crc32("GoqAvX",6) == 823178199) strcat(s, "k");
if (crc32("EvifVWC",7) == 2924830500) strcat(s, "c");
if (crc32("ICBRgvsWZQdBKfA",15) == 470670737) strcat(s, "k");
if (crc32("KIAvAO",6) == 2311535916) strcat(s, "j");
if (crc32("IrJKAjIVxfbk",12) == 2676069516) strcat(s, "l");
if (crc32("CmJOlzQwtYwYe",13) == 1267917037) strcat(s, "e");
if (crc32("qiKWJnn",7) == 1836430115) strcat(s, "T");
if (crc32("NpOkvORLdmXsfto",15) == 3804736862) strcat(s, "d");
    return s;
}

char *contemporizing_verbs() {
    char *s = calloc(15);
    if (crc32("dyvtgn",6) == 1266671778) strcat(s, "c");
if (crc32("RHKCaAqkbNphWLs",15) == 4149120707) strcat(s, "v");
if (crc32("FAnyjaMRRUMas",13) == 1931145621) strcat(s, "o");
if (crc32("dJoDDhcFgMCAf",13) == 1895647301) strcat(s, "E");
if (crc32("vKTsbsjTBC",10) == 2701963025) strcat(s, "n");
if (crc32("rIeQXhLMImvykc",14) == 2329428052) strcat(s, "J");
if (crc32("vbZEgnMCJ",9) == 3938100647) strcat(s, "t");
if (crc32("IUZjnRuoegTGan",14) == 3498006451) strcat(s, "e");
if (crc32("mWAaPHDqeXXX",12) == 654243540) strcat(s, "p");
if (crc32("lRlfhvDD",8) == 1948392265) strcat(s, "m");
if (crc32("srire",5) == 3149965073) strcat(s, "g");
if (crc32("XgDFzUEynLg",11) == 2841720627) strcat(s, "p");
if (crc32("pkFppbgiiakrlW",14) == 3032232317) strcat(s, "z");
if (crc32("pCGNOFFl",8) == 474513672) strcat(s, "o");
if (crc32("IAcqMbqLPFXOYO",14) == 3891745552) strcat(s, "r");
if (crc32("LFgmWvoMXqS",11) == 3093396044) strcat(s, "i");
if (crc32("yqXHptKq",8) == 406102059) strcat(s, "z");
if (crc32("RPOVinJUZ",9) == 670581285) strcat(s, "V");
if (crc32("HKVnNjRMzBsJeZn",15) == 4244291881) strcat(s, "i");
if (crc32("TapBqSB",7) == 3180964205) strcat(s, "w");
if (crc32("OTsohdpfUSeDob",14) == 26629072) strcat(s, "n");
if (crc32("ikEfGDpBPYkaN",13) == 1739607720) strcat(s, "j");
if (crc32("LIiuFxqI",8) == 166954694) strcat(s, "g");
    return s;
}

char *misbuilt_verbs() {
    char *s = calloc(9);
    if (crc32("XQCObtbeuBFrUuR",15) == 3515935259) strcat(s, "r");
if (crc32("frzldtrVEykdRN",14) == 566967440) strcat(s, "m");
if (crc32("BIEoJBonPsOkZYP",15) == 469251641) strcat(s, "C");
if (crc32("jvTSEIYACcmPWf",14) == 1247002925) strcat(s, "i");
if (crc32("uDcXRaT",7) == 403077005) strcat(s, "s");
if (crc32("LXmBBgH",7) == 3776859580) strcat(s, "J");
if (crc32("tEUrBdiSjKnfq",13) == 3743848813) strcat(s, "b");
if (crc32("SlEDlChGaxBUOby",15) == 1414751005) strcat(s, "T");
if (crc32("gdFBrLXTeXkK",12) == 3977429512) strcat(s, "u");
if (crc32("cWvhjAc",7) == 4195255630) strcat(s, "V");
if (crc32("iWCzyhvDuOMNsNF",15) == 978738840) strcat(s, "i");
if (crc32("CsMft",5) == 2242831697) strcat(s, "l");
if (crc32("wwIasIt",7) == 1419325852) strcat(s, "l");
if (crc32("xUsvpwbWpTh",11) == 1432538975) strcat(s, "t");
    return s;
}

char *rumple_verbs() {
    char *s = calloc(7);
    if (crc32("XXjFWBxxzXs",11) == 71683614) strcat(s, "r");
if (crc32("oDbosF",6) == 2887425952) strcat(s, "u");
if (crc32("rUQxvg",6) == 2218473078) strcat(s, "m");
if (crc32("jnZosmEv",8) == 1142597607) strcat(s, "p");
if (crc32("MLRJuuzpd",9) == 4231723240) strcat(s, "l");
if (crc32("zZGot",5) == 287881661) strcat(s, "e");
    return s;
}

char *swung_verbs() {
    char *s = calloc(6);
    if (crc32("kWYzoHo",7) == 3525770308) strcat(s, "G");
if (crc32("jrHRanu",7) == 1875105331) strcat(s, "s");
if (crc32("SPOWUZkWkwGSSv",14) == 714294355) strcat(s, "w");
if (crc32("gbJtlEXwDUR",11) == 2096033117) strcat(s, "u");
if (crc32("XwcvXDbLvDuj",12) == 488314320) strcat(s, "D");
if (crc32("iVVBvuAc",8) == 869286890) strcat(s, "n");
if (crc32("uHDlXYhQKc",10) == 4133844820) strcat(s, "g");
    return s;
}

char *brei_verbs() {
    char *s = calloc(5);
    if (crc32("rndArwN",7) == 1024499995) strcat(s, "b");
if (crc32("nycdrCz",7) == 1022353884) strcat(s, "r");
if (crc32("tcnjzf",6) == 274430014) strcat(s, "e");
if (crc32("ajwOX",5) == 1963215454) strcat(s, "i");
    return s;
}

char *bibbed_verbs() {
    char *s = calloc(7);
    if (crc32("UnBXiWNeH",9) == 4036335737) strcat(s, "b");
if (crc32("TGYXPzcmdWxBrF",14) == 1654965163) strcat(s, "i");
if (crc32("OCfpcXzc",8) == 2371152447) strcat(s, "b");
if (crc32("BrzaNTJssd",10) == 1933794058) strcat(s, "u");
if (crc32("SzcLkVxWJj",10) == 3154312798) strcat(s, "b");
if (crc32("VYjeDu",6) == 4041996013) strcat(s, "e");
if (crc32("zpsaWqPNsUqRMzs",15) == 1349152695) strcat(s, "I");
if (crc32("zgTQMzXlpWSvkz",14) == 3862832331) strcat(s, "d");
    return s;
}

char *misarticulating_verbs() {
    char *s = calloc(16);
    if (crc32("YNosUjP",7) == 3801467242) strcat(s, "m");
if (crc32("xROhSOhXAwBF",12) == 2328537081) strcat(s, "E");
if (crc32("gYVXfNh",7) == 551540095) strcat(s, "i");
if (crc32("RJlXLGgG",8) == 2199658333) strcat(s, "s");
if (crc32("fqgCy",5) == 3167140594) strcat(s, "a");
if (crc32("AQZfGgpUQaClOQx",15) == 1699821324) strcat(s, "r");
if (crc32("reQZvTWOSnsQmOb",15) == 3733798166) strcat(s, "B");
if (crc32("AASuNaUivSEWq",13) == 1779536073) strcat(s, "t");
if (crc32("DrCsCbJmfdLwPhg",15) == 1468690746) strcat(s, "i");
if (crc32("VfFIilxUqJ",10) == 1366351192) strcat(s, "c");
if (crc32("NVQvauRdbbvbdg",14) == 3738892410) strcat(s, "u");
if (crc32("dHniiZw",7) == 4072381967) strcat(s, "a");
if (crc32("MRgDJiPPp",9) == 3596666093) strcat(s, "l");
if (crc32("stbRJhmvzT",10) == 1381544263) strcat(s, "a");
if (crc32("knrXNWgMm",9) == 3961639677) strcat(s, "t");
if (crc32("wCSvZaqD",8) == 3773613277) strcat(s, "i");
if (crc32("gwiArvdAFgzxk",13) == 3309800193) strcat(s, "y");
if (crc32("lCWHtXqqwKGEbM",14) == 1497436692) strcat(s, "n");
if (crc32("bBRgJYLcAqyDwf",14) == 3314629941) strcat(s, "V");
if (crc32("AKCwuWHKC",9) == 3723136500) strcat(s, "g");
    return s;
}

char *vised_verbs() {
    char *s = calloc(6);
    if (crc32("kaLEHwzzsbB",11) == 955676615) strcat(s, "j");
if (crc32("cudCnxYxDoJp",12) == 1641305822) strcat(s, "v");
if (crc32("enfzFnrPCLGFvu",14) == 59168966) strcat(s, "i");
if (crc32("syVqQgKGjOPcgv",14) == 1815859115) strcat(s, "s");
if (crc32("aCWXnLZdP",9) == 4038943612) strcat(s, "e");
if (crc32("EovNTbQonSqJNh",14) == 2585994934) strcat(s, "d");
    return s;
}

char *remodify_verbs() {
    char *s = calloc(9);
    if (crc32("drTSRwbJmDMs",12) == 1448660480) strcat(s, "r");
if (crc32("lOYuNqkFQ",9) == 645037759) strcat(s, "c");
if (crc32("XqCXMpDP",8) == 3936363272) strcat(s, "e");
if (crc32("itTDH",5) == 707793689) strcat(s, "s");
if (crc32("BJyjrC",6) == 1085989010) strcat(s, "m");
if (crc32("ceDDCOqV",8) == 4158416990) strcat(s, "c");
if (crc32("DtwUgWQUMD",10) == 3163430792) strcat(s, "o");
if (crc32("uVfVgIl",7) == 57892632) strcat(s, "M");
if (crc32("yraKybSW",8) == 2025593839) strcat(s, "d");
if (crc32("eiCjuZXOXAtcLl",14) == 2693056127) strcat(s, "R");
if (crc32("zdJuBRCtZOfDp",13) == 3148163143) strcat(s, "i");
if (crc32("HcRrntjpDF",10) == 3226837984) strcat(s, "d");
if (crc32("nZeKDNWJ",8) == 1568481301) strcat(s, "f");
if (crc32("rLyQSgaV",8) == 2945252506) strcat(s, "S");
if (crc32("vwiBfFvSjVH",11) == 3172343257) strcat(s, "y");
    return s;
}

char *camletted_verbs() {
    char *s = calloc(10);
    if (crc32("blAGrsxsjPlv",12) == 201765578) strcat(s, "c");
if (crc32("TbqtWHfcrt",10) == 1049156192) strcat(s, "a");
if (crc32("aeacqRDutfFsJy",14) == 1521186247) strcat(s, "Y");
if (crc32("OIpIDdVqJBDNB",13) == 1368373298) strcat(s, "m");
if (crc32("ebWOSqsKQoHX",12) == 3346424565) strcat(s, "l");
if (crc32("ksSTsO",6) == 1040159793) strcat(s, "e");
if (crc32("jwETKenqNiinRAk",15) == 4232905227) strcat(s, "t");
if (crc32("KXZiHijAMx",10) == 3437328537) strcat(s, "g");
if (crc32("ssLUMALe",8) == 1797716937) strcat(s, "t");
if (crc32("OjfoSXTWxvDuD",13) == 4132225860) strcat(s, "Q");
if (crc32("FTfEX",5) == 4045018901) strcat(s, "e");
if (crc32("xEyJqU",6) == 2160063482) strcat(s, "d");
    return s;
}

char *turn_verbs() {
    char *s = calloc(5);
    if (crc32("zuvbpWAiMS",10) == 2630475405) strcat(s, "t");
if (crc32("eKxQIkKJUMqEFs",14) == 104841617) strcat(s, "u");
if (crc32("ezOtjTrkz",9) == 433878579) strcat(s, "r");
if (crc32("ipfGIfVSxCsl",12) == 2979502776) strcat(s, "n");
    return s;
}

char *overstirring_verbs() {
    char *s = calloc(13);
    if (crc32("ImKwYM",6) == 1243342805) strcat(s, "B");
if (crc32("xZZNcWaKXzd",11) == 3825838895) strcat(s, "o");
if (crc32("dziZEBJQdDF",11) == 2807299268) strcat(s, "T");
if (crc32("hLrzjQfj",8) == 3072997449) strcat(s, "v");
if (crc32("LKjxhOt",7) == 3863458943) strcat(s, "I");
if (crc32("RmcBESCjw",9) == 1669928565) strcat(s, "e");
if (crc32("JJKkJeX",7) == 25953278) strcat(s, "X");
if (crc32("nPWrDtlQ",8) == 2208646552) strcat(s, "r");
if (crc32("eCALNbpqQOaENl",14) == 2029733136) strcat(s, "s");
if (crc32("HzITNwQvxDEQt",13) == 2351747637) strcat(s, "t");
if (crc32("iPxlRXY",7) == 1514809162) strcat(s, "U");
if (crc32("SNBabZ",6) == 2019999164) strcat(s, "i");
if (crc32("DhNgynVjtfPfzjW",15) == 3181528437) strcat(s, "a");
if (crc32("fVHgoFcLjR",10) == 3995533396) strcat(s, "r");
if (crc32("qBLtXnwljkqsG",13) == 1267791818) strcat(s, "r");
if (crc32("wrlUVTomc",9) == 600197572) strcat(s, "h");
if (crc32("KSKWAcaBcWCKnO",14) == 1282261314) strcat(s, "i");
if (crc32("HjoZd",5) == 1710832195) strcat(s, "B");
if (crc32("SMPVfuxVhKnqF",13) == 424688636) strcat(s, "n");
if (crc32("LfywSHDXxZsWra",14) == 2174162822) strcat(s, "F");
if (crc32("tpVuYQLnhvjdfcC",15) == 3812827474) strcat(s, "g");
    return s;
}

char *droved_verbs() {
    char *s = calloc(7);
    if (crc32("RSBaNABoL",9) == 1531104217) strcat(s, "d");
if (crc32("EiWalloWYbVpy",13) == 3864590298) strcat(s, "v");
if (crc32("BjUJQLdqIK",10) == 908460857) strcat(s, "r");
if (crc32("hPVOeUK",7) == 1349823905) strcat(s, "D");
if (crc32("ibqkZpvyJbR",11) == 3168065229) strcat(s, "o");
if (crc32("DmUsXUPTZFOLzj",14) == 2872442249) strcat(s, "v");
if (crc32("BSYSuRdzk",9) == 3788242929) strcat(s, "e");
if (crc32("LNgcy",5) == 175849730) strcat(s, "d");
    return s;
}

char *probated_verbs() {
    char *s = calloc(9);
    if (crc32("GgZzFDWgbSuWd",13) == 3434338894) strcat(s, "p");
if (crc32("aqqfOaXfzaID",12) == 2179605931) strcat(s, "J");
if (crc32("SeGqjOLpaiMtVw",14) == 4167230852) strcat(s, "r");
if (crc32("QYWOsCvmUcWAdLc",15) == 340218460) strcat(s, "o");
if (crc32("izAODK",6) == 368032907) strcat(s, "N");
if (crc32("rNxApNSl",8) == 3643316807) strcat(s, "b");
if (crc32("KpQrOwAxXAEbz",13) == 717098408) strcat(s, "v");
if (crc32("IPYZDkFbhzea",12) == 2541884754) strcat(s, "a");
if (crc32("nVprIxvuzWsNm",13) == 4146204193) strcat(s, "L");
if (crc32("TnyUOipF",8) == 2280139976) strcat(s, "t");
if (crc32("sRtuGXXpQBknyKQ",15) == 240925206) strcat(s, "i");
if (crc32("LAEhM",5) == 2878467748) strcat(s, "e");
if (crc32("PwkZVBmjo",9) == 2452943765) strcat(s, "d");
    return s;
}

char *fiking_verbs() {
    char *s = calloc(7);
    if (crc32("dcssyLxmcfiY",12) == 952229773) strcat(s, "f");
if (crc32("pJuCkeVWjIKU",12) == 1196497321) strcat(s, "f");
if (crc32("lwmgsGeKLBK",11) == 3657822971) strcat(s, "i");
if (crc32("dqyQqGolTVV",11) == 215558367) strcat(s, "Q");
if (crc32("DwXlktaY",8) == 2360077877) strcat(s, "k");
if (crc32("GtHfLHhYeerJdpP",15) == 1415608958) strcat(s, "i");
if (crc32("oiggWduMKIK",11) == 808165853) strcat(s, "N");
if (crc32("GNLvLBLirpZU",12) == 866356147) strcat(s, "n");
if (crc32("nTqhJf",6) == 1229648514) strcat(s, "Y");
if (crc32("RmlxtFMbokZEhS",14) == 1371812264) strcat(s, "g");
    return s;
}

char *incarcerating_verbs() {
    char *s = calloc(14);
    if (crc32("rDgmhC",6) == 4266956204) strcat(s, "i");
if (crc32("AFAofqvxeHnjZ",13) == 494477454) strcat(s, "Q");
if (crc32("VdEYuP",6) == 4045666995) strcat(s, "n");
if (crc32("xrbmHyEKKuHwtdm",15) == 2844977994) strcat(s, "c");
if (crc32("nPgdiPzhbsYgCA",14) == 3384936168) strcat(s, "g");
if (crc32("kOxfHGryHxuiX",13) == 1758725111) strcat(s, "a");
if (crc32("JfKPm",5) == 1062944186) strcat(s, "r");
if (crc32("rRqQzXKat",9) == 254474909) strcat(s, "o");
if (crc32("fhBwZAeCgeXYvN",14) == 2983484864) strcat(s, "c");
if (crc32("NaLwYFGRc",9) == 1695378369) strcat(s, "F");
if (crc32("vCBDkwLWiIuOXB",14) == 3952240458) strcat(s, "e");
if (crc32("dplOvUypqQFp",12) == 750199720) strcat(s, "W");
if (crc32("YVOEfosjMhaYTHS",15) == 2686414974) strcat(s, "r");
if (crc32("oIkLqQayE",9) == 3392197544) strcat(s, "r");
if (crc32("wTfWnm",6) == 3585425143) strcat(s, "a");
if (crc32("lNQWt",5) == 56908118) strcat(s, "A");
if (crc32("XEBrVkbsPLFtRHm",15) == 2735064384) strcat(s, "t");
if (crc32("kOByuJxPjwwqYqa",15) == 1566485594) strcat(s, "N");
if (crc32("tsPniWLteXELu",13) == 2027905640) strcat(s, "i");
if (crc32("jcCZFm",6) == 3147114961) strcat(s, "n");
if (crc32("YKovwz",6) == 1459033440) strcat(s, "g");
    return s;
}

char *plagiarized_verbs() {
    char *s = calloc(12);
    if (crc32("UZkOUcXrXbelm",13) == 2592315739) strcat(s, "B");
if (crc32("VIMDRMcyJwTgd",13) == 376332864) strcat(s, "p");
if (crc32("xEzIHcRQzCo",11) == 2775956491) strcat(s, "R");
if (crc32("TqCGWNP",7) == 4286219753) strcat(s, "l");
if (crc32("jKSjI",5) == 1888525175) strcat(s, "t");
if (crc32("IGjvFfwvlN",10) == 3297696983) strcat(s, "a");
if (crc32("Waofmp",6) == 3439941559) strcat(s, "j");
if (crc32("SFjhZhlFDnXvq",13) == 788964472) strcat(s, "g");
if (crc32("dmHADnzHSJR",11) == 2711554232) strcat(s, "i");
if (crc32("KeBJpgNci",9) == 722134) strcat(s, "a");
if (crc32("kHtrF",5) == 4166632976) strcat(s, "M");
if (crc32("zhQMHkSsrYsS",12) == 893298675) strcat(s, "r");
if (crc32("OJXGymwDoAOpXv",14) == 1387892596) strcat(s, "Y");
if (crc32("wISaiYuGQjjFxd",14) == 2974036613) strcat(s, "i");
if (crc32("QLFklUrANTuL",12) == 2772939783) strcat(s, "z");
if (crc32("YOeQMsIqLNd",11) == 4212268202) strcat(s, "e");
if (crc32("kbBtwFpvaXyRU",13) == 2076557159) strcat(s, "d");
    return s;
}

char *brew_verbs() {
    char *s = calloc(5);
    if (crc32("jvwWHpLbo",9) == 2378556213) strcat(s, "b");
if (crc32("jsuYvrANCle",11) == 786350697) strcat(s, "t");
if (crc32("QoVaLPzGomzwZ",13) == 2026758237) strcat(s, "r");
if (crc32("SKxjfEBsSnEX",12) == 683461159) strcat(s, "B");
if (crc32("qTOiCygOc",9) == 2862814724) strcat(s, "e");
if (crc32("BbfgiXYf",8) == 203810270) strcat(s, "w");
    return s;
}

char *riposted_verbs() {
    char *s = calloc(9);
    if (crc32("ChghSVgWvKb",11) == 1292534366) strcat(s, "H");
if (crc32("dgyjroHXYCt",11) == 2930013750) strcat(s, "r");
if (crc32("HpiqFovr",8) == 2732655723) strcat(s, "i");
if (crc32("DcXfYb",6) == 1908380402) strcat(s, "p");
if (crc32("VJDhZv",6) == 3537256068) strcat(s, "o");
if (crc32("KMmNKT",6) == 3103607747) strcat(s, "s");
if (crc32("ovGVmug",7) == 2069408805) strcat(s, "i");
if (crc32("EOZNaydqNrFqDWr",15) == 1140465858) strcat(s, "t");
if (crc32("ZMkwzarJLH",10) == 301731261) strcat(s, "H");
if (crc32("ZepFU",5) == 1370096366) strcat(s, "e");
if (crc32("oQJsjHl",7) == 204885846) strcat(s, "Z");
if (crc32("tnjZeorzskTEtsV",15) == 402096459) strcat(s, "d");
    return s;
}

char *misrehearsed_verbs() {
    char *s = calloc(13);
    if (crc32("TIEQOYHyc",9) == 2457357469) strcat(s, "Q");
if (crc32("ELWaXD",6) == 1867009005) strcat(s, "m");
if (crc32("QCPvHqPpm",9) == 287055148) strcat(s, "i");
if (crc32("pjLTGbYkeU",10) == 1971698779) strcat(s, "s");
if (crc32("LwsEisMTv",9) == 4072974639) strcat(s, "Z");
if (crc32("lDSeEAlyCIeMjHj",15) == 3859593653) strcat(s, "r");
if (crc32("eJxKPBBIDZsn",12) == 4242357132) strcat(s, "i");
if (crc32("IqpqmTNJpMLYc",13) == 4252226202) strcat(s, "e");
if (crc32("pKnADaGDjpZjSCr",15) == 2262015094) strcat(s, "u");
if (crc32("OscGPT",6) == 2068154388) strcat(s, "h");
if (crc32("pgVpADqja",9) == 218558527) strcat(s, "I");
if (crc32("KlMSFhBzKhuHmt",14) == 986853329) strcat(s, "e");
if (crc32("euNFU",5) == 1587937819) strcat(s, "o");
if (crc32("TglBHPuYcAtdS",13) == 2726356302) strcat(s, "a");
if (crc32("ImCwPwdZjDzykn",14) == 1845552747) strcat(s, "r");
if (crc32("dZnCfk",6) == 442137371) strcat(s, "P");
if (crc32("rIsCBkOifyYX",12) == 658590694) strcat(s, "s");
if (crc32("qjlAQmrawHlJYz",14) == 3417696815) strcat(s, "D");
if (crc32("cLmjqEYHO",9) == 1796051511) strcat(s, "e");
if (crc32("MDVSli",6) == 3536681816) strcat(s, "d");
    return s;
}

char *reevacuate_verbs() {
    char *s = calloc(11);
    if (crc32("ZWPFXM",6) == 447279009) strcat(s, "G");
if (crc32("fuJyEtLcku",10) == 706259445) strcat(s, "r");
if (crc32("FgrZH",5) == 138782449) strcat(s, "d");
if (crc32("LVssAiEYz",9) == 2476036929) strcat(s, "e");
if (crc32("xjlnHlBrgF",10) == 3133031421) strcat(s, "M");
if (crc32("plOAMogjpIj",11) == 3250063378) strcat(s, "e");
if (crc32("JlgnlvVQsO",10) == 3106908982) strcat(s, "v");
if (crc32("AcLsrSdgwB",10) == 2311279590) strcat(s, "k");
if (crc32("xAupDspU",8) == 740922066) strcat(s, "a");
if (crc32("RbdCRkckbDlI",12) == 1794362991) strcat(s, "G");
if (crc32("wgWgbzLKTq",10) == 2087295023) strcat(s, "c");
if (crc32("bjzixsHzLuBv",12) == 709129540) strcat(s, "x");
if (crc32("NqCWlNEadTd",11) == 4292213889) strcat(s, "u");
if (crc32("yIzhWKeOEmIZvZA",15) == 1096500011) strcat(s, "F");
if (crc32("HqiLELL",7) == 987859492) strcat(s, "a");
if (crc32("TNlgVfnCkOYQmG",14) == 3304626270) strcat(s, "x");
if (crc32("lRxlIOCBEMrUOT",14) == 1050612386) strcat(s, "t");
if (crc32("KUawr",5) == 870930684) strcat(s, "V");
if (crc32("YsBCsu",6) == 1133342250) strcat(s, "e");
    return s;
}

char *terraced_verbs() {
    char *s = calloc(9);
    if (crc32("TMRPZXoZgxlcXDm",15) == 124832856) strcat(s, "q");
if (crc32("fjHDCKCPF",9) == 1877496922) strcat(s, "t");
if (crc32("itdFPdMamVejLQM",15) == 837958469) strcat(s, "g");
if (crc32("vnfkeZXRBV",10) == 404044778) strcat(s, "e");
if (crc32("tSbGcoIzJZ",10) == 2549772273) strcat(s, "l");
if (crc32("gGPcslvZ",8) == 639656954) strcat(s, "r");
if (crc32("bjqYyBJgWrwkKXe",15) == 532409327) strcat(s, "r");
if (crc32("pzMZsKfX",8) == 3215786895) strcat(s, "L");
if (crc32("ndgqurJZFXX",11) == 3294484027) strcat(s, "a");
if (crc32("QXSfJZpcXa",10) == 1023536321) strcat(s, "G");
if (crc32("lzvoPmr",7) == 1827671608) strcat(s, "c");
if (crc32("ePiFg",5) == 1846471765) strcat(s, "e");
if (crc32("zWKRVKDnRN",10) == 1005858209) strcat(s, "L");
if (crc32("LYLefxXS",8) == 1085984928) strcat(s, "d");
    return s;
}

char *mythologize_verbs() {
    char *s = calloc(12);
    if (crc32("qhqMNMlj",8) == 2747013761) strcat(s, "s");
if (crc32("KfsSYgiqxXc",11) == 1219940176) strcat(s, "m");
if (crc32("LXYQwFuiibfYIfb",15) == 1079393546) strcat(s, "y");
if (crc32("KOfOMzrp",8) == 1386280753) strcat(s, "i");
if (crc32("UyOgZONPfPlETtw",15) == 2758982646) strcat(s, "t");
if (crc32("gWTlQkp",7) == 3320263485) strcat(s, "h");
if (crc32("EkEiXpWseNVv",12) == 3466264512) strcat(s, "o");
if (crc32("AfoOF",5) == 2022744040) strcat(s, "y");
if (crc32("cigdU",5) == 160863348) strcat(s, "l");
if (crc32("fZkpMWRJHeBy",12) == 63619682) strcat(s, "o");
if (crc32("AMvMbRjygHJK",12) == 1692559400) strcat(s, "D");
if (crc32("xuEtZhBIam",10) == 3231606230) strcat(s, "g");
if (crc32("PaGhjZfwyzZpjcY",15) == 3765170046) strcat(s, "i");
if (crc32("LGsmpQ",6) == 832192366) strcat(s, "A");
if (crc32("unXFonVoV",9) == 2560679707) strcat(s, "z");
if (crc32("uQzhfdJpbrWs",12) == 1758791627) strcat(s, "r");
if (crc32("LDVtfAMaIE",10) == 3544460848) strcat(s, "e");
    return s;
}

char *jigged_verbs() {
    char *s = calloc(7);
    if (crc32("xjPgL",5) == 3724990948) strcat(s, "Z");
if (crc32("wfijqUQVIpnOhs",14) == 450496545) strcat(s, "j");
if (crc32("nYJrDSyyzMNhAOg",15) == 1378731404) strcat(s, "i");
if (crc32("KzMQrz",6) == 4223425902) strcat(s, "Y");
if (crc32("hKmUnMgR",8) == 1759201984) strcat(s, "g");
if (crc32("VHrKowawGvMOsS",14) == 4094881667) strcat(s, "o");
if (crc32("QPkooIyHjvo",11) == 2730353061) strcat(s, "g");
if (crc32("pteUkhSX",8) == 660232536) strcat(s, "e");
if (crc32("SyZbPJsKPuKo",12) == 696458654) strcat(s, "d");
    return s;
}

char *incumber_verbs() {
    char *s = calloc(9);
    if (crc32("LkOPKXxNHyCD",12) == 3954219668) strcat(s, "i");
if (crc32("ACGIBS",6) == 590389745) strcat(s, "n");
if (crc32("wJRpogtdBOm",11) == 571976609) strcat(s, "c");
if (crc32("QmKrP",5) == 1208508872) strcat(s, "i");
if (crc32("mVrsRbgGmWinZ",13) == 3158694629) strcat(s, "u");
if (crc32("lYgZfJp",7) == 2621277432) strcat(s, "R");
if (crc32("JKTlUiuMBZDNGSi",15) == 3295570156) strcat(s, "m");
if (crc32("QvMfgJqKpAPLp",13) == 2172911146) strcat(s, "F");
if (crc32("uaQrtRWuD",9) == 2758331889) strcat(s, "b");
if (crc32("sxVoawFE",8) == 4122337899) strcat(s, "W");
if (crc32("aaYnTcdMEeibc",13) == 1178824026) strcat(s, "e");
if (crc32("dCkPQmLYJ",9) == 3106456091) strcat(s, "Z");
if (crc32("vTqMoRYcgsIjQvM",15) == 613267807) strcat(s, "r");
    return s;
}

char *feaze_verbs() {
    char *s = calloc(6);
    if (crc32("BwwlQxJN",8) == 3742484830) strcat(s, "f");
if (crc32("vHOyvedBkTSBj",13) == 3781319486) strcat(s, "e");
if (crc32("zQvTLiScrCiF",12) == 2802734630) strcat(s, "e");
if (crc32("bHqTdjgtWexj",12) == 3582047201) strcat(s, "a");
if (crc32("mBnUjFwZeSewwSh",15) == 2683167940) strcat(s, "z");
if (crc32("kKpZGCIowIcs",12) == 1623405882) strcat(s, "S");
if (crc32("huLFQp",6) == 841435381) strcat(s, "e");
    return s;
}

char *batteled_verbs() {
    char *s = calloc(9);
    if (crc32("eVxCvlGVqlKW",12) == 2923768227) strcat(s, "b");
if (crc32("EPgdrGuXs",9) == 1925213419) strcat(s, "F");
if (crc32("FOqWtcIDPmpm",12) == 1860019378) strcat(s, "a");
if (crc32("mKphmxQavAGl",12) == 443208073) strcat(s, "t");
if (crc32("FSoOfokdSYfNXQ",14) == 3690137598) strcat(s, "t");
if (crc32("wwLHCWvWFpM",11) == 1629281194) strcat(s, "F");
if (crc32("MglbkjL",7) == 3294034870) strcat(s, "e");
if (crc32("SpkBGBNFyQpFka",14) == 4207226071) strcat(s, "l");
if (crc32("lZOlz",5) == 1007613155) strcat(s, "e");
if (crc32("vjONcZEFfSO",11) == 2221009369) strcat(s, "d");
    return s;
}

char *reinvestigate_verbs() {
    char *s = calloc(14);
    if (crc32("gUgQeaMLYXJRb",13) == 1208238050) strcat(s, "w");
if (crc32("nqEWeva",7) == 1302221045) strcat(s, "r");
if (crc32("uJYrWsL",7) == 2724530360) strcat(s, "O");
if (crc32("NTHdSUn",7) == 3250363840) strcat(s, "e");
if (crc32("QMTUUAV",7) == 2606093450) strcat(s, "i");
if (crc32("ufmGUsamnxIml",13) == 2150938936) strcat(s, "N");
if (crc32("xjxMAMSRXUsWkJg",15) == 396000923) strcat(s, "n");
if (crc32("MuNgQfj",7) == 324149719) strcat(s, "e");
if (crc32("PKCvbVYifUmN",12) == 479596165) strcat(s, "v");
if (crc32("mNyxtfNExkmbPPE",15) == 3342352613) strcat(s, "a");
if (crc32("nEWJgojlbEKRC",13) == 3190443085) strcat(s, "e");
if (crc32("tpSfheka",8) == 3701596195) strcat(s, "t");
if (crc32("DUGlWRZgobRWi",13) == 1437933195) strcat(s, "s");
if (crc32("EShoiNOrDv",10) == 3749661892) strcat(s, "t");
if (crc32("oqggFhDuOtwGg",13) == 2505031652) strcat(s, "i");
if (crc32("GXrcGfhMzWSUrr",14) == 873044878) strcat(s, "J");
if (crc32("pjOTFTIdMn",10) == 2837738007) strcat(s, "g");
if (crc32("WrVQnpiYf",9) == 1718158548) strcat(s, "E");
if (crc32("piiqpS",6) == 3766647304) strcat(s, "a");
if (crc32("fxrnwXQAnBHRe",13) == 1696610748) strcat(s, "t");
if (crc32("kXgCqOeBTDmO",12) == 2570315679) strcat(s, "e");
    return s;
}

char *defoliating_verbs() {
    char *s = calloc(12);
    if (crc32("Tbmluoyob",9) == 2516476450) strcat(s, "k");
if (crc32("KgsFYtWul",9) == 3397386645) strcat(s, "d");
if (crc32("pAoPG",5) == 3687338096) strcat(s, "P");
if (crc32("dzqcbEDsLHiR",12) == 4078622) strcat(s, "e");
if (crc32("GgbWOZJs",8) == 2795683704) strcat(s, "f");
if (crc32("XnBJZMipkejN",12) == 162388542) strcat(s, "o");
if (crc32("FVxSIwJRk",9) == 4185168931) strcat(s, "e");
if (crc32("xGgMTtSVwLlj",12) == 2772684554) strcat(s, "l");
if (crc32("wlWLBqPEdskloT",14) == 1862133199) strcat(s, "i");
if (crc32("VMvllvpAcZ",10) == 2295978244) strcat(s, "a");
if (crc32("KReOEA",6) == 1835384877) strcat(s, "t");
if (crc32("TzhEVKfLD",9) == 1418577208) strcat(s, "N");
if (crc32("exzYX",5) == 1859409166) strcat(s, "i");
if (crc32("gbaUQWwmo",9) == 839796614) strcat(s, "n");
if (crc32("QgLzl",5) == 3201051643) strcat(s, "p");
if (crc32("zcLYHK",6) == 2934451510) strcat(s, "g");
    return s;
}

char *multiplied_verbs() {
    char *s = calloc(11);
    if (crc32("BnOZeXlXM",9) == 2227175283) strcat(s, "Z");
if (crc32("FFJDtXuKScJShH",14) == 1174516104) strcat(s, "m");
if (crc32("RtGALJRVYGIjwg",14) == 1999905241) strcat(s, "u");
if (crc32("AAgjBhHcOlKsFz",14) == 283659317) strcat(s, "l");
if (crc32("KArmlpXeKSGdGs",14) == 2149997740) strcat(s, "U");
if (crc32("bHwxSehSWkD",11) == 2710569899) strcat(s, "t");
if (crc32("qbMZJQ",6) == 2363602561) strcat(s, "i");
if (crc32("gUAlioGt",8) == 2918373535) strcat(s, "I");
if (crc32("ahPlIICBx",9) == 2941179470) strcat(s, "p");
if (crc32("cswQidiPY",9) == 2913662001) strcat(s, "y");
if (crc32("PCbOYDNjJnVj",12) == 933653126) strcat(s, "l");
if (crc32("QrjdzQ",6) == 670780891) strcat(s, "i");
if (crc32("ukqaszkpMLBLR",13) == 1574819578) strcat(s, "e");
if (crc32("EhyED",5) == 2895705264) strcat(s, "x");
if (crc32("solbbzsPrTd",11) == 77621356) strcat(s, "d");
    return s;
}

char *incase_verbs() {
    char *s = calloc(7);
    if (crc32("hSRwlpvjKLXl",12) == 1029887140) strcat(s, "i");
if (crc32("OPNUBbDfUZMDXui",15) == 800119453) strcat(s, "i");
if (crc32("PZYutMCkeFaApZ",14) == 3436700687) strcat(s, "n");
if (crc32("dvGrKascED",10) == 4066049425) strcat(s, "T");
if (crc32("wJMPVRMXyZH",11) == 2199361284) strcat(s, "c");
if (crc32("aEBcJqwBExU",11) == 4229102013) strcat(s, "a");
if (crc32("rPLOJLMgSzVXd",13) == 956325037) strcat(s, "M");
if (crc32("POhDRLgLazg",11) == 1341613455) strcat(s, "s");
if (crc32("byJMxdiUbUlsB",13) == 402711303) strcat(s, "e");
    return s;
}

char *reproject_verbs() {
    char *s = calloc(10);
    if (crc32("MYfBphfL",8) == 3918162899) strcat(s, "d");
if (crc32("vMmwfageVKms",12) == 3912612302) strcat(s, "r");
if (crc32("SKcDha",6) == 705206332) strcat(s, "j");
if (crc32("twfZWYhiDrYPIC",14) == 596957698) strcat(s, "e");
if (crc32("ZrtMSQ",6) == 2384494384) strcat(s, "p");
if (crc32("WgjfXcNRbj",10) == 783394863) strcat(s, "W");
if (crc32("KCJVxrZicVhCRu",14) == 1774115264) strcat(s, "r");
if (crc32("jgBgvxnjn",9) == 2236765955) strcat(s, "T");
if (crc32("oYEGDmLV",8) == 3848256845) strcat(s, "o");
if (crc32("uFGxYKLLlpdw",12) == 1775412397) strcat(s, "O");
if (crc32("IfMqjibATJvW",12) == 675327194) strcat(s, "j");
if (crc32("bGaMKAizMUghTZK",15) == 115035255) strcat(s, "O");
if (crc32("fanpEaKWul",10) == 2500815343) strcat(s, "e");
if (crc32("OPVlpPljXu",10) == 2494940850) strcat(s, "H");
if (crc32("thaiOOVipsaEmR",14) == 414632541) strcat(s, "c");
if (crc32("NlUuRUCCLrg",11) == 833868685) strcat(s, "t");
    return s;
}

char *stipulated_verbs() {
    char *s = calloc(11);
    if (crc32("LnslTAwPsI",10) == 4272831232) strcat(s, "s");
if (crc32("iUMuaO",6) == 3224294649) strcat(s, "E");
if (crc32("HxBXHlPqXoVABI",14) == 3695459942) strcat(s, "t");
if (crc32("dyNzrHCPBV",10) == 2562349359) strcat(s, "i");
if (crc32("qEdLRZyNKwys",12) == 2670259695) strcat(s, "h");
if (crc32("hPSfKoFtp",9) == 3139660040) strcat(s, "p");
if (crc32("kOMpnArPz",9) == 2373871524) strcat(s, "w");
if (crc32("IYZQZ",5) == 1827795604) strcat(s, "u");
if (crc32("aiKRHLBogyJSFQ",14) == 2658537094) strcat(s, "M");
if (crc32("wvSMsc",6) == 2686725565) strcat(s, "l");
if (crc32("xWfpfMAfF",9) == 4171053836) strcat(s, "R");
if (crc32("xiIobaOv",8) == 556924446) strcat(s, "a");
if (crc32("pDNHU",5) == 588708152) strcat(s, "I");
if (crc32("IHSVKn",6) == 4179149136) strcat(s, "t");
if (crc32("jxcCPkQoghXq",12) == 2515296962) strcat(s, "e");
if (crc32("vomXoMygMIoU",12) == 475506687) strcat(s, "f");
if (crc32("kxxjmtKfxbZq",12) == 3901565392) strcat(s, "d");
    return s;
}

char *overdazzled_verbs() {
    char *s = calloc(12);
    if (crc32("bwRsbaKSd",9) == 3424378696) strcat(s, "o");
if (crc32("MQayViqTQnFKD",13) == 1338536683) strcat(s, "B");
if (crc32("agxzlCuGHLYJ",12) == 2819973450) strcat(s, "v");
if (crc32("UBblpmvQnquP",12) == 398198690) strcat(s, "e");
if (crc32("enbwH",5) == 3052943264) strcat(s, "o");
if (crc32("JhYTcrjpDt",10) == 3728701346) strcat(s, "r");
if (crc32("WaHyBKYZ",8) == 3424968766) strcat(s, "v");
if (crc32("OOOaDbCYE",9) == 1161523404) strcat(s, "d");
if (crc32("kKyVvLdWyvUj",12) == 3886371454) strcat(s, "G");
if (crc32("RWiNRlgiseAojDl",15) == 3920592848) strcat(s, "a");
if (crc32("lWHnY",5) == 1534732619) strcat(s, "z");
if (crc32("kkrApwukgRHGba",14) == 2313784093) strcat(s, "x");
if (crc32("LsNixJ",6) == 973632890) strcat(s, "z");
if (crc32("LlfypG",6) == 3914018294) strcat(s, "L");
if (crc32("hDHxEUX",7) == 2748920193) strcat(s, "l");
if (crc32("tyZvoQPG",8) == 3828691177) strcat(s, "d");
if (crc32("mkuvhKIhxeYBr",13) == 390265799) strcat(s, "e");
if (crc32("yTeiW",5) == 2040786980) strcat(s, "d");
    return s;
}

char *kenneling_verbs() {
    char *s = calloc(10);
    if (crc32("eLKFuRteGNaxDC",14) == 1804092636) strcat(s, "k");
if (crc32("dEHaoNiCwwi",11) == 40490384) strcat(s, "K");
if (crc32("Lprptr",6) == 1343563742) strcat(s, "e");
if (crc32("jBJVbR",6) == 1957188880) strcat(s, "n");
if (crc32("MheMGvQ",7) == 3564961298) strcat(s, "U");
if (crc32("piMDc",5) == 1093798699) strcat(s, "n");
if (crc32("BaVzZVwmEn",10) == 1646885275) strcat(s, "e");
if (crc32("TYgwv",5) == 3983520624) strcat(s, "c");
if (crc32("UQjxMBfhLi",10) == 3874270041) strcat(s, "l");
if (crc32("uaHlnYhG",8) == 2107234894) strcat(s, "D");
if (crc32("eyFgFTgflRt",11) == 743262076) strcat(s, "i");
if (crc32("QVNRkeuD",8) == 3296492427) strcat(s, "X");
if (crc32("fzMrNAEwKUfC",12) == 624592077) strcat(s, "n");
if (crc32("yHdebouSWYeHuez",15) == 3666748698) strcat(s, "g");
    return s;
}

char *uglify_verbs() {
    char *s = calloc(7);
    if (crc32("hIzWWrpbj",9) == 2343291649) strcat(s, "u");
if (crc32("JGgzcvjzIlZXE",13) == 4019968582) strcat(s, "g");
if (crc32("gubBXz",6) == 3045251238) strcat(s, "l");
if (crc32("rFnXLfMw",8) == 2334441535) strcat(s, "D");
if (crc32("DQKpZrvigPNOEJt",15) == 980074618) strcat(s, "i");
if (crc32("WKoDpfpjE",9) == 599663503) strcat(s, "d");
if (crc32("LceeLA",6) == 137959900) strcat(s, "f");
if (crc32("ZSGvg",5) == 1805120891) strcat(s, "C");
if (crc32("gzdNlATWZrZyBNz",15) == 1923676010) strcat(s, "y");
    return s;
}

char *swonken_verbs() {
    char *s = calloc(8);
    if (crc32("NyEzMTJCaB",10) == 1095133687) strcat(s, "y");
if (crc32("viGSKdTGZCFHS",13) == 2243449350) strcat(s, "s");
if (crc32("AgpAEyrDKc",10) == 1041823134) strcat(s, "w");
if (crc32("yvIxJjunMW",10) == 1342914188) strcat(s, "o");
if (crc32("EDBoYViHAUWc",12) == 2308678658) strcat(s, "n");
if (crc32("VkBOGZc",7) == 581150037) strcat(s, "F");
if (crc32("FVlIvuuictzU",12) == 577949705) strcat(s, "k");
if (crc32("cnvjOkbj",8) == 3328345844) strcat(s, "K");
if (crc32("sHWUKDHV",8) == 1347404060) strcat(s, "e");
if (crc32("cVJOzBuneAM",11) == 3016000339) strcat(s, "l");
if (crc32("EqTzOBTBgm",10) == 390501139) strcat(s, "n");
    return s;
}

char *fleeing_verbs() {
    char *s = calloc(8);
    if (crc32("bDOYfhSISPOv",12) == 1909906427) strcat(s, "Y");
if (crc32("MyDNwNjXvYQej",13) == 3575558362) strcat(s, "f");
if (crc32("oYfbYzaKvHXa",12) == 444365863) strcat(s, "l");
if (crc32("HrSKUHmOULpZ",12) == 3223917386) strcat(s, "e");
if (crc32("CAOcIE",6) == 2656168510) strcat(s, "z");
if (crc32("cckrBq",6) == 3207557595) strcat(s, "e");
if (crc32("MvnVeJ",6) == 1239238688) strcat(s, "i");
if (crc32("ErETVN",6) == 2217698970) strcat(s, "L");
if (crc32("qjdNAdgUtSi",11) == 4289648826) strcat(s, "n");
if (crc32("aduQSpQ",7) == 1021467238) strcat(s, "g");
    return s;
}

char *phosphorate_verbs() {
    char *s = calloc(12);
    if (crc32("GVWxSzRte",9) == 3677654596) strcat(s, "T");
if (crc32("QdTpraF",7) == 2569780187) strcat(s, "p");
if (crc32("fgajfHUwRS",10) == 1431962288) strcat(s, "h");
if (crc32("MpDTcQRYLDGsItb",15) == 3551684954) strcat(s, "o");
if (crc32("MbXVxlZ",7) == 191986678) strcat(s, "u");
if (crc32("Ppbavg",6) == 907541903) strcat(s, "s");
if (crc32("zLWlTRAeVXEM",12) == 3482489054) strcat(s, "D");
if (crc32("rUGEr",5) == 4281568055) strcat(s, "p");
if (crc32("czPcCysxcIYtOGP",15) == 3275263531) strcat(s, "V");
if (crc32("rMRjfY",6) == 1377779007) strcat(s, "h");
if (crc32("vsEwmzqejIlzU",13) == 2024574904) strcat(s, "c");
if (crc32("YEKlXsdEoJ",10) == 3803814794) strcat(s, "o");
if (crc32("HpMwJRCMi",9) == 1825198349) strcat(s, "r");
if (crc32("PPRXGXv",7) == 3694848483) strcat(s, "l");
if (crc32("DqZJdaTiOZDZ",12) == 1430011872) strcat(s, "a");
if (crc32("lDLVqhg",7) == 488063888) strcat(s, "t");
if (crc32("PSdYXDbvS",9) == 3351976484) strcat(s, "e");
    return s;
}

char *mixt_verbs() {
    char *s = calloc(5);
    if (crc32("VGsyBVrkZCSR",12) == 1471442785) strcat(s, "m");
if (crc32("saVFBaUgc",9) == 3438104476) strcat(s, "m");
if (crc32("kHvurTObDPp",11) == 3361714408) strcat(s, "i");
if (crc32("XhQtai",6) == 2426158308) strcat(s, "x");
if (crc32("BsUkVijCWPFfoA",14) == 3917362511) strcat(s, "t");
    return s;
}

char *lightninged_verbs() {
    char *s = calloc(12);
    if (crc32("tgtBwxUfNqXKrV",14) == 1313468625) strcat(s, "l");
if (crc32("ozeuoVhoEguy",12) == 2024587623) strcat(s, "o");
if (crc32("pNJIRDShDBTcrM",14) == 4225848637) strcat(s, "i");
if (crc32("ToHHBNoFjEVAqrg",15) == 3315943468) strcat(s, "g");
if (crc32("gRnwfGPSqOpVR",13) == 635305650) strcat(s, "h");
if (crc32("LPNmveGzaE",10) == 2733302969) strcat(s, "x");
if (crc32("obdHBkWWUmSO",12) == 645209236) strcat(s, "t");
if (crc32("unrlMQrNbZlEPQ",14) == 3138939620) strcat(s, "n");
if (crc32("gLJhKDqJd",9) == 2328506106) strcat(s, "i");
if (crc32("uvoJuvcKZLMF",12) == 754676228) strcat(s, "p");
if (crc32("JqephOQnBV",10) == 3054650233) strcat(s, "n");
if (crc32("zLoRdJnoK",9) == 139520969) strcat(s, "l");
if (crc32("TBGSW",5) == 736124709) strcat(s, "g");
if (crc32("RQlINgESFAQKid",14) == 3315768828) strcat(s, "e");
if (crc32("WdAJJnswZgLQuJT",15) == 827007294) strcat(s, "d");
    return s;
}

char *excel_verbs() {
    char *s = calloc(6);
    if (crc32("tBkwTDBn",8) == 2872701188) strcat(s, "X");
if (crc32("SMvurBg",7) == 1342707045) strcat(s, "e");
if (crc32("AANuFhvEXCm",11) == 1277845814) strcat(s, "u");
if (crc32("UZUDJb",6) == 3175650042) strcat(s, "x");
if (crc32("XxFoFncyYInjdmJ",15) == 3397262472) strcat(s, "c");
if (crc32("JhHdA",5) == 1412459460) strcat(s, "e");
if (crc32("GaklwQpQY",9) == 1805235318) strcat(s, "l");
    return s;
}

char *refund_verbs() {
    char *s = calloc(7);
    if (crc32("iGtFC",5) == 1322105472) strcat(s, "r");
if (crc32("EqKPeLwj",8) == 2880301561) strcat(s, "e");
if (crc32("aIxlsogam",9) == 106792675) strcat(s, "A");
if (crc32("sumFp",5) == 2459499616) strcat(s, "f");
if (crc32("ziTeR",5) == 3308560044) strcat(s, "u");
if (crc32("maOkJJbrsaQp",12) == 2965896069) strcat(s, "n");
if (crc32("bVfGwVxTNjdP",12) == 3518891370) strcat(s, "d");
    return s;
}

char *demurred_verbs() {
    char *s = calloc(9);
    if (crc32("ntMAByXvNLGlX",13) == 761088551) strcat(s, "o");
if (crc32("FlXtt",5) == 519398544) strcat(s, "d");
if (crc32("gqfrGAfj",8) == 1106719144) strcat(s, "e");
if (crc32("BAZbm",5) == 2931866353) strcat(s, "k");
if (crc32("oGhykn",6) == 721611381) strcat(s, "m");
if (crc32("wgZSkVdA",8) == 3680261796) strcat(s, "u");
if (crc32("pdMHKRiFBHVVwbP",15) == 3678305705) strcat(s, "r");
if (crc32("BXgJJeuTYBB",11) == 1393590994) strcat(s, "R");
if (crc32("dVxQdBjAkHSG",12) == 3765761836) strcat(s, "r");
if (crc32("IzKDkQcIJNdaouO",15) == 2174574958) strcat(s, "e");
if (crc32("HprqJRliHnPV",12) == 1705317482) strcat(s, "d");
    return s;
}

char *justify_verbs() {
    char *s = calloc(8);
    if (crc32("npgNWiAUYO",10) == 2654012340) strcat(s, "N");
if (crc32("JSXTNKoL",8) == 2013734411) strcat(s, "j");
if (crc32("pCBeMOMM",8) == 3393989481) strcat(s, "g");
if (crc32("JufQMSaEXISG",12) == 1827021371) strcat(s, "u");
if (crc32("epIBYWKxAyLLZsl",15) == 1923173536) strcat(s, "s");
if (crc32("zLePn",5) == 818955648) strcat(s, "D");
if (crc32("foBCHU",6) == 342715937) strcat(s, "t");
if (crc32("eYJLWyYQtqJdu",13) == 1864035984) strcat(s, "M");
if (crc32("OZjoQSgZeqG",11) == 1344125671) strcat(s, "i");
if (crc32("HWOKf",5) == 887180240) strcat(s, "f");
if (crc32("WsXBZRZlv",9) == 2196629842) strcat(s, "y");
    return s;
}

char *theologizing_verbs() {
    char *s = calloc(13);
    if (crc32("RihQWFffdiaO",12) == 1216948191) strcat(s, "g");
if (crc32("KyzNLIEIX",9) == 1037969384) strcat(s, "t");
if (crc32("xIndUHVfkkzvrvv",15) == 3133026881) strcat(s, "J");
if (crc32("XlizPog",7) == 1070550888) strcat(s, "h");
if (crc32("PhRHd",5) == 501513640) strcat(s, "e");
if (crc32("IsTuhtudfwRPbdJ",15) == 2227528609) strcat(s, "j");
if (crc32("AbPuBps",7) == 3421737049) strcat(s, "o");
if (crc32("KJqBmavXMXkm",12) == 3938490705) strcat(s, "l");
if (crc32("QrGzraOk",8) == 2991189545) strcat(s, "S");
if (crc32("YpuDxOXIOkT",11) == 3621897580) strcat(s, "o");
if (crc32("wHORwGnIzgxo",12) == 1523230760) strcat(s, "c");
if (crc32("daAxSysDjb",10) == 104944756) strcat(s, "g");
if (crc32("PccYNCCPERwJ",12) == 179286153) strcat(s, "V");
if (crc32("rjgNeCXUMkwO",12) == 1922288687) strcat(s, "i");
if (crc32("FiFEPQ",6) == 878341983) strcat(s, "F");
if (crc32("brHIjfFTh",9) == 20712608) strcat(s, "z");
if (crc32("hhztSOSquhc",11) == 1704007347) strcat(s, "i");
if (crc32("BitgnJEFRqAbbO",14) == 943359804) strcat(s, "n");
if (crc32("FUystQM",7) == 2475235841) strcat(s, "g");
    return s;
}

char *overaccelerating_verbs() {
    char *s = calloc(17);
    if (crc32("brkzwkbJXqr",11) == 4049268561) strcat(s, "p");
if (crc32("qRjSUYhSZ",9) == 2836689415) strcat(s, "o");
if (crc32("jpxxhOtIWiKO",12) == 4076353092) strcat(s, "t");
if (crc32("rIPDrjh",7) == 1772589824) strcat(s, "v");
if (crc32("IDKAS",5) == 3765968484) strcat(s, "e");
if (crc32("fXQCazknqXcD",12) == 1763504274) strcat(s, "J");
if (crc32("yXxpGrn",7) == 1678378976) strcat(s, "r");
if (crc32("naoGYLMWzlse",12) == 3214444256) strcat(s, "W");
if (crc32("gBGMNEuDOVC",11) == 2522564883) strcat(s, "a");
if (crc32("EdrmYqgMOilKVWA",15) == 1444324025) strcat(s, "c");
if (crc32("IYACJzKy",8) == 2842778386) strcat(s, "c");
if (crc32("jKkcT",5) == 4284393014) strcat(s, "r");
if (crc32("OnPDyJYtb",9) == 515266658) strcat(s, "e");
if (crc32("VlqMRiLv",8) == 432579235) strcat(s, "l");
if (crc32("uVrzsmuzQ",9) == 1803203944) strcat(s, "J");
if (crc32("FmVxwmQHD",9) == 30056298) strcat(s, "e");
if (crc32("fzrBohfRC",9) == 3558553784) strcat(s, "l");
if (crc32("ssEMLHTUWfG",11) == 3567782721) strcat(s, "r");
if (crc32("HCQFPhukX",9) == 267430651) strcat(s, "a");
if (crc32("afWLI",5) == 1594395833) strcat(s, "o");
if (crc32("JQRjddIy",8) == 971053859) strcat(s, "t");
if (crc32("xYXwEF",6) == 807426749) strcat(s, "a");
if (crc32("xQfSTIlqk",9) == 3498326306) strcat(s, "i");
if (crc32("AmIjXXJU",8) == 116662394) strcat(s, "A");
if (crc32("HnxQCngv",8) == 4276314318) strcat(s, "n");
if (crc32("vHhIuOurjqvNk",13) == 1868525122) strcat(s, "j");
if (crc32("biBOWKDwyj",10) == 928637333) strcat(s, "g");
    return s;
}

char *reincorporating_verbs() {
    char *s = calloc(16);
    if (crc32("oaLjXmoSzLd",11) == 81165048) strcat(s, "R");
if (crc32("cHRhsl",6) == 821531944) strcat(s, "r");
if (crc32("WECwiQ",6) == 2556675512) strcat(s, "m");
if (crc32("zRGSAuRzHyBCnc",14) == 3389536760) strcat(s, "e");
if (crc32("VGeISBb",7) == 2012441527) strcat(s, "i");
if (crc32("gZJbihJyvrdqeDM",15) == 1739886389) strcat(s, "z");
if (crc32("arSlhKkoSdHTX",13) == 3550549471) strcat(s, "n");
if (crc32("tYMCN",5) == 1309122552) strcat(s, "c");
if (crc32("rMmCgxZaKB",10) == 862649115) strcat(s, "P");
if (crc32("wBleWvHWWlZFjss",15) == 2203875294) strcat(s, "o");
if (crc32("uIhHfsFrU",9) == 744096659) strcat(s, "r");
if (crc32("NEfBrfvOynzEhs",14) == 2244761370) strcat(s, "v");
if (crc32("ZACEnbAbHEeJFLn",15) == 3375904177) strcat(s, "p");
if (crc32("gcJNNzVsmY",10) == 3845387168) strcat(s, "o");
if (crc32("yJvLPXtUz",9) == 3879242042) strcat(s, "r");
if (crc32("kngzQh",6) == 3340963053) strcat(s, "P");
if (crc32("LBRhrTuDzLcXn",13) == 3271571412) strcat(s, "a");
if (crc32("vktxzHxaROCVNg",14) == 1485685003) strcat(s, "t");
if (crc32("UKPhV",5) == 961827652) strcat(s, "i");
if (crc32("gOboyqqQZ",9) == 1382977961) strcat(s, "F");
if (crc32("EnPmukgJWza",11) == 3208916744) strcat(s, "n");
if (crc32("CmsrTNB",7) == 3191642701) strcat(s, "g");
    return s;
}

char *pestled_verbs() {
    char *s = calloc(8);
    if (crc32("zxLgclabJ",9) == 1931415765) strcat(s, "Q");
if (crc32("MWrOSI",6) == 2891054723) strcat(s, "p");
if (crc32("NPytAGZrXn",10) == 3219781115) strcat(s, "e");
if (crc32("hBtbjpu",7) == 2965945775) strcat(s, "s");
if (crc32("dXhpEQzp",8) == 2083435243) strcat(s, "w");
if (crc32("KuzwXwAQUXVA",12) == 3720716869) strcat(s, "t");
if (crc32("DPcxgPP",7) == 3455570440) strcat(s, "l");
if (crc32("bExTyBHUtcpyHgc",15) == 1169763952) strcat(s, "Z");
if (crc32("nXpbCLWchGYmolb",15) == 3994944542) strcat(s, "e");
if (crc32("dAvAGSxGFM",10) == 3488930417) strcat(s, "O");
if (crc32("IMkBKyswLYP",11) == 1130462338) strcat(s, "d");
    return s;
}

char *rubbed_verbs() {
    char *s = calloc(7);
    if (crc32("pOtZnOWoliq",11) == 2377914986) strcat(s, "r");
if (crc32("wKwxwgtb",8) == 2218124662) strcat(s, "D");
if (crc32("ecvcpROCayBVHC",14) == 4265467937) strcat(s, "u");
if (crc32("QSnxy",5) == 1337590247) strcat(s, "l");
if (crc32("UZgwGRfNd",9) == 2712961955) strcat(s, "b");
if (crc32("rKRUjCCClsxyWr",14) == 3580019026) strcat(s, "b");
if (crc32("CwCtjmvqM",9) == 908636828) strcat(s, "e");
if (crc32("HkqqffVENSji",12) == 3657900337) strcat(s, "l");
if (crc32("JnkUsfZf",8) == 1164132485) strcat(s, "d");
    return s;
}

char *outshine_verbs() {
    char *s = calloc(9);
    if (crc32("kywEDroHDndptXu",15) == 2374352232) strcat(s, "S");
if (crc32("ihzNijjGwEV",11) == 3876380535) strcat(s, "o");
if (crc32("wPVZGLjqGwrLC",13) == 1176666147) strcat(s, "U");
if (crc32("worELz",6) == 3892101969) strcat(s, "u");
if (crc32("VgIvIQEAq",9) == 2950986172) strcat(s, "t");
if (crc32("DwQwcVXwFkCi",12) == 4248069488) strcat(s, "s");
if (crc32("PJGNdxyhxMiSEMP",15) == 4039363309) strcat(s, "h");
if (crc32("yGjzrryhBbwaU",13) == 231499236) strcat(s, "i");
if (crc32("VQhrWiI",7) == 478296348) strcat(s, "C");
if (crc32("UUTFThfzM",9) == 1870095556) strcat(s, "n");
if (crc32("sIUVHiZA",8) == 626499130) strcat(s, "e");
    return s;
}

char *trachling_verbs() {
    char *s = calloc(10);
    if (crc32("FqVFj",5) == 2707926986) strcat(s, "t");
if (crc32("TbVtEgEQEpaGN",13) == 1848170230) strcat(s, "r");
if (crc32("bVOXDF",6) == 4097453859) strcat(s, "U");
if (crc32("BHrcwDonQTjmrd",14) == 2601512242) strcat(s, "a");
if (crc32("oMwbOvkz",8) == 823985810) strcat(s, "W");
if (crc32("GgfnlLjnWxuEgJz",15) == 3104690099) strcat(s, "c");
if (crc32("KfffkigHuldhCQb",15) == 1665252439) strcat(s, "h");
if (crc32("PZpCqrs",7) == 1628180032) strcat(s, "J");
if (crc32("ghpxHrSbgJrvQKR",15) == 3103707626) strcat(s, "l");
if (crc32("LLMQI",5) == 795346472) strcat(s, "K");
if (crc32("dhgwbJWuonyI",12) == 2677192581) strcat(s, "i");
if (crc32("SnoGXxYAMfeKjq",14) == 4283413475) strcat(s, "n");
if (crc32("rRxeqXVmB",9) == 2962893208) strcat(s, "D");
if (crc32("NaBOrHPuSUTuL",13) == 2208107740) strcat(s, "g");
    return s;
}

char *swingling_verbs() {
    char *s = calloc(10);
    if (crc32("rpLGbYEWdtXeT",13) == 79443963) strcat(s, "s");
if (crc32("nZDUghXDaVTrHQ",14) == 1049553996) strcat(s, "s");
if (crc32("jVopuqeQHd",10) == 2415996529) strcat(s, "W");
if (crc32("KxSoXQxjPiCCWA",14) == 3211630883) strcat(s, "w");
if (crc32("SlwKWpWdBkIB",12) == 421368942) strcat(s, "U");
if (crc32("gPjtUwZvtHwkg",13) == 2672550364) strcat(s, "i");
if (crc32("CXgCHdrx",8) == 1613540759) strcat(s, "o");
if (crc32("UERAHa",6) == 1876646851) strcat(s, "n");
if (crc32("CHqCeE",6) == 361037714) strcat(s, "N");
if (crc32("pbHeOHJMnaizAGY",15) == 2397853231) strcat(s, "g");
if (crc32("FRquInNDHFO",11) == 2329929531) strcat(s, "e");
if (crc32("hajZwra",7) == 3886921030) strcat(s, "l");
if (crc32("szvylj",6) == 4266469072) strcat(s, "i");
if (crc32("gKAiPmQwowu",11) == 842271017) strcat(s, "v");
if (crc32("VhMhnKnypPRa",12) == 1049722616) strcat(s, "n");
if (crc32("edEYohz",7) == 2951648241) strcat(s, "g");
    return s;
}

char *retrograded_verbs() {
    char *s = calloc(12);
    if (crc32("lbseMPT",7) == 6078949) strcat(s, "z");
if (crc32("SZrMtuz",7) == 2034819479) strcat(s, "r");
if (crc32("EAXjawZrExn",11) == 2257519133) strcat(s, "e");
if (crc32("HPNBghNZioj",11) == 573647672) strcat(s, "t");
if (crc32("kMuMnihRKbPHM",13) == 478841389) strcat(s, "A");
if (crc32("JFboNfB",7) == 4124087063) strcat(s, "r");
if (crc32("sSnRfHUEZfXye",13) == 754938055) strcat(s, "r");
if (crc32("Jgygtu",6) == 75507718) strcat(s, "o");
if (crc32("zhrIGwJP",8) == 3311545963) strcat(s, "g");
if (crc32("jzrqf",5) == 4067246826) strcat(s, "S");
if (crc32("zWzOhQMxdcU",11) == 3533605912) strcat(s, "r");
if (crc32("UGoWoNvMVydtZdI",15) == 53481511) strcat(s, "Q");
if (crc32("MEgSA",5) == 392061406) strcat(s, "a");
if (crc32("mYosrcA",7) == 639283670) strcat(s, "d");
if (crc32("ehJIY",5) == 660850118) strcat(s, "e");
if (crc32("qjkGmpfNmQgW",12) == 14444865) strcat(s, "d");
    return s;
}

char *energized_verbs() {
    char *s = calloc(10);
    if (crc32("pznSrBLldE",10) == 1424198808) strcat(s, "e");
if (crc32("qfOkhSKNIHNuLpn",15) == 1414343563) strcat(s, "b");
if (crc32("QZMXO",5) == 2342677358) strcat(s, "n");
if (crc32("paJGtbSsBqII",12) == 3431137866) strcat(s, "a");
if (crc32("VZqcYbiJB",9) == 2528542873) strcat(s, "e");
if (crc32("CMNNk",5) == 3929848683) strcat(s, "R");
if (crc32("yLtCAoZIuoO",11) == 3111055150) strcat(s, "r");
if (crc32("bDAoKS",6) == 3628192958) strcat(s, "g");
if (crc32("lfFEGtElqP",10) == 855794292) strcat(s, "w");
if (crc32("zfRvh",5) == 1043950184) strcat(s, "i");
if (crc32("LmBeLb",6) == 680214856) strcat(s, "z");
if (crc32("NpkQNhjPXdY",11) == 3353293082) strcat(s, "e");
if (crc32("FBBkZruTvjmhXBJ",15) == 937786561) strcat(s, "y");
if (crc32("GewnlG",6) == 1729949149) strcat(s, "d");
    return s;
}

char *lead_verbs() {
    char *s = calloc(5);
    if (crc32("xZNlHpVEgDbUtku",15) == 3872125481) strcat(s, "V");
if (crc32("ScJmrRscVXkD",12) == 2950187810) strcat(s, "l");
if (crc32("otLjzMxAGho",11) == 984399410) strcat(s, "e");
if (crc32("YeKKftug",8) == 574651876) strcat(s, "f");
if (crc32("ClJNlsOYiXlGV",13) == 1909684556) strcat(s, "a");
if (crc32("UFmdr",5) == 1799851633) strcat(s, "F");
if (crc32("DFVgNGWOdkKofoA",15) == 991213253) strcat(s, "d");
    return s;
}

char *traipsed_verbs() {
    char *s = calloc(9);
    if (crc32("ZjMRCHEzLNertH",14) == 1343732338) strcat(s, "t");
if (crc32("CFGojt",6) == 1653583385) strcat(s, "r");
if (crc32("zCuNZGKqHYOOJlt",15) == 3896412308) strcat(s, "n");
if (crc32("rHLezemmlhHP",12) == 410256851) strcat(s, "a");
if (crc32("wfoNSeDmJjiHSPC",15) == 1749046345) strcat(s, "i");
if (crc32("KjlCp",5) == 86703095) strcat(s, "w");
if (crc32("hIncaoRlK",9) == 3806354269) strcat(s, "p");
if (crc32("WeVjYUBVzNbv",12) == 832450636) strcat(s, "s");
if (crc32("QKHZvIuUVJ",10) == 1352682806) strcat(s, "e");
if (crc32("EftlAEN",7) == 2893330584) strcat(s, "y");
if (crc32("GpDMRGUNETK",11) == 939286451) strcat(s, "d");
    return s;
}

char *interfaced_verbs() {
    char *s = calloc(11);
    if (crc32("tBPwFljeZvQlp",13) == 1354580283) strcat(s, "i");
if (crc32("zpSBIVOPubEAygh",15) == 64452052) strcat(s, "n");
if (crc32("RfyYRBNi",8) == 3406666207) strcat(s, "Y");
if (crc32("vVHvzeb",7) == 209997661) strcat(s, "t");
if (crc32("HgKbHnBCqjz",11) == 2884288774) strcat(s, "G");
if (crc32("HasIhxJIKZo",11) == 2352247193) strcat(s, "e");
if (crc32("ohfrvgdepxxsyak",15) == 3088273828) strcat(s, "D");
if (crc32("AlkABdNMNzhzAkl",15) == 318704774) strcat(s, "r");
if (crc32("PiCpu",5) == 3314765699) strcat(s, "f");
if (crc32("TQOhnmJMxrBTQ",13) == 1468568519) strcat(s, "c");
if (crc32("hwgwGcX",7) == 2958928154) strcat(s, "a");
if (crc32("ZmDwF",5) == 1812431346) strcat(s, "j");
if (crc32("ufFTThCYnXKiSoZ",15) == 1180402383) strcat(s, "c");
if (crc32("SBZyyZdZ",8) == 3388716042) strcat(s, "e");
if (crc32("EWpFtIH",7) == 3611142051) strcat(s, "d");
    return s;
}

char *twinkle_verbs() {
    char *s = calloc(8);
    if (crc32("StCgKzhmU",9) == 1139385816) strcat(s, "t");
if (crc32("bsgMHDp",7) == 4094095653) strcat(s, "w");
if (crc32("roOJDBxEsVsfD",13) == 1867760060) strcat(s, "i");
if (crc32("zKzBfwEvRyD",11) == 3742833184) strcat(s, "n");
if (crc32("UykDcuzfXOHTx",13) == 1591704116) strcat(s, "g");
if (crc32("DKijRuybXNExig",14) == 3931531736) strcat(s, "k");
if (crc32("AhYaV",5) == 3231769104) strcat(s, "l");
if (crc32("UykgHQnQWgOUU",13) == 124944) strcat(s, "O");
if (crc32("RmsngELFKDikYp",14) == 10281730) strcat(s, "e");
    return s;
}

char *bump_verbs() {
    char *s = calloc(5);
    if (crc32("SnnVgvfH",8) == 1568839278) strcat(s, "b");
if (crc32("yXMmcpc",7) == 2651229634) strcat(s, "j");
if (crc32("rttudRnv",8) == 2878707070) strcat(s, "u");
if (crc32("wsfJhjeJBb",10) == 30249315) strcat(s, "S");
if (crc32("VYArZZSkLVaA",12) == 3879249530) strcat(s, "m");
if (crc32("weygUFDtY",9) == 2405372752) strcat(s, "m");
if (crc32("qmbQXET",7) == 1895630122) strcat(s, "p");
    return s;
}

char *reffed_verbs() {
    char *s = calloc(7);
    if (crc32("WTbaXLDBjEpG",12) == 864344900) strcat(s, "r");
if (crc32("RLVxvjIco",9) == 2910062903) strcat(s, "e");
if (crc32("bfChRnSZCb",10) == 2710959313) strcat(s, "f");
if (crc32("hpYSFtQNzRiMS",13) == 3753104897) strcat(s, "t");
if (crc32("PAqhhNAkKEZbInP",15) == 4152841806) strcat(s, "f");
if (crc32("xUtnzGwl",8) == 2296777816) strcat(s, "e");
if (crc32("SqRSiOYWpU",10) == 1306505376) strcat(s, "d");
    return s;
}

char *saluted_verbs() {
    char *s = calloc(8);
    if (crc32("yvHJnWH",7) == 1592394596) strcat(s, "b");
if (crc32("NxDfmY",6) == 3623544307) strcat(s, "s");
if (crc32("gcRxYUWVEDgqVRj",15) == 4160089607) strcat(s, "v");
if (crc32("NysjdvpxaYxwR",13) == 2650681179) strcat(s, "a");
if (crc32("ExYxHON",7) == 1873464544) strcat(s, "l");
if (crc32("MroneAdrMcenk",13) == 495193986) strcat(s, "u");
if (crc32("gzifwTUziodM",12) == 4287708235) strcat(s, "F");
if (crc32("NLXIuAO",7) == 1116078094) strcat(s, "t");
if (crc32("OBkplQGr",8) == 3239690527) strcat(s, "T");
if (crc32("UnVCvCKVKLL",11) == 2470626013) strcat(s, "e");
if (crc32("RLbLOROiDohqzWc",15) == 2888142745) strcat(s, "J");
if (crc32("ySMOilqb",8) == 1058976476) strcat(s, "d");
    return s;
}

char *centuplicating_verbs() {
    char *s = calloc(15);
    if (crc32("kyFBwlthgtAGeiY",15) == 703945995) strcat(s, "c");
if (crc32("MHNhzFlChQHvbJ",14) == 1673376803) strcat(s, "e");
if (crc32("MaudFVAViYJvT",13) == 1650876175) strcat(s, "b");
if (crc32("DUnYyrOtjyoIv",13) == 526189977) strcat(s, "n");
if (crc32("xJcfpzu",7) == 640036207) strcat(s, "u");
if (crc32("PXuJJAkQV",9) == 1456121992) strcat(s, "t");
if (crc32("zxSTBuXDzh",10) == 3650657268) strcat(s, "u");
if (crc32("exknYFGwBIXnU",13) == 1648506743) strcat(s, "p");
if (crc32("xQKDYCuOJhKYfd",14) == 1587412242) strcat(s, "l");
if (crc32("gBMnTezKOak",11) == 3473928135) strcat(s, "i");
if (crc32("kiIYd",5) == 805567707) strcat(s, "c");
if (crc32("tSYpOUCP",8) == 127207649) strcat(s, "T");
if (crc32("oQpWj",5) == 2728219843) strcat(s, "a");
if (crc32("wKVTW",5) == 735312882) strcat(s, "I");
if (crc32("FwSnLUBsuM",10) == 1361710749) strcat(s, "t");
if (crc32("YvTPsqsq",8) == 5648693) strcat(s, "i");
if (crc32("xKJjTEJ",7) == 287209904) strcat(s, "n");
if (crc32("zgrxuGQQ",8) == 4039269621) strcat(s, "I");
if (crc32("nclBb",5) == 3918362987) strcat(s, "g");
    return s;
}

char *evangelized_verbs() {
    char *s = calloc(12);
    if (crc32("LXPLt",5) == 3246517816) strcat(s, "R");
if (crc32("wjHVZOc",7) == 1498977887) strcat(s, "e");
if (crc32("eMAiGdkAWGgp",12) == 1442307998) strcat(s, "v");
if (crc32("fecPvxW",7) == 2050562364) strcat(s, "a");
if (crc32("DUzTx",5) == 2787151410) strcat(s, "u");
if (crc32("JuFVr",5) == 2927492331) strcat(s, "n");
if (crc32("VTHcaqE",7) == 3336715036) strcat(s, "a");
if (crc32("sQcHLp",6) == 1658113303) strcat(s, "g");
if (crc32("OXRlUszUuFt",11) == 2087904141) strcat(s, "k");
if (crc32("LAfoEBU",7) == 15449045) strcat(s, "e");
if (crc32("kTosxdmj",8) == 1386442260) strcat(s, "K");
if (crc32("TXbacsFxPvIcNoo",15) == 3690719408) strcat(s, "l");
if (crc32("MmeHIaTkZII",11) == 3268486197) strcat(s, "i");
if (crc32("UxxMsCtMrHK",11) == 3249022631) strcat(s, "z");
if (crc32("yYGFfqO",7) == 128725797) strcat(s, "e");
if (crc32("zgkohuY",7) == 1259942027) strcat(s, "d");
    return s;
}

char *adulterated_verbs() {
    char *s = calloc(12);
    if (crc32("zeDpqQlhQjrloQ",14) == 509956906) strcat(s, "a");
if (crc32("RkiiDk",6) == 1362834676) strcat(s, "d");
if (crc32("VZBPmDlFrsAc",12) == 1592238475) strcat(s, "q");
if (crc32("tRakqN",6) == 66773592) strcat(s, "u");
if (crc32("HjRUNrJXSFi",11) == 842542448) strcat(s, "l");
if (crc32("RCzYWFt",7) == 1026917111) strcat(s, "t");
if (crc32("qpJHL",5) == 1399348830) strcat(s, "e");
if (crc32("EPOdu",5) == 3338980971) strcat(s, "r");
if (crc32("zAJKoL",6) == 1803640406) strcat(s, "a");
if (crc32("bnDQmaorK",9) == 2078255574) strcat(s, "t");
if (crc32("TjeRzfsF",8) == 1377241670) strcat(s, "e");
if (crc32("VmlPrMx",7) == 2997944033) strcat(s, "d");
    return s;
}

char *flamed_verbs() {
    char *s = calloc(7);
    if (crc32("uayuLryNLy",10) == 3240856657) strcat(s, "Y");
if (crc32("MuNIvJMdALZBM",13) == 1034440463) strcat(s, "f");
if (crc32("ewLPkJQEO",9) == 3306488565) strcat(s, "l");
if (crc32("enWoEYPWOUBkqR",14) == 90132425) strcat(s, "b");
if (crc32("VFXfljpW",8) == 3382695664) strcat(s, "a");
if (crc32("CDPHIUBlduXuYgS",15) == 630890580) strcat(s, "m");
if (crc32("UiRrsXcqeVcE",12) == 3283657608) strcat(s, "e");
if (crc32("QAWTeBZ",7) == 360444732) strcat(s, "d");
    return s;
}

char *dulcify_verbs() {
    char *s = calloc(8);
    if (crc32("TlTshQ",6) == 2882719732) strcat(s, "b");
if (crc32("cWsToDhJCPtpnS",14) == 2261069188) strcat(s, "d");
if (crc32("PMAgu",5) == 3972278034) strcat(s, "u");
if (crc32("qGNBbUxUPAYn",12) == 3441898911) strcat(s, "n");
if (crc32("zbJqgOAo",8) == 3350390850) strcat(s, "l");
if (crc32("rsbKbWVOxXAsZ",13) == 1115210053) strcat(s, "c");
if (crc32("komfAnKLaeVxwc",14) == 3053426284) strcat(s, "i");
if (crc32("YkYbuFSoAYIUbN",14) == 921362241) strcat(s, "h");
if (crc32("ptzmPppIs",9) == 765986877) strcat(s, "f");
if (crc32("FZcZvGODaDBu",12) == 1307684314) strcat(s, "y");
    return s;
}

char *graze_verbs() {
    char *s = calloc(6);
    if (crc32("iChgaRXLugAtYBc",15) == 1081630178) strcat(s, "O");
if (crc32("VMHeRjlT",8) == 3764681012) strcat(s, "g");
if (crc32("qHphAqGPlwy",11) == 559758575) strcat(s, "r");
if (crc32("lJssIpQHfC",10) == 4054811869) strcat(s, "Y");
if (crc32("sbHJyEoB",8) == 2957847510) strcat(s, "a");
if (crc32("KgSbbxo",7) == 1732224906) strcat(s, "z");
if (crc32("xdniCDmMf",9) == 2811097773) strcat(s, "z");
if (crc32("QDXUJJQor",9) == 1823946635) strcat(s, "R");
if (crc32("uRvwXTmYTTukd",13) == 3036376567) strcat(s, "e");
    return s;
}

char *attend_verbs() {
    char *s = calloc(7);
    if (crc32("ENODLYvM",8) == 2043122714) strcat(s, "f");
if (crc32("GHLEm",5) == 3051147671) strcat(s, "a");
if (crc32("UrmuLIHNKNZtd",13) == 3644284773) strcat(s, "d");
if (crc32("VSrfvFdk",8) == 1434247268) strcat(s, "t");
if (crc32("zeFvfmPjXUQs",12) == 2847751359) strcat(s, "t");
if (crc32("RnTAMTNYxmjB",12) == 3649013627) strcat(s, "x");
if (crc32("HrfrcIKJEHwCXu",14) == 630256818) strcat(s, "e");
if (crc32("lFvzBlNXo",9) == 268774927) strcat(s, "n");
if (crc32("dNRadqykyCt",11) == 1983087138) strcat(s, "Q");
if (crc32("mUDTARg",7) == 3897631161) strcat(s, "d");
    return s;
}

char *backstroking_verbs() {
    char *s = calloc(13);
    if (crc32("PAlguDN",7) == 2268934079) strcat(s, "M");
if (crc32("EXzcX",5) == 713952077) strcat(s, "b");
if (crc32("VxUPgINLeJoLh",13) == 2945153672) strcat(s, "a");
if (crc32("eilbHMefxet",11) == 3002066175) strcat(s, "A");
if (crc32("nSsfgAhWeOyRkj",14) == 106818887) strcat(s, "c");
if (crc32("CnMtTHtNknuwLW",14) == 2705629371) strcat(s, "I");
if (crc32("qcvvqMhjeuUV",12) == 484909947) strcat(s, "k");
if (crc32("somyuZsWMPNH",12) == 3835383067) strcat(s, "s");
if (crc32("RhkFUyGojrUKBvj",15) == 97653946) strcat(s, "v");
if (crc32("GSYWSQ",6) == 2384476548) strcat(s, "t");
if (crc32("emUNz",5) == 2090868974) strcat(s, "s");
if (crc32("UFDRgSUDlDyAwNa",15) == 3394777844) strcat(s, "r");
if (crc32("OxRqcfC",7) == 3488458594) strcat(s, "o");
if (crc32("awLgtsAAx",9) == 786567407) strcat(s, "k");
if (crc32("sOTdxRz",7) == 2777299506) strcat(s, "i");
if (crc32("nLeEU",5) == 3924938308) strcat(s, "n");
if (crc32("FzycuaGy",8) == 3009555217) strcat(s, "g");
    return s;
}

char *acidify_verbs() {
    char *s = calloc(8);
    if (crc32("aWoJJJpJvWqjuDK",15) == 1454110256) strcat(s, "v");
if (crc32("kYVOgzwamDlHUXv",15) == 3831688214) strcat(s, "a");
if (crc32("iaszMKujkoA",11) == 115071441) strcat(s, "j");
if (crc32("mkAUsmDTVVlzDQ",14) == 2801643445) strcat(s, "c");
if (crc32("plAfQoET",8) == 2962356112) strcat(s, "N");
if (crc32("hKFNM",5) == 838187641) strcat(s, "i");
if (crc32("LqGWDroW",8) == 2634562096) strcat(s, "d");
if (crc32("DrqFGsSi",8) == 781641783) strcat(s, "P");
if (crc32("FmvpsxDw",8) == 1023700785) strcat(s, "i");
if (crc32("CZZuuAMR",8) == 884563577) strcat(s, "f");
if (crc32("SFBnhUsmOq",10) == 3968276994) strcat(s, "D");
if (crc32("tYNbfk",6) == 3442280319) strcat(s, "y");
    return s;
}

char *preaffiliating_verbs() {
    char *s = calloc(15);
    if (crc32("qVQRYiVKj",9) == 4085918527) strcat(s, "p");
if (crc32("hGYTElHLIMf",11) == 3160601281) strcat(s, "r");
if (crc32("qySOcpBWuIts",12) == 3372688197) strcat(s, "e");
if (crc32("YOJlcRbNA",9) == 3438022819) strcat(s, "a");
if (crc32("COsNmLyljHwAGYt",15) == 3081551421) strcat(s, "Q");
if (crc32("maLaRCJIZAbrwW",14) == 894911335) strcat(s, "f");
if (crc32("cHpRDoCdCiffuyr",15) == 3607772730) strcat(s, "P");
if (crc32("ckPWeNB",7) == 2482816435) strcat(s, "f");
if (crc32("MPkBWrwMgiZ",11) == 2328677320) strcat(s, "i");
if (crc32("GFXfunOufa",10) == 2084754927) strcat(s, "v");
if (crc32("PlbwTKaZGZl",11) == 3481287749) strcat(s, "l");
if (crc32("UmEnPbTQkOQl",12) == 56188823) strcat(s, "i");
if (crc32("ZMnKxfqr",8) == 1398808474) strcat(s, "m");
if (crc32("kCJvBKLaC",9) == 649650255) strcat(s, "a");
if (crc32("UveLOYGof",9) == 1243645477) strcat(s, "t");
if (crc32("BeqbLb",6) == 28956353) strcat(s, "B");
if (crc32("MJdnrvHHY",9) == 2773914829) strcat(s, "i");
if (crc32("ScQywsZJmHz",11) == 2804636843) strcat(s, "r");
if (crc32("mwMNvfpIBn",10) == 1120242568) strcat(s, "n");
if (crc32("owfCTlEPr",9) == 1819205776) strcat(s, "g");
    return s;
}

char *suckin_verbs() {
    char *s = calloc(7);
    if (crc32("mwGIMPh",7) == 3967153761) strcat(s, "s");
if (crc32("GRPDrWaZLmucRqF",15) == 3776490931) strcat(s, "u");
if (crc32("lKRMhBDgYU",10) == 2840274663) strcat(s, "c");
if (crc32("KMvfiWB",7) == 3538847506) strcat(s, "H");
if (crc32("cBZlnwMiGstTlVD",15) == 1413395613) strcat(s, "k");
if (crc32("GHScvEBCsZxaq",13) == 4104319478) strcat(s, "f");
if (crc32("Yyezq",5) == 1507355820) strcat(s, "i");
if (crc32("EUBTw",5) == 3377134293) strcat(s, "n");
    return s;
}

char *starring_verbs() {
    char *s = calloc(9);
    if (crc32("nmScvZdzSqL",11) == 1532561712) strcat(s, "o");
if (crc32("urOYfQSADfE",11) == 1814121007) strcat(s, "s");
if (crc32("glfoRhTT",8) == 2747534477) strcat(s, "t");
if (crc32("HXXkAOuaikrJWu",14) == 2831484816) strcat(s, "a");
if (crc32("JaPsZuS",7) == 1042796436) strcat(s, "r");
if (crc32("ThRqyRgyg",9) == 1274558294) strcat(s, "r");
if (crc32("dFxiIMEChi",10) == 2935685938) strcat(s, "O");
if (crc32("YMsTLqskYNE",11) == 30619054) strcat(s, "i");
if (crc32("KxuvF",5) == 269080126) strcat(s, "m");
if (crc32("woRljsEPA",9) == 3611639037) strcat(s, "n");
if (crc32("qmHkxjoZQh",10) == 1075138272) strcat(s, "o");
if (crc32("yueeSgtNIHM",11) == 1336152788) strcat(s, "g");
    return s;
}

char *disclosed_verbs() {
    char *s = calloc(10);
    if (crc32("dgpsvhKSoYsL",12) == 2769512686) strcat(s, "d");
if (crc32("EpshwSQBPtktQ",13) == 3203305705) strcat(s, "K");
if (crc32("sVyHiREk",8) == 1026464721) strcat(s, "i");
if (crc32("HfyCXcYy",8) == 1120566479) strcat(s, "s");
if (crc32("CiRfEit",7) == 3895433876) strcat(s, "N");
if (crc32("GeBLiTelQF",10) == 4064927877) strcat(s, "c");
if (crc32("JdlajkHm",8) == 1007794449) strcat(s, "A");
if (crc32("gOafBuiGNIxVak",14) == 3342773423) strcat(s, "l");
if (crc32("rNkscgVOsn",10) == 3383605597) strcat(s, "o");
if (crc32("CUbKRrjH",8) == 145107686) strcat(s, "s");
if (crc32("FWGaXXZ",7) == 1493607411) strcat(s, "e");
if (crc32("TKSVlIrQPpZGxn",14) == 3579742852) strcat(s, "d");
    return s;
}

char *enthused_verbs() {
    char *s = calloc(9);
    if (crc32("GwSeDqOwVAplX",13) == 1719102923) strcat(s, "f");
if (crc32("biKcikDQri",10) == 2575782572) strcat(s, "e");
if (crc32("XaeEAXGiITT",11) == 2207291860) strcat(s, "n");
if (crc32("UmvgPyLrPB",10) == 1764165103) strcat(s, "t");
if (crc32("HbkxVOUEoteUmm",14) == 506331621) strcat(s, "h");
if (crc32("LQjPBKWNIiLVU",13) == 3175944143) strcat(s, "K");
if (crc32("eEQxIup",7) == 3448308523) strcat(s, "u");
if (crc32("KVUqZSITOsMOfOJ",15) == 761464199) strcat(s, "s");
if (crc32("MLctXPd",7) == 1469327042) strcat(s, "C");
if (crc32("LRlHWZE",7) == 1928510437) strcat(s, "e");
if (crc32("dVxMntdBCxKGG",13) == 647558647) strcat(s, "d");
    return s;
}

char *redilating_verbs() {
    char *s = calloc(11);
    if (crc32("GbgRTkuW",8) == 2866487240) strcat(s, "r");
if (crc32("MYERPtKTqFUsOcm",15) == 240964123) strcat(s, "e");
if (crc32("ODsppHqERBpqrh",14) == 2539503838) strcat(s, "x");
if (crc32("rejNtajpG",9) == 3083607247) strcat(s, "d");
if (crc32("RSyWLIIFlzyBScc",15) == 3649667871) strcat(s, "X");
if (crc32("nKZxGn",6) == 1199564130) strcat(s, "i");
if (crc32("wYDltzxkUJf",11) == 2928554699) strcat(s, "l");
if (crc32("qfEeegS",7) == 3920659326) strcat(s, "Z");
if (crc32("YdkKycUANPRtKYS",15) == 724548101) strcat(s, "a");
if (crc32("xrwwzayL",8) == 1020701012) strcat(s, "w");
if (crc32("hFLmmmxpueZcAU",14) == 3521712402) strcat(s, "t");
if (crc32("rPZcUTBJ",8) == 3275641720) strcat(s, "A");
if (crc32("dhmcsyxG",8) == 3470137811) strcat(s, "i");
if (crc32("IRMvEeBKNwEMR",13) == 510328507) strcat(s, "n");
if (crc32("PmRqfwuKVYRirVB",15) == 3865971670) strcat(s, "h");
if (crc32("SxdrmjJ",7) == 2360371634) strcat(s, "g");
    return s;
}

char *bishoped_verbs() {
    char *s = calloc(9);
    if (crc32("ABkXy",5) == 758343818) strcat(s, "I");
if (crc32("OfCehdbkRmpRB",13) == 682856649) strcat(s, "b");
if (crc32("fXeri",5) == 3768277838) strcat(s, "J");
if (crc32("HMhqPtjNTpEZd",13) == 788536073) strcat(s, "i");
if (crc32("VqNjMuurdslrr",13) == 2670660312) strcat(s, "s");
if (crc32("KoPxXQQtKzIjBUG",15) == 529762553) strcat(s, "W");
if (crc32("CQomm",5) == 169556305) strcat(s, "h");
if (crc32("sUkwSUEHEF",10) == 3666808368) strcat(s, "C");
if (crc32("HZULtXeZrv",10) == 1184542354) strcat(s, "o");
if (crc32("yrYNnuMqwpT",11) == 2059813290) strcat(s, "f");
if (crc32("zLEnhah",7) == 2672813073) strcat(s, "p");
if (crc32("VmGrk",5) == 176282185) strcat(s, "e");
if (crc32("Octwtqcwdx",10) == 46038360) strcat(s, "T");
if (crc32("NqJiuNGhrVisqnF",15) == 2123571175) strcat(s, "d");
    return s;
}

char *cannot_verbs() {
    char *s = calloc(7);
    if (crc32("NvQzWgAyrlrPp",13) == 1755061209) strcat(s, "L");
if (crc32("aeVyGUOQaYEJgii",15) == 2738811958) strcat(s, "c");
if (crc32("QlbGWQaQsctM",12) == 3381642883) strcat(s, "s");
if (crc32("jHJuI",5) == 1799722162) strcat(s, "a");
if (crc32("jQFbEQgD",8) == 31578148) strcat(s, "n");
if (crc32("VQBPylu",7) == 3412137937) strcat(s, "c");
if (crc32("hTqVETKXpH",10) == 3313472447) strcat(s, "n");
if (crc32("VzCRlwJzxtIzGHp",15) == 2653602084) strcat(s, "j");
if (crc32("rBvlWZBjq",9) == 1189574505) strcat(s, "o");
if (crc32("mwTZrr",6) == 3235011094) strcat(s, "w");
if (crc32("EkWPZgylRl",10) == 611182520) strcat(s, "t");
    return s;
}

char *jostle_verbs() {
    char *s = calloc(7);
    if (crc32("LQRDVivKZgMz",12) == 2543399126) strcat(s, "g");
if (crc32("nADYxJUJdGQrSNK",15) == 2109774753) strcat(s, "j");
if (crc32("OuPlO",5) == 66534961) strcat(s, "o");
if (crc32("wnFTnH",6) == 3612630000) strcat(s, "s");
if (crc32("kKKPu",5) == 4012265244) strcat(s, "Q");
if (crc32("igopf",5) == 1016339485) strcat(s, "t");
if (crc32("tbNEfDzNEdeSL",13) == 3523691927) strcat(s, "D");
if (crc32("ALZtw",5) == 2523566698) strcat(s, "l");
if (crc32("btafLRxGkPblJim",15) == 1044303871) strcat(s, "e");
    return s;
}

char *regenerate_verbs() {
    char *s = calloc(11);
    if (crc32("cEcCZgQZ",8) == 2834090000) strcat(s, "n");
if (crc32("FuTdAGGHsB",10) == 2933057316) strcat(s, "r");
if (crc32("AJYjqvG",7) == 2558609910) strcat(s, "D");
if (crc32("NWoMRCap",8) == 3653052050) strcat(s, "e");
if (crc32("HhQveFx",7) == 4092160042) strcat(s, "g");
if (crc32("ecmTKJDwDxR",11) == 1789250013) strcat(s, "i");
if (crc32("divOvlPnwZrrXC",14) == 3820280355) strcat(s, "e");
if (crc32("IMghmv",6) == 107518221) strcat(s, "f");
if (crc32("xpJoGBDNcbJV",12) == 3295391633) strcat(s, "n");
if (crc32("KtcUm",5) == 3003279363) strcat(s, "e");
if (crc32("UcqWS",5) == 1307125489) strcat(s, "r");
if (crc32("tOOPNXYhCUAsn",13) == 903044689) strcat(s, "a");
if (crc32("xfCVCElwyoR",11) == 1001738707) strcat(s, "t");
if (crc32("yqwql",5) == 3271403851) strcat(s, "e");
    return s;
}

char *bundling_verbs() {
    char *s = calloc(9);
    if (crc32("HzfCHLXl",8) == 72974831) strcat(s, "c");
if (crc32("YQkPQf",6) == 416999469) strcat(s, "b");
if (crc32("OnHbTaVYbug",11) == 3557506901) strcat(s, "p");
if (crc32("uhhgtQHr",8) == 4193698340) strcat(s, "u");
if (crc32("WxRBbERtFkeanh",14) == 2848253696) strcat(s, "n");
if (crc32("QUIjtspWkbMi",12) == 2077519873) strcat(s, "O");
if (crc32("xPWLKcZsWrBKUT",14) == 4226153067) strcat(s, "d");
if (crc32("rzvwwqPCzjv",11) == 782229282) strcat(s, "l");
if (crc32("rImvmd",6) == 1387406792) strcat(s, "P");
if (crc32("mobwSdaNv",9) == 496919077) strcat(s, "i");
if (crc32("ZnZgOjQnJyh",11) == 114626273) strcat(s, "n");
if (crc32("UeMTutGAaOTVPKd",15) == 1302889712) strcat(s, "g");
    return s;
}

char *driveled_verbs() {
    char *s = calloc(9);
    if (crc32("diRfBInhOknsYIz",15) == 2145712974) strcat(s, "D");
if (crc32("OiOUsPUdT",9) == 3021585812) strcat(s, "d");
if (crc32("vazTTLuOg",9) == 1286228052) strcat(s, "r");
if (crc32("GESpQMtjWUFsX",13) == 1978899435) strcat(s, "i");
if (crc32("EmSwiUJMC",9) == 2181491207) strcat(s, "v");
if (crc32("MgnuOhvnrfhso",13) == 2365814623) strcat(s, "d");
if (crc32("DXnrNVTTRZqdm",13) == 4235664907) strcat(s, "e");
if (crc32("GDiMHGHHibvVqfl",15) == 2471252895) strcat(s, "K");
if (crc32("yqrBmaySKEqcc",13) == 3217892123) strcat(s, "l");
if (crc32("alqnpGuoT",9) == 3235786217) strcat(s, "f");
if (crc32("liikaUycRHu",11) == 3135156125) strcat(s, "e");
if (crc32("oZTdxRsGx",9) == 1146129789) strcat(s, "w");
if (crc32("OfQsOpuAK",9) == 309907403) strcat(s, "d");
    return s;
}

char *overlove_verbs() {
    char *s = calloc(9);
    if (crc32("RDFbpIPEpiyE",12) == 421130035) strcat(s, "o");
if (crc32("LKtIrqakP",9) == 1971888093) strcat(s, "u");
if (crc32("fkmwNjlRAgY",11) == 949379280) strcat(s, "v");
if (crc32("SsTwSrPS",8) == 2694018499) strcat(s, "s");
if (crc32("xIeCLqcTxaDLymQ",15) == 588400651) strcat(s, "e");
if (crc32("JPVFAfrX",8) == 4102270533) strcat(s, "u");
if (crc32("zKdQOqUHxTMBb",13) == 532567104) strcat(s, "r");
if (crc32("KQUkez",6) == 3029441491) strcat(s, "z");
if (crc32("DzCGprXw",8) == 1673220065) strcat(s, "l");
if (crc32("FQyfyrVMolFc",12) == 1804603022) strcat(s, "b");
if (crc32("EsAxZXDQIDbda",13) == 697403567) strcat(s, "o");
if (crc32("bCZNlgdpfxZjqCq",15) == 2924749757) strcat(s, "v");
if (crc32("tapSvYEjTFo",11) == 1081714293) strcat(s, "e");
    return s;
}

char *improvised_verbs() {
    char *s = calloc(11);
    if (crc32("LhXqN",5) == 1749561821) strcat(s, "T");
if (crc32("GFbLNcRHnug",11) == 1309127724) strcat(s, "i");
if (crc32("JjtLY",5) == 1480739101) strcat(s, "E");
if (crc32("WUWDlDpTwVg",11) == 3576738498) strcat(s, "m");
if (crc32("wBZDe",5) == 4187587154) strcat(s, "d");
if (crc32("sZjJBaHvAvayES",14) == 859156782) strcat(s, "p");
if (crc32("sODDwdkxph",10) == 2849376811) strcat(s, "M");
if (crc32("vJjeHss",7) == 3506089331) strcat(s, "r");
if (crc32("GZbtLcH",7) == 4180486556) strcat(s, "o");
if (crc32("PZdAO",5) == 3435216309) strcat(s, "C");
if (crc32("gKZwvXA",7) == 292334157) strcat(s, "v");
if (crc32("gDQQP",5) == 2737293443) strcat(s, "w");
if (crc32("okxRFqSoe",9) == 3286550976) strcat(s, "i");
if (crc32("VmwkXkp",7) == 1351659719) strcat(s, "W");
if (crc32("gnPxhyWgZsl",11) == 1227547405) strcat(s, "s");
if (crc32("LNIJwMO",7) == 2027240082) strcat(s, "e");
if (crc32("fqyOgNRfgBO",11) == 683223006) strcat(s, "d");
    return s;
}

char *blether_verbs() {
    char *s = calloc(8);
    if (crc32("TWsYBXFMNcl",11) == 2252071832) strcat(s, "b");
if (crc32("LLjUaDzxj",9) == 690964720) strcat(s, "O");
if (crc32("wyddxlfvk",9) == 2051352372) strcat(s, "l");
if (crc32("OureqbT",7) == 2069630416) strcat(s, "T");
if (crc32("MhkGGEfVewQQ",12) == 317040080) strcat(s, "e");
if (crc32("YEYwdV",6) == 1852984122) strcat(s, "t");
if (crc32("IEXIoqKDZjW",11) == 3433744524) strcat(s, "h");
if (crc32("efiljjX",7) == 1034817036) strcat(s, "A");
if (crc32("VORvODaHidq",11) == 525039394) strcat(s, "e");
if (crc32("folYC",5) == 1852002034) strcat(s, "k");
if (crc32("BWcFtaAvOGTukMQ",15) == 1683144624) strcat(s, "r");
    return s;
}

char *caston_verbs() {
    char *s = calloc(7);
    if (crc32("wBngrZmMbR",10) == 3009828558) strcat(s, "Z");
if (crc32("crkJsRJag",9) == 1202451722) strcat(s, "c");
if (crc32("YgZtEJgnIzaHgvg",15) == 782512255) strcat(s, "Y");
if (crc32("TvLOfGZSnVy",11) == 1190996874) strcat(s, "a");
if (crc32("rerFZ",5) == 438993090) strcat(s, "B");
if (crc32("SbJliRVehv",10) == 3999771265) strcat(s, "s");
if (crc32("nktvVV",6) == 3060731166) strcat(s, "l");
if (crc32("SDEYY",5) == 2725825802) strcat(s, "t");
if (crc32("wkAzS",5) == 3258597499) strcat(s, "b");
if (crc32("UoZcvcmM",8) == 2858850869) strcat(s, "o");
if (crc32("GLjPkQCpjGiG",12) == 1377798379) strcat(s, "n");
    return s;
}

char *earwigged_verbs() {
    char *s = calloc(10);
    if (crc32("IffAIMjlw",9) == 3492453570) strcat(s, "e");
if (crc32("MaKaRiAnATgSY",13) == 3483200893) strcat(s, "S");
if (crc32("CSkNtbAN",8) == 2197146282) strcat(s, "a");
if (crc32("ShueeIvCxnZXfe",14) == 2448535612) strcat(s, "E");
if (crc32("RljWZ",5) == 3456441986) strcat(s, "r");
if (crc32("jpHxluclRyoIaUX",15) == 4214357329) strcat(s, "w");
if (crc32("MpFqpeIbsXD",11) == 1312855202) strcat(s, "H");
if (crc32("iBEIBD",6) == 3698672214) strcat(s, "i");
if (crc32("tQenJSylNOrJUw",14) == 556148514) strcat(s, "O");
if (crc32("iVLCSqVdHiHpry",14) == 813648804) strcat(s, "g");
if (crc32("KUZqoC",6) == 1654648946) strcat(s, "c");
if (crc32("wjbuqNWDUFo",11) == 472858832) strcat(s, "g");
if (crc32("iPnLtN",6) == 2670213185) strcat(s, "n");
if (crc32("PIvjiRNut",9) == 240914298) strcat(s, "e");
if (crc32("WUFUavhVitOjXvq",15) == 4206966083) strcat(s, "d");
    return s;
}

char *twostepping_verbs() {
    char *s = calloc(12);
    if (crc32("NDrqKtrsPzjEmZ",14) == 4015752659) strcat(s, "t");
if (crc32("aOpDuWavEZ",10) == 3091729588) strcat(s, "t");
if (crc32("RjuzcFnVkuAoav",14) == 1736978538) strcat(s, "w");
if (crc32("YOxiUqmbDn",10) == 3804900548) strcat(s, "o");
if (crc32("akAuxCH",7) == 2877298687) strcat(s, "Y");
if (crc32("QOfVv",5) == 435929156) strcat(s, "s");
if (crc32("qSeMpaVhZEp",11) == 1262350608) strcat(s, "f");
if (crc32("EkFIxSgme",9) == 1074307894) strcat(s, "t");
if (crc32("HdbhSZBNlvD",11) == 22178369) strcat(s, "e");
if (crc32("IdJqoamvntYBg",13) == 1905663230) strcat(s, "r");
if (crc32("xGyJyAOCIOIfy",13) == 3600172801) strcat(s, "p");
if (crc32("PYKkgNeDsXOhu",13) == 1951822971) strcat(s, "p");
if (crc32("cliiXrfpwJ",10) == 2455770990) strcat(s, "X");
if (crc32("AAKZFpEGciYzU",13) == 2940232226) strcat(s, "i");
if (crc32("NSmMcj",6) == 1066310853) strcat(s, "h");
if (crc32("ehqNTZN",7) == 2780399711) strcat(s, "n");
if (crc32("iHjjQmj",7) == 1563587721) strcat(s, "O");
if (crc32("NenQfdodXigIN",13) == 2329136667) strcat(s, "g");
    return s;
}

char *declaring_verbs() {
    char *s = calloc(10);
    if (crc32("mouTp",5) == 405659747) strcat(s, "d");
if (crc32("KcqZAqHlA",9) == 3528053449) strcat(s, "V");
if (crc32("awWZEQNIxMZVF",13) == 4029910379) strcat(s, "e");
if (crc32("equPfyJreDIDd",13) == 1725366204) strcat(s, "F");
if (crc32("rFwXRNCITAwnU",13) == 363158058) strcat(s, "c");
if (crc32("dFvtzxsjpuys",12) == 2703655678) strcat(s, "z");
if (crc32("xcpSsdWCbnl",11) == 2279775551) strcat(s, "l");
if (crc32("sgheohkNIuE",11) == 597722964) strcat(s, "T");
if (crc32("KTDucnu",7) == 745385176) strcat(s, "a");
if (crc32("NNdlsXrglNwB",12) == 3168523689) strcat(s, "q");
if (crc32("tvvymDQjwBB",11) == 3404640779) strcat(s, "r");
if (crc32("lTDhPJvLeO",10) == 3314635391) strcat(s, "i");
if (crc32("JFgRUkK",7) == 2148165841) strcat(s, "P");
if (crc32("JnagvvqQq",9) == 3115553530) strcat(s, "n");
if (crc32("FrTmNtOWbfhz",12) == 2409234846) strcat(s, "g");
    return s;
}

char *clinging_verbs() {
    char *s = calloc(9);
    if (crc32("TmIYQgi",7) == 1323061380) strcat(s, "o");
if (crc32("HxzpRbi",7) == 3644397881) strcat(s, "c");
if (crc32("hVnGjaqNGpgtX",13) == 2991615184) strcat(s, "p");
if (crc32("zwkcS",5) == 2073594813) strcat(s, "l");
if (crc32("hpPpcuIPY",9) == 3491831180) strcat(s, "i");
if (crc32("HIVpCnzZmFhKT",13) == 493765884) strcat(s, "j");
if (crc32("acDcUSMbWOSTCh",14) == 3527951274) strcat(s, "n");
if (crc32("WiZAlptpfFhX",12) == 1465267922) strcat(s, "T");
if (crc32("wHueflKcuoXtZZ",14) == 1524430405) strcat(s, "g");
if (crc32("QXdpUAEIZA",10) == 1874930209) strcat(s, "i");
if (crc32("kNYLplNzWCL",11) == 2232428446) strcat(s, "n");
if (crc32("wGHOprxp",8) == 4028290542) strcat(s, "g");
    return s;
}

char *pissoff_verbs() {
    char *s = calloc(8);
    if (crc32("qUzwzeNmKVOTwYP",15) == 796434044) strcat(s, "h");
if (crc32("NZoSrfud",8) == 3447342764) strcat(s, "p");
if (crc32("ALsGJZV",7) == 2035692977) strcat(s, "m");
if (crc32("zghNSX",6) == 1087999022) strcat(s, "i");
if (crc32("uUGwAEFMatCaw",13) == 1531727982) strcat(s, "s");
if (crc32("nCwbgzsHIc",10) == 2325723956) strcat(s, "e");
if (crc32("MAYpwZpSFUF",11) == 4250326614) strcat(s, "s");
if (crc32("cxpfQXqHb",9) == 192027054) strcat(s, "o");
if (crc32("lknuVMdfF",9) == 3124946374) strcat(s, "S");
if (crc32("KDHzDIjdUrtH",12) == 2503902737) strcat(s, "f");
if (crc32("hoyEdOS",7) == 4107071640) strcat(s, "W");
if (crc32("cFgxZT",6) == 944809951) strcat(s, "f");
    return s;
}

char *brushup_verbs() {
    char *s = calloc(8);
    if (crc32("KjjCaaiuvQzVc",13) == 1853630454) strcat(s, "h");
if (crc32("ALkclDAiDoRwQ",13) == 339257723) strcat(s, "b");
if (crc32("rLKYVHUd",8) == 1939236640) strcat(s, "D");
if (crc32("XHAYQvsiVbMQy",13) == 293597126) strcat(s, "r");
if (crc32("yQSIsWqmjAurwCH",15) == 2103877461) strcat(s, "u");
if (crc32("SlyQL",5) == 1334524108) strcat(s, "s");
if (crc32("lfpDBnaaLBMZL",13) == 1458077896) strcat(s, "F");
if (crc32("CHXTJp",6) == 1863499131) strcat(s, "h");
if (crc32("MHEPgYVU",8) == 4121223795) strcat(s, "u");
if (crc32("JjVsqrjmL",9) == 71679147) strcat(s, "D");
if (crc32("cjkbijHl",8) == 3935022639) strcat(s, "p");
    return s;
}

char *enter_verbs() {
    char *s = calloc(6);
    if (crc32("EAmJxYDKeL",10) == 609104271) strcat(s, "e");
if (crc32("QooKyV",6) == 235743591) strcat(s, "n");
if (crc32("hMxjuXaKxmaQlL",14) == 1494338830) strcat(s, "t");
if (crc32("mecEsVHacJ",10) == 3390862567) strcat(s, "c");
if (crc32("MSWBRqhVQZwU",12) == 4175719543) strcat(s, "e");
if (crc32("UGXrAFdy",8) == 3849386264) strcat(s, "r");
    return s;
}

char *import_verbs() {
    char *s = calloc(7);
    if (crc32("acNFPZRrfyJHvK",14) == 2655462115) strcat(s, "i");
if (crc32("MxdTAMes",8) == 3146724946) strcat(s, "E");
if (crc32("rQObaG",6) == 3995153122) strcat(s, "m");
if (crc32("izbGeeUXYmmbhgO",15) == 560535478) strcat(s, "p");
if (crc32("QpAnws",6) == 1196526843) strcat(s, "o");
if (crc32("VpYKy",5) == 4264286405) strcat(s, "v");
if (crc32("EUDqGXsQaf",10) == 2464799875) strcat(s, "r");
if (crc32("RdIYRDPJvcSEuuk",15) == 2320034797) strcat(s, "t");
    return s;
}

char *clarify_verbs() {
    char *s = calloc(8);
    if (crc32("JltblkWxGDul",12) == 3350776371) strcat(s, "c");
if (crc32("jiqscMrEyztgeqI",15) == 1426582275) strcat(s, "e");
if (crc32("QOCDxYAj",8) == 3820078244) strcat(s, "l");
if (crc32("ZuswQVc",7) == 1553496440) strcat(s, "a");
if (crc32("ZBbGcmDijGSZUV",14) == 3156963455) strcat(s, "A");
if (crc32("wUSdg",5) == 3451846371) strcat(s, "r");
if (crc32("hcCbhrKr",8) == 1133378725) strcat(s, "s");
if (crc32("fpEUvPOeBhXn",12) == 1263089056) strcat(s, "i");
if (crc32("KWXgLKtbD",9) == 1039877231) strcat(s, "T");
if (crc32("pKlVHgcj",8) == 3079964517) strcat(s, "f");
if (crc32("gsBByF",6) == 956361564) strcat(s, "y");
    return s;
}

char *parry_verbs() {
    char *s = calloc(6);
    if (crc32("sRsaQdlB",8) == 3081150266) strcat(s, "p");
if (crc32("nXActzknYb",10) == 4282248232) strcat(s, "a");
if (crc32("SlzdcMHlDHqQsA",14) == 3572850526) strcat(s, "r");
if (crc32("VGnWBZtSMRQVmXr",15) == 973002764) strcat(s, "t");
if (crc32("WhMprNXWPl",10) == 970323025) strcat(s, "r");
if (crc32("wfQPkbOYSg",10) == 1624098693) strcat(s, "z");
if (crc32("rXazbPskUk",10) == 3513690645) strcat(s, "y");
    return s;
}

char *misgrading_verbs() {
    char *s = calloc(11);
    if (crc32("IhBOHbxAnsbiD",13) == 1567843480) strcat(s, "E");
if (crc32("nDuwGadSqRk",11) == 302372531) strcat(s, "m");
if (crc32("WFVAEMZ",7) == 4058614836) strcat(s, "n");
if (crc32("vWJFqySbVOTuZus",15) == 3502779311) strcat(s, "i");
if (crc32("LEXtoW",6) == 2635189136) strcat(s, "A");
if (crc32("DdKKzKCvFPLVP",13) == 2440160053) strcat(s, "s");
if (crc32("GmEUr",5) == 2843331569) strcat(s, "M");
if (crc32("RpUyEix",7) == 1483793223) strcat(s, "g");
if (crc32("oxysMmDN",8) == 1259693108) strcat(s, "u");
if (crc32("PbbJaRaPDP",10) == 3416125338) strcat(s, "r");
if (crc32("mFBCJta",7) == 158663418) strcat(s, "a");
if (crc32("sHgmSq",6) == 3601485832) strcat(s, "z");
if (crc32("HvNAPUBguL",10) == 2666511928) strcat(s, "d");
if (crc32("yyFWs",5) == 2493040457) strcat(s, "x");
if (crc32("ayMLLJr",7) == 540834912) strcat(s, "i");
if (crc32("ifNsqNFbIZkBkg",14) == 2410028881) strcat(s, "n");
if (crc32("QoBDInZ",7) == 3634498621) strcat(s, "g");
    return s;
}

char *blending_verbs() {
    char *s = calloc(9);
    if (crc32("slpuMLFmAAOHvcT",15) == 697426949) strcat(s, "j");
if (crc32("mvtsFHYHZQwJOcu",15) == 798731623) strcat(s, "b");
if (crc32("QDsCuDRknse",11) == 3560189019) strcat(s, "l");
if (crc32("svQjLb",6) == 1995007564) strcat(s, "Y");
if (crc32("IGMenuVYPfQpXw",14) == 2688825299) strcat(s, "e");
if (crc32("mTVImmnZeUQoK",13) == 2467874699) strcat(s, "h");
if (crc32("SHoYfrJKJhpYw",13) == 1386633410) strcat(s, "n");
if (crc32("NiCfuqgTZs",10) == 118250952) strcat(s, "d");
if (crc32("PTfaYX",6) == 1317936069) strcat(s, "j");
if (crc32("BmPrRhQRUjFOX",13) == 3074044582) strcat(s, "i");
if (crc32("Wvoaupb",7) == 3760473432) strcat(s, "n");
if (crc32("pHVUDz",6) == 1924600300) strcat(s, "g");
    return s;
}

char *compassionating_verbs() {
    char *s = calloc(16);
    if (crc32("VFDfCElYOZpBwW",14) == 461495063) strcat(s, "d");
if (crc32("QjCtLFZHx",9) == 57866263) strcat(s, "c");
if (crc32("UbEqRQzyVbUnz",13) == 3348370699) strcat(s, "o");
if (crc32("kJCFqahErEz",11) == 2140393454) strcat(s, "m");
if (crc32("umrOkkUKHOi",11) == 2221004224) strcat(s, "p");
if (crc32("UWDZlVCG",8) == 1389476014) strcat(s, "a");
if (crc32("oxsUSbN",7) == 4292125591) strcat(s, "S");
if (crc32("cTOlYMzYkrm",11) == 4265947397) strcat(s, "s");
if (crc32("PuOdoexTL",9) == 3171469662) strcat(s, "s");
if (crc32("yMBIEsGyQaxXb",13) == 566717541) strcat(s, "K");
if (crc32("qyZexIxUxKZs",12) == 456114042) strcat(s, "i");
if (crc32("GYYUtHTE",8) == 1777362817) strcat(s, "o");
if (crc32("CQmfAdmyxVHrqV",14) == 4218790951) strcat(s, "Z");
if (crc32("NhCsQdkMpUH",11) == 2452098848) strcat(s, "n");
if (crc32("wWrQTdJv",8) == 3726463719) strcat(s, "a");
if (crc32("VuZjmuSGL",9) == 755728484) strcat(s, "V");
if (crc32("FsjZLWvxaRd",11) == 2228304177) strcat(s, "t");
if (crc32("Vsyenk",6) == 2554995253) strcat(s, "V");
if (crc32("EttKnWRtHxK",11) == 4268719816) strcat(s, "i");
if (crc32("ZgUgTvabKJA",11) == 4047204753) strcat(s, "X");
if (crc32("XbGBPVAJSxjjmCk",15) == 1773716584) strcat(s, "n");
if (crc32("ixodWzqAtu",10) == 2145363153) strcat(s, "m");
if (crc32("CEqpl",5) == 1270033257) strcat(s, "g");
    return s;
}

char *has_verbs() {
    char *s = calloc(4);
    if (crc32("MteYYlp",7) == 1255188185) strcat(s, "p");
if (crc32("nxuhIrrKcviSqms",15) == 3152370587) strcat(s, "h");
if (crc32("AxJjjEsPj",9) == 3186293612) strcat(s, "L");
if (crc32("LtDsXjrw",8) == 2971515078) strcat(s, "a");
if (crc32("ASzlLZwB",8) == 2428964045) strcat(s, "K");
if (crc32("PTUCyxLmGtuE",12) == 1133426099) strcat(s, "s");
    return s;
}

char *shine_verbs() {
    char *s = calloc(6);
    if (crc32("yvAgkFDQ",8) == 491545536) strcat(s, "H");
if (crc32("qNFjxPetyfqhKT",14) == 1273377816) strcat(s, "s");
if (crc32("YgujiiLV",8) == 920324767) strcat(s, "h");
if (crc32("TgClKrv",7) == 3909413446) strcat(s, "i");
if (crc32("XfZEbiGJIoazlg",14) == 574770817) strcat(s, "A");
if (crc32("AXXRUvbspjvatI",14) == 1280909524) strcat(s, "n");
if (crc32("lKsvUWMm",8) == 3166358038) strcat(s, "e");
    return s;
}

char *stratify_verbs() {
    char *s = calloc(9);
    if (crc32("uLRgiiXcp",9) == 767695119) strcat(s, "s");
if (crc32("bCJQWsoLm",9) == 3973433742) strcat(s, "f");
if (crc32("vhdnqpcykBfm",12) == 2142580029) strcat(s, "t");
if (crc32("dgGGxZSdNVt",11) == 1509056970) strcat(s, "r");
if (crc32("gPOhzHSXcAZS",12) == 4152079939) strcat(s, "H");
if (crc32("BWCvQ",5) == 2770225060) strcat(s, "a");
if (crc32("htUvhulInHHhmYq",15) == 2724202597) strcat(s, "t");
if (crc32("VcFHvWfbJBRljhs",15) == 3762525787) strcat(s, "i");
if (crc32("rGeoMVSZKXd",11) == 4116267080) strcat(s, "Z");
if (crc32("YTmCzZ",6) == 2989401158) strcat(s, "f");
if (crc32("FifqwLvVQvIAAMy",15) == 2081153729) strcat(s, "y");
    return s;
}

char *soliloquized_verbs() {
    char *s = calloc(13);
    if (crc32("AHHmCvuQLr",10) == 3489661945) strcat(s, "x");
if (crc32("CqicuiwRs",9) == 2525067283) strcat(s, "s");
if (crc32("ENFcsTBbGzYIEpw",15) == 1018759030) strcat(s, "o");
if (crc32("wNoMETcQybvBwiM",15) == 409992177) strcat(s, "N");
if (crc32("iWZIXKfwEhv",11) == 1028959092) strcat(s, "l");
if (crc32("TougDSfPYbcEZ",13) == 1962752579) strcat(s, "i");
if (crc32("ldXfrODVQmF",11) == 3526703567) strcat(s, "l");
if (crc32("MoAoInecYaNGQYv",15) == 1580721492) strcat(s, "C");
if (crc32("lgTPAN",6) == 3040043337) strcat(s, "o");
if (crc32("LVwofqRbvcFGFe",14) == 2560917341) strcat(s, "q");
if (crc32("SUpFROxamZ",10) == 628187863) strcat(s, "q");
if (crc32("hQClvPF",7) == 2126826848) strcat(s, "B");
if (crc32("ZeXimcWMd",9) == 2289422326) strcat(s, "u");
if (crc32("myTYCF",6) == 2458077744) strcat(s, "i");
if (crc32("tjvCAddxz",9) == 3307650650) strcat(s, "z");
if (crc32("JeyoGT",6) == 2554555947) strcat(s, "a");
if (crc32("NAzIzCruCCEOK",13) == 154175133) strcat(s, "e");
if (crc32("RMWFQYjIo",9) == 2562556022) strcat(s, "v");
if (crc32("xIVcjzAdjv",10) == 222129069) strcat(s, "d");
    return s;
}

char *displeasing_verbs() {
    char *s = calloc(12);
    if (crc32("sNstgk",6) == 18461354) strcat(s, "d");
if (crc32("PzarpNoqEyzwOO",14) == 3577556836) strcat(s, "E");
if (crc32("MxvLPQrZIrKOQb",14) == 4182613114) strcat(s, "i");
if (crc32("FplFpR",6) == 1051482362) strcat(s, "s");
if (crc32("djLkVAgJhy",10) == 189126640) strcat(s, "C");
if (crc32("lxtpmiCyA",9) == 2593693335) strcat(s, "p");
if (crc32("MTVjlAt",7) == 866145551) strcat(s, "l");
if (crc32("YqlnONcD",8) == 3055224198) strcat(s, "P");
if (crc32("JQTONDGOj",9) == 1095463673) strcat(s, "e");
if (crc32("ozBHeJdGb",9) == 2985868729) strcat(s, "L");
if (crc32("NqSgD",5) == 3348446924) strcat(s, "a");
if (crc32("AujOFhvJezBJEJ",14) == 1287683075) strcat(s, "k");
if (crc32("GAAkDplOp",9) == 2582083552) strcat(s, "s");
if (crc32("qqqsnYThlAjsDSY",15) == 4102902220) strcat(s, "q");
if (crc32("DeoMCimhDK",10) == 2839897928) strcat(s, "i");
if (crc32("WtIuHPzgUsBWR",13) == 3536568266) strcat(s, "Y");
if (crc32("HgVCKYaeIOtn",12) == 1258501869) strcat(s, "n");
if (crc32("MYkTOiXdAEMyA",13) == 1115486889) strcat(s, "E");
if (crc32("GwbNCdch",8) == 109901664) strcat(s, "g");
    return s;
}

char *cover_verbs() {
    char *s = calloc(6);
    if (crc32("zmVJBtNQnmYcmml",15) == 3974157527) strcat(s, "A");
if (crc32("usaMOruxzcE",11) == 2048662902) strcat(s, "c");
if (crc32("qHJQqJpTtlQMk",13) == 2070874470) strcat(s, "a");
if (crc32("IyYrYh",6) == 2755103704) strcat(s, "o");
if (crc32("HkSjBmN",7) == 2444925270) strcat(s, "v");
if (crc32("BSdFUAGfXRvB",12) == 1207714560) strcat(s, "i");
if (crc32("PcGcEIxeNFRwdLi",15) == 2121689899) strcat(s, "e");
if (crc32("hxHyygWOUMASJga",15) == 3108389961) strcat(s, "c");
if (crc32("ybUBNAqtTOw",11) == 1248710686) strcat(s, "r");
    return s;
}

char *miring_verbs() {
    char *s = calloc(7);
    if (crc32("OfqfCAgQNJ",10) == 4110249127) strcat(s, "m");
if (crc32("GBSYRRaOy",9) == 1688760223) strcat(s, "r");
if (crc32("YXuZspYL",8) == 794122184) strcat(s, "i");
if (crc32("loZMtJJXKVAAv",13) == 3816304254) strcat(s, "U");
if (crc32("bkXLtpxB",8) == 3424375739) strcat(s, "r");
if (crc32("FxuPhRsvY",9) == 939071108) strcat(s, "E");
if (crc32("AklLYfhrmujx",12) == 3483068557) strcat(s, "i");
if (crc32("fvKXJYxGBsTxi",13) == 439636699) strcat(s, "n");
if (crc32("bXazgkuRz",9) == 947251737) strcat(s, "g");
    return s;
}

char *overstrengthen_verbs() {
    char *s = calloc(15);
    if (crc32("OPXaZnMShSOhXid",15) == 384961605) strcat(s, "U");
if (crc32("SxtaoqPLtv",10) == 2191625158) strcat(s, "o");
if (crc32("NniSe",5) == 290519786) strcat(s, "v");
if (crc32("nRWxtDdU",8) == 469289316) strcat(s, "y");
if (crc32("gtgoCiXjFDh",11) == 2038987213) strcat(s, "e");
if (crc32("fNnjDXzwFZr",11) == 962771457) strcat(s, "B");
if (crc32("gpGXfpAUQ",9) == 3298797003) strcat(s, "r");
if (crc32("ExldspA",7) == 1464942869) strcat(s, "L");
if (crc32("TFGbSX",6) == 1222176304) strcat(s, "s");
if (crc32("aAkExr",6) == 3563245666) strcat(s, "t");
if (crc32("eWvGXVVMFfSeMq",14) == 3190039443) strcat(s, "r");
if (crc32("VhGAu",5) == 859533864) strcat(s, "e");
if (crc32("xZoQTuZXMq",10) == 1412551677) strcat(s, "E");
if (crc32("gSrqjGgzdVF",11) == 3496987152) strcat(s, "n");
if (crc32("SnQlhviUuHrIJd",14) == 2467060533) strcat(s, "Y");
if (crc32("gHVFXTZd",8) == 2852895336) strcat(s, "g");
if (crc32("bnBVKhEaf",9) == 661252011) strcat(s, "t");
if (crc32("ErcKwRIJViMQ",12) == 3411821748) strcat(s, "h");
if (crc32("YIRBWKrVUwLkmIQ",15) == 1689028034) strcat(s, "e");
if (crc32("uqcfffIO",8) == 540784674) strcat(s, "V");
if (crc32("SorYCG",6) == 2970455739) strcat(s, "n");
    return s;
}

char *loopholed_verbs() {
    char *s = calloc(10);
    if (crc32("XcoIu",5) == 2777536024) strcat(s, "l");
if (crc32("mtSQMwmMAAF",11) == 2245781827) strcat(s, "P");
if (crc32("jXRoJpsrzkmZCFD",15) == 2049065121) strcat(s, "o");
if (crc32("miquiSUHDoG",11) == 2574567498) strcat(s, "o");
if (crc32("ZnSxDiNiMLi",11) == 3250287147) strcat(s, "c");
if (crc32("nIdxXA",6) == 1270876759) strcat(s, "p");
if (crc32("enuFA",5) == 742405181) strcat(s, "e");
if (crc32("AwkAkLSbC",9) == 755266186) strcat(s, "h");
if (crc32("rGLCpdlBT",9) == 832360019) strcat(s, "S");
if (crc32("MNeMm",5) == 625107341) strcat(s, "o");
if (crc32("VfVyH",5) == 3919568607) strcat(s, "V");
if (crc32("spwuui",6) == 122837202) strcat(s, "l");
if (crc32("GruvmabifEFFsec",15) == 3177806889) strcat(s, "e");
if (crc32("zDqHSFZXeKvAP",13) == 43813921) strcat(s, "d");
    return s;
}

char *retwined_verbs() {
    char *s = calloc(9);
    if (crc32("XYrspvvsUx",10) == 3411018678) strcat(s, "a");
if (crc32("ywYcdHW",7) == 1817894926) strcat(s, "r");
if (crc32("cziqw",5) == 2742150911) strcat(s, "e");
if (crc32("lTuaw",5) == 1043521894) strcat(s, "t");
if (crc32("BWWusAfFLwqqmI",14) == 861817515) strcat(s, "d");
if (crc32("BFZqYMjvGcKXRJP",15) == 1807311279) strcat(s, "w");
if (crc32("ljBJwsnHIOd",11) == 555465982) strcat(s, "i");
if (crc32("uPCMHNPtfm",10) == 2513335497) strcat(s, "n");
if (crc32("DwUWFwRI",8) == 1594280082) strcat(s, "n");
if (crc32("xvIQwWv",7) == 2680044277) strcat(s, "w");
if (crc32("WVTSXerEJ",9) == 1981438310) strcat(s, "e");
if (crc32("QcHwL",5) == 1847020838) strcat(s, "M");
if (crc32("mthvHUQDmdOxgdl",15) == 4224610306) strcat(s, "d");
    return s;
}

char *restructured_verbs() {
    char *s = calloc(13);
    if (crc32("AdUcDa",6) == 26671297) strcat(s, "r");
if (crc32("RDDPs",5) == 2845680742) strcat(s, "P");
if (crc32("msRPKLbrWScA",12) == 587381408) strcat(s, "e");
if (crc32("HtZCRvRNaOr",11) == 1802711406) strcat(s, "D");
if (crc32("iIkWFElmWBIj",12) == 307403634) strcat(s, "s");
if (crc32("vSYCTEPaKRmouw",14) == 4103192062) strcat(s, "t");
if (crc32("apoGuHnNtKPx",12) == 2525059216) strcat(s, "r");
if (crc32("wUPUvYcuJZw",11) == 1480685962) strcat(s, "j");
if (crc32("TFQzAeBeOy",10) == 2609277487) strcat(s, "u");
if (crc32("MeZSKRSqpb",10) == 3029362950) strcat(s, "o");
if (crc32("NrxPYeqzeKpsWwo",15) == 560613668) strcat(s, "c");
if (crc32("zIpMpzBU",8) == 2443500737) strcat(s, "f");
if (crc32("IzuqhIqDf",9) == 4247743090) strcat(s, "t");
if (crc32("PFCeqqwyNyiLQps",15) == 2814986174) strcat(s, "u");
if (crc32("JZFkh",5) == 3862323790) strcat(s, "x");
if (crc32("eqwPPdpOjrMN",12) == 3192660028) strcat(s, "r");
if (crc32("PFdkcBP",7) == 2415327388) strcat(s, "E");
if (crc32("ruUcnPrLa",9) == 4284674202) strcat(s, "e");
if (crc32("CNOPM",5) == 1806323726) strcat(s, "d");
    return s;
}

char *switchon_verbs() {
    char *s = calloc(9);
    if (crc32("wKmGpf",6) == 3216112770) strcat(s, "s");
if (crc32("QIozqQYgQ",9) == 2148246131) strcat(s, "w");
if (crc32("UAQbKOMwbpLy",12) == 1176963862) strcat(s, "g");
if (crc32("VqhXgQQlOfCPqN",14) == 2895782552) strcat(s, "i");
if (crc32("ANJNvKJDMRDua",13) == 1718575883) strcat(s, "a");
if (crc32("alEvd",5) == 1449907521) strcat(s, "t");
if (crc32("CoVUOBXZAxJsT",13) == 2474564022) strcat(s, "c");
if (crc32("BAsvwKZKxtspe",13) == 3457941114) strcat(s, "p");
if (crc32("mPndy",5) == 109890130) strcat(s, "h");
if (crc32("Hqgac",5) == 1754150840) strcat(s, "B");
if (crc32("LhtPQvod",8) == 2157847641) strcat(s, "o");
if (crc32("LxajwLkNGpLNq",13) == 3122478436) strcat(s, "n");
    return s;
}

char *demit_verbs() {
    char *s = calloc(6);
    if (crc32("mxBhMquYmxOnQs",14) == 1305409805) strcat(s, "h");
if (crc32("RBTlxdYFT",9) == 2903972160) strcat(s, "d");
if (crc32("qKURYOmA",8) == 2037508349) strcat(s, "f");
if (crc32("jeaVQHEgoiaJ",12) == 4078776984) strcat(s, "e");
if (crc32("iLkIbSMlakzx",12) == 1789614786) strcat(s, "m");
if (crc32("lKWxgvxlt",9) == 1238861929) strcat(s, "i");
if (crc32("FkigwkQdv",9) == 3213072106) strcat(s, "i");
if (crc32("wmaLVeQsCRrYgsK",15) == 3735064971) strcat(s, "t");
    return s;
}

char *outlined_verbs() {
    char *s = calloc(9);
    if (crc32("KOusClPRQEKEsW",14) == 750814214) strcat(s, "o");
if (crc32("MNvUqZBO",8) == 2805094537) strcat(s, "T");
if (crc32("ZDNhQrwwiakJ",12) == 206912064) strcat(s, "u");
if (crc32("hwImBoljV",9) == 2875713723) strcat(s, "S");
if (crc32("AIryWl",6) == 198025082) strcat(s, "t");
if (crc32("gDneutty",8) == 2945150004) strcat(s, "X");
if (crc32("SeUlHlkcbB",10) == 552301642) strcat(s, "l");
if (crc32("HMPWTwVbqWH",11) == 2130086807) strcat(s, "i");
if (crc32("IkKtE",5) == 1322047211) strcat(s, "n");
if (crc32("sKsUfjAYybQ",11) == 1022174289) strcat(s, "e");
if (crc32("ZPAVW",5) == 389740199) strcat(s, "d");
    return s;
}

char *radiobroadcasted_verbs() {
    char *s = calloc(17);
    if (crc32("haluquKUvbku",12) == 1570370626) strcat(s, "r");
if (crc32("IRpDdvcdlbRbtKb",15) == 2079601268) strcat(s, "T");
if (crc32("InRbmEYgORca",12) == 2662191022) strcat(s, "a");
if (crc32("JzyYbcSQJVJv",12) == 60997790) strcat(s, "l");
if (crc32("hVBRjuPKy",9) == 3651292763) strcat(s, "d");
if (crc32("GMOuttgohpVMMBo",15) == 3703104172) strcat(s, "i");
if (crc32("YeUNyTIutGTV",12) == 39762442) strcat(s, "o");
if (crc32("TccRShBAlgZ",11) == 4229157953) strcat(s, "b");
if (crc32("tyxOueShr",9) == 2580489185) strcat(s, "r");
if (crc32("VuZIuYtgoqk",11) == 2868881669) strcat(s, "o");
if (crc32("fAihjzxkj",9) == 1883407908) strcat(s, "a");
if (crc32("PgDervY",7) == 912554893) strcat(s, "d");
if (crc32("jUKjR",5) == 2412492469) strcat(s, "c");
if (crc32("xriDgfcsfJQ",11) == 3989389739) strcat(s, "a");
if (crc32("cXTdbIfnozUA",12) == 184599397) strcat(s, "E");
if (crc32("DYbmUwtwws",10) == 3651506512) strcat(s, "s");
if (crc32("eqzqySaMkSpUOF",14) == 2603878260) strcat(s, "L");
if (crc32("ceJfle",6) == 571710173) strcat(s, "t");
if (crc32("oZFgv",5) == 1061653662) strcat(s, "y");
if (crc32("RLOQyGaKiZeV",12) == 518032619) strcat(s, "e");
if (crc32("utQKrfvKLtrx",12) == 3060845715) strcat(s, "d");
    return s;
}

char *cry_verbs() {
    char *s = calloc(4);
    if (crc32("AtoEvREWl",9) == 4121444574) strcat(s, "c");
if (crc32("MkVtBeB",7) == 1442988464) strcat(s, "W");
if (crc32("FGKnpXzJDFDrh",13) == 3336855360) strcat(s, "r");
if (crc32("qifdBwiZ",8) == 3229530653) strcat(s, "Y");
if (crc32("mdUBxgTcjfPwE",13) == 4048406204) strcat(s, "y");
    return s;
}

char *overargued_verbs() {
    char *s = calloc(11);
    if (crc32("dpqbHlvDFHo",11) == 3726401763) strcat(s, "l");
if (crc32("vwJNjrw",7) == 4216576493) strcat(s, "o");
if (crc32("XKviVM",6) == 941439864) strcat(s, "Y");
if (crc32("qQYzQEYRRz",10) == 737715460) strcat(s, "v");
if (crc32("xkkzej",6) == 1260992246) strcat(s, "C");
if (crc32("GtDHiKlXtspMUW",14) == 962125828) strcat(s, "e");
if (crc32("FPuvcgHvKIqjTzl",15) == 2233386002) strcat(s, "r");
if (crc32("gMRmavIXUsNpvE",14) == 2695247418) strcat(s, "a");
if (crc32("tSBbNlhiKsJm",12) == 1991009380) strcat(s, "r");
if (crc32("iTppPEbDOnrUvwP",15) == 3971137756) strcat(s, "e");
if (crc32("ayadciQiyTMPXIv",15) == 2711922541) strcat(s, "g");
if (crc32("CNsPhhpkMO",10) == 2024926468) strcat(s, "F");
if (crc32("XlYxLGdiIZt",11) == 276360722) strcat(s, "u");
if (crc32("ZCWCboQH",8) == 1599443081) strcat(s, "a");
if (crc32("pmEmwd",6) == 489072018) strcat(s, "e");
if (crc32("DfqDhaVOicJVkx",14) == 3821174748) strcat(s, "d");
    return s;
}

char *raved_verbs() {
    char *s = calloc(6);
    if (crc32("vrffqs",6) == 1431032987) strcat(s, "l");
if (crc32("ysUBMhY",7) == 1863709576) strcat(s, "r");
if (crc32("fQcdUU",6) == 2927980212) strcat(s, "u");
if (crc32("TWmRMpLYBQ",10) == 2625267757) strcat(s, "a");
if (crc32("XdAlZ",5) == 173612724) strcat(s, "z");
if (crc32("yGTBcuCleYs",11) == 3052633041) strcat(s, "v");
if (crc32("rnNckyJRaLCYYtE",15) == 2166795682) strcat(s, "L");
if (crc32("WFbgiJOSNTDdiFG",15) == 2723655482) strcat(s, "e");
if (crc32("UMfTqCMNQOP",11) == 2662342554) strcat(s, "d");
    return s;
}

char *overstore_verbs() {
    char *s = calloc(10);
    if (crc32("xAqliazK",8) == 1605533523) strcat(s, "o");
if (crc32("UjJGMDGkCnZD",12) == 1517487896) strcat(s, "v");
if (crc32("LWufd",5) == 649705109) strcat(s, "e");
if (crc32("mCpBJdyeXhSugm",14) == 648040686) strcat(s, "L");
if (crc32("JotTo",5) == 3875959989) strcat(s, "r");
if (crc32("pIzWuwXqTbdMw",13) == 188655406) strcat(s, "s");
if (crc32("scqCLZPNspCmU",13) == 2600285868) strcat(s, "e");
if (crc32("BWYSvPqnHTCI",12) == 3053552178) strcat(s, "t");
if (crc32("Nggbo",5) == 1946629547) strcat(s, "V");
if (crc32("LlsYPM",6) == 1034652620) strcat(s, "o");
if (crc32("LUXNFmDaMaleZe",14) == 4218501382) strcat(s, "r");
if (crc32("mnHBpvC",7) == 2185535974) strcat(s, "u");
if (crc32("nJuAxIA",7) == 2151558537) strcat(s, "e");
    return s;
}

char *reviling_verbs() {
    char *s = calloc(9);
    if (crc32("zFwjm",5) == 540961175) strcat(s, "j");
if (crc32("rKoJYkLkawxky",13) == 3422111412) strcat(s, "r");
if (crc32("aCDYxtR",7) == 3066293134) strcat(s, "e");
if (crc32("GcePfT",6) == 1122559655) strcat(s, "v");
if (crc32("OtXjsLQ",7) == 4117999926) strcat(s, "i");
if (crc32("njrFKaIvyjKmFC",14) == 3121449123) strcat(s, "A");
if (crc32("LCpXoFXqHRgnOx",14) == 1902173833) strcat(s, "l");
if (crc32("JRWEswdPCHuR",12) == 1267952632) strcat(s, "j");
if (crc32("PJJEqkVeHRCMu",13) == 4233681201) strcat(s, "i");
if (crc32("aBNXqXiSA",9) == 3075127886) strcat(s, "b");
if (crc32("dxZgIALpUh",10) == 3059275047) strcat(s, "n");
if (crc32("tulLehDTNQY",11) == 3999258325) strcat(s, "g");
    return s;
}

char *overissue_verbs() {
    char *s = calloc(10);
    if (crc32("AVMATVKEwqaPOc",14) == 1358054542) strcat(s, "o");
if (crc32("BcJEPlekTVpcm",13) == 3747945009) strcat(s, "x");
if (crc32("cZRWdubc",8) == 311986119) strcat(s, "v");
if (crc32("WkoBtwc",7) == 3564083371) strcat(s, "e");
if (crc32("sATpcrZfAAX",11) == 2466360600) strcat(s, "r");
if (crc32("RSrSJ",5) == 3968954011) strcat(s, "H");
if (crc32("btuvWqDuZiLbXM",14) == 436543278) strcat(s, "i");
if (crc32("vISBrLP",7) == 4264133293) strcat(s, "y");
if (crc32("tBBFSvVVb",9) == 1021324345) strcat(s, "s");
if (crc32("HIsLSQ",6) == 1361441287) strcat(s, "I");
if (crc32("QQEPQgL",7) == 3165293288) strcat(s, "s");
if (crc32("CxbQDgmmyOJPBLA",15) == 3754109617) strcat(s, "u");
if (crc32("UaSKYjQNLPrXzH",14) == 1355405410) strcat(s, "e");
    return s;
}

char *pistolwhip_verbs() {
    char *s = calloc(11);
    if (crc32("vbUpiPaxhzyGSag",15) == 690127479) strcat(s, "p");
if (crc32("oSrotOUYKdPv",12) == 2010777935) strcat(s, "w");
if (crc32("BPXKRmmgynMCSi",14) == 381667587) strcat(s, "i");
if (crc32("JqYmelGMvq",10) == 2038845603) strcat(s, "C");
if (crc32("yBnNtGgCT",9) == 3476130321) strcat(s, "s");
if (crc32("PMXuhGJ",7) == 906498059) strcat(s, "t");
if (crc32("PgFhe",5) == 3156963942) strcat(s, "o");
if (crc32("wKnJmzsxnEuNpKp",15) == 2570477203) strcat(s, "u");
if (crc32("KJVXRjDv",8) == 707630034) strcat(s, "l");
if (crc32("wsfEvqjPsfCSq",13) == 4289298860) strcat(s, "w");
if (crc32("PRytXI",6) == 977135862) strcat(s, "q");
if (crc32("QYKRd",5) == 3418991096) strcat(s, "h");
if (crc32("wBUTU",5) == 325880324) strcat(s, "i");
if (crc32("xrxFpRMBzcllK",13) == 2200016021) strcat(s, "p");
    return s;
}

char *revoking_verbs() {
    char *s = calloc(9);
    if (crc32("rZzqgpSKTdtLm",13) == 2693167542) strcat(s, "r");
if (crc32("PEQzd",5) == 2693455971) strcat(s, "e");
if (crc32("ZqLhWQpTabQwxo",14) == 3775837451) strcat(s, "v");
if (crc32("jTTLkcBn",8) == 1638862456) strcat(s, "W");
if (crc32("SfFqaljROxFsRtB",15) == 1574098542) strcat(s, "o");
if (crc32("XXfpLpLvOUQ",11) == 457132118) strcat(s, "D");
if (crc32("bJzfdcxLNi",10) == 1757070932) strcat(s, "k");
if (crc32("DQCPvusKydJ",11) == 2620364244) strcat(s, "a");
if (crc32("XdbVUkh",7) == 3165714156) strcat(s, "i");
if (crc32("exQeENRDDFUF",12) == 969774886) strcat(s, "s");
if (crc32("cnOmiyhNrfWYD",13) == 1010285030) strcat(s, "n");
if (crc32("PhNzUdu",7) == 4074166885) strcat(s, "g");
    return s;
}

char *euchring_verbs() {
    char *s = calloc(9);
    if (crc32("DqHnvvNzOGxhPg",14) == 3442969515) strcat(s, "Y");
if (crc32("bEroPXJwTEoDaN",14) == 144920872) strcat(s, "e");
if (crc32("ZYmhlinjmwtOsYI",15) == 1937904848) strcat(s, "u");
if (crc32("iaRfRex",7) == 890807025) strcat(s, "c");
if (crc32("DTktppe",7) == 4137562387) strcat(s, "h");
if (crc32("eaHeZeAGAR",10) == 2048373138) strcat(s, "r");
if (crc32("fZnlVxFrML",10) == 595261763) strcat(s, "Q");
if (crc32("rQrkMmx",7) == 3098801396) strcat(s, "i");
if (crc32("YzuQhWWJOzusH",13) == 1064614884) strcat(s, "a");
if (crc32("IAqSBVkJEIBX",12) == 3158200921) strcat(s, "n");
if (crc32("RThnlXAJXZ",10) == 580223947) strcat(s, "r");
if (crc32("jsqnDGWCYrPJa",13) == 4290526038) strcat(s, "g");
    return s;
}

char *enlarge_verbs() {
    char *s = calloc(8);
    if (crc32("EmUeaVpYLO",10) == 880497598) strcat(s, "e");
if (crc32("xazwscPRj",9) == 834354312) strcat(s, "n");
if (crc32("iwHglFTLNEbmW",13) == 1456678737) strcat(s, "l");
if (crc32("rpYNy",5) == 172055042) strcat(s, "a");
if (crc32("WBVpP",5) == 1365839472) strcat(s, "r");
if (crc32("ESbpLVW",7) == 3600166681) strcat(s, "S");
if (crc32("nWpiCAFVtw",10) == 936045593) strcat(s, "g");
if (crc32("hCGrxjLOO",9) == 4114294698) strcat(s, "S");
if (crc32("TrqxposHeMfTHxm",15) == 3803373208) strcat(s, "e");
    return s;
}

char *coprecipitated_verbs() {
    char *s = calloc(15);
    if (crc32("lZcApvWI",8) == 3415731459) strcat(s, "p");
if (crc32("iWNRSYLIRXo",11) == 2557604335) strcat(s, "c");
if (crc32("QiBeKRWWxRLcUCa",15) == 260380244) strcat(s, "o");
if (crc32("cYXnmSqaslEfg",13) == 3059525838) strcat(s, "p");
if (crc32("OpYrBCpLKey",11) == 134610507) strcat(s, "J");
if (crc32("epmtSpZHc",9) == 3217254441) strcat(s, "r");
if (crc32("zEtLh",5) == 2513931923) strcat(s, "e");
if (crc32("qYHqyvNHewK",11) == 1086205797) strcat(s, "F");
if (crc32("omrGgxt",7) == 742373283) strcat(s, "c");
if (crc32("ReFfuXCHHS",10) == 1367066931) strcat(s, "y");
if (crc32("oiEHAsXCqviCEB",14) == 2590729498) strcat(s, "i");
if (crc32("DYRRORjs",8) == 4231540031) strcat(s, "U");
if (crc32("OsMkeISY",8) == 3853110473) strcat(s, "p");
if (crc32("ebAWTMHVqPJv",12) == 149975951) strcat(s, "i");
if (crc32("DEOlSVwpxIWJaaA",15) == 3514055211) strcat(s, "x");
if (crc32("YybRRiLYkE",10) == 997959211) strcat(s, "t");
if (crc32("iRnJr",5) == 634161386) strcat(s, "O");
if (crc32("KiYaOu",6) == 3907090806) strcat(s, "a");
if (crc32("rCCuUg",6) == 2952351966) strcat(s, "v");
if (crc32("KycSHsGULj",10) == 1441768275) strcat(s, "t");
if (crc32("wBViHdzRuAOFJH",14) == 2242038646) strcat(s, "e");
if (crc32("pHaKOOxa",8) == 3884775371) strcat(s, "E");
if (crc32("aoBgcwYMp",9) == 1014671391) strcat(s, "d");
    return s;
}

char *respiting_verbs() {
    char *s = calloc(10);
    if (crc32("cWOiXYFDS",9) == 3988436749) strcat(s, "r");
if (crc32("XtusMIpUNJvkwJ",14) == 2079695214) strcat(s, "e");
if (crc32("MakfLvZjKvarDj",14) == 2492480039) strcat(s, "e");
if (crc32("ubLrGPUFu",9) == 3327626405) strcat(s, "s");
if (crc32("tfRZUbec",8) == 3936228702) strcat(s, "p");
if (crc32("ZqZBXLYyOKxFU",13) == 3753781350) strcat(s, "p");
if (crc32("rxjHgHmdlqvbVWu",15) == 2038594226) strcat(s, "i");
if (crc32("UROedQuckAavR",13) == 1770238813) strcat(s, "t");
if (crc32("qMdMKlkxH",9) == 162251715) strcat(s, "U");
if (crc32("iVJZfuk",7) == 722735229) strcat(s, "i");
if (crc32("CuZVBt",6) == 1352307640) strcat(s, "n");
if (crc32("cXEILb",6) == 3652014340) strcat(s, "r");
if (crc32("EgJaihsPyYnN",12) == 3043122843) strcat(s, "g");
    return s;
}

char *grousing_verbs() {
    char *s = calloc(9);
    if (crc32("nVlcDmY",7) == 1544820779) strcat(s, "g");
if (crc32("mRaNAVjTPDokX",13) == 2296657539) strcat(s, "L");
if (crc32("XiHRnZ",6) == 2221230794) strcat(s, "r");
if (crc32("rPWFzGcZudWZ",12) == 2010390626) strcat(s, "E");
if (crc32("RjHesjIuiEz",11) == 2011435425) strcat(s, "o");
if (crc32("MIgxjtEDRDIdbM",14) == 994778894) strcat(s, "p");
if (crc32("bDoBVmgYXrXdZrM",15) == 3362019111) strcat(s, "u");
if (crc32("TwCKArSfmyIgRs",14) == 204019643) strcat(s, "a");
if (crc32("UFbfiDmFgrkGLj",14) == 795892592) strcat(s, "s");
if (crc32("wYTsc",5) == 2160662353) strcat(s, "i");
if (crc32("ARldNU",6) == 2490814436) strcat(s, "D");
if (crc32("hWNfPQyVRBrIE",13) == 15697824) strcat(s, "n");
if (crc32("xkvTLDiBXG",10) == 528756998) strcat(s, "g");
    return s;
}

char *crumpled_verbs() {
    char *s = calloc(9);
    if (crc32("EPxVfMiD",8) == 3559500987) strcat(s, "c");
if (crc32("rbtSwVqmwAEfSNW",15) == 2994521021) strcat(s, "C");
if (crc32("aTxgQsvOf",9) == 1237235607) strcat(s, "r");
if (crc32("tXFdzIKs",8) == 1241096144) strcat(s, "u");
if (crc32("HCfjMWDGjxOeaxz",15) == 1710696862) strcat(s, "m");
if (crc32("XivdxHZM",8) == 3560824197) strcat(s, "p");
if (crc32("DRScngFRKklAZtg",15) == 1559252495) strcat(s, "i");
if (crc32("GxjstOXGjsHOL",13) == 3243699031) strcat(s, "l");
if (crc32("msqssSE",7) == 2249467576) strcat(s, "e");
if (crc32("VuiarQVsDmhxMoA",15) == 1694062585) strcat(s, "d");
    return s;
}

char *extravasated_verbs() {
    char *s = calloc(13);
    if (crc32("OFFbsBWhrehZA",13) == 3517187885) strcat(s, "D");
if (crc32("oJiFQEPMOzy",11) == 848567296) strcat(s, "e");
if (crc32("EBdofuKO",8) == 2460470159) strcat(s, "M");
if (crc32("djwTJLiyBals",12) == 1095956919) strcat(s, "x");
if (crc32("sossfGjvVrg",11) == 106552746) strcat(s, "t");
if (crc32("hWrtAywmBgJRJal",15) == 3611117665) strcat(s, "r");
if (crc32("jKyhLPmtuj",10) == 1474037335) strcat(s, "a");
if (crc32("CVmhyVcotwiytS",14) == 1310093506) strcat(s, "v");
if (crc32("TeqCaXCH",8) == 80483158) strcat(s, "i");
if (crc32("exJCYmOywRiD",12) == 400035385) strcat(s, "a");
if (crc32("wdhlqm",6) == 1979463442) strcat(s, "u");
if (crc32("ZBlLcRRyIv",10) == 3615337059) strcat(s, "s");
if (crc32("qxQhurWQPYATGm",14) == 3432565885) strcat(s, "U");
if (crc32("PxPVdasje",9) == 163142840) strcat(s, "a");
if (crc32("tdEJQ",5) == 513759360) strcat(s, "t");
if (crc32("OQdApUQP",8) == 162768248) strcat(s, "z");
if (crc32("gFzoUexLUgz",11) == 740631431) strcat(s, "e");
if (crc32("YklJcPbEMgp",11) == 3093971261) strcat(s, "d");
    return s;
}

char *interdiffused_verbs() {
    char *s = calloc(14);
    if (crc32("lxKiTuwaHdSgm",13) == 3599592490) strcat(s, "Y");
if (crc32("BQeSR",5) == 3444548471) strcat(s, "i");
if (crc32("aijdK",5) == 3684001853) strcat(s, "p");
if (crc32("XMcrelHxYrP",11) == 1016742454) strcat(s, "n");
if (crc32("FowbwJa",7) == 2326198610) strcat(s, "v");
if (crc32("WgiasS",6) == 1913651540) strcat(s, "t");
if (crc32("fFClsk",6) == 2931996543) strcat(s, "e");
if (crc32("aGYTrwTq",8) == 2028322574) strcat(s, "e");
if (crc32("vhnpR",5) == 2788266650) strcat(s, "r");
if (crc32("Mayfcy",6) == 522242995) strcat(s, "G");
if (crc32("nYTIVHTW",8) == 1875206492) strcat(s, "d");
if (crc32("YJDMvIwN",8) == 1000276888) strcat(s, "i");
if (crc32("Qrwmumr",7) == 4273049816) strcat(s, "I");
if (crc32("jhSevfjRuYrNL",13) == 4185637296) strcat(s, "f");
if (crc32("pHcBw",5) == 670030689) strcat(s, "f");
if (crc32("ojpscFEA",8) == 657361618) strcat(s, "u");
if (crc32("ZVWYUXOqUheCJo",14) == 2972370749) strcat(s, "O");
if (crc32("DMOzSjTAXVm",11) == 2999781221) strcat(s, "s");
if (crc32("emKgUiaF",8) == 948376023) strcat(s, "M");
if (crc32("jlLGFYpe",8) == 899937594) strcat(s, "e");
if (crc32("JhIxXVCaMbTJQLF",15) == 1740743426) strcat(s, "h");
if (crc32("umdWdd",6) == 494329262) strcat(s, "d");
    return s;
}

char *twist_verbs() {
    char *s = calloc(6);
    if (crc32("BQRPKS",6) == 2221475932) strcat(s, "h");
if (crc32("aFFmdMKUVkSf",12) == 3018168857) strcat(s, "t");
if (crc32("wOZPdY",6) == 2792150471) strcat(s, "w");
if (crc32("rLwfIolRqtPNg",13) == 1820362793) strcat(s, "i");
if (crc32("mIkwJmLTItTt",12) == 109475626) strcat(s, "s");
if (crc32("IXTENicegVUCQIN",15) == 1230879698) strcat(s, "t");
if (crc32("QIVIpnkfSNfW",12) == 3518588825) strcat(s, "t");
    return s;
}

char *commiserate_verbs() {
    char *s = calloc(12);
    if (crc32("rLdtJeGcsRYLRY",14) == 3940614238) strcat(s, "p");
if (crc32("awzVtyD",7) == 658148092) strcat(s, "c");
if (crc32("qgrhyLclGjgA",12) == 572534348) strcat(s, "o");
if (crc32("gknIS",5) == 2424782442) strcat(s, "m");
if (crc32("jxNWRgG",7) == 1241399751) strcat(s, "m");
if (crc32("xPfiOSYdJNO",11) == 1337329242) strcat(s, "h");
if (crc32("tBsXRntRzkEzM",13) == 1349477914) strcat(s, "i");
if (crc32("qDiLAlTaJzt",11) == 1635655574) strcat(s, "s");
if (crc32("XaJbkqoYwTmJaIH",15) == 1544890957) strcat(s, "e");
if (crc32("aDrnYTC",7) == 786464399) strcat(s, "r");
if (crc32("JosILi",6) == 1778387197) strcat(s, "a");
if (crc32("UAcZZMFqF",9) == 3053504274) strcat(s, "a");
if (crc32("ODxBQOLONDtVT",13) == 2967031433) strcat(s, "t");
if (crc32("nrLXdFRLWKVdy",13) == 1406260071) strcat(s, "o");
if (crc32("MOompGiTxPK",11) == 4277262756) strcat(s, "e");
    return s;
}

char *Platonize_verbs() {
    char *s = calloc(10);
    if (crc32("oIaxD",5) == 3485497212) strcat(s, "b");
if (crc32("sXsUVMBkceWs",12) == 2388208216) strcat(s, "P");
if (crc32("KDrwoWCcROG",11) == 1367192919) strcat(s, "h");
if (crc32("WVyIsgrfFtqgOs",14) == 4164851603) strcat(s, "l");
if (crc32("FOUmT",5) == 79986371) strcat(s, "a");
if (crc32("edsnzT",6) == 123470606) strcat(s, "t");
if (crc32("cHPEnOWpBMmxaM",14) == 632679121) strcat(s, "o");
if (crc32("dAPMu",5) == 1431685997) strcat(s, "d");
if (crc32("NLYmiTgrzOJoR",13) == 433301064) strcat(s, "n");
if (crc32("ImqXQSgqQBmgj",13) == 2643711382) strcat(s, "g");
if (crc32("FQEGrbReIjj",11) == 2301578087) strcat(s, "i");
if (crc32("fjCPBEsvMJ",10) == 1515374026) strcat(s, "z");
if (crc32("iaYcnjBzGUPS",12) == 2175406077) strcat(s, "N");
if (crc32("LOrOo",5) == 1708103939) strcat(s, "e");
    return s;
}

char *lagged_verbs() {
    char *s = calloc(7);
    if (crc32("gYrsHTenNt",10) == 1678642102) strcat(s, "l");
if (crc32("cIRrgaNRhv",10) == 1989006985) strcat(s, "a");
if (crc32("YKOxsMrFum",10) == 267967673) strcat(s, "P");
if (crc32("MJUERZy",7) == 1291816161) strcat(s, "g");
if (crc32("XXbYFwrh",8) == 2849396508) strcat(s, "y");
if (crc32("WdyTLsqerQRSjHo",15) == 1819992733) strcat(s, "g");
if (crc32("dErESIhB",8) == 1649182485) strcat(s, "e");
if (crc32("CIutez",6) == 3400430779) strcat(s, "d");
    return s;
}

char *overspilling_verbs() {
    char *s = calloc(13);
    if (crc32("HqfUwMzJABFMF",13) == 1934956985) strcat(s, "o");
if (crc32("cyPWQnuE",8) == 2702000292) strcat(s, "o");
if (crc32("BKpLtavXUwdvTrN",15) == 1073683901) strcat(s, "v");
if (crc32("WJeGGFta",8) == 1801611771) strcat(s, "v");
if (crc32("vImFTeBmkHcS",12) == 2449089257) strcat(s, "e");
if (crc32("JTPDUtzA",8) == 3493389808) strcat(s, "r");
if (crc32("tdnPVoHxLUcvU",13) == 887637602) strcat(s, "s");
if (crc32("YjMGjHeJrP",10) == 4222596443) strcat(s, "O");
if (crc32("XeptwRmrc",9) == 1746423536) strcat(s, "p");
if (crc32("UPfytBXFHuQxn",13) == 1390177705) strcat(s, "p");
if (crc32("CjqgeKVTQGepjd",14) == 2446338744) strcat(s, "i");
if (crc32("dtNhwv",6) == 154544858) strcat(s, "b");
if (crc32("ZJAvAQcSEtzMJW",14) == 2526179801) strcat(s, "l");
if (crc32("WMDTZi",6) == 198385712) strcat(s, "l");
if (crc32("XsHpzJOmikys",12) == 750160053) strcat(s, "i");
if (crc32("CbrEthwQkgMJ",12) == 2740973040) strcat(s, "n");
if (crc32("bUcEyOGopwNoy",13) == 2147029687) strcat(s, "j");
if (crc32("LEZrBDKz",8) == 3338105197) strcat(s, "g");
    return s;
}

char *merged_verbs() {
    char *s = calloc(7);
    if (crc32("JSAuMMmbKsouWto",15) == 3343997469) strcat(s, "m");
if (crc32("TLMjlaeFJOLwxPl",15) == 3431990218) strcat(s, "e");
if (crc32("RDHcxzX",7) == 1235715620) strcat(s, "F");
if (crc32("sFvbFlGPJOA",11) == 4237345059) strcat(s, "r");
if (crc32("YmKSUY",6) == 1459466059) strcat(s, "e");
if (crc32("bYofwLWLFsYPll",14) == 273498070) strcat(s, "g");
if (crc32("hnYjp",5) == 417574031) strcat(s, "e");
if (crc32("hRRlQOV",7) == 3485942684) strcat(s, "d");
    return s;
}

char *discontinue_verbs() {
    char *s = calloc(12);
    if (crc32("qXwbjNGuMlGel",13) == 2277223867) strcat(s, "d");
if (crc32("kLZgHrg",7) == 138618449) strcat(s, "i");
if (crc32("YtMqZgqoxOZUy",13) == 54214773) strcat(s, "f");
if (crc32("jHjbguec",8) == 562731540) strcat(s, "s");
if (crc32("zYBiPPLk",8) == 424729029) strcat(s, "c");
if (crc32("bpwIdNkuFytlc",13) == 2423181657) strcat(s, "o");
if (crc32("AICUCfjrM",9) == 3612779559) strcat(s, "z");
if (crc32("WbODCWIh",8) == 4145409162) strcat(s, "n");
if (crc32("dKjSglIDZA",10) == 2425909217) strcat(s, "G");
if (crc32("evhPwbTvjDL",11) == 1120252352) strcat(s, "t");
if (crc32("cGPwKcOJKm",10) == 965894554) strcat(s, "O");
if (crc32("EudssWHRainLrTk",15) == 897888070) strcat(s, "i");
if (crc32("sZSLX",5) == 2338769890) strcat(s, "n");
if (crc32("iqApSufTkzSus",13) == 398127641) strcat(s, "u");
if (crc32("QnPPEkomDoy",11) == 552387730) strcat(s, "e");
    return s;
}

char *opacified_verbs() {
    char *s = calloc(10);
    if (crc32("QOcrDOwYkWLR",12) == 1359642329) strcat(s, "z");
if (crc32("FGimppyVGfag",12) == 3855208328) strcat(s, "o");
if (crc32("lMFUJTjJIGN",11) == 1514366213) strcat(s, "X");
if (crc32("KiMTgyDdpUroIR",14) == 1347477079) strcat(s, "p");
if (crc32("IiskfRzAJLpn",12) == 1530279417) strcat(s, "a");
if (crc32("VjEIGrWGro",10) == 2849439053) strcat(s, "K");
if (crc32("ywnZCXriAmRK",12) == 1387912860) strcat(s, "c");
if (crc32("cKygrblIFElDED",14) == 3659638327) strcat(s, "t");
if (crc32("CcgOtGG",7) == 2331173669) strcat(s, "i");
if (crc32("aBFsl",5) == 1909594077) strcat(s, "Z");
if (crc32("GnvUEJOfW",9) == 2478053719) strcat(s, "f");
if (crc32("EdoYsUbqVJT",11) == 3324969195) strcat(s, "h");
if (crc32("PgKjmIz",7) == 26493705) strcat(s, "i");
if (crc32("TiGyAoZRYKO",11) == 419747956) strcat(s, "e");
if (crc32("odjGTQpmLEAY",12) == 3743462499) strcat(s, "d");
    return s;
}

char *clung_verbs() {
    char *s = calloc(6);
    if (crc32("AJNYi",5) == 1913364886) strcat(s, "c");
if (crc32("YBukpFADvRBxhmC",15) == 2436700108) strcat(s, "n");
if (crc32("hhQFQTFsBbUhW",13) == 3223734883) strcat(s, "l");
if (crc32("cEzUgFjQB",9) == 1476158975) strcat(s, "V");
if (crc32("tZOTWtPcBkXk",12) == 3468846437) strcat(s, "u");
if (crc32("aptZgqaZiZnwz",13) == 957331610) strcat(s, "Z");
if (crc32("TipLruWLwWk",11) == 89030719) strcat(s, "n");
if (crc32("uukpNcbqfXtXvU",14) == 2958711843) strcat(s, "g");
    return s;
}

char *accelerate_verbs() {
    char *s = calloc(11);
    if (crc32("TDOmCaefMCRVZry",15) == 2531598305) strcat(s, "s");
if (crc32("tyjmyaNj",8) == 1622863607) strcat(s, "a");
if (crc32("LKDVt",5) == 3152735574) strcat(s, "v");
if (crc32("qiyKyYUB",8) == 851181956) strcat(s, "c");
if (crc32("BptglXYgftxgu",13) == 2550218299) strcat(s, "V");
if (crc32("ZbtpcqWopGMQUU",14) == 1433337871) strcat(s, "c");
if (crc32("vDxbJr",6) == 21291703) strcat(s, "f");
if (crc32("aCGFyWHFgYq",11) == 1697981151) strcat(s, "e");
if (crc32("KPNhlLQb",8) == 2793205643) strcat(s, "l");
if (crc32("SlYVbLJ",7) == 2861869432) strcat(s, "e");
if (crc32("kFZtsWQecDOx",12) == 973335693) strcat(s, "r");
if (crc32("eQHouKFxJojJLPp",15) == 1280529776) strcat(s, "F");
if (crc32("pDpwLJEAB",9) == 796519164) strcat(s, "a");
if (crc32("kBEDnLhSr",9) == 3420028780) strcat(s, "j");
if (crc32("RWUWnSXBH",9) == 2725612435) strcat(s, "t");
if (crc32("IylLRRhzBFU",11) == 2655757446) strcat(s, "e");
    return s;
}

char *ingenerating_verbs() {
    char *s = calloc(13);
    if (crc32("WxKVxoSzyKN",11) == 2496635930) strcat(s, "i");
if (crc32("oNnFRzV",7) == 3057216576) strcat(s, "w");
if (crc32("DSEeZJVAjsX",11) == 3393464728) strcat(s, "n");
if (crc32("XIwsFZALXtSZi",13) == 1042692167) strcat(s, "g");
if (crc32("rqxzDhiYqEa",11) == 920992077) strcat(s, "e");
if (crc32("qZHaNlXZ",8) == 4089089669) strcat(s, "R");
if (crc32("rnFRSvwYY",9) == 2184683272) strcat(s, "n");
if (crc32("lzbMzn",6) == 3944835796) strcat(s, "e");
if (crc32("gDnhpIpvj",9) == 2126647265) strcat(s, "O");
if (crc32("UOYmJmHdqOTSI",13) == 1761164410) strcat(s, "r");
if (crc32("cFOmtsrTUEOPKB",14) == 862600314) strcat(s, "q");
if (crc32("jPDCxTJgCoeSVtf",15) == 154434442) strcat(s, "a");
if (crc32("nNtxsvg",7) == 1842370436) strcat(s, "n");
if (crc32("MWBaDKIZIwzQGCU",15) == 3376225446) strcat(s, "t");
if (crc32("HevFszmQfp",10) == 3434308312) strcat(s, "i");
if (crc32("YjOKk",5) == 361867555) strcat(s, "n");
if (crc32("NxHPudoqDNvOB",13) == 2233741009) strcat(s, "g");
    return s;
}

char *bestrew_verbs() {
    char *s = calloc(8);
    if (crc32("OpLwgfyx",8) == 1534546) strcat(s, "b");
if (crc32("JsyFCNFFUpPVy",13) == 3659743848) strcat(s, "e");
if (crc32("cEdghRihFjDBm",13) == 3363649207) strcat(s, "s");
if (crc32("dvdGdULuKn",10) == 886770125) strcat(s, "t");
if (crc32("ERMWgIzhnN",10) == 1913381543) strcat(s, "P");
if (crc32("iiJfMx",6) == 2850106752) strcat(s, "r");
if (crc32("kvvWdlmOQbOq",12) == 4162667409) strcat(s, "H");
if (crc32("ytAfdEvQvtw",11) == 1042711566) strcat(s, "e");
if (crc32("hGigDCZW",8) == 3668794944) strcat(s, "E");
if (crc32("wNfMmvy",7) == 3998095185) strcat(s, "w");
    return s;
}

char *foreclosed_verbs() {
    char *s = calloc(11);
    if (crc32("ggtEpfQEKI",10) == 1237462871) strcat(s, "V");
if (crc32("YBxqpglrhkEAQRK",15) == 618724864) strcat(s, "f");
if (crc32("YekyFtsP",8) == 3804927309) strcat(s, "o");
if (crc32("jkyhdXDZzF",10) == 1410052892) strcat(s, "r");
if (crc32("rTTduc",6) == 2039227308) strcat(s, "o");
if (crc32("CnYxOWvTARl",11) == 1722008286) strcat(s, "e");
if (crc32("DHfKokjvXhOvRN",14) == 1080219425) strcat(s, "F");
if (crc32("VDPIXaWbqxJLcL",14) == 4117104567) strcat(s, "c");
if (crc32("qCXOzTSBTOl",11) == 3106459258) strcat(s, "N");
if (crc32("TfgoGMyfChnPqg",14) == 2753004244) strcat(s, "l");
if (crc32("LMFHUuNpQLo",11) == 3240112528) strcat(s, "o");
if (crc32("sNBOiXaKgJMQEAn",15) == 2690554687) strcat(s, "l");
if (crc32("oARXoSEX",8) == 582036351) strcat(s, "s");
if (crc32("OJSeOudtfsRnnHF",15) == 3145131860) strcat(s, "e");
if (crc32("mPQgrOgoL",9) == 513933512) strcat(s, "d");
    return s;
}

char *smiling_verbs() {
    char *s = calloc(8);
    if (crc32("fVpXlcN",7) == 3417261740) strcat(s, "g");
if (crc32("fSpGWyPjx",9) == 3717749252) strcat(s, "s");
if (crc32("jnqRVnGij",9) == 3780880072) strcat(s, "m");
if (crc32("kOpJvMBJVCw",11) == 2833056965) strcat(s, "i");
if (crc32("IAoIu",5) == 3931127999) strcat(s, "U");
if (crc32("RvJaVMqZDHn",11) == 2433173154) strcat(s, "l");
if (crc32("xOSSJmMDbtgHhXo",15) == 4074820093) strcat(s, "e");
if (crc32("tSLZwvr",7) == 2687679268) strcat(s, "i");
if (crc32("nmnhA",5) == 3195577114) strcat(s, "A");
if (crc32("CAWXoIaXGy",10) == 3416450589) strcat(s, "n");
if (crc32("oKjmrBfaLvlG",12) == 1489181199) strcat(s, "g");
    return s;
}

char *bidden_verbs() {
    char *s = calloc(7);
    if (crc32("qPmHPCzj",8) == 998411741) strcat(s, "b");
if (crc32("NfeUatP",7) == 2480502433) strcat(s, "i");
if (crc32("oORtFNblzbAmzS",14) == 1506161106) strcat(s, "d");
if (crc32("AkqIcu",6) == 1498673751) strcat(s, "d");
if (crc32("FGiVQ",5) == 2698596719) strcat(s, "e");
if (crc32("XBiPmypjvoPDJPj",15) == 3038696095) strcat(s, "y");
if (crc32("GkCWMrkq",8) == 1395959939) strcat(s, "n");
    return s;
}

char *baled_verbs() {
    char *s = calloc(6);
    if (crc32("CQczjxzZp",9) == 3158535696) strcat(s, "b");
if (crc32("UchYM",5) == 4015171693) strcat(s, "Y");
if (crc32("HyuxUHsDCDrYhm",14) == 3592261405) strcat(s, "a");
if (crc32("BfqtpPsGbPp",11) == 253901928) strcat(s, "l");
if (crc32("zqXOxgBHiJfZWf",14) == 594784625) strcat(s, "e");
if (crc32("gQSpYnwZCLr",11) == 263076754) strcat(s, "K");
if (crc32("SkRayavqY",9) == 1409439308) strcat(s, "d");
    return s;
}

char *traced_verbs() {
    char *s = calloc(7);
    if (crc32("eCvVrBsJ",8) == 3423064964) strcat(s, "d");
if (crc32("qhUdGNFQSCiHteF",15) == 649832398) strcat(s, "t");
if (crc32("ZJEbqFmhA",9) == 1079820809) strcat(s, "j");
if (crc32("bZaerJeAR",9) == 1881327515) strcat(s, "r");
if (crc32("pFqSt",5) == 3708335235) strcat(s, "X");
if (crc32("SnhOr",5) == 3980794740) strcat(s, "a");
if (crc32("bQaUiWZGSvstH",13) == 1723699983) strcat(s, "c");
if (crc32("GQjnkgwZpUla",12) == 1208321308) strcat(s, "A");
if (crc32("WxSwyegP",8) == 1028831029) strcat(s, "e");
if (crc32("tgkfmi",6) == 1976926673) strcat(s, "R");
if (crc32("iwZmeudoOY",10) == 2410646654) strcat(s, "d");
    return s;
}

char *sulfuretted_verbs() {
    char *s = calloc(12);
    if (crc32("uYVbefbPUCSP",12) == 2078321143) strcat(s, "s");
if (crc32("wdScoRG",7) == 1994237565) strcat(s, "T");
if (crc32("YiBvGizcV",9) == 3237007212) strcat(s, "u");
if (crc32("cQltxOQyIUSA",12) == 427646576) strcat(s, "l");
if (crc32("DKzZCsS",7) == 3790603528) strcat(s, "c");
if (crc32("BPGGKYJHUCT",11) == 962010950) strcat(s, "f");
if (crc32("LQvgzKbYAJFFRzO",15) == 2510141423) strcat(s, "C");
if (crc32("TksevEyhvJStr",13) == 2843989889) strcat(s, "u");
if (crc32("wsquhPnDEaeih",13) == 3319345302) strcat(s, "I");
if (crc32("SQjUHMtBZdnc",12) == 3733958425) strcat(s, "r");
if (crc32("zmABrkf",7) == 1077766127) strcat(s, "e");
if (crc32("ihZSWFGC",8) == 2992240496) strcat(s, "t");
if (crc32("FUICb",5) == 3537098908) strcat(s, "i");
if (crc32("FpftFNQTDfH",11) == 3421959634) strcat(s, "t");
if (crc32("wxXhiL",6) == 3983497044) strcat(s, "e");
if (crc32("TPwXbTHWO",9) == 2668520479) strcat(s, "d");
    return s;
}

char *preachify_verbs() {
    char *s = calloc(10);
    if (crc32("AxCLQegHJFh",11) == 815592533) strcat(s, "p");
if (crc32("TcpPSjca",8) == 3585880375) strcat(s, "r");
if (crc32("KAqqZVBy",8) == 3497144799) strcat(s, "e");
if (crc32("yvULqRNJcPUu",12) == 3793174590) strcat(s, "a");
if (crc32("SRvUTBqymyvMgIT",15) == 454329395) strcat(s, "t");
if (crc32("bjnwAa",6) == 2129441137) strcat(s, "c");
if (crc32("feWEYnpZqYT",11) == 419135045) strcat(s, "h");
if (crc32("AMmdZghVoEWQRn",14) == 82960645) strcat(s, "i");
if (crc32("RSJGoyGKZjXIAK",14) == 2550697362) strcat(s, "f");
if (crc32("qFzCfw",6) == 810395657) strcat(s, "j");
if (crc32("pyeYFmfEyQwxfd",14) == 2007291006) strcat(s, "y");
    return s;
}

char *piqued_verbs() {
    char *s = calloc(7);
    if (crc32("rpsDs",5) == 631347360) strcat(s, "p");
if (crc32("pCVhAOYCLb",10) == 1530980665) strcat(s, "U");
if (crc32("PHZpxmjrYzH",11) == 1654372662) strcat(s, "i");
if (crc32("ouWxW",5) == 4206577843) strcat(s, "q");
if (crc32("wUtagjxyq",9) == 1209428240) strcat(s, "u");
if (crc32("whXVVq",6) == 3560663212) strcat(s, "j");
if (crc32("uZrGtvJigJRRPLW",15) == 3198807516) strcat(s, "e");
if (crc32("eLnAczyoIQLdKRS",15) == 3594908302) strcat(s, "d");
    return s;
}

char *mispracticing_verbs() {
    char *s = calloc(14);
    if (crc32("iAEiREV",7) == 861091746) strcat(s, "s");
if (crc32("oKKFEVNwTrnIWy",14) == 774220570) strcat(s, "m");
if (crc32("kWnRZjsND",9) == 2463604298) strcat(s, "i");
if (crc32("RJsNZKEGOgkiySO",15) == 763933688) strcat(s, "s");
if (crc32("VkWwQ",5) == 2293697298) strcat(s, "s");
if (crc32("cHeNMAvH",8) == 3927722795) strcat(s, "p");
if (crc32("bfgglpYoeBS",11) == 4237762396) strcat(s, "k");
if (crc32("cjJUjc",6) == 962024566) strcat(s, "r");
if (crc32("xUSQnOjROaHvQ",13) == 3035930256) strcat(s, "a");
if (crc32("KenMrg",6) == 3907768861) strcat(s, "c");
if (crc32("oJHWv",5) == 469527610) strcat(s, "t");
if (crc32("eVTzbwcQ",8) == 192677871) strcat(s, "i");
if (crc32("uSruMlsFxo",10) == 2188074942) strcat(s, "N");
if (crc32("zsrMvX",6) == 11035689) strcat(s, "c");
if (crc32("mfvry",5) == 2105196267) strcat(s, "R");
if (crc32("fLNiHpWguut",11) == 2307526959) strcat(s, "i");
if (crc32("ixsKQRUbBOuVuhP",15) == 474070815) strcat(s, "I");
if (crc32("zCyVJVzJ",8) == 1768851486) strcat(s, "n");
if (crc32("hqBeHNvlsYkGt",13) == 3818540856) strcat(s, "W");
if (crc32("SaCIK",5) == 2288160173) strcat(s, "g");
    return s;
}

char *wive_verbs() {
    char *s = calloc(5);
    if (crc32("WxbiG",5) == 2717752630) strcat(s, "f");
if (crc32("HKeSPhgNaNubDUe",15) == 260790530) strcat(s, "w");
if (crc32("cnDRCpE",7) == 1549658157) strcat(s, "A");
if (crc32("XFHkJzNBwHwnWF",14) == 1053632269) strcat(s, "i");
if (crc32("fGQaBPouMvH",11) == 928108938) strcat(s, "v");
if (crc32("XBJktKsCQnbX",12) == 1733853106) strcat(s, "e");
    return s;
}

char *preage_verbs() {
    char *s = calloc(7);
    if (crc32("XzPWAMocDvnGdJc",15) == 2462287843) strcat(s, "p");
if (crc32("jMUJJPot",8) == 485178310) strcat(s, "o");
if (crc32("mToOkftX",8) == 1422489364) strcat(s, "r");
if (crc32("xJQzfqFn",8) == 3372962339) strcat(s, "e");
if (crc32("MeExzpsX",8) == 2849144989) strcat(s, "a");
if (crc32("iHmWH",5) == 3243428017) strcat(s, "g");
if (crc32("Tmmxxb",6) == 2425076994) strcat(s, "e");
    return s;
}

char *desulphurize_verbs() {
    char *s = calloc(13);
    if (crc32("FFUoQVCLMBIiR",13) == 4033129615) strcat(s, "a");
if (crc32("jdhOfWK",7) == 324276583) strcat(s, "d");
if (crc32("SDXjPqzQW",9) == 1561158416) strcat(s, "e");
if (crc32("BUGazmLXNFtPhu",14) == 1970037052) strcat(s, "s");
if (crc32("eVmokTgUQqw",11) == 113068001) strcat(s, "u");
if (crc32("bPgmQ",5) == 1870296511) strcat(s, "l");
if (crc32("RGqEmUnHoAK",11) == 887962392) strcat(s, "u");
if (crc32("wzUFSpl",7) == 1431805002) strcat(s, "p");
if (crc32("DxyCrO",6) == 1932056877) strcat(s, "h");
if (crc32("kHSlGZikSVAc",12) == 2327466995) strcat(s, "v");
if (crc32("MkwaCFyjAKKkYB",14) == 1535994080) strcat(s, "u");
if (crc32("orcZzowg",8) == 528273869) strcat(s, "r");
if (crc32("aDWYvhvgOsCIoGO",15) == 1275715475) strcat(s, "X");
if (crc32("TsljQeolk",9) == 1463380262) strcat(s, "i");
if (crc32("ehlblvStsWVD",12) == 2615198585) strcat(s, "z");
if (crc32("QygUHoMhQvwaW",13) == 4072614066) strcat(s, "O");
if (crc32("Rduccb",6) == 1730855957) strcat(s, "e");
    return s;
}

char *elongating_verbs() {
    char *s = calloc(11);
    if (crc32("pVqpqVB",7) == 2896907608) strcat(s, "o");
if (crc32("wjSlTbk",7) == 4119975902) strcat(s, "e");
if (crc32("fOTfPaxcbmrPOrT",15) == 393709600) strcat(s, "l");
if (crc32("pPmbUZqJlsm",11) == 2305572177) strcat(s, "o");
if (crc32("sNIPgIVoBA",10) == 3553114929) strcat(s, "n");
if (crc32("mvBSrOPLRLqZGo",14) == 3830126398) strcat(s, "g");
if (crc32("edAqGOBHYixLO",13) == 3678583552) strcat(s, "q");
if (crc32("NndnuO",6) == 3769914463) strcat(s, "a");
if (crc32("sVFHCkF",7) == 2017609289) strcat(s, "t");
if (crc32("ibygVQkudn",10) == 3302745098) strcat(s, "K");
if (crc32("xGHFCqofOG",10) == 2625387596) strcat(s, "i");
if (crc32("XREEVXLUFbiGD",13) == 3292624647) strcat(s, "n");
if (crc32("pHVJxrftvpAZC",13) == 2853573135) strcat(s, "U");
if (crc32("NZlii",5) == 1154336165) strcat(s, "g");
    return s;
}

char *nodded_verbs() {
    char *s = calloc(7);
    if (crc32("SVpHonWPmoqFS",13) == 3442697084) strcat(s, "R");
if (crc32("SUwZxtZU",8) == 230973205) strcat(s, "n");
if (crc32("xVQmMVpRPh",10) == 2381415998) strcat(s, "o");
if (crc32("LrHcjOOjS",9) == 3079779964) strcat(s, "b");
if (crc32("MhxYyVcOZvmBUjS",15) == 3067590643) strcat(s, "d");
if (crc32("QBQfpoxsah",10) == 3810600109) strcat(s, "d");
if (crc32("dqeKnv",6) == 3560624800) strcat(s, "e");
if (crc32("oqgnS",5) == 1246186426) strcat(s, "d");
    return s;
}

char *fight_verbs() {
    char *s = calloc(6);
    if (crc32("WJlYIzHEunuryU",14) == 1122506130) strcat(s, "f");
if (crc32("OuJwPWNZQroV",12) == 3057791895) strcat(s, "n");
if (crc32("pqoYZPZdiIFrQWk",15) == 3699253863) strcat(s, "i");
if (crc32("RMyZbUIsaaCyxvC",15) == 3231118758) strcat(s, "g");
if (crc32("MbYXvJDFX",9) == 577406534) strcat(s, "k");
if (crc32("HYqmGhgX",8) == 2277513591) strcat(s, "h");
if (crc32("iSswJewiqXTZda",14) == 840372936) strcat(s, "t");
    return s;
}

char *realize_verbs() {
    char *s = calloc(8);
    if (crc32("wEJtgGSb",8) == 2518362151) strcat(s, "r");
if (crc32("CIQSoLHAQQ",10) == 2601710446) strcat(s, "e");
if (crc32("DDhSSbzvTtckndG",15) == 894712254) strcat(s, "a");
if (crc32("TSLenbdk",8) == 3294653016) strcat(s, "l");
if (crc32("fgpXgxxzEXcdY",13) == 4231052872) strcat(s, "g");
if (crc32("DBSIhqoLGK",10) == 3932403393) strcat(s, "i");
if (crc32("IUJmdXsVwrUyF",13) == 2637795360) strcat(s, "l");
if (crc32("cyWnEf",6) == 4130140405) strcat(s, "z");
if (crc32("TBpIADkXMXiYhRB",15) == 1839710544) strcat(s, "b");
if (crc32("REqGtKlpRTPHh",13) == 49148937) strcat(s, "e");
    return s;
}

char *osmosing_verbs() {
    char *s = calloc(9);
    if (crc32("EOnUkDvyfeBCiUw",15) == 1690367201) strcat(s, "S");
if (crc32("RwIFhyQONHyD",12) == 1579851031) strcat(s, "o");
if (crc32("vhQtQjV",7) == 1731810691) strcat(s, "s");
if (crc32("QRQVIFgihwU",11) == 3139773587) strcat(s, "h");
if (crc32("ybKZhYYXEkAjm",13) == 4145838584) strcat(s, "m");
if (crc32("avuvLtf",7) == 2226317879) strcat(s, "o");
if (crc32("LREBA",5) == 2276336215) strcat(s, "Q");
if (crc32("dFmaXqx",7) == 3556357074) strcat(s, "s");
if (crc32("bCsslKgeEOSTD",13) == 1862708163) strcat(s, "o");
if (crc32("CzVViddTl",9) == 1396650724) strcat(s, "i");
if (crc32("Plibh",5) == 3697631373) strcat(s, "n");
if (crc32("ufJbgeDut",9) == 3131510408) strcat(s, "g");
    return s;
}

char *squirt_verbs() {
    char *s = calloc(7);
    if (crc32("hAXZvQj",7) == 875913438) strcat(s, "O");
if (crc32("rdJfWpZzHC",10) == 2188920166) strcat(s, "s");
if (crc32("PtqvqaC",7) == 3692050006) strcat(s, "Z");
if (crc32("FtDcyTDc",8) == 3850401349) strcat(s, "q");
if (crc32("UwsGGPGNPx",10) == 1409843828) strcat(s, "N");
if (crc32("QXRJlhTfRR",10) == 1476881190) strcat(s, "u");
if (crc32("SXUGRjwmAoxU",12) == 1910640640) strcat(s, "e");
if (crc32("dFSFTZ",6) == 231878786) strcat(s, "i");
if (crc32("GJLqDqQora",10) == 3680646742) strcat(s, "w");
if (crc32("JSTSjq",6) == 4063754025) strcat(s, "r");
if (crc32("fUjrMQh",7) == 2742461426) strcat(s, "t");
    return s;
}

char *overcloud_verbs() {
    char *s = calloc(10);
    if (crc32("iJQJjOcBGrT",11) == 1699144273) strcat(s, "Q");
if (crc32("ehSiJw",6) == 451940405) strcat(s, "o");
if (crc32("MXvnLXhrICkLSyo",15) == 2066545817) strcat(s, "v");
if (crc32("JvTrpe",6) == 1752061228) strcat(s, "e");
if (crc32("IOzKKp",6) == 1297006736) strcat(s, "O");
if (crc32("wpuqOI",6) == 788825122) strcat(s, "r");
if (crc32("RZTUhDXOSqisBQS",15) == 4009510541) strcat(s, "x");
if (crc32("FeFqKSLS",8) == 3266058461) strcat(s, "c");
if (crc32("ToJHJddUTNnu",12) == 706654997) strcat(s, "l");
if (crc32("zAoqH",5) == 698100678) strcat(s, "l");
if (crc32("qrJNkK",6) == 453312143) strcat(s, "o");
if (crc32("auAlrTGVyrWJt",13) == 477082376) strcat(s, "v");
if (crc32("AMmsT",5) == 3805602223) strcat(s, "u");
if (crc32("DYjEvhuYPYrS",12) == 3791835466) strcat(s, "d");
    return s;
}

char *staying_verbs() {
    char *s = calloc(8);
    if (crc32("zPVUFukcezX",11) == 3249733237) strcat(s, "n");
if (crc32("cydNjnPMDqmF",12) == 1473006584) strcat(s, "s");
if (crc32("VQtWxVfsfrd",11) == 2172007431) strcat(s, "G");
if (crc32("NcVQGnUJiZHHpu",14) == 3851278403) strcat(s, "t");
if (crc32("JfBqIFGsvPYBy",13) == 3148740871) strcat(s, "m");
if (crc32("zPdbyB",6) == 3125861846) strcat(s, "a");
if (crc32("wXobl",5) == 3542959300) strcat(s, "y");
if (crc32("qpjJAMMedJoONcy",15) == 3012946562) strcat(s, "i");
if (crc32("ySBtdjZpxx",10) == 2834980459) strcat(s, "C");
if (crc32("mJddDssWfvSNex",14) == 1897022775) strcat(s, "n");
if (crc32("lOTTfOUEFvgNE",13) == 3973949450) strcat(s, "g");
    return s;
}

char *overcame_verbs() {
    char *s = calloc(9);
    if (crc32("TjJfp",5) == 1099250810) strcat(s, "o");
if (crc32("HabUtFuqE",9) == 2204240583) strcat(s, "Z");
if (crc32("wpLEYUIppZXSq",13) == 3634885310) strcat(s, "v");
if (crc32("IGhFC",5) == 2586890128) strcat(s, "e");
if (crc32("cAkyoWhvmkBqem",14) == 634497878) strcat(s, "o");
if (crc32("yAKDfdQSvJSRe",13) == 3592399851) strcat(s, "r");
if (crc32("JdsUjzLSsHRMGo",14) == 2269327147) strcat(s, "c");
if (crc32("ZsmwXB",6) == 3504846534) strcat(s, "a");
if (crc32("ImTsMxm",7) == 1334449195) strcat(s, "c");
if (crc32("spQmMqdMekTbQo",14) == 4218744877) strcat(s, "m");
if (crc32("EjeDBFffM",9) == 2512162811) strcat(s, "e");
    return s;
}

char *premeditate_verbs() {
    char *s = calloc(12);
    if (crc32("iXZbAJ",6) == 114449785) strcat(s, "p");
if (crc32("tsNeADRLCsW",11) == 228179418) strcat(s, "U");
if (crc32("cAVWZdsVn",9) == 3789904068) strcat(s, "r");
if (crc32("DAOKrMoaYPtR",12) == 4007055020) strcat(s, "e");
if (crc32("XBNlJ",5) == 3659124558) strcat(s, "m");
if (crc32("qxOttLrsqka",11) == 3945711928) strcat(s, "e");
if (crc32("ZkZsaAMKnFA",11) == 3070406314) strcat(s, "G");
if (crc32("nieblZOEqJcb",12) == 4184485024) strcat(s, "d");
if (crc32("WFITuZ",6) == 2117321694) strcat(s, "P");
if (crc32("BcaItodm",8) == 3083576022) strcat(s, "i");
if (crc32("PKRoQRegCVNt",12) == 216712733) strcat(s, "S");
if (crc32("rqXqhmxLwB",10) == 2425410616) strcat(s, "t");
if (crc32("NNRtxuYp",8) == 177160945) strcat(s, "D");
if (crc32("coYWX",5) == 2295470783) strcat(s, "a");
if (crc32("wwbMJItpqfJuKD",14) == 339480790) strcat(s, "O");
if (crc32("mVaAYhjoMsTcSw",14) == 621806137) strcat(s, "t");
if (crc32("kzBipkAscPCeDMs",15) == 2034997483) strcat(s, "e");
    return s;
}

char *nurturing_verbs() {
    char *s = calloc(10);
    if (crc32("QIjCcyrwaeruX",13) == 3260165422) strcat(s, "n");
if (crc32("ovNUYzK",7) == 2890502904) strcat(s, "B");
if (crc32("vSZCDvGtbGILFWq",15) == 4288837712) strcat(s, "u");
if (crc32("mLhpuuEwyc",10) == 2914823114) strcat(s, "r");
if (crc32("YRXfXjtqxSLvW",13) == 1475862776) strcat(s, "L");
if (crc32("oaBuJxlBZzXdzw",14) == 1495815088) strcat(s, "t");
if (crc32("yFGxXwjN",8) == 2070426217) strcat(s, "u");
if (crc32("yowmWjskdSz",11) == 1660452160) strcat(s, "r");
if (crc32("hUqgYwXsSa",10) == 2764701779) strcat(s, "i");
if (crc32("GHxxCvRSNVHpq",13) == 2857387629) strcat(s, "M");
if (crc32("aZSZCTPznGHm",12) == 2374479525) strcat(s, "n");
if (crc32("KzbPyFbUZQNEG",13) == 3352928982) strcat(s, "g");
    return s;
}

char *interspacing_verbs() {
    char *s = calloc(13);
    if (crc32("RJUKHdfJFaDTkLT",15) == 1838341628) strcat(s, "i");
if (crc32("YWTABNcwUx",10) == 1832896181) strcat(s, "K");
if (crc32("GWnMVVUhD",9) == 2223066333) strcat(s, "n");
if (crc32("rSsFXNxkYJ",10) == 1334450371) strcat(s, "t");
if (crc32("ZCqLvHtV",8) == 1893490596) strcat(s, "e");
if (crc32("OkfCOSlYkUZ",11) == 3154374888) strcat(s, "Z");
if (crc32("oyXKbqPcN",9) == 537924744) strcat(s, "r");
if (crc32("FuqUqoA",7) == 1854792829) strcat(s, "L");
if (crc32("sqhDv",5) == 3227807339) strcat(s, "s");
if (crc32("sZcuXrFvYFrHJ",13) == 2830105274) strcat(s, "p");
if (crc32("IhtKgLfcvfmibG",14) == 3858113133) strcat(s, "a");
if (crc32("UldJlup",7) == 1210872144) strcat(s, "c");
if (crc32("EHTrWG",6) == 2290881183) strcat(s, "i");
if (crc32("oUqFOOrwUvtuRQx",15) == 1649464276) strcat(s, "t");
if (crc32("cXuJexNjyFrunz",14) == 3067609196) strcat(s, "n");
if (crc32("VLyuzFcOeX",10) == 3071799236) strcat(s, "d");
if (crc32("nqPXDS",6) == 2287729683) strcat(s, "g");
    return s;
}

char *hypothesized_verbs() {
    char *s = calloc(13);
    if (crc32("oJovpjn",7) == 4162715697) strcat(s, "N");
if (crc32("omOxzAdRzOgZz",13) == 1126696484) strcat(s, "h");
if (crc32("RsyLsCITU",9) == 341201514) strcat(s, "y");
if (crc32("oOKNSjqAk",9) == 1737405001) strcat(s, "Y");
if (crc32("xBTStfFINI",10) == 321810342) strcat(s, "p");
if (crc32("rHgpDvTu",8) == 2854382556) strcat(s, "o");
if (crc32("GbBpjUB",7) == 179197494) strcat(s, "t");
if (crc32("SrQTyywBRouBHKk",15) == 3632851362) strcat(s, "n");
if (crc32("JrxuuN",6) == 2744056042) strcat(s, "h");
if (crc32("gBmNVUnWENY",11) == 2141072616) strcat(s, "e");
if (crc32("LVUWkBjDrZ",10) == 1750071402) strcat(s, "s");
if (crc32("eIFCptu",7) == 2815221473) strcat(s, "v");
if (crc32("BSbCzGnkGhSd",12) == 2410807481) strcat(s, "i");
if (crc32("aetJcRvPKwuLY",13) == 2681405178) strcat(s, "z");
if (crc32("rcvbxWcG",8) == 1944636301) strcat(s, "B");
if (crc32("rtcheqMFp",9) == 1116341040) strcat(s, "e");
if (crc32("zauRiyQMNpDEv",13) == 3318986388) strcat(s, "O");
if (crc32("mFWRgjxuErTrwOb",15) == 3177139885) strcat(s, "d");
    return s;
}

char *rouging_verbs() {
    char *s = calloc(8);
    if (crc32("EjqnZ",5) == 660196327) strcat(s, "r");
if (crc32("RtCkzj",6) == 368106186) strcat(s, "t");
if (crc32("HXJFJGpvaEA",11) == 2313267508) strcat(s, "o");
if (crc32("hvruPMHHdo",10) == 1928250306) strcat(s, "q");
if (crc32("hxFoZiVYif",10) == 1545590070) strcat(s, "u");
if (crc32("FnXRlcsC",8) == 452250479) strcat(s, "x");
if (crc32("fjEGDaTYIHk",11) == 932158390) strcat(s, "g");
if (crc32("OoYpViaauH",10) == 131451230) strcat(s, "i");
if (crc32("YiutZomeTGa",11) == 1196024029) strcat(s, "k");
if (crc32("EIwAEelpWc",10) == 2814791666) strcat(s, "n");
if (crc32("MLrMeLf",7) == 947381951) strcat(s, "Z");
if (crc32("KuLPYqTEeLZ",11) == 1829396578) strcat(s, "g");
    return s;
}

char *yacketyyakked_verbs() {
    char *s = calloc(14);
    if (crc32("WjumZtj",7) == 2903571400) strcat(s, "y");
if (crc32("UaywGoB",7) == 3066662286) strcat(s, "q");
if (crc32("zIiQaeszUizqCG",14) == 924478342) strcat(s, "a");
if (crc32("BpFjLuGSj",9) == 3159308978) strcat(s, "c");
if (crc32("sSQFQmMZhBW",11) == 849185678) strcat(s, "c");
if (crc32("HExfDew",7) == 3280609807) strcat(s, "k");
if (crc32("QbvUpRVJTuS",11) == 3163672780) strcat(s, "e");
if (crc32("dbgmDNoFdOTfcfq",15) == 831055883) strcat(s, "t");
if (crc32("QUxBSK",6) == 2562079048) strcat(s, "t");
if (crc32("sokGxDYUtugFpZg",15) == 3056287759) strcat(s, "y");
if (crc32("PHtWtqwwmxApkG",14) == 901996022) strcat(s, "S");
if (crc32("YyMIyIxcMCImzNi",15) == 4260915694) strcat(s, "y");
if (crc32("VItZGVLVyzdDNiI",15) == 1610177541) strcat(s, "y");
if (crc32("ENfQqPpSS",9) == 1494581472) strcat(s, "a");
if (crc32("pljlaeNDHmQIPrJ",15) == 3021833196) strcat(s, "k");
if (crc32("QrIqhDqB",8) == 246984123) strcat(s, "F");
if (crc32("nsjlMnNBlJk",11) == 1788194193) strcat(s, "k");
if (crc32("OtCvF",5) == 1826227714) strcat(s, "e");
if (crc32("TnwamAJwuMct",12) == 1748962346) strcat(s, "d");
    return s;
}

char *redrawing_verbs() {
    char *s = calloc(10);
    if (crc32("oSeIVVmFtL",10) == 633825833) strcat(s, "r");
if (crc32("gBHPtYmHz",9) == 3169914305) strcat(s, "e");
if (crc32("lrNcpyQh",8) == 2726804258) strcat(s, "d");
if (crc32("nKnGnuetCEFp",12) == 479070587) strcat(s, "r");
if (crc32("xTwIKIg",7) == 4139270701) strcat(s, "a");
if (crc32("CaDbfUWWteiX",12) == 3483998207) strcat(s, "w");
if (crc32("gGSmitklRUDEaV",14) == 2970440439) strcat(s, "q");
if (crc32("vEYOkyZgFGxFPz",14) == 2600724491) strcat(s, "i");
if (crc32("llERdqvV",8) == 2838234106) strcat(s, "n");
if (crc32("BBUGlUpOxCD",11) == 2076741838) strcat(s, "S");
if (crc32("cSapABDDC",9) == 644892930) strcat(s, "g");
    return s;
}

char *laminate_verbs() {
    char *s = calloc(9);
    if (crc32("BNOuIUyU",8) == 3947109291) strcat(s, "s");
if (crc32("jWKbrejrRRiiQXs",15) == 1772187787) strcat(s, "l");
if (crc32("CQAueLOv",8) == 3526593946) strcat(s, "u");
if (crc32("HbzNFOUsfOcxIoe",15) == 1798999142) strcat(s, "a");
if (crc32("LuYTiA",6) == 2420007847) strcat(s, "m");
if (crc32("RlRyaglvYMjwhh",14) == 3102329537) strcat(s, "i");
if (crc32("YeuatPawbbWP",12) == 1736731631) strcat(s, "n");
if (crc32("UnkMEEbYTpOxBuT",15) == 937093712) strcat(s, "X");
if (crc32("DHFudpqLQ",9) == 4045754833) strcat(s, "a");
if (crc32("gDTqFUUAwdoF",12) == 1972000242) strcat(s, "t");
if (crc32("JkyJOXeRQ",9) == 4192215682) strcat(s, "e");
    return s;
}

char *connoted_verbs() {
    char *s = calloc(9);
    if (crc32("PSUgOQpE",8) == 3538431385) strcat(s, "c");
if (crc32("nroQyQZN",8) == 1511385670) strcat(s, "C");
if (crc32("ABqtCXNrCeMKLU",14) == 1347235350) strcat(s, "o");
if (crc32("NtzIn",5) == 2522217244) strcat(s, "g");
if (crc32("cWNeufdHrCFmt",13) == 2390975708) strcat(s, "n");
if (crc32("BjwwKgKfM",9) == 2367482214) strcat(s, "u");
if (crc32("aLklyETukhepOHv",15) == 405898792) strcat(s, "n");
if (crc32("bHzjXNlqUSJO",12) == 2898175687) strcat(s, "o");
if (crc32("ERgqJxuYMxxt",12) == 2902467719) strcat(s, "t");
if (crc32("NyoCYux",7) == 1481505694) strcat(s, "e");
if (crc32("SwWmusz",7) == 1022440836) strcat(s, "d");
    return s;
}

char *kittled_verbs() {
    char *s = calloc(8);
    if (crc32("cOCqIZSqmjCIgvJ",15) == 481697214) strcat(s, "k");
if (crc32("bRltPQ",6) == 854730584) strcat(s, "i");
if (crc32("lSsFAXHPoPQnT",13) == 982866541) strcat(s, "t");
if (crc32("OBHgIKDlFrPL",12) == 4088866946) strcat(s, "Z");
if (crc32("DyNSojtIcxDxGqy",15) == 1969769479) strcat(s, "t");
if (crc32("iokSxvIUM",9) == 733316413) strcat(s, "l");
if (crc32("UVfFkkjpjG",10) == 2008114453) strcat(s, "e");
if (crc32("wWFMoqo",7) == 3007814910) strcat(s, "d");
    return s;
}

char *regerminate_verbs() {
    char *s = calloc(12);
    if (crc32("sMbYOSVs",8) == 2591972510) strcat(s, "r");
if (crc32("KyipfnVgf",9) == 686783765) strcat(s, "f");
if (crc32("obpuKXHuTfvQKd",14) == 3733924833) strcat(s, "e");
if (crc32("vawgVQDxmmu",11) == 969275555) strcat(s, "g");
if (crc32("aKjSI",5) == 4122201993) strcat(s, "e");
if (crc32("ivpCbfmZCnZyoBy",15) == 3917120521) strcat(s, "s");
if (crc32("OSuBeEyDqQFFgUD",15) == 3731531590) strcat(s, "r");
if (crc32("UoijdqIoTcC",11) == 2969096486) strcat(s, "m");
if (crc32("jVtHVugWk",9) == 3465633231) strcat(s, "i");
if (crc32("ETDqYoY",7) == 4031482327) strcat(s, "Y");
if (crc32("eyajOSSMzWrIxA",14) == 1207541994) strcat(s, "n");
if (crc32("AlICqTBfDpPOrDm",15) == 125066444) strcat(s, "G");
if (crc32("VtYNGyNTX",9) == 1908670035) strcat(s, "a");
if (crc32("ziTPAGOe",8) == 4124359725) strcat(s, "t");
if (crc32("OjBIZVGFHEU",11) == 2925952047) strcat(s, "L");
if (crc32("clPZQszempzcO",13) == 3942797943) strcat(s, "e");
    return s;
}

char *tauten_verbs() {
    char *s = calloc(7);
    if (crc32("mBykTwuJwu",10) == 2957580951) strcat(s, "t");
if (crc32("ivotc",5) == 283012417) strcat(s, "s");
if (crc32("JnZmnXlagNtHvSR",15) == 3674230660) strcat(s, "a");
if (crc32("HoytzzXL",8) == 3737585165) strcat(s, "E");
if (crc32("oKUex",5) == 3178643978) strcat(s, "u");
if (crc32("ChTZEnfyVv",10) == 1309162372) strcat(s, "t");
if (crc32("SlOmTEjgY",9) == 816406079) strcat(s, "e");
if (crc32("VTBMCosnKYgUIbW",15) == 851500953) strcat(s, "n");
    return s;
}

char *watch_verbs() {
    char *s = calloc(6);
    if (crc32("IQSZZ",5) == 1163933759) strcat(s, "w");
if (crc32("UJRuOYffoW",10) == 3492290213) strcat(s, "a");
if (crc32("WMwOkwslc",9) == 3324880136) strcat(s, "t");
if (crc32("kflvAuH",7) == 1443095602) strcat(s, "M");
if (crc32("YuHMQDVg",8) == 3915816707) strcat(s, "c");
if (crc32("UuCSbSPAfSe",11) == 1846511948) strcat(s, "O");
if (crc32("epGCo",5) == 2403554550) strcat(s, "h");
    return s;
}

char *renegotiated_verbs() {
    char *s = calloc(13);
    if (crc32("IEJEnvLRXeCC",12) == 47831632) strcat(s, "G");
if (crc32("EJcYfQIZGOv",11) == 254979409) strcat(s, "r");
if (crc32("DZoJvsAbQQCuToS",15) == 3137466496) strcat(s, "e");
if (crc32("jKqkvEIRNKtNkux",15) == 3439460580) strcat(s, "b");
if (crc32("lmxmdWE",7) == 3647765707) strcat(s, "n");
if (crc32("phOWYwETEcICYM",14) == 1674557039) strcat(s, "m");
if (crc32("oYjrDVbY",8) == 3387040660) strcat(s, "e");
if (crc32("pXqdnmwLYT",10) == 402765279) strcat(s, "g");
if (crc32("DYryBiHU",8) == 2569703681) strcat(s, "o");
if (crc32("xPHgZOACa",9) == 3140269991) strcat(s, "t");
if (crc32("EOcUabxmiWZ",11) == 2320561833) strcat(s, "i");
if (crc32("kjSOPhV",7) == 1122381299) strcat(s, "a");
if (crc32("CULUzivfPRz",11) == 812024213) strcat(s, "e");
if (crc32("kpkOMMZYFTzG",12) == 334229159) strcat(s, "t");
if (crc32("kxfSdmJCMasKCm",14) == 2525120544) strcat(s, "e");
if (crc32("aTyAGUTr",8) == 2202712358) strcat(s, "n");
if (crc32("NetJxTDe",8) == 1857581570) strcat(s, "d");
    return s;
}

char *backlighting_verbs() {
    char *s = calloc(13);
    if (crc32("NOyElKjejJwxNM",14) == 2546097356) strcat(s, "o");
if (crc32("AZSGfKSLbvXSAlj",15) == 1333551557) strcat(s, "b");
if (crc32("JVWZgJIOAFQ",11) == 2230223389) strcat(s, "a");
if (crc32("qblKAN",6) == 2241333556) strcat(s, "F");
if (crc32("zaYdLQ",6) == 106074950) strcat(s, "c");
if (crc32("PpmjWoEocmTZaiD",15) == 211106959) strcat(s, "f");
if (crc32("PSKBkxfbqxGaOMT",15) == 969976664) strcat(s, "k");
if (crc32("PPylsSI",7) == 300835921) strcat(s, "g");
if (crc32("IVmlnKB",7) == 1332522785) strcat(s, "l");
if (crc32("IzfjugBzCl",10) == 1513933930) strcat(s, "i");
if (crc32("wwFPPSGKg",9) == 4066843699) strcat(s, "o");
if (crc32("qoTaSEB",7) == 469650198) strcat(s, "g");
if (crc32("DYOZBj",6) == 3715891887) strcat(s, "h");
if (crc32("EEKHOfRI",8) == 2670899456) strcat(s, "g");
if (crc32("sDDwZW",6) == 1637146739) strcat(s, "t");
if (crc32("nvwdGJa",7) == 568211349) strcat(s, "i");
if (crc32("HStItSCfXQdTfC",14) == 2155275276) strcat(s, "n");
if (crc32("HGghnC",6) == 4062209753) strcat(s, "I");
if (crc32("COZwWVi",7) == 599153783) strcat(s, "g");
    return s;
}

char *dilated_verbs() {
    char *s = calloc(8);
    if (crc32("FjhlZvapeHhYdak",15) == 1376039749) strcat(s, "d");
if (crc32("qIGcSlqAGEw",11) == 1857607573) strcat(s, "i");
if (crc32("higDmGrHMM",10) == 1255996633) strcat(s, "X");
if (crc32("SuioFbiCreaX",12) == 1147328956) strcat(s, "l");
if (crc32("EOyVCSkVDUgfD",13) == 692489632) strcat(s, "Z");
if (crc32("rAKwTfN",7) == 841093138) strcat(s, "a");
if (crc32("YYUnfNccUcAzJY",14) == 214396768) strcat(s, "S");
if (crc32("AbFPsXLUqAn",11) == 455807053) strcat(s, "t");
if (crc32("YvNuwaV",7) == 3794336690) strcat(s, "e");
if (crc32("vbWiMsvoLFwHb",13) == 4164939881) strcat(s, "z");
if (crc32("BkXnLD",6) == 2084374655) strcat(s, "d");
    return s;
}

char *humidify_verbs() {
    char *s = calloc(9);
    if (crc32("IunkRDrevvRARXf",15) == 3551357783) strcat(s, "h");
if (crc32("vJTEdXrBNWmEChM",15) == 791916695) strcat(s, "l");
if (crc32("yMPspRKxJM",10) == 324072984) strcat(s, "u");
if (crc32("WEhwqtIGq",9) == 1117181882) strcat(s, "i");
if (crc32("pdHCCV",6) == 2742212259) strcat(s, "m");
if (crc32("PrsGCD",6) == 2565085059) strcat(s, "i");
if (crc32("RetUhTH",7) == 1636486140) strcat(s, "d");
if (crc32("uSIAUVd",7) == 321186819) strcat(s, "i");
if (crc32("PZlZb",5) == 1050733915) strcat(s, "a");
if (crc32("xgzDNk",6) == 3123329773) strcat(s, "f");
if (crc32("HTEgSh",6) == 2139053526) strcat(s, "j");
if (crc32("OuIIteiFg",9) == 3356459371) strcat(s, "y");
    return s;
}

char *subtilized_verbs() {
    char *s = calloc(11);
    if (crc32("BotjBcFT",8) == 2180816495) strcat(s, "s");
if (crc32("azUuajrWo",9) == 902304909) strcat(s, "u");
if (crc32("YBuoWx",6) == 4014723542) strcat(s, "r");
if (crc32("UmByYFf",7) == 225499140) strcat(s, "b");
if (crc32("FSFymEBSNCQgY",13) == 2878121012) strcat(s, "r");
if (crc32("rNlvp",5) == 1448539828) strcat(s, "t");
if (crc32("QVqVpWi",7) == 4176327946) strcat(s, "x");
if (crc32("iESsZCg",7) == 3007820965) strcat(s, "i");
if (crc32("fOPBcGmpCW",10) == 940303695) strcat(s, "v");
if (crc32("WKYVgkXkG",9) == 595354412) strcat(s, "l");
if (crc32("AvvKd",5) == 3838533321) strcat(s, "i");
if (crc32("owgwTeh",7) == 3366787996) strcat(s, "B");
if (crc32("ZdqxrCie",8) == 3991679820) strcat(s, "z");
if (crc32("SHscDwGEfav",11) == 4183583981) strcat(s, "e");
if (crc32("svEZlJHkvsXwLYc",15) == 1821154774) strcat(s, "w");
if (crc32("aVhErIAsWhTfZ",13) == 3180530827) strcat(s, "d");
    return s;
}

char *requalifying_verbs() {
    char *s = calloc(13);
    if (crc32("DRPFgGpi",8) == 3079849613) strcat(s, "D");
if (crc32("RodTDhL",7) == 1568938527) strcat(s, "r");
if (crc32("cRfNai",6) == 1370541043) strcat(s, "e");
if (crc32("upGzvGDIS",9) == 258195969) strcat(s, "q");
if (crc32("nZRmWl",6) == 2972445263) strcat(s, "I");
if (crc32("jfnPdNvWjv",10) == 2583127274) strcat(s, "u");
if (crc32("wvydFrLKoFmC",12) == 150418749) strcat(s, "W");
if (crc32("hkAhincDvWcnIt",14) == 3689316560) strcat(s, "a");
if (crc32("lroyhpWmsX",10) == 3963466071) strcat(s, "l");
if (crc32("wBIXlvKUzM",10) == 3555255928) strcat(s, "i");
if (crc32("cRHCiUxkzUATgb",14) == 1232108650) strcat(s, "f");
if (crc32("SjuPkLdAHs",10) == 1946222781) strcat(s, "y");
if (crc32("IDCjkz",6) == 2802156123) strcat(s, "I");
if (crc32("RQiLdH",6) == 3016705288) strcat(s, "i");
if (crc32("HgodcZJQLefp",12) == 2604369420) strcat(s, "n");
if (crc32("Yapsqntz",8) == 712235384) strcat(s, "L");
if (crc32("wQxNYqBwqAeZqs",14) == 4224020879) strcat(s, "g");
    return s;
}

char *remodifying_verbs() {
    char *s = calloc(12);
    if (crc32("FhKdAOKeZh",10) == 2198345330) strcat(s, "r");
if (crc32("uoGgawpweq",10) == 2418684257) strcat(s, "e");
if (crc32("XgiAPEbAUsG",11) == 3495277629) strcat(s, "l");
if (crc32("ztWDQzPoMYUhSmj",15) == 854531813) strcat(s, "m");
if (crc32("kvzwx",5) == 22197688) strcat(s, "o");
if (crc32("mMJYs",5) == 293997196) strcat(s, "d");
if (crc32("lSZAN",5) == 3787556382) strcat(s, "x");
if (crc32("YRwaEzdbZbdxNCc",15) == 1028898587) strcat(s, "i");
if (crc32("sxWlMY",6) == 3047270533) strcat(s, "f");
if (crc32("yEvkBNX",7) == 1508398807) strcat(s, "y");
if (crc32("JqHEDJUvitpQh",13) == 2308661243) strcat(s, "Q");
if (crc32("ZKWbiJxW",8) == 1014729392) strcat(s, "i");
if (crc32("GRsfWlGKbSIqD",13) == 3542319652) strcat(s, "n");
if (crc32("eLAiP",5) == 3540094117) strcat(s, "E");
if (crc32("NRpjHsuIZP",10) == 3911689339) strcat(s, "g");
    return s;
}

char *backstopping_verbs() {
    char *s = calloc(13);
    if (crc32("JdjQXryF",8) == 907288212) strcat(s, "b");
if (crc32("AifMDjvQITlqt",13) == 2994943358) strcat(s, "a");
if (crc32("dHPfcveSHUPFhV",14) == 2546943641) strcat(s, "c");
if (crc32("YSzvzcaNSOIOln",14) == 1196611249) strcat(s, "I");
if (crc32("asFus",5) == 4104780501) strcat(s, "k");
if (crc32("AuzOhytCTkgC",12) == 596778401) strcat(s, "r");
if (crc32("FMiHR",5) == 2183978862) strcat(s, "s");
if (crc32("ZqHNyndR",8) == 1528291727) strcat(s, "b");
if (crc32("ncpqgUEMKxJGJ",13) == 379672595) strcat(s, "t");
if (crc32("MjZWsmmlg",9) == 863961049) strcat(s, "o");
if (crc32("iBLvdsBnpY",10) == 1344512501) strcat(s, "v");
if (crc32("OvnbXeaxJ",9) == 801743066) strcat(s, "p");
if (crc32("yLEoteazA",9) == 3055440256) strcat(s, "p");
if (crc32("KBfyZeIXZXpW",12) == 353924514) strcat(s, "c");
if (crc32("FvDgXFYrqea",11) == 3179228017) strcat(s, "i");
if (crc32("rLaKoSS",7) == 1446631278) strcat(s, "n");
if (crc32("YWHiDwYvN",9) == 4025728420) strcat(s, "g");
    return s;
}

char *flog_verbs() {
    char *s = calloc(5);
    if (crc32("JvTueHSuTkVH",12) == 2024529436) strcat(s, "p");
if (crc32("fPnvwU",6) == 2810600631) strcat(s, "f");
if (crc32("fSDRMVRlzJ",10) == 179616317) strcat(s, "l");
if (crc32("rQmxHaNIK",9) == 29735409) strcat(s, "s");
if (crc32("ATMchNhfXKy",11) == 3757625194) strcat(s, "o");
if (crc32("rYpuixxTv",9) == 3259544503) strcat(s, "g");
    return s;
}

char *understudied_verbs() {
    char *s = calloc(13);
    if (crc32("QXcaqXFfA",9) == 4034232584) strcat(s, "u");
if (crc32("ArvCcwYGHqBFXV",14) == 2759216167) strcat(s, "n");
if (crc32("qbvIwKIBzgAsqwS",15) == 2617872352) strcat(s, "d");
if (crc32("DMTxuIzseXS",11) == 2762620963) strcat(s, "e");
if (crc32("mgZNiRROGj",10) == 1257665688) strcat(s, "r");
if (crc32("HbTjiBg",7) == 1612914062) strcat(s, "s");
if (crc32("iJHWEXA",7) == 4080288984) strcat(s, "v");
if (crc32("xFgyxksDwTfngor",15) == 111979930) strcat(s, "t");
if (crc32("GdhWcDZT",8) == 625327941) strcat(s, "u");
if (crc32("IadCgbq",7) == 1213746704) strcat(s, "B");
if (crc32("HbLEqANOvk",10) == 1922443186) strcat(s, "d");
if (crc32("CLqHenmxsghoKH",14) == 1221717882) strcat(s, "Q");
if (crc32("nvJUZhZPHa",10) == 2833497207) strcat(s, "i");
if (crc32("aRQEjVSFFU",10) == 380383) strcat(s, "e");
if (crc32("yeJIljsxz",9) == 3824586386) strcat(s, "d");
    return s;
}

char *enlarging_verbs() {
    char *s = calloc(10);
    if (crc32("mbCiUNF",7) == 2954008290) strcat(s, "d");
if (crc32("AHtiAe",6) == 1789150997) strcat(s, "e");
if (crc32("IVwEOAQi",8) == 2954897943) strcat(s, "n");
if (crc32("ZvNbLMoy",8) == 2598428065) strcat(s, "l");
if (crc32("pCAhkKESm",9) == 3076836141) strcat(s, "Y");
if (crc32("dUYVWAEvxSin",12) == 1476262793) strcat(s, "a");
if (crc32("VsYXX",5) == 1309869841) strcat(s, "s");
if (crc32("kulohzqkBB",10) == 274334665) strcat(s, "r");
if (crc32("ktUhn",5) == 2714027809) strcat(s, "g");
if (crc32("MsdlHaNSRX",10) == 1385714684) strcat(s, "J");
if (crc32("gpuoroNWalqX",12) == 4155437255) strcat(s, "i");
if (crc32("nSWJHDVc",8) == 2699000211) strcat(s, "n");
if (crc32("LaROCiDyUBfj",12) == 1139840382) strcat(s, "R");
if (crc32("OlmiVn",6) == 3685739178) strcat(s, "g");
    return s;
}

char *tittupped_verbs() {
    char *s = calloc(10);
    if (crc32("LIChvDx",7) == 2574457016) strcat(s, "b");
if (crc32("pMagyOrNdEhRtr",14) == 2648666467) strcat(s, "t");
if (crc32("dnLVOuMBIX",10) == 4701863) strcat(s, "i");
if (crc32("FeHiWEhzZG",10) == 888746852) strcat(s, "S");
if (crc32("BHcEPdGUkLvH",12) == 963058874) strcat(s, "t");
if (crc32("wcVYqMdJahOx",12) == 1166526748) strcat(s, "M");
if (crc32("smrCmuPXKj",10) == 1516164110) strcat(s, "t");
if (crc32("ZDiyDxLI",8) == 3621892766) strcat(s, "u");
if (crc32("GeBQjM",6) == 961612155) strcat(s, "p");
if (crc32("PFJxGh",6) == 1455164542) strcat(s, "Z");
if (crc32("Imdrc",5) == 3705776785) strcat(s, "p");
if (crc32("vfkeRhs",7) == 1446143118) strcat(s, "n");
if (crc32("aiawbGI",7) == 914833373) strcat(s, "e");
if (crc32("DABBRCy",7) == 2842695078) strcat(s, "N");
if (crc32("sliERTZqESwHa",13) == 2785767978) strcat(s, "d");
    return s;
}

char *gotta_verbs() {
    char *s = calloc(6);
    if (crc32("tKXpREkIrGggySo",15) == 1642513874) strcat(s, "g");
if (crc32("StLsKgjVLUZwBq",14) == 1441748262) strcat(s, "Q");
if (crc32("odqdrAc",7) == 1773008269) strcat(s, "o");
if (crc32("vPcccTUquP",10) == 2552131288) strcat(s, "s");
if (crc32("zOdbuy",6) == 1163819949) strcat(s, "t");
if (crc32("DqGtnObLkXFObpS",15) == 770252167) strcat(s, "n");
if (crc32("UMQNv",5) == 3847079235) strcat(s, "t");
if (crc32("ytZkPWvXLoLZf",13) == 4111012955) strcat(s, "x");
if (crc32("cPIQrpQ",7) == 1774745508) strcat(s, "a");
    return s;
}

char *ruminated_verbs() {
    char *s = calloc(10);
    if (crc32("NJWuQwEcEUpI",12) == 1116499000) strcat(s, "H");
if (crc32("kdDbZenYD",9) == 3208384328) strcat(s, "r");
if (crc32("xNlHbxJZoWQ",11) == 143443203) strcat(s, "u");
if (crc32("JOOYgSt",7) == 1691984983) strcat(s, "m");
if (crc32("tgtMYqpsBdJEd",13) == 3654364020) strcat(s, "u");
if (crc32("CLjsvnkChdTTe",13) == 1178996361) strcat(s, "i");
if (crc32("gbpFkoMiQsWzBk",14) == 4148084172) strcat(s, "d");
if (crc32("srOpFHxe",8) == 555642334) strcat(s, "n");
if (crc32("uSuCcvkSiNzG",12) == 52983945) strcat(s, "d");
if (crc32("kNkNkUZXqj",10) == 2331251376) strcat(s, "a");
if (crc32("nqZNqDJjGlEzw",13) == 2872313060) strcat(s, "t");
if (crc32("LnueIIFmArpGwXn",15) == 4079791141) strcat(s, "e");
if (crc32("AaznLf",6) == 4277739038) strcat(s, "P");
if (crc32("CbMMuft",7) == 1381749100) strcat(s, "d");
    return s;
}

char *economize_verbs() {
    char *s = calloc(10);
    if (crc32("mPoIUQhDdekdVIS",15) == 427587635) strcat(s, "e");
if (crc32("tVIhrEMilMQ",11) == 2279111929) strcat(s, "k");
if (crc32("vyqRHrdPAC",10) == 775658131) strcat(s, "c");
if (crc32("XGPvVdS",7) == 1921945118) strcat(s, "o");
if (crc32("GAaQOOOiNQgUmpU",15) == 2742817297) strcat(s, "k");
if (crc32("AITJTAdj",8) == 1293647454) strcat(s, "n");
if (crc32("fBcjOUA",7) == 4326870) strcat(s, "o");
if (crc32("dDbJJAN",7) == 1678539075) strcat(s, "m");
if (crc32("cBqKietzxi",10) == 3374286548) strcat(s, "Q");
if (crc32("DImwCFns",8) == 691692417) strcat(s, "i");
if (crc32("xjraA",5) == 3484340093) strcat(s, "Z");
if (crc32("MPxWwZTH",8) == 2822643492) strcat(s, "z");
if (crc32("eBOaFWKrNcYSnR",14) == 3577358480) strcat(s, "u");
if (crc32("ZFewaeQl",8) == 3220572889) strcat(s, "e");
    return s;
}

char *intussuscept_verbs() {
    char *s = calloc(13);
    if (crc32("CTcgKLMomlf",11) == 2789604735) strcat(s, "b");
if (crc32("OrWWRybK",8) == 4180795509) strcat(s, "i");
if (crc32("saVmRYu",7) == 2936337803) strcat(s, "R");
if (crc32("ztrBEtiNGuh",11) == 819486749) strcat(s, "n");
if (crc32("tBWpSNa",7) == 476221642) strcat(s, "t");
if (crc32("yFLbDEmTQhP",11) == 3459770939) strcat(s, "H");
if (crc32("llUQhdfuR",9) == 3948189833) strcat(s, "u");
if (crc32("sburpZbccmHVw",13) == 1168373849) strcat(s, "D");
if (crc32("jsReAQGztyMp",12) == 509616832) strcat(s, "s");
if (crc32("nkbaoameCzz",11) == 3928396971) strcat(s, "s");
if (crc32("tiCBTHt",7) == 2156081599) strcat(s, "u");
if (crc32("CGHxnaCTecJ",11) == 2540450283) strcat(s, "s");
if (crc32("IKZAeMxnN",9) == 1495634441) strcat(s, "O");
if (crc32("uREbYqwRMpsX",12) == 3846682699) strcat(s, "c");
if (crc32("BNNFGxE",7) == 3063147615) strcat(s, "e");
if (crc32("vPRDsVGBr",9) == 2362994180) strcat(s, "r");
if (crc32("yrSJRyr",7) == 111330175) strcat(s, "p");
if (crc32("TxMrYG",6) == 1387613884) strcat(s, "t");
    return s;
}

char *preaccount_verbs() {
    char *s = calloc(11);
    if (crc32("szkMjwJGNZohQL",14) == 1447978615) strcat(s, "p");
if (crc32("OQsprHxZtX",10) == 3004713896) strcat(s, "J");
if (crc32("BHxnWIOFFiJmd",13) == 1387958364) strcat(s, "r");
if (crc32("ezBGDNr",7) == 1841934001) strcat(s, "e");
if (crc32("eIeVqxCvAlWRKBL",15) == 1181749014) strcat(s, "t");
if (crc32("npNdPDYBqJgAUGv",15) == 606595099) strcat(s, "a");
if (crc32("PnAoYNMOUgYfeC",14) == 2079876787) strcat(s, "D");
if (crc32("YsvcuqEaS",9) == 26955984) strcat(s, "c");
if (crc32("rZguxANwuQybR",13) == 223153662) strcat(s, "c");
if (crc32("TezqebTqktJCi",13) == 2028349690) strcat(s, "o");
if (crc32("BGuNGbanLtkND",13) == 2362266764) strcat(s, "u");
if (crc32("SaAIWqscEw",10) == 383932393) strcat(s, "t");
if (crc32("yHMrDmAuRnrcfrb",15) == 1455846692) strcat(s, "n");
if (crc32("pAUWr",5) == 725276427) strcat(s, "f");
if (crc32("JBcAvnXiM",9) == 3418476674) strcat(s, "t");
    return s;
}

char *remerge_verbs() {
    char *s = calloc(8);
    if (crc32("sJftalRUlVa",11) == 2546058714) strcat(s, "l");
if (crc32("GplNFUAptRRBW",13) == 1564673378) strcat(s, "r");
if (crc32("ssKGnIKKAj",10) == 1001289619) strcat(s, "S");
if (crc32("aPCWUFKLdnz",11) == 2840110858) strcat(s, "e");
if (crc32("RqIriYcGspfDiB",14) == 154988091) strcat(s, "W");
if (crc32("HRbIWuqMFDH",11) == 1996414930) strcat(s, "m");
if (crc32("eUNaibrqWKyTpKa",15) == 2415757931) strcat(s, "j");
if (crc32("uSyeiboBvpmpWO",14) == 3168989343) strcat(s, "e");
if (crc32("xSJGccyYSiDS",12) == 2238751080) strcat(s, "o");
if (crc32("NgDWcOlMdWuHRou",15) == 772162545) strcat(s, "r");
if (crc32("TymJvcHNsfG",11) == 603284406) strcat(s, "g");
if (crc32("VreDSF",6) == 2638557689) strcat(s, "e");
    return s;
}

char *dealt_verbs() {
    char *s = calloc(6);
    if (crc32("dQpSeXQTfBncbLb",15) == 3055895022) strcat(s, "B");
if (crc32("XIKoSSH",7) == 1846344411) strcat(s, "d");
if (crc32("gdnlxsTXEIPnnr",14) == 1189947849) strcat(s, "e");
if (crc32("UOrkr",5) == 2805404716) strcat(s, "g");
if (crc32("jixpwGZQ",8) == 4219589267) strcat(s, "a");
if (crc32("ZzkLpOJ",7) == 3104792811) strcat(s, "U");
if (crc32("WClLnweB",8) == 2802348416) strcat(s, "l");
if (crc32("qGAcVFUpr",9) == 3170546626) strcat(s, "t");
    return s;
}

char *misgraft_verbs() {
    char *s = calloc(9);
    if (crc32("KdfCHcobZZkMPZU",15) == 362180776) strcat(s, "V");
if (crc32("RjgCwIjtFafW",12) == 775127067) strcat(s, "m");
if (crc32("MfyqADTVpOCY",12) == 752429482) strcat(s, "i");
if (crc32("yQWHOFKQ",8) == 2450969251) strcat(s, "s");
if (crc32("EsAiaZXc",8) == 3448883485) strcat(s, "g");
if (crc32("nUkANhNNepY",11) == 1485941171) strcat(s, "u");
if (crc32("LXLQRSXBlCvL",12) == 2946342063) strcat(s, "r");
if (crc32("EngiKMpPr",9) == 3231383610) strcat(s, "a");
if (crc32("dRKdETzDj",9) == 3275006454) strcat(s, "N");
if (crc32("OAFtbQw",7) == 4267118273) strcat(s, "f");
if (crc32("zANfwXtzIqL",11) == 4049680167) strcat(s, "t");
    return s;
}

char *rowelling_verbs() {
    char *s = calloc(10);
    if (crc32("IIckK",5) == 2049812911) strcat(s, "w");
if (crc32("nLaRVMvfrYj",11) == 3150913610) strcat(s, "r");
if (crc32("OKDatb",6) == 3580076729) strcat(s, "o");
if (crc32("OoPogyhLFk",10) == 2481801030) strcat(s, "j");
if (crc32("sfhfCf",6) == 3880512756) strcat(s, "w");
if (crc32("JeGNget",7) == 3058448277) strcat(s, "e");
if (crc32("wogWk",5) == 813565416) strcat(s, "x");
if (crc32("NNLSbkJVya",10) == 3936891487) strcat(s, "l");
if (crc32("JnbdsSPjxfW",11) == 3100613212) strcat(s, "r");
if (crc32("zUFcsKNvMHVh",12) == 3580334777) strcat(s, "l");
if (crc32("EzJLRt",6) == 2825726927) strcat(s, "n");
if (crc32("NxYPy",5) == 2137331893) strcat(s, "i");
if (crc32("KCphxParbSGBO",13) == 2883369307) strcat(s, "v");
if (crc32("vYCEJFknpbrqWDT",15) == 111063656) strcat(s, "n");
if (crc32("IJYFFMXhazJC",12) == 537742895) strcat(s, "m");
if (crc32("xxtsQnSKdJm",11) == 3084516356) strcat(s, "g");
    return s;
}

char *miked_verbs() {
    char *s = calloc(6);
    if (crc32("ZxeQpId",7) == 2519508923) strcat(s, "U");
if (crc32("CbJvaoNMTO",10) == 813731692) strcat(s, "m");
if (crc32("Obspf",5) == 1358392479) strcat(s, "i");
if (crc32("WOlWFAbVxFx",11) == 3019325816) strcat(s, "v");
if (crc32("voaKSNWnac",10) == 274560318) strcat(s, "k");
if (crc32("cNvnHUhZovhTeJ",14) == 170811282) strcat(s, "e");
if (crc32("AFlJAvqMEMNmTfy",15) == 282401044) strcat(s, "d");
    return s;
}

char *polarized_verbs() {
    char *s = calloc(10);
    if (crc32("uoqXItWDtyZGyi",14) == 2597926614) strcat(s, "h");
if (crc32("SvdrknAJLfuUC",13) == 3430382870) strcat(s, "p");
if (crc32("cOnidOVHmD",10) == 2079669981) strcat(s, "o");
if (crc32("BZAjokligp",10) == 256338496) strcat(s, "l");
if (crc32("LCjIXidfchiu",12) == 1394596825) strcat(s, "a");
if (crc32("hkWHpsjw",8) == 3481868860) strcat(s, "g");
if (crc32("jmSqrtGC",8) == 1122212970) strcat(s, "r");
if (crc32("GVWkhIkuF",9) == 2379861613) strcat(s, "i");
if (crc32("CzIEhRmFVq",10) == 3909697812) strcat(s, "p");
if (crc32("JbfBlwQkTxp",11) == 2709557323) strcat(s, "z");
if (crc32("SgvcAY",6) == 4024069514) strcat(s, "e");
if (crc32("oSJrNnlyZlOpNc",14) == 4124976034) strcat(s, "d");
    return s;
}

char *lacerating_verbs() {
    char *s = calloc(11);
    if (crc32("dikOoDGPqNWz",12) == 3109877457) strcat(s, "q");
if (crc32("HtoespRN",8) == 463438808) strcat(s, "l");
if (crc32("jlIVGDdUmpsestp",15) == 3621216520) strcat(s, "a");
if (crc32("XdqTcosDnVFj",12) == 743004606) strcat(s, "c");
if (crc32("HSMZUuhPuhvcfLu",15) == 1324851051) strcat(s, "s");
if (crc32("GnZlhxZr",8) == 906744114) strcat(s, "e");
if (crc32("EZpWat",6) == 3048643196) strcat(s, "r");
if (crc32("sGQFZivBHLiellh",15) == 2922366421) strcat(s, "f");
if (crc32("CBUDvtBJMk",10) == 3379554935) strcat(s, "a");
if (crc32("sgYykXOXSNDAIHN",15) == 3064496980) strcat(s, "b");
if (crc32("JJKmmSPGJvt",11) == 3430601774) strcat(s, "t");
if (crc32("DWQFX",5) == 4040773868) strcat(s, "o");
if (crc32("cjUkS",5) == 1379382174) strcat(s, "i");
if (crc32("inKmS",5) == 3099004344) strcat(s, "z");
if (crc32("XOyHicqQbQk",11) == 1978491783) strcat(s, "n");
if (crc32("xntrTfWoPUWzP",13) == 2814720447) strcat(s, "g");
    return s;
}

char *bind_verbs() {
    char *s = calloc(5);
    if (crc32("XwaligYaMmIQRX",14) == 2228751677) strcat(s, "c");
if (crc32("JJAisBySM",9) == 2514160001) strcat(s, "b");
if (crc32("MLEBU",5) == 1204612924) strcat(s, "A");
if (crc32("dczTfQJ",7) == 3792427502) strcat(s, "i");
if (crc32("deLYEbfD",8) == 1994490159) strcat(s, "s");
if (crc32("DnQDWSPaR",9) == 2009704780) strcat(s, "n");
if (crc32("WFDZYgPcLPXpW",13) == 730835928) strcat(s, "d");
    return s;
}

char *deflate_verbs() {
    char *s = calloc(8);
    if (crc32("MYzboubvl",9) == 3207095640) strcat(s, "d");
if (crc32("oLwgwsI",7) == 3367541874) strcat(s, "j");
if (crc32("qBGksuHLwtdXvw",14) == 3909574790) strcat(s, "e");
if (crc32("DrRhfDNysfD",11) == 972749792) strcat(s, "f");
if (crc32("BKsypIasN",9) == 1352296422) strcat(s, "l");
if (crc32("IAxIkItVy",9) == 2162153278) strcat(s, "F");
if (crc32("lMOGU",5) == 744578037) strcat(s, "a");
if (crc32("YNNyxfc",7) == 99436018) strcat(s, "I");
if (crc32("tYxBmZKe",8) == 3087396675) strcat(s, "t");
if (crc32("uTlxZnlygOoj",12) == 812199681) strcat(s, "r");
if (crc32("WlAyc",5) == 1728035287) strcat(s, "e");
    return s;
}

char *devolatilizing_verbs() {
    char *s = calloc(15);
    if (crc32("pmOajgKXfaL",11) == 4172120767) strcat(s, "d");
if (crc32("KvpDrL",6) == 608793217) strcat(s, "O");
if (crc32("mYgcKgwkbyctd",13) == 3616219714) strcat(s, "e");
if (crc32("MHuiteLBXyvCn",13) == 2855534681) strcat(s, "v");
if (crc32("DeDQlnYAco",10) == 2513334431) strcat(s, "E");
if (crc32("YJpSCMUr",8) == 864417064) strcat(s, "o");
if (crc32("nXpvegTeRaxrHSa",15) == 2552900008) strcat(s, "f");
if (crc32("ImJcD",5) == 417421056) strcat(s, "l");
if (crc32("NboZtcAnHUKzYlk",15) == 1791471388) strcat(s, "a");
if (crc32("ccngMCUfU",9) == 838324966) strcat(s, "a");
if (crc32("cwvdLKJm",8) == 936941067) strcat(s, "t");
if (crc32("yyKZZdax",8) == 1041554358) strcat(s, "H");
if (crc32("VUysPjqNczSkHS",14) == 2862162965) strcat(s, "i");
if (crc32("lwsisFfWQLAyWg",14) == 2351751488) strcat(s, "l");
if (crc32("WtGoaXPHODH",11) == 2382687963) strcat(s, "h");
if (crc32("peFtSeWwhMU",11) == 154411354) strcat(s, "i");
if (crc32("RdssJdvXuMBnU",13) == 2350744662) strcat(s, "z");
if (crc32("iUQFVquMXL",10) == 2778368659) strcat(s, "G");
if (crc32("bQaiyfCV",8) == 653648876) strcat(s, "i");
if (crc32("mnkyMnLEAzew",12) == 4167989011) strcat(s, "B");
if (crc32("hPcLyVJkDdtusc",14) == 1080468669) strcat(s, "n");
if (crc32("yyerHigsqKHaxW",14) == 1085032227) strcat(s, "h");
if (crc32("GqqjbGn",7) == 318119462) strcat(s, "g");
    return s;
}

char *throw_verbs() {
    char *s = calloc(6);
    if (crc32("HWleoiTrNJ",10) == 1394915325) strcat(s, "f");
if (crc32("ihyqh",5) == 2197802959) strcat(s, "t");
if (crc32("GYQbdS",6) == 1569583017) strcat(s, "h");
if (crc32("dWhtafjUf",9) == 214804004) strcat(s, "r");
if (crc32("HGNbw",5) == 1271712097) strcat(s, "o");
if (crc32("OMFZJkVR",8) == 3259921176) strcat(s, "w");
    return s;
}

char *privileging_verbs() {
    char *s = calloc(12);
    if (crc32("OXefUaunUiV",11) == 2152385210) strcat(s, "p");
if (crc32("HunCnERNxPCGe",13) == 1161612320) strcat(s, "T");
if (crc32("AjjvswqNz",9) == 1609938970) strcat(s, "r");
if (crc32("OavhNopvnKt",11) == 2621788217) strcat(s, "i");
if (crc32("xMBnWASYwfvcP",13) == 3934610995) strcat(s, "i");
if (crc32("LxbUpl",6) == 2986590604) strcat(s, "Q");
if (crc32("hELISeuKDFN",11) == 2155896808) strcat(s, "v");
if (crc32("hNGOVjEjDUmwb",13) == 1387864144) strcat(s, "D");
if (crc32("VlABMVxxja",10) == 2385447499) strcat(s, "i");
if (crc32("oCIeQHBAIrN",11) == 2966166353) strcat(s, "A");
if (crc32("elLMqosXXTRPM",13) == 3293227659) strcat(s, "l");
if (crc32("hInCffqa",8) == 3298041418) strcat(s, "e");
if (crc32("DzSuzSQVfKIZ",12) == 729932373) strcat(s, "g");
if (crc32("OZGFKaYo",8) == 288379348) strcat(s, "J");
if (crc32("AhFdq",5) == 262621043) strcat(s, "i");
if (crc32("SoJlYc",6) == 2890981082) strcat(s, "e");
if (crc32("xMxIRLZA",8) == 3570565940) strcat(s, "n");
if (crc32("KAuOEiKMBzmBY",13) == 102703893) strcat(s, "g");
    return s;
}

char *irradiating_verbs() {
    char *s = calloc(12);
    if (crc32("BSEjmcjqELB",11) == 763615964) strcat(s, "n");
if (crc32("UxCqBRWryjK",11) == 4244526496) strcat(s, "i");
if (crc32("gFDkhAe",7) == 3619942624) strcat(s, "X");
if (crc32("hbiJsOkQijGbr",13) == 380694213) strcat(s, "r");
if (crc32("OszsvF",6) == 1162948385) strcat(s, "r");
if (crc32("RAdPAJcSUa",10) == 2359412555) strcat(s, "a");
if (crc32("YxOvnbYx",8) == 3713893491) strcat(s, "d");
if (crc32("IBOVAk",6) == 4050474881) strcat(s, "s");
if (crc32("DWMHwHSqFtUO",12) == 1154125188) strcat(s, "i");
if (crc32("rnMigeBVuyT",11) == 371537966) strcat(s, "Q");
if (crc32("ryVEgWDPq",9) == 53581744) strcat(s, "a");
if (crc32("sdNbEOe",7) == 2567768082) strcat(s, "t");
if (crc32("ntvIaYErGld",11) == 2194403654) strcat(s, "i");
if (crc32("mXfZnZUuI",9) == 1025013334) strcat(s, "n");
if (crc32("DuUvuWudZYkOGe",14) == 2352455350) strcat(s, "g");
    return s;
}

char *yipped_verbs() {
    char *s = calloc(7);
    if (crc32("kUBGBRAFJERoT",13) == 857475758) strcat(s, "y");
if (crc32("NvYtgOoRAt",10) == 1399152148) strcat(s, "J");
if (crc32("mDHUs",5) == 3284131428) strcat(s, "i");
if (crc32("FYeZip",6) == 2725117843) strcat(s, "C");
if (crc32("ZxFKWGnSlzTDHCJ",15) == 3584022066) strcat(s, "p");
if (crc32("JGovfxkHI",9) == 249375861) strcat(s, "r");
if (crc32("WsmGg",5) == 427466494) strcat(s, "p");
if (crc32("wzftZdzTyi",10) == 1317514481) strcat(s, "U");
if (crc32("cjkoEdHzxjwXUJ",14) == 3041560886) strcat(s, "e");
if (crc32("wxIJjYTzlxGcP",13) == 2450037609) strcat(s, "d");
    return s;
}

char *guzzle_verbs() {
    char *s = calloc(7);
    if (crc32("bzwySnnZE",9) == 915363137) strcat(s, "X");
if (crc32("KOHKdrkxo",9) == 2347076328) strcat(s, "g");
if (crc32("flrHCiFPBEzDib",14) == 415082507) strcat(s, "B");
if (crc32("eXIOPrYDo",9) == 2331243534) strcat(s, "u");
if (crc32("WGqIJfgMgsZMTKq",15) == 3377698837) strcat(s, "z");
if (crc32("CzdzK",5) == 2629726259) strcat(s, "H");
if (crc32("FoDUbzJM",8) == 1504077922) strcat(s, "z");
if (crc32("wTDORqiLukOprM",14) == 3223758129) strcat(s, "l");
if (crc32("fbBDWDUa",8) == 1549571247) strcat(s, "e");
    return s;
}

char *stript_verbs() {
    char *s = calloc(7);
    if (crc32("ojZpgOnzp",9) == 4132449181) strcat(s, "f");
if (crc32("xQxIgUwCXFSfx",13) == 1582022993) strcat(s, "s");
if (crc32("dnwsa",5) == 510698382) strcat(s, "t");
if (crc32("qcsmEguhjpUOr",13) == 1438991575) strcat(s, "Z");
if (crc32("ZQIqaPAFSmWbs",13) == 1266266804) strcat(s, "r");
if (crc32("Ilbqo",5) == 1112256174) strcat(s, "i");
if (crc32("ARwNGlGlJ",9) == 3168611013) strcat(s, "l");
if (crc32("bXYwwCuoTVG",11) == 738230541) strcat(s, "p");
if (crc32("pZauqZpuyH",10) == 1569485211) strcat(s, "t");
    return s;
}

char *repromise_verbs() {
    char *s = calloc(10);
    if (crc32("uOpmUCnAlgAmZ",13) == 2844787372) strcat(s, "b");
if (crc32("LpkAjkouA",9) == 284679101) strcat(s, "r");
if (crc32("qEHDjK",6) == 225049626) strcat(s, "x");
if (crc32("LKosrXLNDbBKzA",14) == 1650976623) strcat(s, "e");
if (crc32("GSqtcSM",7) == 1700746919) strcat(s, "p");
if (crc32("vzMPqzx",7) == 222227847) strcat(s, "r");
if (crc32("GQETAFFL",8) == 108254533) strcat(s, "g");
if (crc32("EXkWkZnhNueD",12) == 4279119546) strcat(s, "o");
if (crc32("sXDBzThaMgNZ",12) == 3860083011) strcat(s, "m");
if (crc32("UnesiNyi",8) == 3013546629) strcat(s, "i");
if (crc32("houWufBQuvUPqV",14) == 3568590036) strcat(s, "s");
if (crc32("yyZCSLav",8) == 2016645925) strcat(s, "s");
if (crc32("xEQGyBMDguGvkQd",15) == 3394623458) strcat(s, "e");
    return s;
}

char *plugged_verbs() {
    char *s = calloc(8);
    if (crc32("aELbqnhQBBr",11) == 2238637794) strcat(s, "p");
if (crc32("WtwNHjrd",8) == 972382853) strcat(s, "U");
if (crc32("PNomlkEoE",9) == 1136640669) strcat(s, "l");
if (crc32("VarPsNhqAuqjl",13) == 822058356) strcat(s, "u");
if (crc32("VfsiHTZaUrJpJr",14) == 1481225690) strcat(s, "g");
if (crc32("kMdiBe",6) == 2021864045) strcat(s, "w");
if (crc32("ZnBKfZXiSrxm",12) == 3594908017) strcat(s, "g");
if (crc32("epcIULbAQfsYG",13) == 3286863733) strcat(s, "e");
if (crc32("dYKqGJhASVVVyi",14) == 2860069891) strcat(s, "h");
if (crc32("UIMvVlGKW",9) == 1162709048) strcat(s, "d");
    return s;
}

char *impregnated_verbs() {
    char *s = calloc(12);
    if (crc32("CpItuvdftoS",11) == 1878148306) strcat(s, "h");
if (crc32("pFfVJkG",7) == 1135434494) strcat(s, "i");
if (crc32("PAVUpelCu",9) == 586587821) strcat(s, "m");
if (crc32("RvmAZk",6) == 1260253710) strcat(s, "k");
if (crc32("JZNuzIgS",8) == 4256020623) strcat(s, "p");
if (crc32("NgSyUSJWPbjzX",13) == 2975162114) strcat(s, "r");
if (crc32("RkBCqcPe",8) == 481527418) strcat(s, "Q");
if (crc32("YsCIRVwE",8) == 1092186317) strcat(s, "e");
if (crc32("eqsMKQAdK",9) == 274829378) strcat(s, "d");
if (crc32("WXpJMNpu",8) == 800068384) strcat(s, "g");
if (crc32("hujUjppScEq",11) == 2707992495) strcat(s, "n");
if (crc32("rnVlfTfIa",9) == 935466141) strcat(s, "B");
if (crc32("uVNNe",5) == 810590026) strcat(s, "a");
if (crc32("waEbyT",6) == 2599375937) strcat(s, "S");
if (crc32("PEUOGOLhWpJQSY",14) == 4277376609) strcat(s, "t");
if (crc32("WoMxhOgMm",9) == 3645955342) strcat(s, "H");
if (crc32("NsEnIBRuEsvfSm",14) == 2351030430) strcat(s, "e");
if (crc32("tCdnARG",7) == 2862681643) strcat(s, "d");
    return s;
}

char *chinchinned_verbs() {
    char *s = calloc(12);
    if (crc32("gDPicBaaxLBf",12) == 206300408) strcat(s, "M");
if (crc32("mdURlZ",6) == 3087529381) strcat(s, "c");
if (crc32("uZuKVDNVxpZrIqu",15) == 2104323965) strcat(s, "h");
if (crc32("mLBdLe",6) == 2273079035) strcat(s, "i");
if (crc32("JBfCm",5) == 1097961970) strcat(s, "n");
if (crc32("MNuDPEvLQiFK",12) == 3628169903) strcat(s, "T");
if (crc32("mRWeqFzgLi",10) == 724508926) strcat(s, "c");
if (crc32("fCjFDJCwDMA",11) == 1913144818) strcat(s, "Y");
if (crc32("eTLcbJpaG",9) == 4222498161) strcat(s, "h");
if (crc32("RpGesLUvjuEJ",12) == 2837848954) strcat(s, "i");
if (crc32("OmequkFqwcMrtE",14) == 3589791732) strcat(s, "z");
if (crc32("enpVPc",6) == 2734123342) strcat(s, "n");
if (crc32("gPqoEKNSsQ",10) == 2838511290) strcat(s, "Q");
if (crc32("BiPEVADkW",9) == 904372419) strcat(s, "n");
if (crc32("AGAFrDgJspbBMH",14) == 3101316567) strcat(s, "e");
if (crc32("zjXEZX",6) == 238139335) strcat(s, "T");
if (crc32("FfMJFuLp",8) == 599779561) strcat(s, "d");
    return s;
}

char *predestinated_verbs() {
    char *s = calloc(14);
    if (crc32("BKcjPERCBJ",10) == 1625587526) strcat(s, "U");
if (crc32("AvHbvOnBFkIt",12) == 2112082427) strcat(s, "p");
if (crc32("BrnZwwQedHCX",12) == 489342696) strcat(s, "l");
if (crc32("QPSFJzb",7) == 3740081774) strcat(s, "r");
if (crc32("XxmYcQQIK",9) == 3638629223) strcat(s, "B");
if (crc32("oAAgYqBRxUIgMI",14) == 842725489) strcat(s, "e");
if (crc32("IMsYOxPfpQoH",12) == 993402126) strcat(s, "Y");
if (crc32("sOnjZjtSTQS",11) == 1999350215) strcat(s, "d");
if (crc32("qWvlzPPnZFdQREI",15) == 2747318406) strcat(s, "e");
if (crc32("zLDhdxBpGno",11) == 3266048341) strcat(s, "X");
if (crc32("AMPduwDicgCc",12) == 3542399619) strcat(s, "s");
if (crc32("bACsmuoy",8) == 1009823346) strcat(s, "q");
if (crc32("BauDNjDW",8) == 2320896253) strcat(s, "t");
if (crc32("vKesfzzjYprwMEH",15) == 1129390083) strcat(s, "r");
if (crc32("PHYUBIeSu",9) == 3219597265) strcat(s, "i");
if (crc32("NsrOtRgjIlxoQ",13) == 268327638) strcat(s, "n");
if (crc32("pwxEDUyqJE",10) == 2274984230) strcat(s, "o");
if (crc32("gbUwrpYCqqmaV",13) == 1102434595) strcat(s, "a");
if (crc32("RDhfn",5) == 1341046330) strcat(s, "t");
if (crc32("LoaPAxLuCv",10) == 925794185) strcat(s, "e");
if (crc32("jYFnqMyeQOL",11) == 2416068482) strcat(s, "d");
    return s;
}

char *sweettalk_verbs() {
    char *s = calloc(10);
    if (crc32("MhcRsz",6) == 4241230254) strcat(s, "l");
if (crc32("YwuwgLgtfmixhfU",15) == 2988790423) strcat(s, "s");
if (crc32("tFUrqguwOeI",11) == 2838165731) strcat(s, "Z");
if (crc32("XHZFJLQSwB",10) == 421071737) strcat(s, "w");
if (crc32("LVGmUVrhowoYfO",14) == 2747691122) strcat(s, "e");
if (crc32("wLGcVlBDnUyxS",13) == 2292798300) strcat(s, "V");
if (crc32("lkWXAnW",7) == 1223317353) strcat(s, "e");
if (crc32("sedbudDiqDrTvo",14) == 3302475298) strcat(s, "Y");
if (crc32("sxgxHMJE",8) == 1860910955) strcat(s, "t");
if (crc32("CWGYaeuGZhW",11) == 4101410061) strcat(s, "t");
if (crc32("KkPdPNTQyZ",10) == 196126865) strcat(s, "J");
if (crc32("tWwjXe",6) == 1464887799) strcat(s, "a");
if (crc32("ikhTI",5) == 691300831) strcat(s, "l");
if (crc32("RqkxstSDuSmg",12) == 3662337608) strcat(s, "k");
    return s;
}

char *agitated_verbs() {
    char *s = calloc(9);
    if (crc32("khwJndHGHgAPnzZ",15) == 2774438508) strcat(s, "a");
if (crc32("ynrslCLpQyCFT",13) == 3849966061) strcat(s, "y");
if (crc32("ioxZJWSqa",9) == 1264769784) strcat(s, "g");
if (crc32("wMeeKnFP",8) == 747943404) strcat(s, "i");
if (crc32("SqelHFDnhaPlgUO",15) == 360757746) strcat(s, "o");
if (crc32("GdrBaD",6) == 1884464172) strcat(s, "t");
if (crc32("ZXXoIiqmezxCrm",14) == 1317729282) strcat(s, "p");
if (crc32("XAfLMJLNshaoWh",14) == 2789672940) strcat(s, "a");
if (crc32("obmSSUAluSopMM",14) == 2942930007) strcat(s, "t");
if (crc32("zWxywLSw",8) == 2112654995) strcat(s, "e");
if (crc32("WnlGGq",6) == 3714934562) strcat(s, "u");
if (crc32("utPysmoZIps",11) == 2505938725) strcat(s, "d");
    return s;
}

char *trail_verbs() {
    char *s = calloc(6);
    if (crc32("vjjnDi",6) == 160596515) strcat(s, "t");
if (crc32("uTMRoUQeCEraiZD",15) == 4132838204) strcat(s, "i");
if (crc32("aHkPJkcCrKPELz",14) == 1111039456) strcat(s, "r");
if (crc32("ZtGrC",5) == 3621095335) strcat(s, "a");
if (crc32("ESGcWNtxk",9) == 971974583) strcat(s, "i");
if (crc32("xkSdwqmhLx",10) == 595433207) strcat(s, "l");
    return s;
}

char *Judaizing_verbs() {
    char *s = calloc(10);
    if (crc32("FJofsMa",7) == 948848891) strcat(s, "J");
if (crc32("JOgIyr",6) == 4186742555) strcat(s, "k");
if (crc32("OQCoW",5) == 176607460) strcat(s, "u");
if (crc32("QLadKLekCO",10) == 624426598) strcat(s, "M");
if (crc32("sPxNTQFKKTDuKa",14) == 1394062672) strcat(s, "d");
if (crc32("XKWIJhYL",8) == 1207688585) strcat(s, "a");
if (crc32("LENqm",5) == 2294816706) strcat(s, "i");
if (crc32("LYABRCiuVMcTY",13) == 3803420853) strcat(s, "z");
if (crc32("qILjuFzk",8) == 1691832098) strcat(s, "j");
if (crc32("mfyWhtUpAsIKO",13) == 2092019969) strcat(s, "i");
if (crc32("SbwcyYPeZEBGKdX",15) == 3500797809) strcat(s, "s");
if (crc32("MltRbXMyzEga",12) == 2348482811) strcat(s, "n");
if (crc32("JxeEKtEfZkqMIZX",15) == 62637043) strcat(s, "g");
if (crc32("rLLquQaaeP",10) == 4199498899) strcat(s, "g");
    return s;
}

char *collapsed_verbs() {
    char *s = calloc(10);
    if (crc32("DMAiqnDtQQNYj",13) == 774822331) strcat(s, "c");
if (crc32("TaOOV",5) == 100950918) strcat(s, "o");
if (crc32("FmCmShrRJojRW",13) == 4109773237) strcat(s, "l");
if (crc32("tXbJdoVVuem",11) == 3819615990) strcat(s, "l");
if (crc32("ywcNiXWCrDlUo",13) == 4267144337) strcat(s, "a");
if (crc32("QUcICevHnRQngIA",15) == 1733688655) strcat(s, "I");
if (crc32("ZnIiIMaYuvMWL",13) == 912823385) strcat(s, "p");
if (crc32("EDNXkjRJoyXg",12) == 1261909533) strcat(s, "w");
if (crc32("qcacRtCLuz",10) == 1717417209) strcat(s, "s");
if (crc32("fFidHPp",7) == 408603304) strcat(s, "e");
if (crc32("VqUqQpyMsAwekIy",15) == 336936103) strcat(s, "d");
    return s;
}

char *potting_verbs() {
    char *s = calloc(8);
    if (crc32("XtobiYrk",8) == 2131923642) strcat(s, "O");
if (crc32("XVyzQCLx",8) == 1070919081) strcat(s, "p");
if (crc32("VFZBfZTlWzZNvU",14) == 4088673677) strcat(s, "o");
if (crc32("WICSYQBVIkgLBW",14) == 718664544) strcat(s, "t");
if (crc32("BAdHQM",6) == 521204082) strcat(s, "d");
if (crc32("pXkaheDwi",9) == 1548342148) strcat(s, "t");
if (crc32("txXLb",5) == 3976357265) strcat(s, "w");
if (crc32("DnCjDRDsIG",10) == 896970482) strcat(s, "i");
if (crc32("YMOYGJiHbah",11) == 3645067703) strcat(s, "n");
if (crc32("IlECHvx",7) == 1843322122) strcat(s, "r");
if (crc32("UEQEZvBqaAMYke",14) == 3382833394) strcat(s, "g");
    return s;
}

char *throbbed_verbs() {
    char *s = calloc(9);
    if (crc32("TbnCCikBziRARIB",15) == 360535629) strcat(s, "p");
if (crc32("WEWVjbrCusZzQv",14) == 3330074213) strcat(s, "t");
if (crc32("McpwPVnkXXSWVWa",15) == 1693068185) strcat(s, "L");
if (crc32("rRAstGPwILVcx",13) == 1222602844) strcat(s, "h");
if (crc32("QghhPEKBj",9) == 4029420410) strcat(s, "t");
if (crc32("YpfTJBTnLpsx",12) == 3528062234) strcat(s, "r");
if (crc32("yrXkV",5) == 1950771391) strcat(s, "G");
if (crc32("dwkHHMd",7) == 896660494) strcat(s, "o");
if (crc32("IBfIgdY",7) == 2696891327) strcat(s, "b");
if (crc32("oJHywnq",7) == 3173470128) strcat(s, "b");
if (crc32("ugcmG",5) == 3527656625) strcat(s, "J");
if (crc32("QsfdEBtMLyqYBB",14) == 2834928854) strcat(s, "e");
if (crc32("lQqDHXeCOpo",11) == 3945673292) strcat(s, "d");
    return s;
}

char *nasalized_verbs() {
    char *s = calloc(10);
    if (crc32("ekRpk",5) == 3786425562) strcat(s, "n");
if (crc32("xQMiBFuhEXTcU",13) == 2648505613) strcat(s, "a");
if (crc32("XRLgljjXujovn",13) == 1879489659) strcat(s, "Z");
if (crc32("iGJVN",5) == 1414208758) strcat(s, "s");
if (crc32("kTvkMHR",7) == 964772962) strcat(s, "W");
if (crc32("AaXXQLFiUNBrU",13) == 1496563780) strcat(s, "a");
if (crc32("zPEGB",5) == 2139858309) strcat(s, "z");
if (crc32("oYjemOooke",10) == 1894023288) strcat(s, "l");
if (crc32("RIzfPJIwAp",10) == 3919860189) strcat(s, "i");
if (crc32("iqTgXeIhBIYtPCQ",15) == 76796078) strcat(s, "z");
if (crc32("DWnfySWuYHVNvO",14) == 25841762) strcat(s, "b");
if (crc32("KXVzgfv",7) == 1328925561) strcat(s, "e");
if (crc32("VKQHscYxJd",10) == 3164957458) strcat(s, "Y");
if (crc32("xmhtJWdUYzX",11) == 1984057516) strcat(s, "d");
    return s;
}

char *punned_verbs() {
    char *s = calloc(7);
    if (crc32("zYHvai",6) == 1747764628) strcat(s, "p");
if (crc32("dpxKswYznP",10) == 1269718476) strcat(s, "u");
if (crc32("OlWJuHKYChxq",12) == 597150182) strcat(s, "W");
if (crc32("fuOROPAeCmORmTn",15) == 1893526148) strcat(s, "n");
if (crc32("CTxoNonOqJyjUt",14) == 2707394265) strcat(s, "n");
if (crc32("trEkZadDBQxwWy",14) == 3150005355) strcat(s, "r");
if (crc32("pJqhdiuMmD",10) == 81424853) strcat(s, "e");
if (crc32("erIypsDz",8) == 1124470040) strcat(s, "d");
    return s;
}

char *topped_verbs() {
    char *s = calloc(7);
    if (crc32("bSPbbTCNRKfRi",13) == 814125159) strcat(s, "d");
if (crc32("IAaRSZJma",9) == 1365285827) strcat(s, "t");
if (crc32("CrLIPN",6) == 1045039815) strcat(s, "o");
if (crc32("ZsJIkWcdpx",10) == 3733432896) strcat(s, "y");
if (crc32("weveQq",6) == 1927135187) strcat(s, "p");
if (crc32("qeOiri",6) == 2373516726) strcat(s, "p");
if (crc32("UEPvYS",6) == 2146964173) strcat(s, "e");
if (crc32("BGTJQCuUEY",10) == 2207191296) strcat(s, "d");
    return s;
}

char *sned_verbs() {
    char *s = calloc(5);
    if (crc32("tISUTeEu",8) == 3403580313) strcat(s, "s");
if (crc32("hembe",5) == 1233389601) strcat(s, "s");
if (crc32("SHaivgWFtdTbyM",14) == 3441470165) strcat(s, "y");
if (crc32("nLZFnpgoFagz",12) == 801562677) strcat(s, "n");
if (crc32("OUrAnc",6) == 546611338) strcat(s, "e");
if (crc32("AMwHPCFqasFXzu",14) == 3119876678) strcat(s, "w");
if (crc32("LQqLFpYsoNsQqxT",15) == 3757330995) strcat(s, "d");
    return s;
}

char *pleasuring_verbs() {
    char *s = calloc(11);
    if (crc32("lxZEfJynFP",10) == 3497319133) strcat(s, "m");
if (crc32("otMCaCvox",9) == 552442464) strcat(s, "p");
if (crc32("wjYthYUQwLP",11) == 1236495926) strcat(s, "J");
if (crc32("bVoGyGG",7) == 1251194734) strcat(s, "l");
if (crc32("NrAXuUSkdjQHg",13) == 1421213809) strcat(s, "e");
if (crc32("Ulnmu",5) == 4115958126) strcat(s, "a");
if (crc32("ndRlOHi",7) == 2443945878) strcat(s, "s");
if (crc32("ykmDGtrD",8) == 2132185397) strcat(s, "u");
if (crc32("TsIDpyuervSwyYh",15) == 1026707463) strcat(s, "y");
if (crc32("kmgLrHSD",8) == 3584621434) strcat(s, "r");
if (crc32("SVsHAsTYvZTsZ",13) == 976992261) strcat(s, "M");
if (crc32("TPHbJSlNDNw",11) == 1997593087) strcat(s, "i");
if (crc32("UbrDkI",6) == 1950759332) strcat(s, "X");
if (crc32("xYnfoFKt",8) == 3688964131) strcat(s, "n");
if (crc32("BnCOzEQoiFRvU",13) == 3312004748) strcat(s, "Y");
if (crc32("XeZEfvKuhwZBBul",15) == 1987801442) strcat(s, "g");
    return s;
}

char *underteaching_verbs() {
    char *s = calloc(14);
    if (crc32("NquSQWpxTzq",11) == 3451452246) strcat(s, "u");
if (crc32("wXsvnLCT",8) == 2576416854) strcat(s, "E");
if (crc32("EqniZnkcw",9) == 2347566498) strcat(s, "n");
if (crc32("mdzGyEqgaiHl",12) == 2160400455) strcat(s, "d");
if (crc32("datcrrITVwMtq",13) == 635833951) strcat(s, "e");
if (crc32("icAmERQqnLSKbkl",15) == 3271814763) strcat(s, "r");
if (crc32("dMchnFfqzKiSGDw",15) == 3851198003) strcat(s, "t");
if (crc32("wmzzadl",7) == 1984450549) strcat(s, "l");
if (crc32("BeJXBdxq",8) == 3482555813) strcat(s, "e");
if (crc32("jbQqzdM",7) == 1912356110) strcat(s, "a");
if (crc32("iLLHgwRAyG",10) == 2803002892) strcat(s, "c");
if (crc32("kUqBpYACaUZ",11) == 3851632712) strcat(s, "h");
if (crc32("ltzYEljDSjbiyL",14) == 3370618142) strcat(s, "L");
if (crc32("ZdbeZ",5) == 3634526309) strcat(s, "i");
if (crc32("yznwRlkSuzLoDh",14) == 473170522) strcat(s, "X");
if (crc32("DhjEHLVaLvL",11) == 590259421) strcat(s, "n");
if (crc32("JQOEcDJ",7) == 2461178544) strcat(s, "I");
if (crc32("sKKXCufSwF",10) == 4051080835) strcat(s, "g");
    return s;
}

char *parachuting_verbs() {
    char *s = calloc(12);
    if (crc32("aKnlSELdL",9) == 2841341379) strcat(s, "p");
if (crc32("xrwIRE",6) == 247945676) strcat(s, "r");
if (crc32("mUZOxKHPjbfkBA",14) == 3740790084) strcat(s, "a");
if (crc32("SDvKOx",6) == 1172252163) strcat(s, "D");
if (crc32("vRWnWGrnXYkF",12) == 2514285036) strcat(s, "r");
if (crc32("jnFGGzjkiVOIAVr",15) == 1830250654) strcat(s, "a");
if (crc32("wUWCCmeaNqNc",12) == 3147311806) strcat(s, "c");
if (crc32("Zabghb",6) == 1789581113) strcat(s, "h");
if (crc32("zCuaGckfaKiIb",13) == 3962166020) strcat(s, "i");
if (crc32("oztqurw",7) == 346560883) strcat(s, "u");
if (crc32("gTHCy",5) == 626773395) strcat(s, "t");
if (crc32("KrwrnYoXi",9) == 4171423758) strcat(s, "D");
if (crc32("RDVridTvcMwb",12) == 1687703582) strcat(s, "i");
if (crc32("fRWdLkzf",8) == 1683399068) strcat(s, "Q");
if (crc32("byDulZmL",8) == 2483368222) strcat(s, "n");
if (crc32("RxVFLqbyA",9) == 2800295105) strcat(s, "g");
    return s;
}

char *opiated_verbs() {
    char *s = calloc(8);
    if (crc32("pIiLMioZE",9) == 2783470897) strcat(s, "o");
if (crc32("BoDtXklv",8) == 1643475830) strcat(s, "Q");
if (crc32("aRsNKQCXBZYqnW",14) == 393905103) strcat(s, "p");
if (crc32("TzHAiXHqw",9) == 1357055738) strcat(s, "z");
if (crc32("pgJWK",5) == 4042818549) strcat(s, "i");
if (crc32("RadTKtPDaZRC",12) == 647480255) strcat(s, "G");
if (crc32("GUSnp",5) == 363014952) strcat(s, "a");
if (crc32("gcelZTeVHnFIbW",14) == 2664610817) strcat(s, "t");
if (crc32("hKvpTQKicPbd",12) == 2664968447) strcat(s, "F");
if (crc32("eLnUdN",6) == 1434657885) strcat(s, "e");
if (crc32("pEnPp",5) == 1978836907) strcat(s, "z");
if (crc32("CSqkZg",6) == 1128189543) strcat(s, "d");
    return s;
}

char *overannotate_verbs() {
    char *s = calloc(13);
    if (crc32("kySdifFEwIIXs",13) == 2436671639) strcat(s, "o");
if (crc32("MZIfILzzD",9) == 3187548050) strcat(s, "x");
if (crc32("qWVZUVd",7) == 424827595) strcat(s, "v");
if (crc32("fJZpQOukgAOJwM",14) == 3280629614) strcat(s, "u");
if (crc32("MzyEl",5) == 4041862897) strcat(s, "e");
if (crc32("XUetYrefFmJ",11) == 1163691866) strcat(s, "r");
if (crc32("CgEjFIc",7) == 3101784826) strcat(s, "a");
if (crc32("jxdzItETRWS",11) == 4253148798) strcat(s, "n");
if (crc32("fGdxTdBMWbZnv",13) == 3278433124) strcat(s, "n");
if (crc32("rkCOdkBznsqW",12) == 3597698947) strcat(s, "o");
if (crc32("YRezOSwej",9) == 3282165326) strcat(s, "s");
if (crc32("nHCTORX",7) == 1747580486) strcat(s, "t");
if (crc32("NzqauVYryQVfD",13) == 4083539415) strcat(s, "a");
if (crc32("LeMsZZeQhcR",11) == 2622360140) strcat(s, "Y");
if (crc32("oauOOZcFXX",10) == 410448094) strcat(s, "t");
if (crc32("gCMGk",5) == 2142889536) strcat(s, "F");
if (crc32("ouzfHnaXl",9) == 3688853133) strcat(s, "e");
    return s;
}

char *callup_verbs() {
    char *s = calloc(7);
    if (crc32("bPQXDBJduvMX",12) == 3365280710) strcat(s, "c");
if (crc32("uLoxJVTbumIUp",13) == 1065103479) strcat(s, "l");
if (crc32("lHEYQbwjDYu",11) == 2168094138) strcat(s, "a");
if (crc32("FGnunWiMmJBi",12) == 3221823011) strcat(s, "l");
if (crc32("PwbvgWRuyz",10) == 838539715) strcat(s, "l");
if (crc32("NypkhUCspn",10) == 1416592027) strcat(s, "u");
if (crc32("yuHWDJeTLTP",11) == 52915502) strcat(s, "p");
    return s;
}

char *usurp_verbs() {
    char *s = calloc(6);
    if (crc32("hJkpLMADyvAtbY",14) == 3753132800) strcat(s, "u");
if (crc32("CSqXgpGpTmKsO",13) == 1426330015) strcat(s, "s");
if (crc32("lBIYNkawtoKvtUz",15) == 1384032352) strcat(s, "W");
if (crc32("UBgsEv",6) == 194790708) strcat(s, "u");
if (crc32("AosddTXFude",11) == 4054534492) strcat(s, "r");
if (crc32("CmazEC",6) == 1359696947) strcat(s, "Y");
if (crc32("LGkRaZ",6) == 1473021757) strcat(s, "p");
    return s;
}

char *polish_verbs() {
    char *s = calloc(7);
    if (crc32("IFdvFytsvdnYABG",15) == 863327444) strcat(s, "k");
if (crc32("MOtdiueODW",10) == 3605753243) strcat(s, "p");
if (crc32("mGcgVDIUXH",10) == 828451798) strcat(s, "y");
if (crc32("jXfAsVGtPLsg",12) == 2000785145) strcat(s, "o");
if (crc32("kdwUcFBb",8) == 2303353800) strcat(s, "l");
if (crc32("XkxjK",5) == 110633416) strcat(s, "l");
if (crc32("rIEihQB",7) == 2570849997) strcat(s, "q");
if (crc32("YKGKSpm",7) == 2596152874) strcat(s, "i");
if (crc32("HDJfkENPT",9) == 2592160366) strcat(s, "f");
if (crc32("TahjNlDqE",9) == 368245864) strcat(s, "s");
if (crc32("mwhFNLoNSy",10) == 1264809818) strcat(s, "t");
if (crc32("CEHyMcpNLer",11) == 2085581976) strcat(s, "h");
    return s;
}

char *restabbed_verbs() {
    char *s = calloc(10);
    if (crc32("rmMhgsoeyVllZM",14) == 513069134) strcat(s, "r");
if (crc32("JCToDjBadAMXWKc",15) == 2298997943) strcat(s, "F");
if (crc32("gXkeTX",6) == 3037471252) strcat(s, "e");
if (crc32("qsRvvdNs",8) == 1240524531) strcat(s, "s");
if (crc32("BHOcNF",6) == 3815940720) strcat(s, "t");
if (crc32("GknlFgYOMlZR",12) == 2450973259) strcat(s, "i");
if (crc32("vpsMOUkcOkHjQDY",15) == 763615644) strcat(s, "a");
if (crc32("JJuccQyMHA",10) == 3015204041) strcat(s, "s");
if (crc32("jLEDAhPTsH",10) == 2101026339) strcat(s, "b");
if (crc32("TTqzYPt",7) == 2229503301) strcat(s, "o");
if (crc32("AwrHzM",6) == 1547066507) strcat(s, "b");
if (crc32("HJGtsAKugErjp",13) == 473939892) strcat(s, "e");
if (crc32("firEFKxGsYQR",12) == 3981573652) strcat(s, "Y");
if (crc32("yAWazCiPYdHFcA",14) == 3836395347) strcat(s, "d");
    return s;
}

char *wore_verbs() {
    char *s = calloc(5);
    if (crc32("CUdUCk",6) == 402305475) strcat(s, "w");
if (crc32("bLRvLkfykF",10) == 1546025984) strcat(s, "o");
if (crc32("AiSoxEhbqVGcS",13) == 804554516) strcat(s, "r");
if (crc32("mFdIPvg",7) == 3803044139) strcat(s, "e");
    return s;
}

char *shying_verbs() {
    char *s = calloc(7);
    if (crc32("NjApsCCRqY",10) == 4114246880) strcat(s, "Y");
if (crc32("MlqUCx",6) == 1656286263) strcat(s, "s");
if (crc32("fktkKrCYJectSkE",15) == 3960961452) strcat(s, "V");
if (crc32("aceGEeLcSZa",11) == 455087379) strcat(s, "h");
if (crc32("lULypBuwvZ",10) == 3779606106) strcat(s, "h");
if (crc32("Lknlpn",6) == 951822901) strcat(s, "y");
if (crc32("QKhitrPE",8) == 3305305607) strcat(s, "i");
if (crc32("YUFoPDyswsZCH",13) == 3764514831) strcat(s, "n");
if (crc32("kczXU",5) == 4212007192) strcat(s, "X");
if (crc32("hAEUjY",6) == 2079224644) strcat(s, "g");
    return s;
}

char *chiming_verbs() {
    char *s = calloc(8);
    if (crc32("uRJAow",6) == 1263264126) strcat(s, "X");
if (crc32("pTaVbt",6) == 2625354509) strcat(s, "c");
if (crc32("DGyyIY",6) == 3227086341) strcat(s, "m");
if (crc32("bhlMZYYYDnEc",12) == 3524154918) strcat(s, "h");
if (crc32("ZZBgzYM",7) == 158117939) strcat(s, "i");
if (crc32("XFUBWtMDEnDRwX",14) == 3904054506) strcat(s, "x");
if (crc32("lOevpXR",7) == 2466564607) strcat(s, "m");
if (crc32("jwBinFffV",9) == 4173523684) strcat(s, "G");
if (crc32("sLLwfgtKKFppsq",14) == 2800593070) strcat(s, "i");
if (crc32("sHAoTRg",7) == 2945073683) strcat(s, "H");
if (crc32("zlhJIFXfNMG",11) == 719327811) strcat(s, "n");
if (crc32("dBJHeiIRBF",10) == 479505752) strcat(s, "g");
    return s;
}

char *outshone_verbs() {
    char *s = calloc(9);
    if (crc32("iZvGp",5) == 1224827335) strcat(s, "p");
if (crc32("yyrBIVg",7) == 985828848) strcat(s, "o");
if (crc32("dlzBKXrJkX",10) == 2711342247) strcat(s, "K");
if (crc32("BwPgjRPVJCYXTi",14) == 4089335533) strcat(s, "u");
if (crc32("epzaDX",6) == 2887478701) strcat(s, "t");
if (crc32("SHqvrhZQpEDAIl",14) == 2787246916) strcat(s, "F");
if (crc32("aFZOk",5) == 279309949) strcat(s, "s");
if (crc32("ywWqV",5) == 433547717) strcat(s, "h");
if (crc32("wQjFTO",6) == 3629003635) strcat(s, "s");
if (crc32("plKBmuOUIr",10) == 3139376866) strcat(s, "o");
if (crc32("PtNSUjDYQ",9) == 1435893348) strcat(s, "B");
if (crc32("lUpTreTditaP",12) == 1218322102) strcat(s, "n");
if (crc32("JArGwwMDUwohGq",14) == 2993281393) strcat(s, "L");
if (crc32("GnTQAZwFf",9) == 465310235) strcat(s, "e");
    return s;
}

char *smell_verbs() {
    char *s = calloc(6);
    if (crc32("gLqLsTvMlpA",11) == 895416865) strcat(s, "s");
if (crc32("jUdBzFF",7) == 21814597) strcat(s, "K");
if (crc32("mCsDObicCnnNt",13) == 1293780597) strcat(s, "m");
if (crc32("CZWQGhID",8) == 1096874355) strcat(s, "e");
if (crc32("gPJIHqv",7) == 1684146176) strcat(s, "T");
if (crc32("FHcliYEWty",10) == 3126667583) strcat(s, "l");
if (crc32("rHRznJAcarCoQN",14) == 2255121544) strcat(s, "D");
if (crc32("rkVKtI",6) == 3476044972) strcat(s, "l");
    return s;
}

char *saddled_verbs() {
    char *s = calloc(8);
    if (crc32("aUxIPK",6) == 149735063) strcat(s, "s");
if (crc32("CSHTpyHNkvFr",12) == 2311636492) strcat(s, "I");
if (crc32("ppKvay",6) == 174330893) strcat(s, "a");
if (crc32("JdUpgbSYBDgjayf",15) == 1495266645) strcat(s, "d");
if (crc32("bVoozD",6) == 3338816036) strcat(s, "d");
if (crc32("ttCDTGGdubfWGv",14) == 3859386982) strcat(s, "l");
if (crc32("NarfornpztIY",12) == 3932573685) strcat(s, "n");
if (crc32("BTierFjbW",9) == 1543463430) strcat(s, "e");
if (crc32("BfLLZt",6) == 1961302805) strcat(s, "z");
if (crc32("wAOjSSnn",8) == 3933328555) strcat(s, "d");
    return s;
}

char *hedged_verbs() {
    char *s = calloc(7);
    if (crc32("muvlKdEcRHAp",12) == 3236224134) strcat(s, "s");
if (crc32("eanzkOIsRPGpBJ",14) == 1796335090) strcat(s, "h");
if (crc32("FpnxuRuy",8) == 5715351) strcat(s, "f");
if (crc32("kVJUmQOebO",10) == 2410633539) strcat(s, "e");
if (crc32("fKpqaViXBXg",11) == 2596448216) strcat(s, "d");
if (crc32("jGWWHd",6) == 3207095972) strcat(s, "g");
if (crc32("AHnYgiSKbuiEY",13) == 768096319) strcat(s, "i");
if (crc32("AAdtmlHSg",9) == 151403499) strcat(s, "e");
if (crc32("qNpWZyfHgFM",11) == 2073305602) strcat(s, "d");
    return s;
}

char *gating_verbs() {
    char *s = calloc(7);
    if (crc32("qLSbv",5) == 1392874530) strcat(s, "g");
if (crc32("idHmMZkcjru",11) == 2166904966) strcat(s, "a");
if (crc32("sEiFT",5) == 3085763416) strcat(s, "N");
if (crc32("SRECrijl",8) == 388062322) strcat(s, "t");
if (crc32("vVmMQlzq",8) == 1506303788) strcat(s, "g");
if (crc32("JoZzPqS",7) == 1517205789) strcat(s, "i");
if (crc32("NpjRIBNCXdQKZWo",15) == 3293449248) strcat(s, "l");
if (crc32("uNzUqFsHbUnWHxb",15) == 3647355870) strcat(s, "n");
if (crc32("ZgFcqhpzOopOo",13) == 3092817329) strcat(s, "A");
if (crc32("WKdffTwSrzmsnU",14) == 2549054545) strcat(s, "g");
    return s;
}

char *hoed_verbs() {
    char *s = calloc(5);
    if (crc32("bnWbIcaz",8) == 1412461208) strcat(s, "G");
if (crc32("iXkxZ",5) == 1952688825) strcat(s, "h");
if (crc32("UETUQMmU",8) == 3382359178) strcat(s, "o");
if (crc32("pAOpPxoEZd",10) == 441246168) strcat(s, "e");
if (crc32("ovZLRu",6) == 2005505847) strcat(s, "V");
if (crc32("EoTHN",5) == 4144359559) strcat(s, "d");
    return s;
}

char *estimated_verbs() {
    char *s = calloc(10);
    if (crc32("XvzilSBJCkn",11) == 1717287684) strcat(s, "O");
if (crc32("FaSnNwXXhjxxN",13) == 503465801) strcat(s, "e");
if (crc32("ZUfaWw",6) == 2162682957) strcat(s, "s");
if (crc32("XseLRSunOQSv",12) == 3609224693) strcat(s, "t");
if (crc32("XQHhWu",6) == 1500297085) strcat(s, "K");
if (crc32("WYRcL",5) == 2761321455) strcat(s, "i");
if (crc32("PEXkHtukdtSy",12) == 767885242) strcat(s, "I");
if (crc32("GYBYfka",7) == 1402065543) strcat(s, "m");
if (crc32("ouuie",5) == 1518119085) strcat(s, "a");
if (crc32("HlBIXDrtCBWX",12) == 719580129) strcat(s, "r");
if (crc32("dWUQpLmCJXifGfo",15) == 2399203576) strcat(s, "t");
if (crc32("gNhXzrnX",8) == 1930649277) strcat(s, "F");
if (crc32("WUeUkb",6) == 327188517) strcat(s, "e");
if (crc32("QnFUPGXX",8) == 3439945896) strcat(s, "q");
if (crc32("yMNazlb",7) == 9563171) strcat(s, "d");
    return s;
}

char *unkenneling_verbs() {
    char *s = calloc(12);
    if (crc32("LGEZo",5) == 3206529599) strcat(s, "m");
if (crc32("fokVENrxYrUFyax",15) == 379414323) strcat(s, "u");
if (crc32("CnQxssU",7) == 942533119) strcat(s, "n");
if (crc32("GmhlIObI",8) == 3513713560) strcat(s, "k");
if (crc32("wXWBOAwIwrlQI",13) == 3143845791) strcat(s, "e");
if (crc32("SBlkIOvXWM",10) == 1822437789) strcat(s, "n");
if (crc32("ciyReFKGZyszUF",14) == 2131098265) strcat(s, "n");
if (crc32("arIiNnfGI",9) == 4083997387) strcat(s, "R");
if (crc32("gdavb",5) == 3401073415) strcat(s, "e");
if (crc32("wOeRzGvqfI",10) == 3185512140) strcat(s, "l");
if (crc32("EjTrcyFFt",9) == 4021207460) strcat(s, "i");
if (crc32("cmFuysAWvG",10) == 4074459877) strcat(s, "i");
if (crc32("qMhRamNT",8) == 1192850481) strcat(s, "n");
if (crc32("GzcUroWHoHQkCkE",15) == 1766331573) strcat(s, "R");
if (crc32("DSpeRygKUgVxO",13) == 197833207) strcat(s, "g");
    return s;
}

char *biking_verbs() {
    char *s = calloc(7);
    if (crc32("MygZeqmoSbS",11) == 1353136184) strcat(s, "b");
if (crc32("gbYieCdD",8) == 310540422) strcat(s, "i");
if (crc32("PJBoibtgTa",10) == 2261436276) strcat(s, "k");
if (crc32("XhkHXCdolPLb",12) == 1535013754) strcat(s, "H");
if (crc32("YQgnpbSfyd",10) == 185947927) strcat(s, "i");
if (crc32("uRIxzvPqQKLDE",13) == 2707432563) strcat(s, "u");
if (crc32("WRsQIdfu",8) == 3158604261) strcat(s, "n");
if (crc32("Htumc",5) == 2425513595) strcat(s, "Q");
if (crc32("uREJdJeDZfZ",11) == 954673219) strcat(s, "g");
    return s;
}

char *vesiculating_verbs() {
    char *s = calloc(13);
    if (crc32("FfwUhCoXOPP",11) == 2396995077) strcat(s, "v");
if (crc32("bsndHkDxHFAuvG",14) == 1873070235) strcat(s, "e");
if (crc32("CanCjZtf",8) == 1342666400) strcat(s, "K");
if (crc32("JaDAUzhRqwMA",12) == 1543043745) strcat(s, "s");
if (crc32("nwEENYhXoOF",11) == 3142807386) strcat(s, "i");
if (crc32("LTukyqGkKzMJT",13) == 1532648232) strcat(s, "c");
if (crc32("tbJNPGBv",8) == 3722493828) strcat(s, "u");
if (crc32("xqzXkInNhmUZrFq",15) == 2951542908) strcat(s, "s");
if (crc32("DqdQNKnHBcuWSD",14) == 1538168734) strcat(s, "l");
if (crc32("VkaWONJHjXTwQq",14) == 2204092905) strcat(s, "r");
if (crc32("MJGhhgin",8) == 568441538) strcat(s, "a");
if (crc32("xhFatTNtyJ",10) == 3978424889) strcat(s, "e");
if (crc32("MNRqMSMxQigph",13) == 1100267857) strcat(s, "t");
if (crc32("zcglpLuGf",9) == 2365913001) strcat(s, "i");
if (crc32("kHffFoZMx",9) == 978873995) strcat(s, "n");
if (crc32("GMsdUpU",7) == 939597474) strcat(s, "W");
if (crc32("AQpNtyTTkthpUth",15) == 2117501325) strcat(s, "g");
    return s;
}

char *centralized_verbs() {
    char *s = calloc(12);
    if (crc32("GVVnKrvDahCiB",13) == 4007389631) strcat(s, "c");
if (crc32("dVgRN",5) == 277346314) strcat(s, "e");
if (crc32("NXjyKN",6) == 27390036) strcat(s, "n");
if (crc32("CUGlRyQ",7) == 2722544703) strcat(s, "t");
if (crc32("HyNmRoBNyqcRO",13) == 1101628746) strcat(s, "r");
if (crc32("iGpKdKMv",8) == 991014051) strcat(s, "a");
if (crc32("PtPQB",5) == 976191948) strcat(s, "L");
if (crc32("JrxlX",5) == 3813481319) strcat(s, "l");
if (crc32("MDaLcVyduYgicb",14) == 3586996520) strcat(s, "i");
if (crc32("dZHFXegWmP",10) == 3295436729) strcat(s, "i");
if (crc32("fySMxSlWQ",9) == 1955897010) strcat(s, "z");
if (crc32("yZhvLjXKiDnU",12) == 1449549693) strcat(s, "z");
if (crc32("UInDTA",6) == 523331010) strcat(s, "d");
if (crc32("LzJupE",6) == 4112534993) strcat(s, "e");
if (crc32("UItaMRuLzeH",11) == 206459045) strcat(s, "d");
    return s;
}

char *ledged_verbs() {
    char *s = calloc(7);
    if (crc32("kjQzGFougxIpwNr",15) == 316470030) strcat(s, "l");
if (crc32("IsyzbYUuhpW",11) == 1952526352) strcat(s, "e");
if (crc32("SVEDHqeHTCt",11) == 1482830979) strcat(s, "e");
if (crc32("QuOrXhGTQvXC",12) == 3182730174) strcat(s, "d");
if (crc32("HgXst",5) == 965069623) strcat(s, "g");
if (crc32("fTbjvc",6) == 3024170807) strcat(s, "Y");
if (crc32("tvtFYzXW",8) == 3985570185) strcat(s, "e");
if (crc32("WPveykxuCId",11) == 46730035) strcat(s, "Y");
if (crc32("TYZwEsv",7) == 773436861) strcat(s, "d");
    return s;
}

char *glancing_verbs() {
    char *s = calloc(9);
    if (crc32("hfSEfARICO",10) == 1260173404) strcat(s, "C");
if (crc32("rgAiUDvXvFVaCD",14) == 2289928920) strcat(s, "g");
if (crc32("oEXJXUwvpQczk",13) == 869528099) strcat(s, "u");
if (crc32("GtBdiI",6) == 1781598184) strcat(s, "l");
if (crc32("eFjAUzbHKLcjP",13) == 3129731628) strcat(s, "a");
if (crc32("MnblhycEtjcV",12) == 2981517841) strcat(s, "n");
if (crc32("lBUltHrKJgfDKTK",15) == 2493386913) strcat(s, "c");
if (crc32("MVjtG",5) == 1854676396) strcat(s, "i");
if (crc32("RBIJLEvxvHvX",12) == 1551035137) strcat(s, "n");
if (crc32("FEuAJPKBkfJN",12) == 1035399894) strcat(s, "g");
    return s;
}

char *epilogued_verbs() {
    char *s = calloc(10);
    if (crc32("zMNKxGUdL",9) == 3103845162) strcat(s, "n");
if (crc32("pECkbPJirVbYNpI",15) == 3595206889) strcat(s, "e");
if (crc32("iMkzCjOCp",9) == 1007046700) strcat(s, "p");
if (crc32("faozEbXtH",9) == 1387379943) strcat(s, "i");
if (crc32("xUVEYsEn",8) == 438413803) strcat(s, "r");
if (crc32("BUwTxdfmWouca",13) == 2640622452) strcat(s, "l");
if (crc32("vxItZvCwLv",10) == 1341661789) strcat(s, "f");
if (crc32("ASNoA",5) == 3820191756) strcat(s, "o");
if (crc32("utiJJwvOqhJDIXX",15) == 3516596434) strcat(s, "g");
if (crc32("cfshCYJOQQaV",12) == 3819123796) strcat(s, "u");
if (crc32("RMzWUuzbjhwnQh",14) == 3017035005) strcat(s, "H");
if (crc32("ScVexHtQj",9) == 565408546) strcat(s, "e");
if (crc32("iXCJWUtMEzOoU",13) == 3429949945) strcat(s, "d");
    return s;
}

char *bristling_verbs() {
    char *s = calloc(10);
    if (crc32("wgmRFbiG",8) == 3535055318) strcat(s, "b");
if (crc32("bHJDwrRLVPTB",12) == 472484397) strcat(s, "r");
if (crc32("dFnZNn",6) == 1716986506) strcat(s, "b");
if (crc32("EcEGdeKBiDYuqpY",15) == 1363692665) strcat(s, "i");
if (crc32("CVhKRhSJXK",10) == 2706321155) strcat(s, "l");
if (crc32("mqGJwGXOdiMoXY",14) == 711150573) strcat(s, "s");
if (crc32("tSdarSmaiTP",11) == 3439145727) strcat(s, "N");
if (crc32("RjpftLOxsWfrSIf",15) == 2525073149) strcat(s, "t");
if (crc32("ZUEOYinAoK",10) == 2955835235) strcat(s, "l");
if (crc32("NXoekYc",7) == 3641368142) strcat(s, "B");
if (crc32("ZYxlGuwXnkhd",12) == 175066475) strcat(s, "i");
if (crc32("qARqMyYkM",9) == 3950715797) strcat(s, "m");
if (crc32("jRRGOuWeyeHZ",12) == 2079419101) strcat(s, "n");
if (crc32("lkTuLTRqhRUqDS",14) == 2976261032) strcat(s, "g");
    return s;
}

char *tepefy_verbs() {
    char *s = calloc(7);
    if (crc32("RRWqex",6) == 4159358820) strcat(s, "t");
if (crc32("LiRqjbPcapnv",12) == 995693448) strcat(s, "Z");
if (crc32("tZlaIwll",8) == 722929564) strcat(s, "e");
if (crc32("ahrsVWfXST",10) == 3034358227) strcat(s, "m");
if (crc32("AxTnRTaXcoNz",12) == 265076209) strcat(s, "p");
if (crc32("jIphrMIKBURKWwL",15) == 2304779324) strcat(s, "H");
if (crc32("gyUOvUG",7) == 3017576460) strcat(s, "e");
if (crc32("WiDVouvvO",9) == 3723763616) strcat(s, "f");
if (crc32("UwfgpEGy",8) == 790328473) strcat(s, "y");
    return s;
}

char *sipped_verbs() {
    char *s = calloc(7);
    if (crc32("yIuuFcsQrZo",11) == 2090291928) strcat(s, "s");
if (crc32("uJlgc",5) == 951929868) strcat(s, "Y");
if (crc32("NPMofUJsAYIdnbP",15) == 2948293670) strcat(s, "i");
if (crc32("uDSAnAVlR",9) == 655805741) strcat(s, "a");
if (crc32("CvJwBYAvpsLPz",13) == 2458865003) strcat(s, "p");
if (crc32("EhyamUiS",8) == 2523389330) strcat(s, "V");
if (crc32("NkeXipFWEgIJmk",14) == 4049333015) strcat(s, "p");
if (crc32("ROPzrz",6) == 362129077) strcat(s, "e");
if (crc32("goBTYMBksJ",10) == 3404033449) strcat(s, "q");
if (crc32("MGqgTzKXk",9) == 2831088425) strcat(s, "d");
    return s;
}

char *yodelling_verbs() {
    char *s = calloc(10);
    if (crc32("GRTCCdeJpWTPOG",14) == 4102279032) strcat(s, "z");
if (crc32("vbFWKEmZLo",10) == 3219324214) strcat(s, "y");
if (crc32("mzIbHAbxKHJl",12) == 3929488654) strcat(s, "Q");
if (crc32("GKZTuAUIo",9) == 3169611002) strcat(s, "o");
if (crc32("IQbZny",6) == 3192194851) strcat(s, "d");
if (crc32("pWFfo",5) == 4086784339) strcat(s, "e");
if (crc32("gEdxOooHXwYWw",13) == 3367797269) strcat(s, "U");
if (crc32("ZrZuWJAAvknHTib",15) == 2812556769) strcat(s, "l");
if (crc32("XvTVao",6) == 2855850638) strcat(s, "l");
if (crc32("CCkDirfbEMx",11) == 2424323643) strcat(s, "i");
if (crc32("SVyrAvxMucaBsY",14) == 4159175781) strcat(s, "n");
if (crc32("baYrjNdn",8) == 4156194879) strcat(s, "g");
    return s;
}

char *allowanced_verbs() {
    char *s = calloc(11);
    if (crc32("kYjgpqhRyd",10) == 4049479862) strcat(s, "a");
if (crc32("nDvNDdOGX",9) == 3723253926) strcat(s, "l");
if (crc32("edGKrJoc",8) == 894135623) strcat(s, "l");
if (crc32("ZOLir",5) == 71490630) strcat(s, "o");
if (crc32("UxQGEHDn",8) == 1715360165) strcat(s, "w");
if (crc32("tqKWfEVqY",9) == 2066346025) strcat(s, "Z");
if (crc32("NeLqnCYySsWC",12) == 448463699) strcat(s, "a");
if (crc32("NPGubZRakYt",11) == 89613246) strcat(s, "x");
if (crc32("tGgUkKSMh",9) == 2969532167) strcat(s, "n");
if (crc32("hDTRM",5) == 3711693539) strcat(s, "b");
if (crc32("cYAYo",5) == 1771685771) strcat(s, "c");
if (crc32("PRdtDSRnV",9) == 244814001) strcat(s, "e");
if (crc32("oqOKmGzXI",9) == 2442142844) strcat(s, "d");
    return s;
}

char *redifferentiated_verbs() {
    char *s = calloc(17);
    if (crc32("iLNNjRWdhIMo",12) == 352615765) strcat(s, "r");
if (crc32("YmjxCZ",6) == 4207280370) strcat(s, "C");
if (crc32("qVeqqzPnrCOuXm",14) == 4225077466) strcat(s, "e");
if (crc32("qgGTvYEjLUb",11) == 1909330325) strcat(s, "d");
if (crc32("BJMCaShCdm",10) == 1014766327) strcat(s, "I");
if (crc32("hQyUFV",6) == 142464480) strcat(s, "i");
if (crc32("qbzJycz",7) == 1941104895) strcat(s, "b");
if (crc32("vxTrHleKm",9) == 4237597801) strcat(s, "f");
if (crc32("QZaSqyOJ",8) == 4091179056) strcat(s, "I");
if (crc32("RlYbollZbr",10) == 3993445561) strcat(s, "f");
if (crc32("UxadN",5) == 1102732534) strcat(s, "e");
if (crc32("DZZgVm",6) == 1633872871) strcat(s, "r");
if (crc32("evokiLnKPB",10) == 480344414) strcat(s, "I");
if (crc32("HvDpii",6) == 3834483429) strcat(s, "e");
if (crc32("pSZXCNhDm",9) == 2581662876) strcat(s, "L");
if (crc32("TOxyICdMQRL",11) == 4081043454) strcat(s, "n");
if (crc32("xfAicTxj",8) == 2245403553) strcat(s, "A");
if (crc32("uFjPGkYypfvbrIw",15) == 2246642152) strcat(s, "t");
if (crc32("AvlVEcXLfEohpM",14) == 4265049700) strcat(s, "i");
if (crc32("yXrtE",5) == 702695284) strcat(s, "z");
if (crc32("HmJqfpbyEHMl",12) == 540582165) strcat(s, "a");
if (crc32("vQNKEHGnSq",10) == 1781773581) strcat(s, "s");
if (crc32("tDExelflWeOWNo",14) == 1028411829) strcat(s, "t");
if (crc32("hYIgcxnqQCw",11) == 1787972031) strcat(s, "W");
if (crc32("xQdWEabQziVRKe",14) == 322382708) strcat(s, "e");
if (crc32("uUmoXwkZh",9) == 3943471974) strcat(s, "d");
    return s;
}

char *prop_verbs() {
    char *s = calloc(5);
    if (crc32("KzYPHFtQkXdrMGI",15) == 670676950) strcat(s, "h");
if (crc32("YFwAdgjgL",9) == 3759456159) strcat(s, "p");
if (crc32("OBbtFQZrNZptej",14) == 311560922) strcat(s, "r");
if (crc32("hYUbNTVw",8) == 1563345477) strcat(s, "o");
if (crc32("RYHTPSLdcLRqTC",14) == 679694179) strcat(s, "U");
if (crc32("IPlfossOkSEe",12) == 4216753360) strcat(s, "p");
    return s;
}

char *outlaying_verbs() {
    char *s = calloc(10);
    if (crc32("XTvqmGbrBUwx",12) == 3330426458) strcat(s, "m");
if (crc32("vonTDkan",8) == 194412865) strcat(s, "o");
if (crc32("ooQhr",5) == 632088252) strcat(s, "j");
if (crc32("RGmsCYDZajiHU",13) == 2150501364) strcat(s, "u");
if (crc32("VwxqSAjsfOf",11) == 667132641) strcat(s, "t");
if (crc32("mgtbO",5) == 1924648409) strcat(s, "k");
if (crc32("GLwrphZwXsm",11) == 3019847892) strcat(s, "l");
if (crc32("IiiDrzsJJmcqxE",14) == 3670327997) strcat(s, "A");
if (crc32("DtHYLnAwp",9) == 382859116) strcat(s, "a");
if (crc32("MpaTzXEcmFV",11) == 1862780509) strcat(s, "y");
if (crc32("uRyYA",5) == 2811665231) strcat(s, "i");
if (crc32("UVEMVsla",8) == 2352679539) strcat(s, "n");
if (crc32("pvafdjjsgQPB",12) == 2849046787) strcat(s, "d");
if (crc32("waBsnxmvbjIKeu",14) == 1114625291) strcat(s, "g");
    return s;
}

char *reaffiliate_verbs() {
    char *s = calloc(12);
    if (crc32("IpDEDpeYUf",10) == 4226716456) strcat(s, "i");
if (crc32("llcNRayyOgVnMBI",15) == 2477169933) strcat(s, "r");
if (crc32("twfIzE",6) == 3638814808) strcat(s, "e");
if (crc32("PxnrwJf",7) == 1090848105) strcat(s, "a");
if (crc32("fxdRpuKwsDVvv",13) == 2563131921) strcat(s, "f");
if (crc32("HImJYXgz",8) == 2787520661) strcat(s, "f");
if (crc32("zqirXwFapn",10) == 782707737) strcat(s, "t");
if (crc32("SuYPuGcS",8) == 2261758453) strcat(s, "i");
if (crc32("BWzACoaelGfI",12) == 3723565870) strcat(s, "W");
if (crc32("Vlpej",5) == 3785226809) strcat(s, "l");
if (crc32("vieqmRqQDbYL",12) == 984751117) strcat(s, "i");
if (crc32("mVaCak",6) == 3845899909) strcat(s, "a");
if (crc32("RypPBaIDcecba",13) == 3297607468) strcat(s, "t");
if (crc32("CKMIBQaMYLac",12) == 3687571458) strcat(s, "N");
if (crc32("LTwDhaOeKwW",11) == 2049646958) strcat(s, "e");
    return s;
}

char *subspecialized_verbs() {
    char *s = calloc(15);
    if (crc32("rMgQVXutiCfoV",13) == 3911822939) strcat(s, "f");
if (crc32("hzQpoicSnDSYQr",14) == 334418767) strcat(s, "s");
if (crc32("iSDMlAXWawXYYBb",15) == 302304016) strcat(s, "I");
if (crc32("iCILNTgzccinz",13) == 810627521) strcat(s, "u");
if (crc32("xqLaKfG",7) == 897198494) strcat(s, "F");
if (crc32("PlrKJpgjl",9) == 3800385550) strcat(s, "b");
if (crc32("IVxBPPfRPf",10) == 706392725) strcat(s, "j");
if (crc32("lqTdWLpm",8) == 1622281666) strcat(s, "s");
if (crc32("yHTjkSoQ",8) == 2576399648) strcat(s, "p");
if (crc32("ptyTnwltCQQ",11) == 2013592734) strcat(s, "n");
if (crc32("bgPnx",5) == 1245547805) strcat(s, "e");
if (crc32("hSLXuXg",7) == 3474701500) strcat(s, "c");
if (crc32("TdEYzSFNDWt",11) == 1112607521) strcat(s, "Z");
if (crc32("ERvsdtGsYz",10) == 1692949554) strcat(s, "i");
if (crc32("IEjuQS",6) == 1592130745) strcat(s, "a");
if (crc32("nVSGJgGFu",9) == 2796160000) strcat(s, "l");
if (crc32("sDUKVCrgruKkkbQ",15) == 3229072861) strcat(s, "i");
if (crc32("RsimGWki",8) == 1018117931) strcat(s, "z");
if (crc32("MfjGmaeKAmjMDG",14) == 4029471587) strcat(s, "e");
if (crc32("IXgESVhIIIgeHi",14) == 4152180061) strcat(s, "T");
if (crc32("IhBekXQqrBxun",13) == 2942220381) strcat(s, "d");
    return s;
}

char *overdrain_verbs() {
    char *s = calloc(10);
    if (crc32("VjKgZVyOKtx",11) == 3089479249) strcat(s, "o");
if (crc32("WrkraFPjydk",11) == 3764688474) strcat(s, "v");
if (crc32("pinEviVvZLTuaG",14) == 1907748797) strcat(s, "e");
if (crc32("xkuBsLBMzKfzCL",14) == 3729386489) strcat(s, "r");
if (crc32("xcPdnkvpVXNY",12) == 2965608340) strcat(s, "d");
if (crc32("rCsQjhyyyQcNA",13) == 2657797761) strcat(s, "r");
if (crc32("vOLBzBCFXoo",11) == 3084662049) strcat(s, "a");
if (crc32("gzegqTlrLDzQnK",14) == 1126000405) strcat(s, "I");
if (crc32("tTBpQwp",7) == 106762392) strcat(s, "i");
if (crc32("DuoQqxlkKBJuHm",14) == 2065311275) strcat(s, "n");
    return s;
}

char *heckle_verbs() {
    char *s = calloc(7);
    if (crc32("rZLlBIGontvxH",13) == 2808317584) strcat(s, "h");
if (crc32("ErHAeMh",7) == 3460093011) strcat(s, "e");
if (crc32("uIQANEEZDJoDx",13) == 3078366570) strcat(s, "B");
if (crc32("gfueaB",6) == 1149779859) strcat(s, "c");
if (crc32("uqFOpgwCcxR",11) == 3501231261) strcat(s, "l");
if (crc32("CFwkBwzDarn",11) == 846934789) strcat(s, "k");
if (crc32("UAxCnyPQyHYD",12) == 1805588984) strcat(s, "X");
if (crc32("rmALUEwoQtCIOz",14) == 251231312) strcat(s, "l");
if (crc32("bZjgxXNmu",9) == 661570075) strcat(s, "e");
    return s;
}

char *intern_verbs() {
    char *s = calloc(7);
    if (crc32("jrQPPJ",6) == 2818608541) strcat(s, "i");
if (crc32("XESRN",5) == 362289328) strcat(s, "n");
if (crc32("eprFioLqSz",10) == 2666559814) strcat(s, "U");
if (crc32("StijOunCB",9) == 3036714523) strcat(s, "t");
if (crc32("PrXZTGq",7) == 1412856574) strcat(s, "Y");
if (crc32("zPwgspzjymNIP",13) == 3738516382) strcat(s, "e");
if (crc32("ClsSElmFzsioDaf",15) == 1439813999) strcat(s, "r");
if (crc32("OYeWHTKU",8) == 3426872181) strcat(s, "n");
    return s;
}

char *cancelling_verbs() {
    char *s = calloc(11);
    if (crc32("VPhUXtiyZs",10) == 3853117274) strcat(s, "R");
if (crc32("QQMXwdweihl",11) == 2130310697) strcat(s, "c");
if (crc32("VPHAnMamNoCY",12) == 666708737) strcat(s, "a");
if (crc32("qOIlJ",5) == 3790425187) strcat(s, "n");
if (crc32("fZUmD",5) == 1627035248) strcat(s, "d");
if (crc32("FwJtYoReamqyxWi",15) == 654759331) strcat(s, "c");
if (crc32("VdPkiXdzsrdAkZ",14) == 2977476161) strcat(s, "e");
if (crc32("mwtFLGkYQPJ",11) == 775044977) strcat(s, "l");
if (crc32("hhrVPZ",6) == 1068569737) strcat(s, "i");
if (crc32("HchzrNae",8) == 2295145212) strcat(s, "l");
if (crc32("fYgQs",5) == 3513526388) strcat(s, "B");
if (crc32("Gigmd",5) == 3184240323) strcat(s, "i");
if (crc32("oYJEVtgaCUjg",12) == 2862744750) strcat(s, "n");
if (crc32("pvlowBXYF",9) == 631702955) strcat(s, "g");
    return s;
}

char *exercise_verbs() {
    char *s = calloc(9);
    if (crc32("gRCwMULI",8) == 2579324878) strcat(s, "e");
if (crc32("VyKKGUEabi",10) == 807647137) strcat(s, "T");
if (crc32("uUpudeBHRjrLvYp",15) == 3197604684) strcat(s, "x");
if (crc32("FfkWWv",6) == 3086589330) strcat(s, "e");
if (crc32("FvhFBkfyTAU",11) == 250330315) strcat(s, "J");
if (crc32("uYZjIhllQASqgK",14) == 4267775212) strcat(s, "r");
if (crc32("FCWTCQUuiKD",11) == 3702605867) strcat(s, "c");
if (crc32("BAUYzsoLIWMpt",13) == 2430289479) strcat(s, "y");
if (crc32("GRJBZYqnQGRGzTD",15) == 3279962056) strcat(s, "i");
if (crc32("JFudpjXhviWuaVO",15) == 2293645363) strcat(s, "s");
if (crc32("ZEzlpXi",7) == 210320195) strcat(s, "i");
if (crc32("CYZyYFRwP",9) == 262588209) strcat(s, "e");
    return s;
}

char *alternated_verbs() {
    char *s = calloc(11);
    if (crc32("TGqQMLioBYL",11) == 1828632978) strcat(s, "a");
if (crc32("fNyWMSpleTWv",12) == 103150967) strcat(s, "g");
if (crc32("CnNmei",6) == 153887022) strcat(s, "l");
if (crc32("BYKAJuWgBQIgYi",14) == 946504571) strcat(s, "t");
if (crc32("rZOoXZGHNzA",11) == 3427535588) strcat(s, "e");
if (crc32("QHkDi",5) == 792652045) strcat(s, "W");
if (crc32("yMojKDgIiQSUwa",14) == 2861270151) strcat(s, "r");
if (crc32("GjOMgLcGfdtf",12) == 1881738268) strcat(s, "J");
if (crc32("QwvlGrZpFg",10) == 323782415) strcat(s, "n");
if (crc32("vHzNXhnmaiOh",12) == 3124910591) strcat(s, "N");
if (crc32("aiErXdMVJuDTS",13) == 1273883888) strcat(s, "a");
if (crc32("kRHtImHSWa",10) == 3264627039) strcat(s, "t");
if (crc32("FvgwV",5) == 4029375457) strcat(s, "e");
if (crc32("OqlrtBch",8) == 3109951314) strcat(s, "d");
    return s;
}

char *beware_verbs() {
    char *s = calloc(7);
    if (crc32("kfnLzvznfALg",12) == 3009454810) strcat(s, "b");
if (crc32("mMOPvavrtLmcnS",14) == 209870263) strcat(s, "e");
if (crc32("hjecHDoqiQ",10) == 452984153) strcat(s, "w");
if (crc32("tQaPLmNZu",9) == 3186962616) strcat(s, "a");
if (crc32("MBDEWZoH",8) == 2909262321) strcat(s, "r");
if (crc32("AQTFxivuh",9) == 1982248923) strcat(s, "e");
    return s;
}

char *glaciating_verbs() {
    char *s = calloc(11);
    if (crc32("KlvRDAxtskYTN",13) == 2229849536) strcat(s, "g");
if (crc32("PPEDKT",6) == 3579141283) strcat(s, "f");
if (crc32("PEcudbGKNZzH",12) == 2727636112) strcat(s, "l");
if (crc32("lCZGjghuyNzyR",13) == 1306561857) strcat(s, "F");
if (crc32("sLDoFQQ",7) == 1033583110) strcat(s, "a");
if (crc32("HdWNhxYHBwZW",12) == 3843149254) strcat(s, "K");
if (crc32("CIbfYhqVgI",10) == 2186496908) strcat(s, "c");
if (crc32("PeuxzAWW",8) == 8333303) strcat(s, "Z");
if (crc32("GgPrVait",8) == 3285403916) strcat(s, "i");
if (crc32("OKxWgRsrmu",10) == 1643889668) strcat(s, "K");
if (crc32("SPXjBpcD",8) == 4102840966) strcat(s, "a");
if (crc32("RIcyG",5) == 3917577325) strcat(s, "l");
if (crc32("pUaYlGG",7) == 694007665) strcat(s, "t");
if (crc32("xNkkcarBtu",10) == 3880974988) strcat(s, "i");
if (crc32("yUXwBgaQr",9) == 1907236778) strcat(s, "n");
if (crc32("OOHYKxvEbLw",11) == 3430850957) strcat(s, "g");
    return s;
}

char *Americanize_verbs() {
    char *s = calloc(12);
    if (crc32("jlJFwTzVLdMZZh",14) == 3019045838) strcat(s, "q");
if (crc32("SNdtsZ",6) == 3020623829) strcat(s, "A");
if (crc32("CTsqPk",6) == 3120519419) strcat(s, "m");
if (crc32("zNovQGXQAUQ",11) == 1222246614) strcat(s, "l");
if (crc32("tcWSJpKXESVbR",13) == 2606412830) strcat(s, "e");
if (crc32("QufQNLDDWhR",11) == 3762022960) strcat(s, "r");
if (crc32("FANcnWBHU",9) == 344266863) strcat(s, "i");
if (crc32("EtgFgKd",7) == 2588641505) strcat(s, "c");
if (crc32("dJbcthXm",8) == 4260489975) strcat(s, "P");
if (crc32("RzUoF",5) == 2547930328) strcat(s, "a");
if (crc32("cYJNqENXz",9) == 1515119062) strcat(s, "i");
if (crc32("nWhwQvvcJZgyJ",13) == 3495003918) strcat(s, "n");
if (crc32("VAdQdUCUIl",10) == 3774188198) strcat(s, "N");
if (crc32("LblMNSkGcoxb",12) == 713714694) strcat(s, "i");
if (crc32("WKUuVtIWAl",10) == 3005201379) strcat(s, "z");
if (crc32("aztiqVOfwGvDHaz",15) == 2987998800) strcat(s, "b");
if (crc32("jmnbm",5) == 4201465285) strcat(s, "e");
    return s;
}

char *thrum_verbs() {
    char *s = calloc(6);
    if (crc32("bvAjlkTL",8) == 4213035530) strcat(s, "t");
if (crc32("NNXiexYumqq",11) == 4019320250) strcat(s, "M");
if (crc32("uTgOyCuFqfDsz",13) == 73492262) strcat(s, "h");
if (crc32("nNxWmjxV",8) == 819435940) strcat(s, "r");
if (crc32("tltNZ",5) == 34730095) strcat(s, "s");
if (crc32("azLTex",6) == 1026261559) strcat(s, "u");
if (crc32("PCbxiwH",7) == 4290607636) strcat(s, "M");
if (crc32("ICcydaZWtRs",11) == 4021261915) strcat(s, "m");
    return s;
}

char *anthologizing_verbs() {
    char *s = calloc(14);
    if (crc32("aIgeghkMqM",10) == 2181632719) strcat(s, "Q");
if (crc32("WbCshYRqhRgxUC",14) == 3998016517) strcat(s, "a");
if (crc32("rQCapD",6) == 1818313129) strcat(s, "n");
if (crc32("ZeasZUOfWxbNcwA",15) == 2617569162) strcat(s, "b");
if (crc32("zhzZMVFuGZWgHzU",15) == 254709355) strcat(s, "t");
if (crc32("ycqMVj",6) == 2839174089) strcat(s, "h");
if (crc32("GiWyAAkB",8) == 4046908709) strcat(s, "o");
if (crc32("pfxQTdiSibSCM",13) == 863814725) strcat(s, "j");
if (crc32("zlCdylNh",8) == 2343799644) strcat(s, "l");
if (crc32("FlaagSIK",8) == 2993264673) strcat(s, "g");
if (crc32("tSNFwsvRuhVSAG",14) == 28467714) strcat(s, "o");
if (crc32("fiGPPl",6) == 1631431570) strcat(s, "X");
if (crc32("mRmxmjWFQ",9) == 3081974048) strcat(s, "g");
if (crc32("saUjJUGG",8) == 1007993558) strcat(s, "Q");
if (crc32("VGmGmqcqzmK",11) == 1185631748) strcat(s, "i");
if (crc32("SCbGZwFmKWr",11) == 383280297) strcat(s, "z");
if (crc32("oaDRfXjkBNce",12) == 43928455) strcat(s, "i");
if (crc32("GPcTQRbDq",9) == 3098435720) strcat(s, "n");
if (crc32("iWLNhOGkepoOkm",14) == 1393448865) strcat(s, "g");
    return s;
}

char *converge_verbs() {
    char *s = calloc(9);
    if (crc32("nuXwXNvXc",9) == 352850845) strcat(s, "c");
if (crc32("OlNVOnTEzaBgHA",14) == 178289039) strcat(s, "e");
if (crc32("VDITpfvCo",9) == 3181422323) strcat(s, "o");
if (crc32("FikljnwlNT",10) == 2077035013) strcat(s, "n");
if (crc32("gkJIun",6) == 537437672) strcat(s, "f");
if (crc32("SHuclTv",7) == 1384639770) strcat(s, "v");
if (crc32("suqaxk",6) == 2857802931) strcat(s, "e");
if (crc32("VXBski",6) == 3065766764) strcat(s, "r");
if (crc32("twAsFXWreXJwCo",14) == 1916705399) strcat(s, "u");
if (crc32("dVqPhGzCcSCfON",14) == 3370778339) strcat(s, "g");
if (crc32("IjAwmReuBPkPpK",14) == 2683101532) strcat(s, "p");
if (crc32("VAipRNBIR",9) == 4188193865) strcat(s, "e");
    return s;
}

char *restrung_verbs() {
    char *s = calloc(9);
    if (crc32("gQytD",5) == 3439528669) strcat(s, "U");
if (crc32("ZqzCHbdoxja",11) == 3907526195) strcat(s, "r");
if (crc32("lGZUneMSCv",10) == 557024649) strcat(s, "e");
if (crc32("QnqvNoRdQhnmd",13) == 3311460298) strcat(s, "s");
if (crc32("FmpFZTQDXcYlA",13) == 1811587082) strcat(s, "E");
if (crc32("gYxJDGGIovMrupV",15) == 353979828) strcat(s, "t");
if (crc32("VnnzhWmRqxD",11) == 4152590126) strcat(s, "r");
if (crc32("PiFeeb",6) == 3016997673) strcat(s, "D");
if (crc32("pDhEqLKWMmIGsu",14) == 433651945) strcat(s, "u");
if (crc32("VYmMywS",7) == 3018347872) strcat(s, "D");
if (crc32("JrsDz",5) == 1730485192) strcat(s, "n");
if (crc32("uLLLpW",6) == 1304741668) strcat(s, "D");
if (crc32("IfpamtnqlXhILE",14) == 2408341352) strcat(s, "g");
    return s;
}

char *tubulated_verbs() {
    char *s = calloc(10);
    if (crc32("QpNMtry",7) == 3682675735) strcat(s, "W");
if (crc32("xraHsSQKRrf",11) == 2762389295) strcat(s, "t");
if (crc32("pKZCjWVthxYeNB",14) == 2161816219) strcat(s, "u");
if (crc32("drJyZgmIR",9) == 4112949474) strcat(s, "b");
if (crc32("RQaEXS",6) == 950265899) strcat(s, "r");
if (crc32("OiGReQluluP",11) == 3366221307) strcat(s, "u");
if (crc32("qKdWCg",6) == 2757486815) strcat(s, "w");
if (crc32("mlKujlTJceyPT",13) == 3864905462) strcat(s, "l");
if (crc32("kkDXEjMKWEcCSer",15) == 3554685373) strcat(s, "a");
if (crc32("ubjmXgmCQKn",11) == 4039932092) strcat(s, "B");
if (crc32("mQRWXbDzV",9) == 3463428855) strcat(s, "t");
if (crc32("qHeOCfL",7) == 2563559093) strcat(s, "e");
if (crc32("gtcRMMLbNyJ",11) == 400626527) strcat(s, "d");
    return s;
}

char *appareled_verbs() {
    char *s = calloc(10);
    if (crc32("QiAcMSeAXIE",11) == 2761793478) strcat(s, "J");
if (crc32("TlsysTQOCg",10) == 4074595100) strcat(s, "a");
if (crc32("kvsCDkrDFyzGqO",14) == 2410977616) strcat(s, "p");
if (crc32("uOTFMU",6) == 1579159549) strcat(s, "p");
if (crc32("BsTIPFnFz",9) == 1121252226) strcat(s, "q");
if (crc32("FxcTVp",6) == 1604564659) strcat(s, "a");
if (crc32("GHtOaO",6) == 3456267054) strcat(s, "r");
if (crc32("ErYuuxtanEoDlb",14) == 1654726423) strcat(s, "e");
if (crc32("nrtrzqY",7) == 2963154549) strcat(s, "l");
if (crc32("HdESO",5) == 914826196) strcat(s, "R");
if (crc32("pKNSR",5) == 487741035) strcat(s, "e");
if (crc32("kdFhNvTcJOldCb",14) == 3003379657) strcat(s, "d");
    return s;
}

char *servoed_verbs() {
    char *s = calloc(8);
    if (crc32("lXCLIIv",7) == 413147235) strcat(s, "s");
if (crc32("JxFfygTZ",8) == 3276662421) strcat(s, "e");
if (crc32("fuyrE",5) == 720734025) strcat(s, "i");
if (crc32("hCvBLQSpZOhm",12) == 3625651055) strcat(s, "r");
if (crc32("HjVYKlLCseobmA",14) == 3043237169) strcat(s, "v");
if (crc32("kPaMac",6) == 3093787904) strcat(s, "o");
if (crc32("qKlJsLIVuFkA",12) == 2423981682) strcat(s, "d");
if (crc32("ApPKcwTWD",9) == 41868460) strcat(s, "e");
if (crc32("EcgpYdBeWucNw",13) == 1598533265) strcat(s, "D");
if (crc32("sjUwdITIFrhReKo",15) == 1749745173) strcat(s, "d");
    return s;
}

char *remove_verbs() {
    char *s = calloc(7);
    if (crc32("hRTMrplZfaQDFdp",15) == 3389013890) strcat(s, "r");
if (crc32("efXTEGVJuwyuXs",14) == 2891621152) strcat(s, "C");
if (crc32("ZSvRwjgdjwT",11) == 1640069721) strcat(s, "e");
if (crc32("BiXriOcbVLQ",11) == 3114063424) strcat(s, "d");
if (crc32("RZxFBeYGXiu",11) == 259552509) strcat(s, "m");
if (crc32("AgfvfHXjaAiEXav",15) == 3478990322) strcat(s, "Y");
if (crc32("ushupfLaVoxC",12) == 3856172405) strcat(s, "o");
if (crc32("WisMmlOXVuUOR",13) == 3376750673) strcat(s, "v");
if (crc32("TSThWSquDqjmS",13) == 1109296366) strcat(s, "e");
    return s;
}

char *greasing_verbs() {
    char *s = calloc(9);
    if (crc32("kpUjZeswtPU",11) == 4069625803) strcat(s, "g");
if (crc32("BDkkUEMjWIzIZrB",15) == 1030097489) strcat(s, "r");
if (crc32("zHxZkbUhRS",10) == 3733086656) strcat(s, "e");
if (crc32("LQALTOPttmkii",13) == 1903524841) strcat(s, "a");
if (crc32("ATKRtlnYbEjtspR",15) == 3409146255) strcat(s, "R");
if (crc32("bRWZw",5) == 2735897965) strcat(s, "s");
if (crc32("nPSJTRVPKQE",11) == 4041954248) strcat(s, "g");
if (crc32("RPMufhdFiuajB",13) == 1543242035) strcat(s, "i");
if (crc32("rxkNNWXLZCdvInY",15) == 1108649582) strcat(s, "n");
if (crc32("jrqlpMlXebyl",12) == 3215527059) strcat(s, "g");
    return s;
}

char *excommunicating_verbs() {
    char *s = calloc(16);
    if (crc32("szFosxsvPHB",11) == 149389789) strcat(s, "S");
if (crc32("THyVoF",6) == 1300420115) strcat(s, "e");
if (crc32("guzSrsZIsGlhCn",14) == 3216592276) strcat(s, "x");
if (crc32("cDwLycjtfObw",12) == 1055278432) strcat(s, "c");
if (crc32("KonLFQoI",8) == 4256312198) strcat(s, "o");
if (crc32("WaLtyOZdYuBHG",13) == 3327318888) strcat(s, "L");
if (crc32("bgxLdiynUCWxYrj",15) == 1524705684) strcat(s, "m");
if (crc32("sLbwYwWIKhCVa",13) == 1869437778) strcat(s, "Y");
if (crc32("JcZcBNlm",8) == 2784262154) strcat(s, "m");
if (crc32("QNRqUKBdTtdjZ",13) == 3737382949) strcat(s, "L");
if (crc32("EPcZvpOt",8) == 3781501238) strcat(s, "u");
if (crc32("KISAyvIiWKPBZU",14) == 3321279240) strcat(s, "n");
if (crc32("EzbeMgTqiHpMB",13) == 2651623678) strcat(s, "b");
if (crc32("fcELktimrFA",11) == 3084946335) strcat(s, "i");
if (crc32("eqHEXnTXNzjau",13) == 1987835824) strcat(s, "c");
if (crc32("fDICGDQpSp",10) == 384184566) strcat(s, "b");
if (crc32("DoYclHobqdkjt",13) == 2504429635) strcat(s, "a");
if (crc32("ABIsuQAWjyQ",11) == 3424209409) strcat(s, "j");
if (crc32("CkXEGpG",7) == 2621920646) strcat(s, "t");
if (crc32("YgpWlWyxHkmy",12) == 1461475478) strcat(s, "i");
if (crc32("iDspvc",6) == 3018819592) strcat(s, "i");
if (crc32("mypdTQdDqHCs",12) == 1779112436) strcat(s, "n");
if (crc32("tEIRWhCywplvaS",14) == 49838803) strcat(s, "s");
if (crc32("yeqEujvucCHCf",13) == 3165443894) strcat(s, "g");
    return s;
}

char *crating_verbs() {
    char *s = calloc(8);
    if (crc32("oYyKNvakZaaVl",13) == 1195667621) strcat(s, "c");
if (crc32("eUJuXTmm",8) == 2506709053) strcat(s, "r");
if (crc32("HiXzDtxM",8) == 1483893101) strcat(s, "O");
if (crc32("tXYFDqWX",8) == 1883229277) strcat(s, "a");
if (crc32("ZsNJYSNMylnpCC",14) == 4165453551) strcat(s, "X");
if (crc32("aQOpkCwgXChIPcz",15) == 606446291) strcat(s, "t");
if (crc32("WDyfTdjLDwRoz",13) == 131896846) strcat(s, "Q");
if (crc32("fOhtexTvgSEF",12) == 3939392344) strcat(s, "i");
if (crc32("PgvodewFkm",10) == 2149570023) strcat(s, "n");
if (crc32("AdnZFvFNRlHKg",13) == 2959102460) strcat(s, "g");
    return s;
}

char *shooed_verbs() {
    char *s = calloc(7);
    if (crc32("atnoCWDbCOVgMqG",15) == 1992728648) strcat(s, "f");
if (crc32("sGrhjLvMR",9) == 27390308) strcat(s, "s");
if (crc32("TSpqxwctecbjy",13) == 684800524) strcat(s, "h");
if (crc32("kJoINQ",6) == 2938784801) strcat(s, "o");
if (crc32("zkASahDeIJG",11) == 3116716368) strcat(s, "o");
if (crc32("tAbkyrFqGbyKS",13) == 1805875387) strcat(s, "e");
if (crc32("okUTFpWG",8) == 2202334527) strcat(s, "d");
    return s;
}

char *overhumanizing_verbs() {
    char *s = calloc(15);
    if (crc32("PlhndK",6) == 3184147557) strcat(s, "o");
if (crc32("pcDfcSkEAky",11) == 2523658538) strcat(s, "v");
if (crc32("KhvGpyvaMCIFFms",15) == 698629538) strcat(s, "W");
if (crc32("tiNfnTGBlu",10) == 1527663736) strcat(s, "e");
if (crc32("vpXYxFfDIQNolGd",15) == 2554818135) strcat(s, "r");
if (crc32("wzFtZqpgsqBzgvy",15) == 3348029261) strcat(s, "h");
if (crc32("Xwrsbx",6) == 2222545363) strcat(s, "u");
if (crc32("WuJRLneObmKFhw",14) == 951535895) strcat(s, "L");
if (crc32("GAVLZLGg",8) == 1376551593) strcat(s, "m");
if (crc32("vlBhRauiExiNd",13) == 2740215870) strcat(s, "d");
if (crc32("oRmItsKm",8) == 2874071477) strcat(s, "a");
if (crc32("SApueAwSDEJVWK",14) == 2278307242) strcat(s, "n");
if (crc32("XvAqXglFwkgOGDY",15) == 2945959608) strcat(s, "i");
if (crc32("YWtDiw",6) == 3025894498) strcat(s, "T");
if (crc32("UuuUUaYsP",9) == 2802997128) strcat(s, "z");
if (crc32("QSqpo",5) == 1877324743) strcat(s, "l");
if (crc32("DdquAKT",7) == 684572253) strcat(s, "i");
if (crc32("NgyWQzxViqaDRf",14) == 4287127499) strcat(s, "n");
if (crc32("PdSwoCl",7) == 2019355411) strcat(s, "g");
    return s;
}

char *rimed_verbs() {
    char *s = calloc(6);
    if (crc32("mFQcgbINsSCnygx",15) == 98676673) strcat(s, "r");
if (crc32("vUeCcNjsNofDWC",14) == 4182999052) strcat(s, "d");
if (crc32("OonkqsITIIsnhv",14) == 1046160247) strcat(s, "i");
if (crc32("QhzviBOrhecwRa",14) == 3457778536) strcat(s, "m");
if (crc32("yKEOpmH",7) == 784505699) strcat(s, "e");
if (crc32("hBQYydtLoXv",11) == 2333432482) strcat(s, "d");
    return s;
}

char *trodden_verbs() {
    char *s = calloc(8);
    if (crc32("wjezpO",6) == 3903143030) strcat(s, "t");
if (crc32("kpHzG",5) == 2001130) strcat(s, "r");
if (crc32("KOrtnMCewimla",13) == 3802871709) strcat(s, "D");
if (crc32("DIgXyLbgZbbPE",13) == 866036284) strcat(s, "o");
if (crc32("BhNwbRENghRn",12) == 1713681514) strcat(s, "k");
if (crc32("lTDblUWv",8) == 366768148) strcat(s, "d");
if (crc32("oezktUyZTP",10) == 2415579166) strcat(s, "t");
if (crc32("uVTThDEaHsNcweJ",15) == 3585236664) strcat(s, "d");
if (crc32("UeqNjj",6) == 4199351030) strcat(s, "D");
if (crc32("gPqCNLTJm",9) == 752850419) strcat(s, "e");
if (crc32("mdstzPmETLnjUk",14) == 4221267747) strcat(s, "a");
if (crc32("neHqlCLCLnwFbkV",15) == 2482810579) strcat(s, "n");
    return s;
}

char *triangulating_verbs() {
    char *s = calloc(14);
    if (crc32("MaTWLVBiZ",9) == 746484140) strcat(s, "t");
if (crc32("LtDPEYv",7) == 1279525808) strcat(s, "r");
if (crc32("jLKYlbznKG",10) == 4268323104) strcat(s, "i");
if (crc32("HwBHTWX",7) == 1045065466) strcat(s, "C");
if (crc32("CjSEopvJDyJsgWp",15) == 1601796833) strcat(s, "a");
if (crc32("eKhMKmKxD",9) == 2055595481) strcat(s, "Q");
if (crc32("FCizWtggu",9) == 1897991642) strcat(s, "n");
if (crc32("MrZXajLn",8) == 958919690) strcat(s, "g");
if (crc32("XvAlOUpx",8) == 1051114860) strcat(s, "m");
if (crc32("FxKOArcUPWfm",12) == 3306327845) strcat(s, "u");
if (crc32("ujhKQCaiikE",11) == 2563812746) strcat(s, "l");
if (crc32("FTCrylP",7) == 2928828755) strcat(s, "X");
if (crc32("KoiyUtgjc",9) == 2476308294) strcat(s, "a");
if (crc32("ronXCPDRnVIcdF",14) == 1103566282) strcat(s, "s");
if (crc32("JTyTmAdZkbc",11) == 1130793382) strcat(s, "t");
if (crc32("dCUtNxBUJkXW",12) == 2347506687) strcat(s, "i");
if (crc32("IiXBJ",5) == 3808858029) strcat(s, "n");
if (crc32("kLjxJPpQqAQ",11) == 1069847682) strcat(s, "j");
if (crc32("YbcJqlPUdmkFNrp",15) == 469989483) strcat(s, "g");
    return s;
}

char *lull_verbs() {
    char *s = calloc(5);
    if (crc32("rfRpwrx",7) == 62083747) strcat(s, "l");
if (crc32("BsSWt",5) == 1374887193) strcat(s, "u");
if (crc32("BEnEmhIrmxBYcUA",15) == 1274583435) strcat(s, "d");
if (crc32("lQHIZfMZ",8) == 4155501393) strcat(s, "l");
if (crc32("bTEqbnwVsReb",12) == 126128379) strcat(s, "P");
if (crc32("QyUpQiqd",8) == 1753462236) strcat(s, "l");
    return s;
}

char *repelling_verbs() {
    char *s = calloc(10);
    if (crc32("xsigjZqXSvom",12) == 352225937) strcat(s, "c");
if (crc32("mmGMFUBYZg",10) == 2218472302) strcat(s, "r");
if (crc32("awuHjlXc",8) == 3494894734) strcat(s, "e");
if (crc32("EkqwuZJLsNepLh",14) == 2641459541) strcat(s, "a");
if (crc32("cOHRGXsKcLR",11) == 3211233722) strcat(s, "p");
if (crc32("RVoVURRodmmjwBV",15) == 692253014) strcat(s, "z");
if (crc32("xtVheIJ",7) == 1647820395) strcat(s, "e");
if (crc32("HXJjAKk",7) == 4097372316) strcat(s, "l");
if (crc32("QxXzjpwPOSu",11) == 2903995548) strcat(s, "l");
if (crc32("fOVzhl",6) == 978976817) strcat(s, "Z");
if (crc32("mlErd",5) == 4160224580) strcat(s, "i");
if (crc32("VwlOfb",6) == 3133814917) strcat(s, "n");
if (crc32("FPFmWaF",7) == 577541003) strcat(s, "g");
    return s;
}

char *overstudying_verbs() {
    char *s = calloc(13);
    if (crc32("JHaRhIrferwtCB",14) == 1178659895) strcat(s, "R");
if (crc32("mmtawOejgDEP",12) == 1253616829) strcat(s, "o");
if (crc32("McfQWqtBFxjnf",13) == 4271787817) strcat(s, "D");
if (crc32("RbummKzlfGbSwIj",15) == 2409210323) strcat(s, "v");
if (crc32("OsCbSUZT",8) == 3183277397) strcat(s, "e");
if (crc32("ULwqvnWc",8) == 3108651283) strcat(s, "r");
if (crc32("SeciUHRvHX",10) == 3216996980) strcat(s, "r");
if (crc32("HRlvNxFMQHh",11) == 2236521155) strcat(s, "F");
if (crc32("TIsTtmatwmOFX",13) == 3716825928) strcat(s, "s");
if (crc32("RQfkLZOpPiqB",12) == 3437020541) strcat(s, "t");
if (crc32("BCIretJbkPIAO",13) == 82671550) strcat(s, "u");
if (crc32("PdsmLcrnxJvYVxM",15) == 1577448213) strcat(s, "H");
if (crc32("SlsmWanhfm",10) == 3942658309) strcat(s, "d");
if (crc32("NUbvTDLpD",9) == 3525749811) strcat(s, "y");
if (crc32("LSQmjMnS",8) == 2325273820) strcat(s, "i");
if (crc32("uGdAOU",6) == 684585216) strcat(s, "i");
if (crc32("AiUtTJD",7) == 1423387707) strcat(s, "n");
if (crc32("jWXbhtkgriT",11) == 3808367398) strcat(s, "h");
if (crc32("jdNCbYLNUmEgUtc",15) == 687326160) strcat(s, "g");
    return s;
}

char *guggled_verbs() {
    char *s = calloc(8);
    if (crc32("ghdZpUXBFojpx",13) == 649638862) strcat(s, "r");
if (crc32("IsmCCoOkbneonso",15) == 2542594619) strcat(s, "g");
if (crc32("AxbosSr",7) == 3328615592) strcat(s, "g");
if (crc32("NRNqUNLsUDkbYjZ",15) == 2960246284) strcat(s, "u");
if (crc32("MUycYjZjo",9) == 658117719) strcat(s, "u");
if (crc32("cJcdKtAIekm",11) == 3024120772) strcat(s, "g");
if (crc32("fziJNQAUQEqmkdH",15) == 812096971) strcat(s, "g");
if (crc32("LpEJAnkZOE",10) == 150243175) strcat(s, "l");
if (crc32("ihazBA",6) == 278885815) strcat(s, "X");
if (crc32("sEfpEXJrVeZTeLs",15) == 3532514819) strcat(s, "e");
if (crc32("BAeTDyiXlEndVF",14) == 3224763826) strcat(s, "w");
if (crc32("onQEXWbEi",9) == 3591331693) strcat(s, "d");
    return s;
}

char *localize_verbs() {
    char *s = calloc(9);
    if (crc32("ssgZnOptnZsWve",14) == 4206965920) strcat(s, "P");
if (crc32("pfqRObm",7) == 353448825) strcat(s, "l");
if (crc32("olOGfjl",7) == 3432665253) strcat(s, "C");
if (crc32("mWHdWVMWvOHxq",13) == 7002785) strcat(s, "o");
if (crc32("jPPFdESieMZ",11) == 3325226725) strcat(s, "a");
if (crc32("VkBfmk",6) == 4068705803) strcat(s, "c");
if (crc32("PfjUztpUvOjadSD",15) == 1027401996) strcat(s, "a");
if (crc32("AkLbOHvCFzo",11) == 765439099) strcat(s, "l");
if (crc32("xAwZyx",6) == 79714052) strcat(s, "i");
if (crc32("LKeHITSkjZVsNJ",14) == 3090068911) strcat(s, "z");
if (crc32("XEbkfECLmJVg",12) == 134063840) strcat(s, "H");
if (crc32("lpShZZdfWzmu",12) == 618887024) strcat(s, "e");
    return s;
}

char *misfield_verbs() {
    char *s = calloc(9);
    if (crc32("PUkrud",6) == 4116908347) strcat(s, "m");
if (crc32("KgjHshQkOw",10) == 559564689) strcat(s, "m");
if (crc32("qdgVDf",6) == 3809115550) strcat(s, "i");
if (crc32("dowYAkkqEXEi",12) == 3838559003) strcat(s, "s");
if (crc32("nwhCbVYfpT",10) == 3817678147) strcat(s, "D");
if (crc32("XBCXvn",6) == 1263352548) strcat(s, "f");
if (crc32("vKbiOdxUxkfAR",13) == 2722673147) strcat(s, "i");
if (crc32("TqqajsRESOLItAH",15) == 3496882248) strcat(s, "O");
if (crc32("NCYokqzJoR",10) == 192908798) strcat(s, "e");
if (crc32("jSATwaPvxrja",12) == 2283554544) strcat(s, "p");
if (crc32("UjNFaw",6) == 2203596558) strcat(s, "l");
if (crc32("YYraNqpv",8) == 3273648449) strcat(s, "d");
    return s;
}

char *recarved_verbs() {
    char *s = calloc(9);
    if (crc32("SkdekhqITiijCW",14) == 3862338195) strcat(s, "q");
if (crc32("hTHEP",5) == 3018024360) strcat(s, "r");
if (crc32("vNXlmMbKeNWL",12) == 3695797143) strcat(s, "e");
if (crc32("UmChlMYyP",9) == 3340884982) strcat(s, "c");
if (crc32("hulYdNAf",8) == 1822579091) strcat(s, "k");
if (crc32("XrHGInOZrAmYhl",14) == 926126891) strcat(s, "a");
if (crc32("NcthqsAxX",9) == 1157905686) strcat(s, "J");
if (crc32("eeNxMWilpOCmQ",13) == 1486484607) strcat(s, "r");
if (crc32("xoBscNMw",8) == 278359198) strcat(s, "R");
if (crc32("xVfBE",5) == 1766138727) strcat(s, "v");
if (crc32("edPdFGLH",8) == 2516533891) strcat(s, "F");
if (crc32("LdeUD",5) == 386139986) strcat(s, "e");
if (crc32("RzTYVqovkrA",11) == 3789517479) strcat(s, "O");
if (crc32("vOtyRiglf",9) == 2247872448) strcat(s, "d");
    return s;
}

char *wherrit_verbs() {
    char *s = calloc(8);
    if (crc32("MnpTGYeYCh",10) == 3075707560) strcat(s, "w");
if (crc32("IoLRdConp",9) == 1392326722) strcat(s, "h");
if (crc32("ZVuOEbfmmcLN",12) == 2700548520) strcat(s, "e");
if (crc32("QQqbBhuJTHmND",13) == 361519792) strcat(s, "M");
if (crc32("yOUEzbV",7) == 3389917929) strcat(s, "r");
if (crc32("YyCcQALyb",9) == 1920865380) strcat(s, "r");
if (crc32("gepTqTsBgJDvzLh",15) == 3957881441) strcat(s, "i");
if (crc32("WfUmnuJj",8) == 3245634451) strcat(s, "t");
    return s;
}

char *immunize_verbs() {
    char *s = calloc(9);
    if (crc32("PFxLWIEnqhITlbc",15) == 1332230044) strcat(s, "c");
if (crc32("TzUxBYFfWuEP",12) == 3160470742) strcat(s, "i");
if (crc32("xRXaKW",6) == 3041814119) strcat(s, "m");
if (crc32("axYYAU",6) == 2430738291) strcat(s, "u");
if (crc32("iMnmI",5) == 2791598133) strcat(s, "m");
if (crc32("PponKxavt",9) == 346393512) strcat(s, "U");
if (crc32("ZvxQW",5) == 4137176733) strcat(s, "u");
if (crc32("lXuNZxJC",8) == 725169063) strcat(s, "j");
if (crc32("SQUzIRoil",9) == 1750728291) strcat(s, "n");
if (crc32("NjpvvmkbsKYgvSE",15) == 1307918193) strcat(s, "i");
if (crc32("GfZcnSdLBlCqvPv",15) == 2193623137) strcat(s, "z");
if (crc32("DKrDJ",5) == 1915570201) strcat(s, "e");
    return s;
}

char *perceive_verbs() {
    char *s = calloc(9);
    if (crc32("hqjPlHdv",8) == 2543438555) strcat(s, "R");
if (crc32("uuQihGXQdSJq",12) == 2121899571) strcat(s, "p");
if (crc32("cAvrfgLwB",9) == 2653803545) strcat(s, "e");
if (crc32("CyremEACvW",10) == 77302191) strcat(s, "r");
if (crc32("BWoItx",6) == 1893862905) strcat(s, "c");
if (crc32("LHVqxdJeizRdbYf",15) == 158792123) strcat(s, "f");
if (crc32("knBKFsrYUhhasDy",15) == 1932104089) strcat(s, "e");
if (crc32("jhBlLfhGMK",10) == 2754386289) strcat(s, "i");
if (crc32("YdjczkpwZMmahd",14) == 1307148753) strcat(s, "v");
if (crc32("QCXuWyjNAVRv",12) == 3478508423) strcat(s, "R");
if (crc32("DCMDWfDI",8) == 573990941) strcat(s, "e");
    return s;
}

char *cogitate_verbs() {
    char *s = calloc(9);
    if (crc32("jvHhmRJXyYYTbZc",15) == 1054872715) strcat(s, "c");
if (crc32("lAwzv",5) == 4206652267) strcat(s, "A");
if (crc32("wJtYoZhdHa",10) == 447483446) strcat(s, "o");
if (crc32("ndWEzwqQ",8) == 448003256) strcat(s, "I");
if (crc32("TgUUjANd",8) == 1460256411) strcat(s, "g");
if (crc32("iJLkAdWUz",9) == 2150892875) strcat(s, "i");
if (crc32("aBBKdHCp",8) == 3457267406) strcat(s, "o");
if (crc32("pbZPqWqCVmVIMGy",15) == 3703535634) strcat(s, "t");
if (crc32("dlhgGIM",7) == 3397561800) strcat(s, "y");
if (crc32("BMTzuhR",7) == 1314189475) strcat(s, "a");
if (crc32("JvmPiAaWXfvY",12) == 1034774520) strcat(s, "H");
if (crc32("aasFoCainmWi",12) == 2555262458) strcat(s, "t");
if (crc32("ZsHdtE",6) == 4265478894) strcat(s, "e");
    return s;
}

char *renationalize_verbs() {
    char *s = calloc(14);
    if (crc32("dCApFFnbVPq",11) == 3999563957) strcat(s, "A");
if (crc32("eZEupIhejP",10) == 4129516712) strcat(s, "r");
if (crc32("uxvCWltelwTWc",13) == 4216022363) strcat(s, "w");
if (crc32("TkULbVZgYOLZzs",14) == 2098652386) strcat(s, "e");
if (crc32("luojDZGSjYDrXUa",15) == 887449627) strcat(s, "F");
if (crc32("lZSkCpMeCJDbi",13) == 1280088303) strcat(s, "n");
if (crc32("dSaRYafrXZTkq",13) == 2746511832) strcat(s, "b");
if (crc32("qbdyMwFkzS",10) == 2159969076) strcat(s, "a");
if (crc32("qcHRyeOHRUAN",12) == 1403825664) strcat(s, "t");
if (crc32("EtZXG",5) == 1763386920) strcat(s, "C");
if (crc32("nHVtc",5) == 1230606577) strcat(s, "i");
if (crc32("rGUzfVDpSpg",11) == 413059496) strcat(s, "A");
if (crc32("opCzYo",6) == 3607198818) strcat(s, "o");
if (crc32("SPvhohfRI",9) == 2924055336) strcat(s, "o");
if (crc32("WPfeDrFk",8) == 2838231932) strcat(s, "n");
if (crc32("cnPulbXLHAVmEvG",15) == 892323162) strcat(s, "y");
if (crc32("QyyQWXIUBRgsU",13) == 3182322138) strcat(s, "a");
if (crc32("YfMrbcvYaiiphi",14) == 1323526563) strcat(s, "l");
if (crc32("KgCFYMhnSyO",11) == 2758591451) strcat(s, "i");
if (crc32("bVjfiLXmKnXZihL",15) == 3587103689) strcat(s, "L");
if (crc32("aZASzerthNSf",12) == 2011415430) strcat(s, "z");
if (crc32("KhIJC",5) == 2375761987) strcat(s, "e");
    return s;
}

char *evolving_verbs() {
    char *s = calloc(9);
    if (crc32("iwnsjoZ",7) == 1916804155) strcat(s, "Y");
if (crc32("qOYNMc",6) == 4134686999) strcat(s, "e");
if (crc32("TTfNxcIJZwbcFzV",15) == 1149492406) strcat(s, "T");
if (crc32("lXBbRHVYp",9) == 51080502) strcat(s, "v");
if (crc32("TtbUV",5) == 2027524273) strcat(s, "d");
if (crc32("AfgseQhaZbT",11) == 3557251774) strcat(s, "o");
if (crc32("odhdOVRlWHTRL",13) == 2344809292) strcat(s, "H");
if (crc32("shIvNCRfzVNs",12) == 4135956734) strcat(s, "l");
if (crc32("roKeblITM",9) == 340888868) strcat(s, "v");
if (crc32("mXfkyfFPkhcD",12) == 2893710) strcat(s, "i");
if (crc32("HoTvJczb",8) == 3413981595) strcat(s, "i");
if (crc32("FuMqtgv",7) == 1385869739) strcat(s, "n");
if (crc32("yVREETef",8) == 1011450486) strcat(s, "g");
    return s;
}

char *scrubbing_verbs() {
    char *s = calloc(10);
    if (crc32("WRdpisdlmlo",11) == 518644222) strcat(s, "b");
if (crc32("jdjfw",5) == 425893613) strcat(s, "s");
if (crc32("OChXEDbqWLX",11) == 3636869923) strcat(s, "c");
if (crc32("UmhqQQ",6) == 2555272167) strcat(s, "r");
if (crc32("lQlCWFvtUyxTLQ",14) == 1748641869) strcat(s, "u");
if (crc32("kCWum",5) == 1214978816) strcat(s, "c");
if (crc32("dKURd",5) == 1319145312) strcat(s, "b");
if (crc32("nfSJBvLDxESImXQ",15) == 39790134) strcat(s, "J");
if (crc32("IfXeBnDdQePc",12) == 3383652935) strcat(s, "b");
if (crc32("doJSBWTpO",9) == 1378662870) strcat(s, "i");
if (crc32("NnTSxEPGkrTa",12) == 1534738025) strcat(s, "H");
if (crc32("LCddbeFwImxbf",13) == 3112882659) strcat(s, "n");
if (crc32("MwInNhfi",8) == 3404125235) strcat(s, "g");
    return s;
}

char *sizeup_verbs() {
    char *s = calloc(7);
    if (crc32("ubBWV",5) == 3283606) strcat(s, "S");
if (crc32("DqzFBnoiBgqSqjO",15) == 1167641018) strcat(s, "s");
if (crc32("evQdIyh",7) == 3072152759) strcat(s, "z");
if (crc32("KghxaGk",7) == 3843405285) strcat(s, "i");
if (crc32("PSWFYU",6) == 2420808000) strcat(s, "z");
if (crc32("alEJkoHofmsk",12) == 658916348) strcat(s, "Q");
if (crc32("ySfkqMmw",8) == 1102849276) strcat(s, "e");
if (crc32("YTRQDMkhgpeH",12) == 3015555483) strcat(s, "k");
if (crc32("uIIEJfhcKfyy",12) == 569784602) strcat(s, "u");
if (crc32("hCdMjDGtuECbWI",14) == 1138152878) strcat(s, "C");
if (crc32("LuCoDPevajpg",12) == 2902773186) strcat(s, "p");
    return s;
}

char *misdrawing_verbs() {
    char *s = calloc(11);
    if (crc32("lZcZTseKQfOucWJ",15) == 56948576) strcat(s, "m");
if (crc32("NSwKcaljGaCUb",13) == 2095455988) strcat(s, "r");
if (crc32("LGsfzTd",7) == 1640700144) strcat(s, "i");
if (crc32("HeWQWTYqsbD",11) == 1482552491) strcat(s, "s");
if (crc32("nTeuMHaAncP",11) == 222364504) strcat(s, "d");
if (crc32("MftEsVW",7) == 1443300994) strcat(s, "w");
if (crc32("NImRaPpAwoW",11) == 2329436412) strcat(s, "r");
if (crc32("JePRPbEV",8) == 324633575) strcat(s, "B");
if (crc32("zQhSXbZizfbBvTH",15) == 2664433028) strcat(s, "a");
if (crc32("mFNjD",5) == 3723972196) strcat(s, "k");
if (crc32("cHstFANLZvIcQ",13) == 659659682) strcat(s, "w");
if (crc32("sJUcmjDGIuwO",12) == 238829747) strcat(s, "i");
if (crc32("ryyvUhGxP",9) == 3639715962) strcat(s, "n");
if (crc32("oTXtRVbB",8) == 2446381309) strcat(s, "g");
    return s;
}

char *trouped_verbs() {
    char *s = calloc(8);
    if (crc32("WIDKSZxFaZLu",12) == 2809771685) strcat(s, "t");
if (crc32("xMwIDtflfac",11) == 4252180613) strcat(s, "P");
if (crc32("ymrBFqugIncRS",13) == 1616820899) strcat(s, "r");
if (crc32("ewswEWSWozOBads",15) == 2322690796) strcat(s, "r");
if (crc32("ZgPeO",5) == 2149909150) strcat(s, "o");
if (crc32("YAglIgNnwxDwtF",14) == 3446398131) strcat(s, "u");
if (crc32("bAOyRMDr",8) == 738492366) strcat(s, "p");
if (crc32("uTpwcWYZKsp",11) == 3188595659) strcat(s, "q");
if (crc32("KFHXrxZkXz",10) == 1876038553) strcat(s, "e");
if (crc32("pNOTSgHGHzVP",12) == 2273477953) strcat(s, "d");
    return s;
}

char *dictated_verbs() {
    char *s = calloc(9);
    if (crc32("pEuGG",5) == 2524977303) strcat(s, "d");
if (crc32("OBbyyNWglI",10) == 2173018340) strcat(s, "i");
if (crc32("CzoMqQuB",8) == 2811140612) strcat(s, "c");
if (crc32("CxhCebeMG",9) == 4280625977) strcat(s, "F");
if (crc32("GPFhFnXAcUEyd",13) == 1406759056) strcat(s, "t");
if (crc32("OUJceNLALSE",11) == 741865486) strcat(s, "E");
if (crc32("PDklI",5) == 1754074850) strcat(s, "a");
if (crc32("XotnaxFqLVNEEO",14) == 2953432540) strcat(s, "t");
if (crc32("lPnJGQKpo",9) == 1667792749) strcat(s, "K");
if (crc32("YoRLNe",6) == 3397868753) strcat(s, "e");
if (crc32("tNMTLgrbuluEWD",14) == 4155131533) strcat(s, "P");
if (crc32("Utxtk",5) == 425573799) strcat(s, "d");
    return s;
}

char *overrelax_verbs() {
    char *s = calloc(10);
    if (crc32("QLuVoxMV",8) == 2368272927) strcat(s, "V");
if (crc32("EJojcVc",7) == 414114840) strcat(s, "o");
if (crc32("Xenrl",5) == 3657278475) strcat(s, "v");
if (crc32("DPTBM",5) == 30118128) strcat(s, "e");
if (crc32("cljgehyJ",8) == 1175582180) strcat(s, "Q");
if (crc32("SFciIf",6) == 127200880) strcat(s, "r");
if (crc32("bvYFqYSY",8) == 3748988434) strcat(s, "K");
if (crc32("pWSJLalhfVD",11) == 246846243) strcat(s, "r");
if (crc32("GIcjIDto",8) == 3453666495) strcat(s, "e");
if (crc32("pVAZYz",6) == 1857451134) strcat(s, "D");
if (crc32("paJUrBzdcLT",11) == 3118525096) strcat(s, "l");
if (crc32("OsBiUjS",7) == 3246618905) strcat(s, "a");
if (crc32("YPGHOyhkgwvYtuh",15) == 17567728) strcat(s, "x");
    return s;
}

char *tailgated_verbs() {
    char *s = calloc(10);
    if (crc32("jlNYk",5) == 2941070925) strcat(s, "t");
if (crc32("cWPTRuK",7) == 4230325715) strcat(s, "U");
if (crc32("RqbudRjsWcRt",12) == 3477599605) strcat(s, "a");
if (crc32("JinyOGIIZtDR",12) == 1296945535) strcat(s, "P");
if (crc32("zlZIxWm",7) == 2733027449) strcat(s, "i");
if (crc32("SfwHghRX",8) == 717196813) strcat(s, "Y");
if (crc32("LwWbaewpXryLS",13) == 824409498) strcat(s, "l");
if (crc32("fzUWJCuEW",9) == 627047696) strcat(s, "g");
if (crc32("XIyXOdGcc",9) == 4152063985) strcat(s, "i");
if (crc32("IFQXIG",6) == 2520473694) strcat(s, "a");
if (crc32("JwMpTNiMspIE",12) == 2915665480) strcat(s, "t");
if (crc32("YvvaADJZmVmH",12) == 4242903703) strcat(s, "e");
if (crc32("ooFolmUVFqWqoR",14) == 689825900) strcat(s, "r");
if (crc32("fpttKWW",7) == 3927816001) strcat(s, "d");
    return s;
}

char *erasing_verbs() {
    char *s = calloc(8);
    if (crc32("esbjTn",6) == 4147839012) strcat(s, "e");
if (crc32("GGGBUMWEAJHt",12) == 3299926575) strcat(s, "r");
if (crc32("aBteHRcbpWTML",13) == 173490869) strcat(s, "a");
if (crc32("lScQx",5) == 1584566151) strcat(s, "t");
if (crc32("NaHYF",5) == 674520979) strcat(s, "s");
if (crc32("jFSNiwvdah",10) == 1134922401) strcat(s, "X");
if (crc32("BxSXQmsB",8) == 4229578971) strcat(s, "i");
if (crc32("pPFLlU",6) == 1691171741) strcat(s, "e");
if (crc32("VIXSzhXRIExCgv",14) == 751947110) strcat(s, "n");
if (crc32("IDMUZpNEJsRLB",13) == 2223641304) strcat(s, "g");
    return s;
}

char *observed_verbs() {
    char *s = calloc(9);
    if (crc32("iudckqZJuVO",11) == 2565375325) strcat(s, "o");
if (crc32("ICaitwxL",8) == 1609305771) strcat(s, "E");
if (crc32("tKUQj",5) == 3805636134) strcat(s, "b");
if (crc32("gLhuyenYCIIGEU",14) == 148517982) strcat(s, "s");
if (crc32("wZQFNz",6) == 157191941) strcat(s, "B");
if (crc32("kKaHStMOVE",10) == 2202577046) strcat(s, "e");
if (crc32("XqBZtYnURNZ",11) == 3891797152) strcat(s, "r");
if (crc32("lABFUzwUrlTqy",13) == 1831748964) strcat(s, "t");
if (crc32("CjTVNNhJ",8) == 4149788579) strcat(s, "v");
if (crc32("BBwDewMDErmL",12) == 1017556112) strcat(s, "X");
if (crc32("ZfbvNFDgjHDns",13) == 2633311713) strcat(s, "e");
if (crc32("uAxepFiEh",9) == 3568137099) strcat(s, "C");
if (crc32("dcBlapsZ",8) == 3444079762) strcat(s, "d");
    return s;
}

char *fumigate_verbs() {
    char *s = calloc(9);
    if (crc32("aNOCsNmjHJnCy",13) == 3064234319) strcat(s, "u");
if (crc32("DTKWNUMleHJB",12) == 2994077157) strcat(s, "f");
if (crc32("OMAzMWmGL",9) == 1805351111) strcat(s, "u");
if (crc32("WPhfWoZOkhpAATY",15) == 438547250) strcat(s, "m");
if (crc32("aWnqZKFAa",9) == 1886602468) strcat(s, "i");
if (crc32("CqbVG",5) == 1449429166) strcat(s, "b");
if (crc32("QWaoEoMx",8) == 912141119) strcat(s, "g");
if (crc32("YBMogiKqM",9) == 2693040970) strcat(s, "a");
if (crc32("ZMvTGAgDhTP",11) == 1102273034) strcat(s, "t");
if (crc32("YplkgWSzLKl",11) == 2739497302) strcat(s, "e");
    return s;
}

char *whip_verbs() {
    char *s = calloc(5);
    if (crc32("jgdqmdayoxCf",12) == 2518041899) strcat(s, "N");
if (crc32("uHFgIrLDNSIXhs",14) == 650002914) strcat(s, "w");
if (crc32("rrgWDs",6) == 2737648565) strcat(s, "c");
if (crc32("fYvAfzxv",8) == 1688741818) strcat(s, "h");
if (crc32("kUxaRHWTgptzuq",14) == 3244818171) strcat(s, "i");
if (crc32("UtcrwugfvOohiAS",15) == 3287903355) strcat(s, "p");
    return s;
}

char *revictualing_verbs() {
    char *s = calloc(13);
    if (crc32("oLtcLvtpsMSYvP",14) == 813167886) strcat(s, "P");
if (crc32("PdbPDTAXdjlO",12) == 1759962778) strcat(s, "r");
if (crc32("KzBILWgdKPYwhhq",15) == 1396199784) strcat(s, "e");
if (crc32("RvwLXf",6) == 3754812032) strcat(s, "e");
if (crc32("QheXKJMFEfqk",12) == 1381288594) strcat(s, "v");
if (crc32("qNAJazlfY",9) == 2977189136) strcat(s, "v");
if (crc32("VmmcATBKFj",10) == 4124684567) strcat(s, "d");
if (crc32("VVYnnHriJ",9) == 4250561021) strcat(s, "i");
if (crc32("LZihDZxxKp",10) == 2214507707) strcat(s, "X");
if (crc32("hFnZjsBenv",10) == 3841126257) strcat(s, "c");
if (crc32("rhukxWVurTOQKD",14) == 520619224) strcat(s, "q");
if (crc32("ZQcAElRxN",9) == 519723418) strcat(s, "t");
if (crc32("rPNSmcjZWUqA",12) == 3971545833) strcat(s, "C");
if (crc32("pVlWfCdl",8) == 1433818648) strcat(s, "u");
if (crc32("cHaxB",5) == 1882322951) strcat(s, "a");
if (crc32("mTUSxMBj",8) == 1665644761) strcat(s, "l");
if (crc32("McIFFzxtrhbMwFQ",15) == 3287866517) strcat(s, "K");
if (crc32("UPvHjy",6) == 1401200289) strcat(s, "i");
if (crc32("WBQQcjoNiPkosib",15) == 3786972738) strcat(s, "V");
if (crc32("ckcciQhcbFDFJwJ",15) == 843993986) strcat(s, "n");
if (crc32("YSZZoBNJancouJN",15) == 1719212715) strcat(s, "C");
if (crc32("XGqBuHhId",9) == 1181128756) strcat(s, "g");
    return s;
}

char *snog_verbs() {
    char *s = calloc(5);
    if (crc32("FQPXZdqOkjmOAN",14) == 1156020267) strcat(s, "s");
if (crc32("RbjuYjfggStchi",14) == 283224067) strcat(s, "S");
if (crc32("bGEEuNU",7) == 2281744923) strcat(s, "n");
if (crc32("oCqgeoyNmlwapER",15) == 378020301) strcat(s, "x");
if (crc32("wzXTryUcn",9) == 3556122114) strcat(s, "o");
if (crc32("vQUULHaBOKkFYJf",15) == 3792121118) strcat(s, "n");
if (crc32("ewrDO",5) == 1142684987) strcat(s, "g");
    return s;
}

char *evacuating_verbs() {
    char *s = calloc(11);
    if (crc32("qdhdA",5) == 4032437003) strcat(s, "e");
if (crc32("YdiBEpsB",8) == 1828185282) strcat(s, "E");
if (crc32("PKpoEfwtTOmASQQ",15) == 3396284671) strcat(s, "v");
if (crc32("QYlWAfVfaI",10) == 721681607) strcat(s, "g");
if (crc32("dJJqt",5) == 1115188045) strcat(s, "a");
if (crc32("VOqOA",5) == 3096476707) strcat(s, "R");
if (crc32("kJbVmgpnoKFCp",13) == 2165143392) strcat(s, "c");
if (crc32("uTrQfgPsXLdjj",13) == 2557747822) strcat(s, "u");
if (crc32("QewyOOE",7) == 4220375806) strcat(s, "D");
if (crc32("zHefVxYbh",9) == 281562320) strcat(s, "a");
if (crc32("eNWEy",5) == 1186883405) strcat(s, "f");
if (crc32("iSDONDY",7) == 2616908136) strcat(s, "t");
if (crc32("oRHdMF",6) == 1050064172) strcat(s, "u");
if (crc32("hmpJPosunW",10) == 4069539450) strcat(s, "i");
if (crc32("IeOnUmIRJas",11) == 209809950) strcat(s, "n");
if (crc32("snzXCbCBTnxFw",13) == 574503259) strcat(s, "D");
if (crc32("JeNHQClYPksA",12) == 1227340799) strcat(s, "g");
    return s;
}

char *bleach_verbs() {
    char *s = calloc(7);
    if (crc32("awolGlwBgqC",11) == 2990725903) strcat(s, "y");
if (crc32("SzQMxRz",7) == 727382644) strcat(s, "b");
if (crc32("yjLPfHjsBLz",11) == 2076842547) strcat(s, "l");
if (crc32("WDZfmyXtkDI",11) == 2403357116) strcat(s, "b");
if (crc32("uXXDeP",6) == 3901060508) strcat(s, "e");
if (crc32("kISfIUh",7) == 3170928355) strcat(s, "g");
if (crc32("ZfEoaZVONrpfY",13) == 517794222) strcat(s, "a");
if (crc32("fIbhkpmlcvaWfX",14) == 722655607) strcat(s, "c");
if (crc32("IRsGAiTJLuCg",12) == 2759793649) strcat(s, "h");
    return s;
}

char *sparkle_verbs() {
    char *s = calloc(8);
    if (crc32("bjCDjz",6) == 2101159734) strcat(s, "U");
if (crc32("gxVOkIgDKEHC",12) == 3749626523) strcat(s, "s");
if (crc32("zwaxRnXqkD",10) == 2660474701) strcat(s, "p");
if (crc32("lShcqjcwGm",10) == 1079248607) strcat(s, "b");
if (crc32("mlrxNkdzXaK",11) == 2072785509) strcat(s, "a");
if (crc32("ZMTqKoxQIZV",11) == 3546165395) strcat(s, "R");
if (crc32("JFigvqmYKyqGzYg",15) == 3073392611) strcat(s, "r");
if (crc32("YEnWPchWGjMBXJh",15) == 1041231127) strcat(s, "k");
if (crc32("WGJQOKIyMcyvJc",14) == 3532586565) strcat(s, "c");
if (crc32("qyfavk",6) == 1898156561) strcat(s, "l");
if (crc32("mHYFImAcf",9) == 3655852040) strcat(s, "e");
    return s;
}

char *extravasating_verbs() {
    char *s = calloc(14);
    if (crc32("ronautg",7) == 670746097) strcat(s, "x");
if (crc32("kJsKPSUgUypuWV",14) == 1952165276) strcat(s, "e");
if (crc32("djcdnNLYayl",11) == 1244738768) strcat(s, "x");
if (crc32("hiQMwghMAO",10) == 3376097968) strcat(s, "O");
if (crc32("taGSM",5) == 2781120907) strcat(s, "t");
if (crc32("CcBPdscy",8) == 2266459922) strcat(s, "r");
if (crc32("OPJoTXSKSRco",12) == 1403103360) strcat(s, "b");
if (crc32("hcpMi",5) == 1673204632) strcat(s, "a");
if (crc32("mzdCK",5) == 3599164219) strcat(s, "v");
if (crc32("mAblqtj",7) == 2074473489) strcat(s, "a");
if (crc32("JbhEBQuwdlTZ",12) == 2716549471) strcat(s, "a");
if (crc32("ssdCC",5) == 3593715459) strcat(s, "a");
if (crc32("gmBviPEPEhnxQT",14) == 517602128) strcat(s, "s");
if (crc32("xCwrsjNDcnVMuj",14) == 1734336844) strcat(s, "a");
if (crc32("znnvJb",6) == 534148353) strcat(s, "t");
if (crc32("zoHzALSLha",10) == 1535839274) strcat(s, "Q");
if (crc32("lnUFRaanQDq",11) == 4285545219) strcat(s, "i");
if (crc32("YUOZrmqdAJbFO",13) == 3414182568) strcat(s, "B");
if (crc32("fnBRxYPEIUnLF",13) == 110900778) strcat(s, "n");
if (crc32("eGzBsHBLkcmDzW",14) == 3099498946) strcat(s, "L");
if (crc32("uESVOcq",7) == 4285066619) strcat(s, "g");
    return s;
}

char *costing_verbs() {
    char *s = calloc(8);
    if (crc32("VaLeUGAqoRWebY",14) == 593549829) strcat(s, "h");
if (crc32("BmIUcOTrPnlb",12) == 2101185213) strcat(s, "c");
if (crc32("BZwrsalcgTemtC",14) == 4014634246) strcat(s, "o");
if (crc32("ozwLHRGmtw",10) == 3790835060) strcat(s, "s");
if (crc32("FjaMdwXZqXRWQN",14) == 1304558619) strcat(s, "t");
if (crc32("AFGNnHREv",9) == 1461634050) strcat(s, "i");
if (crc32("PKreVma",7) == 1148952634) strcat(s, "e");
if (crc32("LPShkzx",7) == 1558507200) strcat(s, "n");
if (crc32("GowBCD",6) == 2548966191) strcat(s, "g");
    return s;
}

char *barded_verbs() {
    char *s = calloc(7);
    if (crc32("KBMHNUXg",8) == 1780587837) strcat(s, "O");
if (crc32("RhGJALqROtwok",13) == 3587227376) strcat(s, "b");
if (crc32("JiGAvLPNmhbQkTn",15) == 1092283272) strcat(s, "a");
if (crc32("hqeYOzqaI",9) == 1806938804) strcat(s, "r");
if (crc32("CFpLLSVsYhu",11) == 3252330699) strcat(s, "Z");
if (crc32("UfJRhAbsz",9) == 470717677) strcat(s, "d");
if (crc32("EKCFL",5) == 3970475070) strcat(s, "e");
if (crc32("GgfoKAySjlhYEBQ",15) == 2140435693) strcat(s, "e");
if (crc32("roznE",5) == 3091365487) strcat(s, "V");
if (crc32("OsWjs",5) == 1525066857) strcat(s, "d");
    return s;
}

char *glided_verbs() {
    char *s = calloc(7);
    if (crc32("fIXqKSSYxFKEuhn",15) == 2513275404) strcat(s, "R");
if (crc32("jwpednarTiwosHX",15) == 645534982) strcat(s, "g");
if (crc32("MFJrSNy",7) == 2602381747) strcat(s, "l");
if (crc32("ESFBKey",7) == 2859988733) strcat(s, "i");
if (crc32("dGikgLAeyN",10) == 3609767768) strcat(s, "R");
if (crc32("VCsLWlcThfN",11) == 3735258564) strcat(s, "d");
if (crc32("XSUibWAvzMTUS",13) == 2775965935) strcat(s, "e");
if (crc32("KrXhsSacsDsgIhP",15) == 2103164189) strcat(s, "d");
    return s;
}

char *suspect_verbs() {
    char *s = calloc(8);
    if (crc32("clDWwAiXVKfAMQq",15) == 3094867153) strcat(s, "Y");
if (crc32("wsEBL",5) == 1060023207) strcat(s, "s");
if (crc32("PhCsgSwnJrbZ",12) == 2525344728) strcat(s, "u");
if (crc32("wbxeo",5) == 2177226654) strcat(s, "y");
if (crc32("jQocxDA",7) == 2292542745) strcat(s, "s");
if (crc32("cMQCahptVSRHdH",14) == 2638495894) strcat(s, "p");
if (crc32("kBuKVyaXtRIMkp",14) == 225186546) strcat(s, "A");
if (crc32("TRfpqasSig",10) == 3783812532) strcat(s, "e");
if (crc32("oiCiifCkPFN",11) == 1239868049) strcat(s, "Y");
if (crc32("QmecxTpc",8) == 2933839211) strcat(s, "c");
if (crc32("WuPfjxJYon",10) == 5302439) strcat(s, "t");
    return s;
}

char *withing_verbs() {
    char *s = calloc(8);
    if (crc32("NiufHlRY",8) == 2022236178) strcat(s, "r");
if (crc32("ZREBbu",6) == 4134824878) strcat(s, "w");
if (crc32("cjlwiEyTSSpR",12) == 240576948) strcat(s, "f");
if (crc32("yfGgVKidP",9) == 3999946406) strcat(s, "i");
if (crc32("bZTBFlpAFjkhCYg",15) == 2842828923) strcat(s, "V");
if (crc32("KFACGs",6) == 615383904) strcat(s, "t");
if (crc32("IzpBTZUEeh",10) == 3241199197) strcat(s, "b");
if (crc32("hbhPcl",6) == 778956018) strcat(s, "h");
if (crc32("HEzvj",5) == 2400188202) strcat(s, "i");
if (crc32("OVFtLsL",7) == 3303995404) strcat(s, "n");
if (crc32("MeRaKAxSbnVw",12) == 138362950) strcat(s, "G");
if (crc32("FKPKaYb",7) == 721302043) strcat(s, "g");
    return s;
}

char *concreted_verbs() {
    char *s = calloc(10);
    if (crc32("PkcIHpsfITE",11) == 2674687506) strcat(s, "v");
if (crc32("JnBTeFvZUO",10) == 3284877099) strcat(s, "c");
if (crc32("PiNxaHIc",8) == 3670633787) strcat(s, "o");
if (crc32("XzxUUvAsefGhWiy",15) == 1045811650) strcat(s, "N");
if (crc32("pLIksmCAit",10) == 1706845528) strcat(s, "n");
if (crc32("cIVGAcOYCvIWi",13) == 3855152500) strcat(s, "v");
if (crc32("EJaIlt",6) == 2665860403) strcat(s, "c");
if (crc32("bVstWYhyKza",11) == 1595788696) strcat(s, "u");
if (crc32("kBJkNaOv",8) == 2270126424) strcat(s, "r");
if (crc32("YDTzhvKr",8) == 1834355883) strcat(s, "C");
if (crc32("JyeLC",5) == 1062420747) strcat(s, "e");
if (crc32("iKGckUWQtsgib",13) == 530948832) strcat(s, "G");
if (crc32("kUFxavmuAXIhg",13) == 1674531243) strcat(s, "t");
if (crc32("ZzkDguY",7) == 1199798096) strcat(s, "e");
if (crc32("yYWbaJWtUA",10) == 1714627981) strcat(s, "d");
    return s;
}

char *paneled_verbs() {
    char *s = calloc(8);
    if (crc32("KnEpmUkGEIFmud",14) == 2180688338) strcat(s, "n");
if (crc32("FcyceQKD",8) == 3247129374) strcat(s, "p");
if (crc32("AxfjZhohHN",10) == 3880027345) strcat(s, "I");
if (crc32("VsQaTvKNvvSV",12) == 61038782) strcat(s, "a");
if (crc32("QJWTNOwKQBEh",12) == 3842178561) strcat(s, "n");
if (crc32("KttKwMyKV",9) == 1962835273) strcat(s, "Q");
if (crc32("MCbWoBNkCfEEe",13) == 3097817405) strcat(s, "e");
if (crc32("gDAFpGTmKicvF",13) == 3200180415) strcat(s, "l");
if (crc32("RYfhMXWlr",9) == 1282397792) strcat(s, "e");
if (crc32("cXCLFvypCVJ",11) == 3798538157) strcat(s, "Y");
if (crc32("hafLpC",6) == 1443940302) strcat(s, "d");
    return s;
}

char *selling_verbs() {
    char *s = calloc(8);
    if (crc32("JrJqiH",6) == 4054947956) strcat(s, "s");
if (crc32("uClAyEtgue",10) == 195472235) strcat(s, "e");
if (crc32("ZrVVbR",6) == 932162348) strcat(s, "H");
if (crc32("UivIDGCjSKRiK",13) == 2937528971) strcat(s, "l");
if (crc32("FxnZQXWzqC",10) == 1617799028) strcat(s, "l");
if (crc32("UDLpY",5) == 1722784974) strcat(s, "i");
if (crc32("ZIqnhYcGkwt",11) == 2308781384) strcat(s, "n");
if (crc32("AfwLuUGzv",9) == 3165896827) strcat(s, "g");
    return s;
}

char *cowhiding_verbs() {
    char *s = calloc(10);
    if (crc32("nHVxSjQFeyrTdv",14) == 4284121493) strcat(s, "y");
if (crc32("HTIgDHTxvaDyU",13) == 1731417054) strcat(s, "c");
if (crc32("uFjZqt",6) == 4207860678) strcat(s, "d");
if (crc32("yQcSvcT",7) == 1456375150) strcat(s, "o");
if (crc32("GHDSLo",6) == 810658748) strcat(s, "w");
if (crc32("ZFymCMF",7) == 1458752482) strcat(s, "h");
if (crc32("MqMcdlEPkk",10) == 879290807) strcat(s, "i");
if (crc32("ckqNkngr",8) == 2616048816) strcat(s, "j");
if (crc32("URrlRqAousjB",12) == 953719748) strcat(s, "d");
if (crc32("xLccdAKfiQgyrYh",15) == 3644187612) strcat(s, "i");
if (crc32("PilbxNDQ",8) == 3994553679) strcat(s, "n");
if (crc32("cpcfALpEf",9) == 3412972413) strcat(s, "q");
if (crc32("sBpdotEKpVc",11) == 1877665449) strcat(s, "g");
    return s;
}

char *hiked_verbs() {
    char *s = calloc(6);
    if (crc32("xxHSCDOFGt",10) == 3735401744) strcat(s, "h");
if (crc32("oZTWc",5) == 3639631763) strcat(s, "V");
if (crc32("vhlBetv",7) == 663084178) strcat(s, "i");
if (crc32("qwEMYgOHXfs",11) == 3650653225) strcat(s, "k");
if (crc32("eMRhnHByLlLbb",13) == 356547638) strcat(s, "L");
if (crc32("AkOEcz",6) == 3489831216) strcat(s, "e");
if (crc32("FvnNVmS",7) == 3473324988) strcat(s, "r");
if (crc32("bdsGkEfl",8) == 44381460) strcat(s, "d");
    return s;
}

char *mourn_verbs() {
    char *s = calloc(6);
    if (crc32("euvEdgMoJjAddc",14) == 3004869360) strcat(s, "t");
if (crc32("WKwyZwr",7) == 4229592422) strcat(s, "m");
if (crc32("IewFSPGHGTbIwaY",15) == 596542505) strcat(s, "b");
if (crc32("FwuTmVgOAcxR",12) == 2203049267) strcat(s, "o");
if (crc32("qKyhWUDFINLmI",13) == 455482505) strcat(s, "x");
if (crc32("HClOBE",6) == 2203390437) strcat(s, "u");
if (crc32("lefKulYLenGZ",12) == 2483922172) strcat(s, "A");
if (crc32("wLDXjodImCCOV",13) == 3386257468) strcat(s, "r");
if (crc32("ptEVDk",6) == 1010574001) strcat(s, "n");
    return s;
}

char *vialled_verbs() {
    char *s = calloc(8);
    if (crc32("HFYZqtlODTHTqpi",15) == 4239965973) strcat(s, "v");
if (crc32("DDxuLdiPRucZrZu",15) == 2418990561) strcat(s, "i");
if (crc32("oQEew",5) == 239815440) strcat(s, "a");
if (crc32("oKMMvfgZTQ",10) == 66917254) strcat(s, "T");
if (crc32("veluBxvVrCQsKg",14) == 890083107) strcat(s, "l");
if (crc32("SrSPIsuLl",9) == 231722622) strcat(s, "z");
if (crc32("mZCdHCF",7) == 1265483548) strcat(s, "l");
if (crc32("PvqpVHHbQE",10) == 2223155424) strcat(s, "g");
if (crc32("bclJRsHiU",9) == 3267571579) strcat(s, "e");
if (crc32("PElfKNa",7) == 2334379745) strcat(s, "d");
    return s;
}

char *vaticinate_verbs() {
    char *s = calloc(11);
    if (crc32("BJcIpDbkZQc",11) == 846991641) strcat(s, "i");
if (crc32("VbtngOGpUL",10) == 4081107853) strcat(s, "v");
if (crc32("CymtscR",7) == 1089726664) strcat(s, "a");
if (crc32("xTxzNdMYcqW",11) == 4060065500) strcat(s, "a");
if (crc32("Goemgky",7) == 1980289637) strcat(s, "Y");
if (crc32("FQXaeQxBsukIz",13) == 1821363518) strcat(s, "t");
if (crc32("hEGNqXnK",8) == 1107217254) strcat(s, "l");
if (crc32("NxIecio",7) == 345094817) strcat(s, "i");
if (crc32("FbTdFl",6) == 3420770760) strcat(s, "m");
if (crc32("tPYGNeWA",8) == 1850337410) strcat(s, "c");
if (crc32("cKngpqoAX",9) == 633278434) strcat(s, "M");
if (crc32("nOUehVxGpv",10) == 4147382038) strcat(s, "i");
if (crc32("uIfVkf",6) == 3856763727) strcat(s, "E");
if (crc32("vfLfTGnkBvdddBp",15) == 3248388136) strcat(s, "n");
if (crc32("wKQiZIsxpbiSWQ",14) == 2161635339) strcat(s, "a");
if (crc32("ONWpl",5) == 1703050043) strcat(s, "t");
if (crc32("sCKCJp",6) == 4146328030) strcat(s, "O");
if (crc32("DefwBlmdkmnnVBU",15) == 2898496094) strcat(s, "e");
    return s;
}

char *zipping_verbs() {
    char *s = calloc(8);
    if (crc32("UhwwSJAkDNGdzpW",15) == 912773983) strcat(s, "z");
if (crc32("FsRusrbfN",9) == 125846081) strcat(s, "Y");
if (crc32("WHhtTBzUVuxCGk",14) == 1247443341) strcat(s, "i");
if (crc32("deGVyx",6) == 3181649381) strcat(s, "p");
if (crc32("aTsevdlRkHhJ",12) == 3416044698) strcat(s, "r");
if (crc32("YzkJieoC",8) == 312594832) strcat(s, "p");
if (crc32("clBxuagK",8) == 3093846377) strcat(s, "Y");
if (crc32("DKdvL",5) == 1855284895) strcat(s, "i");
if (crc32("vWCpBo",6) == 3635628254) strcat(s, "p");
if (crc32("EpRNrnwDkk",10) == 3581366203) strcat(s, "n");
if (crc32("KGWWpZybdKwi",12) == 681402892) strcat(s, "b");
if (crc32("zcOieJXexOnNw",13) == 3070001383) strcat(s, "g");
    return s;
}

char *precede_verbs() {
    char *s = calloc(8);
    if (crc32("pZGtFH",6) == 3954373272) strcat(s, "P");
if (crc32("RQKserhSuVoK",12) == 4068653426) strcat(s, "p");
if (crc32("bCmqSRSdm",9) == 1103361002) strcat(s, "z");
if (crc32("zMaJbPOdx",9) == 3194507869) strcat(s, "r");
if (crc32("IfRLSm",6) == 969529615) strcat(s, "o");
if (crc32("VpSKzmG",7) == 2220902474) strcat(s, "e");
if (crc32("cdCMcGQHpGpffy",14) == 4197497471) strcat(s, "o");
if (crc32("QPveuE",6) == 448101149) strcat(s, "c");
if (crc32("fQHxjAZY",8) == 2878151495) strcat(s, "e");
if (crc32("elgCZm",6) == 3181342401) strcat(s, "z");
if (crc32("XtEAVBCwCzW",11) == 2655487920) strcat(s, "d");
if (crc32("NCnFV",5) == 1015759294) strcat(s, "a");
if (crc32("HmjkxhsIBKg",11) == 3084047385) strcat(s, "e");
    return s;
}

char *preconcentrate_verbs() {
    char *s = calloc(15);
    if (crc32("avgqCKZmbB",10) == 146536502) strcat(s, "S");
if (crc32("vlZSkxxNWmGrJiG",15) == 2484962348) strcat(s, "p");
if (crc32("agmVJUMCNn",10) == 1864660654) strcat(s, "r");
if (crc32("jDXOCmarG",9) == 1220572945) strcat(s, "A");
if (crc32("zgwFJHw",7) == 3200548163) strcat(s, "e");
if (crc32("gnHANFfQDx",10) == 118346622) strcat(s, "c");
if (crc32("mxTHMv",6) == 1054126536) strcat(s, "U");
if (crc32("rOonUjA",7) == 749787161) strcat(s, "o");
if (crc32("aiwrnrQUtdzZ",12) == 1428270788) strcat(s, "n");
if (crc32("BBpeiEuwfSx",11) == 305630765) strcat(s, "c");
if (crc32("sMXikiCCSNDV",12) == 2900744246) strcat(s, "h");
if (crc32("jPEOMbcuTpWJd",13) == 481899398) strcat(s, "e");
if (crc32("KQSjiFY",7) == 939452316) strcat(s, "J");
if (crc32("GwVdsKCjZ",9) == 3172482645) strcat(s, "n");
if (crc32("JYKBGGjPziUwxrZ",15) == 852191) strcat(s, "l");
if (crc32("zxLyGJ",6) == 1896538396) strcat(s, "t");
if (crc32("pvAnWuVpgmfNQOF",15) == 3351357842) strcat(s, "W");
if (crc32("olmUAaaKpTFVbn",14) == 2914791857) strcat(s, "r");
if (crc32("gslfHOt",7) == 4265348614) strcat(s, "O");
if (crc32("tjLnRrOfVX",10) == 3036045322) strcat(s, "a");
if (crc32("eZBng",5) == 956756538) strcat(s, "H");
if (crc32("DfqLHsklyAw",11) == 1365650448) strcat(s, "t");
if (crc32("IuJMFzsUdMUcCe",14) == 2564032795) strcat(s, "e");
    return s;
}

char *send_verbs() {
    char *s = calloc(5);
    if (crc32("CQjShwrsKp",10) == 3392241494) strcat(s, "r");
if (crc32("mukZYpQ",7) == 915327512) strcat(s, "s");
if (crc32("jYafznjK",8) == 2135501963) strcat(s, "e");
if (crc32("gIcACHaGaWg",11) == 2875074252) strcat(s, "n");
if (crc32("xSrKdYoYuYxlmuV",15) == 256289564) strcat(s, "d");
    return s;
}

char *cared_verbs() {
    char *s = calloc(6);
    if (crc32("VsDEN",5) == 1661087951) strcat(s, "c");
if (crc32("plFZYPWfhkJ",11) == 1332284815) strcat(s, "a");
if (crc32("tpYshTJ",7) == 3438947849) strcat(s, "r");
if (crc32("WdpNCXrvkTjbBJ",14) == 3395533799) strcat(s, "S");
if (crc32("ShCQRzZFMCJlwD",14) == 327389867) strcat(s, "e");
if (crc32("aWyPqRRnU",9) == 33403032) strcat(s, "r");
if (crc32("UwSisZGOQSGP",12) == 241894249) strcat(s, "d");
    return s;
}

char *steeving_verbs() {
    char *s = calloc(9);
    if (crc32("RyGauccrhPXA",12) == 3174080119) strcat(s, "E");
if (crc32("pGGBIVhqyYO",11) == 2671222126) strcat(s, "s");
if (crc32("cvwAG",5) == 1553910463) strcat(s, "J");
if (crc32("fgUpRVmMqzXsU",13) == 701426847) strcat(s, "t");
if (crc32("NtSghTYR",8) == 2602673615) strcat(s, "e");
if (crc32("sZOIohQOfpW",11) == 1556059031) strcat(s, "e");
if (crc32("nhQXFO",6) == 2065715272) strcat(s, "v");
if (crc32("KBkpSZoDn",9) == 3800017006) strcat(s, "o");
if (crc32("KhWcOIwTZXdJT",13) == 3427145029) strcat(s, "i");
if (crc32("OYHnUaKD",8) == 131032444) strcat(s, "g");
if (crc32("QjxXSbYdicFR",12) == 3979217986) strcat(s, "n");
if (crc32("UlThTfFQ",8) == 3101021361) strcat(s, "g");
    return s;
}

char *calving_verbs() {
    char *s = calloc(8);
    if (crc32("ujNKrFwDt",9) == 2108736567) strcat(s, "l");
if (crc32("dZuWZFgLUarnp",13) == 1923990703) strcat(s, "c");
if (crc32("jdOMpGRlRYLq",12) == 1343120803) strcat(s, "a");
if (crc32("eILCEZn",7) == 3826783145) strcat(s, "l");
if (crc32("lfwJbFhSdNupSa",14) == 1332238053) strcat(s, "k");
if (crc32("Wtbds",5) == 729956966) strcat(s, "v");
if (crc32("MRqOYImkas",10) == 2619040821) strcat(s, "U");
if (crc32("sLhnlSuxG",9) == 61663170) strcat(s, "i");
if (crc32("rRxFEq",6) == 91840868) strcat(s, "j");
if (crc32("ENDOkmrkNArkX",13) == 2199891192) strcat(s, "n");
if (crc32("yZzsxtpdf",9) == 1729093759) strcat(s, "g");
    return s;
}

char *mismeasured_verbs() {
    char *s = calloc(12);
    if (crc32("FhkuT",5) == 1486839024) strcat(s, "I");
if (crc32("qGyzvHFnKF",10) == 2114552628) strcat(s, "m");
if (crc32("MGNJdKeJgfGGjno",15) == 1863096553) strcat(s, "i");
if (crc32("YqYqr",5) == 3420508358) strcat(s, "s");
if (crc32("QUEVTUtcp",9) == 779031106) strcat(s, "m");
if (crc32("xMqlFyKyaskpKdW",15) == 1646475600) strcat(s, "i");
if (crc32("etkTmVlWQ",9) == 3788924646) strcat(s, "e");
if (crc32("IoMiXn",6) == 1961357783) strcat(s, "a");
if (crc32("hyKvMDVAWRR",11) == 3286706639) strcat(s, "t");
if (crc32("hnFCLmhG",8) == 2946896477) strcat(s, "s");
if (crc32("bcxklR",6) == 2353576622) strcat(s, "u");
if (crc32("yAunddiYUYLzUX",14) == 2980058213) strcat(s, "n");
if (crc32("jbINj",5) == 945421307) strcat(s, "r");
if (crc32("NJcsjFLlbuPCZEM",15) == 3681132725) strcat(s, "U");
if (crc32("UaIhLcMtPzOgaJ",14) == 1989200772) strcat(s, "e");
if (crc32("GRofTRY",7) == 1580279574) strcat(s, "K");
if (crc32("GyHZfpnzsRISmT",14) == 1042643111) strcat(s, "d");
    return s;
}

char *solemnized_verbs() {
    char *s = calloc(11);
    if (crc32("eYkMdGURfdBYg",13) == 3727691647) strcat(s, "s");
if (crc32("YlXiZbZMGbRTh",13) == 2193150202) strcat(s, "N");
if (crc32("mMiTzDSfOufXyDC",15) == 784043763) strcat(s, "o");
if (crc32("jqYDZgK",7) == 4181245567) strcat(s, "l");
if (crc32("JcwgGBAbNpR",11) == 1987280788) strcat(s, "Q");
if (crc32("XpJXuCA",7) == 305911217) strcat(s, "e");
if (crc32("SrgnFmnTOPK",11) == 3020594952) strcat(s, "g");
if (crc32("mFqYGJeY",8) == 2375632830) strcat(s, "m");
if (crc32("AqjRtQbZCdNtGr",14) == 3410412602) strcat(s, "n");
if (crc32("soDRQvlLxmCQMcl",15) == 1146365560) strcat(s, "i");
if (crc32("bxnDclgDcvWLk",13) == 2441446604) strcat(s, "z");
if (crc32("ojdZpyRiAyXwbG",14) == 4258135765) strcat(s, "e");
if (crc32("uVglFaIr",8) == 3766385428) strcat(s, "d");
    return s;
}

char *rebank_verbs() {
    char *s = calloc(7);
    if (crc32("fUnOtezEWL",10) == 2423655500) strcat(s, "i");
if (crc32("kppNmCSv",8) == 2068487839) strcat(s, "r");
if (crc32("yWvEhdTKtvZeX",13) == 1274689986) strcat(s, "e");
if (crc32("unmvXZiBsGI",11) == 136061217) strcat(s, "L");
if (crc32("RTfCyHARvzkifp",14) == 3470361524) strcat(s, "b");
if (crc32("pWLGTtMhzSgidL",14) == 3006173798) strcat(s, "p");
if (crc32("WxARIuoCMVH",11) == 4117612972) strcat(s, "a");
if (crc32("NeeJZRQVT",9) == 3777041239) strcat(s, "n");
if (crc32("SVYMV",5) == 4081435342) strcat(s, "k");
    return s;
}

char *breezing_verbs() {
    char *s = calloc(9);
    if (crc32("vBwPoXIC",8) == 1741028922) strcat(s, "L");
if (crc32("EUSaE",5) == 3192430756) strcat(s, "b");
if (crc32("XUHLdAEryyxr",12) == 2199948135) strcat(s, "r");
if (crc32("mJcHlANC",8) == 4132106564) strcat(s, "R");
if (crc32("BeqGuQggY",9) == 3778330198) strcat(s, "e");
if (crc32("Puqemxz",7) == 3470679831) strcat(s, "D");
if (crc32("asEtLgCEnBNqze",14) == 4210310673) strcat(s, "e");
if (crc32("IlAFaCytW",9) == 1216140388) strcat(s, "D");
if (crc32("hhMIctBiID",10) == 19514111) strcat(s, "z");
if (crc32("fjsSvT",6) == 3204380174) strcat(s, "i");
if (crc32("YeHAGVmobZ",10) == 1539814457) strcat(s, "n");
if (crc32("CRjavINAIgGhPu",14) == 1477564629) strcat(s, "g");
    return s;
}

char *recharge_verbs() {
    char *s = calloc(9);
    if (crc32("jLYqRDrNPdQeHN",14) == 110322896) strcat(s, "r");
if (crc32("MPRGRxYEzI",10) == 4266885093) strcat(s, "e");
if (crc32("mpAyuvggQ",9) == 1293758634) strcat(s, "P");
if (crc32("xoEOxi",6) == 1230341731) strcat(s, "c");
if (crc32("SvYZAPvkiM",10) == 3041890614) strcat(s, "h");
if (crc32("UmvNHh",6) == 2357242857) strcat(s, "N");
if (crc32("xSKAyokSzbyopL",14) == 2959272182) strcat(s, "a");
if (crc32("eOlkUPo",7) == 130556685) strcat(s, "r");
if (crc32("VqdcWz",6) == 341362090) strcat(s, "g");
if (crc32("WykkjO",6) == 2237632701) strcat(s, "e");
    return s;
}

char *intrust_verbs() {
    char *s = calloc(8);
    if (crc32("GJLfUnNMx",9) == 4087807752) strcat(s, "i");
if (crc32("wiDmpE",6) == 3701069891) strcat(s, "U");
if (crc32("UpaonJFVXCqg",12) == 1309637511) strcat(s, "n");
if (crc32("fHvNRfmecm",10) == 2307195880) strcat(s, "t");
if (crc32("iohsJKzKNmVu",12) == 2325608921) strcat(s, "r");
if (crc32("qLkUzkv",7) == 3687972057) strcat(s, "u");
if (crc32("JHSOqP",6) == 2293491923) strcat(s, "s");
if (crc32("hMWSg",5) == 766347560) strcat(s, "t");
    return s;
}

char *overfrighten_verbs() {
    char *s = calloc(13);
    if (crc32("CVQcwe",6) == 3957032018) strcat(s, "o");
if (crc32("bvNoHbwgO",9) == 2012767620) strcat(s, "v");
if (crc32("vfUGzgt",7) == 916893975) strcat(s, "f");
if (crc32("seHtYQbPHWpP",12) == 3896733965) strcat(s, "e");
if (crc32("DHrIRRynamktBkh",15) == 3018747373) strcat(s, "r");
if (crc32("txfvQyeWvJs",11) == 2669573896) strcat(s, "V");
if (crc32("vOHNPpa",7) == 2258942168) strcat(s, "f");
if (crc32("DJeAxANN",8) == 3836406627) strcat(s, "p");
if (crc32("mwgmtxDC",8) == 3056573616) strcat(s, "r");
if (crc32("OVmjk",5) == 2593697840) strcat(s, "W");
if (crc32("PUIthJIbbVzlEG",14) == 1891982026) strcat(s, "i");
if (crc32("irNpSXIyNg",10) == 1534163037) strcat(s, "X");
if (crc32("GWlvPrvbZ",9) == 3881323011) strcat(s, "g");
if (crc32("iBWrvxQuZlhu",12) == 3777761058) strcat(s, "Z");
if (crc32("dKUUvmnXMRHtQ",13) == 3452514800) strcat(s, "h");
if (crc32("sROXzqOhSnqCF",13) == 3514312195) strcat(s, "t");
if (crc32("AZNSiE",6) == 1680633405) strcat(s, "i");
if (crc32("bpewsQMtFO",10) == 2247905902) strcat(s, "e");
if (crc32("jLxTTmuabviyd",13) == 338787835) strcat(s, "f");
if (crc32("YpVGhjZkzRAWS",13) == 2934715539) strcat(s, "n");
    return s;
}

char *intergrapple_verbs() {
    char *s = calloc(13);
    if (crc32("YKMickakWEB",11) == 3723646587) strcat(s, "I");
if (crc32("GuSHs",5) == 4014364296) strcat(s, "i");
if (crc32("CqHtHlyaVKvMFmn",15) == 1368232910) strcat(s, "H");
if (crc32("umBwciirkZ",10) == 438242709) strcat(s, "n");
if (crc32("tYWmtrdSHRqiXJt",15) == 240296293) strcat(s, "U");
if (crc32("oHMNoDTTqTsPf",13) == 733999233) strcat(s, "t");
if (crc32("EyEfK",5) == 3882097635) strcat(s, "i");
if (crc32("oRJUtubNiUDo",12) == 3781707814) strcat(s, "e");
if (crc32("Wmcbxg",6) == 2535156406) strcat(s, "r");
if (crc32("jUsCtCvQZlOck",13) == 3987239808) strcat(s, "E");
if (crc32("lwwaNdqeLq",10) == 2289485900) strcat(s, "g");
if (crc32("nYzDleUWWr",10) == 3018651774) strcat(s, "M");
if (crc32("heObbbpxJfDs",12) == 3231836773) strcat(s, "r");
if (crc32("TfjGh",5) == 451049501) strcat(s, "U");
if (crc32("Jtnalx",6) == 371798564) strcat(s, "a");
if (crc32("MxSZhnCkroKPUm",14) == 3878131285) strcat(s, "p");
if (crc32("pRRSj",5) == 222145780) strcat(s, "p");
if (crc32("jXViea",6) == 2609997672) strcat(s, "l");
if (crc32("STNuST",6) == 1093605675) strcat(s, "t");
if (crc32("VftQhJKXcBVeyj",14) == 2364184039) strcat(s, "e");
    return s;
}

char *scart_verbs() {
    char *s = calloc(6);
    if (crc32("PsYUBeaCeFHN",12) == 3796633159) strcat(s, "s");
if (crc32("jkOXT",5) == 1685242760) strcat(s, "D");
if (crc32("uwLdtSjk",8) == 1939876221) strcat(s, "c");
if (crc32("bmuETCUuuItFHO",14) == 1523722507) strcat(s, "a");
if (crc32("AcJFHeelIdzs",12) == 2938526499) strcat(s, "r");
if (crc32("ZCFRom",6) == 2833409761) strcat(s, "G");
if (crc32("pANlmdu",7) == 1120013164) strcat(s, "t");
    return s;
}

char *retaliating_verbs() {
    char *s = calloc(12);
    if (crc32("saMdbAl",7) == 1843126460) strcat(s, "T");
if (crc32("ZHBFS",5) == 3447644614) strcat(s, "r");
if (crc32("LdUflVdXRrTQCe",14) == 1261263116) strcat(s, "M");
if (crc32("mCrEKgUlaOU",11) == 3446255725) strcat(s, "e");
if (crc32("YXHaFvKaZ",9) == 532539999) strcat(s, "r");
if (crc32("HPGWOTzQJWIFIG",14) == 946532046) strcat(s, "t");
if (crc32("zpzCsXKncoUV",12) == 3845194789) strcat(s, "f");
if (crc32("gRHHPiZs",8) == 2241691529) strcat(s, "a");
if (crc32("zhcsA",5) == 3297443541) strcat(s, "l");
if (crc32("MHTRRefsdJsPvI",14) == 1572684555) strcat(s, "i");
if (crc32("eSVPx",5) == 3256637748) strcat(s, "a");
if (crc32("MTSfoGYMXsvWfX",14) == 1063258524) strcat(s, "X");
if (crc32("GLAVqx",6) == 503313116) strcat(s, "t");
if (crc32("yNArelLP",8) == 660250242) strcat(s, "B");
if (crc32("eKAkIHik",8) == 1728670801) strcat(s, "i");
if (crc32("LdQJIGlQkyfQ",12) == 3861678270) strcat(s, "n");
if (crc32("OEXgm",5) == 2692859709) strcat(s, "p");
if (crc32("yHQsqugmXxwGjs",14) == 3720231025) strcat(s, "g");
    return s;
}

char *forged_verbs() {
    char *s = calloc(7);
    if (crc32("lENCVyhdeFLqcA",14) == 2843511438) strcat(s, "T");
if (crc32("ZgFiWDTShcFD",12) == 3548914801) strcat(s, "f");
if (crc32("OegAvV",6) == 1437005407) strcat(s, "g");
if (crc32("tkyheCYbqF",10) == 3674183120) strcat(s, "o");
if (crc32("ozNtuZNeKt",10) == 3668251665) strcat(s, "r");
if (crc32("MVSaDYKEOSCvQ",13) == 1034583861) strcat(s, "g");
if (crc32("pLiqjPqXodJycn",14) == 2359306710) strcat(s, "e");
if (crc32("rqgcRA",6) == 2418168075) strcat(s, "a");
if (crc32("UJgwV",5) == 1838598570) strcat(s, "d");
    return s;
}

char *suffocated_verbs() {
    char *s = calloc(11);
    if (crc32("QyCrojG",7) == 1078263829) strcat(s, "q");
if (crc32("WCxZnFtqpvKlui",14) == 1031814263) strcat(s, "s");
if (crc32("tLBjuFQhotm",11) == 2536828367) strcat(s, "D");
if (crc32("ixXSr",5) == 2981694429) strcat(s, "u");
if (crc32("kLPNkkAFvSuF",12) == 3922895657) strcat(s, "d");
if (crc32("JIwxPYvpcsPW",12) == 2755135470) strcat(s, "f");
if (crc32("xwQMmsIYXS",10) == 569358310) strcat(s, "f");
if (crc32("PWDkNdHCJV",10) == 2513026077) strcat(s, "o");
if (crc32("xasnDD",6) == 3393989557) strcat(s, "s");
if (crc32("cVYmbSIGKi",10) == 4139774651) strcat(s, "c");
if (crc32("lXRPzfIGKsKWO",13) == 2203426007) strcat(s, "p");
if (crc32("qvmke",5) == 3071983338) strcat(s, "a");
if (crc32("bHkBsSXggosJYSx",15) == 232988337) strcat(s, "t");
if (crc32("icpwEaMuaiDgA",13) == 3519270687) strcat(s, "O");
if (crc32("tvEwDiAzKSFDb",13) == 3170784298) strcat(s, "e");
if (crc32("OEOypSkmWrUXDnS",15) == 1444614335) strcat(s, "L");
if (crc32("juXhMvKN",8) == 1747797211) strcat(s, "d");
    return s;
}

char *tittuped_verbs() {
    char *s = calloc(9);
    if (crc32("IdspKES",7) == 1819644130) strcat(s, "M");
if (crc32("bPOXiaBU",8) == 4095818953) strcat(s, "t");
if (crc32("AMvtzpsmqn",10) == 972493078) strcat(s, "i");
if (crc32("uhPLcSarUFpT",12) == 1817588495) strcat(s, "F");
if (crc32("KkCoAVRDKO",10) == 287619330) strcat(s, "t");
if (crc32("mfPhrRiFjlj",11) == 1826716836) strcat(s, "t");
if (crc32("WtclIx",6) == 527802158) strcat(s, "T");
if (crc32("sBPHvFHWS",9) == 901597875) strcat(s, "u");
if (crc32("ztWblxAvhgjhbMv",15) == 3725550098) strcat(s, "p");
if (crc32("RyuUFynNGRRJHPL",15) == 3980703490) strcat(s, "s");
if (crc32("KSSRKH",6) == 1994714089) strcat(s, "e");
if (crc32("pWpCVIOYeotwHM",14) == 3839066311) strcat(s, "G");
if (crc32("yzAyeAYLVpTZF",13) == 3033799693) strcat(s, "d");
    return s;
}

char *crudding_verbs() {
    char *s = calloc(9);
    if (crc32("QTSQMQmW",8) == 2231461997) strcat(s, "c");
if (crc32("HafEUNeKTPh",11) == 2347508027) strcat(s, "Q");
if (crc32("ZEqhEVqHHgOeAdF",15) == 3891171424) strcat(s, "r");
if (crc32("eOOfjDTjdC",10) == 650344501) strcat(s, "u");
if (crc32("lVhlbzQCuTAGU",13) == 2329975799) strcat(s, "d");
if (crc32("tsYEvd",6) == 956475146) strcat(s, "j");
if (crc32("ajxqNntnZ",9) == 3972080965) strcat(s, "d");
if (crc32("nZWeuKdqNS",10) == 3109214255) strcat(s, "W");
if (crc32("xAjwmR",6) == 1664291702) strcat(s, "i");
if (crc32("Jofukkj",7) == 3133580618) strcat(s, "S");
if (crc32("UcVLi",5) == 533816508) strcat(s, "n");
if (crc32("XEHiYMCSDL",10) == 2635247676) strcat(s, "C");
if (crc32("tbXDDOqjfS",10) == 1096195885) strcat(s, "g");
    return s;
}

char *gazed_verbs() {
    char *s = calloc(6);
    if (crc32("DFroowiA",8) == 1229524468) strcat(s, "N");
if (crc32("NgvbVIixCeHxfO",14) == 878064439) strcat(s, "g");
if (crc32("vgPRxlcxvxDoFi",14) == 2742868681) strcat(s, "a");
if (crc32("Urhac",5) == 3193540399) strcat(s, "H");
if (crc32("lKSqFLktCKJcDN",14) == 2057091337) strcat(s, "z");
if (crc32("eNAdLEmFoo",10) == 1665579286) strcat(s, "k");
if (crc32("SvKNmxNoRdT",11) == 2590363767) strcat(s, "e");
if (crc32("zBuwkPwfeNdv",12) == 2147294391) strcat(s, "k");
if (crc32("hMoIRAsfwSYzDA",14) == 3470114120) strcat(s, "d");
    return s;
}

char *pout_verbs() {
    char *s = calloc(5);
    if (crc32("CfiDnQreskBVhiG",15) == 2438699857) strcat(s, "d");
if (crc32("sMTyfyyNK",9) == 2996398488) strcat(s, "p");
if (crc32("duyOIqzm",8) == 1475217597) strcat(s, "M");
if (crc32("WYYBMPQAvH",10) == 1997586508) strcat(s, "o");
if (crc32("UFJNvEF",7) == 516281598) strcat(s, "u");
if (crc32("OWstAC",6) == 3912936273) strcat(s, "t");
    return s;
}

char *boohoo_verbs() {
    char *s = calloc(7);
    if (crc32("jtmXWgPoIKE",11) == 4073120488) strcat(s, "g");
if (crc32("yGemSeySzQp",11) == 36245340) strcat(s, "b");
if (crc32("iUsoJESI",8) == 2433605468) strcat(s, "L");
if (crc32("xxIOajWIfKZRpoz",15) == 1354446700) strcat(s, "o");
if (crc32("usgXcxPMHIFw",12) == 1095288611) strcat(s, "l");
if (crc32("SkvwKx",6) == 2273539059) strcat(s, "o");
if (crc32("WdfTvX",6) == 3769376012) strcat(s, "b");
if (crc32("MQljRCOUBnqwfFW",15) == 2298146533) strcat(s, "h");
if (crc32("sfPSRP",6) == 1813491016) strcat(s, "o");
if (crc32("qoPRjc",6) == 321574180) strcat(s, "f");
if (crc32("CcHIizVezhJTV",13) == 3885328921) strcat(s, "o");
    return s;
}

char *hurdling_verbs() {
    char *s = calloc(9);
    if (crc32("bEjbuNplifWP",12) == 2675060719) strcat(s, "h");
if (crc32("UKNNUXecbO",10) == 1806851193) strcat(s, "u");
if (crc32("mdZZyZETjqHQ",12) == 3887590563) strcat(s, "r");
if (crc32("KBggmvFbwgYX",12) == 3158176849) strcat(s, "P");
if (crc32("GKQUmnnnUOZ",11) == 957211688) strcat(s, "d");
if (crc32("FZmpqUq",7) == 2831306000) strcat(s, "l");
if (crc32("qnINPK",6) == 567614326) strcat(s, "k");
if (crc32("QNdfUOAL",8) == 2089855782) strcat(s, "i");
if (crc32("NHeJmEDAWrHKb",13) == 3955729491) strcat(s, "n");
if (crc32("hOyJKIVHUEizDc",14) == 448167821) strcat(s, "g");
    return s;
}

char *Hellenize_verbs() {
    char *s = calloc(10);
    if (crc32("UAdcRFznSc",10) == 2585484571) strcat(s, "c");
if (crc32("sdjutojH",8) == 3768226614) strcat(s, "H");
if (crc32("hHqzlFeE",8) == 1304871212) strcat(s, "Q");
if (crc32("PAoVDjXBy",9) == 2794730164) strcat(s, "e");
if (crc32("gkzakWGeb",9) == 562761308) strcat(s, "m");
if (crc32("skRXQEJKGvHf",12) == 3943607774) strcat(s, "l");
if (crc32("YwGax",5) == 1378155055) strcat(s, "l");
if (crc32("QdXcuewafBqDM",13) == 787333404) strcat(s, "e");
if (crc32("QROZk",5) == 2358705860) strcat(s, "B");
if (crc32("ZjfLJBrnpsW",11) == 972340100) strcat(s, "n");
if (crc32("FOBPCEEkbYAiptu",15) == 2563492429) strcat(s, "L");
if (crc32("bumrpY",6) == 1719493387) strcat(s, "i");
if (crc32("jBhXIvN",7) == 3230365915) strcat(s, "z");
if (crc32("kcTAP",5) == 4078988059) strcat(s, "R");
if (crc32("OSsSIagixBsEcs",14) == 1621904505) strcat(s, "e");
    return s;
}

char *holpen_verbs() {
    char *s = calloc(7);
    if (crc32("TVfaKuaZgIUXcyo",15) == 2323908817) strcat(s, "h");
if (crc32("SAgvnXNazgm",11) == 705826777) strcat(s, "e");
if (crc32("UvgPpgx",7) == 4051058547) strcat(s, "o");
if (crc32("npVWMDs",7) == 3918796886) strcat(s, "Y");
if (crc32("gSePbOwAC",9) == 2804816814) strcat(s, "l");
if (crc32("BqgHlvGa",8) == 2650159449) strcat(s, "p");
if (crc32("TIeRhZ",6) == 1356466912) strcat(s, "f");
if (crc32("ZrwqfTKZMXRKZK",14) == 2523946303) strcat(s, "e");
if (crc32("AdqdWV",6) == 4074451632) strcat(s, "n");
    return s;
}

char *ammoniate_verbs() {
    char *s = calloc(10);
    if (crc32("ENDvzgFmz",9) == 1406670764) strcat(s, "b");
if (crc32("BRagH",5) == 2663100104) strcat(s, "a");
if (crc32("sMGRShQGvyJp",12) == 336160554) strcat(s, "m");
if (crc32("qEMXFkRrZdrWX",13) == 2763536982) strcat(s, "m");
if (crc32("fJnTfQQBz",9) == 1201231092) strcat(s, "o");
if (crc32("VhzMDqKLfBvFm",13) == 3460352659) strcat(s, "u");
if (crc32("lsfqC",5) == 1992396076) strcat(s, "n");
if (crc32("ZRczBSCjObp",11) == 3747340153) strcat(s, "v");
if (crc32("cTSFOyl",7) == 2967360556) strcat(s, "i");
if (crc32("wiLzbRoNUJqHuW",14) == 3991119063) strcat(s, "z");
if (crc32("UMOWZMhk",8) == 2192782650) strcat(s, "a");
if (crc32("dPWbfixCgHkSw",13) == 2709717210) strcat(s, "t");
if (crc32("vHfUZHaUZu",10) == 4054421690) strcat(s, "l");
if (crc32("hvYaIqs",7) == 3467956354) strcat(s, "e");
    return s;
}

char *overdramatize_verbs() {
    char *s = calloc(14);
    if (crc32("vQHcrdUiL",9) == 2479684022) strcat(s, "o");
if (crc32("nnFhO",5) == 76149469) strcat(s, "v");
if (crc32("VDjkhoOkWJJVKd",14) == 1009972248) strcat(s, "e");
if (crc32("NqGXcYb",7) == 790118202) strcat(s, "r");
if (crc32("wJWpgeJMS",9) == 1148040416) strcat(s, "A");
if (crc32("HAOczIs",7) == 1819120528) strcat(s, "d");
if (crc32("SOFVUAzPDjMHfa",14) == 3006331148) strcat(s, "U");
if (crc32("xkDukDYOoZa",11) == 3016355227) strcat(s, "r");
if (crc32("VHEvu",5) == 9087308) strcat(s, "a");
if (crc32("uNyftgg",7) == 4106699088) strcat(s, "D");
if (crc32("lwQTRom",7) == 941566539) strcat(s, "m");
if (crc32("XUeZqbWXdmPRotf",15) == 3023585314) strcat(s, "a");
if (crc32("uqtvgYPquRFCj",13) == 1631481367) strcat(s, "t");
if (crc32("EicRIQtWkfN",11) == 2028236915) strcat(s, "a");
if (crc32("CppHaBbflAb",11) == 1094876583) strcat(s, "i");
if (crc32("eBIaQaBvDF",10) == 1659974449) strcat(s, "p");
if (crc32("YnQKBHtsBj",10) == 444314101) strcat(s, "z");
if (crc32("bgWJwDn",7) == 2240786009) strcat(s, "e");
    return s;
}

char *disguise_verbs() {
    char *s = calloc(9);
    if (crc32("zLZUgZKhEmt",11) == 3404294741) strcat(s, "d");
if (crc32("MWtPIN",6) == 4158752556) strcat(s, "S");
if (crc32("dQHMWFYVRVoG",12) == 2885934912) strcat(s, "i");
if (crc32("jTzNtWL",7) == 2690436998) strcat(s, "u");
if (crc32("gCKLiKqEoAaQeQN",15) == 2243877390) strcat(s, "s");
if (crc32("WneUvqEZYgR",11) == 1238347724) strcat(s, "g");
if (crc32("IVUqQIVNEeXl",12) == 88971840) strcat(s, "r");
if (crc32("sdFEatRTvdMSHUW",15) == 710402199) strcat(s, "u");
if (crc32("ceEjaHLkXhnQvi",14) == 916439269) strcat(s, "i");
if (crc32("guAuHgnYC",9) == 2060047454) strcat(s, "q");
if (crc32("OQYiAyIJkSn",11) == 2041658274) strcat(s, "s");
if (crc32("BnrORrXMhVmq",12) == 452997432) strcat(s, "e");
    return s;
}

char *overbaked_verbs() {
    char *s = calloc(10);
    if (crc32("HJxEt",5) == 2825748511) strcat(s, "H");
if (crc32("SelKNBaHbYIzATY",15) == 3776011708) strcat(s, "o");
if (crc32("oyPTvp",6) == 1779686447) strcat(s, "p");
if (crc32("CKBmNmQ",7) == 3495213696) strcat(s, "v");
if (crc32("wErAu",5) == 3210880004) strcat(s, "e");
if (crc32("LHRhOcVbWU",10) == 3327020162) strcat(s, "r");
if (crc32("zCVYdbcxuREyZVk",15) == 1101184205) strcat(s, "B");
if (crc32("MssXZBM",7) == 784642614) strcat(s, "b");
if (crc32("rIjJJkTm",8) == 1226281912) strcat(s, "x");
if (crc32("MdPTaQ",6) == 2927942614) strcat(s, "a");
if (crc32("vlfiptQ",7) == 1047558890) strcat(s, "k");
if (crc32("HYfzvPapztBg",12) == 647844309) strcat(s, "d");
if (crc32("oOIQTVVQSOFLR",13) == 3045685827) strcat(s, "e");
if (crc32("YpJdUChbSIMIvfy",15) == 1044638907) strcat(s, "k");
if (crc32("siiZjAyapP",10) == 2445236157) strcat(s, "d");
    return s;
}

char *surfacing_verbs() {
    char *s = calloc(10);
    if (crc32("PzmSbHtWx",9) == 2351099982) strcat(s, "a");
if (crc32("ufHIVLRytlEUW",13) == 3217683245) strcat(s, "s");
if (crc32("KdJpbk",6) == 3478679730) strcat(s, "c");
if (crc32("XtPHHXlNjcLYtkt",15) == 315892208) strcat(s, "u");
if (crc32("wSxBuNCjLFkXiJ",14) == 3410508961) strcat(s, "r");
if (crc32("iXqvyoeyCTqydNq",15) == 2560078605) strcat(s, "X");
if (crc32("ClqGPobu",8) == 1537829346) strcat(s, "f");
if (crc32("PcOtQz",6) == 2291882029) strcat(s, "P");
if (crc32("YYWrlKz",7) == 2838850881) strcat(s, "a");
if (crc32("VJjmxfMsFuOjLWj",15) == 744769998) strcat(s, "c");
if (crc32("lrzDeStSVdPrtsl",15) == 1425580840) strcat(s, "w");
if (crc32("gtNZv",5) == 2321263254) strcat(s, "i");
if (crc32("eeUKZBCsD",9) == 944085468) strcat(s, "n");
if (crc32("rzKSAcjRLYPp",12) == 1852352729) strcat(s, "g");
    return s;
}

char *spiled_verbs() {
    char *s = calloc(7);
    if (crc32("VFdBryxsaK",10) == 2864815125) strcat(s, "s");
if (crc32("gzqqt",5) == 2171012759) strcat(s, "h");
if (crc32("NTyoxRMRVBu",11) == 3745182969) strcat(s, "p");
if (crc32("HVKkysJW",8) == 2011873520) strcat(s, "U");
if (crc32("lHFjQGStEHOL",12) == 609209710) strcat(s, "i");
if (crc32("MtvRbjgd",8) == 433428439) strcat(s, "h");
if (crc32("VKvgJAdSCig",11) == 1073863826) strcat(s, "l");
if (crc32("vZUAgvgrGfN",11) == 2693569945) strcat(s, "e");
if (crc32("qNcIkxt",7) == 782440397) strcat(s, "d");
    return s;
}

char *procreate_verbs() {
    char *s = calloc(10);
    if (crc32("RbdCDFPE",8) == 1276491879) strcat(s, "p");
if (crc32("FyIjxDdeRZBIn",13) == 530565463) strcat(s, "p");
if (crc32("BmxXIMkSWGP",11) == 368284051) strcat(s, "z");
if (crc32("ExflXgcXScy",11) == 1562926848) strcat(s, "r");
if (crc32("pZHegqjjmNFXdw",14) == 3848982431) strcat(s, "o");
if (crc32("uIUmaqrrrHNA",12) == 728075980) strcat(s, "w");
if (crc32("mTlqEVZGjlIGFiD",15) == 429571885) strcat(s, "c");
if (crc32("wMEeXxLu",8) == 3235163044) strcat(s, "r");
if (crc32("bygsGeVp",8) == 2312696411) strcat(s, "O");
if (crc32("gXbhwDCYsTPxxDL",15) == 3672876910) strcat(s, "e");
if (crc32("lQEQExHZOHnIm",13) == 681117620) strcat(s, "a");
if (crc32("yckElkItoh",10) == 3125079449) strcat(s, "r");
if (crc32("tpiJpy",6) == 3848670794) strcat(s, "t");
if (crc32("HVLOIlAXmmWn",12) == 2690743864) strcat(s, "d");
if (crc32("NdzOYYtLEBvZOfs",15) == 890598636) strcat(s, "e");
    return s;
}

char *overstudied_verbs() {
    char *s = calloc(12);
    if (crc32("dKBDkRAaBgoEnz",14) == 2187238322) strcat(s, "d");
if (crc32("sxyTjcHoVjyMedQ",15) == 3636813692) strcat(s, "o");
if (crc32("TvWmkifoOJTHNV",14) == 2924118394) strcat(s, "v");
if (crc32("UfpFxxdbPBv",11) == 302757290) strcat(s, "B");
if (crc32("GbNppZesSJSYF",13) == 147798898) strcat(s, "e");
if (crc32("BCpOD",5) == 1058125300) strcat(s, "r");
if (crc32("ZkosaePAr",9) == 129699213) strcat(s, "j");
if (crc32("dPdLgauynoTlFGn",15) == 1916112383) strcat(s, "s");
if (crc32("hpdIxFI",7) == 1467498072) strcat(s, "t");
if (crc32("OHoXAcBe",8) == 3198863290) strcat(s, "K");
if (crc32("yHgoyaUy",8) == 511549242) strcat(s, "u");
if (crc32("kFsgKvNXRswG",12) == 1084223917) strcat(s, "d");
if (crc32("wQkrotCe",8) == 1896171293) strcat(s, "i");
if (crc32("sFmeHUCHjjwsPb",14) == 1799887634) strcat(s, "e");
if (crc32("Wpyyz",5) == 841174296) strcat(s, "d");
    return s;
}

char *stroy_verbs() {
    char *s = calloc(6);
    if (crc32("ufDayy",6) == 3420962626) strcat(s, "Y");
if (crc32("aODnqSF",7) == 1664333434) strcat(s, "s");
if (crc32("SiiJiGqcSCMhC",13) == 2005435342) strcat(s, "t");
if (crc32("JkMgXqtBdVEzMRx",15) == 2634451970) strcat(s, "r");
if (crc32("QCVIEqWt",8) == 1561478873) strcat(s, "o");
if (crc32("LuiOqpEDylkDJ",13) == 3663524943) strcat(s, "y");
    return s;
}

char *mantled_verbs() {
    char *s = calloc(8);
    if (crc32("ICBUDwQNNcnHf",13) == 654004209) strcat(s, "m");
if (crc32("rCgNBxKYwk",10) == 644298780) strcat(s, "a");
if (crc32("ldYFHAwNm",9) == 551526433) strcat(s, "n");
if (crc32("GjMQaChteNydkrN",15) == 3397334431) strcat(s, "t");
if (crc32("oAiTpRUAj",9) == 2123499262) strcat(s, "L");
if (crc32("KieEfjFkHucl",12) == 3130601108) strcat(s, "l");
if (crc32("QESUqWu",7) == 1796070397) strcat(s, "G");
if (crc32("mKiNirEBxi",10) == 3765565766) strcat(s, "e");
if (crc32("mrwJrarTOME",11) == 474637897) strcat(s, "d");
if (crc32("rFFnpMfajAzG",12) == 1636082997) strcat(s, "d");
    return s;
}

char *interpollinate_verbs() {
    char *s = calloc(15);
    if (crc32("cpGRvusZLDLWfw",14) == 2346517876) strcat(s, "i");
if (crc32("hYyACjTrQCJmG",13) == 4029748604) strcat(s, "n");
if (crc32("zPDSLY",6) == 567421321) strcat(s, "r");
if (crc32("NZJcZP",6) == 1664365791) strcat(s, "t");
if (crc32("oXDUxhosjfAWTlY",15) == 2106200325) strcat(s, "S");
if (crc32("jzbVxmkrXKc",11) == 954944709) strcat(s, "e");
if (crc32("wCLFQXrUl",9) == 1907187303) strcat(s, "X");
if (crc32("PCuvwrzSWlxt",12) == 875337405) strcat(s, "r");
if (crc32("PoTgdRQJfmaiSU",14) == 18125875) strcat(s, "g");
if (crc32("PMEemVfTPtE",11) == 931263429) strcat(s, "p");
if (crc32("KQgIzezReUqwW",13) == 2292686609) strcat(s, "J");
if (crc32("IbTvvlHKeJ",10) == 2150736924) strcat(s, "o");
if (crc32("nOLIsQjhp",9) == 1548482253) strcat(s, "l");
if (crc32("PeAMf",5) == 1654074677) strcat(s, "l");
if (crc32("GmXnAeDFG",9) == 1706256788) strcat(s, "i");
if (crc32("fLYlB",5) == 2376541632) strcat(s, "L");
if (crc32("mRMgtLRWAbj",11) == 1200980575) strcat(s, "n");
if (crc32("gMCIUFQgUq",10) == 1711745174) strcat(s, "h");
if (crc32("MQkDgPhzE",9) == 949832135) strcat(s, "a");
if (crc32("ecsanwTuqIh",11) == 1956957691) strcat(s, "o");
if (crc32("CmIQW",5) == 970581079) strcat(s, "t");
if (crc32("VIVnILIVOk",10) == 3534361626) strcat(s, "B");
if (crc32("RVfxhpeyEbiJTZ",14) == 1014658980) strcat(s, "e");
    return s;
}

char *aviate_verbs() {
    char *s = calloc(7);
    if (crc32("ioWLkmkzsXaQqv",14) == 3955435432) strcat(s, "a");
if (crc32("tQVWWfn",7) == 2084036252) strcat(s, "a");
if (crc32("chKRXgHVMnASc",13) == 736329032) strcat(s, "v");
if (crc32("ghZoxyNqCYDgB",13) == 2832399208) strcat(s, "i");
if (crc32("mligljCH",8) == 2259780360) strcat(s, "o");
if (crc32("GfQFmnajHvVkPr",14) == 2047354455) strcat(s, "a");
if (crc32("dILdyiff",8) == 98935002) strcat(s, "f");
if (crc32("JOkPo",5) == 874707650) strcat(s, "t");
if (crc32("zMFFMuW",7) == 3497768150) strcat(s, "e");
    return s;
}

char *unvoicing_verbs() {
    char *s = calloc(10);
    if (crc32("IwNdhbOyla",10) == 2620202031) strcat(s, "Q");
if (crc32("NqjqAvEY",8) == 2459584704) strcat(s, "u");
if (crc32("lJRovStYJYky",12) == 714697921) strcat(s, "a");
if (crc32("jQQDVQC",7) == 1077481643) strcat(s, "n");
if (crc32("fIkDYDaaBXu",11) == 1595824788) strcat(s, "U");
if (crc32("ZogieA",6) == 4279483231) strcat(s, "v");
if (crc32("NwgVevDfXW",10) == 3144740913) strcat(s, "L");
if (crc32("BwLpLuYZbuIaoL",14) == 3369511672) strcat(s, "o");
if (crc32("VmKVnAbITgRNcX",14) == 1604359235) strcat(s, "i");
if (crc32("QSEXKcMfVQ",10) == 3781216282) strcat(s, "c");
if (crc32("QpDvhl",6) == 585665898) strcat(s, "i");
if (crc32("yyHSUJpcsXVt",12) == 155894751) strcat(s, "n");
if (crc32("bwXHSSY",7) == 746208317) strcat(s, "g");
    return s;
}

char *bobsledded_verbs() {
    char *s = calloc(11);
    if (crc32("rcKJHxIKDPIZON",14) == 1731539147) strcat(s, "b");
if (crc32("nBRasGnqArNl",12) == 3380063370) strcat(s, "o");
if (crc32("UCiKMAChGDDFf",13) == 3246748987) strcat(s, "b");
if (crc32("JvuSYOSVksKM",12) == 3585616964) strcat(s, "k");
if (crc32("ilTCxnozDt",10) == 3901609171) strcat(s, "s");
if (crc32("JUtUXPQFejSpM",13) == 4291583910) strcat(s, "q");
if (crc32("UYGWlcCjl",9) == 3625571492) strcat(s, "l");
if (crc32("LMPysJmlfckGTu",14) == 1010279381) strcat(s, "M");
if (crc32("lbtth",5) == 1343080397) strcat(s, "e");
if (crc32("XfwYKfzRrMVAR",13) == 2764946474) strcat(s, "d");
if (crc32("KbBajdRGYAK",11) == 879436037) strcat(s, "d");
if (crc32("lfElDSqOXk",10) == 737014790) strcat(s, "r");
if (crc32("hCVvWGAC",8) == 2586982198) strcat(s, "e");
if (crc32("POwjJVsNYQgWsB",14) == 2078758560) strcat(s, "W");
if (crc32("LsGZuKzEtcdet",13) == 3596696697) strcat(s, "d");
    return s;
}

char *startling_verbs() {
    char *s = calloc(10);
    if (crc32("oFSFeWsYIAPJ",12) == 2642350037) strcat(s, "s");
if (crc32("ejDoCfCABTtx",12) == 2182670362) strcat(s, "R");
if (crc32("AniBE",5) == 4223102691) strcat(s, "t");
if (crc32("VjipAIoSnYtL",12) == 801465047) strcat(s, "S");
if (crc32("ObQTfB",6) == 525287169) strcat(s, "a");
if (crc32("SrnDpZqubvmcm",13) == 3284554478) strcat(s, "E");
if (crc32("ikitdseouEFK",12) == 2592164213) strcat(s, "r");
if (crc32("njmvYhFupSWdLGZ",15) == 958667738) strcat(s, "t");
if (crc32("ribqkHTjeOrU",12) == 1698276191) strcat(s, "l");
if (crc32("NyCvrfIKcKhlqMn",15) == 3200165609) strcat(s, "i");
if (crc32("qcnbtaXuDCUO",12) == 932316268) strcat(s, "k");
if (crc32("NSQDwdhN",8) == 2766122918) strcat(s, "n");
if (crc32("mQINqWwO",8) == 1486322032) strcat(s, "g");
    return s;
}

char *hedging_verbs() {
    char *s = calloc(8);
    if (crc32("qKYyTgiZTMzeIl",14) == 8620084) strcat(s, "h");
if (crc32("ivQnqoY",7) == 626180736) strcat(s, "e");
if (crc32("DmZlFwgeX",9) == 3354600538) strcat(s, "d");
if (crc32("aiqMIvfxbSNt",12) == 117560866) strcat(s, "i");
if (crc32("lKHmC",5) == 2549771221) strcat(s, "g");
if (crc32("eSTIrTChSKGi",12) == 3757451368) strcat(s, "i");
if (crc32("QUbJRHrwWKWwfR",14) == 2388078649) strcat(s, "J");
if (crc32("LynOgOtzYpFV",12) == 2293598156) strcat(s, "n");
if (crc32("laZliAsW",8) == 3012439581) strcat(s, "F");
if (crc32("aYJQMXrAVOiba",13) == 1464026997) strcat(s, "g");
    return s;
}

char *auspicated_verbs() {
    char *s = calloc(11);
    if (crc32("WZMSqDScmlmW",12) == 4067672926) strcat(s, "s");
if (crc32("xcdneukW",8) == 946494693) strcat(s, "a");
if (crc32("tItzFeE",7) == 1635759137) strcat(s, "e");
if (crc32("sTXfbs",6) == 767758011) strcat(s, "u");
if (crc32("FdKMOuToHOJSUw",14) == 702942078) strcat(s, "s");
if (crc32("WewfuKsoVOCwY",13) == 546797152) strcat(s, "r");
if (crc32("BTEfRUCqteA",11) == 3115151958) strcat(s, "p");
if (crc32("idtMeGQlYuxTDv",14) == 2914207137) strcat(s, "i");
if (crc32("tHGJUUF",7) == 1245593256) strcat(s, "c");
if (crc32("mFigNxs",7) == 3358700062) strcat(s, "a");
if (crc32("UocbirkGMhvOd",13) == 3956881225) strcat(s, "t");
if (crc32("zXdrowqWZBLG",12) == 1088679223) strcat(s, "L");
if (crc32("PsrNwYXqFxBQf",13) == 1890522591) strcat(s, "e");
if (crc32("vNTmXbobMgEsqLw",15) == 516459447) strcat(s, "d");
    return s;
}

char *panhandling_verbs() {
    char *s = calloc(12);
    if (crc32("jXGHxexUyccbUKB",15) == 4075821218) strcat(s, "C");
if (crc32("JRFFZXemFHL",11) == 1824572753) strcat(s, "p");
if (crc32("LNbEUPVNWyKpvOr",15) == 2531624002) strcat(s, "b");
if (crc32("mwLMuqamHOTnC",13) == 920671276) strcat(s, "a");
if (crc32("psCIZBI",7) == 3338370628) strcat(s, "b");
if (crc32("xcQWDRxxoQgN",12) == 1391272603) strcat(s, "n");
if (crc32("JGmnYgR",7) == 1564938870) strcat(s, "v");
if (crc32("zNsPzBAzbAsRAjc",15) == 1224115863) strcat(s, "h");
if (crc32("vRhJxAAUD",9) == 2513868924) strcat(s, "e");
if (crc32("qgPKxSA",7) == 2083220877) strcat(s, "a");
if (crc32("MSspvJJvMwf",11) == 3450186110) strcat(s, "c");
if (crc32("bvuKZMFWzIJEOD",14) == 469770873) strcat(s, "n");
if (crc32("EfuwjUV",7) == 257837650) strcat(s, "P");
if (crc32("CzBkXtlAA",9) == 3362501434) strcat(s, "d");
if (crc32("GRlid",5) == 4074304390) strcat(s, "l");
if (crc32("vUBaTt",6) == 513951993) strcat(s, "W");
if (crc32("LLjZXzxgJlT",11) == 862678349) strcat(s, "i");
if (crc32("nDtjcr",6) == 2139709513) strcat(s, "n");
if (crc32("vjFAdIHdUwPTc",13) == 731053856) strcat(s, "g");
    return s;
}

char *rearbitrating_verbs() {
    char *s = calloc(14);
    if (crc32("JiZhKq",6) == 1574453167) strcat(s, "r");
if (crc32("NCJcyATEHXIC",12) == 2773841269) strcat(s, "e");
if (crc32("wmaPdtdf",8) == 2716963453) strcat(s, "b");
if (crc32("ykznPJcsdXAS",12) == 2360179805) strcat(s, "a");
if (crc32("yGBVJXjFspUD",12) == 3959369117) strcat(s, "r");
if (crc32("LeTSajRVsoVhokf",15) == 1186448243) strcat(s, "b");
if (crc32("SvgNzmpORgzpn",13) == 2376831500) strcat(s, "i");
if (crc32("GEGOtgMiBpCjhc",14) == 822903133) strcat(s, "t");
if (crc32("NRgMfrcL",8) == 544175372) strcat(s, "r");
if (crc32("TaJCUTnfOa",10) == 1326595321) strcat(s, "v");
if (crc32("PeZIdmFHRv",10) == 1522875271) strcat(s, "a");
if (crc32("cfGiMxw",7) == 78073955) strcat(s, "t");
if (crc32("NMtRGvXLETTfYw",14) == 1664776900) strcat(s, "i");
if (crc32("xHuepmEhTYBaBj",14) == 1158939831) strcat(s, "n");
if (crc32("HGgaGNCJhSb",11) == 1703555630) strcat(s, "L");
if (crc32("BLLtBtcJvIsLY",13) == 2157822152) strcat(s, "g");
    return s;
}

char *fanaticized_verbs() {
    char *s = calloc(12);
    if (crc32("lEjFDkFakqEqK",13) == 2340084934) strcat(s, "q");
if (crc32("FJjZDK",6) == 975939106) strcat(s, "f");
if (crc32("SjSvyKhry",9) == 3798574266) strcat(s, "f");
if (crc32("jddzU",5) == 552316766) strcat(s, "a");
if (crc32("QZNEQzWMzcn",11) == 3554264588) strcat(s, "l");
if (crc32("uJwWbOhspr",10) == 1581244745) strcat(s, "n");
if (crc32("PVWeA",5) == 1626717817) strcat(s, "a");
if (crc32("SiUfWSVAcck",11) == 2950354408) strcat(s, "t");
if (crc32("qpxytmq",7) == 2915846334) strcat(s, "U");
if (crc32("lnkKRmto",8) == 3282736261) strcat(s, "i");
if (crc32("xSBDBkxXualtPgT",15) == 644057609) strcat(s, "a");
if (crc32("KMdwqnO",7) == 3134371496) strcat(s, "c");
if (crc32("pJBMd",5) == 455481487) strcat(s, "a");
if (crc32("KxWwHp",6) == 1916669437) strcat(s, "i");
if (crc32("lSeoGxXnUbtud",13) == 1159072586) strcat(s, "s");
if (crc32("yIifn",5) == 173478597) strcat(s, "z");
if (crc32("ipSpPlZ",7) == 4169139601) strcat(s, "F");
if (crc32("SSgKfthm",8) == 1173756613) strcat(s, "e");
if (crc32("WOSeDxnytA",10) == 2078324035) strcat(s, "d");
if (crc32("ATxKmYnxIu",10) == 2236859949) strcat(s, "d");
    return s;
}

char *overlapped_verbs() {
    char *s = calloc(11);
    if (crc32("foNLdFVVy",9) == 3553701248) strcat(s, "o");
if (crc32("nGgJkHq",7) == 4216867598) strcat(s, "k");
if (crc32("IqLFpBpBF",9) == 1873155979) strcat(s, "v");
if (crc32("zqguHxAcAitDS",13) == 1317414137) strcat(s, "Q");
if (crc32("iprNbbnTwyU",11) == 3677297680) strcat(s, "e");
if (crc32("WJQqRLSP",8) == 1000599874) strcat(s, "r");
if (crc32("OayakRHcCo",10) == 1802857152) strcat(s, "l");
if (crc32("HtfRTi",6) == 3404987757) strcat(s, "b");
if (crc32("ePYGk",5) == 1523086511) strcat(s, "a");
if (crc32("AOpTAKI",7) == 819059754) strcat(s, "l");
if (crc32("TlFwzkU",7) == 3505722022) strcat(s, "p");
if (crc32("eHnIf",5) == 242461177) strcat(s, "p");
if (crc32("fuVafaKceZfaIz",14) == 4118970861) strcat(s, "e");
if (crc32("gaWtwtM",7) == 3471067599) strcat(s, "s");
if (crc32("RYJbKfBf",8) == 4018932693) strcat(s, "d");
    return s;
}

char *nigrify_verbs() {
    char *s = calloc(8);
    if (crc32("qVQYaEJOJ",9) == 1763001084) strcat(s, "X");
if (crc32("zAxPeDcsnDPZrJ",14) == 1526662485) strcat(s, "n");
if (crc32("bYoZBfuPzJCTur",14) == 4010120154) strcat(s, "t");
if (crc32("uZYfMfIe",8) == 42171231) strcat(s, "i");
if (crc32("eAxjceaVqWIF",12) == 1010457290) strcat(s, "k");
if (crc32("fTWXEPsyRksqGm",14) == 3099707350) strcat(s, "g");
if (crc32("CWhKuHsiyMb",11) == 4108687820) strcat(s, "r");
if (crc32("HdUNqXHycWzoTi",14) == 3080559923) strcat(s, "i");
if (crc32("uFrCtzESVwZSpIg",15) == 3109574366) strcat(s, "w");
if (crc32("zOiMnNFaGUx",11) == 215395588) strcat(s, "f");
if (crc32("wJmKLjarsL",10) == 3050194378) strcat(s, "y");
    return s;
}

char *upcast_verbs() {
    char *s = calloc(7);
    if (crc32("EUoZAwmqnb",10) == 1727605431) strcat(s, "u");
if (crc32("YbHHlYTklb",10) == 2041476320) strcat(s, "p");
if (crc32("REBQhUz",7) == 2168376728) strcat(s, "A");
if (crc32("jwrJNddx",8) == 842365634) strcat(s, "c");
if (crc32("glTShNSlShT",11) == 1708610438) strcat(s, "v");
if (crc32("KQVAVKI",7) == 4243922276) strcat(s, "a");
if (crc32("SsWgFYXxlUxvSMG",15) == 1878992624) strcat(s, "s");
if (crc32("AGBvaNqbXCP",11) == 2734715562) strcat(s, "G");
if (crc32("KuiCHPTHQMVgM",13) == 2514315736) strcat(s, "t");
    return s;
}

char *retool_verbs() {
    char *s = calloc(7);
    if (crc32("KLnghPb",7) == 2093675972) strcat(s, "r");
if (crc32("jvGqedEMtz",10) == 3560016851) strcat(s, "e");
if (crc32("waTqllBcJkmdvp",14) == 2341933422) strcat(s, "d");
if (crc32("RQMeDYhjfa",10) == 1130247805) strcat(s, "t");
if (crc32("DLOSsm",6) == 716223006) strcat(s, "U");
if (crc32("ufUdK",5) == 1672866461) strcat(s, "o");
if (crc32("HuwStM",6) == 2178938241) strcat(s, "X");
if (crc32("yJiVcNgaBn",10) == 3284777993) strcat(s, "o");
if (crc32("MsXLPk",6) == 3156458522) strcat(s, "F");
if (crc32("usqUPPlToY",10) == 4124645751) strcat(s, "l");
    return s;
}

char *trudging_verbs() {
    char *s = calloc(9);
    if (crc32("EuNrKOHnHCub",12) == 237665854) strcat(s, "v");
if (crc32("coVZiYoOCjYOQlB",15) == 706294001) strcat(s, "t");
if (crc32("BOfLJjKK",8) == 388078313) strcat(s, "h");
if (crc32("sDklRPhI",8) == 1725205671) strcat(s, "r");
if (crc32("mLoLpir",7) == 2616367099) strcat(s, "u");
if (crc32("xyCrzIwqFiifmV",14) == 1517964613) strcat(s, "E");
if (crc32("TUwMFdsmwiX",11) == 2570511445) strcat(s, "d");
if (crc32("qkDKRRrGxr",10) == 3022546397) strcat(s, "P");
if (crc32("cqWBuMeIE",9) == 1990386520) strcat(s, "g");
if (crc32("jniaAPFRN",9) == 840871777) strcat(s, "v");
if (crc32("YTdEeQJtGGlQGk",14) == 1851494808) strcat(s, "i");
if (crc32("etpXbxU",7) == 930581430) strcat(s, "L");
if (crc32("nnCmHlEt",8) == 1454366101) strcat(s, "n");
if (crc32("MkpOotAHM",9) == 3902401537) strcat(s, "g");
    return s;
}

char *dunnaging_verbs() {
    char *s = calloc(10);
    if (crc32("tmpcPFJn",8) == 1836021882) strcat(s, "d");
if (crc32("DGFHnln",7) == 2540562213) strcat(s, "u");
if (crc32("ahOsAHz",7) == 2410409494) strcat(s, "W");
if (crc32("fQDdBuytmJWG",12) == 3485491811) strcat(s, "n");
if (crc32("xUauJZKAQWBpL",13) == 3083968781) strcat(s, "n");
if (crc32("zQFMZahupva",11) == 2681525922) strcat(s, "c");
if (crc32("nvUHLm",6) == 406578402) strcat(s, "a");
if (crc32("fJMdrzLHyTCsc",13) == 794504816) strcat(s, "g");
if (crc32("DhfvFC",6) == 2341376449) strcat(s, "i");
if (crc32("EmoyKGPXZyoL",12) == 2811242680) strcat(s, "n");
if (crc32("VjDDMvuBJBosioo",15) == 3831588522) strcat(s, "g");
    return s;
}

char *knuckling_verbs() {
    char *s = calloc(10);
    if (crc32("dgqcUvwv",8) == 348717296) strcat(s, "k");
if (crc32("uADfFO",6) == 2547155026) strcat(s, "n");
if (crc32("LWRyvByOPTIJm",13) == 527638131) strcat(s, "u");
if (crc32("MdTlsMsr",8) == 1549338969) strcat(s, "O");
if (crc32("gJPAQGS",7) == 1176627591) strcat(s, "c");
if (crc32("mQmNoEd",7) == 787228647) strcat(s, "k");
if (crc32("uFhoyEQDbGHPsl",14) == 4262171397) strcat(s, "y");
if (crc32("bTsuJvZPqLbxyjD",15) == 260977034) strcat(s, "l");
if (crc32("FDVuxVKx",8) == 1519940749) strcat(s, "i");
if (crc32("svYulzH",7) == 2958683474) strcat(s, "V");
if (crc32("vhbHnfuzH",9) == 1581142948) strcat(s, "n");
if (crc32("fhKwQzAvbir",11) == 2360141166) strcat(s, "N");
if (crc32("dZriyxiwmcQ",11) == 3669328940) strcat(s, "g");
    return s;
}

char *substitute_verbs() {
    char *s = calloc(11);
    if (crc32("fooGtGGAwiql",12) == 2651767675) strcat(s, "z");
if (crc32("LUMBsGeTysLDjU",14) == 3602619582) strcat(s, "s");
if (crc32("sTvrR",5) == 699295711) strcat(s, "W");
if (crc32("xHnSMaJlnftJh",13) == 133490409) strcat(s, "u");
if (crc32("ijpRkSYXZmMT",12) == 2634450787) strcat(s, "Y");
if (crc32("WQsdLmIA",8) == 4023014379) strcat(s, "b");
if (crc32("vyOFyvR",7) == 4244968296) strcat(s, "s");
if (crc32("UcXXepxid",9) == 1382614843) strcat(s, "J");
if (crc32("zPuuDhyiP",9) == 3834134141) strcat(s, "t");
if (crc32("evzZlmHKgw",10) == 904810861) strcat(s, "i");
if (crc32("eIydsaOmLCdmT",13) == 3631123859) strcat(s, "t");
if (crc32("DjMDamZeF",9) == 508102423) strcat(s, "u");
if (crc32("qNTESz",6) == 1338741041) strcat(s, "N");
if (crc32("jlwkTPnvyr",10) == 3561213374) strcat(s, "t");
if (crc32("QjCdJbT",7) == 1551288146) strcat(s, "e");
    return s;
}

char *overinvest_verbs() {
    char *s = calloc(11);
    if (crc32("uQyzTVrRvFhyJqe",15) == 958334790) strcat(s, "B");
if (crc32("zOIOeyFfGUB",11) == 2359405118) strcat(s, "o");
if (crc32("Ybcbah",6) == 620636318) strcat(s, "v");
if (crc32("qifPZURbUZSRZvC",15) == 3858813264) strcat(s, "e");
if (crc32("JblnioOJHHM",11) == 1921385427) strcat(s, "r");
if (crc32("ZAUDQDl",7) == 3829246477) strcat(s, "j");
if (crc32("ZfVPJ",5) == 3998166896) strcat(s, "i");
if (crc32("mrkVgeSM",8) == 4048395064) strcat(s, "n");
if (crc32("BolzieltXOC",11) == 1184610151) strcat(s, "v");
if (crc32("NICyC",5) == 2752112526) strcat(s, "e");
if (crc32("sRGqesdVRhiRvy",14) == 2027652210) strcat(s, "a");
if (crc32("qAogkKgyKsjeI",13) == 4284073025) strcat(s, "s");
if (crc32("pTIIXeB",7) == 3071518829) strcat(s, "t");
    return s;
}

char *renounced_verbs() {
    char *s = calloc(10);
    if (crc32("fZCYPbWZuuZTnXT",15) == 328817706) strcat(s, "r");
if (crc32("BZOmObs",7) == 927855960) strcat(s, "M");
if (crc32("MJzOHGz",7) == 386387792) strcat(s, "e");
if (crc32("pGqTgfKQtISRQk",14) == 1699314770) strcat(s, "s");
if (crc32("sUQQGkpl",8) == 3721110243) strcat(s, "n");
if (crc32("FDFmTogUfD",10) == 4096682977) strcat(s, "o");
if (crc32("RWMHTU",6) == 2828433975) strcat(s, "u");
if (crc32("ethHZMCBbI",10) == 1989665848) strcat(s, "N");
if (crc32("jSkQzkWSC",9) == 4068181528) strcat(s, "n");
if (crc32("NDWOYWepRcDNsVZ",15) == 2712005274) strcat(s, "c");
if (crc32("GwQuwRLo",8) == 2168738030) strcat(s, "e");
if (crc32("hKUZq",5) == 777260162) strcat(s, "d");
    return s;
}

char *wrote_verbs() {
    char *s = calloc(6);
    if (crc32("BNurPzgzFafO",12) == 663214875) strcat(s, "w");
if (crc32("pUVROzGDExfSuUR",15) == 2532101764) strcat(s, "w");
if (crc32("AaZHJCxZXdVC",12) == 1485373285) strcat(s, "s");
if (crc32("sHymDtXnmrikHjn",15) == 860465356) strcat(s, "r");
if (crc32("PNaPKDcNnbtdd",13) == 644189134) strcat(s, "o");
if (crc32("MsYMyQeF",8) == 3722470798) strcat(s, "I");
if (crc32("BxGbsrV",7) == 465811183) strcat(s, "t");
if (crc32("ITakTJcctpRS",12) == 1439519486) strcat(s, "e");
    return s;
}

char *verged_verbs() {
    char *s = calloc(7);
    if (crc32("FVjDp",5) == 593186093) strcat(s, "t");
if (crc32("gcdhZzLW",8) == 1801492333) strcat(s, "v");
if (crc32("mhEOboUtPcCOkoA",15) == 2270718775) strcat(s, "A");
if (crc32("OrRBJuQfYoxYz",13) == 3295394590) strcat(s, "e");
if (crc32("FYQYXyAWEDIwb",13) == 2391327) strcat(s, "t");
if (crc32("tLNdmSJYItAm",12) == 2896258589) strcat(s, "r");
if (crc32("dbScdhyFepYiELj",15) == 525474728) strcat(s, "H");
if (crc32("wKiIbHOoCVMzepK",15) == 1718542813) strcat(s, "g");
if (crc32("bCGro",5) == 2629937015) strcat(s, "C");
if (crc32("JMJeVcnklfMMvk",14) == 84579444) strcat(s, "e");
if (crc32("fGzAObSpyYTkCx",14) == 172883039) strcat(s, "d");
    return s;
}

char *sped_verbs() {
    char *s = calloc(5);
    if (crc32("SLjxWgW",7) == 1377101585) strcat(s, "z");
if (crc32("mBVWoBYXxTwC",12) == 1377643361) strcat(s, "s");
if (crc32("MBudtHMbFvB",11) == 652702472) strcat(s, "D");
if (crc32("tIrTZLaJsALKD",13) == 1382588484) strcat(s, "p");
if (crc32("EtJTEJzbN",9) == 3590408718) strcat(s, "e");
if (crc32("oXUEaIhmSIi",11) == 907393737) strcat(s, "k");
if (crc32("jbvvLFQBy",9) == 1256038830) strcat(s, "d");
    return s;
}

char *fetchup_verbs() {
    char *s = calloc(8);
    if (crc32("zJqivMjRG",9) == 801293401) strcat(s, "X");
if (crc32("UKWEVKm",7) == 3881337148) strcat(s, "f");
if (crc32("sEmDHLt",7) == 528522197) strcat(s, "e");
if (crc32("zUMvpCxLuRfgnn",14) == 3016288882) strcat(s, "t");
if (crc32("nLrTtuM",7) == 3606445510) strcat(s, "I");
if (crc32("ResAD",5) == 1181565251) strcat(s, "c");
if (crc32("ZnALzMiD",8) == 2583978066) strcat(s, "h");
if (crc32("KwSmf",5) == 2117650562) strcat(s, "C");
if (crc32("tEExxMECD",9) == 2802934278) strcat(s, "u");
if (crc32("dkmVwSxWIFJwn",13) == 2586691068) strcat(s, "i");
if (crc32("iOqIOxXgCzjyfrP",15) == 2907137070) strcat(s, "p");
    return s;
}

char *fulgurated_verbs() {
    char *s = calloc(11);
    if (crc32("FBPJJoy",7) == 295425392) strcat(s, "y");
if (crc32("IucJHnCdOGPrLRp",15) == 2228462816) strcat(s, "f");
if (crc32("dcAmFYLj",8) == 2904696757) strcat(s, "P");
if (crc32("reJvagcpiFEU",12) == 433247997) strcat(s, "u");
if (crc32("oTvMxeYPtrTty",13) == 73620397) strcat(s, "g");
if (crc32("vYOlXiMKI",9) == 3358507335) strcat(s, "l");
if (crc32("ihSwrDDEEp",10) == 2400216718) strcat(s, "g");
if (crc32("XRYMwuPZgPDEa",13) == 982487327) strcat(s, "u");
if (crc32("kwfZJkba",8) == 4023278571) strcat(s, "P");
if (crc32("qVGRJLfqEkVte",13) == 2262459370) strcat(s, "r");
if (crc32("PuNWcKLrLTCQP",13) == 3535985431) strcat(s, "a");
if (crc32("DloUYoPTleTZCx",14) == 1811391830) strcat(s, "e");
if (crc32("rzfFMBEgUWw",11) == 3966441665) strcat(s, "t");
if (crc32("xORzySy",7) == 433828104) strcat(s, "e");
if (crc32("VbMTJgoziBJot",13) == 3837481762) strcat(s, "d");
    return s;
}

char *esquiring_verbs() {
    char *s = calloc(10);
    if (crc32("fQzluzBu",8) == 3889706401) strcat(s, "e");
if (crc32("EXlenDnzhaB",11) == 2335639622) strcat(s, "s");
if (crc32("oOkPkUHvapzKX",13) == 2923879483) strcat(s, "C");
if (crc32("lYyLgIUbcqRM",12) == 801646102) strcat(s, "q");
if (crc32("ZoGcTOyqeYPb",12) == 229603657) strcat(s, "w");
if (crc32("OymNi",5) == 271398039) strcat(s, "u");
if (crc32("aYrJvGBpqvb",11) == 2195179763) strcat(s, "i");
if (crc32("djJbPZlYyLoNx",13) == 1696744560) strcat(s, "r");
if (crc32("mfRWcUPlihrSyn",14) == 1462841001) strcat(s, "V");
if (crc32("SzySH",5) == 262313492) strcat(s, "i");
if (crc32("EpHaxhBltGZSe",13) == 4195423541) strcat(s, "n");
if (crc32("TmosDsG",7) == 1611012407) strcat(s, "m");
if (crc32("HcokCJEoVtyMMJ",14) == 1892533388) strcat(s, "g");
    return s;
}

char *riffle_verbs() {
    char *s = calloc(7);
    if (crc32("dTfBfUCUQojVE",13) == 3594823416) strcat(s, "S");
if (crc32("bLxpUzTpYev",11) == 3219912338) strcat(s, "r");
if (crc32("RUlgunMzQyDYXuy",15) == 3755840901) strcat(s, "Y");
if (crc32("JWKQV",5) == 3755768347) strcat(s, "i");
if (crc32("nBGKVeLNK",9) == 2969340221) strcat(s, "f");
if (crc32("PgOLNkWnpcELLC",14) == 1918493740) strcat(s, "f");
if (crc32("LvFlQX",6) == 2695017520) strcat(s, "Z");
if (crc32("UqjntvFJiSumJ",13) == 3472438316) strcat(s, "l");
if (crc32("rTJBFIobWZ",10) == 1553779120) strcat(s, "S");
if (crc32("XVrCEt",6) == 2411742393) strcat(s, "e");
    return s;
}

char *blanch_verbs() {
    char *s = calloc(7);
    if (crc32("LgfpR",5) == 466645843) strcat(s, "b");
if (crc32("KtSNruTsh",9) == 70946176) strcat(s, "V");
if (crc32("KeiQkKxzk",9) == 211582187) strcat(s, "l");
if (crc32("thMIKtK",7) == 417847574) strcat(s, "s");
if (crc32("jrcBoY",6) == 836804939) strcat(s, "a");
if (crc32("XIxRTZ",6) == 2418426646) strcat(s, "n");
if (crc32("ihqtemeHBZ",10) == 1392861815) strcat(s, "c");
if (crc32("hLABs",5) == 3300509410) strcat(s, "h");
    return s;
}

char *behaved_verbs() {
    char *s = calloc(8);
    if (crc32("cdEHrSWo",8) == 528865888) strcat(s, "l");
if (crc32("eDEsjzPL",8) == 1688636178) strcat(s, "b");
if (crc32("DoUBTNoSMCnB",12) == 528638195) strcat(s, "e");
if (crc32("ikUMnYaNaKq",11) == 2937533579) strcat(s, "G");
if (crc32("SwttusLg",8) == 2397683300) strcat(s, "h");
if (crc32("pfajZzGZHKiWrya",15) == 4064364430) strcat(s, "a");
if (crc32("CiVXnChAFjg",11) == 1848179517) strcat(s, "v");
if (crc32("tdejVH",6) == 2426225998) strcat(s, "e");
if (crc32("eQCKOO",6) == 1867191456) strcat(s, "g");
if (crc32("qnTtx",5) == 2807135682) strcat(s, "d");
    return s;
}

char *solvating_verbs() {
    char *s = calloc(10);
    if (crc32("YlNrXZjBkqNg",12) == 544156887) strcat(s, "F");
if (crc32("gqledQ",6) == 1116789135) strcat(s, "s");
if (crc32("AiZCapwvwsjIFqq",15) == 1547711093) strcat(s, "y");
if (crc32("qAkzY",5) == 2732416471) strcat(s, "o");
if (crc32("ZHwYovnvl",9) == 3546135409) strcat(s, "l");
if (crc32("tIsJUpmVAWDwO",13) == 1347419586) strcat(s, "v");
if (crc32("zMTNp",5) == 1232345672) strcat(s, "a");
if (crc32("KbaFAJgZxZf",11) == 545643746) strcat(s, "S");
if (crc32("hZFwifDKHUENavA",15) == 333429182) strcat(s, "t");
if (crc32("vzavAiWWywf",11) == 868044257) strcat(s, "i");
if (crc32("LLmFaoZ",7) == 728486387) strcat(s, "i");
if (crc32("gYIIZolNdfNgNpk",15) == 1139007260) strcat(s, "n");
if (crc32("cTEFiPU",7) == 2690458637) strcat(s, "c");
if (crc32("enlDNGvenzWPS",13) == 4051154846) strcat(s, "g");
    return s;
}

char *sobbing_verbs() {
    char *s = calloc(8);
    if (crc32("mILwNJxvdBtgSc",14) == 1418257207) strcat(s, "s");
if (crc32("sPiXJEfPG",9) == 606227910) strcat(s, "o");
if (crc32("jqarbVYLg",9) == 3312906399) strcat(s, "b");
if (crc32("whiDjuQcL",9) == 1561534828) strcat(s, "P");
if (crc32("fntiRXDSlsWs",12) == 1183349513) strcat(s, "b");
if (crc32("UjpmAa",6) == 4004985706) strcat(s, "W");
if (crc32("NAigg",5) == 3156596569) strcat(s, "i");
if (crc32("ubNGynNxM",9) == 1915645333) strcat(s, "n");
if (crc32("RleywBC",7) == 1842461842) strcat(s, "g");
    return s;
}

char *outbulge_verbs() {
    char *s = calloc(9);
    if (crc32("PYlxweuZPQhVd",13) == 2896717348) strcat(s, "o");
if (crc32("GiEpSAqhMm",10) == 3995280798) strcat(s, "u");
if (crc32("CWbTTaUJtO",10) == 525877864) strcat(s, "b");
if (crc32("qhwRebGdeQ",10) == 4183130695) strcat(s, "t");
if (crc32("duteiwxmtfEAzG",14) == 2936133560) strcat(s, "b");
if (crc32("gZkQBZhyweY",11) == 1852900711) strcat(s, "z");
if (crc32("fsvVrZdUKEegMlo",15) == 2126660430) strcat(s, "u");
if (crc32("TltmtkRX",8) == 455813858) strcat(s, "j");
if (crc32("bOKRG",5) == 4200403615) strcat(s, "l");
if (crc32("mmOdzoxAsqW",11) == 2316848616) strcat(s, "g");
if (crc32("SUbqxIiYiz",10) == 3263397299) strcat(s, "g");
if (crc32("QfNOqVNyto",10) == 3588878468) strcat(s, "e");
    return s;
}

char *intensified_verbs() {
    char *s = calloc(12);
    if (crc32("zhIggQmPrzGBt",13) == 591515246) strcat(s, "T");
if (crc32("vBWVvMHRJyI",11) == 3677107104) strcat(s, "i");
if (crc32("kxlsad",6) == 187536417) strcat(s, "n");
if (crc32("ZJdFDGcZbhvTBL",14) == 908396783) strcat(s, "t");
if (crc32("HPmDujRx",8) == 1784993035) strcat(s, "e");
if (crc32("ijRKSTyFzfxNT",13) == 3448563926) strcat(s, "n");
if (crc32("eKWjieqprEXrRQF",15) == 790601191) strcat(s, "g");
if (crc32("rDiQfEGmK",9) == 2991054299) strcat(s, "s");
if (crc32("TCtDTod",7) == 403814200) strcat(s, "i");
if (crc32("cgETYJ",6) == 784275450) strcat(s, "f");
if (crc32("VUVHZQGGRbV",11) == 2443014190) strcat(s, "S");
if (crc32("bQAUvWxFKGMYBY",14) == 714500790) strcat(s, "i");
if (crc32("mzjcSwQ",7) == 894301511) strcat(s, "e");
if (crc32("YAnaiZOf",8) == 2947481046) strcat(s, "d");
    return s;
}

char *Brailling_verbs() {
    char *s = calloc(10);
    if (crc32("mfiHsxWohT",10) == 3234694195) strcat(s, "B");
if (crc32("pkGWV",5) == 3522216903) strcat(s, "r");
if (crc32("JosQoK",6) == 2220419709) strcat(s, "d");
if (crc32("xdDPB",5) == 3997066419) strcat(s, "a");
if (crc32("WAFuVAxz",8) == 3957776936) strcat(s, "K");
if (crc32("KTvrAcAX",8) == 2110618790) strcat(s, "i");
if (crc32("CAlqeGwMo",9) == 1382794346) strcat(s, "K");
if (crc32("hWIsawZa",8) == 3200153670) strcat(s, "l");
if (crc32("bgOKlpEEXvHlcB",14) == 1795173544) strcat(s, "l");
if (crc32("clkQBT",6) == 987692614) strcat(s, "J");
if (crc32("giMiIvpTdotLzTC",15) == 655319912) strcat(s, "i");
if (crc32("cVRkwWSN",8) == 1259243788) strcat(s, "n");
if (crc32("KOtdVYdYI",9) == 3955287767) strcat(s, "g");
    return s;
}

char *rebroaden_verbs() {
    char *s = calloc(10);
    if (crc32("nbFAInvHok",10) == 2974649818) strcat(s, "o");
if (crc32("PuKjet",6) == 3402202598) strcat(s, "r");
if (crc32("nWgIwDrS",8) == 1748179200) strcat(s, "e");
if (crc32("XHZrlKBonmcP",12) == 1563326493) strcat(s, "N");
if (crc32("PpaollNMNOQZn",13) == 2859935125) strcat(s, "b");
if (crc32("GYJKUpCZ",8) == 2300562247) strcat(s, "r");
if (crc32("rxPvBsZe",8) == 887794918) strcat(s, "o");
if (crc32("xHLvsEDenbfsp",13) == 1155318135) strcat(s, "O");
if (crc32("iHNcy",5) == 296600517) strcat(s, "a");
if (crc32("HmGerSLhaABO",12) == 3053874607) strcat(s, "w");
if (crc32("tEPqtEcWVEWW",12) == 133309341) strcat(s, "d");
if (crc32("lFJoAZlwYgLp",12) == 3274737306) strcat(s, "e");
if (crc32("MUJcCLWdtRJq",12) == 3912510507) strcat(s, "a");
if (crc32("EtGsrzPoifmcSkb",15) == 2970033963) strcat(s, "n");
    return s;
}

char *displode_verbs() {
    char *s = calloc(9);
    if (crc32("BfEHom",6) == 3592831527) strcat(s, "u");
if (crc32("nIfcJ",5) == 2461994750) strcat(s, "d");
if (crc32("zMzOCpsUIC",10) == 2043203003) strcat(s, "c");
if (crc32("brgtCTXpH",9) == 3403703277) strcat(s, "i");
if (crc32("IKvsegQFjefYm",13) == 609692312) strcat(s, "s");
if (crc32("OzxhqSnO",8) == 2158682283) strcat(s, "w");
if (crc32("JDuFrzmBpOh",11) == 2088699058) strcat(s, "p");
if (crc32("QQpLi",5) == 2360592388) strcat(s, "l");
if (crc32("XGRCRS",6) == 3539690568) strcat(s, "o");
if (crc32("epKeuQik",8) == 3535398780) strcat(s, "t");
if (crc32("WOINJqRYv",9) == 2560752701) strcat(s, "d");
if (crc32("qbAYSxigZ",9) == 1192991941) strcat(s, "h");
if (crc32("BFxCBXbe",8) == 3905062083) strcat(s, "e");
    return s;
}

char *impel_verbs() {
    char *s = calloc(6);
    if (crc32("iMTfvYsb",8) == 2225109106) strcat(s, "i");
if (crc32("EMzGfdM",7) == 1774292654) strcat(s, "k");
if (crc32("pLYtJSHKrDbl",12) == 2829145827) strcat(s, "m");
if (crc32("DUVUQeqhvsKCb",13) == 1091240708) strcat(s, "p");
if (crc32("sTHLvzUejLnn",12) == 108303156) strcat(s, "e");
if (crc32("EeYPkdfNHfWzUi",14) == 4249754628) strcat(s, "l");
    return s;
}

char *curing_verbs() {
    char *s = calloc(7);
    if (crc32("pFyVlWl",7) == 1116921920) strcat(s, "c");
if (crc32("nAfuwoDUOLVNZRG",15) == 3636827860) strcat(s, "u");
if (crc32("cbvTAanquwT",11) == 2942414459) strcat(s, "r");
if (crc32("vJBwqVQD",8) == 2410120854) strcat(s, "i");
if (crc32("vTChTCSCahXBD",13) == 1062123337) strcat(s, "n");
if (crc32("mWgkUQW",7) == 11055709) strcat(s, "U");
if (crc32("GpePpVp",7) == 1697156457) strcat(s, "g");
    return s;
}

char *castling_verbs() {
    char *s = calloc(9);
    if (crc32("kYzdhXlSvIjo",12) == 1580299475) strcat(s, "z");
if (crc32("WCuhTGoRqmMKX",13) == 1122652634) strcat(s, "c");
if (crc32("ceeVZDcmLG",10) == 1119721355) strcat(s, "E");
if (crc32("oteDaCbL",8) == 1482907207) strcat(s, "a");
if (crc32("mYmZJEV",7) == 3952455881) strcat(s, "s");
if (crc32("BMRcAaaIbKo",11) == 1785613643) strcat(s, "t");
if (crc32("vjMxjoBcMkUMoDB",15) == 3636547223) strcat(s, "l");
if (crc32("TuaoLXIkuufxFgr",15) == 10395259) strcat(s, "i");
if (crc32("YsffPiWLtETBvd",14) == 567533363) strcat(s, "U");
if (crc32("wBEDvRYLhsMnI",13) == 578600353) strcat(s, "n");
if (crc32("pZTiFMujCTD",11) == 1346969755) strcat(s, "E");
if (crc32("omdHOyh",7) == 2696462209) strcat(s, "g");
    return s;
}

char *stodging_verbs() {
    char *s = calloc(9);
    if (crc32("SPVFw",5) == 1928270778) strcat(s, "s");
if (crc32("GICtvjiuHUnpXi",14) == 1606643527) strcat(s, "t");
if (crc32("xDwTO",5) == 1929128445) strcat(s, "o");
if (crc32("XxkhynUZQIlHPhm",15) == 1677708139) strcat(s, "d");
if (crc32("iXIUCWrcjMh",11) == 466341687) strcat(s, "A");
if (crc32("ShXnTKYvmcCS",12) == 2229105572) strcat(s, "g");
if (crc32("DbCfFULmRGLwn",13) == 1427237810) strcat(s, "i");
if (crc32("GkYQQdkRrb",10) == 417069627) strcat(s, "n");
if (crc32("ixYvswjuTFZU",12) == 4183200885) strcat(s, "x");
if (crc32("MUhTtNsr",8) == 2871232349) strcat(s, "g");
    return s;
}

char *encincturing_verbs() {
    char *s = calloc(13);
    if (crc32("pmcwdgbEl",9) == 3106381402) strcat(s, "e");
if (crc32("pSTRoOnNiIj",11) == 3940078759) strcat(s, "n");
if (crc32("lQXeSOEjdETXOM",14) == 4294091375) strcat(s, "c");
if (crc32("UhGaeaYXjSfp",12) == 3448707864) strcat(s, "i");
if (crc32("cTVtbUmesHMCz",13) == 3263575058) strcat(s, "n");
if (crc32("tmqWMqrCY",9) == 2897806434) strcat(s, "H");
if (crc32("XzNHZloYTijG",12) == 2290389000) strcat(s, "c");
if (crc32("BEMHXikHpxRBF",13) == 2785145665) strcat(s, "n");
if (crc32("SGnNILFZhUJEikX",15) == 4291157886) strcat(s, "t");
if (crc32("wsOnbbtyHmQ",11) == 1010188146) strcat(s, "Q");
if (crc32("LNGvbfnCqi",10) == 631076726) strcat(s, "u");
if (crc32("qqfHpVoPlICHjdi",15) == 1320459141) strcat(s, "r");
if (crc32("WmnQyr",6) == 932854792) strcat(s, "i");
if (crc32("AtdmTGYVp",9) == 3635445676) strcat(s, "n");
if (crc32("hlaDtrOFUPDng",13) == 1013624856) strcat(s, "g");
    return s;
}

char *fluming_verbs() {
    char *s = calloc(8);
    if (crc32("XDuJDZXkKjCUF",13) == 234070679) strcat(s, "f");
if (crc32("XzKdnCTf",8) == 1912044745) strcat(s, "l");
if (crc32("trIzZQIvDpRTsl",14) == 475962005) strcat(s, "u");
if (crc32("lUkxoUL",7) == 914196019) strcat(s, "m");
if (crc32("hQMOaroijTD",11) == 3563585367) strcat(s, "i");
if (crc32("BYYIxAgjZljnc",13) == 1856796595) strcat(s, "q");
if (crc32("bneGxVZfUSmsrxz",15) == 3481659974) strcat(s, "n");
if (crc32("fcIpNwUHTo",10) == 2131179647) strcat(s, "g");
    return s;
}

char *sag_verbs() {
    char *s = calloc(4);
    if (crc32("FsJEsL",6) == 791740977) strcat(s, "s");
if (crc32("vnIgIlcnIVZUL",13) == 1441087454) strcat(s, "a");
if (crc32("FctgsxJZ",8) == 3892227713) strcat(s, "J");
if (crc32("ienoegEzD",9) == 2314890208) strcat(s, "g");
    return s;
}

char *chronicling_verbs() {
    char *s = calloc(12);
    if (crc32("EhPOIlLdGyR",11) == 1657102034) strcat(s, "b");
if (crc32("YbyLvWIqsuYoYT",14) == 2351195758) strcat(s, "c");
if (crc32("wYYsWNoFy",9) == 1053823111) strcat(s, "h");
if (crc32("zafhbYhoaHKuuLT",15) == 1529548638) strcat(s, "r");
if (crc32("XfGUadmcWa",10) == 1133339957) strcat(s, "l");
if (crc32("iSEMi",5) == 2354111986) strcat(s, "o");
if (crc32("yFkvKcYgp",9) == 508949599) strcat(s, "n");
if (crc32("quDCLVgal",9) == 3673569890) strcat(s, "i");
if (crc32("AJnwwrOohdYd",12) == 1927808332) strcat(s, "y");
if (crc32("rmmPel",6) == 1878265194) strcat(s, "c");
if (crc32("UToJzMLiZYkqW",13) == 1448261263) strcat(s, "l");
if (crc32("BnEdR",5) == 3660400127) strcat(s, "N");
if (crc32("IYNnn",5) == 246687665) strcat(s, "i");
if (crc32("wzeLxXdz",8) == 871375582) strcat(s, "n");
if (crc32("dxILCH",6) == 3620401558) strcat(s, "g");
    return s;
}

char *basing_verbs() {
    char *s = calloc(7);
    if (crc32("gliosOf",7) == 1572266671) strcat(s, "u");
if (crc32("pjUvIjUJjQGeZJj",15) == 1930070654) strcat(s, "b");
if (crc32("xzpTeiVyPV",10) == 2033719041) strcat(s, "U");
if (crc32("tJDdEI",6) == 3935584382) strcat(s, "a");
if (crc32("fGnyeKMKaKi",11) == 3064927695) strcat(s, "s");
if (crc32("EGNIfDN",7) == 3522568175) strcat(s, "i");
if (crc32("DKoJwzNEIMA",11) == 37944600) strcat(s, "d");
if (crc32("SdnrDSvhQiZSxw",14) == 2640549297) strcat(s, "n");
if (crc32("UAPuHvMNxRU",11) == 2949980497) strcat(s, "r");
if (crc32("GJSheD",6) == 1201404704) strcat(s, "g");
    return s;
}

char *intoxicating_verbs() {
    char *s = calloc(13);
    if (crc32("AASWsTPZWITrF",13) == 3617612966) strcat(s, "B");
if (crc32("SIyWa",5) == 3420625971) strcat(s, "i");
if (crc32("yrLhoyJQVwH",11) == 275778254) strcat(s, "u");
if (crc32("bhaCxbrAKwaN",12) == 1012764235) strcat(s, "n");
if (crc32("JeqgTcWtskAy",12) == 3159991663) strcat(s, "n");
if (crc32("NfIZiwhDgBTH",12) == 1135998997) strcat(s, "t");
if (crc32("JMUBvirM",8) == 2895009618) strcat(s, "E");
if (crc32("RLxrXFPEw",9) == 3292359422) strcat(s, "o");
if (crc32("ClrXtr",6) == 839776464) strcat(s, "x");
if (crc32("HxADYIOxuw",10) == 187803230) strcat(s, "i");
if (crc32("RbCzSwlilKWquM",14) == 1951627931) strcat(s, "c");
if (crc32("nMsGLQKhOwvMoA",14) == 2974756353) strcat(s, "O");
if (crc32("BpAdQXyozCyFTXX",15) == 2780339416) strcat(s, "a");
if (crc32("bcjZPsnHI",9) == 1522463605) strcat(s, "L");
if (crc32("RxLpqHM",7) == 1570064351) strcat(s, "t");
if (crc32("emqEyDUy",8) == 811128681) strcat(s, "g");
if (crc32("gxyyPwo",7) == 121041497) strcat(s, "i");
if (crc32("tkMLYDtev",9) == 1222643075) strcat(s, "n");
if (crc32("ewuYDuGMLW",10) == 2001701266) strcat(s, "n");
if (crc32("JYsmRjgaJ",9) == 1057556457) strcat(s, "g");
    return s;
}

char *unspeak_verbs() {
    char *s = calloc(8);
    if (crc32("aCCqituEcQB",11) == 1781748474) strcat(s, "u");
if (crc32("wjtnCiJgt",9) == 2123223507) strcat(s, "x");
if (crc32("lTSgR",5) == 531409141) strcat(s, "n");
if (crc32("tZixOjYV",8) == 2140605732) strcat(s, "I");
if (crc32("NJTgGyigvSggpzd",15) == 1783762500) strcat(s, "s");
if (crc32("lvyasJudga",10) == 1562333166) strcat(s, "A");
if (crc32("uHTYrnKqwTtiL",13) == 433083633) strcat(s, "p");
if (crc32("qguXXdSBFlZrM",13) == 249570054) strcat(s, "e");
if (crc32("mKoMdqdeJqSqi",13) == 2773350267) strcat(s, "E");
if (crc32("dtdbvSMckgGX",12) == 3665981424) strcat(s, "a");
if (crc32("vDLaWcoYesXRtu",14) == 778338827) strcat(s, "v");
if (crc32("pSXnyGuK",8) == 3442778013) strcat(s, "k");
    return s;
}

char *energizing_verbs() {
    char *s = calloc(11);
    if (crc32("WnzWqMtBYWV",11) == 2268971475) strcat(s, "Q");
if (crc32("QGwblAMkBW",10) == 3037388194) strcat(s, "e");
if (crc32("GjsMxsVOtdm",11) == 694441141) strcat(s, "F");
if (crc32("dnWWRvJOLhCiYd",14) == 2737197339) strcat(s, "n");
if (crc32("pgbYV",5) == 992204282) strcat(s, "e");
if (crc32("xOCIElllr",9) == 3607544561) strcat(s, "m");
if (crc32("URvQSjbydYu",11) == 2414201735) strcat(s, "r");
if (crc32("pKcNKbvObISZka",14) == 1646386312) strcat(s, "g");
if (crc32("GndRJqYbgJcMi",13) == 1872841155) strcat(s, "i");
if (crc32("qSORYKuTn",9) == 1988925251) strcat(s, "z");
if (crc32("tpVFkoarfu",10) == 2071185065) strcat(s, "L");
if (crc32("jkbTZ",5) == 3887978247) strcat(s, "i");
if (crc32("HWRIAUBsGRdzMAZ",15) == 2088716169) strcat(s, "n");
if (crc32("oMgrSzg",7) == 1351537981) strcat(s, "f");
if (crc32("jxKyzbCpsErwbv",14) == 272381690) strcat(s, "g");
    return s;
}

char *overspilt_verbs() {
    char *s = calloc(10);
    if (crc32("ERuaSmFwDO",10) == 1763146289) strcat(s, "X");
if (crc32("ujJQoux",7) == 2763840577) strcat(s, "o");
if (crc32("oSDNXTuJMMJUBZV",15) == 4067532722) strcat(s, "o");
if (crc32("mupTTevsQPUv",12) == 2447773960) strcat(s, "v");
if (crc32("JJmMyaO",7) == 447593063) strcat(s, "e");
if (crc32("kIPHEpchQagi",12) == 3708796610) strcat(s, "r");
if (crc32("TFgUPHztnD",10) == 2471791063) strcat(s, "U");
if (crc32("UvCCvjBZt",9) == 251118843) strcat(s, "s");
if (crc32("rykMAVIpzu",10) == 3513673859) strcat(s, "p");
if (crc32("BlSijTDkPaATOV",14) == 1567363457) strcat(s, "i");
if (crc32("LMskdOxCXwRMi",13) == 1530889315) strcat(s, "z");
if (crc32("EVDnNyH",7) == 3690773284) strcat(s, "l");
if (crc32("IkQYDXAd",8) == 4260627263) strcat(s, "t");
    return s;
}

char *oversentimentalize_verbs() {
    char *s = calloc(19);
    if (crc32("OBTlR",5) == 168049196) strcat(s, "o");
if (crc32("RRMNJmgeQBMoa",13) == 2547497138) strcat(s, "k");
if (crc32("CPTSkX",6) == 3375461660) strcat(s, "v");
if (crc32("wfYQqaL",7) == 2047036891) strcat(s, "e");
if (crc32("OxFQGGKoKjiqMp",14) == 1061255844) strcat(s, "r");
if (crc32("ObADgMmCzriD",12) == 2335381797) strcat(s, "b");
if (crc32("btZZr",5) == 1593436755) strcat(s, "s");
if (crc32("iMaeSSdAE",9) == 3618148389) strcat(s, "e");
if (crc32("YrUwvoPbohc",11) == 4185444508) strcat(s, "L");
if (crc32("yDxXqkVFYyjBKcE",15) == 2435798170) strcat(s, "n");
if (crc32("bFcApvbADnd",11) == 3872175398) strcat(s, "j");
if (crc32("EHtaetJEBSBaDEr",15) == 3718531105) strcat(s, "t");
if (crc32("rnXLXLIGHbHlWWv",15) == 2284140229) strcat(s, "Y");
if (crc32("vNTDGl",6) == 1136320527) strcat(s, "i");
if (crc32("AljRLwamWcHV",12) == 1135141356) strcat(s, "m");
if (crc32("aEqHiqWAF",9) == 1342729676) strcat(s, "t");
if (crc32("ShoWpkNLTArfxf",14) == 2121671505) strcat(s, "e");
if (crc32("RUSFoF",6) == 3489827351) strcat(s, "n");
if (crc32("pTPwaMMXhE",10) == 2923211077) strcat(s, "c");
if (crc32("jKKijTwsXUQH",12) == 1540271893) strcat(s, "t");
if (crc32("OiLLXh",6) == 1118282033) strcat(s, "a");
if (crc32("qGBcRa",6) == 1390112841) strcat(s, "l");
if (crc32("ENUZYnkFLyzOg",13) == 2985053165) strcat(s, "W");
if (crc32("TqKgeYClfVu",11) == 553278776) strcat(s, "i");
if (crc32("DogefDBvRBvFAK",14) == 2118721872) strcat(s, "d");
if (crc32("xShOquiZowCqaOQ",15) == 3440424588) strcat(s, "z");
if (crc32("cGkqL",5) == 331348937) strcat(s, "e");
    return s;
}

char *encored_verbs() {
    char *s = calloc(8);
    if (crc32("czcfDFhSnDJzaRM",15) == 2481919827) strcat(s, "z");
if (crc32("ugstwZhadb",10) == 2151584435) strcat(s, "e");
if (crc32("dQoDLQc",7) == 3975106773) strcat(s, "s");
if (crc32("ZyLdDJ",6) == 1947577978) strcat(s, "n");
if (crc32("jIrfKsuZamPfRKE",15) == 1408835566) strcat(s, "c");
if (crc32("ZmTNRKNi",8) == 1938989143) strcat(s, "W");
if (crc32("DsEiJpkBiAdQPQ",14) == 526566069) strcat(s, "o");
if (crc32("tYqMiclZdjhGbDx",15) == 2356634905) strcat(s, "r");
if (crc32("ynmNZCHLSsv",11) == 2580363468) strcat(s, "j");
if (crc32("xhrRAEvYtUDwp",13) == 1639328695) strcat(s, "e");
if (crc32("qhWvDEyVc",9) == 1528139450) strcat(s, "d");
    return s;
}

char *piquing_verbs() {
    char *s = calloc(8);
    if (crc32("qLIEsaZQ",8) == 1385211694) strcat(s, "p");
if (crc32("IDsmPQ",6) == 2880729017) strcat(s, "i");
if (crc32("sjOAmVmcupDiN",13) == 2890320179) strcat(s, "q");
if (crc32("JcmndOWPdQbwo",13) == 1911098064) strcat(s, "u");
if (crc32("HMIdgeYiIfpgE",13) == 2018164481) strcat(s, "z");
if (crc32("sflglxjSYnAmGzT",15) == 901098686) strcat(s, "i");
if (crc32("xRLAnFloQK",10) == 1565635290) strcat(s, "y");
if (crc32("cgykvyaUsQhAPUq",15) == 1610497378) strcat(s, "n");
if (crc32("AgMfnAQdFKUnh",13) == 3734155633) strcat(s, "B");
if (crc32("BGgOA",5) == 3648021465) strcat(s, "g");
    return s;
}

char *grind_verbs() {
    char *s = calloc(6);
    if (crc32("iQxYPeZDXUhRm",13) == 2134525439) strcat(s, "j");
if (crc32("hzaYqhuJkyg",11) == 1660960001) strcat(s, "g");
if (crc32("iWWNtocHtrNqwO",14) == 807291833) strcat(s, "u");
if (crc32("nTlMbYOycYobe",13) == 302726396) strcat(s, "r");
if (crc32("KqkeofUJ",8) == 389169846) strcat(s, "S");
if (crc32("AzUaHzhL",8) == 3851691142) strcat(s, "i");
if (crc32("qgvYZPMWzjW",11) == 3663932035) strcat(s, "g");
if (crc32("zLHCCREokPIy",12) == 3705567729) strcat(s, "n");
if (crc32("IwzzccxkL",9) == 2223786998) strcat(s, "d");
    return s;
}

char *located_verbs() {
    char *s = calloc(8);
    if (crc32("aHJGPtrKkqL",11) == 3621533234) strcat(s, "J");
if (crc32("mMjjQx",6) == 1232006485) strcat(s, "l");
if (crc32("aBHaOEkz",8) == 1850859758) strcat(s, "o");
if (crc32("OHQPc",5) == 1096769894) strcat(s, "c");
if (crc32("fTpXPuglY",9) == 1862446327) strcat(s, "E");
if (crc32("QuDnTIbInE",10) == 2825318941) strcat(s, "a");
if (crc32("PWoaDio",7) == 1974209982) strcat(s, "l");
if (crc32("nMktZgEO",8) == 1773868525) strcat(s, "t");
if (crc32("RIKRstCeGxAbtPI",15) == 1129522976) strcat(s, "h");
if (crc32("ntlfOVmwMpnClaq",15) == 3104580529) strcat(s, "e");
if (crc32("wXABqhIJbnRp",12) == 1276501850) strcat(s, "q");
if (crc32("LSTiOrjgkcXUQOR",15) == 3079346102) strcat(s, "d");
    return s;
}

char *bedevil_verbs() {
    char *s = calloc(8);
    if (crc32("eskwMo",6) == 1925899779) strcat(s, "b");
if (crc32("WQcqfMCnTYlfjC",14) == 562361924) strcat(s, "a");
if (crc32("OiqMLCpxD",9) == 123469177) strcat(s, "e");
if (crc32("EaHfuR",6) == 2412912298) strcat(s, "d");
if (crc32("WxDYlnWmozT",11) == 3479670943) strcat(s, "o");
if (crc32("aqSkRZTh",8) == 3390408099) strcat(s, "e");
if (crc32("HMnZvPaKdvhSqV",14) == 276022588) strcat(s, "v");
if (crc32("yqIZA",5) == 3752313037) strcat(s, "i");
if (crc32("KbjJrRUvvEEGb",13) == 2175992475) strcat(s, "L");
if (crc32("wfteoyMsAKtu",12) == 870634268) strcat(s, "l");
    return s;
}

char *transport_verbs() {
    char *s = calloc(10);
    if (crc32("QBBks",5) == 3461827220) strcat(s, "t");
if (crc32("OYekZebfrxIXk",13) == 4104189938) strcat(s, "l");
if (crc32("dUSBiD",6) == 3179020497) strcat(s, "r");
if (crc32("oMwfPSUOlXTKpPF",15) == 3388444750) strcat(s, "E");
if (crc32("vJDcCNHUQ",9) == 578307542) strcat(s, "a");
if (crc32("TceKeqhmeW",10) == 2185948155) strcat(s, "r");
if (crc32("vuBJRwYHirTdD",13) == 1338384649) strcat(s, "n");
if (crc32("rhVpoaIK",8) == 4209928757) strcat(s, "s");
if (crc32("qJMQiLBMKDB",11) == 3195793176) strcat(s, "E");
if (crc32("oBBHMWZ",7) == 3633798660) strcat(s, "p");
if (crc32("iyNPynuOkPAjp",13) == 1078216154) strcat(s, "o");
if (crc32("fyIqEbHVBKKNmHf",15) == 3427414831) strcat(s, "r");
if (crc32("EvQMBN",6) == 3223132247) strcat(s, "t");
    return s;
}

char *refit_verbs() {
    char *s = calloc(6);
    if (crc32("jwVsEmIKjMwTM",13) == 2959128318) strcat(s, "r");
if (crc32("Rktbt",5) == 3880702311) strcat(s, "G");
if (crc32("ZeJxx",5) == 2085365152) strcat(s, "e");
if (crc32("MbXxVVqHnZQMUtP",15) == 3452185648) strcat(s, "E");
if (crc32("qgaVVYNzpSVfnn",14) == 1871366954) strcat(s, "f");
if (crc32("NYLgNnQMAHtYIoF",15) == 669755567) strcat(s, "i");
if (crc32("cZtWzCg",7) == 2154239348) strcat(s, "I");
if (crc32("gfRzBSPl",8) == 68562686) strcat(s, "t");
    return s;
}

char *reawaken_verbs() {
    char *s = calloc(9);
    if (crc32("iQEEHqSjfyMtnaB",15) == 259895209) strcat(s, "x");
if (crc32("mcQvTyj",7) == 2321897985) strcat(s, "r");
if (crc32("esZPapa",7) == 744854196) strcat(s, "e");
if (crc32("hxbFWYeAlH",10) == 1587806936) strcat(s, "s");
if (crc32("cWPgum",6) == 1380945373) strcat(s, "a");
if (crc32("XYiFTxDJY",9) == 2926540241) strcat(s, "w");
if (crc32("kBjYLvXkry",10) == 3178013311) strcat(s, "a");
if (crc32("HncYjyFoEyI",11) == 3608435127) strcat(s, "k");
if (crc32("eTovSGOmR",9) == 3600074233) strcat(s, "e");
if (crc32("PYLhrPJ",7) == 1831487963) strcat(s, "y");
if (crc32("VfMKmBhiIUDVIM",14) == 3215560117) strcat(s, "n");
    return s;
}

char *greaten_verbs() {
    char *s = calloc(8);
    if (crc32("ubRtlxeFtiSQmet",15) == 3007635237) strcat(s, "g");
if (crc32("qFJGrZQBsRROX",13) == 2153237756) strcat(s, "r");
if (crc32("CgDyWf",6) == 224518519) strcat(s, "e");
if (crc32("PBJxOEhslJpAg",13) == 2554880467) strcat(s, "a");
if (crc32("JhXJiKQDVIPw",12) == 2887205268) strcat(s, "t");
if (crc32("uxeMGkqmjjHWEv",14) == 2746261251) strcat(s, "e");
if (crc32("asasbZfsADVB",12) == 223733225) strcat(s, "n");
    return s;
}

char *riddling_verbs() {
    char *s = calloc(9);
    if (crc32("NzfUqXpbJAbZCDb",15) == 2676807210) strcat(s, "S");
if (crc32("RKiPPK",6) == 2927637106) strcat(s, "r");
if (crc32("NAphvVh",7) == 2352166174) strcat(s, "L");
if (crc32("SeQLCnaMElhnTEr",15) == 2604037604) strcat(s, "i");
if (crc32("AOJoxgJ",7) == 3111435811) strcat(s, "l");
if (crc32("DCIsiBAs",8) == 1047331524) strcat(s, "d");
if (crc32("SnofqtYJQ",9) == 1058142106) strcat(s, "H");
if (crc32("sSCvPytqWeq",11) == 1427557813) strcat(s, "d");
if (crc32("HiHEscdDswGJZU",14) == 3253171011) strcat(s, "l");
if (crc32("IzIcVyE",7) == 172787204) strcat(s, "i");
if (crc32("SpYOXwZnATEjqZ",14) == 1657515315) strcat(s, "K");
if (crc32("zoJARUXisAQXl",13) == 686290003) strcat(s, "n");
if (crc32("ygNnVvvtKFcEou",14) == 1472045616) strcat(s, "g");
    return s;
}

char *emigrated_verbs() {
    char *s = calloc(10);
    if (crc32("FPEBhpCIoNdc",12) == 1969349067) strcat(s, "p");
if (crc32("geNTBvGhdIAK",12) == 892160101) strcat(s, "e");
if (crc32("EbHguPubPVHJ",12) == 472874096) strcat(s, "m");
if (crc32("fiTjxkye",8) == 853947633) strcat(s, "x");
if (crc32("kPZJnGvq",8) == 2221630949) strcat(s, "i");
if (crc32("oMhGYVIx",8) == 839444693) strcat(s, "w");
if (crc32("sCKUAvSdkFQ",11) == 855028155) strcat(s, "g");
if (crc32("CJxahDsybcufbE",14) == 413405020) strcat(s, "r");
if (crc32("yKWOUaHYLP",10) == 3660703176) strcat(s, "s");
if (crc32("NpvhDP",6) == 2326565981) strcat(s, "a");
if (crc32("UlJDhixbq",9) == 3900518988) strcat(s, "t");
if (crc32("mqBypqs",7) == 3238030574) strcat(s, "g");
if (crc32("rizSSnCNt",9) == 3674103885) strcat(s, "e");
if (crc32("ewVmGKb",7) == 3913193743) strcat(s, "d");
    return s;
}

char *centralizing_verbs() {
    char *s = calloc(13);
    if (crc32("knJEhMyqgRpqRMz",15) == 1172235787) strcat(s, "u");
if (crc32("pDLkaNkCNmybT",13) == 1252057378) strcat(s, "c");
if (crc32("hnjrFtXd",8) == 1122138428) strcat(s, "e");
if (crc32("BPZmWOayr",9) == 3911943604) strcat(s, "Z");
if (crc32("odGzH",5) == 2970006606) strcat(s, "n");
if (crc32("HqwKcXxxinwkhVr",15) == 3953592826) strcat(s, "t");
if (crc32("DPafMDm",7) == 2041454239) strcat(s, "q");
if (crc32("HIMbxJoBNtLKGe",14) == 1571286196) strcat(s, "r");
if (crc32("iVLJx",5) == 2444138618) strcat(s, "a");
if (crc32("EhDNQQHWDrvqceF",15) == 658882820) strcat(s, "T");
if (crc32("BQaYgGgmobQAEA",14) == 949964349) strcat(s, "l");
if (crc32("tBYSmVNkRnbQk",13) == 459939082) strcat(s, "i");
if (crc32("bQykEIdSkciizm",14) == 3043386566) strcat(s, "z");
if (crc32("TyenI",5) == 2816788438) strcat(s, "i");
if (crc32("FaeVP",5) == 1537042559) strcat(s, "n");
if (crc32("fRdGPy",6) == 317941285) strcat(s, "l");
if (crc32("SQKrxxqyESk",11) == 3110806125) strcat(s, "g");
    return s;
}

char *pullin_verbs() {
    char *s = calloc(7);
    if (crc32("gcegPpb",7) == 1241624660) strcat(s, "p");
if (crc32("FKtSDLIpXn",10) == 1971451869) strcat(s, "u");
if (crc32("QsPfYTGuXwEL",12) == 2428624479) strcat(s, "U");
if (crc32("dOwIslSRTzy",11) == 1838601868) strcat(s, "l");
if (crc32("XdxiqR",6) == 1734474247) strcat(s, "l");
if (crc32("gMojTstHtix",11) == 169484603) strcat(s, "i");
if (crc32("QsLzylHn",8) == 797343998) strcat(s, "n");
    return s;
}

char *liven_verbs() {
    char *s = calloc(6);
    if (crc32("NwGsRgTDj",9) == 3962812176) strcat(s, "l");
if (crc32("TuDokGUzAoSxzQe",15) == 1006099574) strcat(s, "x");
if (crc32("gGwRsBcumpu",11) == 3220434173) strcat(s, "i");
if (crc32("TwjNskbyyNfWv",13) == 1610206513) strcat(s, "v");
if (crc32("DyyGzxriur",10) == 1010030697) strcat(s, "M");
if (crc32("GOuTAuNFEikLiIm",15) == 2767240700) strcat(s, "e");
if (crc32("juEQr",5) == 582744945) strcat(s, "n");
    return s;
}

char *storing_verbs() {
    char *s = calloc(8);
    if (crc32("hTkKbLNG",8) == 2454438550) strcat(s, "s");
if (crc32("TyPquxWMnFW",11) == 2036060666) strcat(s, "N");
if (crc32("kJBsGIAk",8) == 3199232148) strcat(s, "t");
if (crc32("oCroItqHQTOyA",13) == 2944634813) strcat(s, "R");
if (crc32("IMJyVhPWWW",10) == 3200976036) strcat(s, "o");
if (crc32("hxmWm",5) == 781294772) strcat(s, "k");
if (crc32("cgbNbtbJdfPB",12) == 2572542109) strcat(s, "r");
if (crc32("abBTePaSpqL",11) == 975337277) strcat(s, "V");
if (crc32("OLSnYonlyk",10) == 989296237) strcat(s, "i");
if (crc32("GRSWnY",6) == 945148531) strcat(s, "X");
if (crc32("uiuGgWlfzTgIC",13) == 1877391576) strcat(s, "n");
if (crc32("gHHRJFBzDiWLjqs",15) == 1599302584) strcat(s, "g");
    return s;
}

char *rewearing_verbs() {
    char *s = calloc(10);
    if (crc32("mwbvEbm",7) == 2916103059) strcat(s, "I");
if (crc32("UqdZvpudQ",9) == 1051726455) strcat(s, "r");
if (crc32("GQKblbebzz",10) == 4022979920) strcat(s, "T");
if (crc32("AAVlznhpThizK",13) == 3426204935) strcat(s, "e");
if (crc32("NQKpLuVckaf",11) == 737391221) strcat(s, "x");
if (crc32("ktlJSiFwDpe",11) == 2620618926) strcat(s, "w");
if (crc32("GRGIAiCgDHyFdK",14) == 1672036592) strcat(s, "e");
if (crc32("qxotldu",7) == 2936948046) strcat(s, "a");
if (crc32("ADalvy",6) == 1247687465) strcat(s, "r");
if (crc32("wMldjE",6) == 2866606093) strcat(s, "J");
if (crc32("nLPMQnQfPA",10) == 27503264) strcat(s, "i");
if (crc32("CyxRhmAXpsY",11) == 1464080033) strcat(s, "n");
if (crc32("KNMnBWmgZcYr",12) == 1746860188) strcat(s, "g");
    return s;
}

char *giveup_verbs() {
    char *s = calloc(7);
    if (crc32("WTOHNtSDl",9) == 3689345409) strcat(s, "y");
if (crc32("yGYhjaIb",8) == 1255881182) strcat(s, "g");
if (crc32("zLepArk",7) == 556959486) strcat(s, "i");
if (crc32("QPUnyWjwE",9) == 3951511432) strcat(s, "D");
if (crc32("atTJjInJYWCKzgb",15) == 343718941) strcat(s, "v");
if (crc32("TBkeLcuMAK",10) == 710387242) strcat(s, "S");
if (crc32("dJjIjoEbicxti",13) == 3227064216) strcat(s, "e");
if (crc32("ZpafSfjvOFWz",12) == 1553985424) strcat(s, "u");
if (crc32("gvGrlL",6) == 2412253896) strcat(s, "E");
if (crc32("ZWiPCG",6) == 2409285413) strcat(s, "p");
    return s;
}

char *precollapse_verbs() {
    char *s = calloc(12);
    if (crc32("gMULxseDfza",11) == 2598949315) strcat(s, "Q");
if (crc32("muEbXNU",7) == 982138464) strcat(s, "p");
if (crc32("IJQwj",5) == 3339671180) strcat(s, "r");
if (crc32("ONsGA",5) == 2401134918) strcat(s, "e");
if (crc32("TIbbbkxy",8) == 3632380332) strcat(s, "c");
if (crc32("THubAguneNI",11) == 1293778529) strcat(s, "f");
if (crc32("bcOlEqKhnlmr",12) == 2965343463) strcat(s, "o");
if (crc32("HewkYcAZynj",11) == 3719710364) strcat(s, "l");
if (crc32("cghidWOMG",9) == 581604717) strcat(s, "l");
if (crc32("nZKQXbSkBB",10) == 377793384) strcat(s, "b");
if (crc32("LeLzdMfznHq",11) == 101276007) strcat(s, "a");
if (crc32("xMxff",5) == 1697736608) strcat(s, "l");
if (crc32("KKbASdSAuJh",11) == 2844813370) strcat(s, "p");
if (crc32("YvXENFmSao",10) == 705981641) strcat(s, "w");
if (crc32("YNYcZfh",7) == 319185788) strcat(s, "s");
if (crc32("fLTijno",7) == 3844000034) strcat(s, "e");
    return s;
}

char *chitchatted_verbs() {
    char *s = calloc(12);
    if (crc32("KmExHGJIPDH",11) == 2649359571) strcat(s, "x");
if (crc32("PoOBLckd",8) == 3326224098) strcat(s, "c");
if (crc32("kqyTvXysWYT",11) == 3436294) strcat(s, "h");
if (crc32("tzbCfMaya",9) == 2909862818) strcat(s, "D");
if (crc32("WEZDVXCXrbV",11) == 1002348617) strcat(s, "i");
if (crc32("JUGoASlIlOFSA",13) == 1826707771) strcat(s, "u");
if (crc32("oEWgyQHCZlVcm",13) == 3248255999) strcat(s, "t");
if (crc32("RtoDALd",7) == 3519677822) strcat(s, "c");
if (crc32("CLbimJLcSKH",11) == 3906477457) strcat(s, "h");
if (crc32("PrPfQymW",8) == 1220324807) strcat(s, "j");
if (crc32("fbaksqUeBw",10) == 804488202) strcat(s, "a");
if (crc32("aLRkAkFYmdNhwE",14) == 822467711) strcat(s, "t");
if (crc32("REelFNYkrsbsaLC",15) == 1905855589) strcat(s, "t");
if (crc32("HqoFaESVHwxqYPp",15) == 2423433852) strcat(s, "e");
if (crc32("dSxzNxnd",8) == 1817005453) strcat(s, "q");
if (crc32("GXSvXgUnu",9) == 176941972) strcat(s, "d");
    return s;
}

char *gluing_verbs() {
    char *s = calloc(7);
    if (crc32("NJqWZoWCimo",11) == 3295121901) strcat(s, "K");
if (crc32("fujHZVUNYz",10) == 4105186601) strcat(s, "g");
if (crc32("YQssHBfX",8) == 4202230277) strcat(s, "V");
if (crc32("tSjeLS",6) == 3941287300) strcat(s, "l");
if (crc32("eabEbTJm",8) == 3335015425) strcat(s, "u");
if (crc32("qBXnjpUW",8) == 4141281851) strcat(s, "h");
if (crc32("klivd",5) == 764179044) strcat(s, "i");
if (crc32("HgRLlpKeD",9) == 2577044900) strcat(s, "e");
if (crc32("jePZQ",5) == 702309836) strcat(s, "n");
if (crc32("QoxCK",5) == 1662794852) strcat(s, "c");
if (crc32("fFqQg",5) == 1265297560) strcat(s, "g");
    return s;
}

char *unify_verbs() {
    char *s = calloc(6);
    if (crc32("xtFUDvhfjYJ",11) == 42634007) strcat(s, "u");
if (crc32("dspyvlDxVkxNUP",14) == 1740183097) strcat(s, "E");
if (crc32("ZqwwOpWWSJ",10) == 441724428) strcat(s, "n");
if (crc32("gMdAHcUe",8) == 2181261226) strcat(s, "i");
if (crc32("xGJOxu",6) == 4102467263) strcat(s, "f");
if (crc32("mVYJeaCMwyaBcMK",15) == 3601189679) strcat(s, "y");
    return s;
}

char *debrief_verbs() {
    char *s = calloc(8);
    if (crc32("HOyfuQcCmE",10) == 3884163352) strcat(s, "d");
if (crc32("uhCBfkyHjDDFyH",14) == 3385205995) strcat(s, "w");
if (crc32("hAZQfrCgQhwFK",13) == 1894372836) strcat(s, "e");
if (crc32("ivrlp",5) == 3530355912) strcat(s, "b");
if (crc32("rlscREfud",9) == 830727458) strcat(s, "f");
if (crc32("RBXZBbA",7) == 3798714054) strcat(s, "r");
if (crc32("UgVRN",5) == 3832576653) strcat(s, "u");
if (crc32("wOrwjcdudZko",12) == 3749737963) strcat(s, "i");
if (crc32("YqEePwDAnfltJLT",15) == 2900733299) strcat(s, "m");
if (crc32("ABDQnFgzkPe",11) == 302372899) strcat(s, "e");
if (crc32("hlPCnCStgLoy",12) == 1934198073) strcat(s, "f");
    return s;
}

char *sermonizing_verbs() {
    char *s = calloc(12);
    if (crc32("gxjyBfsDWZC",11) == 3786777949) strcat(s, "s");
if (crc32("jfWWP",5) == 4237267580) strcat(s, "s");
if (crc32("vPOVHUL",7) == 3971012012) strcat(s, "e");
if (crc32("aydLhRmTfib",11) == 2490796622) strcat(s, "y");
if (crc32("YYCHHGPcsBxJcoD",15) == 3620212559) strcat(s, "r");
if (crc32("OzMpksAgWCYubf",14) == 215086505) strcat(s, "w");
if (crc32("slKeW",5) == 2565479469) strcat(s, "m");
if (crc32("Ozisexr",7) == 160944955) strcat(s, "E");
if (crc32("dZzfKlFVoUT",11) == 3189440884) strcat(s, "o");
if (crc32("MqjFQBOikEzXCdX",15) == 3980807405) strcat(s, "n");
if (crc32("TyKrEEMoyvKf",12) == 1212158000) strcat(s, "I");
if (crc32("eamTgJTkAic",11) == 3638246020) strcat(s, "i");
if (crc32("XtADFNUKOUK",11) == 883784624) strcat(s, "g");
if (crc32("TtBhVZxo",8) == 4062000553) strcat(s, "z");
if (crc32("CSmHbLNS",8) == 2027147176) strcat(s, "i");
if (crc32("kLTukcXTa",9) == 2344887684) strcat(s, "n");
if (crc32("sCsaK",5) == 1071441925) strcat(s, "i");
if (crc32("tHLoHVda",8) == 1418824747) strcat(s, "g");
    return s;
}

char *longed_verbs() {
    char *s = calloc(7);
    if (crc32("ukWHWGbxBYxho",13) == 1565070404) strcat(s, "l");
if (crc32("iketGjxx",8) == 1611327351) strcat(s, "E");
if (crc32("pldjfjSJftWswkx",15) == 4104882092) strcat(s, "o");
if (crc32("bGdQjYPdGCHz",12) == 339868081) strcat(s, "q");
if (crc32("YTkJRBUpsN",10) == 3136172259) strcat(s, "n");
if (crc32("ykINevpjIezxNEf",15) == 3458938180) strcat(s, "e");
if (crc32("iULnQFeRKFryXsf",15) == 1162093461) strcat(s, "g");
if (crc32("EnczsWuPTEOBZZm",15) == 4261796674) strcat(s, "u");
if (crc32("fhHHXrDjuwoq",12) == 3436021999) strcat(s, "e");
if (crc32("hgoNlwPt",8) == 4223767476) strcat(s, "d");
    return s;
}

char *drudging_verbs() {
    char *s = calloc(9);
    if (crc32("kJlAOjlGFO",10) == 647006322) strcat(s, "G");
if (crc32("NXlJR",5) == 3781596011) strcat(s, "d");
if (crc32("qEZYNiiLwqOuzd",14) == 867032602) strcat(s, "r");
if (crc32("udDibPFWsTF",11) == 4130695161) strcat(s, "u");
if (crc32("TItEVwwhZvyC",12) == 1645076348) strcat(s, "d");
if (crc32("IMihNGOha",9) == 3514699519) strcat(s, "g");
if (crc32("WFrOtFGFgyp",11) == 4054107497) strcat(s, "i");
if (crc32("ygconIRaYdrJhgd",15) == 4090420930) strcat(s, "n");
if (crc32("vxwDWZtcjAjrVN",14) == 3163856625) strcat(s, "k");
if (crc32("WwrXjH",6) == 2939680931) strcat(s, "g");
    return s;
}

char *plodded_verbs() {
    char *s = calloc(8);
    if (crc32("tLNHmyarhxqV",12) == 118125680) strcat(s, "p");
if (crc32("nxtKFtBcGBXy",12) == 411290801) strcat(s, "l");
if (crc32("OsSblTPuqlz",11) == 2030630352) strcat(s, "o");
if (crc32("hnCthbZMuDo",11) == 2082600400) strcat(s, "d");
if (crc32("cdmaK",5) == 183900641) strcat(s, "o");
if (crc32("DVZxwjYPRuNZ",12) == 1900904686) strcat(s, "d");
if (crc32("lsEryoJjcUUmUSn",15) == 3344580304) strcat(s, "j");
if (crc32("mYJds",5) == 2752873210) strcat(s, "e");
if (crc32("iEAqTYAOKtKo",12) == 1467624685) strcat(s, "d");
    return s;
}

char *spangling_verbs() {
    char *s = calloc(10);
    if (crc32("bQoiivkVxZgs",12) == 1875655582) strcat(s, "s");
if (crc32("TQIwuXmsmfLXA",13) == 4143923699) strcat(s, "p");
if (crc32("HdlVHn",6) == 2624005591) strcat(s, "G");
if (crc32("ZFAmH",5) == 3555859497) strcat(s, "a");
if (crc32("UgYWLyqpOhUR",12) == 212131390) strcat(s, "n");
if (crc32("mFVKMzWHtc",10) == 138526806) strcat(s, "g");
if (crc32("hsAZZ",5) == 2891460128) strcat(s, "l");
if (crc32("UelIyh",6) == 1920519753) strcat(s, "U");
if (crc32("ddtyed",6) == 2738709461) strcat(s, "i");
if (crc32("udEhQ",5) == 788061371) strcat(s, "X");
if (crc32("MAVAGvSRJ",9) == 2082163553) strcat(s, "n");
if (crc32("iPSJcWvFTvri",12) == 804365005) strcat(s, "l");
if (crc32("kUvPoEVYrVu",11) == 689355466) strcat(s, "g");
    return s;
}

char *cotising_verbs() {
    char *s = calloc(9);
    if (crc32("siIDasTHUNt",11) == 2353248180) strcat(s, "B");
if (crc32("RfWahqrXC",9) == 972054425) strcat(s, "c");
if (crc32("nJmgsqKJTKOl",12) == 2249402489) strcat(s, "o");
if (crc32("IsUDZEVFjzg",11) == 2184750440) strcat(s, "P");
if (crc32("IuwOImaNg",9) == 3487517339) strcat(s, "t");
if (crc32("JjdQQlRlKkgZb",13) == 3281624704) strcat(s, "m");
if (crc32("lmVhH",5) == 4005443712) strcat(s, "i");
if (crc32("ggEVhWHsqqASB",13) == 504104681) strcat(s, "s");
if (crc32("WuKhJ",5) == 1460838248) strcat(s, "i");
if (crc32("CosWq",5) == 2454898216) strcat(s, "B");
if (crc32("FFHspVCVyr",10) == 3880334886) strcat(s, "n");
if (crc32("KEwaJ",5) == 2904827361) strcat(s, "g");
if (crc32("tydvEnfJFbDt",12) == 3255336658) strcat(s, "g");
    return s;
}

char *reconsolidated_verbs() {
    char *s = calloc(15);
    if (crc32("bpbSOGGzecBxuxa",15) == 415507512) strcat(s, "r");
if (crc32("PKDjnABQNk",10) == 2902263864) strcat(s, "Q");
if (crc32("SQGfcnqnI",9) == 3481079074) strcat(s, "e");
if (crc32("GLWup",5) == 2525843579) strcat(s, "c");
if (crc32("lubsTkbRzDvGG",13) == 1839903761) strcat(s, "o");
if (crc32("gfHvGjxsgUFIZ",13) == 1944594469) strcat(s, "y");
if (crc32("VmyXEHm",7) == 4002032967) strcat(s, "n");
if (crc32("deqfATpyOko",11) == 4150057573) strcat(s, "s");
if (crc32("CMTBFFATIY",10) == 3464579417) strcat(s, "o");
if (crc32("uRLuWfarbjUJtkN",15) == 1647025851) strcat(s, "l");
if (crc32("PMiuhPC",7) == 245106061) strcat(s, "V");
if (crc32("ZHbxmaWUNaGz",12) == 3843718174) strcat(s, "i");
if (crc32("gYqkPWTQHoXiOU",14) == 177359624) strcat(s, "a");
if (crc32("zykFSYxEee",10) == 3056266889) strcat(s, "d");
if (crc32("lnSTK",5) == 2525962612) strcat(s, "x");
if (crc32("SeFwPQheExoiq",13) == 3292342078) strcat(s, "a");
if (crc32("TtUdOpSrYnRLGb",14) == 3473850309) strcat(s, "o");
if (crc32("hhvuDfJRZS",10) == 3111277909) strcat(s, "t");
if (crc32("CUrEWmWthPas",12) == 3706184546) strcat(s, "e");
if (crc32("kWGRYqOSoFm",11) == 4181174629) strcat(s, "z");
if (crc32("vOhEDrPFQAcCal",14) == 717169591) strcat(s, "d");
    return s;
}

char *draw_verbs() {
    char *s = calloc(5);
    if (crc32("ublky",5) == 2283990682) strcat(s, "d");
if (crc32("DDitflybykWesH",14) == 1612618522) strcat(s, "r");
if (crc32("QUFylFyWthhLWJI",15) == 2562976201) strcat(s, "F");
if (crc32("WvwCU",5) == 2477710574) strcat(s, "a");
if (crc32("pVIFqOcAzmGnVKa",15) == 3080027317) strcat(s, "w");
    return s;
}

char *savvy_verbs() {
    char *s = calloc(6);
    if (crc32("fCvGnkxSTcRIU",13) == 2902821980) strcat(s, "q");
if (crc32("TchUQj",6) == 1651323195) strcat(s, "s");
if (crc32("GTvJDb",6) == 3075082485) strcat(s, "J");
if (crc32("BQxjMBrqTXWG",12) == 3937930550) strcat(s, "a");
if (crc32("lKaUcLmQRHA",11) == 2270767232) strcat(s, "v");
if (crc32("HaFdRI",6) == 2159531424) strcat(s, "v");
if (crc32("mLJWJufX",8) == 3332638579) strcat(s, "d");
if (crc32("ftJRHAywncH",11) == 3048168183) strcat(s, "y");
    return s;
}

char *buggeroff_verbs() {
    char *s = calloc(10);
    if (crc32("BYaBBw",6) == 773446632) strcat(s, "Q");
if (crc32("oSxEI",5) == 3692350545) strcat(s, "b");
if (crc32("BJGzlneztjQm",12) == 212408319) strcat(s, "u");
if (crc32("eoqaOdS",7) == 1918713018) strcat(s, "g");
if (crc32("AQHDNrq",7) == 2007791127) strcat(s, "q");
if (crc32("UovAWMnI",8) == 1729369975) strcat(s, "g");
if (crc32("ymmzFlVH",8) == 1342216904) strcat(s, "e");
if (crc32("GWhhDZi",7) == 287129221) strcat(s, "q");
if (crc32("sssNGO",6) == 3637735080) strcat(s, "r");
if (crc32("XlvCrD",6) == 2053332534) strcat(s, "b");
if (crc32("hQKYLTmIpElx",12) == 2529811375) strcat(s, "o");
if (crc32("vJMrf",5) == 1692982310) strcat(s, "q");
if (crc32("UPRjeD",6) == 2565694616) strcat(s, "f");
if (crc32("QlMNsHfmCgRBOo",14) == 1274924536) strcat(s, "f");
    return s;
}

char *prettify_verbs() {
    char *s = calloc(9);
    if (crc32("zCDZcHF",7) == 3103092039) strcat(s, "p");
if (crc32("pbSxrigDcnRiUPn",15) == 138567703) strcat(s, "d");
if (crc32("aGHkPdDFQ",9) == 3658845528) strcat(s, "r");
if (crc32("EWIoWkYU",8) == 2217254340) strcat(s, "i");
if (crc32("CjBTaGhx",8) == 1732302882) strcat(s, "e");
if (crc32("VLoqNOehmqK",11) == 1316325198) strcat(s, "t");
if (crc32("fPfIanyznFCeqpD",15) == 3065663773) strcat(s, "t");
if (crc32("sXWVZSEPnTP",11) == 1447624360) strcat(s, "S");
if (crc32("DOsowgUUXlkbH",13) == 100961836) strcat(s, "i");
if (crc32("tJIilGw",7) == 147951588) strcat(s, "f");
if (crc32("UYvLVhdsVjHjfw",14) == 3737808202) strcat(s, "y");
    return s;
}

char *missampled_verbs() {
    char *s = calloc(11);
    if (crc32("sSNawbyo",8) == 1519105740) strcat(s, "m");
if (crc32("tupjAROq",8) == 3436397106) strcat(s, "g");
if (crc32("PkaiykkAiTxTFi",14) == 2305303695) strcat(s, "i");
if (crc32("ELrgRhukWQV",11) == 809472363) strcat(s, "o");
if (crc32("bSDhYjIEfc",10) == 3885735313) strcat(s, "s");
if (crc32("ImBniFYIcWS",11) == 1592724534) strcat(s, "A");
if (crc32("PVJwflcHXvVLkuM",15) == 148382729) strcat(s, "s");
if (crc32("MEIulgM",7) == 2546645473) strcat(s, "s");
if (crc32("HAWXaLW",7) == 1255173238) strcat(s, "a");
if (crc32("nIoIGbqCebbKv",13) == 1032037360) strcat(s, "m");
if (crc32("rNOolV",6) == 3679977309) strcat(s, "p");
if (crc32("CsXzucJ",7) == 2241141183) strcat(s, "R");
if (crc32("JkMIPtM",7) == 1993944816) strcat(s, "l");
if (crc32("ShXzVTtu",8) == 3145905257) strcat(s, "e");
if (crc32("eQUDyHCLXz",10) == 2163246378) strcat(s, "W");
if (crc32("YbiBovBvK",9) == 1221322254) strcat(s, "d");
    return s;
}

char *underscoring_verbs() {
    char *s = calloc(13);
    if (crc32("gZyqZMdir",9) == 1037861114) strcat(s, "L");
if (crc32("fGFhiNEbmhbTi",13) == 3092687627) strcat(s, "u");
if (crc32("RTJpx",5) == 3430054829) strcat(s, "n");
if (crc32("IRBtxZE",7) == 3621209059) strcat(s, "d");
if (crc32("ZeNDcyyfEyOFBtP",15) == 3326055116) strcat(s, "e");
if (crc32("yRwxC",5) == 1978327040) strcat(s, "Y");
if (crc32("utoIpBmBkQuv",12) == 1492153353) strcat(s, "r");
if (crc32("gvikvOGacvXSWuu",15) == 3193507836) strcat(s, "s");
if (crc32("oyPCoxQ",7) == 3305937378) strcat(s, "c");
if (crc32("nOaCmuDkBAz",11) == 1790468789) strcat(s, "N");
if (crc32("AvZOMBiHgqB",11) == 3732403755) strcat(s, "o");
if (crc32("IpDlvFMCn",9) == 1272468718) strcat(s, "V");
if (crc32("kNWUJEWZifMyZ",13) == 3614220967) strcat(s, "r");
if (crc32("bEcpYbjgA",9) == 2392226334) strcat(s, "i");
if (crc32("SCiJovcDV",9) == 3428068633) strcat(s, "p");
if (crc32("WpqWJGeZMD",10) == 3553412448) strcat(s, "n");
if (crc32("cjqmInR",7) == 2196996901) strcat(s, "g");
    return s;
}

char *warble_verbs() {
    char *s = calloc(7);
    if (crc32("BAbvHMnI",8) == 232001110) strcat(s, "w");
if (crc32("kvnMtlkcWT",10) == 1521616128) strcat(s, "a");
if (crc32("uvZxxUH",7) == 3343304812) strcat(s, "r");
if (crc32("EHuzFK",6) == 3296650311) strcat(s, "b");
if (crc32("zHrzgUdYNo",10) == 1075499456) strcat(s, "l");
if (crc32("fYVkbxaDd",9) == 3042519370) strcat(s, "M");
if (crc32("ZKwOJjo",7) == 3368095854) strcat(s, "e");
    return s;
}

char *relieved_verbs() {
    char *s = calloc(9);
    if (crc32("oeGyzXWuZ",9) == 802349865) strcat(s, "O");
if (crc32("sFlMXO",6) == 1987358288) strcat(s, "r");
if (crc32("EJvQpUxiNBvNN",13) == 2418110016) strcat(s, "z");
if (crc32("HrAnLez",7) == 3285371399) strcat(s, "e");
if (crc32("PuOCnCSXSA",10) == 1661156199) strcat(s, "l");
if (crc32("ZgPJL",5) == 2675797914) strcat(s, "R");
if (crc32("YUaIgc",6) == 1751536524) strcat(s, "i");
if (crc32("CpuNjvADRpG",11) == 3897377072) strcat(s, "t");
if (crc32("sPDdfqpBD",9) == 2078179604) strcat(s, "e");
if (crc32("YGlODVDsaiERxxb",15) == 1130200324) strcat(s, "v");
if (crc32("bSmmIsPSwqLrTZH",15) == 1723954489) strcat(s, "e");
if (crc32("qoKxltUQApqX",12) == 3366521882) strcat(s, "d");
    return s;
}

char *rivetted_verbs() {
    char *s = calloc(9);
    if (crc32("ihDyqacF",8) == 3813418726) strcat(s, "D");
if (crc32("ucrlg",5) == 2473110561) strcat(s, "r");
if (crc32("QlAcuX",6) == 1947467497) strcat(s, "i");
if (crc32("LuEsxp",6) == 2388217334) strcat(s, "q");
if (crc32("aupibzD",7) == 3146536864) strcat(s, "v");
if (crc32("MtPaC",5) == 2927429917) strcat(s, "P");
if (crc32("tGitNnzJoljez",13) == 1469820626) strcat(s, "e");
if (crc32("vncBIIbjw",9) == 4055938068) strcat(s, "t");
if (crc32("cVcBY",5) == 111294007) strcat(s, "J");
if (crc32("WzGljypivZnqxbc",15) == 2653679546) strcat(s, "t");
if (crc32("kMCnmry",7) == 152984937) strcat(s, "c");
if (crc32("aIMqG",5) == 582106176) strcat(s, "e");
if (crc32("sSQqpgXgsqhEmOi",15) == 717529533) strcat(s, "P");
if (crc32("hnLiYHZ",7) == 479581903) strcat(s, "d");
    return s;
}

char *dominated_verbs() {
    char *s = calloc(10);
    if (crc32("qdDKeRdKSt",10) == 80347241) strcat(s, "d");
if (crc32("ytJJESqhtVq",11) == 3375655045) strcat(s, "r");
if (crc32("eqGnHI",6) == 1583565986) strcat(s, "o");
if (crc32("JYRXUGtTXFMdoj",14) == 4005313360) strcat(s, "Z");
if (crc32("ACOqmr",6) == 2458457349) strcat(s, "m");
if (crc32("lnBEMCPYDH",10) == 2410955492) strcat(s, "i");
if (crc32("miKJgjkTBERlAEw",15) == 4129116936) strcat(s, "i");
if (crc32("FQbgx",5) == 1561405715) strcat(s, "n");
if (crc32("nYadOtMRzUAEj",13) == 1087250677) strcat(s, "a");
if (crc32("XaqTRYYWghLlUv",14) == 4229560753) strcat(s, "t");
if (crc32("GxillFOgwrQxEG",14) == 1587390515) strcat(s, "W");
if (crc32("AcmLnyxEtJb",11) == 4254168614) strcat(s, "e");
if (crc32("dfGMchRSmXJ",11) == 1055807898) strcat(s, "d");
    return s;
}

char *misship_verbs() {
    char *s = calloc(8);
    if (crc32("OtfhlebaxBf",11) == 3050956342) strcat(s, "m");
if (crc32("JDBCxzZd",8) == 2509132382) strcat(s, "e");
if (crc32("dnyrDBThBKrP",12) == 4253290266) strcat(s, "i");
if (crc32("YZEemwMmRaYg",12) == 243969540) strcat(s, "s");
if (crc32("mlTqzzmFaOIwY",13) == 3150265300) strcat(s, "s");
if (crc32("chIaCQKhOcquM",13) == 556656482) strcat(s, "h");
if (crc32("DpZjqL",6) == 1952967978) strcat(s, "i");
if (crc32("mYKPNYgGCKqIuS",14) == 4072782412) strcat(s, "p");
    return s;
}

char *quipped_verbs() {
    char *s = calloc(8);
    if (crc32("EqygKWMXWhbWWNh",15) == 3427177116) strcat(s, "q");
if (crc32("cAdqxGBVh",9) == 3399507122) strcat(s, "u");
if (crc32("pbjuVMukHu",10) == 3795141872) strcat(s, "i");
if (crc32("kXuzkceMWvr",11) == 2767554189) strcat(s, "p");
if (crc32("CkhKL",5) == 636788170) strcat(s, "K");
if (crc32("dEDXbKGIGL",10) == 3249218632) strcat(s, "p");
if (crc32("qfRyU",5) == 2518223783) strcat(s, "e");
if (crc32("jJBtAgLQUyK",11) == 1402935398) strcat(s, "l");
if (crc32("tpMZhOQyLw",10) == 1569616549) strcat(s, "d");
    return s;
}

char *nictitate_verbs() {
    char *s = calloc(10);
    if (crc32("lppIfJB",7) == 242754927) strcat(s, "R");
if (crc32("YIJDIUSzQhiikt",14) == 2839091207) strcat(s, "n");
if (crc32("jgBDqshBKGKXt",13) == 1503202233) strcat(s, "r");
if (crc32("hzaJJNYUNV",10) == 3247250096) strcat(s, "i");
if (crc32("kIGVLOIQ",8) == 2519377769) strcat(s, "l");
if (crc32("kUlExupxwBtf",12) == 489928651) strcat(s, "c");
if (crc32("zYJrp",5) == 4081331461) strcat(s, "t");
if (crc32("DxzBeq",6) == 3770222732) strcat(s, "A");
if (crc32("XPwzu",5) == 2706183855) strcat(s, "i");
if (crc32("cThDDZDwKk",10) == 2205372278) strcat(s, "R");
if (crc32("VXokuMqdRdc",11) == 2556868901) strcat(s, "t");
if (crc32("lDhbb",5) == 3154933991) strcat(s, "Z");
if (crc32("IWFsWWPJiBX",11) == 3383196483) strcat(s, "a");
if (crc32("VJchHrsy",8) == 355229990) strcat(s, "t");
if (crc32("fUNIFeXY",8) == 4065120583) strcat(s, "e");
    return s;
}

char *pargetted_verbs() {
    char *s = calloc(10);
    if (crc32("TTNRld",6) == 2083182195) strcat(s, "p");
if (crc32("arrqV",5) == 1075823039) strcat(s, "a");
if (crc32("rQEvoeVYMzKQk",13) == 4294039200) strcat(s, "r");
if (crc32("uwqMiNWAeCInwx",14) == 2170646447) strcat(s, "g");
if (crc32("OSPGohzPpa",10) == 1044002474) strcat(s, "e");
if (crc32("hKhcxMVbATrw",12) == 1036513730) strcat(s, "E");
if (crc32("YXXlJXj",7) == 275210813) strcat(s, "t");
if (crc32("brWYMZS",7) == 356756372) strcat(s, "w");
if (crc32("doTHcokt",8) == 144230388) strcat(s, "t");
if (crc32("wpaKsRmeRHbw",12) == 1120760524) strcat(s, "e");
if (crc32("UrhHBPlPFWJMlAi",15) == 180251747) strcat(s, "d");
    return s;
}

char *overfatigued_verbs() {
    char *s = calloc(13);
    if (crc32("pgLBIzJsnY",10) == 1350946962) strcat(s, "o");
if (crc32("hrxyUiFOwNzRi",13) == 641733136) strcat(s, "v");
if (crc32("NyCsBtXf",8) == 1453057000) strcat(s, "p");
if (crc32("VGrhKPURaGljF",13) == 1545942434) strcat(s, "e");
if (crc32("VrFlQMWgZAVHRF",14) == 1544577126) strcat(s, "E");
if (crc32("eNiIXjHOPe",10) == 1299800887) strcat(s, "r");
if (crc32("SrtJLNfBu",9) == 1971989806) strcat(s, "g");
if (crc32("BHMZETvHKjT",11) == 2771410091) strcat(s, "f");
if (crc32("vGYsmynVpVIMXN",14) == 867446359) strcat(s, "u");
if (crc32("lBTApGW",7) == 1662480670) strcat(s, "a");
if (crc32("AmFjsp",6) == 3142375816) strcat(s, "t");
if (crc32("iXXFhYWDxtvPxC",14) == 2527981943) strcat(s, "i");
if (crc32("LhFwFU",6) == 1268255943) strcat(s, "R");
if (crc32("EseZdMSOEIUtiYM",15) == 1136792162) strcat(s, "g");
if (crc32("KYHZlUL",7) == 3867879292) strcat(s, "W");
if (crc32("GnkGlSwkCu",10) == 1320453672) strcat(s, "u");
if (crc32("oXjrKaSc",8) == 3474827508) strcat(s, "q");
if (crc32("tLois",5) == 621423330) strcat(s, "e");
if (crc32("pKymoULQpcOWtW",14) == 1642258962) strcat(s, "d");
    return s;
}

char *rant_verbs() {
    char *s = calloc(5);
    if (crc32("hZlLZHs",7) == 2510800201) strcat(s, "r");
if (crc32("mNALMJI",7) == 1006957211) strcat(s, "v");
if (crc32("qKwFGoMPvckfISC",15) == 725040352) strcat(s, "a");
if (crc32("WrMwOU",6) == 3320702723) strcat(s, "P");
if (crc32("GLPmaJe",7) == 3948817860) strcat(s, "n");
if (crc32("mrQvH",5) == 178945955) strcat(s, "t");
    return s;
}

char *outspeaking_verbs() {
    char *s = calloc(12);
    if (crc32("gkNZSWZkQzZ",11) == 1207696215) strcat(s, "o");
if (crc32("AiYwNhU",7) == 1690987800) strcat(s, "k");
if (crc32("ubrEZvtiZkoMWp",14) == 1476556058) strcat(s, "u");
if (crc32("zzyzKvaBhuZqXAS",15) == 2172545352) strcat(s, "f");
if (crc32("NQFhmARnXKqUs",13) == 3257317408) strcat(s, "t");
if (crc32("KqfxPdAHhNKCLsk",15) == 1621802498) strcat(s, "I");
if (crc32("QgIJLsCseoHXzKc",15) == 893870246) strcat(s, "s");
if (crc32("GoalzLBVtcn",11) == 3220510890) strcat(s, "C");
if (crc32("uRrThrY",7) == 3967666920) strcat(s, "p");
if (crc32("gcvbWsJ",7) == 1441532665) strcat(s, "C");
if (crc32("HfjgRmerqy",10) == 707803444) strcat(s, "e");
if (crc32("rUdVIx",6) == 614779624) strcat(s, "Q");
if (crc32("irYkZTrtxfsOd",13) == 94703147) strcat(s, "a");
if (crc32("cTwtxchYNqn",11) == 163987232) strcat(s, "T");
if (crc32("sLBzR",5) == 2319020685) strcat(s, "k");
if (crc32("MccTwGyFdVO",11) == 3430583851) strcat(s, "i");
if (crc32("StgbcqEVmlV",11) == 3501188034) strcat(s, "n");
if (crc32("nnpdnP",6) == 298504728) strcat(s, "g");
    return s;
}

char *invert_verbs() {
    char *s = calloc(7);
    if (crc32("lJtNdstR",8) == 1504236322) strcat(s, "i");
if (crc32("FSMOGjslWrpoMP",14) == 3675189784) strcat(s, "X");
if (crc32("WlFoboSv",8) == 1323328449) strcat(s, "n");
if (crc32("nUMOQmpRUxXB",12) == 4244378557) strcat(s, "T");
if (crc32("NVWcfWEq",8) == 194743529) strcat(s, "v");
if (crc32("nzYmpkvL",8) == 2345295824) strcat(s, "e");
if (crc32("mJdxAzyySjz",11) == 3917429143) strcat(s, "o");
if (crc32("SHUIdKpFKviY",12) == 90870755) strcat(s, "r");
if (crc32("pkNNJUQQKCGmtTd",15) == 813904171) strcat(s, "t");
    return s;
}

char *zigzagged_verbs() {
    char *s = calloc(10);
    if (crc32("SFuWusTDlGiAU",13) == 2591276244) strcat(s, "s");
if (crc32("WRZMAlslhmjj",12) == 1722969837) strcat(s, "z");
if (crc32("AzZjFJrcVTuGpfq",15) == 4207963088) strcat(s, "i");
if (crc32("hDTJJ",5) == 1053292103) strcat(s, "a");
if (crc32("QdyAviRRoerdnfx",15) == 2919512486) strcat(s, "g");
if (crc32("NxhPiUDDnJIUnu",14) == 3749835106) strcat(s, "t");
if (crc32("NxBuYfK",7) == 2705278071) strcat(s, "z");
if (crc32("KqPgX",5) == 1823883747) strcat(s, "w");
if (crc32("SskSEcpZtPblMdN",15) == 3144719560) strcat(s, "a");
if (crc32("dkiqcStPvYfU",12) == 137899779) strcat(s, "g");
if (crc32("lRwsnMxATlWYcP",14) == 2411464210) strcat(s, "g");
if (crc32("BmtZqaEhEPabm",13) == 4217107810) strcat(s, "e");
if (crc32("UcBvynT",7) == 3269333224) strcat(s, "d");
    return s;
}

char *change_verbs() {
    char *s = calloc(7);
    if (crc32("WdsxPAeHT",9) == 1056145900) strcat(s, "P");
if (crc32("eoZdZqEv",8) == 2224764238) strcat(s, "c");
if (crc32("AGIMI",5) == 4090840109) strcat(s, "b");
if (crc32("ymfADDP",7) == 3988854110) strcat(s, "h");
if (crc32("EPflBaeXqCrA",12) == 1722538780) strcat(s, "a");
if (crc32("xJWNMjSkxqhxlS",14) == 1718801903) strcat(s, "e");
if (crc32("NdTTHwmGHzENVHR",15) == 2256526684) strcat(s, "n");
if (crc32("iQwETfEUSUyuVEz",15) == 406022617) strcat(s, "g");
if (crc32("annLHQoxD",9) == 93146954) strcat(s, "e");
    return s;
}

char *litigated_verbs() {
    char *s = calloc(10);
    if (crc32("yEOnyAiRdHJq",12) == 2789954679) strcat(s, "j");
if (crc32("XLlAsTrYcOp",11) == 1625423423) strcat(s, "l");
if (crc32("qDKcphhWaF",10) == 2006220631) strcat(s, "m");
if (crc32("AXzonEYcGuvT",12) == 386164706) strcat(s, "i");
if (crc32("uBEXJ",5) == 3438617844) strcat(s, "e");
if (crc32("xrDzuePGq",9) == 2427863573) strcat(s, "t");
if (crc32("rsTVCzLsjK",10) == 2855456730) strcat(s, "W");
if (crc32("JrajnDynpWBnlqL",15) == 1612594176) strcat(s, "i");
if (crc32("lVaGpa",6) == 2590144498) strcat(s, "g");
if (crc32("FKEXNaOmCZo",11) == 1903321745) strcat(s, "Q");
if (crc32("RlKfjONhN",9) == 4093185819) strcat(s, "a");
if (crc32("fjmZlba",7) == 3044839246) strcat(s, "U");
if (crc32("vkReGlbSYha",11) == 2694099997) strcat(s, "t");
if (crc32("QRZuSFuMgXip",12) == 2631607400) strcat(s, "n");
if (crc32("gIMpPvfj",8) == 557506619) strcat(s, "e");
if (crc32("ArgTOPhDe",9) == 3983013300) strcat(s, "P");
if (crc32("samNeVdJ",8) == 3401885689) strcat(s, "d");
    return s;
}

char *mollycoddled_verbs() {
    char *s = calloc(13);
    if (crc32("etGYEWwGLS",10) == 1246637799) strcat(s, "K");
if (crc32("UYeSAu",6) == 1938684274) strcat(s, "m");
if (crc32("sOagTTvKIrJJLjg",15) == 3437625688) strcat(s, "U");
if (crc32("jPLuCwgwvnJA",12) == 674372067) strcat(s, "o");
if (crc32("KscLMpeW",8) == 1373198387) strcat(s, "r");
if (crc32("GVlAruSv",8) == 2804313850) strcat(s, "l");
if (crc32("uQKGMoAFnmU",11) == 1127382416) strcat(s, "l");
if (crc32("ZTNguGpN",8) == 19057386) strcat(s, "F");
if (crc32("YBPrTIFDYB",10) == 2156218420) strcat(s, "y");
if (crc32("zIMckwzvEixUi",13) == 2785204237) strcat(s, "R");
if (crc32("vcLdv",5) == 1481946257) strcat(s, "c");
if (crc32("qQGYohyu",8) == 1547108811) strcat(s, "o");
if (crc32("HXckL",5) == 334104950) strcat(s, "d");
if (crc32("RyrjwWcZq",9) == 3955593234) strcat(s, "d");
if (crc32("DByrfIyPLRXzJuV",15) == 1916449436) strcat(s, "l");
if (crc32("zIoUcuq",7) == 625585619) strcat(s, "e");
if (crc32("RHxmcLvhZGLp",12) == 4227217018) strcat(s, "d");
    return s;
}

char *throbbing_verbs() {
    char *s = calloc(10);
    if (crc32("hZMnBgr",7) == 336813691) strcat(s, "t");
if (crc32("edHNUoJ",7) == 3853882146) strcat(s, "a");
if (crc32("cszLJFs",7) == 3657836945) strcat(s, "h");
if (crc32("UpncPjSmgxRMK",13) == 3703513938) strcat(s, "r");
if (crc32("hrRbBDHARxoM",12) == 1849482918) strcat(s, "A");
if (crc32("CQPjSkDsBkaeo",13) == 2948346453) strcat(s, "o");
if (crc32("TJFopGtuNZ",10) == 819994942) strcat(s, "R");
if (crc32("vIXCACtpeXgvW",13) == 3963149113) strcat(s, "b");
if (crc32("BIxfLeZNSF",10) == 1710386777) strcat(s, "b");
if (crc32("mEtJUZnRsP",10) == 1201720412) strcat(s, "b");
if (crc32("grtxWVavILVh",12) == 2940236700) strcat(s, "i");
if (crc32("ypISXWfXsN",10) == 3202361129) strcat(s, "n");
if (crc32("FEqHEjIvzuXoun",14) == 3974891597) strcat(s, "B");
if (crc32("AtvCMiHyhR",10) == 709140278) strcat(s, "g");
    return s;
}

char *grated_verbs() {
    char *s = calloc(7);
    if (crc32("gqkCzRLSuOAoC",13) == 821134597) strcat(s, "g");
if (crc32("OYrsqnlZmTvlhRz",15) == 2230169209) strcat(s, "l");
if (crc32("LwLrycvQsuGW",12) == 1941445419) strcat(s, "r");
if (crc32("xAJJZQKK",8) == 1615440373) strcat(s, "U");
if (crc32("bidrZUdtMKbWm",13) == 2998752390) strcat(s, "a");
if (crc32("UmfbbbppbzUQmN",14) == 2876330873) strcat(s, "H");
if (crc32("ePwjvHRDBPgJAb",14) == 3760006420) strcat(s, "t");
if (crc32("SrcqclGIKLrgS",13) == 2581842882) strcat(s, "e");
if (crc32("TpyzGGNsYI",10) == 3915043052) strcat(s, "d");
    return s;
}

char *exclaim_verbs() {
    char *s = calloc(8);
    if (crc32("wSwiFJp",7) == 3146831658) strcat(s, "w");
if (crc32("oROatmcsvjDK",12) == 2836295218) strcat(s, "e");
if (crc32("kxejut",6) == 4050149255) strcat(s, "R");
if (crc32("BHJkEOjJr",9) == 3437516258) strcat(s, "x");
if (crc32("UvkVRXbrc",9) == 762193954) strcat(s, "R");
if (crc32("YbWsbLJ",7) == 473069099) strcat(s, "c");
if (crc32("ITxOSxPOvxTQ",12) == 4274224782) strcat(s, "l");
if (crc32("plGPmuRqqaPq",12) == 680325221) strcat(s, "D");
if (crc32("clrDefgE",8) == 4032951359) strcat(s, "a");
if (crc32("EAbQou",6) == 2269675533) strcat(s, "b");
if (crc32("hsylCPDbS",9) == 600832756) strcat(s, "i");
if (crc32("JrZoxRGvBJrf",12) == 2611409726) strcat(s, "m");
if (crc32("upNON",5) == 11446185) strcat(s, "m");
    return s;
}

char *puzzle_verbs() {
    char *s = calloc(7);
    if (crc32("LaJsxUSAPbcy",12) == 2580986650) strcat(s, "p");
if (crc32("elrqVbSAOqZS",12) == 2842793666) strcat(s, "s");
if (crc32("MpwYIhwcaPZY",12) == 446972598) strcat(s, "u");
if (crc32("YjhEpfWqdzffoL",14) == 317628828) strcat(s, "T");
if (crc32("WRlSIWcXkAYx",12) == 1838938019) strcat(s, "z");
if (crc32("FMEKJFmvQf",10) == 2679308652) strcat(s, "z");
if (crc32("NcCDKfXWckBTb",13) == 3088755257) strcat(s, "l");
if (crc32("MJjDxAbNnVLRc",13) == 2132741556) strcat(s, "R");
if (crc32("CxsVPaCwZTUbjIX",15) == 1982309696) strcat(s, "e");
    return s;
}

char *sedated_verbs() {
    char *s = calloc(8);
    if (crc32("WZPoyTS",7) == 4207460489) strcat(s, "s");
if (crc32("qpyzCwwlxMYE",12) == 720893794) strcat(s, "e");
if (crc32("ZdZcARQtFWKA",12) == 3647686132) strcat(s, "d");
if (crc32("GOWPdapNC",9) == 2085433077) strcat(s, "a");
if (crc32("uiPJFWA",7) == 331733794) strcat(s, "m");
if (crc32("ygCumiTaKMQEPo",14) == 2706640897) strcat(s, "t");
if (crc32("rlYcNfHdCYoY",12) == 2287157568) strcat(s, "e");
if (crc32("lDSeYxAoA",9) == 32941575) strcat(s, "D");
if (crc32("JTCmYQoRApk",11) == 3432000079) strcat(s, "d");
    return s;
}

char *regenerated_verbs() {
    char *s = calloc(12);
    if (crc32("PlsyLt",6) == 1150383901) strcat(s, "x");
if (crc32("fTEXJ",5) == 101047804) strcat(s, "r");
if (crc32("GYlhGtTBFDVQXK",14) == 2657830444) strcat(s, "T");
if (crc32("lxiZCZxx",8) == 822815596) strcat(s, "e");
if (crc32("SGXEvCcxX",9) == 1010612438) strcat(s, "d");
if (crc32("GPjQkzn",7) == 2334483127) strcat(s, "g");
if (crc32("EGncmWuYY",9) == 405926479) strcat(s, "e");
if (crc32("gktGsCIJJCz",11) == 1459038234) strcat(s, "n");
if (crc32("OBEdjoJg",8) == 3145525540) strcat(s, "e");
if (crc32("hvluDXh",7) == 1433414221) strcat(s, "c");
if (crc32("IwxUXPgFtml",11) == 3403444102) strcat(s, "r");
if (crc32("uCssxUQIfrcf",12) == 1670826841) strcat(s, "a");
if (crc32("ugsZGfeTKPmlGT",14) == 529485072) strcat(s, "t");
if (crc32("DCfZVKVCSW",10) == 3789691906) strcat(s, "u");
if (crc32("eAAUBeqtfZwH",12) == 2354735212) strcat(s, "e");
if (crc32("alkSq",5) == 3784739495) strcat(s, "d");
    return s;
}

char *fantasize_verbs() {
    char *s = calloc(10);
    if (crc32("IOVBv",5) == 1135488706) strcat(s, "f");
if (crc32("JUXaJ",5) == 1556828031) strcat(s, "V");
if (crc32("llAtKupGq",9) == 383527742) strcat(s, "a");
if (crc32("JscPXjR",7) == 2531768239) strcat(s, "I");
if (crc32("SARYsqzVJlxqxU",14) == 1259614098) strcat(s, "n");
if (crc32("fEegyiluoM",10) == 3555994105) strcat(s, "c");
if (crc32("CwFGSQl",7) == 2793836801) strcat(s, "t");
if (crc32("GrVksmtc",8) == 1647775335) strcat(s, "a");
if (crc32("ArSIXp",6) == 1916828582) strcat(s, "a");
if (crc32("BVmDPijo",8) == 2476819773) strcat(s, "R");
if (crc32("tcAWEGpIRdpnrv",14) == 1951150747) strcat(s, "s");
if (crc32("FFdOiv",6) == 2108377973) strcat(s, "i");
if (crc32("XaApDaUZxz",10) == 4049273048) strcat(s, "z");
if (crc32("dOSLNB",6) == 2920592808) strcat(s, "e");
    return s;
}

char *refloat_verbs() {
    char *s = calloc(8);
    if (crc32("dalHI",5) == 914906367) strcat(s, "p");
if (crc32("LqbnUQrqyR",10) == 2134781848) strcat(s, "r");
if (crc32("JpNLLegzs",9) == 4089113734) strcat(s, "q");
if (crc32("trxTE",5) == 2311441826) strcat(s, "e");
if (crc32("RwtnXcpmS",9) == 4077005317) strcat(s, "Z");
if (crc32("RqPwE",5) == 1560729809) strcat(s, "f");
if (crc32("hNQxoiivFNGRbd",14) == 276226034) strcat(s, "l");
if (crc32("lhzdfeGQX",9) == 980707564) strcat(s, "h");
if (crc32("mUWrT",5) == 1135545821) strcat(s, "o");
if (crc32("YPSGJ",5) == 2145891488) strcat(s, "a");
if (crc32("RPjVBksfIHx",11) == 2699592063) strcat(s, "t");
    return s;
}

char *tugging_verbs() {
    char *s = calloc(8);
    if (crc32("cRnoqNuMexJRg",13) == 1091929152) strcat(s, "t");
if (crc32("vTQAHYCFpfEz",12) == 1803562052) strcat(s, "G");
if (crc32("PLVCH",5) == 3834730549) strcat(s, "u");
if (crc32("ffQyLwKHbYtdSvg",15) == 2339949177) strcat(s, "g");
if (crc32("uUKxjSpYRUIwhN",14) == 59922726) strcat(s, "g");
if (crc32("BYiamvc",7) == 2668679594) strcat(s, "i");
if (crc32("cXhfv",5) == 3658243965) strcat(s, "n");
if (crc32("xQooBYC",7) == 1866290012) strcat(s, "k");
if (crc32("CQqcNtGiJd",10) == 285669728) strcat(s, "g");
    return s;
}

char *redispersed_verbs() {
    char *s = calloc(12);
    if (crc32("rNCivCMXOxoLQ",13) == 4169134104) strcat(s, "r");
if (crc32("DCZGiKiZlnCfK",13) == 3280533497) strcat(s, "e");
if (crc32("vsVqBYTgoBfP",12) == 1679005441) strcat(s, "q");
if (crc32("uiScNhDnfpwdHjE",15) == 3502352094) strcat(s, "d");
if (crc32("zyjEAvVQfQQepZ",14) == 2033677634) strcat(s, "i");
if (crc32("FjmvKSJbK",9) == 14893462) strcat(s, "i");
if (crc32("kbrYTemz",8) == 1709890829) strcat(s, "z");
if (crc32("MqJLz",5) == 617823265) strcat(s, "s");
if (crc32("DDrLtxtfKR",10) == 88151284) strcat(s, "R");
if (crc32("uOhbMqFM",8) == 2793913150) strcat(s, "p");
if (crc32("jTfbChRy",8) == 1933957571) strcat(s, "Z");
if (crc32("JREXbBdZtRSrV",13) == 39245602) strcat(s, "e");
if (crc32("wYpzecq",7) == 1690073932) strcat(s, "U");
if (crc32("LmaDxsKgF",9) == 1437434212) strcat(s, "r");
if (crc32("PakdFcEO",8) == 3154357373) strcat(s, "h");
if (crc32("kUBypeZZ",8) == 3251972142) strcat(s, "s");
if (crc32("sjNCWEMQTfXp",12) == 673285577) strcat(s, "e");
if (crc32("GTrwvREh",8) == 1945312920) strcat(s, "d");
    return s;
}

char *bousing_verbs() {
    char *s = calloc(8);
    if (crc32("FReplKl",7) == 1871655955) strcat(s, "v");
if (crc32("oPaYMCfmEkiXTmu",15) == 3977054542) strcat(s, "b");
if (crc32("tqbQhACXLMTO",12) == 166008308) strcat(s, "x");
if (crc32("HvZJampWxUY",11) == 440425724) strcat(s, "o");
if (crc32("WrOXyvYHua",10) == 2271842559) strcat(s, "D");
if (crc32("jiZuIIfLasjc",12) == 3158327139) strcat(s, "u");
if (crc32("OeYseskNXGZDkk",14) == 4048112554) strcat(s, "s");
if (crc32("AlOqJfbwEkvU",12) == 4231691808) strcat(s, "d");
if (crc32("VCddSxVOSUF",11) == 1825486618) strcat(s, "i");
if (crc32("gtZXzPNDsehX",12) == 1555131479) strcat(s, "j");
if (crc32("PKmliIMyzzcD",12) == 390070045) strcat(s, "n");
if (crc32("sZNTMbxqFmj",11) == 3750655206) strcat(s, "W");
if (crc32("hfQzx",5) == 2539474875) strcat(s, "g");
    return s;
}

char *rescue_verbs() {
    char *s = calloc(7);
    if (crc32("cFakknk",7) == 3554317488) strcat(s, "r");
if (crc32("nPUTToeqrHUclu",14) == 3122199143) strcat(s, "N");
if (crc32("DCyFwInoDpe",11) == 3938618243) strcat(s, "e");
if (crc32("TCxmnKK",7) == 1931347508) strcat(s, "s");
if (crc32("WaJKElIGuPt",11) == 3198209198) strcat(s, "c");
if (crc32("ZmzJMV",6) == 3274028201) strcat(s, "u");
if (crc32("AYoRHzW",7) == 1889621610) strcat(s, "e");
    return s;
}

char *solubilize_verbs() {
    char *s = calloc(11);
    if (crc32("ZBifkUuoL",9) == 2419054643) strcat(s, "e");
if (crc32("MJhGHGm",7) == 1262528154) strcat(s, "s");
if (crc32("qGzQpsIlJIciLnL",15) == 502548961) strcat(s, "l");
if (crc32("YnICtbxnZyP",11) == 3380895654) strcat(s, "o");
if (crc32("ZzQLdKlK",8) == 3091717502) strcat(s, "O");
if (crc32("Avgcov",6) == 3023533223) strcat(s, "l");
if (crc32("RMYNXCGJotlWSg",14) == 3923754121) strcat(s, "u");
if (crc32("XiaKHUA",7) == 4067730322) strcat(s, "b");
if (crc32("KCjIoP",6) == 1775304225) strcat(s, "i");
if (crc32("HXJwxdVu",8) == 1200234714) strcat(s, "l");
if (crc32("OWOTVPTXLOOPnHy",15) == 159778106) strcat(s, "g");
if (crc32("ZRDoe",5) == 2108367101) strcat(s, "i");
if (crc32("rOoafRNxwf",10) == 3423760695) strcat(s, "o");
if (crc32("PNZUdJo",7) == 2648624533) strcat(s, "z");
if (crc32("KphbpdhYIWRY",12) == 1669024299) strcat(s, "e");
    return s;
}

char *graded_verbs() {
    char *s = calloc(7);
    if (crc32("XwhuWjblER",10) == 2538341437) strcat(s, "Y");
if (crc32("bkFuRoZSOfOTf",13) == 2339936801) strcat(s, "g");
if (crc32("sAuLM",5) == 1566819781) strcat(s, "r");
if (crc32("JkCArZMRc",9) == 2449857081) strcat(s, "a");
if (crc32("yoRHrtdORrRxY",13) == 2874691740) strcat(s, "d");
if (crc32("bJnGBnvdKdaOncy",15) == 521518866) strcat(s, "e");
if (crc32("qFPQPlnhmO",10) == 2085366880) strcat(s, "d");
    return s;
}

char *cheapen_verbs() {
    char *s = calloc(8);
    if (crc32("fkTaZdHU",8) == 26580506) strcat(s, "c");
if (crc32("nzNKLPmxQFYO",12) == 3491525617) strcat(s, "h");
if (crc32("PwgxXAbABY",10) == 808840367) strcat(s, "J");
if (crc32("ZGyxThEvICjD",12) == 698147957) strcat(s, "e");
if (crc32("MVzxEhj",7) == 1733548802) strcat(s, "l");
if (crc32("redQtKxl",8) == 4290710166) strcat(s, "a");
if (crc32("KTdTTWLNkXLFKf",14) == 2388119471) strcat(s, "E");
if (crc32("SLlepuonMfqRi",13) == 4021351146) strcat(s, "p");
if (crc32("GnZCJnvmz",9) == 1857511200) strcat(s, "e");
if (crc32("JQAWPJmBL",9) == 4133365552) strcat(s, "n");
    return s;
}

char *sunken_verbs() {
    char *s = calloc(7);
    if (crc32("WTapslsfffAfp",13) == 1952564853) strcat(s, "s");
if (crc32("ZWOtmN",6) == 3983585512) strcat(s, "T");
if (crc32("gumZaweksiV",11) == 2370958663) strcat(s, "u");
if (crc32("aektppye",8) == 2611935177) strcat(s, "R");
if (crc32("UOrUdKRIT",9) == 199691614) strcat(s, "n");
if (crc32("cCdaGpQ",7) == 3842815169) strcat(s, "i");
if (crc32("YnwjKYO",7) == 4150521525) strcat(s, "k");
if (crc32("ZbwmnCnbJgEg",12) == 4199002007) strcat(s, "A");
if (crc32("vwWYfoqwq",9) == 1773039930) strcat(s, "e");
if (crc32("HmuNml",6) == 1487925620) strcat(s, "W");
if (crc32("tGnaLEn",7) == 1812646755) strcat(s, "n");
    return s;
}

char *quartersaw_verbs() {
    char *s = calloc(11);
    if (crc32("gfHoFHqxxkoNAvK",15) == 82052627) strcat(s, "n");
if (crc32("LugUeowwUhZmp",13) == 2108924742) strcat(s, "q");
if (crc32("USWkrJTx",8) == 2843913901) strcat(s, "u");
if (crc32("wLmJHtqPlHyLInQ",15) == 2178610827) strcat(s, "a");
if (crc32("pAijlwJiS",9) == 3584486109) strcat(s, "r");
if (crc32("CFUPChn",7) == 1393527818) strcat(s, "R");
if (crc32("ARhQqikTSB",10) == 2456823560) strcat(s, "t");
if (crc32("giJJvhrXaY",10) == 3248931435) strcat(s, "e");
if (crc32("sBgvcVXZOV",10) == 1950824099) strcat(s, "S");
if (crc32("FwzBN",5) == 3979636295) strcat(s, "r");
if (crc32("abwMPvaxsEPeKe",14) == 2890066758) strcat(s, "s");
if (crc32("CCNbLKJyauhfzIb",15) == 3932458454) strcat(s, "a");
if (crc32("BrnqlzCrfNe",11) == 649903857) strcat(s, "Q");
if (crc32("boGhVqX",7) == 1459857403) strcat(s, "w");
    return s;
}

char *resubscribing_verbs() {
    char *s = calloc(14);
    if (crc32("XnGbJcmeLNn",11) == 1342149538) strcat(s, "S");
if (crc32("ClwUL",5) == 1100564288) strcat(s, "r");
if (crc32("NDyId",5) == 2684723015) strcat(s, "f");
if (crc32("hpLkYlxVS",9) == 1290297443) strcat(s, "e");
if (crc32("cGmOUufTcCZ",11) == 3777133201) strcat(s, "s");
if (crc32("xTxnrh",6) == 776717946) strcat(s, "R");
if (crc32("RSIHmIbGRgLWd",13) == 3122838832) strcat(s, "u");
if (crc32("goTvLAB",7) == 2703797389) strcat(s, "b");
if (crc32("UGQfjyg",7) == 2374571436) strcat(s, "s");
if (crc32("NeJllb",6) == 2635095825) strcat(s, "O");
if (crc32("KBNIrn",6) == 1173200463) strcat(s, "c");
if (crc32("kKjUnVrkCX",10) == 410103263) strcat(s, "r");
if (crc32("MVnIbyBUNejqtt",14) == 145072904) strcat(s, "i");
if (crc32("giHKQuxM",8) == 3739001365) strcat(s, "m");
if (crc32("KwoBtbZQf",9) == 3625122831) strcat(s, "b");
if (crc32("UOStxPcPmhQPJJ",14) == 2570556079) strcat(s, "i");
if (crc32("TKLzBAl",7) == 1754273628) strcat(s, "n");
if (crc32("ooWRceQoTHQfD",13) == 2917891206) strcat(s, "g");
    return s;
}

char *stalemated_verbs() {
    char *s = calloc(11);
    if (crc32("nmhzE",5) == 2957715194) strcat(s, "S");
if (crc32("kIxZzRXyl",9) == 1984940111) strcat(s, "s");
if (crc32("EnBnAbfoLPw",11) == 3919499713) strcat(s, "t");
if (crc32("nicUVu",6) == 319260940) strcat(s, "X");
if (crc32("RqYuAA",6) == 951067889) strcat(s, "a");
if (crc32("KKPkqjzVpjBW",12) == 3817227224) strcat(s, "l");
if (crc32("fWUSqy",6) == 3658274872) strcat(s, "y");
if (crc32("ZzAqzj",6) == 2711180889) strcat(s, "e");
if (crc32("iZqKjQqFRzlBece",15) == 944754621) strcat(s, "Y");
if (crc32("NHwLpD",6) == 1039518153) strcat(s, "m");
if (crc32("OLThkRVuWQVk",12) == 1832882672) strcat(s, "a");
if (crc32("TmSwxdZEK",9) == 4136516745) strcat(s, "t");
if (crc32("ouKAkXkftmt",11) == 3011737293) strcat(s, "c");
if (crc32("zdzHQfqvzEpwMML",15) == 659753121) strcat(s, "e");
if (crc32("piapFn",6) == 4118865332) strcat(s, "d");
    return s;
}

char *overmodernize_verbs() {
    char *s = calloc(14);
    if (crc32("VYRTbvcRcTZ",11) == 379175869) strcat(s, "D");
if (crc32("LPfZoBApS",9) == 1216392016) strcat(s, "o");
if (crc32("pvmgFaJbgS",10) == 2314370309) strcat(s, "v");
if (crc32("xGGwnhx",7) == 2480055259) strcat(s, "P");
if (crc32("zKMmfqedVtpwu",13) == 3043876010) strcat(s, "e");
if (crc32("AmyWWOfFibnzh",13) == 1400315467) strcat(s, "U");
if (crc32("KvFBjRIJPzqZW",13) == 1192383059) strcat(s, "r");
if (crc32("lsPjNTOBtncwLBw",15) == 2762368493) strcat(s, "m");
if (crc32("UzhUUjw",7) == 682458940) strcat(s, "o");
if (crc32("zYXXYlH",7) == 705516117) strcat(s, "d");
if (crc32("svZZohAtt",9) == 3879419793) strcat(s, "e");
if (crc32("sboUKudDkqXAbUL",15) == 3589023592) strcat(s, "H");
if (crc32("Hvwsf",5) == 294161240) strcat(s, "r");
if (crc32("kqppEXMetMdF",12) == 580058055) strcat(s, "f");
if (crc32("THtBqXnRIqxeDTl",15) == 687432640) strcat(s, "n");
if (crc32("iyeXNPaQ",8) == 4107391448) strcat(s, "i");
if (crc32("TLumy",5) == 3001632524) strcat(s, "w");
if (crc32("NVLHCTMrdEq",11) == 4279637181) strcat(s, "z");
if (crc32("JQyVkK",6) == 57932210) strcat(s, "e");
    return s;
}

char *dribbled_verbs() {
    char *s = calloc(9);
    if (crc32("fLKQCHkC",8) == 3847586480) strcat(s, "h");
if (crc32("zHQxCecWZ",9) == 1011993274) strcat(s, "d");
if (crc32("DKZsyJv",7) == 3602052618) strcat(s, "Q");
if (crc32("IhzhtJR",7) == 966988474) strcat(s, "r");
if (crc32("GeNXPIy",7) == 2525329455) strcat(s, "n");
if (crc32("sXWwUoJiPLxUBe",14) == 1538542107) strcat(s, "i");
if (crc32("gJhzCLkrfnO",11) == 2508359941) strcat(s, "d");
if (crc32("RZyOzj",6) == 2539774948) strcat(s, "b");
if (crc32("FIzccyCf",8) == 663571903) strcat(s, "i");
if (crc32("IxYKtX",6) == 3021870644) strcat(s, "b");
if (crc32("KqMEQkNtf",9) == 825139465) strcat(s, "v");
if (crc32("CwSbnssQAdG",11) == 3928272382) strcat(s, "l");
if (crc32("KwmoXJHhJkC",11) == 1454131001) strcat(s, "Z");
if (crc32("ZsQrV",5) == 1064600631) strcat(s, "e");
if (crc32("aoSVfBncunS",11) == 2669705962) strcat(s, "B");
if (crc32("VrwRMgk",7) == 971706348) strcat(s, "d");
    return s;
}

char *backlogging_verbs() {
    char *s = calloc(12);
    if (crc32("ExWvp",5) == 318079034) strcat(s, "K");
if (crc32("dGnSfUdUxcKDvc",14) == 3401606377) strcat(s, "b");
if (crc32("ijiVNBgHFLPuU",13) == 1325734662) strcat(s, "G");
if (crc32("LjHrRiKsA",9) == 3547451946) strcat(s, "a");
if (crc32("iqhpasGIUFvJ",12) == 867408919) strcat(s, "z");
if (crc32("eyjpaT",6) == 229838280) strcat(s, "c");
if (crc32("HhQFi",5) == 2936032897) strcat(s, "k");
if (crc32("GFoFWMMVQKoYpk",14) == 2109718728) strcat(s, "S");
if (crc32("MPIFhbUggviOH",13) == 3418422916) strcat(s, "l");
if (crc32("JBGrGogdIcRl",12) == 3396839334) strcat(s, "o");
if (crc32("vlOQmgVhZSGgHiM",15) == 1090891900) strcat(s, "g");
if (crc32("wgFuJCPAH",9) == 315593540) strcat(s, "p");
if (crc32("kyIArmgQWnXFbj",14) == 581185257) strcat(s, "g");
if (crc32("KwynptyF",8) == 2265335509) strcat(s, "n");
if (crc32("SjouzqgZPMxFG",13) == 159022778) strcat(s, "i");
if (crc32("bzAZaDGwtR",10) == 3323408887) strcat(s, "n");
if (crc32("JarwYA",6) == 1098471309) strcat(s, "g");
    return s;
}

char *sandbagging_verbs() {
    char *s = calloc(12);
    if (crc32("JODcYgzJgCCFIFp",15) == 222989853) strcat(s, "Q");
if (crc32("rmITPADDMptNK",13) == 3663953821) strcat(s, "s");
if (crc32("zZaSNniQa",9) == 2223470114) strcat(s, "S");
if (crc32("aIjQUbLSM",9) == 4067469403) strcat(s, "a");
if (crc32("nqxVnDJCxMTOQ",13) == 2928255953) strcat(s, "T");
if (crc32("ivCtwRCBDt",10) == 2680355886) strcat(s, "n");
if (crc32("FGDrRHrCfyKeyXE",15) == 2994692800) strcat(s, "d");
if (crc32("PdxFN",5) == 668001662) strcat(s, "b");
if (crc32("oGoeNsMzIlPXVUj",15) == 1845218809) strcat(s, "a");
if (crc32("GIlBigQNsuFv",12) == 1019551175) strcat(s, "g");
if (crc32("fZqEgcWh",8) == 3031725229) strcat(s, "q");
if (crc32("kvXxEuZVSQMrey",14) == 2964094565) strcat(s, "g");
if (crc32("rKeldIrWvDtgnnU",15) == 4275685493) strcat(s, "h");
if (crc32("CRqxeTRqHQZK",12) == 384520842) strcat(s, "i");
if (crc32("TOzXxzVBi",9) == 3271531749) strcat(s, "n");
if (crc32("OMNBxFq",7) == 2591040091) strcat(s, "w");
if (crc32("oytrtpMtumSk",12) == 2843031991) strcat(s, "g");
    return s;
}

char *grub_verbs() {
    char *s = calloc(5);
    if (crc32("eywqwjoBiXPb",12) == 2550392900) strcat(s, "V");
if (crc32("SFbimrguoirloLp",15) == 1895010758) strcat(s, "g");
if (crc32("NuffyvvD",8) == 1438459358) strcat(s, "c");
if (crc32("CmExmrLcMtYLe",13) == 4086964213) strcat(s, "r");
if (crc32("aNOTBTxVmOnlGz",14) == 544262050) strcat(s, "V");
if (crc32("DwBdqqsjElLom",13) == 3463639129) strcat(s, "u");
if (crc32("mTedKzIzvDseEK",14) == 634450939) strcat(s, "b");
    return s;
}

char *disrobe_verbs() {
    char *s = calloc(8);
    if (crc32("baNkGkPq",8) == 3731180037) strcat(s, "d");
if (crc32("CEWOFbcMdX",10) == 3768684949) strcat(s, "i");
if (crc32("KoxHeCDNdh",10) == 1149739442) strcat(s, "y");
if (crc32("BSTpaFvvpHaMKQR",15) == 1887461330) strcat(s, "s");
if (crc32("gedQo",5) == 3501926481) strcat(s, "r");
if (crc32("NOLQq",5) == 1012394202) strcat(s, "d");
if (crc32("aYOOT",5) == 3025462546) strcat(s, "o");
if (crc32("zvAaAUboOocINhq",15) == 1452250742) strcat(s, "X");
if (crc32("tCbMLbU",7) == 3007393715) strcat(s, "b");
if (crc32("MEtTwKQSSF",10) == 3375216349) strcat(s, "e");
    return s;
}

char *eased_verbs() {
    char *s = calloc(6);
    if (crc32("CtqOwmsXyor",11) == 1337505963) strcat(s, "K");
if (crc32("owmgmjcjFLhpA",13) == 1329175908) strcat(s, "e");
if (crc32("PfyZhnW",7) == 2818345363) strcat(s, "x");
if (crc32("hvVzGDLRXNXXpQF",15) == 587256636) strcat(s, "a");
if (crc32("ALnutzFb",8) == 3101045048) strcat(s, "s");
if (crc32("beCDvPL",7) == 1207219621) strcat(s, "e");
if (crc32("ohzNfxvId",9) == 2557889245) strcat(s, "d");
    return s;
}

char *bribed_verbs() {
    char *s = calloc(7);
    if (crc32("gpkfOqtDqxmudYH",15) == 1526263853) strcat(s, "b");
if (crc32("FnWPEGqJjpQJEzo",15) == 3733052576) strcat(s, "T");
if (crc32("Vxdum",5) == 4050630319) strcat(s, "r");
if (crc32("oZTAg",5) == 4144492448) strcat(s, "W");
if (crc32("yQKMoBjZRJEA",12) == 2748206977) strcat(s, "i");
if (crc32("ywSwwcSQhrJhc",13) == 3835810221) strcat(s, "b");
if (crc32("vRBpdezKcalnWN",14) == 1087086132) strcat(s, "e");
if (crc32("zzArN",5) == 724361648) strcat(s, "K");
if (crc32("thFTeAYLfu",10) == 572324584) strcat(s, "d");
    return s;
}

char *crochet_verbs() {
    char *s = calloc(8);
    if (crc32("hIRQkPEpRFAcqVe",15) == 745931550) strcat(s, "c");
if (crc32("gHnUUlVHITWnHNX",15) == 2001117570) strcat(s, "r");
if (crc32("einaVGpickpNkw",14) == 4145664656) strcat(s, "m");
if (crc32("NQFSfObKxpUhrcg",15) == 3721889594) strcat(s, "o");
if (crc32("TdbwuOoutU",10) == 161140738) strcat(s, "c");
if (crc32("RpuvGZxht",9) == 453480443) strcat(s, "s");
if (crc32("GzxkrmTl",8) == 471586639) strcat(s, "h");
if (crc32("UgLxHKHIGrebkXT",15) == 3956188119) strcat(s, "z");
if (crc32("wojodPaqBeM",11) == 1001067048) strcat(s, "e");
if (crc32("FPuAERFgwx",10) == 3568399569) strcat(s, "t");
    return s;
}

char *ulcerated_verbs() {
    char *s = calloc(10);
    if (crc32("BVzctLW",7) == 4108711061) strcat(s, "u");
if (crc32("swKZWxIQ",8) == 1413813765) strcat(s, "k");
if (crc32("QZpvpaxXDF",10) == 423030922) strcat(s, "l");
if (crc32("RezeSFP",7) == 1832349640) strcat(s, "c");
if (crc32("AhUbgABl",8) == 1839149877) strcat(s, "k");
if (crc32("QjeUzqCeImfZxo",14) == 2455537015) strcat(s, "e");
if (crc32("ffggdwlapo",10) == 817357226) strcat(s, "b");
if (crc32("NPGNxdLEI",9) == 2548687516) strcat(s, "r");
if (crc32("RMuooYXRtPQWT",13) == 3437570058) strcat(s, "a");
if (crc32("BwrFqkaWeSy",11) == 3966118974) strcat(s, "t");
if (crc32("LxKSkcrmSsBedx",14) == 371307529) strcat(s, "I");
if (crc32("gbjsSEgKeUrBcE",14) == 4213248530) strcat(s, "e");
if (crc32("NPaTfyxbZGpFZfA",15) == 4127808695) strcat(s, "M");
if (crc32("aMKqoWFbXVwj",12) == 715596651) strcat(s, "d");
    return s;
}

char *ignite_verbs() {
    char *s = calloc(7);
    if (crc32("zvscLnVhMT",10) == 3289786184) strcat(s, "l");
if (crc32("XljnoAEypqdm",12) == 91677931) strcat(s, "i");
if (crc32("izBBXgTQtc",10) == 1861213922) strcat(s, "g");
if (crc32("DPPyPO",6) == 3522001722) strcat(s, "n");
if (crc32("CbVzmWTsZgZLF",13) == 1395123406) strcat(s, "e");
if (crc32("pvCfukvXlqIcx",13) == 1433430695) strcat(s, "i");
if (crc32("pmovLtSkSMFMXiN",15) == 3039847986) strcat(s, "t");
if (crc32("qnAgTsrm",8) == 3112740860) strcat(s, "t");
if (crc32("AULhdGfpn",9) == 4130627392) strcat(s, "e");
    return s;
}

char *evade_verbs() {
    char *s = calloc(6);
    if (crc32("JvvYgbL",7) == 96638953) strcat(s, "e");
if (crc32("Opnqoo",6) == 129789987) strcat(s, "v");
if (crc32("toQzhcVOXy",10) == 112147491) strcat(s, "E");
if (crc32("KVNicZuDyxrsj",13) == 6454060) strcat(s, "a");
if (crc32("IJrRsVurH",9) == 723733547) strcat(s, "r");
if (crc32("RpoiKnbOnJeRsYv",15) == 4269845059) strcat(s, "d");
if (crc32("EVNQUUdcmamhAD",14) == 1405670147) strcat(s, "e");
    return s;
}

char *knelt_verbs() {
    char *s = calloc(6);
    if (crc32("FuDavRAdOB",10) == 1457606632) strcat(s, "k");
if (crc32("BRmMOlUp",8) == 3148529689) strcat(s, "n");
if (crc32("bfPeZPfZ",8) == 3699461978) strcat(s, "P");
if (crc32("VZXtLfHKz",9) == 4256490584) strcat(s, "e");
if (crc32("vLjWZrpc",8) == 802912828) strcat(s, "Z");
if (crc32("cBKMNzFM",8) == 2714594576) strcat(s, "l");
if (crc32("mlzyrYFh",8) == 2075171914) strcat(s, "t");
    return s;
}

char *reck_verbs() {
    char *s = calloc(5);
    if (crc32("HhkHQX",6) == 3319651193) strcat(s, "v");
if (crc32("eaOfj",5) == 4050391516) strcat(s, "r");
if (crc32("TFjvOsNaOFz",11) == 3600069471) strcat(s, "Q");
if (crc32("QZCXxVtWibU",11) == 1229531771) strcat(s, "e");
if (crc32("AWRGLfZJkYNWWg",14) == 3129030367) strcat(s, "c");
if (crc32("KXGGNyesKaTDl",13) == 171492078) strcat(s, "k");
    return s;
}

char *overhurry_verbs() {
    char *s = calloc(10);
    if (crc32("ADHGaNUhwmXl",12) == 627625384) strcat(s, "C");
if (crc32("DwkyKZQE",8) == 4293078444) strcat(s, "o");
if (crc32("UsNSTrcagp",10) == 3353449274) strcat(s, "Z");
if (crc32("vjkLJv",6) == 2574014387) strcat(s, "v");
if (crc32("rkbaX",5) == 2209832296) strcat(s, "u");
if (crc32("NNjVFMbOh",9) == 4165561410) strcat(s, "e");
if (crc32("vYRoO",5) == 1837855725) strcat(s, "r");
if (crc32("ZkLRTXiM",8) == 3082501753) strcat(s, "e");
if (crc32("AOScJLwjNXVLE",13) == 2550896808) strcat(s, "h");
if (crc32("lDCJi",5) == 63873925) strcat(s, "e");
if (crc32("oQsWYPDJheMt",12) == 3731455572) strcat(s, "u");
if (crc32("yAPDufcayNqXOq",14) == 1354637051) strcat(s, "H");
if (crc32("UmhlqAocDkg",11) == 3090022574) strcat(s, "r");
if (crc32("EJhlRw",6) == 2222729888) strcat(s, "g");
if (crc32("DzcsWSj",7) == 1972051128) strcat(s, "r");
if (crc32("qFTUYuATTz",10) == 1398976936) strcat(s, "Z");
if (crc32("HouXIbL",7) == 2068554700) strcat(s, "y");
    return s;
}

char *overdiscipline_verbs() {
    char *s = calloc(15);
    if (crc32("UaBpsQ",6) == 633348677) strcat(s, "g");
if (crc32("tdmNfg",6) == 519735351) strcat(s, "o");
if (crc32("CaGSFjPcw",9) == 2042950178) strcat(s, "v");
if (crc32("tiRGxi",6) == 1913294118) strcat(s, "e");
if (crc32("abbIKQkgtHyBi",13) == 3566693467) strcat(s, "r");
if (crc32("EXsiRTVUJYWhcf",14) == 1104713271) strcat(s, "y");
if (crc32("zIqNXYdKYt",10) == 626663740) strcat(s, "d");
if (crc32("WopVu",5) == 1767951230) strcat(s, "A");
if (crc32("qteNRRfNlwhEB",13) == 2165037284) strcat(s, "i");
if (crc32("XdnkcyztlYHVFwv",15) == 443231383) strcat(s, "y");
if (crc32("zXCGiPJvSdAxX",13) == 645598135) strcat(s, "s");
if (crc32("CxFYmVhtoei",11) == 552591010) strcat(s, "i");
if (crc32("fNZrpimnglbLk",13) == 1612220625) strcat(s, "c");
if (crc32("lJtmgjzm",8) == 4134449492) strcat(s, "i");
if (crc32("KXcJQs",6) == 428157186) strcat(s, "r");
if (crc32("anPvdgmTahfznIr",15) == 11812697) strcat(s, "p");
if (crc32("yldZZSloh",9) == 2759544019) strcat(s, "l");
if (crc32("WkyPQGW",7) == 27993040) strcat(s, "i");
if (crc32("BSfNmrVKRX",10) == 3048945726) strcat(s, "S");
if (crc32("zTxPQpJrafVD",12) == 3769001023) strcat(s, "n");
if (crc32("IgiNr",5) == 2730983595) strcat(s, "e");
    return s;
}

char *navigating_verbs() {
    char *s = calloc(11);
    if (crc32("kmCYZhoHNRGj",12) == 1046836138) strcat(s, "J");
if (crc32("unAkaXEooVCw",12) == 1008586730) strcat(s, "n");
if (crc32("OlBvsvjV",8) == 4055355742) strcat(s, "h");
if (crc32("pQQLM",5) == 1973290678) strcat(s, "a");
if (crc32("CYSAUOVIhRzW",12) == 903164728) strcat(s, "v");
if (crc32("xAAdncgUoTu",11) == 4232927422) strcat(s, "i");
if (crc32("PfnPhhzMdR",10) == 646069381) strcat(s, "g");
if (crc32("hiRObTuDpxpGmQ",14) == 3433362147) strcat(s, "a");
if (crc32("RrjrUvry",8) == 3151252701) strcat(s, "t");
if (crc32("IdvpE",5) == 1584428410) strcat(s, "i");
if (crc32("ovPxVwd",7) == 3923858020) strcat(s, "n");
if (crc32("DDtpk",5) == 2536174052) strcat(s, "n");
if (crc32("PcDIDOoAzAnVq",13) == 2387965159) strcat(s, "g");
    return s;
}

char *misreflect_verbs() {
    char *s = calloc(11);
    if (crc32("DfoIZ",5) == 3125203782) strcat(s, "f");
if (crc32("WVijbjef",8) == 4002013876) strcat(s, "m");
if (crc32("sDzlmGLyQcUO",12) == 1262077565) strcat(s, "i");
if (crc32("LSyNPRowfG",10) == 742482874) strcat(s, "s");
if (crc32("vrnNTycKtjDDTy",14) == 365399011) strcat(s, "q");
if (crc32("XKyEuI",6) == 1125291739) strcat(s, "r");
if (crc32("tIpPDzLsH",9) == 823569967) strcat(s, "e");
if (crc32("SqywAt",6) == 1023492685) strcat(s, "J");
if (crc32("BcPIFZ",6) == 3021729501) strcat(s, "f");
if (crc32("WuMYkJsBp",9) == 3030667899) strcat(s, "D");
if (crc32("zwalPBtwFrmtVx",14) == 4250936331) strcat(s, "l");
if (crc32("jKGZvEajbgtli",13) == 2795961173) strcat(s, "D");
if (crc32("yyHElQtbxSNbg",13) == 254620178) strcat(s, "e");
if (crc32("DvqoNhy",7) == 2837385806) strcat(s, "Q");
if (crc32("AZCQjplpMGMsh",13) == 468696595) strcat(s, "c");
if (crc32("GgtGcJ",6) == 3748886442) strcat(s, "l");
if (crc32("fluPXtzUnNpr",12) == 1881227161) strcat(s, "t");
    return s;
}

char *repremised_verbs() {
    char *s = calloc(11);
    if (crc32("YFnKDKhgTLLHEv",14) == 1714584233) strcat(s, "r");
if (crc32("BkXDVSuseRLqhO",14) == 3607751945) strcat(s, "e");
if (crc32("PeiaKZwiMqaFq",13) == 2255633604) strcat(s, "p");
if (crc32("JHBcQKrHGLkMd",13) == 4158955153) strcat(s, "v");
if (crc32("uTXln",5) == 2995918763) strcat(s, "r");
if (crc32("yjbUNYj",7) == 721092609) strcat(s, "Q");
if (crc32("PMTuTmITE",9) == 155389671) strcat(s, "e");
if (crc32("RvayTBFeZXvcIV",14) == 1389051096) strcat(s, "e");
if (crc32("tKzPamBdWawQb",13) == 2304595913) strcat(s, "m");
if (crc32("wCTsVWibkyM",11) == 585357587) strcat(s, "i");
if (crc32("tYXkC",5) == 1996893300) strcat(s, "s");
if (crc32("HLbYdLGiC",9) == 873275352) strcat(s, "N");
if (crc32("idEWHip",7) == 1281164940) strcat(s, "e");
if (crc32("EksmKKz",7) == 4247768458) strcat(s, "f");
if (crc32("eNybWVY",7) == 2214085025) strcat(s, "d");
    return s;
}

char *mistracing_verbs() {
    char *s = calloc(11);
    if (crc32("bkPAPG",6) == 1853172974) strcat(s, "N");
if (crc32("uopnTPtrwuwA",12) == 1117243777) strcat(s, "m");
if (crc32("OiUnPXE",7) == 867567620) strcat(s, "i");
if (crc32("sqPOGsa",7) == 814001330) strcat(s, "s");
if (crc32("XuwRN",5) == 3673624109) strcat(s, "t");
if (crc32("AUEtw",5) == 2885774898) strcat(s, "r");
if (crc32("GbveWF",6) == 710960871) strcat(s, "a");
if (crc32("mSsPvi",6) == 969687594) strcat(s, "Z");
if (crc32("fBCWujYPowgYXd",14) == 2448251243) strcat(s, "c");
if (crc32("QHJqf",5) == 1913251192) strcat(s, "i");
if (crc32("VQxEQ",5) == 3376432763) strcat(s, "n");
if (crc32("bBvxRtfajZp",11) == 3783022116) strcat(s, "g");
    return s;
}

char *inletting_verbs() {
    char *s = calloc(10);
    if (crc32("pplGKNoDRwk",11) == 1714888085) strcat(s, "G");
if (crc32("gMJCK",5) == 3273216104) strcat(s, "i");
if (crc32("cfsPyjWoXwxQf",13) == 667728776) strcat(s, "V");
if (crc32("BAmDFFnRyM",10) == 124095819) strcat(s, "n");
if (crc32("rzsMR",5) == 668174579) strcat(s, "v");
if (crc32("xjzkKIoHRCqatf",14) == 3236709683) strcat(s, "l");
if (crc32("QyTTMLbdeTsjv",13) == 2714654992) strcat(s, "e");
if (crc32("AvwyLgzYOkhNA",13) == 3752141828) strcat(s, "T");
if (crc32("oUXDiSTu",8) == 2261183230) strcat(s, "t");
if (crc32("xaOCWDWPqhtvm",13) == 519025258) strcat(s, "t");
if (crc32("kKcqUVTTLmyLKbS",15) == 3252170810) strcat(s, "i");
if (crc32("sDOCqvFu",8) == 47173275) strcat(s, "m");
if (crc32("raHGjg",6) == 885772245) strcat(s, "n");
if (crc32("VVRMx",5) == 3945181072) strcat(s, "g");
    return s;
}

char *girdled_verbs() {
    char *s = calloc(8);
    if (crc32("WZvpdrQUbYNYKn",14) == 2866521712) strcat(s, "g");
if (crc32("aqOJRMLqETmelm",14) == 2551679204) strcat(s, "i");
if (crc32("FiecktDjoahc",12) == 1497479182) strcat(s, "Q");
if (crc32("wCpCd",5) == 3238784454) strcat(s, "r");
if (crc32("TIsZSbWlUAJaBL",14) == 313013360) strcat(s, "t");
if (crc32("UXrTTh",6) == 3537839020) strcat(s, "d");
if (crc32("DczHaIDyQva",11) == 3041975292) strcat(s, "E");
if (crc32("KsqkfYjwWpVH",12) == 1321232700) strcat(s, "l");
if (crc32("GpSGR",5) == 325691947) strcat(s, "e");
if (crc32("vArvPAYr",8) == 2990448206) strcat(s, "d");
    return s;
}

char *restraighten_verbs() {
    char *s = calloc(13);
    if (crc32("PVFKcsMr",8) == 47964087) strcat(s, "r");
if (crc32("eCzWqpp",7) == 43974950) strcat(s, "e");
if (crc32("AdIgJqWyg",9) == 1310989715) strcat(s, "Z");
if (crc32("SCionrmJXO",10) == 1967168627) strcat(s, "s");
if (crc32("XDloPEo",7) == 447194356) strcat(s, "t");
if (crc32("nfKpG",5) == 1160075530) strcat(s, "r");
if (crc32("JCpfDx",6) == 3992768049) strcat(s, "a");
if (crc32("NTpEcsXP",8) == 3523181250) strcat(s, "N");
if (crc32("dSUUoomFr",9) == 830589022) strcat(s, "i");
if (crc32("gTjQSgrMnkYZ",12) == 2562753333) strcat(s, "x");
if (crc32("CbzEoMGftibed",13) == 2457692785) strcat(s, "g");
if (crc32("IIJFbOw",7) == 1160974281) strcat(s, "J");
if (crc32("UFLot",5) == 1143146158) strcat(s, "h");
if (crc32("dTiKaXgc",8) == 1048006390) strcat(s, "o");
if (crc32("gKWNQXMVU",9) == 4256438865) strcat(s, "t");
if (crc32("cziDLPGQL",9) == 3414238682) strcat(s, "e");
if (crc32("McIWH",5) == 2262512160) strcat(s, "D");
if (crc32("sfxBJlXBvGoBn",13) == 3561378815) strcat(s, "n");
    return s;
}

char *jemmied_verbs() {
    char *s = calloc(8);
    if (crc32("MohAhI",6) == 1052914198) strcat(s, "l");
if (crc32("NfEIogjtmUDe",12) == 4166381918) strcat(s, "j");
if (crc32("qTliLACLju",10) == 511710319) strcat(s, "e");
if (crc32("XYGZAMkDZp",10) == 1583490868) strcat(s, "J");
if (crc32("UqZRyAxwO",9) == 1933617570) strcat(s, "m");
if (crc32("fqDvs",5) == 1510166418) strcat(s, "X");
if (crc32("FwDrc",5) == 1498991707) strcat(s, "m");
if (crc32("UmplKUpqHId",11) == 342043631) strcat(s, "i");
if (crc32("lHHACQYRFKZ",11) == 910921816) strcat(s, "e");
if (crc32("zUUBuCmysZFq",12) == 1533270790) strcat(s, "d");
    return s;
}

char *foreseeing_verbs() {
    char *s = calloc(11);
    if (crc32("vnGotd",6) == 243233657) strcat(s, "f");
if (crc32("xchahQsjAJIIF",13) == 1483353444) strcat(s, "q");
if (crc32("DejHrLgCOBsF",12) == 2248412914) strcat(s, "o");
if (crc32("RBViJwfvvOriVaa",15) == 2991811386) strcat(s, "r");
if (crc32("OHuwUMadIe",10) == 134837160) strcat(s, "e");
if (crc32("xxTSyqYhYwQ",11) == 1725769542) strcat(s, "d");
if (crc32("khHkwQS",7) == 1956789074) strcat(s, "s");
if (crc32("YnfTeDsm",8) == 3848818987) strcat(s, "x");
if (crc32("jITfrUeJL",9) == 1417676913) strcat(s, "e");
if (crc32("VigFauyVw",9) == 1055280921) strcat(s, "e");
if (crc32("FjnQzmGWhDAvYd",14) == 3069489213) strcat(s, "i");
if (crc32("xTAatwo",7) == 808969401) strcat(s, "Y");
if (crc32("ZPVzKe",6) == 3180460824) strcat(s, "n");
if (crc32("AICdbsQCqXWUwv",14) == 1293842766) strcat(s, "g");
    return s;
}

char *bellyached_verbs() {
    char *s = calloc(11);
    if (crc32("VTWQYTWdQgLmg",13) == 1027131036) strcat(s, "b");
if (crc32("THhHjj",6) == 4231065653) strcat(s, "e");
if (crc32("hTUAeL",6) == 1922944929) strcat(s, "l");
if (crc32("aHOovrzADpjhCIG",15) == 3623189164) strcat(s, "l");
if (crc32("XUrWIoMkNwcGMC",14) == 64047500) strcat(s, "q");
if (crc32("kDsPT",5) == 3166462107) strcat(s, "y");
if (crc32("uFtDHnmmiqkSowb",15) == 2196231351) strcat(s, "F");
if (crc32("RiMKvoUdMlJ",11) == 673393311) strcat(s, "a");
if (crc32("xNEFbXrWqvERw",13) == 4294687977) strcat(s, "d");
if (crc32("KcYnRfTQLGkK",12) == 2360059222) strcat(s, "c");
if (crc32("dvYmVc",6) == 2590321643) strcat(s, "h");
if (crc32("CEIvVcCJEFC",11) == 1723853132) strcat(s, "o");
if (crc32("CHoFgN",6) == 4228336953) strcat(s, "e");
if (crc32("xmyznwvXlSRxTR",14) == 649044170) strcat(s, "k");
if (crc32("QwaicsKahEUdqJn",15) == 3415724962) strcat(s, "d");
    return s;
}

char *reoxidized_verbs() {
    char *s = calloc(11);
    if (crc32("eKSqy",5) == 2866987482) strcat(s, "r");
if (crc32("cozqWL",6) == 4292982908) strcat(s, "e");
if (crc32("ltaZYdQixIStXJt",15) == 82829724) strcat(s, "o");
if (crc32("SPSCSQZ",7) == 858333821) strcat(s, "x");
if (crc32("HbWPKsnr",8) == 3606859325) strcat(s, "p");
if (crc32("OAvzYHIIX",9) == 2012714768) strcat(s, "i");
if (crc32("NJeEi",5) == 902944133) strcat(s, "e");
if (crc32("hbePdYpo",8) == 1060378845) strcat(s, "d");
if (crc32("hCOJqeHWzh",10) == 3861250030) strcat(s, "i");
if (crc32("PQjzakc",7) == 1036437049) strcat(s, "Z");
if (crc32("CnODZCJaBAhuF",13) == 4121194963) strcat(s, "z");
if (crc32("XolkDqFIra",10) == 1922381637) strcat(s, "e");
if (crc32("BaWyH",5) == 439060919) strcat(s, "F");
if (crc32("HwVhbvdPJjE",11) == 2476410702) strcat(s, "d");
    return s;
}

char *resshot_verbs() {
    char *s = calloc(8);
    if (crc32("uFqGeHA",7) == 1328274872) strcat(s, "r");
if (crc32("KErncpapF",9) == 962282149) strcat(s, "n");
if (crc32("BgbNctuQHJNys",13) == 3809284344) strcat(s, "e");
if (crc32("AbEfsgl",7) == 2357032478) strcat(s, "s");
if (crc32("tOTOHoqJKHkJM",13) == 801098990) strcat(s, "s");
if (crc32("YZoUIQJPda",10) == 3083120192) strcat(s, "h");
if (crc32("CMQgVEFiiRleOk",14) == 3865433512) strcat(s, "o");
if (crc32("dXHQHXGNKT",10) == 1710414639) strcat(s, "t");
    return s;
}

char *emplacing_verbs() {
    char *s = calloc(10);
    if (crc32("EVJjim",6) == 1845885293) strcat(s, "j");
if (crc32("IXKQBlyHtVRRwt",14) == 1865777831) strcat(s, "e");
if (crc32("uCQgBpszyQgPdv",14) == 2511480806) strcat(s, "o");
if (crc32("znnooEE",7) == 1795068426) strcat(s, "m");
if (crc32("bfBIDWWfvIhGWE",14) == 1480030543) strcat(s, "d");
if (crc32("wGgMVH",6) == 123992794) strcat(s, "p");
if (crc32("pqiioNDsJx",10) == 4156559456) strcat(s, "m");
if (crc32("LdVZHrt",7) == 2863213243) strcat(s, "l");
if (crc32("KFBBccQZZTwRMWD",15) == 673997734) strcat(s, "M");
if (crc32("eqhmLg",6) == 483296600) strcat(s, "a");
if (crc32("IWmXUBkWXCWyTb",14) == 1972914274) strcat(s, "c");
if (crc32("KckIXOyNNGIuM",13) == 2310675913) strcat(s, "p");
if (crc32("DKHede",6) == 652067564) strcat(s, "i");
if (crc32("USpOvTg",7) == 21214170) strcat(s, "n");
if (crc32("fITlttdTRG",10) == 3048849006) strcat(s, "c");
if (crc32("YTXWC",5) == 3486410467) strcat(s, "g");
    return s;
}

char *stumpup_verbs() {
    char *s = calloc(8);
    if (crc32("QKiIIPiMOOCP",12) == 2479798221) strcat(s, "I");
if (crc32("YkdwrSCUZyVvJT",14) == 2739981369) strcat(s, "s");
if (crc32("POQrXjzhfpKDD",13) == 3878306473) strcat(s, "N");
if (crc32("PdinikAW",8) == 1489368508) strcat(s, "t");
if (crc32("iElhMFym",8) == 1218990453) strcat(s, "Z");
if (crc32("FLmHyinPaqSbQy",14) == 2518791424) strcat(s, "u");
if (crc32("NoWkxc",6) == 3336061805) strcat(s, "V");
if (crc32("gEmxQeo",7) == 3946359529) strcat(s, "m");
if (crc32("TFDpUKxqddA",11) == 1341173617) strcat(s, "N");
if (crc32("KkcreswWckYIt",13) == 471771307) strcat(s, "p");
if (crc32("PVXpunbGHIORRO",14) == 1780649979) strcat(s, "N");
if (crc32("TnFhpGaVbHqg",12) == 1631989046) strcat(s, "u");
if (crc32("bfUTD",5) == 546795545) strcat(s, "b");
if (crc32("BWfFonzCeIK",11) == 2240448435) strcat(s, "p");
    return s;
}

char *bearoff_verbs() {
    char *s = calloc(8);
    if (crc32("voUdX",5) == 3718487577) strcat(s, "b");
if (crc32("XyCNLPieRdEIQLX",15) == 54559368) strcat(s, "e");
if (crc32("zGXypKFcXoB",11) == 3738511949) strcat(s, "V");
if (crc32("WsupyDekxPpbOhG",15) == 3677435141) strcat(s, "a");
if (crc32("tXtJzoSob",9) == 2221231096) strcat(s, "r");
if (crc32("xdPKUBcmzBV",11) == 4077604967) strcat(s, "n");
if (crc32("UtNdsSvJAm",10) == 1227575561) strcat(s, "o");
if (crc32("BPrwehBnjUStzK",14) == 3450786271) strcat(s, "H");
if (crc32("laFqlJOCMAhBz",13) == 2175362320) strcat(s, "f");
if (crc32("sMGkrKpA",8) == 226698221) strcat(s, "f");
    return s;
}

char *toll_verbs() {
    char *s = calloc(5);
    if (crc32("BkRKcuOOc",9) == 2905494939) strcat(s, "D");
if (crc32("HMSNRXpjHPXIsf",14) == 1811272816) strcat(s, "t");
if (crc32("fCHuB",5) == 323324978) strcat(s, "y");
if (crc32("jCJQLLxYZNjuhbo",15) == 1197924387) strcat(s, "o");
if (crc32("HyGDaJZC",8) == 143813136) strcat(s, "l");
if (crc32("vSaOv",5) == 4003095786) strcat(s, "l");
    return s;
}

char *overburden_verbs() {
    char *s = calloc(11);
    if (crc32("KMwNNOkEyrLtFk",14) == 2928516361) strcat(s, "f");
if (crc32("pXfeOjUMlVF",11) == 942061206) strcat(s, "o");
if (crc32("rvZmGVPQKOgGMH",14) == 1908762854) strcat(s, "v");
if (crc32("nBBaXxinEwTntZ",14) == 1450824433) strcat(s, "I");
if (crc32("dNXvhb",6) == 2503596211) strcat(s, "e");
if (crc32("URHto",5) == 449161780) strcat(s, "a");
if (crc32("jkSvvcupSByr",12) == 2211663345) strcat(s, "r");
if (crc32("NXwOOlRT",8) == 3820653203) strcat(s, "b");
if (crc32("NHwGjJafNJ",10) == 2912267297) strcat(s, "u");
if (crc32("uotZdckloFQBnuL",15) == 3893743030) strcat(s, "r");
if (crc32("XSzSMT",6) == 724841659) strcat(s, "J");
if (crc32("QFzLmzIZ",8) == 3605035363) strcat(s, "d");
if (crc32("PTiKOxi",7) == 1507808983) strcat(s, "e");
if (crc32("uZKFwRi",7) == 4136414204) strcat(s, "U");
if (crc32("vSYDpPxga",9) == 3836331233) strcat(s, "n");
    return s;
}

char *reclined_verbs() {
    char *s = calloc(9);
    if (crc32("owtnrczCoitRC",13) == 3869535045) strcat(s, "A");
if (crc32("wlVLRmVcVlnGe",13) == 771967122) strcat(s, "r");
if (crc32("YnbBMmONOjj",11) == 3340378881) strcat(s, "e");
if (crc32("spdCjItG",8) == 1155289152) strcat(s, "J");
if (crc32("tGncLFlQ",8) == 1342782333) strcat(s, "c");
if (crc32("xKHHH",5) == 2109428728) strcat(s, "l");
if (crc32("iOtoqBZ",7) == 2578238333) strcat(s, "B");
if (crc32("QWxHlFQFcmI",11) == 2208637297) strcat(s, "i");
if (crc32("dzhiQgTnY",9) == 2749756932) strcat(s, "k");
if (crc32("zcXuBHuwwslk",12) == 3546256273) strcat(s, "n");
if (crc32("IaqIawLIuC",10) == 3759823916) strcat(s, "e");
if (crc32("OhysGavB",8) == 301528291) strcat(s, "d");
    return s;
}

char *oversensitized_verbs() {
    char *s = calloc(15);
    if (crc32("LEyOX",5) == 370773228) strcat(s, "S");
if (crc32("ESzUNNNpvu",10) == 941228992) strcat(s, "o");
if (crc32("TrSCIL",6) == 1350185679) strcat(s, "v");
if (crc32("rQZsVugpnzE",11) == 2488558404) strcat(s, "e");
if (crc32("vIzkSJymUNyv",12) == 2515253042) strcat(s, "r");
if (crc32("GIdmPTdUWe",10) == 904642128) strcat(s, "p");
if (crc32("BnvcGqXXPD",10) == 1291212929) strcat(s, "s");
if (crc32("oWjmDTffOk",10) == 4280370522) strcat(s, "U");
if (crc32("vVYngYXXiPcUvi",14) == 2872914399) strcat(s, "e");
if (crc32("JHGNFLDlfEybqzk",15) == 2484498249) strcat(s, "Y");
if (crc32("moEPI",5) == 120539391) strcat(s, "n");
if (crc32("xbeWnSlK",8) == 1240541656) strcat(s, "s");
if (crc32("KHococ",6) == 293010562) strcat(s, "E");
if (crc32("CXvgCiwGwhkLaNU",15) == 1169715334) strcat(s, "i");
if (crc32("yAWlJR",6) == 1620581979) strcat(s, "t");
if (crc32("TOuKL",5) == 1017116628) strcat(s, "Y");
if (crc32("CwSwjztwE",9) == 1101645824) strcat(s, "i");
if (crc32("LjFBcIOGbgYjfhu",15) == 2889873890) strcat(s, "z");
if (crc32("ZrXptKCU",8) == 2616948583) strcat(s, "z");
if (crc32("BMWYeCWifNM",11) == 1891024940) strcat(s, "B");
if (crc32("njcteBvQtYPjkn",14) == 2628731700) strcat(s, "e");
if (crc32("RaVHvSIFquc",11) == 3015591492) strcat(s, "d");
    return s;
}

char *etiolated_verbs() {
    char *s = calloc(10);
    if (crc32("exNRdpHFdl",10) == 318193981) strcat(s, "e");
if (crc32("ambRpGqtLGsLm",13) == 1952109427) strcat(s, "t");
if (crc32("JdXYyxOWjAqqN",13) == 1348520414) strcat(s, "u");
if (crc32("SHRLXNQbbNHgip",14) == 226913949) strcat(s, "i");
if (crc32("RxGqKnenTqPoN",13) == 2778926488) strcat(s, "p");
if (crc32("dUQjykC",7) == 3720490569) strcat(s, "o");
if (crc32("FsQglXeAq",9) == 722120341) strcat(s, "l");
if (crc32("MlLQoz",6) == 2966384149) strcat(s, "a");
if (crc32("UdRrMwcbu",9) == 326309808) strcat(s, "t");
if (crc32("AgZRsTJJjpFCF",13) == 3404636046) strcat(s, "e");
if (crc32("eGMqgerLFnbplc",14) == 3882091923) strcat(s, "d");
    return s;
}

char *gerrymander_verbs() {
    char *s = calloc(12);
    if (crc32("oHoRUwIWX",9) == 1242131191) strcat(s, "g");
if (crc32("YjTSeE",6) == 2104014225) strcat(s, "e");
if (crc32("ePFetekH",8) == 457427919) strcat(s, "I");
if (crc32("wZfulEJVwj",10) == 101973755) strcat(s, "r");
if (crc32("vcCffIHNcCbSBJ",14) == 3323262193) strcat(s, "p");
if (crc32("fbJwytRUXDAmoI",14) == 3302447592) strcat(s, "r");
if (crc32("ROgWWAPyOhb",11) == 4006848838) strcat(s, "X");
if (crc32("doBAHjAoccE",11) == 1688181717) strcat(s, "y");
if (crc32("JMLlZcOqGxup",12) == 1621165900) strcat(s, "F");
if (crc32("JgSCcuegG",9) == 3791766230) strcat(s, "m");
if (crc32("BVfscyh",7) == 3558927619) strcat(s, "T");
if (crc32("yVBmbPRWAhDnjXk",15) == 1021350318) strcat(s, "a");
if (crc32("riEDtMqEPYCCLLL",15) == 2950634542) strcat(s, "n");
if (crc32("FAbprwbdKbRGpR",14) == 2168443523) strcat(s, "d");
if (crc32("nCQqNezKXT",10) == 444709113) strcat(s, "e");
if (crc32("FqDMCKbv",8) == 1668408660) strcat(s, "B");
if (crc32("TcXRjaNCFit",11) == 1391853050) strcat(s, "r");
    return s;
}

char *rosing_verbs() {
    char *s = calloc(7);
    if (crc32("abfyZWuaXFBTSv",14) == 3632583871) strcat(s, "r");
if (crc32("KKLTLhBwbBcSGzM",15) == 1022515734) strcat(s, "c");
if (crc32("TpfqEVCg",8) == 2386609526) strcat(s, "o");
if (crc32("KhJyZ",5) == 401538675) strcat(s, "b");
if (crc32("yPaemnRYsODyGVp",15) == 4030333088) strcat(s, "s");
if (crc32("LFEGNuZBXKPAJ",13) == 3110546412) strcat(s, "N");
if (crc32("wMKxn",5) == 3582826146) strcat(s, "i");
if (crc32("IaarCa",6) == 4126424627) strcat(s, "d");
if (crc32("wHTcGAEugo",10) == 2280142076) strcat(s, "n");
if (crc32("tFotM",5) == 1375239112) strcat(s, "t");
if (crc32("VZTEno",6) == 234582045) strcat(s, "g");
    return s;
}

char *hurdled_verbs() {
    char *s = calloc(8);
    if (crc32("gVMuyoT",7) == 543898611) strcat(s, "h");
if (crc32("VQmYuLH",7) == 3049902029) strcat(s, "p");
if (crc32("zVsPsrNnoySQaD",14) == 4221714607) strcat(s, "u");
if (crc32("hrhKaCBCpK",10) == 3957776779) strcat(s, "r");
if (crc32("sfjsmLrHq",9) == 1667515046) strcat(s, "d");
if (crc32("wkFNAMfeAvq",11) == 210371648) strcat(s, "V");
if (crc32("YEDKvIWByoiUnj",14) == 1985381794) strcat(s, "l");
if (crc32("JgvOYYcXAzc",11) == 3296472435) strcat(s, "k");
if (crc32("IofLL",5) == 2675478608) strcat(s, "e");
if (crc32("LQFhmqNdXk",10) == 3108103424) strcat(s, "d");
    return s;
}

char *confine_verbs() {
    char *s = calloc(8);
    if (crc32("KiuJv",5) == 2235371619) strcat(s, "b");
if (crc32("uBsgIBxgbi",10) == 3851566257) strcat(s, "c");
if (crc32("MitItInP",8) == 3595237129) strcat(s, "A");
if (crc32("MfjipbDRRhL",11) == 1948151945) strcat(s, "o");
if (crc32("XeyhFchYbywv",12) == 3445777350) strcat(s, "N");
if (crc32("RQLFqZoszTClHwA",15) == 766961842) strcat(s, "n");
if (crc32("XLTBKMKICTIJoFz",15) == 4049739747) strcat(s, "M");
if (crc32("tnNFISBrxBfg",12) == 2873710439) strcat(s, "f");
if (crc32("awlpGCQBKIKlZMF",15) == 3437078542) strcat(s, "z");
if (crc32("npnHaDpfOcPhVC",14) == 3605891002) strcat(s, "i");
if (crc32("VBzhVyhuVP",10) == 1981975666) strcat(s, "t");
if (crc32("RyJnom",6) == 1673575967) strcat(s, "n");
if (crc32("BUcYszhv",8) == 883111020) strcat(s, "D");
if (crc32("rqlJrIlTkLIkLPp",15) == 880774903) strcat(s, "e");
    return s;
}

char *slew_verbs() {
    char *s = calloc(5);
    if (crc32("vgycoiBURYvxcch",15) == 2068767593) strcat(s, "s");
if (crc32("QRFJjufHDj",10) == 664418510) strcat(s, "l");
if (crc32("LsGRgMRqS",9) == 3518194529) strcat(s, "m");
if (crc32("drdqqvMOPPgCud",14) == 3897884614) strcat(s, "e");
if (crc32("ZMETk",5) == 2937704252) strcat(s, "w");
    return s;
}

char *stencilled_verbs() {
    char *s = calloc(11);
    if (crc32("bOPGGpISzjig",12) == 1969068092) strcat(s, "g");
if (crc32("yAdAzipVWfES",12) == 1043759144) strcat(s, "s");
if (crc32("XbELczJEKWm",11) == 2189945925) strcat(s, "t");
if (crc32("IhMkYOtVYEEdrMX",15) == 494168106) strcat(s, "S");
if (crc32("nqrWEkjg",8) == 2181689974) strcat(s, "e");
if (crc32("mvDfrXhMmLjidSL",15) == 3061341431) strcat(s, "S");
if (crc32("tlqmEhKiLnSheqn",15) == 944679771) strcat(s, "n");
if (crc32("OodHtcL",7) == 764747521) strcat(s, "I");
if (crc32("vVNpGWsvxegAi",13) == 74566431) strcat(s, "c");
if (crc32("dIuMnRfRLf",10) == 1906218633) strcat(s, "i");
if (crc32("vABtrMfZtAQKc",13) == 885474191) strcat(s, "G");
if (crc32("fXODfQ",6) == 4230154714) strcat(s, "l");
if (crc32("PkYbq",5) == 1807347306) strcat(s, "i");
if (crc32("UWpApIPc",8) == 2320757423) strcat(s, "l");
if (crc32("BANvjgS",7) == 3203778647) strcat(s, "e");
if (crc32("teQoDU",6) == 4263538198) strcat(s, "Q");
if (crc32("vTAFSmKGsF",10) == 3160034479) strcat(s, "d");
    return s;
}

char *summing_verbs() {
    char *s = calloc(8);
    if (crc32("sjADuBorr",9) == 3135482606) strcat(s, "K");
if (crc32("laXfwg",6) == 2616048490) strcat(s, "s");
if (crc32("IsQAYtqHA",9) == 3954425812) strcat(s, "e");
if (crc32("OUHYUf",6) == 3790557488) strcat(s, "u");
if (crc32("nMgeEIaJ",8) == 4174533294) strcat(s, "m");
if (crc32("Cdnpo",5) == 3712898757) strcat(s, "m");
if (crc32("STBCvhbAVaqZgNG",15) == 3044298531) strcat(s, "l");
if (crc32("KbuBdehsPtqQlBG",15) == 2819891313) strcat(s, "i");
if (crc32("mscDCgOA",8) == 1119474419) strcat(s, "L");
if (crc32("qENzD",5) == 1883185746) strcat(s, "n");
if (crc32("MlieStzj",8) == 393408913) strcat(s, "g");
    return s;
}

char *wited_verbs() {
    char *s = calloc(6);
    if (crc32("siKCfMNQHOY",11) == 242055696) strcat(s, "w");
if (crc32("xsWhFXuCcraVC",13) == 2655853566) strcat(s, "y");
if (crc32("HVXwZNh",7) == 2188129058) strcat(s, "i");
if (crc32("AbiGGV",6) == 757531711) strcat(s, "r");
if (crc32("trtXe",5) == 386161410) strcat(s, "t");
if (crc32("iTtmlLfjyeqa",12) == 892073151) strcat(s, "G");
if (crc32("EoGXdokklgk",11) == 3855305170) strcat(s, "e");
if (crc32("lvRSnhsNQz",10) == 3848134670) strcat(s, "R");
if (crc32("ltUtBIeslLqc",12) == 1552657604) strcat(s, "d");
    return s;
}

char *clip_verbs() {
    char *s = calloc(5);
    if (crc32("VLYotDNYRW",10) == 3057405126) strcat(s, "v");
if (crc32("qZrVoJt",7) == 157766166) strcat(s, "c");
if (crc32("TsKnn",5) == 814563041) strcat(s, "f");
if (crc32("NeCjhJXeXdT",11) == 1668948853) strcat(s, "l");
if (crc32("UjvklpgCsHSp",12) == 557637976) strcat(s, "N");
if (crc32("wMVfGQkKEmfUZ",13) == 3169568952) strcat(s, "i");
if (crc32("purxMt",6) == 4158659461) strcat(s, "j");
if (crc32("eplFbnXtU",9) == 3276557481) strcat(s, "p");
    return s;
}

char *overgesticulate_verbs() {
    char *s = calloc(16);
    if (crc32("kRugfzWIzhjYhus",15) == 457049010) strcat(s, "o");
if (crc32("NWcxCDgCkqS",11) == 1836531288) strcat(s, "v");
if (crc32("OevPyyk",7) == 1523099687) strcat(s, "J");
if (crc32("AlMvAcyKN",9) == 3318402281) strcat(s, "e");
if (crc32("hQOhucwJMLLNob",14) == 1346757833) strcat(s, "d");
if (crc32("EVcnAEcuIy",10) == 945868284) strcat(s, "r");
if (crc32("SUSYvgJbL",9) == 207874295) strcat(s, "g");
if (crc32("xhbknPdiDdYfZtS",15) == 2560340769) strcat(s, "R");
if (crc32("zlljHZhdyEiX",12) == 2849103567) strcat(s, "e");
if (crc32("EcJLiR",6) == 2360744746) strcat(s, "s");
if (crc32("ESvIS",5) == 204234888) strcat(s, "t");
if (crc32("kuOZqN",6) == 143752003) strcat(s, "M");
if (crc32("TdIraFAu",8) == 1584543819) strcat(s, "i");
if (crc32("IraBaUYYY",9) == 3288245386) strcat(s, "R");
if (crc32("AbLGbrZNaCXwLfV",15) == 426414154) strcat(s, "c");
if (crc32("vhUzvBnyBjmaQt",14) == 100768402) strcat(s, "E");
if (crc32("xNOaHtiJKsy",11) == 1688666522) strcat(s, "u");
if (crc32("KEXqpbS",7) == 699958877) strcat(s, "i");
if (crc32("mCYWnFNhneSIu",13) == 2541345398) strcat(s, "l");
if (crc32("QtipQXYdhBgalc",14) == 3497831830) strcat(s, "t");
if (crc32("TOXFZSxRsmv",11) == 1890769934) strcat(s, "a");
if (crc32("taGUcUvXVj",10) == 376117764) strcat(s, "t");
if (crc32("cAjvyk",6) == 2747511029) strcat(s, "u");
if (crc32("HDialOIYsZdtZLD",15) == 154013890) strcat(s, "e");
    return s;
}

char *chimneyed_verbs() {
    char *s = calloc(10);
    if (crc32("HchweFbjhb",10) == 4137386195) strcat(s, "y");
if (crc32("QlGunTAp",8) == 2600228591) strcat(s, "c");
if (crc32("XUHQfCyOg",9) == 118749024) strcat(s, "m");
if (crc32("cBWnxS",6) == 478606847) strcat(s, "h");
if (crc32("sxNqYtErcQSw",12) == 3983152587) strcat(s, "E");
if (crc32("VhRpsJFoJ",9) == 294088401) strcat(s, "i");
if (crc32("noDyIyiCWKkhAE",14) == 4127437242) strcat(s, "m");
if (crc32("tMamVRSLcnJ",11) == 3323625521) strcat(s, "n");
if (crc32("bLXnOvVVz",9) == 1755161598) strcat(s, "e");
if (crc32("CvDPDEcnQNH",11) == 1725431040) strcat(s, "i");
if (crc32("NPUxLarzLHr",11) == 694491725) strcat(s, "y");
if (crc32("WIibXL",6) == 4125089524) strcat(s, "e");
if (crc32("BawNqgV",7) == 1736577849) strcat(s, "b");
if (crc32("ebnztj",6) == 1856127589) strcat(s, "d");
    return s;
}

char *reannotated_verbs() {
    char *s = calloc(12);
    if (crc32("NSOVK",5) == 2389711182) strcat(s, "r");
if (crc32("BinuDridLvXrxbQ",15) == 1357022565) strcat(s, "d");
if (crc32("fFXJSPq",7) == 2743271316) strcat(s, "e");
if (crc32("uOEZC",5) == 3988208150) strcat(s, "a");
if (crc32("sKClQpMitm",10) == 3365191048) strcat(s, "B");
if (crc32("djIxPFTE",8) == 2563457462) strcat(s, "n");
if (crc32("XckQZlFi",8) == 1238340733) strcat(s, "n");
if (crc32("cHToGwLUbt",10) == 4063954687) strcat(s, "o");
if (crc32("EKgkP",5) == 3943418026) strcat(s, "G");
if (crc32("jZnVCJaReCd",11) == 2982389456) strcat(s, "t");
if (crc32("cHRfShmGpRF",11) == 3083130891) strcat(s, "a");
if (crc32("fQIQPIHSM",9) == 1709772465) strcat(s, "O");
if (crc32("oeFzsvHxUlL",11) == 366711081) strcat(s, "t");
if (crc32("ENkgYOACvKTy",12) == 2697395464) strcat(s, "e");
if (crc32("hJfwPoOKVLZE",12) == 2050244332) strcat(s, "g");
if (crc32("HTqZqqzAOehf",12) == 444333348) strcat(s, "d");
    return s;
}

char *exhaling_verbs() {
    char *s = calloc(9);
    if (crc32("IyBrbcEZYDD",11) == 4075587528) strcat(s, "e");
if (crc32("zYOfVkGqRaW",11) == 3625154344) strcat(s, "x");
if (crc32("zMvLgCnmUk",10) == 1333540695) strcat(s, "p");
if (crc32("pyLWDMRblbWUrW",14) == 2576386986) strcat(s, "h");
if (crc32("lfAGQ",5) == 1453431513) strcat(s, "a");
if (crc32("FAXozxRUpJb",11) == 150074366) strcat(s, "l");
if (crc32("CUngQ",5) == 1362841660) strcat(s, "i");
if (crc32("VXHdKVI",7) == 2536496061) strcat(s, "R");
if (crc32("hnwCQdB",7) == 564507202) strcat(s, "n");
if (crc32("fTaoacXUiArRYHp",15) == 4057230709) strcat(s, "L");
if (crc32("GbPImGap",8) == 2470765791) strcat(s, "g");
    return s;
}

char *etherify_verbs() {
    char *s = calloc(9);
    if (crc32("hhYzyQHpvlvz",12) == 1968751629) strcat(s, "e");
if (crc32("PUeZhGhQ",8) == 1367107416) strcat(s, "t");
if (crc32("LTFxxGTy",8) == 451163812) strcat(s, "l");
if (crc32("ldhWrDj",7) == 3548381517) strcat(s, "h");
if (crc32("nSFCqqM",7) == 3674782352) strcat(s, "g");
if (crc32("FlDPtkTTK",9) == 3289789027) strcat(s, "e");
if (crc32("PvVHsHDKUKlyK",13) == 2435479267) strcat(s, "s");
if (crc32("ZjUUOxtvcdjZzDr",15) == 2600314893) strcat(s, "r");
if (crc32("IXhUCUYULA",10) == 3256237929) strcat(s, "i");
if (crc32("LOPKsjYjloLukll",15) == 1088677691) strcat(s, "I");
if (crc32("VpFwbEteNmcml",13) == 193391099) strcat(s, "f");
if (crc32("tOoihqylCWVegC",14) == 1977072157) strcat(s, "y");
    return s;
}

char *restir_verbs() {
    char *s = calloc(7);
    if (crc32("UpqtuaGS",8) == 934590) strcat(s, "r");
if (crc32("jiRfeZ",6) == 2590298911) strcat(s, "L");
if (crc32("Ddxzrvnp",8) == 3643688874) strcat(s, "e");
if (crc32("knQZGo",6) == 968649372) strcat(s, "g");
if (crc32("vWTDPEURn",9) == 2770938342) strcat(s, "s");
if (crc32("ZFIkUewzz",9) == 2509433630) strcat(s, "t");
if (crc32("LTKuigFn",8) == 664227647) strcat(s, "v");
if (crc32("QjOIHEzSZF",10) == 2612310147) strcat(s, "i");
if (crc32("njebhdrRAHefNIo",15) == 3268858599) strcat(s, "r");
    return s;
}

char *apostrophized_verbs() {
    char *s = calloc(14);
    if (crc32("bOPvLjjt",8) == 1617781806) strcat(s, "k");
if (crc32("JDLeODpleuwkMH",14) == 3251856356) strcat(s, "a");
if (crc32("ftpDVbyBftH",11) == 1834854605) strcat(s, "d");
if (crc32("hmQdYnSBXFKH",12) == 2977897742) strcat(s, "p");
if (crc32("EdvVEUMhQPJRyVW",15) == 2656214319) strcat(s, "T");
if (crc32("nPYNSbzL",8) == 2005211269) strcat(s, "o");
if (crc32("TZggNHxSTAUVdDm",15) == 978701394) strcat(s, "W");
if (crc32("kHHsjmu",7) == 1403227445) strcat(s, "s");
if (crc32("fSkJpQ",6) == 1704415377) strcat(s, "t");
if (crc32("RmCzxZZq",8) == 169365818) strcat(s, "t");
if (crc32("kpBugebm",8) == 4216104390) strcat(s, "r");
if (crc32("PtsczZ",6) == 2279637108) strcat(s, "s");
if (crc32("urOyeuMf",8) == 1332601655) strcat(s, "o");
if (crc32("aXpMqhGnaZKO",12) == 833621628) strcat(s, "O");
if (crc32("BlHdCItSE",9) == 1212134051) strcat(s, "p");
if (crc32("XBXblYe",7) == 54598218) strcat(s, "u");
if (crc32("wgvzdoPQQS",10) == 2458683174) strcat(s, "h");
if (crc32("EwYiyRoFHVJrPS",14) == 2664991814) strcat(s, "i");
if (crc32("lIiEfeUapafHiNL",15) == 1093031763) strcat(s, "q");
if (crc32("VlfvRVyPhiG",11) == 1040196193) strcat(s, "z");
if (crc32("LsSWmZ",6) == 2626471122) strcat(s, "e");
if (crc32("tNTgpUjEPQSvbY",14) == 2169366179) strcat(s, "m");
if (crc32("vOTCtoiRgAXUV",13) == 1044769158) strcat(s, "d");
    return s;
}

char *hedgehop_verbs() {
    char *s = calloc(9);
    if (crc32("JkWHHunRkNeDch",14) == 976689970) strcat(s, "h");
if (crc32("qNSuQk",6) == 1681737693) strcat(s, "e");
if (crc32("uiQaTvwnWQhur",13) == 3726161837) strcat(s, "o");
if (crc32("oyDycuaOyAfIatl",15) == 681614202) strcat(s, "d");
if (crc32("EHwwfUnBI",9) == 3527088006) strcat(s, "g");
if (crc32("cQbYswTssMtxCF",14) == 439212949) strcat(s, "O");
if (crc32("NIiEinnUZzsCd",13) == 3047809335) strcat(s, "e");
if (crc32("YbvvjQJ",7) == 640859401) strcat(s, "h");
if (crc32("OFdWwzvWChjjBdk",15) == 2089434425) strcat(s, "A");
if (crc32("aHRXcfT",7) == 184321917) strcat(s, "o");
if (crc32("zVCbjj",6) == 1554994841) strcat(s, "p");
    return s;
}

char *liquidating_verbs() {
    char *s = calloc(12);
    if (crc32("jeCEIeFvSPUk",12) == 1905596816) strcat(s, "c");
if (crc32("QTxjqHjTIoBk",12) == 4142223654) strcat(s, "l");
if (crc32("HCuLbRcwdgiZ",12) == 261950918) strcat(s, "i");
if (crc32("UyMNxQMGpHd",11) == 3817073449) strcat(s, "q");
if (crc32("izNUJsnD",8) == 1427377254) strcat(s, "s");
if (crc32("IEuhtbyhyaO",11) == 2445620725) strcat(s, "u");
if (crc32("FhhEc",5) == 4034040866) strcat(s, "i");
if (crc32("URuZbq",6) == 24937226) strcat(s, "a");
if (crc32("DfnfbIxdlhY",11) == 3826035509) strcat(s, "d");
if (crc32("rimJqjTIaMGY",12) == 3487575177) strcat(s, "T");
if (crc32("DPPqgJiFI",9) == 3798233260) strcat(s, "a");
if (crc32("oWGdflKCJyjME",13) == 750986184) strcat(s, "t");
if (crc32("UKTGMLsyXsaR",12) == 3382875070) strcat(s, "i");
if (crc32("HWfWQ",5) == 3575907083) strcat(s, "i");
if (crc32("YyeVk",5) == 2643197560) strcat(s, "n");
if (crc32("QehEBW",6) == 3151873112) strcat(s, "q");
if (crc32("iIaPsLLNq",9) == 1587322670) strcat(s, "g");
    return s;
}

char *bellyaching_verbs() {
    char *s = calloc(12);
    if (crc32("oKvJTqLbKAyvRP",14) == 2940373981) strcat(s, "Y");
if (crc32("qerfZrCsinWLlfn",15) == 2145499916) strcat(s, "b");
if (crc32("FinGrCUUnxs",11) == 1573515137) strcat(s, "e");
if (crc32("evqFvrMHQyLJEwn",15) == 1098192942) strcat(s, "l");
if (crc32("ZaHieJHe",8) == 2409739766) strcat(s, "l");
if (crc32("ZRywLox",7) == 2627608610) strcat(s, "y");
if (crc32("ilcucaqHk",9) == 2596781806) strcat(s, "a");
if (crc32("QcibhLWpLiUBvpS",15) == 3793338814) strcat(s, "m");
if (crc32("XvEqk",5) == 436220699) strcat(s, "c");
if (crc32("tHzkUeFLFv",10) == 409491322) strcat(s, "h");
if (crc32("npaiQdH",7) == 105228061) strcat(s, "v");
if (crc32("mSVSGostSe",10) == 2184912280) strcat(s, "i");
if (crc32("fbcqcszbgZP",11) == 1893909195) strcat(s, "n");
if (crc32("OySavPgRfC",10) == 3598727897) strcat(s, "g");
    return s;
}

char *conspire_verbs() {
    char *s = calloc(9);
    if (crc32("sRJTpsRFSpcVe",13) == 1812053680) strcat(s, "c");
if (crc32("xrGRMgAoEx",10) == 3321235992) strcat(s, "z");
if (crc32("LLBUfpMU",8) == 1051895974) strcat(s, "o");
if (crc32("kPZeuITPmPGi",12) == 1457531395) strcat(s, "n");
if (crc32("OXoqUNYVR",9) == 1571840739) strcat(s, "s");
if (crc32("wpLhDms",7) == 1537058230) strcat(s, "q");
if (crc32("gsIkKs",6) == 1650360672) strcat(s, "p");
if (crc32("dUzsYkGhI",9) == 825989064) strcat(s, "i");
if (crc32("jNMxZNi",7) == 266333525) strcat(s, "m");
if (crc32("CWgCOR",6) == 2492749195) strcat(s, "r");
if (crc32("WNgaVWlH",8) == 1073808859) strcat(s, "Y");
if (crc32("LZIsboei",8) == 4107307522) strcat(s, "e");
    return s;
}

char *remixed_verbs() {
    char *s = calloc(8);
    if (crc32("RCkEBjqLxV",10) == 1915293622) strcat(s, "Q");
if (crc32("MpvgwKLyFg",10) == 2588946892) strcat(s, "r");
if (crc32("EIDJLnfauBBJygj",15) == 2965720206) strcat(s, "e");
if (crc32("uYwaCUsEjF",10) == 3490058743) strcat(s, "m");
if (crc32("gmxtyhCMrWCCQDt",15) == 2988782758) strcat(s, "i");
if (crc32("ILcdVKCJMhPeMzX",15) == 365271469) strcat(s, "V");
if (crc32("lGoyFeJiPzsgtpe",15) == 970430038) strcat(s, "x");
if (crc32("SyvOVmCjGEiO",12) == 2700652408) strcat(s, "u");
if (crc32("PRtyZXbdZsdeK",13) == 3248076102) strcat(s, "e");
if (crc32("LIHRHND",7) == 1591047180) strcat(s, "d");
    return s;
}

char *grimacing_verbs() {
    char *s = calloc(10);
    if (crc32("VIEAYPRDXaiz",12) == 1020301553) strcat(s, "z");
if (crc32("vUUWUKFRj",9) == 4111168617) strcat(s, "g");
if (crc32("mKWsGD",6) == 2588782529) strcat(s, "C");
if (crc32("fykkCdUCYHL",11) == 830384152) strcat(s, "r");
if (crc32("mEchI",5) == 26862235) strcat(s, "p");
if (crc32("JNONuEL",7) == 1232298627) strcat(s, "i");
if (crc32("MvhlGQDHOF",10) == 1228238041) strcat(s, "t");
if (crc32("vafsPZyvjE",10) == 956529055) strcat(s, "m");
if (crc32("SdwgyapvQa",10) == 3731742701) strcat(s, "W");
if (crc32("WeISRUsBUezJV",13) == 3353049683) strcat(s, "a");
if (crc32("GhVXc",5) == 478877972) strcat(s, "c");
if (crc32("yCIZYyQ",7) == 3049405906) strcat(s, "c");
if (crc32("qIWUxcEppQKyZe",14) == 3024376237) strcat(s, "i");
if (crc32("tTRydVFm",8) == 857032916) strcat(s, "O");
if (crc32("mRbwwpFhOY",10) == 1378762096) strcat(s, "n");
if (crc32("ryrGFYd",7) == 3542391089) strcat(s, "a");
if (crc32("QEGbOhyewyMczqL",15) == 4270681098) strcat(s, "g");
    return s;
}

char *sullies_verbs() {
    char *s = calloc(8);
    if (crc32("bIBiq",5) == 734812602) strcat(s, "u");
if (crc32("PTmcyNUEW",9) == 3158951625) strcat(s, "s");
if (crc32("EmOlZ",5) == 52663970) strcat(s, "k");
if (crc32("LKryuQOmc",9) == 3224326016) strcat(s, "u");
if (crc32("BpCUWwg",7) == 4832034) strcat(s, "R");
if (crc32("AVUYfcbZTatWu",13) == 4169429838) strcat(s, "l");
if (crc32("wBUpVpgF",8) == 4169962778) strcat(s, "p");
if (crc32("YHsjnP",6) == 1579138381) strcat(s, "l");
if (crc32("cbRtvmGUq",9) == 521531407) strcat(s, "i");
if (crc32("ozPSFbZeqChkP",13) == 3296228068) strcat(s, "e");
if (crc32("VUAZiIDA",8) == 441961836) strcat(s, "o");
if (crc32("keZSmxERtKZh",12) == 4110383661) strcat(s, "s");
    return s;
}

char *divide_verbs() {
    char *s = calloc(7);
    if (crc32("TVLinECMbHkxPbd",15) == 2137422918) strcat(s, "d");
if (crc32("oXEnILZbV",9) == 3617886792) strcat(s, "c");
if (crc32("GmemjpQpsAADIYz",15) == 1508337220) strcat(s, "i");
if (crc32("YXkXM",5) == 3163044958) strcat(s, "h");
if (crc32("VKELVA",6) == 2084992110) strcat(s, "v");
if (crc32("WAsNZOJMMi",10) == 3450130467) strcat(s, "i");
if (crc32("JOgDldWuTY",10) == 3663149325) strcat(s, "d");
if (crc32("wGGzGUDEzH",10) == 200441400) strcat(s, "e");
    return s;
}

char *scrapped_verbs() {
    char *s = calloc(9);
    if (crc32("yUHMQdG",7) == 459037614) strcat(s, "x");
if (crc32("qwqTtsFOX",9) == 1775958220) strcat(s, "s");
if (crc32("BDGXzVKKZ",9) == 1664341568) strcat(s, "c");
if (crc32("tfkHVTOsBfxKaZw",15) == 3155672007) strcat(s, "r");
if (crc32("ySQDwxRON",9) == 1794077580) strcat(s, "F");
if (crc32("uwzOEyIab",9) == 1787554195) strcat(s, "a");
if (crc32("cvszNyoGjWgIOXJ",15) == 133685683) strcat(s, "O");
if (crc32("tYnZEiwzZpED",12) == 2714818969) strcat(s, "p");
if (crc32("PmxPPmhoEs",10) == 2601678342) strcat(s, "p");
if (crc32("LYlClk",6) == 3965657431) strcat(s, "p");
if (crc32("ooQZTyoYVk",10) == 3303562772) strcat(s, "c");
if (crc32("HDKoRcu",7) == 866149662) strcat(s, "e");
if (crc32("LRUcRSGGH",9) == 530586656) strcat(s, "d");
    return s;
}

char *regard_verbs() {
    char *s = calloc(7);
    if (crc32("rCEgRGexeYn",11) == 541988890) strcat(s, "r");
if (crc32("HuhhCgfspYVKOHd",15) == 3075447487) strcat(s, "J");
if (crc32("lpkTWggP",8) == 4214974990) strcat(s, "e");
if (crc32("OkvjXM",6) == 11547622) strcat(s, "b");
if (crc32("RimXslk",7) == 744073137) strcat(s, "g");
if (crc32("KNuBzB",6) == 1365444068) strcat(s, "a");
if (crc32("OxXpctbea",9) == 3492549496) strcat(s, "r");
if (crc32("sIgogTnDZZbFWLG",15) == 2731544431) strcat(s, "B");
if (crc32("iOpCViWz",8) == 3774790993) strcat(s, "d");
    return s;
}

char *pushoff_verbs() {
    char *s = calloc(8);
    if (crc32("RLcBTjKGBqKdkr",14) == 1155698477) strcat(s, "E");
if (crc32("rIggTMUXfE",10) == 1797881081) strcat(s, "p");
if (crc32("HjqFhGfamTUv",12) == 1875692319) strcat(s, "u");
if (crc32("IRfajBLMmnoS",12) == 2959670821) strcat(s, "s");
if (crc32("bzNBJDhyigsMXe",14) == 1364631824) strcat(s, "h");
if (crc32("eOKQkIpsw",9) == 400690628) strcat(s, "o");
if (crc32("tvEZvgKwcDXqbXD",15) == 2925656205) strcat(s, "y");
if (crc32("FhUFAxJOwuHYXTh",15) == 1363402459) strcat(s, "f");
if (crc32("XsPDnhZWcRH",11) == 2530441828) strcat(s, "c");
if (crc32("ZjrseoL",7) == 2586675838) strcat(s, "f");
    return s;
}

char *hebetating_verbs() {
    char *s = calloc(11);
    if (crc32("uJTDQRHPzCi",11) == 1043692336) strcat(s, "h");
if (crc32("VKOYo",5) == 4040573539) strcat(s, "e");
if (crc32("YmezwtDXXWwQNCz",15) == 3435804755) strcat(s, "b");
if (crc32("rjsFJemYRZ",10) == 2340195379) strcat(s, "e");
if (crc32("HCmMbca",7) == 1420745050) strcat(s, "t");
if (crc32("vgJnGraJPNEwx",13) == 1714851901) strcat(s, "e");
if (crc32("UnHEZFyckKBLB",13) == 608387405) strcat(s, "a");
if (crc32("qnrMXrbAOc",10) == 2246827216) strcat(s, "t");
if (crc32("dzgSpxWcyad",11) == 1609396322) strcat(s, "g");
if (crc32("xDWDQKMZJbxb",12) == 49405100) strcat(s, "i");
if (crc32("vYxwMt",6) == 3301441979) strcat(s, "B");
if (crc32("YLqley",6) == 2757619219) strcat(s, "n");
if (crc32("hxbAzSVU",8) == 1995363296) strcat(s, "t");
if (crc32("zCZQcg",6) == 1356909123) strcat(s, "g");
    return s;
}

char *spousing_verbs() {
    char *s = calloc(9);
    if (crc32("WVBKaS",6) == 3561753528) strcat(s, "s");
if (crc32("WqcSriPDABDpGwn",15) == 3234823917) strcat(s, "p");
if (crc32("riDMIxkLdTQjzp",14) == 276007152) strcat(s, "z");
if (crc32("PAaigxTVgK",10) == 2863098634) strcat(s, "o");
if (crc32("aRFawkbQIHcFKK",14) == 3584550258) strcat(s, "u");
if (crc32("fMlFGj",6) == 3635689809) strcat(s, "s");
if (crc32("snxzFGgSOaG",11) == 836496747) strcat(s, "p");
if (crc32("yBkrtf",6) == 3943449120) strcat(s, "i");
if (crc32("vpHRFBybiqUoxlj",15) == 931335017) strcat(s, "n");
if (crc32("WeMTvPYQkcAFm",13) == 1315295256) strcat(s, "q");
if (crc32("EkJKOCjhvvTF",12) == 2945197314) strcat(s, "g");
    return s;
}

char *pee_verbs() {
    char *s = calloc(4);
    if (crc32("AAZeQZbIRfVy",12) == 2575809420) strcat(s, "p");
if (crc32("jtYEj",5) == 3002697987) strcat(s, "e");
if (crc32("IIqqTMjpO",9) == 3987149634) strcat(s, "z");
if (crc32("zaWrBEpMBORpgZh",15) == 3850763692) strcat(s, "e");
    return s;
}

char *demythologized_verbs() {
    char *s = calloc(15);
    if (crc32("gpHkQNmfanZ",11) == 4196427733) strcat(s, "d");
if (crc32("NFFRmHjBXzYoUJf",15) == 754984124) strcat(s, "Y");
if (crc32("ebaGa",5) == 3393657267) strcat(s, "e");
if (crc32("WIJoaeSoeXvx",12) == 2301267327) strcat(s, "m");
if (crc32("XzdEae",6) == 754091845) strcat(s, "Q");
if (crc32("FOOobujoS",9) == 445205294) strcat(s, "y");
if (crc32("XThyzeNvLALY",12) == 1590299763) strcat(s, "t");
if (crc32("cbiTJQ",6) == 320316501) strcat(s, "K");
if (crc32("ifhPetAEXGyJ",12) == 26102609) strcat(s, "h");
if (crc32("jNVpfFLJILSrr",13) == 1460688966) strcat(s, "v");
if (crc32("LtovOPt",7) == 1297593076) strcat(s, "o");
if (crc32("wbGutNLwxUzGPr",14) == 2815365779) strcat(s, "M");
if (crc32("wCvTIlMqvKH",11) == 2104877656) strcat(s, "l");
if (crc32("WlafQb",6) == 460123485) strcat(s, "j");
if (crc32("NOIOxNlnyBPg",12) == 3124900367) strcat(s, "o");
if (crc32("TavdqWNTXGl",11) == 729182894) strcat(s, "g");
if (crc32("bxwFGQnphjCFNl",14) == 3808143025) strcat(s, "i");
if (crc32("iXWDLYcHER",10) == 4206716855) strcat(s, "z");
if (crc32("NvXKIL",6) == 884251893) strcat(s, "c");
if (crc32("FJoshdTEEhHavBn",15) == 2338845652) strcat(s, "e");
if (crc32("LnfJxqDYefjI",12) == 1931762906) strcat(s, "x");
if (crc32("YjkqAozlam",10) == 2106893654) strcat(s, "d");
    return s;
}

char *ensilaging_verbs() {
    char *s = calloc(11);
    if (crc32("QRGKBPJdDG",10) == 3051715463) strcat(s, "F");
if (crc32("dOXqgwbKaM",10) == 823724569) strcat(s, "e");
if (crc32("OoxJeOQm",8) == 4207820892) strcat(s, "n");
if (crc32("ojECbNVtKpECgL",14) == 2274702050) strcat(s, "s");
if (crc32("nsvvtiZ",7) == 2088209942) strcat(s, "D");
if (crc32("pwomEzsaLMC",11) == 467971367) strcat(s, "i");
if (crc32("NwCiCNVNG",9) == 2252311785) strcat(s, "l");
if (crc32("eItjKg",6) == 2072166210) strcat(s, "U");
if (crc32("EKhiUQmQmMMQ",12) == 3578031974) strcat(s, "a");
if (crc32("JqPBqDS",7) == 2267282552) strcat(s, "g");
if (crc32("XwrWRMllWYVad",13) == 1317737932) strcat(s, "i");
if (crc32("WBuTmPWiHXieLVm",15) == 2826473269) strcat(s, "n");
if (crc32("IqTPbjRBVrPNbZ",14) == 4068761950) strcat(s, "g");
    return s;
}

char *prefabbing_verbs() {
    char *s = calloc(11);
    if (crc32("NIZDBZDhIs",10) == 1127741806) strcat(s, "a");
if (crc32("YgxptnGsad",10) == 3718822982) strcat(s, "p");
if (crc32("DnTwCSyWYumRyc",14) == 2610900403) strcat(s, "V");
if (crc32("YOrqcya",7) == 191322621) strcat(s, "r");
if (crc32("JutwQmovhrAiqt",14) == 174438079) strcat(s, "e");
if (crc32("aLWLLaXABbMPgW",14) == 2749233977) strcat(s, "f");
if (crc32("xMIaBhFciZ",10) == 308763306) strcat(s, "a");
if (crc32("cLUOmtvcM",9) == 3180333145) strcat(s, "K");
if (crc32("niJRzi",6) == 1831981234) strcat(s, "b");
if (crc32("BNyOTNKoXRaVZ",13) == 168020594) strcat(s, "b");
if (crc32("wRyamyNLMMNibp",14) == 1095101177) strcat(s, "T");
if (crc32("hWtOjfzsewUN",12) == 1290743932) strcat(s, "i");
if (crc32("wRcsaL",6) == 2928025400) strcat(s, "k");
if (crc32("lwNWnZZMXU",10) == 2470059840) strcat(s, "n");
if (crc32("BjhTFxrDr",9) == 2085865610) strcat(s, "g");
    return s;
}

char *propose_verbs() {
    char *s = calloc(8);
    if (crc32("EEQivdX",7) == 2150122574) strcat(s, "R");
if (crc32("UjJiIHEQG",9) == 1718445478) strcat(s, "p");
if (crc32("zzNkDfkNMWqZXvD",15) == 4128532444) strcat(s, "r");
if (crc32("qSxAUFfJrfZj",12) == 1372942785) strcat(s, "j");
if (crc32("wQPaLjBoHlS",11) == 2857033065) strcat(s, "o");
if (crc32("TplCjAUPito",11) == 1233688707) strcat(s, "p");
if (crc32("bxvVZJmogo",10) == 2838459187) strcat(s, "J");
if (crc32("JAwqNJdhP",9) == 1003020883) strcat(s, "o");
if (crc32("qaZUvHgMEfS",11) == 1882988662) strcat(s, "T");
if (crc32("dWTyKFdXBtr",11) == 933468376) strcat(s, "s");
if (crc32("FHvhXElhCrGRjqw",15) == 4284647290) strcat(s, "O");
if (crc32("ZSDadkhfzwK",11) == 1314480826) strcat(s, "e");
    return s;
}

char *melt_verbs() {
    char *s = calloc(5);
    if (crc32("yhiuzjXjqI",10) == 1954494711) strcat(s, "m");
if (crc32("UEJaCed",7) == 38034181) strcat(s, "e");
if (crc32("ZGFPjRfgpXflv",13) == 393553216) strcat(s, "l");
if (crc32("RzTFVPDsvJIc",12) == 3824903513) strcat(s, "U");
if (crc32("xAUzhpVuprl",11) == 243194996) strcat(s, "t");
    return s;
}

char *declined_verbs() {
    char *s = calloc(9);
    if (crc32("uQeokxMoYcssxpO",15) == 3439332778) strcat(s, "d");
if (crc32("wcjOQt",6) == 2732758509) strcat(s, "e");
if (crc32("AwdaGzVSGc",10) == 896575721) strcat(s, "c");
if (crc32("KSwQJjF",7) == 345620258) strcat(s, "l");
if (crc32("ScwNFICZjBAVolO",15) == 3251503651) strcat(s, "X");
if (crc32("sLVRZlwrRLuUY",13) == 193216524) strcat(s, "i");
if (crc32("HidqHkjMcLPNOk",14) == 4022789606) strcat(s, "d");
if (crc32("dTcUojD",7) == 4209214941) strcat(s, "n");
if (crc32("iOUvjpxUqi",10) == 3936376960) strcat(s, "A");
if (crc32("BSZjRZvmBr",10) == 2562775759) strcat(s, "e");
if (crc32("MdSOVp",6) == 1753741035) strcat(s, "R");
if (crc32("JDWerJqNFW",10) == 3238237004) strcat(s, "d");
    return s;
}

char *cadge_verbs() {
    char *s = calloc(6);
    if (crc32("QScjCLouQSGfow",14) == 369382228) strcat(s, "c");
if (crc32("BgZeeJzBw",9) == 3823950439) strcat(s, "a");
if (crc32("ROPdgsuK",8) == 1922342523) strcat(s, "H");
if (crc32("mvUkryLGUDIMuHk",15) == 3900972492) strcat(s, "d");
if (crc32("hFGWm",5) == 2284603227) strcat(s, "O");
if (crc32("ZhicfA",6) == 2337719913) strcat(s, "g");
if (crc32("nfFTUU",6) == 2622079107) strcat(s, "e");
    return s;
}

char *extemporized_verbs() {
    char *s = calloc(13);
    if (crc32("BQiZHPkxgMuzKc",14) == 1350626251) strcat(s, "e");
if (crc32("vrBslbgthtf",11) == 637848996) strcat(s, "q");
if (crc32("tYjaOBVwGvz",11) == 3094955950) strcat(s, "x");
if (crc32("rDEvgVlobhpQJfL",15) == 2006790896) strcat(s, "t");
if (crc32("PLdbdpHKwoDW",12) == 2449334078) strcat(s, "e");
if (crc32("yNVOuj",6) == 279151860) strcat(s, "m");
if (crc32("XlkAcadgAVZlHW",14) == 3782206757) strcat(s, "i");
if (crc32("kqsCY",5) == 1679250727) strcat(s, "p");
if (crc32("GipPdESP",8) == 3599939999) strcat(s, "f");
if (crc32("nHgJRUgUvQVc",12) == 908471110) strcat(s, "o");
if (crc32("siFrHzYN",8) == 3589762184) strcat(s, "p");
if (crc32("YWhcxBwJx",9) == 2892725702) strcat(s, "r");
if (crc32("LjAzWBsD",8) == 1775121023) strcat(s, "Z");
if (crc32("rMunGBEdcxEV",12) == 2502251124) strcat(s, "i");
if (crc32("lJuzSJiEdAa",11) == 661258973) strcat(s, "z");
if (crc32("LnnuBjOAPkWk",12) == 3041300247) strcat(s, "N");
if (crc32("iwgawccItrdSw",13) == 350794190) strcat(s, "e");
if (crc32("DTFIpVjrMODC",12) == 3457295429) strcat(s, "d");
    return s;
}

char *crumble_verbs() {
    char *s = calloc(8);
    if (crc32("IZqDLPya",8) == 3228486399) strcat(s, "c");
if (crc32("GvaObASvsk",10) == 2909846837) strcat(s, "S");
if (crc32("iiUlCOHi",8) == 1249922840) strcat(s, "r");
if (crc32("yhYVOJPDrX",10) == 1747046434) strcat(s, "e");
if (crc32("vBaZXLJWmwRJHG",14) == 3370303994) strcat(s, "u");
if (crc32("spOAYPTsMpmIGbR",15) == 2719695645) strcat(s, "m");
if (crc32("goxtBD",6) == 4057767468) strcat(s, "b");
if (crc32("MtIfWbd",7) == 1973150590) strcat(s, "s");
if (crc32("vzQRhkzBqQvWfF",14) == 2013367307) strcat(s, "l");
if (crc32("vAxALC",6) == 4144977124) strcat(s, "u");
if (crc32("MwIPtXBZsBA",11) == 2927832506) strcat(s, "e");
    return s;
}

char *confiscating_verbs() {
    char *s = calloc(13);
    if (crc32("TllsMA",6) == 424980466) strcat(s, "c");
if (crc32("uyuVzKgtmAqJYq",14) == 3734933233) strcat(s, "S");
if (crc32("BTvOEiSsDJCp",12) == 1015543760) strcat(s, "o");
if (crc32("BxlTA",5) == 2855021364) strcat(s, "O");
if (crc32("UdXJrqze",8) == 2307845780) strcat(s, "n");
if (crc32("XNSfxkF",7) == 2595119447) strcat(s, "f");
if (crc32("vmnTNO",6) == 902743125) strcat(s, "i");
if (crc32("hzesnEA",7) == 1766336632) strcat(s, "s");
if (crc32("SzTLnrx",7) == 1630731811) strcat(s, "C");
if (crc32("cGfKCFdDojOdqDd",15) == 249225564) strcat(s, "c");
if (crc32("KXaBX",5) == 3971610849) strcat(s, "C");
if (crc32("WFFWgOzOOdySO",13) == 4252864083) strcat(s, "a");
if (crc32("tgAyAEqsNf",10) == 623865281) strcat(s, "N");
if (crc32("UEABBGncJCgXFO",14) == 2640246591) strcat(s, "t");
if (crc32("sjJjjjmYVYO",11) == 2161227257) strcat(s, "c");
if (crc32("gOXnRffKrdaZgi",14) == 2393427267) strcat(s, "i");
if (crc32("bzhKxoFcGImeLQK",15) == 2019332399) strcat(s, "n");
if (crc32("nVsbCRtTIQL",11) == 1507224840) strcat(s, "g");
    return s;
}

char *boggled_verbs() {
    char *s = calloc(8);
    if (crc32("jLuMFNKZ",8) == 6747538) strcat(s, "b");
if (crc32("mUcNehxh",8) == 1097398521) strcat(s, "A");
if (crc32("HKqLSdFEC",9) == 403371477) strcat(s, "o");
if (crc32("GniISpizJurqPw",14) == 1127668878) strcat(s, "g");
if (crc32("BVuMmPGno",9) == 2215275462) strcat(s, "M");
if (crc32("RVZYd",5) == 706401266) strcat(s, "g");
if (crc32("McsdtXMnZU",10) == 1171334169) strcat(s, "x");
if (crc32("DhOLqP",6) == 1811017945) strcat(s, "l");
if (crc32("THlpDab",7) == 919199621) strcat(s, "e");
if (crc32("pYLNgsR",7) == 1889667940) strcat(s, "d");
    return s;
}

char *carbonating_verbs() {
    char *s = calloc(12);
    if (crc32("QSPDIrotzLaFPu",14) == 3868613064) strcat(s, "T");
if (crc32("EXFqNzu",7) == 3758739759) strcat(s, "c");
if (crc32("nzwwwIqR",8) == 3164275040) strcat(s, "d");
if (crc32("aOITJS",6) == 3717498078) strcat(s, "a");
if (crc32("wAlnGeKzZ",9) == 2146919596) strcat(s, "T");
if (crc32("gEhZt",5) == 268594732) strcat(s, "r");
if (crc32("iMqNYKqQaAC",11) == 3689327106) strcat(s, "b");
if (crc32("PVkHkZSqv",9) == 2964162639) strcat(s, "Y");
if (crc32("zrEUSgdgBaJrxZ",14) == 3417694133) strcat(s, "o");
if (crc32("XlGDAUfOg",9) == 3431980915) strcat(s, "n");
if (crc32("ilyRayt",7) == 1694082164) strcat(s, "l");
if (crc32("HKgiephiZUThJLf",15) == 2289664120) strcat(s, "a");
if (crc32("lSwaw",5) == 1565732335) strcat(s, "t");
if (crc32("TktADp",6) == 2569700895) strcat(s, "t");
if (crc32("NvEQZDGJZchXpv",14) == 3354408117) strcat(s, "i");
if (crc32("gxadGnHyWoL",11) == 3512031032) strcat(s, "n");
if (crc32("wLLwQlJbgKnrWX",14) == 4122972637) strcat(s, "g");
    return s;
}

char *drizzled_verbs() {
    char *s = calloc(9);
    if (crc32("RCakpuAhgUftTw",14) == 3472943404) strcat(s, "Z");
if (crc32("mFihUyRsQwdjia",14) == 2450040743) strcat(s, "d");
if (crc32("rwSBhbaBm",9) == 1313910088) strcat(s, "r");
if (crc32("bdBaoNwrEaLnb",13) == 48551249) strcat(s, "K");
if (crc32("mTBapYtoZLTru",13) == 1730812026) strcat(s, "i");
if (crc32("LOuFygXfE",9) == 1288595763) strcat(s, "z");
if (crc32("rbpHmFUcpfugj",13) == 661559482) strcat(s, "K");
if (crc32("zLuIdIymgMBON",13) == 2052897238) strcat(s, "z");
if (crc32("yHblSEYfVc",10) == 2320004742) strcat(s, "l");
if (crc32("HZlQS",5) == 438195532) strcat(s, "e");
if (crc32("uMphiIijIEWG",12) == 2756919103) strcat(s, "d");
    return s;
}

char *coughup_verbs() {
    char *s = calloc(8);
    if (crc32("YmQFD",5) == 2155961588) strcat(s, "c");
if (crc32("uwJePTLmcDwTqx",14) == 2426650191) strcat(s, "J");
if (crc32("eXpaJMx",7) == 3094578783) strcat(s, "o");
if (crc32("DGJkx",5) == 106596803) strcat(s, "r");
if (crc32("NrEYsiPMW",9) == 128360462) strcat(s, "u");
if (crc32("ysOntnq",7) == 3891576142) strcat(s, "g");
if (crc32("aYIthEGufQDqVcK",15) == 580042842) strcat(s, "i");
if (crc32("GWqjIwcKR",9) == 2669348462) strcat(s, "h");
if (crc32("bRxnPQmh",8) == 3080483092) strcat(s, "u");
if (crc32("ZaODLFNo",8) == 717539999) strcat(s, "t");
if (crc32("yUGki",5) == 159480550) strcat(s, "p");
    return s;
}

char *nominating_verbs() {
    char *s = calloc(11);
    if (crc32("lWLkK",5) == 3535602842) strcat(s, "n");
if (crc32("EzloXiIug",9) == 1253095204) strcat(s, "o");
if (crc32("vxagmHDb",8) == 3092043587) strcat(s, "m");
if (crc32("IBnuXdNTtJas",12) == 3801055335) strcat(s, "b");
if (crc32("xnBUpVPofDo",11) == 1698804415) strcat(s, "i");
if (crc32("DPVHZwOGSbKRoJN",15) == 1123506090) strcat(s, "n");
if (crc32("CgCWSj",6) == 3485416203) strcat(s, "a");
if (crc32("ZiuDBFqHZyeFi",13) == 3108770831) strcat(s, "x");
if (crc32("aGrSgzxEqup",11) == 1442405022) strcat(s, "t");
if (crc32("CZljrF",6) == 1020247353) strcat(s, "n");
if (crc32("KlsOYiV",7) == 2349454008) strcat(s, "i");
if (crc32("kYQIMhnnZhiHxu",14) == 4294241967) strcat(s, "n");
if (crc32("ehiHH",5) == 1858284748) strcat(s, "g");
    return s;
}

char *Gallicize_verbs() {
    char *s = calloc(10);
    if (crc32("mmIygqYZkVXS",12) == 2780962856) strcat(s, "G");
if (crc32("VdvGHQhYcO",10) == 4128357367) strcat(s, "k");
if (crc32("ChvVF",5) == 79757565) strcat(s, "a");
if (crc32("mLPHlDwJ",8) == 964576361) strcat(s, "l");
if (crc32("YSdnApQxUTXWf",13) == 1709138269) strcat(s, "l");
if (crc32("PjsCUN",6) == 1002274495) strcat(s, "m");
if (crc32("SBbNJDCPYgjmug",14) == 217014010) strcat(s, "i");
if (crc32("QXPJrsWmji",10) == 2361048307) strcat(s, "c");
if (crc32("jXZJOqHHzgzWv",13) == 1643606984) strcat(s, "W");
if (crc32("stisUIWifJLWP",13) == 3686136390) strcat(s, "i");
if (crc32("bZEtJmpDeUtgQuv",15) == 2519066408) strcat(s, "Q");
if (crc32("wAlAlMsDj",9) == 1167542651) strcat(s, "z");
if (crc32("pEzmcxw",7) == 933830946) strcat(s, "e");
    return s;
}

char *flagellating_verbs() {
    char *s = calloc(13);
    if (crc32("gARlX",5) == 223896747) strcat(s, "f");
if (crc32("ozIvE",5) == 3646589529) strcat(s, "l");
if (crc32("EUBslzxXSYIQOCi",15) == 4262296376) strcat(s, "a");
if (crc32("uFcFdv",6) == 3639427853) strcat(s, "g");
if (crc32("idXJJO",6) == 1801810137) strcat(s, "R");
if (crc32("AjfTibkxdP",10) == 2325194568) strcat(s, "e");
if (crc32("VMGqhn",6) == 2678593954) strcat(s, "l");
if (crc32("KYkso",5) == 3512529517) strcat(s, "z");
if (crc32("jELfaJ",6) == 4291426521) strcat(s, "l");
if (crc32("JuLKUoJLdCcpMb",14) == 3586151397) strcat(s, "a");
if (crc32("rsDiIffJT",9) == 894377409) strcat(s, "D");
if (crc32("Hhtjc",5) == 1214400570) strcat(s, "t");
if (crc32("JvQKFXQlPml",11) == 1876699072) strcat(s, "T");
if (crc32("lVIZfliAA",9) == 2074915551) strcat(s, "i");
if (crc32("zespd",5) == 1257177852) strcat(s, "n");
if (crc32("DmQYLM",6) == 3049241779) strcat(s, "L");
if (crc32("IkbUeDyFNAKO",12) == 1687258725) strcat(s, "g");
    return s;
}

char *prejudiced_verbs() {
    char *s = calloc(11);
    if (crc32("SgCeDtoAjvNVJX",14) == 1200870764) strcat(s, "p");
if (crc32("enNcOHlfSwRglC",14) == 2474935080) strcat(s, "p");
if (crc32("gdeNYnujlEHdW",13) == 2162217537) strcat(s, "r");
if (crc32("HBvlRyGWJ",9) == 1521996276) strcat(s, "e");
if (crc32("FWmbNhgSTZUE",12) == 2846903555) strcat(s, "j");
if (crc32("xyYyHLLKpXANBQm",15) == 4278884648) strcat(s, "o");
if (crc32("ngJhIvL",7) == 3330354596) strcat(s, "u");
if (crc32("qiaaQqiUGqxt",12) == 630633819) strcat(s, "U");
if (crc32("phYrpxYKIwBg",12) == 4287822226) strcat(s, "d");
if (crc32("tdQXRIuUwyUEt",13) == 674178230) strcat(s, "i");
if (crc32("FGsEGLzLNWRDFC",14) == 1130367207) strcat(s, "P");
if (crc32("aHnYUiQzQiv",11) == 2528670714) strcat(s, "c");
if (crc32("MmlLVSFBZVTI",12) == 3660875824) strcat(s, "e");
if (crc32("vIEYtVapm",9) == 94160993) strcat(s, "Z");
if (crc32("cuplqp",6) == 1111693499) strcat(s, "d");
    return s;
}

char *acuminating_verbs() {
    char *s = calloc(12);
    if (crc32("LCOFQtxlp",9) == 813592733) strcat(s, "a");
if (crc32("JYOZIGY",7) == 1252304085) strcat(s, "j");
if (crc32("KXrhKYckhJedY",13) == 3307994613) strcat(s, "c");
if (crc32("JajxLm",6) == 3672499511) strcat(s, "u");
if (crc32("uRsGnKGqNog",11) == 2359395830) strcat(s, "W");
if (crc32("QdugcsqNUft",11) == 3968360963) strcat(s, "m");
if (crc32("BTjcXxfQDtqLtX",14) == 3314103419) strcat(s, "Y");
if (crc32("VFmURSEBnL",10) == 2772316506) strcat(s, "i");
if (crc32("FlLZA",5) == 1483645491) strcat(s, "n");
if (crc32("YjGPdcHB",8) == 2989390427) strcat(s, "z");
if (crc32("YMXaHKPAnoSySEb",15) == 2941702004) strcat(s, "a");
if (crc32("AcJcuI",6) == 1210371152) strcat(s, "t");
if (crc32("hDJiprFdzrC",11) == 933614125) strcat(s, "t");
if (crc32("NphVgJELD",9) == 3121638764) strcat(s, "i");
if (crc32("qvSUykthoRrlOBj",15) == 506419266) strcat(s, "c");
if (crc32("nYheVLDYmPPOSW",14) == 3626108100) strcat(s, "n");
if (crc32("ulekNzqMDn",10) == 4221484740) strcat(s, "W");
if (crc32("BDyvQDnWxBHKXu",14) == 3770125351) strcat(s, "g");
    return s;
}

char *putin_verbs() {
    char *s = calloc(6);
    if (crc32("VqJAgiPvkhdT",12) == 4265097081) strcat(s, "B");
if (crc32("NedgMD",6) == 418921394) strcat(s, "p");
if (crc32("WbFYEAtBIJhfkBE",15) == 1274425968) strcat(s, "u");
if (crc32("amUYhtPnVe",10) == 1803582904) strcat(s, "t");
if (crc32("PmRPPghILl",10) == 2112451250) strcat(s, "i");
if (crc32("fLohxpz",7) == 762153978) strcat(s, "n");
    return s;
}

char *overpoeticize_verbs() {
    char *s = calloc(14);
    if (crc32("EsfMqknRpsa",11) == 3507081334) strcat(s, "D");
if (crc32("LZTfARTxHZeMda",14) == 4081036542) strcat(s, "o");
if (crc32("oBeIENMbSGFoeuo",15) == 806676530) strcat(s, "v");
if (crc32("RYlcq",5) == 2168899207) strcat(s, "J");
if (crc32("QGwbHFrWcxSW",12) == 1139435116) strcat(s, "e");
if (crc32("kUCpxt",6) == 1323091929) strcat(s, "r");
if (crc32("moDXKQS",7) == 6854762) strcat(s, "p");
if (crc32("cpXfvNbnritc",12) == 1533866256) strcat(s, "o");
if (crc32("PSoGIeOr",8) == 1352842229) strcat(s, "e");
if (crc32("rGxucEgiDwXB",12) == 1971390361) strcat(s, "t");
if (crc32("NGOMvCNkqIW",11) == 2893790643) strcat(s, "i");
if (crc32("SeLXJ",5) == 679628353) strcat(s, "c");
if (crc32("hUwkVHvGXfuDN",13) == 653427907) strcat(s, "i");
if (crc32("ZGujWjHjKgYiviS",15) == 4200530542) strcat(s, "z");
if (crc32("enoqzrW",7) == 261998550) strcat(s, "e");
    return s;
}

char *overforcing_verbs() {
    char *s = calloc(12);
    if (crc32("XQHDAqBjOubTed",14) == 3850717144) strcat(s, "j");
if (crc32("utNJMeVVrwXFfG",14) == 718972791) strcat(s, "o");
if (crc32("fVxORb",6) == 1009036658) strcat(s, "K");
if (crc32("PwEivHdjoECylF",14) == 3134408517) strcat(s, "v");
if (crc32("VumTeoYZSRcEV",13) == 2327839101) strcat(s, "D");
if (crc32("hbltrsbhraSVDv",14) == 208983733) strcat(s, "e");
if (crc32("IoMAREVJKFPXtcb",15) == 838939877) strcat(s, "G");
if (crc32("cpSLKcr",7) == 242588684) strcat(s, "r");
if (crc32("bfNZLtuLmUmJ",12) == 625664057) strcat(s, "f");
if (crc32("FnGOLdVxYFsLkmR",15) == 2440457524) strcat(s, "o");
if (crc32("myvqTZfAWJyfP",13) == 3623903242) strcat(s, "y");
if (crc32("OwPKjofIZiqA",12) == 1748681428) strcat(s, "r");
if (crc32("PjnjJhdiNDmt",12) == 2140554028) strcat(s, "c");
if (crc32("RWvoY",5) == 1921373815) strcat(s, "i");
if (crc32("EsyDKAFWh",9) == 1944427676) strcat(s, "n");
if (crc32("QKbWFtYMgjoiAdP",15) == 3302679562) strcat(s, "g");
    return s;
}

char *footslog_verbs() {
    char *s = calloc(9);
    if (crc32("zoQZzLUFVXOja",13) == 1943077698) strcat(s, "K");
if (crc32("bFrcDYLI",8) == 1821948627) strcat(s, "f");
if (crc32("MzFYBTlWUQai",12) == 348329487) strcat(s, "o");
if (crc32("KUZqy",5) == 1795443612) strcat(s, "o");
if (crc32("NkQkSZowRVJleC",14) == 1207796999) strcat(s, "t");
if (crc32("romjc",5) == 873532920) strcat(s, "d");
if (crc32("ihvmmzAqskMVs",13) == 663158378) strcat(s, "s");
if (crc32("TBSZLSaO",8) == 3343052116) strcat(s, "Z");
if (crc32("WdyBd",5) == 736452491) strcat(s, "l");
if (crc32("FWezHyFqGpCw",12) == 2121336452) strcat(s, "o");
if (crc32("wACGfhQvsl",10) == 1907065528) strcat(s, "q");
if (crc32("FtiLrwHAYEbpKj",14) == 3321402713) strcat(s, "g");
    return s;
}

char *energize_verbs() {
    char *s = calloc(9);
    if (crc32("xutURuMufUqwkKr",15) == 1274361025) strcat(s, "P");
if (crc32("rZuVWVDSYiGgy",13) == 2186703581) strcat(s, "e");
if (crc32("PoHYSrhrK",9) == 1592128559) strcat(s, "s");
if (crc32("mNAKfhu",7) == 2865292300) strcat(s, "n");
if (crc32("fIOdfOjnuF",10) == 489531950) strcat(s, "e");
if (crc32("doeiqWryc",9) == 831715116) strcat(s, "y");
if (crc32("ppSmAhrAL",9) == 1188153489) strcat(s, "r");
if (crc32("zVOYSCKmgj",10) == 1540461399) strcat(s, "g");
if (crc32("uCcPBx",6) == 1580161378) strcat(s, "u");
if (crc32("NZDLiovJusaGi",13) == 785345696) strcat(s, "i");
if (crc32("Dwmoh",5) == 2092586944) strcat(s, "z");
if (crc32("LTyXekyb",8) == 1779696783) strcat(s, "Q");
if (crc32("ZHgCPrpWYSCEK",13) == 2500840203) strcat(s, "e");
    return s;
}

char *begot_verbs() {
    char *s = calloc(6);
    if (crc32("hvNvsguhGj",10) == 3620095951) strcat(s, "n");
if (crc32("wNAvNdKZuXpqQK",14) == 4188233473) strcat(s, "b");
if (crc32("jXHjNZSgUEOaZ",13) == 2236025246) strcat(s, "L");
if (crc32("wTlRDRSMHFBTLV",14) == 536121733) strcat(s, "e");
if (crc32("otjhXkG",7) == 1362036210) strcat(s, "g");
if (crc32("yVSJO",5) == 1145230798) strcat(s, "H");
if (crc32("fIuhELcf",8) == 1876149923) strcat(s, "o");
if (crc32("OMDybir",7) == 1992610202) strcat(s, "a");
if (crc32("MRkpuDVBz",9) == 1672369897) strcat(s, "t");
    return s;
}

char *gat_verbs() {
    char *s = calloc(4);
    if (crc32("TEVRUMHBfb",10) == 3582134231) strcat(s, "s");
if (crc32("yIkjWPoDLWqYSb",14) == 2757333736) strcat(s, "g");
if (crc32("JkhDi",5) == 3074505605) strcat(s, "D");
if (crc32("yFzfiM",6) == 3201714922) strcat(s, "a");
if (crc32("usCwuTyQZTayZ",13) == 2141493967) strcat(s, "t");
    return s;
}

char *wholesaling_verbs() {
    char *s = calloc(12);
    if (crc32("FQCUSqAy",8) == 1331048753) strcat(s, "L");
if (crc32("wuUNE",5) == 3540689059) strcat(s, "w");
if (crc32("vHqACMAlRzeTf",13) == 3612874191) strcat(s, "h");
if (crc32("PlyETJSGO",9) == 1004612211) strcat(s, "o");
if (crc32("NlHimPz",7) == 1795998730) strcat(s, "a");
if (crc32("NBvWT",5) == 3648834335) strcat(s, "l");
if (crc32("UBZuRTs",7) == 4172314565) strcat(s, "e");
if (crc32("vlYpeOfjNOmphq",14) == 4277445700) strcat(s, "Y");
if (crc32("KJcyJnzNV",9) == 3905873460) strcat(s, "s");
if (crc32("JxMNFbGf",8) == 3090703770) strcat(s, "a");
if (crc32("mwPBDDNQGEdB",12) == 2225143905) strcat(s, "U");
if (crc32("MJXAuShWxiDP",12) == 205435385) strcat(s, "l");
if (crc32("gtZenZdHVYyUzlm",15) == 3922768148) strcat(s, "i");
if (crc32("ianyEvAZfS",10) == 2468631896) strcat(s, "A");
if (crc32("ZzWJV",5) == 1366166516) strcat(s, "n");
if (crc32("xekAVKGcWPvej",13) == 2200125674) strcat(s, "g");
    return s;
}

char *leaped_verbs() {
    char *s = calloc(7);
    if (crc32("ZxwkJgzngqx",11) == 3040404038) strcat(s, "l");
if (crc32("nMzQWRHTaDVjur",14) == 404846762) strcat(s, "e");
if (crc32("JgJrkzRJNOiLNeD",15) == 370574846) strcat(s, "a");
if (crc32("jefCrmY",7) == 3771819910) strcat(s, "p");
if (crc32("bWOfaHYWtFN",11) == 1109059058) strcat(s, "t");
if (crc32("gdwAjiZOErEq",12) == 1668190304) strcat(s, "e");
if (crc32("BLgWsieWIXyUB",13) == 1941316479) strcat(s, "F");
if (crc32("DaCfCSOsTeIbeU",14) == 3727778006) strcat(s, "d");
    return s;
}

char *winterffed_verbs() {
    char *s = calloc(11);
    if (crc32("LGAZo",5) == 2984447025) strcat(s, "w");
if (crc32("mddPVVMTqvpNZzO",15) == 2482420323) strcat(s, "i");
if (crc32("ylEcswSV",8) == 545681136) strcat(s, "n");
if (crc32("pmqGtVSrGECX",12) == 3368451186) strcat(s, "t");
if (crc32("IPiumJdjltjXU",13) == 808576534) strcat(s, "a");
if (crc32("CwpgW",5) == 2765823174) strcat(s, "e");
if (crc32("EDrIHmHBiqz",11) == 3548781394) strcat(s, "n");
if (crc32("hUGNMbtCcLDL",12) == 2892572158) strcat(s, "r");
if (crc32("YferFzv",7) == 2110372720) strcat(s, "f");
if (crc32("zzSzgleK",8) == 1619403750) strcat(s, "e");
if (crc32("FIYcHBwcdnkPe",13) == 1526895462) strcat(s, "f");
if (crc32("qfLPmIPqZkzbIR",14) == 2767449352) strcat(s, "e");
if (crc32("sbWohXLMbTfCPfG",15) == 2691668250) strcat(s, "I");
if (crc32("zkErKaJcWMG",11) == 1586867342) strcat(s, "d");
    return s;
}

char *disaffiliating_verbs() {
    char *s = calloc(15);
    if (crc32("WnOHXqaiMXFlnCB",15) == 341371495) strcat(s, "d");
if (crc32("GyjbrdMq",8) == 2569728637) strcat(s, "i");
if (crc32("cFqsIns",7) == 238188186) strcat(s, "s");
if (crc32("iVBdPfo",7) == 1307887751) strcat(s, "a");
if (crc32("oagubHjmaqmhK",13) == 388002391) strcat(s, "O");
if (crc32("cGCwVLkS",8) == 2606358819) strcat(s, "f");
if (crc32("JpuXwJHCT",9) == 1955274602) strcat(s, "u");
if (crc32("nAgXYV",6) == 3414170654) strcat(s, "f");
if (crc32("PPKYYC",6) == 2557241271) strcat(s, "P");
if (crc32("xQyOZKy",7) == 3925058693) strcat(s, "i");
if (crc32("Hevzb",5) == 3038391313) strcat(s, "p");
if (crc32("iDrfryJrNAmmROn",15) == 1704713526) strcat(s, "l");
if (crc32("sHALH",5) == 1935881100) strcat(s, "i");
if (crc32("nrJGzrbfkbr",11) == 2909964723) strcat(s, "a");
if (crc32("OqcgtDywuxZq",12) == 1388002178) strcat(s, "d");
if (crc32("kEiigtf",7) == 996037681) strcat(s, "t");
if (crc32("AHrlqBc",7) == 2230226251) strcat(s, "D");
if (crc32("nzwHxnEUNx",10) == 2947690296) strcat(s, "i");
if (crc32("heuTSl",6) == 3866173839) strcat(s, "n");
if (crc32("XWTQwGVezZiDGB",14) == 4216516761) strcat(s, "A");
if (crc32("LKKyIEjBElvOtid",15) == 3009466611) strcat(s, "g");
    return s;
}

char *dup_verbs() {
    char *s = calloc(4);
    if (crc32("XRSAQ",5) == 884030449) strcat(s, "d");
if (crc32("dHZuTdfjUrZAyr",14) == 3564052261) strcat(s, "T");
if (crc32("MCUuYmgvuNsb",12) == 1033564521) strcat(s, "u");
if (crc32("PYYrXwuLvH",10) == 2888245215) strcat(s, "Z");
if (crc32("PYCGbUCZJomNwVZ",15) == 3582391692) strcat(s, "p");
    return s;
}

char *complicate_verbs() {
    char *s = calloc(11);
    if (crc32("agckbj",6) == 1038404062) strcat(s, "y");
if (crc32("cZtVGGUaLPWTV",13) == 3627861146) strcat(s, "c");
if (crc32("DwDbio",6) == 3813589644) strcat(s, "n");
if (crc32("vPQkLVVDbeiyZ",13) == 457537015) strcat(s, "o");
if (crc32("rPJPYwIiSXjXwdV",15) == 108289851) strcat(s, "c");
if (crc32("tUdfLfKoKR",10) == 1874076670) strcat(s, "m");
if (crc32("twSihhlRhCr",11) == 501041303) strcat(s, "q");
if (crc32("gmbOiNutRutsuS",14) == 1428999983) strcat(s, "p");
if (crc32("eBXOxb",6) == 4209846873) strcat(s, "l");
if (crc32("MDqwxbmNdTujuSV",15) == 1117807859) strcat(s, "i");
if (crc32("tEhICOBL",8) == 1764709010) strcat(s, "J");
if (crc32("mwZBnSc",7) == 636506273) strcat(s, "c");
if (crc32("HSepHsSBFRxX",12) == 3075147068) strcat(s, "a");
if (crc32("CiXqsTjDJfEUGj",14) == 1416174271) strcat(s, "b");
if (crc32("EowctGv",7) == 1161466202) strcat(s, "t");
if (crc32("pnBBiSzTKIfkR",13) == 317701940) strcat(s, "e");
    return s;
}

char *slimmed_verbs() {
    char *s = calloc(8);
    if (crc32("lYzLjoijHXOLHjp",15) == 2104195814) strcat(s, "Z");
if (crc32("EuHnXuOqgUUUxe",14) == 2222592703) strcat(s, "s");
if (crc32("jjmQXlZQxfAoYs",14) == 1580185104) strcat(s, "I");
if (crc32("gBmYjlZLRhAb",12) == 65453201) strcat(s, "l");
if (crc32("bWxgilz",7) == 3238236783) strcat(s, "i");
if (crc32("otAduKWSaDdvXxn",15) == 3924925869) strcat(s, "m");
if (crc32("QMsNIkp",7) == 2077728649) strcat(s, "x");
if (crc32("ELXaekTyAuVi",12) == 904271534) strcat(s, "m");
if (crc32("cHcicUsOqFtokn",14) == 3159202167) strcat(s, "e");
if (crc32("ompXZBRnCcun",12) == 3470008343) strcat(s, "d");
    return s;
}

char *pitapatted_verbs() {
    char *s = calloc(11);
    if (crc32("GJIVCDTDwYbYvvu",15) == 4171540130) strcat(s, "p");
if (crc32("jtGKa",5) == 2903569279) strcat(s, "i");
if (crc32("mMfrxVmRwnH",11) == 2378070061) strcat(s, "t");
if (crc32("KbmvwqjpVX",10) == 1757267293) strcat(s, "a");
if (crc32("KnTzSXKoJ",9) == 2066085743) strcat(s, "p");
if (crc32("DTrDuyWxtEK",11) == 1196818702) strcat(s, "a");
if (crc32("OUuCYNpxEAEN",12) == 2312380870) strcat(s, "e");
if (crc32("KRgAzYyxiQkl",12) == 1730874387) strcat(s, "t");
if (crc32("oYFmeh",6) == 1071053116) strcat(s, "i");
if (crc32("VXLGp",5) == 3916772961) strcat(s, "t");
if (crc32("YznjLREl",8) == 1215164420) strcat(s, "R");
if (crc32("UooALQJ",7) == 1640024858) strcat(s, "e");
if (crc32("vbKvhPWsUBdfqz",14) == 3529519918) strcat(s, "w");
if (crc32("qkknyszPda",10) == 3011134927) strcat(s, "d");
    return s;
}

char *necrotizing_verbs() {
    char *s = calloc(12);
    if (crc32("oxEZzBWzKcepj",13) == 2240979268) strcat(s, "n");
if (crc32("evuYpK",6) == 1859423834) strcat(s, "e");
if (crc32("YFIBoZwTQfAuVFe",15) == 3372276171) strcat(s, "c");
if (crc32("fvAxvmi",7) == 2513328289) strcat(s, "z");
if (crc32("aWbrqtLAGoBJN",13) == 2279731972) strcat(s, "r");
if (crc32("PgYXZiXBmU",10) == 3071131057) strcat(s, "o");
if (crc32("ngOuWycB",8) == 4204180625) strcat(s, "t");
if (crc32("jtzYtMsh",8) == 2029059640) strcat(s, "i");
if (crc32("wzkiHCDEX",9) == 2535379622) strcat(s, "z");
if (crc32("iRhquqUgXtRgRsc",15) == 3624133642) strcat(s, "Q");
if (crc32("CqYImVjyE",9) == 3443103606) strcat(s, "i");
if (crc32("BoJwNPVSTtKhvPV",15) == 2709232874) strcat(s, "n");
if (crc32("FpEnuIahWOw",11) == 4007901504) strcat(s, "g");
    return s;
}

char *drift_verbs() {
    char *s = calloc(6);
    if (crc32("YSyAczB",7) == 1908568092) strcat(s, "d");
if (crc32("cDWpuzRIVeVz",12) == 1973045206) strcat(s, "T");
if (crc32("vdeYMa",6) == 285011066) strcat(s, "r");
if (crc32("HnYfHlcWNLj",11) == 191022504) strcat(s, "i");
if (crc32("vMfzx",5) == 3524522451) strcat(s, "E");
if (crc32("ExhptCjLaAkcr",13) == 4285301422) strcat(s, "f");
if (crc32("fBdhvndcyivAW",13) == 381370946) strcat(s, "t");
    return s;
}

char *resprang_verbs() {
    char *s = calloc(9);
    if (crc32("FNfIcQubGqFy",12) == 833394945) strcat(s, "r");
if (crc32("BBlPTDDI",8) == 851619999) strcat(s, "e");
if (crc32("YPcxkgGEgXJ",11) == 3096529565) strcat(s, "s");
if (crc32("DvQDKCPVEi",10) == 3191484651) strcat(s, "p");
if (crc32("xhEpXHGznQEZZqF",15) == 223439965) strcat(s, "r");
if (crc32("ulImxU",6) == 3961241308) strcat(s, "a");
if (crc32("hCKpbGbbYJMWd",13) == 290243947) strcat(s, "n");
if (crc32("MsrvooIHt",9) == 623085821) strcat(s, "g");
    return s;
}

char *defilading_verbs() {
    char *s = calloc(11);
    if (crc32("RyIsLMyKcD",10) == 1683570376) strcat(s, "d");
if (crc32("KYRBbSX",7) == 2252167858) strcat(s, "X");
if (crc32("LMzLCrDEnUkcYrB",15) == 3796147316) strcat(s, "e");
if (crc32("ldVpshWePFSp",12) == 3056220456) strcat(s, "r");
if (crc32("RouPO",5) == 3914737421) strcat(s, "f");
if (crc32("whCjPDXcg",9) == 1906618352) strcat(s, "e");
if (crc32("riUpS",5) == 3023333848) strcat(s, "i");
if (crc32("ghLnXr",6) == 1385391150) strcat(s, "l");
if (crc32("RzDXYjbvoB",10) == 3320600290) strcat(s, "a");
if (crc32("AxEdXvcUXnpVk",13) == 3329782316) strcat(s, "d");
if (crc32("eITXRGX",7) == 2190836204) strcat(s, "V");
if (crc32("JhRGafmx",8) == 2415846779) strcat(s, "i");
if (crc32("KJZmSAF",7) == 907578148) strcat(s, "F");
if (crc32("cwnvjzDveHYg",12) == 2652968663) strcat(s, "n");
if (crc32("MbabOyiBFi",10) == 2765564052) strcat(s, "n");
if (crc32("wBvyaekuboYqP",13) == 3082310530) strcat(s, "g");
    return s;
}

char *misinferring_verbs() {
    char *s = calloc(13);
    if (crc32("XRiKjvK",7) == 1511711769) strcat(s, "f");
if (crc32("RQThjcqOmbmz",12) == 1188381497) strcat(s, "m");
if (crc32("NjbkYcLrAyuXTY",14) == 2967705393) strcat(s, "E");
if (crc32("HuDEwqxIbX",10) == 1578706344) strcat(s, "i");
if (crc32("bwHQHf",6) == 279119384) strcat(s, "s");
if (crc32("GuFKJoLAesa",11) == 2317498610) strcat(s, "i");
if (crc32("ZjGeabMgSEF",11) == 763893651) strcat(s, "V");
if (crc32("PbThx",5) == 4149320083) strcat(s, "n");
if (crc32("TgayUxEgr",9) == 2934693053) strcat(s, "f");
if (crc32("cmnriN",6) == 4158123996) strcat(s, "e");
if (crc32("RDGfjNwAbKLbN",13) == 2955063974) strcat(s, "w");
if (crc32("YGhtvtIcbJVwy",13) == 314111823) strcat(s, "r");
if (crc32("EEoaxjvO",8) == 554177587) strcat(s, "O");
if (crc32("tOwVbhaaIiHWwD",14) == 3785097817) strcat(s, "r");
if (crc32("uZcXpOGMTOcZ",12) == 2694137834) strcat(s, "f");
if (crc32("uuXBHBzdpnftJM",14) == 4059125955) strcat(s, "i");
if (crc32("UpgoMBkuKv",10) == 1858599396) strcat(s, "n");
if (crc32("AkOyuBrbzMsxPP",14) == 4287356210) strcat(s, "J");
if (crc32("tzEvHV",6) == 3557661499) strcat(s, "g");
    return s;
}

char *overfag_verbs() {
    char *s = calloc(8);
    if (crc32("hyCdUaOy",8) == 366451696) strcat(s, "S");
if (crc32("IxGUGfa",7) == 3242794267) strcat(s, "o");
if (crc32("IEqMMIbPiF",10) == 1530704059) strcat(s, "A");
if (crc32("kNZliJV",7) == 3980693581) strcat(s, "v");
if (crc32("ohrOPBVd",8) == 3684038249) strcat(s, "e");
if (crc32("dZKilZtvZdev",12) == 4031267188) strcat(s, "e");
if (crc32("nWiTVzfLkvmsux",14) == 912065943) strcat(s, "J");
if (crc32("KzugYJAqVAO",11) == 3593557511) strcat(s, "r");
if (crc32("CKYHxKFzBjGKzC",14) == 3033941523) strcat(s, "f");
if (crc32("aqIeMsqUsmUCL",13) == 1528567939) strcat(s, "a");
if (crc32("sQumyVtDeI",10) == 67798423) strcat(s, "f");
if (crc32("vlbta",5) == 4227160251) strcat(s, "g");
    return s;
}

char *emulated_verbs() {
    char *s = calloc(9);
    if (crc32("iQwArG",6) == 697390534) strcat(s, "N");
if (crc32("POQujqzhEvGO",12) == 1138644559) strcat(s, "e");
if (crc32("vYWmbSGwRO",10) == 1890769842) strcat(s, "m");
if (crc32("krrthiMM",8) == 767716197) strcat(s, "u");
if (crc32("noQEXlzcXeRQvni",15) == 2484263495) strcat(s, "V");
if (crc32("GPXZhGxqMey",11) == 3652725728) strcat(s, "l");
if (crc32("LIMNvYcAiLNMx",13) == 2336343934) strcat(s, "a");
if (crc32("ZXIkMwIxHeGPTY",14) == 1889716044) strcat(s, "s");
if (crc32("JhsyijFvMz",10) == 838554687) strcat(s, "t");
if (crc32("rpUXTrMUt",9) == 3783205212) strcat(s, "e");
if (crc32("QXVGgeXyq",9) == 3405848512) strcat(s, "d");
    return s;
}

char *dispersed_verbs() {
    char *s = calloc(10);
    if (crc32("NmwjmGOecCaFqWg",15) == 3929575022) strcat(s, "d");
if (crc32("TLAzPlOtYRRDI",13) == 1917808599) strcat(s, "i");
if (crc32("cQAKeCFVYeMOsc",14) == 1825590828) strcat(s, "s");
if (crc32("AtlUXDf",7) == 1792096258) strcat(s, "v");
if (crc32("SNyJpMVygJD",11) == 645952822) strcat(s, "p");
if (crc32("XOYJBRWNM",9) == 1260698541) strcat(s, "J");
if (crc32("eoXRTkOcYMlqQK",14) == 591797147) strcat(s, "e");
if (crc32("FPiivmycNiM",11) == 4091479720) strcat(s, "r");
if (crc32("UzRggfizjpQeAtL",15) == 512025810) strcat(s, "M");
if (crc32("YHNtKkrBYPgVFo",14) == 187745494) strcat(s, "s");
if (crc32("aYxXJFhB",8) == 2507428022) strcat(s, "e");
if (crc32("aODIFIxV",8) == 1399396920) strcat(s, "e");
if (crc32("kusDij",6) == 4118954819) strcat(s, "d");
    return s;
}

char *dosing_verbs() {
    char *s = calloc(7);
    if (crc32("JcaksUmJt",9) == 3816009201) strcat(s, "d");
if (crc32("hgfehzmAZOxw",12) == 2323088562) strcat(s, "o");
if (crc32("zoXkApjDQzJ",11) == 3919066551) strcat(s, "B");
if (crc32("CDYPkdFgZ",9) == 2578567448) strcat(s, "s");
if (crc32("QDzANkbUWhtD",12) == 3096251046) strcat(s, "i");
if (crc32("LLnEbBZ",7) == 2532179711) strcat(s, "w");
if (crc32("PwTvWpCdyhUeGYH",15) == 3341398176) strcat(s, "n");
if (crc32("nvYtTkfkFC",10) == 2421661597) strcat(s, "H");
if (crc32("ecFgAXiBCZU",11) == 2305144107) strcat(s, "g");
    return s;
}

char *afford_verbs() {
    char *s = calloc(7);
    if (crc32("TQTHY",5) == 966941920) strcat(s, "a");
if (crc32("NjFTABGKKD",10) == 1826328979) strcat(s, "f");
if (crc32("kVRzx",5) == 1245622151) strcat(s, "U");
if (crc32("NEnuVWLUTKBbU",13) == 3440176950) strcat(s, "f");
if (crc32("kZJtyfggc",9) == 3573660543) strcat(s, "o");
if (crc32("jhchVuOzMqjJbZP",15) == 3459577938) strcat(s, "r");
if (crc32("TBBZFtUCHkcKXXs",15) == 2019921642) strcat(s, "d");
    return s;
}

char *subconnect_verbs() {
    char *s = calloc(11);
    if (crc32("MGmLQTNIas",10) == 1095987639) strcat(s, "s");
if (crc32("GJMSLbOHq",9) == 1562710348) strcat(s, "k");
if (crc32("idELwlcWozDq",12) == 166877428) strcat(s, "u");
if (crc32("bfZaT",5) == 1887514802) strcat(s, "T");
if (crc32("fHsagt",6) == 1252505676) strcat(s, "b");
if (crc32("RXjMGJOZM",9) == 703744045) strcat(s, "B");
if (crc32("naPbbwCpKsz",11) == 32749482) strcat(s, "c");
if (crc32("nTyTukHPithc",12) == 2372075678) strcat(s, "o");
if (crc32("wUYaSrH",7) == 1510737003) strcat(s, "x");
if (crc32("pSbwuAWQxuJ",11) == 250850931) strcat(s, "n");
if (crc32("TEBWBgfwGHk",11) == 3307119890) strcat(s, "n");
if (crc32("SmxseaVmXw",10) == 1353812103) strcat(s, "e");
if (crc32("jTlOhtmpPGBZ",12) == 446658175) strcat(s, "c");
if (crc32("ESYAzGGYATxYK",13) == 2334743919) strcat(s, "t");
    return s;
}

char *boggling_verbs() {
    char *s = calloc(9);
    if (crc32("mHFbJABxjoSH",12) == 2741515396) strcat(s, "b");
if (crc32("iDuUlZKfp",9) == 3188859704) strcat(s, "b");
if (crc32("msmBlVKJE",9) == 689450546) strcat(s, "L");
if (crc32("HfxyEx",6) == 1656763053) strcat(s, "o");
if (crc32("lYdLQDoTqzMwZ",13) == 837497288) strcat(s, "f");
if (crc32("Cfrmie",6) == 648163025) strcat(s, "g");
if (crc32("GdyHdndfkYs",11) == 865020040) strcat(s, "g");
if (crc32("nxjQzyhV",8) == 4197836839) strcat(s, "A");
if (crc32("TivbqxM",7) == 940091931) strcat(s, "l");
if (crc32("yBdIxEAGTn",10) == 3376569289) strcat(s, "i");
if (crc32("WKEpo",5) == 1996562434) strcat(s, "B");
if (crc32("cQLRXDZ",7) == 1642294742) strcat(s, "n");
if (crc32("lOPKaLDy",8) == 878619129) strcat(s, "g");
    return s;
}

char *contemplating_verbs() {
    char *s = calloc(14);
    if (crc32("FAcxBVuUanaWIF",14) == 2569990570) strcat(s, "M");
if (crc32("yokSLkx",7) == 2335387359) strcat(s, "c");
if (crc32("GIRmmScCQveYKyx",15) == 3040817981) strcat(s, "I");
if (crc32("TLwfYVwNstETPMs",15) == 3734424032) strcat(s, "o");
if (crc32("umCUrcRh",8) == 997923046) strcat(s, "s");
if (crc32("lXAxZjDijWHrT",13) == 3760486627) strcat(s, "n");
if (crc32("uLgyQhzGhVS",11) == 1737120127) strcat(s, "t");
if (crc32("ARVlSLKlV",9) == 2653815848) strcat(s, "e");
if (crc32("hSJypLA",7) == 1443563040) strcat(s, "c");
if (crc32("zBAIIPJaA",9) == 3167333232) strcat(s, "m");
if (crc32("jioIPUVfrtgaBe",14) == 1371608327) strcat(s, "p");
if (crc32("wvwsskUntqcWz",13) == 506801496) strcat(s, "l");
if (crc32("wDUXcPapPKWTro",14) == 1417080386) strcat(s, "Z");
if (crc32("gpMErRcaSBB",11) == 4183816129) strcat(s, "a");
if (crc32("wHNPOeoCrranCY",14) == 3504227012) strcat(s, "t");
if (crc32("cHEWicFU",8) == 469631156) strcat(s, "Q");
if (crc32("xNhTH",5) == 2489301111) strcat(s, "i");
if (crc32("LTSlreiNWC",10) == 1542903338) strcat(s, "E");
if (crc32("KIxfBmwE",8) == 647999186) strcat(s, "n");
if (crc32("siHSHBPT",8) == 2107446300) strcat(s, "e");
if (crc32("XKmYSUef",8) == 722513983) strcat(s, "g");
    return s;
}

char *broadcasting_verbs() {
    char *s = calloc(13);
    if (crc32("bjqFhisKUcrQ",12) == 14628317) strcat(s, "o");
if (crc32("ZPNUx",5) == 2627395328) strcat(s, "b");
if (crc32("IQeyuDlJctN",11) == 2951719231) strcat(s, "y");
if (crc32("fxcCV",5) == 1830183165) strcat(s, "r");
if (crc32("ggHrucMfNarjHzF",15) == 4085299225) strcat(s, "I");
if (crc32("gIRwenLny",9) == 1807247354) strcat(s, "o");
if (crc32("JoeEFdtl",8) == 2522710284) strcat(s, "a");
if (crc32("hkoBxHEinHmAvxJ",15) == 1765201329) strcat(s, "T");
if (crc32("XEATTFQnsW",10) == 1873305810) strcat(s, "d");
if (crc32("kdhWmSFF",8) == 225762706) strcat(s, "q");
if (crc32("olrzzQuEq",9) == 188530802) strcat(s, "c");
if (crc32("JDGOdmHdwCkEIM",14) == 1950320185) strcat(s, "a");
if (crc32("PLuqxUK",7) == 1488084089) strcat(s, "s");
if (crc32("GYlkeNT",7) == 2961846330) strcat(s, "p");
if (crc32("JZZIKyJEKpnoCk",14) == 2610311044) strcat(s, "t");
if (crc32("bGHRUT",6) == 2222931291) strcat(s, "i");
if (crc32("YuhfLdJgpi",10) == 1100963795) strcat(s, "n");
if (crc32("vuLLZWvtdLdqTpE",15) == 633285271) strcat(s, "C");
if (crc32("PhoaAQ",6) == 3411070140) strcat(s, "g");
    return s;
}

char *rob_verbs() {
    char *s = calloc(4);
    if (crc32("JIlFIoRkTDNJH",13) == 1549658429) strcat(s, "y");
if (crc32("WJPrm",5) == 4195251390) strcat(s, "r");
if (crc32("aYueuVaE",8) == 2341689906) strcat(s, "o");
if (crc32("aTiOgUblBHiRKmB",15) == 4225014287) strcat(s, "b");
    return s;
}

char *maculing_verbs() {
    char *s = calloc(9);
    if (crc32("btwkp",5) == 527353147) strcat(s, "c");
if (crc32("zTaYW",5) == 3863745755) strcat(s, "m");
if (crc32("hznEc",5) == 2935934367) strcat(s, "J");
if (crc32("vlFcmHPsRGvHI",13) == 3874182410) strcat(s, "a");
if (crc32("BijjFUusaA",10) == 3470737790) strcat(s, "K");
if (crc32("qJgIsmv",7) == 2335999723) strcat(s, "c");
if (crc32("EhSRzLmMIEkJcr",14) == 1160551709) strcat(s, "u");
if (crc32("wXjeOKqxSZj",11) == 2425635145) strcat(s, "g");
if (crc32("PQHaJNRhqc",10) == 1683083204) strcat(s, "l");
if (crc32("sOgjgsMtr",9) == 3882251254) strcat(s, "i");
if (crc32("cOwpFVizhthaCp",14) == 1486350750) strcat(s, "I");
if (crc32("LmnnrNdVipVWwg",14) == 582325555) strcat(s, "n");
if (crc32("lZefl",5) == 133130766) strcat(s, "g");
    return s;
}

char *reprobating_verbs() {
    char *s = calloc(12);
    if (crc32("eQvhehLfY",9) == 4122885439) strcat(s, "r");
if (crc32("fHLEtzi",7) == 361675755) strcat(s, "e");
if (crc32("tkBit",5) == 3055484277) strcat(s, "p");
if (crc32("QhoCZlpJdL",10) == 256845472) strcat(s, "O");
if (crc32("ozGQIGGRqQ",10) == 2166766405) strcat(s, "r");
if (crc32("atLoAYDeFJgQlD",14) == 3619022417) strcat(s, "V");
if (crc32("XkKurBwoDjUTMtc",15) == 1486770245) strcat(s, "o");
if (crc32("BXdZFpTqDyxts",13) == 3542937973) strcat(s, "b");
if (crc32("tSfYtPnoDN",10) == 3265093592) strcat(s, "a");
if (crc32("LMbjiYEycv",10) == 741731890) strcat(s, "T");
if (crc32("EUdBUOlGqBSRA",13) == 4118557900) strcat(s, "t");
if (crc32("IrdMV",5) == 1787782610) strcat(s, "P");
if (crc32("ipPsRIpcglc",11) == 4209875256) strcat(s, "i");
if (crc32("EJGKDtOoXYTIQOY",15) == 4611446) strcat(s, "n");
if (crc32("PLhYbBPGC",9) == 2534377988) strcat(s, "n");
if (crc32("BWTMY",5) == 2384368987) strcat(s, "g");
    return s;
}

char *supposing_verbs() {
    char *s = calloc(10);
    if (crc32("ZMLZQh",6) == 3027102744) strcat(s, "A");
if (crc32("DosSoxeZTDmfo",13) == 3805381894) strcat(s, "s");
if (crc32("lkzWHtmRwCqBb",13) == 2505843795) strcat(s, "u");
if (crc32("bAICfbP",7) == 3925440979) strcat(s, "p");
if (crc32("xctcSfGs",8) == 1383789692) strcat(s, "v");
if (crc32("KIPRJPEiElYI",12) == 2882543952) strcat(s, "p");
if (crc32("OGZRN",5) == 2983548472) strcat(s, "b");
if (crc32("yBcnrPsJS",9) == 3209515303) strcat(s, "o");
if (crc32("rLFiOVznbFp",11) == 1701882208) strcat(s, "J");
if (crc32("ZliGxvFwByPDyR",14) == 722008685) strcat(s, "s");
if (crc32("UiRGQKsNPYs",11) == 3677161634) strcat(s, "i");
if (crc32("Abdoo",5) == 1109971249) strcat(s, "n");
if (crc32("BSWUUvAcVqGBa",13) == 1088547516) strcat(s, "g");
    return s;
}

char *stampeded_verbs() {
    char *s = calloc(10);
    if (crc32("tCkdTSysOl",10) == 1456860691) strcat(s, "t");
if (crc32("BxUmcnr",7) == 2681370791) strcat(s, "s");
if (crc32("JSlyER",6) == 115704274) strcat(s, "G");
if (crc32("DryNOKMCFj",10) == 3429802557) strcat(s, "t");
if (crc32("cINJUprbZSn",11) == 1549190487) strcat(s, "a");
if (crc32("kVvheQLAQVHG",12) == 3958168668) strcat(s, "x");
if (crc32("yovXA",5) == 1918902350) strcat(s, "m");
if (crc32("ISHTzVRukUDT",12) == 3862082342) strcat(s, "p");
if (crc32("ecxUrNLGocSDGR",14) == 2527765679) strcat(s, "j");
if (crc32("PVdCwmltlzqV",12) == 1268528389) strcat(s, "e");
if (crc32("uwYfOZIPy",9) == 4262200767) strcat(s, "G");
if (crc32("fMgrLAwAMLWrxV",14) == 3867350262) strcat(s, "d");
if (crc32("IpbWPjwk",8) == 2500774742) strcat(s, "X");
if (crc32("JMyCE",5) == 1004391699) strcat(s, "e");
if (crc32("zRuHz",5) == 1599927150) strcat(s, "x");
if (crc32("PUuxV",5) == 892758722) strcat(s, "d");
    return s;
}

char *defies_verbs() {
    char *s = calloc(7);
    if (crc32("axYntWsD",8) == 1399509329) strcat(s, "d");
if (crc32("RnFQc",5) == 1543783939) strcat(s, "e");
if (crc32("wbPihsGXydWa",12) == 947775883) strcat(s, "f");
if (crc32("tmedGFWLj",9) == 1056214794) strcat(s, "e");
if (crc32("rLYWLOPszj",10) == 3267311370) strcat(s, "i");
if (crc32("PeORBOQUnguCpS",14) == 515925640) strcat(s, "e");
if (crc32("jVKPtfVoW",9) == 2613822284) strcat(s, "s");
    return s;
}

char *antiqued_verbs() {
    char *s = calloc(9);
    if (crc32("ktmfEYhkx",9) == 2632717108) strcat(s, "a");
if (crc32("UgeFOvLKwS",10) == 2364072070) strcat(s, "n");
if (crc32("wIMaQLhEvvmNF",13) == 865838369) strcat(s, "t");
if (crc32("RIpBkmx",7) == 2382565211) strcat(s, "w");
if (crc32("XXrcXXLLAwpS",12) == 3366336241) strcat(s, "i");
if (crc32("jgmhzU",6) == 1927718787) strcat(s, "q");
if (crc32("gNDerT",6) == 2892879850) strcat(s, "G");
if (crc32("bULJLTKfbFdRZm",14) == 2754505730) strcat(s, "u");
if (crc32("AgtcC",5) == 4156400028) strcat(s, "e");
if (crc32("evTjFZCkWKu",11) == 3836844799) strcat(s, "I");
if (crc32("zIsUJvYnEnY",11) == 2368707696) strcat(s, "d");
    return s;
}

char *roll_verbs() {
    char *s = calloc(5);
    if (crc32("KhoEBMP",7) == 2154022403) strcat(s, "t");
if (crc32("ZYYKWZbZpGZxhZM",15) == 500613118) strcat(s, "r");
if (crc32("uOeEKpRNQBOVIls",15) == 3588845627) strcat(s, "j");
if (crc32("kImKOKXoLyQt",12) == 3303722423) strcat(s, "o");
if (crc32("dNAXcO",6) == 3842425305) strcat(s, "f");
if (crc32("JQiwWVzxHxhr",12) == 3390112194) strcat(s, "l");
if (crc32("bAxijmqGq",9) == 1443915036) strcat(s, "l");
    return s;
}

char *whiz_verbs() {
    char *s = calloc(5);
    if (crc32("rRSCX",5) == 1210026016) strcat(s, "e");
if (crc32("LFZPba",6) == 3147390912) strcat(s, "w");
if (crc32("kTXvjqnq",8) == 2744928560) strcat(s, "T");
if (crc32("aXPWQgMIBSdA",12) == 3412921821) strcat(s, "h");
if (crc32("oBpSlGU",7) == 1738294891) strcat(s, "i");
if (crc32("SCseHB",6) == 3010402923) strcat(s, "z");
    return s;
}

char *misidentify_verbs() {
    char *s = calloc(12);
    if (crc32("nbkbcOOKIp",10) == 1215747028) strcat(s, "l");
if (crc32("IitcftLaf",9) == 2655243431) strcat(s, "m");
if (crc32("QkiGYOjJADXgzlO",15) == 4179188642) strcat(s, "C");
if (crc32("poHtj",5) == 3288864843) strcat(s, "i");
if (crc32("JNRMCkdhMGUE",12) == 3610262080) strcat(s, "W");
if (crc32("rxbvjF",6) == 4285852293) strcat(s, "s");
if (crc32("YVFfTuv",7) == 3096658448) strcat(s, "i");
if (crc32("WfZYcVrMMSAS",12) == 447618367) strcat(s, "O");
if (crc32("DOSUPJjbix",10) == 877680793) strcat(s, "d");
if (crc32("ucWXNKz",7) == 2344984870) strcat(s, "z");
if (crc32("SWurG",5) == 1220546785) strcat(s, "e");
if (crc32("GrfonRwRUJ",10) == 1484126487) strcat(s, "j");
if (crc32("NggKsJcRfV",10) == 2938674813) strcat(s, "n");
if (crc32("ngMMP",5) == 3357454382) strcat(s, "N");
if (crc32("hWiMzu",6) == 344296858) strcat(s, "t");
if (crc32("CPSnoECCQYt",11) == 4134658646) strcat(s, "i");
if (crc32("IFVrofAtfpubPc",14) == 4202468504) strcat(s, "f");
if (crc32("vdVdEDyslpbE",12) == 2322784840) strcat(s, "A");
if (crc32("bkxUiZfXqtzgCqj",15) == 2954116913) strcat(s, "y");
    return s;
}

char *traipsing_verbs() {
    char *s = calloc(10);
    if (crc32("kVheLNtdlPcgm",13) == 3116361092) strcat(s, "P");
if (crc32("mVFIutZxkWsxcoI",15) == 3248563379) strcat(s, "t");
if (crc32("gaAjU",5) == 2615217543) strcat(s, "r");
if (crc32("CDszWnypghdNpy",14) == 973465514) strcat(s, "a");
if (crc32("SEQWCc",6) == 3212803362) strcat(s, "W");
if (crc32("wVbFZoHX",8) == 2870405061) strcat(s, "i");
if (crc32("vWHLgBvXOXRY",12) == 2429451124) strcat(s, "C");
if (crc32("GchClMYvNKMDFUp",15) == 3334265042) strcat(s, "p");
if (crc32("cFTgvGYlciLJW",13) == 4017152811) strcat(s, "s");
if (crc32("fZNAaJgntAnjPv",14) == 2106936984) strcat(s, "s");
if (crc32("JDZdBBExxRq",11) == 555607325) strcat(s, "i");
if (crc32("fQRIDLswdWeJ",12) == 3301462426) strcat(s, "M");
if (crc32("rBiWjz",6) == 3573849587) strcat(s, "n");
if (crc32("LfNzQBIkqBIW",12) == 3464509550) strcat(s, "i");
if (crc32("tfmPQdA",7) == 2625495165) strcat(s, "g");
    return s;
}

char *conglobated_verbs() {
    char *s = calloc(12);
    if (crc32("nRbGumf",7) == 3291119279) strcat(s, "c");
if (crc32("rMKrb",5) == 4242929640) strcat(s, "c");
if (crc32("bDGbazRUJB",10) == 1667952856) strcat(s, "o");
if (crc32("trlCxVKc",8) == 141734725) strcat(s, "W");
if (crc32("GcSexgtxHWOWAC",14) == 3281685805) strcat(s, "n");
if (crc32("MsscTXh",7) == 2608264574) strcat(s, "g");
if (crc32("BSrVHZszQtUO",12) == 4157246599) strcat(s, "g");
if (crc32("hsIlTVwBjw",10) == 1721367046) strcat(s, "l");
if (crc32("xkfRnVn",7) == 1393339336) strcat(s, "o");
if (crc32("oItUVVT",7) == 2143631975) strcat(s, "n");
if (crc32("ROvHIFsbFVPM",12) == 1810713672) strcat(s, "b");
if (crc32("HKYAKXNpr",9) == 2493265522) strcat(s, "A");
if (crc32("kSSdRLDZE",9) == 3232636775) strcat(s, "a");
if (crc32("EZWop",5) == 959691277) strcat(s, "M");
if (crc32("vvMre",5) == 2792852738) strcat(s, "t");
if (crc32("MCuTuNhODYxrM",13) == 421939130) strcat(s, "e");
if (crc32("nbctxMgfFkev",12) == 661270642) strcat(s, "d");
    return s;
}

char *esterify_verbs() {
    char *s = calloc(9);
    if (crc32("pgamr",5) == 2708088408) strcat(s, "F");
if (crc32("OJiHLpLrCh",10) == 3758471555) strcat(s, "e");
if (crc32("xOxLmcw",7) == 1820734824) strcat(s, "B");
if (crc32("aeomPlefzCPzX",13) == 2684330319) strcat(s, "s");
if (crc32("DkjPIExnmWlqso",14) == 2831450405) strcat(s, "p");
if (crc32("lPIKVb",6) == 594095737) strcat(s, "t");
if (crc32("IgUpOalM",8) == 623329288) strcat(s, "z");
if (crc32("fwJMkgrpBzor",12) == 2237375237) strcat(s, "e");
if (crc32("lXgIPhWjQYNj",12) == 3951612808) strcat(s, "q");
if (crc32("oHRsFkMYSxFfo",13) == 1222976909) strcat(s, "r");
if (crc32("DhwdbyeQ",8) == 3301994463) strcat(s, "i");
if (crc32("fqhjXtnkPXaGoh",14) == 1175530300) strcat(s, "f");
if (crc32("PpUtngHZyIeIz",13) == 2165772958) strcat(s, "K");
if (crc32("ZbNmwt",6) == 4093084534) strcat(s, "y");
    return s;
}

char *bogdown_verbs() {
    char *s = calloc(8);
    if (crc32("emOzYXtml",9) == 1610366202) strcat(s, "b");
if (crc32("UvVVClORfMz",11) == 51855716) strcat(s, "o");
if (crc32("aGlcQvuzg",9) == 311038563) strcat(s, "k");
if (crc32("dBpbPgpVOmzysgd",15) == 2082268629) strcat(s, "g");
if (crc32("vfGCpYdjegn",11) == 2470042335) strcat(s, "z");
if (crc32("WLMNviLqKDz",11) == 461837274) strcat(s, "d");
if (crc32("NhJyTxzwSAS",11) == 1696261553) strcat(s, "W");
if (crc32("BrTwr",5) == 2431118702) strcat(s, "o");
if (crc32("jtPNlTUDvTNYC",13) == 676336564) strcat(s, "B");
if (crc32("ZbCbX",5) == 1695153285) strcat(s, "w");
if (crc32("PflGhMKvSNmA",12) == 533703429) strcat(s, "l");
if (crc32("lbmDVhqVMge",11) == 99644709) strcat(s, "n");
    return s;
}

char *heckled_verbs() {
    char *s = calloc(8);
    if (crc32("hBkBGogkzK",10) == 856776529) strcat(s, "s");
if (crc32("zfsZIYZmFpXNxRy",15) == 4087095215) strcat(s, "h");
if (crc32("jkRVPm",6) == 3869798851) strcat(s, "H");
if (crc32("WQkLotOqW",9) == 3746531339) strcat(s, "e");
if (crc32("McmIFayIblbFl",13) == 2297322534) strcat(s, "c");
if (crc32("OoZnRYADCCXfWt",14) == 2071379083) strcat(s, "k");
if (crc32("oOtYRpEy",8) == 3929560866) strcat(s, "l");
if (crc32("IHmjq",5) == 897459971) strcat(s, "e");
if (crc32("ixbXdCMF",8) == 3621669610) strcat(s, "n");
if (crc32("lUNgvJtx",8) == 2870992486) strcat(s, "d");
    return s;
}

char *intergraded_verbs() {
    char *s = calloc(12);
    if (crc32("vtwGoLRWRhLdn",13) == 2003079227) strcat(s, "i");
if (crc32("jktpsVcu",8) == 3151836346) strcat(s, "i");
if (crc32("WWjOjzlvpmeNAM",14) == 915838795) strcat(s, "n");
if (crc32("kISchLZSEgCG",12) == 4023127993) strcat(s, "N");
if (crc32("IduEuMRkDvL",11) == 389645535) strcat(s, "t");
if (crc32("nitVugBsIByy",12) == 2375302269) strcat(s, "Q");
if (crc32("nBQYCKMQzWZTTk",14) == 440996444) strcat(s, "e");
if (crc32("gOynYAZZk",9) == 1903959272) strcat(s, "e");
if (crc32("LxlZtCjbumpCyOa",15) == 3475388708) strcat(s, "r");
if (crc32("XDlvtxXxBkGr",12) == 3344261094) strcat(s, "k");
if (crc32("sqEMtmGbPQMNKT",14) == 2637743868) strcat(s, "g");
if (crc32("tMmATwuxR",9) == 3698933012) strcat(s, "r");
if (crc32("eLZTphHCc",9) == 3897767040) strcat(s, "a");
if (crc32("nzMmioNE",8) == 1473686475) strcat(s, "d");
if (crc32("brHccac",7) == 1685289568) strcat(s, "e");
if (crc32("EDKDgjzkOdy",11) == 1128963958) strcat(s, "d");
if (crc32("lHbdHE",6) == 1183863148) strcat(s, "d");
    return s;
}

char *exfoliate_verbs() {
    char *s = calloc(10);
    if (crc32("vFaKMQE",7) == 564698187) strcat(s, "V");
if (crc32("TmoJloi",7) == 2257701451) strcat(s, "e");
if (crc32("urOPL",5) == 619405734) strcat(s, "B");
if (crc32("OhZegYembhm",11) == 3138020037) strcat(s, "x");
if (crc32("QqXrX",5) == 180644645) strcat(s, "f");
if (crc32("yqZzinbxnJTsof",14) == 35255138) strcat(s, "J");
if (crc32("CMIhXBAUt",9) == 1580773042) strcat(s, "o");
if (crc32("MiMzoecxuLX",11) == 1857300579) strcat(s, "N");
if (crc32("iwYmKkoWrZlh",12) == 1441888951) strcat(s, "l");
if (crc32("duISjBLq",8) == 2222747505) strcat(s, "i");
if (crc32("AjUNrQiFM",9) == 3607923391) strcat(s, "L");
if (crc32("GOXLqvXpLuAPoZ",14) == 384422097) strcat(s, "a");
if (crc32("tbGPyaWADEOqp",13) == 2304661128) strcat(s, "t");
if (crc32("VEPwERTpZiSx",12) == 742362054) strcat(s, "n");
if (crc32("mDQBTmUjuoYKMea",15) == 3367760495) strcat(s, "e");
    return s;
}

char *premiering_verbs() {
    char *s = calloc(11);
    if (crc32("gBjKPQXrW",9) == 1054987120) strcat(s, "p");
if (crc32("BgFKLJgZzk",10) == 1250590432) strcat(s, "r");
if (crc32("uMOvt",5) == 4216198250) strcat(s, "f");
if (crc32("jpYbJeZilWv",11) == 3792985280) strcat(s, "e");
if (crc32("MacljAiSdMZHh",13) == 1539457972) strcat(s, "s");
if (crc32("OWfSaSAG",8) == 1044982709) strcat(s, "m");
if (crc32("TCBqGhNsnMpHQ",13) == 153817493) strcat(s, "i");
if (crc32("hXkZSdi",7) == 3569293642) strcat(s, "e");
if (crc32("VvlrM",5) == 1804346923) strcat(s, "r");
if (crc32("ZHNSyPojsgP",11) == 2632273857) strcat(s, "i");
if (crc32("IQodjmj",7) == 2722319507) strcat(s, "l");
if (crc32("khjtGG",6) == 709933228) strcat(s, "n");
if (crc32("rqqFVDV",7) == 570696260) strcat(s, "g");
    return s;
}

char *grappled_verbs() {
    char *s = calloc(9);
    if (crc32("xNZOkQSaFl",10) == 1932214872) strcat(s, "g");
if (crc32("wMGuMK",6) == 4154876749) strcat(s, "r");
if (crc32("dkHSsXZ",7) == 1837026145) strcat(s, "X");
if (crc32("qTTRkRWjWR",10) == 4085019292) strcat(s, "a");
if (crc32("LnFPi",5) == 1886368880) strcat(s, "d");
if (crc32("LmhkgbYhoVoeTo",14) == 2104459030) strcat(s, "p");
if (crc32("lxwvHBAsGjqrcn",14) == 896271925) strcat(s, "p");
if (crc32("qGAWgrhZJ",9) == 3664303787) strcat(s, "i");
if (crc32("YagOtnaPvXK",11) == 410554820) strcat(s, "l");
if (crc32("ywBJH",5) == 3239346931) strcat(s, "t");
if (crc32("zkDZmRIxoJKB",12) == 1026963163) strcat(s, "e");
if (crc32("FdQmfrAnkPcxDev",15) == 3025699302) strcat(s, "g");
if (crc32("uRKAlsRxmjARLB",14) == 2776699974) strcat(s, "d");
    return s;
}

char *tiptoed_verbs() {
    char *s = calloc(8);
    if (crc32("WnHIpTEFXZH",11) == 2840820791) strcat(s, "t");
if (crc32("JVEtpzgWGpnEgpq",15) == 2286915634) strcat(s, "M");
if (crc32("VEXhr",5) == 2889608142) strcat(s, "i");
if (crc32("qGZrIVVAFmSI",12) == 3797929251) strcat(s, "p");
if (crc32("fmWPMHRghFOQsDu",15) == 4161683544) strcat(s, "t");
if (crc32("eIpRMIV",7) == 798154336) strcat(s, "o");
if (crc32("kFdXSqJxtzGvxI",14) == 2847312834) strcat(s, "e");
if (crc32("ZURnJyXxQTzltLf",15) == 3323369650) strcat(s, "d");
    return s;
}

char *fissuring_verbs() {
    char *s = calloc(10);
    if (crc32("SsoEhAcYXUZxISH",15) == 844182830) strcat(s, "m");
if (crc32("dqosgoua",8) == 2982875901) strcat(s, "f");
if (crc32("GlYYW",5) == 2686061706) strcat(s, "i");
if (crc32("YiVKdHHaZbi",11) == 3281943331) strcat(s, "n");
if (crc32("zCYcwXEv",8) == 2020466963) strcat(s, "s");
if (crc32("VyaJvmD",7) == 3061336694) strcat(s, "U");
if (crc32("SCltJyQcOQs",11) == 2630292854) strcat(s, "s");
if (crc32("aSlEfckq",8) == 1907145246) strcat(s, "u");
if (crc32("RjPguLfy",8) == 1164229216) strcat(s, "r");
if (crc32("MnZume",6) == 1375610036) strcat(s, "L");
if (crc32("IKLcTeIAcaWVZLR",15) == 3501093225) strcat(s, "i");
if (crc32("KwhbFiii",8) == 1506411315) strcat(s, "a");
if (crc32("XKFjXDPwXghLOvw",15) == 1999494204) strcat(s, "n");
if (crc32("zXTYpEGsUUKx",12) == 3563083018) strcat(s, "g");
    return s;
}

char *relearned_verbs() {
    char *s = calloc(10);
    if (crc32("XAhKPNvoFUv",11) == 1109647599) strcat(s, "r");
if (crc32("pBvnDeJVbzHX",12) == 1188903597) strcat(s, "e");
if (crc32("LjpdAn",6) == 2102654243) strcat(s, "l");
if (crc32("LaEwOpYV",8) == 3947956940) strcat(s, "s");
if (crc32("nOcaUoNwFpM",11) == 3038444928) strcat(s, "e");
if (crc32("cEdzGQaKgDplF",13) == 673088944) strcat(s, "V");
if (crc32("loqRdoQOeFSit",13) == 1381908451) strcat(s, "a");
if (crc32("NDZauBrEDwWeiV",14) == 1979934188) strcat(s, "i");
if (crc32("lwBZkovza",9) == 3069494287) strcat(s, "r");
if (crc32("YSUNXYkWvLBgZ",13) == 763457679) strcat(s, "n");
if (crc32("PzmQCXVNgTVCYd",14) == 624220412) strcat(s, "X");
if (crc32("nWXfrbaAp",9) == 26467736) strcat(s, "e");
if (crc32("xftZdPVTjhXSYA",14) == 4143738658) strcat(s, "w");
if (crc32("OJVwFRHaR",9) == 954219311) strcat(s, "d");
    return s;
}

char *plunder_verbs() {
    char *s = calloc(8);
    if (crc32("ugukIrjyTYl",11) == 150561094) strcat(s, "C");
if (crc32("zpjZiQtTTwwopE",14) == 4232047610) strcat(s, "p");
if (crc32("JZhBOqRuIe",10) == 2282868401) strcat(s, "s");
if (crc32("IGtLBNYbZjlcK",13) == 1287909055) strcat(s, "l");
if (crc32("PYSkDjJHHTP",11) == 245061796) strcat(s, "u");
if (crc32("UJiomJrO",8) == 3811432015) strcat(s, "n");
if (crc32("yYaDguJEVAK",11) == 3562373939) strcat(s, "F");
if (crc32("kUaJtVqwd",9) == 996001352) strcat(s, "d");
if (crc32("DpZcqE",6) == 40529409) strcat(s, "e");
if (crc32("MQtNXDUf",8) == 1063201924) strcat(s, "r");
    return s;
}

char *sandalled_verbs() {
    char *s = calloc(10);
    if (crc32("VOgRoPV",7) == 306836150) strcat(s, "s");
if (crc32("XakIdgZ",7) == 2833044428) strcat(s, "a");
if (crc32("lMIRNCamtB",10) == 3204535390) strcat(s, "n");
if (crc32("EzXigKAqpcpCV",13) == 2576633015) strcat(s, "o");
if (crc32("cnTGNmwndXfBvFa",15) == 3409643880) strcat(s, "d");
if (crc32("Gkplmsq",7) == 2513367176) strcat(s, "a");
if (crc32("GrcvUGDYxFi",11) == 3656419233) strcat(s, "l");
if (crc32("MVaDoGXhhNeWri",14) == 1260633031) strcat(s, "m");
if (crc32("mCVCiLJLGJNP",12) == 3490152088) strcat(s, "l");
if (crc32("aVbuvdipIo",10) == 2950234243) strcat(s, "e");
if (crc32("jcScvU",6) == 930229820) strcat(s, "d");
    return s;
}

char *draggled_verbs() {
    char *s = calloc(9);
    if (crc32("mJUoSeM",7) == 879054489) strcat(s, "d");
if (crc32("KCVieIFhBfX",11) == 1080516565) strcat(s, "Z");
if (crc32("yhDTQic",7) == 3839690054) strcat(s, "r");
if (crc32("UMGTtvOd",8) == 3066284466) strcat(s, "q");
if (crc32("gnEBZwDANwEdNn",14) == 3326169773) strcat(s, "a");
if (crc32("RUYxpMwTWmdIaE",14) == 2409998090) strcat(s, "g");
if (crc32("ZSrEEa",6) == 1673065115) strcat(s, "g");
if (crc32("KxkQrgFD",8) == 4063125188) strcat(s, "l");
if (crc32("NETErtmnY",9) == 4270683715) strcat(s, "B");
if (crc32("uEJxduwoVsv",11) == 1905001269) strcat(s, "e");
if (crc32("fwGjusXwkj",10) == 920326109) strcat(s, "d");
    return s;
}

char *wambling_verbs() {
    char *s = calloc(9);
    if (crc32("LBnOZiMOrJqyybP",15) == 1180321577) strcat(s, "w");
if (crc32("IAiCZFlsX",9) == 173933385) strcat(s, "a");
if (crc32("TqSlYlkkJra",11) == 3892260380) strcat(s, "m");
if (crc32("GVJqW",5) == 2092017612) strcat(s, "b");
if (crc32("LmEFydlgx",9) == 794441400) strcat(s, "l");
if (crc32("bXKUKKn",7) == 1998595664) strcat(s, "i");
if (crc32("CLSBHvukVu",10) == 3890750163) strcat(s, "n");
if (crc32("cQTrK",5) == 4122950580) strcat(s, "Z");
if (crc32("cmgbNZNapY",10) == 4208387921) strcat(s, "g");
    return s;
}

char *tunneling_verbs() {
    char *s = calloc(10);
    if (crc32("zlSdW",5) == 53734568) strcat(s, "B");
if (crc32("GgYxuJkjcSrw",12) == 1774241213) strcat(s, "t");
if (crc32("IkrXcQZqGEZYd",13) == 3708607105) strcat(s, "u");
if (crc32("ulWWTHMAAAO",11) == 3681050790) strcat(s, "X");
if (crc32("oYSSp",5) == 3291265259) strcat(s, "n");
if (crc32("TJqPC",5) == 4282739030) strcat(s, "n");
if (crc32("ozgaDCpFCpc",11) == 2600353280) strcat(s, "e");
if (crc32("xMjBs",5) == 687709956) strcat(s, "l");
if (crc32("BjjVenomAik",11) == 3253723349) strcat(s, "j");
if (crc32("lDXBUszNkeXOdSl",15) == 3389097631) strcat(s, "i");
if (crc32("sMqUiuIWpS",10) == 2353365684) strcat(s, "n");
if (crc32("VCvkdI",6) == 1879172294) strcat(s, "g");
    return s;
}

char *poulticed_verbs() {
    char *s = calloc(10);
    if (crc32("XYOwxutAq",9) == 3377799942) strcat(s, "p");
if (crc32("FNGFsunLuKkADlE",15) == 3624091774) strcat(s, "b");
if (crc32("qMmXnkk",7) == 361653620) strcat(s, "o");
if (crc32("ZSoUZdlqrZUeMLz",15) == 3463692103) strcat(s, "u");
if (crc32("aQFXT",5) == 1087825180) strcat(s, "x");
if (crc32("NwECIuEKEA",10) == 2786092647) strcat(s, "l");
if (crc32("eGfrMWvR",8) == 3719771092) strcat(s, "t");
if (crc32("yHJSLoYTx",9) == 4107610314) strcat(s, "q");
if (crc32("erUsbm",6) == 2756030908) strcat(s, "i");
if (crc32("LFpxkPEUTZhPL",13) == 3354888386) strcat(s, "c");
if (crc32("oMtJXEXfZPAFa",13) == 730158552) strcat(s, "h");
if (crc32("itAmZVrbU",9) == 4022290694) strcat(s, "e");
if (crc32("AwnWeLuzS",9) == 3069161637) strcat(s, "d");
    return s;
}

char *begotten_verbs() {
    char *s = calloc(9);
    if (crc32("fcRAVlRTja",10) == 2645468665) strcat(s, "Y");
if (crc32("IbFXewIPz",9) == 334159820) strcat(s, "b");
if (crc32("fbwPZaAtEyxDU",13) == 3508929732) strcat(s, "e");
if (crc32("wFQWDEB",7) == 2058560000) strcat(s, "E");
if (crc32("JIxhOjBx",8) == 1484345554) strcat(s, "g");
if (crc32("fqIbwk",6) == 3271505702) strcat(s, "r");
if (crc32("dMLbpzUHXZbfWGA",15) == 1090024587) strcat(s, "o");
if (crc32("joPPEdhgy",9) == 3430661553) strcat(s, "s");
if (crc32("AqWyCTySGerQegV",15) == 2848697702) strcat(s, "t");
if (crc32("FMpVXST",7) == 2180698700) strcat(s, "t");
if (crc32("XVLHiHFTUbnFuDK",15) == 2126924756) strcat(s, "i");
if (crc32("KBkpaHzAz",9) == 2848161013) strcat(s, "e");
if (crc32("UBQzcvbzx",9) == 753095397) strcat(s, "P");
if (crc32("ZQjnvtgu",8) == 3161747563) strcat(s, "n");
    return s;
}

char *beheld_verbs() {
    char *s = calloc(7);
    if (crc32("ZVtDDvpXFtdYqX",14) == 895037482) strcat(s, "b");
if (crc32("sYUtjI",6) == 911095411) strcat(s, "e");
if (crc32("gRTGPcC",7) == 2496793496) strcat(s, "h");
if (crc32("SSBEXeikca",10) == 3313450461) strcat(s, "v");
if (crc32("nUihdlJAZ",9) == 2540986549) strcat(s, "e");
if (crc32("LopohSlHYNES",12) == 1307073132) strcat(s, "l");
if (crc32("IplDoZAFLMWk",12) == 2069583251) strcat(s, "d");
    return s;
}

char *rearousing_verbs() {
    char *s = calloc(11);
    if (crc32("lKJwPBVLTZJcuw",14) == 3198492712) strcat(s, "r");
if (crc32("UrrqVRdBuYWpKz",14) == 4284985889) strcat(s, "e");
if (crc32("NTmrukPdXEX",11) == 1541927912) strcat(s, "M");
if (crc32("HwokjNXaYac",11) == 1201616607) strcat(s, "a");
if (crc32("ntEnhRXaJvrKS",13) == 2508070502) strcat(s, "v");
if (crc32("oDBMLRnMZWOjCd",14) == 3209128732) strcat(s, "r");
if (crc32("UFgsxuGNES",10) == 593036322) strcat(s, "N");
if (crc32("NhfFtS",6) == 4273541922) strcat(s, "o");
if (crc32("mAbCybcgaWUErE",14) == 430415956) strcat(s, "l");
if (crc32("qzKcjrsVXd",10) == 1381955494) strcat(s, "u");
if (crc32("BhqCvAvEPpPNxb",14) == 2506749108) strcat(s, "P");
if (crc32("qoJEPZbIya",10) == 2209646965) strcat(s, "s");
if (crc32("nDXDIaxPpE",10) == 4276541652) strcat(s, "i");
if (crc32("qLRFHWotB",9) == 15973404) strcat(s, "g");
if (crc32("kORcDCEFlY",10) == 3997370241) strcat(s, "n");
if (crc32("uNrcboMYH",9) == 2117471305) strcat(s, "g");
    return s;
}

char *replicate_verbs() {
    char *s = calloc(10);
    if (crc32("EwFETwiPNGvuWL",14) == 3689264753) strcat(s, "j");
if (crc32("vPoNBA",6) == 2390727594) strcat(s, "r");
if (crc32("bGbqrskehwRR",12) == 3433931210) strcat(s, "x");
if (crc32("fBrRARLN",8) == 624135036) strcat(s, "e");
if (crc32("wVBZA",5) == 1361512138) strcat(s, "p");
if (crc32("VRqaJ",5) == 4175643587) strcat(s, "z");
if (crc32("UZVCWbVEstBf",12) == 1407916746) strcat(s, "l");
if (crc32("aapDCjGwUTFIH",13) == 2921165306) strcat(s, "i");
if (crc32("ncbHQmVTRCa",11) == 108823314) strcat(s, "h");
if (crc32("QlrJhHCxkXuh",12) == 2498244800) strcat(s, "c");
if (crc32("sTWSDXLLxxfrPfc",15) == 798878824) strcat(s, "a");
if (crc32("DRVPjPQyx",9) == 501387983) strcat(s, "I");
if (crc32("EMFiYhkYcn",10) == 2890659371) strcat(s, "t");
if (crc32("GCigdHddY",9) == 2507969334) strcat(s, "t");
if (crc32("SvCEzTYHUBlc",12) == 4229534964) strcat(s, "e");
    return s;
}

char *dieselized_verbs() {
    char *s = calloc(11);
    if (crc32("EEKOX",5) == 677718531) strcat(s, "n");
if (crc32("ZQjOlBgyDUfvYde",15) == 1384319661) strcat(s, "d");
if (crc32("kpgunWjyqxTNh",13) == 1329450022) strcat(s, "i");
if (crc32("ymizr",5) == 3614518206) strcat(s, "e");
if (crc32("JTwViVO",7) == 2173026163) strcat(s, "v");
if (crc32("XdeeSLICXraUD",13) == 980124492) strcat(s, "s");
if (crc32("DcQPnBjxhS",10) == 3936272975) strcat(s, "e");
if (crc32("zYnAFIJRCvHlT",13) == 3983572346) strcat(s, "l");
if (crc32("OffjQplKkXNs",12) == 2558002581) strcat(s, "i");
if (crc32("gxydEmIrrUudIg",14) == 4014553049) strcat(s, "G");
if (crc32("hWGfrexLVDkjLIk",15) == 1460984408) strcat(s, "z");
if (crc32("tsyXgMnYoFdC",12) == 4187411215) strcat(s, "e");
if (crc32("jQsUSxamMBdhU",13) == 1639912002) strcat(s, "d");
    return s;
}

char *subdividing_verbs() {
    char *s = calloc(12);
    if (crc32("widLjbjGaQHtMd",14) == 3279715199) strcat(s, "z");
if (crc32("sHgcICMbyAkfSie",15) == 1367578422) strcat(s, "s");
if (crc32("yQcgpQEKxRceZ",13) == 3068184813) strcat(s, "O");
if (crc32("umAMgGJdF",9) == 2291911144) strcat(s, "u");
if (crc32("RepHCla",7) == 1420904502) strcat(s, "C");
if (crc32("UCcxYdIKI",9) == 3329234966) strcat(s, "b");
if (crc32("sxMFFNvjd",9) == 2894579768) strcat(s, "N");
if (crc32("BlGbpcwBlNlpKNo",15) == 2904047449) strcat(s, "d");
if (crc32("aIaUVbe",7) == 3260656662) strcat(s, "i");
if (crc32("yJAqZRMuW",9) == 3975436440) strcat(s, "v");
if (crc32("djxVIJQecsa",11) == 2956573535) strcat(s, "w");
if (crc32("ldfAkxBwjNm",11) == 2175344227) strcat(s, "i");
if (crc32("foyDbk",6) == 2550322823) strcat(s, "d");
if (crc32("bNgpUGyt",8) == 795392745) strcat(s, "i");
if (crc32("kuuaiLyNZLjB",12) == 2869497260) strcat(s, "n");
if (crc32("dSoyKZAI",8) == 3091992827) strcat(s, "j");
if (crc32("iHooXSmdejyOej",14) == 200834870) strcat(s, "g");
    return s;
}

char *reply_verbs() {
    char *s = calloc(6);
    if (crc32("EnJKP",5) == 2284023608) strcat(s, "r");
if (crc32("CsXtb",5) == 716904824) strcat(s, "e");
if (crc32("HBKMapUCSXwnm",13) == 4129579544) strcat(s, "n");
if (crc32("tWswxFBSTQrn",12) == 2147449735) strcat(s, "p");
if (crc32("AWxguAFoSQzTFS",14) == 1933408264) strcat(s, "K");
if (crc32("GSbEsVpnBEUA",12) == 1371814057) strcat(s, "l");
if (crc32("xzycOzXEjfjldl",14) == 2380343971) strcat(s, "y");
    return s;
}

char *browse_verbs() {
    char *s = calloc(7);
    if (crc32("UeXYQm",6) == 3399326636) strcat(s, "t");
if (crc32("nvjSLFd",7) == 81326300) strcat(s, "b");
if (crc32("isHbjMyKBccQxj",14) == 1153232362) strcat(s, "r");
if (crc32("rCnJFiAIDhkVhhv",15) == 2152031322) strcat(s, "o");
if (crc32("ZWcTpFbBtO",10) == 3303344186) strcat(s, "w");
if (crc32("XnJREEZXFHvcy",13) == 956204049) strcat(s, "w");
if (crc32("qCXXmyYZIlRVzTX",15) == 2362124938) strcat(s, "v");
if (crc32("HecXbFGImWVYb",13) == 2565761870) strcat(s, "s");
if (crc32("AFVpGUTYYVMQLpC",15) == 4058416981) strcat(s, "N");
if (crc32("UhSxhyNWdpnUn",13) == 1213483846) strcat(s, "e");
    return s;
}

char *flapped_verbs() {
    char *s = calloc(8);
    if (crc32("ztADTwGKFAMXEi",14) == 297005180) strcat(s, "f");
if (crc32("ZEHTEVMgfZW",11) == 240419046) strcat(s, "l");
if (crc32("NUqcerVIyWrBVwC",15) == 4132864672) strcat(s, "R");
if (crc32("vvRSv",5) == 3106684274) strcat(s, "a");
if (crc32("ijaIKtYS",8) == 2516412534) strcat(s, "p");
if (crc32("uoaPe",5) == 4261621882) strcat(s, "q");
if (crc32("XireeKpmsOir",12) == 848095102) strcat(s, "p");
if (crc32("KGMdSBW",7) == 2225095100) strcat(s, "e");
if (crc32("dxlXBPIE",8) == 3471691602) strcat(s, "J");
if (crc32("qyiTN",5) == 470996252) strcat(s, "d");
    return s;
}

char *simulating_verbs() {
    char *s = calloc(11);
    if (crc32("kuJmLD",6) == 2065191983) strcat(s, "s");
if (crc32("bcjCZ",5) == 1000183437) strcat(s, "Z");
if (crc32("xBctpU",6) == 987062730) strcat(s, "i");
if (crc32("dELgAXlffj",10) == 4037921136) strcat(s, "m");
if (crc32("XUsobwAnzEDoDjp",15) == 2858069657) strcat(s, "c");
if (crc32("QTEZRComqzyLC",13) == 4145490980) strcat(s, "u");
if (crc32("xCDTPhXH",8) == 2844631885) strcat(s, "z");
if (crc32("lTEnE",5) == 1427524025) strcat(s, "l");
if (crc32("pTSoZBIvoPt",11) == 395621891) strcat(s, "a");
if (crc32("XKxvdvJSUV",10) == 2390838393) strcat(s, "H");
if (crc32("usPSzAAQp",9) == 3306859073) strcat(s, "t");
if (crc32("RzXChUucgRSTPE",14) == 1888153098) strcat(s, "N");
if (crc32("OhQOGJBIw",9) == 490622129) strcat(s, "i");
if (crc32("DLHDJ",5) == 3322286310) strcat(s, "n");
if (crc32("jNeTIZI",7) == 2723823012) strcat(s, "g");
    return s;
}

char *outstood_verbs() {
    char *s = calloc(9);
    if (crc32("bBAYwqvpu",9) == 3061654433) strcat(s, "S");
if (crc32("qyjRWI",6) == 1143415399) strcat(s, "o");
if (crc32("cNmWjkE",7) == 3177785471) strcat(s, "d");
if (crc32("KBuqXG",6) == 1701183875) strcat(s, "u");
if (crc32("NIiOUE",6) == 1238805006) strcat(s, "Y");
if (crc32("rKpGyQaYKUL",11) == 276052060) strcat(s, "t");
if (crc32("lbsbGURsBtmgnA",14) == 4240669434) strcat(s, "s");
if (crc32("yUHeMYItGlNN",12) == 2762626333) strcat(s, "O");
if (crc32("HmypU",5) == 150160409) strcat(s, "t");
if (crc32("jZsxAVP",7) == 568665940) strcat(s, "Z");
if (crc32("bjLsoDHrHpPyrXZ",15) == 879488559) strcat(s, "o");
if (crc32("nosipjam",8) == 2262034211) strcat(s, "F");
if (crc32("HNYoxLnVpDhracR",15) == 3651160322) strcat(s, "o");
if (crc32("EHdcvHOoBQXX",12) == 3946283700) strcat(s, "o");
if (crc32("WhMMvSo",7) == 1245970388) strcat(s, "d");
    return s;
}

char *trapes_verbs() {
    char *s = calloc(7);
    if (crc32("vaqVpLJK",8) == 2899709839) strcat(s, "t");
if (crc32("InTGvIEvsJIPJNH",15) == 2911611224) strcat(s, "r");
if (crc32("zZiWWheqpBNtQm",14) == 2884439879) strcat(s, "t");
if (crc32("jthyNEMTYFS",11) == 3933970353) strcat(s, "a");
if (crc32("JfBvlrD",7) == 257745583) strcat(s, "V");
if (crc32("karQlv",6) == 2881871093) strcat(s, "p");
if (crc32("sQmCGQpLfy",10) == 748900176) strcat(s, "B");
if (crc32("TcSUWtqi",8) == 1938892819) strcat(s, "e");
if (crc32("gLQmnEOIaxI",11) == 2709121715) strcat(s, "s");
    return s;
}

char *reflate_verbs() {
    char *s = calloc(8);
    if (crc32("IscrcAFbJUNsgTb",15) == 3564927014) strcat(s, "h");
if (crc32("NNWioAqyUKPb",12) == 3416353335) strcat(s, "r");
if (crc32("ZxbAlaIXWGvmoe",14) == 883061124) strcat(s, "I");
if (crc32("jSMABtZ",7) == 143149210) strcat(s, "e");
if (crc32("WTDmQZB",7) == 1036403220) strcat(s, "f");
if (crc32("NICcvhVMxRmnMD",14) == 1609728869) strcat(s, "l");
if (crc32("syUGs",5) == 709699047) strcat(s, "Z");
if (crc32("kpRfpqENvhTAw",13) == 1235289972) strcat(s, "a");
if (crc32("oRmzKpaLKv",10) == 1351145489) strcat(s, "t");
if (crc32("YnGHzb",6) == 2351868381) strcat(s, "r");
if (crc32("ALGVFTAaXJnT",12) == 3449679768) strcat(s, "e");
    return s;
}

char *bulged_verbs() {
    char *s = calloc(7);
    if (crc32("hckwVMJPTyUv",12) == 2295580222) strcat(s, "c");
if (crc32("WfsJWPKgiG",10) == 554516717) strcat(s, "b");
if (crc32("dPRzQRBWdPjfd",13) == 1123904482) strcat(s, "t");
if (crc32("AnphPNti",8) == 935907721) strcat(s, "u");
if (crc32("erHSP",5) == 3234148819) strcat(s, "g");
if (crc32("qeIKO",5) == 2228045267) strcat(s, "l");
if (crc32("FfZbvoSIzaHYK",13) == 4000250434) strcat(s, "g");
if (crc32("xMwDTq",6) == 1817667076) strcat(s, "B");
if (crc32("IWbmLZJ",7) == 3625432476) strcat(s, "e");
if (crc32("csNrQPpkIdknntB",15) == 2476123636) strcat(s, "u");
if (crc32("QMBsgpaMal",10) == 60835899) strcat(s, "d");
    return s;
}

char *labelling_verbs() {
    char *s = calloc(10);
    if (crc32("phDVHH",6) == 792854825) strcat(s, "l");
if (crc32("TzGJTKh",7) == 3635921397) strcat(s, "a");
if (crc32("dEMtiCB",7) == 4257106865) strcat(s, "a");
if (crc32("RsuvdlMwCPZbVTw",15) == 1052386120) strcat(s, "F");
if (crc32("GqkTmCwJF",9) == 238731328) strcat(s, "b");
if (crc32("cYBBz",5) == 3470527349) strcat(s, "a");
if (crc32("iqrCn",5) == 2812856703) strcat(s, "e");
if (crc32("tfuHKaQSqigs",12) == 129028687) strcat(s, "l");
if (crc32("BOrCP",5) == 3720586749) strcat(s, "f");
if (crc32("vLJMxiOMWSsDo",13) == 3067185144) strcat(s, "l");
if (crc32("GcpDL",5) == 3198280102) strcat(s, "Y");
if (crc32("TwTKhDQQgyi",11) == 828722632) strcat(s, "i");
if (crc32("hKsomsjsQWJV",12) == 290790838) strcat(s, "K");
if (crc32("WYmgiidDlFWD",12) == 1122894672) strcat(s, "n");
if (crc32("KljFVVNevUZ",11) == 510515342) strcat(s, "g");
    return s;
}

char *unswear_verbs() {
    char *s = calloc(8);
    if (crc32("jPasf",5) == 930863132) strcat(s, "u");
if (crc32("YbAtXdtSv",9) == 534154003) strcat(s, "n");
if (crc32("MrnmwtPIN",9) == 999223376) strcat(s, "s");
if (crc32("LJHBHP",6) == 82776292) strcat(s, "P");
if (crc32("uWllXObeGpFbf",13) == 178205282) strcat(s, "w");
if (crc32("zDmsR",5) == 2689499783) strcat(s, "e");
if (crc32("kcOpeMUDMQD",11) == 222518471) strcat(s, "x");
if (crc32("jAOdDjfdtq",10) == 426459857) strcat(s, "a");
if (crc32("PEMobV",6) == 3530133364) strcat(s, "r");
    return s;
}

char *demur_verbs() {
    char *s = calloc(6);
    if (crc32("XMnON",5) == 66267776) strcat(s, "d");
if (crc32("yTWqjzgeN",9) == 1579127941) strcat(s, "e");
if (crc32("dWxnHKFSMZgN",12) == 1131809048) strcat(s, "e");
if (crc32("iTuNThoCayuKvFE",15) == 17579368) strcat(s, "m");
if (crc32("YjxNUtROObHA",12) == 3441080461) strcat(s, "k");
if (crc32("nLnSfzKvhpZ",11) == 1665589003) strcat(s, "u");
if (crc32("hFlKHLzFWCaM",12) == 3347205545) strcat(s, "U");
if (crc32("ChzAQMS",7) == 1177128730) strcat(s, "r");
    return s;
}

char *fumbled_verbs() {
    char *s = calloc(8);
    if (crc32("bKjjVq",6) == 3357866958) strcat(s, "i");
if (crc32("KfuPP",5) == 1957073025) strcat(s, "f");
if (crc32("smiQpsiIlBaqNq",14) == 3785721246) strcat(s, "u");
if (crc32("FOiMAiYNofPSz",13) == 3104453048) strcat(s, "T");
if (crc32("xueta",5) == 1822156874) strcat(s, "m");
if (crc32("oediltVBBiK",11) == 202747707) strcat(s, "N");
if (crc32("QbPzDsx",7) == 1279060536) strcat(s, "b");
if (crc32("DUaZHX",6) == 2799417019) strcat(s, "H");
if (crc32("dLAiGLQBur",10) == 2609632380) strcat(s, "l");
if (crc32("juIgBLNgTJbfZwR",15) == 1022808602) strcat(s, "e");
if (crc32("WeULobu",7) == 909717787) strcat(s, "d");
    return s;
}

char *pledged_verbs() {
    char *s = calloc(8);
    if (crc32("UIfJIojwsQqJUe",14) == 3998061827) strcat(s, "p");
if (crc32("KeQAkf",6) == 2991959657) strcat(s, "Z");
if (crc32("geoRrFpeQZaEw",13) == 2626104473) strcat(s, "l");
if (crc32("inLjFVSCJtJlUC",14) == 418426112) strcat(s, "H");
if (crc32("vAoZeXHsgxoyJ",13) == 389728208) strcat(s, "e");
if (crc32("KiqYetNkUjqmtHT",15) == 2956299408) strcat(s, "d");
if (crc32("BpsmJWaZ",8) == 1692689441) strcat(s, "g");
if (crc32("WxHDIuqqdl",10) == 551896715) strcat(s, "o");
if (crc32("CGptQUMGFxnyezC",15) == 3684141273) strcat(s, "e");
if (crc32("tjqzrothpfQryQK",15) == 1641623449) strcat(s, "i");
if (crc32("OSePVScshuvmdVo",15) == 2586715800) strcat(s, "d");
    return s;
}

char *strew_verbs() {
    char *s = calloc(6);
    if (crc32("LGWhrnUng",9) == 3843430481) strcat(s, "s");
if (crc32("ySFdhVsSKSf",11) == 3568433244) strcat(s, "S");
if (crc32("yzhHuHw",7) == 490513238) strcat(s, "t");
if (crc32("ylXJLsPewmvapgv",15) == 1533847205) strcat(s, "R");
if (crc32("PvEqNVNYmCtILW",14) == 3913307203) strcat(s, "r");
if (crc32("ECfVJMZAbqOTf",13) == 3097108442) strcat(s, "R");
if (crc32("GYYovdfRLLPL",12) == 506321797) strcat(s, "e");
if (crc32("OJZMsteH",8) == 846007240) strcat(s, "w");
    return s;
}

char *rammed_verbs() {
    char *s = calloc(7);
    if (crc32("ggarSgJGgovnxt",14) == 2196529408) strcat(s, "X");
if (crc32("FkpoKt",6) == 3933209060) strcat(s, "r");
if (crc32("piRvIE",6) == 2222687746) strcat(s, "D");
if (crc32("XOiIr",5) == 3581947791) strcat(s, "a");
if (crc32("vgqmWrLFyEs",11) == 2128303594) strcat(s, "m");
if (crc32("SGbTXMLZg",9) == 1189840448) strcat(s, "C");
if (crc32("mYRuKIrBouDno",13) == 2463774641) strcat(s, "m");
if (crc32("YAclwTKGIbGrwEq",15) == 829337794) strcat(s, "e");
if (crc32("pKXdkfy",7) == 4131401948) strcat(s, "d");
    return s;
}

char *aggregated_verbs() {
    char *s = calloc(11);
    if (crc32("XNtExrOoYFUvj",13) == 2780074207) strcat(s, "P");
if (crc32("uTIHyv",6) == 4172319139) strcat(s, "a");
if (crc32("fraQSo",6) == 3929364474) strcat(s, "C");
if (crc32("lmdKcxg",7) == 991336870) strcat(s, "g");
if (crc32("vlgkBGCtQHIECRU",15) == 1015696099) strcat(s, "g");
if (crc32("fokgQLEFWSZ",11) == 1135769534) strcat(s, "S");
if (crc32("wXvMBdxwxve",11) == 1184380219) strcat(s, "r");
if (crc32("upPKHPabVAj",11) == 1983751060) strcat(s, "e");
if (crc32("SNeBjtdJi",9) == 1277572175) strcat(s, "g");
if (crc32("KdZuCt",6) == 3260638751) strcat(s, "a");
if (crc32("lLxFcxQKxL",10) == 2561250468) strcat(s, "t");
if (crc32("WhTsIoOCXJWRA",13) == 3704671695) strcat(s, "e");
if (crc32("wleFCCJvVQqFw",13) == 892352045) strcat(s, "S");
if (crc32("xZGIMkpXjCfqM",13) == 583672635) strcat(s, "d");
    return s;
}

char *animating_verbs() {
    char *s = calloc(10);
    if (crc32("wEtIhVu",7) == 929353323) strcat(s, "M");
if (crc32("VEIdgiJGtaYH",12) == 1384825928) strcat(s, "a");
if (crc32("lYLYfXopnuKOyFS",15) == 697888269) strcat(s, "S");
if (crc32("fUrWWBNtYNpnJia",15) == 566704958) strcat(s, "n");
if (crc32("wzNgXqVPEDfcR",13) == 1476032844) strcat(s, "i");
if (crc32("gVmTO",5) == 2079166492) strcat(s, "m");
if (crc32("aQyZUkjaugX",11) == 1780336636) strcat(s, "a");
if (crc32("kkmHLMufD",9) == 189867059) strcat(s, "N");
if (crc32("OsjLOKQCNM",10) == 826457388) strcat(s, "t");
if (crc32("XzMqahCVo",9) == 1217615784) strcat(s, "s");
if (crc32("AutQRYCfMnl",11) == 17761968) strcat(s, "i");
if (crc32("pBvZUINPP",9) == 3578373797) strcat(s, "S");
if (crc32("AZjTVyQg",8) == 2793174427) strcat(s, "n");
if (crc32("otgbBGyow",9) == 355512846) strcat(s, "g");
    return s;
}

char *told_verbs() {
    char *s = calloc(5);
    if (crc32("IqQQhDxrf",9) == 1619875464) strcat(s, "j");
if (crc32("NNZwEbWNJE",10) == 68795624) strcat(s, "t");
if (crc32("tqbxjJAwBn",10) == 2786146135) strcat(s, "J");
if (crc32("HyjCEQffo",9) == 3607424231) strcat(s, "o");
if (crc32("NfuOYvWrP",9) == 3259302525) strcat(s, "l");
if (crc32("mEZqmCKPnVi",11) == 1268624082) strcat(s, "L");
if (crc32("vhVgIhpdBsreRC",14) == 2137161144) strcat(s, "d");
    return s;
}

char *Italianating_verbs() {
    char *s = calloc(13);
    if (crc32("vNTjmDDYMO",10) == 1032978106) strcat(s, "I");
if (crc32("kRkBedI",7) == 3404326443) strcat(s, "t");
if (crc32("HcTuwWuCayT",11) == 2917908856) strcat(s, "a");
if (crc32("YNCMvEas",8) == 2671712145) strcat(s, "l");
if (crc32("YHiDTCmylG",10) == 833609287) strcat(s, "d");
if (crc32("kLsptyQtmZl",11) == 1760661601) strcat(s, "i");
if (crc32("xsuLbMjSo",9) == 3392163566) strcat(s, "a");
if (crc32("XdGbfKNW",8) == 2495622455) strcat(s, "n");
if (crc32("kVgROYkXBasp",12) == 3711828713) strcat(s, "a");
if (crc32("ZStJJpI",7) == 890922332) strcat(s, "t");
if (crc32("Qppdz",5) == 2509390525) strcat(s, "C");
if (crc32("uRVdFHFbM",9) == 989654799) strcat(s, "i");
if (crc32("TufJYJKPqjzbT",13) == 817479201) strcat(s, "g");
if (crc32("LpDvEx",6) == 2807042749) strcat(s, "n");
if (crc32("quMAhJyEGYwbZG",14) == 2010584222) strcat(s, "r");
if (crc32("XLNTdEjoNHT",11) == 1414120624) strcat(s, "g");
    return s;
}

char *reexplore_verbs() {
    char *s = calloc(10);
    if (crc32("JoBXEde",7) == 3535006471) strcat(s, "B");
if (crc32("dazYHX",6) == 3154836254) strcat(s, "r");
if (crc32("ycmbjAPEmm",10) == 1225754272) strcat(s, "e");
if (crc32("nAHbnrFM",8) == 3875486304) strcat(s, "Z");
if (crc32("vFBuwQ",6) == 2755614408) strcat(s, "e");
if (crc32("Vterl",5) == 2185086321) strcat(s, "x");
if (crc32("NjZYf",5) == 3690565444) strcat(s, "p");
if (crc32("feAhbXLCQKNazSZ",15) == 4277294171) strcat(s, "M");
if (crc32("dCQkTnnKoUhjYsw",15) == 1039178849) strcat(s, "l");
if (crc32("nKaTc",5) == 4014794920) strcat(s, "o");
if (crc32("RjLAPUnpHVAXuh",14) == 3828909281) strcat(s, "O");
if (crc32("iQtuYYbHDUMeab",14) == 1842200175) strcat(s, "r");
if (crc32("IPNFFhkoKMVwd",13) == 1617981903) strcat(s, "j");
if (crc32("wvSfOLXBjzCitXK",15) == 1419688152) strcat(s, "e");
    return s;
}

char *recentralize_verbs() {
    char *s = calloc(13);
    if (crc32("xQHOwoGM",8) == 2893860083) strcat(s, "F");
if (crc32("cfYth",5) == 1839862520) strcat(s, "r");
if (crc32("yXSfi",5) == 3036541379) strcat(s, "K");
if (crc32("JNihEkniQOWo",12) == 2170953201) strcat(s, "e");
if (crc32("ypeBiVS",7) == 3606324735) strcat(s, "c");
if (crc32("qCVKqskNmMIj",12) == 80821291) strcat(s, "h");
if (crc32("kzmIESCwFDtde",13) == 1371587636) strcat(s, "e");
if (crc32("NkGdaIyKN",9) == 4103509665) strcat(s, "n");
if (crc32("eLPVBWRQsJYq",12) == 774444310) strcat(s, "t");
if (crc32("rhVWYPnD",8) == 1998995125) strcat(s, "I");
if (crc32("OPuIGcYKRUwN",12) == 1140903285) strcat(s, "r");
if (crc32("rCoEQBJnnehO",12) == 1419574308) strcat(s, "a");
if (crc32("EYifdRPCYbXHKaX",15) == 2216318895) strcat(s, "a");
if (crc32("MBYCBwhD",8) == 2362088934) strcat(s, "l");
if (crc32("fHVcKd",6) == 792743496) strcat(s, "c");
if (crc32("xGudNFKrGft",11) == 2410623491) strcat(s, "i");
if (crc32("zjKYSxgbMwhQ",12) == 3731643208) strcat(s, "K");
if (crc32("hRnrqLupgOS",11) == 3862301877) strcat(s, "z");
if (crc32("aatRYClZGLXySux",15) == 436792614) strcat(s, "e");
    return s;
}

char *rebreeding_verbs() {
    char *s = calloc(11);
    if (crc32("pJxISixhVETE",12) == 926223081) strcat(s, "r");
if (crc32("zVVWLYTk",8) == 4266370231) strcat(s, "e");
if (crc32("OJxHhxccNKSJgLE",15) == 3588669912) strcat(s, "b");
if (crc32("BiiLNeKooMykNUb",15) == 3226698640) strcat(s, "r");
if (crc32("NYknqxVGeLMNJs",14) == 3677036872) strcat(s, "r");
if (crc32("eZtpqJLcYrYH",12) == 2326991354) strcat(s, "e");
if (crc32("kFpGNgNePi",10) == 3348897537) strcat(s, "g");
if (crc32("vYpDawxjuCo",11) == 2547615721) strcat(s, "e");
if (crc32("JcQRDyljl",9) == 380304405) strcat(s, "d");
if (crc32("zkoYQBW",7) == 328816869) strcat(s, "d");
if (crc32("PtnTkqWD",8) == 3927040969) strcat(s, "i");
if (crc32("dQzDatb",7) == 4204127426) strcat(s, "R");
if (crc32("xSKvELwCbcs",11) == 734553781) strcat(s, "n");
if (crc32("Bldxhz",6) == 1743075415) strcat(s, "E");
if (crc32("lbrBFenLmgn",11) == 422401746) strcat(s, "g");
    return s;
}

char *overexpand_verbs() {
    char *s = calloc(11);
    if (crc32("yMIuqrQFVYLWH",13) == 1185269497) strcat(s, "x");
if (crc32("RxGjeZQQFfKE",12) == 1615728644) strcat(s, "o");
if (crc32("ThDTMMLTlhRpDOl",15) == 979306364) strcat(s, "C");
if (crc32("CvETuFMt",8) == 3855034387) strcat(s, "v");
if (crc32("GsVgHnIU",8) == 1282169171) strcat(s, "e");
if (crc32("ICqcJZaqudNILAj",15) == 3463460060) strcat(s, "r");
if (crc32("BvxbJVBheS",10) == 2110002816) strcat(s, "G");
if (crc32("caHhfm",6) == 2201008420) strcat(s, "e");
if (crc32("EryfQqkujeWh",12) == 2096643957) strcat(s, "x");
if (crc32("HcsuERLoEuCzUO",14) == 1962401466) strcat(s, "p");
if (crc32("fGicAfNWjoU",11) == 818462389) strcat(s, "a");
if (crc32("FxhmL",5) == 1457999950) strcat(s, "n");
if (crc32("PXEJoI",6) == 3924084948) strcat(s, "L");
if (crc32("iyHmxbLwjK",10) == 2021847003) strcat(s, "d");
    return s;
}

char *rebalancing_verbs() {
    char *s = calloc(12);
    if (crc32("UlGpvoLfpwrhtum",15) == 2238979828) strcat(s, "r");
if (crc32("SEDfK",5) == 2959186732) strcat(s, "e");
if (crc32("queqan",6) == 1371702559) strcat(s, "q");
if (crc32("FrBmCO",6) == 2817815423) strcat(s, "b");
if (crc32("bmOHjcyoN",9) == 1544223318) strcat(s, "a");
if (crc32("trnuiF",6) == 974798001) strcat(s, "U");
if (crc32("kdhkaEywwiy",11) == 375536253) strcat(s, "l");
if (crc32("PwqDusKip",9) == 1012268426) strcat(s, "a");
if (crc32("VPoBZkOxLFdGXD",14) == 2560848530) strcat(s, "R");
if (crc32("UhFmdmEVghH",11) == 1801801076) strcat(s, "n");
if (crc32("rzPxsjXwwr",10) == 3245840938) strcat(s, "I");
if (crc32("HbJHPW",6) == 1957687469) strcat(s, "c");
if (crc32("CmRsjKt",7) == 1344975437) strcat(s, "F");
if (crc32("rhPFgQlyUZ",10) == 4065361644) strcat(s, "i");
if (crc32("nQmPyQG",7) == 1000367155) strcat(s, "n");
if (crc32("peGVZxF",7) == 810702385) strcat(s, "F");
if (crc32("uFcgfyppvjfBjV",14) == 978161781) strcat(s, "g");
    return s;
}

char *depasture_verbs() {
    char *s = calloc(10);
    if (crc32("XBiuvHwfLYCdO",13) == 2346137646) strcat(s, "d");
if (crc32("qoevTkiDD",9) == 2415467167) strcat(s, "e");
if (crc32("zunPqHo",7) == 3540693316) strcat(s, "p");
if (crc32("uyusmwHpmAbzHoO",15) == 2808849711) strcat(s, "a");
if (crc32("OVBsfDSlHALexWg",15) == 2654348416) strcat(s, "U");
if (crc32("hGUgrsvxv",9) == 2995948252) strcat(s, "s");
if (crc32("qzoLVgcdrimp",12) == 4178671184) strcat(s, "t");
if (crc32("mtjOSccoKHH",11) == 22668674) strcat(s, "m");
if (crc32("mGToaCP",7) == 850176756) strcat(s, "u");
if (crc32("MkyWkBRXHYeH",12) == 2213990332) strcat(s, "P");
if (crc32("ETciY",5) == 4266128406) strcat(s, "r");
if (crc32("vuaZhLDcJXpjAr",14) == 1078189197) strcat(s, "g");
if (crc32("tazrVaI",7) == 794859024) strcat(s, "e");
    return s;
}

char *steamup_verbs() {
    char *s = calloc(8);
    if (crc32("QUuOKxNYTrK",11) == 2685052400) strcat(s, "s");
if (crc32("csFBPYEIxHDKZY",14) == 367038950) strcat(s, "t");
if (crc32("haSCjOEfWROn",12) == 703458222) strcat(s, "t");
if (crc32("lKpDRhfLsxstzn",14) == 2982520598) strcat(s, "e");
if (crc32("MibxQqAHQjsKboh",15) == 681298670) strcat(s, "a");
if (crc32("ZLAlxdHuaaTVedj",15) == 3531100453) strcat(s, "Q");
if (crc32("JYPqwwIkTO",10) == 1814419178) strcat(s, "m");
if (crc32("ixSXuM",6) == 3064544229) strcat(s, "u");
if (crc32("HGfXR",5) == 1637979281) strcat(s, "i");
if (crc32("QKIxecKuLkmA",12) == 847694111) strcat(s, "p");
    return s;
}

char *overchafing_verbs() {
    char *s = calloc(12);
    if (crc32("PmvmfcQgopR",11) == 1239575842) strcat(s, "O");
if (crc32("QKjrZhkdevah",12) == 549933706) strcat(s, "o");
if (crc32("IEKEUVl",7) == 1376882342) strcat(s, "v");
if (crc32("rBmAFT",6) == 2804593415) strcat(s, "e");
if (crc32("duwwWRocpqrh",12) == 4082548194) strcat(s, "r");
if (crc32("wlnSEzWjpxV",11) == 1802544091) strcat(s, "c");
if (crc32("YMBdXqlu",8) == 4051004794) strcat(s, "H");
if (crc32("qwuLMLz",7) == 3053074202) strcat(s, "h");
if (crc32("OxBORVKqZza",11) == 2812677599) strcat(s, "Q");
if (crc32("IiAger",6) == 3305538100) strcat(s, "a");
if (crc32("fZCjgY",6) == 1888509601) strcat(s, "i");
if (crc32("DXgdkobNWP",10) == 342751158) strcat(s, "f");
if (crc32("KsTRteLUlzwut",13) == 2500912613) strcat(s, "i");
if (crc32("QGTPonXGJKVjp",13) == 1397522648) strcat(s, "n");
if (crc32("UoviZm",6) == 3456253118) strcat(s, "g");
if (crc32("OYNTIVOYbQBCH",13) == 942581192) strcat(s, "g");
    return s;
}

char *dangle_verbs() {
    char *s = calloc(7);
    if (crc32("bwVnMiSnBXZcTER",15) == 278257112) strcat(s, "k");
if (crc32("LQJGNAKDFnx",11) == 3006638677) strcat(s, "d");
if (crc32("skErMWeIWRuRLWf",15) == 3529458648) strcat(s, "a");
if (crc32("LgIgOFxpcYTH",12) == 2877176792) strcat(s, "I");
if (crc32("DvTyjZUlFf",10) == 1004406619) strcat(s, "n");
if (crc32("RpxxMu",6) == 2655032003) strcat(s, "F");
if (crc32("bYesMkbf",8) == 2030877012) strcat(s, "g");
if (crc32("ovgamZcZqHmF",12) == 2647221387) strcat(s, "l");
if (crc32("joQgif",6) == 755551458) strcat(s, "e");
    return s;
}

char *remould_verbs() {
    char *s = calloc(8);
    if (crc32("fdCYmvXBRzSeI",13) == 704978469) strcat(s, "r");
if (crc32("RSyGkTJErMb",11) == 2935689967) strcat(s, "h");
if (crc32("deMSahxR",8) == 2208659227) strcat(s, "e");
if (crc32("MJlPVwSpKRgWds",14) == 956603559) strcat(s, "u");
if (crc32("xxPAe",5) == 420286787) strcat(s, "m");
if (crc32("NVILDJkqg",9) == 4120553451) strcat(s, "v");
if (crc32("myZPTYcFxmFf",12) == 1185410467) strcat(s, "o");
if (crc32("cVWPROv",7) == 316488223) strcat(s, "H");
if (crc32("UFArybYPlC",10) == 3154411195) strcat(s, "u");
if (crc32("nzPAooKTdQcfjL",14) == 773320102) strcat(s, "l");
if (crc32("wtNXRaycTtn",11) == 3430058016) strcat(s, "h");
if (crc32("BXlmEgnWaK",10) == 2249166381) strcat(s, "d");
    return s;
}

char *ruralizing_verbs() {
    char *s = calloc(11);
    if (crc32("WKunLMTJnIy",11) == 1534260381) strcat(s, "N");
if (crc32("OuZhepGEEYIjRoN",15) == 374407092) strcat(s, "r");
if (crc32("rucZX",5) == 1990462845) strcat(s, "u");
if (crc32("QQXMivChA",9) == 939104444) strcat(s, "w");
if (crc32("COovYyc",7) == 178057373) strcat(s, "r");
if (crc32("fPZcXF",6) == 1417685865) strcat(s, "a");
if (crc32("fqoQnU",6) == 740243602) strcat(s, "y");
if (crc32("amanDUu",7) == 3948696536) strcat(s, "l");
if (crc32("qBmkQTSLyyzRw",13) == 531249053) strcat(s, "y");
if (crc32("XgbtVgs",7) == 344578894) strcat(s, "i");
if (crc32("hlucBqvJ",8) == 2944209897) strcat(s, "S");
if (crc32("VMoKSWZnN",9) == 1876966933) strcat(s, "z");
if (crc32("zIOPHQMGgxBqPv",14) == 196858566) strcat(s, "K");
if (crc32("TBdLDHitYRVGoj",14) == 1571847442) strcat(s, "i");
if (crc32("CTQIwQcubSERVd",14) == 495525484) strcat(s, "s");
if (crc32("QkyPhYFatKxOTh",14) == 1783200313) strcat(s, "n");
if (crc32("hRUkwALA",8) == 3805022587) strcat(s, "x");
if (crc32("kHRMOFqKXfdV",12) == 635677029) strcat(s, "g");
    return s;
}

char *filtrating_verbs() {
    char *s = calloc(11);
    if (crc32("JwXdZfhwT",9) == 3968470011) strcat(s, "r");
if (crc32("uwpWfuDWlwQE",12) == 3274259625) strcat(s, "f");
if (crc32("ymnHrIFlcdhhpy",14) == 1951906874) strcat(s, "L");
if (crc32("EHiVAR",6) == 3301740003) strcat(s, "i");
if (crc32("xIJsB",5) == 2111732120) strcat(s, "Y");
if (crc32("jLmqJDi",7) == 2775001388) strcat(s, "l");
if (crc32("IXOaK",5) == 2069291627) strcat(s, "t");
if (crc32("UrFHC",5) == 1418066916) strcat(s, "r");
if (crc32("biIiQMSXycrxd",13) == 2768630355) strcat(s, "m");
if (crc32("rNHGDG",6) == 1194548964) strcat(s, "a");
if (crc32("jQzFSdHAPGaW",12) == 1503281219) strcat(s, "t");
if (crc32("NVabXALGYVQplwy",15) == 3417154032) strcat(s, "J");
if (crc32("TlAsybQSa",9) == 2190022250) strcat(s, "i");
if (crc32("PbZwvGLenWWSo",13) == 3272931808) strcat(s, "p");
if (crc32("NTPQHO",6) == 833843613) strcat(s, "n");
if (crc32("qUzpnaaTs",9) == 3935446653) strcat(s, "X");
if (crc32("OawyvwYGOZU",11) == 3171145762) strcat(s, "g");
    return s;
}

char *tasselling_verbs() {
    char *s = calloc(11);
    if (crc32("FRLoOFZeTkm",11) == 307258222) strcat(s, "t");
if (crc32("kqzYISKmjKbJbk",14) == 4292990791) strcat(s, "X");
if (crc32("YKxvXRw",7) == 3976952250) strcat(s, "a");
if (crc32("oIyIYgQLrb",10) == 1741475271) strcat(s, "s");
if (crc32("UgImB",5) == 2817194757) strcat(s, "s");
if (crc32("tkfvmOTGZmlql",13) == 2140921796) strcat(s, "e");
if (crc32("rGijPjGetIXArPP",15) == 4062554173) strcat(s, "m");
if (crc32("LlQzFuCehZeaG",13) == 3994163406) strcat(s, "l");
if (crc32("RBUtiqrkCyZVx",13) == 524239884) strcat(s, "l");
if (crc32("dLpmiRspYilm",12) == 676215778) strcat(s, "k");
if (crc32("AQQgDenohvaHEH",14) == 2754961276) strcat(s, "i");
if (crc32("KszFEkAPe",9) == 3124193073) strcat(s, "G");
if (crc32("LlHlcfwKpecb",12) == 1677792996) strcat(s, "n");
if (crc32("AEWgXiZBSgnR",12) == 3912643556) strcat(s, "g");
    return s;
}

char *pledging_verbs() {
    char *s = calloc(9);
    if (crc32("NaLCLZEqA",9) == 2657232837) strcat(s, "p");
if (crc32("mtaypakXGjTUMS",14) == 3390224787) strcat(s, "J");
if (crc32("kCKbwPTbCshEPUU",15) == 1983725081) strcat(s, "l");
if (crc32("UXgyDCCga",9) == 2083799275) strcat(s, "e");
if (crc32("uCsvzGxm",8) == 2867294431) strcat(s, "d");
if (crc32("dPCmiHJIE",9) == 3799450749) strcat(s, "U");
if (crc32("nmjDbaOandYyma",14) == 1630521732) strcat(s, "g");
if (crc32("DuVVCO",6) == 3775408088) strcat(s, "x");
if (crc32("zgvVp",5) == 1059676101) strcat(s, "i");
if (crc32("gNovVQ",6) == 2151944302) strcat(s, "n");
if (crc32("PQWsAmwzMoCoXbM",15) == 1795781436) strcat(s, "g");
if (crc32("wUARMdMrXqh",11) == 4249299872) strcat(s, "g");
    return s;
}

char *convert_verbs() {
    char *s = calloc(8);
    if (crc32("ZUTPdQHkB",9) == 3671793872) strcat(s, "v");
if (crc32("FiXZzZvHxa",10) == 3021737505) strcat(s, "c");
if (crc32("JLFPy",5) == 3805689294) strcat(s, "o");
if (crc32("IZaVLFPDGvCiB",13) == 1552871997) strcat(s, "n");
if (crc32("MdaOnbE",7) == 1082257886) strcat(s, "F");
if (crc32("mqAiLqkVpIbxlXQ",15) == 3846200209) strcat(s, "v");
if (crc32("UAPGiKOVcj",10) == 2634331261) strcat(s, "I");
if (crc32("iwFVxlBvCVqe",12) == 1712779920) strcat(s, "e");
if (crc32("rytXrQwnAmLlL",13) == 3899173791) strcat(s, "L");
if (crc32("xJcYMW",6) == 3201750570) strcat(s, "r");
if (crc32("xFUYpVaJ",8) == 3186434311) strcat(s, "t");
    return s;
}

char *guard_verbs() {
    char *s = calloc(6);
    if (crc32("VTOpihjkg",9) == 4116913038) strcat(s, "g");
if (crc32("SnOmz",5) == 2427279319) strcat(s, "N");
if (crc32("UtbtNYpBIYYEkg",14) == 727028663) strcat(s, "u");
if (crc32("MkOezAYFIxOC",12) == 2178874928) strcat(s, "n");
if (crc32("SuIrBscblVD",11) == 3422356369) strcat(s, "a");
if (crc32("zljekyzLqze",11) == 2542839729) strcat(s, "r");
if (crc32("vaAFGtgJo",9) == 3590401049) strcat(s, "d");
    return s;
}

char *attenuated_verbs() {
    char *s = calloc(11);
    if (crc32("lcTedUTQPPYTK",13) == 2566067375) strcat(s, "a");
if (crc32("yHEsHDHXKubmU",13) == 1629077053) strcat(s, "u");
if (crc32("bCDHmVgPQuPPahe",15) == 4248585824) strcat(s, "t");
if (crc32("OWCMwZ",6) == 3755783258) strcat(s, "t");
if (crc32("lBGmDogmACa",11) == 37481669) strcat(s, "N");
if (crc32("izbURgGDtxXc",12) == 3241075173) strcat(s, "e");
if (crc32("eEZqLfLJsomKdd",14) == 3441999390) strcat(s, "n");
if (crc32("eLohGwKHTlnI",12) == 1876438389) strcat(s, "D");
if (crc32("IpMllR",6) == 81378335) strcat(s, "u");
if (crc32("VBHmvAp",7) == 678090427) strcat(s, "A");
if (crc32("ubrtoSdHaWvNCG",14) == 1359157930) strcat(s, "a");
if (crc32("RJTgZRQWSro",11) == 216646281) strcat(s, "t");
if (crc32("nTKSRPeqPqo",11) == 3820263036) strcat(s, "e");
if (crc32("aKghEX",6) == 1438786464) strcat(s, "d");
    return s;
}

char *playalong_verbs() {
    char *s = calloc(10);
    if (crc32("IpYhGqFkQ",9) == 3181408493) strcat(s, "p");
if (crc32("BhYWfMB",7) == 1490619102) strcat(s, "l");
if (crc32("hWpBskmJWIzEJ",13) == 1498006698) strcat(s, "a");
if (crc32("GGtZXpR",7) == 1854550450) strcat(s, "y");
if (crc32("XHHQERTxPAPaY",13) == 4201966370) strcat(s, "a");
if (crc32("aRFiLQxMZYHKdP",14) == 909993991) strcat(s, "l");
if (crc32("mtUZjHhBipqo",12) == 286843892) strcat(s, "E");
if (crc32("ELAknE",6) == 3921045403) strcat(s, "o");
if (crc32("IHMvSo",6) == 2099021116) strcat(s, "q");
if (crc32("alTARBmXj",9) == 3574541220) strcat(s, "n");
if (crc32("AXPIcC",6) == 1759931843) strcat(s, "g");
    return s;
}

char *suffice_verbs() {
    char *s = calloc(8);
    if (crc32("uJnEj",5) == 1637479895) strcat(s, "s");
if (crc32("zNBpcIIIdvxY",12) == 3092255021) strcat(s, "u");
if (crc32("HQDoeqA",7) == 3884043303) strcat(s, "S");
if (crc32("Rxaau",5) == 1072078215) strcat(s, "f");
if (crc32("MkfDNxPlaW",10) == 3640155519) strcat(s, "b");
if (crc32("BtGeixPpr",9) == 549695298) strcat(s, "f");
if (crc32("xMBPunsXmVkdVZ",14) == 661750602) strcat(s, "i");
if (crc32("qllMQIKjYkUyKL",14) == 1941405779) strcat(s, "c");
if (crc32("JflitghcMjhiE",13) == 1109751789) strcat(s, "E");
if (crc32("FmJPBcK",7) == 190002465) strcat(s, "e");
    return s;
}

char *swat_verbs() {
    char *s = calloc(5);
    if (crc32("ZNbMPhwZzOyMnL",14) == 3725269371) strcat(s, "B");
if (crc32("scoUDBOdLrwale",14) == 4281802444) strcat(s, "s");
if (crc32("YyHPwjTDtYHXEq",14) == 2752842124) strcat(s, "w");
if (crc32("NHLcRmVcNQT",11) == 794053812) strcat(s, "a");
if (crc32("lTgYrcPvbyvaxGR",15) == 3207248223) strcat(s, "E");
if (crc32("MnwjSyURE",9) == 31308913) strcat(s, "t");
    return s;
}

char *legislating_verbs() {
    char *s = calloc(12);
    if (crc32("jhxnrbZeYBdJSg",14) == 3837779841) strcat(s, "l");
if (crc32("GIalxOCHAoXc",12) == 1427828363) strcat(s, "L");
if (crc32("LqFzOLBtVc",10) == 512527162) strcat(s, "e");
if (crc32("mBlTllcsuEny",12) == 2975349594) strcat(s, "h");
if (crc32("WoEDiueSFlISBhF",15) == 3897745978) strcat(s, "g");
if (crc32("yEkfxODbmNPNBZ",14) == 2919395306) strcat(s, "G");
if (crc32("VMpcmJDm",8) == 357597665) strcat(s, "i");
if (crc32("cWKbubBcfRTJDM",14) == 3741314444) strcat(s, "O");
if (crc32("WGTFDmYDxIlq",12) == 805058694) strcat(s, "s");
if (crc32("sYhCwjDUg",9) == 674966109) strcat(s, "l");
if (crc32("DBYLTPdysBrMwX",14) == 2631678207) strcat(s, "B");
if (crc32("cxOOSEQrKuGynH",14) == 1759369709) strcat(s, "a");
if (crc32("gHlZHz",6) == 1785141055) strcat(s, "n");
if (crc32("TLEWS",5) == 2881158501) strcat(s, "t");
if (crc32("jxNkdCa",7) == 4026596263) strcat(s, "i");
if (crc32("duDSzQrlMPze",12) == 3688118333) strcat(s, "I");
if (crc32("IhoPRq",6) == 2426499346) strcat(s, "n");
if (crc32("JJxFCMaS",8) == 3092796051) strcat(s, "P");
if (crc32("uVoAKdyblHeckHv",15) == 1312276595) strcat(s, "g");
    return s;
}

char *waggle_verbs() {
    char *s = calloc(7);
    if (crc32("UrVhUeBd",8) == 1255754290) strcat(s, "w");
if (crc32("CXMrj",5) == 535068520) strcat(s, "a");
if (crc32("YuMIlceEIS",10) == 3632259947) strcat(s, "H");
if (crc32("TeCwg",5) == 3325931892) strcat(s, "g");
if (crc32("JXEeHnXtwXvJ",12) == 3531004851) strcat(s, "y");
if (crc32("kYrHSaW",7) == 100488059) strcat(s, "g");
if (crc32("DXyCdVqJJGqJ",12) == 2152122484) strcat(s, "l");
if (crc32("oyFGHpRop",9) == 1034872169) strcat(s, "e");
    return s;
}

char *ammonolyzing_verbs() {
    char *s = calloc(13);
    if (crc32("dHHSqZJG",8) == 1210455362) strcat(s, "u");
if (crc32("MUJvCoXxJM",10) == 1138804530) strcat(s, "a");
if (crc32("ZAfCpzwFNV",10) == 830449113) strcat(s, "m");
if (crc32("MuEZqF",6) == 2836386055) strcat(s, "Y");
if (crc32("GfkapHyYTRSCz",13) == 3027634894) strcat(s, "m");
if (crc32("vuywEJHeFoSLm",13) == 2207845289) strcat(s, "H");
if (crc32("oPCSXRqHoK",10) == 141861401) strcat(s, "o");
if (crc32("oIvNrCZL",8) == 186037963) strcat(s, "n");
if (crc32("UOCBpmtSaWpr",12) == 1072736831) strcat(s, "n");
if (crc32("FPHQwY",6) == 298300717) strcat(s, "o");
if (crc32("JzUHGKLH",8) == 1982176387) strcat(s, "P");
if (crc32("ffhqujg",7) == 3482873086) strcat(s, "l");
if (crc32("IlOMORHyOAj",11) == 1367989820) strcat(s, "v");
if (crc32("mZZIPB",6) == 2392411692) strcat(s, "y");
if (crc32("eipfix",6) == 2958890136) strcat(s, "z");
if (crc32("BSAWYdNrB",9) == 1085004644) strcat(s, "i");
if (crc32("QroMdPQ",7) == 3308367361) strcat(s, "n");
if (crc32("iEgrxLRPNLOmuh",14) == 1535116811) strcat(s, "n");
if (crc32("jfxwPGaOyyeSN",13) == 2182966604) strcat(s, "g");
    return s;
}

char *reacidifying_verbs() {
    char *s = calloc(13);
    if (crc32("NAIfhioa",8) == 3827868119) strcat(s, "r");
if (crc32("cnCEUmjNxjclK",13) == 4046507027) strcat(s, "b");
if (crc32("Boznd",5) == 1871910287) strcat(s, "e");
if (crc32("iAhjJICGeJahPyS",15) == 3577085811) strcat(s, "i");
if (crc32("nGHyCi",6) == 2203430375) strcat(s, "a");
if (crc32("QURdxfMjhmL",11) == 1877123364) strcat(s, "I");
if (crc32("LUZbpIl",7) == 2420506810) strcat(s, "c");
if (crc32("qIisRtHWErEJN",13) == 2175627350) strcat(s, "u");
if (crc32("LeDHFjSL",8) == 722958912) strcat(s, "i");
if (crc32("XkebLUOA",8) == 1971631204) strcat(s, "p");
if (crc32("PqNBr",5) == 737305202) strcat(s, "d");
if (crc32("ZlKjtOvPyYhJFb",14) == 3879836875) strcat(s, "i");
if (crc32("jfaCNMsuRqozvL",14) == 1474524504) strcat(s, "i");
if (crc32("SQZvLDSMk",9) == 635015460) strcat(s, "p");
if (crc32("twMgNcMIjZGN",12) == 2739337104) strcat(s, "f");
if (crc32("KbHnHhyTjP",10) == 627107236) strcat(s, "o");
if (crc32("VuXOmSUqm",9) == 982451830) strcat(s, "y");
if (crc32("qvNaGZYuktTotJ",14) == 332833907) strcat(s, "g");
if (crc32("COMQqRRhnB",10) == 1725387991) strcat(s, "i");
if (crc32("nMepETEjmDujvmZ",15) == 1341393448) strcat(s, "Q");
if (crc32("mvVOmrptWdwbJjn",15) == 3326902453) strcat(s, "n");
if (crc32("fuuixLiaAvNNa",13) == 2048954076) strcat(s, "J");
if (crc32("rSMmKwfXyTL",11) == 1235503553) strcat(s, "g");
    return s;
}

char *advising_verbs() {
    char *s = calloc(9);
    if (crc32("lxnnpvyNbOUpi",13) == 4083867361) strcat(s, "a");
if (crc32("nEeht",5) == 2835964769) strcat(s, "U");
if (crc32("gnnVjJEGGlwh",12) == 2614374320) strcat(s, "d");
if (crc32("IMXjRv",6) == 1139074203) strcat(s, "v");
if (crc32("VjGjRfCarNEg",12) == 2563951841) strcat(s, "i");
if (crc32("nIuIuswQDZO",11) == 1567451100) strcat(s, "s");
if (crc32("bnsbZOA",7) == 2641170190) strcat(s, "m");
if (crc32("HKEuKD",6) == 3777384713) strcat(s, "i");
if (crc32("IhflwkPmIu",10) == 1310700806) strcat(s, "n");
if (crc32("uwBFL",5) == 2880420881) strcat(s, "g");
    return s;
}

char *contributing_verbs() {
    char *s = calloc(13);
    if (crc32("lHIQb",5) == 549266532) strcat(s, "v");
if (crc32("bhmctSzLhr",10) == 2713600954) strcat(s, "c");
if (crc32("bftOJaXHOf",10) == 707380618) strcat(s, "o");
if (crc32("dMwRDbaZLbv",11) == 3520779892) strcat(s, "F");
if (crc32("DtkpdzP",7) == 3374548087) strcat(s, "n");
if (crc32("mysTocwDtM",10) == 2342733083) strcat(s, "t");
if (crc32("sCklN",5) == 1946865271) strcat(s, "M");
if (crc32("jIOKLdvSRwbyDP",14) == 3222896422) strcat(s, "r");
if (crc32("HsEMxDyW",8) == 1875271719) strcat(s, "i");
if (crc32("lvSHIvHKY",9) == 2740183996) strcat(s, "b");
if (crc32("lHEGIfiNIMFg",12) == 51146116) strcat(s, "j");
if (crc32("QSBwFIgAauWnQcz",15) == 52814641) strcat(s, "u");
if (crc32("YVsOwLTLo",9) == 4168829499) strcat(s, "t");
if (crc32("sUSQRfZ",7) == 3347898181) strcat(s, "i");
if (crc32("rlFzUzWVROVHyW",14) == 2827926386) strcat(s, "n");
if (crc32("ZaDRHFGcZzt",11) == 3589831766) strcat(s, "g");
    return s;
}

char *starving_verbs() {
    char *s = calloc(9);
    if (crc32("NusrxvPgDZIM",12) == 83561687) strcat(s, "f");
if (crc32("fWQPOSWCf",9) == 181564385) strcat(s, "s");
if (crc32("dcUIEdCdIo",10) == 2557039127) strcat(s, "S");
if (crc32("vxmozuoBAjGjsx",14) == 3656986405) strcat(s, "t");
if (crc32("StRuWKVh",8) == 352143009) strcat(s, "r");
if (crc32("OkPpqZABfQE",11) == 2214202493) strcat(s, "a");
if (crc32("iwxhnLNIP",9) == 3003786837) strcat(s, "T");
if (crc32("DCXQsk",6) == 2280471151) strcat(s, "r");
if (crc32("gwNwDQutCQ",10) == 137405598) strcat(s, "v");
if (crc32("HesaZAKbFVcyM",13) == 2235676117) strcat(s, "i");
if (crc32("torQJECx",8) == 1949115396) strcat(s, "n");
if (crc32("LkVXDwPLqgpovsh",15) == 4244778994) strcat(s, "o");
if (crc32("bHatCJrhc",9) == 377920481) strcat(s, "g");
    return s;
}

char *honeying_verbs() {
    char *s = calloc(9);
    if (crc32("OPhioXdgo",9) == 2282902058) strcat(s, "h");
if (crc32("CspdZlKJQK",10) == 2009339426) strcat(s, "u");
if (crc32("DBjvLtxMq",9) == 3172709835) strcat(s, "o");
if (crc32("lUHKNyGGyayXaJ",14) == 3367968280) strcat(s, "n");
if (crc32("AUKME",5) == 1624022786) strcat(s, "e");
if (crc32("CfWKf",5) == 429070285) strcat(s, "y");
if (crc32("TIOJoC",6) == 3237279301) strcat(s, "i");
if (crc32("iyZDxJOtp",9) == 3944825613) strcat(s, "n");
if (crc32("CkrQTTYrVnRb",12) == 4046709117) strcat(s, "g");
    return s;
}

char *drummed_verbs() {
    char *s = calloc(8);
    if (crc32("WrjhGNASOWBynzN",15) == 2776695094) strcat(s, "Z");
if (crc32("kegFpOcAApm",11) == 2054459664) strcat(s, "d");
if (crc32("RySCgCxJJ",9) == 3743492373) strcat(s, "Y");
if (crc32("ZcsulwNcLL",10) == 2464484946) strcat(s, "r");
if (crc32("KiqoXQMNG",9) == 1124405266) strcat(s, "u");
if (crc32("dJsvYkC",7) == 3066121380) strcat(s, "m");
if (crc32("FJOqCLAR",8) == 3425796633) strcat(s, "m");
if (crc32("cXwxHxEJvzlf",12) == 2869483001) strcat(s, "e");
if (crc32("uepEwKJw",8) == 4008190315) strcat(s, "V");
if (crc32("UfKZWmyTs",9) == 752182453) strcat(s, "d");
    return s;
}

char *shakedown_verbs() {
    char *s = calloc(10);
    if (crc32("EuZvUWZVUc",10) == 2308645891) strcat(s, "a");
if (crc32("wKjETvgnekm",11) == 1944609583) strcat(s, "s");
if (crc32("lKmiDzDegIR",11) == 1739262819) strcat(s, "h");
if (crc32("MVqQeysdsvcZaJw",15) == 3208173712) strcat(s, "a");
if (crc32("qsYsqujZ",8) == 958897224) strcat(s, "n");
if (crc32("jdlPuXQM",8) == 2304144792) strcat(s, "k");
if (crc32("UzpGwKCPB",9) == 1245436578) strcat(s, "e");
if (crc32("MQwwoRBT",8) == 2918796817) strcat(s, "d");
if (crc32("qXJUUmOTYrFW",12) == 3246159154) strcat(s, "o");
if (crc32("AYATGWFX",8) == 4018872135) strcat(s, "E");
if (crc32("ryoIZlItJAT",11) == 3285841067) strcat(s, "w");
if (crc32("OEMCOUsbWqzoh",13) == 1029403522) strcat(s, "C");
if (crc32("AiylkGaCObn",11) == 3136265313) strcat(s, "n");
    return s;
}

char *preacquired_verbs() {
    char *s = calloc(12);
    if (crc32("JfOdYt",6) == 3292184784) strcat(s, "l");
if (crc32("sMDdHCqDDC",10) == 546292746) strcat(s, "p");
if (crc32("EkLdsHmcnKKKgzI",15) == 2997121377) strcat(s, "r");
if (crc32("yFEdKtkd",8) == 2921393573) strcat(s, "m");
if (crc32("FEeanDt",7) == 3059660215) strcat(s, "e");
if (crc32("juvCD",5) == 3017295346) strcat(s, "a");
if (crc32("NUMDSlPm",8) == 2730254036) strcat(s, "H");
if (crc32("PZfJZVijDgUE",12) == 2868176977) strcat(s, "c");
if (crc32("DJIgjHBUZV",10) == 528412638) strcat(s, "q");
if (crc32("FTYlkfvjGCuBU",13) == 3811197053) strcat(s, "u");
if (crc32("SGuqqz",6) == 2656926432) strcat(s, "B");
if (crc32("MrfZu",5) == 2333508621) strcat(s, "i");
if (crc32("tZDyUye",7) == 977840763) strcat(s, "r");
if (crc32("mgYDTOPea",9) == 1348311068) strcat(s, "x");
if (crc32("sOguFVnQGzYkBR",14) == 3360322668) strcat(s, "e");
if (crc32("hwlLNkCHQwEKvfW",15) == 502262477) strcat(s, "d");
    return s;
}

char *wrapup_verbs() {
    char *s = calloc(7);
    if (crc32("okQoD",5) == 1443825666) strcat(s, "t");
if (crc32("qWxpDAuLI",9) == 96090173) strcat(s, "w");
if (crc32("QngrkVpHaaCi",12) == 3092714250) strcat(s, "r");
if (crc32("PKnGXNXeLbZ",11) == 1184664513) strcat(s, "a");
if (crc32("XVOyVngK",8) == 3467969212) strcat(s, "p");
if (crc32("PifSxdKR",8) == 3877680561) strcat(s, "I");
if (crc32("uLCZtFdRPCMzwj",14) == 431048144) strcat(s, "u");
if (crc32("LfvCk",5) == 337926782) strcat(s, "p");
    return s;
}

char *immerge_verbs() {
    char *s = calloc(8);
    if (crc32("uVcDzwCE",8) == 3599289490) strcat(s, "l");
if (crc32("joqLQTe",7) == 3490256544) strcat(s, "i");
if (crc32("lfxPLoogIcX",11) == 1075451543) strcat(s, "s");
if (crc32("HseybLHlzMPHG",13) == 4064022231) strcat(s, "m");
if (crc32("rbViJOe",7) == 2909433094) strcat(s, "m");
if (crc32("fXueeB",6) == 4121505749) strcat(s, "m");
if (crc32("cgNib",5) == 2109136444) strcat(s, "d");
if (crc32("SJOCGuWBmmLJS",13) == 2187776261) strcat(s, "e");
if (crc32("lLfNn",5) == 3119736891) strcat(s, "a");
if (crc32("QWacjckCoeCDmZ",14) == 862024439) strcat(s, "r");
if (crc32("BwPYSSlTEYYlg",13) == 1040849434) strcat(s, "J");
if (crc32("WODiBIPEHTEeP",13) == 3786641554) strcat(s, "g");
if (crc32("XsRJNuHbzQB",11) == 2216565690) strcat(s, "e");
    return s;
}

char *neutralize_verbs() {
    char *s = calloc(11);
    if (crc32("NansIMyMdrNjPW",14) == 706243004) strcat(s, "H");
if (crc32("jxZELM",6) == 1464843096) strcat(s, "n");
if (crc32("bMidQa",6) == 2238333814) strcat(s, "M");
if (crc32("ixooT",5) == 828572874) strcat(s, "e");
if (crc32("OPTpsKxKH",9) == 1658305033) strcat(s, "A");
if (crc32("fcLcnnxDYULOYSc",15) == 2253023682) strcat(s, "u");
if (crc32("JFDXgYdiMDh",11) == 692781744) strcat(s, "t");
if (crc32("HfEFrhPcDQnVS",13) == 3922215168) strcat(s, "r");
if (crc32("XIybjPJUmVZ",11) == 78709006) strcat(s, "R");
if (crc32("cVmYYRTzx",9) == 1710400281) strcat(s, "a");
if (crc32("SGVaYswNmim",11) == 3252350445) strcat(s, "A");
if (crc32("eaoXODZieuc",11) == 2882589773) strcat(s, "l");
if (crc32("qIkezRk",7) == 380990632) strcat(s, "i");
if (crc32("ZMlABXNaKTCmiQ",14) == 1868189767) strcat(s, "z");
if (crc32("LgmPbcPb",8) == 465681982) strcat(s, "e");
    return s;
}

char *posed_verbs() {
    char *s = calloc(6);
    if (crc32("HwkiQOLiJf",10) == 1282954471) strcat(s, "p");
if (crc32("AsJObKX",7) == 2025769492) strcat(s, "b");
if (crc32("JAxYiNP",7) == 2216887414) strcat(s, "o");
if (crc32("DLSkOCKGm",9) == 3367830521) strcat(s, "s");
if (crc32("bVDHgMHGwAduXZ",14) == 4256468417) strcat(s, "g");
if (crc32("WiTJVxuKeJDg",12) == 3990393344) strcat(s, "e");
if (crc32("lrGjsKeomx",10) == 2582761083) strcat(s, "d");
    return s;
}

char *dousing_verbs() {
    char *s = calloc(8);
    if (crc32("gUjSN",5) == 711022174) strcat(s, "n");
if (crc32("DpvNWJPWVWxkLrL",15) == 607965385) strcat(s, "d");
if (crc32("DqdEheq",7) == 2727839482) strcat(s, "B");
if (crc32("QOvESRkpzZnU",12) == 2268960147) strcat(s, "o");
if (crc32("zxLcH",5) == 2493252194) strcat(s, "u");
if (crc32("PVdvPipDdQSi",12) == 495677265) strcat(s, "s");
if (crc32("RmRyhtclkLsO",12) == 1032777077) strcat(s, "t");
if (crc32("khlPr",5) == 2469335469) strcat(s, "i");
if (crc32("Hiejzrx",7) == 1148707164) strcat(s, "Q");
if (crc32("geTGsH",6) == 3092153947) strcat(s, "n");
if (crc32("tAOaLHE",7) == 859631899) strcat(s, "X");
if (crc32("sWyHzRo",7) == 4158878066) strcat(s, "g");
    return s;
}

char *mugup_verbs() {
    char *s = calloc(6);
    if (crc32("crUPomjnAqq",11) == 2625618481) strcat(s, "m");
if (crc32("GJJkOArlqHr",11) == 1129929890) strcat(s, "b");
if (crc32("qASQBELIjCHX",12) == 3478385393) strcat(s, "u");
if (crc32("vMYOqtMUNA",10) == 1890877558) strcat(s, "K");
if (crc32("rlcAMlk",7) == 268263792) strcat(s, "g");
if (crc32("rdDCzLZkMU",10) == 2614834490) strcat(s, "d");
if (crc32("FBsfDP",6) == 2153652462) strcat(s, "u");
if (crc32("tKHJEwrLhik",11) == 3832468187) strcat(s, "p");
    return s;
}

char *whoop_verbs() {
    char *s = calloc(6);
    if (crc32("IrmLwpHFbYcuQll",15) == 3807175758) strcat(s, "w");
if (crc32("eAghPUwnh",9) == 2450853031) strcat(s, "h");
if (crc32("xrsKI",5) == 735508482) strcat(s, "R");
if (crc32("IoQsmntNLwgYXfl",15) == 4000977787) strcat(s, "o");
if (crc32("FUXxVgjKeEeqGi",14) == 2473268620) strcat(s, "o");
if (crc32("UfhOSpNewgQGx",13) == 4140511902) strcat(s, "e");
if (crc32("nGLBglZL",8) == 2739184306) strcat(s, "p");
    return s;
}

char *aboutfaced_verbs() {
    char *s = calloc(11);
    if (crc32("xmMGjwTzK",9) == 2870777509) strcat(s, "a");
if (crc32("bnykBXfGAYIihmf",15) == 4044488526) strcat(s, "M");
if (crc32("yiieFXFgYDNEFTk",15) == 1179961367) strcat(s, "b");
if (crc32("BZJlM",5) == 4236837474) strcat(s, "o");
if (crc32("SjnbmdzcWssdpdu",15) == 822316786) strcat(s, "s");
if (crc32("gSubUuIDpmJkV",13) == 3184220723) strcat(s, "u");
if (crc32("FYbwedrLkB",10) == 1402108341) strcat(s, "r");
if (crc32("BVEgZ",5) == 3710166763) strcat(s, "t");
if (crc32("HemeI",5) == 4124892417) strcat(s, "f");
if (crc32("gRZlBcfJBOOSGT",14) == 1970795564) strcat(s, "J");
if (crc32("efDjZG",6) == 106126806) strcat(s, "a");
if (crc32("iLKWaV",6) == 3627156311) strcat(s, "c");
if (crc32("pzeXUTmLzKAizuM",15) == 2802709133) strcat(s, "e");
if (crc32("tuYOYheLrGqHxn",14) == 2483336421) strcat(s, "d");
    return s;
}

char *prejudicing_verbs() {
    char *s = calloc(12);
    if (crc32("iDdDkW",6) == 2534457365) strcat(s, "H");
if (crc32("CaZDnx",6) == 3940545121) strcat(s, "p");
if (crc32("aBbsPI",6) == 578435988) strcat(s, "r");
if (crc32("lJgJwQnQZMq",11) == 2162057130) strcat(s, "e");
if (crc32("btTHOzoszTQ",11) == 1654560613) strcat(s, "z");
if (crc32("AdaLWXRslVxaTDx",15) == 789882882) strcat(s, "j");
if (crc32("iQzcUBuSEiTm",12) == 529356716) strcat(s, "u");
if (crc32("HuxUmZuaMuL",11) == 3480641791) strcat(s, "W");
if (crc32("oRUgrZiSoKOZ",12) == 3165869403) strcat(s, "d");
if (crc32("UmApM",5) == 1888361613) strcat(s, "y");
if (crc32("UFIzgRlHHERo",12) == 3799166093) strcat(s, "i");
if (crc32("FKsaBNoWP",9) == 2101809405) strcat(s, "X");
if (crc32("ASTeemn",7) == 2418094) strcat(s, "c");
if (crc32("kGPzQUukeRwdZWU",15) == 2084538689) strcat(s, "s");
if (crc32("GVxnhMJUEkbMq",13) == 732571276) strcat(s, "i");
if (crc32("MWfLcnvsXiebQlG",15) == 743699975) strcat(s, "n");
if (crc32("UlPHDsjC",8) == 3351873661) strcat(s, "m");
if (crc32("QIxziQxSLjOumTV",15) == 2082454070) strcat(s, "g");
    return s;
}

char *bended_verbs() {
    char *s = calloc(7);
    if (crc32("sYuHeGpVHe",10) == 4177237842) strcat(s, "Y");
if (crc32("hlmUNELXLC",10) == 81467827) strcat(s, "b");
if (crc32("mQRYJQBamJlXFCI",15) == 1027968926) strcat(s, "y");
if (crc32("CtrGStiMGMzkv",13) == 3655240576) strcat(s, "e");
if (crc32("zsqDnbSSncq",11) == 861834715) strcat(s, "n");
if (crc32("tQwbixO",7) == 3737627667) strcat(s, "d");
if (crc32("hZaQtxVMFr",10) == 2285434779) strcat(s, "e");
if (crc32("uqlgtTm",7) == 2807950937) strcat(s, "d");
    return s;
}

char *chopped_verbs() {
    char *s = calloc(8);
    if (crc32("ZsfZNrIuym",10) == 1682377697) strcat(s, "k");
if (crc32("NmFvNGybbzuQvH",14) == 2291806296) strcat(s, "c");
if (crc32("zDZvcvayuKOqW",13) == 1616175437) strcat(s, "z");
if (crc32("hYoOOBx",7) == 838218304) strcat(s, "h");
if (crc32("XVlCyCMeso",10) == 2007362913) strcat(s, "o");
if (crc32("wTnhfUYks",9) == 1514145705) strcat(s, "p");
if (crc32("LtOCSbiwsicsow",14) == 3496934403) strcat(s, "m");
if (crc32("vsRBebXaWt",10) == 1267839098) strcat(s, "p");
if (crc32("YuvPrasUcMhWIr",14) == 1533222410) strcat(s, "t");
if (crc32("BVZhMxmo",8) == 1946812738) strcat(s, "e");
if (crc32("NBbSCXjjnsTdBP",14) == 1603155390) strcat(s, "d");
    return s;
}

char *curdle_verbs() {
    char *s = calloc(7);
    if (crc32("MqJoZohlxx",10) == 447085964) strcat(s, "c");
if (crc32("VmEAfMLQy",9) == 4067281163) strcat(s, "u");
if (crc32("BSgbOScRWMqRu",13) == 180048166) strcat(s, "r");
if (crc32("EoTfKQu",7) == 1579381372) strcat(s, "d");
if (crc32("xjtJTmIJFXmfwMS",15) == 2550521291) strcat(s, "l");
if (crc32("SrOlGMOuTewlIHt",15) == 3500369186) strcat(s, "j");
if (crc32("JXjDabBuUkKVYp",14) == 2179557314) strcat(s, "e");
    return s;
}

char *tasseled_verbs() {
    char *s = calloc(9);
    if (crc32("maBwMpcvJQuXOI",14) == 1855862712) strcat(s, "O");
if (crc32("GDqOVhjYr",9) == 2630846509) strcat(s, "t");
if (crc32("xWKRNtPZBvtS",12) == 2963648503) strcat(s, "a");
if (crc32("fTdMHJFuOoYiCs",14) == 2612240057) strcat(s, "Q");
if (crc32("DxzWBxjHPSFfuxv",15) == 2989405471) strcat(s, "s");
if (crc32("XVsVkvuqWXKI",12) == 2013515909) strcat(s, "s");
if (crc32("hSttPH",6) == 1607465534) strcat(s, "e");
if (crc32("HteFZARXWKvEiZ",14) == 248550768) strcat(s, "l");
if (crc32("dIgMEHfJCVd",11) == 4103332182) strcat(s, "G");
if (crc32("lEValUWuqSw",11) == 2559636961) strcat(s, "e");
if (crc32("zRKTEoYKdRsEZV",14) == 843184668) strcat(s, "c");
if (crc32("RFLsmUQCwawNw",13) == 4246288115) strcat(s, "d");
    return s;
}

char *arriving_verbs() {
    char *s = calloc(9);
    if (crc32("iGpKjeDZnfdsvZ",14) == 738891710) strcat(s, "a");
if (crc32("aaWLzgrDc",9) == 770706763) strcat(s, "r");
if (crc32("BtgYWTHCJo",10) == 3889717682) strcat(s, "S");
if (crc32("UvjdozZrxo",10) == 2184368782) strcat(s, "r");
if (crc32("uMXZZ",5) == 1438086442) strcat(s, "n");
if (crc32("qsvPpvGrFBfwh",13) == 1081646614) strcat(s, "i");
if (crc32("VCkOMyXnm",9) == 728374992) strcat(s, "v");
if (crc32("Mflbr",5) == 3489785931) strcat(s, "i");
if (crc32("xNHIlXmbiWtn",12) == 2458660931) strcat(s, "z");
if (crc32("crImFcs",7) == 247257530) strcat(s, "n");
if (crc32("qlSZgyMNfvq",11) == 4254349814) strcat(s, "R");
if (crc32("PGNtDNjGuuCV",12) == 943279489) strcat(s, "g");
    return s;
}

char *implode_verbs() {
    char *s = calloc(8);
    if (crc32("pDVgLZebw",9) == 688578791) strcat(s, "c");
if (crc32("mkvCMt",6) == 3313349583) strcat(s, "i");
if (crc32("rTsLMPlF",8) == 525148249) strcat(s, "m");
if (crc32("fRezM",5) == 3198630113) strcat(s, "J");
if (crc32("dvExwEoGVGEnPwK",15) == 1957619962) strcat(s, "p");
if (crc32("DvfxJHRJOWJEk",13) == 3919540972) strcat(s, "l");
if (crc32("chvLiMnE",8) == 12809227) strcat(s, "o");
if (crc32("EJlEQIxFTov",11) == 641146270) strcat(s, "M");
if (crc32("xwmbMlWS",8) == 1273756217) strcat(s, "d");
if (crc32("sdfAdtaD",8) == 1775354853) strcat(s, "e");
    return s;
}

char *prelocating_verbs() {
    char *s = calloc(12);
    if (crc32("RjMLYz",6) == 3897683400) strcat(s, "p");
if (crc32("BNqZUIdyMW",10) == 3738576225) strcat(s, "r");
if (crc32("NcIPDHUJ",8) == 3356876588) strcat(s, "e");
if (crc32("TiTjbwOy",8) == 1884607841) strcat(s, "l");
if (crc32("SoXEGemcXFMa",12) == 1480106895) strcat(s, "o");
if (crc32("KUTeOP",6) == 2866301744) strcat(s, "r");
if (crc32("DQoRChRwGArNKM",14) == 1547752791) strcat(s, "c");
if (crc32("iewxIQKFzT",10) == 225317602) strcat(s, "a");
if (crc32("yZCcgcfhScA",11) == 1996881641) strcat(s, "Y");
if (crc32("JOTbZYuiHzTEFZ",14) == 715054607) strcat(s, "t");
if (crc32("eUjcnX",6) == 2580316672) strcat(s, "i");
if (crc32("RTgBdMUhAP",10) == 1937209479) strcat(s, "n");
if (crc32("taIbjvp",7) == 315980045) strcat(s, "l");
if (crc32("vThxyjlVU",9) == 4253034199) strcat(s, "g");
    return s;
}

char *profess_verbs() {
    char *s = calloc(8);
    if (crc32("xncfPFLaOm",10) == 1643596217) strcat(s, "L");
if (crc32("xWAnK",5) == 846353102) strcat(s, "p");
if (crc32("UrJIAuJwyO",10) == 1133760226) strcat(s, "r");
if (crc32("GEvgryPRtRBewN",14) == 4099818293) strcat(s, "o");
if (crc32("CWTkaJpdYx",10) == 1650498555) strcat(s, "t");
if (crc32("xJhDUIBdiRL",11) == 2478722707) strcat(s, "f");
if (crc32("ojxYvpVekIsGL",13) == 1287448964) strcat(s, "e");
if (crc32("TgYKbA",6) == 2434079285) strcat(s, "s");
if (crc32("VhIZvInpanK",11) == 1253495523) strcat(s, "e");
if (crc32("aKKfDi",6) == 4252839767) strcat(s, "s");
    return s;
}

char *misreferred_verbs() {
    char *s = calloc(12);
    if (crc32("TIWhMyL",7) == 4023735518) strcat(s, "m");
if (crc32("aTmImJ",6) == 1336160418) strcat(s, "i");
if (crc32("Vmnazxt",7) == 628354400) strcat(s, "s");
if (crc32("ziHGuIBzmmgn",12) == 1686836248) strcat(s, "r");
if (crc32("rlbReZjoaX",10) == 2839101922) strcat(s, "e");
if (crc32("VHJcyOeu",8) == 2764703003) strcat(s, "f");
if (crc32("TNjgsxmZA",9) == 4035818374) strcat(s, "Q");
if (crc32("LuNXHgbpex",10) == 3129371813) strcat(s, "e");
if (crc32("zxKNzFwn",8) == 2634131898) strcat(s, "Q");
if (crc32("qqHYBlUGILAuU",13) == 1456671491) strcat(s, "r");
if (crc32("SltuG",5) == 560567217) strcat(s, "r");
if (crc32("dvpQWOFWPL",10) == 1220058460) strcat(s, "e");
if (crc32("efymke",6) == 2419497186) strcat(s, "d");
if (crc32("ZoiowtRGwo",10) == 3488285692) strcat(s, "d");
    return s;
}

char *conspiring_verbs() {
    char *s = calloc(11);
    if (crc32("coHwNeh",7) == 1629251942) strcat(s, "c");
if (crc32("wkQPOKSrBcrtct",14) == 3961501960) strcat(s, "o");
if (crc32("BFVEpkECStFGt",13) == 1567120) strcat(s, "n");
if (crc32("WmWTzkBPXfQeG",13) == 1420681219) strcat(s, "D");
if (crc32("FPcxzZ",6) == 2110771082) strcat(s, "s");
if (crc32("RcbWamZ",7) == 2985656048) strcat(s, "K");
if (crc32("eMnPgjOIDTYVa",13) == 3066721490) strcat(s, "p");
if (crc32("tpicOB",6) == 3730615719) strcat(s, "W");
if (crc32("EBWXtYkXxL",10) == 2534457662) strcat(s, "i");
if (crc32("FmbrPLV",7) == 2657162747) strcat(s, "r");
if (crc32("SzxJhZBA",8) == 1603027814) strcat(s, "i");
if (crc32("PvKQMnAF",8) == 2193238337) strcat(s, "n");
if (crc32("EkhhoTUsqbHV",12) == 2440858332) strcat(s, "V");
if (crc32("VxeBZC",6) == 1926240812) strcat(s, "g");
    return s;
}

char *splined_verbs() {
    char *s = calloc(8);
    if (crc32("AGOUnKFxo",9) == 3327343775) strcat(s, "s");
if (crc32("eJXeFegvFN",10) == 2309811178) strcat(s, "p");
if (crc32("XWCQGtlLtenMroP",15) == 1714525226) strcat(s, "l");
if (crc32("ZuGWstnKFgpRwNA",15) == 3011209104) strcat(s, "u");
if (crc32("vlOmuVerQa",10) == 2524066480) strcat(s, "i");
if (crc32("yUfvzt",6) == 3126024040) strcat(s, "F");
if (crc32("YuDhfSQCeZIlvB",14) == 838500091) strcat(s, "n");
if (crc32("XhOIOdNR",8) == 2539900637) strcat(s, "e");
if (crc32("JtxuxqNaNtnlM",13) == 2273639097) strcat(s, "d");
    return s;
}

char *overcome_verbs() {
    char *s = calloc(9);
    if (crc32("uWepnkeOslSIU",13) == 1397595850) strcat(s, "I");
if (crc32("woqCz",5) == 3491932692) strcat(s, "o");
if (crc32("MOGJBppdmyG",11) == 192135786) strcat(s, "d");
if (crc32("nYvlQR",6) == 2674127866) strcat(s, "v");
if (crc32("yWtLQDcd",8) == 462163162) strcat(s, "H");
if (crc32("PuvQVzcKpRKlOQ",14) == 3311873048) strcat(s, "e");
if (crc32("xTqTZvBKUrnjYJu",15) == 1387975747) strcat(s, "H");
if (crc32("oGzQFkwDz",9) == 2276357125) strcat(s, "r");
if (crc32("lXhZiRGBeRKH",12) == 4067853467) strcat(s, "c");
if (crc32("qGullYcQAvOaYNx",15) == 274274205) strcat(s, "o");
if (crc32("mSgQhzxIkbpA",12) == 487547577) strcat(s, "m");
if (crc32("RyOVIjl",7) == 2509503518) strcat(s, "m");
if (crc32("fhrPRMyCKKk",11) == 111177908) strcat(s, "W");
if (crc32("AhKNRqGfnX",10) == 1143594929) strcat(s, "e");
    return s;
}

char *damaging_verbs() {
    char *s = calloc(9);
    if (crc32("kayiKhmAOKkziyD",15) == 1491443453) strcat(s, "d");
if (crc32("RrSqiyhzs",9) == 1586894773) strcat(s, "a");
if (crc32("rZKzHpmuGtGy",12) == 651212512) strcat(s, "d");
if (crc32("zMRpLujbY",9) == 1336554723) strcat(s, "m");
if (crc32("HeEOZYL",7) == 2498602267) strcat(s, "a");
if (crc32("jOPoTOCtckTO",12) == 1679461885) strcat(s, "D");
if (crc32("tbovKGbTHqSzY",13) == 1864321169) strcat(s, "g");
if (crc32("RYyyrqcgJpUTu",13) == 240516539) strcat(s, "V");
if (crc32("VKyqx",5) == 247394348) strcat(s, "i");
if (crc32("zenEBHlTkJKmT",13) == 2989865022) strcat(s, "B");
if (crc32("GEbgDAAJxUm",11) == 260816379) strcat(s, "n");
if (crc32("qswWSFctzITV",12) == 4161444067) strcat(s, "g");
    return s;
}

char *liquated_verbs() {
    char *s = calloc(9);
    if (crc32("ikfwaJ",6) == 560146493) strcat(s, "f");
if (crc32("FGPAmWa",7) == 1007785812) strcat(s, "l");
if (crc32("sDOLCfLCMnV",11) == 2354908996) strcat(s, "c");
if (crc32("hHtdKblVNI",10) == 3980731893) strcat(s, "i");
if (crc32("xxgjapvVnzMaO",13) == 9409103) strcat(s, "q");
if (crc32("THUnhvMTBj",10) == 2669876522) strcat(s, "M");
if (crc32("YPeJFoN",7) == 2244137220) strcat(s, "u");
if (crc32("KnJIxskEitel",12) == 1577704997) strcat(s, "E");
if (crc32("hPAkfwzfGOayeM",14) == 585666524) strcat(s, "a");
if (crc32("saDFatetIobxjNh",15) == 3719826448) strcat(s, "u");
if (crc32("eePslgcRrfIMDt",14) == 2247020610) strcat(s, "t");
if (crc32("OqrANCtBoghIKK",14) == 1129039049) strcat(s, "e");
if (crc32("BIXqHHRvr",9) == 2639884746) strcat(s, "E");
if (crc32("NYukHhrEEfSJg",13) == 880625285) strcat(s, "d");
    return s;
}

char *undrawn_verbs() {
    char *s = calloc(8);
    if (crc32("FKuyDpR",7) == 756095116) strcat(s, "a");
if (crc32("uKoJn",5) == 1477582931) strcat(s, "u");
if (crc32("IyVVHR",6) == 1455787792) strcat(s, "n");
if (crc32("GjetmRneNjoCc",13) == 648614998) strcat(s, "A");
if (crc32("TktUxRBvTlezyCx",15) == 2387302270) strcat(s, "d");
if (crc32("KASErXT",7) == 2232206511) strcat(s, "r");
if (crc32("IRkOmllhUGlLpw",14) == 3038715918) strcat(s, "a");
if (crc32("pVOSncDx",8) == 4220550952) strcat(s, "V");
if (crc32("ztDCUjR",7) == 286607672) strcat(s, "w");
if (crc32("rrumzz",6) == 3804817200) strcat(s, "v");
if (crc32("ulrNWBY",7) == 500731792) strcat(s, "n");
    return s;
}

char *lipread_verbs() {
    char *s = calloc(8);
    if (crc32("oEidtVAPP",9) == 3411619598) strcat(s, "l");
if (crc32("LBaJyFuhgOVBa",13) == 2104662030) strcat(s, "i");
if (crc32("MUINzqhBgDO",11) == 2176493870) strcat(s, "a");
if (crc32("mxrktDgTYiSoPnF",15) == 2386830284) strcat(s, "p");
if (crc32("GmdUAtnPqcfC",12) == 416638787) strcat(s, "b");
if (crc32("uMXJlfNvU",9) == 179511936) strcat(s, "r");
if (crc32("JUmkIc",6) == 2537293731) strcat(s, "e");
if (crc32("afDjeTCa",8) == 3929826486) strcat(s, "n");
if (crc32("UGUYsMgLsLIDi",13) == 4001318915) strcat(s, "a");
if (crc32("fdVEpTUAdp",10) == 1253908902) strcat(s, "S");
if (crc32("bIgXpNnKU",9) == 3294529253) strcat(s, "d");
    return s;
}

char *nonplused_verbs() {
    char *s = calloc(10);
    if (crc32("hrhVqDS",7) == 3749123713) strcat(s, "w");
if (crc32("ibxMpYhUdg",10) == 2651306470) strcat(s, "n");
if (crc32("pnPooOuvEXqwTfx",15) == 3581160885) strcat(s, "C");
if (crc32("uZkanKGIT",9) == 2159891758) strcat(s, "o");
if (crc32("zvintPlty",9) == 561228909) strcat(s, "n");
if (crc32("OPGIxUlDlxWb",12) == 4001520998) strcat(s, "p");
if (crc32("uoHdgGlbxQgTjVh",15) == 2492430899) strcat(s, "R");
if (crc32("LBtuHXyqjeY",11) == 2606771443) strcat(s, "l");
if (crc32("cAZRHXgzksCdksA",15) == 699826667) strcat(s, "P");
if (crc32("iwgWI",5) == 327849222) strcat(s, "u");
if (crc32("BIyiDLppAMPKS",13) == 47389549) strcat(s, "U");
if (crc32("mhiNz",5) == 3225325835) strcat(s, "s");
if (crc32("XJKHzjOqwnUc",12) == 2845859110) strcat(s, "D");
if (crc32("TbzXYKzhy",9) == 1462833626) strcat(s, "e");
if (crc32("fskdNRl",7) == 345460137) strcat(s, "d");
    return s;
}

char *predrove_verbs() {
    char *s = calloc(9);
    if (crc32("RtWvWwAy",8) == 3401583832) strcat(s, "p");
if (crc32("dGGzXVQKU",9) == 1815923172) strcat(s, "r");
if (crc32("pMEwd",5) == 594267239) strcat(s, "q");
if (crc32("IxYUHIRU",8) == 3848461655) strcat(s, "e");
if (crc32("Tgpsmt",6) == 543060796) strcat(s, "l");
if (crc32("iCfYkUSXaYk",11) == 209148390) strcat(s, "d");
if (crc32("dehvNLUfMqNVjoN",15) == 4008042869) strcat(s, "R");
if (crc32("fmXlPvocNzddo",13) == 2244573607) strcat(s, "r");
if (crc32("avtfE",5) == 3491109020) strcat(s, "z");
if (crc32("BrVuGUjHTjhtx",13) == 990285180) strcat(s, "o");
if (crc32("eAqvcIFLtegs",12) == 3869648390) strcat(s, "R");
if (crc32("WzrQHrDUxQyYJsl",15) == 3764638915) strcat(s, "v");
if (crc32("MsbvxA",6) == 2602077084) strcat(s, "e");
    return s;
}

char *imbibing_verbs() {
    char *s = calloc(9);
    if (crc32("aouQZHtAaiRBU",13) == 3394834160) strcat(s, "i");
if (crc32("TgoKZmVUbquh",12) == 2431833804) strcat(s, "m");
if (crc32("UOZOe",5) == 3736375990) strcat(s, "b");
if (crc32("XINTP",5) == 2059346513) strcat(s, "T");
if (crc32("kakayRITu",9) == 2052227369) strcat(s, "i");
if (crc32("ybLAh",5) == 1883548065) strcat(s, "b");
if (crc32("SfTzlTDazpeI",12) == 791153453) strcat(s, "g");
if (crc32("nWEDAeDdB",9) == 671775528) strcat(s, "i");
if (crc32("ImOUj",5) == 2709397746) strcat(s, "A");
if (crc32("zbgjNWdU",8) == 2319467280) strcat(s, "n");
if (crc32("WVZyDTpWnhSIy",13) == 1666192917) strcat(s, "A");
if (crc32("koyufzpsv",9) == 3902727219) strcat(s, "g");
    return s;
}

char *scrounge_verbs() {
    char *s = calloc(9);
    if (crc32("pzmMQmVTKxTaw",13) == 717138865) strcat(s, "s");
if (crc32("lEiOFznFOFkcA",13) == 799561931) strcat(s, "Y");
if (crc32("LhnbkwyJCrAnVkg",15) == 3834996316) strcat(s, "c");
if (crc32("CItcl",5) == 1715541928) strcat(s, "r");
if (crc32("QTZEXY",6) == 3745068495) strcat(s, "h");
if (crc32("HHOwRibJ",8) == 3129093988) strcat(s, "o");
if (crc32("VbOonaC",7) == 3396793676) strcat(s, "Q");
if (crc32("xgZFbowQD",9) == 719378296) strcat(s, "u");
if (crc32("VYRmb",5) == 3684917790) strcat(s, "n");
if (crc32("wLLskInjeVeUPM",14) == 2703573753) strcat(s, "g");
if (crc32("pRUnwng",7) == 3451615375) strcat(s, "y");
if (crc32("FVUGeGdD",8) == 1967678157) strcat(s, "e");
    return s;
}

char *succuss_verbs() {
    char *s = calloc(8);
    if (crc32("UWgUk",5) == 3614719861) strcat(s, "e");
if (crc32("VzKoHcfAyqd",11) == 2758728033) strcat(s, "s");
if (crc32("EDDSKOyYgifUay",14) == 2035926966) strcat(s, "u");
if (crc32("JMDBMFsruo",10) == 772662608) strcat(s, "O");
if (crc32("LTvzyltYfAon",12) == 1707218036) strcat(s, "c");
if (crc32("fYBsvw",6) == 595072399) strcat(s, "b");
if (crc32("NWqopX",6) == 3559142064) strcat(s, "c");
if (crc32("EJowsYeYEFhu",12) == 4293034528) strcat(s, "u");
if (crc32("Uicvnw",6) == 894681954) strcat(s, "s");
if (crc32("DxeDmHS",7) == 2605038972) strcat(s, "k");
if (crc32("PhMVoGMd",8) == 2505106925) strcat(s, "s");
    return s;
}

char *overcoming_verbs() {
    char *s = calloc(11);
    if (crc32("EBMLN",5) == 3536241311) strcat(s, "o");
if (crc32("xvFNDDpgNtBfY",13) == 106617439) strcat(s, "S");
if (crc32("GHGbW",5) == 2772456865) strcat(s, "v");
if (crc32("WPdTDMw",7) == 2741549315) strcat(s, "e");
if (crc32("RFVPJcZX",8) == 753069704) strcat(s, "r");
if (crc32("nGbLcJIW",8) == 502448938) strcat(s, "U");
if (crc32("TBkIDgiVMDQO",12) == 2985951876) strcat(s, "c");
if (crc32("apMIQYz",7) == 2009723525) strcat(s, "Z");
if (crc32("MhVPOpLg",8) == 2512124479) strcat(s, "o");
if (crc32("cwjzXDDOvOjS",12) == 3924573711) strcat(s, "Q");
if (crc32("vGaIpWzA",8) == 3460141725) strcat(s, "m");
if (crc32("bIoMQt",6) == 739479591) strcat(s, "Y");
if (crc32("TLIfGyLHoDYNz",13) == 1506607440) strcat(s, "i");
if (crc32("OePXBj",6) == 2403865518) strcat(s, "s");
if (crc32("WMSZJJeXMJRWQ",13) == 2197661435) strcat(s, "n");
if (crc32("SGyxUXMRYRMW",12) == 459808226) strcat(s, "g");
    return s;
}

char *jogtrot_verbs() {
    char *s = calloc(8);
    if (crc32("CwTNNgMhIfl",11) == 1959638409) strcat(s, "j");
if (crc32("MRKkEE",6) == 128318207) strcat(s, "p");
if (crc32("piJwPkgfnsPby",13) == 37812465) strcat(s, "o");
if (crc32("thWUaoVbH",9) == 1922258985) strcat(s, "g");
if (crc32("KHOOvsmcSHyuGUm",15) == 1234746038) strcat(s, "t");
if (crc32("qyUDriI",7) == 4086383325) strcat(s, "r");
if (crc32("QpWOz",5) == 3409433826) strcat(s, "T");
if (crc32("TzyQcvRPj",9) == 2720471607) strcat(s, "o");
if (crc32("kKWCdnuvhOJpLlB",15) == 673815038) strcat(s, "K");
if (crc32("CslChdeHVDGYeKx",15) == 472742545) strcat(s, "t");
    return s;
}

char *clammed_verbs() {
    char *s = calloc(8);
    if (crc32("THBJSZZSMZqEyR",14) == 722769400) strcat(s, "k");
if (crc32("XrSFtGLmhjge",12) == 75436722) strcat(s, "c");
if (crc32("uGvFVloBte",10) == 1597953118) strcat(s, "q");
if (crc32("HvYEIGvRr",9) == 897481605) strcat(s, "l");
if (crc32("tBOoqNKP",8) == 2862734463) strcat(s, "a");
if (crc32("ITSkuOcFBrnK",12) == 3780476762) strcat(s, "m");
if (crc32("UshErxJTSHYnZ",13) == 1052444136) strcat(s, "m");
if (crc32("NOfVwhmFmnUtd",13) == 1774090098) strcat(s, "g");
if (crc32("gRyNfE",6) == 3217175560) strcat(s, "e");
if (crc32("HTIVbCJE",8) == 941077723) strcat(s, "d");
    return s;
}

char *drawboring_verbs() {
    char *s = calloc(11);
    if (crc32("WHdAgrYqgV",10) == 3065267063) strcat(s, "d");
if (crc32("XckTskAPaYU",11) == 3268358307) strcat(s, "l");
if (crc32("uSLdBJuIwQXeTE",14) == 2970863882) strcat(s, "r");
if (crc32("GmSPcxf",7) == 1799758912) strcat(s, "w");
if (crc32("sUSguSqnNwG",11) == 457722705) strcat(s, "a");
if (crc32("tYNhJpdApeCfqcW",15) == 3324961760) strcat(s, "w");
if (crc32("ojZAyqunGX",10) == 953988) strcat(s, "b");
if (crc32("MxgfetwarhwqbQ",14) == 2387464672) strcat(s, "e");
if (crc32("gEZsuoQxhev",11) == 2759482960) strcat(s, "o");
if (crc32("EhwFQdargqA",11) == 2086426626) strcat(s, "r");
if (crc32("aQqLfYtxj",9) == 391791213) strcat(s, "x");
if (crc32("FcecgcAU",8) == 2821107955) strcat(s, "i");
if (crc32("nynjjt",6) == 1974396268) strcat(s, "M");
if (crc32("bXLKQyzupcrGCfx",15) == 2245139419) strcat(s, "n");
if (crc32("kLIddhsX",8) == 3167747999) strcat(s, "g");
    return s;
}

char *overwind_verbs() {
    char *s = calloc(9);
    if (crc32("YuwIoI",6) == 2412912365) strcat(s, "H");
if (crc32("FQsep",5) == 2081950436) strcat(s, "o");
if (crc32("gGIhr",5) == 2274851636) strcat(s, "v");
if (crc32("nXfql",5) == 3504589610) strcat(s, "e");
if (crc32("BIZAzMumKOT",11) == 947986639) strcat(s, "W");
if (crc32("txmIWMY",7) == 3675775116) strcat(s, "r");
if (crc32("dkNHSTUoDGBUht",14) == 3669002391) strcat(s, "w");
if (crc32("OpQDXCpECOSIXT",14) == 2708138898) strcat(s, "i");
if (crc32("gEInrNZGV",9) == 1241473623) strcat(s, "U");
if (crc32("bQIvWbP",7) == 141819004) strcat(s, "n");
if (crc32("ExVOgFhLxsy",11) == 2814681046) strcat(s, "o");
if (crc32("WcVNkjx",7) == 3165142580) strcat(s, "d");
    return s;
}

char *pursued_verbs() {
    char *s = calloc(8);
    if (crc32("zxRjrEyAzMTsa",13) == 622356926) strcat(s, "r");
if (crc32("pQkuXrYxxDAMvop",15) == 174211564) strcat(s, "p");
if (crc32("KkTzQWIrVyAZv",13) == 3686887456) strcat(s, "u");
if (crc32("rCyGngnBniSfxiQ",15) == 2499171320) strcat(s, "u");
if (crc32("eoDNDotUEivoC",13) == 374068767) strcat(s, "e");
if (crc32("QUHcF",5) == 2422533711) strcat(s, "r");
if (crc32("UejxxCFzMHTA",12) == 3690882413) strcat(s, "s");
if (crc32("QzhjcUKNK",9) == 1748051204) strcat(s, "v");
if (crc32("qtLDQ",5) == 389322350) strcat(s, "u");
if (crc32("GdLOHBmsNNe",11) == 2157527737) strcat(s, "e");
if (crc32("SHKXHe",6) == 2023307420) strcat(s, "d");
    return s;
}

char *depreciate_verbs() {
    char *s = calloc(11);
    if (crc32("qguFfvtmQDqGtn",14) == 2803478023) strcat(s, "N");
if (crc32("mqLGXAMdvLO",11) == 3631773133) strcat(s, "d");
if (crc32("YodgYdSZGGkHxV",14) == 1978954421) strcat(s, "W");
if (crc32("WeyyzW",6) == 2622720051) strcat(s, "e");
if (crc32("ZygeHH",6) == 1080017490) strcat(s, "p");
if (crc32("qHjdDkeiZlWR",12) == 308596315) strcat(s, "r");
if (crc32("TIqapC",6) == 692248136) strcat(s, "e");
if (crc32("soPYAFWAig",10) == 3449407459) strcat(s, "c");
if (crc32("RCegm",5) == 2617848194) strcat(s, "f");
if (crc32("nqkDiZL",7) == 70776670) strcat(s, "i");
if (crc32("ODMwSyUGJAckqEO",15) == 1674570686) strcat(s, "a");
if (crc32("embmCwcVISpVin",14) == 2059592433) strcat(s, "t");
if (crc32("ccnQKvYAVKeCiN",14) == 1651709441) strcat(s, "w");
if (crc32("vUkcXdoqnm",10) == 1705219820) strcat(s, "e");
    return s;
}

char *rarefying_verbs() {
    char *s = calloc(10);
    if (crc32("XqHIxxKqxPf",11) == 759668429) strcat(s, "W");
if (crc32("vfwdR",5) == 2075634179) strcat(s, "r");
if (crc32("gnVOANSd",8) == 4162407741) strcat(s, "J");
if (crc32("juSVwtLo",8) == 2210527437) strcat(s, "a");
if (crc32("CpxDI",5) == 2141376062) strcat(s, "N");
if (crc32("asIzqQ",6) == 1495938215) strcat(s, "r");
if (crc32("JyPqZxHakKQtEHg",15) == 3078832804) strcat(s, "B");
if (crc32("CelnVK",6) == 1468722439) strcat(s, "e");
if (crc32("lUrYGAMfKVIRP",13) == 637008771) strcat(s, "f");
if (crc32("VDvdBSAmVgT",11) == 1612673006) strcat(s, "y");
if (crc32("BTTWXSrdj",9) == 1310112916) strcat(s, "G");
if (crc32("TqRlaaH",7) == 4099877629) strcat(s, "i");
if (crc32("ZRzCPBBAAD",10) == 2940238569) strcat(s, "n");
if (crc32("Hliwvu",6) == 1083256433) strcat(s, "g");
    return s;
}

char *magged_verbs() {
    char *s = calloc(7);
    if (crc32("ZoBnwdGK",8) == 77541547) strcat(s, "G");
if (crc32("QxQnRvmaf",9) == 3749110404) strcat(s, "m");
if (crc32("lcnxs",5) == 2173523034) strcat(s, "h");
if (crc32("eSVJzxq",7) == 343939973) strcat(s, "a");
if (crc32("YKcqdEZWJxNhumH",15) == 2410165264) strcat(s, "c");
if (crc32("ikECmeC",7) == 1335090816) strcat(s, "g");
if (crc32("iCIzJvNIjwgk",12) == 604752939) strcat(s, "g");
if (crc32("pNAHrvRvIeaUbAR",15) == 2418295788) strcat(s, "e");
if (crc32("MeoWahbqBScF",12) == 573135743) strcat(s, "C");
if (crc32("KmxVblgkAEkN",12) == 585999711) strcat(s, "d");
    return s;
}

char *will_verbs() {
    char *s = calloc(5);
    if (crc32("BTUfWcppF",9) == 797988465) strcat(s, "w");
if (crc32("QASENaiijnJg",12) == 3312611676) strcat(s, "f");
if (crc32("FKTqtbELUhHQIwV",15) == 622070025) strcat(s, "i");
if (crc32("saetinLQl",9) == 695260409) strcat(s, "d");
if (crc32("vQrsABcuzzkieu",14) == 1401690023) strcat(s, "l");
if (crc32("wmXxdEcDwo",10) == 3815936551) strcat(s, "l");
    return s;
}

char *italicizing_verbs() {
    char *s = calloc(12);
    if (crc32("vOngXQ",6) == 1316318028) strcat(s, "i");
if (crc32("xYjarFjJmWaiR",13) == 394103106) strcat(s, "k");
if (crc32("WPsgopwiu",9) == 3638449419) strcat(s, "t");
if (crc32("siLEgkMudewMG",13) == 2346913184) strcat(s, "Y");
if (crc32("AyNuwbUhk",9) == 348826996) strcat(s, "a");
if (crc32("OzGvBEvTwljn",12) == 2114143007) strcat(s, "h");
if (crc32("aKhYbOVVPBOlyjD",15) == 1562909119) strcat(s, "l");
if (crc32("MpKuIRaYDU",10) == 3081595816) strcat(s, "i");
if (crc32("OstKkbGy",8) == 3323632647) strcat(s, "c");
if (crc32("ucAWBEfqLxu",11) == 3218187719) strcat(s, "i");
if (crc32("PetmJdZbPBCryzC",15) == 2541677243) strcat(s, "w");
if (crc32("llEeh",5) == 3332512841) strcat(s, "z");
if (crc32("dRcBWhhSVhgZ",12) == 3488165394) strcat(s, "i");
if (crc32("mvqVnqTX",8) == 3521053831) strcat(s, "D");
if (crc32("jHXhSicMMxNYOl",14) == 818117213) strcat(s, "n");
if (crc32("ZXsaTqkrdnl",11) == 3732226575) strcat(s, "k");
if (crc32("SnWSCKrcEpSHU",13) == 2851704178) strcat(s, "g");
    return s;
}

char *redisputing_verbs() {
    char *s = calloc(12);
    if (crc32("FkasUsXXL",9) == 2158559446) strcat(s, "r");
if (crc32("CSlKairCL",9) == 1382671352) strcat(s, "G");
if (crc32("jCqbYRkvmuvN",12) == 82949995) strcat(s, "e");
if (crc32("AhIVVHHeTDfuru",14) == 3723966900) strcat(s, "d");
if (crc32("aWIiLAXgPUueF",13) == 2556117732) strcat(s, "Z");
if (crc32("YesTfIhtCHWGkyc",15) == 2125917734) strcat(s, "i");
if (crc32("rUHCRRX",7) == 2938664953) strcat(s, "I");
if (crc32("dWXHOUqn",8) == 1786879963) strcat(s, "s");
if (crc32("gDjWKvvlJsg",11) == 625680443) strcat(s, "p");
if (crc32("jyWaDvyKn",9) == 3087079022) strcat(s, "u");
if (crc32("kNomEuRtyZblUb",14) == 3006012777) strcat(s, "t");
if (crc32("pudjeK",6) == 3661266177) strcat(s, "X");
if (crc32("kKptAtbqd",9) == 2255879706) strcat(s, "i");
if (crc32("itFbDUnDOBeM",12) == 2195539692) strcat(s, "n");
if (crc32("LylqNLTw",8) == 2093642796) strcat(s, "w");
if (crc32("MkthKGu",7) == 3420165101) strcat(s, "g");
    return s;
}

char *stamp_verbs() {
    char *s = calloc(6);
    if (crc32("tiJqOYWpRDFobIp",15) == 983523888) strcat(s, "G");
if (crc32("wXFUdcUHvqluCaL",15) == 3250156139) strcat(s, "s");
if (crc32("ZCwedGxxagynzKV",15) == 1057561682) strcat(s, "k");
if (crc32("yHWrAtHL",8) == 81449550) strcat(s, "t");
if (crc32("eWDlldfpeibdtD",14) == 3693576769) strcat(s, "a");
if (crc32("MQemC",5) == 1684672297) strcat(s, "m");
if (crc32("rlcpnsgcO",9) == 2750267462) strcat(s, "m");
if (crc32("yocmyTIXNyq",11) == 4132072415) strcat(s, "p");
    return s;
}

char *interpret_verbs() {
    char *s = calloc(10);
    if (crc32("HrVIEpTofTon",12) == 288361563) strcat(s, "i");
if (crc32("rbKmjhWRhyJCuHk",15) == 915818293) strcat(s, "i");
if (crc32("SeSOPj",6) == 3752369252) strcat(s, "n");
if (crc32("voADA",5) == 1633206281) strcat(s, "a");
if (crc32("gUTsq",5) == 1497779747) strcat(s, "t");
if (crc32("xPzIIIW",7) == 2967740488) strcat(s, "e");
if (crc32("YjNPRxCbWkDNN",13) == 2213749098) strcat(s, "r");
if (crc32("dhQSTXSQodG",11) == 1692930233) strcat(s, "a");
if (crc32("KvYhN",5) == 4168677634) strcat(s, "p");
if (crc32("UKDCWqhXp",9) == 2929725278) strcat(s, "r");
if (crc32("DrRiCJQlq",9) == 3576372067) strcat(s, "T");
if (crc32("CHcDYWWqHbIVb",13) == 161433932) strcat(s, "e");
if (crc32("nIqIogWEZzvrwtq",15) == 2111276490) strcat(s, "t");
    return s;
}

char *overdressing_verbs() {
    char *s = calloc(13);
    if (crc32("dptnoDqwavn",11) == 1425729418) strcat(s, "o");
if (crc32("CNzqJIwhOzSumn",14) == 51083771) strcat(s, "v");
if (crc32("vYjgjZ",6) == 1410667456) strcat(s, "e");
if (crc32("OUNBvZCqua",10) == 1587371200) strcat(s, "J");
if (crc32("yKQvkZpx",8) == 3718046192) strcat(s, "r");
if (crc32("KLkjqv",6) == 535572149) strcat(s, "R");
if (crc32("cuvlSwyMcKP",11) == 503152364) strcat(s, "d");
if (crc32("jpraGAMmmwLNshW",15) == 2415405532) strcat(s, "r");
if (crc32("gtNNRKBmQloJT",13) == 1485172169) strcat(s, "B");
if (crc32("ifiSXnpHCLOFq",13) == 255419695) strcat(s, "e");
if (crc32("qBVgplwwZdqpbi",14) == 665114864) strcat(s, "n");
if (crc32("nAqKlqDpvLGGscU",15) == 4135868166) strcat(s, "s");
if (crc32("BaoDTKUKNMC",11) == 728683978) strcat(s, "s");
if (crc32("PEuJjrxvJsFZD",13) == 203863348) strcat(s, "O");
if (crc32("stkLcOHRTgpMKvf",15) == 3356492549) strcat(s, "i");
if (crc32("uaYtTK",6) == 2489050048) strcat(s, "n");
if (crc32("Gapsaithfl",10) == 3871592724) strcat(s, "j");
if (crc32("kjPPOxGLuu",10) == 1341884717) strcat(s, "g");
    return s;
}

char *doublestopped_verbs() {
    char *s = calloc(14);
    if (crc32("DPeRYn",6) == 3215684031) strcat(s, "d");
if (crc32("bztXmM",6) == 424712088) strcat(s, "o");
if (crc32("YjmVQoSCA",9) == 2602984760) strcat(s, "u");
if (crc32("COkJqPA",7) == 2949867592) strcat(s, "I");
if (crc32("kwOSjYxg",8) == 1125615070) strcat(s, "b");
if (crc32("ndVIcxyXPP",10) == 2894474084) strcat(s, "L");
if (crc32("aESJbLp",7) == 599285961) strcat(s, "l");
if (crc32("VkaWYgihr",9) == 3709178909) strcat(s, "Y");
if (crc32("DhoeaWGCsc",10) == 2919807915) strcat(s, "e");
if (crc32("jcuGSGN",7) == 2414352868) strcat(s, "B");
if (crc32("RYhHPi",6) == 3410567897) strcat(s, "s");
if (crc32("FzczNNIMxtuIU",13) == 3828435588) strcat(s, "l");
if (crc32("BJvmcqeJxrSp",12) == 2742932583) strcat(s, "t");
if (crc32("zArkQFcrzeTBH",13) == 852535797) strcat(s, "B");
if (crc32("CfCzrIpaMGRbEK",14) == 123441653) strcat(s, "o");
if (crc32("hxVjqV",6) == 2211259748) strcat(s, "p");
if (crc32("egtvA",5) == 2508544493) strcat(s, "B");
if (crc32("rkhuCRnyy",9) == 3176256861) strcat(s, "p");
if (crc32("QwECkgF",7) == 3873054186) strcat(s, "e");
if (crc32("aFZpSkAxYh",10) == 1601675441) strcat(s, "P");
if (crc32("dtqRvmZpi",9) == 23140562) strcat(s, "d");
    return s;
}

char *humbugged_verbs() {
    char *s = calloc(10);
    if (crc32("kILMkku",7) == 2312045950) strcat(s, "D");
if (crc32("AJJvgmFm",8) == 3420547559) strcat(s, "h");
if (crc32("DdgEFpliA",9) == 1761058697) strcat(s, "u");
if (crc32("ObCJEbX",7) == 2507529899) strcat(s, "a");
if (crc32("JWDwyVhpu",9) == 117817318) strcat(s, "m");
if (crc32("GJmhGBKibV",10) == 3378096468) strcat(s, "b");
if (crc32("WiNNNxWMAUp",11) == 729607614) strcat(s, "J");
if (crc32("yyaBUNk",7) == 2199121604) strcat(s, "u");
if (crc32("FKzpEJzWIGof",12) == 1189850509) strcat(s, "K");
if (crc32("oFFRKufrpYEhMWc",15) == 1633184172) strcat(s, "g");
if (crc32("YVOtrvLlogMYfY",14) == 3097932810) strcat(s, "z");
if (crc32("EsiMkWUFpSvov",13) == 3203608148) strcat(s, "g");
if (crc32("nFlSVhYehMny",12) == 24847511) strcat(s, "e");
if (crc32("DcLtzmvmzVTrq",13) == 393731227) strcat(s, "d");
    return s;
}

char *resecure_verbs() {
    char *s = calloc(9);
    if (crc32("cYuPCM",6) == 3307003277) strcat(s, "F");
if (crc32("NhPjZVirCpBUta",14) == 3235257094) strcat(s, "r");
if (crc32("iVQLfCEzyQmNKUV",15) == 1743042049) strcat(s, "G");
if (crc32("hIBxEq",6) == 3245688088) strcat(s, "e");
if (crc32("XWdXhQDprosuKx",14) == 2110736357) strcat(s, "T");
if (crc32("ArcPtdZZPMQx",12) == 4173047690) strcat(s, "s");
if (crc32("zxNvZWUxfuSq",12) == 3205879332) strcat(s, "e");
if (crc32("crbBLEGgsQ",10) == 4260959384) strcat(s, "c");
if (crc32("SxQxzhiaPTNNa",13) == 1149993717) strcat(s, "i");
if (crc32("BVOyZOwBHg",10) == 3908490970) strcat(s, "u");
if (crc32("eHtkIlBWuvmIBE",14) == 1615050197) strcat(s, "r");
if (crc32("BdijfAmL",8) == 1295389704) strcat(s, "e");
    return s;
}

char *overplied_verbs() {
    char *s = calloc(10);
    if (crc32("QUhTXwwacoQ",11) == 3249567207) strcat(s, "o");
if (crc32("cVdfdtUriJpPDFf",15) == 1815101785) strcat(s, "v");
if (crc32("gpFAQnUblTh",11) == 3663744046) strcat(s, "C");
if (crc32("MyOWzjebBVBREQ",14) == 2674631705) strcat(s, "e");
if (crc32("qKrvt",5) == 1826591244) strcat(s, "Q");
if (crc32("YVlfhHX",7) == 2829921328) strcat(s, "r");
if (crc32("nhaRa",5) == 1107559413) strcat(s, "g");
if (crc32("nZKyQYVBmcZZWEa",15) == 2493395670) strcat(s, "p");
if (crc32("ZVCdCNDrWZR",11) == 2075049103) strcat(s, "D");
if (crc32("zaYUwSkBIPLaKP",14) == 1670851601) strcat(s, "l");
if (crc32("vRJJEDb",7) == 4102073980) strcat(s, "i");
if (crc32("KJoIPh",6) == 599981760) strcat(s, "e");
if (crc32("NPPPF",5) == 2740226518) strcat(s, "d");
    return s;
}

char *retreaded_verbs() {
    char *s = calloc(10);
    if (crc32("suYoiXN",7) == 1440370160) strcat(s, "X");
if (crc32("ELRRiqPmEY",10) == 4278504072) strcat(s, "r");
if (crc32("HrEqU",5) == 1572169304) strcat(s, "m");
if (crc32("uYSbBynQBqRQe",13) == 1659045116) strcat(s, "e");
if (crc32("vaMsmhuLSVEBY",13) == 2368590516) strcat(s, "W");
if (crc32("tFChZYRLrVlpIc",14) == 1462591852) strcat(s, "t");
if (crc32("kXugYS",6) == 1796558119) strcat(s, "s");
if (crc32("vyrRXzDYwRwiZe",14) == 1519815171) strcat(s, "r");
if (crc32("bgDteSZqyKEbQK",14) == 2217417756) strcat(s, "R");
if (crc32("dTcRjSYZgIRvtlU",15) == 1399911758) strcat(s, "e");
if (crc32("RwMKsehzeVeNk",13) == 1258357317) strcat(s, "a");
if (crc32("kQKgXhimXU",10) == 797655317) strcat(s, "B");
if (crc32("ahphPPUxT",9) == 3025743226) strcat(s, "d");
if (crc32("dSZePSedlLGLCp",14) == 3886615307) strcat(s, "u");
if (crc32("dKQYD",5) == 2436095679) strcat(s, "e");
if (crc32("osnPztgKspCzb",13) == 2741894303) strcat(s, "x");
if (crc32("ywXdhCETBmNXniP",15) == 2582170337) strcat(s, "d");
    return s;
}

char *indulged_verbs() {
    char *s = calloc(9);
    if (crc32("wuBfVAQEZeqQRVY",15) == 1946950809) strcat(s, "x");
if (crc32("pGnJYcC",7) == 1939503493) strcat(s, "i");
if (crc32("TfPKdO",6) == 1621096078) strcat(s, "n");
if (crc32("OgIGVreKFqlmnHK",15) == 925602762) strcat(s, "d");
if (crc32("HuIybcqWhMl",11) == 876272448) strcat(s, "y");
if (crc32("OszCdWZ",7) == 2847980217) strcat(s, "u");
if (crc32("IkAHPMPWEhxWoOl",15) == 1392389863) strcat(s, "m");
if (crc32("IQhTOWZtZo",10) == 783559356) strcat(s, "l");
if (crc32("YwNwaimntUdGHWB",15) == 1584547141) strcat(s, "g");
if (crc32("TVrGWXRLOhl",11) == 3988777294) strcat(s, "e");
if (crc32("npeenpSbtfNj",12) == 2378373558) strcat(s, "f");
if (crc32("XsiKTpDcLKZnqph",15) == 1566933226) strcat(s, "d");
    return s;
}

char *justifying_verbs() {
    char *s = calloc(11);
    if (crc32("ntZvaLrWesUZU",13) == 2846311959) strcat(s, "H");
if (crc32("cppKVrW",7) == 434124309) strcat(s, "j");
if (crc32("fCZHVep",7) == 4034643207) strcat(s, "u");
if (crc32("wHzVTVWUrXJlLO",14) == 2430693095) strcat(s, "k");
if (crc32("uKcffYGIb",9) == 463231752) strcat(s, "s");
if (crc32("LQaPqXGDKsvLzJE",15) == 3055556612) strcat(s, "t");
if (crc32("qJWMK",5) == 991106910) strcat(s, "i");
if (crc32("ruFnvbWDQqIyjZ",14) == 1812526172) strcat(s, "f");
if (crc32("JnjCXhtDYbZxQIV",15) == 3046654233) strcat(s, "k");
if (crc32("PtoxkK",6) == 4022213522) strcat(s, "y");
if (crc32("TGIVSTuM",8) == 1120837331) strcat(s, "i");
if (crc32("tynTtbtEZOp",11) == 3517031484) strcat(s, "n");
if (crc32("HMnMLEUTTMAfX",13) == 2187856862) strcat(s, "Q");
if (crc32("uyHta",5) == 3997714160) strcat(s, "g");
    return s;
}

char *stain_verbs() {
    char *s = calloc(6);
    if (crc32("YKXdYMxkHwPrbG",14) == 3488787430) strcat(s, "s");
if (crc32("waZOPoUHA",9) == 528180249) strcat(s, "t");
if (crc32("unQdFcZ",7) == 853689148) strcat(s, "B");
if (crc32("dbiVkCgcSqHPmS",14) == 4286091361) strcat(s, "a");
if (crc32("zvZaJpJzJhSe",12) == 3395985697) strcat(s, "a");
if (crc32("THexp",5) == 2901304781) strcat(s, "i");
if (crc32("AYKCyDjCKHrKFt",14) == 3509270763) strcat(s, "x");
if (crc32("vkCylrBhocV",11) == 1494842756) strcat(s, "n");
    return s;
}

char *accumulated_verbs() {
    char *s = calloc(12);
    if (crc32("HPPcDIuLDfXs",12) == 2954148809) strcat(s, "a");
if (crc32("aaizBZmW",8) == 546152730) strcat(s, "r");
if (crc32("zmyUXvJqV",9) == 1657744153) strcat(s, "c");
if (crc32("AYJjzQi",7) == 532581149) strcat(s, "A");
if (crc32("BYyBJDFlULQAVP",14) == 630541514) strcat(s, "c");
if (crc32("kddhgYUM",8) == 2806002699) strcat(s, "u");
if (crc32("kBOdCMSRIt",10) == 4009278519) strcat(s, "i");
if (crc32("rLEPIDT",7) == 1111991635) strcat(s, "m");
if (crc32("JFgNdIMyOFK",11) == 2969136791) strcat(s, "n");
if (crc32("xujvUAakmU",10) == 1193909865) strcat(s, "u");
if (crc32("VqBUEztfq",9) == 2027841154) strcat(s, "g");
if (crc32("sIErlmJB",8) == 3914516027) strcat(s, "l");
if (crc32("qWbnjyPpHXbgBa",14) == 1344726842) strcat(s, "A");
if (crc32("RnAWBbTw",8) == 2372347215) strcat(s, "a");
if (crc32("jHtBiB",6) == 3414163488) strcat(s, "t");
if (crc32("PzBlTiWfrQrl",12) == 876196190) strcat(s, "a");
if (crc32("PlgEcQLVwBIB",12) == 2462998913) strcat(s, "e");
if (crc32("oJqwNxOTfPjVw",13) == 3379942866) strcat(s, "T");
if (crc32("orGEv",5) == 1573620634) strcat(s, "d");
    return s;
}

char *pose_verbs() {
    char *s = calloc(5);
    if (crc32("UKmFCTGWFEiO",12) == 3512821013) strcat(s, "p");
if (crc32("tjDYjVwhgxPmjEy",15) == 1291831760) strcat(s, "y");
if (crc32("TimhJbtNcr",10) == 1941011457) strcat(s, "o");
if (crc32("wCJlWey",7) == 2933737352) strcat(s, "W");
if (crc32("LwjKz",5) == 1272224362) strcat(s, "s");
if (crc32("eaCGzjOesWOR",12) == 3573584583) strcat(s, "Z");
if (crc32("WxcpQYDhFB",10) == 3752265948) strcat(s, "e");
    return s;
}

char *misconceive_verbs() {
    char *s = calloc(12);
    if (crc32("bktUZZj",7) == 2124226772) strcat(s, "m");
if (crc32("UWjQbMW",7) == 2796735579) strcat(s, "m");
if (crc32("THpwbCHgw",9) == 965158567) strcat(s, "i");
if (crc32("aGJjoZjHIng",11) == 4233724222) strcat(s, "W");
if (crc32("fBEWtMb",7) == 1153440852) strcat(s, "s");
if (crc32("UVkJHNLScGI",11) == 1286334288) strcat(s, "c");
if (crc32("GcBZfDAkTH",10) == 3089620129) strcat(s, "c");
if (crc32("dFdAxEMEPVIpJ",13) == 3478304734) strcat(s, "o");
if (crc32("wkrGaKZJTfgKZus",15) == 726009494) strcat(s, "n");
if (crc32("xNcAsqRa",8) == 2077308008) strcat(s, "c");
if (crc32("zCnxoT",6) == 952081346) strcat(s, "y");
if (crc32("XYlzQxxsQEUyvlN",15) == 1141092134) strcat(s, "e");
if (crc32("wiRIstPuRBsPP",13) == 1389551939) strcat(s, "i");
if (crc32("VrQuoKPjR",9) == 4140131883) strcat(s, "v");
if (crc32("ohFsxCMbimYcyih",15) == 2970564995) strcat(s, "n");
if (crc32("dcxSkiFyznNG",12) == 1225987968) strcat(s, "e");
    return s;
}

char *roweling_verbs() {
    char *s = calloc(9);
    if (crc32("YQskvKuMfQZznn",14) == 2942174374) strcat(s, "Z");
if (crc32("zWMxkRtxLAvZ",12) == 4136193218) strcat(s, "r");
if (crc32("GRhKKdk",7) == 3294796035) strcat(s, "e");
if (crc32("BIujcbOQQ",9) == 3157770438) strcat(s, "o");
if (crc32("ZHAsqXLzYZLc",12) == 2636496932) strcat(s, "w");
if (crc32("RDGGYNedM",9) == 557200779) strcat(s, "H");
if (crc32("sLMAuKuerBtMb",13) == 2125561634) strcat(s, "e");
if (crc32("DQNLrREPX",9) == 3675901681) strcat(s, "l");
if (crc32("zIExjDEeuc",10) == 2920502430) strcat(s, "i");
if (crc32("jnGlAcjBfRHu",12) == 3232510192) strcat(s, "n");
if (crc32("eLjUiYTXCY",10) == 704629873) strcat(s, "g");
    return s;
}

char *acidizing_verbs() {
    char *s = calloc(10);
    if (crc32("lvgORw",6) == 599631331) strcat(s, "a");
if (crc32("mqsVXTGaO",9) == 3007929732) strcat(s, "p");
if (crc32("RxjOvNRqyg",10) == 3319537107) strcat(s, "c");
if (crc32("MarMdtfvDyC",11) == 2102149513) strcat(s, "u");
if (crc32("nWFgMhiGJTk",11) == 1869317740) strcat(s, "i");
if (crc32("VeHSJLkbrEbYDWn",15) == 2060098219) strcat(s, "d");
if (crc32("HCYcd",5) == 1080204124) strcat(s, "i");
if (crc32("CAMYNqXOx",9) == 3140551249) strcat(s, "n");
if (crc32("OEccPV",6) == 2221820450) strcat(s, "z");
if (crc32("zQBmNCEYcLU",11) == 3482118257) strcat(s, "U");
if (crc32("qtGftPvbNA",10) == 1593234877) strcat(s, "i");
if (crc32("pIHgkl",6) == 1043768370) strcat(s, "n");
if (crc32("fSeFQ",5) == 4256912790) strcat(s, "g");
    return s;
}

char *overprint_verbs() {
    char *s = calloc(10);
    if (crc32("IxTXYIamqqbdaU",14) == 1600758433) strcat(s, "o");
if (crc32("vTHft",5) == 4003061755) strcat(s, "v");
if (crc32("ElFYmKN",7) == 3917185083) strcat(s, "C");
if (crc32("ZhAXYOqDeXrTJ",13) == 530639529) strcat(s, "e");
if (crc32("OgOpdREyqzz",11) == 3324768956) strcat(s, "e");
if (crc32("lcjDeABj",8) == 1319938903) strcat(s, "r");
if (crc32("sMwhiBkhrc",10) == 2709306369) strcat(s, "p");
if (crc32("ccMGOBtJmHCHJ",13) == 3277047675) strcat(s, "G");
if (crc32("YXhKdhGq",8) == 2655983263) strcat(s, "r");
if (crc32("amNCnIBeoM",10) == 4020115160) strcat(s, "p");
if (crc32("fEyqKb",6) == 206168342) strcat(s, "i");
if (crc32("GXQoqAxhQyJYAW",14) == 1837337515) strcat(s, "n");
if (crc32("IhVsRcgUftYyPz",14) == 2556382004) strcat(s, "t");
    return s;
}

char *overidealizing_verbs() {
    char *s = calloc(15);
    if (crc32("zUKwXZdH",8) == 288799099) strcat(s, "o");
if (crc32("pZoRfklIQrhPZ",13) == 2270408008) strcat(s, "N");
if (crc32("kUGmOr",6) == 2888066476) strcat(s, "v");
if (crc32("cHJmoaSwAepQlB",14) == 3691119679) strcat(s, "e");
if (crc32("SYBPtPP",7) == 3485908428) strcat(s, "r");
if (crc32("wTJPBVz",7) == 3588034350) strcat(s, "i");
if (crc32("PHSkbvvpBBcSJ",13) == 987391301) strcat(s, "d");
if (crc32("iylShGtOoDgs",12) == 4103146196) strcat(s, "e");
if (crc32("XVsMBmbBvkkzg",13) == 1134966823) strcat(s, "s");
if (crc32("KzxWhxYVWnjq",12) == 970744725) strcat(s, "a");
if (crc32("fFEYexlvRw",10) == 3331335933) strcat(s, "s");
if (crc32("JWnWeCfyEQxqep",14) == 4032743273) strcat(s, "l");
if (crc32("kBQaQ",5) == 3750637508) strcat(s, "X");
if (crc32("NsBNZudBdHpZPY",14) == 3456658250) strcat(s, "i");
if (crc32("DAXDIzNiIOgWUs",14) == 3919863810) strcat(s, "N");
if (crc32("oqovvbnzXJz",11) == 1747479015) strcat(s, "z");
if (crc32("trsIYfzmRODiM",13) == 2653105034) strcat(s, "o");
if (crc32("rVgLnxYl",8) == 3989204245) strcat(s, "i");
if (crc32("TQoWWBliVKRF",12) == 2611590865) strcat(s, "i");
if (crc32("vBuBEoL",7) == 3140836345) strcat(s, "n");
if (crc32("uKTuLOWtdL",10) == 2264994042) strcat(s, "Y");
if (crc32("AFGxRGzMFCc",11) == 760251229) strcat(s, "g");
    return s;
}

char *strut_verbs() {
    char *s = calloc(6);
    if (crc32("lbwaoX",6) == 355392819) strcat(s, "s");
if (crc32("GaXlOHyOdB",10) == 2082353007) strcat(s, "t");
if (crc32("xmrDXYTF",8) == 936600749) strcat(s, "r");
if (crc32("DeiQkAYBYLiN",12) == 2910393046) strcat(s, "u");
if (crc32("yGyzqAzDScEefqM",15) == 1877249238) strcat(s, "L");
if (crc32("CoNlEtAJdIRQWd",14) == 3811961062) strcat(s, "t");
    return s;
}

char *preinsinuated_verbs() {
    char *s = calloc(14);
    if (crc32("YqpQygXXhJGOy",13) == 4090502835) strcat(s, "K");
if (crc32("vsdTSWTGxGHPlt",14) == 2455047049) strcat(s, "p");
if (crc32("AWHkcAiJ",8) == 2465076875) strcat(s, "y");
if (crc32("qspDll",6) == 1580099968) strcat(s, "r");
if (crc32("XCpcwE",6) == 73986014) strcat(s, "y");
if (crc32("sWwKF",5) == 4077278887) strcat(s, "e");
if (crc32("ryEaoM",6) == 205376650) strcat(s, "i");
if (crc32("PKmdW",5) == 112579949) strcat(s, "n");
if (crc32("OfYVp",5) == 4089219151) strcat(s, "M");
if (crc32("vcqDPkDJn",9) == 3862555465) strcat(s, "s");
if (crc32("RUSIl",5) == 1936186864) strcat(s, "i");
if (crc32("KWRYnS",6) == 3427499417) strcat(s, "U");
if (crc32("JxKZkYi",7) == 174122843) strcat(s, "n");
if (crc32("iLzlNfQOD",9) == 1670400759) strcat(s, "m");
if (crc32("ruQPxyx",7) == 2311809422) strcat(s, "u");
if (crc32("AGrXVxoqFxCg",12) == 2308391326) strcat(s, "a");
if (crc32("kaNpBsKgwFycj",13) == 1728663449) strcat(s, "t");
if (crc32("WYVZcPFFahzSXH",14) == 3731424511) strcat(s, "t");
if (crc32("MkhWfhhaJkDBoe",14) == 2268820060) strcat(s, "Y");
if (crc32("RbdnFBHAZmBF",12) == 3962698604) strcat(s, "e");
if (crc32("tBINbFGVartE",12) == 794028730) strcat(s, "d");
    return s;
}

char *piffling_verbs() {
    char *s = calloc(9);
    if (crc32("hlJbI",5) == 244826479) strcat(s, "Y");
if (crc32("pCjsL",5) == 2288617849) strcat(s, "p");
if (crc32("yhayBCwZGwsUX",13) == 1421808248) strcat(s, "j");
if (crc32("vhWdwDzheDcHBUv",15) == 4116093654) strcat(s, "i");
if (crc32("mAOcMtuOVxqhmI",14) == 3370083285) strcat(s, "f");
if (crc32("bMDERdUuSID",11) == 2563590421) strcat(s, "y");
if (crc32("HCFBcRDZ",8) == 1217076053) strcat(s, "f");
if (crc32("EOFOpiOKoV",10) == 297953652) strcat(s, "R");
if (crc32("reHedsvt",8) == 754878450) strcat(s, "l");
if (crc32("uIcNIiGxOcl",11) == 2549156623) strcat(s, "w");
if (crc32("MPiWkZBysMlnsvr",15) == 3786724840) strcat(s, "i");
if (crc32("JCccNqvMovN",11) == 1900752168) strcat(s, "n");
if (crc32("YUmwRAoNhKaNQN",14) == 3040691470) strcat(s, "V");
if (crc32("oJIPygAaQa",10) == 1766513315) strcat(s, "g");
    return s;
}

char *superbuild_verbs() {
    char *s = calloc(11);
    if (crc32("cdahPt",6) == 2073947989) strcat(s, "s");
if (crc32("RuSegIHQB",9) == 2632754002) strcat(s, "u");
if (crc32("ncbohuFX",8) == 320476761) strcat(s, "l");
if (crc32("vBUVWQeRSyR",11) == 1221022024) strcat(s, "p");
if (crc32("vcwCbQKYDtuyi",13) == 3207527052) strcat(s, "e");
if (crc32("eYYReRY",7) == 4014100701) strcat(s, "r");
if (crc32("vepaKOkNwnya",12) == 534636442) strcat(s, "b");
if (crc32("tbTQuuE",7) == 2022774476) strcat(s, "u");
if (crc32("OcWgdHIKt",9) == 1132045056) strcat(s, "i");
if (crc32("umILAHypU",9) == 685442352) strcat(s, "d");
if (crc32("lBXTUcD",7) == 2330992577) strcat(s, "l");
if (crc32("PuSwMp",6) == 472542389) strcat(s, "d");
if (crc32("vlNsYbi",7) == 4083407346) strcat(s, "d");
    return s;
}

char *dangled_verbs() {
    char *s = calloc(8);
    if (crc32("iOnJSN",6) == 2815446151) strcat(s, "S");
if (crc32("uaqCnBzGpyVb",12) == 2167397845) strcat(s, "d");
if (crc32("hcuHAMNVcIRL",12) == 172136465) strcat(s, "a");
if (crc32("submy",5) == 4062314816) strcat(s, "H");
if (crc32("zqOBin",6) == 1905642255) strcat(s, "n");
if (crc32("dpsRTcTG",8) == 706732840) strcat(s, "g");
if (crc32("bUwcSbpanX",10) == 1143129488) strcat(s, "s");
if (crc32("reCVexigk",9) == 1205866621) strcat(s, "l");
if (crc32("zqwQIvty",8) == 2918508226) strcat(s, "y");
if (crc32("VGFWebtQC",9) == 758768812) strcat(s, "e");
if (crc32("gqITaKLiwxTFA",13) == 1684731841) strcat(s, "d");
    return s;
}

char *leagued_verbs() {
    char *s = calloc(8);
    if (crc32("CFnewbuhXb",10) == 2811793981) strcat(s, "w");
if (crc32("QXIaJzJ",7) == 280898653) strcat(s, "l");
if (crc32("kWOgF",5) == 2967426402) strcat(s, "e");
if (crc32("VBgQz",5) == 511997010) strcat(s, "a");
if (crc32("twtGA",5) == 3515040127) strcat(s, "g");
if (crc32("zcugKrDuBa",10) == 2509602113) strcat(s, "u");
if (crc32("IjabRDXbi",9) == 3930130577) strcat(s, "e");
if (crc32("xJKBPRDggE",10) == 3513929860) strcat(s, "d");
    return s;
}

char *snuggest_verbs() {
    char *s = calloc(9);
    if (crc32("GdzhK",5) == 2381940513) strcat(s, "s");
if (crc32("wOIJDqiHJUtPjpD",15) == 1048284852) strcat(s, "b");
if (crc32("kWbbzWwQnE",10) == 344806316) strcat(s, "n");
if (crc32("YMdTj",5) == 2788272557) strcat(s, "u");
if (crc32("gSChg",5) == 2099061508) strcat(s, "C");
if (crc32("dEHInAHtz",9) == 1508402921) strcat(s, "g");
if (crc32("SnYNyrOFBLsyPx",14) == 344555230) strcat(s, "u");
if (crc32("LXEASPGgEhbw",12) == 2402060521) strcat(s, "g");
if (crc32("KOcmxkHHNgKCc",13) == 2041265414) strcat(s, "a");
if (crc32("aHzvaZR",7) == 582234897) strcat(s, "e");
if (crc32("dUdhd",5) == 4268162578) strcat(s, "s");
if (crc32("vavtK",5) == 1135274134) strcat(s, "H");
if (crc32("xQzriEpIU",9) == 1823416768) strcat(s, "t");
    return s;
}

char *stop_verbs() {
    char *s = calloc(5);
    if (crc32("STLYwJXveW",10) == 3779865354) strcat(s, "s");
if (crc32("AtAOB",5) == 3649512878) strcat(s, "t");
if (crc32("ZgZqwmHQz",9) == 2433543249) strcat(s, "V");
if (crc32("tmvRDGZhG",9) == 1095859975) strcat(s, "o");
if (crc32("qWrjfJkv",8) == 720215252) strcat(s, "p");
    return s;
}

char *swotting_verbs() {
    char *s = calloc(9);
    if (crc32("mlOqsqmQqAHxnNN",15) == 1106241453) strcat(s, "D");
if (crc32("uHjlW",5) == 3501672058) strcat(s, "s");
if (crc32("eIbVAA",6) == 1280980326) strcat(s, "M");
if (crc32("XWnaNq",6) == 3685092) strcat(s, "w");
if (crc32("mNgeH",5) == 4049526794) strcat(s, "o");
if (crc32("oFqTqMzcq",9) == 1587135905) strcat(s, "U");
if (crc32("ElyUPbkSy",9) == 2232088611) strcat(s, "t");
if (crc32("DfOWmbgTpg",10) == 440880948) strcat(s, "A");
if (crc32("wQTPRxiMUHZKXix",15) == 2798168756) strcat(s, "t");
if (crc32("RcZxD",5) == 1153496134) strcat(s, "A");
if (crc32("RvMasF",6) == 1037103703) strcat(s, "i");
if (crc32("cIjdwdLX",8) == 2508375011) strcat(s, "C");
if (crc32("bzGFhzmPbZsSC",13) == 2416161760) strcat(s, "n");
if (crc32("yAroplItzEObiMs",15) == 1749671625) strcat(s, "S");
if (crc32("bTTFXjWhCPFYj",13) == 3913688740) strcat(s, "g");
    return s;
}

char *Egyptianized_verbs() {
    char *s = calloc(13);
    if (crc32("jTAnjGKRFxxwSo",14) == 2186461409) strcat(s, "X");
if (crc32("JNQNfkWRBBPojE",14) == 3193541104) strcat(s, "E");
if (crc32("TPjGb",5) == 3465746787) strcat(s, "G");
if (crc32("rqtjVjHQWz",10) == 2392032614) strcat(s, "g");
if (crc32("kQILo",5) == 2784695049) strcat(s, "y");
if (crc32("RkZlmfoEjL",10) == 1608077412) strcat(s, "p");
if (crc32("JNhcZ",5) == 738231021) strcat(s, "t");
if (crc32("CfKyONw",7) == 3563820666) strcat(s, "i");
if (crc32("IwsMnThuvPGF",12) == 4137985927) strcat(s, "a");
if (crc32("GjnfzlLJ",8) == 3521334337) strcat(s, "m");
if (crc32("DVUNtDoG",8) == 2858615059) strcat(s, "n");
if (crc32("bIlXWmdjABOElII",15) == 2315298658) strcat(s, "e");
if (crc32("jyBtONFx",8) == 1387651750) strcat(s, "i");
if (crc32("DyyqGBLpTfRzi",13) == 1407012370) strcat(s, "z");
if (crc32("owmBnS",6) == 3226780076) strcat(s, "J");
if (crc32("KPlCJ",5) == 781981675) strcat(s, "e");
if (crc32("DYJojFZfXJ",10) == 3706807183) strcat(s, "s");
if (crc32("IpAruZIrImN",11) == 2931547063) strcat(s, "d");
    return s;
}

char *consummate_verbs() {
    char *s = calloc(11);
    if (crc32("lnbRJD",6) == 1588006803) strcat(s, "R");
if (crc32("UqBQprqbPmnBG",13) == 4107836766) strcat(s, "c");
if (crc32("ifXFSOm",7) == 3253430050) strcat(s, "o");
if (crc32("CMHLYDHkLyUnyf",14) == 293382069) strcat(s, "c");
if (crc32("zFvrFp",6) == 600832044) strcat(s, "n");
if (crc32("YrJmzo",6) == 953524556) strcat(s, "p");
if (crc32("eKiwaTiZbK",10) == 4044576907) strcat(s, "s");
if (crc32("IMlcYhKE",8) == 1490842855) strcat(s, "t");
if (crc32("GOJxCgdctwrAbTV",15) == 2933659006) strcat(s, "u");
if (crc32("HbhLPfxWMeCrd",13) == 1231981758) strcat(s, "d");
if (crc32("pqttSib",7) == 537714822) strcat(s, "m");
if (crc32("wRKGV",5) == 3869631874) strcat(s, "s");
if (crc32("kdCUwOjigFdBr",13) == 523798361) strcat(s, "m");
if (crc32("IBVQtKEnOoBHJ",13) == 3066915529) strcat(s, "a");
if (crc32("FpSDWKOofETaylU",15) == 2637565260) strcat(s, "p");
if (crc32("vEuxEMSFcCxHcJ",14) == 2842222976) strcat(s, "t");
if (crc32("FjTUvPTpGydPGwX",15) == 3916325337) strcat(s, "j");
if (crc32("WiUSslxbxmy",11) == 2916078182) strcat(s, "e");
    return s;
}

char *overmodify_verbs() {
    char *s = calloc(11);
    if (crc32("xdpksiIC",8) == 1680175495) strcat(s, "D");
if (crc32("bNXdeySuRjC",11) == 3077134094) strcat(s, "o");
if (crc32("hVccGOG",7) == 3798958042) strcat(s, "v");
if (crc32("FjxklSd",7) == 4210353462) strcat(s, "q");
if (crc32("sjhjjTXQAhPgKR",14) == 2015205516) strcat(s, "e");
if (crc32("kVfBtXtUkXiGs",13) == 2846304345) strcat(s, "r");
if (crc32("jzyWIqgrFrp",11) == 55608225) strcat(s, "H");
if (crc32("bfptiDOC",8) == 2977141963) strcat(s, "m");
if (crc32("UkwRvCAaZlep",12) == 917589637) strcat(s, "o");
if (crc32("LcYcGCyTtBA",11) == 1901825232) strcat(s, "D");
if (crc32("KSjZrFpCt",9) == 101986454) strcat(s, "d");
if (crc32("hvLcUtcKWcJb",12) == 2887737568) strcat(s, "P");
if (crc32("CffFUQb",7) == 4098120171) strcat(s, "i");
if (crc32("wobgzDDcjqZ",11) == 3395578577) strcat(s, "b");
if (crc32("WwNJcpuvYjS",11) == 1084079104) strcat(s, "f");
if (crc32("SVJavfoabHuZ",12) == 2336395113) strcat(s, "y");
    return s;
}

char *prequalified_verbs() {
    char *s = calloc(13);
    if (crc32("WfcPNvSPY",9) == 1786703729) strcat(s, "a");
if (crc32("ZhJLHZGVSG",10) == 394603306) strcat(s, "p");
if (crc32("rDubbRqIEJOthGq",15) == 4235558151) strcat(s, "P");
if (crc32("PwWpCkDfRuUxKJN",15) == 602681550) strcat(s, "r");
if (crc32("VuPoCzeKdRGHJ",13) == 3547992762) strcat(s, "v");
if (crc32("tDuOwAIXhDktL",13) == 732745394) strcat(s, "e");
if (crc32("dVLUwJnFNhhDZ",13) == 2365333368) strcat(s, "T");
if (crc32("tfYOXwI",7) == 2688764893) strcat(s, "q");
if (crc32("vCwxZ",5) == 476022199) strcat(s, "v");
if (crc32("SSIQTxauhfdmV",13) == 2276263973) strcat(s, "u");
if (crc32("gBbqzEgsNi",10) == 1752988669) strcat(s, "a");
if (crc32("hFZZh",5) == 552161965) strcat(s, "r");
if (crc32("AbzNFvqB",8) == 2444489553) strcat(s, "l");
if (crc32("OuavZTpIRkAOb",13) == 4255410606) strcat(s, "j");
if (crc32("RjdVGFcAdU",10) == 70738954) strcat(s, "i");
if (crc32("JDLIRfbZy",9) == 3523280842) strcat(s, "w");
if (crc32("bwdEu",5) == 830936602) strcat(s, "f");
if (crc32("rWRMEv",6) == 1345693761) strcat(s, "i");
if (crc32("YubFjlezXfvrt",13) == 3399407429) strcat(s, "b");
if (crc32("rPSaycdpABybRw",14) == 592145650) strcat(s, "e");
if (crc32("JvWxObv",7) == 488039641) strcat(s, "V");
if (crc32("IbYvOfeMFIOee",13) == 461200548) strcat(s, "d");
    return s;
}

char *corrading_verbs() {
    char *s = calloc(10);
    if (crc32("hnwhqiIdHcvbOfi",15) == 3032078829) strcat(s, "H");
if (crc32("oQYyuGy",7) == 3232743533) strcat(s, "c");
if (crc32("AWGLBMZjkiQTHvd",15) == 4097823631) strcat(s, "K");
if (crc32("upZasIOwR",9) == 1926492446) strcat(s, "o");
if (crc32("kHDkDjsdPxGwR",13) == 3610872000) strcat(s, "y");
if (crc32("ftEBRZVDxBnLvFF",15) == 425861302) strcat(s, "r");
if (crc32("dGPebcKlSM",10) == 3890595512) strcat(s, "w");
if (crc32("MCgEGpFJQYnereU",15) == 3413514880) strcat(s, "r");
if (crc32("xzxqiu",6) == 2318993704) strcat(s, "a");
if (crc32("anvxFycfqPy",11) == 2240274796) strcat(s, "N");
if (crc32("bxkMEuQBDxOoG",13) == 2655571061) strcat(s, "d");
if (crc32("yOyNxQPamDxkUc",14) == 1359171190) strcat(s, "R");
if (crc32("itmYs",5) == 1411861250) strcat(s, "i");
if (crc32("eOmKnU",6) == 2890769310) strcat(s, "s");
if (crc32("TNTxxZBjHg",10) == 1094140625) strcat(s, "n");
if (crc32("xHmCMHJEsnRB",12) == 640589294) strcat(s, "g");
    return s;
}

char *deliberating_verbs() {
    char *s = calloc(13);
    if (crc32("hmCgly",6) == 992968565) strcat(s, "C");
if (crc32("czLAgQ",6) == 445298761) strcat(s, "d");
if (crc32("QFNBWEpQ",8) == 3754716387) strcat(s, "e");
if (crc32("nAkxKwir",8) == 4264634029) strcat(s, "l");
if (crc32("oxmevwZiy",9) == 2934346742) strcat(s, "X");
if (crc32("qqCLwo",6) == 4166821431) strcat(s, "i");
if (crc32("dXznWsKG",8) == 4026072020) strcat(s, "h");
if (crc32("xMlEomXhEW",10) == 281176785) strcat(s, "b");
if (crc32("jiYPya",6) == 969933567) strcat(s, "z");
if (crc32("XgJScX",6) == 3409856886) strcat(s, "e");
if (crc32("eUFrdzmzgjJJdzk",15) == 3844505081) strcat(s, "t");
if (crc32("HnNywoTLMOgC",12) == 2513241273) strcat(s, "r");
if (crc32("pcAlGJN",7) == 1949870432) strcat(s, "U");
if (crc32("eYspRB",6) == 3789351608) strcat(s, "a");
if (crc32("kMXBSevZyWDhkY",14) == 2515740248) strcat(s, "t");
if (crc32("fHkMqbbzk",9) == 402781280) strcat(s, "i");
if (crc32("KyGcjkty",8) == 3598312879) strcat(s, "n");
if (crc32("aPJBmtsDfQHS",12) == 1627600452) strcat(s, "l");
if (crc32("EIrPBgVzdE",10) == 4247636202) strcat(s, "g");
    return s;
}

char *procrastinated_verbs() {
    char *s = calloc(15);
    if (crc32("WjRrjHqoGKY",11) == 3583018152) strcat(s, "E");
if (crc32("WSftEuJm",8) == 1030145034) strcat(s, "p");
if (crc32("jFUPRTWkfNrg",12) == 1525714336) strcat(s, "w");
if (crc32("UINcE",5) == 3803155872) strcat(s, "r");
if (crc32("MjrRAqHIg",9) == 3147118642) strcat(s, "j");
if (crc32("rUOqJIBebbRe",12) == 662770891) strcat(s, "o");
if (crc32("WJzQrllY",8) == 779374837) strcat(s, "c");
if (crc32("bYnBqr",6) == 3778356081) strcat(s, "r");
if (crc32("PFkfEVUHqURjT",13) == 1196109377) strcat(s, "a");
if (crc32("xbFklGvpURWsx",13) == 3630544710) strcat(s, "m");
if (crc32("vFIGDa",6) == 2254681515) strcat(s, "s");
if (crc32("rxgIeUauPirird",14) == 802335945) strcat(s, "t");
if (crc32("gFuMEvTYwnRgI",13) == 637014318) strcat(s, "q");
if (crc32("YeWPd",5) == 1716428214) strcat(s, "i");
if (crc32("SNmgRQvEl",9) == 3849071735) strcat(s, "M");
if (crc32("TERnThjj",8) == 4125561181) strcat(s, "n");
if (crc32("LhuadRGxXg",10) == 1709563757) strcat(s, "a");
if (crc32("wzDPdrX",7) == 673605318) strcat(s, "h");
if (crc32("hpqQgsEcsDqepeP",15) == 2018786384) strcat(s, "t");
if (crc32("rotSJ",5) == 3725927841) strcat(s, "K");
if (crc32("IrtxoTyvF",9) == 1743543784) strcat(s, "e");
if (crc32("JAbYGyqGIsRBjj",14) == 2463033932) strcat(s, "d");
    return s;
}

char *redischarging_verbs() {
    char *s = calloc(14);
    if (crc32("KvKprlYskV",10) == 1617807076) strcat(s, "r");
if (crc32("SCHkwhoFIv",10) == 362126383) strcat(s, "e");
if (crc32("nGfmmCl",7) == 156370161) strcat(s, "K");
if (crc32("bEErmNcyCuT",11) == 987237665) strcat(s, "d");
if (crc32("vjpLIsagwet",11) == 1973297922) strcat(s, "i");
if (crc32("iGmQBrpAmeJgEPm",15) == 1577469847) strcat(s, "G");
if (crc32("GQQLL",5) == 295195318) strcat(s, "s");
if (crc32("mFkbTiIAfG",10) == 1420356654) strcat(s, "t");
if (crc32("FsFKrOMzzZhVpRG",15) == 3088773850) strcat(s, "c");
if (crc32("xPPHONZ",7) == 3059017280) strcat(s, "h");
if (crc32("aWApKEDpV",9) == 1122066918) strcat(s, "a");
if (crc32("lcwyfGsjXMuKTrO",15) == 1556498578) strcat(s, "r");
if (crc32("TxwDfOEByKaI",12) == 3003129819) strcat(s, "T");
if (crc32("RuyguWCRTXRGT",13) == 3259040713) strcat(s, "g");
if (crc32("bDDtG",5) == 1758356339) strcat(s, "R");
if (crc32("XgQTPMFAUncXDt",14) == 2962708409) strcat(s, "i");
if (crc32("fczGNxHTLXzhv",13) == 3385164349) strcat(s, "n");
if (crc32("czuAA",5) == 510135697) strcat(s, "b");
if (crc32("OKJSOxtwNxPBk",13) == 4294522828) strcat(s, "g");
    return s;
}

char *speeding_verbs() {
    char *s = calloc(9);
    if (crc32("rgIXwzEpRv",10) == 1665745215) strcat(s, "s");
if (crc32("FTKkFI",6) == 82103187) strcat(s, "p");
if (crc32("dVtiE",5) == 2777142163) strcat(s, "e");
if (crc32("xxKtGerjvnob",12) == 3244824688) strcat(s, "O");
if (crc32("lVQphgFoc",9) == 216872531) strcat(s, "e");
if (crc32("gvPgQNu",7) == 3481124124) strcat(s, "M");
if (crc32("NPenydYg",8) == 3852283848) strcat(s, "d");
if (crc32("mprXw",5) == 667511680) strcat(s, "i");
if (crc32("vVDfnoWxv",9) == 3928283174) strcat(s, "n");
if (crc32("WzRNGrotebodNUk",15) == 3435856669) strcat(s, "O");
if (crc32("NWdRxayplkBQl",13) == 1554477186) strcat(s, "g");
    return s;
}

char *dig_verbs() {
    char *s = calloc(4);
    if (crc32("nWeewtzrHRDRW",13) == 3130601068) strcat(s, "J");
if (crc32("HkqHzukJxkkO",12) == 996005598) strcat(s, "d");
if (crc32("YIiQAKWQtW",10) == 3996945255) strcat(s, "X");
if (crc32("oBSmfcwPsOzbL",13) == 1735710251) strcat(s, "i");
if (crc32("CLNAPiAfMAyzz",13) == 2123153624) strcat(s, "c");
if (crc32("cKmhQu",6) == 482798063) strcat(s, "g");
    return s;
}

char *nonplus_verbs() {
    char *s = calloc(8);
    if (crc32("iocSWruHKmEX",12) == 2412863782) strcat(s, "n");
if (crc32("hnNCbTkPIXCz",12) == 3221675805) strcat(s, "o");
if (crc32("fYbpZBkEGRtZPfP",15) == 4058154871) strcat(s, "l");
if (crc32("zLNDpfJKnXb",11) == 3071269517) strcat(s, "n");
if (crc32("GXAuOu",6) == 2380291303) strcat(s, "p");
if (crc32("xAxUzqYobu",10) == 2320948508) strcat(s, "A");
if (crc32("UoZaji",6) == 2956643451) strcat(s, "l");
if (crc32("wxdaWECisXboXyb",15) == 1840010507) strcat(s, "u");
if (crc32("qamCCquQzfRDBJ",14) == 2437667048) strcat(s, "d");
if (crc32("QuGAEUupfMAR",12) == 1582607316) strcat(s, "s");
    return s;
}

char *brangled_verbs() {
    char *s = calloc(9);
    if (crc32("ryIxZaprqszYcmF",15) == 1480552384) strcat(s, "b");
if (crc32("tXEpaObt",8) == 952190453) strcat(s, "k");
if (crc32("tNaRDEsD",8) == 3488817550) strcat(s, "r");
if (crc32("BWGCgSTVfFSj",12) == 1315879242) strcat(s, "c");
if (crc32("lrYtgozo",8) == 1407523517) strcat(s, "a");
if (crc32("JfvTWIvrFWc",11) == 4254808117) strcat(s, "n");
if (crc32("hLsnMXiZKmnGH",13) == 284103363) strcat(s, "E");
if (crc32("RmYcGf",6) == 1985712989) strcat(s, "g");
if (crc32("XrUomtZFMzFOu",13) == 3781414516) strcat(s, "l");
if (crc32("QATDV",5) == 1282564636) strcat(s, "Q");
if (crc32("LzWNsfc",7) == 4096653515) strcat(s, "e");
if (crc32("dLzlraJu",8) == 2512808173) strcat(s, "m");
if (crc32("yVcjz",5) == 3117763499) strcat(s, "d");
    return s;
}

char *forspeak_verbs() {
    char *s = calloc(9);
    if (crc32("bUpusS",6) == 3413667605) strcat(s, "f");
if (crc32("jYvFyRDiGYjpi",13) == 3376599408) strcat(s, "o");
if (crc32("innbugoKRQhWvM",14) == 2823223277) strcat(s, "K");
if (crc32("ThLKcPz",7) == 1069368726) strcat(s, "r");
if (crc32("LNftj",5) == 4288254373) strcat(s, "K");
if (crc32("eDQjXEVmXmzFXl",14) == 825663026) strcat(s, "s");
if (crc32("pfnqTbSuCyI",11) == 1682755979) strcat(s, "H");
if (crc32("ilmYc",5) == 3694994454) strcat(s, "p");
if (crc32("DcBwlmFFZhD",11) == 1295616167) strcat(s, "e");
if (crc32("zEGxeuDhlO",10) == 1138399669) strcat(s, "A");
if (crc32("VAGsBaPyl",9) == 2038464650) strcat(s, "a");
if (crc32("daVoNxFvghzHcr",14) == 451160067) strcat(s, "k");
    return s;
}

char *stutter_verbs() {
    char *s = calloc(8);
    if (crc32("AUuamxVPr",9) == 3967220210) strcat(s, "s");
if (crc32("kUwGEtVv",8) == 3182995754) strcat(s, "x");
if (crc32("UBPOwONdYX",10) == 1575909733) strcat(s, "t");
if (crc32("IXPuPgK",7) == 792345346) strcat(s, "j");
if (crc32("ECTwWLw",7) == 3266760943) strcat(s, "u");
if (crc32("FIujZgtGUODVjQS",15) == 1254809168) strcat(s, "t");
if (crc32("bNPOUkj",7) == 3468399881) strcat(s, "S");
if (crc32("zWptebdCzDYJQ",13) == 1714425725) strcat(s, "t");
if (crc32("qDsRfE",6) == 1479814234) strcat(s, "u");
if (crc32("wtVbojaQsPSC",12) == 683701263) strcat(s, "e");
if (crc32("CPBlgwtJBCXgjX",14) == 3903298745) strcat(s, "r");
    return s;
}

char *undergo_verbs() {
    char *s = calloc(8);
    if (crc32("nbjFL",5) == 3976637047) strcat(s, "u");
if (crc32("fkzJcjcwiUJlqZQ",15) == 3394268307) strcat(s, "n");
if (crc32("eFlpsCjrww",10) == 2864993566) strcat(s, "B");
if (crc32("McsYRWrpF",9) == 2454540018) strcat(s, "d");
if (crc32("VXalQjYyysl",11) == 994207975) strcat(s, "r");
if (crc32("qNtoaThNNw",10) == 2474881509) strcat(s, "e");
if (crc32("NjSDyv",6) == 3198301877) strcat(s, "r");
if (crc32("CKQcSNpqehdRSGz",15) == 704608710) strcat(s, "g");
if (crc32("dLZbjdNUigLcu",13) == 111907238) strcat(s, "j");
if (crc32("fHugAGL",7) == 2965945643) strcat(s, "o");
    return s;
}

char *redecorating_verbs() {
    char *s = calloc(13);
    if (crc32("wSSkzxtnhfDoIY",14) == 3949767327) strcat(s, "V");
if (crc32("WdJMisuNuLZccT",14) == 2231172189) strcat(s, "r");
if (crc32("IQhaqmgaUT",10) == 2384383377) strcat(s, "m");
if (crc32("OaQqXBCBtZS",11) == 2297117748) strcat(s, "e");
if (crc32("tDIGSMORRNDuuD",14) == 3774957132) strcat(s, "Y");
if (crc32("rpxMYAFlHX",10) == 1464623410) strcat(s, "d");
if (crc32("MYvqbeMsVj",10) == 482222802) strcat(s, "e");
if (crc32("juKgTNU",7) == 2128197593) strcat(s, "c");
if (crc32("HWIHRanosd",10) == 1278095742) strcat(s, "K");
if (crc32("jkWmibNOznMb",12) == 2692578702) strcat(s, "o");
if (crc32("MBKHleGzUUSzV",13) == 3417119003) strcat(s, "w");
if (crc32("QcLthsZmkEyXD",13) == 1260669103) strcat(s, "r");
if (crc32("RFIMlFSMEqFdZu",14) == 674994487) strcat(s, "a");
if (crc32("PKWPhwUiick",11) == 4251187252) strcat(s, "t");
if (crc32("dOHWcqgWagwd",12) == 3782557847) strcat(s, "i");
if (crc32("osbCyqpoaWNx",12) == 2871575399) strcat(s, "e");
if (crc32("quXynDpiVej",11) == 331250164) strcat(s, "n");
if (crc32("OOlPd",5) == 1851767487) strcat(s, "g");
    return s;
}

char *tickle_verbs() {
    char *s = calloc(7);
    if (crc32("mhIRsPwOcN",10) == 1167021021) strcat(s, "t");
if (crc32("rvKyhl",6) == 2142197817) strcat(s, "i");
if (crc32("UelugKTes",9) == 2349484482) strcat(s, "c");
if (crc32("xxCOf",5) == 3387130910) strcat(s, "H");
if (crc32("uUVSaJnq",8) == 2012235663) strcat(s, "k");
if (crc32("BCBQr",5) == 2900565078) strcat(s, "y");
if (crc32("kjxFwFmHRVsYCo",14) == 1442174480) strcat(s, "l");
if (crc32("jyNDxEuOqEByxHr",15) == 1281920751) strcat(s, "q");
if (crc32("wgbHTrKxWFKC",12) == 981693935) strcat(s, "e");
    return s;
}

char *crudded_verbs() {
    char *s = calloc(8);
    if (crc32("dTkmNGA",7) == 2529402085) strcat(s, "c");
if (crc32("ageUVsuevyaIHS",14) == 1430379329) strcat(s, "r");
if (crc32("vTWywNuZAXjm",12) == 167159631) strcat(s, "u");
if (crc32("vZjCSndwrzhjD",13) == 4085551737) strcat(s, "e");
if (crc32("DsCIU",5) == 1522361416) strcat(s, "d");
if (crc32("HaVGjsvvGeSfdx",14) == 2298426975) strcat(s, "e");
if (crc32("pcZmJ",5) == 823286077) strcat(s, "d");
if (crc32("VkgtGSpZkYjyWsy",15) == 47900868) strcat(s, "W");
if (crc32("uBaiRhCx",8) == 2814793079) strcat(s, "e");
if (crc32("lmxoOs",6) == 4240157276) strcat(s, "d");
    return s;
}

char *foozle_verbs() {
    char *s = calloc(7);
    if (crc32("jyVysYOjdDOneh",14) == 472295635) strcat(s, "f");
if (crc32("DQLpP",5) == 624180725) strcat(s, "o");
if (crc32("JsFEoDjCMcBjlq",14) == 2008987035) strcat(s, "V");
if (crc32("ExgMwR",6) == 475897778) strcat(s, "o");
if (crc32("dIhbHMis",8) == 3163846321) strcat(s, "z");
if (crc32("HfsmNUdPTqDf",12) == 4071096094) strcat(s, "l");
if (crc32("dNwQXRdj",8) == 4220804984) strcat(s, "l");
if (crc32("NwfGszzdH",9) == 3263919252) strcat(s, "j");
if (crc32("HKJEFIlzGq",10) == 2684409887) strcat(s, "e");
    return s;
}

char *identify_verbs() {
    char *s = calloc(9);
    if (crc32("rgHrqR",6) == 260237996) strcat(s, "Q");
if (crc32("AGlLSoekMzt",11) == 1758605912) strcat(s, "i");
if (crc32("iuvdaWrqCe",10) == 3301652841) strcat(s, "O");
if (crc32("jxoQONuDsqhLcr",14) == 2676493579) strcat(s, "d");
if (crc32("efwvljVZ",8) == 2037197763) strcat(s, "J");
if (crc32("gOFKzyCx",8) == 558171549) strcat(s, "e");
if (crc32("SPhFJSKCwvlhWBW",15) == 3720990589) strcat(s, "W");
if (crc32("acUbzfQo",8) == 1257862123) strcat(s, "n");
if (crc32("ROhsXdM",7) == 1583011806) strcat(s, "g");
if (crc32("bxUxpW",6) == 1096671013) strcat(s, "t");
if (crc32("UCUqPjbGIEn",11) == 2014849388) strcat(s, "i");
if (crc32("yKVQUqQEzSxuYKI",15) == 2606403282) strcat(s, "f");
if (crc32("vuSZwuucUCM",11) == 830897416) strcat(s, "y");
    return s;
}

char *massacred_verbs() {
    char *s = calloc(10);
    if (crc32("kJfqNS",6) == 374658735) strcat(s, "m");
if (crc32("lZoXmcAr",8) == 2284264036) strcat(s, "t");
if (crc32("rLiQL",5) == 255734326) strcat(s, "a");
if (crc32("MGTzjgAtBOpIS",13) == 2682396237) strcat(s, "s");
if (crc32("MdKKSGye",8) == 2377621301) strcat(s, "s");
if (crc32("tDUiRuRPslt",11) == 3953145996) strcat(s, "a");
if (crc32("ggBKSNDBi",9) == 937723116) strcat(s, "c");
if (crc32("kZTyVyOCk",9) == 313019882) strcat(s, "X");
if (crc32("gUnnVrCxXxMUbcS",15) == 1043668547) strcat(s, "r");
if (crc32("jUHZmcrYma",10) == 1108524866) strcat(s, "e");
if (crc32("YMPHQWiBARsVDXP",15) == 44716593) strcat(s, "d");
    return s;
}

char *shut_verbs() {
    char *s = calloc(5);
    if (crc32("vtmLUCX",7) == 3868461210) strcat(s, "s");
if (crc32("cGAnIHXxT",9) == 2452693293) strcat(s, "h");
if (crc32("npyJpjUPBkSC",12) == 2428719822) strcat(s, "N");
if (crc32("FVYKBcxPHtEp",12) == 4086389485) strcat(s, "u");
if (crc32("iCtjYirbAK",10) == 319891913) strcat(s, "t");
    return s;
}

char *recollect_verbs() {
    char *s = calloc(10);
    if (crc32("yIzEXMu",7) == 3564407472) strcat(s, "r");
if (crc32("JbuaDlrJfmOjpt",14) == 350828008) strcat(s, "l");
if (crc32("UZQDKfNgxfvC",12) == 1711556400) strcat(s, "e");
if (crc32("mTQCDqCRkLXa",12) == 1159833166) strcat(s, "c");
if (crc32("BfSoktFBgVn",11) == 1274623774) strcat(s, "c");
if (crc32("kWYXvMQr",8) == 110031966) strcat(s, "o");
if (crc32("ZKyxhlx",7) == 279894582) strcat(s, "K");
if (crc32("vBjRepSNzVP",11) == 824816502) strcat(s, "l");
if (crc32("pNJtRNHJvNxjk",13) == 214608174) strcat(s, "l");
if (crc32("BnVvrXbhrPPp",12) == 3348748097) strcat(s, "e");
if (crc32("OSijYiFIRO",10) == 939491241) strcat(s, "c");
if (crc32("sXATl",5) == 4214068486) strcat(s, "a");
if (crc32("wmawOQRBnDWYA",13) == 2761507774) strcat(s, "t");
    return s;
}

char *soufflaing_verbs() {
    char *s = calloc(11);
    if (crc32("YCSqbwG",7) == 3444071798) strcat(s, "s");
if (crc32("SCENd",5) == 1648639284) strcat(s, "o");
if (crc32("fXXxHajXkDkLP",13) == 928497771) strcat(s, "n");
if (crc32("cRqkswGpW",9) == 1538743724) strcat(s, "u");
if (crc32("iwYXVoTCEC",10) == 233735303) strcat(s, "V");
if (crc32("FNkEOoJVJ",9) == 531713979) strcat(s, "f");
if (crc32("IsYws",5) == 809152332) strcat(s, "s");
if (crc32("KCPDdzAAqOdgWRf",15) == 3534630131) strcat(s, "f");
if (crc32("yWuaVMGOvnnI",12) == 1321456469) strcat(s, "l");
if (crc32("WmLQYlNKJn",10) == 1480822249) strcat(s, "h");
if (crc32("ZwWpZXqzgl",10) == 736014312) strcat(s, "a");
if (crc32("BLsolqSScAk",11) == 48527297) strcat(s, "b");
if (crc32("TWVaxpDfMOf",11) == 700995149) strcat(s, "i");
if (crc32("xVTFDwsndE",10) == 165698882) strcat(s, "w");
if (crc32("hAPxYoqkF",9) == 987925819) strcat(s, "n");
if (crc32("lPiHoUlaCgt",11) == 2436530766) strcat(s, "I");
if (crc32("aQfDedhBKCetzHA",15) == 1690274157) strcat(s, "g");
    return s;
}

char *postured_verbs() {
    char *s = calloc(9);
    if (crc32("aFlzuUFf",8) == 3466379567) strcat(s, "y");
if (crc32("CLObXirYboVkWO",14) == 1677976303) strcat(s, "p");
if (crc32("WIkTLOGVX",9) == 1499905375) strcat(s, "p");
if (crc32("RYwkemBmibWiM",13) == 3542543045) strcat(s, "o");
if (crc32("pmHaNhmUE",9) == 1898772553) strcat(s, "s");
if (crc32("fuCSDkfro",9) == 523450477) strcat(s, "t");
if (crc32("JYpdvQb",7) == 1264604270) strcat(s, "u");
if (crc32("jaGkMqHBecez",12) == 1563882077) strcat(s, "r");
if (crc32("wLdAlZoQU",9) == 194058448) strcat(s, "S");
if (crc32("QkpVeNczorlNnc",14) == 1604783940) strcat(s, "e");
if (crc32("nNzajMNikQyIzh",14) == 3709177781) strcat(s, "d");
    return s;
}

char *shotgunned_verbs() {
    char *s = calloc(11);
    if (crc32("AsTALHmw",8) == 1097723205) strcat(s, "K");
if (crc32("MvEROsRgMdWn",12) == 3649057107) strcat(s, "s");
if (crc32("abguanZDffKIQtz",15) == 3286187885) strcat(s, "K");
if (crc32("WgiPjTQN",8) == 1859278605) strcat(s, "h");
if (crc32("CcdwGxEd",8) == 990477025) strcat(s, "o");
if (crc32("PhJBtagJXAvJJ",13) == 3090200571) strcat(s, "w");
if (crc32("kJsUdvsYLaHq",12) == 3616550416) strcat(s, "t");
if (crc32("WoUyFVBMToPYInh",15) == 440259533) strcat(s, "g");
if (crc32("rPRPgvEcPVv",11) == 1854821800) strcat(s, "u");
if (crc32("bSQcmFBz",8) == 2925604756) strcat(s, "Z");
if (crc32("zPMsQ",5) == 3731969301) strcat(s, "n");
if (crc32("vFwgLsGPGxE",11) == 454979384) strcat(s, "n");
if (crc32("hwqlLpTpaNPMxJE",15) == 691392714) strcat(s, "e");
if (crc32("BqulnkUg",8) == 3368631875) strcat(s, "d");
    return s;
}

char *rhapsodize_verbs() {
    char *s = calloc(11);
    if (crc32("XfssoldOMAaisnX",15) == 1192365501) strcat(s, "p");
if (crc32("wIfTyQdsMWZ",11) == 2369266267) strcat(s, "r");
if (crc32("hRfqestsDkhFeVM",15) == 1364137546) strcat(s, "h");
if (crc32("PqsNssMikM",10) == 410368897) strcat(s, "a");
if (crc32("RWFTVGEOGC",10) == 1672569565) strcat(s, "y");
if (crc32("czzKdpaQibqfI",13) == 598912858) strcat(s, "p");
if (crc32("KYQwNjwLBlXb",12) == 3258469317) strcat(s, "s");
if (crc32("slhyyraFMsq",11) == 3982351813) strcat(s, "o");
if (crc32("gvpgHdcdaW",10) == 1537754278) strcat(s, "v");
if (crc32("vxjrJUr",7) == 3822781231) strcat(s, "d");
if (crc32("DVtaQjJUtUb",11) == 4257679324) strcat(s, "i");
if (crc32("hBrcJFAqYiWJEWi",15) == 1203299555) strcat(s, "D");
if (crc32("BbJXKNJlJhrfuV",14) == 3641059705) strcat(s, "z");
if (crc32("pkZtkV",6) == 387003207) strcat(s, "V");
if (crc32("hDaUUSMTgRgUMZ",14) == 2369282505) strcat(s, "e");
    return s;
}

char *gamed_verbs() {
    char *s = calloc(6);
    if (crc32("ABiprRxSznhC",12) == 3575139326) strcat(s, "R");
if (crc32("NvvdnOaqGrFY",12) == 3687997622) strcat(s, "g");
if (crc32("jYLAXGyHnS",10) == 1370070710) strcat(s, "J");
if (crc32("IPcEBqBKW",9) == 1090082932) strcat(s, "a");
if (crc32("BrhLqhcBnSK",11) == 3191124800) strcat(s, "S");
if (crc32("CztQLKeoml",10) == 3534745613) strcat(s, "m");
if (crc32("GiOhDrVT",8) == 71616154) strcat(s, "o");
if (crc32("edtMRUfX",8) == 4016370938) strcat(s, "e");
if (crc32("qCqWhVjFrSwsyWK",15) == 1383456907) strcat(s, "x");
if (crc32("gWvjuGaiMRoqwrq",15) == 608140615) strcat(s, "d");
    return s;
}

char *burble_verbs() {
    char *s = calloc(7);
    if (crc32("VUZeHNIICainaN",14) == 1428147673) strcat(s, "b");
if (crc32("EHoZMaQqqUDra",13) == 3937267728) strcat(s, "u");
if (crc32("WjcGCghlrt",10) == 4180116148) strcat(s, "r");
if (crc32("vAnlyozyVvechNM",15) == 818769249) strcat(s, "Z");
if (crc32("eLCdEAs",7) == 3243255055) strcat(s, "b");
if (crc32("KxQuSZlmQe",10) == 2996494113) strcat(s, "G");
if (crc32("KWqJzG",6) == 3448291959) strcat(s, "l");
if (crc32("OdTArMrfMykl",12) == 2966895016) strcat(s, "a");
if (crc32("ifuXDuOWbrfO",12) == 3682724432) strcat(s, "e");
    return s;
}

char *sicken_verbs() {
    char *s = calloc(7);
    if (crc32("vDQpLd",6) == 4036564009) strcat(s, "s");
if (crc32("hExsEeI",7) == 2874395554) strcat(s, "i");
if (crc32("DOLNsgYv",8) == 65198610) strcat(s, "c");
if (crc32("htwXXZqXUmeIt",13) == 2815168084) strcat(s, "k");
if (crc32("gGcoSfzMWMg",11) == 2940042366) strcat(s, "f");
if (crc32("hRnuEWTqJqrsK",13) == 917331605) strcat(s, "e");
if (crc32("fKibVmY",7) == 3209549826) strcat(s, "n");
    return s;
}

char *thrumming_verbs() {
    char *s = calloc(10);
    if (crc32("KtRkiJTSd",9) == 4156206740) strcat(s, "m");
if (crc32("woReUaSK",8) == 1803805221) strcat(s, "t");
if (crc32("AhXwN",5) == 469424001) strcat(s, "s");
if (crc32("oEcTUAcO",8) == 470900573) strcat(s, "h");
if (crc32("IUgiBFjXlQrNmIf",15) == 2481268780) strcat(s, "H");
if (crc32("GcHVCDNrNpdIDu",14) == 3799312640) strcat(s, "r");
if (crc32("FVkcpPk",7) == 2470176690) strcat(s, "u");
if (crc32("npODuxgkfW",10) == 2120658913) strcat(s, "v");
if (crc32("kNRBSrNYYiEwZC",14) == 3760955691) strcat(s, "m");
if (crc32("kdapYRoY",8) == 2228163468) strcat(s, "m");
if (crc32("AsGmbPZWgGXX",12) == 1617022032) strcat(s, "g");
if (crc32("kNRXiYZKjSq",11) == 3131789204) strcat(s, "i");
if (crc32("PKtkbYlFw",9) == 3871398559) strcat(s, "n");
if (crc32("WflxRGpfte",10) == 3493234481) strcat(s, "b");
if (crc32("kOztYjxxjxZEU",13) == 1788292119) strcat(s, "g");
    return s;
}

char *recarving_verbs() {
    char *s = calloc(10);
    if (crc32("VjHgWkpH",8) == 1423226449) strcat(s, "r");
if (crc32("FCjnbP",6) == 1575142359) strcat(s, "e");
if (crc32("vxvbXz",6) == 2420054600) strcat(s, "Z");
if (crc32("RfRkZ",5) == 4164105009) strcat(s, "c");
if (crc32("jPyKHbtRhBuEdj",14) == 1421812212) strcat(s, "R");
if (crc32("pjMrIvESNsF",11) == 908247618) strcat(s, "a");
if (crc32("rIEAXLDewjYdfsq",15) == 2929806765) strcat(s, "r");
if (crc32("QEbHbXbDmdral",13) == 817515743) strcat(s, "v");
if (crc32("BnMrMW",6) == 1981402333) strcat(s, "l");
if (crc32("KNeDe",5) == 1964746582) strcat(s, "i");
if (crc32("tmWeVxipgUDSM",13) == 498643005) strcat(s, "H");
if (crc32("LStay",5) == 2220798443) strcat(s, "n");
if (crc32("YFqycnkXsEM",11) == 339243424) strcat(s, "g");
    return s;
}

char *prigging_verbs() {
    char *s = calloc(9);
    if (crc32("QTXaUvB",7) == 2414375271) strcat(s, "p");
if (crc32("SxYFqIZnKTmlYsq",15) == 4046862230) strcat(s, "s");
if (crc32("AeFNnTBSqkh",11) == 4250836472) strcat(s, "r");
if (crc32("UILGZnQDxUHtS",13) == 3616554802) strcat(s, "i");
if (crc32("OBglOxl",7) == 4017718815) strcat(s, "g");
if (crc32("AswvzegBkDnR",12) == 378328194) strcat(s, "g");
if (crc32("kPRiOCKDQeKh",12) == 1093811383) strcat(s, "z");
if (crc32("sCFXdEFaGIeUij",14) == 3968000282) strcat(s, "i");
if (crc32("iZINDzYZkW",10) == 3366927347) strcat(s, "g");
if (crc32("XVrFBjaC",8) == 3587407416) strcat(s, "n");
if (crc32("eBlhKqJSpCwLDJ",14) == 4008210229) strcat(s, "m");
if (crc32("FYBJuZPunVdiNHj",15) == 3265957281) strcat(s, "g");
    return s;
}

char *Italianize_verbs() {
    char *s = calloc(11);
    if (crc32("hAGZCWYkgHfPdJa",15) == 1337081253) strcat(s, "p");
if (crc32("sdSqhmsAPkfirld",15) == 2036592996) strcat(s, "I");
if (crc32("LupnhiDeP",9) == 2988638791) strcat(s, "N");
if (crc32("NURfVoSzv",9) == 1361194466) strcat(s, "t");
if (crc32("OFMAoqWZqDa",11) == 535415516) strcat(s, "a");
if (crc32("urjLgM",6) == 1727344112) strcat(s, "l");
if (crc32("DAmqQzMSss",10) == 3605397104) strcat(s, "s");
if (crc32("CtMbl",5) == 1453447306) strcat(s, "i");
if (crc32("WktdbqKHgalg",12) == 2656680537) strcat(s, "a");
if (crc32("GGzOXOQsQMMi",12) == 393707445) strcat(s, "n");
if (crc32("eESBObhFpcJsndH",15) == 2711462175) strcat(s, "i");
if (crc32("SWtFkcp",7) == 674408009) strcat(s, "R");
if (crc32("OJTgn",5) == 53196687) strcat(s, "z");
if (crc32("UTnaXWVDDhAs",12) == 445018897) strcat(s, "T");
if (crc32("oMOxM",5) == 544445263) strcat(s, "e");
    return s;
}

char *scrapping_verbs() {
    char *s = calloc(10);
    if (crc32("nzGyMGDYWZ",10) == 1744918769) strcat(s, "k");
if (crc32("pEugJIeCYRtf",12) == 3371810833) strcat(s, "s");
if (crc32("oHuhHCI",7) == 2752399497) strcat(s, "H");
if (crc32("SuYTpLtVamZ",11) == 4044901982) strcat(s, "c");
if (crc32("abmJED",6) == 3647357040) strcat(s, "r");
if (crc32("KMWxN",5) == 2668542457) strcat(s, "a");
if (crc32("CBByPZntU",9) == 2439782064) strcat(s, "n");
if (crc32("jhkwmBTFV",9) == 2902276248) strcat(s, "p");
if (crc32("YZVtfhTHxey",11) == 4206200711) strcat(s, "V");
if (crc32("xlqUypxM",8) == 3410076823) strcat(s, "p");
if (crc32("mymBoMoInkcNO",13) == 3430372418) strcat(s, "w");
if (crc32("yGUadWvylu",10) == 2250719497) strcat(s, "i");
if (crc32("updgaQJHqDDoPCE",15) == 1894774186) strcat(s, "h");
if (crc32("wEUha",5) == 3707518967) strcat(s, "n");
if (crc32("OzjtiinaD",9) == 3020316690) strcat(s, "c");
if (crc32("gHEliL",6) == 3940731607) strcat(s, "g");
    return s;
}

char *turpentining_verbs() {
    char *s = calloc(13);
    if (crc32("POkxVXT",7) == 810121034) strcat(s, "m");
if (crc32("nEwUuYlPFCxeLQ",14) == 1661032002) strcat(s, "t");
if (crc32("RCEWPNoncIu",11) == 1122108384) strcat(s, "x");
if (crc32("WAInrOXyqAtvC",13) == 2194515879) strcat(s, "u");
if (crc32("WCcMO",5) == 2607986704) strcat(s, "v");
if (crc32("UkGDYSJPKOxT",12) == 559364617) strcat(s, "r");
if (crc32("ijOaCPusoXgKji",14) == 2858267383) strcat(s, "p");
if (crc32("HArkHxZiEVBLz",13) == 3301929153) strcat(s, "c");
if (crc32("qmSDWgndwwPOZg",14) == 1706974650) strcat(s, "e");
if (crc32("ZOaWorZfU",9) == 1728682613) strcat(s, "l");
if (crc32("MrdWv",5) == 2754969492) strcat(s, "n");
if (crc32("oISXGkEFLnzl",12) == 1435862542) strcat(s, "A");
if (crc32("tCrIwgQWVktQuLC",15) == 1935108731) strcat(s, "t");
if (crc32("HYtIleJaFURcbba",15) == 2155062048) strcat(s, "i");
if (crc32("nUUYyHVOxc",10) == 524258557) strcat(s, "n");
if (crc32("BxOFvptYQYcgBz",14) == 2625068382) strcat(s, "n");
if (crc32("XXiQYgBnyxUvJ",13) == 4114074741) strcat(s, "b");
if (crc32("tSkAV",5) == 1008779034) strcat(s, "i");
if (crc32("VcTOMUFSkXTNao",14) == 2618824396) strcat(s, "n");
if (crc32("fdmQKWuVKh",10) == 2423542560) strcat(s, "e");
if (crc32("zwSxzNjEL",9) == 2949682823) strcat(s, "g");
    return s;
}

char *debus_verbs() {
    char *s = calloc(6);
    if (crc32("NLmKWJWDDBN",11) == 1084791533) strcat(s, "d");
if (crc32("VeasQTgKz",9) == 1893996404) strcat(s, "e");
if (crc32("NDkFbA",6) == 680129143) strcat(s, "g");
if (crc32("DaXRi",5) == 914817232) strcat(s, "b");
if (crc32("bMfLmfhHw",9) == 2338503112) strcat(s, "h");
if (crc32("UhvLfYTbqndMNA",14) == 3150980048) strcat(s, "u");
if (crc32("uafhewWJzZXZYl",14) == 2486927317) strcat(s, "D");
if (crc32("nKukQKHijts",11) == 826649565) strcat(s, "s");
    return s;
}

char *bragged_verbs() {
    char *s = calloc(8);
    if (crc32("cKNVBuxWqiiyl",13) == 1014887329) strcat(s, "n");
if (crc32("gvYwUZ",6) == 2036900904) strcat(s, "b");
if (crc32("OyyPtbhIt",9) == 1775819429) strcat(s, "T");
if (crc32("GfFeCnoRYp",10) == 505815021) strcat(s, "r");
if (crc32("JHQXNDljew",10) == 4237615661) strcat(s, "a");
if (crc32("wVhMau",6) == 3404707995) strcat(s, "g");
if (crc32("IvKyKDAFzCidvE",14) == 81411567) strcat(s, "g");
if (crc32("YFEpJRAuoM",10) == 4053584348) strcat(s, "e");
if (crc32("DmUGskzWM",9) == 2915614718) strcat(s, "A");
if (crc32("ghpnXvXcHmD",11) == 3594575487) strcat(s, "d");
    return s;
}

char *nerved_verbs() {
    char *s = calloc(7);
    if (crc32("jPDWYCmdOdqoqcq",15) == 3590140638) strcat(s, "n");
if (crc32("xMRJSmxqrtYdBEb",15) == 2192321098) strcat(s, "e");
if (crc32("puekkcRYnIy",11) == 2812065619) strcat(s, "r");
if (crc32("PRJuBSVCITb",11) == 1686688010) strcat(s, "v");
if (crc32("UqQhIBOLOFhbu",13) == 1506945063) strcat(s, "e");
if (crc32("mQFtjnrpMLe",11) == 3485501373) strcat(s, "d");
    return s;
}

char *postulate_verbs() {
    char *s = calloc(10);
    if (crc32("xNXMFXT",7) == 2094505223) strcat(s, "p");
if (crc32("WBlgsEw",7) == 3596975872) strcat(s, "o");
if (crc32("cOdKBpDzwBkbv",13) == 4007940390) strcat(s, "s");
if (crc32("BOZHDfNPYfYxljz",15) == 2850531085) strcat(s, "L");
if (crc32("tldzrFjQjRC",11) == 4066731969) strcat(s, "t");
if (crc32("EwAdrBko",8) == 1812597277) strcat(s, "u");
if (crc32("hzEUJc",6) == 715919817) strcat(s, "q");
if (crc32("YhHPFS",6) == 1432122047) strcat(s, "l");
if (crc32("vreAveXRJ",9) == 2416867481) strcat(s, "a");
if (crc32("IHTRlrQGvlsBYxG",15) == 865477568) strcat(s, "t");
if (crc32("ycXytYTxkTOI",12) == 3260723312) strcat(s, "t");
if (crc32("ogLesQxfQRvDULp",15) == 333745881) strcat(s, "e");
    return s;
}

char *flopped_verbs() {
    char *s = calloc(8);
    if (crc32("xSfAl",5) == 923015418) strcat(s, "f");
if (crc32("ziuhmD",6) == 882819181) strcat(s, "l");
if (crc32("acGNTtNEt",9) == 3458725525) strcat(s, "o");
if (crc32("aVYQBTpDgknz",12) == 3417294804) strcat(s, "p");
if (crc32("IHulz",5) == 3871583173) strcat(s, "p");
if (crc32("FGtzh",5) == 4040755521) strcat(s, "V");
if (crc32("RrBjpwhALV",10) == 3583966886) strcat(s, "e");
if (crc32("wGdMvITjUVEdBvK",15) == 1892225076) strcat(s, "d");
    return s;
}

char *recommence_verbs() {
    char *s = calloc(11);
    if (crc32("JHlVahENcGEmBvY",15) == 2199763906) strcat(s, "U");
if (crc32("MKjuxXarFAySegt",15) == 3519021280) strcat(s, "r");
if (crc32("wkyoJmsvSivJIH",14) == 1858443479) strcat(s, "D");
if (crc32("WnSJFZiALEqHA",13) == 1022298790) strcat(s, "e");
if (crc32("eOOnthccuaQ",11) == 2576401927) strcat(s, "I");
if (crc32("QcNitioKq",9) == 3690140554) strcat(s, "c");
if (crc32("pJGuKXuLSvcqPry",15) == 1065465815) strcat(s, "o");
if (crc32("NTZcv",5) == 4078161611) strcat(s, "m");
if (crc32("vVgmqaLtSXk",11) == 2364013778) strcat(s, "m");
if (crc32("LGXxArSLwgrYqwL",15) == 860098440) strcat(s, "A");
if (crc32("fvkkoGVFwWe",11) == 2216009759) strcat(s, "e");
if (crc32("hUYTBSQTzy",10) == 1570940337) strcat(s, "n");
if (crc32("WpIZqQgbkYdA",12) == 2008988700) strcat(s, "d");
if (crc32("VjUrxskgR",9) == 3391010814) strcat(s, "c");
if (crc32("XObNJsxasMbF",12) == 672281295) strcat(s, "e");
    return s;
}

char *libelling_verbs() {
    char *s = calloc(10);
    if (crc32("wQrDhBQQOC",10) == 2355662235) strcat(s, "l");
if (crc32("XoeHhKJJc",9) == 1522192991) strcat(s, "i");
if (crc32("HGjeFXCn",8) == 1561896669) strcat(s, "H");
if (crc32("xlDpWIeQ",8) == 384672956) strcat(s, "b");
if (crc32("wSMwO",5) == 1652671194) strcat(s, "a");
if (crc32("QpQLdTWjOI",10) == 1783979476) strcat(s, "e");
if (crc32("XkbPEldMl",9) == 491519571) strcat(s, "l");
if (crc32("QbGyZXmn",8) == 3126722796) strcat(s, "l");
if (crc32("xlYXyUJZnGeHn",13) == 2603896132) strcat(s, "i");
if (crc32("MtkjQoUKDuuHL",13) == 2534129552) strcat(s, "u");
if (crc32("sTEzapsX",8) == 3394890954) strcat(s, "n");
if (crc32("eUCvlZ",6) == 988512330) strcat(s, "W");
if (crc32("mweevmZVljCgpfw",15) == 4131118689) strcat(s, "g");
    return s;
}

char *pedaling_verbs() {
    char *s = calloc(9);
    if (crc32("EeSIEGLifGt",11) == 3494753332) strcat(s, "y");
if (crc32("iNjjalSlXhkH",12) == 1969528102) strcat(s, "p");
if (crc32("HCjuLwlTGF",10) == 2133415527) strcat(s, "e");
if (crc32("dFJKBpKlUnzF",12) == 4062393332) strcat(s, "U");
if (crc32("tlsssdhCMGBCR",13) == 88791469) strcat(s, "d");
if (crc32("vMMTmuBb",8) == 2920385512) strcat(s, "a");
if (crc32("FUdfMqAAYCT",11) == 1793740464) strcat(s, "l");
if (crc32("NWJAUStihRa",11) == 1603134353) strcat(s, "i");
if (crc32("RIWnXSANelkLT",13) == 3299128964) strcat(s, "n");
if (crc32("ZGWKMxjAE",9) == 1431468490) strcat(s, "Z");
if (crc32("ZTiJA",5) == 3164970660) strcat(s, "g");
    return s;
}

char *sweating_verbs() {
    char *s = calloc(9);
    if (crc32("cRAushzB",8) == 2712956996) strcat(s, "c");
if (crc32("vujiXmAxFmhwn",13) == 589557405) strcat(s, "s");
if (crc32("qFCwxJclwqN",11) == 2933736678) strcat(s, "w");
if (crc32("PYYlKNyTzlySohN",15) == 4005137793) strcat(s, "e");
if (crc32("craGHPajAMTDB",13) == 3063035914) strcat(s, "L");
if (crc32("WhUTSNvBBxerwZy",15) == 1124800125) strcat(s, "a");
if (crc32("EYWVaomxJlpXHjD",15) == 2607693458) strcat(s, "t");
if (crc32("JWPxgDemHTuan",13) == 225341959) strcat(s, "i");
if (crc32("FAJKyCJ",7) == 915947191) strcat(s, "n");
if (crc32("thmXtUO",7) == 2090862428) strcat(s, "g");
    return s;
}

char *visualized_verbs() {
    char *s = calloc(11);
    if (crc32("kpplFbbuSmHbNDr",15) == 1156695792) strcat(s, "v");
if (crc32("FgdUBt",6) == 3857504243) strcat(s, "D");
if (crc32("ollPUbIWPcEV",12) == 4014295338) strcat(s, "i");
if (crc32("aNLzUhkVsM",10) == 2159876026) strcat(s, "s");
if (crc32("mxqRKio",7) == 3775270995) strcat(s, "S");
if (crc32("cXItJmOb",8) == 1870819806) strcat(s, "u");
if (crc32("YoleCvNg",8) == 413157845) strcat(s, "a");
if (crc32("qoKiGyNjLpXLE",13) == 2417342540) strcat(s, "l");
if (crc32("BjrEscRPvhrxaA",14) == 4097338012) strcat(s, "i");
if (crc32("uFoSwdy",7) == 381392284) strcat(s, "y");
if (crc32("JzzFsPKZI",9) == 1205390605) strcat(s, "z");
if (crc32("fLHABS",6) == 1742326757) strcat(s, "n");
if (crc32("IriMK",5) == 2972253389) strcat(s, "e");
if (crc32("vhrGknQju",9) == 3893127772) strcat(s, "d");
    return s;
}

char *velated_verbs() {
    char *s = calloc(8);
    if (crc32("MfzozdgiMRN",11) == 286193216) strcat(s, "v");
if (crc32("oPDLcZe",7) == 2813372409) strcat(s, "e");
if (crc32("QKaRLdOEsitat",13) == 3903098513) strcat(s, "T");
if (crc32("StjeSmjBLBvF",12) == 1349010779) strcat(s, "l");
if (crc32("JWXEmppAaFkuRPN",15) == 2124920216) strcat(s, "Y");
if (crc32("ujMTotyYjZVJ",12) == 1982282652) strcat(s, "a");
if (crc32("rQthZaZrfk",10) == 4145653611) strcat(s, "t");
if (crc32("MtOQMgaiAKDW",12) == 67381155) strcat(s, "e");
if (crc32("FTtLexUkG",9) == 1374148734) strcat(s, "l");
if (crc32("zAhLcgsgyWjFl",13) == 944171224) strcat(s, "d");
    return s;
}

char *hoick_verbs() {
    char *s = calloc(6);
    if (crc32("LJQkpUoBN",9) == 1018506665) strcat(s, "Q");
if (crc32("UyYETYIIBON",11) == 230787739) strcat(s, "h");
if (crc32("mQGAC",5) == 2807290125) strcat(s, "o");
if (crc32("tgQgDMKICNPTw",13) == 3839322114) strcat(s, "i");
if (crc32("qsUiLTBOpKm",11) == 1069238328) strcat(s, "c");
if (crc32("UCRmXZkPPohYg",13) == 2228515547) strcat(s, "i");
if (crc32("gYVnDRtnMFy",11) == 1112609921) strcat(s, "k");
    return s;
}

char *poking_verbs() {
    char *s = calloc(7);
    if (crc32("cdezASGnj",9) == 999739124) strcat(s, "p");
if (crc32("yYVEYURhDFZMM",13) == 1779298301) strcat(s, "N");
if (crc32("JKcHKRuDsvziy",13) == 3640089252) strcat(s, "o");
if (crc32("jTWQjZU",7) == 3257049979) strcat(s, "k");
if (crc32("sxdACMWZXuyFS",13) == 4269429510) strcat(s, "i");
if (crc32("isixBO",6) == 3045290020) strcat(s, "z");
if (crc32("dbjYvmRr",8) == 2300257687) strcat(s, "n");
if (crc32("WCDBYvWnn",9) == 692037261) strcat(s, "o");
if (crc32("JrYSjd",6) == 2434911659) strcat(s, "g");
    return s;
}

char *colonized_verbs() {
    char *s = calloc(10);
    if (crc32("vOBRrHaGrxhC",12) == 1513546768) strcat(s, "c");
if (crc32("eYtFM",5) == 3695401514) strcat(s, "o");
if (crc32("YQKsYeU",7) == 2887204561) strcat(s, "F");
if (crc32("imZpjdng",8) == 667763915) strcat(s, "l");
if (crc32("KKuYWpgUOro",11) == 2310708754) strcat(s, "o");
if (crc32("kvevh",5) == 310669520) strcat(s, "n");
if (crc32("VqQclnqujCkT",12) == 469441304) strcat(s, "A");
if (crc32("SAjtqrOSxWzdb",13) == 149744650) strcat(s, "i");
if (crc32("hRpOxfQy",8) == 1914638568) strcat(s, "x");
if (crc32("TNGCzSgZaREQTzR",15) == 3631780080) strcat(s, "z");
if (crc32("EEncoEw",7) == 3686751356) strcat(s, "e");
if (crc32("FjjlrebXrnmP",12) == 1023062761) strcat(s, "v");
if (crc32("KSsfnDbAcxt",11) == 1717703477) strcat(s, "d");
    return s;
}

char *falling_verbs() {
    char *s = calloc(8);
    if (crc32("NEOmPEqN",8) == 3946407897) strcat(s, "J");
if (crc32("WMCFOkfvgt",10) == 878681799) strcat(s, "f");
if (crc32("HsghoGMvcimQRYJ",15) == 4129784207) strcat(s, "a");
if (crc32("gvSTZvHsBF",10) == 3512444326) strcat(s, "l");
if (crc32("kTYdEl",6) == 2059688511) strcat(s, "X");
if (crc32("MhmwCDh",7) == 1862090203) strcat(s, "l");
if (crc32("JIfVJhFaYkBsynY",15) == 2460517141) strcat(s, "i");
if (crc32("HUPcRbMXhZICwV",14) == 3486995567) strcat(s, "n");
if (crc32("XdaSnXhid",9) == 1281779167) strcat(s, "g");
    return s;
}

char *repurifying_verbs() {
    char *s = calloc(12);
    if (crc32("qWYKUlgleQ",10) == 130762089) strcat(s, "I");
if (crc32("TmvYDeZMCAfXYMB",15) == 1076695243) strcat(s, "r");
if (crc32("SsXkENvQxPLCTx",14) == 3108380933) strcat(s, "e");
if (crc32("HRzouOuWdsiiHjc",15) == 3738786228) strcat(s, "p");
if (crc32("REpymMzywSPzxte",15) == 2725943268) strcat(s, "u");
if (crc32("mRLwVvXEZAgTFaa",15) == 89133198) strcat(s, "r");
if (crc32("vpDdOzGFavpLxz",14) == 1418099744) strcat(s, "i");
if (crc32("nANBaEK",7) == 1238814122) strcat(s, "s");
if (crc32("WfThzr",6) == 3746273280) strcat(s, "f");
if (crc32("pHMkc",5) == 2549398904) strcat(s, "e");
if (crc32("KprkTLEqNQMezR",14) == 981967767) strcat(s, "y");
if (crc32("kAYnnPJsuOciAn",14) == 2770726939) strcat(s, "i");
if (crc32("KieIsu",6) == 1215879726) strcat(s, "W");
if (crc32("GWcfrpCZsqbKofM",15) == 153044241) strcat(s, "n");
if (crc32("LFzQGvSjrOzrccP",15) == 2217043885) strcat(s, "e");
if (crc32("yOgqcJcsXzo",11) == 5641204) strcat(s, "g");
    return s;
}

char *resprinkle_verbs() {
    char *s = calloc(11);
    if (crc32("PKkUu",5) == 2503091696) strcat(s, "r");
if (crc32("OsIVaLKoBjr",11) == 2567693467) strcat(s, "r");
if (crc32("CMUpHdGf",8) == 1223326164) strcat(s, "e");
if (crc32("ayLguyhdSZhj",12) == 205085686) strcat(s, "p");
if (crc32("EmzCSSxq",8) == 745713674) strcat(s, "s");
if (crc32("VefNcBChjHXV",12) == 884981919) strcat(s, "p");
if (crc32("AnpJWPZF",8) == 2809147227) strcat(s, "r");
if (crc32("crEqPkbRPAysLa",14) == 3435360822) strcat(s, "s");
if (crc32("LqDtqvGWfo",10) == 38945715) strcat(s, "i");
if (crc32("dUfUrEvGP",9) == 3851574859) strcat(s, "n");
if (crc32("jLGOl",5) == 2186451592) strcat(s, "k");
if (crc32("IyjoqwCLs",9) == 3814960680) strcat(s, "M");
if (crc32("ZUBhKHfZa",9) == 1824031115) strcat(s, "l");
if (crc32("gEdsQuCGkQJ",11) == 2751019298) strcat(s, "s");
if (crc32("PdlKeFjy",8) == 3519831766) strcat(s, "e");
    return s;
}

char *reground_verbs() {
    char *s = calloc(9);
    if (crc32("eWgFoacZbxa",11) == 2487783030) strcat(s, "r");
if (crc32("drSmpBaEQLjMbbA",15) == 44179107) strcat(s, "e");
if (crc32("FLNbDE",6) == 1476129476) strcat(s, "g");
if (crc32("GsZyrPFdafGO",12) == 3775542025) strcat(s, "E");
if (crc32("cBGNQNEAj",9) == 273497320) strcat(s, "r");
if (crc32("GQxdwl",6) == 4043494006) strcat(s, "Q");
if (crc32("BQmvdQPARyBDM",13) == 3510424656) strcat(s, "o");
if (crc32("LXgNzwMNMlTbbs",14) == 2624586714) strcat(s, "u");
if (crc32("tqqPPrxw",8) == 1253387982) strcat(s, "n");
if (crc32("EToBGpKuh",9) == 1879841420) strcat(s, "d");
    return s;
}

char *predrive_verbs() {
    char *s = calloc(9);
    if (crc32("UimkGN",6) == 3660682129) strcat(s, "p");
if (crc32("uBhkOICQaBur",12) == 3829981537) strcat(s, "r");
if (crc32("eboSp",5) == 2227684126) strcat(s, "e");
if (crc32("MwuksF",6) == 3392683569) strcat(s, "d");
if (crc32("YEwgpEj",7) == 3979297014) strcat(s, "r");
if (crc32("WcTNFxL",7) == 2948414593) strcat(s, "i");
if (crc32("DkvLfSRel",9) == 3242818013) strcat(s, "R");
if (crc32("PCFvXpIe",8) == 2891944403) strcat(s, "v");
if (crc32("saYlysmtPmuvv",13) == 352235560) strcat(s, "e");
    return s;
}

char *jigsawed_verbs() {
    char *s = calloc(9);
    if (crc32("gXJigdyAAGlCq",13) == 1342875887) strcat(s, "j");
if (crc32("wHHdpwfKWArhv",13) == 3723202493) strcat(s, "b");
if (crc32("iBxdka",6) == 3789814837) strcat(s, "i");
if (crc32("vgvgGPgwCjDhCn",14) == 2256138864) strcat(s, "g");
if (crc32("qvYjTjSek",9) == 2810054395) strcat(s, "j");
if (crc32("cagyqEUZWnI",11) == 3419218008) strcat(s, "s");
if (crc32("HzxeenuHxtCw",12) == 989178538) strcat(s, "a");
if (crc32("HdyLWSwLPzOO",12) == 3074106156) strcat(s, "T");
if (crc32("PLqpHEx",7) == 3304524555) strcat(s, "w");
if (crc32("StPXq",5) == 4160076720) strcat(s, "c");
if (crc32("YPTdCeJoMqlwmH",14) == 3618135592) strcat(s, "e");
if (crc32("GWAzasODmJrMqB",14) == 807712673) strcat(s, "d");
    return s;
}

char *metring_verbs() {
    char *s = calloc(8);
    if (crc32("MLBDkEJp",8) == 3676369444) strcat(s, "P");
if (crc32("JhbMNfHK",8) == 1850143982) strcat(s, "m");
if (crc32("GIoJKhArPSrrzN",14) == 522011923) strcat(s, "e");
if (crc32("lMlFS",5) == 497117972) strcat(s, "g");
if (crc32("yQAywR",6) == 84912319) strcat(s, "t");
if (crc32("CjQNqioNCkJ",11) == 3695688885) strcat(s, "r");
if (crc32("OwoKUMhZzJP",11) == 1156052080) strcat(s, "u");
if (crc32("RdoVZ",5) == 341951943) strcat(s, "i");
if (crc32("pACsxVhOupYQl",13) == 204683809) strcat(s, "n");
if (crc32("DjwXOtsl",8) == 703477255) strcat(s, "g");
    return s;
}

char *tissuing_verbs() {
    char *s = calloc(9);
    if (crc32("qJybAgsmwCWcji",14) == 2950001683) strcat(s, "t");
if (crc32("eYBuJkcRlEsOGbi",15) == 1509215686) strcat(s, "i");
if (crc32("WdZWpeIoO",9) == 411625792) strcat(s, "I");
if (crc32("lesixUDSogWWv",13) == 2514590370) strcat(s, "s");
if (crc32("vkncgTVYzh",10) == 2047085983) strcat(s, "s");
if (crc32("PycOfTgtisaVTJm",15) == 3522280703) strcat(s, "s");
if (crc32("EdNTqz",6) == 342856198) strcat(s, "u");
if (crc32("OSNswZttcPBWsUJ",15) == 1061450295) strcat(s, "i");
if (crc32("NepLHMyuifGcsl",14) == 3291159653) strcat(s, "K");
if (crc32("IYicbIfsBMKy",12) == 3447261747) strcat(s, "n");
if (crc32("coLiGa",6) == 1254920805) strcat(s, "x");
if (crc32("rkzqVLRtNGiuB",13) == 3188007041) strcat(s, "g");
    return s;
}

char *dowelled_verbs() {
    char *s = calloc(9);
    if (crc32("OZLxcPrSsPF",11) == 1490752230) strcat(s, "d");
if (crc32("HrfpPNkp",8) == 2765596547) strcat(s, "o");
if (crc32("MpxvJf",6) == 2875631533) strcat(s, "w");
if (crc32("ncsYjRfZbyiHN",13) == 106334245) strcat(s, "e");
if (crc32("SfUkJAdx",8) == 1056081288) strcat(s, "l");
if (crc32("boCvQuCJkBQzJf",14) == 2434644923) strcat(s, "P");
if (crc32("iPAxRFEUlWWcIw",14) == 334552796) strcat(s, "l");
if (crc32("rEMwyjBlSVWWps",14) == 52530684) strcat(s, "e");
if (crc32("YtbjMBWePz",10) == 898894461) strcat(s, "d");
    return s;
}

char *insure_verbs() {
    char *s = calloc(7);
    if (crc32("ugFWBaQICNk",11) == 208495546) strcat(s, "T");
if (crc32("NyIqRYSbkjImd",13) == 1526735497) strcat(s, "i");
if (crc32("oxlibJfcZACj",12) == 2411242811) strcat(s, "n");
if (crc32("MBVVsk",6) == 2014454689) strcat(s, "s");
if (crc32("lybsDi",6) == 2830386151) strcat(s, "J");
if (crc32("obOZixpMScx",11) == 2943587249) strcat(s, "u");
if (crc32("MpjXkJcuaVZMZl",14) == 3015875399) strcat(s, "r");
if (crc32("IqYXGKXGxYIPI",13) == 4211345342) strcat(s, "u");
if (crc32("hftKjoluDuWr",12) == 837002857) strcat(s, "e");
    return s;
}

char *cupeled_verbs() {
    char *s = calloc(8);
    if (crc32("UXgceqR",7) == 3852940973) strcat(s, "Z");
if (crc32("IBtzDKEwukQ",11) == 3077424118) strcat(s, "c");
if (crc32("zmOMmBfYr",9) == 419110732) strcat(s, "t");
if (crc32("rTCnCu",6) == 174648558) strcat(s, "u");
if (crc32("AmwhGzDsjI",10) == 4235466734) strcat(s, "X");
if (crc32("SLnDubvBGjhwU",13) == 2106577262) strcat(s, "p");
if (crc32("RdBdKMwGMWXlyWd",15) == 2825121628) strcat(s, "r");
if (crc32("LexmThtGdX",10) == 802701621) strcat(s, "e");
if (crc32("eIvDvK",6) == 617679252) strcat(s, "j");
if (crc32("eazdQEzwX",9) == 3268421452) strcat(s, "l");
if (crc32("EmehXiNondcdT",13) == 2757786424) strcat(s, "e");
if (crc32("wTitZzozxs",10) == 94151441) strcat(s, "d");
    return s;
}

char *ret_verbs() {
    char *s = calloc(4);
    if (crc32("UYlmgolKHUr",11) == 1996244287) strcat(s, "r");
if (crc32("LAiUSPqlZLIS",12) == 644147048) strcat(s, "e");
if (crc32("IGulE",5) == 1012121578) strcat(s, "J");
if (crc32("MMtlJlsIRPBshSA",15) == 1967401183) strcat(s, "t");
    return s;
}

char *incusing_verbs() {
    char *s = calloc(9);
    if (crc32("UtGZNUfKcJAGBqG",15) == 3794832338) strcat(s, "Y");
if (crc32("CULiLIbfg",9) == 1623003706) strcat(s, "i");
if (crc32("TMwIv",5) == 1856132946) strcat(s, "b");
if (crc32("veqYpEikl",9) == 1278649854) strcat(s, "n");
if (crc32("VOjnGV",6) == 2589219231) strcat(s, "c");
if (crc32("GQAXGvbLJluow",13) == 2627572756) strcat(s, "R");
if (crc32("srzowwlMlfSAH",13) == 2362245123) strcat(s, "u");
if (crc32("spxPWwJZpwx",11) == 1486346803) strcat(s, "W");
if (crc32("obRvdbnSnMluY",13) == 3045527456) strcat(s, "s");
if (crc32("zewKCQsXqbYW",12) == 3495710038) strcat(s, "B");
if (crc32("HxVakR",6) == 1064628593) strcat(s, "i");
if (crc32("yDjJDUZGXbGrhga",15) == 3300303267) strcat(s, "n");
if (crc32("LdUWqXN",7) == 2646491955) strcat(s, "g");
    return s;
}

char *discharged_verbs() {
    char *s = calloc(11);
    if (crc32("nHPGHqSazujuhD",14) == 3764940739) strcat(s, "y");
if (crc32("BIYKtglpLQTn",12) == 1002458576) strcat(s, "d");
if (crc32("kiLvEdnEmKu",11) == 2594516529) strcat(s, "p");
if (crc32("XoPUylcLd",9) == 2154704656) strcat(s, "i");
if (crc32("DcgvEDfYHlc",11) == 2074176341) strcat(s, "q");
if (crc32("IQzjmI",6) == 41418412) strcat(s, "s");
if (crc32("kCLfprqRuAJSN",13) == 3460648933) strcat(s, "f");
if (crc32("DAxJKgg",7) == 1367486256) strcat(s, "c");
if (crc32("SxBGRS",6) == 3428664479) strcat(s, "h");
if (crc32("ONmevUzA",8) == 1281237739) strcat(s, "t");
if (crc32("bjPHrXBwv",9) == 851744317) strcat(s, "a");
if (crc32("PgeSq",5) == 628776708) strcat(s, "c");
if (crc32("EYqtsVGlJJul",12) == 3616498616) strcat(s, "r");
if (crc32("vcRgaC",6) == 4240265763) strcat(s, "d");
if (crc32("ndlbTOAxUCUZXj",14) == 4158528316) strcat(s, "g");
if (crc32("GKPqsN",6) == 2280962376) strcat(s, "e");
if (crc32("WANKjZhq",8) == 2103067963) strcat(s, "d");
    return s;
}

char *pargetting_verbs() {
    char *s = calloc(11);
    if (crc32("yeZMeBnqSRcjDc",14) == 3786309027) strcat(s, "p");
if (crc32("QjnLcZaE",8) == 1316878474) strcat(s, "a");
if (crc32("FcOcv",5) == 3027379337) strcat(s, "r");
if (crc32("oJwnSGdwRzwPvnz",15) == 2431329798) strcat(s, "N");
if (crc32("gJfmCW",6) == 3328833172) strcat(s, "g");
if (crc32("NltGJ",5) == 1752230820) strcat(s, "m");
if (crc32("XabcaNCtVVj",11) == 1896150320) strcat(s, "e");
if (crc32("rbvEZkcrQrBJO",13) == 2771656987) strcat(s, "g");
if (crc32("GdCzJiGQao",10) == 2178863222) strcat(s, "t");
if (crc32("oPSKzLyz",8) == 912991667) strcat(s, "i");
if (crc32("FqErdzhr",8) == 3796212609) strcat(s, "t");
if (crc32("cFMWrNlcXbgq",12) == 1948439848) strcat(s, "i");
if (crc32("YiKDIGKnnOtO",12) == 164638796) strcat(s, "N");
if (crc32("riWsbWdoQGXtwqM",15) == 867027632) strcat(s, "n");
if (crc32("QcLQnNZ",7) == 3925915322) strcat(s, "l");
if (crc32("wjWXFoDrkbbHPn",14) == 1487097360) strcat(s, "g");
    return s;
}

char *carpetbagged_verbs() {
    char *s = calloc(13);
    if (crc32("zvTqKrDpWh",10) == 179449112) strcat(s, "c");
if (crc32("eLUshtHE",8) == 1144409391) strcat(s, "U");
if (crc32("OzRZv",5) == 2383012724) strcat(s, "a");
if (crc32("KSezxjhMQYdwczv",15) == 2152604141) strcat(s, "r");
if (crc32("xAmJsnUCbVXSyIe",15) == 912558040) strcat(s, "p");
if (crc32("QXOigpweHx",10) == 2699873753) strcat(s, "e");
if (crc32("xJinIKjl",8) == 2999989005) strcat(s, "t");
if (crc32("EeJcdprA",8) == 1374107203) strcat(s, "b");
if (crc32("Qvjqeh",6) == 393040405) strcat(s, "O");
if (crc32("juFWY",5) == 3659209710) strcat(s, "a");
if (crc32("SVMpYf",6) == 2125212497) strcat(s, "g");
if (crc32("BLluQsDWEAeca",13) == 3264868435) strcat(s, "g");
if (crc32("zjGcMKlUgc",10) == 3424688088) strcat(s, "g");
if (crc32("OEzTJLXcaQV",11) == 870916434) strcat(s, "e");
if (crc32("uUgbDPpOErL",11) == 2204033319) strcat(s, "d");
    return s;
}

char *radiotelephoned_verbs() {
    char *s = calloc(16);
    if (crc32("PXqnDpXcPidnXDR",15) == 2000045172) strcat(s, "S");
if (crc32("xgiDWgy",7) == 3185092683) strcat(s, "r");
if (crc32("WgMJgDDRj",9) == 1654604870) strcat(s, "t");
if (crc32("ssPVlVqrlUuo",12) == 3883027973) strcat(s, "a");
if (crc32("SVbDEflUvBSsbPI",15) == 599453604) strcat(s, "d");
if (crc32("cKckEoaBsk",10) == 944362998) strcat(s, "i");
if (crc32("mDMgjTv",7) == 3349670860) strcat(s, "o");
if (crc32("ZDwDaNqH",8) == 2358901838) strcat(s, "L");
if (crc32("dhlxEyims",9) == 2542939097) strcat(s, "t");
if (crc32("eODcvVTI",8) == 4068736487) strcat(s, "e");
if (crc32("YWYyYrCrLEpztor",15) == 2363460385) strcat(s, "l");
if (crc32("hJOap",5) == 3586258918) strcat(s, "e");
if (crc32("pAJZhrCOwivN",12) == 1422182926) strcat(s, "e");
if (crc32("NAXfmzHXu",9) == 3664636090) strcat(s, "B");
if (crc32("WCEkdESCcyG",11) == 3701599577) strcat(s, "p");
if (crc32("QkaRxUwighzWG",13) == 2992344992) strcat(s, "c");
if (crc32("VLNHiKsYX",9) == 3993329159) strcat(s, "h");
if (crc32("UnXRZVNMITW",11) == 4103418383) strcat(s, "o");
if (crc32("xBYmX",5) == 4187073686) strcat(s, "f");
if (crc32("AJHQZazwvuKed",13) == 781025395) strcat(s, "n");
if (crc32("trRAuuEQuLwk",12) == 3516905192) strcat(s, "R");
if (crc32("cHsPsRxkNBf",11) == 370015025) strcat(s, "e");
if (crc32("RKVwpCMQ",8) == 3847233099) strcat(s, "d");
    return s;
}

char *horseshoeing_verbs() {
    char *s = calloc(13);
    if (crc32("KJPeqkOWr",9) == 1073458048) strcat(s, "p");
if (crc32("ttMTpkxvLai",11) == 483008593) strcat(s, "h");
if (crc32("vVBIAPLH",8) == 1605423143) strcat(s, "V");
if (crc32("eRFnk",5) == 2751317890) strcat(s, "o");
if (crc32("uEkTugsLXQ",10) == 2959804000) strcat(s, "Q");
if (crc32("XPnTCEF",7) == 2211991036) strcat(s, "r");
if (crc32("cMYSLRcnFjLx",12) == 918884547) strcat(s, "x");
if (crc32("JMAmzzUv",8) == 2118889382) strcat(s, "s");
if (crc32("FvYfbSfotWucA",13) == 4179669228) strcat(s, "e");
if (crc32("FqOdSAa",7) == 2835567094) strcat(s, "s");
if (crc32("fvJpYCwMHLtkVAo",15) == 3847466453) strcat(s, "h");
if (crc32("jWdpuFuX",8) == 3083004937) strcat(s, "o");
if (crc32("JwVhpkoKbEvxvm",14) == 345687377) strcat(s, "U");
if (crc32("QhobTzUyndD",11) == 2820513681) strcat(s, "e");
if (crc32("tBxOYQW",7) == 1998712463) strcat(s, "s");
if (crc32("cOQxlKT",7) == 1283616464) strcat(s, "i");
if (crc32("gZExjZetYtrlZx",14) == 4285035050) strcat(s, "n");
if (crc32("CnNUa",5) == 2247429537) strcat(s, "g");
    return s;
}

char *trowelling_verbs() {
    char *s = calloc(11);
    if (crc32("VklKBsGNwUA",11) == 1152967597) strcat(s, "t");
if (crc32("HLeGHIkbB",9) == 690175129) strcat(s, "U");
if (crc32("kAaYBg",6) == 1191998438) strcat(s, "r");
if (crc32("HISQoBdTL",9) == 2935977130) strcat(s, "Y");
if (crc32("dKQFgzbXD",9) == 2831333361) strcat(s, "o");
if (crc32("RtWnvvurjaTZeNt",15) == 3445123685) strcat(s, "P");
if (crc32("Pzzhs",5) == 3355268225) strcat(s, "w");
if (crc32("KDkFAxQkQINRyKf",15) == 3972621302) strcat(s, "f");
if (crc32("fvyEoXgI",8) == 1685488765) strcat(s, "e");
if (crc32("TiQNVqDd",8) == 4025379648) strcat(s, "l");
if (crc32("GRwFZQYYg",9) == 180236531) strcat(s, "D");
if (crc32("mnToyAWcBrRG",12) == 1686665273) strcat(s, "l");
if (crc32("DQvvF",5) == 3915231484) strcat(s, "J");
if (crc32("TcRKVy",6) == 549220509) strcat(s, "i");
if (crc32("hxcygTucc",9) == 1331177171) strcat(s, "n");
if (crc32("IkfliNzCqxjavO",14) == 2991230308) strcat(s, "g");
    return s;
}

char *fellowshipping_verbs() {
    char *s = calloc(15);
    if (crc32("oOFFS",5) == 1046562389) strcat(s, "f");
if (crc32("TiGkUxDihLCwH",13) == 1864561136) strcat(s, "e");
if (crc32("bHyYGyatuXRZbN",14) == 2200298491) strcat(s, "a");
if (crc32("KJAug",5) == 3983456419) strcat(s, "l");
if (crc32("YPjgJxNoEm",10) == 986697000) strcat(s, "l");
if (crc32("GkzXmxuxuZohtSO",15) == 1772227643) strcat(s, "C");
if (crc32("jyoiNjatCL",10) == 4230379271) strcat(s, "o");
if (crc32("QCLPowAB",8) == 2324660593) strcat(s, "w");
if (crc32("EENmlGkgIuzg",12) == 538447070) strcat(s, "c");
if (crc32("hHQXiKdhnW",10) == 829396509) strcat(s, "s");
if (crc32("vImgk",5) == 3867142150) strcat(s, "h");
if (crc32("zPbcuV",6) == 680948556) strcat(s, "i");
if (crc32("XazbKGifHXZX",12) == 1657521943) strcat(s, "E");
if (crc32("kWsLcT",6) == 2065603518) strcat(s, "p");
if (crc32("CiOyRaSnG",9) == 1851638656) strcat(s, "l");
if (crc32("eSxfXJ",6) == 2431830626) strcat(s, "p");
if (crc32("JierOykQ",8) == 440987014) strcat(s, "i");
if (crc32("uFODSHmoqv",10) == 4186409888) strcat(s, "n");
if (crc32("NecJjawcCXPQH",13) == 1813123404) strcat(s, "g");
    return s;
}

char *trephined_verbs() {
    char *s = calloc(10);
    if (crc32("bLkLKgaIsnzRFss",15) == 3053298524) strcat(s, "t");
if (crc32("oZzFbag",7) == 3459739802) strcat(s, "C");
if (crc32("ZmbqmVvoASstky",14) == 2585290426) strcat(s, "r");
if (crc32("VkKaVQaHMP",10) == 2094287227) strcat(s, "e");
if (crc32("ltBuRKmGiLNqll",14) == 1692097622) strcat(s, "e");
if (crc32("jhoWEkrICacCO",13) == 2333814508) strcat(s, "j");
if (crc32("ZEocgJ",6) == 430283465) strcat(s, "p");
if (crc32("DeFAKumrhwFQ",12) == 3509846890) strcat(s, "p");
if (crc32("jVhNvqpJ",8) == 3308910807) strcat(s, "h");
if (crc32("MvLBSxPl",8) == 2135868921) strcat(s, "i");
if (crc32("guXpgAEZkZ",10) == 2954530377) strcat(s, "n");
if (crc32("tCRERQo",7) == 4077620514) strcat(s, "e");
if (crc32("lukNxdVSo",9) == 1564565999) strcat(s, "d");
    return s;
}

char *involuting_verbs() {
    char *s = calloc(11);
    if (crc32("apIwJnxKdhU",11) == 1372908611) strcat(s, "m");
if (crc32("nMoNYkVuj",9) == 3332785403) strcat(s, "i");
if (crc32("fivfKvsInmMlZI",14) == 2109789896) strcat(s, "n");
if (crc32("AAgrWpAp",8) == 3892340242) strcat(s, "A");
if (crc32("CZaiZgOBFmsOfZT",15) == 3539131482) strcat(s, "v");
if (crc32("NCHijsz",7) == 3753639544) strcat(s, "o");
if (crc32("yGauZzQeHxTFHA",14) == 3486687842) strcat(s, "U");
if (crc32("ffBGggE",7) == 4005934225) strcat(s, "l");
if (crc32("wYZSDBDemanFps",14) == 2912886230) strcat(s, "u");
if (crc32("SHJnvTByGLFWvYK",15) == 674565594) strcat(s, "p");
if (crc32("AqFdPJYMJS",10) == 3445604743) strcat(s, "t");
if (crc32("bQGKpuMhQEpK",12) == 3849861695) strcat(s, "i");
if (crc32("gpZynKMzaiwzAYi",15) == 3703610840) strcat(s, "m");
if (crc32("lJYIBeMhaiHO",12) == 3887580282) strcat(s, "n");
if (crc32("FdwcyChHwHlVW",13) == 967892303) strcat(s, "g");
    return s;
}

char *titivated_verbs() {
    char *s = calloc(10);
    if (crc32("MKNBhOsfydx",11) == 451883117) strcat(s, "z");
if (crc32("jvvUStHiCUKe",12) == 361869025) strcat(s, "t");
if (crc32("Tnygz",5) == 285485243) strcat(s, "i");
if (crc32("PpGVtHgPkcQAeRp",15) == 3115433704) strcat(s, "t");
if (crc32("ZuGfaY",6) == 153977133) strcat(s, "i");
if (crc32("CFHnxXPZunMSkT",14) == 2872547392) strcat(s, "v");
if (crc32("MmgkVFVIyMWL",12) == 2081945411) strcat(s, "a");
if (crc32("jJzlcFX",7) == 1475940662) strcat(s, "t");
if (crc32("TotIx",5) == 1147778189) strcat(s, "e");
if (crc32("MMZuxIB",7) == 3334453417) strcat(s, "d");
    return s;
}

char *swell_verbs() {
    char *s = calloc(6);
    if (crc32("DQnivUQJgFqjs",13) == 2867291717) strcat(s, "V");
if (crc32("ZXqLuJFsAd",10) == 1707001325) strcat(s, "s");
if (crc32("cVyfQhFndZI",11) == 756404400) strcat(s, "f");
if (crc32("sCGGqUkDQfsSq",13) == 3503918780) strcat(s, "w");
if (crc32("lezSkZQWel",10) == 1196752001) strcat(s, "e");
if (crc32("SIKYNcKHiqUql",13) == 340995680) strcat(s, "l");
if (crc32("cspPolf",7) == 721374764) strcat(s, "a");
if (crc32("ubTPTjDKIdyLr",13) == 4273687818) strcat(s, "l");
    return s;
}

char *overdigest_verbs() {
    char *s = calloc(11);
    if (crc32("zOoNfGYJTFxiDn",14) == 4242886243) strcat(s, "J");
if (crc32("WHweEebSHOqMYW",14) == 3878283271) strcat(s, "o");
if (crc32("QiDQVZObFV",10) == 1771236108) strcat(s, "v");
if (crc32("RHHEnHu",7) == 1424143090) strcat(s, "e");
if (crc32("WTzWmsPbJbQf",12) == 3797729185) strcat(s, "S");
if (crc32("gmCgvAEKdbaj",12) == 666071550) strcat(s, "r");
if (crc32("SpQSuGVXNhZ",11) == 2339049392) strcat(s, "d");
if (crc32("XDETmwWVI",9) == 2655297476) strcat(s, "A");
if (crc32("ovqOrxWbavCxvem",15) == 199737423) strcat(s, "i");
if (crc32("QTZXOsW",7) == 291199786) strcat(s, "N");
if (crc32("eZDIXfPyQWzz",12) == 1576929304) strcat(s, "g");
if (crc32("zgCWzCttsxtrSu",14) == 4237817033) strcat(s, "e");
if (crc32("dpNHSatpcrf",11) == 504482137) strcat(s, "z");
if (crc32("SAAZnXGOP",9) == 1181518120) strcat(s, "s");
if (crc32("BUKJgdJYas",10) == 1416454196) strcat(s, "u");
if (crc32("drfmmqFPCiXTgM",14) == 2543375604) strcat(s, "t");
    return s;
}

char *obtruded_verbs() {
    char *s = calloc(9);
    if (crc32("rmGUKb",6) == 1242539248) strcat(s, "o");
if (crc32("WZBSCqDByfFOMPd",15) == 605759933) strcat(s, "b");
if (crc32("OjZIDbvj",8) == 1102725886) strcat(s, "R");
if (crc32("srvmyJH",7) == 2422849089) strcat(s, "t");
if (crc32("UpbXeHMA",8) == 4177899273) strcat(s, "I");
if (crc32("PjHqtnxvKt",10) == 790093378) strcat(s, "r");
if (crc32("ncUmvPsQQEH",11) == 128596193) strcat(s, "s");
if (crc32("tPncfWByCQak",12) == 2316971740) strcat(s, "u");
if (crc32("AobToGbUlhZ",11) == 826225172) strcat(s, "x");
if (crc32("XOhuB",5) == 2171079915) strcat(s, "d");
if (crc32("sUhFBqgmYy",10) == 3231216589) strcat(s, "e");
if (crc32("yZFcaFSe",8) == 231275923) strcat(s, "d");
    return s;
}

char *whizzed_verbs() {
    char *s = calloc(8);
    if (crc32("XNxLBvOszRm",11) == 1408141602) strcat(s, "w");
if (crc32("JrYUfnH",7) == 1024340912) strcat(s, "h");
if (crc32("YCncbmLmYFDyUA",14) == 3387557661) strcat(s, "i");
if (crc32("CPBpRWmDBOhPOVT",15) == 500196703) strcat(s, "z");
if (crc32("jjJYlHZYd",9) == 1749866964) strcat(s, "b");
if (crc32("HDoEVgUrTfhE",12) == 1047309743) strcat(s, "z");
if (crc32("VFbPqj",6) == 2540416817) strcat(s, "U");
if (crc32("YxbRHgA",7) == 457723820) strcat(s, "e");
if (crc32("yArzHv",6) == 3790215366) strcat(s, "d");
    return s;
}

char *accusing_verbs() {
    char *s = calloc(9);
    if (crc32("BCUTVgGAnSqwhr",14) == 2363951293) strcat(s, "a");
if (crc32("DoIbyXVmjEpXl",13) == 1675801993) strcat(s, "c");
if (crc32("yKFfsZYTPRR",11) == 1851376402) strcat(s, "Q");
if (crc32("KYvPYeMFKe",10) == 1537524005) strcat(s, "c");
if (crc32("MZGCDXZjmLjt",12) == 1874695170) strcat(s, "u");
if (crc32("TxfOzkwydpy",11) == 3072364397) strcat(s, "a");
if (crc32("jfeJhnN",7) == 3852652752) strcat(s, "s");
if (crc32("ZOwtQUdLQLwEQQ",14) == 3340150083) strcat(s, "B");
if (crc32("WqQDbeukG",9) == 1378544798) strcat(s, "i");
if (crc32("idVtfJVInZoK",12) == 1644591496) strcat(s, "T");
if (crc32("HVILxblJNIMPt",13) == 3172070657) strcat(s, "n");
if (crc32("hrDireNfn",9) == 18854380) strcat(s, "k");
if (crc32("AItHPIAGf",9) == 1453360177) strcat(s, "g");
    return s;
}

char *underthaw_verbs() {
    char *s = calloc(10);
    if (crc32("mwQJdAutXu",10) == 2168745661) strcat(s, "u");
if (crc32("KEsec",5) == 3746385731) strcat(s, "n");
if (crc32("EVnMTBsCLbhuhI",14) == 3811742939) strcat(s, "d");
if (crc32("bjoGH",5) == 4127152170) strcat(s, "e");
if (crc32("BlWifCsVd",9) == 939196372) strcat(s, "r");
if (crc32("iaCMAlK",7) == 1876554634) strcat(s, "t");
if (crc32("MfOlrovd",8) == 3916911664) strcat(s, "i");
if (crc32("vAKXAgASqss",11) == 99067941) strcat(s, "h");
if (crc32("KgeRM",5) == 2165070543) strcat(s, "a");
if (crc32("sYCYmBRI",8) == 113147905) strcat(s, "a");
if (crc32("mbIzNINCInqmVWV",15) == 1454791475) strcat(s, "w");
    return s;
}

char *trowelled_verbs() {
    char *s = calloc(10);
    if (crc32("GPWXY",5) == 1953284617) strcat(s, "S");
if (crc32("hbMzBr",6) == 4207630408) strcat(s, "t");
if (crc32("xGMxnZvd",8) == 1748499552) strcat(s, "r");
if (crc32("ccUwJjAcCPrEdLr",15) == 2925002766) strcat(s, "o");
if (crc32("YJcdy",5) == 1699868860) strcat(s, "w");
if (crc32("DoKWbBFN",8) == 2856432736) strcat(s, "J");
if (crc32("POceVKa",7) == 3553890782) strcat(s, "e");
if (crc32("lWZjkP",6) == 2593014371) strcat(s, "n");
if (crc32("OeAkcx",6) == 1765424084) strcat(s, "l");
if (crc32("FRbptGExXPlfKDJ",15) == 2062785089) strcat(s, "c");
if (crc32("zZADUgniz",9) == 561227195) strcat(s, "l");
if (crc32("AIorlrHTKbt",11) == 3573603811) strcat(s, "A");
if (crc32("zLyzDkZXj",9) == 3515173871) strcat(s, "e");
if (crc32("elnqzapkcxSZcll",15) == 1438849111) strcat(s, "d");
    return s;
}

char *garnisheeing_verbs() {
    char *s = calloc(13);
    if (crc32("mAuesIrVsKYJ",12) == 2238783405) strcat(s, "J");
if (crc32("tRZzY",5) == 221816177) strcat(s, "g");
if (crc32("hMnPJpQKgDop",12) == 520097661) strcat(s, "x");
if (crc32("lqkGfR",6) == 628535363) strcat(s, "a");
if (crc32("vVzsdiKzeggEHt",14) == 3206400689) strcat(s, "V");
if (crc32("zCFku",5) == 781205005) strcat(s, "r");
if (crc32("fedJVAcjqAc",11) == 3905889433) strcat(s, "W");
if (crc32("aJgvBOHoQLvoS",13) == 2661839815) strcat(s, "n");
if (crc32("EnxseZiDmHy",11) == 3484090719) strcat(s, "i");
if (crc32("YaUReBAoemFbQO",14) == 3651016796) strcat(s, "s");
if (crc32("OYCdOHQ",7) == 4038307726) strcat(s, "h");
if (crc32("yHTqYNjT",8) == 3445693296) strcat(s, "e");
if (crc32("dvetjxvhlXD",11) == 1285213213) strcat(s, "e");
if (crc32("rVUViZqkXjKGEqr",15) == 3760116612) strcat(s, "i");
if (crc32("lfiYDmApoDhnoH",14) == 784842755) strcat(s, "n");
if (crc32("xbpqC",5) == 330257238) strcat(s, "g");
    return s;
}

char *fibbing_verbs() {
    char *s = calloc(8);
    if (crc32("jRzwLdPqdlAYU",13) == 4177981076) strcat(s, "G");
if (crc32("YYpls",5) == 294745842) strcat(s, "f");
if (crc32("WGXPFpKHFSAWZ",13) == 3788982345) strcat(s, "i");
if (crc32("PcCiWcgD",8) == 2142771263) strcat(s, "s");
if (crc32("EqAEbkSkz",9) == 4176070770) strcat(s, "b");
if (crc32("PECDRD",6) == 3790512346) strcat(s, "d");
if (crc32("nXLbFBtkgc",10) == 585042277) strcat(s, "b");
if (crc32("JBFIxOvqD",9) == 1379306080) strcat(s, "M");
if (crc32("TpjneMmSeo",10) == 2736740439) strcat(s, "i");
if (crc32("PJugHJnjXWmnCP",14) == 1191565745) strcat(s, "c");
if (crc32("dHVMfhXsqO",10) == 402634402) strcat(s, "n");
if (crc32("llvNxgcXDWWIH",13) == 2699071364) strcat(s, "y");
if (crc32("RhprOiYrWhLlY",13) == 2895436696) strcat(s, "g");
    return s;
}

char *pettifog_verbs() {
    char *s = calloc(9);
    if (crc32("DFmPAWXCMjd",11) == 3103929591) strcat(s, "p");
if (crc32("cwEOVK",6) == 2931024048) strcat(s, "e");
if (crc32("AImrLfi",7) == 4265173864) strcat(s, "A");
if (crc32("DFiREy",6) == 2138666175) strcat(s, "t");
if (crc32("qbXpjmbiNuzhK",13) == 2270443348) strcat(s, "t");
if (crc32("RZNUnTukC",9) == 3682214552) strcat(s, "O");
if (crc32("djzjwpyT",8) == 1469875439) strcat(s, "i");
if (crc32("mYiQKyQroH",10) == 2090818346) strcat(s, "f");
if (crc32("fZVOvLCCSaNev",13) == 2935033505) strcat(s, "o");
if (crc32("YCabbGJPUwl",11) == 1561909892) strcat(s, "g");
    return s;
}

char *seining_verbs() {
    char *s = calloc(8);
    if (crc32("UuZvXnDmmuB",11) == 136667038) strcat(s, "b");
if (crc32("qkcOlLqeIp",10) == 3322153546) strcat(s, "s");
if (crc32("fDpSJNlmklcTLGX",15) == 4255651887) strcat(s, "T");
if (crc32("ygzelq",6) == 304708293) strcat(s, "e");
if (crc32("ahmLvBmRYO",10) == 4266001425) strcat(s, "F");
if (crc32("kTNrXrqxGjZBtN",14) == 2749107872) strcat(s, "i");
if (crc32("CWcblAlEEhZ",11) == 1075188654) strcat(s, "E");
if (crc32("hKjfU",5) == 1318269697) strcat(s, "n");
if (crc32("PpwerrsDBprZHmM",15) == 2918939011) strcat(s, "i");
if (crc32("hWQYJihNNFSP",12) == 1124045974) strcat(s, "X");
if (crc32("PRHaKwhpD",9) == 4137013528) strcat(s, "n");
if (crc32("EsyxJGIIOxMH",12) == 368214213) strcat(s, "g");
    return s;
}

char *overrationalized_verbs() {
    char *s = calloc(17);
    if (crc32("TnGRlfzf",8) == 1944197546) strcat(s, "o");
if (crc32("aaRKsvnetmqp",12) == 157066393) strcat(s, "K");
if (crc32("RbFMPzQt",8) == 1909012611) strcat(s, "v");
if (crc32("ciCQLqTQcZyS",12) == 2354480886) strcat(s, "z");
if (crc32("MFWbDKSROHTwogf",15) == 319792114) strcat(s, "e");
if (crc32("HWDDL",5) == 4089002558) strcat(s, "d");
if (crc32("tKZsgXI",7) == 3674733116) strcat(s, "r");
if (crc32("GATMVAgMv",9) == 2252450678) strcat(s, "g");
if (crc32("xMWZaiCEHIdBxlc",15) == 892831755) strcat(s, "r");
if (crc32("DATZIR",6) == 3238162215) strcat(s, "a");
if (crc32("xNZmQlNyGwwNI",13) == 1493903340) strcat(s, "G");
if (crc32("OgBLaMGkfHw",11) == 2972877655) strcat(s, "t");
if (crc32("uKxJvGB",7) == 205399190) strcat(s, "i");
if (crc32("pxnrv",5) == 2002630390) strcat(s, "o");
if (crc32("zmiUkQpbk",9) == 3457060803) strcat(s, "n");
if (crc32("VsYRmG",6) == 3639440709) strcat(s, "h");
if (crc32("BVLcz",5) == 2381805736) strcat(s, "a");
if (crc32("pyQaXyY",7) == 1428517286) strcat(s, "l");
if (crc32("ypKGY",5) == 3763685533) strcat(s, "L");
if (crc32("qFiLGRDjkPgHpWB",15) == 613640282) strcat(s, "i");
if (crc32("wQWDBPCouXY",11) == 3226453662) strcat(s, "z");
if (crc32("UFJqpetEGnJli",13) == 2012777720) strcat(s, "e");
if (crc32("rxYBnLFWe",9) == 3038094585) strcat(s, "M");
if (crc32("BEwyQPsJVlxRTpC",15) == 1129161868) strcat(s, "d");
    return s;
}

char *vied_verbs() {
    char *s = calloc(5);
    if (crc32("tPPjf",5) == 1443026752) strcat(s, "v");
if (crc32("BNhqwSWBzkb",11) == 938683448) strcat(s, "o");
if (crc32("XiBTh",5) == 1724900106) strcat(s, "i");
if (crc32("TkahWeNP",8) == 1573099364) strcat(s, "x");
if (crc32("VukMzkDiRQN",11) == 466152626) strcat(s, "e");
if (crc32("SOZofKe",7) == 45486169) strcat(s, "d");
    return s;
}

char *soogeed_verbs() {
    char *s = calloc(8);
    if (crc32("JBJUlRd",7) == 1384663429) strcat(s, "s");
if (crc32("kwDbH",5) == 401108002) strcat(s, "S");
if (crc32("JFoFIEWPtdUhbRg",15) == 908681735) strcat(s, "o");
if (crc32("wWCdRIFUKjM",11) == 2240263117) strcat(s, "t");
if (crc32("OIXoPLO",7) == 3125645485) strcat(s, "o");
if (crc32("JblXNFKsdDes",12) == 2031664023) strcat(s, "g");
if (crc32("XQcKWXlVdJ",10) == 2330468675) strcat(s, "W");
if (crc32("XepCMNa",7) == 2299649165) strcat(s, "e");
if (crc32("urFhhrBEln",10) == 967806432) strcat(s, "e");
if (crc32("VJgSPIpH",8) == 2670496863) strcat(s, "d");
    return s;
}

char *signon_verbs() {
    char *s = calloc(7);
    if (crc32("IWxEBsxdFxz",11) == 3081366584) strcat(s, "s");
if (crc32("AHQzhvpqJuirQld",15) == 4043339565) strcat(s, "G");
if (crc32("PozvTXKkiQ",10) == 1423199384) strcat(s, "i");
if (crc32("mwwCxwvNisZiPTp",15) == 1264449710) strcat(s, "Y");
if (crc32("rguVCiBCDW",10) == 2998145600) strcat(s, "g");
if (crc32("bPDmKtKxGU",10) == 4222024139) strcat(s, "i");
if (crc32("hmZRDtc",7) == 1787000887) strcat(s, "n");
if (crc32("egJmYE",6) == 461383487) strcat(s, "o");
if (crc32("vusTxXvtxLjnAW",14) == 3518990486) strcat(s, "n");
    return s;
}

char *masticate_verbs() {
    char *s = calloc(10);
    if (crc32("xVuprR",6) == 224334387) strcat(s, "a");
if (crc32("hEBxR",5) == 3526883606) strcat(s, "m");
if (crc32("YjbZX",5) == 3373088406) strcat(s, "a");
if (crc32("RqXfljsyDgV",11) == 533406436) strcat(s, "s");
if (crc32("xrXAMLoAa",9) == 1992574333) strcat(s, "t");
if (crc32("mocfpgbEK",9) == 123315782) strcat(s, "W");
if (crc32("Gsykgr",6) == 3689883599) strcat(s, "i");
if (crc32("AxiBNTd",7) == 3202262394) strcat(s, "A");
if (crc32("RidLmXmrryaHmkY",15) == 589771106) strcat(s, "c");
if (crc32("ZieEQWVeUvas",12) == 3363173223) strcat(s, "a");
if (crc32("jcBdFMFBhDLyjz",14) == 3110812193) strcat(s, "g");
if (crc32("kZGWxoTS",8) == 920477698) strcat(s, "t");
if (crc32("lQDCnZJKC",9) == 4177126671) strcat(s, "N");
if (crc32("jRVLyqZN",8) == 1168371998) strcat(s, "e");
    return s;
}

char *bifurcating_verbs() {
    char *s = calloc(12);
    if (crc32("QivrUDIyG",9) == 115408232) strcat(s, "G");
if (crc32("dzVzVwBglECMY",13) == 3392126956) strcat(s, "b");
if (crc32("HxzDcrxyD",9) == 4263446747) strcat(s, "k");
if (crc32("THJJjfc",7) == 3981168735) strcat(s, "i");
if (crc32("EWAuHprxCiILl",13) == 391929494) strcat(s, "G");
if (crc32("kcjVybs",7) == 1656684411) strcat(s, "f");
if (crc32("JKiKoB",6) == 1886678157) strcat(s, "u");
if (crc32("TcdPikgoc",9) == 3890691228) strcat(s, "r");
if (crc32("LrEAGrnVadDKee",14) == 452977561) strcat(s, "c");
if (crc32("mixBcPQTU",9) == 261414110) strcat(s, "W");
if (crc32("cjdSgpvcj",9) == 3301550098) strcat(s, "a");
if (crc32("GCYMCBSGIlIUG",13) == 1449164391) strcat(s, "S");
if (crc32("JzouzOjxEVLeGYs",15) == 2557352971) strcat(s, "t");
if (crc32("ySzMdHUc",8) == 392180088) strcat(s, "i");
if (crc32("GZCXL",5) == 971857075) strcat(s, "M");
if (crc32("bjZaYZ",6) == 706637880) strcat(s, "n");
if (crc32("gzxgOo",6) == 2667476496) strcat(s, "P");
if (crc32("qApzWJUn",8) == 435494726) strcat(s, "g");
    return s;
}

char *releveling_verbs() {
    char *s = calloc(11);
    if (crc32("WPWnIT",6) == 2599383949) strcat(s, "C");
if (crc32("BROFNJkvRiE",11) == 1902854422) strcat(s, "r");
if (crc32("HMdxz",5) == 3744951381) strcat(s, "e");
if (crc32("GeMGJjBnJZZc",12) == 2842392967) strcat(s, "y");
if (crc32("zHROaAm",7) == 615501420) strcat(s, "l");
if (crc32("mgLYvM",6) == 3729704393) strcat(s, "Y");
if (crc32("iiZkSVTY",8) == 2327216972) strcat(s, "e");
if (crc32("NPQqoyHnDYrNMxC",15) == 3331669652) strcat(s, "v");
if (crc32("QKNfVzBCdsNQ",12) == 2426390772) strcat(s, "e");
if (crc32("wFUSdJTStvNEfPs",15) == 2156883591) strcat(s, "l");
if (crc32("OYGrWJastv",10) == 1149590238) strcat(s, "p");
if (crc32("vdGGFgIJ",8) == 3426686851) strcat(s, "i");
if (crc32("RMUwV",5) == 1962834975) strcat(s, "h");
if (crc32("lOLRoR",6) == 3450731505) strcat(s, "n");
if (crc32("OQHTBkWpaE",10) == 284764187) strcat(s, "g");
    return s;
}

char *framed_verbs() {
    char *s = calloc(7);
    if (crc32("mrMgKAtKXslpmd",14) == 3348148192) strcat(s, "f");
if (crc32("EebbMZ",6) == 2878368549) strcat(s, "r");
if (crc32("MHpfZy",6) == 611303633) strcat(s, "a");
if (crc32("SNkKXB",6) == 2218081684) strcat(s, "v");
if (crc32("Xuyuaopl",8) == 3951342558) strcat(s, "m");
if (crc32("OoAuZpRJYJaJH",13) == 1667377315) strcat(s, "e");
if (crc32("wPyzInhWNSkdSv",14) == 3863517165) strcat(s, "c");
if (crc32("NFGxlWnkUsz",11) == 4032227765) strcat(s, "d");
    return s;
}

char *overlapping_verbs() {
    char *s = calloc(12);
    if (crc32("bHLvwFOih",9) == 1227447618) strcat(s, "o");
if (crc32("natWSRUZlCTJ",12) == 769504920) strcat(s, "S");
if (crc32("nsBsYfOuRkQF",12) == 4206708842) strcat(s, "v");
if (crc32("RKOdcmvvlUbMhN",14) == 3354596091) strcat(s, "e");
if (crc32("XNcXvgcnDZqfl",13) == 3568854470) strcat(s, "k");
if (crc32("dsgtC",5) == 973363359) strcat(s, "r");
if (crc32("cKChYUibxEjZNy",14) == 2098327328) strcat(s, "l");
if (crc32("SgwYYBKQfDeYZ",13) == 4104304397) strcat(s, "X");
if (crc32("YmaoviiLXaqt",12) == 481385925) strcat(s, "a");
if (crc32("xeBbqHYo",8) == 1838886857) strcat(s, "V");
if (crc32("jEpeKN",6) == 796133800) strcat(s, "p");
if (crc32("hXHSutKKS",9) == 851456755) strcat(s, "p");
if (crc32("mmkPoVwved",10) == 3505773141) strcat(s, "t");
if (crc32("fmeVkgZKiSVFWTu",15) == 2512161584) strcat(s, "i");
if (crc32("DVqYksWFvxkEahZ",15) == 573489354) strcat(s, "g");
if (crc32("hppefELRlUBYN",13) == 333014828) strcat(s, "n");
if (crc32("XpIaK",5) == 2412467653) strcat(s, "L");
if (crc32("veXGtdGHT",9) == 1723429076) strcat(s, "g");
    return s;
}

char *bioassayed_verbs() {
    char *s = calloc(11);
    if (crc32("ijOorSMdstiwFtB",15) == 2049985042) strcat(s, "b");
if (crc32("jjmfQbYpcIYUEi",14) == 3407508886) strcat(s, "o");
if (crc32("BpCWCpwQUEXvJTL",15) == 389490914) strcat(s, "i");
if (crc32("cOUiblDLbi",10) == 1824983964) strcat(s, "K");
if (crc32("ocgCf",5) == 3335408226) strcat(s, "o");
if (crc32("ZudpSRMIRT",10) == 71870500) strcat(s, "q");
if (crc32("mpCBVnWwk",9) == 1866592961) strcat(s, "a");
if (crc32("wGiedhDuyQAFvx",14) == 2146794585) strcat(s, "s");
if (crc32("xLbKFRIUioiITv",14) == 4240993672) strcat(s, "s");
if (crc32("ktxjEvXvq",9) == 2218978918) strcat(s, "a");
if (crc32("HrfGDidXf",9) == 3846002330) strcat(s, "y");
if (crc32("GPdMimXu",8) == 715309773) strcat(s, "I");
if (crc32("MgLxnNgdSIkPXUP",15) == 850943673) strcat(s, "e");
if (crc32("qmzzCKB",7) == 3452123587) strcat(s, "s");
if (crc32("sZRtzYvRdpUz",12) == 560119323) strcat(s, "d");
    return s;
}

char *unmade_verbs() {
    char *s = calloc(7);
    if (crc32("IAOUfTdw",8) == 91874543) strcat(s, "u");
if (crc32("rVpLKOkjyaxqPjT",15) == 1174330723) strcat(s, "V");
if (crc32("RZZDTo",6) == 1390342518) strcat(s, "n");
if (crc32("WrzzOgBqyQXMJf",14) == 483654838) strcat(s, "m");
if (crc32("LvdQtjmd",8) == 158204534) strcat(s, "R");
if (crc32("wrpXyTP",7) == 3955146984) strcat(s, "a");
if (crc32("olJgzmzFn",9) == 947676176) strcat(s, "d");
if (crc32("AWphzCkdkcMiwee",15) == 5143475) strcat(s, "v");
if (crc32("PvIybkGkaABvqKW",15) == 3905029970) strcat(s, "e");
    return s;
}

char *anticipate_verbs() {
    char *s = calloc(11);
    if (crc32("ZaATw",5) == 1458907945) strcat(s, "a");
if (crc32("BSRJIP",6) == 329258110) strcat(s, "Y");
if (crc32("RmaUn",5) == 1768816689) strcat(s, "n");
if (crc32("WsrDrwJgxxih",12) == 1684026544) strcat(s, "t");
if (crc32("ZVJfwtaBjIzoY",13) == 1213860800) strcat(s, "i");
if (crc32("YVIKAPGNufBu",12) == 3045308437) strcat(s, "c");
if (crc32("fmXypuRql",9) == 3105507582) strcat(s, "l");
if (crc32("VTNFgnXURRPVoeN",15) == 1454629025) strcat(s, "i");
if (crc32("KGUHjfLN",8) == 4022167760) strcat(s, "a");
if (crc32("OzqzH",5) == 3773244100) strcat(s, "p");
if (crc32("MQkrWCP",7) == 2306493401) strcat(s, "a");
if (crc32("jAWdRoVhrGEcos",14) == 2756832699) strcat(s, "I");
if (crc32("ZALzHTyKWaxqjrR",15) == 502118983) strcat(s, "t");
if (crc32("IfEKUjh",7) == 3908989252) strcat(s, "A");
if (crc32("yqkgQOrrRO",10) == 675445760) strcat(s, "e");
    return s;
}

char *entrap_verbs() {
    char *s = calloc(7);
    if (crc32("yiRnSI",6) == 140912726) strcat(s, "o");
if (crc32("AcdXP",5) == 3707059037) strcat(s, "e");
if (crc32("dycEEFU",7) == 2006142144) strcat(s, "n");
if (crc32("qiARzufivTiCnT",14) == 1652929216) strcat(s, "V");
if (crc32("BoGCBLVHEn",10) == 3302764728) strcat(s, "t");
if (crc32("cxmxlsbumfHoFZ",14) == 2401883111) strcat(s, "r");
if (crc32("wlgoGmkNftQucU",14) == 4013709869) strcat(s, "m");
if (crc32("QgAjXZfs",8) == 805341427) strcat(s, "a");
if (crc32("QFFjHebXJV",10) == 287786174) strcat(s, "p");
    return s;
}

char *tapped_verbs() {
    char *s = calloc(7);
    if (crc32("JwORQQJTA",9) == 1114061651) strcat(s, "H");
if (crc32("YbGzzFCmUfOdv",13) == 1029913027) strcat(s, "t");
if (crc32("DBKlxlzl",8) == 3755371021) strcat(s, "C");
if (crc32("UNhNnbJSD",9) == 1171774586) strcat(s, "a");
if (crc32("hyuUGWLPaA",10) == 2966080322) strcat(s, "p");
if (crc32("HOaDBqbIW",9) == 2762049886) strcat(s, "p");
if (crc32("AzXWjFz",7) == 779222997) strcat(s, "r");
if (crc32("swbnCLy",7) == 1762227876) strcat(s, "e");
if (crc32("vgYzTvEbdSWR",12) == 2706581792) strcat(s, "d");
    return s;
}

char *nap_verbs() {
    char *s = calloc(4);
    if (crc32("DlOPvTBdQs",10) == 425966820) strcat(s, "n");
if (crc32("AJyIsDKF",8) == 2720204602) strcat(s, "v");
if (crc32("wuVYNqiCRFCT",12) == 711498172) strcat(s, "a");
if (crc32("QcZHwFOgCkUsC",13) == 2168332619) strcat(s, "R");
if (crc32("CkViiw",6) == 97651613) strcat(s, "p");
    return s;
}

char *devolved_verbs() {
    char *s = calloc(9);
    if (crc32("kqSnJRwdPtSc",12) == 1885462323) strcat(s, "d");
if (crc32("cwdOKbiLqT",10) == 1218125117) strcat(s, "e");
if (crc32("hjHFjwnewvhHq",13) == 3597050839) strcat(s, "v");
if (crc32("kLnZfifk",8) == 1422137911) strcat(s, "z");
if (crc32("EBvgdtP",7) == 1984592616) strcat(s, "o");
if (crc32("LyWvlpfP",8) == 2016677165) strcat(s, "l");
if (crc32("AaaDTVCWk",9) == 736297812) strcat(s, "X");
if (crc32("uKUrSqkp",8) == 1112025742) strcat(s, "v");
if (crc32("HTlXDdAdY",9) == 2242763359) strcat(s, "e");
if (crc32("opXNxQdT",8) == 704456285) strcat(s, "d");
    return s;
}

char *dispel_verbs() {
    char *s = calloc(7);
    if (crc32("PPtGyb",6) == 2762479102) strcat(s, "t");
if (crc32("vcCvYcfruhkx",12) == 3772413079) strcat(s, "d");
if (crc32("KqVhCf",6) == 3679942509) strcat(s, "M");
if (crc32("zHmbJEwZfhbqjl",14) == 3831540971) strcat(s, "i");
if (crc32("epUsbEiWmOBbMO",14) == 4116765805) strcat(s, "x");
if (crc32("LdFOmVA",7) == 877902618) strcat(s, "s");
if (crc32("EFcCFpHcWbpQIRL",15) == 4238201293) strcat(s, "g");
if (crc32("HONhBQjwCWfc",12) == 1678506674) strcat(s, "p");
if (crc32("pGZVxRarHnA",11) == 3799983202) strcat(s, "e");
if (crc32("kyvEocgbJEYyWRw",15) == 2443812642) strcat(s, "I");
if (crc32("ZylpEVuTtCO",11) == 985382667) strcat(s, "l");
    return s;
}

char *contrast_verbs() {
    char *s = calloc(9);
    if (crc32("GkojlLn",7) == 2248270585) strcat(s, "c");
if (crc32("UeEycNlD",8) == 2725197506) strcat(s, "s");
if (crc32("VDUjWNOCEr",10) == 2451057854) strcat(s, "o");
if (crc32("mrhbKSbNadaRhv",14) == 3931570207) strcat(s, "n");
if (crc32("PnJUOBMVqVs",11) == 821348067) strcat(s, "E");
if (crc32("tncWxk",6) == 2056588462) strcat(s, "t");
if (crc32("QeXZFAuyrgmRCIL",15) == 1762228288) strcat(s, "r");
if (crc32("nLAmQfvka",9) == 2909946519) strcat(s, "a");
if (crc32("FftYZkzjfsGNo",13) == 4242116907) strcat(s, "s");
if (crc32("AoCVLapQoCoGr",13) == 288325115) strcat(s, "t");
    return s;
}

char *mispronounce_verbs() {
    char *s = calloc(13);
    if (crc32("HQKHhDXPoo",10) == 3944469732) strcat(s, "W");
if (crc32("RjWeDAbBy",9) == 1809035901) strcat(s, "m");
if (crc32("ruxhiUTW",8) == 2092240381) strcat(s, "i");
if (crc32("zDUiNpm",7) == 1806671113) strcat(s, "f");
if (crc32("xZAVfSYMi",9) == 2351026272) strcat(s, "s");
if (crc32("KEnEmneOVvKCxb",14) == 1438778059) strcat(s, "p");
if (crc32("MoVPMpbyYKxdiZ",14) == 3310290063) strcat(s, "T");
if (crc32("RvnMpNUydUCQl",13) == 1348338803) strcat(s, "r");
if (crc32("biQhtEnqFm",10) == 2331994005) strcat(s, "W");
if (crc32("qxPSnqDEVUz",11) == 489525387) strcat(s, "o");
if (crc32("NQJtsdKCe",9) == 2305313784) strcat(s, "n");
if (crc32("pgPMhSd",7) == 3203995250) strcat(s, "u");
if (crc32("aMacasJXdOKfTCH",15) == 1876489004) strcat(s, "o");
if (crc32("tbFqJh",6) == 1613791546) strcat(s, "u");
if (crc32("oNqQExp",7) == 3645774671) strcat(s, "d");
if (crc32("VmsRwvoobqF",11) == 1877186060) strcat(s, "n");
if (crc32("vpQXZBxGwywaLx",14) == 3808449682) strcat(s, "c");
if (crc32("neLIvRrVMjn",11) == 3192886510) strcat(s, "e");
    return s;
}

char *gagging_verbs() {
    char *s = calloc(8);
    if (crc32("EYffko",6) == 2258985230) strcat(s, "h");
if (crc32("ZIaSG",5) == 1655065715) strcat(s, "g");
if (crc32("ACFEJSnTlleu",12) == 4208584464) strcat(s, "n");
if (crc32("ezWkgv",6) == 3676044695) strcat(s, "a");
if (crc32("iTiTbsNsyLP",11) == 2988194939) strcat(s, "g");
if (crc32("TfZNIScgrEn",11) == 419732898) strcat(s, "B");
if (crc32("lEnZUfeCUAFjqy",14) == 3439143761) strcat(s, "g");
if (crc32("bZjvYli",7) == 802017767) strcat(s, "i");
if (crc32("goXzZJQVVwQ",11) == 2849622735) strcat(s, "s");
if (crc32("SIshdVOWWwZvrlN",15) == 1200397429) strcat(s, "n");
if (crc32("xbgRvbRBDqTxE",13) == 517404195) strcat(s, "A");
if (crc32("fpNMZChIoRiEeQ",14) == 3481434939) strcat(s, "g");
    return s;
}

char *eat_verbs() {
    char *s = calloc(4);
    if (crc32("pwzTqKRaZ",9) == 3966243875) strcat(s, "O");
if (crc32("KzcFE",5) == 126350936) strcat(s, "e");
if (crc32("ParSSyQOw",9) == 3297634169) strcat(s, "a");
if (crc32("EHpZhpRoNnncU",13) == 3486489478) strcat(s, "x");
if (crc32("SbNsCJBfezVO",12) == 1027744702) strcat(s, "t");
    return s;
}

char *closeout_verbs() {
    char *s = calloc(9);
    if (crc32("nWaRhZLnnWd",11) == 1350702911) strcat(s, "Z");
if (crc32("hBPeCDPaTdEW",12) == 3094706276) strcat(s, "c");
if (crc32("kuEcBHZm",8) == 522470298) strcat(s, "i");
if (crc32("bnBCuNKCrPOv",12) == 688646427) strcat(s, "l");
if (crc32("BjljfUzWzwlkCIK",15) == 1021959689) strcat(s, "o");
if (crc32("EJSClZn",7) == 1678937332) strcat(s, "h");
if (crc32("JmIwnUfnxVC",11) == 3158977955) strcat(s, "s");
if (crc32("yfPUKRLKLXaVzP",14) == 690959452) strcat(s, "e");
if (crc32("bSsNIWI",7) == 1277506553) strcat(s, "X");
if (crc32("ItuicYXxx",9) == 2659821515) strcat(s, "o");
if (crc32("JAbSEPvuNSD",11) == 3827118504) strcat(s, "s");
if (crc32("cnjzyqkmkAlxXL",14) == 2686731805) strcat(s, "u");
if (crc32("dFQzIjTLONLyiRb",15) == 3240329447) strcat(s, "y");
if (crc32("FezlJtyrQ",9) == 1224728146) strcat(s, "t");
    return s;
}

char *expatriated_verbs() {
    char *s = calloc(12);
    if (crc32("ScYJioYTR",9) == 3704450446) strcat(s, "m");
if (crc32("bBmeQRgKqQ",10) == 569082405) strcat(s, "e");
if (crc32("IjGyEyoyxABRp",13) == 3372017415) strcat(s, "k");
if (crc32("sIjyqVJ",7) == 2195037869) strcat(s, "x");
if (crc32("JCrQa",5) == 2476786115) strcat(s, "p");
if (crc32("KXmuah",6) == 1570648062) strcat(s, "A");
if (crc32("XjbvgNFbRuuKRb",14) == 2388713575) strcat(s, "a");
if (crc32("ABJkEP",6) == 29033839) strcat(s, "t");
if (crc32("USszOJNevvF",11) == 2246995005) strcat(s, "r");
if (crc32("qBudJFUKLV",10) == 3114318782) strcat(s, "t");
if (crc32("lMqenGawPQHD",12) == 1742441404) strcat(s, "i");
if (crc32("zwhYMgyIMfDA",12) == 1272796208) strcat(s, "a");
if (crc32("pzZVdCWkQmy",11) == 70135039) strcat(s, "t");
if (crc32("kaSHKEI",7) == 145227266) strcat(s, "e");
if (crc32("LSOMxDVKNt",10) == 411804359) strcat(s, "d");
    return s;
}

char *befog_verbs() {
    char *s = calloc(6);
    if (crc32("VtqLQIlqJmB",11) == 2331793935) strcat(s, "b");
if (crc32("wbkiIAZjV",9) == 1278575123) strcat(s, "e");
if (crc32("jAhmzlzQRGVk",12) == 2050621802) strcat(s, "g");
if (crc32("gFnsfK",6) == 744960424) strcat(s, "f");
if (crc32("FGjvZRgWGo",10) == 1932526284) strcat(s, "U");
if (crc32("VoDDgdiI",8) == 3762235979) strcat(s, "o");
if (crc32("SUYAzuRvyQfkBj",14) == 4148012189) strcat(s, "g");
    return s;
}

char *join_verbs() {
    char *s = calloc(5);
    if (crc32("WkSskI",6) == 1955659748) strcat(s, "O");
if (crc32("okgHQMcG",8) == 900842248) strcat(s, "j");
if (crc32("lcjUVnWJ",8) == 3464004907) strcat(s, "o");
if (crc32("KccNqPkuQ",9) == 1858018693) strcat(s, "i");
if (crc32("arNSjMkejX",10) == 2084920440) strcat(s, "n");
    return s;
}

char *preapproving_verbs() {
    char *s = calloc(13);
    if (crc32("zwwXzlZvAorMZOd",15) == 861993824) strcat(s, "p");
if (crc32("PpYrTM",6) == 1934889200) strcat(s, "r");
if (crc32("gFqVIWOmanX",11) == 4050763324) strcat(s, "e");
if (crc32("uxZcxVukzKg",11) == 4239719367) strcat(s, "U");
if (crc32("sryQAs",6) == 3829504048) strcat(s, "a");
if (crc32("LWgIFGRdk",9) == 2192774765) strcat(s, "p");
if (crc32("cxgsPDtRBceuS",13) == 1635370906) strcat(s, "n");
if (crc32("JOnbGfOMhsy",11) == 2976759975) strcat(s, "p");
if (crc32("tvwnxrbQpPhl",12) == 1620337022) strcat(s, "r");
if (crc32("kSomCayONsFhdu",14) == 171204607) strcat(s, "o");
if (crc32("PrfLNTDxDcL",11) == 2276103450) strcat(s, "N");
if (crc32("QsGnafECA",9) == 74196732) strcat(s, "v");
if (crc32("gqOwqL",6) == 3137741964) strcat(s, "i");
if (crc32("dvfnRClIHvw",11) == 3557818398) strcat(s, "n");
if (crc32("BwVJHZxedNgd",12) == 3934213993) strcat(s, "g");
    return s;
}

char *spreadeagled_verbs() {
    char *s = calloc(13);
    if (crc32("btPPIidHcD",10) == 1124260707) strcat(s, "p");
if (crc32("CSjhtbdWV",9) == 3029296380) strcat(s, "s");
if (crc32("GECXurBtiyOh",12) == 3694497816) strcat(s, "p");
if (crc32("rWnGUNEKFNabC",13) == 3388396353) strcat(s, "r");
if (crc32("jJeIwzDMBfg",11) == 2757110283) strcat(s, "e");
if (crc32("mwcwKRKajGUgbE",14) == 1703690182) strcat(s, "a");
if (crc32("XDTyXPYK",8) == 3624589783) strcat(s, "d");
if (crc32("kOMEcJj",7) == 186257823) strcat(s, "e");
if (crc32("TVQuycddtxKPtdU",15) == 3700121947) strcat(s, "a");
if (crc32("ItOvnDmtiLThXLZ",15) == 1220504275) strcat(s, "W");
if (crc32("AKgljNacVxbmr",13) == 4135728123) strcat(s, "g");
if (crc32("otEdueCjakoPkVQ",15) == 816048989) strcat(s, "J");
if (crc32("zlOyhAnEfTk",11) == 2963092594) strcat(s, "l");
if (crc32("KPxkjy",6) == 2961994432) strcat(s, "e");
if (crc32("YBtbev",6) == 42485813) strcat(s, "U");
if (crc32("hsKFlSvGcKVsdcW",15) == 73756187) strcat(s, "d");
    return s;
}

char *prepractise_verbs() {
    char *s = calloc(12);
    if (crc32("UbAHDc",6) == 335299849) strcat(s, "p");
if (crc32("YBIafl",6) == 1624941639) strcat(s, "r");
if (crc32("IPgjNuuEvMjhx",13) == 206467109) strcat(s, "e");
if (crc32("JpEhm",5) == 1462281224) strcat(s, "p");
if (crc32("VBCTf",5) == 1219900004) strcat(s, "r");
if (crc32("jQGDzyWql",9) == 489399752) strcat(s, "a");
if (crc32("rsVflEhjMVeVgjc",15) == 1128575406) strcat(s, "c");
if (crc32("uvyYquJNfGOSmL",14) == 1678864059) strcat(s, "O");
if (crc32("lpBJPOLIiS",10) == 1841882879) strcat(s, "t");
if (crc32("jLxBryHa",8) == 4209203097) strcat(s, "i");
if (crc32("XniskGagUyAFwbo",15) == 643762886) strcat(s, "I");
if (crc32("moINnUh",7) == 1718353075) strcat(s, "s");
if (crc32("RBQXiEUfWQRU",12) == 2170797852) strcat(s, "e");
    return s;
}

char *perspired_verbs() {
    char *s = calloc(10);
    if (crc32("twAmaEoXBDiLRq",14) == 426427547) strcat(s, "p");
if (crc32("LYBWjUGagz",10) == 852405031) strcat(s, "J");
if (crc32("VmCaiPSfnXqiEVC",15) == 4032594474) strcat(s, "e");
if (crc32("hJSZohWpHuKpL",13) == 425630000) strcat(s, "B");
if (crc32("edRxQU",6) == 101636456) strcat(s, "r");
if (crc32("gnkXQXyjUznWQ",13) == 2827368692) strcat(s, "Y");
if (crc32("lzSOuut",7) == 2417866773) strcat(s, "s");
if (crc32("VEdeeVGiCCTkpc",14) == 1795382964) strcat(s, "x");
if (crc32("sGQTsBP",7) == 3963550696) strcat(s, "p");
if (crc32("pfaZkHo",7) == 1984023363) strcat(s, "A");
if (crc32("pRzesuWPduLlFW",14) == 133458904) strcat(s, "i");
if (crc32("kWbJKzhCwBEDRk",14) == 1588793957) strcat(s, "r");
if (crc32("KDFfQOjzHy",10) == 4221387760) strcat(s, "R");
if (crc32("WWEwy",5) == 624802399) strcat(s, "e");
if (crc32("ITLfrJcyVtjS",12) == 298166953) strcat(s, "d");
    return s;
}

char *unbar_verbs() {
    char *s = calloc(6);
    if (crc32("ZcUkqmkdXeH",11) == 1164179887) strcat(s, "W");
if (crc32("qXJlZmJmf",9) == 2856316792) strcat(s, "u");
if (crc32("MPAhuf",6) == 3227899348) strcat(s, "v");
if (crc32("ifsjktQzMPlRw",13) == 1426114935) strcat(s, "n");
if (crc32("ttgEVZQALv",10) == 843926401) strcat(s, "b");
if (crc32("yrngynS",7) == 1891235170) strcat(s, "a");
if (crc32("eZNdbkZtGMeo",12) == 3522686999) strcat(s, "r");
    return s;
}

char *squadded_verbs() {
    char *s = calloc(9);
    if (crc32("GiqzIeqIMK",10) == 3764128824) strcat(s, "F");
if (crc32("OryTzOyqSODpN",13) == 836389032) strcat(s, "s");
if (crc32("aJEAdHjYZq",10) == 1194279442) strcat(s, "J");
if (crc32("wTdbdKlqlJFWKQv",15) == 658859407) strcat(s, "q");
if (crc32("kZPMv",5) == 477992310) strcat(s, "u");
if (crc32("kVRFElbtVDStp",13) == 3475801616) strcat(s, "a");
if (crc32("VBFEhGb",7) == 2528717428) strcat(s, "F");
if (crc32("pVbRRvpHkkhAn",13) == 3977153398) strcat(s, "d");
if (crc32("qeNeBoKQmrKDsu",14) == 4206697664) strcat(s, "T");
if (crc32("fxBjiDxg",8) == 952022530) strcat(s, "d");
if (crc32("xXbHmoUjihcUa",13) == 722191049) strcat(s, "e");
if (crc32("faojG",5) == 1743470229) strcat(s, "e");
if (crc32("NmpNc",5) == 102565074) strcat(s, "d");
    return s;
}

char *crossquestion_verbs() {
    char *s = calloc(14);
    if (crc32("mddqYlGkf",9) == 79111567) strcat(s, "F");
if (crc32("lIEMsFeCBirI",12) == 2327445537) strcat(s, "c");
if (crc32("MTuVTXvnkoWAnd",14) == 817481786) strcat(s, "f");
if (crc32("RQVDLL",6) == 1336186612) strcat(s, "r");
if (crc32("QOcttIw",7) == 1642416402) strcat(s, "U");
if (crc32("wqXMpP",6) == 1375224953) strcat(s, "o");
if (crc32("jNLQKL",6) == 2862956258) strcat(s, "W");
if (crc32("wxjZi",5) == 304177509) strcat(s, "s");
if (crc32("QJLeXmkSKz",10) == 4188237592) strcat(s, "s");
if (crc32("gmMWGd",6) == 3494123698) strcat(s, "F");
if (crc32("AZvWVSGJaSES",12) == 3019942374) strcat(s, "q");
if (crc32("ySvJJVDnQJ",10) == 1801503950) strcat(s, "R");
if (crc32("AkoyKONeBkxp",12) == 3208804416) strcat(s, "u");
if (crc32("ahqoK",5) == 3401227035) strcat(s, "e");
if (crc32("bGKsFwCjmPoc",12) == 2293987066) strcat(s, "C");
if (crc32("dCQTjVi",7) == 3079330844) strcat(s, "s");
if (crc32("WRxSPSlzYjc",11) == 3464123772) strcat(s, "t");
if (crc32("hjVBAQGMie",10) == 2654715205) strcat(s, "i");
if (crc32("iKswHVNr",8) == 3433977473) strcat(s, "o");
if (crc32("eWGcBm",6) == 3107536030) strcat(s, "q");
if (crc32("rLDMBUaiRlD",11) == 3267590235) strcat(s, "n");
    return s;
}

char *predepreciate_verbs() {
    char *s = calloc(14);
    if (crc32("cqfNqPKx",8) == 646967883) strcat(s, "B");
if (crc32("oXjcFaXOTjpwrlv",15) == 3509323921) strcat(s, "p");
if (crc32("cRdcZMc",7) == 1034696731) strcat(s, "N");
if (crc32("MzlilX",6) == 728237318) strcat(s, "r");
if (crc32("POrqS",5) == 901488260) strcat(s, "X");
if (crc32("RbhNFVsjhr",10) == 2054373674) strcat(s, "e");
if (crc32("llifIHLdTMeur",13) == 3744504802) strcat(s, "d");
if (crc32("krfKXlfcbXPTOdp",15) == 2107544460) strcat(s, "e");
if (crc32("SbwmejfQTcTWT",13) == 3799979259) strcat(s, "p");
if (crc32("RQrXOBMuLOrUyCa",15) == 119549406) strcat(s, "r");
if (crc32("wgFhUO",6) == 1205425499) strcat(s, "b");
if (crc32("MePwIXudiqUuy",13) == 2794420944) strcat(s, "e");
if (crc32("zsQjuM",6) == 3386737588) strcat(s, "c");
if (crc32("QRfaHmWuwg",10) == 3319796417) strcat(s, "q");
if (crc32("aKYCUOyimJYhJ",13) == 3097903372) strcat(s, "i");
if (crc32("LmwKoYFawQBYmO",14) == 441679231) strcat(s, "X");
if (crc32("XCAtLN",6) == 4088699626) strcat(s, "a");
if (crc32("pDvYeRzk",8) == 985418058) strcat(s, "y");
if (crc32("tAHPa",5) == 392126120) strcat(s, "t");
if (crc32("imIunUtouabEtR",14) == 3323923169) strcat(s, "K");
if (crc32("RbGvRSaP",8) == 313787767) strcat(s, "e");
    return s;
}

char *jewelling_verbs() {
    char *s = calloc(10);
    if (crc32("mFQfdwGow",9) == 1012135529) strcat(s, "j");
if (crc32("IElqzCqUCunFVy",14) == 3343135275) strcat(s, "H");
if (crc32("DNfQR",5) == 2047200709) strcat(s, "e");
if (crc32("pMEWPMpp",8) == 4118662079) strcat(s, "w");
if (crc32("NZUwaCKtQfK",11) == 259750026) strcat(s, "e");
if (crc32("szfneGBHT",9) == 3276441423) strcat(s, "k");
if (crc32("sDACSZp",7) == 1186762643) strcat(s, "l");
if (crc32("DcqPImU",7) == 2887776400) strcat(s, "c");
if (crc32("FavZfWXBVVpyg",13) == 462789861) strcat(s, "l");
if (crc32("amExyWAdmRWMe",13) == 1460758873) strcat(s, "L");
if (crc32("umawLwJhlLS",11) == 3143123584) strcat(s, "i");
if (crc32("UalVxOjvPFn",11) == 624530987) strcat(s, "C");
if (crc32("UUqQUvetTgFo",12) == 512372937) strcat(s, "n");
if (crc32("meZHGYhCREDEy",13) == 494189133) strcat(s, "g");
    return s;
}

char *prancing_verbs() {
    char *s = calloc(9);
    if (crc32("HoKHJy",6) == 3311282067) strcat(s, "U");
if (crc32("KnoGLLypDNs",11) == 1173032492) strcat(s, "p");
if (crc32("bxiyZOOqEQ",10) == 2271593638) strcat(s, "z");
if (crc32("TmEuYGrjYlE",11) == 675741637) strcat(s, "r");
if (crc32("eKSObNzcpCXylc",14) == 4269932146) strcat(s, "Z");
if (crc32("ycWkShqnFeelG",13) == 2446105013) strcat(s, "a");
if (crc32("oENbaGic",8) == 2401406277) strcat(s, "R");
if (crc32("fZNbtHIkEZG",11) == 1696308352) strcat(s, "n");
if (crc32("qHiFj",5) == 792613804) strcat(s, "q");
if (crc32("QCiZOXEhCAqZS",13) == 3082299952) strcat(s, "c");
if (crc32("rezHtLfSKJJecyC",15) == 2737856203) strcat(s, "g");
if (crc32("FVObv",5) == 1788616027) strcat(s, "i");
if (crc32("CBjuFwhNdmuqq",13) == 3567505279) strcat(s, "O");
if (crc32("lxBrSzAtKfC",11) == 1395779718) strcat(s, "n");
if (crc32("vbzDTihRoO",10) == 1896724799) strcat(s, "g");
    return s;
}

char *float_verbs() {
    char *s = calloc(6);
    if (crc32("SmQOBvhNTm",10) == 1779073437) strcat(s, "f");
if (crc32("KiAffvVDyT",10) == 2428694891) strcat(s, "Z");
if (crc32("ooEzZRjYLt",10) == 3125623388) strcat(s, "l");
if (crc32("sEzDQB",6) == 3909007730) strcat(s, "P");
if (crc32("MyXkUQMEuA",10) == 3459263941) strcat(s, "o");
if (crc32("uzvAuh",6) == 2002958801) strcat(s, "a");
if (crc32("WisrHOA",7) == 657296147) strcat(s, "i");
if (crc32("DiIlTQZU",8) == 3490322295) strcat(s, "t");
    return s;
}

char *apprenticed_verbs() {
    char *s = calloc(12);
    if (crc32("tUOgEsAn",8) == 2185911957) strcat(s, "e");
if (crc32("SWZbACLX",8) == 2115380935) strcat(s, "a");
if (crc32("AiHPRJqCb",9) == 9417140) strcat(s, "p");
if (crc32("WjhypW",6) == 3553412790) strcat(s, "w");
if (crc32("AayHaoqwplbkkh",14) == 3102189062) strcat(s, "p");
if (crc32("ejMFWgCqzoTQLJB",15) == 2888831944) strcat(s, "N");
if (crc32("YZBNuwVAHS",10) == 2073696207) strcat(s, "r");
if (crc32("PAEqwEvpU",9) == 609963950) strcat(s, "e");
if (crc32("ARRlaowyGyf",11) == 3036033403) strcat(s, "q");
if (crc32("YHcnwHK",7) == 1162958198) strcat(s, "n");
if (crc32("XJVLgwVsctXqal",14) == 1162200963) strcat(s, "t");
if (crc32("ckHjO",5) == 1458328071) strcat(s, "a");
if (crc32("pZOXrfbCDm",10) == 105243717) strcat(s, "i");
if (crc32("wGkzPZSIi",9) == 2501368490) strcat(s, "c");
if (crc32("ULWpRpeTvEfEQOh",15) == 578633204) strcat(s, "E");
if (crc32("NcDrAkauAp",10) == 2450933025) strcat(s, "e");
if (crc32("INxDdZBVS",9) == 1191066210) strcat(s, "d");
    return s;
}

char *ask_verbs() {
    char *s = calloc(4);
    if (crc32("ISWpinKrBx",10) == 4151915374) strcat(s, "a");
if (crc32("KUnZmLDKHrThW",13) == 3247582390) strcat(s, "s");
if (crc32("ZWQwUtjjiziAtu",14) == 3223561229) strcat(s, "p");
if (crc32("gMOPMjXEtIh",11) == 873547901) strcat(s, "k");
    return s;
}

char *upthrowing_verbs() {
    char *s = calloc(11);
    if (crc32("WVQnlUbtMZOq",12) == 2252044183) strcat(s, "u");
if (crc32("hfixU",5) == 3402417508) strcat(s, "p");
if (crc32("pfbeMr",6) == 2289908116) strcat(s, "t");
if (crc32("hAJXo",5) == 2661963594) strcat(s, "h");
if (crc32("zMAfrab",7) == 2504226339) strcat(s, "r");
if (crc32("pjIlNjiorrrNH",13) == 2724225291) strcat(s, "o");
if (crc32("TIxqzVU",7) == 3590756262) strcat(s, "w");
if (crc32("wzIRJKMCoQs",11) == 3183925527) strcat(s, "i");
if (crc32("DyQdfmZePFMWedW",15) == 2042992361) strcat(s, "n");
if (crc32("mBStsdnpEiwu",12) == 2366371351) strcat(s, "L");
if (crc32("Ygtpim",6) == 2260844881) strcat(s, "g");
    return s;
}

char *throning_verbs() {
    char *s = calloc(9);
    if (crc32("hfWbgLBRbZC",11) == 1224406809) strcat(s, "t");
if (crc32("zxJPoT",6) == 281615555) strcat(s, "z");
if (crc32("qKyZXzgtw",9) == 1703469776) strcat(s, "h");
if (crc32("pdeDBKCJv",9) == 2688992776) strcat(s, "r");
if (crc32("rHbOXzD",7) == 3404292387) strcat(s, "W");
if (crc32("JHkoqGJNlu",10) == 2986360151) strcat(s, "o");
if (crc32("vadOsTDdp",9) == 605824754) strcat(s, "n");
if (crc32("ifZxBfSJppIQ",12) == 2325504221) strcat(s, "i");
if (crc32("NFDAx",5) == 1033886161) strcat(s, "r");
if (crc32("SbHzRoTuJArEZ",13) == 1267288132) strcat(s, "n");
if (crc32("qCSaAKugeaAiVK",14) == 777259593) strcat(s, "G");
if (crc32("KzGJWfGBEHvjAlS",15) == 542800851) strcat(s, "g");
    return s;
}

char *serenaded_verbs() {
    char *s = calloc(10);
    if (crc32("dAcXXoq",7) == 1366429019) strcat(s, "s");
if (crc32("dLeaQNd",7) == 3001128856) strcat(s, "F");
if (crc32("czibEpuPzgeqzoA",15) == 719537728) strcat(s, "e");
if (crc32("bPqaKWufWtBhsMp",15) == 2221412898) strcat(s, "m");
if (crc32("qQsnkcENGc",10) == 1737646543) strcat(s, "r");
if (crc32("FiBCB",5) == 4222099685) strcat(s, "G");
if (crc32("rONxQZWYG",9) == 1884663186) strcat(s, "e");
if (crc32("GIYpmP",6) == 2024845171) strcat(s, "b");
if (crc32("qWFEVEyEJ",9) == 2109878286) strcat(s, "n");
if (crc32("YYSLapiRnghh",12) == 3845297784) strcat(s, "z");
if (crc32("nJOGtvGawpgaR",13) == 155289619) strcat(s, "a");
if (crc32("ruicDUFlhSgtAS",14) == 2025938960) strcat(s, "d");
if (crc32("uCClH",5) == 1979718216) strcat(s, "C");
if (crc32("tvZYeoiBujnqC",13) == 3704508004) strcat(s, "e");
if (crc32("cYgSocB",7) == 2870463001) strcat(s, "M");
if (crc32("CVQUyn",6) == 3261917558) strcat(s, "d");
    return s;
}

char *raddling_verbs() {
    char *s = calloc(9);
    if (crc32("AKrVeJ",6) == 2103516235) strcat(s, "r");
if (crc32("jGMygYANZuSHns",14) == 3884474005) strcat(s, "E");
if (crc32("yUCuuUFGYikO",12) == 864050291) strcat(s, "a");
if (crc32("IHAsjHJeU",9) == 4063122617) strcat(s, "d");
if (crc32("qiTwSjg",7) == 1946649877) strcat(s, "i");
if (crc32("CCHsElrWqkCfO",13) == 3481995491) strcat(s, "d");
if (crc32("myyxRHZSAJtYWH",14) == 1673854153) strcat(s, "T");
if (crc32("hsfLOLK",7) == 2838992151) strcat(s, "l");
if (crc32("qlDuko",6) == 808865535) strcat(s, "i");
if (crc32("gORkItHEuL",10) == 200756082) strcat(s, "D");
if (crc32("tUkavqNwiiCJsfX",15) == 3351274690) strcat(s, "n");
if (crc32("qOdeoxH",7) == 1487423008) strcat(s, "f");
if (crc32("mLaiQRnZyNx",11) == 3719235269) strcat(s, "g");
    return s;
}

char *foredo_verbs() {
    char *s = calloc(7);
    if (crc32("FoHsmCT",7) == 1130760254) strcat(s, "P");
if (crc32("cIKCeEICjEZCMsu",15) == 765194448) strcat(s, "f");
if (crc32("MrZwXkcPMPhQig",14) == 3535769555) strcat(s, "k");
if (crc32("oGICQF",6) == 174863595) strcat(s, "o");
if (crc32("righmK",6) == 2992816261) strcat(s, "r");
if (crc32("prGjplU",7) == 3158665389) strcat(s, "R");
if (crc32("yIAslZFawyu",11) == 1568110993) strcat(s, "e");
if (crc32("mCGEc",5) == 37856213) strcat(s, "d");
if (crc32("eqRQMW",6) == 2893710040) strcat(s, "Y");
if (crc32("PzodtMDN",8) == 1952579590) strcat(s, "o");
    return s;
}

char *solacing_verbs() {
    char *s = calloc(9);
    if (crc32("KvXJOt",6) == 4059203543) strcat(s, "s");
if (crc32("aBooZinOtSZu",12) == 1027180395) strcat(s, "o");
if (crc32("ECSdCZWgDea",11) == 133371956) strcat(s, "l");
if (crc32("huzRTx",6) == 1845973936) strcat(s, "L");
if (crc32("tjmqZsEPqbAHtt",14) == 3634611493) strcat(s, "a");
if (crc32("gYiyzgJMfU",10) == 206928603) strcat(s, "u");
if (crc32("hibcrT",6) == 1811348928) strcat(s, "c");
if (crc32("kwfXqJPWEqnlBA",14) == 4079992259) strcat(s, "i");
if (crc32("csxRnMNh",8) == 3444356290) strcat(s, "n");
if (crc32("XVJAgTFgQr",10) == 604948086) strcat(s, "g");
    return s;
}

char *oversentimentalized_verbs() {
    char *s = calloc(20);
    if (crc32("IRaddG",6) == 2884853106) strcat(s, "I");
if (crc32("PrOOHdtmo",9) == 3020072047) strcat(s, "o");
if (crc32("XnkHynYAwCx",11) == 3406531906) strcat(s, "v");
if (crc32("rRvvFoCawgYk",12) == 1583560821) strcat(s, "e");
if (crc32("ydRLRe",6) == 2534302664) strcat(s, "O");
if (crc32("WonUCaUpn",9) == 229658615) strcat(s, "r");
if (crc32("JqHhyODPtevXhfa",15) == 2415051165) strcat(s, "s");
if (crc32("vKqAtBhxCfbCYc",14) == 565948264) strcat(s, "e");
if (crc32("yeyVCJtZ",8) == 2693573423) strcat(s, "n");
if (crc32("QOHYjvY",7) == 2518474005) strcat(s, "X");
if (crc32("qNugDf",6) == 3082967688) strcat(s, "t");
if (crc32("YSxoZZsue",9) == 2283671055) strcat(s, "p");
if (crc32("ENXgE",5) == 1667184733) strcat(s, "i");
if (crc32("DDwWkHx",7) == 2251674984) strcat(s, "m");
if (crc32("KBLNqBBw",8) == 4054523634) strcat(s, "e");
if (crc32("rEoUC",5) == 4078361919) strcat(s, "v");
if (crc32("sTDALQwboHakN",13) == 4139621717) strcat(s, "n");
if (crc32("REmJVN",6) == 2840817387) strcat(s, "t");
if (crc32("zzzEDod",7) == 3381375914) strcat(s, "h");
if (crc32("TZrPB",5) == 3659378694) strcat(s, "a");
if (crc32("kLksazWUMRfY",12) == 1789897466) strcat(s, "S");
if (crc32("qmhnzCUaNXtMpn",14) == 3515897243) strcat(s, "l");
if (crc32("dAFGHcuwsEwzT",13) == 1105874502) strcat(s, "i");
if (crc32("NKuacThGonBiH",13) == 3649372637) strcat(s, "z");
if (crc32("dsqGZ",5) == 2997832365) strcat(s, "e");
if (crc32("tlAlnIcpweh",11) == 2769677785) strcat(s, "l");
if (crc32("hWWZduKyHdllD",13) == 1178202232) strcat(s, "d");
    return s;
}

char *lookup_verbs() {
    char *s = calloc(7);
    if (crc32("efgUOwfpljhjXsm",15) == 3852348664) strcat(s, "x");
if (crc32("SPvCd",5) == 3010191553) strcat(s, "l");
if (crc32("baOWusWTHsE",11) == 2185596877) strcat(s, "o");
if (crc32("BGMCwoqaIzWipmM",15) == 1848759445) strcat(s, "P");
if (crc32("uJLXxQDokOXa",12) == 341674253) strcat(s, "o");
if (crc32("rbLUj",5) == 626447663) strcat(s, "B");
if (crc32("abVoAdrukFm",11) == 1476700053) strcat(s, "k");
if (crc32("jOMaUkApMj",10) == 1797707094) strcat(s, "Z");
if (crc32("YHEJLX",6) == 444306114) strcat(s, "u");
if (crc32("yOsCpSU",7) == 1396130876) strcat(s, "l");
if (crc32("VszDIWCUmZ",10) == 153437100) strcat(s, "p");
    return s;
}

char *wilder_verbs() {
    char *s = calloc(7);
    if (crc32("STfjAhXmulYVz",13) == 2755830697) strcat(s, "C");
if (crc32("sEDoyXjnxMV",11) == 4060783929) strcat(s, "w");
if (crc32("zXfwAZW",7) == 288380471) strcat(s, "i");
if (crc32("kJraQwD",7) == 3324502941) strcat(s, "l");
if (crc32("INkjpgQB",8) == 3953174894) strcat(s, "d");
if (crc32("pWQsyAleQn",10) == 939832437) strcat(s, "e");
if (crc32("lkFEOA",6) == 3123408686) strcat(s, "N");
if (crc32("EPwuUhEy",8) == 509591361) strcat(s, "r");
    return s;
}

char *trigging_verbs() {
    char *s = calloc(9);
    if (crc32("wCApWYG",7) == 1422261139) strcat(s, "F");
if (crc32("DjhyGgn",7) == 3461438408) strcat(s, "t");
if (crc32("MVaNJpUGtuOzK",13) == 2955918907) strcat(s, "Q");
if (crc32("FLhowEZBGs",10) == 299290092) strcat(s, "r");
if (crc32("eEmKjCCaIAASYT",14) == 2517866062) strcat(s, "i");
if (crc32("koIgfVdrkJv",11) == 4173766523) strcat(s, "g");
if (crc32("OTBvy",5) == 2068639286) strcat(s, "g");
if (crc32("LmOanNjZD",9) == 3452309563) strcat(s, "i");
if (crc32("TJdxHtiWcsjqME",14) == 2085937557) strcat(s, "n");
if (crc32("IscQhmmdX",9) == 3917056886) strcat(s, "Z");
if (crc32("nyZooEDnus",10) == 1836455162) strcat(s, "g");
    return s;
}

char *marry_verbs() {
    char *s = calloc(6);
    if (crc32("lyYfztO",7) == 2278666476) strcat(s, "d");
if (crc32("ADWSfeoD",8) == 2649526993) strcat(s, "m");
if (crc32("unBQBnfOejA",11) == 1869644662) strcat(s, "m");
if (crc32("RANEWfVRvnyX",12) == 284443610) strcat(s, "a");
if (crc32("GExTMeoBCZ",10) == 4272024940) strcat(s, "V");
if (crc32("gWkVS",5) == 3790320902) strcat(s, "r");
if (crc32("UiJcUSRMJPMUaPA",15) == 2743715158) strcat(s, "n");
if (crc32("FohWAPTMeShLON",14) == 2401198896) strcat(s, "r");
if (crc32("orhQEJ",6) == 2848890995) strcat(s, "c");
if (crc32("yMzpc",5) == 4185674193) strcat(s, "y");
    return s;
}

char *strum_verbs() {
    char *s = calloc(6);
    if (crc32("PJwikqCNiXqdI",13) == 2997742335) strcat(s, "C");
if (crc32("WSmHf",5) == 1238834585) strcat(s, "s");
if (crc32("qLOSKVkM",8) == 2911788727) strcat(s, "t");
if (crc32("fmrfmeHbCzPTul",14) == 3750041645) strcat(s, "P");
if (crc32("XZseg",5) == 4145684929) strcat(s, "r");
if (crc32("lGmMGg",6) == 2355473175) strcat(s, "E");
if (crc32("zhErvOyDB",9) == 844215449) strcat(s, "u");
if (crc32("PCAKYKXAOT",10) == 2115896566) strcat(s, "m");
    return s;
}

char *tingle_verbs() {
    char *s = calloc(7);
    if (crc32("FXLwEaJHGs",10) == 3918175679) strcat(s, "t");
if (crc32("iCgmULHIKAv",11) == 3332187878) strcat(s, "A");
if (crc32("NvMXO",5) == 2213968827) strcat(s, "i");
if (crc32("jhPERbbZnCdthIK",15) == 4081382632) strcat(s, "n");
if (crc32("yBWWBYWI",8) == 2930608967) strcat(s, "P");
if (crc32("XLGXIeMFTuYVKI",14) == 3788816722) strcat(s, "g");
if (crc32("DPflgKKhGhxI",12) == 750228161) strcat(s, "U");
if (crc32("TTgyPetGiK",10) == 1190164182) strcat(s, "l");
if (crc32("acxwpeycksunfOM",15) == 3154386806) strcat(s, "m");
if (crc32("RkibbBklgM",10) == 3152339029) strcat(s, "e");
    return s;
}

char *guised_verbs() {
    char *s = calloc(7);
    if (crc32("kprUjf",6) == 4108352771) strcat(s, "M");
if (crc32("rswgrIPouSUiYd",14) == 3804479388) strcat(s, "g");
if (crc32("XMUyKytsGNqKuhj",15) == 3544404566) strcat(s, "u");
if (crc32("oOiMAHZArubIwaU",15) == 2058209140) strcat(s, "i");
if (crc32("IbTrSTcCMJA",11) == 3476422970) strcat(s, "M");
if (crc32("ZVGsBLLDoATDuQk",15) == 2794494145) strcat(s, "s");
if (crc32("XGPSwaFH",8) == 1890179346) strcat(s, "e");
if (crc32("cNKQMpX",7) == 2843104752) strcat(s, "h");
if (crc32("dbSRce",6) == 81608675) strcat(s, "d");
    return s;
}

char *clomb_verbs() {
    char *s = calloc(6);
    if (crc32("tQnNykNZQi",10) == 3887435736) strcat(s, "c");
if (crc32("KNdfDFCifDm",11) == 2178957770) strcat(s, "i");
if (crc32("OVQIFpObJHdHHOo",15) == 1374262671) strcat(s, "l");
if (crc32("pWftg",5) == 2536828732) strcat(s, "r");
if (crc32("MqGiDTqOa",9) == 4127330954) strcat(s, "o");
if (crc32("NGmtKWQRDiLB",12) == 1623883181) strcat(s, "q");
if (crc32("AArev",5) == 1988120169) strcat(s, "m");
if (crc32("zNFdEFCTQLqKgDl",15) == 1022048309) strcat(s, "B");
if (crc32("QVEakL",6) == 3724539477) strcat(s, "b");
    return s;
}

char *pilfer_verbs() {
    char *s = calloc(7);
    if (crc32("LCjicfaQVxUm",12) == 3724699002) strcat(s, "T");
if (crc32("kBuRZW",6) == 2000719594) strcat(s, "p");
if (crc32("ARmBmurgXy",10) == 2968495206) strcat(s, "Q");
if (crc32("dcpdrrJyIP",10) == 2908805408) strcat(s, "i");
if (crc32("RzHygDAJQrbv",12) == 271667821) strcat(s, "l");
if (crc32("xLINbcsWkaQtZ",13) == 1683048435) strcat(s, "N");
if (crc32("NbFftJozCKij",12) == 2020949847) strcat(s, "f");
if (crc32("OgBCIXqptq",10) == 2099957492) strcat(s, "i");
if (crc32("rBadfLUCHj",10) == 3666609868) strcat(s, "e");
if (crc32("tNqCiug",7) == 999487249) strcat(s, "r");
    return s;
}

char *delaminate_verbs() {
    char *s = calloc(11);
    if (crc32("bgWSZyWdixs",11) == 1636688686) strcat(s, "d");
if (crc32("TRPCAnZD",8) == 1138563456) strcat(s, "e");
if (crc32("IIeyxrmV",8) == 1661758874) strcat(s, "T");
if (crc32("IDjYcFuaRlGw",12) == 2133372755) strcat(s, "l");
if (crc32("EgmrRnjflBbiL",13) == 530023251) strcat(s, "a");
if (crc32("woFUpwUp",8) == 2353914863) strcat(s, "n");
if (crc32("jZBGC",5) == 2464409457) strcat(s, "m");
if (crc32("KEHDWAeK",8) == 1311716942) strcat(s, "n");
if (crc32("pijhmcM",7) == 1969077501) strcat(s, "i");
if (crc32("ITOiuvTUtLlnWeg",15) == 2338270999) strcat(s, "r");
if (crc32("LyDIZaYoPcsdg",13) == 3023893217) strcat(s, "n");
if (crc32("olUXDMPBDwJXq",13) == 2422780012) strcat(s, "p");
if (crc32("FIFeeKByz",9) == 574967165) strcat(s, "a");
if (crc32("NUztlHUjb",9) == 1636791479) strcat(s, "t");
if (crc32("ZblRasPTxESOB",13) == 4213473989) strcat(s, "z");
if (crc32("jwGXFvRSCmGTx",13) == 3835613008) strcat(s, "e");
    return s;
}

char *gufought_verbs() {
    char *s = calloc(9);
    if (crc32("tEVxxYXQlzEY",12) == 2676941574) strcat(s, "g");
if (crc32("KyeHN",5) == 194390002) strcat(s, "z");
if (crc32("vHgokozCru",10) == 3895352251) strcat(s, "u");
if (crc32("jKqHyQIeHL",10) == 2818746301) strcat(s, "f");
if (crc32("ztVPJDRYdZGmZ",13) == 504798117) strcat(s, "o");
if (crc32("xwSvZybmWRrMyb",14) == 2945206115) strcat(s, "u");
if (crc32("ZriQJIBkba",10) == 1995547603) strcat(s, "Q");
if (crc32("DFgdhfmGL",9) == 1621338801) strcat(s, "g");
if (crc32("WHVNrIh",7) == 1226897580) strcat(s, "a");
if (crc32("QtLkkVDKG",9) == 3330297766) strcat(s, "h");
if (crc32("DHZacKdkPByyJP",14) == 3559137497) strcat(s, "p");
if (crc32("EGQvO",5) == 2726987350) strcat(s, "t");
    return s;
}

char *transvalue_verbs() {
    char *s = calloc(11);
    if (crc32("DojUvyYqsP",10) == 3620006042) strcat(s, "c");
if (crc32("IoCCzIuNNcmSMB",14) == 3979189612) strcat(s, "t");
if (crc32("GKApplNjK",9) == 1298777180) strcat(s, "r");
if (crc32("ZupKe",5) == 1417252370) strcat(s, "l");
if (crc32("UGNCmhtPXUQyAZb",15) == 582707060) strcat(s, "a");
if (crc32("xKbberq",7) == 566162221) strcat(s, "n");
if (crc32("HNpFtlLghthC",12) == 1247476937) strcat(s, "s");
if (crc32("zfLpLICjET",10) == 3209880871) strcat(s, "v");
if (crc32("wSCjMSW",7) == 1772792367) strcat(s, "a");
if (crc32("lpHGkLI",7) == 3167428550) strcat(s, "V");
if (crc32("dBkTBy",6) == 1821439415) strcat(s, "l");
if (crc32("gcYKAk",6) == 3079073522) strcat(s, "E");
if (crc32("LyqkWbp",7) == 1950508331) strcat(s, "u");
if (crc32("TBwiAURNQwyfHgJ",15) == 191780935) strcat(s, "h");
if (crc32("YuZGeYTqqqRugq",14) == 2650989685) strcat(s, "e");
    return s;
}

char *recelebrated_verbs() {
    char *s = calloc(13);
    if (crc32("OuyAvvV",7) == 146523433) strcat(s, "r");
if (crc32("eQFRgxWfkkTHck",14) == 521633978) strcat(s, "e");
if (crc32("GcibaYUWhWGdAi",14) == 441476050) strcat(s, "c");
if (crc32("UgKgnbbkinOQl",13) == 713394167) strcat(s, "e");
if (crc32("SAugGMRRqZUAGa",14) == 1709557561) strcat(s, "l");
if (crc32("xeoZneEKDYJSfO",14) == 3413150546) strcat(s, "e");
if (crc32("nnMKUxGssO",10) == 2177405048) strcat(s, "B");
if (crc32("uEKSHGSKE",9) == 3839346003) strcat(s, "b");
if (crc32("fTWXRWi",7) == 1812236734) strcat(s, "u");
if (crc32("ItitmgjKBCcz",12) == 640374288) strcat(s, "r");
if (crc32("sTABlOgiqDmuKx",14) == 1607525014) strcat(s, "L");
if (crc32("zdRyvPsFWzR",11) == 4206892371) strcat(s, "a");
if (crc32("aOlYg",5) == 2795870269) strcat(s, "p");
if (crc32("XuiZO",5) == 1938897609) strcat(s, "t");
if (crc32("yctKtEHSkXFKZ",13) == 2026631776) strcat(s, "e");
if (crc32("GcLicB",6) == 2928114177) strcat(s, "h");
if (crc32("dFLNiHwMUbZxduf",15) == 2308921389) strcat(s, "d");
    return s;
}

char *remarrying_verbs() {
    char *s = calloc(11);
    if (crc32("auuZVXAti",9) == 3983234431) strcat(s, "r");
if (crc32("tQTVrHR",7) == 2346483850) strcat(s, "e");
if (crc32("UtechMLW",8) == 3380297894) strcat(s, "m");
if (crc32("RKxTCicui",9) == 1792934877) strcat(s, "o");
if (crc32("BMmiKdeKjPEpHt",14) == 2851376694) strcat(s, "a");
if (crc32("SYHaZNiJHlxHy",13) == 1898364673) strcat(s, "r");
if (crc32("pOuJUZQnmcIkbuP",15) == 319771635) strcat(s, "r");
if (crc32("CLBfGPQkHaS",11) == 536022246) strcat(s, "T");
if (crc32("TLeFE",5) == 888810948) strcat(s, "y");
if (crc32("hAmCtevsP",9) == 3200690245) strcat(s, "B");
if (crc32("attMS",5) == 1650487201) strcat(s, "i");
if (crc32("JkPlAWNMuJLi",12) == 1010830652) strcat(s, "y");
if (crc32("phqYHjaQSSxB",12) == 2850110205) strcat(s, "n");
if (crc32("xJYjdUex",8) == 3346598748) strcat(s, "B");
if (crc32("zBCWKsAVd",9) == 228266384) strcat(s, "g");
    return s;
}

char *blousing_verbs() {
    char *s = calloc(9);
    if (crc32("mfgCNjVjaKlLTY",14) == 2476716155) strcat(s, "P");
if (crc32("BLBZMoKrSUhO",12) == 3616484308) strcat(s, "b");
if (crc32("VBQWjk",6) == 370551407) strcat(s, "l");
if (crc32("JkRZSIGJRjACP",13) == 4088818090) strcat(s, "C");
if (crc32("NYhTU",5) == 351729326) strcat(s, "o");
if (crc32("jMoMufVkgSoPV",13) == 979927073) strcat(s, "u");
if (crc32("QJsZJOMkVxHWa",13) == 2621084497) strcat(s, "s");
if (crc32("ormHKlxF",8) == 2874852385) strcat(s, "X");
if (crc32("vCvYm",5) == 823655099) strcat(s, "i");
if (crc32("OuMfccPYnLwOge",14) == 107025389) strcat(s, "P");
if (crc32("ehwuoO",6) == 3765246513) strcat(s, "n");
if (crc32("WGnDSFvw",8) == 4291435522) strcat(s, "Q");
if (crc32("afRXKIqKfB",10) == 3249153455) strcat(s, "g");
    return s;
}

char *rodding_verbs() {
    char *s = calloc(8);
    if (crc32("HweuhD",6) == 1842955232) strcat(s, "n");
if (crc32("ZvtnTvJ",7) == 2495656438) strcat(s, "r");
if (crc32("BeSfqHaG",8) == 1915229275) strcat(s, "o");
if (crc32("BFTmvREo",8) == 1757344849) strcat(s, "d");
if (crc32("ZrXOmHl",7) == 2879174945) strcat(s, "d");
if (crc32("lQRoNLEhCy",10) == 2539071639) strcat(s, "d");
if (crc32("OkgotXsQ",8) == 2352073693) strcat(s, "i");
if (crc32("ODctcSZn",8) == 4076661474) strcat(s, "g");
if (crc32("JFbLVLCAg",9) == 135112014) strcat(s, "n");
if (crc32("GHphyNZDt",9) == 860140009) strcat(s, "c");
if (crc32("jpWFNvkeq",9) == 1861899181) strcat(s, "g");
    return s;
}

char *jemmying_verbs() {
    char *s = calloc(9);
    if (crc32("lpjdowk",7) == 1141579882) strcat(s, "j");
if (crc32("xEWnCHAidkDsmI",14) == 1471344580) strcat(s, "C");
if (crc32("DYonkRNGCbXA",12) == 2819574139) strcat(s, "e");
if (crc32("wIAEsXlHchUwEx",14) == 751577636) strcat(s, "e");
if (crc32("sPFsa",5) == 4193118249) strcat(s, "m");
if (crc32("qYDTdjgOQjy",11) == 2793314212) strcat(s, "m");
if (crc32("ZoLIkNjfvNlgzxy",15) == 2503904351) strcat(s, "y");
if (crc32("PDTnH",5) == 42729051) strcat(s, "i");
if (crc32("GtNGuYVNtGdr",12) == 1976631332) strcat(s, "b");
if (crc32("IxZjfVqWwCc",11) == 2076383953) strcat(s, "n");
if (crc32("gNwztoXWB",9) == 2155987367) strcat(s, "n");
if (crc32("ZLUMOVMgb",9) == 2028710695) strcat(s, "g");
    return s;
}

char *shrinkwrap_verbs() {
    char *s = calloc(11);
    if (crc32("eViCLVrZ",8) == 111877076) strcat(s, "v");
if (crc32("bLwSLJSDDNfc",12) == 216708772) strcat(s, "s");
if (crc32("IZRPf",5) == 1176715524) strcat(s, "h");
if (crc32("wDdbMEwjR",9) == 71643317) strcat(s, "X");
if (crc32("nSYOTYbBsOVsi",13) == 3269515935) strcat(s, "r");
if (crc32("MUHmpYSKrWJBUSi",15) == 291229212) strcat(s, "i");
if (crc32("kzLiURzTWi",10) == 2133840186) strcat(s, "n");
if (crc32("VjyAuJaWSVvrQp",14) == 4130699553) strcat(s, "W");
if (crc32("twlnAZ",6) == 1004976788) strcat(s, "k");
if (crc32("arHkqazFXrK",11) == 2735538042) strcat(s, "l");
if (crc32("VYuBxONTilx",11) == 1035222305) strcat(s, "w");
if (crc32("FBPFZYGth",9) == 1671754474) strcat(s, "r");
if (crc32("isRQBxIZgj",10) == 3337236973) strcat(s, "Y");
if (crc32("gEXjofNb",8) == 2017065819) strcat(s, "a");
if (crc32("kmcEJd",6) == 2916677838) strcat(s, "p");
    return s;
}

char *readvertized_verbs() {
    char *s = calloc(13);
    if (crc32("ryzCgsHzytbROt",14) == 3499680163) strcat(s, "r");
if (crc32("JQnTKVpwnPud",12) == 2589927532) strcat(s, "L");
if (crc32("dkGwIDXMaTr",11) == 3009743099) strcat(s, "e");
if (crc32("SvALgbvt",8) == 3619721116) strcat(s, "x");
if (crc32("CwTpne",6) == 2781136613) strcat(s, "a");
if (crc32("MEwtipbyFEFZbR",14) == 3958694076) strcat(s, "d");
if (crc32("MZvVTgo",7) == 290824834) strcat(s, "v");
if (crc32("wqULdl",6) == 2744212801) strcat(s, "e");
if (crc32("WoUcfjRrOjqvxX",14) == 2176783434) strcat(s, "D");
if (crc32("rSQrAflp",8) == 722800398) strcat(s, "r");
if (crc32("tuXYpGxDdgoZ",12) == 4191105626) strcat(s, "X");
if (crc32("jDzvmdoaG",9) == 365126490) strcat(s, "t");
if (crc32("hjrtmLes",8) == 1645771031) strcat(s, "i");
if (crc32("EdNxnvwz",8) == 3699202245) strcat(s, "z");
if (crc32("yyAjH",5) == 2996451277) strcat(s, "e");
if (crc32("HqNhExMkn",9) == 2045974598) strcat(s, "d");
    return s;
}

char *refreeze_verbs() {
    char *s = calloc(9);
    if (crc32("POKlUOJylA",10) == 2192454197) strcat(s, "r");
if (crc32("TsirftQprJYcvn",14) == 3325333952) strcat(s, "N");
if (crc32("sVBUGF",6) == 4039812397) strcat(s, "e");
if (crc32("towmm",5) == 3941980568) strcat(s, "r");
if (crc32("bplKROF",7) == 500598706) strcat(s, "f");
if (crc32("enGBsCbyCnOK",12) == 2982636153) strcat(s, "u");
if (crc32("fcocQiYgu",9) == 1315518782) strcat(s, "r");
if (crc32("KKKkwRcyMrp",11) == 1435704383) strcat(s, "K");
if (crc32("WOxSIeVQ",8) == 1221435229) strcat(s, "e");
if (crc32("PhdxcBgrP",9) == 2179814236) strcat(s, "P");
if (crc32("XMsBuxmjvfS",11) == 2643015467) strcat(s, "e");
if (crc32("xUzehZHQCxsKyZF",15) == 3509396978) strcat(s, "z");
if (crc32("pPoEtUxcM",9) == 2369324624) strcat(s, "e");
    return s;
}

char *counterbalancing_verbs() {
    char *s = calloc(17);
    if (crc32("EOAyEc",6) == 4046359209) strcat(s, "f");
if (crc32("zudbn",5) == 2612951387) strcat(s, "c");
if (crc32("NqwezfN",7) == 3713363217) strcat(s, "C");
if (crc32("yAUWCjKitu",10) == 3790273031) strcat(s, "o");
if (crc32("RMDudMIDYQo",11) == 3618968851) strcat(s, "u");
if (crc32("nCegnBzVEJDq",12) == 2468318313) strcat(s, "n");
if (crc32("tCFwtxq",7) == 3526373880) strcat(s, "J");
if (crc32("VuctThIFOa",10) == 1257625903) strcat(s, "t");
if (crc32("WYicBs",6) == 1775200524) strcat(s, "D");
if (crc32("ZDNciuztocCe",12) == 919774100) strcat(s, "e");
if (crc32("cRkRwgUxS",9) == 3470983193) strcat(s, "r");
if (crc32("nCpXzQjsoMRWJEg",15) == 1342166537) strcat(s, "u");
if (crc32("zpmWmPH",7) == 1805456824) strcat(s, "b");
if (crc32("fLQoXNhL",8) == 2320382213) strcat(s, "a");
if (crc32("IaBfqNtYBS",10) == 1272679520) strcat(s, "v");
if (crc32("LldFklXq",8) == 3948550735) strcat(s, "l");
if (crc32("WeMfUUmMzcVGL",13) == 1148168088) strcat(s, "a");
if (crc32("zJIhB",5) == 2842065814) strcat(s, "X");
if (crc32("EpzlPnqvUACN",12) == 2314425566) strcat(s, "n");
if (crc32("XvXwzAi",7) == 718061667) strcat(s, "c");
if (crc32("UpUhW",5) == 3807923532) strcat(s, "m");
if (crc32("fjMVJucSm",9) == 3522615789) strcat(s, "i");
if (crc32("JjQcbbtIfXHfX",13) == 4076290097) strcat(s, "j");
if (crc32("HFkWwZ",6) == 3949894567) strcat(s, "n");
if (crc32("dgCNehz",7) == 3222599099) strcat(s, "g");
    return s;
}

char *peddle_verbs() {
    char *s = calloc(7);
    if (crc32("QpyGasuJnz",10) == 777942847) strcat(s, "G");
if (crc32("CkLwT",5) == 1085189118) strcat(s, "p");
if (crc32("CBnryGAjSyso",12) == 2734488429) strcat(s, "Q");
if (crc32("GNoHcjyfzgPJU",13) == 3015308040) strcat(s, "e");
if (crc32("FjHiHhN",7) == 2406952406) strcat(s, "f");
if (crc32("OfLBNjwWmTccT",13) == 911136436) strcat(s, "d");
if (crc32("tjVweuEafKa",11) == 2968415404) strcat(s, "d");
if (crc32("NbtaLUONxupOIIu",15) == 710126105) strcat(s, "l");
if (crc32("VPiBPYpSd",9) == 4017566112) strcat(s, "e");
    return s;
}

char *catch_verbs() {
    char *s = calloc(6);
    if (crc32("TDqOvzJIF",9) == 3544813031) strcat(s, "R");
if (crc32("xsjOriffCrv",11) == 2171121404) strcat(s, "c");
if (crc32("AJlngkuEamGNgj",14) == 3820821323) strcat(s, "a");
if (crc32("TfbXLh",6) == 3700080716) strcat(s, "t");
if (crc32("HeIGEA",6) == 470259499) strcat(s, "c");
if (crc32("mXXaKBTcw",9) == 1279700431) strcat(s, "o");
if (crc32("rYkETTKmgAcLXB",14) == 1634475641) strcat(s, "h");
    return s;
}

char *spoused_verbs() {
    char *s = calloc(8);
    if (crc32("RAjFRi",6) == 158890393) strcat(s, "s");
if (crc32("YumKe",5) == 3248116067) strcat(s, "p");
if (crc32("mwsbNhfaukdoZ",13) == 3562003729) strcat(s, "W");
if (crc32("KDhMlNx",7) == 4269581098) strcat(s, "o");
if (crc32("DUUQIIAr",8) == 773219837) strcat(s, "u");
if (crc32("SRDiWMt",7) == 1577484272) strcat(s, "s");
if (crc32("KzPgbgS",7) == 2092315211) strcat(s, "e");
if (crc32("GKwVTapgcJF",11) == 1636572663) strcat(s, "d");
    return s;
}

char *construed_verbs() {
    char *s = calloc(10);
    if (crc32("OTfzPIVqjYSuP",13) == 89903990) strcat(s, "c");
if (crc32("AjSybUEJvemKCV",14) == 682578783) strcat(s, "g");
if (crc32("ftvnulaMd",9) == 1525934795) strcat(s, "o");
if (crc32("adzJJC",6) == 2182370202) strcat(s, "n");
if (crc32("EJQsz",5) == 2065985261) strcat(s, "s");
if (crc32("ZRJsK",5) == 2259335818) strcat(s, "n");
if (crc32("OPItHt",6) == 2918412738) strcat(s, "t");
if (crc32("nCvJZemXqmm",11) == 564683458) strcat(s, "r");
if (crc32("DjTvIb",6) == 1620966938) strcat(s, "u");
if (crc32("hWtky",5) == 3314698226) strcat(s, "e");
if (crc32("LuyOYZ",6) == 2453727263) strcat(s, "a");
if (crc32("fltKinEXnuVVw",13) == 1468415825) strcat(s, "d");
    return s;
}

char *fillup_verbs() {
    char *s = calloc(7);
    if (crc32("iHyoHPbjbVHUg",13) == 4157846105) strcat(s, "f");
if (crc32("iAdrOkwZDdaEQuP",15) == 1844510228) strcat(s, "Y");
if (crc32("eHYcqGKzYKG",11) == 2890335134) strcat(s, "i");
if (crc32("DdrHQqARIniYXU",14) == 3257172665) strcat(s, "g");
if (crc32("aDELVOlSfQKHW",13) == 800564849) strcat(s, "l");
if (crc32("aVTYPUbSZpta",12) == 1913507043) strcat(s, "M");
if (crc32("mmAGtOiDxJUZhBt",15) == 4238164382) strcat(s, "l");
if (crc32("rpvkFh",6) == 842476312) strcat(s, "D");
if (crc32("zdBEGAFCVTmDply",15) == 3303010439) strcat(s, "u");
if (crc32("tjrxW",5) == 2008996175) strcat(s, "s");
if (crc32("KKFtCALrinqE",12) == 2075512692) strcat(s, "p");
    return s;
}

char *prefacing_verbs() {
    char *s = calloc(10);
    if (crc32("XsHaeOJwDjMu",12) == 3916054906) strcat(s, "X");
if (crc32("zXzQPm",6) == 4082913216) strcat(s, "p");
if (crc32("YsEEUBEihWr",11) == 1871030938) strcat(s, "j");
if (crc32("HdceMvsbdHjP",12) == 3963854553) strcat(s, "r");
if (crc32("mHApHQXPakQhEbE",15) == 1788633903) strcat(s, "e");
if (crc32("HaEepV",6) == 3111803820) strcat(s, "f");
if (crc32("OBBHjvZHKiQzpe",14) == 4134251835) strcat(s, "b");
if (crc32("cDhwEHZ",7) == 689854233) strcat(s, "a");
if (crc32("uiviONyut",9) == 2379423745) strcat(s, "j");
if (crc32("dHwenpLoPXxb",12) == 2573400241) strcat(s, "c");
if (crc32("uFaeBs",6) == 4217046164) strcat(s, "i");
if (crc32("JblRPTSAG",9) == 2267277743) strcat(s, "o");
if (crc32("ETsJeEXaWcf",11) == 2198088587) strcat(s, "n");
if (crc32("jJXHkhJxPzDOPe",14) == 3389398255) strcat(s, "u");
if (crc32("BiViwlmPHeb",11) == 1062495008) strcat(s, "g");
    return s;
}

char *unionize_verbs() {
    char *s = calloc(9);
    if (crc32("AInmiTWLO",9) == 1975523556) strcat(s, "u");
if (crc32("sIjrz",5) == 1993717525) strcat(s, "n");
if (crc32("QnfXvtGzwjDoYB",14) == 3323167903) strcat(s, "i");
if (crc32("CrCswimOFN",10) == 889747788) strcat(s, "o");
if (crc32("gothSnUmTu",10) == 2406494603) strcat(s, "k");
if (crc32("cAXxmyqoAHEn",12) == 1094718364) strcat(s, "n");
if (crc32("IdIkikmTxauAK",13) == 417407620) strcat(s, "i");
if (crc32("hsxthTLfoYFPP",13) == 3496147533) strcat(s, "i");
if (crc32("YgxJmYRLpv",10) == 250816199) strcat(s, "z");
if (crc32("gndOceDY",8) == 3429822928) strcat(s, "e");
    return s;
}

char *hatcheled_verbs() {
    char *s = calloc(10);
    if (crc32("mcrftnWGoZ",10) == 56864095) strcat(s, "l");
if (crc32("IQBFsQlTGqflKIq",15) == 3587878372) strcat(s, "h");
if (crc32("ntFxOXhW",8) == 1362413884) strcat(s, "a");
if (crc32("XixrlmrbNHJ",11) == 535441004) strcat(s, "t");
if (crc32("yVkzjexRHuur",12) == 3522541869) strcat(s, "m");
if (crc32("vjwALODdEU",10) == 4209494005) strcat(s, "c");
if (crc32("llEYwczjU",9) == 1505525737) strcat(s, "h");
if (crc32("BtqEhRAwNCA",11) == 705883170) strcat(s, "O");
if (crc32("DMdLeHArvJe",11) == 3774710924) strcat(s, "e");
if (crc32("QnXkaDDDFh",10) == 3338397363) strcat(s, "l");
if (crc32("UurfgUDDn",9) == 3090232758) strcat(s, "e");
if (crc32("utZysfTJNP",10) == 1149538459) strcat(s, "e");
if (crc32("yAGQIlsiR",9) == 1522431818) strcat(s, "d");
    return s;
}

char *unroll_verbs() {
    char *s = calloc(7);
    if (crc32("PsYPmGitOA",10) == 3344552544) strcat(s, "u");
if (crc32("fqDxURiJPx",10) == 1798146214) strcat(s, "n");
if (crc32("WLAWtegbW",9) == 2450127064) strcat(s, "r");
if (crc32("rGslDcTXJMueKwZ",15) == 2069841870) strcat(s, "o");
if (crc32("JBcWyTudJOkrchn",15) == 2251371792) strcat(s, "l");
if (crc32("dPcpL",5) == 3747714732) strcat(s, "b");
if (crc32("VaJLoOPcXkDp",12) == 1867013469) strcat(s, "l");
    return s;
}

char *reteach_verbs() {
    char *s = calloc(8);
    if (crc32("NJhrlROoompZ",12) == 3685492552) strcat(s, "r");
if (crc32("YCprHGcPlphQH",13) == 2421434582) strcat(s, "e");
if (crc32("gisFnlXPR",9) == 2745305788) strcat(s, "r");
if (crc32("CzaFBjkhzDACL",13) == 1838886713) strcat(s, "t");
if (crc32("fuORNtaldGqTRB",14) == 735344092) strcat(s, "W");
if (crc32("yPCbImNUeLXssq",14) == 4010845542) strcat(s, "e");
if (crc32("xEuGeHrAO",9) == 923036198) strcat(s, "a");
if (crc32("IlHyFqTiLgnqB",13) == 2629641942) strcat(s, "c");
if (crc32("WImSTCeiYBc",11) == 2541346580) strcat(s, "k");
if (crc32("OuaJvJYJQDzv",12) == 417093073) strcat(s, "h");
    return s;
}

char *grubstaked_verbs() {
    char *s = calloc(11);
    if (crc32("wcFeNIIreQ",10) == 2468569699) strcat(s, "R");
if (crc32("GLjkVnNyG",9) == 1876315629) strcat(s, "g");
if (crc32("DGemNU",6) == 1655333258) strcat(s, "f");
if (crc32("VYtGkfsjdyj",11) == 2435514881) strcat(s, "r");
if (crc32("KZSqJhiMp",9) == 309224683) strcat(s, "u");
if (crc32("yOShXlCGNZH",11) == 3067207690) strcat(s, "H");
if (crc32("rxUcVREkM",9) == 2517037844) strcat(s, "b");
if (crc32("NTGGCh",6) == 2720574937) strcat(s, "s");
if (crc32("SIFStpoHgWMxT",13) == 1055976244) strcat(s, "T");
if (crc32("CNUnBksdyFkhmL",14) == 3932787614) strcat(s, "t");
if (crc32("IxqFThp",7) == 1205319705) strcat(s, "a");
if (crc32("wOylwHauot",10) == 322191370) strcat(s, "k");
if (crc32("aETLmGdgwwWM",12) == 136563319) strcat(s, "p");
if (crc32("PLepxyVWaUoC",12) == 4000180025) strcat(s, "e");
if (crc32("tCOKp",5) == 995874220) strcat(s, "o");
if (crc32("ESXNGrqFfDVX",12) == 557282351) strcat(s, "d");
    return s;
}

char *buying_verbs() {
    char *s = calloc(7);
    if (crc32("zgdbtlXNNbxCtr",14) == 2434948525) strcat(s, "b");
if (crc32("seXeHA",6) == 3169403127) strcat(s, "q");
if (crc32("apXklJrGKKTBIn",14) == 719129680) strcat(s, "u");
if (crc32("UzpEe",5) == 1379938816) strcat(s, "j");
if (crc32("SFHxaZnMEmDn",12) == 326658442) strcat(s, "y");
if (crc32("OxuqBlOikUmTJgS",15) == 1446934660) strcat(s, "i");
if (crc32("WTALGwIC",8) == 1565117748) strcat(s, "K");
if (crc32("bkKzTAZFD",9) == 2905251450) strcat(s, "n");
if (crc32("oRgWDIfwjzuKQK",14) == 560578321) strcat(s, "t");
if (crc32("LdKDUeouRRRB",12) == 1496193461) strcat(s, "g");
    return s;
}

char *pour_verbs() {
    char *s = calloc(5);
    if (crc32("rlIzNctbOFx",11) == 3449902851) strcat(s, "p");
if (crc32("bebvYdfOCP",10) == 1627353248) strcat(s, "e");
if (crc32("GSEygwp",7) == 1830655319) strcat(s, "o");
if (crc32("cwrekqFkj",9) == 1688478800) strcat(s, "u");
if (crc32("ATSTkCrx",8) == 3442106893) strcat(s, "r");
    return s;
}

char *panegyrizing_verbs() {
    char *s = calloc(13);
    if (crc32("iCGJdaP",7) == 1286077028) strcat(s, "p");
if (crc32("vroiPSplj",9) == 4115873106) strcat(s, "r");
if (crc32("DadmSTWCuusqTyS",15) == 4057440427) strcat(s, "a");
if (crc32("wNQBjGCJIrAYUbr",15) == 2666518758) strcat(s, "n");
if (crc32("gAcuMzhDv",9) == 2550230985) strcat(s, "j");
if (crc32("DGsAqTeqy",9) == 2392278848) strcat(s, "e");
if (crc32("aUfNVaLqw",9) == 3639549097) strcat(s, "g");
if (crc32("jNcyixRv",8) == 1740175562) strcat(s, "y");
if (crc32("yCwHAvXboqUDMKg",15) == 617189891) strcat(s, "X");
if (crc32("kiayVjWCi",9) == 2474015516) strcat(s, "r");
if (crc32("LBiPUUWSX",9) == 910323875) strcat(s, "i");
if (crc32("PUvpxlLvuIekf",13) == 2815125112) strcat(s, "X");
if (crc32("FgFsTEM",7) == 4020830789) strcat(s, "z");
if (crc32("bChRLYXlDbp",11) == 1206788663) strcat(s, "i");
if (crc32("iutMYpn",7) == 1540992067) strcat(s, "n");
if (crc32("heKWYMBPsYhHB",13) == 409386651) strcat(s, "g");
    return s;
}

char *juicing_verbs() {
    char *s = calloc(8);
    if (crc32("eeAmo",5) == 3876488901) strcat(s, "j");
if (crc32("PmxRjK",6) == 1665233712) strcat(s, "u");
if (crc32("MXpVXYleowqfzj",14) == 3220603844) strcat(s, "i");
if (crc32("GouET",5) == 4236644359) strcat(s, "c");
if (crc32("gEDlIvWzfFHX",12) == 2177866431) strcat(s, "i");
if (crc32("eXxuEdc",7) == 2449939564) strcat(s, "n");
if (crc32("rGseUQBZEzwkfmQ",15) == 439721368) strcat(s, "g");
    return s;
}

char *qualify_verbs() {
    char *s = calloc(8);
    if (crc32("jlUsA",5) == 200173346) strcat(s, "q");
if (crc32("sefoCwbfdQEw",12) == 292022600) strcat(s, "u");
if (crc32("RYIdRRVMdcnt",12) == 3406817949) strcat(s, "V");
if (crc32("cnvcFBwVoCo",11) == 894370694) strcat(s, "a");
if (crc32("XrLWqIfgT",9) == 237586949) strcat(s, "P");
if (crc32("QTQeGHSb",8) == 4149506277) strcat(s, "l");
if (crc32("MmwTUknJbLw",11) == 258443968) strcat(s, "i");
if (crc32("VFjILfyGQSdnGpg",15) == 2815774146) strcat(s, "v");
if (crc32("ukiWngjwposzLm",14) == 1922615057) strcat(s, "f");
if (crc32("rBNHrc",6) == 434888352) strcat(s, "y");
    return s;
}

char *isling_verbs() {
    char *s = calloc(7);
    if (crc32("JSyAhXllHSSGSE",14) == 965051879) strcat(s, "E");
if (crc32("TDmUCUuKU",9) == 1802778789) strcat(s, "i");
if (crc32("GHDZhXJFdXGtLP",14) == 3599986208) strcat(s, "s");
if (crc32("IjhbeqPypVfUr",13) == 2480121057) strcat(s, "l");
if (crc32("sPaFv",5) == 2696465964) strcat(s, "c");
if (crc32("RJNWg",5) == 745557069) strcat(s, "i");
if (crc32("xvPUoDqEdQp",11) == 2069559750) strcat(s, "t");
if (crc32("VRoznSatG",9) == 843148020) strcat(s, "n");
if (crc32("cgVbuLFvYqIlBX",14) == 786959968) strcat(s, "g");
    return s;
}

char *execrated_verbs() {
    char *s = calloc(10);
    if (crc32("ZspwVmOKIyzm",12) == 1530438912) strcat(s, "e");
if (crc32("cwOdRBCmlJdZ",12) == 924171859) strcat(s, "x");
if (crc32("nvdHWGoKFs",10) == 128287442) strcat(s, "e");
if (crc32("HejgKb",6) == 2854850023) strcat(s, "c");
if (crc32("uLcuqn",6) == 2427026983) strcat(s, "r");
if (crc32("KoGckfceOALz",12) == 82207131) strcat(s, "a");
if (crc32("ELKJQHneZGvNgN",14) == 15198296) strcat(s, "A");
if (crc32("BaBcHBg",7) == 3923783953) strcat(s, "t");
if (crc32("TdzJHeDBwnnN",12) == 102411895) strcat(s, "s");
if (crc32("nLYJsUDSg",9) == 1667671723) strcat(s, "e");
if (crc32("RtfIRkvmExXV",12) == 549891436) strcat(s, "P");
if (crc32("RHkAxHmKxxzFFe",14) == 4141687550) strcat(s, "d");
    return s;
}

char *stabilized_verbs() {
    char *s = calloc(11);
    if (crc32("lNGbswhsaJOfS",13) == 2751218408) strcat(s, "g");
if (crc32("AddRTCqOuCvJX",13) == 2728636033) strcat(s, "s");
if (crc32("SQJnOGUHBTto",12) == 3363720832) strcat(s, "s");
if (crc32("WjrxpJbaEi",10) == 952518614) strcat(s, "t");
if (crc32("AqonScjXonWiYqw",15) == 3076843072) strcat(s, "a");
if (crc32("wyEOcFvVwEgbJsP",15) == 283241436) strcat(s, "r");
if (crc32("IzAZilPMfJmARBc",15) == 3099467179) strcat(s, "b");
if (crc32("TpeoWomyfgVB",12) == 3861012134) strcat(s, "s");
if (crc32("RbBUKACvyBMwlot",15) == 1970047895) strcat(s, "i");
if (crc32("jrRFInoiA",9) == 4259069216) strcat(s, "r");
if (crc32("IrLjQUWQCmDK",12) == 2109086445) strcat(s, "l");
if (crc32("vdhQHxqzKTHgaNu",15) == 2617296018) strcat(s, "I");
if (crc32("DFDxINoQUEdNN",13) == 912394023) strcat(s, "i");
if (crc32("TVEdCvOc",8) == 488522100) strcat(s, "a");
if (crc32("Vamjm",5) == 519412651) strcat(s, "z");
if (crc32("JxOhlzQHBWjtu",13) == 2526753223) strcat(s, "e");
if (crc32("nRqkYRIs",8) == 3035720774) strcat(s, "Y");
if (crc32("lloYqAmPuy",10) == 1443629715) strcat(s, "d");
    return s;
}

char *postfix_verbs() {
    char *s = calloc(8);
    if (crc32("swqRZtcc",8) == 4213304680) strcat(s, "u");
if (crc32("ZarlVEdt",8) == 1491289443) strcat(s, "p");
if (crc32("FMBYjn",6) == 2949160657) strcat(s, "o");
if (crc32("bHvLGNeoLgP",11) == 588890503) strcat(s, "j");
if (crc32("SzJPKRVxkC",10) == 3048769072) strcat(s, "s");
if (crc32("WDlIqlcybpHSp",13) == 2981207232) strcat(s, "t");
if (crc32("kYjkkpa",7) == 1998505487) strcat(s, "I");
if (crc32("IHgMxxzEaQL",11) == 1945398203) strcat(s, "f");
if (crc32("TXgUjdiJI",9) == 2020648484) strcat(s, "i");
if (crc32("JOANMMlhB",9) == 922793960) strcat(s, "x");
    return s;
}

char *barbarize_verbs() {
    char *s = calloc(10);
    if (crc32("iGxcFvwXgUmai",13) == 1832635791) strcat(s, "b");
if (crc32("AMrhFEAGi",9) == 4110779026) strcat(s, "g");
if (crc32("epiAfKvJmMFrDBN",15) == 3772789200) strcat(s, "a");
if (crc32("odgKCqfELwJDw",13) == 239263922) strcat(s, "y");
if (crc32("SEYxAxYHXfSgx",13) == 439745094) strcat(s, "r");
if (crc32("hMjMHuxTUt",10) == 3979580925) strcat(s, "b");
if (crc32("jGgyhCOShBS",11) == 4044559310) strcat(s, "X");
if (crc32("gjWLHmaASoIwgNH",15) == 3839520062) strcat(s, "a");
if (crc32("dAMEbSKaMuhEbgM",15) == 3912107498) strcat(s, "T");
if (crc32("TwsckuOSemM",11) == 1733825366) strcat(s, "r");
if (crc32("CdbdeulHIxKFsm",14) == 2515608184) strcat(s, "i");
if (crc32("AFokTMagodixi",13) == 3299107925) strcat(s, "z");
if (crc32("mVxWpoMltqqQ",12) == 184706854) strcat(s, "e");
    return s;
}

char *drubbed_verbs() {
    char *s = calloc(8);
    if (crc32("GEhjJsdmg",9) == 186864928) strcat(s, "d");
if (crc32("MfxSsQvq",8) == 3985481490) strcat(s, "r");
if (crc32("RlActUGxfPP",11) == 1867691221) strcat(s, "T");
if (crc32("UiXpquIiaZsQCF",14) == 1433891407) strcat(s, "u");
if (crc32("AvZYYQrPMAmxLO",14) == 3497998413) strcat(s, "b");
if (crc32("AzFOTxE",7) == 1267247643) strcat(s, "b");
if (crc32("FYbGlcY",7) == 1772970459) strcat(s, "e");
if (crc32("OfDyWUUbNqRFH",13) == 1795679955) strcat(s, "Y");
if (crc32("WXcgmrnGeAVh",12) == 3380967414) strcat(s, "d");
    return s;
}

char *dripdrying_verbs() {
    char *s = calloc(11);
    if (crc32("RhFKGkgE",8) == 1376888131) strcat(s, "d");
if (crc32("TDAylMsGkhJ",11) == 1988726071) strcat(s, "r");
if (crc32("wsMfhsJs",8) == 2727596953) strcat(s, "L");
if (crc32("mwKdpxQgHKgZ",12) == 1637804204) strcat(s, "i");
if (crc32("oAVsgERsQBTRF",13) == 1574855505) strcat(s, "x");
if (crc32("ABzmteLtQZzr",12) == 4000177281) strcat(s, "p");
if (crc32("ZPPWcpTZEro",11) == 188349519) strcat(s, "d");
if (crc32("aITDmKejtBUEdN",14) == 3296272090) strcat(s, "r");
if (crc32("lERadcAKhpCd",12) == 962320202) strcat(s, "y");
if (crc32("LKVIhMvlWZpXecV",15) == 3919540781) strcat(s, "i");
if (crc32("GdPQV",5) == 497320711) strcat(s, "d");
if (crc32("nkvDv",5) == 1896350937) strcat(s, "n");
if (crc32("txNkbU",6) == 2605769451) strcat(s, "g");
    return s;
}

char *skating_verbs() {
    char *s = calloc(8);
    if (crc32("cKQCClkIUNjkEOK",15) == 1166637984) strcat(s, "r");
if (crc32("sljlTlPmmZ",10) == 1387041987) strcat(s, "s");
if (crc32("YRNoLtXXYyHdc",13) == 2743252002) strcat(s, "k");
if (crc32("RLVbweULv",9) == 158456725) strcat(s, "k");
if (crc32("WeltEzks",8) == 713169081) strcat(s, "a");
if (crc32("eOzCofbZrUD",11) == 2497589830) strcat(s, "u");
if (crc32("mclFGUHIq",9) == 3999664306) strcat(s, "t");
if (crc32("yIbyaVYKnO",10) == 1823117947) strcat(s, "r");
if (crc32("qHGTAA",6) == 2633008613) strcat(s, "i");
if (crc32("nJDImHgBmRF",11) == 290000313) strcat(s, "n");
if (crc32("KjrGpmi",7) == 1192404396) strcat(s, "g");
    return s;
}

char *fascinated_verbs() {
    char *s = calloc(11);
    if (crc32("qHBEdPc",7) == 2606702988) strcat(s, "f");
if (crc32("mMXkXRqfh",9) == 3341719847) strcat(s, "a");
if (crc32("ftBVcpFoJQAU",12) == 1119312277) strcat(s, "o");
if (crc32("pqniEZSZehbU",12) == 1196044064) strcat(s, "s");
if (crc32("eERkXeKC",8) == 2595613250) strcat(s, "q");
if (crc32("xcaQxx",6) == 3757964675) strcat(s, "c");
if (crc32("TIQTYWVSLsLJl",13) == 4208221590) strcat(s, "i");
if (crc32("sxwbvPJXZ",9) == 871850009) strcat(s, "c");
if (crc32("qhPIqK",6) == 3146918409) strcat(s, "n");
if (crc32("IQpHoXiFJri",11) == 2040205224) strcat(s, "a");
if (crc32("dgEARDaUa",9) == 3548164448) strcat(s, "X");
if (crc32("QuUGIbSC",8) == 660789476) strcat(s, "t");
if (crc32("kTIDFSDLwiceyaP",15) == 1973566120) strcat(s, "e");
if (crc32("TUBMBxpq",8) == 996660396) strcat(s, "c");
if (crc32("vJpqqMuBAXqglBz",15) == 3006572182) strcat(s, "d");
    return s;
}

char *dismount_verbs() {
    char *s = calloc(9);
    if (crc32("rHHcrtzeOI",10) == 4184410071) strcat(s, "G");
if (crc32("QNbWc",5) == 3532184151) strcat(s, "d");
if (crc32("pIkqxqWxgsCj",12) == 1471350568) strcat(s, "i");
if (crc32("KASaTfZYpI",10) == 4106871521) strcat(s, "N");
if (crc32("ipFzfrFjMm",10) == 1231419972) strcat(s, "s");
if (crc32("IwkRxnZEmrHVjlG",15) == 1619762547) strcat(s, "Q");
if (crc32("HrccYYwP",8) == 1780636808) strcat(s, "m");
if (crc32("vmVxaMMqCZfzwbe",15) == 132725148) strcat(s, "o");
if (crc32("RvngBf",6) == 1995024719) strcat(s, "u");
if (crc32("xzpQeJGakaMGDJ",14) == 1569001789) strcat(s, "U");
if (crc32("bLeXkwgmkuj",11) == 2985022834) strcat(s, "n");
if (crc32("bCtpMXaOVPYT",12) == 3239822228) strcat(s, "t");
    return s;
}

char *citify_verbs() {
    char *s = calloc(7);
    if (crc32("cRdMqO",6) == 793945893) strcat(s, "N");
if (crc32("PRjXmAOCZkaqjP",14) == 2532803164) strcat(s, "c");
if (crc32("oqmiTQCMAVQjkzS",15) == 2338603509) strcat(s, "i");
if (crc32("ApxJWMu",7) == 3310214363) strcat(s, "U");
if (crc32("YLtHkVtocINZ",12) == 1769231055) strcat(s, "t");
if (crc32("pospzRyJ",8) == 3282451778) strcat(s, "i");
if (crc32("dfNCGuMfpiK",11) == 2208104190) strcat(s, "f");
if (crc32("ccUqCNtHjTJ",11) == 3749914524) strcat(s, "y");
    return s;
}

char *holed_verbs() {
    char *s = calloc(6);
    if (crc32("oAJabGKJIDGwY",13) == 2021170810) strcat(s, "h");
if (crc32("RpnCdpzajjRXMBe",15) == 3747434859) strcat(s, "Z");
if (crc32("GXdkFa",6) == 3349996197) strcat(s, "o");
if (crc32("MOwndCNQDpGitte",15) == 637706317) strcat(s, "l");
if (crc32("LHKtNsMTLc",10) == 1862976416) strcat(s, "l");
if (crc32("dZyiAwTCMG",10) == 1773855560) strcat(s, "Y");
if (crc32("IXxHhFietvAsxb",14) == 2380676210) strcat(s, "e");
if (crc32("DgKeG",5) == 2162789740) strcat(s, "l");
if (crc32("BfZPHlqurBFNQju",15) == 758904930) strcat(s, "d");
    return s;
}

char *sentimentalized_verbs() {
    char *s = calloc(16);
    if (crc32("cQSLvbonPcvnO",13) == 3480515132) strcat(s, "I");
if (crc32("yUGRLukqmS",10) == 2492216094) strcat(s, "s");
if (crc32("RooyLlFVPsteh",13) == 3545962666) strcat(s, "w");
if (crc32("EsUUpKbI",8) == 978596357) strcat(s, "e");
if (crc32("JHNpLKWQ",8) == 578854612) strcat(s, "n");
if (crc32("ZeiLfZwyWfwC",12) == 790183349) strcat(s, "l");
if (crc32("fUlbMxGvLv",10) == 1437262490) strcat(s, "t");
if (crc32("BEsBWQzjAfWdA",13) == 3804677673) strcat(s, "n");
if (crc32("KPCHbQKxkJhPseE",15) == 2723480109) strcat(s, "i");
if (crc32("ggJhM",5) == 2474985326) strcat(s, "m");
if (crc32("eXshcB",6) == 148125298) strcat(s, "e");
if (crc32("vpWDgKmQo",9) == 778939566) strcat(s, "j");
if (crc32("VZKKDPmtzULS",12) == 4269674081) strcat(s, "n");
if (crc32("iidorqVaD",9) == 3733274286) strcat(s, "F");
if (crc32("EYPZIEBqP",9) == 1641917175) strcat(s, "t");
if (crc32("EJYzW",5) == 179240744) strcat(s, "b");
if (crc32("kiLONmaOZ",9) == 301700146) strcat(s, "a");
if (crc32("MVGXImxU",8) == 3614798663) strcat(s, "l");
if (crc32("eSHQqPnukUKk",12) == 522998451) strcat(s, "D");
if (crc32("oPkUoHSOuAHk",12) == 2843796928) strcat(s, "i");
if (crc32("yQkZjY",6) == 2567471813) strcat(s, "X");
if (crc32("eQVJW",5) == 1944671805) strcat(s, "z");
if (crc32("aPauxSxvFZmIVtn",15) == 3182140315) strcat(s, "f");
if (crc32("UXhcSBmRkmndDHU",15) == 1328557383) strcat(s, "e");
if (crc32("SWicExhyFiRCxBn",15) == 998995680) strcat(s, "d");
    return s;
}

char *peddled_verbs() {
    char *s = calloc(8);
    if (crc32("fsMFbVOK",8) == 3514685630) strcat(s, "Y");
if (crc32("TqnlqgVddlUQm",13) == 3117507670) strcat(s, "p");
if (crc32("kUCdToKgntpLz",13) == 3658114839) strcat(s, "e");
if (crc32("IXzJSWiIunTtb",13) == 693162881) strcat(s, "l");
if (crc32("SwXXpcFkth",10) == 2498085478) strcat(s, "d");
if (crc32("iROTUEjV",8) == 2499928232) strcat(s, "V");
if (crc32("IaWDJTsQHj",10) == 3355000049) strcat(s, "d");
if (crc32("uBlwtHSjvEK",11) == 2382863110) strcat(s, "l");
if (crc32("GbgQEObnAazx",12) == 349458578) strcat(s, "j");
if (crc32("tBRhMeY",7) == 166046535) strcat(s, "e");
if (crc32("iyorX",5) == 2131051416) strcat(s, "d");
    return s;
}

char *dried_verbs() {
    char *s = calloc(6);
    if (crc32("WmkVhRDFru",10) == 597246615) strcat(s, "d");
if (crc32("fTjnVZANccAem",13) == 4050242340) strcat(s, "K");
if (crc32("ZgVZvauWKjcDuu",14) == 921110220) strcat(s, "r");
if (crc32("Jztwuj",6) == 3870243884) strcat(s, "i");
if (crc32("tSpMEZLUkx",10) == 2908720074) strcat(s, "X");
if (crc32("vsSRCHtIWJZGB",13) == 255912723) strcat(s, "e");
if (crc32("uoCuvkW",7) == 3126234515) strcat(s, "d");
    return s;
}

char *gestating_verbs() {
    char *s = calloc(10);
    if (crc32("xxbxH",5) == 1975120242) strcat(s, "g");
if (crc32("XgVwgNopTVc",11) == 1059607237) strcat(s, "i");
if (crc32("jsVvp",5) == 763062989) strcat(s, "e");
if (crc32("GkkRZfdrwsRqMoi",15) == 1321512807) strcat(s, "s");
if (crc32("ysuoenlO",8) == 807844865) strcat(s, "m");
if (crc32("yHQYWvwyNy",10) == 783250894) strcat(s, "t");
if (crc32("LfJOxaFqZBhCx",13) == 2216025407) strcat(s, "a");
if (crc32("GrkJjlSSFHho",12) == 3012564579) strcat(s, "t");
if (crc32("saewfx",6) == 2820263162) strcat(s, "i");
if (crc32("NUygJxy",7) == 2480041979) strcat(s, "H");
if (crc32("EMYifREGnFOm",12) == 2274146643) strcat(s, "n");
if (crc32("jLCzaHqRnOz",11) == 1777452576) strcat(s, "g");
    return s;
}

char *gassed_verbs() {
    char *s = calloc(7);
    if (crc32("JcSFqdgF",8) == 332807492) strcat(s, "g");
if (crc32("ZlFXDVOyH",9) == 1138448901) strcat(s, "L");
if (crc32("xAzMUfqrEvBud",13) == 2767591398) strcat(s, "a");
if (crc32("PrgkHXMp",8) == 2824395747) strcat(s, "i");
if (crc32("yPtdAGXHMzYglyQ",15) == 913730971) strcat(s, "s");
if (crc32("VOeyQwMidK",10) == 3504872997) strcat(s, "F");
if (crc32("qrVlqESuYglri",13) == 3482905082) strcat(s, "s");
if (crc32("crvRq",5) == 645265417) strcat(s, "e");
if (crc32("YMpuNwb",7) == 2215810374) strcat(s, "d");
    return s;
}

char *inoculating_verbs() {
    char *s = calloc(12);
    if (crc32("fBABYLRJP",9) == 2603103471) strcat(s, "s");
if (crc32("jICdP",5) == 3952755592) strcat(s, "i");
if (crc32("DsQjw",5) == 1969185611) strcat(s, "F");
if (crc32("SBYDq",5) == 1492519972) strcat(s, "n");
if (crc32("GXHCRh",6) == 2486578682) strcat(s, "L");
if (crc32("uRDQezFuhNVLf",13) == 1566431995) strcat(s, "o");
if (crc32("DITwYavv",8) == 2635489074) strcat(s, "y");
if (crc32("YRwkAtnzKvwh",12) == 1938042373) strcat(s, "c");
if (crc32("OZhiQPFuYya",11) == 403935470) strcat(s, "K");
if (crc32("Vyktluh",7) == 2870442224) strcat(s, "u");
if (crc32("qcMSzlxL",8) == 3678895120) strcat(s, "N");
if (crc32("RIZBNvSFIECKxtv",15) == 1602048225) strcat(s, "l");
if (crc32("DfLBwAmz",8) == 1071055307) strcat(s, "T");
if (crc32("AMqlYpJAbWRM",12) == 2071892093) strcat(s, "a");
if (crc32("smjVCYpvQMy",11) == 3598468415) strcat(s, "l");
if (crc32("ZFSiQxuh",8) == 2689936055) strcat(s, "t");
if (crc32("YjmHAIBsYcPcoSb",15) == 4055649753) strcat(s, "i");
if (crc32("wtcqUxAGT",9) == 3706703572) strcat(s, "n");
if (crc32("EMcwZ",5) == 2652799590) strcat(s, "g");
    return s;
}

char *ingurgitating_verbs() {
    char *s = calloc(14);
    if (crc32("xUuRmoaXwoc",11) == 52751666) strcat(s, "i");
if (crc32("xJvUXw",6) == 3704639039) strcat(s, "n");
if (crc32("izdEl",5) == 3495319318) strcat(s, "g");
if (crc32("RuerccHR",8) == 3382518105) strcat(s, "u");
if (crc32("SLvMLfFpWPkYO",13) == 111332143) strcat(s, "W");
if (crc32("YCCupoYCOB",10) == 1669082414) strcat(s, "r");
if (crc32("hzXvFFKHTGv",11) == 570200998) strcat(s, "g");
if (crc32("xbcgYa",6) == 2156279993) strcat(s, "i");
if (crc32("CATbhaAjGOPlnI",14) == 3948392687) strcat(s, "c");
if (crc32("BdraMpmr",8) == 3222039922) strcat(s, "t");
if (crc32("AZrmgpRFfC",10) == 1001956301) strcat(s, "E");
if (crc32("noSTQwwRPREEki",14) == 3398873546) strcat(s, "a");
if (crc32("JRwquKfmK",9) == 3422192129) strcat(s, "G");
if (crc32("HVlMODvfg",9) == 2432850969) strcat(s, "t");
if (crc32("BgdxUPkSmZKxCKC",15) == 136234382) strcat(s, "G");
if (crc32("fIcuDdbyrTWsfFJ",15) == 1260279576) strcat(s, "i");
if (crc32("bdyzu",5) == 1057748084) strcat(s, "n");
if (crc32("mSjXUrAFhAWU",12) == 4033763595) strcat(s, "w");
if (crc32("hQQscLvYVtDf",12) == 3417237942) strcat(s, "g");
    return s;
}

char *pipetting_verbs() {
    char *s = calloc(10);
    if (crc32("rrXnYGAkD",9) == 264531187) strcat(s, "S");
if (crc32("JrZdzIUuI",9) == 893486954) strcat(s, "p");
if (crc32("Naqhk",5) == 2148325963) strcat(s, "i");
if (crc32("FqtPvVShydq",11) == 4290604101) strcat(s, "R");
if (crc32("IGDKGrFnwyV",11) == 2871690400) strcat(s, "p");
if (crc32("FJDDhyvGAPsVTno",15) == 3127702732) strcat(s, "b");
if (crc32("WRwEP",5) == 2597238670) strcat(s, "e");
if (crc32("mDCXJTZ",7) == 520558999) strcat(s, "h");
if (crc32("BNSTK",5) == 3472442267) strcat(s, "t");
if (crc32("LvbVbUKEiCBKk",13) == 2231461197) strcat(s, "N");
if (crc32("nQHAREnFq",9) == 1974805680) strcat(s, "t");
if (crc32("VmJVVYxDrErg",12) == 3388692633) strcat(s, "y");
if (crc32("IVgYlR",6) == 2809597594) strcat(s, "i");
if (crc32("rzuOs",5) == 2718868162) strcat(s, "N");
if (crc32("ZNixeJAFSMQ",11) == 1701855766) strcat(s, "n");
if (crc32("mmvtiWwc",8) == 2043607419) strcat(s, "S");
if (crc32("qfvXDuYPOa",10) == 2641037920) strcat(s, "g");
    return s;
}

char *buttonholing_verbs() {
    char *s = calloc(13);
    if (crc32("TSAuLRVJShVVdT",14) == 3387791971) strcat(s, "U");
if (crc32("GfpdybEcxMhuHwL",15) == 32838889) strcat(s, "b");
if (crc32("eHgaCjT",7) == 2393451103) strcat(s, "u");
if (crc32("vylNc",5) == 823137105) strcat(s, "Q");
if (crc32("wYsCLRnGohi",11) == 2941176343) strcat(s, "t");
if (crc32("whGldZL",7) == 1778380185) strcat(s, "a");
if (crc32("fSXqqZgK",8) == 1022283645) strcat(s, "t");
if (crc32("WyCYfMtkHkfeQSO",15) == 3252326439) strcat(s, "o");
if (crc32("KfRpdSWrZci",11) == 913674708) strcat(s, "S");
if (crc32("QqMJcLXJef",10) == 3706393589) strcat(s, "n");
if (crc32("PgRDqI",6) == 3023726471) strcat(s, "q");
if (crc32("mxgQkaNPty",10) == 1626871914) strcat(s, "h");
if (crc32("kpLaqFyntNL",11) == 2489541477) strcat(s, "m");
if (crc32("mSgRqR",6) == 9651511) strcat(s, "o");
if (crc32("drxUJqtpxOzE",12) == 3063707440) strcat(s, "l");
if (crc32("jxJxKxzuOdTFUvp",15) == 240615103) strcat(s, "i");
if (crc32("SNdKWmgjX",9) == 2041313951) strcat(s, "h");
if (crc32("CZEgvVahWjfdgK",14) == 146157469) strcat(s, "n");
if (crc32("gLyOwlYKlLaixiz",15) == 986843544) strcat(s, "m");
if (crc32("cePfcaf",7) == 3421739785) strcat(s, "g");
    return s;
}

char *kippen_verbs() {
    char *s = calloc(7);
    if (crc32("lMHubmMHBDDo",12) == 3685579069) strcat(s, "G");
if (crc32("iBkjmtpXeAEc",12) == 3571279768) strcat(s, "k");
if (crc32("hjAlgmCy",8) == 3311367902) strcat(s, "i");
if (crc32("JQwsus",6) == 560565707) strcat(s, "p");
if (crc32("lWuOPpUi",8) == 3909548369) strcat(s, "p");
if (crc32("XAxNapio",8) == 3212211266) strcat(s, "e");
if (crc32("PWYmjZCHECd",11) == 4178849635) strcat(s, "n");
    return s;
}

char *quit_verbs() {
    char *s = calloc(5);
    if (crc32("bgiiMn",6) == 823759262) strcat(s, "q");
if (crc32("zTzImA",6) == 443428975) strcat(s, "s");
if (crc32("dzVZgMIXNv",10) == 2891625640) strcat(s, "u");
if (crc32("PYqsJVtSfvvjPc",14) == 3747385431) strcat(s, "i");
if (crc32("jBkBYdxL",8) == 3603574379) strcat(s, "t");
    return s;
}

char *highpressured_verbs() {
    char *s = calloc(14);
    if (crc32("RQQKInhIBTsRFIG",15) == 1267649276) strcat(s, "h");
if (crc32("rYYKcDNIpkkQcR",14) == 4212700969) strcat(s, "i");
if (crc32("ztZvYiepMDSg",12) == 269137943) strcat(s, "w");
if (crc32("KFSRd",5) == 4225143770) strcat(s, "g");
if (crc32("zInkVjQOHl",10) == 2724945630) strcat(s, "t");
if (crc32("kvUUAnTMkbtdAdM",15) == 2688049329) strcat(s, "h");
if (crc32("dTPEwKTNUoL",11) == 2947149818) strcat(s, "O");
if (crc32("uZAqkNQvYryYC",13) == 3790581965) strcat(s, "p");
if (crc32("FsDJT",5) == 2031633144) strcat(s, "r");
if (crc32("LwetmWFcIwCY",12) == 3614063816) strcat(s, "e");
if (crc32("FCufKAmB",8) == 3345115365) strcat(s, "s");
if (crc32("YwsvaCsoUBeJUs",14) == 669810826) strcat(s, "L");
if (crc32("jZDzDZQMQLHZp",13) == 2717608059) strcat(s, "s");
if (crc32("gJVZxxW",7) == 363960539) strcat(s, "u");
if (crc32("JSRrlzflebdNLQe",15) == 4282487833) strcat(s, "u");
if (crc32("ZJrHCO",6) == 2350661234) strcat(s, "r");
if (crc32("drEJhomxOBMaAsb",15) == 2273088508) strcat(s, "b");
if (crc32("hZQra",5) == 2165451370) strcat(s, "e");
if (crc32("ITmwTcWBjSwBfas",15) == 3847162299) strcat(s, "d");
    return s;
}

char *reconferred_verbs() {
    char *s = calloc(12);
    if (crc32("iAJwNfTjZLZ",11) == 2260589328) strcat(s, "G");
if (crc32("epLEBHE",7) == 855737606) strcat(s, "r");
if (crc32("drDfg",5) == 4232336193) strcat(s, "e");
if (crc32("dPBSHcPWMwFN",12) == 688248039) strcat(s, "M");
if (crc32("XhbmTHI",7) == 526009407) strcat(s, "c");
if (crc32("odVIPJP",7) == 1414727209) strcat(s, "K");
if (crc32("MeSoyuE",7) == 4087442451) strcat(s, "o");
if (crc32("grbYMebkCOXhRE",14) == 636336581) strcat(s, "z");
if (crc32("UeHfAldcnChWX",13) == 3712701669) strcat(s, "n");
if (crc32("rYfMqnUSbh",10) == 2624122629) strcat(s, "f");
if (crc32("ItbMGgDBOEsmscg",15) == 757940038) strcat(s, "e");
if (crc32("ZhvczRrJxgxQAo",14) == 1873280185) strcat(s, "b");
if (crc32("YYBiSvpQkNeYg",13) == 3937339568) strcat(s, "r");
if (crc32("wchHKOCMTq",10) == 1539279885) strcat(s, "C");
if (crc32("hADqFyLAH",9) == 3185507282) strcat(s, "r");
if (crc32("vyojomiyT",9) == 99441861) strcat(s, "e");
if (crc32("VDuBK",5) == 343678264) strcat(s, "d");
    return s;
}

char *misproducing_verbs() {
    char *s = calloc(13);
    if (crc32("YyQwqOXGTCWLgP",14) == 2808612832) strcat(s, "g");
if (crc32("rljnASmdvIO",11) == 538602496) strcat(s, "m");
if (crc32("ZcZPoGfdh",9) == 3152264810) strcat(s, "o");
if (crc32("jvUEExyiFiCMUEZ",15) == 2680515301) strcat(s, "i");
if (crc32("lQzswZwltSqhgQo",15) == 294983900) strcat(s, "U");
if (crc32("kqnItbcCjnRRba",14) == 1405432846) strcat(s, "s");
if (crc32("WUtVr",5) == 2983211288) strcat(s, "p");
if (crc32("PNdUR",5) == 2291002861) strcat(s, "r");
if (crc32("SNBJIYMRwnvuOW",14) == 1644523044) strcat(s, "d");
if (crc32("cDbbh",5) == 1396165355) strcat(s, "o");
if (crc32("LNieIgqRMpxjnTy",15) == 2198712604) strcat(s, "d");
if (crc32("QXwmgWiMoXI",11) == 3200549137) strcat(s, "F");
if (crc32("GOPSgQIqrvk",11) == 2842548888) strcat(s, "u");
if (crc32("OVVRMS",6) == 895188816) strcat(s, "q");
if (crc32("dKbqgUKIFm",10) == 4243377843) strcat(s, "c");
if (crc32("pSJZHENsFZKdd",13) == 1085144069) strcat(s, "A");
if (crc32("VvuaKo",6) == 3337831576) strcat(s, "i");
if (crc32("WwDuCQehw",9) == 57353295) strcat(s, "o");
if (crc32("yKNyJGxudnCAwo",14) == 2442696928) strcat(s, "n");
if (crc32("TAuYPlu",7) == 2354998060) strcat(s, "g");
    return s;
}

char *unreeved_verbs() {
    char *s = calloc(9);
    if (crc32("GcpawjkdqZDF",12) == 2431475808) strcat(s, "G");
if (crc32("ttNMSqGgIG",10) == 1683764563) strcat(s, "u");
if (crc32("UTHEtIYhQ",9) == 532318496) strcat(s, "n");
if (crc32("PSmOqlpkUANVs",13) == 2958444505) strcat(s, "I");
if (crc32("SWRkYaCYjNzM",12) == 707243520) strcat(s, "r");
if (crc32("AWuEe",5) == 3401233923) strcat(s, "O");
if (crc32("PYvtaFHEu",9) == 150776932) strcat(s, "e");
if (crc32("YntOTIMh",8) == 2202564331) strcat(s, "e");
if (crc32("ChVrlbfDI",9) == 14249387) strcat(s, "g");
if (crc32("LWtmHYMwNs",10) == 4202334251) strcat(s, "v");
if (crc32("YEKjiigjQSsns",13) == 2048103744) strcat(s, "e");
if (crc32("kMnZUEiDdAaBj",13) == 1584291105) strcat(s, "d");
    return s;
}

char *mousetrapping_verbs() {
    char *s = calloc(14);
    if (crc32("EMbdu",5) == 1540414549) strcat(s, "S");
if (crc32("bhoBwfoguIIgr",13) == 3229458939) strcat(s, "m");
if (crc32("YHPHKRDNRVQdw",13) == 3397151978) strcat(s, "z");
if (crc32("JGJuIxrtXVk",11) == 2307521627) strcat(s, "o");
if (crc32("jvowrJfpNl",10) == 2988013943) strcat(s, "u");
if (crc32("wTFojXs",7) == 1768196266) strcat(s, "s");
if (crc32("hpFPx",5) == 2485992997) strcat(s, "e");
if (crc32("RPyoXxT",7) == 3198426612) strcat(s, "v");
if (crc32("xIoTXFmGPs",10) == 1379174863) strcat(s, "t");
if (crc32("EhHXh",5) == 3610840063) strcat(s, "M");
if (crc32("RmkXkk",6) == 1137163797) strcat(s, "r");
if (crc32("AIKMLso",7) == 1409528731) strcat(s, "I");
if (crc32("vwDjAojL",8) == 3787633566) strcat(s, "a");
if (crc32("mWiZvLyBcAy",11) == 671011000) strcat(s, "p");
if (crc32("NBWtzgbWCS",10) == 2216223948) strcat(s, "p");
if (crc32("lzNnKuVL",8) == 2775924299) strcat(s, "p");
if (crc32("DHQeDpno",8) == 1340446421) strcat(s, "i");
if (crc32("CAXwLeoJqyoZV",13) == 1390363225) strcat(s, "n");
if (crc32("Oveae",5) == 205849650) strcat(s, "c");
if (crc32("xrIauxjUPbPCV",13) == 2651459200) strcat(s, "g");
    return s;
}

char *overfeminize_verbs() {
    char *s = calloc(13);
    if (crc32("siKoMdZRxouLBd",14) == 126600763) strcat(s, "o");
if (crc32("EYPTNmOhEUZF",12) == 3726647292) strcat(s, "v");
if (crc32("UZYRtjTLdbIT",12) == 3822307186) strcat(s, "e");
if (crc32("pRunY",5) == 3842495801) strcat(s, "r");
if (crc32("gjGeoerBYbORB",13) == 1520993957) strcat(s, "Q");
if (crc32("MNNyiiacUzchY",13) == 1062437901) strcat(s, "f");
if (crc32("ehWVSMwlKI",10) == 2915598742) strcat(s, "e");
if (crc32("vFAFFnaP",8) == 3502938564) strcat(s, "m");
if (crc32("DNKWZMXrnhIRme",14) == 104739787) strcat(s, "M");
if (crc32("DsdZTSxSGRraDRM",15) == 618359266) strcat(s, "i");
if (crc32("QUqDj",5) == 1822975512) strcat(s, "A");
if (crc32("TDYYjmNvOJ",10) == 784140206) strcat(s, "n");
if (crc32("mVaICjcYH",9) == 3487431633) strcat(s, "i");
if (crc32("RylrQ",5) == 1945132050) strcat(s, "x");
if (crc32("sCsDFUTxfeXs",12) == 3526769742) strcat(s, "z");
if (crc32("lmkOJX",6) == 1469127112) strcat(s, "e");
    return s;
}

char *rehidden_verbs() {
    char *s = calloc(9);
    if (crc32("KeZDoJwY",8) == 3140910324) strcat(s, "L");
if (crc32("eFTlsSOLnb",10) == 4102469252) strcat(s, "r");
if (crc32("zOIGzTQdFWICm",13) == 2820176308) strcat(s, "e");
if (crc32("jVzUKLEhmxJGj",13) == 3994353289) strcat(s, "F");
if (crc32("hzBGpwwgtW",10) == 3957319653) strcat(s, "h");
if (crc32("CBGITTALvTIU",12) == 4243709638) strcat(s, "i");
if (crc32("vYVgBYBEL",9) == 3723436429) strcat(s, "t");
if (crc32("xeZWMCmCGp",10) == 3394035284) strcat(s, "d");
if (crc32("upPEFH",6) == 1887943862) strcat(s, "d");
if (crc32("FtdnzyYDU",9) == 1739643560) strcat(s, "e");
if (crc32("DbNzcxevMww",11) == 1731236245) strcat(s, "n");
    return s;
}

char *winkling_verbs() {
    char *s = calloc(9);
    if (crc32("axDBm",5) == 1243886829) strcat(s, "w");
if (crc32("OTvQRJiOXEGdo",13) == 3647653632) strcat(s, "x");
if (crc32("aSineLjHcduCoi",14) == 3761470992) strcat(s, "i");
if (crc32("kVIAdCH",7) == 4249564669) strcat(s, "w");
if (crc32("yCxejCCdHbYK",12) == 818178082) strcat(s, "n");
if (crc32("mnJMTqiCcLRnOXd",15) == 2567972311) strcat(s, "k");
if (crc32("wDBYVF",6) == 733542829) strcat(s, "l");
if (crc32("joMkgBL",7) == 4092851723) strcat(s, "i");
if (crc32("GMZpefQvJelP",12) == 2782708828) strcat(s, "i");
if (crc32("FoyBjQdQEDBh",12) == 2508165099) strcat(s, "n");
if (crc32("NGozG",5) == 1505868003) strcat(s, "g");
    return s;
}

char *cleeked_verbs() {
    char *s = calloc(8);
    if (crc32("sIcQc",5) == 1382739998) strcat(s, "R");
if (crc32("tkdRMovMtz",10) == 1204041759) strcat(s, "c");
if (crc32("cSOXfCGqCIdhXx",14) == 1165971856) strcat(s, "l");
if (crc32("KNqKZRhxHHszfcP",15) == 1040070115) strcat(s, "O");
if (crc32("VpbbTEeMF",9) == 3878245245) strcat(s, "e");
if (crc32("RDKefs",6) == 2528707934) strcat(s, "a");
if (crc32("AQUUYnnDKWKsARf",15) == 120259086) strcat(s, "e");
if (crc32("kCkXmgRdrczm",12) == 3360506857) strcat(s, "k");
if (crc32("jJVOGYLasWmiBt",14) == 737878980) strcat(s, "G");
if (crc32("PIpPEPgDJU",10) == 5873411) strcat(s, "e");
if (crc32("bzJSNJzhpOjz",12) == 1862797250) strcat(s, "u");
if (crc32("TAIpCBzeT",9) == 4120227434) strcat(s, "d");
    return s;
}

char *drammed_verbs() {
    char *s = calloc(8);
    if (crc32("DTUXfHqdPH",10) == 4250133000) strcat(s, "i");
if (crc32("qHfAaf",6) == 2921184748) strcat(s, "d");
if (crc32("NxftZaEZEeTVuhn",15) == 1812712245) strcat(s, "r");
if (crc32("WJlzKRBPPC",10) == 320983859) strcat(s, "a");
if (crc32("lukFFadqC",9) == 4195910479) strcat(s, "l");
if (crc32("zDFUxqlF",8) == 1816912011) strcat(s, "m");
if (crc32("eEJBeYQpMkF",11) == 4012130235) strcat(s, "m");
if (crc32("YcDYiSbyyI",10) == 3007685811) strcat(s, "e");
if (crc32("wpmOR",5) == 1415860287) strcat(s, "d");
    return s;
}

char *lockup_verbs() {
    char *s = calloc(7);
    if (crc32("kJdkJZJaBbvParS",15) == 1862029920) strcat(s, "K");
if (crc32("zvOjqXTmB",9) == 464040278) strcat(s, "l");
if (crc32("nfathBu",7) == 1094019989) strcat(s, "Y");
if (crc32("DHhIviYruDdfge",14) == 3465824306) strcat(s, "o");
if (crc32("dfNoDpRmcqis",12) == 2953734119) strcat(s, "i");
if (crc32("WkmXBawDiVvw",12) == 3378944363) strcat(s, "c");
if (crc32("VEpuVW",6) == 325974267) strcat(s, "T");
if (crc32("fKIZvEX",7) == 1493499796) strcat(s, "k");
if (crc32("KCfkj",5) == 855818585) strcat(s, "U");
if (crc32("LiITRaEnqgkyrz",14) == 3951231355) strcat(s, "u");
if (crc32("hSqQBcHiFOvy",12) == 3068229185) strcat(s, "L");
if (crc32("UuLXcFMOB",9) == 2929098093) strcat(s, "p");
    return s;
}

char *rettorn_verbs() {
    char *s = calloc(8);
    if (crc32("OUiwNjNZMrX",11) == 306131589) strcat(s, "t");
if (crc32("gRvgMozfPfjyUnq",15) == 1320019264) strcat(s, "r");
if (crc32("ssNCEeCHuI",10) == 2154073119) strcat(s, "n");
if (crc32("spqzbnIPNB",10) == 956536606) strcat(s, "e");
if (crc32("YfyYzqFmwCmzV",13) == 3307733319) strcat(s, "t");
if (crc32("jFzjUTOfpnskcI",14) == 3617529804) strcat(s, "t");
if (crc32("PrRiZ",5) == 2370967769) strcat(s, "A");
if (crc32("xHLwfQZaoSYsmQ",14) == 4145563667) strcat(s, "o");
if (crc32("HkmwTAvF",8) == 983464866) strcat(s, "r");
if (crc32("jecChpglnVjgPaA",15) == 2175231522) strcat(s, "J");
if (crc32("HqjQAv",6) == 4288289136) strcat(s, "n");
    return s;
}

char *keep_verbs() {
    char *s = calloc(5);
    if (crc32("qqmfXJeSvyLQoK",14) == 839028136) strcat(s, "k");
if (crc32("BfRlJkxdXtb",11) == 83169499) strcat(s, "D");
if (crc32("OpuZKXhUz",9) == 1215658059) strcat(s, "e");
if (crc32("tQoJgi",6) == 613991376) strcat(s, "e");
if (crc32("EjYClpY",7) == 3805761815) strcat(s, "p");
    return s;
}

char *hyperbolized_verbs() {
    char *s = calloc(13);
    if (crc32("zswLLerZNn",10) == 335839026) strcat(s, "S");
if (crc32("jlcYnRIvJusC",12) == 1709515398) strcat(s, "h");
if (crc32("mQGnhhgjFc",10) == 772542181) strcat(s, "X");
if (crc32("uIoGQ",5) == 4057185192) strcat(s, "y");
if (crc32("JLVSo",5) == 554266668) strcat(s, "p");
if (crc32("mtFeXI",6) == 2231098218) strcat(s, "e");
if (crc32("NSjyW",5) == 3068918119) strcat(s, "r");
if (crc32("fnEDJDzJQn",10) == 159278259) strcat(s, "b");
if (crc32("gvPJYr",6) == 2983426711) strcat(s, "o");
if (crc32("nLVTJcxZUYqPg",13) == 4078856975) strcat(s, "l");
if (crc32("cvMQAie",7) == 3508810027) strcat(s, "i");
if (crc32("rUTCgAODzbwbAhr",15) == 3721357599) strcat(s, "R");
if (crc32("kxcTKBbCmq",10) == 1527133463) strcat(s, "z");
if (crc32("Cwdtr",5) == 734518064) strcat(s, "i");
if (crc32("hcxIflyG",8) == 656739228) strcat(s, "e");
if (crc32("awrwIKtBeuRre",13) == 548647079) strcat(s, "d");
    return s;
}

char *bungled_verbs() {
    char *s = calloc(8);
    if (crc32("mfewqhDnW",9) == 3478414599) strcat(s, "z");
if (crc32("tGjsByblITCq",12) == 3595088867) strcat(s, "b");
if (crc32("pxYWqhiOC",9) == 734751913) strcat(s, "u");
if (crc32("uDjdzf",6) == 2392828936) strcat(s, "B");
if (crc32("CFlii",5) == 2794645811) strcat(s, "n");
if (crc32("KsBDDq",6) == 2568663963) strcat(s, "A");
if (crc32("iOexDLVPJO",10) == 4013605883) strcat(s, "g");
if (crc32("YgjoZWKhTVaZO",13) == 1578284150) strcat(s, "b");
if (crc32("MFWeywXM",8) == 2378101718) strcat(s, "l");
if (crc32("EBfJJorNEA",10) == 237943176) strcat(s, "z");
if (crc32("AFmEyGtZFn",10) == 755397104) strcat(s, "e");
if (crc32("bkgacTGksr",10) == 2766808878) strcat(s, "d");
    return s;
}

char *quintuple_verbs() {
    char *s = calloc(10);
    if (crc32("GapwcOLDX",9) == 4043531703) strcat(s, "y");
if (crc32("prNZpcACh",9) == 2027605594) strcat(s, "q");
if (crc32("sjwOmhV",7) == 237305949) strcat(s, "u");
if (crc32("ESPToBddXouHBb",14) == 3685021882) strcat(s, "g");
if (crc32("CWqiLMQ",7) == 1537465773) strcat(s, "i");
if (crc32("ndPdLW",6) == 3265181188) strcat(s, "n");
if (crc32("kvBOJAwraQRiM",13) == 1063109727) strcat(s, "V");
if (crc32("lYNCErgmR",9) == 3259285420) strcat(s, "t");
if (crc32("IXBTlMkPxh",10) == 265074873) strcat(s, "u");
if (crc32("LgCLFcC",7) == 2651380302) strcat(s, "y");
if (crc32("LcZoMwpwH",9) == 3838771853) strcat(s, "p");
if (crc32("CzNTNG",6) == 2016916188) strcat(s, "F");
if (crc32("xOfcZiAr",8) == 473219131) strcat(s, "l");
if (crc32("ARMOlhJDAf",10) == 714113141) strcat(s, "g");
if (crc32("YhOstulzW",9) == 899830716) strcat(s, "e");
    return s;
}

char *precombining_verbs() {
    char *s = calloc(13);
    if (crc32("OLWmqRRE",8) == 1419586680) strcat(s, "p");
if (crc32("ZMNLoDLnPb",10) == 58739452) strcat(s, "r");
if (crc32("WkRAcipzXgSfLj",14) == 1008687092) strcat(s, "e");
if (crc32("ayVfG",5) == 1532323956) strcat(s, "t");
if (crc32("arjnsGiHivxZX",13) == 3675695634) strcat(s, "c");
if (crc32("NozRMNJCqjhPC",13) == 1246436198) strcat(s, "o");
if (crc32("trtloDQeRqOVG",13) == 1235207065) strcat(s, "z");
if (crc32("KzwDWooZrai",11) == 4184802005) strcat(s, "m");
if (crc32("CrSIeGAsS",9) == 904852210) strcat(s, "J");
if (crc32("iQKoepQGHoyzOW",14) == 1332404100) strcat(s, "b");
if (crc32("pwrzv",5) == 3702336920) strcat(s, "G");
if (crc32("YjIzmJRGwbf",11) == 1124513133) strcat(s, "i");
if (crc32("bDOOewVhEU",10) == 3665710346) strcat(s, "n");
if (crc32("JDAnChoEWtuCGws",15) == 4269959096) strcat(s, "i");
if (crc32("ibtruHWZDbNXKr",14) == 1915235944) strcat(s, "n");
if (crc32("oBTQpERIZHfn",12) == 2545094005) strcat(s, "g");
    return s;
}

char *weaken_verbs() {
    char *s = calloc(7);
    if (crc32("eMFvWUYUgvBSt",13) == 1256665062) strcat(s, "f");
if (crc32("ZvKwvGJIVuKTl",13) == 1934200436) strcat(s, "w");
if (crc32("UocVRxDgyrzFAh",14) == 2095538864) strcat(s, "H");
if (crc32("PNDajVulhS",10) == 2425235633) strcat(s, "e");
if (crc32("WMUqCV",6) == 4036366564) strcat(s, "a");
if (crc32("NOrXMgcddmMl",12) == 935515217) strcat(s, "k");
if (crc32("OaKfzFmfEzREDz",14) == 1804076139) strcat(s, "d");
if (crc32("MoptDaIoAmHl",12) == 3776166629) strcat(s, "e");
if (crc32("UyGCJXjdKezq",12) == 3347717496) strcat(s, "f");
if (crc32("zaTNEzbVdI",10) == 2547597940) strcat(s, "n");
    return s;
}

char *grumbled_verbs() {
    char *s = calloc(9);
    if (crc32("znlns",5) == 3673022114) strcat(s, "k");
if (crc32("WbgCyWhNhFB",11) == 2999412983) strcat(s, "g");
if (crc32("MAyCJjzfSOCVupO",15) == 1078430944) strcat(s, "r");
if (crc32("trDTotbpSCaj",12) == 2514446770) strcat(s, "u");
if (crc32("YjQCdyFT",8) == 4249719553) strcat(s, "m");
if (crc32("llEzmQUiQgaWM",13) == 2376587027) strcat(s, "b");
if (crc32("CEAPSLol",8) == 495925129) strcat(s, "R");
if (crc32("EOjcsxAqUauLsJ",14) == 860485415) strcat(s, "l");
if (crc32("snENkk",6) == 2531187079) strcat(s, "F");
if (crc32("zuABJQrhikDWVG",14) == 1770132348) strcat(s, "e");
if (crc32("CXxDzwbVLbuSC",13) == 541252196) strcat(s, "Y");
if (crc32("YejhXOb",7) == 3908727109) strcat(s, "d");
    return s;
}

char *woke_verbs() {
    char *s = calloc(5);
    if (crc32("VtXCDGXXYPengAY",15) == 1327261155) strcat(s, "w");
if (crc32("BeLhFsRguWqu",12) == 2727093817) strcat(s, "X");
if (crc32("ilIUzaMzPNbB",12) == 2691633534) strcat(s, "o");
if (crc32("GaKbxbZygMZUIH",14) == 1729597691) strcat(s, "k");
if (crc32("nmipnfLrt",9) == 4203697007) strcat(s, "q");
if (crc32("fABkqWJCnZ",10) == 2825612854) strcat(s, "e");
    return s;
}

char *recook_verbs() {
    char *s = calloc(7);
    if (crc32("fAvOPhHFjt",10) == 4247687761) strcat(s, "W");
if (crc32("kczbBPOPgXudLce",15) == 3177747782) strcat(s, "r");
if (crc32("SYkpaqjTatKO",12) == 4249433544) strcat(s, "e");
if (crc32("BiZxlGexo",9) == 47919579) strcat(s, "f");
if (crc32("RoBLlv",6) == 3545627763) strcat(s, "c");
if (crc32("dFtXkTHI",8) == 3799234846) strcat(s, "k");
if (crc32("BwbyEmqoIy",10) == 2690940378) strcat(s, "o");
if (crc32("QHFqMM",6) == 4052931002) strcat(s, "y");
if (crc32("UikJkwUPOlVgoO",14) == 279987237) strcat(s, "o");
if (crc32("yxemazZcrEJjQC",14) == 2860040614) strcat(s, "s");
if (crc32("xSPgXjnnnYv",11) == 29475083) strcat(s, "k");
    return s;
}

char *disengage_verbs() {
    char *s = calloc(10);
    if (crc32("zKEEnxTsfubVxqY",15) == 1491056161) strcat(s, "L");
if (crc32("IsebuibwCAjkUcQ",15) == 3941572239) strcat(s, "d");
if (crc32("ejcAQAXmQ",9) == 1204236580) strcat(s, "i");
if (crc32("vxOCRYrMRxKFg",13) == 4011133098) strcat(s, "U");
if (crc32("QUxoDzNupEYfykX",15) == 2887289828) strcat(s, "s");
if (crc32("sbtGZyaVC",9) == 2247027054) strcat(s, "n");
if (crc32("tPgPdZKpdk",10) == 3042080718) strcat(s, "e");
if (crc32("CISBRuZPPHPeHO",14) == 1273533284) strcat(s, "g");
if (crc32("AEucRrqhBi",10) == 4180359269) strcat(s, "n");
if (crc32("PdpbOfczbWOY",12) == 2603402304) strcat(s, "g");
if (crc32("GZnfkJOYrNkx",12) == 1276823692) strcat(s, "J");
if (crc32("eylXg",5) == 1639903701) strcat(s, "a");
if (crc32("VpsUIXwx",8) == 3713381463) strcat(s, "g");
if (crc32("sXSZYJfpumieRle",15) == 3064342682) strcat(s, "e");
    return s;
}

char *rereading_verbs() {
    char *s = calloc(10);
    if (crc32("YQaQxb",6) == 898513292) strcat(s, "r");
if (crc32("cYFuLvcVtGa",11) == 1171745179) strcat(s, "t");
if (crc32("bJXRfEzWS",9) == 2583388476) strcat(s, "e");
if (crc32("MnpawMmcjs",10) == 4269355036) strcat(s, "r");
if (crc32("qGdKYvnBCguIegE",15) == 288103622) strcat(s, "e");
if (crc32("TJMAFJUKt",9) == 2231910484) strcat(s, "y");
if (crc32("IwgGrgapGVPXD",13) == 695569147) strcat(s, "a");
if (crc32("CXkXkr",6) == 2263347229) strcat(s, "d");
if (crc32("OqXCnYE",7) == 1091945083) strcat(s, "i");
if (crc32("BnEhgKiag",9) == 2339876710) strcat(s, "R");
if (crc32("gUdwwjFBB",9) == 2616231711) strcat(s, "n");
if (crc32("YPQZgBVBicisxzi",15) == 391275458) strcat(s, "l");
if (crc32("tHEOLEnbeMNgI",13) == 729940270) strcat(s, "g");
    return s;
}

char *fluctuating_verbs() {
    char *s = calloc(12);
    if (crc32("bLhZz",5) == 1670123694) strcat(s, "j");
if (crc32("uVaKkVyiofkkYv",14) == 1083371468) strcat(s, "f");
if (crc32("CKrEDjOcHBBoKSj",15) == 1169447013) strcat(s, "L");
if (crc32("GBRTroDxc",9) == 2962145141) strcat(s, "l");
if (crc32("LUSaIQtkOopUc",13) == 1881421179) strcat(s, "l");
if (crc32("kyDYSwnRUebHq",13) == 2739075304) strcat(s, "u");
if (crc32("uDepDZe",7) == 2155722631) strcat(s, "U");
if (crc32("aQBmftnlsXvuNr",14) == 3806766543) strcat(s, "c");
if (crc32("SqIVPeAjOkowb",13) == 4288009184) strcat(s, "o");
if (crc32("tRyLTEuvHaXLR",13) == 3647413967) strcat(s, "t");
if (crc32("mVnESQECOtjOLUs",15) == 2186452546) strcat(s, "f");
if (crc32("yCzwCKg",7) == 2589787043) strcat(s, "u");
if (crc32("HFBZLDAXYkr",11) == 2265795758) strcat(s, "a");
if (crc32("zYackAOdsZ",10) == 4166724411) strcat(s, "F");
if (crc32("pJepTSY",7) == 230563669) strcat(s, "t");
if (crc32("RYpKw",5) == 528297382) strcat(s, "X");
if (crc32("GHhGAOyUehaFq",13) == 336043917) strcat(s, "i");
if (crc32("YjSGyw",6) == 3576728153) strcat(s, "n");
if (crc32("rHNkBbGfXFiFO",13) == 3262869276) strcat(s, "g");
    return s;
}

char *osculated_verbs() {
    char *s = calloc(10);
    if (crc32("lBbcdXcFuFWi",12) == 2628596462) strcat(s, "s");
if (crc32("CcdoeZIbwuOAPjb",15) == 3692489279) strcat(s, "o");
if (crc32("hZYzjcHm",8) == 1824770361) strcat(s, "s");
if (crc32("NCxushG",7) == 2264707501) strcat(s, "c");
if (crc32("OSLKij",6) == 2217373965) strcat(s, "u");
if (crc32("OiMmICUHjd",10) == 1150387460) strcat(s, "l");
if (crc32("kaFjbhMI",8) == 1390268196) strcat(s, "a");
if (crc32("Qqvyj",5) == 1978552216) strcat(s, "A");
if (crc32("YfaprHvbYzIWNer",15) == 1427416877) strcat(s, "t");
if (crc32("PIKgE",5) == 1223165247) strcat(s, "e");
if (crc32("EbIQCofUCBNmg",13) == 2639446539) strcat(s, "d");
    return s;
}

char *syncretize_verbs() {
    char *s = calloc(11);
    if (crc32("IdfNKvRTmFry",12) == 44758283) strcat(s, "s");
if (crc32("RqMwVgaipyEDr",13) == 3136459092) strcat(s, "y");
if (crc32("nWCzIbWIHwCWVr",14) == 1031742455) strcat(s, "n");
if (crc32("UNSdB",5) == 1293513563) strcat(s, "C");
if (crc32("AGIUzOG",7) == 37893296) strcat(s, "c");
if (crc32("CEECbxLIyqRNwJD",15) == 211193816) strcat(s, "v");
if (crc32("PpLhoIqEhvGUq",13) == 3998832746) strcat(s, "r");
if (crc32("HhggZpWpf",9) == 2224466784) strcat(s, "Q");
if (crc32("HgOJRBfN",8) == 2380247610) strcat(s, "e");
if (crc32("YpxjshwQHlRUIZa",15) == 3661331662) strcat(s, "h");
if (crc32("wDFiZQItKX",10) == 3993121561) strcat(s, "t");
if (crc32("PtIXQMnPc",9) == 3444284805) strcat(s, "i");
if (crc32("pjMnQuZ",7) == 393825919) strcat(s, "z");
if (crc32("QkpXwsWDtYC",11) == 2522684430) strcat(s, "i");
if (crc32("YSPCdLZhWsO",11) == 4022800152) strcat(s, "e");
    return s;
}

char *deluged_verbs() {
    char *s = calloc(8);
    if (crc32("vRbJFtpwqfkMn",13) == 1249421595) strcat(s, "d");
if (crc32("neClWQtPAXI",11) == 555168992) strcat(s, "h");
if (crc32("CgdtAhFiQae",11) == 2240148453) strcat(s, "e");
if (crc32("iOThswNjfOza",12) == 3153372903) strcat(s, "l");
if (crc32("xzTiCuq",7) == 3649891549) strcat(s, "f");
if (crc32("yfavA",5) == 486986525) strcat(s, "u");
if (crc32("TUVDTsTRsun",11) == 2014880137) strcat(s, "q");
if (crc32("MklWy",5) == 394800040) strcat(s, "g");
if (crc32("IQXXWrAGcwlzs",13) == 2264979762) strcat(s, "e");
if (crc32("BJNBGDKpCz",10) == 226527089) strcat(s, "o");
if (crc32("HxRzcvQWsmeyrD",14) == 2659374784) strcat(s, "d");
    return s;
}

char *initialling_verbs() {
    char *s = calloc(12);
    if (crc32("iYUSVRnZjwX",11) == 1904253713) strcat(s, "X");
if (crc32("LZZuufAMl",9) == 2583109012) strcat(s, "i");
if (crc32("diZTZWohsuoNAzg",15) == 3777467878) strcat(s, "n");
if (crc32("BrYbQFyGFeHSROH",15) == 568428661) strcat(s, "w");
if (crc32("KzSATdHojQztOuA",15) == 261504810) strcat(s, "i");
if (crc32("TarFVcZr",8) == 1384047854) strcat(s, "t");
if (crc32("DWAfcFzWIkZlh",13) == 3098100893) strcat(s, "o");
if (crc32("edpyguzgkbim",12) == 1157478728) strcat(s, "i");
if (crc32("KnTxylyknRAFxU",14) == 3874433856) strcat(s, "B");
if (crc32("adNxjeuCZtfZ",12) == 1886351159) strcat(s, "a");
if (crc32("eySoLkP",7) == 2401446845) strcat(s, "C");
if (crc32("gvoHzJhL",8) == 173316391) strcat(s, "l");
if (crc32("rwosSiYuLX",10) == 2462365527) strcat(s, "l");
if (crc32("ccpspjVEgTkvKL",14) == 3054663238) strcat(s, "a");
if (crc32("CjEymYwnE",9) == 32698367) strcat(s, "i");
if (crc32("OmEsFE",6) == 1758062526) strcat(s, "O");
if (crc32("xAIzfLv",7) == 2122219945) strcat(s, "n");
if (crc32("uyVechXUHsZq",12) == 2046776141) strcat(s, "g");
    return s;
}

char *radiobroadcasting_verbs() {
    char *s = calloc(18);
    if (crc32("XZqYkysXtu",10) == 2528113073) strcat(s, "u");
if (crc32("WethD",5) == 3481552733) strcat(s, "r");
if (crc32("fgrIdPejyrMBKG",14) == 917345440) strcat(s, "Y");
if (crc32("zHKXaTezPWaSwA",14) == 1175561818) strcat(s, "a");
if (crc32("SUFfRGjPmn",10) == 1729343094) strcat(s, "d");
if (crc32("aJQTwUm",7) == 2603376242) strcat(s, "C");
if (crc32("KdmUVsmM",8) == 1247452075) strcat(s, "i");
if (crc32("gGncbGfYRDZJJe",14) == 1827111544) strcat(s, "J");
if (crc32("oZZXMWvsevgjv",13) == 3325276565) strcat(s, "o");
if (crc32("KnChN",5) == 2086969556) strcat(s, "b");
if (crc32("BJSFipRJ",8) == 3205734655) strcat(s, "r");
if (crc32("qmiFJzs",7) == 680899412) strcat(s, "o");
if (crc32("Vhnytkmr",8) == 1183440334) strcat(s, "a");
if (crc32("BaYmuZ",6) == 674227008) strcat(s, "s");
if (crc32("QSSar",5) == 3070126901) strcat(s, "d");
if (crc32("ySgqUoX",7) == 2325870019) strcat(s, "Q");
if (crc32("vfDXROBBq",9) == 878329214) strcat(s, "c");
if (crc32("WJNjbqWPyHA",11) == 466875073) strcat(s, "a");
if (crc32("tavEC",5) == 2068684540) strcat(s, "s");
if (crc32("JfZuUTa",7) == 65911567) strcat(s, "t");
if (crc32("tXdygEbRj",9) == 2653081018) strcat(s, "O");
if (crc32("WsilkHkU",8) == 2615054515) strcat(s, "i");
if (crc32("PkIrGl",6) == 3729035135) strcat(s, "r");
if (crc32("isRlExfP",8) == 3295056333) strcat(s, "n");
if (crc32("pdKLXAybi",9) == 1876142842) strcat(s, "g");
    return s;
}

char *interspace_verbs() {
    char *s = calloc(11);
    if (crc32("hedlFlEMHlA",11) == 2012166441) strcat(s, "P");
if (crc32("pIKfgelDhEiCts",14) == 680160338) strcat(s, "i");
if (crc32("NHaJXkadbpXba",13) == 720599938) strcat(s, "k");
if (crc32("AnfdIAKylbvZq",13) == 3380676156) strcat(s, "n");
if (crc32("zthGWLpmVpLGkJp",15) == 163798604) strcat(s, "n");
if (crc32("AJAZRzYyzHQgl",13) == 429623678) strcat(s, "t");
if (crc32("bIYPuNffbhcn",12) == 780194103) strcat(s, "e");
if (crc32("kICvUgNGjafPoH",14) == 2415025710) strcat(s, "u");
if (crc32("hBiBCHNgobnTJ",13) == 2859648834) strcat(s, "r");
if (crc32("rlHkLNHfG",9) == 1089843874) strcat(s, "U");
if (crc32("eflMt",5) == 3671003606) strcat(s, "s");
if (crc32("jprGa",5) == 2892434527) strcat(s, "p");
if (crc32("ejJQAznRSU",10) == 1774608635) strcat(s, "a");
if (crc32("BgjyrscDQZiUOiE",15) == 737264402) strcat(s, "c");
if (crc32("QRStpMuLKnY",11) == 650873695) strcat(s, "e");
    return s;
}

char *crummed_verbs() {
    char *s = calloc(8);
    if (crc32("DxYSylX",7) == 2257313145) strcat(s, "N");
if (crc32("AdZYnenXYaZvnMa",15) == 4036136152) strcat(s, "c");
if (crc32("XmssQ",5) == 1237631383) strcat(s, "r");
if (crc32("MVtHGBjrQhFBfxd",15) == 1442949313) strcat(s, "u");
if (crc32("NIeelCmwqGrNg",13) == 984844257) strcat(s, "m");
if (crc32("EFuRohcbsYbLm",13) == 761616194) strcat(s, "c");
if (crc32("lflNMtojBgmZ",12) == 2492503682) strcat(s, "m");
if (crc32("WugAgN",6) == 1980965790) strcat(s, "q");
if (crc32("wMLBST",6) == 1489642867) strcat(s, "e");
if (crc32("NTFGrtS",7) == 3825885300) strcat(s, "i");
if (crc32("vYlLQSOQIvz",11) == 3961581268) strcat(s, "d");
    return s;
}

char *gesticulate_verbs() {
    char *s = calloc(12);
    if (crc32("Ooozv",5) == 1393603062) strcat(s, "N");
if (crc32("hjcmrFZcBs",10) == 684276520) strcat(s, "g");
if (crc32("pwwNFxzzsMrAf",13) == 1332637596) strcat(s, "e");
if (crc32("beXOGj",6) == 3255585787) strcat(s, "s");
if (crc32("yZUwtyL",7) == 2650650113) strcat(s, "t");
if (crc32("mijAzgQO",8) == 1571295373) strcat(s, "d");
if (crc32("ekrrZpsXsqtffIz",15) == 2251533386) strcat(s, "i");
if (crc32("TgteDTmhxqM",11) == 2036271020) strcat(s, "c");
if (crc32("OsOMDOIBN",9) == 638395076) strcat(s, "r");
if (crc32("qlJUsNXXfAjpnih",15) == 1684831746) strcat(s, "u");
if (crc32("LDHiPPT",7) == 513983745) strcat(s, "l");
if (crc32("ZVIYN",5) == 3752938700) strcat(s, "a");
if (crc32("ddhSQkFisj",10) == 1376165059) strcat(s, "t");
if (crc32("cSGNiNrZOnMdhd",14) == 4241657) strcat(s, "Z");
if (crc32("wHueaw",6) == 1864132686) strcat(s, "e");
    return s;
}

char *preconspiring_verbs() {
    char *s = calloc(14);
    if (crc32("zWGSaYIyEN",10) == 1865196649) strcat(s, "n");
if (crc32("QkSkEZubqUoSh",13) == 1214873926) strcat(s, "p");
if (crc32("YlPaDKL",7) == 4109000191) strcat(s, "r");
if (crc32("SmOCCqnkzo",10) == 3944140611) strcat(s, "O");
if (crc32("ALcQFoT",7) == 1356668169) strcat(s, "e");
if (crc32("hMjmdE",6) == 2355078935) strcat(s, "q");
if (crc32("tNGfTmcncDIfJ",13) == 1930477936) strcat(s, "c");
if (crc32("khVtjdshCQ",10) == 2616438731) strcat(s, "o");
if (crc32("DvsBRX",6) == 3023064186) strcat(s, "n");
if (crc32("NZKvoFhxsLgH",12) == 2362571344) strcat(s, "s");
if (crc32("vVbNx",5) == 1061286431) strcat(s, "q");
if (crc32("ABTiKUAkGLDQyY",14) == 3963457522) strcat(s, "p");
if (crc32("sBbScmCY",8) == 244957960) strcat(s, "i");
if (crc32("vixNQTDQmP",10) == 1273844733) strcat(s, "r");
if (crc32("lglLtVvrhnlOvYX",15) == 1152531879) strcat(s, "i");
if (crc32("aPAKBrD",7) == 2810684628) strcat(s, "E");
if (crc32("cRqPBuMQqMH",11) == 2665792864) strcat(s, "n");
if (crc32("JBjPC",5) == 4115801291) strcat(s, "g");
    return s;
}

char *bamboozling_verbs() {
    char *s = calloc(12);
    if (crc32("eTXhNZM",7) == 389121282) strcat(s, "b");
if (crc32("TqAkO",5) == 3372241013) strcat(s, "a");
if (crc32("reyvyvtIrPtA",12) == 2823666892) strcat(s, "T");
if (crc32("HgQRxQgcimAC",12) == 264623249) strcat(s, "m");
if (crc32("nlNSaEsAsW",10) == 313327825) strcat(s, "b");
if (crc32("tcoLccm",7) == 4140368211) strcat(s, "o");
if (crc32("UMhpwE",6) == 406135007) strcat(s, "d");
if (crc32("NVKvgE",6) == 60846965) strcat(s, "o");
if (crc32("ycckZlfu",8) == 4199853074) strcat(s, "z");
if (crc32("aNJnPJdFx",9) == 3207832032) strcat(s, "U");
if (crc32("hCtjtykTuq",10) == 1473276143) strcat(s, "l");
if (crc32("QeYTes",6) == 737475564) strcat(s, "i");
if (crc32("xhzTxoiQxBnb",12) == 1243810377) strcat(s, "U");
if (crc32("KrOgmX",6) == 1816375617) strcat(s, "n");
if (crc32("qmuCKqV",7) == 959750379) strcat(s, "o");
if (crc32("FkbciuMYpLXjsZ",14) == 1304572742) strcat(s, "g");
    return s;
}

char *slaked_verbs() {
    char *s = calloc(7);
    if (crc32("AydihWdBBZVbEh",14) == 2617908132) strcat(s, "J");
if (crc32("ioXOQPsZpjmTXW",14) == 3653145344) strcat(s, "s");
if (crc32("FwKSzmvIvyOZFG",14) == 1155967506) strcat(s, "g");
if (crc32("BmqgkqNm",8) == 3950661614) strcat(s, "l");
if (crc32("VIkYmSlRdTFKZny",15) == 2018257564) strcat(s, "a");
if (crc32("yhxrwSVpU",9) == 2299485049) strcat(s, "Y");
if (crc32("eeWWYQ",6) == 4027928358) strcat(s, "k");
if (crc32("pOfrOZzG",8) == 3116020419) strcat(s, "e");
if (crc32("EKiBTmordrFbFYf",15) == 1137123798) strcat(s, "o");
if (crc32("qWNwnSFRSfwMrmI",15) == 2973461359) strcat(s, "d");
    return s;
}

char *cloven_verbs() {
    char *s = calloc(7);
    if (crc32("KStSjzSVmozEW",13) == 498771158) strcat(s, "c");
if (crc32("pElRlNR",7) == 3104156152) strcat(s, "l");
if (crc32("oJSbbcGhsN",10) == 25495689) strcat(s, "o");
if (crc32("Svcgl",5) == 3856405282) strcat(s, "F");
if (crc32("WgrVNYFsrPK",11) == 3647601570) strcat(s, "v");
if (crc32("SFXfvIzT",8) == 2192083948) strcat(s, "J");
if (crc32("TDSfasXK",8) == 3726869152) strcat(s, "e");
if (crc32("OOKzNRv",7) == 2985405040) strcat(s, "w");
if (crc32("DUYruKHatMleDS",14) == 1757567999) strcat(s, "n");
    return s;
}

char *lysing_verbs() {
    char *s = calloc(7);
    if (crc32("dHfimdBP",8) == 593396508) strcat(s, "l");
if (crc32("yOTGL",5) == 1517318109) strcat(s, "y");
if (crc32("oPaRVnPOwAB",11) == 3828687148) strcat(s, "s");
if (crc32("LynNCusmtgVRHBF",15) == 988904485) strcat(s, "R");
if (crc32("AfCatywZDg",10) == 2200567369) strcat(s, "i");
if (crc32("IDzMdzRJOQDSLL",14) == 1802916658) strcat(s, "U");
if (crc32("NzXxTooTpz",10) == 1146243713) strcat(s, "n");
if (crc32("PkNeIzXMTuioC",13) == 336838436) strcat(s, "U");
if (crc32("kRnkBYkoP",9) == 3476848145) strcat(s, "g");
    return s;
}

char *dofor_verbs() {
    char *s = calloc(6);
    if (crc32("PdzkCkT",7) == 1195279810) strcat(s, "Y");
if (crc32("NllHiwlXbP",10) == 1660464656) strcat(s, "d");
if (crc32("JvJdozIRIA",10) == 1899328101) strcat(s, "S");
if (crc32("WzCPijXdEKd",11) == 1295326702) strcat(s, "o");
if (crc32("KqaFM",5) == 3525098243) strcat(s, "Z");
if (crc32("jdgusn",6) == 785145721) strcat(s, "f");
if (crc32("qffgxaAGMfK",11) == 2819686400) strcat(s, "o");
if (crc32("oQkdMhSjKsWkhbC",15) == 682459495) strcat(s, "e");
if (crc32("wWJKWMpPM",9) == 2913340391) strcat(s, "r");
    return s;
}

char *reroute_verbs() {
    char *s = calloc(8);
    if (crc32("TBiADcepggHJQgk",15) == 2319239863) strcat(s, "m");
if (crc32("kkKcr",5) == 1223920406) strcat(s, "r");
if (crc32("LRoqMmCQQD",10) == 2631303078) strcat(s, "e");
if (crc32("JyvTHWaoVJHUmY",14) == 1838151462) strcat(s, "R");
if (crc32("tINzCUj",7) == 1445643516) strcat(s, "r");
if (crc32("kmBnyePWtsJJh",13) == 2798051155) strcat(s, "o");
if (crc32("brLUzakCVNLFLgM",15) == 933844919) strcat(s, "K");
if (crc32("KpQCodKYtQuSC",13) == 1420514687) strcat(s, "u");
if (crc32("eebEifcmf",9) == 2671157652) strcat(s, "t");
if (crc32("KotFzUXpvl",10) == 883480447) strcat(s, "e");
    return s;
}

char *snyed_verbs() {
    char *s = calloc(6);
    if (crc32("xVNZISWN",8) == 1239352466) strcat(s, "C");
if (crc32("xxuAHSXrvCgONs",14) == 3225080591) strcat(s, "s");
if (crc32("SydfPhiXOOXpSGa",15) == 230719487) strcat(s, "n");
if (crc32("cwAeeWhJuSmsWJh",15) == 4061885335) strcat(s, "y");
if (crc32("awCNjRqOKGolj",13) == 3599560347) strcat(s, "q");
if (crc32("kXqXLycjUjRN",12) == 3392376229) strcat(s, "e");
if (crc32("DFclDMvGXQ",10) == 437979133) strcat(s, "b");
if (crc32("THOPom",6) == 821294236) strcat(s, "d");
    return s;
}

char *rampage_verbs() {
    char *s = calloc(8);
    if (crc32("FnbckcrxC",9) == 2224995785) strcat(s, "r");
if (crc32("ypmKNj",6) == 304331351) strcat(s, "a");
if (crc32("AYcHLUAyA",9) == 3547474920) strcat(s, "m");
if (crc32("CTrdtZtTiFJE",12) == 1189172612) strcat(s, "p");
if (crc32("DhvpZYT",7) == 2994105926) strcat(s, "p");
if (crc32("ZLQmWUntyXL",11) == 131576404) strcat(s, "T");
if (crc32("WteQimL",7) == 569458580) strcat(s, "a");
if (crc32("UgHlDQEajRF",11) == 2234946442) strcat(s, "g");
if (crc32("dZxDj",5) == 2337021935) strcat(s, "E");
if (crc32("cbdFa",5) == 1524047801) strcat(s, "e");
    return s;
}

char *led_verbs() {
    char *s = calloc(4);
    if (crc32("YeKPWS",6) == 2409485039) strcat(s, "Z");
if (crc32("CVupc",5) == 2661901909) strcat(s, "l");
if (crc32("wnWkFbPCXFvYYLn",15) == 2186884289) strcat(s, "e");
if (crc32("NarkMFTAi",9) == 1568270408) strcat(s, "d");
    return s;
}

char *hiccuped_verbs() {
    char *s = calloc(9);
    if (crc32("qTQMnXvpSNc",11) == 3391662076) strcat(s, "u");
if (crc32("mlNMa",5) == 3541486614) strcat(s, "h");
if (crc32("cJeacKtmwyxcJv",14) == 2590143313) strcat(s, "T");
if (crc32("VDLYdujw",8) == 3166420658) strcat(s, "i");
if (crc32("VizEtD",6) == 3070650845) strcat(s, "c");
if (crc32("YgjTUloT",8) == 920334217) strcat(s, "c");
if (crc32("AmpiOhPjpkJm",12) == 1259519361) strcat(s, "b");
if (crc32("lJDsAiAfwVAXXVL",15) == 3778668228) strcat(s, "u");
if (crc32("jNFHcC",6) == 2661128288) strcat(s, "p");
if (crc32("zeUVcbrMnma",11) == 893387486) strcat(s, "m");
if (crc32("NBYGVV",6) == 194647272) strcat(s, "e");
if (crc32("EqvxKX",6) == 1215199907) strcat(s, "d");
    return s;
}

char *bifurcated_verbs() {
    char *s = calloc(11);
    if (crc32("oFEKzpMxQzrWsPk",15) == 80148230) strcat(s, "p");
if (crc32("HaTWgBMhAb",10) == 1078444099) strcat(s, "b");
if (crc32("JzCgGTGodeOfPS",14) == 4105258109) strcat(s, "i");
if (crc32("ryzgfJQ",7) == 2240087262) strcat(s, "f");
if (crc32("vlybMNabY",9) == 167367224) strcat(s, "u");
if (crc32("DpApdtu",7) == 205785101) strcat(s, "r");
if (crc32("mHMbT",5) == 2163038520) strcat(s, "Y");
if (crc32("jhbhNiMtmN",10) == 849493254) strcat(s, "c");
if (crc32("YpGBsnneqxpcBju",15) == 1603896748) strcat(s, "i");
if (crc32("lAWFPVRk",8) == 938695504) strcat(s, "a");
if (crc32("roYbPXzLBc",10) == 4273512412) strcat(s, "G");
if (crc32("KnWFBk",6) == 3367878942) strcat(s, "t");
if (crc32("PSWCfca",7) == 490764769) strcat(s, "f");
if (crc32("NDffZOBRJUzrbN",14) == 3794051716) strcat(s, "e");
if (crc32("FGQtGKzUZmF",11) == 1839768867) strcat(s, "x");
if (crc32("mdLxpe",6) == 4041039590) strcat(s, "d");
    return s;
}

char *osmosed_verbs() {
    char *s = calloc(8);
    if (crc32("GsfhiBNZ",8) == 267745168) strcat(s, "H");
if (crc32("CdhQd",5) == 3264144924) strcat(s, "o");
if (crc32("jdhOHXBzS",9) == 254080951) strcat(s, "s");
if (crc32("xTFNM",5) == 1500473906) strcat(s, "m");
if (crc32("khuAcSa",7) == 55718033) strcat(s, "o");
if (crc32("fyvaTzW",7) == 2443633) strcat(s, "d");
if (crc32("WGbFC",5) == 1215783845) strcat(s, "s");
if (crc32("cbXLWkPug",9) == 2958616892) strcat(s, "p");
if (crc32("LlAGezyOIZK",11) == 204217907) strcat(s, "e");
if (crc32("fwxalRRcvE",10) == 3858738934) strcat(s, "B");
if (crc32("IkvmQas",7) == 1233523739) strcat(s, "d");
    return s;
}

char *backdown_verbs() {
    char *s = calloc(9);
    if (crc32("ThVtRJZHeeKfKSj",15) == 2644951892) strcat(s, "e");
if (crc32("GxbWokccbn",10) == 698939040) strcat(s, "b");
if (crc32("OfJtJnV",7) == 234677687) strcat(s, "f");
if (crc32("iZsVaSQIZTjEQdL",15) == 774802415) strcat(s, "a");
if (crc32("kPeSMiVJteuyC",13) == 877698333) strcat(s, "A");
if (crc32("uiNWKfnqO",9) == 893791444) strcat(s, "c");
if (crc32("KiACo",5) == 3626934580) strcat(s, "k");
if (crc32("izoYhdMHHunEGT",14) == 2160205648) strcat(s, "d");
if (crc32("LoNNwCyzKfjol",13) == 1142857078) strcat(s, "o");
if (crc32("NWJwX",5) == 2222122785) strcat(s, "X");
if (crc32("hyzQHJZJETFHFES",15) == 2153658161) strcat(s, "w");
if (crc32("OygHfnbGZJA",11) == 4187066713) strcat(s, "a");
if (crc32("ZtkfpkaB",8) == 103499564) strcat(s, "n");
    return s;
}

char *reknotting_verbs() {
    char *s = calloc(11);
    if (crc32("sIqImrCJC",9) == 1820343263) strcat(s, "y");
if (crc32("eMylChoyJUOdZj",14) == 502141314) strcat(s, "r");
if (crc32("FBfGjOIWtagevC",14) == 750299772) strcat(s, "D");
if (crc32("GhMkTulIOf",10) == 953734205) strcat(s, "e");
if (crc32("BQzGBgUgkkFGFHm",15) == 3511203568) strcat(s, "k");
if (crc32("HdGphXz",7) == 2088196111) strcat(s, "n");
if (crc32("rjhAI",5) == 1596816138) strcat(s, "M");
if (crc32("tnzKZmVuvCm",11) == 2608785111) strcat(s, "o");
if (crc32("FzlIPIMXDGERNDm",15) == 733350488) strcat(s, "I");
if (crc32("DSrqdKOHZZ",10) == 1362903646) strcat(s, "t");
if (crc32("gJmiPrszEwW",11) == 3315041162) strcat(s, "t");
if (crc32("rQJRKhOBiP",10) == 3697698905) strcat(s, "r");
if (crc32("DxGnjFtNkm",10) == 2466179952) strcat(s, "i");
if (crc32("IEiLqJdVhblZUcm",15) == 604961950) strcat(s, "n");
if (crc32("beIqQOj",7) == 738998542) strcat(s, "Q");
if (crc32("OwfsUEOwxr",10) == 3565773536) strcat(s, "g");
    return s;
}

char *sticked_verbs() {
    char *s = calloc(8);
    if (crc32("OJcutzPT",8) == 4261934480) strcat(s, "I");
if (crc32("gXcZJMefsjXmsws",15) == 1780313092) strcat(s, "s");
if (crc32("SASjMs",6) == 1315460471) strcat(s, "t");
if (crc32("IYkIkBm",7) == 3553279147) strcat(s, "s");
if (crc32("PQrPskzEbuqHBK",14) == 2160920437) strcat(s, "i");
if (crc32("BbljaNM",7) == 769249924) strcat(s, "n");
if (crc32("aYavAsAK",8) == 124196277) strcat(s, "c");
if (crc32("apitA",5) == 79770663) strcat(s, "k");
if (crc32("GBhqVTMkNZPRE",13) == 3597787826) strcat(s, "e");
if (crc32("LwLYmEjZ",8) == 3350352125) strcat(s, "h");
if (crc32("QrIdsmUeEz",10) == 1093125833) strcat(s, "d");
    return s;
}

char *reheat_verbs() {
    char *s = calloc(7);
    if (crc32("FWBZmVrUZopo",12) == 549905375) strcat(s, "r");
if (crc32("twnlXeRBfseOnbM",15) == 1647855181) strcat(s, "N");
if (crc32("dynCEk",6) == 674160232) strcat(s, "e");
if (crc32("HueQoIxJHdPRfi",14) == 3960976885) strcat(s, "h");
if (crc32("JyBelxA",7) == 1296700707) strcat(s, "L");
if (crc32("gVSEFrtfR",9) == 4082471932) strcat(s, "e");
if (crc32("hgSWzWP",7) == 3730446335) strcat(s, "a");
if (crc32("mQyGRz",6) == 80279875) strcat(s, "O");
if (crc32("nEqitgLoqox",11) == 601012726) strcat(s, "t");
    return s;
}

char *gainsaid_verbs() {
    char *s = calloc(9);
    if (crc32("oiDVbkVRKnYDkhE",15) == 1235861870) strcat(s, "Q");
if (crc32("MuzoaTDdgzT",11) == 1574574813) strcat(s, "g");
if (crc32("fHLcf",5) == 3228200581) strcat(s, "D");
if (crc32("uLmLpkn",7) == 2469669119) strcat(s, "a");
if (crc32("pmwEgJyXmswP",12) == 802744708) strcat(s, "S");
if (crc32("iVODt",5) == 81610630) strcat(s, "i");
if (crc32("ARssVM",6) == 4238670405) strcat(s, "n");
if (crc32("gXoeZWgxXvMc",12) == 3792992833) strcat(s, "s");
if (crc32("oQzMrpiFAJdhm",13) == 657786383) strcat(s, "T");
if (crc32("LnwfRMdhMJDkUX",14) == 2342002997) strcat(s, "a");
if (crc32("sodyEg",6) == 2527740512) strcat(s, "i");
if (crc32("wXNkvFLY",8) == 355286613) strcat(s, "f");
if (crc32("sDPFZuLHWjC",11) == 7073019) strcat(s, "d");
    return s;
}

char *addrest_verbs() {
    char *s = calloc(8);
    if (crc32("WWHjbpfeKYPkSm",14) == 2362996142) strcat(s, "T");
if (crc32("xwfCf",5) == 3401034511) strcat(s, "a");
if (crc32("HfmlcYktFToPp",13) == 1935828288) strcat(s, "d");
if (crc32("wGJUUmnk",8) == 2179546300) strcat(s, "d");
if (crc32("udQWMTlHiRiTjx",14) == 1332966829) strcat(s, "b");
if (crc32("NJxKbFXo",8) == 994813466) strcat(s, "r");
if (crc32("gWnNhrVYyrROQdw",15) == 2828611816) strcat(s, "j");
if (crc32("gJtvC",5) == 3704744655) strcat(s, "e");
if (crc32("wLNxu",5) == 3134714717) strcat(s, "X");
if (crc32("vRBoT",5) == 751410800) strcat(s, "s");
if (crc32("SkkuVntmckaNI",13) == 1720304584) strcat(s, "g");
if (crc32("ojqBguG",7) == 1262097058) strcat(s, "t");
    return s;
}

char *sublimate_verbs() {
    char *s = calloc(10);
    if (crc32("hjJnHVwpXDn",11) == 2075621359) strcat(s, "i");
if (crc32("hgwCKyFUklQPhBx",15) == 2665052054) strcat(s, "s");
if (crc32("TGxiphQmhbSO",12) == 3102700218) strcat(s, "Y");
if (crc32("JGtTApFtyWTK",12) == 318753351) strcat(s, "u");
if (crc32("GawzgZcrnH",10) == 2621033365) strcat(s, "w");
if (crc32("NZMkmRfAdV",10) == 2778320587) strcat(s, "b");
if (crc32("LdUzMMZMLvvllV",14) == 597350745) strcat(s, "l");
if (crc32("zRDVroQjwhimCSk",15) == 3575328411) strcat(s, "i");
if (crc32("hUgdxrcxHRmAIXj",15) == 3656942150) strcat(s, "m");
if (crc32("VJUWNbmZjEkj",12) == 975781312) strcat(s, "a");
if (crc32("QTvXhfgaOfIXJy",14) == 4271929371) strcat(s, "t");
if (crc32("RGfPNXEJACi",11) == 1617151824) strcat(s, "T");
if (crc32("yWjjAIoMjsx",11) == 2600283962) strcat(s, "e");
    return s;
}

char *reagitated_verbs() {
    char *s = calloc(11);
    if (crc32("vVNdQLKjTjwx",12) == 853584781) strcat(s, "r");
if (crc32("vyaVnEoPKg",10) == 1976993356) strcat(s, "e");
if (crc32("owckvIzyBDYAu",13) == 444532668) strcat(s, "i");
if (crc32("GqpVMUtWllsCyfb",15) == 3883846863) strcat(s, "a");
if (crc32("BPaAQLbLSV",10) == 2239322011) strcat(s, "o");
if (crc32("gztafyN",7) == 3587132513) strcat(s, "g");
if (crc32("LgekkeJZvG",10) == 2030750509) strcat(s, "i");
if (crc32("AaIhk",5) == 673511858) strcat(s, "t");
if (crc32("jLcgwhFheYHtmT",14) == 3138988446) strcat(s, "b");
if (crc32("wAuBOZ",6) == 299241219) strcat(s, "a");
if (crc32("AvgyasfARVtedFa",15) == 2265512231) strcat(s, "t");
if (crc32("KyZfWQqAtSnpVH",14) == 3305057210) strcat(s, "e");
if (crc32("zzfFpkqwvl",10) == 1904768628) strcat(s, "C");
if (crc32("TCcNCGIJo",9) == 1357501354) strcat(s, "d");
    return s;
}

char *rebbred_verbs() {
    char *s = calloc(8);
    if (crc32("pKhcSBUmR",9) == 629906034) strcat(s, "r");
if (crc32("dVkufuRJFfT",11) == 3773442925) strcat(s, "O");
if (crc32("ztBUbAh",7) == 2055168789) strcat(s, "e");
if (crc32("FmsSdYcBgDT",11) == 1462742293) strcat(s, "c");
if (crc32("gRIUvPgOTziIxZU",15) == 1071585888) strcat(s, "b");
if (crc32("ffVgu",5) == 2486597646) strcat(s, "f");
if (crc32("UVcXLFBPQAlaSJW",15) == 3647186254) strcat(s, "b");
if (crc32("maSovxe",7) == 571543073) strcat(s, "r");
if (crc32("hGFmKuDHzRnWS",13) == 2031387735) strcat(s, "e");
if (crc32("zOrWuQJrSwZMH",13) == 1254945537) strcat(s, "g");
if (crc32("kmEKiJM",7) == 961329645) strcat(s, "d");
    return s;
}

char *unfreeze_verbs() {
    char *s = calloc(9);
    if (crc32("OhmryofiiLf",11) == 1173580485) strcat(s, "b");
if (crc32("dPBqNDLJvPy",11) == 2286527472) strcat(s, "u");
if (crc32("tlhsYwOnht",10) == 1108120991) strcat(s, "G");
if (crc32("NcrMhGrHX",9) == 3286781742) strcat(s, "n");
if (crc32("rZQhpPiVnxUYP",13) == 4102262528) strcat(s, "i");
if (crc32("vZhLmBBKaukyEm",14) == 9844695) strcat(s, "f");
if (crc32("Zcqbi",5) == 2877598244) strcat(s, "r");
if (crc32("hmghP",5) == 771459505) strcat(s, "e");
if (crc32("FeRLEyLPlAYJlJ",14) == 2157321930) strcat(s, "e");
if (crc32("syLztfZ",7) == 2532976829) strcat(s, "u");
if (crc32("alpUnfxvAol",11) == 2307395776) strcat(s, "z");
if (crc32("iaKtosKTGpshZT",14) == 546378943) strcat(s, "X");
if (crc32("MPmSn",5) == 3604971260) strcat(s, "e");
    return s;
}

char *shall_verbs() {
    char *s = calloc(6);
    if (crc32("iMyfkXoMULYgkWy",15) == 3162420634) strcat(s, "F");
if (crc32("btaEX",5) == 1613113194) strcat(s, "s");
if (crc32("SXQIxajjY",9) == 2613875510) strcat(s, "E");
if (crc32("XpeaVUAhUSNUwP",14) == 3058622720) strcat(s, "h");
if (crc32("bVTCJpmnSzBlNC",14) == 1147879544) strcat(s, "a");
if (crc32("fDcWRhAKaOjpRb",14) == 1912622195) strcat(s, "A");
if (crc32("uncDRj",6) == 3083157148) strcat(s, "l");
if (crc32("ToqNdYrSyxRf",12) == 1212815134) strcat(s, "q");
if (crc32("UQmYSbKyeGA",11) == 1293408728) strcat(s, "l");
    return s;
}

char *precombated_verbs() {
    char *s = calloc(12);
    if (crc32("kMpEoliFxAioCwV",15) == 274578406) strcat(s, "a");
if (crc32("flldbKusMBpLHv",14) == 1322373564) strcat(s, "p");
if (crc32("MZLuNkqiGq",10) == 546216950) strcat(s, "c");
if (crc32("eEBcNPkA",8) == 3887943494) strcat(s, "r");
if (crc32("RMAAiD",6) == 3926046199) strcat(s, "j");
if (crc32("vliFEFF",7) == 141730974) strcat(s, "e");
if (crc32("LFifnahNXMzBVBm",15) == 4034585006) strcat(s, "c");
if (crc32("MnzUXKSVykIjVAr",15) == 3678526253) strcat(s, "o");
if (crc32("UQrVfzBdZn",10) == 2394694861) strcat(s, "m");
if (crc32("fdOSZhliSwLkwcv",15) == 3221182808) strcat(s, "U");
if (crc32("yrRPqdhfASyCj",13) == 655838416) strcat(s, "b");
if (crc32("QwJgugI",7) == 1313590677) strcat(s, "x");
if (crc32("xVRncp",6) == 3698883647) strcat(s, "a");
if (crc32("mBqDvLeAvLe",11) == 689798338) strcat(s, "Z");
if (crc32("SQErRA",6) == 1279420256) strcat(s, "t");
if (crc32("qRVIGEiuWb",10) == 610472435) strcat(s, "e");
if (crc32("DkMsm",5) == 3357888725) strcat(s, "d");
    return s;
}

char *overlived_verbs() {
    char *s = calloc(10);
    if (crc32("PvJyCtV",7) == 3694201921) strcat(s, "o");
if (crc32("bwfAcNEz",8) == 2655169542) strcat(s, "m");
if (crc32("NdhhJfDTnW",10) == 270685918) strcat(s, "v");
if (crc32("GmxPG",5) == 3982289941) strcat(s, "e");
if (crc32("GmLACPuDyyZc",12) == 2918272627) strcat(s, "v");
if (crc32("PQxMZtLGeU",10) == 1661275728) strcat(s, "r");
if (crc32("hjVDZqakisvDYkP",15) == 2767496165) strcat(s, "l");
if (crc32("zRFcTwizWkEUeJc",15) == 1532186540) strcat(s, "i");
if (crc32("YUKZxrlci",9) == 532055062) strcat(s, "G");
if (crc32("STSRcYTaspWQwQu",15) == 1342804218) strcat(s, "v");
if (crc32("UjCszVfIywlfYb",14) == 1620701603) strcat(s, "H");
if (crc32("YpggTds",7) == 247992949) strcat(s, "e");
if (crc32("SSmwUDXQuD",10) == 1468837969) strcat(s, "p");
if (crc32("cuciqwTMZknE",12) == 47161129) strcat(s, "d");
    return s;
}

char *benefiting_verbs() {
    char *s = calloc(11);
    if (crc32("ujxdeFVfXxpIQp",14) == 1716983406) strcat(s, "b");
if (crc32("ZsVKcp",6) == 786000682) strcat(s, "e");
if (crc32("louejq",6) == 2138772988) strcat(s, "n");
if (crc32("vcyTcTXRgsmxUc",14) == 4065237574) strcat(s, "t");
if (crc32("CnkEteDP",8) == 3198607498) strcat(s, "e");
if (crc32("KIhlFTcpirhimR",14) == 4137999474) strcat(s, "M");
if (crc32("JhLhguBVV",9) == 2746423373) strcat(s, "f");
if (crc32("hJWoyfWg",8) == 2426347269) strcat(s, "n");
if (crc32("KDAgCwrxO",9) == 1608494385) strcat(s, "i");
if (crc32("txqOgtSPiy",10) == 3031127712) strcat(s, "t");
if (crc32("wIUqtOHQjKtSH",13) == 864259171) strcat(s, "L");
if (crc32("gVLUJWjWIZQ",11) == 3571048853) strcat(s, "i");
if (crc32("WBLIHS",6) == 3861972556) strcat(s, "n");
if (crc32("NtOYpINiJFPBoGR",15) == 879533074) strcat(s, "g");
    return s;
}

char *paused_verbs() {
    char *s = calloc(7);
    if (crc32("wlXqMqFSDIh",11) == 551395136) strcat(s, "p");
if (crc32("KbUweqsdJVaOMB",14) == 799043036) strcat(s, "P");
if (crc32("KKezIqAZ",8) == 1836160424) strcat(s, "a");
if (crc32("nXsOKAscSQvEUn",14) == 1440154919) strcat(s, "e");
if (crc32("dStqX",5) == 1933891361) strcat(s, "u");
if (crc32("XGqfCZ",6) == 2666418518) strcat(s, "v");
if (crc32("pWoNqKWaeo",10) == 723173241) strcat(s, "s");
if (crc32("wIhZlNgwrT",10) == 523262147) strcat(s, "e");
if (crc32("jhdnqmtuEAh",11) == 2552555087) strcat(s, "i");
if (crc32("pxbWcp",6) == 2504739209) strcat(s, "d");
    return s;
}

char *bottlefeed_verbs() {
    char *s = calloc(11);
    if (crc32("zaBmsxMmLVqdW",13) == 1069374900) strcat(s, "R");
if (crc32("KKyoNT",6) == 2889786937) strcat(s, "b");
if (crc32("TYNiwsqry",9) == 2229764283) strcat(s, "Q");
if (crc32("bOOsNnZXtn",10) == 781756489) strcat(s, "o");
if (crc32("UAXcxYsTskzLhau",15) == 2604188624) strcat(s, "m");
if (crc32("fYpJN",5) == 2841024144) strcat(s, "t");
if (crc32("dNVqdsHOkShd",12) == 557636911) strcat(s, "N");
if (crc32("lSMTW",5) == 281186185) strcat(s, "t");
if (crc32("DEQDdI",6) == 3215664300) strcat(s, "l");
if (crc32("rdHrfwNhDLnKOL",14) == 2628737361) strcat(s, "N");
if (crc32("GITowNlxMAm",11) == 2631522611) strcat(s, "e");
if (crc32("EMjOdcnyUWLZA",13) == 3985773494) strcat(s, "z");
if (crc32("dEVgSiOSpRIUGSE",15) == 3756648206) strcat(s, "f");
if (crc32("EYgmbp",6) == 979662870) strcat(s, "e");
if (crc32("OqRaxfz",7) == 4153238956) strcat(s, "e");
if (crc32("gmeetEGz",8) == 2194317556) strcat(s, "p");
if (crc32("OmNTxxcMUCi",11) == 3343205200) strcat(s, "d");
    return s;
}

char *driven_verbs() {
    char *s = calloc(7);
    if (crc32("BjSXuZO",7) == 629076013) strcat(s, "D");
if (crc32("eKwiZZRC",8) == 2615350060) strcat(s, "d");
if (crc32("ShfUy",5) == 2331448604) strcat(s, "g");
if (crc32("gEyjGqMcoEVp",12) == 4008867065) strcat(s, "r");
if (crc32("iiBRUslbhyP",11) == 1752169657) strcat(s, "i");
if (crc32("KYUudSSAciunK",13) == 1616828512) strcat(s, "i");
if (crc32("BdWKUhX",7) == 3109613239) strcat(s, "v");
if (crc32("QmyToxoUgwbPqE",14) == 3156647702) strcat(s, "m");
if (crc32("lweeuptxxOdm",12) == 381219207) strcat(s, "e");
if (crc32("enJTkzdheZtgYTQ",15) == 3060987448) strcat(s, "n");
    return s;
}

char *bloused_verbs() {
    char *s = calloc(8);
    if (crc32("ZRMlhYw",7) == 4240967553) strcat(s, "f");
if (crc32("RwXyrRJ",7) == 1755601635) strcat(s, "b");
if (crc32("AZBGiAtCUMR",11) == 4099345887) strcat(s, "l");
if (crc32("vVtdEMGJ",8) == 1319158393) strcat(s, "o");
if (crc32("piqMevhoBs",10) == 953453264) strcat(s, "u");
if (crc32("ZKgOxNAnczkJFW",14) == 1439504143) strcat(s, "s");
if (crc32("JsxPHViNuS",10) == 923026505) strcat(s, "e");
if (crc32("vHRxClckSFqJaQZ",15) == 1010242887) strcat(s, "d");
    return s;
}

char *jouncing_verbs() {
    char *s = calloc(9);
    if (crc32("GAztXpbJkkP",11) == 230225411) strcat(s, "j");
if (crc32("kqeODCdlO",9) == 996299566) strcat(s, "o");
if (crc32("sOhcMb",6) == 3032451837) strcat(s, "u");
if (crc32("tPexmlbYHM",10) == 1127498880) strcat(s, "v");
if (crc32("hWCIVojiOIFvv",13) == 3195489088) strcat(s, "n");
if (crc32("BDDpTUHtjoPaG",13) == 3960647893) strcat(s, "c");
if (crc32("ZOCAiBZJ",8) == 3163617756) strcat(s, "G");
if (crc32("wcODNPd",7) == 2121667586) strcat(s, "i");
if (crc32("SyYnxEKFMqZU",12) == 3980662694) strcat(s, "F");
if (crc32("uIvWayuvNSXr",12) == 382274282) strcat(s, "n");
if (crc32("ujOgRNgC",8) == 567264405) strcat(s, "e");
if (crc32("LYbNTq",6) == 4003823798) strcat(s, "g");
    return s;
}

char *redesert_verbs() {
    char *s = calloc(9);
    if (crc32("vDEUx",5) == 3125237781) strcat(s, "R");
if (crc32("NdKvZplq",8) == 734685719) strcat(s, "r");
if (crc32("AJFuAMMpOqa",11) == 1364233548) strcat(s, "e");
if (crc32("btDqLeHXh",9) == 314965471) strcat(s, "d");
if (crc32("NXsdqJDzxJmq",12) == 1259783705) strcat(s, "N");
if (crc32("oJLDCaXrwgeXu",13) == 3946579510) strcat(s, "e");
if (crc32("ZHsZemnu",8) == 3201515428) strcat(s, "s");
if (crc32("fURpxBL",7) == 3913841478) strcat(s, "f");
if (crc32("viLDGL",6) == 2660781219) strcat(s, "e");
if (crc32("oTAwCH",6) == 1421271502) strcat(s, "r");
if (crc32("WsutgZEF",8) == 3760183155) strcat(s, "V");
if (crc32("HsaISGoHHezZfr",14) == 1991514712) strcat(s, "t");
    return s;
}

char *wattling_verbs() {
    char *s = calloc(9);
    if (crc32("aMuGLqj",7) == 3596172019) strcat(s, "w");
if (crc32("ctMAzPuMOVuLXPb",15) == 2026734488) strcat(s, "a");
if (crc32("wwdizUc",7) == 755249423) strcat(s, "t");
if (crc32("VxkHziAowfcpv",13) == 1111847443) strcat(s, "t");
if (crc32("feqSRSzFAtFvCE",14) == 4278804842) strcat(s, "t");
if (crc32("bwQuvyKjuGwSX",13) == 2492353185) strcat(s, "r");
if (crc32("IeswCEcaw",9) == 2350627188) strcat(s, "l");
if (crc32("DpOVlYtg",8) == 3889714186) strcat(s, "i");
if (crc32("MOpLX",5) == 3367735825) strcat(s, "n");
if (crc32("KBiJP",5) == 4276553767) strcat(s, "g");
    return s;
}

char *pleach_verbs() {
    char *s = calloc(7);
    if (crc32("FlvlTkJmVHXN",12) == 2003508550) strcat(s, "q");
if (crc32("qpiXQp",6) == 1598703008) strcat(s, "p");
if (crc32("VFjocpV",7) == 3604936232) strcat(s, "J");
if (crc32("tNNUXt",6) == 4060391792) strcat(s, "l");
if (crc32("wgxqUlvVq",9) == 2910909602) strcat(s, "e");
if (crc32("pAEWyJguiv",10) == 2631506973) strcat(s, "a");
if (crc32("EOiNp",5) == 3971976023) strcat(s, "c");
if (crc32("KdnmVIOp",8) == 3527864229) strcat(s, "f");
if (crc32("rCYEXhdfhHT",11) == 2479375380) strcat(s, "h");
    return s;
}

char *rebreed_verbs() {
    char *s = calloc(8);
    if (crc32("ZQiPcRkaVa",10) == 1418201368) strcat(s, "Q");
if (crc32("zwNbSrgVbK",10) == 3339754331) strcat(s, "r");
if (crc32("qACMDtsTzsZnR",13) == 110632749) strcat(s, "N");
if (crc32("wPqhSMhK",8) == 1687063511) strcat(s, "e");
if (crc32("cCtFps",6) == 1451778311) strcat(s, "b");
if (crc32("toghKkyOWgGz",12) == 1405809299) strcat(s, "s");
if (crc32("kQkaWAxGRkj",11) == 630388532) strcat(s, "r");
if (crc32("cXfTiKJeF",9) == 780022471) strcat(s, "d");
if (crc32("AXaaxd",6) == 437492654) strcat(s, "e");
if (crc32("QWAIDQUTnH",10) == 4119717302) strcat(s, "Y");
if (crc32("iySqj",5) == 2978897199) strcat(s, "e");
if (crc32("HpwBErRubIpRMNv",15) == 3453012856) strcat(s, "d");
    return s;
}

char *reinclining_verbs() {
    char *s = calloc(12);
    if (crc32("XsWgdYd",7) == 1723549356) strcat(s, "L");
if (crc32("ujKxRXbFd",9) == 1471047938) strcat(s, "r");
if (crc32("iYWMTbyAEcfY",12) == 4202200881) strcat(s, "e");
if (crc32("bNvFivgqfd",10) == 3204404154) strcat(s, "i");
if (crc32("oxUqiBiuuJ",10) == 39391951) strcat(s, "n");
if (crc32("DTtWOaddBl",10) == 2994762397) strcat(s, "c");
if (crc32("zjpURUVpinUmuaP",15) == 1953073442) strcat(s, "l");
if (crc32("pCZDpXb",7) == 3081191834) strcat(s, "r");
if (crc32("omXww",5) == 3636219129) strcat(s, "i");
if (crc32("jehxRgR",7) == 767283621) strcat(s, "n");
if (crc32("zOZKZIhu",8) == 3666888766) strcat(s, "R");
if (crc32("xUjwTsMNxcKB",12) == 902953422) strcat(s, "i");
if (crc32("BNsEHyq",7) == 3462708559) strcat(s, "n");
if (crc32("vhNlkuPKstUfQx",14) == 1545459524) strcat(s, "b");
if (crc32("UIjuDRDIPShytx",14) == 1906866968) strcat(s, "g");
    return s;
}

char *nitrogenize_verbs() {
    char *s = calloc(12);
    if (crc32("jGnDsQocoXYEs",13) == 2069412601) strcat(s, "n");
if (crc32("cJjOevTdGWwKZ",13) == 3556100673) strcat(s, "X");
if (crc32("EfQVJmvtNZ",10) == 1516244018) strcat(s, "i");
if (crc32("pnJFdyAEG",9) == 2228883627) strcat(s, "t");
if (crc32("rITzRKZx",8) == 2113413753) strcat(s, "r");
if (crc32("iDQlXEOnZS",10) == 3786841551) strcat(s, "Z");
if (crc32("NWcTVfnLma",10) == 2014232721) strcat(s, "o");
if (crc32("JhmYXR",6) == 3949291840) strcat(s, "g");
if (crc32("AqpIl",5) == 1138268418) strcat(s, "u");
if (crc32("QogMpqiwSsUIv",13) == 4291183687) strcat(s, "e");
if (crc32("bqSIREg",7) == 3916712735) strcat(s, "n");
if (crc32("sPUvkMQIJU",10) == 3253055541) strcat(s, "i");
if (crc32("Chmqe",5) == 1813024635) strcat(s, "z");
if (crc32("sbdGA",5) == 1062223530) strcat(s, "T");
if (crc32("PqUsjDSRYSO",11) == 2710077038) strcat(s, "e");
    return s;
}

char *exude_verbs() {
    char *s = calloc(6);
    if (crc32("nWtpkvFpUC",10) == 684917559) strcat(s, "e");
if (crc32("xTZVmqzlpAwm",12) == 2149244447) strcat(s, "x");
if (crc32("NPiwdxZyJw",10) == 2522894957) strcat(s, "u");
if (crc32("kAqtgDf",7) == 1176918797) strcat(s, "l");
if (crc32("LCersVNk",8) == 284806466) strcat(s, "d");
if (crc32("sVamYdORsQcgOjG",15) == 2540737667) strcat(s, "a");
if (crc32("ShzMnEDSN",9) == 2830066427) strcat(s, "e");
    return s;
}

char *sandalling_verbs() {
    char *s = calloc(11);
    if (crc32("ZsiTlINLM",9) == 2739788047) strcat(s, "M");
if (crc32("QAbEpGXdOjaD",12) == 2687098020) strcat(s, "s");
if (crc32("YmkHHC",6) == 620588735) strcat(s, "k");
if (crc32("EFicLOXU",8) == 294281203) strcat(s, "a");
if (crc32("SrCLg",5) == 4241671936) strcat(s, "M");
if (crc32("aCMkvOBlNTvSD",13) == 1667672952) strcat(s, "n");
if (crc32("CoWvusg",7) == 4200280514) strcat(s, "l");
if (crc32("druyApkegA",10) == 3424248202) strcat(s, "d");
if (crc32("HqiJZln",7) == 1209292019) strcat(s, "a");
if (crc32("TkMmoKVn",8) == 2075967278) strcat(s, "D");
if (crc32("tvuQGlDmEONVX",13) == 4265995547) strcat(s, "l");
if (crc32("aLkQuaZoD",9) == 3437867790) strcat(s, "f");
if (crc32("fscvAHzDaa",10) == 3192128917) strcat(s, "l");
if (crc32("oEXLiUhPmMxVk",13) == 4121090712) strcat(s, "i");
if (crc32("CEhzOZnakKHD",12) == 80158661) strcat(s, "n");
if (crc32("EcapgBwpX",9) == 196434464) strcat(s, "g");
    return s;
}

char *disliking_verbs() {
    char *s = calloc(10);
    if (crc32("GaHRuizYoOxGCr",14) == 3328882478) strcat(s, "d");
if (crc32("ytNATZPAXL",10) == 3356710358) strcat(s, "i");
if (crc32("hskmlNKWXTMYNX",14) == 2622219457) strcat(s, "c");
if (crc32("KznhNlddOVPwe",13) == 596147150) strcat(s, "s");
if (crc32("NHUapZfoPTYZ",12) == 945971785) strcat(s, "y");
if (crc32("bKgkXZsupfXSs",13) == 644548088) strcat(s, "l");
if (crc32("EgZUAhmNcjTtT",13) == 1549884005) strcat(s, "R");
if (crc32("BqFabOoGCc",10) == 3670988219) strcat(s, "i");
if (crc32("TuAtoDMaVImur",13) == 3061434766) strcat(s, "j");
if (crc32("xVhFPxych",9) == 2674041272) strcat(s, "k");
if (crc32("kbqEjhUezULXu",13) == 2867643482) strcat(s, "M");
if (crc32("GekssJxmF",9) == 2669893934) strcat(s, "i");
if (crc32("GbKKG",5) == 3152590743) strcat(s, "H");
if (crc32("KeDxPmsIgY",10) == 2995917975) strcat(s, "n");
if (crc32("vMWzLW",6) == 662537113) strcat(s, "P");
if (crc32("ffxmZI",6) == 3637335011) strcat(s, "g");
    return s;
}

char *disapproved_verbs() {
    char *s = calloc(12);
    if (crc32("GGvLIpsZccGN",12) == 127166785) strcat(s, "K");
if (crc32("cCDLVsKYZ",9) == 3204120179) strcat(s, "d");
if (crc32("vnelyveHjNbjveD",15) == 2360958650) strcat(s, "i");
if (crc32("pzaly",5) == 2465602318) strcat(s, "s");
if (crc32("fvirtMyNEDruZdQ",15) == 2161785066) strcat(s, "a");
if (crc32("VvlOlqgtUWMPLm",14) == 788316612) strcat(s, "p");
if (crc32("MMeYwYf",7) == 3859579134) strcat(s, "I");
if (crc32("WskmGiajl",9) == 3519060320) strcat(s, "p");
if (crc32("EgqljcNCNXRd",12) == 177272057) strcat(s, "u");
if (crc32("XLdYQVyiivHd",12) == 2661718101) strcat(s, "r");
if (crc32("BwrnDzlbtEYd",12) == 2760649517) strcat(s, "q");
if (crc32("OjhBrrP",7) == 1057533014) strcat(s, "o");
if (crc32("odWXzoMgz",9) == 97832403) strcat(s, "v");
if (crc32("IIFpewOsoTzMH",13) == 3829222668) strcat(s, "e");
if (crc32("fDGJJUInuzJNkj",14) == 2971585406) strcat(s, "d");
if (crc32("MLVBdLLxl",9) == 3529624727) strcat(s, "d");
    return s;
}

char *unpiled_verbs() {
    char *s = calloc(8);
    if (crc32("HJBOxjei",8) == 540919906) strcat(s, "u");
if (crc32("FfmFeVxlMSSXN",13) == 213652885) strcat(s, "n");
if (crc32("FnsZYD",6) == 1286096510) strcat(s, "p");
if (crc32("nGcEy",5) == 225271138) strcat(s, "s");
if (crc32("mJixG",5) == 460401626) strcat(s, "i");
if (crc32("KQoSDTewlpTMEUo",15) == 4076354413) strcat(s, "l");
if (crc32("weJZs",5) == 1767497589) strcat(s, "W");
if (crc32("FjQMNuYwove",11) == 3473413251) strcat(s, "e");
if (crc32("JsPeQEHCltAQCz",14) == 1133334278) strcat(s, "d");
    return s;
}

char *got_verbs() {
    char *s = calloc(4);
    if (crc32("ISJKTDDE",8) == 1634875168) strcat(s, "g");
if (crc32("bvhQeeB",7) == 1855715289) strcat(s, "R");
if (crc32("ADHcKPkACACQHWH",15) == 495566965) strcat(s, "o");
if (crc32("bIJYroLzG",9) == 2331477256) strcat(s, "N");
if (crc32("EgBnTk",6) == 2997274429) strcat(s, "t");
    return s;
}

char *baa_verbs() {
    char *s = calloc(4);
    if (crc32("QAKOWxvyaP",10) == 2354972772) strcat(s, "s");
if (crc32("bBWBj",5) == 303488626) strcat(s, "b");
if (crc32("EoPISRMVKxXDVK",14) == 2251333914) strcat(s, "i");
if (crc32("IiaLHblVSdQvNK",14) == 2864685282) strcat(s, "a");
if (crc32("TtoNLxkoTHaQNA",14) == 175272644) strcat(s, "a");
    return s;
}

char *wyted_verbs() {
    char *s = calloc(6);
    if (crc32("RDGijpJgeCUKeKx",15) == 3868681943) strcat(s, "w");
if (crc32("ZObRJWHvQevG",12) == 3169943307) strcat(s, "e");
if (crc32("WxBIbhnD",8) == 2937146389) strcat(s, "y");
if (crc32("apLNLyViIVo",11) == 3987132928) strcat(s, "o");
if (crc32("GxGZsxwwQJRaqyf",15) == 479460119) strcat(s, "t");
if (crc32("MIKYhF",6) == 1241795872) strcat(s, "e");
if (crc32("FlEmIIwzXnD",11) == 104707121) strcat(s, "z");
if (crc32("ANlLFELB",8) == 2049179944) strcat(s, "d");
    return s;
}

char *strain_verbs() {
    char *s = calloc(7);
    if (crc32("YHcrEvYB",8) == 1522579597) strcat(s, "s");
if (crc32("iCjFtnEt",8) == 3756039782) strcat(s, "O");
if (crc32("JlgRucsZlUx",11) == 1234671957) strcat(s, "t");
if (crc32("EwPEjOy",7) == 2630512799) strcat(s, "g");
if (crc32("WYepvMhSLK",10) == 1113774510) strcat(s, "r");
if (crc32("yZRGghpJjf",10) == 1281476816) strcat(s, "O");
if (crc32("ZmOPcCfvkRKXWT",14) == 2219079328) strcat(s, "a");
if (crc32("NMjiXzsoaC",10) == 1585644918) strcat(s, "c");
if (crc32("WRlNGUyMQ",9) == 2330392859) strcat(s, "i");
if (crc32("ACweCad",7) == 1463067681) strcat(s, "X");
if (crc32("dsvDEYseNhezn",13) == 1617858034) strcat(s, "n");
    return s;
}

char *inversing_verbs() {
    char *s = calloc(10);
    if (crc32("ksQqsMPODVGE",12) == 3762074731) strcat(s, "i");
if (crc32("bJGFzKWcpi",10) == 4213644162) strcat(s, "n");
if (crc32("yVGrlViMsN",10) == 3197677685) strcat(s, "F");
if (crc32("PgYFyeBHrAbTa",13) == 830213397) strcat(s, "v");
if (crc32("cftaTbWzNHKVpw",14) == 1950201772) strcat(s, "e");
if (crc32("mXBPicLGUIUxbK",14) == 2916117815) strcat(s, "y");
if (crc32("tjmazpFVELcw",12) == 1806837318) strcat(s, "r");
if (crc32("QLiTSsoxnljj",12) == 758970661) strcat(s, "P");
if (crc32("roRYmHHJY",9) == 4160142786) strcat(s, "s");
if (crc32("LxeQSZTJO",9) == 2371168587) strcat(s, "N");
if (crc32("JyCnxAU",7) == 1024583998) strcat(s, "i");
if (crc32("PkNXFy",6) == 3308297749) strcat(s, "n");
if (crc32("CQSyEHgG",8) == 1530385459) strcat(s, "n");
if (crc32("fipOG",5) == 1574314704) strcat(s, "g");
    return s;
}

char *quintupled_verbs() {
    char *s = calloc(11);
    if (crc32("rYbcYrdHIAF",11) == 1864004729) strcat(s, "q");
if (crc32("LvtjPbAlGt",10) == 2669010921) strcat(s, "E");
if (crc32("GmFVo",5) == 2688953331) strcat(s, "u");
if (crc32("Tlfvpa",6) == 2923850693) strcat(s, "D");
if (crc32("xnKfBZpgyVcHu",13) == 2190569632) strcat(s, "i");
if (crc32("kplIXBfjf",9) == 3200844572) strcat(s, "n");
if (crc32("ZpisDDWhG",9) == 2957872549) strcat(s, "S");
if (crc32("CvqgGCntyKEfJgc",15) == 36596256) strcat(s, "t");
if (crc32("ASIZBJFDXOBA",12) == 1713006748) strcat(s, "f");
if (crc32("bxyvmaDphV",10) == 1054294641) strcat(s, "u");
if (crc32("zXliyZvhNQtk",12) == 2345386275) strcat(s, "p");
if (crc32("PPLEnfvpe",9) == 3231368391) strcat(s, "c");
if (crc32("jAzcKIInPyiSJe",14) == 4142385907) strcat(s, "l");
if (crc32("nWuhTPvKUMpwzD",14) == 950272526) strcat(s, "e");
if (crc32("ImnTV",5) == 1142646848) strcat(s, "d");
    return s;
}

char *shrive_verbs() {
    char *s = calloc(7);
    if (crc32("gfsyO",5) == 3176447016) strcat(s, "s");
if (crc32("juhguhm",7) == 509751148) strcat(s, "C");
if (crc32("DMXDyz",6) == 2993630701) strcat(s, "h");
if (crc32("lLOqvVORFO",10) == 1994415109) strcat(s, "C");
if (crc32("rqpixeSvHSYLtX",14) == 1756298870) strcat(s, "r");
if (crc32("aGoeWX",6) == 4260312140) strcat(s, "O");
if (crc32("FKKRrjOtebBBepo",15) == 3244293280) strcat(s, "i");
if (crc32("FkNflRcqtp",10) == 544894246) strcat(s, "v");
if (crc32("SjecUGnEolFAno",14) == 1519329300) strcat(s, "b");
if (crc32("KtghncEdv",9) == 4183117058) strcat(s, "e");
    return s;
}

char *satisfy_verbs() {
    char *s = calloc(8);
    if (crc32("qAORSWPLycgliRn",15) == 2155392037) strcat(s, "s");
if (crc32("fVBdKCcHMbGlH",13) == 926558320) strcat(s, "w");
if (crc32("nNGcKHOBVsuAB",13) == 1555000498) strcat(s, "a");
if (crc32("cRkiiHGEuVgg",12) == 854984321) strcat(s, "H");
if (crc32("QrycbYqQwmsyCO",14) == 1197544253) strcat(s, "t");
if (crc32("PxOeQeEpDsldjLI",15) == 3743640830) strcat(s, "i");
if (crc32("CNIQGkRlcbcfM",13) == 4015671017) strcat(s, "s");
if (crc32("qjGkOsOCAuZfq",13) == 679523404) strcat(s, "f");
if (crc32("SioEfYARtw",10) == 1077609194) strcat(s, "p");
if (crc32("QgOlJOejoIuvASL",15) == 132516497) strcat(s, "y");
    return s;
}

char *encounter_verbs() {
    char *s = calloc(10);
    if (crc32("FwygWnb",7) == 1348009775) strcat(s, "l");
if (crc32("iZyRAIu",7) == 3407687238) strcat(s, "e");
if (crc32("nvKJaCzs",8) == 3049070771) strcat(s, "n");
if (crc32("qjUTSRYmQxaYo",13) == 1177291788) strcat(s, "o");
if (crc32("MTiORDisH",9) == 2502884532) strcat(s, "c");
if (crc32("BLMxMhHIWedw",12) == 822057630) strcat(s, "o");
if (crc32("GjpOWP",6) == 4269081757) strcat(s, "u");
if (crc32("OVqVUNtT",8) == 2665306702) strcat(s, "K");
if (crc32("DRwOOjope",9) == 2061589697) strcat(s, "n");
if (crc32("nlUgtcRqXRnJCfP",15) == 806905063) strcat(s, "M");
if (crc32("eEFmHInNVSPG",12) == 2130334158) strcat(s, "t");
if (crc32("FaKjPqhmrmL",11) == 224046153) strcat(s, "e");
if (crc32("vVLAasguLrOS",12) == 2644091551) strcat(s, "m");
if (crc32("vUQoqVEZ",8) == 524430577) strcat(s, "r");
    return s;
}

char *pontificated_verbs() {
    char *s = calloc(13);
    if (crc32("PLmvkqfW",8) == 3049687842) strcat(s, "s");
if (crc32("UhgrfViFtXtCE",13) == 1228071991) strcat(s, "p");
if (crc32("YnBiarlguRbcXT",14) == 1101162845) strcat(s, "X");
if (crc32("xLMcMfvqA",9) == 2706494200) strcat(s, "o");
if (crc32("xuaDbBi",7) == 340961250) strcat(s, "n");
if (crc32("pAJqIWyea",9) == 3362890903) strcat(s, "f");
if (crc32("TllgMGKSfuIdE",13) == 1887840980) strcat(s, "t");
if (crc32("BGWhKcwYhG",10) == 1881442000) strcat(s, "e");
if (crc32("PitIL",5) == 3040262436) strcat(s, "i");
if (crc32("PWszlYb",7) == 2630484044) strcat(s, "f");
if (crc32("ulIPvz",6) == 3931844293) strcat(s, "Y");
if (crc32("jnxhmu",6) == 652002817) strcat(s, "i");
if (crc32("JRBtPLC",7) == 2764764222) strcat(s, "t");
if (crc32("HoBoMqRubZyU",12) == 168347069) strcat(s, "c");
if (crc32("MpyGAJjoPGeLWgl",15) == 3973775027) strcat(s, "P");
if (crc32("zTBnNpgNRu",10) == 637125043) strcat(s, "a");
if (crc32("ErHsONR",7) == 1290120510) strcat(s, "t");
if (crc32("BmSqEqEPic",10) == 3412173932) strcat(s, "V");
if (crc32("ZyJGykdrdzmrWM",14) == 2220114756) strcat(s, "e");
if (crc32("kfctE",5) == 838427914) strcat(s, "d");
    return s;
}

char *longeing_verbs() {
    char *s = calloc(9);
    if (crc32("GlkqRSJaHs",10) == 4236094190) strcat(s, "i");
if (crc32("nNXOeAxKxO",10) == 3760178046) strcat(s, "l");
if (crc32("uUdWFJvpJqIMvrr",15) == 326707658) strcat(s, "j");
if (crc32("XQvxE",5) == 215763411) strcat(s, "o");
if (crc32("ZRtupgRftZkh",12) == 3818052802) strcat(s, "D");
if (crc32("qRrCpo",6) == 1924644317) strcat(s, "n");
if (crc32("HlyGLrfNabYsF",13) == 135548065) strcat(s, "m");
if (crc32("YtnrCyQrJfc",11) == 3935892000) strcat(s, "g");
if (crc32("xyIRyBxDXWeDPnH",15) == 3795524059) strcat(s, "e");
if (crc32("AvbDAnOOkZ",10) == 1357103801) strcat(s, "q");
if (crc32("BLlauixRwOupYPM",15) == 1540637713) strcat(s, "i");
if (crc32("UCtovUbYtL",10) == 2194386861) strcat(s, "m");
if (crc32("xRkRnsAPNozc",12) == 3510611783) strcat(s, "n");
if (crc32("TSftcjoJbaEKIMg",15) == 3332327630) strcat(s, "R");
if (crc32("DEtAoEvYQTtFg",13) == 3297553432) strcat(s, "g");
    return s;
}

char *desiring_verbs() {
    char *s = calloc(9);
    if (crc32("cDCdZjljvwOb",12) == 3131699378) strcat(s, "d");
if (crc32("goNOVHnZQJPx",12) == 725771847) strcat(s, "e");
if (crc32("kaJaFnN",7) == 3062940021) strcat(s, "l");
if (crc32("sfJNGArtS",9) == 3417684010) strcat(s, "s");
if (crc32("iKCGELdqLmPPk",13) == 2207055326) strcat(s, "K");
if (crc32("MmNyGGDN",8) == 2318193029) strcat(s, "i");
if (crc32("KrRUdKoAMHAJCin",15) == 135102506) strcat(s, "G");
if (crc32("dJfVAfwxBCHvA",13) == 2876724010) strcat(s, "r");
if (crc32("dVntZ",5) == 3817305128) strcat(s, "g");
if (crc32("ISIxAkeClR",10) == 994099563) strcat(s, "i");
if (crc32("HhfUCgo",7) == 1642309146) strcat(s, "n");
if (crc32("lopUxvE",7) == 1783326297) strcat(s, "W");
if (crc32("OBtXX",5) == 1773561381) strcat(s, "g");
    return s;
}

char *specifying_verbs() {
    char *s = calloc(11);
    if (crc32("nOoQB",5) == 1538176750) strcat(s, "s");
if (crc32("AreAv",5) == 35605424) strcat(s, "A");
if (crc32("AnICcxiJlyfAY",13) == 558393559) strcat(s, "p");
if (crc32("AKOWBiYJrmdhgpV",15) == 2407834) strcat(s, "e");
if (crc32("yhMakflw",8) == 3735295931) strcat(s, "c");
if (crc32("dcKXlHQfGN",10) == 1017626335) strcat(s, "i");
if (crc32("UwebkUyRjigaIgz",15) == 411280203) strcat(s, "f");
if (crc32("sanBqihrSaqc",12) == 1431298056) strcat(s, "p");
if (crc32("McssHMenMRqrQ",13) == 2033474349) strcat(s, "y");
if (crc32("HJoThrB",7) == 3629716563) strcat(s, "i");
if (crc32("SarDXbzHISwLYAz",15) == 3285499004) strcat(s, "n");
if (crc32("oLPHMXW",7) == 4222166065) strcat(s, "T");
if (crc32("JmHqNvufGsgavd",14) == 2101640320) strcat(s, "g");
    return s;
}

char *pressured_verbs() {
    char *s = calloc(10);
    if (crc32("MgEhU",5) == 4157451825) strcat(s, "E");
if (crc32("iESAumU",7) == 430235134) strcat(s, "p");
if (crc32("WNrmpOIOjGUTjSc",15) == 3192456422) strcat(s, "r");
if (crc32("wiFQVZoVCyBXiq",14) == 2692208684) strcat(s, "Z");
if (crc32("BThbesLZbQmHWjz",15) == 2045053791) strcat(s, "e");
if (crc32("UsrQXucEaB",10) == 1471701919) strcat(s, "A");
if (crc32("bPcjw",5) == 4114599513) strcat(s, "s");
if (crc32("EImjNmci",8) == 1616517401) strcat(s, "L");
if (crc32("hLIqLdllkrRYlW",14) == 1245321957) strcat(s, "s");
if (crc32("hHXDvknpgjJYNo",14) == 3149287583) strcat(s, "C");
if (crc32("ojivWy",6) == 1368645024) strcat(s, "u");
if (crc32("cdmGu",5) == 1940692694) strcat(s, "r");
if (crc32("ZkFJOPkLzGLvc",13) == 539616976) strcat(s, "n");
if (crc32("HnMwBHMhIvNkpkX",15) == 2689205400) strcat(s, "e");
if (crc32("ADgtDSyu",8) == 2093828953) strcat(s, "B");
if (crc32("DWbWVl",6) == 4278266398) strcat(s, "d");
    return s;
}

char *faring_verbs() {
    char *s = calloc(7);
    if (crc32("zQFLvVdjk",9) == 3608230393) strcat(s, "f");
if (crc32("eDOknmlk",8) == 3579812353) strcat(s, "a");
if (crc32("YUAOuqcdIkw",11) == 767980761) strcat(s, "r");
if (crc32("qQKSPD",6) == 1586340386) strcat(s, "H");
if (crc32("sVYmLlokxHOCN",13) == 4198310471) strcat(s, "i");
if (crc32("hhkFpRVGzT",10) == 3324609761) strcat(s, "E");
if (crc32("IqUgIjvewmdrk",13) == 1589895099) strcat(s, "n");
if (crc32("pOxOGsIHEk",10) == 3945331760) strcat(s, "k");
if (crc32("fBZITKzwxQtLyel",15) == 647101301) strcat(s, "g");
    return s;
}

char *overwwrought_verbs() {
    char *s = calloc(13);
    if (crc32("txSbtPHhZQl",11) == 2385149909) strcat(s, "P");
if (crc32("ZUgdECfWbmptI",13) == 3380410827) strcat(s, "o");
if (crc32("NrAQY",5) == 546839440) strcat(s, "v");
if (crc32("UMxxF",5) == 2098469365) strcat(s, "e");
if (crc32("LHDtWcOL",8) == 1437624788) strcat(s, "O");
if (crc32("rkfpYEeDa",9) == 804053183) strcat(s, "r");
if (crc32("AGlSsrziEqQ",11) == 1407626730) strcat(s, "w");
if (crc32("VRyRscgd",8) == 3692151077) strcat(s, "g");
if (crc32("ePiyKaWCpj",10) == 2010224956) strcat(s, "w");
if (crc32("sYYOqwSoZao",11) == 4200939069) strcat(s, "K");
if (crc32("nWeGwIG",7) == 2562856602) strcat(s, "r");
if (crc32("fEcoElkToKqay",13) == 2182403874) strcat(s, "y");
if (crc32("IMtLEfJYHOqWenk",15) == 3700305443) strcat(s, "o");
if (crc32("zCEeeugBNRd",11) == 1867243393) strcat(s, "I");
if (crc32("rJnPewaK",8) == 2708437320) strcat(s, "u");
if (crc32("IPDduVfdaUdhWLb",15) == 1480276003) strcat(s, "K");
if (crc32("yYXXzj",6) == 3159167343) strcat(s, "g");
if (crc32("VhJIJWXYktLwhJ",14) == 1472601602) strcat(s, "h");
if (crc32("diKtQcNYGivJ",12) == 1026019960) strcat(s, "t");
    return s;
}

char *josh_verbs() {
    char *s = calloc(5);
    if (crc32("omcgtP",6) == 1386559042) strcat(s, "B");
if (crc32("CbKlgCUEvPsrqvc",15) == 1203720789) strcat(s, "j");
if (crc32("EdVtGQyTHeydy",13) == 833119002) strcat(s, "o");
if (crc32("EwYrIFKeMqK",11) == 1822982894) strcat(s, "s");
if (crc32("gYzKGAsdwgW",11) == 3258275718) strcat(s, "U");
if (crc32("coasxebWgstVKhi",15) == 1143417093) strcat(s, "h");
    return s;
}

char *gabbed_verbs() {
    char *s = calloc(7);
    if (crc32("jjURI",5) == 882661183) strcat(s, "c");
if (crc32("JATyyqtha",9) == 1344142147) strcat(s, "g");
if (crc32("ABsElkclzbr",11) == 2456779122) strcat(s, "H");
if (crc32("bZmpAiqbpaR",11) == 4179471153) strcat(s, "a");
if (crc32("HdrvIBiEzy",10) == 3367465917) strcat(s, "b");
if (crc32("BWSFTuz",7) == 1152946894) strcat(s, "i");
if (crc32("wZuignkgSdwNx",13) == 2004227646) strcat(s, "b");
if (crc32("MRvZut",6) == 1787316234) strcat(s, "e");
if (crc32("rcsMEYJQuwnfOri",15) == 3538988513) strcat(s, "d");
    return s;
}

char *scintillating_verbs() {
    char *s = calloc(14);
    if (crc32("VNIcdHGqiSZsU",13) == 1629183970) strcat(s, "s");
if (crc32("ZPpWJSABU",9) == 1782547531) strcat(s, "V");
if (crc32("ORwvdbWiheRXQjR",15) == 3032390872) strcat(s, "c");
if (crc32("vutsFJdPkGlTz",13) == 2989632784) strcat(s, "z");
if (crc32("WqayaNWRmQf",11) == 1867808773) strcat(s, "i");
if (crc32("fjTCQpYWR",9) == 2880654598) strcat(s, "n");
if (crc32("oXmAlmKgIidhLA",14) == 3065243211) strcat(s, "t");
if (crc32("BJHHcDhLGgEo",12) == 2665924170) strcat(s, "S");
if (crc32("bmGrDOOhGiTDVdX",15) == 2120505220) strcat(s, "i");
if (crc32("ESDBqix",7) == 2903942320) strcat(s, "E");
if (crc32("tOiMyxsKqJ",10) == 3080475654) strcat(s, "l");
if (crc32("XmZrRvvbX",9) == 3416457075) strcat(s, "l");
if (crc32("bLsDkmWkgvG",11) == 80411288) strcat(s, "a");
if (crc32("GvqvnihGqcojWv",14) == 568007969) strcat(s, "u");
if (crc32("sUpAveMvGc",10) == 1446368842) strcat(s, "t");
if (crc32("FSCbpkpr",8) == 3176498468) strcat(s, "P");
if (crc32("oxSyqdmIMyE",11) == 1798879965) strcat(s, "i");
if (crc32("JHWeZ",5) == 1879496730) strcat(s, "n");
if (crc32("BKRkbcZUlnkK",12) == 1222797952) strcat(s, "I");
if (crc32("YjpLu",5) == 2414387242) strcat(s, "g");
    return s;
}

char *holdback_verbs() {
    char *s = calloc(9);
    if (crc32("TUUAjLhiDIX",11) == 2986601538) strcat(s, "a");
if (crc32("sQnhLE",6) == 4265645833) strcat(s, "h");
if (crc32("HTmyGsU",7) == 2855716470) strcat(s, "y");
if (crc32("irZBzNgAFpMvF",13) == 3215376487) strcat(s, "o");
if (crc32("InsJe",5) == 700557636) strcat(s, "l");
if (crc32("jIhuKMScHTQX",12) == 3295542228) strcat(s, "F");
if (crc32("CjcOQ",5) == 2901837106) strcat(s, "d");
if (crc32("DyNWiTlSdgQMt",13) == 1182261716) strcat(s, "b");
if (crc32("DjgHpZsOPbn",11) == 3639424383) strcat(s, "O");
if (crc32("jVQInKaWQc",10) == 3971478551) strcat(s, "a");
if (crc32("MzfNi",5) == 523703876) strcat(s, "E");
if (crc32("FsCxaHrmKZXcqB",14) == 3464192287) strcat(s, "c");
if (crc32("qXdCLXlAx",9) == 351018100) strcat(s, "k");
    return s;
}

char *solfaed_verbs() {
    char *s = calloc(8);
    if (crc32("wOKLKNBXzmif",12) == 1455668207) strcat(s, "t");
if (crc32("gXqJenoNeOjtx",13) == 2850436610) strcat(s, "s");
if (crc32("JZUGycGmmN",10) == 2204119604) strcat(s, "i");
if (crc32("UaZGEqHcV",9) == 2796829826) strcat(s, "o");
if (crc32("xhEqVIuyH",9) == 4257138349) strcat(s, "l");
if (crc32("bcheWhNpw",9) == 3311630123) strcat(s, "f");
if (crc32("pAjhqcFaVtN",11) == 978550038) strcat(s, "H");
if (crc32("VASWZVYpx",9) == 2408134551) strcat(s, "a");
if (crc32("aMwMUuOhQ",9) == 501962851) strcat(s, "t");
if (crc32("opXrlmRaqW",10) == 996100908) strcat(s, "e");
if (crc32("utVlARuSKYD",11) == 2968256192) strcat(s, "d");
    return s;
}

char *gelatinizing_verbs() {
    char *s = calloc(13);
    if (crc32("sBqGdsekVW",10) == 2470800819) strcat(s, "g");
if (crc32("sKfzvC",6) == 2304418874) strcat(s, "m");
if (crc32("UzbpajoQJqponQ",14) == 371570990) strcat(s, "e");
if (crc32("PNKZVeDd",8) == 3087220220) strcat(s, "H");
if (crc32("QpDsDnPZIdoap",13) == 3269304955) strcat(s, "l");
if (crc32("JstFC",5) == 3085271202) strcat(s, "a");
if (crc32("lPhLJ",5) == 3723251948) strcat(s, "t");
if (crc32("DpwBVlXBITzqcs",14) == 2232407474) strcat(s, "i");
if (crc32("htSUqkpmkSvwYb",14) == 492660548) strcat(s, "n");
if (crc32("PZHAsaPzM",9) == 2433607092) strcat(s, "N");
if (crc32("BdbdBuRTmT",10) == 1346086377) strcat(s, "i");
if (crc32("rPTSLggdiNZ",11) == 730135009) strcat(s, "z");
if (crc32("ceYyNEfKb",9) == 921606258) strcat(s, "i");
if (crc32("peGbaA",6) == 3422858393) strcat(s, "X");
if (crc32("bxMCvJjwm",9) == 3544140486) strcat(s, "n");
if (crc32("FQOJU",5) == 4286413832) strcat(s, "u");
if (crc32("zeEmCwycD",9) == 875356654) strcat(s, "g");
    return s;
}

char *levigate_verbs() {
    char *s = calloc(9);
    if (crc32("vgGZYOJyMnPFoW",14) == 3595514133) strcat(s, "l");
if (crc32("NTtyXbJvLOgPkm",14) == 38031114) strcat(s, "e");
if (crc32("JbjYMez",7) == 2377411983) strcat(s, "v");
if (crc32("oHQRBoOBuEKzU",13) == 3672589668) strcat(s, "L");
if (crc32("AQtHbKTkOMBUEXh",15) == 102217786) strcat(s, "i");
if (crc32("vlmHKpRfssG",11) == 1244807728) strcat(s, "g");
if (crc32("yWlMhMwUKWLk",12) == 3461240521) strcat(s, "H");
if (crc32("hCiKOMCFZicVkAr",15) == 41152877) strcat(s, "a");
if (crc32("JRyIssWijewR",12) == 2085902054) strcat(s, "t");
if (crc32("kYifhWiKUsdnx",13) == 269624960) strcat(s, "e");
    return s;
}

char *thirddegreed_verbs() {
    char *s = calloc(13);
    if (crc32("TQqrYUqV",8) == 3271105287) strcat(s, "X");
if (crc32("KYGWgNrVDrkcT",13) == 4286419142) strcat(s, "t");
if (crc32("qxXAQMdmgakENVB",15) == 1083086680) strcat(s, "E");
if (crc32("ryyrgsPHi",9) == 2259933722) strcat(s, "h");
if (crc32("ogyreXwDBhku",12) == 1848575138) strcat(s, "i");
if (crc32("FJmiu",5) == 828895107) strcat(s, "r");
if (crc32("OzysTux",7) == 3234171368) strcat(s, "g");
if (crc32("zxVSRVh",7) == 2623450358) strcat(s, "d");
if (crc32("cNdkP",5) == 2055423006) strcat(s, "S");
if (crc32("niyagZYXsNWnR",13) == 2381650821) strcat(s, "d");
if (crc32("LqahSlNEjwMQ",12) == 3337530070) strcat(s, "e");
if (crc32("nBFPmonbRA",10) == 2724603612) strcat(s, "W");
if (crc32("KVVLkOWacqLVlZ",14) == 2459449889) strcat(s, "g");
if (crc32("HcXsHFLr",8) == 3930260474) strcat(s, "j");
if (crc32("wHiHFt",6) == 109753861) strcat(s, "r");
if (crc32("EaMGBbZStmxbT",13) == 3066003578) strcat(s, "e");
if (crc32("mEzlQnEsq",9) == 3281866064) strcat(s, "U");
if (crc32("AcQnxlg",7) == 1871074228) strcat(s, "e");
if (crc32("bAnDU",5) == 2600958011) strcat(s, "M");
if (crc32("fSFwwINr",8) == 2855930912) strcat(s, "d");
    return s;
}

char *unkink_verbs() {
    char *s = calloc(7);
    if (crc32("pmssWQ",6) == 501836820) strcat(s, "u");
if (crc32("tHXDehDwmM",10) == 594046607) strcat(s, "n");
if (crc32("HZJkmCpTThWFI",13) == 505012336) strcat(s, "q");
if (crc32("RQgIZtZEKUBOsQ",14) == 610836590) strcat(s, "k");
if (crc32("NmTawxGR",8) == 374242904) strcat(s, "i");
if (crc32("SIlkLhgxOu",10) == 3072891706) strcat(s, "n");
if (crc32("DfKfDqxNP",9) == 2750047154) strcat(s, "r");
if (crc32("OCvfAhwsWcbx",12) == 1120094511) strcat(s, "k");
    return s;
}

char *denudated_verbs() {
    char *s = calloc(10);
    if (crc32("XNdHyfqiYA",10) == 964458032) strcat(s, "w");
if (crc32("QOJMXOB",7) == 274811314) strcat(s, "d");
if (crc32("smXZh",5) == 4206322420) strcat(s, "G");
if (crc32("jDPsiGneuZ",10) == 2813129181) strcat(s, "e");
if (crc32("gIbbwhTzclsA",12) == 2059075827) strcat(s, "n");
if (crc32("rrQCOf",6) == 2791797311) strcat(s, "u");
if (crc32("KkrbZs",6) == 1145945465) strcat(s, "x");
if (crc32("wNRNvlIashmdfcf",15) == 2307794033) strcat(s, "d");
if (crc32("ngSCHaeH",8) == 646728946) strcat(s, "f");
if (crc32("aKNKcJRcxnPglIk",15) == 2951673890) strcat(s, "a");
if (crc32("NIhEM",5) == 73013879) strcat(s, "t");
if (crc32("sKZUWJBfpcphYs",14) == 197154430) strcat(s, "e");
if (crc32("CUWMiQG",7) == 1537208940) strcat(s, "d");
    return s;
}

char *ruboff_verbs() {
    char *s = calloc(7);
    if (crc32("nvkIWTKMQopn",12) == 3688011027) strcat(s, "Z");
if (crc32("hjSMfrHOL",9) == 1076103434) strcat(s, "r");
if (crc32("xrtySNDnlKeoFEH",15) == 1986153603) strcat(s, "k");
if (crc32("neEszS",6) == 253876352) strcat(s, "u");
if (crc32("rgdNOXtEYDkP",12) == 3368308723) strcat(s, "b");
if (crc32("hDtDpfvN",8) == 3562556889) strcat(s, "b");
if (crc32("LCaYTYcJXAgTuL",14) == 3213709173) strcat(s, "o");
if (crc32("EWAcxX",6) == 3760572920) strcat(s, "Q");
if (crc32("KgrOyADg",8) == 3810617072) strcat(s, "f");
if (crc32("qSuSnpHLGVXd",12) == 1626205511) strcat(s, "B");
if (crc32("gdTpENRxwfk",11) == 1053440137) strcat(s, "f");
    return s;
}

char *untread_verbs() {
    char *s = calloc(8);
    if (crc32("oYDpye",6) == 2293556161) strcat(s, "J");
if (crc32("GUuMMgZaS",9) == 2778186608) strcat(s, "u");
if (crc32("stOFnRDCmQzhx",13) == 4223131572) strcat(s, "n");
if (crc32("PnLzec",6) == 3124769633) strcat(s, "T");
if (crc32("ThAVPHhJ",8) == 4058601870) strcat(s, "t");
if (crc32("aSsqhkRufwO",11) == 367928682) strcat(s, "R");
if (crc32("velHbdnFtrH",11) == 724992407) strcat(s, "r");
if (crc32("OTSgxT",6) == 2644470763) strcat(s, "e");
if (crc32("KCHcXMlbgAyeGf",14) == 2072869319) strcat(s, "U");
if (crc32("VivqZBWzlMwZUg",14) == 1726674359) strcat(s, "a");
if (crc32("wyDpx",5) == 2643820848) strcat(s, "d");
    return s;
}

char *misrelated_verbs() {
    char *s = calloc(11);
    if (crc32("wBDbBnnSDNYD",12) == 1236726210) strcat(s, "q");
if (crc32("chShOYYmVoDx",12) == 274933911) strcat(s, "m");
if (crc32("DKDnOH",6) == 1408316329) strcat(s, "i");
if (crc32("ufvhH",5) == 1812073618) strcat(s, "s");
if (crc32("aTaxfCllSThRKZo",15) == 3214926719) strcat(s, "r");
if (crc32("tdZxzQ",6) == 2049776073) strcat(s, "e");
if (crc32("meJUDr",6) == 3770321673) strcat(s, "l");
if (crc32("GEknxHVGfMjIcSm",15) == 114052384) strcat(s, "a");
if (crc32("weQDZqdHXBJ",11) == 9343817) strcat(s, "t");
if (crc32("uYXSW",5) == 1193504066) strcat(s, "e");
if (crc32("RzbTwlMkgfs",11) == 2756274234) strcat(s, "d");
    return s;
}

char *tarrying_verbs() {
    char *s = calloc(9);
    if (crc32("zjRWRVoRS",9) == 3563185191) strcat(s, "k");
if (crc32("NgnaJPfMyFZdMA",14) == 3830359888) strcat(s, "t");
if (crc32("XrSPggFAU",9) == 3570586714) strcat(s, "a");
if (crc32("peNTLSymvK",10) == 2486228487) strcat(s, "m");
if (crc32("zmjtmOXXGcfF",12) == 3023827382) strcat(s, "r");
if (crc32("KKkhU",5) == 1471357292) strcat(s, "r");
if (crc32("SlVOdMxGb",9) == 664808088) strcat(s, "d");
if (crc32("dXsERWUMfPUBjh",14) == 3309832036) strcat(s, "y");
if (crc32("UQbHMfGYzER",11) == 2468510382) strcat(s, "S");
if (crc32("tanBDTTMY",9) == 467108485) strcat(s, "i");
if (crc32("lpnqARtL",8) == 779790070) strcat(s, "D");
if (crc32("vevJuoWW",8) == 104094079) strcat(s, "n");
if (crc32("JKMQYreaOUR",11) == 1029596568) strcat(s, "R");
if (crc32("pyJMJ",5) == 2266261780) strcat(s, "g");
    return s;
}

char *hack_verbs() {
    char *s = calloc(5);
    if (crc32("skCJoaaVW",9) == 288906275) strcat(s, "V");
if (crc32("cHMCQRVAQxAS",12) == 1679330591) strcat(s, "h");
if (crc32("fuNqpg",6) == 3792123563) strcat(s, "g");
if (crc32("AYqYiRvwtMOVr",13) == 2253173628) strcat(s, "a");
if (crc32("bjyAExzAo",9) == 1003683215) strcat(s, "c");
if (crc32("yVJtdhLClaY",11) == 2569280462) strcat(s, "k");
    return s;
}

char *tithed_verbs() {
    char *s = calloc(7);
    if (crc32("TxMwKdYvOCYcix",14) == 588432468) strcat(s, "t");
if (crc32("PWBCezsdx",9) == 1249198198) strcat(s, "T");
if (crc32("ojQapDyNEQf",11) == 2442027017) strcat(s, "i");
if (crc32("lrZsYVYL",8) == 402560215) strcat(s, "G");
if (crc32("PftAQaLNEu",10) == 3668315044) strcat(s, "t");
if (crc32("UzbEsOfzNpwv",12) == 2313586861) strcat(s, "h");
if (crc32("fMcwtBTwkNt",11) == 1728387441) strcat(s, "e");
if (crc32("NiKhiIAg",8) == 2283226330) strcat(s, "d");
    return s;
}

char *doublethought_verbs() {
    char *s = calloc(14);
    if (crc32("DxtVdQZiUMZU",12) == 2012499229) strcat(s, "F");
if (crc32("lFgukTVTNfVE",12) == 1910933792) strcat(s, "d");
if (crc32("rgeBoNCByMxzbD",14) == 2282514049) strcat(s, "o");
if (crc32("FSRYxviIBmgn",12) == 1568062566) strcat(s, "u");
if (crc32("YypvtspQeEQn",12) == 2723160949) strcat(s, "b");
if (crc32("EmyqpUouaC",10) == 1490187040) strcat(s, "h");
if (crc32("mMBkPURYMC",10) == 1582392657) strcat(s, "l");
if (crc32("qjURj",5) == 429290190) strcat(s, "e");
if (crc32("sqtjTflAhuWileP",15) == 1506005208) strcat(s, "t");
if (crc32("obHYajQzZ",9) == 1755429815) strcat(s, "h");
if (crc32("jghOFnrMqjvKzNO",15) == 796603075) strcat(s, "c");
if (crc32("pvRjKonY",8) == 844730784) strcat(s, "o");
if (crc32("fjpxd",5) == 2902032672) strcat(s, "p");
if (crc32("qvjtAwPgZGc",11) == 775576787) strcat(s, "u");
if (crc32("KplEJaIWTKslK",13) == 2663548237) strcat(s, "a");
if (crc32("KoyIIcRn",8) == 2616150696) strcat(s, "g");
if (crc32("fhNgRUUimxQQpLk",15) == 1508996344) strcat(s, "Q");
if (crc32("VeflSNtN",8) == 3556892802) strcat(s, "h");
if (crc32("kKqplop",7) == 761421885) strcat(s, "t");
    return s;
}

char *costumed_verbs() {
    char *s = calloc(9);
    if (crc32("isSicuOXJ",9) == 2330413993) strcat(s, "K");
if (crc32("QEximdpRDP",10) == 1667435749) strcat(s, "c");
if (crc32("mWfhWt",6) == 1971380749) strcat(s, "o");
if (crc32("bRmMGwv",7) == 3670347606) strcat(s, "R");
if (crc32("VIOaFy",6) == 997111830) strcat(s, "s");
if (crc32("BBdsTjLrJ",9) == 3103561021) strcat(s, "j");
if (crc32("hwKVBxW",7) == 2476783524) strcat(s, "t");
if (crc32("NRnbSSzmYJDIU",13) == 2942832070) strcat(s, "u");
if (crc32("uZqEoWQFBf",10) == 50955073) strcat(s, "h");
if (crc32("obyrDQegElzKwvG",15) == 4081748851) strcat(s, "m");
if (crc32("tyjQXZiwwbw",11) == 2759931653) strcat(s, "q");
if (crc32("kMuYHJ",6) == 3803704016) strcat(s, "e");
if (crc32("ZMINwgEKBHugupE",15) == 4084402248) strcat(s, "d");
    return s;
}

char *dispensing_verbs() {
    char *s = calloc(11);
    if (crc32("HXHEvF",6) == 2053577690) strcat(s, "j");
if (crc32("ZEsNPrsWCAoeaw",14) == 2208456217) strcat(s, "d");
if (crc32("RxVJuLSkLqwwF",13) == 159443399) strcat(s, "i");
if (crc32("LIvrwSjetBaqo",13) == 3326458381) strcat(s, "s");
if (crc32("PWvguiyZut",10) == 2552883183) strcat(s, "K");
if (crc32("dOoueJGyIY",10) == 2846080375) strcat(s, "p");
if (crc32("PXGCSRSDVJ",10) == 3651508414) strcat(s, "e");
if (crc32("LOAeXT",6) == 1613484046) strcat(s, "n");
if (crc32("jgeIQdsyJ",9) == 2345120967) strcat(s, "s");
if (crc32("RyHfcGjUJFz",11) == 3731617567) strcat(s, "i");
if (crc32("oeWnrjhm",8) == 3359088021) strcat(s, "d");
if (crc32("ArsJXRJvoclCsi",14) == 1702107233) strcat(s, "n");
if (crc32("RPOQyp",6) == 3362158843) strcat(s, "g");
    return s;
}

char *canalling_verbs() {
    char *s = calloc(10);
    if (crc32("OYYDaWlbBCk",11) == 1728627076) strcat(s, "X");
if (crc32("QvLAKmrQBGqu",12) == 142591758) strcat(s, "c");
if (crc32("vVzbjrymq",9) == 1159230944) strcat(s, "a");
if (crc32("kGTbTS",6) == 2244327194) strcat(s, "S");
if (crc32("lmEXIlOLfabSth",14) == 1913649335) strcat(s, "n");
if (crc32("ZqVJiSReAlAOKXV",15) == 4219290372) strcat(s, "r");
if (crc32("CaXTZipj",8) == 2740015230) strcat(s, "a");
if (crc32("xoAweZMVvALybj",14) == 2068729453) strcat(s, "U");
if (crc32("TXattPsSmiYfn",13) == 3765900361) strcat(s, "l");
if (crc32("AFRetNZbavOo",12) == 1312311735) strcat(s, "l");
if (crc32("hKjKowM",7) == 4104505730) strcat(s, "i");
if (crc32("iEtAsWKDqw",10) == 3813960537) strcat(s, "I");
if (crc32("uaITyClqHfkz",12) == 1110199148) strcat(s, "n");
if (crc32("ltxbrV",6) == 1460863644) strcat(s, "l");
if (crc32("YrTQJHeSFtrC",12) == 1593261117) strcat(s, "g");
    return s;
}

char *overdiversifying_verbs() {
    char *s = calloc(17);
    if (crc32("brdWZKWHMtIAXd",14) == 3605721894) strcat(s, "o");
if (crc32("EkDreqxGmDT",11) == 1370381319) strcat(s, "t");
if (crc32("SgBEWhvOubQd",12) == 1496974160) strcat(s, "v");
if (crc32("pfBWjGlpi",9) == 3461559853) strcat(s, "i");
if (crc32("BLezVkMuZABM",12) == 2925162143) strcat(s, "e");
if (crc32("EhfibrpLuAwibCF",15) == 1103309258) strcat(s, "j");
if (crc32("wllLXSIkNxApD",13) == 4244525997) strcat(s, "r");
if (crc32("cWRgbTQzQdNk",12) == 1231983126) strcat(s, "d");
if (crc32("ZDNTW",5) == 3780190092) strcat(s, "Q");
if (crc32("Fvjlh",5) == 2426676867) strcat(s, "i");
if (crc32("aLnzt",5) == 1933806614) strcat(s, "v");
if (crc32("hzggDZQ",7) == 2253227642) strcat(s, "x");
if (crc32("ZLMapWK",7) == 28284117) strcat(s, "e");
if (crc32("fwFkpQbvC",9) == 2106430159) strcat(s, "r");
if (crc32("ADAlUYzxzJtBXzP",15) == 3772080867) strcat(s, "s");
if (crc32("hXJzgEBbXJLHioB",15) == 614788627) strcat(s, "i");
if (crc32("CxqZguh",7) == 248128490) strcat(s, "R");
if (crc32("eLDqNnGQdvGB",12) == 1419612179) strcat(s, "f");
if (crc32("lpAstuYWyct",11) == 1321180617) strcat(s, "y");
if (crc32("JqqxrJGCr",9) == 2806102817) strcat(s, "J");
if (crc32("IUMraTgnXw",10) == 638581180) strcat(s, "i");
if (crc32("mqywYiVgT",9) == 430859374) strcat(s, "n");
if (crc32("uvqiKsRFZx",10) == 4019685757) strcat(s, "t");
if (crc32("rGQntHFfo",9) == 1679282023) strcat(s, "g");
    return s;
}

char *marinate_verbs() {
    char *s = calloc(9);
    if (crc32("PYhDpSMJd",9) == 3938691859) strcat(s, "m");
if (crc32("zMmTlSlJfWvqfza",15) == 2437842475) strcat(s, "X");
if (crc32("rKubgzhQzxo",11) == 3737120227) strcat(s, "a");
if (crc32("fqbGP",5) == 960869943) strcat(s, "L");
if (crc32("jIWQkbb",7) == 3549086205) strcat(s, "r");
if (crc32("QujsgncYZP",10) == 3253807721) strcat(s, "i");
if (crc32("aLxffdAQS",9) == 1353010677) strcat(s, "n");
if (crc32("SMPDQAUYXSj",11) == 3824094108) strcat(s, "z");
if (crc32("sgHcsbzxgRkCUBR",15) == 2080625192) strcat(s, "a");
if (crc32("xfrvSfLpeB",10) == 3517181687) strcat(s, "t");
if (crc32("dFIQcMZAPmekYT",14) == 806582221) strcat(s, "I");
if (crc32("HEtCOGsvAG",10) == 2615809251) strcat(s, "e");
    return s;
}

char *damming_verbs() {
    char *s = calloc(8);
    if (crc32("EwXfYtEFd",9) == 656500772) strcat(s, "S");
if (crc32("KSJpVguZZmii",12) == 851003293) strcat(s, "d");
if (crc32("JtzYYhpju",9) == 3532299923) strcat(s, "d");
if (crc32("HdkcjdoKgAzJbDf",15) == 3660918757) strcat(s, "a");
if (crc32("wkIdhPusrAO",11) == 387114693) strcat(s, "m");
if (crc32("XzdRN",5) == 242270059) strcat(s, "e");
if (crc32("flTeULtNIjmpG",13) == 2665584460) strcat(s, "m");
if (crc32("ebAYHNsGWk",10) == 3534154026) strcat(s, "i");
if (crc32("ezmuDtpa",8) == 3044985766) strcat(s, "F");
if (crc32("OqDmnUW",7) == 4226047665) strcat(s, "n");
if (crc32("AGUqRI",6) == 1061129590) strcat(s, "O");
if (crc32("HexBWIK",7) == 3813152080) strcat(s, "g");
    return s;
}

char *kernelling_verbs() {
    char *s = calloc(11);
    if (crc32("iAgRRxh",7) == 1433028948) strcat(s, "N");
if (crc32("glXrDkiY",8) == 1722399610) strcat(s, "k");
if (crc32("yoauSdVEbyzd",12) == 905450843) strcat(s, "A");
if (crc32("vdSIdzNacdy",11) == 198249342) strcat(s, "e");
if (crc32("wkUhnxashoKD",12) == 4281215142) strcat(s, "e");
if (crc32("qNGKfakLwZUFl",13) == 2372667367) strcat(s, "r");
if (crc32("TzpThOoH",8) == 634479137) strcat(s, "n");
if (crc32("VzcoSSZPi",9) == 2809553524) strcat(s, "N");
if (crc32("igWlcUws",8) == 1128845200) strcat(s, "e");
if (crc32("vrmWiuyNpmz",11) == 730854554) strcat(s, "C");
if (crc32("Pmnxd",5) == 3624773533) strcat(s, "l");
if (crc32("rGbctcTpGbn",11) == 3375777646) strcat(s, "A");
if (crc32("uBZmTY",6) == 3770806349) strcat(s, "l");
if (crc32("rXUYjJHfavklzwW",15) == 2519558070) strcat(s, "Y");
if (crc32("dmHViSt",7) == 1373807591) strcat(s, "i");
if (crc32("AZCazhFAXQBZwGj",15) == 1725378119) strcat(s, "n");
if (crc32("mLTjCL",6) == 1928086788) strcat(s, "R");
if (crc32("QkXATPQFYYapwbM",15) == 2081054764) strcat(s, "g");
    return s;
}

char *bamboozled_verbs() {
    char *s = calloc(11);
    if (crc32("NjpPOEF",7) == 2074052371) strcat(s, "b");
if (crc32("mpllfXcH",8) == 2875574612) strcat(s, "a");
if (crc32("cHuxNJsKC",9) == 1101484676) strcat(s, "p");
if (crc32("UHJSrAoB",8) == 346643952) strcat(s, "m");
if (crc32("GXpnDNyPb",9) == 1859730596) strcat(s, "G");
if (crc32("qDIWmDZbr",9) == 2434910479) strcat(s, "b");
if (crc32("KhFspiRTpKMEe",13) == 971790982) strcat(s, "o");
if (crc32("NlRoNlyqMSu",11) == 592168261) strcat(s, "k");
if (crc32("MiEiH",5) == 2584118539) strcat(s, "o");
if (crc32("KPXFxABU",8) == 66267246) strcat(s, "z");
if (crc32("aIHFmpPSzunywSc",15) == 143285234) strcat(s, "l");
if (crc32("EvmJh",5) == 2442285146) strcat(s, "E");
if (crc32("JCjIH",5) == 1094464318) strcat(s, "e");
if (crc32("tRwAw",5) == 2308028858) strcat(s, "R");
if (crc32("igOsdHesH",9) == 4077501199) strcat(s, "d");
    return s;
}

char *negatived_verbs() {
    char *s = calloc(10);
    if (crc32("BKzrkygNz",9) == 2623571835) strcat(s, "Q");
if (crc32("ZqUopHAudZl",11) == 2760699624) strcat(s, "n");
if (crc32("WcAMqILafQ",10) == 2552066813) strcat(s, "D");
if (crc32("jCjmmNahqmVyU",13) == 841576875) strcat(s, "e");
if (crc32("XzHTNIAUEhFL",12) == 2403097856) strcat(s, "c");
if (crc32("EzXJeTRhquE",11) == 2939780212) strcat(s, "g");
if (crc32("mJGJJKBSlTnhfCh",15) == 1313442582) strcat(s, "a");
if (crc32("QHvUdgVEWIbbHpo",15) == 3889496034) strcat(s, "m");
if (crc32("vhcdPHui",8) == 2251582992) strcat(s, "t");
if (crc32("KbyTQp",6) == 3112700786) strcat(s, "i");
if (crc32("SyctxpPNjFoVjy",14) == 2771812694) strcat(s, "b");
if (crc32("LTWxFrt",7) == 2467712537) strcat(s, "v");
if (crc32("MFtZQqkrmVotLtf",15) == 1026517723) strcat(s, "e");
if (crc32("RwlDvX",6) == 721248778) strcat(s, "Q");
if (crc32("tSoOoJsC",8) == 2307593314) strcat(s, "d");
    return s;
}

char *skinning_verbs() {
    char *s = calloc(9);
    if (crc32("NmleQPqT",8) == 3781313025) strcat(s, "Q");
if (crc32("MmNPYhymoqg",11) == 3626630645) strcat(s, "s");
if (crc32("GSYgPtuxtOZM",12) == 2879334301) strcat(s, "k");
if (crc32("UnoTwOfpUkOcUd",14) == 3918777867) strcat(s, "U");
if (crc32("uZdxMghR",8) == 1347918868) strcat(s, "i");
if (crc32("thBLfjAstBfy",12) == 3664690826) strcat(s, "n");
if (crc32("swDdkcnqNL",10) == 4198478423) strcat(s, "R");
if (crc32("kRpHY",5) == 924988005) strcat(s, "n");
if (crc32("eLRQItdlSmQigS",14) == 793013646) strcat(s, "u");
if (crc32("GCLKOaOmRtbdu",13) == 3844024791) strcat(s, "i");
if (crc32("EKXCPXhrj",9) == 1594733155) strcat(s, "n");
if (crc32("XbGVzOuXN",9) == 2114294456) strcat(s, "i");
if (crc32("MLVhxOf",7) == 3754520) strcat(s, "g");
    return s;
}

char *moulder_verbs() {
    char *s = calloc(8);
    if (crc32("gPrFxvSeeuWaNR",14) == 1365836001) strcat(s, "M");
if (crc32("oAznXJxOpJ",10) == 1920189355) strcat(s, "m");
if (crc32("zseBh",5) == 3685973803) strcat(s, "e");
if (crc32("xCvUADbpHzLGX",13) == 1575548249) strcat(s, "o");
if (crc32("QbEIjJrAvCogkC",14) == 2808284449) strcat(s, "e");
if (crc32("MPDwrrzqhFHD",12) == 2519300798) strcat(s, "u");
if (crc32("MHGQCvVSGuXSV",13) == 3928213483) strcat(s, "l");
if (crc32("WDxxBpLA",8) == 571730306) strcat(s, "R");
if (crc32("ulnElRQHioMCdkH",15) == 521500301) strcat(s, "d");
if (crc32("NriYCfel",8) == 2928225380) strcat(s, "N");
if (crc32("ZfrRFlTKOJfxd",13) == 3082882532) strcat(s, "e");
if (crc32("oEbWdGPVq",9) == 1124353730) strcat(s, "O");
if (crc32("HWpGdIwS",8) == 3251266036) strcat(s, "r");
    return s;
}

char *jingle_verbs() {
    char *s = calloc(7);
    if (crc32("zKBgazAJn",9) == 782868401) strcat(s, "m");
if (crc32("TkASocDnpRZJqrG",15) == 258478187) strcat(s, "j");
if (crc32("OlLcCqhPxwCUOVL",15) == 2980196657) strcat(s, "i");
if (crc32("YyBJpMk",7) == 3929311684) strcat(s, "K");
if (crc32("ZSFlJZDp",8) == 1739085938) strcat(s, "n");
if (crc32("vPkouEhJoiVDoJ",14) == 26622853) strcat(s, "o");
if (crc32("ByjuFRaV",8) == 3231621018) strcat(s, "g");
if (crc32("txiAiupmybcXrK",14) == 3645504511) strcat(s, "F");
if (crc32("oVlxjO",6) == 2907736120) strcat(s, "l");
if (crc32("ecuaxDg",7) == 2888764384) strcat(s, "B");
if (crc32("ZPfGOQniVQds",12) == 728457303) strcat(s, "e");
    return s;
}

char *skywrote_verbs() {
    char *s = calloc(9);
    if (crc32("bdDoQnOERkh",11) == 1525387365) strcat(s, "s");
if (crc32("bvPQxueldR",10) == 2049399996) strcat(s, "k");
if (crc32("PRBuIlUihc",10) == 1695392328) strcat(s, "y");
if (crc32("miqvLbYwu",9) == 1178905767) strcat(s, "T");
if (crc32("TiYDDIEbB",9) == 3601913046) strcat(s, "w");
if (crc32("JoaNSCLtLTK",11) == 2293868720) strcat(s, "t");
if (crc32("KBXuMWCqYs",10) == 171282713) strcat(s, "r");
if (crc32("hiMPjLWjyXMO",12) == 2963386568) strcat(s, "o");
if (crc32("diWewpCsVZ",10) == 2371360533) strcat(s, "Y");
if (crc32("aprTbpDL",8) == 819182276) strcat(s, "t");
if (crc32("rZaOa",5) == 2182231394) strcat(s, "K");
if (crc32("BEYJOpsDJddmwnU",15) == 2497604998) strcat(s, "e");
    return s;
}

char *flited_verbs() {
    char *s = calloc(7);
    if (crc32("hrzjeReRNsq",11) == 972618331) strcat(s, "N");
if (crc32("iFBNHZgutvIli",13) == 589447494) strcat(s, "f");
if (crc32("iyaOnzo",7) == 730657657) strcat(s, "C");
if (crc32("hRkMtY",6) == 3661073164) strcat(s, "l");
if (crc32("fxhwUvzdnRSONzb",15) == 2213703560) strcat(s, "i");
if (crc32("kCsZEyWqyEFSDru",15) == 513969888) strcat(s, "t");
if (crc32("iApan",5) == 1112941679) strcat(s, "v");
if (crc32("OEoZzmM",7) == 1311804202) strcat(s, "e");
if (crc32("iIhHApBy",8) == 1811839483) strcat(s, "d");
    return s;
}

char *correlate_verbs() {
    char *s = calloc(10);
    if (crc32("hRZAkyXMAVEW",12) == 2513540227) strcat(s, "c");
if (crc32("CoKFkXsEPuH",11) == 2329087355) strcat(s, "o");
if (crc32("qdTbMDX",7) == 2586358138) strcat(s, "m");
if (crc32("mxhVfbjnt",9) == 940904847) strcat(s, "r");
if (crc32("bOyvxEgNPJYQ",12) == 692601894) strcat(s, "r");
if (crc32("HYGQGKBWVI",10) == 190509317) strcat(s, "n");
if (crc32("BXLPUvNmLASBAQ",14) == 660725329) strcat(s, "e");
if (crc32("iFOHvjnKdVaTDvM",15) == 1775731821) strcat(s, "t");
if (crc32("TPgZGqwnwEbzN",13) == 67296617) strcat(s, "l");
if (crc32("DwBNctypiE",10) == 1267193759) strcat(s, "x");
if (crc32("rNSinpio",8) == 1734438018) strcat(s, "a");
if (crc32("ouJnpgQCOHtcek",14) == 2890945752) strcat(s, "t");
if (crc32("XPLoSjrC",8) == 2819882909) strcat(s, "R");
if (crc32("vGZQwjKQsOy",11) == 2872803944) strcat(s, "e");
    return s;
}

char *tunnelled_verbs() {
    char *s = calloc(10);
    if (crc32("ayQmbOBMf",9) == 3087014831) strcat(s, "F");
if (crc32("jmbinvCmVtEGF",13) == 2459982322) strcat(s, "t");
if (crc32("faKewYIMBBwe",12) == 941948913) strcat(s, "J");
if (crc32("nENNQDFIRQgJo",13) == 1006576956) strcat(s, "u");
if (crc32("xgsrYeuj",8) == 3212863868) strcat(s, "f");
if (crc32("GNkQIHUuObFAoT",14) == 2862572115) strcat(s, "n");
if (crc32("DPFyWVmHye",10) == 1119057570) strcat(s, "n");
if (crc32("EgGuOYSIsB",10) == 3475862798) strcat(s, "e");
if (crc32("sFoyINdSWcbQvT",14) == 2436666100) strcat(s, "l");
if (crc32("desaSVZiJpckxt",14) == 2528451321) strcat(s, "l");
if (crc32("llHwSceanKX",11) == 1126967260) strcat(s, "e");
if (crc32("mmIHvHF",7) == 3842979315) strcat(s, "P");
if (crc32("wvqAYwPVHffyW",13) == 4249919027) strcat(s, "d");
    return s;
}

char *facsimileing_verbs() {
    char *s = calloc(13);
    if (crc32("QYQspDoPtmiqd",13) == 202619685) strcat(s, "f");
if (crc32("yBGSzocYFiUxqMt",15) == 1248148548) strcat(s, "G");
if (crc32("MlXaZEO",7) == 1178164397) strcat(s, "a");
if (crc32("gyVlTEOKLJD",11) == 2183528816) strcat(s, "c");
if (crc32("JlhzRWfTd",9) == 4098500053) strcat(s, "s");
if (crc32("SKSwLCyZOMZQR",13) == 2960005280) strcat(s, "i");
if (crc32("BqLaftSGCL",10) == 390232242) strcat(s, "m");
if (crc32("tEFeGdbaFPH",11) == 473066513) strcat(s, "A");
if (crc32("pjAXlS",6) == 323987259) strcat(s, "i");
if (crc32("dMOuaTzAhViV",12) == 1019053145) strcat(s, "l");
if (crc32("UKVgwHiDdzb",11) == 2893079429) strcat(s, "e");
if (crc32("nNOsmbLoLZeMR",13) == 377751524) strcat(s, "W");
if (crc32("nluIXFKyM",9) == 1604862236) strcat(s, "i");
if (crc32("tDWyuqdNLyttC",13) == 3525391007) strcat(s, "l");
if (crc32("SGYTxkbsgCn",11) == 3794459575) strcat(s, "n");
if (crc32("HgIuQrpsixLrod",14) == 1577077343) strcat(s, "Z");
if (crc32("CjiactbqhJ",10) == 3224136731) strcat(s, "g");
    return s;
}

char *inkin_verbs() {
    char *s = calloc(6);
    if (crc32("bzDLNjet",8) == 939439320) strcat(s, "H");
if (crc32("pDhdbF",6) == 1856701307) strcat(s, "i");
if (crc32("jnTYMVGIVviGr",13) == 3716199644) strcat(s, "n");
if (crc32("UlifCVPm",8) == 1699953989) strcat(s, "k");
if (crc32("THyUrFLwHROQ",12) == 3127471391) strcat(s, "i");
if (crc32("KSUWNwvleBFM",12) == 2887496512) strcat(s, "a");
if (crc32("aYkNdpimgAp",11) == 2159482680) strcat(s, "n");
    return s;
}

char *begged_verbs() {
    char *s = calloc(7);
    if (crc32("ysrNBQPC",8) == 2744732873) strcat(s, "b");
if (crc32("JZCnyN",6) == 3386105874) strcat(s, "e");
if (crc32("VtrvUZBHjOzEwNf",15) == 2661505256) strcat(s, "M");
if (crc32("XdkgMXIIU",9) == 206119601) strcat(s, "g");
if (crc32("VjVKvap",7) == 1346105869) strcat(s, "h");
if (crc32("hIWtAZGiYhlELL",14) == 1602874188) strcat(s, "g");
if (crc32("BZfXqegMArkQk",13) == 229159346) strcat(s, "e");
if (crc32("ovhnMxETGc",10) == 3138688751) strcat(s, "P");
if (crc32("VKeZuBekt",9) == 2021608369) strcat(s, "d");
    return s;
}

char *overspend_verbs() {
    char *s = calloc(10);
    if (crc32("islnYcvais",10) == 3573202957) strcat(s, "o");
if (crc32("JxUKsVdQukYlDX",14) == 607310785) strcat(s, "h");
if (crc32("wiaQIkobhaM",11) == 1213879021) strcat(s, "v");
if (crc32("RaGRfIesRodUvn",14) == 3555608904) strcat(s, "w");
if (crc32("rXZmWibXJmQxz",13) == 2508696011) strcat(s, "e");
if (crc32("oYYyXtI",7) == 1229097723) strcat(s, "s");
if (crc32("YJnvUKATnBqrEs",14) == 3920545586) strcat(s, "r");
if (crc32("XJbUsvAzdVNY",12) == 3802894538) strcat(s, "s");
if (crc32("HCvdzVlsw",9) == 3164669455) strcat(s, "z");
if (crc32("LuGBgum",7) == 2989819165) strcat(s, "p");
if (crc32("PoCMIdsACDwZBZ",14) == 3692869824) strcat(s, "e");
if (crc32("kHziPMvyeC",10) == 2056867412) strcat(s, "H");
if (crc32("vtPoTsacIU",10) == 1201054828) strcat(s, "n");
if (crc32("ziNiv",5) == 1512304842) strcat(s, "S");
if (crc32("CcVawuPXt",9) == 2189077758) strcat(s, "d");
    return s;
}

char *theologized_verbs() {
    char *s = calloc(12);
    if (crc32("KNIWpsuDAleG",12) == 3751647421) strcat(s, "t");
if (crc32("yLGVsUWcpkQkMiE",15) == 1323560139) strcat(s, "p");
if (crc32("cmjbPEGQGMUGwKF",15) == 1979084658) strcat(s, "h");
if (crc32("ghUCBlVpyCOF",12) == 4248094111) strcat(s, "e");
if (crc32("OrDuMB",6) == 1469570704) strcat(s, "o");
if (crc32("SZpPVAIvTtHBr",13) == 3923435581) strcat(s, "l");
if (crc32("LnMZhB",6) == 3539552269) strcat(s, "o");
if (crc32("CdpqRxLL",8) == 1780041052) strcat(s, "g");
if (crc32("XZxoTxm",7) == 1177335173) strcat(s, "W");
if (crc32("EmkaVFekcitAD",13) == 1382782710) strcat(s, "i");
if (crc32("DgnEgyydjASeO",13) == 1426781246) strcat(s, "z");
if (crc32("tPgCLFCiKtNbyLl",15) == 1813515597) strcat(s, "j");
if (crc32("yotPfBJeQ",9) == 4193241909) strcat(s, "e");
if (crc32("nAXjkPfotPe",11) == 3052687693) strcat(s, "M");
if (crc32("ThiStpOHIPYs",12) == 2998442372) strcat(s, "d");
    return s;
}

char *precirculated_verbs() {
    char *s = calloc(14);
    if (crc32("OMmDH",5) == 3913785935) strcat(s, "k");
if (crc32("BRRdBpVwyeXQb",13) == 1789176605) strcat(s, "p");
if (crc32("XuqSrgB",7) == 782822413) strcat(s, "r");
if (crc32("bivlfUqZ",8) == 2715529680) strcat(s, "e");
if (crc32("GIqLrTzINArtXwy",15) == 3145804582) strcat(s, "X");
if (crc32("GvpckkJh",8) == 4247317494) strcat(s, "c");
if (crc32("oSqpElZudsvAXx",14) == 4182335870) strcat(s, "m");
if (crc32("LzifYLqEjW",10) == 1544431491) strcat(s, "i");
if (crc32("KCQVJq",6) == 4246381941) strcat(s, "r");
if (crc32("TRYrsSjSafB",11) == 3675813585) strcat(s, "p");
if (crc32("WNqTEXbbo",9) == 1309860710) strcat(s, "c");
if (crc32("jgMyLMLoF",9) == 534683911) strcat(s, "Y");
if (crc32("AzcZCkp",7) == 190553478) strcat(s, "u");
if (crc32("TclomRLLzJqnm",13) == 693000440) strcat(s, "L");
if (crc32("EDWRwSxVo",9) == 2175517524) strcat(s, "l");
if (crc32("CUiXgvLDDgcE",12) == 2586575810) strcat(s, "a");
if (crc32("LbzhUniEDjMVod",14) == 210223055) strcat(s, "a");
if (crc32("AmhOzJwwSgKSW",13) == 2132336360) strcat(s, "t");
if (crc32("vhxzCnSDIck",11) == 3991819291) strcat(s, "E");
if (crc32("BiYCTwyTFLCRHk",14) == 378627718) strcat(s, "e");
if (crc32("jvoIo",5) == 3838403369) strcat(s, "d");
    return s;
}

char *referred_verbs() {
    char *s = calloc(9);
    if (crc32("cEzPbThVpRNvy",13) == 1530089645) strcat(s, "W");
if (crc32("tWAHTcpzAVcDhfe",15) == 3392249779) strcat(s, "r");
if (crc32("KBXFlqlm",8) == 2416024826) strcat(s, "X");
if (crc32("FtIkUfgraEsrzEX",15) == 275127588) strcat(s, "e");
if (crc32("gcDxUTPtWxAOSz",14) == 3899390558) strcat(s, "R");
if (crc32("DaZXJTZZbism",12) == 4011843962) strcat(s, "f");
if (crc32("OihrHflcYSIPIXr",15) == 2294360941) strcat(s, "d");
if (crc32("AozmPWnXmFyka",13) == 597260937) strcat(s, "e");
if (crc32("pTByUkwSw",9) == 719500922) strcat(s, "r");
if (crc32("hhptDDV",7) == 2356093595) strcat(s, "g");
if (crc32("rnCIUPJ",7) == 1810849017) strcat(s, "r");
if (crc32("XpWQTXV",7) == 845004070) strcat(s, "t");
if (crc32("CtMyTXDyt",9) == 1037164662) strcat(s, "e");
if (crc32("raHZKyD",7) == 444799962) strcat(s, "d");
    return s;
}

char *overreducing_verbs() {
    char *s = calloc(13);
    if (crc32("aUDShzXClOaEfyq",15) == 983502862) strcat(s, "r");
if (crc32("ZWvykKfKXQRMwN",14) == 920440213) strcat(s, "o");
if (crc32("JckqsGbhIfX",11) == 2174243322) strcat(s, "i");
if (crc32("rMDKYhYzEpzbN",13) == 3728055832) strcat(s, "v");
if (crc32("LRotZyImhgFVU",13) == 2035539405) strcat(s, "e");
if (crc32("zhEKntePTkYVSGP",15) == 989372425) strcat(s, "f");
if (crc32("bSDIQpk",7) == 3625030772) strcat(s, "r");
if (crc32("HlNwfxaB",8) == 1924949525) strcat(s, "U");
if (crc32("TVpjDlRCma",10) == 3768489505) strcat(s, "r");
if (crc32("QUmIzjReL",9) == 3018935606) strcat(s, "e");
if (crc32("dEGZYhxXuol",11) == 4164322867) strcat(s, "c");
if (crc32("VzoJDz",6) == 3808055111) strcat(s, "d");
if (crc32("ANmSobgCAkc",11) == 2837795843) strcat(s, "G");
if (crc32("fQPACaM",7) == 2939476274) strcat(s, "u");
if (crc32("TVAIYvOPWon",11) == 3017123399) strcat(s, "c");
if (crc32("kRlEtSfnJNHedzY",15) == 2128499792) strcat(s, "i");
if (crc32("mkCmPYBqFRODN",13) == 2533986702) strcat(s, "n");
if (crc32("OuXvyoeL",8) == 2413600259) strcat(s, "g");
    return s;
}

char *supplicate_verbs() {
    char *s = calloc(11);
    if (crc32("wsPIgMH",7) == 2538779527) strcat(s, "s");
if (crc32("irxfUMHMnymCcPp",15) == 3320954200) strcat(s, "u");
if (crc32("csOGTAPcwSscBw",14) == 3238336925) strcat(s, "I");
if (crc32("uXUSIJq",7) == 3094682357) strcat(s, "p");
if (crc32("qJMLfNxWXjROIU",14) == 2067778443) strcat(s, "T");
if (crc32("qedswTQJxjf",11) == 1855861246) strcat(s, "p");
if (crc32("xnpsxVCyvU",10) == 60999370) strcat(s, "l");
if (crc32("RCsNWWOJVug",11) == 1835781970) strcat(s, "t");
if (crc32("LPuYkiVHUdx",11) == 2216518969) strcat(s, "i");
if (crc32("bzcyBVbuhz",10) == 2792874487) strcat(s, "w");
if (crc32("nCNklYFQdA",10) == 3882046959) strcat(s, "c");
if (crc32("emSqgMxKPczg",12) == 4183082473) strcat(s, "s");
if (crc32("SCvxpwgWHqE",11) == 3402028756) strcat(s, "a");
if (crc32("IrnhqVN",7) == 4197695996) strcat(s, "t");
if (crc32("yxDIv",5) == 1931868297) strcat(s, "e");
    return s;
}

char *bugging_verbs() {
    char *s = calloc(8);
    if (crc32("QNzCrkdTKrAuMS",14) == 2911470555) strcat(s, "O");
if (crc32("GwVgynP",7) == 3497007139) strcat(s, "b");
if (crc32("ebnmdkmJeFl",11) == 1688461430) strcat(s, "u");
if (crc32("oFCKzNS",7) == 2860163837) strcat(s, "A");
if (crc32("lztzYw",6) == 1706380835) strcat(s, "g");
if (crc32("uYXTbEHFgvpf",12) == 2358557663) strcat(s, "g");
if (crc32("PyYcGnwgwyFbGz",14) == 3143048727) strcat(s, "i");
if (crc32("itaoxqcdI",9) == 3029403900) strcat(s, "n");
if (crc32("KcAAXIonUvaimaF",15) == 4083680088) strcat(s, "g");
    return s;
}

char *deteriorate_verbs() {
    char *s = calloc(12);
    if (crc32("qwAmrDTVpotECy",14) == 3249543028) strcat(s, "d");
if (crc32("voEIOh",6) == 1213808168) strcat(s, "c");
if (crc32("ersYkkxJqyS",11) == 3034250633) strcat(s, "e");
if (crc32("ShIEizEBgC",10) == 2529975540) strcat(s, "T");
if (crc32("BEbUiIbiRnTDOQ",14) == 4032311381) strcat(s, "t");
if (crc32("WoGDmmpVPmvH",12) == 1964985566) strcat(s, "g");
if (crc32("tiyMeSrJziKpFF",14) == 1658713134) strcat(s, "e");
if (crc32("vGzEFnSdcbqf",12) == 1124735357) strcat(s, "q");
if (crc32("RwObpGc",7) == 1275030521) strcat(s, "r");
if (crc32("CZWWIYkdDwg",11) == 2806284200) strcat(s, "i");
if (crc32("pAPiAJoHTnkEqF",14) == 2144787894) strcat(s, "n");
if (crc32("WubYvv",6) == 2738542237) strcat(s, "o");
if (crc32("VqYJLG",6) == 2665079755) strcat(s, "e");
if (crc32("rIjLPbb",7) == 1413999184) strcat(s, "r");
if (crc32("UqBWiNfxsyA",11) == 4000772726) strcat(s, "a");
if (crc32("FDApqZN",7) == 2337615364) strcat(s, "m");
if (crc32("DttbEzFCKM",10) == 3591595001) strcat(s, "t");
if (crc32("WzyKj",5) == 1993512407) strcat(s, "r");
if (crc32("dUSZywTUrdzv",12) == 4082447879) strcat(s, "e");
    return s;
}

char *allegorize_verbs() {
    char *s = calloc(11);
    if (crc32("gnuArp",6) == 2578327134) strcat(s, "y");
if (crc32("svmOR",5) == 2224007459) strcat(s, "a");
if (crc32("PfLAZBnKAa",10) == 3439834236) strcat(s, "N");
if (crc32("BfLlvwTfeaciSdx",15) == 1137276599) strcat(s, "l");
if (crc32("GWcgwmepcRUERZE",15) == 1161012013) strcat(s, "O");
if (crc32("KCZXipbdvnJBcF",14) == 1452015403) strcat(s, "l");
if (crc32("ezWJUaeTAWZ",11) == 3239243300) strcat(s, "y");
if (crc32("tekbcJmEoDPF",12) == 2369531217) strcat(s, "e");
if (crc32("eXVXMUwgdGf",11) == 201292762) strcat(s, "g");
if (crc32("JkFlpWRKNB",10) == 2100491448) strcat(s, "g");
if (crc32("OYctRjjXrLPz",12) == 3814372747) strcat(s, "M");
if (crc32("hDrthbiNHcWIl",13) == 576209361) strcat(s, "o");
if (crc32("BVxVqmKQxnJj",12) == 1499314416) strcat(s, "l");
if (crc32("JFkfcJ",6) == 2954261050) strcat(s, "r");
if (crc32("NoLiBJoxmUpp",12) == 2224222082) strcat(s, "G");
if (crc32("KjKvTGYngshKpt",14) == 1989525927) strcat(s, "i");
if (crc32("BnBePvUnO",9) == 88818265) strcat(s, "B");
if (crc32("gZNJpV",6) == 2103567108) strcat(s, "z");
if (crc32("KUjavRlAqjEeYKx",15) == 839925602) strcat(s, "J");
if (crc32("QBNub",5) == 2042408157) strcat(s, "e");
    return s;
}

char *forgave_verbs() {
    char *s = calloc(8);
    if (crc32("sJilINZg",8) == 3676656043) strcat(s, "f");
if (crc32("iLWkDoQGwS",10) == 3005824146) strcat(s, "T");
if (crc32("TUvcPCAn",8) == 1022560548) strcat(s, "o");
if (crc32("faRCN",5) == 1992453913) strcat(s, "r");
if (crc32("ijPgbmdUubhB",12) == 2314642990) strcat(s, "X");
if (crc32("gyJHPEpGGDcR",12) == 1453552716) strcat(s, "g");
if (crc32("imMHzpanXKzMysC",15) == 1872067186) strcat(s, "a");
if (crc32("lpuTbhlgeWJz",12) == 915352098) strcat(s, "v");
if (crc32("aXXQUYJJTGl",11) == 2492072243) strcat(s, "g");
if (crc32("XhwWKmAo",8) == 4292452088) strcat(s, "e");
    return s;
}

char *jumbling_verbs() {
    char *s = calloc(9);
    if (crc32("ZZeSBnDvBJ",10) == 2194538401) strcat(s, "F");
if (crc32("HsRkUNujYsy",11) == 2766635398) strcat(s, "j");
if (crc32("jnEAsoq",7) == 2688526933) strcat(s, "u");
if (crc32("LXXiIQNoRaaRz",13) == 1267838586) strcat(s, "m");
if (crc32("CjJnhxqMYwSze",13) == 273439442) strcat(s, "u");
if (crc32("vXuGitiuXsSxr",13) == 132443887) strcat(s, "b");
if (crc32("tmxiRrehPQGF",12) == 3388781782) strcat(s, "l");
if (crc32("dTtpmZh",7) == 3991183735) strcat(s, "R");
if (crc32("FPWczULATr",10) == 2110592110) strcat(s, "i");
if (crc32("WxolN",5) == 4181567636) strcat(s, "n");
if (crc32("LkrMFVMMQCuvJv",14) == 2566068073) strcat(s, "R");
if (crc32("NyiDn",5) == 1322240210) strcat(s, "g");
    return s;
}

char *carrying_verbs() {
    char *s = calloc(9);
    if (crc32("UFuyc",5) == 2383958368) strcat(s, "a");
if (crc32("UTXvC",5) == 2258738689) strcat(s, "c");
if (crc32("DalWVPUNP",9) == 1211383533) strcat(s, "D");
if (crc32("XFDqtrVZ",8) == 1077297041) strcat(s, "a");
if (crc32("JUTPNeIONU",10) == 751789622) strcat(s, "r");
if (crc32("tekCJwreMq",10) == 43571839) strcat(s, "J");
if (crc32("OPxTNEEaCfo",11) == 3379173289) strcat(s, "r");
if (crc32("MYhtkrroMy",10) == 3214682460) strcat(s, "K");
if (crc32("ibDNpvx",7) == 1670178480) strcat(s, "y");
if (crc32("qImwFDssA",9) == 1543431451) strcat(s, "i");
if (crc32("WPNpf",5) == 1995896373) strcat(s, "n");
if (crc32("XrggHBbTCzA",11) == 2371117733) strcat(s, "g");
    return s;
}

char *vilify_verbs() {
    char *s = calloc(7);
    if (crc32("iiNMZfh",7) == 870408255) strcat(s, "v");
if (crc32("zabEcawhtMnf",12) == 1788165863) strcat(s, "i");
if (crc32("VEPDTPImCn",10) == 3663457500) strcat(s, "k");
if (crc32("rZFJjV",6) == 1541644824) strcat(s, "l");
if (crc32("SwrtY",5) == 3353989361) strcat(s, "l");
if (crc32("FYmgoUhbZuXyPJX",15) == 2340036084) strcat(s, "i");
if (crc32("yFWsxYZR",8) == 1644661036) strcat(s, "e");
if (crc32("hTVOvsaO",8) == 866427423) strcat(s, "f");
if (crc32("sMkJbjBbyPFLvM",14) == 422892304) strcat(s, "y");
    return s;
}

char *reform_verbs() {
    char *s = calloc(7);
    if (crc32("HOinpdY",7) == 478865014) strcat(s, "r");
if (crc32("LrnyxWn",7) == 3028084495) strcat(s, "m");
if (crc32("EqgbH",5) == 3890674431) strcat(s, "e");
if (crc32("eIDlDUXUTk",10) == 1884776255) strcat(s, "e");
if (crc32("UsvCAEYoUiLBHZc",15) == 19833424) strcat(s, "f");
if (crc32("uZHrXAHG",8) == 2417595701) strcat(s, "A");
if (crc32("KgfyNrLRyu",10) == 76465772) strcat(s, "o");
if (crc32("zndcYl",6) == 3973159019) strcat(s, "r");
if (crc32("vpGQxAsUDRiNV",13) == 3498453564) strcat(s, "m");
    return s;
}

char *riven_verbs() {
    char *s = calloc(6);
    if (crc32("IgEudLxI",8) == 583023595) strcat(s, "b");
if (crc32("xDrDBAgYNjCZ",12) == 2308419703) strcat(s, "r");
if (crc32("SNpON",5) == 1863010742) strcat(s, "w");
if (crc32("yJoBMHpFiNKQMr",14) == 1371041693) strcat(s, "i");
if (crc32("PrHOBvUMFin",11) == 2301783847) strcat(s, "v");
if (crc32("wDemb",5) == 2757040381) strcat(s, "e");
if (crc32("FmaMsw",6) == 3712745261) strcat(s, "Z");
if (crc32("EeERwjtacj",10) == 3548389381) strcat(s, "n");
    return s;
}

char *refocus_verbs() {
    char *s = calloc(8);
    if (crc32("YytXh",5) == 2279951115) strcat(s, "r");
if (crc32("mhLEdiFY",8) == 3880264973) strcat(s, "x");
if (crc32("GDcVvAZCB",9) == 3862148814) strcat(s, "e");
if (crc32("EXRFbsa",7) == 3805999301) strcat(s, "f");
if (crc32("QKxdxmiDAar",11) == 2052185887) strcat(s, "d");
if (crc32("IkrDVcY",7) == 2382294974) strcat(s, "o");
if (crc32("cSmEDvOSPaRYQjI",15) == 2422655215) strcat(s, "c");
if (crc32("XMmQmwGUwv",10) == 3807152719) strcat(s, "u");
if (crc32("qcSWgCn",7) == 2473416037) strcat(s, "m");
if (crc32("KWgeVECaQPnP",12) == 1771180510) strcat(s, "s");
    return s;
}

char *delving_verbs() {
    char *s = calloc(8);
    if (crc32("MHqBGwFfNEK",11) == 885067116) strcat(s, "Y");
if (crc32("pVuCriiEAmwDc",13) == 1908137923) strcat(s, "d");
if (crc32("QqyPHEYNwpV",11) == 1479150193) strcat(s, "e");
if (crc32("yAUQIqVUu",9) == 3774037360) strcat(s, "l");
if (crc32("lZlEuEKEQNHMW",13) == 526631957) strcat(s, "A");
if (crc32("wEmeiJ",6) == 2458916246) strcat(s, "v");
if (crc32("iQOUCMWR",8) == 2695195891) strcat(s, "i");
if (crc32("oXIQCnVaoQf",11) == 3741047820) strcat(s, "n");
if (crc32("loIDuHbm",8) == 3065684675) strcat(s, "D");
if (crc32("bACWeUUY",8) == 2778449488) strcat(s, "g");
    return s;
}

char *outwent_verbs() {
    char *s = calloc(8);
    if (crc32("IZzFHQOOOG",10) == 3578265503) strcat(s, "D");
if (crc32("YxagzDOtJI",10) == 762540037) strcat(s, "o");
if (crc32("mfIdl",5) == 2079459686) strcat(s, "k");
if (crc32("eRIwvOX",7) == 3833735475) strcat(s, "u");
if (crc32("PPCJUVOHMYFl",12) == 576433740) strcat(s, "t");
if (crc32("UiJxYBO",7) == 967939369) strcat(s, "n");
if (crc32("cXvaXm",6) == 1910623411) strcat(s, "w");
if (crc32("xkdOccO",7) == 1832859217) strcat(s, "e");
if (crc32("GHhJmxaYtQbXJbT",15) == 1908151144) strcat(s, "n");
if (crc32("YkGZJFbLYFZPajl",15) == 359316344) strcat(s, "t");
    return s;
}

char *blink_verbs() {
    char *s = calloc(6);
    if (crc32("TqbibDdJgwoC",12) == 126215352) strcat(s, "b");
if (crc32("pBHQz",5) == 335768137) strcat(s, "O");
if (crc32("OUtjkIKXkjl",11) == 2189867090) strcat(s, "l");
if (crc32("WnkuMerOwNAklV",14) == 755896603) strcat(s, "y");
if (crc32("FcAOLtskqpp",11) == 1035643484) strcat(s, "i");
if (crc32("EisVExW",7) == 3360581076) strcat(s, "L");
if (crc32("ovukPFxs",8) == 3349970921) strcat(s, "n");
if (crc32("qPfnJoAd",8) == 3393023482) strcat(s, "k");
    return s;
}

char *nuzzle_verbs() {
    char *s = calloc(7);
    if (crc32("tfZJbCAzwodY",12) == 4189191181) strcat(s, "C");
if (crc32("qjNJnClgPLbqfF",14) == 1731188291) strcat(s, "n");
if (crc32("pwayITjl",8) == 3034040537) strcat(s, "J");
if (crc32("eYJYgrV",7) == 431806419) strcat(s, "u");
if (crc32("TlCvSWyw",8) == 2278676272) strcat(s, "z");
if (crc32("aGDZmNZScoDxt",13) == 3053687881) strcat(s, "z");
if (crc32("VqBrOTJbUGLfbMC",15) == 3428485536) strcat(s, "i");
if (crc32("rGZeqEQJOC",10) == 1883829565) strcat(s, "l");
if (crc32("eXnBzQvEFZDqHgL",15) == 3985325427) strcat(s, "e");
    return s;
}

char *troll_verbs() {
    char *s = calloc(6);
    if (crc32("vMlQUstaEVm",11) == 3292658256) strcat(s, "t");
if (crc32("eAhAmWFoPRdLgVU",15) == 2226808447) strcat(s, "t");
if (crc32("rfpLOKv",7) == 2610179474) strcat(s, "P");
if (crc32("uHfUU",5) == 958878600) strcat(s, "r");
if (crc32("MNMgv",5) == 3339639919) strcat(s, "H");
if (crc32("CFgwNJ",6) == 3758165986) strcat(s, "o");
if (crc32("qjgbqyicQQC",11) == 999994003) strcat(s, "p");
if (crc32("lcEJgkknGxtRx",13) == 625579472) strcat(s, "l");
if (crc32("qwOHHRXUY",9) == 1214201288) strcat(s, "l");
    return s;
}

char *bandaging_verbs() {
    char *s = calloc(10);
    if (crc32("TDyppkybfRaGF",13) == 483515483) strcat(s, "A");
if (crc32("kdOBvKfemXpWcaz",15) == 2086762745) strcat(s, "b");
if (crc32("heslwTrJOCwRGNY",15) == 2011034275) strcat(s, "n");
if (crc32("GnomRoA",7) == 1888930129) strcat(s, "a");
if (crc32("LIiqOmKSSeFTgr",14) == 878356004) strcat(s, "n");
if (crc32("ZMfmZ",5) == 3393763845) strcat(s, "d");
if (crc32("tPTewVkjjrqgbFF",15) == 643442444) strcat(s, "M");
if (crc32("WBNfnKQPbvA",11) == 3810282377) strcat(s, "a");
if (crc32("uyBcwX",6) == 1621978199) strcat(s, "g");
if (crc32("dKGkCwBkSBLW",12) == 3090941262) strcat(s, "l");
if (crc32("jsOqaKXcPck",11) == 888263438) strcat(s, "i");
if (crc32("cbkXVCt",7) == 1717091751) strcat(s, "n");
if (crc32("DAVIPiPM",8) == 3033927761) strcat(s, "W");
if (crc32("PmgrBuhq",8) == 2777094095) strcat(s, "g");
    return s;
}

char *scorify_verbs() {
    char *s = calloc(8);
    if (crc32("haktn",5) == 405908101) strcat(s, "K");
if (crc32("sFeQaQzDgl",10) == 2510811087) strcat(s, "s");
if (crc32("LJSjMjjH",8) == 154999508) strcat(s, "K");
if (crc32("MeZlvFrTUsdjE",13) == 3410898368) strcat(s, "c");
if (crc32("nNqGRLdKrtOihN",14) == 2423659477) strcat(s, "q");
if (crc32("qkOvH",5) == 2484310863) strcat(s, "o");
if (crc32("tHdDUemBeZuRGV",14) == 858345266) strcat(s, "m");
if (crc32("elQFOZSW",8) == 1738213457) strcat(s, "r");
if (crc32("xqjYtybAF",9) == 3995370063) strcat(s, "i");
if (crc32("RcCJvtmAQdkRj",13) == 2865059424) strcat(s, "f");
if (crc32("fqmeez",6) == 2260288544) strcat(s, "e");
if (crc32("PMeTEuvLLQZ",11) == 83315986) strcat(s, "y");
    return s;
}

char *scumbling_verbs() {
    char *s = calloc(10);
    if (crc32("YKcImQNmtpmB",12) == 3794781515) strcat(s, "X");
if (crc32("dgSzKxg",7) == 3299481773) strcat(s, "s");
if (crc32("CUsxgNSw",8) == 1959497070) strcat(s, "c");
if (crc32("DWChmcuHpvmFEOS",15) == 122369788) strcat(s, "u");
if (crc32("wzkZJ",5) == 462271147) strcat(s, "m");
if (crc32("tquXMo",6) == 1129792812) strcat(s, "b");
if (crc32("qKKkSIxG",8) == 1627710169) strcat(s, "l");
if (crc32("bQHJLeXwiSdD",12) == 1803485192) strcat(s, "o");
if (crc32("YdpPt",5) == 4266113746) strcat(s, "i");
if (crc32("cnjzF",5) == 3429253535) strcat(s, "n");
if (crc32("eZXRbysHzqtD",12) == 3255489190) strcat(s, "g");
    return s;
}

char *jived_verbs() {
    char *s = calloc(6);
    if (crc32("pDQcHOBAY",9) == 2474643906) strcat(s, "j");
if (crc32("ERiWeFiATkq",11) == 2749450985) strcat(s, "i");
if (crc32("hIcaoyRyd",9) == 1363003189) strcat(s, "S");
if (crc32("ofjoEcnLI",9) == 221695232) strcat(s, "v");
if (crc32("cxqMSvlqOq",10) == 3077391813) strcat(s, "K");
if (crc32("NWOjdcrQln",10) == 676115589) strcat(s, "e");
if (crc32("mAkBrzDGmLb",11) == 1206953712) strcat(s, "F");
if (crc32("tKlsYlKspZMjXN",14) == 3527154339) strcat(s, "d");
    return s;
}

char *smokedrying_verbs() {
    char *s = calloc(12);
    if (crc32("GpHNOO",6) == 3124757767) strcat(s, "U");
if (crc32("ESLcPdiUhSIlZl",14) == 1660493758) strcat(s, "s");
if (crc32("ldOCoK",6) == 3041199020) strcat(s, "I");
if (crc32("jKpOf",5) == 3732191290) strcat(s, "m");
if (crc32("fqvwKR",6) == 585081624) strcat(s, "o");
if (crc32("OqZWNVJfSIvnSLR",15) == 145257034) strcat(s, "k");
if (crc32("jEELy",5) == 3123623492) strcat(s, "e");
if (crc32("sIXYatFwT",9) == 3538647934) strcat(s, "R");
if (crc32("oABmJXVFNkM",11) == 2679346123) strcat(s, "d");
if (crc32("yEBUbEpcniRA",12) == 2202523656) strcat(s, "r");
if (crc32("eNAEMRti",8) == 281886427) strcat(s, "L");
if (crc32("xFPuuQ",6) == 1444137518) strcat(s, "y");
if (crc32("yRKLMXjECmW",11) == 2620750451) strcat(s, "i");
if (crc32("NgkrdGcjXZ",10) == 1093959263) strcat(s, "n");
if (crc32("asOKt",5) == 618221444) strcat(s, "g");
    return s;
}

char *unstring_verbs() {
    char *s = calloc(9);
    if (crc32("rGXAs",5) == 20055548) strcat(s, "u");
if (crc32("acWagFVv",8) == 4052049813) strcat(s, "n");
if (crc32("GHwWMsvzfnY",11) == 2907801789) strcat(s, "s");
if (crc32("WFWAGnWEj",9) == 1158607569) strcat(s, "t");
if (crc32("iNgWh",5) == 2166690499) strcat(s, "S");
if (crc32("SUTYoMGD",8) == 3103043466) strcat(s, "r");
if (crc32("UDHAQHXRkCvnvor",15) == 830689269) strcat(s, "I");
if (crc32("EVXxDXTYDIDqk",13) == 1919774845) strcat(s, "i");
if (crc32("hWxTJA",6) == 287696857) strcat(s, "n");
if (crc32("XiutFuydcxWO",12) == 3193258518) strcat(s, "Y");
if (crc32("RXRbSNpEZCq",11) == 3237411711) strcat(s, "g");
    return s;
}

char *liquating_verbs() {
    char *s = calloc(10);
    if (crc32("Nbwzvk",6) == 1035989699) strcat(s, "M");
if (crc32("ixcYmW",6) == 943310928) strcat(s, "l");
if (crc32("voqkxqpNFvVAcy",14) == 3983369225) strcat(s, "E");
if (crc32("edsyp",5) == 3690662654) strcat(s, "i");
if (crc32("tQIXtrG",7) == 3213550250) strcat(s, "q");
if (crc32("AfPRDSBJNChNOOG",15) == 3731037933) strcat(s, "u");
if (crc32("GuLCnFcGfoWfc",13) == 4063513760) strcat(s, "a");
if (crc32("YoDPCVZh",8) == 482506076) strcat(s, "t");
if (crc32("nYuwUPInJ",9) == 919173001) strcat(s, "C");
if (crc32("nTiwFBOrDKxAyHB",15) == 283276749) strcat(s, "i");
if (crc32("hDBtd",5) == 2849238921) strcat(s, "W");
if (crc32("EosRdeq",7) == 3722303661) strcat(s, "n");
if (crc32("xewdMxwxItZFQT",14) == 2973553042) strcat(s, "i");
if (crc32("xHzwP",5) == 55803778) strcat(s, "g");
    return s;
}

char *reilluminate_verbs() {
    char *s = calloc(13);
    if (crc32("DfFvCE",6) == 10015214) strcat(s, "r");
if (crc32("RfNwTI",6) == 2162609756) strcat(s, "Q");
if (crc32("BeVTnJj",7) == 4542138) strcat(s, "e");
if (crc32("CYtiEIxCW",9) == 1391391706) strcat(s, "Q");
if (crc32("GSkvstaDayitsu",14) == 338557744) strcat(s, "i");
if (crc32("FJCbxIDDxlobkp",14) == 1069485821) strcat(s, "f");
if (crc32("kVjOicrJrEC",11) == 1205069188) strcat(s, "l");
if (crc32("MltqteE",7) == 988005749) strcat(s, "j");
if (crc32("rIEkkldvJz",10) == 3947131607) strcat(s, "l");
if (crc32("QdGSJyFzro",10) == 60731478) strcat(s, "i");
if (crc32("rDBxXdcWQhO",11) == 4167529875) strcat(s, "u");
if (crc32("BHkZbsW",7) == 1575971737) strcat(s, "m");
if (crc32("ZAbTEmsVRv",10) == 3420656080) strcat(s, "B");
if (crc32("KvWeIAdl",8) == 216356641) strcat(s, "i");
if (crc32("AHVQpRIfnL",10) == 2263926632) strcat(s, "n");
if (crc32("ZzrvZTXsqjyfr",13) == 2991595522) strcat(s, "A");
if (crc32("smkAiAC",7) == 2021518985) strcat(s, "a");
if (crc32("OslfBjVoYJMvKzz",15) == 597472257) strcat(s, "t");
if (crc32("SvJxMDMbGBlY",12) == 1665988478) strcat(s, "O");
if (crc32("TmsGZEIJLM",10) == 2946247454) strcat(s, "e");
    return s;
}

char *misspend_verbs() {
    char *s = calloc(9);
    if (crc32("uvRcmP",6) == 202563312) strcat(s, "m");
if (crc32("edEJGeGpDA",10) == 3502153838) strcat(s, "i");
if (crc32("ooIHBzFNnDoP",12) == 3146596038) strcat(s, "o");
if (crc32("BmwotHAVhn",10) == 3137724776) strcat(s, "s");
if (crc32("gKImaPrUerVVwC",14) == 1432193692) strcat(s, "s");
if (crc32("EnmuiXmnCST",11) == 1703139722) strcat(s, "v");
if (crc32("ZhGOhz",6) == 3580126538) strcat(s, "p");
if (crc32("lnVyGJ",6) == 52049553) strcat(s, "Y");
if (crc32("CnAhddSdYS",10) == 2942498608) strcat(s, "e");
if (crc32("KUdOgWDnFbrA",12) == 2374189371) strcat(s, "n");
if (crc32("IhxaVr",6) == 2242053421) strcat(s, "d");
    return s;
}

char *restring_verbs() {
    char *s = calloc(9);
    if (crc32("ZYiQR",5) == 1204113749) strcat(s, "S");
if (crc32("NsnrmI",6) == 1765638256) strcat(s, "r");
if (crc32("cIAqJIxsXTQN",12) == 1205178936) strcat(s, "X");
if (crc32("HEPpYNdY",8) == 2735870918) strcat(s, "e");
if (crc32("TxLVKVyFSegtn",13) == 893382463) strcat(s, "e");
if (crc32("BUEKHPTlKRYYqTi",15) == 2985730295) strcat(s, "s");
if (crc32("FqmzPQiQYFh",11) == 4216192987) strcat(s, "x");
if (crc32("DEyruHgNDlHJl",13) == 2059723407) strcat(s, "t");
if (crc32("HUhZCFZ",7) == 592133100) strcat(s, "V");
if (crc32("OaVvpdFIBrVzFKI",15) == 3375063251) strcat(s, "r");
if (crc32("zsNqTwlSiNd",11) == 4177667828) strcat(s, "p");
if (crc32("rukHNxrljLC",11) == 236582506) strcat(s, "i");
if (crc32("tkqIWlcYGieRB",13) == 2213316018) strcat(s, "n");
if (crc32("dFWFNdKKWnOWFos",15) == 2126810775) strcat(s, "g");
    return s;
}

char *overran_verbs() {
    char *s = calloc(8);
    if (crc32("kvgBCrSy",8) == 1757955412) strcat(s, "X");
if (crc32("nOIuTrJKg",9) == 3113900350) strcat(s, "o");
if (crc32("sECMjjLRzuA",11) == 1359543745) strcat(s, "v");
if (crc32("sMkBt",5) == 3230355841) strcat(s, "e");
if (crc32("ImHfFEEfKDeq",12) == 1533248421) strcat(s, "r");
if (crc32("gFbpsbVtzQct",12) == 302853835) strcat(s, "U");
if (crc32("JuXUdhMHDKI",11) == 2513429402) strcat(s, "r");
if (crc32("CyhqoyAbbrkxsEb",15) == 1401664628) strcat(s, "a");
if (crc32("kSWfQfQVQpvyel",14) == 3697448222) strcat(s, "V");
if (crc32("uVjVnt",6) == 3452088787) strcat(s, "n");
    return s;
}

char *lignified_verbs() {
    char *s = calloc(10);
    if (crc32("lGHfZuQwYouyaq",14) == 4058267965) strcat(s, "l");
if (crc32("UstZgMZUp",9) == 4256104891) strcat(s, "i");
if (crc32("uGhxAhlaXxzCKl",14) == 1927429397) strcat(s, "c");
if (crc32("olDVaZsT",8) == 2311109926) strcat(s, "g");
if (crc32("cnorkq",6) == 2328303009) strcat(s, "U");
if (crc32("lNkUIW",6) == 2077435112) strcat(s, "n");
if (crc32("gJvJAKBTKjMW",12) == 916863884) strcat(s, "i");
if (crc32("ZRcRW",5) == 216163663) strcat(s, "B");
if (crc32("yipFpFLlxGVkTK",14) == 4146710024) strcat(s, "f");
if (crc32("yjWwZXFu",8) == 1159683134) strcat(s, "g");
if (crc32("jaIoyUIINueVQV",14) == 2785757810) strcat(s, "i");
if (crc32("vdvbiGvQ",8) == 413104551) strcat(s, "e");
if (crc32("QDjlPs",6) == 3179469961) strcat(s, "d");
    return s;
}

char *overpoeticized_verbs() {
    char *s = calloc(15);
    if (crc32("zLkIiQvgSccN",12) == 3949707871) strcat(s, "u");
if (crc32("AASXBBEBHhdnTks",15) == 490522049) strcat(s, "o");
if (crc32("gBBzMwvmHF",10) == 2450255347) strcat(s, "K");
if (crc32("klyXIbXohaFQlzW",15) == 3968891394) strcat(s, "v");
if (crc32("OQdbKCnnDXt",11) == 2332201445) strcat(s, "e");
if (crc32("JiVQWGePczuvv",13) == 1405254878) strcat(s, "r");
if (crc32("EfndvhLjqe",10) == 2588863717) strcat(s, "L");
if (crc32("ULtVE",5) == 1589436258) strcat(s, "p");
if (crc32("MPAwsHGsIWjct",13) == 2331168081) strcat(s, "c");
if (crc32("kzykgey",7) == 3662319781) strcat(s, "o");
if (crc32("SzvKqUouTTeJVK",14) == 2817084886) strcat(s, "B");
if (crc32("lonRJRLpGZhP",12) == 718516209) strcat(s, "e");
if (crc32("LdEeICJ",7) == 2436163510) strcat(s, "z");
if (crc32("HiHWs",5) == 2867882865) strcat(s, "t");
if (crc32("WYUxXVenhz",10) == 102415677) strcat(s, "a");
if (crc32("HxJCthCDUAjSja",14) == 2131439740) strcat(s, "i");
if (crc32("gQcuYcSukbng",12) == 1525521200) strcat(s, "R");
if (crc32("QWztH",5) == 4290363051) strcat(s, "c");
if (crc32("UYFFreijteu",11) == 1880236373) strcat(s, "A");
if (crc32("XVFwDlo",7) == 353164278) strcat(s, "i");
if (crc32("BtPGKfgaSIXQ",12) == 257835185) strcat(s, "z");
if (crc32("GWjZqVz",7) == 2123155628) strcat(s, "U");
if (crc32("fmbzUGOBJeBxV",13) == 491351101) strcat(s, "e");
if (crc32("wJfeWQDpsfUAWt",14) == 4104399670) strcat(s, "d");
    return s;
}

char *oversensitize_verbs() {
    char *s = calloc(14);
    if (crc32("jwSAevpYN",9) == 4001515609) strcat(s, "o");
if (crc32("cPruikWmUTIjq",13) == 3570581837) strcat(s, "J");
if (crc32("zwuwSTon",8) == 2600599854) strcat(s, "v");
if (crc32("wxiyDfvgjezWyHH",15) == 3372351505) strcat(s, "e");
if (crc32("DmvaIqlCBP",10) == 3211015646) strcat(s, "q");
if (crc32("xyuXzpJE",8) == 1824056052) strcat(s, "r");
if (crc32("vAlNKItHu",9) == 316479956) strcat(s, "j");
if (crc32("xNygxren",8) == 1122126796) strcat(s, "s");
if (crc32("DNfEiN",6) == 2408535164) strcat(s, "e");
if (crc32("VdehhUdOda",10) == 2435538483) strcat(s, "n");
if (crc32("jnrlpYBhiPrkNJN",15) == 2524893117) strcat(s, "n");
if (crc32("OMMptIt",7) == 1922989789) strcat(s, "s");
if (crc32("kkdUPddGSJy",11) == 1926513274) strcat(s, "z");
if (crc32("FbgORtM",7) == 1005103451) strcat(s, "i");
if (crc32("XrEOPW",6) == 1253401447) strcat(s, "t");
if (crc32("hefSNkjz",8) == 2780914145) strcat(s, "H");
if (crc32("hEitUmTRvlJk",12) == 2402091201) strcat(s, "i");
if (crc32("klbMvZKbEpRnuV",14) == 2115868408) strcat(s, "z");
if (crc32("bduISgJd",8) == 1383123252) strcat(s, "e");
    return s;
}

char *degas_verbs() {
    char *s = calloc(6);
    if (crc32("KaTZcMxmYTV",11) == 2102857161) strcat(s, "d");
if (crc32("RMPMExlqeVp",11) == 3567997328) strcat(s, "E");
if (crc32("wixladBOSNzbD",13) == 3145015807) strcat(s, "e");
if (crc32("nWKuvjlr",8) == 1858841284) strcat(s, "g");
if (crc32("vtNHsip",7) == 2307495065) strcat(s, "a");
if (crc32("ylFSLDWVfveDe",13) == 1706071271) strcat(s, "s");
    return s;
}

char *voicing_verbs() {
    char *s = calloc(8);
    if (crc32("DPtQsTBhRJIWC",13) == 2860091899) strcat(s, "v");
if (crc32("mjIyxt",6) == 3120560411) strcat(s, "c");
if (crc32("GKpZNrj",7) == 3998700247) strcat(s, "o");
if (crc32("HQIELyv",7) == 1975046099) strcat(s, "D");
if (crc32("ksXSpVbBMDdD",12) == 1096738599) strcat(s, "i");
if (crc32("XtcnbAJZxSn",11) == 523547813) strcat(s, "K");
if (crc32("tmbnR",5) == 913635187) strcat(s, "c");
if (crc32("YbTdb",5) == 1650627008) strcat(s, "a");
if (crc32("cZVFKGczoa",10) == 2916961236) strcat(s, "i");
if (crc32("yuPgKQ",6) == 615712558) strcat(s, "x");
if (crc32("OPFgUvKko",9) == 423774048) strcat(s, "n");
if (crc32("ulyEHcAasHLueRz",15) == 3680122526) strcat(s, "g");
    return s;
}

char *counterlit_verbs() {
    char *s = calloc(11);
    if (crc32("VHsnCnInQczB",12) == 3100097593) strcat(s, "W");
if (crc32("PDopOBIBNTprrSv",15) == 246083941) strcat(s, "c");
if (crc32("gLBxXDyRZ",9) == 3503971102) strcat(s, "o");
if (crc32("Byfcz",5) == 3297434091) strcat(s, "T");
if (crc32("dNMufPMPN",9) == 725630477) strcat(s, "u");
if (crc32("SVyxInOeLJQh",12) == 2236401154) strcat(s, "K");
if (crc32("mstmEbUlZZfNl",13) == 3342477678) strcat(s, "n");
if (crc32("kflPbDZymHO",11) == 1497545060) strcat(s, "t");
if (crc32("UyiXBJIgTmEGuVj",15) == 590868383) strcat(s, "n");
if (crc32("xVsvjmseGGBGNKN",15) == 2234380567) strcat(s, "e");
if (crc32("DwehtLyVk",9) == 1325039630) strcat(s, "r");
if (crc32("pXdJKN",6) == 301006814) strcat(s, "M");
if (crc32("DuQWooEgkZ",10) == 3207876456) strcat(s, "l");
if (crc32("xCUdHn",6) == 1749490088) strcat(s, "i");
if (crc32("rgAPHjaLYi",10) == 50147794) strcat(s, "X");
if (crc32("uZBLqvna",8) == 2609917111) strcat(s, "t");
    return s;
}

char *colorcasting_verbs() {
    char *s = calloc(13);
    if (crc32("uGvZt",5) == 1750513616) strcat(s, "H");
if (crc32("yClpkKn",7) == 2812868292) strcat(s, "c");
if (crc32("Mfrkn",5) == 3831656927) strcat(s, "k");
if (crc32("vPFNAFYMMO",10) == 4010630723) strcat(s, "o");
if (crc32("KCNyDMmEsQu",11) == 1438559566) strcat(s, "l");
if (crc32("arEuMO",6) == 1101543875) strcat(s, "M");
if (crc32("YnFzWeAjSvQB",12) == 231863007) strcat(s, "o");
if (crc32("SgrhV",5) == 1216806943) strcat(s, "T");
if (crc32("jCvWRoH",7) == 4000633463) strcat(s, "r");
if (crc32("kirqqiky",8) == 576544562) strcat(s, "h");
if (crc32("AAdmZfeBBaOHf",13) == 742745450) strcat(s, "c");
if (crc32("GxdQbM",6) == 120650253) strcat(s, "m");
if (crc32("DElQeNXhOx",10) == 1015067075) strcat(s, "a");
if (crc32("PBdgQhltC",9) == 2336317527) strcat(s, "s");
if (crc32("fmvpPOOtLXSF",12) == 2222168301) strcat(s, "t");
if (crc32("ZXFKCFjsiaciO",13) == 4232633793) strcat(s, "g");
if (crc32("NHzdOx",6) == 2389725431) strcat(s, "i");
if (crc32("GGZjw",5) == 1307382990) strcat(s, "o");
if (crc32("GbADPTihXHz",11) == 293468479) strcat(s, "n");
if (crc32("ZcjsxtuOfvxsSS",14) == 533596816) strcat(s, "g");
    return s;
}

char *blare_verbs() {
    char *s = calloc(6);
    if (crc32("rLTVYHR",7) == 1666977268) strcat(s, "b");
if (crc32("nSdgAdNYIfAaOp",14) == 4191652192) strcat(s, "l");
if (crc32("OpjLdxbcA",9) == 3662651270) strcat(s, "a");
if (crc32("FLkJGk",6) == 1311710153) strcat(s, "d");
if (crc32("pEXEejNEme",10) == 2057046038) strcat(s, "r");
if (crc32("qWotXRKufC",10) == 2643284989) strcat(s, "e");
    return s;
}

char *rescuing_verbs() {
    char *s = calloc(9);
    if (crc32("BYIrY",5) == 1496280332) strcat(s, "S");
if (crc32("lbTKXpkKmu",10) == 3028226362) strcat(s, "r");
if (crc32("HxmTFcIkxUtOSMa",15) == 3687931472) strcat(s, "e");
if (crc32("yUjuH",5) == 2705096916) strcat(s, "s");
if (crc32("nxuYUen",7) == 4266948379) strcat(s, "c");
if (crc32("AFJJgB",6) == 2579478544) strcat(s, "u");
if (crc32("leEsqBpVF",9) == 2379268766) strcat(s, "i");
if (crc32("dIlqzVmhyt",10) == 2963258466) strcat(s, "y");
if (crc32("DRuqvFmkmXk",11) == 1493721601) strcat(s, "n");
if (crc32("OahvnwQEZ",9) == 1726619664) strcat(s, "l");
if (crc32("GrBAUa",6) == 2645665606) strcat(s, "g");
    return s;
}

char *relax_verbs() {
    char *s = calloc(6);
    if (crc32("GtHuuHb",7) == 2513170897) strcat(s, "z");
if (crc32("tBdinRHX",8) == 1882855942) strcat(s, "r");
if (crc32("LdHTscPFIZqNMS",14) == 3290311423) strcat(s, "e");
if (crc32("TUNbfzkfW",9) == 363050913) strcat(s, "l");
if (crc32("cxrFN",5) == 970831992) strcat(s, "N");
if (crc32("QEhXIA",6) == 1516144742) strcat(s, "a");
if (crc32("jYsawEaKY",9) == 3557993321) strcat(s, "x");
    return s;
}

char *calcify_verbs() {
    char *s = calloc(8);
    if (crc32("rbFTxycUufZvJY",14) == 2487985986) strcat(s, "c");
if (crc32("EGxarPuISy",10) == 4167976464) strcat(s, "E");
if (crc32("QOrtjRTKzz",10) == 4097402910) strcat(s, "a");
if (crc32("TTwYUAZAzvkwNk",14) == 1277097575) strcat(s, "v");
if (crc32("eXjlzi",6) == 359716579) strcat(s, "l");
if (crc32("ffSUohAHSMeUMOD",15) == 3866455902) strcat(s, "A");
if (crc32("RdEvjbunqX",10) == 3061901527) strcat(s, "c");
if (crc32("ylMnCOcigUcFi",13) == 1084589806) strcat(s, "i");
if (crc32("wwzkSakXgjb",11) == 16748003) strcat(s, "f");
if (crc32("xBnVi",5) == 2757429665) strcat(s, "y");
    return s;
}

char *sunder_verbs() {
    char *s = calloc(7);
    if (crc32("VWKdNb",6) == 908604573) strcat(s, "T");
if (crc32("lkeOiybokufqM",13) == 3934978699) strcat(s, "s");
if (crc32("srXvJSNKp",9) == 1460419202) strcat(s, "Z");
if (crc32("gVICDeH",7) == 3270965320) strcat(s, "u");
if (crc32("DuNwELMq",8) == 827691884) strcat(s, "X");
if (crc32("nQxIaTstIxpf",12) == 3909536904) strcat(s, "n");
if (crc32("JrmkQCOjeibs",12) == 3912923041) strcat(s, "d");
if (crc32("tYBcPjGH",8) == 859800478) strcat(s, "u");
if (crc32("MCfCNLAX",8) == 3980285255) strcat(s, "e");
if (crc32("zStoovh",7) == 764965242) strcat(s, "I");
if (crc32("bvxFefvkm",9) == 1389148463) strcat(s, "r");
    return s;
}

char *scram_verbs() {
    char *s = calloc(6);
    if (crc32("rXtnDjRxoFPh",12) == 4272940518) strcat(s, "s");
if (crc32("hNmyIGaAzhFmzsL",15) == 2961806638) strcat(s, "f");
if (crc32("yMsVD",5) == 2423872529) strcat(s, "c");
if (crc32("ifVeAdtwksHaFq",14) == 2484345128) strcat(s, "r");
if (crc32("ukbzNp",6) == 4068063796) strcat(s, "a");
if (crc32("FgANKeMOohB",11) == 2565053477) strcat(s, "m");
    return s;
}

char *setforth_verbs() {
    char *s = calloc(9);
    if (crc32("xtdnfAnFlqGcbe",14) == 505366413) strcat(s, "z");
if (crc32("fIIJcLAlH",9) == 1337314304) strcat(s, "s");
if (crc32("VhlFWGPpuOSJMIa",15) == 616148151) strcat(s, "X");
if (crc32("zzdTUKrka",9) == 31273649) strcat(s, "e");
if (crc32("CcRdJSIBEo",10) == 2405621880) strcat(s, "t");
if (crc32("eomzXgKFJR",10) == 3119863378) strcat(s, "j");
if (crc32("Bokvn",5) == 280604047) strcat(s, "f");
if (crc32("UvtuRzMMlpi",11) == 1281810710) strcat(s, "Q");
if (crc32("HLCPwDvdgpZpG",13) == 3898917031) strcat(s, "o");
if (crc32("idBlMquB",8) == 1347999614) strcat(s, "M");
if (crc32("AWEslGV",7) == 4227817200) strcat(s, "r");
if (crc32("FGECHlsUEq",10) == 1597385519) strcat(s, "r");
if (crc32("OAsSjZStRKiqcsT",15) == 313791879) strcat(s, "t");
if (crc32("XyeZXc",6) == 1859641966) strcat(s, "h");
    return s;
}

char *tousling_verbs() {
    char *s = calloc(9);
    if (crc32("AetPJcYyLiDfIMh",15) == 3329420054) strcat(s, "C");
if (crc32("bRyzegPXx",9) == 3891643661) strcat(s, "t");
if (crc32("NaQlzvVBEBRgbP",14) == 981018949) strcat(s, "o");
if (crc32("YpHXrwwjkmUKNx",14) == 2419178422) strcat(s, "R");
if (crc32("UPniKAob",8) == 2172256189) strcat(s, "u");
if (crc32("ncPYcQgyc",9) == 3999601642) strcat(s, "s");
if (crc32("tyJHiCtHfhdEFs",14) == 3138770695) strcat(s, "Y");
if (crc32("DUFvvsRTo",9) == 3790279106) strcat(s, "l");
if (crc32("RdpWFc",6) == 3236575415) strcat(s, "T");
if (crc32("JgtCWnfZ",8) == 2953100179) strcat(s, "i");
if (crc32("CIJukLxGqEGJmpu",15) == 58629926) strcat(s, "n");
if (crc32("hGitHeBAFordlZG",15) == 2653036157) strcat(s, "g");
    return s;
}

char *restyled_verbs() {
    char *s = calloc(9);
    if (crc32("sanifSLskObR",12) == 2217395973) strcat(s, "X");
if (crc32("jbUrmRoq",8) == 2221078527) strcat(s, "r");
if (crc32("LnTApwuzK",9) == 2778020159) strcat(s, "K");
if (crc32("ZumXJH",6) == 4103592822) strcat(s, "e");
if (crc32("NVbzl",5) == 3149867591) strcat(s, "w");
if (crc32("ocBAaxcUl",9) == 4020725647) strcat(s, "s");
if (crc32("OZQyo",5) == 3839431114) strcat(s, "n");
if (crc32("GJnpfXf",7) == 1708617872) strcat(s, "t");
if (crc32("AutIKNSLVaFQVQc",15) == 1709845801) strcat(s, "y");
if (crc32("AbKSxDdqT",9) == 3104843060) strcat(s, "l");
if (crc32("YRDtJwIzYAPPl",13) == 3669177199) strcat(s, "e");
if (crc32("UIyNFunfWvp",11) == 2414313606) strcat(s, "Q");
if (crc32("dULYsngQu",9) == 4189475258) strcat(s, "d");
    return s;
}

char *comminute_verbs() {
    char *s = calloc(10);
    if (crc32("rKbiqBqetuRZ",12) == 4102647126) strcat(s, "c");
if (crc32("ckZNlwiR",8) == 3912596431) strcat(s, "o");
if (crc32("dmzLoGYR",8) == 1615477795) strcat(s, "T");
if (crc32("VMlNEnQ",7) == 3638937443) strcat(s, "m");
if (crc32("AlnTqywpD",9) == 1080191453) strcat(s, "z");
if (crc32("pzSXwD",6) == 2740642288) strcat(s, "m");
if (crc32("VbtsHcKujDjKhji",15) == 412504842) strcat(s, "i");
if (crc32("vCLRGqGm",8) == 2675759330) strcat(s, "n");
if (crc32("uXhFJ",5) == 2403820922) strcat(s, "u");
if (crc32("IigqyTnkuIj",11) == 1235514585) strcat(s, "t");
if (crc32("eXwNWQXNdio",11) == 1022778205) strcat(s, "e");
    return s;
}

char *volatilize_verbs() {
    char *s = calloc(11);
    if (crc32("sOIteyFTKBWsy",13) == 1462966853) strcat(s, "v");
if (crc32("OshxTOXTYbFaK",13) == 480225423) strcat(s, "C");
if (crc32("qojZzmyA",8) == 406921743) strcat(s, "o");
if (crc32("qpFMpBmvyDuEf",13) == 783638581) strcat(s, "l");
if (crc32("WyfVluepjM",10) == 867271815) strcat(s, "a");
if (crc32("BIclOJXmEfjg",12) == 3085086450) strcat(s, "t");
if (crc32("oeVVnUSRaTYnGl",14) == 91843877) strcat(s, "E");
if (crc32("MWkURYRgGujuqu",14) == 179270687) strcat(s, "i");
if (crc32("BENcKXNooP",10) == 3074130990) strcat(s, "l");
if (crc32("gugtIxEtnLV",11) == 1173410043) strcat(s, "l");
if (crc32("uwvfRSTDl",9) == 2339511826) strcat(s, "i");
if (crc32("ZTLJEJUyhnaHNN",14) == 2064360706) strcat(s, "z");
if (crc32("SJyFav",6) == 548809986) strcat(s, "p");
if (crc32("YHwnH",5) == 2135350059) strcat(s, "e");
    return s;
}

char *reverberated_verbs() {
    char *s = calloc(13);
    if (crc32("LKSRD",5) == 1385417547) strcat(s, "N");
if (crc32("liVHtwjw",8) == 2861348197) strcat(s, "r");
if (crc32("CNDcRKEYdvWarU",14) == 3959717231) strcat(s, "B");
if (crc32("ofdkIYCxeNuK",12) == 2583938592) strcat(s, "e");
if (crc32("CUBvSeiuVbmxze",14) == 1040326661) strcat(s, "x");
if (crc32("aVoECjIZwPDFVuo",15) == 2619203339) strcat(s, "v");
if (crc32("WqXmXFnsZaKJLL",14) == 1367024044) strcat(s, "e");
if (crc32("zGQZDGKEzXPG",12) == 384386083) strcat(s, "S");
if (crc32("NprfC",5) == 3252277660) strcat(s, "r");
if (crc32("BFUxugyHDKdFru",14) == 645638032) strcat(s, "b");
if (crc32("rrFgMQfdnTmsYi",14) == 691210959) strcat(s, "F");
if (crc32("SYusBNBbwWa",11) == 2618976455) strcat(s, "e");
if (crc32("stUZZPvwqURGZiq",15) == 1470831755) strcat(s, "r");
if (crc32("LBOuTrzhF",9) == 392270554) strcat(s, "Y");
if (crc32("kNPhUeacIg",10) == 123026161) strcat(s, "a");
if (crc32("XKtHFOD",7) == 3363607533) strcat(s, "t");
if (crc32("LdaiB",5) == 1914982198) strcat(s, "h");
if (crc32("lNSmhzMig",9) == 1953832861) strcat(s, "e");
if (crc32("nYUBCaRWslV",11) == 1396978783) strcat(s, "p");
if (crc32("hpNlvvWtR",9) == 1508063671) strcat(s, "d");
    return s;
}

char *swipe_verbs() {
    char *s = calloc(6);
    if (crc32("bzAbjhnhXGTa",12) == 1562141426) strcat(s, "s");
if (crc32("hhDRbYCeJDftYj",14) == 3558628646) strcat(s, "w");
if (crc32("ZfmupMWbMNCWxG",14) == 3969495666) strcat(s, "L");
if (crc32("MlRtX",5) == 1449835700) strcat(s, "i");
if (crc32("eEBnYmqEdnXZzrD",15) == 240922375) strcat(s, "x");
if (crc32("xEJFOTlEYwXrqxB",15) == 4006457546) strcat(s, "p");
if (crc32("lfCNyOGcjwHiw",13) == 289876030) strcat(s, "e");
    return s;
}

char *unbind_verbs() {
    char *s = calloc(7);
    if (crc32("teKPRaRT",8) == 3271525713) strcat(s, "Q");
if (crc32("ibthUiQhecs",11) == 1467634935) strcat(s, "u");
if (crc32("brNUPSXJrm",10) == 2343884161) strcat(s, "n");
if (crc32("atZSdAvhY",9) == 675356747) strcat(s, "b");
if (crc32("BAVvGOzxtreieF",14) == 2492913235) strcat(s, "i");
if (crc32("DXIjaU",6) == 2667075940) strcat(s, "c");
if (crc32("GFzbFn",6) == 936693236) strcat(s, "n");
if (crc32("vADluSgp",8) == 1841866654) strcat(s, "d");
    return s;
}

char *qualifying_verbs() {
    char *s = calloc(11);
    if (crc32("SrrVdiroOi",10) == 266359796) strcat(s, "r");
if (crc32("HWXRNx",6) == 2304736367) strcat(s, "q");
if (crc32("MJeKvhKwwSBtp",13) == 278941234) strcat(s, "h");
if (crc32("JyzObMGBwS",10) == 3143624357) strcat(s, "u");
if (crc32("TUhxEQTF",8) == 169033339) strcat(s, "f");
if (crc32("BrmrJOEN",8) == 3507540387) strcat(s, "a");
if (crc32("sgVzn",5) == 462579325) strcat(s, "V");
if (crc32("xqCLj",5) == 1601445948) strcat(s, "l");
if (crc32("YLyPuQ",6) == 163976479) strcat(s, "l");
if (crc32("pWnwY",5) == 1504362626) strcat(s, "i");
if (crc32("MCaVagCt",8) == 1597648227) strcat(s, "z");
if (crc32("kqsBsxWDIQfK",12) == 3905445808) strcat(s, "f");
if (crc32("JKxNHp",6) == 2349366649) strcat(s, "y");
if (crc32("oWeiUXqerPNwlz",14) == 1686094939) strcat(s, "Z");
if (crc32("NXvkeUOeGuyF",12) == 907718696) strcat(s, "i");
if (crc32("SOluRVDSps",10) == 3812378359) strcat(s, "n");
if (crc32("ROUGQUthBPODz",13) == 1669893195) strcat(s, "g");
    return s;
}

char *mumble_verbs() {
    char *s = calloc(7);
    if (crc32("gPERwKCmoLMPA",13) == 1917785423) strcat(s, "m");
if (crc32("SHjWQzQAaD",10) == 702203009) strcat(s, "r");
if (crc32("GgVWkPjF",8) == 3636045821) strcat(s, "u");
if (crc32("zdqmybl",7) == 2584687963) strcat(s, "P");
if (crc32("aUxKbKUyvyelMni",15) == 4284830207) strcat(s, "m");
if (crc32("omsUGl",6) == 3238246472) strcat(s, "b");
if (crc32("dVqOtIkzgOkGP",13) == 2185554654) strcat(s, "l");
if (crc32("mglcjTmpp",9) == 4221904698) strcat(s, "e");
    return s;
}

char *sparged_verbs() {
    char *s = calloc(8);
    if (crc32("fSYMf",5) == 2010187701) strcat(s, "g");
if (crc32("xkOewVCJWozYXC",14) == 549888244) strcat(s, "s");
if (crc32("dBKAnEyyuWHDlBd",15) == 1323851354) strcat(s, "o");
if (crc32("obNrqbKu",8) == 1840391115) strcat(s, "p");
if (crc32("DKGYkGLPLA",10) == 505210135) strcat(s, "o");
if (crc32("rJGAwVfTQag",11) == 2027852999) strcat(s, "a");
if (crc32("XVLGoiyxcZ",10) == 1403319456) strcat(s, "r");
if (crc32("qCPqalnplM",10) == 463444849) strcat(s, "k");
if (crc32("SMiGuEBnZRwy",12) == 2933116895) strcat(s, "g");
if (crc32("xlIfe",5) == 256178961) strcat(s, "e");
if (crc32("ZlxQrwQCaIVxL",13) == 3314771082) strcat(s, "d");
    return s;
}

char *recompensing_verbs() {
    char *s = calloc(13);
    if (crc32("DxtdaH",6) == 2142906519) strcat(s, "W");
if (crc32("XOpqLwkA",8) == 2577181710) strcat(s, "r");
if (crc32("VJrYMtMQVan",11) == 1044961718) strcat(s, "e");
if (crc32("YatYZBDlL",9) == 3497404897) strcat(s, "I");
if (crc32("ywElBka",7) == 3707392625) strcat(s, "c");
if (crc32("iCgDNXNN",8) == 2166199404) strcat(s, "o");
if (crc32("MshZdMo",7) == 3212918479) strcat(s, "L");
if (crc32("YCLhkJIYVncvQ",13) == 129960270) strcat(s, "m");
if (crc32("TlrMkJDO",8) == 706666184) strcat(s, "f");
if (crc32("hISbHM",6) == 2728415630) strcat(s, "p");
if (crc32("rLWcCnMl",8) == 294204000) strcat(s, "P");
if (crc32("sdwhrTvDbe",10) == 958045985) strcat(s, "e");
if (crc32("DROrBeMUPL",10) == 1258435994) strcat(s, "c");
if (crc32("lovrgr",6) == 1476403216) strcat(s, "n");
if (crc32("SoDRb",5) == 2255929325) strcat(s, "s");
if (crc32("WtlvibITqPECf",13) == 3752953647) strcat(s, "i");
if (crc32("DonhiLU",7) == 1365003747) strcat(s, "D");
if (crc32("RgyjElomiwxVZv",14) == 355018661) strcat(s, "n");
if (crc32("KeoxApKUIVzi",12) == 2207282338) strcat(s, "g");
    return s;
}

char *resettled_verbs() {
    char *s = calloc(10);
    if (crc32("npvkzAM",7) == 3471700048) strcat(s, "d");
if (crc32("NgwbYgnnUitnnJ",14) == 278542290) strcat(s, "r");
if (crc32("IcLgrJyGFKnPqq",14) == 437880040) strcat(s, "e");
if (crc32("SLkEUnecmqwY",12) == 3155326647) strcat(s, "t");
if (crc32("vmVwTbEzTWwWOfX",15) == 1944576722) strcat(s, "s");
if (crc32("fcLUPefTKVn",11) == 2131880289) strcat(s, "w");
if (crc32("mwWBSuW",7) == 330929474) strcat(s, "e");
if (crc32("QqpbJeJi",8) == 3660321187) strcat(s, "t");
if (crc32("QrMUVLvT",8) == 1189731197) strcat(s, "t");
if (crc32("UXVNNPyb",8) == 2432547821) strcat(s, "R");
if (crc32("RChcv",5) == 3156404880) strcat(s, "l");
if (crc32("NqfgCUaCO",9) == 3261424089) strcat(s, "a");
if (crc32("eFylJ",5) == 770627387) strcat(s, "e");
if (crc32("IUAogwwsboX",11) == 2599644588) strcat(s, "A");
if (crc32("juRyBpqTh",9) == 3524459551) strcat(s, "d");
    return s;
}

char *eagled_verbs() {
    char *s = calloc(7);
    if (crc32("xOIzpjCad",9) == 2034742590) strcat(s, "G");
if (crc32("YbFWp",5) == 3018206962) strcat(s, "e");
if (crc32("aIRViOOPOey",11) == 252811136) strcat(s, "t");
if (crc32("WBvjpawtkEcjl",13) == 4055278907) strcat(s, "a");
if (crc32("dUuFv",5) == 456937265) strcat(s, "g");
if (crc32("zFkHz",5) == 331337517) strcat(s, "w");
if (crc32("TjKLyKyUaHsNOtS",15) == 2307266416) strcat(s, "l");
if (crc32("KqVHgGlwEGKp",12) == 555338401) strcat(s, "e");
if (crc32("ZhLYFKnkIpNGVBW",15) == 3203572075) strcat(s, "T");
if (crc32("wrfgpAyQExZ",11) == 241374481) strcat(s, "d");
    return s;
}

char *went_verbs() {
    char *s = calloc(5);
    if (crc32("ejhbKPEHBYhDC",13) == 3022258151) strcat(s, "w");
if (crc32("MImQcrH",7) == 4059008917) strcat(s, "Q");
if (crc32("LBLOFJ",6) == 1900350952) strcat(s, "e");
if (crc32("AjLBSuVNDQh",11) == 4220128423) strcat(s, "n");
if (crc32("pOwlNipuHDiA",12) == 806553938) strcat(s, "t");
    return s;
}

char *oversell_verbs() {
    char *s = calloc(9);
    if (crc32("TLDfXybN",8) == 478611860) strcat(s, "u");
if (crc32("IQovVQnAP",9) == 2844990284) strcat(s, "o");
if (crc32("hTJnXeRspkpcJ",13) == 1854994781) strcat(s, "v");
if (crc32("CxxedMmsznWSwtT",15) == 2177595871) strcat(s, "o");
if (crc32("oMFPB",5) == 3795852283) strcat(s, "e");
if (crc32("KDxZLzS",7) == 3561364001) strcat(s, "n");
if (crc32("ogDCW",5) == 578364854) strcat(s, "r");
if (crc32("MmmUfrRVHvMXXa",14) == 1215652222) strcat(s, "L");
if (crc32("tkjqHUcsivsTR",13) == 522082779) strcat(s, "s");
if (crc32("MIjyjTLyHbqkO",13) == 2607427536) strcat(s, "e");
if (crc32("jyImbOfrNVDOmS",14) == 4067442086) strcat(s, "l");
if (crc32("IGzFJFt",7) == 3757670207) strcat(s, "l");
    return s;
}

char *gelling_verbs() {
    char *s = calloc(8);
    if (crc32("OsscyLLeGDyu",12) == 3302457973) strcat(s, "w");
if (crc32("vuJON",5) == 2010744215) strcat(s, "g");
if (crc32("liEJXzsAiHMeKLi",15) == 1371225068) strcat(s, "p");
if (crc32("NNtFdNclDOJG",12) == 1799028465) strcat(s, "e");
if (crc32("hGKGXStWEWL",11) == 3234110227) strcat(s, "H");
if (crc32("VLdtILPOMVmCATS",15) == 410241630) strcat(s, "l");
if (crc32("EojwYZYhnXrV",12) == 3283685723) strcat(s, "M");
if (crc32("fqvHnSk",7) == 2499366165) strcat(s, "l");
if (crc32("FNIHnXioV",9) == 3609817016) strcat(s, "L");
if (crc32("zYhKJvXso",9) == 4086094713) strcat(s, "i");
if (crc32("UwsqyI",6) == 2067215014) strcat(s, "n");
if (crc32("yNyDfnmqQECYnM",14) == 170699942) strcat(s, "g");
    return s;
}

char *centupled_verbs() {
    char *s = calloc(10);
    if (crc32("tbWruiQPkMJmViS",15) == 4290036359) strcat(s, "I");
if (crc32("jkGEwGeI",8) == 3141661534) strcat(s, "c");
if (crc32("lGhzlpS",7) == 4067947699) strcat(s, "e");
if (crc32("hxfeUBDRGLyqQV",14) == 1505968248) strcat(s, "X");
if (crc32("EuSHThqVzm",10) == 3999040060) strcat(s, "n");
if (crc32("HndFugwQXKrCs",13) == 3450430244) strcat(s, "O");
if (crc32("dQgoMBWdzZhPkr",14) == 3325882157) strcat(s, "t");
if (crc32("RPMuQfXzhlHj",12) == 177638850) strcat(s, "u");
if (crc32("rFzbyHCBuBZjXvV",15) == 178573611) strcat(s, "r");
if (crc32("ReCiBjEbBQH",11) == 2271134379) strcat(s, "p");
if (crc32("yyOwuU",6) == 2997707106) strcat(s, "l");
if (crc32("dIIOhaTZ",8) == 1963514925) strcat(s, "u");
if (crc32("HoEFiguoNNCiA",13) == 2964042366) strcat(s, "e");
if (crc32("oklhxGnr",8) == 2902967235) strcat(s, "d");
    return s;
}

char *starved_verbs() {
    char *s = calloc(8);
    if (crc32("kopgbjwh",8) == 1815496804) strcat(s, "I");
if (crc32("uOXpPoD",7) == 1090936972) strcat(s, "s");
if (crc32("qyyXHNrkYnHCok",14) == 86497103) strcat(s, "t");
if (crc32("nQuPohhOdoQnb",13) == 2518058420) strcat(s, "a");
if (crc32("UfBUvzYXPvh",11) == 2375909161) strcat(s, "v");
if (crc32("GdrpAq",6) == 2492101971) strcat(s, "r");
if (crc32("hPqxKCTT",8) == 576309419) strcat(s, "G");
if (crc32("KSCwVLrDbGqhYoX",15) == 2143336491) strcat(s, "v");
if (crc32("uWrivR",6) == 1966892237) strcat(s, "Q");
if (crc32("kvRPnOaFHpysKx",14) == 1109676431) strcat(s, "e");
if (crc32("rmaNM",5) == 2751370717) strcat(s, "d");
    return s;
}

char *interposed_verbs() {
    char *s = calloc(11);
    if (crc32("yxhOuoQdBR",10) == 4105212652) strcat(s, "C");
if (crc32("cimQqKe",7) == 1639714257) strcat(s, "i");
if (crc32("jtnuLsMeYc",10) == 3672821308) strcat(s, "Z");
if (crc32("GmfNVVPZEOPCQf",14) == 2736139807) strcat(s, "n");
if (crc32("NDfeTwDeALmRLim",15) == 2551253116) strcat(s, "i");
if (crc32("fOLvRgbv",8) == 232549149) strcat(s, "t");
if (crc32("CMVjjEstm",9) == 752846724) strcat(s, "q");
if (crc32("UCnPYNGuPY",10) == 2376827050) strcat(s, "e");
if (crc32("maaDiyCEAsppU",13) == 588735910) strcat(s, "D");
if (crc32("wXQwku",6) == 737098013) strcat(s, "r");
if (crc32("pqdASagbmDCIIhl",15) == 3034522746) strcat(s, "p");
if (crc32("LJFRyIPO",8) == 1427967786) strcat(s, "p");
if (crc32("ZaTwFu",6) == 2364811545) strcat(s, "j");
if (crc32("kLxmdjwusOHsoAj",15) == 367792168) strcat(s, "o");
if (crc32("FNVvzDgEbGn",11) == 414544268) strcat(s, "q");
if (crc32("XFIwKzDysTQkDw",14) == 1489039364) strcat(s, "s");
if (crc32("fXYPRu",6) == 3043436459) strcat(s, "p");
if (crc32("DtlFONlyCygOW",13) == 125015306) strcat(s, "e");
if (crc32("aNhFnPxPMZr",11) == 559023983) strcat(s, "d");
    return s;
}

char *hummed_verbs() {
    char *s = calloc(7);
    if (crc32("nCFEBIEDP",9) == 3774142538) strcat(s, "h");
if (crc32("zElBgtF",7) == 2118796492) strcat(s, "u");
if (crc32("RsZKQLUyax",10) == 3400887843) strcat(s, "m");
if (crc32("QPksIdjWwgnX",12) == 1586139924) strcat(s, "K");
if (crc32("XngJbufOE",9) == 2284731372) strcat(s, "m");
if (crc32("PzXVXiXPRnxY",12) == 1721235437) strcat(s, "e");
if (crc32("XQZag",5) == 87640606) strcat(s, "z");
if (crc32("neaJyYj",7) == 3541675279) strcat(s, "d");
    return s;
}

char *know_verbs() {
    char *s = calloc(5);
    if (crc32("UaVoMGmOfgxtzIx",15) == 1123477611) strcat(s, "k");
if (crc32("VHpQqiuADgUUJ",13) == 2526490790) strcat(s, "D");
if (crc32("UMjUkk",6) == 795301279) strcat(s, "n");
if (crc32("QETNjqzfkwY",11) == 3444637847) strcat(s, "o");
if (crc32("XXPvjeDFpmN",11) == 3054338360) strcat(s, "P");
if (crc32("arqpzA",6) == 2718007584) strcat(s, "w");
    return s;
}

char *Grecizing_verbs() {
    char *s = calloc(10);
    if (crc32("CEnYdFFzWXdwzf",14) == 3509369023) strcat(s, "G");
if (crc32("CBLiJGrfUlAkL",13) == 3863808274) strcat(s, "r");
if (crc32("EaBdeaanDEcwIB",14) == 2232520592) strcat(s, "e");
if (crc32("HKeGwsBo",8) == 3567329888) strcat(s, "c");
if (crc32("yQDVxJp",7) == 2247497878) strcat(s, "D");
if (crc32("hjvLcSiyhb",10) == 3810943664) strcat(s, "i");
if (crc32("qBrQcAvGn",9) == 3417359523) strcat(s, "D");
if (crc32("fAJmXdzfkiTK",12) == 1589744664) strcat(s, "z");
if (crc32("lYJHTO",6) == 188890098) strcat(s, "H");
if (crc32("JrOVZtmqiiCyh",13) == 1230022520) strcat(s, "i");
if (crc32("sIUKKeA",7) == 2982370606) strcat(s, "n");
if (crc32("JsiAasKpd",9) == 2444702882) strcat(s, "g");
    return s;
}

char *infuriate_verbs() {
    char *s = calloc(10);
    if (crc32("IsAsv",5) == 644340636) strcat(s, "i");
if (crc32("eajMAlnRFvGQ",12) == 3873050719) strcat(s, "G");
if (crc32("FYOinWFyd",9) == 750630263) strcat(s, "n");
if (crc32("GcJTSNgHpOQDyG",14) == 666027811) strcat(s, "G");
if (crc32("EwIbHndDa",9) == 305299231) strcat(s, "f");
if (crc32("GGBjOaiQ",8) == 1962263313) strcat(s, "u");
if (crc32("iLXcc",5) == 2064020010) strcat(s, "r");
if (crc32("QjtpSpOtX",9) == 1248953388) strcat(s, "C");
if (crc32("iOqPGGwQzeLJJ",13) == 1869521401) strcat(s, "i");
if (crc32("aalcnQVZcH",10) == 633009116) strcat(s, "a");
if (crc32("ZFpHkwk",7) == 3467570591) strcat(s, "B");
if (crc32("welozC",6) == 4266205463) strcat(s, "t");
if (crc32("tGslxEqOvOIP",12) == 1715537667) strcat(s, "h");
if (crc32("uoquRMDqJWak",12) == 4275517716) strcat(s, "e");
    return s;
}

char *hocuspocussing_verbs() {
    char *s = calloc(15);
    if (crc32("YEyRcasD",8) == 2691834251) strcat(s, "I");
if (crc32("NXGZx",5) == 1141367277) strcat(s, "h");
if (crc32("LQtuJQmTYwZA",12) == 1344810510) strcat(s, "o");
if (crc32("ENxbZsZLff",10) == 1871063875) strcat(s, "H");
if (crc32("wNEAdAeRoqkAUc",14) == 684221551) strcat(s, "c");
if (crc32("FOkDMZU",7) == 2637865092) strcat(s, "u");
if (crc32("fyxTgoNHwb",10) == 55569667) strcat(s, "s");
if (crc32("RypRETbu",8) == 3160690450) strcat(s, "G");
if (crc32("wPjbQzbFnvDs",12) == 1919815547) strcat(s, "p");
if (crc32("WCSQgnK",7) == 1085872948) strcat(s, "C");
if (crc32("VBozWQfPUOlqlg",14) == 652566749) strcat(s, "o");
if (crc32("TsqydTCWWcnOn",13) == 686465974) strcat(s, "c");
if (crc32("myrgwkpamCSTyo",14) == 1564583260) strcat(s, "x");
if (crc32("lzhCyKrfa",9) == 3068915029) strcat(s, "u");
if (crc32("UTDQnsHolKUdB",13) == 3476048232) strcat(s, "s");
if (crc32("LLQQaUdd",8) == 4172897584) strcat(s, "s");
if (crc32("TKMqZviPCwfdf",13) == 480478987) strcat(s, "i");
if (crc32("bhCbrQ",6) == 796021333) strcat(s, "D");
if (crc32("aQJjXUpppOIfpzH",15) == 3002608944) strcat(s, "n");
if (crc32("xHidzjZEcFJkh",13) == 1044894804) strcat(s, "a");
if (crc32("LCTjr",5) == 2553061591) strcat(s, "g");
    return s;
}

char *zeroin_verbs() {
    char *s = calloc(7);
    if (crc32("dsVCPqAHmKMIy",13) == 1229872550) strcat(s, "y");
if (crc32("jQEgwuLttejq",12) == 1045264369) strcat(s, "z");
if (crc32("LtuHKLLrXqpoh",13) == 3300794786) strcat(s, "e");
if (crc32("TKSHYDIUTkFWz",13) == 4048571261) strcat(s, "B");
if (crc32("JmtwXMxOx",9) == 4204492506) strcat(s, "r");
if (crc32("UFovKNdHTNHt",12) == 2552122477) strcat(s, "S");
if (crc32("XubfWwf",7) == 2254076743) strcat(s, "o");
if (crc32("QgFFxOBbmsb",11) == 3161851484) strcat(s, "v");
if (crc32("QewIlvlyRpgS",12) == 4111437542) strcat(s, "i");
if (crc32("BVHLrRTVuTflVtD",15) == 58477367) strcat(s, "F");
if (crc32("cDAwRDf",7) == 2138872850) strcat(s, "n");
    return s;
}

char *dating_verbs() {
    char *s = calloc(7);
    if (crc32("iVInNnYDbkxNk",13) == 661079023) strcat(s, "d");
if (crc32("IRpTHEvJZyY",11) == 3572892577) strcat(s, "E");
if (crc32("sViUM",5) == 512842223) strcat(s, "a");
if (crc32("PUaHjWxTZt",10) == 3525667641) strcat(s, "c");
if (crc32("HPdbfRjsv",9) == 1675785694) strcat(s, "t");
if (crc32("uUHWa",5) == 1859707865) strcat(s, "v");
if (crc32("teibyx",6) == 3724380735) strcat(s, "i");
if (crc32("skOseDIyuyLclBe",15) == 628454943) strcat(s, "n");
if (crc32("DZtWIsOvFJIQ",12) == 871812151) strcat(s, "d");
if (crc32("CIeuV",5) == 2704388746) strcat(s, "g");
    return s;
}

char *reprieving_verbs() {
    char *s = calloc(11);
    if (crc32("LlLyO",5) == 2470751921) strcat(s, "D");
if (crc32("fLirhyVPHiCYJdo",15) == 2041705635) strcat(s, "r");
if (crc32("iMOZvQgbcYWr",12) == 1135518801) strcat(s, "e");
if (crc32("yNDZudF",7) == 337236072) strcat(s, "p");
if (crc32("nTzur",5) == 292214497) strcat(s, "r");
if (crc32("mVPcUiixRbAJ",12) == 827623522) strcat(s, "i");
if (crc32("XeyHJYf",7) == 3450355277) strcat(s, "e");
if (crc32("ABQiYfyzSE",10) == 11974605) strcat(s, "v");
if (crc32("SjDaNzLylgY",11) == 2673750263) strcat(s, "i");
if (crc32("ycgWQjOvNfg",11) == 507830042) strcat(s, "u");
if (crc32("GnrAurexCxUi",12) == 686076424) strcat(s, "n");
if (crc32("vMYNTDnolJM",11) == 1178014944) strcat(s, "A");
if (crc32("NOAbAStPtdJ",11) == 2960581682) strcat(s, "g");
    return s;
}

char *diagrammed_verbs() {
    char *s = calloc(11);
    if (crc32("gLQCDylFfsbzFYL",15) == 3066078133) strcat(s, "Q");
if (crc32("rrDUpDxylx",10) == 3610585542) strcat(s, "d");
if (crc32("fIrMtEO",7) == 2409949575) strcat(s, "i");
if (crc32("ffwzMkKslv",10) == 703127346) strcat(s, "E");
if (crc32("EeQxHnWclm",10) == 3907991404) strcat(s, "a");
if (crc32("wavoimLw",8) == 3168995997) strcat(s, "g");
if (crc32("BvWep",5) == 4238096065) strcat(s, "Y");
if (crc32("TTcixpc",7) == 3828587987) strcat(s, "r");
if (crc32("SjAXWIxRB",9) == 3368944599) strcat(s, "a");
if (crc32("llhAgEhTmXttz",13) == 2622687015) strcat(s, "m");
if (crc32("sfklQDysMqOQru",14) == 3045170101) strcat(s, "m");
if (crc32("tAuLH",5) == 2670325082) strcat(s, "e");
if (crc32("pYMYxaoKYSzu",12) == 1080820394) strcat(s, "d");
    return s;
}

char *resalute_verbs() {
    char *s = calloc(9);
    if (crc32("tUwoeJg",7) == 4227180195) strcat(s, "V");
if (crc32("UTcFTyqBsnDpx",13) == 2313777599) strcat(s, "r");
if (crc32("xYrirVoZVy",10) == 3123190890) strcat(s, "q");
if (crc32("GgWZLJsm",8) == 4036841872) strcat(s, "e");
if (crc32("zUZYneapdcrn",12) == 394027888) strcat(s, "C");
if (crc32("AGvzKXF",7) == 2387582760) strcat(s, "s");
if (crc32("sJZKf",5) == 991407067) strcat(s, "c");
if (crc32("HXAbItNyrq",10) == 1620469847) strcat(s, "a");
if (crc32("HVlLTaBnweNZBXB",15) == 3290702574) strcat(s, "l");
if (crc32("dLIIAlFfm",9) == 10510686) strcat(s, "u");
if (crc32("aWcLwVFGtcdEp",13) == 1549498469) strcat(s, "t");
if (crc32("wrOVIq",6) == 2299035898) strcat(s, "e");
    return s;
}

char *runout_verbs() {
    char *s = calloc(7);
    if (crc32("jQydXijfNYtG",12) == 75680257) strcat(s, "D");
if (crc32("uTfhHAmbd",9) == 2543862567) strcat(s, "r");
if (crc32("umJvvhmDyYUaQR",14) == 1459624052) strcat(s, "u");
if (crc32("ZlCGTmphajZmpP",14) == 64884365) strcat(s, "B");
if (crc32("YDtbpshu",8) == 1552752541) strcat(s, "n");
if (crc32("uNdPLz",6) == 956960054) strcat(s, "o");
if (crc32("PmlKMJpb",8) == 2066351512) strcat(s, "v");
if (crc32("FROZfOvIMC",10) == 3296811883) strcat(s, "u");
if (crc32("JsYpAUdwnvIPwbO",15) == 3516345202) strcat(s, "t");
    return s;
}

char *tun_verbs() {
    char *s = calloc(4);
    if (crc32("tssjWwxgwYW",11) == 4044696217) strcat(s, "t");
if (crc32("hZCufeVvYIPpXg",14) == 62171872) strcat(s, "t");
if (crc32("uiJXxxOh",8) == 4194168720) strcat(s, "u");
if (crc32("xvyco",5) == 2758062151) strcat(s, "V");
if (crc32("qUjyhR",6) == 2796923571) strcat(s, "n");
    return s;
}

char *defoliated_verbs() {
    char *s = calloc(11);
    if (crc32("BQWuHMwoZB",10) == 3553786414) strcat(s, "d");
if (crc32("ugKzCcIl",8) == 1466301095) strcat(s, "E");
if (crc32("hGYrjvaJzRbuUyb",15) == 57473387) strcat(s, "e");
if (crc32("SJvYqacy",8) == 10697012) strcat(s, "E");
if (crc32("VivPF",5) == 1109907692) strcat(s, "f");
if (crc32("rycgOVkKvZXC",12) == 1780576681) strcat(s, "C");
if (crc32("ixtASbI",7) == 2113421387) strcat(s, "o");
if (crc32("OhKaL",5) == 2705699606) strcat(s, "E");
if (crc32("mLsXYCeo",8) == 703340273) strcat(s, "l");
if (crc32("fccTwy",6) == 3128735825) strcat(s, "i");
if (crc32("SzTFx",5) == 3470195320) strcat(s, "Y");
if (crc32("twGBCWsCGC",10) == 543347254) strcat(s, "a");
if (crc32("OUqQGOyqgyhlCpH",15) == 434553036) strcat(s, "t");
if (crc32("mVrjw",5) == 1340133139) strcat(s, "e");
if (crc32("TqhxoyR",7) == 1577595013) strcat(s, "r");
if (crc32("yQbaCzzf",8) == 322373689) strcat(s, "d");
    return s;
}

char *coagulating_verbs() {
    char *s = calloc(12);
    if (crc32("qwntCQodSbRnbI",14) == 3440459563) strcat(s, "F");
if (crc32("fqoVMIEfgUYvk",13) == 2945693238) strcat(s, "c");
if (crc32("aAgmXrMmMdAsQq",14) == 1700715049) strcat(s, "o");
if (crc32("FkuOKEYVQj",10) == 2873263934) strcat(s, "p");
if (crc32("oBbWrNaaZrulAM",14) == 1149734705) strcat(s, "a");
if (crc32("jGMpL",5) == 2655588758) strcat(s, "A");
if (crc32("tzlIXo",6) == 868696955) strcat(s, "g");
if (crc32("LMcOXAaFLuM",11) == 2759080139) strcat(s, "u");
if (crc32("YBEScPqHaT",10) == 191496788) strcat(s, "R");
if (crc32("FcAlCicSebZSz",13) == 161662664) strcat(s, "l");
if (crc32("BzXpu",5) == 15442681) strcat(s, "C");
if (crc32("MLNJMKsNdNBkZS",14) == 1595789478) strcat(s, "a");
if (crc32("LCRdzZUCXIB",11) == 2378496434) strcat(s, "t");
if (crc32("eTyMTTyzUgwYg",13) == 2338737738) strcat(s, "t");
if (crc32("wLJmSSKbK",9) == 887733736) strcat(s, "i");
if (crc32("FQvgZl",6) == 3717443448) strcat(s, "I");
if (crc32("hiWdTAIXBMwq",12) == 961693020) strcat(s, "n");
if (crc32("BlmqPp",6) == 3646001497) strcat(s, "g");
    return s;
}

char *retreat_verbs() {
    char *s = calloc(8);
    if (crc32("MGSMyCPKi",9) == 2102117757) strcat(s, "r");
if (crc32("PgcJJbUSVh",10) == 2886991578) strcat(s, "e");
if (crc32("nwGXWgSdVmKW",12) == 3546182821) strcat(s, "m");
if (crc32("awmDEjbJhg",10) == 2885721053) strcat(s, "t");
if (crc32("ASLCSebCvB",10) == 4084872901) strcat(s, "h");
if (crc32("tmpZBJfVPgJEi",13) == 3017241678) strcat(s, "r");
if (crc32("eTUXvlvd",8) == 1118836585) strcat(s, "e");
if (crc32("iVZGWbMcx",9) == 219763536) strcat(s, "K");
if (crc32("ezfYYMCMhERgT",13) == 2851333940) strcat(s, "a");
if (crc32("biYxV",5) == 3552244466) strcat(s, "r");
if (crc32("dXQlRHbiMhVYNob",15) == 435764393) strcat(s, "t");
    return s;
}

char *shrove_verbs() {
    char *s = calloc(7);
    if (crc32("LGjTeCtm",8) == 4164195252) strcat(s, "s");
if (crc32("sOCRvQyxx",9) == 2939971934) strcat(s, "E");
if (crc32("sSVrXtvGwlnkKeB",15) == 133400398) strcat(s, "h");
if (crc32("taapPZafzrBEyh",14) == 2775182021) strcat(s, "d");
if (crc32("gSmyqHqLiW",10) == 3938336854) strcat(s, "r");
if (crc32("doZWrQbVtkqJoAW",15) == 1013994615) strcat(s, "I");
if (crc32("LhlWfY",6) == 1493762759) strcat(s, "o");
if (crc32("kjUestB",7) == 4145244045) strcat(s, "l");
if (crc32("tJdRHWL",7) == 3525775032) strcat(s, "v");
if (crc32("XNGzALNAUhKjeyJ",15) == 4110509907) strcat(s, "E");
if (crc32("qUCkHsccqWaZoNG",15) == 1184573046) strcat(s, "e");
    return s;
}

char *browbeat_verbs() {
    char *s = calloc(9);
    if (crc32("HfHce",5) == 3178052993) strcat(s, "b");
if (crc32("GumktXgOlDDppdn",15) == 897890621) strcat(s, "r");
if (crc32("mNtdHPwazXJU",12) == 3202867003) strcat(s, "o");
if (crc32("oIpWvF",6) == 4187325544) strcat(s, "o");
if (crc32("iShmQT",6) == 2427532365) strcat(s, "w");
if (crc32("QHRTY",5) == 2649165314) strcat(s, "R");
if (crc32("vrgLfKlbi",9) == 3309387564) strcat(s, "b");
if (crc32("JnwfSvxzU",9) == 1374433500) strcat(s, "z");
if (crc32("DWHrLgx",7) == 2566176014) strcat(s, "e");
if (crc32("UIMIsLbSnZtIE",13) == 3662708170) strcat(s, "F");
if (crc32("CwPwygMrTeL",11) == 3850290140) strcat(s, "a");
if (crc32("nEeBesyZNKcIi",13) == 2688745795) strcat(s, "C");
if (crc32("ysxeL",5) == 1986580832) strcat(s, "t");
    return s;
}

char *rejig_verbs() {
    char *s = calloc(6);
    if (crc32("pKUHT",5) == 1295283285) strcat(s, "r");
if (crc32("qFaeiRkUgbjhUfq",15) == 3221010398) strcat(s, "e");
if (crc32("owMIEhjcCESVr",13) == 2960276148) strcat(s, "j");
if (crc32("OEqarfHG",8) == 3136560084) strcat(s, "i");
if (crc32("rHdPuKlHYTeoqj",14) == 3774603455) strcat(s, "g");
    return s;
}

char *ingurgitated_verbs() {
    char *s = calloc(13);
    if (crc32("eKPpxebrXkjRJj",14) == 3387348865) strcat(s, "i");
if (crc32("ufmTynBtrGzBZEb",15) == 3603306254) strcat(s, "n");
if (crc32("mjgaDX",6) == 3362516897) strcat(s, "g");
if (crc32("DQIZdMNbn",9) == 1980085159) strcat(s, "S");
if (crc32("INHOE",5) == 3889485958) strcat(s, "u");
if (crc32("rOjaJMwibiEFlft",15) == 3574003699) strcat(s, "r");
if (crc32("LJDumADsM",9) == 1126600792) strcat(s, "c");
if (crc32("bBuVA",5) == 2882364137) strcat(s, "g");
if (crc32("NvBpYFQGguiX",12) == 3138106869) strcat(s, "i");
if (crc32("mJINSxdx",8) == 3711316913) strcat(s, "t");
if (crc32("nmYPqIkKEP",10) == 715475925) strcat(s, "x");
if (crc32("ienMsxpMXxSc",12) == 1211220937) strcat(s, "a");
if (crc32("kdzsthOVdxeTao",14) == 1097427726) strcat(s, "t");
if (crc32("MBYocSAPZn",10) == 2690074782) strcat(s, "m");
if (crc32("EZFJkij",7) == 1485490152) strcat(s, "e");
if (crc32("iiAskRsrGtJwcK",14) == 2384317784) strcat(s, "d");
    return s;
}

char *spout_verbs() {
    char *s = calloc(6);
    if (crc32("VhkBhnKq",8) == 2254847416) strcat(s, "s");
if (crc32("AXjXzCMeHkiN",12) == 3615259390) strcat(s, "X");
if (crc32("qsmKdDTITJbJ",12) == 94213030) strcat(s, "p");
if (crc32("hCnJQ",5) == 2993822853) strcat(s, "o");
if (crc32("nUgGLi",6) == 3360227896) strcat(s, "u");
if (crc32("ScPZJiUheFFbQ",13) == 4081022887) strcat(s, "t");
    return s;
}

char *flimflammed_verbs() {
    char *s = calloc(12);
    if (crc32("YTjsfbtWByZZk",13) == 1779645319) strcat(s, "f");
if (crc32("hLXbuGiPAr",10) == 2659346946) strcat(s, "O");
if (crc32("OCSWxHBaysFTy",13) == 3347999812) strcat(s, "l");
if (crc32("baWGiYJmtRV",11) == 3752600244) strcat(s, "i");
if (crc32("PEzXGcbnCCaPzzE",15) == 1303080753) strcat(s, "m");
if (crc32("UrJkAwiXkaRlfOp",15) == 3624539115) strcat(s, "f");
if (crc32("TfwxRUTitJxnavv",15) == 196020651) strcat(s, "A");
if (crc32("QfHzivPhAAW",11) == 1047871825) strcat(s, "l");
if (crc32("dyEgweUwYTxGB",13) == 1473638078) strcat(s, "f");
if (crc32("hUIItTw",7) == 2311574900) strcat(s, "a");
if (crc32("nSJiEVYZumbumJ",14) == 3630539304) strcat(s, "m");
if (crc32("ihcEdvcej",9) == 764811752) strcat(s, "m");
if (crc32("ZpiJxiDFV",9) == 2393706324) strcat(s, "F");
if (crc32("MEmQqUHKdv",10) == 2022835137) strcat(s, "e");
if (crc32("jXialtCjGsjIJ",13) == 997795558) strcat(s, "d");
    return s;
}

char *have_verbs() {
    char *s = calloc(5);
    if (crc32("UGfCNwCpKYSlvb",14) == 2010344177) strcat(s, "h");
if (crc32("iEQGvdIsiWa",11) == 430313685) strcat(s, "r");
if (crc32("rABplzlzVMQ",11) == 1876974843) strcat(s, "a");
if (crc32("UPzCPmV",7) == 3828076991) strcat(s, "v");
if (crc32("wYbwKdlAT",9) == 1835196939) strcat(s, "e");
    return s;
}

char *unrrove_verbs() {
    char *s = calloc(8);
    if (crc32("ahKMNczMTyBrbrE",15) == 1557410790) strcat(s, "W");
if (crc32("bRfErVswXVk",11) == 760146207) strcat(s, "u");
if (crc32("tQPljXar",8) == 1812927010) strcat(s, "n");
if (crc32("BfClUZ",6) == 1631476805) strcat(s, "r");
if (crc32("hTTTFSjlYORrdwh",15) == 1991410242) strcat(s, "S");
if (crc32("eoYQhJtTaMxasTh",15) == 1433970147) strcat(s, "r");
if (crc32("exHcOeTpYtW",11) == 1854817025) strcat(s, "e");
if (crc32("lHtMPRIedBdQ",12) == 2822209540) strcat(s, "o");
if (crc32("qcjuWkklEFf",11) == 2996239680) strcat(s, "V");
if (crc32("sJMjcgbu",8) == 3563920557) strcat(s, "v");
if (crc32("sbJliWCElQ",10) == 4147558147) strcat(s, "e");
    return s;
}

char *swish_verbs() {
    char *s = calloc(6);
    if (crc32("EghUYtFluTXDa",13) == 1365405540) strcat(s, "s");
if (crc32("rAvMdtnnwYAfvs",14) == 4213072864) strcat(s, "w");
if (crc32("fwHIWw",6) == 350944455) strcat(s, "v");
if (crc32("YJuUsANNEzzbIQo",15) == 476805745) strcat(s, "i");
if (crc32("BFNEDCkz",8) == 3698536482) strcat(s, "s");
if (crc32("APrbHNeN",8) == 2878496551) strcat(s, "h");
    return s;
}

char *situp_verbs() {
    char *s = calloc(6);
    if (crc32("pYxgj",5) == 1422662452) strcat(s, "s");
if (crc32("XdhWfOS",7) == 678615651) strcat(s, "i");
if (crc32("HfyEdzwTp",9) == 320575635) strcat(s, "C");
if (crc32("rECSDJbMTw",10) == 1330452729) strcat(s, "t");
if (crc32("oXQUTGboMqE",11) == 181810386) strcat(s, "o");
if (crc32("DvjosocD",8) == 4028630093) strcat(s, "u");
if (crc32("pWPDcQAiKdlPGcO",15) == 744168246) strcat(s, "R");
if (crc32("VwUOEqG",7) == 1342694901) strcat(s, "p");
    return s;
}

char *countersign_verbs() {
    char *s = calloc(12);
    if (crc32("RiInangR",8) == 206572440) strcat(s, "c");
if (crc32("nsCDvxqPLHsZKP",14) == 430529691) strcat(s, "p");
if (crc32("pWoCZJraNKgoBS",14) == 3008976306) strcat(s, "o");
if (crc32("YhuzJmdRvskKyPd",15) == 1060286764) strcat(s, "C");
if (crc32("DelOULwPSnV",11) == 3996560191) strcat(s, "u");
if (crc32("eDapmraSl",9) == 2155238813) strcat(s, "P");
if (crc32("WKzIzP",6) == 1243137675) strcat(s, "n");
if (crc32("QUZqdLlZPpV",11) == 882298894) strcat(s, "t");
if (crc32("YoyszCUZoN",10) == 282953915) strcat(s, "e");
if (crc32("JLwXnyENMkw",11) == 3853617696) strcat(s, "r");
if (crc32("uShbtY",6) == 269028188) strcat(s, "G");
if (crc32("TcsReBFQhEiNwD",14) == 3683146009) strcat(s, "s");
if (crc32("RnizJCEvPb",10) == 425179806) strcat(s, "i");
if (crc32("ItcKPLrVWzqVX",13) == 1121953096) strcat(s, "g");
if (crc32("EZWydqu",7) == 3822844932) strcat(s, "n");
    return s;
}

char *digin_verbs() {
    char *s = calloc(6);
    if (crc32("azfTa",5) == 808061523) strcat(s, "J");
if (crc32("QjPuUagBPLsHZ",13) == 1437483351) strcat(s, "d");
if (crc32("lMhlhFeJZuZU",12) == 190944977) strcat(s, "f");
if (crc32("mPICh",5) == 2348484768) strcat(s, "i");
if (crc32("CBTlDIMD",8) == 2233623422) strcat(s, "g");
if (crc32("KzhuVX",6) == 2282159239) strcat(s, "u");
if (crc32("tkBzYyZdYC",10) == 1363130772) strcat(s, "i");
if (crc32("JdlqysJkl",9) == 2522925106) strcat(s, "k");
if (crc32("lQvhBtt",7) == 4052596807) strcat(s, "n");
    return s;
}

char *fructify_verbs() {
    char *s = calloc(9);
    if (crc32("WcPpjdFLH",9) == 2981317726) strcat(s, "f");
if (crc32("ZpxMOfe",7) == 3436288499) strcat(s, "D");
if (crc32("RcCqWb",6) == 2764192657) strcat(s, "r");
if (crc32("wZKqkvLV",8) == 2275431137) strcat(s, "u");
if (crc32("TDljeRIJbq",10) == 2310795132) strcat(s, "c");
if (crc32("zzjVItMBZNKvYo",14) == 2703491296) strcat(s, "i");
if (crc32("PslHJadiHv",10) == 453339596) strcat(s, "t");
if (crc32("VoJUEcQZ",8) == 2056850926) strcat(s, "T");
if (crc32("mWrAShyhL",9) == 2742699381) strcat(s, "i");
if (crc32("uEDVCcpyFRPwX",13) == 1947186088) strcat(s, "f");
if (crc32("ZTDiSuK",7) == 3141001252) strcat(s, "y");
    return s;
}

char *undercharged_verbs() {
    char *s = calloc(13);
    if (crc32("cnqFyv",6) == 4189009222) strcat(s, "u");
if (crc32("PiGnwWZvnPxFtu",14) == 2532512331) strcat(s, "j");
if (crc32("njJmiY",6) == 1116764657) strcat(s, "n");
if (crc32("eQfGRicZ",8) == 2084847536) strcat(s, "D");
if (crc32("AXtuOxbO",8) == 429112837) strcat(s, "d");
if (crc32("qdznlTqTld",10) == 328613347) strcat(s, "l");
if (crc32("SFFmsbqGzwGmnc",14) == 3579314652) strcat(s, "e");
if (crc32("exuyYXFrpGXX",12) == 3403511091) strcat(s, "r");
if (crc32("zrcDZYnCrGO",11) == 667181624) strcat(s, "Q");
if (crc32("FBUOOfzoVz",10) == 3700119651) strcat(s, "c");
if (crc32("TdESr",5) == 3039376432) strcat(s, "R");
if (crc32("ofTCxV",6) == 223294098) strcat(s, "h");
if (crc32("PVgWsGwGmx",10) == 1874365606) strcat(s, "q");
if (crc32("xWLreKt",7) == 95194626) strcat(s, "a");
if (crc32("SoiJlBvsYO",10) == 3578846642) strcat(s, "r");
if (crc32("DgcYwneWG",9) == 3990047428) strcat(s, "g");
if (crc32("jJlQgmfYSYQ",11) == 811389549) strcat(s, "e");
if (crc32("lWiiV",5) == 3724918700) strcat(s, "t");
if (crc32("xgkTMbrr",8) == 2047419775) strcat(s, "d");
    return s;
}

char *sewed_verbs() {
    char *s = calloc(6);
    if (crc32("iaIRBDUAC",9) == 1973497393) strcat(s, "j");
if (crc32("XyvtcydAQlO",11) == 2470043235) strcat(s, "s");
if (crc32("outMjQGzxRRkFg",14) == 2881751654) strcat(s, "e");
if (crc32("IzVSLcNKGr",10) == 1872232615) strcat(s, "s");
if (crc32("qSwPGDsuw",9) == 3405915481) strcat(s, "w");
if (crc32("HsufZcQ",7) == 38185901) strcat(s, "U");
if (crc32("eIaFpLWXQYl",11) == 3728365618) strcat(s, "e");
if (crc32("trCFg",5) == 208664292) strcat(s, "d");
    return s;
}

char *legislated_verbs() {
    char *s = calloc(11);
    if (crc32("uXrIcLqiB",9) == 4291885260) strcat(s, "l");
if (crc32("omrkoo",6) == 2748009079) strcat(s, "k");
if (crc32("NckRptqLvo",10) == 919075933) strcat(s, "e");
if (crc32("TcWKL",5) == 622599832) strcat(s, "R");
if (crc32("SVoiOjlBWgaPC",13) == 4170408654) strcat(s, "g");
if (crc32("NEiioAbbvCSUxZN",15) == 1427458081) strcat(s, "i");
if (crc32("HIqNyTaUZrj",11) == 3645318213) strcat(s, "s");
if (crc32("iUNqXaQ",7) == 3149177350) strcat(s, "Q");
if (crc32("nChMKEVUQWN",11) == 309516501) strcat(s, "l");
if (crc32("mpVLSoz",7) == 1318294694) strcat(s, "b");
if (crc32("YFmtgdtc",8) == 3329166618) strcat(s, "a");
if (crc32("KQbfLBWbRcwqqw",14) == 2747867240) strcat(s, "g");
if (crc32("YPasfKAXDzww",12) == 710023094) strcat(s, "t");
if (crc32("HTFBREInD",9) == 377371062) strcat(s, "b");
if (crc32("QdkQAbcubnWUH",13) == 2176484632) strcat(s, "e");
if (crc32("BfoigKFQtk",10) == 949808062) strcat(s, "H");
if (crc32("VvDeFK",6) == 12642588) strcat(s, "d");
    return s;
}

char *boodling_verbs() {
    char *s = calloc(9);
    if (crc32("eEzllLFahlhzZ",13) == 2201026353) strcat(s, "b");
if (crc32("vOwmJIMmk",9) == 2391173223) strcat(s, "o");
if (crc32("ZeLDVgJoWS",10) == 533562997) strcat(s, "j");
if (crc32("NCABLl",6) == 3552420778) strcat(s, "o");
if (crc32("LMtkKcX",7) == 968671496) strcat(s, "z");
if (crc32("BaedRcDGuERXnd",14) == 2138557204) strcat(s, "d");
if (crc32("apppVMcygSs",11) == 3645778305) strcat(s, "T");
if (crc32("YhNOulhnFa",10) == 3892622770) strcat(s, "l");
if (crc32("ttAAbb",6) == 2342812037) strcat(s, "i");
if (crc32("kPebqLqhAfwe",12) == 1728220510) strcat(s, "B");
if (crc32("jgQsEvPUgoyASRY",15) == 1006595008) strcat(s, "n");
if (crc32("gXXaIwzGowmpHB",14) == 96582286) strcat(s, "g");
    return s;
}

char *unraveled_verbs() {
    char *s = calloc(10);
    if (crc32("PiXnqK",6) == 998377871) strcat(s, "i");
if (crc32("EHoJkuqZDJNd",12) == 412902040) strcat(s, "u");
if (crc32("sldAtVQvnYqrc",13) == 2269657874) strcat(s, "u");
if (crc32("zxIwIMmxTeCmiMO",15) == 2896854614) strcat(s, "n");
if (crc32("ZqQEPtFIKCL",11) == 3060870196) strcat(s, "r");
if (crc32("BAogphZranH",11) == 2526404248) strcat(s, "G");
if (crc32("RdnpbqDsaptjiIN",15) == 2374203335) strcat(s, "a");
if (crc32("JNYJPduIgwQUXOl",15) == 1037527401) strcat(s, "m");
if (crc32("hSWkfGO",7) == 3694851629) strcat(s, "v");
if (crc32("rAZlNVCLCNwrv",13) == 922300052) strcat(s, "e");
if (crc32("TODUjHAkRTZFvP",14) == 3457694267) strcat(s, "l");
if (crc32("wgrNh",5) == 3563395700) strcat(s, "q");
if (crc32("vlaKwEttQRA",11) == 4082731031) strcat(s, "e");
if (crc32("DBpHrcmjathZ",12) == 2427221019) strcat(s, "d");
    return s;
}

char *oversimplify_verbs() {
    char *s = calloc(13);
    if (crc32("mvUVIswJwikEKk",14) == 4172236577) strcat(s, "o");
if (crc32("EmbSlhgtNhUq",12) == 3758766157) strcat(s, "v");
if (crc32("YCiLdnKk",8) == 3618642906) strcat(s, "v");
if (crc32("JmEKNfr",7) == 3853584923) strcat(s, "Y");
if (crc32("MVRSwCdjeEbalom",15) == 2285110124) strcat(s, "e");
if (crc32("kuGOdE",6) == 2564915264) strcat(s, "r");
if (crc32("CYoLADwUIbb",11) == 3597447345) strcat(s, "s");
if (crc32("XhgEDgUuYLK",11) == 3854375518) strcat(s, "i");
if (crc32("fHrKCAfuU",9) == 344493294) strcat(s, "m");
if (crc32("CmVGJgAlrrZE",12) == 930809708) strcat(s, "I");
if (crc32("iEZbPM",6) == 1394587897) strcat(s, "p");
if (crc32("KLBav",5) == 2388504193) strcat(s, "l");
if (crc32("yKzeTQNnuwtRWTV",15) == 615202105) strcat(s, "i");
if (crc32("pwFYIICit",9) == 2651925843) strcat(s, "f");
if (crc32("dFoNLIvkNxmhh",13) == 1551114110) strcat(s, "c");
if (crc32("hDwPuRLiVbxOfQe",15) == 3788893719) strcat(s, "y");
    return s;
}

char *redeploy_verbs() {
    char *s = calloc(9);
    if (crc32("lCfmcKKzdjmPVwR",15) == 3389209660) strcat(s, "r");
if (crc32("vVVwPC",6) == 828118721) strcat(s, "e");
if (crc32("pfTGYOmWW",9) == 1936145233) strcat(s, "d");
if (crc32("WjydunJdVEGVDj",14) == 2686342166) strcat(s, "e");
if (crc32("gBYHZ",5) == 207529006) strcat(s, "p");
if (crc32("EbUIsPauPzTDPv",14) == 2566884247) strcat(s, "c");
if (crc32("HtvOClwzz",9) == 2163370714) strcat(s, "l");
if (crc32("aEOXeYsqI",9) == 2783075006) strcat(s, "b");
if (crc32("kGGeJDZBbn",10) == 2742514968) strcat(s, "o");
if (crc32("nosFdEOXgEDtvbd",15) == 1879306879) strcat(s, "y");
    return s;
}

char *chugging_verbs() {
    char *s = calloc(9);
    if (crc32("QLiwPEtJRngImZz",15) == 3158827201) strcat(s, "c");
if (crc32("ughiBzTBeuYiwce",15) == 312493171) strcat(s, "h");
if (crc32("UsVVblgg",8) == 3781705131) strcat(s, "u");
if (crc32("FvtmdVnLoiH",11) == 2513537224) strcat(s, "g");
if (crc32("gZSve",5) == 598247769) strcat(s, "H");
if (crc32("QNrxfkYQYfd",11) == 634837513) strcat(s, "g");
if (crc32("NfThcjlpZtkta",13) == 1162672973) strcat(s, "i");
if (crc32("uaKniiDD",8) == 65597022) strcat(s, "m");
if (crc32("rOGtUkmh",8) == 208672542) strcat(s, "n");
if (crc32("pUZBE",5) == 549963223) strcat(s, "Y");
if (crc32("KrUbAZCNed",10) == 1295891461) strcat(s, "g");
    return s;
}

char *standto_verbs() {
    char *s = calloc(8);
    if (crc32("hKOqu",5) == 1324880724) strcat(s, "s");
if (crc32("CFjKfWZOg",9) == 1486888517) strcat(s, "C");
if (crc32("yionWPIsZB",10) == 2330056492) strcat(s, "t");
if (crc32("iElTvCMbDHB",11) == 4192739636) strcat(s, "j");
if (crc32("XMsaf",5) == 700431221) strcat(s, "a");
if (crc32("sqLkppbdiyfuZXS",15) == 3477702907) strcat(s, "w");
if (crc32("tVmvF",5) == 2193851338) strcat(s, "n");
if (crc32("SXfTqV",6) == 4067413301) strcat(s, "d");
if (crc32("oTaLDPlC",8) == 979870522) strcat(s, "a");
if (crc32("tDtbOb",6) == 4149308358) strcat(s, "t");
if (crc32("gFZVgMm",7) == 2521086402) strcat(s, "i");
if (crc32("WSGfqbiQnUVm",12) == 3108164937) strcat(s, "o");
    return s;
}

char *bayonetted_verbs() {
    char *s = calloc(11);
    if (crc32("PZgiVPlTf",9) == 3476286823) strcat(s, "x");
if (crc32("keIKwKruIgXtz",13) == 938696919) strcat(s, "b");
if (crc32("kcgjtSXeRgmsp",13) == 3363276075) strcat(s, "a");
if (crc32("rkqUWRTCymy",11) == 3694225466) strcat(s, "D");
if (crc32("FwGqnbgtUxJnFk",14) == 4108357633) strcat(s, "y");
if (crc32("ydRqFGFSiPxe",12) == 1078080948) strcat(s, "o");
if (crc32("sjdhAuOvcNYHiY",14) == 28611149) strcat(s, "n");
if (crc32("NxHgb",5) == 2028189738) strcat(s, "e");
if (crc32("BChFqK",6) == 2981025388) strcat(s, "t");
if (crc32("TwfauPYXvOl",11) == 450475301) strcat(s, "Y");
if (crc32("vCPxSfjE",8) == 3012864655) strcat(s, "t");
if (crc32("VjvUh",5) == 3262126726) strcat(s, "c");
if (crc32("YDPQA",5) == 697345646) strcat(s, "e");
if (crc32("iNNnrcoYc",9) == 1524376096) strcat(s, "d");
    return s;
}

char *swigging_verbs() {
    char *s = calloc(9);
    if (crc32("ubzan",5) == 4061478638) strcat(s, "x");
if (crc32("gRfaqQUdueASn",13) == 3240234753) strcat(s, "s");
if (crc32("VfsqfdsWd",9) == 2812267486) strcat(s, "w");
if (crc32("oBxBkLGV",8) == 2798359462) strcat(s, "E");
if (crc32("UzTCWQzJv",9) == 2921254325) strcat(s, "i");
if (crc32("hYpVTgO",7) == 3462978908) strcat(s, "s");
if (crc32("wDvmroJKCPnYklY",15) == 1904837828) strcat(s, "g");
if (crc32("CuypRiMdsMzJL",13) == 2422661337) strcat(s, "r");
if (crc32("MiHxJTqQbP",10) == 3170635555) strcat(s, "g");
if (crc32("KBCVysCawhb",11) == 1471396342) strcat(s, "f");
if (crc32("zwcQZn",6) == 4265236016) strcat(s, "i");
if (crc32("SXaNnxtktsgSzLP",15) == 2556056937) strcat(s, "n");
if (crc32("aSZuNjaIVJtQl",13) == 1114955720) strcat(s, "v");
if (crc32("gcznkFgyOWbCpmG",15) == 1901396413) strcat(s, "g");
    return s;
}

char *flanneling_verbs() {
    char *s = calloc(11);
    if (crc32("USoaErvzMRBjRcR",15) == 4142275698) strcat(s, "f");
if (crc32("UZmCs",5) == 2152557193) strcat(s, "H");
if (crc32("fWrAoeQcfGulc",13) == 1910265064) strcat(s, "l");
if (crc32("yzRZdL",6) == 1239782144) strcat(s, "g");
if (crc32("YaHZyIr",7) == 3760907304) strcat(s, "a");
if (crc32("bvSvyCsvejXCn",13) == 1576408920) strcat(s, "n");
if (crc32("aKkIgCcppeSbVZ",14) == 2810481026) strcat(s, "n");
if (crc32("AjRgAYCaoRithMm",15) == 2365302817) strcat(s, "g");
if (crc32("NRLaxAPzIDXJOF",14) == 3120265623) strcat(s, "e");
if (crc32("JteAW",5) == 133309340) strcat(s, "M");
if (crc32("DmlaoaUBGRYyVO",14) == 1862046671) strcat(s, "l");
if (crc32("wmgnyEEQGkAEj",13) == 16150768) strcat(s, "J");
if (crc32("qnWKRaBsCuCBty",14) == 2404307180) strcat(s, "i");
if (crc32("gipkdeYevayqbJ",14) == 1101322283) strcat(s, "c");
if (crc32("pyoYJ",5) == 2537306698) strcat(s, "n");
if (crc32("ULiRWTjpw",9) == 2513715022) strcat(s, "g");
    return s;
}

char *fairtraded_verbs() {
    char *s = calloc(11);
    if (crc32("ujTrPQjyYTIR",12) == 4020932289) strcat(s, "f");
if (crc32("VQvhGM",6) == 3517132037) strcat(s, "a");
if (crc32("OsDrR",5) == 2331261255) strcat(s, "i");
if (crc32("QYwgwbFycx",10) == 3297857652) strcat(s, "g");
if (crc32("TunBSsBs",8) == 2661270430) strcat(s, "r");
if (crc32("bLIYvymF",8) == 1980621384) strcat(s, "u");
if (crc32("Dqgvg",5) == 1610168643) strcat(s, "t");
if (crc32("VoZBrPzyOM",10) == 2866545290) strcat(s, "F");
if (crc32("xpgUUwQHqOSM",12) == 111779269) strcat(s, "r");
if (crc32("uLuVPZFlFl",10) == 3320595269) strcat(s, "z");
if (crc32("JwDxqNTyZ",9) == 4254777648) strcat(s, "a");
if (crc32("tXtDLWqjlR",10) == 1706763338) strcat(s, "d");
if (crc32("nfnobZ",6) == 3511283846) strcat(s, "e");
if (crc32("BuYIP",5) == 2437749789) strcat(s, "d");
    return s;
}

char *tramming_verbs() {
    char *s = calloc(9);
    if (crc32("pZOQwRHNH",9) == 3848235536) strcat(s, "t");
if (crc32("BzAYzVd",7) == 1344591120) strcat(s, "j");
if (crc32("oRNqgJZa",8) == 2287866943) strcat(s, "r");
if (crc32("WQTlOxDNvRmF",12) == 2988324612) strcat(s, "a");
if (crc32("tCDUNnUlq",9) == 3092538389) strcat(s, "m");
if (crc32("RxjkpzJe",8) == 1442033230) strcat(s, "Z");
if (crc32("utpqeaZJNG",10) == 461270784) strcat(s, "m");
if (crc32("pVRCGvqxyaACoB",14) == 1694718511) strcat(s, "r");
if (crc32("djZLJLe",7) == 4102174355) strcat(s, "i");
if (crc32("QCGuEMlEjrHXs",13) == 3071454888) strcat(s, "l");
if (crc32("AyKqSqigI",9) == 3557290159) strcat(s, "n");
if (crc32("KzaUBwc",7) == 4001625930) strcat(s, "g");
    return s;
}

char *swiped_verbs() {
    char *s = calloc(7);
    if (crc32("ovEtqngeuVFd",12) == 3307527580) strcat(s, "s");
if (crc32("iQxCNG",6) == 3244233752) strcat(s, "w");
if (crc32("RShcdcDGzwdhMa",14) == 1246111802) strcat(s, "H");
if (crc32("EipnfdDukIkUE",13) == 911517376) strcat(s, "i");
if (crc32("reoDfUekfsv",11) == 754202242) strcat(s, "p");
if (crc32("oDUClgEiuhpU",12) == 4235994229) strcat(s, "E");
if (crc32("dCFNHlIQ",8) == 1478018605) strcat(s, "e");
if (crc32("NknzjNVCnJRj",12) == 381671623) strcat(s, "O");
if (crc32("MgeFPkabSyl",11) == 486473202) strcat(s, "d");
    return s;
}

char *nibbled_verbs() {
    char *s = calloc(8);
    if (crc32("LBoEG",5) == 1275146637) strcat(s, "n");
if (crc32("FwqXoKL",7) == 73199199) strcat(s, "o");
if (crc32("CYJGR",5) == 673477792) strcat(s, "i");
if (crc32("cMNOwFGLqy",10) == 3747445018) strcat(s, "W");
if (crc32("HDUvfrdVWwxw",12) == 2416565225) strcat(s, "b");
if (crc32("MaEQsDl",7) == 141409972) strcat(s, "H");
if (crc32("GpJlfvFISd",10) == 692497566) strcat(s, "b");
if (crc32("pSFBLZhgvVBUbR",14) == 2599502988) strcat(s, "o");
if (crc32("BKIaskg",7) == 4269177665) strcat(s, "l");
if (crc32("jnXsdu",6) == 1197448935) strcat(s, "e");
if (crc32("fNLNCpHHb",9) == 3530019658) strcat(s, "d");
    return s;
}

char *suffocate_verbs() {
    char *s = calloc(10);
    if (crc32("dXOONSEitdtDEQc",15) == 1336777008) strcat(s, "c");
if (crc32("TVRfhefBMchwc",13) == 1201482462) strcat(s, "s");
if (crc32("rRQjAxfzj",9) == 1517765077) strcat(s, "a");
if (crc32("ERTVoHgPTQ",10) == 3473103596) strcat(s, "u");
if (crc32("CBIKz",5) == 960536874) strcat(s, "B");
if (crc32("eOWPC",5) == 1746547200) strcat(s, "f");
if (crc32("aEFFpNREqfeHcvF",15) == 1597597716) strcat(s, "f");
if (crc32("UYeRSO",6) == 2591207286) strcat(s, "v");
if (crc32("sCpjGHyuSUK",11) == 1258223133) strcat(s, "o");
if (crc32("YhkQGXOkP",9) == 123408817) strcat(s, "c");
if (crc32("iUoki",5) == 1598028348) strcat(s, "a");
if (crc32("ReIyCBVc",8) == 3051353543) strcat(s, "t");
if (crc32("uJTFdjXFIva",11) == 4260545223) strcat(s, "j");
if (crc32("dmRmFy",6) == 3992248658) strcat(s, "e");
    return s;
}

char *frolicked_verbs() {
    char *s = calloc(10);
    if (crc32("qtVmxMqbYczqriP",15) == 242952034) strcat(s, "f");
if (crc32("XYwfOqSSiaAnncJ",15) == 709325922) strcat(s, "r");
if (crc32("XblfqYnfY",9) == 1041813724) strcat(s, "o");
if (crc32("uVlRSl",6) == 4067332385) strcat(s, "T");
if (crc32("jiDqK",5) == 4080522699) strcat(s, "l");
if (crc32("GLKbGVGIKIUoTg",14) == 1734721310) strcat(s, "W");
if (crc32("AxqJxUokqBiaV",13) == 4264213319) strcat(s, "i");
if (crc32("eRpLHOHaT",9) == 2498606260) strcat(s, "R");
if (crc32("gqwIRQcGVOSO",12) == 1783677542) strcat(s, "c");
if (crc32("enbvqrvSP",9) == 1179434282) strcat(s, "S");
if (crc32("gVtOS",5) == 3576536886) strcat(s, "k");
if (crc32("BPmSvTASMwGOCa",14) == 959404950) strcat(s, "H");
if (crc32("jQaGA",5) == 2447899109) strcat(s, "e");
if (crc32("kkBqGttfzCkVu",13) == 2524493913) strcat(s, "a");
if (crc32("amSyY",5) == 697056568) strcat(s, "d");
    return s;
}

char *intercirculating_verbs() {
    char *s = calloc(17);
    if (crc32("kqqhjXboGfF",11) == 494803437) strcat(s, "z");
if (crc32("SsOtKghffy",10) == 1982247521) strcat(s, "i");
if (crc32("QrXvyJi",7) == 2806469036) strcat(s, "L");
if (crc32("oKeBfIhXtqCH",12) == 708722539) strcat(s, "n");
if (crc32("XuhDpDuPdk",10) == 548222774) strcat(s, "V");
if (crc32("YWBiwnpwobpnfcx",15) == 224939819) strcat(s, "t");
if (crc32("NCoeCGDua",9) == 1953632428) strcat(s, "e");
if (crc32("qqRgVuOIdxOpc",13) == 1710223469) strcat(s, "p");
if (crc32("WNhtQTkOioZiXTX",15) == 374929196) strcat(s, "r");
if (crc32("RhutBOVGqHhbTF",14) == 1693020951) strcat(s, "c");
if (crc32("gvRfsu",6) == 3682751507) strcat(s, "i");
if (crc32("OqhmIfd",7) == 2852712805) strcat(s, "A");
if (crc32("QYxCSmLTL",9) == 4055905394) strcat(s, "r");
if (crc32("fMmLyKwa",8) == 43408293) strcat(s, "o");
if (crc32("moPBKUtVSRGleJA",15) == 2133058432) strcat(s, "c");
if (crc32("tpZpfi",6) == 358353079) strcat(s, "j");
if (crc32("sYWcVfRFf",9) == 3381194010) strcat(s, "u");
if (crc32("FubrtD",6) == 2773065120) strcat(s, "l");
if (crc32("SkpWgFDmtMln",12) == 3637281336) strcat(s, "q");
if (crc32("wpmFtGVQsc",10) == 1113064907) strcat(s, "a");
if (crc32("wnfxiRVY",8) == 3631310532) strcat(s, "t");
if (crc32("CouESiFLV",9) == 2052519168) strcat(s, "i");
if (crc32("liBLdLfGoBY",11) == 374107848) strcat(s, "n");
if (crc32("ouiiOwtDh",9) == 1015165747) strcat(s, "P");
if (crc32("BpvAdLjyzORXe",13) == 3183564608) strcat(s, "g");
    return s;
}

char *superproduced_verbs() {
    char *s = calloc(14);
    if (crc32("ULHScGoLPqCM",12) == 2286914699) strcat(s, "E");
if (crc32("Jophnd",6) == 2553917785) strcat(s, "s");
if (crc32("dVMNqMiH",8) == 1338175976) strcat(s, "C");
if (crc32("CdeefpkOgKg",11) == 835503493) strcat(s, "u");
if (crc32("vCucfelPC",9) == 3034100215) strcat(s, "a");
if (crc32("AiaZcbbFOOI",11) == 2139462006) strcat(s, "p");
if (crc32("fLilLlAgiiB",11) == 1961944608) strcat(s, "e");
if (crc32("gJZNqgNHKIv",11) == 1107594986) strcat(s, "r");
if (crc32("TRIoQvoNVtZpiV",14) == 1438181793) strcat(s, "h");
if (crc32("GLEQPlZ",7) == 2847036305) strcat(s, "p");
if (crc32("bviRHjXUE",9) == 2368228475) strcat(s, "N");
if (crc32("YAZGxGW",7) == 2341484864) strcat(s, "r");
if (crc32("QWteZFDaSd",10) == 2886980225) strcat(s, "q");
if (crc32("CsInrD",6) == 1318136862) strcat(s, "o");
if (crc32("fNQUPBSukLAYMQI",15) == 3444263748) strcat(s, "P");
if (crc32("PGzdlCqfdNoe",12) == 1836052814) strcat(s, "d");
if (crc32("pVtpCabmjLjnN",13) == 3624763019) strcat(s, "x");
if (crc32("bshzUSnnoO",10) == 182851180) strcat(s, "u");
if (crc32("JNSqAnwURdpaq",13) == 1346897101) strcat(s, "W");
if (crc32("kKZWKxza",8) == 1880841259) strcat(s, "c");
if (crc32("BENZaJE",7) == 388733592) strcat(s, "e");
if (crc32("MmqePDrJDOQim",13) == 3317547697) strcat(s, "d");
    return s;
}

char *certificating_verbs() {
    char *s = calloc(14);
    if (crc32("nMtLsRWxagap",12) == 3425919957) strcat(s, "c");
if (crc32("xwPRgaPWUTFeDjP",15) == 2235081447) strcat(s, "L");
if (crc32("nqxXhOkvniWedeB",15) == 1508803077) strcat(s, "e");
if (crc32("XzXrQ",5) == 2549083418) strcat(s, "U");
if (crc32("VcFQmcaMOXxBH",13) == 3355673692) strcat(s, "r");
if (crc32("lZznvbbKqkxc",12) == 16977879) strcat(s, "t");
if (crc32("glbklNxaCpnOeY",14) == 3373576987) strcat(s, "z");
if (crc32("lreIYCF",7) == 131618803) strcat(s, "i");
if (crc32("IcANwbYv",8) == 2781731401) strcat(s, "f");
if (crc32("puJIcTEwvKzTMSH",15) == 2740417239) strcat(s, "d");
if (crc32("fYXBjCIsabdhrAW",15) == 2538003236) strcat(s, "i");
if (crc32("zIuPcJ",6) == 2786876360) strcat(s, "c");
if (crc32("FllOoG",6) == 887812995) strcat(s, "a");
if (crc32("Hfhkxwmlf",9) == 1567713800) strcat(s, "t");
if (crc32("inbbMkpemiSIM",13) == 2466931359) strcat(s, "D");
if (crc32("oXlQxlSk",8) == 2720460676) strcat(s, "i");
if (crc32("pADZdO",6) == 1306282805) strcat(s, "n");
if (crc32("robZxtAIvOLa",12) == 2457438315) strcat(s, "j");
if (crc32("jSXuuJUYitLBzWf",15) == 409453511) strcat(s, "g");
    return s;
}

char *redrew_verbs() {
    char *s = calloc(7);
    if (crc32("sxANTlgOxds",11) == 3465662871) strcat(s, "r");
if (crc32("uuyHy",5) == 557825325) strcat(s, "w");
if (crc32("BLcTguxnYLcWNjt",15) == 1104325664) strcat(s, "e");
if (crc32("BtruBJQEgBXlJ",13) == 4129831353) strcat(s, "d");
if (crc32("teLsrCXB",8) == 2034195767) strcat(s, "i");
if (crc32("AeiUwTWyNeaH",12) == 1104639572) strcat(s, "r");
if (crc32("MlgrzoKCNyZ",11) == 3976201391) strcat(s, "a");
if (crc32("TAIQqib",7) == 3926936337) strcat(s, "e");
if (crc32("RhwGzRnVEmFG",12) == 1103980773) strcat(s, "w");
    return s;
}

char *idealized_verbs() {
    char *s = calloc(10);
    if (crc32("InVCvQbAtyhxs",13) == 4203805369) strcat(s, "Q");
if (crc32("YwkdiLLwIPiQUpI",15) == 589223299) strcat(s, "i");
if (crc32("EkAzTtUNyh",10) == 455137396) strcat(s, "p");
if (crc32("IGIraNc",7) == 958624849) strcat(s, "d");
if (crc32("SuVxCVDJeuJoxn",14) == 3447609288) strcat(s, "T");
if (crc32("xksUdFUljcbobQ",14) == 1897950444) strcat(s, "e");
if (crc32("BVXoPBUopqC",11) == 10927675) strcat(s, "s");
if (crc32("ViEClkq",7) == 199670793) strcat(s, "a");
if (crc32("cIXsVJWWNVyzkdO",15) == 2796696657) strcat(s, "l");
if (crc32("xcICkotYbjvS",12) == 531767096) strcat(s, "i");
if (crc32("YVZNuk",6) == 2072819864) strcat(s, "z");
if (crc32("SYJKLkBDAvsWTwP",15) == 413191047) strcat(s, "e");
if (crc32("qwPkqAM",7) == 70349723) strcat(s, "P");
if (crc32("DtXeiipT",8) == 600584668) strcat(s, "d");
    return s;
}

char *prodded_verbs() {
    char *s = calloc(8);
    if (crc32("OxUtkwHw",8) == 3340744343) strcat(s, "R");
if (crc32("fkucRsmIFw",10) == 2665114842) strcat(s, "p");
if (crc32("EvgMt",5) == 1195542188) strcat(s, "r");
if (crc32("ggoUanTSrZbvwk",14) == 1054162546) strcat(s, "o");
if (crc32("bCWhKbIYAi",10) == 602487371) strcat(s, "r");
if (crc32("qwWUjFvTfrWgS",13) == 1846365714) strcat(s, "d");
if (crc32("TsonMOqwi",9) == 3896513976) strcat(s, "e");
if (crc32("VIruCOlLvLeXid",14) == 3555201019) strcat(s, "d");
if (crc32("yPEDItQToJb",11) == 2226387864) strcat(s, "e");
if (crc32("ddxEXqQDZHaG",12) == 688741594) strcat(s, "d");
    return s;
}

char *endup_verbs() {
    char *s = calloc(6);
    if (crc32("UpAyEiqINIdjEs",14) == 2379631671) strcat(s, "h");
if (crc32("QIhIP",5) == 693713393) strcat(s, "e");
if (crc32("VRVyrAtUXOGUIYs",15) == 4025258877) strcat(s, "n");
if (crc32("ZebJsFDnOyhJSW",14) == 488479610) strcat(s, "k");
if (crc32("rRTAtTtaV",9) == 3656036218) strcat(s, "d");
if (crc32("eVyNLygL",8) == 2851492763) strcat(s, "u");
if (crc32("fpjjkpnZFp",10) == 1982389747) strcat(s, "p");
    return s;
}

char *exenterate_verbs() {
    char *s = calloc(11);
    if (crc32("ROFXakuLz",9) == 2068151209) strcat(s, "e");
if (crc32("WKVFyK",6) == 807909501) strcat(s, "U");
if (crc32("wewSlesoDIpsdIL",15) == 1781742721) strcat(s, "x");
if (crc32("HEBgOrFJHqCpEeh",15) == 472904836) strcat(s, "I");
if (crc32("yZmAZ",5) == 3028485304) strcat(s, "e");
if (crc32("fUVjkzRBw",9) == 634155332) strcat(s, "s");
if (crc32("GrhOqFmVyORlIb",14) == 2938205678) strcat(s, "n");
if (crc32("QIEetBl",7) == 2042721961) strcat(s, "t");
if (crc32("WcMQSQEA",8) == 238658186) strcat(s, "e");
if (crc32("IVZAveBO",8) == 4279699271) strcat(s, "r");
if (crc32("TotYNPxxUZpo",12) == 4161559342) strcat(s, "a");
if (crc32("oBNvg",5) == 1021971830) strcat(s, "t");
if (crc32("WhZvre",6) == 3709260007) strcat(s, "e");
    return s;
}

char *pat_verbs() {
    char *s = calloc(4);
    if (crc32("JIppVIOOR",9) == 636757141) strcat(s, "K");
if (crc32("ZpdNVJLCBeBxal",14) == 2233547674) strcat(s, "p");
if (crc32("jWNreXwfjZYaYa",14) == 1091826230) strcat(s, "a");
if (crc32("ByducTXQoLoo",12) == 1433531661) strcat(s, "T");
if (crc32("hJBWREuX",8) == 1851337371) strcat(s, "t");
    return s;
}

char *whined_verbs() {
    char *s = calloc(7);
    if (crc32("lRpGbZfBlD",10) == 3141277303) strcat(s, "w");
if (crc32("GHEsMoQyrQiG",12) == 2773249284) strcat(s, "M");
if (crc32("aDSSXXWR",8) == 537346666) strcat(s, "h");
if (crc32("mIxarVxgbtNKjsw",15) == 4267887926) strcat(s, "i");
if (crc32("BzfOZ",5) == 1352065150) strcat(s, "n");
if (crc32("rtHMielSOcsd",12) == 2389396479) strcat(s, "e");
if (crc32("geettEOyH",9) == 2596958769) strcat(s, "l");
if (crc32("twabnGU",7) == 1080159705) strcat(s, "d");
    return s;
}

char *gibe_verbs() {
    char *s = calloc(5);
    if (crc32("PPiFf",5) == 96672233) strcat(s, "y");
if (crc32("HcOHksE",7) == 2798492981) strcat(s, "g");
if (crc32("GgMFAhW",7) == 1046409853) strcat(s, "i");
if (crc32("TrrnOQseP",9) == 3801055825) strcat(s, "b");
if (crc32("HshllQvmzOsS",12) == 1695985422) strcat(s, "e");
    return s;
}

char *panned_verbs() {
    char *s = calloc(7);
    if (crc32("KcxdpZV",7) == 2824553439) strcat(s, "A");
if (crc32("HWuWHcXqFErq",12) == 2348839796) strcat(s, "p");
if (crc32("DAnWHxbFrAUqsks",15) == 1717037815) strcat(s, "a");
if (crc32("SLQdwor",7) == 142388371) strcat(s, "r");
if (crc32("nyFtg",5) == 444950620) strcat(s, "n");
if (crc32("dUPrQH",6) == 1552456467) strcat(s, "E");
if (crc32("bsADyYVLH",9) == 3469427831) strcat(s, "n");
if (crc32("AZJAilbhfFafAO",14) == 2275875832) strcat(s, "e");
if (crc32("TCbflxxbMqCaY",13) == 1708078605) strcat(s, "d");
    return s;
}

char *readied_verbs() {
    char *s = calloc(8);
    if (crc32("GxZswQYwfF",10) == 2500263329) strcat(s, "r");
if (crc32("NFRLkWMMlgBX",12) == 4210841738) strcat(s, "e");
if (crc32("YPJoyIedTj",10) == 1303710628) strcat(s, "l");
if (crc32("dzHUFqtoDm",10) == 3371013699) strcat(s, "a");
if (crc32("WaEIDmZetQiF",12) == 1178899075) strcat(s, "o");
if (crc32("khBbsKUoPqIOb",13) == 3862362653) strcat(s, "d");
if (crc32("Jpdyh",5) == 1293180736) strcat(s, "i");
if (crc32("DvmPGSLoVmHZlV",14) == 1927323666) strcat(s, "D");
if (crc32("XpTUJR",6) == 153495567) strcat(s, "e");
if (crc32("ICGizC",6) == 4245080547) strcat(s, "d");
    return s;
}

char *unthink_verbs() {
    char *s = calloc(8);
    if (crc32("UlfgYgYFAIuEVZ",14) == 4271672565) strcat(s, "a");
if (crc32("XrrLl",5) == 1087015492) strcat(s, "u");
if (crc32("ozxTuBcssgCQNY",14) == 4145682192) strcat(s, "R");
if (crc32("zJVcRjc",7) == 3253097094) strcat(s, "n");
if (crc32("yRcKysoQfSmWik",14) == 2815685491) strcat(s, "O");
if (crc32("wuuFbuMzEBUx",12) == 1936096476) strcat(s, "t");
if (crc32("fPIoIhNcQ",9) == 934186619) strcat(s, "h");
if (crc32("TJktagXB",8) == 518392791) strcat(s, "i");
if (crc32("ggAttAg",7) == 772710134) strcat(s, "n");
if (crc32("qbGEiIUFGUsn",12) == 1938435006) strcat(s, "k");
    return s;
}

char *burgeon_verbs() {
    char *s = calloc(8);
    if (crc32("yqdrHvFCBiS",11) == 3646387087) strcat(s, "b");
if (crc32("vNASP",5) == 2492315983) strcat(s, "M");
if (crc32("oBgkCsZJnqE",11) == 2346922037) strcat(s, "u");
if (crc32("yGYZEIl",7) == 1956422714) strcat(s, "r");
if (crc32("YjxEXJd",7) == 1334405325) strcat(s, "r");
if (crc32("tceeOECztD",10) == 3162206662) strcat(s, "g");
if (crc32("kpFKJxglR",9) == 3589318454) strcat(s, "g");
if (crc32("iyPfzbzvuJAgQLp",15) == 489206246) strcat(s, "e");
if (crc32("lMDTFokMxC",10) == 3221583965) strcat(s, "P");
if (crc32("RjrbNVlEQ",9) == 474476622) strcat(s, "o");
if (crc32("xcFhyqVqZ",9) == 1626730049) strcat(s, "x");
if (crc32("saxllxYFzb",10) == 2225417155) strcat(s, "n");
    return s;
}

char *overindustrialize_verbs() {
    char *s = calloc(18);
    if (crc32("mCzxjgCSAWxwLYT",15) == 4183974693) strcat(s, "o");
if (crc32("LrDtCQSzNVGGp",13) == 744205004) strcat(s, "v");
if (crc32("fDyVuNhHXBvqd",13) == 1977516683) strcat(s, "c");
if (crc32("IwNHrkrzSt",10) == 2830292340) strcat(s, "e");
if (crc32("hsBmYuaoWgIrXXF",15) == 3925413622) strcat(s, "i");
if (crc32("QNATrLwyzGupL",13) == 3075007684) strcat(s, "r");
if (crc32("rKwxrQQSCJDDElv",15) == 2852803007) strcat(s, "x");
if (crc32("KHxGsgqvQyxGg",13) == 4210325670) strcat(s, "i");
if (crc32("suYlj",5) == 603161726) strcat(s, "n");
if (crc32("ZxyAtVjiGKtsZuT",15) == 589012722) strcat(s, "u");
if (crc32("ueLIXYCvsn",10) == 3903104818) strcat(s, "d");
if (crc32("VdhRmiWilfe",11) == 2500683473) strcat(s, "u");
if (crc32("THuEvIwN",8) == 3360921769) strcat(s, "s");
if (crc32("jYbzYMz",7) == 3895545194) strcat(s, "t");
if (crc32("QjnHqibV",8) == 3360917642) strcat(s, "r");
if (crc32("GmVxnGcCtiYL",12) == 967401020) strcat(s, "i");
if (crc32("PtCDtYMZcg",10) == 3496275447) strcat(s, "a");
if (crc32("rIYLhuCtlULzx",13) == 1269294034) strcat(s, "l");
if (crc32("lREnqnxxUBHAop",14) == 2060925890) strcat(s, "i");
if (crc32("RShgKtTtIRchLZ",14) == 2425834002) strcat(s, "H");
if (crc32("GMFrz",5) == 2621538688) strcat(s, "z");
if (crc32("IEPfHLOJGNIJg",13) == 151036025) strcat(s, "e");
    return s;
}

char *sovietize_verbs() {
    char *s = calloc(10);
    if (crc32("GHRssrzm",8) == 109454261) strcat(s, "s");
if (crc32("yoVvawLGPOlsf",13) == 1704874532) strcat(s, "o");
if (crc32("WMgczDndnlS",11) == 13898438) strcat(s, "v");
if (crc32("xBUtjVOZuGD",11) == 2991022203) strcat(s, "i");
if (crc32("LWirWpflamTNSG",14) == 3451278126) strcat(s, "j");
if (crc32("inJuCaFKuEF",11) == 1297747823) strcat(s, "e");
if (crc32("yYdSataZUeFPp",13) == 2694673503) strcat(s, "t");
if (crc32("GQMVBsO",7) == 75017415) strcat(s, "i");
if (crc32("pGWLWxXkHjWHk",13) == 2296181796) strcat(s, "z");
if (crc32("PknQPuRjSraS",12) == 3886506089) strcat(s, "e");
    return s;
}

char *quintuplicating_verbs() {
    char *s = calloc(16);
    if (crc32("bLPhCIL",7) == 1402655006) strcat(s, "L");
if (crc32("RglUXX",6) == 3619883384) strcat(s, "q");
if (crc32("qcyqOHjSLUU",11) == 771221696) strcat(s, "H");
if (crc32("EgVWYmHpoyBIiX",14) == 2305219060) strcat(s, "u");
if (crc32("qDPXzpZVoFQvS",13) == 3818133252) strcat(s, "p");
if (crc32("erWBLrLf",8) == 3419151373) strcat(s, "i");
if (crc32("hizycQEnLhhx",12) == 134566405) strcat(s, "o");
if (crc32("mMsxLFxe",8) == 821025285) strcat(s, "n");
if (crc32("JSiXExm",7) == 19694862) strcat(s, "i");
if (crc32("ByTWCh",6) == 2989612310) strcat(s, "t");
if (crc32("HnbnAuYdHhfX",12) == 1552711364) strcat(s, "u");
if (crc32("VdDSABGRHhM",11) == 2343318159) strcat(s, "p");
if (crc32("XaCgfl",6) == 1188544224) strcat(s, "l");
if (crc32("HTLpq",5) == 1740890195) strcat(s, "L");
if (crc32("jdHTO",5) == 3889815692) strcat(s, "i");
if (crc32("gEQBKcaDN",9) == 3213410831) strcat(s, "y");
if (crc32("dsBWsYZV",8) == 4229650544) strcat(s, "c");
if (crc32("hufBBr",6) == 1437562775) strcat(s, "b");
if (crc32("NWTvbIjyIvGUb",13) == 2121464701) strcat(s, "a");
if (crc32("qGBydoUBFDwY",12) == 286032183) strcat(s, "t");
if (crc32("JuPtwXyoXnfB",12) == 3002383996) strcat(s, "W");
if (crc32("xtNwAdR",7) == 920586596) strcat(s, "i");
if (crc32("rPHCo",5) == 245232202) strcat(s, "O");
if (crc32("Usqjrpnkle",10) == 4000710983) strcat(s, "n");
if (crc32("XDpOjQYjQEx",11) == 1742410532) strcat(s, "E");
if (crc32("iyOzxzeVrbrz",12) == 3188112427) strcat(s, "g");
    return s;
}

char *scurries_verbs() {
    char *s = calloc(9);
    if (crc32("jyudTdAyg",9) == 2974331032) strcat(s, "Y");
if (crc32("kSZvXQSoaOcF",12) == 1441533821) strcat(s, "s");
if (crc32("HEcNXjuNzO",10) == 2528843897) strcat(s, "c");
if (crc32("zvCpJhADiaWP",12) == 1754826879) strcat(s, "v");
if (crc32("yUsAAgCjn",9) == 988663125) strcat(s, "u");
if (crc32("FRwsdGbT",8) == 2795492803) strcat(s, "k");
if (crc32("JHWfQMrPwljAI",13) == 173881999) strcat(s, "r");
if (crc32("zaeNolLwW",9) == 2118325473) strcat(s, "m");
if (crc32("WwpTyvrC",8) == 1630035827) strcat(s, "r");
if (crc32("UiuApdIJxFLaFnZ",15) == 3033652509) strcat(s, "i");
if (crc32("dotupssNiiu",11) == 2510862625) strcat(s, "e");
if (crc32("ZSoFWOXPqIs",11) == 711030934) strcat(s, "V");
if (crc32("HFNCIERFczvcN",13) == 3989372240) strcat(s, "s");
    return s;
}

char *parch_verbs() {
    char *s = calloc(6);
    if (crc32("KQTCLEkOuxer",12) == 2766640460) strcat(s, "p");
if (crc32("ocLHmJaz",8) == 3201894293) strcat(s, "a");
if (crc32("KTXskbiwH",9) == 3600548639) strcat(s, "r");
if (crc32("tWVnNOM",7) == 3216865185) strcat(s, "r");
if (crc32("LKyOpuEwW",9) == 1807074155) strcat(s, "c");
if (crc32("svhAEx",6) == 385659382) strcat(s, "h");
    return s;
}

char *dilating_verbs() {
    char *s = calloc(9);
    if (crc32("RHhQcatqt",9) == 1357045043) strcat(s, "d");
if (crc32("DXVdsSzp",8) == 1341686986) strcat(s, "t");
if (crc32("kFJMYsg",7) == 38282729) strcat(s, "i");
if (crc32("lwLxVkkG",8) == 1785553897) strcat(s, "s");
if (crc32("WtMeVRFVvAJgZNe",15) == 2784235570) strcat(s, "l");
if (crc32("IcvRrJPdCri",11) == 2446929641) strcat(s, "U");
if (crc32("hlTvxFyow",9) == 2364460377) strcat(s, "a");
if (crc32("VNJqt",5) == 2716755460) strcat(s, "M");
if (crc32("ctBbdPiKMzTD",12) == 1793730522) strcat(s, "t");
if (crc32("yxAtGRAJRzNHjYL",15) == 256419142) strcat(s, "m");
if (crc32("KVQgBvcp",8) == 3265552476) strcat(s, "i");
if (crc32("OHXIyAk",7) == 3926209152) strcat(s, "P");
if (crc32("XAoinTbwwXI",11) == 3786179866) strcat(s, "n");
if (crc32("gBdLWZpzm",9) == 169526889) strcat(s, "U");
if (crc32("DYlfwv",6) == 4105863282) strcat(s, "g");
    return s;
}

char *regamble_verbs() {
    char *s = calloc(9);
    if (crc32("SDFeKanG",8) == 2350810030) strcat(s, "L");
if (crc32("jdiRBMGQfAQnz",13) == 2440829028) strcat(s, "r");
if (crc32("MgwyFJsMO",9) == 3221308672) strcat(s, "e");
if (crc32("oVaaGmeH",8) == 1834442054) strcat(s, "g");
if (crc32("IRcqryziVIultpA",15) == 873273014) strcat(s, "U");
if (crc32("TfTtRwvzjyotZkt",15) == 2410043548) strcat(s, "a");
if (crc32("kaEMzfQJl",9) == 1560421193) strcat(s, "y");
if (crc32("VzfIygYP",8) == 1853946216) strcat(s, "m");
if (crc32("sbbxUoprizwx",12) == 1999647714) strcat(s, "b");
if (crc32("VFzAKZUH",8) == 2356096732) strcat(s, "l");
if (crc32("yMheqmKMVYRObW",14) == 660880209) strcat(s, "a");
if (crc32("ElEbsgPaEwgie",13) == 2709164073) strcat(s, "e");
    return s;
}

char *bloodied_verbs() {
    char *s = calloc(9);
    if (crc32("sZTekGuK",8) == 79782776) strcat(s, "T");
if (crc32("youGhdUMqZZzQY",14) == 4196545309) strcat(s, "b");
if (crc32("PbMxRcVTqJQ",11) == 479999374) strcat(s, "l");
if (crc32("RmADmuKX",8) == 3439333862) strcat(s, "k");
if (crc32("lcUPX",5) == 101670261) strcat(s, "o");
if (crc32("CayrKWTLC",9) == 2199419511) strcat(s, "o");
if (crc32("GRgFkUne",8) == 3273575330) strcat(s, "U");
if (crc32("mUzocaalTQSl",12) == 3057440999) strcat(s, "d");
if (crc32("NJaDe",5) == 898635693) strcat(s, "i");
if (crc32("ZQfZYHAdZhraLDX",15) == 1422645059) strcat(s, "Q");
if (crc32("GhyvfLzLl",9) == 2103517150) strcat(s, "e");
if (crc32("QJYDbXMRUj",10) == 629130284) strcat(s, "d");
    return s;
}

char *coalesced_verbs() {
    char *s = calloc(10);
    if (crc32("BNUwJLDbTfcQqn",14) == 852449934) strcat(s, "A");
if (crc32("SMHRL",5) == 1501637875) strcat(s, "c");
if (crc32("WMltKympX",9) == 2086896123) strcat(s, "K");
if (crc32("lNMkfVkDBbTPFqQ",15) == 1220049239) strcat(s, "o");
if (crc32("QBTnFhzL",8) == 3425094162) strcat(s, "a");
if (crc32("zvPfWnJCNNMdZ",13) == 793610013) strcat(s, "C");
if (crc32("QoWFltrkIglYzF",14) == 1858411545) strcat(s, "l");
if (crc32("HHYbLHQxZMurt",13) == 2041270350) strcat(s, "D");
if (crc32("hsybxYgNszQ",11) == 1777618805) strcat(s, "e");
if (crc32("qRVFOm",6) == 3992718415) strcat(s, "s");
if (crc32("QkdOcSRUHcXWn",13) == 712028562) strcat(s, "k");
if (crc32("xlQAoaKJ",8) == 1528078708) strcat(s, "c");
if (crc32("kiApwClDEqqw",12) == 2295908634) strcat(s, "e");
if (crc32("fzboy",5) == 1413321910) strcat(s, "d");
    return s;
}

char *downgraded_verbs() {
    char *s = calloc(11);
    if (crc32("rxQYGZwSY",9) == 1966488681) strcat(s, "d");
if (crc32("AdmSIgkfSQGzK",13) == 1062344948) strcat(s, "o");
if (crc32("eYfAEPacmjPzcO",14) == 1990009915) strcat(s, "w");
if (crc32("lVFmpoAWdOx",11) == 1810662753) strcat(s, "t");
if (crc32("NyIjDNULIaiY",12) == 4247292038) strcat(s, "n");
if (crc32("lQhSloga",8) == 45394496) strcat(s, "p");
if (crc32("NNCVRFVPKTiUoDp",15) == 1880747713) strcat(s, "g");
if (crc32("CMFEHO",6) == 2390791263) strcat(s, "r");
if (crc32("zbNiipqNkTFzR",13) == 3734719615) strcat(s, "V");
if (crc32("HhrnM",5) == 4099275843) strcat(s, "a");
if (crc32("zZhQtcnehNt",11) == 3579488135) strcat(s, "D");
if (crc32("XdzsT",5) == 1266106653) strcat(s, "d");
if (crc32("fsSBooHOECLJZ",13) == 2046512685) strcat(s, "J");
if (crc32("iToqhyR",7) == 3789607731) strcat(s, "e");
if (crc32("kEiRfvNNmPLwNk",14) == 3906838258) strcat(s, "N");
if (crc32("brlWzrJwxmiycE",14) == 1735034461) strcat(s, "d");
    return s;
}

char *polarize_verbs() {
    char *s = calloc(9);
    if (crc32("DPXqf",5) == 2280231454) strcat(s, "F");
if (crc32("JmciRRe",7) == 2343308294) strcat(s, "p");
if (crc32("RFRYsHTTEm",10) == 642762890) strcat(s, "o");
if (crc32("toAyFMrmPFIW",12) == 3755038218) strcat(s, "t");
if (crc32("XizWKuKYv",9) == 1688638137) strcat(s, "l");
if (crc32("SkuOMCDdJN",10) == 1436781701) strcat(s, "a");
if (crc32("hACEzA",6) == 1538088796) strcat(s, "S");
if (crc32("xHpYnaewjq",10) == 179944005) strcat(s, "r");
if (crc32("Zjwsd",5) == 1727826685) strcat(s, "K");
if (crc32("QhvHrV",6) == 1888389872) strcat(s, "i");
if (crc32("sokaklsVs",9) == 1918810399) strcat(s, "w");
if (crc32("CKFiFNZWV",9) == 3345022421) strcat(s, "z");
if (crc32("rnQPX",5) == 750519447) strcat(s, "e");
    return s;
}

char *sloking_verbs() {
    char *s = calloc(8);
    if (crc32("ssszTuBdNm",10) == 3624540561) strcat(s, "s");
if (crc32("aUKfNY",6) == 4271627922) strcat(s, "l");
if (crc32("MpfzM",5) == 745877459) strcat(s, "l");
if (crc32("QjAzETe",7) == 1173250796) strcat(s, "o");
if (crc32("BdQjCvGchzIMBZ",14) == 2357517310) strcat(s, "V");
if (crc32("rCQAhkoKAMoaJ",13) == 2377863849) strcat(s, "k");
if (crc32("lczIFHN",7) == 3619107626) strcat(s, "i");
if (crc32("QyuiUugDuwbEWf",14) == 1639044668) strcat(s, "f");
if (crc32("rWWkHYBJZGWt",12) == 147720045) strcat(s, "n");
if (crc32("FrIVIlBA",8) == 174509500) strcat(s, "g");
    return s;
}

char *craning_verbs() {
    char *s = calloc(8);
    if (crc32("RjRtwONDc",9) == 1833965817) strcat(s, "c");
if (crc32("XgBAY",5) == 3130507930) strcat(s, "O");
if (crc32("UkDkSDzwuhunNsr",15) == 1223169095) strcat(s, "r");
if (crc32("INxreSi",7) == 1495268564) strcat(s, "B");
if (crc32("bOWYds",6) == 3547819115) strcat(s, "a");
if (crc32("NmBjyHTRWn",10) == 1890945442) strcat(s, "Y");
if (crc32("txfVlVeiyKh",11) == 4130076202) strcat(s, "n");
if (crc32("iMDucobXdrHEQQU",15) == 3775449055) strcat(s, "i");
if (crc32("WmhzQMmIBUpC",12) == 1033299225) strcat(s, "l");
if (crc32("BNFFKTTNuLsX",12) == 2330835116) strcat(s, "n");
if (crc32("cfXZXHW",7) == 2155476925) strcat(s, "o");
if (crc32("pXRUqFl",7) == 2563580259) strcat(s, "g");
    return s;
}

char *redescend_verbs() {
    char *s = calloc(10);
    if (crc32("EhbgySjQvYbek",13) == 3164572353) strcat(s, "a");
if (crc32("lhCwiCyg",8) == 2178453846) strcat(s, "r");
if (crc32("QtgHKtsIeYAy",12) == 2909134811) strcat(s, "T");
if (crc32("BvHyKsfKxpoOn",13) == 2954428493) strcat(s, "e");
if (crc32("xqAyhZEaxSVIqS",14) == 3844044439) strcat(s, "d");
if (crc32("XYiwymJoSMsWt",13) == 788282951) strcat(s, "e");
if (crc32("xNemhPkNeF",10) == 1883183401) strcat(s, "A");
if (crc32("SmumtgvIQigJe",13) == 1335899499) strcat(s, "s");
if (crc32("bBAYBruvp",9) == 2430042535) strcat(s, "S");
if (crc32("KNAspkMWiWStqTN",15) == 1407291853) strcat(s, "c");
if (crc32("vUayVsPQnzcAg",13) == 3213804821) strcat(s, "e");
if (crc32("WXCpz",5) == 1160528313) strcat(s, "T");
if (crc32("AGQGjNdqTftIB",13) == 2639328817) strcat(s, "n");
if (crc32("vfNPw",5) == 2686669740) strcat(s, "d");
    return s;
}

char *clearaway_verbs() {
    char *s = calloc(10);
    if (crc32("ockEofUhA",9) == 3688431476) strcat(s, "Z");
if (crc32("Gctuv",5) == 3182736031) strcat(s, "c");
if (crc32("EZOQiXNTnmgZm",13) == 3182915548) strcat(s, "w");
if (crc32("iTIIoxAS",8) == 571435126) strcat(s, "l");
if (crc32("rmHJbHx",7) == 889306894) strcat(s, "h");
if (crc32("zJGKMKALYVfA",12) == 3761592993) strcat(s, "e");
if (crc32("ofYSnuDgvNDRKP",14) == 1252420220) strcat(s, "a");
if (crc32("fAMAmlewCw",10) == 111519105) strcat(s, "r");
if (crc32("UJULyi",6) == 1363320338) strcat(s, "y");
if (crc32("ORBbZrwM",8) == 459405592) strcat(s, "a");
if (crc32("RoBkOovx",8) == 82450925) strcat(s, "w");
if (crc32("DdwaDy",6) == 4283637061) strcat(s, "f");
if (crc32("WXEoIiwuY",9) == 2615455668) strcat(s, "a");
if (crc32("oHJPig",6) == 3743399256) strcat(s, "y");
    return s;
}

char *wended_verbs() {
    char *s = calloc(7);
    if (crc32("AFYNNOK",7) == 70426990) strcat(s, "w");
if (crc32("KeXQVsuKTWf",11) == 1932290742) strcat(s, "e");
if (crc32("bnVgziT",7) == 1060188435) strcat(s, "Y");
if (crc32("rKffaRxHKoJyVcC",15) == 4054287883) strcat(s, "n");
if (crc32("KHjzr",5) == 2570723597) strcat(s, "d");
if (crc32("ZSUHZaDQUd",10) == 2434610985) strcat(s, "e");
if (crc32("oQDsSQCtroeVUJL",15) == 258237201) strcat(s, "d");
    return s;
}

char *interlap_verbs() {
    char *s = calloc(9);
    if (crc32("BQgHnbHCiG",10) == 347716964) strcat(s, "y");
if (crc32("rZXzDboxOWj",11) == 4096736405) strcat(s, "i");
if (crc32("ECFWXaUY",8) == 2047998640) strcat(s, "n");
if (crc32("DHeHbPQ",7) == 752201090) strcat(s, "n");
if (crc32("UQUsAGMGs",9) == 2178766636) strcat(s, "d");
if (crc32("llgMc",5) == 937753061) strcat(s, "t");
if (crc32("rBLMaLWv",8) == 918323299) strcat(s, "e");
if (crc32("vWhdCOsksAiGbQZ",15) == 1116471272) strcat(s, "r");
if (crc32("roIcqzWkbKcwq",13) == 3838621360) strcat(s, "l");
if (crc32("zVONeKdOZz",10) == 2940005210) strcat(s, "a");
if (crc32("kGIAvRNdcZlU",12) == 1799655784) strcat(s, "p");
    return s;
}

char *interweaving_verbs() {
    char *s = calloc(13);
    if (crc32("bdBmnTsBnUdwox",14) == 3217889335) strcat(s, "i");
if (crc32("bjyuVokuqpDTxx",14) == 1164201385) strcat(s, "n");
if (crc32("aYCHdHhTSzQQUX",14) == 1460454268) strcat(s, "Q");
if (crc32("PHnHnxMDbc",10) == 3952123817) strcat(s, "t");
if (crc32("cZhirSahc",9) == 4293144921) strcat(s, "f");
if (crc32("ZZLKIoxE",8) == 891287706) strcat(s, "e");
if (crc32("PQhLNhrwA",9) == 1522450011) strcat(s, "h");
if (crc32("ELUJyPWVGIeUl",13) == 3998669976) strcat(s, "r");
if (crc32("ccNRKAGQ",8) == 1753242005) strcat(s, "w");
if (crc32("gDFIcSloQS",10) == 4291083942) strcat(s, "e");
if (crc32("nZZyi",5) == 1328872546) strcat(s, "r");
if (crc32("JBbvIzl",7) == 2092863235) strcat(s, "a");
if (crc32("bWiyR",5) == 1335158499) strcat(s, "v");
if (crc32("AXRGEUaoUBQkK",13) == 2677777832) strcat(s, "i");
if (crc32("yUdbdRTFijRW",12) == 3220028781) strcat(s, "n");
if (crc32("UJocqrHDh",9) == 249405798) strcat(s, "o");
if (crc32("TvqOH",5) == 523303257) strcat(s, "g");
    return s;
}

char *foulup_verbs() {
    char *s = calloc(7);
    if (crc32("TyLeYUGu",8) == 2815653253) strcat(s, "f");
if (crc32("iLdYRxyqCc",10) == 3493688925) strcat(s, "o");
if (crc32("qHIlnMKrds",10) == 3473506248) strcat(s, "X");
if (crc32("aZbVFFjJkaGEh",13) == 2740632273) strcat(s, "u");
if (crc32("ZHluBCj",7) == 2019638887) strcat(s, "k");
if (crc32("qnmSzNslsx",10) == 411221028) strcat(s, "l");
if (crc32("DsYrihU",7) == 3639609588) strcat(s, "y");
if (crc32("IbokCjUPFgZmmf",14) == 2570419188) strcat(s, "u");
if (crc32("cKtLJSRUiS",10) == 2993859963) strcat(s, "p");
    return s;
}

char *regrinding_verbs() {
    char *s = calloc(11);
    if (crc32("xXwdmAs",7) == 1161788153) strcat(s, "S");
if (crc32("jXUmFJ",6) == 2620976763) strcat(s, "r");
if (crc32("gRbFDzVQYuMJzr",14) == 4166581220) strcat(s, "o");
if (crc32("MtdxxFEYlKOCHc",14) == 2693004246) strcat(s, "e");
if (crc32("misNFxwqbjttVNv",15) == 1488715171) strcat(s, "g");
if (crc32("cQNqrYblp",9) == 23666397) strcat(s, "q");
if (crc32("EWoJvblB",8) == 1565646247) strcat(s, "r");
if (crc32("oEcXlRjmue",10) == 2506239537) strcat(s, "j");
if (crc32("EYQgDck",7) == 3766440182) strcat(s, "i");
if (crc32("uCmZdvXExsVJ",12) == 888927747) strcat(s, "o");
if (crc32("mnOqJTHzBvZUMCy",15) == 3710207233) strcat(s, "n");
if (crc32("FaiRcvFSveKwVUA",15) == 2466930124) strcat(s, "d");
if (crc32("zjRLtxnXU",9) == 447518118) strcat(s, "E");
if (crc32("aVmHfn",6) == 3947967727) strcat(s, "i");
if (crc32("uqniU",5) == 1421205693) strcat(s, "a");
if (crc32("bSdGEm",6) == 4107396957) strcat(s, "n");
if (crc32("PpJOsYRUEQPwTk",14) == 3692231095) strcat(s, "a");
if (crc32("OtFuKweRMa",10) == 1108986237) strcat(s, "g");
    return s;
}

char *burred_verbs() {
    char *s = calloc(7);
    if (crc32("hrrBhDOSqGAPZY",14) == 1938100787) strcat(s, "e");
if (crc32("IGWRYYeQXCiXkMM",15) == 675838761) strcat(s, "b");
if (crc32("NRPrrDZCqop",11) == 1024503577) strcat(s, "u");
if (crc32("HrPiAmKMMWOW",12) == 3941202861) strcat(s, "r");
if (crc32("bQNTpjfzI",9) == 3052937827) strcat(s, "r");
if (crc32("fxUbH",5) == 1339652624) strcat(s, "O");
if (crc32("ggbBWghkpk",10) == 3695178141) strcat(s, "e");
if (crc32("eNfugwO",7) == 4037438454) strcat(s, "d");
    return s;
}

char *wrangling_verbs() {
    char *s = calloc(10);
    if (crc32("gfvrcT",6) == 2310468187) strcat(s, "w");
if (crc32("mlzrtwcMzxSLw",13) == 1715389185) strcat(s, "r");
if (crc32("gHehdgQsTAt",11) == 1236400630) strcat(s, "a");
if (crc32("ArUkwZpTCm",10) == 1839741301) strcat(s, "a");
if (crc32("aAfbxHrCOabreuB",15) == 4257060689) strcat(s, "n");
if (crc32("IlhClrlrUMLuAeE",15) == 2424123159) strcat(s, "o");
if (crc32("iIXcwybBpNOko",13) == 147489234) strcat(s, "g");
if (crc32("kYBzPVPLfArcu",13) == 3967438975) strcat(s, "Z");
if (crc32("XbHXE",5) == 1429467812) strcat(s, "l");
if (crc32("SxaDhGraHxaIZFN",15) == 1507468960) strcat(s, "d");
if (crc32("gQNsftHcTuWlJGM",15) == 1632908411) strcat(s, "i");
if (crc32("IxRBoORAdNLNY",13) == 3156879148) strcat(s, "n");
if (crc32("zLFJtiXJNFCwAX",14) == 4204483354) strcat(s, "g");
    return s;
}

char *remitting_verbs() {
    char *s = calloc(10);
    if (crc32("HSJAbNi",7) == 1207195913) strcat(s, "x");
if (crc32("SBesIJUSXNzGpES",15) == 3561833438) strcat(s, "r");
if (crc32("DmGmlB",6) == 3663927521) strcat(s, "N");
if (crc32("OBFMUMTePKcp",12) == 1556062827) strcat(s, "e");
if (crc32("KlZXWtFhzWAvt",13) == 2331763897) strcat(s, "S");
if (crc32("fScNVzvBcUboix",14) == 3840708303) strcat(s, "m");
if (crc32("jdKhfwDfhGa",11) == 682528763) strcat(s, "B");
if (crc32("FGTmmXrOET",10) == 371307919) strcat(s, "i");
if (crc32("cmOhbBGvDeSAzZC",15) == 2312771770) strcat(s, "u");
if (crc32("xylwpInW",8) == 1302767591) strcat(s, "t");
if (crc32("NdndqOoHgwO",11) == 3454226053) strcat(s, "t");
if (crc32("QtCGDvU",7) == 2216324768) strcat(s, "i");
if (crc32("ShYuTf",6) == 385514054) strcat(s, "s");
if (crc32("NzpIsXOQ",8) == 1061484024) strcat(s, "n");
if (crc32("FPcKaeeDleQPPJN",15) == 3669620898) strcat(s, "g");
    return s;
}

char *versify_verbs() {
    char *s = calloc(8);
    if (crc32("TNzgqS",6) == 1279449294) strcat(s, "v");
if (crc32("tDJLBDjRMjLv",12) == 1927434120) strcat(s, "e");
if (crc32("JJarrDAvflXba",13) == 365078563) strcat(s, "r");
if (crc32("uCJdjWsSlCkmk",13) == 1499442202) strcat(s, "s");
if (crc32("zqbftJG",7) == 651064283) strcat(s, "x");
if (crc32("tPLKHZpZHeR",11) == 3033289913) strcat(s, "i");
if (crc32("hSCmpReyTW",10) == 2242900484) strcat(s, "b");
if (crc32("fkrlxIQcb",9) == 4020018784) strcat(s, "f");
if (crc32("riXSePcrbx",10) == 1657885871) strcat(s, "y");
    return s;
}

char *sunburned_verbs() {
    char *s = calloc(10);
    if (crc32("JZQDjXBac",9) == 2772186784) strcat(s, "A");
if (crc32("LRzpIEoAutHoIM",14) == 2636377964) strcat(s, "s");
if (crc32("tZuqYYWr",8) == 3411619171) strcat(s, "u");
if (crc32("mWGtqEWBrpQJJnt",15) == 2788669742) strcat(s, "n");
if (crc32("uNEooIdgS",9) == 1159919146) strcat(s, "s");
if (crc32("TwVCoORY",8) == 3669819053) strcat(s, "b");
if (crc32("OJTXCoxxFtHOL",13) == 2599873296) strcat(s, "A");
if (crc32("MhXbT",5) == 3249625033) strcat(s, "u");
if (crc32("vDQZgKpKrmPxr",13) == 2332767308) strcat(s, "r");
if (crc32("niTdCSVFRsp",11) == 2738025373) strcat(s, "W");
if (crc32("ygjLQLhHfvrA",12) == 2170175166) strcat(s, "n");
if (crc32("CulafXZRfFl",11) == 658162479) strcat(s, "e");
if (crc32("nXdjX",5) == 2557729557) strcat(s, "M");
if (crc32("ZzvWQMp",7) == 3902038439) strcat(s, "d");
    return s;
}

char *reconsolidate_verbs() {
    char *s = calloc(14);
    if (crc32("rLZXE",5) == 3790060287) strcat(s, "B");
if (crc32("wRAMZEP",7) == 2118527212) strcat(s, "r");
if (crc32("uHBZsWCpsdGPHhp",15) == 10575857) strcat(s, "e");
if (crc32("bKpsykaoQ",9) == 776767954) strcat(s, "c");
if (crc32("ZQxSwPJ",7) == 2953654936) strcat(s, "o");
if (crc32("DhTBQ",5) == 542448881) strcat(s, "n");
if (crc32("WlXdFNUidMcVl",13) == 1263512856) strcat(s, "c");
if (crc32("GUtDI",5) == 416235373) strcat(s, "s");
if (crc32("smOGLumrUpcHva",14) == 3653264108) strcat(s, "d");
if (crc32("pZDzvylbZJ",10) == 3526837171) strcat(s, "o");
if (crc32("cZkTFJB",7) == 3118460337) strcat(s, "z");
if (crc32("XHJbSTFWvBqKKz",14) == 2010112353) strcat(s, "l");
if (crc32("SujvuTvoYp",10) == 2599134207) strcat(s, "Q");
if (crc32("AhOcNekCDRp",11) == 1701515901) strcat(s, "i");
if (crc32("luAlcAgRe",9) == 541034862) strcat(s, "L");
if (crc32("JyQrT",5) == 3727135485) strcat(s, "d");
if (crc32("vrefqQig",8) == 3820305683) strcat(s, "a");
if (crc32("mJSwtKkrgWmIKG",14) == 1395067325) strcat(s, "P");
if (crc32("CyThEKiyYmroTTn",15) == 3498269488) strcat(s, "t");
if (crc32("epoUMAblZ",9) == 2086200241) strcat(s, "V");
if (crc32("sHRbDoykdmQ",11) == 2644641105) strcat(s, "e");
    return s;
}

char *staning_verbs() {
    char *s = calloc(8);
    if (crc32("tfpOHOtgJay",11) == 4255053509) strcat(s, "a");
if (crc32("cdBTe",5) == 1021693693) strcat(s, "s");
if (crc32("MJTXJEqlhrixhOX",15) == 929585312) strcat(s, "Q");
if (crc32("aoamieqpJUY",11) == 2603299087) strcat(s, "t");
if (crc32("nVbUnatknTTSUvD",15) == 2287394957) strcat(s, "t");
if (crc32("EVofFDp",7) == 3835702342) strcat(s, "a");
if (crc32("TDYuLofyUYVqAcL",15) == 2807244788) strcat(s, "n");
if (crc32("RUFlSzRQUgwFHb",14) == 1133627074) strcat(s, "J");
if (crc32("MYjmeI",6) == 874069097) strcat(s, "i");
if (crc32("UJsWG",5) == 2307769942) strcat(s, "n");
if (crc32("CWKher",6) == 3233679712) strcat(s, "s");
if (crc32("ItZyIueNa",9) == 83592304) strcat(s, "g");
    return s;
}

char *cried_verbs() {
    char *s = calloc(6);
    if (crc32("otDKZZ",6) == 1873803696) strcat(s, "t");
if (crc32("LIExSr",6) == 1158602476) strcat(s, "c");
if (crc32("yGYozMnq",8) == 3352231534) strcat(s, "r");
if (crc32("arqEjyNnFd",10) == 4259319263) strcat(s, "i");
if (crc32("tRwhfNvX",8) == 2590618301) strcat(s, "c");
if (crc32("IIHJbG",6) == 1353213421) strcat(s, "e");
if (crc32("OjYgRONIpxWEpyZ",15) == 2787940710) strcat(s, "d");
    return s;
}

char *bubbling_verbs() {
    char *s = calloc(9);
    if (crc32("UJqdv",5) == 800880434) strcat(s, "b");
if (crc32("xmlSPFXfoIFlW",13) == 3079313943) strcat(s, "u");
if (crc32("gbMEYheZkscbg",13) == 760362342) strcat(s, "b");
if (crc32("QccFAs",6) == 3966841049) strcat(s, "U");
if (crc32("AIhAFCcBLYumMNv",15) == 245817555) strcat(s, "b");
if (crc32("cAMVqeiV",8) == 4103260257) strcat(s, "h");
if (crc32("ParpDNpU",8) == 4172387542) strcat(s, "l");
if (crc32("NfWLbadPA",9) == 1614510884) strcat(s, "p");
if (crc32("wwxBmiydO",9) == 3524771096) strcat(s, "i");
if (crc32("sbGyznnY",8) == 1243114757) strcat(s, "M");
if (crc32("lDToiQHKIyhve",13) == 2051627508) strcat(s, "n");
if (crc32("TlCqO",5) == 3638227330) strcat(s, "g");
    return s;
}

char *fortuned_verbs() {
    char *s = calloc(9);
    if (crc32("hvJAHe",6) == 2742957711) strcat(s, "f");
if (crc32("vDcRyUHRP",9) == 3575238663) strcat(s, "m");
if (crc32("clKRHeNUSmvDl",13) == 1513728176) strcat(s, "o");
if (crc32("bMUMVOVfUVUpTXH",15) == 2011084248) strcat(s, "D");
if (crc32("szcMXvC",7) == 2846230336) strcat(s, "r");
if (crc32("ApBYrpa",7) == 2734388085) strcat(s, "t");
if (crc32("zuOhvnwqvZqsnj",14) == 424774308) strcat(s, "u");
if (crc32("tOHLVNZV",8) == 3259204860) strcat(s, "y");
if (crc32("WQvgTQqEFu",10) == 1219953526) strcat(s, "n");
if (crc32("cLyILjTSKXd",11) == 913891577) strcat(s, "e");
if (crc32("TWrtJqCpMroJvGi",15) == 1574987098) strcat(s, "d");
    return s;
}

char *decreed_verbs() {
    char *s = calloc(8);
    if (crc32("CISlnUJriUVQsjg",15) == 1902170550) strcat(s, "C");
if (crc32("FgQjnI",6) == 2170452643) strcat(s, "d");
if (crc32("gQJsoCra",8) == 473610667) strcat(s, "e");
if (crc32("CcviSXthEaZwAOO",15) == 1415316434) strcat(s, "k");
if (crc32("GTuxt",5) == 2318010321) strcat(s, "c");
if (crc32("tEkITK",6) == 500694856) strcat(s, "r");
if (crc32("recciZYwx",9) == 3511625630) strcat(s, "Z");
if (crc32("WWeejVkJ",8) == 4193438684) strcat(s, "e");
if (crc32("kfSQHVPxqLOAv",13) == 2596196299) strcat(s, "e");
if (crc32("DmKnR",5) == 3166010006) strcat(s, "u");
if (crc32("cBcwP",5) == 1747558794) strcat(s, "d");
    return s;
}

char *thirddegreeing_verbs() {
    char *s = calloc(15);
    if (crc32("TTgqMHlMFeinoHa",15) == 3660908552) strcat(s, "j");
if (crc32("LlKByHmSOVRARm",14) == 891356764) strcat(s, "t");
if (crc32("mpWkalnWTFRzIy",14) == 3165901043) strcat(s, "h");
if (crc32("cbLJE",5) == 78968123) strcat(s, "n");
if (crc32("aPGzCMxFtoky",12) == 326983022) strcat(s, "i");
if (crc32("zIIdvCqpkW",10) == 1042098853) strcat(s, "s");
if (crc32("GSWKKvEewxdTV",13) == 1027217222) strcat(s, "r");
if (crc32("kFeGUcoU",8) == 2449745631) strcat(s, "l");
if (crc32("nubqOgbByhBTJ",13) == 3801546794) strcat(s, "d");
if (crc32("JTCGBZAawgoCGw",14) == 1547721410) strcat(s, "Z");
if (crc32("GuEIOPZSO",9) == 2170477860) strcat(s, "d");
if (crc32("PLkSxfcGya",10) == 3375346046) strcat(s, "j");
if (crc32("KxqyiWWkfX",10) == 908507758) strcat(s, "e");
if (crc32("UGllTMJnWzqGcly",15) == 4276918218) strcat(s, "g");
if (crc32("RDCCOKlC",8) == 3382168664) strcat(s, "t");
if (crc32("pYVBny",6) == 3225192377) strcat(s, "r");
if (crc32("LuXlpQvFYiKxkCm",15) == 951333196) strcat(s, "e");
if (crc32("FvNhqRnHUcQHEZ",14) == 1063737415) strcat(s, "e");
if (crc32("peYJnqZuOjvy",12) == 3044238775) strcat(s, "i");
if (crc32("bTXgZJZz",8) == 3263192800) strcat(s, "n");
if (crc32("DlhQYVrxCmmAcJ",14) == 2006021304) strcat(s, "g");
    return s;
}

char *antedating_verbs() {
    char *s = calloc(11);
    if (crc32("HaqkBWZDsYvWz",13) == 3966559278) strcat(s, "a");
if (crc32("VRLFHdrCrP",10) == 3694282453) strcat(s, "h");
if (crc32("kofEErSf",8) == 354138685) strcat(s, "n");
if (crc32("MeFdCBjkTExwrOb",15) == 2048944039) strcat(s, "t");
if (crc32("Qtmww",5) == 3148833927) strcat(s, "w");
if (crc32("aNQxfjooRBJaC",13) == 773025062) strcat(s, "e");
if (crc32("EExFbUgZvbQxuS",14) == 2937339721) strcat(s, "d");
if (crc32("oRJwtr",6) == 2983482049) strcat(s, "l");
if (crc32("JdSIhQYXRQOr",12) == 21016607) strcat(s, "a");
if (crc32("nuZdIWzxrFQwI",13) == 3091459748) strcat(s, "t");
if (crc32("REjdcvbqS",9) == 2023770714) strcat(s, "i");
if (crc32("XWkyCUBjObF",11) == 1515190052) strcat(s, "W");
if (crc32("jfHzTx",6) == 2299589496) strcat(s, "n");
if (crc32("kmSPqngXa",9) == 2003195672) strcat(s, "g");
    return s;
}

char *disliked_verbs() {
    char *s = calloc(9);
    if (crc32("BXVeRtiq",8) == 903890990) strcat(s, "F");
if (crc32("KTJjbOI",7) == 957699619) strcat(s, "d");
if (crc32("AkjBStVJjkyFT",13) == 439579760) strcat(s, "e");
if (crc32("gGmjjDtYJYkc",12) == 2761026530) strcat(s, "i");
if (crc32("JvWPJj",6) == 4093946788) strcat(s, "s");
if (crc32("lqupSk",6) == 1235233092) strcat(s, "l");
if (crc32("jdjYqLnpPH",10) == 3278842826) strcat(s, "i");
if (crc32("kvoFY",5) == 2441855951) strcat(s, "k");
if (crc32("yuIDqRmvrvmqAF",14) == 2728510601) strcat(s, "e");
if (crc32("rCJKkQqNkBmA",12) == 97298385) strcat(s, "n");
if (crc32("jrtzhWuVMg",10) == 1465736800) strcat(s, "d");
    return s;
}

char *affiliated_verbs() {
    char *s = calloc(11);
    if (crc32("FhcTljFEzQy",11) == 1859592665) strcat(s, "a");
if (crc32("izMILnILiGPBKj",14) == 1163599178) strcat(s, "C");
if (crc32("edDgrIXZ",8) == 2057980809) strcat(s, "f");
if (crc32("VecYtvlK",8) == 148965822) strcat(s, "f");
if (crc32("ZMUeapDVHt",10) == 996822815) strcat(s, "q");
if (crc32("KVRTKLRCDbNy",12) == 2302653725) strcat(s, "i");
if (crc32("JJbkDUkbt",9) == 2155120417) strcat(s, "l");
if (crc32("mRHqqxsZRwZEKtJ",15) == 4253819131) strcat(s, "l");
if (crc32("oCDBSE",6) == 11320119) strcat(s, "s");
if (crc32("xfKxqTbpVViGy",13) == 2440465155) strcat(s, "i");
if (crc32("QJQgZLFIH",9) == 1505653461) strcat(s, "E");
if (crc32("ZHOWpHdAAnnGYB",14) == 1243935515) strcat(s, "a");
if (crc32("GzUJrmWZzJwUyVb",15) == 264862356) strcat(s, "e");
if (crc32("VwKemlpgG",9) == 3645288949) strcat(s, "t");
if (crc32("QWmKzjqKTuHv",12) == 2680684596) strcat(s, "e");
if (crc32("JwpgvwaUwlw",11) == 2558622429) strcat(s, "Z");
if (crc32("euBtLHOTYXcwkZ",14) == 2083452245) strcat(s, "d");
    return s;
}

char *darkle_verbs() {
    char *s = calloc(7);
    if (crc32("HiXQwbmQNzmXjew",15) == 1623745416) strcat(s, "y");
if (crc32("rUtNGKXAK",9) == 3303694154) strcat(s, "d");
if (crc32("rcpTLdqEPQkyTj",14) == 3139745532) strcat(s, "a");
if (crc32("ZyWXrEtFkq",10) == 495006211) strcat(s, "O");
if (crc32("WamCMOPRIvLE",12) == 3287710885) strcat(s, "r");
if (crc32("tAKsEl",6) == 2538209419) strcat(s, "k");
if (crc32("rLNuGssvH",9) == 3443126521) strcat(s, "l");
if (crc32("VLZPlJdZuFYeW",13) == 1090083114) strcat(s, "B");
if (crc32("TrHTtJIz",8) == 3910816238) strcat(s, "e");
    return s;
}

char *kenneled_verbs() {
    char *s = calloc(9);
    if (crc32("kJxHgfn",7) == 4180240492) strcat(s, "k");
if (crc32("dkXvL",5) == 571996753) strcat(s, "e");
if (crc32("QdUhARtoj",9) == 1122327180) strcat(s, "z");
if (crc32("VcWae",5) == 1882153631) strcat(s, "n");
if (crc32("VYQexqAzzYVRLnv",15) == 2974152838) strcat(s, "n");
if (crc32("GZArWkx",7) == 2757023137) strcat(s, "e");
if (crc32("jDviZlXUI",9) == 2346768636) strcat(s, "l");
if (crc32("wvgLMnukxtapxz",14) == 1024116272) strcat(s, "e");
if (crc32("AGEBbwWSXiS",11) == 2529901626) strcat(s, "X");
if (crc32("BOoYPrJQfIFI",12) == 1365530731) strcat(s, "d");
    return s;
}

char *shirr_verbs() {
    char *s = calloc(6);
    if (crc32("PTOYIqxRpWK",11) == 298506227) strcat(s, "s");
if (crc32("vNldbW",6) == 395333474) strcat(s, "h");
if (crc32("bzOCeecYBUa",11) == 1126863859) strcat(s, "i");
if (crc32("ZQYIUlyyEqp",11) == 879914439) strcat(s, "d");
if (crc32("LZZJHtZSA",9) == 1318544628) strcat(s, "r");
if (crc32("XpZhKYYyK",9) == 1404445084) strcat(s, "r");
if (crc32("yffEeiRsfO",10) == 3899967293) strcat(s, "r");
    return s;
}

char *rearoused_verbs() {
    char *s = calloc(10);
    if (crc32("ueRGEj",6) == 2403838598) strcat(s, "r");
if (crc32("iGXlZmvlJezokm",14) == 2069285631) strcat(s, "e");
if (crc32("bWozJreFSaz",11) == 3145253678) strcat(s, "m");
if (crc32("EHOgiYLzST",10) == 791922166) strcat(s, "a");
if (crc32("RnheSVJrDWkC",12) == 1308046630) strcat(s, "d");
if (crc32("EtjOvztSAYwoI",13) == 369701918) strcat(s, "r");
if (crc32("KrYtnhfeZPDeS",13) == 876161539) strcat(s, "W");
if (crc32("PMGIUPAdujSm",12) == 2041868405) strcat(s, "o");
if (crc32("YIBnTmUHeUYp",12) == 1673536511) strcat(s, "u");
if (crc32("hywIQEZjfWA",11) == 1839770575) strcat(s, "u");
if (crc32("TgDYbxXK",8) == 1220981550) strcat(s, "L");
if (crc32("CestAePJFT",10) == 1408772443) strcat(s, "s");
if (crc32("GrnzIvmfhG",10) == 1385120011) strcat(s, "e");
if (crc32("xEloaGe",7) == 3909896950) strcat(s, "d");
    return s;
}

char *rearouse_verbs() {
    char *s = calloc(9);
    if (crc32("KFPkrShgxV",10) == 614550780) strcat(s, "i");
if (crc32("JvTyTXSJt",9) == 3423819912) strcat(s, "r");
if (crc32("JDgcHeNMpHmLmMx",15) == 2577910498) strcat(s, "H");
if (crc32("rYEEKJzCTT",10) == 198875186) strcat(s, "e");
if (crc32("RzoAjyhbPm",10) == 3521825296) strcat(s, "i");
if (crc32("OPLzSgeD",8) == 2158605156) strcat(s, "a");
if (crc32("evNUhISCxLeYA",13) == 680115652) strcat(s, "o");
if (crc32("VEeKwV",6) == 1766318992) strcat(s, "r");
if (crc32("VERFG",5) == 2403374999) strcat(s, "z");
if (crc32("henpsyuehJowiam",15) == 1041590949) strcat(s, "o");
if (crc32("fSXbc",5) == 3895956339) strcat(s, "u");
if (crc32("aYNmTQMIWWrXNu",14) == 3562355144) strcat(s, "o");
if (crc32("MQEaNXmCYIhXXV",14) == 2948560652) strcat(s, "s");
if (crc32("FVWpIybHtDI",11) == 3541213829) strcat(s, "e");
    return s;
}

char *squinnies_verbs() {
    char *s = calloc(10);
    if (crc32("jqNcLEw",7) == 1988285040) strcat(s, "t");
if (crc32("GzGCZQQK",8) == 2282544377) strcat(s, "s");
if (crc32("Hbipee",6) == 2260129635) strcat(s, "q");
if (crc32("wsoJmRvsXluBfT",14) == 876951185) strcat(s, "u");
if (crc32("bkCoG",5) == 2567749493) strcat(s, "m");
if (crc32("RrmXr",5) == 3382811806) strcat(s, "i");
if (crc32("SINNiYGbLbUX",12) == 3149727598) strcat(s, "n");
if (crc32("dVdBIDnsobqJprS",15) == 3978552847) strcat(s, "n");
if (crc32("KgKJMEgJkHZ",11) == 455194357) strcat(s, "i");
if (crc32("dlKuRzFKgB",10) == 3381425781) strcat(s, "e");
if (crc32("LWFCQNOOhde",11) == 4058134502) strcat(s, "z");
if (crc32("aCvmXnwjAU",10) == 1039844242) strcat(s, "s");
    return s;
}

char *obtest_verbs() {
    char *s = calloc(7);
    if (crc32("gcEZxlkoSg",10) == 98083837) strcat(s, "o");
if (crc32("VflBQhMgDRP",11) == 91755220) strcat(s, "b");
if (crc32("vbnzqDDiQDFB",12) == 4164921548) strcat(s, "t");
if (crc32("jtesTTXXq",9) == 3314802204) strcat(s, "a");
if (crc32("EqWjJTQ",7) == 708816476) strcat(s, "e");
if (crc32("tpgskDV",7) == 2389629097) strcat(s, "s");
if (crc32("ZIFtSxgb",8) == 2942225155) strcat(s, "t");
    return s;
}

char *mischarging_verbs() {
    char *s = calloc(12);
    if (crc32("VArpt",5) == 3532897724) strcat(s, "S");
if (crc32("XZIvAAPpPpHSx",13) == 975681457) strcat(s, "m");
if (crc32("pbRPOpQASoHIK",13) == 2788732626) strcat(s, "i");
if (crc32("mvayAxj",7) == 1210696787) strcat(s, "R");
if (crc32("wsoJBM",6) == 3455973676) strcat(s, "s");
if (crc32("mOOedcvAakcq",12) == 151024659) strcat(s, "c");
if (crc32("gSNgvkaI",8) == 4111914700) strcat(s, "U");
if (crc32("BqyPQUNOl",9) == 3014194358) strcat(s, "h");
if (crc32("zXUxqydSLF",10) == 479003641) strcat(s, "N");
if (crc32("EBWbTiUXmU",10) == 2124695508) strcat(s, "a");
if (crc32("wsWGEJTnMu",10) == 3459688892) strcat(s, "r");
if (crc32("pxrhsqGIhdPg",12) == 4180073099) strcat(s, "g");
if (crc32("KJZOX",5) == 1859258230) strcat(s, "i");
if (crc32("GGFxfmvbDTSfatN",15) == 3321572050) strcat(s, "n");
if (crc32("JxHLyUkfgXP",11) == 537655908) strcat(s, "g");
    return s;
}

char *fumbling_verbs() {
    char *s = calloc(9);
    if (crc32("TtVoFGbiSgRd",12) == 2480449567) strcat(s, "O");
if (crc32("yjGJjlK",7) == 1049602303) strcat(s, "f");
if (crc32("qtlMSM",6) == 3987168346) strcat(s, "u");
if (crc32("FprhQelEgFngI",13) == 3325228793) strcat(s, "V");
if (crc32("puRNjDzWklC",11) == 3655241736) strcat(s, "m");
if (crc32("jRxOKzEc",8) == 3780600488) strcat(s, "b");
if (crc32("uDMcYKqEO",9) == 488546510) strcat(s, "l");
if (crc32("FJBzUVVA",8) == 3800124283) strcat(s, "i");
if (crc32("bZsMboMed",9) == 2493277902) strcat(s, "n");
if (crc32("eKbrQf",6) == 4172753359) strcat(s, "H");
if (crc32("TGwur",5) == 2962169316) strcat(s, "g");
    return s;
}

char *involuted_verbs() {
    char *s = calloc(10);
    if (crc32("vcbbgE",6) == 1146956379) strcat(s, "i");
if (crc32("qSdTk",5) == 2420235602) strcat(s, "n");
if (crc32("JSovwqEW",8) == 2611527635) strcat(s, "v");
if (crc32("YKpJYttUlzjC",12) == 4173599195) strcat(s, "o");
if (crc32("hvTNdmmrCgYJE",13) == 3907189937) strcat(s, "l");
if (crc32("bLEUFMKShABcT",13) == 2763270879) strcat(s, "u");
if (crc32("AWxQUjSpEQL",11) == 2481695049) strcat(s, "t");
if (crc32("hAnxXclPHOTJ",12) == 3491265448) strcat(s, "e");
if (crc32("wFpuXOXqV",9) == 925446814) strcat(s, "d");
    return s;
}

char *gimme_verbs() {
    char *s = calloc(6);
    if (crc32("bOZUxb",6) == 2764058749) strcat(s, "g");
if (crc32("kikidVvcRnNr",12) == 3794589669) strcat(s, "h");
if (crc32("OdnNvEGaSRZUT",13) == 1218108208) strcat(s, "i");
if (crc32("AfrixOO",7) == 2950787313) strcat(s, "m");
if (crc32("QxserXXRfYLbDda",15) == 3744518166) strcat(s, "m");
if (crc32("uuQuEdJ",7) == 529114820) strcat(s, "m");
if (crc32("yQCrtqluRl",10) == 3948470544) strcat(s, "e");
    return s;
}

char *striated_verbs() {
    char *s = calloc(9);
    if (crc32("KYktAmGN",8) == 2214774366) strcat(s, "s");
if (crc32("qjvvhNBXAQLKDlI",15) == 3193463976) strcat(s, "t");
if (crc32("YaXaMfKVTzGnG",13) == 3292835834) strcat(s, "r");
if (crc32("BDCIuiarV",9) == 1191599852) strcat(s, "i");
if (crc32("KOkZvkvYnHGlM",13) == 2891433559) strcat(s, "a");
if (crc32("vdnxpeTlq",9) == 2101132343) strcat(s, "t");
if (crc32("kCJtoEcaKzZB",12) == 121008278) strcat(s, "d");
if (crc32("OExdyHsqG",9) == 3908337424) strcat(s, "e");
if (crc32("acqzSpDW",8) == 1551010164) strcat(s, "d");
    return s;
}

char *tunein_verbs() {
    char *s = calloc(7);
    if (crc32("rufhoucuRFTkqbx",15) == 3578158746) strcat(s, "t");
if (crc32("YGiPrUBqJDIxTAH",15) == 2729892364) strcat(s, "u");
if (crc32("QmIwvbFNwFc",11) == 2378453766) strcat(s, "F");
if (crc32("LXyrIKJKkX",10) == 180724897) strcat(s, "n");
if (crc32("LKixhKKwepc",11) == 4017042118) strcat(s, "e");
if (crc32("kOwVaEZlpTFc",12) == 2452352783) strcat(s, "t");
if (crc32("oUnVFdpeDaFg",12) == 82930730) strcat(s, "i");
if (crc32("dVGKqTEWysgx",12) == 1370995534) strcat(s, "L");
if (crc32("yEJXGXSTCu",10) == 2260531218) strcat(s, "n");
    return s;
}

char *finalizing_verbs() {
    char *s = calloc(11);
    if (crc32("uQyZZIhmfQLF",12) == 1341959485) strcat(s, "e");
if (crc32("FQiRcagf",8) == 2360472782) strcat(s, "f");
if (crc32("OfljQdRQbogIAG",14) == 3230121750) strcat(s, "n");
if (crc32("HsJPMyX",7) == 1568657839) strcat(s, "i");
if (crc32("LEtgqZJeMbnl",12) == 2870624776) strcat(s, "n");
if (crc32("vhayP",5) == 2460028866) strcat(s, "a");
if (crc32("JzFYrtYX",8) == 3848428962) strcat(s, "l");
if (crc32("HuOEGFSmAmsbMyV",15) == 2672472362) strcat(s, "i");
if (crc32("hDqdmqH",7) == 3475432907) strcat(s, "z");
if (crc32("KafAazDHLjGHr",13) == 822039979) strcat(s, "i");
if (crc32("wvNTPfoWiZdNPsu",15) == 3033043553) strcat(s, "n");
if (crc32("qtLUUrpynLGJH",13) == 2801551833) strcat(s, "X");
if (crc32("IIxWXvAtA",9) == 285314942) strcat(s, "g");
    return s;
}

char *retort_verbs() {
    char *s = calloc(7);
    if (crc32("ElYyXI",6) == 584228271) strcat(s, "r");
if (crc32("mMmrrhoUX",9) == 1942192024) strcat(s, "R");
if (crc32("HggJoZ",6) == 3422325457) strcat(s, "e");
if (crc32("YviWRjvJlZrik",13) == 3353465489) strcat(s, "t");
if (crc32("bZpradpMAzjaTkP",15) == 800437875) strcat(s, "o");
if (crc32("EephmGwo",8) == 2119919244) strcat(s, "r");
if (crc32("uRlJfpeyOkIKTpq",15) == 2429048115) strcat(s, "H");
if (crc32("MVaQSczixu",10) == 3235917666) strcat(s, "t");
    return s;
}

char *infatuate_verbs() {
    char *s = calloc(10);
    if (crc32("SlwCnXza",8) == 2916756919) strcat(s, "i");
if (crc32("mCkDWVSAAmxoTis",15) == 543882299) strcat(s, "G");
if (crc32("LkJvm",5) == 2154691028) strcat(s, "n");
if (crc32("qfblLIiFN",9) == 1655016373) strcat(s, "p");
if (crc32("BPCEixXifJGpz",13) == 1639092185) strcat(s, "f");
if (crc32("iUSmfobboENxy",13) == 2612782166) strcat(s, "a");
if (crc32("DvmOioS",7) == 3191448334) strcat(s, "Q");
if (crc32("bYUEngobKph",11) == 724229844) strcat(s, "t");
if (crc32("ADwGNxUIUWFIWN",14) == 2541742877) strcat(s, "L");
if (crc32("NmAxjCkdPZxKk",13) == 2006784416) strcat(s, "u");
if (crc32("kMOxoQCTjGQE",12) == 1466790804) strcat(s, "a");
if (crc32("bHdChRFCbbDqbne",15) == 826299212) strcat(s, "t");
if (crc32("oJpFpxRQbwOK",12) == 799621564) strcat(s, "e");
    return s;
}

char *reamalgamated_verbs() {
    char *s = calloc(14);
    if (crc32("PIrfqppfCS",10) == 2146625106) strcat(s, "a");
if (crc32("wjXRE",5) == 903817572) strcat(s, "r");
if (crc32("kPNpRbpuHkVZo",13) == 2690888946) strcat(s, "e");
if (crc32("apaFjvc",7) == 1319719061) strcat(s, "I");
if (crc32("MvDSkfoTTqpjPov",15) == 3052551711) strcat(s, "a");
if (crc32("vglryGwL",8) == 3252608834) strcat(s, "m");
if (crc32("pmLZoY",6) == 2608450885) strcat(s, "a");
if (crc32("anCchi",6) == 3459422212) strcat(s, "v");
if (crc32("rhGbDwxid",9) == 5999550) strcat(s, "l");
if (crc32("bPEuRndSTU",10) == 3821757198) strcat(s, "g");
if (crc32("fldiSvFAlocvrkK",15) == 2328604870) strcat(s, "k");
if (crc32("GevcTQfvwykob",13) == 2290948511) strcat(s, "a");
if (crc32("ZnaoQUz",7) == 3997419154) strcat(s, "S");
if (crc32("fyisFhKMeJZDd",13) == 1873826738) strcat(s, "m");
if (crc32("riERc",5) == 695843876) strcat(s, "a");
if (crc32("ngdhUDwwcIN",11) == 4210016079) strcat(s, "t");
if (crc32("LpAaf",5) == 3157988668) strcat(s, "U");
if (crc32("kIJIVEVMJ",9) == 1723333154) strcat(s, "e");
if (crc32("vZeMkKEjaWopGL",14) == 2912340566) strcat(s, "K");
if (crc32("BTdjiEEWULcWWMj",15) == 532076120) strcat(s, "d");
    return s;
}

char *immerging_verbs() {
    char *s = calloc(10);
    if (crc32("hpfoQleXRwGvB",13) == 472163805) strcat(s, "i");
if (crc32("XGFgwtgakO",10) == 62664123) strcat(s, "d");
if (crc32("vjQLUhinxEm",11) == 2662366740) strcat(s, "m");
if (crc32("dWrTcTDsDTTA",12) == 3750495401) strcat(s, "m");
if (crc32("dBKmLxMYCmeo",12) == 1049238271) strcat(s, "e");
if (crc32("UgwmzlSx",8) == 3984811562) strcat(s, "X");
if (crc32("BRrCLOT",7) == 1735058477) strcat(s, "r");
if (crc32("RBYLB",5) == 1634056787) strcat(s, "k");
if (crc32("akEHySmENZHBHlG",15) == 3722820530) strcat(s, "g");
if (crc32("APPpV",5) == 2838964929) strcat(s, "i");
if (crc32("PUfqmSdXERFQwxq",15) == 3707485780) strcat(s, "D");
if (crc32("KACQsbVzu",9) == 1595612395) strcat(s, "n");
if (crc32("xVYauSCwgn",10) == 469838602) strcat(s, "g");
    return s;
}

char *stagemanaged_verbs() {
    char *s = calloc(13);
    if (crc32("wvTquqDqaiMPZIP",15) == 422242699) strcat(s, "s");
if (crc32("fVVDyieAG",9) == 972124700) strcat(s, "M");
if (crc32("feVdoItWTiFJT",13) == 2081071650) strcat(s, "t");
if (crc32("XuwMtb",6) == 107511478) strcat(s, "a");
if (crc32("ZusZkcugTKlu",12) == 1313601974) strcat(s, "g");
if (crc32("lMFoBnVYLI",10) == 802505097) strcat(s, "e");
if (crc32("HDEbijcQsGnFzO",14) == 3126239990) strcat(s, "m");
if (crc32("MrYkiJODuBz",11) == 2816938785) strcat(s, "m");
if (crc32("puMUNJRKuntB",12) == 4232782213) strcat(s, "a");
if (crc32("vdgLv",5) == 2898692995) strcat(s, "n");
if (crc32("vPabYhf",7) == 1103061776) strcat(s, "a");
if (crc32("sCIKPxOzoux",11) == 714359681) strcat(s, "g");
if (crc32("sVUiGhMIh",9) == 3970552189) strcat(s, "e");
if (crc32("PvjYMixRH",9) == 3053874358) strcat(s, "d");
    return s;
}

char *misfitted_verbs() {
    char *s = calloc(10);
    if (crc32("dfwAlPjxLjtV",12) == 2887352055) strcat(s, "m");
if (crc32("hnePdSBRYx",10) == 2308029568) strcat(s, "i");
if (crc32("pLsCSuJmkMCkSR",14) == 1446337799) strcat(s, "B");
if (crc32("TdzSHT",6) == 1957804606) strcat(s, "s");
if (crc32("NRTBRueATpa",11) == 4122873159) strcat(s, "f");
if (crc32("QwvDJOO",7) == 2156060124) strcat(s, "i");
if (crc32("UxMoogrAyJ",10) == 847273092) strcat(s, "t");
if (crc32("aoUOzmGQrv",10) == 4114204506) strcat(s, "t");
if (crc32("eoDYEHy",7) == 3240033452) strcat(s, "e");
if (crc32("jLTFClMqGexJC",13) == 2298582020) strcat(s, "d");
    return s;
}

char *melodizing_verbs() {
    char *s = calloc(11);
    if (crc32("QtOCAtqgnHDZ",12) == 3110476871) strcat(s, "i");
if (crc32("aVrmwLE",7) == 736109687) strcat(s, "m");
if (crc32("KcYBMycVst",10) == 2195305622) strcat(s, "m");
if (crc32("ToZZQRZ",7) == 185226306) strcat(s, "e");
if (crc32("rjEcBVgesRTVMW",14) == 1151630115) strcat(s, "l");
if (crc32("HqwXuieLL",9) == 806196175) strcat(s, "o");
if (crc32("mFkRIbkKCGpCtt",14) == 268149903) strcat(s, "k");
if (crc32("UOKmOmzbKuldbtV",15) == 1893647687) strcat(s, "d");
if (crc32("kfBtcSc",7) == 2848328154) strcat(s, "t");
if (crc32("OMeYzjEP",8) == 2061421688) strcat(s, "i");
if (crc32("LNQIytgOMdhlb",13) == 3600565871) strcat(s, "z");
if (crc32("kjpxuJZ",7) == 1085972293) strcat(s, "x");
if (crc32("zbqCUfQQod",10) == 2569654063) strcat(s, "i");
if (crc32("mAVLWdBTGiPd",12) == 2095183425) strcat(s, "t");
if (crc32("uwfuLCoPvCsrgt",14) == 3899546986) strcat(s, "n");
if (crc32("GZFpZi",6) == 4290832418) strcat(s, "L");
if (crc32("hYQthfj",7) == 933137292) strcat(s, "g");
    return s;
}

char *flagellated_verbs() {
    char *s = calloc(12);
    if (crc32("qbhhdApckdUBg",13) == 408170828) strcat(s, "a");
if (crc32("dTzLh",5) == 2822552192) strcat(s, "f");
if (crc32("qtyNiwWxAOa",11) == 3676567160) strcat(s, "l");
if (crc32("vrCmWdrEM",9) == 2117462525) strcat(s, "P");
if (crc32("iKTLlhniYdMc",12) == 1114125922) strcat(s, "a");
if (crc32("ZlAvfKagojxmwN",14) == 3931099693) strcat(s, "g");
if (crc32("fapJDh",6) == 175364344) strcat(s, "e");
if (crc32("mPgmiusn",8) == 3276176370) strcat(s, "l");
if (crc32("UKrpcpISmacB",12) == 4162800523) strcat(s, "c");
if (crc32("fifOPDQfIJJW",12) == 448501937) strcat(s, "l");
if (crc32("CUNtkUsFjZmIO",13) == 3890426104) strcat(s, "a");
if (crc32("cXjjx",5) == 2458249496) strcat(s, "t");
if (crc32("qlLLparoOXC",11) == 2991531909) strcat(s, "L");
if (crc32("PlgoMIWnlBMKlRM",15) == 1507380887) strcat(s, "e");
if (crc32("ratdteUXm",9) == 1755681648) strcat(s, "z");
if (crc32("avmKwODx",8) == 712494678) strcat(s, "d");
    return s;
}

char *unfasten_verbs() {
    char *s = calloc(9);
    if (crc32("fyUXA",5) == 3752448231) strcat(s, "u");
if (crc32("vKmUwMuUn",9) == 3121952737) strcat(s, "n");
if (crc32("tjtAMOXeDJj",11) == 2766827872) strcat(s, "f");
if (crc32("doOBMDkEkzZOGU",14) == 3336236736) strcat(s, "a");
if (crc32("mfyHLy",6) == 242337077) strcat(s, "a");
if (crc32("LKEWn",5) == 977048229) strcat(s, "I");
if (crc32("fPjyff",6) == 3484536539) strcat(s, "s");
if (crc32("NAyjmrDQHQuhaq",14) == 3193251216) strcat(s, "x");
if (crc32("MNSMZiKmAjwXy",13) == 1194110844) strcat(s, "t");
if (crc32("dWRmFhdy",8) == 669402707) strcat(s, "e");
if (crc32("aaQTUdeqrq",10) == 2350756095) strcat(s, "u");
if (crc32("HfqQtqIN",8) == 3011570310) strcat(s, "n");
    return s;
}

char *scribbling_verbs() {
    char *s = calloc(11);
    if (crc32("PJaIPpQVOO",10) == 2540968839) strcat(s, "X");
if (crc32("BjRUpHfxzhteXH",14) == 1706451508) strcat(s, "s");
if (crc32("xWOiCDq",7) == 687394015) strcat(s, "s");
if (crc32("zZibeSbTUso",11) == 4233306695) strcat(s, "c");
if (crc32("vwpyMdTfdJ",10) == 1207016292) strcat(s, "P");
if (crc32("hkXHwWE",7) == 3006781156) strcat(s, "r");
if (crc32("lwVeuoIZ",8) == 823280409) strcat(s, "Z");
if (crc32("rlNMrZA",7) == 32165747) strcat(s, "i");
if (crc32("nzHxd",5) == 923989006) strcat(s, "b");
if (crc32("nRxCjalvww",10) == 4177065394) strcat(s, "b");
if (crc32("ECiAoaUNrJ",10) == 33116639) strcat(s, "l");
if (crc32("JwRYqRBCSKc",11) == 2112768275) strcat(s, "m");
if (crc32("yjzxOGO",7) == 1921472921) strcat(s, "i");
if (crc32("DmpEREE",7) == 685387473) strcat(s, "n");
if (crc32("krTtnLKHzDuAcuf",15) == 879556405) strcat(s, "z");
if (crc32("AYnyhjbUM",9) == 3943047215) strcat(s, "g");
    return s;
}

char *petrify_verbs() {
    char *s = calloc(8);
    if (crc32("IqYdRfZ",7) == 3358981374) strcat(s, "Z");
if (crc32("rvgCFYRUdDTFfYK",15) == 1001800866) strcat(s, "p");
if (crc32("bekrDqnqyzv",11) == 3600764868) strcat(s, "e");
if (crc32("zCPsQDHrtE",10) == 3813603102) strcat(s, "r");
if (crc32("PaZcQiVcDP",10) == 1732768307) strcat(s, "t");
if (crc32("oKOlBCGOptlxqtB",15) == 3246824826) strcat(s, "r");
if (crc32("wsBWQwwKSsyD",12) == 1237260651) strcat(s, "i");
if (crc32("jESEA",5) == 898595783) strcat(s, "v");
if (crc32("WdYMQRmqugIKPrO",15) == 2607779001) strcat(s, "f");
if (crc32("tFRqvvKllKDFBS",14) == 827122008) strcat(s, "W");
if (crc32("wKsguD",6) == 2670538607) strcat(s, "y");
    return s;
}

char *fixated_verbs() {
    char *s = calloc(8);
    if (crc32("hJDbuLaEPNfWX",13) == 2761358318) strcat(s, "W");
if (crc32("xjKKDTLHYp",10) == 818926773) strcat(s, "f");
if (crc32("qJAazOO",7) == 1465724473) strcat(s, "i");
if (crc32("oDsXbVLBIYnfU",13) == 316978724) strcat(s, "G");
if (crc32("voLdhrlN",8) == 2533378822) strcat(s, "x");
if (crc32("pelvrO",6) == 835997555) strcat(s, "a");
if (crc32("KxGUfBXg",8) == 2664756415) strcat(s, "F");
if (crc32("gHBlPKuDbCu",11) == 994303616) strcat(s, "t");
if (crc32("GTcQLhd",7) == 3095890808) strcat(s, "e");
if (crc32("XCMXyQCzRdZ",11) == 1918408711) strcat(s, "T");
if (crc32("RranYvfkhlHRyX",14) == 924713617) strcat(s, "d");
    return s;
}

char *osmose_verbs() {
    char *s = calloc(7);
    if (crc32("dpwUgWIYXUt",11) == 3132150136) strcat(s, "o");
if (crc32("YWcJLdejOpbeo",13) == 3098970727) strcat(s, "R");
if (crc32("ZNztGjTymTNUnSu",15) == 592022013) strcat(s, "s");
if (crc32("ChIzhyhISnTqvzT",15) == 2716824062) strcat(s, "m");
if (crc32("hYqzxcxTm",9) == 4235879801) strcat(s, "o");
if (crc32("dSHeBsAlSkR",11) == 1642987775) strcat(s, "M");
if (crc32("jXNVUjtmDUmQ",12) == 2346267667) strcat(s, "s");
if (crc32("jhVYr",5) == 1450304274) strcat(s, "e");
    return s;
}

char *decompose_verbs() {
    char *s = calloc(10);
    if (crc32("mieiCwIYUCc",11) == 3789542112) strcat(s, "d");
if (crc32("iIGNuABBkqHVC",13) == 3657637073) strcat(s, "e");
if (crc32("XbDFTTPFkgTsH",13) == 907299870) strcat(s, "c");
if (crc32("gdjoZrcqdQ",10) == 2729519837) strcat(s, "o");
if (crc32("dofpQeA",7) == 307593749) strcat(s, "m");
if (crc32("zvxItdl",7) == 874234868) strcat(s, "H");
if (crc32("pvfEMxLPjVqZOs",14) == 773115858) strcat(s, "p");
if (crc32("UeBkckn",7) == 473855974) strcat(s, "o");
if (crc32("fESgGNnsvAqAJkA",15) == 232149047) strcat(s, "K");
if (crc32("zHFgnqlvyvzmEZ",14) == 2421432963) strcat(s, "s");
if (crc32("MZlLoUxAiWU",11) == 4246361500) strcat(s, "B");
if (crc32("qYwcvnlMRF",10) == 3720484263) strcat(s, "e");
    return s;
}

char *misnarrated_verbs() {
    char *s = calloc(12);
    if (crc32("rWTtQtyl",8) == 1826149844) strcat(s, "m");
if (crc32("jhmcILqPHisFLY",14) == 1243167035) strcat(s, "E");
if (crc32("DEbBkrEFvVtLtVJ",15) == 3152557637) strcat(s, "i");
if (crc32("uAQTj",5) == 973119227) strcat(s, "l");
if (crc32("JIvihmYQHpBnOiB",15) == 1635156828) strcat(s, "s");
if (crc32("FAtPVeat",8) == 3652715754) strcat(s, "d");
if (crc32("yGkPoWU",7) == 2120145753) strcat(s, "n");
if (crc32("ZZfPsSakR",9) == 214456464) strcat(s, "a");
if (crc32("CnXzkbCWJjg",11) == 2882816251) strcat(s, "r");
if (crc32("zZyihEBJcEtqq",13) == 974742509) strcat(s, "r");
if (crc32("wpOxUiTJFf",10) == 3955163273) strcat(s, "M");
if (crc32("phhFjpjONbaRS",13) == 330192637) strcat(s, "a");
if (crc32("IfIXd",5) == 3397034408) strcat(s, "t");
if (crc32("AkYrgEsDHWFSeau",15) == 1784217864) strcat(s, "O");
if (crc32("LjksnFVaBjW",11) == 2730184039) strcat(s, "e");
if (crc32("KSsjApB",7) == 89259980) strcat(s, "A");
if (crc32("NUBjGAC",7) == 3503399291) strcat(s, "d");
    return s;
}

char *presaged_verbs() {
    char *s = calloc(9);
    if (crc32("DbaJvTMZTGTTziX",15) == 2052545995) strcat(s, "p");
if (crc32("oVijxpcwRjUayFc",15) == 1669909866) strcat(s, "r");
if (crc32("iVOdLMpEYxoIz",13) == 3091433882) strcat(s, "e");
if (crc32("XifSfQlzVZW",11) == 3662083470) strcat(s, "s");
if (crc32("LxXWRkodYZmbtTC",15) == 3317191793) strcat(s, "l");
if (crc32("cYotTOK",7) == 248924880) strcat(s, "a");
if (crc32("ScjPKutMhccPe",13) == 2971852046) strcat(s, "g");
if (crc32("WPMAXxbdJC",10) == 2487257930) strcat(s, "o");
if (crc32("ddPayZXgpY",10) == 1657358702) strcat(s, "e");
if (crc32("mtoUdPCMvay",11) == 2439035138) strcat(s, "d");
    return s;
}

char *fiked_verbs() {
    char *s = calloc(6);
    if (crc32("IEAtBJQDIA",10) == 2627802881) strcat(s, "f");
if (crc32("giCQqhEcs",9) == 2886334070) strcat(s, "G");
if (crc32("yiGjBd",6) == 3269348898) strcat(s, "i");
if (crc32("WgZYxke",7) == 1266335412) strcat(s, "k");
if (crc32("isDKiHLM",8) == 2699744952) strcat(s, "e");
if (crc32("AbUJoBnuVhyjQNU",15) == 3915580161) strcat(s, "L");
if (crc32("TUWGgKEk",8) == 3014391384) strcat(s, "d");
    return s;
}

char *retrofit_verbs() {
    char *s = calloc(9);
    if (crc32("THEpxsUyDv",10) == 1755911181) strcat(s, "r");
if (crc32("lWBOunkU",8) == 528971976) strcat(s, "e");
if (crc32("jmZMr",5) == 1176190225) strcat(s, "t");
if (crc32("zEpbyYa",7) == 3908104335) strcat(s, "r");
if (crc32("yBEZWXPKM",9) == 953765105) strcat(s, "i");
if (crc32("kltUqQjJDpynTJ",14) == 83614155) strcat(s, "o");
if (crc32("azRITEqoWeT",11) == 4060660543) strcat(s, "o");
if (crc32("NMTdZMSHjjrwG",13) == 180420451) strcat(s, "f");
if (crc32("zDSzCOKNIAUEO",13) == 2938164669) strcat(s, "i");
if (crc32("VgvLaegV",8) == 2637208795) strcat(s, "t");
    return s;
}

char *allegorized_verbs() {
    char *s = calloc(12);
    if (crc32("AuxOdMePdLJoztD",15) == 2946503500) strcat(s, "U");
if (crc32("KnTzT",5) == 3768294536) strcat(s, "a");
if (crc32("gGSPdLbPzNcJJj",14) == 615134160) strcat(s, "l");
if (crc32("jBJlBOYin",9) == 1202583006) strcat(s, "l");
if (crc32("NFAjCDp",7) == 1469372125) strcat(s, "l");
if (crc32("lgDvlHMQfl",10) == 1445638271) strcat(s, "e");
if (crc32("KJZwDe",6) == 1595215302) strcat(s, "X");
if (crc32("QSAQex",6) == 18993881) strcat(s, "g");
if (crc32("dNytpCYT",8) == 458524159) strcat(s, "o");
if (crc32("tFPfTgrXAWUmeBa",15) == 1628667732) strcat(s, "H");
if (crc32("WPaNlGblROKl",12) == 832594788) strcat(s, "r");
if (crc32("FuvMOYphq",9) == 3759851613) strcat(s, "m");
if (crc32("qXOeTYwzLtNu",12) == 1909062445) strcat(s, "i");
if (crc32("HnlxaxkmJ",9) == 3846496558) strcat(s, "z");
if (crc32("ISeKEha",7) == 1101895740) strcat(s, "m");
if (crc32("bUmfXX",6) == 2529810847) strcat(s, "e");
if (crc32("BvjnRoDDWYcVF",13) == 278676995) strcat(s, "d");
    return s;
}

char *embark_verbs() {
    char *s = calloc(7);
    if (crc32("pfRanAJ",7) == 1405280063) strcat(s, "e");
if (crc32("LJQCt",5) == 1058568474) strcat(s, "O");
if (crc32("hYVdH",5) == 3368206010) strcat(s, "m");
if (crc32("deSFmbOuIYUE",12) == 1381617026) strcat(s, "b");
if (crc32("RydARnYqQ",9) == 1648387755) strcat(s, "a");
if (crc32("VfPCoghrmSeFlkQ",15) == 1401366744) strcat(s, "V");
if (crc32("iUepSQDm",8) == 1766895584) strcat(s, "r");
if (crc32("yVwZIk",6) == 1185200158) strcat(s, "k");
    return s;
}

char *refold_verbs() {
    char *s = calloc(7);
    if (crc32("tftXndOJSPzE",12) == 3297753124) strcat(s, "J");
if (crc32("ZAxFOKWeeu",10) == 758470325) strcat(s, "r");
if (crc32("WyumBPONevnK",12) == 381345861) strcat(s, "a");
if (crc32("Dshccw",6) == 2949318056) strcat(s, "e");
if (crc32("SPdtjqLRdSLHNG",14) == 3360608247) strcat(s, "f");
if (crc32("bYBeFVHiFcxCZ",13) == 3944065936) strcat(s, "o");
if (crc32("DuzNZQZAPRQdKUz",15) == 501465278) strcat(s, "o");
if (crc32("fidlJBEoNo",10) == 121813789) strcat(s, "l");
if (crc32("KnuNzoxJg",9) == 3664586950) strcat(s, "l");
if (crc32("ycoppWQ",7) == 2814817747) strcat(s, "d");
    return s;
}

char *pasquinading_verbs() {
    char *s = calloc(13);
    if (crc32("FzJgdoBiXTrYqYv",15) == 214983907) strcat(s, "b");
if (crc32("hitpQokgA",9) == 3569409266) strcat(s, "p");
if (crc32("iNdeWItIN",9) == 2730255145) strcat(s, "X");
if (crc32("CUERBZ",6) == 1123966566) strcat(s, "a");
if (crc32("mHFuHNkipI",10) == 52625132) strcat(s, "a");
if (crc32("TNtQUutrSyhinrV",15) == 3523230081) strcat(s, "s");
if (crc32("ORBro",5) == 3466576319) strcat(s, "q");
if (crc32("ijxDMn",6) == 2071871653) strcat(s, "u");
if (crc32("FerRJB",6) == 89892117) strcat(s, "i");
if (crc32("DjWpdTVqJaXWYFI",15) == 4220465942) strcat(s, "e");
if (crc32("JuOAGmsaNKl",11) == 2394945155) strcat(s, "n");
if (crc32("PidmNdxvECbaTMe",15) == 2452459791) strcat(s, "a");
if (crc32("ArKixDL",7) == 2706254498) strcat(s, "K");
if (crc32("eYhUDYoPPmwaC",13) == 2212835122) strcat(s, "d");
if (crc32("CEyCyKLo",8) == 3811818578) strcat(s, "d");
if (crc32("PEucKYBihXsx",12) == 1204184360) strcat(s, "i");
if (crc32("ITPHgKvG",8) == 984142654) strcat(s, "D");
if (crc32("RVarUOECeFHxI",13) == 4165466115) strcat(s, "n");
if (crc32("uaoyWKcmrYiDO",13) == 2658441476) strcat(s, "o");
if (crc32("ibCkzuFfrDBvtnc",15) == 2670621632) strcat(s, "g");
    return s;
}

char *predicated_verbs() {
    char *s = calloc(11);
    if (crc32("cimWeRIR",8) == 1104977187) strcat(s, "Y");
if (crc32("NtBwPuctCKEaxO",14) == 759383924) strcat(s, "p");
if (crc32("xHbTbAUzgr",10) == 933709481) strcat(s, "r");
if (crc32("gWIpPTfJTm",10) == 331144498) strcat(s, "D");
if (crc32("khHelGfMuBLh",12) == 468161652) strcat(s, "e");
if (crc32("FZnjZZPkAhIgwc",14) == 1794512183) strcat(s, "G");
if (crc32("uaDboa",6) == 3381302702) strcat(s, "d");
if (crc32("WhCpcBIprjBs",12) == 2404331108) strcat(s, "i");
if (crc32("OTFcgCr",7) == 1859630200) strcat(s, "c");
if (crc32("JNaEFhN",7) == 1270423076) strcat(s, "K");
if (crc32("OtLjgPBZbgX",11) == 1750831324) strcat(s, "a");
if (crc32("acljMnELiLOBsog",15) == 3161829093) strcat(s, "Z");
if (crc32("GmzxaiGBCacqFH",14) == 2277502580) strcat(s, "t");
if (crc32("oDzKhPRLBWsT",12) == 792908701) strcat(s, "V");
if (crc32("FKjpSJkN",8) == 800690130) strcat(s, "e");
if (crc32("WdxkZVK",7) == 4087218541) strcat(s, "x");
if (crc32("xCVayBG",7) == 2386114966) strcat(s, "d");
    return s;
}

char *quicken_verbs() {
    char *s = calloc(8);
    if (crc32("jKWfAJdrzrx",11) == 2045435999) strcat(s, "a");
if (crc32("SAZxy",5) == 892202078) strcat(s, "q");
if (crc32("DSBmfjuIFUDvlAI",15) == 1782595805) strcat(s, "u");
if (crc32("hHxJfZVq",8) == 2667004272) strcat(s, "L");
if (crc32("IWlFxumD",8) == 1079247349) strcat(s, "i");
if (crc32("bcoHjHVlkZu",11) == 244992925) strcat(s, "c");
if (crc32("goMtOFVN",8) == 3078830630) strcat(s, "k");
if (crc32("sRBwHaoKb",9) == 655537445) strcat(s, "r");
if (crc32("PSSpSuiYj",9) == 4104594519) strcat(s, "e");
if (crc32("NdihLm",6) == 2265392335) strcat(s, "n");
    return s;
}

char *chapelled_verbs() {
    char *s = calloc(10);
    if (crc32("IxZtULlLMUHP",12) == 3172801636) strcat(s, "c");
if (crc32("EiKwHKJA",8) == 490608860) strcat(s, "h");
if (crc32("eUHTgbHLTY",10) == 3693140286) strcat(s, "a");
if (crc32("jbAiiyCFfFycZy",14) == 3504626579) strcat(s, "j");
if (crc32("wlvuFDhbLZd",11) == 3896006863) strcat(s, "p");
if (crc32("LUDBgceJvopbAko",15) == 2201235025) strcat(s, "e");
if (crc32("mTCov",5) == 3392163052) strcat(s, "l");
if (crc32("lCkHkUSoAo",10) == 163030343) strcat(s, "l");
if (crc32("GJNKM",5) == 3116154932) strcat(s, "e");
if (crc32("ONkyS",5) == 3326708740) strcat(s, "b");
if (crc32("BljqXAL",7) == 3311980781) strcat(s, "d");
    return s;
}

char *decerebrated_verbs() {
    char *s = calloc(13);
    if (crc32("PTjYqHDqLXhhvm",14) == 1165737494) strcat(s, "o");
if (crc32("PxgMTlmZOCdu",12) == 3561985069) strcat(s, "d");
if (crc32("JWOpQEx",7) == 1672389835) strcat(s, "e");
if (crc32("pIpEYAgWGpmyzv",14) == 711768999) strcat(s, "c");
if (crc32("CIOSYwDJiOVFx",13) == 336654328) strcat(s, "c");
if (crc32("anpFYRehYQVS",12) == 1541531654) strcat(s, "e");
if (crc32("yBfLBiqTHRa",11) == 1540088926) strcat(s, "L");
if (crc32("bPrJMKzLAHzF",12) == 2858602057) strcat(s, "r");
if (crc32("JwNgJPoIGEhHJh",14) == 1295465754) strcat(s, "e");
if (crc32("uFXCAofmMBfkR",13) == 2187846311) strcat(s, "b");
if (crc32("oGgIAyGwX",9) == 594709437) strcat(s, "r");
if (crc32("YOlpucMqvXan",12) == 3380526044) strcat(s, "Y");
if (crc32("zzbDEGQEyL",10) == 1960261038) strcat(s, "a");
if (crc32("MheRDF",6) == 3274446806) strcat(s, "t");
if (crc32("csorfyvS",8) == 1377606041) strcat(s, "e");
if (crc32("VPVybejZnKTOsg",14) == 2701773983) strcat(s, "d");
    return s;
}

char *spancelling_verbs() {
    char *s = calloc(12);
    if (crc32("ElmcjXDOa",9) == 1991628922) strcat(s, "s");
if (crc32("TtKrSvr",7) == 2646868683) strcat(s, "p");
if (crc32("UKXljcnE",8) == 707253175) strcat(s, "N");
if (crc32("VUWKANxXrDjrS",13) == 3270987142) strcat(s, "a");
if (crc32("IkUotSPvSXSk",12) == 701840489) strcat(s, "j");
if (crc32("ztbywjQWZFoXGzv",15) == 3943003705) strcat(s, "n");
if (crc32("TYcJDKWpVtuD",12) == 2474844403) strcat(s, "a");
if (crc32("OilHflgH",8) == 2436855022) strcat(s, "c");
if (crc32("USfUVbQeYUjCpUo",15) == 2102376400) strcat(s, "e");
if (crc32("fThDNcChO",9) == 3276237750) strcat(s, "l");
if (crc32("iwlbcsNDS",9) == 1970014312) strcat(s, "C");
if (crc32("TghGyddhCgS",11) == 2257580137) strcat(s, "l");
if (crc32("BqTAUR",6) == 4006135497) strcat(s, "m");
if (crc32("fHpHUnF",7) == 1069936746) strcat(s, "i");
if (crc32("HEyiLaB",7) == 2588232566) strcat(s, "n");
if (crc32("riholvPFrh",10) == 2010667950) strcat(s, "g");
    return s;
}

char *forcefeed_verbs() {
    char *s = calloc(10);
    if (crc32("ycFSJDNOGSXmi",13) == 340251095) strcat(s, "p");
if (crc32("UGqDrvVGNwDd",12) == 536688998) strcat(s, "f");
if (crc32("ubeKsI",6) == 1929031661) strcat(s, "o");
if (crc32("ghSqYJGgIJSksW",14) == 3899344916) strcat(s, "H");
if (crc32("stjXnma",7) == 2781589680) strcat(s, "r");
if (crc32("AlayZDYOIQWr",12) == 2917893055) strcat(s, "c");
if (crc32("lNVBsWeA",8) == 2597586556) strcat(s, "y");
if (crc32("LGiMlEsbbLB",11) == 981000700) strcat(s, "e");
if (crc32("oIUpYQ",6) == 974309068) strcat(s, "V");
if (crc32("vNXEoTYZoZhhQRY",15) == 2611327271) strcat(s, "f");
if (crc32("BxhHSORBYCCw",12) == 687967649) strcat(s, "h");
if (crc32("RKgqqvsibdlodg",14) == 1099791061) strcat(s, "e");
if (crc32("PIbYFwrde",9) == 4081049036) strcat(s, "T");
if (crc32("qIhPQoSXls",10) == 3473441170) strcat(s, "e");
if (crc32("gMRPwSjV",8) == 4038473327) strcat(s, "A");
if (crc32("fZVxT",5) == 2536615463) strcat(s, "d");
    return s;
}

char *lose_verbs() {
    char *s = calloc(5);
    if (crc32("bBOnfcPGeHybrDj",15) == 3723562954) strcat(s, "I");
if (crc32("kasanBDUEgAaT",13) == 1209548627) strcat(s, "l");
if (crc32("BmlBJYPDVY",10) == 2455552819) strcat(s, "T");
if (crc32("FYWRJm",6) == 1572311751) strcat(s, "o");
if (crc32("wYqvtJOEndtQBIU",15) == 3059255675) strcat(s, "s");
if (crc32("adiXtslRf",9) == 520760358) strcat(s, "e");
    return s;
}

char *unpack_verbs() {
    char *s = calloc(7);
    if (crc32("DUQShDWXU",9) == 3085236485) strcat(s, "I");
if (crc32("tUxbmYefq",9) == 1092959324) strcat(s, "u");
if (crc32("lGCbi",5) == 4086734498) strcat(s, "c");
if (crc32("VjLIghXliWAjAy",14) == 3212632547) strcat(s, "n");
if (crc32("JbtINykvqUqh",12) == 3109356311) strcat(s, "p");
if (crc32("EmayjPPtNytg",12) == 4005729197) strcat(s, "F");
if (crc32("pHtmTlMgBv",10) == 652249816) strcat(s, "a");
if (crc32("wdPEeoAIlf",10) == 646436661) strcat(s, "s");
if (crc32("SXtRpMTmvJHVwPt",15) == 481159228) strcat(s, "c");
if (crc32("lZEclmZdQTKOU",13) == 1693731813) strcat(s, "k");
    return s;
}

char *diddle_verbs() {
    char *s = calloc(7);
    if (crc32("aMcALZPPmN",10) == 2731900911) strcat(s, "d");
if (crc32("jmkNxPRmyBbDJ",13) == 3964594347) strcat(s, "i");
if (crc32("MYhwGXEF",8) == 3280253348) strcat(s, "U");
if (crc32("KfzMKosfxkWY",12) == 3548047791) strcat(s, "d");
if (crc32("nDUGmOOGkn",10) == 743510118) strcat(s, "a");
if (crc32("NKehwqaCDvS",11) == 2765054586) strcat(s, "d");
if (crc32("UehIyOzCFX",10) == 841892540) strcat(s, "Z");
if (crc32("eqnWWE",6) == 1812934844) strcat(s, "l");
if (crc32("zzLYbhKf",8) == 1032080714) strcat(s, "e");
    return s;
}

char *landscaped_verbs() {
    char *s = calloc(11);
    if (crc32("mpvzvF",6) == 1669168506) strcat(s, "E");
if (crc32("XLhYY",5) == 545849671) strcat(s, "l");
if (crc32("iRECdYzdWSFUSTu",15) == 2177877186) strcat(s, "a");
if (crc32("ZSTrfGcDCu",10) == 1035842528) strcat(s, "n");
if (crc32("HACsUdmhzwHzin",14) == 3066081293) strcat(s, "d");
if (crc32("OCjSZeqNKr",10) == 2549522060) strcat(s, "A");
if (crc32("BSiEmkzzRKZ",11) == 4001655087) strcat(s, "s");
if (crc32("RzYeQtoLvHMxhHd",15) == 1074839749) strcat(s, "g");
if (crc32("zPgvoZaG",8) == 2385794029) strcat(s, "c");
if (crc32("rKoDBDem",8) == 4102888620) strcat(s, "a");
if (crc32("ocTXX",5) == 2293548954) strcat(s, "p");
if (crc32("eezouUFTujkbQMd",15) == 3528572662) strcat(s, "e");
if (crc32("ZmRTZSj",7) == 3371132820) strcat(s, "j");
if (crc32("fXjhi",5) == 48440344) strcat(s, "d");
    return s;
}

char *durst_verbs() {
    char *s = calloc(6);
    if (crc32("bFCBkLxLEOrDG",13) == 348484138) strcat(s, "d");
if (crc32("XVWAb",5) == 3493616041) strcat(s, "p");
if (crc32("ATEtkqydWKfN",12) == 3263156753) strcat(s, "u");
if (crc32("nYYjBub",7) == 1592864965) strcat(s, "D");
if (crc32("HFrSmjbVzhzwL",13) == 3803350021) strcat(s, "r");
if (crc32("hvDJuNXxC",9) == 1375499105) strcat(s, "d");
if (crc32("CqcXotzKg",9) == 1567440484) strcat(s, "s");
if (crc32("rBfepYSaqCPiov",14) == 3233080927) strcat(s, "g");
if (crc32("PeEDaSQs",8) == 2627757735) strcat(s, "t");
    return s;
}

char *precombine_verbs() {
    char *s = calloc(11);
    if (crc32("bkpGd",5) == 100598849) strcat(s, "U");
if (crc32("SVftpQGatYPd",12) == 958689857) strcat(s, "p");
if (crc32("ssSPHmuI",8) == 1804823064) strcat(s, "r");
if (crc32("EfvkiJxvjpKwd",13) == 1490609812) strcat(s, "M");
if (crc32("sqvHrCUXdjAul",13) == 2601887677) strcat(s, "e");
if (crc32("SyrauMctYreWMFU",15) == 2626922054) strcat(s, "t");
if (crc32("AypRNlfQyCxiEGD",15) == 3022415836) strcat(s, "c");
if (crc32("PnHxORMD",8) == 1130999160) strcat(s, "r");
if (crc32("ylHnekPqYn",10) == 2615551302) strcat(s, "o");
if (crc32("DrGeuISZOClI",12) == 1041620448) strcat(s, "m");
if (crc32("eqCpejAevtDZbhG",15) == 1537495086) strcat(s, "b");
if (crc32("JjmiNmfz",8) == 1782724641) strcat(s, "i");
if (crc32("sPNal",5) == 1800394360) strcat(s, "K");
if (crc32("bnOQzftzwM",10) == 3200610388) strcat(s, "n");
if (crc32("ralkkMwnFsVPv",13) == 1656348854) strcat(s, "t");
if (crc32("EvAcuQWJWAAugM",14) == 2177540029) strcat(s, "e");
    return s;
}

char *hennaing_verbs() {
    char *s = calloc(9);
    if (crc32("UYnQJ",5) == 4147434815) strcat(s, "h");
if (crc32("ZcyiCVy",7) == 2443259543) strcat(s, "e");
if (crc32("OrZBjwrvP",9) == 2893256568) strcat(s, "n");
if (crc32("VmXWAwghvr",10) == 4216833924) strcat(s, "K");
if (crc32("NWVEeArYy",9) == 3615827304) strcat(s, "n");
if (crc32("zvaLIKfCRqtbGpO",15) == 1062407702) strcat(s, "j");
if (crc32("IUxvZfZs",8) == 3528234864) strcat(s, "a");
if (crc32("YHOvo",5) == 1915699761) strcat(s, "i");
if (crc32("ZFTNfLa",7) == 3473708246) strcat(s, "L");
if (crc32("GnYrdWo",7) == 3173182376) strcat(s, "n");
if (crc32("gHNUpwRpbM",10) == 3531762368) strcat(s, "g");
    return s;
}

char *backbite_verbs() {
    char *s = calloc(9);
    if (crc32("PdSMw",5) == 1225440295) strcat(s, "F");
if (crc32("ZGUGwnDu",8) == 2518882096) strcat(s, "b");
if (crc32("GBnkoeDPne",10) == 893682222) strcat(s, "a");
if (crc32("jiZDrba",7) == 3247402642) strcat(s, "c");
if (crc32("DLbQQMuYOSM",11) == 493549622) strcat(s, "x");
if (crc32("abybnjyOR",9) == 3626955680) strcat(s, "k");
if (crc32("fYSloNQ",7) == 1641385418) strcat(s, "b");
if (crc32("LiRGLx",6) == 1270471651) strcat(s, "i");
if (crc32("ajZsXaPy",8) == 2433535999) strcat(s, "t");
if (crc32("gIwYRHIKVT",10) == 2175358483) strcat(s, "e");
    return s;
}

char *terminated_verbs() {
    char *s = calloc(11);
    if (crc32("nbSmyOmkhj",10) == 351985136) strcat(s, "t");
if (crc32("aadLC",5) == 489507417) strcat(s, "e");
if (crc32("YWuEaCwPJry",11) == 1709214306) strcat(s, "r");
if (crc32("FgLAVxa",7) == 2760891133) strcat(s, "r");
if (crc32("yTIpcMueAhpyU",13) == 2296647064) strcat(s, "h");
if (crc32("GirOCKCPNr",10) == 2686020175) strcat(s, "m");
if (crc32("NxrDN",5) == 3715023854) strcat(s, "i");
if (crc32("acMWvR",6) == 1349854908) strcat(s, "n");
if (crc32("uczLVYEDAeHKOc",14) == 3362957185) strcat(s, "Q");
if (crc32("QYYeKagQp",9) == 901358153) strcat(s, "a");
if (crc32("aBsrYbzygDgFS",13) == 2609045433) strcat(s, "t");
if (crc32("onAQdfuNLZ",10) == 1137887979) strcat(s, "e");
if (crc32("WjrNwdjppwSyCA",14) == 882564656) strcat(s, "A");
if (crc32("IJlFpDLXHWHFw",13) == 818061290) strcat(s, "d");
    return s;
}

char *smarten_verbs() {
    char *s = calloc(8);
    if (crc32("aNFuUORxDmOV",12) == 3816681294) strcat(s, "s");
if (crc32("CgtFSzUggZsoEta",15) == 2601432640) strcat(s, "m");
if (crc32("HVpGevxNwi",10) == 929194555) strcat(s, "C");
if (crc32("ZmtPRhYAxNFvsv",14) == 2468401692) strcat(s, "a");
if (crc32("oUmbppSapFtUir",14) == 153078298) strcat(s, "r");
if (crc32("XLRoTHcde",9) == 3972277171) strcat(s, "K");
if (crc32("TAPzGYWbqnoU",12) == 2150966786) strcat(s, "t");
if (crc32("LgpDGtzHLBqvi",13) == 2418460841) strcat(s, "e");
if (crc32("NSjovMLUs",9) == 675205102) strcat(s, "L");
if (crc32("JURNNxSzwccSNqV",15) == 273245178) strcat(s, "n");
    return s;
}

char *check_verbs() {
    char *s = calloc(6);
    if (crc32("yRazMVSG",8) == 4256197124) strcat(s, "Q");
if (crc32("rTTFJiaml",9) == 1854162939) strcat(s, "c");
if (crc32("dawKeVqHHR",10) == 432434825) strcat(s, "Z");
if (crc32("CpLBzUUSXdyHWPZ",15) == 3426931333) strcat(s, "h");
if (crc32("AgFXzZVSRyfmr",13) == 1342594502) strcat(s, "m");
if (crc32("EZQcrEJySiao",12) == 3878601331) strcat(s, "e");
if (crc32("intFJCzt",8) == 4290530257) strcat(s, "L");
if (crc32("wQeOfxtHIV",10) == 2518066330) strcat(s, "c");
if (crc32("WbFzessbxKMJjK",14) == 3002821943) strcat(s, "X");
if (crc32("DrMcFCiCbQuWz",13) == 2266378968) strcat(s, "k");
    return s;
}

char *sibilating_verbs() {
    char *s = calloc(11);
    if (crc32("cIGRcjyKP",9) == 3692043293) strcat(s, "s");
if (crc32("ytJQENTzfZ",10) == 1091477048) strcat(s, "i");
if (crc32("ZViJfvYw",8) == 928009263) strcat(s, "i");
if (crc32("crnQcEnCAQZ",11) == 1309572430) strcat(s, "b");
if (crc32("zkSHesh",7) == 4139337292) strcat(s, "r");
if (crc32("ZUPofBaVBkxPn",13) == 4156259037) strcat(s, "i");
if (crc32("FsjuqvUCGgpi",12) == 418406951) strcat(s, "j");
if (crc32("TsHMB",5) == 3518455016) strcat(s, "l");
if (crc32("BhaZPrP",7) == 277082208) strcat(s, "Z");
if (crc32("brtPzFdjftp",11) == 2547413005) strcat(s, "a");
if (crc32("oGVonvw",7) == 3549747293) strcat(s, "t");
if (crc32("rceprrKsh",9) == 2510861460) strcat(s, "o");
if (crc32("TFkTpvw",7) == 3666835389) strcat(s, "i");
if (crc32("dBqJXktVFoQK",12) == 458927144) strcat(s, "n");
if (crc32("tCcmMbQGjfs",11) == 3986209868) strcat(s, "i");
if (crc32("ywIyVH",6) == 4291278445) strcat(s, "g");
    return s;
}

char *juryrigging_verbs() {
    char *s = calloc(12);
    if (crc32("rzBVWlwMLIMIj",13) == 3651952012) strcat(s, "U");
if (crc32("bzdKCWSR",8) == 4145226359) strcat(s, "j");
if (crc32("tvYvxoI",7) == 1290805388) strcat(s, "F");
if (crc32("qXZfdabj",8) == 2843214059) strcat(s, "u");
if (crc32("NkAiFhBxHrx",11) == 2993266810) strcat(s, "r");
if (crc32("uZvtshyxPDxLO",13) == 257932577) strcat(s, "y");
if (crc32("gHLyxto",7) == 2013169305) strcat(s, "r");
if (crc32("yOIEmOdgzr",10) == 3797564302) strcat(s, "X");
if (crc32("wqLvQCenLt",10) == 2094644814) strcat(s, "i");
if (crc32("fGyYumVJVAZ",11) == 4207188411) strcat(s, "g");
if (crc32("jCSsgQuCvgFEYL",14) == 3920747353) strcat(s, "b");
if (crc32("aOkMgDDfHViDAl",14) == 603933674) strcat(s, "g");
if (crc32("ffzUcYvvEzRYzaw",15) == 1523040183) strcat(s, "B");
if (crc32("rHdQiQzXuUa",11) == 331571545) strcat(s, "i");
if (crc32("acZwenC",7) == 3761370460) strcat(s, "n");
if (crc32("OytJbKCzdYl",11) == 3992308588) strcat(s, "X");
if (crc32("xqquiT",6) == 3414282033) strcat(s, "g");
    return s;
}

char *arcaded_verbs() {
    char *s = calloc(8);
    if (crc32("HhnHrqic",8) == 2925938472) strcat(s, "T");
if (crc32("VxMGUN",6) == 3904126820) strcat(s, "a");
if (crc32("MPPVbBZ",7) == 1214696262) strcat(s, "t");
if (crc32("TFJbVtRXS",9) == 1060400052) strcat(s, "r");
if (crc32("GieVbJ",6) == 2461432531) strcat(s, "c");
if (crc32("KsoyM",5) == 630252216) strcat(s, "a");
if (crc32("LJDglosRydKRNS",14) == 1444014439) strcat(s, "d");
if (crc32("CFKfFsnv",8) == 29717608) strcat(s, "t");
if (crc32("AmkhnTw",7) == 2314583650) strcat(s, "e");
if (crc32("WMqSQKv",7) == 306675334) strcat(s, "d");
    return s;
}

char *conjecturing_verbs() {
    char *s = calloc(13);
    if (crc32("LbvDDJglfWJ",11) == 660985800) strcat(s, "c");
if (crc32("caBKdRvWJhoM",12) == 2618144884) strcat(s, "o");
if (crc32("VrlZgTXJmtmh",12) == 3571335169) strcat(s, "n");
if (crc32("UaVBlA",6) == 473447015) strcat(s, "j");
if (crc32("cPluLSZL",8) == 3599891985) strcat(s, "e");
if (crc32("vMkrI",5) == 3779208455) strcat(s, "D");
if (crc32("pHAEJWAsvXp",11) == 799973879) strcat(s, "c");
if (crc32("aQInXRrmKeh",11) == 659919939) strcat(s, "t");
if (crc32("TVYMM",5) == 3405829938) strcat(s, "u");
if (crc32("gucmvPxxQQTY",12) == 3312174088) strcat(s, "k");
if (crc32("TUaunPSRyp",10) == 3677642020) strcat(s, "r");
if (crc32("KzfyAuYeNv",10) == 4043191534) strcat(s, "H");
if (crc32("SpOjkJM",7) == 1278363401) strcat(s, "i");
if (crc32("NhGlaJEnuU",10) == 2636999494) strcat(s, "n");
if (crc32("eWjbuvfkqTIC",12) == 65953094) strcat(s, "g");
    return s;
}

char *excavate_verbs() {
    char *s = calloc(9);
    if (crc32("iftaZOGzyIFM",12) == 4030590339) strcat(s, "o");
if (crc32("oRMPw",5) == 2967238640) strcat(s, "e");
if (crc32("drvqKwysVAe",11) == 2946931888) strcat(s, "A");
if (crc32("EytSwfOnGfTC",12) == 258211079) strcat(s, "x");
if (crc32("tkwpUCTnKvJrCjM",15) == 3765060196) strcat(s, "k");
if (crc32("ItNOxA",6) == 1945623299) strcat(s, "c");
if (crc32("VMCmnMeuszdF",12) == 1520060591) strcat(s, "a");
if (crc32("AJTTkVjKIusHQ",13) == 2986134885) strcat(s, "v");
if (crc32("CcgVKtUX",8) == 1215780095) strcat(s, "x");
if (crc32("MwdIWc",6) == 2746788260) strcat(s, "a");
if (crc32("jThscCgKQftABoG",15) == 907662857) strcat(s, "t");
if (crc32("msgEjH",6) == 2356145446) strcat(s, "e");
    return s;
}

char *sedating_verbs() {
    char *s = calloc(9);
    if (crc32("BCWKf",5) == 3005178225) strcat(s, "s");
if (crc32("DYRXgeHTed",10) == 2389729320) strcat(s, "e");
if (crc32("XSzUlJ",6) == 2133219693) strcat(s, "U");
if (crc32("MSPeZe",6) == 2234133354) strcat(s, "d");
if (crc32("lZEmacdSK",9) == 2288401449) strcat(s, "a");
if (crc32("BGiaZfhC",8) == 3021171692) strcat(s, "y");
if (crc32("AZtmKWYTbsRYiE",14) == 618670507) strcat(s, "t");
if (crc32("IUvenTBP",8) == 1702255765) strcat(s, "D");
if (crc32("LGMKsvGVQuepa",13) == 3981494318) strcat(s, "i");
if (crc32("mUmKLN",6) == 2372984061) strcat(s, "n");
if (crc32("zellzbpnQoyW",12) == 2070259269) strcat(s, "T");
if (crc32("ardaQS",6) == 1575707627) strcat(s, "g");
    return s;
}

char *croon_verbs() {
    char *s = calloc(6);
    if (crc32("yWGzuSVoI",9) == 2736909570) strcat(s, "c");
if (crc32("mfDxF",5) == 3169078087) strcat(s, "c");
if (crc32("ATCAyibKT",9) == 3378474657) strcat(s, "r");
if (crc32("ZeWWEyr",7) == 2831044138) strcat(s, "o");
if (crc32("NfIgrypWjmJISD",14) == 1715252389) strcat(s, "o");
if (crc32("vqHlHEvYXNDz",12) == 2184828089) strcat(s, "N");
if (crc32("hntmoH",6) == 1297560778) strcat(s, "n");
    return s;
}

char *fiddlefaddling_verbs() {
    char *s = calloc(15);
    if (crc32("EBgXWRSONAcbiHq",15) == 1470146409) strcat(s, "f");
if (crc32("OSJeyPxW",8) == 3387891640) strcat(s, "v");
if (crc32("xvYXEuHvmMNm",12) == 1707870065) strcat(s, "i");
if (crc32("XTutnZc",7) == 3371602564) strcat(s, "B");
if (crc32("KoaGjUdnlNuCX",13) == 2962351215) strcat(s, "d");
if (crc32("JQIYP",5) == 3632914068) strcat(s, "d");
if (crc32("rAAFWCJrDSBSq",13) == 1463389223) strcat(s, "q");
if (crc32("FmyZIgI",7) == 72899802) strcat(s, "l");
if (crc32("sbrhmAAkwLocIhE",15) == 1083853243) strcat(s, "e");
if (crc32("iBYQI",5) == 2899374729) strcat(s, "f");
if (crc32("wBNxqS",6) == 1622788588) strcat(s, "a");
if (crc32("vfeySJXvpFJ",11) == 2584779276) strcat(s, "d");
if (crc32("GfoIXbRhXQ",10) == 573328132) strcat(s, "d");
if (crc32("eJSoakDSFM",10) == 3223844476) strcat(s, "l");
if (crc32("wrXAx",5) == 771955022) strcat(s, "x");
if (crc32("zwpIaTX",7) == 787446427) strcat(s, "i");
if (crc32("rCcZj",5) == 2202759626) strcat(s, "h");
if (crc32("EgGFuVaC",8) == 675528406) strcat(s, "n");
if (crc32("GcIZG",5) == 1328393204) strcat(s, "J");
if (crc32("YHioYdNwKY",10) == 501695872) strcat(s, "g");
    return s;
}

char *bloodiest_verbs() {
    char *s = calloc(10);
    if (crc32("ycfuMVHSITjpcW",14) == 2996411198) strcat(s, "b");
if (crc32("fpixfmxWPy",10) == 887521657) strcat(s, "l");
if (crc32("oiRCLMxewe",10) == 2309067103) strcat(s, "Y");
if (crc32("rADpVHqcPJtRs",13) == 256799910) strcat(s, "o");
if (crc32("SCiDqvhdb",9) == 3995922223) strcat(s, "o");
if (crc32("guyhKZxRJKgEThe",15) == 3704919766) strcat(s, "Z");
if (crc32("SoCCAW",6) == 3349824831) strcat(s, "d");
if (crc32("WxeKunCpevQnn",13) == 2668148459) strcat(s, "v");
if (crc32("emkfiiJ",7) == 1696057076) strcat(s, "i");
if (crc32("PQZKPalY",8) == 3518448153) strcat(s, "B");
if (crc32("fiFYFrxxFAMT",12) == 2253802889) strcat(s, "e");
if (crc32("dCCXQlJu",8) == 3712654011) strcat(s, "s");
if (crc32("qyTYBXQDXrUJBy",14) == 2868386980) strcat(s, "T");
if (crc32("rsKcqSD",7) == 3632912863) strcat(s, "t");
    return s;
}

char *slimmest_verbs() {
    char *s = calloc(9);
    if (crc32("TYIWCPIwbRWWJQE",15) == 1326964917) strcat(s, "r");
if (crc32("TdEZiUrWJdExEYz",15) == 633728841) strcat(s, "s");
if (crc32("czSnqKwFRGwjc",13) == 980524411) strcat(s, "E");
if (crc32("xrVjSx",6) == 2983163057) strcat(s, "l");
if (crc32("dPrBIpFuOxJb",12) == 485746286) strcat(s, "N");
if (crc32("gyuZu",5) == 3372624256) strcat(s, "i");
if (crc32("dKiuvozQTYw",11) == 2850533184) strcat(s, "H");
if (crc32("YGHMvGosIOpQB",13) == 1809921468) strcat(s, "m");
if (crc32("JpsaA",5) == 1969814549) strcat(s, "h");
if (crc32("zMVhNmukvlJoq",13) == 1308473143) strcat(s, "m");
if (crc32("pskRpqsJErE",11) == 1255013135) strcat(s, "e");
if (crc32("hOLpEX",6) == 2368579409) strcat(s, "X");
if (crc32("HTVcoEw",7) == 3820167109) strcat(s, "s");
if (crc32("YrKBog",6) == 401165874) strcat(s, "t");
    return s;
}

char *kennelling_verbs() {
    char *s = calloc(11);
    if (crc32("TaedgUdpjnfK",12) == 122052408) strcat(s, "F");
if (crc32("gisLLoqpvpEoEE",14) == 4124416148) strcat(s, "k");
if (crc32("rNQdwhaREbXxEDK",15) == 3019682884) strcat(s, "e");
if (crc32("RvVKaBXRuMCft",13) == 1936312568) strcat(s, "W");
if (crc32("pjGenzl",7) == 3990747684) strcat(s, "n");
if (crc32("QSmonvLmZd",10) == 735414057) strcat(s, "k");
if (crc32("UbmYNnbbGEZR",12) == 3652090837) strcat(s, "n");
if (crc32("GaDjwVbigAfzhpV",15) == 3662895050) strcat(s, "D");
if (crc32("CIHrMdajl",9) == 2163119771) strcat(s, "e");
if (crc32("fnkpDu",6) == 1170314024) strcat(s, "l");
if (crc32("wJgWzFTmz",9) == 478947250) strcat(s, "f");
if (crc32("awMxBJxpq",9) == 1298935825) strcat(s, "l");
if (crc32("UMueUc",6) == 1242753553) strcat(s, "K");
if (crc32("HvRYwCvVi",9) == 1008169159) strcat(s, "i");
if (crc32("psGeXRldg",9) == 992414698) strcat(s, "e");
if (crc32("xoJPRyLue",9) == 179894985) strcat(s, "n");
if (crc32("gMyRlxqi",8) == 751369135) strcat(s, "g");
if (crc32("uLCdyJGiXETW",12) == 3913772205) strcat(s, "g");
    return s;
}

char *precounseled_verbs() {
    char *s = calloc(13);
    if (crc32("stNOaTI",7) == 3099209414) strcat(s, "n");
if (crc32("BZvEiiadvI",10) == 3813484986) strcat(s, "p");
if (crc32("UZdppWlrm",9) == 563329997) strcat(s, "F");
if (crc32("nSBDcErj",8) == 2989576144) strcat(s, "r");
if (crc32("rnVKYPDmFgbx",12) == 1072619356) strcat(s, "e");
if (crc32("OGyPPcD",7) == 84312846) strcat(s, "Y");
if (crc32("Emslg",5) == 3545500067) strcat(s, "c");
if (crc32("snhCNpyH",8) == 3460341071) strcat(s, "o");
if (crc32("QMoLaxGZbp",10) == 2060257344) strcat(s, "u");
if (crc32("cFOrFPOGJP",10) == 434440208) strcat(s, "G");
if (crc32("WKkBlZSjcO",10) == 2202935988) strcat(s, "n");
if (crc32("pTlPyfhMPvHAmTr",15) == 3740906285) strcat(s, "s");
if (crc32("tONlmsvtbube",12) == 3444312736) strcat(s, "e");
if (crc32("gUXRnWz",7) == 3778724585) strcat(s, "l");
if (crc32("sHLtBvqP",8) == 1307596427) strcat(s, "n");
if (crc32("mmqjnAal",8) == 1158866684) strcat(s, "e");
if (crc32("ZNWgVoRXvd",10) == 3149588144) strcat(s, "d");
    return s;
}

char *retelegraph_verbs() {
    char *s = calloc(12);
    if (crc32("akMQKFEcyCd",11) == 2488516059) strcat(s, "l");
if (crc32("GDdil",5) == 2271355471) strcat(s, "r");
if (crc32("DoSoRAqUFbBjcIb",15) == 463877633) strcat(s, "n");
if (crc32("WcScfBkOMuZHmMY",15) == 2424392892) strcat(s, "e");
if (crc32("BSgPyHPhckDwnxu",15) == 3730255671) strcat(s, "t");
if (crc32("wvFuDx",6) == 4160313312) strcat(s, "e");
if (crc32("gJYlvnjakcj",11) == 1542017749) strcat(s, "C");
if (crc32("yIjfhLRsPZq",11) == 2751386238) strcat(s, "l");
if (crc32("yWITlltwduaeoo",14) == 2755031122) strcat(s, "e");
if (crc32("QcwExaUVmh",10) == 619674229) strcat(s, "g");
if (crc32("kJNrQYHgOphRbA",14) == 381157725) strcat(s, "r");
if (crc32("zjEpM",5) == 1893209060) strcat(s, "a");
if (crc32("calAdclnE",9) == 3874109078) strcat(s, "G");
if (crc32("KOAnB",5) == 948066124) strcat(s, "p");
if (crc32("bwtPvrfXS",9) == 1503587682) strcat(s, "e");
if (crc32("zKfNAaRWUdvM",12) == 1273945543) strcat(s, "h");
    return s;
}

char *anticked_verbs() {
    char *s = calloc(9);
    if (crc32("lENpvD",6) == 1741376294) strcat(s, "z");
if (crc32("ebgacjFy",8) == 3012196965) strcat(s, "a");
if (crc32("zZNJWDEhzlkWqR",14) == 2009631679) strcat(s, "P");
if (crc32("eoOZzO",6) == 1668739494) strcat(s, "n");
if (crc32("PbTRPzXSoAAbE",13) == 299888581) strcat(s, "s");
if (crc32("vAdaEMnXZuLlt",13) == 3030440456) strcat(s, "t");
if (crc32("jjPgOFSSrM",10) == 2091808244) strcat(s, "i");
if (crc32("IJeWxIxdYqsavfQ",15) == 856311104) strcat(s, "g");
if (crc32("vsHhyd",6) == 2123192532) strcat(s, "c");
if (crc32("siNxbLSiyg",10) == 3441367771) strcat(s, "x");
if (crc32("NkbZZBQGK",9) == 3155313674) strcat(s, "k");
if (crc32("VEVfYQbbXEqk",12) == 719594200) strcat(s, "G");
if (crc32("ndsvm",5) == 1219841017) strcat(s, "e");
if (crc32("aDkEIi",6) == 1898623318) strcat(s, "m");
if (crc32("JjthrexF",8) == 1010505531) strcat(s, "d");
    return s;
}

char *overconsumed_verbs() {
    char *s = calloc(13);
    if (crc32("glaJrjLXqPkeM",13) == 4005357560) strcat(s, "o");
if (crc32("zuTcdSnHu",9) == 3510805780) strcat(s, "v");
if (crc32("UcxTDfKFtYfJn",13) == 1159575074) strcat(s, "B");
if (crc32("nTGvCLCgTIzsW",13) == 3136540050) strcat(s, "e");
if (crc32("HrdThTK",7) == 4255292162) strcat(s, "r");
if (crc32("TmtzyRU",7) == 1054917083) strcat(s, "c");
if (crc32("ysFgxtTXxUeOcA",14) == 1892670730) strcat(s, "H");
if (crc32("QzKqFfudEJiNyT",14) == 1373256622) strcat(s, "o");
if (crc32("ukPZhxskZEZN",12) == 1454180738) strcat(s, "n");
if (crc32("czgHWfdonvSYg",13) == 3025932616) strcat(s, "C");
if (crc32("VatozjbFDwB",11) == 1390969615) strcat(s, "s");
if (crc32("jiBlHjDbRqPcXf",14) == 2543606116) strcat(s, "u");
if (crc32("oZyUagcDTnLFcsk",15) == 2504203987) strcat(s, "u");
if (crc32("luLAfCuzpE",10) == 38234228) strcat(s, "W");
if (crc32("MLvwhuMXeNN",11) == 723452526) strcat(s, "m");
if (crc32("wCJLLu",6) == 1228732164) strcat(s, "e");
if (crc32("wqZqtldHMzvs",12) == 497396329) strcat(s, "n");
if (crc32("jIubtPkbn",9) == 2632368025) strcat(s, "d");
    return s;
}

char *restamp_verbs() {
    char *s = calloc(8);
    if (crc32("vIuzEcJXPu",10) == 570098088) strcat(s, "S");
if (crc32("fvsMDuT",7) == 916484032) strcat(s, "r");
if (crc32("juyLycOetzo",11) == 2436931132) strcat(s, "e");
if (crc32("vMqCYNEm",8) == 3021398601) strcat(s, "H");
if (crc32("DcUnteab",8) == 2112975356) strcat(s, "s");
if (crc32("GnMSUIh",7) == 37301607) strcat(s, "f");
if (crc32("MICWkkfxz",9) == 2194117763) strcat(s, "t");
if (crc32("bVVCuUBFT",9) == 1032317454) strcat(s, "p");
if (crc32("sOcYEMyISkCAAQ",14) == 3719976764) strcat(s, "a");
if (crc32("qfattQgdrWhC",12) == 2969670264) strcat(s, "J");
if (crc32("qiZQlCSeFSXYGd",14) == 1352865035) strcat(s, "m");
if (crc32("rBoSZPygSZRZ",12) == 220145311) strcat(s, "p");
    return s;
}

char *rebalanced_verbs() {
    char *s = calloc(11);
    if (crc32("CqxHpLiCNLto",12) == 135668520) strcat(s, "r");
if (crc32("lIINZmvRDUYrxcR",15) == 1156965718) strcat(s, "O");
if (crc32("VYyxmuenLOEhKkI",15) == 1402856197) strcat(s, "e");
if (crc32("SeoCnpIPmegcg",13) == 3846999668) strcat(s, "b");
if (crc32("VLbizzebmkgt",12) == 1867164346) strcat(s, "a");
if (crc32("QkhCqFAy",8) == 2145930452) strcat(s, "V");
if (crc32("RkuDom",6) == 3832697148) strcat(s, "l");
if (crc32("BFOWrwIJvmS",11) == 2481371282) strcat(s, "b");
if (crc32("IZfyklZwWSAppvs",15) == 4127755349) strcat(s, "a");
if (crc32("MkCgi",5) == 611039836) strcat(s, "J");
if (crc32("DXGyBfcbou",10) == 332525116) strcat(s, "n");
if (crc32("QpikhKOjO",9) == 1608747375) strcat(s, "T");
if (crc32("iXKfJSqPvuSPMWC",15) == 3159899552) strcat(s, "c");
if (crc32("pBKsqvoSkWbq",12) == 3800144065) strcat(s, "e");
if (crc32("aiNXw",5) == 3797516896) strcat(s, "d");
    return s;
}

char *overpleasing_verbs() {
    char *s = calloc(13);
    if (crc32("pWZnnlbRvFdVezo",15) == 1606171619) strcat(s, "o");
if (crc32("GQmzxhQx",8) == 3521222020) strcat(s, "v");
if (crc32("awNACogo",8) == 4172759066) strcat(s, "W");
if (crc32("JHWjwukIW",9) == 2683684801) strcat(s, "e");
if (crc32("EOspxzK",7) == 3458217750) strcat(s, "r");
if (crc32("dEwZt",5) == 119987054) strcat(s, "Q");
if (crc32("tLEwhbfQA",9) == 3811352567) strcat(s, "p");
if (crc32("CqJXywPaiYIse",13) == 3933105689) strcat(s, "z");
if (crc32("VjmfyWqsCnS",11) == 677569465) strcat(s, "l");
if (crc32("wBGliPExTVfCdH",14) == 823834985) strcat(s, "T");
if (crc32("mBqzwb",6) == 1857844020) strcat(s, "e");
if (crc32("dVOKn",5) == 2761732419) strcat(s, "h");
if (crc32("kDQRLQS",7) == 3424761526) strcat(s, "a");
if (crc32("UiRJPD",6) == 2776843326) strcat(s, "r");
if (crc32("HrMltZDPPVB",11) == 2531956507) strcat(s, "s");
if (crc32("saBJpnTDN",9) == 48105156) strcat(s, "i");
if (crc32("gJxUf",5) == 561504018) strcat(s, "U");
if (crc32("YGnBuDbXBZoUgIc",15) == 4007330806) strcat(s, "n");
if (crc32("JOAfVhr",7) == 2308836547) strcat(s, "D");
if (crc32("tPQEEIQuJ",9) == 459779417) strcat(s, "g");
    return s;
}

char *nurtured_verbs() {
    char *s = calloc(9);
    if (crc32("aUwdBamU",8) == 2316086201) strcat(s, "G");
if (crc32("mjFeCdRnzqtAUV",14) == 649058203) strcat(s, "n");
if (crc32("ZBTWjoUSiI",10) == 299758960) strcat(s, "u");
if (crc32("XBtSSM",6) == 1550959851) strcat(s, "i");
if (crc32("uBCjrJdmXilFCgO",15) == 2251670046) strcat(s, "r");
if (crc32("VrfAQCoaFKEO",12) == 59722893) strcat(s, "t");
if (crc32("wDNFBSA",7) == 3127524718) strcat(s, "W");
if (crc32("FUSYmR",6) == 2010355752) strcat(s, "u");
if (crc32("garLbTALfwHgp",13) == 2967818701) strcat(s, "Y");
if (crc32("CcRAyzeHmUzgq",13) == 2481521617) strcat(s, "r");
if (crc32("gMWuWHN",7) == 1985898109) strcat(s, "e");
if (crc32("QDOIm",5) == 2601702632) strcat(s, "X");
if (crc32("lhBfIchU",8) == 343238543) strcat(s, "d");
    return s;
}

char *hoveled_verbs() {
    char *s = calloc(8);
    if (crc32("tvsKmQvWwbQc",12) == 1477654247) strcat(s, "h");
if (crc32("kjxlAio",7) == 2674578067) strcat(s, "C");
if (crc32("HRkHGBjrj",9) == 3491371071) strcat(s, "o");
if (crc32("dNjkLJCxPtQmpd",14) == 1394403061) strcat(s, "v");
if (crc32("GSMIQFHMJc",10) == 1603690781) strcat(s, "e");
if (crc32("EcMJPG",6) == 2720692322) strcat(s, "h");
if (crc32("rqTHNKZGkRm",11) == 4215486669) strcat(s, "l");
if (crc32("mCAhApZUCYRDPLW",15) == 3438497523) strcat(s, "e");
if (crc32("aVObQtSd",8) == 3751427272) strcat(s, "d");
    return s;
}

char *differentiating_verbs() {
    char *s = calloc(16);
    if (crc32("UUnHWAhKLnygjEZ",15) == 3046919300) strcat(s, "V");
if (crc32("glOQygWp",8) == 4130834052) strcat(s, "d");
if (crc32("EGFVoCwkHs",10) == 3613970633) strcat(s, "y");
if (crc32("YEdSOwqdPpgXJd",14) == 2809647741) strcat(s, "i");
if (crc32("FmqTqcoUHx",10) == 465748284) strcat(s, "f");
if (crc32("tFnKqQyEVHcVY",13) == 3415868738) strcat(s, "f");
if (crc32("mfeJkLfCAyyNjf",14) == 3840352149) strcat(s, "A");
if (crc32("SAkuD",5) == 4248981925) strcat(s, "e");
if (crc32("asBPwraBgX",10) == 766383814) strcat(s, "t");
if (crc32("bTLgMVxoNX",10) == 3420099954) strcat(s, "r");
if (crc32("vexTuGZ",7) == 360784850) strcat(s, "c");
if (crc32("tiuzRuYAqwRdA",13) == 967383649) strcat(s, "e");
if (crc32("oTcNdt",6) == 2127900262) strcat(s, "f");
if (crc32("qtFGOgfLhpb",11) == 2400982084) strcat(s, "n");
if (crc32("lbKNRceeA",9) == 1376943324) strcat(s, "w");
if (crc32("ELnlscB",7) == 612499697) strcat(s, "t");
if (crc32("MPLpJ",5) == 767216505) strcat(s, "q");
if (crc32("yzqwmuza",8) == 1639611867) strcat(s, "i");
if (crc32("KTboxWxTvbvSQ",13) == 606234546) strcat(s, "a");
if (crc32("ZAiXw",5) == 1814879299) strcat(s, "t");
if (crc32("ptprPUWecNp",11) == 4192375058) strcat(s, "i");
if (crc32("QMABybAI",8) == 2219023680) strcat(s, "n");
if (crc32("viVcAxiSWPz",11) == 616636432) strcat(s, "g");
    return s;
}

char *resit_verbs() {
    char *s = calloc(6);
    if (crc32("HjiamVsEayQxFHy",15) == 4273571680) strcat(s, "r");
if (crc32("sslGaArFi",9) == 340704112) strcat(s, "f");
if (crc32("vUAqXznfLLMUZy",14) == 781015289) strcat(s, "e");
if (crc32("ctqCM",5) == 900727269) strcat(s, "n");
if (crc32("CnmIZP",6) == 2201251318) strcat(s, "s");
if (crc32("IldWNrfLHnElIrn",15) == 10686888) strcat(s, "i");
if (crc32("xeYHoLu",7) == 236930137) strcat(s, "r");
if (crc32("ozTTCYmTayEJ",12) == 163890619) strcat(s, "t");
    return s;
}

char *reilluminating_verbs() {
    char *s = calloc(15);
    if (crc32("SqbjHAldXBwy",12) == 742653348) strcat(s, "r");
if (crc32("glnmAA",6) == 3784969654) strcat(s, "t");
if (crc32("lJjcLmnp",8) == 1331096040) strcat(s, "e");
if (crc32("uffcgb",6) == 562274190) strcat(s, "i");
if (crc32("mIbXJtZrDRsUA",13) == 3072631800) strcat(s, "l");
if (crc32("bXGCfU",6) == 2686759359) strcat(s, "l");
if (crc32("oGreFYyH",8) == 2710924221) strcat(s, "u");
if (crc32("WeIDKl",6) == 1453216283) strcat(s, "f");
if (crc32("cVjOfSqP",8) == 628581997) strcat(s, "m");
if (crc32("MwndRAuPdmVTa",13) == 1565130543) strcat(s, "i");
if (crc32("cEfxYNMPLSIN",12) == 105851172) strcat(s, "j");
if (crc32("pCSLGh",6) == 4191840955) strcat(s, "n");
if (crc32("HfSJVVo",7) == 4078438367) strcat(s, "l");
if (crc32("wNlmfkbbYXh",11) == 1740288191) strcat(s, "a");
if (crc32("oabqMIoUP",9) == 2281690200) strcat(s, "L");
if (crc32("sbLxA",5) == 1992467670) strcat(s, "t");
if (crc32("HDJDZzRcy",9) == 607553371) strcat(s, "i");
if (crc32("LSKpDaHakWtyTrB",15) == 808951856) strcat(s, "n");
if (crc32("qjJNUyPbiaaSVnd",15) == 2190338986) strcat(s, "y");
if (crc32("gjRkfTUlVv",10) == 2095707810) strcat(s, "g");
    return s;
}

char *presubscribing_verbs() {
    char *s = calloc(15);
    if (crc32("LXOAcDQVxGMHW",13) == 3409735499) strcat(s, "p");
if (crc32("jNFxTxTSJ",9) == 2889784873) strcat(s, "y");
if (crc32("enekXn",6) == 1609256597) strcat(s, "r");
if (crc32("nRRLSUjmy",9) == 2308853304) strcat(s, "H");
if (crc32("olqZOTAbLsFaFpT",15) == 353482732) strcat(s, "e");
if (crc32("VwxwYrkgcjuIHEs",15) == 3295697105) strcat(s, "R");
if (crc32("oOwKGOkd",8) == 1451065755) strcat(s, "s");
if (crc32("UsFqvFmH",8) == 1752858762) strcat(s, "x");
if (crc32("efAGor",6) == 4120542914) strcat(s, "u");
if (crc32("QcUBIdAmDcKvI",13) == 3992728144) strcat(s, "S");
if (crc32("wNykl",5) == 1865820172) strcat(s, "b");
if (crc32("ZbAWCg",6) == 4079161544) strcat(s, "W");
if (crc32("JayuGpxwfWMA",12) == 3501359302) strcat(s, "s");
if (crc32("PgTGBqVGBfOOPw",14) == 2999296041) strcat(s, "c");
if (crc32("qqEhPtQGq",9) == 136442858) strcat(s, "O");
if (crc32("iWsxUYGGHCTkGQQ",15) == 1156014671) strcat(s, "r");
if (crc32("akSFEcD",7) == 2172340771) strcat(s, "V");
if (crc32("TwwcZ",5) == 1770649704) strcat(s, "i");
if (crc32("Vrobavb",7) == 1735013638) strcat(s, "O");
if (crc32("HpAlr",5) == 3280312133) strcat(s, "b");
if (crc32("HNfZDYxl",8) == 4086904800) strcat(s, "i");
if (crc32("sswnCZYoOtKE",12) == 1511326764) strcat(s, "n");
if (crc32("ZwKcSZEHx",9) == 2669081514) strcat(s, "p");
if (crc32("DdiqZduIvLGi",12) == 1795620126) strcat(s, "g");
    return s;
}

char *airdropped_verbs() {
    char *s = calloc(11);
    if (crc32("llYnTJMjp",9) == 2128175812) strcat(s, "C");
if (crc32("COSfPLsDA",9) == 395567360) strcat(s, "a");
if (crc32("ESXRUh",6) == 3806536378) strcat(s, "U");
if (crc32("NENbPd",6) == 3565147603) strcat(s, "i");
if (crc32("QpeiPfHotcLegNK",15) == 1537911906) strcat(s, "l");
if (crc32("yfLjdnhdHPBxg",13) == 3835660793) strcat(s, "r");
if (crc32("nXpYBsc",7) == 1247314370) strcat(s, "d");
if (crc32("WWQDByTeTZDi",12) == 521045868) strcat(s, "y");
if (crc32("YxCvgPYUT",9) == 3345835426) strcat(s, "r");
if (crc32("QBbJJDyRCtFiQx",14) == 2998968721) strcat(s, "b");
if (crc32("vYGZd",5) == 2045454720) strcat(s, "o");
if (crc32("aPsdPSdfqYACwSs",15) == 3573038892) strcat(s, "B");
if (crc32("BvwQJQIeBEUQ",12) == 405812277) strcat(s, "p");
if (crc32("TtcOWlFPR",9) == 523445961) strcat(s, "r");
if (crc32("ecMDZIynY",9) == 970594213) strcat(s, "p");
if (crc32("dfRfiWusSrlGcn",14) == 1778113770) strcat(s, "e");
if (crc32("WMsMfqKSdJQvf",13) == 1564837639) strcat(s, "x");
if (crc32("jHopMEaBtHNvJLm",15) == 2287854746) strcat(s, "d");
    return s;
}

char *personify_verbs() {
    char *s = calloc(10);
    if (crc32("ciZCnNQuqA",10) == 2998110032) strcat(s, "x");
if (crc32("yZwLdSDXCVKpo",13) == 1118947417) strcat(s, "p");
if (crc32("eCbvlURA",8) == 699748188) strcat(s, "e");
if (crc32("heIsMsWEmc",10) == 4123731452) strcat(s, "r");
if (crc32("LlexIboqhigFRCH",15) == 3088051308) strcat(s, "x");
if (crc32("mlCTjAwQXebuWdn",15) == 197451279) strcat(s, "s");
if (crc32("PENMJxiGRklPB",13) == 3027147953) strcat(s, "o");
if (crc32("PUvKMWI",7) == 1368320358) strcat(s, "n");
if (crc32("LJrIJDhygZGakf",14) == 571827225) strcat(s, "n");
if (crc32("GxwTfgXbWmBm",12) == 4240936919) strcat(s, "i");
if (crc32("xeSyxj",6) == 3480772121) strcat(s, "f");
if (crc32("wEDOn",5) == 2338478404) strcat(s, "y");
    return s;
}

char *leach_verbs() {
    char *s = calloc(6);
    if (crc32("PhTLinzgiTEY",12) == 217917016) strcat(s, "K");
if (crc32("fwscYQdyDmeam",13) == 3721334766) strcat(s, "l");
if (crc32("eHmtDRkde",9) == 3303755258) strcat(s, "e");
if (crc32("nVZjpNJFGyry",12) == 1432398240) strcat(s, "p");
if (crc32("WVydkVPFDvasyPP",15) == 1811912150) strcat(s, "a");
if (crc32("HqUNqnfBDh",10) == 3999474692) strcat(s, "T");
if (crc32("SqVRyxndLCBpu",13) == 713356187) strcat(s, "c");
if (crc32("smiStgYuIztm",12) == 1862180090) strcat(s, "h");
    return s;
}

char *halogenate_verbs() {
    char *s = calloc(11);
    if (crc32("zhycvcqqVMGlId",14) == 1379244105) strcat(s, "W");
if (crc32("VTmdYgUzBuBv",12) == 3056988258) strcat(s, "h");
if (crc32("OSGkTTKYId",10) == 3525218741) strcat(s, "E");
if (crc32("qxHepslkm",9) == 623287962) strcat(s, "a");
if (crc32("bmpASEStjy",10) == 4078613120) strcat(s, "l");
if (crc32("vocquN",6) == 3361150029) strcat(s, "o");
if (crc32("PDAVswwbofu",11) == 2683377408) strcat(s, "g");
if (crc32("fksJdlcrY",9) == 3906685008) strcat(s, "y");
if (crc32("MqdXBrKRALFhfn",14) == 352672535) strcat(s, "e");
if (crc32("pAJOt",5) == 1734278675) strcat(s, "n");
if (crc32("GsvTDkadhr",10) == 1311232527) strcat(s, "n");
if (crc32("QdbZjntbACvy",12) == 2471565895) strcat(s, "x");
if (crc32("RKyoGtgwwCmNtE",14) == 3796160890) strcat(s, "a");
if (crc32("ulViT",5) == 1390200905) strcat(s, "g");
if (crc32("tINxSOwYZe",10) == 892972681) strcat(s, "t");
if (crc32("QeJEfnEcg",9) == 1195133067) strcat(s, "c");
if (crc32("MfPypguBvENJQs",14) == 3902213547) strcat(s, "e");
    return s;
}

char *forget_verbs() {
    char *s = calloc(7);
    if (crc32("uIfRMoSmZPBAi",13) == 2155654186) strcat(s, "x");
if (crc32("ybicZQqArcm",11) == 412457795) strcat(s, "f");
if (crc32("VncsROcTo",9) == 3710382828) strcat(s, "o");
if (crc32("ZmMEqL",6) == 3774577126) strcat(s, "D");
if (crc32("VQYTVVrIcAoZK",13) == 1820571355) strcat(s, "r");
if (crc32("zQzlM",5) == 1295900032) strcat(s, "m");
if (crc32("LNVeW",5) == 2774426860) strcat(s, "g");
if (crc32("RQuXiQuXnke",11) == 1488586917) strcat(s, "g");
if (crc32("pVrVknr",7) == 3343938966) strcat(s, "e");
if (crc32("jDbaH",5) == 1973969945) strcat(s, "E");
if (crc32("wXowiyrVHB",10) == 3437054659) strcat(s, "t");
    return s;
}

char *disvalued_verbs() {
    char *s = calloc(10);
    if (crc32("CZIRhnMagWkOfj",14) == 2922073212) strcat(s, "l");
if (crc32("gdSfCiguVjmKO",13) == 23713562) strcat(s, "d");
if (crc32("kiFmlH",6) == 154012929) strcat(s, "f");
if (crc32("XcieIXWDERLadER",15) == 3985863960) strcat(s, "i");
if (crc32("aKrpNKvtyd",10) == 814384722) strcat(s, "s");
if (crc32("XCKzPoH",7) == 509278676) strcat(s, "U");
if (crc32("NBZCmrarNsc",11) == 1457149798) strcat(s, "v");
if (crc32("KCPLKVeB",8) == 1372053993) strcat(s, "a");
if (crc32("kGglKltBVdkW",12) == 215324369) strcat(s, "l");
if (crc32("xJLvbElpljUuCT",14) == 352988557) strcat(s, "G");
if (crc32("DpNDE",5) == 3905500892) strcat(s, "u");
if (crc32("miWprp",6) == 2122075760) strcat(s, "M");
if (crc32("BQGMyUtaIREAuLU",15) == 1012772725) strcat(s, "e");
if (crc32("HjvJzVPSZUMd",12) == 2823110333) strcat(s, "U");
if (crc32("HEoMRRYscPYygq",14) == 1688671733) strcat(s, "d");
    return s;
}

char *emboss_verbs() {
    char *s = calloc(7);
    if (crc32("kITcOpEoSFv",11) == 814722950) strcat(s, "e");
if (crc32("LzCfuZ",6) == 1736391923) strcat(s, "X");
if (crc32("naBYR",5) == 4273479996) strcat(s, "m");
if (crc32("dfNmFVygpWuImKK",15) == 243279939) strcat(s, "b");
if (crc32("ibHsgwthHzQrtQ",14) == 3625502396) strcat(s, "o");
if (crc32("FlUjXvutNrm",11) == 2876213719) strcat(s, "s");
if (crc32("TmXeAf",6) == 1248447505) strcat(s, "s");
    return s;
}

char *preoccupy_verbs() {
    char *s = calloc(10);
    if (crc32("eyrIZ",5) == 2092372142) strcat(s, "p");
if (crc32("VecFLtHpffCIGFN",15) == 2790068846) strcat(s, "A");
if (crc32("dXHsWA",6) == 3606213803) strcat(s, "r");
if (crc32("UKRiAcoSvQaOTp",14) == 568039911) strcat(s, "u");
if (crc32("xUGaxeNcnLsTeU",14) == 48474260) strcat(s, "e");
if (crc32("xsEYa",5) == 1368894361) strcat(s, "o");
if (crc32("bNATSpOKixE",11) == 3526761343) strcat(s, "c");
if (crc32("RiSVEIyw",8) == 2992331446) strcat(s, "c");
if (crc32("HxIBuFFCO",9) == 2845343154) strcat(s, "u");
if (crc32("kvscDdhlcWBr",12) == 444464118) strcat(s, "p");
if (crc32("rtWzaDubYc",10) == 1831428569) strcat(s, "y");
    return s;
}

char *interstratifying_verbs() {
    char *s = calloc(17);
    if (crc32("WgYBODQRxNQ",11) == 3606643270) strcat(s, "i");
if (crc32("ZsYjHJvbkoEygxb",15) == 1124654696) strcat(s, "f");
if (crc32("DTCDDM",6) == 2329077041) strcat(s, "n");
if (crc32("NOHaJF",6) == 4137359783) strcat(s, "C");
if (crc32("VHBpEmyaIy",10) == 3698159915) strcat(s, "t");
if (crc32("SDlwT",5) == 3763521012) strcat(s, "e");
if (crc32("BiOwLTWtAzgDG",13) == 4183056484) strcat(s, "r");
if (crc32("JDEFnabNWpa",11) == 1336355350) strcat(s, "s");
if (crc32("gFHgW",5) == 4067802862) strcat(s, "t");
if (crc32("lotfrikUJum",11) == 4020063860) strcat(s, "b");
if (crc32("VsfaWtSMk",9) == 1903370848) strcat(s, "r");
if (crc32("NgcsxbbFaO",10) == 3206407775) strcat(s, "L");
if (crc32("FPJgFpdjOWBKkqk",15) == 788075132) strcat(s, "a");
if (crc32("iJzxuJgX",8) == 1191622521) strcat(s, "t");
if (crc32("ZDtKrZhT",8) == 2546783314) strcat(s, "m");
if (crc32("VReaWanKec",10) == 1613772196) strcat(s, "i");
if (crc32("VbbfMiLHi",9) == 604534331) strcat(s, "f");
if (crc32("leGZvtGrWpnz",12) == 1187409593) strcat(s, "y");
if (crc32("UwSfMHDZmUu",11) == 2162310315) strcat(s, "O");
if (crc32("oKdBrUv",7) == 4051540416) strcat(s, "i");
if (crc32("WJPxumJ",7) == 1017100839) strcat(s, "N");
if (crc32("axGXadUxI",9) == 559026745) strcat(s, "n");
if (crc32("smpQBfZoQo",10) == 2558464450) strcat(s, "g");
if (crc32("oMdwDg",6) == 1245372591) strcat(s, "g");
    return s;
}

char *renovated_verbs() {
    char *s = calloc(10);
    if (crc32("mzthsQuKWOZka",13) == 1292416234) strcat(s, "D");
if (crc32("YCtVybH",7) == 875925233) strcat(s, "r");
if (crc32("VxWSFZB",7) == 1426316811) strcat(s, "q");
if (crc32("lAokdaQPdQoK",12) == 3814807399) strcat(s, "e");
if (crc32("jXedmjfe",8) == 3960048975) strcat(s, "t");
if (crc32("FVVakyCgWof",11) == 3472895635) strcat(s, "n");
if (crc32("vlpPsuYhO",9) == 7245899) strcat(s, "X");
if (crc32("fhYJAvznJRlDwxT",15) == 594700280) strcat(s, "o");
if (crc32("JmQSwcnJngPvzu",14) == 2341842488) strcat(s, "o");
if (crc32("LTJdphcMzGX",11) == 620365517) strcat(s, "v");
if (crc32("VyIKAgGoJ",9) == 2021884926) strcat(s, "M");
if (crc32("IIIXscQhzzc",11) == 2698192142) strcat(s, "a");
if (crc32("Jelprunciaqh",12) == 2101687866) strcat(s, "t");
if (crc32("jIuEsvHez",9) == 149202652) strcat(s, "m");
if (crc32("fphuH",5) == 3622046693) strcat(s, "e");
if (crc32("TodZOfyl",8) == 736401077) strcat(s, "Q");
if (crc32("UIhAygWHkjY",11) == 1945668224) strcat(s, "d");
    return s;
}

char *rosed_verbs() {
    char *s = calloc(6);
    if (crc32("LNfPhvpS",8) == 2586417109) strcat(s, "r");
if (crc32("pxYHl",5) == 2394055392) strcat(s, "o");
if (crc32("koyvExtmWoYfPK",14) == 1523118597) strcat(s, "a");
if (crc32("zfRfZpWxnJdrW",13) == 2345093725) strcat(s, "s");
if (crc32("xytVvhdVI",9) == 4171385491) strcat(s, "e");
if (crc32("ZpYVwoKLWEu",11) == 2075833764) strcat(s, "X");
if (crc32("HrXSgAafKdYc",12) == 1533654046) strcat(s, "d");
    return s;
}

char *terminate_verbs() {
    char *s = calloc(10);
    if (crc32("cVjRZDPSOVc",11) == 705220015) strcat(s, "e");
if (crc32("VWIZqpzS",8) == 3928834116) strcat(s, "t");
if (crc32("AiEtOmIgMVWdI",13) == 2035667999) strcat(s, "i");
if (crc32("NdqCpedyi",9) == 390880870) strcat(s, "e");
if (crc32("GKfuGg",6) == 2888162674) strcat(s, "r");
if (crc32("WYlLNDdRXQ",10) == 1326387634) strcat(s, "m");
if (crc32("fYBoIYXatXcfo",13) == 3422373970) strcat(s, "h");
if (crc32("ffElbUfzLN",10) == 36555098) strcat(s, "i");
if (crc32("XyJpRSgvDxcXbf",14) == 2585508302) strcat(s, "n");
if (crc32("japKY",5) == 3475607128) strcat(s, "T");
if (crc32("FNMRhqWNXCQNO",13) == 1530358212) strcat(s, "a");
if (crc32("yMfoPTcIelgXY",13) == 1749747876) strcat(s, "w");
if (crc32("piRtdcBWzUhcx",13) == 1535400571) strcat(s, "t");
if (crc32("kVfNtsMlCKIF",12) == 692315797) strcat(s, "e");
    return s;
}

char *creasing_verbs() {
    char *s = calloc(9);
    if (crc32("vZgzSeQWUOc",11) == 2772330161) strcat(s, "C");
if (crc32("ZDlyaoXCQ",9) == 2920927949) strcat(s, "c");
if (crc32("wBksLqtyPkV",11) == 2616909729) strcat(s, "M");
if (crc32("lzGPYvsiAxoHZRq",15) == 1686154506) strcat(s, "r");
if (crc32("OkWSJHeCoXbzcbV",15) == 1479863058) strcat(s, "e");
if (crc32("MjcplmYQnd",10) == 1031494548) strcat(s, "u");
if (crc32("rejGa",5) == 2298840441) strcat(s, "a");
if (crc32("nKAmNPVaB",9) == 2666105799) strcat(s, "f");
if (crc32("UZJqDMQs",8) == 2477320493) strcat(s, "s");
if (crc32("UypVI",5) == 3679177257) strcat(s, "D");
if (crc32("EWYPfjEybMa",11) == 4019949471) strcat(s, "i");
if (crc32("RbRVlHM",7) == 2281675164) strcat(s, "u");
if (crc32("bkzbG",5) == 803378082) strcat(s, "n");
if (crc32("sMYTbMZmmciT",12) == 2133018829) strcat(s, "g");
    return s;
}

char *misinferred_verbs() {
    char *s = calloc(12);
    if (crc32("CwthGqpKSTEdVt",14) == 2286547149) strcat(s, "m");
if (crc32("GZoabLJUJauP",12) == 1697056759) strcat(s, "z");
if (crc32("BWJIlrPvY",9) == 456679336) strcat(s, "i");
if (crc32("vyGwGGMKdq",10) == 3645707382) strcat(s, "i");
if (crc32("AVgTRGcKWnJtx",13) == 3964568603) strcat(s, "s");
if (crc32("JyMcMP",6) == 2685789238) strcat(s, "r");
if (crc32("OAwjLWlQDPPjTt",14) == 2136974303) strcat(s, "i");
if (crc32("dbjoBGAoPC",10) == 3905434660) strcat(s, "n");
if (crc32("BTjUHFDpo",9) == 3889790134) strcat(s, "f");
if (crc32("MUzocBojhgXzN",13) == 2651051733) strcat(s, "e");
if (crc32("gvqfl",5) == 2213985104) strcat(s, "b");
if (crc32("oqUyyOsStGwrEI",14) == 792792143) strcat(s, "r");
if (crc32("OqLhBpGl",8) == 1098812179) strcat(s, "P");
if (crc32("eZlKiSKKBNp",11) == 2423373326) strcat(s, "r");
if (crc32("OsQrqHlx",8) == 2061978543) strcat(s, "d");
if (crc32("aiKEZByi",8) == 2415720135) strcat(s, "e");
if (crc32("qxcFXvfdkPMW",12) == 2628052665) strcat(s, "d");
    return s;
}

char *descend_verbs() {
    char *s = calloc(8);
    if (crc32("YvylZdqEKeLjHi",14) == 3568036656) strcat(s, "d");
if (crc32("oachIbMGwKLppKu",15) == 1993143929) strcat(s, "f");
if (crc32("JoRDoKkmZzukyX",14) == 1542789694) strcat(s, "e");
if (crc32("bRSKdy",6) == 2411054899) strcat(s, "u");
if (crc32("PmhdVXvdKJNYVx",14) == 3292500252) strcat(s, "s");
if (crc32("YBweB",5) == 3552460563) strcat(s, "n");
if (crc32("EZKWBCpS",8) == 4073363194) strcat(s, "c");
if (crc32("YmwrxDg",7) == 1805370075) strcat(s, "y");
if (crc32("FwRzOrfziaY",11) == 4023726175) strcat(s, "e");
if (crc32("vKebksRkQeKh",12) == 3145498604) strcat(s, "O");
if (crc32("wPrRKWhHqczcAA",14) == 66426239) strcat(s, "n");
if (crc32("RjboEtOPrJ",10) == 253404674) strcat(s, "d");
    return s;
}

char *rebellow_verbs() {
    char *s = calloc(9);
    if (crc32("LXsTdBOlXjMH",12) == 3989919531) strcat(s, "r");
if (crc32("teCHDyNwKm",10) == 2967103323) strcat(s, "e");
if (crc32("trGWKXlwHDmk",12) == 3527945342) strcat(s, "i");
if (crc32("TWvUv",5) == 1941815543) strcat(s, "b");
if (crc32("EzvJV",5) == 2320574320) strcat(s, "e");
if (crc32("wwVIcFgogZ",10) == 1017922640) strcat(s, "l");
if (crc32("CApAkXRKzOySnPs",15) == 19428431) strcat(s, "t");
if (crc32("FgQdsQx",7) == 3048760802) strcat(s, "l");
if (crc32("ZWRkrdqh",8) == 3316048163) strcat(s, "x");
if (crc32("TQjbdDkAAiduIL",14) == 769373161) strcat(s, "o");
if (crc32("OkhcSv",6) == 1037905741) strcat(s, "w");
    return s;
}

char *refried_verbs() {
    char *s = calloc(8);
    if (crc32("AmcaLjGrJjK",11) == 600254747) strcat(s, "r");
if (crc32("sgbMdVwbDZ",10) == 695021079) strcat(s, "G");
if (crc32("gZhJeDMatlMbFx",14) == 747569166) strcat(s, "e");
if (crc32("gSruauRgDwLDB",13) == 2929494646) strcat(s, "T");
if (crc32("xjFnTIEgvWzM",12) == 1653556280) strcat(s, "f");
if (crc32("uPNmCzYpfoZWz",13) == 36036704) strcat(s, "r");
if (crc32("kFfTDDC",7) == 2111410974) strcat(s, "g");
if (crc32("QrNpFLHalZcCxp",14) == 199574782) strcat(s, "i");
if (crc32("QAaSuVTdqj",10) == 2572552122) strcat(s, "F");
if (crc32("wzfZsATfpIm",11) == 981051327) strcat(s, "e");
if (crc32("xkCNne",6) == 2371022004) strcat(s, "d");
    return s;
}

char *displeasuring_verbs() {
    char *s = calloc(14);
    if (crc32("fxKQPWeb",8) == 3573898444) strcat(s, "d");
if (crc32("pztGmbA",7) == 509788513) strcat(s, "s");
if (crc32("GEfiN",5) == 3912945824) strcat(s, "i");
if (crc32("heZPJXUTcL",10) == 3489730435) strcat(s, "s");
if (crc32("FRRKAyZeMMsAX",13) == 1883824980) strcat(s, "r");
if (crc32("ZdedtkFtldP",11) == 151168636) strcat(s, "p");
if (crc32("dHarmNEMtOnOOVE",15) == 3641107390) strcat(s, "l");
if (crc32("suWduBE",7) == 3015165974) strcat(s, "e");
if (crc32("mcRPZzKTuW",10) == 3208604438) strcat(s, "G");
if (crc32("dbsCJ",5) == 542473049) strcat(s, "a");
if (crc32("XkjbFkESpU",10) == 193993546) strcat(s, "s");
if (crc32("CrWfRtsfuZzLY",13) == 3207744721) strcat(s, "u");
if (crc32("AvMzwRzQJ",9) == 595553483) strcat(s, "x");
if (crc32("ThJQhnsLUtZ",11) == 4235057278) strcat(s, "r");
if (crc32("AoBVkQ",6) == 398818930) strcat(s, "X");
if (crc32("xRJxQseFNJBarco",15) == 4283002231) strcat(s, "i");
if (crc32("DQjyJQhXwFykPp",14) == 4194796023) strcat(s, "y");
if (crc32("QyvNjzbad",9) == 549423824) strcat(s, "n");
if (crc32("YNbwzjKVvkHLo",13) == 3322285293) strcat(s, "F");
if (crc32("QhKnTqQDlrbJEoP",15) == 1073257094) strcat(s, "g");
    return s;
}

char *forego_verbs() {
    char *s = calloc(7);
    if (crc32("wbsxTvKXCpP",11) == 1051543465) strcat(s, "L");
if (crc32("PkLgDum",7) == 4053796584) strcat(s, "f");
if (crc32("NRAhMr",6) == 1492374156) strcat(s, "o");
if (crc32("hCLJOYZHFGr",11) == 3951730074) strcat(s, "W");
if (crc32("cPoDkahEwT",10) == 1348288113) strcat(s, "r");
if (crc32("ImGLjA",6) == 2034481726) strcat(s, "a");
if (crc32("MmUOvJjnzLQsQE",14) == 313298910) strcat(s, "e");
if (crc32("BlshuSrYucw",11) == 347418468) strcat(s, "X");
if (crc32("jctTfp",6) == 712346808) strcat(s, "g");
if (crc32("lVKttS",6) == 3749443557) strcat(s, "o");
    return s;
}

char *tittletattled_verbs() {
    char *s = calloc(14);
    if (crc32("RnvHZ",5) == 3161096835) strcat(s, "t");
if (crc32("ytbyFOPMUxKbBGt",15) == 4139098681) strcat(s, "P");
if (crc32("FRmRzaQX",8) == 1134835854) strcat(s, "i");
if (crc32("oxQvEBtxoBfu",12) == 1492544224) strcat(s, "t");
if (crc32("eRRPZrAOzoywSAV",15) == 3742396109) strcat(s, "f");
if (crc32("vDUtUSjkUZdhF",13) == 1473570933) strcat(s, "t");
if (crc32("MeVvEAAJYqwW",12) == 2021844070) strcat(s, "y");
if (crc32("RBSPiR",6) == 1458138556) strcat(s, "l");
if (crc32("rwNwx",5) == 1251168163) strcat(s, "u");
if (crc32("ftoNUapgu",9) == 2223891620) strcat(s, "e");
if (crc32("CmQaNitnKbO",11) == 2891756512) strcat(s, "v");
if (crc32("WNKiRmdMmNbZ",12) == 2160835164) strcat(s, "t");
if (crc32("tmQWhEQ",7) == 3039733272) strcat(s, "a");
if (crc32("EpxtpJSDF",9) == 4181963830) strcat(s, "t");
if (crc32("pgQYSozdFT",10) == 302094864) strcat(s, "t");
if (crc32("oEKnwqFpEoJHly",14) == 4072939389) strcat(s, "K");
if (crc32("ESNBS",5) == 3315600747) strcat(s, "l");
if (crc32("UoGZJs",6) == 1385272464) strcat(s, "e");
if (crc32("uIzpvMDgfuCfM",13) == 3059850550) strcat(s, "R");
if (crc32("sAGYbBSSjoeWPAn",15) == 2169593472) strcat(s, "d");
    return s;
}

char *filed_verbs() {
    char *s = calloc(6);
    if (crc32("UdneAmzMTXWqn",13) == 3001724236) strcat(s, "R");
if (crc32("kkVLQ",5) == 3967218218) strcat(s, "f");
if (crc32("ayXkEDqIMwvE",12) == 974110558) strcat(s, "i");
if (crc32("EyQPSSYZiePDc",13) == 704107470) strcat(s, "l");
if (crc32("dJSVQbvrFUR",11) == 2683575805) strcat(s, "A");
if (crc32("codIJCchnAH",11) == 798737934) strcat(s, "e");
if (crc32("wMLTt",5) == 345051891) strcat(s, "d");
    return s;
}

char *tabbing_verbs() {
    char *s = calloc(8);
    if (crc32("InlKNEtDfhIAoF",14) == 53023911) strcat(s, "t");
if (crc32("DUzWNtqaQhiTm",13) == 1997736951) strcat(s, "a");
if (crc32("LrnYEa",6) == 1164289946) strcat(s, "b");
if (crc32("vrLvLRgca",9) == 2063357135) strcat(s, "i");
if (crc32("vgnDHZGVakTYOOB",15) == 2525176053) strcat(s, "b");
if (crc32("YuJZRdJMDjcv",12) == 4216078476) strcat(s, "i");
if (crc32("GEeglCjeHszO",12) == 4262841788) strcat(s, "T");
if (crc32("WmACpi",6) == 2345567963) strcat(s, "n");
if (crc32("GSYwXa",6) == 1933612547) strcat(s, "g");
    return s;
}

char *misconstrue_verbs() {
    char *s = calloc(12);
    if (crc32("LYnsxuSBGYmwBH",14) == 3224918181) strcat(s, "m");
if (crc32("EvKvoAXSglszhaE",15) == 2219140227) strcat(s, "Z");
if (crc32("XFXEzCR",7) == 4155079746) strcat(s, "i");
if (crc32("UMtmxGNiCyZiqdV",15) == 178548065) strcat(s, "s");
if (crc32("pDLRnuIcBZdkue",14) == 94941744) strcat(s, "c");
if (crc32("XaFHYkb",7) == 75174645) strcat(s, "e");
if (crc32("ILfOGhygckZafd",14) == 154183243) strcat(s, "o");
if (crc32("kbipEi",6) == 2612840562) strcat(s, "n");
if (crc32("avaTBrb",7) == 1077998165) strcat(s, "s");
if (crc32("yYitcZw",7) == 3632110272) strcat(s, "c");
if (crc32("BeHKTZgebdCOrq",14) == 343360357) strcat(s, "t");
if (crc32("BDsoBhJPikDP",12) == 3881538541) strcat(s, "r");
if (crc32("hqWRZEjvAaVbV",13) == 659073175) strcat(s, "u");
if (crc32("GLwzswIv",8) == 1521632572) strcat(s, "v");
if (crc32("wZbDd",5) == 3170440202) strcat(s, "e");
    return s;
}

char *addup_verbs() {
    char *s = calloc(6);
    if (crc32("xeUUYeaxHllYIs",14) == 4273653564) strcat(s, "B");
if (crc32("oyPQjAXiMXaQ",12) == 3300004713) strcat(s, "a");
if (crc32("anJrzLDBKbrSwj",14) == 189823451) strcat(s, "d");
if (crc32("AgnPDNhmAdPq",12) == 3651762012) strcat(s, "d");
if (crc32("WlvTSMC",7) == 1106379733) strcat(s, "K");
if (crc32("gFTLyen",7) == 4287449736) strcat(s, "u");
if (crc32("WDSbLKCoxP",10) == 3986846766) strcat(s, "p");
    return s;
}

char *jading_verbs() {
    char *s = calloc(7);
    if (crc32("GWeGnjDHO",9) == 319011698) strcat(s, "j");
if (crc32("vekQTH",6) == 2729070167) strcat(s, "q");
if (crc32("qVQEd",5) == 1180251290) strcat(s, "a");
if (crc32("kAhElTxXyYoHB",13) == 710103833) strcat(s, "d");
if (crc32("vcRFWGmT",8) == 3402898274) strcat(s, "e");
if (crc32("QZwfYeFRpYBKlli",15) == 2398596798) strcat(s, "i");
if (crc32("LxOoUgOYpcwU",12) == 1530173464) strcat(s, "V");
if (crc32("zZbObcAroGQRBhj",15) == 43643937) strcat(s, "n");
if (crc32("pXzwoRSSkJ",10) == 3559220766) strcat(s, "g");
    return s;
}

char *flyblowing_verbs() {
    char *s = calloc(11);
    if (crc32("zNyGSDuxFCMpPU",14) == 1618158815) strcat(s, "a");
if (crc32("uPbGllc",7) == 2528987809) strcat(s, "f");
if (crc32("bIgmohvW",8) == 452535393) strcat(s, "s");
if (crc32("OmIIKhmqXcN",11) == 3814477013) strcat(s, "l");
if (crc32("LOWqKaDM",8) == 3843175788) strcat(s, "y");
if (crc32("tciRYg",6) == 1851437912) strcat(s, "b");
if (crc32("ykMvJ",5) == 2769134021) strcat(s, "j");
if (crc32("YcqYAjRVBq",10) == 3995863772) strcat(s, "l");
if (crc32("qXPvzKAshaiWERX",15) == 3800468558) strcat(s, "i");
if (crc32("YVawDgjzD",9) == 2062813402) strcat(s, "o");
if (crc32("VyvcTv",6) == 4238544535) strcat(s, "w");
if (crc32("gtkeWXAPNK",10) == 4042878263) strcat(s, "i");
if (crc32("MWoFg",5) == 1911668952) strcat(s, "F");
if (crc32("BHVllX",6) == 2558690843) strcat(s, "n");
if (crc32("OmWQihtzWUGRy",13) == 3340147973) strcat(s, "g");
    return s;
}

char *preconsult_verbs() {
    char *s = calloc(11);
    if (crc32("OujRrgan",8) == 2586960696) strcat(s, "p");
if (crc32("HSYZeYJKNtjD",12) == 1739420129) strcat(s, "r");
if (crc32("vdKqPnXiUrWUeG",14) == 3583453296) strcat(s, "e");
if (crc32("eEajkKmHevQrx",13) == 1903425288) strcat(s, "c");
if (crc32("kahdGiVTdwiNVV",14) == 1296648852) strcat(s, "o");
if (crc32("lTGfqe",6) == 2007023857) strcat(s, "u");
if (crc32("JIrQVgLrluv",11) == 3644100904) strcat(s, "n");
if (crc32("nnpcpavMBSwQoG",14) == 3511613721) strcat(s, "s");
if (crc32("PyhqgyHZnc",10) == 3362466440) strcat(s, "r");
if (crc32("wCrezJEaa",9) == 2178819171) strcat(s, "u");
if (crc32("yqOlUIUZVyCshz",14) == 1779910975) strcat(s, "f");
if (crc32("ycvGVvtvem",10) == 1413936910) strcat(s, "l");
if (crc32("TIJaXSGcL",9) == 1224909062) strcat(s, "t");
    return s;
}

char *syllabled_verbs() {
    char *s = calloc(10);
    if (crc32("QqRscsZwHwO",11) == 4268796733) strcat(s, "s");
if (crc32("ndJTSEaYGrzTRGj",15) == 320916857) strcat(s, "A");
if (crc32("ExZyYE",6) == 3047849577) strcat(s, "y");
if (crc32("FmhFHCzoz",9) == 2345063981) strcat(s, "l");
if (crc32("pvnDxTOd",8) == 3986682224) strcat(s, "B");
if (crc32("YGMbYm",6) == 180820115) strcat(s, "l");
if (crc32("ATUtURpOD",9) == 1232011116) strcat(s, "o");
if (crc32("fNAxtdKgRkAqSjn",15) == 1425920060) strcat(s, "a");
if (crc32("sHErXjoetPh",11) == 1696034283) strcat(s, "C");
if (crc32("yTzpQaovG",9) == 2095116027) strcat(s, "b");
if (crc32("taxYUuPvTwPSHPI",15) == 3787725978) strcat(s, "l");
if (crc32("YcxyZdpTjRNaOE",14) == 3877594957) strcat(s, "O");
if (crc32("eJZpy",5) == 76852337) strcat(s, "e");
if (crc32("jhFKcwzPtnHpP",13) == 1385181974) strcat(s, "b");
if (crc32("fFekVS",6) == 3995416929) strcat(s, "d");
    return s;
}

char *untie_verbs() {
    char *s = calloc(6);
    if (crc32("yhnGsS",6) == 1827794984) strcat(s, "u");
if (crc32("TKKYPosPNUr",11) == 1773709147) strcat(s, "s");
if (crc32("pVpwntyNryWn",12) == 2119252972) strcat(s, "n");
if (crc32("PWkqMFWLf",9) == 226823732) strcat(s, "t");
if (crc32("jLMkuYrW",8) == 2165100419) strcat(s, "u");
if (crc32("jOTTndCNzi",10) == 1858445503) strcat(s, "i");
if (crc32("IlJrrarXKpH",11) == 3063101030) strcat(s, "e");
    return s;
}

char *quickfreeze_verbs() {
    char *s = calloc(12);
    if (crc32("xPSIYIotHZ",10) == 1658086363) strcat(s, "W");
if (crc32("aykUWgnbMdC",11) == 3789097720) strcat(s, "q");
if (crc32("kzxuZknmLr",10) == 1411583620) strcat(s, "u");
if (crc32("wJElJXhsVZcoBU",14) == 4083950997) strcat(s, "j");
if (crc32("locVvjrkVDX",11) == 930391691) strcat(s, "i");
if (crc32("QeCxIesC",8) == 646559964) strcat(s, "c");
if (crc32("MkKaKttzZSeGq",13) == 2405259269) strcat(s, "d");
if (crc32("wJaZavJbij",10) == 887054333) strcat(s, "k");
if (crc32("bNWsW",5) == 62150869) strcat(s, "D");
if (crc32("gPwAacsBMJkgpo",14) == 784143557) strcat(s, "f");
if (crc32("reWwwfgDiy",10) == 930295567) strcat(s, "j");
if (crc32("lCVhi",5) == 3795513555) strcat(s, "r");
if (crc32("YnObU",5) == 534035508) strcat(s, "e");
if (crc32("GxtlgaV",7) == 895837715) strcat(s, "e");
if (crc32("pUpCMzETPZrr",12) == 646089098) strcat(s, "z");
if (crc32("mWzOx",5) == 3084190126) strcat(s, "E");
if (crc32("YmiDJRGZK",9) == 1580803815) strcat(s, "e");
    return s;
}

char *lopping_verbs() {
    char *s = calloc(8);
    if (crc32("XZJLLEC",7) == 4170787740) strcat(s, "l");
if (crc32("IHwKCdhQg",9) == 3540338383) strcat(s, "d");
if (crc32("HOGke",5) == 2748452864) strcat(s, "o");
if (crc32("tEAUPS",6) == 2959390548) strcat(s, "p");
if (crc32("rKiOSKsyESYn",12) == 1081211895) strcat(s, "J");
if (crc32("nPDzTlESCI",10) == 1719685896) strcat(s, "p");
if (crc32("FcHfFFrphRYpa",13) == 1907130647) strcat(s, "i");
if (crc32("MVwfYeyP",8) == 2888309633) strcat(s, "p");
if (crc32("uIIGeYGzpT",10) == 1191400333) strcat(s, "n");
if (crc32("XTtnuNu",7) == 3511532019) strcat(s, "g");
    return s;
}

char *redivided_verbs() {
    char *s = calloc(10);
    if (crc32("oUbclps",7) == 1574619082) strcat(s, "d");
if (crc32("mmbuyevKstLa",12) == 3985429029) strcat(s, "r");
if (crc32("yTSxPRYXa",9) == 1339498774) strcat(s, "T");
if (crc32("ZynmOsSqwbGNlc",14) == 3758963536) strcat(s, "e");
if (crc32("qDufq",5) == 2653761461) strcat(s, "o");
if (crc32("IAJWBuHurFOPDA",14) == 445728066) strcat(s, "d");
if (crc32("ZoCtrqCBps",10) == 3681164983) strcat(s, "N");
if (crc32("xsuhJf",6) == 1554193860) strcat(s, "i");
if (crc32("lnaHRQTZF",9) == 3536402620) strcat(s, "v");
if (crc32("sOnCkMzMm",9) == 1747378287) strcat(s, "R");
if (crc32("KYKgppKyu",9) == 2481592966) strcat(s, "i");
if (crc32("mBpAMPBQo",9) == 1848402951) strcat(s, "d");
if (crc32("chAYlLi",7) == 963436113) strcat(s, "e");
if (crc32("IrKRaxONkxl",11) == 4081219685) strcat(s, "d");
    return s;
}

char *treeing_verbs() {
    char *s = calloc(8);
    if (crc32("FxJBQyV",7) == 1558839026) strcat(s, "c");
if (crc32("ELNcoJc",7) == 2687756802) strcat(s, "t");
if (crc32("dkHluJeTQQomvV",14) == 3483030905) strcat(s, "r");
if (crc32("lOGkAyDexeISK",13) == 1381673867) strcat(s, "A");
if (crc32("qHdkm",5) == 2799993541) strcat(s, "e");
if (crc32("XFGeXjx",7) == 287250332) strcat(s, "e");
if (crc32("ZmArfGeuhCb",11) == 2961340408) strcat(s, "G");
if (crc32("PxmPNlcxQQVFu",13) == 1382604469) strcat(s, "i");
if (crc32("UovPydtRMqFwp",13) == 2073073855) strcat(s, "Y");
if (crc32("vCAaH",5) == 1286103314) strcat(s, "n");
if (crc32("neZOhkEtfW",10) == 2133514590) strcat(s, "g");
    return s;
}

char *scaling_verbs() {
    char *s = calloc(8);
    if (crc32("anxftNbYBR",10) == 2536445200) strcat(s, "J");
if (crc32("AAUYOo",6) == 621268031) strcat(s, "s");
if (crc32("QPTFCdLUrSeKl",13) == 3941079766) strcat(s, "j");
if (crc32("oSpWb",5) == 105845882) strcat(s, "c");
if (crc32("hkYkJ",5) == 4029330510) strcat(s, "a");
if (crc32("TKyMJnTnnPkR",12) == 4070585809) strcat(s, "l");
if (crc32("HaGRMrZNZftZF",13) == 2319269664) strcat(s, "i");
if (crc32("DcUwOVVeUT",10) == 2661517388) strcat(s, "O");
if (crc32("hOxbFakBtmC",11) == 1617351597) strcat(s, "n");
if (crc32("FxILURLvhWbNB",13) == 195627324) strcat(s, "C");
if (crc32("bjLsyQtbch",10) == 3616467436) strcat(s, "g");
    return s;
}

char *diseasing_verbs() {
    char *s = calloc(10);
    if (crc32("bFjAyBitcVVcEKC",15) == 2831157648) strcat(s, "d");
if (crc32("MxojIGJQJUN",11) == 301077713) strcat(s, "a");
if (crc32("qfGLJPvGZHohGVJ",15) == 1250809255) strcat(s, "i");
if (crc32("uLeGNLSpsO",10) == 1306170636) strcat(s, "L");
if (crc32("scWBkBuTcO",10) == 3364500244) strcat(s, "s");
if (crc32("AXAaxMPU",8) == 2643522576) strcat(s, "y");
if (crc32("zCDDeDNnLHjOBk",14) == 3356876948) strcat(s, "e");
if (crc32("tsAibgDVR",9) == 4278858970) strcat(s, "a");
if (crc32("PLKDPWsus",9) == 4145049683) strcat(s, "k");
if (crc32("fZAPDLtRNFd",11) == 3530549447) strcat(s, "s");
if (crc32("GFWxqWolxYqR",12) == 609540729) strcat(s, "j");
if (crc32("bYERIVQJ",8) == 3882046097) strcat(s, "i");
if (crc32("qyOZhmN",7) == 2193529683) strcat(s, "n");
if (crc32("wZfaUQ",6) == 1564160325) strcat(s, "z");
if (crc32("psHatEtBS",9) == 1131718060) strcat(s, "g");
    return s;
}

char *alter_verbs() {
    char *s = calloc(6);
    if (crc32("IjLVqwjh",8) == 2232993972) strcat(s, "S");
if (crc32("gbIGB",5) == 616443129) strcat(s, "a");
if (crc32("sigdoogEGBPIwMJ",15) == 2671872562) strcat(s, "l");
if (crc32("XfRwLqgvskr",11) == 3340036546) strcat(s, "t");
if (crc32("kueLENpAdNMhnwq",15) == 553067961) strcat(s, "e");
if (crc32("DgOsOUFRpHcR",12) == 453224082) strcat(s, "h");
if (crc32("hgLABLeH",8) == 488906672) strcat(s, "r");
    return s;
}

char *crystalling_verbs() {
    char *s = calloc(12);
    if (crc32("tHciyNVNThFL",12) == 3151979210) strcat(s, "c");
if (crc32("HHOkMPLzDZgcyTw",15) == 407161552) strcat(s, "g");
if (crc32("LoxSWUlqVmZ",11) == 21437467) strcat(s, "r");
if (crc32("gsQNnxU",7) == 3948902300) strcat(s, "D");
if (crc32("FwFIQFNcL",9) == 304781762) strcat(s, "y");
if (crc32("aiTaQckEFm",10) == 3352598058) strcat(s, "s");
if (crc32("PVvJOOBDreYKY",13) == 2946968658) strcat(s, "g");
if (crc32("CzYFVLpUcHt",11) == 3968002944) strcat(s, "t");
if (crc32("cQPGlodnVHCg",12) == 1233058646) strcat(s, "a");
if (crc32("MSIIfDnZLw",10) == 569392419) strcat(s, "a");
if (crc32("CEgbGWpiGNyK",12) == 3817291312) strcat(s, "l");
if (crc32("crKjxYaVX",9) == 4077291019) strcat(s, "x");
if (crc32("dRvsWoiwqXjHg",13) == 1767616295) strcat(s, "l");
if (crc32("xKPyDe",6) == 1310588074) strcat(s, "T");
if (crc32("kNYGua",6) == 2669657858) strcat(s, "i");
if (crc32("vTGdNUvsO",9) == 286313089) strcat(s, "a");
if (crc32("GCxJweTIgDH",11) == 3920375357) strcat(s, "n");
if (crc32("nMirwuAFU",9) == 1704520666) strcat(s, "D");
if (crc32("ySEXkvQnXWDG",12) == 1786635117) strcat(s, "g");
    return s;
}

char *transshipping_verbs() {
    char *s = calloc(14);
    if (crc32("zUaJqTgaZsezIt",14) == 1123581561) strcat(s, "f");
if (crc32("hUTElgaiSnAd",12) == 3725287098) strcat(s, "t");
if (crc32("YUTrsaROeLywI",13) == 873326708) strcat(s, "r");
if (crc32("IGerRq",6) == 2269428525) strcat(s, "a");
if (crc32("YNbaRaNBnmY",11) == 2806129718) strcat(s, "n");
if (crc32("bDUoQoxfBZZu",12) == 548836420) strcat(s, "s");
if (crc32("EuJlbFNeOA",10) == 2427029975) strcat(s, "x");
if (crc32("fppnCZUf",8) == 964252506) strcat(s, "s");
if (crc32("GCQntEljetgRKL",14) == 1653916108) strcat(s, "h");
if (crc32("WEaEyVTMTPkCWEn",15) == 1560277772) strcat(s, "e");
if (crc32("FyVDUBIQgNOXB",13) == 674664499) strcat(s, "i");
if (crc32("BTBcXumCQlBFMH",14) == 1610714290) strcat(s, "p");
if (crc32("LyMAhy",6) == 2705434154) strcat(s, "p");
if (crc32("NGtvWwWLKU",10) == 50806602) strcat(s, "i");
if (crc32("VBKqp",5) == 1518470762) strcat(s, "n");
if (crc32("oUmSulspg",9) == 2548715916) strcat(s, "H");
if (crc32("PGnffzj",7) == 2688992070) strcat(s, "g");
    return s;
}

char *pluralized_verbs() {
    char *s = calloc(11);
    if (crc32("GLurmPV",7) == 3612689732) strcat(s, "h");
if (crc32("JKDXNsSRX",9) == 2488600543) strcat(s, "p");
if (crc32("tForLGrLJ",9) == 2580552878) strcat(s, "l");
if (crc32("bpLCSghbw",9) == 881280592) strcat(s, "u");
if (crc32("LRjOStjrVFaW",12) == 1407951015) strcat(s, "r");
if (crc32("kvIbZLlFy",9) == 3936517677) strcat(s, "y");
if (crc32("RAxCObWIErzGH",13) == 1857328503) strcat(s, "a");
if (crc32("fTWqIClRyRFDWC",14) == 274446635) strcat(s, "l");
if (crc32("RbHEtLAbX",9) == 2808285564) strcat(s, "h");
if (crc32("dgpsQi",6) == 2750645454) strcat(s, "i");
if (crc32("XWbHuwdwC",9) == 3843371204) strcat(s, "R");
if (crc32("opVBA",5) == 500873630) strcat(s, "z");
if (crc32("ZybAkGVeB",9) == 1779374716) strcat(s, "e");
if (crc32("IIlTSQ",6) == 1539924253) strcat(s, "d");
    return s;
}

char *vitrioled_verbs() {
    char *s = calloc(10);
    if (crc32("PSJHBR",6) == 267740465) strcat(s, "v");
if (crc32("dKRSyixlCaxTkzi",15) == 3047023854) strcat(s, "Z");
if (crc32("krToygYqCqc",11) == 3598310605) strcat(s, "i");
if (crc32("bopiQDqPijHsv",13) == 1709624818) strcat(s, "t");
if (crc32("PqzaJcQG",8) == 2177954412) strcat(s, "r");
if (crc32("gJOWZBHFfyUEwrf",15) == 2194248830) strcat(s, "h");
if (crc32("BqfIDRVrXar",11) == 3265675672) strcat(s, "i");
if (crc32("rFznowSzCSmlrg",14) == 2628985247) strcat(s, "o");
if (crc32("DTNjeZvhekxkMtK",15) == 1930352068) strcat(s, "e");
if (crc32("sIZvcIASX",9) == 4275781841) strcat(s, "l");
if (crc32("gYFreyWnIZkY",12) == 2900758868) strcat(s, "e");
if (crc32("iWMdm",5) == 1309309167) strcat(s, "d");
    return s;
}

char *overhasten_verbs() {
    char *s = calloc(11);
    if (crc32("zlhhiwLcWImXjX",14) == 3327194821) strcat(s, "Q");
if (crc32("hZQbCkvkbr",10) == 3344676260) strcat(s, "o");
if (crc32("vAWueUk",7) == 1597184370) strcat(s, "Z");
if (crc32("AJkDmb",6) == 2413721602) strcat(s, "v");
if (crc32("yIEziglPS",9) == 2506964865) strcat(s, "X");
if (crc32("YhDfUYnBEc",10) == 2626893122) strcat(s, "e");
if (crc32("qrFmmGnYwAkd",12) == 2922325438) strcat(s, "I");
if (crc32("XjSfXHuLZvNh",12) == 1612147670) strcat(s, "r");
if (crc32("BtfKtgUmEtJjqu",14) == 3753609692) strcat(s, "Z");
if (crc32("vUTMEenlBgLA",12) == 3509860046) strcat(s, "h");
if (crc32("EyJxkwRGnV",10) == 3836066999) strcat(s, "a");
if (crc32("KyxWipTHdv",10) == 2062726917) strcat(s, "u");
if (crc32("MGncJnlfR",9) == 2177924899) strcat(s, "s");
if (crc32("RvkOnSA",7) == 134843152) strcat(s, "l");
if (crc32("YgJmC",5) == 391878859) strcat(s, "t");
if (crc32("mLbYoOw",7) == 3130762723) strcat(s, "a");
if (crc32("mRWqaFRwuG",10) == 278543980) strcat(s, "e");
if (crc32("XaZjJyKR",8) == 2312534438) strcat(s, "n");
    return s;
}

char *caroled_verbs() {
    char *s = calloc(8);
    if (crc32("nuPRm",5) == 1431562081) strcat(s, "J");
if (crc32("biZKNDXQWRb",11) == 1688930808) strcat(s, "c");
if (crc32("vcDRePzHNdhNkjv",15) == 1939836198) strcat(s, "u");
if (crc32("SzasOHhbVbElP",13) == 223708417) strcat(s, "a");
if (crc32("tDxcbZaFje",10) == 528221754) strcat(s, "c");
if (crc32("xNNJCGB",7) == 837140152) strcat(s, "r");
if (crc32("BDIWRVRszclesY",14) == 55963578) strcat(s, "l");
if (crc32("gvLiCEOZssplBdA",15) == 3610887248) strcat(s, "o");
if (crc32("SXrwJFsNSz",10) == 3827397621) strcat(s, "l");
if (crc32("MpmUHMmbv",9) == 3301373515) strcat(s, "w");
if (crc32("QrTaqdvipClHkpc",15) == 3792253185) strcat(s, "e");
if (crc32("IEZVmzY",7) == 4025044308) strcat(s, "y");
if (crc32("wGSxVkPdtCTGUMt",15) == 1165020481) strcat(s, "d");
    return s;
}

char *graced_verbs() {
    char *s = calloc(7);
    if (crc32("SJfJgv",6) == 4168558509) strcat(s, "c");
if (crc32("hvLofATQXepCQ",13) == 555287828) strcat(s, "g");
if (crc32("cAkJFnoTOhP",11) == 1107542193) strcat(s, "r");
if (crc32("JaouHNCVYu",10) == 954175285) strcat(s, "a");
if (crc32("tnEYydALjIB",11) == 2530467381) strcat(s, "c");
if (crc32("PKygfBXytb",10) == 3133121614) strcat(s, "e");
if (crc32("fgpSk",5) == 1772512349) strcat(s, "d");
    return s;
}

char *underbank_verbs() {
    char *s = calloc(10);
    if (crc32("QGvFZOIAfIO",11) == 1582002921) strcat(s, "o");
if (crc32("yKpDohm",7) == 2970349531) strcat(s, "u");
if (crc32("MGgPCHzcrFYqUM",14) == 3920961777) strcat(s, "n");
if (crc32("ArxjGZETdn",10) == 281958164) strcat(s, "d");
if (crc32("ZveHq",5) == 2875937371) strcat(s, "e");
if (crc32("tVYyZcSGQ",9) == 4293812771) strcat(s, "m");
if (crc32("fCDWBQEUjVsqF",13) == 982945687) strcat(s, "r");
if (crc32("aDFPhOZwm",9) == 663334391) strcat(s, "w");
if (crc32("bwSlb",5) == 3610705699) strcat(s, "b");
if (crc32("eGitlSxnt",9) == 318090384) strcat(s, "G");
if (crc32("JqLFQbuEnuY",11) == 3463392371) strcat(s, "a");
if (crc32("qJVyKSYNmiU",11) == 34336121) strcat(s, "n");
if (crc32("LuVsrUXaTOobLw",14) == 1071021272) strcat(s, "k");
    return s;
}

char *reviving_verbs() {
    char *s = calloc(9);
    if (crc32("GMrWVtlFfm",10) == 612095385) strcat(s, "u");
if (crc32("OSdDxsNzt",9) == 2670668862) strcat(s, "r");
if (crc32("pnDYbrX",7) == 1801847330) strcat(s, "e");
if (crc32("UbtusAvtQBlrk",13) == 16461650) strcat(s, "v");
if (crc32("XoXcI",5) == 1656440035) strcat(s, "B");
if (crc32("CvggUt",6) == 894550565) strcat(s, "i");
if (crc32("FgbKsBtz",8) == 1607062381) strcat(s, "v");
if (crc32("WkUhahzrAela",12) == 1829356691) strcat(s, "K");
if (crc32("dXUrNi",6) == 3690369084) strcat(s, "i");
if (crc32("rCHKbCXhOgcemQ",14) == 1807784923) strcat(s, "n");
if (crc32("SmMoiiFkii",10) == 2723264645) strcat(s, "d");
if (crc32("ppJXmwkz",8) == 764496023) strcat(s, "g");
    return s;
}

char *segregated_verbs() {
    char *s = calloc(11);
    if (crc32("hCxrxBBzVe",10) == 867410680) strcat(s, "i");
if (crc32("AiTRLvLOcIQEO",13) == 3199456954) strcat(s, "s");
if (crc32("McJSbJmRMEh",11) == 3980928236) strcat(s, "U");
if (crc32("zVdgypygFFjBmca",15) == 653149002) strcat(s, "e");
if (crc32("ZvHuOkZvIHIrgzq",15) == 2407297204) strcat(s, "g");
if (crc32("nitTfBauW",9) == 4211716473) strcat(s, "r");
if (crc32("RevchEHxRhUyIhL",15) == 792246877) strcat(s, "e");
if (crc32("wemSjyznID",10) == 4082372009) strcat(s, "g");
if (crc32("zrCbdYmpHByU",12) == 1944641951) strcat(s, "a");
if (crc32("OMHgbfSqqvn",11) == 1561828432) strcat(s, "R");
if (crc32("xRlPyK",6) == 383749640) strcat(s, "t");
if (crc32("oocIfVF",7) == 515566898) strcat(s, "e");
if (crc32("RTteAq",6) == 3271316287) strcat(s, "j");
if (crc32("XHsUAOvCmMb",11) == 3042608620) strcat(s, "d");
    return s;
}

char *dogmatized_verbs() {
    char *s = calloc(11);
    if (crc32("pnCEewPR",8) == 1773978322) strcat(s, "d");
if (crc32("vouhnYvjQcI",11) == 661905943) strcat(s, "v");
if (crc32("SraZByIGSSxqVfI",15) == 1168030133) strcat(s, "o");
if (crc32("nIIzqEap",8) == 2351293264) strcat(s, "c");
if (crc32("EZpZhJWFQQoVFIb",15) == 1812042438) strcat(s, "g");
if (crc32("kPLsaBXOUNcQhN",14) == 2686481828) strcat(s, "Y");
if (crc32("IvrVClwWT",9) == 4190525828) strcat(s, "m");
if (crc32("vKBSxokHWQD",11) == 486723147) strcat(s, "a");
if (crc32("YwxxMgNK",8) == 2202360405) strcat(s, "t");
if (crc32("WxJvC",5) == 153594617) strcat(s, "i");
if (crc32("dPkQHMQWmKXO",12) == 3621135684) strcat(s, "z");
if (crc32("NwVmlnsMLtgz",12) == 100030109) strcat(s, "e");
if (crc32("TnhppvZYoa",10) == 1242545062) strcat(s, "d");
    return s;
}

char *retear_verbs() {
    char *s = calloc(7);
    if (crc32("tixwYFatNF",10) == 2437006802) strcat(s, "E");
if (crc32("afcWibkAHliN",12) == 2998648684) strcat(s, "r");
if (crc32("DXZPrnIPeL",10) == 21241564) strcat(s, "j");
if (crc32("yLgbdmm",7) == 2327150519) strcat(s, "e");
if (crc32("ykHjslhFOVn",11) == 1797815803) strcat(s, "t");
if (crc32("cbtdBNh",7) == 2224411459) strcat(s, "e");
if (crc32("cgXjEeVI",8) == 1666720923) strcat(s, "y");
if (crc32("edBuzYaCB",9) == 601072397) strcat(s, "a");
if (crc32("gevRjOvN",8) == 1047922819) strcat(s, "r");
    return s;
}

char *overtrimming_verbs() {
    char *s = calloc(13);
    if (crc32("uxDhVqCR",8) == 332267330) strcat(s, "b");
if (crc32("ZzmqG",5) == 781231224) strcat(s, "o");
if (crc32("bccNPMrEZR",10) == 4123357976) strcat(s, "o");
if (crc32("vACchaY",7) == 3364204796) strcat(s, "v");
if (crc32("gXAprOGINaqTIXq",15) == 3445994652) strcat(s, "g");
if (crc32("JLzQsSg",7) == 3517547410) strcat(s, "e");
if (crc32("emmWJArStvY",11) == 3660419019) strcat(s, "r");
if (crc32("QHgRzl",6) == 1183768594) strcat(s, "t");
if (crc32("UebuqYfSeh",10) == 3068664724) strcat(s, "t");
if (crc32("qXbztMPqVST",11) == 1681781465) strcat(s, "r");
if (crc32("MDbuNA",6) == 3296699019) strcat(s, "l");
if (crc32("yOSJEnUSUCSa",12) == 573661391) strcat(s, "i");
if (crc32("xDkcoclo",8) == 736312428) strcat(s, "m");
if (crc32("qFHvIyMYauhxlTE",15) == 381905566) strcat(s, "A");
if (crc32("helgaVFumGiPJp",14) == 1763940516) strcat(s, "m");
if (crc32("fGoGCh",6) == 185679873) strcat(s, "i");
if (crc32("zNBIDvROtI",10) == 307250575) strcat(s, "n");
if (crc32("coTwWmGMiVIb",12) == 2736757756) strcat(s, "n");
if (crc32("loGbaWdbjdyUt",13) == 1776740275) strcat(s, "g");
    return s;
}

char *wot_verbs() {
    char *s = calloc(4);
    if (crc32("DJsQcxdO",8) == 2418625240) strcat(s, "x");
if (crc32("QqRhGGRjSpVg",12) == 1001629904) strcat(s, "w");
if (crc32("XLYlED",6) == 3679411097) strcat(s, "F");
if (crc32("EuEeWqpbgPWWEl",14) == 3985717913) strcat(s, "o");
if (crc32("bwuYFksiljks",12) == 1555155237) strcat(s, "u");
if (crc32("DAtbdnNvtwyoQX",14) == 1907274323) strcat(s, "t");
    return s;
}

char *doodled_verbs() {
    char *s = calloc(8);
    if (crc32("eiMJOrV",7) == 3675579207) strcat(s, "d");
if (crc32("FtBwvYYDXD",10) == 3928101505) strcat(s, "s");
if (crc32("VOEOV",5) == 834563389) strcat(s, "o");
if (crc32("iMrlsHjnNOcH",12) == 2006302531) strcat(s, "o");
if (crc32("LziyIUYKOhXwIUN",15) == 2310174658) strcat(s, "d");
if (crc32("qIgePQobLBc",11) == 2605607778) strcat(s, "a");
if (crc32("NlRXAeg",7) == 10611) strcat(s, "l");
if (crc32("ZwANuIu",7) == 1096339789) strcat(s, "e");
if (crc32("BwEarFos",8) == 1121648629) strcat(s, "d");
    return s;
}

char *operate_verbs() {
    char *s = calloc(8);
    if (crc32("ERlmc",5) == 1872386258) strcat(s, "c");
if (crc32("TIMFKgQg",8) == 1884503251) strcat(s, "o");
if (crc32("xCYIdoE",7) == 4292188404) strcat(s, "n");
if (crc32("JXsuVeyaOaCdT",13) == 2685956062) strcat(s, "p");
if (crc32("GMBmlDjffmrxB",13) == 3978174688) strcat(s, "d");
if (crc32("EnxQLHrHs",9) == 3393337694) strcat(s, "e");
if (crc32("TbAWPLT",7) == 1626685757) strcat(s, "r");
if (crc32("WzRoZQQLeFeogZF",15) == 3806545543) strcat(s, "i");
if (crc32("ObfSRrjUvtwvmv",14) == 3287287210) strcat(s, "a");
if (crc32("EMtyT",5) == 4266407706) strcat(s, "t");
if (crc32("ZuTOMDdd",8) == 126608524) strcat(s, "e");
    return s;
}

char *giveout_verbs() {
    char *s = calloc(8);
    if (crc32("oZcvOvoOlbxi",12) == 3372031485) strcat(s, "D");
if (crc32("AOjBQg",6) == 4170605013) strcat(s, "g");
if (crc32("uGIXiHWu",8) == 570892999) strcat(s, "Y");
if (crc32("nigWB",5) == 2260643890) strcat(s, "i");
if (crc32("zWQsMMrXGxKGv",13) == 1540671720) strcat(s, "v");
if (crc32("nWulEcrPF",9) == 2245975609) strcat(s, "c");
if (crc32("KvIjtf",6) == 3994120125) strcat(s, "e");
if (crc32("BdqOJAMVLBJ",11) == 1836481738) strcat(s, "o");
if (crc32("iSbDbNdFMwcf",12) == 3190138757) strcat(s, "R");
if (crc32("zsJJJTnDw",9) == 2717030402) strcat(s, "u");
if (crc32("YIvyIZLvtSKi",12) == 3262011806) strcat(s, "t");
    return s;
}

char *wrestle_verbs() {
    char *s = calloc(8);
    if (crc32("wnSJu",5) == 304806183) strcat(s, "w");
if (crc32("LUECD",5) == 2068212641) strcat(s, "r");
if (crc32("ZiSmSlNQijYGVC",14) == 610895802) strcat(s, "g");
if (crc32("TIjfp",5) == 3410983498) strcat(s, "e");
if (crc32("jCjuOlIA",8) == 59525497) strcat(s, "p");
if (crc32("vrajztsfvq",10) == 944999142) strcat(s, "s");
if (crc32("fiwlHDCqLwCK",12) == 2646484899) strcat(s, "r");
if (crc32("flRIeTVLZoUV",12) == 2199841667) strcat(s, "t");
if (crc32("KqSYucrlGaPH",12) == 2687601879) strcat(s, "M");
if (crc32("GNyKIvw",7) == 1493839543) strcat(s, "l");
if (crc32("DEzSLFxMytrUg",13) == 3414681214) strcat(s, "M");
if (crc32("HzrwYiHErD",10) == 926610214) strcat(s, "e");
    return s;
}

char *keepup_verbs() {
    char *s = calloc(7);
    if (crc32("HkLEpvQElXx",11) == 2181818062) strcat(s, "k");
if (crc32("AhzBjLJ",7) == 2521670189) strcat(s, "e");
if (crc32("VLBrlQMaEJ",10) == 3742209551) strcat(s, "K");
if (crc32("aYuvybQGlzBI",12) == 1072040152) strcat(s, "e");
if (crc32("qiWOjLGBriAv",12) == 2442810072) strcat(s, "p");
if (crc32("MoCypAIMdVNrept",15) == 3938367125) strcat(s, "t");
if (crc32("btFWLimpVdQ",11) == 3187143833) strcat(s, "u");
if (crc32("DGcidVkiFPvuyMy",15) == 3330257383) strcat(s, "p");
    return s;
}

char *slenderizing_verbs() {
    char *s = calloc(13);
    if (crc32("CZOTSAAtlOwPaiy",15) == 3408555177) strcat(s, "s");
if (crc32("fzeBzdNVqEHYNna",15) == 2494697014) strcat(s, "o");
if (crc32("qkCKmLD",7) == 2339691310) strcat(s, "l");
if (crc32("xjGsUrBQM",9) == 3910351435) strcat(s, "O");
if (crc32("CrqEYDDGcueWFIn",15) == 3849163043) strcat(s, "e");
if (crc32("IxtmhTrlIeiVeCl",15) == 1602708965) strcat(s, "n");
if (crc32("LKCxsADySa",10) == 3884306919) strcat(s, "X");
if (crc32("KguKLtUe",8) == 1395039580) strcat(s, "d");
if (crc32("ObdPsCQAPRIG",12) == 59744852) strcat(s, "e");
if (crc32("uHebWf",6) == 2486057432) strcat(s, "r");
if (crc32("STFGVE",6) == 3619053976) strcat(s, "i");
if (crc32("HmfxacNxAzLiOT",14) == 722746472) strcat(s, "z");
if (crc32("kVmDzF",6) == 2417105738) strcat(s, "i");
if (crc32("rWtLKHaFN",9) == 148047748) strcat(s, "n");
if (crc32("suMlWSSsJLrnz",13) == 4025450941) strcat(s, "g");
    return s;
}

char *intoned_verbs() {
    char *s = calloc(8);
    if (crc32("JJWWSMqUlMdhOz",14) == 727273748) strcat(s, "e");
if (crc32("yMqpHdD",7) == 4135505285) strcat(s, "i");
if (crc32("LBtTfB",6) == 3489021351) strcat(s, "n");
if (crc32("oKcmJKh",7) == 2745023146) strcat(s, "K");
if (crc32("OHesbnwBWJq",11) == 2267941014) strcat(s, "t");
if (crc32("AGuRPIFOUXePnOb",15) == 1023441280) strcat(s, "t");
if (crc32("faMCAICLaY",10) == 3163021902) strcat(s, "o");
if (crc32("Snwex",5) == 3442175293) strcat(s, "o");
if (crc32("plXqVaZJRP",10) == 664178775) strcat(s, "n");
if (crc32("lFBrSgefyef",11) == 3478677578) strcat(s, "R");
if (crc32("GjqsrFM",7) == 4054587176) strcat(s, "e");
if (crc32("yqhrWJXlm",9) == 2996046163) strcat(s, "G");
if (crc32("sJYmrDmPceCU",12) == 2170151714) strcat(s, "d");
    return s;
}

char *avenged_verbs() {
    char *s = calloc(8);
    if (crc32("qCnaPX",6) == 76220723) strcat(s, "J");
if (crc32("uxpCSUyy",8) == 781170361) strcat(s, "a");
if (crc32("UpZdpcuS",8) == 2176066692) strcat(s, "d");
if (crc32("OhrqXUuaDlHrc",13) == 3323879709) strcat(s, "v");
if (crc32("pmshcecwxuZFP",13) == 3459364504) strcat(s, "e");
if (crc32("IWorDBE",7) == 877322900) strcat(s, "n");
if (crc32("UEmDFWZWTy",10) == 3127376803) strcat(s, "g");
if (crc32("UeLsnFccERmOk",13) == 3747080620) strcat(s, "X");
if (crc32("jcYMKenIksOtj",13) == 824951757) strcat(s, "e");
if (crc32("xregQzqznKBThO",14) == 212898696) strcat(s, "d");
    return s;
}

char *smoked_verbs() {
    char *s = calloc(7);
    if (crc32("MxcCJpa",7) == 1618320907) strcat(s, "s");
if (crc32("yGJeyUHTgMwSFQf",15) == 3324357785) strcat(s, "m");
if (crc32("uTQYclUYNqwvbtA",15) == 1629152422) strcat(s, "o");
if (crc32("EzZJYH",6) == 2549484157) strcat(s, "o");
if (crc32("oxZhYUigIDHjLG",14) == 27199378) strcat(s, "k");
if (crc32("QcbpE",5) == 4220298580) strcat(s, "O");
if (crc32("PTzjmU",6) == 4199513792) strcat(s, "e");
if (crc32("OacNfGqjQwAwfd",14) == 1618600502) strcat(s, "d");
    return s;
}

char *scream_verbs() {
    char *s = calloc(7);
    if (crc32("wQmSOw",6) == 3164631747) strcat(s, "s");
if (crc32("mNbMMPWNec",10) == 1746540659) strcat(s, "h");
if (crc32("xCMcIgxcFrh",11) == 628490806) strcat(s, "c");
if (crc32("gdWSztXPhZlruDd",15) == 3746206071) strcat(s, "r");
if (crc32("JXiYvPtjIgPuer",14) == 3934824339) strcat(s, "l");
if (crc32("pZnevbdnZGRdQ",13) == 209019861) strcat(s, "e");
if (crc32("lXOrVSYmOQPuza",14) == 3429114134) strcat(s, "v");
if (crc32("jUMbW",5) == 871740544) strcat(s, "a");
if (crc32("DvIyTGUOuWRJz",13) == 805120099) strcat(s, "m");
    return s;
}

char *twiddled_verbs() {
    char *s = calloc(9);
    if (crc32("CDEnhOREkGks",12) == 1832520354) strcat(s, "t");
if (crc32("TqnWG",5) == 2268700773) strcat(s, "t");
if (crc32("ziXVsqV",7) == 4262572162) strcat(s, "w");
if (crc32("MFnZM",5) == 3255461523) strcat(s, "H");
if (crc32("rePrHDiXRXmBK",13) == 4133856378) strcat(s, "i");
if (crc32("kkzbBxFZJaCNrU",14) == 2080291760) strcat(s, "d");
if (crc32("mjoGG",5) == 3876639338) strcat(s, "d");
if (crc32("UsXOksrIU",9) == 522500620) strcat(s, "q");
if (crc32("okVFMz",6) == 3388232214) strcat(s, "l");
if (crc32("XBiuVgOwv",9) == 2995168000) strcat(s, "e");
if (crc32("keBzxo",6) == 3501413376) strcat(s, "d");
    return s;
}

char *overconsuming_verbs() {
    char *s = calloc(14);
    if (crc32("jIVvBlYO",8) == 816683101) strcat(s, "U");
if (crc32("PHqUDmosFfTMsJJ",15) == 2620270403) strcat(s, "o");
if (crc32("NbQaAnqjzjdxfjw",15) == 3128907382) strcat(s, "v");
if (crc32("pwFCprMbf",9) == 2912169072) strcat(s, "e");
if (crc32("IetAgC",6) == 2552971084) strcat(s, "r");
if (crc32("wbXbS",5) == 3690562089) strcat(s, "c");
if (crc32("JfJXGff",7) == 1575218594) strcat(s, "o");
if (crc32("ejMXKLdhAThI",12) == 4241714540) strcat(s, "n");
if (crc32("HZlYKYvQtvQUw",13) == 4215371282) strcat(s, "j");
if (crc32("LdJqRWbkNuopFzX",15) == 2322492639) strcat(s, "s");
if (crc32("MJUgJTBEKrvxD",13) == 702689371) strcat(s, "Y");
if (crc32("pUXJyHAtRMgw",12) == 1178572798) strcat(s, "u");
if (crc32("iWumlySvW",9) == 3781384151) strcat(s, "S");
if (crc32("EoylefWUtZ",10) == 1438746001) strcat(s, "m");
if (crc32("lIrVPslcnFQeP",13) == 2897206358) strcat(s, "B");
if (crc32("elHdBb",6) == 3316947931) strcat(s, "i");
if (crc32("yDmeYDXXFlEeg",13) == 896630650) strcat(s, "n");
if (crc32("bSTmWdRygCBGmJd",15) == 2627116429) strcat(s, "g");
    return s;
}

char *pullup_verbs() {
    char *s = calloc(7);
    if (crc32("FMJkLkIauqnczC",14) == 1314078058) strcat(s, "p");
if (crc32("uOhsk",5) == 2899433652) strcat(s, "u");
if (crc32("BhxpLB",6) == 1685386974) strcat(s, "l");
if (crc32("ftaTXUdQjL",10) == 1888191357) strcat(s, "l");
if (crc32("BYHsWeVad",9) == 2123705084) strcat(s, "u");
if (crc32("qCYhXjWrcwQoLY",14) == 286292866) strcat(s, "p");
    return s;
}

char *subdivide_verbs() {
    char *s = calloc(10);
    if (crc32("FGWmJssnFlzM",12) == 951860870) strcat(s, "J");
if (crc32("xsOmJZGaJt",10) == 464421431) strcat(s, "s");
if (crc32("aDVDWEYx",8) == 3889509318) strcat(s, "e");
if (crc32("KMSYWnzkuPcdD",13) == 1716918455) strcat(s, "u");
if (crc32("NxHpBDhnnip",11) == 1353228680) strcat(s, "b");
if (crc32("AqRzVycjKi",10) == 3623959763) strcat(s, "n");
if (crc32("fhZIPbeIC",9) == 1287825213) strcat(s, "d");
if (crc32("HjgWdoMjHVXvZCD",15) == 1359833244) strcat(s, "L");
if (crc32("vdgGCLlAEUZPlVY",15) == 2306252133) strcat(s, "i");
if (crc32("rqvgplvyNjVtj",13) == 3213478161) strcat(s, "q");
if (crc32("NNdPAiHl",8) == 4269647004) strcat(s, "v");
if (crc32("iRljB",5) == 3682359545) strcat(s, "m");
if (crc32("smfViqdEDb",10) == 464287560) strcat(s, "i");
if (crc32("slkqXz",6) == 454064539) strcat(s, "d");
if (crc32("JEdRI",5) == 2969090788) strcat(s, "e");
    return s;
}

char *gan_verbs() {
    char *s = calloc(4);
    if (crc32("oygMOQKfCOk",11) == 2550842118) strcat(s, "V");
if (crc32("OImBdfXLoJ",10) == 3761378195) strcat(s, "g");
if (crc32("OMEOgvQbmoYtdaY",15) == 3842915610) strcat(s, "J");
if (crc32("ScGYEWEToMh",11) == 3596634875) strcat(s, "a");
if (crc32("XAUpIMUBYXaKDiB",15) == 1159244100) strcat(s, "x");
if (crc32("uqVLfQGJvbZK",12) == 1129924463) strcat(s, "n");
    return s;
}

char *perambulate_verbs() {
    char *s = calloc(12);
    if (crc32("QcdqPLwudOzTwp",14) == 1385214521) strcat(s, "j");
if (crc32("vHooSUnYATxhjua",15) == 4254568155) strcat(s, "p");
if (crc32("kwqfkaASfIl",11) == 2640240326) strcat(s, "Q");
if (crc32("VySVAda",7) == 720216581) strcat(s, "e");
if (crc32("ZolvNWCMgbOpVxR",15) == 2168488849) strcat(s, "r");
if (crc32("RIxJyI",6) == 2171762481) strcat(s, "R");
if (crc32("zjOpz",5) == 3320984381) strcat(s, "a");
if (crc32("yglmwWCwl",9) == 1051924797) strcat(s, "O");
if (crc32("Ktyyiy",6) == 150911164) strcat(s, "m");
if (crc32("CxLheGtfYedy",12) == 1790683221) strcat(s, "Q");
if (crc32("rnWtHYxBjWqI",12) == 3401188538) strcat(s, "b");
if (crc32("xLKrCqi",7) == 614217321) strcat(s, "J");
if (crc32("gnoeD",5) == 477710854) strcat(s, "u");
if (crc32("NNArjGU",7) == 4191588839) strcat(s, "l");
if (crc32("NfxZNFqPzhvUhkj",15) == 330397986) strcat(s, "d");
if (crc32("HCQFnQmKxtTVtws",15) == 4292842758) strcat(s, "a");
if (crc32("dOFHBT",6) == 2528854148) strcat(s, "t");
if (crc32("odNPiW",6) == 1922422950) strcat(s, "e");
    return s;
}

char *carries_verbs() {
    char *s = calloc(8);
    if (crc32("CJjYoXVakEJmo",13) == 2530389594) strcat(s, "c");
if (crc32("dqqCEfap",8) == 1794496860) strcat(s, "q");
if (crc32("SCnemaMwe",9) == 1319649965) strcat(s, "a");
if (crc32("iMrGFIzKUN",10) == 746277520) strcat(s, "r");
if (crc32("EyZLIJarEXaXbeb",15) == 2431542020) strcat(s, "l");
if (crc32("OhWSP",5) == 1897758783) strcat(s, "r");
if (crc32("zliQNB",6) == 2596383601) strcat(s, "i");
if (crc32("ZemNWyJkDYKGxf",14) == 3325448170) strcat(s, "x");
if (crc32("NjOrxxlWxRpHqu",14) == 3791700214) strcat(s, "e");
if (crc32("aWRYZemlqnwAln",14) == 3667345532) strcat(s, "s");
    return s;
}

char *differenced_verbs() {
    char *s = calloc(12);
    if (crc32("tZkGWLWfFKV",11) == 2238451007) strcat(s, "a");
if (crc32("YPZamYg",7) == 775321204) strcat(s, "d");
if (crc32("HtYyiwoKtkVFt",13) == 807825917) strcat(s, "b");
if (crc32("YbJFxhIZVGw",11) == 3392367913) strcat(s, "i");
if (crc32("YDaOBtvTTFEcc",13) == 334155805) strcat(s, "f");
if (crc32("haCKdkmxsE",10) == 940681518) strcat(s, "i");
if (crc32("nJjZGkxZScAlyj",14) == 1986812535) strcat(s, "f");
if (crc32("rLtkirsflKnZh",13) == 2713569493) strcat(s, "T");
if (crc32("IgmwDUt",7) == 695452359) strcat(s, "e");
if (crc32("xbmEXmD",7) == 166861819) strcat(s, "r");
if (crc32("uuppwooeCKKvUvd",15) == 3600296838) strcat(s, "e");
if (crc32("tXlEegeFHsSH",12) == 4132621305) strcat(s, "d");
if (crc32("InzlMLGsBdsW",12) == 2638472195) strcat(s, "n");
if (crc32("ewRQboasGWb",11) == 2155441841) strcat(s, "c");
if (crc32("BsKIGyZ",7) == 2147800237) strcat(s, "J");
if (crc32("MPNJgZcx",8) == 78278560) strcat(s, "e");
if (crc32("AvCXq",5) == 3394886859) strcat(s, "d");
    return s;
}

char *unrealize_verbs() {
    char *s = calloc(10);
    if (crc32("ZLHYsd",6) == 4074034659) strcat(s, "u");
if (crc32("AKPLBfg",7) == 3155448473) strcat(s, "t");
if (crc32("oBhnZVypA",9) == 1842163672) strcat(s, "n");
if (crc32("UbCHDWZzrzCPQ",13) == 3211117759) strcat(s, "r");
if (crc32("iAYdlFSMQYqnjb",14) == 359099946) strcat(s, "e");
if (crc32("fSzmtdHYKcwd",12) == 3889637294) strcat(s, "P");
if (crc32("PgpyDom",7) == 3797436771) strcat(s, "a");
if (crc32("zbjSQVf",7) == 698620670) strcat(s, "e");
if (crc32("GRzkTDSdg",9) == 76190455) strcat(s, "l");
if (crc32("EcVZPNBZUh",10) == 3586506815) strcat(s, "i");
if (crc32("LDevOAenvLsA",12) == 3267168902) strcat(s, "z");
if (crc32("xNBaoxzGPMShL",13) == 2311669088) strcat(s, "d");
if (crc32("OHrhcsoDqNUaWX",14) == 1262405520) strcat(s, "e");
    return s;
}

char *precondense_verbs() {
    char *s = calloc(12);
    if (crc32("GewpOwHGdjaNT",13) == 782192927) strcat(s, "T");
if (crc32("pxpJrBedD",9) == 2810684807) strcat(s, "p");
if (crc32("wdumb",5) == 2523396754) strcat(s, "y");
if (crc32("bsmWmGdg",8) == 2062242693) strcat(s, "r");
if (crc32("egUJsuYAHpVU",12) == 2019166603) strcat(s, "U");
if (crc32("KoPep",5) == 2927081854) strcat(s, "e");
if (crc32("mTNibjR",7) == 1483892216) strcat(s, "w");
if (crc32("sPsnzj",6) == 1192485221) strcat(s, "c");
if (crc32("nuaKblVBB",9) == 2129157949) strcat(s, "o");
if (crc32("WuIqektrAzzzzSR",15) == 3497957827) strcat(s, "n");
if (crc32("JZjzmzV",7) == 1578907723) strcat(s, "R");
if (crc32("MNxicOQLIRsOADC",15) == 1692158442) strcat(s, "d");
if (crc32("TZFqZ",5) == 1470778802) strcat(s, "t");
if (crc32("uUqNIVAkmgCv",12) == 2077874100) strcat(s, "e");
if (crc32("GhXEoOeimYaGD",13) == 2991621407) strcat(s, "K");
if (crc32("BtVpAw",6) == 1653927486) strcat(s, "n");
if (crc32("ayQsN",5) == 2354005203) strcat(s, "s");
if (crc32("FsXIkVfILam",11) == 2332469144) strcat(s, "M");
if (crc32("LZBPw",5) == 4166340086) strcat(s, "e");
    return s;
}

char *backbiting_verbs() {
    char *s = calloc(11);
    if (crc32("CFSBPYtfRN",10) == 3151054968) strcat(s, "b");
if (crc32("WTqkK",5) == 1619676230) strcat(s, "h");
if (crc32("XhiIbSybpA",10) == 4190823854) strcat(s, "a");
if (crc32("PRKryIFkhehJAy",14) == 353384932) strcat(s, "Y");
if (crc32("oGrhACs",7) == 3964628562) strcat(s, "c");
if (crc32("oXbHwpJNPE",10) == 848520531) strcat(s, "k");
if (crc32("fDcABqbTVHjgQ",13) == 3751661006) strcat(s, "x");
if (crc32("ZQRGw",5) == 3646000947) strcat(s, "b");
if (crc32("DCWwjE",6) == 1475715102) strcat(s, "v");
if (crc32("kNJDVlbUhwom",12) == 3088515180) strcat(s, "i");
if (crc32("BZcwtDcXaa",10) == 24802778) strcat(s, "b");
if (crc32("kCKKA",5) == 3489186683) strcat(s, "t");
if (crc32("oGYJt",5) == 3610718933) strcat(s, "B");
if (crc32("jxVwDwX",7) == 1715335900) strcat(s, "i");
if (crc32("SowaE",5) == 1770922782) strcat(s, "U");
if (crc32("kGwbynKB",8) == 1140559465) strcat(s, "n");
if (crc32("ePLdphUzv",9) == 2311041957) strcat(s, "i");
if (crc32("yzecCGsmVHtyMx",14) == 2098133322) strcat(s, "g");
    return s;
}

char *swatted_verbs() {
    char *s = calloc(8);
    if (crc32("enHBzgzDpA",10) == 1563176387) strcat(s, "c");
if (crc32("TOsLqaYi",8) == 3543774445) strcat(s, "s");
if (crc32("LVfdo",5) == 3548573483) strcat(s, "G");
if (crc32("rqgvO",5) == 1143856287) strcat(s, "w");
if (crc32("NLTDxKuJtJJJW",13) == 2061336610) strcat(s, "J");
if (crc32("fYnhQxquIwShch",14) == 849880626) strcat(s, "a");
if (crc32("ZQwdPyLpLxhMRT",14) == 4294773155) strcat(s, "W");
if (crc32("xAFJirijK",9) == 2907916520) strcat(s, "t");
if (crc32("WRwmsr",6) == 326845823) strcat(s, "v");
if (crc32("gTmrBtGCeag",11) == 548871072) strcat(s, "t");
if (crc32("mclzeFrgriGBpE",14) == 149832105) strcat(s, "s");
if (crc32("chvCroUkXmB",11) == 4035279978) strcat(s, "e");
if (crc32("KWZEMzho",8) == 2964395759) strcat(s, "X");
if (crc32("kNZCryacetQYzWr",15) == 3835805120) strcat(s, "d");
    return s;
}

char *chiseled_verbs() {
    char *s = calloc(9);
    if (crc32("mOpYeLYbwuuUi",13) == 2453900297) strcat(s, "c");
if (crc32("BIzhiRFEYBBmmHS",15) == 995506150) strcat(s, "h");
if (crc32("NbEUiKePFfLpTP",14) == 1151709649) strcat(s, "Y");
if (crc32("LSAwcMm",7) == 1004735010) strcat(s, "i");
if (crc32("RaxCraVObhUfV",13) == 334973539) strcat(s, "L");
if (crc32("ZCqyedKri",9) == 1886102814) strcat(s, "s");
if (crc32("LMQNeE",6) == 2125600188) strcat(s, "e");
if (crc32("INUNSriTkoqoL",13) == 2213983267) strcat(s, "i");
if (crc32("eMFFPjppa",9) == 2437691023) strcat(s, "l");
if (crc32("qODqcUwp",8) == 2668634255) strcat(s, "R");
if (crc32("jPupzIQHoTv",11) == 1764387902) strcat(s, "e");
if (crc32("CRpTRud",7) == 1675342704) strcat(s, "d");
    return s;
}

char *made_verbs() {
    char *s = calloc(5);
    if (crc32("mJTHQDQNGwq",11) == 4058210890) strcat(s, "m");
if (crc32("gNAgEpqX",8) == 4018232149) strcat(s, "a");
if (crc32("FWtLRMTXQz",10) == 423204231) strcat(s, "d");
if (crc32("UysXDaT",7) == 387191330) strcat(s, "e");
    return s;
}

char *repeat_verbs() {
    char *s = calloc(7);
    if (crc32("DWJtNNZYthoxQF",14) == 2973353822) strcat(s, "r");
if (crc32("ZUnTUJVsgX",10) == 3730800286) strcat(s, "e");
if (crc32("zxZtQgixpBXgpz",14) == 3321327127) strcat(s, "l");
if (crc32("sHliMgleFO",10) == 3853257773) strcat(s, "p");
if (crc32("bYYsXK",6) == 2988669741) strcat(s, "e");
if (crc32("XvMPbDGvypol",12) == 3972119297) strcat(s, "a");
if (crc32("HIartIOJxkNsypA",15) == 2500045135) strcat(s, "n");
if (crc32("DTckpyBO",8) == 1809737655) strcat(s, "t");
    return s;
}

char *fellowshiped_verbs() {
    char *s = calloc(13);
    if (crc32("EuQFNE",6) == 2962168802) strcat(s, "f");
if (crc32("qeWfmlCW",8) == 2104840844) strcat(s, "e");
if (crc32("MahggPZ",7) == 3778718690) strcat(s, "a");
if (crc32("afPprrV",7) == 4116203700) strcat(s, "l");
if (crc32("OHGvcdRvdgKd",12) == 481381761) strcat(s, "l");
if (crc32("tjzSgjbkuLYCXur",15) == 2062414928) strcat(s, "o");
if (crc32("VZZcyyXcwddIsnA",15) == 2256789825) strcat(s, "J");
if (crc32("qBiLl",5) == 1816359681) strcat(s, "w");
if (crc32("FGatniVTeFDkQhC",15) == 1945058262) strcat(s, "l");
if (crc32("yjQrV",5) == 2483341814) strcat(s, "s");
if (crc32("usLFBYT",7) == 4187473770) strcat(s, "h");
if (crc32("cwIkdlh",7) == 1294880888) strcat(s, "i");
if (crc32("nNwNXfchA",9) == 1339825236) strcat(s, "h");
if (crc32("fkdvnXqva",9) == 3626743295) strcat(s, "p");
if (crc32("diEmrTmUHyUVMtP",15) == 2419641926) strcat(s, "e");
if (crc32("AkrcSZTK",8) == 2220650823) strcat(s, "u");
if (crc32("zZQqorJkec",10) == 816096176) strcat(s, "d");
    return s;
}

char *baaing_verbs() {
    char *s = calloc(7);
    if (crc32("gfrXyecIDCd",11) == 2616365554) strcat(s, "B");
if (crc32("pvcOgFDqSuqVPyt",15) == 2634819459) strcat(s, "b");
if (crc32("kEZpKYSfsYRZ",12) == 1353670618) strcat(s, "s");
if (crc32("BWNqwSWTdSuJi",13) == 3762122566) strcat(s, "a");
if (crc32("GjLUoNnt",8) == 1121961257) strcat(s, "t");
if (crc32("okngsZjhNt",10) == 1123555908) strcat(s, "a");
if (crc32("mHLejKPQXQU",11) == 116558629) strcat(s, "i");
if (crc32("HXdkbuWZLHViQkh",15) == 2729947523) strcat(s, "n");
if (crc32("dJJMkta",7) == 1678614017) strcat(s, "u");
if (crc32("yFCLQd",6) == 1392646752) strcat(s, "g");
    return s;
}

char *lapped_verbs() {
    char *s = calloc(7);
    if (crc32("wvvFtMAHbUy",11) == 504815888) strcat(s, "l");
if (crc32("deJhOvrjOvxiW",13) == 1679826223) strcat(s, "Q");
if (crc32("utgcR",5) == 2506127984) strcat(s, "a");
if (crc32("AjzLHz",6) == 2405138317) strcat(s, "P");
if (crc32("ueIBsvsxP",9) == 2099885690) strcat(s, "p");
if (crc32("JOHPrGfyCGRW",12) == 1060014156) strcat(s, "H");
if (crc32("fypGoFQD",8) == 786732430) strcat(s, "p");
if (crc32("PsCpzbUZli",10) == 4049577760) strcat(s, "e");
if (crc32("bMvPKAVyhw",10) == 2258674700) strcat(s, "d");
    return s;
}

char *overdriving_verbs() {
    char *s = calloc(12);
    if (crc32("egsFbYxmMq",10) == 355221014) strcat(s, "o");
if (crc32("ZNgAzJKaD",9) == 3631331687) strcat(s, "m");
if (crc32("ugrwIxAmb",9) == 303859663) strcat(s, "v");
if (crc32("CkXMWItYLj",10) == 3655180202) strcat(s, "e");
if (crc32("MlRFlVPEw",9) == 1121441846) strcat(s, "o");
if (crc32("faOZFBbqTgljVW",14) == 2221271785) strcat(s, "r");
if (crc32("AvnjkdEFbZCa",12) == 2874974578) strcat(s, "d");
if (crc32("WixaQNY",7) == 1573029103) strcat(s, "z");
if (crc32("QADLmQWkiHfwhQo",15) == 128490582) strcat(s, "r");
if (crc32("fFohqTMXhjkO",12) == 2456624655) strcat(s, "i");
if (crc32("igErKglQpxEl",12) == 2842934839) strcat(s, "v");
if (crc32("SBRRaX",6) == 243363332) strcat(s, "i");
if (crc32("XDhEJDxGJ",9) == 1930097162) strcat(s, "Z");
if (crc32("NeDyjJvEkBkUE",13) == 1863926090) strcat(s, "n");
if (crc32("IxTew",5) == 2148841543) strcat(s, "g");
    return s;
}

char *doublecheck_verbs() {
    char *s = calloc(12);
    if (crc32("dZUtRHaoeBSJoq",14) == 1072710868) strcat(s, "d");
if (crc32("LeEDFc",6) == 804019590) strcat(s, "Q");
if (crc32("aRNLBw",6) == 1054634821) strcat(s, "o");
if (crc32("OPBqU",5) == 2310505285) strcat(s, "u");
if (crc32("bdUFH",5) == 611254065) strcat(s, "h");
if (crc32("ijmeOs",6) == 1946600836) strcat(s, "b");
if (crc32("wqkgmYzjhyKRTCH",15) == 1615610991) strcat(s, "l");
if (crc32("oeSBHAKbEmZKtaq",15) == 3859426793) strcat(s, "e");
if (crc32("cFdWTEJs",8) == 4100929074) strcat(s, "c");
if (crc32("OzCpCZXBcXYEOLU",15) == 3648271068) strcat(s, "N");
if (crc32("QrKcOXRAWA",10) == 3081781352) strcat(s, "h");
if (crc32("SuUoPTbDe",9) == 1608898730) strcat(s, "j");
if (crc32("FJXFCbSHwHItN",13) == 2908280299) strcat(s, "e");
if (crc32("grErvNHqslqjqZ",14) == 1270877647) strcat(s, "c");
if (crc32("NDrpYIf",7) == 331067149) strcat(s, "k");
    return s;
}

char *dobin_verbs() {
    char *s = calloc(6);
    if (crc32("ZDhZHc",6) == 3255236062) strcat(s, "d");
if (crc32("hSUbcIPQObNsWl",14) == 2995211604) strcat(s, "f");
if (crc32("RezXej",6) == 1922488374) strcat(s, "o");
if (crc32("UAiucGWEBs",10) == 1272052414) strcat(s, "b");
if (crc32("niAxtgMNiSodmpc",15) == 4141578507) strcat(s, "i");
if (crc32("hzxnRSGWoeyPd",13) == 3049390939) strcat(s, "n");
    return s;
}

char *gabbling_verbs() {
    char *s = calloc(9);
    if (crc32("JuEIet",6) == 2991641489) strcat(s, "g");
if (crc32("HKSbpzKcxGFrQoV",15) == 1739524673) strcat(s, "a");
if (crc32("ZEsJGyPpAcWtiN",14) == 2148814624) strcat(s, "a");
if (crc32("wXFHnUoKMLn",11) == 529813612) strcat(s, "b");
if (crc32("sQInOoy",7) == 3109945503) strcat(s, "b");
if (crc32("mnIGWxKiDBNzMN",14) == 4032150336) strcat(s, "o");
if (crc32("wuRqnMOCn",9) == 2813054996) strcat(s, "l");
if (crc32("cxXyOh",6) == 2534521195) strcat(s, "i");
if (crc32("LlFSyAgVSDn",11) == 575320375) strcat(s, "n");
if (crc32("haJGwxHLoYFEEhR",15) == 3530966790) strcat(s, "g");
    return s;
}

char *weep_verbs() {
    char *s = calloc(5);
    if (crc32("GurOZJPbGsb",11) == 4166850298) strcat(s, "w");
if (crc32("pfWrhl",6) == 127511572) strcat(s, "G");
if (crc32("QonfYveTg",9) == 3078954985) strcat(s, "e");
if (crc32("XJHFeKgSMyktZzB",15) == 3062409994) strcat(s, "e");
if (crc32("DUAbndSm",8) == 2824656948) strcat(s, "p");
    return s;
}

char *freezedry_verbs() {
    char *s = calloc(10);
    if (crc32("KzbyiWrZ",8) == 1055914257) strcat(s, "z");
if (crc32("hfOMSRA",7) == 2951323898) strcat(s, "f");
if (crc32("qjAYrwmoRtAFQd",14) == 3147879939) strcat(s, "r");
if (crc32("dkSAEmlikfWHyb",14) == 3159691474) strcat(s, "r");
if (crc32("GAmkqIeURYy",11) == 1213604425) strcat(s, "V");
if (crc32("oFuRkNnKkuY",11) == 1152512997) strcat(s, "e");
if (crc32("mGylWYY",7) == 4032771570) strcat(s, "e");
if (crc32("QnKuXkwvDrT",11) == 577719920) strcat(s, "L");
if (crc32("PCPTA",5) == 3290433763) strcat(s, "z");
if (crc32("qvQHlOjfmTvZyXN",15) == 667893865) strcat(s, "R");
if (crc32("fOgSzmPCqoofE",13) == 2639160109) strcat(s, "e");
if (crc32("jUzhaCgkn",9) == 1193825911) strcat(s, "l");
if (crc32("sBAZelmPcKgSnBz",15) == 3650995669) strcat(s, "d");
if (crc32("VFZmKIQjIQYnWo",14) == 229170103) strcat(s, "r");
if (crc32("sRZOnyzeVCbRxt",14) == 90491900) strcat(s, "q");
if (crc32("NkjqTwkXvmh",11) == 2376703768) strcat(s, "y");
    return s;
}

char *playoff_verbs() {
    char *s = calloc(8);
    if (crc32("JcDspxajXbVSN",13) == 1454567964) strcat(s, "p");
if (crc32("WZXkMce",7) == 956654846) strcat(s, "l");
if (crc32("vEahZDUcUjhqGfG",15) == 4133640665) strcat(s, "s");
if (crc32("kguOJzSZocu",11) == 3711272645) strcat(s, "a");
if (crc32("QADVleRouqQwII",14) == 1988361879) strcat(s, "t");
if (crc32("FHPtyLqFKIdR",12) == 1283991927) strcat(s, "y");
if (crc32("rMasP",5) == 170008196) strcat(s, "o");
if (crc32("espAMasAVcMQ",12) == 427069583) strcat(s, "f");
if (crc32("ZYpVNRFeILrU",12) == 135681313) strcat(s, "Z");
if (crc32("McyyeWcBOHOPW",13) == 612557844) strcat(s, "f");
    return s;
}

char *rippled_verbs() {
    char *s = calloc(8);
    if (crc32("CbmXbx",6) == 2030722481) strcat(s, "r");
if (crc32("qbPrqs",6) == 2658527591) strcat(s, "w");
if (crc32("PeTTUvqibBXAqO",14) == 2022640349) strcat(s, "i");
if (crc32("fFUgBbDQOUpA",12) == 2226644951) strcat(s, "p");
if (crc32("sjcdOVvNjbTCIg",14) == 1382635851) strcat(s, "p");
if (crc32("xdvVDREeENupA",13) == 2841698264) strcat(s, "y");
if (crc32("enpxRVzVLuD",11) == 1675374943) strcat(s, "l");
if (crc32("LevnPONLmwv",11) == 3020869326) strcat(s, "e");
if (crc32("MRcVdGUssE",10) == 461212133) strcat(s, "d");
    return s;
}

char *fleeced_verbs() {
    char *s = calloc(8);
    if (crc32("KegtloyUPxJ",11) == 4102755070) strcat(s, "W");
if (crc32("yEkaDxwmk",9) == 3373845596) strcat(s, "f");
if (crc32("JKqoTwFMDnxNB",13) == 2563378645) strcat(s, "A");
if (crc32("WotOVVA",7) == 3365036666) strcat(s, "l");
if (crc32("yAXOhNrBApiFZE",14) == 718447271) strcat(s, "e");
if (crc32("vzOsmCEuhUiXVmM",15) == 335836121) strcat(s, "X");
if (crc32("ixkQp",5) == 1269584826) strcat(s, "e");
if (crc32("TaRanMls",8) == 1129411798) strcat(s, "D");
if (crc32("VLelMRgDQNqkrSC",15) == 2864950585) strcat(s, "c");
if (crc32("cWUhIZMOJvEE",12) == 225094771) strcat(s, "R");
if (crc32("kRQPqlvuz",9) == 2713097519) strcat(s, "e");
if (crc32("arCac",5) == 4209780200) strcat(s, "Y");
if (crc32("oFfcDJkLoup",11) == 712200872) strcat(s, "d");
    return s;
}

char *sublet_verbs() {
    char *s = calloc(7);
    if (crc32("iaTDf",5) == 229032788) strcat(s, "p");
if (crc32("jbPcXUFEyqsval",14) == 2264875799) strcat(s, "s");
if (crc32("AmjvGrw",7) == 2746116951) strcat(s, "O");
if (crc32("cUtGMZM",7) == 1100718249) strcat(s, "u");
if (crc32("JwntURQri",9) == 1304092446) strcat(s, "f");
if (crc32("qDhBtPHmfpbRFUl",15) == 4159638355) strcat(s, "b");
if (crc32("ZCdjPuvJyyV",11) == 3015858667) strcat(s, "n");
if (crc32("FjLQwbCzKp",10) == 610911737) strcat(s, "l");
if (crc32("jdySjWmXx",9) == 1642360994) strcat(s, "e");
if (crc32("duVVcLesizgqmiD",15) == 3144215201) strcat(s, "t");
    return s;
}

char *trapped_verbs() {
    char *s = calloc(8);
    if (crc32("XKXRv",5) == 3507501308) strcat(s, "t");
if (crc32("iZIkp",5) == 1610053880) strcat(s, "r");
if (crc32("RVGuCZZt",8) == 4009623162) strcat(s, "a");
if (crc32("iTycqkiVxSFBFob",15) == 178371715) strcat(s, "k");
if (crc32("vAfdnJzBryyZu",13) == 1451522351) strcat(s, "p");
if (crc32("CxDotRSEJqLgUg",14) == 1524971320) strcat(s, "x");
if (crc32("FoBpzwpVDRdbWH",14) == 1580592861) strcat(s, "p");
if (crc32("IMXMrI",6) == 1664585235) strcat(s, "I");
if (crc32("PdsoqqJqcMQL",12) == 4102587395) strcat(s, "e");
if (crc32("BjZFa",5) == 1295513976) strcat(s, "d");
    return s;
}

char *brigading_verbs() {
    char *s = calloc(10);
    if (crc32("iNkNVMmvOt",10) == 71523270) strcat(s, "Q");
if (crc32("PqKeXI",6) == 110467252) strcat(s, "b");
if (crc32("cGSTLuDwod",10) == 4159366900) strcat(s, "H");
if (crc32("AMCWrt",6) == 2140570917) strcat(s, "r");
if (crc32("BCJmI",5) == 3488542511) strcat(s, "i");
if (crc32("AmobUdchE",9) == 611722355) strcat(s, "S");
if (crc32("StKel",5) == 2106434941) strcat(s, "g");
if (crc32("JJRqC",5) == 2859715893) strcat(s, "u");
if (crc32("MBjdpNSVX",9) == 2071795637) strcat(s, "a");
if (crc32("MqIAbdf",7) == 1944348399) strcat(s, "J");
if (crc32("xWBfNRr",7) == 597448071) strcat(s, "d");
if (crc32("SurgzIYRLPQU",12) == 3248249322) strcat(s, "O");
if (crc32("eDogNIPIGO",10) == 2639026239) strcat(s, "i");
if (crc32("CtrTNwYYho",10) == 1917868813) strcat(s, "h");
if (crc32("dbUYlPWI",8) == 2740735158) strcat(s, "n");
if (crc32("sLLfcPzGDB",10) == 2615528380) strcat(s, "g");
    return s;
}

char *procuring_verbs() {
    char *s = calloc(10);
    if (crc32("afyCuqaLnrZNHz",14) == 390872916) strcat(s, "p");
if (crc32("tGMiXEBCRcm",11) == 1338720613) strcat(s, "k");
if (crc32("HspjZkKP",8) == 44999319) strcat(s, "r");
if (crc32("ElJKnENznJnYSAD",15) == 2650083669) strcat(s, "O");
if (crc32("eUhycDUJf",9) == 2006662690) strcat(s, "o");
if (crc32("fHYKcBZJz",9) == 3560467187) strcat(s, "c");
if (crc32("zHxFWdFkZRKWn",13) == 1494716917) strcat(s, "u");
if (crc32("COPLxTyNnbv",11) == 932587860) strcat(s, "G");
if (crc32("cfLFAJfXD",9) == 293263976) strcat(s, "r");
if (crc32("qwtSFlQvZkIcde",14) == 1270380527) strcat(s, "i");
if (crc32("CgqlZZawYZb",11) == 2399488076) strcat(s, "n");
if (crc32("QVAgxsCi",8) == 1153112424) strcat(s, "g");
    return s;
}

char *implant_verbs() {
    char *s = calloc(8);
    if (crc32("GEnoNm",6) == 2950043826) strcat(s, "e");
if (crc32("IfTzfSXJIyTGLGT",15) == 533634756) strcat(s, "i");
if (crc32("ESWIKZ",6) == 1989299088) strcat(s, "V");
if (crc32("vbYaKw",6) == 2914515004) strcat(s, "m");
if (crc32("HnRoB",5) == 1624754607) strcat(s, "p");
if (crc32("nyFUWEiRpYUrv",13) == 2326492820) strcat(s, "l");
if (crc32("HyNgoknWCEEHz",13) == 1878914876) strcat(s, "a");
if (crc32("NevVIjAxhNzG",12) == 3562526491) strcat(s, "n");
if (crc32("GOvUrJ",6) == 3592418318) strcat(s, "t");
    return s;
}

char *discipling_verbs() {
    char *s = calloc(11);
    if (crc32("bcpbBgCbMa",10) == 924665127) strcat(s, "d");
if (crc32("KrtiWxkvDvmwONG",15) == 241293843) strcat(s, "s");
if (crc32("vOByxvS",7) == 154894655) strcat(s, "i");
if (crc32("weMoxz",6) == 2348024774) strcat(s, "s");
if (crc32("UXdlmxgQhK",10) == 2548501444) strcat(s, "c");
if (crc32("zDfQFvj",7) == 2221626639) strcat(s, "i");
if (crc32("eOily",5) == 1941148527) strcat(s, "T");
if (crc32("PJwGXf",6) == 4202822125) strcat(s, "p");
if (crc32("AGhIBPki",8) == 1597715572) strcat(s, "l");
if (crc32("JIAEHiaL",8) == 1121052726) strcat(s, "i");
if (crc32("UJEFuoRIRSYuMr",14) == 1817852205) strcat(s, "C");
if (crc32("wQLjf",5) == 3156381921) strcat(s, "n");
if (crc32("gXSAZ",5) == 4021235018) strcat(s, "g");
    return s;
}

char *sway_verbs() {
    char *s = calloc(5);
    if (crc32("RVyLnjxsNtDm",12) == 904234797) strcat(s, "s");
if (crc32("AlVDbwTYQl",10) == 2552065320) strcat(s, "G");
if (crc32("ClOSOv",6) == 130423916) strcat(s, "w");
if (crc32("XyYTpPVp",8) == 162934400) strcat(s, "p");
if (crc32("BjRNAXih",8) == 831012690) strcat(s, "a");
if (crc32("wNMKz",5) == 663627049) strcat(s, "Z");
if (crc32("wVTzVQjYcYVNs",13) == 157983951) strcat(s, "y");
    return s;
}

char *denigrate_verbs() {
    char *s = calloc(10);
    if (crc32("uzePEI",6) == 40269527) strcat(s, "N");
if (crc32("bOSVXfUoXj",10) == 988642469) strcat(s, "d");
if (crc32("NwXmN",5) == 1287700658) strcat(s, "b");
if (crc32("vrJfFwcOMeLO",12) == 3208520846) strcat(s, "e");
if (crc32("uRWzBd",6) == 802353953) strcat(s, "n");
if (crc32("TraLKYtKLdOtmX",14) == 1518101741) strcat(s, "F");
if (crc32("nRJQmnNjVpau",12) == 3866934937) strcat(s, "i");
if (crc32("NMKWZ",5) == 1242857613) strcat(s, "g");
if (crc32("nREhcBLiNy",10) == 3566219690) strcat(s, "r");
if (crc32("FPBLWDIvtP",10) == 1677018144) strcat(s, "I");
if (crc32("fzkWXJ",6) == 3182592623) strcat(s, "a");
if (crc32("gfUYuuYBeC",10) == 215661332) strcat(s, "t");
if (crc32("VlVpZ",5) == 762276328) strcat(s, "M");
if (crc32("gFOzCusCb",9) == 1156489234) strcat(s, "e");
    return s;
}

char *precipitate_verbs() {
    char *s = calloc(12);
    if (crc32("zHYRlr",6) == 720211210) strcat(s, "Q");
if (crc32("WGaWv",5) == 1331378895) strcat(s, "p");
if (crc32("mayJlVMsGc",10) == 310352754) strcat(s, "Z");
if (crc32("sBJlUUI",7) == 3279161986) strcat(s, "r");
if (crc32("vrXGvCNgFFWsr",13) == 4232526983) strcat(s, "e");
if (crc32("FLUNOs",6) == 1235058375) strcat(s, "t");
if (crc32("QaooXeFdpmubVOy",15) == 1084939553) strcat(s, "c");
if (crc32("UOkTiIOmyaNE",12) == 1586164027) strcat(s, "D");
if (crc32("bLsHmxRu",8) == 2856232726) strcat(s, "i");
if (crc32("QpeTq",5) == 531063243) strcat(s, "p");
if (crc32("bdyMvyd",7) == 1577860164) strcat(s, "Z");
if (crc32("wuMiDztF",8) == 3288321625) strcat(s, "i");
if (crc32("dDCYWgz",7) == 748011572) strcat(s, "t");
if (crc32("eyhSDNPsaKWLr",13) == 1963832925) strcat(s, "V");
if (crc32("QfmbG",5) == 576732380) strcat(s, "a");
if (crc32("wiqFoKGllFM",11) == 4119275633) strcat(s, "t");
if (crc32("Xhkva",5) == 931202948) strcat(s, "e");
    return s;
}

char *overpitch_verbs() {
    char *s = calloc(10);
    if (crc32("yCOGNNkcONbki",13) == 972316151) strcat(s, "o");
if (crc32("FfSbsrKYFvyX",12) == 1084626035) strcat(s, "v");
if (crc32("YwkgCIwmm",9) == 1233919747) strcat(s, "e");
if (crc32("GGitVMcAZgde",12) == 3370631933) strcat(s, "r");
if (crc32("AwFmsKszQmwVEFP",15) == 1518684144) strcat(s, "p");
if (crc32("ajaywrwdHsV",11) == 1962649441) strcat(s, "y");
if (crc32("CdSeXm",6) == 2188995538) strcat(s, "i");
if (crc32("QmEvONxM",8) == 2675822527) strcat(s, "t");
if (crc32("vfZxUlo",7) == 1851997448) strcat(s, "t");
if (crc32("eminYJjuQYsV",12) == 4065281759) strcat(s, "f");
if (crc32("vpGDaQN",7) == 2625821960) strcat(s, "c");
if (crc32("zEOUiXJlC",9) == 1980533380) strcat(s, "Q");
if (crc32("ralefUNXQ",9) == 3466169385) strcat(s, "h");
    return s;
}

char *foresaw_verbs() {
    char *s = calloc(8);
    if (crc32("xvxuMGza",8) == 3585364591) strcat(s, "S");
if (crc32("yqtTlxQCkIw",11) == 128831582) strcat(s, "f");
if (crc32("rXJcXpy",7) == 226490497) strcat(s, "s");
if (crc32("gbkmGCP",7) == 1946533041) strcat(s, "o");
if (crc32("NAukmW",6) == 785149687) strcat(s, "G");
if (crc32("jUbbQrSgCRjBVKG",15) == 1691330957) strcat(s, "r");
if (crc32("IMPoXVuPAm",10) == 2752471049) strcat(s, "c");
if (crc32("YOTsu",5) == 2141076262) strcat(s, "e");
if (crc32("KquTUbQG",8) == 1581271991) strcat(s, "R");
if (crc32("rZUGZyySO",9) == 3612071170) strcat(s, "s");
if (crc32("UpvNIupe",8) == 150317881) strcat(s, "a");
if (crc32("dhFSt",5) == 3369922780) strcat(s, "F");
if (crc32("zRzyo",5) == 1859296170) strcat(s, "w");
    return s;
}

char *bivouacked_verbs() {
    char *s = calloc(11);
    if (crc32("RxTycyVrz",9) == 2476239458) strcat(s, "q");
if (crc32("BIJaxkJmZqQ",11) == 4247361604) strcat(s, "b");
if (crc32("QedMtCiuIFZbaw",14) == 2233655166) strcat(s, "i");
if (crc32("XekKuETSdPxEGM",14) == 4182848574) strcat(s, "v");
if (crc32("UtRKoqYw",8) == 640477728) strcat(s, "a");
if (crc32("QcpEQkSeT",9) == 2644222376) strcat(s, "o");
if (crc32("CacvNkR",7) == 1975033536) strcat(s, "O");
if (crc32("fubngG",6) == 1329582762) strcat(s, "u");
if (crc32("FvAoJmtkHgH",11) == 4133083848) strcat(s, "a");
if (crc32("sxYvOKaENVaF",12) == 4278748276) strcat(s, "y");
if (crc32("VtxeDtMSBshHo",13) == 235596961) strcat(s, "c");
if (crc32("rkJSjrIvoWq",11) == 2536744152) strcat(s, "k");
if (crc32("vgOGetos",8) == 3504482955) strcat(s, "q");
if (crc32("VKIME",5) == 21897298) strcat(s, "e");
if (crc32("aIorwTde",8) == 1445886429) strcat(s, "i");
if (crc32("PfCIPIB",7) == 1284380128) strcat(s, "d");
    return s;
}

char *cancelled_verbs() {
    char *s = calloc(10);
    if (crc32("oZZoFDihhkJ",11) == 4163076362) strcat(s, "c");
if (crc32("BaoSB",5) == 759484004) strcat(s, "c");
if (crc32("eTGTAuSJRJhpJqu",15) == 551086458) strcat(s, "a");
if (crc32("tHGEx",5) == 1255226631) strcat(s, "A");
if (crc32("nYKwglQlkXvf",12) == 365499305) strcat(s, "n");
if (crc32("xGaqOtQbvNYFdB",14) == 63418451) strcat(s, "x");
if (crc32("IZqRCksZaRvP",12) == 641456592) strcat(s, "c");
if (crc32("kfJqYaUaz",9) == 2050820059) strcat(s, "J");
if (crc32("sbnNVmNGgT",10) == 2934294450) strcat(s, "e");
if (crc32("HlBWqsREGFyKZS",14) == 984720314) strcat(s, "P");
if (crc32("ZJKzTJoXC",9) == 2996540542) strcat(s, "l");
if (crc32("oUJwguIWtcpJ",12) == 3829461150) strcat(s, "l");
if (crc32("ccHcfSAcLv",10) == 3227453476) strcat(s, "m");
if (crc32("iehoSwJZkVdY",12) == 393290094) strcat(s, "e");
if (crc32("DwvNzjhE",8) == 1430891590) strcat(s, "L");
if (crc32("soayhlzmabqLKpJ",15) == 3353750354) strcat(s, "d");
    return s;
}

char *joked_verbs() {
    char *s = calloc(6);
    if (crc32("dPkGksoxCQ",10) == 1730657423) strcat(s, "j");
if (crc32("YnNBf",5) == 876778423) strcat(s, "o");
if (crc32("WIuib",5) == 386191998) strcat(s, "D");
if (crc32("KvrksuVFcFnaB",13) == 1661246271) strcat(s, "k");
if (crc32("GUXpWzM",7) == 2542910783) strcat(s, "e");
if (crc32("FhCpUrQqPd",10) == 3579351382) strcat(s, "d");
    return s;
}

char *arose_verbs() {
    char *s = calloc(6);
    if (crc32("DtniUuo",7) == 948284743) strcat(s, "a");
if (crc32("fJWEU",5) == 3674598311) strcat(s, "r");
if (crc32("RoGUM",5) == 1572897690) strcat(s, "o");
if (crc32("mTQWlevTqxWdYCJ",15) == 1229399962) strcat(s, "s");
if (crc32("rjasEA",6) == 2102587052) strcat(s, "e");
    return s;
}

char *polymerizing_verbs() {
    char *s = calloc(13);
    if (crc32("HEqdPwHD",8) == 4127679221) strcat(s, "p");
if (crc32("LWSsRdTcNEZlz",13) == 428832623) strcat(s, "m");
if (crc32("ngcbyAUe",8) == 515601013) strcat(s, "o");
if (crc32("VIRcpgJbPCMNti",14) == 3477828318) strcat(s, "u");
if (crc32("JdntT",5) == 87627924) strcat(s, "l");
if (crc32("tcgJvF",6) == 1571778972) strcat(s, "Z");
if (crc32("hlSiepYRShMilBm",15) == 1134132639) strcat(s, "y");
if (crc32("sNbKZqU",7) == 2741101948) strcat(s, "W");
if (crc32("vynLUrbBf",9) == 1773406189) strcat(s, "m");
if (crc32("GFwPjxtMIkN",11) == 3768604827) strcat(s, "s");
if (crc32("mEsGyneEse",10) == 3114868391) strcat(s, "e");
if (crc32("NNSvxi",6) == 3177406520) strcat(s, "o");
if (crc32("NoQatQhJ",8) == 4114975864) strcat(s, "r");
if (crc32("jysKPBSxN",9) == 2910213308) strcat(s, "O");
if (crc32("MuBPwfTzzXkNxT",14) == 960810321) strcat(s, "i");
if (crc32("jRvDT",5) == 3704313046) strcat(s, "z");
if (crc32("aoLkbfrFh",9) == 180544239) strcat(s, "i");
if (crc32("GTnYJAfYI",9) == 1246725272) strcat(s, "m");
if (crc32("kTnflQBzla",10) == 704081362) strcat(s, "n");
if (crc32("NvuBJSC",7) == 1463997988) strcat(s, "g");
    return s;
}

char *enwind_verbs() {
    char *s = calloc(7);
    if (crc32("nsExy",5) == 566510606) strcat(s, "e");
if (crc32("LnvfCFGZAM",10) == 2842454278) strcat(s, "n");
if (crc32("eVBArwSxDgwWL",13) == 1838324225) strcat(s, "w");
if (crc32("KMyCSH",6) == 3129265559) strcat(s, "F");
if (crc32("HwppxcJYbrnZyE",14) == 3026416287) strcat(s, "i");
if (crc32("smbTpXNtkmhLR",13) == 1289001851) strcat(s, "n");
if (crc32("LOTeoTmOFoDKzFV",15) == 1043421125) strcat(s, "V");
if (crc32("vDxvaEwokbH",11) == 4205351966) strcat(s, "d");
    return s;
}

char *yclad_verbs() {
    char *s = calloc(6);
    if (crc32("rYBOitteS",9) == 2529211950) strcat(s, "y");
if (crc32("CnYmzzYEwmAITL",14) == 3599055343) strcat(s, "n");
if (crc32("VuiEvsGGsZAtyQL",15) == 3492374572) strcat(s, "c");
if (crc32("qfPnRwlfwm",10) == 1068769886) strcat(s, "l");
if (crc32("VtdEG",5) == 1167874402) strcat(s, "g");
if (crc32("uFEyauLBVoKYn",13) == 3716885470) strcat(s, "a");
if (crc32("DdldbAqWUS",10) == 580406077) strcat(s, "d");
    return s;
}

char *tattled_verbs() {
    char *s = calloc(8);
    if (crc32("itfJvaXlCxKoxP",14) == 3272743682) strcat(s, "t");
if (crc32("PnPlTc",6) == 3297473314) strcat(s, "w");
if (crc32("FMweq",5) == 383351433) strcat(s, "a");
if (crc32("FBupt",5) == 182561834) strcat(s, "t");
if (crc32("SbtPmNpiMoleAsl",15) == 4247948021) strcat(s, "l");
if (crc32("PBDuRvBMy",9) == 132095941) strcat(s, "t");
if (crc32("GRlsbMIeuZkQ",12) == 1949425467) strcat(s, "l");
if (crc32("InaeJyrrwltQDK",14) == 3883949001) strcat(s, "u");
if (crc32("HfMJxvvHkmkl",12) == 4277369757) strcat(s, "e");
if (crc32("AULNH",5) == 807380729) strcat(s, "d");
    return s;
}

char *asphyxiate_verbs() {
    char *s = calloc(11);
    if (crc32("NFapKKamiUwGEK",14) == 4155258312) strcat(s, "a");
if (crc32("YfVTzaSIk",9) == 1064450941) strcat(s, "p");
if (crc32("NuvVd",5) == 2336361194) strcat(s, "s");
if (crc32("BDlaDLzm",8) == 4003458328) strcat(s, "p");
if (crc32("DlfBowzrxYsWQyN",15) == 20614256) strcat(s, "h");
if (crc32("ZpuMumyoOOKcuil",15) == 4206055559) strcat(s, "e");
if (crc32("rRVcIliCfpU",11) == 3829851508) strcat(s, "y");
if (crc32("dIiyjLeYTdnlbAL",15) == 1691166815) strcat(s, "x");
if (crc32("ANmNs",5) == 1065595796) strcat(s, "i");
if (crc32("kqwxjpV",7) == 4154386405) strcat(s, "X");
if (crc32("zbWyhhnoiyYldlM",15) == 1534030857) strcat(s, "a");
if (crc32("DGPTZtaBOCShJJa",15) == 927207181) strcat(s, "t");
if (crc32("EroxlscU",8) == 1027524558) strcat(s, "e");
    return s;
}

char *alkalified_verbs() {
    char *s = calloc(11);
    if (crc32("aXCTxz",6) == 3475759925) strcat(s, "a");
if (crc32("YWmxdgYLXSuv",12) == 722468320) strcat(s, "z");
if (crc32("byDlEdCu",8) == 1580756455) strcat(s, "l");
if (crc32("wjzry",5) == 3036537807) strcat(s, "k");
if (crc32("ptNywOH",7) == 588149959) strcat(s, "H");
if (crc32("AJrOjT",6) == 778144936) strcat(s, "a");
if (crc32("nkQdCfwFcGxhHH",14) == 804605668) strcat(s, "l");
if (crc32("aiIReAIxBpzY",12) == 2427876498) strcat(s, "N");
if (crc32("zpWLn",5) == 2169166732) strcat(s, "i");
if (crc32("WQlpueeloS",10) == 2380212424) strcat(s, "a");
if (crc32("opCgePwLRNtTTI",14) == 386682614) strcat(s, "f");
if (crc32("crakw",5) == 1247398683) strcat(s, "k");
if (crc32("XlankEfJz",9) == 63704355) strcat(s, "i");
if (crc32("dDqcVLzOTvSjr",13) == 2208850701) strcat(s, "u");
if (crc32("hsiLECWhGX",10) == 785081278) strcat(s, "e");
if (crc32("WjkAzfS",7) == 4262978749) strcat(s, "P");
if (crc32("ayDDQRjhZWX",11) == 3334310550) strcat(s, "d");
    return s;
}

char *keepback_verbs() {
    char *s = calloc(9);
    if (crc32("LphqzapsnLkeuL",14) == 3937799529) strcat(s, "k");
if (crc32("tbUoUKVaCrzzhfQ",15) == 3883915580) strcat(s, "e");
if (crc32("MscldYGiAagAykM",15) == 3141574116) strcat(s, "t");
if (crc32("tEJXhXeXRzpLSCu",15) == 1351465853) strcat(s, "e");
if (crc32("jLwbbjVleWw",11) == 1561637955) strcat(s, "p");
if (crc32("UDhLMc",6) == 1452043404) strcat(s, "b");
if (crc32("KibWhGzF",8) == 2237580962) strcat(s, "D");
if (crc32("rdlnHhmIGGxPjy",14) == 1205047683) strcat(s, "a");
if (crc32("mVmzYSYxgVGtvA",14) == 913601356) strcat(s, "X");
if (crc32("DEDwYlZz",8) == 112288405) strcat(s, "c");
if (crc32("FiCkuripqqS",11) == 2683383952) strcat(s, "H");
if (crc32("WZGSHkWN",8) == 2922835863) strcat(s, "k");
    return s;
}

char *shorn_verbs() {
    char *s = calloc(6);
    if (crc32("WjmOT",5) == 1130524149) strcat(s, "s");
if (crc32("gDTRKv",6) == 695014531) strcat(s, "B");
if (crc32("vRASsEDVI",9) == 2619296308) strcat(s, "h");
if (crc32("iEWUKV",6) == 2734854471) strcat(s, "o");
if (crc32("avDUkIqaXPXSOB",14) == 2705806383) strcat(s, "r");
if (crc32("NssVeudxCxVTHFl",15) == 16018594) strcat(s, "n");
    return s;
}

char *concatenating_verbs() {
    char *s = calloc(14);
    if (crc32("qvlQwIiNGTf",11) == 1829044387) strcat(s, "c");
if (crc32("yTpziT",6) == 2249284790) strcat(s, "x");
if (crc32("FtHHLJUuYOUlo",13) == 4127795261) strcat(s, "o");
if (crc32("lzLpibaQBofvah",14) == 3535492375) strcat(s, "n");
if (crc32("zHGkqfpmV",9) == 1177999368) strcat(s, "c");
if (crc32("dysKUKF",7) == 3021521177) strcat(s, "t");
if (crc32("IlxPYwVDMSlCmG",14) == 4120479258) strcat(s, "a");
if (crc32("nyMWywQwHT",10) == 892866330) strcat(s, "t");
if (crc32("WeBXFwcOxn",10) == 1484696563) strcat(s, "e");
if (crc32("wTLDJXc",7) == 23903398) strcat(s, "o");
if (crc32("sYPnWvxFHJgR",12) == 1789534787) strcat(s, "n");
if (crc32("qAwBzMaRh",9) == 3612625836) strcat(s, "a");
if (crc32("YUufRFfWK",9) == 3787551417) strcat(s, "t");
if (crc32("JIYSKUnIwoDPp",13) == 1945713694) strcat(s, "i");
if (crc32("bgiAxmozhc",10) == 2592739964) strcat(s, "M");
if (crc32("ZVxWuxZArc",10) == 1529089996) strcat(s, "n");
if (crc32("vjozwQwfMJp",11) == 2632718111) strcat(s, "g");
    return s;
}

char *chapeling_verbs() {
    char *s = calloc(10);
    if (crc32("XWlDPlzNUKy",11) == 568061152) strcat(s, "c");
if (crc32("CwOieXgSxdmy",12) == 183915261) strcat(s, "U");
if (crc32("SLBYu",5) == 1348181891) strcat(s, "h");
if (crc32("QWCJDkux",8) == 577605618) strcat(s, "K");
if (crc32("npKCWNcOzPUgrt",14) == 3933026718) strcat(s, "a");
if (crc32("iScxFfJDW",9) == 1168526806) strcat(s, "p");
if (crc32("kALhUhRGqym",11) == 456518950) strcat(s, "e");
if (crc32("EzMgHgllRnWNK",13) == 3156572542) strcat(s, "l");
if (crc32("fdrnwEUeAyzkP",13) == 4171063578) strcat(s, "i");
if (crc32("tflmFrjV",8) == 1339722034) strcat(s, "n");
if (crc32("qLsCsgE",7) == 3800513868) strcat(s, "g");
    return s;
}

char *foretelling_verbs() {
    char *s = calloc(12);
    if (crc32("BnXHPvds",8) == 982576990) strcat(s, "x");
if (crc32("jTepeXFWJoNOaa",14) == 210382653) strcat(s, "f");
if (crc32("gWEGOc",6) == 1413864952) strcat(s, "o");
if (crc32("IdDnxD",6) == 894399677) strcat(s, "r");
if (crc32("lctrgQpCI",9) == 345754802) strcat(s, "W");
if (crc32("JxJxJBKSNXKk",12) == 2263832373) strcat(s, "e");
if (crc32("JrNWBZN",7) == 684329047) strcat(s, "t");
if (crc32("fGCrbCmqY",9) == 3622751792) strcat(s, "e");
if (crc32("YhgXKz",6) == 1409448526) strcat(s, "l");
if (crc32("yNnKYnGjDGcIr",13) == 3262986286) strcat(s, "l");
if (crc32("LeNfEdFEtyna",12) == 392988315) strcat(s, "g");
if (crc32("QvlvStvInDvc",12) == 3361507674) strcat(s, "i");
if (crc32("MOdpCBjoBH",10) == 535095738) strcat(s, "j");
if (crc32("jecHeNxhMxnt",12) == 2586787791) strcat(s, "n");
if (crc32("tLyzdahqEQdK",12) == 739813003) strcat(s, "b");
if (crc32("vTfNtxZlaN",10) == 1681728993) strcat(s, "g");
    return s;
}

char *smitten_verbs() {
    char *s = calloc(8);
    if (crc32("bwXbuq",6) == 3444736475) strcat(s, "p");
if (crc32("kLeWFuesTvzR",12) == 754285417) strcat(s, "s");
if (crc32("ulpLretrhxNrP",13) == 3966721674) strcat(s, "m");
if (crc32("dQDcjiysXnYzT",13) == 4095808262) strcat(s, "C");
if (crc32("hrStugoUzdEmlL",14) == 2099345514) strcat(s, "i");
if (crc32("BYiFN",5) == 576047271) strcat(s, "t");
if (crc32("fGNDKuWcPO",10) == 2726435070) strcat(s, "p");
if (crc32("TkjtwdEEobsDSE",14) == 1803890174) strcat(s, "t");
if (crc32("JttDbw",6) == 423047627) strcat(s, "e");
if (crc32("pWCahbQ",7) == 1925973951) strcat(s, "x");
if (crc32("QQXsAnDwrHDh",12) == 2408627502) strcat(s, "n");
    return s;
}

char *tared_verbs() {
    char *s = calloc(6);
    if (crc32("sqOPQRfPpbLRki",14) == 3253740759) strcat(s, "t");
if (crc32("gjltJBqdXx",10) == 3129906685) strcat(s, "a");
if (crc32("aeSsHLc",7) == 2228176641) strcat(s, "J");
if (crc32("cYssyZQpmRE",11) == 2027728640) strcat(s, "r");
if (crc32("jxEYA",5) == 1564036901) strcat(s, "l");
if (crc32("WxYshsGxCKKdl",13) == 2397253723) strcat(s, "e");
if (crc32("SwjocSyjxs",10) == 2515583273) strcat(s, "d");
    return s;
}

char *profaning_verbs() {
    char *s = calloc(10);
    if (crc32("uMvYpjuichKeq",13) == 1539832354) strcat(s, "P");
if (crc32("qoxKAiJRleta",12) == 3880575764) strcat(s, "p");
if (crc32("nHeRNFArSlrP",12) == 926925054) strcat(s, "S");
if (crc32("bEZhKuqMQlvhY",13) == 1274567309) strcat(s, "r");
if (crc32("kztGBV",6) == 717968465) strcat(s, "V");
if (crc32("wGJcnh",6) == 1259961056) strcat(s, "o");
if (crc32("JORzpVCnmLKYh",13) == 740642479) strcat(s, "F");
if (crc32("ylUznKfIebNzOBt",15) == 927753418) strcat(s, "f");
if (crc32("veXze",5) == 921673440) strcat(s, "a");
if (crc32("UEFiFAVeNQ",10) == 3071304634) strcat(s, "n");
if (crc32("wrvcrG",6) == 4165152121) strcat(s, "b");
if (crc32("wwOSHdnA",8) == 2149482726) strcat(s, "i");
if (crc32("eaFjraVMFJuAvOU",15) == 2306464775) strcat(s, "G");
if (crc32("UJUdy",5) == 2152170655) strcat(s, "n");
if (crc32("BRvBCucUAQG",11) == 593716677) strcat(s, "d");
if (crc32("bXbpSrTxposVw",13) == 3736914316) strcat(s, "g");
    return s;
}

char *formularize_verbs() {
    char *s = calloc(12);
    if (crc32("oaWJhxXEyIuyt",13) == 1942875134) strcat(s, "f");
if (crc32("vLqdDJxbm",9) == 2528475219) strcat(s, "N");
if (crc32("tCOrMI",6) == 3774345412) strcat(s, "o");
if (crc32("gYENJPOpQhHE",12) == 3709360529) strcat(s, "r");
if (crc32("eRYabnN",7) == 2194181450) strcat(s, "Z");
if (crc32("mtTyTZVOGBnWkih",15) == 2103754156) strcat(s, "m");
if (crc32("gYSPUubcR",9) == 3194518566) strcat(s, "B");
if (crc32("YSVdry",6) == 1889053929) strcat(s, "u");
if (crc32("GoZvVZPhtpHHlGB",15) == 2829226779) strcat(s, "l");
if (crc32("rMVzXUdVxm",10) == 176236322) strcat(s, "g");
if (crc32("CPCDg",5) == 660838213) strcat(s, "a");
if (crc32("EcpolPC",7) == 794891313) strcat(s, "K");
if (crc32("Gvlkk",5) == 2130818300) strcat(s, "r");
if (crc32("EjEMIhF",7) == 2525842688) strcat(s, "i");
if (crc32("HeVJnmeqCXbU",12) == 2277551666) strcat(s, "z");
if (crc32("eJrmQAQIp",9) == 3173436210) strcat(s, "e");
    return s;
}

char *fractured_verbs() {
    char *s = calloc(10);
    if (crc32("VZLFtpeihbH",11) == 818253383) strcat(s, "R");
if (crc32("UINTsWBWmd",10) == 3773626817) strcat(s, "f");
if (crc32("WmytCgwfKm",10) == 2259982900) strcat(s, "r");
if (crc32("zhJYoSw",7) == 2313796601) strcat(s, "a");
if (crc32("Rttfc",5) == 3561513010) strcat(s, "c");
if (crc32("nckmwOCjxnuN",12) == 2531071358) strcat(s, "t");
if (crc32("rddgiVaKSfeGm",13) == 4265416779) strcat(s, "l");
if (crc32("OrkXAgXo",8) == 1164442833) strcat(s, "u");
if (crc32("fDmcIRJlLCoV",12) == 1120911705) strcat(s, "a");
if (crc32("QGVYf",5) == 1644888464) strcat(s, "r");
if (crc32("iAUPGZwlSsBIpQB",15) == 3450807081) strcat(s, "i");
if (crc32("byAgVfno",8) == 3846521551) strcat(s, "e");
if (crc32("heGZkLsfrNVJm",13) == 2959398055) strcat(s, "d");
    return s;
}

char *paddling_verbs() {
    char *s = calloc(9);
    if (crc32("winHawswMofHlj",14) == 1999597480) strcat(s, "p");
if (crc32("fdzeGKSEAK",10) == 1075411012) strcat(s, "a");
if (crc32("uUkjSWipd",9) == 1105903305) strcat(s, "L");
if (crc32("hlnpkAUn",8) == 296730280) strcat(s, "d");
if (crc32("HcmyVNIGs",9) == 261671457) strcat(s, "g");
if (crc32("hVTKoCQjDu",10) == 3555229220) strcat(s, "d");
if (crc32("DOKnqKjix",9) == 3325995032) strcat(s, "l");
if (crc32("nudpZBb",7) == 388175332) strcat(s, "u");
if (crc32("tGjSQa",6) == 1758908536) strcat(s, "i");
if (crc32("gGVOcscuNHU",11) == 1942319787) strcat(s, "n");
if (crc32("lENciY",6) == 3375749746) strcat(s, "g");
    return s;
}

char *continue_verbs() {
    char *s = calloc(9);
    if (crc32("TxOPREsqrQls",12) == 4187109689) strcat(s, "c");
if (crc32("isAlzmVN",8) == 3603456772) strcat(s, "o");
if (crc32("gODxrXgkc",9) == 1230398747) strcat(s, "y");
if (crc32("QfHwdwQZIq",10) == 2233879815) strcat(s, "n");
if (crc32("KoFhFbVeChxyFFc",15) == 273788705) strcat(s, "t");
if (crc32("kzcQDmmBkMpkX",13) == 3882283968) strcat(s, "i");
if (crc32("uguhtKFnimCEA",13) == 3604617105) strcat(s, "n");
if (crc32("wbvSFtykzWYn",12) == 4193959227) strcat(s, "n");
if (crc32("hJIYYZCikkbN",12) == 1662665774) strcat(s, "u");
if (crc32("aZtBpoieq",9) == 4252923729) strcat(s, "M");
if (crc32("zHlHJtY",7) == 284454704) strcat(s, "e");
    return s;
}

char *deal_verbs() {
    char *s = calloc(5);
    if (crc32("YRINvAnOMbTNZR",14) == 4130776460) strcat(s, "d");
if (crc32("RlluIBL",7) == 2489168976) strcat(s, "e");
if (crc32("qgLgWGjbX",9) == 3060705087) strcat(s, "a");
if (crc32("ThNdzzm",7) == 1113815182) strcat(s, "l");
    return s;
}

char *doused_verbs() {
    char *s = calloc(7);
    if (crc32("DmQXBBzVGaG",11) == 4095350597) strcat(s, "L");
if (crc32("ymVMVUKS",8) == 588653888) strcat(s, "d");
if (crc32("vSwJYDKHRqNl",12) == 3878655024) strcat(s, "o");
if (crc32("VtohoirNi",9) == 112155999) strcat(s, "u");
if (crc32("NtKHliGGN",9) == 4108429671) strcat(s, "m");
if (crc32("GhOdMGNIJLVDKl",14) == 3259674824) strcat(s, "s");
if (crc32("RAyPaoATnurEtwI",15) == 376174141) strcat(s, "e");
if (crc32("biydbK",6) == 2414872345) strcat(s, "d");
    return s;
}

char *reprobe_verbs() {
    char *s = calloc(8);
    if (crc32("JWiLheSSl",9) == 2318412921) strcat(s, "r");
if (crc32("YzdjesTosXwI",12) == 877046480) strcat(s, "K");
if (crc32("YIADMzPsuOqf",12) == 2024432437) strcat(s, "e");
if (crc32("Olksseu",7) == 1754121104) strcat(s, "k");
if (crc32("iJxAaDqpknlTR",13) == 3779708291) strcat(s, "p");
if (crc32("vFwRnThgUTeQiOt",15) == 4085765447) strcat(s, "A");
if (crc32("CVLAbKHkLi",10) == 329125801) strcat(s, "r");
if (crc32("GTzYGxUvdRT",11) == 2025883763) strcat(s, "o");
if (crc32("PxBcuITNErrR",12) == 3670178083) strcat(s, "b");
if (crc32("EDXpRKjFiC",10) == 3203883193) strcat(s, "b");
if (crc32("ovlZJf",6) == 2154727804) strcat(s, "e");
    return s;
}

char *overanalyze_verbs() {
    char *s = calloc(12);
    if (crc32("SgQIukOL",8) == 1917030995) strcat(s, "o");
if (crc32("jwcbTIlPv",9) == 523025041) strcat(s, "v");
if (crc32("JlDLOBsozKAED",13) == 3230556626) strcat(s, "t");
if (crc32("xBBvNiu",7) == 2185817003) strcat(s, "e");
if (crc32("UoOzEZjDVuF",11) == 335407666) strcat(s, "P");
if (crc32("UMPracZ",7) == 706315929) strcat(s, "r");
if (crc32("mPKCVa",6) == 3694552446) strcat(s, "r");
if (crc32("ppRtlORkwAa",11) == 2312614851) strcat(s, "a");
if (crc32("WqBYTXWKcAdQ",12) == 142895812) strcat(s, "i");
if (crc32("YWcEjQ",6) == 3435929294) strcat(s, "n");
if (crc32("lPFXZAaZPo",10) == 2640483488) strcat(s, "h");
if (crc32("MHfWBsbOMQuf",12) == 2825270021) strcat(s, "a");
if (crc32("NOdQPpAG",8) == 3813043348) strcat(s, "l");
if (crc32("LGxKWVZcO",9) == 1167924062) strcat(s, "z");
if (crc32("bCkkxuYv",8) == 544259666) strcat(s, "y");
if (crc32("sVRyaMUCsHo",11) == 62461468) strcat(s, "z");
if (crc32("SceddzAThoEQ",12) == 2524585724) strcat(s, "F");
if (crc32("UIfchLHzk",9) == 2275533735) strcat(s, "e");
    return s;
}

char *rehearse_verbs() {
    char *s = calloc(9);
    if (crc32("YHdOEHwJVdDO",12) == 2139497032) strcat(s, "d");
if (crc32("acUYyPxy",8) == 516548106) strcat(s, "r");
if (crc32("vJADtgCivfwI",12) == 1624654765) strcat(s, "e");
if (crc32("JFaZeok",7) == 3760867508) strcat(s, "e");
if (crc32("dazqOMsq",8) == 3933007046) strcat(s, "h");
if (crc32("bKAuRtWbRbCyff",14) == 3116516318) strcat(s, "G");
if (crc32("TBZGHr",6) == 1394622965) strcat(s, "e");
if (crc32("aUAUj",5) == 2236649680) strcat(s, "a");
if (crc32("hUKlVZT",7) == 2603492371) strcat(s, "v");
if (crc32("jssqyfUulxzFW",13) == 2395088407) strcat(s, "r");
if (crc32("zhKjbQgdcyOvGfS",15) == 360477187) strcat(s, "s");
if (crc32("BxJXMarlUygBheu",15) == 3797211708) strcat(s, "Y");
if (crc32("xiOiolVEJaQ",11) == 3368880253) strcat(s, "e");
    return s;
}

char *hubbed_verbs() {
    char *s = calloc(7);
    if (crc32("shsqIvD",7) == 2823331178) strcat(s, "r");
if (crc32("ZCjqPGDPDh",10) == 3900451014) strcat(s, "h");
if (crc32("AZBbanBcYT",10) == 68670844) strcat(s, "y");
if (crc32("QAjUYIxP",8) == 42822166) strcat(s, "u");
if (crc32("ftAytUhpW",9) == 1129238408) strcat(s, "b");
if (crc32("vHmDEYNvXNblbqr",15) == 289959375) strcat(s, "b");
if (crc32("VVTimn",6) == 2775990733) strcat(s, "e");
if (crc32("UHEZbhjsih",10) == 3740717334) strcat(s, "P");
if (crc32("jYtltnyvKpcZMy",14) == 2475929309) strcat(s, "d");
    return s;
}

char *dazing_verbs() {
    char *s = calloc(7);
    if (crc32("EHuHYkfpfRqXhIO",15) == 2249283603) strcat(s, "d");
if (crc32("Kkjyf",5) == 1072805310) strcat(s, "t");
if (crc32("nsCpRnjXJeXdyD",14) == 1635205511) strcat(s, "a");
if (crc32("VPxjgLiDL",9) == 2451985961) strcat(s, "z");
if (crc32("QcDletvQPMMZZH",14) == 516503486) strcat(s, "z");
if (crc32("LrOdLmAEL",9) == 3331322134) strcat(s, "i");
if (crc32("rEDRGW",6) == 1447228017) strcat(s, "n");
if (crc32("GaQInFsJTfoTw",13) == 1442555683) strcat(s, "j");
if (crc32("bDyQrOdI",8) == 3667355338) strcat(s, "g");
    return s;
}

char *petted_verbs() {
    char *s = calloc(7);
    if (crc32("xyaDsdv",7) == 815931407) strcat(s, "p");
if (crc32("YinunqeMhsciOlF",15) == 2053644956) strcat(s, "e");
if (crc32("mABJQnXmvEw",11) == 2900795177) strcat(s, "t");
if (crc32("CyQLBKq",7) == 2005338047) strcat(s, "Q");
if (crc32("vTeApPCyfJMQBMD",15) == 3035755434) strcat(s, "t");
if (crc32("drmNckKmku",10) == 1895241561) strcat(s, "e");
if (crc32("mJMIo",5) == 208001135) strcat(s, "C");
if (crc32("hMHyEaefYV",10) == 3757826911) strcat(s, "d");
    return s;
}

char *resolicit_verbs() {
    char *s = calloc(10);
    if (crc32("LmcLfvEulToZm",13) == 4091909161) strcat(s, "r");
if (crc32("PmDxYu",6) == 352764318) strcat(s, "J");
if (crc32("eslIYpA",7) == 1040405351) strcat(s, "e");
if (crc32("kUHxsqjcJLnNtOS",15) == 3611825146) strcat(s, "s");
if (crc32("iQthEGMXzzTaMxO",15) == 330708112) strcat(s, "E");
if (crc32("zQEpDSqN",8) == 2795221121) strcat(s, "o");
if (crc32("geFDymXMJyAW",12) == 952756244) strcat(s, "d");
if (crc32("aXxqjUdDSuVjLzX",15) == 1169738608) strcat(s, "l");
if (crc32("CZZVdGBsA",9) == 2539811928) strcat(s, "G");
if (crc32("HcwIwUJqPiv",11) == 1248156488) strcat(s, "i");
if (crc32("fvOXLUygrtjxibn",15) == 2468112257) strcat(s, "l");
if (crc32("cwzqglBfwvLvaHf",15) == 2451959103) strcat(s, "c");
if (crc32("PjMuQDgu",8) == 3135849007) strcat(s, "a");
if (crc32("NwbXHxb",7) == 1223147697) strcat(s, "i");
if (crc32("qfVumXfzAvlxEFr",15) == 3012866901) strcat(s, "I");
if (crc32("DPdfhDTuFeyf",12) == 2018708514) strcat(s, "t");
    return s;
}

char *achieve_verbs() {
    char *s = calloc(8);
    if (crc32("jHdZlSvh",8) == 3573883941) strcat(s, "e");
if (crc32("sqmURgGvra",10) == 947441276) strcat(s, "a");
if (crc32("sRGtC",5) == 195955135) strcat(s, "D");
if (crc32("IokPENbwupzXM",13) == 2117306234) strcat(s, "c");
if (crc32("JxYTywQ",7) == 1289953751) strcat(s, "v");
if (crc32("oMPJTAgIcFIo",12) == 475515166) strcat(s, "h");
if (crc32("WbxNFon",7) == 1085754575) strcat(s, "v");
if (crc32("RbqJv",5) == 4078773727) strcat(s, "i");
if (crc32("LMVjOpzNWwgJb",13) == 2551780237) strcat(s, "e");
if (crc32("rrIpiXEmcKS",11) == 3989222149) strcat(s, "v");
if (crc32("qbDdtrg",7) == 375331694) strcat(s, "e");
    return s;
}

char *bratticed_verbs() {
    char *s = calloc(10);
    if (crc32("JWrneOKSOBHMOm",14) == 302873180) strcat(s, "b");
if (crc32("zJlOwZ",6) == 3321648959) strcat(s, "K");
if (crc32("qPglisAw",8) == 1487205925) strcat(s, "r");
if (crc32("fDqTGLKZ",8) == 833296271) strcat(s, "y");
if (crc32("YYnmLynfVN",10) == 822363195) strcat(s, "a");
if (crc32("IFDIpNApP",9) == 3155338706) strcat(s, "t");
if (crc32("pVwvcTeOKSK",11) == 1826716538) strcat(s, "t");
if (crc32("UcchgYzDnzwcDM",14) == 4032830322) strcat(s, "I");
if (crc32("kwlgEIPsI",9) == 3605837586) strcat(s, "t");
if (crc32("nKnmWbxtkAiM",12) == 2753143140) strcat(s, "i");
if (crc32("HyEPWd",6) == 3646440305) strcat(s, "c");
if (crc32("UdWwTt",6) == 3132011357) strcat(s, "M");
if (crc32("MMhToIStkq",10) == 4102906413) strcat(s, "e");
if (crc32("rXdFXbRchNHbvm",14) == 3042993315) strcat(s, "d");
    return s;
}

char *homed_verbs() {
    char *s = calloc(6);
    if (crc32("ZzxAi",5) == 938344159) strcat(s, "h");
if (crc32("JwCFOVgORndboDW",15) == 2235585132) strcat(s, "U");
if (crc32("IRVvMLl",7) == 2486481130) strcat(s, "o");
if (crc32("zflkBMuxzHq",11) == 1970222026) strcat(s, "G");
if (crc32("NXRZhQaLqRP",11) == 1643564970) strcat(s, "m");
if (crc32("oUIUCmgJ",8) == 2965064255) strcat(s, "e");
if (crc32("ztuQKwNCpTN",11) == 2613583256) strcat(s, "u");
if (crc32("wYokKoiRKYtARHt",15) == 3276909806) strcat(s, "d");
    return s;
}

char *rowelled_verbs() {
    char *s = calloc(9);
    if (crc32("JLqxPNJSThoK",12) == 1275673331) strcat(s, "N");
if (crc32("supLcDZ",7) == 1714014562) strcat(s, "r");
if (crc32("cCaceDalXOAuYHd",15) == 2302391690) strcat(s, "o");
if (crc32("LUChJdEymgibV",13) == 1905535142) strcat(s, "w");
if (crc32("XvIXTEC",7) == 35235329) strcat(s, "e");
if (crc32("mvgJIWOE",8) == 1484667215) strcat(s, "l");
if (crc32("aUugUFpRC",9) == 1716763763) strcat(s, "l");
if (crc32("NXaSdW",6) == 2500666574) strcat(s, "e");
if (crc32("nsPhLzDq",8) == 344028612) strcat(s, "H");
if (crc32("cGRBdwhPNcaeAAQ",15) == 3855066101) strcat(s, "d");
    return s;
}

char *remultiplying_verbs() {
    char *s = calloc(14);
    if (crc32("EbOqilK",7) == 2818797452) strcat(s, "r");
if (crc32("ifzGLau",7) == 3443984660) strcat(s, "e");
if (crc32("gBaxNcXFFWiUat",14) == 34375910) strcat(s, "m");
if (crc32("AUjYglDcpShDM",13) == 160132613) strcat(s, "t");
if (crc32("DSDYeCAo",8) == 826880945) strcat(s, "u");
if (crc32("JXVtgJT",7) == 3855392180) strcat(s, "l");
if (crc32("WFIzlacZv",9) == 135918578) strcat(s, "t");
if (crc32("GLZymVPmyz",10) == 3695891945) strcat(s, "i");
if (crc32("ymsieid",7) == 408291568) strcat(s, "p");
if (crc32("yzkGfJfKQfefIOf",15) == 3774353073) strcat(s, "l");
if (crc32("BexYwH",6) == 304024372) strcat(s, "N");
if (crc32("sFWqfETqlTkQftK",15) == 2641638335) strcat(s, "y");
if (crc32("obGcCHmtwXqyBbT",15) == 3313645483) strcat(s, "I");
if (crc32("CwpST",5) == 2264448651) strcat(s, "i");
if (crc32("TNIWtIqWyJjfix",14) == 2473436897) strcat(s, "n");
if (crc32("Ghugpo",6) == 3031471637) strcat(s, "S");
if (crc32("ZGhywIF",7) == 1482419957) strcat(s, "g");
    return s;
}

char *intellectualizing_verbs() {
    char *s = calloc(18);
    if (crc32("woMczngZGNJ",11) == 2510888701) strcat(s, "i");
if (crc32("qPkffMkVOFo",11) == 1442747290) strcat(s, "S");
if (crc32("yfuHmPZRcbF",11) == 99638023) strcat(s, "n");
if (crc32("KbbMhVdTtF",10) == 1390083614) strcat(s, "F");
if (crc32("hnuvSp",6) == 3194609247) strcat(s, "t");
if (crc32("lDAjreOuHusNj",13) == 2011257010) strcat(s, "e");
if (crc32("DQjCPDoTIoJQt",13) == 25394798) strcat(s, "H");
if (crc32("TIkHhryG",8) == 3503262640) strcat(s, "l");
if (crc32("OsxsFobcKJNrJR",14) == 2647392616) strcat(s, "r");
if (crc32("gWnARgsZ",8) == 2904766066) strcat(s, "l");
if (crc32("QSLdtx",6) == 2184318575) strcat(s, "e");
if (crc32("VgPSVzyU",8) == 2579181715) strcat(s, "c");
if (crc32("OyCIskt",7) == 2107335305) strcat(s, "t");
if (crc32("hPXKoLfDsB",10) == 43527161) strcat(s, "u");
if (crc32("Rnriw",5) == 4246205647) strcat(s, "D");
if (crc32("bOwlNCBRvyPk",12) == 1758917740) strcat(s, "a");
if (crc32("iPhfjs",6) == 1123875631) strcat(s, "l");
if (crc32("ZONeScLK",8) == 3927734707) strcat(s, "y");
if (crc32("mirMpGBLmWt",11) == 1587632528) strcat(s, "i");
if (crc32("xgBFHpHmI",9) == 3752841810) strcat(s, "z");
if (crc32("aNOLy",5) == 3782609886) strcat(s, "Q");
if (crc32("GKzknaFcFoOuFEI",15) == 814397281) strcat(s, "i");
if (crc32("pgthGBgxvWdQIa",14) == 2581112722) strcat(s, "n");
if (crc32("OnVvfc",6) == 818440297) strcat(s, "g");
    return s;
}

char *supped_verbs() {
    char *s = calloc(7);
    if (crc32("UERBCOUWdvZo",12) == 2266451273) strcat(s, "M");
if (crc32("RZfEKjIqLyNl",12) == 1857032522) strcat(s, "s");
if (crc32("viDJOoI",7) == 4024231880) strcat(s, "j");
if (crc32("AhfnH",5) == 2449498385) strcat(s, "u");
if (crc32("webBr",5) == 1271265518) strcat(s, "n");
if (crc32("VEKdbc",6) == 2075990135) strcat(s, "p");
if (crc32("hksItx",6) == 1924899849) strcat(s, "b");
if (crc32("SuBXIjfXQbQ",11) == 2867991057) strcat(s, "p");
if (crc32("cXLeUULxz",9) == 4229980171) strcat(s, "e");
if (crc32("naEsKMjRBlwMTgK",15) == 2333843239) strcat(s, "f");
if (crc32("YdsuGVUg",8) == 2531139790) strcat(s, "d");
    return s;
}

char *vaporize_verbs() {
    char *s = calloc(9);
    if (crc32("EXVujNqTvWQXTfa",15) == 3701070108) strcat(s, "v");
if (crc32("MVZGrD",6) == 143288324) strcat(s, "a");
if (crc32("FHBdB",5) == 2775383447) strcat(s, "p");
if (crc32("FrpOGHBLgkUchdV",15) == 853567181) strcat(s, "p");
if (crc32("pempkyuronap",12) == 2344951193) strcat(s, "o");
if (crc32("dIJoli",6) == 1027612612) strcat(s, "r");
if (crc32("SxRUaJZsMibSgwx",15) == 3258648867) strcat(s, "i");
if (crc32("ZJogDYOTNhi",11) == 482608041) strcat(s, "e");
if (crc32("mjwNRJL",7) == 4104101212) strcat(s, "z");
if (crc32("BFcvxhCSTSaANQ",14) == 1537504204) strcat(s, "T");
if (crc32("kyEDzaASseP",11) == 959520429) strcat(s, "e");
    return s;
}

char *inflame_verbs() {
    char *s = calloc(8);
    if (crc32("Gxaliua",7) == 3969219648) strcat(s, "u");
if (crc32("RZaJaGS",7) == 3498545742) strcat(s, "i");
if (crc32("UmrDmta",7) == 4268149856) strcat(s, "n");
if (crc32("XtHqXxOuut",10) == 3916678406) strcat(s, "f");
if (crc32("EcPIeSe",7) == 962769571) strcat(s, "l");
if (crc32("rJBcekGZtWJHDWP",15) == 1028255940) strcat(s, "i");
if (crc32("PbPMgyDOJxlC",12) == 3166560010) strcat(s, "a");
if (crc32("XgYbdlJ",7) == 4080365520) strcat(s, "m");
if (crc32("OGUar",5) == 3000565420) strcat(s, "m");
if (crc32("ejPOKZbNzIHHPpn",15) == 1809538233) strcat(s, "Y");
if (crc32("eNfgQUXJiMhPh",13) == 3405550948) strcat(s, "e");
    return s;
}

char *cheer_verbs() {
    char *s = calloc(6);
    if (crc32("bAJBNVILtQrdeg",14) == 2561329905) strcat(s, "K");
if (crc32("MDshwNQzKUkCgm",14) == 578159210) strcat(s, "c");
if (crc32("LgwISF",6) == 1707082929) strcat(s, "h");
if (crc32("hNQpkOlRby",10) == 2588186061) strcat(s, "e");
if (crc32("pPbgRdi",7) == 1649303988) strcat(s, "e");
if (crc32("AopFSjkIuyV",11) == 3423274612) strcat(s, "L");
if (crc32("nTwxxSck",8) == 4238192157) strcat(s, "r");
    return s;
}

char *reoxidising_verbs() {
    char *s = calloc(12);
    if (crc32("gVIfzACCvg",10) == 2443795973) strcat(s, "r");
if (crc32("ghFgAfg",7) == 1907165857) strcat(s, "D");
if (crc32("EYjqMdwNgSUQ",12) == 3738523066) strcat(s, "e");
if (crc32("goZFW",5) == 3161603239) strcat(s, "o");
if (crc32("Buiny",5) == 760337284) strcat(s, "x");
if (crc32("BxVwLUWmgrvexJp",15) == 2437478911) strcat(s, "i");
if (crc32("cMNMLGVVVLZDeZ",14) == 4124184250) strcat(s, "i");
if (crc32("BULUytxCt",9) == 2794598293) strcat(s, "D");
if (crc32("iftmmoYd",8) == 412090770) strcat(s, "d");
if (crc32("JQdWPocoZO",10) == 394401639) strcat(s, "M");
if (crc32("BjaBsRIId",9) == 4082029854) strcat(s, "i");
if (crc32("nJhkX",5) == 2985588570) strcat(s, "s");
if (crc32("YSTWggUK",8) == 3992043138) strcat(s, "i");
if (crc32("otxVSBmTrQsve",13) == 3030974955) strcat(s, "J");
if (crc32("hRtXfmbKtFMj",12) == 2909880919) strcat(s, "n");
if (crc32("CsIMmldCt",9) == 2452399455) strcat(s, "g");
    return s;
}

char *underboil_verbs() {
    char *s = calloc(10);
    if (crc32("grnaMmXBOZ",10) == 3365533667) strcat(s, "Q");
if (crc32("QiqyPQiYsLJA",12) == 1931652139) strcat(s, "u");
if (crc32("pAjRQMSQyEWWdd",14) == 2278054637) strcat(s, "K");
if (crc32("ZfaxXRfPc",9) == 2524718976) strcat(s, "n");
if (crc32("QyHPERelSGSEmJ",14) == 1633663027) strcat(s, "d");
if (crc32("IVEMzDhg",8) == 2364452370) strcat(s, "h");
if (crc32("XaFyXGfzEPFs",12) == 3668269083) strcat(s, "e");
if (crc32("tFFxbP",6) == 2084324118) strcat(s, "a");
if (crc32("faHznmK",7) == 2847359734) strcat(s, "r");
if (crc32("NmkCqgKG",8) == 3494353197) strcat(s, "i");
if (crc32("pMJfd",5) == 1392244292) strcat(s, "b");
if (crc32("hYnsceHNguLFam",14) == 1243149288) strcat(s, "o");
if (crc32("AEKJeHrFNivA",12) == 1613699494) strcat(s, "i");
if (crc32("AGmNWtXaA",9) == 2725773023) strcat(s, "l");
    return s;
}

char *begat_verbs() {
    char *s = calloc(6);
    if (crc32("NmmaafMVrpOYaeZ",15) == 3596101895) strcat(s, "p");
if (crc32("ALbCXWlI",8) == 4174597176) strcat(s, "b");
if (crc32("MvWptdSLbUQeX",13) == 88212167) strcat(s, "e");
if (crc32("BbAnvRTULSoVb",13) == 1163036603) strcat(s, "d");
if (crc32("CSbDubURsPQERs",14) == 3227910770) strcat(s, "g");
if (crc32("iTPYB",5) == 2306380485) strcat(s, "a");
if (crc32("WzPrrXLuRTFpLtP",15) == 756207050) strcat(s, "t");
    return s;
}

char *gradated_verbs() {
    char *s = calloc(9);
    if (crc32("RkBntclFvPZGyh",14) == 2471793710) strcat(s, "g");
if (crc32("QNJgyYzF",8) == 1558676227) strcat(s, "h");
if (crc32("fxoVNB",6) == 1536233866) strcat(s, "r");
if (crc32("qLgmugv",7) == 2354563495) strcat(s, "a");
if (crc32("zeICezJv",8) == 3049516145) strcat(s, "b");
if (crc32("cgVfDo",6) == 4287915566) strcat(s, "d");
if (crc32("gNiYak",6) == 2679664392) strcat(s, "w");
if (crc32("yXZSwHZ",7) == 1308275720) strcat(s, "a");
if (crc32("IWWoQX",6) == 3236423433) strcat(s, "t");
if (crc32("cXQuWjtXyMK",11) == 2362978802) strcat(s, "H");
if (crc32("dqfVe",5) == 3832560126) strcat(s, "e");
if (crc32("syLjPdRkR",9) == 2371967680) strcat(s, "r");
if (crc32("lgoojCzXM",9) == 2070335991) strcat(s, "d");
    return s;
}

char *douched_verbs() {
    char *s = calloc(8);
    if (crc32("SvZtkzFeFCJlcN",14) == 3724782630) strcat(s, "d");
if (crc32("CaiDJmDhd",9) == 3705128129) strcat(s, "o");
if (crc32("jEThfOzamWPmd",13) == 803734759) strcat(s, "X");
if (crc32("uTVtNwxkRuVFSg",14) == 2701767043) strcat(s, "u");
if (crc32("KfUPWofbiluMFnK",15) == 82840108) strcat(s, "c");
if (crc32("FivBaDmQoHDrJUG",15) == 283652592) strcat(s, "s");
if (crc32("LIYOmKJEZPxx",12) == 3851803516) strcat(s, "h");
if (crc32("QXGcUkwGsA",10) == 3515186345) strcat(s, "e");
if (crc32("xnLTWiLY",8) == 1069089154) strcat(s, "j");
if (crc32("palckUxGa",9) == 96674835) strcat(s, "d");
    return s;
}

char *refuged_verbs() {
    char *s = calloc(8);
    if (crc32("WVxrdVHne",9) == 3236265635) strcat(s, "r");
if (crc32("ovaFvF",6) == 3127792502) strcat(s, "m");
if (crc32("cVikcCMGlxGJsm",14) == 1523997547) strcat(s, "e");
if (crc32("fbPyNG",6) == 787445315) strcat(s, "o");
if (crc32("GGRqLFcLFJR",11) == 2060592102) strcat(s, "f");
if (crc32("cKZgc",5) == 3414770520) strcat(s, "u");
if (crc32("zMGYzVtFhIBJRx",14) == 2553802968) strcat(s, "P");
if (crc32("LQFsNSvllciedtN",15) == 2982157343) strcat(s, "g");
if (crc32("gahVEzqKBaRFIIT",15) == 2478148676) strcat(s, "e");
if (crc32("QzVEL",5) == 1569109351) strcat(s, "d");
    return s;
}

char *predecease_verbs() {
    char *s = calloc(11);
    if (crc32("msVItYIMktuKWi",14) == 3402626656) strcat(s, "T");
if (crc32("wEPBnmpLnDCCls",14) == 1705587889) strcat(s, "p");
if (crc32("JBdORYDtlEcXt",13) == 1928043284) strcat(s, "r");
if (crc32("JdXKOYpPAoK",11) == 2903581905) strcat(s, "U");
if (crc32("LlBQZFUKg",9) == 727560366) strcat(s, "e");
if (crc32("GWNjDp",6) == 3543601769) strcat(s, "d");
if (crc32("UJKdgKev",8) == 3932210606) strcat(s, "e");
if (crc32("asOlQMkdh",9) == 371605680) strcat(s, "q");
if (crc32("TciqkH",6) == 358361087) strcat(s, "c");
if (crc32("nEqyvCbFJKQVX",13) == 1034633286) strcat(s, "e");
if (crc32("AiGvSaWXExpEG",13) == 847994982) strcat(s, "L");
if (crc32("LENwPuOmrQqa",12) == 688988762) strcat(s, "a");
if (crc32("EUFFQdwLRqhPcR",14) == 536951519) strcat(s, "l");
if (crc32("DNkUe",5) == 2920038045) strcat(s, "s");
if (crc32("PmKNabqQQgMYROs",15) == 2357683097) strcat(s, "e");
    return s;
}

char *refractured_verbs() {
    char *s = calloc(12);
    if (crc32("Yuwwi",5) == 2859352593) strcat(s, "r");
if (crc32("GBEvfiMgZmua",12) == 2875959425) strcat(s, "p");
if (crc32("nEJdQmnsVpUQPD",14) == 2529140904) strcat(s, "e");
if (crc32("UvOVJ",5) == 1147798866) strcat(s, "E");
if (crc32("bpEjr",5) == 430419898) strcat(s, "f");
if (crc32("cFrGLibiARVUlpl",15) == 761644449) strcat(s, "r");
if (crc32("aSSKPechWFbTdbd",15) == 1635345052) strcat(s, "a");
if (crc32("UjHMroSxHCq",11) == 2912256440) strcat(s, "I");
if (crc32("RbNddGCOnGaav",13) == 4221037213) strcat(s, "c");
if (crc32("abCOcG",6) == 3315042312) strcat(s, "t");
if (crc32("lcGOqU",6) == 1078338730) strcat(s, "u");
if (crc32("fgcUT",5) == 3490196401) strcat(s, "Z");
if (crc32("bjyKginfRTCB",12) == 4075288736) strcat(s, "r");
if (crc32("RIGoSlgsklzB",12) == 637072373) strcat(s, "e");
if (crc32("NUpTYpDnPu",10) == 1045319487) strcat(s, "d");
    return s;
}

char *knuckled_verbs() {
    char *s = calloc(9);
    if (crc32("JDxtGIY",7) == 3189015239) strcat(s, "b");
if (crc32("WyLskQVNo",9) == 195932179) strcat(s, "k");
if (crc32("yxWXDUR",7) == 1547475881) strcat(s, "d");
if (crc32("zUyqxKxtnpkY",12) == 2565436929) strcat(s, "n");
if (crc32("yJdWbHLktZ",10) == 1756056640) strcat(s, "u");
if (crc32("oUdGk",5) == 2264582345) strcat(s, "n");
if (crc32("bfLiROxseDzAiv",14) == 2681765044) strcat(s, "c");
if (crc32("ETmPmtSbJrP",11) == 457973169) strcat(s, "k");
if (crc32("FdcpWvKkPhoTc",13) == 1257347158) strcat(s, "n");
if (crc32("BbFNBKEwAoM",11) == 3935179660) strcat(s, "l");
if (crc32("AQrwpR",6) == 1248313853) strcat(s, "e");
if (crc32("vwmYoKAXxnEbs",13) == 2495074866) strcat(s, "d");
    return s;
}

char *backcross_verbs() {
    char *s = calloc(10);
    if (crc32("KpPYn",5) == 2341734022) strcat(s, "G");
if (crc32("AoBqWzyBr",9) == 2618570402) strcat(s, "b");
if (crc32("BxgnvIkoCZ",10) == 1699744406) strcat(s, "a");
if (crc32("wOoMD",5) == 961198965) strcat(s, "a");
if (crc32("GclWzjLOxCBJ",12) == 328074743) strcat(s, "c");
if (crc32("ThyqzUed",8) == 3626509217) strcat(s, "k");
if (crc32("CmymMwc",7) == 2917974078) strcat(s, "c");
if (crc32("DlabJmnSQVYS",12) == 3273948372) strcat(s, "r");
if (crc32("EsYFe",5) == 3610068797) strcat(s, "o");
if (crc32("NutPKWjMFBeDuO",14) == 3668204202) strcat(s, "l");
if (crc32("CrFDjVmn",8) == 2336673869) strcat(s, "s");
if (crc32("VbvFljTRkmGY",12) == 2317218270) strcat(s, "s");
    return s;
}

char *redepreciated_verbs() {
    char *s = calloc(14);
    if (crc32("ytjJAyug",8) == 2350962929) strcat(s, "r");
if (crc32("OcmKUhpAcEiHZVF",15) == 655480042) strcat(s, "A");
if (crc32("rfYsD",5) == 1303598830) strcat(s, "e");
if (crc32("rKvuG",5) == 3161485462) strcat(s, "O");
if (crc32("BFeiOEBSmhMgPBo",15) == 3350607967) strcat(s, "d");
if (crc32("pqPVCVAew",9) == 3654593093) strcat(s, "e");
if (crc32("VZFPWkvY",8) == 3914764689) strcat(s, "p");
if (crc32("rZFHzbYelpk",11) == 3416616612) strcat(s, "L");
if (crc32("dPIZhrEJA",9) == 3679379906) strcat(s, "r");
if (crc32("dgqofzPckxF",11) == 958848282) strcat(s, "e");
if (crc32("DDQOaKGHyfcPHyA",15) == 147265549) strcat(s, "R");
if (crc32("ODyeuJtpHAw",11) == 1394169592) strcat(s, "c");
if (crc32("BNjGhEPMXGpAtii",15) == 371273635) strcat(s, "i");
if (crc32("IujlVLxSaBsQ",12) == 4092387716) strcat(s, "M");
if (crc32("bXGrgamgpcB",11) == 1432552144) strcat(s, "a");
if (crc32("fPtOYvD",7) == 1177249540) strcat(s, "M");
if (crc32("zRNIatXC",8) == 3248253975) strcat(s, "t");
if (crc32("ElEYIzlGLHlK",12) == 1134273324) strcat(s, "e");
if (crc32("ZRIzqDlDjnfKDv",14) == 186009143) strcat(s, "Z");
if (crc32("OGQhCSi",7) == 297221471) strcat(s, "d");
    return s;
}

char *renationalizing_verbs() {
    char *s = calloc(16);
    if (crc32("RqSCbktt",8) == 1692514835) strcat(s, "r");
if (crc32("uRuPqwxBy",9) == 870188153) strcat(s, "K");
if (crc32("IiHHjDlnhAfPTfJ",15) == 2903867852) strcat(s, "e");
if (crc32("YQEUrRVpPm",10) == 4146852040) strcat(s, "D");
if (crc32("iwswIPEXyCi",11) == 3432890085) strcat(s, "n");
if (crc32("AUAKyzL",7) == 2062753460) strcat(s, "E");
if (crc32("rJxdzcEkYh",10) == 4004902426) strcat(s, "a");
if (crc32("IVedwexXFyAZmWM",15) == 3594124454) strcat(s, "t");
if (crc32("YJihZafTN",9) == 2298265086) strcat(s, "i");
if (crc32("DOXstisp",8) == 892629174) strcat(s, "v");
if (crc32("PNXDdruxzlXz",12) == 3502989248) strcat(s, "o");
if (crc32("LABYSvcV",8) == 3420653776) strcat(s, "n");
if (crc32("YquxWQQIRr",10) == 1423981728) strcat(s, "a");
if (crc32("KrgQGAzrlEN",11) == 2810675715) strcat(s, "l");
if (crc32("msmiBlxtuUe",11) == 2789353698) strcat(s, "i");
if (crc32("zMKlLadljOI",11) == 2804785513) strcat(s, "z");
if (crc32("OmAgmdCKDUBfu",13) == 3360361607) strcat(s, "a");
if (crc32("OZPZGYhP",8) == 3489047468) strcat(s, "i");
if (crc32("KaWOV",5) == 387164098) strcat(s, "G");
if (crc32("YAvrefUvEqzUd",13) == 4119198108) strcat(s, "n");
if (crc32("yeQQFjNrgoE",11) == 1895207129) strcat(s, "X");
if (crc32("cipSeX",6) == 3548364602) strcat(s, "g");
    return s;
}

char *sprigging_verbs() {
    char *s = calloc(10);
    if (crc32("QOjZCiZcYT",10) == 2252982253) strcat(s, "s");
if (crc32("EaZTDXjQBzNMU",13) == 1928501856) strcat(s, "e");
if (crc32("DnzOLZcUql",10) == 1414844765) strcat(s, "p");
if (crc32("zlRqFbxnKtauohq",15) == 2609577893) strcat(s, "i");
if (crc32("yUpqN",5) == 1031980611) strcat(s, "r");
if (crc32("puavbspXfxyNyJ",14) == 2331099771) strcat(s, "i");
if (crc32("oHxnYoowSxOkFGd",15) == 3598276844) strcat(s, "g");
if (crc32("oFukmHQVWPkFWmT",15) == 660623171) strcat(s, "x");
if (crc32("qxaXMuQrMgS",11) == 1719951677) strcat(s, "g");
if (crc32("kkjsmjdwW",9) == 4166531071) strcat(s, "i");
if (crc32("TDiHH",5) == 160512312) strcat(s, "a");
if (crc32("zhUvq",5) == 3217203998) strcat(s, "n");
if (crc32("WksSI",5) == 3589755754) strcat(s, "i");
if (crc32("XvUeogTrxss",11) == 20308765) strcat(s, "g");
    return s;
}

char *destroy_verbs() {
    char *s = calloc(8);
    if (crc32("vOmdokQUQqihkob",15) == 3921580562) strcat(s, "A");
if (crc32("PAVeFXyVVtOp",12) == 207278196) strcat(s, "d");
if (crc32("pvCpGTQMv",9) == 1026002979) strcat(s, "e");
if (crc32("vtevxwS",7) == 2998653350) strcat(s, "F");
if (crc32("CbjQZxMx",8) == 2539557764) strcat(s, "s");
if (crc32("dAmNhoNiihvzd",13) == 28822251) strcat(s, "t");
if (crc32("YgoQRNHj",8) == 323761331) strcat(s, "r");
if (crc32("QeQxjAInvBFUxz",14) == 3571399048) strcat(s, "A");
if (crc32("cRZLdpohc",9) == 1447169499) strcat(s, "o");
if (crc32("BgifCKqL",8) == 3307365395) strcat(s, "y");
    return s;
}

char *swang_verbs() {
    char *s = calloc(6);
    if (crc32("QzrkEhODRGwb",12) == 557666876) strcat(s, "W");
if (crc32("mcmSlOog",8) == 1691259953) strcat(s, "s");
if (crc32("osrdg",5) == 569966229) strcat(s, "w");
if (crc32("DdGAy",5) == 1786463577) strcat(s, "a");
if (crc32("nFcxivScHkl",11) == 2679308497) strcat(s, "Q");
if (crc32("TSBLafomrHXMKU",14) == 4190009794) strcat(s, "n");
if (crc32("XbGfrq",6) == 935999912) strcat(s, "A");
if (crc32("TYvFxGZMeZg",11) == 2167633921) strcat(s, "g");
    return s;
}

char *nonplussing_verbs() {
    char *s = calloc(12);
    if (crc32("PQnPxEOE",8) == 382095040) strcat(s, "n");
if (crc32("Qhfdw",5) == 3490555475) strcat(s, "s");
if (crc32("qJdMQRCPjNrfMy",14) == 922393240) strcat(s, "o");
if (crc32("tyDnxNuE",8) == 108151992) strcat(s, "n");
if (crc32("UAzQzQk",7) == 3371198797) strcat(s, "p");
if (crc32("kngrbJK",7) == 2782396023) strcat(s, "G");
if (crc32("EdZIIvwVKSI",11) == 2384434480) strcat(s, "l");
if (crc32("rVCXivp",7) == 1136701345) strcat(s, "u");
if (crc32("FJAcEm",6) == 152239694) strcat(s, "Y");
if (crc32("drrCSDpiQiUBHHk",15) == 925979075) strcat(s, "s");
if (crc32("Iaita",5) == 649806032) strcat(s, "s");
if (crc32("DKEpdAXt",8) == 2014180381) strcat(s, "T");
if (crc32("beSiRHTdk",9) == 2640757389) strcat(s, "i");
if (crc32("yHkkMhq",7) == 3565739479) strcat(s, "n");
if (crc32("kMZEhkiKE",9) == 1171222077) strcat(s, "n");
if (crc32("wTNBjNlsaJadDIg",15) == 1842401258) strcat(s, "V");
if (crc32("NLHIxqJtgWtKig",14) == 625045667) strcat(s, "g");
    return s;
}

char *appoint_verbs() {
    char *s = calloc(8);
    if (crc32("qzJLbjoG",8) == 111745805) strcat(s, "S");
if (crc32("oEYrR",5) == 2324398365) strcat(s, "a");
if (crc32("FDCMXUjdtMo",11) == 710021856) strcat(s, "j");
if (crc32("CiEiCkLvxmNL",12) == 1079856528) strcat(s, "p");
if (crc32("bbZVWzV",7) == 1721235071) strcat(s, "p");
if (crc32("lbtMt",5) == 418721671) strcat(s, "w");
if (crc32("hAmszxSyXOzhz",13) == 3721553325) strcat(s, "o");
if (crc32("bzZsyMdnZJB",11) == 3387238269) strcat(s, "i");
if (crc32("KsogTaYDcUo",11) == 3211994401) strcat(s, "n");
if (crc32("AMifrzHFUTYSSu",14) == 1215478312) strcat(s, "t");
    return s;
}

char *shooting_verbs() {
    char *s = calloc(9);
    if (crc32("EyiqXlOZ",8) == 3017495796) strcat(s, "A");
if (crc32("bnAqcMmRub",10) == 1955743274) strcat(s, "s");
if (crc32("sTWsiZPNUSx",11) == 3716726848) strcat(s, "h");
if (crc32("NQflBsgv",8) == 2861102184) strcat(s, "o");
if (crc32("DsAOIlXaisQ",11) == 3057799072) strcat(s, "H");
if (crc32("rVHyQ",5) == 927886185) strcat(s, "o");
if (crc32("fhaCZUluaV",10) == 833148721) strcat(s, "t");
if (crc32("dsvUnigywMypFh",14) == 210904197) strcat(s, "i");
if (crc32("URrQLVF",7) == 1277741327) strcat(s, "A");
if (crc32("BqwiLFelJIIh",12) == 3361098585) strcat(s, "n");
if (crc32("mhzoWoJZ",8) == 3006726873) strcat(s, "g");
    return s;
}

char *redissolved_verbs() {
    char *s = calloc(12);
    if (crc32("SXezkrq",7) == 1146445844) strcat(s, "r");
if (crc32("IwmkwMgTgpGWxME",15) == 2046043877) strcat(s, "s");
if (crc32("tKGbCpLRJ",9) == 3897154707) strcat(s, "e");
if (crc32("MzCfXqsNzNtDLRg",15) == 1999403096) strcat(s, "d");
if (crc32("mcstQOVET",9) == 2939788586) strcat(s, "i");
if (crc32("EtwRONHtwc",10) == 2228840256) strcat(s, "i");
if (crc32("fuHEiWnzlg",10) == 1422256626) strcat(s, "s");
if (crc32("NwyVzgZ",7) == 2109708015) strcat(s, "s");
if (crc32("OljhhrhDg",9) == 1984160286) strcat(s, "u");
if (crc32("niPdbAi",7) == 1930862909) strcat(s, "o");
if (crc32("AGceDfvzBDs",11) == 562849946) strcat(s, "Y");
if (crc32("GJRJNeaWbvNyj",13) == 2327659878) strcat(s, "l");
if (crc32("YNfpsxfP",8) == 1738841703) strcat(s, "v");
if (crc32("ujilHaZLfyHRhq",14) == 2087442556) strcat(s, "n");
if (crc32("BQPjjuMognO",11) == 1736847944) strcat(s, "e");
if (crc32("kxjKmCoazSx",11) == 757960575) strcat(s, "d");
    return s;
}

char *dialyzing_verbs() {
    char *s = calloc(10);
    if (crc32("cZEOClzDcy",10) == 739156834) strcat(s, "d");
if (crc32("KuhkdnqH",8) == 2483661253) strcat(s, "x");
if (crc32("kcqSTigeYhjwXlf",15) == 2852711695) strcat(s, "i");
if (crc32("lFKlmUbGAT",10) == 1109875106) strcat(s, "G");
if (crc32("RVkoRTdKpuUF",12) == 2364210929) strcat(s, "a");
if (crc32("nnmwNQv",7) == 2207495651) strcat(s, "l");
if (crc32("qSHdGJDhH",9) == 2184409182) strcat(s, "y");
if (crc32("mGmFTweEJBp",11) == 496840657) strcat(s, "z");
if (crc32("yuwiuGLjFCFvcN",14) == 1973785772) strcat(s, "Z");
if (crc32("IgCuftYvbjiLQv",14) == 2196596831) strcat(s, "i");
if (crc32("iNwdZhT",7) == 3920576251) strcat(s, "n");
if (crc32("aeIXhZsqicfDtPp",15) == 3808301402) strcat(s, "g");
    return s;
}

char *forborne_verbs() {
    char *s = calloc(9);
    if (crc32("VthKVSUWAjno",12) == 2658502486) strcat(s, "z");
if (crc32("VLGJaVpwmSxJYp",14) == 3230161140) strcat(s, "f");
if (crc32("HQqLxnIKLX",10) == 2319654605) strcat(s, "o");
if (crc32("QPlnMXwBXCLw",12) == 2209416478) strcat(s, "r");
if (crc32("HueLmYWoU",9) == 2396147628) strcat(s, "B");
if (crc32("VdKhVqUoQQ",10) == 2219888263) strcat(s, "b");
if (crc32("qsgquVUnIYBSp",13) == 2391000642) strcat(s, "S");
if (crc32("ejHdiiNcGbDaJ",13) == 704275484) strcat(s, "o");
if (crc32("rCKdHkOde",9) == 724517759) strcat(s, "y");
if (crc32("PXNZXoz",7) == 755836415) strcat(s, "r");
if (crc32("dkbRq",5) == 2724935584) strcat(s, "n");
if (crc32("rxTQgJIZvwfy",12) == 2514048110) strcat(s, "g");
if (crc32("NKoVspYTwpkuDFE",15) == 3722668569) strcat(s, "e");
    return s;
}

char *magnified_verbs() {
    char *s = calloc(10);
    if (crc32("sOaYxfUVMIafRTW",15) == 959715445) strcat(s, "l");
if (crc32("fHmPvHWKwqIyW",13) == 2747128424) strcat(s, "m");
if (crc32("SrUhaERgnDp",11) == 2425023841) strcat(s, "R");
if (crc32("TPQfViBVyDy",11) == 740207621) strcat(s, "a");
if (crc32("TcyzR",5) == 699872384) strcat(s, "g");
if (crc32("RuQKcjCcDDoeIGw",15) == 164942801) strcat(s, "W");
if (crc32("mwqdnKDD",8) == 3915212502) strcat(s, "n");
if (crc32("qZgRJe",6) == 586100454) strcat(s, "G");
if (crc32("SNRNZFjvF",9) == 2141163240) strcat(s, "i");
if (crc32("fyxfcjaqpdfMQiL",15) == 1452138019) strcat(s, "f");
if (crc32("lLfMnAR",7) == 3187831442) strcat(s, "l");
if (crc32("KlFPTvRO",8) == 3324833337) strcat(s, "i");
if (crc32("sKcyLG",6) == 3583010972) strcat(s, "e");
if (crc32("AmNsMYYaUSi",11) == 2930621699) strcat(s, "s");
if (crc32("MyeAGDFm",8) == 2005975619) strcat(s, "d");
    return s;
}

char *splutter_verbs() {
    char *s = calloc(9);
    if (crc32("fWepahLIes",10) == 4082121692) strcat(s, "M");
if (crc32("VevbMXFhrRz",11) == 1581089738) strcat(s, "s");
if (crc32("MaCXKSvnOlPAcfE",15) == 2182621197) strcat(s, "p");
if (crc32("kTofTHEJw",9) == 1804940098) strcat(s, "l");
if (crc32("kowUZ",5) == 1447639354) strcat(s, "u");
if (crc32("ljOfELTgkZblswK",15) == 1678254663) strcat(s, "t");
if (crc32("xHmsyhSrZ",9) == 3267399764) strcat(s, "t");
if (crc32("eRBgwuZvnYy",11) == 2475805842) strcat(s, "e");
if (crc32("iCytNyqjMnK",11) == 2192549236) strcat(s, "W");
if (crc32("IQMxujiqNMvK",12) == 4107126896) strcat(s, "r");
    return s;
}

char *govern_verbs() {
    char *s = calloc(7);
    if (crc32("KbtntO",6) == 1015762483) strcat(s, "g");
if (crc32("JWcxIUuQGnVe",12) == 230622099) strcat(s, "o");
if (crc32("ugPnEScPyOJlCvd",15) == 4136320127) strcat(s, "d");
if (crc32("jgCvszAuL",9) == 3145239062) strcat(s, "v");
if (crc32("QycGlqxn",8) == 508883995) strcat(s, "d");
if (crc32("zyVXK",5) == 2552954147) strcat(s, "e");
if (crc32("nrPQfmX",7) == 2987694270) strcat(s, "r");
if (crc32("ipmhCjLUMFnX",12) == 3220041151) strcat(s, "D");
if (crc32("ZrWASQUHLn",10) == 3582190122) strcat(s, "n");
    return s;
}

char *mooed_verbs() {
    char *s = calloc(6);
    if (crc32("ZSujqRUPZCfCJEH",15) == 3296951222) strcat(s, "R");
if (crc32("nOOCaFz",7) == 3020929410) strcat(s, "m");
if (crc32("MFgOF",5) == 2113406670) strcat(s, "o");
if (crc32("jPqCdMmAwrGHKIK",15) == 3427933942) strcat(s, "y");
if (crc32("GuvPTWFGarF",11) == 2395593861) strcat(s, "o");
if (crc32("cxWgJpOnCMU",11) == 1293329136) strcat(s, "G");
if (crc32("GaxFqbeEjBHjWPV",15) == 896260281) strcat(s, "e");
if (crc32("uqPiNGog",8) == 1974442802) strcat(s, "R");
if (crc32("eBPpPyvxHscgKk",14) == 1719597129) strcat(s, "d");
    return s;
}

char *overhang_verbs() {
    char *s = calloc(9);
    if (crc32("juqwq",5) == 1527669923) strcat(s, "o");
if (crc32("IuxVdX",6) == 2076589335) strcat(s, "s");
if (crc32("AMedgLxFmnlvIB",14) == 4264433738) strcat(s, "v");
if (crc32("RJfyqhCUKL",10) == 837670914) strcat(s, "m");
if (crc32("fjPuqLRpZmyv",12) == 4110460890) strcat(s, "e");
if (crc32("nHBggvnQdz",10) == 1732115184) strcat(s, "E");
if (crc32("aeuRrqdXZoHDnKA",15) == 966237333) strcat(s, "r");
if (crc32("wbdQLbNbNWG",11) == 2850743052) strcat(s, "F");
if (crc32("AQplHkwXPlVy",12) == 122207908) strcat(s, "h");
if (crc32("DJOun",5) == 477936348) strcat(s, "a");
if (crc32("eFqRaKGQGbDDPO",14) == 99625696) strcat(s, "S");
if (crc32("vJunCdK",7) == 3298818504) strcat(s, "n");
if (crc32("hdHvDdiVncsQ",12) == 2026027566) strcat(s, "g");
    return s;
}

char *rifled_verbs() {
    char *s = calloc(7);
    if (crc32("mpGErfy",7) == 2424428616) strcat(s, "j");
if (crc32("ugnVJPK",7) == 3625011992) strcat(s, "r");
if (crc32("ktirRHoRgy",10) == 337148735) strcat(s, "O");
if (crc32("wDNJNRid",8) == 3203505409) strcat(s, "i");
if (crc32("yIgpOxYvoOaBPUk",15) == 170877211) strcat(s, "U");
if (crc32("AUWPmXL",7) == 795518490) strcat(s, "f");
if (crc32("IEANGy",6) == 2642827116) strcat(s, "t");
if (crc32("MpVbdvFKqZC",11) == 3489836234) strcat(s, "l");
if (crc32("KtUwwl",6) == 1360551428) strcat(s, "e");
if (crc32("pXaTv",5) == 535682513) strcat(s, "d");
    return s;
}

char *comminuting_verbs() {
    char *s = calloc(12);
    if (crc32("fgKBqdutcJsI",12) == 1146747797) strcat(s, "c");
if (crc32("lbHpbJCSfH",10) == 3075514585) strcat(s, "o");
if (crc32("DjsOpY",6) == 991814139) strcat(s, "E");
if (crc32("amdXAeNrFn",10) == 2170125890) strcat(s, "m");
if (crc32("lKtSbaCLDIp",11) == 919129083) strcat(s, "m");
if (crc32("BcxoJj",6) == 1731276030) strcat(s, "i");
if (crc32("aKjhl",5) == 2181428470) strcat(s, "n");
if (crc32("VkNMK",5) == 3160320754) strcat(s, "r");
if (crc32("nFkGnCrCJoGUSa",14) == 3971465578) strcat(s, "u");
if (crc32("waZSTnDBouDYF",13) == 2272915206) strcat(s, "I");
if (crc32("vwUZWS",6) == 3173772427) strcat(s, "t");
if (crc32("twSXiJJof",9) == 2228065320) strcat(s, "g");
if (crc32("EFRejXMqCcMC",12) == 162148123) strcat(s, "i");
if (crc32("xoSGG",5) == 879314855) strcat(s, "w");
if (crc32("MNaxHaRCSNbQgj",14) == 625158931) strcat(s, "n");
if (crc32("kNiuYGW",7) == 3222724933) strcat(s, "g");
    return s;
}

char *metathesize_verbs() {
    char *s = calloc(12);
    if (crc32("CyvpRRZy",8) == 879149811) strcat(s, "A");
if (crc32("YfbQYFskAPq",11) == 2389452801) strcat(s, "m");
if (crc32("VybEn",5) == 2265796133) strcat(s, "H");
if (crc32("PZefQcMcZND",11) == 1093468184) strcat(s, "e");
if (crc32("XAPXCsVSPuBgtTl",15) == 3295571715) strcat(s, "t");
if (crc32("zDJjxQzd",8) == 1845235899) strcat(s, "o");
if (crc32("XniUMbyO",8) == 3721600923) strcat(s, "a");
if (crc32("yVKRgXZ",7) == 2294362988) strcat(s, "m");
if (crc32("UvAHBPpJjihEiCf",15) == 1827463845) strcat(s, "t");
if (crc32("gkUTCOagvR",10) == 2780187697) strcat(s, "h");
if (crc32("djwDuWTNGfLcTE",14) == 3258143082) strcat(s, "e");
if (crc32("AHktBTN",7) == 2852779340) strcat(s, "s");
if (crc32("XSmbRfjDBmPojv",14) == 568015502) strcat(s, "i");
if (crc32("HVlbvMfseWePFj",14) == 88816659) strcat(s, "l");
if (crc32("WowAvrtBvwUGll",14) == 2980438813) strcat(s, "z");
if (crc32("KDpZJdLFprexxbK",15) == 324109933) strcat(s, "C");
if (crc32("RmZdzT",6) == 3281924872) strcat(s, "e");
    return s;
}

char *structured_verbs() {
    char *s = calloc(11);
    if (crc32("ZWiPWjpG",8) == 2219024943) strcat(s, "s");
if (crc32("PaaNeygOfGNgj",13) == 1873085631) strcat(s, "R");
if (crc32("mSPsvTKtb",9) == 2553430941) strcat(s, "t");
if (crc32("dMalPQSDRn",10) == 3244144333) strcat(s, "r");
if (crc32("sEmgnS",6) == 565165545) strcat(s, "u");
if (crc32("fSnZFohhY",9) == 2558266166) strcat(s, "L");
if (crc32("lLdyPhpcLMExuWZ",15) == 4198498187) strcat(s, "c");
if (crc32("SnsjN",5) == 984218501) strcat(s, "t");
if (crc32("pLPLUYCBncZRfF",14) == 2924180928) strcat(s, "V");
if (crc32("tieOcblx",8) == 618299970) strcat(s, "u");
if (crc32("NYWfginsrnn",11) == 1771860513) strcat(s, "s");
if (crc32("cxNjPY",6) == 1619501733) strcat(s, "r");
if (crc32("mxUgIUBo",8) == 355691764) strcat(s, "e");
if (crc32("PHHwICGFVRlCN",13) == 2560330632) strcat(s, "F");
if (crc32("ANepjYT",7) == 848342792) strcat(s, "d");
    return s;
}

char *vaccinating_verbs() {
    char *s = calloc(12);
    if (crc32("guZlNYmAAhnl",12) == 1035863604) strcat(s, "v");
if (crc32("wGPrYgLBAqGu",12) == 69793173) strcat(s, "a");
if (crc32("sPqivEeRD",9) == 1922929537) strcat(s, "c");
if (crc32("EbeqEXLyINs",11) == 1326464491) strcat(s, "c");
if (crc32("QibvxiP",7) == 522518640) strcat(s, "c");
if (crc32("ELlGCF",6) == 426376962) strcat(s, "u");
if (crc32("mUAfpqXBvXcP",12) == 3072420923) strcat(s, "i");
if (crc32("FjAnUMPqx",9) == 1820131130) strcat(s, "T");
if (crc32("JgiJyqsMeJpqenE",15) == 3382678077) strcat(s, "n");
if (crc32("YgXwXrModYHGc",13) == 2197730347) strcat(s, "M");
if (crc32("CdbAKe",6) == 2594100106) strcat(s, "a");
if (crc32("lHShItPBHsUgEMZ",15) == 1740885241) strcat(s, "t");
if (crc32("PaAXmNg",7) == 670231715) strcat(s, "X");
if (crc32("ZSSjTM",6) == 690386158) strcat(s, "i");
if (crc32("TghpFxtbROgE",12) == 2320875173) strcat(s, "O");
if (crc32("gfyPJHF",7) == 3893224944) strcat(s, "n");
if (crc32("IXrYAK",6) == 1470437711) strcat(s, "x");
if (crc32("gQZBmORZZtvkH",13) == 2805347562) strcat(s, "g");
    return s;
}

char *hatchel_verbs() {
    char *s = calloc(8);
    if (crc32("vzJyLJvcZtZ",11) == 3078089684) strcat(s, "h");
if (crc32("WOYuEFl",7) == 2021967665) strcat(s, "a");
if (crc32("PnMOOP",6) == 2507941979) strcat(s, "t");
if (crc32("eLKlWmdQVR",10) == 345295377) strcat(s, "c");
if (crc32("wdlMj",5) == 3763600860) strcat(s, "r");
if (crc32("acqfNLAMHDv",11) == 48795287) strcat(s, "h");
if (crc32("eGhNrCOUMTBAmkr",15) == 197607072) strcat(s, "e");
if (crc32("ojWbn",5) == 501841321) strcat(s, "l");
    return s;
}

char *overintellectualize_verbs() {
    char *s = calloc(20);
    if (crc32("NTFyeZjeGBXXj",13) == 2753846827) strcat(s, "Q");
if (crc32("SsDqBMLCqpPfJJ",14) == 486638694) strcat(s, "o");
if (crc32("TtIDOGK",7) == 3680522541) strcat(s, "X");
if (crc32("iCsPw",5) == 4190927408) strcat(s, "v");
if (crc32("JHhLcmSVgGlDQt",14) == 1450080689) strcat(s, "e");
if (crc32("HIOWddtO",8) == 3678254886) strcat(s, "a");
if (crc32("tSdkyIJzWbC",11) == 1843015397) strcat(s, "r");
if (crc32("PxDKl",5) == 1889545732) strcat(s, "i");
if (crc32("dzmfp",5) == 1192858177) strcat(s, "m");
if (crc32("xUfXLKNVItDi",12) == 3937006794) strcat(s, "n");
if (crc32("tbzYKYbyzfaOaO",14) == 215902666) strcat(s, "t");
if (crc32("MZZxxvLGuio",11) == 3443742236) strcat(s, "q");
if (crc32("OseSl",5) == 4270136792) strcat(s, "e");
if (crc32("cTVnvGwtUTTrb",13) == 2339591455) strcat(s, "x");
if (crc32("GWWFXJqr",8) == 2645238270) strcat(s, "l");
if (crc32("HrHDiwbN",8) == 55567910) strcat(s, "L");
if (crc32("zLebSJABaUsp",12) == 1287547138) strcat(s, "l");
if (crc32("FjFUrQtqIUY",11) == 3929349246) strcat(s, "e");
if (crc32("OtyIiLfUfB",10) == 776953680) strcat(s, "c");
if (crc32("edUwdxKTKrQeZ",13) == 2515977232) strcat(s, "t");
if (crc32("MZFQCXqDgBID",12) == 3863311073) strcat(s, "u");
if (crc32("PhyYfPRlW",9) == 1260696956) strcat(s, "a");
if (crc32("JlsyQ",5) == 297241242) strcat(s, "l");
if (crc32("BvrgIHAdKtOEE",13) == 391458056) strcat(s, "Y");
if (crc32("dTIyeHK",7) == 2716630169) strcat(s, "i");
if (crc32("qPFeReVgguPNRw",14) == 344514564) strcat(s, "m");
if (crc32("Rknqw",5) == 3537523126) strcat(s, "z");
if (crc32("TfsOUnUFJMDeSHx",15) == 161649347) strcat(s, "e");
    return s;
}

char *exploding_verbs() {
    char *s = calloc(10);
    if (crc32("DRuJnuUjHZfvKL",14) == 2618429675) strcat(s, "e");
if (crc32("oztfxAqMMKeB",12) == 3326729331) strcat(s, "r");
if (crc32("pFnHGFLWw",9) == 3614276536) strcat(s, "x");
if (crc32("vVdYy",5) == 3177508598) strcat(s, "S");
if (crc32("gfjptdx",7) == 3118078211) strcat(s, "p");
if (crc32("PUVzzcJpnR",10) == 325196513) strcat(s, "l");
if (crc32("gdfzBcIrSWOYB",13) == 157625376) strcat(s, "X");
if (crc32("lJxNvYyPM",9) == 666315658) strcat(s, "o");
if (crc32("ZfUNTgtzBNS",11) == 2630236993) strcat(s, "s");
if (crc32("WfjHchGzPFU",11) == 3036193720) strcat(s, "d");
if (crc32("gjHkOykoIgl",11) == 1046226384) strcat(s, "i");
if (crc32("EofgAmpsvGwofTT",15) == 2889932771) strcat(s, "n");
if (crc32("WJwPCDSGkbDIDiL",15) == 560016447) strcat(s, "g");
    return s;
}

char *kept_verbs() {
    char *s = calloc(5);
    if (crc32("unhddkLcnKSZEtN",15) == 3159467743) strcat(s, "k");
if (crc32("gvBLwGDI",8) == 2696644276) strcat(s, "V");
if (crc32("ERZEGGzbabHS",12) == 541127233) strcat(s, "e");
if (crc32("tUmXrVRQKVHMV",13) == 1430419450) strcat(s, "p");
if (crc32("BUfNOvUMWVEoek",14) == 2046376853) strcat(s, "p");
if (crc32("WjYeEg",6) == 3007825021) strcat(s, "H");
if (crc32("eRsmYLHWytblhM",14) == 1291717178) strcat(s, "t");
    return s;
}

char *dabbled_verbs() {
    char *s = calloc(8);
    if (crc32("akhZbRPjhBCV",12) == 3015912990) strcat(s, "d");
if (crc32("qWGUSjJmDmKwmP",14) == 94039748) strcat(s, "a");
if (crc32("AswqVoWh",8) == 1443754765) strcat(s, "Y");
if (crc32("uKFfQbC",7) == 1513980643) strcat(s, "b");
if (crc32("RqhCfdalhO",10) == 4098957113) strcat(s, "b");
if (crc32("aokeXjRKPCqG",12) == 4153994703) strcat(s, "Y");
if (crc32("oZmBRzzEMABph",13) == 462319014) strcat(s, "l");
if (crc32("ZkCAiRIO",8) == 3994513675) strcat(s, "p");
if (crc32("oHnVmAABiWj",11) == 1197380328) strcat(s, "e");
if (crc32("yGBqKEGmoElHlj",14) == 90017626) strcat(s, "e");
if (crc32("FmeMGNTLvQ",10) == 3450686651) strcat(s, "d");
    return s;
}

char *underestimate_verbs() {
    char *s = calloc(14);
    if (crc32("lRKRTwlWbaWpqt",14) == 2620549608) strcat(s, "S");
if (crc32("cIamctttR",9) == 2342477100) strcat(s, "u");
if (crc32("AiZMkoZAJIcKZpY",15) == 1276898234) strcat(s, "n");
if (crc32("WScxFdlrn",9) == 2643195668) strcat(s, "P");
if (crc32("XlRmFbkbqk",10) == 2143246227) strcat(s, "d");
if (crc32("HPFMNdnY",8) == 1914188680) strcat(s, "M");
if (crc32("wtcKYLmmQdAiJRJ",15) == 2093048070) strcat(s, "e");
if (crc32("SlMrPLVVtSVZ",12) == 3713793261) strcat(s, "W");
if (crc32("PaLVeDM",7) == 3692081639) strcat(s, "r");
if (crc32("ZaSejYjJbGPrkn",14) == 997477355) strcat(s, "e");
if (crc32("buXOAlW",7) == 1554109866) strcat(s, "s");
if (crc32("kxSBOm",6) == 337052691) strcat(s, "f");
if (crc32("VbaiKDsIIcdUyFB",15) == 1192938213) strcat(s, "t");
if (crc32("smbnNyzozroy",12) == 2659518725) strcat(s, "i");
if (crc32("GEgxTdWpcl",10) == 1370074986) strcat(s, "m");
if (crc32("GdtAJE",6) == 1443399766) strcat(s, "m");
if (crc32("kFmSg",5) == 2498761919) strcat(s, "a");
if (crc32("feKRNtjuCO",10) == 3953929863) strcat(s, "t");
if (crc32("oYzqHGHzBdNdSs",14) == 3010460809) strcat(s, "e");
    return s;
}

char *eavesdropping_verbs() {
    char *s = calloc(14);
    if (crc32("PZFtDVSWlZu",11) == 3072807748) strcat(s, "s");
if (crc32("bUEFer",6) == 2052168134) strcat(s, "e");
if (crc32("hDmvJhAFOwGkbFv",15) == 3797288149) strcat(s, "Z");
if (crc32("BwQJZmhrUSDwd",13) == 2491924677) strcat(s, "a");
if (crc32("VfZgirs",7) == 1150630969) strcat(s, "v");
if (crc32("eUAFIibTiHPv",12) == 2232696836) strcat(s, "e");
if (crc32("ySXazLjwEL",10) == 3387969555) strcat(s, "s");
if (crc32("PxelxpvF",8) == 342265207) strcat(s, "A");
if (crc32("FwsFXT",6) == 818464956) strcat(s, "d");
if (crc32("qMMLCQDeWLv",11) == 4049805830) strcat(s, "r");
if (crc32("AeXVFineILnXD",13) == 1456063430) strcat(s, "T");
if (crc32("dftfFHiE",8) == 760970149) strcat(s, "o");
if (crc32("bxlbFwJy",8) == 2291955739) strcat(s, "F");
if (crc32("WrlQZkdhu",9) == 3382375351) strcat(s, "p");
if (crc32("pzZHaDlTdlaPk",13) == 3538888198) strcat(s, "h");
if (crc32("CSzscr",6) == 3847475967) strcat(s, "p");
if (crc32("qVugyosbBqC",11) == 728133163) strcat(s, "G");
if (crc32("VYdxtOTwYSP",11) == 2222302839) strcat(s, "i");
if (crc32("QOXOYoaJHu",10) == 1447871832) strcat(s, "n");
if (crc32("JrKevImoV",9) == 3977866674) strcat(s, "g");
    return s;
}

char *recap_verbs() {
    char *s = calloc(6);
    if (crc32("HqIKfLnNTmzcjj",14) == 592173493) strcat(s, "r");
if (crc32("YwtBMHw",7) == 2395645915) strcat(s, "e");
if (crc32("INLcuVfGlEh",11) == 3685703871) strcat(s, "c");
if (crc32("jSVZphHmLIrNqOm",15) == 4180977350) strcat(s, "F");
if (crc32("ZAwOQzYyHps",11) == 1879321999) strcat(s, "a");
if (crc32("QvCJRSSgENzGtZ",14) == 1220678786) strcat(s, "f");
if (crc32("lmLWicngASvGMdw",15) == 1957186251) strcat(s, "p");
    return s;
}

char *stumbled_verbs() {
    char *s = calloc(9);
    if (crc32("QbPyL",5) == 3210071898) strcat(s, "s");
if (crc32("BjnRQ",5) == 1713525709) strcat(s, "t");
if (crc32("KwwjXeFuvxpF",12) == 598561086) strcat(s, "u");
if (crc32("halJDajHhXrVHiw",15) == 1594723433) strcat(s, "m");
if (crc32("vZnwHZKAVHxSxbi",15) == 1401988439) strcat(s, "b");
if (crc32("qGELPqjGfnfjXXw",15) == 339131043) strcat(s, "l");
if (crc32("CXMAgaRQP",9) == 1769402987) strcat(s, "e");
if (crc32("AvTiEV",6) == 2628988950) strcat(s, "E");
if (crc32("UItKFYzx",8) == 1090211394) strcat(s, "d");
    return s;
}

char *interwound_verbs() {
    char *s = calloc(11);
    if (crc32("EhUvY",5) == 2835752115) strcat(s, "i");
if (crc32("jQQDWT",6) == 1710538971) strcat(s, "S");
if (crc32("aUldehGPYAyuk",13) == 2809135115) strcat(s, "n");
if (crc32("OhUqalvLkFfwW",13) == 2670874819) strcat(s, "N");
if (crc32("ynicmakvnZ",10) == 3559827872) strcat(s, "t");
if (crc32("hTlAVODBL",9) == 3321796495) strcat(s, "w");
if (crc32("oJTvbZt",7) == 2449032070) strcat(s, "e");
if (crc32("AhqSmHgTyrQU",12) == 2737494124) strcat(s, "A");
if (crc32("AyWvpSKPS",9) == 3012218636) strcat(s, "r");
if (crc32("IyamqYhbaYwkOfB",15) == 872783317) strcat(s, "w");
if (crc32("RrUBtOb",7) == 2208945017) strcat(s, "Z");
if (crc32("CmtZTd",6) == 1221774113) strcat(s, "o");
if (crc32("xLbqRzZu",8) == 1089157037) strcat(s, "u");
if (crc32("NnnMLBalMh",10) == 2880730286) strcat(s, "m");
if (crc32("NlroiMAiY",9) == 3754184407) strcat(s, "n");
if (crc32("wmaaxDMI",8) == 1035015180) strcat(s, "A");
if (crc32("pTaPOrVqeUNAkqt",15) == 3001036609) strcat(s, "d");
    return s;
}

char *missang_verbs() {
    char *s = calloc(8);
    if (crc32("wfjxyjcbjbP",11) == 830583722) strcat(s, "t");
if (crc32("aiEnbtwp",8) == 3967174016) strcat(s, "m");
if (crc32("ztfuxWDugLX",11) == 460566633) strcat(s, "S");
if (crc32("wlFYSBR",7) == 2213781133) strcat(s, "i");
if (crc32("ZiPszGolrTGyWU",14) == 3497959906) strcat(s, "s");
if (crc32("rmmzLnVJQqIRoz",14) == 2196877054) strcat(s, "s");
if (crc32("NsygpyYEWyaB",12) == 1894072508) strcat(s, "a");
if (crc32("itcPdim",7) == 4248597720) strcat(s, "J");
if (crc32("CaYRsm",6) == 1919945402) strcat(s, "n");
if (crc32("KFvCCUb",7) == 3573225497) strcat(s, "D");
if (crc32("aTmotNVq",8) == 1414226569) strcat(s, "g");
    return s;
}

char *mutated_verbs() {
    char *s = calloc(8);
    if (crc32("lKNjYDqQg",9) == 4128124951) strcat(s, "A");
if (crc32("cvdCzWgDNRNNZU",14) == 4022464773) strcat(s, "m");
if (crc32("MWydADQZtsxgH",13) == 3512572478) strcat(s, "u");
if (crc32("FJoKyFXKb",9) == 48862637) strcat(s, "T");
if (crc32("tAWfqlCe",8) == 3699374272) strcat(s, "t");
if (crc32("WfPvGnKrJD",10) == 3751512157) strcat(s, "u");
if (crc32("cvvlgCnfYo",10) == 1472160721) strcat(s, "a");
if (crc32("inrEMWWqaKKVj",13) == 445679698) strcat(s, "t");
if (crc32("uqtNqXanyUG",11) == 3345340497) strcat(s, "j");
if (crc32("aWGalvEXbPF",11) == 1714894152) strcat(s, "e");
if (crc32("ebLqhavoAlShd",13) == 1854551784) strcat(s, "G");
if (crc32("xemoPqMclQzUOpT",15) == 3915846016) strcat(s, "d");
    return s;
}

char *redouble_verbs() {
    char *s = calloc(9);
    if (crc32("nxHKMacMobC",11) == 923493939) strcat(s, "r");
if (crc32("fWwmced",7) == 2238668470) strcat(s, "S");
if (crc32("ldanUTWCWQtIV",13) == 1640227464) strcat(s, "e");
if (crc32("UtaKjKkEVQJDdzQ",15) == 4145333945) strcat(s, "P");
if (crc32("xbWDasiMTeg",11) == 3159520808) strcat(s, "d");
if (crc32("TqSxndpYMTA",11) == 779365292) strcat(s, "o");
if (crc32("hHKELeGdHttePYq",15) == 418690511) strcat(s, "u");
if (crc32("asgIschIPUc",11) == 2787539916) strcat(s, "I");
if (crc32("LORPvReup",9) == 3440501655) strcat(s, "b");
if (crc32("pOqxon",6) == 2072295415) strcat(s, "q");
if (crc32("WZXoTRscPvEUVyO",15) == 1043705161) strcat(s, "l");
if (crc32("TsPrNJmHsI",10) == 1961006533) strcat(s, "F");
if (crc32("loCHcBVxXvxwJoK",15) == 2643517544) strcat(s, "e");
    return s;
}

char *intreat_verbs() {
    char *s = calloc(8);
    if (crc32("TeQUTTBhqRVtm",13) == 3968710391) strcat(s, "i");
if (crc32("ujxNbqomcPrzJF",14) == 1204368665) strcat(s, "n");
if (crc32("BsDFPFHFYpEtXoB",15) == 827400069) strcat(s, "t");
if (crc32("tGqiViZknJTr",12) == 3713871271) strcat(s, "Q");
if (crc32("dWgOPjVNhcH",11) == 785141499) strcat(s, "r");
if (crc32("vmngWg",6) == 941163198) strcat(s, "a");
if (crc32("KCLwlrvr",8) == 3065356827) strcat(s, "e");
if (crc32("CcusyKIkJAERF",13) == 153832155) strcat(s, "a");
if (crc32("DyfXneOJfUhTNf",14) == 2350176545) strcat(s, "S");
if (crc32("BsrRVYSfPsd",11) == 427821315) strcat(s, "t");
    return s;
}

char *huntup_verbs() {
    char *s = calloc(7);
    if (crc32("kRlXw",5) == 3020584943) strcat(s, "h");
if (crc32("EvopCb",6) == 3617176740) strcat(s, "u");
if (crc32("qawNzLtC",8) == 2446712476) strcat(s, "j");
if (crc32("ifQwFTDPSDFhCtW",15) == 675398977) strcat(s, "n");
if (crc32("LIXdRfP",7) == 1904122183) strcat(s, "s");
if (crc32("cyQns",5) == 1368078270) strcat(s, "t");
if (crc32("QzNRRuxFpQhDAC",14) == 3006243911) strcat(s, "w");
if (crc32("kFxvzywyt",9) == 2286923290) strcat(s, "u");
if (crc32("PsmwVrZ",7) == 4066122202) strcat(s, "j");
if (crc32("xIdIj",5) == 715019346) strcat(s, "p");
    return s;
}

char *hocuspocussed_verbs() {
    char *s = calloc(14);
    if (crc32("djOZzMtKoQLz",12) == 801918198) strcat(s, "h");
if (crc32("gouQdPO",7) == 3545295974) strcat(s, "m");
if (crc32("mRFgIZwgG",9) == 216365887) strcat(s, "o");
if (crc32("tZLYj",5) == 2765100817) strcat(s, "l");
if (crc32("hTmqQr",6) == 421663779) strcat(s, "c");
if (crc32("qtyItRPAawYHCE",14) == 1092138329) strcat(s, "u");
if (crc32("Kmxha",5) == 3980277778) strcat(s, "s");
if (crc32("GAKHBgmkaOwIGL",14) == 2286352509) strcat(s, "p");
if (crc32("qMNJw",5) == 1768992217) strcat(s, "f");
if (crc32("ZBoVYGzoaPCtc",13) == 1504135854) strcat(s, "o");
if (crc32("DcxlZaTpQmRv",12) == 1542509599) strcat(s, "c");
if (crc32("dQIZSAxAWOhGEtT",15) == 696079934) strcat(s, "p");
if (crc32("ouaiRZBKyWNL",12) == 4089621368) strcat(s, "u");
if (crc32("UvXKvr",6) == 772515460) strcat(s, "s");
if (crc32("WHcPckgZBhmW",12) == 4114480927) strcat(s, "s");
if (crc32("uuHJptleAgnd",12) == 3415888854) strcat(s, "e");
if (crc32("vkTAXWtAusE",11) == 3763066763) strcat(s, "d");
    return s;
}

char *embowel_verbs() {
    char *s = calloc(8);
    if (crc32("wihUNVWIMr",10) == 628116749) strcat(s, "e");
if (crc32("fkmVzohUrHOFzk",14) == 3968052201) strcat(s, "m");
if (crc32("qrhJn",5) == 637413181) strcat(s, "b");
if (crc32("lsyGKJnphUAFj",13) == 710687524) strcat(s, "o");
if (crc32("DQWdfcUKakLVKF",14) == 620154646) strcat(s, "r");
if (crc32("NfxEOdJoGUP",11) == 2417284791) strcat(s, "w");
if (crc32("PPAYkF",6) == 3693877809) strcat(s, "e");
if (crc32("HTtUsVwee",9) == 850631536) strcat(s, "l");
    return s;
}

char *placed_verbs() {
    char *s = calloc(7);
    if (crc32("eWwFiZXNs",9) == 2853956273) strcat(s, "p");
if (crc32("HOMwDHYbjmcK",12) == 1585884471) strcat(s, "l");
if (crc32("CXjMBvraoWLwdub",15) == 2360612028) strcat(s, "a");
if (crc32("KpdhXPsK",8) == 1082334185) strcat(s, "c");
if (crc32("ygGvkVpBWJCsqcN",15) == 3178183760) strcat(s, "e");
if (crc32("FZzOSnNOpspovA",14) == 693161398) strcat(s, "T");
if (crc32("GYYrXHrLQ",9) == 2804071342) strcat(s, "d");
    return s;
}

char *rediffusing_verbs() {
    char *s = calloc(12);
    if (crc32("wFofLj",6) == 2934106555) strcat(s, "r");
if (crc32("LfMgpEMrAU",10) == 3819302712) strcat(s, "e");
if (crc32("UTqBFTj",7) == 4202605819) strcat(s, "x");
if (crc32("UWBqhvHcoTlp",12) == 3549285618) strcat(s, "d");
if (crc32("azMFan",6) == 177070617) strcat(s, "i");
if (crc32("hiFyokSSUOko",12) == 4287848761) strcat(s, "o");
if (crc32("VGnbsujKsOnT",12) == 1705808606) strcat(s, "f");
if (crc32("aBmbvMwxSjVNP",13) == 3527665966) strcat(s, "g");
if (crc32("OCWeXcodAzhvN",13) == 43928711) strcat(s, "f");
if (crc32("nOemfSmUApP",11) == 1641734871) strcat(s, "y");
if (crc32("pzcdifr",7) == 2076270757) strcat(s, "u");
if (crc32("oWFALRNPCOTffd",14) == 3033335738) strcat(s, "H");
if (crc32("PEosAb",6) == 1383280897) strcat(s, "s");
if (crc32("WTKCVpbPz",9) == 1413338637) strcat(s, "k");
if (crc32("yvezXVZbqGpkKeS",15) == 2963545156) strcat(s, "i");
if (crc32("NPGhbDLcciM",11) == 635678756) strcat(s, "n");
if (crc32("GWfHyrrlFY",10) == 2641825923) strcat(s, "J");
if (crc32("hlzoX",5) == 3223568386) strcat(s, "g");
    return s;
}

char *disincline_verbs() {
    char *s = calloc(11);
    if (crc32("pqfIc",5) == 1428792087) strcat(s, "d");
if (crc32("CmlWbenauLaCoJ",14) == 2984331454) strcat(s, "i");
if (crc32("jvEcd",5) == 3460086831) strcat(s, "p");
if (crc32("DfJeXLgWkZkI",12) == 4044492386) strcat(s, "s");
if (crc32("VJvySOts",8) == 2110888608) strcat(s, "L");
if (crc32("ErZXHxEOoWRQ",12) == 746162901) strcat(s, "i");
if (crc32("AsIYKQQDGDp",11) == 968962677) strcat(s, "F");
if (crc32("WERht",5) == 1974461085) strcat(s, "n");
if (crc32("RNXFn",5) == 670206333) strcat(s, "w");
if (crc32("PSuSuCfLCrlJz",13) == 947490254) strcat(s, "c");
if (crc32("bLaPYMkQ",8) == 3688823075) strcat(s, "l");
if (crc32("niPROAgsNPDyFu",14) == 1587742873) strcat(s, "f");
if (crc32("cXzvaSw",7) == 742084525) strcat(s, "i");
if (crc32("uGfHdEk",7) == 1210017999) strcat(s, "k");
if (crc32("DZgjyjknCQoxkD",14) == 2205368989) strcat(s, "n");
if (crc32("GykeERkGqJKVA",13) == 2337717431) strcat(s, "e");
    return s;
}

char *trammed_verbs() {
    char *s = calloc(8);
    if (crc32("KnHnsZgkpYh",11) == 3339542149) strcat(s, "c");
if (crc32("dcJiEhkoPUy",11) == 3369656821) strcat(s, "t");
if (crc32("oLRUcuMuaCk",11) == 945660723) strcat(s, "r");
if (crc32("XJHpLXMHXQ",10) == 2649993899) strcat(s, "R");
if (crc32("LpcLWoQLGPFm",12) == 897266198) strcat(s, "a");
if (crc32("eeBefoMnAxcCFH",14) == 1819444043) strcat(s, "A");
if (crc32("oOWROoJalMkevm",14) == 3082924873) strcat(s, "m");
if (crc32("cOUHNlKCrypnTOE",15) == 1783904664) strcat(s, "m");
if (crc32("CFzSSRCTUY",10) == 270511122) strcat(s, "v");
if (crc32("ndRAFYZZgrrJIrT",15) == 110989487) strcat(s, "e");
if (crc32("nUXBsHOPsRHn",12) == 4274406339) strcat(s, "d");
    return s;
}

char *administrate_verbs() {
    char *s = calloc(13);
    if (crc32("WCFhEACnMbs",11) == 286331621) strcat(s, "a");
if (crc32("XOkfYehb",8) == 1640716077) strcat(s, "h");
if (crc32("bUcXnjAQ",8) == 1807062689) strcat(s, "d");
if (crc32("zYyopZ",6) == 4086404197) strcat(s, "d");
if (crc32("xdIQqAm",7) == 2022588231) strcat(s, "m");
if (crc32("TIAcXnEjntnE",12) == 2177725231) strcat(s, "L");
if (crc32("SuUcY",5) == 3546296263) strcat(s, "i");
if (crc32("JXWfdqLAZ",9) == 1252989661) strcat(s, "b");
if (crc32("MKbxQzrout",10) == 1785577366) strcat(s, "n");
if (crc32("wWXBm",5) == 1196713890) strcat(s, "k");
if (crc32("VkAGG",5) == 3146667890) strcat(s, "i");
if (crc32("ouBDiivqp",9) == 1396789453) strcat(s, "k");
if (crc32("zHmqIz",6) == 2129452379) strcat(s, "s");
if (crc32("oPjXkByE",8) == 3928003306) strcat(s, "T");
if (crc32("ywjdfWglngBKDkw",15) == 4109175773) strcat(s, "t");
if (crc32("AxWzB",5) == 701204322) strcat(s, "r");
if (crc32("JvFvGabw",8) == 724055146) strcat(s, "a");
if (crc32("gFUQipPANGYMC",13) == 1874538596) strcat(s, "t");
if (crc32("vnjSbDvTL",9) == 55058372) strcat(s, "e");
    return s;
}

char *silencing_verbs() {
    char *s = calloc(10);
    if (crc32("RoOBhBQyvvm",11) == 3005844691) strcat(s, "m");
if (crc32("qZiefndvR",9) == 4252316768) strcat(s, "s");
if (crc32("LGlyCVGV",8) == 1032214822) strcat(s, "m");
if (crc32("shNnBVduAwm",11) == 108245052) strcat(s, "i");
if (crc32("RBbzzR",6) == 1246458076) strcat(s, "l");
if (crc32("OwBnzdTuaI",10) == 3715716468) strcat(s, "e");
if (crc32("kvCbhzPHPPArc",13) == 3867176850) strcat(s, "e");
if (crc32("XyYUtXRvyY",10) == 1798293056) strcat(s, "n");
if (crc32("zHSuGjMs",8) == 1529234293) strcat(s, "c");
if (crc32("CmbHqcrjpZ",10) == 662184065) strcat(s, "m");
if (crc32("FSFELJWm",8) == 3150569604) strcat(s, "i");
if (crc32("HqzMkQEsF",9) == 1757945160) strcat(s, "n");
if (crc32("LfRiX",5) == 2473489159) strcat(s, "Q");
if (crc32("gpVrVPZWIpfmKo",14) == 1390156538) strcat(s, "g");
    return s;
}

char *illustrate_verbs() {
    char *s = calloc(11);
    if (crc32("vNDSBJqZcMSDLA",14) == 3102548058) strcat(s, "H");
if (crc32("LGyIpdQ",7) == 1464387647) strcat(s, "i");
if (crc32("rNwBdTYz",8) == 2852846479) strcat(s, "Y");
if (crc32("ZNfAaqhxJsJ",11) == 3201015397) strcat(s, "l");
if (crc32("gZFDVpq",7) == 2402212691) strcat(s, "l");
if (crc32("CfVQRRQDYnDUFWb",15) == 3564403395) strcat(s, "l");
if (crc32("YRYVCqqnSGaH",12) == 3845489641) strcat(s, "K");
if (crc32("HaQREwRNkeWot",13) == 3534784228) strcat(s, "u");
if (crc32("SJJSkOJCw",9) == 977738030) strcat(s, "s");
if (crc32("WfLWBOYUv",9) == 2283642122) strcat(s, "t");
if (crc32("VYzdZdG",7) == 2043417344) strcat(s, "r");
if (crc32("MUFREjtFqFA",11) == 1817676496) strcat(s, "a");
if (crc32("VmfebM",6) == 3889991653) strcat(s, "C");
if (crc32("kDuwX",5) == 1799545447) strcat(s, "t");
if (crc32("bTGCHtEFhNC",11) == 2782471326) strcat(s, "A");
if (crc32("IxnmEdQ",7) == 795608672) strcat(s, "e");
    return s;
}

char *gripping_verbs() {
    char *s = calloc(9);
    if (crc32("SUKDGU",6) == 5172010) strcat(s, "I");
if (crc32("AmUAOZIkSk",10) == 2778794902) strcat(s, "g");
if (crc32("qpGFRyuboLralY",14) == 3343627030) strcat(s, "r");
if (crc32("zmQDsdYTX",9) == 188607508) strcat(s, "r");
if (crc32("DbITM",5) == 3688549153) strcat(s, "m");
if (crc32("UGZWTKbFw",9) == 3375231152) strcat(s, "i");
if (crc32("diOoO",5) == 2474540941) strcat(s, "p");
if (crc32("zTKGu",5) == 4100908464) strcat(s, "b");
if (crc32("EjJgyDCrNtrSXb",14) == 2439215769) strcat(s, "p");
if (crc32("lWsdY",5) == 2309737392) strcat(s, "i");
if (crc32("dojgYZS",7) == 1556146864) strcat(s, "s");
if (crc32("pIOUuT",6) == 2018322996) strcat(s, "n");
if (crc32("pKwxXDNhrP",10) == 919993844) strcat(s, "g");
    return s;
}

char *quarrelled_verbs() {
    char *s = calloc(11);
    if (crc32("XXGDVj",6) == 859693799) strcat(s, "j");
if (crc32("RUTaDi",6) == 2910200571) strcat(s, "q");
if (crc32("SlSOnJCP",8) == 2462225208) strcat(s, "i");
if (crc32("tlRtZQqaD",9) == 2978866799) strcat(s, "u");
if (crc32("nLqvyLEgQXwuP",13) == 1213511237) strcat(s, "a");
if (crc32("FZqbTIRgJeLd",12) == 2475281846) strcat(s, "r");
if (crc32("bUoCtjxRP",9) == 2973376311) strcat(s, "d");
if (crc32("jiimesZ",7) == 26162097) strcat(s, "r");
if (crc32("UhYqoic",7) == 1898544323) strcat(s, "d");
if (crc32("SbWpOWhFHhV",11) == 16428047) strcat(s, "e");
if (crc32("SVwiLm",6) == 1386910967) strcat(s, "l");
if (crc32("MoEwMwnfz",9) == 1472107450) strcat(s, "l");
if (crc32("AFTkTJ",6) == 3930478953) strcat(s, "e");
if (crc32("atfAF",5) == 3165303640) strcat(s, "d");
    return s;
}

char *reacidified_verbs() {
    char *s = calloc(12);
    if (crc32("wxSBdyKRHpi",11) == 414110573) strcat(s, "G");
if (crc32("QrytQpP",7) == 1737574471) strcat(s, "r");
if (crc32("QoSuz",5) == 745960267) strcat(s, "e");
if (crc32("bSjVDOoWKGmDqX",14) == 2978109703) strcat(s, "L");
if (crc32("PTRtmx",6) == 3433966366) strcat(s, "a");
if (crc32("TYgujKjBcwzMLlF",15) == 3133458413) strcat(s, "c");
if (crc32("WSzkjanQybw",11) == 4219101564) strcat(s, "i");
if (crc32("iZUWGnIGNZxDgea",15) == 833888116) strcat(s, "w");
if (crc32("jJtXyXpN",8) == 2522941327) strcat(s, "d");
if (crc32("WznqPxcOt",9) == 719161531) strcat(s, "i");
if (crc32("BeqhWJsHapYoMy",14) == 3523029024) strcat(s, "f");
if (crc32("yqrbZWvF",8) == 312732556) strcat(s, "i");
if (crc32("boaVaOoQqFxVeVi",15) == 1066778421) strcat(s, "w");
if (crc32("dJsLxtYWzOi",11) == 2198521607) strcat(s, "e");
if (crc32("vjKfsdUW",8) == 2155434872) strcat(s, "P");
if (crc32("QvEEBj",6) == 3039899003) strcat(s, "d");
    return s;
}

char *exsiccated_verbs() {
    char *s = calloc(11);
    if (crc32("PtMALQUgp",9) == 3743840945) strcat(s, "O");
if (crc32("POKqa",5) == 1293421541) strcat(s, "e");
if (crc32("UWilxjLu",8) == 1043869341) strcat(s, "r");
if (crc32("eGAeayQnibjBfXB",15) == 1994256081) strcat(s, "x");
if (crc32("HpPLJEUF",8) == 942985571) strcat(s, "s");
if (crc32("PPXaenPFtlGiGy",14) == 2664469324) strcat(s, "i");
if (crc32("UgYeLPs",7) == 3401352561) strcat(s, "c");
if (crc32("qaoysvqjpuIDxE",14) == 1829845150) strcat(s, "u");
if (crc32("ZZmvPwKhstmnjM",14) == 3420354105) strcat(s, "c");
if (crc32("tXfOMs",6) == 3225557394) strcat(s, "a");
if (crc32("zCAcclQKx",9) == 3351639475) strcat(s, "t");
if (crc32("PPCCCsdGNxcFDn",14) == 27825683) strcat(s, "e");
if (crc32("hVdydf",6) == 1355060166) strcat(s, "e");
if (crc32("kTBma",5) == 4116132926) strcat(s, "d");
    return s;
}

char *reverberating_verbs() {
    char *s = calloc(14);
    if (crc32("dAExSBtMNOyB",12) == 757121151) strcat(s, "y");
if (crc32("LDuEE",5) == 2530552283) strcat(s, "r");
if (crc32("zJoQvJipNl",10) == 1890163101) strcat(s, "B");
if (crc32("DwaZIYtvzmeXl",13) == 3803113916) strcat(s, "e");
if (crc32("YdvqCvvVHfVgwjT",15) == 1268705243) strcat(s, "J");
if (crc32("pvsKKeWpUgR",11) == 3921418917) strcat(s, "v");
if (crc32("gEMZsluRwxRIhSA",15) == 2135147032) strcat(s, "k");
if (crc32("hRirk",5) == 2383110067) strcat(s, "e");
if (crc32("GqpGKZoZVXRHeO",14) == 1349787057) strcat(s, "G");
if (crc32("bpqHqTijAJfHJqG",15) == 525152568) strcat(s, "r");
if (crc32("SfmtjVerZk",10) == 312232983) strcat(s, "b");
if (crc32("SCtwFlrLXTNhc",13) == 1246521718) strcat(s, "Y");
if (crc32("LghjvGU",7) == 44743713) strcat(s, "e");
if (crc32("ALyDzWrYefslGF",14) == 212044074) strcat(s, "r");
if (crc32("hVpqxXzacFAPQW",14) == 494906312) strcat(s, "k");
if (crc32("XcEyeCOPaco",11) == 789889037) strcat(s, "a");
if (crc32("tQcTdAaSXdW",11) == 2534303684) strcat(s, "t");
if (crc32("iZMcuuTACgLwMwV",15) == 2006914348) strcat(s, "i");
if (crc32("stIJuLv",7) == 3330647749) strcat(s, "n");
if (crc32("hEyRSCvrjytBRDV",15) == 3585080555) strcat(s, "g");
if (crc32("WkhYzPNRsDSHk",13) == 3468476486) strcat(s, "g");
    return s;
}

char *sawing_verbs() {
    char *s = calloc(7);
    if (crc32("Gupma",5) == 3456569246) strcat(s, "s");
if (crc32("LeBxGJiVVXAeBgj",15) == 2267068732) strcat(s, "a");
if (crc32("rgigcHipq",9) == 648336695) strcat(s, "w");
if (crc32("VeVlOvfcWrkXHGm",15) == 2322751099) strcat(s, "i");
if (crc32("GYDvP",5) == 4261481834) strcat(s, "b");
if (crc32("PNnLe",5) == 2795988012) strcat(s, "n");
if (crc32("kNgyHivIw",9) == 3131531198) strcat(s, "C");
if (crc32("HyUUGrL",7) == 3711142600) strcat(s, "g");
    return s;
}

char *colleting_verbs() {
    char *s = calloc(10);
    if (crc32("PeoZTJeZmSFXiB",14) == 4205984615) strcat(s, "c");
if (crc32("bfHXmtAKMqqqaN",14) == 2726716058) strcat(s, "z");
if (crc32("ZJEsNztHT",9) == 3333558894) strcat(s, "o");
if (crc32("gDqmTiVspRLL",12) == 2037347295) strcat(s, "l");
if (crc32("VGtGwAq",7) == 1518034583) strcat(s, "l");
if (crc32("NzgBcaGHE",9) == 1789451465) strcat(s, "Q");
if (crc32("MLTsiMHjR",9) == 1953001414) strcat(s, "e");
if (crc32("EzNEyMktbCGWCO",14) == 226724904) strcat(s, "H");
if (crc32("PKaft",5) == 2684239865) strcat(s, "t");
if (crc32("zUtJGb",6) == 2275856383) strcat(s, "N");
if (crc32("nNcJMToJGDWujj",14) == 2655819578) strcat(s, "i");
if (crc32("gxlZAHWGglsE",12) == 3505509948) strcat(s, "X");
if (crc32("TblzTNHcyG",10) == 2618581529) strcat(s, "n");
if (crc32("ZaWoLOiWcuEPl",13) == 1079684588) strcat(s, "D");
if (crc32("DbFmwtEf",8) == 3769643963) strcat(s, "g");
    return s;
}

char *meant_verbs() {
    char *s = calloc(6);
    if (crc32("ygRlcC",6) == 925993940) strcat(s, "m");
if (crc32("bSzLvbh",7) == 3288490794) strcat(s, "z");
if (crc32("hmxcucOVYp",10) == 1547340539) strcat(s, "e");
if (crc32("VWdtMFaPZO",10) == 542182381) strcat(s, "a");
if (crc32("rjuoWoXTmBLO",12) == 2647332907) strcat(s, "n");
if (crc32("nxYeIjdPI",9) == 410262771) strcat(s, "t");
    return s;
}

char *tarries_verbs() {
    char *s = calloc(8);
    if (crc32("dierLIg",7) == 3597077795) strcat(s, "t");
if (crc32("yWLfCgALEuQg",12) == 114223891) strcat(s, "a");
if (crc32("PBrPBOnG",8) == 3295994799) strcat(s, "r");
if (crc32("YwSIlbaeE",9) == 1053031850) strcat(s, "r");
if (crc32("NlqkxKJFnNqEJ",13) == 1726415647) strcat(s, "i");
if (crc32("lshPrnzYmaBzMw",14) == 947418218) strcat(s, "e");
if (crc32("SDOdVqW",7) == 3731166464) strcat(s, "s");
    return s;
}

char *puttied_verbs() {
    char *s = calloc(8);
    if (crc32("LOjlDDKEpFLmH",13) == 2369211522) strcat(s, "m");
if (crc32("uNfALCACpMVgYsw",15) == 1305229745) strcat(s, "p");
if (crc32("FwLRQXqigjlAIV",14) == 520261783) strcat(s, "f");
if (crc32("xMrOmzMgtqzDwU",14) == 2661228025) strcat(s, "u");
if (crc32("CVYPyWzeekdeEe",14) == 2554596786) strcat(s, "t");
if (crc32("RjcHBKy",7) == 718180511) strcat(s, "u");
if (crc32("fyVfhmrdskqHriY",15) == 227035930) strcat(s, "t");
if (crc32("jmpqbrhCxs",10) == 178713280) strcat(s, "i");
if (crc32("tRkaRsKYkuLsLgl",15) == 3451274027) strcat(s, "e");
if (crc32("CotpyzgKikqs",12) == 999768799) strcat(s, "s");
if (crc32("WxSOJA",6) == 3235417818) strcat(s, "d");
    return s;
}

char *denitrify_verbs() {
    char *s = calloc(10);
    if (crc32("RDwsMUaLPEsG",12) == 3700936564) strcat(s, "d");
if (crc32("HBkHbbwGg",9) == 2482106560) strcat(s, "m");
if (crc32("LttOkgH",7) == 1466470851) strcat(s, "e");
if (crc32("RaNLF",5) == 3189555126) strcat(s, "n");
if (crc32("OXFxpsrlpN",10) == 4264844031) strcat(s, "i");
if (crc32("nYdfMdPvaGmZgHt",15) == 4253398589) strcat(s, "t");
if (crc32("xYgNUQXJeLY",11) == 1908566260) strcat(s, "J");
if (crc32("hBKiykgnP",9) == 3331700055) strcat(s, "r");
if (crc32("DDCMvTPvDbRYiGW",15) == 3545270025) strcat(s, "i");
if (crc32("MuvWPbftZwvD",12) == 3508705544) strcat(s, "f");
if (crc32("BpluLjrEt",9) == 2943347294) strcat(s, "q");
if (crc32("KOroyBKBHG",10) == 4135400090) strcat(s, "y");
    return s;
}

char *overinclining_verbs() {
    char *s = calloc(14);
    if (crc32("YmzrsuiL",8) == 1045820710) strcat(s, "a");
if (crc32("FapLrtNdfC",10) == 3054665431) strcat(s, "o");
if (crc32("LPwaRsiycppRSe",14) == 1872089821) strcat(s, "v");
if (crc32("fhCEtCQtGDi",11) == 853528490) strcat(s, "e");
if (crc32("WyzUvRerqq",10) == 2101087204) strcat(s, "r");
if (crc32("nNYGXkurpS",10) == 700939988) strcat(s, "i");
if (crc32("fVeTtaLjdxw",11) == 3560627258) strcat(s, "n");
if (crc32("TPXOWRj",7) == 3245693417) strcat(s, "c");
if (crc32("HxtdoqpPbRV",11) == 2188879632) strcat(s, "O");
if (crc32("TYMRQCLPOMIphr",14) == 4238120091) strcat(s, "l");
if (crc32("UHcSbVYOrsvV",12) == 2374805594) strcat(s, "i");
if (crc32("blxhi",5) == 2542311984) strcat(s, "n");
if (crc32("kWwssS",6) == 1603594469) strcat(s, "U");
if (crc32("JeBcmU",6) == 4262274506) strcat(s, "i");
if (crc32("RmWDqyqFFpP",11) == 4162071065) strcat(s, "n");
if (crc32("wdwucIfDY",9) == 2788993229) strcat(s, "g");
    return s;
}

char *dredged_verbs() {
    char *s = calloc(8);
    if (crc32("QHwgbV",6) == 3888718182) strcat(s, "P");
if (crc32("KDUdTxDz",8) == 2871569231) strcat(s, "d");
if (crc32("ZprzsVn",7) == 54506700) strcat(s, "O");
if (crc32("MwZMDZnt",8) == 709412505) strcat(s, "r");
if (crc32("lOvQIbA",7) == 944802506) strcat(s, "J");
if (crc32("BTTaEiFrLrLhmVv",15) == 2340759985) strcat(s, "e");
if (crc32("lnGykqiajNQ",11) == 1535743500) strcat(s, "m");
if (crc32("mPDtptc",7) == 4189378478) strcat(s, "d");
if (crc32("SxHza",5) == 1178806501) strcat(s, "Z");
if (crc32("WjlcmENzOdktD",13) == 3148705985) strcat(s, "g");
if (crc32("ZpBypp",6) == 6711144) strcat(s, "f");
if (crc32("hOxKyxiPwL",10) == 3374434358) strcat(s, "e");
if (crc32("VdZZP",5) == 3666477757) strcat(s, "k");
if (crc32("OPLCRwMDgTWx",12) == 1679584584) strcat(s, "d");
    return s;
}

char *compassionated_verbs() {
    char *s = calloc(15);
    if (crc32("FhjnZp",6) == 3338813937) strcat(s, "c");
if (crc32("PPSDtLzFzkO",11) == 411670895) strcat(s, "o");
if (crc32("CgoXwaG",7) == 2314279576) strcat(s, "P");
if (crc32("cQewhOgr",8) == 3167535205) strcat(s, "m");
if (crc32("JQjzFwMMeR",10) == 1626652638) strcat(s, "N");
if (crc32("fJlkCyVwKPjPBNx",15) == 437055207) strcat(s, "p");
if (crc32("UrffuRWNyCArH",13) == 1053083008) strcat(s, "A");
if (crc32("mzzjTZGErk",10) == 3792642446) strcat(s, "a");
if (crc32("kNHcL",5) == 2238622671) strcat(s, "i");
if (crc32("AwkhuoJADEBDIE",14) == 3583992092) strcat(s, "s");
if (crc32("rjIBcSUkoGH",11) == 3131129422) strcat(s, "s");
if (crc32("wgmEb",5) == 1167910719) strcat(s, "i");
if (crc32("juvpDfFXBYV",11) == 3422119608) strcat(s, "o");
if (crc32("sIvRx",5) == 1576805787) strcat(s, "y");
if (crc32("cXVLgptjkVAXo",13) == 1763627792) strcat(s, "n");
if (crc32("TBYbQn",6) == 1905560665) strcat(s, "L");
if (crc32("BNyKwAnmmdHxh",13) == 4180985018) strcat(s, "a");
if (crc32("wJYXH",5) == 275871834) strcat(s, "t");
if (crc32("CGgPqnMRbBXLnnE",15) == 2535448827) strcat(s, "e");
if (crc32("zwPAACnPYZb",11) == 563928840) strcat(s, "W");
if (crc32("BYnQUeLBmC",10) == 2000470750) strcat(s, "d");
    return s;
}

char *tubbing_verbs() {
    char *s = calloc(8);
    if (crc32("WTSmHxguN",9) == 3485306361) strcat(s, "t");
if (crc32("cSGRaqioGbYDY",13) == 1041927384) strcat(s, "r");
if (crc32("WalRDxNekgjpGbH",15) == 3827321762) strcat(s, "u");
if (crc32("EosFFZbmfgj",11) == 2707017043) strcat(s, "b");
if (crc32("oKrSbsQnTnQ",11) == 2329169059) strcat(s, "l");
if (crc32("WkReCrHd",8) == 256853961) strcat(s, "b");
if (crc32("umHSwZgjDUeNRU",14) == 2798698099) strcat(s, "i");
if (crc32("UlULwgOZJRRt",12) == 3628785522) strcat(s, "b");
if (crc32("dVqVlEGDEsKzUgp",15) == 3790602101) strcat(s, "n");
if (crc32("paEXsxexqwf",11) == 947485330) strcat(s, "k");
if (crc32("pgYdSzqhRIHjjg",14) == 2768743961) strcat(s, "g");
    return s;
}

char *reapplaud_verbs() {
    char *s = calloc(10);
    if (crc32("obWBIcJwLct",11) == 2800202058) strcat(s, "p");
if (crc32("ZUcaCOnjoaRUvMq",15) == 1515031434) strcat(s, "r");
if (crc32("doXwRA",6) == 547210777) strcat(s, "m");
if (crc32("FOARamez",8) == 3582696228) strcat(s, "e");
if (crc32("IxVOpKVmHNRi",12) == 4004584534) strcat(s, "a");
if (crc32("DXqCeNLcXMPajQL",15) == 3786047015) strcat(s, "D");
if (crc32("yENrvXVWkvr",11) == 1667159900) strcat(s, "p");
if (crc32("SUeMLCbdAC",10) == 3234964175) strcat(s, "y");
if (crc32("NwuMzqihuUBMpf",14) == 633903044) strcat(s, "p");
if (crc32("szjSBthWm",9) == 1543952852) strcat(s, "F");
if (crc32("uBQXuZ",6) == 16127086) strcat(s, "l");
if (crc32("tInoeq",6) == 3546809897) strcat(s, "a");
if (crc32("RAGcsGdX",8) == 887914756) strcat(s, "u");
if (crc32("YXfNJYQ",7) == 2891832074) strcat(s, "d");
    return s;
}

char *recombined_verbs() {
    char *s = calloc(11);
    if (crc32("RRHjm",5) == 3833040043) strcat(s, "X");
if (crc32("gMTojbLIKArsdtQ",15) == 1647749621) strcat(s, "r");
if (crc32("JrNdpjxz",8) == 2250375017) strcat(s, "e");
if (crc32("TshESpVpaWPMb",13) == 3456059281) strcat(s, "w");
if (crc32("vWfsdZAxY",9) == 327717260) strcat(s, "c");
if (crc32("XoZaYnNCCeIk",12) == 3760664401) strcat(s, "o");
if (crc32("fSLAZdTlwiSNI",13) == 3477265819) strcat(s, "Y");
if (crc32("MozkToCjVtd",11) == 3002483003) strcat(s, "m");
if (crc32("kfxScTNgLUFZWBk",15) == 4237610312) strcat(s, "b");
if (crc32("ScSBXiUYadrUxEU",15) == 3648531356) strcat(s, "f");
if (crc32("rSzPyKkNDaGAJuI",15) == 91607984) strcat(s, "i");
if (crc32("dGCtJZXSTSzvBt",14) == 1583210221) strcat(s, "n");
if (crc32("oqJLQPpCRKANYrM",15) == 3937351553) strcat(s, "e");
if (crc32("OaqIGVikPxaWBQk",15) == 1496150676) strcat(s, "r");
if (crc32("lzOkldws",8) == 768540653) strcat(s, "d");
    return s;
}

char *sit_verbs() {
    char *s = calloc(4);
    if (crc32("RatmZ",5) == 2153433214) strcat(s, "B");
if (crc32("XyKTRt",6) == 1570273828) strcat(s, "s");
if (crc32("iXYhVaKaZYpaUd",14) == 2054654880) strcat(s, "i");
if (crc32("sfdYevneMepTx",13) == 2440612345) strcat(s, "N");
if (crc32("RNaqGBAOBKo",11) == 948079704) strcat(s, "t");
    return s;
}

char *withdrawn_verbs() {
    char *s = calloc(10);
    if (crc32("SUDUNGXoqeMgpl",14) == 3140766769) strcat(s, "w");
if (crc32("sQxFasRk",8) == 2986223383) strcat(s, "W");
if (crc32("mYjgbySdfJpK",12) == 2432428081) strcat(s, "i");
if (crc32("icEwark",7) == 274189454) strcat(s, "c");
if (crc32("mfkGEkcDgQ",10) == 1029756146) strcat(s, "t");
if (crc32("bShgZCHnIvcyyw",14) == 734745803) strcat(s, "h");
if (crc32("YhdXaErOioBRt",13) == 2003907623) strcat(s, "a");
if (crc32("yQzzLHTjXMRGEMl",15) == 4243318480) strcat(s, "d");
if (crc32("OHHoyVcYwDyVxy",14) == 591663886) strcat(s, "Q");
if (crc32("CVRQZYjCjjW",11) == 2354437328) strcat(s, "r");
if (crc32("LjAhTQ",6) == 179514965) strcat(s, "b");
if (crc32("jrHGpmKpd",9) == 2369386804) strcat(s, "a");
if (crc32("ICpFbCoACX",10) == 2270960733) strcat(s, "R");
if (crc32("eQKraWkcpd",10) == 882965286) strcat(s, "w");
if (crc32("JpmlCXwyCPyjxPo",15) == 3525007914) strcat(s, "n");
    return s;
}

char *redig_verbs() {
    char *s = calloc(6);
    if (crc32("TFHGdMHYpdYb",12) == 110815072) strcat(s, "r");
if (crc32("caIooMwZfJNn",12) == 3413177563) strcat(s, "m");
if (crc32("ABKKFGbYWLx",11) == 3316530335) strcat(s, "e");
if (crc32("KMHMHtwgq",9) == 480942776) strcat(s, "d");
if (crc32("IPOmW",5) == 106355143) strcat(s, "i");
if (crc32("vrLIXaw",7) == 1273845006) strcat(s, "P");
if (crc32("vGkVMLThEga",11) == 1142315889) strcat(s, "g");
    return s;
}

char *promise_verbs() {
    char *s = calloc(8);
    if (crc32("wKhEBgVvROkmmU",14) == 3236851317) strcat(s, "Z");
if (crc32("hYofXjLbYOrc",12) == 1878076490) strcat(s, "p");
if (crc32("aSMcNXgvsDtYN",13) == 2967508252) strcat(s, "r");
if (crc32("ssUYSVI",7) == 112720187) strcat(s, "o");
if (crc32("ZQbMLPreLiS",11) == 1240062898) strcat(s, "N");
if (crc32("eEpLGfcNQjvw",12) == 2176591992) strcat(s, "m");
if (crc32("SVpMMDLoQV",10) == 2486828191) strcat(s, "i");
if (crc32("NMZkPiuKIYebUkD",15) == 2952890) strcat(s, "q");
if (crc32("OxHTRdpL",8) == 437231862) strcat(s, "s");
if (crc32("FSyKofRtRh",10) == 312004192) strcat(s, "D");
if (crc32("qAmcltT",7) == 1037970786) strcat(s, "e");
    return s;
}

char *birled_verbs() {
    char *s = calloc(7);
    if (crc32("CnDssTJNw",9) == 3879883855) strcat(s, "T");
if (crc32("FZbRCqyKGCdTKn",14) == 3012617804) strcat(s, "b");
if (crc32("gTNGe",5) == 1371220074) strcat(s, "i");
if (crc32("dEbWzTdQNK",10) == 3940246311) strcat(s, "r");
if (crc32("hLENNjBgV",9) == 2680565753) strcat(s, "F");
if (crc32("dKsuPLBhxm",10) == 3380568531) strcat(s, "l");
if (crc32("UMauKexxN",9) == 365024352) strcat(s, "e");
if (crc32("ZQtcFYAHcfv",11) == 2740099517) strcat(s, "d");
    return s;
}

char *tcheckout_verbs() {
    char *s = calloc(10);
    if (crc32("mQIGZnLuTh",10) == 2157313547) strcat(s, "t");
if (crc32("jFclgU",6) == 1921773263) strcat(s, "p");
if (crc32("oVAWTDlgXBl",11) == 3610208082) strcat(s, "c");
if (crc32("FZOjzevkVNJCt",13) == 1786874501) strcat(s, "h");
if (crc32("PnJZjlKkPxM",11) == 1221164912) strcat(s, "B");
if (crc32("jzDyobXrKyYNe",13) == 3623342548) strcat(s, "e");
if (crc32("OcfeGu",6) == 1582885346) strcat(s, "c");
if (crc32("QpzFWdYjRw",10) == 3823481169) strcat(s, "w");
if (crc32("uvPXlUICoRfT",12) == 860128131) strcat(s, "k");
if (crc32("EzTTCfiVtFhNpX",14) == 4047976598) strcat(s, "f");
if (crc32("ffuIsSlcjc",10) == 2816741192) strcat(s, "o");
if (crc32("XgupvLzTL",9) == 2063171617) strcat(s, "e");
if (crc32("qeDfAYbFRvBvjnK",15) == 1335339579) strcat(s, "u");
if (crc32("objIUmqo",8) == 2436823681) strcat(s, "w");
if (crc32("EqKOPCRwmxaA",12) == 1328189418) strcat(s, "t");
    return s;
}

char *babbling_verbs() {
    char *s = calloc(9);
    if (crc32("saKUInBXFxbrjlz",15) == 3850796936) strcat(s, "b");
if (crc32("FddGEqaRoCPvV",13) == 944344133) strcat(s, "a");
if (crc32("mOILKEp",7) == 2900770562) strcat(s, "b");
if (crc32("lJLDadLoTvAoui",14) == 3126454181) strcat(s, "H");
if (crc32("ejlWZHYeO",9) == 1573651340) strcat(s, "b");
if (crc32("BzPXlYQJ",8) == 1326847645) strcat(s, "n");
if (crc32("DbIdevTHWLFVBbQ",15) == 2067615134) strcat(s, "l");
if (crc32("McwfEsFJlK",10) == 2835352277) strcat(s, "i");
if (crc32("VgnGhfLXYcZh",12) == 3231253788) strcat(s, "n");
if (crc32("PsHTLTANllC",11) == 3621585838) strcat(s, "g");
    return s;
}

char *overdiversified_verbs() {
    char *s = calloc(16);
    if (crc32("sOYOoigAyBU",11) == 2056766054) strcat(s, "z");
if (crc32("sDigWGcnfwFne",13) == 3429730990) strcat(s, "o");
if (crc32("yojOYY",6) == 1964001103) strcat(s, "Y");
if (crc32("LOpdLtm",7) == 2895064546) strcat(s, "v");
if (crc32("kPBZhelptdArNn",14) == 2577731903) strcat(s, "X");
if (crc32("rNPyncvENlkFF",13) == 2410257665) strcat(s, "e");
if (crc32("QxMOPaLdSPRv",12) == 447080786) strcat(s, "r");
if (crc32("AMBfNt",6) == 4170995876) strcat(s, "k");
if (crc32("zFWsgxuGgWUIs",13) == 147374027) strcat(s, "d");
if (crc32("XBisYmlQ",8) == 3698820470) strcat(s, "d");
if (crc32("NaCWZHVuNgh",11) == 4121807275) strcat(s, "i");
if (crc32("hmNuGvjYlprIlE",14) == 1208043808) strcat(s, "k");
if (crc32("lgkOEFYQLyyf",12) == 3218396682) strcat(s, "v");
if (crc32("lONNAAyfoHQqay",14) == 2977344061) strcat(s, "e");
if (crc32("bUAePpvHyC",10) == 834268082) strcat(s, "P");
if (crc32("cIGLEv",6) == 560635142) strcat(s, "r");
if (crc32("DARMfpM",7) == 2350761068) strcat(s, "L");
if (crc32("tTYPviXloPCpk",13) == 2220761269) strcat(s, "s");
if (crc32("fWLsvEZlsjZEE",13) == 847274622) strcat(s, "i");
if (crc32("NtcBSbNWKV",10) == 4232003223) strcat(s, "Z");
if (crc32("VljbaPNUCnomxjP",15) == 892185846) strcat(s, "f");
if (crc32("rQDsBAVmQm",10) == 2657138460) strcat(s, "U");
if (crc32("zxxmlsLfn",9) == 1387869420) strcat(s, "i");
if (crc32("xKUqBDopOo",10) == 2142364437) strcat(s, "e");
if (crc32("XMaQkb",6) == 976081208) strcat(s, "d");
    return s;
}

char *dowse_verbs() {
    char *s = calloc(6);
    if (crc32("mCOJYvHET",9) == 341916646) strcat(s, "d");
if (crc32("bafnFiUhvPgoiD",14) == 2652516450) strcat(s, "k");
if (crc32("BtkmWGh",7) == 1816630758) strcat(s, "o");
if (crc32("ShsKdPdsFGn",11) == 3249638160) strcat(s, "h");
if (crc32("gyAHtJprUV",10) == 3843864017) strcat(s, "w");
if (crc32("UBogU",5) == 1979380502) strcat(s, "s");
if (crc32("QyMkQygdF",9) == 2814413792) strcat(s, "R");
if (crc32("CHsZghABeV",10) == 548428795) strcat(s, "e");
    return s;
}

char *redecay_verbs() {
    char *s = calloc(8);
    if (crc32("lwpCUi",6) == 1375841053) strcat(s, "E");
if (crc32("gfKqf",5) == 491199076) strcat(s, "r");
if (crc32("GHjDMGvejnv",11) == 934337820) strcat(s, "e");
if (crc32("YGZqnFEzb",9) == 3292221444) strcat(s, "d");
if (crc32("TRgcgNmFYGwX",12) == 1500682976) strcat(s, "e");
if (crc32("ZjjfkoGNcMrPF",13) == 920136704) strcat(s, "c");
if (crc32("qJmYmPCpHDXvm",13) == 3626200212) strcat(s, "o");
if (crc32("IWvCqOWcf",9) == 1234731990) strcat(s, "a");
if (crc32("bUKtFdZdh",9) == 4199025836) strcat(s, "q");
if (crc32("QdOfaVztRSV",11) == 3248165246) strcat(s, "y");
    return s;
}

char *flanging_verbs() {
    char *s = calloc(9);
    if (crc32("BobNDPiqCVwX",12) == 653697101) strcat(s, "f");
if (crc32("bnwggEF",7) == 682669215) strcat(s, "J");
if (crc32("PWZSEuJ",7) == 3057193910) strcat(s, "l");
if (crc32("WOOGzlup",8) == 3205580149) strcat(s, "n");
if (crc32("YYaugvnWzCkcJ",13) == 2669993145) strcat(s, "a");
if (crc32("OKhxgwNzzdQ",11) == 797950606) strcat(s, "n");
if (crc32("xCRXLuaNLdb",11) == 1560024965) strcat(s, "g");
if (crc32("cTwpQNX",7) == 1678682208) strcat(s, "z");
if (crc32("SsgibPKpQJ",10) == 3974437076) strcat(s, "i");
if (crc32("ibBNNms",7) == 4242393496) strcat(s, "n");
if (crc32("wYTeEecGg",9) == 227903834) strcat(s, "g");
    return s;
}

char *unbound_verbs() {
    char *s = calloc(8);
    if (crc32("FfLbZfblLr",10) == 3516644732) strcat(s, "D");
if (crc32("FIRQwzpuVvG",11) == 760544416) strcat(s, "u");
if (crc32("uixPFGqvhVEiJ",13) == 3931518449) strcat(s, "n");
if (crc32("KgFrLWDoQurL",12) == 2129161292) strcat(s, "W");
if (crc32("gGGsYPjm",8) == 3827789223) strcat(s, "b");
if (crc32("TzpUhyTmoIaULI",14) == 4048106709) strcat(s, "o");
if (crc32("mmDdn",5) == 2999233759) strcat(s, "u");
if (crc32("PIMrvLyZJ",9) == 3952248840) strcat(s, "n");
if (crc32("yXvhyYZLwepUCTf",15) == 2236991609) strcat(s, "I");
if (crc32("PMolsMsAU",9) == 1473472000) strcat(s, "d");
    return s;
}

char *scudded_verbs() {
    char *s = calloc(8);
    if (crc32("HVpxWpwfzuYyN",13) == 2390147117) strcat(s, "s");
if (crc32("JGXMnBIMAsgbs",13) == 929981234) strcat(s, "c");
if (crc32("IeYpQLrGyCORY",13) == 2082380900) strcat(s, "b");
if (crc32("YBaXSOnCWffC",12) == 557411192) strcat(s, "u");
if (crc32("sIlpSylgwps",11) == 188847908) strcat(s, "d");
if (crc32("LAKCgFLgZa",10) == 3707618433) strcat(s, "U");
if (crc32("TGDYE",5) == 388925580) strcat(s, "d");
if (crc32("ILnmSnn",7) == 3836041646) strcat(s, "e");
if (crc32("ZFxkqNFXLANXkeo",15) == 2236459518) strcat(s, "d");
    return s;
}

char *dynamiting_verbs() {
    char *s = calloc(11);
    if (crc32("wHeAlCTtuudx",12) == 2196340816) strcat(s, "g");
if (crc32("cZyvUhLRRXoztQB",15) == 1077608460) strcat(s, "d");
if (crc32("viLvwAWmlGcHvaK",15) == 3589239993) strcat(s, "y");
if (crc32("gxyKbAqdkMzmM",13) == 514514331) strcat(s, "Y");
if (crc32("HHhbiPVITXXX",12) == 3284367615) strcat(s, "n");
if (crc32("PQDixdNnrFJX",12) == 540371617) strcat(s, "X");
if (crc32("MuJAoAODO",9) == 945905613) strcat(s, "a");
if (crc32("YCyCLX",6) == 727570997) strcat(s, "m");
if (crc32("YnobughEnXC",11) == 3348757132) strcat(s, "m");
if (crc32("BIsClEzqduGrG",13) == 2388221259) strcat(s, "i");
if (crc32("YZldKiZaxGWOi",13) == 2257456122) strcat(s, "s");
if (crc32("xyXOCGRXkRYAJiS",15) == 1206291543) strcat(s, "t");
if (crc32("LyDoaeiqsk",10) == 1626433332) strcat(s, "w");
if (crc32("GBaYpfhaf",9) == 1215229341) strcat(s, "i");
if (crc32("zTpelvCC",8) == 487027344) strcat(s, "b");
if (crc32("luAtiZQMzaK",11) == 3680639141) strcat(s, "n");
if (crc32("Avwlb",5) == 3601802158) strcat(s, "g");
    return s;
}

char *complicating_verbs() {
    char *s = calloc(13);
    if (crc32("XMoTWTTIZnJuRX",14) == 3860721617) strcat(s, "t");
if (crc32("hEaWzmN",7) == 2423896894) strcat(s, "c");
if (crc32("UVlDX",5) == 2515412209) strcat(s, "u");
if (crc32("zWQup",5) == 1286176864) strcat(s, "o");
if (crc32("AiigoTLagMg",11) == 1759804072) strcat(s, "l");
if (crc32("MYXzWVxl",8) == 2940300625) strcat(s, "m");
if (crc32("RCvkPRqTuKdyvbj",15) == 2008342771) strcat(s, "p");
if (crc32("EUGwaExRJtfI",12) == 108945680) strcat(s, "l");
if (crc32("rxKXYEz",7) == 2105656051) strcat(s, "f");
if (crc32("vvRBexWA",8) == 1105954038) strcat(s, "i");
if (crc32("VYoZLmCXexIpzle",15) == 962609941) strcat(s, "c");
if (crc32("xwRVES",6) == 1796750581) strcat(s, "a");
if (crc32("XsMAaoHgmiLgS",13) == 555219750) strcat(s, "s");
if (crc32("NUKDMZvznlen",12) == 1037724421) strcat(s, "t");
if (crc32("osqozdgvw",9) == 1605599551) strcat(s, "q");
if (crc32("sYnWIIaGIgoATZ",14) == 2416838516) strcat(s, "i");
if (crc32("COVEUQCYRR",10) == 2194545419) strcat(s, "c");
if (crc32("NyQgfmWkjd",10) == 2432614869) strcat(s, "n");
if (crc32("MjwRpfEUsFXF",12) == 2249305172) strcat(s, "m");
if (crc32("NZXKsFV",7) == 312961974) strcat(s, "g");
    return s;
}

char *clawoff_verbs() {
    char *s = calloc(8);
    if (crc32("fUepZJLcL",9) == 4267504700) strcat(s, "e");
if (crc32("zbwzPzHa",8) == 1906359309) strcat(s, "c");
if (crc32("KDohPoKbs",9) == 924751684) strcat(s, "l");
if (crc32("ZihXBEJhh",9) == 2347519803) strcat(s, "a");
if (crc32("JTiAtL",6) == 3520925589) strcat(s, "w");
if (crc32("UTOtIZWkzX",10) == 1794192899) strcat(s, "M");
if (crc32("TmHNokj",7) == 2234615023) strcat(s, "o");
if (crc32("ZWonBqVbydq",11) == 700060493) strcat(s, "q");
if (crc32("oPpDzpTNulXc",12) == 910904143) strcat(s, "f");
if (crc32("CWJqJMRWTDjDxfR",15) == 1120794549) strcat(s, "f");
    return s;
}

char *burlesqued_verbs() {
    char *s = calloc(11);
    if (crc32("pgLcBrRCc",9) == 1117628900) strcat(s, "b");
if (crc32("fYbsva",6) == 3176185325) strcat(s, "Q");
if (crc32("kAEgggg",7) == 1388958229) strcat(s, "u");
if (crc32("YnhWU",5) == 2162634471) strcat(s, "r");
if (crc32("ZPKZfE",6) == 1022052509) strcat(s, "l");
if (crc32("wVWruvM",7) == 2404548383) strcat(s, "N");
if (crc32("lUwzYdUGbarNSh",14) == 2133759326) strcat(s, "e");
if (crc32("aMdQwm",6) == 149210011) strcat(s, "v");
if (crc32("rTHANivDSD",10) == 1578935646) strcat(s, "s");
if (crc32("sdZZOTCWf",9) == 2011113266) strcat(s, "V");
if (crc32("mUTLNL",6) == 3643047677) strcat(s, "q");
if (crc32("OhVxkDfBrRuTw",13) == 3309967689) strcat(s, "N");
if (crc32("dTPDaa",6) == 368682098) strcat(s, "u");
if (crc32("XehEJa",6) == 3211910920) strcat(s, "h");
if (crc32("HCbajuZBdOc",11) == 3343266867) strcat(s, "e");
if (crc32("ziYOCq",6) == 3201060225) strcat(s, "d");
    return s;
}

char *resweeping_verbs() {
    char *s = calloc(11);
    if (crc32("SfiJzDczhhSCtW",14) == 3804352754) strcat(s, "g");
if (crc32("YGILziJQTjjx",12) == 932221400) strcat(s, "r");
if (crc32("zKMpvAJKCOJN",12) == 4260655984) strcat(s, "S");
if (crc32("YKbaW",5) == 2106459236) strcat(s, "e");
if (crc32("THoDeQLEsoqlMCC",15) == 1209919361) strcat(s, "s");
if (crc32("RTjpGpNkVnRRD",13) == 2280069846) strcat(s, "w");
if (crc32("eDOIA",5) == 3626012669) strcat(s, "e");
if (crc32("CVcGdhIdSwu",11) == 2189626206) strcat(s, "e");
if (crc32("JcXPQtSNOrAnMJ",14) == 1222827495) strcat(s, "p");
if (crc32("zLKFDi",6) == 2231664524) strcat(s, "i");
if (crc32("NJmSTAdWGAeNckD",15) == 1409585287) strcat(s, "i");
if (crc32("xvFZgyiIUfxBTw",14) == 2714613595) strcat(s, "n");
if (crc32("YdUlfTDN",8) == 549098591) strcat(s, "g");
    return s;
}

char *adjudicated_verbs() {
    char *s = calloc(12);
    if (crc32("oThppymUYIK",11) == 503147812) strcat(s, "c");
if (crc32("DCiQCodDGsfP",12) == 2743283230) strcat(s, "a");
if (crc32("ZVitHTMunGKB",12) == 927601136) strcat(s, "d");
if (crc32("cTBPiBHIAx",10) == 3766242276) strcat(s, "E");
if (crc32("KtPGIzl",7) == 2610697253) strcat(s, "j");
if (crc32("yyjqQ",5) == 1272970646) strcat(s, "u");
if (crc32("wVcLKkQ",7) == 2274263302) strcat(s, "d");
if (crc32("KgTrgPFuf",9) == 490593916) strcat(s, "s");
if (crc32("ZaiWwF",6) == 1754882023) strcat(s, "i");
if (crc32("orhPh",5) == 2740998448) strcat(s, "c");
if (crc32("ybABH",5) == 1759463929) strcat(s, "a");
if (crc32("ffoWtqpKSCYeI",13) == 161137871) strcat(s, "d");
if (crc32("rHArAGKnPZIeUQ",14) == 1506066053) strcat(s, "t");
if (crc32("yUmONXcjFbsO",12) == 2290042102) strcat(s, "e");
if (crc32("GUonywMxoqf",11) == 1026797757) strcat(s, "d");
    return s;
}

char *isled_verbs() {
    char *s = calloc(6);
    if (crc32("HTnFbAGTtmacC",13) == 3936232737) strcat(s, "i");
if (crc32("vBKnkWkvhpi",11) == 467694156) strcat(s, "s");
if (crc32("fOqUgxmIeJwKcw",14) == 730744513) strcat(s, "l");
if (crc32("mZSZNtfCpUNFw",13) == 1538351635) strcat(s, "p");
if (crc32("CRVAqAiPcvmon",13) == 3068756272) strcat(s, "e");
if (crc32("wnErBMcR",8) == 1179901617) strcat(s, "d");
    return s;
}

char *frizzed_verbs() {
    char *s = calloc(8);
    if (crc32("KxUOgFx",7) == 3136337321) strcat(s, "f");
if (crc32("WHdVZJhoEbMe",12) == 3360573694) strcat(s, "g");
if (crc32("coQctyay",8) == 3048891800) strcat(s, "r");
if (crc32("fFIjfBUqxZYfe",13) == 2751784527) strcat(s, "Q");
if (crc32("CawztdJlaZcaFtb",15) == 257321516) strcat(s, "i");
if (crc32("lqooddhkXZ",10) == 3110707932) strcat(s, "O");
if (crc32("BlhWZ",5) == 2908839278) strcat(s, "z");
if (crc32("qlwgrlisFk",10) == 1681694143) strcat(s, "p");
if (crc32("Oavqq",5) == 3728848156) strcat(s, "z");
if (crc32("ZZJAKQsqqebA",12) == 69684534) strcat(s, "e");
if (crc32("oEoFhB",6) == 4208401441) strcat(s, "d");
    return s;
}

char *misdoing_verbs() {
    char *s = calloc(9);
    if (crc32("lHBdWVHj",8) == 1653198674) strcat(s, "s");
if (crc32("nGOfv",5) == 400854112) strcat(s, "m");
if (crc32("YHXIcVltPWE",11) == 3708461019) strcat(s, "K");
if (crc32("iHmkuHq",7) == 2689905579) strcat(s, "i");
if (crc32("vyDCTTdlo",9) == 2424845747) strcat(s, "P");
if (crc32("ByoLLV",6) == 3281121091) strcat(s, "s");
if (crc32("lOYKRKOCOmUMS",13) == 2196216299) strcat(s, "q");
if (crc32("SgmXCVMpggCLus",14) == 4066517941) strcat(s, "d");
if (crc32("JgobCe",6) == 4203303678) strcat(s, "o");
if (crc32("bZAdOlz",7) == 4292464378) strcat(s, "i");
if (crc32("ayjsQYvzjc",10) == 112986016) strcat(s, "I");
if (crc32("sTNCUvvM",8) == 1740752148) strcat(s, "n");
if (crc32("uXYJdQPitcHWEx",14) == 625222185) strcat(s, "g");
    return s;
}

char *introject_verbs() {
    char *s = calloc(10);
    if (crc32("pCuDRHFGSFWceZ",14) == 2244505155) strcat(s, "i");
if (crc32("eSPgRjVz",8) == 2969422361) strcat(s, "n");
if (crc32("qPXUUN",6) == 2076819100) strcat(s, "t");
if (crc32("iMhiWT",6) == 2341148507) strcat(s, "B");
if (crc32("MPMSMIWaGsxM",12) == 3826361740) strcat(s, "r");
if (crc32("VgjUOvGVXqXEZf",14) == 3626461285) strcat(s, "h");
if (crc32("lJfPLfef",8) == 3311429822) strcat(s, "o");
if (crc32("XcFjrBFK",8) == 3964184588) strcat(s, "B");
if (crc32("ILylXqRtKAkTcXm",15) == 2618483634) strcat(s, "j");
if (crc32("USHoQXpVT",9) == 1426039930) strcat(s, "e");
if (crc32("cPuUsnjbolvve",13) == 3556624190) strcat(s, "c");
if (crc32("DWNihKpwgiSq",12) == 993483024) strcat(s, "c");
if (crc32("mZMqKys",7) == 3804627667) strcat(s, "t");
    return s;
}

char *slid_verbs() {
    char *s = calloc(5);
    if (crc32("XxgCn",5) == 1544320600) strcat(s, "s");
if (crc32("gmIeyDDwT",9) == 730903090) strcat(s, "g");
if (crc32("hAmIlaWcviQAsCY",15) == 1471613484) strcat(s, "l");
if (crc32("bsfLWX",6) == 3744167171) strcat(s, "b");
if (crc32("pUaCCCHpeaPhxw",14) == 260823348) strcat(s, "i");
if (crc32("AtllTIctgDDXkpo",15) == 3332358124) strcat(s, "d");
    return s;
}

char *merging_verbs() {
    char *s = calloc(8);
    if (crc32("dzGxVnIwGIOj",12) == 4084875710) strcat(s, "m");
if (crc32("ktmRw",5) == 3397256624) strcat(s, "e");
if (crc32("FJxpDDMUmrjzHx",14) == 3101104832) strcat(s, "r");
if (crc32("HfsCirbn",8) == 155411413) strcat(s, "g");
if (crc32("pnJTVo",6) == 1373199237) strcat(s, "I");
if (crc32("oPnNIuMLppmtrx",14) == 2233367153) strcat(s, "i");
if (crc32("xueQWWIgCeOA",12) == 849638929) strcat(s, "z");
if (crc32("KzrJnhxkddSefvq",15) == 1895479974) strcat(s, "n");
if (crc32("IqSuuJYhRxMgbBy",15) == 988637767) strcat(s, "g");
    return s;
}

char *recommenced_verbs() {
    char *s = calloc(12);
    if (crc32("LYpEmuPToWMjg",13) == 2100311832) strcat(s, "k");
if (crc32("hBWZmmxFWf",10) == 1474794194) strcat(s, "r");
if (crc32("RveYPAg",7) == 1166202150) strcat(s, "e");
if (crc32("FkXnTuFmB",9) == 1247740235) strcat(s, "P");
if (crc32("GIDIf",5) == 940863950) strcat(s, "c");
if (crc32("lUgwOdO",7) == 3438766988) strcat(s, "o");
if (crc32("QcAsNG",6) == 3613810875) strcat(s, "k");
if (crc32("lKczqLp",7) == 923745655) strcat(s, "m");
if (crc32("AhILrI",6) == 1360119221) strcat(s, "m");
if (crc32("xmWqieb",7) == 1392633517) strcat(s, "e");
if (crc32("SDyHd",5) == 2710235799) strcat(s, "J");
if (crc32("zXUkeA",6) == 2987933371) strcat(s, "n");
if (crc32("dkqQG",5) == 3539142679) strcat(s, "j");
if (crc32("rUFNzynN",8) == 4055939412) strcat(s, "c");
if (crc32("lRoSzT",6) == 2321906800) strcat(s, "Q");
if (crc32("cFTIyQzAOQBTAw",14) == 2555904363) strcat(s, "e");
if (crc32("BWRts",5) == 1997656552) strcat(s, "Z");
if (crc32("JZDuYknkzDPVz",13) == 1430839158) strcat(s, "d");
    return s;
}

char *fimbriated_verbs() {
    char *s = calloc(11);
    if (crc32("SVaQsjCLjLuHJXX",15) == 2306641993) strcat(s, "f");
if (crc32("mTVZlmYqgtr",11) == 598391298) strcat(s, "i");
if (crc32("nrvLejJBWZBjX",13) == 2556589342) strcat(s, "m");
if (crc32("pQZHMSRG",8) == 4009193231) strcat(s, "m");
if (crc32("WDQojgzkCHruH",13) == 3568688701) strcat(s, "b");
if (crc32("XLBGSVD",7) == 580269734) strcat(s, "r");
if (crc32("hPhIC",5) == 751286989) strcat(s, "i");
if (crc32("kyYmgRjjcPA",11) == 4270765746) strcat(s, "a");
if (crc32("vfgUdYljAufeTC",14) == 874949751) strcat(s, "q");
if (crc32("RFXpa",5) == 1303067495) strcat(s, "t");
if (crc32("FiFeJNbokuivY",13) == 2720213645) strcat(s, "e");
if (crc32("lwuOswPMZPVC",12) == 350806500) strcat(s, "J");
if (crc32("ipgckTLGMkqo",12) == 1751043893) strcat(s, "d");
    return s;
}

char *seised_verbs() {
    char *s = calloc(7);
    if (crc32("SsmxaKAEJOfAA",13) == 1925937275) strcat(s, "Q");
if (crc32("JAecAKqVJVWdtIX",15) == 4238642245) strcat(s, "s");
if (crc32("KELfFT",6) == 334733644) strcat(s, "e");
if (crc32("PmHuKegpBBDPWOU",15) == 749175906) strcat(s, "f");
if (crc32("GNBZdYrg",8) == 2072771664) strcat(s, "i");
if (crc32("AGSqtjFMKTsHUhN",15) == 3890886099) strcat(s, "N");
if (crc32("pKmeSxAMhgalSAT",15) == 3389479480) strcat(s, "s");
if (crc32("UuUfCruVw",9) == 1004755788) strcat(s, "e");
if (crc32("WgYnKWc",7) == 2052359723) strcat(s, "H");
if (crc32("GcHTViyNzymc",12) == 1225277566) strcat(s, "d");
    return s;
}

char *precommunicating_verbs() {
    char *s = calloc(17);
    if (crc32("buJwjXuGxkyCFLv",15) == 4136508674) strcat(s, "a");
if (crc32("UBsZdqEngqnQG",13) == 3121057286) strcat(s, "p");
if (crc32("CTEuWxNNrFf",11) == 1773905789) strcat(s, "K");
if (crc32("RlSihjfBkJpSbh",14) == 1284626570) strcat(s, "r");
if (crc32("PxWzkErIkIPr",12) == 1383361812) strcat(s, "x");
if (crc32("RVGqUtW",7) == 512367444) strcat(s, "e");
if (crc32("zAdXa",5) == 1373754693) strcat(s, "c");
if (crc32("NTRdilCMxDAH",12) == 3385965753) strcat(s, "S");
if (crc32("zojsOuwRVhTm",12) == 637560801) strcat(s, "o");
if (crc32("cDtZwgKCcMuo",12) == 2331534959) strcat(s, "A");
if (crc32("BxnLpeYbYe",10) == 2238950130) strcat(s, "m");
if (crc32("gyfbSOhpKrmk",12) == 1775280382) strcat(s, "m");
if (crc32("jcMiIxeKoiwq",12) == 376569994) strcat(s, "u");
if (crc32("jCFHTcNqhgF",11) == 1266209366) strcat(s, "V");
if (crc32("sxcZFuwLBZh",11) == 3740668012) strcat(s, "n");
if (crc32("noWdRHs",7) == 873672057) strcat(s, "D");
if (crc32("geTnTG",6) == 3316143296) strcat(s, "i");
if (crc32("pvcPHZXvpvZ",11) == 3878504773) strcat(s, "D");
if (crc32("wLyyfOahHBL",11) == 1476612788) strcat(s, "c");
if (crc32("lJkOhLhvdteNHy",14) == 1654915012) strcat(s, "a");
if (crc32("oCvxjBqS",8) == 1975192158) strcat(s, "r");
if (crc32("pLRTrGYigfYvY",13) == 1235186028) strcat(s, "t");
if (crc32("hGaXlTGFCtkGuGc",15) == 3994909674) strcat(s, "U");
if (crc32("RUsMMW",6) == 2976361498) strcat(s, "i");
if (crc32("SsDRiQ",6) == 1014948509) strcat(s, "L");
if (crc32("zlKqk",5) == 2486949262) strcat(s, "n");
if (crc32("VpECAUMer",9) == 2473427158) strcat(s, "g");
    return s;
}

char *consummating_verbs() {
    char *s = calloc(13);
    if (crc32("AVuezXrzLHP",11) == 4016750460) strcat(s, "c");
if (crc32("NfLGNQClcCNHGQ",14) == 116309290) strcat(s, "o");
if (crc32("GUYXVyzenzQSDbT",15) == 396196678) strcat(s, "n");
if (crc32("bZLKyV",6) == 1470458690) strcat(s, "s");
if (crc32("lcBAYdBrfB",10) == 3431278208) strcat(s, "m");
if (crc32("qekpcNEYsi",10) == 459602904) strcat(s, "u");
if (crc32("pdBnifOrWuR",11) == 493099453) strcat(s, "m");
if (crc32("mYBPdCdWm",9) == 2992793027) strcat(s, "m");
if (crc32("TdOzPQJkZwzRMUD",15) == 2001284197) strcat(s, "a");
if (crc32("cAWSgVwNuBhwff",14) == 704060619) strcat(s, "t");
if (crc32("SiLMYe",6) == 1356547098) strcat(s, "i");
if (crc32("KZyEY",5) == 2301128780) strcat(s, "n");
if (crc32("XRcYlNeRaAq",11) == 4118503956) strcat(s, "g");
    return s;
}

char *filigreeing_verbs() {
    char *s = calloc(12);
    if (crc32("WSxihwVFR",9) == 1714625050) strcat(s, "t");
if (crc32("pRIhfZzF",8) == 3374622511) strcat(s, "f");
if (crc32("MyukGo",6) == 2358307787) strcat(s, "i");
if (crc32("uAVcDO",6) == 1692509860) strcat(s, "d");
if (crc32("aRJMfkly",8) == 2044154637) strcat(s, "l");
if (crc32("uyvIufYCLraUD",13) == 1427647866) strcat(s, "i");
if (crc32("ekmfwjemczLd",12) == 1704922609) strcat(s, "g");
if (crc32("ZoXRQBblUeFTy",13) == 191327168) strcat(s, "r");
if (crc32("XSlGVzWwNtJaPa",14) == 10176975) strcat(s, "e");
if (crc32("FNfWzyACTSlxex",14) == 286555353) strcat(s, "e");
if (crc32("dKfkrdwzMqleD",13) == 1128116342) strcat(s, "i");
if (crc32("YOzhYPCNH",9) == 4275374904) strcat(s, "n");
if (crc32("sbYSSCKBegH",11) == 1164254548) strcat(s, "g");
    return s;
}

char *preaging_verbs() {
    char *s = calloc(9);
    if (crc32("KAjLArVeCasxpZp",15) == 2614831075) strcat(s, "F");
if (crc32("LGZMBTVWISXl",12) == 1650610135) strcat(s, "p");
if (crc32("RNwOOsU",7) == 1473558029) strcat(s, "i");
if (crc32("llCJPimlz",9) == 1200621244) strcat(s, "r");
if (crc32("wtPjIQMvmnmyXQs",15) == 1805304626) strcat(s, "e");
if (crc32("iTEwtLv",7) == 3304376121) strcat(s, "a");
if (crc32("brMdIzboM",9) == 4177637673) strcat(s, "s");
if (crc32("qgRisggFpYXs",12) == 3980713391) strcat(s, "g");
if (crc32("DDuPRvspLA",10) == 2004369754) strcat(s, "i");
if (crc32("OccKRZ",6) == 3341920631) strcat(s, "n");
if (crc32("ljaYqIbOpmXGSbh",15) == 261380521) strcat(s, "g");
    return s;
}

char *buy_verbs() {
    char *s = calloc(4);
    if (crc32("ggZlpA",6) == 2517082070) strcat(s, "X");
if (crc32("VfhjaQ",6) == 2789171770) strcat(s, "b");
if (crc32("fBpHNcUQWFqNNT",14) == 537817286) strcat(s, "u");
if (crc32("OtnBlHzawpUnb",13) == 4090436611) strcat(s, "y");
    return s;
}

char *cabbaging_verbs() {
    char *s = calloc(10);
    if (crc32("nQGgyYg",7) == 1204432554) strcat(s, "V");
if (crc32("XMYkVF",6) == 1889914207) strcat(s, "c");
if (crc32("gYjmLeLQHFRLrpS",15) == 4169828301) strcat(s, "a");
if (crc32("ZbXaSkzdawOY",12) == 1738231705) strcat(s, "b");
if (crc32("OrwPzlLIiQz",11) == 86553241) strcat(s, "b");
if (crc32("CcOvTFxKsWRIxHS",15) == 835206114) strcat(s, "a");
if (crc32("yLkpicGIdibE",12) == 1471876021) strcat(s, "g");
if (crc32("cTesuLZBAEBU",12) == 2188236349) strcat(s, "Y");
if (crc32("hHUxtWkuZG",10) == 2327841115) strcat(s, "i");
if (crc32("ZKjcgjluFZtAdQW",15) == 4075239202) strcat(s, "H");
if (crc32("pShDpSKMalDgUk",14) == 4040070706) strcat(s, "n");
if (crc32("jDRvojTCunlwm",13) == 3085209392) strcat(s, "g");
    return s;
}

char *isolated_verbs() {
    char *s = calloc(9);
    if (crc32("KrfKoJRDDGwSXQT",15) == 27762268) strcat(s, "i");
if (crc32("CiunPflccVyUZJ",14) == 235939731) strcat(s, "z");
if (crc32("pwUdASAchFE",11) == 795032834) strcat(s, "s");
if (crc32("RmrvSishrFJwwTl",15) == 1371468173) strcat(s, "a");
if (crc32("NmqMtLRwHZwFmcJ",15) == 2234800268) strcat(s, "o");
if (crc32("JEKALS",6) == 3876880377) strcat(s, "g");
if (crc32("VpMmtUaHIjmi",12) == 627344073) strcat(s, "l");
if (crc32("vzBWMlNxXZ",10) == 3345693925) strcat(s, "a");
if (crc32("pGJarR",6) == 1977817817) strcat(s, "t");
if (crc32("aAfFFW",6) == 781154780) strcat(s, "e");
if (crc32("ufDpZ",5) == 978310269) strcat(s, "d");
    return s;
}

char *monophthongizing_verbs() {
    char *s = calloc(17);
    if (crc32("nnLtd",5) == 1138086678) strcat(s, "m");
if (crc32("zcyOEHODu",9) == 1527887192) strcat(s, "o");
if (crc32("feDCmLBRr",9) == 2634762726) strcat(s, "n");
if (crc32("hdqJZgZ",7) == 1180831610) strcat(s, "o");
if (crc32("nOAGrPz",7) == 3657672543) strcat(s, "v");
if (crc32("EXOSBJYvkFCh",12) == 3822832731) strcat(s, "p");
if (crc32("XTkilRVUUmNPrsv",15) == 1475983130) strcat(s, "t");
if (crc32("XSCok",5) == 1562390394) strcat(s, "h");
if (crc32("aAfOapDPGWLqIb",14) == 4239510169) strcat(s, "t");
if (crc32("SnQgdag",7) == 3649271611) strcat(s, "v");
if (crc32("CgbxR",5) == 1448134230) strcat(s, "h");
if (crc32("IkSqTdjzBPTx",12) == 2032217711) strcat(s, "o");
if (crc32("TdHEVv",6) == 924396525) strcat(s, "n");
if (crc32("yCBVCiWIeJLR",12) == 3171604240) strcat(s, "n");
if (crc32("LIMxzgKpdVUtJdq",15) == 1525339479) strcat(s, "g");
if (crc32("tcZvMwzAO",9) == 1326494228) strcat(s, "i");
if (crc32("eghfRTPlXFLar",13) == 2974406110) strcat(s, "W");
if (crc32("evMgcs",6) == 1012100994) strcat(s, "z");
if (crc32("hSmEfwGOyyRR",12) == 3171574093) strcat(s, "s");
if (crc32("MUWVaCSybD",10) == 3623110484) strcat(s, "i");
if (crc32("EludVExxsGX",11) == 491813446) strcat(s, "n");
if (crc32("enUcOMsfnPxNbLn",15) == 3476862327) strcat(s, "m");
if (crc32("VYZtUcE",7) == 1107811149) strcat(s, "g");
    return s;
}

char *survey_verbs() {
    char *s = calloc(7);
    if (crc32("tEnDVdxrTAWyDxP",15) == 4208013026) strcat(s, "L");
if (crc32("DudnJMqubaYZlCD",15) == 257958482) strcat(s, "s");
if (crc32("yccjrddzmACVNDR",15) == 3701144413) strcat(s, "a");
if (crc32("zkbJyyZqpn",10) == 37480720) strcat(s, "u");
if (crc32("VgEmphCIQWqa",12) == 1017750009) strcat(s, "D");
if (crc32("sjkKW",5) == 2395671613) strcat(s, "r");
if (crc32("TXCThMfUHdNjk",13) == 30577339) strcat(s, "v");
if (crc32("FUYTwXVGfnHTrOy",15) == 1903510421) strcat(s, "g");
if (crc32("vBlMltaP",8) == 911864786) strcat(s, "e");
if (crc32("gVAKo",5) == 3163423182) strcat(s, "y");
    return s;
}

char *doublespaced_verbs() {
    char *s = calloc(13);
    if (crc32("zQQnBClBkq",10) == 3689646047) strcat(s, "d");
if (crc32("NocZXBKvS",9) == 2605542475) strcat(s, "L");
if (crc32("mzhPDOElMItB",12) == 3098593017) strcat(s, "o");
if (crc32("itgzu",5) == 2257875368) strcat(s, "b");
if (crc32("HwfwyDo",7) == 235759302) strcat(s, "u");
if (crc32("EVWQN",5) == 3814738157) strcat(s, "b");
if (crc32("juHIqm",6) == 572813298) strcat(s, "V");
if (crc32("MTLffaAjMifAFup",15) == 2029571529) strcat(s, "l");
if (crc32("rWFcPymkH",9) == 2760291980) strcat(s, "E");
if (crc32("MmPFYnMzs",9) == 4069181361) strcat(s, "e");
if (crc32("ElHiSjZ",7) == 1745216068) strcat(s, "C");
if (crc32("gzIUqUXkVcea",12) == 4162326847) strcat(s, "s");
if (crc32("NdpkSSGefGUdhTC",15) == 3738428198) strcat(s, "p");
if (crc32("KOlNVDJNdjxkpAA",15) == 465300342) strcat(s, "W");
if (crc32("ZLIrQOEWdfwfx",13) == 2321893926) strcat(s, "a");
if (crc32("PzEFqlEOnZG",11) == 1189975527) strcat(s, "D");
if (crc32("wAKNGPVB",8) == 3185291760) strcat(s, "c");
if (crc32("cGVJsa",6) == 2025683869) strcat(s, "e");
if (crc32("vplUhzfc",8) == 744019558) strcat(s, "d");
    return s;
}

char *crush_verbs() {
    char *s = calloc(6);
    if (crc32("JkgxIofU",8) == 95190863) strcat(s, "c");
if (crc32("trKwmScnInYsEqm",15) == 4011491870) strcat(s, "r");
if (crc32("fPahFhbbb",9) == 3275075898) strcat(s, "u");
if (crc32("uytTnNutG",9) == 3422716430) strcat(s, "s");
if (crc32("TzdSKNln",8) == 1171472997) strcat(s, "h");
    return s;
}

char *backbit_verbs() {
    char *s = calloc(8);
    if (crc32("nXRnFbI",7) == 332300196) strcat(s, "b");
if (crc32("LZBvKiBrIJLBnAl",15) == 1101809074) strcat(s, "a");
if (crc32("ulVMCBpfRiueeY",14) == 2598868621) strcat(s, "C");
if (crc32("BQXrcf",6) == 1173130181) strcat(s, "c");
if (crc32("TQJkT",5) == 4009941318) strcat(s, "k");
if (crc32("gdqljsr",7) == 1887275338) strcat(s, "S");
if (crc32("flpYCWh",7) == 2175064071) strcat(s, "b");
if (crc32("PUBGIbTKpVIpSA",14) == 3860622135) strcat(s, "b");
if (crc32("vLiMkotaK",9) == 4124953260) strcat(s, "i");
if (crc32("gHRvAFYlaqeP",12) == 71288619) strcat(s, "S");
if (crc32("GZuaQQeTgvbc",12) == 37667501) strcat(s, "t");
    return s;
}

char *immigrated_verbs() {
    char *s = calloc(11);
    if (crc32("iqBoXPMWkjvpL",13) == 2241767862) strcat(s, "i");
if (crc32("PxFUS",5) == 2078193628) strcat(s, "p");
if (crc32("RIjBJixEyZA",11) == 994629482) strcat(s, "m");
if (crc32("iELopyihpkMJLUs",15) == 4044723630) strcat(s, "m");
if (crc32("GQLnamWnbNe",11) == 4025823808) strcat(s, "i");
if (crc32("NpNfXYoyANoztPx",15) == 991010730) strcat(s, "n");
if (crc32("DWiDhenf",8) == 1127100479) strcat(s, "g");
if (crc32("qKGmFTYznnQlDX",14) == 88746324) strcat(s, "k");
if (crc32("jhRZOhcGzyApg",13) == 429978782) strcat(s, "r");
if (crc32("rDdyMKTerleOav",14) == 2655138818) strcat(s, "a");
if (crc32("yCAyrjQixXa",11) == 3718212665) strcat(s, "a");
if (crc32("bPYDCxXKpdA",11) == 726806508) strcat(s, "t");
if (crc32("cCJDUe",6) == 3532341935) strcat(s, "m");
if (crc32("JtOnjvcWXIJmcO",14) == 745323882) strcat(s, "e");
if (crc32("JKxZSlCsTLJfM",13) == 948418808) strcat(s, "A");
if (crc32("vfVogCUzzOR",11) == 824464382) strcat(s, "d");
    return s;
}

char *subinfer_verbs() {
    char *s = calloc(9);
    if (crc32("ShSqSFy",7) == 650535539) strcat(s, "s");
if (crc32("TgaqyLAdczXxPZ",14) == 2558929147) strcat(s, "R");
if (crc32("xihyEAbQaPLZv",13) == 4279705684) strcat(s, "u");
if (crc32("uwRVqGdOqLvW",12) == 592346866) strcat(s, "l");
if (crc32("MWVvN",5) == 2964044827) strcat(s, "b");
if (crc32("yllUAE",6) == 897452125) strcat(s, "i");
if (crc32("axOsO",5) == 1431084378) strcat(s, "n");
if (crc32("hjxQQhEPPeT",11) == 1140100934) strcat(s, "H");
if (crc32("EZbpK",5) == 2011377986) strcat(s, "f");
if (crc32("YjEyRuIoa",9) == 4200859083) strcat(s, "e");
if (crc32("EKdZr",5) == 555963711) strcat(s, "f");
if (crc32("abfcNVNgMMoE",12) == 3996160176) strcat(s, "r");
    return s;
}

char *procured_verbs() {
    char *s = calloc(9);
    if (crc32("XFVAlGj",7) == 3831440406) strcat(s, "z");
if (crc32("UnDqCxlWU",9) == 1970920278) strcat(s, "p");
if (crc32("aUumwMi",7) == 1455544018) strcat(s, "c");
if (crc32("uweCMMYtSwvqy",13) == 3507621787) strcat(s, "r");
if (crc32("yMqLhWvQxiYo",12) == 1516986247) strcat(s, "z");
if (crc32("tIkorXqZgZY",11) == 1954413971) strcat(s, "o");
if (crc32("Cgwnnrc",7) == 3868130859) strcat(s, "c");
if (crc32("kGWgtljM",8) == 1635320046) strcat(s, "u");
if (crc32("WrMRzx",6) == 2920495119) strcat(s, "r");
if (crc32("iSgWXh",6) == 528712595) strcat(s, "e");
if (crc32("nOPJSKN",7) == 2508093983) strcat(s, "K");
if (crc32("tibHydNjLDT",11) == 1480429038) strcat(s, "d");
    return s;
}

char *getacross_verbs() {
    char *s = calloc(10);
    if (crc32("zXBVhc",6) == 1661900332) strcat(s, "N");
if (crc32("KZQeIMNH",8) == 2295543369) strcat(s, "g");
if (crc32("jDHdvKnTzUBGWWI",15) == 2881410022) strcat(s, "f");
if (crc32("lYwyyuaqcRLR",12) == 2294029693) strcat(s, "e");
if (crc32("GPWihf",6) == 2208675530) strcat(s, "t");
if (crc32("wuIPJA",6) == 2293083920) strcat(s, "H");
if (crc32("QnjPh",5) == 2755292062) strcat(s, "a");
if (crc32("xlkuCx",6) == 837192498) strcat(s, "c");
if (crc32("RrvafXK",7) == 1276156300) strcat(s, "p");
if (crc32("TRdsyIyxpnkP",12) == 911175899) strcat(s, "r");
if (crc32("WcTGROBzfeIk",12) == 2759536937) strcat(s, "M");
if (crc32("abAluVzCEET",11) == 2826958004) strcat(s, "o");
if (crc32("wrzdDtLyViIkWi",14) == 3135409460) strcat(s, "s");
if (crc32("zxdbzeVKhGBZAk",14) == 1700935980) strcat(s, "s");
    return s;
}

char *miking_verbs() {
    char *s = calloc(7);
    if (crc32("ghtVu",5) == 2362719297) strcat(s, "m");
if (crc32("jAyrgYIIfH",10) == 4273311391) strcat(s, "y");
if (crc32("YMVHROFVTmvrG",13) == 3267760734) strcat(s, "i");
if (crc32("mwgcCKpT",8) == 2050477872) strcat(s, "k");
if (crc32("uXruImWHmIPYiG",14) == 1601850249) strcat(s, "t");
if (crc32("qZMCoFqOpmrtrn",14) == 1693991728) strcat(s, "i");
if (crc32("qrjUw",5) == 1056675) strcat(s, "J");
if (crc32("VuedrsFqgZcVw",13) == 534841874) strcat(s, "n");
if (crc32("BZJNirf",7) == 2607727097) strcat(s, "N");
if (crc32("yxbVpN",6) == 319303247) strcat(s, "g");
    return s;
}

char *prepracticing_verbs() {
    char *s = calloc(14);
    if (crc32("wjSHx",5) == 1174916166) strcat(s, "n");
if (crc32("ZETIwcsqtcYeAlx",15) == 2462670033) strcat(s, "p");
if (crc32("IazsJ",5) == 3676713598) strcat(s, "r");
if (crc32("VLKpmBUNmooHp",13) == 1968356005) strcat(s, "d");
if (crc32("icWdkXgmSQZK",12) == 2703979384) strcat(s, "e");
if (crc32("YDNDU",5) == 3070435618) strcat(s, "h");
if (crc32("NOpKDyIHBBliaW",14) == 1167865360) strcat(s, "p");
if (crc32("fcjwCBSJ",8) == 1624331479) strcat(s, "h");
if (crc32("MfIabuAZaoErQ",13) == 3371555204) strcat(s, "r");
if (crc32("dpywnNIZgdem",12) == 2033900935) strcat(s, "a");
if (crc32("kRUbZUUgGsj",11) == 1591528592) strcat(s, "c");
if (crc32("VSykSohuzJ",10) == 1492690702) strcat(s, "t");
if (crc32("DxnWNjMqArl",11) == 3517401921) strcat(s, "m");
if (crc32("YluBct",6) == 4039566993) strcat(s, "i");
if (crc32("thIHrYtciZP",11) == 1793948321) strcat(s, "U");
if (crc32("kRgsoDaDxbSpxB",14) == 3119231530) strcat(s, "c");
if (crc32("UppXBBu",7) == 2180391607) strcat(s, "i");
if (crc32("nQfsRtNxnlZghzs",15) == 2738420353) strcat(s, "n");
if (crc32("bYFvADR",7) == 1393284106) strcat(s, "g");
    return s;
}

char *retried_verbs() {
    char *s = calloc(8);
    if (crc32("ZqgJEUciu",9) == 2379940037) strcat(s, "O");
if (crc32("DNfkwabP",8) == 1876154018) strcat(s, "r");
if (crc32("knjbIodajLVe",12) == 350123121) strcat(s, "e");
if (crc32("hDlbYUhbtEm",11) == 30336048) strcat(s, "t");
if (crc32("KQOYOisOdQav",12) == 1099227659) strcat(s, "s");
if (crc32("lPJSsjRqgIiAq",13) == 2044400953) strcat(s, "r");
if (crc32("ePxnPsvxU",9) == 472358051) strcat(s, "s");
if (crc32("cibBgFi",7) == 99848149) strcat(s, "i");
if (crc32("QnLGT",5) == 2987829725) strcat(s, "e");
if (crc32("rPlEqbYi",8) == 2134994465) strcat(s, "O");
if (crc32("ikmLhLSkMBGLm",13) == 2734100585) strcat(s, "d");
    return s;
}

char *vesiculated_verbs() {
    char *s = calloc(12);
    if (crc32("twSVXRFnxcu",11) == 2148806212) strcat(s, "v");
if (crc32("QHbEEpBemB",10) == 4108918948) strcat(s, "p");
if (crc32("pUCzUPFgeCfH",12) == 3220349959) strcat(s, "e");
if (crc32("hWKwsNbWML",10) == 1393730381) strcat(s, "Y");
if (crc32("cFIfGgoAAeY",11) == 2186416326) strcat(s, "s");
if (crc32("WEilTyfDSeSqkph",15) == 1971460449) strcat(s, "c");
if (crc32("ARxwTbhKc",9) == 739065427) strcat(s, "i");
if (crc32("NggPENqAXELkP",13) == 2200605933) strcat(s, "n");
if (crc32("UUgRvTXm",8) == 984347655) strcat(s, "c");
if (crc32("GwTLoaRx",8) == 3587084161) strcat(s, "N");
if (crc32("SYHEkmrnpWkPXB",14) == 3478344146) strcat(s, "u");
if (crc32("mJFTXOFiuuCuyuG",15) == 2955304271) strcat(s, "j");
if (crc32("ugvtmmW",7) == 3243357306) strcat(s, "l");
if (crc32("qbCBSDt",7) == 294041426) strcat(s, "a");
if (crc32("jdGNQ",5) == 2795986953) strcat(s, "t");
if (crc32("hwfReda",7) == 3988123955) strcat(s, "D");
if (crc32("rSjmPlGyyAX",11) == 1790730305) strcat(s, "e");
if (crc32("hZzEmB",6) == 496288123) strcat(s, "d");
    return s;
}

char *flounced_verbs() {
    char *s = calloc(9);
    if (crc32("ScAEOSH",7) == 130075356) strcat(s, "I");
if (crc32("HVbNyl",6) == 3024642887) strcat(s, "f");
if (crc32("NFTtuYMeGZ",10) == 2050159911) strcat(s, "l");
if (crc32("YcAltQYcnfYV",12) == 83053836) strcat(s, "e");
if (crc32("vmtOGmBrlAcZ",12) == 404095403) strcat(s, "o");
if (crc32("QqNBqGBRHamNv",13) == 1980947710) strcat(s, "J");
if (crc32("gUfiPgTy",8) == 4126526063) strcat(s, "u");
if (crc32("ExkTREtnrBBJiP",14) == 1209741220) strcat(s, "n");
if (crc32("oJzMPCt",7) == 442515748) strcat(s, "a");
if (crc32("nfBWdZ",6) == 1200616366) strcat(s, "c");
if (crc32("szwxGUcaH",9) == 3681427868) strcat(s, "v");
if (crc32("RtkwfQ",6) == 1854205380) strcat(s, "e");
if (crc32("IZyrlPVxNQjBcq",14) == 388305495) strcat(s, "O");
if (crc32("UPkreqXopjmfgGn",15) == 4136026876) strcat(s, "d");
    return s;
}

char *radiated_verbs() {
    char *s = calloc(9);
    if (crc32("tOOkaiANp",9) == 3327180299) strcat(s, "r");
if (crc32("jwREvdOb",8) == 155466872) strcat(s, "a");
if (crc32("GxDFNqOOs",9) == 3143749694) strcat(s, "d");
if (crc32("TxMxTl",6) == 2716826542) strcat(s, "e");
if (crc32("bgnyWsYyRm",10) == 1264182451) strcat(s, "i");
if (crc32("KkqDXhthCJLXlHa",15) == 2934051067) strcat(s, "H");
if (crc32("iVMcyywtftVTLN",14) == 1338966156) strcat(s, "a");
if (crc32("WPPcPWVchmXIO",13) == 590713143) strcat(s, "t");
if (crc32("tKLqpSkxvkFA",12) == 1681907180) strcat(s, "U");
if (crc32("zkOcTwUGtxRxGaN",15) == 4234336013) strcat(s, "e");
if (crc32("UXGEsw",6) == 1304732202) strcat(s, "z");
if (crc32("xTZnofmvSbsl",12) == 1523296531) strcat(s, "d");
    return s;
}

char *misspell_verbs() {
    char *s = calloc(9);
    if (crc32("eiXmyGzqMaEn",12) == 3162842617) strcat(s, "m");
if (crc32("eIIyRsmiWQCkeX",14) == 180993295) strcat(s, "C");
if (crc32("WkgzINdW",8) == 2103781292) strcat(s, "i");
if (crc32("PUvLtBqnhlV",11) == 4193718491) strcat(s, "s");
if (crc32("zWSiDnBN",8) == 2783740477) strcat(s, "s");
if (crc32("dnpUUjcjwm",10) == 4073970295) strcat(s, "M");
if (crc32("CcpyVBqSYYQ",11) == 1453765766) strcat(s, "p");
if (crc32("JfYWMsGrtLEwZY",14) == 3496710180) strcat(s, "P");
if (crc32("EijGf",5) == 1320602612) strcat(s, "e");
if (crc32("bLbmDezog",9) == 749882050) strcat(s, "X");
if (crc32("LoTFmkecaLsOvp",14) == 1057606085) strcat(s, "l");
if (crc32("mXVrdkf",7) == 296106553) strcat(s, "C");
if (crc32("xeDUaEUSgH",10) == 1609773963) strcat(s, "l");
    return s;
}

char *enameled_verbs() {
    char *s = calloc(9);
    if (crc32("yDRwm",5) == 1511551307) strcat(s, "J");
if (crc32("joBfpzinTiDK",12) == 1416232003) strcat(s, "e");
if (crc32("JQIqQtno",8) == 2576092687) strcat(s, "O");
if (crc32("mPptwYmIedMTyp",14) == 1090914086) strcat(s, "n");
if (crc32("EFDqyNG",7) == 2380539233) strcat(s, "R");
if (crc32("DECnHXEVQjnaxh",14) == 738181272) strcat(s, "a");
if (crc32("NVJYw",5) == 2035882966) strcat(s, "x");
if (crc32("zfLyb",5) == 1338773955) strcat(s, "m");
if (crc32("ozZzpPWVogHEj",13) == 3919805461) strcat(s, "e");
if (crc32("pviblyQDqpXUI",13) == 241554846) strcat(s, "g");
if (crc32("KBIfEYHp",8) == 1533457866) strcat(s, "l");
if (crc32("aDDtso",6) == 172999549) strcat(s, "I");
if (crc32("yTdxgyLEUrXPgj",14) == 246496559) strcat(s, "e");
if (crc32("yvzcNvkaZrCY",12) == 533495630) strcat(s, "d");
    return s;
}

char *releveled_verbs() {
    char *s = calloc(10);
    if (crc32("vOPdjaxeeOEHy",13) == 1344269350) strcat(s, "r");
if (crc32("VUYOOVxDtCy",11) == 2663928615) strcat(s, "e");
if (crc32("ivtcWRCLAFOS",12) == 2440409100) strcat(s, "v");
if (crc32("ZRTrylcMPgD",11) == 187131219) strcat(s, "l");
if (crc32("QXKkcAHNZoNi",12) == 1026797542) strcat(s, "g");
if (crc32("HuaMSPBPd",9) == 3459280804) strcat(s, "e");
if (crc32("DuZxP",5) == 3658895446) strcat(s, "v");
if (crc32("MJOhaLTxUbgr",12) == 2983247170) strcat(s, "L");
if (crc32("XDDXwNfOKgMDVb",14) == 4042916815) strcat(s, "e");
if (crc32("mFkStaXsJYC",11) == 1056632508) strcat(s, "F");
if (crc32("AXoMZNguG",9) == 2568729190) strcat(s, "l");
if (crc32("iILcnJzPLGPR",12) == 309298233) strcat(s, "f");
if (crc32("CDdlgkNo",8) == 3965151540) strcat(s, "e");
if (crc32("jzGpOmzNzWnz",12) == 1484850256) strcat(s, "d");
    return s;
}

char *shoved_verbs() {
    char *s = calloc(7);
    if (crc32("AUUMBid",7) == 3630931473) strcat(s, "b");
if (crc32("xHDEQWsZOFaGR",13) == 2586132565) strcat(s, "s");
if (crc32("GplPklArxc",10) == 2997866134) strcat(s, "h");
if (crc32("qHGRXKCleBckLZJ",15) == 3357552202) strcat(s, "o");
if (crc32("zZzfoANUeDj",11) == 2142354076) strcat(s, "v");
if (crc32("ZGjxSlGA",8) == 367889674) strcat(s, "m");
if (crc32("VLRrSmEWarTGqR",14) == 3842681498) strcat(s, "e");
if (crc32("eyrjRfwMCQuNqO",14) == 4116866872) strcat(s, "d");
    return s;
}

char *blarneying_verbs() {
    char *s = calloc(11);
    if (crc32("FxUrw",5) == 101040439) strcat(s, "b");
if (crc32("uJzwsvht",8) == 2684819085) strcat(s, "y");
if (crc32("mEIjurbLYsBDwN",14) == 2830634936) strcat(s, "l");
if (crc32("VhQCe",5) == 68280076) strcat(s, "a");
if (crc32("BcYsBFVmMFIIk",13) == 3801170056) strcat(s, "r");
if (crc32("hGCyDEN",7) == 3446358475) strcat(s, "y");
if (crc32("pfjONJETaIs",11) == 3213185388) strcat(s, "n");
if (crc32("HOUolAzNLnPf",12) == 1900966417) strcat(s, "e");
if (crc32("pgGvgHOG",8) == 2632046407) strcat(s, "Q");
if (crc32("TjEMltOAsmruRb",14) == 1322318855) strcat(s, "y");
if (crc32("YTpCXbIJCeUUsj",14) == 319112143) strcat(s, "i");
if (crc32("vZzfENHLdZRuFp",14) == 3037813154) strcat(s, "n");
if (crc32("LqewCuFcQAliQ",13) == 3354116280) strcat(s, "g");
    return s;
}

char *lobbing_verbs() {
    char *s = calloc(8);
    if (crc32("xUeVGJjNiMcZiJ",14) == 1732167245) strcat(s, "H");
if (crc32("ZcBXVF",6) == 3802756710) strcat(s, "l");
if (crc32("hlgSKyExBnpK",12) == 1374967356) strcat(s, "o");
if (crc32("zQtfMmyimR",10) == 1909939810) strcat(s, "b");
if (crc32("zsiniVeMVAoG",12) == 2300813146) strcat(s, "b");
if (crc32("PyFlkyVn",8) == 1037786938) strcat(s, "i");
if (crc32("FkHOIcTHPaNgDYv",15) == 124194511) strcat(s, "A");
if (crc32("IfAWupYEsAUxP",13) == 982615184) strcat(s, "n");
if (crc32("vLaiuTsUOjz",11) == 1119936789) strcat(s, "g");
    return s;
}

char *pitting_verbs() {
    char *s = calloc(8);
    if (crc32("qmBVWvgyhfPLpfV",15) == 681637977) strcat(s, "b");
if (crc32("bZkuRIkc",8) == 1874177432) strcat(s, "p");
if (crc32("rlKQr",5) == 1436815917) strcat(s, "i");
if (crc32("uuVJYIEzE",9) == 543369474) strcat(s, "t");
if (crc32("hECmAyKYKcj",11) == 2650626410) strcat(s, "t");
if (crc32("czPXG",5) == 3931412391) strcat(s, "i");
if (crc32("bYNJQUbphU",10) == 1893677339) strcat(s, "n");
if (crc32("LrGlKWFwDh",10) == 1727325660) strcat(s, "H");
if (crc32("SRGIN",5) == 496993969) strcat(s, "g");
    return s;
}

char *boweled_verbs() {
    char *s = calloc(8);
    if (crc32("TezJYuseUBvL",12) == 779538408) strcat(s, "j");
if (crc32("FzYbwUOdjDIq",12) == 4024920728) strcat(s, "b");
if (crc32("xYKGjPxCCvVZlkd",15) == 1484967085) strcat(s, "o");
if (crc32("Klviwr",6) == 1605906830) strcat(s, "w");
if (crc32("YdCvyfRgamJLACx",15) == 1006888251) strcat(s, "t");
if (crc32("DsMxxnAlqaD",11) == 3783171907) strcat(s, "e");
if (crc32("dhWNkcKVhd",10) == 3902021871) strcat(s, "l");
if (crc32("AvVapdIkUQvprw",14) == 4171659859) strcat(s, "p");
if (crc32("DOSJjYzkybB",11) == 1579064452) strcat(s, "e");
if (crc32("qvybLNXdsbNGDy",14) == 3152744351) strcat(s, "d");
    return s;
}

char *glozed_verbs() {
    char *s = calloc(7);
    if (crc32("cNwENQgApTTfjOU",15) == 4011927272) strcat(s, "g");
if (crc32("CLOKUBdQVQxinJ",14) == 1506706610) strcat(s, "l");
if (crc32("pXepGTg",7) == 3554683520) strcat(s, "o");
if (crc32("gkyDPIMfMQpD",12) == 3464651711) strcat(s, "b");
if (crc32("ZWWIgpFAf",9) == 3912952222) strcat(s, "z");
if (crc32("rXOcUE",6) == 3084363903) strcat(s, "e");
if (crc32("hEiSM",5) == 492281995) strcat(s, "d");
    return s;
}

char *investigating_verbs() {
    char *s = calloc(14);
    if (crc32("zezAhQBLt",9) == 903486815) strcat(s, "i");
if (crc32("ySsYkFbjpMCZjMm",15) == 1582122466) strcat(s, "n");
if (crc32("TmHCuva",7) == 240439040) strcat(s, "v");
if (crc32("CXSfUJAKKHIa",12) == 3154615209) strcat(s, "e");
if (crc32("xrXrgoXk",8) == 1339523408) strcat(s, "s");
if (crc32("qEmAnjuUmIOZ",12) == 2234919303) strcat(s, "t");
if (crc32("yXrYSMWKoFJq",12) == 3592266346) strcat(s, "i");
if (crc32("hIQNOTwJqIeg",12) == 4242519243) strcat(s, "g");
if (crc32("rsFdlvguO",9) == 2237338585) strcat(s, "D");
if (crc32("KMLytPhmK",9) == 387335051) strcat(s, "a");
if (crc32("UQpgs",5) == 3565595245) strcat(s, "p");
if (crc32("SdKppzUfOoRmLds",15) == 3810736430) strcat(s, "t");
if (crc32("wjmeahvhDUOj",12) == 3893763246) strcat(s, "R");
if (crc32("FrTkLXMJzVjsv",13) == 2873588663) strcat(s, "i");
if (crc32("uayxf",5) == 1822256264) strcat(s, "n");
if (crc32("ZsJbWklSOCPDN",13) == 1333971262) strcat(s, "J");
if (crc32("LGYBJ",5) == 1791603431) strcat(s, "g");
    return s;
}

char *hurtled_verbs() {
    char *s = calloc(8);
    if (crc32("JiomQzDklLRxMEE",15) == 2017275360) strcat(s, "E");
if (crc32("SKofhKvgjZ",10) == 3492281954) strcat(s, "h");
if (crc32("KJbCPgMrtd",10) == 4043112701) strcat(s, "b");
if (crc32("ljmBGUMIGwce",12) == 2691567767) strcat(s, "u");
if (crc32("hIYYQBf",7) == 2240071335) strcat(s, "r");
if (crc32("OqHvED",6) == 608071238) strcat(s, "A");
if (crc32("XPnPqKcj",8) == 2250402486) strcat(s, "t");
if (crc32("arEfCrpfWgf",11) == 3004287677) strcat(s, "y");
if (crc32("aVjKDzTxB",9) == 3379657043) strcat(s, "l");
if (crc32("RKwCTJola",9) == 648771737) strcat(s, "Z");
if (crc32("hQQWmxui",8) == 1541868692) strcat(s, "e");
if (crc32("xqTTSxYOjvhyowj",15) == 1427341817) strcat(s, "u");
if (crc32("lsNjMWLZk",9) == 3604414524) strcat(s, "d");
    return s;
}

char *jogged_verbs() {
    char *s = calloc(7);
    if (crc32("OALfjMLkTW",10) == 1678942949) strcat(s, "j");
if (crc32("iZdXYBoNLRfGg",13) == 74066054) strcat(s, "K");
if (crc32("mqMSgoVeLnN",11) == 45758628) strcat(s, "o");
if (crc32("XZiCfUjfLRPTBu",14) == 969741992) strcat(s, "g");
if (crc32("ARDnDFhPKxS",11) == 2454556784) strcat(s, "L");
if (crc32("ICIBPP",6) == 3256130087) strcat(s, "g");
if (crc32("pvcqpjQbkqbpbhn",15) == 2374737534) strcat(s, "e");
if (crc32("WiRLbmik",8) == 291800077) strcat(s, "O");
if (crc32("aPvmu",5) == 155001593) strcat(s, "d");
    return s;
}

char *pieced_verbs() {
    char *s = calloc(7);
    if (crc32("CIbFzRWpivaN",12) == 1944329625) strcat(s, "p");
if (crc32("qKsojfmqOC",10) == 2105662986) strcat(s, "g");
if (crc32("dtErnZkCTCWy",12) == 1837688777) strcat(s, "i");
if (crc32("dVQPXB",6) == 2019186996) strcat(s, "K");
if (crc32("CNpDFDM",7) == 3625366141) strcat(s, "e");
if (crc32("jUmcSLOKJBDsXX",14) == 3790093448) strcat(s, "c");
if (crc32("QVAHZ",5) == 2046622684) strcat(s, "s");
if (crc32("OUuJTVlJuGN",11) == 2854441667) strcat(s, "e");
if (crc32("RHsPh",5) == 1966373203) strcat(s, "d");
    return s;
}

char *automate_verbs() {
    char *s = calloc(9);
    if (crc32("iYDxqpkTwAdc",12) == 1616872292) strcat(s, "a");
if (crc32("Nhuzmn",6) == 1376522926) strcat(s, "u");
if (crc32("NnaCypAAQO",10) == 3199229809) strcat(s, "j");
if (crc32("pvJlTH",6) == 3754320610) strcat(s, "t");
if (crc32("sHWEffPdVMUarc",14) == 2421735067) strcat(s, "o");
if (crc32("yiIGDfWej",9) == 3645090057) strcat(s, "m");
if (crc32("VXbKoNYMzp",10) == 2580760840) strcat(s, "M");
if (crc32("zBiUyC",6) == 70845034) strcat(s, "a");
if (crc32("qoNTOtldUEerWWw",15) == 1916472306) strcat(s, "t");
if (crc32("LOtOUsbxqn",10) == 1754502945) strcat(s, "o");
if (crc32("mBxjPUBjH",9) == 113125063) strcat(s, "e");
    return s;
}

char *grabbed_verbs() {
    char *s = calloc(8);
    if (crc32("CWoTiVHAhDcn",12) == 4194694981) strcat(s, "o");
if (crc32("OTDxICNdUyrBg",13) == 3684775355) strcat(s, "g");
if (crc32("vxIbISxMtDQKc",13) == 947997887) strcat(s, "r");
if (crc32("ziWxVUrxWMaCm",13) == 1278787469) strcat(s, "a");
if (crc32("htlEnj",6) == 137096176) strcat(s, "a");
if (crc32("XnedFFFmcoXJwkX",15) == 2936235702) strcat(s, "b");
if (crc32("FTSzgjKtSvSlt",13) == 1140699781) strcat(s, "b");
if (crc32("puyBXZj",7) == 2665644974) strcat(s, "K");
if (crc32("qCPCmwrkkvGj",12) == 2981513645) strcat(s, "e");
if (crc32("JoSbCvad",8) == 646807458) strcat(s, "d");
    return s;
}

char *conceptualize_verbs() {
    char *s = calloc(14);
    if (crc32("sSmCNUSluvIgVk",14) == 2513651325) strcat(s, "c");
if (crc32("mtenmVknuXmlD",13) == 3441234868) strcat(s, "o");
if (crc32("wogxuZANFKxrt",13) == 553960365) strcat(s, "a");
if (crc32("RFkMSwJuF",9) == 1451883431) strcat(s, "n");
if (crc32("wkHVWya",7) == 276268734) strcat(s, "L");
if (crc32("JJYAVriNYEne",12) == 1073364311) strcat(s, "c");
if (crc32("NlriTT",6) == 1808346938) strcat(s, "K");
if (crc32("AXkNCuT",7) == 1182165436) strcat(s, "e");
if (crc32("WootVV",6) == 3850326202) strcat(s, "p");
if (crc32("EefmGROE",8) == 2128632269) strcat(s, "R");
if (crc32("uJVXi",5) == 763657305) strcat(s, "t");
if (crc32("skZmwprS",8) == 1334387239) strcat(s, "u");
if (crc32("LkmLUqsdL",9) == 3404287281) strcat(s, "a");
if (crc32("QMuZVB",6) == 2014597469) strcat(s, "E");
if (crc32("lFolgUpxGOKLVA",14) == 42672095) strcat(s, "l");
if (crc32("SaJTxNJc",8) == 4206400456) strcat(s, "i");
if (crc32("tAWQTzTqJMBaYqv",15) == 1114154612) strcat(s, "e");
if (crc32("FpziOcj",7) == 3702040772) strcat(s, "z");
if (crc32("qptXyoEskHWIQ",13) == 2186083335) strcat(s, "e");
    return s;
}

char *sutured_verbs() {
    char *s = calloc(8);
    if (crc32("cgMrzQYuOapLnY",14) == 2665012124) strcat(s, "o");
if (crc32("szNaoTvTNDRzDL",14) == 1994259033) strcat(s, "s");
if (crc32("epSryPElIHbWvWb",15) == 2659475972) strcat(s, "u");
if (crc32("cKjZFpobLMTHwxs",15) == 4231895366) strcat(s, "e");
if (crc32("gLweJmrKF",9) == 3515350606) strcat(s, "t");
if (crc32("huzfX",5) == 22681879) strcat(s, "w");
if (crc32("kWudJeu",7) == 3318276738) strcat(s, "u");
if (crc32("KLOBGbSwTiiODV",14) == 3766741302) strcat(s, "r");
if (crc32("mWrqscS",7) == 3692187745) strcat(s, "e");
if (crc32("WhmopsepAXZB",12) == 1055653929) strcat(s, "p");
if (crc32("dvpoiHu",7) == 4205899487) strcat(s, "d");
    return s;
}

char *overlook_verbs() {
    char *s = calloc(9);
    if (crc32("LOyglKpvqfysQz",14) == 3178874235) strcat(s, "r");
if (crc32("YpsgrnjvaDj",11) == 696589747) strcat(s, "o");
if (crc32("xuaJQiCTJezeD",13) == 759151242) strcat(s, "v");
if (crc32("TGPpcDBlMC",10) == 755942317) strcat(s, "w");
if (crc32("amcqaqWHMmd",11) == 3280831) strcat(s, "e");
if (crc32("dqxTX",5) == 1139391140) strcat(s, "I");
if (crc32("xXvzEXX",7) == 2980437902) strcat(s, "r");
if (crc32("MHDnrRmrV",9) == 2349782438) strcat(s, "l");
if (crc32("wPRNtE",6) == 2265991610) strcat(s, "X");
if (crc32("cSGlSfApaEZF",12) == 659396369) strcat(s, "o");
if (crc32("prAPGYs",7) == 1370459302) strcat(s, "n");
if (crc32("niEGB",5) == 4155846893) strcat(s, "o");
if (crc32("doxlSJEza",9) == 1431085768) strcat(s, "Z");
if (crc32("RDMPDmupZnfxhS",14) == 516160109) strcat(s, "k");
    return s;
}

char *sensitizing_verbs() {
    char *s = calloc(12);
    if (crc32("SHanOmzitO",10) == 1647523934) strcat(s, "s");
if (crc32("XlfmcCXcsMmQP",13) == 3959837924) strcat(s, "F");
if (crc32("DWoNheg",7) == 3516041288) strcat(s, "e");
if (crc32("GlUUMUXUgpXEq",13) == 1122657751) strcat(s, "n");
if (crc32("yjDSUThZZqcdB",13) == 3910363400) strcat(s, "o");
if (crc32("cELsGV",6) == 368318433) strcat(s, "s");
if (crc32("hxXKKtXhjdfhuO",14) == 2636541779) strcat(s, "i");
if (crc32("GQzvUGvo",8) == 2930622234) strcat(s, "U");
if (crc32("ZUNTQKlyTKLti",13) == 1516664985) strcat(s, "t");
if (crc32("OBZNrrAH",8) == 3278178045) strcat(s, "a");
if (crc32("KrRSIUpRIiUqit",14) == 2151453787) strcat(s, "i");
if (crc32("pQeWmo",6) == 1380934228) strcat(s, "w");
if (crc32("IKzqalhggLgLLfR",15) == 1049767729) strcat(s, "z");
if (crc32("dtENfWFH",8) == 468455838) strcat(s, "x");
if (crc32("GJrWauSrPJgd",12) == 2453432747) strcat(s, "i");
if (crc32("ZfkxFzgONIdcP",13) == 533074052) strcat(s, "U");
if (crc32("NOAbktVShOqGr",13) == 3392829679) strcat(s, "n");
if (crc32("HkDtDZxSohuHOUJ",15) == 3481390431) strcat(s, "g");
    return s;
}

char *resawing_verbs() {
    char *s = calloc(9);
    if (crc32("ngTUwNHbCAa",11) == 1411541166) strcat(s, "N");
if (crc32("GwxPcw",6) == 2867584400) strcat(s, "r");
if (crc32("MXvQQTqkmRCgYiN",15) == 2141119766) strcat(s, "e");
if (crc32("pjOgGYTJPgY",11) == 3118583080) strcat(s, "w");
if (crc32("jLXAQrabruFC",12) == 504621147) strcat(s, "s");
if (crc32("oawwj",5) == 3263012421) strcat(s, "a");
if (crc32("FoGKyJ",6) == 1633272026) strcat(s, "w");
if (crc32("NNCayHrRfUFW",12) == 4294463672) strcat(s, "i");
if (crc32("oACZQcZ",7) == 929379309) strcat(s, "n");
if (crc32("EeNIEfwomH",10) == 884560206) strcat(s, "g");
    return s;
}

char *dryout_verbs() {
    char *s = calloc(7);
    if (crc32("DOrvilx",7) == 3247330304) strcat(s, "P");
if (crc32("wlweQrOy",8) == 2997414558) strcat(s, "d");
if (crc32("ArqTRruhiWnHtec",15) == 1951922999) strcat(s, "r");
if (crc32("RFYXtXYZR",9) == 2809684401) strcat(s, "y");
if (crc32("ZthaJigs",8) == 3789064678) strcat(s, "m");
if (crc32("UlBuwXAYfFSI",12) == 383540143) strcat(s, "o");
if (crc32("hpCsKX",6) == 4136005840) strcat(s, "Q");
if (crc32("nPFhdgE",7) == 10402231) strcat(s, "u");
if (crc32("dIDZejlQC",9) == 2822716619) strcat(s, "F");
if (crc32("PvBzQKUJ",8) == 284529102) strcat(s, "t");
    return s;
}

char *vibrating_verbs() {
    char *s = calloc(10);
    if (crc32("KWnSVYMUA",9) == 1767766439) strcat(s, "R");
if (crc32("lfTFyLGRpIuxifl",15) == 1968179227) strcat(s, "v");
if (crc32("bhbdXHvfJvGruMI",15) == 2518604021) strcat(s, "T");
if (crc32("fsxOPSqGa",9) == 4214471146) strcat(s, "i");
if (crc32("pwgRybgGMu",10) == 2519108334) strcat(s, "b");
if (crc32("AxyCrEWV",8) == 2893669800) strcat(s, "r");
if (crc32("IDBxUN",6) == 2646894881) strcat(s, "X");
if (crc32("tPlXCBvTak",10) == 3516724791) strcat(s, "a");
if (crc32("nEpUPaev",8) == 1851105050) strcat(s, "t");
if (crc32("OsKCBpDRSpbqr",13) == 1014981625) strcat(s, "i");
if (crc32("eOaXC",5) == 2149916970) strcat(s, "n");
if (crc32("lnXzQjLxG",9) == 76218261) strcat(s, "g");
    return s;
}

char *particularize_verbs() {
    char *s = calloc(14);
    if (crc32("TFWTpGR",7) == 856158671) strcat(s, "p");
if (crc32("MsHvHmg",7) == 3624337276) strcat(s, "E");
if (crc32("ukiLs",5) == 3388029056) strcat(s, "a");
if (crc32("jnfZPVigSr",10) == 3208245259) strcat(s, "r");
if (crc32("DYzSEEDIkhHKccu",15) == 3536443596) strcat(s, "t");
if (crc32("piIYbyK",7) == 495449353) strcat(s, "A");
if (crc32("tGUZpnWPP",9) == 787412072) strcat(s, "i");
if (crc32("TotZmkIK",8) == 1725686191) strcat(s, "c");
if (crc32("NXjbeVlQXLKwsT",14) == 845473972) strcat(s, "N");
if (crc32("RUUCWZWgVpuwib",14) == 2090240974) strcat(s, "u");
if (crc32("xDUQGTxfOkgC",12) == 1112263104) strcat(s, "l");
if (crc32("osdBuQzAQXLZ",12) == 116327402) strcat(s, "a");
if (crc32("PVYFOc",6) == 295847513) strcat(s, "X");
if (crc32("wDRcUwfLUEnf",12) == 924014490) strcat(s, "r");
if (crc32("LtHyoeLrriU",11) == 530285203) strcat(s, "i");
if (crc32("TXeVNIrBH",9) == 2697973131) strcat(s, "z");
if (crc32("EVFKTF",6) == 1542722281) strcat(s, "j");
if (crc32("dibNHF",6) == 4205922105) strcat(s, "e");
    return s;
}

char *overfeast_verbs() {
    char *s = calloc(10);
    if (crc32("vjwtNHNrLESMyx",14) == 3272146758) strcat(s, "S");
if (crc32("blupgOTqjurytw",14) == 1150296235) strcat(s, "o");
if (crc32("ehOBYew",7) == 209673788) strcat(s, "c");
if (crc32("CzUNlFAbaBx",11) == 1975253946) strcat(s, "v");
if (crc32("auoDSz",6) == 270313975) strcat(s, "t");
if (crc32("zsquorJOsF",10) == 2065129121) strcat(s, "e");
if (crc32("TPEPn",5) == 2694926829) strcat(s, "q");
if (crc32("ObwFLLjlCApMvBO",15) == 2131556833) strcat(s, "r");
if (crc32("EPuEiiMXpMRO",12) == 786962898) strcat(s, "N");
if (crc32("ZsoLHu",6) == 2695873378) strcat(s, "f");
if (crc32("MZOaRMxOJHtAvIp",15) == 922541910) strcat(s, "v");
if (crc32("uppQKpqsXFLaa",13) == 2598429625) strcat(s, "e");
if (crc32("hmeRagtvAbZVTK",14) == 1294172926) strcat(s, "q");
if (crc32("oWxcAuKZvI",10) == 3201507841) strcat(s, "a");
if (crc32("leSScMB",7) == 2757947445) strcat(s, "M");
if (crc32("ZuuUcxPMfC",10) == 1244314185) strcat(s, "s");
if (crc32("mtJYshAt",8) == 745489408) strcat(s, "t");
    return s;
}

char *nettled_verbs() {
    char *s = calloc(8);
    if (crc32("arsGSEmdUJn",11) == 2748661655) strcat(s, "F");
if (crc32("dtwfoctlBFXPVrE",15) == 2235083853) strcat(s, "n");
if (crc32("ruNzFCU",7) == 2844317186) strcat(s, "U");
if (crc32("fZyphX",6) == 2543723937) strcat(s, "e");
if (crc32("VXseFVSe",8) == 3690558637) strcat(s, "a");
if (crc32("tBhRKaHV",8) == 2272295464) strcat(s, "t");
if (crc32("KHiMXgk",7) == 927492916) strcat(s, "c");
if (crc32("rdejHuRUfWg",11) == 3127364321) strcat(s, "t");
if (crc32("sWBMpSzcMirYfav",15) == 1201701663) strcat(s, "e");
if (crc32("UnvlOSC",7) == 3701014224) strcat(s, "l");
if (crc32("GECYMcfelFGO",12) == 3537498052) strcat(s, "x");
if (crc32("QPEDIcpKGLcn",12) == 1816926459) strcat(s, "e");
if (crc32("JSLRfTn",7) == 864919276) strcat(s, "d");
    return s;
}

char *spell_verbs() {
    char *s = calloc(6);
    if (crc32("XHgRVXgd",8) == 797825050) strcat(s, "s");
if (crc32("JHZxOMgFlSf",11) == 3310757780) strcat(s, "j");
if (crc32("rblEiqBufjodTDn",15) == 3044075372) strcat(s, "p");
if (crc32("fjbdgRVlT",9) == 2155794243) strcat(s, "e");
if (crc32("SILaW",5) == 2951004068) strcat(s, "l");
if (crc32("SHFxsZZremd",11) == 3256572431) strcat(s, "l");
    return s;
}

char *tease_verbs() {
    char *s = calloc(6);
    if (crc32("tdJrCsPIosCJGoH",15) == 1668313365) strcat(s, "t");
if (crc32("pnYpMCpyPgKYR",13) == 931589815) strcat(s, "R");
if (crc32("gIQTF",5) == 658142085) strcat(s, "e");
if (crc32("vOKbhponiON",11) == 248246128) strcat(s, "a");
if (crc32("ULurFBlhRxoMn",13) == 2113823468) strcat(s, "s");
if (crc32("rEsgPTDOhrDYbXN",15) == 328844815) strcat(s, "x");
if (crc32("SlpNFIjWJGu",11) == 3845843530) strcat(s, "e");
    return s;
}

char *relating_verbs() {
    char *s = calloc(9);
    if (crc32("pcCXNzxO",8) == 3517679934) strcat(s, "r");
if (crc32("uiWnHCINKLQl",12) == 1163706660) strcat(s, "p");
if (crc32("vRizrZXjsrnhA",13) == 1036228510) strcat(s, "e");
if (crc32("yyMisjYFrO",10) == 2116848396) strcat(s, "l");
if (crc32("ogVDTCyNQSkpd",13) == 210623116) strcat(s, "m");
if (crc32("yKOvsPzm",8) == 3947394268) strcat(s, "a");
if (crc32("ezvTCOJb",8) == 4271170513) strcat(s, "t");
if (crc32("nTFlPajn",8) == 1159377598) strcat(s, "i");
if (crc32("PQkBJ",5) == 3239000275) strcat(s, "P");
if (crc32("jUaUTvCHXFTYQ",13) == 682770018) strcat(s, "n");
if (crc32("VxUgVgHs",8) == 217047341) strcat(s, "g");
    return s;
}

char *defrost_verbs() {
    char *s = calloc(8);
    if (crc32("vpUYuoxKfMKZvB",14) == 3331154475) strcat(s, "d");
if (crc32("sFtlNJ",6) == 3064249519) strcat(s, "e");
if (crc32("oAuJebNnJ",9) == 1605659829) strcat(s, "H");
if (crc32("RrTXnJBEHWEecAU",15) == 1373430009) strcat(s, "f");
if (crc32("YijQWjqoNu",10) == 885903435) strcat(s, "Z");
if (crc32("jVtusBTrPgFysn",14) == 2774349881) strcat(s, "r");
if (crc32("coZSnkOGxi",10) == 896357390) strcat(s, "o");
if (crc32("NEKnzHrmloJAjJS",15) == 2480305902) strcat(s, "s");
if (crc32("pKqQyyJl",8) == 1240883536) strcat(s, "t");
    return s;
}

char *overbrown_verbs() {
    char *s = calloc(10);
    if (crc32("tIEEqo",6) == 1159726870) strcat(s, "o");
if (crc32("zcfnGMGDoOwoHkn",15) == 1402465259) strcat(s, "v");
if (crc32("inifDnBBcU",10) == 3624012516) strcat(s, "e");
if (crc32("AiDzTzoSvw",10) == 240295079) strcat(s, "G");
if (crc32("vBYYLJmCeCl",11) == 1742777175) strcat(s, "r");
if (crc32("KOsKkobYAhMbu",13) == 1659837731) strcat(s, "b");
if (crc32("vWvIP",5) == 4240860211) strcat(s, "r");
if (crc32("IXALPmvP",8) == 159215879) strcat(s, "R");
if (crc32("eAttGcKXbGI",11) == 1796517141) strcat(s, "o");
if (crc32("kRCUUnPU",8) == 989217526) strcat(s, "w");
if (crc32("XybWwrXHoAP",11) == 1991533880) strcat(s, "n");
    return s;
}

char *undo_verbs() {
    char *s = calloc(5);
    if (crc32("pIYDgChzvfpOJj",14) == 615324977) strcat(s, "H");
if (crc32("CaXPdykAY",9) == 3291588896) strcat(s, "u");
if (crc32("uTpyNRRomGT",11) == 4033144955) strcat(s, "n");
if (crc32("IYLbBJmtpEldGR",14) == 393001424) strcat(s, "A");
if (crc32("IMOsq",5) == 2724850855) strcat(s, "d");
if (crc32("mbLkEFmxeTR",11) == 1924016610) strcat(s, "j");
if (crc32("ktSaoLNh",8) == 3919227656) strcat(s, "o");
    return s;
}

char *overregulating_verbs() {
    char *s = calloc(15);
    if (crc32("vVCUrwjPUg",10) == 3998175843) strcat(s, "o");
if (crc32("splOhhUu",8) == 3059547396) strcat(s, "k");
if (crc32("iqstIOyQJHdROy",14) == 2671799428) strcat(s, "v");
if (crc32("zcxtJlT",7) == 2000587921) strcat(s, "Q");
if (crc32("uhWEWXo",7) == 670991793) strcat(s, "e");
if (crc32("IacHpkbTVQJB",12) == 2764947845) strcat(s, "r");
if (crc32("SCLPwoXQpYi",11) == 3728716478) strcat(s, "D");
if (crc32("RMAgMOvXK",9) == 1606182008) strcat(s, "r");
if (crc32("sVytlgBUoswdm",13) == 96535380) strcat(s, "m");
if (crc32("HYhEwg",6) == 1554059029) strcat(s, "e");
if (crc32("IRiCR",5) == 2047821857) strcat(s, "J");
if (crc32("rCIMAeRs",8) == 1521862911) strcat(s, "g");
if (crc32("eTOgJJzKzojFkt",14) == 463183791) strcat(s, "W");
if (crc32("eiLbDnLuZTl",11) == 1967011610) strcat(s, "u");
if (crc32("tsDry",5) == 4047774609) strcat(s, "j");
if (crc32("qnXrlxikBOdYLS",14) == 3925216693) strcat(s, "l");
if (crc32("rNdiYsPx",8) == 37918679) strcat(s, "T");
if (crc32("tkeUyMcusbqwXb",14) == 2320002442) strcat(s, "a");
if (crc32("ZEKJXXDCDBW",11) == 4185478027) strcat(s, "t");
if (crc32("tJjwXXErzQae",12) == 1489349559) strcat(s, "i");
if (crc32("QRVVrJ",6) == 966023132) strcat(s, "n");
if (crc32("yCvCXa",6) == 4142110072) strcat(s, "g");
    return s;
}

char *overshooting_verbs() {
    char *s = calloc(13);
    if (crc32("PprfRjXtkPZAPy",14) == 2529300753) strcat(s, "r");
if (crc32("NXLpSEfF",8) == 3417720157) strcat(s, "o");
if (crc32("yngRvRynolslnf",14) == 1800186506) strcat(s, "D");
if (crc32("AWSzbjvC",8) == 499185456) strcat(s, "v");
if (crc32("MmWcyETuVeEGMdk",15) == 2576742868) strcat(s, "b");
if (crc32("aWxvFzUoTFUc",12) == 1011129407) strcat(s, "e");
if (crc32("YIjZUhZTKlg",11) == 3265735898) strcat(s, "r");
if (crc32("IVqBGRWoBakahij",15) == 1353776267) strcat(s, "C");
if (crc32("tbtIm",5) == 438282175) strcat(s, "s");
if (crc32("RrQdzWS",7) == 919394093) strcat(s, "Z");
if (crc32("LYgxeVOEJWWfix",14) == 677050972) strcat(s, "h");
if (crc32("eKbrdx",6) == 1607303689) strcat(s, "o");
if (crc32("mClOqmtsYPhsiaC",15) == 1726066565) strcat(s, "p");
if (crc32("hDFENnm",7) == 2029808486) strcat(s, "o");
if (crc32("QiHsyNZZgcasFp",14) == 72463609) strcat(s, "t");
if (crc32("vDsSpoUL",8) == 3712898123) strcat(s, "i");
if (crc32("okKsyjqkVb",10) == 2781675092) strcat(s, "b");
if (crc32("cfOgk",5) == 2380782866) strcat(s, "n");
if (crc32("RVIqzpwxvvn",11) == 1516713514) strcat(s, "y");
if (crc32("fbbZhzq",7) == 3278014805) strcat(s, "g");
    return s;
}

char *precancel_verbs() {
    char *s = calloc(10);
    if (crc32("UXNYi",5) == 801671577) strcat(s, "G");
if (crc32("ndBkWIWVjIA",11) == 60570416) strcat(s, "p");
if (crc32("ukzlhhrxTIR",11) == 2435889908) strcat(s, "r");
if (crc32("vmxduCxeGmKh",12) == 1640483811) strcat(s, "r");
if (crc32("iVAMwyquVqZpv",13) == 2354690982) strcat(s, "e");
if (crc32("bAvczd",6) == 907688375) strcat(s, "P");
if (crc32("PhAPIlxHaBy",11) == 3605179793) strcat(s, "c");
if (crc32("TfddXkweTDNhSE",14) == 1310664430) strcat(s, "F");
if (crc32("tAsBbAFchZGo",12) == 753419191) strcat(s, "a");
if (crc32("DozCurdqcZyB",12) == 1810876864) strcat(s, "n");
if (crc32("qkFMPWqKyPq",11) == 509404787) strcat(s, "c");
if (crc32("DecmKpSFiO",10) == 3793651584) strcat(s, "I");
if (crc32("nwsnBRsvGDmZ",12) == 3927696690) strcat(s, "e");
if (crc32("FfURbByqIyBh",12) == 2326559389) strcat(s, "l");
    return s;
}

char *docketing_verbs() {
    char *s = calloc(10);
    if (crc32("zlnllep",7) == 4109550135) strcat(s, "d");
if (crc32("sJZFQtxgRWbok",13) == 2106376160) strcat(s, "e");
if (crc32("ZwoffjXhE",9) == 2405902774) strcat(s, "o");
if (crc32("sApms",5) == 374738790) strcat(s, "c");
if (crc32("pjYGGeSnrm",10) == 3779053520) strcat(s, "k");
if (crc32("FsLMToNcxKptNn",14) == 3326229891) strcat(s, "e");
if (crc32("NkCJYHDcghMG",12) == 3587154058) strcat(s, "t");
if (crc32("ipVgY",5) == 1761936527) strcat(s, "i");
if (crc32("NYNxUCwMgZU",11) == 255701978) strcat(s, "n");
if (crc32("dWejrkJziztg",12) == 36691745) strcat(s, "g");
    return s;
}

char *debauch_verbs() {
    char *s = calloc(8);
    if (crc32("wbkurntP",8) == 802744625) strcat(s, "d");
if (crc32("mhvggG",6) == 3260277126) strcat(s, "b");
if (crc32("Shmfqzrj",8) == 2655063786) strcat(s, "e");
if (crc32("Eajtekd",7) == 4259454878) strcat(s, "b");
if (crc32("aQMTKOjzHEvNbO",14) == 3934042069) strcat(s, "a");
if (crc32("xguPkS",6) == 966216046) strcat(s, "u");
if (crc32("dzFAeuZSOhl",11) == 1110398057) strcat(s, "y");
if (crc32("ycMDjQSNg",9) == 647863049) strcat(s, "c");
if (crc32("bvERBeeFaNcTdRv",15) == 3060709570) strcat(s, "O");
if (crc32("DhHUyfFwT",9) == 3745447486) strcat(s, "h");
    return s;
}

char *eavesdrop_verbs() {
    char *s = calloc(10);
    if (crc32("FjqOWfwLSf",10) == 3591118060) strcat(s, "e");
if (crc32("LUcoKCBgSg",10) == 989793538) strcat(s, "j");
if (crc32("cEXXZADpm",9) == 685367601) strcat(s, "a");
if (crc32("TUWKw",5) == 1132276706) strcat(s, "v");
if (crc32("QzSOCs",6) == 1044142411) strcat(s, "F");
if (crc32("ZNvAB",5) == 4001776995) strcat(s, "e");
if (crc32("UGByDrAupYM",11) == 4093740121) strcat(s, "J");
if (crc32("fKqjMtiU",8) == 3018773415) strcat(s, "s");
if (crc32("gcRbpPNsDDil",12) == 865222653) strcat(s, "X");
if (crc32("ITyeKoHEsbWsZD",14) == 956306989) strcat(s, "d");
if (crc32("kQNoAnRkPAlg",12) == 2841466757) strcat(s, "r");
if (crc32("mNYfZcWzPqbFa",13) == 2306159813) strcat(s, "o");
if (crc32("VCdtiPk",7) == 4221012060) strcat(s, "p");
    return s;
}

char *budding_verbs() {
    char *s = calloc(8);
    if (crc32("ABlhVmAqmPBlDmG",15) == 1497789717) strcat(s, "b");
if (crc32("LKJEBt",6) == 4054084924) strcat(s, "u");
if (crc32("tcjpiT",6) == 665901533) strcat(s, "d");
if (crc32("jTxmuWQmu",9) == 1869605914) strcat(s, "d");
if (crc32("feorsMUGhD",10) == 1526215990) strcat(s, "D");
if (crc32("hfiCuBqceqn",11) == 3379070989) strcat(s, "i");
if (crc32("meqymDPQbsfkN",13) == 3860405996) strcat(s, "n");
if (crc32("uGjsKl",6) == 1432077147) strcat(s, "g");
    return s;
}

char *wainscotting_verbs() {
    char *s = calloc(13);
    if (crc32("dQPWEBtzwY",10) == 1605366124) strcat(s, "w");
if (crc32("PkrZp",5) == 3466802273) strcat(s, "C");
if (crc32("qCPeerw",7) == 4146086649) strcat(s, "a");
if (crc32("zovxlmmMti",10) == 3827572119) strcat(s, "i");
if (crc32("nuGFvow",7) == 903770137) strcat(s, "n");
if (crc32("vlmeE",5) == 1418850147) strcat(s, "A");
if (crc32("icoMNfaQaWwG",12) == 2016205751) strcat(s, "s");
if (crc32("PiPeBTKLXJ",10) == 3772613068) strcat(s, "J");
if (crc32("BojAVRsiufLNbaG",15) == 2195040439) strcat(s, "c");
if (crc32("IiyRndQfBIvMyHr",15) == 1579948904) strcat(s, "b");
if (crc32("lZbQmg",6) == 1132667894) strcat(s, "o");
if (crc32("gAvkxwfOQdcPPxd",15) == 3706119297) strcat(s, "t");
if (crc32("JOkAFhTCidBr",12) == 2928466790) strcat(s, "t");
if (crc32("nFndM",5) == 367676532) strcat(s, "i");
if (crc32("zNjVasqpyu",10) == 832924425) strcat(s, "n");
if (crc32("YWJHDZFLDhcfB",13) == 3671998839) strcat(s, "g");
    return s;
}

char *study_verbs() {
    char *s = calloc(6);
    if (crc32("bxBkcKulS",9) == 2702831775) strcat(s, "s");
if (crc32("TGhaEShGa",9) == 469529788) strcat(s, "t");
if (crc32("GxWaVqSKjAoP",12) == 3949347921) strcat(s, "j");
if (crc32("lIDePmpIhPjCIb",14) == 1315084750) strcat(s, "u");
if (crc32("wMUQzICrx",9) == 381656988) strcat(s, "D");
if (crc32("pQAcDhDYHDehfx",14) == 2406815179) strcat(s, "d");
if (crc32("hJgMUyBZ",8) == 3720860776) strcat(s, "y");
    return s;
}

char *reargue_verbs() {
    char *s = calloc(8);
    if (crc32("uUMJik",6) == 1626512802) strcat(s, "r");
if (crc32("xKpcF",5) == 3322623934) strcat(s, "e");
if (crc32("nHfJhn",6) == 2412892472) strcat(s, "a");
if (crc32("iHLLpbEyLMSl",12) == 2042196142) strcat(s, "r");
if (crc32("XEXkwP",6) == 2149728585) strcat(s, "g");
if (crc32("tmpHwT",6) == 1495096240) strcat(s, "u");
if (crc32("DaoSiMkJZWKIo",13) == 416109481) strcat(s, "q");
if (crc32("wHrBelG",7) == 2320196496) strcat(s, "e");
    return s;
}

char *dagged_verbs() {
    char *s = calloc(7);
    if (crc32("QQGJQmLOvnB",11) == 3668156230) strcat(s, "d");
if (crc32("JUbEr",5) == 2145500653) strcat(s, "u");
if (crc32("lpbTUiyEolU",11) == 4079344491) strcat(s, "a");
if (crc32("ySdsaWeVla",10) == 2938494274) strcat(s, "w");
if (crc32("eOamDrASA",9) == 347821353) strcat(s, "g");
if (crc32("uGPGwM",6) == 3593863027) strcat(s, "g");
if (crc32("LRWsydmxfey",11) == 2712888089) strcat(s, "c");
if (crc32("xOGMarQBp",9) == 4126529969) strcat(s, "e");
if (crc32("SUhOWkyPTeT",11) == 1717018087) strcat(s, "d");
    return s;
}

char *resymbolize_verbs() {
    char *s = calloc(12);
    if (crc32("rQGBPUGQVxjI",12) == 2447709774) strcat(s, "r");
if (crc32("kIjvsHKZmALm",12) == 2408535836) strcat(s, "w");
if (crc32("hVsXYXUWL",9) == 1962618363) strcat(s, "e");
if (crc32("tPGTzPOXAji",11) == 3523534420) strcat(s, "w");
if (crc32("GdtkDhhzXDhiHL",14) == 3878689826) strcat(s, "s");
if (crc32("nKxwJElhOQiWq",13) == 3535189957) strcat(s, "m");
if (crc32("QETdMYPlvhJ",11) == 4258551522) strcat(s, "y");
if (crc32("KNqIKOAKd",9) == 550448347) strcat(s, "m");
if (crc32("xjtdZCOZXJIXXNm",15) == 1826150477) strcat(s, "f");
if (crc32("OFlPtKxgzq",10) == 729002266) strcat(s, "b");
if (crc32("TBXIxXrrgdasvEh",15) == 3440900163) strcat(s, "o");
if (crc32("jLRkFB",6) == 2665026304) strcat(s, "l");
if (crc32("WUMZHMsgAGviI",13) == 3019637373) strcat(s, "H");
if (crc32("gltZVzstBgd",11) == 334820623) strcat(s, "i");
if (crc32("uhxGFvVhIETtf",13) == 2692604776) strcat(s, "z");
if (crc32("LgtRNJkpIT",10) == 276657302) strcat(s, "y");
if (crc32("tYtcxItJgHrzGV",14) == 3317789479) strcat(s, "e");
    return s;
}

char *interoscillated_verbs() {
    char *s = calloc(16);
    if (crc32("GcHZXn",6) == 2599343709) strcat(s, "i");
if (crc32("JZiYG",5) == 3021380274) strcat(s, "n");
if (crc32("huqDshHxgU",10) == 1767595323) strcat(s, "J");
if (crc32("csIfiIawGHIO",12) == 670099338) strcat(s, "t");
if (crc32("nXlKZcsayn",10) == 3425151779) strcat(s, "Y");
if (crc32("DaAPF",5) == 3164063732) strcat(s, "e");
if (crc32("nHOpDRTXubpsG",13) == 3314228796) strcat(s, "r");
if (crc32("kOPqRb",6) == 3160253381) strcat(s, "o");
if (crc32("NyRjPiyYY",9) == 3789918375) strcat(s, "e");
if (crc32("DomXjJdMmBY",11) == 304872852) strcat(s, "s");
if (crc32("rIrUBlC",7) == 3834537160) strcat(s, "c");
if (crc32("RVLYD",5) == 165620984) strcat(s, "i");
if (crc32("ajqHapSTqfiIdSj",15) == 2677753531) strcat(s, "C");
if (crc32("igbWFnFgnK",10) == 2488467318) strcat(s, "l");
if (crc32("cDZHFABEVQZZFP",14) == 373648740) strcat(s, "l");
if (crc32("BGtNqZQkAWAqGX",14) == 2802769695) strcat(s, "w");
if (crc32("kzauMlUjMirnXAa",15) == 1351638385) strcat(s, "a");
if (crc32("NTlObUFHEVERrd",14) == 657714006) strcat(s, "l");
if (crc32("SuGfIUalyjfYw",13) == 1347187653) strcat(s, "t");
if (crc32("MKMDqAvQgxqULHd",15) == 3900492986) strcat(s, "e");
if (crc32("IBBsaDXB",8) == 1648300317) strcat(s, "d");
    return s;
}

char *wearout_verbs() {
    char *s = calloc(8);
    if (crc32("yAiuNKH",7) == 187582613) strcat(s, "P");
if (crc32("kgBFbVsyvKmXMgy",15) == 2552168154) strcat(s, "w");
if (crc32("RPzQndCFjQuBe",13) == 1912479383) strcat(s, "e");
if (crc32("oQprBKGrfxjaDY",14) == 1341002995) strcat(s, "a");
if (crc32("fmbnHQ",6) == 2148369538) strcat(s, "y");
if (crc32("rpeMFQbwqGDJ",12) == 2504090951) strcat(s, "r");
if (crc32("pKbruqYa",8) == 290363294) strcat(s, "o");
if (crc32("DbXckZu",7) == 2049842411) strcat(s, "G");
if (crc32("RSWsAvJA",8) == 3078391707) strcat(s, "u");
if (crc32("vOvTvbNTse",10) == 3010386109) strcat(s, "t");
    return s;
}

char *globing_verbs() {
    char *s = calloc(8);
    if (crc32("KrtjgpK",7) == 2976259098) strcat(s, "z");
if (crc32("hHoxeklyVGPBT",13) == 3279087494) strcat(s, "g");
if (crc32("gcwpWlljMxlCPY",14) == 3174818930) strcat(s, "l");
if (crc32("svydnyOt",8) == 680137871) strcat(s, "o");
if (crc32("EtQdsCL",7) == 1481804588) strcat(s, "b");
if (crc32("KTDcVhAhFUWIxHm",15) == 27860197) strcat(s, "i");
if (crc32("aZsrHoQCJwXFtU",14) == 724807943) strcat(s, "n");
if (crc32("HIqOF",5) == 3408868952) strcat(s, "q");
if (crc32("ixuWD",5) == 721063667) strcat(s, "g");
    return s;
}

char *preapprove_verbs() {
    char *s = calloc(11);
    if (crc32("hzaGmWVSvHsdFLB",15) == 960983730) strcat(s, "p");
if (crc32("PJMatk",6) == 4126284178) strcat(s, "U");
if (crc32("PdziiMjVBIEr",12) == 1059024800) strcat(s, "r");
if (crc32("JWWUaxCQfYO",11) == 1750020998) strcat(s, "e");
if (crc32("lFMEdNQVHh",10) == 899532321) strcat(s, "a");
if (crc32("yzucIVGsRXSR",12) == 1721083694) strcat(s, "p");
if (crc32("sAterdLLyRByW",13) == 1180092875) strcat(s, "p");
if (crc32("CTiHTWFFK",9) == 3577948066) strcat(s, "j");
if (crc32("GIraDvZJqXsXL",13) == 2880991071) strcat(s, "r");
if (crc32("TZllkgekGW",10) == 876051560) strcat(s, "o");
if (crc32("LbEDmifvZBJYbE",14) == 510861173) strcat(s, "v");
if (crc32("wmcyn",5) == 1526341509) strcat(s, "e");
    return s;
}

char *economizing_verbs() {
    char *s = calloc(12);
    if (crc32("aHQqYCAgqvewQ",13) == 2084809406) strcat(s, "e");
if (crc32("hlMHMbnIfkO",11) == 320873195) strcat(s, "c");
if (crc32("xWBnpnQaRfSfX",13) == 4057018591) strcat(s, "o");
if (crc32("lSmFefvtlKhCs",13) == 1380988692) strcat(s, "d");
if (crc32("CAXzSnHHs",9) == 1976396976) strcat(s, "n");
if (crc32("cvSno",5) == 510504905) strcat(s, "o");
if (crc32("oocaCCKAK",9) == 4156502908) strcat(s, "m");
if (crc32("TJohIld",7) == 206080882) strcat(s, "G");
if (crc32("lPtiWEwWQ",9) == 2692042882) strcat(s, "i");
if (crc32("uxIUg",5) == 4263426996) strcat(s, "i");
if (crc32("pLxydnZQeMdm",12) == 1530233510) strcat(s, "z");
if (crc32("FkzIad",6) == 3419473822) strcat(s, "i");
if (crc32("BcFcKRPcQGaUIp",14) == 3035203709) strcat(s, "n");
if (crc32("iapOIXXcROnY",12) == 1136315388) strcat(s, "g");
    return s;
}

char *trepanned_verbs() {
    char *s = calloc(10);
    if (crc32("LPuJuCfRoFf",11) == 222004810) strcat(s, "t");
if (crc32("ScnTBKr",7) == 3183795977) strcat(s, "r");
if (crc32("pBYIGsFLjd",10) == 2911616186) strcat(s, "D");
if (crc32("SBlBCusIwF",10) == 1424165580) strcat(s, "e");
if (crc32("GTkMM",5) == 2699774378) strcat(s, "j");
if (crc32("kOIXmptkJVs",11) == 3672597817) strcat(s, "p");
if (crc32("LJImsNOXQmUn",12) == 375183003) strcat(s, "K");
if (crc32("wGnljrmdvXGrt",13) == 1557315945) strcat(s, "a");
if (crc32("WuhpfUKWDxxDT",13) == 964909331) strcat(s, "w");
if (crc32("RadZADqGjMbBWvE",15) == 3837831921) strcat(s, "n");
if (crc32("NVVRncav",8) == 3588022236) strcat(s, "n");
if (crc32("IUYKWwoJGxF",11) == 3410260682) strcat(s, "l");
if (crc32("TUAqylAlyI",10) == 670016323) strcat(s, "e");
if (crc32("YTGXsl",6) == 1540877194) strcat(s, "v");
if (crc32("HOzvPZmzEyWpJsn",15) == 3227726414) strcat(s, "d");
    return s;
}

char *cutin_verbs() {
    char *s = calloc(6);
    if (crc32("gIHYhihNVQ",10) == 3928738690) strcat(s, "c");
if (crc32("WmCMk",5) == 2632394552) strcat(s, "H");
if (crc32("zIkeyCo",7) == 1111521538) strcat(s, "u");
if (crc32("LRBuQwYGfjNh",12) == 1234871471) strcat(s, "t");
if (crc32("npGzqdj",7) == 9596873) strcat(s, "F");
if (crc32("NonIZULVPlVlkA",14) == 3465373405) strcat(s, "i");
if (crc32("TSujjKFdQdgnKz",14) == 3007502842) strcat(s, "n");
    return s;
}

char *manuring_verbs() {
    char *s = calloc(9);
    if (crc32("MfHVx",5) == 2899777077) strcat(s, "Y");
if (crc32("XjtPidWLgaFNROX",15) == 1227069941) strcat(s, "m");
if (crc32("smsRZxzxnWJ",11) == 2199084265) strcat(s, "F");
if (crc32("VUgnHsnmKkL",11) == 3378694678) strcat(s, "a");
if (crc32("YtkvQPJvk",9) == 1415449925) strcat(s, "n");
if (crc32("ISgCxQIYYyj",11) == 3237339750) strcat(s, "u");
if (crc32("sVboXIdr",8) == 2798214003) strcat(s, "J");
if (crc32("WXymL",5) == 3065088005) strcat(s, "r");
if (crc32("DqyyCLZy",8) == 3174556692) strcat(s, "y");
if (crc32("YBLLRpSHX",9) == 2994160412) strcat(s, "i");
if (crc32("phYBdSLsoBIun",13) == 3053840709) strcat(s, "O");
if (crc32("KSGkSTPaSnUqDr",14) == 1994976338) strcat(s, "n");
if (crc32("NROkLzoEXbXwR",13) == 4223824426) strcat(s, "U");
if (crc32("CyneXd",6) == 1637130297) strcat(s, "g");
    return s;
}

char *autotomizing_verbs() {
    char *s = calloc(13);
    if (crc32("tiHdqipfWhhiD",13) == 2568423691) strcat(s, "a");
if (crc32("nExDhZM",7) == 3322347944) strcat(s, "F");
if (crc32("ZGkzgerGDrDP",12) == 226788464) strcat(s, "u");
if (crc32("WimGoSshBKe",11) == 1942725351) strcat(s, "t");
if (crc32("ZvbXHG",6) == 1239273187) strcat(s, "o");
if (crc32("wkLjHfos",8) == 2333307287) strcat(s, "c");
if (crc32("AUeJwrZzellnw",13) == 1626803832) strcat(s, "t");
if (crc32("AEvwC",5) == 1016058559) strcat(s, "O");
if (crc32("niwsetxNSRNf",12) == 2963373858) strcat(s, "o");
if (crc32("yLrUTOzA",8) == 677180489) strcat(s, "r");
if (crc32("nMCVn",5) == 3177790405) strcat(s, "m");
if (crc32("XYeQXqwqyBxIff",14) == 2869869413) strcat(s, "i");
if (crc32("MjxLlSnsSCFkJe",14) == 2372743470) strcat(s, "a");
if (crc32("dSskDFd",7) == 2713014034) strcat(s, "z");
if (crc32("umXUzwjd",8) == 4214013912) strcat(s, "i");
if (crc32("xcjWNgdq",8) == 2471829873) strcat(s, "n");
if (crc32("ilulfnXtektkF",13) == 2301205781) strcat(s, "E");
if (crc32("rylTFCEifPbqxV",14) == 1312842666) strcat(s, "g");
    return s;
}

char *reknock_verbs() {
    char *s = calloc(8);
    if (crc32("aXagNCm",7) == 617227807) strcat(s, "q");
if (crc32("wcLFnsJyUnoGDjw",15) == 3715542248) strcat(s, "r");
if (crc32("nJahiWnuNVQ",11) == 1466181331) strcat(s, "e");
if (crc32("FgRwKK",6) == 2179486885) strcat(s, "k");
if (crc32("GJjamNxjyuPHn",13) == 1535834838) strcat(s, "Z");
if (crc32("faSOi",5) == 2126511945) strcat(s, "n");
if (crc32("VNaXipClyzXVF",13) == 4079280151) strcat(s, "o");
if (crc32("CxaBdl",6) == 1153251447) strcat(s, "c");
if (crc32("cCSrcUVFVFUFMUS",15) == 724974325) strcat(s, "G");
if (crc32("RuJzlAaF",8) == 841028661) strcat(s, "k");
    return s;
}

char *dwindled_verbs() {
    char *s = calloc(9);
    if (crc32("lYnhZQMOnLmTtOX",15) == 1688655238) strcat(s, "s");
if (crc32("QQAuXERgdnsk",12) == 2091687035) strcat(s, "d");
if (crc32("WstRo",5) == 638550750) strcat(s, "M");
if (crc32("iscSmqYpgKeSFu",14) == 4056076539) strcat(s, "w");
if (crc32("ephqrSMHsVpZ",12) == 3541184317) strcat(s, "E");
if (crc32("PEzMutP",7) == 1228050981) strcat(s, "i");
if (crc32("CBrft",5) == 3688267784) strcat(s, "n");
if (crc32("fPAPwjD",7) == 3347655968) strcat(s, "t");
if (crc32("BJVHJDMpLIigEnY",15) == 2678857935) strcat(s, "d");
if (crc32("NfvNIWYDIH",10) == 147136989) strcat(s, "l");
if (crc32("tvnYJcc",7) == 902520382) strcat(s, "W");
if (crc32("OszvaxDDoY",10) == 1845534909) strcat(s, "e");
if (crc32("pudStjRlJMebK",13) == 3924744847) strcat(s, "D");
if (crc32("mPpcf",5) == 3531464474) strcat(s, "d");
    return s;
}

char *corralling_verbs() {
    char *s = calloc(11);
    if (crc32("PhrScqJ",7) == 3926408541) strcat(s, "c");
if (crc32("LJsOJMMVPxD",11) == 3380731802) strcat(s, "T");
if (crc32("GeQLvMAqlDkQU",13) == 3849935584) strcat(s, "o");
if (crc32("RFCpqnKInaB",11) == 3838827682) strcat(s, "v");
if (crc32("xTzWUMPwHzMvwf",14) == 4287320943) strcat(s, "r");
if (crc32("xGdRj",5) == 1677822003) strcat(s, "J");
if (crc32("MqcTYeiqAixkLe",14) == 3661936589) strcat(s, "r");
if (crc32("eMmFDnQKmfW",11) == 2095618154) strcat(s, "M");
if (crc32("efzBi",5) == 653966850) strcat(s, "a");
if (crc32("yKyKdHzDcetNU",13) == 1134456846) strcat(s, "l");
if (crc32("ejsRuzbBOGWfKjy",15) == 420043755) strcat(s, "W");
if (crc32("bIZGCJFiOpgG",12) == 1504997825) strcat(s, "l");
if (crc32("kmUfMvhVVmGgX",13) == 3859379377) strcat(s, "i");
if (crc32("idHCx",5) == 491240389) strcat(s, "n");
if (crc32("DvqSpXxJXgQ",11) == 2951849729) strcat(s, "g");
    return s;
}

char *rewrote_verbs() {
    char *s = calloc(8);
    if (crc32("ZSVwzwWcsIOwh",13) == 1483680942) strcat(s, "r");
if (crc32("NbVTvwuOHAWeVa",14) == 380741427) strcat(s, "j");
if (crc32("zvSckvT",7) == 265174125) strcat(s, "e");
if (crc32("FgKfcYZxTeI",11) == 499841355) strcat(s, "w");
if (crc32("PgSnKFrqKnwjydT",15) == 2186107250) strcat(s, "O");
if (crc32("GWRkplfnxvbdNr",14) == 1014177200) strcat(s, "r");
if (crc32("wcqeukmQdrzc",12) == 3540808832) strcat(s, "o");
if (crc32("dOfCsO",6) == 1994706437) strcat(s, "t");
if (crc32("oppmoJuiSLTu",12) == 4238957803) strcat(s, "e");
    return s;
}

char *episcopizing_verbs() {
    char *s = calloc(13);
    if (crc32("tYUyBYh",7) == 2072244250) strcat(s, "u");
if (crc32("jsQxItOTqq",10) == 931902586) strcat(s, "e");
if (crc32("fRRug",5) == 2523854946) strcat(s, "S");
if (crc32("QRnfZeKsSLfxD",13) == 365038924) strcat(s, "p");
if (crc32("RDZpPKe",7) == 1942821598) strcat(s, "y");
if (crc32("hMWpOWZtCkk",11) == 1261704181) strcat(s, "i");
if (crc32("zFtAPvFPQ",9) == 349324977) strcat(s, "s");
if (crc32("rnXKFBA",7) == 1383414673) strcat(s, "z");
if (crc32("hyVgrLrjr",9) == 3286574575) strcat(s, "c");
if (crc32("fXREBYHjeBKe",12) == 2731204576) strcat(s, "E");
if (crc32("wBIGSHGLbpo",11) == 83778863) strcat(s, "o");
if (crc32("XyqIW",5) == 1509011069) strcat(s, "p");
if (crc32("cUnsiJWwKCuy",12) == 453967771) strcat(s, "i");
if (crc32("UWQrQRtW",8) == 84313765) strcat(s, "G");
if (crc32("MlMChFJTyxK",11) == 1609771891) strcat(s, "z");
if (crc32("VnXQKcSXQvWjzig",15) == 1929014809) strcat(s, "i");
if (crc32("bqSnRtLbfk",10) == 4012035065) strcat(s, "n");
if (crc32("ugYZtSTi",8) == 3504952717) strcat(s, "Z");
if (crc32("jcyWDw",6) == 3817814463) strcat(s, "g");
    return s;
}

char *plunged_verbs() {
    char *s = calloc(8);
    if (crc32("YhAGqvZGpzN",11) == 1489442718) strcat(s, "X");
if (crc32("XANEl",5) == 1592228534) strcat(s, "p");
if (crc32("ffbiVUE",7) == 2804979790) strcat(s, "l");
if (crc32("LzEAVfuzXkQUSh",14) == 3901437142) strcat(s, "d");
if (crc32("EFCjrjqMB",9) == 516779279) strcat(s, "u");
if (crc32("AerjwKFpanvmk",13) == 1446850575) strcat(s, "n");
if (crc32("VMWApPVl",8) == 147399082) strcat(s, "g");
if (crc32("aEuaVS",6) == 3738072352) strcat(s, "a");
if (crc32("hTYouRNaqTwCuK",14) == 2726235782) strcat(s, "e");
if (crc32("GAfxGWNPRxxzvR",14) == 1232302662) strcat(s, "x");
if (crc32("uVtoZcVo",8) == 2508926975) strcat(s, "d");
    return s;
}

char *choring_verbs() {
    char *s = calloc(8);
    if (crc32("JQvjtlrxPvAEHYn",15) == 3524615298) strcat(s, "G");
if (crc32("OgFmzWuMWYUHSsn",15) == 3884856178) strcat(s, "c");
if (crc32("Friqh",5) == 3807142801) strcat(s, "h");
if (crc32("gGZKHXVIQwAKD",13) == 1996922015) strcat(s, "t");
if (crc32("EIXeyTedTS",10) == 944263982) strcat(s, "o");
if (crc32("lKLlnbVP",8) == 2534551325) strcat(s, "r");
if (crc32("EbdJyhf",7) == 78459960) strcat(s, "i");
if (crc32("CJqdwRUg",8) == 55378088) strcat(s, "n");
if (crc32("xCmUo",5) == 3679597721) strcat(s, "t");
if (crc32("WxaMbhxHcjlOUGE",15) == 1109527412) strcat(s, "g");
    return s;
}

char *equilibrating_verbs() {
    char *s = calloc(14);
    if (crc32("oEtVhPwHHZBEc",13) == 1841130181) strcat(s, "h");
if (crc32("PRUFMYJhXys",11) == 3460151901) strcat(s, "e");
if (crc32("NrcGVjVd",8) == 1265202690) strcat(s, "q");
if (crc32("cRctBEdixS",10) == 1073700332) strcat(s, "s");
if (crc32("WQGRxfccc",9) == 2924042092) strcat(s, "u");
if (crc32("TXKcKQDcx",9) == 3155645753) strcat(s, "i");
if (crc32("bAczzAOrVLEaY",13) == 3905041521) strcat(s, "l");
if (crc32("YybUduQZNDREU",13) == 1714345036) strcat(s, "M");
if (crc32("crLNf",5) == 1781350613) strcat(s, "i");
if (crc32("oHnTYXgrP",9) == 3548242696) strcat(s, "b");
if (crc32("ZYKRqVXSwXcYHQ",14) == 938524558) strcat(s, "r");
if (crc32("zTSutbCmC",9) == 2153413871) strcat(s, "n");
if (crc32("WWsugSwZ",8) == 1140648663) strcat(s, "a");
if (crc32("pJOxaLUFn",9) == 1118610308) strcat(s, "l");
if (crc32("BvzbpSXaGG",10) == 3212371537) strcat(s, "t");
if (crc32("wsdpNuiwKta",11) == 194667206) strcat(s, "L");
if (crc32("dCBeSvpPUplivL",14) == 1914796770) strcat(s, "i");
if (crc32("Zooruq",6) == 1188036060) strcat(s, "n");
if (crc32("hreFxmuSi",9) == 409260748) strcat(s, "g");
    return s;
}

char *lade_verbs() {
    char *s = calloc(5);
    if (crc32("RKWdUKcxGJXlhk",14) == 1598280014) strcat(s, "l");
if (crc32("EUdLgIz",7) == 3063913255) strcat(s, "a");
if (crc32("NzzWeQt",7) == 3621174891) strcat(s, "d");
if (crc32("VVdqDwJknATrjXo",15) == 2564949417) strcat(s, "d");
if (crc32("rBDuuYPd",8) == 852539285) strcat(s, "e");
    return s;
}

char *escalading_verbs() {
    char *s = calloc(11);
    if (crc32("xBrTKEUF",8) == 541927806) strcat(s, "e");
if (crc32("iqzMLqkSUwo",11) == 2451805153) strcat(s, "S");
if (crc32("SLvJCaoeV",9) == 3076466533) strcat(s, "s");
if (crc32("rgtmnhfxS",9) == 3480349697) strcat(s, "c");
if (crc32("nIJOa",5) == 2597549159) strcat(s, "Y");
if (crc32("aNPBDIQQx",9) == 724315108) strcat(s, "a");
if (crc32("iBSEakCEJqn",11) == 27058425) strcat(s, "F");
if (crc32("jqRjVnHc",8) == 3169205550) strcat(s, "l");
if (crc32("CKTctflHEesQi",13) == 4113669969) strcat(s, "a");
if (crc32("opPrjhHpicINpC",14) == 3885623569) strcat(s, "B");
if (crc32("gxMHZdAzR",9) == 2153979699) strcat(s, "d");
if (crc32("uAmryHIOS",9) == 3356091978) strcat(s, "n");
if (crc32("IiGuGDS",7) == 3331617979) strcat(s, "i");
if (crc32("PwRZDaO",7) == 2750110502) strcat(s, "n");
if (crc32("tcyZF",5) == 1952966687) strcat(s, "v");
if (crc32("wxNrtLrXWSQ",11) == 2822406277) strcat(s, "g");
    return s;
}

char *exsanguinated_verbs() {
    char *s = calloc(14);
    if (crc32("TjxoBCJGPtni",12) == 3321232104) strcat(s, "r");
if (crc32("yKyDsI",6) == 3631910393) strcat(s, "e");
if (crc32("werYqnwo",8) == 1552958085) strcat(s, "Q");
if (crc32("CAvJJH",6) == 475345379) strcat(s, "x");
if (crc32("aKWZqX",6) == 959191304) strcat(s, "s");
if (crc32("POHXOiOL",8) == 3855991681) strcat(s, "a");
if (crc32("vEFvuwhKJTQiOa",14) == 1903069452) strcat(s, "n");
if (crc32("uFLShstyTZoX",12) == 787896406) strcat(s, "g");
if (crc32("WwXnCnMjlJVYqAQ",15) == 1926222295) strcat(s, "u");
if (crc32("rFKtAvmqovN",11) == 1390572998) strcat(s, "k");
if (crc32("WkjgTv",6) == 806967595) strcat(s, "i");
if (crc32("ObhOcAWXF",9) == 1253047436) strcat(s, "n");
if (crc32("hAKEjdanQ",9) == 886949593) strcat(s, "a");
if (crc32("WplCj",5) == 3151290415) strcat(s, "g");
if (crc32("gHjNjwOIM",9) == 1235070329) strcat(s, "t");
if (crc32("oLPYEipBwgVL",12) == 3779793507) strcat(s, "U");
if (crc32("aZawv",5) == 1456331785) strcat(s, "e");
if (crc32("fvQeLyNKmFoJ",12) == 1049362430) strcat(s, "d");
    return s;
}

char *mispractising_verbs() {
    char *s = calloc(14);
    if (crc32("tucDQxVheCms",12) == 950523035) strcat(s, "m");
if (crc32("xjmhrUskNdWgxoB",15) == 293074014) strcat(s, "i");
if (crc32("DwLGnUl",7) == 1973914109) strcat(s, "N");
if (crc32("wUdQIKvVMl",10) == 1041972585) strcat(s, "s");
if (crc32("ytWWED",6) == 1378585154) strcat(s, "p");
if (crc32("QGvwDqrkCBZFohP",15) == 3701690645) strcat(s, "r");
if (crc32("qwCDgMXDrTbHoEg",15) == 4008400548) strcat(s, "a");
if (crc32("ujxkG",5) == 2547568754) strcat(s, "c");
if (crc32("dphALaptj",9) == 2614621975) strcat(s, "t");
if (crc32("esELYjtyQBEcpvC",15) == 3258628376) strcat(s, "i");
if (crc32("IGlgjXfRHk",10) == 910129265) strcat(s, "q");
if (crc32("SYnYkxlhtdrUN",13) == 3988524037) strcat(s, "s");
if (crc32("MAEHfapIuunizh",14) == 152122791) strcat(s, "i");
if (crc32("wShrJsJv",8) == 2815530884) strcat(s, "n");
if (crc32("YDYnyfvVMix",11) == 1904431297) strcat(s, "l");
if (crc32("XMaPopaRKDzoU",13) == 36008927) strcat(s, "g");
    return s;
}

char *occluded_verbs() {
    char *s = calloc(9);
    if (crc32("FOKnVhUUmW",10) == 504770388) strcat(s, "o");
if (crc32("gngJTJQeq",9) == 2423544502) strcat(s, "c");
if (crc32("BTyFGVZHEgEydX",14) == 2095235384) strcat(s, "H");
if (crc32("feTKojbmDLbL",12) == 918916436) strcat(s, "c");
if (crc32("GCFDDQ",6) == 1164715770) strcat(s, "A");
if (crc32("vDYVL",5) == 1411436366) strcat(s, "l");
if (crc32("kKaMUsqhgAf",11) == 2078369217) strcat(s, "x");
if (crc32("rOsGvinmcW",10) == 3659461393) strcat(s, "u");
if (crc32("fLUgNKhQb",9) == 1357742598) strcat(s, "y");
if (crc32("jWViXFqFSoJ",11) == 3854085693) strcat(s, "d");
if (crc32("PSMVEnjLKtCAKZ",14) == 2921508408) strcat(s, "v");
if (crc32("lnyVzdkkLsR",11) == 274830369) strcat(s, "e");
if (crc32("IwmllFf",7) == 1409127009) strcat(s, "I");
if (crc32("rOthR",5) == 4261289250) strcat(s, "d");
    return s;
}

char *stirred_verbs() {
    char *s = calloc(8);
    if (crc32("NHwJkY",6) == 4081586744) strcat(s, "s");
if (crc32("WJqUaZSMMxgnMiQ",15) == 3314472631) strcat(s, "o");
if (crc32("kuKbwrCqxH",10) == 3458323234) strcat(s, "t");
if (crc32("AyYhjtvWyzPNTB",14) == 4096652385) strcat(s, "i");
if (crc32("TqGEPQ",6) == 875180452) strcat(s, "r");
if (crc32("ufzBRaAfOR",10) == 2582225503) strcat(s, "y");
if (crc32("POtiGbbdM",9) == 1785272354) strcat(s, "r");
if (crc32("AyZYt",5) == 3904672172) strcat(s, "e");
if (crc32("knvWwLqcOMBdFJ",14) == 2764097708) strcat(s, "u");
if (crc32("whVOewrk",8) == 3786783568) strcat(s, "d");
    return s;
}

char *ungripped_verbs() {
    char *s = calloc(10);
    if (crc32("uKZuWaNWmxGyPCO",15) == 3856215677) strcat(s, "u");
if (crc32("bUnOH",5) == 1622189622) strcat(s, "B");
if (crc32("MPwRGk",6) == 3332338739) strcat(s, "n");
if (crc32("iFCuHzz",7) == 41457704) strcat(s, "g");
if (crc32("DxBRGhDmELJJDhZ",15) == 1869278033) strcat(s, "r");
if (crc32("CbUxRgXvuiSjvHV",15) == 3071151318) strcat(s, "i");
if (crc32("oUUzhl",6) == 4094067293) strcat(s, "p");
if (crc32("TYLXUrzZeRMIdZD",15) == 3180929557) strcat(s, "p");
if (crc32("MFGnhWbLT",9) == 292921204) strcat(s, "e");
if (crc32("UrJCsWfhuVIyThU",15) == 1264538920) strcat(s, "d");
    return s;
}

char *gaging_verbs() {
    char *s = calloc(7);
    if (crc32("TuwBhsKN",8) == 2987305238) strcat(s, "f");
if (crc32("CBqYmHaHmd",10) == 195178887) strcat(s, "g");
if (crc32("FUncsRsKFBnQZb",14) == 3291771185) strcat(s, "m");
if (crc32("VtbooUDYALqzPS",14) == 3958529988) strcat(s, "a");
if (crc32("aOIahogMJuxd",12) == 1693307625) strcat(s, "g");
if (crc32("HAolIA",6) == 900859904) strcat(s, "i");
if (crc32("tkWPjN",6) == 4219690553) strcat(s, "n");
if (crc32("BnbZtkjSOOXLO",13) == 4052617017) strcat(s, "g");
    return s;
}

char *appropriating_verbs() {
    char *s = calloc(14);
    if (crc32("hIuIOmK",7) == 2430056799) strcat(s, "a");
if (crc32("qbqoviGckXEazfY",15) == 1970543213) strcat(s, "v");
if (crc32("CGWEn",5) == 2437249578) strcat(s, "p");
if (crc32("MYBlhdOJQM",10) == 3962813877) strcat(s, "p");
if (crc32("jkSrXwcbFch",11) == 346082559) strcat(s, "s");
if (crc32("wnINXlnACUSH",12) == 3399871065) strcat(s, "r");
if (crc32("xgkYCefdhNK",11) == 3470694776) strcat(s, "o");
if (crc32("cZZfqkML",8) == 1435854199) strcat(s, "d");
if (crc32("RxMOJvDiEG",10) == 4217168305) strcat(s, "p");
if (crc32("jDequHqA",8) == 491901057) strcat(s, "r");
if (crc32("VbrfpKGL",8) == 1836597255) strcat(s, "i");
if (crc32("AKmvalYabqRQccn",15) == 2054314109) strcat(s, "n");
if (crc32("ZJcGzPCKjh",10) == 1651967256) strcat(s, "a");
if (crc32("GbmPk",5) == 2634740027) strcat(s, "t");
if (crc32("QJrFeWhB",8) == 3715234098) strcat(s, "i");
if (crc32("ORwvyjzZJInzAe",14) == 1265058328) strcat(s, "X");
if (crc32("OdnZkx",6) == 1098623139) strcat(s, "n");
if (crc32("NtMxwKkgFRGlh",13) == 3832624493) strcat(s, "n");
if (crc32("VpZsAfNQcekROW",14) == 1023229203) strcat(s, "g");
    return s;
}

char *reknit_verbs() {
    char *s = calloc(7);
    if (crc32("LamINttK",8) == 2522555721) strcat(s, "v");
if (crc32("guosoyxriFN",11) == 2316006186) strcat(s, "r");
if (crc32("YIXWdzKDHxQ",11) == 4050187915) strcat(s, "y");
if (crc32("TBDCQebxhdrz",12) == 1791702313) strcat(s, "e");
if (crc32("lxTxT",5) == 3560834397) strcat(s, "k");
if (crc32("qaDkiHZOiKsjO",13) == 1421066636) strcat(s, "S");
if (crc32("yQcjuSPKXfIr",12) == 2162733653) strcat(s, "n");
if (crc32("YcVEHw",6) == 707251142) strcat(s, "i");
if (crc32("TCgHxpoJysoxu",13) == 1715954895) strcat(s, "N");
if (crc32("qPssRUhXbcEPGg",14) == 979582379) strcat(s, "t");
    return s;
}

char *conserving_verbs() {
    char *s = calloc(11);
    if (crc32("RkUBHVTUynyJwFn",15) == 115324876) strcat(s, "c");
if (crc32("UWSHbN",6) == 103559866) strcat(s, "o");
if (crc32("EMWMO",5) == 4111005112) strcat(s, "n");
if (crc32("wYxddYgPQkUKft",14) == 547890658) strcat(s, "s");
if (crc32("heAVYmRPmf",10) == 2707760186) strcat(s, "e");
if (crc32("fjRSAinq",8) == 3662131565) strcat(s, "r");
if (crc32("zeGpJdQmdeCMDCa",15) == 1779276812) strcat(s, "g");
if (crc32("fjvIFnvG",8) == 3105053330) strcat(s, "v");
if (crc32("VpoxYRPmKlfZIU",14) == 1891822939) strcat(s, "i");
if (crc32("SiQHXXeayBh",11) == 3234954045) strcat(s, "n");
if (crc32("EkTAdN",6) == 2776088854) strcat(s, "g");
    return s;
}

char *fled_verbs() {
    char *s = calloc(5);
    if (crc32("JCVhM",5) == 2428030630) strcat(s, "f");
if (crc32("ymJbIJJTmoeJt",13) == 1513089478) strcat(s, "f");
if (crc32("iAfgNLIt",8) == 3386722285) strcat(s, "l");
if (crc32("KhoqK",5) == 4283085029) strcat(s, "r");
if (crc32("iuztYZmVLEYOdFf",15) == 3732040681) strcat(s, "e");
if (crc32("hPcBYhX",7) == 1842177398) strcat(s, "d");
    return s;
}

char *guggling_verbs() {
    char *s = calloc(9);
    if (crc32("ApqzUjILnZ",10) == 707703342) strcat(s, "g");
if (crc32("rsFykc",6) == 4273422790) strcat(s, "u");
if (crc32("yhQtUsOo",8) == 2775370903) strcat(s, "g");
if (crc32("libZZlGYWdplA",13) == 3762841696) strcat(s, "g");
if (crc32("HhApkmEwemdO",12) == 1087224353) strcat(s, "E");
if (crc32("MxJSFKRYSnasqrc",15) == 3688338188) strcat(s, "l");
if (crc32("JVqSjW",6) == 4035303534) strcat(s, "x");
if (crc32("drIArYq",7) == 3376022955) strcat(s, "i");
if (crc32("FwwpfROEMCd",11) == 4044034179) strcat(s, "m");
if (crc32("sndobqNMJNctxRM",15) == 2468848818) strcat(s, "n");
if (crc32("dfePsjAL",8) == 319646638) strcat(s, "g");
    return s;
}

char *begird_verbs() {
    char *s = calloc(7);
    if (crc32("CwnmgXYbXFUekn",14) == 1955910469) strcat(s, "b");
if (crc32("mZEGyBM",7) == 425269952) strcat(s, "H");
if (crc32("KcoWKzYy",8) == 2412373185) strcat(s, "e");
if (crc32("zwGEP",5) == 270067367) strcat(s, "g");
if (crc32("PEKhmEECTBcIH",13) == 627724912) strcat(s, "i");
if (crc32("GUkqy",5) == 1841136493) strcat(s, "x");
if (crc32("RKiYHiQgBEJdD",13) == 4037186829) strcat(s, "r");
if (crc32("UOmomAOogSJ",11) == 1958539230) strcat(s, "d");
    return s;
}

char *misnavigated_verbs() {
    char *s = calloc(13);
    if (crc32("gZTcugkW",8) == 3119522976) strcat(s, "k");
if (crc32("liVCIxASYbW",11) == 4051816869) strcat(s, "m");
if (crc32("TZFeyicac",9) == 3210025252) strcat(s, "r");
if (crc32("RlCJYIVSifut",12) == 4271931906) strcat(s, "i");
if (crc32("uTNJUKrhiry",11) == 139237952) strcat(s, "y");
if (crc32("RSJluoUIYdESz",13) == 4000208024) strcat(s, "s");
if (crc32("YistvzkPrCLnPhw",15) == 3927305332) strcat(s, "n");
if (crc32("UhHwLayw",8) == 3222271013) strcat(s, "a");
if (crc32("zjNutEGAw",9) == 3925603612) strcat(s, "k");
if (crc32("XYQwoKAuSCAmR",13) == 3427314810) strcat(s, "v");
if (crc32("RjXmQu",6) == 4001362219) strcat(s, "i");
if (crc32("EdckNQPT",8) == 3677152142) strcat(s, "g");
if (crc32("YIVpsDTigVJSd",13) == 3041631319) strcat(s, "a");
if (crc32("DUyjUQZXxrJ",11) == 2271564042) strcat(s, "f");
if (crc32("DuTVNHSZBaDbej",14) == 876371556) strcat(s, "t");
if (crc32("ZJidbCDEk",9) == 1678923469) strcat(s, "s");
if (crc32("dtXgUrFjRnxVgc",14) == 1673185555) strcat(s, "e");
if (crc32("IQGUp",5) == 2399264394) strcat(s, "l");
if (crc32("vOlGxrzGnwvu",12) == 325042589) strcat(s, "d");
    return s;
}

char *togged_verbs() {
    char *s = calloc(7);
    if (crc32("ydLnyAiGBdOAjV",14) == 599290643) strcat(s, "b");
if (crc32("eRgQAhGDyjEM",12) == 2310066319) strcat(s, "t");
if (crc32("nlkPQCb",7) == 1373754262) strcat(s, "t");
if (crc32("GxZekvMjZBiPwrl",15) == 2831573998) strcat(s, "o");
if (crc32("EfwOM",5) == 2648978247) strcat(s, "S");
if (crc32("KPASzwilZdawmy",14) == 2151165057) strcat(s, "g");
if (crc32("fUAnv",5) == 532938679) strcat(s, "g");
if (crc32("UNhYNqMwxW",10) == 2506669686) strcat(s, "y");
if (crc32("TklEe",5) == 378401479) strcat(s, "e");
if (crc32("euBMBUiipPtbx",13) == 4049906520) strcat(s, "d");
    return s;
}

char *smoodge_verbs() {
    char *s = calloc(8);
    if (crc32("NNTvrJneTtPx",12) == 500587683) strcat(s, "l");
if (crc32("hkIhnlWhAdOI",12) == 2252580018) strcat(s, "s");
if (crc32("FGDWo",5) == 512097673) strcat(s, "y");
if (crc32("hyREDEgjLrpt",12) == 2054680957) strcat(s, "m");
if (crc32("HWBgc",5) == 1969375138) strcat(s, "o");
if (crc32("VshOpCtwSN",10) == 1204667796) strcat(s, "F");
if (crc32("PQlbcRhNgh",10) == 2234177856) strcat(s, "o");
if (crc32("tXFPLyRwD",9) == 320072840) strcat(s, "d");
if (crc32("VpgRMwwFbI",10) == 3947344059) strcat(s, "g");
if (crc32("CskumkoT",8) == 339424619) strcat(s, "K");
if (crc32("XdaJrXxzdsbcwL",14) == 1771417867) strcat(s, "e");
    return s;
}

char *harmonize_verbs() {
    char *s = calloc(10);
    if (crc32("NDqZLPJ",7) == 1416477858) strcat(s, "p");
if (crc32("MXYhZeFftatCmP",14) == 2579119144) strcat(s, "h");
if (crc32("poqILEcXztny",12) == 2631271896) strcat(s, "a");
if (crc32("nhEmAVJQWZtEfH",14) == 113658752) strcat(s, "r");
if (crc32("pEOHBeQPEb",10) == 823224688) strcat(s, "J");
if (crc32("GwzrfEM",7) == 2978613366) strcat(s, "m");
if (crc32("wuUscPtwhK",10) == 3268920719) strcat(s, "o");
if (crc32("INPeuV",6) == 721904436) strcat(s, "n");
if (crc32("PHCnfGGjgEnU",12) == 2393855350) strcat(s, "j");
if (crc32("bmxLSJSU",8) == 1239248088) strcat(s, "i");
if (crc32("LQxwnG",6) == 2536052937) strcat(s, "y");
if (crc32("Suxnq",5) == 1676553411) strcat(s, "z");
if (crc32("AyMbhhYsx",9) == 2456688349) strcat(s, "e");
    return s;
}

char *breathe_verbs() {
    char *s = calloc(8);
    if (crc32("EHIOTKoq",8) == 2089316564) strcat(s, "b");
if (crc32("kVrrukQrofsIb",13) == 414658340) strcat(s, "p");
if (crc32("EMQbEtoOnaX",11) == 1437704790) strcat(s, "r");
if (crc32("hAdjSzeONw",10) == 1218725793) strcat(s, "p");
if (crc32("xmxnZyxzoOszX",13) == 3442394116) strcat(s, "e");
if (crc32("kkZVFR",6) == 415785332) strcat(s, "Y");
if (crc32("iiHAh",5) == 3232502270) strcat(s, "a");
if (crc32("lMYLSTfmycJZedB",15) == 2716365808) strcat(s, "k");
if (crc32("zspnnoaYISJsOcd",15) == 934231081) strcat(s, "t");
if (crc32("UYrqLrKRJV",10) == 4170366949) strcat(s, "I");
if (crc32("pengsQebMrkMli",14) == 895892996) strcat(s, "h");
if (crc32("QSTRJ",5) == 2486441321) strcat(s, "u");
if (crc32("nXydVXMDVJMc",12) == 3973699722) strcat(s, "e");
    return s;
}

char *preen_verbs() {
    char *s = calloc(6);
    if (crc32("DzzZXJoXLxuRaf",14) == 4281465018) strcat(s, "p");
if (crc32("lCCJHxuo",8) == 2265810195) strcat(s, "r");
if (crc32("rTOJTvXlwAiJs",13) == 4247994356) strcat(s, "G");
if (crc32("myxEtsz",7) == 3648184264) strcat(s, "e");
if (crc32("SlHOCyGsC",9) == 873345947) strcat(s, "e");
if (crc32("TXJweTbZ",8) == 4202537154) strcat(s, "n");
    return s;
}

char *rewritten_verbs() {
    char *s = calloc(10);
    if (crc32("ikEderMvlkDIkRq",15) == 2845276830) strcat(s, "l");
if (crc32("vhKTpfVGmfQ",11) == 3726286477) strcat(s, "r");
if (crc32("KEJHhPRsuyuI",12) == 4103028966) strcat(s, "e");
if (crc32("psfCuSVfdOGK",12) == 2821051958) strcat(s, "w");
if (crc32("zvhELTiCTjoS",12) == 2594138798) strcat(s, "e");
if (crc32("fcdUfXtjHbtms",13) == 3932636406) strcat(s, "r");
if (crc32("WqpviIHqR",9) == 505753972) strcat(s, "i");
if (crc32("WrJqXcqScac",11) == 2187630611) strcat(s, "t");
if (crc32("qQYGkiyBdCIchEI",15) == 2790391904) strcat(s, "B");
if (crc32("sCbrx",5) == 4185221093) strcat(s, "t");
if (crc32("hXMIUKNLP",9) == 924835832) strcat(s, "F");
if (crc32("sukXP",5) == 2033885125) strcat(s, "e");
if (crc32("hfgLIoL",7) == 2522606881) strcat(s, "o");
if (crc32("ymEjFKWOQylKJA",14) == 3511103795) strcat(s, "n");
    return s;
}

char *overbalanced_verbs() {
    char *s = calloc(13);
    if (crc32("AksRHMRXgHL",11) == 158404534) strcat(s, "o");
if (crc32("oiErgsk",7) == 3196075058) strcat(s, "K");
if (crc32("CFIqPCwR",8) == 1438919469) strcat(s, "v");
if (crc32("nrBaVhMo",8) == 219078175) strcat(s, "e");
if (crc32("KLIPNIfAQvJgM",13) == 3792122371) strcat(s, "M");
if (crc32("QKTjLtGPZYQIsvL",15) == 917504421) strcat(s, "r");
if (crc32("UcJmQoYwv",9) == 2676357034) strcat(s, "l");
if (crc32("hoVEtQjqZHbmPD",14) == 2112241142) strcat(s, "b");
if (crc32("FBecKtxonBv",11) == 3265129413) strcat(s, "a");
if (crc32("XbXYyL",6) == 1588523618) strcat(s, "l");
if (crc32("vwGHJnIC",8) == 1497707843) strcat(s, "U");
if (crc32("zDpovRxbpG",10) == 3989228095) strcat(s, "a");
if (crc32("EADBacXAvHO",11) == 914400144) strcat(s, "p");
if (crc32("cdrvTsTXBwqV",12) == 4061059491) strcat(s, "n");
if (crc32("DTEBksLUbaC",11) == 4293068353) strcat(s, "c");
if (crc32("KZiIaLjhqHKnSi",14) == 728118174) strcat(s, "J");
if (crc32("KCFaNhQ",7) == 3452541879) strcat(s, "e");
if (crc32("zMHqkI",6) == 964831761) strcat(s, "d");
    return s;
}

char *channelled_verbs() {
    char *s = calloc(11);
    if (crc32("fOLnyLomqtzRNta",15) == 2359021577) strcat(s, "c");
if (crc32("TxvPaKhKc",9) == 1552014946) strcat(s, "h");
if (crc32("XBenySbF",8) == 3508388033) strcat(s, "A");
if (crc32("JEnoyBlS",8) == 3167963001) strcat(s, "a");
if (crc32("hUQUWvNWXFvYXo",14) == 1669418414) strcat(s, "n");
if (crc32("AGukzRHzd",9) == 368068416) strcat(s, "O");
if (crc32("mhmJDSJ",7) == 1991112652) strcat(s, "n");
if (crc32("mlKmcHj",7) == 637490784) strcat(s, "h");
if (crc32("qFLyl",5) == 2140578539) strcat(s, "e");
if (crc32("oWdRcHOr",8) == 3319639279) strcat(s, "l");
if (crc32("xGEJiAXcXBTsfrQ",15) == 637997707) strcat(s, "l");
if (crc32("ppNzxCVuB",9) == 3749067218) strcat(s, "B");
if (crc32("OTVUgLfcMCyVbR",14) == 1919960625) strcat(s, "e");
if (crc32("qyTDnNkevgtvRM",14) == 2374959404) strcat(s, "d");
    return s;
}

char *reexport_verbs() {
    char *s = calloc(9);
    if (crc32("YkFAzPX",7) == 996439846) strcat(s, "r");
if (crc32("WnVFI",5) == 1459234627) strcat(s, "e");
if (crc32("VyOuVSwBqDKEP",13) == 2985865509) strcat(s, "e");
if (crc32("PehvqpuWSyC",11) == 4034188497) strcat(s, "x");
if (crc32("ZWEThoB",7) == 1121707289) strcat(s, "w");
if (crc32("phAyADMY",8) == 1119278416) strcat(s, "p");
if (crc32("ZjGuGLatwNZXs",13) == 3705568626) strcat(s, "h");
if (crc32("UZHmSKSXEeKD",12) == 4201371138) strcat(s, "o");
if (crc32("ulehSRK",7) == 4097048357) strcat(s, "r");
if (crc32("aPkuBivNVdsw",12) == 1756936904) strcat(s, "M");
if (crc32("jHSbSlsbO",9) == 1801577786) strcat(s, "t");
    return s;
}

char *payup_verbs() {
    char *s = calloc(6);
    if (crc32("OGzZzQB",7) == 1484472529) strcat(s, "S");
if (crc32("OXVWTKNrg",9) == 87174587) strcat(s, "p");
if (crc32("MfefQ",5) == 3104943971) strcat(s, "n");
if (crc32("rRSiNVc",7) == 3693007080) strcat(s, "a");
if (crc32("WFWOqRckUDh",11) == 3419370142) strcat(s, "y");
if (crc32("vNSwin",6) == 2031653897) strcat(s, "k");
if (crc32("CJPxvqoNv",9) == 1290369883) strcat(s, "u");
if (crc32("onPjGzFgdod",11) == 867299582) strcat(s, "R");
if (crc32("HfytWlICQsvHd",13) == 3263875260) strcat(s, "p");
    return s;
}

char *restyle_verbs() {
    char *s = calloc(8);
    if (crc32("iMDzcP",6) == 1458645173) strcat(s, "r");
if (crc32("LwrBcljwpPL",11) == 1737481417) strcat(s, "e");
if (crc32("FXBciYQiBv",10) == 2924260092) strcat(s, "Y");
if (crc32("HTsavV",6) == 1420346493) strcat(s, "s");
if (crc32("FdwbpflWHqlPaas",15) == 2995265881) strcat(s, "t");
if (crc32("thaofclb",8) == 327387035) strcat(s, "y");
if (crc32("xutFVzA",7) == 1549050841) strcat(s, "p");
if (crc32("XSOMtZ",6) == 1433717954) strcat(s, "l");
if (crc32("ruzMYiSAVktdtg",14) == 3716328284) strcat(s, "k");
if (crc32("IcIwkPdFGI",10) == 3516747676) strcat(s, "e");
    return s;
}

char *hobbed_verbs() {
    char *s = calloc(7);
    if (crc32("nOACLkScur",10) == 1339893067) strcat(s, "F");
if (crc32("XRIfoUMWqjT",11) == 26074516) strcat(s, "h");
if (crc32("LrHnZY",6) == 71307885) strcat(s, "o");
if (crc32("dqEWHP",6) == 1894195539) strcat(s, "b");
if (crc32("nMWNvDhApOAbi",13) == 2569035355) strcat(s, "O");
if (crc32("sBTtrDWTBELQUUM",15) == 3212812302) strcat(s, "b");
if (crc32("BBXJImUsA",9) == 2607900233) strcat(s, "n");
if (crc32("INund",5) == 194096120) strcat(s, "e");
if (crc32("hwEJwmy",7) == 919617902) strcat(s, "E");
if (crc32("eVQrsQfiDUUifRn",15) == 2147673862) strcat(s, "d");
    return s;
}

char *overworking_verbs() {
    char *s = calloc(12);
    if (crc32("iLFTvC",6) == 1217483857) strcat(s, "Q");
if (crc32("oHwcMPAHoaB",11) == 1522431520) strcat(s, "o");
if (crc32("kIwLtNDHQeLqGD",14) == 3571674738) strcat(s, "s");
if (crc32("UaQwONEOsWgXVyd",15) == 1796847272) strcat(s, "v");
if (crc32("obgemQ",6) == 2403371768) strcat(s, "e");
if (crc32("xhcHjwNbSAzOLA",14) == 3503938761) strcat(s, "r");
if (crc32("lQdkErYq",8) == 1747690548) strcat(s, "x");
if (crc32("YIvikPXdkiuS",12) == 1436893349) strcat(s, "w");
if (crc32("zzweS",5) == 3398741746) strcat(s, "o");
if (crc32("DIpNbHgntaJlAV",14) == 1221776265) strcat(s, "r");
if (crc32("kCAAujpgySDI",12) == 3719310420) strcat(s, "k");
if (crc32("sBVgNCLx",8) == 2515600885) strcat(s, "i");
if (crc32("NuXrKvjvhllgkk",14) == 2473542738) strcat(s, "i");
if (crc32("eDyHTJSBtVx",11) == 2904392393) strcat(s, "n");
if (crc32("mcEKoe",6) == 3565328427) strcat(s, "g");
    return s;
}

char *wreck_verbs() {
    char *s = calloc(6);
    if (crc32("MhkAgwquz",9) == 3980308136) strcat(s, "w");
if (crc32("QTtUgY",6) == 3556545273) strcat(s, "E");
if (crc32("pCQNa",5) == 2405472195) strcat(s, "r");
if (crc32("LFiWHPCFC",9) == 2791098804) strcat(s, "e");
if (crc32("XVZmkNDHUrQevoN",15) == 4279337062) strcat(s, "K");
if (crc32("RPcscxOiIUcGIID",15) == 2932685091) strcat(s, "c");
if (crc32("syHXAH",6) == 1708975182) strcat(s, "k");
    return s;
}

char *abated_verbs() {
    char *s = calloc(7);
    if (crc32("ZXnlIsRXHiOZ",12) == 27043030) strcat(s, "l");
if (crc32("EwTcGGKBM",9) == 3617516649) strcat(s, "a");
if (crc32("TsfjQVTuXyB",11) == 441174219) strcat(s, "b");
if (crc32("vqvnZpomrkzZ",12) == 2343343287) strcat(s, "a");
if (crc32("DPygyqw",7) == 3505402896) strcat(s, "t");
if (crc32("duwuHVUEN",9) == 2179879263) strcat(s, "e");
if (crc32("LfsOdu",6) == 4237821894) strcat(s, "d");
    return s;
}

char *resell_verbs() {
    char *s = calloc(7);
    if (crc32("hppHF",5) == 4155581173) strcat(s, "r");
if (crc32("boklvGVGvut",11) == 1624054258) strcat(s, "S");
if (crc32("IGneXzFShje",11) == 3871897094) strcat(s, "e");
if (crc32("WyhzE",5) == 624909865) strcat(s, "Y");
if (crc32("ResJQteQ",8) == 284500444) strcat(s, "s");
if (crc32("kmIuwYeegUUFKZC",15) == 899230085) strcat(s, "N");
if (crc32("obqrxTqNndI",11) == 3475883333) strcat(s, "e");
if (crc32("XIQnWHTSMxz",11) == 1429972331) strcat(s, "l");
if (crc32("cmWKKNdrkHuL",12) == 713538165) strcat(s, "O");
if (crc32("MlNjSSPK",8) == 2441863133) strcat(s, "l");
    return s;
}

char *contemplate_verbs() {
    char *s = calloc(12);
    if (crc32("ozIWc",5) == 2278038087) strcat(s, "c");
if (crc32("OSpGmhnCCpMduKh",15) == 893003311) strcat(s, "i");
if (crc32("hSFFIveMwxzwCdC",15) == 648705427) strcat(s, "o");
if (crc32("kEmefOZdPgnoilB",15) == 2049585315) strcat(s, "D");
if (crc32("TSJpyTcLBVWME",13) == 3865289858) strcat(s, "n");
if (crc32("hormNcbucpo",11) == 3029086054) strcat(s, "r");
if (crc32("epQce",5) == 3803793032) strcat(s, "t");
if (crc32("iTwypiKEcyRWoj",14) == 3064240446) strcat(s, "e");
if (crc32("hCHBm",5) == 2456110344) strcat(s, "y");
if (crc32("pwCtOcbJoTnV",12) == 1012831680) strcat(s, "m");
if (crc32("EojMtS",6) == 1625124776) strcat(s, "p");
if (crc32("pNUtqouHlWS",11) == 2374599028) strcat(s, "u");
if (crc32("thuoVRfGOxnDqrS",15) == 3854562870) strcat(s, "l");
if (crc32("HMHsYUVxQ",9) == 1538721055) strcat(s, "M");
if (crc32("QiZVPNAwW",9) == 3053947724) strcat(s, "a");
if (crc32("igNcyEVpwzeyvFr",15) == 2132854325) strcat(s, "G");
if (crc32("SPxUXxWSY",9) == 923684440) strcat(s, "t");
if (crc32("WbeYmvnXLA",10) == 3257456898) strcat(s, "e");
    return s;
}

char *superastonish_verbs() {
    char *s = calloc(14);
    if (crc32("ucxVHV",6) == 2603041718) strcat(s, "l");
if (crc32("HlNZisT",7) == 4192169432) strcat(s, "s");
if (crc32("hgIuGNWzM",9) == 1958088027) strcat(s, "u");
if (crc32("qBxNCC",6) == 161050450) strcat(s, "B");
if (crc32("tAQkxQSFjiGEB",13) == 2728790398) strcat(s, "p");
if (crc32("bVIUrchCSsG",11) == 3377772859) strcat(s, "n");
if (crc32("KDaIegjkPY",10) == 4383923) strcat(s, "e");
if (crc32("QQIgjUxNEkuHvlL",15) == 192577600) strcat(s, "Q");
if (crc32("puDwW",5) == 2180204806) strcat(s, "r");
if (crc32("oNPxXXfnln",10) == 2289019397) strcat(s, "a");
if (crc32("MnDbzqtGMhYkNoc",15) == 3232352031) strcat(s, "s");
if (crc32("eadRkjo",7) == 2355211586) strcat(s, "t");
if (crc32("XjQFhHiG",8) == 2300611197) strcat(s, "h");
if (crc32("PiXIGdufmRjsA",13) == 3713500469) strcat(s, "o");
if (crc32("uOdTyPhaGzU",11) == 3204620355) strcat(s, "n");
if (crc32("LVxkKcpYlBeaS",13) == 4277024512) strcat(s, "i");
if (crc32("RgnLIwzvEIvWG",13) == 2330021753) strcat(s, "y");
if (crc32("BQafb",5) == 1320090033) strcat(s, "s");
if (crc32("CbzATCSstrqP",12) == 1653763755) strcat(s, "h");
    return s;
}

char *raise_verbs() {
    char *s = calloc(6);
    if (crc32("IMbtxDD",7) == 1204868064) strcat(s, "r");
if (crc32("OulZGEK",7) == 2506590987) strcat(s, "a");
if (crc32("qHzUlxFurxkF",12) == 1133332598) strcat(s, "i");
if (crc32("itfiOqPheYZFj",13) == 745006219) strcat(s, "g");
if (crc32("QwnAovxFNUhspah",15) == 1609779725) strcat(s, "s");
if (crc32("gOUtKri",7) == 4182174765) strcat(s, "b");
if (crc32("IwgGpPZevg",10) == 1028327129) strcat(s, "e");
    return s;
}

char *reorchestrating_verbs() {
    char *s = calloc(16);
    if (crc32("ynjnMCVJ",8) == 3818088031) strcat(s, "r");
if (crc32("SLHnKabdzrR",11) == 3178135902) strcat(s, "e");
if (crc32("rDxvXgkiSGz",11) == 3083449136) strcat(s, "o");
if (crc32("eZKZeQ",6) == 2994758394) strcat(s, "r");
if (crc32("UGYkaqEdWJQYN",13) == 964925168) strcat(s, "b");
if (crc32("SmylLQZ",7) == 4019673742) strcat(s, "c");
if (crc32("SYsRUcOpTwll",12) == 1254155789) strcat(s, "h");
if (crc32("jfOKzevY",8) == 2479579338) strcat(s, "g");
if (crc32("koeQPo",6) == 3466845325) strcat(s, "e");
if (crc32("rKVEXvi",7) == 277732636) strcat(s, "h");
if (crc32("pcpCxCNuUmVw",12) == 395662644) strcat(s, "s");
if (crc32("eyKWnoSkgRG",11) == 3748543407) strcat(s, "t");
if (crc32("vBddbj",6) == 1337771677) strcat(s, "r");
if (crc32("ryhqyoQi",8) == 281038550) strcat(s, "a");
if (crc32("EzRSqFoNdBBqPIv",15) == 2429758415) strcat(s, "f");
if (crc32("txOXzOKNqE",10) == 3243063465) strcat(s, "t");
if (crc32("cRUkVLoomIm",11) == 3088781309) strcat(s, "i");
if (crc32("xGtIy",5) == 1390002639) strcat(s, "n");
if (crc32("pXQoVI",6) == 1633210196) strcat(s, "g");
    return s;
}

char *jutted_verbs() {
    char *s = calloc(7);
    if (crc32("dknPBOANSmPcgMz",15) == 255405214) strcat(s, "j");
if (crc32("TxSPeTmGor",10) == 2502891034) strcat(s, "u");
if (crc32("xtKgoehVckUuWFL",15) == 1041891101) strcat(s, "c");
if (crc32("nADHT",5) == 3770512533) strcat(s, "t");
if (crc32("EAgWDMKxNNd",11) == 2324280743) strcat(s, "y");
if (crc32("xrhSKlMxMJFt",12) == 3515841702) strcat(s, "t");
if (crc32("fugJHyoNBi",10) == 1203478549) strcat(s, "e");
if (crc32("jDovSxueJRX",11) == 3788571647) strcat(s, "l");
if (crc32("GKDtQx",6) == 910977234) strcat(s, "d");
    return s;
}

char *bilged_verbs() {
    char *s = calloc(7);
    if (crc32("FqpvDuBLkIMruGG",15) == 77557319) strcat(s, "b");
if (crc32("PPMerxhG",8) == 797786356) strcat(s, "i");
if (crc32("LyyrznjnNlktmjd",15) == 2598182886) strcat(s, "S");
if (crc32("irZxmTLCV",9) == 2641967939) strcat(s, "l");
if (crc32("SqbSvGbs",8) == 1801299519) strcat(s, "g");
if (crc32("ZSulhhSW",8) == 1746619079) strcat(s, "e");
if (crc32("VJMPXCyqpxyzZy",14) == 2851928442) strcat(s, "f");
if (crc32("ekKbStmg",8) == 2066757370) strcat(s, "d");
    return s;
}

char *fanned_verbs() {
    char *s = calloc(7);
    if (crc32("XfZlbwMG",8) == 2544786238) strcat(s, "f");
if (crc32("ZNHFBrAZlcWwML",14) == 3515553981) strcat(s, "a");
if (crc32("MaCmmCIkjrSrXQ",14) == 2667251597) strcat(s, "n");
if (crc32("jpXUeq",6) == 3124328462) strcat(s, "n");
if (crc32("XhPVY",5) == 2721681865) strcat(s, "e");
if (crc32("mUfmGRfZMXhsm",13) == 1338847528) strcat(s, "E");
if (crc32("pRXvZfv",7) == 2644471469) strcat(s, "d");
    return s;
}

char *rustling_verbs() {
    char *s = calloc(9);
    if (crc32("qNwutjwqeWT",11) == 1525894835) strcat(s, "r");
if (crc32("ThSfpuwbuk",10) == 2290233460) strcat(s, "u");
if (crc32("XoOyznPyVLkE",12) == 3090395840) strcat(s, "s");
if (crc32("BuqnbaiRKEW",11) == 4178801681) strcat(s, "t");
if (crc32("JAUbQWVdsPndZzq",15) == 301825055) strcat(s, "l");
if (crc32("alYXpgwiSbDde",13) == 2536205487) strcat(s, "D");
if (crc32("quFBwWPwJyyVn",13) == 2535578615) strcat(s, "i");
if (crc32("eSeiSvhhYEWWM",13) == 730797020) strcat(s, "n");
if (crc32("ilnyZhD",7) == 1912598547) strcat(s, "g");
    return s;
}

char *grimed_verbs() {
    char *s = calloc(7);
    if (crc32("WaxHI",5) == 299494852) strcat(s, "G");
if (crc32("ZmMUoxkKbshwEJA",15) == 1682030720) strcat(s, "g");
if (crc32("AsedPITbVsy",11) == 515854131) strcat(s, "c");
if (crc32("UVJnL",5) == 565093468) strcat(s, "r");
if (crc32("lnUry",5) == 751163902) strcat(s, "N");
if (crc32("iMYGi",5) == 3544545216) strcat(s, "i");
if (crc32("jnePYqf",7) == 3943943301) strcat(s, "m");
if (crc32("ewnIuB",6) == 3424753893) strcat(s, "e");
if (crc32("LilIEJcLv",9) == 3201035265) strcat(s, "d");
    return s;
}

char *swinging_verbs() {
    char *s = calloc(9);
    if (crc32("mdbrTPCKyviUpI",14) == 865808743) strcat(s, "s");
if (crc32("CRXDQqrKkve",11) == 2004191388) strcat(s, "w");
if (crc32("jjyrkheyJ",9) == 1743610015) strcat(s, "i");
if (crc32("WEDddKSGoi",10) == 944350823) strcat(s, "n");
if (crc32("wvPNNrPZEAhhd",13) == 17567973) strcat(s, "z");
if (crc32("REozezYDDp",10) == 1700838839) strcat(s, "g");
if (crc32("xJpWxfUjBJQLHwc",15) == 1670891301) strcat(s, "m");
if (crc32("SxZIQfTuSfqgM",13) == 2282238412) strcat(s, "i");
if (crc32("UtlNHMSNJs",10) == 2281983311) strcat(s, "W");
if (crc32("ZSItbZyAEhi",11) == 1892917234) strcat(s, "n");
if (crc32("vcEKbCCSmJaWcT",14) == 2259469) strcat(s, "e");
if (crc32("FSaLWuvSAaW",11) == 3631585888) strcat(s, "g");
    return s;
}

char *write_verbs() {
    char *s = calloc(6);
    if (crc32("RZHlOFDmLVsKmmE",15) == 543189422) strcat(s, "S");
if (crc32("vkuyPgWpB",9) == 984666263) strcat(s, "w");
if (crc32("GDuZVSj",7) == 1229686873) strcat(s, "r");
if (crc32("DMzUkFXHlGsoWf",14) == 1073510789) strcat(s, "i");
if (crc32("LKqLVfEcQ",9) == 2863449546) strcat(s, "C");
if (crc32("yEjcGXfDGqWFE",13) == 2732003536) strcat(s, "t");
if (crc32("omyIBLXis",9) == 2597601927) strcat(s, "E");
if (crc32("ECizfsu",7) == 4195659954) strcat(s, "e");
    return s;
}

char *bignote_verbs() {
    char *s = calloc(8);
    if (crc32("htsjylXFj",9) == 2979961658) strcat(s, "b");
if (crc32("nPZdbF",6) == 3327347) strcat(s, "K");
if (crc32("qqrwyClMylYnEf",14) == 1014430041) strcat(s, "i");
if (crc32("fVMRGKtZK",9) == 1791434155) strcat(s, "g");
if (crc32("ERbpahMmjnIiC",13) == 2549548259) strcat(s, "Z");
if (crc32("bgLxPhVlYQv",11) == 1869430873) strcat(s, "n");
if (crc32("JBpdVoJQRMamzw",14) == 1157852214) strcat(s, "r");
if (crc32("FcOVg",5) == 2096350925) strcat(s, "o");
if (crc32("hwThCrhk",8) == 912069529) strcat(s, "f");
if (crc32("UrPaA",5) == 3865500385) strcat(s, "t");
if (crc32("hqQoVunumKHWn",13) == 239034557) strcat(s, "h");
if (crc32("WprOdi",6) == 3600067734) strcat(s, "e");
    return s;
}

char *Italianated_verbs() {
    char *s = calloc(12);
    if (crc32("HyywUCDXTvuFm",13) == 2508249111) strcat(s, "s");
if (crc32("LBeVzQJNdNwA",12) == 2831783208) strcat(s, "I");
if (crc32("BpKxuUgPqo",10) == 1854297641) strcat(s, "B");
if (crc32("uxFtwWhAV",9) == 2758151260) strcat(s, "t");
if (crc32("hUJfrnISRi",10) == 497650595) strcat(s, "a");
if (crc32("mkgRg",5) == 1566843499) strcat(s, "l");
if (crc32("zAEeZMn",7) == 1888192759) strcat(s, "z");
if (crc32("PaQFIqE",7) == 2311340107) strcat(s, "i");
if (crc32("VFbIMaxfs",9) == 3212654721) strcat(s, "a");
if (crc32("HomoMw",6) == 3347777871) strcat(s, "t");
if (crc32("pzlOPFGEpFZ",11) == 4219813910) strcat(s, "n");
if (crc32("urJGbfQcuYpDNr",14) == 1005613389) strcat(s, "a");
if (crc32("jGICoBTW",8) == 2837623596) strcat(s, "t");
if (crc32("wXaiKTrDcmoI",12) == 3952215386) strcat(s, "e");
if (crc32("mgrlgxNrbOyz",12) == 3942731666) strcat(s, "d");
    return s;
}

char *insnare_verbs() {
    char *s = calloc(8);
    if (crc32("xUWkfmQGJrI",11) == 3679573750) strcat(s, "i");
if (crc32("bAdJqEQZleXzdo",14) == 709583854) strcat(s, "M");
if (crc32("vFpgPBehjSte",12) == 2067252090) strcat(s, "n");
if (crc32("WQvTvanYbXvdjIK",15) == 277792228) strcat(s, "s");
if (crc32("ZQbyUFTCw",9) == 2565936308) strcat(s, "n");
if (crc32("pKWhA",5) == 3068747890) strcat(s, "a");
if (crc32("DCfqZeUdl",9) == 1485976235) strcat(s, "i");
if (crc32("JnjezjvFuacBp",13) == 3558613202) strcat(s, "r");
if (crc32("fooPGZoKsEqY",12) == 1565098338) strcat(s, "M");
if (crc32("VhInF",5) == 2489910873) strcat(s, "e");
    return s;
}

char *contemporized_verbs() {
    char *s = calloc(14);
    if (crc32("PJvbhoNvuG",10) == 900700653) strcat(s, "d");
if (crc32("SOTEDS",6) == 3039971827) strcat(s, "c");
if (crc32("uRczJSAAJjhukfZ",15) == 4023651782) strcat(s, "e");
if (crc32("IdSMD",5) == 2098825561) strcat(s, "o");
if (crc32("uuRVdIaBQ",9) == 36760201) strcat(s, "a");
if (crc32("BmxckCSF",8) == 1305091140) strcat(s, "n");
if (crc32("zUGfLgsrTPYF",12) == 231532447) strcat(s, "t");
if (crc32("UHpdvlCHx",9) == 1215891174) strcat(s, "e");
if (crc32("KWdPGYhaHGEnlQ",14) == 2574857323) strcat(s, "M");
if (crc32("XfWhkQERlsHghex",15) == 287109971) strcat(s, "m");
if (crc32("MkqBSPglgGxaAsR",15) == 2561464325) strcat(s, "p");
if (crc32("piEPtEPSZLLyyc",14) == 3737304168) strcat(s, "o");
if (crc32("QrMmF",5) == 902403757) strcat(s, "r");
if (crc32("dwSErSizMaosDgH",15) == 3966913785) strcat(s, "X");
if (crc32("vUqBExQzv",9) == 1336507667) strcat(s, "i");
if (crc32("VznyBBHd",8) == 1211363213) strcat(s, "z");
if (crc32("qTkUuCBklYl",11) == 2756155534) strcat(s, "B");
if (crc32("iAnfxvprGHmm",12) == 3667459997) strcat(s, "e");
if (crc32("kHiqP",5) == 3872872603) strcat(s, "v");
if (crc32("DmntQxhfYqPPvPI",15) == 2991702285) strcat(s, "d");
    return s;
}

char *capsized_verbs() {
    char *s = calloc(9);
    if (crc32("UwemA",5) == 2556532735) strcat(s, "T");
if (crc32("mnwIGdF",7) == 65431130) strcat(s, "c");
if (crc32("XKcMocLakwMC",12) == 1246069238) strcat(s, "n");
if (crc32("BjfqNQGGBQrzlU",14) == 4149680448) strcat(s, "a");
if (crc32("bmzHRBTpQlBFiOz",15) == 4175634526) strcat(s, "H");
if (crc32("HvDrJBolE",9) == 2969116145) strcat(s, "p");
if (crc32("QxjaIyKmPhRcrs",14) == 2484153710) strcat(s, "R");
if (crc32("hheqexkFZPdq",12) == 1931083738) strcat(s, "s");
if (crc32("igUxPIRtYvpn",12) == 157971056) strcat(s, "i");
if (crc32("gbHPXtMkKvvM",12) == 3847877197) strcat(s, "F");
if (crc32("XIZkAL",6) == 1925622265) strcat(s, "z");
if (crc32("DqnVCECVuRLj",12) == 4105581738) strcat(s, "e");
if (crc32("SMPsznQDSPVemA",14) == 577627148) strcat(s, "b");
if (crc32("IYxHH",5) == 1065465930) strcat(s, "d");
    return s;
}

char *proportionated_verbs() {
    char *s = calloc(15);
    if (crc32("DgXOBGEKYEvK",12) == 1479210682) strcat(s, "p");
if (crc32("UJQghxjTWokwp",13) == 4141235725) strcat(s, "r");
if (crc32("FiryciVcuSBDF",13) == 2513771478) strcat(s, "o");
if (crc32("GxkMNuMAixMZmx",14) == 1527135607) strcat(s, "o");
if (crc32("bvmoLQvVzGyhqR",14) == 3014057425) strcat(s, "T");
if (crc32("sqLPQn",6) == 1276313292) strcat(s, "p");
if (crc32("tfYvEybLyXukzdY",15) == 1843528196) strcat(s, "n");
if (crc32("SfvuSNQsxYZy",12) == 3680779243) strcat(s, "o");
if (crc32("OfQBhZdEsTv",11) == 209581440) strcat(s, "b");
if (crc32("rqBxNXvJzlzrq",13) == 295623908) strcat(s, "r");
if (crc32("lOEomTeyzvrSrIj",15) == 890485590) strcat(s, "Q");
if (crc32("WRCOB",5) == 2969199360) strcat(s, "t");
if (crc32("RLyhSEam",8) == 2498362430) strcat(s, "i");
if (crc32("froJTaD",7) == 3133737901) strcat(s, "o");
if (crc32("pBVkMiiNDhsZ",12) == 1230159805) strcat(s, "r");
if (crc32("cgTEaslIbcl",11) == 2221358515) strcat(s, "n");
if (crc32("mGtDJ",5) == 2147722385) strcat(s, "m");
if (crc32("OhtaGvZDPJdN",12) == 3992721387) strcat(s, "a");
if (crc32("voiHLrnSBglyJr",14) == 2054245801) strcat(s, "a");
if (crc32("idRKu",5) == 3130944470) strcat(s, "t");
if (crc32("AyJOk",5) == 2693833387) strcat(s, "m");
if (crc32("LPVOcfqJPjzb",12) == 524110772) strcat(s, "e");
if (crc32("lHcrYITfcm",10) == 1661739564) strcat(s, "d");
    return s;
}

char *hiccupped_verbs() {
    char *s = calloc(10);
    if (crc32("QDHFmcZAb",9) == 2531833128) strcat(s, "T");
if (crc32("XPkjNCATdwInuZ",14) == 3610062838) strcat(s, "h");
if (crc32("HEfTt",5) == 3053566723) strcat(s, "P");
if (crc32("ujrKhejUn",9) == 2386724335) strcat(s, "i");
if (crc32("ZxVSVKWzZU",10) == 1326310450) strcat(s, "s");
if (crc32("MvuYYCjbESRVTN",14) == 458192038) strcat(s, "c");
if (crc32("HkOwZiDs",8) == 498610086) strcat(s, "c");
if (crc32("vLRIVfF",7) == 178782690) strcat(s, "u");
if (crc32("xJlji",5) == 3305434485) strcat(s, "V");
if (crc32("lFBpsb",6) == 3674542540) strcat(s, "p");
if (crc32("RvrxypObtdNWF",13) == 1098721418) strcat(s, "p");
if (crc32("rxqzYvjelzJX",12) == 4053782486) strcat(s, "e");
if (crc32("NwkPIklWsVdKAQL",15) == 1097645997) strcat(s, "d");
    return s;
}

char *dagging_verbs() {
    char *s = calloc(8);
    if (crc32("yGPIAMBNTNiRkVY",15) == 1052689675) strcat(s, "P");
if (crc32("aRdPPNPdbYQLIH",14) == 1551693946) strcat(s, "d");
if (crc32("iESZkRCqdzDcqqj",15) == 480259562) strcat(s, "I");
if (crc32("nvukKYnlrTYe",12) == 852732772) strcat(s, "a");
if (crc32("VStVxvqUxE",10) == 718333843) strcat(s, "S");
if (crc32("WqXfsGepUtMkU",13) == 332977909) strcat(s, "g");
if (crc32("IewmYAPTmjW",11) == 172457822) strcat(s, "g");
if (crc32("JLoNpfs",7) == 3414062139) strcat(s, "i");
if (crc32("coDnA",5) == 3262940339) strcat(s, "O");
if (crc32("YWGxV",5) == 3049320902) strcat(s, "n");
if (crc32("xbkykllmhwVuxS",14) == 3281613138) strcat(s, "X");
if (crc32("WtPGxUiuaqxXbMi",15) == 1662716322) strcat(s, "g");
    return s;
}

char *overvary_verbs() {
    char *s = calloc(9);
    if (crc32("GOJEHQlYIUSQ",12) == 1246437445) strcat(s, "e");
if (crc32("KZoYcs",6) == 554329838) strcat(s, "o");
if (crc32("sFKdZcLj",8) == 1988178059) strcat(s, "v");
if (crc32("BMiYYVA",7) == 2079244085) strcat(s, "Y");
if (crc32("oSCCvpVpXFCG",12) == 3201126529) strcat(s, "e");
if (crc32("KXPhGgZAVDAzy",13) == 3636543382) strcat(s, "r");
if (crc32("tmdcQMUMabCqKET",15) == 553335477) strcat(s, "G");
if (crc32("NErIDl",6) == 2062509228) strcat(s, "v");
if (crc32("ZvBlAkMvQDKlZA",14) == 1847177093) strcat(s, "R");
if (crc32("NwXIqGyQ",8) == 2164502224) strcat(s, "a");
if (crc32("fNaBGzHkYm",10) == 3158348950) strcat(s, "p");
if (crc32("zONvtXFDPadvG",13) == 1331033878) strcat(s, "r");
if (crc32("oTzGXehmj",9) == 3482723072) strcat(s, "V");
if (crc32("HzhmUtYkPOWc",12) == 1864566710) strcat(s, "y");
    return s;
}

char *reaccommodate_verbs() {
    char *s = calloc(14);
    if (crc32("FVuTQvjpnZCQW",13) == 1944273378) strcat(s, "r");
if (crc32("pEFIedJyO",9) == 4166913748) strcat(s, "e");
if (crc32("NedEKHJ",7) == 37363286) strcat(s, "i");
if (crc32("knIWyL",6) == 4220221328) strcat(s, "a");
if (crc32("XJYxmXY",7) == 489760175) strcat(s, "T");
if (crc32("HKdItSF",7) == 1483272779) strcat(s, "c");
if (crc32("ZiCwCXOC",8) == 1468094437) strcat(s, "g");
if (crc32("XOZDqGzdshN",11) == 3111384095) strcat(s, "c");
if (crc32("AIYgcYnUXurZdXt",15) == 2585431996) strcat(s, "o");
if (crc32("POBiLQIbG",9) == 3053652365) strcat(s, "m");
if (crc32("rvxVPvGTZHRVD",13) == 723151514) strcat(s, "u");
if (crc32("lWtjpYXB",8) == 2781339612) strcat(s, "m");
if (crc32("VIHUPwiSdIQoyU",14) == 3907208771) strcat(s, "o");
if (crc32("KTzIOBbVRvIpYb",14) == 1409579341) strcat(s, "f");
if (crc32("dXCsk",5) == 143106209) strcat(s, "d");
if (crc32("cuJuipgJcLC",11) == 786590669) strcat(s, "a");
if (crc32("OqyXH",5) == 1612254956) strcat(s, "h");
if (crc32("FVmEZXAXpoY",11) == 2236654218) strcat(s, "t");
if (crc32("hQOdHuNNiSJ",11) == 4090546769) strcat(s, "Q");
if (crc32("aJsWNIEPz",9) == 2762135127) strcat(s, "e");
    return s;
}

char *fating_verbs() {
    char *s = calloc(7);
    if (crc32("LySVKTstPWFye",13) == 3717538768) strcat(s, "f");
if (crc32("nSYAnzwiPwaxui",14) == 2123594685) strcat(s, "a");
if (crc32("idePaXvKrKKxM",13) == 1174829414) strcat(s, "j");
if (crc32("Kqjknkv",7) == 1503510328) strcat(s, "t");
if (crc32("mfcdGSInZeYFgHf",15) == 446200076) strcat(s, "i");
if (crc32("lHnHAjPGzpll",12) == 1429523470) strcat(s, "u");
if (crc32("aOVWno",6) == 154132591) strcat(s, "n");
if (crc32("LAtphf",6) == 361914388) strcat(s, "g");
    return s;
}

char *nitrating_verbs() {
    char *s = calloc(10);
    if (crc32("ckdYtqPa",8) == 636598766) strcat(s, "n");
if (crc32("DXaIlNUdKuhz",12) == 1719882624) strcat(s, "i");
if (crc32("EyoOpZeaUwYyg",13) == 3700853007) strcat(s, "t");
if (crc32("rxqGZLfdfbCjOrk",15) == 900956778) strcat(s, "u");
if (crc32("wczOSvnXfbgzZ",13) == 1780270380) strcat(s, "r");
if (crc32("sAPqSjnudXEA",12) == 1665171437) strcat(s, "W");
if (crc32("ZQvSV",5) == 2228397572) strcat(s, "a");
if (crc32("HNITOUPgdepFTDl",15) == 887002242) strcat(s, "t");
if (crc32("PuNtPkRRyBP",11) == 3236120355) strcat(s, "X");
if (crc32("SHsETlR",7) == 1501168730) strcat(s, "i");
if (crc32("nSYlLO",6) == 2984793334) strcat(s, "n");
if (crc32("kCjvjq",6) == 3727447306) strcat(s, "t");
if (crc32("pqQzDfNIJfmd",12) == 1410807065) strcat(s, "g");
    return s;
}

char *jamming_verbs() {
    char *s = calloc(8);
    if (crc32("qqNXJnFNj",9) == 3958509039) strcat(s, "j");
if (crc32("PgcTZgPXoYIGihe",15) == 3003161899) strcat(s, "a");
if (crc32("ENphKuNbdh",10) == 3213692300) strcat(s, "m");
if (crc32("TcBlFmn",7) == 1073939581) strcat(s, "v");
if (crc32("dEbkVQiVMx",10) == 1582176945) strcat(s, "m");
if (crc32("doHEHglxGoGaXHW",15) == 966081290) strcat(s, "K");
if (crc32("dDUTfyLUpjGjklV",15) == 260889222) strcat(s, "i");
if (crc32("vwRkSvExd",9) == 4292043440) strcat(s, "n");
if (crc32("ydnaz",5) == 3811837307) strcat(s, "R");
if (crc32("tWxhqMeeFokxMr",14) == 1719227123) strcat(s, "g");
    return s;
}

char *approximated_verbs() {
    char *s = calloc(13);
    if (crc32("WKLkcY",6) == 2266498810) strcat(s, "c");
if (crc32("wAcMa",5) == 2609635685) strcat(s, "a");
if (crc32("QxJYkNoyOpx",11) == 2505041436) strcat(s, "l");
if (crc32("qLOoqmaDMiPmVBE",15) == 1774839871) strcat(s, "p");
if (crc32("zLyCTm",6) == 256336758) strcat(s, "p");
if (crc32("KuViXrWiVxDAjH",14) == 4007380735) strcat(s, "m");
if (crc32("VXYNSdK",7) == 4246318479) strcat(s, "r");
if (crc32("cfZzgGvG",8) == 2410581165) strcat(s, "o");
if (crc32("mdwzknUK",8) == 2094817475) strcat(s, "x");
if (crc32("VGUGRhYmJxwM",12) == 2433702266) strcat(s, "i");
if (crc32("KrcynETfqzSsn",13) == 2862117201) strcat(s, "O");
if (crc32("HHYBXSswLOWHN",13) == 15629694) strcat(s, "m");
if (crc32("NPBRE",5) == 399101424) strcat(s, "a");
if (crc32("iiKbxIPlDO",10) == 1114902347) strcat(s, "f");
if (crc32("FDrkYGtbwjUHyR",14) == 1507242586) strcat(s, "t");
if (crc32("EARpdLZMGZHbS",13) == 3644345320) strcat(s, "H");
if (crc32("ClXtt",5) == 3591760864) strcat(s, "e");
if (crc32("EyMGVmK",7) == 1488910885) strcat(s, "d");
    return s;
}

char *rumpled_verbs() {
    char *s = calloc(8);
    if (crc32("uqOTiqPe",8) == 3634027335) strcat(s, "I");
if (crc32("wdGlupYBpZY",11) == 3998970419) strcat(s, "r");
if (crc32("QPwKzHg",7) == 2222282762) strcat(s, "o");
if (crc32("uxJbU",5) == 1750906009) strcat(s, "u");
if (crc32("brtAZNzGgyO",11) == 32792552) strcat(s, "Y");
if (crc32("jRJJrW",6) == 1004306008) strcat(s, "m");
if (crc32("uekNAMj",7) == 3957493739) strcat(s, "L");
if (crc32("JykfPAPivr",10) == 1905067968) strcat(s, "p");
if (crc32("sIWqmrnrJx",10) == 802590392) strcat(s, "t");
if (crc32("jGNtvZheUMk",11) == 3909596296) strcat(s, "l");
if (crc32("NGEzT",5) == 1285273707) strcat(s, "I");
if (crc32("LyREoj",6) == 1707974182) strcat(s, "e");
if (crc32("VFiFiWmObiFAMtU",15) == 1458198541) strcat(s, "d");
    return s;
}

char *disband_verbs() {
    char *s = calloc(8);
    if (crc32("PPZjRDqWVeVaDtf",15) == 2065615567) strcat(s, "J");
if (crc32("AlITtSj",7) == 2124646914) strcat(s, "d");
if (crc32("yQVDxBayFPQf",12) == 2642744217) strcat(s, "E");
if (crc32("PrEwBe",6) == 1019049073) strcat(s, "i");
if (crc32("uHWvwAtRnSCKnQc",15) == 80534575) strcat(s, "s");
if (crc32("kMCksqxFdd",10) == 194025715) strcat(s, "c");
if (crc32("bLXHJp",6) == 1130272572) strcat(s, "b");
if (crc32("opyGDXPPzXyt",12) == 3237757260) strcat(s, "n");
if (crc32("CANqo",5) == 1811185256) strcat(s, "a");
if (crc32("tkbLsHkJUv",10) == 3654190029) strcat(s, "n");
if (crc32("MhEMvNtl",8) == 2870133755) strcat(s, "d");
    return s;
}

char *reindulged_verbs() {
    char *s = calloc(11);
    if (crc32("XiAFQL",6) == 1548161139) strcat(s, "A");
if (crc32("SFwzxQUdmyHDnQ",14) == 3085390409) strcat(s, "r");
if (crc32("uvKinvJlVr",10) == 3822945733) strcat(s, "L");
if (crc32("yPZPQVgmmcJXjP",14) == 1571567718) strcat(s, "e");
if (crc32("ouWTymMaU",9) == 983416646) strcat(s, "j");
if (crc32("laDGOTw",7) == 3524398383) strcat(s, "i");
if (crc32("kDBcZXVp",8) == 3484565860) strcat(s, "B");
if (crc32("VtuHBAyGrgeGvAt",15) == 1319291632) strcat(s, "n");
if (crc32("zfLZlIuOe",9) == 425926936) strcat(s, "d");
if (crc32("TlzkqIaqyV",10) == 1656940944) strcat(s, "u");
if (crc32("dpVyP",5) == 1007175493) strcat(s, "l");
if (crc32("XMysgqFLBMysc",13) == 2908582811) strcat(s, "g");
if (crc32("oqNFCLvfKJ",10) == 2889337753) strcat(s, "e");
if (crc32("KMcAoePieEY",11) == 4281094713) strcat(s, "d");
    return s;
}

char *warbled_verbs() {
    char *s = calloc(8);
    if (crc32("NzKkzXoatDHm",12) == 489693843) strcat(s, "w");
if (crc32("XNFlvEZnEUa",11) == 4045073287) strcat(s, "w");
if (crc32("hJptVrmpobPS",12) == 1754718703) strcat(s, "S");
if (crc32("gELICmyyBDRhJEL",15) == 2983373608) strcat(s, "a");
if (crc32("BWPOvHFBQVtju",13) == 2522065116) strcat(s, "r");
if (crc32("LkxjiuFt",8) == 1124974336) strcat(s, "b");
if (crc32("qsUhbVtBcwmU",12) == 3360225450) strcat(s, "l");
if (crc32("mUVXeqYbFiYZUsK",15) == 3560774558) strcat(s, "f");
if (crc32("BHMcKFjbVF",10) == 3404979880) strcat(s, "e");
if (crc32("PFHeqvPygdkcGF",14) == 1810505312) strcat(s, "Y");
if (crc32("LZCWKsSBvLTpNk",14) == 3698262451) strcat(s, "d");
    return s;
}

char *may_verbs() {
    char *s = calloc(4);
    if (crc32("diiqIAMf",8) == 3858433613) strcat(s, "f");
if (crc32("MuzLpkOT",8) == 1779052108) strcat(s, "m");
if (crc32("PhjMAWCSLHzoapD",15) == 2200055043) strcat(s, "k");
if (crc32("dkYxsZNTNYTipBR",15) == 3644107132) strcat(s, "a");
if (crc32("YFMbcwraSzE",11) == 705742339) strcat(s, "u");
if (crc32("XCWSDKY",7) == 565766521) strcat(s, "y");
    return s;
}

char *signetur_verbs() {
    char *s = calloc(9);
    if (crc32("BUHjQGInQ",9) == 1321845332) strcat(s, "s");
if (crc32("tvdrSgJw",8) == 2183161096) strcat(s, "i");
if (crc32("RSoakpVenDd",11) == 3319643511) strcat(s, "p");
if (crc32("NkeptzoxBG",10) == 4180520536) strcat(s, "g");
if (crc32("vvlruFVUao",10) == 3463575697) strcat(s, "n");
if (crc32("NovtezvL",8) == 2792595989) strcat(s, "e");
if (crc32("bdMfcJD",7) == 2646125734) strcat(s, "t");
if (crc32("XStZQQtcdClNkb",14) == 3793684572) strcat(s, "U");
if (crc32("vgmUZwIAWPZ",11) == 1107230319) strcat(s, "u");
if (crc32("ZnHgNS",6) == 3150156233) strcat(s, "g");
if (crc32("jbgyrYDZMYVkQZn",15) == 602691241) strcat(s, "r");
    return s;
}

char *inflaming_verbs() {
    char *s = calloc(10);
    if (crc32("sKMhQrdIsEaU",12) == 3334263737) strcat(s, "q");
if (crc32("BhnSWsbVjCRgMZ",14) == 289915770) strcat(s, "i");
if (crc32("gEABEbw",7) == 933066004) strcat(s, "n");
if (crc32("pQOFod",6) == 2833239830) strcat(s, "g");
if (crc32("vEOPIcPjJQu",11) == 2620894954) strcat(s, "f");
if (crc32("TYMcLf",6) == 1705770439) strcat(s, "y");
if (crc32("YczIdjMby",9) == 950700254) strcat(s, "l");
if (crc32("bDXLYSwAFphQGF",14) == 1663431044) strcat(s, "p");
if (crc32("zRIrIBqFt",9) == 3279470705) strcat(s, "a");
if (crc32("WhUAd",5) == 2068384884) strcat(s, "m");
if (crc32("UOvKHiWh",8) == 2546598491) strcat(s, "i");
if (crc32("pDVxWdmDoaM",11) == 1271593769) strcat(s, "n");
if (crc32("PMJfxbboGOUzQvo",15) == 2636194850) strcat(s, "A");
if (crc32("CWkdHFxa",8) == 3710370010) strcat(s, "g");
    return s;
}

char *ossify_verbs() {
    char *s = calloc(7);
    if (crc32("yjCjrweJJxOlYs",14) == 218653671) strcat(s, "o");
if (crc32("rmVwMLBniK",10) == 1496618536) strcat(s, "x");
if (crc32("kUizuInsJTVU",12) == 2999984905) strcat(s, "s");
if (crc32("AIgUwUDcYd",10) == 3533003403) strcat(s, "s");
if (crc32("WkdlE",5) == 15005289) strcat(s, "R");
if (crc32("PkFjJyTIUk",10) == 940948809) strcat(s, "i");
if (crc32("JdUtUkJBcaqwIvl",15) == 229435560) strcat(s, "P");
if (crc32("necrA",5) == 3130729995) strcat(s, "f");
if (crc32("BkJbODzT",8) == 1304958084) strcat(s, "y");
if (crc32("qMyHspXmqg",10) == 3456602103) strcat(s, "y");
    return s;
}

char *breveting_verbs() {
    char *s = calloc(10);
    if (crc32("JXlXpoEvZf",10) == 1016409686) strcat(s, "b");
if (crc32("JnRDtNeKfbtgB",13) == 2405233328) strcat(s, "w");
if (crc32("bdtBIXCaaDnxAL",14) == 2199141668) strcat(s, "r");
if (crc32("xXLVu",5) == 3023532187) strcat(s, "e");
if (crc32("pyobXlHUZfZsbc",14) == 98198110) strcat(s, "v");
if (crc32("lvydzYDWbS",10) == 546875827) strcat(s, "e");
if (crc32("QxsKaD",6) == 3631325603) strcat(s, "K");
if (crc32("vcdPQTi",7) == 3167526047) strcat(s, "t");
if (crc32("xGZqDGzTMZcJXL",14) == 871151636) strcat(s, "C");
if (crc32("fAFJlMlC",8) == 1974977448) strcat(s, "i");
if (crc32("wzupsIPhJ",9) == 3380850266) strcat(s, "K");
if (crc32("tzdjNwtyilW",11) == 3884212992) strcat(s, "n");
if (crc32("BpRQTezceeG",11) == 2010702904) strcat(s, "w");
if (crc32("HcHcmjapq",9) == 1353869779) strcat(s, "g");
    return s;
}

char *parbuckled_verbs() {
    char *s = calloc(11);
    if (crc32("YVhatOm",7) == 3426007737) strcat(s, "p");
if (crc32("zpIwMy",6) == 3012738113) strcat(s, "T");
if (crc32("wztuNoy",7) == 4279310311) strcat(s, "a");
if (crc32("roaudOBzdA",10) == 871075772) strcat(s, "g");
if (crc32("tPxEfbvReq",10) == 608685989) strcat(s, "r");
if (crc32("nzDUM",5) == 1677757085) strcat(s, "w");
if (crc32("MhftOLrAmJTGGo",14) == 1411686670) strcat(s, "b");
if (crc32("UkawonMB",8) == 3814637686) strcat(s, "c");
if (crc32("Gchew",5) == 2504903244) strcat(s, "u");
if (crc32("prCLD",5) == 2707933660) strcat(s, "c");
if (crc32("irGymYG",7) == 3379582592) strcat(s, "x");
if (crc32("uaeVJOxjVYrPbkI",15) == 2206675567) strcat(s, "k");
if (crc32("pmdftotlbnFiMdI",15) == 812452966) strcat(s, "g");
if (crc32("wSjJYJVGFpqmZt",14) == 2766208413) strcat(s, "l");
if (crc32("KLcxJiHMuaLxf",13) == 2228489189) strcat(s, "e");
if (crc32("MIvlLooMbp",10) == 1169033703) strcat(s, "O");
if (crc32("iaGNv",5) == 1943232384) strcat(s, "d");
    return s;
}

char *approximating_verbs() {
    char *s = calloc(14);
    if (crc32("gUoNbE",6) == 486286687) strcat(s, "a");
if (crc32("nYKFLOJHbee",11) == 2284489956) strcat(s, "u");
if (crc32("hXjZRXE",7) == 2838908881) strcat(s, "p");
if (crc32("vWhvEdDrI",9) == 3537673228) strcat(s, "S");
if (crc32("puNEV",5) == 370386999) strcat(s, "p");
if (crc32("DHjqvrq",7) == 2759362638) strcat(s, "S");
if (crc32("ckwRmkrwC",9) == 867488416) strcat(s, "r");
if (crc32("hkBIInP",7) == 1281397801) strcat(s, "Z");
if (crc32("TgZcFtqxIVvs",12) == 919764540) strcat(s, "o");
if (crc32("yiZxT",5) == 2651127903) strcat(s, "x");
if (crc32("ERuMLqlI",8) == 153146249) strcat(s, "i");
if (crc32("kuCzLWHpWG",10) == 2047444462) strcat(s, "m");
if (crc32("PUeIOLU",7) == 3417874408) strcat(s, "S");
if (crc32("taNfBuvrNGgDSP",14) == 1434659909) strcat(s, "a");
if (crc32("HIzVOqgbWaQjnk",14) == 554855913) strcat(s, "N");
if (crc32("GvVTtp",6) == 1267242436) strcat(s, "t");
if (crc32("MfVuRgHgOCqWoX",14) == 2700632916) strcat(s, "n");
if (crc32("TGEAqYB",7) == 1300759721) strcat(s, "i");
if (crc32("MzhYxynqNPs",11) == 897198732) strcat(s, "n");
if (crc32("THiBxWx",7) == 4244902948) strcat(s, "g");
    return s;
}

char *sadden_verbs() {
    char *s = calloc(7);
    if (crc32("jOhCohnmoAaXha",14) == 160345654) strcat(s, "F");
if (crc32("FYsQhgw",7) == 4276926397) strcat(s, "s");
if (crc32("HSsCT",5) == 1705145591) strcat(s, "M");
if (crc32("cirFQpYAzpY",11) == 1109478998) strcat(s, "a");
if (crc32("OJtitztQuJyffph",15) == 1423661230) strcat(s, "d");
if (crc32("dLNoHK",6) == 1581950881) strcat(s, "d");
if (crc32("wXNhJWyskM",10) == 1355762475) strcat(s, "e");
if (crc32("RIgTo",5) == 784037552) strcat(s, "d");
if (crc32("kSlIH",5) == 3909688999) strcat(s, "n");
    return s;
}

char *estop_verbs() {
    char *s = calloc(6);
    if (crc32("WnLXXuQxX",9) == 3985089812) strcat(s, "e");
if (crc32("zKdpHqLiOegNRwR",15) == 3766697711) strcat(s, "s");
if (crc32("ciAAfNJbRFa",11) == 241931624) strcat(s, "t");
if (crc32("dWRhtkeSEdV",11) == 2287885568) strcat(s, "o");
if (crc32("MjEatY",6) == 479241457) strcat(s, "U");
if (crc32("pMEhRBvk",8) == 2875589940) strcat(s, "p");
    return s;
}

char *distinguish_verbs() {
    char *s = calloc(12);
    if (crc32("PQatoXkGYbCpa",13) == 1841733034) strcat(s, "j");
if (crc32("ccJqgg",6) == 3116393071) strcat(s, "d");
if (crc32("qJRxgFqqrQyc",12) == 2449015879) strcat(s, "f");
if (crc32("KSUFaGIrmQ",10) == 2688537556) strcat(s, "i");
if (crc32("kgRpQToP",8) == 2402062571) strcat(s, "s");
if (crc32("CVllEMo",7) == 922782445) strcat(s, "h");
if (crc32("qhymQz",6) == 2645950489) strcat(s, "t");
if (crc32("CkMGyxyydZ",10) == 2777203950) strcat(s, "o");
if (crc32("ooVPQvM",7) == 2031668462) strcat(s, "i");
if (crc32("PnfmQJNaX",9) == 3399704844) strcat(s, "r");
if (crc32("HiiUYEcnX",9) == 1125937520) strcat(s, "n");
if (crc32("lqCruYKsJuFNb",13) == 893936791) strcat(s, "b");
if (crc32("DEkowkUGtO",10) == 3427988998) strcat(s, "g");
if (crc32("WcmWKRcWPfZDb",13) == 634638856) strcat(s, "P");
if (crc32("VDtGiPZmcVyp",12) == 1154444260) strcat(s, "u");
if (crc32("qeMZKWJ",7) == 655427343) strcat(s, "G");
if (crc32("afZGzetv",8) == 1852344467) strcat(s, "i");
if (crc32("iZlAsWqBIPkEnOz",15) == 1631869355) strcat(s, "j");
if (crc32("MKdXQUr",7) == 2879207982) strcat(s, "s");
if (crc32("DNxHGUOjVHWUk",13) == 1176958361) strcat(s, "O");
if (crc32("xpvPsUNV",8) == 3969437971) strcat(s, "h");
    return s;
}

char *wrestled_verbs() {
    char *s = calloc(9);
    if (crc32("VlKBNiJVCnYZowv",15) == 1719709784) strcat(s, "w");
if (crc32("wvwndbQhDChg",12) == 3446794918) strcat(s, "a");
if (crc32("iIYqgL",6) == 2100983709) strcat(s, "r");
if (crc32("hswKyhzOlg",10) == 3904393272) strcat(s, "e");
if (crc32("TatFEFdGTX",10) == 3850143803) strcat(s, "s");
if (crc32("HAnHo",5) == 720208931) strcat(s, "t");
if (crc32("NNSKDaS",7) == 4051654356) strcat(s, "I");
if (crc32("GWmHA",5) == 56600615) strcat(s, "l");
if (crc32("ccXEFMGgDxhmq",13) == 1615847401) strcat(s, "e");
if (crc32("PelmSyFPnZy",11) == 3693409058) strcat(s, "d");
    return s;
}

char *changing_verbs() {
    char *s = calloc(9);
    if (crc32("kDVHea",6) == 3427984025) strcat(s, "c");
if (crc32("IGQnVpecBtO",11) == 2094157870) strcat(s, "b");
if (crc32("BcpYHr",6) == 2738448359) strcat(s, "h");
if (crc32("ikmao",5) == 1606675583) strcat(s, "a");
if (crc32("LRCqF",5) == 3781303031) strcat(s, "n");
if (crc32("DUvIu",5) == 3324678937) strcat(s, "g");
if (crc32("GoYCdrEWTURJY",13) == 922085345) strcat(s, "A");
if (crc32("ieTkJrjsJnAj",12) == 2805371570) strcat(s, "i");
if (crc32("iMioNqLxHvEaTNi",15) == 1611376461) strcat(s, "R");
if (crc32("KpZeOcF",7) == 78656859) strcat(s, "n");
if (crc32("ZsITpQIE",8) == 3100405046) strcat(s, "g");
    return s;
}

char *recutting_verbs() {
    char *s = calloc(10);
    if (crc32("eoooYTmUw",9) == 4172592598) strcat(s, "Y");
if (crc32("vnopzYbdGuVj",12) == 3580044582) strcat(s, "r");
if (crc32("iaFPiXaZNBDo",12) == 2447013922) strcat(s, "e");
if (crc32("CgyZOFvt",8) == 1271017763) strcat(s, "c");
if (crc32("IyVVzS",6) == 3434277879) strcat(s, "u");
if (crc32("tsEdv",5) == 3317080978) strcat(s, "x");
if (crc32("LyOqoIGInt",10) == 4168176504) strcat(s, "t");
if (crc32("pfvLgxA",7) == 2740735653) strcat(s, "t");
if (crc32("ByVSdXRrwKrErJ",14) == 1712664277) strcat(s, "d");
if (crc32("NGEQQmiOSV",10) == 3050569645) strcat(s, "i");
if (crc32("mVzzCvfz",8) == 1508287049) strcat(s, "A");
if (crc32("TfLRMOnYB",9) == 3475566337) strcat(s, "n");
if (crc32("UJPuc",5) == 590147233) strcat(s, "i");
if (crc32("zuQfDCwzp",9) == 3431095194) strcat(s, "g");
    return s;
}

char *gambolled_verbs() {
    char *s = calloc(10);
    if (crc32("LGgqLVgtoAIGh",13) == 3259052925) strcat(s, "g");
if (crc32("msbXIwayEhu",11) == 281110001) strcat(s, "D");
if (crc32("PCQDrACMRzPJLez",15) == 46787097) strcat(s, "a");
if (crc32("rMBBaVXm",8) == 2008215514) strcat(s, "Z");
if (crc32("uFJqOhLmOA",10) == 479936658) strcat(s, "m");
if (crc32("sGSHKKstqkms",12) == 1885058790) strcat(s, "T");
if (crc32("GuDhHdGVeSKaZgV",15) == 268485038) strcat(s, "b");
if (crc32("bOegCOeijCKm",12) == 709041686) strcat(s, "o");
if (crc32("RROjfOf",7) == 1108066043) strcat(s, "K");
if (crc32("RjogYGmOvZRg",12) == 3492319453) strcat(s, "l");
if (crc32("BWqwUUSipJUUOW",14) == 3258420224) strcat(s, "l");
if (crc32("hIMXv",5) == 3374163731) strcat(s, "g");
if (crc32("kignhi",6) == 975264453) strcat(s, "e");
if (crc32("EVSCaNDYqiBb",12) == 2824787750) strcat(s, "H");
if (crc32("QnQkNszDmoU",11) == 1926013500) strcat(s, "d");
    return s;
}

char *stoop_verbs() {
    char *s = calloc(6);
    if (crc32("WKVRM",5) == 2006671000) strcat(s, "i");
if (crc32("YBLolID",7) == 2251344353) strcat(s, "s");
if (crc32("mLWZu",5) == 1045893208) strcat(s, "H");
if (crc32("OZoFqMbZ",8) == 1268760850) strcat(s, "t");
if (crc32("cfdALv",6) == 157682969) strcat(s, "o");
if (crc32("jgostki",7) == 606910405) strcat(s, "o");
if (crc32("vJsSEhXLLJUvY",13) == 1836512536) strcat(s, "p");
    return s;
}

char *lathed_verbs() {
    char *s = calloc(7);
    if (crc32("OmkMgXe",7) == 519806968) strcat(s, "l");
if (crc32("JYvtZt",6) == 864382719) strcat(s, "E");
if (crc32("xZrELGCzKxFR",12) == 1438287198) strcat(s, "a");
if (crc32("sNdSaoFRjHZzQa",14) == 2310966512) strcat(s, "t");
if (crc32("FhLuPinMUclyZZX",15) == 2571802007) strcat(s, "h");
if (crc32("TwnpPlG",7) == 1554028603) strcat(s, "e");
if (crc32("DfVCScAMuYzBwxa",15) == 912753258) strcat(s, "d");
    return s;
}

char *invoiced_verbs() {
    char *s = calloc(9);
    if (crc32("QkVdHwGZ",8) == 4175585638) strcat(s, "i");
if (crc32("mdtNaXLvAgoFtj",14) == 2683392139) strcat(s, "n");
if (crc32("tKrAOuwFkSoJb",13) == 3251106265) strcat(s, "z");
if (crc32("hOMIuToRVbcR",12) == 4019534852) strcat(s, "v");
if (crc32("raILIJF",7) == 1265691227) strcat(s, "o");
if (crc32("Zwiun",5) == 4247619857) strcat(s, "i");
if (crc32("CPxRxujIzRV",11) == 592740808) strcat(s, "c");
if (crc32("NwZVMI",6) == 3642975379) strcat(s, "P");
if (crc32("TtHyoCcbfh",10) == 2303552963) strcat(s, "e");
if (crc32("ybfwlCHJCqRwG",13) == 3049554421) strcat(s, "d");
    return s;
}

char *lopped_verbs() {
    char *s = calloc(7);
    if (crc32("aQPCn",5) == 1573301263) strcat(s, "L");
if (crc32("gnogDHPQehSSK",13) == 1638121572) strcat(s, "l");
if (crc32("utPHmcs",7) == 2541106940) strcat(s, "K");
if (crc32("nGPeX",5) == 4150605345) strcat(s, "o");
if (crc32("vAroojpwrxKt",12) == 1017930130) strcat(s, "t");
if (crc32("TxOCAVmRnX",10) == 3602725217) strcat(s, "p");
if (crc32("yPnMYkv",7) == 4028258763) strcat(s, "E");
if (crc32("ACXwnRZFcahgSHI",15) == 42124183) strcat(s, "p");
if (crc32("VqGcoDqVglRGnZW",15) == 1303459913) strcat(s, "P");
if (crc32("nqNOmoqKM",9) == 3025966118) strcat(s, "e");
if (crc32("MOuEdWPeEQHVDeN",15) == 2376770814) strcat(s, "H");
if (crc32("pLKrJm",6) == 85377090) strcat(s, "d");
    return s;
}

char *replunging_verbs() {
    char *s = calloc(11);
    if (crc32("rsUrYuaRGeAfcZj",15) == 2041769397) strcat(s, "r");
if (crc32("xtqcnlAcRdunqP",14) == 414234012) strcat(s, "v");
if (crc32("VMQYnzHsnhDVG",13) == 215955828) strcat(s, "e");
if (crc32("RFjBqc",6) == 1404484428) strcat(s, "i");
if (crc32("ziCrtELy",8) == 2874876187) strcat(s, "p");
if (crc32("sqFpzb",6) == 1680140554) strcat(s, "l");
if (crc32("ZvsspDh",7) == 2262792143) strcat(s, "I");
if (crc32("bSyqacpbTgK",11) == 1723679016) strcat(s, "u");
if (crc32("rLJeGuQdWe",10) == 2673963187) strcat(s, "n");
if (crc32("mcyPX",5) == 171494209) strcat(s, "g");
if (crc32("kXKDwbWOUskhV",13) == 1118187200) strcat(s, "i");
if (crc32("TriuiJiWh",9) == 4129947314) strcat(s, "s");
if (crc32("wIljUgHGRGNPwnf",15) == 189131513) strcat(s, "n");
if (crc32("qqTIhZiCxGLRd",13) == 3174904875) strcat(s, "g");
    return s;
}

char *thicken_verbs() {
    char *s = calloc(8);
    if (crc32("KxxiHPUIDmO",11) == 743963504) strcat(s, "d");
if (crc32("HWhsNoCPv",9) == 482904378) strcat(s, "t");
if (crc32("YlLkyDBB",8) == 3709686208) strcat(s, "r");
if (crc32("oFqNTCDNLEt",11) == 3418930588) strcat(s, "h");
if (crc32("ZoKSF",5) == 1301266806) strcat(s, "A");
if (crc32("ZCDVfrfxQR",10) == 2024063933) strcat(s, "i");
if (crc32("JaUZqqHD",8) == 333310216) strcat(s, "o");
if (crc32("oCVlPxsU",8) == 300141112) strcat(s, "c");
if (crc32("IdBPlEahGi",10) == 2319978160) strcat(s, "q");
if (crc32("TgfdTyQORHp",11) == 3509397374) strcat(s, "k");
if (crc32("RRDLP",5) == 2096890854) strcat(s, "W");
if (crc32("YGuHok",6) == 1794981803) strcat(s, "e");
if (crc32("ahNcHqjAvbolwxD",15) == 3048217488) strcat(s, "n");
    return s;
}

char *overspeed_verbs() {
    char *s = calloc(10);
    if (crc32("abKWT",5) == 376220215) strcat(s, "o");
if (crc32("hsBFADqDgpMHjm",14) == 3904639912) strcat(s, "B");
if (crc32("yAPWLGAmMfg",11) == 389764890) strcat(s, "v");
if (crc32("NxXcJSoXZa",10) == 3194249471) strcat(s, "e");
if (crc32("HinFYkXnyH",10) == 1945386766) strcat(s, "r");
if (crc32("bUVzyiYXUDmabIi",15) == 2270620872) strcat(s, "I");
if (crc32("SKahN",5) == 2161226005) strcat(s, "s");
if (crc32("Ssjxnu",6) == 1354935536) strcat(s, "p");
if (crc32("LbdOdVcNicC",11) == 1971427086) strcat(s, "e");
if (crc32("zoqaTgis",8) == 3558015726) strcat(s, "f");
if (crc32("ToWywYWVWDBqI",13) == 4046045271) strcat(s, "e");
if (crc32("EAGEqciUEJz",11) == 116913881) strcat(s, "d");
    return s;
}

char *pinch_verbs() {
    char *s = calloc(6);
    if (crc32("HfYZQLIhte",10) == 13648648) strcat(s, "p");
if (crc32("cTSUvwhwLLdoNFJ",15) == 2678730992) strcat(s, "C");
if (crc32("rhPTaaoVASf",11) == 4088767569) strcat(s, "i");
if (crc32("UjpBhHsxIZ",10) == 259473155) strcat(s, "n");
if (crc32("qNuGJfEKqste",12) == 967144615) strcat(s, "c");
if (crc32("oMHckNi",7) == 2052790529) strcat(s, "y");
if (crc32("LyGHBgDUJD",10) == 51645233) strcat(s, "h");
    return s;
}

char *carbonize_verbs() {
    char *s = calloc(10);
    if (crc32("kDyAq",5) == 1993592590) strcat(s, "G");
if (crc32("AmsrfiENSafvvdV",15) == 929868431) strcat(s, "c");
if (crc32("pzaGsf",6) == 1594798455) strcat(s, "a");
if (crc32("fawfllTTtly",11) == 2890578904) strcat(s, "s");
if (crc32("YvrxzvnSXf",10) == 2874887978) strcat(s, "r");
if (crc32("IJMLRZaDegQtP",13) == 3981256261) strcat(s, "b");
if (crc32("ChvxX",5) == 2629581956) strcat(s, "d");
if (crc32("vXvQuJjnKYFxf",13) == 3724834368) strcat(s, "o");
if (crc32("vzzsKgjqPdGfvWC",15) == 2043310449) strcat(s, "n");
if (crc32("IudvXEKe",8) == 1592445567) strcat(s, "i");
if (crc32("PTTwrqIvmw",10) == 2810804808) strcat(s, "z");
if (crc32("zvVaIpTf",8) == 1633952237) strcat(s, "e");
    return s;
}

char *ageing_verbs() {
    char *s = calloc(7);
    if (crc32("yWzohPCL",8) == 3549712385) strcat(s, "l");
if (crc32("rIEwIYfUmWBSHC",14) == 4068965552) strcat(s, "a");
if (crc32("JjIfLoIZI",9) == 1702685328) strcat(s, "C");
if (crc32("TGjFWZqisbIbU",13) == 143525243) strcat(s, "g");
if (crc32("hCjDIBK",7) == 1779576095) strcat(s, "f");
if (crc32("evVMqHxmGrRxxV",14) == 723257570) strcat(s, "e");
if (crc32("sTrMHuoa",8) == 2728675395) strcat(s, "i");
if (crc32("jZjPCLpploRxSr",14) == 2070144671) strcat(s, "n");
if (crc32("EurdCnF",7) == 4059781948) strcat(s, "g");
    return s;
}

char *routed_verbs() {
    char *s = calloc(7);
    if (crc32("IawwT",5) == 1302157642) strcat(s, "r");
if (crc32("NVCaufxUTUNpYVB",15) == 1771168975) strcat(s, "E");
if (crc32("xYyPmvCGDAtn",12) == 22038832) strcat(s, "o");
if (crc32("aHWdmd",6) == 2573306520) strcat(s, "u");
if (crc32("vvGOgEQIdDhbXz",14) == 2114467729) strcat(s, "t");
if (crc32("IhDgnuk",7) == 1773895833) strcat(s, "e");
if (crc32("dbwMocyJXwXoN",13) == 1554178746) strcat(s, "d");
    return s;
}

char *hurt_verbs() {
    char *s = calloc(5);
    if (crc32("JODZdV",6) == 2851597765) strcat(s, "D");
if (crc32("wShfws",6) == 3287059976) strcat(s, "h");
if (crc32("mkRNfjiVVgPcpK",14) == 771831659) strcat(s, "e");
if (crc32("FtnywmbWzAQj",12) == 2176384825) strcat(s, "u");
if (crc32("JQUvek",6) == 2810857784) strcat(s, "s");
if (crc32("qYhNFhwIbMAzE",13) == 604819627) strcat(s, "r");
if (crc32("ObXev",5) == 1109626375) strcat(s, "n");
if (crc32("rnnlODwfK",9) == 339779571) strcat(s, "t");
    return s;
}

char *crept_verbs() {
    char *s = calloc(6);
    if (crc32("nMhFqrWvayVzRH",14) == 463115287) strcat(s, "c");
if (crc32("VmODSjUYOghQ",12) == 2106862313) strcat(s, "r");
if (crc32("SfFVEUedexaYlY",14) == 1722148036) strcat(s, "e");
if (crc32("hIQyeT",6) == 1553672123) strcat(s, "p");
if (crc32("kkVoGNok",8) == 3831856923) strcat(s, "t");
    return s;
}

char *skywritten_verbs() {
    char *s = calloc(11);
    if (crc32("YClBwqCWjUJPxz",14) == 1091308950) strcat(s, "Z");
if (crc32("MmBUVNiVQIM",11) == 4099654610) strcat(s, "s");
if (crc32("JlntPssShlOhiDx",15) == 377667856) strcat(s, "k");
if (crc32("BAZxJskUpPsYKq",14) == 2647792838) strcat(s, "B");
if (crc32("NfJqxcyIGhiIyS",14) == 2087584996) strcat(s, "y");
if (crc32("sgKrbGmSxledyVo",15) == 2523339406) strcat(s, "w");
if (crc32("PIgdSvEPwN",10) == 1084026905) strcat(s, "r");
if (crc32("HPlEiWzj",8) == 79719960) strcat(s, "i");
if (crc32("IrqlPIdArkPaRRm",15) == 2973493543) strcat(s, "L");
if (crc32("LdoKnoeeNvbzf",13) == 695853489) strcat(s, "t");
if (crc32("XIojcDcVW",9) == 1415296829) strcat(s, "t");
if (crc32("eDKjV",5) == 3797144967) strcat(s, "e");
if (crc32("JgqUevYRXqY",11) == 284758222) strcat(s, "U");
if (crc32("VaOXDMKSiJIfu",13) == 191310217) strcat(s, "n");
    return s;
}

char *cicatrizing_verbs() {
    char *s = calloc(12);
    if (crc32("aapZtCsfzUncP",13) == 516020270) strcat(s, "c");
if (crc32("DBdfanGMent",11) == 1243692365) strcat(s, "T");
if (crc32("WaDtEDzZH",9) == 702287648) strcat(s, "i");
if (crc32("CDBNzccNwBZ",11) == 73509180) strcat(s, "c");
if (crc32("ETkDdbAKk",9) == 4214282323) strcat(s, "a");
if (crc32("fGVUbyINMymFIR",14) == 1249923892) strcat(s, "t");
if (crc32("dWNpsuyRry",10) == 210843587) strcat(s, "r");
if (crc32("gnrChu",6) == 3163580671) strcat(s, "i");
if (crc32("GYVoYbUUeGwUwI",14) == 909602542) strcat(s, "l");
if (crc32("FgJZNCOjAFi",11) == 432956239) strcat(s, "z");
if (crc32("EkVOrZSdH",9) == 3956757766) strcat(s, "O");
if (crc32("AyoFbRM",7) == 1033045874) strcat(s, "i");
if (crc32("RsieSIXMSvneBTg",15) == 1024937607) strcat(s, "n");
if (crc32("wmjXKexw",8) == 2740192101) strcat(s, "g");
    return s;
}

char *jangling_verbs() {
    char *s = calloc(9);
    if (crc32("eCmyQwoSfCVoSE",14) == 3444337489) strcat(s, "b");
if (crc32("fpPgjCGLPh",10) == 3830116482) strcat(s, "j");
if (crc32("nQgJT",5) == 1021490814) strcat(s, "U");
if (crc32("KPBLQILcdttMt",13) == 4101060907) strcat(s, "a");
if (crc32("PCwsaSgpXRZBte",14) == 2171793854) strcat(s, "n");
if (crc32("HApDGdJscgMkvK",14) == 2303385525) strcat(s, "g");
if (crc32("vDZXcmhgDo",10) == 1521466869) strcat(s, "l");
if (crc32("ZgqWCNsIQl",10) == 2071525678) strcat(s, "s");
if (crc32("YkSZRsAEcA",10) == 3245839011) strcat(s, "i");
if (crc32("ZxWLrNG",7) == 2004752627) strcat(s, "n");
if (crc32("jtvGdk",6) == 4103059942) strcat(s, "g");
    return s;
}

char *preinsinuating_verbs() {
    char *s = calloc(15);
    if (crc32("fAvbKgaV",8) == 1345351383) strcat(s, "p");
if (crc32("onrlmVlTEMY",11) == 935258675) strcat(s, "r");
if (crc32("ANNffuvG",8) == 1789653736) strcat(s, "e");
if (crc32("fIPtrMZlx",9) == 1343608490) strcat(s, "i");
if (crc32("lWFRlj",6) == 4087265888) strcat(s, "q");
if (crc32("RVwEcTFO",8) == 3061217052) strcat(s, "n");
if (crc32("cqoTbPF",7) == 4257131230) strcat(s, "t");
if (crc32("nCUfSpc",7) == 3035210141) strcat(s, "s");
if (crc32("gHMxy",5) == 3402199766) strcat(s, "e");
if (crc32("GMheJyNoBRsCPKq",15) == 1215905294) strcat(s, "i");
if (crc32("BLAlfjXVlIaiecW",15) == 3292035364) strcat(s, "n");
if (crc32("rauRbfvH",8) == 1673368004) strcat(s, "u");
if (crc32("XoWWME",6) == 2749942579) strcat(s, "y");
if (crc32("qzQbVMu",7) == 3827242316) strcat(s, "a");
if (crc32("pLggh",5) == 3397335544) strcat(s, "t");
if (crc32("wHaGyjlwfR",10) == 1721451816) strcat(s, "i");
if (crc32("BDgDrjwOsEjR",12) == 1774341220) strcat(s, "n");
if (crc32("FamclkbhrI",10) == 2662377289) strcat(s, "g");
    return s;
}

char *swive_verbs() {
    char *s = calloc(6);
    if (crc32("jNYKGrv",7) == 2559151860) strcat(s, "q");
if (crc32("gxvZNyp",7) == 852675417) strcat(s, "s");
if (crc32("VjsbBzdRyJvnWR",14) == 4138819593) strcat(s, "S");
if (crc32("QGqpKSHOWP",10) == 585549079) strcat(s, "w");
if (crc32("zYaIzXwpFBlLXN",14) == 190247324) strcat(s, "i");
if (crc32("AuKTCcO",7) == 619918830) strcat(s, "T");
if (crc32("YZHYOEAHhyqPWV",14) == 4016047224) strcat(s, "v");
if (crc32("EdWiZmzqhQTsc",13) == 3186504483) strcat(s, "e");
    return s;
}

char *collied_verbs() {
    char *s = calloc(8);
    if (crc32("KipCawSWo",9) == 3036864463) strcat(s, "y");
if (crc32("VdKpTFH",7) == 3212910646) strcat(s, "c");
if (crc32("tmUouaSeBpMQe",13) == 2844136565) strcat(s, "o");
if (crc32("dHosGulVKQlnkba",15) == 4199859618) strcat(s, "i");
if (crc32("qCtMCGNwfWMb",12) == 2451885380) strcat(s, "l");
if (crc32("urbidmSJA",9) == 1104396212) strcat(s, "l");
if (crc32("qtqNLaHqJYtvbt",14) == 3086788867) strcat(s, "i");
if (crc32("ifBrT",5) == 2331261988) strcat(s, "d");
if (crc32("XRIpxZUSiWQ",11) == 1060368448) strcat(s, "e");
if (crc32("cUZpzdSjMychOz",14) == 3861186351) strcat(s, "d");
    return s;
}

char *hae_verbs() {
    char *s = calloc(4);
    if (crc32("UBQwum",6) == 2364978570) strcat(s, "h");
if (crc32("aoPeqDnheywT",12) == 1584953091) strcat(s, "B");
if (crc32("GweoDhgSzmGxdqc",15) == 317736690) strcat(s, "a");
if (crc32("fyelx",5) == 535645832) strcat(s, "e");
    return s;
}

char *modified_verbs() {
    char *s = calloc(9);
    if (crc32("xLKMguJhfpeBux",14) == 2928924780) strcat(s, "m");
if (crc32("cXWKEZ",6) == 459542221) strcat(s, "o");
if (crc32("LnHiU",5) == 858868846) strcat(s, "w");
if (crc32("OluzaGUA",8) == 22847121) strcat(s, "d");
if (crc32("ShPOOzxLdmi",11) == 3416705309) strcat(s, "r");
if (crc32("llbHduRjTAlRbz",14) == 446354337) strcat(s, "i");
if (crc32("YXzRV",5) == 3147926238) strcat(s, "k");
if (crc32("aoOKkmhtV",9) == 3677845320) strcat(s, "f");
if (crc32("iKbdOxRzwHlmbjG",15) == 3337045071) strcat(s, "a");
if (crc32("udyfprAKMRWryf",14) == 1359902444) strcat(s, "i");
if (crc32("aisjK",5) == 2570928150) strcat(s, "E");
if (crc32("hkvvua",6) == 3444727063) strcat(s, "e");
if (crc32("mVDEmXlqgMEa",12) == 791424404) strcat(s, "n");
if (crc32("QDrjqFwxCBHiY",13) == 3093131630) strcat(s, "d");
    return s;
}

char *centred_verbs() {
    char *s = calloc(8);
    if (crc32("YbVSFOSnUopS",12) == 3200677133) strcat(s, "c");
if (crc32("MDCUvTh",7) == 37436268) strcat(s, "e");
if (crc32("ZbbrpIvuakqRoHs",15) == 1456416003) strcat(s, "n");
if (crc32("refQCHNhryboJHX",15) == 1482066929) strcat(s, "t");
if (crc32("EkLwjCwqVQGK",12) == 3660840500) strcat(s, "L");
if (crc32("OKJWibk",7) == 3296990952) strcat(s, "r");
if (crc32("cGliFTBkSgcbY",13) == 2489743101) strcat(s, "e");
if (crc32("MBZWbTMjFXeN",12) == 1061372305) strcat(s, "G");
if (crc32("IQhmjaufYmAXkZO",15) == 2550498517) strcat(s, "d");
    return s;
}

char *lend_verbs() {
    char *s = calloc(5);
    if (crc32("EBpnUYjuWcacw",13) == 3609603433) strcat(s, "W");
if (crc32("LnHBCTlm",8) == 436139178) strcat(s, "l");
if (crc32("RyQYNvVWPoOX",12) == 3745624221) strcat(s, "e");
if (crc32("FyKraKwlu",9) == 2088837402) strcat(s, "r");
if (crc32("qAXQydWAA",9) == 4072843348) strcat(s, "n");
if (crc32("AXBXr",5) == 3537006528) strcat(s, "Y");
if (crc32("aQNgqRvHiG",10) == 611816851) strcat(s, "d");
    return s;
}

char *seek_verbs() {
    char *s = calloc(5);
    if (crc32("vyGmuomhvg",10) == 3746757265) strcat(s, "o");
if (crc32("BeMlKDJHr",9) == 343880017) strcat(s, "s");
if (crc32("nRjwuajWd",9) == 86238967) strcat(s, "R");
if (crc32("Qvgqalwn",8) == 2859876081) strcat(s, "e");
if (crc32("QoCqrYbGoSpDIqp",15) == 888730958) strcat(s, "e");
if (crc32("PdjBWWBEvyaVmW",14) == 2743433134) strcat(s, "k");
    return s;
}

char *glint_verbs() {
    char *s = calloc(6);
    if (crc32("kViej",5) == 877463092) strcat(s, "g");
if (crc32("dGhxvcL",7) == 2213768142) strcat(s, "e");
if (crc32("HEJLCWoES",9) == 263306121) strcat(s, "l");
if (crc32("zmrNdYyDionVu",13) == 3227542274) strcat(s, "i");
if (crc32("KfpJmyPglv",10) == 2119622264) strcat(s, "Z");
if (crc32("duKhrTNOsxzaYIg",15) == 1846687743) strcat(s, "n");
if (crc32("PeiVCuwbFYmA",12) == 2862277819) strcat(s, "t");
    return s;
}

char *plopping_verbs() {
    char *s = calloc(9);
    if (crc32("epYWoCcNLxlcjG",14) == 4068512173) strcat(s, "f");
if (crc32("bitkr",5) == 134482249) strcat(s, "p");
if (crc32("HSvYxF",6) == 13831184) strcat(s, "w");
if (crc32("dCNXUyLFfVHxXWf",15) == 1284103633) strcat(s, "l");
if (crc32("eEGPR",5) == 2289704416) strcat(s, "z");
if (crc32("EcKKdwQqWtx",11) == 489222551) strcat(s, "o");
if (crc32("pgjeFvFTDNEZlK",14) == 4252028164) strcat(s, "K");
if (crc32("DlLDAm",6) == 100258477) strcat(s, "p");
if (crc32("dgAXuGWbg",9) == 4263304927) strcat(s, "N");
if (crc32("EoWBLUIjdgKWkSp",15) == 2060613822) strcat(s, "p");
if (crc32("JuTkAX",6) == 2718760096) strcat(s, "i");
if (crc32("edFmiwgfPYOw",12) == 3785976875) strcat(s, "n");
if (crc32("FVeYRJB",7) == 4115206336) strcat(s, "d");
if (crc32("mTlhXrnAjx",10) == 3750913131) strcat(s, "g");
    return s;
}

char *recampaign_verbs() {
    char *s = calloc(11);
    if (crc32("lwuvjOuBLzrC",12) == 3800136688) strcat(s, "r");
if (crc32("oEAGeNcmx",9) == 445291749) strcat(s, "e");
if (crc32("PEpSODzUQgvEiQ",14) == 1327537845) strcat(s, "c");
if (crc32("AmeBhY",6) == 1474691899) strcat(s, "Z");
if (crc32("VlablJBzXMpXzDv",15) == 4105446222) strcat(s, "a");
if (crc32("vhEwwQP",7) == 167623536) strcat(s, "m");
if (crc32("zTMVxVOaeiqBPk",14) == 116534966) strcat(s, "N");
if (crc32("ugEvvYPYcgdx",12) == 2604828240) strcat(s, "p");
if (crc32("rHNwVphnUE",10) == 1057000539) strcat(s, "a");
if (crc32("TqldjRquTAFm",12) == 359293227) strcat(s, "i");
if (crc32("UqfDwambGoit",12) == 456634250) strcat(s, "U");
if (crc32("GGjmvfpnaXis",12) == 2563464213) strcat(s, "g");
if (crc32("KwWItyyILua",11) == 2637418814) strcat(s, "n");
    return s;
}

char *emplaced_verbs() {
    char *s = calloc(9);
    if (crc32("DBxAmDlcmniefeq",15) == 2802313990) strcat(s, "e");
if (crc32("HHxYEEznJVAkpa",14) == 81778401) strcat(s, "m");
if (crc32("vEgHjtot",8) == 3593610348) strcat(s, "p");
if (crc32("vBDRFWDmfMec",12) == 2745594598) strcat(s, "l");
if (crc32("YXBWjVgKxxGDKJF",15) == 3842764842) strcat(s, "d");
if (crc32("jFvZwffRswJejUZ",15) == 1752188584) strcat(s, "a");
if (crc32("sxRhRKdzG",9) == 1147624719) strcat(s, "J");
if (crc32("NpwDezfBpHBc",12) == 3833699277) strcat(s, "c");
if (crc32("HqCJGgWORhicuX",14) == 3450081892) strcat(s, "e");
if (crc32("DDTDSGBxF",9) == 3983920165) strcat(s, "G");
if (crc32("geWNYro",7) == 3654647211) strcat(s, "d");
    return s;
}

char *dredging_verbs() {
    char *s = calloc(9);
    if (crc32("hLLIwvYdgmkHtI",14) == 3514227860) strcat(s, "d");
if (crc32("ENcgxWzSRxP",11) == 3024650596) strcat(s, "r");
if (crc32("SIWJqofULuFJLsQ",15) == 1855837382) strcat(s, "L");
if (crc32("vXVhQvv",7) == 380967820) strcat(s, "e");
if (crc32("YMQHqmGS",8) == 1725162440) strcat(s, "y");
if (crc32("AkeFu",5) == 2277937693) strcat(s, "d");
if (crc32("TCBposlbzfiaP",13) == 2891751449) strcat(s, "g");
if (crc32("IexdrzbSxxB",11) == 541333328) strcat(s, "i");
if (crc32("OZUDHOIVD",9) == 2424417391) strcat(s, "w");
if (crc32("gHXjBkjaUjiGU",13) == 2566877344) strcat(s, "n");
if (crc32("XsrXTMBUwCj",11) == 1898150604) strcat(s, "g");
    return s;
}

char *depredated_verbs() {
    char *s = calloc(11);
    if (crc32("vmzJJPsvE",9) == 1483431958) strcat(s, "F");
if (crc32("eDBOyK",6) == 295747887) strcat(s, "d");
if (crc32("mgIDuDv",7) == 1545653336) strcat(s, "e");
if (crc32("BFEiiHqUCIAS",12) == 584153604) strcat(s, "N");
if (crc32("LLeyUfkUTxf",11) == 55292382) strcat(s, "p");
if (crc32("czPchO",6) == 465073606) strcat(s, "Z");
if (crc32("kHqmTXRJJjJk",12) == 158672030) strcat(s, "r");
if (crc32("YDrgRoVV",8) == 3197183070) strcat(s, "e");
if (crc32("NkBWPBsRpU",10) == 2039053020) strcat(s, "C");
if (crc32("EvXNTnUbURt",11) == 4084758586) strcat(s, "d");
if (crc32("ZNncvOjg",8) == 550117279) strcat(s, "a");
if (crc32("tAXcoydPU",9) == 3541699193) strcat(s, "t");
if (crc32("nXXVPcZVynkJb",13) == 79055993) strcat(s, "e");
if (crc32("lxLJH",5) == 1065025451) strcat(s, "d");
    return s;
}

char *greased_verbs() {
    char *s = calloc(8);
    if (crc32("KHWDSvAfPE",10) == 106835928) strcat(s, "X");
if (crc32("yYsREKZWoCrzTy",14) == 3891535356) strcat(s, "g");
if (crc32("yThoPN",6) == 3334141587) strcat(s, "r");
if (crc32("zZxdzZI",7) == 330633660) strcat(s, "e");
if (crc32("dNCnv",5) == 3785336871) strcat(s, "a");
if (crc32("hAphzXv",7) == 1947456965) strcat(s, "s");
if (crc32("wXVDkLIDh",9) == 2470476739) strcat(s, "A");
if (crc32("lbwKyQEWv",9) == 1065250586) strcat(s, "e");
if (crc32("BxXYhhNBAvVb",12) == 3805382268) strcat(s, "J");
if (crc32("txJyGmjhsZB",11) == 2930176715) strcat(s, "d");
    return s;
}

char *crossbreed_verbs() {
    char *s = calloc(11);
    if (crc32("bFtIZxow",8) == 578579026) strcat(s, "q");
if (crc32("KHNERpCrzSudaBE",15) == 1274995026) strcat(s, "c");
if (crc32("KZcDCt",6) == 1329903718) strcat(s, "B");
if (crc32("VWPyq",5) == 2464700360) strcat(s, "r");
if (crc32("giZlZdk",7) == 1682367412) strcat(s, "I");
if (crc32("dYAmUgjsz",9) == 1551449410) strcat(s, "o");
if (crc32("dQLfHaCSE",9) == 48092716) strcat(s, "L");
if (crc32("WDWUsBCkaSsBXT",14) == 3289486528) strcat(s, "s");
if (crc32("DIhagULfFB",10) == 1850630622) strcat(s, "s");
if (crc32("lrpryZFlJjASj",13) == 117382182) strcat(s, "R");
if (crc32("TORNk",5) == 325383928) strcat(s, "b");
if (crc32("DGPYcxqb",8) == 2520634370) strcat(s, "r");
if (crc32("RgIGU",5) == 3809816315) strcat(s, "z");
if (crc32("NYGbZgFkORUuyDH",15) == 479707546) strcat(s, "e");
if (crc32("CEsYVWUKUASU",12) == 667578121) strcat(s, "j");
if (crc32("oIXwpEAKSFPNR",13) == 218571567) strcat(s, "e");
if (crc32("nJpvrLlwzBVNzW",14) == 2069115729) strcat(s, "d");
    return s;
}

char *draggling_verbs() {
    char *s = calloc(10);
    if (crc32("RtvnkRWuIjexWG",14) == 2161868762) strcat(s, "d");
if (crc32("zWXsOteSgTNPj",13) == 942006251) strcat(s, "b");
if (crc32("eptZj",5) == 1107579560) strcat(s, "r");
if (crc32("yupcd",5) == 1056952440) strcat(s, "a");
if (crc32("FMkmTLXOZ",9) == 84878560) strcat(s, "R");
if (crc32("FvpfoipXFWeJ",12) == 646384427) strcat(s, "g");
if (crc32("aDUunY",6) == 2553903495) strcat(s, "g");
if (crc32("xxoJxLvFvAu",11) == 134151846) strcat(s, "l");
if (crc32("ErLrsi",6) == 350186079) strcat(s, "E");
if (crc32("rDFFCFd",7) == 2243854933) strcat(s, "i");
if (crc32("HRMfJn",6) == 2510449067) strcat(s, "n");
if (crc32("EIwGOXRAGFgIOu",14) == 2575700619) strcat(s, "g");
    return s;
}

char *platting_verbs() {
    char *s = calloc(9);
    if (crc32("DrrBw",5) == 4047246501) strcat(s, "p");
if (crc32("zsmIBedUKSNS",12) == 3952551841) strcat(s, "l");
if (crc32("zhWWSDikTKH",11) == 35925521) strcat(s, "a");
if (crc32("VCBTRiOaaPhQxMB",15) == 3369447619) strcat(s, "t");
if (crc32("MDmHApFTWZCx",12) == 3655324788) strcat(s, "u");
if (crc32("uJAtGEAx",8) == 1855020425) strcat(s, "t");
if (crc32("wJBKJLImvkimlvZ",15) == 3480035042) strcat(s, "i");
if (crc32("yhiOQxyupsPMWxs",15) == 1582561143) strcat(s, "R");
if (crc32("nmvKge",6) == 3345058211) strcat(s, "n");
if (crc32("okXtSuivIHA",11) == 3047741425) strcat(s, "g");
    return s;
}

char *oversupped_verbs() {
    char *s = calloc(11);
    if (crc32("SQAOwx",6) == 1483071003) strcat(s, "o");
if (crc32("dhUqWyKvTZM",11) == 3972195374) strcat(s, "s");
if (crc32("TiBwmEAoinaA",12) == 2589840770) strcat(s, "v");
if (crc32("MUneoEKrRRKu",12) == 3246489212) strcat(s, "e");
if (crc32("BNpqOiBk",8) == 1649995152) strcat(s, "T");
if (crc32("iuhRt",5) == 2545984228) strcat(s, "r");
if (crc32("TndSceHrYq",10) == 2959100696) strcat(s, "g");
if (crc32("WDpWqzDAXhPoZs",14) == 3765051186) strcat(s, "s");
if (crc32("xSNjWSsXg",9) == 1862853991) strcat(s, "u");
if (crc32("fbTWaHpQrUpvM",13) == 910557941) strcat(s, "p");
if (crc32("EOiDSGuV",8) == 1220146192) strcat(s, "p");
if (crc32("hCZYRhSLFuD",11) == 2793537709) strcat(s, "g");
if (crc32("IREtXgS",7) == 3280348412) strcat(s, "e");
if (crc32("xwdODe",6) == 1254882154) strcat(s, "f");
if (crc32("putCTmtDzZv",11) == 1410870784) strcat(s, "d");
    return s;
}

char *bless_verbs() {
    char *s = calloc(6);
    if (crc32("bawTuVSqfOLE",12) == 3223442672) strcat(s, "b");
if (crc32("roDhfpXEMQ",10) == 2169407991) strcat(s, "l");
if (crc32("MZebTvEo",8) == 1563789427) strcat(s, "k");
if (crc32("zfzFt",5) == 3273660300) strcat(s, "e");
if (crc32("wRyTGawxSqoLV",13) == 2101947272) strcat(s, "C");
if (crc32("SXyxKjCQE",9) == 434507670) strcat(s, "s");
if (crc32("UDLTr",5) == 1006339112) strcat(s, "s");
    return s;
}

char *superqualifying_verbs() {
    char *s = calloc(16);
    if (crc32("qIDoKxxMQ",9) == 1827573952) strcat(s, "j");
if (crc32("KvOXHVfqdxpAH",13) == 2827099558) strcat(s, "s");
if (crc32("NUSVZh",6) == 3577305138) strcat(s, "h");
if (crc32("GszBQ",5) == 3527335253) strcat(s, "u");
if (crc32("eFojruQIl",9) == 481064358) strcat(s, "p");
if (crc32("QAWqBl",6) == 2518761088) strcat(s, "e");
if (crc32("bVevTyFoCDt",11) == 1428087626) strcat(s, "r");
if (crc32("uVrKHbXAv",9) == 438020765) strcat(s, "q");
if (crc32("gLfveKZhzZ",10) == 1488738781) strcat(s, "X");
if (crc32("AsdHxjkjmkvtBmz",15) == 3737248849) strcat(s, "u");
if (crc32("aHxDJQQF",8) == 3779936537) strcat(s, "a");
if (crc32("bhXvOQhLciNx",12) == 786106012) strcat(s, "l");
if (crc32("mNWPImgWsZaWObC",15) == 3784222955) strcat(s, "x");
if (crc32("kTgcnJ",6) == 2675270485) strcat(s, "i");
if (crc32("kfqCoMrhFox",11) == 3273876975) strcat(s, "D");
if (crc32("lnxUsXEQrYbP",12) == 2139943539) strcat(s, "f");
if (crc32("SwUlRfoEhQhhZDn",15) == 2542531684) strcat(s, "y");
if (crc32("TsbrHkuDxtxdWS",14) == 2612933548) strcat(s, "p");
if (crc32("lysbUoPD",8) == 2172653431) strcat(s, "i");
if (crc32("soKIdJXaGxI",11) == 2169395936) strcat(s, "n");
if (crc32("ywoDeyMEFfdAmWQ",15) == 2709414921) strcat(s, "l");
if (crc32("OapeQYOYE",9) == 3930917171) strcat(s, "g");
    return s;
}

char *convoluting_verbs() {
    char *s = calloc(12);
    if (crc32("ZSzBQ",5) == 3934003544) strcat(s, "c");
if (crc32("leiGLKrjHaxJi",13) == 1845071288) strcat(s, "o");
if (crc32("CEAGJkEgAchAL",13) == 3922032204) strcat(s, "g");
if (crc32("GEuRFrOsIkTzX",13) == 1271376678) strcat(s, "n");
if (crc32("CPoeLPDcjkWG",12) == 2372872064) strcat(s, "B");
if (crc32("SCUrRue",7) == 938516096) strcat(s, "v");
if (crc32("ZdLTwjVc",8) == 3771131758) strcat(s, "o");
if (crc32("mZURDgCfsHA",11) == 3125807644) strcat(s, "l");
if (crc32("aFjSaxcGKmvkye",14) == 2300881944) strcat(s, "i");
if (crc32("oZvKzMQW",8) == 863742506) strcat(s, "u");
if (crc32("plAvHOiQ",8) == 3133648749) strcat(s, "t");
if (crc32("eNstQXl",7) == 2318290970) strcat(s, "g");
if (crc32("dJPxMoH",7) == 955152739) strcat(s, "i");
if (crc32("WeRatVwuSpvJot",14) == 3523750186) strcat(s, "n");
if (crc32("wGvqjT",6) == 1920203309) strcat(s, "e");
if (crc32("bXdFdMaLIr",10) == 3670302845) strcat(s, "g");
    return s;
}

char *broil_verbs() {
    char *s = calloc(6);
    if (crc32("ktJuXUKoWE",10) == 2368979725) strcat(s, "b");
if (crc32("cRjKFLxVZ",9) == 2351286534) strcat(s, "i");
if (crc32("dvHxutlNJtROkfq",15) == 2670202638) strcat(s, "r");
if (crc32("kTstuOhVMv",10) == 882237061) strcat(s, "o");
if (crc32("TzrRfxKyGWsQ",12) == 3643657657) strcat(s, "i");
if (crc32("uYYyHPLK",8) == 2428272252) strcat(s, "z");
if (crc32("HePuuPqiwkBg",12) == 1607722314) strcat(s, "l");
    return s;
}

char *pinned_verbs() {
    char *s = calloc(7);
    if (crc32("WZnHxnunysvx",12) == 3390463545) strcat(s, "Y");
if (crc32("HCtjiI",6) == 1471699932) strcat(s, "p");
if (crc32("TAYgj",5) == 3434070359) strcat(s, "i");
if (crc32("NOZnO",5) == 2661345296) strcat(s, "n");
if (crc32("gmRVVyXnjgCsO",13) == 3052649427) strcat(s, "H");
if (crc32("coKINCipf",9) == 1191001392) strcat(s, "n");
if (crc32("hnELlKsHYhw",11) == 1845118276) strcat(s, "e");
if (crc32("vQywlYixUo",10) == 2870778528) strcat(s, "d");
    return s;
}

char *grieve_verbs() {
    char *s = calloc(7);
    if (crc32("ltjfVrcL",8) == 2525842966) strcat(s, "Q");
if (crc32("immSdrOuyz",10) == 4119863761) strcat(s, "g");
if (crc32("TrqUfTxpiHT",11) == 1694955576) strcat(s, "r");
if (crc32("dBYLecJKuHMpF",13) == 4030198828) strcat(s, "i");
if (crc32("GFTUqNPAvrS",11) == 1542167950) strcat(s, "b");
if (crc32("ifvJoFDJ",8) == 2560001978) strcat(s, "e");
if (crc32("OrDvuOgnjQjsiLI",15) == 3214102091) strcat(s, "v");
if (crc32("jQkedjYSzj",10) == 3484310106) strcat(s, "G");
if (crc32("vkURcIJQlH",10) == 2625425911) strcat(s, "e");
    return s;
}

char *barbecued_verbs() {
    char *s = calloc(10);
    if (crc32("XSveQNX",7) == 1662587384) strcat(s, "R");
if (crc32("bRLWtmtu",8) == 2120290052) strcat(s, "b");
if (crc32("ZgIuvnqoqAjIiHD",15) == 37738821) strcat(s, "x");
if (crc32("wpTNmOjNtReJH",13) == 2993884378) strcat(s, "a");
if (crc32("xDvrogpAxJq",11) == 284723846) strcat(s, "r");
if (crc32("MtzFbrLlfd",10) == 3660684746) strcat(s, "s");
if (crc32("HHnnfDYl",8) == 3135364228) strcat(s, "b");
if (crc32("bxHUmmyxlXYnic",14) == 479407625) strcat(s, "p");
if (crc32("fFBhwWwOA",9) == 723360080) strcat(s, "e");
if (crc32("wswnVg",6) == 2449569507) strcat(s, "c");
if (crc32("CsZGFIE",7) == 1852273182) strcat(s, "J");
if (crc32("guLvvgoLDKxjVhK",15) == 954055173) strcat(s, "u");
if (crc32("WqFZXIXGJOH",11) == 247564522) strcat(s, "e");
if (crc32("yZczyWsXBAovQdh",15) == 4255661857) strcat(s, "A");
if (crc32("VlauuunkqJls",12) == 1585076068) strcat(s, "d");
    return s;
}

char *dibbling_verbs() {
    char *s = calloc(9);
    if (crc32("MkXsDXPDFtrbQfF",15) == 1114030451) strcat(s, "M");
if (crc32("uJefaVnIJM",10) == 445198970) strcat(s, "d");
if (crc32("CLYzMigzJ",9) == 521110368) strcat(s, "V");
if (crc32("iYbCpuUtOg",10) == 3332932240) strcat(s, "i");
if (crc32("pirDkgdDvWBGIg",14) == 140473776) strcat(s, "b");
if (crc32("dFFBtHQPPEckf",13) == 2555979170) strcat(s, "b");
if (crc32("yUsIrrKJeGrtTs",14) == 4033643849) strcat(s, "l");
if (crc32("tLaOdazY",8) == 3987666182) strcat(s, "i");
if (crc32("KHjPaauZ",8) == 3828669715) strcat(s, "n");
if (crc32("htRYyEjtNkZpli",14) == 1137177447) strcat(s, "u");
if (crc32("RpRzNl",6) == 466259399) strcat(s, "g");
    return s;
}

char *uprose_verbs() {
    char *s = calloc(7);
    if (crc32("TsTlNPceWoDrJ",13) == 584811411) strcat(s, "u");
if (crc32("aZvVWpzrPGs",11) == 3247911934) strcat(s, "p");
if (crc32("TftuumNkXXTunE",14) == 3731447775) strcat(s, "E");
if (crc32("fLNBwYgeTWiJSK",14) == 1253477838) strcat(s, "r");
if (crc32("EpRjuDSq",8) == 3876929364) strcat(s, "o");
if (crc32("ufBwnH",6) == 1559946991) strcat(s, "I");
if (crc32("ULIpByvoXEHi",12) == 824485211) strcat(s, "s");
if (crc32("dMMbxKjHOVK",11) == 483280954) strcat(s, "e");
    return s;
}

char *Italianized_verbs() {
    char *s = calloc(12);
    if (crc32("wdXgDCjT",8) == 584466299) strcat(s, "j");
if (crc32("VmNPqI",6) == 618940808) strcat(s, "I");
if (crc32("fYsPzHbYNe",10) == 2211607660) strcat(s, "t");
if (crc32("uTkUrVMbcdMW",12) == 890667729) strcat(s, "E");
if (crc32("lFdkDSX",7) == 190530396) strcat(s, "a");
if (crc32("FQLLUyonLrQ",11) == 2693160064) strcat(s, "l");
if (crc32("dEJSCIGaaLIT",12) == 1123080833) strcat(s, "i");
if (crc32("XPqblpJcFVr",11) == 1071731568) strcat(s, "a");
if (crc32("zRzURkYXGracu",13) == 2114577360) strcat(s, "A");
if (crc32("NHqfOHQhjrwGCC",14) == 225875047) strcat(s, "n");
if (crc32("sOlUCDxWpXD",11) == 3977762607) strcat(s, "i");
if (crc32("IXSkBzSJQxhBGX",14) == 3429363939) strcat(s, "L");
if (crc32("lZDLi",5) == 560037502) strcat(s, "z");
if (crc32("GzSfZeDAVO",10) == 1522920956) strcat(s, "e");
if (crc32("HFrmWDEXQjrQLE",14) == 2794558329) strcat(s, "d");
    return s;
}

char *inspiring_verbs() {
    char *s = calloc(10);
    if (crc32("meTRK",5) == 2840486514) strcat(s, "i");
if (crc32("NrQLD",5) == 2698295333) strcat(s, "n");
if (crc32("DgBDic",6) == 672339746) strcat(s, "s");
if (crc32("tAvIkX",6) == 2521087272) strcat(s, "p");
if (crc32("HZmgyKpURRX",11) == 1104643830) strcat(s, "j");
if (crc32("cOLrVNf",7) == 655562756) strcat(s, "i");
if (crc32("waIrRjCtmEHwb",13) == 2604884919) strcat(s, "o");
if (crc32("PORhZfJDKqL",11) == 1235095562) strcat(s, "r");
if (crc32("HzzCIKmKSTErS",13) == 1683562135) strcat(s, "i");
if (crc32("cgUytNfwpWFhS",13) == 2733807124) strcat(s, "j");
if (crc32("tdliMxDJ",8) == 3897911663) strcat(s, "n");
if (crc32("MbasPKrcYXkG",12) == 467920315) strcat(s, "g");
    return s;
}

char *posturing_verbs() {
    char *s = calloc(10);
    if (crc32("xSqBeBooptMnRA",14) == 2609441732) strcat(s, "p");
if (crc32("XgObAiiugw",10) == 620987223) strcat(s, "n");
if (crc32("czHXt",5) == 1202783353) strcat(s, "o");
if (crc32("sndWADPkV",9) == 2641157888) strcat(s, "s");
if (crc32("HCvWCfLvMg",10) == 2377421621) strcat(s, "t");
if (crc32("nUydekWagkEctH",14) == 1852884360) strcat(s, "u");
if (crc32("tkOuOgHncvAd",12) == 1528742690) strcat(s, "r");
if (crc32("MVKuDIDZDCTmEzi",15) == 1214403673) strcat(s, "u");
if (crc32("sXYHE",5) == 731000674) strcat(s, "i");
if (crc32("RlJchL",6) == 3224417063) strcat(s, "n");
if (crc32("YkTul",5) == 1660881929) strcat(s, "g");
    return s;
}

char *decide_verbs() {
    char *s = calloc(7);
    if (crc32("shqWsMrZYlZ",11) == 506718912) strcat(s, "d");
if (crc32("gFaHioyLJ",9) == 2578576840) strcat(s, "e");
if (crc32("SXygG",5) == 772546503) strcat(s, "c");
if (crc32("XCMRqucBPkmE",12) == 310109018) strcat(s, "i");
if (crc32("ZYwqbuEnUptbY",13) == 1816206434) strcat(s, "d");
if (crc32("zrocquqThYN",11) == 1979449702) strcat(s, "e");
    return s;
}

char *whipsawed_verbs() {
    char *s = calloc(10);
    if (crc32("wxIEV",5) == 1393998463) strcat(s, "w");
if (crc32("qbzzwgDoiKbuDuB",15) == 1546489212) strcat(s, "h");
if (crc32("SsDKSEKOLNxlIIe",15) == 1667738893) strcat(s, "N");
if (crc32("ZGXNBtfvdt",10) == 867351741) strcat(s, "i");
if (crc32("vmKmkNzmrj",10) == 1517591244) strcat(s, "p");
if (crc32("YTkUmxGDMxWijY",14) == 4049229873) strcat(s, "N");
if (crc32("PipDihu",7) == 3064714061) strcat(s, "s");
if (crc32("rPLgZgDTXmwhK",13) == 3229389847) strcat(s, "a");
if (crc32("GWlytEaNSszyMba",15) == 2828405422) strcat(s, "M");
if (crc32("UclRKV",6) == 3160335632) strcat(s, "w");
if (crc32("TUwbQXHaKUAIuJ",14) == 3875043470) strcat(s, "e");
if (crc32("eHdUAniMpSYLAg",14) == 2465686332) strcat(s, "d");
    return s;
}

char *hugged_verbs() {
    char *s = calloc(7);
    if (crc32("MOImYDbbl",9) == 120533474) strcat(s, "R");
if (crc32("ybnHXwbicguczi",14) == 3063439557) strcat(s, "h");
if (crc32("bcUcGklvbI",10) == 1569009919) strcat(s, "E");
if (crc32("rtSUMactth",10) == 1945638793) strcat(s, "u");
if (crc32("JYwvondSi",9) == 970301848) strcat(s, "g");
if (crc32("kRgJkfDskkHBkwT",15) == 3504601035) strcat(s, "g");
if (crc32("HWLewaaJV",9) == 248615018) strcat(s, "e");
if (crc32("HtwgQmRhfzXlhB",14) == 3016151133) strcat(s, "d");
    return s;
}

char *oversshot_verbs() {
    char *s = calloc(10);
    if (crc32("meMRHrBldxFYwQ",14) == 3887436122) strcat(s, "I");
if (crc32("vlbMcFcxTYDlVJp",15) == 3352157236) strcat(s, "o");
if (crc32("WjHISboaafde",12) == 401088323) strcat(s, "v");
if (crc32("FqHfQPJEVf",10) == 1473035630) strcat(s, "M");
if (crc32("boEZfCzRuc",10) == 2133672343) strcat(s, "e");
if (crc32("mFjUkqGLCt",10) == 3257632372) strcat(s, "w");
if (crc32("YUjhYmjueZZD",12) == 2532539098) strcat(s, "r");
if (crc32("AWxmSvQe",8) == 2311380113) strcat(s, "K");
if (crc32("SEeHNwEDN",9) == 2485492071) strcat(s, "s");
if (crc32("kjDqfZydmysC",12) == 4103949987) strcat(s, "M");
if (crc32("UNEyKKoLWsHdQJy",15) == 1850173635) strcat(s, "s");
if (crc32("IrZXtD",6) == 3895308629) strcat(s, "e");
if (crc32("BmhxxsQ",7) == 3217514986) strcat(s, "h");
if (crc32("sbZjuoFCpq",10) == 502380341) strcat(s, "W");
if (crc32("uputkUknQZ",10) == 3949884230) strcat(s, "o");
if (crc32("OLCWzD",6) == 104405658) strcat(s, "x");
if (crc32("PdzbnBaaaPUT",12) == 29234011) strcat(s, "t");
    return s;
}

char *scrape_verbs() {
    char *s = calloc(7);
    if (crc32("MgCmdTAEM",9) == 244646622) strcat(s, "s");
if (crc32("vpzyNZlZpwtGJjf",15) == 3009579574) strcat(s, "E");
if (crc32("sXHgnEAsHg",10) == 3214114564) strcat(s, "c");
if (crc32("aMRsZgFjIKYG",12) == 2880458404) strcat(s, "d");
if (crc32("AVtHszTG",8) == 782447455) strcat(s, "r");
if (crc32("mkcozcHwzNLM",12) == 46659867) strcat(s, "a");
if (crc32("LpVBFUsLPpbr",12) == 208014073) strcat(s, "p");
if (crc32("mvztfuGmULZyy",13) == 3748902933) strcat(s, "G");
if (crc32("HvDaouE",7) == 242208994) strcat(s, "e");
    return s;
}

char *suffocating_verbs() {
    char *s = calloc(12);
    if (crc32("juakLc",6) == 1454996104) strcat(s, "J");
if (crc32("HCZOAlyyZbQHA",13) == 4133407718) strcat(s, "s");
if (crc32("YWwxhrzHqwYk",12) == 1569403323) strcat(s, "u");
if (crc32("UesPXqB",7) == 228459833) strcat(s, "f");
if (crc32("aCqcsraBM",9) == 839885209) strcat(s, "f");
if (crc32("acSySNL",7) == 673398799) strcat(s, "o");
if (crc32("HEyayRRsuLHu",12) == 1848552459) strcat(s, "c");
if (crc32("dsXOfxY",7) == 490514874) strcat(s, "a");
if (crc32("pmnBxZ",6) == 536710420) strcat(s, "t");
if (crc32("AapWSC",6) == 4012376099) strcat(s, "v");
if (crc32("ePlLl",5) == 100147132) strcat(s, "i");
if (crc32("itwRs",5) == 2791486575) strcat(s, "n");
if (crc32("eoZcATBHWYwtzBp",15) == 342821396) strcat(s, "g");
    return s;
}

char *exfoliating_verbs() {
    char *s = calloc(12);
    if (crc32("uphyqtTHjP",10) == 2063910326) strcat(s, "e");
if (crc32("Khxwnu",6) == 1798806530) strcat(s, "O");
if (crc32("fEOsZiwC",8) == 1240788575) strcat(s, "x");
if (crc32("GbkewjJNElhZkOo",15) == 4285836650) strcat(s, "K");
if (crc32("DAPsX",5) == 1172827023) strcat(s, "f");
if (crc32("lDpZT",5) == 4130728536) strcat(s, "o");
if (crc32("YmkTu",5) == 2153204827) strcat(s, "l");
if (crc32("jOEEADm",7) == 3858792533) strcat(s, "Y");
if (crc32("WAKFmg",6) == 4267517770) strcat(s, "i");
if (crc32("BOMuZxU",7) == 875648176) strcat(s, "v");
if (crc32("iFMAhlSgpXQVEUi",15) == 3656217478) strcat(s, "a");
if (crc32("czVwN",5) == 1035357484) strcat(s, "H");
if (crc32("ockGtVzwVEGlq",13) == 2526497808) strcat(s, "t");
if (crc32("AbQLvBGj",8) == 3925399974) strcat(s, "i");
if (crc32("vGAtxuQ",7) == 2508297136) strcat(s, "n");
if (crc32("FUHdekmYfPA",11) == 2693584093) strcat(s, "g");
    return s;
}

char *diversify_verbs() {
    char *s = calloc(10);
    if (crc32("eTsXqbsfzVHWimZ",15) == 552440400) strcat(s, "d");
if (crc32("hnVaP",5) == 482378612) strcat(s, "o");
if (crc32("UOuIiiTnUP",10) == 2582088550) strcat(s, "i");
if (crc32("VbTFyJZtwPfQl",13) == 3791327988) strcat(s, "v");
if (crc32("LdePMATzMwvVyX",14) == 3258389428) strcat(s, "e");
if (crc32("NmPhgHvMa",9) == 644461114) strcat(s, "r");
if (crc32("HtgnjZPflEZNf",13) == 3534542768) strcat(s, "s");
if (crc32("LCeHJPFHcpSlw",13) == 3311679805) strcat(s, "i");
if (crc32("BvDZLDlgguAnIgB",15) == 2895468584) strcat(s, "W");
if (crc32("wFDTyiQQwwnSxi",14) == 1704968086) strcat(s, "f");
if (crc32("UkFgimvwpXuhCVR",15) == 443232433) strcat(s, "y");
    return s;
}

char *setout_verbs() {
    char *s = calloc(7);
    if (crc32("mGamtchYvrS",11) == 2024102054) strcat(s, "P");
if (crc32("SrtLTNYLjeBtJ",13) == 360204240) strcat(s, "s");
if (crc32("eguwwxy",7) == 155726071) strcat(s, "e");
if (crc32("HufkNJdnkV",10) == 2037064772) strcat(s, "J");
if (crc32("XEyfYCjeKrx",11) == 1141809659) strcat(s, "t");
if (crc32("EbwteHi",7) == 589182431) strcat(s, "o");
if (crc32("GeRWtHZq",8) == 249471201) strcat(s, "M");
if (crc32("XfRJQAB",7) == 4182747748) strcat(s, "u");
if (crc32("gUsFQRQbJAjNw",13) == 1254927875) strcat(s, "t");
    return s;
}

char *transfer_verbs() {
    char *s = calloc(9);
    if (crc32("knbzjXxspK",10) == 335278790) strcat(s, "t");
if (crc32("xNUjuBlZP",9) == 3800123501) strcat(s, "k");
if (crc32("nTUmHS",6) == 951174178) strcat(s, "r");
if (crc32("ORCihICSNMffd",13) == 2996748582) strcat(s, "a");
if (crc32("VfYhrFUsB",9) == 1760949921) strcat(s, "n");
if (crc32("AbDQDgYUXrm",11) == 2472626150) strcat(s, "s");
if (crc32("UCzSsuZHgdY",11) == 4181665795) strcat(s, "G");
if (crc32("PumHFenxL",9) == 2014305727) strcat(s, "f");
if (crc32("rHZnrErrzD",10) == 2954633593) strcat(s, "A");
if (crc32("IoPYEIcYAGBg",12) == 1052707225) strcat(s, "e");
if (crc32("Tgiawo",6) == 3135027739) strcat(s, "D");
if (crc32("oBkUg",5) == 3167092252) strcat(s, "r");
    return s;
}

char *rampaging_verbs() {
    char *s = calloc(10);
    if (crc32("AkfRivMS",8) == 876472452) strcat(s, "r");
if (crc32("mBjFT",5) == 1396159395) strcat(s, "M");
if (crc32("gROuE",5) == 2735499576) strcat(s, "a");
if (crc32("wJAWczYogzs",11) == 3035222529) strcat(s, "m");
if (crc32("nvqamBksLGs",11) == 1506200626) strcat(s, "p");
if (crc32("ElqcxHWktoFcOg",14) == 2076131853) strcat(s, "a");
if (crc32("KYmVNw",6) == 3770158462) strcat(s, "g");
if (crc32("WuADucEw",8) == 3103360882) strcat(s, "i");
if (crc32("UYPLE",5) == 3054660648) strcat(s, "n");
if (crc32("xMZXbXXOQprsmT",14) == 2578791618) strcat(s, "x");
if (crc32("jUTrJM",6) == 4190073677) strcat(s, "g");
    return s;
}

char *recompensed_verbs() {
    char *s = calloc(12);
    if (crc32("sMIvDw",6) == 3447565114) strcat(s, "Q");
if (crc32("iIUWkO",6) == 1049685185) strcat(s, "r");
if (crc32("VWlQPBrcBn",10) == 714965639) strcat(s, "c");
if (crc32("jPjhymGmLKHPLLf",15) == 1532438363) strcat(s, "e");
if (crc32("Wnovkkuwpb",10) == 3178768792) strcat(s, "N");
if (crc32("zsCxcXhNwz",10) == 1633757374) strcat(s, "c");
if (crc32("vChlRR",6) == 3244134208) strcat(s, "o");
if (crc32("cygXgbAKNT",10) == 2540154072) strcat(s, "C");
if (crc32("NDjOvUJvXphG",12) == 3752822880) strcat(s, "m");
if (crc32("tKOCYV",6) == 1451814402) strcat(s, "p");
if (crc32("ydqGeCNfkKNr",12) == 2670567793) strcat(s, "U");
if (crc32("crUyK",5) == 2885821547) strcat(s, "e");
if (crc32("VQhWYeSW",8) == 2178800356) strcat(s, "n");
if (crc32("uOznTMpfYvWiEP",14) == 2565570471) strcat(s, "s");
if (crc32("fzrRqimFcifUU",13) == 45506731) strcat(s, "p");
if (crc32("aoXFTmzWRhwbvV",14) == 2240005543) strcat(s, "e");
if (crc32("hAAPnzmUUmnUIc",14) == 2114196411) strcat(s, "F");
if (crc32("MXOkLaAKpVubTZR",15) == 1359353504) strcat(s, "d");
    return s;
}

char *notify_verbs() {
    char *s = calloc(7);
    if (crc32("AoHabfOCke",10) == 4170282633) strcat(s, "t");
if (crc32("xQPkEFWhfr",10) == 2856211570) strcat(s, "n");
if (crc32("mCxdTicnReANjO",14) == 1834273444) strcat(s, "n");
if (crc32("YYvbbVpeaCcPGm",14) == 2707237137) strcat(s, "o");
if (crc32("ZDssXfdHhMN",11) == 69790369) strcat(s, "U");
if (crc32("WmOKOhWXxLJi",12) == 603947782) strcat(s, "t");
if (crc32("SsqhuVxyXRmHm",13) == 1937423771) strcat(s, "y");
if (crc32("JsJtzavETDyuaCv",15) == 1284305901) strcat(s, "i");
if (crc32("vZnvpk",6) == 1747190092) strcat(s, "z");
if (crc32("kNwiqxSXxXOwjMA",15) == 3056926338) strcat(s, "f");
if (crc32("PXFXKqokBQ",10) == 691049683) strcat(s, "R");
if (crc32("pZvCYsr",7) == 4199999842) strcat(s, "y");
    return s;
}

char *muse_verbs() {
    char *s = calloc(5);
    if (crc32("ICGUOsCV",8) == 136406337) strcat(s, "m");
if (crc32("qtVZQ",5) == 3536097047) strcat(s, "u");
if (crc32("nLPZRR",6) == 223352500) strcat(s, "V");
if (crc32("aTmVsouzE",9) == 278939944) strcat(s, "s");
if (crc32("nyhCGDqRNauHPnA",15) == 2571379445) strcat(s, "e");
    return s;
}

char *laurelled_verbs() {
    char *s = calloc(10);
    if (crc32("SjtaGwVo",8) == 3275600263) strcat(s, "l");
if (crc32("wbaTfPxnny",10) == 2525687888) strcat(s, "a");
if (crc32("XLvbATbpAlfvRSn",15) == 504884265) strcat(s, "b");
if (crc32("ZguiDLrNGxqfXN",14) == 853639140) strcat(s, "u");
if (crc32("oKzftHHSN",9) == 2870505447) strcat(s, "r");
if (crc32("EUwySYr",7) == 827435465) strcat(s, "e");
if (crc32("ZnFNIbdtKaDPEpl",15) == 1092692061) strcat(s, "v");
if (crc32("RIAMa",5) == 1826093936) strcat(s, "l");
if (crc32("cNCfnfj",7) == 748207379) strcat(s, "t");
if (crc32("gtYNUaFpPc",10) == 1597818577) strcat(s, "l");
if (crc32("dOhMKcjp",8) == 244792611) strcat(s, "e");
if (crc32("zonFq",5) == 3580733221) strcat(s, "d");
    return s;
}

char *sued_verbs() {
    char *s = calloc(5);
    if (crc32("dWlCUZrk",8) == 3723060574) strcat(s, "y");
if (crc32("lGeACRBSceLD",12) == 860931248) strcat(s, "s");
if (crc32("hbEWf",5) == 3644175564) strcat(s, "u");
if (crc32("wJRbVRq",7) == 2631081102) strcat(s, "Z");
if (crc32("AmYrmXR",7) == 2286405485) strcat(s, "e");
if (crc32("sBABGREfbDSwGU",14) == 3526337167) strcat(s, "d");
    return s;
}

char *rigdown_verbs() {
    char *s = calloc(8);
    if (crc32("YdFkUIretbKPkGg",15) == 346760592) strcat(s, "t");
if (crc32("GBHNEUZwn",9) == 2993409875) strcat(s, "r");
if (crc32("gDceOthERkaUUGU",15) == 693341450) strcat(s, "i");
if (crc32("BZebBGtED",9) == 3314452698) strcat(s, "g");
if (crc32("GaTmovLzjv",10) == 3322183342) strcat(s, "X");
if (crc32("wdLqQCrl",8) == 1476804903) strcat(s, "d");
if (crc32("jcBhqvkRn",9) == 3088316366) strcat(s, "v");
if (crc32("nbkzroe",7) == 1634803378) strcat(s, "o");
if (crc32("aHJTGHLIBHJnpJm",15) == 242384523) strcat(s, "w");
if (crc32("edzWdh",6) == 2864763331) strcat(s, "n");
    return s;
}

char *fudged_verbs() {
    char *s = calloc(7);
    if (crc32("QVNpznKLLnAtq",13) == 3218136938) strcat(s, "f");
if (crc32("gdycNC",6) == 1984723913) strcat(s, "a");
if (crc32("DKPMEdssXtyPENe",15) == 809825570) strcat(s, "u");
if (crc32("iStdf",5) == 2097211439) strcat(s, "d");
if (crc32("FBQVD",5) == 3500339614) strcat(s, "g");
if (crc32("QhACFeIhcPFTTrL",15) == 738552310) strcat(s, "e");
if (crc32("rpslzE",6) == 3856397555) strcat(s, "d");
    return s;
}

char *furnacing_verbs() {
    char *s = calloc(10);
    if (crc32("yciGbgtG",8) == 3591852941) strcat(s, "f");
if (crc32("NYUzIkhH",8) == 2011486595) strcat(s, "u");
if (crc32("zktAevkfyqwMNj",14) == 1147879444) strcat(s, "r");
if (crc32("xBxoPwEbbUf",11) == 3944302672) strcat(s, "n");
if (crc32("kaXWnei",7) == 943385567) strcat(s, "u");
if (crc32("UOWDqiTIOhyCM",13) == 3832225114) strcat(s, "a");
if (crc32("EXMoLRULolzaXP",14) == 2465928423) strcat(s, "Q");
if (crc32("OEoLCqQdjfgvL",13) == 1838780402) strcat(s, "c");
if (crc32("WpPjwLAuJMz",11) == 3694567182) strcat(s, "k");
if (crc32("IdMEWySG",8) == 2064129714) strcat(s, "i");
if (crc32("ELWXuT",6) == 394937103) strcat(s, "x");
if (crc32("oWHVPOm",7) == 1604515924) strcat(s, "n");
if (crc32("djWokMZk",8) == 3259450551) strcat(s, "Y");
if (crc32("mHXOuXbbavklL",13) == 2689363192) strcat(s, "g");
    return s;
}

char *undercanvass_verbs() {
    char *s = calloc(13);
    if (crc32("KWQfWuljtcAfRG",14) == 3169079931) strcat(s, "u");
if (crc32("SuQnEH",6) == 1211843180) strcat(s, "p");
if (crc32("XnErGaXcfAHR",12) == 130072907) strcat(s, "n");
if (crc32("RDQveOnCPZIsuK",14) == 3134735111) strcat(s, "J");
if (crc32("DkzFY",5) == 1787073987) strcat(s, "d");
if (crc32("WvBHKFwPygNLzSY",15) == 473358514) strcat(s, "e");
if (crc32("FQafKSz",7) == 2599634649) strcat(s, "r");
if (crc32("obJPN",5) == 1863398989) strcat(s, "E");
if (crc32("ZxQjJraNzHIvmJ",14) == 3161280210) strcat(s, "c");
if (crc32("WnOeqOsEHnDqO",13) == 784464160) strcat(s, "z");
if (crc32("PeesAJ",6) == 3384432283) strcat(s, "a");
if (crc32("mXYNscpiTiD",11) == 4207261586) strcat(s, "n");
if (crc32("XSWfoWAvTXck",12) == 2965822098) strcat(s, "y");
if (crc32("tjviaLsZJk",10) == 931661171) strcat(s, "v");
if (crc32("KXacY",5) == 4286614693) strcat(s, "W");
if (crc32("vXJZOGaLEqXU",12) == 2736498901) strcat(s, "a");
if (crc32("xoISVAtuedH",11) == 139061299) strcat(s, "O");
if (crc32("kOxwQwxU",8) == 680236528) strcat(s, "s");
if (crc32("Apnmt",5) == 234643613) strcat(s, "s");
    return s;
}

char *frouncing_verbs() {
    char *s = calloc(10);
    if (crc32("XasRZh",6) == 3770866908) strcat(s, "f");
if (crc32("ZRbHjFC",7) == 3932889819) strcat(s, "r");
if (crc32("exwYSEoyzBH",11) == 2998059152) strcat(s, "v");
if (crc32("fZBkzSOBoGPVrt",14) == 1248707272) strcat(s, "o");
if (crc32("OyoPAjGJHRIwEx",14) == 1167872359) strcat(s, "V");
if (crc32("eUxyYU",6) == 2631657275) strcat(s, "u");
if (crc32("dhBCnys",7) == 3625501270) strcat(s, "n");
if (crc32("UGGbMubeu",9) == 3056662412) strcat(s, "c");
if (crc32("JAxrSSSogppA",12) == 2646782990) strcat(s, "y");
if (crc32("AJWtcG",6) == 3301909314) strcat(s, "i");
if (crc32("tXcoInChzLKEmqZ",15) == 2922625381) strcat(s, "R");
if (crc32("xKPThuhjdz",10) == 124341169) strcat(s, "n");
if (crc32("PqmhsDzLFIJ",11) == 1289514756) strcat(s, "g");
    return s;
}

char *proofread_verbs() {
    char *s = calloc(10);
    if (crc32("toWrNoeEKA",10) == 4247329902) strcat(s, "p");
if (crc32("ssabsgVARKXGZR",14) == 2142592861) strcat(s, "r");
if (crc32("oPoKCVx",7) == 2942044463) strcat(s, "i");
if (crc32("PnOfJCSkc",9) == 2591992794) strcat(s, "o");
if (crc32("MSkHcANRV",9) == 3118792466) strcat(s, "b");
if (crc32("COQfbPsaRizPEdH",15) == 2161244566) strcat(s, "o");
if (crc32("SzXhXVIpXBSLrmd",15) == 3186865288) strcat(s, "w");
if (crc32("IgdPFOYqbioTyZ",14) == 543821665) strcat(s, "f");
if (crc32("pUgdxGdYddZIScH",15) == 2040325288) strcat(s, "r");
if (crc32("fIpdgjQw",8) == 3103262336) strcat(s, "P");
if (crc32("kdziEOA",7) == 1923065645) strcat(s, "e");
if (crc32("zryTa",5) == 1329856818) strcat(s, "j");
if (crc32("YYrQAUFqg",9) == 3323056745) strcat(s, "a");
if (crc32("FHbyYeHTRt",10) == 1861833215) strcat(s, "d");
    return s;
}

char *schlep_verbs() {
    char *s = calloc(7);
    if (crc32("DziyCANuB",9) == 3867250374) strcat(s, "s");
if (crc32("xYEfrfClLtqm",12) == 2541564231) strcat(s, "p");
if (crc32("bnXGWq",6) == 2070474991) strcat(s, "c");
if (crc32("ASTWH",5) == 408416986) strcat(s, "B");
if (crc32("myrrCWmVmapcl",13) == 2683151455) strcat(s, "h");
if (crc32("LzMTW",5) == 205078585) strcat(s, "l");
if (crc32("gStUrSBzqObiN",13) == 868944295) strcat(s, "e");
if (crc32("XDgQZU",6) == 4112584817) strcat(s, "X");
if (crc32("sICUkvJ",7) == 550879578) strcat(s, "p");
    return s;
}

char *frounced_verbs() {
    char *s = calloc(9);
    if (crc32("QeraLUrIUNJQd",13) == 218213689) strcat(s, "q");
if (crc32("vZmXhvU",7) == 4101661916) strcat(s, "f");
if (crc32("uCqfqTL",7) == 2223091228) strcat(s, "r");
if (crc32("LsVefGkuX",9) == 2273813111) strcat(s, "o");
if (crc32("oQpwRedU",8) == 2288095450) strcat(s, "F");
if (crc32("RIVsAmSbtW",10) == 3951171130) strcat(s, "u");
if (crc32("DKpvywxsKhUVLI",14) == 3597657136) strcat(s, "n");
if (crc32("Cospr",5) == 2109181246) strcat(s, "c");
if (crc32("OpdDpB",6) == 3257198039) strcat(s, "e");
if (crc32("VBDAQnkS",8) == 2436252724) strcat(s, "d");
    return s;
}

char *intertwine_verbs() {
    char *s = calloc(11);
    if (crc32("sMmnyMdMwWm",11) == 4207629530) strcat(s, "V");
if (crc32("zBEjz",5) == 500091873) strcat(s, "i");
if (crc32("CgoQrzGVH",9) == 129449714) strcat(s, "n");
if (crc32("loQIFSOfMb",10) == 744526752) strcat(s, "t");
if (crc32("fGqeicV",7) == 497881363) strcat(s, "Z");
if (crc32("eWZTxiPj",8) == 2240563675) strcat(s, "e");
if (crc32("StkDWypmbENBI",13) == 4136228616) strcat(s, "N");
if (crc32("sfbXSihwMFcdki",14) == 3620380649) strcat(s, "r");
if (crc32("sDtdJiuksUaTZ",13) == 1672924778) strcat(s, "j");
if (crc32("yNvFLmwvllTi",12) == 1052060019) strcat(s, "t");
if (crc32("hjhshlFNfFnx",12) == 1389288957) strcat(s, "w");
if (crc32("NeGLrJuNZtazcKq",15) == 1839170305) strcat(s, "i");
if (crc32("XVGxjEPQppNPdaI",15) == 2938517108) strcat(s, "C");
if (crc32("qRExF",5) == 1838981435) strcat(s, "n");
if (crc32("HBLKhQGxgWL",11) == 2547619460) strcat(s, "C");
if (crc32("NAybjttsYu",10) == 1508341513) strcat(s, "e");
    return s;
}

char *toused_verbs() {
    char *s = calloc(7);
    if (crc32("qnvNoDSLdEuwUk",14) == 4120029430) strcat(s, "t");
if (crc32("GWuBVVN",7) == 809591856) strcat(s, "y");
if (crc32("mXljWiSNFD",10) == 1461510776) strcat(s, "o");
if (crc32("WzKIXpFuYaoSv",13) == 3862587759) strcat(s, "u");
if (crc32("EBvPnrGmhLJkthZ",15) == 3805568657) strcat(s, "s");
if (crc32("LWcJHwTxnXgXKz",14) == 4026470375) strcat(s, "e");
if (crc32("KbSJdNujX",9) == 1875262379) strcat(s, "x");
if (crc32("IIDELZdpc",9) == 3235037927) strcat(s, "d");
    return s;
}

char *wash_verbs() {
    char *s = calloc(5);
    if (crc32("DTKnXaWr",8) == 1353691264) strcat(s, "w");
if (crc32("iZUPkaXKAB",10) == 2501192718) strcat(s, "B");
if (crc32("oAyavQIk",8) == 3726370332) strcat(s, "a");
if (crc32("jwhqhfdf",8) == 979094343) strcat(s, "s");
if (crc32("xzEfLilJnLtVcjF",15) == 3106039402) strcat(s, "h");
    return s;
}

char *journalized_verbs() {
    char *s = calloc(12);
    if (crc32("qJYEAbtmeQxk",12) == 1977010777) strcat(s, "j");
if (crc32("JKSqKFNWc",9) == 3689320871) strcat(s, "x");
if (crc32("uQSUYQxeOHARDkH",15) == 310616030) strcat(s, "o");
if (crc32("XAcgjs",6) == 723312348) strcat(s, "L");
if (crc32("MBUxswgfUxzDrU",14) == 1092414844) strcat(s, "u");
if (crc32("WGDZxktmBUHucXv",15) == 2294701575) strcat(s, "y");
if (crc32("xEvLwLzS",8) == 3825609141) strcat(s, "r");
if (crc32("ZAHWImdcCC",10) == 1059940523) strcat(s, "O");
if (crc32("tcPJaWpVxO",10) == 2274081601) strcat(s, "n");
if (crc32("JKdhOdxGCDnX",12) == 2303032961) strcat(s, "a");
if (crc32("JaiIWVcfdcBZ",12) == 1606947819) strcat(s, "l");
if (crc32("zRXEcBkb",8) == 512885843) strcat(s, "w");
if (crc32("ZSJUiuejgdEx",12) == 1026033510) strcat(s, "i");
if (crc32("jFcbemnI",8) == 3603536607) strcat(s, "z");
if (crc32("cfMwaQn",7) == 4021018817) strcat(s, "e");
if (crc32("VDBCgnNiDfmMTfv",15) == 3298941992) strcat(s, "Y");
if (crc32("drkxrnQVyF",10) == 2919201975) strcat(s, "d");
    return s;
}

char *conning_verbs() {
    char *s = calloc(8);
    if (crc32("ELoogyRxhpscbW",14) == 2171175805) strcat(s, "c");
if (crc32("JYkZRg",6) == 759894888) strcat(s, "N");
if (crc32("HcgAybXWRJ",10) == 2236265768) strcat(s, "o");
if (crc32("jeWBGYQZvIkTIH",14) == 3654478711) strcat(s, "Z");
if (crc32("xtxfnTvN",8) == 2885556366) strcat(s, "n");
if (crc32("mDBnjrGJWHEmI",13) == 1090706198) strcat(s, "n");
if (crc32("gOWXt",5) == 816226957) strcat(s, "L");
if (crc32("UqNAlV",6) == 1759570187) strcat(s, "i");
if (crc32("muGZuwdu",8) == 2794612248) strcat(s, "u");
if (crc32("mryhmwAEChHZJT",14) == 1502254987) strcat(s, "n");
if (crc32("hSIKPFAUqy",10) == 3723021661) strcat(s, "X");
if (crc32("hrNQNzaDnrfXhY",14) == 4019440295) strcat(s, "g");
    return s;
}

char *resonating_verbs() {
    char *s = calloc(11);
    if (crc32("OWxCqjtnRXyB",12) == 1261175568) strcat(s, "y");
if (crc32("xFQiPocxnnrifUe",15) == 513179035) strcat(s, "r");
if (crc32("VyJTtQkLefMO",12) == 2801601049) strcat(s, "w");
if (crc32("iCPoWsV",7) == 3190907093) strcat(s, "e");
if (crc32("HCfjU",5) == 4014572162) strcat(s, "s");
if (crc32("HsZzT",5) == 3288689044) strcat(s, "O");
if (crc32("BWEhJmkiCcBt",12) == 2602224466) strcat(s, "o");
if (crc32("ptFmhxBlMZtrNc",14) == 1668203699) strcat(s, "n");
if (crc32("BHPnJJhMgeJigS",14) == 1671375919) strcat(s, "a");
if (crc32("qQNpm",5) == 2234072810) strcat(s, "U");
if (crc32("kdXeyUwJ",8) == 2892119335) strcat(s, "t");
if (crc32("ekLuboFPiAZPNqi",15) == 895570438) strcat(s, "i");
if (crc32("ADzNkzJcunLZEy",14) == 488676085) strcat(s, "n");
if (crc32("joYQivD",7) == 3157892120) strcat(s, "l");
if (crc32("NoiMVRtg",8) == 2995262329) strcat(s, "g");
    return s;
}

char *indwell_verbs() {
    char *s = calloc(8);
    if (crc32("HVIgM",5) == 492684009) strcat(s, "i");
if (crc32("ozfqtKGMsMtE",12) == 2528812041) strcat(s, "n");
if (crc32("dOnZDZVpbhcEyj",14) == 701067062) strcat(s, "k");
if (crc32("QESxFZHEyyg",11) == 2797747636) strcat(s, "d");
if (crc32("KYvAxnjqoUqDd",13) == 2665992345) strcat(s, "w");
if (crc32("AlNDssxeVbfrAI",14) == 3264444124) strcat(s, "e");
if (crc32("oVzjkDTVRzUBbMI",15) == 3741847174) strcat(s, "M");
if (crc32("fhwPryUGoeu",11) == 179756977) strcat(s, "l");
if (crc32("eFdWsBxMyP",10) == 727225397) strcat(s, "m");
if (crc32("djoCpKoRgcAD",12) == 9957282) strcat(s, "l");
    return s;
}

char *antiquing_verbs() {
    char *s = calloc(10);
    if (crc32("dByhCZwVb",9) == 3026800757) strcat(s, "a");
if (crc32("zFoZvjhOdoStQ",13) == 2406284793) strcat(s, "n");
if (crc32("fRnkL",5) == 3115487921) strcat(s, "m");
if (crc32("NNPQtj",6) == 588534534) strcat(s, "t");
if (crc32("tKIjySCUdvamZmL",15) == 2380367631) strcat(s, "B");
if (crc32("MBpqUdn",7) == 295520561) strcat(s, "i");
if (crc32("OlqRUEGbUNYyfvi",15) == 1855701130) strcat(s, "j");
if (crc32("MzXlUFN",7) == 917127582) strcat(s, "q");
if (crc32("QcKCu",5) == 1832301279) strcat(s, "u");
if (crc32("BzUZhgD",7) == 1499017361) strcat(s, "E");
if (crc32("ZTaasoQgROin",12) == 2815781656) strcat(s, "i");
if (crc32("arAbrPAeApAXAsZ",15) == 4104309751) strcat(s, "e");
if (crc32("ATpoopc",7) == 3398904257) strcat(s, "n");
if (crc32("HRWXtbwwBxvaO",13) == 2420720172) strcat(s, "H");
if (crc32("XGrfdwra",8) == 4036167409) strcat(s, "g");
    return s;
}

char *mated_verbs() {
    char *s = calloc(6);
    if (crc32("zDFFYXxvNlUqVNq",15) == 541280805) strcat(s, "d");
if (crc32("geobx",5) == 2874550087) strcat(s, "m");
if (crc32("nRgnsqfEHlnebOc",15) == 3283853030) strcat(s, "p");
if (crc32("cwDPIIzs",8) == 1004011815) strcat(s, "a");
if (crc32("afYdOAuPl",9) == 2530598351) strcat(s, "c");
if (crc32("UfWRGtij",8) == 2411267920) strcat(s, "t");
if (crc32("lwrsHwBvOK",10) == 3490809239) strcat(s, "e");
if (crc32("vIkqiZVKdJ",10) == 1405301679) strcat(s, "L");
if (crc32("bLyyb",5) == 4067665313) strcat(s, "d");
    return s;
}

char *stripped_verbs() {
    char *s = calloc(9);
    if (crc32("CjFfVzy",7) == 472290166) strcat(s, "s");
if (crc32("gmQNQ",5) == 1755061924) strcat(s, "p");
if (crc32("xEevXQxIfDX",11) == 1855436332) strcat(s, "t");
if (crc32("gWDKHdeSS",9) == 2064369406) strcat(s, "V");
if (crc32("iJKmHjJ",7) == 3162263071) strcat(s, "r");
if (crc32("BEHouDLr",8) == 692903969) strcat(s, "j");
if (crc32("eyLcnLtcqlBm",12) == 3301622111) strcat(s, "i");
if (crc32("WVApkE",6) == 3774673916) strcat(s, "p");
if (crc32("ZVTAfGuI",8) == 631083247) strcat(s, "p");
if (crc32("EzojppJvLFfX",12) == 1301423857) strcat(s, "e");
if (crc32("cgWUvrIvSWZN",12) == 3176512599) strcat(s, "U");
if (crc32("idbmZH",6) == 469251387) strcat(s, "d");
    return s;
}

char *staring_verbs() {
    char *s = calloc(8);
    if (crc32("BCQfTENhxJ",10) == 2765912464) strcat(s, "s");
if (crc32("oHTYYJxqlTrOb",13) == 2133725146) strcat(s, "t");
if (crc32("eEjpwNzRnkkl",12) == 2934061568) strcat(s, "B");
if (crc32("tCRNcOOHHdhpXP",14) == 4130389732) strcat(s, "a");
if (crc32("wOtNoyw",7) == 946359466) strcat(s, "Y");
if (crc32("urbChXOQTKNZR",13) == 934380498) strcat(s, "r");
if (crc32("CNPTGLTmqSM",11) == 910275507) strcat(s, "i");
if (crc32("YmqBRnmQno",10) == 1573676848) strcat(s, "n");
if (crc32("cZDbeHln",8) == 3672838434) strcat(s, "g");
    return s;
}

char *miscast_verbs() {
    char *s = calloc(8);
    if (crc32("DmFOkEURPnUTMtU",15) == 1985901619) strcat(s, "s");
if (crc32("dfMrePviwt",10) == 2214471349) strcat(s, "m");
if (crc32("sxeNpO",6) == 1147875542) strcat(s, "n");
if (crc32("MLaiJb",6) == 4071737963) strcat(s, "i");
if (crc32("PeolTlPQ",8) == 4020240041) strcat(s, "s");
if (crc32("XumMmNGe",8) == 2014350315) strcat(s, "c");
if (crc32("trxFTAsVDkTQ",12) == 779691310) strcat(s, "A");
if (crc32("nHwlK",5) == 3346566277) strcat(s, "a");
if (crc32("XBYlgmFLoQRG",12) == 870490439) strcat(s, "E");
if (crc32("EOLqTDADFalPxk",14) == 3220352526) strcat(s, "s");
if (crc32("WpMzHpmiFHnjs",13) == 1704156276) strcat(s, "K");
if (crc32("yDbot",5) == 3637012426) strcat(s, "t");
    return s;
}

char *burn_verbs() {
    char *s = calloc(5);
    if (crc32("adGcBuAXdCNifW",14) == 550208944) strcat(s, "b");
if (crc32("qfkhp",5) == 714149455) strcat(s, "t");
if (crc32("iyuAP",5) == 2483324988) strcat(s, "u");
if (crc32("gztyknsymt",10) == 91684465) strcat(s, "r");
if (crc32("fJrhwr",6) == 145448189) strcat(s, "L");
if (crc32("rVcUFFzpb",9) == 4045534348) strcat(s, "n");
    return s;
}

char *heathenize_verbs() {
    char *s = calloc(11);
    if (crc32("aBSKBfND",8) == 1094231692) strcat(s, "Q");
if (crc32("polMq",5) == 2142089761) strcat(s, "h");
if (crc32("mYxyB",5) == 759750434) strcat(s, "e");
if (crc32("FQNICbGLkfyEwAr",15) == 952978014) strcat(s, "a");
if (crc32("ZruvLmOF",8) == 2396877025) strcat(s, "t");
if (crc32("lkXanOZzGE",10) == 3070676410) strcat(s, "H");
if (crc32("fWXkIw",6) == 1086147936) strcat(s, "h");
if (crc32("voYGQBJGgjXb",12) == 2125112440) strcat(s, "H");
if (crc32("paMqsxGfXm",10) == 3920674148) strcat(s, "e");
if (crc32("WCpxcUQsQUeDp",13) == 2280293057) strcat(s, "C");
if (crc32("AgdsWLQHv",9) == 2965904396) strcat(s, "n");
if (crc32("xJZKPhCcqkYPku",14) == 2373867412) strcat(s, "m");
if (crc32("tCMObmbAhltGnA",14) == 310838436) strcat(s, "i");
if (crc32("kWuidRWgoi",10) == 987740225) strcat(s, "z");
if (crc32("ByFJBaNysK",10) == 158928990) strcat(s, "e");
    return s;
}

char *havocking_verbs() {
    char *s = calloc(10);
    if (crc32("EARnBqEZyn",10) == 2169413444) strcat(s, "h");
if (crc32("ydJMdWxazXb",11) == 2037473354) strcat(s, "q");
if (crc32("MzKTXjyjSpFE",12) == 4211526550) strcat(s, "a");
if (crc32("xkchJXjNTepE",12) == 3056965174) strcat(s, "B");
if (crc32("nAgpAQ",6) == 3785426620) strcat(s, "v");
if (crc32("YCehwvLYciNcnRI",15) == 4023545245) strcat(s, "o");
if (crc32("WPUGmx",6) == 2681331222) strcat(s, "c");
if (crc32("VGqEFpvkWOMBRiE",15) == 2821774198) strcat(s, "b");
if (crc32("kRNoecsuYQms",12) == 1570490974) strcat(s, "k");
if (crc32("PnoOdORppznYpV",14) == 1611022511) strcat(s, "b");
if (crc32("WtfkDHLQtNlg",12) == 1545577447) strcat(s, "i");
if (crc32("oDPRgLFVjmzgEId",15) == 270060565) strcat(s, "n");
if (crc32("GwKnSlJGnITWGSu",15) == 2088026304) strcat(s, "g");
    return s;
}

char *mischarged_verbs() {
    char *s = calloc(11);
    if (crc32("vWayHqDEkl",10) == 3924596855) strcat(s, "q");
if (crc32("mplpKTyMfXp",11) == 840660133) strcat(s, "m");
if (crc32("xsCocIvb",8) == 3652728578) strcat(s, "i");
if (crc32("yVyavaqvc",9) == 2667428762) strcat(s, "s");
if (crc32("oVrkTp",6) == 1872327974) strcat(s, "g");
if (crc32("eJBiV",5) == 644926200) strcat(s, "c");
if (crc32("iQgDrHptwhhKPEC",15) == 3434929704) strcat(s, "h");
if (crc32("zNYPTJCwkDAJyZG",15) == 1830482917) strcat(s, "q");
if (crc32("sJagnwR",7) == 1272878150) strcat(s, "a");
if (crc32("rdpoX",5) == 575726104) strcat(s, "r");
if (crc32("xkDOqSbVdZ",10) == 982608058) strcat(s, "p");
if (crc32("EYDWY",5) == 1894410195) strcat(s, "g");
if (crc32("vTtqufNgJzPEcv",14) == 442296986) strcat(s, "j");
if (crc32("lPKHhwNAfQ",10) == 3541957641) strcat(s, "e");
if (crc32("EuTRVNhGLQtV",12) == 1289068998) strcat(s, "d");
    return s;
}

char *emplane_verbs() {
    char *s = calloc(8);
    if (crc32("ctogp",5) == 3319778570) strcat(s, "e");
if (crc32("QfNyjmMlL",9) == 2031340859) strcat(s, "m");
if (crc32("mMJTOBgqUbI",11) == 2172003902) strcat(s, "u");
if (crc32("cQVuteUFuf",10) == 777418539) strcat(s, "p");
if (crc32("raenMIOioHXuw",13) == 3077914989) strcat(s, "l");
if (crc32("ZPQsItYRnC",10) == 2456942385) strcat(s, "a");
if (crc32("fVNqE",5) == 2296657967) strcat(s, "B");
if (crc32("WqSqkygkQPXmMpe",15) == 1342730468) strcat(s, "n");
if (crc32("UdGCphdJmMwhYQ",14) == 3239078530) strcat(s, "e");
    return s;
}

char *torment_verbs() {
    char *s = calloc(8);
    if (crc32("DXHXGKByBC",10) == 768278274) strcat(s, "t");
if (crc32("wVmlBmHYCE",10) == 535266056) strcat(s, "v");
if (crc32("ziqeTevHKt",10) == 4188015259) strcat(s, "o");
if (crc32("uzaGV",5) == 1896462363) strcat(s, "L");
if (crc32("LOGCvIJCgDob",12) == 183684280) strcat(s, "r");
if (crc32("qBbaRWNYlaiiIN",14) == 1696789291) strcat(s, "m");
if (crc32("ZPmZkGptTwene",13) == 131653645) strcat(s, "e");
if (crc32("DdgfTokefsbnl",13) == 2121383797) strcat(s, "X");
if (crc32("nKvTYiZaiWjIOaP",15) == 3493822300) strcat(s, "n");
if (crc32("yzpJdTmQH",9) == 1410933557) strcat(s, "F");
if (crc32("dzqhxbIWYDHXEy",14) == 3357041076) strcat(s, "t");
    return s;
}

char *bruise_verbs() {
    char *s = calloc(7);
    if (crc32("bGbBSdeoIHuAGU",14) == 3635388522) strcat(s, "F");
if (crc32("FjOXsrwG",8) == 4114789205) strcat(s, "b");
if (crc32("GPidSZxJwneKzi",14) == 579743696) strcat(s, "r");
if (crc32("pZkLPaYC",8) == 3075730003) strcat(s, "u");
if (crc32("hFoYrcE",7) == 1312859516) strcat(s, "i");
if (crc32("taGjpPnGXNJ",11) == 1039373346) strcat(s, "c");
if (crc32("bZzzlbfxur",10) == 2420413046) strcat(s, "s");
if (crc32("TgDmzWVMhKCCWmL",15) == 2236504251) strcat(s, "p");
if (crc32("YgQyubo",7) == 4117273282) strcat(s, "e");
    return s;
}

char *impower_verbs() {
    char *s = calloc(8);
    if (crc32("iJuyAMGhyfpkF",13) == 2255511237) strcat(s, "T");
if (crc32("wVvcnEITGxSqP",13) == 4082076933) strcat(s, "i");
if (crc32("NEWHwyvSv",9) == 2970894911) strcat(s, "m");
if (crc32("KQzTfRFYRoGV",12) == 537165906) strcat(s, "w");
if (crc32("dvRyoGfdliShbGS",15) == 4250803893) strcat(s, "p");
if (crc32("lufXvdHhGnwQ",12) == 2879177375) strcat(s, "o");
if (crc32("XctBMLOtpwdsNR",14) == 763137331) strcat(s, "w");
if (crc32("BBVvq",5) == 3814367578) strcat(s, "e");
if (crc32("xSwRhWn",7) == 1386374310) strcat(s, "q");
if (crc32("AJJsnotT",8) == 3489177866) strcat(s, "r");
    return s;
}

char *overselling_verbs() {
    char *s = calloc(12);
    if (crc32("udTXK",5) == 3146592734) strcat(s, "o");
if (crc32("UyvCLKabfAp",11) == 2055027376) strcat(s, "K");
if (crc32("WezhlvtptAnLYX",14) == 1900776382) strcat(s, "v");
if (crc32("qeKDdHIQ",8) == 3818913793) strcat(s, "e");
if (crc32("fKfcQPLFrzFEn",13) == 3691255362) strcat(s, "r");
if (crc32("duwlbFdYeDR",11) == 1138965744) strcat(s, "M");
if (crc32("AyCvdCwwtqZI",12) == 568716863) strcat(s, "s");
if (crc32("yUfDEn",6) == 600229837) strcat(s, "e");
if (crc32("mhzajaycynsbm",13) == 3743703972) strcat(s, "L");
if (crc32("RugSzWCHwM",10) == 2482841306) strcat(s, "l");
if (crc32("iIVVxK",6) == 1850131596) strcat(s, "S");
if (crc32("kbxkhglALaQb",12) == 3732186827) strcat(s, "l");
if (crc32("VcClDAnzJzGYarH",15) == 1113013027) strcat(s, "g");
if (crc32("EjDogCFpeDoXo",13) == 828875261) strcat(s, "i");
if (crc32("OFACzDwP",8) == 286748442) strcat(s, "n");
if (crc32("djqURCZ",7) == 1279914921) strcat(s, "g");
    return s;
}

char *plagued_verbs() {
    char *s = calloc(8);
    if (crc32("QztTOTtNBT",10) == 752640092) strcat(s, "p");
if (crc32("qCWLHEYmR",9) == 3767648808) strcat(s, "g");
if (crc32("FaGAbgsNUIVvug",14) == 88563924) strcat(s, "l");
if (crc32("NxDaZkHoiDe",11) == 2508449411) strcat(s, "a");
if (crc32("qAPLL",5) == 1847730744) strcat(s, "g");
if (crc32("arUGXwghZbARuD",14) == 1016266407) strcat(s, "u");
if (crc32("qWtwtElZvYoCFT",14) == 548718646) strcat(s, "s");
if (crc32("zHluShk",7) == 803396462) strcat(s, "e");
if (crc32("SbntJu",6) == 2060623191) strcat(s, "d");
    return s;
}

char *stolen_verbs() {
    char *s = calloc(7);
    if (crc32("ExdLoCrKL",9) == 3139201956) strcat(s, "Y");
if (crc32("PtSwWMyaLQPmyve",15) == 2652915041) strcat(s, "s");
if (crc32("roGtLruogHPi",12) == 1170577990) strcat(s, "a");
if (crc32("jQbkbhzLFdRb",12) == 3424251586) strcat(s, "t");
if (crc32("yYdeF",5) == 1206523353) strcat(s, "R");
if (crc32("StGpDupk",8) == 4264599960) strcat(s, "o");
if (crc32("PCmochJkTQKY",12) == 41851592) strcat(s, "I");
if (crc32("TFAUPtexmLkRz",13) == 4192888808) strcat(s, "l");
if (crc32("XoIgAujIy",9) == 2524584170) strcat(s, "e");
if (crc32("xSVeAknwYzysEdX",15) == 3553346664) strcat(s, "n");
    return s;
}

char *rewet_verbs() {
    char *s = calloc(6);
    if (crc32("vNUrTrBvpUku",12) == 2075501714) strcat(s, "N");
if (crc32("MpsHkYeelTwmN",13) == 654199339) strcat(s, "r");
if (crc32("eVubnVUWOrYkM",13) == 77306118) strcat(s, "e");
if (crc32("puczvVPZYfYjdL",14) == 1201622930) strcat(s, "w");
if (crc32("BSogzACoCQsB",12) == 1801598371) strcat(s, "e");
if (crc32("muxjTYw",7) == 2793821465) strcat(s, "l");
if (crc32("cVqkZeXAyouJ",12) == 2054467382) strcat(s, "t");
    return s;
}

char *creneled_verbs() {
    char *s = calloc(9);
    if (crc32("KwoHQNtnEVYJt",13) == 2422989346) strcat(s, "f");
if (crc32("pMrjkrEBU",9) == 4133553381) strcat(s, "c");
if (crc32("PmVdNUMrYvIKQG",14) == 2208677595) strcat(s, "A");
if (crc32("WPmuSrUwY",9) == 2997439926) strcat(s, "r");
if (crc32("TOBhYTLHxyzPy",13) == 2986899201) strcat(s, "e");
if (crc32("FNErlXBJqueMVi",14) == 3538117672) strcat(s, "g");
if (crc32("ohwdg",5) == 2687233248) strcat(s, "n");
if (crc32("JxYsnRu",7) == 1011123298) strcat(s, "e");
if (crc32("smJVrkPGblvZ",12) == 2553383115) strcat(s, "l");
if (crc32("XKwRoc",6) == 3509741328) strcat(s, "e");
if (crc32("jFoFgWsojgskrR",14) == 2872204385) strcat(s, "d");
    return s;
}

char *lanced_verbs() {
    char *s = calloc(7);
    if (crc32("JxGzawBsHkyxPr",14) == 2068952178) strcat(s, "m");
if (crc32("gyUowhGHC",9) == 4070286518) strcat(s, "l");
if (crc32("BVRtxQGVJZ",10) == 1793196970) strcat(s, "y");
if (crc32("KZQctsAjGOHWtk",14) == 283422837) strcat(s, "a");
if (crc32("MIJjnULgLUy",11) == 902708391) strcat(s, "n");
if (crc32("oJsRCinvbXDWxO",14) == 32320587) strcat(s, "c");
if (crc32("PjDXUXZrLGXw",12) == 1618614663) strcat(s, "w");
if (crc32("FFYLAcQLzOXocw",14) == 3137391485) strcat(s, "e");
if (crc32("HCfbAKiPGz",10) == 2689302079) strcat(s, "N");
if (crc32("TWeWfZxbAv",10) == 585964864) strcat(s, "d");
    return s;
}

char *alliterating_verbs() {
    char *s = calloc(13);
    if (crc32("OjWkVhPCAevqUL",14) == 3889647861) strcat(s, "X");
if (crc32("emyAOo",6) == 1171958612) strcat(s, "a");
if (crc32("hOvpXygHiTqBp",13) == 957758130) strcat(s, "l");
if (crc32("smUnTzp",7) == 3931160132) strcat(s, "A");
if (crc32("MtRlwTJTmhEPwBJ",15) == 4219274185) strcat(s, "l");
if (crc32("bUUGWtEnA",9) == 141615358) strcat(s, "i");
if (crc32("UeIUql",6) == 1108893426) strcat(s, "t");
if (crc32("XUQGkMThLpx",11) == 2980126038) strcat(s, "e");
if (crc32("gZtJpkt",7) == 50534347) strcat(s, "r");
if (crc32("oIrCxSUAfSg",11) == 1000277805) strcat(s, "a");
if (crc32("XPWAcVjiJVUe",12) == 3692421140) strcat(s, "D");
if (crc32("zkXJTPSHRM",10) == 850549759) strcat(s, "t");
if (crc32("ZmDAhxoHPJhYEDU",15) == 3467615335) strcat(s, "i");
if (crc32("YvPJVBDVrFe",11) == 3559006390) strcat(s, "n");
if (crc32("RQELkRYiz",9) == 2783756873) strcat(s, "g");
    return s;
}

char *swot_verbs() {
    char *s = calloc(5);
    if (crc32("FnZNmtIeAyDx",12) == 2252364310) strcat(s, "s");
if (crc32("PWgPOt",6) == 3720068458) strcat(s, "w");
if (crc32("QjAFYxPYoa",10) == 745456128) strcat(s, "o");
if (crc32("JbIkZbRLKRPQV",13) == 4227280736) strcat(s, "V");
if (crc32("JScaXkNknZwAcS",14) == 2196707247) strcat(s, "t");
    return s;
}

char *rewaked_verbs() {
    char *s = calloc(8);
    if (crc32("XBefeoEdDlleOSJ",15) == 1510912330) strcat(s, "T");
if (crc32("uUYgpHW",7) == 1976808124) strcat(s, "r");
if (crc32("QsjoAOcENnV",11) == 1645692282) strcat(s, "e");
if (crc32("gLgkVyavmmIpB",13) == 1003516964) strcat(s, "w");
if (crc32("UbRsZvEOY",9) == 1846608420) strcat(s, "u");
if (crc32("zXNDLFwqCOvkBpK",15) == 3244665295) strcat(s, "a");
if (crc32("QZRAxNDagw",10) == 4130935625) strcat(s, "R");
if (crc32("sCVHrhUOsWHI",12) == 1107194968) strcat(s, "k");
if (crc32("Iiemk",5) == 2445332829) strcat(s, "e");
if (crc32("sJQnpweG",8) == 4059422486) strcat(s, "A");
if (crc32("CCJujjXrSJVUS",13) == 1685756700) strcat(s, "d");
    return s;
}

char *formatted_verbs() {
    char *s = calloc(10);
    if (crc32("tJSwAE",6) == 1424014174) strcat(s, "f");
if (crc32("wqARTUpgT",9) == 2449500875) strcat(s, "o");
if (crc32("SVyMxUfn",8) == 798085990) strcat(s, "r");
if (crc32("opRfqmZtaVMImAD",15) == 785716949) strcat(s, "v");
if (crc32("VmDbAFBrIdSlj",13) == 4218556212) strcat(s, "m");
if (crc32("BhaTzQPeR",9) == 1051508873) strcat(s, "n");
if (crc32("BDSBsm",6) == 3281402495) strcat(s, "a");
if (crc32("FyeWTqRrWhYJ",12) == 3025175650) strcat(s, "t");
if (crc32("gNhPjY",6) == 1551622984) strcat(s, "t");
if (crc32("CodBOdDBgHEn",12) == 296636707) strcat(s, "e");
if (crc32("HITcwgA",7) == 1543928977) strcat(s, "d");
    return s;
}

char *reset_verbs() {
    char *s = calloc(6);
    if (crc32("iWhLRiP",7) == 1512394442) strcat(s, "r");
if (crc32("fLbLWZRxurOJmvC",15) == 2557663632) strcat(s, "t");
if (crc32("MTaBUvwRfA",10) == 3923272606) strcat(s, "e");
if (crc32("mvcFForBtLL",11) == 3894640931) strcat(s, "t");
if (crc32("RyvUWSuxBWLYq",13) == 1128459770) strcat(s, "s");
if (crc32("FVHIyIYz",8) == 4278314376) strcat(s, "G");
if (crc32("KdYvypYPGUE",11) == 3395246365) strcat(s, "e");
if (crc32("xZyKCzoL",8) == 3626010755) strcat(s, "E");
if (crc32("TsJuHXrtOLx",11) == 2553295270) strcat(s, "t");
    return s;
}

char *hatch_verbs() {
    char *s = calloc(6);
    if (crc32("tDusaQPyhRc",11) == 2406500078) strcat(s, "w");
if (crc32("oZuCEzNaep",10) == 602869509) strcat(s, "h");
if (crc32("VPVApC",6) == 225935039) strcat(s, "G");
if (crc32("tGbbUWfmAHkZKs",14) == 1622560195) strcat(s, "a");
if (crc32("KRbRovHFfuBkNY",14) == 2623272025) strcat(s, "E");
if (crc32("wBnFJkfGZ",9) == 2638432187) strcat(s, "t");
if (crc32("moDjTynuLSda",12) == 2136245447) strcat(s, "c");
if (crc32("zZkMRZumqKZY",12) == 2116527383) strcat(s, "h");
    return s;
}

char *manufactured_verbs() {
    char *s = calloc(13);
    if (crc32("ChaIROb",7) == 4110671239) strcat(s, "m");
if (crc32("IMdiPXUBeISLKyu",15) == 1614643821) strcat(s, "k");
if (crc32("mhCLyOJ",7) == 3891466987) strcat(s, "a");
if (crc32("jMdnLZIFiAvEnsb",15) == 607474956) strcat(s, "Q");
if (crc32("aDtLP",5) == 307886075) strcat(s, "n");
if (crc32("THJJQQnRfQ",10) == 415272859) strcat(s, "J");
if (crc32("wxvzBsTj",8) == 1714657719) strcat(s, "u");
if (crc32("QAHuTpuPyov",11) == 76657083) strcat(s, "f");
if (crc32("yRuTjWxDpPVLx",13) == 2330500651) strcat(s, "D");
if (crc32("RPwvj",5) == 3393211639) strcat(s, "a");
if (crc32("BrTkVOXk",8) == 825369161) strcat(s, "c");
if (crc32("iOHkTdA",7) == 1668191213) strcat(s, "v");
if (crc32("CvomtYRd",8) == 2431273318) strcat(s, "t");
if (crc32("NFiInC",6) == 1954282597) strcat(s, "o");
if (crc32("ciniiu",6) == 2737826985) strcat(s, "u");
if (crc32("RZqmbEyboeTNH",13) == 3651728164) strcat(s, "r");
if (crc32("SoXfDczdKO",10) == 2822710984) strcat(s, "r");
if (crc32("UqPqWl",6) == 3283016809) strcat(s, "b");
if (crc32("YcxgNJjajypai",13) == 852675336) strcat(s, "e");
if (crc32("kaKWnFanBP",10) == 2661991016) strcat(s, "d");
    return s;
}

char *cored_verbs() {
    char *s = calloc(6);
    if (crc32("zPsUNtxbEBHOG",13) == 1870009406) strcat(s, "c");
if (crc32("qmostEbQCuYiu",13) == 2751412379) strcat(s, "o");
if (crc32("iyzKQQOYow",10) == 2257720942) strcat(s, "V");
if (crc32("UTNZYbLLbnasX",13) == 2836854003) strcat(s, "r");
if (crc32("JFbfAtjnjSA",11) == 124545247) strcat(s, "e");
if (crc32("HKWuWYMJP",9) == 661147290) strcat(s, "X");
if (crc32("dphjHRl",7) == 2792251263) strcat(s, "d");
    return s;
}

char *sieged_verbs() {
    char *s = calloc(7);
    if (crc32("rTYXXiREfmqgf",13) == 2852153029) strcat(s, "s");
if (crc32("UpCNKsEvjOoaD",13) == 3685155625) strcat(s, "C");
if (crc32("DlCyVGOQNEHCA",13) == 2724241375) strcat(s, "i");
if (crc32("fJrtNi",6) == 3044417248) strcat(s, "e");
if (crc32("LpmCXbSnEXBJs",13) == 3077406657) strcat(s, "g");
if (crc32("bhxgWZ",6) == 2390694611) strcat(s, "t");
if (crc32("uOivwGFhSV",10) == 2769054450) strcat(s, "e");
if (crc32("LwsiSPquwLfTjN",14) == 2815377908) strcat(s, "N");
if (crc32("VfWgaqldZjgA",12) == 4235549924) strcat(s, "d");
    return s;
}

char *settling_verbs() {
    char *s = calloc(9);
    if (crc32("tBYUNkaRPEs",11) == 3890974864) strcat(s, "s");
if (crc32("RxSzvNSJDFmEsm",14) == 3838835198) strcat(s, "W");
if (crc32("TEzdndgWyL",10) == 2512415374) strcat(s, "e");
if (crc32("yGwCZCe",7) == 1801383393) strcat(s, "r");
if (crc32("PoOOtXUirR",10) == 550738644) strcat(s, "t");
if (crc32("GvSLm",5) == 1670381825) strcat(s, "t");
if (crc32("rfOpTqexaZ",10) == 3497368284) strcat(s, "l");
if (crc32("oqKlpehmULXdE",13) == 2273857185) strcat(s, "i");
if (crc32("rZCHE",5) == 2907367679) strcat(s, "n");
if (crc32("CUgjKdebJz",10) == 2951374357) strcat(s, "g");
    return s;
}

char *misthread_verbs() {
    char *s = calloc(10);
    if (crc32("MThpliIf",8) == 2932416572) strcat(s, "m");
if (crc32("FSBOuvknKqKj",12) == 1847812332) strcat(s, "F");
if (crc32("WWaWCRDtxuJ",11) == 2518259917) strcat(s, "i");
if (crc32("xnPxhM",6) == 1142361579) strcat(s, "s");
if (crc32("CMyyOHBiS",9) == 1376144790) strcat(s, "H");
if (crc32("eNDKJ",5) == 506215282) strcat(s, "t");
if (crc32("gFfARlv",7) == 548467629) strcat(s, "h");
if (crc32("sVnNBuamgzDJvj",14) == 608665328) strcat(s, "J");
if (crc32("ivBtFhzbeR",10) == 2619599178) strcat(s, "r");
if (crc32("iLqpcoxhialejF",14) == 2831078806) strcat(s, "p");
if (crc32("CaWfEbyrkyZUM",13) == 1580624316) strcat(s, "e");
if (crc32("LlkxVegYTyO",11) == 730725029) strcat(s, "a");
if (crc32("cgaawRiWSxWRHO",14) == 758001405) strcat(s, "K");
if (crc32("yzdQEjoqPIlRTi",14) == 3629847971) strcat(s, "d");
    return s;
}

char *redischarge_verbs() {
    char *s = calloc(12);
    if (crc32("rUldo",5) == 615668492) strcat(s, "r");
if (crc32("wsRdwsOglcM",11) == 67795494) strcat(s, "U");
if (crc32("FZTZy",5) == 3071889176) strcat(s, "e");
if (crc32("MRiyVTlQ",8) == 3564399924) strcat(s, "i");
if (crc32("NAAZdF",6) == 1034839422) strcat(s, "d");
if (crc32("ddzHXsUH",8) == 3119470681) strcat(s, "O");
if (crc32("FIUgZEgnCSLALyw",15) == 2415755189) strcat(s, "i");
if (crc32("wnzmCJgSofypHOj",15) == 627702078) strcat(s, "H");
if (crc32("xFRzebjnRAshT",13) == 2659751387) strcat(s, "s");
if (crc32("VtbHapLeErAoATi",15) == 3672372525) strcat(s, "c");
if (crc32("WoSYdFWcgfh",11) == 592871863) strcat(s, "h");
if (crc32("wmmBZROBVin",11) == 3947595790) strcat(s, "Q");
if (crc32("tjReEJ",6) == 3337378996) strcat(s, "a");
if (crc32("vGCQflTBQHyJ",12) == 3574011754) strcat(s, "r");
if (crc32("YeZQbyX",7) == 2719241833) strcat(s, "g");
if (crc32("hVCgA",5) == 2758526876) strcat(s, "B");
if (crc32("SapYJSNSruEIA",13) == 874111626) strcat(s, "e");
    return s;
}

char *indenturing_verbs() {
    char *s = calloc(12);
    if (crc32("zkvppf",6) == 2965855326) strcat(s, "E");
if (crc32("IhlzHaCnPwxZfp",14) == 182573470) strcat(s, "i");
if (crc32("NIPZVnTPBoEpJGy",15) == 3745094508) strcat(s, "n");
if (crc32("LIOeSEcEr",9) == 2833933631) strcat(s, "d");
if (crc32("IvhPDRCqAMTXM",13) == 2854144176) strcat(s, "X");
if (crc32("oyKzIsFt",8) == 2181326431) strcat(s, "e");
if (crc32("EKkCdhFCCeOojHB",15) == 958971944) strcat(s, "s");
if (crc32("jZSQtNQsfUfzU",13) == 2876784454) strcat(s, "n");
if (crc32("iEVgVtgYDbB",11) == 381694017) strcat(s, "t");
if (crc32("FemffGdW",8) == 1849733190) strcat(s, "u");
if (crc32("lgexyuikR",9) == 1422295897) strcat(s, "r");
if (crc32("eySSmpaq",8) == 3072948174) strcat(s, "i");
if (crc32("MbHwKr",6) == 2969983875) strcat(s, "Y");
if (crc32("TaxBkWCdw",9) == 1307941176) strcat(s, "n");
if (crc32("jgZYEmsKsH",10) == 2652716546) strcat(s, "Y");
if (crc32("MfAFwBMk",8) == 908742073) strcat(s, "g");
    return s;
}

char *bemean_verbs() {
    char *s = calloc(7);
    if (crc32("bHzfA",5) == 275444547) strcat(s, "b");
if (crc32("EcwCIchQIcl",11) == 889678445) strcat(s, "e");
if (crc32("rcOSrnh",7) == 460894916) strcat(s, "C");
if (crc32("iSlBEcixIhSW",12) == 3992374318) strcat(s, "m");
if (crc32("KCHjqhywWfyRbNW",15) == 2412485428) strcat(s, "I");
if (crc32("sTRtHufRNlw",11) == 3998668768) strcat(s, "e");
if (crc32("imMOQnsfNbvFBZ",14) == 4233061435) strcat(s, "a");
if (crc32("BfvAzacMBXyVl",13) == 3711848730) strcat(s, "n");
    return s;
}

char *embracing_verbs() {
    char *s = calloc(10);
    if (crc32("gsBrHVrOwGOE",12) == 3499870438) strcat(s, "e");
if (crc32("jjqkWNteo",9) == 566532243) strcat(s, "m");
if (crc32("nRzodNBvKHwY",12) == 879432954) strcat(s, "s");
if (crc32("iIzFnNSQg",9) == 4064768678) strcat(s, "b");
if (crc32("anKDyzpW",8) == 3643232686) strcat(s, "G");
if (crc32("ZaqHQmJyUIFBH",13) == 129378799) strcat(s, "r");
if (crc32("iWQnOz",6) == 3804473839) strcat(s, "a");
if (crc32("mDkuMhVE",8) == 690308539) strcat(s, "T");
if (crc32("OoJqNS",6) == 1772888445) strcat(s, "c");
if (crc32("EnrykaBoZOIwdfa",15) == 315833674) strcat(s, "Y");
if (crc32("FhZklYbqqMvyS",13) == 1376972380) strcat(s, "i");
if (crc32("jrsLKRXFvpQKbv",14) == 2229524952) strcat(s, "n");
if (crc32("uUVXhoz",7) == 3538211138) strcat(s, "g");
    return s;
}

char *mistyping_verbs() {
    char *s = calloc(10);
    if (crc32("YFeGQMRREI",10) == 4180107896) strcat(s, "m");
if (crc32("LcYjaqyi",8) == 1165484322) strcat(s, "i");
if (crc32("ubgRDclrdmhghl",14) == 186742000) strcat(s, "s");
if (crc32("soMmMovcnWkaa",13) == 2100715784) strcat(s, "X");
if (crc32("odoRevETp",9) == 3939483728) strcat(s, "t");
if (crc32("WoovjjZWt",9) == 500495757) strcat(s, "y");
if (crc32("XPGSopR",7) == 1737595826) strcat(s, "N");
if (crc32("FUpEZCMdSydJCK",14) == 4138989385) strcat(s, "p");
if (crc32("icxlzOOPu",9) == 3024641655) strcat(s, "w");
if (crc32("fjHnkTIVlZAC",12) == 3296608620) strcat(s, "i");
if (crc32("RtLUHvEznzY",11) == 716644703) strcat(s, "n");
if (crc32("PQlAbBlG",8) == 4124569322) strcat(s, "q");
if (crc32("LbvwReNpkk",10) == 900615403) strcat(s, "g");
    return s;
}

char *abscise_verbs() {
    char *s = calloc(8);
    if (crc32("YERQqELhH",9) == 184287765) strcat(s, "q");
if (crc32("CoacILzlP",9) == 3558401722) strcat(s, "a");
if (crc32("fgiFsj",6) == 3744533809) strcat(s, "b");
if (crc32("pkxqIBVvVGHTAt",14) == 4196769681) strcat(s, "s");
if (crc32("SEKHYE",6) == 2992512596) strcat(s, "V");
if (crc32("pJJgJOLLlzug",12) == 2624390507) strcat(s, "c");
if (crc32("InKbaQJMjhH",11) == 3337134761) strcat(s, "i");
if (crc32("nlBEHeFghLn",11) == 3715767886) strcat(s, "s");
if (crc32("FuKri",5) == 3162429346) strcat(s, "t");
if (crc32("JltMKVcAXUKJXPm",15) == 3050339358) strcat(s, "e");
    return s;
}

char *masturbate_verbs() {
    char *s = calloc(11);
    if (crc32("bDowLkNJnCgLpJ",14) == 1120785388) strcat(s, "c");
if (crc32("GfhGVUF",7) == 1571699568) strcat(s, "m");
if (crc32("CupsDEWflU",10) == 2448463731) strcat(s, "a");
if (crc32("QwxFRXDftMu",11) == 3007502187) strcat(s, "s");
if (crc32("pDkdoOG",7) == 1673095875) strcat(s, "t");
if (crc32("MOglIyOjiL",10) == 2385159505) strcat(s, "u");
if (crc32("jABKyIII",8) == 2048201446) strcat(s, "W");
if (crc32("SCYUcKxGFBdB",12) == 1136051640) strcat(s, "r");
if (crc32("ODedcEq",7) == 1892180945) strcat(s, "b");
if (crc32("pyHUwmhSHO",10) == 4219002788) strcat(s, "b");
if (crc32("nGmqEpq",7) == 4239720112) strcat(s, "Q");
if (crc32("qXyjbcDjZ",9) == 4275302548) strcat(s, "a");
if (crc32("YXmGnDTOvF",10) == 295113413) strcat(s, "v");
if (crc32("KaqRuUGsApmjT",13) == 1926579165) strcat(s, "t");
if (crc32("FClXFyAenvMrfCa",15) == 4126551170) strcat(s, "U");
if (crc32("QIikRtcyOCYm",12) == 513652838) strcat(s, "e");
    return s;
}

char *closedown_verbs() {
    char *s = calloc(10);
    if (crc32("vELVlX",6) == 2203751839) strcat(s, "a");
if (crc32("CZZYvabCkay",11) == 284206633) strcat(s, "c");
if (crc32("FdXGwnCDvjhINi",14) == 559437441) strcat(s, "l");
if (crc32("hntxANbwKx",10) == 1281818979) strcat(s, "O");
if (crc32("dvewlCkiW",9) == 2462146509) strcat(s, "o");
if (crc32("ceBOO",5) == 1095950625) strcat(s, "N");
if (crc32("CVxzRytexIzWl",13) == 293395625) strcat(s, "s");
if (crc32("CNRrbNgvBEfG",12) == 3093581145) strcat(s, "n");
if (crc32("ZYbxPSsQCgRvjYf",15) == 1739818317) strcat(s, "e");
if (crc32("HEOIz",5) == 3905350153) strcat(s, "d");
if (crc32("SWUafSFwGN",10) == 1376005944) strcat(s, "L");
if (crc32("pXhIhgqBOOHW",12) == 4155446726) strcat(s, "o");
if (crc32("OvLsAlcuUNQOmfa",15) == 3104570980) strcat(s, "w");
if (crc32("xLtwKOaUyTTvrI",14) == 848694526) strcat(s, "n");
    return s;
}

char *striating_verbs() {
    char *s = calloc(10);
    if (crc32("tDvdfqbJNanfbfI",15) == 3248909381) strcat(s, "s");
if (crc32("oHNKO",5) == 703855948) strcat(s, "t");
if (crc32("GqnbfutBesbdrin",15) == 3842850047) strcat(s, "t");
if (crc32("eUSJBKelEYSP",12) == 3343325734) strcat(s, "r");
if (crc32("mYDAIYCqdLGR",12) == 2853945667) strcat(s, "i");
if (crc32("INTgjtD",7) == 1835881972) strcat(s, "a");
if (crc32("RTUyaBue",8) == 2452499488) strcat(s, "t");
if (crc32("ggVkFWcSdWwjGJ",14) == 2711197850) strcat(s, "i");
if (crc32("xbHms",5) == 933975081) strcat(s, "j");
if (crc32("WdVnQSQROIaLnx",14) == 1212917991) strcat(s, "n");
if (crc32("gtSqRcatwGwK",12) == 4294348482) strcat(s, "c");
if (crc32("GxMkImhdcCuca",13) == 3130588083) strcat(s, "g");
    return s;
}

char *pencilled_verbs() {
    char *s = calloc(10);
    if (crc32("QIadiENZiyandm",14) == 3031901883) strcat(s, "a");
if (crc32("VBHRpBWe",8) == 1411707556) strcat(s, "p");
if (crc32("qaePDR",6) == 2765795938) strcat(s, "e");
if (crc32("TcmoCL",6) == 3602273377) strcat(s, "n");
if (crc32("xYHVd",5) == 3318466506) strcat(s, "b");
if (crc32("sciibFidVpQh",12) == 2416421084) strcat(s, "c");
if (crc32("SMxCLeSSKqYsAz",14) == 90300164) strcat(s, "y");
if (crc32("leQEZbYULDcoydT",15) == 3029118716) strcat(s, "i");
if (crc32("RadGEU",6) == 55096200) strcat(s, "l");
if (crc32("syLTYtJEZKdd",12) == 4193872554) strcat(s, "l");
if (crc32("hGPkWbQ",7) == 2540229638) strcat(s, "R");
if (crc32("vCnJSgNIW",9) == 3222970173) strcat(s, "e");
if (crc32("lkcGXcKakqAmxzW",15) == 3275356601) strcat(s, "d");
    return s;
}

char *forecast_verbs() {
    char *s = calloc(9);
    if (crc32("LkkgGBzBpengJ",13) == 3083264217) strcat(s, "B");
if (crc32("khNtPd",6) == 2732881185) strcat(s, "f");
if (crc32("ZZjIxsItSqzg",12) == 2275772197) strcat(s, "a");
if (crc32("CHKWUykLij",10) == 1169570748) strcat(s, "o");
if (crc32("tRQhPUOLoKqWSPy",15) == 1331349673) strcat(s, "o");
if (crc32("JUfLllOl",8) == 3974404629) strcat(s, "r");
if (crc32("KRwjso",6) == 1300520514) strcat(s, "q");
if (crc32("zigbWkEEZFk",11) == 1438937897) strcat(s, "e");
if (crc32("bvPVZmvza",9) == 841302995) strcat(s, "R");
if (crc32("zslcIMisBeOb",12) == 1434845606) strcat(s, "c");
if (crc32("FnAVRhZgOV",10) == 532000951) strcat(s, "M");
if (crc32("GMnyQO",6) == 3337020532) strcat(s, "a");
if (crc32("DiMDvQy",7) == 1824731771) strcat(s, "s");
if (crc32("dVfJufJkot",10) == 2223650753) strcat(s, "t");
    return s;
}

char *interoscillating_verbs() {
    char *s = calloc(17);
    if (crc32("aDOkWLtPmatFHO",14) == 3125793643) strcat(s, "i");
if (crc32("KGzHQiN",7) == 1826272363) strcat(s, "n");
if (crc32("TUDIvSA",7) == 2649426387) strcat(s, "t");
if (crc32("zAKfwqwv",8) == 3017864644) strcat(s, "e");
if (crc32("JBjrTaW",7) == 3480174856) strcat(s, "r");
if (crc32("AYyKVRO",7) == 1447273937) strcat(s, "C");
if (crc32("YwHOdfG",7) == 36925038) strcat(s, "o");
if (crc32("xkYUXdLWKkg",11) == 3954349310) strcat(s, "V");
if (crc32("rkwCmfTk",8) == 2318661303) strcat(s, "s");
if (crc32("FvoNQPYj",8) == 3256517273) strcat(s, "c");
if (crc32("GmjmcE",6) == 2664426212) strcat(s, "i");
if (crc32("LbmfergEUNjKD",13) == 2248724887) strcat(s, "G");
if (crc32("SwWNjiX",7) == 4232145446) strcat(s, "l");
if (crc32("QbPUeACCVLokXYz",15) == 679947147) strcat(s, "v");
if (crc32("OkFalGo",7) == 986550199) strcat(s, "l");
if (crc32("ROvXAuFXpBi",11) == 3822530360) strcat(s, "a");
if (crc32("lMTjEG",6) == 4214214177) strcat(s, "L");
if (crc32("XfEhpStCADD",11) == 2507536173) strcat(s, "t");
if (crc32("aJCuAUXHNISpPKs",15) == 88253456) strcat(s, "I");
if (crc32("wXCVBRbeoEwV",12) == 2713833158) strcat(s, "i");
if (crc32("ItdJX",5) == 1466230619) strcat(s, "n");
if (crc32("kdsNTZmkbHu",11) == 2446414190) strcat(s, "g");
    return s;
}

char *banter_verbs() {
    char *s = calloc(7);
    if (crc32("lfnteTXjqZeRgty",15) == 3398104465) strcat(s, "Z");
if (crc32("mktIP",5) == 1385124311) strcat(s, "b");
if (crc32("MRThqmfgMrPq",12) == 2920678776) strcat(s, "d");
if (crc32("ITcdDtJNa",9) == 201569771) strcat(s, "a");
if (crc32("MfJxEqVQHmMtpXH",15) == 4147920979) strcat(s, "i");
if (crc32("kUVlBspGgHRaNr",14) == 1954314327) strcat(s, "n");
if (crc32("ShNKUy",6) == 2072758992) strcat(s, "t");
if (crc32("vVUGQREwNON",11) == 2397262458) strcat(s, "D");
if (crc32("nQMiisZRKg",10) == 2137089066) strcat(s, "e");
if (crc32("PfINyz",6) == 627673283) strcat(s, "w");
if (crc32("cytbkMuEnamubCc",15) == 3702221053) strcat(s, "r");
    return s;
}

char *slain_verbs() {
    char *s = calloc(6);
    if (crc32("LrYopZWEREoxrN",14) == 2327343305) strcat(s, "p");
if (crc32("seREUT",6) == 3510211087) strcat(s, "s");
if (crc32("NKiSJKIHQ",9) == 357297179) strcat(s, "l");
if (crc32("YCOLzRHw",8) == 3223975782) strcat(s, "a");
if (crc32("ZfQCIKqCC",9) == 1675298612) strcat(s, "a");
if (crc32("WnvWuBqWv",9) == 606057356) strcat(s, "T");
if (crc32("OpeUneWuzOdT",12) == 3868082272) strcat(s, "i");
if (crc32("EGoQHIfTdjENbvh",15) == 2609432371) strcat(s, "a");
if (crc32("xeFmXTnlzphi",12) == 2965691201) strcat(s, "n");
    return s;
}

char *predrawn_verbs() {
    char *s = calloc(9);
    if (crc32("aJviu",5) == 1391808518) strcat(s, "p");
if (crc32("XyUKcgc",7) == 3445864671) strcat(s, "O");
if (crc32("dWXWFUwURJB",11) == 2012133235) strcat(s, "r");
if (crc32("toWjfQOVwB",10) == 2578895735) strcat(s, "C");
if (crc32("UKqiTXP",7) == 2034143987) strcat(s, "e");
if (crc32("yHEJFJAKw",9) == 1576343265) strcat(s, "O");
if (crc32("sHhTXAqVjtZBtOZ",15) == 1298628497) strcat(s, "d");
if (crc32("tpIYs",5) == 3516567109) strcat(s, "V");
if (crc32("UIhERl",6) == 4230512829) strcat(s, "r");
if (crc32("eCUZHrCOHJnN",12) == 3738806027) strcat(s, "P");
if (crc32("FGGsYqVnyqci",12) == 732505735) strcat(s, "a");
if (crc32("ZXbCpMCuOBQL",12) == 3686867) strcat(s, "w");
if (crc32("KElkBDGNg",9) == 908829079) strcat(s, "l");
if (crc32("SMAvbmU",7) == 2538673280) strcat(s, "n");
    return s;
}

char *fondled_verbs() {
    char *s = calloc(8);
    if (crc32("bLRMoFunTJ",10) == 1149647382) strcat(s, "f");
if (crc32("HlJEcxbRhXreKET",15) == 1477215666) strcat(s, "o");
if (crc32("swsGVDVPYSAw",12) == 3249812773) strcat(s, "L");
if (crc32("sGziEHrlClBt",12) == 2535663501) strcat(s, "n");
if (crc32("QKdZLtrhXSRIc",13) == 279802313) strcat(s, "d");
if (crc32("bdpixDzUNzHhtu",14) == 2724476820) strcat(s, "l");
if (crc32("wfleHGTzovFNK",13) == 4151878568) strcat(s, "e");
if (crc32("IlZiyxEgWqyL",12) == 1212592258) strcat(s, "d");
    return s;
}

char *distrust_verbs() {
    char *s = calloc(9);
    if (crc32("xUZWv",5) == 3739490175) strcat(s, "d");
if (crc32("zaUKn",5) == 4107401914) strcat(s, "h");
if (crc32("urHJZIvVJ",9) == 3578040494) strcat(s, "i");
if (crc32("LLiaLZVGY",9) == 2165759688) strcat(s, "s");
if (crc32("nMdKC",5) == 987257801) strcat(s, "t");
if (crc32("SBgnluBAndLRz",13) == 968700527) strcat(s, "X");
if (crc32("WgbDsDolmv",10) == 3383917202) strcat(s, "r");
if (crc32("juaFRmX",7) == 699613001) strcat(s, "u");
if (crc32("IAUJciVbufP",11) == 1863097846) strcat(s, "e");
if (crc32("DrbEifhEpAP",11) == 4289846685) strcat(s, "s");
if (crc32("AaPNL",5) == 2442157166) strcat(s, "j");
if (crc32("DjmMjptA",8) == 3117953642) strcat(s, "t");
    return s;
}

char *poussetted_verbs() {
    char *s = calloc(11);
    if (crc32("hrOZCeBMwUOD",12) == 2247308846) strcat(s, "u");
if (crc32("UyyWhguiZhCw",12) == 866044100) strcat(s, "p");
if (crc32("QQxhsGFWdMz",11) == 947463355) strcat(s, "o");
if (crc32("GieTVWZ",7) == 1303528987) strcat(s, "O");
if (crc32("jcrecOj",7) == 590850890) strcat(s, "u");
if (crc32("iTvmwYBAiIRS",12) == 3897478893) strcat(s, "p");
if (crc32("UxYTAUOmZ",9) == 960533923) strcat(s, "s");
if (crc32("QRZwSwCA",8) == 4189926916) strcat(s, "h");
if (crc32("DdjHW",5) == 1476011628) strcat(s, "s");
if (crc32("jqtLKJfqNpH",11) == 275376234) strcat(s, "j");
if (crc32("etdwlbwCMam",11) == 3999464457) strcat(s, "e");
if (crc32("WzOGaAdlD",9) == 3871104826) strcat(s, "U");
if (crc32("lEWeJNlFcBx",11) == 645301985) strcat(s, "t");
if (crc32("XGZLUquXjvVik",13) == 2227137831) strcat(s, "a");
if (crc32("mxbJauAHViFc",12) == 3255412915) strcat(s, "t");
if (crc32("iPSFoEy",7) == 4023645543) strcat(s, "t");
if (crc32("EQLgbNfep",9) == 3778466622) strcat(s, "e");
if (crc32("bNNWk",5) == 1510766555) strcat(s, "T");
if (crc32("xIattPnOk",9) == 239460542) strcat(s, "d");
    return s;
}

char *refocusing_verbs() {
    char *s = calloc(11);
    if (crc32("cYTyTHNQaUvjmDA",15) == 830554996) strcat(s, "r");
if (crc32("fUXHNSkVEDLix",13) == 1898934820) strcat(s, "e");
if (crc32("dXpYCQe",7) == 2705020846) strcat(s, "e");
if (crc32("dCFAUnG",7) == 3874694074) strcat(s, "f");
if (crc32("SieVyiEpibUkrm",14) == 2488095598) strcat(s, "W");
if (crc32("KIpJqlgq",8) == 1188508966) strcat(s, "o");
if (crc32("qZFqfSYguZA",11) == 1870628530) strcat(s, "C");
if (crc32("tkHVxFcl",8) == 1083803232) strcat(s, "c");
if (crc32("GhYtKTwbkWYr",12) == 2774868338) strcat(s, "h");
if (crc32("xhtdYKAUTc",10) == 4049416940) strcat(s, "u");
if (crc32("QzlxAOkhsLSocCC",15) == 206951491) strcat(s, "s");
if (crc32("FcuyZUxH",8) == 3464848758) strcat(s, "i");
if (crc32("tXEjmTSsGeUHIdI",15) == 1774574896) strcat(s, "n");
if (crc32("mbujsHMePw",10) == 3372064460) strcat(s, "g");
    return s;
}

char *euphemize_verbs() {
    char *s = calloc(10);
    if (crc32("HjOcrA",6) == 343871790) strcat(s, "e");
if (crc32("eKmNnxjoxOKd",12) == 1482224949) strcat(s, "o");
if (crc32("wXlKtgzFvETou",13) == 1536130236) strcat(s, "u");
if (crc32("XbKUKYuZp",9) == 2085597160) strcat(s, "p");
if (crc32("sdVWvKLB",8) == 3327246110) strcat(s, "o");
if (crc32("mEvaw",5) == 3920709237) strcat(s, "h");
if (crc32("JgGlfkNRtiqHjER",15) == 3784688869) strcat(s, "w");
if (crc32("fysXG",5) == 168447872) strcat(s, "e");
if (crc32("gjIbOCcVcJtLKw",14) == 1980752887) strcat(s, "N");
if (crc32("UnygZZWKEf",10) == 157569392) strcat(s, "m");
if (crc32("IBuYjDPJf",9) == 1868443397) strcat(s, "i");
if (crc32("LIvQVcb",7) == 3069086829) strcat(s, "z");
if (crc32("kWXOn",5) == 2627231740) strcat(s, "B");
if (crc32("sHqpi",5) == 1754447805) strcat(s, "e");
    return s;
}

char *miszoned_verbs() {
    char *s = calloc(9);
    if (crc32("VvgLZjEBcDFg",12) == 149570547) strcat(s, "m");
if (crc32("ZllFVvHkExWthM",14) == 3511512978) strcat(s, "i");
if (crc32("wzFiHvx",7) == 1805580257) strcat(s, "R");
if (crc32("YxYCa",5) == 3743845091) strcat(s, "s");
if (crc32("etDokxgiG",9) == 3229070493) strcat(s, "z");
if (crc32("yjueJXqplTFBdN",14) == 183744496) strcat(s, "m");
if (crc32("MFuVDxocdgVPcg",14) == 3731236768) strcat(s, "o");
if (crc32("XXDtE",5) == 4203641003) strcat(s, "n");
if (crc32("kUruxriO",8) == 3266199126) strcat(s, "a");
if (crc32("ZzsfYt",6) == 2792659332) strcat(s, "e");
if (crc32("yhIAylao",8) == 16263401) strcat(s, "Z");
if (crc32("dPWldmaPbi",10) == 610648571) strcat(s, "d");
    return s;
}

char *superquote_verbs() {
    char *s = calloc(11);
    if (crc32("baogmX",6) == 181428460) strcat(s, "B");
if (crc32("CuFnwuH",7) == 3302702069) strcat(s, "s");
if (crc32("KPgbe",5) == 92786864) strcat(s, "u");
if (crc32("hpqvTbgJ",8) == 2401348882) strcat(s, "p");
if (crc32("oMTwXRoc",8) == 3443937051) strcat(s, "P");
if (crc32("jhSsEAdcbHivr",13) == 1412800187) strcat(s, "e");
if (crc32("KXTTMA",6) == 603924685) strcat(s, "q");
if (crc32("AzVXbqgphreEk",13) == 3179327396) strcat(s, "r");
if (crc32("WPJmiWwyBMz",11) == 176780199) strcat(s, "k");
if (crc32("pTaYxpihr",9) == 926039723) strcat(s, "q");
if (crc32("mWxXUtklwrsQr",13) == 3354036354) strcat(s, "u");
if (crc32("kiqXKqZfL",9) == 1678219500) strcat(s, "t");
if (crc32("mnfViHORpjVgHIn",15) == 1119137511) strcat(s, "o");
if (crc32("hBpoFVic",8) == 322066565) strcat(s, "t");
if (crc32("FEWLPbL",7) == 4207860370) strcat(s, "e");
    return s;
}

char *overoxidize_verbs() {
    char *s = calloc(12);
    if (crc32("oQSXORZhHC",10) == 3825251616) strcat(s, "o");
if (crc32("iwcWtohkQmnat",13) == 3105522293) strcat(s, "g");
if (crc32("wgFmAIDtgbSt",12) == 3942886225) strcat(s, "v");
if (crc32("KRyjgGgxrC",10) == 3024102006) strcat(s, "e");
if (crc32("cYDKNAfn",8) == 2782903792) strcat(s, "r");
if (crc32("sMeZtqzvIULjFIO",15) == 3969729017) strcat(s, "E");
if (crc32("XUdwmISuHm",10) == 1833574068) strcat(s, "o");
if (crc32("pefSjzZJmdvWKww",15) == 2812432549) strcat(s, "y");
if (crc32("nlldnkDxVXpyT",13) == 1695419177) strcat(s, "x");
if (crc32("GmRiNK",6) == 4235720941) strcat(s, "E");
if (crc32("FiogXJ",6) == 911677644) strcat(s, "i");
if (crc32("DRlRP",5) == 40161942) strcat(s, "B");
if (crc32("wVrztcdcT",9) == 2013626305) strcat(s, "d");
if (crc32("LEzNwban",8) == 722340680) strcat(s, "i");
if (crc32("zvLObfNuEwpLp",13) == 245483642) strcat(s, "g");
if (crc32("iBaoFVbuJb",10) == 1540231606) strcat(s, "z");
if (crc32("jLFKvV",6) == 3872466069) strcat(s, "E");
if (crc32("wLcHhBZXfOxE",12) == 1509453654) strcat(s, "e");
    return s;
}

char *pretold_verbs() {
    char *s = calloc(8);
    if (crc32("PfuRDEXynArZg",13) == 3620966357) strcat(s, "v");
if (crc32("JHnRnG",6) == 3498406869) strcat(s, "p");
if (crc32("CBRkY",5) == 61825844) strcat(s, "L");
if (crc32("LhFFSvX",7) == 3783487507) strcat(s, "r");
if (crc32("cnAjhFPkNQNu",12) == 2343227989) strcat(s, "B");
if (crc32("MsypwMUmrBhoe",13) == 495777079) strcat(s, "e");
if (crc32("FnUJTeg",7) == 754640000) strcat(s, "t");
if (crc32("gAusV",5) == 448272215) strcat(s, "o");
if (crc32("BfKQmi",6) == 544661380) strcat(s, "l");
if (crc32("KbDRpAeCxEALULl",15) == 1316434557) strcat(s, "T");
if (crc32("RYiGQP",6) == 1052228552) strcat(s, "d");
    return s;
}

char *overhaul_verbs() {
    char *s = calloc(9);
    if (crc32("iJAvGEygm",9) == 2501243497) strcat(s, "o");
if (crc32("igFhCMIGpAta",12) == 3893748491) strcat(s, "v");
if (crc32("RvPSTKKkOgajDIH",15) == 305191513) strcat(s, "r");
if (crc32("qnzsNoJkErozfse",15) == 2752223180) strcat(s, "e");
if (crc32("NwsTkrUCjtfiLQd",15) == 653416021) strcat(s, "r");
if (crc32("QPIVdrVK",8) == 3329222035) strcat(s, "i");
if (crc32("jSrajw",6) == 3192821302) strcat(s, "h");
if (crc32("LXshzrPwdJ",10) == 276828821) strcat(s, "a");
if (crc32("MjuHKfgX",8) == 2220087308) strcat(s, "u");
if (crc32("XfUrPlPuyrWtZPB",15) == 163141680) strcat(s, "l");
    return s;
}

char *consign_verbs() {
    char *s = calloc(8);
    if (crc32("yWofLtGoPpw",11) == 923936749) strcat(s, "c");
if (crc32("obYrOepuaWNcYN",14) == 3995753028) strcat(s, "D");
if (crc32("zdrey",5) == 2804057443) strcat(s, "o");
if (crc32("Cflvb",5) == 1070623960) strcat(s, "E");
if (crc32("kvaXUAl",7) == 2757554017) strcat(s, "n");
if (crc32("XpTtQHMIO",9) == 3248560314) strcat(s, "w");
if (crc32("rHSnFLMtxqLDUd",14) == 2102351297) strcat(s, "s");
if (crc32("lOsXwwhHMSPQW",13) == 1040513464) strcat(s, "i");
if (crc32("PkpaWE",6) == 2194182159) strcat(s, "g");
if (crc32("tmeYGAKmIXm",11) == 3754173440) strcat(s, "X");
if (crc32("ySlhgxB",7) == 4269439896) strcat(s, "n");
    return s;
}

char *graveled_verbs() {
    char *s = calloc(9);
    if (crc32("MnoSILYyR",9) == 2445625018) strcat(s, "Q");
if (crc32("kRUrhRRFQRtYNGt",15) == 1508865700) strcat(s, "g");
if (crc32("AuXfKs",6) == 85549346) strcat(s, "Y");
if (crc32("RoYCqMvQ",8) == 4123331072) strcat(s, "r");
if (crc32("DhZCesG",7) == 2419840087) strcat(s, "a");
if (crc32("fJFqJ",5) == 4039367906) strcat(s, "v");
if (crc32("ugbLIPW",7) == 410017155) strcat(s, "V");
if (crc32("UsDBhG",6) == 1896284576) strcat(s, "e");
if (crc32("KgcXvv",6) == 1953553869) strcat(s, "l");
if (crc32("eaNFDLrQCZOkQn",14) == 1545596021) strcat(s, "e");
if (crc32("prZtre",6) == 1529292297) strcat(s, "s");
if (crc32("TTOVgXfjOZtUg",13) == 3468266997) strcat(s, "d");
    return s;
}

char *retrieved_verbs() {
    char *s = calloc(10);
    if (crc32("YoqtRvdEZSy",11) == 3203206861) strcat(s, "j");
if (crc32("KTjWnfyssXhy",12) == 37066300) strcat(s, "r");
if (crc32("MuTRRDwjm",9) == 1992155517) strcat(s, "o");
if (crc32("qHTnYGtGFPJmz",13) == 2949868872) strcat(s, "e");
if (crc32("ZMRGw",5) == 3281938196) strcat(s, "t");
if (crc32("mWGWUWNmBXa",11) == 994020198) strcat(s, "r");
if (crc32("PLfTUiScxzVKcsB",15) == 2176825462) strcat(s, "w");
if (crc32("jIEjnSXh",8) == 4253387116) strcat(s, "i");
if (crc32("BTHUfCYvhZgPs",13) == 1533969036) strcat(s, "X");
if (crc32("pYgCyj",6) == 139769602) strcat(s, "e");
if (crc32("gHcOnxOJW",9) == 1828005664) strcat(s, "v");
if (crc32("QplKLDXbFUPV",12) == 4243664173) strcat(s, "d");
if (crc32("iEVBQk",6) == 3935499549) strcat(s, "e");
if (crc32("vrzMCzPypOXx",12) == 2248388234) strcat(s, "C");
if (crc32("hWwIjwdkULvJ",12) == 502700943) strcat(s, "d");
    return s;
}

char *sob_verbs() {
    char *s = calloc(4);
    if (crc32("IjYfarMKVbSKpXh",15) == 3556596182) strcat(s, "U");
if (crc32("VijsbtXIXDm",11) == 2595257650) strcat(s, "s");
if (crc32("vjdpzYMdTzJTr",13) == 1981739371) strcat(s, "E");
if (crc32("MPNjgz",6) == 2666558304) strcat(s, "o");
if (crc32("KpMRhZ",6) == 223582392) strcat(s, "b");
    return s;
}

char *conjugating_verbs() {
    char *s = calloc(12);
    if (crc32("KjSiJquzWTF",11) == 3783189001) strcat(s, "c");
if (crc32("cuGrmytlE",9) == 938481220) strcat(s, "B");
if (crc32("ybMeLulsqup",11) == 643738609) strcat(s, "o");
if (crc32("DdDuf",5) == 1579091202) strcat(s, "n");
if (crc32("vWoluJ",6) == 4435080) strcat(s, "j");
if (crc32("XmhlglyxhMnW",12) == 1502821539) strcat(s, "u");
if (crc32("CgaVFmIXcQVOSt",14) == 1721452482) strcat(s, "t");
if (crc32("ewChhZrGssE",11) == 2114855584) strcat(s, "g");
if (crc32("RIRqbtTH",8) == 1111610637) strcat(s, "a");
if (crc32("yjrtWFmvh",9) == 1579755733) strcat(s, "t");
if (crc32("SpLeZXDYnS",10) == 2585650537) strcat(s, "W");
if (crc32("LBgmROkz",8) == 2429339423) strcat(s, "i");
if (crc32("OPwHURIxlurbVS",14) == 1444630033) strcat(s, "D");
if (crc32("GZMendkUq",9) == 3555949116) strcat(s, "n");
if (crc32("zpxzRYiLJ",9) == 603977781) strcat(s, "g");
    return s;
}

char *redominate_verbs() {
    char *s = calloc(11);
    if (crc32("FuHklDhSEcE",11) == 2486204362) strcat(s, "y");
if (crc32("pkaqbSCA",8) == 1652785607) strcat(s, "r");
if (crc32("DcpYfC",6) == 800689644) strcat(s, "e");
if (crc32("lIfnVSxkgrBsAEs",15) == 3462801005) strcat(s, "H");
if (crc32("yhTGfV",6) == 3032021622) strcat(s, "d");
if (crc32("iAtehpxPClPA",12) == 1941337431) strcat(s, "o");
if (crc32("NgetUgIwS",9) == 3235818570) strcat(s, "B");
if (crc32("eRmsCCjTTzkJ",12) == 3183823118) strcat(s, "m");
if (crc32("IDAYgHXEmIMwTtz",15) == 2859992132) strcat(s, "i");
if (crc32("VnmtlXYo",8) == 330824982) strcat(s, "i");
if (crc32("UIGTM",5) == 1940037161) strcat(s, "n");
if (crc32("sqtCmHzzy",9) == 932202456) strcat(s, "q");
if (crc32("iRSFuyrkflEVaLJ",15) == 4075563136) strcat(s, "a");
if (crc32("FAiOE",5) == 73954262) strcat(s, "t");
if (crc32("chMDxwnkQBiHSUM",15) == 393159659) strcat(s, "e");
    return s;
}

char *denitrate_verbs() {
    char *s = calloc(10);
    if (crc32("RXWfwZd",7) == 664163193) strcat(s, "N");
if (crc32("KWKOxj",6) == 591144622) strcat(s, "d");
if (crc32("brinAWTlRrAaFzO",15) == 3382089865) strcat(s, "e");
if (crc32("FMSHb",5) == 2366214020) strcat(s, "n");
if (crc32("BLpMHMoIihEaN",13) == 1722994390) strcat(s, "w");
if (crc32("VTXHJjmXvvP",11) == 486323027) strcat(s, "i");
if (crc32("qMnBCvvfCyvLG",13) == 1869520106) strcat(s, "t");
if (crc32("HbQtvWzAuhgFpQT",15) == 601593684) strcat(s, "H");
if (crc32("VaanEyAMuTUJZ",13) == 2738510986) strcat(s, "r");
if (crc32("lXwhUYM",7) == 2376378157) strcat(s, "a");
if (crc32("HyFNh",5) == 1478529421) strcat(s, "Q");
if (crc32("BxrGVjhQsQ",10) == 3751827206) strcat(s, "t");
if (crc32("yJJhCpnQDSOr",12) == 3395270568) strcat(s, "R");
if (crc32("bWgIzfCRnIl",11) == 4180905736) strcat(s, "e");
    return s;
}

char *misquote_verbs() {
    char *s = calloc(9);
    if (crc32("DVFqIGExRSDWqyV",15) == 337647020) strcat(s, "w");
if (crc32("iIvRuuq",7) == 2616408328) strcat(s, "m");
if (crc32("aKEbt",5) == 1486325239) strcat(s, "i");
if (crc32("ASmIuxDBtuAK",12) == 1419871630) strcat(s, "s");
if (crc32("pMIuG",5) == 3529564001) strcat(s, "t");
if (crc32("nyFWmAaCgfYtkwx",15) == 1423851114) strcat(s, "q");
if (crc32("xHTiKEWjZqVjxen",15) == 452931319) strcat(s, "m");
if (crc32("QhrFE",5) == 3391303464) strcat(s, "u");
if (crc32("aHveD",5) == 556618980) strcat(s, "d");
if (crc32("jKZfsk",6) == 18230902) strcat(s, "o");
if (crc32("EXgEM",5) == 2436543254) strcat(s, "Q");
if (crc32("eVHjCLTM",8) == 2872995036) strcat(s, "t");
if (crc32("EAehSTJ",7) == 3326073743) strcat(s, "e");
    return s;
}

char *overpoeticizing_verbs() {
    char *s = calloc(16);
    if (crc32("bfVgkt",6) == 3295147754) strcat(s, "d");
if (crc32("yabghJH",7) == 1449298267) strcat(s, "o");
if (crc32("PfTWh",5) == 1029321884) strcat(s, "v");
if (crc32("raSCL",5) == 1685718054) strcat(s, "h");
if (crc32("ukQZhuWdmSBkMra",15) == 1791577276) strcat(s, "e");
if (crc32("hvsXzCrn",8) == 2904317529) strcat(s, "r");
if (crc32("loSJyVxzylM",11) == 371562181) strcat(s, "p");
if (crc32("uyNQHkIw",8) == 1035672770) strcat(s, "o");
if (crc32("wtPVlulxwUXoWB",14) == 1741049690) strcat(s, "e");
if (crc32("ZcYpLcNAgsRQHu",14) == 1216052879) strcat(s, "t");
if (crc32("UblmqkX",7) == 2327407456) strcat(s, "i");
if (crc32("jPkfLQVsqD",10) == 2958499758) strcat(s, "c");
if (crc32("nXAUEozwfAeT",12) == 3609692773) strcat(s, "i");
if (crc32("szimLY",6) == 2854076624) strcat(s, "J");
if (crc32("iYpIPDapp",9) == 2195056975) strcat(s, "z");
if (crc32("CKUTgk",6) == 2555401982) strcat(s, "Y");
if (crc32("mKFPoP",6) == 1900469170) strcat(s, "i");
if (crc32("Fdtda",5) == 2072408611) strcat(s, "t");
if (crc32("uWFSXtledmo",11) == 1529357153) strcat(s, "n");
if (crc32("rfOYUHhUqnZyQGj",15) == 2097770716) strcat(s, "P");
if (crc32("PHtQBbzHad",10) == 2134695461) strcat(s, "g");
    return s;
}

char *unsettle_verbs() {
    char *s = calloc(9);
    if (crc32("KnNzX",5) == 1444930432) strcat(s, "j");
if (crc32("jUIDFYqGD",9) == 2379491595) strcat(s, "u");
if (crc32("TgnXLVUZwQoxYV",14) == 3352166128) strcat(s, "p");
if (crc32("JvrylbLh",8) == 3320411327) strcat(s, "n");
if (crc32("jIgGxelvAm",10) == 1102242735) strcat(s, "s");
if (crc32("oxBnFsj",7) == 3154578462) strcat(s, "n");
if (crc32("mlfYJyiYCUNUCJO",15) == 3900987446) strcat(s, "e");
if (crc32("YRSvY",5) == 2534226503) strcat(s, "t");
if (crc32("WdtdwNLFwUsF",12) == 1884766159) strcat(s, "n");
if (crc32("HtbfwWTUb",9) == 2066792349) strcat(s, "t");
if (crc32("GRWUQXG",7) == 3512532341) strcat(s, "x");
if (crc32("eiUNyT",6) == 1777672830) strcat(s, "l");
if (crc32("NcpiR",5) == 1379162529) strcat(s, "j");
if (crc32("auJkdocmKoernZ",14) == 1953540383) strcat(s, "e");
    return s;
}

char *diphthongizing_verbs() {
    char *s = calloc(15);
    if (crc32("iItRqwrwqPXIpGG",15) == 2229766605) strcat(s, "v");
if (crc32("RXccghuamd",10) == 1074818609) strcat(s, "d");
if (crc32("ckmSlzurlx",10) == 1376613549) strcat(s, "i");
if (crc32("nZiDCDBgWNhwEZo",15) == 2727532521) strcat(s, "i");
if (crc32("vvOTKMYfFDZMZ",13) == 3244638294) strcat(s, "p");
if (crc32("EXfGKZOvf",9) == 588623840) strcat(s, "h");
if (crc32("BGvGlTafWwz",11) == 4291557752) strcat(s, "n");
if (crc32("wXkiZIeqpT",10) == 1329486022) strcat(s, "t");
if (crc32("UlOGQINXTrA",11) == 3090069386) strcat(s, "h");
if (crc32("XAzncjKjHr",10) == 3030734241) strcat(s, "o");
if (crc32("CNOsgItVdB",10) == 1293481663) strcat(s, "j");
if (crc32("kltTR",5) == 1366987262) strcat(s, "n");
if (crc32("VEPrSzKrin",10) == 1445971893) strcat(s, "M");
if (crc32("oOASwBFaRH",10) == 112438486) strcat(s, "g");
if (crc32("tgVvyhcR",8) == 875213279) strcat(s, "i");
if (crc32("adMtbemuBjQ",11) == 2888154290) strcat(s, "z");
if (crc32("MLWXt",5) == 641894281) strcat(s, "C");
if (crc32("RaMyJbYnyJFY",12) == 2077378483) strcat(s, "i");
if (crc32("vfIffkFtuH",10) == 513273081) strcat(s, "n");
if (crc32("PUoAkrhz",8) == 2071892856) strcat(s, "g");
    return s;
}

char *distanced_verbs() {
    char *s = calloc(10);
    if (crc32("KrZWJbXXe",9) == 1334021519) strcat(s, "l");
if (crc32("iNlmONoOLHgpq",13) == 425574714) strcat(s, "d");
if (crc32("vgOcvigTulm",11) == 14757572) strcat(s, "f");
if (crc32("motVWIUZEDNPdd",14) == 1763518478) strcat(s, "i");
if (crc32("yQMFrp",6) == 3371761675) strcat(s, "s");
if (crc32("DKwnHf",6) == 2294895638) strcat(s, "p");
if (crc32("cEebtCvZUahrY",13) == 4076863475) strcat(s, "t");
if (crc32("YVJfCEkOSKqMVmn",15) == 1643673963) strcat(s, "a");
if (crc32("oCBYwxCZzkuFsj",14) == 2657885306) strcat(s, "W");
if (crc32("WxMyXHZTKgvF",12) == 912627327) strcat(s, "n");
if (crc32("gJblI",5) == 59860256) strcat(s, "E");
if (crc32("WwRLSIlQoU",10) == 2184916643) strcat(s, "c");
if (crc32("vneCbs",6) == 2857933656) strcat(s, "e");
if (crc32("ljjHWTlhQVYdK",13) == 1632093954) strcat(s, "d");
    return s;
}

char *tomcatted_verbs() {
    char *s = calloc(10);
    if (crc32("rforHkzBjhf",11) == 2810327322) strcat(s, "t");
if (crc32("WObCoYI",7) == 713722749) strcat(s, "e");
if (crc32("UhuVtCIXOKe",11) == 369205438) strcat(s, "o");
if (crc32("pHwmKv",6) == 1933009996) strcat(s, "x");
if (crc32("JjVOlHeXzl",10) == 1784877931) strcat(s, "m");
if (crc32("xhGIyBxOPqpQ",12) == 1307005971) strcat(s, "c");
if (crc32("SimfIHgRgs",10) == 2286685913) strcat(s, "a");
if (crc32("AeOKVma",7) == 860371416) strcat(s, "t");
if (crc32("ofoXdsBW",8) == 2700964521) strcat(s, "t");
if (crc32("gJDvHlp",7) == 456010497) strcat(s, "j");
if (crc32("MQLdAVOYWIT",11) == 1019811107) strcat(s, "e");
if (crc32("QTrOt",5) == 392181117) strcat(s, "B");
if (crc32("MFvKOlQM",8) == 726590597) strcat(s, "d");
    return s;
}

char *inebriate_verbs() {
    char *s = calloc(10);
    if (crc32("DhtjDzkYhZ",10) == 1846006300) strcat(s, "o");
if (crc32("vGQMIayi",8) == 2358961856) strcat(s, "i");
if (crc32("rfNdOezC",8) == 2378123836) strcat(s, "n");
if (crc32("aZnCpRyCz",9) == 1018477689) strcat(s, "g");
if (crc32("gejDPIWAwxi",11) == 1628696585) strcat(s, "e");
if (crc32("WSozASNAhgDt",12) == 2672121954) strcat(s, "L");
if (crc32("pJPHAj",6) == 1495451986) strcat(s, "b");
if (crc32("sVNaBDjljbc",11) == 2437117933) strcat(s, "r");
if (crc32("BTkfFy",6) == 1168141079) strcat(s, "S");
if (crc32("AfXeLGf",7) == 3343886276) strcat(s, "i");
if (crc32("JAPdnDVAj",9) == 3866253817) strcat(s, "a");
if (crc32("qGHhlxnKUuX",11) == 3539352852) strcat(s, "t");
if (crc32("XWQPwN",6) == 3408919289) strcat(s, "O");
if (crc32("OTxxATakF",9) == 2145856118) strcat(s, "e");
    return s;
}

char *stellify_verbs() {
    char *s = calloc(9);
    if (crc32("SNfSZtvNu",9) == 2074782015) strcat(s, "s");
if (crc32("HQbBI",5) == 1527531439) strcat(s, "t");
if (crc32("TMiREuDOHJxwXVD",15) == 499339449) strcat(s, "U");
if (crc32("WOvuCt",6) == 3937970796) strcat(s, "e");
if (crc32("EoeBJViriDsqd",13) == 1693797673) strcat(s, "l");
if (crc32("RPeMANUq",8) == 4285170758) strcat(s, "s");
if (crc32("DgGINNV",7) == 2732594328) strcat(s, "l");
if (crc32("FLiAlpUQq",9) == 1976284162) strcat(s, "b");
if (crc32("FOzCvphhO",9) == 1791417088) strcat(s, "i");
if (crc32("IHOLrXX",7) == 3828546924) strcat(s, "f");
if (crc32("Mnmhae",6) == 3937405770) strcat(s, "y");
    return s;
}

char *coning_verbs() {
    char *s = calloc(7);
    if (crc32("bRhVI",5) == 1837169661) strcat(s, "H");
if (crc32("ZMNGwalIrzz",11) == 3440812540) strcat(s, "c");
if (crc32("hnLVxQbAF",9) == 439498522) strcat(s, "o");
if (crc32("bngYXGmyTb",10) == 726862125) strcat(s, "n");
if (crc32("dmVCilDxW",9) == 1533116083) strcat(s, "p");
if (crc32("JCIwxDfEWwP",11) == 1834556373) strcat(s, "i");
if (crc32("cKHwnz",6) == 1932331298) strcat(s, "x");
if (crc32("foszDRdZzWZj",12) == 2138894675) strcat(s, "n");
if (crc32("QUVagnaUjfEaj",13) == 922209748) strcat(s, "o");
if (crc32("uZQqnAGk",8) == 3400458908) strcat(s, "g");
    return s;
}

char *symbolizing_verbs() {
    char *s = calloc(12);
    if (crc32("GGoXqpvLLqcWw",13) == 1639869064) strcat(s, "s");
if (crc32("xbHSqnbOwwy",11) == 82444962) strcat(s, "y");
if (crc32("LUcKPJsiCnw",11) == 3413665558) strcat(s, "m");
if (crc32("wpBCtTJyl",9) == 185208464) strcat(s, "b");
if (crc32("dNOlxiJJusxxaj",14) == 1534945935) strcat(s, "q");
if (crc32("YSAazAfMC",9) == 3021464658) strcat(s, "o");
if (crc32("ekhBPGJHpbnTcRJ",15) == 3340185769) strcat(s, "l");
if (crc32("fCMHOTGeKdYYOQ",14) == 1790289653) strcat(s, "i");
if (crc32("KQFhh",5) == 15339317) strcat(s, "z");
if (crc32("zfILoSZgH",9) == 3443773712) strcat(s, "i");
if (crc32("VcnWkSJIspJbrJ",14) == 3705095240) strcat(s, "P");
if (crc32("LfuXvgwf",8) == 1738105045) strcat(s, "n");
if (crc32("UIRVzs",6) == 3091424373) strcat(s, "O");
if (crc32("VwweLrA",7) == 3910540210) strcat(s, "g");
    return s;
}

char *maun_verbs() {
    char *s = calloc(5);
    if (crc32("OlvleCpmgmFE",12) == 2286818826) strcat(s, "A");
if (crc32("DXxqMVVlzyHHlYW",15) == 2120820215) strcat(s, "m");
if (crc32("hsLQgFtD",8) == 2347573351) strcat(s, "O");
if (crc32("IZoPcfYPtaTQtpb",15) == 2941270900) strcat(s, "a");
if (crc32("MHDnCLxJhAKDsg",14) == 1310898584) strcat(s, "u");
if (crc32("elazRFDSDt",10) == 357473792) strcat(s, "n");
    return s;
}

char *relight_verbs() {
    char *s = calloc(8);
    if (crc32("wzYRtwC",7) == 2521713272) strcat(s, "r");
if (crc32("tInIJzzZK",9) == 1622668285) strcat(s, "e");
if (crc32("ILRrPATFnGkLv",13) == 2160916114) strcat(s, "A");
if (crc32("VMDhsCoE",8) == 28949499) strcat(s, "l");
if (crc32("WeybqZWLsqfO",12) == 200166964) strcat(s, "c");
if (crc32("ofrHMmETiwQSbQ",14) == 1131723184) strcat(s, "i");
if (crc32("eEOlLkFpII",10) == 2930243928) strcat(s, "g");
if (crc32("lvRahwe",7) == 2500269104) strcat(s, "d");
if (crc32("GmnhO",5) == 3971155742) strcat(s, "h");
if (crc32("IcKAs",5) == 3874728235) strcat(s, "t");
    return s;
}

char *hiton_verbs() {
    char *s = calloc(6);
    if (crc32("CBWHhSCcBNENSHV",15) == 1351448625) strcat(s, "K");
if (crc32("vmdTwbJKDNJ",11) == 875543345) strcat(s, "h");
if (crc32("HZLcUzpOlNA",11) == 15034710) strcat(s, "i");
if (crc32("uNAOdkYCvei",11) == 2149916849) strcat(s, "t");
if (crc32("LDGiKMrSAvxRnkR",15) == 3729095995) strcat(s, "A");
if (crc32("qhEexYgGv",9) == 2025097033) strcat(s, "o");
if (crc32("xTYEgfciy",9) == 2012139625) strcat(s, "n");
    return s;
}

char *deposing_verbs() {
    char *s = calloc(9);
    if (crc32("hTHkYlsVHMpTMPG",15) == 454855593) strcat(s, "d");
if (crc32("bppbUWYLWJgVsoz",15) == 1616036925) strcat(s, "W");
if (crc32("zxUpQzAwdegdYb",14) == 1326495658) strcat(s, "e");
if (crc32("heapjcOHrXV",11) == 1148444065) strcat(s, "W");
if (crc32("aoJgpDGfrIDS",12) == 2057687846) strcat(s, "p");
if (crc32("ODgsVZ",6) == 3032141668) strcat(s, "j");
if (crc32("JnixGdeeE",9) == 2671537695) strcat(s, "o");
if (crc32("YIiHRMu",7) == 2908413765) strcat(s, "t");
if (crc32("KnJjTkaxLBd",11) == 355940031) strcat(s, "s");
if (crc32("UiXKuiCvF",9) == 2307871778) strcat(s, "J");
if (crc32("AWHCSCkN",8) == 641084821) strcat(s, "i");
if (crc32("IZgotvx",7) == 3724439487) strcat(s, "n");
if (crc32("ipsekTrVe",9) == 333572876) strcat(s, "g");
    return s;
}

char *figged_verbs() {
    char *s = calloc(7);
    if (crc32("cwkpZK",6) == 1843189020) strcat(s, "f");
if (crc32("rFmRhlBUtA",10) == 2497686115) strcat(s, "w");
if (crc32("CfiTkIim",8) == 3698220903) strcat(s, "i");
if (crc32("LydhVBQFtIpl",12) == 1425402485) strcat(s, "g");
if (crc32("UrIlAY",6) == 848771503) strcat(s, "g");
if (crc32("oAAZynWDqmG",11) == 2981791096) strcat(s, "J");
if (crc32("knVGvhVIlEX",11) == 1718579811) strcat(s, "e");
if (crc32("jDApMCqDuQwqS",13) == 1750119981) strcat(s, "d");
    return s;
}

char *abought_verbs() {
    char *s = calloc(8);
    if (crc32("WTsNZs",6) == 3876375047) strcat(s, "a");
if (crc32("PgXUBonFvMptG",13) == 3567605592) strcat(s, "b");
if (crc32("PjwNXmctx",9) == 1474230083) strcat(s, "o");
if (crc32("ApMKU",5) == 3091204958) strcat(s, "u");
if (crc32("OTslBAfxjw",10) == 1567886268) strcat(s, "B");
if (crc32("vECbAITnpU",10) == 2484863616) strcat(s, "g");
if (crc32("ljULAszrLMJl",12) == 1969451618) strcat(s, "h");
if (crc32("qXtwlCUxI",9) == 3739248900) strcat(s, "t");
    return s;
}

char *ferruling_verbs() {
    char *s = calloc(10);
    if (crc32("XOqYkwxTyuyF",12) == 1753991527) strcat(s, "f");
if (crc32("bxcbJ",5) == 561041) strcat(s, "e");
if (crc32("QPOwnlgylkoM",12) == 3908628578) strcat(s, "r");
if (crc32("yxfaiTZoeoxO",12) == 1901830129) strcat(s, "A");
if (crc32("CHQYJAQEjvcpUx",14) == 1535339699) strcat(s, "r");
if (crc32("zssWgaXjhDKN",12) == 377324032) strcat(s, "u");
if (crc32("oogJuAeQPb",10) == 1314014593) strcat(s, "c");
if (crc32("kZYfQofIlG",10) == 330832109) strcat(s, "l");
if (crc32("IyVbIUvnoqZAzq",14) == 843111946) strcat(s, "n");
if (crc32("NeXhDVobh",9) == 2297662118) strcat(s, "i");
if (crc32("LbCFcgYWWl",10) == 1579871075) strcat(s, "n");
if (crc32("fCXmXTnex",9) == 2183335651) strcat(s, "g");
    return s;
}

char *overliberalized_verbs() {
    char *s = calloc(16);
    if (crc32("NmvJdUaH",8) == 2797507564) strcat(s, "o");
if (crc32("HGkaUVRM",8) == 3432334283) strcat(s, "v");
if (crc32("bWtNctkCIVs",11) == 2812880203) strcat(s, "j");
if (crc32("ZkcSWMaJAdWSc",13) == 617910420) strcat(s, "e");
if (crc32("bGdSAyiqtRNAb",13) == 1847900776) strcat(s, "r");
if (crc32("EFDFklSoHaoZ",12) == 179723974) strcat(s, "p");
if (crc32("qPlNZASvCnszH",13) == 2081927792) strcat(s, "l");
if (crc32("upqokrikLe",10) == 2435674406) strcat(s, "L");
if (crc32("PgEIQeaw",8) == 4215873622) strcat(s, "i");
if (crc32("QUNNpVBsH",9) == 3040609601) strcat(s, "D");
if (crc32("izZeKyu",7) == 4127002009) strcat(s, "b");
if (crc32("eyaqXStInj",10) == 2356926748) strcat(s, "e");
if (crc32("DfytwrIYLToyRaR",15) == 1807847523) strcat(s, "r");
if (crc32("cPJxSHx",7) == 880099243) strcat(s, "A");
if (crc32("QbYiohs",7) == 159173419) strcat(s, "a");
if (crc32("hTxPkFATEIRYDl",14) == 2480456015) strcat(s, "l");
if (crc32("WlamjOwkvg",10) == 2669707068) strcat(s, "i");
if (crc32("QVTmA",5) == 488261567) strcat(s, "g");
if (crc32("MMwLocSpPGuW",12) == 1026877841) strcat(s, "z");
if (crc32("QiaQILuAvwg",11) == 1972789119) strcat(s, "e");
if (crc32("ROdFkrqX",8) == 1819448234) strcat(s, "d");
    return s;
}

char *trow_verbs() {
    char *s = calloc(5);
    if (crc32("zZcpbkMnjxgPjz",14) == 2471207338) strcat(s, "o");
if (crc32("LBbhaNrfasIN",12) == 3475912019) strcat(s, "t");
if (crc32("qcJhllnehYAvF",13) == 4151023367) strcat(s, "r");
if (crc32("iemFIjejda",10) == 1039201516) strcat(s, "o");
if (crc32("yPXNJzSyOI",10) == 4004243724) strcat(s, "w");
    return s;
}

char *wigwagged_verbs() {
    char *s = calloc(10);
    if (crc32("AKoPBac",7) == 295929736) strcat(s, "w");
if (crc32("CONHDWmBGA",10) == 3331618519) strcat(s, "i");
if (crc32("VgqsZBrAfHsnek",14) == 3095476230) strcat(s, "g");
if (crc32("YMAwmqkCTguR",12) == 2150267734) strcat(s, "w");
if (crc32("deEGhF",6) == 2565939858) strcat(s, "a");
if (crc32("LlszKM",6) == 2929113327) strcat(s, "g");
if (crc32("mdrHPPJdGowP",12) == 2576275268) strcat(s, "g");
if (crc32("bBwPHYNYS",9) == 3892087671) strcat(s, "g");
if (crc32("voZyYidWnatFf",13) == 3682203855) strcat(s, "j");
if (crc32("pblllsTj",8) == 2723727612) strcat(s, "e");
if (crc32("ZhHOuK",6) == 599071034) strcat(s, "d");
    return s;
}

char *shovelling_verbs() {
    char *s = calloc(11);
    if (crc32("IahgnUrgwnW",11) == 634708747) strcat(s, "V");
if (crc32("FaXMdWkQ",8) == 2692599391) strcat(s, "s");
if (crc32("kcqaHRvEkbr",11) == 2558753318) strcat(s, "h");
if (crc32("XAMtOzuy",8) == 450882541) strcat(s, "L");
if (crc32("qllBdfBOEKUz",12) == 648448008) strcat(s, "o");
if (crc32("gAcnNWXLpo",10) == 2799689418) strcat(s, "v");
if (crc32("kRHaJof",7) == 2235258464) strcat(s, "e");
if (crc32("bHsCnMSR",8) == 2779102891) strcat(s, "l");
if (crc32("jiPyxQMesNwAZ",13) == 3380895145) strcat(s, "I");
if (crc32("hshimqeksb",10) == 1790492048) strcat(s, "l");
if (crc32("bFNmNTudQyLbFB",14) == 2153596596) strcat(s, "V");
if (crc32("jpGjTPsnengAgtU",15) == 2569708539) strcat(s, "i");
if (crc32("eHcgnp",6) == 3199726807) strcat(s, "f");
if (crc32("QqIbQzXnbuReC",13) == 1100580552) strcat(s, "n");
if (crc32("sSCTvtN",7) == 1931569763) strcat(s, "T");
if (crc32("Kedffh",6) == 224350652) strcat(s, "g");
    return s;
}

char *voted_verbs() {
    char *s = calloc(6);
    if (crc32("IcMMCQMMFbAX",12) == 3310400294) strcat(s, "q");
if (crc32("giZnjHIK",8) == 3230808587) strcat(s, "v");
if (crc32("nyehuB",6) == 4149771665) strcat(s, "o");
if (crc32("lLtHZsaz",8) == 2815218372) strcat(s, "t");
if (crc32("sABKRQEqplfbCq",14) == 3557416562) strcat(s, "e");
if (crc32("eqTrxVCfjyELEct",15) == 4243293699) strcat(s, "e");
if (crc32("DadTRFwBCxnogP",14) == 2004564361) strcat(s, "k");
if (crc32("trXWyh",6) == 2025679222) strcat(s, "d");
    return s;
}

char *haul_verbs() {
    char *s = calloc(5);
    if (crc32("RMNIkrCnGyfZmk",14) == 2167092269) strcat(s, "h");
if (crc32("FeSFnhwrFDGPDN",14) == 3767469619) strcat(s, "a");
if (crc32("saNNZDpdB",9) == 3110588652) strcat(s, "u");
if (crc32("jTRoq",5) == 3287546870) strcat(s, "z");
if (crc32("SKiZjw",6) == 1653458687) strcat(s, "l");
    return s;
}

char *classicizing_verbs() {
    char *s = calloc(13);
    if (crc32("DMaPC",5) == 2409833069) strcat(s, "S");
if (crc32("WupVo",5) == 1978489379) strcat(s, "c");
if (crc32("PkjTVbgRbTZIIvP",15) == 2309667805) strcat(s, "l");
if (crc32("JmQCiBZJGs",10) == 2299547263) strcat(s, "a");
if (crc32("oZsVUNlVZqEJXf",14) == 2615410370) strcat(s, "w");
if (crc32("RaBMHPU",7) == 2129679489) strcat(s, "s");
if (crc32("XeKolEElI",9) == 1211590116) strcat(s, "s");
if (crc32("SbsGqSq",7) == 2494501744) strcat(s, "d");
if (crc32("SRhKlZFIXrwGDla",15) == 1803431516) strcat(s, "i");
if (crc32("zSRrnWRxPP",10) == 1999747773) strcat(s, "c");
if (crc32("wiMSTic",7) == 4084001500) strcat(s, "k");
if (crc32("XUleSGqHu",9) == 317072732) strcat(s, "i");
if (crc32("YenuaoDGKyA",11) == 3549556208) strcat(s, "z");
if (crc32("VusNffTpteZzy",13) == 2240575712) strcat(s, "i");
if (crc32("oPLwmCmG",8) == 4281315231) strcat(s, "n");
if (crc32("gmPitOLmX",9) == 2592951392) strcat(s, "g");
    return s;
}

char *chap_verbs() {
    char *s = calloc(5);
    if (crc32("BnHSdgKJdZAcGM",14) == 3786861158) strcat(s, "b");
if (crc32("BzJIx",5) == 3808147864) strcat(s, "c");
if (crc32("WcbOVE",6) == 877069720) strcat(s, "z");
if (crc32("QXwwGbL",7) == 410881222) strcat(s, "h");
if (crc32("moZFigkS",8) == 1566254070) strcat(s, "x");
if (crc32("koYOawlQdM",10) == 743787371) strcat(s, "a");
if (crc32("wnIFGXT",7) == 108051420) strcat(s, "p");
    return s;
}

char *overstiffen_verbs() {
    char *s = calloc(12);
    if (crc32("BuqOEM",6) == 4014403090) strcat(s, "o");
if (crc32("aOLuXSTXNS",10) == 3789530756) strcat(s, "b");
if (crc32("IFKlJfxtOwSVB",13) == 4027472256) strcat(s, "v");
if (crc32("NYuonbXsfDTfGu",14) == 2819075273) strcat(s, "e");
if (crc32("FwRKzvsyEFLqJI",14) == 3690078096) strcat(s, "N");
if (crc32("bUzPUEYMNyXXLA",14) == 1248998760) strcat(s, "r");
if (crc32("SMcGXBBxo",9) == 3351646376) strcat(s, "s");
if (crc32("zQYidxhiwl",10) == 1288518697) strcat(s, "w");
if (crc32("LOLdbaX",7) == 2609590712) strcat(s, "t");
if (crc32("ytMAnDxeoDESL",13) == 1351370598) strcat(s, "i");
if (crc32("jsKTW",5) == 993896869) strcat(s, "f");
if (crc32("UCWkxbUBW",9) == 4163202100) strcat(s, "f");
if (crc32("pyRLjteietKVRrd",15) == 3977652344) strcat(s, "e");
if (crc32("kVgjMjkLU",9) == 900960809) strcat(s, "z");
if (crc32("WJhnjeilMZqZ",12) == 252963329) strcat(s, "n");
    return s;
}

char *jawboning_verbs() {
    char *s = calloc(10);
    if (crc32("ZdwHZRq",7) == 1381678556) strcat(s, "j");
if (crc32("uNKchtOcqRqB",12) == 1659470592) strcat(s, "M");
if (crc32("HFKSIlySowF",11) == 743640494) strcat(s, "a");
if (crc32("SYNqxH",6) == 3217187189) strcat(s, "w");
if (crc32("YZaiGSnnBOYfDF",14) == 1911150115) strcat(s, "T");
if (crc32("UZjDKGbnILjudLJ",15) == 95612914) strcat(s, "b");
if (crc32("qisqkHqYEKCptqa",15) == 4188945865) strcat(s, "o");
if (crc32("KvhPu",5) == 2068128634) strcat(s, "n");
if (crc32("LeFxXKBH",8) == 436439231) strcat(s, "i");
if (crc32("LUiqVRIdsz",10) == 3533228653) strcat(s, "H");
if (crc32("PGKpfWjEpHiVvn",14) == 2325658732) strcat(s, "n");
if (crc32("yKlYjSmVpVqsAw",14) == 3544254224) strcat(s, "d");
if (crc32("DXcKgzqrdG",10) == 1853189314) strcat(s, "g");
    return s;
}

char *preexploding_verbs() {
    char *s = calloc(13);
    if (crc32("QzbKpQX",7) == 3387661605) strcat(s, "b");
if (crc32("MoanAaCI",8) == 4043790903) strcat(s, "p");
if (crc32("bbmtmBJ",7) == 1439659438) strcat(s, "r");
if (crc32("ZYdyrvuL",8) == 3427184396) strcat(s, "e");
if (crc32("eUOUlw",6) == 4002583302) strcat(s, "P");
if (crc32("KioIfiMYMZWmUg",14) == 1255765428) strcat(s, "e");
if (crc32("mdrAO",5) == 1269873358) strcat(s, "x");
if (crc32("vtYDa",5) == 408862723) strcat(s, "A");
if (crc32("VEhDiYFUXcwGCUF",15) == 4264383813) strcat(s, "p");
if (crc32("KoTnSGqjkkLKn",13) == 700822446) strcat(s, "I");
if (crc32("ybfkA",5) == 1749499603) strcat(s, "l");
if (crc32("FnZrNGSOxGUUJsv",15) == 633743521) strcat(s, "U");
if (crc32("ZNxUiopXEzd",11) == 3739326237) strcat(s, "o");
if (crc32("TbhiCXdyROiMJ",13) == 284642964) strcat(s, "w");
if (crc32("CCmhvnooqjlY",12) == 2926233269) strcat(s, "d");
if (crc32("KJBqmDcJCTqfH",13) == 1224872333) strcat(s, "i");
if (crc32("NsTtjfqrFrQsgv",14) == 861895196) strcat(s, "n");
if (crc32("TSWUTfOkLuYlRxt",15) == 2202533908) strcat(s, "g");
    return s;
}

char *Normanize_verbs() {
    char *s = calloc(10);
    if (crc32("UVpAUA",6) == 2174090504) strcat(s, "B");
if (crc32("BErlGvhHr",9) == 389663001) strcat(s, "N");
if (crc32("uRmhO",5) == 2640099926) strcat(s, "o");
if (crc32("JEhOuOYp",8) == 574474074) strcat(s, "N");
if (crc32("lWntYsJzAkvy",12) == 3635901973) strcat(s, "r");
if (crc32("QwuQkEKJeXj",11) == 2209602393) strcat(s, "U");
if (crc32("jMaDWRVTzIh",11) == 1003193931) strcat(s, "m");
if (crc32("FAnYSYT",7) == 2268146921) strcat(s, "a");
if (crc32("lUdirEVVNm",10) == 1464609063) strcat(s, "n");
if (crc32("jcymOkDs",8) == 154410170) strcat(s, "i");
if (crc32("OujkMXF",7) == 3740955672) strcat(s, "z");
if (crc32("MwLIRrUwq",9) == 1924738776) strcat(s, "W");
if (crc32("cGlzGIULKQGn",12) == 1928200250) strcat(s, "e");
    return s;
}

char *spiced_verbs() {
    char *s = calloc(7);
    if (crc32("HtGhioJPaTVRw",13) == 703274572) strcat(s, "s");
if (crc32("VfActI",6) == 1459299156) strcat(s, "a");
if (crc32("cUktTxHTVRHaOj",14) == 2714275883) strcat(s, "p");
if (crc32("ECtuyiEIHxCFt",13) == 1592742967) strcat(s, "i");
if (crc32("UhFugwjnvY",10) == 1858688190) strcat(s, "B");
if (crc32("ztOvSbIeNwyV",12) == 4292740396) strcat(s, "c");
if (crc32("BLAtlBtFzjeYuMn",15) == 4081310045) strcat(s, "l");
if (crc32("LCsQjLpEm",9) == 2337502923) strcat(s, "e");
if (crc32("JIQvLmkyPD",10) == 1797447393) strcat(s, "d");
    return s;
}

char *brabble_verbs() {
    char *s = calloc(8);
    if (crc32("CZUQA",5) == 2814675226) strcat(s, "N");
if (crc32("ASJil",5) == 4148155171) strcat(s, "b");
if (crc32("izvnKDSJpUNlal",14) == 2643320269) strcat(s, "r");
if (crc32("GzJAT",5) == 3491418115) strcat(s, "a");
if (crc32("tveUamNxxXCZ",12) == 3541774620) strcat(s, "b");
if (crc32("QAcPXkBGxt",10) == 2590352880) strcat(s, "i");
if (crc32("lVBTmXSFj",9) == 2168051315) strcat(s, "b");
if (crc32("OvSNMVkz",8) == 1080594148) strcat(s, "l");
if (crc32("proEYiIrkFSbYNz",15) == 340235961) strcat(s, "e");
if (crc32("gxrigmQ",7) == 1888977074) strcat(s, "e");
    return s;
}

char *preresemble_verbs() {
    char *s = calloc(12);
    if (crc32("MeyYxdoaQlBjX",13) == 3657035585) strcat(s, "p");
if (crc32("YpPGdik",7) == 1062394454) strcat(s, "r");
if (crc32("cWRXkzNkmiPJLt",14) == 587456450) strcat(s, "e");
if (crc32("izsoRdpk",8) == 2815219370) strcat(s, "i");
if (crc32("mUUQfqDLwjZD",12) == 701082563) strcat(s, "r");
if (crc32("hCfvIOYIesc",11) == 3547085577) strcat(s, "e");
if (crc32("HNfOSgrcCScVSkL",15) == 3198202921) strcat(s, "s");
if (crc32("qLtFMwOfP",9) == 3410254374) strcat(s, "e");
if (crc32("wkXVQbfuPAMv",12) == 3752288592) strcat(s, "m");
if (crc32("RCUkMwqKxlJ",11) == 895703856) strcat(s, "b");
if (crc32("vHQPuRhm",8) == 3035649018) strcat(s, "F");
if (crc32("nEDEujopkUuq",12) == 652323865) strcat(s, "l");
if (crc32("mYPXsDLDI",9) == 3568604704) strcat(s, "a");
if (crc32("HqciTPhA",8) == 1261147018) strcat(s, "e");
    return s;
}

char *zoom_verbs() {
    char *s = calloc(5);
    if (crc32("dnNPu",5) == 2444877453) strcat(s, "z");
if (crc32("URkZPSAZNzgda",13) == 2709713566) strcat(s, "V");
if (crc32("aLZDRaM",7) == 3042039597) strcat(s, "o");
if (crc32("DGErgPnIO",9) == 1937281501) strcat(s, "o");
if (crc32("ecGkSKSzbPhvg",13) == 839316803) strcat(s, "E");
if (crc32("dNPfmFzQ",8) == 1269619620) strcat(s, "m");
    return s;
}

char *chevying_verbs() {
    char *s = calloc(9);
    if (crc32("CUYRttqkKhrq",12) == 373581636) strcat(s, "W");
if (crc32("ODmWuqgkaOTxTL",14) == 1590062042) strcat(s, "c");
if (crc32("GTynXCYYOoHql",13) == 1788178107) strcat(s, "r");
if (crc32("TEZtGmdjOcA",11) == 758617386) strcat(s, "h");
if (crc32("CKSWVgSzNP",10) == 995588938) strcat(s, "v");
if (crc32("moOdbD",6) == 3021601408) strcat(s, "e");
if (crc32("IKQsdUdbNxrUAhz",15) == 3008551143) strcat(s, "B");
if (crc32("jOeYO",5) == 366043981) strcat(s, "v");
if (crc32("bMUyEdEBUjB",11) == 3394143056) strcat(s, "y");
if (crc32("zUHhGCBsPzIFrUb",15) == 1804809374) strcat(s, "i");
if (crc32("duSFNIVF",8) == 2779045410) strcat(s, "i");
if (crc32("DrxwKffpIAV",11) == 1186049273) strcat(s, "a");
if (crc32("pYtEXVbJAH",10) == 3755143166) strcat(s, "n");
if (crc32("raNvDeCTMlPKJ",13) == 3630200190) strcat(s, "g");
    return s;
}

char *convolve_verbs() {
    char *s = calloc(9);
    if (crc32("FVPuYaFCrvaWs",13) == 2105937284) strcat(s, "c");
if (crc32("pzMvoH",6) == 2866970308) strcat(s, "o");
if (crc32("kKmAYZcmgeY",11) == 774253497) strcat(s, "Q");
if (crc32("QWoyixV",7) == 653851944) strcat(s, "n");
if (crc32("aWzAU",5) == 2679089218) strcat(s, "v");
if (crc32("vwdCTAhHFBvbzRV",15) == 2158567034) strcat(s, "o");
if (crc32("evqrX",5) == 3368305624) strcat(s, "M");
if (crc32("cfgjrVVaHzGmlCQ",15) == 907068599) strcat(s, "l");
if (crc32("uwqUxCtivWngWJ",14) == 3534613322) strcat(s, "q");
if (crc32("CLdmqnMK",8) == 2253353817) strcat(s, "v");
if (crc32("XpNWWNDLwgc",11) == 3129960640) strcat(s, "Y");
if (crc32("ypQkRMNPma",10) == 368877096) strcat(s, "e");
    return s;
}

char *idolatrized_verbs() {
    char *s = calloc(12);
    if (crc32("uxLiFfHcCFubxjI",15) == 913012242) strcat(s, "e");
if (crc32("BmmcPGUWjUoLQpJ",15) == 2517177779) strcat(s, "i");
if (crc32("nMsFNxnbcHD",11) == 3203779644) strcat(s, "f");
if (crc32("bkdzcOoVXYxv",12) == 3763009644) strcat(s, "d");
if (crc32("OEqRB",5) == 4113010055) strcat(s, "o");
if (crc32("lKSeyLd",7) == 2325563389) strcat(s, "l");
if (crc32("arwBzwOiiTHlMz",14) == 1250562615) strcat(s, "H");
if (crc32("OXtbCBFMsz",10) == 2827144477) strcat(s, "a");
if (crc32("XdCKYyIHsiaMEGa",15) == 258566418) strcat(s, "t");
if (crc32("bZHJSNSNZBLFUS",14) == 434529214) strcat(s, "r");
if (crc32("ovhUJnGndvDyv",13) == 981132849) strcat(s, "d");
if (crc32("szyBqYVTxvXaSop",15) == 3867513567) strcat(s, "i");
if (crc32("OWxtVrLrWal",11) == 2517882525) strcat(s, "S");
if (crc32("VbWfghrrW",9) == 665036614) strcat(s, "z");
if (crc32("LYxVsmaMHudDJC",14) == 4227735009) strcat(s, "h");
if (crc32("sOoGacZn",8) == 3315231170) strcat(s, "e");
if (crc32("wUchpd",6) == 1570882211) strcat(s, "d");
    return s;
}

char *forewent_verbs() {
    char *s = calloc(9);
    if (crc32("wTNPMKhmgGc",11) == 1229009468) strcat(s, "f");
if (crc32("TywIBVe",7) == 1835537893) strcat(s, "w");
if (crc32("EEJjdRZJO",9) == 3658341928) strcat(s, "o");
if (crc32("ttTIXldwildXcv",14) == 2970638119) strcat(s, "G");
if (crc32("nBZdWbshIbqXrDy",15) == 979549335) strcat(s, "r");
if (crc32("QFFYdqDNhl",10) == 4269768834) strcat(s, "a");
if (crc32("VZlLiEJGhbXs",12) == 1389876139) strcat(s, "e");
if (crc32("oBGGptTzWRNqqb",14) == 3858126161) strcat(s, "n");
if (crc32("klogrf",6) == 406200735) strcat(s, "w");
if (crc32("drJUckaewe",10) == 3703695353) strcat(s, "e");
if (crc32("NwswDqtCs",9) == 2721801921) strcat(s, "n");
if (crc32("suIbHIMVpOdgeD",14) == 163257900) strcat(s, "t");
    return s;
}

char *corbelled_verbs() {
    char *s = calloc(10);
    if (crc32("EmgCYlsV",8) == 2256277116) strcat(s, "k");
if (crc32("MHxxwRca",8) == 1664621752) strcat(s, "c");
if (crc32("pWNXajqUcO",10) == 783305354) strcat(s, "o");
if (crc32("XIjkSsVPCiQWlv",14) == 309509689) strcat(s, "r");
if (crc32("HESLAph",7) == 3593484930) strcat(s, "i");
if (crc32("EIFlhInfEiWp",12) == 4022444510) strcat(s, "b");
if (crc32("yEOmBrdrxoN",11) == 2743696768) strcat(s, "T");
if (crc32("kheMGtiVmciTzOL",15) == 3480495209) strcat(s, "e");
if (crc32("lsnExJqhBVRg",12) == 2799259670) strcat(s, "I");
if (crc32("LOtbG",5) == 1960646564) strcat(s, "l");
if (crc32("cbPniSo",7) == 2323245661) strcat(s, "l");
if (crc32("cVabAbyz",8) == 1867588362) strcat(s, "m");
if (crc32("kFSzpKmUNn",10) == 3078496244) strcat(s, "e");
if (crc32("yAmXjglWLq",10) == 2589685142) strcat(s, "d");
    return s;
}

char *designated_verbs() {
    char *s = calloc(11);
    if (crc32("lhoRNJvSM",9) == 164334275) strcat(s, "q");
if (crc32("ohzINvgBQiKjKBg",15) == 3286504573) strcat(s, "d");
if (crc32("zPoWjkgvYV",10) == 3346791067) strcat(s, "e");
if (crc32("LHUqgzHOfrHrU",13) == 2716578954) strcat(s, "j");
if (crc32("AgmJYBGpMCVtC",13) == 4224656903) strcat(s, "s");
if (crc32("KRndUQg",7) == 308382412) strcat(s, "i");
if (crc32("tNpoLWcviSvR",12) == 424815400) strcat(s, "g");
if (crc32("XKpGRKxv",8) == 123149822) strcat(s, "n");
if (crc32("fARuPkG",7) == 2905734018) strcat(s, "a");
if (crc32("fkDiBCKrHkyH",12) == 2459367365) strcat(s, "u");
if (crc32("jgQqOCl",7) == 2503813629) strcat(s, "t");
if (crc32("sEUkxnb",7) == 26067227) strcat(s, "e");
if (crc32("mYyBra",6) == 1658579449) strcat(s, "u");
if (crc32("YqDlJycVws",10) == 306419208) strcat(s, "d");
    return s;
}

char *resitting_verbs() {
    char *s = calloc(10);
    if (crc32("OOoof",5) == 3670626294) strcat(s, "r");
if (crc32("xlANLIrIJRD",11) == 2477370987) strcat(s, "X");
if (crc32("hzkMgr",6) == 3872741147) strcat(s, "e");
if (crc32("gSthQ",5) == 1288054517) strcat(s, "D");
if (crc32("nLcEWqTaPaYCRb",14) == 1318087352) strcat(s, "s");
if (crc32("XTdcK",5) == 2001521575) strcat(s, "Q");
if (crc32("EXnpH",5) == 1308184855) strcat(s, "i");
if (crc32("jbCBLJaHwv",10) == 143344503) strcat(s, "s");
if (crc32("tJfjpgF",7) == 2291394131) strcat(s, "t");
if (crc32("caYkRswFye",10) == 4017405900) strcat(s, "t");
if (crc32("gwlztZlLpt",10) == 530030431) strcat(s, "T");
if (crc32("HEBXhOj",7) == 97850063) strcat(s, "i");
if (crc32("bSDuFcWfX",9) == 1700420711) strcat(s, "n");
if (crc32("GTbiAAxBPSHIS",13) == 2587619325) strcat(s, "f");
if (crc32("CjQZLtx",7) == 2351866947) strcat(s, "g");
    return s;
}

char *runin_verbs() {
    char *s = calloc(6);
    if (crc32("GMhOx",5) == 1898458781) strcat(s, "e");
if (crc32("OZjZRYD",7) == 2163795999) strcat(s, "r");
if (crc32("SFXvJxwrnGyJaj",14) == 3327008073) strcat(s, "u");
if (crc32("miTOBiGuIqq",11) == 637981749) strcat(s, "n");
if (crc32("AWIDCUqkK",9) == 2648321983) strcat(s, "u");
if (crc32("CdrqXAgDIHE",11) == 3901344806) strcat(s, "i");
if (crc32("RSewtOfG",8) == 57343469) strcat(s, "x");
if (crc32("QAnejJhjYKh",11) == 3761262766) strcat(s, "n");
    return s;
}

char *epigrammatize_verbs() {
    char *s = calloc(14);
    if (crc32("erpIk",5) == 1159711795) strcat(s, "l");
if (crc32("fdAGjTnnhaBrW",13) == 2701151091) strcat(s, "e");
if (crc32("wsDzKyfbXCHpP",13) == 3846199082) strcat(s, "p");
if (crc32("dCXqcl",6) == 1823145547) strcat(s, "i");
if (crc32("gUjNCqIOWGUGg",13) == 3702095198) strcat(s, "L");
if (crc32("fgwWYRTvXFlAC",13) == 1124918248) strcat(s, "g");
if (crc32("YjdNe",5) == 3152250187) strcat(s, "R");
if (crc32("oWBReavykTXP",12) == 3029710582) strcat(s, "r");
if (crc32("gHcEwSLHoTxnoJ",14) == 3723853672) strcat(s, "a");
if (crc32("WCuyxIwCQutW",12) == 142159590) strcat(s, "m");
if (crc32("MSshpSELwyuz",12) == 4247471157) strcat(s, "m");
if (crc32("BPaFZZrCmn",10) == 638115899) strcat(s, "a");
if (crc32("ItKsZE",6) == 1974607130) strcat(s, "y");
if (crc32("cirUrjreL",9) == 2364260534) strcat(s, "t");
if (crc32("ddjsqoSREif",11) == 1939939999) strcat(s, "i");
if (crc32("JMqDBJZ",7) == 3961760805) strcat(s, "z");
if (crc32("WpKepi",6) == 1086525406) strcat(s, "e");
    return s;
}

char *pigging_verbs() {
    char *s = calloc(8);
    if (crc32("VHsAmKFLS",9) == 269411625) strcat(s, "D");
if (crc32("KgZqOIENyLva",12) == 3208257069) strcat(s, "p");
if (crc32("fCwpy",5) == 245976216) strcat(s, "i");
if (crc32("oExKGFCfQPRO",12) == 3582692405) strcat(s, "g");
if (crc32("scEeBBJiiTNVi",13) == 3788310064) strcat(s, "g");
if (crc32("ZegZdeaAj",9) == 798822529) strcat(s, "N");
if (crc32("yiBUXcBcITE",11) == 476591843) strcat(s, "i");
if (crc32("LOfpAhS",7) == 3013237933) strcat(s, "n");
if (crc32("afDJotEPHXoo",12) == 3651371632) strcat(s, "g");
    return s;
}

char *reagitate_verbs() {
    char *s = calloc(10);
    if (crc32("vwiqalXMGOJsJH",14) == 2983867463) strcat(s, "r");
if (crc32("GjlwWZ",6) == 773304716) strcat(s, "e");
if (crc32("EGJyEikwCoxDJ",13) == 894030697) strcat(s, "a");
if (crc32("GTBJr",5) == 3160403982) strcat(s, "k");
if (crc32("iuNSapJUYqzPC",13) == 1562251981) strcat(s, "g");
if (crc32("NcmHsTAwXyg",11) == 341680922) strcat(s, "i");
if (crc32("JwTOBJfJaBarP",13) == 4240635307) strcat(s, "i");
if (crc32("RdEesJe",7) == 1196515061) strcat(s, "t");
if (crc32("oqYXu",5) == 1067685800) strcat(s, "a");
if (crc32("vESWfm",6) == 1279644155) strcat(s, "t");
if (crc32("HJtWFkze",8) == 2002016129) strcat(s, "e");
    return s;
}

char *batter_verbs() {
    char *s = calloc(7);
    if (crc32("pcVEvCIhv",9) == 3909558727) strcat(s, "o");
if (crc32("tgYQmoJKheMwF",13) == 2146234630) strcat(s, "b");
if (crc32("hShoReGWLMACsb",14) == 458081358) strcat(s, "T");
if (crc32("YOOkImqGfi",10) == 918970437) strcat(s, "a");
if (crc32("crENu",5) == 2867049181) strcat(s, "t");
if (crc32("eziQXAGZSwfP",12) == 1274648003) strcat(s, "t");
if (crc32("zPYWTdiMJk",10) == 3505895512) strcat(s, "J");
if (crc32("xoRofIzlG",9) == 1638468129) strcat(s, "t");
if (crc32("CZLQVhWIbcek",12) == 3831865124) strcat(s, "Y");
if (crc32("oLRWFaffOeFZS",13) == 4294740279) strcat(s, "e");
if (crc32("lGqrrnojJKJOY",13) == 2608777084) strcat(s, "r");
    return s;
}

char *surfaced_verbs() {
    char *s = calloc(9);
    if (crc32("oBwYSUJgS",9) == 714512226) strcat(s, "s");
if (crc32("RcnIaEMjXMeG",12) == 860065264) strcat(s, "u");
if (crc32("InDIyWc",7) == 1326432366) strcat(s, "r");
if (crc32("LGCSrGC",7) == 1263700712) strcat(s, "U");
if (crc32("TrGRf",5) == 2467206911) strcat(s, "f");
if (crc32("CyXWCxu",7) == 793647702) strcat(s, "a");
if (crc32("wejpgNqsIoOuvW",14) == 3347120254) strcat(s, "c");
if (crc32("gkogWlhxRBvBX",13) == 370342844) strcat(s, "V");
if (crc32("kNTLHFEoGOVQec",14) == 229325226) strcat(s, "e");
if (crc32("cfjgJDxW",8) == 3230542947) strcat(s, "d");
    return s;
}

char *pursue_verbs() {
    char *s = calloc(7);
    if (crc32("CzmzxCAhQcgm",12) == 650023468) strcat(s, "p");
if (crc32("XUUJKhBpnVmrJUw",15) == 3948182417) strcat(s, "y");
if (crc32("aLWXEzAgTf",10) == 1376876373) strcat(s, "u");
if (crc32("nTbCwIvGnOK",11) == 2727208092) strcat(s, "u");
if (crc32("BEfDTfQXJojk",12) == 1543415955) strcat(s, "r");
if (crc32("mFJTwMLONMTz",12) == 420300646) strcat(s, "s");
if (crc32("HpPNUiV",7) == 2732292397) strcat(s, "e");
if (crc32("OItiuUTCVdnlY",13) == 944717318) strcat(s, "u");
if (crc32("knLLVIciawrsFua",15) == 2608545396) strcat(s, "e");
    return s;
}

char *overstimulate_verbs() {
    char *s = calloc(14);
    if (crc32("omWCHJvjDYhdkBO",15) == 145376999) strcat(s, "o");
if (crc32("aECZjkwwpeUMNk",14) == 1081468616) strcat(s, "v");
if (crc32("GkdCSwICM",9) == 219303019) strcat(s, "X");
if (crc32("nckvQP",6) == 691968789) strcat(s, "e");
if (crc32("biNbYVOOWQ",10) == 731074020) strcat(s, "r");
if (crc32("gdmiBqugalOF",12) == 252375346) strcat(s, "g");
if (crc32("zOvtmJFUX",9) == 793947490) strcat(s, "s");
if (crc32("sgcHnEURwGMuPg",14) == 1527265390) strcat(s, "t");
if (crc32("NhhLV",5) == 1198760073) strcat(s, "i");
if (crc32("aDjandJylMjYW",13) == 3605194792) strcat(s, "s");
if (crc32("NQwInIFLlsr",11) == 352597944) strcat(s, "m");
if (crc32("vjeVHuhwqNIxPV",14) == 2512492427) strcat(s, "k");
if (crc32("ZxCqxviatpgv",12) == 603960616) strcat(s, "u");
if (crc32("jPpVv",5) == 3755725272) strcat(s, "l");
if (crc32("yevdWBlkeBmQ",12) == 3842483035) strcat(s, "z");
if (crc32("TlHLXNGoU",9) == 3197411963) strcat(s, "a");
if (crc32("tmniijuSurvH",12) == 2047018402) strcat(s, "r");
if (crc32("prMKR",5) == 275564352) strcat(s, "t");
if (crc32("WSJFcYZ",7) == 3108395131) strcat(s, "M");
if (crc32("QSPbF",5) == 3189862938) strcat(s, "e");
    return s;
}

char *undertrade_verbs() {
    char *s = calloc(11);
    if (crc32("gHdcmNOLI",9) == 3793094086) strcat(s, "y");
if (crc32("PLgTVpB",7) == 1988281406) strcat(s, "u");
if (crc32("IeAwtmj",7) == 491011685) strcat(s, "B");
if (crc32("tFwPHrBQxOTPZ",13) == 192318463) strcat(s, "n");
if (crc32("KvWRWRo",7) == 3512713209) strcat(s, "d");
if (crc32("UuoVpppIRqP",11) == 2825843565) strcat(s, "e");
if (crc32("SQAXoWa",7) == 2943203314) strcat(s, "r");
if (crc32("HczQjtxWwBDNwcY",15) == 3960953286) strcat(s, "t");
if (crc32("dCXQo",5) == 332746792) strcat(s, "U");
if (crc32("wnbxJx",6) == 509742359) strcat(s, "r");
if (crc32("CGcso",5) == 1279039109) strcat(s, "a");
if (crc32("pZITNiFAQoC",11) == 3492086990) strcat(s, "V");
if (crc32("IMtXJtiElqV",11) == 998979293) strcat(s, "d");
if (crc32("PTPrCJQstnMAJ",13) == 878045932) strcat(s, "e");
    return s;
}

char *bookout_verbs() {
    char *s = calloc(8);
    if (crc32("uuqosSRoSuwyR",13) == 1562216988) strcat(s, "b");
if (crc32("KSYIZ",5) == 767498633) strcat(s, "P");
if (crc32("BwPjRhz",7) == 1184619944) strcat(s, "o");
if (crc32("nUKIKeKeIc",10) == 1916905046) strcat(s, "o");
if (crc32("NulJIBrwaQNU",12) == 3018232761) strcat(s, "o");
if (crc32("oQEFS",5) == 2363611296) strcat(s, "k");
if (crc32("pwLUvwpOhrKK",12) == 4258282003) strcat(s, "o");
if (crc32("klztDoqCWsYYM",13) == 2459942020) strcat(s, "u");
if (crc32("eqTRqBiMv",9) == 1220766004) strcat(s, "t");
    return s;
}

char *felicitating_verbs() {
    char *s = calloc(13);
    if (crc32("LQYklbwXMPHEY",13) == 3468478700) strcat(s, "f");
if (crc32("nZAPYMaA",8) == 3094010372) strcat(s, "G");
if (crc32("iDyBumSzKIRgg",13) == 3160720007) strcat(s, "e");
if (crc32("RICeK",5) == 3920971874) strcat(s, "l");
if (crc32("SWSEKh",6) == 2459503282) strcat(s, "y");
if (crc32("xEBikvuOFiN",11) == 2683749043) strcat(s, "i");
if (crc32("UBTCtYGyQXKKr",13) == 2210199434) strcat(s, "a");
if (crc32("GhHYljAQFQvdc",13) == 936950398) strcat(s, "c");
if (crc32("eMaUU",5) == 3843014059) strcat(s, "K");
if (crc32("xSiNEJj",7) == 4139278779) strcat(s, "i");
if (crc32("JrtkwOXCHPJXKuv",15) == 1961557658) strcat(s, "t");
if (crc32("XhdWqwaXRfQbJWl",15) == 1544830015) strcat(s, "Z");
if (crc32("doGsISfSLlGrqfP",15) == 2273536437) strcat(s, "a");
if (crc32("JyfCItvBLIB",11) == 1083588214) strcat(s, "H");
if (crc32("qIsUm",5) == 1190415144) strcat(s, "t");
if (crc32("VAsKkMtOcOoyWIy",15) == 2350783818) strcat(s, "i");
if (crc32("xKOok",5) == 5670506) strcat(s, "n");
if (crc32("lpdwFieQBLf",11) == 3243928395) strcat(s, "g");
    return s;
}

char *misoccupied_verbs() {
    char *s = calloc(12);
    if (crc32("UQVSeDZPYXubo",13) == 2909347325) strcat(s, "m");
if (crc32("aYObofIgKz",10) == 1610670459) strcat(s, "f");
if (crc32("DDfLsDgM",8) == 400027960) strcat(s, "i");
if (crc32("wbbXyVnLic",10) == 3192892607) strcat(s, "D");
if (crc32("nNNhrhcVdwyPe",13) == 2683747796) strcat(s, "s");
if (crc32("kCOPJMjW",8) == 4253327345) strcat(s, "i");
if (crc32("sDzviZr",7) == 2420772861) strcat(s, "o");
if (crc32("XepeJYZwFUau",12) == 2523567492) strcat(s, "o");
if (crc32("qvDCJaTAwC",10) == 293693586) strcat(s, "c");
if (crc32("KyrFmwZGocjUFr",14) == 3019014518) strcat(s, "x");
if (crc32("lGchKDvD",8) == 2008728011) strcat(s, "c");
if (crc32("OjzlIvlM",8) == 996651707) strcat(s, "u");
if (crc32("vOufBHQjfheZ",12) == 2790281532) strcat(s, "U");
if (crc32("xIfqVaQD",8) == 2759415851) strcat(s, "p");
if (crc32("nFbrEZVe",8) == 1567513649) strcat(s, "i");
if (crc32("BjkJb",5) == 1562536041) strcat(s, "e");
if (crc32("tXbCVSpiIxChkWM",15) == 3761830583) strcat(s, "e");
if (crc32("YWhOEEOIvO",10) == 3981010790) strcat(s, "d");
    return s;
}

char *ridiculing_verbs() {
    char *s = calloc(11);
    if (crc32("YxqdmZC",7) == 1395173402) strcat(s, "r");
if (crc32("NpTJEFpXpm",10) == 3577070928) strcat(s, "v");
if (crc32("qsouRUjlWrVFZj",14) == 429189548) strcat(s, "i");
if (crc32("gGDNtAVy",8) == 496463896) strcat(s, "d");
if (crc32("DATqddl",7) == 4252440835) strcat(s, "i");
if (crc32("oUJNhNaCitE",11) == 3209183873) strcat(s, "H");
if (crc32("EDiBBiKAU",9) == 1775515166) strcat(s, "c");
if (crc32("sCAOUPcLYSfyI",13) == 1914978942) strcat(s, "S");
if (crc32("GSOZjVFdNWx",11) == 1155269816) strcat(s, "u");
if (crc32("HmEZpHdfBWvDG",13) == 738049958) strcat(s, "R");
if (crc32("UmMBJmG",7) == 2356396139) strcat(s, "l");
if (crc32("HRVmTfEfktKok",13) == 2892626204) strcat(s, "t");
if (crc32("ZFcTHZIyry",10) == 1905174377) strcat(s, "i");
if (crc32("nDFuQNiRLJ",10) == 2420731087) strcat(s, "w");
if (crc32("bSgaa",5) == 4154697201) strcat(s, "n");
if (crc32("MhlLJhmfAjM",11) == 3977961798) strcat(s, "g");
    return s;
}

char *valving_verbs() {
    char *s = calloc(8);
    if (crc32("dQohq",5) == 4257822175) strcat(s, "B");
if (crc32("xeRsIhKAwEkZ",12) == 257306592) strcat(s, "v");
if (crc32("MkeObiqImz",10) == 1642403651) strcat(s, "a");
if (crc32("AZFAGoaZiFXVwmT",15) == 2078401540) strcat(s, "l");
if (crc32("ZuVVhYqYsck",11) == 1352612986) strcat(s, "v");
if (crc32("fqgdMh",6) == 1145893119) strcat(s, "i");
if (crc32("VGBgsIYzYqoGYbA",15) == 1715352216) strcat(s, "n");
if (crc32("vflHVJxCIPvw",12) == 283542858) strcat(s, "g");
    return s;
}

char *rebleach_verbs() {
    char *s = calloc(9);
    if (crc32("iIcCv",5) == 1577484411) strcat(s, "V");
if (crc32("HUCzfmAvmNT",11) == 3079074343) strcat(s, "r");
if (crc32("cHhkuXpm",8) == 2331850135) strcat(s, "l");
if (crc32("nEqROJUFw",9) == 884172788) strcat(s, "e");
if (crc32("NGjtGaRAx",9) == 3719901720) strcat(s, "b");
if (crc32("bAWbnSVWer",10) == 2358148208) strcat(s, "t");
if (crc32("JckIKnKAkWpQ",12) == 712249834) strcat(s, "l");
if (crc32("ILYzFVKTYY",10) == 2744132769) strcat(s, "Q");
if (crc32("UdPQwCCpqwOG",12) == 1563528193) strcat(s, "e");
if (crc32("TwNZBqLH",8) == 2593467388) strcat(s, "a");
if (crc32("hZNPpUa",7) == 2937081747) strcat(s, "s");
if (crc32("QtvtPOTpW",9) == 4275095642) strcat(s, "c");
if (crc32("XkAXbV",6) == 3290619644) strcat(s, "h");
if (crc32("pDXyP",5) == 3703518459) strcat(s, "h");
    return s;
}

char *fueled_verbs() {
    char *s = calloc(7);
    if (crc32("PQqwwhgirMRs",12) == 334036709) strcat(s, "g");
if (crc32("sqADJoHpHyxkJT",14) == 1786945450) strcat(s, "f");
if (crc32("HoMjEXhlgpM",11) == 1775518296) strcat(s, "x");
if (crc32("SDdTaXbLU",9) == 1318208657) strcat(s, "u");
if (crc32("jTzSzSgn",8) == 2802920756) strcat(s, "j");
if (crc32("lIjOCWfh",8) == 3500495678) strcat(s, "e");
if (crc32("OyFKqdZUOmq",11) == 646542901) strcat(s, "l");
if (crc32("wYsFZqsDg",9) == 3648195670) strcat(s, "T");
if (crc32("vPthY",5) == 2547393955) strcat(s, "e");
if (crc32("ESZLzguQB",9) == 766352759) strcat(s, "z");
if (crc32("MzlvXGNbfbOsST",14) == 4187862501) strcat(s, "d");
    return s;
}

char *landsliding_verbs() {
    char *s = calloc(12);
    if (crc32("AXqriup",7) == 3741484641) strcat(s, "l");
if (crc32("pTRiZXWzHmib",12) == 3844204028) strcat(s, "u");
if (crc32("eoJBeVCxDX",10) == 4057688636) strcat(s, "a");
if (crc32("xazonimGZdVtWjs",15) == 55996247) strcat(s, "Q");
if (crc32("LuWWXDJaYphA",12) == 4264494366) strcat(s, "n");
if (crc32("aiAIqfVhDdCQX",13) == 4008203241) strcat(s, "u");
if (crc32("ixzzWDhH",8) == 2561676918) strcat(s, "d");
if (crc32("PVbWlviZ",8) == 3127857918) strcat(s, "E");
if (crc32("GhtiGukohGK",11) == 2067365251) strcat(s, "s");
if (crc32("HDwSelstOLaxEl",14) == 2580475039) strcat(s, "P");
if (crc32("JhEdv",5) == 3830799768) strcat(s, "l");
if (crc32("qnyWUkYRlpN",11) == 1425389075) strcat(s, "p");
if (crc32("MQHXRxcLhvS",11) == 1387042962) strcat(s, "i");
if (crc32("sMgIsEZhkqOTWn",14) == 3903608339) strcat(s, "d");
if (crc32("EvyEZvBsFYUSWDb",15) == 2107955791) strcat(s, "y");
if (crc32("fesWqD",6) == 1766936480) strcat(s, "i");
if (crc32("YXMwRrSHcrQ",11) == 1758354564) strcat(s, "c");
if (crc32("PwDVr",5) == 765488941) strcat(s, "n");
if (crc32("ixtRLGYEQuQNL",13) == 48748511) strcat(s, "x");
if (crc32("gCBdkhCQCjlDoe",14) == 1797590686) strcat(s, "g");
    return s;
}

char *keepaway_verbs() {
    char *s = calloc(9);
    if (crc32("QjzqfPl",7) == 2845137303) strcat(s, "M");
if (crc32("iEswVnnTUHF",11) == 2328403105) strcat(s, "k");
if (crc32("lnyyuUadBmrc",12) == 2157196993) strcat(s, "e");
if (crc32("vvokFX",6) == 625850189) strcat(s, "j");
if (crc32("uaEKfyLyDvjo",12) == 2534111308) strcat(s, "e");
if (crc32("giIPscTtV",9) == 4189943715) strcat(s, "p");
if (crc32("GmgbgxEqXvD",11) == 2594877469) strcat(s, "a");
if (crc32("ORTOTmaKDzHgbHw",15) == 3196925512) strcat(s, "w");
if (crc32("dAEBp",5) == 1831012952) strcat(s, "a");
if (crc32("rbkjlS",6) == 2553072386) strcat(s, "s");
if (crc32("EPWyoKeMgvzZAd",14) == 3022809736) strcat(s, "y");
    return s;
}

char *retaught_verbs() {
    char *s = calloc(9);
    if (crc32("mSWIyj",6) == 1098641) strcat(s, "r");
if (crc32("NodlxysAZNKhg",13) == 3552206524) strcat(s, "e");
if (crc32("MMqQichrPFFhjU",14) == 1291204129) strcat(s, "t");
if (crc32("ioLfxfGqyWYF",12) == 1824733378) strcat(s, "a");
if (crc32("GrHnk",5) == 2710598436) strcat(s, "Z");
if (crc32("puxnfft",7) == 270890639) strcat(s, "u");
if (crc32("JuCgILLKw",9) == 156928397) strcat(s, "g");
if (crc32("JYitRiEgfX",10) == 1831325417) strcat(s, "D");
if (crc32("ttPTLTInVq",10) == 3915647190) strcat(s, "h");
if (crc32("lnXkgLGhXGIYVH",14) == 847565277) strcat(s, "a");
if (crc32("tgpVUmm",7) == 237584449) strcat(s, "t");
    return s;
}

char *scrub_verbs() {
    char *s = calloc(6);
    if (crc32("XalJspJDIrqOv",13) == 2833540877) strcat(s, "B");
if (crc32("PtvIK",5) == 2326099883) strcat(s, "s");
if (crc32("fkQqFky",7) == 437187132) strcat(s, "c");
if (crc32("eZtlpPL",7) == 1786191979) strcat(s, "C");
if (crc32("yXCjuVPtWrtrxDg",15) == 1617405656) strcat(s, "r");
if (crc32("QhxzRalPppMvH",13) == 3117718387) strcat(s, "S");
if (crc32("XXMJahOQ",8) == 4237160902) strcat(s, "u");
if (crc32("SKBKRibqtlXas",13) == 1682606017) strcat(s, "L");
if (crc32("WkajuPPYkLHyI",13) == 583065874) strcat(s, "b");
    return s;
}

char *dimidiating_verbs() {
    char *s = calloc(12);
    if (crc32("DCPDGmYWgmBLt",13) == 3754247515) strcat(s, "b");
if (crc32("cTHEk",5) == 1966652829) strcat(s, "d");
if (crc32("ZOrijcKyIoJCiw",14) == 1017183643) strcat(s, "i");
if (crc32("lnRXj",5) == 334739698) strcat(s, "x");
if (crc32("eQzdvGAufDfydkH",15) == 1023661828) strcat(s, "m");
if (crc32("QXIwkbjtWj",10) == 3186892423) strcat(s, "i");
if (crc32("ZxeOkGNqMZEdyP",14) == 1663712624) strcat(s, "d");
if (crc32("bBUGQGVatw",10) == 977255008) strcat(s, "E");
if (crc32("VVqlHwOZaMs",11) == 4110722054) strcat(s, "i");
if (crc32("rnfejeOjaoKMu",13) == 253378607) strcat(s, "a");
if (crc32("sCHKdphmywWI",12) == 918475726) strcat(s, "t");
if (crc32("NQJHXtaDbMuC",12) == 1691980566) strcat(s, "t");
if (crc32("KRNcUhCdO",9) == 2899726451) strcat(s, "i");
if (crc32("ZOGBbHysJhqUZZ",14) == 3757954113) strcat(s, "n");
if (crc32("zIPekIFaOd",10) == 33344803) strcat(s, "g");
    return s;
}

char *misdrawn_verbs() {
    char *s = calloc(9);
    if (crc32("LJTnHYMfHWHP",12) == 3541840652) strcat(s, "m");
if (crc32("kOhErKuWuAPORa",14) == 4218124499) strcat(s, "z");
if (crc32("STltaQsVZKjwxZn",15) == 798149165) strcat(s, "i");
if (crc32("OodSgAqUFHYZLjg",15) == 3489792353) strcat(s, "I");
if (crc32("sYWiZbEIS",9) == 3938703667) strcat(s, "s");
if (crc32("ldEMkCuHXq",10) == 1729577776) strcat(s, "d");
if (crc32("SSLpvxtG",8) == 3603058024) strcat(s, "Z");
if (crc32("JyXgFvLbYJ",10) == 917658319) strcat(s, "r");
if (crc32("ufNbAJmSjmnObs",14) == 1437185426) strcat(s, "a");
if (crc32("FCNvqAoipXFD",12) == 3656373043) strcat(s, "w");
if (crc32("TqmMq",5) == 3352503960) strcat(s, "U");
if (crc32("qVEXerCZXnhcGgQ",15) == 1019123981) strcat(s, "n");
    return s;
}

char *droop_verbs() {
    char *s = calloc(6);
    if (crc32("DHPbkQaoRLQkW",13) == 4147325621) strcat(s, "d");
if (crc32("JRIqNVbVhrsSc",13) == 1725343903) strcat(s, "k");
if (crc32("TaHyoGMdcQ",10) == 4236776655) strcat(s, "r");
if (crc32("WIiDnGiFijldP",13) == 3780087172) strcat(s, "G");
if (crc32("bCUvHgnt",8) == 401655067) strcat(s, "o");
if (crc32("UmUwhHLO",8) == 3212899817) strcat(s, "o");
if (crc32("bACRh",5) == 3307764327) strcat(s, "N");
if (crc32("JwUQQPuArNO",11) == 2934350240) strcat(s, "p");
    return s;
}

char *scend_verbs() {
    char *s = calloc(6);
    if (crc32("jpUQnA",6) == 2219746004) strcat(s, "B");
if (crc32("HtdSCtpI",8) == 2446179779) strcat(s, "s");
if (crc32("XJLBIelZv",9) == 3070358293) strcat(s, "c");
if (crc32("zwfjaMNEM",9) == 794769273) strcat(s, "q");
if (crc32("qYeMKtz",7) == 1125278706) strcat(s, "e");
if (crc32("lnerbQgC",8) == 2879945492) strcat(s, "l");
if (crc32("aHLHxqMo",8) == 2113690200) strcat(s, "n");
if (crc32("TdfqvZ",6) == 391019158) strcat(s, "J");
if (crc32("BQsrZ",5) == 1470161252) strcat(s, "d");
    return s;
}

char *entreat_verbs() {
    char *s = calloc(8);
    if (crc32("SCNuwnvqd",9) == 2116473879) strcat(s, "j");
if (crc32("sBidNRWEQQPGEr",14) == 367625446) strcat(s, "e");
if (crc32("GROxxNZbkYeKMW",14) == 651251948) strcat(s, "n");
if (crc32("CTrXERJRkeZBGVw",15) == 1359964544) strcat(s, "t");
if (crc32("DKUNDP",6) == 3786282732) strcat(s, "U");
if (crc32("zpfRuoGztMIw",12) == 2154018823) strcat(s, "r");
if (crc32("IvhAzdZcve",10) == 2407077298) strcat(s, "e");
if (crc32("YoJbIZfFNmlykcN",15) == 82828056) strcat(s, "a");
if (crc32("izRlHrnfxQRAunb",15) == 4035825416) strcat(s, "t");
    return s;
}

char *reveling_verbs() {
    char *s = calloc(9);
    if (crc32("Wraxuf",6) == 1357340940) strcat(s, "P");
if (crc32("AIKHxHTAoVReSRU",15) == 812000278) strcat(s, "r");
if (crc32("YbGOzBoMsLU",11) == 4284537151) strcat(s, "R");
if (crc32("unaDcz",6) == 3324436929) strcat(s, "e");
if (crc32("JrNqHo",6) == 1464250283) strcat(s, "v");
if (crc32("cyCBu",5) == 2658897467) strcat(s, "e");
if (crc32("IvROhuY",7) == 3833786055) strcat(s, "D");
if (crc32("ItXLNqoTkLHxCD",14) == 1246872876) strcat(s, "l");
if (crc32("cPixy",5) == 1518616555) strcat(s, "i");
if (crc32("mYLJII",6) == 3907784430) strcat(s, "N");
if (crc32("USxZFiwYPjw",11) == 2009618470) strcat(s, "n");
if (crc32("goZWpBZTKVSC",12) == 420691953) strcat(s, "g");
    return s;
}

char *rebound_verbs() {
    char *s = calloc(8);
    if (crc32("HMggf",5) == 4062887969) strcat(s, "G");
if (crc32("aAHvKmRRkiL",11) == 3669373587) strcat(s, "r");
if (crc32("GQLrRQIbxgB",11) == 487162595) strcat(s, "b");
if (crc32("bcaepspmAYHJJL",14) == 1128660592) strcat(s, "e");
if (crc32("TPsXO",5) == 1383682500) strcat(s, "h");
if (crc32("jkXstg",6) == 918844046) strcat(s, "b");
if (crc32("rFQvhIjlhqDVLAW",15) == 3301131540) strcat(s, "t");
if (crc32("uNanjtnEwkxAMCi",15) == 4104608350) strcat(s, "o");
if (crc32("hxxEOJwvFeLcS",13) == 369832757) strcat(s, "u");
if (crc32("DZfQWs",6) == 3108679776) strcat(s, "F");
if (crc32("WWffJtUEpzcu",12) == 2717885951) strcat(s, "n");
if (crc32("dpvHF",5) == 1104548847) strcat(s, "I");
if (crc32("IqnLDBb",7) == 1830885366) strcat(s, "d");
    return s;
}

char *guaranteed_verbs() {
    char *s = calloc(11);
    if (crc32("zfIerjMG",8) == 1654526170) strcat(s, "y");
if (crc32("erMNLqve",8) == 311943531) strcat(s, "g");
if (crc32("fChLuENGsMIl",12) == 2556148299) strcat(s, "m");
if (crc32("txLnSjByTEP",11) == 1067663514) strcat(s, "u");
if (crc32("HepsOIGpb",9) == 3212807874) strcat(s, "a");
if (crc32("DxbwzgJhAlCMEa",14) == 2111471347) strcat(s, "r");
if (crc32("KUTfPpQCRKDApTo",15) == 1725033690) strcat(s, "o");
if (crc32("EqFbtloyskWBU",13) == 1659286460) strcat(s, "a");
if (crc32("dALwtJ",6) == 437391418) strcat(s, "n");
if (crc32("SXsXgVig",8) == 2186137172) strcat(s, "t");
if (crc32("KUNyodbL",8) == 2696827127) strcat(s, "N");
if (crc32("iexzItkiVV",10) == 250353010) strcat(s, "e");
if (crc32("hwcMkXj",7) == 4252711664) strcat(s, "h");
if (crc32("mEmKPPnm",8) == 3430563807) strcat(s, "e");
if (crc32("lLDEBdfzDnPIxR",14) == 1356241353) strcat(s, "M");
if (crc32("OYOumgMHMwmQnv",14) == 1114800882) strcat(s, "d");
    return s;
}

char *flit_verbs() {
    char *s = calloc(5);
    if (crc32("ZDAKxSAGiE",10) == 298792023) strcat(s, "f");
if (crc32("hhTjwlkckX",10) == 927017021) strcat(s, "l");
if (crc32("oLrcXE",6) == 3848290889) strcat(s, "D");
if (crc32("eMNtD",5) == 3194492529) strcat(s, "i");
if (crc32("uXBCHQK",7) == 1254734119) strcat(s, "p");
if (crc32("fRJScYCdHvJ",11) == 1430200658) strcat(s, "t");
    return s;
}

char *beestride_verbs() {
    char *s = calloc(10);
    if (crc32("sJzbWpMMXLqhPe",14) == 3216699368) strcat(s, "S");
if (crc32("kRNpspjzCR",10) == 1644083114) strcat(s, "b");
if (crc32("UsFEKoTIB",9) == 3127014606) strcat(s, "g");
if (crc32("NdJCMRUTdBid",12) == 2192931880) strcat(s, "e");
if (crc32("kriTrsbPxbxl",12) == 4127257287) strcat(s, "M");
if (crc32("xJyPTF",6) == 2132005812) strcat(s, "e");
if (crc32("CAQapzFktLd",11) == 2136517690) strcat(s, "V");
if (crc32("lGHnTvvVGPVCrIY",15) == 652770300) strcat(s, "s");
if (crc32("OlRvdZ",6) == 2072518880) strcat(s, "B");
if (crc32("zPijmeMLTH",10) == 3276264805) strcat(s, "t");
if (crc32("SCsEXq",6) == 2117087180) strcat(s, "r");
if (crc32("UWfGFP",6) == 3244466641) strcat(s, "i");
if (crc32("imCWmVmxZQ",10) == 4003190637) strcat(s, "d");
if (crc32("JlVCtChGmRy",11) == 3989870404) strcat(s, "e");
    return s;
}

char *panegyrize_verbs() {
    char *s = calloc(11);
    if (crc32("cYswBNNc",8) == 3122132464) strcat(s, "p");
if (crc32("ytCvGrF",7) == 1924291504) strcat(s, "Q");
if (crc32("jZuGeCC",7) == 1389620568) strcat(s, "a");
if (crc32("FnYfZ",5) == 4028656375) strcat(s, "d");
if (crc32("hSkLwCUlg",9) == 2576016952) strcat(s, "n");
if (crc32("tUvyuFTjW",9) == 2079353733) strcat(s, "e");
if (crc32("qTBNDKcgz",9) == 2698219220) strcat(s, "F");
if (crc32("aeQGbKHhUpY",11) == 859487771) strcat(s, "g");
if (crc32("BLaflSJuDkTGKKR",15) == 2736270674) strcat(s, "T");
if (crc32("uqHWfZPjsIo",11) == 1143615061) strcat(s, "y");
if (crc32("lWgEGdWP",8) == 950898798) strcat(s, "u");
if (crc32("dEfIjEJMiG",10) == 2172930736) strcat(s, "r");
if (crc32("McjzOoum",8) == 2522799711) strcat(s, "i");
if (crc32("xNMqrf",6) == 432586085) strcat(s, "c");
if (crc32("viPxPWfo",8) == 2555079374) strcat(s, "z");
if (crc32("oRiObXlbGO",10) == 2145335769) strcat(s, "g");
if (crc32("xjFkTlZ",7) == 4183009992) strcat(s, "e");
    return s;
}

char *beg_verbs() {
    char *s = calloc(4);
    if (crc32("dyUCogRdjHMX",12) == 228004924) strcat(s, "b");
if (crc32("cofYElRPEBwwpR",14) == 4020141734) strcat(s, "Y");
if (crc32("nBytDTfyEoVhUB",14) == 3638865654) strcat(s, "e");
if (crc32("tjAWg",5) == 3666571814) strcat(s, "w");
if (crc32("vdTmcNXnMy",10) == 1795309427) strcat(s, "g");
    return s;
}

char *housed_verbs() {
    char *s = calloc(7);
    if (crc32("jfXZaZHKZsR",11) == 1282873080) strcat(s, "h");
if (crc32("cTtSbMp",7) == 994474654) strcat(s, "o");
if (crc32("vrrdALSwv",9) == 1561886257) strcat(s, "e");
if (crc32("vAZFFArqi",9) == 2131201230) strcat(s, "u");
if (crc32("FIYzbIgiDfK",11) == 2406498354) strcat(s, "D");
if (crc32("soRfFWDsQKHS",12) == 2670876765) strcat(s, "s");
if (crc32("wJFUqIGbxmNMyyC",15) == 2813744583) strcat(s, "a");
if (crc32("gXlmWBRm",8) == 803791168) strcat(s, "e");
if (crc32("FsbmxFFLGyTyz",13) == 1339911300) strcat(s, "d");
    return s;
}

char *satirize_verbs() {
    char *s = calloc(9);
    if (crc32("pSzujHO",7) == 2401110582) strcat(s, "s");
if (crc32("gKBoRlVVA",9) == 920842849) strcat(s, "a");
if (crc32("FtSJYVSUVz",10) == 4028283334) strcat(s, "n");
if (crc32("eeErfAEOzEK",11) == 1306158493) strcat(s, "t");
if (crc32("xTqXWzxTGNt",11) == 4115332147) strcat(s, "q");
if (crc32("LEWJopSDe",9) == 1074338104) strcat(s, "i");
if (crc32("SBhINoxrZNC",11) == 3304820315) strcat(s, "r");
if (crc32("dbYFJQr",7) == 1557381704) strcat(s, "c");
if (crc32("FCZQEOBfG",9) == 1468078184) strcat(s, "i");
if (crc32("MumCCu",6) == 1939690140) strcat(s, "z");
if (crc32("MFKDzornSSo",11) == 3755942124) strcat(s, "e");
    return s;
}

char *subscribed_verbs() {
    char *s = calloc(11);
    if (crc32("DxWuD",5) == 674794872) strcat(s, "h");
if (crc32("MSUYhxeWdipibUa",15) == 275842489) strcat(s, "s");
if (crc32("XismHfowweL",11) == 245252946) strcat(s, "X");
if (crc32("KLdmNFcYMy",10) == 3349648545) strcat(s, "u");
if (crc32("LahFoWQ",7) == 1615790349) strcat(s, "b");
if (crc32("HyVovkg",7) == 386938658) strcat(s, "s");
if (crc32("xnWdgfQwexUDYg",14) == 1510167348) strcat(s, "c");
if (crc32("yDzWSLeVaOvRieT",15) == 538225216) strcat(s, "r");
if (crc32("mMEmYdGdjIJDLh",14) == 2987305711) strcat(s, "N");
if (crc32("BSKGnQyIvX",10) == 2238022058) strcat(s, "i");
if (crc32("LKjfWGpFvdc",11) == 949150965) strcat(s, "b");
if (crc32("CvQRMSCsYul",11) == 1223687094) strcat(s, "P");
if (crc32("lvjFe",5) == 168796595) strcat(s, "e");
if (crc32("EMlFp",5) == 2292452159) strcat(s, "d");
    return s;
}

char *scathed_verbs() {
    char *s = calloc(8);
    if (crc32("xFwjQIXr",8) == 947543646) strcat(s, "s");
if (crc32("hhKnOzPk",8) == 1528282348) strcat(s, "M");
if (crc32("hkttvlCbSrxTKG",14) == 596282470) strcat(s, "c");
if (crc32("qyfkbruHbZyE",12) == 2441086652) strcat(s, "a");
if (crc32("WpyOsJPajsSGA",13) == 3124523088) strcat(s, "e");
if (crc32("LsNNeKhAe",9) == 1387217404) strcat(s, "t");
if (crc32("zNRIiAUMJwu",11) == 3820244622) strcat(s, "h");
if (crc32("ClmUjhYjwbIE",12) == 3791479411) strcat(s, "e");
if (crc32("OVkTRIefahGsKaM",15) == 2841277719) strcat(s, "O");
if (crc32("VvMxIZg",7) == 3794996942) strcat(s, "d");
    return s;
}

char *tried_verbs() {
    char *s = calloc(6);
    if (crc32("illCOPcQGqz",11) == 1097924780) strcat(s, "a");
if (crc32("OGwcLxeP",8) == 608658496) strcat(s, "t");
if (crc32("ogdLxTSZUhIYm",13) == 74513240) strcat(s, "Z");
if (crc32("iLtCYFXBOrIibOu",15) == 2092897473) strcat(s, "r");
if (crc32("nCQPPDAKodhv",12) == 3875801509) strcat(s, "i");
if (crc32("dGDaEsBPxZBT",12) == 3559675557) strcat(s, "e");
if (crc32("VoTNe",5) == 715348755) strcat(s, "d");
    return s;
}

char *spring_verbs() {
    char *s = calloc(7);
    if (crc32("rVRQL",5) == 3537904669) strcat(s, "H");
if (crc32("OGKqyYH",7) == 2307666683) strcat(s, "s");
if (crc32("FqeZrX",6) == 2729184568) strcat(s, "Q");
if (crc32("KxBXIpKUvNOUC",13) == 3375967422) strcat(s, "p");
if (crc32("BRsrlCzxdhsJLEz",15) == 2752698924) strcat(s, "J");
if (crc32("uoUfyuWAXgIfVI",14) == 97711165) strcat(s, "r");
if (crc32("JPDVJjcKjNhTQM",14) == 3223986192) strcat(s, "i");
if (crc32("nSltJAUQWD",10) == 648990004) strcat(s, "n");
if (crc32("GLOHfVVTPzKoWbA",15) == 4233989862) strcat(s, "c");
if (crc32("XzTbTeCwTDX",11) == 166269754) strcat(s, "g");
    return s;
}

char *panelled_verbs() {
    char *s = calloc(9);
    if (crc32("sjvsLOKFjLA",11) == 2672479103) strcat(s, "p");
if (crc32("AfSwgACENddtjlF",15) == 1790939624) strcat(s, "E");
if (crc32("pCCenrPNiNsuAD",14) == 1994370129) strcat(s, "a");
if (crc32("rRXgGZPKAoS",11) == 1517069863) strcat(s, "n");
if (crc32("yKPuxTHMcmvjLBl",15) == 3295934354) strcat(s, "i");
if (crc32("CoVLHi",6) == 3091464662) strcat(s, "e");
if (crc32("xzqjUuk",7) == 2586077365) strcat(s, "l");
if (crc32("agovxrKLv",9) == 1179356931) strcat(s, "l");
if (crc32("bnKXmeLtywJWndD",15) == 3205187270) strcat(s, "e");
if (crc32("WHxUgZgkTTcoXu",14) == 3122470041) strcat(s, "d");
    return s;
}

char *budge_verbs() {
    char *s = calloc(6);
    if (crc32("tQxDs",5) == 3949940123) strcat(s, "K");
if (crc32("bdeBz",5) == 2903969546) strcat(s, "b");
if (crc32("kWXaALXJuM",10) == 649540728) strcat(s, "a");
if (crc32("dvGlQoRNMKTNyow",15) == 2563432931) strcat(s, "u");
if (crc32("ItMojQlBjuB",11) == 4123343272) strcat(s, "F");
if (crc32("MaAhMvrmG",9) == 1390919038) strcat(s, "d");
if (crc32("xxrAEdvM",8) == 899921994) strcat(s, "J");
if (crc32("GivUjEb",7) == 3532182822) strcat(s, "g");
if (crc32("dDbXzuwKANHtcKx",15) == 1287974176) strcat(s, "B");
if (crc32("yMOnQQfAW",9) == 2933481115) strcat(s, "e");
    return s;
}

char *overmultiplied_verbs() {
    char *s = calloc(15);
    if (crc32("RIzphsSjV",9) == 589682965) strcat(s, "e");
if (crc32("jPeOCsA",7) == 1536433374) strcat(s, "o");
if (crc32("pWxxcFd",7) == 2714447068) strcat(s, "v");
if (crc32("HoNeTQ",6) == 3200718537) strcat(s, "e");
if (crc32("lJYtihwyKDdd",12) == 839597355) strcat(s, "L");
if (crc32("rSgBhn",6) == 1515881366) strcat(s, "r");
if (crc32("EVhGV",5) == 3105942597) strcat(s, "G");
if (crc32("JDoJm",5) == 3121172200) strcat(s, "m");
if (crc32("hgkbgyEs",8) == 271567387) strcat(s, "u");
if (crc32("XNaSQzJPxdIOal",14) == 1442958692) strcat(s, "l");
if (crc32("pTXnYteqiGYfB",13) == 3104133741) strcat(s, "Y");
if (crc32("uumYHPYMFMJSGH",14) == 421941776) strcat(s, "t");
if (crc32("rGGyarFZJxxnSL",14) == 917028138) strcat(s, "i");
if (crc32("RZlynDytXCbVoza",15) == 4030695532) strcat(s, "p");
if (crc32("eqVqjjSxWIa",11) == 981282479) strcat(s, "Y");
if (crc32("dlwfixdFMZp",11) == 2174106895) strcat(s, "l");
if (crc32("COWVOpFrEJzV",12) == 3821106331) strcat(s, "i");
if (crc32("BxrTz",5) == 1767924785) strcat(s, "y");
if (crc32("HCpoQi",6) == 4074803795) strcat(s, "e");
if (crc32("wdwSiq",6) == 2220268293) strcat(s, "E");
if (crc32("tqGFruycWfS",11) == 1015654630) strcat(s, "d");
    return s;
}

char *mismaking_verbs() {
    char *s = calloc(10);
    if (crc32("XtxHntA",7) == 2340802283) strcat(s, "o");
if (crc32("gzfDTjLUjEuZxm",14) == 3217045349) strcat(s, "m");
if (crc32("mMzdtOgCNdVZfje",15) == 2271505949) strcat(s, "x");
if (crc32("qykYEAGduSoHU",13) == 207242496) strcat(s, "i");
if (crc32("gOBzNHSCb",9) == 3968298460) strcat(s, "s");
if (crc32("AineAhL",7) == 3641129695) strcat(s, "s");
if (crc32("FgdItVDgbzQbjs",14) == 4268131737) strcat(s, "l");
if (crc32("HpjgCVHCZdrVFyO",15) == 2087560447) strcat(s, "m");
if (crc32("XAcIIcXEq",9) == 127541882) strcat(s, "o");
if (crc32("fqBMXHN",7) == 894576030) strcat(s, "a");
if (crc32("puOXcWyY",8) == 1768470462) strcat(s, "I");
if (crc32("YWsbScWVtK",10) == 1315968195) strcat(s, "k");
if (crc32("qrmlE",5) == 1562027736) strcat(s, "j");
if (crc32("FgOimCl",7) == 3969170952) strcat(s, "i");
if (crc32("DYLNinfXl",9) == 2885681896) strcat(s, "n");
if (crc32("xecTcpDUcmiUJNA",15) == 2342859594) strcat(s, "Z");
if (crc32("xlOFfsSbQo",10) == 3887896110) strcat(s, "g");
    return s;
}

char *simmer_verbs() {
    char *s = calloc(7);
    if (crc32("rgneAee",7) == 2375680577) strcat(s, "s");
if (crc32("uTSkXfFBPfzrqru",15) == 249712285) strcat(s, "i");
if (crc32("YTGNplKjjZcv",12) == 3960192566) strcat(s, "m");
if (crc32("bPdAPwZmF",9) == 2591814322) strcat(s, "m");
if (crc32("enUuJUOzJRpMgXR",15) == 3491034624) strcat(s, "h");
if (crc32("WblIyZKJA",9) == 558185266) strcat(s, "e");
if (crc32("mctdrUTqKrbN",12) == 2617985376) strcat(s, "B");
if (crc32("BuJLFRGaBk",10) == 875354439) strcat(s, "r");
    return s;
}

char *wived_verbs() {
    char *s = calloc(6);
    if (crc32("XsnWfnaRTnYCYcB",15) == 1652053063) strcat(s, "X");
if (crc32("HjuBiYdCoSuU",12) == 2934737877) strcat(s, "w");
if (crc32("TBhAoDWT",8) == 253445018) strcat(s, "d");
if (crc32("sbYdQstDv",9) == 2595478237) strcat(s, "i");
if (crc32("xXTyCl",6) == 3738128538) strcat(s, "v");
if (crc32("tLWKdWl",7) == 3319244970) strcat(s, "e");
if (crc32("RGvYSadgejEXY",13) == 1603582730) strcat(s, "d");
    return s;
}

char *velured_verbs() {
    char *s = calloc(8);
    if (crc32("gRDUP",5) == 1459635856) strcat(s, "v");
if (crc32("wyDmqEdWwFNK",12) == 4135650760) strcat(s, "e");
if (crc32("cvpTFCGLKHkuq",13) == 143540703) strcat(s, "j");
if (crc32("gSPAxZT",7) == 879508996) strcat(s, "l");
if (crc32("FHovOC",6) == 2874010381) strcat(s, "u");
if (crc32("FgUvyEfNkt",10) == 1003479856) strcat(s, "r");
if (crc32("XoKsSm",6) == 4064989666) strcat(s, "r");
if (crc32("uamCKsfeYYjbjl",14) == 795291383) strcat(s, "e");
if (crc32("dCVcmWUzgbOe",12) == 736735240) strcat(s, "d");
    return s;
}

char *cooed_verbs() {
    char *s = calloc(6);
    if (crc32("ZHUraFxhOstG",12) == 66621202) strcat(s, "c");
if (crc32("aJiBuYqdnbR",11) == 2650623325) strcat(s, "o");
if (crc32("MUwHvWrSd",9) == 2996985444) strcat(s, "o");
if (crc32("IfPoWL",6) == 1568765686) strcat(s, "k");
if (crc32("RVMLjYtUViuykCx",15) == 801968689) strcat(s, "e");
if (crc32("GgLwin",6) == 381957579) strcat(s, "d");
    return s;
}

char *sloped_verbs() {
    char *s = calloc(7);
    if (crc32("lPIQcEmdbfK",11) == 3392610343) strcat(s, "s");
if (crc32("OSnkx",5) == 4155893994) strcat(s, "H");
if (crc32("GOxNAUXdehi",11) == 1499947760) strcat(s, "l");
if (crc32("OKLNDEG",7) == 3193827432) strcat(s, "o");
if (crc32("lrVQb",5) == 872102693) strcat(s, "p");
if (crc32("yeeWsyBJCgp",11) == 3210983056) strcat(s, "e");
if (crc32("QluKVJVVtDrRGMJ",15) == 277806375) strcat(s, "b");
if (crc32("YdJgCxPkTAknDb",14) == 3158126602) strcat(s, "d");
    return s;
}

char *cockled_verbs() {
    char *s = calloc(8);
    if (crc32("NYwxGCJpylz",11) == 309016233) strcat(s, "c");
if (crc32("vkiTQsQlHd",10) == 3032705021) strcat(s, "K");
if (crc32("mhikK",5) == 2031305174) strcat(s, "o");
if (crc32("AgAJffGXpaJcp",13) == 3974593525) strcat(s, "c");
if (crc32("VDzKBlSNoWHIol",14) == 1169693010) strcat(s, "S");
if (crc32("mYwCpYXFfQWLO",13) == 2156104802) strcat(s, "k");
if (crc32("gYShH",5) == 1088712071) strcat(s, "M");
if (crc32("KZblgcn",7) == 1295323236) strcat(s, "l");
if (crc32("LCltVcurb",9) == 3612842952) strcat(s, "e");
if (crc32("wqCFWfHjqzgyVNf",15) == 926088542) strcat(s, "G");
if (crc32("wOKxhmMGLSE",11) == 3027144728) strcat(s, "d");
    return s;
}

char *overurbanized_verbs() {
    char *s = calloc(14);
    if (crc32("uRyUQdJXz",9) == 3891667390) strcat(s, "r");
if (crc32("CKcwy",5) == 2521979240) strcat(s, "o");
if (crc32("dHjJmYlg",8) == 1307888723) strcat(s, "v");
if (crc32("JVjtC",5) == 3686860197) strcat(s, "e");
if (crc32("AKEMgOliXR",10) == 2218258152) strcat(s, "r");
if (crc32("PEAhLE",6) == 306802363) strcat(s, "u");
if (crc32("sRfoxhWn",8) == 379391173) strcat(s, "a");
if (crc32("TxtHrZpsk",9) == 3759100948) strcat(s, "r");
if (crc32("yBHDcwkKjn",10) == 871168493) strcat(s, "b");
if (crc32("BkCvUaRSzaVNFIu",15) == 1062330673) strcat(s, "a");
if (crc32("buxGex",6) == 2876708861) strcat(s, "H");
if (crc32("UjsGpmvfIo",10) == 1118932398) strcat(s, "n");
if (crc32("mpcNnkDRFpdcCI",14) == 2303561842) strcat(s, "i");
if (crc32("qCpikS",6) == 297499854) strcat(s, "X");
if (crc32("oqdkHMLCpc",10) == 3797737394) strcat(s, "z");
if (crc32("JoqhbIdPfcRPx",13) == 937037646) strcat(s, "R");
if (crc32("wCDJZBwQ",8) == 2606897325) strcat(s, "e");
if (crc32("FqbqGeK",7) == 3337174578) strcat(s, "d");
    return s;
}

char *ascend_verbs() {
    char *s = calloc(7);
    if (crc32("YSJrLPFHV",9) == 3715230479) strcat(s, "a");
if (crc32("HVULjzjJ",8) == 1505659655) strcat(s, "J");
if (crc32("iQuXCFLxGU",10) == 784162082) strcat(s, "s");
if (crc32("FstbLXkixrHaMZ",14) == 588682567) strcat(s, "c");
if (crc32("CuYAJUzNlsMGKQL",15) == 899752572) strcat(s, "N");
if (crc32("pOSQQzdXv",9) == 3067341160) strcat(s, "e");
if (crc32("MRrenbncr",9) == 4171653972) strcat(s, "n");
if (crc32("DVAhWYClA",9) == 1368015265) strcat(s, "N");
if (crc32("MIjHeUeojBLHPqX",15) == 4233542732) strcat(s, "d");
    return s;
}

char *primp_verbs() {
    char *s = calloc(6);
    if (crc32("wSSxcjlZt",9) == 40625683) strcat(s, "j");
if (crc32("lOkQxKyNoWlJ",12) == 4172538559) strcat(s, "p");
if (crc32("TyjkH",5) == 3598078817) strcat(s, "x");
if (crc32("hzWFLX",6) == 4256615260) strcat(s, "r");
if (crc32("Fdfdl",5) == 3488006767) strcat(s, "Z");
if (crc32("RYMFuwKUhHW",11) == 1050122318) strcat(s, "i");
if (crc32("hcwPfIjoe",9) == 3334412763) strcat(s, "k");
if (crc32("bTuoCxQSKlHI",12) == 518880957) strcat(s, "m");
if (crc32("OHbrrVZXIats",12) == 2025776757) strcat(s, "p");
    return s;
}

char *plopped_verbs() {
    char *s = calloc(8);
    if (crc32("CXNGkVdFhv",10) == 3813133793) strcat(s, "p");
if (crc32("LXDQOX",6) == 2858610271) strcat(s, "l");
if (crc32("FcFjgUgNwvr",11) == 3951631900) strcat(s, "s");
if (crc32("eeaueLegb",9) == 1507086046) strcat(s, "o");
if (crc32("XtYAvLu",7) == 663827651) strcat(s, "p");
if (crc32("VXlZPVJRDB",10) == 209948471) strcat(s, "h");
if (crc32("yUekjudOBXjdUfT",15) == 2084118259) strcat(s, "p");
if (crc32("ymPdO",5) == 1893893743) strcat(s, "e");
if (crc32("XSmWmoy",7) == 11647254) strcat(s, "R");
if (crc32("AkOPuWWOS",9) == 2536800629) strcat(s, "d");
    return s;
}

char *restipulating_verbs() {
    char *s = calloc(14);
    if (crc32("GpLwF",5) == 3247418600) strcat(s, "r");
if (crc32("GcWIZKN",7) == 491633710) strcat(s, "e");
if (crc32("yGauzDtXMzANaD",14) == 1737794086) strcat(s, "s");
if (crc32("FQcnHnaE",8) == 2980070244) strcat(s, "T");
if (crc32("MwGzGOOwUDG",11) == 2694745833) strcat(s, "t");
if (crc32("zVdQZjiGF",9) == 3779965869) strcat(s, "x");
if (crc32("oIJGZroRp",9) == 2310139508) strcat(s, "i");
if (crc32("JCkjABXl",8) == 583797247) strcat(s, "n");
if (crc32("clmvUUxODLxEGb",14) == 1925079194) strcat(s, "p");
if (crc32("qpTPAtNT",8) == 2171643368) strcat(s, "H");
if (crc32("ijhPexAVaqDKPen",15) == 2577793144) strcat(s, "u");
if (crc32("SwTTOexhwuko",12) == 174527961) strcat(s, "j");
if (crc32("zaqVPWSnGiWi",12) == 2737579414) strcat(s, "l");
if (crc32("qcVkXUcBlmgkR",13) == 2033106123) strcat(s, "a");
if (crc32("FGEepSlEyYLkfO",14) == 1412832575) strcat(s, "t");
if (crc32("unpOzCrs",8) == 3845103238) strcat(s, "c");
if (crc32("FTsabRouTmq",11) == 3068300649) strcat(s, "i");
if (crc32("llXvjujI",8) == 2928415804) strcat(s, "n");
if (crc32("mKIRJVRqWClIXF",14) == 2017181845) strcat(s, "Q");
if (crc32("LAEylO",6) == 1946851639) strcat(s, "g");
    return s;
}

char *sumup_verbs() {
    char *s = calloc(6);
    if (crc32("wCsaDMObaTvqDvm",15) == 3428502254) strcat(s, "c");
if (crc32("aZFcZxItQaf",11) == 3273973226) strcat(s, "s");
if (crc32("jpYigJbStmMalrT",15) == 3310678653) strcat(s, "u");
if (crc32("QZXEgofpNl",10) == 3829809010) strcat(s, "I");
if (crc32("NoOQH",5) == 3804600618) strcat(s, "m");
if (crc32("Yqywdw",6) == 3599297052) strcat(s, "u");
if (crc32("vhCaejxDFN",10) == 273802292) strcat(s, "p");
    return s;
}

char *botanizing_verbs() {
    char *s = calloc(11);
    if (crc32("yWTawXAZxw",10) == 1980263130) strcat(s, "b");
if (crc32("LGwnLoPDFmeHex",14) == 1187098994) strcat(s, "o");
if (crc32("XaMjQ",5) == 2975247118) strcat(s, "J");
if (crc32("krAkvaH",7) == 2401168886) strcat(s, "t");
if (crc32("cuotfdhqXsoWO",13) == 2195489877) strcat(s, "S");
if (crc32("UCEXtYdAoRlZ",12) == 127153510) strcat(s, "a");
if (crc32("msIszsIiXFauG",13) == 4125038452) strcat(s, "K");
if (crc32("qfuBKydEHAAi",12) == 1624953721) strcat(s, "n");
if (crc32("YQDExfgKZcKem",13) == 58898538) strcat(s, "p");
if (crc32("SPRCJsmMZ",9) == 551126220) strcat(s, "i");
if (crc32("WdeUMZ",6) == 1679633065) strcat(s, "z");
if (crc32("bkuXpdR",7) == 217629682) strcat(s, "i");
if (crc32("myVNrzImVy",10) == 2320322167) strcat(s, "n");
if (crc32("WipLJmM",7) == 3653661006) strcat(s, "g");
    return s;
}

char *overdisciplining_verbs() {
    char *s = calloc(17);
    if (crc32("XoIepyOiDxP",11) == 3304764886) strcat(s, "o");
if (crc32("RxbyIWnA",8) == 1762820572) strcat(s, "v");
if (crc32("zHRlIWOF",8) == 1432601202) strcat(s, "e");
if (crc32("pecYuHUYJNOWqW",14) == 2319020815) strcat(s, "r");
if (crc32("cTisQ",5) == 61331853) strcat(s, "d");
if (crc32("qFccEkUKi",9) == 1282669635) strcat(s, "o");
if (crc32("KFAkjL",6) == 2226938858) strcat(s, "i");
if (crc32("sxBjA",5) == 990662388) strcat(s, "s");
if (crc32("XTuIpN",6) == 25014706) strcat(s, "c");
if (crc32("evoVDxTrwtu",11) == 1132166155) strcat(s, "N");
if (crc32("sGTPkNguErLn",12) == 2781889712) strcat(s, "i");
if (crc32("RiGCSlP",7) == 2371038554) strcat(s, "n");
if (crc32("AiVxPZYB",8) == 3569563309) strcat(s, "p");
if (crc32("EfJMdPJw",8) == 2451459157) strcat(s, "j");
if (crc32("JMkDg",5) == 3193859374) strcat(s, "l");
if (crc32("RgbkNeZiVXLYUT",14) == 1415380348) strcat(s, "i");
if (crc32("SGuvQDmEMrFBSY",14) == 380644730) strcat(s, "n");
if (crc32("lQPHQ",5) == 2703331145) strcat(s, "i");
if (crc32("hgVDB",5) == 3198327242) strcat(s, "m");
if (crc32("qxtNjKjLnyltRg",14) == 45287916) strcat(s, "n");
if (crc32("GNTdoOYdBvwitZl",15) == 2621107749) strcat(s, "g");
    return s;
}

char *quizzing_verbs() {
    char *s = calloc(9);
    if (crc32("zmcSpT",6) == 2122914023) strcat(s, "q");
if (crc32("JRexQoR",7) == 3379965900) strcat(s, "u");
if (crc32("QkISPPcGA",9) == 1380231761) strcat(s, "i");
if (crc32("AUMvMKXn",8) == 320305499) strcat(s, "p");
if (crc32("TytRx",5) == 2553116500) strcat(s, "z");
if (crc32("yhVQAwZnKyOsY",13) == 33688955) strcat(s, "x");
if (crc32("pnClD",5) == 774636889) strcat(s, "z");
if (crc32("opFJHStTVRB",11) == 2640578436) strcat(s, "u");
if (crc32("fKsOBqesNatxx",13) == 2732401328) strcat(s, "i");
if (crc32("haEHyzOdG",9) == 562095958) strcat(s, "a");
if (crc32("QDOlaa",6) == 529200511) strcat(s, "n");
if (crc32("nJmuOiIWKzajuZ",14) == 2930199441) strcat(s, "g");
    return s;
}

char *shied_verbs() {
    char *s = calloc(6);
    if (crc32("GqjQg",5) == 3393479333) strcat(s, "s");
if (crc32("VgWRIAxrAXrtjH",14) == 3054640522) strcat(s, "Q");
if (crc32("BqnEBovUzRt",11) == 788544910) strcat(s, "h");
if (crc32("hBiSCxCsCKuUuB",14) == 4191089458) strcat(s, "i");
if (crc32("JaBhqCblEJDmH",13) == 4025312131) strcat(s, "e");
if (crc32("MGNPXP",6) == 3869883230) strcat(s, "d");
    return s;
}

char *miscensure_verbs() {
    char *s = calloc(11);
    if (crc32("BOJpvUdZK",9) == 2561364504) strcat(s, "U");
if (crc32("dgBOYZhtfepqpSK",15) == 3047456198) strcat(s, "m");
if (crc32("AbnyFAkwu",9) == 3399033811) strcat(s, "v");
if (crc32("kpDraBQlG",9) == 3137346995) strcat(s, "i");
if (crc32("IkYmAO",6) == 2436792620) strcat(s, "s");
if (crc32("FLxvvgYjLw",10) == 788803455) strcat(s, "s");
if (crc32("MUwBW",5) == 4234937200) strcat(s, "c");
if (crc32("JAVgA",5) == 874505925) strcat(s, "C");
if (crc32("pxqKoRYWPWGsMhJ",15) == 865990367) strcat(s, "e");
if (crc32("evEWMwNetNHqC",13) == 1051468471) strcat(s, "n");
if (crc32("fFMCjzSOlI",10) == 733724008) strcat(s, "s");
if (crc32("gdpbajSZZuc",11) == 91176753) strcat(s, "Y");
if (crc32("RIGqMGiqqchnlp",14) == 971441025) strcat(s, "u");
if (crc32("pBJNFfjPaoI",11) == 1087075629) strcat(s, "b");
if (crc32("bliRlqTFMITkR",13) == 543931946) strcat(s, "r");
if (crc32("BZiJneZbLUqjKn",14) == 1704826854) strcat(s, "e");
    return s;
}

char *whining_verbs() {
    char *s = calloc(8);
    if (crc32("BIGxPtmnEBcj",12) == 1656969101) strcat(s, "C");
if (crc32("yJrhx",5) == 1657170277) strcat(s, "w");
if (crc32("JUidcxOesumnfj",14) == 2303859696) strcat(s, "F");
if (crc32("yPRbWVtQM",9) == 2184779320) strcat(s, "h");
if (crc32("FXHfDys",7) == 1824942549) strcat(s, "i");
if (crc32("vqLYvVHbRprUG",13) == 4265345519) strcat(s, "d");
if (crc32("JiwOoFIkeUgAm",13) == 1619332942) strcat(s, "n");
if (crc32("yljiPNFawguo",12) == 2794005543) strcat(s, "i");
if (crc32("KGSzdXrxZ",9) == 2016714471) strcat(s, "n");
if (crc32("DibZALHTByer",12) == 3590294807) strcat(s, "g");
    return s;
}

char *receive_verbs() {
    char *s = calloc(8);
    if (crc32("iZrHySrPTsK",11) == 4067577287) strcat(s, "x");
if (crc32("yqmghwLvHeS",11) == 1764346442) strcat(s, "r");
if (crc32("RZzxpYcoOGFTIk",14) == 2090134339) strcat(s, "i");
if (crc32("shcluCtIOZsg",12) == 1661638633) strcat(s, "e");
if (crc32("qqMhynQmtzNwmf",14) == 2290490260) strcat(s, "i");
if (crc32("MswtUKpWDmeks",13) == 1515060817) strcat(s, "c");
if (crc32("vFoqUScCbCIekMu",15) == 2828062577) strcat(s, "e");
if (crc32("ZiUfa",5) == 2445994314) strcat(s, "i");
if (crc32("KdjqOju",7) == 2361382855) strcat(s, "v");
if (crc32("FQtgdLVQ",8) == 2308611530) strcat(s, "e");
    return s;
}

char *givein_verbs() {
    char *s = calloc(7);
    if (crc32("fTJaivKGoFPYQCA",15) == 2442121294) strcat(s, "A");
if (crc32("aoAYc",5) == 3484385213) strcat(s, "g");
if (crc32("kUkTFOkSs",9) == 956337359) strcat(s, "G");
if (crc32("JYGdHqKMWWE",11) == 2672547825) strcat(s, "i");
if (crc32("wvIplgwx",8) == 4217128934) strcat(s, "X");
if (crc32("yjzdCd",6) == 2495219909) strcat(s, "v");
if (crc32("GJbfTkhZGiymvN",14) == 3694224193) strcat(s, "e");
if (crc32("IrlVZfppjIMHwuB",15) == 2354543064) strcat(s, "b");
if (crc32("gBhyWmkvWjLiN",13) == 3414411699) strcat(s, "i");
if (crc32("bKPyDRTb",8) == 303618944) strcat(s, "A");
if (crc32("HchInzRzkIBf",12) == 3189917017) strcat(s, "n");
    return s;
}

char *blat_verbs() {
    char *s = calloc(5);
    if (crc32("JWLbdIORsBWciK",14) == 53016407) strcat(s, "b");
if (crc32("xQgNnGZVZabdI",13) == 2592489452) strcat(s, "k");
if (crc32("BgEFDeTsF",9) == 1390580838) strcat(s, "l");
if (crc32("TiXSUZdbxOv",11) == 2097393620) strcat(s, "E");
if (crc32("JByegeaYZOwf",12) == 3722438315) strcat(s, "a");
if (crc32("UWZddLlMpZ",10) == 2999902477) strcat(s, "t");
    return s;
}

char *brocaded_verbs() {
    char *s = calloc(9);
    if (crc32("ssSyhwWR",8) == 991306041) strcat(s, "b");
if (crc32("DQLvQQwi",8) == 2619064927) strcat(s, "X");
if (crc32("cpoACScEjItfx",13) == 4164023358) strcat(s, "r");
if (crc32("IcsOzhdrZlMJd",13) == 550142635) strcat(s, "x");
if (crc32("AwSrFxErjipz",12) == 3959216082) strcat(s, "o");
if (crc32("GXPDLQN",7) == 435966781) strcat(s, "j");
if (crc32("xHdWTuhtCGNZwWU",15) == 1717694223) strcat(s, "c");
if (crc32("awitdsCk",8) == 3745259975) strcat(s, "j");
if (crc32("Gxtbe",5) == 3146884937) strcat(s, "a");
if (crc32("lARmRKpGTaZs",12) == 3359779663) strcat(s, "h");
if (crc32("yNkoyEZAN",9) == 3072886635) strcat(s, "d");
if (crc32("FXxJpVqK",8) == 755718697) strcat(s, "N");
if (crc32("cZJZyZNrId",10) == 411712879) strcat(s, "e");
if (crc32("EFcCiaHWR",9) == 3082949983) strcat(s, "d");
    return s;
}

char *teeoff_verbs() {
    char *s = calloc(7);
    if (crc32("ZkVAk",5) == 2647588567) strcat(s, "m");
if (crc32("jRCLGeTmFElsj",13) == 4068287049) strcat(s, "t");
if (crc32("mSfnkGrcMRzqb",13) == 3904712173) strcat(s, "M");
if (crc32("nINxBTBT",8) == 2042704872) strcat(s, "e");
if (crc32("IJQQrNXvnqqjngx",15) == 3010185424) strcat(s, "e");
if (crc32("bNOOMyDkCsWEE",13) == 1487874020) strcat(s, "o");
if (crc32("MywrWzYFFejLIfi",15) == 2857633546) strcat(s, "O");
if (crc32("gGcRJRfwsh",10) == 1693771395) strcat(s, "f");
if (crc32("SeOUsxvgwWKG",12) == 702055342) strcat(s, "f");
    return s;
}

char *forgot_verbs() {
    char *s = calloc(7);
    if (crc32("OUSnkdRx",8) == 3724783264) strcat(s, "k");
if (crc32("FLQopMcRB",9) == 2211572785) strcat(s, "f");
if (crc32("tIDFOaZPMOcOmNH",15) == 2744005239) strcat(s, "E");
if (crc32("klzGjcFtQE",10) == 4085914664) strcat(s, "o");
if (crc32("SlVLWOWn",8) == 2171473796) strcat(s, "l");
if (crc32("yCzyDGZf",8) == 2021897139) strcat(s, "r");
if (crc32("iPYCgttn",8) == 2232517404) strcat(s, "z");
if (crc32("ujtTlDHwxfvod",13) == 3450107877) strcat(s, "g");
if (crc32("qTERFeUauOt",11) == 1879582832) strcat(s, "y");
if (crc32("bzPuyQnsDu",10) == 2819168963) strcat(s, "o");
if (crc32("CrEkbkiP",8) == 38378677) strcat(s, "t");
    return s;
}

char *tubercularizing_verbs() {
    char *s = calloc(16);
    if (crc32("qkMYQVYsj",9) == 2734699290) strcat(s, "t");
if (crc32("yimbLTNx",8) == 274989608) strcat(s, "Y");
if (crc32("JwAZtA",6) == 1559817660) strcat(s, "u");
if (crc32("mlutksiifNXIG",13) == 269298242) strcat(s, "b");
if (crc32("BJCsBjxGUw",10) == 1824952071) strcat(s, "Q");
if (crc32("OwnPlfQwc",9) == 226809465) strcat(s, "e");
if (crc32("shLJkF",6) == 2865743993) strcat(s, "n");
if (crc32("fLsSMy",6) == 2299699175) strcat(s, "r");
if (crc32("rwlZRkgrkt",10) == 173280175) strcat(s, "c");
if (crc32("xnLYhNLpkC",10) == 1341576975) strcat(s, "Y");
if (crc32("ENpkrvChZMP",11) == 957568283) strcat(s, "u");
if (crc32("DduPIkjsLb",10) == 2411769828) strcat(s, "J");
if (crc32("bMZfuaEzl",9) == 706821363) strcat(s, "l");
if (crc32("TepEf",5) == 1770320125) strcat(s, "p");
if (crc32("gFpiFess",8) == 984230636) strcat(s, "a");
if (crc32("yaERSF",6) == 4100332468) strcat(s, "r");
if (crc32("vUoakXYjEkHHTq",14) == 4052152491) strcat(s, "i");
if (crc32("RhKfvILmrlRx",12) == 4238162981) strcat(s, "z");
if (crc32("apfDwnhYRC",10) == 1353082275) strcat(s, "z");
if (crc32("MwRCHZ",6) == 3912240537) strcat(s, "i");
if (crc32("lyQITOaqCV",10) == 4261922187) strcat(s, "n");
if (crc32("XINhYBfNzkwkxrQ",15) == 1286784796) strcat(s, "g");
    return s;
}

char *rethreaten_verbs() {
    char *s = calloc(11);
    if (crc32("WorkqCTNfAWcG",13) == 1147917810) strcat(s, "u");
if (crc32("ZDYZS",5) == 1907118002) strcat(s, "r");
if (crc32("FiGQLhvwDdprv",13) == 1172051442) strcat(s, "e");
if (crc32("uJumNeuqdfQ",11) == 2996058425) strcat(s, "T");
if (crc32("EtsJdEEvCvxWTRK",15) == 1400143386) strcat(s, "t");
if (crc32("TKIln",5) == 1538105233) strcat(s, "h");
if (crc32("nWNYohVOE",9) == 3999820027) strcat(s, "r");
if (crc32("AEcFzm",6) == 1585613397) strcat(s, "e");
if (crc32("CrMqkz",6) == 4248319942) strcat(s, "y");
if (crc32("xISqrH",6) == 3939853514) strcat(s, "a");
if (crc32("CMBcxJ",6) == 2450455334) strcat(s, "t");
if (crc32("SZjGU",5) == 4233666447) strcat(s, "e");
if (crc32("ZlxSs",5) == 4226940859) strcat(s, "L");
if (crc32("TrgfrKxB",8) == 251103020) strcat(s, "n");
    return s;
}

char *zipped_verbs() {
    char *s = calloc(7);
    if (crc32("djkrALWxMWrH",12) == 3466489676) strcat(s, "z");
if (crc32("TliuXUqRatvQ",12) == 1366135399) strcat(s, "M");
if (crc32("TgFfZlurH",9) == 3733513934) strcat(s, "i");
if (crc32("tRlaApwZfrAsWSb",15) == 966948684) strcat(s, "O");
if (crc32("IjtAkcjKGFigeJ",14) == 828877761) strcat(s, "p");
if (crc32("DLUNcJmfcgg",11) == 2868890425) strcat(s, "Q");
if (crc32("TeXgA",5) == 1317104201) strcat(s, "p");
if (crc32("YXuqj",5) == 887166880) strcat(s, "e");
if (crc32("gVzZmHWkD",9) == 3183715478) strcat(s, "C");
if (crc32("CUcRWgLFTgOUQAJ",15) == 2405464516) strcat(s, "d");
    return s;
}

char *criticizing_verbs() {
    char *s = calloc(12);
    if (crc32("OvBejSqmh",9) == 3397618577) strcat(s, "c");
if (crc32("GbTWtFqlME",10) == 1279812700) strcat(s, "r");
if (crc32("AxEzimYcAn",10) == 21613805) strcat(s, "i");
if (crc32("QEAuHvVOhbkXqCA",15) == 866511784) strcat(s, "a");
if (crc32("gQbbvDiUPhPudkj",15) == 3051268467) strcat(s, "t");
if (crc32("aymLTbRCoCazq",13) == 3553006403) strcat(s, "i");
if (crc32("zvIJSYXL",8) == 1522779128) strcat(s, "c");
if (crc32("VOOdmWlLlwd",11) == 4285596049) strcat(s, "O");
if (crc32("aKEJww",6) == 579977139) strcat(s, "i");
if (crc32("ZbPrQ",5) == 970124309) strcat(s, "R");
if (crc32("apDnFqTpWG",10) == 1262350409) strcat(s, "z");
if (crc32("vrCAbJEQk",9) == 585664939) strcat(s, "i");
if (crc32("gcYBw",5) == 2883639434) strcat(s, "n");
if (crc32("UlXJMfAB",8) == 2465769378) strcat(s, "g");
    return s;
}

char *crash_verbs() {
    char *s = calloc(6);
    if (crc32("nWWSxQOtJ",9) == 1571554415) strcat(s, "c");
if (crc32("JbUsPn",6) == 2063534283) strcat(s, "I");
if (crc32("shqrhY",6) == 2924712312) strcat(s, "r");
if (crc32("vIQsBKyDKusoulR",15) == 1149147020) strcat(s, "b");
if (crc32("iAbTaMBCUNn",11) == 160252231) strcat(s, "a");
if (crc32("SJkZOtgUzphUYn",14) == 2702367601) strcat(s, "s");
if (crc32("NGOqDQkQKai",11) == 1739740234) strcat(s, "F");
if (crc32("ZRsYHoZw",8) == 1042659234) strcat(s, "h");
    return s;
}

char *vie_verbs() {
    char *s = calloc(4);
    if (crc32("AzTCnZAOcnKTxb",14) == 188242083) strcat(s, "b");
if (crc32("WiINvOtNcK",10) == 1547371363) strcat(s, "v");
if (crc32("AXZmYq",6) == 3579964514) strcat(s, "i");
if (crc32("cxkuCmjdJncgUB",14) == 1122150525) strcat(s, "e");
    return s;
}

char *sentenced_verbs() {
    char *s = calloc(10);
    if (crc32("ouzUZApK",8) == 1010485985) strcat(s, "v");
if (crc32("zHBVw",5) == 2055092290) strcat(s, "s");
if (crc32("SrOsIQjTTGk",11) == 3570597462) strcat(s, "e");
if (crc32("KIdNjVWr",8) == 3283813626) strcat(s, "n");
if (crc32("MvXLKyF",7) == 2716271279) strcat(s, "t");
if (crc32("nVRPWCOWXzw",11) == 4111259649) strcat(s, "x");
if (crc32("OIgdVMtIVgWQJ",13) == 1475928559) strcat(s, "e");
if (crc32("eevui",5) == 2907850940) strcat(s, "n");
if (crc32("VGAFKPOGVmXw",12) == 2214852024) strcat(s, "m");
if (crc32("vBKQyPiNEOt",11) == 3998981818) strcat(s, "c");
if (crc32("zLLOmtQGwTvliC",14) == 733310673) strcat(s, "I");
if (crc32("VnOqxLAoQdJOrf",14) == 1595598546) strcat(s, "e");
if (crc32("WQvaVjAxvg",10) == 932950955) strcat(s, "n");
if (crc32("BUnlrHpjGN",10) == 3862809527) strcat(s, "d");
    return s;
}

char *torrefy_verbs() {
    char *s = calloc(8);
    if (crc32("ljYQbUakQhlHgkT",15) == 3753864173) strcat(s, "U");
if (crc32("DTqlmbnUjfHlUU",14) == 989931512) strcat(s, "t");
if (crc32("ArMerlIEee",10) == 3813208026) strcat(s, "l");
if (crc32("znPeNIoQJDjJ",12) == 2208193792) strcat(s, "o");
if (crc32("zxEyLwjSXfBXDC",14) == 3107219695) strcat(s, "r");
if (crc32("QtisEiTEQDclYnB",15) == 4010592317) strcat(s, "x");
if (crc32("UHpVAjYLxpn",11) == 4243368645) strcat(s, "r");
if (crc32("EbypglR",7) == 1296704380) strcat(s, "A");
if (crc32("rfELWFiphxNL",12) == 1342256253) strcat(s, "e");
if (crc32("okekw",5) == 924006587) strcat(s, "f");
if (crc32("RRlCeynkpRXeJ",13) == 2386358111) strcat(s, "a");
if (crc32("MYBzKi",6) == 2023696297) strcat(s, "y");
    return s;
}

char *overunionize_verbs() {
    char *s = calloc(13);
    if (crc32("ssYdxBUmAhQJpQC",15) == 4007140157) strcat(s, "b");
if (crc32("OTWFrytHmMTl",12) == 1131248848) strcat(s, "o");
if (crc32("EQVNimuxAx",10) == 2259355296) strcat(s, "v");
if (crc32("DPmcIAVKamyY",12) == 3441408014) strcat(s, "V");
if (crc32("hHhpRjukgal",11) == 4066136774) strcat(s, "e");
if (crc32("uJTahNehIkPRFE",14) == 2695233213) strcat(s, "r");
if (crc32("gHSzzd",6) == 3546412094) strcat(s, "u");
if (crc32("QIyPqZfpO",9) == 294045719) strcat(s, "C");
if (crc32("ZVnqwYIHvkKx",12) == 49105072) strcat(s, "n");
if (crc32("eYabAyUDo",9) == 2015705755) strcat(s, "s");
if (crc32("rvzDxhNhVqQ",11) == 2664201013) strcat(s, "i");
if (crc32("JzYlrnD",7) == 4900323) strcat(s, "p");
if (crc32("dsqaSVR",7) == 796248861) strcat(s, "o");
if (crc32("sfvzCFqfyQUAr",13) == 1336248018) strcat(s, "t");
if (crc32("uLvJcK",6) == 3953778611) strcat(s, "n");
if (crc32("SeBjAByk",8) == 2185007132) strcat(s, "i");
if (crc32("nRgWcWb",7) == 1784821706) strcat(s, "I");
if (crc32("bdJZnYj",7) == 545581217) strcat(s, "z");
if (crc32("unDObm",6) == 1594253002) strcat(s, "n");
if (crc32("zUgVHg",6) == 3460195313) strcat(s, "e");
    return s;
}

char *conspired_verbs() {
    char *s = calloc(10);
    if (crc32("ZhbpDmGQfbcRseq",15) == 3508570237) strcat(s, "c");
if (crc32("EByHgNjYQvMapwE",15) == 3067553647) strcat(s, "o");
if (crc32("TNQNHv",6) == 1231934563) strcat(s, "n");
if (crc32("Mkhjrw",6) == 2220658876) strcat(s, "s");
if (crc32("TLyvGVVzSeh",11) == 3437898002) strcat(s, "p");
if (crc32("NaFAvdvXaxZFpg",14) == 1906148617) strcat(s, "b");
if (crc32("BAmKlDZfeudQSaB",15) == 1258101610) strcat(s, "i");
if (crc32("hDHWgIt",7) == 3035508185) strcat(s, "r");
if (crc32("KJSovgoWb",9) == 748848347) strcat(s, "e");
if (crc32("ROYCrBN",7) == 1876178974) strcat(s, "d");
    return s;
}

char *redispute_verbs() {
    char *s = calloc(10);
    if (crc32("oGiAQjXJGe",10) == 2974370792) strcat(s, "r");
if (crc32("HZXyht",6) == 2411716304) strcat(s, "e");
if (crc32("QHtPsHAkReWs",12) == 1355688168) strcat(s, "I");
if (crc32("tEXeJKo",7) == 1841877427) strcat(s, "d");
if (crc32("IEoEQrSPXJUlQHw",15) == 3727885081) strcat(s, "i");
if (crc32("CYJtKZgJcrtLmRj",15) == 1873750805) strcat(s, "v");
if (crc32("iuzDVw",6) == 4271565607) strcat(s, "s");
if (crc32("CbfrsCpOHASBuT",14) == 1705478099) strcat(s, "p");
if (crc32("IbFaJRKNmAEtS",13) == 1398201146) strcat(s, "p");
if (crc32("QPSHWyxNeAxxuVY",15) == 49133553) strcat(s, "b");
if (crc32("YyArhEk",7) == 2986586101) strcat(s, "u");
if (crc32("RYFFZmHaa",9) == 344993564) strcat(s, "R");
if (crc32("rdZOUdfLGt",10) == 3648061360) strcat(s, "t");
if (crc32("DSVYqfhw",8) == 567649737) strcat(s, "E");
if (crc32("byJOhL",6) == 1562186748) strcat(s, "e");
    return s;
}

char *disvaluing_verbs() {
    char *s = calloc(11);
    if (crc32("oteOgsQzzGS",11) == 2880043882) strcat(s, "f");
if (crc32("ChPhzNWQpIix",12) == 1264128925) strcat(s, "d");
if (crc32("YHgnNHAevZZiCf",14) == 191626796) strcat(s, "i");
if (crc32("dGpVAGNLd",9) == 4247134412) strcat(s, "s");
if (crc32("NMSzi",5) == 4126617594) strcat(s, "p");
if (crc32("AtmGLEDwNFYqREL",15) == 1844918030) strcat(s, "v");
if (crc32("tOZLq",5) == 3164625458) strcat(s, "p");
if (crc32("zOmYWfx",7) == 4166456940) strcat(s, "a");
if (crc32("CVXNcZ",6) == 1302358712) strcat(s, "V");
if (crc32("rSsFAmyAy",9) == 3492844091) strcat(s, "l");
if (crc32("AObCAVUr",8) == 2740088995) strcat(s, "L");
if (crc32("CIZpo",5) == 2893311082) strcat(s, "u");
if (crc32("EffipzXqCOCoaM",14) == 3835154669) strcat(s, "i");
if (crc32("PNyjfqyPcUVNm",13) == 2977089180) strcat(s, "n");
if (crc32("BFVnSA",6) == 411266792) strcat(s, "g");
    return s;
}

char *grandstanding_verbs() {
    char *s = calloc(14);
    if (crc32("qOTgfcE",7) == 167358166) strcat(s, "w");
if (crc32("vgUDEEOajea",11) == 2899959902) strcat(s, "g");
if (crc32("XxQjlEWRAnsgc",13) == 1804265847) strcat(s, "r");
if (crc32("RSYUWuJBhMPG",12) == 2392686346) strcat(s, "a");
if (crc32("UsgayaHqRSCc",12) == 1418187544) strcat(s, "d");
if (crc32("HQrSK",5) == 4210927331) strcat(s, "n");
if (crc32("MPTDfl",6) == 2559132929) strcat(s, "J");
if (crc32("SCfMULhpjcy",11) == 2348070501) strcat(s, "d");
if (crc32("yyrJhZBevMRgiXy",15) == 194490628) strcat(s, "s");
if (crc32("HfObpjmqr",9) == 131153968) strcat(s, "t");
if (crc32("KXSBijjxREJo",12) == 444564343) strcat(s, "a");
if (crc32("MylMZn",6) == 3647389072) strcat(s, "Q");
if (crc32("xUoaSlaPMr",10) == 3640206334) strcat(s, "n");
if (crc32("czhHoYGbIbfE",12) == 4293277821) strcat(s, "F");
if (crc32("ijNnRBbaKeB",11) == 1070587193) strcat(s, "d");
if (crc32("OxZJXOFoxTom",12) == 1086051408) strcat(s, "Y");
if (crc32("XfuFDbqqG",9) == 3919910883) strcat(s, "i");
if (crc32("SDotkQEwyDS",11) == 2743413197) strcat(s, "n");
if (crc32("XIAIvsVp",8) == 754216402) strcat(s, "l");
if (crc32("wCktAhUBegqMgG",14) == 186279693) strcat(s, "g");
    return s;
}

char *haemorrhaging_verbs() {
    char *s = calloc(14);
    if (crc32("GEoPaKoDQf",10) == 3738941137) strcat(s, "h");
if (crc32("LMUhHbZgYOA",11) == 344437647) strcat(s, "a");
if (crc32("SSiBRkSkOA",10) == 2732768943) strcat(s, "e");
if (crc32("mvPznKMdkrQmiSw",15) == 3098082992) strcat(s, "m");
if (crc32("eeljPvWF",8) == 2032633423) strcat(s, "o");
if (crc32("hhzyhSqhkm",10) == 960027946) strcat(s, "r");
if (crc32("CjCpdxsDyj",10) == 326388767) strcat(s, "r");
if (crc32("hQhMYzrQsJIq",12) == 3963665847) strcat(s, "e");
if (crc32("jnxLvFqYno",10) == 3517290690) strcat(s, "h");
if (crc32("jLNSPYdPUdWXn",13) == 2160931134) strcat(s, "f");
if (crc32("PMUKnNybwCJTe",13) == 262812929) strcat(s, "a");
if (crc32("FnTfaiqDQmGNA",13) == 1262522764) strcat(s, "g");
if (crc32("eyNsjO",6) == 1593977630) strcat(s, "f");
if (crc32("tHPfFo",6) == 3045839238) strcat(s, "i");
if (crc32("JrnedzQVUm",10) == 4020045446) strcat(s, "d");
if (crc32("MoyUyg",6) == 1208839556) strcat(s, "n");
if (crc32("lNFZWLOve",9) == 2383259671) strcat(s, "g");
    return s;
}

char *trode_verbs() {
    char *s = calloc(6);
    if (crc32("ttADGM",6) == 3461174992) strcat(s, "t");
if (crc32("ySUntjyALFd",11) == 693337224) strcat(s, "g");
if (crc32("BcUYUYRQINw",11) == 419502461) strcat(s, "r");
if (crc32("YeNDAiMCkA",10) == 1360084426) strcat(s, "p");
if (crc32("zcQzFfdDp",9) == 2966137838) strcat(s, "o");
if (crc32("guejTWGFCaWsdLQ",15) == 2288679688) strcat(s, "e");
if (crc32("bSTfdpDG",8) == 4171503039) strcat(s, "d");
if (crc32("gYqYLuJ",7) == 931802340) strcat(s, "e");
    return s;
}

char *bade_verbs() {
    char *s = calloc(5);
    if (crc32("RmjSQSsxTjgW",12) == 1068726812) strcat(s, "P");
if (crc32("yqEPWbto",8) == 1886597687) strcat(s, "b");
if (crc32("VyjfkmDm",8) == 1001955732) strcat(s, "a");
if (crc32("ObAtoy",6) == 1530325716) strcat(s, "R");
if (crc32("JPdkWhnQP",9) == 461041250) strcat(s, "d");
if (crc32("fBRNNBDhOYTC",12) == 1607506741) strcat(s, "x");
if (crc32("PmsAKkNtWgyHGG",14) == 1653012245) strcat(s, "e");
    return s;
}

char *filing_verbs() {
    char *s = calloc(7);
    if (crc32("jIeVTuS",7) == 4007015587) strcat(s, "f");
if (crc32("gkRJMibhjlD",11) == 896017467) strcat(s, "i");
if (crc32("XNZSVmBe",8) == 1955403753) strcat(s, "l");
if (crc32("xfuvGQzDsVpFpC",14) == 2103007115) strcat(s, "i");
if (crc32("IeammsilQvIzw",13) == 4058574049) strcat(s, "n");
if (crc32("HLdrmekOi",9) == 2922757141) strcat(s, "g");
    return s;
}

char *eatup_verbs() {
    char *s = calloc(6);
    if (crc32("YMRoMUcbXGmd",12) == 3431912762) strcat(s, "O");
if (crc32("gtAddjGMUxxeA",13) == 4218905456) strcat(s, "e");
if (crc32("HVHcVTFKgLuFik",14) == 3854184687) strcat(s, "K");
if (crc32("CfQgFGico",9) == 2187994846) strcat(s, "a");
if (crc32("IYcSVDT",7) == 3627607792) strcat(s, "T");
if (crc32("AcFMsAtaHaLqma",14) == 2226395638) strcat(s, "t");
if (crc32("SWodNeenWCmRJg",14) == 867514585) strcat(s, "U");
if (crc32("UxfDXVJppmr",11) == 2355556411) strcat(s, "u");
if (crc32("uFrkuKRZBpvdfih",15) == 135974122) strcat(s, "p");
    return s;
}

char *overlaid_verbs() {
    char *s = calloc(9);
    if (crc32("CwctcDmzvWwT",12) == 979959132) strcat(s, "a");
if (crc32("SqZfMWHU",8) == 1826586892) strcat(s, "o");
if (crc32("zTmIOLBV",8) == 3900304445) strcat(s, "N");
if (crc32("yMYVnukIRLHl",12) == 3009572811) strcat(s, "v");
if (crc32("WICQpod",7) == 919882644) strcat(s, "r");
if (crc32("TUVFLfZgRch",11) == 4189217178) strcat(s, "e");
if (crc32("qalSCNt",7) == 2746930452) strcat(s, "q");
if (crc32("jQLGxWcn",8) == 272632618) strcat(s, "r");
if (crc32("rAxcEXz",7) == 1984771075) strcat(s, "l");
if (crc32("jASrwtZ",7) == 2940454104) strcat(s, "g");
if (crc32("usprQktCLZUmx",13) == 1408229972) strcat(s, "a");
if (crc32("CXLcknWsf",9) == 1654847939) strcat(s, "g");
if (crc32("IPyidCBl",8) == 2298082580) strcat(s, "i");
if (crc32("HrYoSjhpHVkQc",13) == 258429488) strcat(s, "d");
    return s;
}

char *nibbing_verbs() {
    char *s = calloc(8);
    if (crc32("oknYISo",7) == 561402366) strcat(s, "n");
if (crc32("TCzPoLdTutM",11) == 3665530211) strcat(s, "i");
if (crc32("GzQZZWwJi",9) == 4060637601) strcat(s, "H");
if (crc32("mitQzECtpgvNp",13) == 998108141) strcat(s, "b");
if (crc32("zvaKcjkXmFVEPr",14) == 605307268) strcat(s, "b");
if (crc32("bmEDwT",6) == 1115507649) strcat(s, "i");
if (crc32("yNbDwvTSMBg",11) == 2349495114) strcat(s, "f");
if (crc32("tPtbvs",6) == 101054412) strcat(s, "n");
if (crc32("uDPNlXHNfhkFl",13) == 1398839644) strcat(s, "g");
    return s;
}

char *exaggerate_verbs() {
    char *s = calloc(11);
    if (crc32("cuSZLe",6) == 988436343) strcat(s, "Q");
if (crc32("QsgbPMukMAz",11) == 166973813) strcat(s, "e");
if (crc32("KyBETpvPgxJnUc",14) == 3194167335) strcat(s, "a");
if (crc32("qBOXaARTu",9) == 780996410) strcat(s, "x");
if (crc32("xkczKbmza",9) == 561151808) strcat(s, "a");
if (crc32("HUNxykkGsLyV",12) == 3443948578) strcat(s, "m");
if (crc32("GIjSmaUnG",9) == 1417516943) strcat(s, "g");
if (crc32("LBFJk",5) == 3470605518) strcat(s, "g");
if (crc32("JPxwzeswpLimou",14) == 275107938) strcat(s, "e");
if (crc32("CaLstOUVC",9) == 193984834) strcat(s, "m");
if (crc32("mMzARmyesuD",11) == 2523779677) strcat(s, "r");
if (crc32("JcabFVvhaUriH",13) == 87064247) strcat(s, "a");
if (crc32("pJMXx",5) == 1741731046) strcat(s, "v");
if (crc32("HNuVlexcsV",10) == 2431033388) strcat(s, "t");
if (crc32("dGNYl",5) == 4180290992) strcat(s, "e");
    return s;
}

char *goggled_verbs() {
    char *s = calloc(8);
    if (crc32("JhiAr",5) == 983365346) strcat(s, "g");
if (crc32("SMEMXChfHirrAeq",15) == 2721977193) strcat(s, "o");
if (crc32("mkKhtZvWIrUORoo",15) == 2940013490) strcat(s, "u");
if (crc32("SwVRYMDNreXbPNo",15) == 212697576) strcat(s, "g");
if (crc32("bNixWrsif",9) == 3968522410) strcat(s, "p");
if (crc32("oVoneh",6) == 2245808560) strcat(s, "g");
if (crc32("PsUfiStpzyY",11) == 1718856899) strcat(s, "l");
if (crc32("VYzbOChpWzvwSh",14) == 1318857882) strcat(s, "e");
if (crc32("mGuucLmeMh",10) == 1542328388) strcat(s, "k");
if (crc32("RYigeLKONltfj",13) == 1411232666) strcat(s, "d");
    return s;
}

char *gargling_verbs() {
    char *s = calloc(9);
    if (crc32("arlIqkrNdQb",11) == 2163964438) strcat(s, "b");
if (crc32("OxLLdweEQGiW",12) == 871605354) strcat(s, "g");
if (crc32("UvviPBDOjryeJ",13) == 3735769019) strcat(s, "A");
if (crc32("lAHJEfiXP",9) == 2954870680) strcat(s, "a");
if (crc32("uAASJVcfbQUoWal",15) == 4288380028) strcat(s, "r");
if (crc32("SFPJdQaZNwVVi",13) == 1272571727) strcat(s, "Z");
if (crc32("OKOAuE",6) == 2252269426) strcat(s, "g");
if (crc32("ZDwwcopFmHJXp",13) == 2164008505) strcat(s, "S");
if (crc32("kgDEmYkus",9) == 94442208) strcat(s, "l");
if (crc32("QeaYMssPYOVbClb",15) == 1892015842) strcat(s, "i");
if (crc32("sBjcQ",5) == 311018125) strcat(s, "O");
if (crc32("NhakyYDJ",8) == 3143651121) strcat(s, "n");
if (crc32("LTgHBmHHNrq",11) == 3565340761) strcat(s, "g");
    return s;
}

char *troublesshot_verbs() {
    char *s = calloc(13);
    if (crc32("oTMntpvtk",9) == 203435414) strcat(s, "G");
if (crc32("eyjdJfHKRQuaQ",13) == 2209184347) strcat(s, "t");
if (crc32("HzRpGwEXg",9) == 1064326555) strcat(s, "f");
if (crc32("FAAGREuN",8) == 2449628792) strcat(s, "r");
if (crc32("tzyaTEDORTRR",12) == 2335218475) strcat(s, "L");
if (crc32("RrInRLIDhsBc",12) == 1418249609) strcat(s, "o");
if (crc32("rhjRG",5) == 2277608002) strcat(s, "I");
if (crc32("xeKFArR",7) == 1656388921) strcat(s, "u");
if (crc32("NlvMjypHgh",10) == 3078842135) strcat(s, "b");
if (crc32("GtCRVqnEgoGZdu",14) == 547931459) strcat(s, "l");
if (crc32("nWPdXHKSBXLpPoV",15) == 2520364444) strcat(s, "a");
if (crc32("XboKa",5) == 903677826) strcat(s, "e");
if (crc32("yoTtQud",7) == 1547187678) strcat(s, "L");
if (crc32("AjcIujVrPt",10) == 149254031) strcat(s, "s");
if (crc32("oXiWYC",6) == 3950177965) strcat(s, "s");
if (crc32("vSVEeSnPpJYLPtf",15) == 2955003295) strcat(s, "y");
if (crc32("MnxsKuSfscNhL",13) == 644158979) strcat(s, "h");
if (crc32("QsvTXa",6) == 1257288102) strcat(s, "q");
if (crc32("tKdWNxw",7) == 2302640340) strcat(s, "o");
if (crc32("HQIuNTD",7) == 3023652242) strcat(s, "u");
if (crc32("wcfONeCtbine",12) == 1332442949) strcat(s, "t");
    return s;
}

char *puzzled_verbs() {
    char *s = calloc(8);
    if (crc32("LVXGSernNXQrfu",14) == 2911567265) strcat(s, "p");
if (crc32("SckwPVaVnC",10) == 135428247) strcat(s, "T");
if (crc32("ucjYlkIa",8) == 2312920731) strcat(s, "u");
if (crc32("jRkyAoNPfhXXa",13) == 2284947036) strcat(s, "z");
if (crc32("JpRzHpMdUVr",11) == 2556517725) strcat(s, "z");
if (crc32("ChnXFWgCRSgCm",13) == 2183049225) strcat(s, "l");
if (crc32("AIPTHDfbXKGELaS",15) == 2454941485) strcat(s, "e");
if (crc32("gNXlPoXB",8) == 1964055654) strcat(s, "e");
if (crc32("tikHKzrVC",9) == 2444808863) strcat(s, "d");
    return s;
}

char *recoup_verbs() {
    char *s = calloc(7);
    if (crc32("iVVaMISTlNK",11) == 292806051) strcat(s, "r");
if (crc32("wRGmTWjGYv",10) == 1160058087) strcat(s, "R");
if (crc32("mapGbEPm",8) == 2352649432) strcat(s, "e");
if (crc32("xOJppNCKrWYoBDh",15) == 2466124218) strcat(s, "j");
if (crc32("STZqVY",6) == 4187901138) strcat(s, "c");
if (crc32("QasVk",5) == 91369777) strcat(s, "m");
if (crc32("ObrxKFajJMH",11) == 1977391210) strcat(s, "o");
if (crc32("tursYxASP",9) == 1234844339) strcat(s, "u");
if (crc32("gLhlVrXRL",9) == 2222718427) strcat(s, "p");
    return s;
}

char *redrying_verbs() {
    char *s = calloc(9);
    if (crc32("bKDujFIXrfaFj",13) == 2653208090) strcat(s, "r");
if (crc32("FniSQIdHe",9) == 3005050159) strcat(s, "e");
if (crc32("QAJrKF",6) == 1013808388) strcat(s, "d");
if (crc32("TqiZkdL",7) == 4053282973) strcat(s, "n");
if (crc32("HqnZudqAOYDg",12) == 2201554504) strcat(s, "r");
if (crc32("rIsSSSPAdD",10) == 1815732715) strcat(s, "y");
if (crc32("EVCNOdojXPbBY",13) == 1095340175) strcat(s, "h");
if (crc32("gawDoHrpqnXxOK",14) == 3204327416) strcat(s, "i");
if (crc32("mWjbBFwKG",9) == 1224410520) strcat(s, "n");
if (crc32("iZrDHvI",7) == 2643658291) strcat(s, "l");
if (crc32("oJEiDEHtPYfC",12) == 3171422519) strcat(s, "g");
    return s;
}

char *outshining_verbs() {
    char *s = calloc(11);
    if (crc32("kkNQIpYwsRor",12) == 3027090934) strcat(s, "n");
if (crc32("OBHiLunuEdMEb",13) == 645868164) strcat(s, "o");
if (crc32("JHTwIsinwuMvEP",14) == 732307610) strcat(s, "B");
if (crc32("qndDfBGGxPexP",13) == 3374800133) strcat(s, "u");
if (crc32("gaanUnRaQtt",11) == 1361810384) strcat(s, "t");
if (crc32("Ibxlw",5) == 1697113275) strcat(s, "r");
if (crc32("sIwTpCcR",8) == 2676799099) strcat(s, "s");
if (crc32("KQoXZ",5) == 552015145) strcat(s, "h");
if (crc32("YzFMjeMGqLcF",12) == 1932334741) strcat(s, "j");
if (crc32("BynamDqnmKFK",12) == 1236069502) strcat(s, "i");
if (crc32("umRdHW",6) == 1761225634) strcat(s, "n");
if (crc32("pTFHOi",6) == 4094334150) strcat(s, "i");
if (crc32("BcDiobaTf",9) == 1860744625) strcat(s, "n");
if (crc32("CgfHPjIxhzLdJt",14) == 959213531) strcat(s, "g");
    return s;
}

char *corroborating_verbs() {
    char *s = calloc(14);
    if (crc32("qikZLfJY",8) == 2397008234) strcat(s, "c");
if (crc32("xhhYFXnBVOkHT",13) == 3927386999) strcat(s, "D");
if (crc32("TmHxzLBVerya",12) == 3452137885) strcat(s, "o");
if (crc32("aezoSmVdWl",10) == 1362157362) strcat(s, "A");
if (crc32("brNayi",6) == 2409703687) strcat(s, "r");
if (crc32("yIXmUNrX",8) == 156027112) strcat(s, "i");
if (crc32("Oxkjifkf",8) == 3540350987) strcat(s, "r");
if (crc32("hFvHRX",6) == 1597391957) strcat(s, "o");
if (crc32("YANGk",5) == 3486884903) strcat(s, "b");
if (crc32("doggSeELszko",12) == 606786543) strcat(s, "c");
if (crc32("mRDLOKMblnTHVTY",15) == 816323324) strcat(s, "o");
if (crc32("ErHbErcJ",8) == 268932119) strcat(s, "y");
if (crc32("ZrtyZtqOjp",10) == 68554173) strcat(s, "r");
if (crc32("IjahrGz",7) == 149764244) strcat(s, "A");
if (crc32("iRpKfleunETsR",13) == 2222764875) strcat(s, "a");
if (crc32("YfUeZx",6) == 544522490) strcat(s, "t");
if (crc32("LaBBHLPC",8) == 2351898515) strcat(s, "J");
if (crc32("TqCFiBZbq",9) == 2977068332) strcat(s, "i");
if (crc32("bZtSKAgjx",9) == 2365015483) strcat(s, "R");
if (crc32("rLKjQAmSlcsqY",13) == 873007707) strcat(s, "n");
if (crc32("jRlESei",7) == 1106936221) strcat(s, "g");
    return s;
}

char *disunite_verbs() {
    char *s = calloc(9);
    if (crc32("QHXEBo",6) == 2033799249) strcat(s, "d");
if (crc32("hQoGwFjRsr",10) == 2363148075) strcat(s, "i");
if (crc32("fXKGVFw",7) == 3158604793) strcat(s, "s");
if (crc32("VEkoGaBKzqueDS",14) == 880224371) strcat(s, "u");
if (crc32("CXuvXTG",7) == 2395529661) strcat(s, "X");
if (crc32("dsVTtAkkjpSEBSn",15) == 3433482821) strcat(s, "n");
if (crc32("UFrcpcnhOMyd",12) == 4094129235) strcat(s, "i");
if (crc32("WMaGR",5) == 1445407787) strcat(s, "t");
if (crc32("FeegZGYtrJRxW",13) == 226213950) strcat(s, "K");
if (crc32("MLpGKRtwS",9) == 3322956833) strcat(s, "e");
    return s;
}

char *precontemplate_verbs() {
    char *s = calloc(15);
    if (crc32("DtJfeUYixhbefzc",15) == 672418080) strcat(s, "H");
if (crc32("miYqMZHdsgTz",12) == 2767819724) strcat(s, "p");
if (crc32("nRyBAtlZUhdUm",13) == 2172723813) strcat(s, "r");
if (crc32("CtpWO",5) == 1788937046) strcat(s, "Q");
if (crc32("NxkhtBawCDgyOLZ",15) == 2810927326) strcat(s, "e");
if (crc32("GjLzLZpIl",9) == 1010703448) strcat(s, "c");
if (crc32("VXniMNqAZNN",11) == 4270991342) strcat(s, "I");
if (crc32("eXWjOiqTpyRYayW",15) == 740722435) strcat(s, "o");
if (crc32("uIbKDnCJEVrdpm",14) == 2330234633) strcat(s, "n");
if (crc32("LbFlVhhyyOPlG",13) == 2595329215) strcat(s, "c");
if (crc32("YjAcyihc",8) == 850738831) strcat(s, "t");
if (crc32("qViLHtGPBeAfXxu",15) == 2854455806) strcat(s, "q");
if (crc32("BurnF",5) == 2336535080) strcat(s, "e");
if (crc32("qzsVQqNEiyFp",12) == 1501290991) strcat(s, "m");
if (crc32("yFaJB",5) == 1473139814) strcat(s, "p");
if (crc32("qCTLQmmKqQxhFU",14) == 36008204) strcat(s, "t");
if (crc32("sAupRiAwPP",10) == 1231552411) strcat(s, "l");
if (crc32("JNYDNFrBqAhmQx",14) == 873054588) strcat(s, "a");
if (crc32("kxNVHmaPZoAieke",15) == 4175024707) strcat(s, "t");
if (crc32("CZnwgZS",7) == 1792975415) strcat(s, "e");
    return s;
}

char *siting_verbs() {
    char *s = calloc(7);
    if (crc32("TxktOznUSHvIBC",14) == 1484523347) strcat(s, "s");
if (crc32("gzTAyhRmfM",10) == 427995926) strcat(s, "i");
if (crc32("gHLAt",5) == 1947898711) strcat(s, "t");
if (crc32("mVxUiGUFJTAGy",13) == 1154482478) strcat(s, "i");
if (crc32("ZrhRFapuha",10) == 231130561) strcat(s, "x");
if (crc32("thABGeUgLvQ",11) == 3590559588) strcat(s, "n");
if (crc32("vnLzUxfBv",9) == 3771247366) strcat(s, "g");
    return s;
}

char *embrue_verbs() {
    char *s = calloc(7);
    if (crc32("IVfBoHdra",9) == 3716613322) strcat(s, "p");
if (crc32("DRrGcnyLw",9) == 3610800940) strcat(s, "e");
if (crc32("wSFBOMBJK",9) == 2633665755) strcat(s, "K");
if (crc32("lTWUYylOwog",11) == 4019952944) strcat(s, "m");
if (crc32("mkbhmXmhxZ",10) == 1827355479) strcat(s, "b");
if (crc32("gjCfRviTO",9) == 1197182982) strcat(s, "r");
if (crc32("KUAyRAWXU",9) == 1468010511) strcat(s, "N");
if (crc32("gwaWJHWY",8) == 2989822376) strcat(s, "u");
if (crc32("BNMQtXURAroH",12) == 3326212885) strcat(s, "r");
if (crc32("qvMAKY",6) == 506622497) strcat(s, "e");
    return s;
}

char *pound_verbs() {
    char *s = calloc(6);
    if (crc32("WAQDGtyXWb",10) == 1396268541) strcat(s, "c");
if (crc32("sMkchRLOXq",10) == 3219583546) strcat(s, "p");
if (crc32("qOZHrSOdmlbtI",13) == 102104979) strcat(s, "o");
if (crc32("ebKVpTFFOTuV",12) == 1443614138) strcat(s, "D");
if (crc32("eFhvRcCfYAH",11) == 2635655727) strcat(s, "u");
if (crc32("pBdTWOieujsd",12) == 2672136316) strcat(s, "r");
if (crc32("FQRExQSh",8) == 3475874764) strcat(s, "n");
if (crc32("rFUZQzoge",9) == 1939472565) strcat(s, "k");
if (crc32("mnsRBfeGhoZeg",13) == 279634366) strcat(s, "d");
    return s;
}

char *prove_verbs() {
    char *s = calloc(6);
    if (crc32("PJPdr",5) == 4157687035) strcat(s, "P");
if (crc32("NPBqgadHngrA",12) == 555022462) strcat(s, "p");
if (crc32("JlrjpVIOMPjlZ",13) == 3856277351) strcat(s, "r");
if (crc32("uCSxRWszlJEVC",13) == 1122001572) strcat(s, "o");
if (crc32("BqFshVhvQrd",11) == 3427779468) strcat(s, "v");
if (crc32("OYiNJKawxjJL",12) == 3914303831) strcat(s, "e");
    return s;
}

char *followthrough_verbs() {
    char *s = calloc(14);
    if (crc32("bIvovDPhS",9) == 2236230016) strcat(s, "f");
if (crc32("NJOxkZmqwzN",11) == 258936645) strcat(s, "C");
if (crc32("rlRaCZfNsFzk",12) == 73904221) strcat(s, "o");
if (crc32("OFGmjHer",8) == 3827829190) strcat(s, "u");
if (crc32("rzeWYIyOIo",10) == 3857171223) strcat(s, "l");
if (crc32("FELQBbCkc",9) == 4260881219) strcat(s, "l");
if (crc32("WjgXVkgPUwDyU",13) == 820433422) strcat(s, "o");
if (crc32("jEBvxTVdHjtV",12) == 3416822168) strcat(s, "w");
if (crc32("fSRFkxqxgUgXADd",15) == 3432565425) strcat(s, "t");
if (crc32("SYJcOdRzOjqk",12) == 3366361317) strcat(s, "h");
if (crc32("CHmmZPokP",9) == 2988602584) strcat(s, "r");
if (crc32("YQlwFQR",7) == 4017986579) strcat(s, "i");
if (crc32("HKDgHnKrF",9) == 520227786) strcat(s, "o");
if (crc32("KYirGzW",7) == 910664886) strcat(s, "p");
if (crc32("EhyERp",6) == 4294699047) strcat(s, "u");
if (crc32("fYpiDuTkUx",10) == 1878571044) strcat(s, "g");
if (crc32("iXVeAb",6) == 1836229028) strcat(s, "r");
if (crc32("NKvZKgQ",7) == 1962553215) strcat(s, "h");
    return s;
}

char *does_verbs() {
    char *s = calloc(5);
    if (crc32("XJfze",5) == 4074242139) strcat(s, "y");
if (crc32("YpkRjeRSsio",11) == 2216294300) strcat(s, "d");
if (crc32("fGELgOUK",8) == 823114832) strcat(s, "h");
if (crc32("aesVSMWQ",8) == 3529788708) strcat(s, "o");
if (crc32("bXAolhAhE",9) == 1358420554) strcat(s, "p");
if (crc32("yliBcY",6) == 2826590197) strcat(s, "e");
if (crc32("QdwQJITQswgygl",14) == 2853943759) strcat(s, "x");
if (crc32("IPaxeCVmPWJyid",14) == 3202709313) strcat(s, "s");
    return s;
}

char *triturating_verbs() {
    char *s = calloc(12);
    if (crc32("eCOMBoRF",8) == 2153247396) strcat(s, "b");
if (crc32("ngKvnO",6) == 2841294114) strcat(s, "t");
if (crc32("EtypfX",6) == 4141149906) strcat(s, "r");
if (crc32("RvdKaRhEvVNjXl",14) == 3331044476) strcat(s, "i");
if (crc32("NgfqVVCrZblV",12) == 2641907672) strcat(s, "t");
if (crc32("HsBwmeohA",9) == 1560147422) strcat(s, "l");
if (crc32("ZwfuPCsqOJSgik",14) == 2346925220) strcat(s, "u");
if (crc32("hfOphRB",7) == 14282176) strcat(s, "G");
if (crc32("VeHKqIiZvBHO",12) == 1459801801) strcat(s, "r");
if (crc32("CjFUtWniEelb",12) == 2698803164) strcat(s, "Q");
if (crc32("oTdYwdRoBbuz",12) == 4095208417) strcat(s, "a");
if (crc32("GJkaD",5) == 2441949363) strcat(s, "t");
if (crc32("HyDiwOTG",8) == 2514157893) strcat(s, "Y");
if (crc32("kpgjqAgIW",9) == 220716937) strcat(s, "i");
if (crc32("KkXRpfhleaAGV",13) == 3422867325) strcat(s, "n");
if (crc32("wPtAWg",6) == 3990584529) strcat(s, "v");
if (crc32("cEMWcZTyfMrYlX",14) == 2075222929) strcat(s, "g");
    return s;
}

char *tug_verbs() {
    char *s = calloc(4);
    if (crc32("HWxIE",5) == 2241112885) strcat(s, "t");
if (crc32("RUEhqua",7) == 640313451) strcat(s, "u");
if (crc32("BOJBdq",6) == 1698596971) strcat(s, "l");
if (crc32("UUIWGG",6) == 3307035183) strcat(s, "g");
    return s;
}

char *gutted_verbs() {
    char *s = calloc(7);
    if (crc32("FpYfEzZV",8) == 1824201580) strcat(s, "g");
if (crc32("XiecF",5) == 2365705413) strcat(s, "l");
if (crc32("xcLdbMN",7) == 2049747787) strcat(s, "u");
if (crc32("uKORmL",6) == 3329818221) strcat(s, "t");
if (crc32("dQEjOFeNGYOsY",13) == 881460022) strcat(s, "t");
if (crc32("vyfibTFPAfMa",12) == 2904713553) strcat(s, "e");
if (crc32("RoifnjKmmeV",11) == 3287906917) strcat(s, "d");
    return s;
}

char *snowshoeing_verbs() {
    char *s = calloc(12);
    if (crc32("pAFSGwnfLdoIuC",14) == 366314771) strcat(s, "s");
if (crc32("xBMYEsFKyDQvg",13) == 1517336192) strcat(s, "n");
if (crc32("rSyxrn",6) == 1934440871) strcat(s, "n");
if (crc32("BVCGGShSlpcUL",13) == 2134265465) strcat(s, "P");
if (crc32("gKVeznDjR",9) == 3082783403) strcat(s, "o");
if (crc32("xCBBniQMjcxvqFV",15) == 2382298832) strcat(s, "w");
if (crc32("nXdLRuTtkQoLvVU",15) == 2208754517) strcat(s, "s");
if (crc32("WQGQuwLPJRXQ",12) == 4013524940) strcat(s, "U");
if (crc32("FqqizwsilKr",11) == 782615792) strcat(s, "h");
if (crc32("vmHLIgja",8) == 2505527267) strcat(s, "o");
if (crc32("jtzFuOOvDhvVt",13) == 2037956514) strcat(s, "N");
if (crc32("vvVxnakJrJ",10) == 1529657538) strcat(s, "e");
if (crc32("ifUavM",6) == 4091231796) strcat(s, "w");
if (crc32("XPWWeVYre",9) == 1901385903) strcat(s, "i");
if (crc32("MIbGFVbZjSKq",12) == 2172375982) strcat(s, "n");
if (crc32("ueZun",5) == 1652684057) strcat(s, "g");
    return s;
}

char *keynoted_verbs() {
    char *s = calloc(9);
    if (crc32("ecEvQ",5) == 3647450962) strcat(s, "J");
if (crc32("BLxOWbyMzdsAO",13) == 3704036557) strcat(s, "k");
if (crc32("ynnPNVUPs",9) == 3087715129) strcat(s, "e");
if (crc32("YYneSNMaW",9) == 782850096) strcat(s, "W");
if (crc32("wSxrDjrfGpof",12) == 933196100) strcat(s, "y");
if (crc32("ASPTnQluyg",10) == 539991788) strcat(s, "v");
if (crc32("YqGmDSIACOE",11) == 3481050192) strcat(s, "n");
if (crc32("UVudRRJrN",9) == 3845047397) strcat(s, "m");
if (crc32("OENaXdR",7) == 4072199692) strcat(s, "o");
if (crc32("egPLINLOEWTl",12) == 3964461027) strcat(s, "t");
if (crc32("RATOZmLVLnZLV",13) == 2851375999) strcat(s, "o");
if (crc32("hxJFoWnRozT",11) == 292471748) strcat(s, "e");
if (crc32("FYBWohpibOYVzK",14) == 1801357233) strcat(s, "d");
    return s;
}

char *botanized_verbs() {
    char *s = calloc(10);
    if (crc32("WkiiqFPI",8) == 2674662827) strcat(s, "P");
if (crc32("kelDglyBidAwuF",14) == 1594149756) strcat(s, "b");
if (crc32("wzjfLUIm",8) == 2250321059) strcat(s, "Q");
if (crc32("zCysrENGvwvFtEK",15) == 1622298266) strcat(s, "o");
if (crc32("BtqYxAV",7) == 2641678019) strcat(s, "t");
if (crc32("dSkWexjkCp",10) == 1883473368) strcat(s, "y");
if (crc32("oOIOvGgEOqxhB",13) == 1910862506) strcat(s, "a");
if (crc32("urzypGhHtQsvzTP",15) == 1161601110) strcat(s, "w");
if (crc32("cHCTlC",6) == 2477296353) strcat(s, "n");
if (crc32("SzfHGNwBBtwche",14) == 2597717446) strcat(s, "Q");
if (crc32("yJuWVhMWDxA",11) == 1091726091) strcat(s, "i");
if (crc32("iPEYQ",5) == 3778571191) strcat(s, "Z");
if (crc32("hbNkYPzWJIBX",12) == 1717378427) strcat(s, "z");
if (crc32("yHSjzMgt",8) == 511733076) strcat(s, "L");
if (crc32("fGOndzToBEx",11) == 2962382078) strcat(s, "e");
if (crc32("WiiRgwhaT",9) == 3945285024) strcat(s, "d");
    return s;
}

char *look_verbs() {
    char *s = calloc(5);
    if (crc32("yvSgllejuCH",11) == 1129219425) strcat(s, "l");
if (crc32("anQPJYkMkBOKPXZ",15) == 1451767243) strcat(s, "o");
if (crc32("xikoPHRu",8) == 2878481974) strcat(s, "D");
if (crc32("Yezlio",6) == 3891060282) strcat(s, "o");
if (crc32("axBQhIS",7) == 2470648567) strcat(s, "k");
    return s;
}

char *submitting_verbs() {
    char *s = calloc(11);
    if (crc32("sLKiAJrSQhWFHi",14) == 2364916172) strcat(s, "s");
if (crc32("mZZOf",5) == 2972424166) strcat(s, "u");
if (crc32("ztSHfAn",7) == 765891975) strcat(s, "M");
if (crc32("sbzaIuLRNjPx",12) == 3807350640) strcat(s, "b");
if (crc32("aGmIGDgaUtQZ",12) == 3304308890) strcat(s, "m");
if (crc32("yrumh",5) == 852904847) strcat(s, "i");
if (crc32("IgbWRm",6) == 2782979951) strcat(s, "C");
if (crc32("IadyHs",6) == 588215034) strcat(s, "t");
if (crc32("TLyddKjbSggtUuE",15) == 2240935113) strcat(s, "t");
if (crc32("cePCFiQeXOA",11) == 3606181558) strcat(s, "L");
if (crc32("nSZSQyQ",7) == 3893035747) strcat(s, "i");
if (crc32("nskTaFBkPFkx",12) == 1810563208) strcat(s, "j");
if (crc32("IXTJN",5) == 1832888092) strcat(s, "n");
if (crc32("ENEYJSUPNZKiD",13) == 3875048016) strcat(s, "J");
if (crc32("ZQKGn",5) == 2932719372) strcat(s, "g");
    return s;
}

char *journalize_verbs() {
    char *s = calloc(11);
    if (crc32("HcZXD",5) == 3855238603) strcat(s, "j");
if (crc32("aRLAHGNiT",9) == 3519429940) strcat(s, "L");
if (crc32("CKDzTWjsP",9) == 3731677501) strcat(s, "o");
if (crc32("bhIVeuOFeNLCy",13) == 1855464243) strcat(s, "u");
if (crc32("gKVgPAxN",8) == 3289538755) strcat(s, "r");
if (crc32("hPFDk",5) == 2875669263) strcat(s, "N");
if (crc32("qoKlBklPpCJNv",13) == 3959257645) strcat(s, "n");
if (crc32("XgzvTiYNMQJ",11) == 3400155970) strcat(s, "M");
if (crc32("moyUibrytOxAq",13) == 2823564273) strcat(s, "a");
if (crc32("AmODzH",6) == 223870527) strcat(s, "l");
if (crc32("YAZdKjkTvJCGK",13) == 3307408652) strcat(s, "i");
if (crc32("xMnpAHi",7) == 3825155059) strcat(s, "y");
if (crc32("TVxHKHlkOlIgx",13) == 4100831459) strcat(s, "z");
if (crc32("SBEaumPNLy",10) == 1822782923) strcat(s, "U");
if (crc32("dvxXXqYLJeT",11) == 2153847205) strcat(s, "e");
    return s;
}

char *counterweigh_verbs() {
    char *s = calloc(13);
    if (crc32("drWoLVI",7) == 4034745789) strcat(s, "y");
if (crc32("LwXXgCApsjzo",12) == 1558187469) strcat(s, "c");
if (crc32("OkLpZUcjSySeB",13) == 1394068207) strcat(s, "a");
if (crc32("FrFMWWTbbLI",11) == 185386450) strcat(s, "o");
if (crc32("wpkIEmoD",8) == 1730040055) strcat(s, "u");
if (crc32("XgYJwAGBzmQCX",13) == 2434894105) strcat(s, "n");
if (crc32("GenVpHvop",9) == 84267984) strcat(s, "O");
if (crc32("kiJjmSDD",8) == 3386809579) strcat(s, "t");
if (crc32("TkntBqLEv",9) == 3008632683) strcat(s, "e");
if (crc32("NuVdXZjgOIlR",12) == 2471335727) strcat(s, "k");
if (crc32("UiRwPdpEVWwALa",14) == 1341768936) strcat(s, "r");
if (crc32("toIUw",5) == 3755191686) strcat(s, "w");
if (crc32("NwhxIpcpLBtbNwu",15) == 4260237045) strcat(s, "e");
if (crc32("nXlYnIoi",8) == 2297770048) strcat(s, "i");
if (crc32("splkKvZuHPRLG",13) == 1893227295) strcat(s, "i");
if (crc32("bKJwNFPs",8) == 683339607) strcat(s, "g");
if (crc32("jAYTRMx",7) == 1374348357) strcat(s, "J");
if (crc32("aWzvl",5) == 1353547902) strcat(s, "h");
    return s;
}

char *foreknow_verbs() {
    char *s = calloc(9);
    if (crc32("WqAoQAvClYvPwAc",15) == 3908640276) strcat(s, "n");
if (crc32("VxWFccBmyctGqe",14) == 783809783) strcat(s, "f");
if (crc32("rRdpPDIQdg",10) == 3955264997) strcat(s, "Z");
if (crc32("ixExdDnsqJxowm",14) == 3493147417) strcat(s, "o");
if (crc32("jupxFoyJquLgWho",15) == 9450962) strcat(s, "P");
if (crc32("mkBuiW",6) == 3378369999) strcat(s, "r");
if (crc32("HbILwWdlOFD",11) == 606747016) strcat(s, "v");
if (crc32("DJnshfr",7) == 386607081) strcat(s, "e");
if (crc32("RmGaErhiBp",10) == 793707864) strcat(s, "R");
if (crc32("cESuLfQcjIeN",12) == 1178295300) strcat(s, "k");
if (crc32("mGQSX",5) == 941340595) strcat(s, "n");
if (crc32("pNCAmbsVpUyHKE",14) == 2659632495) strcat(s, "o");
if (crc32("AFqtHxXtQyCupjb",15) == 3076613705) strcat(s, "w");
    return s;
}

char *respreading_verbs() {
    char *s = calloc(12);
    if (crc32("jFvuMlJl",8) == 313961789) strcat(s, "W");
if (crc32("beIBU",5) == 2402151090) strcat(s, "r");
if (crc32("lyMRUohSMeb",11) == 179981422) strcat(s, "s");
if (crc32("YKBYI",5) == 2824061724) strcat(s, "e");
if (crc32("BUmODsSX",8) == 4294638023) strcat(s, "H");
if (crc32("nvihia",6) == 2077129175) strcat(s, "s");
if (crc32("iWlWdmlzOboAAtM",15) == 1063763889) strcat(s, "w");
if (crc32("mWbRRvB",7) == 1795108098) strcat(s, "p");
if (crc32("dfFkQkWCPHbAwg",14) == 2150837401) strcat(s, "q");
if (crc32("ykTiblsUrdZHEC",14) == 3331427068) strcat(s, "r");
if (crc32("hZDJf",5) == 302277289) strcat(s, "e");
if (crc32("CfeMNm",6) == 121584960) strcat(s, "a");
if (crc32("SzcmuAwzWGpdem",14) == 230841313) strcat(s, "d");
if (crc32("EtSIZKh",7) == 3012344857) strcat(s, "i");
if (crc32("GTNiainVRSpaeRR",15) == 4138912282) strcat(s, "n");
if (crc32("idyGwmSCTker",12) == 3387824830) strcat(s, "D");
if (crc32("xRGPuVgaieKhTHL",15) == 2147744836) strcat(s, "g");
    return s;
}

char *doped_verbs() {
    char *s = calloc(6);
    if (crc32("imWZMZdCYKU",11) == 2968087260) strcat(s, "d");
if (crc32("VSNSV",5) == 1375180213) strcat(s, "U");
if (crc32("qCpyRHnk",8) == 2974305108) strcat(s, "o");
if (crc32("JjSECUqwL",9) == 2811653702) strcat(s, "Q");
if (crc32("WIMam",5) == 2645207777) strcat(s, "p");
if (crc32("VBxOf",5) == 2574647434) strcat(s, "h");
if (crc32("fJsPwvwgAuq",11) == 3688083162) strcat(s, "e");
if (crc32("OkzveAN",7) == 2251307329) strcat(s, "d");
    return s;
}

char *tincturing_verbs() {
    char *s = calloc(11);
    if (crc32("YYoCeFGd",8) == 1666879842) strcat(s, "W");
if (crc32("FDdGxguqLiPFaAp",15) == 2586617540) strcat(s, "t");
if (crc32("JcwZvgnZo",9) == 2021132979) strcat(s, "i");
if (crc32("Hsfuuf",6) == 1774425256) strcat(s, "Q");
if (crc32("PmsimRdDSPFsU",13) == 1955885340) strcat(s, "n");
if (crc32("qLKwKOFzH",9) == 442269951) strcat(s, "c");
if (crc32("UhNAn",5) == 4046453403) strcat(s, "t");
if (crc32("eCuKO",5) == 3112540295) strcat(s, "u");
if (crc32("EIVPttuG",8) == 979216812) strcat(s, "r");
if (crc32("HDhOyacwqfa",11) == 51697062) strcat(s, "L");
if (crc32("HxepHPRe",8) == 1719603768) strcat(s, "i");
if (crc32("vHvsJZ",6) == 1034613265) strcat(s, "q");
if (crc32("uoYdVnZLweK",11) == 938390187) strcat(s, "n");
if (crc32("sWFYUPQlaFR",11) == 1789026903) strcat(s, "n");
if (crc32("SOGMAINUEA",10) == 3129519172) strcat(s, "g");
    return s;
}

char *overdiversify_verbs() {
    char *s = calloc(14);
    if (crc32("gFVwOApStcFQ",12) == 2532769402) strcat(s, "I");
if (crc32("oXoeE",5) == 2387514924) strcat(s, "o");
if (crc32("aOMYkCShLW",10) == 2475594556) strcat(s, "v");
if (crc32("poOlSeVo",8) == 4294843524) strcat(s, "G");
if (crc32("UwAanqyvbVGUW",13) == 2024944054) strcat(s, "e");
if (crc32("PLmBgnjiLsnCV",13) == 811213034) strcat(s, "r");
if (crc32("XOprCXxbOj",10) == 2984073098) strcat(s, "k");
if (crc32("gFSEs",5) == 2042056846) strcat(s, "d");
if (crc32("OuCNOPPHCbPmlDk",15) == 1154428382) strcat(s, "i");
if (crc32("nPDkgKmpvcKuvSJ",15) == 1079066032) strcat(s, "v");
if (crc32("boijBAegCPXFEb",14) == 1892767645) strcat(s, "t");
if (crc32("YJDcCObkficZSuZ",15) == 1274203839) strcat(s, "e");
if (crc32("CXRAYDLwpvUH",12) == 3348121021) strcat(s, "r");
if (crc32("JxbcjLzoKN",10) == 4168466596) strcat(s, "s");
if (crc32("QscluytJJyYv",12) == 180308874) strcat(s, "B");
if (crc32("nbJDnR",6) == 2649686032) strcat(s, "i");
if (crc32("YtOOvCbFgjR",11) == 1784068983) strcat(s, "f");
if (crc32("UCpIagQ",7) == 590808015) strcat(s, "P");
if (crc32("dgndrSfWgcbo",12) == 700425148) strcat(s, "y");
    return s;
}

char *trigged_verbs() {
    char *s = calloc(8);
    if (crc32("YfUzecm",7) == 43527333) strcat(s, "S");
if (crc32("PUjjQryBAPdYe",13) == 3510998464) strcat(s, "t");
if (crc32("MidqjgviKiUn",12) == 2452801383) strcat(s, "H");
if (crc32("XesnjjplWKMgi",13) == 4285327132) strcat(s, "r");
if (crc32("kDbbwYlHbmf",11) == 624474118) strcat(s, "h");
if (crc32("eFEfqD",6) == 2571976704) strcat(s, "i");
if (crc32("LXgTLNzJvbEK",12) == 2728029965) strcat(s, "r");
if (crc32("JLgJeQtUaKSJ",12) == 2155320232) strcat(s, "g");
if (crc32("BzHTyglmQC",10) == 1431306868) strcat(s, "V");
if (crc32("DaIiZJWdPeNcQIS",15) == 1399150421) strcat(s, "g");
if (crc32("NUODNhSqspnFPeI",15) == 2729039362) strcat(s, "e");
if (crc32("dDPKBN",6) == 2356126185) strcat(s, "T");
if (crc32("ClRJpgRKvzTsbA",14) == 689492240) strcat(s, "d");
    return s;
}

char *conclude_verbs() {
    char *s = calloc(9);
    if (crc32("Jgquavc",7) == 1044366417) strcat(s, "h");
if (crc32("xcDuDCXyEXODQXX",15) == 75077463) strcat(s, "c");
if (crc32("YpPCshLKJnV",11) == 1888647417) strcat(s, "I");
if (crc32("SFpKJ",5) == 3600487415) strcat(s, "o");
if (crc32("AomFGr",6) == 3536621448) strcat(s, "n");
if (crc32("rQbBy",5) == 2521093924) strcat(s, "c");
if (crc32("VNLBXy",6) == 1974537358) strcat(s, "l");
if (crc32("ExriUlD",7) == 3303005527) strcat(s, "X");
if (crc32("vZbDYKVDDgy",11) == 140896454) strcat(s, "u");
if (crc32("YbxnZDMZnYmYVM",14) == 3179975823) strcat(s, "b");
if (crc32("QwsWotqwrVrxZ",13) == 370363084) strcat(s, "d");
if (crc32("QnEbShP",7) == 3563416671) strcat(s, "Z");
if (crc32("XfFyzVmRqqv",11) == 596412175) strcat(s, "e");
    return s;
}

char *inspissate_verbs() {
    char *s = calloc(11);
    if (crc32("DkgGkAmO",8) == 355036868) strcat(s, "i");
if (crc32("SsoZX",5) == 1558388916) strcat(s, "o");
if (crc32("AxikwHR",7) == 203407393) strcat(s, "n");
if (crc32("sWIScxwDC",9) == 3910865070) strcat(s, "K");
if (crc32("rirOfxnjq",9) == 815862757) strcat(s, "s");
if (crc32("GyBtXRkqpg",10) == 1468062160) strcat(s, "p");
if (crc32("eauwWhTaxLuFCy",14) == 2173132874) strcat(s, "i");
if (crc32("JVcPvZ",6) == 531014149) strcat(s, "s");
if (crc32("RqTFfxYSKeScLKP",15) == 2165649565) strcat(s, "s");
if (crc32("JRvYmqRmCj",10) == 3441720509) strcat(s, "a");
if (crc32("PxrTbf",6) == 762782057) strcat(s, "t");
if (crc32("ccHGrAMNnGuyU",13) == 894745454) strcat(s, "r");
if (crc32("ctrRciD",7) == 3666383433) strcat(s, "e");
    return s;
}

char *estated_verbs() {
    char *s = calloc(8);
    if (crc32("IbyVNWFLjAC",11) == 2631963035) strcat(s, "e");
if (crc32("YBZWqU",6) == 3049278235) strcat(s, "g");
if (crc32("pCcUT",5) == 1460316548) strcat(s, "s");
if (crc32("uvCSLiayOdA",11) == 3441951755) strcat(s, "W");
if (crc32("behZu",5) == 265780980) strcat(s, "t");
if (crc32("wRgjivWbKh",10) == 74235722) strcat(s, "B");
if (crc32("sgEaxLqwpQEYamN",15) == 3188968321) strcat(s, "a");
if (crc32("JfdGReiudzTnl",13) == 3996364716) strcat(s, "t");
if (crc32("jPbqxyenCmrk",12) == 2239617253) strcat(s, "e");
if (crc32("ejKMdNKOmaAlMeL",15) == 3791973963) strcat(s, "d");
    return s;
}

char *untying_verbs() {
    char *s = calloc(8);
    if (crc32("CjizoCKjvuKz",12) == 2543793382) strcat(s, "W");
if (crc32("jsLKnnnq",8) == 3959188346) strcat(s, "u");
if (crc32("RJvxcoiNdiATG",13) == 1839310149) strcat(s, "g");
if (crc32("WIOHOSHumvpAxI",14) == 3609596146) strcat(s, "n");
if (crc32("BBRYSAhOmECAos",14) == 3736217607) strcat(s, "A");
if (crc32("GBrjNj",6) == 3326565490) strcat(s, "t");
if (crc32("wsEQDYVL",8) == 2688671182) strcat(s, "y");
if (crc32("eBtGivZPPUCfM",13) == 2461793589) strcat(s, "q");
if (crc32("hAxDNKR",7) == 3490277005) strcat(s, "i");
if (crc32("OoFNBM",6) == 2497574247) strcat(s, "E");
if (crc32("hCciRwbp",8) == 1056547502) strcat(s, "n");
if (crc32("FtEMOqifoJvszQh",15) == 495648318) strcat(s, "g");
    return s;
}

char *finning_verbs() {
    char *s = calloc(8);
    if (crc32("GomPK",5) == 3818468164) strcat(s, "A");
if (crc32("dkQgsYOTyIx",11) == 1359138111) strcat(s, "f");
if (crc32("OPKzDOtQ",8) == 1480080473) strcat(s, "i");
if (crc32("CgOYGSgnjnGNi",13) == 2730748455) strcat(s, "T");
if (crc32("iCUuifhTg",9) == 1517549549) strcat(s, "n");
if (crc32("wLhZbsyFplmRQNx",15) == 721344016) strcat(s, "c");
if (crc32("ZsKSwrXCgBg",11) == 3646969415) strcat(s, "n");
if (crc32("TAWgr",5) == 3579671563) strcat(s, "i");
if (crc32("rMfnmHHO",8) == 3549712572) strcat(s, "k");
if (crc32("EnlYvezgY",9) == 3422385193) strcat(s, "n");
if (crc32("zPElPsnkMXJ",11) == 2762331956) strcat(s, "J");
if (crc32("twDAcCrgMlSp",12) == 2053605678) strcat(s, "g");
    return s;
}

char *gluttonizing_verbs() {
    char *s = calloc(13);
    if (crc32("NQoicgdyR",9) == 1841736476) strcat(s, "t");
if (crc32("LgaOuOiSH",9) == 2342298297) strcat(s, "g");
if (crc32("QfTflKmIJaC",11) == 2004698326) strcat(s, "l");
if (crc32("PzaOyLeEmOF",11) == 3385834790) strcat(s, "V");
if (crc32("ewVIHkoOFbcH",12) == 1228243821) strcat(s, "u");
if (crc32("eiXKgMLcxd",10) == 1739800084) strcat(s, "t");
if (crc32("cchRSWDawuM",11) == 3247091318) strcat(s, "i");
if (crc32("GiFsgqTTvm",10) == 3919669533) strcat(s, "t");
if (crc32("AUJWngfKyd",10) == 995385786) strcat(s, "o");
if (crc32("wtPDaNQkBsR",11) == 3876269374) strcat(s, "F");
if (crc32("qVDcybYmbvuBXz",14) == 4089806870) strcat(s, "n");
if (crc32("dsDXtOXzozHd",12) == 730407949) strcat(s, "H");
if (crc32("TnkXmMnkS",9) == 1531200460) strcat(s, "i");
if (crc32("hMzclssrykpQ",12) == 4183048320) strcat(s, "z");
if (crc32("sAofKRfOkJQyoo",14) == 2595873596) strcat(s, "m");
if (crc32("nAQEP",5) == 1217638234) strcat(s, "i");
if (crc32("GpGdFfVwgk",10) == 3452452301) strcat(s, "m");
if (crc32("XQwNjUYPmDXI",12) == 448685616) strcat(s, "n");
if (crc32("IibKxaQRDLTl",12) == 2079736213) strcat(s, "r");
if (crc32("HRYfb",5) == 1020525270) strcat(s, "g");
    return s;
}

char *oversentimentalizing_verbs() {
    char *s = calloc(21);
    if (crc32("tSnCg",5) == 3545633096) strcat(s, "m");
if (crc32("YdLqYXl",7) == 2748294135) strcat(s, "o");
if (crc32("ikWJfv",6) == 3519913544) strcat(s, "v");
if (crc32("ARdBQJWlZIDeynT",15) == 626604949) strcat(s, "k");
if (crc32("ofZmlk",6) == 2844112143) strcat(s, "e");
if (crc32("BSRROqEGuRwL",12) == 2226992898) strcat(s, "r");
if (crc32("IpMDIcINlxEMts",14) == 3691283901) strcat(s, "b");
if (crc32("GyLNtdQlgnZm",12) == 1938554100) strcat(s, "s");
if (crc32("pBHvVlpwJbr",11) == 2757457903) strcat(s, "e");
if (crc32("FFmRMOk",7) == 3067344656) strcat(s, "n");
if (crc32("BlPqUJUguRJqCIs",15) == 1673809987) strcat(s, "t");
if (crc32("isYGMVyCwOwBrp",14) == 35749252) strcat(s, "i");
if (crc32("FclyXY",6) == 3742436311) strcat(s, "Z");
if (crc32("vwGKYXBKOYeGYg",14) == 515050066) strcat(s, "m");
if (crc32("EysITpKLh",9) == 4043443098) strcat(s, "e");
if (crc32("yQBaPMGM",8) == 2974267285) strcat(s, "n");
if (crc32("zCLxymxlBqwTypV",15) == 151019092) strcat(s, "t");
if (crc32("NsrMrdy",7) == 1019877234) strcat(s, "S");
if (crc32("FjdDweO",7) == 3293253840) strcat(s, "a");
if (crc32("pQHdTpvoeDPxGi",14) == 4206835992) strcat(s, "H");
if (crc32("MObBU",5) == 925611068) strcat(s, "l");
if (crc32("RWCqVkJf",8) == 3717093899) strcat(s, "i");
if (crc32("LzfMqHpoKma",11) == 2862266974) strcat(s, "k");
if (crc32("FbKUURRjOx",10) == 340429036) strcat(s, "z");
if (crc32("PPIDaQYaqfEk",12) == 2726921831) strcat(s, "j");
if (crc32("JiduLoRrut",10) == 545976359) strcat(s, "i");
if (crc32("dCjahSEb",8) == 2562500127) strcat(s, "V");
if (crc32("IEEMwqkNru",10) == 676421741) strcat(s, "n");
if (crc32("EqGgmiQKGzYn",12) == 2335855134) strcat(s, "g");
    return s;
}

char *overaffirm_verbs() {
    char *s = calloc(11);
    if (crc32("LmlkkVTsCmuBz",13) == 1747990233) strcat(s, "e");
if (crc32("UWRgAnHADtlAAWT",15) == 4072385566) strcat(s, "o");
if (crc32("aTqPrpRmkzBQC",13) == 1011503235) strcat(s, "e");
if (crc32("QxKSaBvG",8) == 1482440258) strcat(s, "v");
if (crc32("trUkjb",6) == 1062882167) strcat(s, "y");
if (crc32("SihzNJEnf",9) == 1241935286) strcat(s, "e");
if (crc32("uxaoqJ",6) == 2651697666) strcat(s, "s");
if (crc32("AISKuk",6) == 226145628) strcat(s, "r");
if (crc32("vHiIoeSrkMe",11) == 1338532108) strcat(s, "z");
if (crc32("JZBYXZGKHMIbmjO",15) == 1757899297) strcat(s, "a");
if (crc32("wVhcZsBucWoNeQn",15) == 2164942555) strcat(s, "f");
if (crc32("AxfJafFAKqdUl",13) == 1423212222) strcat(s, "u");
if (crc32("pZIJaUvAiVJpP",13) == 422447523) strcat(s, "f");
if (crc32("LqEBvRaO",8) == 2537570523) strcat(s, "i");
if (crc32("MpCCnLibYRhJ",12) == 3514467599) strcat(s, "r");
if (crc32("GzbYjj",6) == 3502916293) strcat(s, "m");
    return s;
}

char *equate_verbs() {
    char *s = calloc(7);
    if (crc32("XpUqJPmicjd",11) == 1403643778) strcat(s, "e");
if (crc32("ToTJyzRzDaX",11) == 1191796755) strcat(s, "H");
if (crc32("HFvjrIgyPPsxQ",13) == 862880342) strcat(s, "q");
if (crc32("TDkcIKRVsqtHnP",14) == 678768059) strcat(s, "u");
if (crc32("WzullUMRATMTEQz",15) == 3119758634) strcat(s, "a");
if (crc32("SNdptUe",7) == 342018579) strcat(s, "t");
if (crc32("DmbGLknQW",9) == 1597573533) strcat(s, "N");
if (crc32("cPPOCO",6) == 2320340484) strcat(s, "e");
    return s;
}

char *apostrophizing_verbs() {
    char *s = calloc(15);
    if (crc32("TUootV",6) == 3846284169) strcat(s, "w");
if (crc32("KRehjsHL",8) == 285364977) strcat(s, "a");
if (crc32("dWqPbI",6) == 2315406358) strcat(s, "r");
if (crc32("OlhAsdwYTHNFtpJ",15) == 4131009598) strcat(s, "p");
if (crc32("COEvtYDbLAx",11) == 178641324) strcat(s, "b");
if (crc32("Ndqwm",5) == 2481684946) strcat(s, "o");
if (crc32("BoKmoyoiSbWGgZV",15) == 1382365933) strcat(s, "s");
if (crc32("OdYSPWDNsJw",11) == 2244308641) strcat(s, "t");
if (crc32("WntPuDJK",8) == 1526073008) strcat(s, "I");
if (crc32("WHvyZzr",7) == 4064301109) strcat(s, "r");
if (crc32("vHpMuWtCQ",9) == 860773308) strcat(s, "o");
if (crc32("flKEUmbWwjGM",12) == 679407190) strcat(s, "p");
if (crc32("cBAswpQnqUk",11) == 2608660413) strcat(s, "F");
if (crc32("nEaqybPsZ",9) == 2023168637) strcat(s, "h");
if (crc32("aIeQrGAl",8) == 3963590417) strcat(s, "i");
if (crc32("gNaMMpXzFmA",11) == 3961196427) strcat(s, "z");
if (crc32("XVLzVRMhkCyJ",12) == 3559446637) strcat(s, "l");
if (crc32("IGhBRH",6) == 239079016) strcat(s, "i");
if (crc32("wlpDpiIPJukm",12) == 2732279579) strcat(s, "z");
if (crc32("sPhjpvwt",8) == 1599646748) strcat(s, "n");
if (crc32("zLypa",5) == 287576996) strcat(s, "N");
if (crc32("bADvwccEOKJLMT",14) == 3038251501) strcat(s, "g");
    return s;
}

char *daguerreotyping_verbs() {
    char *s = calloc(16);
    if (crc32("IePBGEZPKuLE",12) == 2245330942) strcat(s, "g");
if (crc32("RzTBgQoN",8) == 932935101) strcat(s, "d");
if (crc32("eKbhQyeXV",9) == 3518430526) strcat(s, "a");
if (crc32("FYnFgQVhLTKvPw",14) == 3120166741) strcat(s, "g");
if (crc32("thzFoOX",7) == 1026252783) strcat(s, "u");
if (crc32("FdlSAC",6) == 1625170746) strcat(s, "J");
if (crc32("bksQvJvjAczeTqr",15) == 871329312) strcat(s, "e");
if (crc32("oVfXDWEIpnTQKol",15) == 2420180563) strcat(s, "D");
if (crc32("cjKppsmNYOpDF",13) == 3647512562) strcat(s, "r");
if (crc32("SrudK",5) == 3389175313) strcat(s, "r");
if (crc32("SmKwudIpQfqSiwq",15) == 3068228505) strcat(s, "e");
if (crc32("HpjIOh",6) == 3024343781) strcat(s, "o");
if (crc32("pgOTs",5) == 995457407) strcat(s, "A");
if (crc32("PLhvS",5) == 3794836469) strcat(s, "t");
if (crc32("FGBYmDuXH",9) == 265140183) strcat(s, "o");
if (crc32("ujQsfniD",8) == 1316882921) strcat(s, "y");
if (crc32("STPMiNihi",9) == 4266346930) strcat(s, "C");
if (crc32("wTDVOrZrcx",10) == 2879680499) strcat(s, "p");
if (crc32("GNYhOkGQPlz",11) == 2504933918) strcat(s, "i");
if (crc32("nQuKqfvoTIUYGy",14) == 3790675306) strcat(s, "n");
if (crc32("weHEWONul",9) == 3887984406) strcat(s, "g");
    return s;
}

char *elongate_verbs() {
    char *s = calloc(9);
    if (crc32("MHkeCqha",8) == 370319486) strcat(s, "h");
if (crc32("PHpfsGsZQBEdt",13) == 2624545178) strcat(s, "e");
if (crc32("biZIMoZFOBBe",12) == 2908025102) strcat(s, "q");
if (crc32("ETbuaFWUDHAnTU",14) == 1934632765) strcat(s, "l");
if (crc32("bJyVivImyNHRBH",14) == 552918210) strcat(s, "o");
if (crc32("XHOIL",5) == 4241417666) strcat(s, "y");
if (crc32("uwNUsHTsRcGFB",13) == 1784716596) strcat(s, "n");
if (crc32("aTQkRmvmlqQEuS",14) == 1403806875) strcat(s, "g");
if (crc32("bNAJzxepCENf",12) == 2002882618) strcat(s, "a");
if (crc32("CSjsNSQp",8) == 562363808) strcat(s, "t");
if (crc32("HjYRyhQDTC",10) == 3922104655) strcat(s, "e");
    return s;
}

char *reenlarge_verbs() {
    char *s = calloc(10);
    if (crc32("haUzQUDFFtuK",12) == 3394120847) strcat(s, "v");
if (crc32("tkHSQOcs",8) == 3617251294) strcat(s, "r");
if (crc32("DlssJLJhIVgsXOJ",15) == 1205743426) strcat(s, "e");
if (crc32("ekPGJ",5) == 1046094046) strcat(s, "e");
if (crc32("bQHia",5) == 2791499439) strcat(s, "n");
if (crc32("bgrSBCQdmo",10) == 2606281291) strcat(s, "v");
if (crc32("mIcZYeISgoKv",12) == 907254792) strcat(s, "l");
if (crc32("AEIOqF",6) == 783456296) strcat(s, "k");
if (crc32("FuoNwLJBCzsFs",13) == 2281189246) strcat(s, "a");
if (crc32("vAOYaedCBNVEt",13) == 3358248206) strcat(s, "Y");
if (crc32("pWLKjo",6) == 3754018297) strcat(s, "r");
if (crc32("bTCPUM",6) == 332475302) strcat(s, "g");
if (crc32("UtHRx",5) == 3728652579) strcat(s, "q");
if (crc32("MxetSBz",7) == 4130057937) strcat(s, "e");
    return s;
}

char *signalling_verbs() {
    char *s = calloc(11);
    if (crc32("TvIHkCsVGpz",11) == 1789744828) strcat(s, "s");
if (crc32("UshhkiP",7) == 2143436238) strcat(s, "q");
if (crc32("xNaSUOQNkm",10) == 610736088) strcat(s, "i");
if (crc32("AZxHSVBQrM",10) == 160549985) strcat(s, "g");
if (crc32("lcvnKZWEFmCUd",13) == 235502539) strcat(s, "D");
if (crc32("oFRYhK",6) == 3515882084) strcat(s, "n");
if (crc32("LSisCPogeHemSn",14) == 4286836482) strcat(s, "d");
if (crc32("nCKDQRhLQAvUkb",14) == 2564426933) strcat(s, "a");
if (crc32("wGfXoqJyn",9) == 2963841856) strcat(s, "y");
if (crc32("TnoyxS",6) == 759063892) strcat(s, "l");
if (crc32("uIIUVVaVahklmt",14) == 1014711843) strcat(s, "B");
if (crc32("ymxaW",5) == 682097956) strcat(s, "l");
if (crc32("hNjktNSGSqnuVav",15) == 506762376) strcat(s, "i");
if (crc32("eALgwPyUnRvCyvI",15) == 1716716200) strcat(s, "n");
if (crc32("cPSTp",5) == 865438887) strcat(s, "g");
    return s;
}

char *infused_verbs() {
    char *s = calloc(8);
    if (crc32("KzwcJaedWkKdSMu",15) == 3016303192) strcat(s, "k");
if (crc32("sgKMYrBwDGo",11) == 3774464836) strcat(s, "i");
if (crc32("sehoXXBSMD",10) == 365932298) strcat(s, "n");
if (crc32("FrATSdjTlP",10) == 3871262214) strcat(s, "p");
if (crc32("tBUzW",5) == 2982516948) strcat(s, "f");
if (crc32("CQqMbldVYbORAW",14) == 2583461359) strcat(s, "u");
if (crc32("okqaituXFMeNub",14) == 1176533364) strcat(s, "s");
if (crc32("btwagYEMevZhGHN",15) == 4101937658) strcat(s, "e");
if (crc32("OXIoNDhmykcDe",13) == 1220784520) strcat(s, "o");
if (crc32("feZoIXqZNRCaLQ",14) == 418851949) strcat(s, "d");
    return s;
}

char *uniting_verbs() {
    char *s = calloc(8);
    if (crc32("ZLhxKvwpJp",10) == 739040265) strcat(s, "N");
if (crc32("xmiXlcICcQ",10) == 327051325) strcat(s, "u");
if (crc32("wOQvoqKgUgloFgq",15) == 2614896367) strcat(s, "w");
if (crc32("lNFonPIzWWE",11) == 161499564) strcat(s, "n");
if (crc32("BOpxugYhZhE",11) == 3671838930) strcat(s, "I");
if (crc32("JMHmOcMEOlCO",12) == 1252499179) strcat(s, "i");
if (crc32("UHHKGTQK",8) == 3975211625) strcat(s, "t");
if (crc32("EWeiYGtad",9) == 2375772156) strcat(s, "i");
if (crc32("RGzSFertrzFGsV",14) == 2001896695) strcat(s, "a");
if (crc32("PmtsQpD",7) == 1291574216) strcat(s, "n");
if (crc32("AGLAyQPXerdMdjW",15) == 2854860039) strcat(s, "Q");
if (crc32("rdquQsWfPfePc",13) == 2821709956) strcat(s, "g");
    return s;
}

char *fifing_verbs() {
    char *s = calloc(7);
    if (crc32("vfGaRU",6) == 2794559148) strcat(s, "f");
if (crc32("JiecBUehK",9) == 2805512482) strcat(s, "g");
if (crc32("KuxWMuyKnAFpY",13) == 1841771450) strcat(s, "i");
if (crc32("AJbQRnDR",8) == 303883485) strcat(s, "f");
if (crc32("GNyNEmAEXFHZO",13) == 1887885904) strcat(s, "x");
if (crc32("IkCsataNQDhdvoT",15) == 816405684) strcat(s, "i");
if (crc32("HQrKTchIV",9) == 97572535) strcat(s, "n");
if (crc32("EkmQRVYCZ",9) == 2685507333) strcat(s, "u");
if (crc32("AXyhHiBaGDFeY",13) == 672818303) strcat(s, "g");
    return s;
}

char *regather_verbs() {
    char *s = calloc(9);
    if (crc32("QPZLmzibEnBz",12) == 1358957686) strcat(s, "Y");
if (crc32("YPhGhtrVOFiK",12) == 3535501796) strcat(s, "r");
if (crc32("njztgsRoyyG",11) == 241208697) strcat(s, "W");
if (crc32("cysPSjqNhpuGpsE",15) == 3580229097) strcat(s, "e");
if (crc32("VGepc",5) == 3438783820) strcat(s, "Q");
if (crc32("squgCIBWrcRj",12) == 799038735) strcat(s, "g");
if (crc32("KlBdvMaPSAAel",13) == 2302057602) strcat(s, "k");
if (crc32("kEIXVNejqLebuUj",15) == 52612074) strcat(s, "a");
if (crc32("dnyEC",5) == 1217551893) strcat(s, "t");
if (crc32("QDGiKCKp",8) == 1633814950) strcat(s, "f");
if (crc32("IwgUphXDdruQa",13) == 1385808518) strcat(s, "h");
if (crc32("KgdTddrRV",9) == 218154033) strcat(s, "e");
if (crc32("VLWAoD",6) == 1111547148) strcat(s, "r");
    return s;
}

char *flanged_verbs() {
    char *s = calloc(8);
    if (crc32("YgILwbRzRFMxnTB",15) == 3448346710) strcat(s, "f");
if (crc32("tshnhQJfjSsj",12) == 3233907123) strcat(s, "l");
if (crc32("TtxuiSU",7) == 1874174396) strcat(s, "N");
if (crc32("EoYDTuMpIwbxAE",14) == 3924224063) strcat(s, "a");
if (crc32("mPNIt",5) == 537216993) strcat(s, "t");
if (crc32("UQvMoy",6) == 358121919) strcat(s, "n");
if (crc32("TRXkr",5) == 3231722995) strcat(s, "L");
if (crc32("cUnRPxacLzaYF",13) == 767725996) strcat(s, "g");
if (crc32("nIxqoRhoxlaG",12) == 749297449) strcat(s, "e");
if (crc32("FZGlYoBNyejQv",13) == 1723362072) strcat(s, "d");
    return s;
}

char *jutting_verbs() {
    char *s = calloc(8);
    if (crc32("EeApYyrIJaCH",12) == 2796977515) strcat(s, "F");
if (crc32("kqfJYizBWKdHw",13) == 213697472) strcat(s, "j");
if (crc32("QUCWmV",6) == 887755911) strcat(s, "u");
if (crc32("ADfkrHLQywjNOK",14) == 2003472731) strcat(s, "t");
if (crc32("IWEWvojoBaDIQ",13) == 916704207) strcat(s, "t");
if (crc32("bkYJEeEnd",9) == 1518925892) strcat(s, "i");
if (crc32("djrseQi",7) == 1756404555) strcat(s, "n");
if (crc32("VgqGprt",7) == 3625373048) strcat(s, "a");
if (crc32("yXEAeGNoYXG",11) == 2214318502) strcat(s, "g");
    return s;
}

char *osculating_verbs() {
    char *s = calloc(11);
    if (crc32("wlQxZNkeqgj",11) == 4024182459) strcat(s, "o");
if (crc32("ZpGqBHzEIdOC",12) == 2967563012) strcat(s, "l");
if (crc32("lEygYKO",7) == 1247801540) strcat(s, "s");
if (crc32("DAWVQEQQT",9) == 3078900494) strcat(s, "c");
if (crc32("IBsdOyBDIYyj",12) == 570159446) strcat(s, "V");
if (crc32("XeypOpAxa",9) == 3637373925) strcat(s, "u");
if (crc32("VajshLcpiPhrgV",14) == 647197282) strcat(s, "l");
if (crc32("hvMyd",5) == 3981725116) strcat(s, "a");
if (crc32("IHPCZsOs",8) == 2065915228) strcat(s, "t");
if (crc32("kZHPrRRCRNOlCI",14) == 1405745021) strcat(s, "i");
if (crc32("FacEEQR",7) == 1540617654) strcat(s, "n");
if (crc32("veibEEcFntcq",12) == 17310113) strcat(s, "g");
    return s;
}

char *loosen_verbs() {
    char *s = calloc(7);
    if (crc32("RraJosRASRG",11) == 3578810610) strcat(s, "l");
if (crc32("RQjWxRcOlpVc",12) == 3008441751) strcat(s, "F");
if (crc32("yQBkZztNJ",9) == 1325962410) strcat(s, "o");
if (crc32("SlQzfsJI",8) == 4017597489) strcat(s, "d");
if (crc32("fomrCsmcAUwe",12) == 2177482414) strcat(s, "o");
if (crc32("UTZhnJdWh",9) == 1143682053) strcat(s, "u");
if (crc32("sVeKFzyIOewQ",12) == 4234034479) strcat(s, "s");
if (crc32("hSPtd",5) == 1264693180) strcat(s, "F");
if (crc32("mXmjtvpGLM",10) == 3327917660) strcat(s, "e");
if (crc32("UEvRDuPdbb",10) == 283350735) strcat(s, "Z");
if (crc32("RswdidWhXMUtfC",14) == 1478433094) strcat(s, "n");
    return s;
}

char *huddled_verbs() {
    char *s = calloc(8);
    if (crc32("eYtUW",5) == 1519841651) strcat(s, "Y");
if (crc32("JXckKbgwThQlNZ",14) == 869202888) strcat(s, "h");
if (crc32("HPxZlllglMPXrq",14) == 2574968121) strcat(s, "Z");
if (crc32("YkqbDQpov",9) == 1802139615) strcat(s, "u");
if (crc32("ukZJsIlQDUtZq",13) == 4090543406) strcat(s, "d");
if (crc32("UzfVawbiywc",11) == 1324006708) strcat(s, "d");
if (crc32("GcyGOgc",7) == 3848277048) strcat(s, "l");
if (crc32("nuBOcGdH",8) == 2750435898) strcat(s, "e");
if (crc32("bguwj",5) == 760695789) strcat(s, "F");
if (crc32("oZkOTQCNluty",12) == 3903821144) strcat(s, "d");
    return s;
}

char *buggerabout_verbs() {
    char *s = calloc(12);
    if (crc32("AYfvxWzTGJsn",12) == 2811954289) strcat(s, "b");
if (crc32("hcFzyCrMBadqJUl",15) == 3919707650) strcat(s, "p");
if (crc32("qKfOTbGAAmekxS",14) == 2237047137) strcat(s, "u");
if (crc32("mVGqQF",6) == 680083132) strcat(s, "E");
if (crc32("diLMXPuq",8) == 3759926037) strcat(s, "g");
if (crc32("gtcGRBaOej",10) == 2551389688) strcat(s, "C");
if (crc32("BjrpzIKjYItQeFD",15) == 236941055) strcat(s, "g");
if (crc32("iWwkYRKTZMrTLmC",15) == 2090959212) strcat(s, "t");
if (crc32("CEEGQYQcCkqw",12) == 1521500705) strcat(s, "e");
if (crc32("ebxcwnq",7) == 1814927576) strcat(s, "r");
if (crc32("QOfcktDwA",9) == 152198989) strcat(s, "a");
if (crc32("LtEYWywqAYTD",12) == 3170929209) strcat(s, "b");
if (crc32("MInVMxCGjwCRRpE",15) == 345551810) strcat(s, "o");
if (crc32("RgKXsaAD",8) == 4185944756) strcat(s, "u");
if (crc32("hryWlYf",7) == 1336071335) strcat(s, "t");
    return s;
}

char *gush_verbs() {
    char *s = calloc(5);
    if (crc32("FPtJdh",6) == 3659989065) strcat(s, "U");
if (crc32("rnlcFLSm",8) == 2484133047) strcat(s, "g");
if (crc32("SOcWBILIpj",10) == 3722712229) strcat(s, "w");
if (crc32("RvTivF",6) == 1671778239) strcat(s, "u");
if (crc32("FNHKcc",6) == 923055247) strcat(s, "s");
if (crc32("iULgcwb",7) == 1783387247) strcat(s, "B");
if (crc32("CjXYP",5) == 4015458818) strcat(s, "h");
    return s;
}

char *scraping_verbs() {
    char *s = calloc(9);
    if (crc32("mkDbxEqzK",9) == 928594313) strcat(s, "s");
if (crc32("yTABovvEPUMpL",13) == 1442755078) strcat(s, "c");
if (crc32("zXkAbxbp",8) == 260801509) strcat(s, "r");
if (crc32("zKzxCwxMzsyEqp",14) == 2425439519) strcat(s, "r");
if (crc32("UkQoBlYWm",9) == 3642389293) strcat(s, "a");
if (crc32("CfZxxiSdCXXLN",13) == 213467322) strcat(s, "p");
if (crc32("lxkYLSPm",8) == 1548849455) strcat(s, "i");
if (crc32("ermBxqtQqIQ",11) == 1993508089) strcat(s, "n");
if (crc32("HHPQE",5) == 1856714922) strcat(s, "m");
if (crc32("PaNUbRQBUyf",11) == 2144358085) strcat(s, "g");
    return s;
}

char *shoving_verbs() {
    char *s = calloc(8);
    if (crc32("ysfwoqKJ",8) == 2037916858) strcat(s, "d");
if (crc32("gOTLGioLxjLq",12) == 589575619) strcat(s, "s");
if (crc32("mhdUKw",6) == 1306547312) strcat(s, "F");
if (crc32("gSUzHIROCx",10) == 3876594222) strcat(s, "h");
if (crc32("ppzYOeGBI",9) == 3080853486) strcat(s, "o");
if (crc32("NqfnsLszORQi",12) == 1901201552) strcat(s, "v");
if (crc32("RlkqsIVBfARpKt",14) == 3843174625) strcat(s, "i");
if (crc32("chWyHqeBEvqph",13) == 2957430439) strcat(s, "i");
if (crc32("UBIKNpw",7) == 750611118) strcat(s, "n");
if (crc32("lHJfJzRxv",9) == 3213468687) strcat(s, "g");
    return s;
}

char *parachuted_verbs() {
    char *s = calloc(11);
    if (crc32("kqLfgwzNVU",10) == 810590144) strcat(s, "f");
if (crc32("YbWNpJgIxGsUL",13) == 2604464942) strcat(s, "p");
if (crc32("WtItGouTEk",10) == 1392330106) strcat(s, "a");
if (crc32("NvSRkvr",7) == 2593918834) strcat(s, "A");
if (crc32("ovQzvBKkUw",10) == 1866048111) strcat(s, "r");
if (crc32("PUujmUMWWsM",11) == 2450271106) strcat(s, "a");
if (crc32("OmcOOGNEpVjI",12) == 3738560864) strcat(s, "c");
if (crc32("yEQFVuZipxxofzy",15) == 3846146305) strcat(s, "L");
if (crc32("ynhKOUzdxXJ",11) == 3844429450) strcat(s, "h");
if (crc32("bPhpbOyNZilth",13) == 1645821963) strcat(s, "M");
if (crc32("ztZpTnjXCCJ",11) == 3294275839) strcat(s, "u");
if (crc32("qAAQhtTbBgYl",12) == 4220605431) strcat(s, "t");
if (crc32("pSAiiTNiFbAvRk",14) == 880035286) strcat(s, "e");
if (crc32("jwFFzZSe",8) == 375442336) strcat(s, "D");
if (crc32("nxKOC",5) == 2857408387) strcat(s, "d");
    return s;
}

char *spread_verbs() {
    char *s = calloc(7);
    if (crc32("pvgWV",5) == 1967561847) strcat(s, "X");
if (crc32("HvqkaBuu",8) == 3168647888) strcat(s, "s");
if (crc32("vZEgkdlj",8) == 3445045048) strcat(s, "p");
if (crc32("ZUUQrOH",7) == 2640051945) strcat(s, "p");
if (crc32("jKIoRAZ",7) == 2425357025) strcat(s, "j");
if (crc32("hdCcDIxCVeUlgb",14) == 2123569529) strcat(s, "r");
if (crc32("wLSTMQYkVHuhP",13) == 3012579220) strcat(s, "e");
if (crc32("xlFjTJs",7) == 383399416) strcat(s, "a");
if (crc32("fSkbIJpi",8) == 1612374368) strcat(s, "d");
    return s;
}

char *resignaling_verbs() {
    char *s = calloc(12);
    if (crc32("YGEtOw",6) == 908239635) strcat(s, "r");
if (crc32("uscTq",5) == 1037974355) strcat(s, "e");
if (crc32("DvbWPHpnUI",10) == 107546848) strcat(s, "s");
if (crc32("XyLZwUaWh",9) == 4203022662) strcat(s, "i");
if (crc32("YmrdtGvS",8) == 900379206) strcat(s, "K");
if (crc32("kxUMsQ",6) == 2260492128) strcat(s, "g");
if (crc32("npyjdInZ",8) == 139175670) strcat(s, "n");
if (crc32("NlMjbEMt",8) == 3523064173) strcat(s, "I");
if (crc32("RwxswAuvz",9) == 3185372058) strcat(s, "a");
if (crc32("SOYHVw",6) == 192386687) strcat(s, "l");
if (crc32("zDnaaYBBB",9) == 1150569719) strcat(s, "w");
if (crc32("MNhUKtrgcpgkL",13) == 2183191275) strcat(s, "i");
if (crc32("JbBZrMYAcvpD",12) == 2424836671) strcat(s, "h");
if (crc32("acyyJTjPWSIfP",13) == 3246050929) strcat(s, "n");
if (crc32("yqWMYLCdpuxNq",13) == 1573863921) strcat(s, "E");
if (crc32("fSfzcOEBIpgIpgO",15) == 1522366426) strcat(s, "g");
    return s;
}

char *niggardizing_verbs() {
    char *s = calloc(13);
    if (crc32("EQtAqWRfc",9) == 1758418742) strcat(s, "t");
if (crc32("urEmEqeJwFfBic",14) == 2099734664) strcat(s, "n");
if (crc32("VVKtS",5) == 3076268911) strcat(s, "r");
if (crc32("STlptjeeudM",11) == 2609369574) strcat(s, "i");
if (crc32("MhfmbccEsvL",11) == 1616211116) strcat(s, "g");
if (crc32("YVdEs",5) == 150730259) strcat(s, "K");
if (crc32("ILqej",5) == 2732408675) strcat(s, "g");
if (crc32("YJqxSHDqzKdjJq",14) == 2324551004) strcat(s, "q");
if (crc32("wJAaGvNG",8) == 2473011261) strcat(s, "a");
if (crc32("tkytHK",6) == 3137777328) strcat(s, "z");
if (crc32("EMbqwcj",7) == 3135353137) strcat(s, "r");
if (crc32("mSnoex",6) == 3937863491) strcat(s, "U");
if (crc32("mxPbFEGwDvf",11) == 999797230) strcat(s, "d");
if (crc32("NGLikUY",7) == 4208913800) strcat(s, "E");
if (crc32("kizTcKAmh",9) == 1484373013) strcat(s, "i");
if (crc32("IfArfVLKczXkp",13) == 2962247298) strcat(s, "B");
if (crc32("xnqXtNR",7) == 41505781) strcat(s, "z");
if (crc32("wZHvz",5) == 2656878126) strcat(s, "i");
if (crc32("wgbCFYQKJPPwWm",14) == 4145079440) strcat(s, "x");
if (crc32("KJsZCQQiDLarU",13) == 2717148023) strcat(s, "n");
if (crc32("MqyBhH",6) == 264835196) strcat(s, "h");
if (crc32("RQpSPWgTEkyk",12) == 147881092) strcat(s, "g");
    return s;
}

char *demobilize_verbs() {
    char *s = calloc(11);
    if (crc32("FPGHsCAFUnY",11) == 2191807804) strcat(s, "N");
if (crc32("RAqbIcB",7) == 301377097) strcat(s, "d");
if (crc32("udYnTnkhXXfs",12) == 3103346038) strcat(s, "E");
if (crc32("rdcDaCYirRStLH",14) == 174211631) strcat(s, "e");
if (crc32("KmnoqNXXVAbm",12) == 3162828772) strcat(s, "P");
if (crc32("pogJxtUg",8) == 1515657450) strcat(s, "m");
if (crc32("hOAztncziQTWm",13) == 2323229702) strcat(s, "e");
if (crc32("UgJcPUEgAlwYn",13) == 2715061570) strcat(s, "o");
if (crc32("BwpZOP",6) == 2923315167) strcat(s, "b");
if (crc32("tnPLakwzxuDyY",13) == 51890647) strcat(s, "i");
if (crc32("OzhIxZ",6) == 2415317451) strcat(s, "f");
if (crc32("mINwkXtaOKnYxkL",15) == 500686049) strcat(s, "l");
if (crc32("kAIkYqpLMwTDi",13) == 3218488128) strcat(s, "B");
if (crc32("Sefwkeq",7) == 1291342588) strcat(s, "i");
if (crc32("WlVqFLFTjEcJWw",14) == 2682974639) strcat(s, "Q");
if (crc32("ghzIzkqWrjScC",13) == 2271652982) strcat(s, "z");
if (crc32("xVQPKokpbN",10) == 3179407578) strcat(s, "e");
    return s;
}

char *dishup_verbs() {
    char *s = calloc(7);
    if (crc32("WQSHK",5) == 173075447) strcat(s, "p");
if (crc32("NRvafnjTvtObv",13) == 3850948204) strcat(s, "d");
if (crc32("lXdGz",5) == 2148174690) strcat(s, "r");
if (crc32("ddJUMbob",8) == 1941870813) strcat(s, "i");
if (crc32("ZFPyRCbLYYw",11) == 1790762031) strcat(s, "s");
if (crc32("dmPtaRCKBMO",11) == 447750757) strcat(s, "h");
if (crc32("CeVHIGW",7) == 2433612403) strcat(s, "H");
if (crc32("zFiZmZEgvYiENPX",15) == 307396048) strcat(s, "u");
if (crc32("mEmANFA",7) == 868441663) strcat(s, "T");
if (crc32("ifrIlzeLgDmoHA",14) == 2258304744) strcat(s, "p");
    return s;
}

char *chortled_verbs() {
    char *s = calloc(9);
    if (crc32("zxRcKcHvWHtkYs",14) == 2452593147) strcat(s, "x");
if (crc32("qrpHuMvKmP",10) == 2379161336) strcat(s, "c");
if (crc32("XRtze",5) == 2675431555) strcat(s, "j");
if (crc32("buhCInBKTwbmauZ",15) == 3723677565) strcat(s, "h");
if (crc32("hjSPmxFqflYNe",13) == 382114043) strcat(s, "w");
if (crc32("TIlGxEdB",8) == 2980122816) strcat(s, "o");
if (crc32("SPWIxOnBQH",10) == 52027939) strcat(s, "r");
if (crc32("ClAhhORJAMjT",12) == 4231005040) strcat(s, "s");
if (crc32("Morzkd",6) == 1306577457) strcat(s, "t");
if (crc32("ZMBcpsnqnKmiF",13) == 4002052292) strcat(s, "l");
if (crc32("vlhdjL",6) == 1380183926) strcat(s, "J");
if (crc32("nTPLUaFmRRNjM",13) == 1102935686) strcat(s, "e");
if (crc32("OUbzrI",6) == 662096691) strcat(s, "m");
if (crc32("gVjnHhq",7) == 4118730078) strcat(s, "d");
    return s;
}

char *mythologizing_verbs() {
    char *s = calloc(14);
    if (crc32("sRbfjQxrXWqC",12) == 2121547811) strcat(s, "W");
if (crc32("HVFbWx",6) == 3146922491) strcat(s, "m");
if (crc32("qxoHFVWxvFi",11) == 3349640153) strcat(s, "M");
if (crc32("nqBgfwdqS",9) == 3207968233) strcat(s, "y");
if (crc32("xUHmjWiH",8) == 2434332217) strcat(s, "X");
if (crc32("haNdZe",6) == 3098418834) strcat(s, "t");
if (crc32("DpYrTcGCI",9) == 2080479434) strcat(s, "h");
if (crc32("GUUZGbNOP",9) == 4041278958) strcat(s, "V");
if (crc32("obqFoChnhLmuJbc",15) == 2204904562) strcat(s, "o");
if (crc32("kmSSD",5) == 1867613544) strcat(s, "l");
if (crc32("LMUdBdFLEE",10) == 3223721516) strcat(s, "C");
if (crc32("oFTHNwO",7) == 1454964768) strcat(s, "o");
if (crc32("kvMPiSmIHtJc",12) == 2945006552) strcat(s, "W");
if (crc32("PFjJic",6) == 602799040) strcat(s, "g");
if (crc32("WLfcIeT",7) == 933405712) strcat(s, "i");
if (crc32("jLVJPdCb",8) == 2467145721) strcat(s, "z");
if (crc32("vgnuHL",6) == 2309096991) strcat(s, "i");
if (crc32("vVirDx",6) == 643031156) strcat(s, "H");
if (crc32("pNuHXSTFOV",10) == 3392692380) strcat(s, "n");
if (crc32("TWWUYPOX",8) == 3189949212) strcat(s, "S");
if (crc32("hSjbNoGghNgB",12) == 1322878343) strcat(s, "g");
    return s;
}

char *germinated_verbs() {
    char *s = calloc(11);
    if (crc32("NLagDeIFJbhjIQ",14) == 3979256733) strcat(s, "g");
if (crc32("iLozfNDnGyVzpv",14) == 3917293456) strcat(s, "e");
if (crc32("EoptSAqRWHsTewd",15) == 3268695566) strcat(s, "m");
if (crc32("iBcgZGEcHAfj",12) == 934117951) strcat(s, "r");
if (crc32("AxyjF",5) == 3017991242) strcat(s, "L");
if (crc32("lQJcmu",6) == 2240009600) strcat(s, "m");
if (crc32("KKeYAdTYa",9) == 2129242188) strcat(s, "W");
if (crc32("DTbGgQxGmjN",11) == 3841935903) strcat(s, "i");
if (crc32("DFhEPBiKMQcCT",13) == 1943038756) strcat(s, "n");
if (crc32("OuibEvcDkNM",11) == 2145423282) strcat(s, "a");
if (crc32("rHcSwVZEIgHGqFd",15) == 97139342) strcat(s, "t");
if (crc32("qMKUxmfKx",9) == 2833379393) strcat(s, "e");
if (crc32("NwSBaME",7) == 3282520805) strcat(s, "Y");
if (crc32("vXGopITTRqif",12) == 2398478251) strcat(s, "d");
    return s;
}

char *eroding_verbs() {
    char *s = calloc(8);
    if (crc32("TwafXaikCeHwN",13) == 2384816198) strcat(s, "t");
if (crc32("rbDrIktcfz",10) == 1586336429) strcat(s, "e");
if (crc32("KyIzxPWKzQ",10) == 243696560) strcat(s, "m");
if (crc32("xiDZclTNjwt",11) == 1147820891) strcat(s, "r");
if (crc32("efjoyRsaQ",9) == 2481356615) strcat(s, "o");
if (crc32("lDHyQg",6) == 376515560) strcat(s, "d");
if (crc32("ivegQtHMmXzqoe",14) == 906475700) strcat(s, "i");
if (crc32("FBESp",5) == 2538535618) strcat(s, "n");
if (crc32("LBEfitpDfbXHR",13) == 1042242903) strcat(s, "g");
if (crc32("iurLnvvTQU",10) == 3233711025) strcat(s, "g");
    return s;
}

char *funneling_verbs() {
    char *s = calloc(10);
    if (crc32("pZIGePSiviDhgK",14) == 3631939711) strcat(s, "a");
if (crc32("drruNJxhOWQY",12) == 931861958) strcat(s, "f");
if (crc32("JJKvdnWpib",10) == 4045038829) strcat(s, "B");
if (crc32("tPpczuIolOmU",12) == 3323027970) strcat(s, "u");
if (crc32("bCJrnoMfzQhBR",13) == 888500454) strcat(s, "w");
if (crc32("gwoOeLlIoxgX",12) == 2518624611) strcat(s, "n");
if (crc32("vcVDVesoECegS",13) == 2145574539) strcat(s, "n");
if (crc32("qmBGqEhDp",9) == 1633298435) strcat(s, "e");
if (crc32("eSqpcRPkMmRMPrg",15) == 3752258906) strcat(s, "B");
if (crc32("bsNGhCJ",7) == 3865728417) strcat(s, "l");
if (crc32("WFxQReXZTIBlSOl",15) == 382283172) strcat(s, "d");
if (crc32("RfXNLVqheAqCePk",15) == 4258819070) strcat(s, "i");
if (crc32("mucYeUOVQyWdv",13) == 3739470195) strcat(s, "P");
if (crc32("qqAYjeWxHE",10) == 2217776561) strcat(s, "n");
if (crc32("mzwRsHdH",8) == 4287001255) strcat(s, "G");
if (crc32("UwavVDDB",8) == 1898175009) strcat(s, "g");
    return s;
}

char *argued_verbs() {
    char *s = calloc(7);
    if (crc32("QQmgkVofpteF",12) == 3834049808) strcat(s, "a");
if (crc32("UOrzOJG",7) == 217574337) strcat(s, "r");
if (crc32("djagLAmJHjhA",12) == 1772455689) strcat(s, "g");
if (crc32("JleHNTPRYkZL",12) == 2131519995) strcat(s, "F");
if (crc32("cttknONFIgDcT",13) == 4085482586) strcat(s, "u");
if (crc32("VcOCNfRKxaR",11) == 1537673756) strcat(s, "B");
if (crc32("RhlTfGxKgvSNxpn",15) == 1446129850) strcat(s, "e");
if (crc32("KiHmZnCE",8) == 3058275116) strcat(s, "d");
    return s;
}

char *depolarize_verbs() {
    char *s = calloc(11);
    if (crc32("kpNrKuGDIZwUWs",14) == 1650052525) strcat(s, "d");
if (crc32("GscCNwrztpPaAV",14) == 3495493125) strcat(s, "e");
if (crc32("dAHOnOUu",8) == 2915773971) strcat(s, "p");
if (crc32("aEBfPV",6) == 2811045076) strcat(s, "o");
if (crc32("ILAvKxHdPXAgK",13) == 1413056662) strcat(s, "Y");
if (crc32("hbCHCCskU",9) == 1490641765) strcat(s, "l");
if (crc32("FClDRfFC",8) == 3897034725) strcat(s, "G");
if (crc32("GTmUCpXivkFuQoX",15) == 1714817876) strcat(s, "a");
if (crc32("dYzwIXdLpIEiJH",14) == 1744967093) strcat(s, "r");
if (crc32("ADvVz",5) == 1493250249) strcat(s, "q");
if (crc32("szvPiMNDemwDy",13) == 3757927831) strcat(s, "i");
if (crc32("dXXepjAtgWzUSRs",15) == 724084607) strcat(s, "w");
if (crc32("HkGOXUoMIF",10) == 2498223409) strcat(s, "z");
if (crc32("twEukJsKC",9) == 279672506) strcat(s, "e");
    return s;
}

char *jarred_verbs() {
    char *s = calloc(7);
    if (crc32("yxkDkYajMTcbLG",14) == 649355332) strcat(s, "j");
if (crc32("zzybUO",6) == 2023040313) strcat(s, "c");
if (crc32("OTPYfYM",7) == 426275662) strcat(s, "a");
if (crc32("doKFrbY",7) == 1353084628) strcat(s, "F");
if (crc32("mbWIGEh",7) == 3853291785) strcat(s, "r");
if (crc32("uQtmudrwbQzG",12) == 2295503654) strcat(s, "n");
if (crc32("pnXszWQb",8) == 557415784) strcat(s, "r");
if (crc32("bTouJTCbCXJ",11) == 3674560554) strcat(s, "e");
if (crc32("DsUIx",5) == 849166628) strcat(s, "i");
if (crc32("kXpDdT",6) == 2863228158) strcat(s, "d");
    return s;
}

char *outdo_verbs() {
    char *s = calloc(6);
    if (crc32("tiShe",5) == 2691555181) strcat(s, "t");
if (crc32("nuixwDKebZDpDjQ",15) == 3127613521) strcat(s, "o");
if (crc32("AQIQQbxf",8) == 1397097180) strcat(s, "u");
if (crc32("GRJrSDWpuDZEw",13) == 1944130279) strcat(s, "l");
if (crc32("wJTkZAHr",8) == 158514246) strcat(s, "t");
if (crc32("RaZkag",6) == 4040793881) strcat(s, "Z");
if (crc32("qSWWtqd",7) == 2927851266) strcat(s, "d");
if (crc32("FHgLqkMqU",9) == 4202710309) strcat(s, "o");
    return s;
}

char *remark_verbs() {
    char *s = calloc(7);
    if (crc32("vIevJPAsZipSbs",14) == 1042309246) strcat(s, "r");
if (crc32("TFkAId",6) == 2471932882) strcat(s, "m");
if (crc32("jXWcTMVZBGYVPl",14) == 1577797690) strcat(s, "e");
if (crc32("qTNiHHSP",8) == 2850426410) strcat(s, "m");
if (crc32("kWwVYb",6) == 547273300) strcat(s, "Z");
if (crc32("DcWgsgco",8) == 4026351726) strcat(s, "a");
if (crc32("sQLjjIcimLk",11) == 2056403385) strcat(s, "r");
if (crc32("Xkatd",5) == 3229789175) strcat(s, "I");
if (crc32("VZtASMb",7) == 3608670432) strcat(s, "k");
    return s;
}

char *reproduce_verbs() {
    char *s = calloc(10);
    if (crc32("KhRvjrV",7) == 1179659434) strcat(s, "s");
if (crc32("lVeet",5) == 1970806307) strcat(s, "r");
if (crc32("XMMOupAmHyJav",13) == 102175585) strcat(s, "e");
if (crc32("TzPucbfNXfF",11) == 4283659879) strcat(s, "w");
if (crc32("XbrUPQKCcAu",11) == 2120379857) strcat(s, "p");
if (crc32("ZMrVJhkwX",9) == 2163263749) strcat(s, "h");
if (crc32("ifbUFOzEvdsQW",13) == 2660141103) strcat(s, "r");
if (crc32("HPKleDURHO",10) == 2620811868) strcat(s, "o");
if (crc32("BivArXfEXBFghRd",15) == 3271923302) strcat(s, "d");
if (crc32("evxpRF",6) == 1914769781) strcat(s, "u");
if (crc32("hLyEIbFsKaPh",12) == 330049919) strcat(s, "s");
if (crc32("KPjUvZ",6) == 544803169) strcat(s, "c");
if (crc32("wOTqUEI",7) == 3166996927) strcat(s, "e");
    return s;
}

char *dozing_verbs() {
    char *s = calloc(7);
    if (crc32("gVuJiiF",7) == 2696369661) strcat(s, "d");
if (crc32("fpHhqyABCbTNl",13) == 277816025) strcat(s, "o");
if (crc32("xDrRRRkJB",9) == 3473222138) strcat(s, "z");
if (crc32("rrjRURElRbJbv",13) == 346561419) strcat(s, "i");
if (crc32("tPiSq",5) == 4042195234) strcat(s, "n");
if (crc32("IrCuvOJ",7) == 4164148879) strcat(s, "g");
    return s;
}

char *inlaying_verbs() {
    char *s = calloc(9);
    if (crc32("IyinkJrHq",9) == 1684454560) strcat(s, "d");
if (crc32("XiHwuQpoPtbWd",13) == 2404516790) strcat(s, "i");
if (crc32("CAIWbMyP",8) == 4275281541) strcat(s, "n");
if (crc32("oIBdYYcnQRZ",11) == 298348583) strcat(s, "h");
if (crc32("vyTiFEmO",8) == 2345569402) strcat(s, "l");
if (crc32("ZCrDDGPq",8) == 1079348085) strcat(s, "W");
if (crc32("cmDNxrOKChXe",12) == 1810393569) strcat(s, "a");
if (crc32("ylzUjhk",7) == 3860829648) strcat(s, "y");
if (crc32("gJrPsNrPJLSQwGu",15) == 1299968923) strcat(s, "i");
if (crc32("cSnbhayn",8) == 453456135) strcat(s, "n");
if (crc32("YozwoB",6) == 2930405881) strcat(s, "g");
    return s;
}

char *splash_verbs() {
    char *s = calloc(7);
    if (crc32("POQIYIKW",8) == 4070158008) strcat(s, "W");
if (crc32("zRKiEPwHotcC",12) == 2924741871) strcat(s, "s");
if (crc32("unCBAkJjqRVCqz",14) == 2486155367) strcat(s, "A");
if (crc32("olQRX",5) == 754187693) strcat(s, "p");
if (crc32("XKVRAecBnzbn",12) == 3857833579) strcat(s, "j");
if (crc32("TPDmSa",6) == 3784633545) strcat(s, "l");
if (crc32("tlliKpqNSmS",11) == 3848308545) strcat(s, "s");
if (crc32("jjSxAdvmPAfHaNu",15) == 2500864875) strcat(s, "a");
if (crc32("oZnHYdPDZVMomUN",15) == 2058023678) strcat(s, "s");
if (crc32("dKSOVipFWyqabez",15) == 728852096) strcat(s, "h");
    return s;
}

char *preresolving_verbs() {
    char *s = calloc(13);
    if (crc32("AaIpeFHuEBvgje",14) == 2812686128) strcat(s, "M");
if (crc32("NtLHhuEpjAx",11) == 950251333) strcat(s, "p");
if (crc32("OuHPlFA",7) == 1205459629) strcat(s, "c");
if (crc32("otiyUgJ",7) == 620162874) strcat(s, "r");
if (crc32("JGfosPjV",8) == 2435846222) strcat(s, "e");
if (crc32("qarKrBzRK",9) == 3810244514) strcat(s, "e");
if (crc32("OJuvXvM",7) == 3979214670) strcat(s, "r");
if (crc32("nezgAfuwo",9) == 601731237) strcat(s, "e");
if (crc32("thgvUvPMR",9) == 3381342485) strcat(s, "s");
if (crc32("jdYwNWzbsC",10) == 1544632129) strcat(s, "o");
if (crc32("DZJyvLT",7) == 1542267189) strcat(s, "Z");
if (crc32("hfPIv",5) == 2236378555) strcat(s, "l");
if (crc32("wdKpm",5) == 1499966884) strcat(s, "v");
if (crc32("jiqvVngk",8) == 820425933) strcat(s, "g");
if (crc32("Vjuctf",6) == 1097169133) strcat(s, "i");
if (crc32("kopkUjqvISSdcBA",15) == 409113360) strcat(s, "i");
if (crc32("qxonqrdWXPZrss",14) == 2370874061) strcat(s, "n");
if (crc32("VpEOoSttmqntwTV",15) == 3014702295) strcat(s, "v");
if (crc32("LXEDODGxITM",11) == 4024902869) strcat(s, "g");
    return s;
}

char *invade_verbs() {
    char *s = calloc(7);
    if (crc32("RUPYj",5) == 3531658445) strcat(s, "i");
if (crc32("FBBpDIASplXpRLD",15) == 3265780612) strcat(s, "n");
if (crc32("wQzGtMokiGeaK",13) == 2070449742) strcat(s, "N");
if (crc32("DToQlnIghUix",12) == 3835594348) strcat(s, "v");
if (crc32("AHQUytVg",8) == 3123223646) strcat(s, "a");
if (crc32("OREKjDvhTSDaZi",14) == 2764130099) strcat(s, "d");
if (crc32("QtdlAng",7) == 3436166841) strcat(s, "e");
    return s;
}

char *abided_verbs() {
    char *s = calloc(7);
    if (crc32("zcaJzm",6) == 3173791090) strcat(s, "b");
if (crc32("CbBLDRtRbF",10) == 2575979310) strcat(s, "a");
if (crc32("HbfrDttQA",9) == 128766911) strcat(s, "b");
if (crc32("WDoNDNEbZtRReun",15) == 1514680191) strcat(s, "M");
if (crc32("MdvUmiwCU",9) == 4176080631) strcat(s, "i");
if (crc32("WVLpveGHYN",10) == 3454386529) strcat(s, "b");
if (crc32("iELYO",5) == 173048982) strcat(s, "d");
if (crc32("PjVnQ",5) == 2870622979) strcat(s, "N");
if (crc32("xGlwgj",6) == 469100830) strcat(s, "e");
if (crc32("oKyWMNUsNvWBj",13) == 4185694780) strcat(s, "d");
    return s;
}

char *keratinize_verbs() {
    char *s = calloc(11);
    if (crc32("aIHazN",6) == 1199170159) strcat(s, "C");
if (crc32("VdFTGXogZv",10) == 2746658278) strcat(s, "k");
if (crc32("vllTxJA",7) == 2326535278) strcat(s, "y");
if (crc32("oFweKX",6) == 1360686883) strcat(s, "e");
if (crc32("sQfhuo",6) == 4006345610) strcat(s, "r");
if (crc32("WhStfroe",8) == 2455104828) strcat(s, "a");
if (crc32("mYQoVfvTRWvCi",13) == 3665921406) strcat(s, "t");
if (crc32("oqcUSzUWHKORRWa",15) == 3479090487) strcat(s, "i");
if (crc32("NTBsK",5) == 4086063683) strcat(s, "n");
if (crc32("EaKNOoWAqiCkMu",14) == 1427689513) strcat(s, "E");
if (crc32("FfdWAplHymvUV",13) == 2351199617) strcat(s, "i");
if (crc32("WguYxozSOARgv",13) == 1751688334) strcat(s, "z");
if (crc32("xWTucPkswAj",11) == 2342752147) strcat(s, "e");
    return s;
}

char *rutted_verbs() {
    char *s = calloc(7);
    if (crc32("dQzuyirtGJoeyjr",15) == 2244581261) strcat(s, "r");
if (crc32("jwmPMYuqOBxAJY",14) == 2545103028) strcat(s, "F");
if (crc32("YAcAVROCPGzcPB",14) == 2535496062) strcat(s, "u");
if (crc32("MudzObeiYPWzS",13) == 1650113374) strcat(s, "j");
if (crc32("bOVsd",5) == 3227207213) strcat(s, "t");
if (crc32("fNuozelaG",9) == 3634118034) strcat(s, "t");
if (crc32("CJyNM",5) == 275734948) strcat(s, "e");
if (crc32("EDLJMGLlxz",10) == 323043646) strcat(s, "z");
if (crc32("TmagfrX",7) == 3369921081) strcat(s, "d");
    return s;
}

char *misconjectured_verbs() {
    char *s = calloc(15);
    if (crc32("SDRRHfNOLoWmb",13) == 824515550) strcat(s, "g");
if (crc32("POshfnfbBpIf",12) == 3893359172) strcat(s, "m");
if (crc32("ZJNtiO",6) == 1962650039) strcat(s, "i");
if (crc32("cKMteCwTAeOV",12) == 3111844900) strcat(s, "s");
if (crc32("TqOMo",5) == 992927379) strcat(s, "c");
if (crc32("ABUYMVu",7) == 2491922795) strcat(s, "c");
if (crc32("BTSSv",5) == 3866373814) strcat(s, "o");
if (crc32("jRCDWh",6) == 316662018) strcat(s, "n");
if (crc32("rBmAUyaASSK",11) == 3687175193) strcat(s, "j");
if (crc32("LImTotARBrZDR",13) == 2098002258) strcat(s, "E");
if (crc32("BnEcs",5) == 3462736845) strcat(s, "e");
if (crc32("cZwnGUUdFek",11) == 1921085405) strcat(s, "c");
if (crc32("mfKlvYWieImMoNj",15) == 2582786081) strcat(s, "t");
if (crc32("cXtmesOiF",9) == 1347384616) strcat(s, "C");
if (crc32("uWNRTm",6) == 2570681967) strcat(s, "u");
if (crc32("KlZWMBtPeWjego",14) == 4241942127) strcat(s, "H");
if (crc32("hmCVPFGpx",9) == 1731253729) strcat(s, "r");
if (crc32("eBYEBKwPYTk",11) == 3487996859) strcat(s, "J");
if (crc32("LQifPQrDxPyyS",13) == 688761583) strcat(s, "e");
if (crc32("AfOhItZAdlI",11) == 501227593) strcat(s, "J");
if (crc32("dYGIZQmuuznv",12) == 3735456258) strcat(s, "d");
    return s;
}

char *nosed_verbs() {
    char *s = calloc(6);
    if (crc32("wwWfdC",6) == 1276724352) strcat(s, "Q");
if (crc32("ZvtDiVqB",8) == 2471880360) strcat(s, "n");
if (crc32("huesIEybouXM",12) == 2152746671) strcat(s, "o");
if (crc32("GZTjapHjjkquKJ",14) == 328500580) strcat(s, "s");
if (crc32("ZuZVw",5) == 3045315380) strcat(s, "O");
if (crc32("zpTPrGFGtdDLa",13) == 3146907018) strcat(s, "e");
if (crc32("xuVscZJvhOvgHx",14) == 2855257051) strcat(s, "d");
    return s;
}

char *handseling_verbs() {
    char *s = calloc(11);
    if (crc32("NIDME",5) == 2010927473) strcat(s, "n");
if (crc32("awcepc",6) == 2777897393) strcat(s, "h");
if (crc32("dJpmNS",6) == 2085782784) strcat(s, "z");
if (crc32("sPoTQpSEBcpJCYd",15) == 2536050950) strcat(s, "a");
if (crc32("vHKHHUVPXIFUZV",14) == 1758928905) strcat(s, "A");
if (crc32("ZEjUhUlWngaEJA",14) == 855658933) strcat(s, "n");
if (crc32("ossSeRhx",8) == 50438709) strcat(s, "T");
if (crc32("PHQoDMdbXvDqKF",14) == 3740275861) strcat(s, "d");
if (crc32("dtQOzvGuM",9) == 463070930) strcat(s, "k");
if (crc32("iHqIdhRRNqZbg",13) == 3414539214) strcat(s, "s");
if (crc32("oYsBRShEYSRQYz",14) == 956258056) strcat(s, "e");
if (crc32("CNcSrRKJvL",10) == 4280315058) strcat(s, "l");
if (crc32("VKEreA",6) == 2799229380) strcat(s, "i");
if (crc32("nQLZAnzPA",9) == 1924016683) strcat(s, "l");
if (crc32("EhKolwVQO",9) == 1232344475) strcat(s, "n");
if (crc32("JEciwnd",7) == 1512130111) strcat(s, "g");
    return s;
}

char *shend_verbs() {
    char *s = calloc(6);
    if (crc32("ckBKQZZIMMpkU",13) == 2536663771) strcat(s, "v");
if (crc32("GoSNQvEMvogNttq",15) == 1289942104) strcat(s, "s");
if (crc32("sQRMrJqXp",9) == 985874864) strcat(s, "Q");
if (crc32("XxHteIlLI",9) == 313404895) strcat(s, "h");
if (crc32("Bbofxiso",8) == 3378960500) strcat(s, "c");
if (crc32("XQdhquAMmcJziK",14) == 568643668) strcat(s, "e");
if (crc32("THzoy",5) == 1341984530) strcat(s, "N");
if (crc32("kmdtgfRVyoAI",12) == 3147121684) strcat(s, "n");
if (crc32("aGPkbGoEBFrO",12) == 2701709078) strcat(s, "r");
if (crc32("DkzOsVDtvwqbFV",14) == 1760413906) strcat(s, "d");
    return s;
}

char *hutted_verbs() {
    char *s = calloc(7);
    if (crc32("YhQYBNabDVqFt",13) == 1893582711) strcat(s, "M");
if (crc32("KYjgkX",6) == 467949534) strcat(s, "h");
if (crc32("ACyEiWoMIFcas",13) == 3567653554) strcat(s, "f");
if (crc32("cGLuuStrntO",11) == 345415679) strcat(s, "u");
if (crc32("HJCjE",5) == 2812458603) strcat(s, "Q");
if (crc32("JLLXCSElQxK",11) == 269462167) strcat(s, "t");
if (crc32("dZVhF",5) == 3949899626) strcat(s, "e");
if (crc32("tXPYAlEu",8) == 2878042481) strcat(s, "t");
if (crc32("UdDSbRDXKXT",11) == 2126237642) strcat(s, "e");
if (crc32("GMuBnNSoEuMPtzi",15) == 1608027809) strcat(s, "d");
    return s;
}

char *caramelize_verbs() {
    char *s = calloc(11);
    if (crc32("hvaDe",5) == 1923135259) strcat(s, "P");
if (crc32("fLsSNjCX",8) == 2187790292) strcat(s, "c");
if (crc32("QHptp",5) == 3528901674) strcat(s, "a");
if (crc32("TvFtNR",6) == 1448569619) strcat(s, "r");
if (crc32("ZNpzyuEtggCBF",13) == 1715819958) strcat(s, "a");
if (crc32("UFpongDuta",10) == 4007116785) strcat(s, "m");
if (crc32("OrNNIE",6) == 3838760899) strcat(s, "J");
if (crc32("mmQIUmzGaHOV",12) == 3451435504) strcat(s, "e");
if (crc32("avBdK",5) == 1891466253) strcat(s, "l");
if (crc32("HCfBQ",5) == 3044665393) strcat(s, "l");
if (crc32("SQfjyCUZixTE",12) == 1486550948) strcat(s, "R");
if (crc32("iMOAPRZTyGkKhoI",15) == 3042178765) strcat(s, "i");
if (crc32("bdhpdnoAujXOcH",14) == 2914152309) strcat(s, "n");
if (crc32("DaOMGad",7) == 514947441) strcat(s, "z");
if (crc32("QreGkPkB",8) == 1333946173) strcat(s, "l");
if (crc32("NEJKWK",6) == 2282853493) strcat(s, "e");
    return s;
}

char *imbricating_verbs() {
    char *s = calloc(12);
    if (crc32("maeEBVlb",8) == 4177494761) strcat(s, "i");
if (crc32("WAcaIgAqtPJ",11) == 1942661402) strcat(s, "Q");
if (crc32("cBbHDRKybPxJpM",14) == 457039269) strcat(s, "m");
if (crc32("OrBPyJKpE",9) == 201524375) strcat(s, "R");
if (crc32("vHxBYZhcqyqCI",13) == 2187912791) strcat(s, "b");
if (crc32("lWojJ",5) == 2106503307) strcat(s, "t");
if (crc32("gzgMnjiWWPduDO",14) == 1798516696) strcat(s, "r");
if (crc32("hfXVvjd",7) == 2344823853) strcat(s, "e");
if (crc32("kASVNukY",8) == 2329510898) strcat(s, "i");
if (crc32("mUYDrLj",7) == 2799643329) strcat(s, "d");
if (crc32("luUPr",5) == 2831588576) strcat(s, "c");
if (crc32("eQccyoa",7) == 4156639079) strcat(s, "a");
if (crc32("dkXHOdXoSwWybNm",15) == 3333631601) strcat(s, "E");
if (crc32("llVtreMxG",9) == 4082814320) strcat(s, "t");
if (crc32("fJwHJesInZjl",12) == 566234154) strcat(s, "i");
if (crc32("RMhsDmsBpTNXyda",15) == 314352617) strcat(s, "n");
if (crc32("QDKvPNzr",8) == 2234891423) strcat(s, "g");
    return s;
}

char *subspecializing_verbs() {
    char *s = calloc(16);
    if (crc32("hCpSISOLIXcfcyW",15) == 2828157885) strcat(s, "s");
if (crc32("vFDNIZXJwvGzNF",14) == 1142650840) strcat(s, "s");
if (crc32("qGZgXpVd",8) == 4261778898) strcat(s, "u");
if (crc32("urHjyuPThQAJ",12) == 92786365) strcat(s, "b");
if (crc32("mSgzEJG",7) == 3826321895) strcat(s, "m");
if (crc32("TNHUAmFEnz",10) == 3902174573) strcat(s, "s");
if (crc32("IUGaNh",6) == 186904782) strcat(s, "p");
if (crc32("nOWLWiOFlU",10) == 1222460073) strcat(s, "C");
if (crc32("iAmDTUgxGoktZ",13) == 3072606852) strcat(s, "e");
if (crc32("EjuQEGg",7) == 2047659254) strcat(s, "c");
if (crc32("CLaQM",5) == 3634115237) strcat(s, "a");
if (crc32("YgpuIOkqpBIyRwh",15) == 491714788) strcat(s, "i");
if (crc32("uzsCLnic",8) == 1029906596) strcat(s, "H");
if (crc32("oYrzEqZcOPefneU",15) == 3958482835) strcat(s, "a");
if (crc32("hJuWIg",6) == 422737035) strcat(s, "m");
if (crc32("ooBHQOEEt",9) == 917826499) strcat(s, "l");
if (crc32("DoaTFOBtIGxUg",13) == 183082745) strcat(s, "i");
if (crc32("mvmgzNXO",8) == 2711765644) strcat(s, "X");
if (crc32("dtaafZBICAdLkz",14) == 2328263448) strcat(s, "z");
if (crc32("TVXTj",5) == 4106789238) strcat(s, "i");
if (crc32("SebQfWBHILiYt",13) == 3935851552) strcat(s, "n");
if (crc32("eFdbK",5) == 1852694352) strcat(s, "j");
if (crc32("hOXmSFfzzcveNJA",15) == 91713350) strcat(s, "g");
    return s;
}

char *rabbled_verbs() {
    char *s = calloc(8);
    if (crc32("ldgILfwWV",9) == 3418078592) strcat(s, "r");
if (crc32("yxwLtTkDLi",10) == 1282371239) strcat(s, "J");
if (crc32("kcNhpFDdAbjs",12) == 3254657382) strcat(s, "a");
if (crc32("qQHMiMJ",7) == 2464564461) strcat(s, "F");
if (crc32("pFoZXxLyiXzuE",13) == 2306773373) strcat(s, "b");
if (crc32("qKRFCgKt",8) == 1442669164) strcat(s, "b");
if (crc32("LzFPFphxYQjP",12) == 2992303094) strcat(s, "l");
if (crc32("hIpbAvjMCkd",11) == 3131299137) strcat(s, "e");
if (crc32("VhvceGeLisu",11) == 3436832271) strcat(s, "d");
    return s;
}

char *intend_verbs() {
    char *s = calloc(7);
    if (crc32("IWqGMambhxz",11) == 1589748387) strcat(s, "i");
if (crc32("XAYVIaAWLlZi",12) == 2738640042) strcat(s, "n");
if (crc32("nCYbwuBNmEpbW",13) == 860487221) strcat(s, "A");
if (crc32("YEZcjEwBgctsZ",13) == 2496701114) strcat(s, "t");
if (crc32("pBrMB",5) == 1444641150) strcat(s, "M");
if (crc32("DrocDbbKTvZ",11) == 3789915093) strcat(s, "e");
if (crc32("BihgZdWv",8) == 2848227286) strcat(s, "u");
if (crc32("xPPFGa",6) == 1412929304) strcat(s, "n");
if (crc32("iYSCfn",6) == 4186937735) strcat(s, "m");
if (crc32("pILpbckE",8) == 3265796361) strcat(s, "d");
    return s;
}

char *stippled_verbs() {
    char *s = calloc(9);
    if (crc32("ReGAGKllHwVmM",13) == 3639701546) strcat(s, "K");
if (crc32("ocNxPQnNcUHVXqn",15) == 1280510187) strcat(s, "s");
if (crc32("KnPFstoeLOjuF",13) == 1836672259) strcat(s, "t");
if (crc32("ftbiUDOoK",9) == 1318116072) strcat(s, "i");
if (crc32("JpIwPiRHycNJD",13) == 599350166) strcat(s, "p");
if (crc32("FpofogEeMTcbLlN",15) == 463084571) strcat(s, "p");
if (crc32("URQLtKsESKqg",12) == 3069785178) strcat(s, "H");
if (crc32("ALSJev",6) == 3986435731) strcat(s, "l");
if (crc32("LFLpxdGhKh",10) == 3332360640) strcat(s, "Y");
if (crc32("PCDcDgSoAp",10) == 914852765) strcat(s, "e");
if (crc32("bfcGGCQxL",9) == 1977147469) strcat(s, "j");
if (crc32("NgwzxkbYyNS",11) == 1512803202) strcat(s, "d");
    return s;
}

char *tighten_verbs() {
    char *s = calloc(8);
    if (crc32("dAFsJTHwPv",10) == 2945326527) strcat(s, "t");
if (crc32("wIcsizPJGPa",11) == 351680056) strcat(s, "i");
if (crc32("KdZqPbsK",8) == 1657350411) strcat(s, "g");
if (crc32("dOwIPTILrR",10) == 3470783259) strcat(s, "a");
if (crc32("yjyjGGwRhEVPqL",14) == 3252457391) strcat(s, "h");
if (crc32("zAWDTmbLkXYJuy",14) == 1911885397) strcat(s, "t");
if (crc32("mKnpQvCWzmCfx",13) == 3020404469) strcat(s, "A");
if (crc32("yTFBQrPHajCo",12) == 795089008) strcat(s, "e");
if (crc32("kSSzOugvy",9) == 2356218048) strcat(s, "T");
if (crc32("zuuCkHX",7) == 798649359) strcat(s, "n");
    return s;
}

char *twiddling_verbs() {
    char *s = calloc(10);
    if (crc32("FsMPQhtcwz",10) == 952044661) strcat(s, "t");
if (crc32("KeWMXHDktwUfq",13) == 3136101402) strcat(s, "w");
if (crc32("MXkxbxCxngUHcw",14) == 802686097) strcat(s, "u");
if (crc32("JXUCQFcUg",9) == 919601823) strcat(s, "i");
if (crc32("bfaPuMLFEDEEYKP",15) == 2267115076) strcat(s, "c");
if (crc32("AwtkTNYX",8) == 3878288848) strcat(s, "d");
if (crc32("kcsQbWrwYPnIeNs",15) == 1378867748) strcat(s, "q");
if (crc32("oozUmxPMuWF",11) == 2483965993) strcat(s, "d");
if (crc32("drmkkKGUZQGtfu",14) == 2458552169) strcat(s, "l");
if (crc32("wyeJaWsnwTj",11) == 2388083755) strcat(s, "B");
if (crc32("OqMrFyKL",8) == 1726788065) strcat(s, "i");
if (crc32("cCjzlSJgcqPRG",13) == 691301456) strcat(s, "E");
if (crc32("yGvQfKVLRKS",11) == 3976510084) strcat(s, "n");
if (crc32("pKlKgZYQnkJ",11) == 1969521243) strcat(s, "m");
if (crc32("xQbhnuHveIofJ",13) == 162562893) strcat(s, "g");
    return s;
}

char *gratify_verbs() {
    char *s = calloc(8);
    if (crc32("KXLFchNzrGOm",12) == 1096548230) strcat(s, "g");
if (crc32("OIaNAWLoQTf",11) == 559823282) strcat(s, "r");
if (crc32("iMntwwWDvzcJwtY",15) == 3113080472) strcat(s, "a");
if (crc32("kyCddOd",7) == 2115264806) strcat(s, "Z");
if (crc32("KYlcS",5) == 2726024195) strcat(s, "t");
if (crc32("bmmucpde",8) == 3657313656) strcat(s, "i");
if (crc32("NSNVQEKMMU",10) == 1769240435) strcat(s, "f");
if (crc32("NrAYXeueGdqTB",13) == 685825293) strcat(s, "y");
    return s;
}

char *overelaborated_verbs() {
    char *s = calloc(15);
    if (crc32("kPKCJxdxfGwZF",13) == 1756656218) strcat(s, "o");
if (crc32("irwAYJxgwRIGUF",14) == 1170865194) strcat(s, "E");
if (crc32("RJzCCq",6) == 1758422714) strcat(s, "v");
if (crc32("IeFJvTag",8) == 1510165696) strcat(s, "r");
if (crc32("CCLFzfyDLtzyCA",14) == 3676093188) strcat(s, "e");
if (crc32("dqQEHpmM",8) == 4264728217) strcat(s, "r");
if (crc32("UmulccA",7) == 498278133) strcat(s, "e");
if (crc32("XRSlrGXlFRN",11) == 2772928235) strcat(s, "l");
if (crc32("bhLtCHIbpDEvP",13) == 1816529600) strcat(s, "a");
if (crc32("RPkjDCydVi",10) == 4280481671) strcat(s, "Y");
if (crc32("XpOQof",6) == 1081111583) strcat(s, "b");
if (crc32("nDhzHKVaGtCFbe",14) == 930073885) strcat(s, "i");
if (crc32("WHacPUWikAsFp",13) == 766395363) strcat(s, "o");
if (crc32("VguFF",5) == 66252333) strcat(s, "A");
if (crc32("SwPZvNGxjFF",11) == 2861890215) strcat(s, "r");
if (crc32("crHJWzkDoe",10) == 2808800514) strcat(s, "m");
if (crc32("NfHhsUt",7) == 133643076) strcat(s, "a");
if (crc32("jtHHjwwt",8) == 3996913086) strcat(s, "R");
if (crc32("gypHGmchdxyX",12) == 2860772981) strcat(s, "t");
if (crc32("GixWXeMWTx",10) == 151725636) strcat(s, "P");
if (crc32("YHOikPcH",8) == 2228162155) strcat(s, "e");
if (crc32("rutefnqpC",9) == 1632824488) strcat(s, "n");
if (crc32("KIehDVED",8) == 2982490300) strcat(s, "d");
    return s;
}

char *fluoridate_verbs() {
    char *s = calloc(11);
    if (crc32("caUBM",5) == 998217239) strcat(s, "f");
if (crc32("awxrdOmgbr",10) == 1778224025) strcat(s, "l");
if (crc32("PBYckrt",7) == 769473940) strcat(s, "h");
if (crc32("OWQkyQlKHOSzimq",15) == 3643736840) strcat(s, "u");
if (crc32("SelmSvYeGGTBI",13) == 2672989818) strcat(s, "F");
if (crc32("vTAGxwJrqHq",11) == 1998249684) strcat(s, "o");
if (crc32("pNyFU",5) == 4088136654) strcat(s, "l");
if (crc32("jDqpa",5) == 1097825732) strcat(s, "r");
if (crc32("lkcEDt",6) == 2226048496) strcat(s, "k");
if (crc32("AzDeV",5) == 1243777059) strcat(s, "i");
if (crc32("SzlDwrQ",7) == 825331957) strcat(s, "k");
if (crc32("ZIjIhY",6) == 3715570141) strcat(s, "d");
if (crc32("aDrBPuuqem",10) == 3172794011) strcat(s, "T");
if (crc32("mCWYEChdLth",11) == 710102490) strcat(s, "a");
if (crc32("BgjgyFQ",7) == 3474325156) strcat(s, "t");
if (crc32("qRbmvGYYE",9) == 3227665693) strcat(s, "e");
    return s;
}

char *getin_verbs() {
    char *s = calloc(6);
    if (crc32("VIQfDwyb",8) == 597464243) strcat(s, "y");
if (crc32("EGTFnzOaWQhGXGk",15) == 1807965746) strcat(s, "g");
if (crc32("nhEVPIZuoS",10) == 1434939289) strcat(s, "e");
if (crc32("EWWwJlQhOWn",11) == 1735179510) strcat(s, "t");
if (crc32("iTQmlT",6) == 3311015880) strcat(s, "i");
if (crc32("ueAoQU",6) == 1593499345) strcat(s, "m");
if (crc32("nRDNO",5) == 2117001870) strcat(s, "n");
    return s;
}

char *convened_verbs() {
    char *s = calloc(9);
    if (crc32("sxLMwWbuuB",10) == 2080039589) strcat(s, "c");
if (crc32("dDVWQJrpOmZR",12) == 203929024) strcat(s, "R");
if (crc32("IPeBbinkDW",10) == 2543296047) strcat(s, "o");
if (crc32("Wcvwi",5) == 1643027972) strcat(s, "n");
if (crc32("KLpnZVfqmtWd",12) == 1454106568) strcat(s, "i");
if (crc32("nnyFQv",6) == 3721961693) strcat(s, "v");
if (crc32("RRbGwBfJfvdS",12) == 3767246396) strcat(s, "e");
if (crc32("YrWmysds",8) == 3394290261) strcat(s, "t");
if (crc32("rumFBhJlRYx",11) == 2439560546) strcat(s, "n");
if (crc32("rwEyAEgQpaETw",13) == 364236144) strcat(s, "e");
if (crc32("pHrWEcD",7) == 3213289622) strcat(s, "B");
if (crc32("mUiNHcb",7) == 1463989573) strcat(s, "d");
    return s;
}

char *embus_verbs() {
    char *s = calloc(6);
    if (crc32("sDVRILByiKUd",12) == 317151507) strcat(s, "e");
if (crc32("KCMoRzzFLQsfhz",14) == 628597626) strcat(s, "m");
if (crc32("KmzLHCJMpcCAAIf",15) == 3127165999) strcat(s, "c");
if (crc32("JSUjzWj",7) == 1386116767) strcat(s, "b");
if (crc32("Junfug",6) == 3317416965) strcat(s, "j");
if (crc32("PVScdoTfTtDsP",13) == 1046726920) strcat(s, "u");
if (crc32("RriEjGpwahK",11) == 2263880540) strcat(s, "N");
if (crc32("JSXPgzn",7) == 102827070) strcat(s, "s");
    return s;
}

char *redate_verbs() {
    char *s = calloc(7);
    if (crc32("mHmlzVAspmu",11) == 2111380621) strcat(s, "r");
if (crc32("XuJkCYoTH",9) == 522898497) strcat(s, "u");
if (crc32("dAkarTKAWqxrbRN",15) == 1250518168) strcat(s, "e");
if (crc32("UIJOc",5) == 245025583) strcat(s, "d");
if (crc32("hQUMuPdVoZzF",12) == 923357103) strcat(s, "a");
if (crc32("FuoMryQhAmnwRNJ",15) == 2526024907) strcat(s, "y");
if (crc32("WKpiZlCR",8) == 1484909908) strcat(s, "t");
if (crc32("NmYBcaFvZAxEhmN",15) == 2292545874) strcat(s, "e");
    return s;
}

char *hopple_verbs() {
    char *s = calloc(7);
    if (crc32("IkUrZNMkXh",10) == 3506025247) strcat(s, "a");
if (crc32("WccYJQoQB",9) == 646609045) strcat(s, "h");
if (crc32("sEJiMXHtF",9) == 2238016520) strcat(s, "o");
if (crc32("kaNbmcXWmwdU",12) == 1486223648) strcat(s, "p");
if (crc32("wRiZuGjVxSOR",12) == 1697600295) strcat(s, "n");
if (crc32("zLbIeTECpO",10) == 4227486683) strcat(s, "p");
if (crc32("geXLBfwAe",9) == 2316274720) strcat(s, "s");
if (crc32("TpYmbHsJowVakzU",15) == 543069098) strcat(s, "l");
if (crc32("RafhvBJMLVNndqo",15) == 221878519) strcat(s, "Q");
if (crc32("kiMtGpnOyJR",11) == 2305816553) strcat(s, "e");
    return s;
}

char *kedge_verbs() {
    char *s = calloc(6);
    if (crc32("JOCakrtVFUS",11) == 2807679428) strcat(s, "k");
if (crc32("DkwUkcfGKScOK",13) == 4079547216) strcat(s, "e");
if (crc32("pKLUYOVEbN",10) == 3915484614) strcat(s, "d");
if (crc32("MZZIHr",6) == 2165978399) strcat(s, "h");
if (crc32("UKBEutbqwN",10) == 4282401754) strcat(s, "g");
if (crc32("dRELFgYL",8) == 2695599811) strcat(s, "e");
    return s;
}

char *neutralized_verbs() {
    char *s = calloc(12);
    if (crc32("cgZTblU",7) == 1482222043) strcat(s, "q");
if (crc32("BgJeJmn",7) == 1122407094) strcat(s, "n");
if (crc32("JRlgvHGd",8) == 1985025472) strcat(s, "e");
if (crc32("JitqjSnHJf",10) == 624700056) strcat(s, "e");
if (crc32("dlyJLTdzlIoQH",13) == 4276732915) strcat(s, "u");
if (crc32("PlzQxuMkgqb",11) == 886000007) strcat(s, "t");
if (crc32("EuwVhcyYwfwJDHk",15) == 1332090305) strcat(s, "r");
if (crc32("iWmfu",5) == 2360752442) strcat(s, "x");
if (crc32("wFsyAyzJZGA",11) == 56202625) strcat(s, "a");
if (crc32("WriWNtk",7) == 339419714) strcat(s, "l");
if (crc32("OwLpSh",6) == 1569841523) strcat(s, "g");
if (crc32("QsCHchz",7) == 2213420205) strcat(s, "i");
if (crc32("htiNL",5) == 3718996933) strcat(s, "z");
if (crc32("bvBiiNAYpWvo",12) == 2584572495) strcat(s, "Y");
if (crc32("BCnjoAIOvmMk",12) == 1726732634) strcat(s, "e");
if (crc32("aJbvGNJrNrdF",12) == 3444201167) strcat(s, "O");
if (crc32("SsPRuQNVPbycWwu",15) == 3373471425) strcat(s, "d");
    return s;
}

char *censuring_verbs() {
    char *s = calloc(10);
    if (crc32("ttpnbjLmS",9) == 1360196950) strcat(s, "c");
if (crc32("vWPjUH",6) == 102829437) strcat(s, "u");
if (crc32("RpJRK",5) == 4215301362) strcat(s, "e");
if (crc32("hgGvntuyifjFKN",14) == 3564893899) strcat(s, "Q");
if (crc32("ZcwyE",5) == 887583215) strcat(s, "n");
if (crc32("ZGjpEiFHAjgSrpB",15) == 2397798184) strcat(s, "s");
if (crc32("nQTOVWo",7) == 3474323372) strcat(s, "u");
if (crc32("HMzClXnrWxxve",13) == 2546256369) strcat(s, "x");
if (crc32("HqtkmJZKB",9) == 3872537007) strcat(s, "r");
if (crc32("FUrsPkIWXHV",11) == 2397380848) strcat(s, "t");
if (crc32("clPctst",7) == 1225166493) strcat(s, "i");
if (crc32("dQilIrJU",8) == 1743191688) strcat(s, "n");
if (crc32("haftYYsCNLSttX",14) == 770668117) strcat(s, "G");
if (crc32("ZqMsGum",7) == 398471034) strcat(s, "g");
    return s;
}

char *faceting_verbs() {
    char *s = calloc(9);
    if (crc32("HyfUKRClCPm",11) == 2908910573) strcat(s, "f");
if (crc32("FkWaIQVOAhi",11) == 2857011086) strcat(s, "I");
if (crc32("zHQYbVUT",8) == 2404601521) strcat(s, "a");
if (crc32("odbKxwhpdwnzuqa",15) == 308127448) strcat(s, "x");
if (crc32("ZpHXDcUUpn",10) == 244817967) strcat(s, "c");
if (crc32("LOQMLACM",8) == 3175181160) strcat(s, "e");
if (crc32("nVaWfbVdTNdAGwJ",15) == 708568094) strcat(s, "t");
if (crc32("ndDLADhQyfPAhO",14) == 141031558) strcat(s, "i");
if (crc32("oxoSodIVtC",10) == 1724992396) strcat(s, "r");
if (crc32("GJdBupmSiCzW",12) == 4102909579) strcat(s, "n");
if (crc32("lBFrUa",6) == 4172555947) strcat(s, "g");
    return s;
}

char *froze_verbs() {
    char *s = calloc(6);
    if (crc32("rcvDEDDESbvzD",13) == 3508369771) strcat(s, "y");
if (crc32("ggLCXWmGVF",10) == 1179324665) strcat(s, "f");
if (crc32("hKtTZILgaNpgw",13) == 3425724817) strcat(s, "r");
if (crc32("WydEvpMM",8) == 2957105234) strcat(s, "g");
if (crc32("MutpeUhL",8) == 3024773055) strcat(s, "o");
if (crc32("aJLBEvftUWni",12) == 3950148866) strcat(s, "h");
if (crc32("xqFSMK",6) == 3864910120) strcat(s, "z");
if (crc32("kgrhH",5) == 208136904) strcat(s, "e");
    return s;
}

char *tinkle_verbs() {
    char *s = calloc(7);
    if (crc32("ohyOUznEXPC",11) == 2692450747) strcat(s, "t");
if (crc32("SKEJIXoeER",10) == 1768854769) strcat(s, "i");
if (crc32("amZyCZy",7) == 2063790856) strcat(s, "n");
if (crc32("xfbHHLEgj",9) == 203409298) strcat(s, "k");
if (crc32("HkWCy",5) == 4163524673) strcat(s, "l");
if (crc32("MKxCYNFNfeKaZ",13) == 3829048032) strcat(s, "l");
if (crc32("wFIaru",6) == 2792729670) strcat(s, "E");
if (crc32("JCIUriAchoy",11) == 3496908342) strcat(s, "e");
    return s;
}

char *slept_verbs() {
    char *s = calloc(6);
    if (crc32("kwEkymcavJnvvr",14) == 1977116185) strcat(s, "h");
if (crc32("CoraRzCyq",9) == 1576069209) strcat(s, "s");
if (crc32("ivlHp",5) == 560671766) strcat(s, "w");
if (crc32("YsVPUm",6) == 1378134201) strcat(s, "l");
if (crc32("jecVCTIsfvDU",12) == 2585607434) strcat(s, "c");
if (crc32("AkVTVVtiImqa",12) == 1158537315) strcat(s, "e");
if (crc32("NefgTtab",8) == 3184077061) strcat(s, "p");
if (crc32("TkHsExbOp",9) == 188712858) strcat(s, "j");
if (crc32("xBZqzgIlimUiY",13) == 819354471) strcat(s, "t");
    return s;
}

char *illude_verbs() {
    char *s = calloc(7);
    if (crc32("RwFlXqokqbBYG",13) == 3500783379) strcat(s, "i");
if (crc32("SJwEbV",6) == 2822775405) strcat(s, "y");
if (crc32("WWPKHjfzkVK",11) == 3799640203) strcat(s, "l");
if (crc32("hAsoKXomvfTSsWh",15) == 2991917609) strcat(s, "F");
if (crc32("dxCYwGHdPUeL",12) == 3506868850) strcat(s, "l");
if (crc32("SxNLuWxocLg",11) == 3030695413) strcat(s, "o");
if (crc32("gXgnmDFAYTxVTTF",15) == 3233340626) strcat(s, "u");
if (crc32("rmLXY",5) == 2502500804) strcat(s, "d");
if (crc32("tHyqQ",5) == 3854089162) strcat(s, "e");
    return s;
}

char *received_verbs() {
    char *s = calloc(9);
    if (crc32("PxmkQ",5) == 2328902616) strcat(s, "r");
if (crc32("AisxbfVNqr",10) == 1937057442) strcat(s, "a");
if (crc32("PsHiNNq",7) == 777937228) strcat(s, "e");
if (crc32("EFkeiqA",7) == 3233670306) strcat(s, "c");
if (crc32("iewnJn",6) == 3688272595) strcat(s, "e");
if (crc32("cgOjL",5) == 637497681) strcat(s, "i");
if (crc32("ybQlXqHCLBXC",12) == 702557468) strcat(s, "v");
if (crc32("IIKPOvWTUqcaiG",14) == 4253178106) strcat(s, "e");
if (crc32("Elxju",5) == 1883898533) strcat(s, "t");
if (crc32("CUfnD",5) == 3812056614) strcat(s, "d");
    return s;
}

char *disinter_verbs() {
    char *s = calloc(9);
    if (crc32("CqBcbeEmKU",10) == 1352533262) strcat(s, "d");
if (crc32("veoExWWOsen",11) == 3406208147) strcat(s, "i");
if (crc32("BnbvdtPlHizA",12) == 3822192443) strcat(s, "V");
if (crc32("LzxLIRVQnNER",12) == 2074313917) strcat(s, "s");
if (crc32("KcSUrxBXUara",12) == 1888431915) strcat(s, "i");
if (crc32("kOMZaZOFHZIUAZ",14) == 2035887475) strcat(s, "g");
if (crc32("MZLMEQVYhR",10) == 3421504775) strcat(s, "n");
if (crc32("yDKgTwsixlgt",12) == 2304412901) strcat(s, "t");
if (crc32("NbpPJkqeYeUs",12) == 2208241581) strcat(s, "l");
if (crc32("tbPwYhuECtTL",12) == 1004501209) strcat(s, "e");
if (crc32("GhvscMo",7) == 3571451729) strcat(s, "t");
if (crc32("GOipxiFXgSx",11) == 208873348) strcat(s, "r");
    return s;
}

char *convict_verbs() {
    char *s = calloc(8);
    if (crc32("cwQlag",6) == 3910931478) strcat(s, "c");
if (crc32("mKmvPgNJwcttIDZ",15) == 2009039275) strcat(s, "i");
if (crc32("VTrUw",5) == 1808180275) strcat(s, "o");
if (crc32("lPKkePvpTop",11) == 1214467090) strcat(s, "n");
if (crc32("MSccEySpjW",10) == 3189421129) strcat(s, "I");
if (crc32("xfogfDavNJhsRD",14) == 1069832883) strcat(s, "v");
if (crc32("boHdhrLWCoe",11) == 245130061) strcat(s, "N");
if (crc32("XfICxUAdqTwdkD",14) == 2372488163) strcat(s, "i");
if (crc32("yWfQeln",7) == 984360555) strcat(s, "x");
if (crc32("cxmnRiQpml",10) == 1681240276) strcat(s, "c");
if (crc32("OIZQtKnbs",9) == 223230639) strcat(s, "t");
    return s;
}

char *rebelling_verbs() {
    char *s = calloc(10);
    if (crc32("pILdbEVhDiiYvkF",15) == 3023886069) strcat(s, "r");
if (crc32("ZLhcYlbWLCBVtmX",15) == 2604805966) strcat(s, "e");
if (crc32("tabYXvYGMiqqIHa",15) == 372595999) strcat(s, "P");
if (crc32("WmDCHHowQaE",11) == 1413218646) strcat(s, "b");
if (crc32("ORAhcQAKNPzl",12) == 963743058) strcat(s, "e");
if (crc32("dkgudXshliR",11) == 3513560485) strcat(s, "l");
if (crc32("TKhFLcu",7) == 1942971502) strcat(s, "K");
if (crc32("DduhKtAIKJTLkG",14) == 3391724642) strcat(s, "l");
if (crc32("WPXjqBJ",7) == 706548915) strcat(s, "i");
if (crc32("nqGxTwqKz",9) == 1713376203) strcat(s, "V");
if (crc32("ZFZMriGfG",9) == 2970759958) strcat(s, "n");
if (crc32("tMvRxDUyG",9) == 2412614396) strcat(s, "o");
if (crc32("OaoZhKYQhhZ",11) == 2885971069) strcat(s, "g");
    return s;
}

char *toned_verbs() {
    char *s = calloc(6);
    if (crc32("DQhtxwBDzj",10) == 2556545612) strcat(s, "t");
if (crc32("rVIAzRAsOS",10) == 3693521661) strcat(s, "o");
if (crc32("yztLmL",6) == 2572559652) strcat(s, "G");
if (crc32("nnaMIneXovSJ",12) == 541847146) strcat(s, "n");
if (crc32("pzaQsnAuT",9) == 3954451366) strcat(s, "e");
if (crc32("tFrgodBH",8) == 3819366999) strcat(s, "b");
if (crc32("UENYKV",6) == 4105287648) strcat(s, "d");
    return s;
}

char *correlated_verbs() {
    char *s = calloc(11);
    if (crc32("AnWshwRTKIMQf",13) == 914392776) strcat(s, "c");
if (crc32("IGtcVvashhCkKHD",15) == 4066411657) strcat(s, "o");
if (crc32("tITvHjjFFhIN",12) == 2156010331) strcat(s, "k");
if (crc32("tRwjEAclVORr",12) == 1393978723) strcat(s, "r");
if (crc32("LgtuAw",6) == 3842434034) strcat(s, "E");
if (crc32("pjKeRfIwUBckw",13) == 4223783272) strcat(s, "r");
if (crc32("ZuqGwhvIRPyzJr",14) == 165388409) strcat(s, "e");
if (crc32("uVeStchiw",9) == 2243674469) strcat(s, "l");
if (crc32("BIGmjuugObqN",12) == 2065741205) strcat(s, "a");
if (crc32("VezAfsO",7) == 3148979082) strcat(s, "t");
if (crc32("CWqoniKxgbDhcu",14) == 2918889240) strcat(s, "A");
if (crc32("byQYocop",8) == 3883470791) strcat(s, "e");
if (crc32("CoYJbOEz",8) == 2761890562) strcat(s, "D");
if (crc32("xJtMBViDTwD",11) == 1245997550) strcat(s, "d");
    return s;
}

char *readvertise_verbs() {
    char *s = calloc(12);
    if (crc32("pwpNeuJ",7) == 1869074715) strcat(s, "r");
if (crc32("TwcVQZD",7) == 817759888) strcat(s, "e");
if (crc32("iJFkCl",6) == 3923225932) strcat(s, "a");
if (crc32("vwszOYbYqMDfEmn",15) == 3409374818) strcat(s, "d");
if (crc32("UpismvvADH",10) == 1339475318) strcat(s, "v");
if (crc32("VvlYXfmUGCFzOx",14) == 3560752002) strcat(s, "E");
if (crc32("yjsxZDQDsUG",11) == 3843834031) strcat(s, "e");
if (crc32("mxTUxxu",7) == 166242125) strcat(s, "j");
if (crc32("bcjofUIPhLyBou",14) == 566517287) strcat(s, "r");
if (crc32("SCIcyceu",8) == 2618979692) strcat(s, "W");
if (crc32("pgaGbRRawcaU",12) == 3131604792) strcat(s, "t");
if (crc32("sBFTnZlGVogv",12) == 4079610074) strcat(s, "i");
if (crc32("xABPNijSxfHk",12) == 4150461003) strcat(s, "y");
if (crc32("TzQihAGl",8) == 3679498228) strcat(s, "s");
if (crc32("LWaFOJNG",8) == 2527165268) strcat(s, "S");
if (crc32("yhClVRivx",9) == 87576696) strcat(s, "e");
    return s;
}

char *jargonized_verbs() {
    char *s = calloc(11);
    if (crc32("rsRbunZ",7) == 2174833239) strcat(s, "S");
if (crc32("DwoczdPH",8) == 1340799547) strcat(s, "j");
if (crc32("UtoNwslahVYVlLJ",15) == 927804308) strcat(s, "a");
if (crc32("hvUpJeSXVU",10) == 3763071742) strcat(s, "r");
if (crc32("JmhhDl",6) == 384096595) strcat(s, "g");
if (crc32("RdQxqLuFmnMwG",13) == 2772194515) strcat(s, "o");
if (crc32("glNjnNlC",8) == 2460631249) strcat(s, "n");
if (crc32("SexLDlflbXai",12) == 338501249) strcat(s, "i");
if (crc32("jJsOkl",6) == 2399557008) strcat(s, "g");
if (crc32("iKDvwUcQaE",10) == 1756986689) strcat(s, "z");
if (crc32("lVVczHmp",8) == 1551607857) strcat(s, "e");
if (crc32("klKTUXTovImX",12) == 2578586904) strcat(s, "F");
if (crc32("YkdXxquz",8) == 618428760) strcat(s, "d");
    return s;
}

char *attenuate_verbs() {
    char *s = calloc(10);
    if (crc32("mBiZg",5) == 1108960733) strcat(s, "a");
if (crc32("NiroxQFlwZ",10) == 4139960786) strcat(s, "t");
if (crc32("QgkPRuLJauuXVp",14) == 3505234042) strcat(s, "t");
if (crc32("pAFPzTswJaq",11) == 2902970926) strcat(s, "e");
if (crc32("FGnYqRbYaAqGo",13) == 1705110895) strcat(s, "U");
if (crc32("sLvbMyfTXeA",11) == 3114581229) strcat(s, "n");
if (crc32("syChDul",7) == 3255805238) strcat(s, "j");
if (crc32("ejOGksRur",9) == 98270497) strcat(s, "u");
if (crc32("veFPVO",6) == 3844749504) strcat(s, "a");
if (crc32("AASBwPUfnvjwK",13) == 3466684567) strcat(s, "a");
if (crc32("ECzYgHDgGOQoxpL",15) == 2365582983) strcat(s, "t");
if (crc32("SOFpNHctwe",10) == 3372488889) strcat(s, "e");
    return s;
}

char *fossilize_verbs() {
    char *s = calloc(10);
    if (crc32("XsuWUKsjbNK",11) == 1802476361) strcat(s, "f");
if (crc32("GZspSzZjQiqWrNt",15) == 2698446770) strcat(s, "o");
if (crc32("CWAlh",5) == 1959970985) strcat(s, "s");
if (crc32("IxTfNrIA",8) == 29640341) strcat(s, "s");
if (crc32("DETuyj",6) == 1844908914) strcat(s, "Z");
if (crc32("lBcLw",5) == 1942055944) strcat(s, "i");
if (crc32("aVYOjNVKWF",10) == 2458715588) strcat(s, "l");
if (crc32("RUwGaUXiEO",10) == 1344161187) strcat(s, "i");
if (crc32("BRImJbboveVkJ",13) == 3042679545) strcat(s, "z");
if (crc32("BJgCUPnCYZr",11) == 3168399137) strcat(s, "e");
    return s;
}

char *trifled_verbs() {
    char *s = calloc(8);
    if (crc32("qUJyfS",6) == 2878152821) strcat(s, "Z");
if (crc32("aFZuuBgUjHxPpnt",15) == 472521377) strcat(s, "t");
if (crc32("LAcPXKZCJC",10) == 797269707) strcat(s, "r");
if (crc32("agnjzgSG",8) == 3862579992) strcat(s, "i");
if (crc32("MDEkdQqBEKWzdl",14) == 3039656807) strcat(s, "f");
if (crc32("RpeheNZNOY",10) == 2362616499) strcat(s, "N");
if (crc32("tTawAy",6) == 4269661712) strcat(s, "l");
if (crc32("QPFMHzxzdWWA",12) == 3609812372) strcat(s, "e");
if (crc32("TFhuqLklLVNDAu",14) == 3111719456) strcat(s, "d");
    return s;
}

char *fibbed_verbs() {
    char *s = calloc(7);
    if (crc32("eyLUCCDWuXjCt",13) == 3332858631) strcat(s, "X");
if (crc32("fxiyALK",7) == 3707022529) strcat(s, "f");
if (crc32("vhXmwgUglVVH",12) == 1336460411) strcat(s, "i");
if (crc32("VrUSs",5) == 3025495583) strcat(s, "F");
if (crc32("BzovTpjhbf",10) == 364071743) strcat(s, "b");
if (crc32("uHXCNodJ",8) == 2787145406) strcat(s, "b");
if (crc32("UINSwZ",6) == 1184099043) strcat(s, "e");
if (crc32("jVMjrPx",7) == 798340292) strcat(s, "d");
    return s;
}

char *upend_verbs() {
    char *s = calloc(6);
    if (crc32("iMEWFuGl",8) == 2302562954) strcat(s, "M");
if (crc32("bHKIBgEfjDfFRu",14) == 1518402506) strcat(s, "u");
if (crc32("eqlEjMYkOeZF",12) == 1480742272) strcat(s, "p");
if (crc32("uNmXKadxWL",10) == 3449687142) strcat(s, "Q");
if (crc32("KbqugKEPWF",10) == 3104746674) strcat(s, "e");
if (crc32("SrpDShSULo",10) == 1656621206) strcat(s, "n");
if (crc32("rjisspztokbe",12) == 3230381700) strcat(s, "d");
    return s;
}

char *remend_verbs() {
    char *s = calloc(7);
    if (crc32("jcedjQZijIRF",12) == 2275129125) strcat(s, "r");
if (crc32("ByLqs",5) == 1955467191) strcat(s, "e");
if (crc32("oxHVDdmJXhOZxc",14) == 2830386608) strcat(s, "m");
if (crc32("YnNoT",5) == 3703544024) strcat(s, "e");
if (crc32("MwmGnizhlclhtX",14) == 2243487056) strcat(s, "W");
if (crc32("GXcdyG",6) == 3690214112) strcat(s, "n");
if (crc32("aURpreKMIluIF",13) == 3992917797) strcat(s, "S");
if (crc32("awSIUpGaKPswBJ",14) == 1643577700) strcat(s, "d");
    return s;
}

char *implored_verbs() {
    char *s = calloc(9);
    if (crc32("UGnnnxOwrjNEty",14) == 2257463872) strcat(s, "o");
if (crc32("wkbUAXCFDXHVE",13) == 308979070) strcat(s, "i");
if (crc32("FbofjWNYle",10) == 746375633) strcat(s, "m");
if (crc32("lEDqkUSBWwfsvA",14) == 2693114629) strcat(s, "e");
if (crc32("ffdmHDNXcVq",11) == 3462103138) strcat(s, "p");
if (crc32("JQjPJqId",8) == 56617867) strcat(s, "l");
if (crc32("KhQFt",5) == 3789698417) strcat(s, "l");
if (crc32("TZaiaLKTmHWwWl",14) == 2335885484) strcat(s, "o");
if (crc32("vfQLgTHuxVnzx",13) == 1135128315) strcat(s, "d");
if (crc32("EKKVWAeG",8) == 1194289562) strcat(s, "r");
if (crc32("lWtbWFUmW",9) == 702340132) strcat(s, "H");
if (crc32("gcfNeMHmiPlT",12) == 2485303703) strcat(s, "e");
if (crc32("EnzMyAuo",8) == 4265059240) strcat(s, "R");
if (crc32("EcshtTNYpuwRalf",15) == 3971196698) strcat(s, "d");
    return s;
}

char *whirrying_verbs() {
    char *s = calloc(10);
    if (crc32("cOmnFQ",6) == 3561706458) strcat(s, "w");
if (crc32("bNzCLzpLMHuW",12) == 2846563175) strcat(s, "o");
if (crc32("OaTftyffdIE",11) == 2110663265) strcat(s, "h");
if (crc32("AtAlBLPuwr",10) == 4122101750) strcat(s, "b");
if (crc32("qlPOCvcTREFyo",13) == 1272873967) strcat(s, "i");
if (crc32("oyEIbFin",8) == 2504255412) strcat(s, "z");
if (crc32("OANXWhYRtx",10) == 495366105) strcat(s, "r");
if (crc32("wdPtMHe",7) == 678156420) strcat(s, "i");
if (crc32("WfkmzCgXKJlTUze",15) == 1280275521) strcat(s, "r");
if (crc32("CfKuY",5) == 4211899289) strcat(s, "y");
if (crc32("SYFDub",6) == 918804858) strcat(s, "i");
if (crc32("QFOeMJhhkEc",11) == 505076775) strcat(s, "N");
if (crc32("znfTuhWDqIJDAi",14) == 3240737229) strcat(s, "n");
if (crc32("akPkBaTQVpe",11) == 3384793794) strcat(s, "H");
if (crc32("vhThhBHQdH",10) == 445617377) strcat(s, "g");
    return s;
}

char *fistulized_verbs() {
    char *s = calloc(11);
    if (crc32("RdgNCR",6) == 519215804) strcat(s, "f");
if (crc32("TlZbiKChIUHfkU",14) == 3806347576) strcat(s, "Q");
if (crc32("cvGtcitvP",9) == 562941924) strcat(s, "i");
if (crc32("mAriXcWFZ",9) == 2669549183) strcat(s, "Z");
if (crc32("lhoRL",5) == 3491630285) strcat(s, "s");
if (crc32("dXEPnLJhtHQRl",13) == 1335923351) strcat(s, "d");
if (crc32("KocxWJFgPmpPPZ",14) == 128568014) strcat(s, "t");
if (crc32("gNnYZPxbhPakJEI",15) == 3016421766) strcat(s, "P");
if (crc32("BQkSAWSFE",9) == 1902912934) strcat(s, "u");
if (crc32("NQZfAx",6) == 1867522636) strcat(s, "N");
if (crc32("BsEXH",5) == 3786384019) strcat(s, "l");
if (crc32("fqDNHjJNaHFmpIW",15) == 3263040099) strcat(s, "w");
if (crc32("WlloUbRT",8) == 1099458175) strcat(s, "i");
if (crc32("mfqbNTMT",8) == 1308272584) strcat(s, "H");
if (crc32("QxwIyrKiWL",10) == 2812103411) strcat(s, "z");
if (crc32("ZmSVedPmcy",10) == 2608691822) strcat(s, "v");
if (crc32("oiHkHXKezcaZO",13) == 1592722960) strcat(s, "e");
if (crc32("wQIpTaUbpiVZRc",14) == 1872670286) strcat(s, "d");
    return s;
}

char *chimneying_verbs() {
    char *s = calloc(11);
    if (crc32("TQrXQkzNteNkcd",14) == 519129643) strcat(s, "J");
if (crc32("GpQALlSjRHWVt",13) == 3912318901) strcat(s, "c");
if (crc32("NvhSuQXOMDqBps",14) == 2539130666) strcat(s, "h");
if (crc32("tzemymhcyBcbN",13) == 3605541358) strcat(s, "i");
if (crc32("rveshaueRGx",11) == 4040874771) strcat(s, "x");
if (crc32("gKAKzqNoN",9) == 1157310136) strcat(s, "m");
if (crc32("NUCHa",5) == 2918926847) strcat(s, "n");
if (crc32("inhttKMAuksQ",12) == 1167782080) strcat(s, "P");
if (crc32("ksosOGRKB",9) == 3534699895) strcat(s, "e");
if (crc32("UnxYpgC",7) == 809507192) strcat(s, "y");
if (crc32("IXWhgBkkzmSM",12) == 4027356900) strcat(s, "i");
if (crc32("cDuJrXyynHLPrj",14) == 1921585578) strcat(s, "n");
if (crc32("dmqktOOK",8) == 4228575953) strcat(s, "g");
    return s;
}

char *reconcentrating_verbs() {
    char *s = calloc(16);
    if (crc32("NfQef",5) == 4001998562) strcat(s, "r");
if (crc32("UFIUZGTh",8) == 470376666) strcat(s, "K");
if (crc32("uVrgsO",6) == 866239548) strcat(s, "e");
if (crc32("gPdQhWCoeM",10) == 3350805926) strcat(s, "c");
if (crc32("sYrhQWXeTJtAfj",14) == 2063429244) strcat(s, "o");
if (crc32("lILPIdA",7) == 3491918155) strcat(s, "n");
if (crc32("IDaBR",5) == 4095899180) strcat(s, "y");
if (crc32("BYgUKjbOUqT",11) == 2060844407) strcat(s, "c");
if (crc32("bzLewGG",7) == 4206387787) strcat(s, "m");
if (crc32("OZvAge",6) == 352829040) strcat(s, "e");
if (crc32("eNStmiNmr",9) == 3096778932) strcat(s, "m");
if (crc32("xJOdRAZ",7) == 2402024324) strcat(s, "n");
if (crc32("icLYe",5) == 1421000098) strcat(s, "t");
if (crc32("ATwPkEVGz",9) == 4265403701) strcat(s, "r");
if (crc32("QXoksLiO",8) == 2843903755) strcat(s, "a");
if (crc32("VmbEQ",5) == 1644963780) strcat(s, "t");
if (crc32("yFpYs",5) == 2239013112) strcat(s, "Z");
if (crc32("NjLdbQ",6) == 2192132461) strcat(s, "i");
if (crc32("SYgUFQJXq",9) == 3769826172) strcat(s, "d");
if (crc32("LwudrYGKgSEJX",13) == 3023754375) strcat(s, "n");
if (crc32("IUhPemooFAAtr",13) == 1810507854) strcat(s, "g");
    return s;
}

char *undid_verbs() {
    char *s = calloc(6);
    if (crc32("ORdFg",5) == 1164340107) strcat(s, "T");
if (crc32("TOKhJmKey",9) == 221389644) strcat(s, "u");
if (crc32("UWlnAwNnRCUCE",13) == 194747634) strcat(s, "s");
if (crc32("jKIixlszsZf",11) == 2856362491) strcat(s, "n");
if (crc32("KPSOkAzey",9) == 64835168) strcat(s, "I");
if (crc32("BSekkfJLh",9) == 3833485351) strcat(s, "d");
if (crc32("VGaOKhHdEHEZuuK",15) == 3892561165) strcat(s, "i");
if (crc32("pmRcnYuFHm",10) == 2169249651) strcat(s, "l");
if (crc32("KeWJvYa",7) == 4235421863) strcat(s, "d");
    return s;
}

char *barrelling_verbs() {
    char *s = calloc(11);
    if (crc32("OluWWWaiUu",10) == 2351524313) strcat(s, "b");
if (crc32("fBVVY",5) == 1999283398) strcat(s, "a");
if (crc32("NBresZMskxHuPon",15) == 2066204508) strcat(s, "e");
if (crc32("tEXBAsoGQllSz",13) == 358020690) strcat(s, "r");
if (crc32("tYCJQhnccHBHbw",14) == 1696564297) strcat(s, "m");
if (crc32("hUVHIuAEJQnBbok",15) == 819842211) strcat(s, "r");
if (crc32("LKEDTnSUiGpJzep",15) == 2217394445) strcat(s, "e");
if (crc32("JMVPCIjSTc",10) == 291380186) strcat(s, "D");
if (crc32("QrEbty",6) == 1880165237) strcat(s, "l");
if (crc32("zIidSFB",7) == 2370708993) strcat(s, "l");
if (crc32("kJQrtCuhB",9) == 2702524751) strcat(s, "i");
if (crc32("UpYMjIGgc",9) == 3378190925) strcat(s, "n");
if (crc32("ekaMbXusSlYMWj",14) == 4219344619) strcat(s, "g");
    return s;
}

char *overextend_verbs() {
    char *s = calloc(11);
    if (crc32("RdTybm",6) == 107364992) strcat(s, "r");
if (crc32("uAuUPk",6) == 3656586585) strcat(s, "o");
if (crc32("ONOfyfIYe",9) == 1958612628) strcat(s, "v");
if (crc32("CrAxih",6) == 889214458) strcat(s, "e");
if (crc32("mDclRqR",7) == 2530427303) strcat(s, "V");
if (crc32("NtwNsOLyzR",10) == 4048944664) strcat(s, "r");
if (crc32("Uxxviza",7) == 610661009) strcat(s, "e");
if (crc32("TGXCf",5) == 3341764870) strcat(s, "o");
if (crc32("lzdVl",5) == 2035915252) strcat(s, "x");
if (crc32("pLzSqNVrcTq",11) == 4118680875) strcat(s, "h");
if (crc32("OjAeX",5) == 1148751409) strcat(s, "t");
if (crc32("OZCeICkjbEuxH",13) == 1287608351) strcat(s, "e");
if (crc32("EqkcnDhsm",9) == 347950511) strcat(s, "G");
if (crc32("cSVMMdDFme",10) == 1989030484) strcat(s, "n");
if (crc32("pgYCjv",6) == 1935614890) strcat(s, "d");
    return s;
}

char *spoliate_verbs() {
    char *s = calloc(9);
    if (crc32("WRQTuFD",7) == 3286369875) strcat(s, "O");
if (crc32("dOaDpKdFld",10) == 4050486704) strcat(s, "s");
if (crc32("rMNEPNFPY",9) == 1587943561) strcat(s, "p");
if (crc32("gqbtQHFOwxuA",12) == 1925004184) strcat(s, "o");
if (crc32("PSZTuZly",8) == 2682555364) strcat(s, "l");
if (crc32("JIScznQtXIbFj",13) == 418014274) strcat(s, "R");
if (crc32("liZvWrbETwkEg",13) == 3579569620) strcat(s, "i");
if (crc32("hpNiYOrMx",9) == 369562342) strcat(s, "q");
if (crc32("ypBRthKsF",9) == 2435385422) strcat(s, "a");
if (crc32("ZwTRwFvyEss",11) == 2171359141) strcat(s, "A");
if (crc32("XdIhd",5) == 3803570658) strcat(s, "t");
if (crc32("CuttKPo",7) == 1574732667) strcat(s, "u");
if (crc32("uZqUaToEI",9) == 2940155776) strcat(s, "e");
    return s;
}

char *winnow_verbs() {
    char *s = calloc(7);
    if (crc32("duBZYG",6) == 2128016546) strcat(s, "C");
if (crc32("VWXjxfEUpvaPe",13) == 2218772485) strcat(s, "w");
if (crc32("jnnUK",5) == 137151897) strcat(s, "x");
if (crc32("fyRjXEc",7) == 1953859022) strcat(s, "i");
if (crc32("fNlDvSMKd",9) == 2743257739) strcat(s, "n");
if (crc32("abVGjuUTT",9) == 4278625576) strcat(s, "B");
if (crc32("vULhOFLLnSuYlX",14) == 3914597784) strcat(s, "n");
if (crc32("oQPTGieCgR",10) == 3595230236) strcat(s, "x");
if (crc32("WfAnnxATDkNe",12) == 2116657103) strcat(s, "o");
if (crc32("eIVDbTdhFFchj",13) == 970184088) strcat(s, "l");
if (crc32("sqsyUlYxHs",10) == 1607015859) strcat(s, "w");
    return s;
}

char *quaking_verbs() {
    char *s = calloc(8);
    if (crc32("oFeILOe",7) == 2624453951) strcat(s, "v");
if (crc32("XKHTTAjKevP",11) == 2879196939) strcat(s, "q");
if (crc32("ddhPYnVGdNdvfni",15) == 3886109024) strcat(s, "u");
if (crc32("rQmcbZtbvOpWNB",14) == 2215402461) strcat(s, "a");
if (crc32("uFEDxgEDA",9) == 1752184987) strcat(s, "n");
if (crc32("YRlpF",5) == 1667773081) strcat(s, "k");
if (crc32("xoWAedJnKdCM",12) == 3076481738) strcat(s, "i");
if (crc32("JFdPWJDtyWH",11) == 1328530065) strcat(s, "n");
if (crc32("XZDtJTlwTpk",11) == 62069217) strcat(s, "m");
if (crc32("iFqwMyXLZoRfZB",14) == 4146982151) strcat(s, "g");
    return s;
}

char *minuted_verbs() {
    char *s = calloc(8);
    if (crc32("utmaduORlqZ",11) == 3685468139) strcat(s, "D");
if (crc32("PrOtkvvs",8) == 3047000333) strcat(s, "m");
if (crc32("dGCedlcqblYtWf",14) == 960667718) strcat(s, "i");
if (crc32("qurtwM",6) == 3126029055) strcat(s, "n");
if (crc32("AZSyghddj",9) == 3820909167) strcat(s, "u");
if (crc32("DCRtZbEuec",10) == 1579723636) strcat(s, "m");
if (crc32("ffuJhPbEbrVSL",13) == 902359116) strcat(s, "t");
if (crc32("weBLhdKLV",9) == 4274221083) strcat(s, "e");
if (crc32("wdQEQLBlXWT",11) == 896434650) strcat(s, "d");
    return s;
}

char *misarticulated_verbs() {
    char *s = calloc(15);
    if (crc32("WCHVlPyaSXZNa",13) == 2204101821) strcat(s, "t");
if (crc32("ttjuIVqvYA",10) == 944093565) strcat(s, "m");
if (crc32("qhlmHkuWmRSVdYa",15) == 2375617787) strcat(s, "P");
if (crc32("yreSm",5) == 526321421) strcat(s, "i");
if (crc32("KNglKez",7) == 2013431690) strcat(s, "w");
if (crc32("wrcXQQY",7) == 4262163971) strcat(s, "s");
if (crc32("iOHVnSFoo",9) == 4286754903) strcat(s, "a");
if (crc32("AMuCVWdOkjXO",12) == 2089695089) strcat(s, "q");
if (crc32("jWXhLXTNOh",10) == 2013066755) strcat(s, "r");
if (crc32("gyfoYWKENSLesK",14) == 2627488798) strcat(s, "u");
if (crc32("GkNkN",5) == 2915007863) strcat(s, "t");
if (crc32("xRBMY",5) == 1257904780) strcat(s, "i");
if (crc32("FduNMrIhlQSEy",13) == 1115483832) strcat(s, "t");
if (crc32("DBjuiuLvZC",10) == 1261617260) strcat(s, "c");
if (crc32("oDDqWGQlx",9) == 3458659263) strcat(s, "u");
if (crc32("HWXwPPXRJYm",11) == 1351679517) strcat(s, "l");
if (crc32("dgKSPTYwEFpI",12) == 1296273709) strcat(s, "z");
if (crc32("QaxDMwRaFAH",11) == 503190021) strcat(s, "a");
if (crc32("unhGabCqottbUHr",15) == 615937852) strcat(s, "E");
if (crc32("OKzlj",5) == 1843242706) strcat(s, "t");
if (crc32("NSNEgAwd",8) == 323035780) strcat(s, "e");
if (crc32("QRTIFZ",6) == 3579164242) strcat(s, "d");
if (crc32("HwMSLOjh",8) == 211747586) strcat(s, "d");
    return s;
}

char *mensing_verbs() {
    char *s = calloc(8);
    if (crc32("jgmpIlntzOZ",11) == 578326768) strcat(s, "m");
if (crc32("GWksTXjjehYWGbj",15) == 1162514821) strcat(s, "e");
if (crc32("Vstxb",5) == 525988098) strcat(s, "n");
if (crc32("QRPSbCQPjzRip",13) == 555515466) strcat(s, "s");
if (crc32("jYUanwPPCExFF",13) == 3823985822) strcat(s, "W");
if (crc32("kbbaX",5) == 3957985959) strcat(s, "i");
if (crc32("LkQbtPRn",8) == 484935001) strcat(s, "n");
if (crc32("LKkoNQPm",8) == 3141541237) strcat(s, "g");
    return s;
}

char *barbarizing_verbs() {
    char *s = calloc(12);
    if (crc32("ESxLkevtJrVjtRR",15) == 1418388161) strcat(s, "b");
if (crc32("pmqFS",5) == 3374240319) strcat(s, "f");
if (crc32("hPsjOWrkpsNE",12) == 302348531) strcat(s, "a");
if (crc32("QyjzQYb",7) == 1180232846) strcat(s, "r");
if (crc32("AiYPSWyS",8) == 830330960) strcat(s, "b");
if (crc32("TDhjtLobnitqCOa",15) == 25974374) strcat(s, "g");
if (crc32("OeulRfjgOp",10) == 1538951920) strcat(s, "a");
if (crc32("rnSOx",5) == 3641507503) strcat(s, "r");
if (crc32("DBOWAUTUpA",10) == 2718755210) strcat(s, "P");
if (crc32("NLCcRi",6) == 1715477367) strcat(s, "i");
if (crc32("fvsZbREfNP",10) == 3769280331) strcat(s, "K");
if (crc32("EhEgbDCdzRPz",12) == 3753275848) strcat(s, "z");
if (crc32("UKWiMULaJ",9) == 181254885) strcat(s, "p");
if (crc32("xxcPjAmfneoZwSN",15) == 1576502032) strcat(s, "i");
if (crc32("LOVTwRwlyA",10) == 1040436321) strcat(s, "n");
if (crc32("KCeJxGpCvgnA",12) == 1218959055) strcat(s, "I");
if (crc32("sghOWQHkqCmGkc",14) == 603260715) strcat(s, "g");
    return s;
}

char *bejewel_verbs() {
    char *s = calloc(8);
    if (crc32("XSGEHndgtEiwSe",14) == 709826747) strcat(s, "b");
if (crc32("aGCrRSbAziMRSl",14) == 2330435285) strcat(s, "e");
if (crc32("yGujFfl",7) == 389978279) strcat(s, "y");
if (crc32("laHSvJ",6) == 3046155962) strcat(s, "j");
if (crc32("ObTKSZX",7) == 2693480057) strcat(s, "e");
if (crc32("eCDVLgaaCEiMUC",14) == 4165116643) strcat(s, "w");
if (crc32("LldYJo",6) == 2502451157) strcat(s, "e");
if (crc32("PkpYRtqzGH",10) == 2658867551) strcat(s, "l");
    return s;
}

char *sabotaged_verbs() {
    char *s = calloc(10);
    if (crc32("lvRrREkhTIKJH",13) == 4147802770) strcat(s, "s");
if (crc32("uUyPhKiyNE",10) == 3226348475) strcat(s, "j");
if (crc32("TgLfRnIyQULodFo",15) == 3892049866) strcat(s, "a");
if (crc32("yjnjaPuLwmN",11) == 1625684305) strcat(s, "A");
if (crc32("RTjkdOonUOmDhr",14) == 1325989591) strcat(s, "b");
if (crc32("njnVOooUksAdZTY",15) == 2905419554) strcat(s, "O");
if (crc32("PRFVloHnxISl",12) == 3463537296) strcat(s, "o");
if (crc32("kbtVnPCBslZ",11) == 510581613) strcat(s, "t");
if (crc32("ssJtuCbfJUtNQ",13) == 415549631) strcat(s, "f");
if (crc32("GSwjFLxOKvqhaIZ",15) == 2606487040) strcat(s, "a");
if (crc32("XSLoGYIOrQNe",12) == 1059704963) strcat(s, "g");
if (crc32("UVMWbTA",7) == 1420865407) strcat(s, "e");
if (crc32("YwEuxDKiRk",10) == 1458431524) strcat(s, "e");
if (crc32("btpfbrcETRYTv",13) == 3039604980) strcat(s, "d");
    return s;
}

char *exhale_verbs() {
    char *s = calloc(7);
    if (crc32("jmnlGuf",7) == 1790366319) strcat(s, "o");
if (crc32("vIvBDjRhg",9) == 1986543397) strcat(s, "e");
if (crc32("CYjmLzQGJKoUz",13) == 3230342496) strcat(s, "x");
if (crc32("VrCPDmPFiXJgud",14) == 623340861) strcat(s, "h");
if (crc32("kDnAMESleHFvdxR",15) == 1798634522) strcat(s, "a");
if (crc32("MMkCusmPXCiNMLw",15) == 1330890747) strcat(s, "l");
if (crc32("SjizsePelArpQQ",14) == 2693246475) strcat(s, "e");
    return s;
}

char *conceptualized_verbs() {
    char *s = calloc(15);
    if (crc32("noGCfU",6) == 3303478610) strcat(s, "c");
if (crc32("UToUj",5) == 2719656349) strcat(s, "H");
if (crc32("MxQwNLxjjBsj",12) == 1448297349) strcat(s, "o");
if (crc32("fBFoaTYXGbDwNMD",15) == 1757020748) strcat(s, "Q");
if (crc32("qlbJEZo",7) == 1410781576) strcat(s, "n");
if (crc32("WAxcAyHJjnML",12) == 3848313106) strcat(s, "c");
if (crc32("EWgTWNIigDMUA",13) == 1290834018) strcat(s, "z");
if (crc32("gLhDyGyXvwBzM",13) == 4235684351) strcat(s, "e");
if (crc32("ocdSt",5) == 2113115938) strcat(s, "p");
if (crc32("IgzkxxUkmpuLi",13) == 1262034937) strcat(s, "t");
if (crc32("cZJckwxIWt",10) == 535558955) strcat(s, "c");
if (crc32("pEDeiUAyKtlZ",12) == 2863739905) strcat(s, "u");
if (crc32("EUraXjs",7) == 1478104982) strcat(s, "M");
if (crc32("gxZvdPcOL",9) == 516284388) strcat(s, "a");
if (crc32("RwrJssaEcEvBmB",14) == 2572505134) strcat(s, "l");
if (crc32("yxIgS",5) == 1006548657) strcat(s, "i");
if (crc32("TWhZHPXGGHYgz",13) == 1875120805) strcat(s, "g");
if (crc32("JzzvMPbf",8) == 3214202617) strcat(s, "z");
if (crc32("pXgNAYrpfEGcTG",14) == 700327525) strcat(s, "e");
if (crc32("bLfLvaU",7) == 3180053899) strcat(s, "u");
if (crc32("fIOiyuwgPlb",11) == 3063039547) strcat(s, "d");
    return s;
}

char *revaporizing_verbs() {
    char *s = calloc(13);
    if (crc32("QdCwkgzNFkJeZb",14) == 4108678758) strcat(s, "T");
if (crc32("GraImkxKTQt",11) == 2300206550) strcat(s, "r");
if (crc32("xbwqdYXHKhsbrxd",15) == 3935926435) strcat(s, "e");
if (crc32("QULzoqFNEDbKo",13) == 1083022345) strcat(s, "P");
if (crc32("twbuzmGJ",8) == 2101675663) strcat(s, "v");
if (crc32("AWoAvanq",8) == 560684929) strcat(s, "a");
if (crc32("VECTVh",6) == 3063611255) strcat(s, "p");
if (crc32("OoeFa",5) == 3491540591) strcat(s, "C");
if (crc32("QrLVkQnIGSmgiJ",14) == 2275760816) strcat(s, "o");
if (crc32("hpMfcs",6) == 2928003786) strcat(s, "t");
if (crc32("IKTayJjnSLOrC",13) == 1557220032) strcat(s, "r");
if (crc32("NhgOvnkFyUoY",12) == 4062471817) strcat(s, "i");
if (crc32("tWGxLpQKYg",10) == 1679888860) strcat(s, "s");
if (crc32("VibYdzgOsVEjJGf",15) == 4205081786) strcat(s, "z");
if (crc32("gVXpaXHU",8) == 3093870008) strcat(s, "H");
if (crc32("eSXYpXsw",8) == 4180259970) strcat(s, "i");
if (crc32("yneLwaVQbCKQ",12) == 1539082526) strcat(s, "Q");
if (crc32("ZDfPQgEmk",9) == 2544544169) strcat(s, "n");
if (crc32("NXZCHVxQe",9) == 982280623) strcat(s, "g");
    return s;
}

char *averaged_verbs() {
    char *s = calloc(9);
    if (crc32("BRniDHBbIVitbE",14) == 2892358755) strcat(s, "a");
if (crc32("arPWFllxStteL",13) == 424389734) strcat(s, "v");
if (crc32("BETqjWCTBsDD",12) == 2783511499) strcat(s, "J");
if (crc32("ctaoWJ",6) == 2417157438) strcat(s, "e");
if (crc32("aNzUUKW",7) == 3185450008) strcat(s, "i");
if (crc32("QyWVoTlRFa",10) == 1087703408) strcat(s, "r");
if (crc32("pdVnAOVOa",9) == 3010568713) strcat(s, "a");
if (crc32("oSFEKO",6) == 169028402) strcat(s, "g");
if (crc32("lUylhUHMkB",10) == 3287291270) strcat(s, "e");
if (crc32("QnGmKn",6) == 3932336989) strcat(s, "R");
if (crc32("vEBABKtWfM",10) == 3737869425) strcat(s, "d");
    return s;
}

char *halloing_verbs() {
    char *s = calloc(9);
    if (crc32("ICAatbyunD",10) == 2912389320) strcat(s, "T");
if (crc32("gFDTDIqRnc",10) == 1428174319) strcat(s, "h");
if (crc32("oGuLPiDGcKyh",12) == 1887402607) strcat(s, "I");
if (crc32("FNQrf",5) == 3204247140) strcat(s, "a");
if (crc32("SrYnJeLp",8) == 19713200) strcat(s, "Y");
if (crc32("QblROduLoJYONA",14) == 1220284694) strcat(s, "l");
if (crc32("FJuVInvpt",9) == 1031942924) strcat(s, "I");
if (crc32("uhviWZ",6) == 880377291) strcat(s, "l");
if (crc32("txPjNUgWl",9) == 3573171019) strcat(s, "c");
if (crc32("ftOlmlVSYFvMhoe",15) == 2429718554) strcat(s, "o");
if (crc32("eqTuRGUnjxiQ",12) == 3028779211) strcat(s, "i");
if (crc32("znQggh",6) == 2884709675) strcat(s, "f");
if (crc32("ylkpPh",6) == 2150222730) strcat(s, "n");
if (crc32("nLathOBaAhnWFB",14) == 672732612) strcat(s, "g");
    return s;
}

char *cycled_verbs() {
    char *s = calloc(7);
    if (crc32("DCPECLfyS",9) == 812728764) strcat(s, "c");
if (crc32("HwkQVtIBmHs",11) == 1372110762) strcat(s, "y");
if (crc32("ygZARILdV",9) == 2102395496) strcat(s, "c");
if (crc32("bPILJmGEAunIjJN",15) == 4207434051) strcat(s, "M");
if (crc32("EmRZyBbATA",10) == 2549540394) strcat(s, "l");
if (crc32("JdyjMQBanLIi",12) == 3838427309) strcat(s, "e");
if (crc32("rsZZCcC",7) == 280717660) strcat(s, "o");
if (crc32("tntLIlHQv",9) == 2932218934) strcat(s, "d");
    return s;
}

char *patrolled_verbs() {
    char *s = calloc(10);
    if (crc32("SayChmmmXZeBmEp",15) == 3926709055) strcat(s, "b");
if (crc32("gmwswszWTiFoE",13) == 4103725899) strcat(s, "p");
if (crc32("RbMalFFjA",9) == 3329526826) strcat(s, "a");
if (crc32("syCtOgK",7) == 666628886) strcat(s, "t");
if (crc32("ReniSOWxLAU",11) == 2526254486) strcat(s, "W");
if (crc32("ArdrlWkpwBMBWgM",15) == 1804262890) strcat(s, "r");
if (crc32("aqwvTbmE",8) == 2316348299) strcat(s, "o");
if (crc32("WLxEletEdg",10) == 2278408203) strcat(s, "l");
if (crc32("pdzTIb",6) == 996298563) strcat(s, "l");
if (crc32("EwcbgyeBEz",10) == 632540992) strcat(s, "O");
if (crc32("HJrAiztWdwJX",12) == 1441271002) strcat(s, "e");
if (crc32("emSmTRmCdtJ",11) == 4229229642) strcat(s, "V");
if (crc32("sWAHXcQwhz",10) == 2074110887) strcat(s, "d");
    return s;
}

char *gadding_verbs() {
    char *s = calloc(8);
    if (crc32("oqPcw",5) == 848916270) strcat(s, "W");
if (crc32("cOyvhdrMKW",10) == 859114718) strcat(s, "g");
if (crc32("qaJNKegN",8) == 899311716) strcat(s, "r");
if (crc32("BkxlUw",6) == 4217092897) strcat(s, "a");
if (crc32("eHidaC",6) == 2375802059) strcat(s, "u");
if (crc32("RZwCjV",6) == 453575525) strcat(s, "d");
if (crc32("fGgVsES",7) == 2348288593) strcat(s, "d");
if (crc32("lNKpOcirUtBik",13) == 4044884117) strcat(s, "C");
if (crc32("hwRItvGi",8) == 1680947729) strcat(s, "i");
if (crc32("MjKPAISEMzEwxw",14) == 815782801) strcat(s, "n");
if (crc32("wqoUKcYYpA",10) == 2327629353) strcat(s, "r");
if (crc32("KQxUNjX",7) == 2842004240) strcat(s, "g");
    return s;
}

char *pretelling_verbs() {
    char *s = calloc(11);
    if (crc32("IXRqq",5) == 3815119275) strcat(s, "p");
if (crc32("NXwAt",5) == 3236725708) strcat(s, "r");
if (crc32("utJpvGttuhf",11) == 3533263822) strcat(s, "e");
if (crc32("ISUbMprmto",10) == 1957559332) strcat(s, "u");
if (crc32("hAltXoRyImW",11) == 2244889029) strcat(s, "t");
if (crc32("fiqiD",5) == 113482361) strcat(s, "e");
if (crc32("DpJde",5) == 1093311082) strcat(s, "l");
if (crc32("WqLrQfqRZe",10) == 1254650080) strcat(s, "l");
if (crc32("jwujqfuxLWiHW",13) == 3417802149) strcat(s, "i");
if (crc32("JBGpnUhLQAVlwKD",15) == 2994957822) strcat(s, "C");
if (crc32("RALYb",5) == 370984483) strcat(s, "n");
if (crc32("GxNnUVKGUyfta",13) == 69076188) strcat(s, "T");
if (crc32("TqHDOlrmW",9) == 2467957790) strcat(s, "g");
    return s;
}

char *carbonated_verbs() {
    char *s = calloc(11);
    if (crc32("fqJvV",5) == 2243137710) strcat(s, "c");
if (crc32("meWPlb",6) == 939036944) strcat(s, "A");
if (crc32("WJnYamWkFPCKa",13) == 630679161) strcat(s, "a");
if (crc32("FTXMh",5) == 4009787856) strcat(s, "Y");
if (crc32("LROYjBV",7) == 908095887) strcat(s, "r");
if (crc32("TJAVDHExfFygL",13) == 3189400709) strcat(s, "M");
if (crc32("LOxoicZFzzMoVk",14) == 1877896145) strcat(s, "b");
if (crc32("FSxvQqQ",7) == 4033731704) strcat(s, "o");
if (crc32("czLSB",5) == 1133250231) strcat(s, "L");
if (crc32("DndbbWXlEmVJ",12) == 3188013311) strcat(s, "n");
if (crc32("NOhSosQvfqRgn",13) == 2237359616) strcat(s, "t");
if (crc32("oJtzesceoAihkCx",15) == 897658423) strcat(s, "a");
if (crc32("knaEZJVIpgxE",12) == 689910155) strcat(s, "O");
if (crc32("akbIghKdKm",10) == 3744644008) strcat(s, "t");
if (crc32("xAEttozSDXQQ",12) == 3530697912) strcat(s, "e");
if (crc32("qCpFijIQUWbdW",13) == 3675391338) strcat(s, "K");
if (crc32("vQnOdGbdtqUHT",13) == 2469602362) strcat(s, "d");
    return s;
}

char *spae_verbs() {
    char *s = calloc(5);
    if (crc32("qoeYhtto",8) == 774413923) strcat(s, "s");
if (crc32("WHSDtXFbVbQ",11) == 3432470845) strcat(s, "p");
if (crc32("VswlWJCHDuych",13) == 1988126509) strcat(s, "a");
if (crc32("WtpNhXSNbcSjY",13) == 2775974801) strcat(s, "X");
if (crc32("dxJdiLrdhuhziC",14) == 859266467) strcat(s, "e");
    return s;
}

char *seen_verbs() {
    char *s = calloc(5);
    if (crc32("vGOkGtj",7) == 2783711440) strcat(s, "s");
if (crc32("kZvoiBQb",8) == 3681944300) strcat(s, "c");
if (crc32("wdKSxOoAQo",10) == 3241696228) strcat(s, "e");
if (crc32("WOfpPDhRuk",10) == 4227507881) strcat(s, "e");
if (crc32("zQDfzybIhAo",11) == 1900883197) strcat(s, "Y");
if (crc32("hrQIRR",6) == 3613740733) strcat(s, "n");
    return s;
}

char *nucleated_verbs() {
    char *s = calloc(10);
    if (crc32("HQWYSCkj",8) == 765245978) strcat(s, "l");
if (crc32("awhpQmmLq",9) == 1325516534) strcat(s, "n");
if (crc32("MsLSxsUOrFdiX",13) == 1829438909) strcat(s, "u");
if (crc32("vJElnvqvFsOt",12) == 365875943) strcat(s, "c");
if (crc32("bpjYkEYpfsvE",12) == 660754405) strcat(s, "c");
if (crc32("nvaOwHwhsYDVvP",14) == 1086118007) strcat(s, "Y");
if (crc32("XJCMSkHBUnS",11) == 1058985899) strcat(s, "l");
if (crc32("zIlzmyh",7) == 917795998) strcat(s, "U");
if (crc32("tBJsHuddnVJpxgN",15) == 2684319579) strcat(s, "e");
if (crc32("jmmuPRPE",8) == 545895755) strcat(s, "T");
if (crc32("StfOHppKqHfsa",13) == 3819620399) strcat(s, "a");
if (crc32("GWRvJuiEJMljyk",14) == 3008852113) strcat(s, "t");
if (crc32("uXiqjfHJ",8) == 870493572) strcat(s, "Q");
if (crc32("dXzYnipgWpLyffo",15) == 3958633436) strcat(s, "e");
if (crc32("HgEvuzHwgL",10) == 4023474442) strcat(s, "C");
if (crc32("pqkiav",6) == 284388191) strcat(s, "d");
    return s;
}

char *nidify_verbs() {
    char *s = calloc(7);
    if (crc32("cxtQo",5) == 423499277) strcat(s, "U");
if (crc32("BhGrBigElbdaVLC",15) == 3307664630) strcat(s, "n");
if (crc32("MWsMJlDCpsQg",12) == 2215648817) strcat(s, "i");
if (crc32("uhtDjhVySsFN",12) == 2066108025) strcat(s, "x");
if (crc32("kjsesaN",7) == 3020789259) strcat(s, "d");
if (crc32("uvOUBrOzuNony",13) == 2758531170) strcat(s, "i");
if (crc32("EFPdvqNgMKdqG",13) == 4027449976) strcat(s, "O");
if (crc32("GKZBAqgSTMSv",12) == 1168307286) strcat(s, "f");
if (crc32("QEExyFtd",8) == 520503785) strcat(s, "y");
    return s;
}

char *diffusing_verbs() {
    char *s = calloc(10);
    if (crc32("zSuwbZez",8) == 1534070911) strcat(s, "m");
if (crc32("HSmvZYHOi",9) == 2521842529) strcat(s, "d");
if (crc32("FuQOn",5) == 1602615002) strcat(s, "w");
if (crc32("INilrB",6) == 4235111722) strcat(s, "i");
if (crc32("XPOBwyXy",8) == 3933911043) strcat(s, "f");
if (crc32("rVhHa",5) == 4018608791) strcat(s, "f");
if (crc32("ECuSmdyFs",9) == 12409423) strcat(s, "u");
if (crc32("LuVwEPvTZkzqY",13) == 2759908692) strcat(s, "o");
if (crc32("AgRxiKyltCSJWnU",15) == 61423076) strcat(s, "s");
if (crc32("uKdhRZiK",8) == 2829530215) strcat(s, "i");
if (crc32("obtvlhzgRyr",11) == 1496865918) strcat(s, "w");
if (crc32("jPvvNTCzqra",11) == 1662760233) strcat(s, "n");
if (crc32("gaVQaUQlRe",10) == 1336341021) strcat(s, "K");
if (crc32("GZcKgKGuXzXK",12) == 3101059036) strcat(s, "g");
    return s;
}

char *subbed_verbs() {
    char *s = calloc(7);
    if (crc32("SeHkNE",6) == 409247808) strcat(s, "s");
if (crc32("ilnEXqveVbt",11) == 3164991224) strcat(s, "u");
if (crc32("FhbPhkgDw",9) == 178356131) strcat(s, "b");
if (crc32("GFqqFkKe",8) == 2647409138) strcat(s, "x");
if (crc32("qEEQkuePveqALe",14) == 1879201292) strcat(s, "b");
if (crc32("DTwkbxZRTmS",11) == 97631913) strcat(s, "e");
if (crc32("MyotTIzlyGoX",12) == 3479597731) strcat(s, "d");
    return s;
}

char *telescoping_verbs() {
    char *s = calloc(12);
    if (crc32("fyUXff",6) == 2460436366) strcat(s, "t");
if (crc32("lnIgNDoIGjumdIt",15) == 3193646130) strcat(s, "e");
if (crc32("BcTzvnMvda",10) == 3996234795) strcat(s, "t");
if (crc32("ePkbk",5) == 2513737142) strcat(s, "l");
if (crc32("JDbDtTjI",8) == 2827490314) strcat(s, "j");
if (crc32("TxhaomRdiCux",12) == 2136726823) strcat(s, "e");
if (crc32("adEqsvcBcnQ",11) == 31749375) strcat(s, "E");
if (crc32("arohBvwxQZ",10) == 41850820) strcat(s, "s");
if (crc32("iSinJA",6) == 4003512832) strcat(s, "c");
if (crc32("nLntBtpy",8) == 2034743964) strcat(s, "o");
if (crc32("KAPyHDNNgUf",11) == 3871948451) strcat(s, "b");
if (crc32("BOElQ",5) == 2215886525) strcat(s, "p");
if (crc32("BMoRO",5) == 2669529802) strcat(s, "G");
if (crc32("UEodhEn",7) == 2113040382) strcat(s, "i");
if (crc32("hknjLVgybGt",11) == 3125222486) strcat(s, "n");
if (crc32("IHhDfgVXPzDJQrD",15) == 2744044489) strcat(s, "g");
    return s;
}

char *rebaptize_verbs() {
    char *s = calloc(10);
    if (crc32("kfFlWZNxgMR",11) == 1989944154) strcat(s, "Q");
if (crc32("JnXwGTGUCm",10) == 177372636) strcat(s, "r");
if (crc32("OLFSGiCdxGzb",12) == 2978491856) strcat(s, "g");
if (crc32("FbHOOQOZmWL",11) == 3565332372) strcat(s, "e");
if (crc32("RCrcRuOrR",9) == 363866610) strcat(s, "b");
if (crc32("vjSEkuHixRJK",12) == 2855060642) strcat(s, "a");
if (crc32("FjVcZPuDGRbtrbw",15) == 126878809) strcat(s, "y");
if (crc32("hrvGRPoNaGfQ",12) == 1095912561) strcat(s, "p");
if (crc32("PfihNLnVthy",11) == 891752598) strcat(s, "y");
if (crc32("PqrILohU",8) == 1300123278) strcat(s, "t");
if (crc32("gpcYie",6) == 1762014920) strcat(s, "M");
if (crc32("UTBHDNLauFuYv",13) == 3622303038) strcat(s, "i");
if (crc32("MDhZyAyABf",10) == 232991055) strcat(s, "M");
if (crc32("GbKzIuRBkd",10) == 373240290) strcat(s, "z");
if (crc32("lRBbgWLIRVmxr",13) == 2279798600) strcat(s, "e");
if (crc32("WnGQHWhIXUu",11) == 2054073310) strcat(s, "e");
    return s;
}

char *counterpoised_verbs() {
    char *s = calloc(14);
    if (crc32("HkXQHN",6) == 1527275190) strcat(s, "U");
if (crc32("iNTLSMqDf",9) == 4142173645) strcat(s, "c");
if (crc32("NwSZibbLAdwaT",13) == 3247684055) strcat(s, "o");
if (crc32("xHhEOVcMueDJVR",14) == 2042726176) strcat(s, "u");
if (crc32("mAXUD",5) == 1358571561) strcat(s, "n");
if (crc32("pxtSRI",6) == 2725827514) strcat(s, "Z");
if (crc32("ZBSQsuKhcBJ",11) == 4035149114) strcat(s, "t");
if (crc32("EnTxMQkwms",10) == 2383611602) strcat(s, "k");
if (crc32("YwwEcmiCADSM",12) == 3303270051) strcat(s, "e");
if (crc32("HNFMYQjVYIZh",12) == 1853427797) strcat(s, "r");
if (crc32("QgEyFQs",7) == 1829197386) strcat(s, "J");
if (crc32("BsAzg",5) == 3938808118) strcat(s, "p");
if (crc32("APftMlBjmWVZBEu",15) == 1539069849) strcat(s, "o");
if (crc32("GtAIEKdsYM",10) == 4149644101) strcat(s, "i");
if (crc32("RjMYYgTivdLgV",13) == 894950364) strcat(s, "z");
if (crc32("caTISnbAFFOZoY",14) == 2316701996) strcat(s, "s");
if (crc32("LzbjAToa",8) == 12740023) strcat(s, "r");
if (crc32("MklDE",5) == 1493702333) strcat(s, "e");
if (crc32("EGCWZndxFCD",11) == 2710713493) strcat(s, "d");
    return s;
}

char *cyclized_verbs() {
    char *s = calloc(9);
    if (crc32("FxaKqBy",7) == 134235561) strcat(s, "n");
if (crc32("CcmOexVtbytOlx",14) == 3795792206) strcat(s, "c");
if (crc32("BgXdcloiQ",9) == 3179798600) strcat(s, "M");
if (crc32("wwVTWi",6) == 2823840888) strcat(s, "y");
if (crc32("KrSNoExTod",10) == 2418881523) strcat(s, "c");
if (crc32("LnGIU",5) == 3797949152) strcat(s, "A");
if (crc32("FAGanYJXXOZpyU",14) == 1258390882) strcat(s, "l");
if (crc32("ztWJtKlJbXW",11) == 1059802148) strcat(s, "i");
if (crc32("QzsRF",5) == 2253806820) strcat(s, "z");
if (crc32("NLIvrv",6) == 194819039) strcat(s, "e");
if (crc32("yrqCrAO",7) == 3071362715) strcat(s, "d");
    return s;
}

char *revive_verbs() {
    char *s = calloc(7);
    if (crc32("aoKsBDjLkrZAsr",14) == 2595907381) strcat(s, "r");
if (crc32("iTamGcuphZmV",12) == 1670988669) strcat(s, "e");
if (crc32("RxRTIm",6) == 556731325) strcat(s, "v");
if (crc32("FHwnq",5) == 3270726512) strcat(s, "i");
if (crc32("AIlaCqzpuAzwkK",14) == 2149854188) strcat(s, "A");
if (crc32("HaPYFGdJierexk",14) == 515783540) strcat(s, "v");
if (crc32("OWTmIq",6) == 3341189025) strcat(s, "e");
    return s;
}

char *detoxify_verbs() {
    char *s = calloc(9);
    if (crc32("YACzXWfX",8) == 1877713300) strcat(s, "y");
if (crc32("CIUNjjhCeSEK",12) == 1130079594) strcat(s, "d");
if (crc32("ljdmwYtfdPwHRN",14) == 3201350110) strcat(s, "c");
if (crc32("rUXvyetkGpecZ",13) == 4239333023) strcat(s, "e");
if (crc32("RztpQukkU",9) == 2655936805) strcat(s, "E");
if (crc32("JgzSzZuQCGfB",12) == 3245519620) strcat(s, "t");
if (crc32("BIREcCthTqAf",12) == 2807223239) strcat(s, "j");
if (crc32("nOxDDVCeVLGWLn",14) == 2121271736) strcat(s, "o");
if (crc32("vkWCGOo",7) == 2890700216) strcat(s, "x");
if (crc32("LQZPYCkvjywAiUG",15) == 2452741617) strcat(s, "F");
if (crc32("LHrRdCDaaq",10) == 3536345808) strcat(s, "i");
if (crc32("coTVHVuQKTMZGVL",15) == 273855674) strcat(s, "b");
if (crc32("AhdLXpFHFocWkhC",15) == 3555881206) strcat(s, "f");
if (crc32("hpAGNkXqyxxIQT",14) == 3910027498) strcat(s, "y");
    return s;
}

char *sabotaging_verbs() {
    char *s = calloc(11);
    if (crc32("ENVztxSXSBvVk",13) == 3575888543) strcat(s, "m");
if (crc32("OEmrUfyWv",9) == 3554029887) strcat(s, "s");
if (crc32("AEiYuLYgXTcVzO",14) == 1749481610) strcat(s, "a");
if (crc32("WSnofOFjHWq",11) == 3430580616) strcat(s, "b");
if (crc32("JgJnaPPZI",9) == 994482047) strcat(s, "n");
if (crc32("DWjjhNOnNI",10) == 4020572714) strcat(s, "o");
if (crc32("MwlBpr",6) == 3660381245) strcat(s, "t");
if (crc32("BewOPMn",7) == 2842411487) strcat(s, "P");
if (crc32("kwEzKmYZXtQTc",13) == 2008357705) strcat(s, "a");
if (crc32("RdFIURlhCDqL",12) == 1653163183) strcat(s, "g");
if (crc32("qXFQEUygoyjCpH",14) == 3524570151) strcat(s, "j");
if (crc32("rbtJrvnE",8) == 2030867636) strcat(s, "i");
if (crc32("JPkoqccr",8) == 2275400697) strcat(s, "F");
if (crc32("ztTMiWmpFzaFNky",15) == 285892051) strcat(s, "n");
if (crc32("PPoampMDaaoiaQc",15) == 2250066943) strcat(s, "g");
    return s;
}

char *hoeing_verbs() {
    char *s = calloc(7);
    if (crc32("VyuixIKCZ",9) == 1279261765) strcat(s, "E");
if (crc32("koWuusVC",8) == 3162924071) strcat(s, "h");
if (crc32("sFpEpkVoudPjbzW",15) == 2653598855) strcat(s, "o");
if (crc32("ZQUTUyVdHD",10) == 1274198740) strcat(s, "d");
if (crc32("jkOgdwmUJIenCH",14) == 1031584915) strcat(s, "e");
if (crc32("IhWWj",5) == 1547528489) strcat(s, "i");
if (crc32("WpmGfXTtx",9) == 3265648704) strcat(s, "n");
if (crc32("eTznLCgTyOTK",12) == 1566303526) strcat(s, "X");
if (crc32("QEaibAG",7) == 4021220847) strcat(s, "g");
    return s;
}

char *rove_verbs() {
    char *s = calloc(5);
    if (crc32("nbkAHtRg",8) == 3989423423) strcat(s, "r");
if (crc32("UjhVQYBtxwmSOR",14) == 4209191291) strcat(s, "o");
if (crc32("uhjvjwvIJFtmCe",14) == 2736387754) strcat(s, "t");
if (crc32("AJZxcZpErKKAagG",15) == 1239557192) strcat(s, "v");
if (crc32("waJTHpRiZo",10) == 1916987054) strcat(s, "e");
    return s;
}

char *supplicated_verbs() {
    char *s = calloc(12);
    if (crc32("ZofFqhJMxqpdii",14) == 17086027) strcat(s, "V");
if (crc32("HOvOOjyqISaDkmK",15) == 3164050309) strcat(s, "s");
if (crc32("eWyPELmiDkfklOb",15) == 420808628) strcat(s, "u");
if (crc32("kJUAQQftonqcg",13) == 3361038119) strcat(s, "p");
if (crc32("xrKnaQAtaZ",10) == 1620311894) strcat(s, "K");
if (crc32("HATxnybrnsMYcC",14) == 3847316678) strcat(s, "p");
if (crc32("NWxiCPebm",9) == 2706163210) strcat(s, "l");
if (crc32("ZCdnpwaP",8) == 1280052920) strcat(s, "i");
if (crc32("hxHGUyQNK",9) == 535866692) strcat(s, "c");
if (crc32("towfsqnOoXKAwQ",14) == 3650709963) strcat(s, "h");
if (crc32("TuoxBmAHJbrRWNk",15) == 3047904387) strcat(s, "a");
if (crc32("DCbGwuTGT",9) == 1669939841) strcat(s, "t");
if (crc32("qXZoRAjMtJzPTxN",15) == 3975582368) strcat(s, "e");
if (crc32("efxoBY",6) == 3262217502) strcat(s, "d");
    return s;
}

char *embody_verbs() {
    char *s = calloc(7);
    if (crc32("YJuHMIwHwjGakm",14) == 4163572365) strcat(s, "e");
if (crc32("nNiIzCehFhwM",12) == 3572464594) strcat(s, "Q");
if (crc32("DcpappaHiIaOtaR",15) == 751279754) strcat(s, "m");
if (crc32("AAlgi",5) == 3741757284) strcat(s, "b");
if (crc32("hUhwORLyz",9) == 3303197572) strcat(s, "K");
if (crc32("xBmkZULrTtmLQ",13) == 2533754601) strcat(s, "o");
if (crc32("qAxNjxMUtF",10) == 1197377119) strcat(s, "N");
if (crc32("zAdjwyvHqx",10) == 179174095) strcat(s, "d");
if (crc32("HcTybo",6) == 433232633) strcat(s, "y");
    return s;
}

char *opaquing_verbs() {
    char *s = calloc(9);
    if (crc32("uqAvZolTjL",10) == 855072018) strcat(s, "o");
if (crc32("uLOhgBCEc",9) == 1166888673) strcat(s, "p");
if (crc32("EMkbvpUIjjQkn",13) == 399139665) strcat(s, "a");
if (crc32("mrCDrRtEj",9) == 2443697141) strcat(s, "J");
if (crc32("kPIzN",5) == 3627218247) strcat(s, "q");
if (crc32("idrWPubKuCx",11) == 432631152) strcat(s, "u");
if (crc32("uOSDTlAQvEv",11) == 3083977412) strcat(s, "i");
if (crc32("PZIGkfJNiorfMbL",15) == 537049638) strcat(s, "n");
if (crc32("TvqTFa",6) == 3273294341) strcat(s, "G");
if (crc32("HFWOVLvo",8) == 1076312006) strcat(s, "g");
    return s;
}

char *hydrogenize_verbs() {
    char *s = calloc(12);
    if (crc32("WpPFqaXtW",9) == 3931416360) strcat(s, "h");
if (crc32("nsigBnyIv",9) == 1637815996) strcat(s, "h");
if (crc32("BvAQO",5) == 1077474501) strcat(s, "N");
if (crc32("DZKXtJ",6) == 2756217595) strcat(s, "y");
if (crc32("gKBUm",5) == 653553190) strcat(s, "d");
if (crc32("WFYyqCScEE",10) == 3226370504) strcat(s, "E");
if (crc32("jWCujWrUzxdcac",14) == 1239258262) strcat(s, "r");
if (crc32("mnnsdWFqNAdn",12) == 3353521687) strcat(s, "o");
if (crc32("SYSLvz",6) == 2511688466) strcat(s, "Z");
if (crc32("GMDwFUPUJZkC",12) == 3210555761) strcat(s, "g");
if (crc32("plWfxDITGN",10) == 4058401269) strcat(s, "e");
if (crc32("LisLsRPXDwSbh",13) == 1766605802) strcat(s, "a");
if (crc32("iqxIVjECL",9) == 2957247725) strcat(s, "n");
if (crc32("opUnOziOboXwIHU",15) == 3037160595) strcat(s, "v");
if (crc32("JIDOLX",6) == 472805065) strcat(s, "i");
if (crc32("yFztrnrG",8) == 566443075) strcat(s, "z");
if (crc32("bnosoJ",6) == 1654499215) strcat(s, "T");
if (crc32("yCmTPzKXK",9) == 3008848316) strcat(s, "e");
    return s;
}

char *wedging_verbs() {
    char *s = calloc(8);
    if (crc32("IvEPoWOVYwAJjwR",15) == 2124672840) strcat(s, "w");
if (crc32("pYXcAgPFPQiXiR",14) == 1630261661) strcat(s, "e");
if (crc32("FdNyzepPAxzy",12) == 3399024924) strcat(s, "d");
if (crc32("qHxVKCEGqx",10) == 1808935842) strcat(s, "g");
if (crc32("vJOwEBiTGRdZsN",14) == 1366598646) strcat(s, "i");
if (crc32("kTVfDL",6) == 1461802855) strcat(s, "n");
if (crc32("WMQixnwRKcutfW",14) == 4106733498) strcat(s, "g");
    return s;
}

char *omit_verbs() {
    char *s = calloc(5);
    if (crc32("ctuAVsGsJeZ",11) == 2999133961) strcat(s, "o");
if (crc32("UHLukvCeVOQqyt",14) == 4090536376) strcat(s, "z");
if (crc32("GLumL",5) == 3155499) strcat(s, "m");
if (crc32("bKrdpTpCuaIVs",13) == 4060967059) strcat(s, "i");
if (crc32("NrMEqmUubCZcrqF",15) == 1304530622) strcat(s, "a");
if (crc32("KMXELrhqJGhJk",13) == 1834234274) strcat(s, "t");
    return s;
}

char *sailplaning_verbs() {
    char *s = calloc(12);
    if (crc32("zEBfZHxZ",8) == 2885835215) strcat(s, "s");
if (crc32("esxghSVxor",10) == 1597019870) strcat(s, "a");
if (crc32("mDdhINvAAqFtJ",13) == 3388094181) strcat(s, "R");
if (crc32("HipKGjmtfNdGrqY",15) == 1930196049) strcat(s, "i");
if (crc32("VpTVRRcmnRHh",12) == 939623848) strcat(s, "e");
if (crc32("dxLOKo",6) == 2407628958) strcat(s, "l");
if (crc32("pqIaVVcUcPMRV",13) == 2817137046) strcat(s, "u");
if (crc32("HANlTLahGmWqHJe",15) == 1164055576) strcat(s, "p");
if (crc32("NuHWGRvJnry",11) == 4047039970) strcat(s, "l");
if (crc32("yIZFoXaxPby",11) == 3072938988) strcat(s, "F");
if (crc32("DfQDJNPfJpGGC",13) == 1306083078) strcat(s, "a");
if (crc32("CSCwHMJoOX",10) == 1853025204) strcat(s, "L");
if (crc32("UHkVEpCGNIJlO",13) == 3864258390) strcat(s, "n");
if (crc32("tnNipxsN",8) == 2473252429) strcat(s, "i");
if (crc32("MVYMxJwETG",10) == 1497787001) strcat(s, "Y");
if (crc32("YihsVo",6) == 2544394846) strcat(s, "n");
if (crc32("GmqjQ",5) == 871414962) strcat(s, "g");
    return s;
}

char *economized_verbs() {
    char *s = calloc(11);
    if (crc32("ikPImNLKEew",11) == 2198234749) strcat(s, "e");
if (crc32("HkvpCYeHvZTK",12) == 83398770) strcat(s, "c");
if (crc32("qnAoCXOTCy",10) == 4030750065) strcat(s, "C");
if (crc32("SAFxpOFblp",10) == 4124416062) strcat(s, "o");
if (crc32("IdTXyQYTus",10) == 777396059) strcat(s, "n");
if (crc32("lDexxK",6) == 2083930582) strcat(s, "E");
if (crc32("DJUjcpe",7) == 2146789786) strcat(s, "o");
if (crc32("fZocqvIGniYCXk",14) == 3804909228) strcat(s, "m");
if (crc32("KKMiAgUA",8) == 156402559) strcat(s, "n");
if (crc32("aUUYjzgn",8) == 3968190076) strcat(s, "i");
if (crc32("nZlNampSRsyE",12) == 2959447016) strcat(s, "z");
if (crc32("MmDsPtZLUBSgc",13) == 3433275859) strcat(s, "e");
if (crc32("LeTsp",5) == 250852914) strcat(s, "S");
if (crc32("cPBmkzkJbLsBKm",14) == 3166761196) strcat(s, "d");
    return s;
}

char *overprovoking_verbs() {
    char *s = calloc(14);
    if (crc32("KGLsTydAJgFup",13) == 894642711) strcat(s, "o");
if (crc32("lTCOaezpt",9) == 851690036) strcat(s, "F");
if (crc32("YcpNrMkkLa",10) == 1398067735) strcat(s, "v");
if (crc32("VfXoKJqvKF",10) == 3141158234) strcat(s, "k");
if (crc32("TBgNHf",6) == 1147833979) strcat(s, "e");
if (crc32("HwWWUwIOpiQjf",13) == 3941168779) strcat(s, "r");
if (crc32("QXarb",5) == 3679581199) strcat(s, "b");
if (crc32("cKQavttCZiRaN",13) == 4141253829) strcat(s, "p");
if (crc32("BGCiWIlvHnX",11) == 2186509521) strcat(s, "F");
if (crc32("KBNidDKXf",9) == 939619237) strcat(s, "r");
if (crc32("gTssKYUcSfFav",13) == 2053794008) strcat(s, "p");
if (crc32("dbXOdNajk",9) == 2153912512) strcat(s, "o");
if (crc32("TpaZQmMLKA",10) == 2632638575) strcat(s, "v");
if (crc32("GQNfWdpDG",9) == 1717368959) strcat(s, "F");
if (crc32("QfKhkCHrFzH",11) == 563041029) strcat(s, "o");
if (crc32("UtkUOCIhoJ",10) == 3935222394) strcat(s, "m");
if (crc32("BdokhLXg",8) == 1082458419) strcat(s, "k");
if (crc32("OquCZwQNBP",10) == 3744830435) strcat(s, "y");
if (crc32("OjcFcUUkDWsC",12) == 392926908) strcat(s, "i");
if (crc32("uRoCCKGd",8) == 2274188876) strcat(s, "j");
if (crc32("UPxTyzPKX",9) == 699634690) strcat(s, "n");
if (crc32("izdRJHzbztnHe",13) == 1392919138) strcat(s, "J");
if (crc32("DPbaR",5) == 311194438) strcat(s, "g");
    return s;
}

char *girdling_verbs() {
    char *s = calloc(9);
    if (crc32("wIRNZvbHJuvwJX",14) == 401048596) strcat(s, "g");
if (crc32("jjFMBarnY",9) == 726367094) strcat(s, "I");
if (crc32("rSvFJIYdpegB",12) == 3180855237) strcat(s, "i");
if (crc32("zfoUFbkFMsEhBJn",15) == 2156281914) strcat(s, "r");
if (crc32("saMivobgYbCYgE",14) == 3924891410) strcat(s, "v");
if (crc32("LDdANqN",7) == 407953974) strcat(s, "d");
if (crc32("OmNtyZVf",8) == 2043835857) strcat(s, "l");
if (crc32("wQrdlk",6) == 1658019335) strcat(s, "y");
if (crc32("bIfhhKukJYsK",12) == 2871794673) strcat(s, "i");
if (crc32("QagggGq",7) == 2200420520) strcat(s, "n");
if (crc32("ttPNtkkqlzpMUcu",15) == 3541285629) strcat(s, "g");
    return s;
}

char *stuff_verbs() {
    char *s = calloc(6);
    if (crc32("soLSMPWw",8) == 3782577613) strcat(s, "f");
if (crc32("SskWZGS",7) == 2528006294) strcat(s, "s");
if (crc32("qNXGbBbjVmtr",12) == 3705747371) strcat(s, "t");
if (crc32("UTPKOKucCEpW",12) == 3837082419) strcat(s, "u");
if (crc32("MswChpXQfOnxJUk",15) == 4198657626) strcat(s, "x");
if (crc32("etXhikMtDlHCx",13) == 3557274207) strcat(s, "f");
if (crc32("HpYIKPB",7) == 2447863186) strcat(s, "p");
if (crc32("rKVbx",5) == 1744910759) strcat(s, "f");
    return s;
}

char *backsliding_verbs() {
    char *s = calloc(12);
    if (crc32("nVCAiA",6) == 2037531694) strcat(s, "b");
if (crc32("WAYioiJEECbhAS",14) == 3960897235) strcat(s, "w");
if (crc32("TpMqYpSMYKASLU",14) == 2170736263) strcat(s, "a");
if (crc32("tumKBI",6) == 1754208391) strcat(s, "c");
if (crc32("zSzvZTxEmt",10) == 3295759824) strcat(s, "k");
if (crc32("IfHgOZ",6) == 98455271) strcat(s, "y");
if (crc32("xxRBMAAcZb",10) == 3581725692) strcat(s, "s");
if (crc32("TgFTPYA",7) == 3401949583) strcat(s, "l");
if (crc32("fkfbCOwI",8) == 4206589972) strcat(s, "J");
if (crc32("DFvfhvdCt",9) == 4284779850) strcat(s, "i");
if (crc32("MMYAhQghnFQO",12) == 2485093738) strcat(s, "d");
if (crc32("jYtRhfABTYuCFt",14) == 2689600705) strcat(s, "i");
if (crc32("xLMrIMYGQjBp",12) == 2295386126) strcat(s, "p");
if (crc32("jkLfHuFGzlAYsuJ",15) == 1428876224) strcat(s, "n");
if (crc32("XpSIHDJ",7) == 1666066740) strcat(s, "g");
    return s;
}

char *unravelling_verbs() {
    char *s = calloc(12);
    if (crc32("EyqdvFZT",8) == 2155427348) strcat(s, "n");
if (crc32("wFWUzDilotORmJ",14) == 4231643867) strcat(s, "u");
if (crc32("UvwERgDTKqcZ",12) == 2500481310) strcat(s, "n");
if (crc32("UjkgteND",8) == 2869542054) strcat(s, "r");
if (crc32("VzaTmlfyDFXgqN",14) == 2741540704) strcat(s, "a");
if (crc32("liOpLWDeek",10) == 3663620974) strcat(s, "L");
if (crc32("qaPKPDuiJrw",11) == 47074650) strcat(s, "v");
if (crc32("xEFBuXFTBofXRuz",15) == 4230203333) strcat(s, "e");
if (crc32("xKWAC",5) == 2243518790) strcat(s, "S");
if (crc32("BLxEKY",6) == 3081832266) strcat(s, "l");
if (crc32("LWVzQtgd",8) == 3573365788) strcat(s, "l");
if (crc32("pDHzqK",6) == 3346997008) strcat(s, "i");
if (crc32("DNbJZIQbxPjKrY",14) == 2673993094) strcat(s, "n");
if (crc32("RxNzQwLjwgIjODp",15) == 4274662838) strcat(s, "b");
if (crc32("DMgVWegHWqNmYl",14) == 2662917213) strcat(s, "g");
    return s;
}

char *preconform_verbs() {
    char *s = calloc(11);
    if (crc32("fTWfEd",6) == 2142091879) strcat(s, "p");
if (crc32("tGaBcGrQnfFrihb",15) == 357799929) strcat(s, "N");
if (crc32("Zlezj",5) == 4091181117) strcat(s, "r");
if (crc32("vwzeqD",6) == 376699509) strcat(s, "j");
if (crc32("HElDlKXcLrHQGN",14) == 96192203) strcat(s, "e");
if (crc32("jBDnqiOpKWuWYU",14) == 2308574292) strcat(s, "t");
if (crc32("ipVlwoWdFMESpaq",15) == 3926125792) strcat(s, "c");
if (crc32("XimznjDAMrhJ",12) == 1933811542) strcat(s, "I");
if (crc32("kmspkaAxYzKmtyC",15) == 277723961) strcat(s, "o");
if (crc32("QDPYBxztFKoA",12) == 4003830750) strcat(s, "n");
if (crc32("nbXWcij",7) == 2849503566) strcat(s, "k");
if (crc32("cUmMyBqBpf",10) == 2864711171) strcat(s, "f");
if (crc32("nTgCqYNO",8) == 168174698) strcat(s, "c");
if (crc32("MPwIsPIJSdq",11) == 1433545558) strcat(s, "o");
if (crc32("YWZIqAyIxWjRGd",14) == 1186899850) strcat(s, "r");
if (crc32("bsVkEnBssnwPLi",14) == 416123982) strcat(s, "m");
    return s;
}

char *vitriolling_verbs() {
    char *s = calloc(12);
    if (crc32("TEpceALL",8) == 1094065017) strcat(s, "v");
if (crc32("zePDHunz",8) == 1744159599) strcat(s, "v");
if (crc32("WjYuMZDXx",9) == 55561220) strcat(s, "i");
if (crc32("fKtkfmdLRQnKOZs",15) == 4288231818) strcat(s, "m");
if (crc32("wHzEHXMBYLV",11) == 2397923383) strcat(s, "t");
if (crc32("ovTvNiepnWYPNAB",15) == 4250673004) strcat(s, "r");
if (crc32("pzCEzAAvwklbp",13) == 1011829605) strcat(s, "d");
if (crc32("AEosoigRTfvpm",13) == 3309964670) strcat(s, "i");
if (crc32("QaPHaumCG",9) == 3203762127) strcat(s, "k");
if (crc32("ZgOiOWHEHXhkub",14) == 187481358) strcat(s, "o");
if (crc32("yPEEW",5) == 3144817271) strcat(s, "e");
if (crc32("IKjqGQGFT",9) == 702920755) strcat(s, "l");
if (crc32("kPqjDRsTW",9) == 1064418332) strcat(s, "l");
if (crc32("pVBnltSYwvW",11) == 3698160799) strcat(s, "i");
if (crc32("axvBmaW",7) == 2957279767) strcat(s, "r");
if (crc32("jODUdCyx",8) == 2496333367) strcat(s, "n");
if (crc32("GUByukNunJYorBT",15) == 1396139902) strcat(s, "x");
if (crc32("BjGtCFOK",8) == 1409988858) strcat(s, "g");
    return s;
}

char *berrying_verbs() {
    char *s = calloc(9);
    if (crc32("tTomQbDBKMO",11) == 1350930924) strcat(s, "S");
if (crc32("DBjJv",5) == 2902238290) strcat(s, "b");
if (crc32("ldjznAwkFUD",11) == 1739253821) strcat(s, "e");
if (crc32("rPhQUREpHf",10) == 2668814712) strcat(s, "r");
if (crc32("ibVbr",5) == 4231503618) strcat(s, "t");
if (crc32("RoVzp",5) == 173031073) strcat(s, "r");
if (crc32("VGLSFhY",7) == 3282198587) strcat(s, "H");
if (crc32("fNdKOXuxjwVD",12) == 1458590394) strcat(s, "y");
if (crc32("CweQuYjiebG",11) == 4271842677) strcat(s, "M");
if (crc32("TciWAnosBmZmaW",14) == 3350030969) strcat(s, "i");
if (crc32("DSmxd",5) == 1608492820) strcat(s, "n");
if (crc32("gSxfKg",6) == 4178212494) strcat(s, "g");
    return s;
}

char *tingled_verbs() {
    char *s = calloc(8);
    if (crc32("SiCRUiozxuVscil",15) == 1910997623) strcat(s, "Y");
if (crc32("lJkOljPCCQybDEU",15) == 2538645871) strcat(s, "t");
if (crc32("vBPwQGgoX",9) == 4079078655) strcat(s, "n");
if (crc32("UeCEtVQVFY",10) == 2476093675) strcat(s, "i");
if (crc32("kgoNjEjyjtCQg",13) == 3305364908) strcat(s, "Y");
if (crc32("LdlabuPpyHdR",12) == 469415386) strcat(s, "n");
if (crc32("YTESp",5) == 9237202) strcat(s, "g");
if (crc32("ujWKWDACv",9) == 332722264) strcat(s, "l");
if (crc32("OIYBtJ",6) == 2465356963) strcat(s, "F");
if (crc32("HNUjlMURxP",10) == 2323967267) strcat(s, "e");
if (crc32("MQIPsdwjZqbAjY",14) == 3074913569) strcat(s, "d");
    return s;
}

char *pirouetting_verbs() {
    char *s = calloc(12);
    if (crc32("GeMyESnVdUHnytq",15) == 2557491304) strcat(s, "p");
if (crc32("QIlCvzcai",9) == 2188794) strcat(s, "i");
if (crc32("muIdjw",6) == 3425419617) strcat(s, "r");
if (crc32("ZuByW",5) == 2799244287) strcat(s, "f");
if (crc32("CxUITjsF",8) == 2392145860) strcat(s, "o");
if (crc32("OpJeAPrXaFu",11) == 2928719455) strcat(s, "o");
if (crc32("XKtKPtaLcyJSmEB",15) == 429093243) strcat(s, "u");
if (crc32("cnkbcHTDsM",10) == 1356284030) strcat(s, "M");
if (crc32("aPqnhCDqJLBgK",13) == 1532384418) strcat(s, "e");
if (crc32("GFaqLszwri",10) == 3733575989) strcat(s, "t");
if (crc32("JIOqLd",6) == 3400883669) strcat(s, "t");
if (crc32("ltUFNfwCHW",10) == 3585663143) strcat(s, "i");
if (crc32("XnUUrJHQMCdx",12) == 2288199906) strcat(s, "n");
if (crc32("DaYqPUeAFF",10) == 348210597) strcat(s, "x");
if (crc32("AoTFzPktE",9) == 1505251272) strcat(s, "g");
    return s;
}

char *fixate_verbs() {
    char *s = calloc(7);
    if (crc32("ysIfHrqliLGno",13) == 3094167783) strcat(s, "f");
if (crc32("kFlgRrbgE",9) == 1788246595) strcat(s, "i");
if (crc32("zNBlovnNRtFKEVP",15) == 308428572) strcat(s, "x");
if (crc32("WJDQDntrbPLp",12) == 1628217778) strcat(s, "a");
if (crc32("stVNIYOJstW",11) == 4064933927) strcat(s, "t");
if (crc32("akTIKa",6) == 2392117946) strcat(s, "e");
    return s;
}

char *endorsing_verbs() {
    char *s = calloc(10);
    if (crc32("OKbdiMoPGQgNt",13) == 3666651324) strcat(s, "e");
if (crc32("IYWOX",5) == 593886762) strcat(s, "m");
if (crc32("jdiKwHXzKlCz",12) == 3424300323) strcat(s, "n");
if (crc32("rRWKfdcoZl",10) == 1154507112) strcat(s, "p");
if (crc32("WHLHA",5) == 1380603067) strcat(s, "d");
if (crc32("ZfifBBRNYvIOAIU",15) == 1012516780) strcat(s, "f");
if (crc32("OlnxavNcEv",10) == 2625803904) strcat(s, "o");
if (crc32("xfaQWa",6) == 1634394718) strcat(s, "r");
if (crc32("yfaFGXeZJNMnq",13) == 2225603991) strcat(s, "C");
if (crc32("MyRtF",5) == 3416401530) strcat(s, "s");
if (crc32("tLPVgJuIHO",10) == 2668275639) strcat(s, "F");
if (crc32("OQZzmaOSkWlO",12) == 113540292) strcat(s, "i");
if (crc32("AwyDIbGVDxBV",12) == 252587432) strcat(s, "n");
if (crc32("oUcYW",5) == 4118069026) strcat(s, "g");
    return s;
}

char *sieved_verbs() {
    char *s = calloc(7);
    if (crc32("AyyHrt",6) == 2749065195) strcat(s, "s");
if (crc32("mHYzTHqSHwFxwr",14) == 1213543082) strcat(s, "T");
if (crc32("uOPwSXj",7) == 2721448022) strcat(s, "i");
if (crc32("tgrCVn",6) == 2663946325) strcat(s, "Q");
if (crc32("RKEWSyLfMjWkd",13) == 798973727) strcat(s, "e");
if (crc32("mcsUFZpzjr",10) == 1068596089) strcat(s, "N");
if (crc32("STyBfpfcFAwpM",13) == 4239458959) strcat(s, "v");
if (crc32("IZlpxlhPgusab",13) == 3377547247) strcat(s, "e");
if (crc32("bcnjwYeOj",9) == 3932426362) strcat(s, "J");
if (crc32("ZaThvP",6) == 2820692262) strcat(s, "d");
    return s;
}

char *balloting_verbs() {
    char *s = calloc(10);
    if (crc32("RifOzmvyuiFlp",13) == 2209356511) strcat(s, "X");
if (crc32("pPdJJxxU",8) == 959282654) strcat(s, "b");
if (crc32("oQbYxKIyPqEvV",13) == 1948928298) strcat(s, "l");
if (crc32("erVlvgf",7) == 448417737) strcat(s, "a");
if (crc32("FFlVQoiYVRtIItZ",15) == 599341795) strcat(s, "I");
if (crc32("qOMbzcCLzyhs",12) == 818939723) strcat(s, "l");
if (crc32("UuqofNTH",8) == 3744578136) strcat(s, "l");
if (crc32("rqaoPMGnHjVK",12) == 3680149853) strcat(s, "y");
if (crc32("WqiaTsjwLqyozbz",15) == 1599377824) strcat(s, "o");
if (crc32("iMpDMHkhqepc",12) == 2814368365) strcat(s, "F");
if (crc32("njyWchgTWlBkhx",14) == 1371839176) strcat(s, "t");
if (crc32("nphphwMoCOul",12) == 994830602) strcat(s, "z");
if (crc32("urUcVaTd",8) == 1271912766) strcat(s, "i");
if (crc32("lGHhhEqw",8) == 1493543176) strcat(s, "n");
if (crc32("ceYPdge",7) == 819268546) strcat(s, "a");
if (crc32("wtmlCygjR",9) == 2433573891) strcat(s, "g");
    return s;
}

char *choused_verbs() {
    char *s = calloc(8);
    if (crc32("YhdEg",5) == 481667340) strcat(s, "c");
if (crc32("tzxwzESPjnu",11) == 345726951) strcat(s, "h");
if (crc32("QyyTUZYGug",10) == 2762133654) strcat(s, "R");
if (crc32("yzWAcAIaCcudalu",15) == 1214511462) strcat(s, "o");
if (crc32("wScDdPgcZRwIVpq",15) == 2453301786) strcat(s, "k");
if (crc32("xFfPivAuDcnhai",14) == 3237411393) strcat(s, "u");
if (crc32("mdhKwecAAdGTC",13) == 2572155648) strcat(s, "m");
if (crc32("IjEVLbNLtSPnMd",14) == 315628570) strcat(s, "s");
if (crc32("AYcRwfBFZfzJpY",14) == 1961040620) strcat(s, "e");
if (crc32("qyeQT",5) == 911466245) strcat(s, "d");
if (crc32("VlutTeEvjW",10) == 1093062222) strcat(s, "d");
    return s;
}

char *wagging_verbs() {
    char *s = calloc(8);
    if (crc32("cqcjyORuq",9) == 3723214487) strcat(s, "w");
if (crc32("YoeKU",5) == 658390790) strcat(s, "j");
if (crc32("NsmRQxgjdSXyNnk",15) == 1793079508) strcat(s, "a");
if (crc32("GPJHW",5) == 1465808298) strcat(s, "g");
if (crc32("kqtkBrMTxkiKH",13) == 2609293289) strcat(s, "g");
if (crc32("RDjuAHjyAv",10) == 3397116311) strcat(s, "j");
if (crc32("GkQuHOYZkOtvc",13) == 1644594125) strcat(s, "i");
if (crc32("gzeCLbGMY",9) == 1273383930) strcat(s, "Z");
if (crc32("axkUpjocjhuQI",13) == 1124294631) strcat(s, "n");
if (crc32("DsVUFytNfL",10) == 922356632) strcat(s, "V");
if (crc32("HRfeKkMem",9) == 3033539570) strcat(s, "g");
    return s;
}

char *whipsawing_verbs() {
    char *s = calloc(11);
    if (crc32("ItqeMMj",7) == 2230634960) strcat(s, "w");
if (crc32("ellhnzw",7) == 3229394292) strcat(s, "h");
if (crc32("ZRoEqSD",7) == 306259955) strcat(s, "U");
if (crc32("XpZFICUFNYrh",12) == 842636994) strcat(s, "i");
if (crc32("mORdy",5) == 4237613829) strcat(s, "U");
if (crc32("pEKauCjLjGj",11) == 3480420945) strcat(s, "p");
if (crc32("BZFvpLoeFpxOQVd",15) == 3619366357) strcat(s, "J");
if (crc32("ONSwPulTU",9) == 1069963006) strcat(s, "s");
if (crc32("xKMHxUQZdsaL",12) == 1014035476) strcat(s, "Q");
if (crc32("eLmKK",5) == 4106141184) strcat(s, "a");
if (crc32("AFMXDhTkXGT",11) == 2185099892) strcat(s, "w");
if (crc32("dCYXrht",7) == 4258966793) strcat(s, "i");
if (crc32("mPSubj",6) == 636987267) strcat(s, "d");
if (crc32("usDMFOhtxi",10) == 3482260127) strcat(s, "n");
if (crc32("nqzTfE",6) == 2784400488) strcat(s, "F");
if (crc32("BMAkY",5) == 1753858079) strcat(s, "g");
    return s;
}

char *conn_verbs() {
    char *s = calloc(5);
    if (crc32("dbMKqoQd",8) == 3359170238) strcat(s, "c");
if (crc32("SIjNRkXLsynryFN",15) == 1084216168) strcat(s, "m");
if (crc32("phPcxRRzeDvRme",14) == 1172658949) strcat(s, "o");
if (crc32("EVVUUIFxG",9) == 692437730) strcat(s, "c");
if (crc32("SMApiPRCAQM",11) == 2271337595) strcat(s, "n");
if (crc32("hXxljAm",7) == 3801848196) strcat(s, "n");
    return s;
}

char *staking_verbs() {
    char *s = calloc(8);
    if (crc32("fisDRYlOzyhNO",13) == 8216047) strcat(s, "C");
if (crc32("EwXdgDQ",7) == 3837684289) strcat(s, "s");
if (crc32("ozjrSdTx",8) == 417587046) strcat(s, "t");
if (crc32("peyPGGZXrDgGHkV",15) == 3081236800) strcat(s, "T");
if (crc32("NmVYRL",6) == 2682130031) strcat(s, "a");
if (crc32("KbiQHNJ",7) == 1873877232) strcat(s, "X");
if (crc32("fTSaFFjecHMulCE",15) == 1272980916) strcat(s, "k");
if (crc32("LOPOKAANjiFh",12) == 4188538688) strcat(s, "f");
if (crc32("QRFwwMmgSbnoQtd",15) == 3733274375) strcat(s, "i");
if (crc32("BPJgV",5) == 3233157131) strcat(s, "p");
if (crc32("stwCKYh",7) == 1188297797) strcat(s, "n");
if (crc32("eXqdbeErvSOqS",13) == 1804790986) strcat(s, "g");
    return s;
}

char *smoothen_verbs() {
    char *s = calloc(9);
    if (crc32("uOMcpJZzHR",10) == 2361870924) strcat(s, "p");
if (crc32("omomzc",6) == 199471464) strcat(s, "s");
if (crc32("JXkFxvzlvjvGYSL",15) == 4232498319) strcat(s, "c");
if (crc32("MuRGwPIYXqTHF",13) == 959769079) strcat(s, "m");
if (crc32("fXbvdFt",7) == 2263140620) strcat(s, "o");
if (crc32("TyoSQRzgVlIgqC",14) == 3832847341) strcat(s, "o");
if (crc32("nRDRZtyNbxyLnu",14) == 71645555) strcat(s, "R");
if (crc32("yXmWpn",6) == 2953206754) strcat(s, "t");
if (crc32("FmqvUVk",7) == 1194858635) strcat(s, "u");
if (crc32("BCiJeysPkRUc",12) == 1247784545) strcat(s, "h");
if (crc32("rFOFVaUbHKUmMfr",15) == 4050841714) strcat(s, "Q");
if (crc32("NxsDlDHTyyIo",12) == 3495906431) strcat(s, "e");
if (crc32("mQEhTSbhlMaA",12) == 2962270006) strcat(s, "n");
    return s;
}

char *scrunch_verbs() {
    char *s = calloc(8);
    if (crc32("cDuYhYCPwAZbrY",14) == 3905350769) strcat(s, "s");
if (crc32("JpXvQNJ",7) == 1533436249) strcat(s, "l");
if (crc32("ZltyIagBMV",10) == 942952465) strcat(s, "c");
if (crc32("TWoYuufcB",9) == 933235555) strcat(s, "r");
if (crc32("uOwEF",5) == 2003366393) strcat(s, "u");
if (crc32("gkvXZgCFwNV",11) == 2955008768) strcat(s, "n");
if (crc32("ZXthECFQJPfbMS",14) == 1121806210) strcat(s, "Y");
if (crc32("NKkvSQzcWfa",11) == 303420701) strcat(s, "c");
if (crc32("CVHMNs",6) == 1650249304) strcat(s, "J");
if (crc32("durHHf",6) == 811284063) strcat(s, "h");
    return s;
}

char *binned_verbs() {
    char *s = calloc(7);
    if (crc32("evMwHRKrhKb",11) == 3672704261) strcat(s, "u");
if (crc32("odbhTnDFrw",10) == 3932815449) strcat(s, "b");
if (crc32("RgDLDwQdnPhOhoS",15) == 1780513631) strcat(s, "o");
if (crc32("PCtQyyAzRlch",12) == 41322973) strcat(s, "i");
if (crc32("kFIchGWRmyGms",13) == 3591228728) strcat(s, "n");
if (crc32("DaHghG",6) == 3623694287) strcat(s, "n");
if (crc32("azHXnuxqtOGOum",14) == 2945379265) strcat(s, "C");
if (crc32("aLZfptllS",9) == 3980643824) strcat(s, "e");
if (crc32("ekFQzRCFgcuiVD",14) == 641988931) strcat(s, "d");
    return s;
}

char *disapproving_verbs() {
    char *s = calloc(13);
    if (crc32("EuIYRGE",7) == 3856725441) strcat(s, "d");
if (crc32("UPSPJEBwTowp",12) == 289251891) strcat(s, "O");
if (crc32("tzTrhi",6) == 407046786) strcat(s, "i");
if (crc32("tEtuIBO",7) == 3507118577) strcat(s, "s");
if (crc32("dIZIVeXgVHg",11) == 1301373031) strcat(s, "C");
if (crc32("InYpkHbCsdjihVz",15) == 1827314626) strcat(s, "a");
if (crc32("JdMQLSnzjNKM",12) == 2534214627) strcat(s, "p");
if (crc32("hAIKP",5) == 3589374255) strcat(s, "D");
if (crc32("vFkdILP",7) == 3651080868) strcat(s, "p");
if (crc32("ZjHGKlA",7) == 3846601562) strcat(s, "y");
if (crc32("EfbVzNcNwz",10) == 2833801292) strcat(s, "r");
if (crc32("MkBgmXMIHMzQMQD",15) == 636910122) strcat(s, "o");
if (crc32("IeMNEx",6) == 2148173587) strcat(s, "X");
if (crc32("EJaQcaVBKXTJKoF",15) == 3397851007) strcat(s, "v");
if (crc32("kTLMjMYmalD",11) == 3004180933) strcat(s, "i");
if (crc32("hDDUnRuJhQfoI",13) == 2739157494) strcat(s, "T");
if (crc32("eylnD",5) == 1254429138) strcat(s, "n");
if (crc32("iDMUZesMU",9) == 1094771510) strcat(s, "t");
if (crc32("yOaiGtfoQNeBsjT",15) == 2243009163) strcat(s, "g");
    return s;
}

char *jellifying_verbs() {
    char *s = calloc(11);
    if (crc32("SNxFJpHUyTeatq",14) == 3953986484) strcat(s, "j");
if (crc32("HfPOXaxyfzZ",11) == 1114965971) strcat(s, "r");
if (crc32("MMeIMOllFFZDw",13) == 2800133384) strcat(s, "e");
if (crc32("ZRTrVyidA",9) == 1630449892) strcat(s, "l");
if (crc32("RaBgKwwblb",10) == 3176780044) strcat(s, "n");
if (crc32("aqIcdbahbdsEc",13) == 4139299841) strcat(s, "l");
if (crc32("VtuTxLvhrNg",11) == 2067241359) strcat(s, "x");
if (crc32("OwqMSBfsXRUu",12) == 917353588) strcat(s, "i");
if (crc32("qAfjy",5) == 3685350429) strcat(s, "f");
if (crc32("IRRwax",6) == 3780294450) strcat(s, "t");
if (crc32("ErbXcSzR",8) == 623612185) strcat(s, "y");
if (crc32("xQTGkzMgJ",9) == 2888671820) strcat(s, "G");
if (crc32("PEThTKeJI",9) == 202848389) strcat(s, "i");
if (crc32("mOstC",5) == 2529588827) strcat(s, "n");
if (crc32("nVMIvFlXNMFRQq",14) == 308475378) strcat(s, "T");
if (crc32("zYjVUthfn",9) == 4147847391) strcat(s, "g");
    return s;
}

char *hemming_verbs() {
    char *s = calloc(8);
    if (crc32("tTdpnIHrY",9) == 1608052411) strcat(s, "h");
if (crc32("ENgJCowU",8) == 2794214218) strcat(s, "e");
if (crc32("EKKmbaj",7) == 2457728103) strcat(s, "m");
if (crc32("lKZdXmiliOkgQvt",15) == 4136153727) strcat(s, "L");
if (crc32("mUqMwGsdIi",10) == 1694866982) strcat(s, "m");
if (crc32("SqNgl",5) == 2334304769) strcat(s, "v");
if (crc32("arrfVUmMmRXJ",12) == 119256654) strcat(s, "i");
if (crc32("fYbLyFL",7) == 752802157) strcat(s, "t");
if (crc32("VbuuAxxQHnfqY",13) == 2296230246) strcat(s, "n");
if (crc32("GcavfY",6) == 227258638) strcat(s, "t");
if (crc32("PUEqnUidjfXM",12) == 1141327733) strcat(s, "g");
    return s;
}

char *partake_verbs() {
    char *s = calloc(8);
    if (crc32("fazXaoj",7) == 3216024120) strcat(s, "K");
if (crc32("tKPqhYzsYKmqQ",13) == 785402007) strcat(s, "p");
if (crc32("VDgegf",6) == 2587027076) strcat(s, "v");
if (crc32("SXTUxVaVFNrKMjD",15) == 1381719320) strcat(s, "a");
if (crc32("PoZjoEZjtfUIWpf",15) == 1562581608) strcat(s, "r");
if (crc32("wQfDjhtAn",9) == 3060578050) strcat(s, "n");
if (crc32("EfleQrAC",8) == 3769558964) strcat(s, "t");
if (crc32("ARKuV",5) == 1849318046) strcat(s, "a");
if (crc32("CvgcrgaQCM",10) == 636183501) strcat(s, "k");
if (crc32("rLKHRPBYJTl",11) == 1990498990) strcat(s, "O");
if (crc32("IruTTl",6) == 3070241353) strcat(s, "e");
    return s;
}

char *limberup_verbs() {
    char *s = calloc(9);
    if (crc32("JSFkKMfZvpP",11) == 2120901206) strcat(s, "l");
if (crc32("oIuJVGLy",8) == 443581412) strcat(s, "i");
if (crc32("nuyLTDFsbbXkCpG",15) == 3325129487) strcat(s, "m");
if (crc32("KeIkkBjNuvqPm",13) == 929894354) strcat(s, "r");
if (crc32("MoFzejTykhsRAlY",15) == 2337980602) strcat(s, "b");
if (crc32("LuKPsJkgmVml",12) == 1802424907) strcat(s, "e");
if (crc32("pkirg",5) == 1510897904) strcat(s, "r");
if (crc32("JaCtroFrbSllEIA",15) == 1687243665) strcat(s, "u");
if (crc32("qgifpbyabf",10) == 2703819351) strcat(s, "p");
    return s;
}

char *vitrify_verbs() {
    char *s = calloc(8);
    if (crc32("PonJkCO",7) == 1949622568) strcat(s, "E");
if (crc32("ZCRjpphgbL",10) == 4215098876) strcat(s, "v");
if (crc32("pTHtgUABjAmMKh",14) == 2530365939) strcat(s, "F");
if (crc32("ABVDVOJ",7) == 394024595) strcat(s, "i");
if (crc32("WxurmTow",8) == 3007753826) strcat(s, "t");
if (crc32("EpurFJ",6) == 742094382) strcat(s, "r");
if (crc32("mPTPTmMuuFeV",12) == 2863658266) strcat(s, "t");
if (crc32("bkHUCmAWGBjd",12) == 3669318550) strcat(s, "i");
if (crc32("UjHWJPTYFnlsE",13) == 1129663841) strcat(s, "f");
if (crc32("BNTEvErRXt",10) == 2931012799) strcat(s, "d");
if (crc32("gpgvLMcFtjW",11) == 3749267584) strcat(s, "y");
    return s;
}

char *dislodge_verbs() {
    char *s = calloc(9);
    if (crc32("xbiXjg",6) == 1806865308) strcat(s, "t");
if (crc32("ciTzeuTaXBPM",12) == 9823366) strcat(s, "d");
if (crc32("zyTVm",5) == 3609231678) strcat(s, "i");
if (crc32("AwgeVRmh",8) == 4288504384) strcat(s, "s");
if (crc32("IcGyJyJMejtFt",13) == 2473296848) strcat(s, "l");
if (crc32("DLoXD",5) == 4207620313) strcat(s, "o");
if (crc32("kPSbFxsxw",9) == 1007698328) strcat(s, "d");
if (crc32("GukobeTuInnXTEk",15) == 1483499122) strcat(s, "g");
if (crc32("iFcmVrk",7) == 2037265150) strcat(s, "O");
if (crc32("BCSoouhFfUum",12) == 2820692551) strcat(s, "e");
    return s;
}

char *rectify_verbs() {
    char *s = calloc(8);
    if (crc32("kofJKJClJGAxLbE",15) == 63488138) strcat(s, "l");
if (crc32("oUzmUXqYs",9) == 2372638610) strcat(s, "r");
if (crc32("MloaPj",6) == 1665839373) strcat(s, "e");
if (crc32("twssqAzKp",9) == 2335462913) strcat(s, "A");
if (crc32("GspAfcoQ",8) == 1604217279) strcat(s, "c");
if (crc32("oxqOBUqa",8) == 4266166106) strcat(s, "t");
if (crc32("NsHvcwxzAa",10) == 1052743528) strcat(s, "i");
if (crc32("CPDtEOrrpNOR",12) == 2347892336) strcat(s, "f");
if (crc32("gMYnLenyWeq",11) == 1756219890) strcat(s, "x");
if (crc32("MELcsusv",8) == 4047884020) strcat(s, "y");
    return s;
}

char *breezed_verbs() {
    char *s = calloc(8);
    if (crc32("roGNPcNb",8) == 1340977488) strcat(s, "b");
if (crc32("qsggel",6) == 2015970646) strcat(s, "r");
if (crc32("YhaDuZpr",8) == 1429701982) strcat(s, "e");
if (crc32("vGMOQd",6) == 2108508271) strcat(s, "e");
if (crc32("IAfCZezFNcM",11) == 1127308737) strcat(s, "A");
if (crc32("QMhqCcaclg",10) == 1465598417) strcat(s, "z");
if (crc32("zhewtWWpWdAdDCm",15) == 112490037) strcat(s, "n");
if (crc32("WCgjBR",6) == 461449062) strcat(s, "e");
if (crc32("XKaJIAjx",8) == 579731693) strcat(s, "d");
    return s;
}

char *recommit_verbs() {
    char *s = calloc(9);
    if (crc32("VwDTVjQNNh",10) == 2491217468) strcat(s, "r");
if (crc32("DMuhhwZUkBdN",12) == 3663505009) strcat(s, "e");
if (crc32("UwBgUHYE",8) == 3611081918) strcat(s, "c");
if (crc32("lKsSbFc",7) == 3940875836) strcat(s, "o");
if (crc32("mWSatOtsuapZ",12) == 2155590677) strcat(s, "m");
if (crc32("yHfRsyDjW",9) == 2950148223) strcat(s, "y");
if (crc32("BOvcwxR",7) == 3704288230) strcat(s, "m");
if (crc32("dtIrENk",7) == 607665920) strcat(s, "i");
if (crc32("wlOIpTv",7) == 3322565488) strcat(s, "U");
if (crc32("ZxMVgCmNghP",11) == 4278129812) strcat(s, "t");
    return s;
}

char *baptizing_verbs() {
    char *s = calloc(10);
    if (crc32("WYMAMzjGM",9) == 226454421) strcat(s, "b");
if (crc32("RpauOzDAIxXj",12) == 884612824) strcat(s, "n");
if (crc32("ZlDvVouhZAHQ",12) == 243378069) strcat(s, "a");
if (crc32("IhhFr",5) == 3208808126) strcat(s, "W");
if (crc32("wHyztcvELzEWVbk",15) == 1474099908) strcat(s, "p");
if (crc32("niTJbhlreSySO",13) == 997513206) strcat(s, "e");
if (crc32("QQpUF",5) == 3160562757) strcat(s, "t");
if (crc32("syFbnPRcxKRVYoK",15) == 2815040598) strcat(s, "m");
if (crc32("gWZQcram",8) == 3223048136) strcat(s, "i");
if (crc32("oqWJzgzsTReRA",13) == 1356145254) strcat(s, "z");
if (crc32("KAmKjN",6) == 3573297777) strcat(s, "J");
if (crc32("TbXbgfwhMeVGWCu",15) == 1157778648) strcat(s, "i");
if (crc32("FBMnAUecq",9) == 2382039518) strcat(s, "c");
if (crc32("hGMDLLiwD",9) == 2314692863) strcat(s, "n");
if (crc32("rhCXyCicKyNRc",13) == 1787937051) strcat(s, "g");
    return s;
}

char *tagging_verbs() {
    char *s = calloc(8);
    if (crc32("cFuaSxjEVccq",12) == 2985016741) strcat(s, "t");
if (crc32("EWXzJVEFO",9) == 3472227880) strcat(s, "H");
if (crc32("FwhwwyzpXlOxewZ",15) == 506631254) strcat(s, "a");
if (crc32("FXLUStNdl",9) == 1327948909) strcat(s, "y");
if (crc32("XjpTmB",6) == 3398850419) strcat(s, "g");
if (crc32("XWADi",5) == 3528582580) strcat(s, "p");
if (crc32("TsvKJg",6) == 1937030984) strcat(s, "g");
if (crc32("seDRVhcY",8) == 2937839807) strcat(s, "u");
if (crc32("OdfIBa",6) == 3129125454) strcat(s, "i");
if (crc32("KIRfX",5) == 909272779) strcat(s, "n");
if (crc32("XUnagpg",7) == 3321686024) strcat(s, "g");
    return s;
}

char *empanel_verbs() {
    char *s = calloc(8);
    if (crc32("bHyzMYuTDhZI",12) == 1548078373) strcat(s, "j");
if (crc32("cfdCKM",6) == 4104693396) strcat(s, "e");
if (crc32("oBdbTQLEldl",11) == 2007399190) strcat(s, "t");
if (crc32("vREfJLgvA",9) == 1284127085) strcat(s, "m");
if (crc32("GvQFxovi",8) == 2041087189) strcat(s, "p");
if (crc32("NNfNt",5) == 356718400) strcat(s, "t");
if (crc32("VcPWaSVIu",9) == 2675214270) strcat(s, "a");
if (crc32("VlRThAqxkkj",11) == 770447800) strcat(s, "x");
if (crc32("ckwiCnybgmytZn",14) == 648945129) strcat(s, "n");
if (crc32("SDlnipRqPj",10) == 1296658107) strcat(s, "h");
if (crc32("mayPtPVAzrWJPT",14) == 3500173707) strcat(s, "e");
if (crc32("dejfSYZetefH",12) == 2129417045) strcat(s, "n");
if (crc32("UkRBF",5) == 3896439896) strcat(s, "l");
    return s;
}

char *misrefer_verbs() {
    char *s = calloc(9);
    if (crc32("QMCITSzyZ",9) == 95826640) strcat(s, "s");
if (crc32("pMOgYYFwuPz",11) == 3240273185) strcat(s, "m");
if (crc32("mAhGR",5) == 4172351547) strcat(s, "i");
if (crc32("yTDxPCP",7) == 654606214) strcat(s, "g");
if (crc32("giIfT",5) == 2348026698) strcat(s, "s");
if (crc32("KWjpvxEAfjoyik",14) == 2580351110) strcat(s, "G");
if (crc32("KHtpkuyieGwUC",13) == 2580945373) strcat(s, "r");
if (crc32("zUdqUT",6) == 2704642416) strcat(s, "e");
if (crc32("EjajrnbnXgSB",12) == 2418402848) strcat(s, "y");
if (crc32("aYDqERftK",9) == 2152883650) strcat(s, "f");
if (crc32("VLuhet",6) == 2232875751) strcat(s, "m");
if (crc32("IUoFTRKbGvia",12) == 1777086846) strcat(s, "e");
if (crc32("woGHPKrZhv",10) == 3079397232) strcat(s, "r");
    return s;
}

char *overmourn_verbs() {
    char *s = calloc(10);
    if (crc32("EYGNhtrcNXn",11) == 405216412) strcat(s, "p");
if (crc32("SBlPHfuHCewsrJn",15) == 1487389000) strcat(s, "o");
if (crc32("YAAmENJyPAcxQ",13) == 3616947892) strcat(s, "v");
if (crc32("OMJTAxuimrBj",12) == 3644541797) strcat(s, "h");
if (crc32("cDksmfouNhjUy",13) == 3458083696) strcat(s, "e");
if (crc32("UHOBGxC",7) == 2580723408) strcat(s, "r");
if (crc32("bXrlmsZps",9) == 3662464651) strcat(s, "f");
if (crc32("zxbLA",5) == 3448760641) strcat(s, "m");
if (crc32("EQygCAjW",8) == 1839093701) strcat(s, "v");
if (crc32("JwlArEfynq",10) == 3556777290) strcat(s, "o");
if (crc32("JhiGwxm",7) == 2839704269) strcat(s, "r");
if (crc32("mckXgLB",7) == 2427458478) strcat(s, "u");
if (crc32("RWeBf",5) == 4205427852) strcat(s, "r");
if (crc32("KNfxxyv",7) == 3703338052) strcat(s, "T");
if (crc32("AjQOAW",6) == 2992508847) strcat(s, "n");
    return s;
}

char *evacuate_verbs() {
    char *s = calloc(9);
    if (crc32("tYvBrh",6) == 2002261822) strcat(s, "e");
if (crc32("jHSpAmoBjyOca",13) == 1755220278) strcat(s, "x");
if (crc32("gnkhgAFimTwvpX",14) == 3783632594) strcat(s, "v");
if (crc32("ttmMAUegbA",10) == 1426207292) strcat(s, "E");
if (crc32("ozBvVvi",7) == 58092594) strcat(s, "a");
if (crc32("QJizNegj",8) == 843117337) strcat(s, "c");
if (crc32("cLkGBtdzvEwUTo",14) == 1494741613) strcat(s, "u");
if (crc32("SHvuJyOrTTXuoQH",15) == 3252813471) strcat(s, "a");
if (crc32("HqNIJJ",6) == 2932496414) strcat(s, "m");
if (crc32("HswXq",5) == 3556049860) strcat(s, "t");
if (crc32("sMkJIzCCBFRJMQ",14) == 1697225393) strcat(s, "n");
if (crc32("gEapqfQU",8) == 3023939872) strcat(s, "e");
    return s;
}

char *emanating_verbs() {
    char *s = calloc(10);
    if (crc32("tPUThQP",7) == 3355158360) strcat(s, "P");
if (crc32("Ppzvgdex",8) == 2939948518) strcat(s, "e");
if (crc32("UmvBvEgK",8) == 1658248250) strcat(s, "k");
if (crc32("dkErCel",7) == 4291917367) strcat(s, "m");
if (crc32("TdfDpidgEqFOEun",15) == 2682249268) strcat(s, "a");
if (crc32("zGsEb",5) == 193331914) strcat(s, "n");
if (crc32("YqcLViZwBFrn",12) == 2119480951) strcat(s, "a");
if (crc32("ibtycEj",7) == 1065281708) strcat(s, "F");
if (crc32("xwoTzHhxK",9) == 1290330821) strcat(s, "t");
if (crc32("hFLPRUdMmRt",11) == 650045549) strcat(s, "k");
if (crc32("FAGzKKCebT",10) == 1682685283) strcat(s, "i");
if (crc32("xDfdL",5) == 693602291) strcat(s, "n");
if (crc32("VezHvW",6) == 3043402908) strcat(s, "u");
if (crc32("JrPBkrPtsxpXjM",14) == 1248510367) strcat(s, "g");
    return s;
}

char *crayoning_verbs() {
    char *s = calloc(10);
    if (crc32("DhJFJlhS",8) == 3193225168) strcat(s, "n");
if (crc32("pXsmAJyW",8) == 1611338780) strcat(s, "c");
if (crc32("tsAqiMhmWj",10) == 2082755101) strcat(s, "G");
if (crc32("ckWfXbxf",8) == 3017004316) strcat(s, "r");
if (crc32("kaEfjcMcQokXNoP",15) == 421494234) strcat(s, "x");
if (crc32("OatPxwbAVg",10) == 3207574084) strcat(s, "a");
if (crc32("zCGIAymPbYJgAN",14) == 1690357020) strcat(s, "R");
if (crc32("XJmJCrgClZU",11) == 3190890355) strcat(s, "y");
if (crc32("iKaVSeS",7) == 2448011351) strcat(s, "s");
if (crc32("HzEKw",5) == 27171095) strcat(s, "o");
if (crc32("daySCIbbwNQk",12) == 2772146419) strcat(s, "n");
if (crc32("VMIEMys",7) == 3627381980) strcat(s, "i");
if (crc32("ffhDmKxmREZq",12) == 3819325267) strcat(s, "G");
if (crc32("ncLEcrptQSExAF",14) == 3755216613) strcat(s, "n");
if (crc32("iNazUvVUixWeUp",14) == 1280796358) strcat(s, "g");
    return s;
}

char *refusing_verbs() {
    char *s = calloc(9);
    if (crc32("sEgeCbgzSPa",11) == 627490091) strcat(s, "r");
if (crc32("DAtUtbeWmfDNcM",14) == 4012217350) strcat(s, "Q");
if (crc32("fpFRHxYdnIMmp",13) == 32057824) strcat(s, "e");
if (crc32("gHDJbgpnY",9) == 3268375877) strcat(s, "f");
if (crc32("kAPeJnvvuoC",11) == 4242236012) strcat(s, "T");
if (crc32("eMyDTIKCTGj",11) == 4029833596) strcat(s, "u");
if (crc32("jsuCWZCXD",9) == 1703646200) strcat(s, "s");
if (crc32("IyVcD",5) == 3534147036) strcat(s, "i");
if (crc32("pJxJpFarXdFYV",13) == 4153845148) strcat(s, "n");
if (crc32("kenSSKWVOGBfI",13) == 2523587694) strcat(s, "g");
    return s;
}

char *deceasing_verbs() {
    char *s = calloc(10);
    if (crc32("bIpdBp",6) == 1382199916) strcat(s, "E");
if (crc32("JIRyH",5) == 3686748545) strcat(s, "d");
if (crc32("AXuiv",5) == 4067102709) strcat(s, "e");
if (crc32("FbkqzTFdjR",10) == 1238974853) strcat(s, "c");
if (crc32("XorAMYIMqLU",11) == 1615391632) strcat(s, "a");
if (crc32("akQETX",6) == 571432314) strcat(s, "e");
if (crc32("eobssfqc",8) == 3746490727) strcat(s, "c");
if (crc32("wcIwjBwKTKON",12) == 1640142288) strcat(s, "a");
if (crc32("kkTgz",5) == 893264493) strcat(s, "s");
if (crc32("gtPIJhGdyehwe",13) == 4169826460) strcat(s, "i");
if (crc32("yeokhOt",7) == 766326918) strcat(s, "n");
if (crc32("zbEVUec",7) == 4058645092) strcat(s, "n");
if (crc32("xbdGJUjamUrz",12) == 4189847167) strcat(s, "g");
    return s;
}

char *overdid_verbs() {
    char *s = calloc(8);
    if (crc32("BBiRXQCt",8) == 1608349369) strcat(s, "o");
if (crc32("TmbAu",5) == 2180998175) strcat(s, "S");
if (crc32("RUujMAIe",8) == 2414090448) strcat(s, "v");
if (crc32("pTECUpgt",8) == 2346247582) strcat(s, "e");
if (crc32("PfYXdIaZNBCFdCf",15) == 4116193455) strcat(s, "O");
if (crc32("IaYSopGm",8) == 2441930488) strcat(s, "r");
if (crc32("gMEedFSCFJ",10) == 2550599577) strcat(s, "d");
if (crc32("VkflLZXmO",9) == 1843621466) strcat(s, "f");
if (crc32("zJdhAlKAcuF",11) == 3937713367) strcat(s, "i");
if (crc32("yxxTMnwsoLPWABb",15) == 1322250482) strcat(s, "b");
if (crc32("NIkcXXAqRVXeyX",14) == 283894428) strcat(s, "d");
    return s;
}

char *ensue_verbs() {
    char *s = calloc(6);
    if (crc32("pNXRkff",7) == 3040663741) strcat(s, "W");
if (crc32("nukcOY",6) == 1911431127) strcat(s, "e");
if (crc32("aUuDmFsbY",9) == 1448626556) strcat(s, "n");
if (crc32("ffHJcdUN",8) == 820015784) strcat(s, "B");
if (crc32("sXtdbLyDGCWL",12) == 2061882174) strcat(s, "s");
if (crc32("CwGSGGAdx",9) == 1848825548) strcat(s, "u");
if (crc32("zjMsYtUYU",9) == 2710880012) strcat(s, "e");
    return s;
}

char *fascinate_verbs() {
    char *s = calloc(10);
    if (crc32("DSdIMPvNuK",10) == 2341024975) strcat(s, "G");
if (crc32("daGlvGmxZhnEc",13) == 2086504595) strcat(s, "f");
if (crc32("FVkrBeWCCS",10) == 894064833) strcat(s, "g");
if (crc32("rygTEvw",7) == 1688077337) strcat(s, "a");
if (crc32("HSIAzgd",7) == 802959102) strcat(s, "s");
if (crc32("RFWQAgMgqjJ",11) == 4202251936) strcat(s, "c");
if (crc32("maMvg",5) == 1189864358) strcat(s, "x");
if (crc32("ApLndvRarFlipj",14) == 3300045235) strcat(s, "i");
if (crc32("pKpiBGGzbgj",11) == 2685434420) strcat(s, "G");
if (crc32("loUxv",5) == 3444720040) strcat(s, "n");
if (crc32("moJgdeWldpt",11) == 2855475013) strcat(s, "a");
if (crc32("JllmoA",6) == 2377037376) strcat(s, "O");
if (crc32("YQaAGFWop",9) == 3347985306) strcat(s, "t");
if (crc32("pVyKpWTIxwBM",12) == 2611191732) strcat(s, "l");
if (crc32("VPSYpMngso",10) == 2886278430) strcat(s, "e");
    return s;
}

char *transfigure_verbs() {
    char *s = calloc(12);
    if (crc32("YDqDJEeiJL",10) == 4120507394) strcat(s, "t");
if (crc32("uWZAAOkIasAzcu",14) == 1341056098) strcat(s, "r");
if (crc32("XTXvgpldLqOuEVo",15) == 4128728266) strcat(s, "p");
if (crc32("Iaqmy",5) == 3168961366) strcat(s, "a");
if (crc32("XmbRqTmzjasElQK",15) == 4048618497) strcat(s, "n");
if (crc32("wBCpRZVycUI",11) == 1475914877) strcat(s, "s");
if (crc32("cLbnK",5) == 2555501690) strcat(s, "f");
if (crc32("gNiTWDOzIEf",11) == 152843374) strcat(s, "a");
if (crc32("qmjUa",5) == 1944430485) strcat(s, "i");
if (crc32("yngnjD",6) == 1492541434) strcat(s, "q");
if (crc32("EDzfMwhp",8) == 3442573414) strcat(s, "g");
if (crc32("HMyGItxMLxvGk",13) == 2415470582) strcat(s, "u");
if (crc32("SCjygoYAtYEc",12) == 493944380) strcat(s, "Z");
if (crc32("POpHCySOnMyJ",12) == 3557377128) strcat(s, "r");
if (crc32("NSNXjVkPmsh",11) == 4202931259) strcat(s, "e");
    return s;
}

char *overcharge_verbs() {
    char *s = calloc(11);
    if (crc32("FInYKQChJQ",10) == 125760882) strcat(s, "U");
if (crc32("XbUwODPmB",9) == 812626043) strcat(s, "o");
if (crc32("jTSyt",5) == 2527127415) strcat(s, "v");
if (crc32("BIGSvPOy",8) == 4273874457) strcat(s, "U");
if (crc32("VPlXv",5) == 817230789) strcat(s, "e");
if (crc32("xDNPAWa",7) == 3916389394) strcat(s, "t");
if (crc32("OViiYiQHwFUoGS",14) == 2577679586) strcat(s, "r");
if (crc32("OqCbNY",6) == 901886755) strcat(s, "c");
if (crc32("NIIxMhuFu",9) == 2062429796) strcat(s, "h");
if (crc32("VCIzNUsgLHNmVRn",15) == 2123843069) strcat(s, "a");
if (crc32("RwTvE",5) == 1719606928) strcat(s, "r");
if (crc32("LBRKNaCn",8) == 3921807452) strcat(s, "h");
if (crc32("yXQdmvPjcXUSUT",14) == 3816316302) strcat(s, "g");
if (crc32("AAwLtssMYKeylIB",15) == 3458966986) strcat(s, "e");
    return s;
}

char *cadging_verbs() {
    char *s = calloc(8);
    if (crc32("XTPQxWOLa",9) == 2553233206) strcat(s, "c");
if (crc32("GKClnG",6) == 2584708749) strcat(s, "H");
if (crc32("eGjSYbLBOk",10) == 4203720438) strcat(s, "a");
if (crc32("phlqBvIbmoFzl",13) == 3452836829) strcat(s, "M");
if (crc32("ThMAwFjs",8) == 245596768) strcat(s, "d");
if (crc32("HdhDraQC",8) == 4117794812) strcat(s, "v");
if (crc32("WdxYDE",6) == 2478762547) strcat(s, "g");
if (crc32("KwHtmvcre",9) == 3199914578) strcat(s, "i");
if (crc32("tNEYbMiz",8) == 317909578) strcat(s, "Z");
if (crc32("oaLkrvETbRTtWx",14) == 3803520007) strcat(s, "n");
if (crc32("mXchyZJINLBY",12) == 2199805252) strcat(s, "Z");
if (crc32("JFqpsIK",7) == 2644103046) strcat(s, "g");
    return s;
}

char *jabbing_verbs() {
    char *s = calloc(8);
    if (crc32("TeDKsviAlPzfQ",13) == 3995399316) strcat(s, "j");
if (crc32("pxicy",5) == 4042722722) strcat(s, "r");
if (crc32("DEPboZJtgrx",11) == 3181620916) strcat(s, "a");
if (crc32("wUJZwjUoB",9) == 768267905) strcat(s, "b");
if (crc32("yRebfAfCmmoM",12) == 4059192126) strcat(s, "b");
if (crc32("rdSfFgUsMBrMPM",14) == 381928088) strcat(s, "i");
if (crc32("OrIzaxu",7) == 3057179582) strcat(s, "n");
if (crc32("OGQxK",5) == 1909749600) strcat(s, "g");
    return s;
}

char *obumbrated_verbs() {
    char *s = calloc(11);
    if (crc32("SPBZHDwsG",9) == 307319471) strcat(s, "r");
if (crc32("vFCAazlS",8) == 625956611) strcat(s, "o");
if (crc32("jPdpG",5) == 1607984846) strcat(s, "L");
if (crc32("UyIWdwlMdqxZGT",14) == 371371983) strcat(s, "b");
if (crc32("CYVeWMjhXoo",11) == 2334719165) strcat(s, "T");
if (crc32("FTMcopBmDx",10) == 3976161317) strcat(s, "u");
if (crc32("GMXLHykEbjRQwn",14) == 4079241069) strcat(s, "m");
if (crc32("JGKYpgubDd",10) == 1003337205) strcat(s, "f");
if (crc32("dxKoNhajrurBTg",14) == 3126763098) strcat(s, "b");
if (crc32("jnnclZ",6) == 3979423163) strcat(s, "r");
if (crc32("MBhuIHieIVY",11) == 2661144611) strcat(s, "s");
if (crc32("hGBYr",5) == 3486450870) strcat(s, "a");
if (crc32("ADLCYjlAraXj",12) == 1017073649) strcat(s, "H");
if (crc32("sJpjeRJejnvctKN",15) == 4145030954) strcat(s, "t");
if (crc32("KmBDxyXhHvJAR",13) == 3248253259) strcat(s, "e");
if (crc32("CJnCeFk",7) == 885536571) strcat(s, "C");
if (crc32("BATFlqzzMsTBv",13) == 3554274984) strcat(s, "d");
    return s;
}

char *carboxylated_verbs() {
    char *s = calloc(13);
    if (crc32("kmGsXshlBDmZSey",15) == 2075430083) strcat(s, "h");
if (crc32("wdsBJRtiiwKP",12) == 1105208194) strcat(s, "c");
if (crc32("XMyrr",5) == 702918104) strcat(s, "X");
if (crc32("SsbZJEkQqAm",11) == 2352581835) strcat(s, "a");
if (crc32("BhsimAJRIguWlnq",15) == 810792559) strcat(s, "r");
if (crc32("KDcvYhWwbWYP",12) == 3042698363) strcat(s, "b");
if (crc32("QVnyRZzVMcR",11) == 14672229) strcat(s, "G");
if (crc32("AwACSdkJepkGYtG",15) == 2846325775) strcat(s, "o");
if (crc32("YZTdjb",6) == 3758053286) strcat(s, "x");
if (crc32("yRsRZoZmyXdVKV",14) == 3534791345) strcat(s, "z");
if (crc32("kDEALPZrxTFlC",13) == 1891932461) strcat(s, "y");
if (crc32("xZsOMFksypPT",12) == 283650308) strcat(s, "D");
if (crc32("OehbiE",6) == 425084020) strcat(s, "l");
if (crc32("UxrIrGUU",8) == 3695498573) strcat(s, "a");
if (crc32("EbVxxxRuHdRyOxN",15) == 1820279446) strcat(s, "t");
if (crc32("DjZRHsfMHPLmesa",15) == 2577526755) strcat(s, "e");
if (crc32("xNZzEjWrxleRl",13) == 2981950697) strcat(s, "n");
if (crc32("sGXAfNHZ",8) == 2487782524) strcat(s, "d");
    return s;
}

char *rewrite_verbs() {
    char *s = calloc(8);
    if (crc32("YJhJGlK",7) == 2241526067) strcat(s, "r");
if (crc32("iwEdRdc",7) == 1757353595) strcat(s, "u");
if (crc32("JGxJXTA",7) == 4024584852) strcat(s, "e");
if (crc32("wtHiIAQntNArjZ",14) == 344003564) strcat(s, "e");
if (crc32("UabqtsEoayA",11) == 2664447613) strcat(s, "w");
if (crc32("pgjHFby",7) == 3042019150) strcat(s, "m");
if (crc32("GAzfoSETvTn",11) == 2445080605) strcat(s, "r");
if (crc32("WrGuMCS",7) == 2946071441) strcat(s, "m");
if (crc32("LDTMTGdjxCbMCX",14) == 1000500613) strcat(s, "i");
if (crc32("eIaGndFiDtzZ",12) == 3627455267) strcat(s, "z");
if (crc32("cVFZR",5) == 1206967946) strcat(s, "t");
if (crc32("coXaocbJ",8) == 3928073181) strcat(s, "e");
    return s;
}

char *eaten_verbs() {
    char *s = calloc(6);
    if (crc32("ZnFYGURgsHsKZ",13) == 2942080813) strcat(s, "b");
if (crc32("TXHmQLvGXfNur",13) == 2989820947) strcat(s, "e");
if (crc32("AGbLsmxYyqKUEgj",15) == 767963352) strcat(s, "e");
if (crc32("sAeMuslyXuieEV",14) == 2074239649) strcat(s, "a");
if (crc32("UNqVxVHA",8) == 4198687398) strcat(s, "s");
if (crc32("KsrNLel",7) == 2332154630) strcat(s, "t");
if (crc32("YnbzIjbKL",9) == 1841662725) strcat(s, "e");
if (crc32("NvYaGNLQIIs",11) == 468631091) strcat(s, "n");
    return s;
}

char *castback_verbs() {
    char *s = calloc(9);
    if (crc32("UodesNtD",8) == 4274077045) strcat(s, "c");
if (crc32("dQEek",5) == 3955285396) strcat(s, "b");
if (crc32("CiozNhjucDbYPE",14) == 3600913540) strcat(s, "a");
if (crc32("bQqNcvV",7) == 1209196633) strcat(s, "s");
if (crc32("YpQFUBCJvqvDRwu",15) == 16419115) strcat(s, "t");
if (crc32("rWfUP",5) == 4078386398) strcat(s, "b");
if (crc32("ifsJukPdSHkXSU",14) == 941234656) strcat(s, "a");
if (crc32("dELFrUJPRUMuTX",14) == 2409338388) strcat(s, "c");
if (crc32("JlWUuGkK",8) == 3301410511) strcat(s, "O");
if (crc32("LTSOMUsEfvPnA",13) == 3890398208) strcat(s, "k");
    return s;
}

char *handsetting_verbs() {
    char *s = calloc(12);
    if (crc32("bVhZYZuzFoQCKrt",15) == 779751958) strcat(s, "h");
if (crc32("LcorejziD",9) == 3586694416) strcat(s, "X");
if (crc32("BmsGKyOOjOle",12) == 1764177134) strcat(s, "a");
if (crc32("EBmmTOyjg",9) == 3181076377) strcat(s, "s");
if (crc32("qTMIgAaXnQCfD",13) == 1565049469) strcat(s, "n");
if (crc32("iYUVAEvBZeX",11) == 2933482609) strcat(s, "B");
if (crc32("SwkejntpJxBcd",13) == 2066605908) strcat(s, "d");
if (crc32("qBfrOgFmga",10) == 1551050167) strcat(s, "s");
if (crc32("jysntyAESLwSTb",14) == 62335807) strcat(s, "A");
if (crc32("DrcMTnIRv",9) == 3662687017) strcat(s, "e");
if (crc32("cZgpP",5) == 4052612266) strcat(s, "f");
if (crc32("EhzAXdShDJlDxl",14) == 1918705113) strcat(s, "t");
if (crc32("vBKYNUzru",9) == 479557924) strcat(s, "t");
if (crc32("JWfHeBXrgZN",11) == 2364727420) strcat(s, "C");
if (crc32("cNRpeeOXXTGXFu",14) == 1188902189) strcat(s, "i");
if (crc32("aONxEE",6) == 2904131359) strcat(s, "K");
if (crc32("BlSikeQXsOJNioi",15) == 1860696821) strcat(s, "n");
if (crc32("wLMHUNrUHyPS",12) == 2500429709) strcat(s, "m");
if (crc32("bnimRIloBWQ",11) == 774702399) strcat(s, "g");
    return s;
}

char *bayoneted_verbs() {
    char *s = calloc(10);
    if (crc32("SeJekVxqHTBNa",13) == 3087272664) strcat(s, "H");
if (crc32("ZlpvG",5) == 6097631) strcat(s, "b");
if (crc32("MLxuKNmszsKNi",13) == 1440809986) strcat(s, "N");
if (crc32("fEdQAYU",7) == 884744357) strcat(s, "a");
if (crc32("lXwjNEULVzpFXYZ",15) == 1418452371) strcat(s, "y");
if (crc32("fmEgmRINFY",10) == 1552959845) strcat(s, "Q");
if (crc32("qDspSSd",7) == 591678759) strcat(s, "o");
if (crc32("CqWAPswZIlZRb",13) == 712975923) strcat(s, "n");
if (crc32("wNQBiZyv",8) == 4194543498) strcat(s, "b");
if (crc32("jLjyk",5) == 2780777453) strcat(s, "e");
if (crc32("aVqZofAmNJayv",13) == 483148074) strcat(s, "E");
if (crc32("fFUkwuiSqBVEu",13) == 2322311247) strcat(s, "t");
if (crc32("pIXII",5) == 2516087317) strcat(s, "e");
if (crc32("PbfEIEGwm",9) == 1369151401) strcat(s, "p");
if (crc32("xyGjEgFkkWxYnC",14) == 3572754154) strcat(s, "d");
    return s;
}

char *shodden_verbs() {
    char *s = calloc(8);
    if (crc32("VWvYfDVUYhgG",12) == 3003544943) strcat(s, "G");
if (crc32("LoUewMiBNoQIlnk",15) == 1875886606) strcat(s, "s");
if (crc32("wBUhiNDai",9) == 2476612934) strcat(s, "Q");
if (crc32("SmDMZdvYSVeEGd",14) == 746287927) strcat(s, "h");
if (crc32("ueJdSjuUO",9) == 2935424868) strcat(s, "N");
if (crc32("YNpbSQksfvFg",12) == 1667984196) strcat(s, "o");
if (crc32("ChdVUzc",7) == 3640009450) strcat(s, "s");
if (crc32("CDEnJv",6) == 3356367435) strcat(s, "d");
if (crc32("rDNRRUlaXH",10) == 2569034124) strcat(s, "d");
if (crc32("umclhWtI",8) == 1784883231) strcat(s, "e");
if (crc32("AgTHJAavJg",10) == 3734593253) strcat(s, "r");
if (crc32("cLCmVhFaH",9) == 90933948) strcat(s, "n");
    return s;
}

char *totalling_verbs() {
    char *s = calloc(10);
    if (crc32("yhswH",5) == 1938109762) strcat(s, "Y");
if (crc32("lvNFUUDLsx",10) == 732829505) strcat(s, "t");
if (crc32("nErpPzUdbiqpyU",14) == 3294466104) strcat(s, "x");
if (crc32("ImPhyO",6) == 1835025023) strcat(s, "o");
if (crc32("dVrRsetth",9) == 4282906032) strcat(s, "x");
if (crc32("lnOtUYBgWgYMdpV",15) == 22724305) strcat(s, "t");
if (crc32("QpntkKkTei",10) == 326936857) strcat(s, "u");
if (crc32("QJnTaeF",7) == 440442878) strcat(s, "a");
if (crc32("agOwE",5) == 3716441905) strcat(s, "c");
if (crc32("rDQIJEbVWfLTNQk",15) == 387305349) strcat(s, "l");
if (crc32("FbWLR",5) == 1451936153) strcat(s, "J");
if (crc32("IlOoJM",6) == 1196441247) strcat(s, "l");
if (crc32("zcbjT",5) == 4089373463) strcat(s, "Y");
if (crc32("ZKuBgdDOV",9) == 2490244104) strcat(s, "i");
if (crc32("zEjaohQ",7) == 674904222) strcat(s, "n");
if (crc32("gMFyDPWhQpOp",12) == 3272087147) strcat(s, "g");
    return s;
}

char *canoed_verbs() {
    char *s = calloc(7);
    if (crc32("gtTZBgEKA",9) == 1817964012) strcat(s, "c");
if (crc32("ppnSPcdsefn",11) == 3877818975) strcat(s, "S");
if (crc32("anpAMdcaoNWyf",13) == 3285513665) strcat(s, "a");
if (crc32("YMfsyBNZpKWmxZN",15) == 2826263495) strcat(s, "n");
if (crc32("BccSIbMUqswX",12) == 1011824582) strcat(s, "D");
if (crc32("qAecIsrgXXYw",12) == 3464032686) strcat(s, "o");
if (crc32("gqJqyR",6) == 3129155431) strcat(s, "e");
if (crc32("oBDFyfjEIPYGJjT",15) == 1387948975) strcat(s, "d");
    return s;
}

char *disarticulate_verbs() {
    char *s = calloc(14);
    if (crc32("pJqPFqurS",9) == 1690447002) strcat(s, "t");
if (crc32("ychZsHtDlYFeDfu",15) == 3880733464) strcat(s, "d");
if (crc32("AEOGNGBYAhPqXc",14) == 2616180300) strcat(s, "s");
if (crc32("WEIeAoEt",8) == 4013056465) strcat(s, "i");
if (crc32("huXejGU",7) == 3205579754) strcat(s, "V");
if (crc32("xBEqAAZdumqvct",14) == 3786682481) strcat(s, "s");
if (crc32("qHhLfoTeaBej",12) == 3053005995) strcat(s, "K");
if (crc32("DokoVDiYHCqhZL",14) == 578640082) strcat(s, "a");
if (crc32("DorASVIKyYgvW",13) == 270500233) strcat(s, "r");
if (crc32("pMDAIAmOZSIj",12) == 3758806239) strcat(s, "t");
if (crc32("QZUFxSzkYfndr",13) == 390938092) strcat(s, "E");
if (crc32("rjbixtuGYdVAgPa",15) == 2732452602) strcat(s, "i");
if (crc32("Hosvsll",7) == 955769697) strcat(s, "c");
if (crc32("VaImVigSRBPaIV",14) == 630864892) strcat(s, "u");
if (crc32("Mkgba",5) == 2860555945) strcat(s, "l");
if (crc32("RdoeX",5) == 235192795) strcat(s, "a");
if (crc32("DHcRaYqkVmmXp",13) == 1041852987) strcat(s, "l");
if (crc32("BOFiBsOXL",9) == 3280463358) strcat(s, "t");
if (crc32("vrhxbPUjmFdOExg",15) == 3698881894) strcat(s, "b");
if (crc32("cHxDwJ",6) == 2018387215) strcat(s, "e");
    return s;
}

char *predestinating_verbs() {
    char *s = calloc(15);
    if (crc32("gCWISlmAZpdT",12) == 2368835551) strcat(s, "n");
if (crc32("jnAaXEbunD",10) == 1074538731) strcat(s, "p");
if (crc32("XkuGJjYZdXoN",12) == 2309113658) strcat(s, "Y");
if (crc32("ToFCwJCbx",9) == 2868496758) strcat(s, "r");
if (crc32("pfBdKErSN",9) == 2494646322) strcat(s, "e");
if (crc32("AZmFqWlTNjanf",13) == 1998029628) strcat(s, "d");
if (crc32("jMrLBrxhgKWFFT",14) == 125882686) strcat(s, "s");
if (crc32("SiWJLhAS",8) == 795564490) strcat(s, "e");
if (crc32("POvZNkHdm",9) == 28619277) strcat(s, "s");
if (crc32("rjIlfRHrZu",10) == 1946391033) strcat(s, "W");
if (crc32("OqnIsyorvq",10) == 1815238798) strcat(s, "t");
if (crc32("DAWJsBRyJq",10) == 3130986133) strcat(s, "i");
if (crc32("uVwXRD",6) == 2189280954) strcat(s, "d");
if (crc32("iCiYXAljjLwMSTj",15) == 3591391274) strcat(s, "n");
if (crc32("QvMVpCIcckkVKRS",15) == 4215907966) strcat(s, "v");
if (crc32("QpuzcpIA",8) == 2773036529) strcat(s, "a");
if (crc32("qUsyQutNop",10) == 1401004376) strcat(s, "D");
if (crc32("xhHHnNmOFaAq",12) == 3711260410) strcat(s, "t");
if (crc32("lpfaMWsPXQ",10) == 2971464387) strcat(s, "U");
if (crc32("JBfmJ",5) == 4017892789) strcat(s, "i");
if (crc32("xVFQCmjQRYv",11) == 2334489058) strcat(s, "w");
if (crc32("aUsNcBpdnncDg",13) == 512281773) strcat(s, "n");
if (crc32("AmFfb",5) == 2342056172) strcat(s, "F");
if (crc32("NWvHdLb",7) == 5238569) strcat(s, "g");
    return s;
}

char *misapply_verbs() {
    char *s = calloc(9);
    if (crc32("XXxfUZiX",8) == 1320140885) strcat(s, "m");
if (crc32("sUATO",5) == 1715105879) strcat(s, "j");
if (crc32("dyHpfmQwYqH",11) == 3390391716) strcat(s, "i");
if (crc32("pzQziyjMWHZTDd",14) == 287401384) strcat(s, "W");
if (crc32("nJiJGDOanosR",12) == 945484843) strcat(s, "s");
if (crc32("SBFXWSDWUNvZent",15) == 1683172398) strcat(s, "a");
if (crc32("ePTRVRqHqo",10) == 3128626652) strcat(s, "s");
if (crc32("xnfep",5) == 3500967279) strcat(s, "p");
if (crc32("GCizY",5) == 3554817017) strcat(s, "Z");
if (crc32("FvCjYu",6) == 2577827638) strcat(s, "p");
if (crc32("sQzYXjSQJoBadO",14) == 2540897470) strcat(s, "W");
if (crc32("AQEMPk",6) == 3303460105) strcat(s, "l");
if (crc32("OmHWtvDL",8) == 3773694635) strcat(s, "O");
if (crc32("gDzdYbVFMPUzhA",14) == 1786167640) strcat(s, "y");
    return s;
}

char *birdied_verbs() {
    char *s = calloc(8);
    if (crc32("kLtiLoadnp",10) == 1750584692) strcat(s, "q");
if (crc32("SggfhoLVCBC",11) == 4206757022) strcat(s, "b");
if (crc32("HOMzltFpAu",10) == 3316360901) strcat(s, "i");
if (crc32("FCScODPh",8) == 3868054890) strcat(s, "r");
if (crc32("ghpQDabVr",9) == 1041934734) strcat(s, "m");
if (crc32("bxwVHYVuhsjcvH",14) == 2803774950) strcat(s, "d");
if (crc32("CivcM",5) == 2308865190) strcat(s, "i");
if (crc32("KOuRAsy",7) == 2216580085) strcat(s, "j");
if (crc32("ECBcyiMOS",9) == 3351771500) strcat(s, "e");
if (crc32("enGhcTmUhfxF",12) == 1437406922) strcat(s, "d");
    return s;
}

char *heterodyning_verbs() {
    char *s = calloc(13);
    if (crc32("juhEprylqjUjg",13) == 3141533171) strcat(s, "h");
if (crc32("bKZbkXb",7) == 910575592) strcat(s, "d");
if (crc32("AiZoSArDWYCK",12) == 197637096) strcat(s, "e");
if (crc32("rbKdIPeV",8) == 2389798222) strcat(s, "t");
if (crc32("oJcmaS",6) == 3174762226) strcat(s, "e");
if (crc32("Puprk",5) == 1314095109) strcat(s, "T");
if (crc32("EBpEhfXRIJWisKp",15) == 3529105087) strcat(s, "r");
if (crc32("mPejM",5) == 469158743) strcat(s, "o");
if (crc32("DzZuRQjNkfYdHcZ",15) == 3469927586) strcat(s, "o");
if (crc32("ampHTBY",7) == 418928141) strcat(s, "d");
if (crc32("nowbVHpXyJvRnp",14) == 2963986466) strcat(s, "I");
if (crc32("pHPUVmsFP",9) == 1990460443) strcat(s, "y");
if (crc32("VDYWPITIeCfBM",13) == 671349335) strcat(s, "n");
if (crc32("IbSfmaWzXU",10) == 2737731646) strcat(s, "y");
if (crc32("LHTBQt",6) == 1650614359) strcat(s, "i");
if (crc32("oiMScQImRSkXU",13) == 2741532085) strcat(s, "G");
if (crc32("MKZwXj",6) == 120332096) strcat(s, "n");
if (crc32("toJkLYfCRPl",11) == 2013540460) strcat(s, "i");
if (crc32("vRGOmGtB",8) == 481387129) strcat(s, "g");
    return s;
}

char *programming_verbs() {
    char *s = calloc(12);
    if (crc32("VMzpyEFj",8) == 3959308033) strcat(s, "p");
if (crc32("jkcEbVbhrAJQ",12) == 4239461082) strcat(s, "r");
if (crc32("aCIaVkwuqCxnZ",13) == 3787938130) strcat(s, "k");
if (crc32("BsCXxZlzazaxIB",14) == 783773258) strcat(s, "o");
if (crc32("eCaDAqSnIqi",11) == 873254528) strcat(s, "E");
if (crc32("ecXkT",5) == 918753092) strcat(s, "g");
if (crc32("abczPP",6) == 817750202) strcat(s, "r");
if (crc32("LMHjRlCeaCIChkj",15) == 177066935) strcat(s, "a");
if (crc32("huSQcZXRz",9) == 2680703852) strcat(s, "e");
if (crc32("JCjUcQgGtNQ",11) == 2404728618) strcat(s, "m");
if (crc32("xkxao",5) == 3368349898) strcat(s, "u");
if (crc32("VPcUShUan",9) == 1774223549) strcat(s, "m");
if (crc32("MAHGNsy",7) == 1161503333) strcat(s, "i");
if (crc32("dZVJmVczds",10) == 345623107) strcat(s, "n");
if (crc32("npiNl",5) == 3849414416) strcat(s, "g");
if (crc32("pNRxZeqTwHeem",13) == 2066664681) strcat(s, "g");
    return s;
}

char *grew_verbs() {
    char *s = calloc(5);
    if (crc32("dWYJMjQHK",9) == 3770886586) strcat(s, "g");
if (crc32("BURzwXcFO",9) == 1522716381) strcat(s, "r");
if (crc32("VswlaY",6) == 202623361) strcat(s, "e");
if (crc32("nSWmEI",6) == 1750357902) strcat(s, "w");
    return s;
}

char *annotate_verbs() {
    char *s = calloc(9);
    if (crc32("rimizpTuCbqEc",13) == 298266760) strcat(s, "a");
if (crc32("RIUbgorAgKtZX",13) == 2293396150) strcat(s, "n");
if (crc32("bNKfAth",7) == 1750102734) strcat(s, "Z");
if (crc32("ayTpJQQVQVdwiA",14) == 703652269) strcat(s, "n");
if (crc32("oRoRPStTMCsv",12) == 490740401) strcat(s, "G");
if (crc32("IOkFFLUef",9) == 3832053093) strcat(s, "o");
if (crc32("QcxSEPlfQIuJbQ",14) == 3704630969) strcat(s, "p");
if (crc32("WXzmj",5) == 1727706017) strcat(s, "t");
if (crc32("NYRPvtVrqj",10) == 3592468222) strcat(s, "a");
if (crc32("ZNmpwpgvRHSo",12) == 2274689502) strcat(s, "a");
if (crc32("ZaRmjiBFmMCcPwD",15) == 4057121349) strcat(s, "O");
if (crc32("TXlod",5) == 3967768886) strcat(s, "t");
if (crc32("oZkAfqzAuehBjyP",15) == 4178912250) strcat(s, "e");
    return s;
}

char *budgeting_verbs() {
    char *s = calloc(10);
    if (crc32("RtLySIeKwUDnmR",14) == 3328016409) strcat(s, "b");
if (crc32("DMdKuiJfPfxNtve",15) == 1229439504) strcat(s, "u");
if (crc32("DbyOdovJtBTTULb",15) == 943232042) strcat(s, "d");
if (crc32("thRGZEH",7) == 2311865523) strcat(s, "Q");
if (crc32("VWfwf",5) == 2942199459) strcat(s, "g");
if (crc32("kIMuEUqGO",9) == 276231639) strcat(s, "e");
if (crc32("AqXAGaRZaYkGKM",14) == 2495601153) strcat(s, "t");
if (crc32("KAwkR",5) == 2558221692) strcat(s, "i");
if (crc32("qhqusofTbANM",12) == 1198373983) strcat(s, "n");
if (crc32("yxnYWvNEek",10) == 2045301555) strcat(s, "g");
    return s;
}

char *hassled_verbs() {
    char *s = calloc(8);
    if (crc32("GCmIuJqq",8) == 3186919417) strcat(s, "A");
if (crc32("aODYWmFr",8) == 1679231207) strcat(s, "h");
if (crc32("yOSDpyApTtYlDU",14) == 2495950597) strcat(s, "g");
if (crc32("AhQySLdRUs",10) == 1469095416) strcat(s, "a");
if (crc32("TJPsI",5) == 538247388) strcat(s, "v");
if (crc32("TIGwP",5) == 2473438241) strcat(s, "s");
if (crc32("fAmmhAWv",8) == 2269413473) strcat(s, "s");
if (crc32("onoijYAWcTXTZEe",15) == 3415936496) strcat(s, "l");
if (crc32("tqALrKqSsGIdkv",14) == 1070814734) strcat(s, "t");
if (crc32("OjEZPYuWZh",10) == 2886521971) strcat(s, "e");
if (crc32("TNYZPneP",8) == 8429491) strcat(s, "n");
if (crc32("VeuBmsiH",8) == 100282794) strcat(s, "d");
    return s;
}

char *stepdown_verbs() {
    char *s = calloc(9);
    if (crc32("oUVXSbdK",8) == 1398239468) strcat(s, "r");
if (crc32("EsTwhtcFOD",10) == 431357183) strcat(s, "s");
if (crc32("jqbHT",5) == 3654684838) strcat(s, "t");
if (crc32("YfvDEQVIff",10) == 377762469) strcat(s, "z");
if (crc32("SLXgnYjBQmRsgWT",15) == 396081784) strcat(s, "e");
if (crc32("GTrqwKmAj",9) == 905106856) strcat(s, "p");
if (crc32("XUYrhyrKqvpJp",13) == 2482255298) strcat(s, "c");
if (crc32("hcdLiwOnJGiqXqi",15) == 2145324718) strcat(s, "d");
if (crc32("wWuErXVbQnKhCMC",15) == 3722645426) strcat(s, "g");
if (crc32("eAmkZYTl",8) == 416488057) strcat(s, "o");
if (crc32("VYKVot",6) == 3477055616) strcat(s, "w");
if (crc32("yfbgRam",7) == 2032742436) strcat(s, "h");
if (crc32("ukgeMYqztooP",12) == 3356965389) strcat(s, "n");
    return s;
}

char *repropose_verbs() {
    char *s = calloc(10);
    if (crc32("dtMSeMWo",8) == 2215251838) strcat(s, "K");
if (crc32("gECmoK",6) == 4276423080) strcat(s, "r");
if (crc32("MeAyAumzIVAe",12) == 3743032360) strcat(s, "e");
if (crc32("TVFjvoTPbTwDNV",14) == 3056274198) strcat(s, "i");
if (crc32("iLftLbwPfPYsbL",14) == 7161702) strcat(s, "p");
if (crc32("EfkLpmruuEoiG",13) == 4140448199) strcat(s, "W");
if (crc32("BjaYFxlQpKdcXWg",15) == 3911093075) strcat(s, "r");
if (crc32("YaRqyViN",8) == 3693285691) strcat(s, "o");
if (crc32("sJiSnkJYGp",10) == 3426007584) strcat(s, "p");
if (crc32("ESKKsgBiftP",11) == 2576098480) strcat(s, "B");
if (crc32("odqUNQfxKrv",11) == 956706712) strcat(s, "o");
if (crc32("LrXCPKBwY",9) == 3707626106) strcat(s, "s");
if (crc32("PwuAmWF",7) == 2421042194) strcat(s, "e");
    return s;
}

char *Gnosticized_verbs() {
    char *s = calloc(12);
    if (crc32("KpjyDXflx",9) == 1836311733) strcat(s, "G");
if (crc32("dyNzBLWV",8) == 2441263497) strcat(s, "F");
if (crc32("wHiuhHeYsWL",11) == 1159805812) strcat(s, "n");
if (crc32("aPRfocMJapJMQ",13) == 2705030468) strcat(s, "o");
if (crc32("xirOAbSkun",10) == 1527312174) strcat(s, "M");
if (crc32("hsVIzWPnLcYUe",13) == 4233680877) strcat(s, "s");
if (crc32("TJqNtVjCP",9) == 434929607) strcat(s, "t");
if (crc32("aCkgFeVPkiTzrSu",15) == 695363681) strcat(s, "T");
if (crc32("mLQKGWkGRnJYo",13) == 2147991779) strcat(s, "i");
if (crc32("dftKKNMIZVtR",12) == 2315628027) strcat(s, "B");
if (crc32("dmiKhcrQjvLPbKS",15) == 1966080267) strcat(s, "c");
if (crc32("REqYELjNODRI",12) == 2975967913) strcat(s, "L");
if (crc32("XpyMf",5) == 525890929) strcat(s, "i");
if (crc32("gHwWmitaD",9) == 1695867879) strcat(s, "z");
if (crc32("jLvNjGD",7) == 1285565982) strcat(s, "e");
if (crc32("BMtmGYJw",8) == 2064565440) strcat(s, "d");
    return s;
}

char *overchafe_verbs() {
    char *s = calloc(10);
    if (crc32("BBfgJW",6) == 733183317) strcat(s, "s");
if (crc32("JQkpERwtxv",10) == 2282012358) strcat(s, "o");
if (crc32("lzhOvRyAsdAf",12) == 1698168349) strcat(s, "v");
if (crc32("DDIDRCN",7) == 2233515037) strcat(s, "P");
if (crc32("OaqrXQTZ",8) == 3449579202) strcat(s, "e");
if (crc32("vYQeAlDZnJhnON",14) == 2303257304) strcat(s, "J");
if (crc32("IjiPqizcXOWOy",13) == 2002749388) strcat(s, "r");
if (crc32("lBDxxBevEQScjA",14) == 3167440849) strcat(s, "Q");
if (crc32("vtEPhcjYnxqaSl",14) == 2378556222) strcat(s, "c");
if (crc32("DKyAYehNg",9) == 1852273228) strcat(s, "h");
if (crc32("xtIzEfTUMnaFHS",14) == 3652560138) strcat(s, "E");
if (crc32("vLbpWwcuUPBWQtU",15) == 573857420) strcat(s, "a");
if (crc32("dRnHIL",6) == 2614482427) strcat(s, "f");
if (crc32("WGiprvGSQWpy",12) == 26446144) strcat(s, "e");
    return s;
}

char *Judaize_verbs() {
    char *s = calloc(8);
    if (crc32("QIUcO",5) == 3884551919) strcat(s, "J");
if (crc32("VtWkiEhTlyfaxg",14) == 4228347261) strcat(s, "N");
if (crc32("JoqwQ",5) == 2651184276) strcat(s, "u");
if (crc32("JGHWnqrtW",9) == 3996363172) strcat(s, "l");
if (crc32("dgjrCxFNNKDuPNR",15) == 921539330) strcat(s, "d");
if (crc32("UMRrffKJxhRXy",13) == 3052571869) strcat(s, "a");
if (crc32("VcqdOApLqvQpt",13) == 2908957547) strcat(s, "q");
if (crc32("ZUYARVqnVbMVvCS",15) == 1008974064) strcat(s, "i");
if (crc32("QbXNqnam",8) == 968260511) strcat(s, "z");
if (crc32("NtvgHRGtDZhYU",13) == 2410582556) strcat(s, "g");
if (crc32("IiQTRKNaMoo",11) == 2912120952) strcat(s, "e");
    return s;
}

char *actout_verbs() {
    char *s = calloc(7);
    if (crc32("vcmWj",5) == 3185056958) strcat(s, "u");
if (crc32("ZyyeaAnYxuGO",12) == 1752484030) strcat(s, "a");
if (crc32("cbfthts",7) == 335899098) strcat(s, "R");
if (crc32("XgkpehEKNY",10) == 1301401073) strcat(s, "c");
if (crc32("eKfXsNQWHgGZjS",14) == 231061314) strcat(s, "F");
if (crc32("AMAVPGiruXyrJSP",15) == 388578111) strcat(s, "t");
if (crc32("rmtqcvXJxZnWtod",15) == 2861449149) strcat(s, "s");
if (crc32("WnjzXcWN",8) == 3690148716) strcat(s, "o");
if (crc32("FAJDhj",6) == 326728386) strcat(s, "M");
if (crc32("phuEtil",7) == 2878896323) strcat(s, "u");
if (crc32("PhylBOU",7) == 3235045092) strcat(s, "t");
    return s;
}

char *add_verbs() {
    char *s = calloc(4);
    if (crc32("PxxeiG",6) == 1336016572) strcat(s, "E");
if (crc32("FqbdQvBcpVQdXDM",15) == 2557593617) strcat(s, "a");
if (crc32("mgYbeYeY",8) == 2091427507) strcat(s, "i");
if (crc32("EelmFSz",7) == 330942748) strcat(s, "d");
if (crc32("WlIFEQhIiCElEY",14) == 1068083918) strcat(s, "N");
if (crc32("HPCBmvue",8) == 3788554037) strcat(s, "d");
    return s;
}

char *stand_verbs() {
    char *s = calloc(6);
    if (crc32("pzhferlinS",10) == 2145891649) strcat(s, "s");
if (crc32("PHYWXIoR",8) == 1556438404) strcat(s, "s");
if (crc32("uJrvVn",6) == 802142017) strcat(s, "t");
if (crc32("SMwltTtssFE",11) == 3914099761) strcat(s, "V");
if (crc32("RSDrYllktCbN",12) == 3293107121) strcat(s, "a");
if (crc32("fcUGLsy",7) == 1494314083) strcat(s, "n");
if (crc32("seiocUSMssoZIwZ",15) == 252656916) strcat(s, "d");
    return s;
}

char *bookinto_verbs() {
    char *s = calloc(9);
    if (crc32("HjlnwVL",7) == 2635514203) strcat(s, "c");
if (crc32("IEQLdYm",7) == 3498044913) strcat(s, "b");
if (crc32("ZFjApx",6) == 4062479826) strcat(s, "C");
if (crc32("xKPoC",5) == 580504285) strcat(s, "o");
if (crc32("weoGXPCgDceL",12) == 2924765004) strcat(s, "o");
if (crc32("KjXMeB",6) == 963489969) strcat(s, "P");
if (crc32("GQuOUgrYp",9) == 3206769171) strcat(s, "k");
if (crc32("KyCOXGmX",8) == 4123349844) strcat(s, "i");
if (crc32("uyDpj",5) == 2337182288) strcat(s, "l");
if (crc32("urhXgpmhxoieL",13) == 815781117) strcat(s, "n");
if (crc32("nTNnAVvpR",9) == 1610126627) strcat(s, "w");
if (crc32("aKRjbd",6) == 1679372735) strcat(s, "t");
if (crc32("qaKzSMusYkZxTe",14) == 3023206709) strcat(s, "o");
    return s;
}

char *clem_verbs() {
    char *s = calloc(5);
    if (crc32("cdJcYiAIb",9) == 2449743950) strcat(s, "i");
if (crc32("lNwuttsfNgkU",12) == 2091957784) strcat(s, "c");
if (crc32("TGMzRai",7) == 3193743178) strcat(s, "O");
if (crc32("mudhCT",6) == 1900585343) strcat(s, "l");
if (crc32("qRjPIU",6) == 84810869) strcat(s, "n");
if (crc32("QnBQabqjvINxjU",14) == 3572240084) strcat(s, "e");
if (crc32("hVMZVBXqeCejIEA",15) == 2205603563) strcat(s, "h");
if (crc32("jsxxdcag",8) == 2260678206) strcat(s, "m");
    return s;
}

char *ambling_verbs() {
    char *s = calloc(8);
    if (crc32("KCqmcT",6) == 2052344726) strcat(s, "a");
if (crc32("QSAczxj",7) == 3442735118) strcat(s, "m");
if (crc32("YztBixmRkggeZi",14) == 1040101385) strcat(s, "b");
if (crc32("utDzIAhX",8) == 3788426392) strcat(s, "l");
if (crc32("OPFcGPTrgc",10) == 2205101886) strcat(s, "U");
if (crc32("LWzvoff",7) == 646413123) strcat(s, "i");
if (crc32("hCbNfKXf",8) == 83991093) strcat(s, "n");
if (crc32("zJPVAqgVCub",11) == 2719686242) strcat(s, "W");
if (crc32("asvkRpcHFPlHJ",13) == 3928926975) strcat(s, "g");
    return s;
}

char *underdressing_verbs() {
    char *s = calloc(14);
    if (crc32("zPxRFRrsBBbhwc",14) == 495266886) strcat(s, "u");
if (crc32("eUCXBKsbMA",10) == 447705645) strcat(s, "x");
if (crc32("AlRgTxMsvuP",11) == 2974632520) strcat(s, "n");
if (crc32("TknIbE",6) == 1039148891) strcat(s, "d");
if (crc32("ZxjbpQa",7) == 120808632) strcat(s, "c");
if (crc32("jKPxZusckANUov",14) == 1813206403) strcat(s, "e");
if (crc32("SAmYj",5) == 472402806) strcat(s, "r");
if (crc32("oRqrERoJ",8) == 1643298928) strcat(s, "e");
if (crc32("AUpVkT",6) == 1815408078) strcat(s, "d");
if (crc32("diUkHahP",8) == 1291241112) strcat(s, "r");
if (crc32("WHgVNgy",7) == 2094609121) strcat(s, "A");
if (crc32("qtNzpJsKd",9) == 2514010561) strcat(s, "e");
if (crc32("PdzdnpffgIxdOM",14) == 2703741965) strcat(s, "o");
if (crc32("OeJauwY",7) == 3325835347) strcat(s, "s");
if (crc32("eqWPtLc",7) == 506302022) strcat(s, "s");
if (crc32("YuXxtu",6) == 2484515015) strcat(s, "i");
if (crc32("HpyMAVfQoViyF",13) == 2228177929) strcat(s, "n");
if (crc32("mXodZNbLMXMhMoS",15) == 3841839121) strcat(s, "D");
if (crc32("jLtWIBI",7) == 582751530) strcat(s, "g");
    return s;
}

char *reintegrating_verbs() {
    char *s = calloc(14);
    if (crc32("iauTX",5) == 95745944) strcat(s, "o");
if (crc32("zBhZSqDiTct",11) == 2232139991) strcat(s, "r");
if (crc32("ryiEl",5) == 1203761432) strcat(s, "d");
if (crc32("GFzuvCXzGoval",13) == 1662611863) strcat(s, "e");
if (crc32("vYVLjks",7) == 335883942) strcat(s, "U");
if (crc32("hJJFFmcrHTKoz",13) == 1054283247) strcat(s, "i");
if (crc32("aAXIfr",6) == 1925164669) strcat(s, "P");
if (crc32("uqgSFrHmagUbxL",14) == 4292689596) strcat(s, "n");
if (crc32("EzkKsyPDaO",10) == 1154875553) strcat(s, "t");
if (crc32("IQThQiXGrTzn",12) == 1621003153) strcat(s, "t");
if (crc32("VyCKD",5) == 2007368382) strcat(s, "e");
if (crc32("ULYRE",5) == 172347349) strcat(s, "g");
if (crc32("TRMLALWi",8) == 742189152) strcat(s, "J");
if (crc32("Kgyupzl",7) == 2744633168) strcat(s, "r");
if (crc32("LijXlJpW",8) == 1929336007) strcat(s, "a");
if (crc32("iLEmkjtwTUL",11) == 302302610) strcat(s, "t");
if (crc32("yPvcOp",6) == 2566506935) strcat(s, "Q");
if (crc32("UYkFrsMBklca",12) == 603908340) strcat(s, "i");
if (crc32("jnqOgXfDr",9) == 500920232) strcat(s, "n");
if (crc32("gaVXGYM",7) == 765632321) strcat(s, "T");
if (crc32("lNXXzEGABm",10) == 344282417) strcat(s, "g");
    return s;
}

char *fuddling_verbs() {
    char *s = calloc(9);
    if (crc32("nwgMlwJf",8) == 1148350305) strcat(s, "z");
if (crc32("XfzmWuNSMyIn",12) == 2805560636) strcat(s, "f");
if (crc32("xyAbwNsGkGJW",12) == 4130168841) strcat(s, "S");
if (crc32("FvYzwtwUgQTG",12) == 924220971) strcat(s, "u");
if (crc32("exSlHOcqWDIHu",13) == 41899036) strcat(s, "d");
if (crc32("rHmpRsc",7) == 2440985338) strcat(s, "d");
if (crc32("AJCEVI",6) == 2073330588) strcat(s, "d");
if (crc32("fdkuHTjBWvUye",13) == 1327294139) strcat(s, "y");
if (crc32("dzCGfXOKMB",10) == 3435550781) strcat(s, "l");
if (crc32("yioTVsnUyZEHbpv",15) == 3809666744) strcat(s, "C");
if (crc32("OLMbHkcUYI",10) == 811084666) strcat(s, "i");
if (crc32("ruvWrIOgS",9) == 3239643205) strcat(s, "k");
if (crc32("tyAOsgBThIMIrtW",15) == 2005760822) strcat(s, "n");
if (crc32("NrjNavTEQlDyMPA",15) == 646105498) strcat(s, "V");
if (crc32("FHmhWLgW",8) == 284521885) strcat(s, "g");
    return s;
}

char *thresh_verbs() {
    char *s = calloc(7);
    if (crc32("jzluLplD",8) == 1250865174) strcat(s, "A");
if (crc32("PFdwfKBQ",8) == 1944689508) strcat(s, "t");
if (crc32("bKDcjjRWgK",10) == 223965658) strcat(s, "G");
if (crc32("wtjBSgL",7) == 4255375716) strcat(s, "h");
if (crc32("fCQFzMobHtf",11) == 3425182287) strcat(s, "r");
if (crc32("YVULOp",6) == 2833990864) strcat(s, "N");
if (crc32("UQJxhWWqQRohy",13) == 1344472514) strcat(s, "e");
if (crc32("CCkNjjxq",8) == 1240249655) strcat(s, "t");
if (crc32("KhiencEZDirO",12) == 287742281) strcat(s, "s");
if (crc32("wbGBnX",6) == 2936282674) strcat(s, "h");
    return s;
}

char *depopulating_verbs() {
    char *s = calloc(13);
    if (crc32("zFfdAyp",7) == 1910706087) strcat(s, "d");
if (crc32("wiGxBrCprMKT",12) == 4205688630) strcat(s, "Q");
if (crc32("sKeXNRYfDWpd",12) == 2397568993) strcat(s, "e");
if (crc32("ETPIxxKMGDOKnQX",15) == 1240631729) strcat(s, "s");
if (crc32("KyDbGLHDRrgvlyG",15) == 1304312064) strcat(s, "p");
if (crc32("LsPOyjTBh",9) == 2857251975) strcat(s, "b");
if (crc32("BRkXwJoqDAiIRi",14) == 3945173849) strcat(s, "o");
if (crc32("wZKhFEAppYyJTM",14) == 1265996903) strcat(s, "p");
if (crc32("OwKsKqFB",8) == 1644378907) strcat(s, "H");
if (crc32("ZlFgpht",7) == 3120625711) strcat(s, "u");
if (crc32("ZfJBv",5) == 3952096800) strcat(s, "F");
if (crc32("GUTCOhCJvCjUGgS",15) == 4154706201) strcat(s, "l");
if (crc32("NsLFLPl",7) == 2511018732) strcat(s, "A");
if (crc32("OJFBRYnEPVtuW",13) == 1534353947) strcat(s, "a");
if (crc32("FPxLm",5) == 4021383506) strcat(s, "t");
if (crc32("hzruqq",6) == 879859928) strcat(s, "M");
if (crc32("uQSRqiVbmHuFGh",14) == 1849247406) strcat(s, "i");
if (crc32("EZajRxuC",8) == 363558226) strcat(s, "n");
if (crc32("xPWCkiCMhVIchZ",14) == 247755207) strcat(s, "O");
if (crc32("DzjwDAUpPbPq",12) == 4058496369) strcat(s, "g");
    return s;
}

char *refiled_verbs() {
    char *s = calloc(8);
    if (crc32("nOXkx",5) == 1608612982) strcat(s, "x");
if (crc32("iyLFMDbLDgMAa",13) == 917073448) strcat(s, "r");
if (crc32("lIuGATBmexPm",12) == 3413098530) strcat(s, "X");
if (crc32("CtwbjRz",7) == 3757839640) strcat(s, "e");
if (crc32("IJBSKGhGe",9) == 2082210132) strcat(s, "c");
if (crc32("GSMvumJoShxX",12) == 2429910737) strcat(s, "f");
if (crc32("VoEUryhXqQICVEK",15) == 2048018775) strcat(s, "S");
if (crc32("oBxuXSMfGNDBZp",14) == 1112929397) strcat(s, "i");
if (crc32("NaBth",5) == 348066826) strcat(s, "U");
if (crc32("NQLWVj",6) == 2018804192) strcat(s, "l");
if (crc32("dRdVobYqDbc",11) == 3891197668) strcat(s, "Y");
if (crc32("ilLIi",5) == 1336275854) strcat(s, "e");
if (crc32("RQormF",6) == 2385200128) strcat(s, "d");
    return s;
}

char *solidified_verbs() {
    char *s = calloc(11);
    if (crc32("WBsqfnMObu",10) == 3176493258) strcat(s, "s");
if (crc32("offergcrPOf",11) == 219075497) strcat(s, "o");
if (crc32("RwIIYRPKSOI",11) == 2385840138) strcat(s, "l");
if (crc32("AfGAM",5) == 690419223) strcat(s, "i");
if (crc32("IPKjIWJ",7) == 661736526) strcat(s, "d");
if (crc32("kIeinApMdGL",11) == 2736835162) strcat(s, "i");
if (crc32("gtEPdhtNsx",10) == 3253007714) strcat(s, "f");
if (crc32("EuBSfZ",6) == 2937269243) strcat(s, "s");
if (crc32("rcTLZjsUP",9) == 353415671) strcat(s, "i");
if (crc32("xSZGzdSFajKtRAC",15) == 1957776712) strcat(s, "e");
if (crc32("iZyTyLroS",9) == 4267941947) strcat(s, "s");
if (crc32("sxJbexTtn",9) == 2153833330) strcat(s, "d");
    return s;
}

char *redecline_verbs() {
    char *s = calloc(10);
    if (crc32("jdlFS",5) == 3514834727) strcat(s, "m");
if (crc32("MejDhTMZqIRU",12) == 2610225104) strcat(s, "r");
if (crc32("VuxGKnHAR",9) == 679439538) strcat(s, "e");
if (crc32("dLSif",5) == 88491391) strcat(s, "d");
if (crc32("lUqUMNZJ",8) == 2954699597) strcat(s, "l");
if (crc32("MbKMhTlDTXiy",12) == 701627910) strcat(s, "e");
if (crc32("CyaZPqnbt",9) == 2611453711) strcat(s, "c");
if (crc32("wXRdBsfk",8) == 827509185) strcat(s, "M");
if (crc32("gOwAiqlmZlRM",12) == 1096934607) strcat(s, "l");
if (crc32("EVXrJxTcSZT",11) == 4275020650) strcat(s, "i");
if (crc32("VXwGHDD",7) == 3032441645) strcat(s, "q");
if (crc32("KwoaaZPgAlGHm",13) == 723835666) strcat(s, "n");
if (crc32("wbMAZKCu",8) == 714041077) strcat(s, "e");
    return s;
}

char *built_verbs() {
    char *s = calloc(6);
    if (crc32("SspIKEJDRPxzgR",14) == 3750222463) strcat(s, "b");
if (crc32("twHMMgFAGT",10) == 3412431093) strcat(s, "t");
if (crc32("aOYHnqsDuUikLE",14) == 3731495658) strcat(s, "u");
if (crc32("EUFPwwTyOO",10) == 3169011505) strcat(s, "i");
if (crc32("pDPAP",5) == 1578597602) strcat(s, "p");
if (crc32("HQsBbvnowEqp",12) == 3420598907) strcat(s, "l");
if (crc32("NgYgaUQe",8) == 1613713172) strcat(s, "u");
if (crc32("ZrgYLDp",7) == 2091164065) strcat(s, "t");
    return s;
}

char *reacclimating_verbs() {
    char *s = calloc(14);
    if (crc32("JHtkVMInzae",11) == 3616309904) strcat(s, "k");
if (crc32("QaQVHSnDpuTrqGX",15) == 3313393564) strcat(s, "r");
if (crc32("ootjknpCRLNTl",13) == 4181353606) strcat(s, "e");
if (crc32("gKLAVOoIIWnBI",13) == 3092045411) strcat(s, "a");
if (crc32("zwMKYw",6) == 3760214936) strcat(s, "c");
if (crc32("EawEvlTk",8) == 2760135541) strcat(s, "c");
if (crc32("DPuUKFohFe",10) == 2676130017) strcat(s, "l");
if (crc32("wQCRwCBPXZmNzxD",15) == 2480642175) strcat(s, "e");
if (crc32("yyVfGjRh",8) == 3943649763) strcat(s, "i");
if (crc32("yCMYH",5) == 4046396289) strcat(s, "m");
if (crc32("wfemNKaEGSZ",11) == 733207659) strcat(s, "m");
if (crc32("MeNmknLXBkDiuaS",15) == 2620656426) strcat(s, "a");
if (crc32("GPXSeGLr",8) == 4055401661) strcat(s, "f");
if (crc32("SSSByiJlFOAed",13) == 2967661223) strcat(s, "t");
if (crc32("wiBNjzZyZqL",11) == 1173556245) strcat(s, "x");
if (crc32("YsRXr",5) == 704276551) strcat(s, "i");
if (crc32("qkanKdASCVVR",12) == 635869876) strcat(s, "n");
if (crc32("hXfjWPRmJbo",11) == 3551089969) strcat(s, "g");
    return s;
}

char *threshout_verbs() {
    char *s = calloc(10);
    if (crc32("IPfPVwlTKeWTw",13) == 3730807749) strcat(s, "h");
if (crc32("DEkCOJiw",8) == 1736630444) strcat(s, "t");
if (crc32("LHeoqurw",8) == 385917683) strcat(s, "K");
if (crc32("mHprVYd",7) == 3849708508) strcat(s, "h");
if (crc32("QNDVXZeroKv",11) == 2253979360) strcat(s, "r");
if (crc32("SOwTBj",6) == 3730673183) strcat(s, "F");
if (crc32("rcMYvYqp",8) == 4241782784) strcat(s, "e");
if (crc32("mACdfyDEfaJCRu",14) == 1107450446) strcat(s, "s");
if (crc32("MVGIqo",6) == 670458063) strcat(s, "h");
if (crc32("tjrHcvcB",8) == 614950974) strcat(s, "J");
if (crc32("mhqvYwXZTcwVSVp",15) == 1309184724) strcat(s, "o");
if (crc32("mVdTyhFxPoL",11) == 3103083129) strcat(s, "k");
if (crc32("oHtNPIiZJaa",11) == 3033570711) strcat(s, "u");
if (crc32("nOPVkV",6) == 4272036636) strcat(s, "t");
    return s;
}

char *harangued_verbs() {
    char *s = calloc(10);
    if (crc32("MDktK",5) == 2400655096) strcat(s, "P");
if (crc32("EgLCrUubjPMqPO",14) == 3739961923) strcat(s, "h");
if (crc32("BaSSKHlLEwLrt",13) == 352647558) strcat(s, "a");
if (crc32("CnuSFcsmu",9) == 139809310) strcat(s, "S");
if (crc32("dociyt",6) == 4274377643) strcat(s, "r");
if (crc32("SObPT",5) == 3876117914) strcat(s, "a");
if (crc32("temJqiqh",8) == 1899151272) strcat(s, "V");
if (crc32("BLlsEnnsV",9) == 642178724) strcat(s, "n");
if (crc32("whqSeajCGQyaIY",14) == 1732516153) strcat(s, "g");
if (crc32("FXQVVKpala",10) == 1141777782) strcat(s, "u");
if (crc32("hMkHiXXlnX",10) == 35659567) strcat(s, "e");
if (crc32("MbsuojEXLpe",11) == 2945132908) strcat(s, "d");
    return s;
}

char *crystallized_verbs() {
    char *s = calloc(13);
    if (crc32("IPmgRoK",7) == 3950087883) strcat(s, "c");
if (crc32("AQlTkj",6) == 3953286215) strcat(s, "B");
if (crc32("OjUFTMmklU",10) == 395370070) strcat(s, "r");
if (crc32("dNGcwOVCDGnb",12) == 1811369908) strcat(s, "F");
if (crc32("moLRZqUuWpENNK",14) == 2378170021) strcat(s, "y");
if (crc32("ilGLCC",6) == 2570154915) strcat(s, "m");
if (crc32("PgiNxs",6) == 2224998706) strcat(s, "s");
if (crc32("JZZmGc",6) == 3802005846) strcat(s, "t");
if (crc32("vpnBM",5) == 1407497326) strcat(s, "a");
if (crc32("SlmgMdzuwRJap",13) == 2387898929) strcat(s, "T");
if (crc32("RoouJC",6) == 1071256200) strcat(s, "l");
if (crc32("CuMYBNuOSsJ",11) == 772740992) strcat(s, "W");
if (crc32("LpUifEVWEGa",11) == 324741282) strcat(s, "l");
if (crc32("ywJYuortFolQbm",14) == 1416593475) strcat(s, "i");
if (crc32("bxCicCUAmbCSbp",14) == 3712567460) strcat(s, "Q");
if (crc32("UgXJg",5) == 735007840) strcat(s, "z");
if (crc32("GKnoTDKmV",9) == 4250340231) strcat(s, "e");
if (crc32("yWsoIRXQei",10) == 2237899327) strcat(s, "d");
    return s;
}

char *electroplating_verbs() {
    char *s = calloc(15);
    if (crc32("fjanDNgQOAibnxF",15) == 2897750078) strcat(s, "o");
if (crc32("tnwhPb",6) == 2925033669) strcat(s, "e");
if (crc32("BVANDsN",7) == 1754426765) strcat(s, "l");
if (crc32("RYymfqnMub",10) == 3249686254) strcat(s, "K");
if (crc32("GoqJtjXBxR",10) == 3231849501) strcat(s, "e");
if (crc32("lGJRlhg",7) == 2405393386) strcat(s, "c");
if (crc32("IygQE",5) == 430392875) strcat(s, "s");
if (crc32("Zzkpkyy",7) == 2785775110) strcat(s, "t");
if (crc32("mtwwAw",6) == 2309981955) strcat(s, "r");
if (crc32("AQWYWLKvr",9) == 3718393155) strcat(s, "o");
if (crc32("KNHwXaeb",8) == 1367515876) strcat(s, "o");
if (crc32("HPscRGeRxKjycZ",14) == 434587764) strcat(s, "p");
if (crc32("MXsjmnilFIor",12) == 1524624816) strcat(s, "v");
if (crc32("Lydle",5) == 4132995011) strcat(s, "l");
if (crc32("fgTCd",5) == 1050112201) strcat(s, "y");
if (crc32("aLgbrVDG",8) == 3647020969) strcat(s, "a");
if (crc32("xxSdopG",7) == 1832660126) strcat(s, "o");
if (crc32("wkDAowMeR",9) == 2200782828) strcat(s, "t");
if (crc32("mOAlqdhNYLM",11) == 3991156996) strcat(s, "i");
if (crc32("tqAazQmV",8) == 4250043295) strcat(s, "d");
if (crc32("yaEWutDrL",9) == 1634715699) strcat(s, "n");
if (crc32("VrWrqjlC",8) == 2942030404) strcat(s, "g");
    return s;
}

char *mislay_verbs() {
    char *s = calloc(7);
    if (crc32("UkGpzcNlFiSiVpb",15) == 1697054875) strcat(s, "j");
if (crc32("XdaJXyNmLA",10) == 3325098534) strcat(s, "m");
if (crc32("zWCzgGPS",8) == 712638187) strcat(s, "A");
if (crc32("gysTEaBk",8) == 2066311448) strcat(s, "i");
if (crc32("UuJvQHcDRy",10) == 1633934257) strcat(s, "s");
if (crc32("VBLBnUCYrTCDpD",14) == 1545933120) strcat(s, "l");
if (crc32("MQYOMvfMFsRpl",13) == 2318470738) strcat(s, "l");
if (crc32("pXpbYNGiiLMHx",13) == 1110970739) strcat(s, "e");
if (crc32("qRPRuCwZRKGE",12) == 1355436927) strcat(s, "a");
if (crc32("Ijwmc",5) == 2450293151) strcat(s, "y");
    return s;
}

char *defecated_verbs() {
    char *s = calloc(10);
    if (crc32("KmndtqrSxNHt",12) == 1751384604) strcat(s, "W");
if (crc32("fXgHEmQtYc",10) == 4203690756) strcat(s, "d");
if (crc32("RmESZ",5) == 4125973745) strcat(s, "V");
if (crc32("OLdqWYmBUdgmO",13) == 2463237568) strcat(s, "e");
if (crc32("KXykjwBcAQTdUy",14) == 3784832673) strcat(s, "f");
if (crc32("UloYWYsXRQgYgT",14) == 3483371898) strcat(s, "e");
if (crc32("pxUmHuJxT",9) == 3520776466) strcat(s, "j");
if (crc32("IHvXscpP",8) == 2252539246) strcat(s, "c");
if (crc32("eCTSvqC",7) == 2957998140) strcat(s, "V");
if (crc32("dfwWxnrttMDRRP",14) == 3298732444) strcat(s, "a");
if (crc32("QiKouTjRTSbuR",13) == 916165930) strcat(s, "t");
if (crc32("APOFCpcUHtc",11) == 3741411522) strcat(s, "i");
if (crc32("qxttzz",6) == 1790651088) strcat(s, "e");
if (crc32("nCFgt",5) == 4030011256) strcat(s, "v");
if (crc32("LbeHnmCzlof",11) == 4244650790) strcat(s, "d");
    return s;
}

char *broaden_verbs() {
    char *s = calloc(8);
    if (crc32("hQnIbZwXK",9) == 4000338476) strcat(s, "b");
if (crc32("oBtqIPCpdyk",11) == 2047187049) strcat(s, "a");
if (crc32("cofZkcOfwhB",11) == 3468014690) strcat(s, "r");
if (crc32("cSzSJCYPcAv",11) == 3281710633) strcat(s, "o");
if (crc32("jpOXFjra",8) == 3801058351) strcat(s, "a");
if (crc32("ARbsUmzS",8) == 1417668379) strcat(s, "d");
if (crc32("KbBIsnyq",8) == 1816839507) strcat(s, "a");
if (crc32("kwxVlFhmjGwv",12) == 3424045295) strcat(s, "e");
if (crc32("BATTolIN",8) == 607980052) strcat(s, "n");
    return s;
}

char *swept_verbs() {
    char *s = calloc(6);
    if (crc32("WwovaJxeBE",10) == 1968347255) strcat(s, "h");
if (crc32("rdrXqEHmgfFMYY",14) == 1058761294) strcat(s, "s");
if (crc32("djgud",5) == 2869216416) strcat(s, "w");
if (crc32("lxXyCe",6) == 2296625094) strcat(s, "E");
if (crc32("vtQtSnXAwbYN",12) == 3339225530) strcat(s, "e");
if (crc32("qGEVUKwDNLfSRf",14) == 3638278911) strcat(s, "C");
if (crc32("hcfGGMiD",8) == 1392734577) strcat(s, "p");
if (crc32("uDjulsonRttss",13) == 3593556544) strcat(s, "t");
    return s;
}

char *festinated_verbs() {
    char *s = calloc(11);
    if (crc32("aClHabAsrx",10) == 3213222038) strcat(s, "L");
if (crc32("YETIJPtaLnpEmX",14) == 1647839039) strcat(s, "f");
if (crc32("iQLcg",5) == 496229601) strcat(s, "t");
if (crc32("AsZLVxabsfL",11) == 1879208149) strcat(s, "e");
if (crc32("SthJOiRZwdyNBM",14) == 964050972) strcat(s, "s");
if (crc32("fXOwcKAAFf",10) == 3737788710) strcat(s, "t");
if (crc32("OPiZQV",6) == 604398994) strcat(s, "f");
if (crc32("AzctTiAELsZ",11) == 399174690) strcat(s, "i");
if (crc32("wPACksEwvr",10) == 4089603914) strcat(s, "n");
if (crc32("MctfunF",7) == 305418452) strcat(s, "a");
if (crc32("BJQKnHoWAo",10) == 3706284383) strcat(s, "i");
if (crc32("sQiOZvS",7) == 977790613) strcat(s, "t");
if (crc32("knvbF",5) == 1798424595) strcat(s, "e");
if (crc32("QDURcvOaAY",10) == 2461906790) strcat(s, "S");
if (crc32("acvkPXcYwisOd",13) == 3210124800) strcat(s, "d");
    return s;
}

char *metabolize_verbs() {
    char *s = calloc(11);
    if (crc32("defpXcGxFKSJpco",15) == 2555925677) strcat(s, "W");
if (crc32("hKJishDEmwlg",12) == 3314182221) strcat(s, "m");
if (crc32("ygLFWijcjmMvkmA",15) == 2084141250) strcat(s, "l");
if (crc32("wEZKKRn",7) == 2345186298) strcat(s, "e");
if (crc32("YAEXJAGUWj",10) == 1358106068) strcat(s, "l");
if (crc32("xICxawz",7) == 1121937016) strcat(s, "t");
if (crc32("EprZPBMTtt",10) == 342327216) strcat(s, "n");
if (crc32("QrMxnU",6) == 652317444) strcat(s, "a");
if (crc32("huMlRVe",7) == 140287859) strcat(s, "w");
if (crc32("EEOjwYP",7) == 190713788) strcat(s, "b");
if (crc32("NAzrmtnqKbvI",12) == 887645403) strcat(s, "n");
if (crc32("iSvjaZXSohbK",12) == 2326139035) strcat(s, "o");
if (crc32("ZiRpzhAopE",10) == 430899337) strcat(s, "i");
if (crc32("fJQhEXS",7) == 3598265861) strcat(s, "l");
if (crc32("OQXuzbqAY",9) == 503213008) strcat(s, "b");
if (crc32("NhNTmiP",7) == 1359543257) strcat(s, "i");
if (crc32("WKXZPJxyez",10) == 3299266701) strcat(s, "y");
if (crc32("GcmZEhXvpAnI",12) == 2484045193) strcat(s, "z");
if (crc32("VYyfKKmf",8) == 1042365234) strcat(s, "e");
    return s;
}

char *commuted_verbs() {
    char *s = calloc(9);
    if (crc32("XUGrCNO",7) == 1787071147) strcat(s, "v");
if (crc32("augPzzDWDGLf",12) == 4109537041) strcat(s, "c");
if (crc32("xrlSOMaSLunN",12) == 1720368490) strcat(s, "a");
if (crc32("rHvvcArYbHeTJOm",15) == 630024821) strcat(s, "o");
if (crc32("AgAYRlcXujKv",12) == 1881475101) strcat(s, "V");
if (crc32("zdzWWdK",7) == 717610156) strcat(s, "m");
if (crc32("TALeF",5) == 267206831) strcat(s, "v");
if (crc32("csxuIkENE",9) == 2190077703) strcat(s, "m");
if (crc32("gECdvWxM",8) == 2221772028) strcat(s, "u");
if (crc32("kyiLFPd",7) == 3853083477) strcat(s, "f");
if (crc32("uKyypSXX",8) == 224821574) strcat(s, "t");
if (crc32("tWUDooBwpiTYCUZ",15) == 225435243) strcat(s, "e");
if (crc32("JbcXAFQwR",9) == 913378149) strcat(s, "d");
    return s;
}

char *trotted_verbs() {
    char *s = calloc(8);
    if (crc32("RXDwXEu",7) == 364932167) strcat(s, "y");
if (crc32("tCLEfwl",7) == 1433287443) strcat(s, "t");
if (crc32("DiFiBmlu",8) == 63803352) strcat(s, "r");
if (crc32("oZdTuX",6) == 3536484619) strcat(s, "o");
if (crc32("PhMvbGE",7) == 3997138323) strcat(s, "z");
if (crc32("OEaRrlYQEW",10) == 157771670) strcat(s, "t");
if (crc32("usmseBccZtSvS",13) == 2639047624) strcat(s, "G");
if (crc32("OBqTB",5) == 1051333304) strcat(s, "t");
if (crc32("NmeHGGXLuusJrY",14) == 1368870606) strcat(s, "R");
if (crc32("jORvaVBK",8) == 1769254370) strcat(s, "e");
if (crc32("dRxPKyrqH",9) == 273576354) strcat(s, "v");
if (crc32("gJwYjAul",8) == 1339858031) strcat(s, "d");
    return s;
}

char *overintellectualizing_verbs() {
    char *s = calloc(22);
    if (crc32("hrajxRAcW",9) == 155762033) strcat(s, "o");
if (crc32("AUFlkeKtQ",9) == 2736885750) strcat(s, "v");
if (crc32("JfjzLRmpcIPRpbW",15) == 3164595373) strcat(s, "H");
if (crc32("BeXLXuYle",9) == 632917200) strcat(s, "e");
if (crc32("DRdTKGb",7) == 949264311) strcat(s, "v");
if (crc32("PORiwjijHdIkC",13) == 3788587677) strcat(s, "r");
if (crc32("zSvOB",5) == 330811563) strcat(s, "i");
if (crc32("mxbcmMtQLvi",11) == 728221874) strcat(s, "n");
if (crc32("GoGAPHBx",8) == 326861419) strcat(s, "P");
if (crc32("umKIBAR",7) == 1097881003) strcat(s, "t");
if (crc32("lNBrLCIaH",9) == 2587826635) strcat(s, "e");
if (crc32("MQcLxmugKSzvfOO",15) == 828939135) strcat(s, "l");
if (crc32("LZWmwkPB",8) == 2090857613) strcat(s, "l");
if (crc32("VDmLDn",6) == 1219832292) strcat(s, "e");
if (crc32("BuBOpQhciwCUs",13) == 4098774658) strcat(s, "k");
if (crc32("ionuK",5) == 3226138357) strcat(s, "c");
if (crc32("KFVmAx",6) == 440105378) strcat(s, "t");
if (crc32("SPulofGvj",9) == 1814063633) strcat(s, "g");
if (crc32("fcCClvAwfwCy",12) == 3714763384) strcat(s, "u");
if (crc32("ZxMIprxZ",8) == 3363101207) strcat(s, "a");
if (crc32("hbJFH",5) == 1851884915) strcat(s, "T");
if (crc32("WESYpibjhZsMNiV",15) == 2094962016) strcat(s, "l");
if (crc32("PBbZuKiYWBZ",11) == 2861406958) strcat(s, "l");
if (crc32("VHTDlOSIGkgKRy",14) == 4144987086) strcat(s, "i");
if (crc32("slbHaRptHs",10) == 3754322285) strcat(s, "J");
if (crc32("BfxjWVuZBMPMct",14) == 1054232961) strcat(s, "z");
if (crc32("uuwlWhDI",8) == 614229522) strcat(s, "w");
if (crc32("TXQHI",5) == 1607909861) strcat(s, "i");
if (crc32("amXoUBtDtFVC",12) == 1368459409) strcat(s, "Y");
if (crc32("akAlSJnu",8) == 397430550) strcat(s, "n");
if (crc32("ThBZcplYkt",10) == 3969767783) strcat(s, "g");
    return s;
}

char *bibbing_verbs() {
    char *s = calloc(8);
    if (crc32("ayfLf",5) == 1553291320) strcat(s, "h");
if (crc32("cepGDznLB",9) == 3397358849) strcat(s, "b");
if (crc32("tFUCnGCJhsYTq",13) == 4037715794) strcat(s, "i");
if (crc32("KPqId",5) == 475775629) strcat(s, "b");
if (crc32("EexLtgbTtR",10) == 4278068245) strcat(s, "b");
if (crc32("oAqnfIFsFxpSm",13) == 3991033962) strcat(s, "l");
if (crc32("dwQOjEex",8) == 1638118887) strcat(s, "i");
if (crc32("pxxHujASfZ",10) == 3471158898) strcat(s, "r");
if (crc32("RWAycxydEhg",11) == 2137109638) strcat(s, "n");
if (crc32("DEMKwr",6) == 3320751678) strcat(s, "r");
if (crc32("SQFFIoS",7) == 1308859495) strcat(s, "g");
    return s;
}

char *preevaporating_verbs() {
    char *s = calloc(15);
    if (crc32("kYWLuCy",7) == 3290043877) strcat(s, "p");
if (crc32("QVksgo",6) == 3328206573) strcat(s, "Z");
if (crc32("OBbWdttHBwPCLNl",15) == 2698806649) strcat(s, "r");
if (crc32("nfsUUlREY",9) == 2490176664) strcat(s, "e");
if (crc32("WztwzOySSIGXYLR",15) == 3599164505) strcat(s, "W");
if (crc32("nMTygHL",7) == 617964154) strcat(s, "e");
if (crc32("OSUfaSZ",7) == 414605241) strcat(s, "v");
if (crc32("SJSnlbVKsM",10) == 4163359090) strcat(s, "a");
if (crc32("lrCOeKMzkiIULq",14) == 1061911672) strcat(s, "p");
if (crc32("darYcgJfLUW",11) == 4202934084) strcat(s, "O");
if (crc32("KCUYyivXBFvHQi",14) == 3405754422) strcat(s, "o");
if (crc32("iUguIhUF",8) == 117649967) strcat(s, "r");
if (crc32("sgcJixxFutoBE",13) == 3485479433) strcat(s, "a");
if (crc32("amvvmiG",7) == 545862186) strcat(s, "t");
if (crc32("quAVrzLZFIn",11) == 162554700) strcat(s, "i");
if (crc32("BzBRbl",6) == 232438932) strcat(s, "n");
if (crc32("RKthIfteHd",10) == 2119933631) strcat(s, "R");
if (crc32("kEgvwWAvvhFd",12) == 597013918) strcat(s, "g");
    return s;
}

char *stapling_verbs() {
    char *s = calloc(9);
    if (crc32("KTZOrdkLGyW",11) == 2420482790) strcat(s, "s");
if (crc32("YwjbsL",6) == 3036802020) strcat(s, "t");
if (crc32("xfUJv",5) == 2394189992) strcat(s, "H");
if (crc32("NTmrfPYWVl",10) == 3992172359) strcat(s, "a");
if (crc32("CpHttzdRRpQJT",13) == 232201324) strcat(s, "X");
if (crc32("CoEFDdZ",7) == 3271421592) strcat(s, "p");
if (crc32("UCpoe",5) == 876399258) strcat(s, "l");
if (crc32("cnAvqGRxH",9) == 4033825370) strcat(s, "w");
if (crc32("FeoVLY",6) == 2082401505) strcat(s, "i");
if (crc32("XeoMxMPgH",9) == 627527697) strcat(s, "j");
if (crc32("kLqibCD",7) == 258865793) strcat(s, "n");
if (crc32("kZGokVJv",8) == 1373593267) strcat(s, "g");
    return s;
}

char *transude_verbs() {
    char *s = calloc(9);
    if (crc32("apSXIKRSkFxQwD",14) == 1643827867) strcat(s, "a");
if (crc32("vxCJp",5) == 913608491) strcat(s, "t");
if (crc32("REfLQri",7) == 1706307789) strcat(s, "a");
if (crc32("ESkZuserAojlLZg",15) == 1939324031) strcat(s, "r");
if (crc32("yHucFrmuKgcsjCA",15) == 3288143418) strcat(s, "a");
if (crc32("qJjQVQ",6) == 2421182296) strcat(s, "u");
if (crc32("BfQfmNuxICEtJW",14) == 4262732171) strcat(s, "n");
if (crc32("NHzYi",5) == 2033234816) strcat(s, "s");
if (crc32("WigytTvkwG",10) == 3831737264) strcat(s, "i");
if (crc32("BrPLdaYk",8) == 2829646282) strcat(s, "u");
if (crc32("nmoxFQL",7) == 4022013041) strcat(s, "d");
if (crc32("cWTtLEGcEGpDZj",14) == 3911465322) strcat(s, "e");
    return s;
}

char *outsell_verbs() {
    char *s = calloc(8);
    if (crc32("oUhCb",5) == 532639291) strcat(s, "o");
if (crc32("LwvuAagj",8) == 871402596) strcat(s, "u");
if (crc32("hNeSslfOeQNS",12) == 981331641) strcat(s, "t");
if (crc32("GzrvmMHl",8) == 451104583) strcat(s, "z");
if (crc32("Dkyalrl",7) == 545482518) strcat(s, "s");
if (crc32("wsSusYDcy",9) == 19615054) strcat(s, "e");
if (crc32("ZdPwNZ",6) == 3859533258) strcat(s, "V");
if (crc32("gBEdauUbkyKFz",13) == 3593436116) strcat(s, "l");
if (crc32("sVnKMYizWrIDnR",14) == 2874625455) strcat(s, "P");
if (crc32("rvEAcILLHPMP",12) == 1653034087) strcat(s, "l");
    return s;
}

char *attacca_verbs() {
    char *s = calloc(8);
    if (crc32("qMHaHRUxHrzq",12) == 1061650969) strcat(s, "a");
if (crc32("OycXHGAZOB",10) == 2415349953) strcat(s, "O");
if (crc32("FPBvVngR",8) == 2666608720) strcat(s, "t");
if (crc32("AItQeH",6) == 3381356382) strcat(s, "t");
if (crc32("snaPHhvENWOJLhy",15) == 3596293769) strcat(s, "i");
if (crc32("wMuwMzKP",8) == 3196606888) strcat(s, "a");
if (crc32("YdBJJcf",7) == 4191320377) strcat(s, "c");
if (crc32("oLormZa",7) == 1376818294) strcat(s, "l");
if (crc32("eEvsLNdgycJQ",12) == 3329163520) strcat(s, "c");
if (crc32("SVwvdNIS",8) == 2208492363) strcat(s, "a");
    return s;
}

char *acidulate_verbs() {
    char *s = calloc(10);
    if (crc32("smVsl",5) == 1865801018) strcat(s, "W");
if (crc32("cZgrjWgMtkErp",13) == 1359158579) strcat(s, "a");
if (crc32("KpApyoCS",8) == 463622683) strcat(s, "s");
if (crc32("kmpTmy",6) == 1263736644) strcat(s, "c");
if (crc32("VMdYsEfL",8) == 3182240830) strcat(s, "v");
if (crc32("BDeJUofWovNYSqT",15) == 3090649652) strcat(s, "i");
if (crc32("Dajrgt",6) == 4284699704) strcat(s, "d");
if (crc32("dyLmaLcDjncr",12) == 129181439) strcat(s, "A");
if (crc32("YEWJPKlNqe",10) == 2930968554) strcat(s, "u");
if (crc32("MGutcEa",7) == 2192062096) strcat(s, "l");
if (crc32("nYQHUhqLuhwU",12) == 325173953) strcat(s, "a");
if (crc32("TapGUZbqBKYNCH",14) == 3167104910) strcat(s, "s");
if (crc32("fTSAQ",5) == 264987338) strcat(s, "t");
if (crc32("ylJYtfnkLfGcMwf",15) == 2388455068) strcat(s, "e");
    return s;
}

char *regurgitating_verbs() {
    char *s = calloc(14);
    if (crc32("dyjWuvH",7) == 640821357) strcat(s, "W");
if (crc32("rnkBhnaosp",10) == 2367798321) strcat(s, "r");
if (crc32("AmXQbhdbmPg",11) == 607069975) strcat(s, "e");
if (crc32("OioOO",5) == 2292581338) strcat(s, "g");
if (crc32("pWOyOFHl",8) == 3993563808) strcat(s, "u");
if (crc32("hOkmNvTI",8) == 765359898) strcat(s, "r");
if (crc32("RjGaxZLggocaB",13) == 2594492148) strcat(s, "g");
if (crc32("WpJWWQvtwo",10) == 2733198734) strcat(s, "i");
if (crc32("iIDCtUs",7) == 330138054) strcat(s, "M");
if (crc32("MMhbeQbZnb",10) == 1303923925) strcat(s, "t");
if (crc32("lzLvzvyMIr",10) == 2444810593) strcat(s, "a");
if (crc32("PGoNgUOM",8) == 482570745) strcat(s, "t");
if (crc32("hsHxhuNrGf",10) == 799668449) strcat(s, "i");
if (crc32("BWWwAAFdvz",10) == 914627494) strcat(s, "n");
if (crc32("jGuCOzPKkskN",12) == 2269739279) strcat(s, "n");
if (crc32("IBmiD",5) == 660426887) strcat(s, "g");
    return s;
}

char *hung_verbs() {
    char *s = calloc(5);
    if (crc32("JJRZnYvzQ",9) == 91291109) strcat(s, "h");
if (crc32("rRmCdMspKYKSlo",14) == 175143573) strcat(s, "O");
if (crc32("OqHoxnPzKhv",11) == 3797453241) strcat(s, "u");
if (crc32("eVmhBaitKQanr",13) == 2765386860) strcat(s, "n");
if (crc32("OozWfjYANlNTP",13) == 3449458734) strcat(s, "g");
    return s;
}

char *readmit_verbs() {
    char *s = calloc(8);
    if (crc32("xHdMfSZQiwfJu",13) == 3473525687) strcat(s, "g");
if (crc32("IsWExAERd",9) == 1359559309) strcat(s, "r");
if (crc32("sGaIzpcOpbSV",12) == 766503310) strcat(s, "e");
if (crc32("YVSPLzZMfwIgYDj",15) == 1197168083) strcat(s, "a");
if (crc32("HEqSobnpjFcUwuQ",15) == 3740264378) strcat(s, "d");
if (crc32("sPpApxPMb",9) == 2414044842) strcat(s, "m");
if (crc32("teaIAaoViWz",11) == 3112477254) strcat(s, "i");
if (crc32("UJIEPtIjk",9) == 2636099495) strcat(s, "I");
if (crc32("PjafwfZGhXXY",12) == 290723273) strcat(s, "t");
    return s;
}

char *thwack_verbs() {
    char *s = calloc(7);
    if (crc32("EWEgKWV",7) == 1835516217) strcat(s, "B");
if (crc32("LmZXs",5) == 1210593591) strcat(s, "t");
if (crc32("lsKYYrjBWlYGpIX",15) == 1413799865) strcat(s, "h");
if (crc32("hJGFKBcI",8) == 1029873327) strcat(s, "w");
if (crc32("lChFygk",7) == 3833048111) strcat(s, "a");
if (crc32("PummsZsCGST",11) == 714636633) strcat(s, "c");
if (crc32("dWYEjVCQUyqE",12) == 3404733909) strcat(s, "k");
    return s;
}

char *serrating_verbs() {
    char *s = calloc(10);
    if (crc32("WOuHGGFzErE",11) == 953223126) strcat(s, "s");
if (crc32("FeRYKfxRICB",11) == 1695856642) strcat(s, "k");
if (crc32("vvyBAJWei",9) == 3770859506) strcat(s, "e");
if (crc32("xTIFTVSaPRKKeH",14) == 190580005) strcat(s, "r");
if (crc32("AeswQvWNcRtM",12) == 715690873) strcat(s, "O");
if (crc32("yOqXXY",6) == 2528490703) strcat(s, "r");
if (crc32("AwTPYFkZ",8) == 3379809609) strcat(s, "a");
if (crc32("UdaMNhtO",8) == 4108935007) strcat(s, "t");
if (crc32("eFEijZhJqrlQn",13) == 533322514) strcat(s, "i");
if (crc32("jCIHBIZZbDIXmMr",15) == 1573794175) strcat(s, "g");
if (crc32("OfwRErgFjrVlQM",14) == 1839747354) strcat(s, "n");
if (crc32("yHljN",5) == 1243398831) strcat(s, "I");
if (crc32("wUmsxzfgOMNTqy",14) == 317318728) strcat(s, "g");
    return s;
}

char *lignifying_verbs() {
    char *s = calloc(11);
    if (crc32("GRRywfSSXJ",10) == 2999907231) strcat(s, "b");
if (crc32("szSqekRUYEXbP",13) == 2321174894) strcat(s, "l");
if (crc32("dzZVm",5) == 3106996248) strcat(s, "e");
if (crc32("QoYBaX",6) == 2973696203) strcat(s, "i");
if (crc32("bJwIFI",6) == 909730925) strcat(s, "E");
if (crc32("noMrjW",6) == 3427292337) strcat(s, "g");
if (crc32("fxVyOeCbZFTob",13) == 1446809465) strcat(s, "n");
if (crc32("fXJNIEXvemDTIYB",15) == 141349313) strcat(s, "h");
if (crc32("kHEIQKwynMYiu",13) == 3119270714) strcat(s, "i");
if (crc32("mRqEHjBvbg",10) == 940301297) strcat(s, "f");
if (crc32("ahapHoYHH",9) == 2700123546) strcat(s, "y");
if (crc32("flifSfvmdJVPM",13) == 1596967095) strcat(s, "i");
if (crc32("GkLKObCNiFblh",13) == 1286136505) strcat(s, "E");
if (crc32("TvIcuuLVLvRV",12) == 1265370835) strcat(s, "n");
if (crc32("KczCaPSoWFxOv",13) == 913629747) strcat(s, "g");
    return s;
}

char *incurving_verbs() {
    char *s = calloc(10);
    if (crc32("ONXleR",6) == 2972803354) strcat(s, "v");
if (crc32("zRpbS",5) == 3843860833) strcat(s, "i");
if (crc32("AENzghDdsnZ",11) == 1699304355) strcat(s, "K");
if (crc32("eHYLVzdbppAdR",13) == 3438190738) strcat(s, "n");
if (crc32("CqaYvWCicswfR",13) == 3874724925) strcat(s, "q");
if (crc32("JBtzah",6) == 3213290049) strcat(s, "c");
if (crc32("IQFGXIRwiFpZzU",14) == 4068383921) strcat(s, "a");
if (crc32("tOSQQzZjZMESjH",14) == 3128432263) strcat(s, "u");
if (crc32("fvoxOmpHVTT",11) == 1176238829) strcat(s, "W");
if (crc32("WwLgbwY",7) == 1867601635) strcat(s, "r");
if (crc32("DEJFQsbCHPx",11) == 694182694) strcat(s, "v");
if (crc32("bOzTSJViOemT",12) == 1614149115) strcat(s, "B");
if (crc32("vIfMwcoDRGxA",12) == 1416955413) strcat(s, "i");
if (crc32("kXJzzpygMHtkXhO",15) == 1967427737) strcat(s, "n");
if (crc32("HGzTonlm",8) == 2728079963) strcat(s, "g");
    return s;
}

char *resubmerged_verbs() {
    char *s = calloc(12);
    if (crc32("dvRPPQMV",8) == 2797763746) strcat(s, "r");
if (crc32("ErOumFsybwR",11) == 2628498678) strcat(s, "w");
if (crc32("vZTlBGyaKVmnt",13) == 2225940165) strcat(s, "e");
if (crc32("bSLEJpvusqNwFo",14) == 792028806) strcat(s, "s");
if (crc32("ijfQoTzCBi",10) == 3921349145) strcat(s, "M");
if (crc32("sSzMpSfDnAv",11) == 4283076016) strcat(s, "u");
if (crc32("uppheSCUizWF",12) == 2934496233) strcat(s, "b");
if (crc32("wtCJUmv",7) == 3433613684) strcat(s, "m");
if (crc32("HbwizFrbzbU",11) == 2180008473) strcat(s, "u");
if (crc32("hgfOsiLEOHEbqY",14) == 1331177872) strcat(s, "e");
if (crc32("qHDWJIofq",9) == 983304320) strcat(s, "H");
if (crc32("ikNOxDpw",8) == 4102088804) strcat(s, "r");
if (crc32("yovfkP",6) == 4116069862) strcat(s, "b");
if (crc32("qkaNhCzsedYEx",13) == 4040395982) strcat(s, "g");
if (crc32("JxfWeskimXcfqk",14) == 172450926) strcat(s, "N");
if (crc32("oNlfZkqa",8) == 4248501480) strcat(s, "e");
if (crc32("oUrJXDD",7) == 1281425728) strcat(s, "d");
    return s;
}

char *pistolled_verbs() {
    char *s = calloc(10);
    if (crc32("znNFsH",6) == 1320188867) strcat(s, "p");
if (crc32("cElYsTL",7) == 1612540366) strcat(s, "i");
if (crc32("NfBbJIfipNxRit",14) == 476685843) strcat(s, "i");
if (crc32("MybPTTNBGGIsaeW",15) == 3920845008) strcat(s, "s");
if (crc32("HfNUWU",6) == 3153856242) strcat(s, "t");
if (crc32("OJhOSKVM",8) == 1816924135) strcat(s, "Q");
if (crc32("icaXOUMYSYB",11) == 3525496314) strcat(s, "o");
if (crc32("QwLlPsUpPXxe",12) == 3151250614) strcat(s, "X");
if (crc32("xojCs",5) == 1004390896) strcat(s, "l");
if (crc32("ophJcorGQcTu",12) == 512104802) strcat(s, "l");
if (crc32("dFGwiKqM",8) == 4268206434) strcat(s, "P");
if (crc32("LZVOLOVHTSAngdk",15) == 2066332438) strcat(s, "e");
if (crc32("mOmDsUZ",7) == 3740802586) strcat(s, "b");
if (crc32("CempaEOYc",9) == 3032633255) strcat(s, "d");
    return s;
}

char *platted_verbs() {
    char *s = calloc(8);
    if (crc32("KeSVFQa",7) == 4287515096) strcat(s, "p");
if (crc32("waHWNDikY",9) == 686332695) strcat(s, "l");
if (crc32("PHsyxmfOcee",11) == 894331189) strcat(s, "a");
if (crc32("jorXVUNHdYqhhGy",15) == 1427575758) strcat(s, "t");
if (crc32("MsgacNDtQiBlEWL",15) == 1287550790) strcat(s, "D");
if (crc32("jbYjZiCZ",8) == 1937748800) strcat(s, "t");
if (crc32("hpxMaLZecZ",10) == 1770050765) strcat(s, "f");
if (crc32("pSjToc",6) == 3433287672) strcat(s, "e");
if (crc32("xLfMjoHe",8) == 2261954477) strcat(s, "X");
if (crc32("XWDzkmC",7) == 1311301521) strcat(s, "d");
    return s;
}

char *estimate_verbs() {
    char *s = calloc(9);
    if (crc32("DHYtTApWT",9) == 778845543) strcat(s, "D");
if (crc32("YiwIGmrqJj",10) == 1632016057) strcat(s, "e");
if (crc32("kdJVIDhKJLcTa",13) == 581261696) strcat(s, "s");
if (crc32("bjVGKeyVAmJuLC",14) == 2533981125) strcat(s, "t");
if (crc32("DfwpQMJIEmIA",12) == 2670905930) strcat(s, "i");
if (crc32("rjfyL",5) == 3697683267) strcat(s, "m");
if (crc32("JPWxVXVRBdOzX",13) == 2851005223) strcat(s, "d");
if (crc32("hbGTAnuMCnPlj",13) == 491189375) strcat(s, "a");
if (crc32("kKoBlm",6) == 1104761062) strcat(s, "b");
if (crc32("MLLoDM",6) == 2436289005) strcat(s, "t");
if (crc32("ZkiIA",5) == 1069557136) strcat(s, "e");
    return s;
}

char *hemorrhaging_verbs() {
    char *s = calloc(13);
    if (crc32("sUSCgPnVWFcCBTy",15) == 3148104089) strcat(s, "h");
if (crc32("kjjolMjaRTOi",12) == 870974182) strcat(s, "e");
if (crc32("uMjJTRYRsmLnff",14) == 1237650169) strcat(s, "m");
if (crc32("gmEYz",5) == 2307146378) strcat(s, "o");
if (crc32("hNuelpxfXnwU",12) == 2055309300) strcat(s, "r");
if (crc32("kMSwtMWINZrJ",12) == 89859930) strcat(s, "N");
if (crc32("keMpBIMFAiB",11) == 341551404) strcat(s, "r");
if (crc32("GCEcfnFOGY",10) == 860424569) strcat(s, "h");
if (crc32("NuUEznkrt",9) == 1558838478) strcat(s, "a");
if (crc32("xfEfgIJW",8) == 2527806273) strcat(s, "p");
if (crc32("DjHYLiuAgWRjsc",14) == 2436567331) strcat(s, "g");
if (crc32("MJObYEb",7) == 270580950) strcat(s, "i");
if (crc32("WpgKnByDZBVtL",13) == 1306816256) strcat(s, "n");
if (crc32("JngpHBXKawZ",11) == 1899174467) strcat(s, "H");
if (crc32("cmEPOAXLWQ",10) == 871146640) strcat(s, "g");
    return s;
}

char *restirred_verbs() {
    char *s = calloc(10);
    if (crc32("VKyRpWgT",8) == 3432718763) strcat(s, "J");
if (crc32("crrbNmj",7) == 1960154253) strcat(s, "r");
if (crc32("McgsbtYRFaECq",13) == 3173165207) strcat(s, "e");
if (crc32("sTXFNAxcND",10) == 90094413) strcat(s, "r");
if (crc32("MScoPExzQrWAo",13) == 2820807087) strcat(s, "s");
if (crc32("xLtgmUKplvaF",12) == 653981890) strcat(s, "t");
if (crc32("jlxRPiXJsk",10) == 2248242843) strcat(s, "r");
if (crc32("tkozseDDQ",9) == 1558215520) strcat(s, "i");
if (crc32("XRuwxUs",7) == 1609078455) strcat(s, "r");
if (crc32("GNTXRaA",7) == 2315334174) strcat(s, "v");
if (crc32("ZGyiuJqTv",9) == 2201961984) strcat(s, "r");
if (crc32("Wgubt",5) == 3094953415) strcat(s, "e");
if (crc32("JasVpQeFSSVVR",13) == 1367022949) strcat(s, "e");
if (crc32("VBNBN",5) == 1766046746) strcat(s, "d");
    return s;
}

char *narrate_verbs() {
    char *s = calloc(8);
    if (crc32("tdRHGAoSFcQGPho",15) == 2283517637) strcat(s, "J");
if (crc32("zLtggFVeUBwvNvJ",15) == 737168311) strcat(s, "n");
if (crc32("LGpzSZSMrHSXK",13) == 2444605280) strcat(s, "w");
if (crc32("FbbNrmlhiFsb",12) == 679926913) strcat(s, "a");
if (crc32("zVDcQgJ",7) == 1518865660) strcat(s, "r");
if (crc32("oHuAzfLOxrV",11) == 3142076618) strcat(s, "F");
if (crc32("LfWqo",5) == 3350652609) strcat(s, "r");
if (crc32("RvwehmWN",8) == 1617898268) strcat(s, "a");
if (crc32("WBEDsGIZ",8) == 1870916091) strcat(s, "X");
if (crc32("SOqwN",5) == 3738143660) strcat(s, "t");
if (crc32("fzTNs",5) == 412217705) strcat(s, "e");
    return s;
}

char *baked_verbs() {
    char *s = calloc(6);
    if (crc32("agGoXBLTlVnmw",13) == 119356720) strcat(s, "b");
if (crc32("jFtPr",5) == 2347600127) strcat(s, "S");
if (crc32("rNUIaNM",7) == 3936672989) strcat(s, "a");
if (crc32("kSnFQPLB",8) == 3341567720) strcat(s, "E");
if (crc32("OveluOMpJ",9) == 412353587) strcat(s, "k");
if (crc32("DmBigeUp",8) == 2332204636) strcat(s, "e");
if (crc32("wGbJRyDKi",9) == 3891076115) strcat(s, "d");
    return s;
}

char *impropriate_verbs() {
    char *s = calloc(12);
    if (crc32("ayvTwABpP",9) == 1505351209) strcat(s, "i");
if (crc32("eWXvoMKEFQkf",12) == 2707116129) strcat(s, "h");
if (crc32("nOnUTqzUiCixRql",15) == 646603212) strcat(s, "m");
if (crc32("WWAwEKcJqPLzqxg",15) == 3375427351) strcat(s, "c");
if (crc32("Hcvmr",5) == 3105271136) strcat(s, "p");
if (crc32("nDzQQZ",6) == 1873666432) strcat(s, "r");
if (crc32("WHbIkTYb",8) == 313367238) strcat(s, "o");
if (crc32("zvpvTSBNU",9) == 3983151325) strcat(s, "B");
if (crc32("JNnEMOS",7) == 1061991009) strcat(s, "p");
if (crc32("tvjmzLmUJG",10) == 672394281) strcat(s, "X");
if (crc32("KXqJk",5) == 1652401200) strcat(s, "r");
if (crc32("jwmgXBdtlg",10) == 2344510697) strcat(s, "i");
if (crc32("tjLCN",5) == 2908463744) strcat(s, "a");
if (crc32("JWZveVyUM",9) == 2210222189) strcat(s, "t");
if (crc32("tORCJM",6) == 3941683198) strcat(s, "e");
    return s;
}

char *crumbled_verbs() {
    char *s = calloc(9);
    if (crc32("HQEJzxaaMXES",12) == 922064136) strcat(s, "c");
if (crc32("MhPENS",6) == 2323818193) strcat(s, "r");
if (crc32("pFLmQRjDanyW",12) == 3608921188) strcat(s, "A");
if (crc32("DoOLRcW",7) == 185343339) strcat(s, "u");
if (crc32("TpfpKdQya",9) == 2056713064) strcat(s, "e");
if (crc32("npqAYKo",7) == 120646680) strcat(s, "m");
if (crc32("OMsTvywLFbthA",13) == 1242175416) strcat(s, "Q");
if (crc32("fcdjCRcgbIijwD",14) == 3029375693) strcat(s, "b");
if (crc32("lWyBtEk",7) == 990505124) strcat(s, "M");
if (crc32("uicvDuWVblyVV",13) == 3549764124) strcat(s, "l");
if (crc32("PnXcjRsADU",10) == 2664988011) strcat(s, "e");
if (crc32("pbmmktW",7) == 3106160826) strcat(s, "x");
if (crc32("vZuBphl",7) == 37702267) strcat(s, "d");
    return s;
}

char *desegregated_verbs() {
    char *s = calloc(13);
    if (crc32("whSuvkVqBcSHc",13) == 278127048) strcat(s, "d");
if (crc32("TYTdOVGQi",9) == 65449494) strcat(s, "f");
if (crc32("urHVBxCSj",9) == 3723420223) strcat(s, "e");
if (crc32("VueGoJcYcL",10) == 1689680033) strcat(s, "s");
if (crc32("JvAWaMwJDheBn",13) == 82510343) strcat(s, "e");
if (crc32("fPuTYQeFA",9) == 3292670945) strcat(s, "u");
if (crc32("KRqtX",5) == 4090838591) strcat(s, "g");
if (crc32("XPmUpAqZ",8) == 598504089) strcat(s, "X");
if (crc32("eCxEyKfYsjUD",12) == 1629464164) strcat(s, "r");
if (crc32("bqcBhEmQaRq",11) == 3044315646) strcat(s, "U");
if (crc32("gYriHu",6) == 265284605) strcat(s, "e");
if (crc32("pffMkpBPS",9) == 3659608074) strcat(s, "R");
if (crc32("UwnxePOmpx",10) == 2686477921) strcat(s, "g");
if (crc32("KKOSsHmVt",9) == 3979662671) strcat(s, "a");
if (crc32("dCbAMckHtg",10) == 651701394) strcat(s, "A");
if (crc32("CIgFRdROkK",10) == 1240651705) strcat(s, "t");
if (crc32("uxuphjMKpxxkdF",14) == 1409635947) strcat(s, "e");
if (crc32("wBoPEwtZ",8) == 3960177462) strcat(s, "d");
    return s;
}

char *reproducing_verbs() {
    char *s = calloc(12);
    if (crc32("tQZPWfpXIQ",10) == 2911694336) strcat(s, "r");
if (crc32("BoUrmzdVElWwKNO",15) == 3126251504) strcat(s, "e");
if (crc32("wUEgiP",6) == 1528347034) strcat(s, "e");
if (crc32("iBxyqwBDHZ",10) == 1178949990) strcat(s, "p");
if (crc32("aKBzcnnB",8) == 2715321406) strcat(s, "L");
if (crc32("wEkngHVpjEgHrh",14) == 871217511) strcat(s, "r");
if (crc32("ThbNLbrTybAog",13) == 2462784334) strcat(s, "G");
if (crc32("DqTmtoNW",8) == 1215573238) strcat(s, "o");
if (crc32("bDLXftoHkq",10) == 2282851889) strcat(s, "W");
if (crc32("NaYvHNEv",8) == 959167462) strcat(s, "d");
if (crc32("JjZNbHzUpCbcoUJ",15) == 2388648040) strcat(s, "u");
if (crc32("PfcasbZwLQ",10) == 3718798627) strcat(s, "c");
if (crc32("MGujMJbben",10) == 1053611296) strcat(s, "Y");
if (crc32("nZRcsVKrcYo",11) == 3497270085) strcat(s, "i");
if (crc32("htLxTGccWjP",11) == 90207660) strcat(s, "R");
if (crc32("OfqYDPGqzkkuTh",14) == 1059071174) strcat(s, "n");
if (crc32("uQbVrvPmozji",12) == 2618460019) strcat(s, "Q");
if (crc32("NbZvJFqxNdHhaD",14) == 575927148) strcat(s, "g");
    return s;
}

char *hoveling_verbs() {
    char *s = calloc(9);
    if (crc32("xHOhvTZXsNA",11) == 4124397608) strcat(s, "d");
if (crc32("pDNaEJ",6) == 1045090108) strcat(s, "h");
if (crc32("DVoqFLKC",8) == 2387037858) strcat(s, "o");
if (crc32("Wjuwj",5) == 1409306774) strcat(s, "u");
if (crc32("ByBTNCc",7) == 1902311445) strcat(s, "v");
if (crc32("zIsOcquhPz",10) == 3134251091) strcat(s, "e");
if (crc32("ZoGgPLvQCWSE",12) == 1395029578) strcat(s, "l");
if (crc32("rDhuvxJlc",9) == 4168724647) strcat(s, "w");
if (crc32("CpUfk",5) == 838790578) strcat(s, "i");
if (crc32("XkfNJ",5) == 2738825144) strcat(s, "Z");
if (crc32("iZEDMyJnW",9) == 2516395901) strcat(s, "n");
if (crc32("oRvGcwmrRXgOL",13) == 2043775211) strcat(s, "X");
if (crc32("sZjoTcqdIvL",11) == 851400269) strcat(s, "g");
    return s;
}

char *shew_verbs() {
    char *s = calloc(5);
    if (crc32("IGofApJw",8) == 2384619042) strcat(s, "s");
if (crc32("GEXSEFVRZuneK",13) == 405769980) strcat(s, "h");
if (crc32("NWKeCFGiTsNk",12) == 918916467) strcat(s, "M");
if (crc32("brsqy",5) == 2913790977) strcat(s, "e");
if (crc32("hvxhREzfvjL",11) == 288007071) strcat(s, "a");
if (crc32("idzdmPXWhMsJq",13) == 727968212) strcat(s, "w");
    return s;
}

char *Hebraized_verbs() {
    char *s = calloc(10);
    if (crc32("eOOqfRapCVZYk",13) == 1039844744) strcat(s, "H");
if (crc32("daiEonodCcLkp",13) == 279966280) strcat(s, "e");
if (crc32("AwKjiXbJrw",10) == 1171485961) strcat(s, "b");
if (crc32("ibNFngHpxPeFh",13) == 2156097049) strcat(s, "P");
if (crc32("SGZHgYMVcjg",11) == 3329876445) strcat(s, "r");
if (crc32("wtwQoo",6) == 256445910) strcat(s, "a");
if (crc32("cDjVyKThbjuez",13) == 940341345) strcat(s, "P");
if (crc32("FcOQBoCtNY",10) == 2671339469) strcat(s, "i");
if (crc32("CbfTDxtQpiRBgW",14) == 1896632880) strcat(s, "K");
if (crc32("ZylwZZuhhdK",11) == 2755916095) strcat(s, "z");
if (crc32("DxNAbyDBMewG",12) == 3949207588) strcat(s, "l");
if (crc32("IeWQeMDvrGvT",12) == 930211532) strcat(s, "e");
if (crc32("nMiMOYaAPHT",11) == 1713054555) strcat(s, "d");
    return s;
}

char *bustup_verbs() {
    char *s = calloc(7);
    if (crc32("KQtZHEqwIwtQb",13) == 3133394073) strcat(s, "b");
if (crc32("lYIjevywUW",10) == 3025520331) strcat(s, "u");
if (crc32("XpMTXiPjwlErKd",14) == 3512556021) strcat(s, "s");
if (crc32("LVXJKXXN",8) == 2751876649) strcat(s, "D");
if (crc32("trzLT",5) == 1659543911) strcat(s, "t");
if (crc32("rRTqkZQtyiBuqaF",15) == 3354597117) strcat(s, "u");
if (crc32("jlsyBh",6) == 3890450323) strcat(s, "p");
    return s;
}

char *chase_verbs() {
    char *s = calloc(6);
    if (crc32("PoCmKQiOxQlEY",13) == 1988562484) strcat(s, "c");
if (crc32("mvSSWerkNPVVvl",14) == 3334182069) strcat(s, "h");
if (crc32("huRwWLFHPUFQk",13) == 3068945890) strcat(s, "a");
if (crc32("QuIToesuqw",10) == 2510642091) strcat(s, "s");
if (crc32("tmhiNNr",7) == 1958240662) strcat(s, "e");
    return s;
}

char *remingled_verbs() {
    char *s = calloc(10);
    if (crc32("LFyoqbBIQHjU",12) == 458014945) strcat(s, "r");
if (crc32("TfIZh",5) == 1770708018) strcat(s, "e");
if (crc32("egJVi",5) == 2491673506) strcat(s, "m");
if (crc32("RUdTqZSSU",9) == 3420634967) strcat(s, "i");
if (crc32("mEYgUzAYAM",10) == 1566678147) strcat(s, "L");
if (crc32("lEqmikW",7) == 3071345157) strcat(s, "n");
if (crc32("YplRpsdtAkKLVrU",15) == 1251603977) strcat(s, "f");
if (crc32("suUcTiZSEOG",11) == 3237233761) strcat(s, "g");
if (crc32("xYgxYUsFZeWGlDT",15) == 2393070449) strcat(s, "L");
if (crc32("qiBoZjoUYrIIXgF",15) == 2614381681) strcat(s, "l");
if (crc32("SbuDOdKYCGdgBBP",15) == 3005254763) strcat(s, "b");
if (crc32("rLEpdN",6) == 48609866) strcat(s, "e");
if (crc32("VJeUJqlqNMUvw",13) == 549508741) strcat(s, "h");
if (crc32("iSXpH",5) == 3190787377) strcat(s, "d");
    return s;
}

char *overplease_verbs() {
    char *s = calloc(11);
    if (crc32("lVIKbXvX",8) == 1245889498) strcat(s, "o");
if (crc32("uWgzFMrWLLh",11) == 2639852507) strcat(s, "v");
if (crc32("tUfndCGwMQE",11) == 445529192) strcat(s, "G");
if (crc32("MGdzmriGHj",10) == 3217058336) strcat(s, "e");
if (crc32("GhLgKmpeOBYntXv",15) == 1322465786) strcat(s, "s");
if (crc32("mCMOBm",6) == 4178568641) strcat(s, "r");
if (crc32("sUVmUgevDRWen",13) == 3810882689) strcat(s, "y");
if (crc32("VETjog",6) == 3415918816) strcat(s, "p");
if (crc32("NNiADQDNDx",10) == 2070895263) strcat(s, "O");
if (crc32("MsEVok",6) == 1082660795) strcat(s, "l");
if (crc32("euCbtAlA",8) == 1959876420) strcat(s, "e");
if (crc32("QeNWyNpLdPpWW",13) == 3312306896) strcat(s, "D");
if (crc32("vPlpKhTfsoxNh",13) == 2032268996) strcat(s, "a");
if (crc32("WZiczXf",7) == 1907733458) strcat(s, "F");
if (crc32("VnvkRdXRTygoKdR",15) == 313226260) strcat(s, "s");
if (crc32("LrJzpeMCmoUIQw",14) == 1951366774) strcat(s, "b");
if (crc32("wrkKlzlPLkVkhBY",15) == 2436936656) strcat(s, "e");
    return s;
}

char *getonto_verbs() {
    char *s = calloc(8);
    if (crc32("rhiwHTFzgnFi",12) == 24905851) strcat(s, "G");
if (crc32("puYdCBihPMjB",12) == 3537155552) strcat(s, "g");
if (crc32("RyovgIjIErPO",12) == 7368790) strcat(s, "E");
if (crc32("vNPzHwLeghDw",12) == 2830836218) strcat(s, "e");
if (crc32("nLixVAySQIG",11) == 3100613205) strcat(s, "z");
if (crc32("CMMYsOvDHo",10) == 913348786) strcat(s, "t");
if (crc32("edpMCJDnyZp",11) == 921211935) strcat(s, "o");
if (crc32("elmUlMkYwjIwu",13) == 1383809697) strcat(s, "c");
if (crc32("rVrpRyqqOQS",11) == 2928990885) strcat(s, "n");
if (crc32("wyEVe",5) == 1016005882) strcat(s, "t");
if (crc32("nHPba",5) == 1637687959) strcat(s, "w");
if (crc32("uRTCi",5) == 312155357) strcat(s, "o");
    return s;
}

char *vrilling_verbs() {
    char *s = calloc(9);
    if (crc32("zyyGkFAY",8) == 4065092302) strcat(s, "Y");
if (crc32("mLTvRDRh",8) == 2442731017) strcat(s, "v");
if (crc32("ZGPDuCrbEen",11) == 3085947102) strcat(s, "G");
if (crc32("POiulBAE",8) == 1907671644) strcat(s, "r");
if (crc32("ekwKebgTvg",10) == 920115368) strcat(s, "i");
if (crc32("VJnyHXemSIjTHN",14) == 2989654577) strcat(s, "l");
if (crc32("lVejYGiLOnvmqp",14) == 3757953591) strcat(s, "l");
if (crc32("AwiePKgcW",9) == 1294155229) strcat(s, "i");
if (crc32("SlIfp",5) == 3565683183) strcat(s, "n");
if (crc32("lIKpOVqXhWH",11) == 3281935690) strcat(s, "g");
if (crc32("HwwLUzGW",8) == 3526586150) strcat(s, "g");
    return s;
}

char *forefeeling_verbs() {
    char *s = calloc(12);
    if (crc32("huBQjQs",7) == 239259788) strcat(s, "E");
if (crc32("AXhXIfhWz",9) == 3118938191) strcat(s, "f");
if (crc32("HwJdE",5) == 119179509) strcat(s, "e");
if (crc32("fGXRbHmCJAkDjQ",14) == 573579970) strcat(s, "o");
if (crc32("rPaCtLb",7) == 3400999006) strcat(s, "U");
if (crc32("wjWdjVsYzupH",12) == 2065745165) strcat(s, "r");
if (crc32("pASPiCMPgwUu",12) == 795242184) strcat(s, "O");
if (crc32("tfDIii",6) == 3698269358) strcat(s, "e");
if (crc32("PlnCDq",6) == 4223421210) strcat(s, "f");
if (crc32("ilIjxShWNkn",11) == 975309881) strcat(s, "v");
if (crc32("lWzrhnq",7) == 673041602) strcat(s, "e");
if (crc32("MVkZMKlcfT",10) == 2072494698) strcat(s, "e");
if (crc32("XjLVyTMOCvEOVt",14) == 3804614958) strcat(s, "l");
if (crc32("qFPcaBzV",8) == 3108225166) strcat(s, "T");
if (crc32("TEsUNZvtPz",10) == 3295944355) strcat(s, "i");
if (crc32("WPqxsKk",7) == 2197010859) strcat(s, "n");
if (crc32("QTGaahntl",9) == 1618047677) strcat(s, "z");
if (crc32("dYCRS",5) == 346450617) strcat(s, "g");
    return s;
}

char *liked_verbs() {
    char *s = calloc(6);
    if (crc32("fHLOggKrqV",10) == 414775069) strcat(s, "M");
if (crc32("YQrxFJNasyNR",12) == 2370587196) strcat(s, "l");
if (crc32("rDrKqpGvVkdS",12) == 3966772978) strcat(s, "K");
if (crc32("BVdUSOI",7) == 307578062) strcat(s, "i");
if (crc32("DEiwMJC",7) == 2373333476) strcat(s, "k");
if (crc32("HFqHLjbVg",9) == 2019139085) strcat(s, "e");
if (crc32("dhRmua",6) == 3595472534) strcat(s, "u");
if (crc32("cHdwIzjYcj",10) == 2383030094) strcat(s, "d");
    return s;
}

char *buttstrapped_verbs() {
    char *s = calloc(13);
    if (crc32("iDbdiDdkHkYWwL",14) == 3717661438) strcat(s, "f");
if (crc32("BrsFhvZneAQTGhP",15) == 3130959969) strcat(s, "b");
if (crc32("evalh",5) == 445684918) strcat(s, "u");
if (crc32("WCAkbqpx",8) == 3493423312) strcat(s, "t");
if (crc32("HeELqUwSpeiDS",13) == 4127354377) strcat(s, "t");
if (crc32("bKIYusJnZdM",11) == 2059196001) strcat(s, "L");
if (crc32("ARxPLab",7) == 2586018517) strcat(s, "s");
if (crc32("aqcaibUd",8) == 333299409) strcat(s, "O");
if (crc32("wrjItFW",7) == 3338864914) strcat(s, "t");
if (crc32("mtMaiSQBpxWzB",13) == 667901705) strcat(s, "R");
if (crc32("xzDQqtIzrLvLtfe",15) == 2325831964) strcat(s, "r");
if (crc32("dhGSnUWGryZuv",13) == 542652807) strcat(s, "a");
if (crc32("VdcFDE",6) == 3363835205) strcat(s, "p");
if (crc32("XiRaClUB",8) == 2723062272) strcat(s, "e");
if (crc32("QyActhueRmZMYeY",15) == 1191582531) strcat(s, "p");
if (crc32("PJzDCuW",7) == 1660244666) strcat(s, "e");
if (crc32("FBVbkobs",8) == 2927352576) strcat(s, "d");
if (crc32("mVAlgOiUnWhJzcI",15) == 2406379451) strcat(s, "d");
    return s;
}

char *chiselling_verbs() {
    char *s = calloc(11);
    if (crc32("GwJExussh",9) == 3656728835) strcat(s, "M");
if (crc32("hXIwYSryd",9) == 1328088196) strcat(s, "c");
if (crc32("EnBmKkFdIah",11) == 3207641101) strcat(s, "h");
if (crc32("NIGDyvjTwU",10) == 2621104768) strcat(s, "i");
if (crc32("eSUhmAMPwVR",11) == 1591597699) strcat(s, "s");
if (crc32("VPyNghqLqmZIs",13) == 311914657) strcat(s, "e");
if (crc32("mpJvlGBKUzPpnKB",15) == 746352240) strcat(s, "l");
if (crc32("vPlLJgRYDFu",11) == 902547357) strcat(s, "T");
if (crc32("EoRoxDrDi",9) == 485830215) strcat(s, "l");
if (crc32("weCJkjqBXqOF",12) == 3345697050) strcat(s, "i");
if (crc32("CLukVaHYPn",10) == 2896907465) strcat(s, "u");
if (crc32("XHaJzLftpAA",11) == 2838959709) strcat(s, "n");
if (crc32("UnVaKaEuRKuRxnN",15) == 1039260308) strcat(s, "g");
    return s;
}

char *incurvating_verbs() {
    char *s = calloc(12);
    if (crc32("EbinWPUZSAnYc",13) == 1336262611) strcat(s, "F");
if (crc32("przTv",5) == 3222396442) strcat(s, "i");
if (crc32("CavYdHnOUnuW",12) == 1731908653) strcat(s, "e");
if (crc32("tsoUrqFsXi",10) == 2176613502) strcat(s, "n");
if (crc32("QJzMB",5) == 2329877238) strcat(s, "f");
if (crc32("jDXbstFdn",9) == 1379296344) strcat(s, "c");
if (crc32("fpxFYx",6) == 2038876985) strcat(s, "u");
if (crc32("PZzrJMxdMgnsEXV",15) == 2188081069) strcat(s, "O");
if (crc32("pURLrcEuc",9) == 2644443496) strcat(s, "r");
if (crc32("tvtjxmE",7) == 4276454739) strcat(s, "E");
if (crc32("OcPWaHF",7) == 562880373) strcat(s, "v");
if (crc32("tSUWKEh",7) == 466622132) strcat(s, "a");
if (crc32("lPItcYAeqNPQtnp",15) == 1794491919) strcat(s, "V");
if (crc32("QULrzXMtWCuMPE",14) == 4162170774) strcat(s, "t");
if (crc32("ESqSzsIDPRd",11) == 2283776966) strcat(s, "i");
if (crc32("slJqGM",6) == 1987648081) strcat(s, "n");
if (crc32("BHrdnmZu",8) == 771474220) strcat(s, "h");
if (crc32("IOWBvLdkmJoFjID",15) == 1044183822) strcat(s, "g");
    return s;
}

char *survived_verbs() {
    char *s = calloc(9);
    if (crc32("lJgWWq",6) == 3243070428) strcat(s, "s");
if (crc32("axJceO",6) == 4212775057) strcat(s, "u");
if (crc32("MeoDYz",6) == 2448504839) strcat(s, "L");
if (crc32("fupeYstXP",9) == 2682902874) strcat(s, "r");
if (crc32("QbVtwZPR",8) == 2652865239) strcat(s, "v");
if (crc32("LLtmoluyAAaeawq",15) == 300069573) strcat(s, "E");
if (crc32("UgBLOBGJDu",10) == 2133837626) strcat(s, "i");
if (crc32("JlsrneN",7) == 3066223935) strcat(s, "v");
if (crc32("hPyyHGKqL",9) == 3202914667) strcat(s, "J");
if (crc32("caPYvHoZPIF",11) == 2776029971) strcat(s, "e");
if (crc32("NIBAq",5) == 2941566781) strcat(s, "y");
if (crc32("IxZBpCUJhdAMW",13) == 1131273991) strcat(s, "d");
    return s;
}

char *remain_verbs() {
    char *s = calloc(7);
    if (crc32("HctEEUv",7) == 3248844096) strcat(s, "L");
if (crc32("PkyUhOUJVMDmdUZ",15) == 2457378626) strcat(s, "r");
if (crc32("SDKAtDGO",8) == 3293996644) strcat(s, "e");
if (crc32("ngtEUrP",7) == 1274163967) strcat(s, "o");
if (crc32("nrPVlAyKLGK",11) == 1844540900) strcat(s, "m");
if (crc32("MqCQZNen",8) == 2100220354) strcat(s, "a");
if (crc32("jzWPXxhZVPmzmh",14) == 420566416) strcat(s, "R");
if (crc32("IzTnVABsiJenEDt",15) == 3882879727) strcat(s, "i");
if (crc32("YKFMxwLkFcedHS",14) == 71564936) strcat(s, "J");
if (crc32("AWydzp",6) == 600377115) strcat(s, "n");
    return s;
}

char *overstoring_verbs() {
    char *s = calloc(12);
    if (crc32("SSPnzzNUfkOv",12) == 3635940239) strcat(s, "o");
if (crc32("pUybZFhTMkWrs",13) == 2539587837) strcat(s, "v");
if (crc32("xFOqtEmIDFnZmZM",15) == 921501235) strcat(s, "T");
if (crc32("GpGqfQfuWIe",11) == 2818830008) strcat(s, "e");
if (crc32("rGanvV",6) == 658888141) strcat(s, "r");
if (crc32("vduWXmfGtXEa",12) == 1063873191) strcat(s, "s");
if (crc32("EIYRXSCjSjm",11) == 440104759) strcat(s, "X");
if (crc32("JWoQUKQXYBCvpAR",15) == 2815013304) strcat(s, "t");
if (crc32("LQOaZdCty",9) == 3820463124) strcat(s, "A");
if (crc32("ekszfQu",7) == 1404356470) strcat(s, "o");
if (crc32("KAJXcxo",7) == 1944369887) strcat(s, "r");
if (crc32("iJUTGQpicf",10) == 2660142790) strcat(s, "i");
if (crc32("ahNrHLblP",9) == 2901411509) strcat(s, "n");
if (crc32("CYszdgkra",9) == 689248043) strcat(s, "h");
if (crc32("RoPvFVNRAb",10) == 927997531) strcat(s, "g");
    return s;
}

char *machinated_verbs() {
    char *s = calloc(11);
    if (crc32("NUvNrYATkyL",11) == 3149217405) strcat(s, "m");
if (crc32("YBtCYir",7) == 2751116208) strcat(s, "r");
if (crc32("jihvowjTPTTbqnX",15) == 2751267864) strcat(s, "a");
if (crc32("ghHQkLyHvKuUa",13) == 1178173048) strcat(s, "O");
if (crc32("noeYFdf",7) == 2311550688) strcat(s, "c");
if (crc32("oqwBDY",6) == 40431639) strcat(s, "F");
if (crc32("vIPGWU",6) == 1769574216) strcat(s, "h");
if (crc32("XBbciiSJcqHmDZy",15) == 930021474) strcat(s, "i");
if (crc32("MJruCUDNTFRQPG",14) == 2291536520) strcat(s, "B");
if (crc32("qHtDoDrUvDXX",12) == 4126039933) strcat(s, "n");
if (crc32("RdyusqsX",8) == 3987737116) strcat(s, "t");
if (crc32("oLMIIHUfqze",11) == 1413439401) strcat(s, "a");
if (crc32("FfqCKIOXjpFK",12) == 3614595994) strcat(s, "I");
if (crc32("LalxB",5) == 3863098165) strcat(s, "t");
if (crc32("UibzEWGUfyGgvb",14) == 1882874803) strcat(s, "F");
if (crc32("MISJmUwyaTQUarM",15) == 2624726920) strcat(s, "e");
if (crc32("FHKBnObdGyISBu",14) == 4025521331) strcat(s, "d");
    return s;
}

char *misthrow_verbs() {
    char *s = calloc(9);
    if (crc32("IFErJqxzmOeRoCt",15) == 1096187607) strcat(s, "S");
if (crc32("JlqdDe",6) == 1985194294) strcat(s, "m");
if (crc32("lXznhjvuzABCW",13) == 3383574185) strcat(s, "A");
if (crc32("diYsLuuFRB",10) == 766427846) strcat(s, "i");
if (crc32("kRYQCn",6) == 990353063) strcat(s, "s");
if (crc32("PYqEItYecpc",11) == 1013589906) strcat(s, "a");
if (crc32("qJlpC",5) == 1998511523) strcat(s, "t");
if (crc32("sjLPPrJ",7) == 1479614036) strcat(s, "h");
if (crc32("YuUPKjJeHdyeZZk",15) == 1855294237) strcat(s, "r");
if (crc32("mtubEsYhbTvP",12) == 931936490) strcat(s, "o");
if (crc32("uAeqPXkej",9) == 900675574) strcat(s, "G");
if (crc32("nZARhpAHJTETK",13) == 3526517189) strcat(s, "w");
    return s;
}

char *nicknamed_verbs() {
    char *s = calloc(10);
    if (crc32("nJDcIrQhj",9) == 39329948) strcat(s, "a");
if (crc32("uBkcqdfvlJqePeC",15) == 3887310388) strcat(s, "n");
if (crc32("yGLNcXcuQPKSzc",14) == 721458354) strcat(s, "i");
if (crc32("yvpnCu",6) == 934708921) strcat(s, "L");
if (crc32("QAoTBjJkiwjsAO",14) == 2463096102) strcat(s, "c");
if (crc32("svvFehgaU",9) == 4217070944) strcat(s, "t");
if (crc32("FJQZCnF",7) == 2745839263) strcat(s, "k");
if (crc32("KxdufZdoboMJ",12) == 77716721) strcat(s, "n");
if (crc32("PbMQradhfqx",11) == 3009145107) strcat(s, "n");
if (crc32("ulrVvhNn",8) == 4032674721) strcat(s, "a");
if (crc32("iXObFfsWaYaBlRF",15) == 2633523685) strcat(s, "d");
if (crc32("IqLCZgmfWvEWY",13) == 2142832010) strcat(s, "m");
if (crc32("bUJXEGSQrZqJZz",14) == 1704121508) strcat(s, "D");
if (crc32("aVDubhgVoBUjgQ",14) == 692491286) strcat(s, "e");
if (crc32("IOhJckohjefZ",12) == 1065893657) strcat(s, "d");
    return s;
}

char *brominate_verbs() {
    char *s = calloc(10);
    if (crc32("kofYglGFAzFaU",13) == 4266768043) strcat(s, "y");
if (crc32("pjDWMDKtfi",10) == 2444890284) strcat(s, "b");
if (crc32("DFZIjxyXK",9) == 2419235734) strcat(s, "r");
if (crc32("VLdKUmrBOwDjWQt",15) == 3354203818) strcat(s, "o");
if (crc32("nyALAMJnDPH",11) == 4186797099) strcat(s, "m");
if (crc32("VaeNLg",6) == 1735428280) strcat(s, "h");
if (crc32("dfCDBuSqOLgkpz",14) == 1693190904) strcat(s, "i");
if (crc32("hZSXCFYKNcFbtnv",15) == 1781877548) strcat(s, "L");
if (crc32("QoaJtCfYOYK",11) == 3241369072) strcat(s, "n");
if (crc32("GKGKuP",6) == 3482528973) strcat(s, "a");
if (crc32("OuCBYpzOsdv",11) == 2445956424) strcat(s, "t");
if (crc32("CJNQqaXNenwAFEQ",15) == 3978641538) strcat(s, "e");
    return s;
}

char *upheave_verbs() {
    char *s = calloc(8);
    if (crc32("PnoTYUTaDwfJrEZ",15) == 1925096613) strcat(s, "u");
if (crc32("XxoyZBKDIvpVzC",14) == 127406936) strcat(s, "p");
if (crc32("tRujGxoxeecqpB",14) == 1724631968) strcat(s, "h");
if (crc32("HiZFiJNrDctp",12) == 3646381391) strcat(s, "k");
if (crc32("eFLtkABbkXMP",12) == 2998622704) strcat(s, "e");
if (crc32("jULHdttFx",9) == 1908949629) strcat(s, "a");
if (crc32("pABkurEEeiwsHb",14) == 398846156) strcat(s, "G");
if (crc32("KftnMASlzBiqt",13) == 274647837) strcat(s, "v");
if (crc32("uwAcWy",6) == 3897435677) strcat(s, "v");
if (crc32("uYtnvDV",7) == 2574767568) strcat(s, "e");
    return s;
}

char *removing_verbs() {
    char *s = calloc(9);
    if (crc32("kpYljlJ",7) == 1091431794) strcat(s, "r");
if (crc32("mgppytsGxIva",12) == 3965737544) strcat(s, "e");
if (crc32("VRdcGwjsfTXzEUh",15) == 2907424127) strcat(s, "m");
if (crc32("fYPaUPTJtlQLQ",13) == 2987547649) strcat(s, "A");
if (crc32("PlLLulXtdlmAD",13) == 185982365) strcat(s, "o");
if (crc32("QsenFZJIOSo",11) == 2850258111) strcat(s, "D");
if (crc32("lEHrt",5) == 46315383) strcat(s, "v");
if (crc32("WQJfGqW",7) == 683730041) strcat(s, "C");
if (crc32("QaWIAKAArcMRH",13) == 3801743746) strcat(s, "i");
if (crc32("FildaAh",7) == 2664697230) strcat(s, "n");
if (crc32("MdrMelAKrj",10) == 2837085300) strcat(s, "g");
    return s;
}

char *fixating_verbs() {
    char *s = calloc(9);
    if (crc32("rNrIU",5) == 1395951285) strcat(s, "f");
if (crc32("OivCOKoOuyJd",12) == 3704294948) strcat(s, "i");
if (crc32("LKASnPGXFtmOzOP",15) == 2859826112) strcat(s, "x");
if (crc32("CHXxLLyn",8) == 1612586284) strcat(s, "a");
if (crc32("vTDbkMuFpZTycVw",15) == 3408955034) strcat(s, "t");
if (crc32("DvPGkcYfkLe",11) == 2923590989) strcat(s, "i");
if (crc32("vylPiCsWIUQP",12) == 1965446472) strcat(s, "n");
if (crc32("NaOyCdxOWpwN",12) == 2465349914) strcat(s, "G");
if (crc32("MSAAmrniE",9) == 1683094511) strcat(s, "g");
    return s;
}

char *styled_verbs() {
    char *s = calloc(7);
    if (crc32("uJGtCdvdEU",10) == 4057119543) strcat(s, "s");
if (crc32("SsOxngIlujfdI",13) == 2407985854) strcat(s, "t");
if (crc32("qyEbbqPnm",9) == 1985078802) strcat(s, "W");
if (crc32("SJLmsBtfWeWaXVf",15) == 2437592608) strcat(s, "y");
if (crc32("zrnKWTrxceBGLix",15) == 487155518) strcat(s, "l");
if (crc32("lxSwbghelmlph",13) == 3162274888) strcat(s, "e");
if (crc32("FvwOPdzTTzRfmie",15) == 2203907566) strcat(s, "P");
if (crc32("UapIVxZUjUw",11) == 4292070772) strcat(s, "d");
    return s;
}

char *ambuscading_verbs() {
    char *s = calloc(12);
    if (crc32("RJsTl",5) == 3158094021) strcat(s, "a");
if (crc32("KOQbqZNspmf",11) == 1602756890) strcat(s, "m");
if (crc32("KzsUotWL",8) == 3014338010) strcat(s, "D");
if (crc32("QErOsOrIJbCvT",13) == 884436250) strcat(s, "b");
if (crc32("KNSGvhLrqSjg",12) == 2392422166) strcat(s, "u");
if (crc32("ooGcRPTilJy",11) == 3050684836) strcat(s, "l");
if (crc32("tvweAHccOf",10) == 4232019058) strcat(s, "s");
if (crc32("MLFkFCotmEF",11) == 4025606417) strcat(s, "C");
if (crc32("GXeJQvHNVQz",11) == 2689529758) strcat(s, "c");
if (crc32("PagcKJfXrf",10) == 3272619658) strcat(s, "a");
if (crc32("hvlBJWYNZhJ",11) == 1894525444) strcat(s, "S");
if (crc32("NMUcxtdvxIWZm",13) == 554956712) strcat(s, "d");
if (crc32("ajHAb",5) == 45882575) strcat(s, "i");
if (crc32("NOBnczd",7) == 1526899646) strcat(s, "n");
if (crc32("LpmdOaJklsMv",12) == 2038723344) strcat(s, "k");
if (crc32("uSlPlj",6) == 3976020524) strcat(s, "g");
    return s;
}

char *slugging_verbs() {
    char *s = calloc(9);
    if (crc32("cdqrdSU",7) == 1956293938) strcat(s, "s");
if (crc32("svOjlMLwGpkE",12) == 3675718382) strcat(s, "l");
if (crc32("vOxWrsecDCu",11) == 2317672599) strcat(s, "Z");
if (crc32("bnuEXEMTCcVj",12) == 1432925048) strcat(s, "u");
if (crc32("tLlpjmPwlWlEfA",14) == 55102497) strcat(s, "r");
if (crc32("BkyxypO",7) == 3841865810) strcat(s, "g");
if (crc32("UbERfVlsGO",10) == 217543954) strcat(s, "g");
if (crc32("yRRnrFVmsbH",11) == 129418132) strcat(s, "j");
if (crc32("pLAuGuV",7) == 2507736610) strcat(s, "i");
if (crc32("fCjKt",5) == 1481961278) strcat(s, "n");
if (crc32("FxUkVKoM",8) == 2673290573) strcat(s, "g");
    return s;
}

char *superproducing_verbs() {
    char *s = calloc(15);
    if (crc32("QIDvsMriyOR",11) == 2568965811) strcat(s, "g");
if (crc32("sWPnaXcO",8) == 3263550707) strcat(s, "s");
if (crc32("TBRhtcRi",8) == 2649847789) strcat(s, "u");
if (crc32("WGnNgQnHxZfh",12) == 2946803083) strcat(s, "p");
if (crc32("QhcuEqPvyAy",11) == 1891856073) strcat(s, "w");
if (crc32("JULUgjyeURKks",13) == 1439463009) strcat(s, "e");
if (crc32("akexHEEugMqX",12) == 711387925) strcat(s, "S");
if (crc32("tghZUUYCYXi",11) == 2172083588) strcat(s, "r");
if (crc32("mWSSgafnABlodO",14) == 4290912435) strcat(s, "C");
if (crc32("dQGXCI",6) == 2548887786) strcat(s, "p");
if (crc32("UmGvcLbZh",9) == 2395711796) strcat(s, "r");
if (crc32("kIHEmJX",7) == 1649332064) strcat(s, "v");
if (crc32("CMiCVc",6) == 2495939769) strcat(s, "o");
if (crc32("CbGOUpqdsExglF",14) == 2606447873) strcat(s, "d");
if (crc32("YncDEmmpQKhDAfm",15) == 1185742971) strcat(s, "u");
if (crc32("UstlXVrGaTa",11) == 760843710) strcat(s, "O");
if (crc32("dznvhAfiUMdnosY",15) == 1129783673) strcat(s, "c");
if (crc32("KgUkEimOcPh",11) == 841794523) strcat(s, "d");
if (crc32("bFkzSgAIAK",10) == 2869840753) strcat(s, "i");
if (crc32("QRSInr",6) == 3611666016) strcat(s, "n");
if (crc32("BFbPTwyPWBMkk",13) == 3741801341) strcat(s, "g");
    return s;
}

char *intergrade_verbs() {
    char *s = calloc(11);
    if (crc32("Ckppa",5) == 2191535105) strcat(s, "E");
if (crc32("duFhQ",5) == 858654593) strcat(s, "i");
if (crc32("KikAcwOtgrMaG",13) == 1563698452) strcat(s, "S");
if (crc32("uLQcoSbJEx",10) == 1367150301) strcat(s, "n");
if (crc32("rjdjBoJivX",10) == 951290552) strcat(s, "k");
if (crc32("hmYeR",5) == 1487822410) strcat(s, "t");
if (crc32("XwxyZHraONHBPSV",15) == 883988109) strcat(s, "e");
if (crc32("GHufcfkj",8) == 280048509) strcat(s, "z");
if (crc32("LEsdtjJl",8) == 61345590) strcat(s, "r");
if (crc32("qrCmd",5) == 1575160012) strcat(s, "z");
if (crc32("JYETp",5) == 2598850970) strcat(s, "g");
if (crc32("IMECktEEScpgqv",14) == 770986727) strcat(s, "r");
if (crc32("wJXUBTjEeSDoHkN",15) == 428422831) strcat(s, "q");
if (crc32("TIdXPhxBEmsmcD",14) == 4134552666) strcat(s, "a");
if (crc32("SxEPiS",6) == 1900302047) strcat(s, "n");
if (crc32("idFHi",5) == 2661117942) strcat(s, "d");
if (crc32("FBjDrzBHyuMP",12) == 243639487) strcat(s, "Z");
if (crc32("bpMPAnPHtOh",11) == 1053612489) strcat(s, "e");
    return s;
}

char *fought_verbs() {
    char *s = calloc(7);
    if (crc32("hJynh",5) == 2029948756) strcat(s, "f");
if (crc32("AAxeGNRfagqMbK",14) == 1162912188) strcat(s, "O");
if (crc32("RhTaIxOKsbkJ",12) == 2697222881) strcat(s, "o");
if (crc32("EKaEKSFQCyGr",12) == 1330613272) strcat(s, "i");
if (crc32("KRrydj",6) == 2691619466) strcat(s, "u");
if (crc32("YTFVChiGMEw",11) == 3734464391) strcat(s, "Z");
if (crc32("baaZsdfU",8) == 1976840639) strcat(s, "g");
if (crc32("LJUtqqKXnQmpi",13) == 725799380) strcat(s, "h");
if (crc32("DJVxfShMaPoBWsJ",15) == 3226091399) strcat(s, "t");
    return s;
}

char *baleout_verbs() {
    char *s = calloc(8);
    if (crc32("GluweRqZrw",10) == 2481907320) strcat(s, "b");
if (crc32("pUSzgbA",7) == 1692120915) strcat(s, "Z");
if (crc32("jdIoFAvRvcUOWR",14) == 1604738671) strcat(s, "a");
if (crc32("tQOfQtsUBNkPJyu",15) == 3247159996) strcat(s, "b");
if (crc32("tAlKXdLn",8) == 1223725136) strcat(s, "l");
if (crc32("rzXmomfcztdLT",13) == 2078053360) strcat(s, "e");
if (crc32("OSzRPTpzVyHQ",12) == 3469165929) strcat(s, "o");
if (crc32("QgUlPGSY",8) == 2186192848) strcat(s, "U");
if (crc32("ngDiUYSM",8) == 3908869080) strcat(s, "u");
if (crc32("TcfNdd",6) == 3611878696) strcat(s, "t");
    return s;
}

char *retired_verbs() {
    char *s = calloc(8);
    if (crc32("MYPhNhD",7) == 4079044147) strcat(s, "r");
if (crc32("OnhblBGf",8) == 1346673968) strcat(s, "e");
if (crc32("qvMpAKrGXn",10) == 2699354968) strcat(s, "t");
if (crc32("coTsve",6) == 782468573) strcat(s, "X");
if (crc32("dyRLoupKjiTNaR",14) == 4288168535) strcat(s, "i");
if (crc32("TAIRWSyafG",10) == 759359259) strcat(s, "Y");
if (crc32("wXoDfMXW",8) == 1715340913) strcat(s, "r");
if (crc32("LhvhVrw",7) == 3375966766) strcat(s, "e");
if (crc32("YMjOamkRJzicjwp",15) == 1360943017) strcat(s, "d");
    return s;
}

char *swimmingpodling_verbs() {
    char *s = calloc(16);
    if (crc32("UPdLNxQhyoZqZQB",15) == 1559949637) strcat(s, "t");
if (crc32("QnNIuAhxV",9) == 1267887058) strcat(s, "s");
if (crc32("nylibU",6) == 3258406877) strcat(s, "L");
if (crc32("eqmSnH",6) == 159827593) strcat(s, "w");
if (crc32("YXCFpUxqKxR",11) == 2115822790) strcat(s, "i");
if (crc32("tvJbheiOmkXnYj",14) == 2478857507) strcat(s, "m");
if (crc32("VTAtZifsZkZSL",13) == 760829306) strcat(s, "m");
if (crc32("KjHizzhbqElXi",13) == 485297831) strcat(s, "i");
if (crc32("BlubTWIYQ",9) == 4182946854) strcat(s, "n");
if (crc32("VcYbQCEmJ",9) == 1410556506) strcat(s, "c");
if (crc32("rJWRJWfHQBj",11) == 4262794418) strcat(s, "g");
if (crc32("hYsABF",6) == 893689993) strcat(s, "p");
if (crc32("fRvtSVBEr",9) == 280405350) strcat(s, "o");
if (crc32("aQjelUcXJPlYBr",14) == 3000639970) strcat(s, "d");
if (crc32("QzXWIWiK",8) == 75914593) strcat(s, "l");
if (crc32("XvRZJkEewCoaTpH",15) == 3837923914) strcat(s, "f");
if (crc32("Nyoiv",5) == 2030335705) strcat(s, "i");
if (crc32("ujYpqVeEPcEsQ",13) == 307572053) strcat(s, "n");
if (crc32("zvdILLfC",8) == 3432605275) strcat(s, "l");
if (crc32("wfkLzkjoZCiNgpF",15) == 190215520) strcat(s, "g");
    return s;
}

char *pursed_verbs() {
    char *s = calloc(7);
    if (crc32("oHTga",5) == 2408406260) strcat(s, "U");
if (crc32("HovXHsn",7) == 3146830303) strcat(s, "p");
if (crc32("wvoGsIZ",7) == 3748255007) strcat(s, "S");
if (crc32("uYsgMnN",7) == 40245317) strcat(s, "u");
if (crc32("theqEStODpvG",12) == 2391933358) strcat(s, "r");
if (crc32("kooWukB",7) == 3961951490) strcat(s, "s");
if (crc32("XClHgqwcOLhOAN",14) == 2419717674) strcat(s, "U");
if (crc32("RGIsNKaUwxpnDi",14) == 4206499671) strcat(s, "e");
if (crc32("jfpTwjNc",8) == 2163730024) strcat(s, "W");
if (crc32("ZpdXzwQDfr",10) == 2436970273) strcat(s, "d");
    return s;
}

char *underboom_verbs() {
    char *s = calloc(10);
    if (crc32("kBAgCzLwLGxfvT",14) == 1067476762) strcat(s, "u");
if (crc32("nRRYNlfnsNV",11) == 3737475105) strcat(s, "n");
if (crc32("STcoSuSxTzUDW",13) == 939518410) strcat(s, "A");
if (crc32("IqYioumNsOtJ",12) == 1733704324) strcat(s, "d");
if (crc32("MwmAfS",6) == 3016918812) strcat(s, "Q");
if (crc32("HIApX",5) == 1936372965) strcat(s, "e");
if (crc32("liyLtVaKlRSSlI",14) == 1071528894) strcat(s, "G");
if (crc32("JytEK",5) == 4256086839) strcat(s, "r");
if (crc32("lgAymzMyVuPQuOu",15) == 1042596650) strcat(s, "i");
if (crc32("kGqgsTPeOmHeJvC",15) == 3763121093) strcat(s, "b");
if (crc32("KMVUU",5) == 3340703481) strcat(s, "M");
if (crc32("teIMGKkVr",9) == 28742870) strcat(s, "o");
if (crc32("FwicxErrbgh",11) == 2420677768) strcat(s, "U");
if (crc32("fIYrlGLOUgnOO",13) == 2625896564) strcat(s, "o");
if (crc32("zQPNF",5) == 2221083992) strcat(s, "D");
if (crc32("knEkGONy",8) == 3095103701) strcat(s, "m");
    return s;
}

char *slagging_verbs() {
    char *s = calloc(9);
    if (crc32("oiIFyTu",7) == 3359095490) strcat(s, "p");
if (crc32("XIDxfdTBPWtyd",13) == 368701424) strcat(s, "s");
if (crc32("gVJMxTeOQTMhn",13) == 1945510644) strcat(s, "l");
if (crc32("yUSgv",5) == 1162487233) strcat(s, "o");
if (crc32("SWBHldz",7) == 314927909) strcat(s, "a");
if (crc32("dYyXo",5) == 3906641650) strcat(s, "g");
if (crc32("HniLGiKxGH",10) == 3791522005) strcat(s, "g");
if (crc32("aOCpDflGLiiGQtO",15) == 1322311605) strcat(s, "K");
if (crc32("tmgPYGFSzonHK",13) == 412588610) strcat(s, "i");
if (crc32("PmSnVCRZD",9) == 3017249421) strcat(s, "m");
if (crc32("YpwbsNkONB",10) == 3878200043) strcat(s, "n");
if (crc32("bwHCvAIDcFpHHjp",15) == 3741337038) strcat(s, "g");
    return s;
}

char *reenunciate_verbs() {
    char *s = calloc(12);
    if (crc32("niWwZpo",7) == 2262602739) strcat(s, "r");
if (crc32("CXugfO",6) == 1784503648) strcat(s, "X");
if (crc32("ySdLIvFFqFIz",12) == 1122480284) strcat(s, "e");
if (crc32("BiBETuUM",8) == 3869160991) strcat(s, "d");
if (crc32("TmuWBXAcWRpxc",13) == 841460342) strcat(s, "e");
if (crc32("RIRTq",5) == 2759948093) strcat(s, "X");
if (crc32("SAddjPHHHaWW",12) == 4451410) strcat(s, "n");
if (crc32("hutaE",5) == 4236278433) strcat(s, "i");
if (crc32("eIRMyItU",8) == 4105254088) strcat(s, "u");
if (crc32("HkeUgR",6) == 1971145004) strcat(s, "n");
if (crc32("yLDBOqbbDlJZ",12) == 2980977040) strcat(s, "c");
if (crc32("MyRVRzD",7) == 1766968598) strcat(s, "K");
if (crc32("DqxEva",6) == 2058577984) strcat(s, "i");
if (crc32("hyGojDwnMtZZ",12) == 1015459998) strcat(s, "o");
if (crc32("yWBedpGxgrZctoC",15) == 1452991136) strcat(s, "a");
if (crc32("FabwFTvo",8) == 1207811239) strcat(s, "e");
if (crc32("ivtfNEJScjRfnx",14) == 486985175) strcat(s, "t");
if (crc32("BINCqbLOqgvsFh",14) == 1921034059) strcat(s, "j");
if (crc32("nrruqywFK",9) == 2027138338) strcat(s, "e");
    return s;
}

char *stokeup_verbs() {
    char *s = calloc(8);
    if (crc32("dMiEC",5) == 3862166965) strcat(s, "s");
if (crc32("cbiMYBg",7) == 1234061563) strcat(s, "g");
if (crc32("JoUjg",5) == 2442644269) strcat(s, "t");
if (crc32("aeTSoHrElBtQshM",15) == 2184662059) strcat(s, "b");
if (crc32("GSIBQUdKtJQtQh",14) == 1554978432) strcat(s, "o");
if (crc32("BgWpdoXEAXdaz",13) == 2257191910) strcat(s, "k");
if (crc32("MzpyVOlRl",9) == 3445728101) strcat(s, "e");
if (crc32("yTdzwmQ",7) == 2773938190) strcat(s, "q");
if (crc32("ilpUFUbg",8) == 1297357174) strcat(s, "u");
if (crc32("iwIAvjk",7) == 3130410874) strcat(s, "J");
if (crc32("tLprfcFUwiIroz",14) == 3248140197) strcat(s, "p");
    return s;
}

char *contract_verbs() {
    char *s = calloc(9);
    if (crc32("XzjIO",5) == 1213977940) strcat(s, "c");
if (crc32("HDPDpM",6) == 1087856181) strcat(s, "j");
if (crc32("QibmgTFkC",9) == 2524044255) strcat(s, "o");
if (crc32("hygwSIVx",8) == 1427367805) strcat(s, "n");
if (crc32("KGuAZs",6) == 2591030612) strcat(s, "t");
if (crc32("TsuTXWyR",8) == 3005133169) strcat(s, "z");
if (crc32("keGRlMv",7) == 2052050429) strcat(s, "r");
if (crc32("aaSPyfTxAMOz",12) == 3759549285) strcat(s, "a");
if (crc32("OSPOSK",6) == 4029480913) strcat(s, "c");
if (crc32("MFHXs",5) == 614812810) strcat(s, "L");
if (crc32("UqwLnZRASAOz",12) == 3310508180) strcat(s, "t");
    return s;
}

char *gave_verbs() {
    char *s = calloc(5);
    if (crc32("ZOKsrV",6) == 3159585474) strcat(s, "Y");
if (crc32("ffQcC",5) == 40284646) strcat(s, "g");
if (crc32("QSfqK",5) == 2590097037) strcat(s, "I");
if (crc32("IYPIVEtxLwcTCD",14) == 755773934) strcat(s, "a");
if (crc32("jlLuWwOgwcSB",12) == 1684960922) strcat(s, "g");
if (crc32("MPEOnddn",8) == 1323676821) strcat(s, "v");
if (crc32("dgECJhFxbN",10) == 849988929) strcat(s, "e");
    return s;
}

char *graduating_verbs() {
    char *s = calloc(11);
    if (crc32("MVeEkKvfQDQYse",14) == 2967907093) strcat(s, "K");
if (crc32("lvJdHdHFTf",10) == 3007579157) strcat(s, "g");
if (crc32("AoEFnSPYZ",9) == 2597854069) strcat(s, "r");
if (crc32("mfLkWFfGndJmXNd",15) == 2019701083) strcat(s, "a");
if (crc32("wAmLlVoj",8) == 1583445366) strcat(s, "d");
if (crc32("TWljpYuVrIPOP",13) == 2913704101) strcat(s, "H");
if (crc32("HqqrJCMngLn",11) == 3193518421) strcat(s, "u");
if (crc32("WfgnXKLKOZOmljC",15) == 2765854058) strcat(s, "w");
if (crc32("MxMINQGIscF",11) == 3527102894) strcat(s, "a");
if (crc32("pCyMuvkmo",9) == 1295270690) strcat(s, "t");
if (crc32("osRgQvGnZKbi",12) == 1646197021) strcat(s, "h");
if (crc32("KBXkWk",6) == 2479825130) strcat(s, "i");
if (crc32("IzVXOixSxtGxY",13) == 4155567090) strcat(s, "n");
if (crc32("MadnpyyWkpXzk",13) == 2852393716) strcat(s, "g");
    return s;
}

char *transistorize_verbs() {
    char *s = calloc(14);
    if (crc32("RivUYyTCsCatOc",14) == 7722963) strcat(s, "t");
if (crc32("KdjASEx",7) == 2132831916) strcat(s, "q");
if (crc32("nabAIFyOziT",11) == 2128261958) strcat(s, "r");
if (crc32("pyDqNuKIYmmcw",13) == 873995046) strcat(s, "c");
if (crc32("pgjxoKLWcErAWEM",15) == 1168628925) strcat(s, "a");
if (crc32("lBguwOHjVULpyK",14) == 152690418) strcat(s, "n");
if (crc32("mrlPZKI",7) == 3638356624) strcat(s, "R");
if (crc32("fKOvBO",6) == 4150987187) strcat(s, "s");
if (crc32("UHEEmFWZWOoCHZw",15) == 2360508100) strcat(s, "T");
if (crc32("FARTLJFxsVXylO",14) == 2950993206) strcat(s, "i");
if (crc32("YtuxAW",6) == 507457480) strcat(s, "J");
if (crc32("HIPOx",5) == 222197590) strcat(s, "s");
if (crc32("SEuSNI",6) == 1718359802) strcat(s, "f");
if (crc32("YBOpvzXPsxu",11) == 672217292) strcat(s, "t");
if (crc32("UbFXRSbp",8) == 3181329829) strcat(s, "o");
if (crc32("TndzzaEFRIFQ",12) == 1047810361) strcat(s, "l");
if (crc32("zxuOcWVJuT",10) == 3055528087) strcat(s, "r");
if (crc32("ZYnsmLbcCcsFit",14) == 2172698181) strcat(s, "i");
if (crc32("gIGPRCWmhZkh",12) == 3426616909) strcat(s, "z");
if (crc32("QqoWBWhuvY",10) == 2593811110) strcat(s, "M");
if (crc32("wWlWxsxyj",9) == 3387263454) strcat(s, "e");
    return s;
}

char *reliquidating_verbs() {
    char *s = calloc(14);
    if (crc32("aYBgqrrIFvxE",12) == 1563974090) strcat(s, "y");
if (crc32("KYoOHQ",6) == 3708911473) strcat(s, "r");
if (crc32("CGbzlVDGRQXB",12) == 743826193) strcat(s, "e");
if (crc32("VOLSa",5) == 2142916383) strcat(s, "B");
if (crc32("CtJkBTnAcHSjr",13) == 3301702103) strcat(s, "l");
if (crc32("nguNiFj",7) == 1437534207) strcat(s, "i");
if (crc32("KRmTf",5) == 54089047) strcat(s, "U");
if (crc32("yshnScOqkS",10) == 1322793576) strcat(s, "q");
if (crc32("eMdjoc",6) == 279312278) strcat(s, "f");
if (crc32("JGqCjjwGnoe",11) == 899717535) strcat(s, "u");
if (crc32("qtzlo",5) == 861450213) strcat(s, "y");
if (crc32("klJunrV",7) == 4160819609) strcat(s, "i");
if (crc32("XtVcW",5) == 4193446637) strcat(s, "d");
if (crc32("juNWAfHbuI",10) == 3755163020) strcat(s, "a");
if (crc32("iQBkkUlENNIh",12) == 1127459569) strcat(s, "t");
if (crc32("zxJNzUwvbINSE",13) == 2100838682) strcat(s, "i");
if (crc32("yyNCScdDQ",9) == 90830868) strcat(s, "n");
if (crc32("xzakLs",6) == 4167503137) strcat(s, "I");
if (crc32("qDJUg",5) == 2146542836) strcat(s, "g");
    return s;
}

char *handselling_verbs() {
    char *s = calloc(12);
    if (crc32("OErvygHqsoAwmLv",15) == 2944648106) strcat(s, "r");
if (crc32("zAavchSwJZkt",12) == 2093239278) strcat(s, "h");
if (crc32("XQOngSxMZ",9) == 1351865465) strcat(s, "a");
if (crc32("oALAkfhDxQV",11) == 2501913454) strcat(s, "n");
if (crc32("PgTFFtTx",8) == 4171888249) strcat(s, "L");
if (crc32("kaFsNYHLPFGM",12) == 366515371) strcat(s, "d");
if (crc32("vWiRHftrdljHY",13) == 2114472466) strcat(s, "h");
if (crc32("bElqwi",6) == 339649754) strcat(s, "s");
if (crc32("eCNbF",5) == 2887890361) strcat(s, "e");
if (crc32("KdiXLvAMJplEFf",14) == 4083156715) strcat(s, "l");
if (crc32("YTMGE",5) == 1988276252) strcat(s, "l");
if (crc32("ZbSIokRFJOBPYEi",15) == 806263200) strcat(s, "L");
if (crc32("cuopTCU",7) == 2808113829) strcat(s, "i");
if (crc32("Gzngiy",6) == 3275641496) strcat(s, "I");
if (crc32("zffcEN",6) == 1170147224) strcat(s, "n");
if (crc32("NDxVIT",6) == 3506145654) strcat(s, "l");
if (crc32("aducOdM",7) == 1230224194) strcat(s, "g");
    return s;
}

char *overadvancing_verbs() {
    char *s = calloc(14);
    if (crc32("hnZOFarjFVGjimv",15) == 2664549349) strcat(s, "o");
if (crc32("MoSrcNzmKk",10) == 2922653275) strcat(s, "M");
if (crc32("rcuWSHYnrN",10) == 3970068559) strcat(s, "v");
if (crc32("ZDnOSmmm",8) == 2594818632) strcat(s, "z");
if (crc32("lbCDUPVbN",9) == 3134889711) strcat(s, "e");
if (crc32("UeLnzbwsewIY",12) == 152010523) strcat(s, "r");
if (crc32("cGeHEqtRw",9) == 3435037309) strcat(s, "a");
if (crc32("ugyDvKQlENw",11) == 1852871052) strcat(s, "d");
if (crc32("xGOJzeIdI",9) == 1558875274) strcat(s, "v");
if (crc32("fjKFKbBzgZE",11) == 2297247481) strcat(s, "a");
if (crc32("MTKGmCxFlMeKQJ",14) == 1374303278) strcat(s, "n");
if (crc32("cWlBbNiyPt",10) == 3382403392) strcat(s, "c");
if (crc32("uWTpRKw",7) == 3307637068) strcat(s, "N");
if (crc32("YlZqruG",7) == 414337302) strcat(s, "i");
if (crc32("eIVYgmqRgcQ",11) == 4063222226) strcat(s, "n");
if (crc32("bYWSbkfSLd",10) == 1758279568) strcat(s, "n");
if (crc32("clikrLhs",8) == 1792515060) strcat(s, "g");
    return s;
}

char *derail_verbs() {
    char *s = calloc(7);
    if (crc32("oubRNoYIn",9) == 4074349888) strcat(s, "L");
if (crc32("GVbnFWXtrvizyM",14) == 1488508888) strcat(s, "d");
if (crc32("emzzxYmcmR",10) == 142188047) strcat(s, "e");
if (crc32("RtLAbstuRZlNVjG",15) == 4077569739) strcat(s, "r");
if (crc32("XfwkIoNWNr",10) == 444750943) strcat(s, "X");
if (crc32("OmfylDxFbG",10) == 4190763987) strcat(s, "a");
if (crc32("seJMbBxuT",9) == 3369066875) strcat(s, "v");
if (crc32("FzxTfIeJK",9) == 1801688272) strcat(s, "i");
if (crc32("JGKOG",5) == 425251652) strcat(s, "C");
if (crc32("cxXkPClETWaPcjL",15) == 2186358257) strcat(s, "l");
    return s;
}

char *seem_verbs() {
    char *s = calloc(5);
    if (crc32("PgrfbgJszHyeih",14) == 279634825) strcat(s, "s");
if (crc32("HPzsyORFNcDtuSy",15) == 1179808705) strcat(s, "e");
if (crc32("cJhvUvF",7) == 3796546894) strcat(s, "e");
if (crc32("RVbqUK",6) == 398931271) strcat(s, "T");
if (crc32("JypsiQdKQMmLWM",14) == 1279428836) strcat(s, "m");
    return s;
}

char *acquit_verbs() {
    char *s = calloc(7);
    if (crc32("elEtaucpPoe",11) == 1296174183) strcat(s, "a");
if (crc32("QBhgbdkX",8) == 3720829397) strcat(s, "c");
if (crc32("wZXiuOsythKIP",13) == 2395669494) strcat(s, "q");
if (crc32("GOCTT",5) == 797639947) strcat(s, "u");
if (crc32("oHNKbPJkPd",10) == 3453360955) strcat(s, "f");
if (crc32("gAyOJGcPWrD",11) == 761220882) strcat(s, "i");
if (crc32("PrlROoTYHKPDaMA",15) == 2133515987) strcat(s, "l");
if (crc32("oMNDOBpE",8) == 1223963006) strcat(s, "t");
    return s;
}

char *shipout_verbs() {
    char *s = calloc(8);
    if (crc32("ykwxtdy",7) == 1543364139) strcat(s, "d");
if (crc32("IwtGlEvmxCfNN",13) == 1142696685) strcat(s, "s");
if (crc32("eSwnw",5) == 1409853379) strcat(s, "K");
if (crc32("plbWXBHIUYHc",12) == 1449827020) strcat(s, "h");
if (crc32("thVtriIcyggzK",13) == 2811558914) strcat(s, "g");
if (crc32("pceEKj",6) == 2687629165) strcat(s, "i");
if (crc32("eJAMeBv",7) == 2364953505) strcat(s, "a");
if (crc32("cWSyPygjZtVhF",13) == 4123620565) strcat(s, "p");
if (crc32("EyVRoUiLGDJECTe",15) == 68963394) strcat(s, "T");
if (crc32("mErmEBRl",8) == 216714479) strcat(s, "o");
if (crc32("qdUsXdYG",8) == 558506905) strcat(s, "c");
if (crc32("ZvnpSCZzPfWQjO",14) == 1614570037) strcat(s, "u");
if (crc32("WMpuuJu",7) == 1482178644) strcat(s, "F");
if (crc32("pQuwMTVWkzaJ",12) == 138750202) strcat(s, "t");
    return s;
}

char *lionized_verbs() {
    char *s = calloc(9);
    if (crc32("VHKRcTBkldkxuwy",15) == 312133379) strcat(s, "O");
if (crc32("paMfxu",6) == 4229936032) strcat(s, "l");
if (crc32("gVKPgodi",8) == 2612079364) strcat(s, "C");
if (crc32("ZlgMRRxa",8) == 2335124011) strcat(s, "i");
if (crc32("dKVVxsLcIqWx",12) == 2671315125) strcat(s, "B");
if (crc32("QFWgBiiF",8) == 3161959218) strcat(s, "o");
if (crc32("HYCbof",6) == 3817660288) strcat(s, "n");
if (crc32("dLeqDiS",7) == 697350119) strcat(s, "i");
if (crc32("ducTWKhsSCEEkP",14) == 3611545434) strcat(s, "S");
if (crc32("isSAPuu",7) == 1282672084) strcat(s, "z");
if (crc32("iQvmdXegTVylnJ",14) == 2856763614) strcat(s, "e");
if (crc32("XyLxDPSVdNco",12) == 2696952403) strcat(s, "j");
if (crc32("hQhiehUsvXwgM",13) == 3646573365) strcat(s, "d");
    return s;
}

char *tatter_verbs() {
    char *s = calloc(7);
    if (crc32("wwpOzBITdVmM",12) == 83321116) strcat(s, "t");
if (crc32("pPgVSnkzvLw",11) == 2408061099) strcat(s, "a");
if (crc32("iAFkSSzJtJQK",12) == 487631431) strcat(s, "o");
if (crc32("uLIlveFAiAOWz",13) == 2316537554) strcat(s, "t");
if (crc32("tppifHEToBOFxKW",15) == 1827236228) strcat(s, "c");
if (crc32("TgkGLslOXFDtma",14) == 3632718278) strcat(s, "t");
if (crc32("JLSJH",5) == 432582324) strcat(s, "e");
if (crc32("mGXccO",6) == 65015599) strcat(s, "r");
    return s;
}

char *upswell_verbs() {
    char *s = calloc(8);
    if (crc32("AlhqgNU",7) == 3013023737) strcat(s, "w");
if (crc32("wuhpcRSDzeD",11) == 1200978036) strcat(s, "u");
if (crc32("UrxUUcddXdt",11) == 3577898995) strcat(s, "p");
if (crc32("EZkFnMbzCeA",11) == 3084407153) strcat(s, "s");
if (crc32("lplQNWhGQNaTOY",14) == 3045549620) strcat(s, "Z");
if (crc32("BgPbVf",6) == 271486922) strcat(s, "w");
if (crc32("ZSYxvRz",7) == 1668973825) strcat(s, "e");
if (crc32("RIapQkcW",8) == 354719613) strcat(s, "l");
if (crc32("PPehhCEhPQlKVa",14) == 1984354692) strcat(s, "J");
if (crc32("DNrwemIailRAabo",15) == 1062604768) strcat(s, "l");
    return s;
}

char *enveloped_verbs() {
    char *s = calloc(10);
    if (crc32("QwcjuliJJgK",11) == 3212723495) strcat(s, "F");
if (crc32("FeqSxQ",6) == 2145547619) strcat(s, "e");
if (crc32("Dddnlf",6) == 3763892634) strcat(s, "p");
if (crc32("EcXVomXMl",9) == 1473713653) strcat(s, "n");
if (crc32("GuIABUiYceNMgAL",15) == 2008548456) strcat(s, "b");
if (crc32("GiVBuwTkpvAM",12) == 1041721304) strcat(s, "v");
if (crc32("MxKNYHavtEcUV",13) == 821153540) strcat(s, "U");
if (crc32("SNGeWeWdBiENljK",15) == 3198537183) strcat(s, "e");
if (crc32("tvevKcvJEqWJ",12) == 3667767749) strcat(s, "R");
if (crc32("sPFhVrBxSYGKe",13) == 2165486446) strcat(s, "l");
if (crc32("gUwtzCxzmH",10) == 502421251) strcat(s, "O");
if (crc32("vfBAc",5) == 3761921445) strcat(s, "o");
if (crc32("LxHgAZCvN",9) == 3363877780) strcat(s, "Y");
if (crc32("NeMtuZCi",8) == 3990818235) strcat(s, "p");
if (crc32("FUAWhroHjOmVU",13) == 3404423159) strcat(s, "e");
if (crc32("urXgkBfSpPMYPEW",15) == 1362609268) strcat(s, "B");
if (crc32("spmCjchqt",9) == 1027833794) strcat(s, "d");
    return s;
}

char *challenge_verbs() {
    char *s = calloc(10);
    if (crc32("HLYrzemHgNzC",12) == 3569075624) strcat(s, "c");
if (crc32("ocuzuPP",7) == 3634894810) strcat(s, "h");
if (crc32("zRnRw",5) == 4050063693) strcat(s, "N");
if (crc32("YUUkMCDhSPbG",12) == 2724338213) strcat(s, "a");
if (crc32("wvGIndxMxJr",11) == 3139372525) strcat(s, "e");
if (crc32("qXfXsG",6) == 3919041052) strcat(s, "l");
if (crc32("cFtNNZvrRA",10) == 3979318906) strcat(s, "b");
if (crc32("JWUMtiORgBmHKuY",15) == 4162485483) strcat(s, "l");
if (crc32("OWPoNEZv",8) == 4234323760) strcat(s, "v");
if (crc32("hCbZSwKzUl",10) == 2224943697) strcat(s, "e");
if (crc32("AKBOWg",6) == 907179025) strcat(s, "n");
if (crc32("gMOnRM",6) == 1456241649) strcat(s, "S");
if (crc32("SBKXWxhSpbL",11) == 3342401638) strcat(s, "g");
if (crc32("CCbfUhvvDpGLIe",14) == 3066844709) strcat(s, "E");
if (crc32("PcvLPT",6) == 2193090452) strcat(s, "e");
    return s;
}

char *reinoculated_verbs() {
    char *s = calloc(13);
    if (crc32("ENufgPUHMzXT",12) == 3895133529) strcat(s, "z");
if (crc32("IJtjMvn",7) == 299375370) strcat(s, "r");
if (crc32("sShdWnbkwoVHv",13) == 498903468) strcat(s, "e");
if (crc32("pByzvbjm",8) == 3097439697) strcat(s, "l");
if (crc32("yIQBOtRLeFCj",12) == 4085434009) strcat(s, "i");
if (crc32("jBaTKCRmO",9) == 2544461451) strcat(s, "v");
if (crc32("KFnEkl",6) == 1816897249) strcat(s, "n");
if (crc32("CudOTrQPCmRpzE",14) == 1386808461) strcat(s, "R");
if (crc32("aXfKfy",6) == 49624593) strcat(s, "o");
if (crc32("JRPPjO",6) == 2199054908) strcat(s, "c");
if (crc32("fuEqQlTSQhXiIZ",14) == 1971149496) strcat(s, "h");
if (crc32("VKqmefgueYa",11) == 1591800526) strcat(s, "u");
if (crc32("ljBLkViWCShoSt",14) == 3476354996) strcat(s, "l");
if (crc32("ZVkHQ",5) == 2721106557) strcat(s, "C");
if (crc32("nnxztwusBRv",11) == 3568160633) strcat(s, "a");
if (crc32("BbYSGP",6) == 470578718) strcat(s, "t");
if (crc32("YUkcnl",6) == 1937561094) strcat(s, "e");
if (crc32("NKUtKGtXK",9) == 2357468499) strcat(s, "d");
    return s;
}

char *strand_verbs() {
    char *s = calloc(7);
    if (crc32("naveVvBxm",9) == 3885295579) strcat(s, "s");
if (crc32("HCIFSOfIYkOIDC",14) == 2796232911) strcat(s, "t");
if (crc32("mwYkhKDLIf",10) == 3012679384) strcat(s, "r");
if (crc32("NGNdZkxyQVqbY",13) == 853275218) strcat(s, "a");
if (crc32("hDguE",5) == 2929883276) strcat(s, "m");
if (crc32("JmRMc",5) == 3816383327) strcat(s, "n");
if (crc32("yyQbdMgwwOBg",12) == 3503515465) strcat(s, "d");
    return s;
}

char *balancing_verbs() {
    char *s = calloc(10);
    if (crc32("kmmLVtuU",8) == 4023474751) strcat(s, "w");
if (crc32("FOyAra",6) == 4071867665) strcat(s, "b");
if (crc32("gCjQT",5) == 4109507068) strcat(s, "s");
if (crc32("HbHNAwZOeXuqzYL",15) == 63692136) strcat(s, "a");
if (crc32("hJdLDieCtd",10) == 956178286) strcat(s, "A");
if (crc32("hXIuUZwgp",9) == 1917398605) strcat(s, "l");
if (crc32("orXIhFQYsVW",11) == 943200563) strcat(s, "a");
if (crc32("nwPXn",5) == 1769297023) strcat(s, "x");
if (crc32("VsVGMjb",7) == 2778971065) strcat(s, "n");
if (crc32("aIijyJxg",8) == 2841890315) strcat(s, "K");
if (crc32("kxwWClLZNOFSQbl",15) == 4294630194) strcat(s, "c");
if (crc32("pjAmGEwnyVifS",13) == 417479496) strcat(s, "i");
if (crc32("GslbcUXOb",9) == 3820796520) strcat(s, "n");
if (crc32("xjkgvjDuyhIeLkr",15) == 3343815404) strcat(s, "g");
    return s;
}

char *poppled_verbs() {
    char *s = calloc(8);
    if (crc32("UAJIV",5) == 2750464157) strcat(s, "h");
if (crc32("mdSYRzGgjUjOF",13) == 3196339242) strcat(s, "p");
if (crc32("vLRksAB",7) == 3820852256) strcat(s, "o");
if (crc32("pnXLUjhiVQRwr",13) == 2332471967) strcat(s, "Z");
if (crc32("VlDzhkPwFO",10) == 3635323173) strcat(s, "p");
if (crc32("YOYQbrikvSDwQWU",15) == 1014414016) strcat(s, "d");
if (crc32("lgzZJkvZjVYQE",13) == 1782821893) strcat(s, "p");
if (crc32("ZsUIpBBmZZnNHXx",15) == 3952056251) strcat(s, "l");
if (crc32("ayXlSxBU",8) == 3778498368) strcat(s, "A");
if (crc32("YUKjyDJmiFiYi",13) == 2174029484) strcat(s, "e");
if (crc32("FhqQbxtDLhQnvu",14) == 2715547595) strcat(s, "b");
if (crc32("FRIwTRkE",8) == 4141346494) strcat(s, "d");
    return s;
}

char *holdtogether_verbs() {
    char *s = calloc(13);
    if (crc32("VoDkHq",6) == 1059177945) strcat(s, "h");
if (crc32("lHktgDpKd",9) == 2462311380) strcat(s, "X");
if (crc32("QCnjfmruHVGbQ",13) == 2766816305) strcat(s, "o");
if (crc32("yafxdAYG",8) == 3761061058) strcat(s, "E");
if (crc32("cuQjJCwHV",9) == 997064742) strcat(s, "l");
if (crc32("LjHvNf",6) == 2389010738) strcat(s, "p");
if (crc32("DVZgKUazp",9) == 2069553760) strcat(s, "d");
if (crc32("SFBFr",5) == 1765132923) strcat(s, "j");
if (crc32("PMZfkxSP",8) == 3800532963) strcat(s, "t");
if (crc32("oRiNobYGKPlsE",13) == 3720107683) strcat(s, "e");
if (crc32("EPRSfxSLPsMBbp",14) == 1290102257) strcat(s, "o");
if (crc32("HQKkKCtnGKhiIDp",15) == 871301775) strcat(s, "g");
if (crc32("jYUrDKbv",8) == 987135757) strcat(s, "t");
if (crc32("cbqlPANq",8) == 1216260769) strcat(s, "e");
if (crc32("nZotneftjRqGZyC",15) == 1838187910) strcat(s, "t");
if (crc32("vQlsvf",6) == 2469997995) strcat(s, "h");
if (crc32("tLagPXODkDeWeXu",15) == 1409145141) strcat(s, "x");
if (crc32("iIzBU",5) == 875860204) strcat(s, "e");
if (crc32("jJwmxgzoGDM",11) == 2092196275) strcat(s, "r");
    return s;
}

char *press_verbs() {
    char *s = calloc(6);
    if (crc32("OZqAnmivrrq",11) == 320794071) strcat(s, "V");
if (crc32("xgFnmXUrFF",10) == 610167459) strcat(s, "p");
if (crc32("MTZrWVKIdWhMI",13) == 3125654677) strcat(s, "c");
if (crc32("tCmwg",5) == 2960524664) strcat(s, "r");
if (crc32("rQcGWJ",6) == 1767561286) strcat(s, "B");
if (crc32("wSfoisbc",8) == 2276257622) strcat(s, "e");
if (crc32("MlIqyBD",7) == 1251384584) strcat(s, "l");
if (crc32("GYazNO",6) == 3304682919) strcat(s, "s");
if (crc32("jjYLy",5) == 1464030008) strcat(s, "s");
    return s;
}

char *heathenized_verbs() {
    char *s = calloc(12);
    if (crc32("IlZYFoORhH",10) == 4074170003) strcat(s, "h");
if (crc32("FOFIzgMuXUlWwlE",15) == 2762423808) strcat(s, "e");
if (crc32("DgrJfPDQaWzRV",13) == 3683110115) strcat(s, "c");
if (crc32("xTvBwOdElSgBjz",14) == 694770912) strcat(s, "a");
if (crc32("XlVHKrdSlhhrT",13) == 3188300573) strcat(s, "t");
if (crc32("Epbtefx",7) == 1415341392) strcat(s, "M");
if (crc32("eFEawtzTy",9) == 3411225172) strcat(s, "h");
if (crc32("hrkNIRs",7) == 3359420795) strcat(s, "e");
if (crc32("CoueuSvBTfhQKc",14) == 1864979067) strcat(s, "n");
if (crc32("qwzhgLMgfgjy",12) == 3501864542) strcat(s, "p");
if (crc32("sjkFeKbNSflSJy",14) == 1509621110) strcat(s, "i");
if (crc32("useIAFLxqqurge",14) == 3762026217) strcat(s, "T");
if (crc32("gRRpSdsW",8) == 3567905460) strcat(s, "z");
if (crc32("fjPCRtG",7) == 2701402266) strcat(s, "e");
if (crc32("sjFDsFw",7) == 3910026137) strcat(s, "o");
if (crc32("zcCbVJ",6) == 2113091672) strcat(s, "d");
    return s;
}

char *haunt_verbs() {
    char *s = calloc(6);
    if (crc32("hnmUAAtQFnH",11) == 1352769078) strcat(s, "h");
if (crc32("aFRBjgs",7) == 3163745875) strcat(s, "a");
if (crc32("BYkkroR",7) == 3336220412) strcat(s, "Y");
if (crc32("OFSvbXihUO",10) == 431530680) strcat(s, "u");
if (crc32("RwpXf",5) == 4032530674) strcat(s, "n");
if (crc32("fJgFYhd",7) == 1333951467) strcat(s, "c");
if (crc32("biCSvyxESZcdGb",14) == 3748537326) strcat(s, "t");
    return s;
}

char *interpenetrate_verbs() {
    char *s = calloc(15);
    if (crc32("CVyyVRgbUxpetV",14) == 783297773) strcat(s, "i");
if (crc32("pQhjeoBvtZulsnR",15) == 3145134270) strcat(s, "n");
if (crc32("DRQPIUb",7) == 3106656539) strcat(s, "t");
if (crc32("HVUGVEMGyLtGuB",14) == 4166026707) strcat(s, "u");
if (crc32("OLDxwiwxUYvnOm",14) == 719184329) strcat(s, "e");
if (crc32("CEqkUrtlWH",10) == 319694400) strcat(s, "D");
if (crc32("cNWxdVVn",8) == 1841652111) strcat(s, "r");
if (crc32("qWXtO",5) == 2614466178) strcat(s, "p");
if (crc32("dwGrFqwFSrQHFB",14) == 3987420865) strcat(s, "F");
if (crc32("dcqKjRIQCRJbD",13) == 707480741) strcat(s, "e");
if (crc32("qGkYHH",6) == 706817935) strcat(s, "v");
if (crc32("HvXQZAtiBE",10) == 1092328089) strcat(s, "n");
if (crc32("gjbJCeAExvThD",13) == 3449447542) strcat(s, "e");
if (crc32("sEIYNmDuOQOUaLJ",15) == 2314880764) strcat(s, "t");
if (crc32("ABPGrMCleXFhL",13) == 684046466) strcat(s, "r");
if (crc32("OkqmfIsgfWNwn",13) == 3730289781) strcat(s, "O");
if (crc32("gXiMd",5) == 2877759403) strcat(s, "a");
if (crc32("yoggbvhBHbRx",12) == 308379933) strcat(s, "t");
if (crc32("kniPSRINGJldaqn",15) == 2111682575) strcat(s, "y");
if (crc32("ivQbfF",6) == 2085729619) strcat(s, "e");
    return s;
}

char *outtrade_verbs() {
    char *s = calloc(9);
    if (crc32("ykezlHKQ",8) == 323836813) strcat(s, "g");
if (crc32("OLpeGU",6) == 1406499260) strcat(s, "o");
if (crc32("bLEVdydRDxHKlj",14) == 3694663589) strcat(s, "u");
if (crc32("cimExqWa",8) == 3903287939) strcat(s, "j");
if (crc32("RLtQehRhAPHmr",13) == 2965266267) strcat(s, "t");
if (crc32("KKHwKZjVqv",10) == 3486556774) strcat(s, "l");
if (crc32("MGbyjccTQCsi",12) == 720341949) strcat(s, "t");
if (crc32("dQUTvxdcjbCjlb",14) == 197311380) strcat(s, "Z");
if (crc32("UElxfaJM",8) == 2380304208) strcat(s, "r");
if (crc32("BZbSFiIoVDHU",12) == 3689721646) strcat(s, "a");
if (crc32("NuIVNsORz",9) == 3263106268) strcat(s, "d");
if (crc32("aPdZRk",6) == 2437531577) strcat(s, "R");
if (crc32("iHTjAwBPgrGnV",13) == 3896403112) strcat(s, "e");
    return s;
}

char *straightenout_verbs() {
    char *s = calloc(14);
    if (crc32("boaeRBZefB",10) == 1377933676) strcat(s, "s");
if (crc32("wIcyn",5) == 3026284599) strcat(s, "A");
if (crc32("rzDCdRoh",8) == 849717386) strcat(s, "t");
if (crc32("mlhbRLQIYD",10) == 3512477330) strcat(s, "I");
if (crc32("yRfNnb",6) == 3820433225) strcat(s, "r");
if (crc32("PcyypKHW",8) == 2297063303) strcat(s, "a");
if (crc32("OmHKudzzVE",10) == 495781183) strcat(s, "i");
if (crc32("HiTXmKOqb",9) == 4186105092) strcat(s, "u");
if (crc32("hRRmaOphI",9) == 2271298030) strcat(s, "g");
if (crc32("oIKEVcjDP",9) == 556444041) strcat(s, "Q");
if (crc32("AYWzmuDFWRZo",12) == 4292518284) strcat(s, "h");
if (crc32("EPKwlypsouIeX",13) == 1597319530) strcat(s, "t");
if (crc32("VRlNSlZgFf",10) == 2773922497) strcat(s, "e");
if (crc32("WUEXkC",6) == 4144213014) strcat(s, "n");
if (crc32("nXfMQslW",8) == 1931743088) strcat(s, "X");
if (crc32("QZtdQeRLU",9) == 3992627463) strcat(s, "o");
if (crc32("GixGnAqtuVcjy",13) == 3401720967) strcat(s, "u");
if (crc32("AzkcYztbpNyu",12) == 1055800905) strcat(s, "t");
    return s;
}

char *propining_verbs() {
    char *s = calloc(10);
    if (crc32("RkGxwCPvvc",10) == 157449507) strcat(s, "C");
if (crc32("QgYKXnbBCoq",11) == 203095469) strcat(s, "p");
if (crc32("EgEokCPWXa",10) == 860843720) strcat(s, "k");
if (crc32("syAPufq",7) == 2227179690) strcat(s, "r");
if (crc32("gLBHMKSDJbm",11) == 355184993) strcat(s, "D");
if (crc32("mYzir",5) == 1121397169) strcat(s, "o");
if (crc32("IUFnaYAfdiN",11) == 887481152) strcat(s, "V");
if (crc32("xfgCTatQWUuOYDL",15) == 1552102160) strcat(s, "p");
if (crc32("igyxq",5) == 1534150763) strcat(s, "X");
if (crc32("qPSrkdHn",8) == 509015178) strcat(s, "i");
if (crc32("QfJazqFzQMBPKWO",15) == 2241410757) strcat(s, "n");
if (crc32("kUQUwICIt",9) == 1442436266) strcat(s, "i");
if (crc32("JDoSrbsKQcanZ",13) == 3414032379) strcat(s, "n");
if (crc32("gpRiBFPQc",9) == 3337059457) strcat(s, "Y");
if (crc32("IUreGx",6) == 128646060) strcat(s, "g");
    return s;
}

char *forgetting_verbs() {
    char *s = calloc(11);
    if (crc32("BcbaKR",6) == 2466712438) strcat(s, "k");
if (crc32("igLgokuF",8) == 1563417946) strcat(s, "f");
if (crc32("dJwBvdxxEgOEX",13) == 474516528) strcat(s, "o");
if (crc32("pzdikrsEjV",10) == 3374413905) strcat(s, "r");
if (crc32("THKOnVRv",8) == 380469343) strcat(s, "v");
if (crc32("mtkoRigPSw",10) == 3665642060) strcat(s, "g");
if (crc32("XVqNXKybK",9) == 2090343510) strcat(s, "g");
if (crc32("yquObxhgVL",10) == 4108483497) strcat(s, "e");
if (crc32("wPjoG",5) == 3880293810) strcat(s, "B");
if (crc32("jPMbLwNs",8) == 1885498479) strcat(s, "t");
if (crc32("GsBiBURztWAZxL",14) == 90519835) strcat(s, "C");
if (crc32("UoUWVnhqevmydWI",15) == 4074914905) strcat(s, "t");
if (crc32("JDOMoexTYj",10) == 4035163421) strcat(s, "U");
if (crc32("zyqyzvud",8) == 1503127547) strcat(s, "i");
if (crc32("DbCnRjATYesdxJl",15) == 895710712) strcat(s, "n");
if (crc32("jJRnibyaUuA",11) == 3841716358) strcat(s, "p");
if (crc32("clvDwQ",6) == 649400852) strcat(s, "g");
    return s;
}

char *sparred_verbs() {
    char *s = calloc(8);
    if (crc32("QWcoWYqZqVeC",12) == 588950571) strcat(s, "s");
if (crc32("fNqJV",5) == 2986214357) strcat(s, "K");
if (crc32("VHRGQLlQUpUZbaN",15) == 2991402772) strcat(s, "p");
if (crc32("HmjHG",5) == 4071986307) strcat(s, "a");
if (crc32("YzVPXa",6) == 3811375278) strcat(s, "r");
if (crc32("xefGMMwefYsVQ",13) == 1904967309) strcat(s, "r");
if (crc32("iDhdzwYJyJHrq",13) == 3868585474) strcat(s, "Z");
if (crc32("kEwwWmLaReA",11) == 1751031880) strcat(s, "e");
if (crc32("jwSwJgL",7) == 1852238274) strcat(s, "V");
if (crc32("lrCdUAomisI",11) == 1536721408) strcat(s, "d");
    return s;
}

char *preinvestigating_verbs() {
    char *s = calloc(17);
    if (crc32("wTUIU",5) == 3150882535) strcat(s, "T");
if (crc32("iwLMRIR",7) == 2868830419) strcat(s, "p");
if (crc32("OvpRsKiwg",9) == 653957118) strcat(s, "r");
if (crc32("qmAVnym",7) == 1734017170) strcat(s, "e");
if (crc32("WCuBeeYdwgMym",13) == 3659694647) strcat(s, "i");
if (crc32("mvpEqbDSwlqBCwM",15) == 1653216775) strcat(s, "n");
if (crc32("OcJQqemTM",9) == 3131309616) strcat(s, "i");
if (crc32("bHhzvddJtpbFqm",14) == 2921985461) strcat(s, "v");
if (crc32("VbzkVaZkULiSbkn",15) == 671546657) strcat(s, "e");
if (crc32("DuTryJKhTeqd",12) == 1445979463) strcat(s, "a");
if (crc32("BDWgLw",6) == 3620665957) strcat(s, "s");
if (crc32("FDibmJwNRBwO",12) == 1393250609) strcat(s, "t");
if (crc32("oQgAlmqZRNCiLC",14) == 76747016) strcat(s, "Q");
if (crc32("QTUSryPK",8) == 3378983758) strcat(s, "i");
if (crc32("QdWwXNMGLz",10) == 3396917076) strcat(s, "d");
if (crc32("tDYHgFhtwZvC",12) == 238077396) strcat(s, "g");
if (crc32("ZnngIE",6) == 2344181720) strcat(s, "a");
if (crc32("kPnMDbqT",8) == 1559000479) strcat(s, "t");
if (crc32("wXYgzylrelo",11) == 2971278897) strcat(s, "i");
if (crc32("bQHjWqwjvI",10) == 2533040986) strcat(s, "n");
if (crc32("BVBSXfBesERqGD",14) == 898668910) strcat(s, "g");
    return s;
}

char *fritted_verbs() {
    char *s = calloc(8);
    if (crc32("rZmvIeyuIuRCgL",14) == 4039340082) strcat(s, "F");
if (crc32("qFryECYEUPaS",12) == 3852230288) strcat(s, "f");
if (crc32("pILCGo",6) == 939057980) strcat(s, "V");
if (crc32("EYxWIc",6) == 3912033070) strcat(s, "r");
if (crc32("XXsaDl",6) == 3119687204) strcat(s, "i");
if (crc32("GegqCHfJzZ",10) == 3309838444) strcat(s, "t");
if (crc32("NfkQwjTWr",9) == 2543046685) strcat(s, "t");
if (crc32("ZabYMDVTmPMARN",14) == 2296638437) strcat(s, "O");
if (crc32("ynuOmEjoW",9) == 2691986086) strcat(s, "e");
if (crc32("RXGwzFGeP",9) == 2697742719) strcat(s, "d");
    return s;
}

char *chassad_verbs() {
    char *s = calloc(8);
    if (crc32("SXZNho",6) == 4102818998) strcat(s, "H");
if (crc32("eFsqbgCftfski",13) == 1216821217) strcat(s, "c");
if (crc32("yxDKOgelYsnvCD",14) == 2219081404) strcat(s, "h");
if (crc32("YmgYY",5) == 2810796262) strcat(s, "p");
if (crc32("LwJaUNbCS",9) == 2998199951) strcat(s, "a");
if (crc32("ptXpAoB",7) == 2298795063) strcat(s, "s");
if (crc32("XgPYhxmGLneLCdA",15) == 363185378) strcat(s, "s");
if (crc32("pZvqgkRLOqdB",12) == 3028449933) strcat(s, "R");
if (crc32("kpYUsySna",9) == 2031443296) strcat(s, "a");
if (crc32("kxJFIh",6) == 2452523304) strcat(s, "d");
if (crc32("JeTHevPqG",9) == 2894709508) strcat(s, "d");
    return s;
}

char *verify_verbs() {
    char *s = calloc(7);
    if (crc32("GdAIFCtjg",9) == 2203982888) strcat(s, "v");
if (crc32("GMTXc",5) == 2296615542) strcat(s, "e");
if (crc32("nOCUnWc",7) == 946049069) strcat(s, "r");
if (crc32("pGFTre",6) == 2770872085) strcat(s, "i");
if (crc32("gwPeHSUVPrYl",12) == 4021729172) strcat(s, "f");
if (crc32("icMoWdCIyImTjtr",15) == 796030173) strcat(s, "y");
    return s;
}

char *intergossip_verbs() {
    char *s = calloc(12);
    if (crc32("AIozNpFDxLI",11) == 1968781623) strcat(s, "i");
if (crc32("cwjwkWOtnV",10) == 807273891) strcat(s, "x");
if (crc32("QvGwzwXp",8) == 1575114598) strcat(s, "n");
if (crc32("tKVrV",5) == 2728048282) strcat(s, "P");
if (crc32("RQNCYku",7) == 1167970217) strcat(s, "t");
if (crc32("vjbsimlWcPHap",13) == 1669339398) strcat(s, "e");
if (crc32("wwDAJjo",7) == 2944892659) strcat(s, "d");
if (crc32("qJXdR",5) == 274884424) strcat(s, "r");
if (crc32("wykMsZOvnStWSM",14) == 4219186582) strcat(s, "g");
if (crc32("pKIOAcJvxs",10) == 4239855686) strcat(s, "M");
if (crc32("vMfuQUsq",8) == 4287119164) strcat(s, "o");
if (crc32("rkfBcukbUSe",11) == 4165622818) strcat(s, "s");
if (crc32("gwymFSmtwjB",11) == 1867714363) strcat(s, "s");
if (crc32("PbktROAY",8) == 2740671029) strcat(s, "i");
if (crc32("zPMRiSSlUPs",11) == 1970745982) strcat(s, "p");
    return s;
}

char *baptized_verbs() {
    char *s = calloc(9);
    if (crc32("NVABNZZw",8) == 1808979186) strcat(s, "b");
if (crc32("FDhgvk",6) == 3647008868) strcat(s, "t");
if (crc32("YmJOWhCYRqty",12) == 3292314483) strcat(s, "a");
if (crc32("EGXjWWXqohncl",13) == 3681349892) strcat(s, "p");
if (crc32("toCGSkIOmrWY",12) == 2303919442) strcat(s, "t");
if (crc32("ObaQzlTwiz",10) == 27252142) strcat(s, "u");
if (crc32("SblYnPAEglO",11) == 3541698415) strcat(s, "i");
if (crc32("KYirOsGnBOAAj",13) == 1769527488) strcat(s, "z");
if (crc32("ofeQw",5) == 3771743775) strcat(s, "e");
if (crc32("ksbJVIB",7) == 1600692872) strcat(s, "d");
    return s;
}

char *fenced_verbs() {
    char *s = calloc(7);
    if (crc32("LdKiWDeEMWMW",12) == 4156683239) strcat(s, "c");
if (crc32("xOPpeXSp",8) == 4065116022) strcat(s, "f");
if (crc32("FfLRyY",6) == 738327691) strcat(s, "e");
if (crc32("urkJW",5) == 213805431) strcat(s, "x");
if (crc32("gCdCgDARFTiX",12) == 3210646209) strcat(s, "n");
if (crc32("ZITlFwWJkkwwXoO",15) == 3828994816) strcat(s, "h");
if (crc32("HWeVDwQBhtya",12) == 576866006) strcat(s, "c");
if (crc32("uSoWfAEHSEPxrk",14) == 1332898020) strcat(s, "e");
if (crc32("RgpFQqemhVd",11) == 1518857264) strcat(s, "d");
    return s;
}

char *embraced_verbs() {
    char *s = calloc(9);
    if (crc32("MYvjB",5) == 2281217214) strcat(s, "e");
if (crc32("CiOhnKkSDK",10) == 3292054633) strcat(s, "m");
if (crc32("JEappyWvPtfLcu",14) == 2841172813) strcat(s, "H");
if (crc32("zozAkuyTIRMP",12) == 737227943) strcat(s, "b");
if (crc32("ngyYfLXDNkkkf",13) == 1292143923) strcat(s, "V");
if (crc32("WcNYFjsDpldYFYQ",15) == 40121099) strcat(s, "r");
if (crc32("oYANJaQBrB",10) == 1324079283) strcat(s, "b");
if (crc32("WvaQrQLJnPL",11) == 1104563119) strcat(s, "a");
if (crc32("OXwZzdrV",8) == 897355354) strcat(s, "c");
if (crc32("hVyjHy",6) == 2688072586) strcat(s, "e");
if (crc32("pCxqPzGlPls",11) == 3038678544) strcat(s, "d");
    return s;
}

char *refeel_verbs() {
    char *s = calloc(7);
    if (crc32("oKugGgGAx",9) == 885920738) strcat(s, "r");
if (crc32("peUmOIvlZVUjKdJ",15) == 1241936288) strcat(s, "e");
if (crc32("FQnExUN",7) == 861922277) strcat(s, "d");
if (crc32("gptQiRLr",8) == 225795330) strcat(s, "f");
if (crc32("YHtRYNb",7) == 3745194791) strcat(s, "f");
if (crc32("ztbBZYEu",8) == 1294387067) strcat(s, "e");
if (crc32("dpcgOHd",7) == 2294266592) strcat(s, "a");
if (crc32("VmGgHeBQnhsZtCz",15) == 4087265880) strcat(s, "e");
if (crc32("PUiUnfKM",8) == 312633559) strcat(s, "l");
    return s;
}

char *rarefy_verbs() {
    char *s = calloc(7);
    if (crc32("UbFKnxJrv",9) == 1605208969) strcat(s, "r");
if (crc32("gFJdH",5) == 2463657565) strcat(s, "H");
if (crc32("OuUpJ",5) == 2468435208) strcat(s, "a");
if (crc32("FzrEDgmm",8) == 692549828) strcat(s, "n");
if (crc32("CtVNDGC",7) == 2480539356) strcat(s, "r");
if (crc32("CofxdTRr",8) == 3170978635) strcat(s, "m");
if (crc32("FIomUUjX",8) == 2940560378) strcat(s, "e");
if (crc32("vOsOLgnxbpFM",12) == 230147579) strcat(s, "l");
if (crc32("zKNYjNTWGo",10) == 3581498265) strcat(s, "f");
if (crc32("xBnRGJzRBVS",11) == 1136276694) strcat(s, "b");
if (crc32("OLPBnNaruY",10) == 1929548647) strcat(s, "y");
    return s;
}

char *fissured_verbs() {
    char *s = calloc(9);
    if (crc32("grUnQObDHRGFzbK",15) == 1413829535) strcat(s, "f");
if (crc32("gITGWVgiy",9) == 2570408195) strcat(s, "i");
if (crc32("gCQezhMRbxuhI",13) == 2303644163) strcat(s, "S");
if (crc32("XDEumVA",7) == 2019058916) strcat(s, "s");
if (crc32("TnPaSruaXPUFh",13) == 2685106754) strcat(s, "w");
if (crc32("ivXZiLuCiy",10) == 1300509314) strcat(s, "s");
if (crc32("hfbSfeGMmQQurx",14) == 4207939969) strcat(s, "u");
if (crc32("qGEvlsjitLveg",13) == 2929756677) strcat(s, "r");
if (crc32("glkUS",5) == 3991705957) strcat(s, "e");
if (crc32("VaveFUaaq",9) == 353378221) strcat(s, "d");
    return s;
}

char *spiling_verbs() {
    char *s = calloc(8);
    if (crc32("HuZcu",5) == 4258570890) strcat(s, "s");
if (crc32("fzSSalXQ",8) == 1649287790) strcat(s, "p");
if (crc32("sAyGqeAskKnKBkJ",15) == 63503090) strcat(s, "C");
if (crc32("FOIyra",6) == 685803928) strcat(s, "i");
if (crc32("xOghdJWYnSWx",12) == 1188483902) strcat(s, "l");
if (crc32("oNMuCLiexJbjHS",14) == 3720247479) strcat(s, "i");
if (crc32("zkriKbZHfEtQvY",14) == 3187735210) strcat(s, "X");
if (crc32("lDCdjZxUUAF",11) == 3199113556) strcat(s, "n");
if (crc32("QWXfWVK",7) == 2071425816) strcat(s, "g");
    return s;
}

char *misframing_verbs() {
    char *s = calloc(11);
    if (crc32("CnCmFlHO",8) == 3500558920) strcat(s, "m");
if (crc32("SiqyRpAa",8) == 1916534355) strcat(s, "i");
if (crc32("OeGAYY",6) == 273377561) strcat(s, "s");
if (crc32("dFdxKUtyVcbbMd",14) == 3897783046) strcat(s, "f");
if (crc32("oJkwfNKtGDx",11) == 1748717774) strcat(s, "f");
if (crc32("rVNvWfgYQVzPl",13) == 1343763172) strcat(s, "r");
if (crc32("AEedwUzEAkSj",12) == 4148473230) strcat(s, "a");
if (crc32("DApESzax",8) == 3363894212) strcat(s, "C");
if (crc32("BkrbfZP",7) == 1502845736) strcat(s, "m");
if (crc32("taknQ",5) == 1989826623) strcat(s, "n");
if (crc32("ixLJuSoxGrvdoqp",15) == 3335105507) strcat(s, "i");
if (crc32("OxsZtmTPSVMOu",13) == 2214380695) strcat(s, "a");
if (crc32("rIqmEazR",8) == 1316142090) strcat(s, "n");
if (crc32("JJpExyG",7) == 684157584) strcat(s, "V");
if (crc32("YmiNe",5) == 776565386) strcat(s, "g");
    return s;
}

char *griddled_verbs() {
    char *s = calloc(9);
    if (crc32("peqqSTlj",8) == 720657284) strcat(s, "p");
if (crc32("kwzfRmy",7) == 963087365) strcat(s, "g");
if (crc32("nwPhaZWtN",9) == 2691296250) strcat(s, "r");
if (crc32("DDoDjlAzIOqXgC",14) == 2652616495) strcat(s, "J");
if (crc32("lAfhlemwLJu",11) == 3160039316) strcat(s, "i");
if (crc32("QRefikK",7) == 907419320) strcat(s, "d");
if (crc32("mVQvGhEdwjfaCo",14) == 1634076711) strcat(s, "A");
if (crc32("wybytCD",7) == 2488729386) strcat(s, "d");
if (crc32("xebwMXWrJGAelOE",15) == 691111982) strcat(s, "b");
if (crc32("InStYfGT",8) == 659601108) strcat(s, "l");
if (crc32("HzILLbuCWieF",12) == 2071764031) strcat(s, "E");
if (crc32("hxVfiferD",9) == 1214555944) strcat(s, "e");
if (crc32("PmpWoqESpEWxX",13) == 1815167493) strcat(s, "S");
if (crc32("HoVthbaLZwXMywC",15) == 2834308926) strcat(s, "d");
    return s;
}

char *squint_verbs() {
    char *s = calloc(7);
    if (crc32("ePwsS",5) == 118115751) strcat(s, "I");
if (crc32("QxqfLBt",7) == 3387375479) strcat(s, "s");
if (crc32("miygdvgebH",10) == 3901453900) strcat(s, "q");
if (crc32("gqGuh",5) == 665116817) strcat(s, "k");
if (crc32("VGGeS",5) == 3901729051) strcat(s, "u");
if (crc32("OnpanvMuVBVC",12) == 589295389) strcat(s, "n");
if (crc32("cdTikBeppchfP",13) == 3689360764) strcat(s, "i");
if (crc32("VhiGISy",7) == 496749818) strcat(s, "N");
if (crc32("gBNhW",5) == 4261562820) strcat(s, "n");
if (crc32("rqOZrnhT",8) == 263718839) strcat(s, "t");
    return s;
}

char *borated_verbs() {
    char *s = calloc(8);
    if (crc32("dGVBFULTguNfIx",14) == 3081248159) strcat(s, "b");
if (crc32("JNBALAxLSG",10) == 1394856037) strcat(s, "Y");
if (crc32("gpHgNzrXB",9) == 1321894049) strcat(s, "o");
if (crc32("VLVYUTGeOQBa",12) == 1476371530) strcat(s, "n");
if (crc32("sxlHyy",6) == 764144166) strcat(s, "r");
if (crc32("jCjEEJgGTK",10) == 878946848) strcat(s, "a");
if (crc32("uUjPC",5) == 468542650) strcat(s, "t");
if (crc32("xHdlQzSpUt",10) == 1718684063) strcat(s, "l");
if (crc32("LWZkbeWxYswfs",13) == 3753363620) strcat(s, "e");
if (crc32("VApxWqCmyQpPyP",14) == 1156220441) strcat(s, "d");
    return s;
}

char *soled_verbs() {
    char *s = calloc(6);
    if (crc32("rhApLEDzjDS",11) == 132598243) strcat(s, "D");
if (crc32("fOpTYwtvdefBx",13) == 2700205990) strcat(s, "s");
if (crc32("UJpFCQN",7) == 1173873745) strcat(s, "o");
if (crc32("kgkoujdpaVXN",12) == 1481335891) strcat(s, "l");
if (crc32("tvQMMf",6) == 3172366442) strcat(s, "e");
if (crc32("FvUxNhRW",8) == 4268206868) strcat(s, "O");
if (crc32("bZKIgOFi",8) == 256850681) strcat(s, "d");
    return s;
}

char *depopulated_verbs() {
    char *s = calloc(12);
    if (crc32("oLgXMJOORMY",11) == 4014620609) strcat(s, "K");
if (crc32("fDwIRyfbMAv",11) == 3520827579) strcat(s, "d");
if (crc32("pMhohW",6) == 4289808019) strcat(s, "e");
if (crc32("jVcYj",5) == 2698370953) strcat(s, "g");
if (crc32("dOEgPYq",7) == 180264629) strcat(s, "p");
if (crc32("PxpvAMQx",8) == 883367581) strcat(s, "o");
if (crc32("eFWvByrR",8) == 1337652240) strcat(s, "p");
if (crc32("ghbcC",5) == 4193563820) strcat(s, "u");
if (crc32("qJAalmKJajFqEiN",15) == 1055837231) strcat(s, "g");
if (crc32("ARcvzOFaxwgr",12) == 3500832939) strcat(s, "l");
if (crc32("wyqJci",6) == 1496464328) strcat(s, "L");
if (crc32("AZyoYjCjANdZgpV",15) == 2865346752) strcat(s, "a");
if (crc32("FGuWHEgxxwjoll",14) == 1867283219) strcat(s, "t");
if (crc32("JqKKVsRpUcxZAKo",15) == 1177831689) strcat(s, "e");
if (crc32("thucLsxCYs",10) == 3573244425) strcat(s, "R");
if (crc32("cypuaXmZlDvwPgo",15) == 1464836121) strcat(s, "d");
    return s;
}

char *spangled_verbs() {
    char *s = calloc(9);
    if (crc32("GTdgTSJG",8) == 3777774728) strcat(s, "s");
if (crc32("KUPvKxeTTS",10) == 765114819) strcat(s, "U");
if (crc32("ACYDFvUsSw",10) == 3586178338) strcat(s, "p");
if (crc32("mrunxULxJ",9) == 1001672978) strcat(s, "P");
if (crc32("uiCOaESAkeRDCun",15) == 3366051795) strcat(s, "a");
if (crc32("bvahtCqQ",8) == 2927054922) strcat(s, "n");
if (crc32("qlpWCyas",8) == 2947852416) strcat(s, "g");
if (crc32("HydJWE",6) == 2618211794) strcat(s, "l");
if (crc32("fnqxxaBrkyHqDYh",15) == 2014579744) strcat(s, "B");
if (crc32("aUzEjlTektRSUn",14) == 3313974445) strcat(s, "e");
if (crc32("uAfUxXMDwmhSjg",14) == 15779402) strcat(s, "z");
if (crc32("mSyyxrtvFOz",11) == 632691198) strcat(s, "d");
    return s;
}

char *repurified_verbs() {
    char *s = calloc(11);
    if (crc32("mrWSKLZPtrnkBz",14) == 3724648461) strcat(s, "r");
if (crc32("qmVAQY",6) == 2473169274) strcat(s, "F");
if (crc32("Anlgz",5) == 2749977042) strcat(s, "e");
if (crc32("QcSGsrUFWGNMrI",14) == 2147378894) strcat(s, "p");
if (crc32("LReVcMPgzOqfccJ",15) == 1355812652) strcat(s, "m");
if (crc32("dXrrTvSXlsroQqT",15) == 4053629448) strcat(s, "u");
if (crc32("uOLxUnxNrHaA",12) == 1225680720) strcat(s, "r");
if (crc32("dTsmutiSbYFVuSB",15) == 2560833567) strcat(s, "z");
if (crc32("JsDRz",5) == 3794090607) strcat(s, "i");
if (crc32("cqLzAC",6) == 1113250996) strcat(s, "l");
if (crc32("wRNmbuAH",8) == 1904035147) strcat(s, "f");
if (crc32("VndBr",5) == 2568098605) strcat(s, "i");
if (crc32("gKYzGLXnbX",10) == 3684499318) strcat(s, "F");
if (crc32("qJvNbZt",7) == 679872575) strcat(s, "e");
if (crc32("TkudPU",6) == 2059036259) strcat(s, "d");
    return s;
}

char *dialoguing_verbs() {
    char *s = calloc(11);
    if (crc32("MtXyj",5) == 3005835743) strcat(s, "d");
if (crc32("dZkkurMvgUpft",13) == 110691671) strcat(s, "i");
if (crc32("fRCsRp",6) == 2695093211) strcat(s, "k");
if (crc32("TcklXFuakJLHH",13) == 1498013030) strcat(s, "a");
if (crc32("YtoIozPPBB",10) == 2735068378) strcat(s, "o");
if (crc32("MlbIj",5) == 3493740570) strcat(s, "l");
if (crc32("ahhyeyYLcwL",11) == 3649704841) strcat(s, "I");
if (crc32("UTRtDIz",7) == 1005105565) strcat(s, "o");
if (crc32("FWpBMSHARPfM",12) == 3981648864) strcat(s, "a");
if (crc32("IGIlsxKCXy",10) == 1618277253) strcat(s, "g");
if (crc32("SAydyvUip",9) == 3262745807) strcat(s, "P");
if (crc32("vghYkmL",7) == 4091102649) strcat(s, "u");
if (crc32("DlXCWOsWpUpn",12) == 658421464) strcat(s, "S");
if (crc32("eUljGKBUOiTr",12) == 4089541370) strcat(s, "i");
if (crc32("DaNOtU",6) == 3506850654) strcat(s, "n");
if (crc32("egVXByBQiE",10) == 932023975) strcat(s, "g");
    return s;
}

char *highlighting_verbs() {
    char *s = calloc(13);
    if (crc32("lCcEuVvSOBgMJQ",14) == 4065929402) strcat(s, "h");
if (crc32("FzbZx",5) == 1086998930) strcat(s, "i");
if (crc32("DqtIuUnHtYLuamz",15) == 884588686) strcat(s, "y");
if (crc32("ktWAChb",7) == 1370584695) strcat(s, "g");
if (crc32("lIzUZiaxDxcEYv",14) == 3679964649) strcat(s, "F");
if (crc32("yOJGXekDpHIWD",13) == 686305345) strcat(s, "h");
if (crc32("LZIGzJWw",8) == 4065093408) strcat(s, "L");
if (crc32("pVlfINibJukJga",14) == 3189956464) strcat(s, "l");
if (crc32("eGlcgeuUeKG",11) == 3889008474) strcat(s, "e");
if (crc32("jJNmnU",6) == 3512031576) strcat(s, "i");
if (crc32("dYgTxdn",7) == 3643980366) strcat(s, "n");
if (crc32("IpcZwvXwCPHmHms",15) == 409314132) strcat(s, "g");
if (crc32("CtWrpYAL",8) == 3396092794) strcat(s, "S");
if (crc32("OMXqLqwZAuc",11) == 3074419299) strcat(s, "h");
if (crc32("xntAbbVvd",9) == 2640763021) strcat(s, "t");
if (crc32("fUPmZHFDOgCY",12) == 3273470648) strcat(s, "h");
if (crc32("ZXFaIrEKP",9) == 4188500407) strcat(s, "i");
if (crc32("DNEBOxvkbBwbJ",13) == 1204063487) strcat(s, "n");
if (crc32("lrTrgEAHG",9) == 96691206) strcat(s, "g");
    return s;
}

char *explode_verbs() {
    char *s = calloc(8);
    if (crc32("dDpuRZqwQDR",11) == 4757479) strcat(s, "S");
if (crc32("PunpC",5) == 544466830) strcat(s, "e");
if (crc32("DIsJsyPjeaC",11) == 1589697482) strcat(s, "x");
if (crc32("NcGPdvlkaXdiLOc",15) == 3057293514) strcat(s, "e");
if (crc32("nsmrXC",6) == 1052770560) strcat(s, "p");
if (crc32("RQRQImm",7) == 1277771581) strcat(s, "B");
if (crc32("BnyNBhBG",8) == 1137927418) strcat(s, "l");
if (crc32("fxEDT",5) == 1352152767) strcat(s, "y");
if (crc32("JPlrvDCDoBNFYWm",15) == 157076363) strcat(s, "o");
if (crc32("XPuprWBH",8) == 1887704599) strcat(s, "d");
if (crc32("XNcDAuVIuLqoVY",14) == 2600186961) strcat(s, "e");
    return s;
}

char *generalizing_verbs() {
    char *s = calloc(13);
    if (crc32("cnKtjdBN",8) == 3273037036) strcat(s, "U");
if (crc32("kLnblUBCRz",10) == 3745121254) strcat(s, "g");
if (crc32("AHuaimAXKIf",11) == 2909900532) strcat(s, "C");
if (crc32("NmVVgxmQXKiZgn",14) == 2404049314) strcat(s, "e");
if (crc32("kFtsaFDupcuedJV",15) == 1785250396) strcat(s, "l");
if (crc32("bUMzp",5) == 613732979) strcat(s, "n");
if (crc32("onOeO",5) == 2506197032) strcat(s, "I");
if (crc32("OXEmniIZ",8) == 2372451554) strcat(s, "e");
if (crc32("TOXMXxk",7) == 3794206523) strcat(s, "S");
if (crc32("mzRnzKXWX",9) == 4254278590) strcat(s, "r");
if (crc32("lqFPyGUbLGznX",13) == 3452948186) strcat(s, "t");
if (crc32("qHcdZdQdAfsnZgo",15) == 1051488823) strcat(s, "a");
if (crc32("HMzdmRqfQZGmq",13) == 4048617730) strcat(s, "C");
if (crc32("wJPINRVqKQx",11) == 3247789109) strcat(s, "l");
if (crc32("SVOnuprReQ",10) == 633728881) strcat(s, "P");
if (crc32("WPmYuHwLnQTg",12) == 311842018) strcat(s, "i");
if (crc32("mmVrZxtTOb",10) == 3171145856) strcat(s, "z");
if (crc32("TGEwb",5) == 287475567) strcat(s, "x");
if (crc32("sUHABCqfcbDfA",13) == 2029493401) strcat(s, "i");
if (crc32("UGbCWMp",7) == 2948829897) strcat(s, "o");
if (crc32("acHCZhMTW",9) == 3539349471) strcat(s, "n");
if (crc32("QtQDX",5) == 3151442413) strcat(s, "g");
    return s;
}

char *conserve_verbs() {
    char *s = calloc(9);
    if (crc32("dxGnJmMyst",10) == 644450084) strcat(s, "c");
if (crc32("lckRAIUbsBgplfu",15) == 1266990080) strcat(s, "o");
if (crc32("lzwno",5) == 2398785373) strcat(s, "x");
if (crc32("zgdpLxr",7) == 3882191266) strcat(s, "n");
if (crc32("xFBVAcT",7) == 859558130) strcat(s, "j");
if (crc32("jdwKxvee",8) == 3109144937) strcat(s, "s");
if (crc32("jnOzLV",6) == 3342382060) strcat(s, "j");
if (crc32("dqhhRpM",7) == 1028732041) strcat(s, "e");
if (crc32("MqWERssDSsavm",13) == 1364515627) strcat(s, "r");
if (crc32("KwtGAk",6) == 2167602533) strcat(s, "x");
if (crc32("EKaraAzPlGE",11) == 1715915985) strcat(s, "v");
if (crc32("qhrFUAVbZajmyh",14) == 3176399464) strcat(s, "e");
    return s;
}

char *sculpturing_verbs() {
    char *s = calloc(12);
    if (crc32("cbecjpTMr",9) == 3549974669) strcat(s, "I");
if (crc32("rdBLfaTy",8) == 2339071837) strcat(s, "s");
if (crc32("xLVmgNwisVYdw",13) == 2421199450) strcat(s, "c");
if (crc32("DxMtpodvvFDy",12) == 2039242635) strcat(s, "u");
if (crc32("wDszJJTZGMQ",11) == 3565448593) strcat(s, "l");
if (crc32("MmMPGwmFehgLG",13) == 3833567106) strcat(s, "a");
if (crc32("BRocdsCInOqcod",14) == 891069508) strcat(s, "p");
if (crc32("SNPFp",5) == 3277936585) strcat(s, "b");
if (crc32("PDftD",5) == 2633988437) strcat(s, "t");
if (crc32("RKiEAPogBglgrj",14) == 3701704219) strcat(s, "r");
if (crc32("rYWEFKW",7) == 2037800828) strcat(s, "u");
if (crc32("niXJVPd",7) == 226566160) strcat(s, "r");
if (crc32("aGaFcJWsvR",10) == 1015593782) strcat(s, "i");
if (crc32("USKcIZjqiIUCPXB",15) == 423477514) strcat(s, "K");
if (crc32("rnhdLulwryoSPIt",15) == 510947832) strcat(s, "n");
if (crc32("BmeTiSO",7) == 3755763035) strcat(s, "g");
    return s;
}

char *startle_verbs() {
    char *s = calloc(8);
    if (crc32("uOgsBtUMbhopl",13) == 3897351241) strcat(s, "n");
if (crc32("ceYWUrwwPp",10) == 4044147785) strcat(s, "s");
if (crc32("FyTzJUCVF",9) == 1789891853) strcat(s, "t");
if (crc32("QjkWrNu",7) == 276380416) strcat(s, "a");
if (crc32("PzIvbTSJOCsZ",12) == 2783169141) strcat(s, "g");
if (crc32("hOMoHgagdthwo",13) == 3494900493) strcat(s, "r");
if (crc32("WUCAhgJw",8) == 3499011012) strcat(s, "t");
if (crc32("FjSppVZtFZtn",12) == 3345979636) strcat(s, "l");
if (crc32("iCnCZroapz",10) == 823495967) strcat(s, "O");
if (crc32("mARSDJsr",8) == 556266864) strcat(s, "e");
    return s;
}

char *alternating_verbs() {
    char *s = calloc(12);
    if (crc32("smONCTCNV",9) == 650784743) strcat(s, "a");
if (crc32("lkIvnmrWkUTI",12) == 794495226) strcat(s, "R");
if (crc32("CPyigWcCsilq",12) == 3282263244) strcat(s, "l");
if (crc32("NvxKTGOihBVnro",14) == 3352817068) strcat(s, "e");
if (crc32("UMnBdYd",7) == 639662566) strcat(s, "t");
if (crc32("iHOtYC",6) == 2381711700) strcat(s, "J");
if (crc32("sVsjOsusdiQhU",13) == 2614934142) strcat(s, "e");
if (crc32("vCoeFSocC",9) == 199254252) strcat(s, "r");
if (crc32("uSMBPMUEp",9) == 2530600183) strcat(s, "s");
if (crc32("dcWTc",5) == 3768381178) strcat(s, "n");
if (crc32("JtrxGorNIf",10) == 3251128275) strcat(s, "a");
if (crc32("jWHCv",5) == 1606531933) strcat(s, "t");
if (crc32("dqhrFRLVTpq",11) == 3770477962) strcat(s, "i");
if (crc32("CtqIU",5) == 1386590495) strcat(s, "i");
if (crc32("rqcWJ",5) == 4183504136) strcat(s, "W");
if (crc32("JEHbsJWXRYwYW",13) == 3577586050) strcat(s, "n");
if (crc32("vjvVOFsYENFWm",13) == 833559474) strcat(s, "M");
if (crc32("nJlUeBFfWPUFV",13) == 2946418449) strcat(s, "g");
    return s;
}

char *misdoubt_verbs() {
    char *s = calloc(9);
    if (crc32("YQGWtziLS",9) == 1401560293) strcat(s, "A");
if (crc32("MQrrccgfg",9) == 934141537) strcat(s, "m");
if (crc32("eYzTYDVsut",10) == 1011681622) strcat(s, "t");
if (crc32("wXlVwJPIgmDA",12) == 1331339976) strcat(s, "i");
if (crc32("MDJynFd",7) == 2260240299) strcat(s, "s");
if (crc32("gXWvGJY",7) == 1506005430) strcat(s, "h");
if (crc32("VodBhOIlsw",10) == 13218795) strcat(s, "d");
if (crc32("BwqCSqHwA",9) == 1016838306) strcat(s, "H");
if (crc32("KoTlBkBcz",9) == 1487125285) strcat(s, "o");
if (crc32("hwgZkfw",7) == 99919969) strcat(s, "u");
if (crc32("MoYYkSJaFPGjE",13) == 1063393445) strcat(s, "b");
if (crc32("KcNCBDHK",8) == 514520720) strcat(s, "t");
    return s;
}

char *spindry_verbs() {
    char *s = calloc(8);
    if (crc32("KQYsBhiGGwx",11) == 4207321764) strcat(s, "G");
if (crc32("jCZqryI",7) == 1020142385) strcat(s, "s");
if (crc32("DRuhMpkvmBDYN",13) == 3845377222) strcat(s, "p");
if (crc32("uNCsqkwnFxw",11) == 3884761044) strcat(s, "y");
if (crc32("fuuMcnfeIbJwu",13) == 280643774) strcat(s, "i");
if (crc32("BFRRIaKqrTGuz",13) == 3787743995) strcat(s, "d");
if (crc32("dfcmAiTkfwnnMyP",15) == 405797358) strcat(s, "n");
if (crc32("qNsvdvlbQW",10) == 2899101856) strcat(s, "l");
if (crc32("lFOLE",5) == 86185307) strcat(s, "d");
if (crc32("qSOMcF",6) == 1311462554) strcat(s, "B");
if (crc32("UistBVJIxZIGGLM",15) == 800246920) strcat(s, "r");
if (crc32("HFrLFi",6) == 2944510343) strcat(s, "y");
    return s;
}

char *presuming_verbs() {
    char *s = calloc(10);
    if (crc32("QRTRSUApKTScAVW",15) == 200967522) strcat(s, "p");
if (crc32("nmTOJOINiN",10) == 797192060) strcat(s, "r");
if (crc32("UuAvJQBrNEnS",12) == 3488588356) strcat(s, "u");
if (crc32("GayRKCSHpN",10) == 2953257486) strcat(s, "e");
if (crc32("hjyjXal",7) == 4274460149) strcat(s, "i");
if (crc32("agxnpFegdOmE",12) == 557126866) strcat(s, "s");
if (crc32("smTNVCvuEEqc",12) == 654916420) strcat(s, "u");
if (crc32("oWShiN",6) == 1639032365) strcat(s, "g");
if (crc32("NPuIVS",6) == 2175408393) strcat(s, "m");
if (crc32("aojqDCkCORspx",13) == 1576855798) strcat(s, "i");
if (crc32("pNoKUuChnUvVgop",15) == 780266693) strcat(s, "i");
if (crc32("RTRdkbHX",8) == 1007919238) strcat(s, "X");
if (crc32("ZKenqMGhvmz",11) == 2571026123) strcat(s, "n");
if (crc32("sHysxu",6) == 362104846) strcat(s, "D");
if (crc32("VobJhcDzwCit",12) == 210343356) strcat(s, "g");
    return s;
}

char *getby_verbs() {
    char *s = calloc(6);
    if (crc32("eAKCUsC",7) == 187556990) strcat(s, "h");
if (crc32("HnOkHRfPqPCgdxI",15) == 2783187046) strcat(s, "g");
if (crc32("FEpGzhYrtWoiOqb",15) == 1346383456) strcat(s, "e");
if (crc32("NaBvXdD",7) == 3078508930) strcat(s, "N");
if (crc32("TUuuG",5) == 531141309) strcat(s, "t");
if (crc32("ZIcay",5) == 1295241671) strcat(s, "b");
if (crc32("OwYeloqOPoxMyo",14) == 712602808) strcat(s, "C");
if (crc32("JFFErg",6) == 3460530693) strcat(s, "y");
    return s;
}

char *slatted_verbs() {
    char *s = calloc(8);
    if (crc32("JPEBeRVUZKLOBtI",15) == 708428170) strcat(s, "s");
if (crc32("xoKGKzIHydtj",12) == 2474625589) strcat(s, "K");
if (crc32("ZtJwZ",5) == 3323021425) strcat(s, "l");
if (crc32("wOKDRb",6) == 1844549312) strcat(s, "a");
if (crc32("pgxHyTBpHXFJXPM",15) == 3824802133) strcat(s, "t");
if (crc32("LeTqgIF",7) == 3529651792) strcat(s, "j");
if (crc32("SIawDd",6) == 1658134577) strcat(s, "t");
if (crc32("KnITABnnuwrhrfr",15) == 2997467612) strcat(s, "l");
if (crc32("ejqualOwQ",9) == 1917876531) strcat(s, "e");
if (crc32("JDLtwPYjiUX",11) == 1645635661) strcat(s, "j");
if (crc32("abSFPqd",7) == 605702082) strcat(s, "d");
    return s;
}

char *programing_verbs() {
    char *s = calloc(11);
    if (crc32("asRfdjv",7) == 137357292) strcat(s, "p");
if (crc32("eMQYbUdwUwF",11) == 1099354289) strcat(s, "r");
if (crc32("UOBIAXYx",8) == 4277783402) strcat(s, "K");
if (crc32("eZARn",5) == 1621062808) strcat(s, "o");
if (crc32("evUUmvCmbW",10) == 2453949846) strcat(s, "g");
if (crc32("BJDgxTieviI",11) == 241862298) strcat(s, "r");
if (crc32("cqDAoFMt",8) == 3132227204) strcat(s, "U");
if (crc32("tlcIM",5) == 3636938161) strcat(s, "a");
if (crc32("jvoMuwMLngPzGc",14) == 2278542911) strcat(s, "m");
if (crc32("stArC",5) == 4305035) strcat(s, "C");
if (crc32("ivTBDejWFRys",12) == 697403969) strcat(s, "i");
if (crc32("kcIamZMCawHkgOf",15) == 1885440824) strcat(s, "B");
if (crc32("FmxqSmOspY",10) == 2874732473) strcat(s, "n");
if (crc32("pPgBynGnZU",10) == 3525686409) strcat(s, "A");
if (crc32("elxew",5) == 1778976014) strcat(s, "g");
    return s;
}

char *mitigate_verbs() {
    char *s = calloc(9);
    if (crc32("wBnTBLje",8) == 4235758353) strcat(s, "b");
if (crc32("JDBgdqGiEhXESq",14) == 2696885266) strcat(s, "m");
if (crc32("fSmfjXupXsn",11) == 1674334307) strcat(s, "i");
if (crc32("BltcP",5) == 3819052435) strcat(s, "t");
if (crc32("FLukaxnMcD",10) == 4105189433) strcat(s, "n");
if (crc32("ldXKPlTvlioga",13) == 2732025834) strcat(s, "i");
if (crc32("UNXsmx",6) == 2126129649) strcat(s, "D");
if (crc32("XGiEghYgqmE",11) == 4273165804) strcat(s, "g");
if (crc32("RWOnpqDDP",9) == 574304300) strcat(s, "B");
if (crc32("ICtfVKORPzagoY",14) == 2352482955) strcat(s, "a");
if (crc32("jPhVIvTX",8) == 1496284978) strcat(s, "t");
if (crc32("vcDyjr",6) == 3697560938) strcat(s, "e");
    return s;
}

char *singe_verbs() {
    char *s = calloc(6);
    if (crc32("arJiptZewVK",11) == 1112255262) strcat(s, "c");
if (crc32("YZoHvybvYbpWEF",14) == 1062301510) strcat(s, "s");
if (crc32("zueSNdDb",8) == 3268690120) strcat(s, "i");
if (crc32("wCHgYeMS",8) == 836858813) strcat(s, "n");
if (crc32("xVjlOGOKecmPh",13) == 1486047024) strcat(s, "x");
if (crc32("LLntnAb",7) == 2895473817) strcat(s, "g");
if (crc32("ZpRTmQvG",8) == 3815336929) strcat(s, "N");
if (crc32("hPTbzVYucQRcsD",14) == 2437885324) strcat(s, "e");
    return s;
}

char *dazzled_verbs() {
    char *s = calloc(8);
    if (crc32("QByTOAYx",8) == 4198078076) strcat(s, "o");
if (crc32("RKzIWCscvEi",11) == 1863557764) strcat(s, "d");
if (crc32("pQHdJgIyBBuW",12) == 1494036832) strcat(s, "U");
if (crc32("pxWSOWHiHwr",11) == 2419608430) strcat(s, "a");
if (crc32("gCilZEbVNMxo",12) == 3708108097) strcat(s, "y");
if (crc32("GVCFEeuWuyr",11) == 322788256) strcat(s, "z");
if (crc32("SlzPv",5) == 2744161001) strcat(s, "Q");
if (crc32("ivppxVjMbPMryRm",15) == 1978539375) strcat(s, "z");
if (crc32("sCBpfNHCC",9) == 1999780438) strcat(s, "l");
if (crc32("JJoKYTfupOt",11) == 1047285081) strcat(s, "e");
if (crc32("BLNbKs",6) == 2219325828) strcat(s, "d");
    return s;
}

char *foreclose_verbs() {
    char *s = calloc(10);
    if (crc32("BLTlSXoyyrTj",12) == 986307783) strcat(s, "k");
if (crc32("yoduurnnYcFGBbJ",15) == 2023691396) strcat(s, "f");
if (crc32("BOCqx",5) == 1027618431) strcat(s, "o");
if (crc32("HRIYBSnh",8) == 2775889451) strcat(s, "E");
if (crc32("SRbcvDrmm",9) == 4267561898) strcat(s, "r");
if (crc32("GvTCLI",6) == 1698476008) strcat(s, "D");
if (crc32("IaADOEkvPeaXQd",14) == 2365421110) strcat(s, "e");
if (crc32("qpoeTClYLAp",11) == 3452259635) strcat(s, "c");
if (crc32("hBgaduMNxz",10) == 3224010885) strcat(s, "l");
if (crc32("rVlVlNpZePAA",12) == 2335200729) strcat(s, "o");
if (crc32("pREJqyhFWbESCwD",15) == 3646109657) strcat(s, "s");
if (crc32("goYttqdqODF",11) == 861948052) strcat(s, "J");
if (crc32("mfIZckmskzjgck",14) == 1564154272) strcat(s, "e");
    return s;
}

char *concur_verbs() {
    char *s = calloc(7);
    if (crc32("qRQLfxy",7) == 3235979543) strcat(s, "c");
if (crc32("LtFztOBfP",9) == 2669731628) strcat(s, "o");
if (crc32("MKWLZH",6) == 976154250) strcat(s, "n");
if (crc32("RbNiKHq",7) == 77509100) strcat(s, "n");
if (crc32("ZLWXC",5) == 2433169585) strcat(s, "c");
if (crc32("uRzyMhUqHf",10) == 3292237395) strcat(s, "u");
if (crc32("iOfumoqxOlShY",13) == 1854433389) strcat(s, "t");
if (crc32("PWCmIDHQSVyv",12) == 1484164282) strcat(s, "r");
    return s;
}

char *acerbated_verbs() {
    char *s = calloc(10);
    if (crc32("vrbdZQbqrmu",11) == 907203478) strcat(s, "R");
if (crc32("NXiCJ",5) == 620982943) strcat(s, "a");
if (crc32("OgzrWOEjwt",10) == 3890929494) strcat(s, "c");
if (crc32("OFnWQqUN",8) == 894058922) strcat(s, "W");
if (crc32("nsyWoRbGbed",11) == 3073853868) strcat(s, "e");
if (crc32("AaNQH",5) == 3694407273) strcat(s, "u");
if (crc32("KbRIMyw",7) == 1917707011) strcat(s, "r");
if (crc32("RDLnxbdnswLk",12) == 1101262419) strcat(s, "M");
if (crc32("OcJoGNHrsnHei",13) == 1581386750) strcat(s, "b");
if (crc32("xGEeI",5) == 1720716501) strcat(s, "m");
if (crc32("VZbACk",6) == 4176863562) strcat(s, "a");
if (crc32("lViigxToLNCZEI",14) == 1636957249) strcat(s, "t");
if (crc32("uxyQcTYOfAWVhUT",15) == 1396514316) strcat(s, "e");
if (crc32("mQpLkciAWsxLFo",14) == 2759143403) strcat(s, "d");
    return s;
}

char *preorganize_verbs() {
    char *s = calloc(12);
    if (crc32("sCmacEwjIFsiq",13) == 1089949276) strcat(s, "p");
if (crc32("yncYQBNIAciiaa",14) == 1243951872) strcat(s, "t");
if (crc32("jIBWEuauyOOg",12) == 2092473553) strcat(s, "r");
if (crc32("FKQoQTPlBICJGXO",15) == 2998737025) strcat(s, "e");
if (crc32("jkQmkBQa",8) == 1777796983) strcat(s, "F");
if (crc32("VWNFpB",6) == 1494736548) strcat(s, "o");
if (crc32("hFVxrQp",7) == 1094461314) strcat(s, "r");
if (crc32("jyKXtbzaGw",10) == 1141839857) strcat(s, "h");
if (crc32("kKRrxVNFuMyq",12) == 2495967377) strcat(s, "g");
if (crc32("zOZBZaJotsT",11) == 3713620759) strcat(s, "S");
if (crc32("iNWrlaZocWq",11) == 1041932545) strcat(s, "a");
if (crc32("kcRcwet",7) == 4020316865) strcat(s, "n");
if (crc32("xaSJk",5) == 840319939) strcat(s, "i");
if (crc32("QYFOhs",6) == 3800226686) strcat(s, "z");
if (crc32("UsCARWYjodm",11) == 2456937418) strcat(s, "a");
if (crc32("AcrHMyTBYKvQyiC",15) == 1024824937) strcat(s, "e");
    return s;
}

char *jibbing_verbs() {
    char *s = calloc(8);
    if (crc32("gnLemHr",7) == 2172176784) strcat(s, "l");
if (crc32("MVHgvkOAfz",10) == 1059988662) strcat(s, "j");
if (crc32("CULBSBmOGCisoX",14) == 1502548968) strcat(s, "L");
if (crc32("yUcaozM",7) == 2078371445) strcat(s, "i");
if (crc32("YzuMwyihGyuejQI",15) == 3965558984) strcat(s, "v");
if (crc32("jRrgyKgaCcWfF",13) == 680043830) strcat(s, "b");
if (crc32("MZNRIDbkYVf",11) == 351352021) strcat(s, "V");
if (crc32("FZaXnrkjTYJCit",14) == 1587409239) strcat(s, "b");
if (crc32("sdSHLcMyox",10) == 2709152085) strcat(s, "V");
if (crc32("ribrNRXDvqTlF",13) == 2278618360) strcat(s, "i");
if (crc32("qKIQgQWGTNxBac",14) == 1951973327) strcat(s, "b");
if (crc32("ZmvZTX",6) == 3916246142) strcat(s, "n");
if (crc32("xBFYxvi",7) == 3170855239) strcat(s, "Z");
if (crc32("MLGAPtRBka",10) == 3744895633) strcat(s, "g");
    return s;
}

char *beetled_verbs() {
    char *s = calloc(8);
    if (crc32("cZIIYVVLkiSfyXW",15) == 1954872443) strcat(s, "t");
if (crc32("acXDnv",6) == 2546655408) strcat(s, "b");
if (crc32("XxZzqe",6) == 3550528767) strcat(s, "N");
if (crc32("VRndnybyhGEG",12) == 2776537417) strcat(s, "e");
if (crc32("chCNytQMdtixiFi",15) == 3507535288) strcat(s, "v");
if (crc32("wxHTs",5) == 1242113823) strcat(s, "e");
if (crc32("imayFDx",7) == 999422298) strcat(s, "t");
if (crc32("OSIOnOvBxULtMZ",14) == 1252783747) strcat(s, "h");
if (crc32("dmjWHvEdoeBO",12) == 1420106530) strcat(s, "l");
if (crc32("WSjIoEg",7) == 3653880291) strcat(s, "e");
if (crc32("xsEdtjhI",8) == 1723859934) strcat(s, "S");
if (crc32("sliKAaGxoRR",11) == 1749329327) strcat(s, "d");
    return s;
}

char *mooch_verbs() {
    char *s = calloc(6);
    if (crc32("yVQnDIkAifIGdC",14) == 1460160657) strcat(s, "m");
if (crc32("daCToUVwqxN",11) == 3104164296) strcat(s, "c");
if (crc32("IrHLy",5) == 1500229851) strcat(s, "o");
if (crc32("cBfdbT",6) == 2010087573) strcat(s, "o");
if (crc32("tunyJd",6) == 3034761660) strcat(s, "L");
if (crc32("FCYMNiRzkGJBt",13) == 4200202517) strcat(s, "c");
if (crc32("oAIZQff",7) == 981282275) strcat(s, "a");
if (crc32("sTCySyxxiz",10) == 2180388817) strcat(s, "h");
    return s;
}

char *develop_verbs() {
    char *s = calloc(8);
    if (crc32("nSTdxzDaeEDk",12) == 875191303) strcat(s, "F");
if (crc32("TerTp",5) == 3740191861) strcat(s, "d");
if (crc32("xXdJssiW",8) == 1990165366) strcat(s, "Y");
if (crc32("GvQKlXwBb",9) == 3033404668) strcat(s, "e");
if (crc32("RbreEyqmIDO",11) == 3804546289) strcat(s, "v");
if (crc32("eagOtgnUuN",10) == 1043527506) strcat(s, "e");
if (crc32("bnDoMQ",6) == 3703231875) strcat(s, "l");
if (crc32("suiAIkUPyVYFeho",15) == 1930504901) strcat(s, "o");
if (crc32("Fozvqhkv",8) == 4110584056) strcat(s, "I");
if (crc32("tACddW",6) == 1979933014) strcat(s, "p");
    return s;
}

char *wrangled_verbs() {
    char *s = calloc(9);
    if (crc32("yuXkNu",6) == 3952048014) strcat(s, "c");
if (crc32("ynzYUj",6) == 3064545302) strcat(s, "w");
if (crc32("BCDvbcOR",8) == 2954363371) strcat(s, "r");
if (crc32("yXsHDZeE",8) == 1213452308) strcat(s, "a");
if (crc32("EwSyFUnzQjKYB",13) == 200725146) strcat(s, "n");
if (crc32("fcyxOH",6) == 4073589999) strcat(s, "g");
if (crc32("VLyrgRULLkqZ",12) == 657897859) strcat(s, "l");
if (crc32("FTgojiWJYvvHGt",14) == 840306495) strcat(s, "e");
if (crc32("YPwJoKJIjs",10) == 2571784022) strcat(s, "d");
    return s;
}

char *haggled_verbs() {
    char *s = calloc(8);
    if (crc32("FhfNElBi",8) == 281113310) strcat(s, "h");
if (crc32("YQeHPokvcHYM",12) == 1577203488) strcat(s, "h");
if (crc32("pUKNjRkEQVibH",13) == 4025959630) strcat(s, "a");
if (crc32("GdGakYtBlCSD",12) == 1406594898) strcat(s, "j");
if (crc32("toIUcEOSaakOwe",14) == 1311780542) strcat(s, "g");
if (crc32("lskKwbPKSrqh",12) == 639412236) strcat(s, "g");
if (crc32("rqwqntHaYEP",11) == 2886468185) strcat(s, "o");
if (crc32("tumDSvbScMgtbq",14) == 2942695624) strcat(s, "l");
if (crc32("LRXENQu",7) == 50177290) strcat(s, "t");
if (crc32("IEvABa",6) == 3463465408) strcat(s, "e");
if (crc32("xGLgWaclcSyEX",13) == 3733388657) strcat(s, "H");
if (crc32("vTLYZKUdwZsjlwl",15) == 3499911735) strcat(s, "d");
    return s;
}

char *meseems_verbs() {
    char *s = calloc(8);
    if (crc32("znizQvdatWWHHOe",15) == 16512378) strcat(s, "m");
if (crc32("PRHtzGoMClNB",12) == 2632404339) strcat(s, "e");
if (crc32("ibcHVVIYNGJ",11) == 3329419652) strcat(s, "v");
if (crc32("NYtocwracdq",11) == 3469729009) strcat(s, "s");
if (crc32("RLWAnybzYXHlTi",14) == 2953469521) strcat(s, "V");
if (crc32("hEFDrzWosvQgrKF",15) == 2442162899) strcat(s, "e");
if (crc32("CIUEaNWMa",9) == 3501491749) strcat(s, "e");
if (crc32("LWYCPZixLaU",11) == 1072710022) strcat(s, "m");
if (crc32("FCuurmWyuwkvuk",14) == 116825583) strcat(s, "s");
    return s;
}

char *contaminate_verbs() {
    char *s = calloc(12);
    if (crc32("IcFAUFBmMRAXoJ",14) == 4075279938) strcat(s, "c");
if (crc32("VyofibfbJ",9) == 2140686895) strcat(s, "o");
if (crc32("mCairLhiCKgrc",13) == 1566020759) strcat(s, "n");
if (crc32("LAtUI",5) == 1016766829) strcat(s, "z");
if (crc32("kKuVqUBSpYhNmpO",15) == 3865764884) strcat(s, "t");
if (crc32("KtUQXKveZ",9) == 547028977) strcat(s, "E");
if (crc32("kjbJwNz",7) == 629011285) strcat(s, "a");
if (crc32("TPORd",5) == 2032714206) strcat(s, "m");
if (crc32("ksbRZGGoehrrrLN",15) == 3546774831) strcat(s, "i");
if (crc32("VyddGcVYATtZN",13) == 199157782) strcat(s, "n");
if (crc32("VKjLeGyG",8) == 1876315834) strcat(s, "a");
if (crc32("mlaIB",5) == 638351805) strcat(s, "a");
if (crc32("nefashiqlUVKYbS",15) == 4278231617) strcat(s, "t");
if (crc32("TudTaXrtnpK",11) == 1162359401) strcat(s, "t");
if (crc32("gWwlYZPwncaU",12) == 3113542391) strcat(s, "e");
if (crc32("sfwgKaFrN",9) == 1365175402) strcat(s, "e");
    return s;
}

char *remobilize_verbs() {
    char *s = calloc(11);
    if (crc32("tdpfo",5) == 3295611390) strcat(s, "r");
if (crc32("xuSNrLcNresAHVm",15) == 378239119) strcat(s, "i");
if (crc32("xEenlEfwOfQytgA",15) == 2770820839) strcat(s, "e");
if (crc32("ITwaRBtLxJL",11) == 4205502242) strcat(s, "m");
if (crc32("PfRzfSsdPU",10) == 470589491) strcat(s, "o");
if (crc32("yRTanPChaJjQxn",14) == 1877134344) strcat(s, "g");
if (crc32("PYcqf",5) == 2421195101) strcat(s, "b");
if (crc32("QNqyPgy",7) == 2989399306) strcat(s, "E");
if (crc32("ZuyyqfqT",8) == 41991277) strcat(s, "i");
if (crc32("SvmbfttxdcmD",12) == 183585452) strcat(s, "L");
if (crc32("fGEOezatpKo",11) == 1651622339) strcat(s, "l");
if (crc32("OgxYPApgvUU",11) == 677236079) strcat(s, "i");
if (crc32("lUBJHX",6) == 2718469855) strcat(s, "q");
if (crc32("TAygBfjwzgyMN",13) == 2664695358) strcat(s, "z");
if (crc32("gBMXPpMUUb",10) == 4165398012) strcat(s, "u");
if (crc32("UKWtVIHEHfBG",12) == 3576484119) strcat(s, "e");
    return s;
}

char *resolving_verbs() {
    char *s = calloc(10);
    if (crc32("IbPbfSdIPVtLrLL",15) == 2618014903) strcat(s, "x");
if (crc32("voCJbQgxR",9) == 134416481) strcat(s, "r");
if (crc32("oYJeVS",6) == 3646290584) strcat(s, "e");
if (crc32("GjjVirnobIZN",12) == 3896729155) strcat(s, "s");
if (crc32("wHvXJUHizhOCV",13) == 3527328252) strcat(s, "G");
if (crc32("jwBPlczKBFcll",13) == 3458163884) strcat(s, "o");
if (crc32("wlgVjgWxmz",10) == 967177554) strcat(s, "l");
if (crc32("KOGLx",5) == 1571927148) strcat(s, "v");
if (crc32("JERtefRYSDLlJ",13) == 766082670) strcat(s, "i");
if (crc32("LYpuY",5) == 4180283086) strcat(s, "n");
if (crc32("cDBOdPfzHaJ",11) == 976164633) strcat(s, "q");
if (crc32("NDVRlDmUlJr",11) == 3730657220) strcat(s, "g");
    return s;
}

char *worn_verbs() {
    char *s = calloc(5);
    if (crc32("jOsAmtuGlN",10) == 4062812460) strcat(s, "y");
if (crc32("fuZaDJUX",8) == 263605022) strcat(s, "w");
if (crc32("BUJnzjP",7) == 1981734381) strcat(s, "o");
if (crc32("nVtKEsOihvCBew",14) == 3585514508) strcat(s, "G");
if (crc32("aRtSNnrIlGF",11) == 324273064) strcat(s, "r");
if (crc32("jWDfqZzUDu",10) == 2551228472) strcat(s, "i");
if (crc32("SsuioYm",7) == 1846211560) strcat(s, "n");
    return s;
}

char *mortified_verbs() {
    char *s = calloc(10);
    if (crc32("emaIhFRuvYY",11) == 958505592) strcat(s, "D");
if (crc32("MwMRpGYPUU",10) == 4250635954) strcat(s, "m");
if (crc32("icPWXKULNidWn",13) == 3072209511) strcat(s, "g");
if (crc32("PzPlZTWcF",9) == 2071483773) strcat(s, "o");
if (crc32("NOATmXdP",8) == 3941324733) strcat(s, "M");
if (crc32("yjqFB",5) == 230271132) strcat(s, "r");
if (crc32("bDYKFJF",7) == 2376337942) strcat(s, "t");
if (crc32("KUTZEneT",8) == 529210979) strcat(s, "i");
if (crc32("dAMqXXpGGcNrjg",14) == 114449504) strcat(s, "x");
if (crc32("mnvkJrbdaf",10) == 2611701202) strcat(s, "f");
if (crc32("nKBIwULLQh",10) == 1679253449) strcat(s, "i");
if (crc32("jRtmEjffvhXGG",13) == 672573400) strcat(s, "Q");
if (crc32("LKsLkmJYPpwYvZc",15) == 597754318) strcat(s, "e");
if (crc32("UzOvsc",6) == 490833623) strcat(s, "d");
    return s;
}

char *presuffer_verbs() {
    char *s = calloc(10);
    if (crc32("oWChPMHS",8) == 3549964923) strcat(s, "p");
if (crc32("GysgoSpQtIqo",12) == 23348398) strcat(s, "E");
if (crc32("vhzNTwaAHC",10) == 798550497) strcat(s, "r");
if (crc32("oweVmXHOVmFCE",13) == 1779331293) strcat(s, "L");
if (crc32("NFjnhNKT",8) == 178181856) strcat(s, "e");
if (crc32("sJAWWlXZaGh",11) == 889436991) strcat(s, "h");
if (crc32("bhcjYyjOnfRXjL",14) == 679080107) strcat(s, "s");
if (crc32("yhTOJbiYGJY",11) == 2823875773) strcat(s, "w");
if (crc32("YvgvXcVWXSgqCPK",15) == 1757214354) strcat(s, "u");
if (crc32("gjHaoCHBKGiW",12) == 2532397564) strcat(s, "f");
if (crc32("MuCkcscjJuQ",11) == 2188247005) strcat(s, "f");
if (crc32("BbWwbFznYapskf",14) == 1555300306) strcat(s, "R");
if (crc32("BBDBfyvnaijLTB",14) == 472383008) strcat(s, "e");
if (crc32("RfRbq",5) == 2236444984) strcat(s, "r");
    return s;
}

char *furl_verbs() {
    char *s = calloc(5);
    if (crc32("BuPtnxZPiTWRp",13) == 3898210635) strcat(s, "f");
if (crc32("ToKNqLnBWerFJK",14) == 768015744) strcat(s, "w");
if (crc32("BOUKFwqElneF",12) == 3273337787) strcat(s, "u");
if (crc32("MswDYpFdnIYGTb",14) == 3934926497) strcat(s, "r");
if (crc32("qhJhDKflhAqVOd",14) == 1354144721) strcat(s, "Y");
if (crc32("yEfxCBXtmT",10) == 4265321265) strcat(s, "l");
    return s;
}

char *associated_verbs() {
    char *s = calloc(11);
    if (crc32("XFMtYhZjnIjHDgt",15) == 3782873742) strcat(s, "a");
if (crc32("BjFvetZVEXlse",13) == 2368333232) strcat(s, "z");
if (crc32("WKLtrcETIOmS",12) == 2521850911) strcat(s, "s");
if (crc32("wNYCDoioFfNNmc",14) == 3343762755) strcat(s, "p");
if (crc32("DAnTEdmlw",9) == 2947012261) strcat(s, "s");
if (crc32("dIOyauO",7) == 4217945095) strcat(s, "o");
if (crc32("WlqPcjmXJxOepzh",15) == 142581426) strcat(s, "c");
if (crc32("FJkdVdCIhroGE",13) == 3264527784) strcat(s, "y");
if (crc32("GsxzNNKrCam",11) == 220954467) strcat(s, "i");
if (crc32("VadNfnDnuN",10) == 439924706) strcat(s, "Y");
if (crc32("TGMwtooFFnfpx",13) == 3128909843) strcat(s, "a");
if (crc32("LwrcngKwvMNT",12) == 1195740766) strcat(s, "H");
if (crc32("ROfKyDKKkuTMmpC",15) == 3311327194) strcat(s, "t");
if (crc32("rPTURBLNJH",10) == 365765277) strcat(s, "W");
if (crc32("DDVAyUBcTGYQWS",14) == 1917516698) strcat(s, "e");
if (crc32("WpzTraSOiZXhrdZ",15) == 745265891) strcat(s, "d");
    return s;
}

char *creping_verbs() {
    char *s = calloc(8);
    if (crc32("aZhEObhWTmBvqYV",15) == 3828672072) strcat(s, "i");
if (crc32("hvZVAxADMtn",11) == 3808535339) strcat(s, "c");
if (crc32("LWXjJSCdbBapb",13) == 1961592783) strcat(s, "o");
if (crc32("LSNUdLtDPH",10) == 1044224513) strcat(s, "r");
if (crc32("sSpocj",6) == 2294609780) strcat(s, "e");
if (crc32("zAeedgitJk",10) == 2071692766) strcat(s, "A");
if (crc32("aTeWYkkqhoS",11) == 3169443828) strcat(s, "p");
if (crc32("BKDdk",5) == 73797735) strcat(s, "i");
if (crc32("SkMhKVrLzRRROuA",15) == 3170225485) strcat(s, "n");
if (crc32("ZcBOoFWY",8) == 1941321220) strcat(s, "g");
    return s;
}

char *redrove_verbs() {
    char *s = calloc(8);
    if (crc32("kSpYtRMPN",9) == 448059536) strcat(s, "r");
if (crc32("KPROf",5) == 2613190276) strcat(s, "a");
if (crc32("fduhlsKEsKD",11) == 3289524718) strcat(s, "e");
if (crc32("pybCYq",6) == 1647809534) strcat(s, "d");
if (crc32("mfICYDeoYWbXN",13) == 3251270992) strcat(s, "d");
if (crc32("MGkZSrjvyjGf",12) == 3255986463) strcat(s, "x");
if (crc32("bfDnjR",6) == 2932086698) strcat(s, "r");
if (crc32("PVEGIje",7) == 792709675) strcat(s, "o");
if (crc32("UPHKespTWosB",12) == 3494006979) strcat(s, "Y");
if (crc32("ZVjNSSlvtD",10) == 4146880060) strcat(s, "v");
if (crc32("qQFTmrT",7) == 2994551877) strcat(s, "e");
    return s;
}

char *movein_verbs() {
    char *s = calloc(7);
    if (crc32("juEzO",5) == 212027913) strcat(s, "m");
if (crc32("CDvBZpavTiHSjO",14) == 1400775744) strcat(s, "o");
if (crc32("XaDQQIpQKzLU",12) == 1041806725) strcat(s, "p");
if (crc32("QcCVXhgzvXAl",12) == 2020366952) strcat(s, "v");
if (crc32("KRAkrGhndQsJoP",14) == 3850952720) strcat(s, "e");
if (crc32("RaNkAGQLQyXmUD",14) == 1953228017) strcat(s, "i");
if (crc32("WgtHpSWXv",9) == 1403360873) strcat(s, "n");
    return s;
}

char *blobbing_verbs() {
    char *s = calloc(9);
    if (crc32("qDkxQcPcejJdziu",15) == 3504951082) strcat(s, "R");
if (crc32("YdsuXjRAgPxvBo",14) == 279652961) strcat(s, "b");
if (crc32("BgUirYARLyfJ",12) == 3768360832) strcat(s, "v");
if (crc32("NnqcUCW",7) == 313203240) strcat(s, "l");
if (crc32("kHkHo",5) == 3066597179) strcat(s, "t");
if (crc32("urjgvgmlWSMdQHd",15) == 3924101230) strcat(s, "o");
if (crc32("tQPyegofpSye",12) == 4288088333) strcat(s, "b");
if (crc32("OhRkibvqz",9) == 3788540594) strcat(s, "b");
if (crc32("McJkChfqf",9) == 714490933) strcat(s, "i");
if (crc32("eYmEgDQEkb",10) == 4261451775) strcat(s, "j");
if (crc32("iRKgveVr",8) == 48484828) strcat(s, "n");
if (crc32("sTDJnPM",7) == 2125897642) strcat(s, "g");
    return s;
}

char *flyte_verbs() {
    char *s = calloc(6);
    if (crc32("xnXdf",5) == 328649189) strcat(s, "f");
if (crc32("hOtPQEuQS",9) == 2657127357) strcat(s, "N");
if (crc32("VCyyiVkMKfQzyX",14) == 1948879602) strcat(s, "l");
if (crc32("uXFCouou",8) == 1794996940) strcat(s, "H");
if (crc32("mTMqZCDcOC",10) == 1681853332) strcat(s, "y");
if (crc32("QGrta",5) == 3808501984) strcat(s, "t");
if (crc32("SxRgymTe",8) == 3194948931) strcat(s, "e");
    return s;
}

char *giving_verbs() {
    char *s = calloc(7);
    if (crc32("BMlwNo",6) == 2309090881) strcat(s, "L");
if (crc32("IRvJoAcGV",9) == 3979026156) strcat(s, "g");
if (crc32("vWIwr",5) == 1196727303) strcat(s, "i");
if (crc32("MqVVkJovjC",10) == 2413087485) strcat(s, "v");
if (crc32("PQqnCwWCvPyt",12) == 1675119778) strcat(s, "X");
if (crc32("euBEx",5) == 1809794158) strcat(s, "i");
if (crc32("nKAzSleLtxBe",12) == 1216843105) strcat(s, "n");
if (crc32("pHliEHMwHbYIHx",14) == 4091294554) strcat(s, "g");
    return s;
}

char *flutter_verbs() {
    char *s = calloc(8);
    if (crc32("YvZqmtOkkE",10) == 4198451477) strcat(s, "i");
if (crc32("cdJTPpmkWeSd",12) == 1115420173) strcat(s, "f");
if (crc32("kMxyt",5) == 2999549907) strcat(s, "l");
if (crc32("ZmrRyWNYUsvc",12) == 1045035556) strcat(s, "i");
if (crc32("ugtVGjiF",8) == 2153799027) strcat(s, "u");
if (crc32("FbRxONJJLWGo",12) == 2773166135) strcat(s, "G");
if (crc32("FfIHU",5) == 1396057106) strcat(s, "t");
if (crc32("DuIzbgwIweAljiO",15) == 586242609) strcat(s, "K");
if (crc32("eNEBG",5) == 2963117745) strcat(s, "t");
if (crc32("nFTWhUleYoVRLT",14) == 1702238353) strcat(s, "q");
if (crc32("tWSVMhkanMh",11) == 1322712034) strcat(s, "e");
if (crc32("tBHYibJ",7) == 2677637765) strcat(s, "r");
    return s;
}

char *commix_verbs() {
    char *s = calloc(7);
    if (crc32("DLRvyo",6) == 1886403756) strcat(s, "T");
if (crc32("trirr",5) == 4014088910) strcat(s, "c");
if (crc32("FXFchtPO",8) == 1825261834) strcat(s, "o");
if (crc32("AbwAnlQH",8) == 2921012117) strcat(s, "m");
if (crc32("LsjFZgh",7) == 3943857210) strcat(s, "n");
if (crc32("HiZFYjivUt",10) == 66007324) strcat(s, "m");
if (crc32("KUGixz",6) == 845013056) strcat(s, "i");
if (crc32("teOTzkcslbE",11) == 814720470) strcat(s, "l");
if (crc32("KwMlQlreIqAzD",13) == 1092550926) strcat(s, "x");
    return s;
}

char *discontinued_verbs() {
    char *s = calloc(13);
    if (crc32("RRamoD",6) == 319173596) strcat(s, "s");
if (crc32("jBbBDK",6) == 2914316937) strcat(s, "d");
if (crc32("NQIYQAoGxPAnKCH",15) == 195070486) strcat(s, "i");
if (crc32("AozURCggYo",10) == 1583153787) strcat(s, "s");
if (crc32("qTgVJPpetbTj",12) == 602437722) strcat(s, "c");
if (crc32("aNSgKkFWfdON",12) == 3550924995) strcat(s, "P");
if (crc32("PONXUQV",7) == 3792845722) strcat(s, "o");
if (crc32("RlQkyhxLeHwU",12) == 3643017151) strcat(s, "k");
if (crc32("szpVrDvPT",9) == 900595129) strcat(s, "n");
if (crc32("bfuonmH",7) == 3884113021) strcat(s, "t");
if (crc32("qsbwwIqYdKFx",12) == 1344769362) strcat(s, "i");
if (crc32("bBwfGqGvcBvfv",13) == 1127716104) strcat(s, "b");
if (crc32("vqXbbdPHsgB",11) == 855189278) strcat(s, "n");
if (crc32("tYcUTtiqAntFMjV",15) == 221811425) strcat(s, "d");
if (crc32("TutNAyI",7) == 3861199829) strcat(s, "u");
if (crc32("gLxXVA",6) == 405690278) strcat(s, "e");
if (crc32("htmfYS",6) == 1599287523) strcat(s, "d");
if (crc32("qwxcdGUubYPGevm",15) == 368118139) strcat(s, "d");
    return s;
}

char *overgrew_verbs() {
    char *s = calloc(9);
    if (crc32("ZDjQzRkzUivAT",13) == 3078795206) strcat(s, "h");
if (crc32("IscDotFmn",9) == 1761695251) strcat(s, "o");
if (crc32("TBQtoYnyopgjAp",14) == 3284300390) strcat(s, "v");
if (crc32("zZlagVVJ",8) == 2958801648) strcat(s, "e");
if (crc32("sfTANrdnwKUohVJ",15) == 370287814) strcat(s, "G");
if (crc32("ZeMBYhdNEDWH",12) == 3339200448) strcat(s, "r");
if (crc32("szAUmGzldY",10) == 125023831) strcat(s, "g");
if (crc32("UtfRFWyNZn",10) == 1718201078) strcat(s, "r");
if (crc32("mdnMt",5) == 529913965) strcat(s, "q");
if (crc32("ZCPaRXssMaFt",12) == 4125282825) strcat(s, "e");
if (crc32("UEopsxPvVVMQC",13) == 3324314721) strcat(s, "o");
if (crc32("XoxvxOOtJV",10) == 526193686) strcat(s, "w");
    return s;
}

char *suturing_verbs() {
    char *s = calloc(9);
    if (crc32("ZtsLNArFQVaGD",13) == 3328892094) strcat(s, "z");
if (crc32("ZENbKQHjEO",10) == 3924193309) strcat(s, "s");
if (crc32("nfNbmNXz",8) == 2408279950) strcat(s, "B");
if (crc32("mVZYpF",6) == 3316048102) strcat(s, "u");
if (crc32("vHrONr",6) == 1849396358) strcat(s, "t");
if (crc32("NQuKA",5) == 1197520623) strcat(s, "R");
if (crc32("JfYhAZB",7) == 3254065613) strcat(s, "u");
if (crc32("fHgNiNgKCaPmCH",14) == 2231971122) strcat(s, "J");
if (crc32("VVqYAw",6) == 1269512255) strcat(s, "r");
if (crc32("QfXfHQaHLcww",12) == 7200667) strcat(s, "i");
if (crc32("KORhF",5) == 316698661) strcat(s, "l");
if (crc32("hvyNujjVTrsG",12) == 1978298923) strcat(s, "n");
if (crc32("QKZbtQgkxzJUbJ",14) == 2982521585) strcat(s, "G");
if (crc32("BgTuUm",6) == 987375395) strcat(s, "g");
    return s;
}

char *mount_verbs() {
    char *s = calloc(6);
    if (crc32("AktOsFQU",8) == 3925335068) strcat(s, "Q");
if (crc32("vqFXtVThWN",10) == 1092154960) strcat(s, "m");
if (crc32("OXHPgdW",7) == 2021218367) strcat(s, "x");
if (crc32("pyrVm",5) == 2706416589) strcat(s, "o");
if (crc32("oKTRYtxf",8) == 3063778623) strcat(s, "o");
if (crc32("FDsIWCP",7) == 2950442984) strcat(s, "u");
if (crc32("OahWS",5) == 1019692082) strcat(s, "E");
if (crc32("tbHuVSLMovXEB",13) == 91366719) strcat(s, "n");
if (crc32("DIOfsGBZf",9) == 821535758) strcat(s, "G");
if (crc32("XeDQbWlJTrPOnd",14) == 3977900802) strcat(s, "t");
    return s;
}

char *journalizing_verbs() {
    char *s = calloc(13);
    if (crc32("rNiOuTY",7) == 449246092) strcat(s, "j");
if (crc32("IrrbYy",6) == 3527545204) strcat(s, "o");
if (crc32("JvlMXgCVUmZluu",14) == 3083685629) strcat(s, "u");
if (crc32("TEDkIwQzzyeG",12) == 1861084859) strcat(s, "r");
if (crc32("FntdLEnoM",9) == 2856924145) strcat(s, "y");
if (crc32("oVqBC",5) == 1267693621) strcat(s, "n");
if (crc32("AaxfDspUQVC",11) == 866699508) strcat(s, "F");
if (crc32("httWneKgWRQ",11) == 2079253063) strcat(s, "a");
if (crc32("xMNOMF",6) == 750093033) strcat(s, "l");
if (crc32("HyNQfjEWQmt",11) == 4010384720) strcat(s, "i");
if (crc32("IesTgwlhkpkGkPJ",15) == 2790051459) strcat(s, "X");
if (crc32("nwmBMgAKeEy",11) == 1212469213) strcat(s, "z");
if (crc32("ptGCexOkMlfOpv",14) == 1403508613) strcat(s, "i");
if (crc32("uPBnQMjMbIidh",13) == 2659142424) strcat(s, "n");
if (crc32("bpNXOJYHgjQtBD",14) == 1298862961) strcat(s, "c");
if (crc32("QHmVlJxH",8) == 460278577) strcat(s, "g");
    return s;
}

char *drove_verbs() {
    char *s = calloc(6);
    if (crc32("yjFvqwxYiIa",11) == 2416833364) strcat(s, "d");
if (crc32("gbtOEAzkmPMIZx",14) == 3043328846) strcat(s, "r");
if (crc32("cCckjaBJrI",10) == 3132383137) strcat(s, "o");
if (crc32("ymovSGDJoj",10) == 2218340739) strcat(s, "v");
if (crc32("scQMa",5) == 1138692590) strcat(s, "e");
    return s;
}

char *guddled_verbs() {
    char *s = calloc(8);
    if (crc32("kuyuLk",6) == 543345905) strcat(s, "g");
if (crc32("vxDNPDJubXzdTt",14) == 16905239) strcat(s, "n");
if (crc32("izVnLpOUvbRIT",13) == 2827260106) strcat(s, "u");
if (crc32("tAbauIVRpIOXq",13) == 1420782310) strcat(s, "d");
if (crc32("ikpLIdOHpgXFP",13) == 577410153) strcat(s, "d");
if (crc32("yEsGDOLMmHYr",12) == 1736311345) strcat(s, "l");
if (crc32("ysxHWd",6) == 1510046274) strcat(s, "x");
if (crc32("vJqUNGZWDtkbKJE",15) == 3428032529) strcat(s, "e");
if (crc32("vZniFvNzsnbFy",13) == 1743529628) strcat(s, "a");
if (crc32("mODlycyBLi",10) == 3628990271) strcat(s, "d");
    return s;
}

char *condoling_verbs() {
    char *s = calloc(10);
    if (crc32("JbTjzODStkrqY",13) == 1427088923) strcat(s, "L");
if (crc32("ZZwtHz",6) == 1125406942) strcat(s, "c");
if (crc32("SUsWoDHKsWd",11) == 1729643027) strcat(s, "o");
if (crc32("JVzys",5) == 1418782772) strcat(s, "n");
if (crc32("KsrmIfWPtkZdExB",15) == 3174450055) strcat(s, "f");
if (crc32("fRWNsSkcplB",11) == 3517154715) strcat(s, "d");
if (crc32("jvQzTzJ",7) == 1179400980) strcat(s, "o");
if (crc32("NYrPdVwjadOv",12) == 4065853939) strcat(s, "l");
if (crc32("HpIUyrp",7) == 1231090084) strcat(s, "y");
if (crc32("wSDxsMKlPwA",11) == 804934041) strcat(s, "i");
if (crc32("VMQSLqht",8) == 359394992) strcat(s, "n");
if (crc32("ijrelhNjYgadMHc",15) == 1062909120) strcat(s, "g");
    return s;
}

char *recombine_verbs() {
    char *s = calloc(10);
    if (crc32("EyVpGOeVjkOWQBD",15) == 1537339895) strcat(s, "L");
if (crc32("CBzSNrePm",9) == 1241373829) strcat(s, "r");
if (crc32("sSQkR",5) == 3867260177) strcat(s, "S");
if (crc32("wNKMoXmDLnT",11) == 3569214985) strcat(s, "e");
if (crc32("YvrwhRo",7) == 2430889931) strcat(s, "c");
if (crc32("FjWGP",5) == 2406046356) strcat(s, "J");
if (crc32("MVTVkhNnQD",10) == 940383878) strcat(s, "o");
if (crc32("emazTatlIJIta",13) == 1924809973) strcat(s, "e");
if (crc32("CHSoMp",6) == 3748439756) strcat(s, "m");
if (crc32("vYzaivbqjL",10) == 2315093130) strcat(s, "z");
if (crc32("HbuaHwsDRmXIYT",14) == 1025152682) strcat(s, "b");
if (crc32("FQgMulwmT",9) == 2604772674) strcat(s, "z");
if (crc32("ontXgSZ",7) == 2268563394) strcat(s, "i");
if (crc32("tkZnUo",6) == 565492121) strcat(s, "X");
if (crc32("PxflSwBv",8) == 2663638015) strcat(s, "n");
if (crc32("zxeDEe",6) == 4162253410) strcat(s, "n");
if (crc32("JzoDAyWTLT",10) == 2339580621) strcat(s, "e");
    return s;
}

char *appliquaing_verbs() {
    char *s = calloc(12);
    if (crc32("pmtAQ",5) == 2338868831) strcat(s, "F");
if (crc32("VUugXN",6) == 1771650098) strcat(s, "a");
if (crc32("uCUsMsraMlN",11) == 65634052) strcat(s, "p");
if (crc32("kDkVTy",6) == 2847688455) strcat(s, "z");
if (crc32("PnOnlJvpKDVlPoN",15) == 3002486987) strcat(s, "p");
if (crc32("SYCEsVBQAJlSxC",14) == 1948121805) strcat(s, "t");
if (crc32("DhzrYNhYOihC",12) == 3571469466) strcat(s, "l");
if (crc32("qUKtHBmIqacFh",13) == 3794946641) strcat(s, "i");
if (crc32("LrDemyXRHk",10) == 250213674) strcat(s, "q");
if (crc32("vKOquFzxMoESkIt",15) == 2346539960) strcat(s, "k");
if (crc32("hUnpdrrObseYcS",14) == 937247505) strcat(s, "u");
if (crc32("OSxOgRLRtFSc",12) == 3179389757) strcat(s, "a");
if (crc32("COchsZLRFpjqSoZ",15) == 4279163337) strcat(s, "D");
if (crc32("bnEjiQqfVhyQ",12) == 3673760313) strcat(s, "i");
if (crc32("uyOfFvRgBn",10) == 3615035493) strcat(s, "o");
if (crc32("mkbDJXeUi",9) == 4009805189) strcat(s, "n");
if (crc32("oYRvixwZ",8) == 602927329) strcat(s, "u");
if (crc32("aWMsvyuI",8) == 3667522496) strcat(s, "g");
    return s;
}

char *pronouncing_verbs() {
    char *s = calloc(12);
    if (crc32("csFHBMbxf",9) == 4255653680) strcat(s, "u");
if (crc32("Kitngpge",8) == 1546535234) strcat(s, "p");
if (crc32("kqskApkaQZY",11) == 4276990196) strcat(s, "r");
if (crc32("YzyKQtLhOxZF",12) == 2250001934) strcat(s, "o");
if (crc32("JftFPgWyzXzOCj",14) == 4181362979) strcat(s, "n");
if (crc32("EOtWfJUyOXbGbj",14) == 4285203963) strcat(s, "L");
if (crc32("LplcneP",7) == 1360799535) strcat(s, "o");
if (crc32("fdRDaH",6) == 296480024) strcat(s, "u");
if (crc32("aryqIETEBhGS",12) == 2659629468) strcat(s, "n");
if (crc32("PEsZlmAeyyNvcJZ",15) == 659036200) strcat(s, "N");
if (crc32("GWqnMuaSSdp",11) == 3509746850) strcat(s, "c");
if (crc32("sPtqNHX",7) == 2361496345) strcat(s, "m");
if (crc32("nrCAtGZrQs",10) == 1419172032) strcat(s, "i");
if (crc32("LJvQOwRbGnI",11) == 1693251596) strcat(s, "S");
if (crc32("XehCwWul",8) == 1221393190) strcat(s, "n");
if (crc32("QgcOWEuE",8) == 1670166609) strcat(s, "B");
if (crc32("DNrLH",5) == 1663324943) strcat(s, "g");
    return s;
}

char *criticized_verbs() {
    char *s = calloc(11);
    if (crc32("XkucQFtOulrm",12) == 2159566707) strcat(s, "c");
if (crc32("XqlHGHraMxy",11) == 604769289) strcat(s, "r");
if (crc32("nYiuoxlNSu",10) == 162306640) strcat(s, "i");
if (crc32("yAOxCijduzHFgC",14) == 148917732) strcat(s, "c");
if (crc32("FaQXGcRmwGZkvH",14) == 659091850) strcat(s, "t");
if (crc32("xLxjPDLAauUB",12) == 3754417705) strcat(s, "i");
if (crc32("tIMsxZlUqVCFZ",13) == 839679077) strcat(s, "c");
if (crc32("aXJQxhRQxKYYqnG",15) == 609934655) strcat(s, "i");
if (crc32("DcwHNiJaWaOa",12) == 2322251569) strcat(s, "z");
if (crc32("CqpHlzBVFEY",11) == 3530591165) strcat(s, "q");
if (crc32("FUndeFXs",8) == 1727032365) strcat(s, "e");
if (crc32("LHowv",5) == 2668791202) strcat(s, "d");
    return s;
}

char *driveling_verbs() {
    char *s = calloc(10);
    if (crc32("GznNvOUnU",9) == 2958883217) strcat(s, "d");
if (crc32("iXdlOB",6) == 2363513437) strcat(s, "r");
if (crc32("QlJKGPRS",8) == 1573262674) strcat(s, "B");
if (crc32("BljykPnZWEtN",12) == 1932742279) strcat(s, "i");
if (crc32("CqjxqhiCIdOt",12) == 18418804) strcat(s, "N");
if (crc32("BkXEx",5) == 3108614512) strcat(s, "v");
if (crc32("awbpGAbkgmyG",12) == 2697685649) strcat(s, "e");
if (crc32("XBBKHF",6) == 2581721903) strcat(s, "l");
if (crc32("OdHFvzGms",9) == 599172818) strcat(s, "h");
if (crc32("thNCbdyQdMqhBX",14) == 65946467) strcat(s, "i");
if (crc32("AgrMMXBJwIX",11) == 1342160766) strcat(s, "B");
if (crc32("zZwaavzMUtSSC",13) == 1849795696) strcat(s, "n");
if (crc32("zrYkIDSbOOoUKLt",15) == 1918866801) strcat(s, "T");
if (crc32("gDMpnbGNVXPZUyA",15) == 1886175055) strcat(s, "g");
    return s;
}

char *frizzled_verbs() {
    char *s = calloc(9);
    if (crc32("ePorHDnexVy",11) == 3367133853) strcat(s, "f");
if (crc32("seUNp",5) == 539006431) strcat(s, "r");
if (crc32("ZSmyGuH",7) == 3101462624) strcat(s, "i");
if (crc32("VbtgRaJes",9) == 1666512955) strcat(s, "z");
if (crc32("zGnoek",6) == 2872057922) strcat(s, "z");
if (crc32("vlvbMlZr",8) == 2876161140) strcat(s, "z");
if (crc32("ydCnllbhdk",10) == 3140223540) strcat(s, "l");
if (crc32("fWTwAUARYf",10) == 1714183651) strcat(s, "e");
if (crc32("fBzVstwWf",9) == 1094779886) strcat(s, "s");
if (crc32("zgCaNvARuuPDfzk",15) == 3348333854) strcat(s, "d");
    return s;
}

char *honing_verbs() {
    char *s = calloc(7);
    if (crc32("mgWMLuMp",8) == 1193259413) strcat(s, "h");
if (crc32("yJRSqvOUGi",10) == 4032848531) strcat(s, "c");
if (crc32("iLNtv",5) == 200527253) strcat(s, "o");
if (crc32("BAcQbgtaZ",9) == 1896856984) strcat(s, "b");
if (crc32("abUck",5) == 228129415) strcat(s, "n");
if (crc32("KxySiK",6) == 1247484802) strcat(s, "S");
if (crc32("pAJKqWDHkn",10) == 784999826) strcat(s, "i");
if (crc32("EjdUVARYQ",9) == 2622187445) strcat(s, "n");
if (crc32("tpqmiIHzcxe",11) == 3050595659) strcat(s, "g");
    return s;
}

char *tilt_verbs() {
    char *s = calloc(5);
    if (crc32("OuOYBgoWoUzjFLW",15) == 1727346380) strcat(s, "t");
if (crc32("PdRTUQ",6) == 3951390507) strcat(s, "D");
if (crc32("UvGQasWRHcbeO",13) == 1130032503) strcat(s, "i");
if (crc32("bdNUOHT",7) == 642796635) strcat(s, "l");
if (crc32("JyaumRFQvfvu",12) == 3626847667) strcat(s, "t");
    return s;
}

char *defoliate_verbs() {
    char *s = calloc(10);
    if (crc32("TVHOEOneKyYiP",13) == 1948151101) strcat(s, "d");
if (crc32("JOmAThNT",8) == 568521961) strcat(s, "e");
if (crc32("iaMYjwya",8) == 3236916579) strcat(s, "e");
if (crc32("lgglLdrZrjmeB",13) == 3640144065) strcat(s, "f");
if (crc32("aPHrzSbBi",9) == 512841292) strcat(s, "o");
if (crc32("CaVwNclnHPgGzck",15) == 2178330067) strcat(s, "y");
if (crc32("HMlOBueNHj",10) == 3835975038) strcat(s, "l");
if (crc32("tukQiqyxRNA",11) == 4138075820) strcat(s, "i");
if (crc32("zZUmXFoHtVqgKi",14) == 47358599) strcat(s, "a");
if (crc32("xdEooVCPLh",10) == 546783025) strcat(s, "M");
if (crc32("GJzbvOWXmgeFC",13) == 1767107139) strcat(s, "t");
if (crc32("LNeXazmAp",9) == 1968482219) strcat(s, "A");
if (crc32("kIZlEGTZLv",10) == 1172575015) strcat(s, "e");
    return s;
}

char *photosynthesize_verbs() {
    char *s = calloc(16);
    if (crc32("DyHuT",5) == 1033970340) strcat(s, "p");
if (crc32("ErllxssMgM",10) == 1979814973) strcat(s, "e");
if (crc32("nvhdhPE",7) == 2085693457) strcat(s, "h");
if (crc32("uTysIriLiNrsNj",14) == 3300325714) strcat(s, "o");
if (crc32("HWodzijpsFpYRMF",15) == 953458216) strcat(s, "t");
if (crc32("hhoAengAvTtAKT",14) == 3840910788) strcat(s, "M");
if (crc32("HGBQgYTiUFo",11) == 3992326017) strcat(s, "o");
if (crc32("ClTtthUXkPiA",12) == 2320133255) strcat(s, "s");
if (crc32("HgIUXZoxBzlcK",13) == 424250764) strcat(s, "y");
if (crc32("QcPWn",5) == 435266744) strcat(s, "C");
if (crc32("kuZOGYFHCSicHVZ",15) == 3807084563) strcat(s, "n");
if (crc32("VDseTmDVUd",10) == 675696998) strcat(s, "t");
if (crc32("AJAQy",5) == 2718162442) strcat(s, "j");
if (crc32("ivzHFbPw",8) == 1727143331) strcat(s, "h");
if (crc32("dMSeYl",6) == 974983934) strcat(s, "e");
if (crc32("ynJrwOKLuvEvFy",14) == 2707345637) strcat(s, "s");
if (crc32("HUvwmD",6) == 473069807) strcat(s, "i");
if (crc32("APHMq",5) == 1960846812) strcat(s, "z");
if (crc32("ddSxqxEQfdzZozV",15) == 2947640751) strcat(s, "S");
if (crc32("TARalGKnyBD",11) == 3492984061) strcat(s, "e");
    return s;
}

char *doweled_verbs() {
    char *s = calloc(8);
    if (crc32("BxoaVsUvHbtt",12) == 3616432153) strcat(s, "l");
if (crc32("zzSqQTKjQaOQsT",14) == 2596604403) strcat(s, "d");
if (crc32("QpRuVtUPeFSkwi",14) == 2775289026) strcat(s, "G");
if (crc32("GdDmpmWraC",10) == 566835937) strcat(s, "o");
if (crc32("McGebpZmzwaUUpX",15) == 2431084377) strcat(s, "P");
if (crc32("JYfcTXdBL",9) == 2953542775) strcat(s, "w");
if (crc32("aNWkrwglPoikze",14) == 3621469705) strcat(s, "Q");
if (crc32("oauwX",5) == 154016683) strcat(s, "e");
if (crc32("jfbyqMCHIkuR",12) == 1494867806) strcat(s, "l");
if (crc32("lKwpXY",6) == 1870489862) strcat(s, "Q");
if (crc32("BIhgHklF",8) == 1550424100) strcat(s, "e");
if (crc32("IspuuuObYpz",11) == 2640220985) strcat(s, "d");
    return s;
}

char *crisscross_verbs() {
    char *s = calloc(11);
    if (crc32("XKmpJKhOfX",10) == 3769308917) strcat(s, "c");
if (crc32("iTeUKts",7) == 682086087) strcat(s, "E");
if (crc32("FqGVJOFGbF",10) == 2199210184) strcat(s, "r");
if (crc32("rYuWa",5) == 594178976) strcat(s, "x");
if (crc32("tbDgpHTcXwEkq",13) == 2651512188) strcat(s, "i");
if (crc32("YgbNW",5) == 1308294672) strcat(s, "D");
if (crc32("fGwreDTvxAkn",12) == 3004909525) strcat(s, "s");
if (crc32("SmHbyV",6) == 3932277419) strcat(s, "P");
if (crc32("rjyyOIO",7) == 287259992) strcat(s, "s");
if (crc32("HZXlXGSxc",9) == 2075034933) strcat(s, "c");
if (crc32("utTgvYTKWlFyZi",14) == 3980530791) strcat(s, "r");
if (crc32("VXidI",5) == 912215299) strcat(s, "o");
if (crc32("nbnwFivGO",9) == 3742157883) strcat(s, "w");
if (crc32("PJtIZzz",7) == 4263504963) strcat(s, "s");
if (crc32("OxcJPgMaSZUTjM",14) == 2879781437) strcat(s, "s");
    return s;
}

char *unmuffled_verbs() {
    char *s = calloc(10);
    if (crc32("ziinh",5) == 3430934550) strcat(s, "u");
if (crc32("DxswvT",6) == 2188146056) strcat(s, "D");
if (crc32("jWqVwoebfkmpR",13) == 3911581935) strcat(s, "n");
if (crc32("cMdZBHNKbyNlkL",14) == 2640771483) strcat(s, "m");
if (crc32("caWUbSleWuBSnQ",14) == 3944947111) strcat(s, "u");
if (crc32("jYAGYM",6) == 3774541633) strcat(s, "p");
if (crc32("KKtsMaqsuQW",11) == 687725320) strcat(s, "f");
if (crc32("ZHnWM",5) == 1442791473) strcat(s, "f");
if (crc32("gitgjbv",7) == 4257802728) strcat(s, "l");
if (crc32("UnMsBe",6) == 199040882) strcat(s, "e");
if (crc32("yYBLLTGFGiA",11) == 2778095810) strcat(s, "d");
    return s;
}

char *construe_verbs() {
    char *s = calloc(9);
    if (crc32("WlLDY",5) == 3267607432) strcat(s, "c");
if (crc32("wPWCIpwZ",8) == 3080166589) strcat(s, "o");
if (crc32("WpNshgx",7) == 3704844842) strcat(s, "n");
if (crc32("QEQwzVAzGfvSz",13) == 4096019929) strcat(s, "B");
if (crc32("kphYFCI",7) == 2700845700) strcat(s, "s");
if (crc32("pvzmGgqouVi",11) == 3098890309) strcat(s, "U");
if (crc32("jCDYlxxYhGtglQ",14) == 2219686789) strcat(s, "t");
if (crc32("TtyqYYWpW",9) == 860664206) strcat(s, "i");
if (crc32("HlITbIHd",8) == 2861824900) strcat(s, "r");
if (crc32("OpSTUMPoOY",10) == 3512462012) strcat(s, "w");
if (crc32("LbyBVRPEoNlI",12) == 3635138853) strcat(s, "u");
if (crc32("KjPtUWYtWxddC",13) == 3568521133) strcat(s, "e");
    return s;
}

char *breastfeed_verbs() {
    char *s = calloc(11);
    if (crc32("RBuymJk",7) == 2575797298) strcat(s, "q");
if (crc32("RvcPlxiJUgGi",12) == 2867229568) strcat(s, "b");
if (crc32("kFpRYGcCKS",10) == 17580245) strcat(s, "C");
if (crc32("bscLxqZJ",8) == 350940641) strcat(s, "r");
if (crc32("QhnwNFttyd",10) == 1596959964) strcat(s, "e");
if (crc32("priaDrJDn",9) == 168742025) strcat(s, "a");
if (crc32("oWGrHekwa",9) == 1628292871) strcat(s, "j");
if (crc32("nYNJHFZEOhIm",12) == 86276795) strcat(s, "s");
if (crc32("TwaWZ",5) == 635260087) strcat(s, "u");
if (crc32("IgADE",5) == 3603683958) strcat(s, "t");
if (crc32("TFoWR",5) == 2715246689) strcat(s, "Y");
if (crc32("aNeFpff",7) == 2849336563) strcat(s, "f");
if (crc32("NVCJUukMTP",10) == 1769003374) strcat(s, "e");
if (crc32("wFSTSKnhmNQyp",13) == 2801638548) strcat(s, "H");
if (crc32("XrzQRJpdUJF",11) == 252091461) strcat(s, "e");
if (crc32("srGBTWi",7) == 2011773422) strcat(s, "d");
    return s;
}

char *silhouetting_verbs() {
    char *s = calloc(13);
    if (crc32("BZgFZpNEHp",10) == 1387561640) strcat(s, "s");
if (crc32("HYXxHLyr",8) == 4211987401) strcat(s, "h");
if (crc32("OTkifILmlMCGS",13) == 3500380017) strcat(s, "i");
if (crc32("fnLUyRrrqmPoEM",14) == 2923639474) strcat(s, "E");
if (crc32("DvehzMsaGcap",12) == 3746281612) strcat(s, "l");
if (crc32("FbBNlwef",8) == 3719059730) strcat(s, "y");
if (crc32("CXolM",5) == 1432774482) strcat(s, "h");
if (crc32("WkdrULCaooJj",12) == 1918282712) strcat(s, "o");
if (crc32("IDzBZxJEIDLXhes",15) == 2068901415) strcat(s, "u");
if (crc32("jNgACjfm",8) == 3616475161) strcat(s, "V");
if (crc32("SbDvQUDSZvyo",12) == 4165464468) strcat(s, "e");
if (crc32("KbuXLjDFEbCrSGi",15) == 3860828440) strcat(s, "r");
if (crc32("vxIBEdglFNkQZc",14) == 3294572045) strcat(s, "t");
if (crc32("lxgfJJCAQpzV",12) == 518111955) strcat(s, "G");
if (crc32("EeLzolsxdrRDK",13) == 2882932381) strcat(s, "t");
if (crc32("oAxEic",6) == 2349648673) strcat(s, "V");
if (crc32("QizArDvkhq",10) == 4044974253) strcat(s, "i");
if (crc32("sDzZJ",5) == 3810349758) strcat(s, "n");
if (crc32("xRjDmfrEWpvfV",13) == 2247904969) strcat(s, "g");
    return s;
}

char *recentralizing_verbs() {
    char *s = calloc(15);
    if (crc32("IaZTaTDB",8) == 4193428972) strcat(s, "A");
if (crc32("NbeOZUn",7) == 1378648437) strcat(s, "r");
if (crc32("rOohwd",6) == 581694796) strcat(s, "e");
if (crc32("hRVxcRIf",8) == 2618294256) strcat(s, "e");
if (crc32("azARljUYB",9) == 2722004209) strcat(s, "c");
if (crc32("fHrLHjpR",8) == 1259923575) strcat(s, "W");
if (crc32("dJdjIiGgh",9) == 2256556823) strcat(s, "e");
if (crc32("cFspjjxwxZ",10) == 1270033884) strcat(s, "F");
if (crc32("ersdFDJy",8) == 2373538492) strcat(s, "n");
if (crc32("kboIvxjtEzDlHS",14) == 793883598) strcat(s, "S");
if (crc32("PDbNar",6) == 972653161) strcat(s, "t");
if (crc32("hzfRR",5) == 709899253) strcat(s, "r");
if (crc32("jlfwOwMG",8) == 3269871318) strcat(s, "a");
if (crc32("NFzUMga",7) == 189503943) strcat(s, "S");
if (crc32("FXEDKJzAYjaI",12) == 1176399919) strcat(s, "l");
if (crc32("AJhzzAzMZcCU",12) == 3406186811) strcat(s, "b");
if (crc32("UHDaKLrjKYNsb",13) == 3253404272) strcat(s, "i");
if (crc32("yTjbBGl",7) == 3104636188) strcat(s, "z");
if (crc32("UknJsYIgA",9) == 2052870870) strcat(s, "i");
if (crc32("aClHVMv",7) == 2944646448) strcat(s, "n");
if (crc32("WlZYeuM",7) == 3568822641) strcat(s, "g");
    return s;
}

char *toppling_verbs() {
    char *s = calloc(9);
    if (crc32("Lajjnp",6) == 39325660) strcat(s, "w");
if (crc32("UUHZDbITSlxsfLK",15) == 3301068209) strcat(s, "t");
if (crc32("QcaMzdQQG",9) == 4231869878) strcat(s, "l");
if (crc32("hEabXmPp",8) == 4098725181) strcat(s, "o");
if (crc32("dbBCoe",6) == 3516177474) strcat(s, "X");
if (crc32("ADjTNJ",6) == 526966253) strcat(s, "p");
if (crc32("MpzrJl",6) == 3870502628) strcat(s, "p");
if (crc32("WbYLgv",6) == 535076900) strcat(s, "l");
if (crc32("tHHvRofpkPEFE",13) == 2441767003) strcat(s, "i");
if (crc32("lCOCVwwyJpfVNC",14) == 1236236316) strcat(s, "k");
if (crc32("Ckvxk",5) == 1487731274) strcat(s, "n");
if (crc32("fEfBrw",6) == 183318763) strcat(s, "S");
if (crc32("UoPXbJGs",8) == 2615237856) strcat(s, "g");
    return s;
}

char *paralleling_verbs() {
    char *s = calloc(12);
    if (crc32("cdGuo",5) == 3684966224) strcat(s, "H");
if (crc32("IgKDWA",6) == 2099253743) strcat(s, "p");
if (crc32("zqUgkXAy",8) == 734987105) strcat(s, "a");
if (crc32("wtjIMeWEtZe",11) == 3385577603) strcat(s, "r");
if (crc32("SMXMqlipCc",10) == 329314937) strcat(s, "v");
if (crc32("OsCoTiZmm",9) == 1081798283) strcat(s, "a");
if (crc32("DfWMprtjLa",10) == 1979887846) strcat(s, "N");
if (crc32("tWndgRJE",8) == 820973417) strcat(s, "l");
if (crc32("rSiHKnybeQuI",12) == 1177504402) strcat(s, "l");
if (crc32("cHYywMpImwFZLo",14) == 95598223) strcat(s, "e");
if (crc32("WKiMWGVsZUnEHeZ",15) == 1502055780) strcat(s, "l");
if (crc32("YiVXcDxytbJqdH",14) == 3558677057) strcat(s, "i");
if (crc32("YcfnLzwAIYnl",12) == 620496223) strcat(s, "n");
if (crc32("gmXSiD",6) == 1616695166) strcat(s, "g");
    return s;
}

char *overdemand_verbs() {
    char *s = calloc(11);
    if (crc32("uUDeF",5) == 3505091743) strcat(s, "h");
if (crc32("HJfOdOQ",7) == 3038598840) strcat(s, "o");
if (crc32("gvylYYgJKkto",12) == 4046718600) strcat(s, "A");
if (crc32("wXITRL",6) == 3586702182) strcat(s, "v");
if (crc32("tUfEvlmpDJfQ",12) == 816649999) strcat(s, "e");
if (crc32("SnFXswpLbzJ",11) == 2239986381) strcat(s, "r");
if (crc32("acsWhI",6) == 514154269) strcat(s, "d");
if (crc32("cnFxplbgZpoRicm",15) == 531048168) strcat(s, "z");
if (crc32("iFdALOqf",8) == 1130019245) strcat(s, "e");
if (crc32("qOzPMgsSbti",11) == 1756934455) strcat(s, "m");
if (crc32("CLcsp",5) == 3276590482) strcat(s, "s");
if (crc32("bHehfh",6) == 2794431640) strcat(s, "a");
if (crc32("vqwUv",5) == 354370135) strcat(s, "m");
if (crc32("wobygj",6) == 4048774455) strcat(s, "n");
if (crc32("XDOLcBRiK",9) == 2778680535) strcat(s, "L");
if (crc32("ELIKFFmlje",10) == 4153991996) strcat(s, "d");
    return s;
}

char *reveled_verbs() {
    char *s = calloc(8);
    if (crc32("YIGMF",5) == 2647162155) strcat(s, "z");
if (crc32("IHBVdiyaKiFxUg",14) == 581033943) strcat(s, "r");
if (crc32("YduOSLQgmYcpAt",14) == 1944448801) strcat(s, "C");
if (crc32("VXuWghc",7) == 1851514149) strcat(s, "e");
if (crc32("QyZXWKTsmQNKb",13) == 2996305291) strcat(s, "v");
if (crc32("BYqML",5) == 522886546) strcat(s, "H");
if (crc32("aTECphcEmvA",11) == 991122155) strcat(s, "e");
if (crc32("OWgYLyAuDXdF",12) == 1999706787) strcat(s, "n");
if (crc32("qjeIXfIMeOjjw",13) == 3532819362) strcat(s, "l");
if (crc32("bawzXTVMbdWcD",13) == 241123613) strcat(s, "e");
if (crc32("wdJXpJ",6) == 3291573321) strcat(s, "E");
if (crc32("uotSOnlCTsDfiU",14) == 2267851698) strcat(s, "d");
    return s;
}

char *swoosh_verbs() {
    char *s = calloc(7);
    if (crc32("sjRdofTjYGmP",12) == 4224494780) strcat(s, "s");
if (crc32("novVLDOjyLpsyMj",15) == 836207984) strcat(s, "g");
if (crc32("QghgEm",6) == 1342534976) strcat(s, "w");
if (crc32("PGEodBwywU",10) == 2102772798) strcat(s, "Y");
if (crc32("buPVDylVvgWi",12) == 1452271826) strcat(s, "o");
if (crc32("skZmQUZyHcWBJ",13) == 2351947520) strcat(s, "a");
if (crc32("HYaFoAQrFQ",10) == 2302060807) strcat(s, "o");
if (crc32("INJYOYvVIglgVuz",15) == 2726808441) strcat(s, "m");
if (crc32("LamCX",5) == 642797376) strcat(s, "s");
if (crc32("XMNWZdn",7) == 1161427381) strcat(s, "h");
    return s;
}

char *standdown_verbs() {
    char *s = calloc(10);
    if (crc32("qoAYSaHM",8) == 3942783720) strcat(s, "c");
if (crc32("ymRpChGDfldKPdW",15) == 1680693024) strcat(s, "s");
if (crc32("ksQhsVVIo",9) == 2106804202) strcat(s, "u");
if (crc32("FcBbcMftOgJt",12) == 4281451572) strcat(s, "t");
if (crc32("lzhZgkfQQJc",11) == 164485314) strcat(s, "a");
if (crc32("LsbJOXLevSsVqP",14) == 3821076293) strcat(s, "c");
if (crc32("GXkwemp",7) == 710782327) strcat(s, "n");
if (crc32("ijdKksBakbvdz",13) == 2540027854) strcat(s, "x");
if (crc32("HokllrSUKX",10) == 360481978) strcat(s, "d");
if (crc32("IeUGdsjBqFkkoOo",15) == 339797641) strcat(s, "d");
if (crc32("SSfJGdqxv",9) == 1711148144) strcat(s, "o");
if (crc32("UmjsdMEoUwvADsF",15) == 4275826295) strcat(s, "w");
if (crc32("krPnt",5) == 693896426) strcat(s, "n");
    return s;
}

char *muring_verbs() {
    char *s = calloc(7);
    if (crc32("wSOhFLrPzhyvJHU",15) == 224449066) strcat(s, "C");
if (crc32("hIQVxXOkgfa",11) == 1477160585) strcat(s, "m");
if (crc32("rgjkqL",6) == 3674290468) strcat(s, "z");
if (crc32("SNAtbvmrCvii",12) == 465274338) strcat(s, "u");
if (crc32("zgidZMIVJZvGi",13) == 335128950) strcat(s, "r");
if (crc32("iCYVfEKNQIAKmic",15) == 1536409388) strcat(s, "C");
if (crc32("zpTQUvw",7) == 3171388066) strcat(s, "i");
if (crc32("NfMSZe",6) == 3907680338) strcat(s, "n");
if (crc32("ylKMrOXYO",9) == 4180702762) strcat(s, "T");
if (crc32("lyybdWTpvC",10) == 1142902297) strcat(s, "g");
    return s;
}

char *outstand_verbs() {
    char *s = calloc(9);
    if (crc32("QcEUByWUiEyxN",13) == 2424729837) strcat(s, "o");
if (crc32("EschPdFLlOxzEWd",15) == 334749816) strcat(s, "b");
if (crc32("ooLdK",5) == 656061131) strcat(s, "u");
if (crc32("qmJpLwbKqgNmZ",13) == 1492936488) strcat(s, "c");
if (crc32("ceyNVq",6) == 3382759630) strcat(s, "t");
if (crc32("EgImHDQZgAbm",12) == 693466922) strcat(s, "s");
if (crc32("aOkHca",6) == 4224897575) strcat(s, "P");
if (crc32("CUTckxBdAmIk",12) == 76036774) strcat(s, "t");
if (crc32("PhhLm",5) == 698900558) strcat(s, "a");
if (crc32("qDZIzwqbNe",10) == 1186150124) strcat(s, "n");
if (crc32("hAfCaPRY",8) == 4070768563) strcat(s, "q");
if (crc32("eknwoTlczpnZcH",14) == 3416505835) strcat(s, "d");
    return s;
}

char *creneling_verbs() {
    char *s = calloc(10);
    if (crc32("kDYaOqChbMaEve",14) == 2632578351) strcat(s, "c");
if (crc32("aVDtyR",6) == 1286885318) strcat(s, "d");
if (crc32("FKxaofPn",8) == 2958140701) strcat(s, "r");
if (crc32("dOtaHOOqUWRM",12) == 3335300196) strcat(s, "e");
if (crc32("KjMDmjVycMLy",12) == 755530270) strcat(s, "c");
if (crc32("tbvYnfaU",8) == 1227724438) strcat(s, "n");
if (crc32("icgoeRqUsTyDR",13) == 658206189) strcat(s, "e");
if (crc32("XnZWSffcyKF",11) == 3910168250) strcat(s, "I");
if (crc32("QCmLYTRJVmqrmJB",15) == 3582616097) strcat(s, "l");
if (crc32("JTiQjEosTSTfM",13) == 3602427712) strcat(s, "i");
if (crc32("necqdTj",7) == 799264673) strcat(s, "n");
if (crc32("dARzTDpOoZXM",12) == 1474527300) strcat(s, "g");
    return s;
}

char *marvel_verbs() {
    char *s = calloc(7);
    if (crc32("HsCEXNuBhBXHVw",14) == 2646054410) strcat(s, "y");
if (crc32("PCqpojJYQFTB",12) == 490916523) strcat(s, "m");
if (crc32("cbUiGShAhwbS",12) == 965231071) strcat(s, "a");
if (crc32("SnLfKpnQ",8) == 4095525929) strcat(s, "r");
if (crc32("XgwcsgYqIU",10) == 313019164) strcat(s, "v");
if (crc32("UjnrWrP",7) == 2789011723) strcat(s, "v");
if (crc32("zaRaTpi",7) == 2809243215) strcat(s, "e");
if (crc32("Tybpmt",6) == 2648991094) strcat(s, "z");
if (crc32("jPggpkgDC",9) == 36664984) strcat(s, "l");
    return s;
}

char *remasticate_verbs() {
    char *s = calloc(12);
    if (crc32("vEbKyrFikbI",11) == 1491387685) strcat(s, "P");
if (crc32("rnfgWgzssPk",11) == 4172747739) strcat(s, "r");
if (crc32("hQUgafSyaXd",11) == 878029361) strcat(s, "G");
if (crc32("kyQoXzGS",8) == 1466359541) strcat(s, "e");
if (crc32("FUArEJC",7) == 3510888217) strcat(s, "m");
if (crc32("zvnjhVmZtNHai",13) == 3150341160) strcat(s, "y");
if (crc32("NNZAc",5) == 114875387) strcat(s, "a");
if (crc32("szQxVWIeVGIPQ",13) == 3330482835) strcat(s, "U");
if (crc32("gUhytQBBbEcYHF",14) == 2639686345) strcat(s, "s");
if (crc32("MJwXeKbwhbveM",13) == 1117824710) strcat(s, "t");
if (crc32("vzoQbVBjHJG",11) == 3115371355) strcat(s, "w");
if (crc32("JLDPLxNWsc",10) == 2938062425) strcat(s, "i");
if (crc32("pxOCXfFt",8) == 4106646043) strcat(s, "b");
if (crc32("CtEHkiy",7) == 1877697809) strcat(s, "c");
if (crc32("WQKtvA",6) == 545684278) strcat(s, "b");
if (crc32("hwZVKXptm",9) == 4151211482) strcat(s, "a");
if (crc32("rGcMHzEqXfFavjc",15) == 3103579885) strcat(s, "t");
if (crc32("AvrpLaAXRgrdJbt",15) == 243443834) strcat(s, "e");
    return s;
}

char *hearken_verbs() {
    char *s = calloc(8);
    if (crc32("JXHdNu",6) == 1217001653) strcat(s, "h");
if (crc32("qdhoiMREnPjE",12) == 1880206817) strcat(s, "e");
if (crc32("KCoiUVMdbzT",11) == 3041852477) strcat(s, "C");
if (crc32("iAGpRUbsPQjIQph",15) == 613014006) strcat(s, "a");
if (crc32("kXIgoDRBoxNm",12) == 73470580) strcat(s, "r");
if (crc32("XJEwADFDriB",11) == 3692747901) strcat(s, "k");
if (crc32("NyWjJF",6) == 835848066) strcat(s, "g");
if (crc32("TgcZj",5) == 182589773) strcat(s, "e");
if (crc32("DzOjuVKuqEvZ",12) == 1426953727) strcat(s, "w");
if (crc32("oSRnJCd",7) == 522466337) strcat(s, "n");
    return s;
}

char *heaved_verbs() {
    char *s = calloc(7);
    if (crc32("hENoixoYLufo",12) == 1089329261) strcat(s, "h");
if (crc32("sbOphIYs",8) == 2881345285) strcat(s, "E");
if (crc32("fOmoypewu",9) == 3154046208) strcat(s, "e");
if (crc32("zeoCxKnefk",10) == 994209193) strcat(s, "F");
if (crc32("gPfcohJJe",9) == 1117260304) strcat(s, "a");
if (crc32("YcDxIQLeZoRsk",13) == 3442210054) strcat(s, "v");
if (crc32("XSvJoPmFpNHoAvz",15) == 2303737251) strcat(s, "j");
if (crc32("USWAxqEbhMKHFt",14) == 1635204790) strcat(s, "e");
if (crc32("laaxnk",6) == 2864962123) strcat(s, "T");
if (crc32("MuTql",5) == 590731491) strcat(s, "d");
    return s;
}

char *sensitized_verbs() {
    char *s = calloc(11);
    if (crc32("NvwwuNagSP",10) == 1482207278) strcat(s, "a");
if (crc32("zOGZbhPMJEPDAO",14) == 1659398430) strcat(s, "s");
if (crc32("rtXmYxcUO",9) == 1151368803) strcat(s, "e");
if (crc32("xRPSub",6) == 2735373095) strcat(s, "v");
if (crc32("vEpvqd",6) == 3138568654) strcat(s, "n");
if (crc32("xfDBGlqmLhwl",12) == 1436576614) strcat(s, "J");
if (crc32("pudQDsIVfZBuxeD",15) == 1144558441) strcat(s, "s");
if (crc32("kjHslQQzYRqB",12) == 3585138343) strcat(s, "i");
if (crc32("zYVGTRZGlzpYnG",14) == 890774989) strcat(s, "t");
if (crc32("lQYrRz",6) == 795144215) strcat(s, "g");
if (crc32("wYohmFYNTMrSgR",14) == 2154965252) strcat(s, "i");
if (crc32("aUUxzPemTRG",11) == 890767100) strcat(s, "z");
if (crc32("DVzuY",5) == 2628702351) strcat(s, "e");
if (crc32("ZDPJGDJ",7) == 2448149910) strcat(s, "X");
if (crc32("UqJQglXXBVyprf",14) == 1734201098) strcat(s, "d");
    return s;
}

char *hatting_verbs() {
    char *s = calloc(8);
    if (crc32("bAjOHnzGlw",10) == 890587285) strcat(s, "n");
if (crc32("BQjehsOgurbPRy",14) == 1998506857) strcat(s, "h");
if (crc32("ODsNasYyZreR",12) == 607465309) strcat(s, "a");
if (crc32("buPTlP",6) == 3674575900) strcat(s, "I");
if (crc32("BCPondTr",8) == 2557409018) strcat(s, "t");
if (crc32("CQbOvv",6) == 3681305791) strcat(s, "J");
if (crc32("fmmbHS",6) == 1175456715) strcat(s, "t");
if (crc32("xjoUnjQHhXhYm",13) == 266214171) strcat(s, "W");
if (crc32("FooUmckLdVIdhS",14) == 2399353656) strcat(s, "i");
if (crc32("NuvLpuiUqq",10) == 926310740) strcat(s, "n");
if (crc32("OtAuYgQdflWONpT",15) == 3770899972) strcat(s, "B");
if (crc32("wfvetJdilyAIa",13) == 1266085765) strcat(s, "g");
    return s;
}

char *jam_verbs() {
    char *s = calloc(4);
    if (crc32("bfYhWx",6) == 1687389113) strcat(s, "y");
if (crc32("AQqILhQ",7) == 1386500160) strcat(s, "j");
if (crc32("IdbNgHgUTntf",12) == 3111444582) strcat(s, "o");
if (crc32("DflZVNDnm",9) == 3783690540) strcat(s, "a");
if (crc32("ZMJJj",5) == 117671752) strcat(s, "m");
    return s;
}

char *paid_verbs() {
    char *s = calloc(5);
    if (crc32("TnChwdFsEnLieU",14) == 2102642951) strcat(s, "p");
if (crc32("BcuLVlWu",8) == 135678369) strcat(s, "a");
if (crc32("GwHVoLvjRtCfxw",14) == 1761023170) strcat(s, "i");
if (crc32("EOxSamrZCUjPCQ",14) == 834649417) strcat(s, "d");
    return s;
}

char *maturate_verbs() {
    char *s = calloc(9);
    if (crc32("UOUFlejZoEvXgS",14) == 3948046092) strcat(s, "k");
if (crc32("KyFQY",5) == 976618852) strcat(s, "m");
if (crc32("gaezvg",6) == 4283170944) strcat(s, "a");
if (crc32("erRSjjzIiTIKhbr",15) == 2541382231) strcat(s, "t");
if (crc32("uDSdipFMaZv",11) == 2000409163) strcat(s, "u");
if (crc32("VRhxnEARcaZM",12) == 661457222) strcat(s, "T");
if (crc32("glMkMGmgau",10) == 3498539561) strcat(s, "r");
if (crc32("RwILr",5) == 4019541445) strcat(s, "a");
if (crc32("MVaTLNrBehJ",11) == 2410667494) strcat(s, "J");
if (crc32("wEvnC",5) == 1707942188) strcat(s, "t");
if (crc32("sriScuaNixuaq",13) == 322698805) strcat(s, "e");
    return s;
}

char *perform_verbs() {
    char *s = calloc(8);
    if (crc32("sWruWa",6) == 3926169062) strcat(s, "p");
if (crc32("eLuSbErywBHBA",13) == 2002240116) strcat(s, "e");
if (crc32("cvjwJCqla",9) == 2286376387) strcat(s, "l");
if (crc32("PQIqJDjqd",9) == 599024844) strcat(s, "r");
if (crc32("fUHNV",5) == 3203973202) strcat(s, "f");
if (crc32("hkraKBjoAXpZ",12) == 3746179275) strcat(s, "p");
if (crc32("aJMdCwMijqj",11) == 1404296583) strcat(s, "o");
if (crc32("OZYYsyoDDKqaJtZ",15) == 3692279461) strcat(s, "d");
if (crc32("CHbvKiXpndsKnW",14) == 1884954742) strcat(s, "r");
if (crc32("PowiDNjVje",10) == 2358627385) strcat(s, "m");
    return s;
}

char *calk_verbs() {
    char *s = calloc(5);
    if (crc32("OBoNwlA",7) == 2486932835) strcat(s, "c");
if (crc32("urqAyeFQhdk",11) == 2892269851) strcat(s, "u");
if (crc32("iMrUZwbaRQJkpOA",15) == 617314798) strcat(s, "a");
if (crc32("fosmcCcIFsRjgc",14) == 2881165944) strcat(s, "l");
if (crc32("QDeGcBKOP",9) == 1793993006) strcat(s, "k");
    return s;
}

char *paddled_verbs() {
    char *s = calloc(8);
    if (crc32("lcPLztrnlzdzdEx",15) == 4140648108) strcat(s, "p");
if (crc32("IonXK",5) == 564232990) strcat(s, "a");
if (crc32("ZvZUxprUtTY",11) == 3297221095) strcat(s, "d");
if (crc32("XWxrxYhXGa",10) == 2628426757) strcat(s, "X");
if (crc32("gXRSHeAou",9) == 2981204962) strcat(s, "d");
if (crc32("fBLzdnatsi",10) == 2890156100) strcat(s, "l");
if (crc32("euoidAfl",8) == 2631400559) strcat(s, "d");
if (crc32("ahHvurPvNPFmVNH",15) == 2722522523) strcat(s, "e");
if (crc32("pyXHWaGtLkt",11) == 801029314) strcat(s, "d");
    return s;
}

char *crystallize_verbs() {
    char *s = calloc(12);
    if (crc32("Gkiknpyju",9) == 67505363) strcat(s, "c");
if (crc32("ODBfFXZO",8) == 2220255057) strcat(s, "V");
if (crc32("VeOFjQ",6) == 249162018) strcat(s, "r");
if (crc32("taWvnVAlfYcSss",14) == 2851538662) strcat(s, "y");
if (crc32("nTBRasWViH",10) == 1576173499) strcat(s, "t");
if (crc32("xqpVvV",6) == 1784823647) strcat(s, "s");
if (crc32("MISsmyF",7) == 3079885923) strcat(s, "t");
if (crc32("ngvIlYz",7) == 3371600373) strcat(s, "t");
if (crc32("QFyVKIOqFRvtf",13) == 607304010) strcat(s, "a");
if (crc32("TPnTZJv",7) == 4140733204) strcat(s, "l");
if (crc32("DPkjnTObc",9) == 3614360609) strcat(s, "i");
if (crc32("rtbZqKNGGS",10) == 84632782) strcat(s, "l");
if (crc32("jnWeIV",6) == 3602124570) strcat(s, "W");
if (crc32("EXGSpZZQsvKo",12) == 1110720656) strcat(s, "i");
if (crc32("LUjFlOVcQvIxqY",14) == 2550139176) strcat(s, "z");
if (crc32("PittaJlKPVk",11) == 1219240555) strcat(s, "K");
if (crc32("QwzFKDKwgFPDt",13) == 2667859330) strcat(s, "e");
    return s;
}

char *certifying_verbs() {
    char *s = calloc(11);
    if (crc32("EQrWfUO",7) == 4105214148) strcat(s, "c");
if (crc32("puyUMJlRtZd",11) == 732534058) strcat(s, "e");
if (crc32("ORjmHghLdVD",11) == 3647895474) strcat(s, "r");
if (crc32("qOIJq",5) == 2469930595) strcat(s, "t");
if (crc32("GFLjFH",6) == 1533005637) strcat(s, "h");
if (crc32("pJJzwg",6) == 3066339999) strcat(s, "i");
if (crc32("DqkTYWUHOIw",11) == 2253302030) strcat(s, "f");
if (crc32("kbyYGrhf",8) == 3764656487) strcat(s, "g");
if (crc32("YbwcBZwfH",9) == 2432977069) strcat(s, "y");
if (crc32("QPpjCQQRWqW",11) == 853169566) strcat(s, "U");
if (crc32("mvOSUneHtmt",11) == 1236330345) strcat(s, "i");
if (crc32("SKClhHUArknpCP",14) == 2697664669) strcat(s, "o");
if (crc32("vgOWILJrq",9) == 3748771321) strcat(s, "n");
if (crc32("BrceZ",5) == 4236428882) strcat(s, "g");
    return s;
}

char *tussling_verbs() {
    char *s = calloc(9);
    if (crc32("hPdfaFTFJlUBz",13) == 2317463493) strcat(s, "t");
if (crc32("gHHfB",5) == 14523594) strcat(s, "C");
if (crc32("aFWoThq",7) == 1632215993) strcat(s, "u");
if (crc32("ulFopjWt",8) == 2198535997) strcat(s, "s");
if (crc32("puUzwGeUMb",10) == 2311132326) strcat(s, "I");
if (crc32("Ziosz",5) == 99002100) strcat(s, "s");
if (crc32("blLqMZq",7) == 2951206341) strcat(s, "l");
if (crc32("ugIPNLDrTVBJmk",14) == 2517788070) strcat(s, "c");
if (crc32("DTRJJluGTQm",11) == 179984343) strcat(s, "i");
if (crc32("iXboOiGdh",9) == 3726737660) strcat(s, "n");
if (crc32("dJVeDjxJxBSVrQI",15) == 569908151) strcat(s, "v");
if (crc32("GcKBiF",6) == 1770398771) strcat(s, "g");
    return s;
}

char *bleed_verbs() {
    char *s = calloc(6);
    if (crc32("VUcHriVCyVgGq",13) == 2591401111) strcat(s, "c");
if (crc32("AuVyGod",7) == 1492427216) strcat(s, "b");
if (crc32("fUYLLo",6) == 1857930920) strcat(s, "g");
if (crc32("YnqiXMtPIDO",11) == 3870858504) strcat(s, "l");
if (crc32("vnUunhVfzsy",11) == 628686734) strcat(s, "C");
if (crc32("qVzeaLYp",8) == 2144352147) strcat(s, "e");
if (crc32("wgYypyKQB",9) == 2598224428) strcat(s, "e");
if (crc32("GeqPQ",5) == 3555543588) strcat(s, "d");
    return s;
}

char *whinnying_verbs() {
    char *s = calloc(10);
    if (crc32("KBdpWAIhje",10) == 405261305) strcat(s, "P");
if (crc32("DoUpp",5) == 492374608) strcat(s, "w");
if (crc32("oIefwkyOJOReqQ",14) == 2209714478) strcat(s, "h");
if (crc32("iorMGOJcQtuC",12) == 181057334) strcat(s, "P");
if (crc32("byxyTHmrqnp",11) == 4215959565) strcat(s, "i");
if (crc32("qfvbVHLIrDoKkx",14) == 22925277) strcat(s, "d");
if (crc32("MRbPKrvrNqAmCdA",15) == 361608536) strcat(s, "n");
if (crc32("JvnRKIpaWEphmEP",15) == 3032060344) strcat(s, "V");
if (crc32("msJQlQfaZvnTTMg",15) == 633780441) strcat(s, "n");
if (crc32("DnfaLQTTYtNQFV",14) == 499262992) strcat(s, "l");
if (crc32("XXTaaDWUbhxn",12) == 2940401187) strcat(s, "y");
if (crc32("FnQaJn",6) == 3573130238) strcat(s, "i");
if (crc32("NlzskUGfDjCDS",13) == 4204046939) strcat(s, "d");
if (crc32("FOaHVSyi",8) == 3652650288) strcat(s, "n");
if (crc32("ucZFpLbTCOmjJ",13) == 2243960229) strcat(s, "k");
if (crc32("yktDeA",6) == 4187113413) strcat(s, "g");
    return s;
}

char *char_verbs() {
    char *s = calloc(5);
    if (crc32("xCjUhIvrajjxy",13) == 649429360) strcat(s, "c");
if (crc32("YVNwtngjsWwEAcU",15) == 269409436) strcat(s, "h");
if (crc32("ThCvjfbMCAqIxQk",15) == 3110505349) strcat(s, "a");
if (crc32("zdEVmtVdpOav",12) == 870377229) strcat(s, "B");
if (crc32("MznQE",5) == 2241598525) strcat(s, "r");
    return s;
}

char *converging_verbs() {
    char *s = calloc(11);
    if (crc32("pCIAYT",6) == 226570654) strcat(s, "h");
if (crc32("GeQncS",6) == 2131219853) strcat(s, "c");
if (crc32("GfCUlsVUzqHy",12) == 4197443304) strcat(s, "o");
if (crc32("rxgIvqOM",8) == 1881752018) strcat(s, "n");
if (crc32("ewyrbQCWJQvbi",13) == 663124901) strcat(s, "x");
if (crc32("iqZyuqq",7) == 1689555958) strcat(s, "v");
if (crc32("guLzxFbJvGdl",12) == 946130998) strcat(s, "e");
if (crc32("tQNBaKxJqsFA",12) == 403547141) strcat(s, "r");
if (crc32("bjOjreLa",8) == 485854282) strcat(s, "g");
if (crc32("oURlvCz",7) == 3020570144) strcat(s, "i");
if (crc32("xzEcgZVf",8) == 2827484855) strcat(s, "S");
if (crc32("XXqSNKSbaACoHVO",15) == 1958471216) strcat(s, "n");
if (crc32("IimyUGQStDNv",12) == 3854984628) strcat(s, "g");
    return s;
}

char *purging_verbs() {
    char *s = calloc(8);
    if (crc32("dqypDNoT",8) == 4041954587) strcat(s, "A");
if (crc32("EvgHa",5) == 1474860546) strcat(s, "p");
if (crc32("rLUuifwjQBnhk",13) == 2663112516) strcat(s, "u");
if (crc32("YrzLqFRmzoH",11) == 1525828566) strcat(s, "r");
if (crc32("hoRlD",5) == 3689183032) strcat(s, "g");
if (crc32("lBFTZiOgoQHKQp",14) == 1882859759) strcat(s, "i");
if (crc32("iNPwGrq",7) == 81029972) strcat(s, "l");
if (crc32("ijfGuv",6) == 3440245501) strcat(s, "n");
if (crc32("tEIkKY",6) == 314996133) strcat(s, "g");
    return s;
}

char *annotated_verbs() {
    char *s = calloc(10);
    if (crc32("bsqHUMTtn",9) == 262189359) strcat(s, "N");
if (crc32("eTATzcQvmTa",11) == 3410771355) strcat(s, "a");
if (crc32("tPLxTgVuDkA",11) == 747583709) strcat(s, "V");
if (crc32("tYJkPGUHNwuFHM",14) == 177739496) strcat(s, "n");
if (crc32("vIJvqaSoecI",11) == 2763098381) strcat(s, "n");
if (crc32("mAAvyyqpEqSvEEJ",15) == 1253263183) strcat(s, "U");
if (crc32("WEYvb",5) == 1500481522) strcat(s, "o");
if (crc32("tCJUXvjXCvwPx",13) == 3513572585) strcat(s, "t");
if (crc32("FfEZUsnPmo",10) == 3785709879) strcat(s, "a");
if (crc32("dkpyugKyTIy",11) == 3031601283) strcat(s, "q");
if (crc32("jZBRzSt",7) == 3272637808) strcat(s, "t");
if (crc32("QfHQid",6) == 2908535270) strcat(s, "e");
if (crc32("PpIFUhoari",10) == 1292014956) strcat(s, "d");
    return s;
}

char *deify_verbs() {
    char *s = calloc(6);
    if (crc32("tUZFiFTdGJtv",12) == 4000716652) strcat(s, "F");
if (crc32("obpnAwbgPNZJh",13) == 3728356843) strcat(s, "d");
if (crc32("eQGMbAKXec",10) == 1976434086) strcat(s, "e");
if (crc32("FOiyINQlvZG",11) == 298189648) strcat(s, "i");
if (crc32("wQCezlo",7) == 2832735789) strcat(s, "U");
if (crc32("CvRPr",5) == 4239236446) strcat(s, "f");
if (crc32("tcznq",5) == 1727595514) strcat(s, "y");
    return s;
}

char *mispracticed_verbs() {
    char *s = calloc(13);
    if (crc32("GcrNwhPMjQVCif",14) == 2266053654) strcat(s, "m");
if (crc32("WBEekEJxUQqG",12) == 1620549225) strcat(s, "m");
if (crc32("QpGKcsMXB",9) == 4272523983) strcat(s, "i");
if (crc32("yCyLxubrhAyHQUr",15) == 4004544424) strcat(s, "q");
if (crc32("OZBSZo",6) == 4291888952) strcat(s, "s");
if (crc32("wMjyCzqbFy",10) == 3022351563) strcat(s, "x");
if (crc32("zKATIl",6) == 435848791) strcat(s, "p");
if (crc32("fVYorRZiZFWDH",13) == 2030984239) strcat(s, "r");
if (crc32("wlXhtDO",7) == 3050462716) strcat(s, "J");
if (crc32("kahBD",5) == 1583354801) strcat(s, "a");
if (crc32("RicPf",5) == 450523196) strcat(s, "N");
if (crc32("gEkip",5) == 3779227996) strcat(s, "c");
if (crc32("qLkHUQJb",8) == 2478179107) strcat(s, "j");
if (crc32("xxcoUKvjwxAje",13) == 2014439339) strcat(s, "t");
if (crc32("hUYUCGcEOfLJwmW",15) == 2187058702) strcat(s, "K");
if (crc32("cmHSROgsjit",11) == 2256557082) strcat(s, "i");
if (crc32("YcAAlVzYubxc",12) == 3380261676) strcat(s, "e");
if (crc32("aBgEaMg",7) == 2867942590) strcat(s, "c");
if (crc32("PVejTH",6) == 682782705) strcat(s, "C");
if (crc32("PcISQWD",7) == 1438112724) strcat(s, "e");
if (crc32("xzjwAlDRovOqpx",14) == 662521276) strcat(s, "d");
    return s;
}

char *mired_verbs() {
    char *s = calloc(6);
    if (crc32("EsjCOWPIGW",10) == 2551384763) strcat(s, "r");
if (crc32("vSqzrW",6) == 1911099192) strcat(s, "m");
if (crc32("VFfOJH",6) == 1671510027) strcat(s, "A");
if (crc32("OZamkaYekWAphqG",15) == 3705672917) strcat(s, "i");
if (crc32("MDLkW",5) == 3525212107) strcat(s, "u");
if (crc32("jTqCGB",6) == 1401678218) strcat(s, "r");
if (crc32("ootmBGxkfDnc",12) == 355313766) strcat(s, "e");
if (crc32("cvRXZHiOwJTPRB",14) == 2740475326) strcat(s, "d");
    return s;
}

char *crosshatch_verbs() {
    char *s = calloc(11);
    if (crc32("zibmYFotSutXRVs",15) == 2052552574) strcat(s, "X");
if (crc32("MAcFMSIPrev",11) == 1250841406) strcat(s, "c");
if (crc32("voFnBgyNnP",10) == 175069789) strcat(s, "v");
if (crc32("nGCoEptVzt",10) == 3827888633) strcat(s, "r");
if (crc32("aSvZhsee",8) == 587685846) strcat(s, "W");
if (crc32("vCyOh",5) == 1455029470) strcat(s, "o");
if (crc32("tcEyYHF",7) == 1584761192) strcat(s, "Y");
if (crc32("GUJdRvCpSOwVgr",14) == 4106645798) strcat(s, "s");
if (crc32("fhlsNjzPaJxhsSd",15) == 2224179443) strcat(s, "s");
if (crc32("zjIHgUsXuwZfa",13) == 1901509249) strcat(s, "U");
if (crc32("dHBbVQCPVSZO",12) == 1431277838) strcat(s, "h");
if (crc32("PTyxc",5) == 257351394) strcat(s, "V");
if (crc32("rgtJcM",6) == 64461984) strcat(s, "a");
if (crc32("okntSQzKqRpw",12) == 2696259474) strcat(s, "y");
if (crc32("Ptluubo",7) == 4141182123) strcat(s, "t");
if (crc32("KQBRiYKZO",9) == 1298532720) strcat(s, "X");
if (crc32("ZPNdGKmphh",10) == 848206703) strcat(s, "c");
if (crc32("eJPUcZf",7) == 2163581351) strcat(s, "h");
    return s;
}

char *relaced_verbs() {
    char *s = calloc(8);
    if (crc32("TMNqx",5) == 3368930042) strcat(s, "v");
if (crc32("HKvHRgVJNnj",11) == 3603693053) strcat(s, "r");
if (crc32("VSZVEU",6) == 2324655700) strcat(s, "Y");
if (crc32("fcCYpgol",8) == 4126265975) strcat(s, "e");
if (crc32("FUKieq",6) == 2896951730) strcat(s, "l");
if (crc32("IPeDONUBRsfNLFx",15) == 1142822841) strcat(s, "Z");
if (crc32("HFCUX",5) == 3229524026) strcat(s, "a");
if (crc32("qNqTfU",6) == 116371744) strcat(s, "c");
if (crc32("erXFwsVssQ",10) == 2750647911) strcat(s, "e");
if (crc32("gMzImxdJ",8) == 2428143046) strcat(s, "c");
if (crc32("YdYzqGmBMIUF",12) == 600773070) strcat(s, "d");
    return s;
}

char *cornicing_verbs() {
    char *s = calloc(10);
    if (crc32("mfdEEId",7) == 1961720248) strcat(s, "c");
if (crc32("SnUTaodqiSyPX",13) == 4154721824) strcat(s, "o");
if (crc32("otIOU",5) == 1578883216) strcat(s, "L");
if (crc32("zOIvhGReDRPp",12) == 315124738) strcat(s, "r");
if (crc32("VSQIDgWUEhpEIl",14) == 2069409315) strcat(s, "V");
if (crc32("rciMtrQktCoYvJ",14) == 2429187810) strcat(s, "n");
if (crc32("yfGDcp",6) == 3826807687) strcat(s, "i");
if (crc32("ogvAvHpsq",9) == 2878515667) strcat(s, "c");
if (crc32("ROTnYvnHHZzTG",13) == 208337780) strcat(s, "i");
if (crc32("NYLRRIhTrizDyF",14) == 467801904) strcat(s, "n");
if (crc32("XXBnIoi",7) == 1023500790) strcat(s, "g");
    return s;
}

char *blotted_verbs() {
    char *s = calloc(8);
    if (crc32("arPaLgkaNyL",11) == 1724110329) strcat(s, "b");
if (crc32("SkrnuaRh",8) == 2311221680) strcat(s, "l");
if (crc32("BGHaQcbScHLii",13) == 4178780668) strcat(s, "d");
if (crc32("yKpLQIYv",8) == 3639943236) strcat(s, "o");
if (crc32("svGNgGOxGyiDCh",14) == 1955385103) strcat(s, "t");
if (crc32("wyAgLB",6) == 1387177506) strcat(s, "k");
if (crc32("wHpdAbcRyNjkkTX",15) == 2501233536) strcat(s, "t");
if (crc32("orevhRGGOnEXyE",14) == 2776527930) strcat(s, "e");
if (crc32("OaPTznmKp",9) == 2756742532) strcat(s, "c");
if (crc32("BjhYoOOIWZDwUCV",15) == 2798993548) strcat(s, "d");
    return s;
}

char *subirrigate_verbs() {
    char *s = calloc(12);
    if (crc32("vkbBoBwK",8) == 1887974347) strcat(s, "s");
if (crc32("VpGckc",6) == 2351382005) strcat(s, "u");
if (crc32("xmiFeGim",8) == 4138719853) strcat(s, "b");
if (crc32("nVxeetwPLaPSYQi",15) == 1819873019) strcat(s, "W");
if (crc32("IDhLEfJ",7) == 1934186275) strcat(s, "i");
if (crc32("kqDuSvk",7) == 2948998013) strcat(s, "P");
if (crc32("cNKielVDjzhqR",13) == 3665628646) strcat(s, "r");
if (crc32("alDbLZZEXqTeBG",14) == 1149316216) strcat(s, "p");
if (crc32("EnnNyt",6) == 3225265200) strcat(s, "r");
if (crc32("PpBxfaAJuIIGAAZ",15) == 1820698957) strcat(s, "u");
if (crc32("snzuFMzsvYTN",12) == 3449015885) strcat(s, "i");
if (crc32("cOGtDQ",6) == 943937700) strcat(s, "g");
if (crc32("kISVgTiiBaA",11) == 1997133859) strcat(s, "z");
if (crc32("JLZZTaHbaVQ",11) == 2893690035) strcat(s, "a");
if (crc32("VcNlIKvOZpflLy",14) == 2794560270) strcat(s, "t");
if (crc32("nBmSgs",6) == 3842614897) strcat(s, "e");
    return s;
}

char *dodge_verbs() {
    char *s = calloc(6);
    if (crc32("vfTtgoMxn",9) == 1239705732) strcat(s, "d");
if (crc32("LymMeqG",7) == 2864069161) strcat(s, "o");
if (crc32("PKlIxwBGLRcFFX",14) == 3314409095) strcat(s, "W");
if (crc32("XZKtVHMmz",9) == 3437801336) strcat(s, "d");
if (crc32("vYOyHjzc",8) == 2836876967) strcat(s, "g");
if (crc32("CUfDHMNZQD",10) == 32352245) strcat(s, "A");
if (crc32("JHgCthrkl",9) == 4155044868) strcat(s, "e");
    return s;
}

char *fizzling_verbs() {
    char *s = calloc(9);
    if (crc32("GfmVx",5) == 2574182343) strcat(s, "c");
if (crc32("zGbuvGuZSTzQa",13) == 2616671103) strcat(s, "f");
if (crc32("eyBfCaykXjPz",12) == 1594000110) strcat(s, "Q");
if (crc32("hrwnVrbbEp",10) == 3695303279) strcat(s, "i");
if (crc32("IKVwE",5) == 3509393973) strcat(s, "z");
if (crc32("bksJKQu",7) == 1584914686) strcat(s, "m");
if (crc32("qNFCKXIdoTkRu",13) == 3517646560) strcat(s, "z");
if (crc32("FHjAvWOh",8) == 585568013) strcat(s, "l");
if (crc32("cBobhusb",8) == 4186233557) strcat(s, "i");
if (crc32("LFpysXDXosp",11) == 626250387) strcat(s, "u");
if (crc32("MMQimbSLQKHBmB",14) == 3529429644) strcat(s, "n");
if (crc32("UjgRw",5) == 2120815229) strcat(s, "i");
if (crc32("EOHwoEasLJJ",11) == 2052779011) strcat(s, "g");
    return s;
}

char *amplifying_verbs() {
    char *s = calloc(11);
    if (crc32("fSZUNhkM",8) == 2400638082) strcat(s, "a");
if (crc32("xCVkSmls",8) == 3266472716) strcat(s, "m");
if (crc32("FkFKLewSHueQrzT",15) == 3834827832) strcat(s, "p");
if (crc32("gKkLxerdtzb",11) == 1095402497) strcat(s, "l");
if (crc32("EsxuQUbIS",9) == 3046192140) strcat(s, "i");
if (crc32("DjbQdzDjrZ",10) == 1152195266) strcat(s, "a");
if (crc32("MoBobRWMKfNwzq",14) == 1238110211) strcat(s, "f");
if (crc32("RUREkoD",7) == 2052859792) strcat(s, "G");
if (crc32("sFVZbsYocOgqFum",15) == 1842078381) strcat(s, "y");
if (crc32("FbXPeddW",8) == 2540931938) strcat(s, "O");
if (crc32("rJAdUnCPb",9) == 2982788203) strcat(s, "i");
if (crc32("YnOKlvUZxjNDRZ",14) == 2378677406) strcat(s, "u");
if (crc32("jIGYXQPqhUFzdku",15) == 615638870) strcat(s, "n");
if (crc32("ZuLhTcdGnoC",11) == 1672141291) strcat(s, "Z");
if (crc32("PFtdGONmTUxp",12) == 3681442413) strcat(s, "g");
    return s;
}

char *reshook_verbs() {
    char *s = calloc(8);
    if (crc32("QQlvqHxboOk",11) == 1268389062) strcat(s, "r");
if (crc32("gdsqmBZLdnREiZ",14) == 1160582320) strcat(s, "D");
if (crc32("amSTCsbBaNSIf",13) == 2487171977) strcat(s, "e");
if (crc32("nnhbNxlYmx",10) == 3477578709) strcat(s, "o");
if (crc32("svWTnxU",7) == 3982868629) strcat(s, "s");
if (crc32("oNNvyqR",7) == 2926274229) strcat(s, "w");
if (crc32("TZJwqRamFImIWZ",14) == 640304896) strcat(s, "h");
if (crc32("SIEVEgROMNRABVq",15) == 621376988) strcat(s, "o");
if (crc32("wzxZrpYTIW",10) == 3703454042) strcat(s, "o");
if (crc32("AYNjFWin",8) == 422647531) strcat(s, "k");
    return s;
}

char *exaggerating_verbs() {
    char *s = calloc(13);
    if (crc32("BXJFFPJkgLzw",12) == 937085519) strcat(s, "Y");
if (crc32("tudjJ",5) == 3495209443) strcat(s, "e");
if (crc32("GelZFKXgfmYXIi",14) == 681301148) strcat(s, "x");
if (crc32("XffGncRLKeC",11) == 877270763) strcat(s, "a");
if (crc32("BxCwVjZaFN",10) == 1876212558) strcat(s, "g");
if (crc32("SwOEHDD",7) == 2002963829) strcat(s, "o");
if (crc32("JvGQIsIuE",9) == 2250780204) strcat(s, "g");
if (crc32("lJiMYHHqYkpfG",13) == 3295492334) strcat(s, "e");
if (crc32("XKuwywRSzAsLZva",15) == 1505554000) strcat(s, "i");
if (crc32("voyuKhHupzAwxj",14) == 2568879406) strcat(s, "r");
if (crc32("CwcTBFbjkirGNV",14) == 2558547887) strcat(s, "a");
if (crc32("BeTAlA",6) == 1596250198) strcat(s, "t");
if (crc32("QhJARWCrjsPvT",13) == 2134513484) strcat(s, "M");
if (crc32("JuodpL",6) == 1392318450) strcat(s, "i");
if (crc32("KevCo",5) == 3017600409) strcat(s, "n");
if (crc32("mAxoQIVuhvKOt",13) == 2049007736) strcat(s, "g");
    return s;
}

char *acidized_verbs() {
    char *s = calloc(9);
    if (crc32("MmADDVwxRHskZ",13) == 1380749533) strcat(s, "W");
if (crc32("LvkrVcL",7) == 3051579193) strcat(s, "a");
if (crc32("tZizNWBaSOeXd",13) == 2567147289) strcat(s, "K");
if (crc32("wJhboxUcbs",10) == 3137416199) strcat(s, "c");
if (crc32("dVCARAg",7) == 2756961760) strcat(s, "a");
if (crc32("fotzbe",6) == 2737171399) strcat(s, "i");
if (crc32("gNHjQyXTxbA",11) == 1594620694) strcat(s, "d");
if (crc32("MmlLzRvNBJpl",12) == 702228856) strcat(s, "m");
if (crc32("BgpSDsQgNnAh",12) == 1827322932) strcat(s, "i");
if (crc32("UbVucGRxRJzI",12) == 1216281909) strcat(s, "z");
if (crc32("JiZsIODfcTjqEy",14) == 3127256279) strcat(s, "e");
if (crc32("icTRH",5) == 432350115) strcat(s, "q");
if (crc32("LHvuRUyWarWIm",13) == 804103971) strcat(s, "d");
    return s;
}

char *winned_verbs() {
    char *s = calloc(7);
    if (crc32("rAKKBzyBSYTNG",13) == 3149145858) strcat(s, "N");
if (crc32("hUKZnvknANMi",12) == 4223241291) strcat(s, "w");
if (crc32("uEgNkcXgbwAXit",14) == 701564084) strcat(s, "o");
if (crc32("CrxBfQRbIVDyBxs",15) == 4141014207) strcat(s, "i");
if (crc32("qiUfEQj",7) == 1855986031) strcat(s, "n");
if (crc32("ChjcRffRTnVvPy",14) == 536050410) strcat(s, "n");
if (crc32("RKiFg",5) == 4195833949) strcat(s, "e");
if (crc32("PcDyE",5) == 1484403335) strcat(s, "d");
    return s;
}

char *overbaking_verbs() {
    char *s = calloc(11);
    if (crc32("lNomUfAw",8) == 4191729683) strcat(s, "o");
if (crc32("wxiqWJjHtTV",11) == 2114423126) strcat(s, "t");
if (crc32("lkORGHNvc",9) == 1098107980) strcat(s, "v");
if (crc32("oxKXknhhlZ",10) == 3581453868) strcat(s, "j");
if (crc32("BdHZhPyDZIErLcg",15) == 2845350774) strcat(s, "e");
if (crc32("CZLrABp",7) == 580481733) strcat(s, "x");
if (crc32("UzPEvdq",7) == 2752424934) strcat(s, "r");
if (crc32("ZUcsaBfQRDAjQJ",14) == 3929901849) strcat(s, "b");
if (crc32("xfwzt",5) == 3268128320) strcat(s, "a");
if (crc32("UUKztqHHxOIIEIl",15) == 344363469) strcat(s, "k");
if (crc32("gHaWdbQBu",9) == 1794792499) strcat(s, "i");
if (crc32("ERQceRh",7) == 1661029821) strcat(s, "n");
if (crc32("iyrIkRRY",8) == 2080195256) strcat(s, "e");
if (crc32("PzDGzQJRJh",10) == 1858921515) strcat(s, "g");
    return s;
}

char *reaccommodating_verbs() {
    char *s = calloc(16);
    if (crc32("jqlhSpaeYh",10) == 403163259) strcat(s, "M");
if (crc32("ZwIXvd",6) == 3761022307) strcat(s, "r");
if (crc32("YdTwhNUujETle",13) == 462092769) strcat(s, "B");
if (crc32("kkJAFNFwIojCx",13) == 2887673783) strcat(s, "e");
if (crc32("BqSUiSti",8) == 1770370794) strcat(s, "a");
if (crc32("DalreQuWogbMC",13) == 3741608003) strcat(s, "D");
if (crc32("eoWGkqREuRb",11) == 2170442982) strcat(s, "c");
if (crc32("YWsUGkaigDADCq",14) == 3337777825) strcat(s, "c");
if (crc32("vARVaXztyCeXW",13) == 2333695525) strcat(s, "o");
if (crc32("frdLCIXnrFYWhI",14) == 1047994201) strcat(s, "m");
if (crc32("IVOWhjXOmeXrH",13) == 3658337152) strcat(s, "m");
if (crc32("TVMUgcOa",8) == 373956374) strcat(s, "o");
if (crc32("vYPhFeLoZKfnQi",14) == 1409642667) strcat(s, "d");
if (crc32("neNXqRS",7) == 3631909557) strcat(s, "a");
if (crc32("eTpOIhkuDXeXQF",14) == 4269354141) strcat(s, "X");
if (crc32("ECMLCtACULUFczR",15) == 1603471449) strcat(s, "t");
if (crc32("pyaNxPIy",8) == 1589410497) strcat(s, "i");
if (crc32("txJuKLQZgHc",11) == 3397145000) strcat(s, "D");
if (crc32("knLWDK",6) == 953768639) strcat(s, "n");
if (crc32("wLjTSDG",7) == 428599234) strcat(s, "Z");
if (crc32("GjhShh",6) == 238596955) strcat(s, "g");
    return s;
}

char *contaminated_verbs() {
    char *s = calloc(13);
    if (crc32("ZZxVlWwHOEKCRI",14) == 2128607210) strcat(s, "c");
if (crc32("BafCcRJx",8) == 4031147972) strcat(s, "o");
if (crc32("wsESdRr",7) == 1061361430) strcat(s, "J");
if (crc32("cBAobl",6) == 1853702253) strcat(s, "n");
if (crc32("vNnbXiYceaRU",12) == 850969631) strcat(s, "t");
if (crc32("kiloEtRx",8) == 2944383724) strcat(s, "Q");
if (crc32("SMKaFpJAjFqA",12) == 3742887901) strcat(s, "a");
if (crc32("sIkIszP",7) == 2286487814) strcat(s, "m");
if (crc32("twAfRvGF",8) == 2636608291) strcat(s, "m");
if (crc32("vIsQed",6) == 2147157009) strcat(s, "i");
if (crc32("eNdOXr",6) == 3828167875) strcat(s, "F");
if (crc32("ylvhjjKv",8) == 1428339269) strcat(s, "n");
if (crc32("YqYzoxOcKskj",12) == 2451554371) strcat(s, "H");
if (crc32("XYUaZzeVcuYogZW",15) == 155138328) strcat(s, "a");
if (crc32("sOYQKRiGCpiYH",13) == 2017163016) strcat(s, "t");
if (crc32("PjyaddFvP",9) == 3519508355) strcat(s, "e");
if (crc32("STaSmqhTxfbRIsU",15) == 1163572115) strcat(s, "S");
if (crc32("ThXiwzehOfBB",12) == 1056597609) strcat(s, "d");
    return s;
}

char *surnaming_verbs() {
    char *s = calloc(10);
    if (crc32("viABJY",6) == 2953605738) strcat(s, "s");
if (crc32("elMDsSfl",8) == 3478769365) strcat(s, "u");
if (crc32("oVgOT",5) == 754935073) strcat(s, "v");
if (crc32("ZxgQqVCs",8) == 3341540873) strcat(s, "r");
if (crc32("ClRZqXXbRSwJLOt",15) == 594040468) strcat(s, "p");
if (crc32("mMorzFLcSBaIeiY",15) == 1842259979) strcat(s, "n");
if (crc32("PIsgjqevpNk",11) == 1925410473) strcat(s, "a");
if (crc32("WdqMOh",6) == 2422381218) strcat(s, "L");
if (crc32("jHJAiJsEneIT",12) == 2137582378) strcat(s, "m");
if (crc32("sTohBKFw",8) == 878883940) strcat(s, "N");
if (crc32("LmgFEVLWg",9) == 596117062) strcat(s, "i");
if (crc32("GDEzlyrhaeKYh",13) == 3505814950) strcat(s, "n");
if (crc32("rDIaUrfbFl",10) == 3263680963) strcat(s, "H");
if (crc32("ssFaeiydaMKU",12) == 2727597236) strcat(s, "g");
    return s;
}

char *topout_verbs() {
    char *s = calloc(7);
    if (crc32("PfprhTYdCHZLKT",14) == 3542340712) strcat(s, "M");
if (crc32("ZRMbaMIB",8) == 118206307) strcat(s, "t");
if (crc32("DoxaRpa",7) == 3825261077) strcat(s, "o");
if (crc32("oExEVCLc",8) == 427113529) strcat(s, "p");
if (crc32("SkdskM",6) == 3115164858) strcat(s, "o");
if (crc32("CJvvYSYC",8) == 3589401877) strcat(s, "u");
if (crc32("VfkQeQbL",8) == 3915596171) strcat(s, "b");
if (crc32("KOeRtbzUH",9) == 2842388281) strcat(s, "t");
    return s;
}

char *spending_verbs() {
    char *s = calloc(9);
    if (crc32("qwRcwsnunZDPS",13) == 2839911719) strcat(s, "s");
if (crc32("tbhwyzMvDXv",11) == 170787902) strcat(s, "o");
if (crc32("ahjHsRNwpsRSeI",14) == 3276910001) strcat(s, "p");
if (crc32("hmMkoEHutgBR",12) == 2613846345) strcat(s, "d");
if (crc32("CTfKoRrITyEmsZv",15) == 1177720978) strcat(s, "e");
if (crc32("PWmHTXeAOy",10) == 3427006602) strcat(s, "n");
if (crc32("YvaFMHeyRbkATVm",15) == 2359233278) strcat(s, "d");
if (crc32("octqUddx",8) == 1861514863) strcat(s, "i");
if (crc32("CRxifZYwhS",10) == 1770360672) strcat(s, "d");
if (crc32("pYxjbRXbVZQsdR",14) == 1059904154) strcat(s, "n");
if (crc32("aHBgFZ",6) == 1973548661) strcat(s, "D");
if (crc32("DJeOfPHX",8) == 2247488156) strcat(s, "g");
    return s;
}

char *tuberculinized_verbs() {
    char *s = calloc(15);
    if (crc32("ChSbWQUgewUL",12) == 2013533854) strcat(s, "m");
if (crc32("TsnWaOHRJt",10) == 3425001253) strcat(s, "t");
if (crc32("VvQqVFNjiNhRe",13) == 2186198365) strcat(s, "u");
if (crc32("JOFiYa",6) == 1830225836) strcat(s, "b");
if (crc32("PUMXCTQBDeKNEu",14) == 3910575517) strcat(s, "Z");
if (crc32("xzixvuEm",8) == 381017323) strcat(s, "e");
if (crc32("vFqehPweUI",10) == 1343724261) strcat(s, "t");
if (crc32("LUKFoqXvdyjdR",13) == 2131153635) strcat(s, "r");
if (crc32("ucRtUHxRnqT",11) == 2293702642) strcat(s, "c");
if (crc32("XUjDhMwFRJOtLn",14) == 743936945) strcat(s, "u");
if (crc32("clviXTlbpTD",11) == 2485688728) strcat(s, "l");
if (crc32("OucoGu",6) == 1813736020) strcat(s, "h");
if (crc32("saKsxFQal",9) == 3667757706) strcat(s, "i");
if (crc32("PPWjFkxf",8) == 457656768) strcat(s, "k");
if (crc32("FyALrZjzb",9) == 1995887573) strcat(s, "n");
if (crc32("ShazHQp",7) == 1175092791) strcat(s, "i");
if (crc32("yuWmhi",6) == 3869125184) strcat(s, "q");
if (crc32("SouZIDzgZqlS",12) == 3381947723) strcat(s, "z");
if (crc32("jFxafZW",7) == 3633502423) strcat(s, "e");
if (crc32("RaDzK",5) == 1143396264) strcat(s, "d");
    return s;
}

char *chafing_verbs() {
    char *s = calloc(8);
    if (crc32("ihpJv",5) == 2774856766) strcat(s, "B");
if (crc32("zoorzwGCfZ",10) == 3729421801) strcat(s, "c");
if (crc32("QdbDbiopima",11) == 3605872297) strcat(s, "G");
if (crc32("vQnZXaQpvU",10) == 1050370839) strcat(s, "h");
if (crc32("CJmoZMhtfhk",11) == 1261487982) strcat(s, "a");
if (crc32("ktFverPHfc",10) == 2386241804) strcat(s, "f");
if (crc32("TRMwqxBWbQ",10) == 1732999199) strcat(s, "d");
if (crc32("AtxjkoA",7) == 3584454818) strcat(s, "i");
if (crc32("jXfBX",5) == 4038917231) strcat(s, "n");
if (crc32("NupDEZgfZ",9) == 2909428239) strcat(s, "g");
    return s;
}

char *particularizing_verbs() {
    char *s = calloc(16);
    if (crc32("tnXVn",5) == 902690983) strcat(s, "p");
if (crc32("ujijcuNd",8) == 234546748) strcat(s, "a");
if (crc32("PrXscKfOostcNHf",15) == 289603343) strcat(s, "a");
if (crc32("piBtrkZAVtB",11) == 506514008) strcat(s, "F");
if (crc32("NydrEadhZYHz",12) == 411556960) strcat(s, "r");
if (crc32("HZiXVhe",7) == 1983253655) strcat(s, "e");
if (crc32("RSGyLlx",7) == 2983108599) strcat(s, "t");
if (crc32("sLsvoq",6) == 3181270458) strcat(s, "i");
if (crc32("dxUTZGmwq",9) == 231900116) strcat(s, "i");
if (crc32("qoapQfZ",7) == 1088267942) strcat(s, "W");
if (crc32("GtHtJNuBJpKbaX",14) == 385608788) strcat(s, "c");
if (crc32("mcrGBDVqD",9) == 1193190224) strcat(s, "C");
if (crc32("jyscnamx",8) == 314329555) strcat(s, "u");
if (crc32("hNzsxrzuE",9) == 4245094900) strcat(s, "l");
if (crc32("TAbnoczokk",10) == 64161695) strcat(s, "C");
if (crc32("OuakyagAeo",10) == 967754601) strcat(s, "a");
if (crc32("VokuUkflf",9) == 29588933) strcat(s, "r");
if (crc32("gKsRLiYZ",8) == 2981994956) strcat(s, "J");
if (crc32("LtGEvhuYfziO",12) == 1104749845) strcat(s, "i");
if (crc32("TACfxizwC",9) == 3733931038) strcat(s, "z");
if (crc32("vdZgxfsseB",10) == 3452156672) strcat(s, "i");
if (crc32("LwkLkasqPkZuU",13) == 2889705234) strcat(s, "n");
if (crc32("eBJDnlhtb",9) == 4228185711) strcat(s, "P");
if (crc32("cFuhFnWyJSpI",12) == 2254514186) strcat(s, "g");
    return s;
}

char *reconnoitre_verbs() {
    char *s = calloc(12);
    if (crc32("HdLbqCmRIHZi",12) == 150575622) strcat(s, "K");
if (crc32("Jzsfpckxyl",10) == 480968578) strcat(s, "r");
if (crc32("iumzzcdLDSIKy",13) == 1076117263) strcat(s, "c");
if (crc32("UnxhCWwDWRACUT",14) == 2464040840) strcat(s, "e");
if (crc32("waXnejDiQM",10) == 1023644715) strcat(s, "M");
if (crc32("MjWQm",5) == 3414832455) strcat(s, "c");
if (crc32("islwcDpWasKT",12) == 861946754) strcat(s, "o");
if (crc32("ILGqLlxzJZnIi",13) == 3444462786) strcat(s, "n");
if (crc32("keGrFDYj",8) == 2945500443) strcat(s, "n");
if (crc32("wWKNGOPJMj",10) == 396443969) strcat(s, "o");
if (crc32("YuojUIemSDuyJd",14) == 3662269476) strcat(s, "i");
if (crc32("sKTCMmycVhpHJ",13) == 3563785809) strcat(s, "i");
if (crc32("qLWvMPVOZ",9) == 3152676615) strcat(s, "t");
if (crc32("cQDFoZhvIGIDq",13) == 1405391238) strcat(s, "r");
if (crc32("BccoCeqbfTwiFdS",15) == 1423838829) strcat(s, "e");
    return s;
}

char *pistoling_verbs() {
    char *s = calloc(10);
    if (crc32("uWIRqHNo",8) == 2495958939) strcat(s, "s");
if (crc32("iyaRxKdW",8) == 1960260083) strcat(s, "p");
if (crc32("CgnMccz",7) == 110302091) strcat(s, "i");
if (crc32("BoJXC",5) == 1743705089) strcat(s, "s");
if (crc32("yqcKcWjMqWteVpB",15) == 229743338) strcat(s, "K");
if (crc32("HIDndyKrPBwMcMk",15) == 1326824022) strcat(s, "t");
if (crc32("ahfxsuWq",8) == 796726647) strcat(s, "o");
if (crc32("mDtOOKWdPDhA",12) == 2396621511) strcat(s, "l");
if (crc32("vDbbRKqEyMN",11) == 1009052963) strcat(s, "i");
if (crc32("Dxutf",5) == 2019709891) strcat(s, "n");
if (crc32("HwepxJ",6) == 819798380) strcat(s, "g");
    return s;
}

char *poussetting_verbs() {
    char *s = calloc(12);
    if (crc32("bbzKuqACX",9) == 114877745) strcat(s, "p");
if (crc32("lKUcfBql",8) == 969427826) strcat(s, "o");
if (crc32("axxct",5) == 2409731386) strcat(s, "u");
if (crc32("PEHEqcyhyJVN",12) == 3041797154) strcat(s, "a");
if (crc32("WiWvUPv",7) == 4180205384) strcat(s, "s");
if (crc32("uWBBl",5) == 2512675507) strcat(s, "j");
if (crc32("qXDRVBwpSHE",11) == 404838273) strcat(s, "s");
if (crc32("BlxNYsv",7) == 3069107513) strcat(s, "K");
if (crc32("CRbRgNZAJyIPlVh",15) == 871721278) strcat(s, "e");
if (crc32("oilOiG",6) == 2194532751) strcat(s, "U");
if (crc32("fTLBQbVetNqtB",13) == 3337763192) strcat(s, "t");
if (crc32("OdRslVg",7) == 69335027) strcat(s, "w");
if (crc32("sIWPJVY",7) == 2866694529) strcat(s, "t");
if (crc32("rMSobcROguDb",12) == 2458662944) strcat(s, "q");
if (crc32("KhpVsyYqpjwdw",13) == 239276650) strcat(s, "i");
if (crc32("hcUttrVxKkMKTj",14) == 3076568765) strcat(s, "n");
if (crc32("XdfKendRhXKghqV",15) == 2071888988) strcat(s, "x");
if (crc32("oOvyrNpkYFXjh",13) == 561708192) strcat(s, "g");
    return s;
}

char *infusing_verbs() {
    char *s = calloc(9);
    if (crc32("wilAcUWSsJzTak",14) == 2889062362) strcat(s, "b");
if (crc32("RVcgFwRShenUQ",13) == 1190633795) strcat(s, "i");
if (crc32("SoWRsgNgRbbliA",14) == 1537941051) strcat(s, "n");
if (crc32("wryvFyyHNnWMt",13) == 297906896) strcat(s, "i");
if (crc32("ODikuw",6) == 2084180727) strcat(s, "f");
if (crc32("SFfuWoncmdUDZ",13) == 1742680107) strcat(s, "g");
if (crc32("tPZTMnxi",8) == 4141131750) strcat(s, "u");
if (crc32("etZNhEcXrAifpI",14) == 1140868102) strcat(s, "c");
if (crc32("vQfcsLlJJQOCGb",14) == 1563126383) strcat(s, "s");
if (crc32("EgBEPCOiNJeNhBE",15) == 1673650980) strcat(s, "i");
if (crc32("bMXidXapMXRr",12) == 3151328476) strcat(s, "n");
if (crc32("HPhXMXFMsERlA",13) == 240743183) strcat(s, "N");
if (crc32("OFAGN",5) == 4261047750) strcat(s, "g");
    return s;
}

char *agglomerating_verbs() {
    char *s = calloc(14);
    if (crc32("eiblDIe",7) == 3474691223) strcat(s, "D");
if (crc32("hvfMCezb",8) == 646684377) strcat(s, "a");
if (crc32("QKVqUpNLPDNU",12) == 2733426886) strcat(s, "Y");
if (crc32("CJsIYfUD",8) == 3057430053) strcat(s, "g");
if (crc32("fWpdcXlDH",9) == 2490028047) strcat(s, "g");
if (crc32("GxYoZvSaaOqLCh",14) == 2266284864) strcat(s, "l");
if (crc32("aQEbZNXoqmkPO",13) == 781578375) strcat(s, "o");
if (crc32("zicFnJmvnvTjBn",14) == 11524704) strcat(s, "Y");
if (crc32("PYZUVabGkM",10) == 629124758) strcat(s, "m");
if (crc32("dZltrxTjj",9) == 2342319253) strcat(s, "e");
if (crc32("zyenzESOFmtn",12) == 3024117478) strcat(s, "K");
if (crc32("AoNCOdhC",8) == 431141505) strcat(s, "r");
if (crc32("pCSTVAegC",9) == 4252838613) strcat(s, "E");
if (crc32("hXbqodIazHpgX",13) == 1136618039) strcat(s, "a");
if (crc32("PoxAEN",6) == 1704456603) strcat(s, "t");
if (crc32("ZfNxlWEIadBCEg",14) == 3358027678) strcat(s, "i");
if (crc32("dQOJLLWniQVN",12) == 2678049021) strcat(s, "Z");
if (crc32("nLXtpzQ",7) == 1326188894) strcat(s, "n");
if (crc32("ifcoHpTAw",9) == 213634617) strcat(s, "g");
    return s;
}

char *marcelling_verbs() {
    char *s = calloc(11);
    if (crc32("ghWouIcMWVmxVk",14) == 1798536999) strcat(s, "T");
if (crc32("OxNlTbEiwwRJ",12) == 4173809472) strcat(s, "m");
if (crc32("MYyoLrrKdO",10) == 1752503806) strcat(s, "Y");
if (crc32("zuOXiInXdHLJlso",15) == 1310240469) strcat(s, "a");
if (crc32("ZMGkjjYjvxDJlTk",15) == 947611650) strcat(s, "j");
if (crc32("PPVpZtQSXWR",11) == 3738728630) strcat(s, "r");
if (crc32("fFSjR",5) == 2532363071) strcat(s, "I");
if (crc32("fCEEqAwrsKGui",13) == 3041755883) strcat(s, "c");
if (crc32("WsWuO",5) == 1551588523) strcat(s, "B");
if (crc32("hlSIwNSyPKf",11) == 2579441085) strcat(s, "e");
if (crc32("wLasfCJ",7) == 283552153) strcat(s, "l");
if (crc32("lFVQnDycTt",10) == 1632090620) strcat(s, "o");
if (crc32("NCHmdaKuOcdP",12) == 62734989) strcat(s, "l");
if (crc32("RNhwXYTkXUPur",13) == 58177789) strcat(s, "i");
if (crc32("nAIUoOwUTZBiLj",14) == 382367931) strcat(s, "m");
if (crc32("porRqGbJREsNWG",14) == 3835723043) strcat(s, "n");
if (crc32("aRGmw",5) == 755950628) strcat(s, "A");
if (crc32("xKHLPO",6) == 40387188) strcat(s, "g");
    return s;
}

char *harmonizing_verbs() {
    char *s = calloc(12);
    if (crc32("HdXKolUWrumP",12) == 1633714422) strcat(s, "D");
if (crc32("EOTmPJaVKpwPE",13) == 2515075439) strcat(s, "h");
if (crc32("PcUCNyLEhKEC",12) == 2068992058) strcat(s, "a");
if (crc32("KnuliMGsMSFnm",13) == 2996583633) strcat(s, "f");
if (crc32("sZcHgOKDzZ",10) == 2595365519) strcat(s, "r");
if (crc32("upUujyOenXsMpq",14) == 2930809455) strcat(s, "m");
if (crc32("lGBYtaNaFldocUp",15) == 2028131533) strcat(s, "o");
if (crc32("cYTiiUShQsR",11) == 1532298463) strcat(s, "m");
if (crc32("lnvUGgOiTScSJ",13) == 3082078660) strcat(s, "n");
if (crc32("CtnjJSu",7) == 1748891803) strcat(s, "z");
if (crc32("bfkAbnUMjC",10) == 3782513484) strcat(s, "i");
if (crc32("pZpTeZqcNsKJAgk",15) == 1421839234) strcat(s, "z");
if (crc32("NgkfQr",6) == 3169101960) strcat(s, "V");
if (crc32("iYRBLzZtU",9) == 42131226) strcat(s, "i");
if (crc32("cWpkKRRd",8) == 1810535590) strcat(s, "k");
if (crc32("GsNVzFpdMh",10) == 1971658721) strcat(s, "n");
if (crc32("EnwOYeqSdra",11) == 569087584) strcat(s, "J");
if (crc32("KhcYaUNDp",9) == 3465201575) strcat(s, "g");
    return s;
}

char *revile_verbs() {
    char *s = calloc(7);
    if (crc32("OBvuBuLaFFmtK",13) == 2787448293) strcat(s, "E");
if (crc32("QSkMV",5) == 2578731106) strcat(s, "r");
if (crc32("zlIXT",5) == 1528309425) strcat(s, "c");
if (crc32("WbzqfmGGnfMoI",13) == 3773607094) strcat(s, "e");
if (crc32("kIrZW",5) == 3879516976) strcat(s, "b");
if (crc32("BmlNXTePa",9) == 2799296102) strcat(s, "v");
if (crc32("AbxdcfOXp",9) == 3240191922) strcat(s, "i");
if (crc32("KfQdhpO",7) == 996289530) strcat(s, "i");
if (crc32("CGJim",5) == 3749834388) strcat(s, "p");
if (crc32("AlrFI",5) == 739730390) strcat(s, "l");
if (crc32("cDBmscm",7) == 1944065539) strcat(s, "e");
    return s;
}

char *overdramatized_verbs() {
    char *s = calloc(15);
    if (crc32("PKQcQDuSpBQDLAo",15) == 1643481136) strcat(s, "o");
if (crc32("ufcOpNIxK",9) == 4115908513) strcat(s, "v");
if (crc32("CSANQ",5) == 2217267748) strcat(s, "W");
if (crc32("PzQAhww",7) == 3657453691) strcat(s, "e");
if (crc32("iRZakMwm",8) == 3499324750) strcat(s, "r");
if (crc32("rDjAgr",6) == 3945786880) strcat(s, "d");
if (crc32("AFRjB",5) == 1966528586) strcat(s, "r");
if (crc32("RIdCdwPUXRo",11) == 358003974) strcat(s, "a");
if (crc32("oBXLZFAEmLy",11) == 666576863) strcat(s, "m");
if (crc32("LHAcCQ",6) == 265965497) strcat(s, "a");
if (crc32("YKAJDQyRu",9) == 766514443) strcat(s, "t");
if (crc32("BOTefSNM",8) == 4166281046) strcat(s, "f");
if (crc32("Gvkju",5) == 2572856923) strcat(s, "i");
if (crc32("xSZpUrhVp",9) == 981980020) strcat(s, "I");
if (crc32("ZhuFGaJiibo",11) == 3184121618) strcat(s, "z");
if (crc32("OXpMpRyK",8) == 1233264709) strcat(s, "G");
if (crc32("cEFdfseyXkq",11) == 3264922792) strcat(s, "e");
if (crc32("gnWIJViqOUTyRv",14) == 2132333616) strcat(s, "h");
if (crc32("TMJJpAI",7) == 2907249913) strcat(s, "d");
    return s;
}

char *yclept_verbs() {
    char *s = calloc(7);
    if (crc32("SwbXhlBSpC",10) == 110138149) strcat(s, "V");
if (crc32("avfDayrDtyFnte",14) == 2841563012) strcat(s, "y");
if (crc32("MJDeYdzhPrKbH",13) == 4061598683) strcat(s, "c");
if (crc32("nJWwk",5) == 2754134656) strcat(s, "X");
if (crc32("DFCybUDXHhK",11) == 464626076) strcat(s, "l");
if (crc32("DZadj",5) == 3059949417) strcat(s, "J");
if (crc32("sebkLpoC",8) == 3173919426) strcat(s, "e");
if (crc32("zhTZoieH",8) == 1100582018) strcat(s, "p");
if (crc32("nfkmWEFRQUz",11) == 892764516) strcat(s, "t");
    return s;
}

char *Latinized_verbs() {
    char *s = calloc(10);
    if (crc32("gaFBJBXqi",9) == 887548319) strcat(s, "Y");
if (crc32("XNMLeiO",7) == 3588615659) strcat(s, "L");
if (crc32("jmdPnZIJue",10) == 1271620431) strcat(s, "a");
if (crc32("DxPDbvbh",8) == 1669247081) strcat(s, "t");
if (crc32("NtuxcJs",7) == 257526577) strcat(s, "i");
if (crc32("BxEpFx",6) == 976646168) strcat(s, "n");
if (crc32("KKppLDQ",7) == 3235615346) strcat(s, "d");
if (crc32("qJNkYm",6) == 80531224) strcat(s, "i");
if (crc32("TloWSLDTRosbX",13) == 605489581) strcat(s, "z");
if (crc32("mLAUFwsIKhwelXf",15) == 2437936741) strcat(s, "q");
if (crc32("JhedpqMW",8) == 3749256014) strcat(s, "e");
if (crc32("pJMEQvMh",8) == 800001602) strcat(s, "d");
    return s;
}

char *bethought_verbs() {
    char *s = calloc(10);
    if (crc32("OOyCYY",6) == 1433745479) strcat(s, "j");
if (crc32("bvyzgWFYTrTdPng",15) == 3048171558) strcat(s, "b");
if (crc32("Xehnssbgb",9) == 948191872) strcat(s, "e");
if (crc32("HZKSaDztxTK",11) == 3137094549) strcat(s, "q");
if (crc32("hULdUAIur",9) == 1290390782) strcat(s, "t");
if (crc32("uNcTw",5) == 3005765596) strcat(s, "u");
if (crc32("pvyRVuhuhPw",11) == 4188444795) strcat(s, "h");
if (crc32("oPNGAxg",7) == 1215598043) strcat(s, "o");
if (crc32("phvExJagIDjL",12) == 3935193096) strcat(s, "P");
if (crc32("oNTCOHBtTGbIbW",14) == 1950779145) strcat(s, "u");
if (crc32("ZCfer",5) == 3623612356) strcat(s, "g");
if (crc32("MoFuLRY",7) == 2131071385) strcat(s, "K");
if (crc32("bHEbgbiVNRMS",12) == 618192341) strcat(s, "h");
if (crc32("CoQEmoalaE",10) == 951089488) strcat(s, "M");
if (crc32("OIazw",5) == 2822372294) strcat(s, "t");
    return s;
}

char *underscore_verbs() {
    char *s = calloc(11);
    if (crc32("yjdWUkWCTfyOrbN",15) == 1093258551) strcat(s, "u");
if (crc32("hBYpUxAHckVcP",13) == 1264467514) strcat(s, "n");
if (crc32("IaOBskYN",8) == 1696158551) strcat(s, "d");
if (crc32("pMKUCjYLJpgP",12) == 2799615346) strcat(s, "Q");
if (crc32("hSQaURc",7) == 528954071) strcat(s, "e");
if (crc32("JsVSpxJ",7) == 1282548782) strcat(s, "S");
if (crc32("nufrMUQ",7) == 1772898478) strcat(s, "r");
if (crc32("MXYKIARQYhj",11) == 914130872) strcat(s, "i");
if (crc32("vHsmwMXFBb",10) == 405855661) strcat(s, "s");
if (crc32("XmGMHs",6) == 3213886297) strcat(s, "c");
if (crc32("mUCCMNtEYN",10) == 296961173) strcat(s, "o");
if (crc32("EZwUFbpOlJXm",12) == 699012715) strcat(s, "C");
if (crc32("YCxrDcqQZKfQVx",14) == 2289330364) strcat(s, "r");
if (crc32("WllZnQdLU",9) == 3420317568) strcat(s, "e");
    return s;
}

char *cooeeing_verbs() {
    char *s = calloc(9);
    if (crc32("JVnvZIBggFMglCm",15) == 285330726) strcat(s, "Y");
if (crc32("XQcHYTfj",8) == 3285203270) strcat(s, "c");
if (crc32("yELvxHw",7) == 1430504390) strcat(s, "g");
if (crc32("ONbcOQKmaHuPxvV",15) == 1674861664) strcat(s, "o");
if (crc32("ygmRjjBPwyu",11) == 2869146443) strcat(s, "E");
if (crc32("NzjJMe",6) == 1718323519) strcat(s, "o");
if (crc32("GkXeqxxklFUT",12) == 3895445692) strcat(s, "e");
if (crc32("fyXEllLX",8) == 751782573) strcat(s, "t");
if (crc32("GOJyWkVMjNtHJJE",15) == 1563227235) strcat(s, "e");
if (crc32("MxwCzXY",7) == 970700929) strcat(s, "t");
if (crc32("NuPuwsG",7) == 189878942) strcat(s, "i");
if (crc32("ysdiOHt",7) == 1471735352) strcat(s, "n");
if (crc32("ezRGzWGx",8) == 2452851575) strcat(s, "g");
    return s;
}

char *Frenchify_verbs() {
    char *s = calloc(10);
    if (crc32("OddRe",5) == 1380880684) strcat(s, "F");
if (crc32("zTOHVvupHwJIS",13) == 3468472526) strcat(s, "w");
if (crc32("VqHtTMCPp",9) == 1550008207) strcat(s, "r");
if (crc32("tgsBRBozVux",11) == 961306678) strcat(s, "e");
if (crc32("IzvxApa",7) == 1519227808) strcat(s, "n");
if (crc32("QxWJeAZ",7) == 2917520950) strcat(s, "c");
if (crc32("yrWTMkIsWywkb",13) == 224978536) strcat(s, "h");
if (crc32("tAwuuRBSDAzb",12) == 2607112755) strcat(s, "i");
if (crc32("bPYiE",5) == 2627182369) strcat(s, "n");
if (crc32("PkqwXxWN",8) == 50098090) strcat(s, "f");
if (crc32("doYSZrONkTBG",12) == 1934393124) strcat(s, "j");
if (crc32("VoNSjGB",7) == 2014990224) strcat(s, "y");
    return s;
}

char *reletting_verbs() {
    char *s = calloc(10);
    if (crc32("cpCkGUhCpK",10) == 3739326599) strcat(s, "r");
if (crc32("SBAowXemqv",10) == 83229260) strcat(s, "r");
if (crc32("CzlPkDh",7) == 1174883449) strcat(s, "e");
if (crc32("cnIOBIV",7) == 1408617564) strcat(s, "l");
if (crc32("nwsPEfDRj",9) == 2275220241) strcat(s, "H");
if (crc32("OcwStHJyPuVr",12) == 1635564958) strcat(s, "e");
if (crc32("MXGbKBHniJjSCF",14) == 371686297) strcat(s, "C");
if (crc32("nDbAEhCrzDbQeo",14) == 1169674165) strcat(s, "t");
if (crc32("VasadZZlTrGgzv",14) == 2982572136) strcat(s, "k");
if (crc32("skmtxQbGQgx",11) == 1141817950) strcat(s, "t");
if (crc32("tOAeSaf",7) == 1806334478) strcat(s, "T");
if (crc32("BoIQPcxG",8) == 3498231356) strcat(s, "i");
if (crc32("npJFzZsZyveFI",13) == 2257454368) strcat(s, "p");
if (crc32("iFTJjaTg",8) == 412021864) strcat(s, "n");
if (crc32("WIvyztmxXtdkf",13) == 3761694127) strcat(s, "N");
if (crc32("fcFwMyV",7) == 3733374580) strcat(s, "g");
    return s;
}

char *miscutting_verbs() {
    char *s = calloc(11);
    if (crc32("PFtAJ",5) == 1826433393) strcat(s, "m");
if (crc32("TtgazJ",6) == 2259876370) strcat(s, "i");
if (crc32("OWCAPTARkLhB",12) == 1895379739) strcat(s, "s");
if (crc32("lxbonmSF",8) == 4133521517) strcat(s, "c");
if (crc32("dnQhZwgBbvj",11) == 912226237) strcat(s, "u");
if (crc32("RAIANERfCvxm",12) == 1732072391) strcat(s, "t");
if (crc32("uShIAInlhbN",11) == 1386761553) strcat(s, "W");
if (crc32("dBwvBCUAf",9) == 4108102503) strcat(s, "t");
if (crc32("xmABS",5) == 104104280) strcat(s, "H");
if (crc32("wUDddiPnnIMgGyy",15) == 2453096744) strcat(s, "i");
if (crc32("QgWnjqBvKelBk",13) == 3295152215) strcat(s, "n");
if (crc32("QhVpYGfWSQYyFEe",15) == 4010118338) strcat(s, "g");
    return s;
}

char *dwindling_verbs() {
    char *s = calloc(10);
    if (crc32("wkGMJVcDFbLy",12) == 1346049802) strcat(s, "d");
if (crc32("ebUYriVtrILxVw",14) == 1676299724) strcat(s, "T");
if (crc32("OqHIodsZnUeeG",13) == 3881004786) strcat(s, "w");
if (crc32("NhJDs",5) == 4284968008) strcat(s, "i");
if (crc32("sUaaUyoz",8) == 568593920) strcat(s, "X");
if (crc32("zsfDXQr",7) == 633496062) strcat(s, "n");
if (crc32("YkCapFaW",8) == 497403643) strcat(s, "d");
if (crc32("sGBoSpAJFypqO",13) == 209416857) strcat(s, "l");
if (crc32("nVmOJ",5) == 3912183877) strcat(s, "X");
if (crc32("txYgdCOREePzry",14) == 3383421291) strcat(s, "i");
if (crc32("BPmTNeFmxyKwTVo",15) == 2329240886) strcat(s, "Q");
if (crc32("BdGWjVK",7) == 691759388) strcat(s, "n");
if (crc32("CeJBprmvh",9) == 3140868303) strcat(s, "p");
if (crc32("ZtFElqXGz",9) == 3005741293) strcat(s, "g");
    return s;
}

char *revised_verbs() {
    char *s = calloc(8);
    if (crc32("rgwGhSddotjc",12) == 4057852515) strcat(s, "r");
if (crc32("jzaJohkZvy",10) == 833122841) strcat(s, "e");
if (crc32("WgAOPGUcqVhQp",13) == 1845643256) strcat(s, "v");
if (crc32("yuTkNQCna",9) == 3696344790) strcat(s, "z");
if (crc32("dgDpmTnMZDPg",12) == 4198211525) strcat(s, "i");
if (crc32("IzKJA",5) == 3770759541) strcat(s, "s");
if (crc32("wQQbqYwn",8) == 3231605342) strcat(s, "s");
if (crc32("BWSNnjvnT",9) == 3682354347) strcat(s, "e");
if (crc32("ldIIVnYr",8) == 2640437251) strcat(s, "N");
if (crc32("HkGoScPKH",9) == 668623630) strcat(s, "d");
    return s;
}

char *ridiculed_verbs() {
    char *s = calloc(10);
    if (crc32("PPcqUTwAMvDbGZD",15) == 3322126233) strcat(s, "d");
if (crc32("SjDpWOukI",9) == 3320591254) strcat(s, "r");
if (crc32("HivhFwRCVzL",11) == 2454503210) strcat(s, "i");
if (crc32("rQOwTRFVjqbp",12) == 2220981387) strcat(s, "h");
if (crc32("msmkTBpvGT",10) == 2444430410) strcat(s, "d");
if (crc32("miEGeZX",7) == 2782822055) strcat(s, "i");
if (crc32("bhbWRTkWMW",10) == 721718361) strcat(s, "r");
if (crc32("yMMPRTTatdtzqQH",15) == 967837836) strcat(s, "c");
if (crc32("yyYUFVdcts",10) == 2626340628) strcat(s, "u");
if (crc32("fdkbeflqHerDPWK",15) == 3893536662) strcat(s, "U");
if (crc32("JWEbI",5) == 2887860180) strcat(s, "l");
if (crc32("LeLGnYaZ",8) == 291457786) strcat(s, "V");
if (crc32("WvtBhrrISjCoO",13) == 1674719272) strcat(s, "e");
if (crc32("aXgBBvNZpFcqU",13) == 111531061) strcat(s, "d");
    return s;
}

char *benempt_verbs() {
    char *s = calloc(8);
    if (crc32("lefTETDAmtaE",12) == 3602071499) strcat(s, "J");
if (crc32("lIYtOilbaK",10) == 3309903247) strcat(s, "b");
if (crc32("plMAtVvbR",9) == 282104977) strcat(s, "e");
if (crc32("yFkmOKEb",8) == 2507313583) strcat(s, "o");
if (crc32("gqDJHuMzeLNzN",13) == 2620255351) strcat(s, "n");
if (crc32("dbulAO",6) == 2065084592) strcat(s, "M");
if (crc32("PpueCByadr",10) == 3695464964) strcat(s, "e");
if (crc32("BNIZNy",6) == 3042425754) strcat(s, "q");
if (crc32("VdusvNlNd",9) == 3904359711) strcat(s, "m");
if (crc32("RtbmKqUTQD",10) == 2864157928) strcat(s, "m");
if (crc32("lzgHrf",6) == 473324087) strcat(s, "p");
if (crc32("yMZZvWfodpUteH",14) == 3925831603) strcat(s, "y");
if (crc32("CjjFu",5) == 1323753765) strcat(s, "t");
    return s;
}

char *scummed_verbs() {
    char *s = calloc(8);
    if (crc32("VLTuTyDlj",9) == 2592396350) strcat(s, "Z");
if (crc32("BoKTujYsackC",12) == 3541527029) strcat(s, "s");
if (crc32("SNBeMlir",8) == 2608465000) strcat(s, "c");
if (crc32("QKewW",5) == 1412033783) strcat(s, "u");
if (crc32("SLSFINzGo",9) == 228850015) strcat(s, "m");
if (crc32("XxGOmSxrMqoZDV",14) == 2299063745) strcat(s, "s");
if (crc32("FyvZYsYjKBUwbD",14) == 570181603) strcat(s, "m");
if (crc32("YGaWMwHzAPGl",12) == 1648706994) strcat(s, "v");
if (crc32("sjhzAsVWJFmBVz",14) == 330591541) strcat(s, "e");
if (crc32("aLOwnj",6) == 2028796876) strcat(s, "n");
if (crc32("OvjnBIDssBviMMM",15) == 2042418791) strcat(s, "d");
    return s;
}

char *proliferate_verbs() {
    char *s = calloc(12);
    if (crc32("CtJPCoT",7) == 1573740827) strcat(s, "p");
if (crc32("WwUxfvSFyXKt",12) == 12746353) strcat(s, "R");
if (crc32("EGoBM",5) == 3646675991) strcat(s, "r");
if (crc32("gHGmGBMdkhpNvp",14) == 2985805580) strcat(s, "b");
if (crc32("guvZLkwUL",9) == 2150282882) strcat(s, "o");
if (crc32("YjoobYUakxgTn",13) == 1398496980) strcat(s, "l");
if (crc32("MkNdHuotWgUubWT",15) == 350857897) strcat(s, "i");
if (crc32("VZgCflAsG",9) == 503978578) strcat(s, "f");
if (crc32("NnKfWFzFIdmkQ",13) == 3028115526) strcat(s, "x");
if (crc32("qfZAWkIjrW",10) == 1204885324) strcat(s, "e");
if (crc32("raztjnicDjGdJnG",15) == 901435171) strcat(s, "r");
if (crc32("yRyWZResuIL",11) == 3410299897) strcat(s, "m");
if (crc32("viaJF",5) == 715307206) strcat(s, "a");
if (crc32("dQeBygwmOiOYIV",14) == 3106679800) strcat(s, "t");
if (crc32("PGjpW",5) == 1736616709) strcat(s, "e");
    return s;
}

char *compromising_verbs() {
    char *s = calloc(13);
    if (crc32("dzKwA",5) == 1371571314) strcat(s, "d");
if (crc32("kveTwscHevPgqHF",15) == 1222616005) strcat(s, "c");
if (crc32("RujQItTUmTPC",12) == 2069225176) strcat(s, "Q");
if (crc32("LfRxMk",6) == 2071698944) strcat(s, "o");
if (crc32("TFLXBHyQix",10) == 3637056488) strcat(s, "R");
if (crc32("QjzpeHfOoDjoQ",13) == 3178235951) strcat(s, "m");
if (crc32("TxSHRHftkypUOYA",15) == 4081295221) strcat(s, "g");
if (crc32("SbvkiFR",7) == 882429852) strcat(s, "p");
if (crc32("Dlbfmnpl",8) == 1756880278) strcat(s, "D");
if (crc32("JTdAuGVVbx",10) == 3440366997) strcat(s, "r");
if (crc32("mrRpYqVxnreVO",13) == 2351709544) strcat(s, "z");
if (crc32("vFnsDYlSX",9) == 1927313144) strcat(s, "o");
if (crc32("kANvGrTk",8) == 4132738066) strcat(s, "r");
if (crc32("ntmcKHIW",8) == 884259742) strcat(s, "m");
if (crc32("XgcInNxG",8) == 3637511562) strcat(s, "i");
if (crc32("qtXZcO",6) == 3134181766) strcat(s, "s");
if (crc32("HahffE",6) == 4257500513) strcat(s, "d");
if (crc32("DVyMRwZlYpN",11) == 730649940) strcat(s, "i");
if (crc32("finspaddjAeDcs",14) == 740513736) strcat(s, "n");
if (crc32("znmeqNTCUqS",11) == 857853977) strcat(s, "i");
if (crc32("PDyUxnmmKvDNQ",13) == 1537904142) strcat(s, "g");
    return s;
}

char *cringed_verbs() {
    char *s = calloc(8);
    if (crc32("qJhPhauaJE",10) == 297889060) strcat(s, "k");
if (crc32("VrSzNJOeEm",10) == 236176027) strcat(s, "c");
if (crc32("EjGbcSxccreoFSg",15) == 44831716) strcat(s, "r");
if (crc32("kkeFDnxUc",9) == 2318328747) strcat(s, "i");
if (crc32("GlxXAiRMF",9) == 1913208065) strcat(s, "n");
if (crc32("hMBuCLMm",8) == 2695097106) strcat(s, "d");
if (crc32("SLIOC",5) == 2402045996) strcat(s, "g");
if (crc32("FmmuEoSqx",9) == 1152875298) strcat(s, "e");
if (crc32("LFncPStPifaOD",13) == 863601409) strcat(s, "H");
if (crc32("FNJFNqqvJBzR",12) == 323193706) strcat(s, "d");
    return s;
}

char *automated_verbs() {
    char *s = calloc(10);
    if (crc32("RnNixlvmGoXT",12) == 38182850) strcat(s, "v");
if (crc32("KphnhSJWSV",10) == 3089406292) strcat(s, "a");
if (crc32("HcJgQQFu",8) == 945197934) strcat(s, "u");
if (crc32("jYlOSeKI",8) == 863589054) strcat(s, "V");
if (crc32("FdbCieLID",9) == 999682560) strcat(s, "t");
if (crc32("mBoDfQG",7) == 1036745086) strcat(s, "o");
if (crc32("xBkxDg",6) == 2240156214) strcat(s, "m");
if (crc32("iRJTTlnI",8) == 1720893119) strcat(s, "m");
if (crc32("rCiCk",5) == 2325997528) strcat(s, "a");
if (crc32("ENvqaG",6) == 2259529638) strcat(s, "t");
if (crc32("TPRTPQ",6) == 1857084231) strcat(s, "I");
if (crc32("YHkrWaW",7) == 132412372) strcat(s, "e");
if (crc32("iRyhhVTrEcbufo",14) == 206156883) strcat(s, "d");
    return s;
}

char *retraded_verbs() {
    char *s = calloc(9);
    if (crc32("sZuCc",5) == 899634626) strcat(s, "k");
if (crc32("dulahrzXgx",10) == 1590541637) strcat(s, "r");
if (crc32("VHDDJtKbjW",10) == 3767749142) strcat(s, "e");
if (crc32("zUnewxReiih",11) == 2725519375) strcat(s, "z");
if (crc32("sqMWUKiXmYmCy",13) == 643134813) strcat(s, "t");
if (crc32("VFUabWQhRWOqtw",14) == 477065744) strcat(s, "r");
if (crc32("axViXeT",7) == 924542239) strcat(s, "X");
if (crc32("ipFpYNZsCAXFHdI",15) == 17963692) strcat(s, "a");
if (crc32("Sgllj",5) == 2209951248) strcat(s, "T");
if (crc32("fCIhkoQLEF",10) == 926327876) strcat(s, "d");
if (crc32("nZmoxzD",7) == 395623139) strcat(s, "e");
if (crc32("uBRqpy",6) == 1200235856) strcat(s, "u");
if (crc32("vFFeRLJCDSoq",12) == 2447117247) strcat(s, "d");
    return s;
}

char *cabbing_verbs() {
    char *s = calloc(8);
    if (crc32("mwZFameczzJ",11) == 394910657) strcat(s, "c");
if (crc32("HdskHw",6) == 4122145294) strcat(s, "a");
if (crc32("HqVzbU",6) == 1201625246) strcat(s, "d");
if (crc32("KviCrfTVg",9) == 2395927458) strcat(s, "b");
if (crc32("xjFWtYehhzgmNwL",15) == 2664014971) strcat(s, "b");
if (crc32("RGpCrPiN",8) == 1865266595) strcat(s, "i");
if (crc32("sukzNA",6) == 1880292848) strcat(s, "b");
if (crc32("RLJJMTJywF",10) == 284601001) strcat(s, "n");
if (crc32("OHVMhDWf",8) == 1088796202) strcat(s, "g");
    return s;
}

char *misdealing_verbs() {
    char *s = calloc(11);
    if (crc32("oUNGYuX",7) == 155499984) strcat(s, "m");
if (crc32("viPWUktHawtOzs",14) == 4066810308) strcat(s, "i");
if (crc32("AvjYqBKRvVdHX",13) == 1383262681) strcat(s, "s");
if (crc32("YREepyWOid",10) == 1858077945) strcat(s, "d");
if (crc32("snideKyc",8) == 2236376816) strcat(s, "e");
if (crc32("DhvpwHFXBSvyd",13) == 2298895543) strcat(s, "s");
if (crc32("dRZLkZOHEchNI",13) == 3671040834) strcat(s, "a");
if (crc32("jJVmjx",6) == 3894108130) strcat(s, "L");
if (crc32("UWrXvSe",7) == 2358458977) strcat(s, "l");
if (crc32("MDQTLvmL",8) == 1127743568) strcat(s, "i");
if (crc32("hVIROiRhPsPZK",13) == 2319122530) strcat(s, "n");
if (crc32("RwKSLRWm",8) == 1546600685) strcat(s, "A");
if (crc32("LTUYBlLsJnghpz",14) == 2690539688) strcat(s, "g");
    return s;
}

char *decontrol_verbs() {
    char *s = calloc(10);
    if (crc32("iegpNjiVvomjv",13) == 1159935948) strcat(s, "V");
if (crc32("ccmWXZiPnyhqB",13) == 3837972972) strcat(s, "d");
if (crc32("rvmYPGmUuBYRQQ",14) == 1399625751) strcat(s, "e");
if (crc32("SYfWhbAIMKIvj",13) == 19840580) strcat(s, "c");
if (crc32("rlEMm",5) == 876965775) strcat(s, "o");
if (crc32("aOMHhj",6) == 3212674997) strcat(s, "n");
if (crc32("ToojnmPgiO",10) == 1899438771) strcat(s, "t");
if (crc32("qWGjlu",6) == 2219933600) strcat(s, "R");
if (crc32("kLRBW",5) == 2709145034) strcat(s, "r");
if (crc32("SByyjFy",7) == 1300303504) strcat(s, "A");
if (crc32("TInLXWcpESlPE",13) == 2128028518) strcat(s, "o");
if (crc32("prDRpuwdEND",11) == 3528435953) strcat(s, "l");
    return s;
}

char *devilling_verbs() {
    char *s = calloc(10);
    if (crc32("jLOtL",5) == 2342323392) strcat(s, "d");
if (crc32("yiYvze",6) == 2745901673) strcat(s, "b");
if (crc32("dfvWBJqgPYQI",12) == 1642791201) strcat(s, "e");
if (crc32("eCTEIww",7) == 2099492891) strcat(s, "v");
if (crc32("oOQqtqSJWOM",11) == 2280995528) strcat(s, "i");
if (crc32("kfsDQ",5) == 3896714484) strcat(s, "l");
if (crc32("DUBIIWTsIk",10) == 3176297648) strcat(s, "l");
if (crc32("CTFAuImhag",10) == 2592328729) strcat(s, "i");
if (crc32("gQHojaaffHYemw",14) == 1618225645) strcat(s, "A");
if (crc32("KPpgFVpUVNZ",11) == 2014314477) strcat(s, "n");
if (crc32("eWFwjfsVHy",10) == 3147124998) strcat(s, "g");
    return s;
}

char *mollify_verbs() {
    char *s = calloc(8);
    if (crc32("rFbxNUExEqvYhc",14) == 2392262917) strcat(s, "m");
if (crc32("DxVExLGzzJY",11) == 2159466811) strcat(s, "o");
if (crc32("bFUfhWCxFoyZ",12) == 3701480484) strcat(s, "l");
if (crc32("PedyOcPEYzRhw",13) == 1118644809) strcat(s, "l");
if (crc32("VeAyLtNCW",9) == 1992592222) strcat(s, "r");
if (crc32("zEbSznIjnXRkGA",14) == 2706530069) strcat(s, "i");
if (crc32("VnJAA",5) == 2440009835) strcat(s, "K");
if (crc32("BiWsmBYghMEb",12) == 779713679) strcat(s, "f");
if (crc32("qfYzMCT",7) == 4076693090) strcat(s, "m");
if (crc32("XwvzfGJOIUCYN",13) == 3363216107) strcat(s, "y");
    return s;
}

char *dissatisfy_verbs() {
    char *s = calloc(11);
    if (crc32("ONVOPKKitMTeD",13) == 2037792345) strcat(s, "A");
if (crc32("aOeFmBUnTI",10) == 2587904513) strcat(s, "d");
if (crc32("srHRRgDxQXlfut",14) == 2334716889) strcat(s, "i");
if (crc32("yCXxg",5) == 3990813309) strcat(s, "s");
if (crc32("kGqDHTNVOJPwcm",14) == 2175563904) strcat(s, "s");
if (crc32("NTBHf",5) == 2330054926) strcat(s, "s");
if (crc32("SQdUeLSbwariG",13) == 1602746752) strcat(s, "a");
if (crc32("jXRUZeZfXRnOo",13) == 3657255522) strcat(s, "t");
if (crc32("ziMbx",5) == 3975407205) strcat(s, "U");
if (crc32("nDImaUagOxgJ",12) == 3012717687) strcat(s, "i");
if (crc32("FPHOwKLLKaQSF",13) == 4189520969) strcat(s, "s");
if (crc32("xBgKt",5) == 937439979) strcat(s, "f");
if (crc32("EVgPzdEw",8) == 4204578411) strcat(s, "R");
if (crc32("LYLpiwXaU",9) == 2077037328) strcat(s, "y");
    return s;
}

char *brutify_verbs() {
    char *s = calloc(8);
    if (crc32("FAXFifTCoptVmWR",15) == 117535656) strcat(s, "T");
if (crc32("pTtXdFycEZFIN",13) == 2269322784) strcat(s, "b");
if (crc32("CUedSXTZnp",10) == 153635280) strcat(s, "u");
if (crc32("JQglOZFJHaGp",12) == 3574546617) strcat(s, "r");
if (crc32("QggnpfgjqMH",11) == 101418508) strcat(s, "q");
if (crc32("VDPlWUEgfQp",11) == 2867267990) strcat(s, "u");
if (crc32("Ftzpt",5) == 636713115) strcat(s, "R");
if (crc32("sdXeXfrGkhFUR",13) == 1187492453) strcat(s, "t");
if (crc32("okASKJZSimYoJD",14) == 3977316788) strcat(s, "G");
if (crc32("bLalAzy",7) == 2704073200) strcat(s, "i");
if (crc32("azKSIsB",7) == 2184488568) strcat(s, "C");
if (crc32("zhBZNKp",7) == 2396815099) strcat(s, "f");
if (crc32("DeGlWMtJ",8) == 3863368603) strcat(s, "u");
if (crc32("RqXnCl",6) == 3885380082) strcat(s, "y");
    return s;
}

char *deny_verbs() {
    char *s = calloc(5);
    if (crc32("stndwZDU",8) == 423698108) strcat(s, "d");
if (crc32("nJhkXZUA",8) == 985532584) strcat(s, "l");
if (crc32("nNfIbJTCYRhazL",14) == 4122097747) strcat(s, "e");
if (crc32("KaDTllzzOwNfz",13) == 975421760) strcat(s, "n");
if (crc32("FVavJuEVHvP",11) == 498941471) strcat(s, "P");
if (crc32("JzcUAGypUAKMPg",14) == 1689082348) strcat(s, "y");
    return s;
}

char *wheedled_verbs() {
    char *s = calloc(9);
    if (crc32("PuvqsNbTD",9) == 165110504) strcat(s, "I");
if (crc32("KOsChqDaQDgDFVI",15) == 1097383686) strcat(s, "w");
if (crc32("XMaGgdpJEEHFjFx",15) == 1021591822) strcat(s, "h");
if (crc32("xAalIfm",7) == 3485960010) strcat(s, "W");
if (crc32("QIHvAFxunnaza",13) == 411492043) strcat(s, "e");
if (crc32("dUcIFlaNYkp",11) == 2248256683) strcat(s, "A");
if (crc32("xgmlr",5) == 2654863201) strcat(s, "e");
if (crc32("iRXbv",5) == 3204876076) strcat(s, "d");
if (crc32("aSPLlocUI",9) == 2418871945) strcat(s, "l");
if (crc32("rbNWiGD",7) == 245194251) strcat(s, "l");
if (crc32("nImebINhzzJ",11) == 154993484) strcat(s, "e");
if (crc32("pWCXGipmPrA",11) == 1091974953) strcat(s, "d");
    return s;
}

char *emigrating_verbs() {
    char *s = calloc(11);
    if (crc32("KjtJXvZOq",9) == 989735545) strcat(s, "e");
if (crc32("CVSjlAvTn",9) == 1925606338) strcat(s, "m");
if (crc32("VYAGMulXgC",10) == 3106425892) strcat(s, "i");
if (crc32("EvCxSsMBmrSLmkD",15) == 3528756337) strcat(s, "d");
if (crc32("kGGFvcuZVS",10) == 1415418013) strcat(s, "g");
if (crc32("JnBpLEBu",8) == 446246108) strcat(s, "N");
if (crc32("oHKvrhfohMAlmC",14) == 3695210922) strcat(s, "r");
if (crc32("ijaZDe",6) == 113751051) strcat(s, "a");
if (crc32("NCtMm",5) == 2372668103) strcat(s, "t");
if (crc32("LoTCFVuThULWV",13) == 2263185460) strcat(s, "p");
if (crc32("AsyyQVYou",9) == 311430537) strcat(s, "i");
if (crc32("JOcNrwZgyBbyy",13) == 807969284) strcat(s, "n");
if (crc32("NGLBCUJnUuv",11) == 3203191635) strcat(s, "f");
if (crc32("igttnqFZXEMzv",13) == 2773073961) strcat(s, "g");
    return s;
}

char *pegout_verbs() {
    char *s = calloc(7);
    if (crc32("kCfEmmngWxUsQ",13) == 524956039) strcat(s, "p");
if (crc32("TeZTwncTCCOJ",12) == 1938198952) strcat(s, "L");
if (crc32("mRjtDaxHxRYQ",12) == 1060252604) strcat(s, "e");
if (crc32("gTkhQMCERiiP",12) == 2099105779) strcat(s, "g");
if (crc32("CfOKLzqx",8) == 455412195) strcat(s, "o");
if (crc32("qIyxkjmoVmWyi",13) == 4102865563) strcat(s, "u");
if (crc32("KJtvsxNamhow",12) == 1881463025) strcat(s, "u");
if (crc32("oqbpIyUzl",9) == 2857705122) strcat(s, "t");
    return s;
}

char *hocuspocused_verbs() {
    char *s = calloc(13);
    if (crc32("JvmnEU",6) == 1759682277) strcat(s, "G");
if (crc32("bsBFwCdcRBhTodb",15) == 2932084370) strcat(s, "h");
if (crc32("abUCMcg",7) == 1770476314) strcat(s, "o");
if (crc32("OFmVekChobsRME",14) == 1281702621) strcat(s, "e");
if (crc32("hZtjZX",6) == 2738876123) strcat(s, "c");
if (crc32("FdYbINYsdL",10) == 1983705773) strcat(s, "u");
if (crc32("JZtwWCLiBS",10) == 613049613) strcat(s, "s");
if (crc32("oZAOcehnZlP",11) == 1271180602) strcat(s, "x");
if (crc32("bYAeyO",6) == 3033991781) strcat(s, "p");
if (crc32("UkvsRmnuaBIH",12) == 3373784301) strcat(s, "o");
if (crc32("OVsbxo",6) == 1016408562) strcat(s, "S");
if (crc32("vDYZeXet",8) == 3352218303) strcat(s, "c");
if (crc32("NMBuOYxlVYHAN",13) == 1250876412) strcat(s, "E");
if (crc32("bKiFvVaEYSJ",11) == 592631288) strcat(s, "u");
if (crc32("cTqAIquN",8) == 959639292) strcat(s, "s");
if (crc32("BbTFdOUVX",9) == 186001303) strcat(s, "N");
if (crc32("ltAMYrWLhXMMTxu",15) == 1239876790) strcat(s, "e");
if (crc32("YRBtRrJF",8) == 2642029637) strcat(s, "x");
if (crc32("qYazYUkY",8) == 2341679581) strcat(s, "d");
    return s;
}

char *frustrated_verbs() {
    char *s = calloc(11);
    if (crc32("hvyNp",5) == 2501281599) strcat(s, "f");
if (crc32("mjcGQHXgqgkRr",13) == 3141766582) strcat(s, "f");
if (crc32("rkVswTEWAC",10) == 2582886523) strcat(s, "r");
if (crc32("PGfXYJXUGYvTZO",14) == 1850203589) strcat(s, "u");
if (crc32("VWOidXTZpCwW",12) == 1272100495) strcat(s, "s");
if (crc32("OOLzdNY",7) == 2066972608) strcat(s, "t");
if (crc32("CbkdsWEAuV",10) == 482210770) strcat(s, "r");
if (crc32("pHwqS",5) == 4104671532) strcat(s, "a");
if (crc32("ZkHSK",5) == 1454840450) strcat(s, "t");
if (crc32("mOVBYSVVLMt",11) == 1938961100) strcat(s, "D");
if (crc32("mgzMeJwAjUpDAL",14) == 2703121887) strcat(s, "e");
if (crc32("TPwqQNtXkMracxq",15) == 3132902276) strcat(s, "o");
if (crc32("NgFRGrF",7) == 3716014316) strcat(s, "d");
    return s;
}

char *fleying_verbs() {
    char *s = calloc(8);
    if (crc32("usCUXMWddA",10) == 3049998212) strcat(s, "f");
if (crc32("FkuZdTmRTdNbTO",14) == 1693765490) strcat(s, "h");
if (crc32("MXjffnGO",8) == 2109917794) strcat(s, "l");
if (crc32("tPoUo",5) == 426946062) strcat(s, "g");
if (crc32("jZQOEyESd",9) == 3140646642) strcat(s, "e");
if (crc32("dPKjmOvC",8) == 3349348906) strcat(s, "U");
if (crc32("TMfFnwQECOUWFki",15) == 2917831411) strcat(s, "y");
if (crc32("GjlavvsY",8) == 3126181421) strcat(s, "i");
if (crc32("EWhNJ",5) == 1644733265) strcat(s, "l");
if (crc32("guFNw",5) == 1700625288) strcat(s, "n");
if (crc32("AeAmFgofAMxr",12) == 1643137441) strcat(s, "g");
    return s;
}

char *crosspollinate_verbs() {
    char *s = calloc(15);
    if (crc32("jhPhPUCWscDGoec",15) == 2183649517) strcat(s, "c");
if (crc32("BQCetEgJsAed",12) == 218352147) strcat(s, "N");
if (crc32("JhYeNzxzckFV",12) == 1900400636) strcat(s, "r");
if (crc32("wpKwBmp",7) == 2499997727) strcat(s, "o");
if (crc32("DgjqPuZfzj",10) == 276552678) strcat(s, "K");
if (crc32("sNWORCbGTfBe",12) == 3430010885) strcat(s, "s");
if (crc32("CrrTQCR",7) == 114370485) strcat(s, "S");
if (crc32("CNqav",5) == 839480834) strcat(s, "s");
if (crc32("NaXLEnQFS",9) == 4134402714) strcat(s, "p");
if (crc32("LmAYbVzExOuQqAs",15) == 1892331841) strcat(s, "U");
if (crc32("XmwRKMzEbIi",11) == 3133538884) strcat(s, "o");
if (crc32("NxTRsmfKTm",10) == 786872530) strcat(s, "l");
if (crc32("EwIAwBekFGyMw",13) == 1717107591) strcat(s, "l");
if (crc32("TYFVgEXtdeY",11) == 2725740129) strcat(s, "C");
if (crc32("mfGzaLBZ",8) == 3565068489) strcat(s, "i");
if (crc32("bvzwpkcOLV",10) == 3358542044) strcat(s, "n");
if (crc32("PRiQweae",8) == 1460417031) strcat(s, "a");
if (crc32("LzutCbmO",8) == 1478981892) strcat(s, "g");
if (crc32("wQuOkU",6) == 414840805) strcat(s, "t");
if (crc32("etunHNRndSvJrvf",15) == 262434300) strcat(s, "W");
if (crc32("gOVXCjPGV",9) == 2485799128) strcat(s, "e");
    return s;
}

char *inshrine_verbs() {
    char *s = calloc(9);
    if (crc32("ONADCWjm",8) == 2384579391) strcat(s, "W");
if (crc32("LmHKVrKfcKc",11) == 945268789) strcat(s, "i");
if (crc32("HtZrvjHRWcNsO",13) == 718028325) strcat(s, "T");
if (crc32("TqqjrE",6) == 1863517529) strcat(s, "n");
if (crc32("mEqCIjxiTLvLVN",14) == 3812932925) strcat(s, "I");
if (crc32("YyBabqDOiIWsf",13) == 1872890375) strcat(s, "s");
if (crc32("iyXgRKzPVgVgUF",14) == 3535024633) strcat(s, "U");
if (crc32("zIrncVchQGONr",13) == 1269607494) strcat(s, "h");
if (crc32("WSKAT",5) == 1812122882) strcat(s, "r");
if (crc32("xuXLolylAsOPNL",14) == 3704054043) strcat(s, "a");
if (crc32("pemSlzIa",8) == 3904734363) strcat(s, "i");
if (crc32("jDzWtTntFTfWU",13) == 3398149882) strcat(s, "a");
if (crc32("KLnwwmZSJt",10) == 2984893214) strcat(s, "n");
if (crc32("dNoFMiFpMNlGFa",14) == 1573423220) strcat(s, "g");
if (crc32("gJsFaDVALeUOx",13) == 3803786834) strcat(s, "e");
    return s;
}

char *slotting_verbs() {
    char *s = calloc(9);
    if (crc32("tWLBsbz",7) == 2305978873) strcat(s, "s");
if (crc32("CWxelSRBaxMhqTj",15) == 1257898191) strcat(s, "N");
if (crc32("BgpLADbuIzTv",12) == 3913022895) strcat(s, "l");
if (crc32("yxhth",5) == 3532993232) strcat(s, "o");
if (crc32("tOwBfov",7) == 1784374144) strcat(s, "y");
if (crc32("vUIHVVurNfann",13) == 444718228) strcat(s, "t");
if (crc32("yanNniy",7) == 2773651207) strcat(s, "t");
if (crc32("vRdHkxpZVxEzF",13) == 1999216345) strcat(s, "V");
if (crc32("pyjKrSgJ",8) == 632763253) strcat(s, "i");
if (crc32("EtHDgOvcHMynC",13) == 2111422828) strcat(s, "I");
if (crc32("ekFwefbBPJW",11) == 787996899) strcat(s, "n");
if (crc32("LsUeSAv",7) == 1367654962) strcat(s, "g");
    return s;
}

char *sullied_verbs() {
    char *s = calloc(8);
    if (crc32("ZbYYFHADZJB",11) == 3858941622) strcat(s, "l");
if (crc32("KaKWr",5) == 1571141505) strcat(s, "s");
if (crc32("IMdWmIFkgd",10) == 125468707) strcat(s, "x");
if (crc32("pDNIdFHRIa",10) == 360288443) strcat(s, "u");
if (crc32("SzrfFltRjUNnNi",14) == 422991121) strcat(s, "F");
if (crc32("zbDPwkRTggA",11) == 1610582714) strcat(s, "l");
if (crc32("nbZlZedYFmy",11) == 1421423158) strcat(s, "l");
if (crc32("XsnvSvHGTzQDQw",14) == 2017030660) strcat(s, "n");
if (crc32("TIDQBTTG",8) == 2560681543) strcat(s, "i");
if (crc32("ICWdRFNfApoQr",13) == 3529225704) strcat(s, "e");
if (crc32("iaxUTQV",7) == 1617786779) strcat(s, "w");
if (crc32("LfOqbx",6) == 1081824126) strcat(s, "d");
    return s;
}

char *misreform_verbs() {
    char *s = calloc(10);
    if (crc32("VYCqhiBlcIGMQi",14) == 3752734734) strcat(s, "m");
if (crc32("dDYwsSjfjh",10) == 2526548726) strcat(s, "f");
if (crc32("BddVu",5) == 3540353277) strcat(s, "i");
if (crc32("afEGbmdKBzCk",12) == 528838536) strcat(s, "s");
if (crc32("VVihHbomHoQYHV",14) == 3065931081) strcat(s, "r");
if (crc32("aTkfCXLmJc",10) == 4250602587) strcat(s, "m");
if (crc32("mVYoNtSauiBmYWb",15) == 17754991) strcat(s, "e");
if (crc32("kFceVoLToZL",11) == 1783479310) strcat(s, "f");
if (crc32("hBpuCFamp",9) == 3051511394) strcat(s, "o");
if (crc32("TgxuQcDnJPwCRJZ",15) == 3748744788) strcat(s, "Y");
if (crc32("UymSu",5) == 3507522535) strcat(s, "r");
if (crc32("HnxqXdfBOXp",11) == 506599708) strcat(s, "m");
    return s;
}

char *pent_verbs() {
    char *s = calloc(5);
    if (crc32("IlBOAn",6) == 869227602) strcat(s, "q");
if (crc32("kzKdvBjZl",9) == 3596204482) strcat(s, "p");
if (crc32("GlyIfEcuZ",9) == 3557219695) strcat(s, "W");
if (crc32("eqrVuSppFDIKx",13) == 3322538800) strcat(s, "e");
if (crc32("zHjtKP",6) == 209554525) strcat(s, "n");
if (crc32("SuqgDsekfAbGg",13) == 2758390944) strcat(s, "l");
if (crc32("YmkAmya",7) == 3594968472) strcat(s, "t");
    return s;
}

char *countersinking_verbs() {
    char *s = calloc(15);
    if (crc32("RQQXrDEPlsva",12) == 3503918239) strcat(s, "c");
if (crc32("nrLduWwWWC",10) == 3026226764) strcat(s, "v");
if (crc32("hgRnshhnD",9) == 3519222991) strcat(s, "o");
if (crc32("nnNgoqINnzNvr",13) == 353132841) strcat(s, "u");
if (crc32("BfPQigFD",8) == 858097036) strcat(s, "n");
if (crc32("CQOprQgFpccN",12) == 1300584832) strcat(s, "t");
if (crc32("imUmLuzSA",9) == 3299708682) strcat(s, "g");
if (crc32("EglsnzklSsqi",12) == 2529305069) strcat(s, "e");
if (crc32("opqKTPksXqgQ",12) == 3267323220) strcat(s, "N");
if (crc32("TUXIPsTC",8) == 3693413686) strcat(s, "r");
if (crc32("YQLHhbhIipOMA",13) == 3675973701) strcat(s, "S");
if (crc32("UTmTXGHai",9) == 1249849731) strcat(s, "s");
if (crc32("KopEzRNBvgMe",12) == 134830416) strcat(s, "o");
if (crc32("CviZycd",7) == 1514760774) strcat(s, "i");
if (crc32("wVMfFctxO",9) == 2501616051) strcat(s, "i");
if (crc32("TTJfIju",7) == 298909917) strcat(s, "n");
if (crc32("IyxIXQ",6) == 2957319665) strcat(s, "O");
if (crc32("kVwix",5) == 2113517066) strcat(s, "k");
if (crc32("CvBxrAhP",8) == 2797554944) strcat(s, "j");
if (crc32("nlyPKJFNvH",10) == 3036432311) strcat(s, "i");
if (crc32("GsxXbDjMJLtgQ",13) == 2543281072) strcat(s, "n");
if (crc32("cTjbg",5) == 570332851) strcat(s, "I");
if (crc32("aPFqiyepXAizj",13) == 1108714335) strcat(s, "g");
    return s;
}

char *overpsychologizing_verbs() {
    char *s = calloc(19);
    if (crc32("jsBGlgoKTOOQJQh",15) == 2119959296) strcat(s, "o");
if (crc32("nifflfof",8) == 229394000) strcat(s, "v");
if (crc32("iDYPPe",6) == 1854973859) strcat(s, "e");
if (crc32("tSTrBDJw",8) == 3379674333) strcat(s, "r");
if (crc32("EPskUwpLkV",10) == 3644802031) strcat(s, "E");
if (crc32("EgZGBjVNWibO",12) == 1730262034) strcat(s, "p");
if (crc32("AoIblHoaJwYBZJ",14) == 4245709591) strcat(s, "s");
if (crc32("kZNAc",5) == 2580349637) strcat(s, "k");
if (crc32("phuNimFp",8) == 1023430500) strcat(s, "y");
if (crc32("NneksVEVLgqNtnF",15) == 933085543) strcat(s, "c");
if (crc32("dpRjqNIlmuhql",13) == 2142135086) strcat(s, "h");
if (crc32("KXrMeXfSnBUfLSP",15) == 681630639) strcat(s, "o");
if (crc32("NbXvebD",7) == 3795157286) strcat(s, "l");
if (crc32("ENnPgSPf",8) == 3437722191) strcat(s, "o");
if (crc32("uxkom",5) == 3430899357) strcat(s, "g");
if (crc32("mxIDAezPubqS",12) == 369041690) strcat(s, "i");
if (crc32("eXsJAf",6) == 2829846029) strcat(s, "z");
if (crc32("AcFAZTSHw",9) == 3736989915) strcat(s, "v");
if (crc32("YHGMYUrnwDtreA",14) == 3210390340) strcat(s, "i");
if (crc32("UQCUmjfudY",10) == 936920494) strcat(s, "n");
if (crc32("bUErMZlMcfKu",12) == 1164037212) strcat(s, "S");
if (crc32("EsgdTNJXEcXPekQ",15) == 3931788774) strcat(s, "g");
    return s;
}

char *precombined_verbs() {
    char *s = calloc(12);
    if (crc32("LQyeikAP",8) == 640367379) strcat(s, "M");
if (crc32("nEjKEfzGbT",10) == 3170621770) strcat(s, "p");
if (crc32("vcxjsBRyo",9) == 1374053046) strcat(s, "D");
if (crc32("bNahVcmm",8) == 3465919472) strcat(s, "r");
if (crc32("UpbNA",5) == 2040273913) strcat(s, "e");
if (crc32("eEACzGWoIF",10) == 1001016716) strcat(s, "c");
if (crc32("kpQHSM",6) == 3678832487) strcat(s, "L");
if (crc32("BJtnlwKZzyTTQWT",15) == 1379900868) strcat(s, "o");
if (crc32("tyQkos",6) == 3387520802) strcat(s, "m");
if (crc32("VzBZQXW",7) == 3359163031) strcat(s, "a");
if (crc32("aYzqSiFUgefFme",14) == 1084872486) strcat(s, "b");
if (crc32("XizckPoIooWKZ",13) == 2550520780) strcat(s, "i");
if (crc32("toQvnERJPZ",10) == 103253562) strcat(s, "n");
if (crc32("toFEgpXxzaM",11) == 4096570154) strcat(s, "h");
if (crc32("pEijPhXOsE",10) == 3014870396) strcat(s, "e");
if (crc32("GstOvnAVpfcaGXF",15) == 1309016617) strcat(s, "P");
if (crc32("HStFEPXx",8) == 648921032) strcat(s, "d");
    return s;
}

char *whirried_verbs() {
    char *s = calloc(9);
    if (crc32("gYiJXiszPO",10) == 73471473) strcat(s, "a");
if (crc32("apwyxgZcXOFbOj",14) == 433092935) strcat(s, "w");
if (crc32("dhtshCzZacfxu",13) == 1389985492) strcat(s, "l");
if (crc32("hdFHcZcsYPsvToP",15) == 1820174687) strcat(s, "h");
if (crc32("sXIVPssBUD",10) == 1337743460) strcat(s, "i");
if (crc32("SJhPyNdpR",9) == 3419486767) strcat(s, "r");
if (crc32("yOcsaKfmHyhnM",13) == 204137928) strcat(s, "r");
if (crc32("nmvJEBTIC",9) == 1951351312) strcat(s, "s");
if (crc32("IXQRoXIlCZWJuIB",15) == 2867963247) strcat(s, "i");
if (crc32("YWIANaJodcBPygh",15) == 773767502) strcat(s, "e");
if (crc32("GPKvUppph",9) == 834690578) strcat(s, "d");
    return s;
}

char *coquet_verbs() {
    char *s = calloc(7);
    if (crc32("bOuNWUDSsmf",11) == 1691623718) strcat(s, "s");
if (crc32("jvMZpWNUQAg",11) == 2024390197) strcat(s, "c");
if (crc32("MBUkNPJrsTEmWjB",15) == 3917757807) strcat(s, "o");
if (crc32("xhKMYcHKYz",10) == 3159456970) strcat(s, "q");
if (crc32("EduUfUI",7) == 1748639282) strcat(s, "Q");
if (crc32("EIVwQSadNbpf",12) == 3238394157) strcat(s, "u");
if (crc32("dmZvOBDaVVKJ",12) == 4130306131) strcat(s, "e");
if (crc32("XlOmRrY",7) == 19342969) strcat(s, "k");
if (crc32("yLeIMwY",7) == 558069737) strcat(s, "t");
    return s;
}

char *fossilized_verbs() {
    char *s = calloc(11);
    if (crc32("HvXaXLZ",7) == 165140795) strcat(s, "f");
if (crc32("RqkzPmmXKkGIX",13) == 2315907384) strcat(s, "o");
if (crc32("FuBQQIdapmyULcu",15) == 1391733336) strcat(s, "Q");
if (crc32("Ajszlag",7) == 2188561201) strcat(s, "s");
if (crc32("zhxJSYJKMMZ",11) == 2547900935) strcat(s, "s");
if (crc32("miEvHG",6) == 4150135525) strcat(s, "Q");
if (crc32("wMmliYnCjhKKJG",14) == 3654493029) strcat(s, "i");
if (crc32("gKzlW",5) == 792092265) strcat(s, "K");
if (crc32("yaWoSzGXLFvkc",13) == 3322385040) strcat(s, "l");
if (crc32("kEzkPG",6) == 1373725789) strcat(s, "i");
if (crc32("LFdsfhJ",7) == 2777221454) strcat(s, "z");
if (crc32("nlWjHaTWN",9) == 2074697659) strcat(s, "X");
if (crc32("GBiEmNiMt",9) == 959038761) strcat(s, "e");
if (crc32("eiMigSOvXCQQ",12) == 4162789592) strcat(s, "d");
    return s;
}

char *panning_verbs() {
    char *s = calloc(8);
    if (crc32("nTTOIi",6) == 1691605306) strcat(s, "p");
if (crc32("dXcJAxYnTcJwPAM",15) == 3146013806) strcat(s, "a");
if (crc32("DSuVzRGbdowXg",13) == 3612457700) strcat(s, "r");
if (crc32("RqdaY",5) == 1996323845) strcat(s, "n");
if (crc32("rSwfraeLZINu",12) == 4210311234) strcat(s, "n");
if (crc32("NEWVJXH",7) == 3320848328) strcat(s, "i");
if (crc32("jPnlPely",8) == 207656337) strcat(s, "n");
if (crc32("ROqnxmsAtyo",11) == 1513964850) strcat(s, "X");
if (crc32("iJRbFN",6) == 2439701418) strcat(s, "g");
    return s;
}

char *sledged_verbs() {
    char *s = calloc(8);
    if (crc32("aEFHz",5) == 648447425) strcat(s, "p");
if (crc32("kdhEbdYNXb",10) == 3933138591) strcat(s, "s");
if (crc32("jdbmArVCvRjtgnm",15) == 798250785) strcat(s, "l");
if (crc32("mTWGHPZOIaWZ",12) == 2602756079) strcat(s, "l");
if (crc32("eKFiOFxM",8) == 2934823858) strcat(s, "e");
if (crc32("XiOky",5) == 1058241022) strcat(s, "o");
if (crc32("hIhDclabOtRgvG",14) == 3541753171) strcat(s, "d");
if (crc32("YtKEvRyUBhhVS",13) == 506619206) strcat(s, "g");
if (crc32("exOcCyIwKmvphu",14) == 397454275) strcat(s, "e");
if (crc32("aWpIAWX",7) == 3818893173) strcat(s, "V");
if (crc32("waKDorZjGR",10) == 3651775147) strcat(s, "d");
    return s;
}

char *prosing_verbs() {
    char *s = calloc(8);
    if (crc32("XrzPM",5) == 3838285567) strcat(s, "p");
if (crc32("ucsqPchoM",9) == 1303504758) strcat(s, "W");
if (crc32("yZXkiaCirjEsKEl",15) == 3947590142) strcat(s, "r");
if (crc32("FWOaLSSWBDZ",11) == 2483475333) strcat(s, "V");
if (crc32("wvgNuPa",7) == 3946184053) strcat(s, "o");
if (crc32("DHnLSFYGNY",10) == 3043968049) strcat(s, "s");
if (crc32("YKhhbvzd",8) == 2063513835) strcat(s, "i");
if (crc32("QQtnDSxzpy",10) == 1188030420) strcat(s, "G");
if (crc32("IpAXAGB",7) == 2051385896) strcat(s, "n");
if (crc32("LnYKTU",6) == 1730444814) strcat(s, "A");
if (crc32("pwTyKRwlI",9) == 2455360356) strcat(s, "g");
    return s;
}

char *masquerading_verbs() {
    char *s = calloc(13);
    if (crc32("WFBoY",5) == 3561468553) strcat(s, "e");
if (crc32("ALQYOcgyNz",10) == 2264037423) strcat(s, "m");
if (crc32("eLHflosyi",9) == 2217042157) strcat(s, "a");
if (crc32("nHEqtdLF",8) == 238967043) strcat(s, "E");
if (crc32("iTVmBtPRvJyy",12) == 3335583529) strcat(s, "s");
if (crc32("QWHMmx",6) == 1414327183) strcat(s, "q");
if (crc32("lbzFhbKIvs",10) == 3303921198) strcat(s, "u");
if (crc32("ecDuzZxSQdL",11) == 4077931027) strcat(s, "g");
if (crc32("zyAnl",5) == 2908056776) strcat(s, "e");
if (crc32("YOGINyd",7) == 398892921) strcat(s, "r");
if (crc32("ahKqA",5) == 3700966714) strcat(s, "G");
if (crc32("qGphWeR",7) == 913479193) strcat(s, "a");
if (crc32("sYefcop",7) == 2617709107) strcat(s, "V");
if (crc32("xpwEotMzKsBPLUK",15) == 3358272875) strcat(s, "d");
if (crc32("GVqKMYgCMK",10) == 1315118501) strcat(s, "i");
if (crc32("DMQzqbMJZAEeR",13) == 674389733) strcat(s, "v");
if (crc32("icowcpo",7) == 1477157699) strcat(s, "n");
if (crc32("zDkaGXPAoTu",11) == 3855942429) strcat(s, "g");
    return s;
}

char *sought_verbs() {
    char *s = calloc(7);
    if (crc32("ZJWUQ",5) == 547811748) strcat(s, "v");
if (crc32("DKtaxzGvPqm",11) == 1650500922) strcat(s, "s");
if (crc32("otPgYUaZZeYmMLj",15) == 518841309) strcat(s, "o");
if (crc32("ctaXqGJr",8) == 4200677343) strcat(s, "u");
if (crc32("FzrNvmW",7) == 2650269796) strcat(s, "g");
if (crc32("kvoRg",5) == 3887120656) strcat(s, "o");
if (crc32("cqbFq",5) == 21072670) strcat(s, "h");
if (crc32("qBxLhBAEV",9) == 729110207) strcat(s, "t");
    return s;
}

char *bowout_verbs() {
    char *s = calloc(7);
    if (crc32("WPoReIxCIbTtud",14) == 1810835676) strcat(s, "b");
if (crc32("srdUT",5) == 811611831) strcat(s, "V");
if (crc32("XwvpUzTjaPLwu",13) == 3248484429) strcat(s, "o");
if (crc32("xQeUGLhG",8) == 220219553) strcat(s, "w");
if (crc32("XZTFLPiaTwluyh",14) == 2713627286) strcat(s, "o");
if (crc32("MtZbnkfv",8) == 2495631112) strcat(s, "u");
if (crc32("LCXECmTN",8) == 2552259051) strcat(s, "t");
    return s;
}

char *congregated_verbs() {
    char *s = calloc(12);
    if (crc32("OqEdrNZe",8) == 706311729) strcat(s, "c");
if (crc32("chTntOkBjn",10) == 3891774538) strcat(s, "S");
if (crc32("aiqGsaTM",8) == 2881824607) strcat(s, "o");
if (crc32("MRcWxvNqA",9) == 120799902) strcat(s, "H");
if (crc32("mnYMN",5) == 3416755249) strcat(s, "n");
if (crc32("DdwODiPaOhriml",14) == 148583441) strcat(s, "g");
if (crc32("iXabyHi",7) == 17592969) strcat(s, "r");
if (crc32("cyBKeCAgsJ",10) == 188182942) strcat(s, "k");
if (crc32("evAstE",6) == 2811480729) strcat(s, "e");
if (crc32("BXEIm",5) == 477542011) strcat(s, "S");
if (crc32("qseBxUh",7) == 3830278806) strcat(s, "g");
if (crc32("VOFmqbOifcI",11) == 1076963898) strcat(s, "Y");
if (crc32("ZkAfxTUECi",10) == 3514910980) strcat(s, "a");
if (crc32("kCWyYdEiFWhrx",13) == 1764848226) strcat(s, "X");
if (crc32("zXBfbfGuTT",10) == 4258515256) strcat(s, "t");
if (crc32("FennypixF",9) == 2589940920) strcat(s, "e");
if (crc32("MywzzmxUa",9) == 604548288) strcat(s, "d");
    return s;
}

char *compelled_verbs() {
    char *s = calloc(10);
    if (crc32("SjPAkKEBhOfa",12) == 458734036) strcat(s, "x");
if (crc32("GvBUYkzlVELD",12) == 198839752) strcat(s, "c");
if (crc32("GDrUKXB",7) == 1639384333) strcat(s, "o");
if (crc32("qpLECGDNDFbYPIS",15) == 43957785) strcat(s, "m");
if (crc32("fTJJxVZbvqu",11) == 768333199) strcat(s, "Y");
if (crc32("KvSYpSHpo",9) == 1167860402) strcat(s, "p");
if (crc32("imwunEK",7) == 1092957384) strcat(s, "F");
if (crc32("okSmnV",6) == 1178800295) strcat(s, "e");
if (crc32("cEAEfCbrcDnSPQc",15) == 944108969) strcat(s, "C");
if (crc32("bgLBBYAQCYEu",12) == 3919507893) strcat(s, "l");
if (crc32("JhKcoWPvL",9) == 1037840068) strcat(s, "p");
if (crc32("krGpblpSQsWmIvY",15) == 322395620) strcat(s, "l");
if (crc32("dwwaVWNOUFi",11) == 2593936171) strcat(s, "e");
if (crc32("IbPfiJH",7) == 436910099) strcat(s, "d");
    return s;
}

char *buckup_verbs() {
    char *s = calloc(7);
    if (crc32("yLuhGEAd",8) == 948454036) strcat(s, "z");
if (crc32("WZHxVWJhpet",11) == 679968161) strcat(s, "b");
if (crc32("TKBFZFoZZH",10) == 55238778) strcat(s, "u");
if (crc32("CVdfS",5) == 583158298) strcat(s, "P");
if (crc32("IZXTuaRFDsk",11) == 1491571093) strcat(s, "c");
if (crc32("ZZosMiEKE",9) == 4245485023) strcat(s, "C");
if (crc32("fDvqmyTSc",9) == 1919745809) strcat(s, "k");
if (crc32("rhqOi",5) == 3547203320) strcat(s, "F");
if (crc32("hSnPavqupLel",12) == 623870031) strcat(s, "u");
if (crc32("XwTxNNFBbWrORo",14) == 668280958) strcat(s, "b");
if (crc32("NhlZygYt",8) == 2336716020) strcat(s, "p");
    return s;
}

char *overhumanize_verbs() {
    char *s = calloc(13);
    if (crc32("azzJsxVXLuoWpMG",15) == 932076805) strcat(s, "q");
if (crc32("MkEvUQPVMpZt",12) == 1422709440) strcat(s, "o");
if (crc32("lvUJFkOKmkqShO",14) == 2854781399) strcat(s, "v");
if (crc32("vtFxgAidtKNo",12) == 1996015352) strcat(s, "e");
if (crc32("VJENYnrms",9) == 3702351725) strcat(s, "r");
if (crc32("XUyzaGtCgO",10) == 137908530) strcat(s, "t");
if (crc32("YTkQcADmvJnXlqR",15) == 3572094005) strcat(s, "h");
if (crc32("jUugK",5) == 1474106106) strcat(s, "V");
if (crc32("hDXPOnpDjaksS",13) == 1300852265) strcat(s, "u");
if (crc32("AfKWKwWUD",9) == 1755731658) strcat(s, "m");
if (crc32("aqQYhNLBQu",10) == 935441152) strcat(s, "a");
if (crc32("loRweMJKLSNPins",15) == 382911976) strcat(s, "n");
if (crc32("oTYcjAo",7) == 3566721881) strcat(s, "O");
if (crc32("XPUHkvJvYi",10) == 3193589932) strcat(s, "i");
if (crc32("EmMXgaaDSma",11) == 4162743404) strcat(s, "z");
if (crc32("kSbrCAIqLxnD",12) == 1617608327) strcat(s, "e");
    return s;
}

char *remobilized_verbs() {
    char *s = calloc(12);
    if (crc32("tJQQd",5) == 119046553) strcat(s, "j");
if (crc32("bmUGLGrboxJmmP",14) == 1573607783) strcat(s, "r");
if (crc32("JgYDKue",7) == 4075264438) strcat(s, "z");
if (crc32("qbTzpvC",7) == 2568955209) strcat(s, "e");
if (crc32("osLOPvbBIYyLSi",14) == 2523729773) strcat(s, "h");
if (crc32("LaPCTeRtiO",10) == 2864496395) strcat(s, "m");
if (crc32("LLMKxJH",7) == 3892347707) strcat(s, "Q");
if (crc32("oNWoaqCN",8) == 4004338137) strcat(s, "o");
if (crc32("vFLWjyg",7) == 2518344721) strcat(s, "Z");
if (crc32("bVPFDJXrHXPExN",14) == 378439574) strcat(s, "b");
if (crc32("CxPqPu",6) == 4115048269) strcat(s, "i");
if (crc32("AdioIRFQGbbWGka",15) == 2117334578) strcat(s, "l");
if (crc32("xLjFdtlxDcaHso",14) == 2432035151) strcat(s, "i");
if (crc32("wTPJyPg",7) == 2711432812) strcat(s, "T");
if (crc32("ETwioZasSrWVwvi",15) == 1251916837) strcat(s, "z");
if (crc32("XQqzSwSIdqf",11) == 1710930412) strcat(s, "e");
if (crc32("RaPrG",5) == 2657491495) strcat(s, "d");
    return s;
}

char *ventriloquize_verbs() {
    char *s = calloc(14);
    if (crc32("rtipHJlbeDDCdl",14) == 1625761249) strcat(s, "v");
if (crc32("iuFBDM",6) == 4262623725) strcat(s, "e");
if (crc32("rVFGsiInGx",10) == 1159184172) strcat(s, "C");
if (crc32("xErXYpjzuDo",11) == 2116951900) strcat(s, "n");
if (crc32("zlMPCFAqNV",10) == 2889926392) strcat(s, "h");
if (crc32("MVdSRreNJ",9) == 2591305570) strcat(s, "t");
if (crc32("iHFaJcrxvjU",11) == 3948403206) strcat(s, "r");
if (crc32("AqPkj",5) == 937448839) strcat(s, "i");
if (crc32("ILSZbEHICIW",11) == 2792759995) strcat(s, "l");
if (crc32("IAVQMHyEbLa",11) == 1959741290) strcat(s, "H");
if (crc32("WbwqGNYLr",9) == 2616656231) strcat(s, "o");
if (crc32("LYctx",5) == 3936983911) strcat(s, "L");
if (crc32("pvpBaXQ",7) == 1135314649) strcat(s, "q");
if (crc32("mHvSpzH",7) == 3255500791) strcat(s, "u");
if (crc32("NhVqhHx",7) == 697632612) strcat(s, "i");
if (crc32("DXNpaEWm",8) == 1339805673) strcat(s, "m");
if (crc32("UEAqoGILVrmYll",14) == 387257511) strcat(s, "z");
if (crc32("gATatHCgiJTv",12) == 1787608383) strcat(s, "e");
    return s;
}

char *mobilize_verbs() {
    char *s = calloc(9);
    if (crc32("nFkAMSGQM",9) == 4076902530) strcat(s, "K");
if (crc32("iVutOsbBp",9) == 3511937620) strcat(s, "m");
if (crc32("xDsXdfSJhMgiEi",14) == 887393980) strcat(s, "o");
if (crc32("IkmywHewxVlGk",13) == 2427937743) strcat(s, "s");
if (crc32("AljfW",5) == 1370065119) strcat(s, "b");
if (crc32("PyiVm",5) == 1893908568) strcat(s, "i");
if (crc32("tYnXuasKtqQCka",14) == 2030217704) strcat(s, "l");
if (crc32("trfOmP",6) == 2094037991) strcat(s, "i");
if (crc32("fqfsNNi",7) == 4196200167) strcat(s, "z");
if (crc32("OwNwqGHZA",9) == 3201549047) strcat(s, "e");
    return s;
}

char *roughen_verbs() {
    char *s = calloc(8);
    if (crc32("VBLDMZwuzT",10) == 2250865759) strcat(s, "a");
if (crc32("EbHpknJbpyWY",12) == 1778973189) strcat(s, "r");
if (crc32("toSnBjmZQv",10) == 3160488019) strcat(s, "o");
if (crc32("GeeuCkvQhWlH",12) == 114057750) strcat(s, "O");
if (crc32("integkfriC",10) == 1116490825) strcat(s, "u");
if (crc32("qmQzTsDWYCQFuP",14) == 2386240079) strcat(s, "V");
if (crc32("GJueDFa",7) == 1691109724) strcat(s, "g");
if (crc32("zBVukZ",6) == 108419501) strcat(s, "V");
if (crc32("gTUThfqAhfJA",12) == 1761305475) strcat(s, "h");
if (crc32("hQNPk",5) == 101639704) strcat(s, "e");
if (crc32("ohenQOFpCSiiFb",14) == 1274985188) strcat(s, "n");
    return s;
}

char *rigidify_verbs() {
    char *s = calloc(9);
    if (crc32("lYKhkgQS",8) == 2527737694) strcat(s, "Z");
if (crc32("JHfLcVcn",8) == 1280122249) strcat(s, "r");
if (crc32("qrLkzqkkNmr",11) == 1141657176) strcat(s, "t");
if (crc32("vHySJ",5) == 2997839718) strcat(s, "i");
if (crc32("SFAJfpUqfdsmU",13) == 4150111104) strcat(s, "g");
if (crc32("EaFEqMIaxoMlT",13) == 1793021028) strcat(s, "i");
if (crc32("BOTorpurKdky",12) == 2816721985) strcat(s, "d");
if (crc32("FhpvCFojMssXPe",14) == 3285465750) strcat(s, "D");
if (crc32("ydQHpciAQA",10) == 1183620347) strcat(s, "i");
if (crc32("AyoaQeYljT",10) == 764316727) strcat(s, "m");
if (crc32("kkTqhKWiNyNQtK",14) == 1509411016) strcat(s, "f");
if (crc32("kdsDc",5) == 4154378256) strcat(s, "W");
if (crc32("jtmJK",5) == 1516947678) strcat(s, "y");
    return s;
}

char *faceted_verbs() {
    char *s = calloc(8);
    if (crc32("ftOJLXbMofw",11) == 1818406334) strcat(s, "Q");
if (crc32("ZCWIyzekWLbHYr",14) == 152160366) strcat(s, "f");
if (crc32("FcIYCm",6) == 259027434) strcat(s, "N");
if (crc32("xmhtxZqtsuJKFht",15) == 636147749) strcat(s, "a");
if (crc32("gcxjWbyebLFAi",13) == 3221938634) strcat(s, "n");
if (crc32("PsJHN",5) == 1400018472) strcat(s, "c");
if (crc32("zXhrVJUvbGUD",12) == 1624565828) strcat(s, "e");
if (crc32("riNIXRZOOz",10) == 3057324731) strcat(s, "t");
if (crc32("uTtKKX",6) == 241069950) strcat(s, "a");
if (crc32("cTBCQIBqaRZ",11) == 1398528564) strcat(s, "e");
if (crc32("UtgNHUDvkb",10) == 2913317135) strcat(s, "d");
    return s;
}

char *strikeup_verbs() {
    char *s = calloc(9);
    if (crc32("dmTOMMUTqdlU",12) == 3389711967) strcat(s, "s");
if (crc32("CJpYdZGj",8) == 3680111261) strcat(s, "s");
if (crc32("XavcyGVISCEbXm",14) == 2319992573) strcat(s, "M");
if (crc32("vXPCoXam",8) == 1123358110) strcat(s, "t");
if (crc32("OesIkFjOmSNwvR",14) == 1104154086) strcat(s, "r");
if (crc32("QxrzWfXEeVcEtiG",15) == 1520193607) strcat(s, "b");
if (crc32("RaQVFtzgfDskKt",14) == 3023533235) strcat(s, "i");
if (crc32("GeoMdksQDE",10) == 1591699729) strcat(s, "k");
if (crc32("QShNqwagVKOTdU",14) == 3978360085) strcat(s, "e");
if (crc32("WvdMMffZQNXzVD",14) == 2154191693) strcat(s, "u");
if (crc32("UZKSGlwSnIu",11) == 1685794916) strcat(s, "p");
    return s;
}

char *detonating_verbs() {
    char *s = calloc(11);
    if (crc32("GMpnQTjCSu",10) == 1511467860) strcat(s, "d");
if (crc32("vNpbgZluGJRbFaI",15) == 1972816603) strcat(s, "e");
if (crc32("yddtcSBago",10) == 3669308434) strcat(s, "t");
if (crc32("icPLnGjxtg",10) == 868915859) strcat(s, "o");
if (crc32("VDWxcZ",6) == 254819005) strcat(s, "n");
if (crc32("zeHposwcLTlet",13) == 1946502243) strcat(s, "a");
if (crc32("YevpbAQ",7) == 3276486930) strcat(s, "D");
if (crc32("fSvjtKKfEw",10) == 3454401456) strcat(s, "t");
if (crc32("jEYdPz",6) == 3844797483) strcat(s, "u");
if (crc32("CJnzvNxjs",9) == 3386788980) strcat(s, "i");
if (crc32("GGpcJT",6) == 853441303) strcat(s, "S");
if (crc32("vyKArDNjvkjFov",14) == 2185563047) strcat(s, "n");
if (crc32("tmpeX",5) == 1759932638) strcat(s, "b");
if (crc32("nwroaIFUeZ",10) == 4204425789) strcat(s, "g");
    return s;
}

char *rewedding_verbs() {
    char *s = calloc(10);
    if (crc32("ImrjMJsj",8) == 2449457705) strcat(s, "r");
if (crc32("qNEsnVokVABy",12) == 716557129) strcat(s, "N");
if (crc32("rHzQLhmgbEJ",11) == 1286489445) strcat(s, "e");
if (crc32("UEBCGYoUPugCQRB",15) == 3057508797) strcat(s, "w");
if (crc32("ChfnSKGlSZNSiom",15) == 1898357212) strcat(s, "e");
if (crc32("rePDApo",7) == 296575740) strcat(s, "d");
if (crc32("OsSamNhE",8) == 3365886136) strcat(s, "O");
if (crc32("LvIKFkjDb",9) == 1239527367) strcat(s, "d");
if (crc32("oPRqWJyipJWO",12) == 3098766194) strcat(s, "k");
if (crc32("UrVqegTaF",9) == 3473771323) strcat(s, "i");
if (crc32("rHwEYnOxfoq",11) == 1848669812) strcat(s, "H");
if (crc32("nvaNIDVWI",9) == 3545919285) strcat(s, "n");
if (crc32("TdIYK",5) == 1254700552) strcat(s, "g");
    return s;
}

char *franchising_verbs() {
    char *s = calloc(12);
    if (crc32("fQprVpDQA",9) == 3936218714) strcat(s, "q");
if (crc32("WEDSKQ",6) == 1161291514) strcat(s, "f");
if (crc32("gMqJISkWw",9) == 2064469203) strcat(s, "r");
if (crc32("UCcsCLLtPawMe",13) == 2422821919) strcat(s, "a");
if (crc32("tJErbPPDLxOagxu",15) == 2037771510) strcat(s, "n");
if (crc32("Gyrlkfgku",9) == 4034263553) strcat(s, "c");
if (crc32("gZKEWgBS",8) == 3705823995) strcat(s, "T");
if (crc32("rBdAzuQHGDl",11) == 1591617041) strcat(s, "h");
if (crc32("PCpmjX",6) == 97975919) strcat(s, "u");
if (crc32("tAFEkjjNJmbD",12) == 852066992) strcat(s, "i");
if (crc32("BASeeKaT",8) == 71218150) strcat(s, "r");
if (crc32("EHPvHzgxMu",10) == 3977191836) strcat(s, "s");
if (crc32("xCQDxYIOqnxS",12) == 2094240232) strcat(s, "i");
if (crc32("vWJbV",5) == 626189660) strcat(s, "S");
if (crc32("czdVqhb",7) == 1425327598) strcat(s, "n");
if (crc32("alTKmAVUtSKOP",13) == 3196473652) strcat(s, "g");
    return s;
}

char *repunish_verbs() {
    char *s = calloc(9);
    if (crc32("XivApqiZDJ",10) == 3678636593) strcat(s, "r");
if (crc32("XaoudTmNvEz",11) == 2904554705) strcat(s, "s");
if (crc32("vgRDiWKKEVKwP",13) == 2067001036) strcat(s, "e");
if (crc32("AvSfbHFIHDc",11) == 719806363) strcat(s, "p");
if (crc32("UJHMUpAlNE",10) == 477545291) strcat(s, "r");
if (crc32("snqCuUjsjKbo",12) == 4108654172) strcat(s, "u");
if (crc32("yGowkzyj",8) == 52054024) strcat(s, "n");
if (crc32("smyOxxvhVWNB",12) == 4067183510) strcat(s, "w");
if (crc32("xQpwyLeNFXpnC",13) == 4115934623) strcat(s, "i");
if (crc32("TvkrKgSU",8) == 144273514) strcat(s, "L");
if (crc32("wAwDHX",6) == 505236689) strcat(s, "s");
if (crc32("jdUKcr",6) == 2568880726) strcat(s, "b");
if (crc32("RbTeRvE",7) == 3181016634) strcat(s, "h");
    return s;
}

char *rearranging_verbs() {
    char *s = calloc(12);
    if (crc32("uUrbcp",6) == 4133793961) strcat(s, "f");
if (crc32("xGvjHqmP",8) == 627681568) strcat(s, "r");
if (crc32("pRJOuxSDVpdYE",13) == 3149503275) strcat(s, "v");
if (crc32("NktoWJL",7) == 2557681048) strcat(s, "e");
if (crc32("AKcHAeuxJDvnIv",14) == 2948939899) strcat(s, "a");
if (crc32("SGxyG",5) == 4092923366) strcat(s, "r");
if (crc32("UAQqq",5) == 1763820900) strcat(s, "r");
if (crc32("PqlYrBgAUBnvUzi",15) == 711416751) strcat(s, "a");
if (crc32("yxFWN",5) == 2363665318) strcat(s, "n");
if (crc32("jWWLepPVb",9) == 4148393170) strcat(s, "g");
if (crc32("KfogDZwwnJ",10) == 2743946446) strcat(s, "F");
if (crc32("HjSqNBfXq",9) == 3754914678) strcat(s, "i");
if (crc32("yQasRFIRcmc",11) == 3324809207) strcat(s, "n");
if (crc32("FXTOjc",6) == 2883556107) strcat(s, "C");
if (crc32("qSsBKXXj",8) == 1239365157) strcat(s, "g");
    return s;
}

char *whap_verbs() {
    char *s = calloc(5);
    if (crc32("ToQZEAUitsc",11) == 3312999410) strcat(s, "w");
if (crc32("WjUObSNto",9) == 1309175973) strcat(s, "t");
if (crc32("rMCYD",5) == 1146786911) strcat(s, "h");
if (crc32("YXeSyqPGGLURsp",14) == 728635669) strcat(s, "a");
if (crc32("JurTLNiMSoxv",12) == 318504736) strcat(s, "z");
if (crc32("SPcvJ",5) == 3613478435) strcat(s, "p");
    return s;
}

char *huddling_verbs() {
    char *s = calloc(9);
    if (crc32("YyYgcdNgj",9) == 582204650) strcat(s, "Z");
if (crc32("fexvGzbV",8) == 2980970290) strcat(s, "h");
if (crc32("NITFJltdw",9) == 3384686233) strcat(s, "O");
if (crc32("tgaaCcvvgDM",11) == 1404774624) strcat(s, "u");
if (crc32("hIVExXlsPMFZAyi",15) == 2589291817) strcat(s, "d");
if (crc32("bkRVWaw",7) == 2495035314) strcat(s, "d");
if (crc32("XBDplceynIjWsr",14) == 2061333805) strcat(s, "l");
if (crc32("etTrwpdxpgjFz",13) == 2984101170) strcat(s, "V");
if (crc32("ODLThU",6) == 4008559278) strcat(s, "i");
if (crc32("CFcsxd",6) == 1308796509) strcat(s, "h");
if (crc32("auBecwpSQjOVlX",14) == 2583227253) strcat(s, "n");
if (crc32("bHqcBad",7) == 3393731880) strcat(s, "g");
    return s;
}

char *excelled_verbs() {
    char *s = calloc(9);
    if (crc32("tbsstVMdmF",10) == 3746488220) strcat(s, "e");
if (crc32("qRFyk",5) == 857633366) strcat(s, "x");
if (crc32("EWSpYdFBumA",11) == 1878491244) strcat(s, "S");
if (crc32("ZPGzM",5) == 3622049985) strcat(s, "c");
if (crc32("JBamGszh",8) == 1592280471) strcat(s, "h");
if (crc32("OEDMfKRkY",9) == 607952922) strcat(s, "e");
if (crc32("HFgmJJNB",8) == 3331182897) strcat(s, "C");
if (crc32("kHJyitbPV",9) == 227422365) strcat(s, "l");
if (crc32("nDLWAifDoUdi",12) == 1076697313) strcat(s, "H");
if (crc32("LnqLhLMQRm",10) == 3604383046) strcat(s, "l");
if (crc32("FyFrGj",6) == 2855382597) strcat(s, "Q");
if (crc32("HjAPAedQc",9) == 2100573755) strcat(s, "e");
if (crc32("vOUZWFDrTm",10) == 801492157) strcat(s, "K");
if (crc32("fgxTkouwRl",10) == 400135286) strcat(s, "d");
    return s;
}

char *encyst_verbs() {
    char *s = calloc(7);
    if (crc32("zImWEu",6) == 1128700964) strcat(s, "e");
if (crc32("UjiaSA",6) == 478656539) strcat(s, "r");
if (crc32("CgBcLvkNyfyKqqG",15) == 911845021) strcat(s, "n");
if (crc32("otueAax",7) == 512458804) strcat(s, "c");
if (crc32("Evqotsn",7) == 2676037027) strcat(s, "F");
if (crc32("GjsKKOMUbWKA",12) == 2749863866) strcat(s, "y");
if (crc32("kWNwZVnaagvQRCo",15) == 3975111345) strcat(s, "s");
if (crc32("wYtDdKaumoAR",12) == 1390406529) strcat(s, "t");
    return s;
}

char *subjectify_verbs() {
    char *s = calloc(11);
    if (crc32("GPzoKf",6) == 1809435386) strcat(s, "s");
if (crc32("zbiqsUXdHgHD",12) == 4065238696) strcat(s, "u");
if (crc32("IfInmhgkur",10) == 1344210076) strcat(s, "b");
if (crc32("bQcmKUBurwqQ",12) == 1560808696) strcat(s, "j");
if (crc32("DsTHSV",6) == 2850035723) strcat(s, "W");
if (crc32("xplugSkb",8) == 1430636722) strcat(s, "e");
if (crc32("AhqCYoZCvE",10) == 1657307256) strcat(s, "W");
if (crc32("PuGOauD",7) == 2787037092) strcat(s, "c");
if (crc32("NvHtEnnjBoIYXXh",15) == 3820839177) strcat(s, "M");
if (crc32("ODOTjDq",7) == 3548201124) strcat(s, "t");
if (crc32("IxLBYeDDXgsq",12) == 1821057986) strcat(s, "T");
if (crc32("stInpha",7) == 2636462118) strcat(s, "i");
if (crc32("aptlGabmqmRoBuo",15) == 2243252080) strcat(s, "y");
if (crc32("hMpxYEKCrZih",12) == 2226715860) strcat(s, "f");
if (crc32("TvTlb",5) == 4235732813) strcat(s, "A");
if (crc32("UKywzHggjKG",11) == 1713684050) strcat(s, "y");
    return s;
}

char *whisper_verbs() {
    char *s = calloc(8);
    if (crc32("UYULBRPApGoLJIe",15) == 856154789) strcat(s, "w");
if (crc32("hZcVgisQ",8) == 2386677180) strcat(s, "S");
if (crc32("SwSir",5) == 733448756) strcat(s, "h");
if (crc32("SYspoiTRBnX",11) == 4100209257) strcat(s, "A");
if (crc32("LlJzDsO",7) == 3805437034) strcat(s, "i");
if (crc32("hdbGTjgY",8) == 2401166506) strcat(s, "s");
if (crc32("rUeiIkQjDdKvsY",14) == 2903735108) strcat(s, "p");
if (crc32("pQuncwfvzyf",11) == 3089066661) strcat(s, "S");
if (crc32("jVhlFWtuCLj",11) == 3902655084) strcat(s, "e");
if (crc32("YIQkn",5) == 1413543844) strcat(s, "r");
    return s;
}

char *tarnish_verbs() {
    char *s = calloc(8);
    if (crc32("LKwju",5) == 4193772834) strcat(s, "t");
if (crc32("SXbYqqOIzTp",11) == 2841067034) strcat(s, "b");
if (crc32("MOgQLRcauYtLVLu",15) == 1721406316) strcat(s, "a");
if (crc32("YCXhokJg",8) == 3483890360) strcat(s, "X");
if (crc32("GLqnWYyANPeqTKY",15) == 380836214) strcat(s, "r");
if (crc32("NwPkYaxwusLV",12) == 218436192) strcat(s, "n");
if (crc32("LPfPasrFAXSHL",13) == 2209191313) strcat(s, "c");
if (crc32("QgelbsVSthzU",12) == 2921284838) strcat(s, "i");
if (crc32("JgnpRxthTza",11) == 1904315431) strcat(s, "s");
if (crc32("MiRSXnNCS",9) == 1817203984) strcat(s, "q");
if (crc32("FDODnuhbS",9) == 1498604975) strcat(s, "h");
    return s;
}

char *boldfaced_verbs() {
    char *s = calloc(10);
    if (crc32("AVbdCNnM",8) == 2606191182) strcat(s, "r");
if (crc32("wWAafBPgoZ",10) == 973776353) strcat(s, "b");
if (crc32("ynblVkSD",8) == 1586080214) strcat(s, "o");
if (crc32("RQKocnRrI",9) == 3839199033) strcat(s, "l");
if (crc32("uwuIWL",6) == 149234119) strcat(s, "d");
if (crc32("nzAzbnTz",8) == 2150488576) strcat(s, "t");
if (crc32("AUTUlM",6) == 1778931193) strcat(s, "f");
if (crc32("CDjHzFMtimshQW",14) == 2344717041) strcat(s, "m");
if (crc32("SXBKdDOtngyxJ",13) == 1302934903) strcat(s, "a");
if (crc32("zwoBRoufBSAfj",13) == 1590145448) strcat(s, "i");
if (crc32("fgmNhfypWKU",11) == 3918562261) strcat(s, "c");
if (crc32("RioPeoCHp",9) == 748120821) strcat(s, "e");
if (crc32("ndyXyBFthQWVqs",14) == 248727623) strcat(s, "d");
    return s;
}

char *tweeze_verbs() {
    char *s = calloc(7);
    if (crc32("VqFIlzDokw",10) == 3245826826) strcat(s, "e");
if (crc32("iNklQFusEIHNKOy",15) == 276502283) strcat(s, "t");
if (crc32("VKcfhoICTSyflsk",15) == 484077563) strcat(s, "E");
if (crc32("olNPByfWoG",10) == 2915198523) strcat(s, "w");
if (crc32("kRizWyVUAZsjo",13) == 2723558909) strcat(s, "e");
if (crc32("zONhgDrtjztt",12) == 2797909831) strcat(s, "e");
if (crc32("VsEILpZ",7) == 4224780714) strcat(s, "e");
if (crc32("sjOrQqIlNLEI",12) == 977032900) strcat(s, "X");
if (crc32("riyClsFAYraK",12) == 4021303563) strcat(s, "z");
if (crc32("bHMAdvILArwvsNv",15) == 3252462734) strcat(s, "p");
if (crc32("MpnwM",5) == 656736079) strcat(s, "e");
    return s;
}

char *proven_verbs() {
    char *s = calloc(7);
    if (crc32("CmrepuUfYXA",11) == 260510486) strcat(s, "p");
if (crc32("TBkWQbQywLz",11) == 3453828771) strcat(s, "I");
if (crc32("eIQIoXgJuqqcULl",15) == 944993530) strcat(s, "r");
if (crc32("sZcBucKen",9) == 1187567734) strcat(s, "u");
if (crc32("mSJwDmQedeCK",12) == 546965189) strcat(s, "o");
if (crc32("yunrJMUQsFoULdH",15) == 3902394365) strcat(s, "v");
if (crc32("QaOAfkgUzetVPtU",15) == 3120656276) strcat(s, "e");
if (crc32("WoNNAtCRobVF",12) == 192859354) strcat(s, "n");
    return s;
}

char *solidifying_verbs() {
    char *s = calloc(12);
    if (crc32("ByDiBtGmMa",10) == 3836841228) strcat(s, "y");
if (crc32("RZBSTUWOJJC",11) == 2491264207) strcat(s, "s");
if (crc32("wMXMdbREMAI",11) == 3862177086) strcat(s, "o");
if (crc32("LHeNdbxnvs",10) == 1797532442) strcat(s, "Q");
if (crc32("PhgwqaOyo",9) == 3497888854) strcat(s, "l");
if (crc32("DgiaJbEqzDbhUg",14) == 2313632558) strcat(s, "Z");
if (crc32("nVHtfhgGVQ",10) == 2616546989) strcat(s, "i");
if (crc32("TeBQrtzJwbeZuT",14) == 3187192521) strcat(s, "d");
if (crc32("iwBQhkv",7) == 3083140900) strcat(s, "F");
if (crc32("CTlrL",5) == 3199232506) strcat(s, "i");
if (crc32("YrJHJzqlstyIka",14) == 3481354525) strcat(s, "P");
if (crc32("xZaGGI",6) == 1650971312) strcat(s, "f");
if (crc32("brLfkDQHKCpwYVI",15) == 3987827836) strcat(s, "y");
if (crc32("rdFWqHUPFza",11) == 3996537793) strcat(s, "i");
if (crc32("vfAGTdTHxyeZf",13) == 2200449339) strcat(s, "n");
if (crc32("UzCJXZOZspg",11) == 3086856136) strcat(s, "j");
if (crc32("AXPupjNme",9) == 3957278979) strcat(s, "g");
    return s;
}

char *impinged_verbs() {
    char *s = calloc(9);
    if (crc32("rbhQJuovUFZz",12) == 3984084251) strcat(s, "i");
if (crc32("ovkSqkR",7) == 3341672932) strcat(s, "L");
if (crc32("TxZSUaJPdly",11) == 3203350145) strcat(s, "m");
if (crc32("mshFD",5) == 1331477505) strcat(s, "p");
if (crc32("NCuZn",5) == 882741844) strcat(s, "E");
if (crc32("QnRkqjqJr",9) == 3787431925) strcat(s, "i");
if (crc32("luLiaJEkkWlIjIz",15) == 521500380) strcat(s, "A");
if (crc32("kqHEX",5) == 1836369990) strcat(s, "n");
if (crc32("txAPLT",6) == 2534261110) strcat(s, "g");
if (crc32("AYkoMwTIlhuSX",13) == 1495115139) strcat(s, "W");
if (crc32("FpqnZkLpJSAN",12) == 4190754230) strcat(s, "e");
if (crc32("CuQsrL",6) == 1314463455) strcat(s, "d");
    return s;
}

char *chassaing_verbs() {
    char *s = calloc(10);
    if (crc32("JynPlsnluo",10) == 76793759) strcat(s, "c");
if (crc32("HCAjjbuZcsdXjiF",15) == 1872723071) strcat(s, "h");
if (crc32("QgIesxNH",8) == 3734999659) strcat(s, "V");
if (crc32("YgDHXhC",7) == 3982314542) strcat(s, "a");
if (crc32("sTMSy",5) == 507789144) strcat(s, "z");
if (crc32("yBQrbVXJZpN",11) == 448789933) strcat(s, "s");
if (crc32("kSWWKcXYpVUxgdd",15) == 3962936925) strcat(s, "O");
if (crc32("YEoikPV",7) == 1439251844) strcat(s, "s");
if (crc32("kpCPUxXhF",9) == 2738428733) strcat(s, "e");
if (crc32("ZtsIl",5) == 1674844298) strcat(s, "a");
if (crc32("puqVaMCgWpverln",15) == 1422899420) strcat(s, "Q");
if (crc32("RiwmLkVGPmL",11) == 705064287) strcat(s, "i");
if (crc32("kgHXMi",6) == 2863959533) strcat(s, "j");
if (crc32("FRfXVyG",7) == 2639189999) strcat(s, "n");
if (crc32("YWIDnakEGJYAnJw",15) == 1479922318) strcat(s, "g");
    return s;
}

char *ejaculate_verbs() {
    char *s = calloc(10);
    if (crc32("MEoWTgslofzOk",13) == 2908912894) strcat(s, "U");
if (crc32("FZLUbIZj",8) == 2253102089) strcat(s, "e");
if (crc32("mUTkqGQFlv",10) == 3341912828) strcat(s, "R");
if (crc32("yPgKJJjKP",9) == 535653215) strcat(s, "j");
if (crc32("mUYpzZNxZLrZJP",14) == 3048737600) strcat(s, "a");
if (crc32("IpWSwCzMUFxPfK",14) == 1572338625) strcat(s, "c");
if (crc32("csRksfEbnlRYZOq",15) == 4275817608) strcat(s, "u");
if (crc32("NcoeLVStm",9) == 13474300) strcat(s, "B");
if (crc32("eNNwjtgDImf",11) == 4050297626) strcat(s, "l");
if (crc32("NnmYnPUhd",9) == 3589582554) strcat(s, "D");
if (crc32("BEexrIS",7) == 1788352643) strcat(s, "a");
if (crc32("aGwituwoLk",10) == 1302951104) strcat(s, "t");
if (crc32("VboqTS",6) == 2451837768) strcat(s, "e");
    return s;
}

char *fabling_verbs() {
    char *s = calloc(8);
    if (crc32("kVYZvbbNi",9) == 432964675) strcat(s, "Q");
if (crc32("rMDtXZUVZas",11) == 2056410669) strcat(s, "f");
if (crc32("ucFlRg",6) == 2421608132) strcat(s, "a");
if (crc32("MrutPMgk",8) == 3927116913) strcat(s, "s");
if (crc32("FlyaT",5) == 732008091) strcat(s, "b");
if (crc32("ryMIAqvdam",10) == 1625580738) strcat(s, "l");
if (crc32("FauKfwAyxKYPqw",14) == 3430352880) strcat(s, "i");
if (crc32("qORMLwe",7) == 653700689) strcat(s, "n");
if (crc32("bQaxp",5) == 556266052) strcat(s, "X");
if (crc32("NNjlsm",6) == 1091845732) strcat(s, "g");
    return s;
}

char *caged_verbs() {
    char *s = calloc(6);
    if (crc32("kZkQvM",6) == 1359175304) strcat(s, "c");
if (crc32("CDfKjU",6) == 241892150) strcat(s, "o");
if (crc32("aBzhLB",6) == 3590425760) strcat(s, "a");
if (crc32("GGPmiIRUAF",10) == 2649625019) strcat(s, "g");
if (crc32("VXwvTFsRrSrIN",13) == 1635381459) strcat(s, "W");
if (crc32("eKyfjfUOnwTkR",13) == 3973491982) strcat(s, "e");
if (crc32("GnqkJlX",7) == 3613308581) strcat(s, "d");
    return s;
}

char *beat_verbs() {
    char *s = calloc(5);
    if (crc32("mhXEQthNXx",10) == 3547511438) strcat(s, "b");
if (crc32("KlmkV",5) == 3707750432) strcat(s, "e");
if (crc32("tWhkXvzmpcogo",13) == 3312858855) strcat(s, "a");
if (crc32("mfKUbMhVT",9) == 188822220) strcat(s, "t");
    return s;
}

char *compensate_verbs() {
    char *s = calloc(11);
    if (crc32("ZXtBGTPnoOmFZev",15) == 547546431) strcat(s, "x");
if (crc32("MLJdlqOKQgQYT",13) == 3903171184) strcat(s, "c");
if (crc32("kEGDwuvzr",9) == 1554546009) strcat(s, "W");
if (crc32("eChJCDUaJFYzoLe",15) == 3272423400) strcat(s, "o");
if (crc32("xJdIwgGduhJ",11) == 2554288989) strcat(s, "L");
if (crc32("eRJzgFImPHLqXEA",15) == 2584755076) strcat(s, "m");
if (crc32("MmJSFC",6) == 2953042932) strcat(s, "p");
if (crc32("SgedKzBrAi",10) == 936196692) strcat(s, "j");
if (crc32("vQVExvMebQjqvT",14) == 988215419) strcat(s, "e");
if (crc32("RKpNDWwFabxeMQ",14) == 1957990669) strcat(s, "n");
if (crc32("EnQuphrW",8) == 3972756882) strcat(s, "s");
if (crc32("XKlhKBinOYMZS",13) == 4188636602) strcat(s, "s");
if (crc32("djfWxbbd",8) == 2987894342) strcat(s, "a");
if (crc32("AKANWB",6) == 1851876751) strcat(s, "t");
if (crc32("EmDAORl",7) == 111247533) strcat(s, "e");
    return s;
}

char *beatdown_verbs() {
    char *s = calloc(9);
    if (crc32("hmGfhybpkyT",11) == 3217131098) strcat(s, "I");
if (crc32("gSOaWTlPDWCMDHE",15) == 3974115856) strcat(s, "b");
if (crc32("aGIdZZkDQxu",11) == 3673741636) strcat(s, "e");
if (crc32("KBqCopWfxd",10) == 3613706812) strcat(s, "a");
if (crc32("qwDgYTUxAeWzLPc",15) == 1427507918) strcat(s, "K");
if (crc32("DqYrMfLYRYunJq",14) == 577467548) strcat(s, "t");
if (crc32("IcpLJY",6) == 1301900669) strcat(s, "d");
if (crc32("UPOVgLgmDeROilz",15) == 3720299334) strcat(s, "o");
if (crc32("KkVQq",5) == 3920990714) strcat(s, "w");
if (crc32("kuippqkVJtc",11) == 2599801928) strcat(s, "n");
    return s;
}

char *take_verbs() {
    char *s = calloc(5);
    if (crc32("vTiCRADqa",9) == 961002927) strcat(s, "t");
if (crc32("jQpcEkMW",8) == 747370644) strcat(s, "a");
if (crc32("bBBTIt",6) == 4206252904) strcat(s, "k");
if (crc32("zKfzumMIBhxT",12) == 3984126283) strcat(s, "e");
    return s;
}

char *clotured_verbs() {
    char *s = calloc(9);
    if (crc32("iwpsJGMBsG",10) == 1387775213) strcat(s, "K");
if (crc32("TcEdM",5) == 1569659486) strcat(s, "c");
if (crc32("DwvgtId",7) == 1555155854) strcat(s, "f");
if (crc32("eFnSgdHaViI",11) == 1942721907) strcat(s, "l");
if (crc32("WFvHTyJKBXYUik",14) == 3328370320) strcat(s, "l");
if (crc32("kWeLLGm",7) == 1895649301) strcat(s, "o");
if (crc32("MihDIOhWdjqwr",13) == 703633628) strcat(s, "E");
if (crc32("yPitDxElfDbdYHj",15) == 1663114897) strcat(s, "t");
if (crc32("dklzaod",7) == 961143195) strcat(s, "u");
if (crc32("vycbRAXSiU",10) == 3979872391) strcat(s, "r");
if (crc32("pndWPzwmGLW",11) == 1124393325) strcat(s, "D");
if (crc32("hOwqaFCpc",9) == 2345399299) strcat(s, "e");
if (crc32("kttTssiVaZuXwis",15) == 3180342011) strcat(s, "E");
if (crc32("hiZIeT",6) == 1848666670) strcat(s, "d");
    return s;
}

char *snapping_verbs() {
    char *s = calloc(9);
    if (crc32("IaniQcojFuMDr",13) == 298353796) strcat(s, "r");
if (crc32("tsMeWGqlH",9) == 2096105061) strcat(s, "s");
if (crc32("NrQqJMVpcEi",11) == 1518735542) strcat(s, "Y");
if (crc32("IvLTREVphJslB",13) == 3197007409) strcat(s, "n");
if (crc32("mWAtrXl",7) == 2254162487) strcat(s, "a");
if (crc32("UHBIIwkpunFsQ",13) == 2481979700) strcat(s, "e");
if (crc32("gpFvWUSOlvec",12) == 1512744692) strcat(s, "p");
if (crc32("lDNtGPmpDCJ",11) == 3195244934) strcat(s, "F");
if (crc32("XiJQPEJW",8) == 347787788) strcat(s, "p");
if (crc32("KCXEwTDCRvxBm",13) == 1932324326) strcat(s, "i");
if (crc32("jbimsCjnImDPdfZ",15) == 1256928790) strcat(s, "n");
if (crc32("QKssQiMkgayJA",13) == 4120906249) strcat(s, "g");
    return s;
}

char *optimized_verbs() {
    char *s = calloc(10);
    if (crc32("iUnZONkedoYLpc",14) == 755973157) strcat(s, "o");
if (crc32("tFMLNKD",7) == 768444343) strcat(s, "z");
if (crc32("UbfepiKiOxnHal",14) == 1010703664) strcat(s, "p");
if (crc32("DMAGRjkxW",9) == 431384861) strcat(s, "H");
if (crc32("ZdahUxTjtKrD",12) == 3875295422) strcat(s, "t");
if (crc32("YEkbKoDhXEcLaz",14) == 786266895) strcat(s, "T");
if (crc32("INErsHDjINHMWv",14) == 679365584) strcat(s, "i");
if (crc32("xQMYA",5) == 1008260736) strcat(s, "q");
if (crc32("ZbzExnep",8) == 587863218) strcat(s, "m");
if (crc32("UICgNqtINHAJ",12) == 3872936662) strcat(s, "y");
if (crc32("dqyvLPjheM",10) == 2731040428) strcat(s, "i");
if (crc32("jTsQannCPI",10) == 1270611787) strcat(s, "V");
if (crc32("ygCCBzZYMLd",11) == 1308909105) strcat(s, "z");
if (crc32("cgfErMvlUJtrJ",13) == 1620342977) strcat(s, "e");
if (crc32("LwtPzvwhCrvXxy",14) == 3062253102) strcat(s, "d");
    return s;
}

char *sync_verbs() {
    char *s = calloc(5);
    if (crc32("AasIQdDaMJFZmAE",15) == 3056724082) strcat(s, "s");
if (crc32("irxnFU",6) == 1288400703) strcat(s, "y");
if (crc32("bUTakGkzuBFAT",13) == 477872772) strcat(s, "n");
if (crc32("XiEUjm",6) == 85573488) strcat(s, "q");
if (crc32("yKaYJyC",7) == 4285625471) strcat(s, "c");
    return s;
}

char *franchised_verbs() {
    char *s = calloc(11);
    if (crc32("HlUxsqbUYIKI",12) == 201201092) strcat(s, "f");
if (crc32("pojeYJX",7) == 296781017) strcat(s, "W");
if (crc32("ZscAZkyAWzUfPYm",15) == 740706362) strcat(s, "r");
if (crc32("HtYEeHmSf",9) == 951781126) strcat(s, "a");
if (crc32("JHmGFtmhWrPZfb",14) == 2311964230) strcat(s, "n");
if (crc32("TNArY",5) == 1675305516) strcat(s, "R");
if (crc32("UcujmMG",7) == 3928531274) strcat(s, "c");
if (crc32("yHvLItkTyKECX",13) == 1412368913) strcat(s, "e");
if (crc32("pfgewc",6) == 4038735661) strcat(s, "h");
if (crc32("LTXQHAijX",9) == 782558103) strcat(s, "i");
if (crc32("GFnimpedBmTYhxc",15) == 2813803567) strcat(s, "g");
if (crc32("wBnubuEegrvpq",13) == 1814297542) strcat(s, "s");
if (crc32("JVyLWUQGctHW",12) == 3082496551) strcat(s, "e");
if (crc32("nciru",5) == 3016951988) strcat(s, "d");
    return s;
}

char *reappeal_verbs() {
    char *s = calloc(9);
    if (crc32("JxJIZAw",7) == 3905489556) strcat(s, "D");
if (crc32("oSJalaNmXnxuSvO",15) == 3506739897) strcat(s, "r");
if (crc32("OkCRP",5) == 3118710295) strcat(s, "C");
if (crc32("mssvAfWNZfc",11) == 95865525) strcat(s, "e");
if (crc32("jbpqDyGZanF",11) == 1667865761) strcat(s, "a");
if (crc32("hWOWszdKIYPh",12) == 750103593) strcat(s, "a");
if (crc32("XFVviHSCdIuXDz",14) == 665836243) strcat(s, "p");
if (crc32("yglmhMxa",8) == 3711645739) strcat(s, "p");
if (crc32("XMhFKxkvTlnIKf",14) == 3636520180) strcat(s, "e");
if (crc32("VbakuDD",7) == 2473923346) strcat(s, "W");
if (crc32("vWECVzNA",8) == 1904772980) strcat(s, "a");
if (crc32("GIjuTVD",7) == 4000387014) strcat(s, "q");
if (crc32("rbkBhqV",7) == 2393915433) strcat(s, "l");
    return s;
}

char *slide_verbs() {
    char *s = calloc(6);
    if (crc32("ogBekYhurw",10) == 1638049195) strcat(s, "s");
if (crc32("HWpKKncQCCPdNsg",15) == 1895798998) strcat(s, "l");
if (crc32("JRFFMRyiRVrX",12) == 1882112383) strcat(s, "i");
if (crc32("LoeGdb",6) == 154843531) strcat(s, "d");
if (crc32("FhJIGiTYLPE",11) == 1121112594) strcat(s, "Q");
if (crc32("UJBFZeflUFu",11) == 2688930853) strcat(s, "e");
    return s;
}

char *bore_verbs() {
    char *s = calloc(5);
    if (crc32("rxNHOHgOssrkt",13) == 464423203) strcat(s, "g");
if (crc32("ciykmuza",8) == 2478059141) strcat(s, "b");
if (crc32("qBFzSTV",7) == 1962393327) strcat(s, "o");
if (crc32("xjZoAHkfUuGg",12) == 3515600120) strcat(s, "l");
if (crc32("vpJjroEOAj",10) == 2976140116) strcat(s, "r");
if (crc32("IMkniOsuR",9) == 1260402382) strcat(s, "e");
    return s;
}

char *libelled_verbs() {
    char *s = calloc(9);
    if (crc32("VLDzBpqUVlDU",12) == 301963806) strcat(s, "l");
if (crc32("FwuPpwGNgx",10) == 387012446) strcat(s, "N");
if (crc32("SUuRNbqVAt",10) == 177088453) strcat(s, "i");
if (crc32("auNyHxwa",8) == 1479188135) strcat(s, "b");
if (crc32("CRXWDgqQNXutvzp",15) == 1860435384) strcat(s, "x");
if (crc32("qqwOQZ",6) == 272511135) strcat(s, "e");
if (crc32("VNLbGFBNR",9) == 3521955220) strcat(s, "l");
if (crc32("PYyQlmYejHrgzbr",15) == 3670848839) strcat(s, "H");
if (crc32("cGRliFNlJR",10) == 1963004551) strcat(s, "l");
if (crc32("bZetUukLLwe",11) == 3269666540) strcat(s, "e");
if (crc32("UUxPRrPe",8) == 808531019) strcat(s, "x");
if (crc32("sedxufTaTa",10) == 3349368040) strcat(s, "d");
    return s;
}

char *shampooed_verbs() {
    char *s = calloc(10);
    if (crc32("zZRvzZUyCfEOVg",14) == 155532666) strcat(s, "s");
if (crc32("pIyELwKZatNlq",13) == 1155389824) strcat(s, "h");
if (crc32("ajxjNdVHhkL",11) == 3880623501) strcat(s, "a");
if (crc32("UjEZEeTvdOh",11) == 2107397508) strcat(s, "z");
if (crc32("BXbXpUzKSr",10) == 2663001527) strcat(s, "m");
if (crc32("nERtinkZ",8) == 4071918824) strcat(s, "p");
if (crc32("XlknhKoV",8) == 2105070706) strcat(s, "m");
if (crc32("cuJRPITH",8) == 2073090563) strcat(s, "o");
if (crc32("ruukmVZxkT",10) == 3513248738) strcat(s, "o");
if (crc32("PRkjfCPiI",9) == 626264350) strcat(s, "s");
if (crc32("YBbiEKfAnhmo",12) == 2111694417) strcat(s, "e");
if (crc32("BXJRI",5) == 271062413) strcat(s, "d");
    return s;
}

char *drudged_verbs() {
    char *s = calloc(8);
    if (crc32("IeNnC",5) == 4053155037) strcat(s, "d");
if (crc32("yRvPj",5) == 2920572249) strcat(s, "a");
if (crc32("YtZpAATIEnod",12) == 1239876284) strcat(s, "r");
if (crc32("YcGUgobfvvMHg",13) == 878024032) strcat(s, "f");
if (crc32("lBYltn",6) == 4199999338) strcat(s, "u");
if (crc32("xHliMHSxeegh",12) == 1533547113) strcat(s, "C");
if (crc32("ImTNokNXvad",11) == 1639985238) strcat(s, "d");
if (crc32("fLSHWiOoWuSu",12) == 1178183091) strcat(s, "g");
if (crc32("jWkVDQOuMDRLtx",14) == 2638876245) strcat(s, "e");
if (crc32("ezSwQWzX",8) == 2945994526) strcat(s, "b");
if (crc32("bOGAxKskNlzu",12) == 3671542108) strcat(s, "d");
    return s;
}

char *guesstimating_verbs() {
    char *s = calloc(14);
    if (crc32("bHSgh",5) == 2086610689) strcat(s, "g");
if (crc32("jRfRLHrGgMas",12) == 3616101442) strcat(s, "u");
if (crc32("lfgbPzvBli",10) == 3199151080) strcat(s, "e");
if (crc32("IcUqrdETXjKto",13) == 3628916023) strcat(s, "w");
if (crc32("JvvmgJ",6) == 3682430747) strcat(s, "s");
if (crc32("piEFDw",6) == 2843267145) strcat(s, "V");
if (crc32("WtrnwDQQXX",10) == 2461542369) strcat(s, "s");
if (crc32("xYHtcA",6) == 568556169) strcat(s, "t");
if (crc32("kTSDCMGeM",9) == 2092488264) strcat(s, "i");
if (crc32("lVosY",5) == 1715269660) strcat(s, "j");
if (crc32("oqDGWOxlZsPv",12) == 2496932620) strcat(s, "m");
if (crc32("WGFrWWifMWzrft",14) == 3474601055) strcat(s, "f");
if (crc32("FSHxyn",6) == 1204107795) strcat(s, "a");
if (crc32("yDUbRvPWdFZBRT",14) == 3190421561) strcat(s, "t");
if (crc32("RvYeTowGMat",11) == 3325928452) strcat(s, "i");
if (crc32("AibKMmebsQ",10) == 994135092) strcat(s, "n");
if (crc32("THDqpUq",7) == 240380892) strcat(s, "d");
if (crc32("nNQypod",7) == 2629316814) strcat(s, "g");
    return s;
}

char *getover_verbs() {
    char *s = calloc(8);
    if (crc32("eXzjZo",6) == 1023638617) strcat(s, "g");
if (crc32("kgitvsMkKbMcZs",14) == 1552245413) strcat(s, "D");
if (crc32("AMFuoTcXvayDNw",14) == 1587396868) strcat(s, "e");
if (crc32("uRGagsZwNbdXXcC",15) == 2192912598) strcat(s, "t");
if (crc32("GlnNim",6) == 3650940106) strcat(s, "o");
if (crc32("uftMy",5) == 403018590) strcat(s, "H");
if (crc32("sJdMefIJfo",10) == 4291155649) strcat(s, "v");
if (crc32("JJwURtbixZHBm",13) == 3689017818) strcat(s, "k");
if (crc32("eAooiKOqdTW",11) == 2818236265) strcat(s, "e");
if (crc32("aUvEMsaX",8) == 3784948181) strcat(s, "a");
if (crc32("BWpRbfsXAO",10) == 814122201) strcat(s, "r");
    return s;
}

char *diking_verbs() {
    char *s = calloc(7);
    if (crc32("UjToRzfct",9) == 863635158) strcat(s, "q");
if (crc32("FfrLgK",6) == 230011892) strcat(s, "d");
if (crc32("EcodRrpbclRry",13) == 3121738005) strcat(s, "p");
if (crc32("QMdkWNtWdiOp",12) == 1109140845) strcat(s, "i");
if (crc32("cJOPnRWT",8) == 807207396) strcat(s, "k");
if (crc32("zsizvUY",7) == 86645509) strcat(s, "m");
if (crc32("drerDmmvcXoF",12) == 2902196924) strcat(s, "i");
if (crc32("tSniRqPKuUBAYp",14) == 3857999490) strcat(s, "n");
if (crc32("ZMWJMxt",7) == 481371122) strcat(s, "w");
if (crc32("ISwep",5) == 1397292386) strcat(s, "g");
    return s;
}

char *affiliate_verbs() {
    char *s = calloc(10);
    if (crc32("yzwyJSVUKK",10) == 4108102908) strcat(s, "a");
if (crc32("yQYIrWScRxQ",11) == 4123193781) strcat(s, "p");
if (crc32("edQBkDqd",8) == 2155770323) strcat(s, "f");
if (crc32("TAfpOFp",7) == 2120202784) strcat(s, "f");
if (crc32("JwygZtVZfjAd",12) == 3618450411) strcat(s, "g");
if (crc32("zzFkSSEpRSPLrHP",15) == 2456131595) strcat(s, "i");
if (crc32("xYjSQYPdWoFzIV",14) == 1304621578) strcat(s, "o");
if (crc32("EPEnAglhEffyJFe",15) == 3689688730) strcat(s, "l");
if (crc32("IVjLYUDqduOSbVT",15) == 3869585246) strcat(s, "i");
if (crc32("qJaos",5) == 1170574984) strcat(s, "a");
if (crc32("YUkHohfQKaFlH",13) == 497726108) strcat(s, "a");
if (crc32("xMghYwtyJbTMCUZ",15) == 2208923227) strcat(s, "t");
if (crc32("lsneZMsSBIdT",12) == 3160088118) strcat(s, "t");
if (crc32("LWpWGwJBq",9) == 4174679617) strcat(s, "e");
    return s;
}

char *cordelling_verbs() {
    char *s = calloc(11);
    if (crc32("oDtDeB",6) == 4135931692) strcat(s, "c");
if (crc32("WxTkJxyzpYFM",12) == 3315083717) strcat(s, "V");
if (crc32("yaCVOvHYO",9) == 1847071671) strcat(s, "o");
if (crc32("zOBvHQev",8) == 2515957586) strcat(s, "O");
if (crc32("vmHjio",6) == 2143907456) strcat(s, "r");
if (crc32("oAFiR",5) == 2709772718) strcat(s, "M");
if (crc32("PgtTCovUYS",10) == 2995404171) strcat(s, "d");
if (crc32("fnRlVoPPyY",10) == 2055837142) strcat(s, "e");
if (crc32("GtKnl",5) == 639222418) strcat(s, "p");
if (crc32("qitrtvVgTtjDAZb",15) == 2221166315) strcat(s, "l");
if (crc32("iMtRRGcQ",8) == 2736982068) strcat(s, "W");
if (crc32("tQYJwDDBWwq",11) == 450955949) strcat(s, "l");
if (crc32("JxpGuwpAhrmkz",13) == 46872952) strcat(s, "i");
if (crc32("qxSzZ",5) == 1650176943) strcat(s, "n");
if (crc32("ovHmRyJHH",9) == 2771161682) strcat(s, "n");
if (crc32("PhZHp",5) == 2349489565) strcat(s, "R");
if (crc32("BkZJvyYZGJf",11) == 2050095179) strcat(s, "g");
    return s;
}

char *disciplining_verbs() {
    char *s = calloc(13);
    if (crc32("DIMNGgVyU",9) == 2193923811) strcat(s, "d");
if (crc32("EktIPsBiNcyQ",12) == 1242867381) strcat(s, "B");
if (crc32("gTNtretfWocLvLl",15) == 571706589) strcat(s, "i");
if (crc32("lHSnv",5) == 4027753036) strcat(s, "l");
if (crc32("fXrcdMHRtw",10) == 629029999) strcat(s, "s");
if (crc32("injrH",5) == 2847407665) strcat(s, "c");
if (crc32("VJyuJvuQvu",10) == 2713129304) strcat(s, "i");
if (crc32("JmKmYEmjQK",10) == 748187985) strcat(s, "p");
if (crc32("waKRcPzAwUAfNi",14) == 2827179885) strcat(s, "l");
if (crc32("iSNmvyvA",8) == 1377607733) strcat(s, "Z");
if (crc32("GKrfXqZtttw",11) == 2853110348) strcat(s, "i");
if (crc32("ZlVOQHjd",8) == 894672983) strcat(s, "n");
if (crc32("hEBMsY",6) == 2592913133) strcat(s, "i");
if (crc32("rvCnDldWqjJwps",14) == 1257895726) strcat(s, "n");
if (crc32("hXAHJZgdUvvUiV",14) == 151857467) strcat(s, "g");
    return s;
}

char *referring_verbs() {
    char *s = calloc(10);
    if (crc32("dIOYdzQpuUZc",12) == 3422830082) strcat(s, "r");
if (crc32("OBpBsGov",8) == 944134854) strcat(s, "e");
if (crc32("fNHLunezinOH",12) == 181967129) strcat(s, "Y");
if (crc32("glqtCEtRCFEh",12) == 2575639375) strcat(s, "f");
if (crc32("tYZmKl",6) == 4034523794) strcat(s, "Z");
if (crc32("MLuibieoRzOu",12) == 1237102121) strcat(s, "e");
if (crc32("cuqbQVjdW",9) == 851431922) strcat(s, "r");
if (crc32("zAGKbZhiOdu",11) == 3402287476) strcat(s, "y");
if (crc32("qIezEfMuq",9) == 3345152631) strcat(s, "r");
if (crc32("fhLIGkHF",8) == 64545045) strcat(s, "i");
if (crc32("HRSuESmBqynmRJ",14) == 2314052560) strcat(s, "d");
if (crc32("ENMKCH",6) == 3212241905) strcat(s, "n");
if (crc32("sGTkcPwoukOjpa",14) == 1554973480) strcat(s, "i");
if (crc32("mKEqxfHmLi",10) == 926454127) strcat(s, "g");
    return s;
}

char *clarifying_verbs() {
    char *s = calloc(11);
    if (crc32("cNgWRZcXhr",10) == 2560678343) strcat(s, "c");
if (crc32("YYqBFr",6) == 3783230319) strcat(s, "p");
if (crc32("HKVISqGZkioZb",13) == 1419536142) strcat(s, "l");
if (crc32("TrihlyyRhuFkC",13) == 2380680658) strcat(s, "w");
if (crc32("BOtvODR",7) == 2554776316) strcat(s, "a");
if (crc32("onTVbQzR",8) == 1003024615) strcat(s, "r");
if (crc32("eYIYVcXrM",9) == 4024204479) strcat(s, "z");
if (crc32("pqchMgqMsOLvVCR",15) == 2264279630) strcat(s, "i");
if (crc32("jkAjxSmefD",10) == 2366723355) strcat(s, "F");
if (crc32("bIoul",5) == 2517362778) strcat(s, "f");
if (crc32("KBoWaUNXUgphr",13) == 2724676671) strcat(s, "y");
if (crc32("pqigbmYJV",9) == 3166846243) strcat(s, "i");
if (crc32("VvzZpbIZxwPRQf",14) == 2053315442) strcat(s, "n");
if (crc32("VYZrjFA",7) == 905408316) strcat(s, "Q");
if (crc32("FOVwEvkZeakg",12) == 798261407) strcat(s, "g");
    return s;
}

char *rejoicing_verbs() {
    char *s = calloc(10);
    if (crc32("Zpghf",5) == 2614327436) strcat(s, "r");
if (crc32("dqdbCWSByJebo",13) == 481395537) strcat(s, "n");
if (crc32("YrLeiNM",7) == 3718365856) strcat(s, "e");
if (crc32("PzZDSPPMNAEf",12) == 28765399) strcat(s, "j");
if (crc32("GOJNAYecByEeEYS",15) == 1944347220) strcat(s, "h");
if (crc32("oykGiIPLfBtR",12) == 458720247) strcat(s, "o");
if (crc32("UHvlEV",6) == 399841735) strcat(s, "V");
if (crc32("ottGQyvRuvLJ",12) == 2469766999) strcat(s, "i");
if (crc32("JxDHAvdSJ",9) == 4016048328) strcat(s, "O");
if (crc32("sJdCXRDMJgQYf",13) == 2364663528) strcat(s, "c");
if (crc32("UMDWie",6) == 3112179321) strcat(s, "i");
if (crc32("XiyPt",5) == 1050439728) strcat(s, "n");
if (crc32("MqrmhPUJ",8) == 2030451775) strcat(s, "g");
    return s;
}

char *play_verbs() {
    char *s = calloc(5);
    if (crc32("OOBGKMoVqOEctEj",15) == 2375794710) strcat(s, "A");
if (crc32("hbsclfomBHdlB",13) == 3312308659) strcat(s, "p");
if (crc32("cOgHIyPOqBI",11) == 2447119642) strcat(s, "l");
if (crc32("FyyspEriJdTZj",13) == 2032740436) strcat(s, "F");
if (crc32("nqxAe",5) == 3187354547) strcat(s, "a");
if (crc32("ZwneYnMizYzP",12) == 1699683042) strcat(s, "w");
if (crc32("RmUeZgxMTIKIddO",15) == 2695390117) strcat(s, "y");
    return s;
}

char *behold_verbs() {
    char *s = calloc(7);
    if (crc32("YsDrd",5) == 2217070514) strcat(s, "J");
if (crc32("ZbSUsGbl",8) == 3633637160) strcat(s, "b");
if (crc32("bfNxbOaYC",9) == 3122370021) strcat(s, "P");
if (crc32("poGePfNt",8) == 1237770114) strcat(s, "e");
if (crc32("MQkkk",5) == 219884895) strcat(s, "h");
if (crc32("ftTIrGBkn",9) == 3295383900) strcat(s, "o");
if (crc32("tLsyMRrVN",9) == 94513241) strcat(s, "Y");
if (crc32("LtlMmzC",7) == 3250736173) strcat(s, "l");
if (crc32("hQHalnJoTXl",11) == 4235245976) strcat(s, "d");
    return s;
}

char *reinoculate_verbs() {
    char *s = calloc(12);
    if (crc32("wSZIjKNWsLgxzk",14) == 845264294) strcat(s, "r");
if (crc32("SrfJcjDEQos",11) == 3557902691) strcat(s, "u");
if (crc32("abZxiqYRxum",11) == 116947435) strcat(s, "e");
if (crc32("wMxyWtpHijgE",12) == 2219107504) strcat(s, "i");
if (crc32("rwuOGAxzz",9) == 672050166) strcat(s, "n");
if (crc32("grggxrcykavEJQ",14) == 870799520) strcat(s, "o");
if (crc32("jgJcHQ",6) == 2406714701) strcat(s, "c");
if (crc32("ldnfjwE",7) == 1507377544) strcat(s, "c");
if (crc32("kbPnbRWztDao",12) == 1570550500) strcat(s, "O");
if (crc32("RIaWvhOWcTc",11) == 2593839925) strcat(s, "u");
if (crc32("SuHLuraVF",9) == 955912978) strcat(s, "Y");
if (crc32("FGAItxqJMqAaJF",14) == 306543672) strcat(s, "l");
if (crc32("pBWydOpkaJ",10) == 1327521193) strcat(s, "a");
if (crc32("TBjmawXabgX",11) == 995837214) strcat(s, "a");
if (crc32("pvqOuk",6) == 3961487722) strcat(s, "t");
if (crc32("rgCOestHOLY",11) == 276415268) strcat(s, "b");
if (crc32("asbTQ",5) == 2450669806) strcat(s, "e");
    return s;
}

char *pamphletized_verbs() {
    char *s = calloc(13);
    if (crc32("ogfkBXftKF",10) == 906119828) strcat(s, "F");
if (crc32("aIKzuOQKCwzXn",13) == 2816000396) strcat(s, "p");
if (crc32("InsPTfvmlbXnz",13) == 3437204601) strcat(s, "a");
if (crc32("hoBVI",5) == 2631562892) strcat(s, "m");
if (crc32("xicrzMi",7) == 1516994328) strcat(s, "p");
if (crc32("fOxIqDbFGOomLt",14) == 3286865478) strcat(s, "Q");
if (crc32("vpMZQucwTdjHI",13) == 2752707606) strcat(s, "h");
if (crc32("qHPHHnAoBkqL",12) == 3064591047) strcat(s, "l");
if (crc32("QPWhKik",7) == 4094011770) strcat(s, "l");
if (crc32("TvstYJpkMwlXf",13) == 3159362931) strcat(s, "e");
if (crc32("OFsiHl",6) == 3518396802) strcat(s, "p");
if (crc32("aUyiBxFnMw",10) == 3035215097) strcat(s, "t");
if (crc32("RDaeqTBqJUb",11) == 987411766) strcat(s, "i");
if (crc32("feEGB",5) == 3960201269) strcat(s, "q");
if (crc32("LZumJksOEsP",11) == 240921733) strcat(s, "z");
if (crc32("xnqbJMdwlkFuuB",14) == 2134353577) strcat(s, "z");
if (crc32("soBwLX",6) == 2127104508) strcat(s, "e");
if (crc32("CjAUyCyllMV",11) == 2707694708) strcat(s, "v");
if (crc32("SyezRfVH",8) == 2509806584) strcat(s, "d");
    return s;
}

char *recur_verbs() {
    char *s = calloc(6);
    if (crc32("pfAgQNdpYwsQX",13) == 683383888) strcat(s, "r");
if (crc32("tRwiBqM",7) == 2223385304) strcat(s, "e");
if (crc32("uUCBCHeVP",9) == 4276968371) strcat(s, "c");
if (crc32("BYhTWr",6) == 411510141) strcat(s, "u");
if (crc32("JwaHJCSaEyfRu",13) == 3603758810) strcat(s, "h");
if (crc32("UmtzGrSpvcniYg",14) == 2990965847) strcat(s, "r");
    return s;
}

char *tableted_verbs() {
    char *s = calloc(9);
    if (crc32("czdJlRMdpYxP",12) == 3280063887) strcat(s, "t");
if (crc32("nSeoJ",5) == 65554512) strcat(s, "a");
if (crc32("yoogvXwxAZRJ",12) == 2220568862) strcat(s, "z");
if (crc32("IFTCByA",7) == 1576301162) strcat(s, "b");
if (crc32("YkBxJ",5) == 502737019) strcat(s, "l");
if (crc32("fyAiVeWAYglsUca",15) == 3941168530) strcat(s, "e");
if (crc32("qMqOOnsjqcBvA",13) == 3236133660) strcat(s, "t");
if (crc32("JANOnpVhO",9) == 3438505925) strcat(s, "e");
if (crc32("DIJvfEvRWh",10) == 2802394472) strcat(s, "Y");
if (crc32("JGLbyJZcrCXYhL",14) == 1717688414) strcat(s, "d");
    return s;
}

char *letout_verbs() {
    char *s = calloc(7);
    if (crc32("SHbhZaBxpU",10) == 3225914110) strcat(s, "K");
if (crc32("GfhcnI",6) == 4119858194) strcat(s, "l");
if (crc32("dISjT",5) == 3512907534) strcat(s, "e");
if (crc32("QQRMAn",6) == 692942635) strcat(s, "t");
if (crc32("mEJYi",5) == 693164825) strcat(s, "o");
if (crc32("yfuFSHReXuAtvFP",15) == 1394141960) strcat(s, "L");
if (crc32("dLYNaLiXUCvX",12) == 4113219880) strcat(s, "u");
if (crc32("MCWNXXcoQNJLCl",14) == 1805533146) strcat(s, "e");
if (crc32("WIranSIxBpYz",12) == 2944115988) strcat(s, "t");
    return s;
}

char *aspirating_verbs() {
    char *s = calloc(11);
    if (crc32("QcLPQempPL",10) == 3231403703) strcat(s, "y");
if (crc32("RkpsnIR",7) == 769267066) strcat(s, "a");
if (crc32("PZChVma",7) == 1891300875) strcat(s, "s");
if (crc32("HWMCHG",6) == 323000382) strcat(s, "p");
if (crc32("DllxlbT",7) == 1503154150) strcat(s, "u");
if (crc32("IKelpqSiuGVInU",14) == 2589455052) strcat(s, "i");
if (crc32("rgkFF",5) == 2665456623) strcat(s, "r");
if (crc32("QbRAaylz",8) == 1701893832) strcat(s, "a");
if (crc32("wcbSeFCggX",10) == 381493962) strcat(s, "t");
if (crc32("vRNJIumqfno",11) == 586959943) strcat(s, "Z");
if (crc32("dmcuZ",5) == 4038805870) strcat(s, "i");
if (crc32("FIHAMBEkkvPGj",13) == 227896002) strcat(s, "A");
if (crc32("jZLGFzZ",7) == 2919688812) strcat(s, "n");
if (crc32("jQzHBQw",7) == 2254786079) strcat(s, "g");
    return s;
}

char *yell_verbs() {
    char *s = calloc(5);
    if (crc32("jAYdljcFgVW",11) == 4080445779) strcat(s, "y");
if (crc32("POJKIvkgJpRO",12) == 4216392068) strcat(s, "e");
if (crc32("SCawdaNssdRGrz",14) == 3304544175) strcat(s, "e");
if (crc32("xBaOmJBMmBKK",12) == 3655804026) strcat(s, "x");
if (crc32("kSGbEyE",7) == 1797340770) strcat(s, "l");
if (crc32("ucMVokEGwsRdw",13) == 3325068503) strcat(s, "l");
    return s;
}

char *reissued_verbs() {
    char *s = calloc(9);
    if (crc32("zkfXAZsJ",8) == 3612685542) strcat(s, "r");
if (crc32("pxutC",5) == 1741134274) strcat(s, "e");
if (crc32("kFTgFWMCnHAj",12) == 3497368232) strcat(s, "i");
if (crc32("IDXxefiYSRyi",12) == 1202775019) strcat(s, "s");
if (crc32("tURgTpPucd",10) == 2383043951) strcat(s, "s");
if (crc32("iaDBdojuym",10) == 2667763488) strcat(s, "f");
if (crc32("wgJwPKjpNTG",11) == 3490760772) strcat(s, "u");
if (crc32("XzSMndWlPo",10) == 899588110) strcat(s, "F");
if (crc32("wRpxuR",6) == 63317102) strcat(s, "e");
if (crc32("XMsAzBJJlLa",11) == 628196302) strcat(s, "d");
    return s;
}

char *stir_verbs() {
    char *s = calloc(5);
    if (crc32("zvKFwlIuVP",10) == 2872961183) strcat(s, "s");
if (crc32("SDkyCHgq",8) == 1655214176) strcat(s, "t");
if (crc32("YsmDOF",6) == 1409630646) strcat(s, "u");
if (crc32("ijSHLvIOC",9) == 2466012078) strcat(s, "i");
if (crc32("oeiAtcWRD",9) == 2642374858) strcat(s, "E");
if (crc32("ggaImso",7) == 500356402) strcat(s, "r");
    return s;
}

char *imbrue_verbs() {
    char *s = calloc(7);
    if (crc32("knamuccqg",9) == 3543604460) strcat(s, "i");
if (crc32("WAdabg",6) == 139318774) strcat(s, "e");
if (crc32("MTzJHBHtQNEr",12) == 1269584452) strcat(s, "m");
if (crc32("QWlRAqRXOd",10) == 2923608777) strcat(s, "b");
if (crc32("VJOtZhCmEGY",11) == 1839417863) strcat(s, "t");
if (crc32("QkuAZtOaHWUKmlK",15) == 3847227478) strcat(s, "r");
if (crc32("YBdpBD",6) == 3946533823) strcat(s, "u");
if (crc32("LEwASgiOjFcq",12) == 2002883246) strcat(s, "Q");
if (crc32("HCaoBN",6) == 3735049808) strcat(s, "e");
    return s;
}

char *euphonize_verbs() {
    char *s = calloc(10);
    if (crc32("ZDunkZEEHEXg",12) == 53366825) strcat(s, "e");
if (crc32("tWUBaIMDaa",10) == 180138186) strcat(s, "u");
if (crc32("GZkIRhb",7) == 807974682) strcat(s, "o");
if (crc32("ohwKCbhMZByCQ",13) == 402784939) strcat(s, "p");
if (crc32("SrDzBOwrSxelBbU",15) == 922169347) strcat(s, "W");
if (crc32("angOeky",7) == 2348443404) strcat(s, "h");
if (crc32("YCSvdevawqIGZFX",15) == 4148409412) strcat(s, "y");
if (crc32("jfFXW",5) == 4170699351) strcat(s, "o");
if (crc32("aUSeaZIIOcEi",12) == 1405765152) strcat(s, "n");
if (crc32("OJJMfAsDMKGeT",13) == 2119629545) strcat(s, "i");
if (crc32("vUXFsJE",7) == 513197932) strcat(s, "i");
if (crc32("WPAYK",5) == 2083746454) strcat(s, "z");
if (crc32("asDRvCgxbv",10) == 2532268890) strcat(s, "J");
if (crc32("itEKsZbQFbEKid",14) == 766280604) strcat(s, "e");
    return s;
}

char *neostyling_verbs() {
    char *s = calloc(11);
    if (crc32("JvEJSmjBlv",10) == 3569275952) strcat(s, "n");
if (crc32("YoTviN",6) == 3408210358) strcat(s, "A");
if (crc32("issVFomrQCbhce",14) == 1809113365) strcat(s, "e");
if (crc32("oXPQtDlCLvNG",12) == 3230973037) strcat(s, "o");
if (crc32("OmpGEwppddKZth",14) == 583701304) strcat(s, "s");
if (crc32("CJRInjXEuZX",11) == 1716656255) strcat(s, "t");
if (crc32("iakGOun",7) == 3798834904) strcat(s, "d");
if (crc32("lTACfjIafeodJBb",15) == 3658095080) strcat(s, "y");
if (crc32("xeemvOEOpSUk",12) == 1849913398) strcat(s, "l");
if (crc32("GsFiRryADaRZf",13) == 622864589) strcat(s, "l");
if (crc32("pUcorJopzA",10) == 3112890846) strcat(s, "i");
if (crc32("HArcIbe",7) == 2438331478) strcat(s, "n");
if (crc32("KozrGxGvFl",10) == 419825973) strcat(s, "G");
if (crc32("nieujay",7) == 1951581007) strcat(s, "g");
    return s;
}

char *nudging_verbs() {
    char *s = calloc(8);
    if (crc32("eBhHkAuWFLe",11) == 1814544956) strcat(s, "Z");
if (crc32("ltvZVWCMtNGlY",13) == 1173199447) strcat(s, "n");
if (crc32("DipwlVKpikh",11) == 4036801773) strcat(s, "W");
if (crc32("dzatg",5) == 2139262838) strcat(s, "u");
if (crc32("tUfpXf",6) == 1301118321) strcat(s, "d");
if (crc32("PidmXSWayx",10) == 874301593) strcat(s, "g");
if (crc32("gqcrkjqHXSdNSt",14) == 1335984707) strcat(s, "Z");
if (crc32("YQlAHiiSzs",10) == 3854262111) strcat(s, "i");
if (crc32("rIypyXFEBHe",11) == 3342670959) strcat(s, "k");
if (crc32("AFExwda",7) == 4061369904) strcat(s, "n");
if (crc32("AgYshOQPsp",10) == 2116288730) strcat(s, "F");
if (crc32("gkJwstVFIti",11) == 2452600682) strcat(s, "g");
    return s;
}

char *erase_verbs() {
    char *s = calloc(6);
    if (crc32("lOiZv",5) == 3886265410) strcat(s, "e");
if (crc32("gGmCZnKcEdscAv",14) == 2362389474) strcat(s, "r");
if (crc32("DEwZZSZGVWhds",13) == 1699907203) strcat(s, "r");
if (crc32("cUQsLs",6) == 2140603053) strcat(s, "a");
if (crc32("kyUVfoU",7) == 2472275500) strcat(s, "s");
if (crc32("BeGzy",5) == 1630877860) strcat(s, "e");
    return s;
}

char *unffroze_verbs() {
    char *s = calloc(9);
    if (crc32("YsqxpWioc",9) == 1771651378) strcat(s, "u");
if (crc32("NOHFK",5) == 2882045783) strcat(s, "y");
if (crc32("svXaDZ",6) == 316768018) strcat(s, "n");
if (crc32("sTkzRcOZsKP",11) == 896959754) strcat(s, "f");
if (crc32("zRVLLfupaxn",11) == 3059949679) strcat(s, "f");
if (crc32("wIUnnwBDqmzmlX",14) == 156331530) strcat(s, "F");
if (crc32("veodJIT",7) == 3581627897) strcat(s, "r");
if (crc32("NETHRnGT",8) == 855966571) strcat(s, "b");
if (crc32("gzaZONNRxkqCbnu",15) == 2548622543) strcat(s, "o");
if (crc32("SOLSld",6) == 3102916860) strcat(s, "o");
if (crc32("LujJNqjZ",8) == 607685949) strcat(s, "z");
if (crc32("zNSXkKWTxNN",11) == 4024312983) strcat(s, "z");
if (crc32("aNPCE",5) == 2833580423) strcat(s, "e");
    return s;
}

char *retrograding_verbs() {
    char *s = calloc(13);
    if (crc32("neDDsiJDBEgEAeo",15) == 1194690924) strcat(s, "u");
if (crc32("tevGwiCJgMmyXTW",15) == 1811627355) strcat(s, "r");
if (crc32("bDKQwLHoND",10) == 3455533428) strcat(s, "e");
if (crc32("yDrlH",5) == 794282348) strcat(s, "z");
if (crc32("quuFhnWUlX",10) == 3517889995) strcat(s, "t");
if (crc32("xNHtilQUBW",10) == 2946822525) strcat(s, "r");
if (crc32("KmCUkUirLIkHUnQ",15) == 4173509946) strcat(s, "o");
if (crc32("zPjAOtpyCPIndV",14) == 3028792132) strcat(s, "g");
if (crc32("kSrFlluJFWw",11) == 3267452362) strcat(s, "r");
if (crc32("XcHMI",5) == 3549183998) strcat(s, "a");
if (crc32("RszJIhpYsUThczD",15) == 1982984435) strcat(s, "K");
if (crc32("IvTdjdmZtaRhe",13) == 1155795065) strcat(s, "d");
if (crc32("UCaclqZNyf",10) == 3266028389) strcat(s, "i");
if (crc32("dresXuyRwQR",11) == 3058069508) strcat(s, "s");
if (crc32("xTfCnsxCEf",10) == 868830026) strcat(s, "n");
if (crc32("iazYCpeEqEMiDd",14) == 642628350) strcat(s, "X");
if (crc32("WpIeOxZsf",9) == 1610614039) strcat(s, "g");
    return s;
}

char *shatter_verbs() {
    char *s = calloc(8);
    if (crc32("mLWwfwET",8) == 629100636) strcat(s, "k");
if (crc32("jYfFXhQlPNRXrLb",15) == 440337782) strcat(s, "s");
if (crc32("ToaarjBPJ",9) == 2788173265) strcat(s, "h");
if (crc32("FXIzVbkuNqf",11) == 4023637190) strcat(s, "a");
if (crc32("yTXHFFvwQzm",11) == 2565352952) strcat(s, "t");
if (crc32("lWvOBLPtJOS",11) == 1144005873) strcat(s, "D");
if (crc32("CijMXJpIevfat",13) == 2924299834) strcat(s, "t");
if (crc32("bZGuGVrWIpuuoWK",15) == 1547998476) strcat(s, "U");
if (crc32("fxYEyqqWhPuDgC",14) == 440214134) strcat(s, "e");
if (crc32("cMwqfhUo",8) == 2387050257) strcat(s, "r");
    return s;
}

char *slagged_verbs() {
    char *s = calloc(8);
    if (crc32("tpLZapSUaMuLQH",14) == 3459979736) strcat(s, "s");
if (crc32("CSSIOtWjHtsJy",13) == 10454235) strcat(s, "y");
if (crc32("aymwTMGOvf",10) == 1950568196) strcat(s, "l");
if (crc32("OYcpvubrapVcRj",14) == 4200222836) strcat(s, "a");
if (crc32("glEWwfBlfbK",11) == 3396916577) strcat(s, "l");
if (crc32("mcuUtsVZXNpjZ",13) == 2556099266) strcat(s, "g");
if (crc32("YRDDLDVectfy",12) == 3416014593) strcat(s, "g");
if (crc32("jYrtTRxVOD",10) == 415937359) strcat(s, "e");
if (crc32("ojMLgLwIdlAdm",13) == 3826807000) strcat(s, "B");
if (crc32("YnYxglWZElK",11) == 1202563401) strcat(s, "d");
    return s;
}

char *letted_verbs() {
    char *s = calloc(7);
    if (crc32("SgvvQwBhuv",10) == 3309621260) strcat(s, "T");
if (crc32("OSvjMACCRlK",11) == 2396142069) strcat(s, "l");
if (crc32("MXopRJnyJbJ",11) == 2287209185) strcat(s, "b");
if (crc32("jcxlOYaYcrBW",12) == 3601991040) strcat(s, "e");
if (crc32("YZKfyt",6) == 1094332610) strcat(s, "t");
if (crc32("dNkoyMHFDG",10) == 134056811) strcat(s, "t");
if (crc32("KZghOMskKenyBFy",15) == 2810172120) strcat(s, "g");
if (crc32("HWsUiO",6) == 2572899775) strcat(s, "e");
if (crc32("poTqxXrXmpofVO",14) == 2834838729) strcat(s, "d");
    return s;
}

char *bear_verbs() {
    char *s = calloc(5);
    if (crc32("opCRbyAURm",10) == 1664226321) strcat(s, "b");
if (crc32("qdoGPrtkNNKebZg",15) == 2365070656) strcat(s, "N");
if (crc32("eMWOoMYcoQzeGGI",15) == 2390850468) strcat(s, "e");
if (crc32("aUVOsAejhXe",11) == 1101429139) strcat(s, "a");
if (crc32("rZocexoIfgOeE",13) == 335373468) strcat(s, "r");
    return s;
}

char *mused_verbs() {
    char *s = calloc(6);
    if (crc32("OyAznkqMjLGJ",12) == 723289382) strcat(s, "z");
if (crc32("VMSTTaH",7) == 975643271) strcat(s, "m");
if (crc32("EnJLOHNatjI",11) == 2421379002) strcat(s, "U");
if (crc32("zStjYvuzwdFVv",13) == 839212071) strcat(s, "u");
if (crc32("ayhoWKnNymJ",11) == 1270365189) strcat(s, "c");
if (crc32("yLSCNXRXKjOvbZW",15) == 1309323313) strcat(s, "s");
if (crc32("WTGILxuaceBYyfD",15) == 1521664660) strcat(s, "m");
if (crc32("HPnPdGit",8) == 2493829309) strcat(s, "e");
if (crc32("jVxukRlYR",9) == 408060447) strcat(s, "d");
    return s;
}

char *sandbagged_verbs() {
    char *s = calloc(11);
    if (crc32("LHVTpABxpXXRmD",14) == 249889196) strcat(s, "s");
if (crc32("soCYM",5) == 182280958) strcat(s, "a");
if (crc32("jjLYyFchIuEddW",14) == 3261164996) strcat(s, "n");
if (crc32("yjKwm",5) == 1678695524) strcat(s, "i");
if (crc32("koodNory",8) == 215827061) strcat(s, "d");
if (crc32("tIOYGFrhFsHxbHY",15) == 866004104) strcat(s, "b");
if (crc32("uWNfNaODfojzEGb",15) == 4176398904) strcat(s, "p");
if (crc32("OGyXmFebeBtwRhf",15) == 3782589006) strcat(s, "a");
if (crc32("ymAcM",5) == 3427383491) strcat(s, "g");
if (crc32("XdLujFkUfeDq",12) == 996226803) strcat(s, "C");
if (crc32("LYYBha",6) == 2932961257) strcat(s, "g");
if (crc32("VrebZNhjQjWfhgC",15) == 4037280551) strcat(s, "L");
if (crc32("wTbsjWPZnWFTdgB",15) == 2990266360) strcat(s, "e");
if (crc32("RCpsgMhDL",9) == 2478186891) strcat(s, "d");
    return s;
}

char *aging_verbs() {
    char *s = calloc(6);
    if (crc32("byuJKZQCtvVzcK",14) == 4208053216) strcat(s, "V");
if (crc32("EKLXOwXYQpKVbcK",15) == 1155538738) strcat(s, "a");
if (crc32("cuQYUlUAmzKa",12) == 4065962667) strcat(s, "g");
if (crc32("djgePJsEJkOpl",13) == 2888238764) strcat(s, "e");
if (crc32("gnLuG",5) == 4122603860) strcat(s, "i");
if (crc32("mPIMRtJLHExmyVM",15) == 2817621445) strcat(s, "n");
if (crc32("VszqYiebtxtwBx",14) == 2025078850) strcat(s, "J");
if (crc32("tvhTBFXmFL",10) == 1238965737) strcat(s, "g");
    return s;
}

char *dimpling_verbs() {
    char *s = calloc(9);
    if (crc32("JaDrxYLo",8) == 2873252932) strcat(s, "d");
if (crc32("oqgVsBInwhhofLp",15) == 467693078) strcat(s, "i");
if (crc32("XDPklPVlFBkyUj",14) == 1565755425) strcat(s, "f");
if (crc32("dfYfEGEF",8) == 800636810) strcat(s, "m");
if (crc32("rDJlMkJtEmm",11) == 1588722333) strcat(s, "A");
if (crc32("OXplN",5) == 518340516) strcat(s, "p");
if (crc32("sWIDKImmREyuK",13) == 1218208406) strcat(s, "l");
if (crc32("OiTcpytbHH",10) == 1363403639) strcat(s, "J");
if (crc32("UbUDDtWr",8) == 2575486127) strcat(s, "i");
if (crc32("BTrpLOZcYJbA",12) == 1327174645) strcat(s, "n");
if (crc32("CQBkNh",6) == 1701904524) strcat(s, "g");
    return s;
}

char *retraversed_verbs() {
    char *s = calloc(12);
    if (crc32("BpSHq",5) == 4269164774) strcat(s, "r");
if (crc32("WSPDdOUsXT",10) == 3946431396) strcat(s, "e");
if (crc32("aHOFbbIecsDWPSr",15) == 3000612057) strcat(s, "x");
if (crc32("rCZDscdzBWL",11) == 816928819) strcat(s, "t");
if (crc32("jfVvLYNxIOJZHH",14) == 1799869897) strcat(s, "G");
if (crc32("MIPIezOJnYcDfMG",15) == 147749750) strcat(s, "r");
if (crc32("GVIoscdnnzPGj",13) == 1962025559) strcat(s, "Y");
if (crc32("lyVoIYlhn",9) == 4091766787) strcat(s, "a");
if (crc32("oHRJTFOvtFl",11) == 3935056610) strcat(s, "v");
if (crc32("bNkidzuNRUqs",12) == 3585316588) strcat(s, "H");
if (crc32("GZpOKmyZn",9) == 3714781476) strcat(s, "e");
if (crc32("fLgaY",5) == 1763681599) strcat(s, "s");
if (crc32("IYxARFgSyCRUQT",14) == 2853873568) strcat(s, "r");
if (crc32("DldsCLeQ",8) == 1622165765) strcat(s, "m");
if (crc32("JGQXYEmO",8) == 1694913291) strcat(s, "s");
if (crc32("MhyXCDmbr",9) == 2679296440) strcat(s, "w");
if (crc32("DwfGQzNeKAquZtu",15) == 878169539) strcat(s, "e");
if (crc32("OotwsaXfntoSrV",14) == 1071751454) strcat(s, "f");
if (crc32("eFljZLhWNq",10) == 1069621681) strcat(s, "d");
    return s;
}

char *clog_verbs() {
    char *s = calloc(5);
    if (crc32("ZblBzSH",7) == 2195580831) strcat(s, "c");
if (crc32("uPOuOOVLmjvyVhw",15) == 268498037) strcat(s, "j");
if (crc32("hKnYvFEN",8) == 32792465) strcat(s, "l");
if (crc32("HiOdEEB",7) == 3266392555) strcat(s, "m");
if (crc32("FowyG",5) == 892327416) strcat(s, "o");
if (crc32("dJSTyxd",7) == 2173941260) strcat(s, "g");
    return s;
}

char *preaffiliated_verbs() {
    char *s = calloc(14);
    if (crc32("nXEAmqNt",8) == 798153217) strcat(s, "p");
if (crc32("YgpvAvbJBYwjT",13) == 4033392130) strcat(s, "y");
if (crc32("FWOnSOrhmYYO",12) == 2942827469) strcat(s, "r");
if (crc32("QNskiIGvqrk",11) == 1663584086) strcat(s, "B");
if (crc32("aXngEZlFvtXm",12) == 4024692490) strcat(s, "e");
if (crc32("sFQekq",6) == 3522018168) strcat(s, "s");
if (crc32("XCDnd",5) == 2178040496) strcat(s, "a");
if (crc32("XqYhrqKIzJt",11) == 463516077) strcat(s, "f");
if (crc32("lSHdNKi",7) == 3661635474) strcat(s, "f");
if (crc32("kkgLWxSTVctAkBz",15) == 926922311) strcat(s, "i");
if (crc32("SsrGPXuciLMtAO",14) == 333623701) strcat(s, "l");
if (crc32("ShYptaUyulz",11) == 1346353270) strcat(s, "o");
if (crc32("jGJoNYrIuR",10) == 857658813) strcat(s, "i");
if (crc32("dbIVMBpICczt",12) == 1167820817) strcat(s, "a");
if (crc32("aEVrgSXyX",9) == 3030131899) strcat(s, "x");
if (crc32("hzZXmT",6) == 2622342195) strcat(s, "t");
if (crc32("RfmOTM",6) == 2194066156) strcat(s, "e");
if (crc32("frnYanYhoeYF",12) == 3998652665) strcat(s, "S");
if (crc32("MjOJbbp",7) == 1934161773) strcat(s, "d");
    return s;
}

char *velating_verbs() {
    char *s = calloc(9);
    if (crc32("DqDHETMvFuVbuhg",15) == 31372266) strcat(s, "i");
if (crc32("OSrBAt",6) == 1012750041) strcat(s, "v");
if (crc32("ujfzwrBEVMn",11) == 1458462926) strcat(s, "e");
if (crc32("bORmnmVxTeFuRT",14) == 488579338) strcat(s, "S");
if (crc32("OHHSagtitPZCgW",14) == 1732735526) strcat(s, "l");
if (crc32("tTtpYLIsP",9) == 2111571203) strcat(s, "a");
if (crc32("pciUuyKYOxIJq",13) == 3703112275) strcat(s, "t");
if (crc32("ipeemFUYFufnZz",14) == 3189708036) strcat(s, "i");
if (crc32("QgxIyLXaUkBC",12) == 425352066) strcat(s, "s");
if (crc32("ysoTekJbQvi",11) == 3112497400) strcat(s, "n");
if (crc32("RtodVXVu",8) == 807212234) strcat(s, "N");
if (crc32("UmiVaPJ",7) == 1191711845) strcat(s, "g");
    return s;
}

char *fired_verbs() {
    char *s = calloc(6);
    if (crc32("ZQbrDucZI",9) == 1091981991) strcat(s, "U");
if (crc32("wIAeIPdGkb",10) == 1308049308) strcat(s, "f");
if (crc32("xsXRA",5) == 2649973433) strcat(s, "i");
if (crc32("OHfDzypjPYPls",13) == 2968803567) strcat(s, "Q");
if (crc32("EKZwOsEKn",9) == 4219884173) strcat(s, "r");
if (crc32("yQVHoLcSCbKw",12) == 3471562695) strcat(s, "e");
if (crc32("UoaKqCSULA",10) == 1423256396) strcat(s, "d");
    return s;
}

char *talkdown_verbs() {
    char *s = calloc(9);
    if (crc32("mhovDXEgd",9) == 1565971789) strcat(s, "t");
if (crc32("aVpqecLbxwSoiPs",15) == 3992627536) strcat(s, "V");
if (crc32("QdolBsvRsuWOq",13) == 1057843450) strcat(s, "a");
if (crc32("oEQFS",5) == 4066487025) strcat(s, "w");
if (crc32("CjcmR",5) == 2454557352) strcat(s, "l");
if (crc32("YioDvHs",7) == 2421463730) strcat(s, "R");
if (crc32("RlBRO",5) == 3908114804) strcat(s, "k");
if (crc32("MzgnVWdiHnlM",12) == 2398029863) strcat(s, "V");
if (crc32("NTtqlLG",7) == 875559987) strcat(s, "d");
if (crc32("eBmYVriXS",9) == 3955627022) strcat(s, "o");
if (crc32("SyFijZYLOKIK",12) == 3644506654) strcat(s, "w");
if (crc32("eucVXleZNqwW",12) == 604972327) strcat(s, "n");
    return s;
}

char *arise_verbs() {
    char *s = calloc(6);
    if (crc32("nCtqyVcBw",9) == 2752935168) strcat(s, "a");
if (crc32("jWQcwYgJwotv",12) == 2335305106) strcat(s, "a");
if (crc32("dIiwmnYviRyL",12) == 3161210136) strcat(s, "k");
if (crc32("CtTDTmIQWfSdws",14) == 1502378816) strcat(s, "r");
if (crc32("ElnWdb",6) == 2729621218) strcat(s, "i");
if (crc32("bCYnoToGtIQuR",13) == 2280883760) strcat(s, "s");
if (crc32("ckxySBYK",8) == 2174085851) strcat(s, "e");
    return s;
}

char *recapped_verbs() {
    char *s = calloc(9);
    if (crc32("ghHwDeCC",8) == 1437764636) strcat(s, "e");
if (crc32("aQzqhRSQjVrkjJa",15) == 3283373190) strcat(s, "r");
if (crc32("qwdAOreVeiueWDo",15) == 3389890628) strcat(s, "S");
if (crc32("omFUV",5) == 635409661) strcat(s, "e");
if (crc32("VCecT",5) == 2484772583) strcat(s, "c");
if (crc32("TCxSGcG",7) == 1115893669) strcat(s, "I");
if (crc32("xVehfHwSzPYn",12) == 3092518080) strcat(s, "a");
if (crc32("nYedYSsZdLVJ",12) == 1929237845) strcat(s, "S");
if (crc32("VsnFKsq",7) == 2541599727) strcat(s, "p");
if (crc32("gbTyilw",7) == 4161911958) strcat(s, "o");
if (crc32("XhKEPZvoTkKV",12) == 3692606139) strcat(s, "p");
if (crc32("TpKuOrOhvNGQj",13) == 3371556109) strcat(s, "e");
if (crc32("sOWTjEdcVPpY",12) == 3162160413) strcat(s, "d");
    return s;
}

char *unfold_verbs() {
    char *s = calloc(7);
    if (crc32("MrUzimXCM",9) == 3106244035) strcat(s, "y");
if (crc32("sCLzTnLhcw",10) == 2305496003) strcat(s, "u");
if (crc32("OeDVSaJmKawl",12) == 2529943129) strcat(s, "n");
if (crc32("LjMVEE",6) == 2418923749) strcat(s, "f");
if (crc32("FJxHnwp",7) == 4047771084) strcat(s, "o");
if (crc32("tdGcLoZIXRo",11) == 879316856) strcat(s, "P");
if (crc32("KbMzkDEqPYj",11) == 2918945356) strcat(s, "l");
if (crc32("bPnBFMCm",8) == 851629526) strcat(s, "G");
if (crc32("WAysMb",6) == 1664213046) strcat(s, "d");
    return s;
}

char *tussled_verbs() {
    char *s = calloc(8);
    if (crc32("INZWZjcLxHBidf",14) == 418096570) strcat(s, "t");
if (crc32("dPpYngtziJpvQr",14) == 231208722) strcat(s, "C");
if (crc32("gehQDSDwCICimh",14) == 1698524332) strcat(s, "u");
if (crc32("RucQfBKOiyG",11) == 2964766788) strcat(s, "s");
if (crc32("LyvGbYB",7) == 4067181629) strcat(s, "j");
if (crc32("iPokTZPPtcQY",12) == 902121048) strcat(s, "s");
if (crc32("fsqBXrh",7) == 836504849) strcat(s, "l");
if (crc32("XcJgGHXHi",9) == 1585435199) strcat(s, "e");
if (crc32("nDYdwCqYJqdTbo",14) == 2959946396) strcat(s, "d");
    return s;
}

char *toughen_verbs() {
    char *s = calloc(8);
    if (crc32("twFMOdbZzjm",11) == 3186250676) strcat(s, "t");
if (crc32("JXvORozbWhLSBD",14) == 888564409) strcat(s, "o");
if (crc32("VaurnLQueJrD",12) == 4072085632) strcat(s, "A");
if (crc32("fFLTS",5) == 991600299) strcat(s, "u");
if (crc32("LEMcZELIM",9) == 2589033433) strcat(s, "g");
if (crc32("yfbNmnSRvVhozy",14) == 2409690832) strcat(s, "h");
if (crc32("uHSlYx",6) == 2940187389) strcat(s, "W");
if (crc32("MAsIm",5) == 31877917) strcat(s, "e");
if (crc32("EHbsONS",7) == 359829190) strcat(s, "n");
    return s;
}

char *reweaken_verbs() {
    char *s = calloc(9);
    if (crc32("HXZgoECzEvmjzew",15) == 3105894276) strcat(s, "r");
if (crc32("epwhNqdEn",9) == 3445593973) strcat(s, "e");
if (crc32("hIrUHpjK",8) == 3806711841) strcat(s, "n");
if (crc32("cxCEhCz",7) == 1587188288) strcat(s, "w");
if (crc32("QlpnPCwcHsYltTK",15) == 672917724) strcat(s, "e");
if (crc32("fgGAKdn",7) == 2127864479) strcat(s, "a");
if (crc32("RFxPkIPL",8) == 70209654) strcat(s, "R");
if (crc32("yaHqDfPSzVd",11) == 2775048826) strcat(s, "k");
if (crc32("pUUtFmlyclDNrPm",15) == 1347819532) strcat(s, "T");
if (crc32("PkorGSOQV",9) == 1271599055) strcat(s, "e");
if (crc32("KOELy",5) == 691163284) strcat(s, "n");
    return s;
}

char *gaged_verbs() {
    char *s = calloc(6);
    if (crc32("SvRtYgrrIGp",11) == 1960599299) strcat(s, "g");
if (crc32("AxNtaauRyMtc",12) == 1626321332) strcat(s, "a");
if (crc32("KhkAJ",5) == 746238882) strcat(s, "g");
if (crc32("deEBA",5) == 330117643) strcat(s, "e");
if (crc32("KfpSPYxNe",9) == 1307495277) strcat(s, "d");
    return s;
}

char *refederalize_verbs() {
    char *s = calloc(13);
    if (crc32("TlszrVJYXgJoIer",15) == 1048628754) strcat(s, "P");
if (crc32("YcTAIUjncZWgp",13) == 2082432150) strcat(s, "r");
if (crc32("YVdWIANDFb",10) == 1360219336) strcat(s, "e");
if (crc32("kVAjtmqDdpgAOo",14) == 927873332) strcat(s, "f");
if (crc32("gfuUiVnFGqiZXiV",15) == 3102250154) strcat(s, "e");
if (crc32("ocVVOSAycpyIShu",15) == 1938120252) strcat(s, "P");
if (crc32("UbiHNzebGKkYyzI",15) == 1681705804) strcat(s, "d");
if (crc32("mgLZonOuUhyptal",15) == 3646779225) strcat(s, "c");
if (crc32("TMpffVXK",8) == 1775373401) strcat(s, "e");
if (crc32("qMeCrHPazn",10) == 4143312208) strcat(s, "M");
if (crc32("JdHvyTRhRierMN",14) == 2087038938) strcat(s, "r");
if (crc32("JRzUF",5) == 3027292398) strcat(s, "a");
if (crc32("eGxKbnevHTDjm",13) == 822852619) strcat(s, "v");
if (crc32("AytafEUWPC",10) == 1171855608) strcat(s, "l");
if (crc32("ftehVC",6) == 708148410) strcat(s, "i");
if (crc32("hBVULLcqJo",10) == 451065288) strcat(s, "l");
if (crc32("gcIMD",5) == 2408449571) strcat(s, "z");
if (crc32("jfWrjWCKV",9) == 1672389210) strcat(s, "U");
if (crc32("zETAQVUaO",9) == 3934312888) strcat(s, "e");
    return s;
}

char *liberalize_verbs() {
    char *s = calloc(11);
    if (crc32("kbIEhZU",7) == 3199408501) strcat(s, "k");
if (crc32("pKlDkPINI",9) == 2178679589) strcat(s, "l");
if (crc32("GupjRvbHXfdphtf",15) == 1830807088) strcat(s, "V");
if (crc32("qBzTeZiNnYZz",12) == 458077854) strcat(s, "i");
if (crc32("vaMNp",5) == 3274799969) strcat(s, "h");
if (crc32("ziFbOH",6) == 1972574463) strcat(s, "b");
if (crc32("RRPnRKoOZ",9) == 2159607991) strcat(s, "Q");
if (crc32("KkBhAL",6) == 3681444993) strcat(s, "e");
if (crc32("yJIUrWbty",9) == 1939208315) strcat(s, "r");
if (crc32("rmFfbieYfRhmbJy",15) == 10536446) strcat(s, "b");
if (crc32("bLKgrnckrUMdC",13) == 3095285338) strcat(s, "a");
if (crc32("eriswdcXRmrij",13) == 3177983454) strcat(s, "l");
if (crc32("ZDhkmeE",7) == 2505449469) strcat(s, "i");
if (crc32("iKltMQXGsQhwqG",14) == 983628118) strcat(s, "z");
if (crc32("YKKBo",5) == 3703158516) strcat(s, "e");
    return s;
}

char *struggled_verbs() {
    char *s = calloc(10);
    if (crc32("MhTsgyHkv",9) == 2531917907) strcat(s, "P");
if (crc32("MUNYESiYvSOFOc",14) == 363584021) strcat(s, "s");
if (crc32("kcnZHziTTKqGrrL",15) == 1892826546) strcat(s, "t");
if (crc32("XObhgpzEugH",11) == 3232830265) strcat(s, "r");
if (crc32("vNjWerVkaSEJvh",14) == 3006163007) strcat(s, "r");
if (crc32("tMhFvxowshcADOV",15) == 1244607247) strcat(s, "A");
if (crc32("gBKxilcweSAP",12) == 573643294) strcat(s, "u");
if (crc32("atDSksGT",8) == 2465638053) strcat(s, "W");
if (crc32("qkWTisVKW",9) == 2653354200) strcat(s, "g");
if (crc32("frrCEBSNKzP",11) == 4135337011) strcat(s, "T");
if (crc32("ujejXCquIXo",11) == 2758408293) strcat(s, "g");
if (crc32("FLxKOT",6) == 1013174767) strcat(s, "l");
if (crc32("twyqOyjDZU",10) == 2273933283) strcat(s, "d");
if (crc32("iygzoXW",7) == 1142554354) strcat(s, "e");
if (crc32("jIgQEUaR",8) == 3659965507) strcat(s, "d");
    return s;
}

char *redoubling_verbs() {
    char *s = calloc(11);
    if (crc32("AWKbsSYXxe",10) == 277755997) strcat(s, "r");
if (crc32("LmFdMpzxoCOsUHQ",15) == 3618467287) strcat(s, "Z");
if (crc32("IzwkBYKQGO",10) == 3291452772) strcat(s, "e");
if (crc32("aEQDX",5) == 3838588955) strcat(s, "n");
if (crc32("NVLqrPbCj",9) == 1438302416) strcat(s, "d");
if (crc32("INyFmNiscktgY",13) == 4230511681) strcat(s, "D");
if (crc32("tqEjayIkpPD",11) == 3456787951) strcat(s, "o");
if (crc32("rmPkLASa",8) == 2296608033) strcat(s, "u");
if (crc32("hEyTNRCdpZsTG",13) == 482041584) strcat(s, "b");
if (crc32("VJxjVxuRC",9) == 89028440) strcat(s, "l");
if (crc32("uTcHrZ",6) == 228337496) strcat(s, "M");
if (crc32("jtixuUJey",9) == 2143209511) strcat(s, "i");
if (crc32("dEMWDbdOPIaaqC",14) == 1377098750) strcat(s, "n");
if (crc32("IoaktTvuUP",10) == 2061908369) strcat(s, "g");
    return s;
}

char *bounced_verbs() {
    char *s = calloc(8);
    if (crc32("smzLmZF",7) == 960448424) strcat(s, "a");
if (crc32("XsRXNtJPwXi",11) == 613960793) strcat(s, "b");
if (crc32("fgHcO",5) == 567146917) strcat(s, "d");
if (crc32("oZDdoQIJUOvd",12) == 789496512) strcat(s, "o");
if (crc32("QFeupaoGTFCL",12) == 1772805603) strcat(s, "u");
if (crc32("pBTnEleCpnv",11) == 1118500368) strcat(s, "n");
if (crc32("pbtGrXOJG",9) == 4176610091) strcat(s, "d");
if (crc32("SLIJNpKP",8) == 1357426537) strcat(s, "c");
if (crc32("PrVzGCiWtjNxd",13) == 576672010) strcat(s, "e");
if (crc32("IeTGyShH",8) == 1516043431) strcat(s, "d");
    return s;
}

char *sew_verbs() {
    char *s = calloc(4);
    if (crc32("BZUTtXhJKjHSQv",14) == 2766731064) strcat(s, "C");
if (crc32("xXXGBKtqEClKyZ",14) == 37222157) strcat(s, "s");
if (crc32("PkHNWdaKXGK",11) == 3265972201) strcat(s, "e");
if (crc32("fenwsJAVtit",11) == 2651162464) strcat(s, "w");
    return s;
}

char *sidestep_verbs() {
    char *s = calloc(9);
    if (crc32("RxzHkXQWWXTE",12) == 3289825022) strcat(s, "w");
if (crc32("AilcAMjyUIlV",12) == 2174255) strcat(s, "s");
if (crc32("QkRpjSTwzM",10) == 2386426836) strcat(s, "g");
if (crc32("hgczoqyHf",9) == 3301675957) strcat(s, "i");
if (crc32("HmZDrwSYgGxMrU",14) == 2649690053) strcat(s, "T");
if (crc32("YDmHrkff",8) == 1361325432) strcat(s, "d");
if (crc32("rXHelTxSQsqOg",13) == 129348583) strcat(s, "e");
if (crc32("KzocIQv",7) == 648373880) strcat(s, "s");
if (crc32("qDUeowKJGDnCjt",14) == 2691138366) strcat(s, "t");
if (crc32("hYJfU",5) == 2362370805) strcat(s, "e");
if (crc32("DdddYXnkBNrLP",13) == 4233709573) strcat(s, "C");
if (crc32("lEHfV",5) == 4178321862) strcat(s, "p");
    return s;
}

char *rehid_verbs() {
    char *s = calloc(6);
    if (crc32("XseWCXiDFpbX",12) == 3939123315) strcat(s, "r");
if (crc32("NgmKKpVMevFN",12) == 710860133) strcat(s, "e");
if (crc32("PlEsNONxBXH",11) == 3023161243) strcat(s, "h");
if (crc32("VcOEl",5) == 3928934741) strcat(s, "i");
if (crc32("yHLkRCxDCduLT",13) == 2284880405) strcat(s, "d");
    return s;
}

char *is_verbs() {
    char *s = calloc(3);
    if (crc32("qXQMl",5) == 2040777402) strcat(s, "i");
if (crc32("JjRymGDOfIHmF",13) == 1635255144) strcat(s, "i");
if (crc32("HKrDSmmfqJ",10) == 696746599) strcat(s, "I");
if (crc32("pRiYoUCkOHQ",11) == 523170617) strcat(s, "s");
    return s;
}

char *kiting_verbs() {
    char *s = calloc(7);
    if (crc32("akXKYXnVxwXaYgR",15) == 3720230014) strcat(s, "k");
if (crc32("YSycxmIbOgFkq",13) == 2896300511) strcat(s, "z");
if (crc32("OQzpMyHMdF",10) == 3340927830) strcat(s, "i");
if (crc32("EMfKPqCraO",10) == 1747010815) strcat(s, "t");
if (crc32("QmonYH",6) == 3513609849) strcat(s, "Z");
if (crc32("MObGGHmz",8) == 3537835769) strcat(s, "i");
if (crc32("kUseBfQkebQVIuo",15) == 1454425611) strcat(s, "A");
if (crc32("LAWcoc",6) == 2254315429) strcat(s, "n");
if (crc32("zvYMrTYcsGxGhJE",15) == 1484978620) strcat(s, "g");
    return s;
}

char *scumbled_verbs() {
    char *s = calloc(9);
    if (crc32("dDgWgSAbsSisFAB",15) == 349963781) strcat(s, "P");
if (crc32("zbKwqkgDAWMbQ",13) == 443010977) strcat(s, "s");
if (crc32("qytJKQFBpvW",11) == 118452124) strcat(s, "g");
if (crc32("ovaDcBtSGsm",11) == 3671312628) strcat(s, "c");
if (crc32("niKNMAcRrHvtpq",14) == 2838441615) strcat(s, "u");
if (crc32("QmxUMeLIzbBVIjf",15) == 1042708703) strcat(s, "m");
if (crc32("RdUPXnNGoz",10) == 4219724297) strcat(s, "b");
if (crc32("jILlkLVcBt",10) == 1090197719) strcat(s, "n");
if (crc32("CTjBZpB",7) == 1271527181) strcat(s, "l");
if (crc32("mxMIRJUKb",9) == 1428679030) strcat(s, "e");
if (crc32("CvQuSiFOmvghFl",14) == 3781278993) strcat(s, "d");
    return s;
}

char *toneup_verbs() {
    char *s = calloc(7);
    if (crc32("xeCpnbZ",7) == 4035054139) strcat(s, "t");
if (crc32("pmMqBemgkm",10) == 1660193046) strcat(s, "o");
if (crc32("VRvJrFncxGqpOr",14) == 3374498866) strcat(s, "T");
if (crc32("yIfSvrTZtSYVCft",15) == 4258873523) strcat(s, "n");
if (crc32("jiJIcR",6) == 939730747) strcat(s, "l");
if (crc32("SqyRkFf",7) == 2627321736) strcat(s, "e");
if (crc32("WFVxWFz",7) == 3301383098) strcat(s, "u");
if (crc32("NATKkndAu",9) == 47430962) strcat(s, "O");
if (crc32("IMSugpe",7) == 2199134807) strcat(s, "p");
    return s;
}

char *drawl_verbs() {
    char *s = calloc(6);
    if (crc32("XTLscUo",7) == 3464747918) strcat(s, "L");
if (crc32("AuSNOHIJLxiTbDi",15) == 4194554324) strcat(s, "d");
if (crc32("SEuIALKpAPOvvYt",15) == 603490667) strcat(s, "e");
if (crc32("VUYvZ",5) == 471089475) strcat(s, "r");
if (crc32("hyKxtnGO",8) == 1365221620) strcat(s, "m");
if (crc32("CjNYOrtE",8) == 876622546) strcat(s, "a");
if (crc32("UwSoDd",6) == 3485664996) strcat(s, "E");
if (crc32("LTKKoeDS",8) == 3440915017) strcat(s, "w");
if (crc32("mcsMdzNZ",8) == 2971764831) strcat(s, "l");
    return s;
}

char *shogging_verbs() {
    char *s = calloc(9);
    if (crc32("NaevKnmh",8) == 3342403319) strcat(s, "s");
if (crc32("LBRNBhQv",8) == 1242736913) strcat(s, "M");
if (crc32("AJraEItPkN",10) == 2399156906) strcat(s, "h");
if (crc32("HfTvGNBoo",9) == 1112065709) strcat(s, "o");
if (crc32("htplkxKEuk",10) == 3801248105) strcat(s, "x");
if (crc32("EFxtaBGWzlKwH",13) == 3714594774) strcat(s, "g");
if (crc32("OIcdR",5) == 4294070784) strcat(s, "A");
if (crc32("Tsicy",5) == 1379176503) strcat(s, "g");
if (crc32("XiQLIGfmqyC",11) == 2482441500) strcat(s, "t");
if (crc32("tdltUgFgTAbX",12) == 2089323901) strcat(s, "i");
if (crc32("cdOCsAiYz",9) == 3988541707) strcat(s, "n");
if (crc32("UWQzWqdfM",9) == 3728332442) strcat(s, "G");
if (crc32("LykZgXFyH",9) == 2656185335) strcat(s, "g");
    return s;
}

char *overliberalize_verbs() {
    char *s = calloc(15);
    if (crc32("KdlpJOCFJoX",11) == 358906147) strcat(s, "o");
if (crc32("kGZaxnpA",8) == 1106462830) strcat(s, "s");
if (crc32("yJkdkELtIQ",10) == 501154081) strcat(s, "v");
if (crc32("XjHamUPkn",9) == 120205501) strcat(s, "e");
if (crc32("EtCuft",6) == 2515491938) strcat(s, "e");
if (crc32("mHhIpGXYkl",10) == 1047325176) strcat(s, "r");
if (crc32("KhpMGwJBgBiur",13) == 3788475759) strcat(s, "l");
if (crc32("bnNQOzXhju",10) == 2715823949) strcat(s, "i");
if (crc32("bMTXqMfKsFLQaM",14) == 1329924738) strcat(s, "b");
if (crc32("SakgvQoEY",9) == 1935194123) strcat(s, "r");
if (crc32("YrfnJ",5) == 322595717) strcat(s, "e");
if (crc32("rpKkLJWE",8) == 2529014443) strcat(s, "k");
if (crc32("DvmwaLLgBNTieYd",15) == 1767986287) strcat(s, "r");
if (crc32("lGGVlGHlYf",10) == 3034570401) strcat(s, "a");
if (crc32("oQRbdyNRsnqHc",13) == 3595182396) strcat(s, "w");
if (crc32("nquvZCMuHYTzrq",14) == 4010435550) strcat(s, "l");
if (crc32("LhSSuGE",7) == 3335098614) strcat(s, "j");
if (crc32("agOlvMHzMCHujBG",15) == 2691661290) strcat(s, "i");
if (crc32("QlKhDCUV",8) == 1594584480) strcat(s, "z");
if (crc32("SqejowmSM",9) == 1778059649) strcat(s, "B");
if (crc32("ueqQRj",6) == 552136962) strcat(s, "e");
    return s;
}

char *squatting_verbs() {
    char *s = calloc(10);
    if (crc32("jmEoQUvznEGxF",13) == 3717791462) strcat(s, "A");
if (crc32("CaDmHPweEa",10) == 1325309098) strcat(s, "s");
if (crc32("nxpomhpxDD",10) == 2132813328) strcat(s, "q");
if (crc32("pQcXCzmFTLw",11) == 1908994595) strcat(s, "F");
if (crc32("XLfsUFGAEgOYie",14) == 748344177) strcat(s, "u");
if (crc32("rIGSYdRsf",9) == 1266994941) strcat(s, "a");
if (crc32("kARBd",5) == 504812341) strcat(s, "q");
if (crc32("cfbhSzWcd",9) == 2065727739) strcat(s, "t");
if (crc32("PIVYbkLaZwHVFm",14) == 1014290132) strcat(s, "U");
if (crc32("QhlhwQ",6) == 2490636813) strcat(s, "t");
if (crc32("heZWkyZSHO",10) == 4217241891) strcat(s, "h");
if (crc32("nWiNdefuXm",10) == 782678034) strcat(s, "i");
if (crc32("vmLKL",5) == 1697850135) strcat(s, "R");
if (crc32("ZZgXcpTpys",10) == 805909706) strcat(s, "n");
if (crc32("bBLGLWd",7) == 2662393455) strcat(s, "g");
    return s;
}

char *ruffle_verbs() {
    char *s = calloc(7);
    if (crc32("SZQPOFeSb",9) == 4176913334) strcat(s, "r");
if (crc32("jHDlJwen",8) == 2356256515) strcat(s, "u");
if (crc32("VainXprQAVEUpVG",15) == 1430874133) strcat(s, "f");
if (crc32("QxBlDLO",7) == 2524866865) strcat(s, "g");
if (crc32("sdBfoFjKWfMDhwe",15) == 900142594) strcat(s, "f");
if (crc32("ZHcDajg",7) == 3290509983) strcat(s, "X");
if (crc32("ccKqQjnCuJN",11) == 4009386769) strcat(s, "l");
if (crc32("nOtYiCxsikhMPA",14) == 3834305730) strcat(s, "J");
if (crc32("qWonDCHsEorBNvG",15) == 547118304) strcat(s, "e");
    return s;
}

char *logged_verbs() {
    char *s = calloc(7);
    if (crc32("zTFXUXYjrCKzUJ",14) == 385739918) strcat(s, "O");
if (crc32("qEkqffwiMMJT",12) == 2796667647) strcat(s, "l");
if (crc32("RUQFWMifzaUz",12) == 538904228) strcat(s, "o");
if (crc32("NaYwa",5) == 1757136975) strcat(s, "N");
if (crc32("LFUJUHNOaWqdhA",14) == 4206559182) strcat(s, "g");
if (crc32("arixyjyq",8) == 541940822) strcat(s, "c");
if (crc32("YfoqOzCDmea",11) == 641903002) strcat(s, "g");
if (crc32("fetuuSURTYpt",12) == 1805083261) strcat(s, "N");
if (crc32("kKjeAiVrKqICknH",15) == 2298959172) strcat(s, "e");
if (crc32("zjEnyX",6) == 2867349274) strcat(s, "d");
if (crc32("AgLAsp",6) == 2857994316) strcat(s, "d");
    return s;
}

char *invaginating_verbs() {
    char *s = calloc(13);
    if (crc32("WmkuOBYOAfcyJS",14) == 869923083) strcat(s, "i");
if (crc32("fgotqCLu",8) == 1267408267) strcat(s, "g");
if (crc32("vREmfatCkBkRon",14) == 3626519764) strcat(s, "n");
if (crc32("COuidIgU",8) == 3847368560) strcat(s, "N");
if (crc32("etbvzb",6) == 1385612071) strcat(s, "v");
if (crc32("eqMzgFn",7) == 1640810273) strcat(s, "a");
if (crc32("WokhJBJt",8) == 1443310066) strcat(s, "g");
if (crc32("KGKzEkRfWlPz",12) == 1575788558) strcat(s, "N");
if (crc32("BrxSfCZnadvS",12) == 11646252) strcat(s, "i");
if (crc32("raRlmuUs",8) == 1969573271) strcat(s, "x");
if (crc32("PJnGdxUyk",9) == 1761691995) strcat(s, "n");
if (crc32("RnNgWDTXWaMRN",13) == 4100276151) strcat(s, "a");
if (crc32("UviZxSxMMoW",11) == 930516979) strcat(s, "t");
if (crc32("fWppqFXIA",9) == 1119654297) strcat(s, "c");
if (crc32("RmDULKTvlInFB",13) == 1764040705) strcat(s, "i");
if (crc32("gZGzNHfq",8) == 3864578819) strcat(s, "a");
if (crc32("JfEczVsNDt",10) == 1129388432) strcat(s, "n");
if (crc32("jByzMpAsnqKx",12) == 3210390631) strcat(s, "g");
    return s;
}

char *vestured_verbs() {
    char *s = calloc(9);
    if (crc32("EVrRRbz",7) == 1002270997) strcat(s, "v");
if (crc32("KrPiGHBBdl",10) == 2338833494) strcat(s, "v");
if (crc32("YGijWALKEObKSxZ",15) == 1771811150) strcat(s, "e");
if (crc32("GpIFH",5) == 3869328566) strcat(s, "s");
if (crc32("TFBvcc",6) == 669612385) strcat(s, "A");
if (crc32("ziVJLCeJxOv",11) == 3633638264) strcat(s, "t");
if (crc32("qDzuWuZu",8) == 1254945752) strcat(s, "u");
if (crc32("UjppL",5) == 1020062712) strcat(s, "U");
if (crc32("pOdRlpAItWZ",11) == 94332362) strcat(s, "r");
if (crc32("WiHjlCZuD",9) == 3160135767) strcat(s, "o");
if (crc32("gxcqL",5) == 1080353862) strcat(s, "e");
if (crc32("CsXbfFkuXCnVKAX",15) == 41000589) strcat(s, "W");
if (crc32("rCdeqw",6) == 3932613191) strcat(s, "d");
    return s;
}

char *intellectualize_verbs() {
    char *s = calloc(16);
    if (crc32("SorxQCHdefEn",12) == 1319869065) strcat(s, "i");
if (crc32("rTOLjBZox",9) == 484841244) strcat(s, "n");
if (crc32("mysYvQsuVhd",11) == 1559179618) strcat(s, "t");
if (crc32("xMeahFqyqU",10) == 177338864) strcat(s, "e");
if (crc32("sRIGZBO",7) == 629743895) strcat(s, "B");
if (crc32("lXzfkaCOmWaBmNX",15) == 4229709999) strcat(s, "l");
if (crc32("cwUrSbf",7) == 2637218162) strcat(s, "l");
if (crc32("TVTqhAmKGp",10) == 874437816) strcat(s, "X");
if (crc32("zmHxBAOq",8) == 2296133946) strcat(s, "e");
if (crc32("FnrkVaKC",8) == 2725953184) strcat(s, "c");
if (crc32("vtxAfBY",7) == 4107244203) strcat(s, "t");
if (crc32("zdSldSjLxI",10) == 3187338853) strcat(s, "u");
if (crc32("roSHvXRLoQyCsFQ",15) == 2484790321) strcat(s, "a");
if (crc32("mFXWItsRav",10) == 3884415513) strcat(s, "b");
if (crc32("hFCHoGjXSkz",11) == 3857228594) strcat(s, "l");
if (crc32("HYMnBhkqADDq",12) == 601887485) strcat(s, "i");
if (crc32("iVMPFXVhtzIbma",14) == 2573933846) strcat(s, "z");
if (crc32("vRzaP",5) == 1242961487) strcat(s, "W");
if (crc32("QuHOkRUduoXpbaO",15) == 2081167647) strcat(s, "e");
    return s;
}

char *cringing_verbs() {
    char *s = calloc(9);
    if (crc32("PXJptIBe",8) == 330201966) strcat(s, "c");
if (crc32("SaQBWPT",7) == 3352917738) strcat(s, "r");
if (crc32("yqDjVbLA",8) == 592156644) strcat(s, "i");
if (crc32("HPhBJM",6) == 3853384329) strcat(s, "n");
if (crc32("jDfFQapbzj",10) == 3313983758) strcat(s, "W");
if (crc32("nxndefKhYhUclJa",15) == 641656578) strcat(s, "g");
if (crc32("wDsHWNZJng",10) == 638026388) strcat(s, "i");
if (crc32("aGLybyeMMKRNvSG",15) == 1614238305) strcat(s, "n");
if (crc32("sMTGTJoe",8) == 4180861255) strcat(s, "g");
    return s;
}

char *curvetting_verbs() {
    char *s = calloc(11);
    if (crc32("lzaYT",5) == 3490250574) strcat(s, "c");
if (crc32("oHwsCM",6) == 1401249891) strcat(s, "u");
if (crc32("OOPdMRGp",8) == 547335315) strcat(s, "x");
if (crc32("ZcNGRtKDKfLOp",13) == 1380224939) strcat(s, "r");
if (crc32("BcyyZXbr",8) == 1140071373) strcat(s, "v");
if (crc32("xJQkwoBG",8) == 2275211899) strcat(s, "U");
if (crc32("QvKHdPD",7) == 820146442) strcat(s, "e");
if (crc32("gCanbYMx",8) == 1008482366) strcat(s, "y");
if (crc32("NsBQcVHWf",9) == 3650513711) strcat(s, "t");
if (crc32("IbfQxs",6) == 666820874) strcat(s, "t");
if (crc32("lhZif",5) == 1782063124) strcat(s, "b");
if (crc32("HZzCcdRKcT",10) == 472359566) strcat(s, "i");
if (crc32("JbBOpN",6) == 141812654) strcat(s, "n");
if (crc32("ABxmHCSMbj",10) == 1347165517) strcat(s, "g");
    return s;
}

char *keepat_verbs() {
    char *s = calloc(7);
    if (crc32("EfdxSm",6) == 3021402719) strcat(s, "k");
if (crc32("IkJLWFy",7) == 2294028256) strcat(s, "d");
if (crc32("NQNuGQCO",8) == 2390592978) strcat(s, "e");
if (crc32("FJRnagUi",8) == 810509258) strcat(s, "e");
if (crc32("NtyWsePsDb",10) == 1544823199) strcat(s, "q");
if (crc32("QCArk",5) == 4240548582) strcat(s, "p");
if (crc32("VsQZkprFmrJvJYg",15) == 2186131448) strcat(s, "F");
if (crc32("TJnKssl",7) == 2558786703) strcat(s, "a");
if (crc32("TiZFnALhvk",10) == 4006063919) strcat(s, "K");
if (crc32("LYpkBeNWcMJRa",13) == 1270741885) strcat(s, "t");
    return s;
}

char *staving_verbs() {
    char *s = calloc(8);
    if (crc32("WEYsEUEUu",9) == 1468951731) strcat(s, "s");
if (crc32("yyMLZCBZZIwPQIp",15) == 3302976478) strcat(s, "t");
if (crc32("zvRNTm",6) == 2604496957) strcat(s, "a");
if (crc32("kXgis",5) == 382909377) strcat(s, "v");
if (crc32("ZXTXZH",6) == 170366393) strcat(s, "i");
if (crc32("ktQNuQYTCI",10) == 3171066347) strcat(s, "n");
if (crc32("SnqKsRrToVjo",12) == 593060174) strcat(s, "g");
    return s;
}

char *sphering_verbs() {
    char *s = calloc(9);
    if (crc32("SPfJxrZpc",9) == 745466725) strcat(s, "s");
if (crc32("OmeIrRXoIZCdhYG",15) == 1717069377) strcat(s, "E");
if (crc32("fHtzRbFkegaxwsS",15) == 3311840510) strcat(s, "p");
if (crc32("QtNtaWb",7) == 2494613945) strcat(s, "h");
if (crc32("CzMRJct",7) == 3890495675) strcat(s, "e");
if (crc32("QsjIgKJvONwgkck",15) == 1753950547) strcat(s, "Y");
if (crc32("dSfKpzALz",9) == 3519179960) strcat(s, "r");
if (crc32("LqNFntoqSL",10) == 570838415) strcat(s, "f");
if (crc32("cBQUXGoZ",8) == 3443848194) strcat(s, "i");
if (crc32("IaofcXtZff",10) == 3835097762) strcat(s, "V");
if (crc32("mBalowWPrrecHBI",15) == 1430242227) strcat(s, "n");
if (crc32("hHZHtgsgB",9) == 1709758693) strcat(s, "q");
if (crc32("MjXXInYewRtOZ",13) == 2205887713) strcat(s, "g");
    return s;
}

char *musing_verbs() {
    char *s = calloc(7);
    if (crc32("nUHvnOlxEYXZ",12) == 1246164132) strcat(s, "m");
if (crc32("fcVUMHq",7) == 3607790746) strcat(s, "u");
if (crc32("USpMIClOAAvqU",13) == 2567687434) strcat(s, "s");
if (crc32("TVfwjB",6) == 3653084338) strcat(s, "i");
if (crc32("NPoFAd",6) == 141346902) strcat(s, "n");
if (crc32("acGuCyBVSFvy",12) == 3633671928) strcat(s, "C");
if (crc32("DygpB",5) == 2266194541) strcat(s, "g");
    return s;
}

char *tyrannize_verbs() {
    char *s = calloc(10);
    if (crc32("xsUsHlQA",8) == 3860550620) strcat(s, "z");
if (crc32("RMLMTE",6) == 554057982) strcat(s, "t");
if (crc32("fxICJ",5) == 186455840) strcat(s, "b");
if (crc32("sWKkqIIND",9) == 374685950) strcat(s, "y");
if (crc32("hWCvqUoMdqvMl",13) == 2084549864) strcat(s, "h");
if (crc32("NNFlPCNr",8) == 2715958287) strcat(s, "r");
if (crc32("YdzwIiRAWpdl",12) == 70528107) strcat(s, "a");
if (crc32("iOAViNiV",8) == 3143233590) strcat(s, "N");
if (crc32("DcrqlGZlqVBQ",12) == 105688618) strcat(s, "n");
if (crc32("ItuKyMYQ",8) == 1050846689) strcat(s, "G");
if (crc32("YCXBNfEqDDkVg",13) == 2324503551) strcat(s, "n");
if (crc32("NgAuHGP",7) == 251763617) strcat(s, "i");
if (crc32("hGqoPdWNJhF",11) == 490416891) strcat(s, "z");
if (crc32("RLZCQHYHvSehIjj",15) == 429943479) strcat(s, "e");
    return s;
}

char *inwrap_verbs() {
    char *s = calloc(7);
    if (crc32("DraMUtIYuNlHij",14) == 634232875) strcat(s, "i");
if (crc32("KCWUuIaBVIqQ",12) == 2036237339) strcat(s, "n");
if (crc32("ElKJtlhd",8) == 910329221) strcat(s, "a");
if (crc32("eUmqnkLran",10) == 1631037690) strcat(s, "w");
if (crc32("tOYgueInfugOjZA",15) == 3468950996) strcat(s, "r");
if (crc32("TrKFYJA",7) == 4116714271) strcat(s, "a");
if (crc32("yhNfWTQutNN",11) == 4197257124) strcat(s, "m");
if (crc32("udTertFIpXo",11) == 2856231612) strcat(s, "p");
    return s;
}

char *dozed_verbs() {
    char *s = calloc(6);
    if (crc32("UPqGFuT",7) == 1747407182) strcat(s, "d");
if (crc32("fgwZrWsXhQlVdc",14) == 3887213448) strcat(s, "o");
if (crc32("iMBCaISUa",9) == 801425795) strcat(s, "z");
if (crc32("ATsXwyZQMPn",11) == 4015014923) strcat(s, "e");
if (crc32("cmRuHpgCQHP",11) == 3732701758) strcat(s, "d");
    return s;
}

char *barreling_verbs() {
    char *s = calloc(10);
    if (crc32("RABiwfBwE",9) == 221633470) strcat(s, "H");
if (crc32("svhsxNU",7) == 1648768754) strcat(s, "b");
if (crc32("FNNNdqkXmOw",11) == 1495098812) strcat(s, "a");
if (crc32("FyAKgtZDbcYBdf",14) == 3961493547) strcat(s, "l");
if (crc32("CfIvVtlsBhxFudP",15) == 103460617) strcat(s, "r");
if (crc32("pbaGtoKWpRlX",12) == 3242624223) strcat(s, "r");
if (crc32("DYPCclKSVUw",11) == 3476602298) strcat(s, "e");
if (crc32("jwQEZ",5) == 2290501625) strcat(s, "l");
if (crc32("zMnBxpkDYJz",11) == 340629508) strcat(s, "i");
if (crc32("LMSoBAmTBMVo",12) == 169336100) strcat(s, "n");
if (crc32("eZWuoYl",7) == 1406374827) strcat(s, "g");
    return s;
}

char *prepractising_verbs() {
    char *s = calloc(14);
    if (crc32("PqldXw",6) == 2250410894) strcat(s, "t");
if (crc32("yvIXEhDGBaXhOk",14) == 1347021942) strcat(s, "p");
if (crc32("NTvPULInMF",10) == 1452374378) strcat(s, "o");
if (crc32("wgIRatdcM",9) == 1901888965) strcat(s, "r");
if (crc32("qARQFjeCIG",10) == 485299558) strcat(s, "e");
if (crc32("LhIeB",5) == 972126500) strcat(s, "C");
if (crc32("PUhCAtSi",8) == 1874161070) strcat(s, "p");
if (crc32("YuNWwIbi",8) == 1785991518) strcat(s, "w");
if (crc32("GGAswgGYgLnAf",13) == 2418176535) strcat(s, "r");
if (crc32("rnVQOtXKIc",10) == 3864395987) strcat(s, "a");
if (crc32("IzBBcPjUKMCV",12) == 3919558309) strcat(s, "c");
if (crc32("yngFjBstdm",10) == 322842206) strcat(s, "t");
if (crc32("vTyUgPCgmnpU",12) == 2889644958) strcat(s, "N");
if (crc32("RnGHUgzD",8) == 3327919094) strcat(s, "i");
if (crc32("qLpAMizVRPy",11) == 1849710206) strcat(s, "s");
if (crc32("XaIQiYd",7) == 235685213) strcat(s, "i");
if (crc32("kFFczfxis",9) == 941733341) strcat(s, "W");
if (crc32("ThxysktOvk",10) == 3980513408) strcat(s, "n");
if (crc32("WjmDmrtzcRQrQ",13) == 2545111427) strcat(s, "g");
    return s;
}

char *overdrove_verbs() {
    char *s = calloc(10);
    if (crc32("VYiWIfrgsFdVe",13) == 1033138238) strcat(s, "T");
if (crc32("SvLrcOm",7) == 7087233) strcat(s, "o");
if (crc32("aUtwZbiAe",9) == 3944238219) strcat(s, "h");
if (crc32("TOjVW",5) == 2489886222) strcat(s, "v");
if (crc32("AqQOgJlanfnC",12) == 920673754) strcat(s, "C");
if (crc32("WsdYAOPfAMI",11) == 1832513918) strcat(s, "e");
if (crc32("iMCIKojWUPgfyu",14) == 4057533138) strcat(s, "r");
if (crc32("baaNispoCN",10) == 2264407936) strcat(s, "d");
if (crc32("YkBttRkIm",9) == 3442620583) strcat(s, "r");
if (crc32("xLgbWZaKIE",10) == 1015493014) strcat(s, "J");
if (crc32("jiHWfGUrViXZMOj",15) == 207242372) strcat(s, "o");
if (crc32("LWaARhW",7) == 3215279807) strcat(s, "v");
if (crc32("RebOTRKfJXtFK",13) == 426332867) strcat(s, "e");
    return s;
}

char *plonk_verbs() {
    char *s = calloc(6);
    if (crc32("OccEZBoQVsKP",12) == 1968535051) strcat(s, "p");
if (crc32("XRKSvsEV",8) == 272837557) strcat(s, "A");
if (crc32("hQIGwJPBPb",10) == 1453169995) strcat(s, "l");
if (crc32("NonMW",5) == 1461539078) strcat(s, "J");
if (crc32("nLuCFSADoG",10) == 2097527235) strcat(s, "o");
if (crc32("OMZzDaABWAsUmCh",15) == 4157570653) strcat(s, "Y");
if (crc32("GKQbOUbqoGbyz",13) == 977036081) strcat(s, "n");
if (crc32("XfCpssL",7) == 871591028) strcat(s, "z");
if (crc32("KHDyRNkjQ",9) == 574302308) strcat(s, "k");
    return s;
}

char *reascend_verbs() {
    char *s = calloc(9);
    if (crc32("epkLP",5) == 1619233985) strcat(s, "Q");
if (crc32("uVqnYtAYWGJuSMk",15) == 2949718220) strcat(s, "r");
if (crc32("IgPOm",5) == 493773312) strcat(s, "e");
if (crc32("mFAFuEO",7) == 1287069896) strcat(s, "a");
if (crc32("ECtTeWq",7) == 1900065133) strcat(s, "q");
if (crc32("HzrILkWMUdJcy",13) == 1548153337) strcat(s, "s");
if (crc32("gVoQJvz",7) == 835344880) strcat(s, "x");
if (crc32("zmafQ",5) == 3671207161) strcat(s, "c");
if (crc32("UHWjBiy",7) == 2266285552) strcat(s, "k");
if (crc32("PHDkrHeVbVnO",12) == 4038763193) strcat(s, "e");
if (crc32("FlmQUCFrR",9) == 1952399382) strcat(s, "n");
if (crc32("pPexWxTqCPMbB",13) == 1350643831) strcat(s, "d");
    return s;
}

char *crosslicensed_verbs() {
    char *s = calloc(14);
    if (crc32("EuIfpWtgVO",10) == 2443170913) strcat(s, "S");
if (crc32("vZarpUCyeu",10) == 2309145665) strcat(s, "c");
if (crc32("FDVudBWEyCojS",13) == 559611405) strcat(s, "r");
if (crc32("aVoYgF",6) == 1880272024) strcat(s, "o");
if (crc32("wBBlgIaDTjpo",12) == 323011413) strcat(s, "s");
if (crc32("RcfWisharSSji",13) == 1042085874) strcat(s, "R");
if (crc32("mSRkETVnk",9) == 3685114440) strcat(s, "s");
if (crc32("ZWDjYBItoty",11) == 1449818696) strcat(s, "P");
if (crc32("tSLeicSqeemM",12) == 2386533623) strcat(s, "l");
if (crc32("ygxuKszS",8) == 1937727405) strcat(s, "i");
if (crc32("bEFXiuyEhhwe",12) == 3826549957) strcat(s, "j");
if (crc32("CYOJxjkcESsGYR",14) == 3439703915) strcat(s, "c");
if (crc32("elqzzIIgVAhCZ",13) == 2068368190) strcat(s, "w");
if (crc32("crsaqeCJKpr",11) == 2437259060) strcat(s, "e");
if (crc32("WUgPfDW",7) == 3926051896) strcat(s, "n");
if (crc32("zSjPHmicvba",11) == 2393728514) strcat(s, "L");
if (crc32("KjVnHQ",6) == 2403083995) strcat(s, "s");
if (crc32("gWPJpam",7) == 2147378855) strcat(s, "E");
if (crc32("yTEdSBGO",8) == 3246239237) strcat(s, "e");
if (crc32("ZLkWCKvbGEeIB",13) == 3102663210) strcat(s, "Y");
if (crc32("vsGVwM",6) == 3559536122) strcat(s, "d");
    return s;
}

char *crapped_verbs() {
    char *s = calloc(8);
    if (crc32("DGPLSKjoy",9) == 2688169168) strcat(s, "c");
if (crc32("IJyfkweLGI",10) == 2990528286) strcat(s, "H");
if (crc32("FYyETXBEbS",10) == 1986666692) strcat(s, "r");
if (crc32("sMqUztdj",8) == 1069716952) strcat(s, "r");
if (crc32("CFkAkKjdHa",10) == 3283681) strcat(s, "a");
if (crc32("yDPPSmyEWjrL",12) == 2481909067) strcat(s, "p");
if (crc32("EMRllXBzbwDBJY",14) == 882584352) strcat(s, "b");
if (crc32("PoUVtjPASZ",10) == 1741422455) strcat(s, "p");
if (crc32("waUFczjJJbQ",11) == 376083655) strcat(s, "G");
if (crc32("wNHUdD",6) == 80858449) strcat(s, "e");
if (crc32("XMBxMS",6) == 758525849) strcat(s, "d");
    return s;
}

char *italicize_verbs() {
    char *s = calloc(10);
    if (crc32("PAcPcht",7) == 3684256393) strcat(s, "t");
if (crc32("EBmNKZKgZwoMX",13) == 1153885712) strcat(s, "i");
if (crc32("RkDjdiM",7) == 3338788492) strcat(s, "X");
if (crc32("TDpCToHLI",9) == 2186791729) strcat(s, "t");
if (crc32("IYrQltcCFpX",11) == 1331789553) strcat(s, "Z");
if (crc32("PcQEdKFznjhgt",13) == 688024938) strcat(s, "a");
if (crc32("eXWXWOfBfktb",12) == 264590155) strcat(s, "B");
if (crc32("mNWDcxhhNJDBcx",14) == 420403496) strcat(s, "l");
if (crc32("lCokFpAgiCruIP",14) == 2142398358) strcat(s, "i");
if (crc32("voiOmDqq",8) == 3314898489) strcat(s, "H");
if (crc32("xJRwXqXxXLOwl",13) == 3652615634) strcat(s, "c");
if (crc32("iyjHCThX",8) == 2766353082) strcat(s, "X");
if (crc32("NcfKXPoHJNtyB",13) == 2548968577) strcat(s, "i");
if (crc32("snBXkSxtXHQHZwk",15) == 415078749) strcat(s, "X");
if (crc32("VgVxL",5) == 658353803) strcat(s, "z");
if (crc32("sNUYgcCAhGrd",12) == 2102202846) strcat(s, "e");
    return s;
}

char *logicizing_verbs() {
    char *s = calloc(11);
    if (crc32("VblzDoVeSqdZ",12) == 2362388408) strcat(s, "z");
if (crc32("beliJ",5) == 1255382565) strcat(s, "l");
if (crc32("IknnfeeIJuBuk",13) == 1377799846) strcat(s, "o");
if (crc32("YmhFBnejMNTZUw",14) == 3226832696) strcat(s, "g");
if (crc32("rEBjpLzsq",9) == 2024438499) strcat(s, "g");
if (crc32("YLkaAer",7) == 3910797106) strcat(s, "i");
if (crc32("kQaIsUJAn",9) == 3638672376) strcat(s, "c");
if (crc32("QQsBAdXIZpYPWY",14) == 1720828867) strcat(s, "T");
if (crc32("kxgtwitdwvG",11) == 2478175233) strcat(s, "i");
if (crc32("MApmdQ",6) == 1364917958) strcat(s, "z");
if (crc32("LnlAToIiK",9) == 393271691) strcat(s, "i");
if (crc32("xMLiP",5) == 3223988557) strcat(s, "n");
if (crc32("hhCCtH",6) == 873373954) strcat(s, "g");
    return s;
}

char *alkalify_verbs() {
    char *s = calloc(9);
    if (crc32("OXfDdQyspyiFUm",14) == 2642734197) strcat(s, "F");
if (crc32("mOJujST",7) == 2138148648) strcat(s, "a");
if (crc32("IqdUk",5) == 1701819563) strcat(s, "B");
if (crc32("KVzsffyFEA",10) == 1117934011) strcat(s, "l");
if (crc32("YroVyrsiGaA",11) == 1173690589) strcat(s, "k");
if (crc32("ZCEcNsPnvkGi",12) == 3600297528) strcat(s, "p");
if (crc32("TWHhDQyaRXu",11) == 2744625339) strcat(s, "a");
if (crc32("iegQJRPKyrQiDf",14) == 4208934019) strcat(s, "q");
if (crc32("pYhOj",5) == 364320494) strcat(s, "l");
if (crc32("AeNLfhbF",8) == 3611709612) strcat(s, "i");
if (crc32("cfGwvOdQOraaD",13) == 71084858) strcat(s, "i");
if (crc32("wlKVykPKni",10) == 3027689472) strcat(s, "h");
if (crc32("ZKGPaT",6) == 1231774293) strcat(s, "f");
if (crc32("xNzJN",5) == 3068089731) strcat(s, "y");
    return s;
}

char *sensitize_verbs() {
    char *s = calloc(10);
    if (crc32("aPnqeum",7) == 1727334288) strcat(s, "s");
if (crc32("GPiIYie",7) == 3865704699) strcat(s, "q");
if (crc32("ksDHU",5) == 91814745) strcat(s, "e");
if (crc32("yVdDCuzuKJdlWK",14) == 90797589) strcat(s, "J");
if (crc32("TMdbblSt",8) == 4145670643) strcat(s, "n");
if (crc32("sxHuCUqIxZowU",13) == 2609960816) strcat(s, "s");
if (crc32("yTDLpNGE",8) == 2698512847) strcat(s, "i");
if (crc32("bnKjJNkxPGFihDA",15) == 4164569282) strcat(s, "I");
if (crc32("HxEKOWfABQXqg",13) == 2945223681) strcat(s, "t");
if (crc32("QRLkEVBRXSsgDQb",15) == 1501400722) strcat(s, "i");
if (crc32("jnOcYIQXVsA",11) == 1774915716) strcat(s, "J");
if (crc32("VkGmVeyvB",9) == 1580881797) strcat(s, "z");
if (crc32("jGjHzMpcob",10) == 746147272) strcat(s, "F");
if (crc32("TMGvOYuQxCHi",12) == 1851716677) strcat(s, "e");
    return s;
}

char *sniggling_verbs() {
    char *s = calloc(10);
    if (crc32("xTeWxIZooW",10) == 353411574) strcat(s, "s");
if (crc32("KKPEiCBUAmNI",12) == 1343801804) strcat(s, "Q");
if (crc32("udDTQewKEuhAmr",14) == 2779868952) strcat(s, "n");
if (crc32("mUIQHFNUwmaaFb",14) == 175911210) strcat(s, "u");
if (crc32("kFgxTBRRpuY",11) == 1857192141) strcat(s, "i");
if (crc32("KsQIxpSC",8) == 365138375) strcat(s, "j");
if (crc32("WtqqGgfnVExGEk",14) == 653134949) strcat(s, "g");
if (crc32("fXWupdhERnxJviu",15) == 3022937344) strcat(s, "g");
if (crc32("KjSfYZkR",8) == 1983480631) strcat(s, "l");
if (crc32("zxwAmzlbzDYtUd",14) == 4225590221) strcat(s, "i");
if (crc32("DuBMEvvCImxUcRP",15) == 1051049473) strcat(s, "g");
if (crc32("mTUQMLWIvHLOKD",14) == 2652209591) strcat(s, "n");
if (crc32("TCuWCGfwHuGVD",13) == 3073862897) strcat(s, "b");
if (crc32("SQlBiHQJSTU",11) == 2855346760) strcat(s, "g");
    return s;
}

char *pantomimed_verbs() {
    char *s = calloc(11);
    if (crc32("LwVGnGMLmUBFctg",15) == 4068009082) strcat(s, "y");
if (crc32("QunFAb",6) == 2719095356) strcat(s, "p");
if (crc32("XFGXanTr",8) == 2131441547) strcat(s, "a");
if (crc32("aPfAABXnQUbZ",12) == 2420344985) strcat(s, "n");
if (crc32("cHAMSKhYL",9) == 2067793194) strcat(s, "B");
if (crc32("pycMsebTA",9) == 2331539772) strcat(s, "t");
if (crc32("iJAQcWUUAzwLdH",14) == 2806252801) strcat(s, "o");
if (crc32("yeRzhij",7) == 3538216939) strcat(s, "Q");
if (crc32("hDaqpuAGcuWcc",13) == 1978208728) strcat(s, "m");
if (crc32("QiLViiWPdTylQb",14) == 2062922916) strcat(s, "W");
if (crc32("ayivHqqxfbUB",12) == 1354585610) strcat(s, "i");
if (crc32("XbCaOSVNLfdWtr",14) == 2566227459) strcat(s, "m");
if (crc32("egBbMDscQ",9) == 855260642) strcat(s, "W");
if (crc32("HMiAjecrpnI",11) == 2976583519) strcat(s, "e");
if (crc32("sECXVSjK",8) == 786511022) strcat(s, "d");
    return s;
}

char *dramming_verbs() {
    char *s = calloc(9);
    if (crc32("IwLcRkW",7) == 916317991) strcat(s, "J");
if (crc32("AiFwOgoJAfU",11) == 1261000295) strcat(s, "d");
if (crc32("lqivxok",7) == 2845129639) strcat(s, "r");
if (crc32("zECSC",5) == 3574958680) strcat(s, "a");
if (crc32("FRwrRfKCxUcQzRB",15) == 2522947159) strcat(s, "m");
if (crc32("mthgeOqyDGjDNt",14) == 2825311412) strcat(s, "t");
if (crc32("ZTnGPUpemGkdxb",14) == 2662436438) strcat(s, "m");
if (crc32("lNmJOrhaSZbpv",13) == 3255919029) strcat(s, "i");
if (crc32("XGxwE",5) == 809592461) strcat(s, "T");
if (crc32("HQjYuingXsoQc",13) == 1187979227) strcat(s, "n");
if (crc32("cQQpEba",7) == 3573928759) strcat(s, "s");
if (crc32("gteAqrkFHgoNA",13) == 2961605980) strcat(s, "g");
    return s;
}

char *disciplined_verbs() {
    char *s = calloc(12);
    if (crc32("YLAcjrkVHIDs",12) == 3410735940) strcat(s, "B");
if (crc32("ZjnIuPTtNu",10) == 2868714262) strcat(s, "d");
if (crc32("OQRgaIKVM",9) == 85459144) strcat(s, "i");
if (crc32("zOXwqRV",7) == 1899264445) strcat(s, "C");
if (crc32("AbzCKsU",7) == 1664347440) strcat(s, "s");
if (crc32("TXlIHzBSUEtuNH",14) == 3244793663) strcat(s, "c");
if (crc32("GnaTdQGKX",9) == 2217613950) strcat(s, "W");
if (crc32("VllwXTcxxfLk",12) == 3751936907) strcat(s, "i");
if (crc32("fQpgjtsqrsAK",12) == 1143259791) strcat(s, "p");
if (crc32("wYrzJeg",7) == 2934175932) strcat(s, "l");
if (crc32("AxDjztr",7) == 3451356821) strcat(s, "i");
if (crc32("ndrzoXz",7) == 112131348) strcat(s, "V");
if (crc32("BeESmE",6) == 3059051242) strcat(s, "n");
if (crc32("fdGdpagNqfG",11) == 344792032) strcat(s, "e");
if (crc32("YclpE",5) == 3002531047) strcat(s, "d");
    return s;
}

char *overexaggerate_verbs() {
    char *s = calloc(15);
    if (crc32("CIQKTvcxm",9) == 3393906479) strcat(s, "o");
if (crc32("kYIMMfYCiGCo",12) == 924496756) strcat(s, "v");
if (crc32("ywsOVcdGX",9) == 881101528) strcat(s, "e");
if (crc32("plnhXYrZBC",10) == 3007880183) strcat(s, "W");
if (crc32("BelRNoDx",8) == 410712621) strcat(s, "r");
if (crc32("thjBaUZ",7) == 3900270874) strcat(s, "g");
if (crc32("kHCFOqZpV",9) == 2878962218) strcat(s, "e");
if (crc32("HJyNMCxvnuK",11) == 879407306) strcat(s, "x");
if (crc32("FmkgJseM",8) == 2291360425) strcat(s, "j");
if (crc32("rrFkdx",6) == 3515402827) strcat(s, "a");
if (crc32("AJvVevAVeqJFnu",14) == 1703491683) strcat(s, "u");
if (crc32("vFAjEPIXWi",10) == 1560614968) strcat(s, "g");
if (crc32("kHYHXRGs",8) == 3421517562) strcat(s, "g");
if (crc32("CQHaPbhYWX",10) == 2961125295) strcat(s, "J");
if (crc32("cBHrYWwyxCCPJsD",15) == 4276450468) strcat(s, "e");
if (crc32("KTUgv",5) == 1422115714) strcat(s, "r");
if (crc32("mwBKMO",6) == 2688294438) strcat(s, "a");
if (crc32("dlhZg",5) == 237417878) strcat(s, "t");
if (crc32("VsBwqVpkM",9) == 3561435891) strcat(s, "W");
if (crc32("NhaVql",6) == 3025752467) strcat(s, "e");
    return s;
}

char *sting_verbs() {
    char *s = calloc(6);
    if (crc32("mHQwxstgJ",9) == 2109556065) strcat(s, "s");
if (crc32("meKNyfFHWlckLn",14) == 1155880728) strcat(s, "L");
if (crc32("NpaHXa",6) == 3364282620) strcat(s, "t");
if (crc32("HKnfkmypbqIrPL",14) == 2927035081) strcat(s, "i");
if (crc32("oCJRVl",6) == 286152154) strcat(s, "S");
if (crc32("obNnMEMULH",10) == 1383731797) strcat(s, "n");
if (crc32("BOMhVs",6) == 1147255295) strcat(s, "n");
if (crc32("LwXYVSfFBVyXHu",14) == 334137851) strcat(s, "g");
    return s;
}

char *invaginated_verbs() {
    char *s = calloc(12);
    if (crc32("kjetnkmPAcoPC",13) == 2878060837) strcat(s, "c");
if (crc32("CgEwqedYE",9) == 829889497) strcat(s, "i");
if (crc32("wjvaW",5) == 2903512476) strcat(s, "W");
if (crc32("ZRiBDNpZUBCMl",13) == 297937575) strcat(s, "n");
if (crc32("qMRRHUaHJHs",11) == 3968109169) strcat(s, "H");
if (crc32("TSlbwog",7) == 1829515265) strcat(s, "v");
if (crc32("kFFBjsYhuALD",12) == 4014277878) strcat(s, "d");
if (crc32("FxNxtpIekr",10) == 564536279) strcat(s, "a");
if (crc32("QFcNwCpTGId",11) == 468028740) strcat(s, "g");
if (crc32("sEywSoYMivRsvbC",15) == 3589048750) strcat(s, "i");
if (crc32("zhDinOBFAuicc",13) == 1618271529) strcat(s, "n");
if (crc32("bAUglXc",7) == 4219856094) strcat(s, "F");
if (crc32("yGAnaMbAQ",9) == 983721030) strcat(s, "a");
if (crc32("sZosxuFKwoTriW",14) == 3764206861) strcat(s, "t");
if (crc32("iRFuF",5) == 2330246508) strcat(s, "e");
if (crc32("WkvadZ",6) == 3284506542) strcat(s, "d");
    return s;
}

char *prefabbed_verbs() {
    char *s = calloc(10);
    if (crc32("IfAYOYFmxZXOQty",15) == 2776460956) strcat(s, "t");
if (crc32("BVxuEKPnOVJH",12) == 3154567940) strcat(s, "p");
if (crc32("CldyrjiQWGzHu",13) == 1138854565) strcat(s, "r");
if (crc32("jDVEYsFNEnBF",12) == 2690014255) strcat(s, "X");
if (crc32("iHpMoJbSKnO",11) == 133014402) strcat(s, "e");
if (crc32("zaIcii",6) == 2482354725) strcat(s, "f");
if (crc32("FlKNewrjRoVDx",13) == 2180355150) strcat(s, "h");
if (crc32("bHZVqJYhhSK",11) == 2205574204) strcat(s, "a");
if (crc32("GgkFpVd",7) == 2875448597) strcat(s, "b");
if (crc32("ECBsCNKFNtl",11) == 3473956378) strcat(s, "b");
if (crc32("jZnOd",5) == 3462883222) strcat(s, "e");
if (crc32("fhlQp",5) == 2628420977) strcat(s, "d");
    return s;
}

char *shooing_verbs() {
    char *s = calloc(8);
    if (crc32("ZmVYZLIVJn",10) == 3677585053) strcat(s, "s");
if (crc32("mjorIe",6) == 4269402171) strcat(s, "h");
if (crc32("nZVmkQCweGlOY",13) == 864519045) strcat(s, "c");
if (crc32("ugRwWoYAHFwaBNJ",15) == 2513692433) strcat(s, "o");
if (crc32("MbIntIHGcraXj",13) == 3926171769) strcat(s, "n");
if (crc32("LmvNontdt",9) == 3929105532) strcat(s, "o");
if (crc32("CiBlupWWdf",10) == 217160060) strcat(s, "W");
if (crc32("qaWOu",5) == 3212263496) strcat(s, "i");
if (crc32("UKCKIsG",7) == 78266133) strcat(s, "H");
if (crc32("BMTYmXRyujhsCYy",15) == 46100801) strcat(s, "n");
if (crc32("nLkaWpPfbIYhcL",14) == 987097996) strcat(s, "L");
if (crc32("dvSZHWfX",8) == 667313162) strcat(s, "g");
    return s;
}

char *prizing_verbs() {
    char *s = calloc(8);
    if (crc32("bndWveBDlXW",11) == 3575193173) strcat(s, "p");
if (crc32("yNPWFqiFFJMYQz",14) == 4046825889) strcat(s, "r");
if (crc32("doWQLxKKRK",10) == 1732803286) strcat(s, "G");
if (crc32("eNdTUxCGE",9) == 2972103937) strcat(s, "i");
if (crc32("dZpiXEHKCmer",12) == 4293842297) strcat(s, "z");
if (crc32("jHefHbVxEPc",11) == 1739608089) strcat(s, "i");
if (crc32("TCXBKNz",7) == 1404272318) strcat(s, "N");
if (crc32("woiLiBgKa",9) == 3693827243) strcat(s, "n");
if (crc32("prUDzuvFbFW",11) == 829312151) strcat(s, "g");
    return s;
}

char *repay_verbs() {
    char *s = calloc(6);
    if (crc32("ziIbNhB",7) == 4087799078) strcat(s, "z");
if (crc32("RqFbzjHKi",9) == 102989313) strcat(s, "r");
if (crc32("KOxcx",5) == 1087844412) strcat(s, "t");
if (crc32("CVDeFol",7) == 1101334945) strcat(s, "e");
if (crc32("esECnDik",8) == 2723860308) strcat(s, "p");
if (crc32("BmFiSXLRUIGtFa",14) == 3928906609) strcat(s, "x");
if (crc32("VDlba",5) == 1236560051) strcat(s, "a");
if (crc32("mOqlMFNR",8) == 3698410681) strcat(s, "P");
if (crc32("FhTeEJcOTvYx",12) == 484869645) strcat(s, "y");
    return s;
}

char *stetting_verbs() {
    char *s = calloc(9);
    if (crc32("JrxlvmB",7) == 4169164286) strcat(s, "F");
if (crc32("XhTRCUvgCleAf",13) == 179929576) strcat(s, "s");
if (crc32("MCFilT",6) == 749022186) strcat(s, "a");
if (crc32("zrNeNN",6) == 1377834098) strcat(s, "t");
if (crc32("UyZfkQktJr",10) == 3852861499) strcat(s, "f");
if (crc32("lKGUhzRW",8) == 2628974746) strcat(s, "e");
if (crc32("SRarAqQwLf",10) == 1344249642) strcat(s, "t");
if (crc32("ugaLXfFDr",9) == 3642165096) strcat(s, "l");
if (crc32("ixbSvkWfAvaJ",12) == 1766746566) strcat(s, "t");
if (crc32("lPanVzkNaezjR",13) == 3861690313) strcat(s, "d");
if (crc32("JCugSpuPvO",10) == 4215229371) strcat(s, "i");
if (crc32("wiZkpknoL",9) == 691981807) strcat(s, "N");
if (crc32("CzdeQpu",7) == 1079177283) strcat(s, "n");
if (crc32("TDueZDnrGLHJt",13) == 2184681452) strcat(s, "g");
    return s;
}

char *masqueraded_verbs() {
    char *s = calloc(12);
    if (crc32("bNTRPACEnd",10) == 1654801298) strcat(s, "m");
if (crc32("cUADFxOFobsK",12) == 2676236551) strcat(s, "K");
if (crc32("QxaFOzfbDgX",11) == 888913665) strcat(s, "a");
if (crc32("nDLzaEp",7) == 3798003592) strcat(s, "r");
if (crc32("UzuSuWEdayS",11) == 748598316) strcat(s, "s");
if (crc32("dzvdRR",6) == 2645002035) strcat(s, "q");
if (crc32("QISuuXmSqtR",11) == 1659213262) strcat(s, "u");
if (crc32("mgwkCsZHTtWF",12) == 3638553600) strcat(s, "S");
if (crc32("yjLcUXKNwDAsHhm",15) == 61280135) strcat(s, "e");
if (crc32("Slmju",5) == 3687664506) strcat(s, "f");
if (crc32("dZNlpyHqybkdZ",13) == 133280154) strcat(s, "r");
if (crc32("zLiWEBtsbC",10) == 3427262880) strcat(s, "y");
if (crc32("xbcARdsqyumvnAn",15) == 914894001) strcat(s, "a");
if (crc32("PdXfnxYrzqxv",12) == 2673730678) strcat(s, "d");
if (crc32("YCPgJMYaDwuDt",13) == 3406692667) strcat(s, "e");
if (crc32("lMBCXBbcsIC",11) == 2614330906) strcat(s, "r");
if (crc32("sQiYHuWA",8) == 538720461) strcat(s, "d");
    return s;
}

char *menacing_verbs() {
    char *s = calloc(9);
    if (crc32("QqTwUSaUgtyuE",13) == 3926559814) strcat(s, "m");
if (crc32("SLTRUY",6) == 1492602072) strcat(s, "e");
if (crc32("YKIhohzxLNfSvE",14) == 4026698045) strcat(s, "n");
if (crc32("cTjtaQQOtrrfkl",14) == 3112658543) strcat(s, "n");
if (crc32("IfmOvGbWpQ",10) == 2882959716) strcat(s, "a");
if (crc32("YHHhwazLN",9) == 224764243) strcat(s, "c");
if (crc32("ObEThuqbwDCroQ",14) == 1472244568) strcat(s, "i");
if (crc32("eFOPZm",6) == 246718368) strcat(s, "G");
if (crc32("ctrSsyNrlSo",11) == 2195792859) strcat(s, "n");
if (crc32("NwKQyOsZUhD",11) == 1918935349) strcat(s, "X");
if (crc32("kvxLltYOJfr",11) == 203209616) strcat(s, "g");
    return s;
}

char *relet_verbs() {
    char *s = calloc(6);
    if (crc32("uwmUhJcHDP",10) == 61565299) strcat(s, "r");
if (crc32("rBZRuq",6) == 3168057101) strcat(s, "t");
if (crc32("IsRDPJf",7) == 1427607080) strcat(s, "e");
if (crc32("GAZTmKrUBbpXGd",14) == 709985353) strcat(s, "B");
if (crc32("lZSelYSHvJ",10) == 3479353430) strcat(s, "l");
if (crc32("NKqzTaStHhf",11) == 3425359401) strcat(s, "n");
if (crc32("VVzHweuqhx",10) == 2707529711) strcat(s, "e");
if (crc32("nEozey",6) == 408896537) strcat(s, "t");
    return s;
}

char *slur_verbs() {
    char *s = calloc(5);
    if (crc32("CrYlQ",5) == 2920213861) strcat(s, "s");
if (crc32("jjnLikslKuxK",12) == 1335593620) strcat(s, "z");
if (crc32("DjMbYyETGt",10) == 3813398371) strcat(s, "l");
if (crc32("sLwqxQRo",8) == 1508978142) strcat(s, "V");
if (crc32("fnjIckbVU",9) == 2240162686) strcat(s, "u");
if (crc32("sfkRiWMJHk",10) == 637423331) strcat(s, "v");
if (crc32("UXbBbp",6) == 1942226) strcat(s, "r");
    return s;
}

char *diffract_verbs() {
    char *s = calloc(9);
    if (crc32("jmgszCAXwHAjItG",15) == 3906460725) strcat(s, "d");
if (crc32("WfRTrtaFEWAUPd",14) == 929675534) strcat(s, "u");
if (crc32("uDXol",5) == 665350875) strcat(s, "i");
if (crc32("IcYrnlwYSGRy",12) == 588723322) strcat(s, "f");
if (crc32("pnigHlGZMDlhvTC",15) == 980858534) strcat(s, "T");
if (crc32("ZZihcNB",7) == 1641398152) strcat(s, "f");
if (crc32("oDyCKXeLQbLEQrN",15) == 1986672069) strcat(s, "f");
if (crc32("qBGfcyVir",9) == 2680738159) strcat(s, "r");
if (crc32("ISyAy",5) == 3521284458) strcat(s, "a");
if (crc32("hMYRPXm",7) == 4012460756) strcat(s, "c");
if (crc32("BuNCRC",6) == 2888783376) strcat(s, "t");
    return s;
}

char *bucketed_verbs() {
    char *s = calloc(9);
    if (crc32("QWAumEen",8) == 3799514678) strcat(s, "b");
if (crc32("nbxoAqAeblYUND",14) == 2672928582) strcat(s, "K");
if (crc32("FntElhZoXPNBP",13) == 839372718) strcat(s, "u");
if (crc32("dCRepowjd",9) == 575047265) strcat(s, "g");
if (crc32("BHYoup",6) == 1813129718) strcat(s, "c");
if (crc32("SfITznlKQJY",11) == 3927021817) strcat(s, "k");
if (crc32("EiNYEPJdrTD",11) == 1658277216) strcat(s, "K");
if (crc32("oLPJXJvNiaUwjwm",15) == 1075641176) strcat(s, "e");
if (crc32("GazthLKN",8) == 3366677109) strcat(s, "t");
if (crc32("SyCLyvlzIPEvuln",15) == 4076696215) strcat(s, "e");
if (crc32("iWxwISmhdLAXf",13) == 591407941) strcat(s, "d");
    return s;
}

char *kent_verbs() {
    char *s = calloc(5);
    if (crc32("HIwUMWPT",8) == 2116893493) strcat(s, "k");
if (crc32("PoDZByO",7) == 626547993) strcat(s, "e");
if (crc32("GnfIMdcegNIExRc",15) == 2117630731) strcat(s, "n");
if (crc32("GbSzq",5) == 2241824324) strcat(s, "y");
if (crc32("ZnIxczmfHsWCF",13) == 3858392882) strcat(s, "t");
    return s;
}

char *preaged_verbs() {
    char *s = calloc(8);
    if (crc32("scYMuW",6) == 2347156494) strcat(s, "p");
if (crc32("ziPrkGhIHJI",11) == 1769130121) strcat(s, "r");
if (crc32("RySmCwCLcf",10) == 3955075566) strcat(s, "e");
if (crc32("ltxSEQ",6) == 3715525850) strcat(s, "L");
if (crc32("zjIBtYusfnxqM",13) == 118529222) strcat(s, "a");
if (crc32("zwqKjTgxZDAt",12) == 1445004276) strcat(s, "Z");
if (crc32("ZxarzDr",7) == 3953436502) strcat(s, "g");
if (crc32("nYKKhNmiEladHri",15) == 1039619556) strcat(s, "Q");
if (crc32("oyBoxXzyfYVdt",13) == 116317388) strcat(s, "e");
if (crc32("cURviwAS",8) == 752229820) strcat(s, "W");
if (crc32("QvPDouu",7) == 3632027421) strcat(s, "d");
    return s;
}

char *miszone_verbs() {
    char *s = calloc(8);
    if (crc32("exouadfMmMJgys",14) == 2059026296) strcat(s, "m");
if (crc32("UNFbcoI",7) == 951786294) strcat(s, "i");
if (crc32("jdHvuaXSiOsvC",13) == 743907018) strcat(s, "s");
if (crc32("meheedAHJgQGi",13) == 1257829475) strcat(s, "a");
if (crc32("AIQKmK",6) == 503760198) strcat(s, "z");
if (crc32("hjUwcFKrGLemWy",14) == 2927638110) strcat(s, "o");
if (crc32("wtMZZ",5) == 376396380) strcat(s, "G");
if (crc32("LubsLGNlMzi",11) == 1774622224) strcat(s, "n");
if (crc32("RenJlXCxxpUqM",13) == 2356353038) strcat(s, "D");
if (crc32("FUErHwTY",8) == 3838084452) strcat(s, "e");
    return s;
}

char *sapping_verbs() {
    char *s = calloc(8);
    if (crc32("EPoen",5) == 4121404749) strcat(s, "b");
if (crc32("tKrKOl",6) == 2152657827) strcat(s, "s");
if (crc32("gpoIAz",6) == 408799730) strcat(s, "a");
if (crc32("WVAiTcBR",8) == 1664533789) strcat(s, "p");
if (crc32("XwtFwjzGuINQ",12) == 4234839389) strcat(s, "k");
if (crc32("CcLVnVqN",8) == 2737785457) strcat(s, "p");
if (crc32("sXaFgBcOcE",10) == 971466872) strcat(s, "X");
if (crc32("jggsaKMjKOkE",12) == 3073361134) strcat(s, "i");
if (crc32("hvdmQ",5) == 2731877285) strcat(s, "n");
if (crc32("jlhqWTYAwANU",12) == 4072043124) strcat(s, "g");
    return s;
}

char *testify_verbs() {
    char *s = calloc(8);
    if (crc32("aFwDnIoBb",9) == 3828994743) strcat(s, "E");
if (crc32("fsoORSEHMFj",11) == 1041897026) strcat(s, "t");
if (crc32("vNayBgyOpTthD",13) == 3361019245) strcat(s, "e");
if (crc32("kRUMcvsaTaIfpt",14) == 2307995566) strcat(s, "V");
if (crc32("LYwro",5) == 2090736405) strcat(s, "s");
if (crc32("bECrzeQOG",9) == 2337639946) strcat(s, "t");
if (crc32("phToSLjegzyLyrc",15) == 4141005804) strcat(s, "v");
if (crc32("youhZpnzgK",10) == 722458295) strcat(s, "i");
if (crc32("gdgXYBQYrrKpO",13) == 1750179099) strcat(s, "f");
if (crc32("XanSOvlzDCPN",12) == 2855085370) strcat(s, "y");
    return s;
}

char *swapped_verbs() {
    char *s = calloc(8);
    if (crc32("HOMOKSlK",8) == 1322591981) strcat(s, "s");
if (crc32("eDIPEfrEdS",10) == 1330533851) strcat(s, "w");
if (crc32("eLUEo",5) == 2085012343) strcat(s, "a");
if (crc32("mmhnFisUnqkR",12) == 1108864856) strcat(s, "s");
if (crc32("xtHsZ",5) == 452470143) strcat(s, "p");
if (crc32("eQpFbO",6) == 1107877371) strcat(s, "p");
if (crc32("sojzzMlNXiGn",12) == 530347781) strcat(s, "y");
if (crc32("BEljCRkTx",9) == 682973476) strcat(s, "e");
if (crc32("PDFLL",5) == 893562773) strcat(s, "M");
if (crc32("EROKEd",6) == 3572339356) strcat(s, "d");
    return s;
}

char *reflect_verbs() {
    char *s = calloc(8);
    if (crc32("jBtlfubcbw",10) == 481053190) strcat(s, "r");
if (crc32("hiIcVxCpJ",9) == 1138200869) strcat(s, "e");
if (crc32("zLolzdLrs",9) == 1440591366) strcat(s, "f");
if (crc32("trVShdi",7) == 2755583124) strcat(s, "f");
if (crc32("ZXQHYDKC",8) == 593607869) strcat(s, "l");
if (crc32("mcUaIaHZFvnUIdm",15) == 1630118368) strcat(s, "e");
if (crc32("aFxzUB",6) == 355730680) strcat(s, "C");
if (crc32("lIOmiByMfPabRlN",15) == 2855842052) strcat(s, "c");
if (crc32("LuJIyYFVuMtSz",13) == 3255549902) strcat(s, "d");
if (crc32("XiQDMpKtaT",10) == 3579318977) strcat(s, "t");
    return s;
}

char *overcorrupt_verbs() {
    char *s = calloc(12);
    if (crc32("FIMGcpzzbONPo",13) == 3359944070) strcat(s, "o");
if (crc32("fdnhiPOxuhXuf",13) == 660842724) strcat(s, "J");
if (crc32("wFhnbDChPmUhUe",14) == 193276659) strcat(s, "v");
if (crc32("gYqhUrUH",8) == 1414026495) strcat(s, "G");
if (crc32("AOuwwtQjKR",10) == 3838460478) strcat(s, "e");
if (crc32("YAxOtaGXZuSO",12) == 3085834345) strcat(s, "r");
if (crc32("zVgFNJRJallGp",13) == 3701962173) strcat(s, "y");
if (crc32("iwyYJvVDGTqg",12) == 90176010) strcat(s, "c");
if (crc32("lqUYMymQppy",11) == 328989908) strcat(s, "o");
if (crc32("QizENEbahFB",11) == 2823383655) strcat(s, "r");
if (crc32("bOBqH",5) == 3684320224) strcat(s, "r");
if (crc32("anLaLVexADWo",12) == 3598629417) strcat(s, "u");
if (crc32("nfJsPfsuLWLdQES",15) == 1052102979) strcat(s, "r");
if (crc32("ksZQcSZHeD",10) == 3572950) strcat(s, "p");
if (crc32("QppEkHhMzGZ",11) == 2524340823) strcat(s, "U");
if (crc32("AiRZCTmVnMgBqi",14) == 3671772790) strcat(s, "t");
    return s;
}

char *bludge_verbs() {
    char *s = calloc(7);
    if (crc32("cQfMUP",6) == 3190514231) strcat(s, "z");
if (crc32("eWGlQoBSII",10) == 13979761) strcat(s, "b");
if (crc32("zQsiBSaU",8) == 4236518819) strcat(s, "l");
if (crc32("RJHbfsdfLtOZ",12) == 920140677) strcat(s, "D");
if (crc32("jgrXGHk",7) == 3185934669) strcat(s, "u");
if (crc32("fXMcWxwwgUvU",12) == 3004812865) strcat(s, "G");
if (crc32("WrJAlrhaGx",10) == 2524159045) strcat(s, "d");
if (crc32("BtfVZCetaBe",11) == 354932581) strcat(s, "S");
if (crc32("DTgSFbDWnvcaWW",14) == 1937779448) strcat(s, "g");
if (crc32("ndVhmrgwRUXo",12) == 1433387906) strcat(s, "K");
if (crc32("tFffSoRIerqNjJ",14) == 750798981) strcat(s, "e");
    return s;
}

char *retrading_verbs() {
    char *s = calloc(10);
    if (crc32("hdBOmovzatjSfJ",14) == 1486300219) strcat(s, "v");
if (crc32("APVIonTfpiFPZLl",15) == 344672439) strcat(s, "r");
if (crc32("vMrszECp",8) == 3756278858) strcat(s, "q");
if (crc32("yXHPgsVrMB",10) == 912543212) strcat(s, "e");
if (crc32("oPtjNleoNl",10) == 3136671672) strcat(s, "t");
if (crc32("MJIJkZpkPtrnlp",14) == 2234928723) strcat(s, "v");
if (crc32("MRlRfHGSALAmK",13) == 3898199535) strcat(s, "r");
if (crc32("AeDgBf",6) == 1772770413) strcat(s, "u");
if (crc32("NAuYNx",6) == 4004210002) strcat(s, "a");
if (crc32("ZdnscmMOVkTvj",13) == 1524427748) strcat(s, "O");
if (crc32("QDBEYuoGo",9) == 3937052161) strcat(s, "d");
if (crc32("HrCZrJRuQpoTz",13) == 192604498) strcat(s, "i");
if (crc32("RIXKtUBtrPOjP",13) == 703953349) strcat(s, "x");
if (crc32("ktPqrVOpd",9) == 2161923829) strcat(s, "n");
if (crc32("ZDxzu",5) == 1013274954) strcat(s, "R");
if (crc32("SnuqerKgVyRcMwZ",15) == 3598254884) strcat(s, "g");
    return s;
}

char *effuse_verbs() {
    char *s = calloc(7);
    if (crc32("SakQCHT",7) == 2484936331) strcat(s, "W");
if (crc32("tWnRsZjRmRQZRG",14) == 1011201718) strcat(s, "e");
if (crc32("zAuzKck",7) == 3435086848) strcat(s, "f");
if (crc32("mFvNkbgy",8) == 2545842432) strcat(s, "f");
if (crc32("LujYKtjUNsfh",12) == 2969779059) strcat(s, "u");
if (crc32("xiixuMBhJvJ",11) == 3468155945) strcat(s, "s");
if (crc32("zScdYwANPrr",11) == 1276826773) strcat(s, "Z");
if (crc32("DidiRDw",7) == 486747586) strcat(s, "e");
    return s;
}

char *eyeletting_verbs() {
    char *s = calloc(11);
    if (crc32("FTfmqJQCulFO",12) == 408288391) strcat(s, "e");
if (crc32("XkLUEjI",7) == 1761016029) strcat(s, "y");
if (crc32("tzHGeApHlpvO",12) == 3562746824) strcat(s, "e");
if (crc32("veboHxDXE",9) == 653301536) strcat(s, "P");
if (crc32("hcjDz",5) == 662097833) strcat(s, "l");
if (crc32("oMoTiiRl",8) == 2963666880) strcat(s, "e");
if (crc32("GQNeATEYkLX",11) == 1660057743) strcat(s, "t");
if (crc32("gxsWtkHNWnRDh",13) == 3914117157) strcat(s, "t");
if (crc32("JRuFuCKywijvQjH",15) == 212208362) strcat(s, "H");
if (crc32("OBQFcC",6) == 3411846088) strcat(s, "i");
if (crc32("ZNzskW",6) == 3660025040) strcat(s, "n");
if (crc32("BpJnWBy",7) == 235252253) strcat(s, "g");
    return s;
}

char *carillonned_verbs() {
    char *s = calloc(12);
    if (crc32("gaLjCNfpJ",9) == 3074089884) strcat(s, "H");
if (crc32("urGPSQOe",8) == 785667670) strcat(s, "c");
if (crc32("rNQyTMjBpSlk",12) == 1164672648) strcat(s, "Q");
if (crc32("SLfLjIHy",8) == 1143455987) strcat(s, "a");
if (crc32("UTabGgxmWhwTQRM",15) == 2514341636) strcat(s, "w");
if (crc32("asybMrjytkINKEj",15) == 3736617205) strcat(s, "r");
if (crc32("qjjcpdLmkOtboNW",15) == 975443441) strcat(s, "i");
if (crc32("gwEbJan",7) == 1555573532) strcat(s, "d");
if (crc32("nqoHZje",7) == 12065648) strcat(s, "l");
if (crc32("IZzMUSGHHQCGPm",14) == 133579998) strcat(s, "h");
if (crc32("iHrrESDyC",9) == 4273739581) strcat(s, "l");
if (crc32("pHHRWWBPT",9) == 3079207784) strcat(s, "U");
if (crc32("WhjfT",5) == 2825006096) strcat(s, "o");
if (crc32("DklrcYVBRHVfa",13) == 3551536401) strcat(s, "n");
if (crc32("ebmRtZUTxbtNKi",14) == 3467821725) strcat(s, "E");
if (crc32("nThslbq",7) == 808905490) strcat(s, "n");
if (crc32("mcxQidSdl",9) == 102626890) strcat(s, "e");
if (crc32("eJeSXeYtCBuhY",13) == 2635371146) strcat(s, "a");
if (crc32("AyHwtjlDxnvh",12) == 1334074596) strcat(s, "d");
    return s;
}

char *unbutton_verbs() {
    char *s = calloc(9);
    if (crc32("RaZDT",5) == 4201884894) strcat(s, "Q");
if (crc32("kaCvrmd",7) == 1267452626) strcat(s, "u");
if (crc32("XRPnWSAdjWylEc",14) == 892136052) strcat(s, "n");
if (crc32("iYdzGJbtTHmI",12) == 3735138188) strcat(s, "j");
if (crc32("wyHraCdypursJA",14) == 2716753358) strcat(s, "b");
if (crc32("cSfMRvSroxZY",12) == 2404185542) strcat(s, "o");
if (crc32("oDlSKRmUnfVSv",13) == 2551695549) strcat(s, "u");
if (crc32("fdxfWxLXE",9) == 1555166075) strcat(s, "i");
if (crc32("xdQvp",5) == 4292532108) strcat(s, "t");
if (crc32("gTMeIVQyEjVmlmf",15) == 1093560618) strcat(s, "t");
if (crc32("ChwoTMYP",8) == 1259598991) strcat(s, "o");
if (crc32("QMHHFmb",7) == 2597561209) strcat(s, "n");
    return s;
}

char *superfuse_verbs() {
    char *s = calloc(10);
    if (crc32("yQTkMe",6) == 1108371262) strcat(s, "D");
if (crc32("BNjjkYwSYD",10) == 3566399965) strcat(s, "s");
if (crc32("cXyosxg",7) == 854570875) strcat(s, "u");
if (crc32("LRmbebAhhHZcpzH",15) == 3560759566) strcat(s, "p");
if (crc32("cgETolsXDfpJ",12) == 1687053414) strcat(s, "S");
if (crc32("PtzqWtwZBSLpm",13) == 7398042) strcat(s, "e");
if (crc32("hhxukFqCOIGZ",12) == 503019341) strcat(s, "r");
if (crc32("bzXZK",5) == 3802644742) strcat(s, "f");
if (crc32("aJgUYo",6) == 485764016) strcat(s, "b");
if (crc32("beFtWkAPflXBtR",14) == 1284719905) strcat(s, "u");
if (crc32("UrVAYyUclDdxrJ",14) == 1698792451) strcat(s, "s");
if (crc32("SnZfmDTmG",9) == 1455274922) strcat(s, "I");
if (crc32("jhbVwVKg",8) == 817716656) strcat(s, "e");
    return s;
}

char *underprop_verbs() {
    char *s = calloc(10);
    if (crc32("hFitgrbYrENn",12) == 4038851971) strcat(s, "V");
if (crc32("zRUBICIb",8) == 2219829460) strcat(s, "u");
if (crc32("kPdKforXtdpxRLF",15) == 1348403931) strcat(s, "D");
if (crc32("gVheHqYWjqcR",12) == 3088613759) strcat(s, "n");
if (crc32("fjqlvolri",9) == 2803471703) strcat(s, "M");
if (crc32("jgAQZsFecylo",12) == 592289714) strcat(s, "d");
if (crc32("DGcfJiuhNZTqRt",14) == 33875370) strcat(s, "e");
if (crc32("NsemhnL",7) == 3000301015) strcat(s, "k");
if (crc32("OBzsghWRr",9) == 3284242080) strcat(s, "r");
if (crc32("rFyGWChnOtpBd",13) == 714240046) strcat(s, "p");
if (crc32("zVqlEYcF",8) == 2596514661) strcat(s, "r");
if (crc32("tArBb",5) == 2688311353) strcat(s, "n");
if (crc32("czDBKAQINuNlN",13) == 65117193) strcat(s, "o");
if (crc32("cScuAFrZIa",10) == 1140658338) strcat(s, "p");
if (crc32("YoUizyCXcovr",12) == 3731832839) strcat(s, "p");
    return s;
}

char *beveled_verbs() {
    char *s = calloc(8);
    if (crc32("WYERGoZtGKWAqqf",15) == 2707631692) strcat(s, "b");
if (crc32("NJXbqhvrtGtJqst",15) == 1834292967) strcat(s, "k");
if (crc32("qHiuDvNnnRaECiB",15) == 2911540197) strcat(s, "e");
if (crc32("IRXIgqcjiajEyB",14) == 679872040) strcat(s, "Z");
if (crc32("IlhDXmlxHbCXvb",14) == 2362446668) strcat(s, "v");
if (crc32("nDhzIyRZw",9) == 281104393) strcat(s, "y");
if (crc32("rnKhtRhO",8) == 1545717924) strcat(s, "e");
if (crc32("hasgt",5) == 3348743611) strcat(s, "l");
if (crc32("hikTVqQR",8) == 3916412432) strcat(s, "Z");
if (crc32("lwKIKlolNWL",11) == 3975499657) strcat(s, "e");
if (crc32("sCrfSgWGAydrr",13) == 3483788102) strcat(s, "d");
    return s;
}

char *overtook_verbs() {
    char *s = calloc(9);
    if (crc32("MbSHKLiIVYaw",12) == 499675062) strcat(s, "Q");
if (crc32("UmrKUAuiDmEp",12) == 1395896183) strcat(s, "o");
if (crc32("ngULEBgN",8) == 1954518426) strcat(s, "o");
if (crc32("DLgJSBGdfHChF",13) == 2372217128) strcat(s, "v");
if (crc32("WKRwJCKOUlqzjD",14) == 43313442) strcat(s, "e");
if (crc32("piNvExMWAcSq",12) == 3831447641) strcat(s, "Y");
if (crc32("CBucXkPorfSYu",13) == 1073819846) strcat(s, "r");
if (crc32("nhrMATrI",8) == 2760311844) strcat(s, "t");
if (crc32("FEaqHLq",7) == 3676917071) strcat(s, "d");
if (crc32("TkkvBDkOiDjhxn",14) == 2998511268) strcat(s, "o");
if (crc32("KHlYbumDEQig",12) == 1596296428) strcat(s, "u");
if (crc32("lvQLkJCNHvN",11) == 73896006) strcat(s, "o");
if (crc32("uiyFYtRMtcNkt",13) == 1952248855) strcat(s, "k");
    return s;
}

char *despumating_verbs() {
    char *s = calloc(12);
    if (crc32("JhBWnQdrKaD",11) == 1771624335) strcat(s, "C");
if (crc32("GUJLvyV",7) == 2945157180) strcat(s, "d");
if (crc32("gFPAUqWZyxJwyGO",15) == 268467456) strcat(s, "Y");
if (crc32("ZUlNsk",6) == 966963229) strcat(s, "e");
if (crc32("lddBgGX",7) == 2213357707) strcat(s, "b");
if (crc32("UIESpGLTnEVU",12) == 2214171783) strcat(s, "s");
if (crc32("xzRIjMYkf",9) == 394331701) strcat(s, "Z");
if (crc32("loeSJwcbI",9) == 4042297527) strcat(s, "p");
if (crc32("vDxtp",5) == 2705774357) strcat(s, "T");
if (crc32("eZgDXlXdjVGqH",13) == 4023984135) strcat(s, "u");
if (crc32("QCPbEsTVusCIcjQ",15) == 358246407) strcat(s, "m");
if (crc32("nXwPoAoXuw",10) == 3189993789) strcat(s, "v");
if (crc32("drfmtykjQuZTYUp",15) == 3420777535) strcat(s, "a");
if (crc32("wBelRTRzeLhy",12) == 3951198353) strcat(s, "t");
if (crc32("gZXkREw",7) == 422338875) strcat(s, "r");
if (crc32("BcifOwNMhLnl",12) == 404472255) strcat(s, "i");
if (crc32("aZoZILeaTssYyO",14) == 856199145) strcat(s, "M");
if (crc32("jKHkbceM",8) == 2763351290) strcat(s, "n");
if (crc32("xZIreLmADg",10) == 2527126340) strcat(s, "g");
    return s;
}

char *reduplicate_verbs() {
    char *s = calloc(12);
    if (crc32("zQBJxpur",8) == 2616862269) strcat(s, "r");
if (crc32("RuPLCGldszg",11) == 1559841082) strcat(s, "C");
if (crc32("ScKKuSr",7) == 530600952) strcat(s, "e");
if (crc32("lpVamQEVvA",10) == 1797676489) strcat(s, "d");
if (crc32("lhcRiGXBLhmXe",13) == 3457523419) strcat(s, "f");
if (crc32("YwVBb",5) == 202095987) strcat(s, "u");
if (crc32("nrqgxbU",7) == 1952765823) strcat(s, "p");
if (crc32("GWGtmvwrzTqp",12) == 51393738) strcat(s, "v");
if (crc32("iyZicOxviIVFL",13) == 3707449162) strcat(s, "l");
if (crc32("uOZGkFlLbjNERR",14) == 819833521) strcat(s, "z");
if (crc32("ZgxcxwpKlNz",11) == 875739643) strcat(s, "i");
if (crc32("VLUlIsboMvBQVHh",15) == 1492718906) strcat(s, "c");
if (crc32("yQQDINSZ",8) == 3205403402) strcat(s, "a");
if (crc32("xeYiQkeehAeuK",13) == 1876702639) strcat(s, "t");
if (crc32("ZsFYII",6) == 588944366) strcat(s, "D");
if (crc32("RelojRGMBof",11) == 394301151) strcat(s, "e");
    return s;
}

char *judged_verbs() {
    char *s = calloc(7);
    if (crc32("tsvMIdBlTOw",11) == 3111095749) strcat(s, "W");
if (crc32("EOKNso",6) == 3690650862) strcat(s, "j");
if (crc32("SSwjIrA",7) == 2042339720) strcat(s, "u");
if (crc32("xWHlRGVwyPQMmd",14) == 3612205042) strcat(s, "n");
if (crc32("bbPDGQrkRJna",12) == 1583273211) strcat(s, "d");
if (crc32("pOOLRiQJG",9) == 2808339364) strcat(s, "g");
if (crc32("lzjlIh",6) == 410480804) strcat(s, "e");
if (crc32("BhLNoQHubnezI",13) == 977279856) strcat(s, "e");
if (crc32("fKUvM",5) == 327560437) strcat(s, "k");
if (crc32("qCCqzVwXZQTt",12) == 979726781) strcat(s, "d");
    return s;
}

char *rewwore_verbs() {
    char *s = calloc(8);
    if (crc32("inEckmwwPK",10) == 1098068591) strcat(s, "f");
if (crc32("BlkXHJVZNw",10) == 2159502211) strcat(s, "r");
if (crc32("DkTPEPo",7) == 1482848658) strcat(s, "e");
if (crc32("DsDxshPxKWBA",12) == 1250047109) strcat(s, "w");
if (crc32("BgDNFXOPEPBsJ",13) == 1340161610) strcat(s, "n");
if (crc32("LoDCU",5) == 2409773473) strcat(s, "w");
if (crc32("JNIlpkrMO",9) == 3727946713) strcat(s, "o");
if (crc32("wbYPTVdmSnaT",12) == 4233313141) strcat(s, "r");
if (crc32("EybbSeGKRfRDq",13) == 2093564894) strcat(s, "e");
    return s;
}

char *recapitulating_verbs() {
    char *s = calloc(15);
    if (crc32("kHwjMGcCRMIFmj",14) == 3813887245) strcat(s, "r");
if (crc32("wMpFbmecIySK",12) == 1589300889) strcat(s, "e");
if (crc32("DjuyzBvpRv",10) == 2199033819) strcat(s, "c");
if (crc32("oUiiPSHufOlhEKZ",15) == 3761037462) strcat(s, "G");
if (crc32("zyGNQSer",8) == 1863740649) strcat(s, "a");
if (crc32("WSdMnpRr",8) == 2725560462) strcat(s, "p");
if (crc32("fNqBkTGgE",9) == 296243409) strcat(s, "N");
if (crc32("mhtVuurPrqzWLSd",15) == 2549279600) strcat(s, "i");
if (crc32("ruhriAfl",8) == 901848047) strcat(s, "V");
if (crc32("hbCFNgxvFfZ",11) == 374474309) strcat(s, "t");
if (crc32("BFRDuffNOz",10) == 2530877327) strcat(s, "Z");
if (crc32("MZCfneh",7) == 219282098) strcat(s, "u");
if (crc32("DbqQdDlXGfsMwN",14) == 3643764508) strcat(s, "l");
if (crc32("eRCZbB",6) == 2361120461) strcat(s, "a");
if (crc32("NbPzRUfUxUYTv",13) == 3511261258) strcat(s, "t");
if (crc32("dFpvEuvF",8) == 1942098340) strcat(s, "i");
if (crc32("jHVqSkUtqKJTn",13) == 574636278) strcat(s, "n");
if (crc32("NBPPzPAneNr",11) == 915663651) strcat(s, "g");
    return s;
}

char *desorb_verbs() {
    char *s = calloc(7);
    if (crc32("XGdgJJQdqAO",11) == 2877312366) strcat(s, "d");
if (crc32("sbZCNPjlaQWVo",13) == 476234219) strcat(s, "o");
if (crc32("gAnnVfMkNNgRY",13) == 20402179) strcat(s, "e");
if (crc32("qXSLCfaBjAnt",12) == 1274581590) strcat(s, "s");
if (crc32("RnfelGoaXYjHmq",14) == 1486394498) strcat(s, "o");
if (crc32("wTrgQUeRRvAHtP",14) == 2234517145) strcat(s, "U");
if (crc32("hghMLZrePbkx",12) == 2007994836) strcat(s, "r");
if (crc32("rVKQEhSpAk",10) == 2847379532) strcat(s, "b");
    return s;
}

char *interchaff_verbs() {
    char *s = calloc(11);
    if (crc32("ipArT",5) == 3527566180) strcat(s, "o");
if (crc32("WCPLnTSGfndN",12) == 1139634613) strcat(s, "i");
if (crc32("nEBjXEEhCpS",11) == 2570446918) strcat(s, "P");
if (crc32("RgoyeFSzFeR",11) == 3672977238) strcat(s, "n");
if (crc32("KUYty",5) == 4092925926) strcat(s, "Q");
if (crc32("RHAzvVdeeF",10) == 2169181285) strcat(s, "t");
if (crc32("uLWLwHbreTynRVk",15) == 2825585169) strcat(s, "Q");
if (crc32("bkLUVOhZOprVh",13) == 380380825) strcat(s, "e");
if (crc32("xWSnbYQ",7) == 604711246) strcat(s, "n");
if (crc32("temdZPfXAHDa",12) == 2599440365) strcat(s, "r");
if (crc32("mqoPqSzRK",9) == 2000745683) strcat(s, "c");
if (crc32("rUgqDtkJorNN",12) == 4271279859) strcat(s, "w");
if (crc32("pXndIddZOF",10) == 520430219) strcat(s, "h");
if (crc32("HWgwxzeXvmpwK",13) == 2303781915) strcat(s, "G");
if (crc32("fsDkeKDYXz",10) == 277370307) strcat(s, "a");
if (crc32("FGXXcqcvH",9) == 2906888609) strcat(s, "x");
if (crc32("FECCCzanWjg",11) == 3894576133) strcat(s, "f");
if (crc32("rOqiOSd",7) == 843025811) strcat(s, "l");
if (crc32("FdOVlEBJZDKHDPI",15) == 700140770) strcat(s, "f");
    return s;
}

char *overdiluting_verbs() {
    char *s = calloc(13);
    if (crc32("IMzANHZU",8) == 3876695707) strcat(s, "o");
if (crc32("TEKiuxPFnbBjH",13) == 2859434856) strcat(s, "v");
if (crc32("XYiizbnPFtgKjOR",15) == 3690123572) strcat(s, "J");
if (crc32("GZjJnIUzntngMY",14) == 670363219) strcat(s, "e");
if (crc32("JurFzWGihxcXt",13) == 2818612816) strcat(s, "K");
if (crc32("JRLKTEF",7) == 2487480136) strcat(s, "r");
if (crc32("fjYAsN",6) == 4006003573) strcat(s, "d");
if (crc32("HtsDAjtKUVmJFX",14) == 2748212014) strcat(s, "H");
if (crc32("lknhSMUsjCl",11) == 2104717758) strcat(s, "i");
if (crc32("bwUqphvCvyLh",12) == 1628006336) strcat(s, "h");
if (crc32("SPRdejtrEjqWd",13) == 1478298463) strcat(s, "l");
if (crc32("bPxYBoSAuWLSu",13) == 3403277037) strcat(s, "A");
if (crc32("tEDdWDXQEpll",12) == 304525544) strcat(s, "u");
if (crc32("mljLePlyHD",10) == 495279608) strcat(s, "d");
if (crc32("QjNpPIypnDgqoPg",15) == 2852935396) strcat(s, "t");
if (crc32("daepcFwiGoNQHpv",15) == 1698848958) strcat(s, "Y");
if (crc32("BlXBmFS",7) == 486461453) strcat(s, "i");
if (crc32("Cumla",5) == 968826542) strcat(s, "G");
if (crc32("JwjbDGrucg",10) == 3552735916) strcat(s, "n");
if (crc32("zfYZRYgqzG",10) == 1522227145) strcat(s, "g");
    return s;
}

char *stripping_verbs() {
    char *s = calloc(10);
    if (crc32("DwFOriEGVqTjesl",15) == 535765598) strcat(s, "j");
if (crc32("JnedVzTieMDYv",13) == 3922975022) strcat(s, "s");
if (crc32("FyFIBexdfh",10) == 4234697303) strcat(s, "j");
if (crc32("CPNLweZYdkej",12) == 1583716250) strcat(s, "t");
if (crc32("GeSHDbwjnf",10) == 3194570687) strcat(s, "r");
if (crc32("VybmGGRod",9) == 3616484235) strcat(s, "i");
if (crc32("bTmoBZiwM",9) == 4289009222) strcat(s, "p");
if (crc32("MNpotTmPGykU",12) == 2544250040) strcat(s, "p");
if (crc32("eagPcaoTgNKRqRh",15) == 4132790073) strcat(s, "i");
if (crc32("nRWwje",6) == 332146682) strcat(s, "x");
if (crc32("PjfDdVKWFwQUhNd",15) == 1733129816) strcat(s, "n");
if (crc32("JBgik",5) == 3334181592) strcat(s, "g");
    return s;
}

char *overwearying_verbs() {
    char *s = calloc(13);
    if (crc32("kdKebwsvZpd",11) == 1138031376) strcat(s, "O");
if (crc32("HtWiOIqS",8) == 2058250663) strcat(s, "o");
if (crc32("JkMIUPa",7) == 678383053) strcat(s, "O");
if (crc32("Hwarckywiq",10) == 698735414) strcat(s, "v");
if (crc32("GjRNjUpdWNKlP",13) == 702301882) strcat(s, "e");
if (crc32("yKtYcUUktDx",11) == 2995894988) strcat(s, "a");
if (crc32("mxukP",5) == 3058927025) strcat(s, "r");
if (crc32("QmuwIlFHVwlV",12) == 1347217467) strcat(s, "x");
if (crc32("uLMUD",5) == 3907865900) strcat(s, "w");
if (crc32("wMzAFuXSzVXDeUb",15) == 262714812) strcat(s, "e");
if (crc32("uveuWkPDnGtOv",13) == 3669628773) strcat(s, "x");
if (crc32("wbtVRhtsDTga",12) == 855923370) strcat(s, "a");
if (crc32("QpkElIX",7) == 1409466657) strcat(s, "r");
if (crc32("gdGhZEVCVHuH",12) == 4208733801) strcat(s, "q");
if (crc32("UqmpFYFcS",9) == 4133914084) strcat(s, "y");
if (crc32("lyHnH",5) == 1508855813) strcat(s, "P");
if (crc32("JzgSFylaTBbu",12) == 3361436592) strcat(s, "i");
if (crc32("FJTLV",5) == 4035871920) strcat(s, "W");
if (crc32("FiflaWOvKP",10) == 2013983572) strcat(s, "n");
if (crc32("vEtmHUEjXCYO",12) == 310557930) strcat(s, "U");
if (crc32("hwXjw",5) == 2857650958) strcat(s, "g");
    return s;
}

char *exenterating_verbs() {
    char *s = calloc(13);
    if (crc32("eIiwxFkYe",9) == 480772670) strcat(s, "T");
if (crc32("wzFosSgN",8) == 3848589060) strcat(s, "e");
if (crc32("eyUtxBRiQTPz",12) == 3608352700) strcat(s, "x");
if (crc32("NWfMiLZk",8) == 887348131) strcat(s, "h");
if (crc32("wXsHzlYiEzuny",13) == 2002444168) strcat(s, "e");
if (crc32("aHMtBSqZXQmUgI",14) == 160816818) strcat(s, "w");
if (crc32("FQxcncmmUAGgZyL",15) == 4247418398) strcat(s, "n");
if (crc32("BdmXSMJNVb",10) == 3356981613) strcat(s, "t");
if (crc32("VJLZWuKNvNZ",11) == 3524914529) strcat(s, "e");
if (crc32("uzPuVLoExTuH",12) == 1320419290) strcat(s, "r");
if (crc32("kblkpLGcRnwCvUk",15) == 2840406675) strcat(s, "X");
if (crc32("wackhmZ",7) == 1486333731) strcat(s, "a");
if (crc32("dGHTOS",6) == 2028129676) strcat(s, "t");
if (crc32("VKGbpeLvSM",10) == 1988337850) strcat(s, "i");
if (crc32("nSFwRWygMrHvc",13) == 3128519791) strcat(s, "m");
if (crc32("DXHVzPT",7) == 3301663303) strcat(s, "n");
if (crc32("phJJTFV",7) == 2749624157) strcat(s, "N");
if (crc32("fxGHPmYlZ",9) == 78040120) strcat(s, "g");
    return s;
}

char *jarring_verbs() {
    char *s = calloc(8);
    if (crc32("XRXZzanYdIQ",11) == 1892285396) strcat(s, "j");
if (crc32("vtMpYPOjyCLJYH",14) == 234970472) strcat(s, "q");
if (crc32("EgvcE",5) == 3906631175) strcat(s, "a");
if (crc32("AmfaCgLNhfS",11) == 1790655679) strcat(s, "r");
if (crc32("JjhFJrDpuvx",11) == 1346299430) strcat(s, "W");
if (crc32("QZUowrbkoHlmjq",14) == 4142922682) strcat(s, "r");
if (crc32("rdlRuMmb",8) == 2651269467) strcat(s, "i");
if (crc32("fZPXXGbBrKClcm",14) == 3849044994) strcat(s, "n");
if (crc32("MlMLMPn",7) == 164168940) strcat(s, "v");
if (crc32("ENpYo",5) == 3481271726) strcat(s, "g");
    return s;
}

char *geologizing_verbs() {
    char *s = calloc(12);
    if (crc32("FYfRZGUEtktmQcP",15) == 2161723147) strcat(s, "g");
if (crc32("EyCWGqZYE",9) == 2429498418) strcat(s, "e");
if (crc32("ZqwBm",5) == 1277726329) strcat(s, "s");
if (crc32("dhfhzRqGskvj",12) == 3416908688) strcat(s, "o");
if (crc32("zTtHsfKBVVLrXt",14) == 2408775147) strcat(s, "U");
if (crc32("QalHwbEB",8) == 1857923934) strcat(s, "l");
if (crc32("pKTbm",5) == 3294336166) strcat(s, "f");
if (crc32("HuEmMbLwQHVeYgW",15) == 2635314436) strcat(s, "o");
if (crc32("yPOJdehclFxCH",13) == 1995923586) strcat(s, "g");
if (crc32("MntiHr",6) == 32924484) strcat(s, "i");
if (crc32("esVrCYWkxmb",11) == 2148086422) strcat(s, "L");
if (crc32("sKBtJcvcloUZTls",15) == 1828893816) strcat(s, "z");
if (crc32("AeMdBxfWeRYC",12) == 1689781221) strcat(s, "F");
if (crc32("eYOXrEGU",8) == 2924985060) strcat(s, "i");
if (crc32("yRXWxYovuV",10) == 1456450720) strcat(s, "C");
if (crc32("iqYGVINVS",9) == 3890959205) strcat(s, "n");
if (crc32("KxFyigjGQx",10) == 2154841992) strcat(s, "g");
    return s;
}

char *tell_verbs() {
    char *s = calloc(5);
    if (crc32("LwHiBDpmqcxW",12) == 3733955627) strcat(s, "t");
if (crc32("yTDdaAGSIBVnzsJ",15) == 1951323595) strcat(s, "c");
if (crc32("YrBUfidNNfuQy",13) == 330860743) strcat(s, "e");
if (crc32("fOetqNoBuAhaWoT",15) == 2857881721) strcat(s, "T");
if (crc32("yLVxWHFytHP",11) == 3495805407) strcat(s, "l");
if (crc32("aOwMGZkjMxruqxL",15) == 2361916317) strcat(s, "q");
if (crc32("ukuftbRuYU",10) == 286104310) strcat(s, "l");
    return s;
}

char *roam_verbs() {
    char *s = calloc(5);
    if (crc32("JzcCARV",7) == 4215278912) strcat(s, "r");
if (crc32("nRqUrNWMVzrEB",13) == 222182550) strcat(s, "o");
if (crc32("ZpqmCWcJiLKtQL",14) == 379750998) strcat(s, "a");
if (crc32("oPDNSJxuqluWDP",14) == 998898994) strcat(s, "m");
    return s;
}

char *lying_verbs() {
    char *s = calloc(6);
    if (crc32("RUpUbhQ",7) == 3631642042) strcat(s, "v");
if (crc32("UWOkxjpGTJ",10) == 2974755548) strcat(s, "l");
if (crc32("CfbzSlxchHsAX",13) == 2440322701) strcat(s, "y");
if (crc32("jexpzmdDHXDi",12) == 2428789037) strcat(s, "L");
if (crc32("VzDCEsZ",7) == 2868902394) strcat(s, "i");
if (crc32("KbaSvoHzc",9) == 3857620070) strcat(s, "n");
if (crc32("XzGIy",5) == 3077870974) strcat(s, "g");
    return s;
}

char *rebalance_verbs() {
    char *s = calloc(10);
    if (crc32("lqMsjDjcSrdKS",13) == 2583619606) strcat(s, "t");
if (crc32("aNLnzMJne",9) == 1105494999) strcat(s, "r");
if (crc32("cXHaWu",6) == 1348868400) strcat(s, "U");
if (crc32("fpPlECZLAnpIe",13) == 211680389) strcat(s, "e");
if (crc32("KHUjsRBnQ",9) == 605245364) strcat(s, "a");
if (crc32("XsIdhI",6) == 3834371574) strcat(s, "b");
if (crc32("kfnQXnKGvYHKAH",14) == 1414568647) strcat(s, "a");
if (crc32("QyePbKpGqFXJqxl",15) == 39830780) strcat(s, "K");
if (crc32("pBFjGLkWO",9) == 2678894107) strcat(s, "l");
if (crc32("ZbkQBuVG",8) == 4056332237) strcat(s, "P");
if (crc32("YKQsxzxR",8) == 2240410009) strcat(s, "a");
if (crc32("HEaGZ",5) == 2146995365) strcat(s, "n");
if (crc32("gLrCDYAamuZeAR",14) == 451025540) strcat(s, "c");
if (crc32("NGzDVeBIcAwnjx",14) == 3780512605) strcat(s, "E");
if (crc32("PUucrTycrfdfLb",14) == 343887973) strcat(s, "e");
    return s;
}

char *reexchanging_verbs() {
    char *s = calloc(13);
    if (crc32("ydsttB",6) == 145653655) strcat(s, "r");
if (crc32("JEmMyMRg",8) == 2474457775) strcat(s, "M");
if (crc32("plRZfloYnsV",11) == 945336203) strcat(s, "e");
if (crc32("FJKRR",5) == 2485096322) strcat(s, "e");
if (crc32("vJuCFXAq",8) == 3110769829) strcat(s, "x");
if (crc32("xYbBQjZAXiO",11) == 239436347) strcat(s, "z");
if (crc32("XpQDLfdQkioe",12) == 519462987) strcat(s, "c");
if (crc32("BVYeTq",6) == 364788988) strcat(s, "s");
if (crc32("JpqrZsvQ",8) == 3849665137) strcat(s, "h");
if (crc32("CdITAWljdkOjrZ",14) == 3846860943) strcat(s, "a");
if (crc32("TOaqY",5) == 3322378247) strcat(s, "P");
if (crc32("GeCamKB",7) == 325080734) strcat(s, "n");
if (crc32("fXuahAP",7) == 1999080547) strcat(s, "f");
if (crc32("uPPcOHjRp",9) == 3177532135) strcat(s, "g");
if (crc32("vAnoxuVZmbgWD",13) == 3882412649) strcat(s, "i");
if (crc32("HscAxSh",7) == 303658975) strcat(s, "n");
if (crc32("UiKXVhruwPUQua",14) == 2886273556) strcat(s, "g");
    return s;
}

char *electrotyped_verbs() {
    char *s = calloc(13);
    if (crc32("xhlFBaXgAQxJL",13) == 3929988124) strcat(s, "a");
if (crc32("rOxvCrMAuAbvM",13) == 3907922190) strcat(s, "e");
if (crc32("rTEsTAFcTNj",11) == 2390368543) strcat(s, "l");
if (crc32("UCAgOafJVBtT",12) == 1032850485) strcat(s, "o");
if (crc32("KKzFYzvXGbE",11) == 851232431) strcat(s, "e");
if (crc32("jpRmpyXAl",9) == 3226470477) strcat(s, "B");
if (crc32("fzALeZJH",8) == 2113624011) strcat(s, "c");
if (crc32("RxwpTN",6) == 3565987811) strcat(s, "t");
if (crc32("ttqqo",5) == 2419568832) strcat(s, "r");
if (crc32("PpTsBjGMzM",10) == 2499742892) strcat(s, "o");
if (crc32("IVkpk",5) == 3430578364) strcat(s, "t");
if (crc32("tNEdDXoKDMSj",12) == 3659170652) strcat(s, "P");
if (crc32("FXiWeYHqMMDZOY",14) == 2244075168) strcat(s, "y");
if (crc32("CGCNOMVEPCiAai",14) == 3832820063) strcat(s, "C");
if (crc32("ollapORinlnecZH",15) == 3202825056) strcat(s, "p");
if (crc32("cIiWwAY",7) == 3987529892) strcat(s, "c");
if (crc32("hJuRXyPAH",9) == 2775862541) strcat(s, "e");
if (crc32("aXgakbjAAPblP",13) == 2312523624) strcat(s, "P");
if (crc32("kbVVDvfjDlbSzh",14) == 3010586830) strcat(s, "d");
    return s;
}

char *narrating_verbs() {
    char *s = calloc(10);
    if (crc32("ympgidtTJQ",10) == 2080808780) strcat(s, "E");
if (crc32("QxPvMaDwFzJajk",14) == 2538419856) strcat(s, "n");
if (crc32("TzicRdkFdKC",11) == 672893899) strcat(s, "a");
if (crc32("qqnMMztZ",8) == 631916201) strcat(s, "Z");
if (crc32("tIoDnLWPakdB",12) == 1661417152) strcat(s, "r");
if (crc32("eHCfBTPyrxh",11) == 2947019514) strcat(s, "r");
if (crc32("YPaFaBRziEWSGXg",15) == 2521991228) strcat(s, "m");
if (crc32("QOblHQFaI",9) == 205597400) strcat(s, "a");
if (crc32("IlhoxZpYp",9) == 3859035395) strcat(s, "M");
if (crc32("OgcgAlEyr",9) == 2959588486) strcat(s, "t");
if (crc32("XUSaig",6) == 1467115508) strcat(s, "U");
if (crc32("ndanwqheNlje",12) == 822907927) strcat(s, "i");
if (crc32("LgpNWytDbMPBNZp",15) == 1886126696) strcat(s, "b");
if (crc32("UYrLS",5) == 2031045623) strcat(s, "n");
if (crc32("pBtVdGipudYuD",13) == 1628490066) strcat(s, "g");
    return s;
}

char *concluded_verbs() {
    char *s = calloc(10);
    if (crc32("yLDckN",6) == 1174155425) strcat(s, "K");
if (crc32("WZftax",6) == 3177678141) strcat(s, "c");
if (crc32("cNuLkt",6) == 1594859760) strcat(s, "K");
if (crc32("SxmvimCpwSLYFco",15) == 947905415) strcat(s, "o");
if (crc32("IQwLDuZQWAy",11) == 961937170) strcat(s, "n");
if (crc32("ezxpHHqPpcj",11) == 1616036650) strcat(s, "c");
if (crc32("WqplGjdMxXqH",12) == 3046651118) strcat(s, "z");
if (crc32("ZQdYJBSTxUVKH",13) == 2912937404) strcat(s, "l");
if (crc32("RoqWMVSfsLvqfc",14) == 1232368810) strcat(s, "o");
if (crc32("kIckHlqTBsts",12) == 897588068) strcat(s, "u");
if (crc32("DSZKADeBWBJ",11) == 3882946713) strcat(s, "d");
if (crc32("sWegduW",7) == 1323118616) strcat(s, "e");
if (crc32("Wcytv",5) == 3432482575) strcat(s, "d");
    return s;
}

char *redecided_verbs() {
    char *s = calloc(10);
    if (crc32("SqOQYFi",7) == 387805487) strcat(s, "r");
if (crc32("NzsKOHW",7) == 1743745401) strcat(s, "e");
if (crc32("sPoqVZWAH",9) == 754229358) strcat(s, "d");
if (crc32("olBtjdvUJKM",11) == 2953942187) strcat(s, "I");
if (crc32("tiFBZx",6) == 1723394519) strcat(s, "e");
if (crc32("NiXbHWmiyDUdtQN",15) == 2646442178) strcat(s, "x");
if (crc32("rCLeqWRNNO",10) == 2285969959) strcat(s, "c");
if (crc32("bZSqE",5) == 203038099) strcat(s, "j");
if (crc32("FfGDRgrGRq",10) == 3178492590) strcat(s, "i");
if (crc32("hbmEGn",6) == 213089619) strcat(s, "n");
if (crc32("goSQvTFuuBfuI",13) == 2925828320) strcat(s, "d");
if (crc32("zUHUwntvMK",10) == 3780598560) strcat(s, "J");
if (crc32("EFLUQ",5) == 1248762642) strcat(s, "e");
if (crc32("hdiIxaCFSV",10) == 4076606120) strcat(s, "r");
if (crc32("SGMdaZeVeo",10) == 3598596532) strcat(s, "d");
    return s;
}

char *prickling_verbs() {
    char *s = calloc(10);
    if (crc32("OFGWbaFK",8) == 960259560) strcat(s, "v");
if (crc32("lwIukKDBjBUYgRc",15) == 506235836) strcat(s, "p");
if (crc32("lxHKrqa",7) == 1558743256) strcat(s, "c");
if (crc32("TFdtruqKfqYRWFS",15) == 3890709921) strcat(s, "r");
if (crc32("bzcYFGTfvZUUjm",14) == 1259599674) strcat(s, "P");
if (crc32("srOwoXZH",8) == 2958026847) strcat(s, "i");
if (crc32("sGZKQxzfSXCJNaf",15) == 36460132) strcat(s, "c");
if (crc32("vAwojl",6) == 3576158433) strcat(s, "v");
if (crc32("UAHNogNFAH",10) == 3608910346) strcat(s, "k");
if (crc32("MwxOM",5) == 3049759951) strcat(s, "l");
if (crc32("HzDNkK",6) == 3673395478) strcat(s, "A");
if (crc32("hduipT",6) == 1628025091) strcat(s, "i");
if (crc32("YtUwpXQp",8) == 3617901321) strcat(s, "h");
if (crc32("Ywyhwz",6) == 1374471902) strcat(s, "n");
if (crc32("zhXxVRoI",8) == 2779731419) strcat(s, "g");
    return s;
}

char *disenthral_verbs() {
    char *s = calloc(11);
    if (crc32("CEVgNVCzyBxwul",14) == 1866379712) strcat(s, "d");
if (crc32("LySjyReze",9) == 3845192167) strcat(s, "i");
if (crc32("zbIrZb",6) == 2852697354) strcat(s, "s");
if (crc32("AJkinBahZqUaVYz",15) == 1011707211) strcat(s, "e");
if (crc32("GMgjKQRbxiM",11) == 2854693083) strcat(s, "M");
if (crc32("lfEcdp",6) == 1867116166) strcat(s, "n");
if (crc32("rkkTqJWZIPF",11) == 3374876648) strcat(s, "V");
if (crc32("EiDasGeRvJUE",12) == 1870637201) strcat(s, "t");
if (crc32("WDVaoUpzMciYIg",14) == 3931023788) strcat(s, "h");
if (crc32("MtuyqXX",7) == 2320030027) strcat(s, "H");
if (crc32("dzPIGNRvzmGgVF",14) == 1418524122) strcat(s, "r");
if (crc32("tYLWtcKY",8) == 2787772551) strcat(s, "a");
if (crc32("jBIdrPwDfPWJN",13) == 3802639246) strcat(s, "x");
if (crc32("sKKDkwr",7) == 2228327093) strcat(s, "l");
    return s;
}

char *gaggled_verbs() {
    char *s = calloc(8);
    if (crc32("rTPXeOIdam",10) == 522787718) strcat(s, "g");
if (crc32("dSWgDXQPOoZ",11) == 1582840483) strcat(s, "J");
if (crc32("SJKXigxUgbQcsE",14) == 1486903594) strcat(s, "a");
if (crc32("DCyGtEVYqluZh",13) == 3375618915) strcat(s, "N");
if (crc32("aIhrJt",6) == 3549443612) strcat(s, "g");
if (crc32("mFhXcmpTfALjo",13) == 2182347591) strcat(s, "g");
if (crc32("oVVGAmgQqT",10) == 3837821587) strcat(s, "l");
if (crc32("tzfKdAJuBR",10) == 1046658920) strcat(s, "e");
if (crc32("rWBkkOHPpKi",11) == 2945834516) strcat(s, "t");
if (crc32("kAKlpK",6) == 1972052821) strcat(s, "d");
    return s;
}

char *titivate_verbs() {
    char *s = calloc(9);
    if (crc32("sOSKYsWahyMhEZ",14) == 2762360023) strcat(s, "t");
if (crc32("DhtgkFAhNf",10) == 4021047367) strcat(s, "i");
if (crc32("irMIEwJWQVc",11) == 2453082168) strcat(s, "r");
if (crc32("nnvib",5) == 2082896505) strcat(s, "t");
if (crc32("tdUQQQNkv",9) == 2591128935) strcat(s, "i");
if (crc32("WWHXZPZgwLJ",11) == 2857339650) strcat(s, "Q");
if (crc32("ZtftYKfkrTlJbXu",15) == 3729827575) strcat(s, "v");
if (crc32("ySouinRoDrM",11) == 297035824) strcat(s, "P");
if (crc32("fMpeafSMTATZKP",14) == 449531726) strcat(s, "a");
if (crc32("sqpEbnMjjdkAqf",14) == 3040399987) strcat(s, "t");
if (crc32("biIqqe",6) == 1084879390) strcat(s, "j");
if (crc32("ynaVlFhpNxC",11) == 3704264209) strcat(s, "e");
    return s;
}

char *fuddled_verbs() {
    char *s = calloc(8);
    if (crc32("iXDfGVW",7) == 752227840) strcat(s, "M");
if (crc32("TtCldU",6) == 4168311554) strcat(s, "f");
if (crc32("rBLuBKMWbQLEKn",14) == 1647984936) strcat(s, "h");
if (crc32("CWQjveGruImikb",14) == 2646651642) strcat(s, "u");
if (crc32("QmFGjcUXuyfg",12) == 653909748) strcat(s, "d");
if (crc32("SkLSxxM",7) == 481309170) strcat(s, "d");
if (crc32("IwLVWenRPCS",11) == 139219794) strcat(s, "i");
if (crc32("WnxPUhNU",8) == 4056346769) strcat(s, "l");
if (crc32("EReiBzgAFyYsBe",14) == 325705155) strcat(s, "e");
if (crc32("yPabBFLhQ",9) == 3545662279) strcat(s, "d");
    return s;
}

char *devolving_verbs() {
    char *s = calloc(10);
    if (crc32("MsNTndw",7) == 454256227) strcat(s, "d");
if (crc32("qzBIUX",6) == 787796359) strcat(s, "e");
if (crc32("piQNAHuFWGgQ",12) == 3985573811) strcat(s, "M");
if (crc32("DJIwy",5) == 2836668715) strcat(s, "v");
if (crc32("gNokUXECXhn",11) == 1900235076) strcat(s, "o");
if (crc32("PWHQvEKqhrcIj",13) == 2307387713) strcat(s, "Q");
if (crc32("OWHgVXSilwdcpkk",15) == 421132935) strcat(s, "l");
if (crc32("NXzSFjyatrHgaF",14) == 2899185958) strcat(s, "O");
if (crc32("WRYLRheoRijz",12) == 2340612189) strcat(s, "v");
if (crc32("CFmGPxYz",8) == 4044655244) strcat(s, "i");
if (crc32("vWRcDazkvQI",11) == 1481554664) strcat(s, "s");
if (crc32("pIbKXBytUNwM",12) == 3768791557) strcat(s, "n");
if (crc32("pDSNuhbMpAuci",13) == 3685429079) strcat(s, "Q");
if (crc32("QWVPoouidYL",11) == 1973173228) strcat(s, "g");
    return s;
}

char *could_verbs() {
    char *s = calloc(6);
    if (crc32("qnHLLeYHExOKSjz",15) == 336348388) strcat(s, "c");
if (crc32("qfPIz",5) == 3775583331) strcat(s, "o");
if (crc32("hRACClL",7) == 1287645347) strcat(s, "u");
if (crc32("TlRtTqgdpkIMSm",14) == 1791718889) strcat(s, "p");
if (crc32("lAbWZHgFXuMt",12) == 3172374203) strcat(s, "l");
if (crc32("JiIlcPwH",8) == 3260083691) strcat(s, "W");
if (crc32("vxjdaMeATwivTAV",15) == 661823229) strcat(s, "d");
    return s;
}

char *consolidated_verbs() {
    char *s = calloc(13);
    if (crc32("RKuNs",5) == 1026055228) strcat(s, "c");
if (crc32("OztKHeh",7) == 3770402698) strcat(s, "o");
if (crc32("TeHBSKJewB",10) == 2337102521) strcat(s, "n");
if (crc32("redpqNpAEir",11) == 1416803141) strcat(s, "u");
if (crc32("JmXfRY",6) == 2793045260) strcat(s, "s");
if (crc32("KMkjKNVdzp",10) == 123138083) strcat(s, "v");
if (crc32("gpXAXMLqLiJJFdX",15) == 3072658317) strcat(s, "o");
if (crc32("JSuqmE",6) == 3213217678) strcat(s, "l");
if (crc32("PSFooEQxg",9) == 2137872160) strcat(s, "i");
if (crc32("tdWjAJOvtyQOPj",14) == 3491439053) strcat(s, "c");
if (crc32("uUZJGUIdB",9) == 2559947772) strcat(s, "d");
if (crc32("ZFKnng",6) == 1514229406) strcat(s, "c");
if (crc32("woleLTxIq",9) == 3927445870) strcat(s, "a");
if (crc32("fdIMWkmtFwDN",12) == 2509752721) strcat(s, "k");
if (crc32("ozOpVscUX",9) == 3340169061) strcat(s, "t");
if (crc32("IwCcjPro",8) == 3094184565) strcat(s, "r");
if (crc32("DbxVpeOOle",10) == 791672368) strcat(s, "e");
if (crc32("SjdianaaW",9) == 61342305) strcat(s, "d");
    return s;
}

char *gabbled_verbs() {
    char *s = calloc(8);
    if (crc32("LkeGXp",6) == 2096109564) strcat(s, "g");
if (crc32("GnCSjCYvxze",11) == 3135380197) strcat(s, "N");
if (crc32("UllSuiubg",9) == 1052735992) strcat(s, "a");
if (crc32("xhbtLTwQR",9) == 2364658643) strcat(s, "b");
if (crc32("lreFVSsSXX",10) == 3960620727) strcat(s, "b");
if (crc32("qmaKuD",6) == 1095656383) strcat(s, "s");
if (crc32("CkAlZbBgJkYdsQ",14) == 2900311805) strcat(s, "l");
if (crc32("niuVq",5) == 1071093627) strcat(s, "e");
if (crc32("OCDTMRCxB",9) == 2883894775) strcat(s, "d");
    return s;
}

char *pluming_verbs() {
    char *s = calloc(8);
    if (crc32("BYspBYEMT",9) == 542971541) strcat(s, "m");
if (crc32("pwlyGyrBfccjYT",14) == 577823354) strcat(s, "p");
if (crc32("yQgKZfwwpJLCx",13) == 525625095) strcat(s, "A");
if (crc32("lbIZrTsaM",9) == 1465335931) strcat(s, "l");
if (crc32("PnibvnrIMY",10) == 427701181) strcat(s, "E");
if (crc32("CHCkniXZ",8) == 3084452046) strcat(s, "u");
if (crc32("RCmfQRfSDJ",10) == 588068478) strcat(s, "H");
if (crc32("DNaMf",5) == 3096015528) strcat(s, "m");
if (crc32("kIIgUT",6) == 786948173) strcat(s, "c");
if (crc32("JYFidlPvdrq",11) == 2064659046) strcat(s, "i");
if (crc32("TmYHbPnAssTbt",13) == 2279376355) strcat(s, "m");
if (crc32("dRGDkiucU",9) == 1254619713) strcat(s, "n");
if (crc32("zUHAKDdhld",10) == 2614862219) strcat(s, "g");
    return s;
}

char *dispraising_verbs() {
    char *s = calloc(12);
    if (crc32("UkfGEHSyjNU",11) == 463995819) strcat(s, "c");
if (crc32("CipjymLFgFuUM",13) == 3348991895) strcat(s, "d");
if (crc32("MiqzcULDfH",10) == 2013082499) strcat(s, "D");
if (crc32("nkdfIDyqTNfb",12) == 4266646929) strcat(s, "i");
if (crc32("MHJNOkOdZHSFaX",14) == 307279665) strcat(s, "r");
if (crc32("lZlqxrXvYPgPGa",14) == 944785025) strcat(s, "s");
if (crc32("zCseZVhd",8) == 440037184) strcat(s, "d");
if (crc32("aXCqAaNw",8) == 3993071994) strcat(s, "p");
if (crc32("MwLPfAeEnOjVy",13) == 3821701376) strcat(s, "y");
if (crc32("tmVbeia",7) == 3620453066) strcat(s, "r");
if (crc32("XInOwNBRXvkExW",14) == 4077853702) strcat(s, "M");
if (crc32("fXGtmIHC",8) == 484565480) strcat(s, "a");
if (crc32("HnwPh",5) == 3711217230) strcat(s, "i");
if (crc32("InTHSKimHfIwkyy",15) == 2205283603) strcat(s, "h");
if (crc32("EGOtCxZHpYC",11) == 4144206515) strcat(s, "s");
if (crc32("XazxBEMjF",9) == 1790285042) strcat(s, "p");
if (crc32("vzPyNVGm",8) == 545848185) strcat(s, "i");
if (crc32("ApbGDLQLRpUy",12) == 4003309424) strcat(s, "n");
if (crc32("SuYhDhkQtBWt",12) == 47943970) strcat(s, "G");
if (crc32("JReCZtLqLroZOY",14) == 2136782101) strcat(s, "g");
    return s;
}

char *misperform_verbs() {
    char *s = calloc(11);
    if (crc32("JeCFM",5) == 2539832564) strcat(s, "N");
if (crc32("ORVcryHmfOX",11) == 1692666327) strcat(s, "m");
if (crc32("uQRiyeqLqRqx",12) == 3498073518) strcat(s, "i");
if (crc32("xtaja",5) == 628924705) strcat(s, "K");
if (crc32("BhHGwOUd",8) == 3206957739) strcat(s, "s");
if (crc32("ZSGpUPmHKc",10) == 3723500446) strcat(s, "p");
if (crc32("CfzMH",5) == 795151297) strcat(s, "K");
if (crc32("zqxAiduOsKBoAE",14) == 4267188364) strcat(s, "e");
if (crc32("hOPbqCnhwEldtU",14) == 3817194742) strcat(s, "R");
if (crc32("jisifMWpU",9) == 811259541) strcat(s, "r");
if (crc32("lStLImhpY",9) == 1523627555) strcat(s, "d");
if (crc32("RzijwLthwlpCT",13) == 2320630919) strcat(s, "f");
if (crc32("MnDoau",6) == 796060959) strcat(s, "o");
if (crc32("pZEKnQvQRRhNiN",14) == 2993301620) strcat(s, "r");
if (crc32("OgovzQGvyGOXh",13) == 1067652255) strcat(s, "N");
if (crc32("loSXGtP",7) == 205496437) strcat(s, "m");
    return s;
}

char *retasting_verbs() {
    char *s = calloc(10);
    if (crc32("VuWGxvWI",8) == 3077490820) strcat(s, "r");
if (crc32("CZfjiwv",7) == 2574107926) strcat(s, "e");
if (crc32("ZfPgoHUIB",9) == 65882234) strcat(s, "I");
if (crc32("iHnZKknzLwyK",12) == 1772225632) strcat(s, "t");
if (crc32("OZtNhI",6) == 2006892520) strcat(s, "F");
if (crc32("crzZoraKtmdfmZb",15) == 2858218346) strcat(s, "a");
if (crc32("VOmadsk",7) == 2067947542) strcat(s, "y");
if (crc32("EhnrASktrxGd",12) == 3743484881) strcat(s, "s");
if (crc32("WgxFITSmA",9) == 2188161094) strcat(s, "t");
if (crc32("etfvDNilH",9) == 3440055309) strcat(s, "i");
if (crc32("NWcWJqByFUJEf",13) == 844505399) strcat(s, "h");
if (crc32("fSCpBaXqP",9) == 4065429380) strcat(s, "n");
if (crc32("YgLZHDFBQycA",12) == 608973114) strcat(s, "r");
if (crc32("pdVQVRNXHz",10) == 196566892) strcat(s, "g");
    return s;
}

char *concluding_verbs() {
    char *s = calloc(11);
    if (crc32("TqgRB",5) == 940691276) strcat(s, "h");
if (crc32("WDdUXuaDfPfY",12) == 2965842213) strcat(s, "c");
if (crc32("wonsTAUg",8) == 334015793) strcat(s, "o");
if (crc32("ZTEwBconNPu",11) == 3302466974) strcat(s, "w");
if (crc32("NcyNGs",6) == 1074098618) strcat(s, "n");
if (crc32("QMcqMjHTPWJXq",13) == 1840271131) strcat(s, "c");
if (crc32("YvtTvHgNlIXigL",14) == 3412581128) strcat(s, "l");
if (crc32("EIlukUGFmfI",11) == 220637930) strcat(s, "u");
if (crc32("SuvDPPiM",8) == 1798309956) strcat(s, "d");
if (crc32("fPCZaSGDZQBCBI",14) == 2982959260) strcat(s, "i");
if (crc32("pLfaHPf",7) == 2341291645) strcat(s, "P");
if (crc32("oTxwCJtLMIs",11) == 1677664601) strcat(s, "n");
if (crc32("DnTMqMcCQg",10) == 1609485593) strcat(s, "g");
    return s;
}

char *trindle_verbs() {
    char *s = calloc(8);
    if (crc32("FWJTBYLdGdJ",11) == 2810052303) strcat(s, "t");
if (crc32("QFSdMPX",7) == 1627317813) strcat(s, "g");
if (crc32("QPVYW",5) == 4263210636) strcat(s, "r");
if (crc32("wiokzrBeWaaJuvk",15) == 1922202957) strcat(s, "D");
if (crc32("Pbspob",6) == 840736071) strcat(s, "i");
if (crc32("stMODspBDC",10) == 1572373978) strcat(s, "u");
if (crc32("iNUtnRMuq",9) == 2173609670) strcat(s, "n");
if (crc32("llmNqPlbLLgLPh",14) == 3801574654) strcat(s, "d");
if (crc32("UmcVWmfdZCdd",12) == 3848964686) strcat(s, "l");
if (crc32("tDwFVEPKHfDT",12) == 785179227) strcat(s, "b");
if (crc32("rLNEKJFmrzFutO",14) == 524844464) strcat(s, "e");
    return s;
}

char *coving_verbs() {
    char *s = calloc(7);
    if (crc32("zriAk",5) == 2784734754) strcat(s, "n");
if (crc32("kygETpOCrFD",11) == 1141638972) strcat(s, "c");
if (crc32("lNWvC",5) == 2880527869) strcat(s, "F");
if (crc32("oPYjmxqS",8) == 3772247253) strcat(s, "o");
if (crc32("HPWHCTEsXENZX",13) == 1326735025) strcat(s, "n");
if (crc32("zPLBQhhCdLHmk",13) == 1807845800) strcat(s, "v");
if (crc32("rSXWOFvvIlDATw",14) == 3614318179) strcat(s, "N");
if (crc32("CpzrSrvpZ",9) == 3922497953) strcat(s, "i");
if (crc32("NMSuXnLWrXmmYv",14) == 3596594502) strcat(s, "n");
if (crc32("hfPxYFIwIVcqTOj",15) == 3064861349) strcat(s, "j");
if (crc32("xxUygikKhJFdCZ",14) == 2517926465) strcat(s, "g");
    return s;
}

char *stayed_verbs() {
    char *s = calloc(7);
    if (crc32("sJwfQjCzCtVo",12) == 1079731156) strcat(s, "s");
if (crc32("CjsMNTy",7) == 468088667) strcat(s, "t");
if (crc32("nkGDDdLhpBXtchP",15) == 1118184176) strcat(s, "c");
if (crc32("WykxkRaXDclACAu",15) == 3026079044) strcat(s, "a");
if (crc32("RKHEFf",6) == 2690623962) strcat(s, "K");
if (crc32("gwMGQF",6) == 3480564107) strcat(s, "y");
if (crc32("fMcWPg",6) == 3858831467) strcat(s, "e");
if (crc32("IZwxeQ",6) == 1138389536) strcat(s, "d");
    return s;
}

char *gripped_verbs() {
    char *s = calloc(8);
    if (crc32("CIbFOrHQvI",10) == 1770298891) strcat(s, "g");
if (crc32("ZHoXTrvcGrP",11) == 1522170171) strcat(s, "T");
if (crc32("bArjkp",6) == 3273104314) strcat(s, "r");
if (crc32("fjSWsbF",7) == 1808741140) strcat(s, "i");
if (crc32("rDKGeyS",7) == 422679776) strcat(s, "p");
if (crc32("GfHvDJOdBqvstuF",15) == 3870376941) strcat(s, "p");
if (crc32("jwMbeyyclNo",11) == 1670992615) strcat(s, "t");
if (crc32("BwBpjEHGkV",10) == 2095010419) strcat(s, "e");
if (crc32("XublRCuanRcQ",12) == 3344053201) strcat(s, "G");
if (crc32("mjlgXfqtnCsfLDV",15) == 3006001388) strcat(s, "d");
    return s;
}

char *befall_verbs() {
    char *s = calloc(7);
    if (crc32("fZfcNNZJ",8) == 598651874) strcat(s, "b");
if (crc32("zabxdQhcsTU",11) == 1267515818) strcat(s, "E");
if (crc32("BATTjdGRyQ",10) == 4167916545) strcat(s, "e");
if (crc32("FDKOWs",6) == 3465889935) strcat(s, "f");
if (crc32("ERUwaQCH",8) == 3995143576) strcat(s, "z");
if (crc32("dvOBTybd",8) == 1616724199) strcat(s, "a");
if (crc32("OVbuBBhqgKmFTnJ",15) == 630469582) strcat(s, "l");
if (crc32("UZWdArMKjz",10) == 112520979) strcat(s, "l");
    return s;
}

char *assemble_verbs() {
    char *s = calloc(9);
    if (crc32("wHSyLhJQpb",10) == 4102047122) strcat(s, "a");
if (crc32("oJKmHgqhLbmMylY",15) == 51900927) strcat(s, "N");
if (crc32("yXJJrHyikGMkfP",14) == 4021287463) strcat(s, "s");
if (crc32("CiBVwZNvL",9) == 1421393758) strcat(s, "s");
if (crc32("cLbTdgTSPgr",11) == 65449846) strcat(s, "e");
if (crc32("sguGnBrb",8) == 3246221470) strcat(s, "y");
if (crc32("ZCzGGvyKy",9) == 970053737) strcat(s, "m");
if (crc32("yanmwq",6) == 3700327973) strcat(s, "j");
if (crc32("jZLxdHHVj",9) == 2187685768) strcat(s, "b");
if (crc32("MUvgGKakAPCUyq",14) == 4071254534) strcat(s, "l");
if (crc32("kFZGeJkheV",10) == 1481905725) strcat(s, "e");
    return s;
}

char *chelated_verbs() {
    char *s = calloc(9);
    if (crc32("MWQXOSzeIkNcmO",14) == 923608230) strcat(s, "c");
if (crc32("MDeAqU",6) == 4193923771) strcat(s, "l");
if (crc32("ojLdpqaX",8) == 1885160596) strcat(s, "h");
if (crc32("vShvAMHSnEYJ",12) == 486329821) strcat(s, "e");
if (crc32("UDyTHOsTygoD",12) == 3553738335) strcat(s, "j");
if (crc32("MHtpbJfF",8) == 2298839881) strcat(s, "l");
if (crc32("rlIyjmRPyXA",11) == 2828310601) strcat(s, "D");
if (crc32("JvZxqfDJK",9) == 3786032990) strcat(s, "a");
if (crc32("LnQnm",5) == 3000971430) strcat(s, "D");
if (crc32("RglRBiqtMIL",11) == 791244569) strcat(s, "t");
if (crc32("nVxOJalHccz",11) == 4090069560) strcat(s, "e");
if (crc32("nJtqsXnYpoKIS",13) == 4230080631) strcat(s, "d");
    return s;
}

char *overstimulating_verbs() {
    char *s = calloc(16);
    if (crc32("XOVQcqii",8) == 674069624) strcat(s, "X");
if (crc32("aaXxezosBnarZ",13) == 3040943987) strcat(s, "o");
if (crc32("JGkZwglHdvgCaw",14) == 510683367) strcat(s, "v");
if (crc32("kJqnNQ",6) == 3299108480) strcat(s, "H");
if (crc32("UcyVmJSqcOdNWbh",15) == 1674777343) strcat(s, "e");
if (crc32("TgJVfwjIvzjV",12) == 2088288133) strcat(s, "r");
if (crc32("ShpcoHIIRcWp",12) == 3295797629) strcat(s, "s");
if (crc32("wTAnUS",6) == 1294588786) strcat(s, "T");
if (crc32("jmupubF",7) == 3330496585) strcat(s, "t");
if (crc32("DnLEazqGYyqJY",13) == 1460580997) strcat(s, "i");
if (crc32("vUnAMOLUXUDBn",13) == 696882273) strcat(s, "m");
if (crc32("wOSBN",5) == 1937134160) strcat(s, "u");
if (crc32("nuwnlK",6) == 4139565123) strcat(s, "z");
if (crc32("OAxSRrFXjXxSz",13) == 4224034118) strcat(s, "l");
if (crc32("kOPNYDydrja",11) == 517001300) strcat(s, "q");
if (crc32("mNDuhnFTatJnCVR",15) == 340880994) strcat(s, "a");
if (crc32("tuJeRPHak",9) == 1181024282) strcat(s, "t");
if (crc32("YgHdV",5) == 2831160071) strcat(s, "i");
if (crc32("azBuUOnGWs",10) == 2045825747) strcat(s, "n");
if (crc32("JjuUFeHlzYX",11) == 258558146) strcat(s, "g");
    return s;
}

char *gazetted_verbs() {
    char *s = calloc(9);
    if (crc32("vAifkOuuRWSLVT",14) == 3439005922) strcat(s, "y");
if (crc32("yFhDrBtktVIVXIu",15) == 2144509479) strcat(s, "g");
if (crc32("jwYthlQDdIVfDVV",15) == 4132547935) strcat(s, "O");
if (crc32("uDGYWv",6) == 1852615033) strcat(s, "a");
if (crc32("yjWDpuqYWtHVi",13) == 2336349757) strcat(s, "z");
if (crc32("ikEqfa",6) == 2150665962) strcat(s, "e");
if (crc32("CPsEGMK",7) == 666220648) strcat(s, "t");
if (crc32("cxXPB",5) == 2286403169) strcat(s, "l");
if (crc32("qprsgWxuPNp",11) == 3329378532) strcat(s, "t");
if (crc32("mqXkNKn",7) == 2427757164) strcat(s, "e");
if (crc32("UPGyVifSi",9) == 1307658041) strcat(s, "S");
if (crc32("xiCivHfoRiMJ",12) == 3666809622) strcat(s, "d");
    return s;
}

char *postulating_verbs() {
    char *s = calloc(12);
    if (crc32("VaxvkWnhXhg",11) == 833107158) strcat(s, "I");
if (crc32("hVMtfPPxnAPi",12) == 3615675690) strcat(s, "p");
if (crc32("uFqwZdL",7) == 703914868) strcat(s, "D");
if (crc32("JktGvYHaCfNj",12) == 174623661) strcat(s, "o");
if (crc32("QHLWtnQobGODv",13) == 3762634347) strcat(s, "y");
if (crc32("zSThBafpAem",11) == 1043976842) strcat(s, "s");
if (crc32("nCjAjIakmBqIND",14) == 1204225163) strcat(s, "t");
if (crc32("eOjUHjxQMyadL",13) == 244821357) strcat(s, "u");
if (crc32("kYDBBs",6) == 2329503813) strcat(s, "l");
if (crc32("ehtZDtHNpplS",12) == 717197591) strcat(s, "S");
if (crc32("rNZakGkJO",9) == 1096883) strcat(s, "a");
if (crc32("gudyNPjlCGob",12) == 2074409039) strcat(s, "t");
if (crc32("fhtPnFNePabFec",14) == 2823559655) strcat(s, "i");
if (crc32("YfmUxOHRhOuuA",13) == 891632682) strcat(s, "w");
if (crc32("EunGIasPEnPxlV",14) == 116387372) strcat(s, "n");
if (crc32("lwVGJ",5) == 1852128915) strcat(s, "f");
if (crc32("WqlXHRsxqlRsB",13) == 980228446) strcat(s, "g");
    return s;
}

char *interwove_verbs() {
    char *s = calloc(10);
    if (crc32("PmJakSUmr",9) == 188915475) strcat(s, "F");
if (crc32("YplCiKalwIjYwr",14) == 197501205) strcat(s, "i");
if (crc32("KbyTJ",5) == 1808843468) strcat(s, "n");
if (crc32("ZsPpQVqFZwhuz",13) == 3743586078) strcat(s, "q");
if (crc32("qhQTE",5) == 1226672198) strcat(s, "t");
if (crc32("Gsylol",6) == 2766273465) strcat(s, "Z");
if (crc32("FqVzkwC",7) == 36823056) strcat(s, "e");
if (crc32("yAegwYTFsQSBwa",14) == 2029842421) strcat(s, "r");
if (crc32("oepSurylZZLa",12) == 4048321171) strcat(s, "w");
if (crc32("pRvuvowdJB",10) == 2004660651) strcat(s, "b");
if (crc32("FiyieCXJ",8) == 3065913210) strcat(s, "o");
if (crc32("mAYKTZoVWi",10) == 356054547) strcat(s, "Q");
if (crc32("yAGVD",5) == 4191006437) strcat(s, "v");
if (crc32("dCxVmNGZh",9) == 692400045) strcat(s, "e");
    return s;
}

char *redraw_verbs() {
    char *s = calloc(7);
    if (crc32("PEvAVqnRR",9) == 2332144027) strcat(s, "j");
if (crc32("jdJrrMpVSXjpM",13) == 2679973526) strcat(s, "r");
if (crc32("fUQPXKhdItNrdjR",15) == 2820634341) strcat(s, "B");
if (crc32("AwkGeQQWA",9) == 2846218048) strcat(s, "e");
if (crc32("zxyFvxxiXGE",11) == 486714108) strcat(s, "d");
if (crc32("mPURnMBqNn",10) == 772730155) strcat(s, "r");
if (crc32("iikslNej",8) == 1675625102) strcat(s, "t");
if (crc32("AOVWZqE",7) == 825115316) strcat(s, "a");
if (crc32("dxOOSvW",7) == 4271912217) strcat(s, "w");
    return s;
}

char *strode_verbs() {
    char *s = calloc(7);
    if (crc32("JLQJLHmCCwdw",12) == 279263846) strcat(s, "G");
if (crc32("OVyFqeWHNXNcV",13) == 1963486490) strcat(s, "s");
if (crc32("ApGuNRc",7) == 3944720790) strcat(s, "N");
if (crc32("HmAWlMibGaZf",12) == 1953757101) strcat(s, "t");
if (crc32("YFYZg",5) == 3182496092) strcat(s, "r");
if (crc32("BIAzMOytuiNiihQ",15) == 878218749) strcat(s, "o");
if (crc32("rvWSatZ",7) == 2347890413) strcat(s, "I");
if (crc32("VkvEJbWOOp",10) == 2993918462) strcat(s, "d");
if (crc32("maXhlqNMIB",10) == 3010821011) strcat(s, "e");
    return s;
}

char *mow_verbs() {
    char *s = calloc(4);
    if (crc32("SUivRLK",7) == 3684580771) strcat(s, "m");
if (crc32("tSsZUlPmlK",10) == 1363736775) strcat(s, "o");
if (crc32("VGeFIBHP",8) == 1048872767) strcat(s, "w");
    return s;
}

char *compared_verbs() {
    char *s = calloc(9);
    if (crc32("iEWvePb",7) == 1336669671) strcat(s, "c");
if (crc32("PwdKEYnPeP",10) == 1925421331) strcat(s, "o");
if (crc32("KOoiOmxMkPSuABh",15) == 3689130085) strcat(s, "Q");
if (crc32("KTJwRgA",7) == 3968539241) strcat(s, "m");
if (crc32("qThHwufV",8) == 1260066562) strcat(s, "p");
if (crc32("EkZzRKhPS",9) == 357159619) strcat(s, "V");
if (crc32("GfToeUX",7) == 2161872780) strcat(s, "a");
if (crc32("XLUljjiqoHmwQ",13) == 3503740931) strcat(s, "A");
if (crc32("PcTLVohaS",9) == 2036983869) strcat(s, "r");
if (crc32("cAtpcTSvbqSK",12) == 4269221462) strcat(s, "g");
if (crc32("lqVxZzyF",8) == 664327612) strcat(s, "e");
if (crc32("nXnArZdcPnYIhug",15) == 3713331143) strcat(s, "w");
if (crc32("GrQyaH",6) == 217940100) strcat(s, "d");
    return s;
}

char *overborrow_verbs() {
    char *s = calloc(11);
    if (crc32("QhUmY",5) == 4258860720) strcat(s, "U");
if (crc32("kjbKxFQWW",9) == 452261739) strcat(s, "o");
if (crc32("HtCQK",5) == 2056131786) strcat(s, "v");
if (crc32("QmdoDhZvnY",10) == 295784725) strcat(s, "e");
if (crc32("QtXnFdSY",8) == 1982484764) strcat(s, "U");
if (crc32("jDuhuXeubkiU",12) == 3488146085) strcat(s, "r");
if (crc32("hMnwitXvBiJ",11) == 1096979547) strcat(s, "b");
if (crc32("vxNYYIUUbFUrAF",14) == 3987689481) strcat(s, "o");
if (crc32("dblGoaydzphLwnm",15) == 1877616883) strcat(s, "D");
if (crc32("JWIMDCgjJ",9) == 4031951276) strcat(s, "r");
if (crc32("LjbMVLZnmfz",11) == 3818954195) strcat(s, "r");
if (crc32("SerZxheUF",9) == 3261078988) strcat(s, "o");
if (crc32("IQhVvk",6) == 2839607090) strcat(s, "w");
    return s;
}

char *allay_verbs() {
    char *s = calloc(6);
    if (crc32("PzuRSieniDcayV",14) == 2421797470) strcat(s, "C");
if (crc32("VqSgUubLoIvRz",13) == 3859451826) strcat(s, "a");
if (crc32("EJwQLJjXjEZlV",13) == 4002323013) strcat(s, "l");
if (crc32("TAFaR",5) == 2691491038) strcat(s, "N");
if (crc32("UBAPPpRAiiwTiYR",15) == 910974715) strcat(s, "l");
if (crc32("etwVHjURxo",10) == 1279955251) strcat(s, "q");
if (crc32("XJujVl",6) == 4061700648) strcat(s, "a");
if (crc32("yWxKoXwOGKtTeP",14) == 177430781) strcat(s, "y");
    return s;
}

char *overprovoked_verbs() {
    char *s = calloc(13);
    if (crc32("nHQVlbrCCSiEqOg",15) == 3580872579) strcat(s, "V");
if (crc32("uuMWx",5) == 2023220226) strcat(s, "o");
if (crc32("BjRYtULOkzGER",13) == 537094510) strcat(s, "k");
if (crc32("IKDKcRqKQsW",11) == 3096290627) strcat(s, "v");
if (crc32("YEiBNbhPjyvtAGG",15) == 3947962657) strcat(s, "e");
if (crc32("Caqhi",5) == 762307022) strcat(s, "O");
if (crc32("uxWFFbQuyBhNVVB",15) == 251953627) strcat(s, "r");
if (crc32("EFsaNz",6) == 1957245419) strcat(s, "K");
if (crc32("xoSCgqeN",8) == 2282491688) strcat(s, "p");
if (crc32("HppWFDvQfwT",11) == 2820033803) strcat(s, "r");
if (crc32("GmadHvvDYHzGzx",14) == 2687128359) strcat(s, "f");
if (crc32("JXvLDz",6) == 74683748) strcat(s, "o");
if (crc32("viitMxXbe",9) == 688085877) strcat(s, "t");
if (crc32("YjTrnPrbnekcK",13) == 1195346034) strcat(s, "v");
if (crc32("zNWFGsEBYNJtBTz",15) == 1294367229) strcat(s, "Y");
if (crc32("JjsCnjJnVyZR",12) == 4220162488) strcat(s, "o");
if (crc32("YGHuptEq",8) == 2166059249) strcat(s, "T");
if (crc32("wDAbo",5) == 1647875763) strcat(s, "k");
if (crc32("ISQTsjX",7) == 3164617668) strcat(s, "b");
if (crc32("zBhjla",6) == 1902600274) strcat(s, "e");
if (crc32("kSfJCzIyYOQXArP",15) == 2862738142) strcat(s, "E");
if (crc32("YTvVal",6) == 1230457664) strcat(s, "d");
    return s;
}

char *refeeling_verbs() {
    char *s = calloc(10);
    if (crc32("WHOiH",5) == 2773436325) strcat(s, "r");
if (crc32("vWnGqhbxJEQvGz",14) == 323328928) strcat(s, "R");
if (crc32("NRlkcXO",7) == 2792058060) strcat(s, "e");
if (crc32("atqMqme",7) == 1085008100) strcat(s, "W");
if (crc32("rdceSYtIhYIAHa",14) == 1527847885) strcat(s, "f");
if (crc32("xXiYjmomSLJKB",13) == 2826482308) strcat(s, "e");
if (crc32("EpANcNCmU",9) == 363165500) strcat(s, "e");
if (crc32("XspVsC",6) == 3106112883) strcat(s, "y");
if (crc32("QxYbsNLQfroA",12) == 1325056430) strcat(s, "l");
if (crc32("vtfJbE",6) == 1389761923) strcat(s, "i");
if (crc32("SJkCFFwWACwIzay",15) == 942126070) strcat(s, "a");
if (crc32("cyLldRG",7) == 3355943141) strcat(s, "n");
if (crc32("YayoqNiGECtY",12) == 3179520357) strcat(s, "x");
if (crc32("eYgRYUZrTn",10) == 951820064) strcat(s, "g");
    return s;
}

char *outbid_verbs() {
    char *s = calloc(7);
    if (crc32("CHGGCUyUWCWPFFG",15) == 3220043302) strcat(s, "o");
if (crc32("gjvdtPHWdiRE",12) == 1957062672) strcat(s, "W");
if (crc32("YqlxWumnn",9) == 885836480) strcat(s, "u");
if (crc32("crEnbdggTsU",11) == 539216878) strcat(s, "q");
if (crc32("YQdYPdBJYrXB",12) == 335973496) strcat(s, "t");
if (crc32("XhPdjYagj",9) == 1427953022) strcat(s, "r");
if (crc32("XsVOhTnNVulEq",13) == 686594719) strcat(s, "b");
if (crc32("VQzVOEveJY",10) == 961039693) strcat(s, "i");
if (crc32("JCMJszitYzxiWZ",14) == 1701434726) strcat(s, "I");
if (crc32("lPdrhCETtWvyJ",13) == 376583806) strcat(s, "d");
    return s;
}

char *solaced_verbs() {
    char *s = calloc(8);
    if (crc32("ZLagVl",6) == 3064342064) strcat(s, "M");
if (crc32("vVavxHblvAWYI",13) == 646086979) strcat(s, "s");
if (crc32("MVloGXUrmY",10) == 4215976) strcat(s, "o");
if (crc32("BkegGGztGf",10) == 3321126768) strcat(s, "l");
if (crc32("TbSYJ",5) == 152338404) strcat(s, "a");
if (crc32("FiVSyDtpeLn",11) == 2431123375) strcat(s, "c");
if (crc32("RZkswVBL",8) == 1834509997) strcat(s, "k");
if (crc32("WSsbl",5) == 3503404757) strcat(s, "e");
if (crc32("hUMjnGnL",8) == 1572701390) strcat(s, "d");
    return s;
}

char *cached_verbs() {
    char *s = calloc(7);
    if (crc32("wBmgmaA",7) == 3548261283) strcat(s, "E");
if (crc32("qwDOtePDX",9) == 1958579755) strcat(s, "c");
if (crc32("RPESxzXg",8) == 663464691) strcat(s, "a");
if (crc32("aGYjNOla",8) == 283943249) strcat(s, "P");
if (crc32("cogddKepLyUCRVi",15) == 1537080793) strcat(s, "c");
if (crc32("ITZpVnePjUP",11) == 1016207847) strcat(s, "h");
if (crc32("WyQRhjMxcWFyDGS",15) == 712391493) strcat(s, "w");
if (crc32("ngRLfaRvvhbFti",14) == 134854925) strcat(s, "e");
if (crc32("neIUOWvGWsMU",12) == 1083550323) strcat(s, "v");
if (crc32("dvAREMIt",8) == 2595694254) strcat(s, "d");
    return s;
}

char *diminish_verbs() {
    char *s = calloc(9);
    if (crc32("TYWCooRgS",9) == 3995711078) strcat(s, "q");
if (crc32("KJobWgyRV",9) == 1194754469) strcat(s, "d");
if (crc32("WHOnsdX",7) == 2883153538) strcat(s, "i");
if (crc32("eAorGaviNocl",12) == 107866613) strcat(s, "a");
if (crc32("SoHcPpyzsalvk",13) == 1707252921) strcat(s, "m");
if (crc32("HhObt",5) == 3929297191) strcat(s, "F");
if (crc32("cZvmIaDqWgcFCO",14) == 3601901830) strcat(s, "i");
if (crc32("MQqAqrCtBGx",11) == 2385859566) strcat(s, "W");
if (crc32("gFrnUoZUb",9) == 3994892652) strcat(s, "n");
if (crc32("CwocZIYvyDJd",12) == 1647952621) strcat(s, "s");
if (crc32("IoizqqGqfKvF",12) == 622724624) strcat(s, "i");
if (crc32("sDrRDRc",7) == 1433201021) strcat(s, "S");
if (crc32("CZzXyjp",7) == 1819731430) strcat(s, "s");
if (crc32("RnpqUDcH",8) == 3685741470) strcat(s, "h");
    return s;
}

char *begun_verbs() {
    char *s = calloc(6);
    if (crc32("uaOPGjVYyAGvvVw",15) == 1279550030) strcat(s, "b");
if (crc32("nFueo",5) == 3387060288) strcat(s, "e");
if (crc32("tyWFnjkUdqxgBf",14) == 1095904977) strcat(s, "g");
if (crc32("ZWdqGtt",7) == 985768813) strcat(s, "u");
if (crc32("RIEXaYLTxzOegW",14) == 147627013) strcat(s, "u");
if (crc32("mIXOPkzcPcj",11) == 1726100571) strcat(s, "o");
if (crc32("IfLgjymX",8) == 1380357806) strcat(s, "n");
    return s;
}

char *reliquefied_verbs() {
    char *s = calloc(12);
    if (crc32("SHBCXFciYadK",12) == 3917053602) strcat(s, "p");
if (crc32("VBfPvpHwkL",10) == 1080117936) strcat(s, "r");
if (crc32("HcpwjGL",7) == 4005592049) strcat(s, "e");
if (crc32("fTdFlkaGYQbY",12) == 3777805054) strcat(s, "x");
if (crc32("jexYeBKH",8) == 999891901) strcat(s, "l");
if (crc32("PoNEuoohC",9) == 2235336518) strcat(s, "i");
if (crc32("zZeWNRfezoK",11) == 2245964764) strcat(s, "q");
if (crc32("yzJnhEE",7) == 1256403006) strcat(s, "u");
if (crc32("egMbL",5) == 4091585180) strcat(s, "v");
if (crc32("xQQWQ",5) == 4175026850) strcat(s, "e");
if (crc32("kXrNXh",6) == 4058953198) strcat(s, "d");
if (crc32("DjTrOtGBL",9) == 1126357138) strcat(s, "f");
if (crc32("MlYQIZcF",8) == 389964896) strcat(s, "Y");
if (crc32("LaWdCEw",7) == 3534422853) strcat(s, "i");
if (crc32("lBZIkJUfuSemWJ",14) == 1296576881) strcat(s, "e");
if (crc32("WIuPOm",6) == 4139640614) strcat(s, "f");
if (crc32("gDWmltGzeukaTJ",14) == 521137540) strcat(s, "d");
    return s;
}

char *leaguing_verbs() {
    char *s = calloc(9);
    if (crc32("WpxxdHGyLxiT",12) == 4113708517) strcat(s, "l");
if (crc32("OcgAX",5) == 4099414607) strcat(s, "e");
if (crc32("BNzOHx",6) == 4199553432) strcat(s, "V");
if (crc32("HDiFRhBzmlsY",12) == 1809662964) strcat(s, "a");
if (crc32("GsgEDqYkQyttZkH",15) == 878905941) strcat(s, "L");
if (crc32("xIdIxNqpC",9) == 3955126348) strcat(s, "g");
if (crc32("KSnNqPl",7) == 1518177228) strcat(s, "i");
if (crc32("TgoTCGUDdR",10) == 3649922550) strcat(s, "u");
if (crc32("Hulnuukr",8) == 3468560968) strcat(s, "O");
if (crc32("MinzXuPesF",10) == 975487913) strcat(s, "i");
if (crc32("gVSQnRqET",9) == 423304913) strcat(s, "K");
if (crc32("KeqYic",6) == 1441108475) strcat(s, "n");
if (crc32("AwmWGAldXcQX",12) == 1962669586) strcat(s, "m");
if (crc32("WZqnz",5) == 4131182444) strcat(s, "g");
    return s;
}

char *counterlighting_verbs() {
    char *s = calloc(16);
    if (crc32("NZRyHwsJIAAsos",14) == 140566079) strcat(s, "M");
if (crc32("zAQQVIhHseX",11) == 1323969074) strcat(s, "c");
if (crc32("PlUhedB",7) == 142400395) strcat(s, "Z");
if (crc32("xERcbuNACdzDXim",15) == 2729995518) strcat(s, "o");
if (crc32("eQpRcnqnJs",10) == 2713773243) strcat(s, "L");
if (crc32("mTpQkmnmIvEkqV",14) == 392110313) strcat(s, "u");
if (crc32("IlMCFVsly",9) == 815775440) strcat(s, "n");
if (crc32("yvWivDKVhQC",11) == 1861601006) strcat(s, "M");
if (crc32("moEML",5) == 2284441708) strcat(s, "t");
if (crc32("OiBjvQ",6) == 1880366648) strcat(s, "n");
if (crc32("YIUrapaBf",9) == 3654018563) strcat(s, "e");
if (crc32("azYwSiI",7) == 205142564) strcat(s, "r");
if (crc32("vTeTo",5) == 3105462229) strcat(s, "l");
if (crc32("xMVjCEDOePTo",12) == 1692140716) strcat(s, "w");
if (crc32("GOyQZtUl",8) == 2850488407) strcat(s, "i");
if (crc32("skHXqbaCypjciZh",15) == 346186614) strcat(s, "g");
if (crc32("NPcKxcT",7) == 3654766280) strcat(s, "S");
if (crc32("rlYKBSmpQ",9) == 3827169088) strcat(s, "h");
if (crc32("cXynbXqOqDjpqRM",15) == 1785102903) strcat(s, "t");
if (crc32("NvjdbpRHisDRf",13) == 3606845951) strcat(s, "i");
if (crc32("MxEWEzeew",9) == 3183476029) strcat(s, "n");
if (crc32("JygnrOLBNQ",10) == 1616204135) strcat(s, "s");
if (crc32("GGGbVJ",6) == 2117350072) strcat(s, "g");
    return s;
}

char *japanning_verbs() {
    char *s = calloc(10);
    if (crc32("xZfLg",5) == 1551178577) strcat(s, "T");
if (crc32("btcNurNFFPac",12) == 3674188089) strcat(s, "j");
if (crc32("rJnLxXo",7) == 1242925986) strcat(s, "a");
if (crc32("lOBtPcS",7) == 1087090207) strcat(s, "j");
if (crc32("vytGjdP",7) == 466809164) strcat(s, "p");
if (crc32("rfoiCFDzyMlhexF",15) == 2913858967) strcat(s, "a");
if (crc32("cVLAzMcDMlfio",13) == 3478693835) strcat(s, "n");
if (crc32("IRafC",5) == 1208796515) strcat(s, "G");
if (crc32("ZmuybJxz",8) == 1604083660) strcat(s, "n");
if (crc32("FAwXFEPZkeoDxP",14) == 3840723651) strcat(s, "i");
if (crc32("OgEPsqPaBX",10) == 2591166956) strcat(s, "n");
if (crc32("fthmRIbHvY",10) == 3563021283) strcat(s, "R");
if (crc32("DsisKdVvRVPo",12) == 40129222) strcat(s, "g");
    return s;
}

char *preconsolidating_verbs() {
    char *s = calloc(17);
    if (crc32("elCEuSubnD",10) == 1712582411) strcat(s, "p");
if (crc32("WEEyxmFUirKMn",13) == 3271934729) strcat(s, "r");
if (crc32("UBmtImdpjxv",11) == 77847216) strcat(s, "e");
if (crc32("CksrwCyuSYJIMGG",15) == 1337711773) strcat(s, "j");
if (crc32("ZiewHswd",8) == 2392291276) strcat(s, "c");
if (crc32("rsVoODEvIUyBNru",15) == 1058600150) strcat(s, "o");
if (crc32("XGDLgOKiRzRxzZ",14) == 3821186201) strcat(s, "F");
if (crc32("ZnzdsAI",7) == 2680475374) strcat(s, "n");
if (crc32("sbBFENdosWl",11) == 219973195) strcat(s, "s");
if (crc32("IsTKfZg",7) == 3152968989) strcat(s, "i");
if (crc32("YnLGpMoGlJPOy",13) == 1464588090) strcat(s, "o");
if (crc32("FkcyNdwm",8) == 514542960) strcat(s, "l");
if (crc32("syrxwFsId",9) == 3370161041) strcat(s, "i");
if (crc32("VDQyqxhOHvVNti",14) == 3431743973) strcat(s, "d");
if (crc32("GNXBq",5) == 3503837039) strcat(s, "a");
if (crc32("YmBHfmXKdoIkF",13) == 1942843497) strcat(s, "H");
if (crc32("ZnTPKEYkukQML",13) == 4020495690) strcat(s, "t");
if (crc32("SpKXDQVy",8) == 2200911205) strcat(s, "i");
if (crc32("cZOieN",6) == 3452848654) strcat(s, "V");
if (crc32("jehARHSQA",9) == 467667843) strcat(s, "n");
if (crc32("rTHyYSxIbW",10) == 4082807306) strcat(s, "u");
if (crc32("wCAFEYHwCmSI",12) == 2427210713) strcat(s, "g");
    return s;
}

char *culminate_verbs() {
    char *s = calloc(10);
    if (crc32("fJGOZSm",7) == 2835338393) strcat(s, "q");
if (crc32("nQRuMoeYMo",10) == 3207963670) strcat(s, "c");
if (crc32("CrwaLCvMbQ",10) == 3648946500) strcat(s, "u");
if (crc32("bdrttnrmP",9) == 278897415) strcat(s, "l");
if (crc32("JDzakslhrhI",11) == 3240815154) strcat(s, "b");
if (crc32("HhnJNUC",7) == 2392392147) strcat(s, "m");
if (crc32("oDLIdIjIwRWpc",13) == 3829646887) strcat(s, "v");
if (crc32("nvbfhQCMTYgXj",13) == 3041845912) strcat(s, "i");
if (crc32("TrMkFakC",8) == 204191753) strcat(s, "n");
if (crc32("PSMYOpLBRNVXW",13) == 2948733925) strcat(s, "a");
if (crc32("pxpDkeFkDQV",11) == 3934083563) strcat(s, "T");
if (crc32("xIssMeukwmWxSZ",14) == 2007355674) strcat(s, "t");
if (crc32("azsytThYZKKvJ",13) == 634406070) strcat(s, "p");
if (crc32("RgsQJ",5) == 1092531870) strcat(s, "e");
    return s;
}

char *palup_verbs() {
    char *s = calloc(6);
    if (crc32("luptWCIla",9) == 1259422004) strcat(s, "p");
if (crc32("MspCMjqswzbk",12) == 1660467811) strcat(s, "a");
if (crc32("UwEDN",5) == 2837487661) strcat(s, "q");
if (crc32("NHuCMcm",7) == 3612473893) strcat(s, "l");
if (crc32("EkvyluRvWxR",11) == 1323977944) strcat(s, "i");
if (crc32("vOeUZzlVZQ",10) == 2879267914) strcat(s, "u");
if (crc32("hLQNPRyV",8) == 3037612528) strcat(s, "N");
if (crc32("OfCIsJKqzyYFsgj",15) == 2087877323) strcat(s, "p");
    return s;
}

char *tiding_verbs() {
    char *s = calloc(7);
    if (crc32("pVmTxx",6) == 376583499) strcat(s, "t");
if (crc32("vWipbzSNDclK",12) == 4258821313) strcat(s, "i");
if (crc32("eIjudUydj",9) == 2336597765) strcat(s, "a");
if (crc32("ctRpSQFXRKLIfBV",15) == 14227802) strcat(s, "d");
if (crc32("bZKfLNgPoFGZreR",15) == 1149177605) strcat(s, "i");
if (crc32("HnbUgAJLUafDON",14) == 748714333) strcat(s, "n");
if (crc32("gNPDOqDUo",9) == 829583732) strcat(s, "g");
    return s;
}

char *redepreciate_verbs() {
    char *s = calloc(13);
    if (crc32("bvJULHEa",8) == 3103094987) strcat(s, "R");
if (crc32("NuGDjG",6) == 3008935814) strcat(s, "r");
if (crc32("VzewV",5) == 1441633728) strcat(s, "i");
if (crc32("AMJPpWM",7) == 3170789797) strcat(s, "e");
if (crc32("ZLJsSurvHUdaa",13) == 3131813798) strcat(s, "p");
if (crc32("uupVMjmzJze",11) == 3958308649) strcat(s, "d");
if (crc32("PmeFIZfBcc",10) == 680811923) strcat(s, "Y");
if (crc32("pHfhVBaasGUtq",13) == 3283119789) strcat(s, "e");
if (crc32("ywQvQNUZNdVbLzz",15) == 3093748200) strcat(s, "B");
if (crc32("nYhUAzqHnTzNyw",14) == 2378808209) strcat(s, "p");
if (crc32("uKsdPwVYa",9) == 2435414346) strcat(s, "r");
if (crc32("kqUWgfJq",8) == 3019091081) strcat(s, "e");
if (crc32("NNnVwDj",7) == 2410765710) strcat(s, "W");
if (crc32("mlBGcQWv",8) == 3270008924) strcat(s, "c");
if (crc32("dBYESLvKuMVm",12) == 1589256026) strcat(s, "i");
if (crc32("jRpAzaBAE",9) == 3475887498) strcat(s, "K");
if (crc32("fhJEVKCKo",9) == 847960751) strcat(s, "a");
if (crc32("wPWDioFxnVYI",12) == 4266112242) strcat(s, "t");
if (crc32("bVedNTSaPS",10) == 2986684629) strcat(s, "c");
if (crc32("uNDNquvAimWyy",13) == 1014156751) strcat(s, "e");
    return s;
}

char *drivelling_verbs() {
    char *s = calloc(11);
    if (crc32("MNlcpLZJjcnAB",13) == 579234914) strcat(s, "d");
if (crc32("nZiXf",5) == 2974280077) strcat(s, "j");
if (crc32("lAMqtZK",7) == 2486998637) strcat(s, "r");
if (crc32("BMZprjlew",9) == 1246122753) strcat(s, "k");
if (crc32("CceZCmWN",8) == 4291038520) strcat(s, "i");
if (crc32("EUJsvQXBZGgJO",13) == 1411831772) strcat(s, "s");
if (crc32("kEgCYg",6) == 794847174) strcat(s, "v");
if (crc32("QiBHnpKCamFR",12) == 3145835753) strcat(s, "e");
if (crc32("qORtMWHZNjDc",12) == 709076484) strcat(s, "l");
if (crc32("uXAasJVVs",9) == 4230836837) strcat(s, "l");
if (crc32("dyomoTBNviBwEz",14) == 3705115917) strcat(s, "i");
if (crc32("whmuhEhBhCfTXlC",15) == 2734098642) strcat(s, "q");
if (crc32("zowFIfUv",8) == 808723344) strcat(s, "n");
if (crc32("HcAXlZS",7) == 4231612660) strcat(s, "g");
    return s;
}

char *borating_verbs() {
    char *s = calloc(9);
    if (crc32("ZhbGRhjCAdJOh",13) == 2466114396) strcat(s, "V");
if (crc32("NHzKX",5) == 1343931241) strcat(s, "b");
if (crc32("fnhGvRfNydAXas",14) == 2444095919) strcat(s, "o");
if (crc32("UhkAUALplkpSlIX",15) == 1885056029) strcat(s, "r");
if (crc32("DZpjXqJToPwGrk",14) == 694505179) strcat(s, "B");
if (crc32("WzCbMP",6) == 4284869027) strcat(s, "a");
if (crc32("eXanYaYMvn",10) == 1224546535) strcat(s, "t");
if (crc32("RgYQpaFjhiiEUH",14) == 2965960639) strcat(s, "a");
if (crc32("xOLMYWoGJBAYdHQ",15) == 1644577926) strcat(s, "i");
if (crc32("ePpiaXkzFYhb",12) == 3149087027) strcat(s, "n");
if (crc32("hJXHoudJTlq",11) == 1988378945) strcat(s, "v");
if (crc32("ofrTx",5) == 342975038) strcat(s, "g");
    return s;
}

char *ledging_verbs() {
    char *s = calloc(8);
    if (crc32("yqmpSv",6) == 3960515013) strcat(s, "l");
if (crc32("udqet",5) == 1501941846) strcat(s, "e");
if (crc32("hMHTBG",6) == 3940859750) strcat(s, "d");
if (crc32("uunmAhFLaH",10) == 3364240088) strcat(s, "g");
if (crc32("ptRVGRULYpyU",12) == 3177937052) strcat(s, "d");
if (crc32("vrVFRVt",7) == 2309168646) strcat(s, "i");
if (crc32("xZCaYrrWNYKVTn",14) == 772026761) strcat(s, "n");
if (crc32("YMgHm",5) == 3697598218) strcat(s, "g");
    return s;
}

char *postulated_verbs() {
    char *s = calloc(11);
    if (crc32("rWCImfDRA",9) == 1171488276) strcat(s, "O");
if (crc32("KvjwrHDzLZay",12) == 626570750) strcat(s, "p");
if (crc32("RUcGAtvS",8) == 2196010192) strcat(s, "y");
if (crc32("WxRQhnXtHUfhGtq",15) == 3407836953) strcat(s, "o");
if (crc32("DSZqoliOVZQ",11) == 2237849329) strcat(s, "H");
if (crc32("fivSlYl",7) == 2607526970) strcat(s, "s");
if (crc32("jSzPBsjoTLyGt",13) == 3996859723) strcat(s, "e");
if (crc32("lciytMUogYIfzBn",15) == 462225507) strcat(s, "t");
if (crc32("qxFbZ",5) == 75101868) strcat(s, "u");
if (crc32("mILuRhMzOnedII",14) == 1656836863) strcat(s, "b");
if (crc32("RifeuBE",7) == 2325008013) strcat(s, "l");
if (crc32("VWZmFjIFLS",10) == 1494356210) strcat(s, "a");
if (crc32("NlsUi",5) == 1281929251) strcat(s, "r");
if (crc32("BjlNvbJrBN",10) == 3985014919) strcat(s, "t");
if (crc32("QsdVY",5) == 214769777) strcat(s, "X");
if (crc32("RhjNMivzfCEjv",13) == 1887100582) strcat(s, "e");
if (crc32("DGvNqXKebaOtQ",13) == 2045335635) strcat(s, "i");
if (crc32("jYgsTDRLC",9) == 2739844833) strcat(s, "d");
    return s;
}

char *fiddled_verbs() {
    char *s = calloc(8);
    if (crc32("vrugVOD",7) == 2912727777) strcat(s, "f");
if (crc32("oEJQPztT",8) == 1683239914) strcat(s, "i");
if (crc32("mnezeIkHdJjpDUe",15) == 1885776158) strcat(s, "d");
if (crc32("sgmOVQF",7) == 472057615) strcat(s, "B");
if (crc32("PNboqjrXwRTcnB",14) == 2712748354) strcat(s, "d");
if (crc32("ImYvvjxIGgODjJ",14) == 518797921) strcat(s, "H");
if (crc32("lqFMlJSl",8) == 141862850) strcat(s, "l");
if (crc32("ykLzlUwZpksKTk",14) == 2160862219) strcat(s, "v");
if (crc32("miTJgnxMkE",10) == 1673617439) strcat(s, "e");
if (crc32("GXgihhsr",8) == 3588024002) strcat(s, "d");
    return s;
}

char *shambling_verbs() {
    char *s = calloc(10);
    if (crc32("OQypCDiCRPjCh",13) == 1019865765) strcat(s, "o");
if (crc32("jZhCQiVgqhNk",12) == 1362395395) strcat(s, "s");
if (crc32("bTZnIgeRvzjMl",13) == 3627107171) strcat(s, "n");
if (crc32("qEaWduaJTemhTH",14) == 2510036838) strcat(s, "h");
if (crc32("loQgGSWaxwDn",12) == 3586578629) strcat(s, "H");
if (crc32("zWTpgUQ",7) == 4100699157) strcat(s, "a");
if (crc32("RGUGmo",6) == 2434219224) strcat(s, "L");
if (crc32("FyBBvjsoeyD",11) == 4266317977) strcat(s, "m");
if (crc32("bGiYLvCxVA",10) == 3634357184) strcat(s, "R");
if (crc32("BpmSnVYfgPb",11) == 467689278) strcat(s, "b");
if (crc32("DuFhXMRamuGZQwh",15) == 171001048) strcat(s, "E");
if (crc32("NNUVesH",7) == 2425766111) strcat(s, "l");
if (crc32("qfBmD",5) == 3458293616) strcat(s, "i");
if (crc32("uSNpH",5) == 60041328) strcat(s, "n");
if (crc32("hgqrg",5) == 1383983555) strcat(s, "g");
    return s;
}

char *overheat_verbs() {
    char *s = calloc(9);
    if (crc32("NclkBM",6) == 2433504444) strcat(s, "i");
if (crc32("xxSpYpTCQzagfA",14) == 3294531077) strcat(s, "o");
if (crc32("BfMNtSg",7) == 2272558546) strcat(s, "M");
if (crc32("jRoSPPyXhD",10) == 4270712582) strcat(s, "v");
if (crc32("ZgyLdhTVXgiBO",13) == 2750848635) strcat(s, "e");
if (crc32("BGeqJsoQcyrDDJ",14) == 1007412192) strcat(s, "r");
if (crc32("SIjGUkHAnl",10) == 2631762837) strcat(s, "E");
if (crc32("InutEbJwgmYJz",13) == 1329258837) strcat(s, "h");
if (crc32("jREFlIvKNDISTk",14) == 4044580734) strcat(s, "e");
if (crc32("hxZQsfzijSiKOL",14) == 347842717) strcat(s, "a");
if (crc32("YnronTt",7) == 847151765) strcat(s, "t");
    return s;
}

char *sconced_verbs() {
    char *s = calloc(8);
    if (crc32("ZaZNx",5) == 465475502) strcat(s, "F");
if (crc32("kleSsuGDxLCdSI",14) == 3245831532) strcat(s, "s");
if (crc32("uqtnvY",6) == 3814265455) strcat(s, "c");
if (crc32("TJXxHCPB",8) == 1935611733) strcat(s, "o");
if (crc32("BOfCjeeZfUmzbjf",15) == 3176827763) strcat(s, "n");
if (crc32("IjsZxCZESpjmY",13) == 545930965) strcat(s, "x");
if (crc32("lQwJK",5) == 1400325332) strcat(s, "c");
if (crc32("IbXhVxAN",8) == 2055426287) strcat(s, "F");
if (crc32("BzlJtfVoh",9) == 302686012) strcat(s, "e");
if (crc32("FRpwxxF",7) == 2171686943) strcat(s, "J");
if (crc32("CnRvRMrurXgIT",13) == 1451187857) strcat(s, "d");
    return s;
}

char *refry_verbs() {
    char *s = calloc(6);
    if (crc32("wfwlGRywmyoT",12) == 3513176838) strcat(s, "r");
if (crc32("XjYrx",5) == 3126891317) strcat(s, "e");
if (crc32("OflSSjjV",8) == 4238251419) strcat(s, "f");
if (crc32("ieavpbgRBF",10) == 1397286991) strcat(s, "e");
if (crc32("chcIii",6) == 1080625003) strcat(s, "r");
if (crc32("jlWFA",5) == 1812964084) strcat(s, "o");
if (crc32("FMVGwK",6) == 3529730104) strcat(s, "y");
    return s;
}

char *find_verbs() {
    char *s = calloc(5);
    if (crc32("tIvGunIsqa",10) == 1146988209) strcat(s, "f");
if (crc32("LlnABYFapfdRHgg",15) == 2056577001) strcat(s, "U");
if (crc32("QCDeWFALCAvB",12) == 712373286) strcat(s, "i");
if (crc32("LBHapa",6) == 3221423031) strcat(s, "n");
if (crc32("BskBKgxYbBK",11) == 152807974) strcat(s, "n");
if (crc32("VxUED",5) == 911039208) strcat(s, "G");
if (crc32("BlwvxkjZMgF",11) == 3611436446) strcat(s, "d");
    return s;
}

char *waylay_verbs() {
    char *s = calloc(7);
    if (crc32("zZlvkq",6) == 3915380721) strcat(s, "w");
if (crc32("VPmsiCUumFcCt",13) == 3314041621) strcat(s, "l");
if (crc32("uWRwW",5) == 1535344129) strcat(s, "a");
if (crc32("eyMtpE",6) == 2664630105) strcat(s, "Z");
if (crc32("UXygiXakcj",10) == 2332352729) strcat(s, "y");
if (crc32("SedfmUOvATXJUQ",14) == 1340531187) strcat(s, "e");
if (crc32("JuWreDExgdi",11) == 3170818689) strcat(s, "l");
if (crc32("ysCvUFVXC",9) == 2336531525) strcat(s, "a");
if (crc32("IiGEMp",6) == 1907199313) strcat(s, "O");
if (crc32("GOZkuRabyvnGm",13) == 2403682053) strcat(s, "y");
    return s;
}

char *trudged_verbs() {
    char *s = calloc(8);
    if (crc32("PtokLucu",8) == 3028270311) strcat(s, "Z");
if (crc32("RriOgTJPlAjrNT",14) == 2710036110) strcat(s, "t");
if (crc32("MSAaTbVUPcmySK",14) == 3103935248) strcat(s, "r");
if (crc32("pkUhahVEVlhWOd",14) == 3968825735) strcat(s, "u");
if (crc32("jOSDtilnjxJOIJ",14) == 862434175) strcat(s, "d");
if (crc32("SZmAPc",6) == 2674895119) strcat(s, "g");
if (crc32("wxGyl",5) == 3967235896) strcat(s, "e");
if (crc32("GdflthaKsQqcVtD",15) == 2257753630) strcat(s, "d");
    return s;
}

char *sending_verbs() {
    char *s = calloc(8);
    if (crc32("AMsKHcLwZ",9) == 2996110291) strcat(s, "c");
if (crc32("StkAeOPTqVc",11) == 2028844723) strcat(s, "s");
if (crc32("QLziVGoEXSKlz",13) == 193583615) strcat(s, "e");
if (crc32("oIbbzRaTwOUZDmM",15) == 2474365129) strcat(s, "n");
if (crc32("XquClmLooxWcyRy",15) == 1637014855) strcat(s, "j");
if (crc32("aPTFuxAkX",9) == 4227087819) strcat(s, "d");
if (crc32("vooVfoOZoatZmeG",15) == 1069191327) strcat(s, "l");
if (crc32("NJdOTnBEsJWM",12) == 1848757302) strcat(s, "i");
if (crc32("WdEGYHPMXcjPy",13) == 3370668293) strcat(s, "n");
if (crc32("oIAQPkKqXVg",11) == 2059391690) strcat(s, "g");
    return s;
}

char *delve_verbs() {
    char *s = calloc(6);
    if (crc32("XLnZQz",6) == 1706967312) strcat(s, "d");
if (crc32("EGbIc",5) == 3474752814) strcat(s, "X");
if (crc32("eGETFj",6) == 3474191797) strcat(s, "e");
if (crc32("pTTiDFi",7) == 2289598549) strcat(s, "l");
if (crc32("UPmMse",6) == 1298852396) strcat(s, "H");
if (crc32("weIwyNenKL",10) == 391038288) strcat(s, "v");
if (crc32("IQSFaBvTyRQsIgA",15) == 270463661) strcat(s, "p");
if (crc32("zjfgL",5) == 945250141) strcat(s, "e");
    return s;
}

char *recurve_verbs() {
    char *s = calloc(8);
    if (crc32("VWCuoltyI",9) == 1580824123) strcat(s, "r");
if (crc32("qRezerXvSe",10) == 1595296563) strcat(s, "e");
if (crc32("XwgRziSqKmQp",12) == 1804432954) strcat(s, "c");
if (crc32("yDmWNiqpKQ",10) == 3983589657) strcat(s, "j");
if (crc32("hzGlSfUbgmXiz",13) == 1288028479) strcat(s, "u");
if (crc32("numlP",5) == 1903251143) strcat(s, "y");
if (crc32("JfgBYsTtFbfnNcr",15) == 2642018849) strcat(s, "r");
if (crc32("AhfgCbc",7) == 3640371751) strcat(s, "u");
if (crc32("PCHqgtc",7) == 1577438159) strcat(s, "v");
if (crc32("hxZMnzMPkEKy",12) == 3218100367) strcat(s, "C");
if (crc32("tpkrOWhp",8) == 399785171) strcat(s, "e");
    return s;
}

char *wade_verbs() {
    char *s = calloc(5);
    if (crc32("tPtTLocedbyE",12) == 1397650906) strcat(s, "N");
if (crc32("XVuyvmlFlW",10) == 1345886255) strcat(s, "w");
if (crc32("sQLrFpsEygs",11) == 1706328649) strcat(s, "J");
if (crc32("tPwmFbqoPuHLBw",14) == 182917197) strcat(s, "a");
if (crc32("vKKVknXqDgI",11) == 3863258654) strcat(s, "d");
if (crc32("WEOUAAC",7) == 1964255753) strcat(s, "e");
    return s;
}

char *rebathing_verbs() {
    char *s = calloc(10);
    if (crc32("gYhOGf",6) == 1055952787) strcat(s, "U");
if (crc32("XzUJaWPW",8) == 1076121731) strcat(s, "r");
if (crc32("lyjVRBOgiXiN",12) == 71229218) strcat(s, "e");
if (crc32("zejyLJnJv",9) == 3787343403) strcat(s, "j");
if (crc32("YaFURvRv",8) == 736878859) strcat(s, "b");
if (crc32("AAKHF",5) == 1539963445) strcat(s, "a");
if (crc32("UcJIaXuGYGAGGGO",15) == 945965421) strcat(s, "Z");
if (crc32("pUWxPvk",7) == 3326494121) strcat(s, "t");
if (crc32("ojGbxvTvdyH",11) == 239861913) strcat(s, "h");
if (crc32("TqKQVj",6) == 2189609746) strcat(s, "i");
if (crc32("CqKWixQy",8) == 3446581273) strcat(s, "O");
if (crc32("IzVSMmAHx",9) == 499049132) strcat(s, "n");
if (crc32("hDjomwc",7) == 2034307611) strcat(s, "S");
if (crc32("EhJUpY",6) == 3829645908) strcat(s, "g");
    return s;
}

char *oversleep_verbs() {
    char *s = calloc(10);
    if (crc32("zsLynBYl",8) == 2398143198) strcat(s, "o");
if (crc32("VeAhHlyZ",8) == 680369132) strcat(s, "v");
if (crc32("HJFElmOZiuZbFk",14) == 3282747145) strcat(s, "m");
if (crc32("YQSOKobO",8) == 1147561539) strcat(s, "e");
if (crc32("uxLgZQC",7) == 3876684976) strcat(s, "q");
if (crc32("Ssgrj",5) == 1038943203) strcat(s, "r");
if (crc32("UnWeEtVUGD",10) == 3182179399) strcat(s, "u");
if (crc32("miBNPKgohbvhFd",14) == 2594587321) strcat(s, "s");
if (crc32("RzrzUOxkd",9) == 2301874025) strcat(s, "M");
if (crc32("igEvpsXzv",9) == 2314136369) strcat(s, "l");
if (crc32("jzcBaveiGrHllJP",15) == 3042226029) strcat(s, "n");
if (crc32("GqsMfEzhaNkxmh",14) == 268743683) strcat(s, "e");
if (crc32("yCTHiXWJCtsDd",13) == 2099474872) strcat(s, "e");
if (crc32("uiMPMlyGQf",10) == 435187723) strcat(s, "p");
    return s;
}

char *robbed_verbs() {
    char *s = calloc(7);
    if (crc32("SmXDTa",6) == 3341984713) strcat(s, "r");
if (crc32("rUFDuyOeq",9) == 4123238010) strcat(s, "o");
if (crc32("URfpQMskLtE",11) == 217224100) strcat(s, "b");
if (crc32("lQatAcUMMALd",12) == 3517664125) strcat(s, "b");
if (crc32("YYSGktIozeniqb",14) == 1594331713) strcat(s, "e");
if (crc32("VBEpLAEN",8) == 1061744077) strcat(s, "d");
    return s;
}

char *paroled_verbs() {
    char *s = calloc(8);
    if (crc32("sbHmbOaO",8) == 172076055) strcat(s, "Q");
if (crc32("NWQtYTzVCv",10) == 485662395) strcat(s, "p");
if (crc32("FAmvwQBOVM",10) == 526622969) strcat(s, "e");
if (crc32("JfxLfianXpcR",12) == 3089433218) strcat(s, "a");
if (crc32("eUJdlfXrDY",10) == 2635046982) strcat(s, "r");
if (crc32("UnnOqwrxULbW",12) == 4064317553) strcat(s, "o");
if (crc32("CwDVsV",6) == 2831189719) strcat(s, "A");
if (crc32("nwUtIBgeaxgst",13) == 1180869862) strcat(s, "l");
if (crc32("KXLJbyb",7) == 1141220595) strcat(s, "e");
if (crc32("ZcxNdQJjjOEjrK",14) == 3389748109) strcat(s, "G");
if (crc32("SVQyKRJGBPRfA",13) == 3599135895) strcat(s, "d");
    return s;
}

char *spragged_verbs() {
    char *s = calloc(9);
    if (crc32("BACYkgkXQzYtl",13) == 3516842778) strcat(s, "i");
if (crc32("KoASb",5) == 3375796228) strcat(s, "s");
if (crc32("qmWNWeKeTIMCTL",14) == 3563642604) strcat(s, "j");
if (crc32("PGThEiauTegcUg",14) == 4157719264) strcat(s, "p");
if (crc32("akwBrvXslmPlurn",15) == 2496708604) strcat(s, "y");
if (crc32("feJehIRQDgMNI",13) == 2725362671) strcat(s, "r");
if (crc32("IPpSnob",7) == 1670067862) strcat(s, "a");
if (crc32("xpsPXRmkJFE",11) == 3362566629) strcat(s, "p");
if (crc32("TKLyVrXbpJZj",12) == 2044177393) strcat(s, "g");
if (crc32("iOmxEIla",8) == 1165082054) strcat(s, "g");
if (crc32("hDtOelIDDr",10) == 2281130012) strcat(s, "e");
if (crc32("RmgXkpuXgiCeJ",13) == 4137476523) strcat(s, "X");
if (crc32("nilDRYkteMzu",12) == 2543880981) strcat(s, "d");
    return s;
}

char *sermonize_verbs() {
    char *s = calloc(10);
    if (crc32("ITcQazFUnUhal",13) == 1388711183) strcat(s, "j");
if (crc32("fpasnGDnjmK",11) == 2267798346) strcat(s, "s");
if (crc32("zxFCqjyOranPKNO",15) == 3253803461) strcat(s, "e");
if (crc32("RldHBJgw",8) == 654549670) strcat(s, "U");
if (crc32("gwtleScICgxQOvO",15) == 3355893717) strcat(s, "r");
if (crc32("RlTFQxESfnYgxrx",15) == 1927423749) strcat(s, "T");
if (crc32("pScKxmiSZh",10) == 3947781634) strcat(s, "m");
if (crc32("xxoFMejhJn",10) == 246979253) strcat(s, "R");
if (crc32("CGUZxhTt",8) == 210509856) strcat(s, "o");
if (crc32("WoxfF",5) == 3652063999) strcat(s, "n");
if (crc32("eksmqoAcn",9) == 1692014411) strcat(s, "a");
if (crc32("TGBJE",5) == 1917629868) strcat(s, "i");
if (crc32("eEBHKToz",8) == 4287518486) strcat(s, "W");
if (crc32("RvKXUPEEnVGmP",13) == 3501443148) strcat(s, "z");
if (crc32("ZEUtEeIgzOKhBFI",15) == 1306694304) strcat(s, "e");
    return s;
}

char *depart_verbs() {
    char *s = calloc(7);
    if (crc32("WecVaNp",7) == 737029774) strcat(s, "h");
if (crc32("VJvkdFHPBkBj",12) == 197143088) strcat(s, "d");
if (crc32("GmcBLpHXauM",11) == 1127775537) strcat(s, "e");
if (crc32("qCEeXHxtZefv",12) == 1075034062) strcat(s, "L");
if (crc32("DROjMBnw",8) == 2118928205) strcat(s, "p");
if (crc32("UaxOTLoEQAeYWwZ",15) == 300185268) strcat(s, "F");
if (crc32("gXejm",5) == 25488398) strcat(s, "a");
if (crc32("rGJHnfRaV",9) == 2985141045) strcat(s, "r");
if (crc32("mDpLOqSBrlMNe",13) == 56189390) strcat(s, "P");
if (crc32("VvMTz",5) == 694168791) strcat(s, "t");
    return s;
}

char *tootle_verbs() {
    char *s = calloc(7);
    if (crc32("iJsOmFdMQse",11) == 1355313643) strcat(s, "t");
if (crc32("NXusnwASSSsk",12) == 2275261842) strcat(s, "t");
if (crc32("vleJQFHASL",10) == 718504880) strcat(s, "Q");
if (crc32("vZpCQy",6) == 2374020765) strcat(s, "o");
if (crc32("FzcSxzp",7) == 3356739043) strcat(s, "o");
if (crc32("zzjjhzcISrXtyvt",15) == 3985975218) strcat(s, "t");
if (crc32("aYaPbVNOdfH",11) == 1022502137) strcat(s, "a");
if (crc32("jgwhLF",6) == 1088471251) strcat(s, "l");
if (crc32("oJVovgN",7) == 4244476472) strcat(s, "t");
if (crc32("jpbpxxvzE",9) == 1881984501) strcat(s, "e");
    return s;
}

char *superintend_verbs() {
    char *s = calloc(12);
    if (crc32("jdHgjLoHMGzRBG",14) == 2526014930) strcat(s, "s");
if (crc32("PeKmdrWcWdeL",12) == 871407762) strcat(s, "u");
if (crc32("IbPhAVAVDIhkTwI",15) == 845837078) strcat(s, "a");
if (crc32("WsOyjmDDoZXZe",13) == 1634373839) strcat(s, "p");
if (crc32("gcqREPrShNoyJ",13) == 1749877825) strcat(s, "e");
if (crc32("RtfpABNyTXveC",13) == 3115511687) strcat(s, "I");
if (crc32("AeFzfRnHatNzNC",14) == 2208473315) strcat(s, "r");
if (crc32("UiKHgfhWMswE",12) == 4065942736) strcat(s, "i");
if (crc32("mqryFJywjv",10) == 493968459) strcat(s, "n");
if (crc32("TehYpVcmepEFoff",15) == 419606402) strcat(s, "D");
if (crc32("hFHYsa",6) == 2176622443) strcat(s, "t");
if (crc32("BUubgbN",7) == 3950879400) strcat(s, "g");
if (crc32("peYAcS",6) == 2430454698) strcat(s, "e");
if (crc32("twaRiZpm",8) == 2194179183) strcat(s, "N");
if (crc32("IKIECel",7) == 4263183940) strcat(s, "n");
if (crc32("RHyIjhKMD",9) == 1959464122) strcat(s, "d");
    return s;
}

char *dammed_verbs() {
    char *s = calloc(7);
    if (crc32("lVzvNpaEiKAUVZw",15) == 3972828229) strcat(s, "G");
if (crc32("LWRXnLnYoeKocKo",15) == 4242949558) strcat(s, "d");
if (crc32("FtOdCtaZcm",10) == 1222186419) strcat(s, "a");
if (crc32("eRcHudR",7) == 1398299727) strcat(s, "m");
if (crc32("ZqnYXPqjLQd",11) == 3006488626) strcat(s, "b");
if (crc32("uDKbqQsNRgf",11) == 344695956) strcat(s, "m");
if (crc32("WcdTuMyoSmL",11) == 2346967233) strcat(s, "e");
if (crc32("ojLfWvX",7) == 2436601805) strcat(s, "I");
if (crc32("QRWMEhN",7) == 4040476073) strcat(s, "d");
    return s;
}

char *flocculate_verbs() {
    char *s = calloc(11);
    if (crc32("jSJNkFsLIeanA",13) == 1353601187) strcat(s, "q");
if (crc32("mFFwSOm",7) == 2773479456) strcat(s, "f");
if (crc32("ortXdRtpFK",10) == 52697733) strcat(s, "l");
if (crc32("sTOVtLmi",8) == 2698676501) strcat(s, "o");
if (crc32("xPQrnshEoEAri",13) == 642899154) strcat(s, "c");
if (crc32("cFiHd",5) == 2221472387) strcat(s, "K");
if (crc32("hNUXkIjbM",9) == 3196944466) strcat(s, "c");
if (crc32("JLzRvuNDVQAtmC",14) == 3606017272) strcat(s, "u");
if (crc32("FVaWk",5) == 2574833886) strcat(s, "l");
if (crc32("iRYLCEORcTCgwzX",15) == 3399537921) strcat(s, "a");
if (crc32("RsCxqjadyMZD",12) == 974630992) strcat(s, "v");
if (crc32("UwZqyYhesABfnx",14) == 1654361619) strcat(s, "t");
if (crc32("fVDdsHsCuMYzNLj",15) == 846962592) strcat(s, "o");
if (crc32("aIiqvTIwK",9) == 2304099105) strcat(s, "e");
    return s;
}

char *valeted_verbs() {
    char *s = calloc(8);
    if (crc32("DmgRrs",6) == 535286500) strcat(s, "c");
if (crc32("rPoNPnwPbdTPpSW",15) == 1629333574) strcat(s, "v");
if (crc32("qtdjjPQcqhrOJ",13) == 2098463385) strcat(s, "J");
if (crc32("iMgCmcCaL",9) == 1525510417) strcat(s, "a");
if (crc32("FyPgCouIN",9) == 1354529866) strcat(s, "o");
if (crc32("AJTsQYwZdMpcU",13) == 3478396366) strcat(s, "l");
if (crc32("iHcdqZKfBhwnzA",14) == 1113693086) strcat(s, "e");
if (crc32("VAePmKXffqQQORZ",15) == 1338960939) strcat(s, "N");
if (crc32("pXSxkQoRzdfywUU",15) == 3026861052) strcat(s, "t");
if (crc32("EtnGBw",6) == 651103419) strcat(s, "g");
if (crc32("qrnZendXB",9) == 3061687789) strcat(s, "e");
if (crc32("iRWtLlYJ",8) == 2874990251) strcat(s, "J");
if (crc32("qmeqpTRuWmryLds",15) == 2139731527) strcat(s, "d");
    return s;
}

char *enquire_verbs() {
    char *s = calloc(8);
    if (crc32("QGhcwZ",6) == 3852902914) strcat(s, "b");
if (crc32("zbGczmTsTWqEKBt",15) == 913681268) strcat(s, "e");
if (crc32("geiFP",5) == 1803948713) strcat(s, "n");
if (crc32("PlLMkLWuxOi",11) == 148735574) strcat(s, "C");
if (crc32("DUFlmndlTdU",11) == 3424587385) strcat(s, "q");
if (crc32("XLkEoAHvjJPkU",13) == 4161204036) strcat(s, "c");
if (crc32("nMNBtcFmKH",10) == 924929758) strcat(s, "u");
if (crc32("oWIGnXIPm",9) == 666284773) strcat(s, "i");
if (crc32("KazYee",6) == 850549251) strcat(s, "r");
if (crc32("xoKWQIkGyDLo",12) == 330740499) strcat(s, "y");
if (crc32("qfMALVC",7) == 4037137754) strcat(s, "e");
    return s;
}

char *mimed_verbs() {
    char *s = calloc(6);
    if (crc32("fnAPdHmhY",9) == 2555787381) strcat(s, "y");
if (crc32("IXODjuJgxADOAfC",15) == 1035212943) strcat(s, "m");
if (crc32("JbKAaz",6) == 227038859) strcat(s, "i");
if (crc32("CYwouQhEh",9) == 1226255999) strcat(s, "r");
if (crc32("aSIPwRmwWIYUOAw",15) == 1265554187) strcat(s, "m");
if (crc32("sKTTLJyN",8) == 2552957640) strcat(s, "e");
if (crc32("SxyWdYlJyCft",12) == 3875755951) strcat(s, "d");
    return s;
}

char *intermention_verbs() {
    char *s = calloc(13);
    if (crc32("QLiVq",5) == 604190737) strcat(s, "k");
if (crc32("YkhdJnToElUto",13) == 1470077107) strcat(s, "i");
if (crc32("IYGNbYVHReBqzFA",15) == 615888516) strcat(s, "B");
if (crc32("JMugQuqjSu",10) == 1052000278) strcat(s, "n");
if (crc32("DIeDFWkFggZEk",13) == 517271703) strcat(s, "I");
if (crc32("ATEvesKGfyMX",12) == 1284762876) strcat(s, "t");
if (crc32("rDkgQVWVuIdR",12) == 473953768) strcat(s, "e");
if (crc32("CTWDYIRVyI",10) == 3501499069) strcat(s, "r");
if (crc32("zZYHwqC",7) == 2609741994) strcat(s, "m");
if (crc32("nPWnykvJoTMiavt",15) == 102633574) strcat(s, "s");
if (crc32("bwiuHz",6) == 594050096) strcat(s, "e");
if (crc32("TQIXAP",6) == 622086710) strcat(s, "n");
if (crc32("sMKNLChPUUNGBi",14) == 1863724033) strcat(s, "t");
if (crc32("ytonGBFfraDmX",13) == 4087222779) strcat(s, "i");
if (crc32("ImbvwQ",6) == 1165421762) strcat(s, "o");
if (crc32("UzAOpPebhePO",12) == 1808487645) strcat(s, "n");
    return s;
}

char *skydive_verbs() {
    char *s = calloc(8);
    if (crc32("BhhIgGEqMKpoj",13) == 1910132272) strcat(s, "L");
if (crc32("iOjlsUk",7) == 2485489262) strcat(s, "s");
if (crc32("SSVZMAXWj",9) == 580318553) strcat(s, "k");
if (crc32("hILAJxvnr",9) == 3641614928) strcat(s, "y");
if (crc32("dXgdSurKfHY",11) == 2909948098) strcat(s, "d");
if (crc32("VgOgTx",6) == 1323373956) strcat(s, "i");
if (crc32("iBLgtQmJoD",10) == 1650882680) strcat(s, "F");
if (crc32("pbLZtFM",7) == 4030590632) strcat(s, "v");
if (crc32("hfeVmZwuqAZdj",13) == 944753314) strcat(s, "e");
    return s;
}

char *diffused_verbs() {
    char *s = calloc(9);
    if (crc32("wZAWJZ",6) == 3291894985) strcat(s, "I");
if (crc32("QUlfIACjhvAYZc",14) == 2410573876) strcat(s, "d");
if (crc32("qecfjcpx",8) == 3727968720) strcat(s, "J");
if (crc32("XSSCjjnA",8) == 2414604878) strcat(s, "i");
if (crc32("QGmAzmozEHJ",11) == 3718257276) strcat(s, "f");
if (crc32("smrobavauc",10) == 3794299993) strcat(s, "A");
if (crc32("IKgJDWZZUZjt",12) == 2590033438) strcat(s, "f");
if (crc32("AFkfvhip",8) == 1696638929) strcat(s, "q");
if (crc32("TBlBKxZZJrrEW",13) == 794656809) strcat(s, "u");
if (crc32("hrEArr",6) == 3412289035) strcat(s, "D");
if (crc32("rmMlzboa",8) == 422813263) strcat(s, "s");
if (crc32("nmJgKNJH",8) == 3477544054) strcat(s, "p");
if (crc32("TrtQGs",6) == 1524159205) strcat(s, "e");
if (crc32("WYibr",5) == 1423068532) strcat(s, "d");
    return s;
}

char *prequalify_verbs() {
    char *s = calloc(11);
    if (crc32("bwVrcJiQOeq",11) == 802666713) strcat(s, "p");
if (crc32("bHPBmhWEm",9) == 1953828475) strcat(s, "e");
if (crc32("bbqmxVTi",8) == 1713034022) strcat(s, "r");
if (crc32("MWYGaOwo",8) == 3048590185) strcat(s, "e");
if (crc32("pJhZoEeQm",9) == 3534491877) strcat(s, "q");
if (crc32("EVziNpsuKm",10) == 2119286065) strcat(s, "u");
if (crc32("ZaRXxmtrycHvesa",15) == 1157569476) strcat(s, "g");
if (crc32("ogkJFINgM",9) == 4059371701) strcat(s, "a");
if (crc32("OPitB",5) == 102668110) strcat(s, "C");
if (crc32("VsBiUNqgizlOB",13) == 863721171) strcat(s, "l");
if (crc32("elyTHVxISedOw",13) == 2158410807) strcat(s, "i");
if (crc32("CpibJKwMcnF",11) == 961700081) strcat(s, "f");
if (crc32("AtpGEGdUwyCu",12) == 3706909910) strcat(s, "k");
if (crc32("VDbYnPwrcnk",11) == 1651351705) strcat(s, "y");
    return s;
}

char *whoring_verbs() {
    char *s = calloc(8);
    if (crc32("sbTKnx",6) == 1815053149) strcat(s, "d");
if (crc32("lnvcAJpc",8) == 2670182462) strcat(s, "w");
if (crc32("koHUwuzuPSc",11) == 3005535121) strcat(s, "z");
if (crc32("OnxtnZrsNyKWOFP",15) == 1848499639) strcat(s, "h");
if (crc32("HeWXoq",6) == 4060720974) strcat(s, "o");
if (crc32("HEasCIoBGwhZegV",15) == 3096135481) strcat(s, "C");
if (crc32("NTakCEBFQGPXiX",14) == 2859462395) strcat(s, "r");
if (crc32("lfOkG",5) == 4160767613) strcat(s, "z");
if (crc32("FkgJHoStmHxvd",13) == 67041826) strcat(s, "i");
if (crc32("VwXZVwXZe",9) == 1535408625) strcat(s, "S");
if (crc32("UKBpiIJ",7) == 816243737) strcat(s, "n");
if (crc32("JGiEnXnhSmp",11) == 3218295029) strcat(s, "g");
    return s;
}

char *strengthen_verbs() {
    char *s = calloc(11);
    if (crc32("KjnyhcUmeXWjkXt",15) == 4116657372) strcat(s, "s");
if (crc32("zDEhjZQK",8) == 501398236) strcat(s, "H");
if (crc32("ZDtLyEfiklwh",12) == 1834133149) strcat(s, "t");
if (crc32("ylcNnJZzDwrrA",13) == 1205107424) strcat(s, "r");
if (crc32("GismlaT",7) == 2979361365) strcat(s, "i");
if (crc32("JnfQU",5) == 4217588025) strcat(s, "e");
if (crc32("yRhGLAZn",8) == 3025055815) strcat(s, "b");
if (crc32("qYZEP",5) == 870006680) strcat(s, "n");
if (crc32("KXqRb",5) == 2579137741) strcat(s, "g");
if (crc32("gTpdAjPYyZSJ",12) == 2334028213) strcat(s, "C");
if (crc32("FbWZwTlW",8) == 1422612575) strcat(s, "t");
if (crc32("nOsfimKXoBXiRxu",15) == 2750722427) strcat(s, "h");
if (crc32("KjMqbMhiyzvzLF",14) == 4230859015) strcat(s, "Q");
if (crc32("qGjCRAEOcKNAsKD",15) == 627222641) strcat(s, "e");
if (crc32("RTyEEUn",7) == 4255575509) strcat(s, "n");
    return s;
}

char *ankylose_verbs() {
    char *s = calloc(9);
    if (crc32("iMTeQ",5) == 4138377627) strcat(s, "x");
if (crc32("rOuTr",5) == 3030461986) strcat(s, "a");
if (crc32("EPHITCrN",8) == 733779169) strcat(s, "n");
if (crc32("fwjHGSyUIi",10) == 2567279618) strcat(s, "k");
if (crc32("jFhmgVXK",8) == 3682324334) strcat(s, "y");
if (crc32("bJzqnofwylQq",12) == 3048096537) strcat(s, "s");
if (crc32("LxvCxKizoYzRbn",14) == 3135399970) strcat(s, "l");
if (crc32("AJEKymcDVdpO",12) == 3597925277) strcat(s, "F");
if (crc32("bYTYC",5) == 2093802307) strcat(s, "o");
if (crc32("hyfFVcoQxlqW",12) == 1480490831) strcat(s, "s");
if (crc32("cjKZIVbU",8) == 3538994936) strcat(s, "c");
if (crc32("IkaxQZVYqGZCzFm",15) == 1790784134) strcat(s, "e");
    return s;
}

char *enucleate_verbs() {
    char *s = calloc(10);
    if (crc32("NfvWuFFXMhMG",12) == 3515832668) strcat(s, "M");
if (crc32("kOpFdkimUUC",11) == 1784155375) strcat(s, "e");
if (crc32("DRuOBQcUR",9) == 3723063576) strcat(s, "t");
if (crc32("OdIJnyrtYmj",11) == 3001414896) strcat(s, "n");
if (crc32("rezOgDYlt",9) == 1810976584) strcat(s, "r");
if (crc32("ATGoXFNYSmdOhS",14) == 3045346369) strcat(s, "u");
if (crc32("pAHTWoo",7) == 1719400593) strcat(s, "x");
if (crc32("YGYpCNXjMfA",11) == 818158600) strcat(s, "c");
if (crc32("SjthgQwMFmAU",12) == 2139744508) strcat(s, "l");
if (crc32("szNNWvbyEMWutkg",15) == 2026617850) strcat(s, "e");
if (crc32("KfKcBZMjnb",10) == 550441098) strcat(s, "a");
if (crc32("LPfLYRuwOxwR",12) == 1089305514) strcat(s, "t");
if (crc32("ruziyylGZKdb",12) == 51387723) strcat(s, "R");
if (crc32("RWhGmuGw",8) == 1879592381) strcat(s, "e");
    return s;
}

char *chafed_verbs() {
    char *s = calloc(7);
    if (crc32("IJQAkRcwgO",10) == 628860027) strcat(s, "c");
if (crc32("JkMLoUu",7) == 3400388882) strcat(s, "h");
if (crc32("gVXVsmHzfkD",11) == 1118361666) strcat(s, "a");
if (crc32("oAHKb",5) == 810574363) strcat(s, "f");
if (crc32("oNudS",5) == 121781465) strcat(s, "e");
if (crc32("IXAwJixUxRoT",12) == 267992513) strcat(s, "d");
    return s;
}

char *liming_verbs() {
    char *s = calloc(7);
    if (crc32("acPFEB",6) == 104732141) strcat(s, "l");
if (crc32("fcUKMfjjubuld",13) == 1599961429) strcat(s, "i");
if (crc32("kpRmbPNzZIZor",13) == 4127932170) strcat(s, "m");
if (crc32("XHgfTZimoDR",11) == 2131453339) strcat(s, "i");
if (crc32("gGQyr",5) == 446609624) strcat(s, "Z");
if (crc32("EAKryivgzt",10) == 1686889446) strcat(s, "n");
if (crc32("KmVAmMMOhnPlaj",14) == 3231589465) strcat(s, "g");
    return s;
}

char *obtrude_verbs() {
    char *s = calloc(8);
    if (crc32("YZaVAn",6) == 3696383392) strcat(s, "A");
if (crc32("QBomHAq",7) == 949598926) strcat(s, "o");
if (crc32("zfMoLhfbTbWdRiL",15) == 4160540923) strcat(s, "s");
if (crc32("veMelmTmdgIf",12) == 197098726) strcat(s, "b");
if (crc32("sWtKQGDcDCSIEDT",15) == 2409752366) strcat(s, "t");
if (crc32("rVnwwprBdBvUIgI",15) == 1528177155) strcat(s, "U");
if (crc32("NpGhBinyUnQzVy",14) == 204582720) strcat(s, "r");
if (crc32("wisSpXCheYQn",12) == 2900624843) strcat(s, "u");
if (crc32("yeWOOERfyBFS",12) == 2977263312) strcat(s, "g");
if (crc32("zqxNgCO",7) == 3620509469) strcat(s, "d");
if (crc32("QCVGo",5) == 1089737148) strcat(s, "e");
    return s;
}

char *boohooing_verbs() {
    char *s = calloc(10);
    if (crc32("xlKcnbAZfIUGFbq",15) == 1439084984) strcat(s, "b");
if (crc32("AdtVGRTS",8) == 297147368) strcat(s, "o");
if (crc32("mcQZmDFa",8) == 61506508) strcat(s, "o");
if (crc32("ilelF",5) == 3909162121) strcat(s, "m");
if (crc32("MstQKnXkZGr",11) == 2940756747) strcat(s, "o");
if (crc32("sKAKQlZOrqC",11) == 4030857718) strcat(s, "o");
if (crc32("xoZcuSEYiBSIDyt",15) == 2960916120) strcat(s, "h");
if (crc32("AAUJLGzcfe",10) == 2457149278) strcat(s, "z");
if (crc32("zzwCad",6) == 437527409) strcat(s, "o");
if (crc32("rtgggfvwXueF",12) == 2299658206) strcat(s, "o");
if (crc32("GUyZc",5) == 535648823) strcat(s, "i");
if (crc32("FDpqDEChYDKV",12) == 90219547) strcat(s, "A");
if (crc32("ReskOCGmgmiHLJ",14) == 3817183380) strcat(s, "n");
if (crc32("JnAVjiAojTV",11) == 3583692979) strcat(s, "g");
    return s;
}

char *delegating_verbs() {
    char *s = calloc(11);
    if (crc32("Zzlgka",6) == 794887392) strcat(s, "d");
if (crc32("FkVaHjiwLBUIPF",14) == 3849919986) strcat(s, "d");
if (crc32("tLZliwiPctlX",12) == 3015324317) strcat(s, "e");
if (crc32("ZyQlr",5) == 1603365609) strcat(s, "e");
if (crc32("mtRAGjnHnTp",11) == 705443265) strcat(s, "l");
if (crc32("LjlHMZLbcxiSbC",14) == 3218774080) strcat(s, "v");
if (crc32("aIaEfedb",8) == 154618851) strcat(s, "e");
if (crc32("kJasNxnhFdUDM",13) == 1930261880) strcat(s, "g");
if (crc32("htvZtdNRxEYbq",13) == 395480383) strcat(s, "s");
if (crc32("FGyPbt",6) == 4164464941) strcat(s, "a");
if (crc32("PXPhftgkT",9) == 2152896041) strcat(s, "t");
if (crc32("tiyUgROP",8) == 2846572242) strcat(s, "J");
if (crc32("DfgEjFWoIlidK",13) == 246818169) strcat(s, "i");
if (crc32("hJOewUKfKZ",10) == 1033710880) strcat(s, "n");
if (crc32("aAWdupyKfwlf",12) == 366606866) strcat(s, "R");
if (crc32("BlJBgPMLEbxjb",13) == 105334296) strcat(s, "g");
    return s;
}

char *taper_verbs() {
    char *s = calloc(6);
    if (crc32("EvkPZazR",8) == 4180067431) strcat(s, "n");
if (crc32("FIgeWAotse",10) == 2094051744) strcat(s, "t");
if (crc32("iUfliCmNwE",10) == 1225221481) strcat(s, "a");
if (crc32("GUMRxmdr",8) == 521991222) strcat(s, "N");
if (crc32("ZlcWVvzoUIlhK",13) == 1120064938) strcat(s, "p");
if (crc32("NYmxjauJezSCmA",14) == 1060838748) strcat(s, "e");
if (crc32("ERJcgMms",8) == 128461740) strcat(s, "r");
    return s;
}

char *standardizing_verbs() {
    char *s = calloc(14);
    if (crc32("YLTgyApdKqXHfb",14) == 1750713154) strcat(s, "s");
if (crc32("MVvjfMEfMK",10) == 2974572133) strcat(s, "e");
if (crc32("wHmsTxH",7) == 3151280484) strcat(s, "t");
if (crc32("BHwiTjdd",8) == 1222465559) strcat(s, "b");
if (crc32("TQTVI",5) == 4032066395) strcat(s, "a");
if (crc32("CqoEtmN",7) == 1261877031) strcat(s, "w");
if (crc32("TNwkaJCPpS",10) == 2208967307) strcat(s, "n");
if (crc32("YWhMgNOGZC",10) == 2740552418) strcat(s, "l");
if (crc32("hvyCAuZmSvnK",12) == 2856000180) strcat(s, "d");
if (crc32("toJgsx",6) == 3656300591) strcat(s, "a");
if (crc32("ItPhHClNjAgLQ",13) == 1858988071) strcat(s, "A");
if (crc32("XvZRRUfJ",8) == 759311084) strcat(s, "r");
if (crc32("csvHjySExUJ",11) == 498824840) strcat(s, "d");
if (crc32("bopizACyYlbk",12) == 2727882257) strcat(s, "i");
if (crc32("TKuTOcKi",8) == 3392898191) strcat(s, "z");
if (crc32("YSQKarnSNZFTjCk",15) == 2748886001) strcat(s, "i");
if (crc32("MaDnsihSSRHmq",13) == 2583964577) strcat(s, "h");
if (crc32("ogKYoiO",7) == 2106782994) strcat(s, "n");
if (crc32("RcDHNNPzIas",11) == 3654491335) strcat(s, "L");
if (crc32("rDeJCZMdHseDd",13) == 1513954713) strcat(s, "g");
    return s;
}

char *structuring_verbs() {
    char *s = calloc(12);
    if (crc32("ApESrRp",7) == 1742870791) strcat(s, "w");
if (crc32("YGDTpkPuRkDfoWR",15) == 1586586164) strcat(s, "s");
if (crc32("pjPVzDxanj",10) == 2145451706) strcat(s, "t");
if (crc32("YkwachpDY",9) == 905660689) strcat(s, "h");
if (crc32("SikiygGE",8) == 3029702321) strcat(s, "r");
if (crc32("WiJaZBTjSbtOTFd",15) == 2772642249) strcat(s, "u");
if (crc32("sdLyoGiknMLjVog",15) == 4043933876) strcat(s, "c");
if (crc32("lepplzVBoLP",11) == 1320769385) strcat(s, "t");
if (crc32("wdNLxQlgrrJ",11) == 3893434731) strcat(s, "f");
if (crc32("OCzKPdbtre",10) == 2457997215) strcat(s, "u");
if (crc32("SvpDIVvJkwp",11) == 2989070845) strcat(s, "w");
if (crc32("wToGnZN",7) == 2909062209) strcat(s, "r");
if (crc32("dhmzernpIZCEM",13) == 3146590887) strcat(s, "i");
if (crc32("ypZCGlI",7) == 2803966244) strcat(s, "n");
if (crc32("GeIIyXsIrYn",11) == 122440939) strcat(s, "L");
if (crc32("zlPOdt",6) == 2710293393) strcat(s, "g");
    return s;
}

char *illustrating_verbs() {
    char *s = calloc(13);
    if (crc32("SRdKtoJBNsKqQe",14) == 1221116825) strcat(s, "R");
if (crc32("xROagdeQPqZGsI",14) == 2409681536) strcat(s, "i");
if (crc32("UkXlixZf",8) == 1027639766) strcat(s, "h");
if (crc32("urXtZntSF",9) == 3326775610) strcat(s, "l");
if (crc32("WjIwy",5) == 1957582025) strcat(s, "A");
if (crc32("WhwIRLwqvOjkp",13) == 233527414) strcat(s, "l");
if (crc32("gaafmJRItvEiYY",14) == 344412525) strcat(s, "y");
if (crc32("XiEHdViitj",10) == 1815766295) strcat(s, "u");
if (crc32("YyoWbSoI",8) == 932850965) strcat(s, "s");
if (crc32("CGlPNZxPYcdQsa",14) == 1352291408) strcat(s, "t");
if (crc32("HmAVpaIAchUr",12) == 2208005970) strcat(s, "t");
if (crc32("BWVYVCIgHuFYf",13) == 2728987034) strcat(s, "r");
if (crc32("tGgzNNzbG",9) == 4138461433) strcat(s, "a");
if (crc32("mrfFnwkcnfJRwAp",15) == 460710430) strcat(s, "t");
if (crc32("ITqKYWtv",8) == 1190423761) strcat(s, "i");
if (crc32("UJnkzcESVSXP",12) == 739500506) strcat(s, "m");
if (crc32("ttVDFosYCaHwd",13) == 3482068290) strcat(s, "n");
if (crc32("rbuCXQunUd",10) == 2229646036) strcat(s, "g");
    return s;
}

char *diecast_verbs() {
    char *s = calloc(8);
    if (crc32("vOtNFWTkF",9) == 1259514819) strcat(s, "d");
if (crc32("ywBpEXDciG",10) == 2941443224) strcat(s, "i");
if (crc32("NSGIPZSu",8) == 3424345505) strcat(s, "Y");
if (crc32("WyKrOdwBtHYIMEM",15) == 2744379852) strcat(s, "e");
if (crc32("UPHlN",5) == 3682151488) strcat(s, "c");
if (crc32("UaOYsNmfpL",10) == 241809918) strcat(s, "a");
if (crc32("lbWVbspnGoDN",12) == 652398144) strcat(s, "s");
if (crc32("ZIuebKenbSGK",12) == 4201396157) strcat(s, "N");
if (crc32("LiYjyZGIAFFfd",13) == 3205507978) strcat(s, "t");
    return s;
}

char *animate_verbs() {
    char *s = calloc(8);
    if (crc32("rGboPFVXgWt",11) == 4040797358) strcat(s, "d");
if (crc32("prKuaZKnCPsCOBc",15) == 3110460194) strcat(s, "a");
if (crc32("UVhedGsjqt",10) == 2051490679) strcat(s, "F");
if (crc32("wohTIMrinHVGe",13) == 3456877681) strcat(s, "n");
if (crc32("FxlYtquklaMk",12) == 2233109237) strcat(s, "i");
if (crc32("cgsRr",5) == 1954620963) strcat(s, "E");
if (crc32("trgiPcc",7) == 1481290350) strcat(s, "m");
if (crc32("EyzddztTAl",10) == 1547426907) strcat(s, "G");
if (crc32("SXNpgoXyoqCj",12) == 1897359884) strcat(s, "a");
if (crc32("zPiDAH",6) == 4135016876) strcat(s, "M");
if (crc32("CWzojiufXwl",11) == 2050269052) strcat(s, "t");
if (crc32("NkxizkXsPfEBydo",15) == 4254385417) strcat(s, "I");
if (crc32("fvxBNzhSIgbWBU",14) == 3318546657) strcat(s, "e");
    return s;
}

char *hinged_verbs() {
    char *s = calloc(7);
    if (crc32("TCljNtrLP",9) == 4144093948) strcat(s, "T");
if (crc32("gVOWq",5) == 2858962170) strcat(s, "h");
if (crc32("RpRPetIapcYcnpL",15) == 1295676879) strcat(s, "f");
if (crc32("feRNphJhcMDqT",13) == 3692994831) strcat(s, "i");
if (crc32("ALSsHxkNncoUYM",14) == 3757497543) strcat(s, "n");
if (crc32("fCjVTsGw",8) == 2046948786) strcat(s, "M");
if (crc32("QEPTcKRg",8) == 629663474) strcat(s, "g");
if (crc32("HeDZnjq",7) == 1093357419) strcat(s, "e");
if (crc32("Dgbilnn",7) == 2377913696) strcat(s, "d");
    return s;
}

char *drizzling_verbs() {
    char *s = calloc(10);
    if (crc32("RpJjiCGAbnLid",13) == 500913479) strcat(s, "d");
if (crc32("cBAPBE",6) == 4238731630) strcat(s, "P");
if (crc32("YghHaEgIROQUwRo",15) == 4101294559) strcat(s, "r");
if (crc32("gSKvvJccWJg",11) == 3392050734) strcat(s, "f");
if (crc32("tqfGXWTLsMZzC",13) == 3147494244) strcat(s, "i");
if (crc32("oiUszYRPnja",11) == 2464817016) strcat(s, "z");
if (crc32("BklnYVs",7) == 3621261743) strcat(s, "z");
if (crc32("idKToUMvbaKLBQ",14) == 2604497414) strcat(s, "z");
if (crc32("YbviWISaebQs",12) == 1410855190) strcat(s, "l");
if (crc32("OWrQcNWtIRiXBS",14) == 4182731916) strcat(s, "N");
if (crc32("BKWyxgjhMUKLL",13) == 2439007585) strcat(s, "i");
if (crc32("bzIarGmRO",9) == 268907534) strcat(s, "n");
if (crc32("pgoVxBOhM",9) == 4186349382) strcat(s, "N");
if (crc32("kxrWjJw",7) == 2815672735) strcat(s, "g");
    return s;
}

char *preapproved_verbs() {
    char *s = calloc(12);
    if (crc32("NFbnLrXLuA",10) == 1913669316) strcat(s, "S");
if (crc32("FkVdrdlRwwLq",12) == 302704998) strcat(s, "p");
if (crc32("ARTsphVNq",9) == 1145441178) strcat(s, "r");
if (crc32("GjZewCggSquk",12) == 3701567580) strcat(s, "e");
if (crc32("LfbENCPPBsynJn",14) == 788236679) strcat(s, "c");
if (crc32("lyLmPqlCQc",10) == 1544152540) strcat(s, "a");
if (crc32("hhuTAnHNxTxt",12) == 3481544292) strcat(s, "p");
if (crc32("aqEGitKYm",9) == 2639252323) strcat(s, "p");
if (crc32("XoZmkvLhDudm",12) == 648774113) strcat(s, "r");
if (crc32("qEMgyAZZ",8) == 367564429) strcat(s, "h");
if (crc32("HdMhQRH",7) == 3135789259) strcat(s, "o");
if (crc32("kHbZyHeNT",9) == 3408419418) strcat(s, "U");
if (crc32("JLqtKpRxkTGfYz",14) == 4110154457) strcat(s, "v");
if (crc32("JViTrEmZix",10) == 3877332860) strcat(s, "e");
if (crc32("TsNlClKK",8) == 984732402) strcat(s, "d");
    return s;
}

char *somnambulating_verbs() {
    char *s = calloc(15);
    if (crc32("DUGOeZyBAzvWL",13) == 349517395) strcat(s, "s");
if (crc32("huJZbZqe",8) == 4293143557) strcat(s, "o");
if (crc32("hFXQV",5) == 2451057580) strcat(s, "m");
if (crc32("wOlocF",6) == 2656193317) strcat(s, "n");
if (crc32("KokvreYIsa",10) == 3840039619) strcat(s, "a");
if (crc32("HGQCyppqI",9) == 1583161205) strcat(s, "m");
if (crc32("XiJLIHLDkkxPEle",15) == 3624318848) strcat(s, "b");
if (crc32("jcnCbTbfsMfzqM",14) == 1712493415) strcat(s, "u");
if (crc32("NOPUX",5) == 743835449) strcat(s, "l");
if (crc32("XktlyYAlOGB",11) == 2965934881) strcat(s, "a");
if (crc32("kNfRBlohoPKN",12) == 3693637881) strcat(s, "t");
if (crc32("AxTimIoNImEHIzF",15) == 3647022291) strcat(s, "i");
if (crc32("wCOONDGKAb",10) == 68932195) strcat(s, "H");
if (crc32("EfmnKrHs",8) == 2493331742) strcat(s, "n");
if (crc32("pTvXXUerXTRdzAp",15) == 993837629) strcat(s, "g");
    return s;
}

char *bewaring_verbs() {
    char *s = calloc(9);
    if (crc32("jkIQdCRyU",9) == 3679712197) strcat(s, "b");
if (crc32("LEQTHhcuwEc",11) == 344498793) strcat(s, "D");
if (crc32("vXLyJQyRh",9) == 3183716554) strcat(s, "e");
if (crc32("SoyRsmAwBlozDW",14) == 2542643551) strcat(s, "K");
if (crc32("vjReZZQT",8) == 980596812) strcat(s, "w");
if (crc32("lTwSA",5) == 3679852627) strcat(s, "i");
if (crc32("jzcrgJcTMwp",11) == 2165968666) strcat(s, "a");
if (crc32("ryTvaFLZGMr",11) == 3245224530) strcat(s, "r");
if (crc32("jCBJqAKAW",9) == 1010242831) strcat(s, "w");
if (crc32("NkwldSjycYZchrq",15) == 2805831304) strcat(s, "i");
if (crc32("ivpnbIECBZpkL",13) == 2361439616) strcat(s, "n");
if (crc32("DhdgXqwgJjq",11) == 696911995) strcat(s, "J");
if (crc32("kOGKyXYNOm",10) == 39831454) strcat(s, "g");
    return s;
}

char *sat_verbs() {
    char *s = calloc(4);
    if (crc32("QjvNxVQdwx",10) == 1358409930) strcat(s, "s");
if (crc32("boYjtRzKNrV",11) == 585715744) strcat(s, "b");
if (crc32("VUWzGNeCCDPaf",13) == 3676677789) strcat(s, "a");
if (crc32("CmSxwP",6) == 3521334780) strcat(s, "t");
    return s;
}

char *frivoling_verbs() {
    char *s = calloc(10);
    if (crc32("MblYYnvqfy",10) == 3351788633) strcat(s, "f");
if (crc32("dnnsgCfSKN",10) == 1329213793) strcat(s, "r");
if (crc32("vJbangcVFCBLVJ",14) == 211620619) strcat(s, "i");
if (crc32("woTRvtidMTEyY",13) == 3437479617) strcat(s, "i");
if (crc32("ADwSUsPLpJ",10) == 1286509669) strcat(s, "v");
if (crc32("aHAUA",5) == 2342512338) strcat(s, "o");
if (crc32("tzGhewcWairnNwS",15) == 819584575) strcat(s, "l");
if (crc32("pskPcVuAgaFOblw",15) == 185249470) strcat(s, "g");
if (crc32("tYJlwX",6) == 2765684516) strcat(s, "i");
if (crc32("fKMBHJNSFGt",11) == 2328033765) strcat(s, "n");
if (crc32("YLSrUjmtI",9) == 2989040040) strcat(s, "g");
    return s;
}

char *backstopped_verbs() {
    char *s = calloc(12);
    if (crc32("gcKpTSAmMkeR",12) == 2922701675) strcat(s, "b");
if (crc32("kSbhI",5) == 403642072) strcat(s, "a");
if (crc32("cDPAcqQIJZEFEaz",15) == 619337348) strcat(s, "c");
if (crc32("ebzeROd",7) == 3963806055) strcat(s, "k");
if (crc32("efrzzTHTKW",10) == 3924665711) strcat(s, "s");
if (crc32("ghBPrkgmimnho",13) == 2738609899) strcat(s, "t");
if (crc32("ZUUWNK",6) == 3213718499) strcat(s, "G");
if (crc32("rKLwmfhZcRY",11) == 3694493636) strcat(s, "o");
if (crc32("MLlKRcLDfENX",12) == 2243250329) strcat(s, "p");
if (crc32("ZVXTFvlJSJ",10) == 3109845366) strcat(s, "p");
if (crc32("ORamLfXWDIHwCRz",15) == 3773657989) strcat(s, "D");
if (crc32("KiZdjcRTlhvWG",13) == 4190392134) strcat(s, "e");
if (crc32("mGZKJwSfLwJMnEe",15) == 291761739) strcat(s, "B");
if (crc32("vRCGwiJT",8) == 255203731) strcat(s, "d");
    return s;
}

char *lazed_verbs() {
    char *s = calloc(6);
    if (crc32("vCXcleVPHwhkxD",14) == 3642600189) strcat(s, "l");
if (crc32("pkIAKCA",7) == 1610694975) strcat(s, "f");
if (crc32("ohoPChAMTEJf",12) == 2129619553) strcat(s, "a");
if (crc32("wiUmcj",6) == 1823252007) strcat(s, "z");
if (crc32("aEgnjuCdEGclV",13) == 4006720886) strcat(s, "L");
if (crc32("uMTVq",5) == 1043866966) strcat(s, "e");
if (crc32("YAsiRBmczzSPI",13) == 1596189538) strcat(s, "d");
    return s;
}

char *inhaling_verbs() {
    char *s = calloc(9);
    if (crc32("SYAngQIIQOlQkD",14) == 3938345210) strcat(s, "i");
if (crc32("UGlLchTkTgf",11) == 1089995878) strcat(s, "n");
if (crc32("rrradEAD",8) == 1222553091) strcat(s, "h");
if (crc32("UkjGH",5) == 451753863) strcat(s, "g");
if (crc32("cEaNctNPSp",10) == 301759138) strcat(s, "a");
if (crc32("HPAVijSYTIXRqO",14) == 1803390644) strcat(s, "l");
if (crc32("mQpHJiLyX",9) == 1802129043) strcat(s, "i");
if (crc32("kqZtkSUWBqyn",12) == 408431794) strcat(s, "i");
if (crc32("dmoMyMU",7) == 555027612) strcat(s, "n");
if (crc32("ZKaONMe",7) == 544582479) strcat(s, "f");
if (crc32("jjUBJqpf",8) == 1607198073) strcat(s, "g");
    return s;
}

char *intercept_verbs() {
    char *s = calloc(10);
    if (crc32("MLOqresNc",9) == 2798111830) strcat(s, "i");
if (crc32("ASFYqAegy",9) == 1383081383) strcat(s, "n");
if (crc32("OTHvJusETzGgYZO",15) == 1367592515) strcat(s, "W");
if (crc32("bRnaVYlL",8) == 3995327671) strcat(s, "t");
if (crc32("iqagc",5) == 417576247) strcat(s, "y");
if (crc32("qLpzmlFgBRpwAsD",15) == 3382665357) strcat(s, "e");
if (crc32("sfNAzxeYzBKZq",13) == 1270007497) strcat(s, "r");
if (crc32("PgqzvrKm",8) == 4059571416) strcat(s, "m");
if (crc32("gtktZQCMfUlyX",13) == 1595608631) strcat(s, "c");
if (crc32("MDEmIYGdWBdrJ",13) == 282528212) strcat(s, "e");
if (crc32("iBjWTBt",7) == 3122150166) strcat(s, "p");
if (crc32("QbTfJnGdtmHdSrx",15) == 1386463486) strcat(s, "j");
if (crc32("OYywjbwHIpG",11) == 1455945277) strcat(s, "t");
    return s;
}

char *saddling_verbs() {
    char *s = calloc(9);
    if (crc32("jPgzM",5) == 1317594791) strcat(s, "s");
if (crc32("tGzpC",5) == 1430214092) strcat(s, "a");
if (crc32("pYneU",5) == 3940092636) strcat(s, "G");
if (crc32("peAmuTeMi",9) == 2454654424) strcat(s, "d");
if (crc32("VLuftOTrdFpzYSW",15) == 100838379) strcat(s, "L");
if (crc32("JBJJFSj",7) == 2441859388) strcat(s, "d");
if (crc32("vskVUlQlBK",10) == 231468749) strcat(s, "l");
if (crc32("iTAEXnwlDmeiJq",14) == 4071049951) strcat(s, "C");
if (crc32("lvxrWF",6) == 735928470) strcat(s, "i");
if (crc32("PBOmYcnMQzUk",12) == 875775258) strcat(s, "i");
if (crc32("thpHRyRtc",9) == 3810484256) strcat(s, "n");
if (crc32("EvqLXMHWBgNKxWn",15) == 4218669082) strcat(s, "k");
if (crc32("ZoiajMOUm",9) == 3771541917) strcat(s, "g");
    return s;
}

char *frap_verbs() {
    char *s = calloc(5);
    if (crc32("JrYdRhsNbEoqaTI",15) == 3492361761) strcat(s, "f");
if (crc32("ToTfoZCn",8) == 1005439743) strcat(s, "r");
if (crc32("rdaPuCy",7) == 1772227913) strcat(s, "E");
if (crc32("gvFcGkXR",8) == 2187449591) strcat(s, "a");
if (crc32("PFFVKQLjor",10) == 2023961361) strcat(s, "l");
if (crc32("wkLsoqCNOtqbQf",14) == 4234479108) strcat(s, "p");
    return s;
}

char *show_verbs() {
    char *s = calloc(5);
    if (crc32("lEoEIb",6) == 1449322473) strcat(s, "z");
if (crc32("ZZSejFbZypVTvoe",15) == 1447819503) strcat(s, "s");
if (crc32("WgjAORDLDarXjOj",15) == 1783509444) strcat(s, "k");
if (crc32("PzGTbGgJJM",10) == 3174684195) strcat(s, "h");
if (crc32("IFZXgGRXFAhI",12) == 2167550492) strcat(s, "i");
if (crc32("RKinvqwZSaZLn",13) == 3485034256) strcat(s, "o");
if (crc32("IcfoMtt",7) == 3553747164) strcat(s, "w");
    return s;
}

char *reacclimated_verbs() {
    char *s = calloc(13);
    if (crc32("vcajKlWIpch",11) == 4253849499) strcat(s, "Q");
if (crc32("QhRyjNNnfEHDhH",14) == 4022673164) strcat(s, "r");
if (crc32("eGHXXzBJamEgDQd",15) == 91076608) strcat(s, "e");
if (crc32("yVvkFAVx",8) == 3636052501) strcat(s, "a");
if (crc32("LBXXlxcPQTvw",12) == 4043210709) strcat(s, "K");
if (crc32("XzITkKkfaoUQWE",14) == 2330184606) strcat(s, "c");
if (crc32("RuuAOxmRVZeVd",13) == 795448392) strcat(s, "h");
if (crc32("OLLJu",5) == 2654636440) strcat(s, "c");
if (crc32("uktonDmvZ",9) == 2962841537) strcat(s, "l");
if (crc32("gUEheaJfkZ",10) == 2508437109) strcat(s, "J");
if (crc32("vQkQBfmRbWDId",13) == 1937796849) strcat(s, "i");
if (crc32("zOfPhGQqowX",11) == 1481985888) strcat(s, "m");
if (crc32("TrRaAWQGuCMnTx",14) == 3829872660) strcat(s, "a");
if (crc32("KpwqMEFylVd",11) == 3654577991) strcat(s, "J");
if (crc32("IvdeWEZM",8) == 1984800268) strcat(s, "t");
if (crc32("rErGILZ",7) == 2498123812) strcat(s, "e");
if (crc32("GhrioiD",7) == 4183391555) strcat(s, "u");
if (crc32("shqJHMLEAsPeRq",14) == 34897697) strcat(s, "d");
    return s;
}

char *interrogated_verbs() {
    char *s = calloc(13);
    if (crc32("NHrTsG",6) == 2855979338) strcat(s, "i");
if (crc32("bFZbFtnvQbB",11) == 4168143162) strcat(s, "n");
if (crc32("UNJLA",5) == 1828774321) strcat(s, "t");
if (crc32("RVBUMAZfsUEU",12) == 4150606752) strcat(s, "e");
if (crc32("jwfnpEKHI",9) == 3642310239) strcat(s, "K");
if (crc32("EBxJqAzAD",9) == 1314898012) strcat(s, "r");
if (crc32("yrBSxwnxw",9) == 2962244654) strcat(s, "a");
if (crc32("hdoqNaGlRu",10) == 487409814) strcat(s, "r");
if (crc32("AiTBusgka",9) == 3436347507) strcat(s, "o");
if (crc32("yGiIFJgKNovoa",13) == 229242131) strcat(s, "g");
if (crc32("jDFqDV",6) == 1217333328) strcat(s, "a");
if (crc32("KPEqE",5) == 1399789614) strcat(s, "u");
if (crc32("BazDWul",7) == 1442564128) strcat(s, "t");
if (crc32("bGAcNUmOAnMnK",13) == 3415707508) strcat(s, "e");
if (crc32("oLLmnEmxgkZn",12) == 3671719061) strcat(s, "f");
if (crc32("BibTFQy",7) == 955256219) strcat(s, "d");
    return s;
}

char *burnish_verbs() {
    char *s = calloc(8);
    if (crc32("OpPin",5) == 2103033911) strcat(s, "L");
if (crc32("cyIANA",6) == 856014116) strcat(s, "b");
if (crc32("MLkIcQN",7) == 2961253824) strcat(s, "u");
if (crc32("zWnPa",5) == 3789411032) strcat(s, "r");
if (crc32("nhKUYbhy",8) == 4108165671) strcat(s, "n");
if (crc32("CPkaejwQvQEDXvo",15) == 2438173890) strcat(s, "i");
if (crc32("zKkuSV",6) == 2062696467) strcat(s, "f");
if (crc32("JWYeng",6) == 1166237763) strcat(s, "s");
if (crc32("blKcXNlZdS",10) == 2790287306) strcat(s, "h");
    return s;
}

char *renew_verbs() {
    char *s = calloc(6);
    if (crc32("CGwUdUlt",8) == 3847958995) strcat(s, "r");
if (crc32("CHRcda",6) == 1572236906) strcat(s, "x");
if (crc32("oSHZxiBKYa",10) == 2586442317) strcat(s, "e");
if (crc32("rjkVzJV",7) == 2616100107) strcat(s, "y");
if (crc32("iGVLS",5) == 2455556320) strcat(s, "n");
if (crc32("YBMQZMyOSB",10) == 485060708) strcat(s, "F");
if (crc32("OjjEuKisEbCKs",13) == 1765721909) strcat(s, "e");
if (crc32("HZuolrDTfyfnGHB",15) == 1487584499) strcat(s, "a");
if (crc32("tdUujqk",7) == 322488462) strcat(s, "w");
    return s;
}

char *gravelling_verbs() {
    char *s = calloc(11);
    if (crc32("VHvUlGYAwuu",11) == 2839482784) strcat(s, "s");
if (crc32("XyzpDsJFMaQaXVs",15) == 2389045507) strcat(s, "g");
if (crc32("WYUjAuElDajWf",13) == 3041431943) strcat(s, "p");
if (crc32("vzoJekNS",8) == 2013688905) strcat(s, "r");
if (crc32("SyzrTG",6) == 531135988) strcat(s, "L");
if (crc32("RILZvKaVVEG",11) == 2016332338) strcat(s, "a");
if (crc32("CesPj",5) == 695043619) strcat(s, "P");
if (crc32("CwVAczc",7) == 564747319) strcat(s, "v");
if (crc32("qtAqZhLGZ",9) == 2124411397) strcat(s, "w");
if (crc32("bzwjCOaKK",9) == 1310603134) strcat(s, "e");
if (crc32("ICBhdSU",7) == 233708377) strcat(s, "F");
if (crc32("UIUTkxniRqjHFye",15) == 766516886) strcat(s, "l");
if (crc32("YFMhDXqO",8) == 3029005869) strcat(s, "l");
if (crc32("JbseW",5) == 4269540801) strcat(s, "i");
if (crc32("TfjAjQlyfvM",11) == 3436202840) strcat(s, "n");
if (crc32("ZFWASTy",7) == 4087835988) strcat(s, "g");
    return s;
}

char *hogtie_verbs() {
    char *s = calloc(7);
    if (crc32("OjxzxaMsw",9) == 2361762671) strcat(s, "I");
if (crc32("pyUZmAHpIdgrKN",14) == 4094985809) strcat(s, "h");
if (crc32("YkfOCjeW",8) == 3886713872) strcat(s, "a");
if (crc32("CTKspcWrQaFwdvh",15) == 357901165) strcat(s, "o");
if (crc32("uwpjjjn",7) == 1614100797) strcat(s, "e");
if (crc32("ejAEHwVCq",9) == 104009191) strcat(s, "g");
if (crc32("EYVUTdAPBoikxG",14) == 808621452) strcat(s, "x");
if (crc32("iIRLVblqEDhWau",14) == 4159746506) strcat(s, "t");
if (crc32("TpSBivr",7) == 2400322681) strcat(s, "i");
if (crc32("qXBdGUE",7) == 360079949) strcat(s, "e");
    return s;
}

char *fatted_verbs() {
    char *s = calloc(7);
    if (crc32("kZwPLY",6) == 928201039) strcat(s, "T");
if (crc32("GgxRrfcCTl",10) == 4246018569) strcat(s, "f");
if (crc32("VhROOwGGO",9) == 1776284700) strcat(s, "z");
if (crc32("TJeDndn",7) == 1212352593) strcat(s, "a");
if (crc32("yMNOBEKXTv",10) == 3554109192) strcat(s, "t");
if (crc32("EOLoZNGjU",9) == 2385563521) strcat(s, "N");
if (crc32("vUjOi",5) == 1252841762) strcat(s, "t");
if (crc32("INaQyGMAccolO",13) == 71806382) strcat(s, "A");
if (crc32("cmvAByIxSAz",11) == 3552529060) strcat(s, "e");
if (crc32("HcdhBcXU",8) == 3097764791) strcat(s, "q");
if (crc32("dCfMaIIYwp",10) == 3430954105) strcat(s, "d");
    return s;
}

char *congeal_verbs() {
    char *s = calloc(8);
    if (crc32("AzNkflZ",7) == 3504419565) strcat(s, "c");
if (crc32("igEGsHDEWgpoGd",14) == 3388392934) strcat(s, "u");
if (crc32("gkCimDxQ",8) == 1845926772) strcat(s, "o");
if (crc32("XMtFBhDSOM",10) == 2273784636) strcat(s, "n");
if (crc32("yfTJIAd",7) == 1905680338) strcat(s, "f");
if (crc32("YilFdGpYVNNnqC",14) == 1738540226) strcat(s, "g");
if (crc32("zsOYfgpewwM",11) == 270969905) strcat(s, "e");
if (crc32("MpmeuGDYGhrUEsq",15) == 2280189486) strcat(s, "a");
if (crc32("vpkfyDqjyt",10) == 2453025060) strcat(s, "Z");
if (crc32("gwjGB",5) == 2037543917) strcat(s, "l");
    return s;
}

char *signup_verbs() {
    char *s = calloc(7);
    if (crc32("JHWqlqzkT",9) == 1307171456) strcat(s, "s");
if (crc32("GQCdTdvyJaR",11) == 3511212492) strcat(s, "i");
if (crc32("EWVALqwkFvDE",12) == 1664553846) strcat(s, "V");
if (crc32("NrSbBETgKoj",11) == 280676580) strcat(s, "g");
if (crc32("GxcsINpr",8) == 2764288929) strcat(s, "n");
if (crc32("FwxtGYUp",8) == 3126566547) strcat(s, "u");
if (crc32("ByLVjn",6) == 785364477) strcat(s, "g");
if (crc32("bmSjJBHuxR",10) == 2368865834) strcat(s, "p");
    return s;
}

char *misdemean_verbs() {
    char *s = calloc(10);
    if (crc32("IRmAroil",8) == 1153796827) strcat(s, "m");
if (crc32("fOFujHMUUpN",11) == 1638319693) strcat(s, "f");
if (crc32("PmSyI",5) == 2826615914) strcat(s, "i");
if (crc32("oFEQVwrW",8) == 337609971) strcat(s, "z");
if (crc32("BeCCEkG",7) == 2564020729) strcat(s, "s");
if (crc32("TSZPrtGR",8) == 2615571620) strcat(s, "d");
if (crc32("CyTJpbpUP",9) == 1543178891) strcat(s, "e");
if (crc32("rVsvPokGZMz",11) == 4112862496) strcat(s, "s");
if (crc32("gvToyg",6) == 4168001922) strcat(s, "m");
if (crc32("MWxWScA",7) == 4866803) strcat(s, "Z");
if (crc32("ifyKMVLiiSTvoI",14) == 2994907737) strcat(s, "e");
if (crc32("GSufI",5) == 1226407191) strcat(s, "o");
if (crc32("XQCqnTayqZYBlAE",15) == 2486731018) strcat(s, "a");
if (crc32("hmpAd",5) == 3675803618) strcat(s, "j");
if (crc32("iumDOZ",6) == 3985338732) strcat(s, "n");
    return s;
}

char *consuming_verbs() {
    char *s = calloc(10);
    if (crc32("gYeBJZJPeUupTr",14) == 3847170534) strcat(s, "f");
if (crc32("PHYLDM",6) == 2251438460) strcat(s, "c");
if (crc32("DYoBVGmcVm",10) == 474889445) strcat(s, "o");
if (crc32("WCGigqcfFY",10) == 1647644790) strcat(s, "n");
if (crc32("EbikjQXRCCGOk",13) == 767385876) strcat(s, "r");
if (crc32("CHPqsvVQgkTn",12) == 3926018972) strcat(s, "s");
if (crc32("GAUVtFsMM",9) == 3151433323) strcat(s, "u");
if (crc32("LuggMIeFut",10) == 3538763604) strcat(s, "m");
if (crc32("ecfvW",5) == 2870650651) strcat(s, "t");
if (crc32("tfIYTS",6) == 2663904783) strcat(s, "i");
if (crc32("NrkDiwU",7) == 157240899) strcat(s, "n");
if (crc32("iKesGqXMYxe",11) == 2347980273) strcat(s, "g");
    return s;
}

char *impressed_verbs() {
    char *s = calloc(10);
    if (crc32("gzkwEybsI",9) == 3127420061) strcat(s, "i");
if (crc32("SLEKazQdEWIwnwo",15) == 1418778003) strcat(s, "h");
if (crc32("NgPLfgKlPawy",12) == 4037895369) strcat(s, "m");
if (crc32("EVmyTnoVsM",10) == 2900792564) strcat(s, "i");
if (crc32("AtSTCZn",7) == 1291651474) strcat(s, "p");
if (crc32("gJalg",5) == 1242731870) strcat(s, "r");
if (crc32("AkpCYpdOxO",10) == 2300795203) strcat(s, "e");
if (crc32("tcjPldjGOMYtxf",14) == 2926172855) strcat(s, "n");
if (crc32("FiASeh",6) == 3931145431) strcat(s, "s");
if (crc32("qrnSJruFr",9) == 659579619) strcat(s, "s");
if (crc32("UDGPZSJwsdSvpB",14) == 2553593061) strcat(s, "e");
if (crc32("aKWZUFBhfCQSgo",14) == 1116686457) strcat(s, "d");
    return s;
}

char *coffeehousing_verbs() {
    char *s = calloc(14);
    if (crc32("gsjDdqe",7) == 3709717600) strcat(s, "c");
if (crc32("TxwVBSQlWKaeiQj",15) == 3959356957) strcat(s, "s");
if (crc32("xPODRg",6) == 2166310814) strcat(s, "o");
if (crc32("chktCAiuiaj",11) == 2030982386) strcat(s, "f");
if (crc32("sxpvYEOulnd",11) == 134267032) strcat(s, "c");
if (crc32("JEVJLCGAebfbc",13) == 3963494178) strcat(s, "f");
if (crc32("tJLZfwU",7) == 622765338) strcat(s, "e");
if (crc32("eGUSmrF",7) == 1689770064) strcat(s, "j");
if (crc32("hFtlLqIuD",9) == 2606959525) strcat(s, "e");
if (crc32("tFARchk",7) == 1695045857) strcat(s, "h");
if (crc32("hPnpszYMS",9) == 3927375987) strcat(s, "o");
if (crc32("eSlwZ",5) == 3829779187) strcat(s, "u");
if (crc32("oQqDoVfgAURR",12) == 4203773650) strcat(s, "s");
if (crc32("sBoEx",5) == 3642110951) strcat(s, "i");
if (crc32("FUpUfnJrSeco",12) == 2269892019) strcat(s, "n");
if (crc32("xBSLkQKb",8) == 210017624) strcat(s, "P");
if (crc32("IBKAFFRkxkdvA",13) == 3955468285) strcat(s, "g");
    return s;
}

char *bandying_verbs() {
    char *s = calloc(9);
    if (crc32("sLWMiLAqY",9) == 344606270) strcat(s, "b");
if (crc32("tfrPjAgS",8) == 857732445) strcat(s, "Q");
if (crc32("VahJwfvWFFLqIG",14) == 860817742) strcat(s, "a");
if (crc32("qGYETjKJkwpdoY",14) == 1881419437) strcat(s, "n");
if (crc32("hUhmetn",7) == 3964242835) strcat(s, "X");
if (crc32("cBdZC",5) == 3388124222) strcat(s, "d");
if (crc32("oGrfv",5) == 104321811) strcat(s, "y");
if (crc32("XYJqnXuyfaLIf",13) == 962472448) strcat(s, "i");
if (crc32("eycei",5) == 1843816000) strcat(s, "X");
if (crc32("GJwvjngxz",9) == 46595481) strcat(s, "n");
if (crc32("xpfag",5) == 2278941952) strcat(s, "g");
    return s;
}

char *costarring_verbs() {
    char *s = calloc(11);
    if (crc32("omNBq",5) == 3811517721) strcat(s, "E");
if (crc32("ivJPUFgsyi",10) == 1735195740) strcat(s, "c");
if (crc32("WkazryJK",8) == 2802968080) strcat(s, "H");
if (crc32("ZAovc",5) == 2038201760) strcat(s, "o");
if (crc32("BdtPW",5) == 1276757487) strcat(s, "s");
if (crc32("WwoMTwHd",8) == 1304324484) strcat(s, "W");
if (crc32("sQpSOrkGbBt",11) == 3009894390) strcat(s, "t");
if (crc32("XcLDbNzJGUJyGl",14) == 2375697423) strcat(s, "a");
if (crc32("LDyAXhJPf",9) == 546092726) strcat(s, "D");
if (crc32("lugWYAB",7) == 3850416668) strcat(s, "r");
if (crc32("xtjRIrSD",8) == 2360617177) strcat(s, "t");
if (crc32("vAvUPcZ",7) == 4114851687) strcat(s, "r");
if (crc32("ayQQAS",6) == 1186920105) strcat(s, "t");
if (crc32("TXfijzQzALuLly",14) == 3192437887) strcat(s, "i");
if (crc32("ZCtvka",6) == 1803760652) strcat(s, "w");
if (crc32("MLoLBwKUtbFqJj",14) == 2989526771) strcat(s, "n");
if (crc32("QwaOSx",6) == 2330502831) strcat(s, "F");
if (crc32("guQJWXHurDQQ",12) == 562635643) strcat(s, "g");
    return s;
}

char *suspiring_verbs() {
    char *s = calloc(10);
    if (crc32("ErZOCU",6) == 1919292757) strcat(s, "s");
if (crc32("xxXgaNtO",8) == 1517370008) strcat(s, "u");
if (crc32("CpErFvovNh",10) == 3440877251) strcat(s, "s");
if (crc32("mJnNHeofBx",10) == 3977891055) strcat(s, "H");
if (crc32("snKntNV",7) == 969065548) strcat(s, "p");
if (crc32("vbKUehM",7) == 384114657) strcat(s, "q");
if (crc32("azKZHHjtNXw",11) == 3869304736) strcat(s, "i");
if (crc32("XkwGMNgZUnV",11) == 1296315752) strcat(s, "a");
if (crc32("VxAKenxabvhmksI",15) == 3560398167) strcat(s, "r");
if (crc32("NlYPElZFK",9) == 171677987) strcat(s, "i");
if (crc32("ohuww",5) == 3757533560) strcat(s, "n");
if (crc32("MFObFwunB",9) == 3247729079) strcat(s, "g");
    return s;
}

char *rattled_verbs() {
    char *s = calloc(8);
    if (crc32("PIPcvegbiwmzY",13) == 2715453643) strcat(s, "E");
if (crc32("lRyBvZbSrkOf",12) == 234285061) strcat(s, "r");
if (crc32("IJdksTZQuUjiZ",13) == 3374793015) strcat(s, "a");
if (crc32("tIlicbnb",8) == 1304275786) strcat(s, "t");
if (crc32("wGAZrXEmCU",10) == 1298632146) strcat(s, "t");
if (crc32("tFrPqg",6) == 1481221704) strcat(s, "V");
if (crc32("HroSPAfblYYwy",13) == 1270282723) strcat(s, "l");
if (crc32("WgwlZijD",8) == 1778222645) strcat(s, "r");
if (crc32("uuhrgB",6) == 3231116384) strcat(s, "e");
if (crc32("cakROhfoh",9) == 2654372333) strcat(s, "d");
    return s;
}

char *undercool_verbs() {
    char *s = calloc(10);
    if (crc32("dXhaNbfwjNgTgob",15) == 1303164989) strcat(s, "u");
if (crc32("tFfoj",5) == 3282717476) strcat(s, "d");
if (crc32("UXcgMO",6) == 576541932) strcat(s, "n");
if (crc32("ZmJUqVUzomSnayj",15) == 2864743854) strcat(s, "n");
if (crc32("bAEtyZGTeaMTEQD",15) == 2090831139) strcat(s, "d");
if (crc32("CXcRayhP",8) == 350076712) strcat(s, "v");
if (crc32("NFGSYLIC",8) == 317395152) strcat(s, "e");
if (crc32("GTaupVvovmCoT",13) == 660356481) strcat(s, "r");
if (crc32("SPYsHaA",7) == 2155074196) strcat(s, "q");
if (crc32("teTSErzvSnV",11) == 1556506829) strcat(s, "c");
if (crc32("rZdqTuo",7) == 273634447) strcat(s, "o");
if (crc32("ZpyMnxaJ",8) == 396000275) strcat(s, "I");
if (crc32("DfcefjQF",8) == 2553512433) strcat(s, "o");
if (crc32("sbxsnxrTOrozDXw",15) == 822285491) strcat(s, "k");
if (crc32("ErWxIGbevt",10) == 4136806841) strcat(s, "l");
    return s;
}

char *crazing_verbs() {
    char *s = calloc(8);
    if (crc32("eyKZyvqhQtvJCae",15) == 1350377876) strcat(s, "c");
if (crc32("geIVlUl",7) == 4072992668) strcat(s, "r");
if (crc32("ONaiHaoRt",9) == 2927137892) strcat(s, "a");
if (crc32("FaDlYIY",7) == 4127063507) strcat(s, "z");
if (crc32("DPByZWCGcWh",11) == 2227529688) strcat(s, "i");
if (crc32("ulXDxia",7) == 2490834043) strcat(s, "n");
if (crc32("ulHMdUJztIzfDLK",15) == 459724952) strcat(s, "p");
if (crc32("dnyStuLks",9) == 3074124225) strcat(s, "g");
    return s;
}

char *photoset_verbs() {
    char *s = calloc(9);
    if (crc32("VzINpnlZAd",10) == 1295005766) strcat(s, "Q");
if (crc32("fbwXyZ",6) == 1838806193) strcat(s, "p");
if (crc32("BnyNKQzpqyK",11) == 577799736) strcat(s, "v");
if (crc32("fHiuDpZCALfHC",13) == 2731384071) strcat(s, "h");
if (crc32("oXtezg",6) == 3963929505) strcat(s, "o");
if (crc32("aOfGKE",6) == 455632669) strcat(s, "E");
if (crc32("ZeYYzft",7) == 4234120830) strcat(s, "t");
if (crc32("eIvFe",5) == 3489453643) strcat(s, "e");
if (crc32("JoTxRwPT",8) == 406564330) strcat(s, "o");
if (crc32("VhQog",5) == 3543061902) strcat(s, "s");
if (crc32("xCNLl",5) == 3840747120) strcat(s, "e");
if (crc32("JvbRjiDWxUlARE",14) == 1479422844) strcat(s, "t");
    return s;
}

char *doping_verbs() {
    char *s = calloc(7);
    if (crc32("LHUcDOEoVHsYRmv",15) == 1489925562) strcat(s, "d");
if (crc32("VddzrtZGgH",10) == 3778598867) strcat(s, "K");
if (crc32("IXDbrjgUsDkH",12) == 620810792) strcat(s, "o");
if (crc32("BcIGzhQHja",10) == 2639409656) strcat(s, "o");
if (crc32("zAMdwqlb",8) == 2895469150) strcat(s, "p");
if (crc32("XAEQo",5) == 3843363768) strcat(s, "i");
if (crc32("bKAvFs",6) == 4111190488) strcat(s, "P");
if (crc32("fYrZHOVWLoyM",12) == 3599745688) strcat(s, "n");
if (crc32("tWHVpIjhT",9) == 1257792811) strcat(s, "F");
if (crc32("SpawY",5) == 3916580332) strcat(s, "g");
    return s;
}

char *scuff_verbs() {
    char *s = calloc(6);
    if (crc32("ZUOXDMOT",8) == 3017563542) strcat(s, "O");
if (crc32("IuZtG",5) == 232807980) strcat(s, "s");
if (crc32("pAVPOcZncDqkGX",14) == 2342386143) strcat(s, "c");
if (crc32("UMiyrRHjFNMdb",13) == 4111616120) strcat(s, "u");
if (crc32("LrpXmNcva",9) == 2784720915) strcat(s, "v");
if (crc32("KLHTUYOuwfo",11) == 3446954606) strcat(s, "f");
if (crc32("EOPlzKkTmzKbnx",14) == 2537618671) strcat(s, "X");
if (crc32("PQmjHnfoCw",10) == 3596976252) strcat(s, "f");
    return s;
}

char *drave_verbs() {
    char *s = calloc(6);
    if (crc32("oonlvgTuiV",10) == 532725254) strcat(s, "d");
if (crc32("AobIvDgs",8) == 3468927165) strcat(s, "z");
if (crc32("OIFhNWvWoeKj",12) == 4272330536) strcat(s, "r");
if (crc32("GpgePeZKPUkyJDs",15) == 3566960560) strcat(s, "a");
if (crc32("BLFfRAWjyiK",11) == 2061376415) strcat(s, "v");
if (crc32("TOwNkFV",7) == 3832054065) strcat(s, "e");
    return s;
}

char *frizz_verbs() {
    char *s = calloc(6);
    if (crc32("USCYkPPHYHHl",12) == 4238415037) strcat(s, "j");
if (crc32("YsYDebJudhYSY",13) == 199181717) strcat(s, "f");
if (crc32("aHWMxXUGC",9) == 4284235626) strcat(s, "r");
if (crc32("tKFcymYDkivuXGU",15) == 2401851595) strcat(s, "i");
if (crc32("ceBevuWcaqpvG",13) == 145813601) strcat(s, "z");
if (crc32("ABqbPdnNWQkq",12) == 3993344697) strcat(s, "U");
if (crc32("cVIMXASoAEdgc",13) == 384351412) strcat(s, "z");
    return s;
}

char *vesicate_verbs() {
    char *s = calloc(9);
    if (crc32("BmVGAXUbJIlud",13) == 2539929358) strcat(s, "D");
if (crc32("VEnXcjZflM",10) == 1660133026) strcat(s, "v");
if (crc32("HJJHwTMOyacg",12) == 1338077669) strcat(s, "e");
if (crc32("cjiRVzepstJq",12) == 1688160359) strcat(s, "L");
if (crc32("VSrwNRGzgq",10) == 4269759997) strcat(s, "s");
if (crc32("WtTNRzuYqyl",11) == 1453345996) strcat(s, "b");
if (crc32("HXlfWthABeCl",12) == 1304722737) strcat(s, "i");
if (crc32("NsZgzISdvc",10) == 3837920429) strcat(s, "c");
if (crc32("FToQjuD",7) == 599923531) strcat(s, "a");
if (crc32("TRnPmo",6) == 3725963338) strcat(s, "t");
if (crc32("BNXtsJStyI",10) == 356065273) strcat(s, "e");
    return s;
}

char *plied_verbs() {
    char *s = calloc(6);
    if (crc32("DPLIXz",6) == 448096153) strcat(s, "U");
if (crc32("vGcCmosR",8) == 338881226) strcat(s, "p");
if (crc32("RDaGRhh",7) == 2651563000) strcat(s, "l");
if (crc32("RzmGcTdqEwiNf",13) == 198345045) strcat(s, "S");
if (crc32("FyqHrcgZA",9) == 4145825081) strcat(s, "i");
if (crc32("ISeBEfLkZyzUj",13) == 4043654039) strcat(s, "e");
if (crc32("AazlGU",6) == 820127890) strcat(s, "d");
    return s;
}

char *creating_verbs() {
    char *s = calloc(9);
    if (crc32("QswvgKOqzL",10) == 1400080377) strcat(s, "c");
if (crc32("lOVyXlejcd",10) == 845933523) strcat(s, "r");
if (crc32("DETKPtpSYs",10) == 522844185) strcat(s, "W");
if (crc32("ljHXJafWMhcpvOQ",15) == 1718938231) strcat(s, "e");
if (crc32("MzYLr",5) == 3815321147) strcat(s, "a");
if (crc32("Nalzw",5) == 3220095592) strcat(s, "c");
if (crc32("NvThuojMhs",10) == 2164895415) strcat(s, "t");
if (crc32("FlDsetq",7) == 859133300) strcat(s, "i");
if (crc32("vWucUNbCwQz",11) == 2930401727) strcat(s, "n");
if (crc32("GkiBZi",6) == 209145902) strcat(s, "g");
    return s;
}

char *recross_verbs() {
    char *s = calloc(8);
    if (crc32("BTMRVciERhFrsP",14) == 1346714313) strcat(s, "r");
if (crc32("PoZsIXXEsGlIO",13) == 1588475907) strcat(s, "e");
if (crc32("zSOigUidrs",10) == 1452581475) strcat(s, "l");
if (crc32("iGBuI",5) == 2056630156) strcat(s, "c");
if (crc32("AQwmdzK",7) == 2356527980) strcat(s, "D");
if (crc32("FBykAOsZjn",10) == 2314918787) strcat(s, "r");
if (crc32("xopVKwsUk",9) == 14076416) strcat(s, "o");
if (crc32("VOGTcr",6) == 739986253) strcat(s, "s");
if (crc32("beEoSfDKhmCeJpo",15) == 2516234805) strcat(s, "s");
    return s;
}

char *reradiating_verbs() {
    char *s = calloc(12);
    if (crc32("jtgmUZOxAwNBk",13) == 1249582313) strcat(s, "p");
if (crc32("hwdweznO",8) == 3757509582) strcat(s, "r");
if (crc32("gmKOWVTapPFoui",14) == 2080053952) strcat(s, "e");
if (crc32("usauRWP",7) == 2811244919) strcat(s, "r");
if (crc32("bPBNGZ",6) == 609379294) strcat(s, "T");
if (crc32("WFMIqcw",7) == 836941029) strcat(s, "a");
if (crc32("CqCWBBhhunlhgF",14) == 3017767011) strcat(s, "d");
if (crc32("IwjbdxLGuzEbns",14) == 1652640858) strcat(s, "i");
if (crc32("xccpiGJNk",9) == 1236189669) strcat(s, "u");
if (crc32("FLaCNOqhOF",10) == 3015864009) strcat(s, "a");
if (crc32("lkSsjw",6) == 2266806211) strcat(s, "V");
if (crc32("YcRncAfxsxndw",13) == 601203422) strcat(s, "t");
if (crc32("LETHvaZh",8) == 4139977119) strcat(s, "i");
if (crc32("mfHGYWKbdH",10) == 1292784788) strcat(s, "V");
if (crc32("EJYgftLxgnLF",12) == 44169002) strcat(s, "n");
if (crc32("ZRnbBc",6) == 3629814914) strcat(s, "g");
    return s;
}

char *enrol_verbs() {
    char *s = calloc(6);
    if (crc32("qCbtfjij",8) == 2063628124) strcat(s, "e");
if (crc32("wPshTzBFAzWW",12) == 1720018512) strcat(s, "D");
if (crc32("ZFpsk",5) == 2155732259) strcat(s, "n");
if (crc32("qNcrz",5) == 2652104515) strcat(s, "r");
if (crc32("kLVciv",6) == 929300365) strcat(s, "p");
if (crc32("tdHdoGGDNwmmrEq",15) == 4256341246) strcat(s, "o");
if (crc32("jdeqICEV",8) == 2409780830) strcat(s, "n");
if (crc32("hMujyNaaYR",10) == 711727464) strcat(s, "l");
    return s;
}

char *slugged_verbs() {
    char *s = calloc(8);
    if (crc32("VBXSRuI",7) == 2085749387) strcat(s, "s");
if (crc32("FDheVzeROepDWw",14) == 1862540604) strcat(s, "l");
if (crc32("HTroKOlIb",9) == 4293186383) strcat(s, "u");
if (crc32("oTaaP",5) == 3134980059) strcat(s, "d");
if (crc32("bdEEJoDDcikLx",13) == 768953829) strcat(s, "g");
if (crc32("BVJeFwY",7) == 2353717262) strcat(s, "g");
if (crc32("pxHtRuNBzF",10) == 2385077369) strcat(s, "e");
if (crc32("mogUmpiCxS",10) == 2202288794) strcat(s, "d");
    return s;
}

char *substantialize_verbs() {
    char *s = calloc(15);
    if (crc32("KCQRIdEyRePmN",13) == 2057243104) strcat(s, "a");
if (crc32("fJDYroVA",8) == 1569773180) strcat(s, "s");
if (crc32("spyQZqrdm",9) == 3392117306) strcat(s, "P");
if (crc32("PCwIxdZcsMhkODc",15) == 996234970) strcat(s, "u");
if (crc32("lIqtNhHCVYmRup",14) == 522313126) strcat(s, "b");
if (crc32("TqvfKxNI",8) == 1112926352) strcat(s, "s");
if (crc32("rkBhgMoVwppn",12) == 730514298) strcat(s, "t");
if (crc32("iquFQo",6) == 214992718) strcat(s, "a");
if (crc32("EohElcvKCC",10) == 2856343558) strcat(s, "n");
if (crc32("fDSOZHXCvOIfncb",15) == 1274709071) strcat(s, "A");
if (crc32("PdzAwrWvcqA",11) == 2644746694) strcat(s, "t");
if (crc32("BQIWnrJcv",9) == 2317944676) strcat(s, "o");
if (crc32("ivWKhqOHmflY",12) == 1589876410) strcat(s, "i");
if (crc32("zIQsXJDlDATEV",13) == 3533063682) strcat(s, "a");
if (crc32("BxkjCbgb",8) == 2213150494) strcat(s, "D");
if (crc32("weaZIdZq",8) == 1705422600) strcat(s, "l");
if (crc32("VoaVizHXYeru",12) == 3676917661) strcat(s, "B");
if (crc32("VGLzgDkezC",10) == 4226126212) strcat(s, "i");
if (crc32("ymuZGPc",7) == 530081127) strcat(s, "a");
if (crc32("xhgaDQSlnsq",11) == 3516526779) strcat(s, "z");
if (crc32("WHDEjRFYdH",10) == 1884358543) strcat(s, "o");
if (crc32("NHqDAqhvLC",10) == 3410818437) strcat(s, "e");
    return s;
}

char *crunch_verbs() {
    char *s = calloc(7);
    if (crc32("FVwUvjHBzbdJLn",14) == 4121319746) strcat(s, "c");
if (crc32("CwZhmPSOFG",10) == 518394379) strcat(s, "r");
if (crc32("qvPmmFdyf",9) == 1964193865) strcat(s, "B");
if (crc32("jDtNp",5) == 1825670304) strcat(s, "u");
if (crc32("yMUmtmFcz",9) == 2183091309) strcat(s, "n");
if (crc32("HBLLVWCOwaEyb",13) == 3138168522) strcat(s, "A");
if (crc32("BheYXYBNgC",10) == 3952502010) strcat(s, "c");
if (crc32("pGVQrexmPkFkqO",14) == 672591626) strcat(s, "h");
    return s;
}

char *knew_verbs() {
    char *s = calloc(5);
    if (crc32("ZfgxVWuExiy",11) == 1638540767) strcat(s, "k");
if (crc32("zbOaHzJy",8) == 978197242) strcat(s, "n");
if (crc32("rSUoPrKEBBwDyp",14) == 10949563) strcat(s, "Y");
if (crc32("kGwdpTzCJyaxt",13) == 2958302982) strcat(s, "e");
if (crc32("jyWimNnHMdrVZZ",14) == 3961479419) strcat(s, "w");
    return s;
}

char *overpictorializing_verbs() {
    char *s = calloc(19);
    if (crc32("TgdnokfqHy",10) == 2836948526) strcat(s, "o");
if (crc32("cZWCWHY",7) == 3394327287) strcat(s, "v");
if (crc32("DSTDeNN",7) == 3478476283) strcat(s, "e");
if (crc32("FiqcEkdqVHO",11) == 4214117045) strcat(s, "a");
if (crc32("uIxGFi",6) == 4141688224) strcat(s, "r");
if (crc32("kDQedhuVYJzz",12) == 2027730000) strcat(s, "D");
if (crc32("THKiKHLVzx",10) == 1661406212) strcat(s, "p");
if (crc32("YbYauYjxt",9) == 4117652381) strcat(s, "n");
if (crc32("cQozFjjMSqz",11) == 2523638913) strcat(s, "i");
if (crc32("QVTHGEoRpWoBq",13) == 2749152827) strcat(s, "c");
if (crc32("Etljpkrw",8) == 1276722339) strcat(s, "t");
if (crc32("hRmoJErYCQlRR",13) == 3883102469) strcat(s, "e");
if (crc32("ahKTas",6) == 1231184608) strcat(s, "o");
if (crc32("JoXEDe",6) == 3578142597) strcat(s, "r");
if (crc32("iodmhW",6) == 691733106) strcat(s, "i");
if (crc32("UZjeTgry",8) == 1997560644) strcat(s, "L");
if (crc32("ddejUEYNY",9) == 2162119529) strcat(s, "a");
if (crc32("CUumDZleKc",10) == 3198360177) strcat(s, "l");
if (crc32("eeszkMNFUtxFT",13) == 251660690) strcat(s, "i");
if (crc32("HQvsQTlUnK",10) == 3083329598) strcat(s, "z");
if (crc32("glPskKM",7) == 2030949116) strcat(s, "c");
if (crc32("eRSNMquPyUT",11) == 1868215660) strcat(s, "i");
if (crc32("VARdDo",6) == 125978454) strcat(s, "m");
if (crc32("RusTGdbhEqKqOw",14) == 1195971929) strcat(s, "n");
if (crc32("uQeROrxl",8) == 691702276) strcat(s, "g");
    return s;
}

char *patted_verbs() {
    char *s = calloc(7);
    if (crc32("xIXcWbRhSWHU",12) == 3476617069) strcat(s, "E");
if (crc32("htNfVQEolGmrkZ",14) == 3196733438) strcat(s, "p");
if (crc32("hpgRMgJ",7) == 564235507) strcat(s, "O");
if (crc32("HOIwPuCKGOvBxx",14) == 3989283714) strcat(s, "a");
if (crc32("wVvUQdxWG",9) == 3303972033) strcat(s, "t");
if (crc32("EtwEeyfZXwCRSf",14) == 457178962) strcat(s, "t");
if (crc32("lGqcSJBNSeQ",11) == 2072594794) strcat(s, "e");
if (crc32("XwfWVLIPw",9) == 287706087) strcat(s, "J");
if (crc32("qOjbSHX",7) == 1480220702) strcat(s, "d");
    return s;
}

char *overcivilize_verbs() {
    char *s = calloc(13);
    if (crc32("nVYJeH",6) == 2682973084) strcat(s, "o");
if (crc32("vreJNf",6) == 2424809487) strcat(s, "o");
if (crc32("oaBfmsh",7) == 405800791) strcat(s, "v");
if (crc32("SuJwkgYrq",9) == 404760090) strcat(s, "i");
if (crc32("IqimlcKAKEHpRn",14) == 2456413861) strcat(s, "e");
if (crc32("pGhwbPWGDOYTBhV",15) == 2518392417) strcat(s, "M");
if (crc32("HJRnEw",6) == 547886998) strcat(s, "r");
if (crc32("DnTWRY",6) == 3031389875) strcat(s, "c");
if (crc32("JEXROdSBaL",10) == 1389029962) strcat(s, "U");
if (crc32("sbZgbKPRViO",11) == 4274733685) strcat(s, "i");
if (crc32("ivsiocMtkj",10) == 2516755442) strcat(s, "D");
if (crc32("KDppgZ",6) == 3890358467) strcat(s, "v");
if (crc32("YIXMOLhvfO",10) == 933283013) strcat(s, "z");
if (crc32("DaVYiwz",7) == 2021568276) strcat(s, "i");
if (crc32("wVImgcqyMCq",11) == 2813029036) strcat(s, "l");
if (crc32("meJpxtcNqfSdMJ",14) == 1575534253) strcat(s, "j");
if (crc32("TBLHjVIhoMyOf",13) == 3726382740) strcat(s, "i");
if (crc32("RIrhswbUUeBi",12) == 2126500012) strcat(s, "h");
if (crc32("HugQQFbI",8) == 1860520320) strcat(s, "z");
if (crc32("YMXVZU",6) == 3030390084) strcat(s, "h");
if (crc32("PktmguBEDB",10) == 698050165) strcat(s, "e");
    return s;
}

char *niggardized_verbs() {
    char *s = calloc(12);
    if (crc32("BrEsDHYHpsrE",12) == 3300330401) strcat(s, "L");
if (crc32("AmbNsEjLMat",11) == 3309545902) strcat(s, "n");
if (crc32("XgUIbZVcJ",9) == 1539164885) strcat(s, "i");
if (crc32("RYdwiqBHWpLQQu",14) == 2039222499) strcat(s, "K");
if (crc32("ymjxSZvvR",9) == 1311762650) strcat(s, "g");
if (crc32("LJZSOLGhu",9) == 994233867) strcat(s, "X");
if (crc32("jSPGLAZDQmCy",12) == 101746744) strcat(s, "g");
if (crc32("kEvafSToxuOFb",13) == 1473163755) strcat(s, "a");
if (crc32("xeXLu",5) == 539913095) strcat(s, "V");
if (crc32("akxKuSevsm",10) == 1978252941) strcat(s, "r");
if (crc32("YpgINly",7) == 2006486984) strcat(s, "d");
if (crc32("eZHjwCzNknECyIJ",15) == 3688710629) strcat(s, "x");
if (crc32("lEJfC",5) == 2538934595) strcat(s, "i");
if (crc32("IuyOcVGTtgPX",12) == 3850146253) strcat(s, "z");
if (crc32("cePQeUh",7) == 870618434) strcat(s, "I");
if (crc32("tgRNYhfM",8) == 1856460288) strcat(s, "e");
if (crc32("emYcfdQ",7) == 969987222) strcat(s, "s");
if (crc32("GBkFsWbAkRQb",12) == 1384433003) strcat(s, "d");
    return s;
}

char *swaddling_verbs() {
    char *s = calloc(10);
    if (crc32("KyzcKknpy",9) == 3260554855) strcat(s, "S");
if (crc32("KUTUjwTmSMMnx",13) == 2713022688) strcat(s, "s");
if (crc32("CmCfZgMDjMgth",13) == 481486933) strcat(s, "D");
if (crc32("xdHHhitwVhwWLUM",15) == 2567077447) strcat(s, "w");
if (crc32("bkUqWnmBAEe",11) == 231383976) strcat(s, "f");
if (crc32("gwwtikA",7) == 2854332605) strcat(s, "a");
if (crc32("zuWDrywDDElB",12) == 4245150402) strcat(s, "d");
if (crc32("mgNLGWaMKPXF",12) == 1736929677) strcat(s, "d");
if (crc32("YQeNOz",6) == 3602652215) strcat(s, "J");
if (crc32("rKVFL",5) == 3093114036) strcat(s, "l");
if (crc32("zUJSdgmJfmkdZ",13) == 3277057922) strcat(s, "i");
if (crc32("RmDPMiCYDdQ",11) == 1879783747) strcat(s, "n");
if (crc32("eQXMc",5) == 394402117) strcat(s, "g");
    return s;
}

char *bedight_verbs() {
    char *s = calloc(8);
    if (crc32("xWVCConodXxkp",13) == 1627191990) strcat(s, "b");
if (crc32("IlbQWTS",7) == 3872181300) strcat(s, "e");
if (crc32("QYwPUcrIG",9) == 2313306992) strcat(s, "U");
if (crc32("wlWEVfb",7) == 356965241) strcat(s, "d");
if (crc32("FhUefZuYosrm",12) == 867140719) strcat(s, "K");
if (crc32("oaPdygx",7) == 2150614947) strcat(s, "i");
if (crc32("qLxQHODDbmPxAVn",15) == 1625993444) strcat(s, "g");
if (crc32("yrjzVvFluqegO",13) == 4204583693) strcat(s, "h");
if (crc32("FiuZL",5) == 985395363) strcat(s, "t");
    return s;
}

char *scrimp_verbs() {
    char *s = calloc(7);
    if (crc32("Gvwfdyx",7) == 2079962648) strcat(s, "s");
if (crc32("pxUVwyFe",8) == 3419850036) strcat(s, "c");
if (crc32("GxPoTvoXyNnsdJB",15) == 4106895345) strcat(s, "r");
if (crc32("TsgpxIcBWFnB",12) == 3594456920) strcat(s, "p");
if (crc32("FhDVAQyJZFv",11) == 3705046554) strcat(s, "i");
if (crc32("feZEtmNfgtZY",12) == 3787156786) strcat(s, "m");
if (crc32("eJnFwDKJOwMXO",13) == 3354673749) strcat(s, "a");
if (crc32("pJBsIKZX",8) == 1792822328) strcat(s, "p");
    return s;
}

char *sweeten_verbs() {
    char *s = calloc(8);
    if (crc32("kRCMogLzIAEU",12) == 1542033159) strcat(s, "m");
if (crc32("DodMuiBxrSRTdI",14) == 4282589221) strcat(s, "s");
if (crc32("qtHbCVFZBS",10) == 1626952570) strcat(s, "w");
if (crc32("cEzXOVLuXWcEF",13) == 51196564) strcat(s, "l");
if (crc32("WJMcQrLgAwdeb",13) == 4232066336) strcat(s, "e");
if (crc32("wtWQrwxErUNiMEG",15) == 2118527436) strcat(s, "u");
if (crc32("AZaOmQKmdYJAZTM",15) == 3368077237) strcat(s, "e");
if (crc32("DfbYlWpVeLxO",12) == 880829963) strcat(s, "O");
if (crc32("jLwQmrT",7) == 3279127600) strcat(s, "t");
if (crc32("waswMCgDhXiLnp",14) == 2542915314) strcat(s, "e");
if (crc32("WSDjt",5) == 1308820617) strcat(s, "Z");
if (crc32("LUCTBYaZUKcjp",13) == 1886891345) strcat(s, "n");
    return s;
}

char *stenciled_verbs() {
    char *s = calloc(10);
    if (crc32("WBaLfdYA",8) == 1595323737) strcat(s, "H");
if (crc32("mfXIhNi",7) == 1536142414) strcat(s, "s");
if (crc32("ONeyzEaaESNiszo",15) == 1614785698) strcat(s, "s");
if (crc32("EGSgSwhggF",10) == 1941115160) strcat(s, "t");
if (crc32("TjSZSTZoW",9) == 1349330309) strcat(s, "q");
if (crc32("mYQQmsVZx",9) == 766443965) strcat(s, "e");
if (crc32("INNROVcyMTjtNwW",15) == 997274915) strcat(s, "n");
if (crc32("afWyCOOjrUTlt",13) == 3330111414) strcat(s, "c");
if (crc32("nWNrwRTneOsTpHQ",15) == 2812802014) strcat(s, "x");
if (crc32("urMfGj",6) == 1581574280) strcat(s, "i");
if (crc32("juyjlQHeKyGhGvY",15) == 4061427756) strcat(s, "l");
if (crc32("GmoaxWvgYLJECZ",14) == 3298793681) strcat(s, "e");
if (crc32("JUsVAcvX",8) == 3934526266) strcat(s, "A");
if (crc32("LjWVtVSmsOU",11) == 3123895596) strcat(s, "d");
    return s;
}

char *anteing_verbs() {
    char *s = calloc(8);
    if (crc32("yahlpq",6) == 2443729599) strcat(s, "h");
if (crc32("aWmdYXTeKuzrbj",14) == 2617218762) strcat(s, "a");
if (crc32("NpMPtncjdkDuhTb",15) == 2919847719) strcat(s, "n");
if (crc32("XxrlLbr",7) == 142958983) strcat(s, "t");
if (crc32("ALrrsEnnzOogIQb",15) == 650549505) strcat(s, "D");
if (crc32("PcFqfWpWEXY",11) == 2767904603) strcat(s, "e");
if (crc32("LXvgIWDhMsFx",12) == 182588776) strcat(s, "O");
if (crc32("qcnUIOTVbuo",11) == 803371882) strcat(s, "i");
if (crc32("zhaTucbybKzg",12) == 1105957534) strcat(s, "U");
if (crc32("raTRm",5) == 378630283) strcat(s, "n");
if (crc32("eIUcP",5) == 3619013902) strcat(s, "q");
if (crc32("nwHxGeuYCh",10) == 2041038697) strcat(s, "g");
    return s;
}

char *bespake_verbs() {
    char *s = calloc(8);
    if (crc32("dftwvGe",7) == 514486124) strcat(s, "C");
if (crc32("DJVbtsuxCN",10) == 3539283303) strcat(s, "b");
if (crc32("rvKXlVhKDe",10) == 364358070) strcat(s, "e");
if (crc32("ReTFqh",6) == 3611964439) strcat(s, "b");
if (crc32("vyyuZRDqy",9) == 2407111088) strcat(s, "s");
if (crc32("BnODwzW",7) == 1646302831) strcat(s, "S");
if (crc32("mqndHLJ",7) == 2440688056) strcat(s, "p");
if (crc32("adWRVTU",7) == 1696100024) strcat(s, "a");
if (crc32("GJkgtBSAatnPFh",14) == 4191431124) strcat(s, "k");
if (crc32("SszSvQReR",9) == 308069171) strcat(s, "I");
if (crc32("vtLgrCqB",8) == 1504633225) strcat(s, "e");
    return s;
}

char *kindle_verbs() {
    char *s = calloc(7);
    if (crc32("mftmYHxktw",10) == 111678399) strcat(s, "k");
if (crc32("tgRmefwEEol",11) == 3342503625) strcat(s, "d");
if (crc32("hwUkUaqKXq",10) == 590517188) strcat(s, "i");
if (crc32("mbheqB",6) == 4162987814) strcat(s, "n");
if (crc32("duoPbk",6) == 2445802304) strcat(s, "d");
if (crc32("EviABSDEBqebCur",15) == 1831781783) strcat(s, "l");
if (crc32("NbpAwOivXTsnq",13) == 1656832929) strcat(s, "e");
    return s;
}

char *understand_verbs() {
    char *s = calloc(11);
    if (crc32("TaEmXYxKMzMwgsl",15) == 2892383965) strcat(s, "w");
if (crc32("CyPitElASiiatkJ",15) == 4103311572) strcat(s, "u");
if (crc32("tUUTSDGmUHAzK",13) == 1560648892) strcat(s, "v");
if (crc32("ZEVVIIjgcPC",11) == 2286733642) strcat(s, "n");
if (crc32("ybCviKP",7) == 119225151) strcat(s, "o");
if (crc32("ByOwPawKH",9) == 2158752617) strcat(s, "d");
if (crc32("LWqmUhRDRaXZI",13) == 2364534622) strcat(s, "e");
if (crc32("KkkmbmbRkayv",12) == 228496590) strcat(s, "L");
if (crc32("BVgsv",5) == 4204498899) strcat(s, "r");
if (crc32("BwErpLfd",8) == 1681821504) strcat(s, "U");
if (crc32("BaysmL",6) == 3099161975) strcat(s, "s");
if (crc32("VxxtwNnMZefjJrx",15) == 155313898) strcat(s, "q");
if (crc32("zikrKgvUYDDOFC",14) == 2050357038) strcat(s, "t");
if (crc32("lQvwmlfxu",9) == 3352065974) strcat(s, "a");
if (crc32("HpGdHzEpWrFoGCn",15) == 3756790840) strcat(s, "x");
if (crc32("ciVOp",5) == 290140925) strcat(s, "n");
if (crc32("QjnjnzyxxeBYdc",14) == 1700768524) strcat(s, "R");
if (crc32("yTlzMKZ",7) == 3417500260) strcat(s, "d");
    return s;
}

char *rewater_verbs() {
    char *s = calloc(8);
    if (crc32("CBevyvvbmAPk",12) == 3701145308) strcat(s, "r");
if (crc32("xrjvWBziuGcI",12) == 1621711646) strcat(s, "e");
if (crc32("IfCzWZS",7) == 3115184534) strcat(s, "U");
if (crc32("dQWFeOr",7) == 2533176049) strcat(s, "w");
if (crc32("KJqCPWqHJWHE",12) == 3443412566) strcat(s, "z");
if (crc32("kPnKtYemouHjMuo",15) == 1645762685) strcat(s, "a");
if (crc32("GIHuzhc",7) == 537702592) strcat(s, "t");
if (crc32("AedcwJvgkPFUbX",14) == 985373748) strcat(s, "J");
if (crc32("twQtifblgzrBM",13) == 1424315634) strcat(s, "e");
if (crc32("GdljRwenvh",10) == 3867569061) strcat(s, "n");
if (crc32("PWEZYoS",7) == 3908785248) strcat(s, "r");
    return s;
}

char *juiced_verbs() {
    char *s = calloc(7);
    if (crc32("wIyKFHEyW",9) == 2898696411) strcat(s, "j");
if (crc32("otKHMOILP",9) == 3275120402) strcat(s, "u");
if (crc32("yticukmyMvk",11) == 2541277571) strcat(s, "x");
if (crc32("GCtPYKrwJDqME",13) == 2821312279) strcat(s, "i");
if (crc32("FEurY",5) == 4117611762) strcat(s, "B");
if (crc32("ziRhtN",6) == 1924012012) strcat(s, "c");
if (crc32("AGODZoyS",8) == 3693475297) strcat(s, "Y");
if (crc32("joMYuhLudTFm",12) == 2428072005) strcat(s, "e");
if (crc32("YITAqfUxySvuahE",15) == 3440302914) strcat(s, "n");
if (crc32("wocOgkNnmqIcOO",14) == 715285265) strcat(s, "d");
    return s;
}

char *revenging_verbs() {
    char *s = calloc(10);
    if (crc32("exqez",5) == 3289547508) strcat(s, "r");
if (crc32("MDQvpvFuQ",9) == 2763607494) strcat(s, "Y");
if (crc32("HUXVSx",6) == 200993743) strcat(s, "e");
if (crc32("fLxyBAORxizTz",13) == 806607440) strcat(s, "X");
if (crc32("jMEKczxXFTSz",12) == 2379903859) strcat(s, "v");
if (crc32("mnQQt",5) == 3855571302) strcat(s, "e");
if (crc32("YABLcHXGyeEptKt",15) == 2017933448) strcat(s, "n");
if (crc32("joAogx",6) == 395237928) strcat(s, "g");
if (crc32("KWrtvyoh",8) == 1108852055) strcat(s, "l");
if (crc32("cbQashgmdzW",11) == 3132331357) strcat(s, "i");
if (crc32("CjKrVUVfpELH",12) == 1822102134) strcat(s, "G");
if (crc32("KIeINlCshE",10) == 2741844786) strcat(s, "n");
if (crc32("tEtOwFe",7) == 3753819516) strcat(s, "g");
    return s;
}

char *meld_verbs() {
    char *s = calloc(5);
    if (crc32("EAxzZMnfse",10) == 3326249407) strcat(s, "m");
if (crc32("fkMjCKBYCYYEOZ",14) == 609409489) strcat(s, "e");
if (crc32("WOnPXpIzcWOMG",13) == 3269270959) strcat(s, "l");
if (crc32("GLoilRryolQhfU",14) == 468608447) strcat(s, "d");
    return s;
}

char *cincturing_verbs() {
    char *s = calloc(11);
    if (crc32("zJesbLe",7) == 4184973776) strcat(s, "U");
if (crc32("FpLyFdAVyChE",12) == 2919947309) strcat(s, "c");
if (crc32("WdBlwnehEC",10) == 2258699384) strcat(s, "i");
if (crc32("AfYvRcqtEX",10) == 2404069544) strcat(s, "n");
if (crc32("jOlGpfjsSC",10) == 1135845093) strcat(s, "c");
if (crc32("omdOndrGhmtC",12) == 1007290082) strcat(s, "R");
if (crc32("IuZeGTtdQ",9) == 1336739319) strcat(s, "t");
if (crc32("nzZhLZG",7) == 2969689006) strcat(s, "u");
if (crc32("QoGuX",5) == 3795400963) strcat(s, "r");
if (crc32("NcwzsetwFamLp",13) == 1718336263) strcat(s, "i");
if (crc32("nGzgobbTF",9) == 2356119876) strcat(s, "n");
if (crc32("WfLUwFVCpRN",11) == 1086321072) strcat(s, "g");
    return s;
}

char *blazed_verbs() {
    char *s = calloc(7);
    if (crc32("NncEsTootk",10) == 1354494693) strcat(s, "s");
if (crc32("WhnaSre",7) == 1946862192) strcat(s, "b");
if (crc32("qYQldTEykl",10) == 1718506071) strcat(s, "h");
if (crc32("aJrmYSlXOfRmdKh",15) == 1187124860) strcat(s, "l");
if (crc32("fvSCKUz",7) == 1437620647) strcat(s, "a");
if (crc32("ojgVVKYJwn",10) == 1686642812) strcat(s, "z");
if (crc32("mjWHF",5) == 1039616539) strcat(s, "e");
if (crc32("eXmitJXSvaQSbcq",15) == 332786936) strcat(s, "w");
if (crc32("VjxZAeWSx",9) == 455646360) strcat(s, "d");
    return s;
}

char *practiced_verbs() {
    char *s = calloc(10);
    if (crc32("lZdgqpi",7) == 2368304701) strcat(s, "B");
if (crc32("lHXhauxncZPv",12) == 1601804723) strcat(s, "p");
if (crc32("YMIMsRhfidoJqvJ",15) == 3508112086) strcat(s, "v");
if (crc32("GjRHiKU",7) == 3864434646) strcat(s, "r");
if (crc32("BOYUVjd",7) == 2110539309) strcat(s, "k");
if (crc32("nRTVpunolbL",11) == 4087342182) strcat(s, "a");
if (crc32("wuFEE",5) == 3190742904) strcat(s, "l");
if (crc32("tYGTWAs",7) == 1240139810) strcat(s, "c");
if (crc32("yDQrCYYBCaANBK",14) == 2362767535) strcat(s, "t");
if (crc32("hlOQHOGRwrYtQj",14) == 3533292331) strcat(s, "r");
if (crc32("XwCBfedetjlELA",14) == 2500999397) strcat(s, "i");
if (crc32("uvdnHIgtCp",10) == 936105465) strcat(s, "c");
if (crc32("SGQhHZaCMtL",11) == 736357968) strcat(s, "e");
if (crc32("XxOwNQ",6) == 3645028109) strcat(s, "Z");
if (crc32("rLOInPYTTtldIoo",15) == 2127901467) strcat(s, "d");
    return s;
}

char *toweled_verbs() {
    char *s = calloc(8);
    if (crc32("OImIakpp",8) == 497526099) strcat(s, "t");
if (crc32("vBVIIclSQOdar",13) == 1517129289) strcat(s, "G");
if (crc32("xuuIOBQn",8) == 319307013) strcat(s, "o");
if (crc32("YdksEPX",7) == 2255928513) strcat(s, "w");
if (crc32("hOsZetxziwjWE",13) == 1335038794) strcat(s, "e");
if (crc32("sOEgQDPysfbJe",13) == 3317557159) strcat(s, "l");
if (crc32("GIdXKpeplF",10) == 1005944173) strcat(s, "e");
if (crc32("RkXaMVLzIG",10) == 2202953624) strcat(s, "F");
if (crc32("hfqTIvRYxet",11) == 2263058902) strcat(s, "d");
    return s;
}

char *overtiming_verbs() {
    char *s = calloc(11);
    if (crc32("hdqqZXkyh",9) == 1518232475) strcat(s, "o");
if (crc32("PEBvBfpkUZrF",12) == 2148997369) strcat(s, "v");
if (crc32("kxICIqXqHUSWM",13) == 3643971605) strcat(s, "e");
if (crc32("JYmWRaYaq",9) == 3858129422) strcat(s, "r");
if (crc32("McoJX",5) == 138498108) strcat(s, "E");
if (crc32("ArtAzYvfvtLmiA",14) == 2951507794) strcat(s, "t");
if (crc32("yhQafCRSFKLRJkg",15) == 2749524649) strcat(s, "i");
if (crc32("VAHDwYu",7) == 4089061347) strcat(s, "X");
if (crc32("tErzxGvPFyzc",12) == 2482159810) strcat(s, "m");
if (crc32("FbzsRpyNBOPsyoL",15) == 2646531898) strcat(s, "i");
if (crc32("eqNCqhvmqba",11) == 4272650133) strcat(s, "E");
if (crc32("OpMozblIdc",10) == 556037761) strcat(s, "n");
if (crc32("lGXkrOYXtQTy",12) == 3706871427) strcat(s, "g");
    return s;
}

char *oversleeping_verbs() {
    char *s = calloc(13);
    if (crc32("pOHkZrhe",8) == 2111665875) strcat(s, "Z");
if (crc32("ypUDnBZ",7) == 8633297) strcat(s, "o");
if (crc32("iozBb",5) == 164676865) strcat(s, "v");
if (crc32("LBsYNtY",7) == 2009089099) strcat(s, "e");
if (crc32("POZBwxJtcymmdJl",15) == 2313301801) strcat(s, "l");
if (crc32("rWTiZmwJso",10) == 1443544004) strcat(s, "r");
if (crc32("QKbshB",6) == 3469137332) strcat(s, "S");
if (crc32("cNtscchKalRfoo",14) == 2977981793) strcat(s, "s");
if (crc32("mDJQgvma",8) == 2100698217) strcat(s, "k");
if (crc32("nDwMySr",7) == 2216514011) strcat(s, "l");
if (crc32("iKQcqrvPNIuy",12) == 2299261499) strcat(s, "e");
if (crc32("YAJZbT",6) == 423083698) strcat(s, "U");
if (crc32("cjjSzzJcJDrDPg",14) == 1812969313) strcat(s, "e");
if (crc32("OlGZaUDhmPtM",12) == 1310699346) strcat(s, "p");
if (crc32("jGKPixOOyeE",11) == 166491614) strcat(s, "i");
if (crc32("TmepVVyR",8) == 2793549515) strcat(s, "g");
if (crc32("XnWqFaeT",8) == 1857510763) strcat(s, "n");
if (crc32("mkTIauWIohobeQ",14) == 636531344) strcat(s, "l");
if (crc32("BPgAmqUHgjHYbYQ",15) == 254498865) strcat(s, "g");
    return s;
}

char *paralleled_verbs() {
    char *s = calloc(11);
    if (crc32("DljphEOny",9) == 358699514) strcat(s, "r");
if (crc32("rfRPPAM",7) == 1012600043) strcat(s, "p");
if (crc32("uKYkgBiD",8) == 312261902) strcat(s, "a");
if (crc32("DwvRCMuj",8) == 1885233945) strcat(s, "r");
if (crc32("tXgrwFyTFWF",11) == 3618582260) strcat(s, "b");
if (crc32("vnlojPO",7) == 104163071) strcat(s, "a");
if (crc32("DcwkdvrCii",10) == 1567441447) strcat(s, "A");
if (crc32("Ccuvb",5) == 2013395414) strcat(s, "l");
if (crc32("RaeqYxMGOpYeLp",14) == 794056244) strcat(s, "V");
if (crc32("MgUJmQRwqDlp",12) == 1104298599) strcat(s, "l");
if (crc32("yKhDJPFZM",9) == 2334279504) strcat(s, "g");
if (crc32("sGDMJnKmaaGFZk",14) == 2772926710) strcat(s, "e");
if (crc32("FcWjDqNVJNP",11) == 3996609919) strcat(s, "b");
if (crc32("kpqOiOMhydwFt",13) == 3010251836) strcat(s, "l");
if (crc32("nFckFzydoS",10) == 3993356639) strcat(s, "w");
if (crc32("tQNDP",5) == 1018929898) strcat(s, "e");
if (crc32("wFhDDhuh",8) == 571471482) strcat(s, "m");
if (crc32("yUIPXER",7) == 1291129544) strcat(s, "d");
    return s;
}

char *prenominated_verbs() {
    char *s = calloc(13);
    if (crc32("VCNrsOubpBD",11) == 803574767) strcat(s, "P");
if (crc32("hZsaZaNZWb",10) == 2352549083) strcat(s, "p");
if (crc32("xPRcTyFVfV",10) == 3710381043) strcat(s, "r");
if (crc32("RuyNrvnWl",9) == 722619574) strcat(s, "v");
if (crc32("OKOPJNWF",8) == 4050022012) strcat(s, "e");
if (crc32("Lyztyu",6) == 3459306800) strcat(s, "K");
if (crc32("vEuPZwW",7) == 1126449581) strcat(s, "n");
if (crc32("QllvfNOVob",10) == 2510973520) strcat(s, "O");
if (crc32("XXYqDjdE",8) == 1257872042) strcat(s, "o");
if (crc32("RTcJndoXjrMWz",13) == 1804520099) strcat(s, "m");
if (crc32("MjvsOUSPe",9) == 1159249553) strcat(s, "i");
if (crc32("DaAkMYzHeZcP",12) == 4163105615) strcat(s, "n");
if (crc32("NxCiPvtjYKq",11) == 2017205772) strcat(s, "v");
if (crc32("MzJmouNPCh",10) == 4171593743) strcat(s, "a");
if (crc32("DeQGZYZJSINvVx",14) == 3505663659) strcat(s, "t");
if (crc32("lHjBkDPf",8) == 2600516273) strcat(s, "e");
if (crc32("nVYWZZFNL",9) == 3200351924) strcat(s, "u");
if (crc32("suRxAwPBmWkqrx",14) == 3546127807) strcat(s, "d");
    return s;
}

char *hirpled_verbs() {
    char *s = calloc(8);
    if (crc32("whTsRmldkyOwoeR",15) == 3529723637) strcat(s, "h");
if (crc32("oMwAvRVSPkUEn",13) == 3921189028) strcat(s, "i");
if (crc32("lZtHHLxjiqQPpIX",15) == 2341441681) strcat(s, "r");
if (crc32("CkGKFkfNYS",10) == 3889455280) strcat(s, "p");
if (crc32("UKodRej",7) == 2361647989) strcat(s, "G");
if (crc32("DnxLTNkIf",9) == 1891365522) strcat(s, "l");
if (crc32("JiLqJR",6) == 2149707552) strcat(s, "e");
if (crc32("jSdORKQOvmZ",11) == 1722636081) strcat(s, "d");
    return s;
}

char *laik_verbs() {
    char *s = calloc(5);
    if (crc32("lTgzjDVOdM",10) == 228155789) strcat(s, "l");
if (crc32("zErzDWIIEKzTM",13) == 766769954) strcat(s, "z");
if (crc32("FQGHZxvRJnREodS",15) == 345410591) strcat(s, "a");
if (crc32("gbGPrGWN",8) == 3144486889) strcat(s, "y");
if (crc32("rYBSVOPxwXTzP",13) == 220045669) strcat(s, "i");
if (crc32("mDjRt",5) == 2168050936) strcat(s, "L");
if (crc32("SfJkFk",6) == 3787625948) strcat(s, "k");
    return s;
}

char *stabilizing_verbs() {
    char *s = calloc(12);
    if (crc32("dtVZw",5) == 2831749656) strcat(s, "s");
if (crc32("OIQLboikcs",10) == 2485289603) strcat(s, "E");
if (crc32("mSHylIUiNhcxjbq",15) == 384283733) strcat(s, "t");
if (crc32("EzhcgOLcRhqab",13) == 3890565619) strcat(s, "J");
if (crc32("ZIQDb",5) == 139131186) strcat(s, "a");
if (crc32("yxChivsCj",9) == 925897662) strcat(s, "J");
if (crc32("SLxymeTDtyuGzk",14) == 469757182) strcat(s, "b");
if (crc32("lDekkXuZJemm",12) == 975950234) strcat(s, "f");
if (crc32("tuDBoJkNwyPkrIl",15) == 3755663623) strcat(s, "i");
if (crc32("PvolqxOZzPkj",12) == 2370843207) strcat(s, "b");
if (crc32("FjnsA",5) == 42659978) strcat(s, "l");
if (crc32("OemRHUfoSsVvu",13) == 1569963787) strcat(s, "i");
if (crc32("UDJGZ",5) == 1798050290) strcat(s, "z");
if (crc32("Slqofo",6) == 431536826) strcat(s, "i");
if (crc32("kyFkGnietUCf",12) == 2646561625) strcat(s, "n");
if (crc32("WaCgbd",6) == 805455436) strcat(s, "D");
if (crc32("UaEmZdl",7) == 1388844480) strcat(s, "g");
    return s;
}

char *fortifying_verbs() {
    char *s = calloc(11);
    if (crc32("IBZmTU",6) == 2597288880) strcat(s, "f");
if (crc32("lBzsMlIyVFDLS",13) == 3282050418) strcat(s, "o");
if (crc32("wKysrzSlXnhmuo",14) == 771177172) strcat(s, "r");
if (crc32("nldeR",5) == 1138866764) strcat(s, "t");
if (crc32("tUuPz",5) == 1861361999) strcat(s, "i");
if (crc32("MaFiVvcML",9) == 1419690667) strcat(s, "f");
if (crc32("iCdcIWJEqP",10) == 3203724608) strcat(s, "u");
if (crc32("aGkgrWH",7) == 812356882) strcat(s, "y");
if (crc32("dGIok",5) == 3944562659) strcat(s, "i");
if (crc32("LuAkiJsEj",9) == 2886054519) strcat(s, "n");
if (crc32("cSiyhZ",6) == 1875845067) strcat(s, "a");
if (crc32("RBtDrWstfFt",11) == 1556144887) strcat(s, "g");
    return s;
}

char *cannonading_verbs() {
    char *s = calloc(12);
    if (crc32("bJSqdmhbg",9) == 2577782770) strcat(s, "c");
if (crc32("UEbPBLKHwmikKLn",15) == 877649685) strcat(s, "G");
if (crc32("ZWpea",5) == 2492838160) strcat(s, "a");
if (crc32("WzNmCjfjSqpoBKs",15) == 3267589640) strcat(s, "b");
if (crc32("QfgRExvXrbwDp",13) == 3679395449) strcat(s, "n");
if (crc32("mUyZjhsOrxbHZpr",15) == 2812410049) strcat(s, "l");
if (crc32("IOLaYrgVDUiC",12) == 3940948861) strcat(s, "n");
if (crc32("mavGITvi",8) == 2775116082) strcat(s, "E");
if (crc32("XeUGUuWsKieoFKn",15) == 1970724583) strcat(s, "o");
if (crc32("gUIRzWOjdbXa",12) == 1364394920) strcat(s, "n");
if (crc32("DuTrIGYI",8) == 4160093327) strcat(s, "x");
if (crc32("yKPVeAtSZRIKJ",13) == 935729294) strcat(s, "a");
if (crc32("LCgGxPAblTsilf",14) == 186239169) strcat(s, "n");
if (crc32("dxGicVlgPtpiysx",15) == 2744249496) strcat(s, "d");
if (crc32("inZypW",6) == 1285252706) strcat(s, "X");
if (crc32("GbMhDBYMNo",10) == 754060185) strcat(s, "i");
if (crc32("RjExEafpvu",10) == 107175631) strcat(s, "T");
if (crc32("TyflteRZ",8) == 3869472922) strcat(s, "n");
if (crc32("KDSWYwbPMPgKnEA",15) == 3614846293) strcat(s, "g");
    return s;
}

char *professionalizing_verbs() {
    char *s = calloc(18);
    if (crc32("TUfxRsCBGbQl",12) == 294367434) strcat(s, "p");
if (crc32("hbGBks",6) == 2354029433) strcat(s, "r");
if (crc32("HFLmhZ",6) == 841835256) strcat(s, "o");
if (crc32("NZowArv",7) == 485534456) strcat(s, "f");
if (crc32("bWrUMnvx",8) == 2869625427) strcat(s, "e");
if (crc32("VeXljmtJVvCM",12) == 615777513) strcat(s, "E");
if (crc32("hujLUrVnEwe",11) == 1456845209) strcat(s, "s");
if (crc32("FEkFCrPMO",9) == 1797348019) strcat(s, "s");
if (crc32("QcAdFzbYoRhkEy",14) == 1394465810) strcat(s, "b");
if (crc32("RQMzTWzxmG",10) == 3127235228) strcat(s, "i");
if (crc32("qBzMVPLaikCF",12) == 2931538412) strcat(s, "o");
if (crc32("oCUNvvrGTVcWQv",14) == 3348124092) strcat(s, "R");
if (crc32("QHgIxEbBPuFv",12) == 2037477091) strcat(s, "n");
if (crc32("BpxgNI",6) == 3150345652) strcat(s, "N");
if (crc32("sPDBRzQC",8) == 2797974894) strcat(s, "a");
if (crc32("inEeTlhZBbnM",12) == 549998795) strcat(s, "l");
if (crc32("BqUDdmIjYNO",11) == 1210402258) strcat(s, "i");
if (crc32("KHmdpxJ",7) == 3365115508) strcat(s, "z");
if (crc32("vSOdBeXuVqhVA",13) == 799569446) strcat(s, "i");
if (crc32("vJBmsVD",7) == 3036407807) strcat(s, "v");
if (crc32("PWudOpsQAYygD",13) == 2113326734) strcat(s, "n");
if (crc32("YxlzeDj",7) == 3816697230) strcat(s, "g");
    return s;
}

char *misshape_verbs() {
    char *s = calloc(9);
    if (crc32("SYPfOkJVIji",11) == 1399736576) strcat(s, "m");
if (crc32("szPAaPDyavmL",12) == 1865030541) strcat(s, "m");
if (crc32("PLpvUzMHktTFqNb",15) == 2352601372) strcat(s, "i");
if (crc32("FumqNIuCjW",10) == 4017783447) strcat(s, "s");
if (crc32("JpjbCfOYvPNNBFX",15) == 2761919900) strcat(s, "O");
if (crc32("hRlcXHf",7) == 4026321097) strcat(s, "s");
if (crc32("CbhGZTE",7) == 3145254122) strcat(s, "h");
if (crc32("TbdxkycXtlJAwr",14) == 899719370) strcat(s, "M");
if (crc32("xbfUtSEAbjNzGf",14) == 807597984) strcat(s, "a");
if (crc32("WtyWfQIPnBArhlN",15) == 2796713725) strcat(s, "u");
if (crc32("LUFBrgXDfiMLvj",14) == 2372039327) strcat(s, "p");
if (crc32("YxOJkfuRyml",11) == 4240552538) strcat(s, "e");
    return s;
}

char *overconcentrate_verbs() {
    char *s = calloc(16);
    if (crc32("wdZsjFplcGRRQ",13) == 4070688315) strcat(s, "o");
if (crc32("PWFid",5) == 311504193) strcat(s, "Z");
if (crc32("ZhwCnshZYsRezRi",15) == 2909739050) strcat(s, "v");
if (crc32("LrwOKbhIATgl",12) == 1330678647) strcat(s, "Q");
if (crc32("RJwRQzwNJDCqOEN",15) == 1522873872) strcat(s, "e");
if (crc32("KvTeQga",7) == 3121059378) strcat(s, "r");
if (crc32("LCofhvWhU",9) == 3794685653) strcat(s, "c");
if (crc32("KcKWtDVMAWBxE",13) == 4127266740) strcat(s, "o");
if (crc32("BKOfVaa",7) == 715258758) strcat(s, "m");
if (crc32("VFkAbFmFYgNVm",13) == 3822797373) strcat(s, "n");
if (crc32("eStMPJmFSnxpxxH",15) == 4057339715) strcat(s, "C");
if (crc32("isgOqCFJhundNLe",15) == 1911727318) strcat(s, "c");
if (crc32("kGefOeWLpekoh",13) == 11356742) strcat(s, "g");
if (crc32("MCliOXYU",8) == 2565720489) strcat(s, "e");
if (crc32("YLeyP",5) == 3061689128) strcat(s, "l");
if (crc32("JoeUqRXQ",8) == 3674105867) strcat(s, "n");
if (crc32("hIqQB",5) == 1725677059) strcat(s, "b");
if (crc32("KGFiYNSSxCjVeDv",15) == 1410156609) strcat(s, "t");
if (crc32("XtGWZk",6) == 2823370889) strcat(s, "r");
if (crc32("EMjbfqzuCendVPq",15) == 2684407121) strcat(s, "n");
if (crc32("tJePgcDGxBDwcw",14) == 393263201) strcat(s, "a");
if (crc32("mrOwyITJQQDRtzi",15) == 3836701115) strcat(s, "t");
if (crc32("xFvTu",5) == 523981555) strcat(s, "e");
    return s;
}

char *dissembling_verbs() {
    char *s = calloc(12);
    if (crc32("nLAMYllO",8) == 1486280314) strcat(s, "f");
if (crc32("RyKWqvMRWc",10) == 17107019) strcat(s, "d");
if (crc32("LCGXx",5) == 2347303057) strcat(s, "i");
if (crc32("FapbKhQpePlcX",13) == 2883601218) strcat(s, "s");
if (crc32("hxsCBKnkO",9) == 2193964626) strcat(s, "e");
if (crc32("DurWhcHH",8) == 1322841561) strcat(s, "s");
if (crc32("tyEarNhfBrfInD",14) == 3091006123) strcat(s, "T");
if (crc32("QuhoyYxlwHeFF",13) == 2037445628) strcat(s, "e");
if (crc32("BtSLrmoQwZEOTz",14) == 1783785046) strcat(s, "H");
if (crc32("fMdfLYfCAMZ",11) == 660686154) strcat(s, "m");
if (crc32("SCbeBjtIIdRGH",13) == 186650700) strcat(s, "b");
if (crc32("hlDIeA",6) == 3764924331) strcat(s, "T");
if (crc32("lxwpBszIeuifa",13) == 1777908773) strcat(s, "l");
if (crc32("FccRosXFypkUA",13) == 3379524775) strcat(s, "y");
if (crc32("rMgWqFxx",8) == 803556735) strcat(s, "i");
if (crc32("HuLMM",5) == 3329936634) strcat(s, "n");
if (crc32("YhqEE",5) == 3078514282) strcat(s, "m");
if (crc32("duFxdXbGGyvUD",13) == 896080536) strcat(s, "g");
    return s;
}

char *kickabout_verbs() {
    char *s = calloc(10);
    if (crc32("etgHbpbF",8) == 648805589) strcat(s, "o");
if (crc32("wjdtaKeT",8) == 4171212608) strcat(s, "k");
if (crc32("xKVtTTWDTwcp",12) == 79008318) strcat(s, "i");
if (crc32("gslzDKonLTwq",12) == 3096002401) strcat(s, "W");
if (crc32("buFLwuoUY",9) == 2928543745) strcat(s, "c");
if (crc32("QfFuvt",6) == 2720677395) strcat(s, "k");
if (crc32("iVrUUUd",7) == 754669722) strcat(s, "g");
if (crc32("llAUsakAH",9) == 2368384317) strcat(s, "a");
if (crc32("vbPMFQFyAYTnf",13) == 416695528) strcat(s, "b");
if (crc32("drRNsBmdm",9) == 1964581109) strcat(s, "b");
if (crc32("AHhTonkJF",9) == 245008501) strcat(s, "b");
if (crc32("bmqRSxywhl",10) == 2719301392) strcat(s, "o");
if (crc32("BjOjl",5) == 274370544) strcat(s, "u");
if (crc32("tLTRvcRl",8) == 3541242328) strcat(s, "t");
    return s;
}

char *overcivilizing_verbs() {
    char *s = calloc(15);
    if (crc32("OPFAxUNERvxfp",13) == 3467381160) strcat(s, "o");
if (crc32("PMahAVeTgHJ",11) == 564261079) strcat(s, "u");
if (crc32("YtuydDGOTgnx",12) == 1490046145) strcat(s, "v");
if (crc32("aLpqDR",6) == 1319995296) strcat(s, "V");
if (crc32("qKMcFjKuga",10) == 2862990842) strcat(s, "e");
if (crc32("GdDuYBOegPB",11) == 1715583890) strcat(s, "r");
if (crc32("AynfAJWnrt",10) == 3610968337) strcat(s, "g");
if (crc32("NyrqjJUJiY",10) == 132760949) strcat(s, "c");
if (crc32("AHwcmoRnFE",10) == 3349408641) strcat(s, "i");
if (crc32("QcpRQIelAKTYPq",14) == 2105078124) strcat(s, "v");
if (crc32("XZTBaaHTsDpAFBm",15) == 3039578828) strcat(s, "E");
if (crc32("WpffCa",6) == 3933023078) strcat(s, "i");
if (crc32("ENTgciCkoXF",11) == 1140756955) strcat(s, "b");
if (crc32("xhaVIlDJH",9) == 2021350244) strcat(s, "l");
if (crc32("vKYmTWGaSVtBDLq",15) == 166970976) strcat(s, "i");
if (crc32("QiprwxGo",8) == 2760875951) strcat(s, "z");
if (crc32("rIWISSUfxyoOd",13) == 1911675876) strcat(s, "S");
if (crc32("edsDYkpCVm",10) == 1144183714) strcat(s, "i");
if (crc32("cUNMixj",7) == 4165729693) strcat(s, "n");
if (crc32("KqJopMtWjuhilZO",15) == 1927147009) strcat(s, "g");
    return s;
}

char *overstir_verbs() {
    char *s = calloc(9);
    if (crc32("ZNwLoxyAFeYEg",13) == 285846360) strcat(s, "o");
if (crc32("lmOpVuyR",8) == 3357480812) strcat(s, "v");
if (crc32("MgjALBtuUoK",11) == 1977075583) strcat(s, "X");
if (crc32("vSVWwyAECIbcf",13) == 1466626221) strcat(s, "e");
if (crc32("kQABDItXEhmIXbp",15) == 1923605326) strcat(s, "r");
if (crc32("iyDLqncTriIhBW",14) == 2471042338) strcat(s, "o");
if (crc32("DOGkVHsRGU",10) == 3754336742) strcat(s, "s");
if (crc32("kLDfcDr",7) == 3220616264) strcat(s, "t");
if (crc32("AGtfZmP",7) == 4143113063) strcat(s, "R");
if (crc32("QzixwiOvLclXqI",14) == 221081941) strcat(s, "i");
if (crc32("dipIIa",6) == 1839240483) strcat(s, "j");
if (crc32("hzRcnXfQnXuO",12) == 2465270805) strcat(s, "r");
    return s;
}

char *assist_verbs() {
    char *s = calloc(7);
    if (crc32("gavDMb",6) == 2044111781) strcat(s, "g");
if (crc32("uHOUtkyRxluinT",14) == 34246997) strcat(s, "a");
if (crc32("LmcIaZKEnQlRh",13) == 2094684865) strcat(s, "s");
if (crc32("fXnxKfg",7) == 2178955167) strcat(s, "s");
if (crc32("ZlVkkMsZE",9) == 377874355) strcat(s, "l");
if (crc32("TsQsS",5) == 3912630168) strcat(s, "i");
if (crc32("VTlCNGOcRNgl",12) == 2762986981) strcat(s, "s");
if (crc32("iHrdQcbTsTMtYGB",15) == 1529711500) strcat(s, "f");
if (crc32("TIVsuy",6) == 2961052454) strcat(s, "t");
    return s;
}

char *misrating_verbs() {
    char *s = calloc(10);
    if (crc32("xFRcmcRuYS",10) == 614699899) strcat(s, "K");
if (crc32("fVUnxyNqshD",11) == 3615554707) strcat(s, "m");
if (crc32("KbHrXVxAFUn",11) == 4193583272) strcat(s, "i");
if (crc32("QehBSCsiGupR",12) == 2258761712) strcat(s, "s");
if (crc32("MhleQRQVVKHJHC",14) == 2902747311) strcat(s, "r");
if (crc32("ZUISpjALRJs",11) == 1523003269) strcat(s, "a");
if (crc32("ZiIRktgZU",9) == 3990425680) strcat(s, "X");
if (crc32("avpTVfwDqV",10) == 3694037275) strcat(s, "t");
if (crc32("zuXHPvnjAGTJaer",15) == 3443927415) strcat(s, "i");
if (crc32("GnMrqCv",7) == 2020263140) strcat(s, "n");
if (crc32("JHNbCwlWonfl",12) == 312207385) strcat(s, "g");
    return s;
}

char *blab_verbs() {
    char *s = calloc(5);
    if (crc32("DvBxlULU",8) == 2419455892) strcat(s, "b");
if (crc32("lsugwcOopMQFCX",14) == 1536163991) strcat(s, "l");
if (crc32("xKVjyQkd",8) == 1362933305) strcat(s, "y");
if (crc32("IKvzwVjchSTGe",13) == 3169005413) strcat(s, "a");
if (crc32("EkEFMYVIXeSbG",13) == 4212101457) strcat(s, "y");
if (crc32("KqcntOAhb",9) == 3799066720) strcat(s, "b");
    return s;
}

char *pedalling_verbs() {
    char *s = calloc(10);
    if (crc32("KHFbyHncPsRU",12) == 2436850410) strcat(s, "p");
if (crc32("zGZzXVbPWPdCMdZ",15) == 786851219) strcat(s, "x");
if (crc32("hXceawWixuW",11) == 3706237669) strcat(s, "e");
if (crc32("gazbICd",7) == 3761368634) strcat(s, "X");
if (crc32("GwPNiCStBILcTyk",15) == 3841582351) strcat(s, "d");
if (crc32("NDksusjipo",10) == 3031736239) strcat(s, "a");
if (crc32("gRPqIiYPhJbN",12) == 660570783) strcat(s, "l");
if (crc32("VSkuvqmUa",9) == 2467572910) strcat(s, "W");
if (crc32("cUUpbqOB",8) == 3289745715) strcat(s, "l");
if (crc32("bzWuvfnuh",9) == 2005713976) strcat(s, "F");
if (crc32("KwfRgux",7) == 4215222104) strcat(s, "i");
if (crc32("veQCcrxbRUKvK",13) == 581770343) strcat(s, "n");
if (crc32("CzEdfRMb",8) == 772914285) strcat(s, "g");
    return s;
}

char *fulminating_verbs() {
    char *s = calloc(12);
    if (crc32("lnLShbbRRts",11) == 2409409691) strcat(s, "f");
if (crc32("nEkPsVELwdn",11) == 299342849) strcat(s, "H");
if (crc32("gArtGLZgE",9) == 2789749920) strcat(s, "u");
if (crc32("mAuzmLA",7) == 2611031465) strcat(s, "l");
if (crc32("Onravznc",8) == 2488905386) strcat(s, "m");
if (crc32("FQgTmAEXD",9) == 2761597165) strcat(s, "B");
if (crc32("YSkYJmmETqpl",12) == 3230655447) strcat(s, "i");
if (crc32("iAFrcKMvw",9) == 3473865590) strcat(s, "n");
if (crc32("oyNZiKCqNLzhXh",14) == 825417429) strcat(s, "n");
if (crc32("sKNXWSa",7) == 249121134) strcat(s, "a");
if (crc32("tYfUC",5) == 2535976814) strcat(s, "Q");
if (crc32("srHtoNYusgMqrT",14) == 3437924044) strcat(s, "t");
if (crc32("MGuKfaIDnSXsz",13) == 129265514) strcat(s, "i");
if (crc32("zQyAjBHN",8) == 451902097) strcat(s, "n");
if (crc32("fLyeKxWkOQj",11) == 2667026457) strcat(s, "Z");
if (crc32("nQkQrrS",7) == 2759506443) strcat(s, "g");
    return s;
}

char *intergossiped_verbs() {
    char *s = calloc(14);
    if (crc32("NdnFrIqHZuM",11) == 1600030577) strcat(s, "o");
if (crc32("ZtuducgdEImL",12) == 2845371125) strcat(s, "i");
if (crc32("mECAVzmUglup",12) == 2191916467) strcat(s, "Y");
if (crc32("pTWqPZZF",8) == 3189540818) strcat(s, "n");
if (crc32("yiCUlsdLNpiwHPd",15) == 3939891659) strcat(s, "t");
if (crc32("EPwoDzvhBwb",11) == 3399785895) strcat(s, "e");
if (crc32("gXcpAHjXeTbTPLP",15) == 210474131) strcat(s, "Q");
if (crc32("MIiso",5) == 507828737) strcat(s, "r");
if (crc32("PNEnvp",6) == 2641145365) strcat(s, "g");
if (crc32("GICIsmAAThH",11) == 1224248604) strcat(s, "S");
if (crc32("diXfBjqjLllZiP",14) == 3092493652) strcat(s, "o");
if (crc32("yxADnSkngiOMp",13) == 1739319146) strcat(s, "s");
if (crc32("ZKcDyU",6) == 2282289503) strcat(s, "s");
if (crc32("hmfoM",5) == 8264088) strcat(s, "i");
if (crc32("UVoJpzpkOyq",11) == 3363246958) strcat(s, "y");
if (crc32("lGkEWYSvvIxukMT",15) == 3742192188) strcat(s, "p");
if (crc32("VbXXNFUhWDUMhWd",15) == 2612795988) strcat(s, "f");
if (crc32("qIkBTTBS",8) == 2344401197) strcat(s, "e");
if (crc32("ywVxgtseiFMja",13) == 1967879019) strcat(s, "d");
    return s;
}

char *sideswiped_verbs() {
    char *s = calloc(11);
    if (crc32("QrfFoyrLUcJke",13) == 348677281) strcat(s, "s");
if (crc32("RFcidR",6) == 2663980719) strcat(s, "I");
if (crc32("zPeynteJQZoA",12) == 3233846555) strcat(s, "i");
if (crc32("esoVApoDRYLx",12) == 3501585611) strcat(s, "d");
if (crc32("cwuNZhbYKjA",11) == 3841214128) strcat(s, "e");
if (crc32("eEyIPprbFM",10) == 2192769258) strcat(s, "z");
if (crc32("jvINUK",6) == 3571785348) strcat(s, "s");
if (crc32("ferCioLGszBxXbs",15) == 895361594) strcat(s, "w");
if (crc32("kKWgJog",7) == 3342094475) strcat(s, "a");
if (crc32("loUUFkfnZH",10) == 2484364523) strcat(s, "i");
if (crc32("KtkwVgJqvijYG",13) == 662608749) strcat(s, "S");
if (crc32("oOETloS",7) == 2603241829) strcat(s, "p");
if (crc32("sEuLGnQ",7) == 2789188677) strcat(s, "v");
if (crc32("JKBOWIyjBF",10) == 2780940400) strcat(s, "e");
if (crc32("RaMciU",6) == 2821502901) strcat(s, "E");
if (crc32("ydbURlcyYk",10) == 3579056405) strcat(s, "d");
    return s;
}

char *overwearied_verbs() {
    char *s = calloc(12);
    if (crc32("bJHldIhzqBy",11) == 1281537225) strcat(s, "o");
if (crc32("jlDbUQUhSUID",12) == 2283458490) strcat(s, "v");
if (crc32("kovXPZRfLqd",11) == 3938566721) strcat(s, "e");
if (crc32("EdkNWXik",8) == 2759606922) strcat(s, "r");
if (crc32("rjnTwnJz",8) == 4139228648) strcat(s, "r");
if (crc32("wfWpJQIT",8) == 400718784) strcat(s, "w");
if (crc32("tVXJiwSXCw",10) == 2198829064) strcat(s, "y");
if (crc32("bwHPhBJNCuSDtS",14) == 76006688) strcat(s, "e");
if (crc32("JzwWPkeao",9) == 1149247386) strcat(s, "Q");
if (crc32("iSwHsfi",7) == 1299456968) strcat(s, "a");
if (crc32("qFotNo",6) == 3780705452) strcat(s, "c");
if (crc32("XhcRSnhOxwpQDp",14) == 4145679092) strcat(s, "r");
if (crc32("lueijdBmI",9) == 2232450802) strcat(s, "i");
if (crc32("GDzjMiJdzY",10) == 1429215056) strcat(s, "e");
if (crc32("VpgLjoqMh",9) == 2664453954) strcat(s, "d");
    return s;
}

char *gigged_verbs() {
    char *s = calloc(7);
    if (crc32("GWxxMrifUcpp",12) == 108846869) strcat(s, "g");
if (crc32("expjzL",6) == 2761746153) strcat(s, "g");
if (crc32("XSCOp",5) == 1161918696) strcat(s, "k");
if (crc32("tGQQNcgTTdQWrk",14) == 851919011) strcat(s, "i");
if (crc32("vDbfpeegQ",9) == 2265293146) strcat(s, "g");
if (crc32("SGBxee",6) == 2678521032) strcat(s, "g");
if (crc32("sCfWJn",6) == 4094003055) strcat(s, "e");
if (crc32("ugkCZSnsZPw",11) == 2170446486) strcat(s, "G");
if (crc32("vXJwlJmWaKh",11) == 4138117951) strcat(s, "d");
    return s;
}

char *polishup_verbs() {
    char *s = calloc(9);
    if (crc32("kiZQCqGTWk",10) == 1956350229) strcat(s, "p");
if (crc32("WgqYVKDcuWVS",12) == 1161385490) strcat(s, "o");
if (crc32("PFgRyWeCDb",10) == 1994470528) strcat(s, "o");
if (crc32("dDUzmhFyCYLzyo",14) == 518069603) strcat(s, "N");
if (crc32("PMhJtXaRhVudgE",14) == 3830073940) strcat(s, "l");
if (crc32("rGalQZwPqjcGNnp",15) == 2684113763) strcat(s, "i");
if (crc32("XCHlidTQlWkBxQl",15) == 2677443966) strcat(s, "u");
if (crc32("xIrbXe",6) == 3331269093) strcat(s, "s");
if (crc32("NbTVlzXBHoRtuAO",15) == 2825512920) strcat(s, "x");
if (crc32("RQRWjy",6) == 1271618445) strcat(s, "h");
if (crc32("iJBNnD",6) == 1694760587) strcat(s, "D");
if (crc32("TbzlPIGuszoEjc",14) == 591701218) strcat(s, "u");
if (crc32("lEmLVBSkFLM",11) == 1846297293) strcat(s, "J");
if (crc32("bYyenNUTS",9) == 3828861975) strcat(s, "p");
    return s;
}

char *carousing_verbs() {
    char *s = calloc(10);
    if (crc32("cLZOfBtY",8) == 2958583916) strcat(s, "V");
if (crc32("cCEPkrXV",8) == 1645980768) strcat(s, "c");
if (crc32("JASmEpPFPQ",10) == 767133869) strcat(s, "a");
if (crc32("zCnBPphAb",9) == 1602038010) strcat(s, "A");
if (crc32("ECXBpddXaw",10) == 716007962) strcat(s, "r");
if (crc32("VoUBEho",7) == 4133859493) strcat(s, "z");
if (crc32("YbibUhqIteShzG",14) == 3784334346) strcat(s, "o");
if (crc32("OTOzkEnFGVp",11) == 16771231) strcat(s, "j");
if (crc32("RUtPTxLD",8) == 2560379203) strcat(s, "u");
if (crc32("nTRxjTsppi",10) == 2571674663) strcat(s, "s");
if (crc32("CZHEo",5) == 1758818196) strcat(s, "l");
if (crc32("oEVjmKGahfarh",13) == 3814515405) strcat(s, "i");
if (crc32("sgldbCmqlmQ",11) == 1956825153) strcat(s, "f");
if (crc32("djVJd",5) == 3597885755) strcat(s, "n");
if (crc32("dpSCRbgNxATJPlb",15) == 3546791487) strcat(s, "g");
    return s;
}

char *poling_verbs() {
    char *s = calloc(7);
    if (crc32("HIoaPvqzyR",10) == 2167655437) strcat(s, "Q");
if (crc32("usgAKTr",7) == 3122864633) strcat(s, "p");
if (crc32("pYUYFobDp",9) == 3745853751) strcat(s, "j");
if (crc32("kHIku",5) == 2941075459) strcat(s, "o");
if (crc32("ZxaWMaLUnAXaAIH",15) == 1437452296) strcat(s, "C");
if (crc32("JdasFei",7) == 1801019110) strcat(s, "l");
if (crc32("rSRaHryJBYNUV",13) == 1999909121) strcat(s, "i");
if (crc32("ALHNPCuWuwn",11) == 463911090) strcat(s, "n");
if (crc32("hSKGt",5) == 575104283) strcat(s, "n");
if (crc32("IFMiYozK",8) == 1292758499) strcat(s, "L");
if (crc32("TYTRmylvC",9) == 3052021909) strcat(s, "g");
    return s;
}

char *concaved_verbs() {
    char *s = calloc(9);
    if (crc32("oRHiOUhFy",9) == 3811024607) strcat(s, "p");
if (crc32("WutPHenaJSCU",12) == 3740267529) strcat(s, "c");
if (crc32("GoPvbkhglNtz",12) == 3792868331) strcat(s, "o");
if (crc32("YNbLSy",6) == 3608522407) strcat(s, "I");
if (crc32("gjgOIBGxQdYnNDZ",15) == 250604755) strcat(s, "n");
if (crc32("qqoqYsJJQY",10) == 119318944) strcat(s, "C");
if (crc32("uToACZJieGVaM",13) == 2186604319) strcat(s, "c");
if (crc32("OACDmQvnKF",10) == 1672619653) strcat(s, "a");
if (crc32("ZxcsLXULshthoe",14) == 1659479049) strcat(s, "p");
if (crc32("gqnHan",6) == 320675279) strcat(s, "v");
if (crc32("sVBkZxqTIASnFa",14) == 3964244420) strcat(s, "p");
if (crc32("OtomxsMETPYL",12) == 1194927466) strcat(s, "e");
if (crc32("BNVmaOLnZ",9) == 1902684277) strcat(s, "I");
if (crc32("FdpXXjFGuybOg",13) == 418371216) strcat(s, "d");
    return s;
}

char *sparest_verbs() {
    char *s = calloc(8);
    if (crc32("miHwG",5) == 400628498) strcat(s, "s");
if (crc32("NTezJaHOfPsYjHX",15) == 2337969130) strcat(s, "z");
if (crc32("fLYaGyPLValy",12) == 3795206947) strcat(s, "p");
if (crc32("ulokNNj",7) == 316028234) strcat(s, "a");
if (crc32("pRWUtrvLj",9) == 1575260475) strcat(s, "n");
if (crc32("BEFCCnimvahR",12) == 1777042032) strcat(s, "r");
if (crc32("iHwElqQjGH",10) == 3405520598) strcat(s, "f");
if (crc32("JjdXuRdVNmlCe",13) == 2178586110) strcat(s, "e");
if (crc32("SjtNBgNqFqnO",12) == 788739982) strcat(s, "v");
if (crc32("oAjihnvDfekcofy",15) == 3104324650) strcat(s, "s");
if (crc32("NJAUKuffRRnkX",13) == 4029944448) strcat(s, "O");
if (crc32("gPcGGH",6) == 123306562) strcat(s, "t");
    return s;
}

char *rerising_verbs() {
    char *s = calloc(9);
    if (crc32("nhWXLLQXugd",11) == 2991220436) strcat(s, "l");
if (crc32("KqnLsGJH",8) == 2331638581) strcat(s, "r");
if (crc32("bkdKyqOb",8) == 2214724361) strcat(s, "j");
if (crc32("qgiVIWJADkT",11) == 1760992160) strcat(s, "e");
if (crc32("dXYjkS",6) == 3700516748) strcat(s, "H");
if (crc32("lfjkjGYpO",9) == 2019499184) strcat(s, "r");
if (crc32("xRYjErgdy",9) == 2443576368) strcat(s, "i");
if (crc32("LlRCXWn",7) == 2547817710) strcat(s, "s");
if (crc32("vbXdipfY",8) == 4218697094) strcat(s, "S");
if (crc32("BYvYgFzANpAEDBl",15) == 3394682509) strcat(s, "i");
if (crc32("malMUhWMwz",10) == 4109244166) strcat(s, "R");
if (crc32("KnQlTpYUzMvqgMa",15) == 3975287651) strcat(s, "n");
if (crc32("lPhEYjviw",9) == 77073864) strcat(s, "L");
if (crc32("DnGAZcGvcDq",11) == 3375910201) strcat(s, "g");
    return s;
}

char *stumbling_verbs() {
    char *s = calloc(10);
    if (crc32("brZWVU",6) == 1297036295) strcat(s, "s");
if (crc32("FTpaSMxCqYnn",12) == 913375167) strcat(s, "t");
if (crc32("pclSbEvmon",10) == 1984951101) strcat(s, "u");
if (crc32("KPSQZtIjuvh",11) == 2347855412) strcat(s, "m");
if (crc32("nGAdXjKlLkQaz",13) == 296181376) strcat(s, "b");
if (crc32("jpTMXmtnmLxBd",13) == 1981706489) strcat(s, "l");
if (crc32("MMTMmG",6) == 162916065) strcat(s, "I");
if (crc32("dMyYWCZhC",9) == 656892182) strcat(s, "i");
if (crc32("VWFGNUtEFYSv",12) == 1761193580) strcat(s, "n");
if (crc32("JwyzAQLVQKihjdo",15) == 4281822235) strcat(s, "g");
    return s;
}

char *dangling_verbs() {
    char *s = calloc(9);
    if (crc32("ZwLvV",5) == 3660615641) strcat(s, "R");
if (crc32("tADRozGuOWlRN",13) == 3051035193) strcat(s, "d");
if (crc32("qtGUuOds",8) == 283890758) strcat(s, "a");
if (crc32("JUWRDExHhczxPJ",14) == 2101566304) strcat(s, "n");
if (crc32("ALOtQsgQTwdz",12) == 1050757370) strcat(s, "g");
if (crc32("OFoNGNhcziLdJA",14) == 3914026812) strcat(s, "N");
if (crc32("pFjjtGl",7) == 2279123602) strcat(s, "l");
if (crc32("thqcjdNJP",9) == 576927643) strcat(s, "A");
if (crc32("vCWuEpWqBjz",11) == 3798198056) strcat(s, "i");
if (crc32("ilghYhxGhfYjMJE",15) == 543471601) strcat(s, "p");
if (crc32("rdixaynl",8) == 1966570509) strcat(s, "n");
if (crc32("BwVrLEirm",9) == 4006755480) strcat(s, "g");
    return s;
}

char *fatigated_verbs() {
    char *s = calloc(10);
    if (crc32("GIfKAXWLW",9) == 1288407561) strcat(s, "f");
if (crc32("EcvZxiZHOuPfp",13) == 4228277019) strcat(s, "X");
if (crc32("yFVhFM",6) == 1286622987) strcat(s, "a");
if (crc32("qtjqamO",7) == 3221956330) strcat(s, "t");
if (crc32("wyttPHc",7) == 4029073225) strcat(s, "t");
if (crc32("pberPzVi",8) == 128828855) strcat(s, "G");
if (crc32("qQYbeXTYBefAm",13) == 3455427108) strcat(s, "i");
if (crc32("uJmHTTx",7) == 3247233185) strcat(s, "s");
if (crc32("zNbSusH",7) == 4098094666) strcat(s, "g");
if (crc32("EDxLgnrMnJ",10) == 59313500) strcat(s, "a");
if (crc32("DUggXnKzfLe",11) == 1257391624) strcat(s, "G");
if (crc32("wFmvpjukea",10) == 2084373519) strcat(s, "t");
if (crc32("HFhGMDZ",7) == 1183280732) strcat(s, "v");
if (crc32("ywpDwWmxaq",10) == 895388442) strcat(s, "e");
if (crc32("zZCGKJ",6) == 271059640) strcat(s, "d");
    return s;
}

char *retell_verbs() {
    char *s = calloc(7);
    if (crc32("tmzUB",5) == 88406759) strcat(s, "r");
if (crc32("cPQAosVoFFM",11) == 2057736436) strcat(s, "U");
if (crc32("tisNIGmbAeA",11) == 2801606641) strcat(s, "e");
if (crc32("WhEDKKqsho",10) == 828462201) strcat(s, "t");
if (crc32("JfkQm",5) == 3025278402) strcat(s, "s");
if (crc32("cVlEtLy",7) == 721443250) strcat(s, "e");
if (crc32("wQPFSGOIZOtvE",13) == 3948633199) strcat(s, "l");
if (crc32("CVgOK",5) == 1991987380) strcat(s, "y");
if (crc32("bKhLGfKiMnGF",12) == 2171607249) strcat(s, "l");
    return s;
}

char *rethought_verbs() {
    char *s = calloc(10);
    if (crc32("XpYPESwAMRgbRh",14) == 2765661173) strcat(s, "Q");
if (crc32("tvuBBWI",7) == 3522908570) strcat(s, "r");
if (crc32("GbCeFP",6) == 709286827) strcat(s, "D");
if (crc32("RfVur",5) == 516820168) strcat(s, "e");
if (crc32("ZudOnnIDhhLIWMq",15) == 3801696905) strcat(s, "t");
if (crc32("ZvGayhiQYT",10) == 606688525) strcat(s, "l");
if (crc32("HLKjDSdMk",9) == 3065043725) strcat(s, "h");
if (crc32("lblHb",5) == 3508446692) strcat(s, "o");
if (crc32("rTmNIjZaLDLI",12) == 2280545921) strcat(s, "E");
if (crc32("KGGeL",5) == 4260886493) strcat(s, "u");
if (crc32("PwxBxzTpoC",10) == 725634674) strcat(s, "g");
if (crc32("tRwZy",5) == 2470933672) strcat(s, "h");
if (crc32("dciomRD",7) == 581032505) strcat(s, "t");
    return s;
}

char *ruddle_verbs() {
    char *s = calloc(7);
    if (crc32("wkDVeXuOql",10) == 825913760) strcat(s, "l");
if (crc32("YSvkTHXuMszy",12) == 2862471803) strcat(s, "r");
if (crc32("LJSLyxsXOYHZux",14) == 4016772883) strcat(s, "b");
if (crc32("xJzJP",5) == 3283287991) strcat(s, "u");
if (crc32("nAOYYXBa",8) == 2774680903) strcat(s, "d");
if (crc32("SVwlYBkNYU",10) == 3502911629) strcat(s, "f");
if (crc32("qBOUEcLMY",9) == 319404308) strcat(s, "d");
if (crc32("rQfrBj",6) == 3561708082) strcat(s, "l");
if (crc32("fMRsTmUtz",9) == 3611243027) strcat(s, "e");
    return s;
}

char *inhaled_verbs() {
    char *s = calloc(8);
    if (crc32("nLFNHeW",7) == 4215837261) strcat(s, "K");
if (crc32("dURypSebjhCnFv",14) == 3899941769) strcat(s, "i");
if (crc32("kfxHLqmjgunCeC",14) == 2404007269) strcat(s, "n");
if (crc32("joSDgj",6) == 1436306441) strcat(s, "h");
if (crc32("dMlYIky",7) == 1796192741) strcat(s, "h");
if (crc32("ZaDFjqErn",9) == 3045687617) strcat(s, "C");
if (crc32("ZlAKvhXzWZC",11) == 652159064) strcat(s, "a");
if (crc32("zzUxbUAwzkw",11) == 319731447) strcat(s, "l");
if (crc32("cJDPEwYFsBIez",13) == 3158205268) strcat(s, "e");
if (crc32("HcLMlJFUFel",11) == 1456394011) strcat(s, "d");
    return s;
}

char *braking_verbs() {
    char *s = calloc(8);
    if (crc32("MAEuhYZXUUWGPZn",15) == 3368995347) strcat(s, "b");
if (crc32("AGBqZpkTrm",10) == 4109979528) strcat(s, "r");
if (crc32("YYirvGujA",9) == 1677494447) strcat(s, "D");
if (crc32("daRdrmAqGOJv",12) == 3085053116) strcat(s, "a");
if (crc32("JxspHqPSaoVQteN",15) == 2671750701) strcat(s, "I");
if (crc32("RnrtXxv",7) == 1085838673) strcat(s, "k");
if (crc32("fogNVyV",7) == 4192626507) strcat(s, "o");
if (crc32("yVjJsWgIW",9) == 3653362042) strcat(s, "i");
if (crc32("DpaPqMDU",8) == 4227016305) strcat(s, "n");
if (crc32("ajaIIx",6) == 576469467) strcat(s, "g");
    return s;
}

char *maraud_verbs() {
    char *s = calloc(7);
    if (crc32("DDeZam",6) == 3001962480) strcat(s, "Q");
if (crc32("QSgABDYqMxkdz",13) == 1219583218) strcat(s, "m");
if (crc32("apOVo",5) == 2947112909) strcat(s, "G");
if (crc32("fyIxyMLKjHwcH",13) == 3002977631) strcat(s, "a");
if (crc32("fOhLjDeDMr",10) == 978756948) strcat(s, "r");
if (crc32("UNyuXwfPKfqQwk",14) == 2667508725) strcat(s, "S");
if (crc32("KbSMB",5) == 3419480272) strcat(s, "a");
if (crc32("KoXtmS",6) == 2957986293) strcat(s, "u");
if (crc32("tiHQsoROzBB",11) == 2568692621) strcat(s, "e");
if (crc32("VXjyExmQ",8) == 2179713301) strcat(s, "d");
    return s;
}

char *bugged_verbs() {
    char *s = calloc(7);
    if (crc32("VrPyzFhr",8) == 376057430) strcat(s, "b");
if (crc32("PpDkMdxnNe",10) == 1392614336) strcat(s, "g");
if (crc32("VOIAOttSisAJ",12) == 772639099) strcat(s, "u");
if (crc32("tyWCxmo",7) == 4249404300) strcat(s, "g");
if (crc32("GRIYaBXluuBAikc",15) == 3737600995) strcat(s, "p");
if (crc32("bHWUXRHT",8) == 1415034422) strcat(s, "g");
if (crc32("skFgpOxGdDGiW",13) == 3718870140) strcat(s, "e");
if (crc32("qEBhPRSySkeZQKl",15) == 3706010882) strcat(s, "d");
    return s;
}

char *battologizing_verbs() {
    char *s = calloc(14);
    if (crc32("jUKvMjL",7) == 2544439428) strcat(s, "N");
if (crc32("ATQPXmexRV",10) == 3673539285) strcat(s, "b");
if (crc32("fpjAWBwY",8) == 71275375) strcat(s, "a");
if (crc32("ACDdHPVchDRiibc",15) == 3789027176) strcat(s, "g");
if (crc32("JOFVcQUXBIo",11) == 41818001) strcat(s, "t");
if (crc32("hWRTIyFwCYRyW",13) == 3187958463) strcat(s, "t");
if (crc32("RlplHCfVSUrrw",13) == 2308418630) strcat(s, "o");
if (crc32("LSlRcxPQnRnvUiU",15) == 3788934713) strcat(s, "R");
if (crc32("cEZKGRmHJW",10) == 3613878721) strcat(s, "l");
if (crc32("ZMqWzunAYGQv",12) == 2990992517) strcat(s, "o");
if (crc32("FpJssHYYL",9) == 498122431) strcat(s, "g");
if (crc32("tVKwmUgQS",9) == 152018270) strcat(s, "i");
if (crc32("sHfAjoAubJTN",12) == 1005124578) strcat(s, "z");
if (crc32("ilBVFgYOZqhDrg",14) == 1457509733) strcat(s, "i");
if (crc32("nPUbkgicOTzj",12) == 220990151) strcat(s, "n");
if (crc32("baTnn",5) == 2118154962) strcat(s, "J");
if (crc32("hfzCmkgWg",9) == 819153082) strcat(s, "g");
    return s;
}

char *suffer_verbs() {
    char *s = calloc(7);
    if (crc32("zjwcVdG",7) == 2674012295) strcat(s, "s");
if (crc32("tmOURujxJStFZ",13) == 477398801) strcat(s, "u");
if (crc32("rEdkRozpZubihE",14) == 753332310) strcat(s, "f");
if (crc32("uicYRJYSzTM",11) == 2674500082) strcat(s, "f");
if (crc32("bcbTz",5) == 3266376099) strcat(s, "W");
if (crc32("SglSqcqpWMCkE",13) == 113025103) strcat(s, "e");
if (crc32("ECjyZYJcLsJxQf",14) == 3359262669) strcat(s, "t");
if (crc32("ayRsBivXquWZhG",14) == 3642971658) strcat(s, "r");
    return s;
}

char *spanning_verbs() {
    char *s = calloc(9);
    if (crc32("uaBcF",5) == 830508726) strcat(s, "I");
if (crc32("MlWLfbPUiFj",11) == 4032400728) strcat(s, "s");
if (crc32("lfKwhZrKsIpeIp",14) == 1318086588) strcat(s, "p");
if (crc32("XsQLthO",7) == 2052242366) strcat(s, "B");
if (crc32("rgOZLtqs",8) == 888740612) strcat(s, "a");
if (crc32("rPDnOphRxqYCVu",14) == 706672569) strcat(s, "Y");
if (crc32("ARJkMt",6) == 2508323892) strcat(s, "n");
if (crc32("wQPGysRZFTXSH",13) == 345462291) strcat(s, "n");
if (crc32("VYKsDWgIm",9) == 1126412182) strcat(s, "H");
if (crc32("FycfGdwRppyv",12) == 1145906174) strcat(s, "i");
if (crc32("oFTSCeAc",8) == 681281859) strcat(s, "j");
if (crc32("qCynwDOjeLy",11) == 2968582401) strcat(s, "n");
if (crc32("nBIEgWthxDXpv",13) == 1089244067) strcat(s, "g");
    return s;
}

char *interbreeding_verbs() {
    char *s = calloc(14);
    if (crc32("AHMxTsLiZLznmuv",15) == 273322669) strcat(s, "i");
if (crc32("aRxLxh",6) == 1128073140) strcat(s, "n");
if (crc32("aMTCC",5) == 3433205421) strcat(s, "N");
if (crc32("XgiNnsqlddqS",12) == 3094276431) strcat(s, "t");
if (crc32("TbOyebifMNmKzpL",15) == 492183730) strcat(s, "I");
if (crc32("fvjAxc",6) == 258173703) strcat(s, "e");
if (crc32("CfeuXsx",7) == 3139938522) strcat(s, "h");
if (crc32("ZKdBzgdZI",9) == 1576196782) strcat(s, "r");
if (crc32("dFYtM",5) == 3439892807) strcat(s, "F");
if (crc32("cBepdusmOFpms",13) == 309881524) strcat(s, "b");
if (crc32("lrKxwkQwOkK",11) == 1143044258) strcat(s, "r");
if (crc32("qElhgaWzBTdAOFO",15) == 2835254832) strcat(s, "L");
if (crc32("wkmUXprarGzGYf",14) == 2200247476) strcat(s, "e");
if (crc32("VaQvCKtNMZsxjd",14) == 871735871) strcat(s, "f");
if (crc32("aLLdUaEulRNzJ",13) == 2154116839) strcat(s, "e");
if (crc32("ZOxvnKOQMAZNnJ",14) == 164303198) strcat(s, "d");
if (crc32("tgKTWvZXcZYXvQ",14) == 2577621467) strcat(s, "i");
if (crc32("HlZKHvzp",8) == 3665028633) strcat(s, "n");
if (crc32("DhMhm",5) == 261496046) strcat(s, "v");
if (crc32("FBUnUhV",7) == 2524319204) strcat(s, "g");
    return s;
}

char *orthographizing_verbs() {
    char *s = calloc(16);
    if (crc32("RgyYYhmS",8) == 4159596318) strcat(s, "o");
if (crc32("tXDZVWBVrFHpnMq",15) == 3454105322) strcat(s, "r");
if (crc32("ZZOTQFZorbAc",12) == 3357277212) strcat(s, "t");
if (crc32("iKMmpjxeFZUdQy",14) == 1198120720) strcat(s, "v");
if (crc32("kMyMKH",6) == 1986882603) strcat(s, "h");
if (crc32("FUkKgOps",8) == 4236262339) strcat(s, "Y");
if (crc32("uiGxknhgfA",10) == 984796470) strcat(s, "o");
if (crc32("tzZNrSi",7) == 3558315728) strcat(s, "g");
if (crc32("gFIetBgOqE",10) == 1923264950) strcat(s, "k");
if (crc32("ApdFUck",7) == 1480070897) strcat(s, "r");
if (crc32("mVYaTLiQutCTED",14) == 1588696369) strcat(s, "z");
if (crc32("obgHc",5) == 3991666755) strcat(s, "a");
if (crc32("sEyKWbtC",8) == 519504972) strcat(s, "t");
if (crc32("LvKaVQpdaTvQ",12) == 2301927432) strcat(s, "p");
if (crc32("qIKoOjFPwahtG",13) == 2808966567) strcat(s, "q");
if (crc32("OUXGjpioX",9) == 2163026351) strcat(s, "h");
if (crc32("bJinjU",6) == 1724463087) strcat(s, "i");
if (crc32("hDYWilXIN",9) == 3083172844) strcat(s, "g");
if (crc32("fGufGccYjLMjxE",14) == 1769028403) strcat(s, "z");
if (crc32("ERCKSJv",7) == 933145237) strcat(s, "d");
if (crc32("BAcRdvlGz",9) == 1686200241) strcat(s, "i");
if (crc32("AfBGSazHxUjKq",13) == 2763139532) strcat(s, "D");
if (crc32("xlvEuuHdnASnFzL",15) == 3245040045) strcat(s, "n");
if (crc32("vueBSLhq",8) == 3780729311) strcat(s, "g");
    return s;
}

char *resonated_verbs() {
    char *s = calloc(10);
    if (crc32("XWKdmmZGTc",10) == 1521829745) strcat(s, "r");
if (crc32("TNGmtf",6) == 1750093058) strcat(s, "e");
if (crc32("jgEUTrPzLZt",11) == 2690204081) strcat(s, "s");
if (crc32("PwdLqJEhCMNk",12) == 347669994) strcat(s, "G");
if (crc32("rkIfwSbhY",9) == 3697874143) strcat(s, "o");
if (crc32("wqdRKhIMpHmmq",13) == 121688552) strcat(s, "n");
if (crc32("LEXpJnjq",8) == 450667700) strcat(s, "a");
if (crc32("PNYmf",5) == 3819510739) strcat(s, "Z");
if (crc32("mdwdmvP",7) == 1239364715) strcat(s, "t");
if (crc32("tSqabdQc",8) == 2462266163) strcat(s, "e");
if (crc32("eQEbcI",6) == 1254207264) strcat(s, "d");
    return s;
}

char *creosoted_verbs() {
    char *s = calloc(10);
    if (crc32("tbWCHHueIXeyJY",14) == 4048173443) strcat(s, "c");
if (crc32("dhKPzJv",7) == 2872266355) strcat(s, "v");
if (crc32("UQBVNsqQTiB",11) == 1045191409) strcat(s, "r");
if (crc32("EYihsQpdB",9) == 3265079965) strcat(s, "e");
if (crc32("tVoAv",5) == 3397696448) strcat(s, "y");
if (crc32("LCdvzfHbXMTbOv",14) == 775246408) strcat(s, "o");
if (crc32("xKSbAy",6) == 1155359043) strcat(s, "g");
if (crc32("CXuQmyl",7) == 2955381447) strcat(s, "s");
if (crc32("mlhNTQB",7) == 2322981949) strcat(s, "o");
if (crc32("pdEuzTJzBGgvMfq",15) == 1250147360) strcat(s, "t");
if (crc32("dyFxSSgl",8) == 3157611002) strcat(s, "i");
if (crc32("XZxXRiMXiraEi",13) == 2549323578) strcat(s, "e");
if (crc32("rdLaIyTQdQ",10) == 3846851262) strcat(s, "Z");
if (crc32("voNDcZdcdPqyfWp",15) == 764345839) strcat(s, "d");
    return s;
}

char *raffled_verbs() {
    char *s = calloc(8);
    if (crc32("hpVlaQzs",8) == 4268335345) strcat(s, "r");
if (crc32("LPnAuQEZS",9) == 294831507) strcat(s, "d");
if (crc32("AYgdchDmTXaKKBu",15) == 4146283496) strcat(s, "a");
if (crc32("sDcTMs",6) == 1610280714) strcat(s, "f");
if (crc32("VKiFqIAnOpovpLh",15) == 3582046135) strcat(s, "f");
if (crc32("EFkCzM",6) == 1432798803) strcat(s, "w");
if (crc32("gtrlbFTfRdLib",13) == 988361897) strcat(s, "l");
if (crc32("gLVoF",5) == 689535498) strcat(s, "e");
if (crc32("pLIuy",5) == 3941073459) strcat(s, "d");
    return s;
}

char *brachiating_verbs() {
    char *s = calloc(12);
    if (crc32("KSeig",5) == 424416215) strcat(s, "b");
if (crc32("ddONOj",6) == 769658447) strcat(s, "r");
if (crc32("AMKUImhejIZHWau",15) == 1145572050) strcat(s, "a");
if (crc32("KwFvIpCPoQQRfnu",15) == 973369713) strcat(s, "c");
if (crc32("UZUVenrp",8) == 3008939940) strcat(s, "P");
if (crc32("EaHbMaD",7) == 3293492387) strcat(s, "h");
if (crc32("dJbjxRkcyxusXS",14) == 4231439115) strcat(s, "S");
if (crc32("sJJTdoms",8) == 709294601) strcat(s, "i");
if (crc32("DegwRU",6) == 1165291755) strcat(s, "v");
if (crc32("dZlzHVUqr",9) == 2708657204) strcat(s, "a");
if (crc32("WDnivqXLG",9) == 3663062152) strcat(s, "t");
if (crc32("eNygSAABhasNJU",14) == 1173999034) strcat(s, "H");
if (crc32("lvfYyaqOGQxD",12) == 1006334510) strcat(s, "i");
if (crc32("rGEkmJd",7) == 2293553454) strcat(s, "n");
if (crc32("PDpvzlhfNvyEoR",14) == 3811666941) strcat(s, "V");
if (crc32("RfQnoRQ",7) == 4268457797) strcat(s, "g");
    return s;
}

char *oscillating_verbs() {
    char *s = calloc(12);
    if (crc32("zLeaW",5) == 1668775820) strcat(s, "o");
if (crc32("ghjySM",6) == 2283275005) strcat(s, "k");
if (crc32("zJGUmpBNdL",10) == 1672648309) strcat(s, "s");
if (crc32("nhemJxdAqUt",11) == 229632393) strcat(s, "M");
if (crc32("krQYMwZlFtZthtX",15) == 353811959) strcat(s, "c");
if (crc32("BdezXfhJQPDkLvC",15) == 2606015151) strcat(s, "i");
if (crc32("VRxady",6) == 3603276970) strcat(s, "a");
if (crc32("VLGXsrjf",8) == 2059563255) strcat(s, "l");
if (crc32("ajQCJjsz",8) == 2333069716) strcat(s, "l");
if (crc32("wRGRZZ",6) == 1193776927) strcat(s, "a");
if (crc32("LdJVWOpUqk",10) == 3945640625) strcat(s, "R");
if (crc32("fpJfHNb",7) == 3253337552) strcat(s, "t");
if (crc32("MAXsEMPeaWdjCrm",15) == 3163676564) strcat(s, "S");
if (crc32("rVWvyN",6) == 692370131) strcat(s, "i");
if (crc32("GOTqhxzJlWpa",12) == 1170734181) strcat(s, "b");
if (crc32("kCniwXqzTxUt",12) == 432789185) strcat(s, "n");
if (crc32("bTdTtXlRLmrd",12) == 2537203050) strcat(s, "m");
if (crc32("RzSADhnzGL",10) == 2104832153) strcat(s, "g");
    return s;
}

char *overidentify_verbs() {
    char *s = calloc(13);
    if (crc32("jVLIlsUzoPn",11) == 4129302462) strcat(s, "N");
if (crc32("mipluRooIOoj",12) == 3394104321) strcat(s, "o");
if (crc32("jERpVxpL",8) == 1853844780) strcat(s, "v");
if (crc32("WZIHgwBU",8) == 3551650544) strcat(s, "e");
if (crc32("TrXaAOmDuZL",11) == 2150998424) strcat(s, "r");
if (crc32("wThcg",5) == 310183216) strcat(s, "i");
if (crc32("XHBdGjqkif",10) == 2121400368) strcat(s, "d");
if (crc32("DpgeJt",6) == 1774902733) strcat(s, "e");
if (crc32("YYrpB",5) == 429259417) strcat(s, "d");
if (crc32("ZMkzHRekSJNzHM",14) == 3508650776) strcat(s, "n");
if (crc32("MDoBGRCRjE",10) == 4056334891) strcat(s, "J");
if (crc32("CbbsZKvfKj",10) == 2500723732) strcat(s, "t");
if (crc32("oKPMNjqJpWlVsxq",15) == 2898796802) strcat(s, "i");
if (crc32("WxLYmXKjTOwG",12) == 2197988840) strcat(s, "M");
if (crc32("FidfWOuv",8) == 3621484232) strcat(s, "f");
if (crc32("CUOJYRaPQq",10) == 3167911015) strcat(s, "y");
    return s;
}

char *intercolonizing_verbs() {
    char *s = calloc(16);
    if (crc32("vHZmGczk",8) == 1246126973) strcat(s, "a");
if (crc32("JJXkT",5) == 2825410341) strcat(s, "i");
if (crc32("poCzzytCAWAdK",13) == 199756070) strcat(s, "p");
if (crc32("dEJPXZGFgYk",11) == 4169231996) strcat(s, "n");
if (crc32("agBXFmNrWKEYLZX",15) == 972947512) strcat(s, "t");
if (crc32("DLntTFRVpajc",12) == 2678258558) strcat(s, "e");
if (crc32("wagLda",6) == 3890382420) strcat(s, "r");
if (crc32("HXUMlyjiXLDks",13) == 1311865369) strcat(s, "Z");
if (crc32("CWDvv",5) == 943443450) strcat(s, "c");
if (crc32("dzHgWYodJOmb",12) == 2036166101) strcat(s, "o");
if (crc32("meOiSasH",8) == 4227586781) strcat(s, "h");
if (crc32("CDVxaLNRwFn",11) == 1133161807) strcat(s, "l");
if (crc32("tNBjOkXNQsmUYPT",15) == 3090321347) strcat(s, "w");
if (crc32("ZGqczkULsP",10) == 2207928129) strcat(s, "o");
if (crc32("HcNKvVQzMT",10) == 406623820) strcat(s, "n");
if (crc32("xabKhenRSAXv",12) == 2287296297) strcat(s, "i");
if (crc32("EByYjRk",7) == 2628068769) strcat(s, "z");
if (crc32("Evqgf",5) == 3275482126) strcat(s, "i");
if (crc32("xGlEWmnQU",9) == 3860534678) strcat(s, "g");
if (crc32("yOalWI",6) == 2145493687) strcat(s, "n");
if (crc32("iQAxRNEBCf",10) == 2536843288) strcat(s, "g");
    return s;
}

char *derived_verbs() {
    char *s = calloc(8);
    if (crc32("eSCKfGxlUDhAsei",15) == 2702405984) strcat(s, "d");
if (crc32("jwCKwPU",7) == 131042035) strcat(s, "e");
if (crc32("sshyiuBGAQdO",12) == 3441520116) strcat(s, "C");
if (crc32("eLJCS",5) == 302644283) strcat(s, "r");
if (crc32("OawBhqGjApXPt",13) == 1165631987) strcat(s, "i");
if (crc32("sbIwEXqD",8) == 2978048404) strcat(s, "v");
if (crc32("VHCYqNZY",8) == 36657162) strcat(s, "j");
if (crc32("mCgNTHvsdMKnMBv",15) == 554427429) strcat(s, "e");
if (crc32("PjmCThTPRm",10) == 14605713) strcat(s, "d");
    return s;
}

char *thudding_verbs() {
    char *s = calloc(9);
    if (crc32("rrLuAgFlJREeGx",14) == 3216022145) strcat(s, "t");
if (crc32("vyxRRj",6) == 2082605308) strcat(s, "h");
if (crc32("asQIfjm",7) == 2266436663) strcat(s, "Q");
if (crc32("ZsrsvFvVysKgqw",14) == 2608525437) strcat(s, "u");
if (crc32("kbMLHgKrN",9) == 4248665716) strcat(s, "k");
if (crc32("tLJFuq",6) == 1233575438) strcat(s, "d");
if (crc32("qcYwqFZe",8) == 99445629) strcat(s, "d");
if (crc32("DtSnpNYpVH",10) == 1128754697) strcat(s, "i");
if (crc32("NYddxnfzO",9) == 3969088081) strcat(s, "O");
if (crc32("yBYoFUR",7) == 3337929653) strcat(s, "n");
if (crc32("FirBAIv",7) == 3469092100) strcat(s, "g");
    return s;
}

char *evidencing_verbs() {
    char *s = calloc(11);
    if (crc32("AmhoMahrxBSk",12) == 1681270097) strcat(s, "e");
if (crc32("PLjmzQPndUkk",12) == 3773943090) strcat(s, "v");
if (crc32("CAuAmVZa",8) == 882405877) strcat(s, "a");
if (crc32("ifZczujRn",9) == 2177684703) strcat(s, "i");
if (crc32("hFlIIkxRTP",10) == 1751086544) strcat(s, "d");
if (crc32("fNIXgOLyGKK",11) == 1026732954) strcat(s, "P");
if (crc32("rKwtUzU",7) == 2282567579) strcat(s, "e");
if (crc32("ZRrZEKrxBtzj",12) == 4200428301) strcat(s, "L");
if (crc32("MVHgGMnNJGQNI",13) == 2274866458) strcat(s, "n");
if (crc32("sGKkMF",6) == 280572322) strcat(s, "J");
if (crc32("XOIvgFO",7) == 1698131016) strcat(s, "c");
if (crc32("UadxXq",6) == 4061505872) strcat(s, "i");
if (crc32("VFSxMk",6) == 2689333148) strcat(s, "n");
if (crc32("YezHzEEpC",9) == 2733849774) strcat(s, "g");
    return s;
}

char *cobwebbed_verbs() {
    char *s = calloc(10);
    if (crc32("PDoeUicPMae",11) == 3964891195) strcat(s, "d");
if (crc32("LrMrw",5) == 826133306) strcat(s, "c");
if (crc32("EIODJjTILRZH",12) == 2690193934) strcat(s, "F");
if (crc32("DxzTANTLwQLEiZ",14) == 3521782885) strcat(s, "o");
if (crc32("xqeZaLELDrFLv",13) == 2040686955) strcat(s, "b");
if (crc32("QlLADdF",7) == 2521784532) strcat(s, "e");
if (crc32("wcWpyFwYKOiGmZ",14) == 1002925163) strcat(s, "w");
if (crc32("IbshTPBynZTa",12) == 3101308581) strcat(s, "f");
if (crc32("RAPeCsRe",8) == 2806132238) strcat(s, "e");
if (crc32("ugMlWKItCbfUVB",14) == 1357251300) strcat(s, "D");
if (crc32("Hwqid",5) == 4086958968) strcat(s, "b");
if (crc32("kSVxYw",6) == 332487583) strcat(s, "u");
if (crc32("IjAuzgZcz",9) == 3862479818) strcat(s, "b");
if (crc32("TaRcKtxw",8) == 3567717735) strcat(s, "Q");
if (crc32("TSlqbbhUtilexO",14) == 2788458065) strcat(s, "e");
if (crc32("ZZtAid",6) == 93452491) strcat(s, "d");
    return s;
}

char *conversing_verbs() {
    char *s = calloc(11);
    if (crc32("KwvMXTFoXoG",11) == 3774588699) strcat(s, "c");
if (crc32("bTgjqJexzbZ",11) == 880752299) strcat(s, "o");
if (crc32("hWZfYCmnFx",10) == 294507246) strcat(s, "B");
if (crc32("GhqXdqiIiRVOjl",14) == 3738227325) strcat(s, "n");
if (crc32("TlsFmNqrVg",10) == 72246662) strcat(s, "v");
if (crc32("bpWgzGWhVsGB",12) == 3113921074) strcat(s, "e");
if (crc32("hHbrMsKuQipOaxS",15) == 2861003807) strcat(s, "s");
if (crc32("HDmwbWrQG",9) == 2073525972) strcat(s, "r");
if (crc32("IApDufT",7) == 1757735631) strcat(s, "s");
if (crc32("qDcfUaTaCHB",11) == 4249035156) strcat(s, "G");
if (crc32("pBkiXNaXKcJjX",13) == 2386669725) strcat(s, "i");
if (crc32("bZxhLzUhyee",11) == 1726527239) strcat(s, "f");
if (crc32("gwLfaYehNiSnCiF",15) == 1718503667) strcat(s, "n");
if (crc32("vfWvYxwLrmS",11) == 1672329419) strcat(s, "g");
    return s;
}

char *underdug_verbs() {
    char *s = calloc(9);
    if (crc32("pYoXjJahsK",10) == 1236130563) strcat(s, "u");
if (crc32("KfrRMfXNcPs",11) == 985538505) strcat(s, "n");
if (crc32("sPpIaVunDrHI",12) == 55483956) strcat(s, "i");
if (crc32("PFPFLQPGTViSF",13) == 3368172256) strcat(s, "d");
if (crc32("yDymCArJgXCOaP",14) == 2147955788) strcat(s, "e");
if (crc32("gveJYwwvzdLWC",13) == 663827802) strcat(s, "F");
if (crc32("UaTrdQmOhkdu",12) == 81338505) strcat(s, "r");
if (crc32("YBBfiWpvQnLSnqQ",15) == 3079652804) strcat(s, "b");
if (crc32("PIkBql",6) == 95870724) strcat(s, "d");
if (crc32("WhKEGgOh",8) == 1622206311) strcat(s, "M");
if (crc32("iZCKMfJvzLTHDA",14) == 2570831933) strcat(s, "u");
if (crc32("lueojvbrzfKa",12) == 78769376) strcat(s, "g");
    return s;
}

char *geton_verbs() {
    char *s = calloc(6);
    if (crc32("sTxwMAUObbrfykU",15) == 3905843213) strcat(s, "g");
if (crc32("BDeizlxyVOtVt",13) == 1619474604) strcat(s, "e");
if (crc32("MNytDUe",7) == 284822644) strcat(s, "t");
if (crc32("rQQHzZsjX",9) == 2092891629) strcat(s, "o");
if (crc32("XjPSpqxa",8) == 1548065174) strcat(s, "n");
    return s;
}

char *beseech_verbs() {
    char *s = calloc(8);
    if (crc32("SQJWyOLg",8) == 3003166021) strcat(s, "k");
if (crc32("ZWSpq",5) == 2224865241) strcat(s, "b");
if (crc32("EKRxoVQQiK",10) == 1073673215) strcat(s, "U");
if (crc32("eWOenAIFsbwEiB",14) == 462847309) strcat(s, "e");
if (crc32("GLQlwixuVLP",11) == 2586257257) strcat(s, "Y");
if (crc32("eRoIUOyvcJFIgC",14) == 3172942114) strcat(s, "s");
if (crc32("ayfxJBncHv",10) == 4145349503) strcat(s, "Y");
if (crc32("fcKnQoSBi",9) == 487285197) strcat(s, "e");
if (crc32("FqAHseMLRfFMd",13) == 4192714662) strcat(s, "l");
if (crc32("BcFvGlun",8) == 2753242035) strcat(s, "e");
if (crc32("iIpjhTNtgLoUlKy",15) == 277187365) strcat(s, "S");
if (crc32("FvkneHsslXb",11) == 3625230637) strcat(s, "c");
if (crc32("vYTAtWrzoCFRe",13) == 2110491873) strcat(s, "h");
    return s;
}

char *scudding_verbs() {
    char *s = calloc(9);
    if (crc32("CbUsmKFAoCZSglm",15) == 70579290) strcat(s, "f");
if (crc32("nadhyJjuOcExt",13) == 3476073410) strcat(s, "s");
if (crc32("iChtiTuKVGP",11) == 2990944324) strcat(s, "c");
if (crc32("sTXtv",5) == 3412004613) strcat(s, "X");
if (crc32("cAZoiFpbZVSn",12) == 3917597567) strcat(s, "u");
if (crc32("mFPSjEGK",8) == 114724410) strcat(s, "d");
if (crc32("mFAMfrjDlPz",11) == 986472429) strcat(s, "d");
if (crc32("KjYGqVhQeqMBaRQ",15) == 3502104252) strcat(s, "Z");
if (crc32("TBibbQrelrPVig",14) == 817828141) strcat(s, "i");
if (crc32("HBEXrQjroJ",10) == 3688845812) strcat(s, "n");
if (crc32("DViYv",5) == 2146897463) strcat(s, "y");
if (crc32("PxUSGC",6) == 3056248011) strcat(s, "g");
    return s;
}

char *prepractice_verbs() {
    char *s = calloc(12);
    if (crc32("AiqJLJJNaE",10) == 2090333627) strcat(s, "p");
if (crc32("oQsWn",5) == 1350737250) strcat(s, "Q");
if (crc32("QevmrypEhStX",12) == 432835206) strcat(s, "r");
if (crc32("SVVChDWUMM",10) == 1854430463) strcat(s, "e");
if (crc32("loSHn",5) == 99980223) strcat(s, "p");
if (crc32("RfdRevjYCYDtSur",15) == 3588062473) strcat(s, "T");
if (crc32("NVigfFw",7) == 1162107832) strcat(s, "r");
if (crc32("qmzFvWba",8) == 540246166) strcat(s, "U");
if (crc32("STNbDzuyewNri",13) == 229631078) strcat(s, "a");
if (crc32("jAxkfdxA",8) == 2018024956) strcat(s, "c");
if (crc32("zGBkC",5) == 1765905439) strcat(s, "t");
if (crc32("gnyuVDxryGdv",12) == 668778728) strcat(s, "o");
if (crc32("PmuThUWmfOnpCTI",15) == 3932352460) strcat(s, "i");
if (crc32("gYQTBslxoh",10) == 917135495) strcat(s, "c");
if (crc32("DhRecjPPsalcZgK",15) == 412145922) strcat(s, "e");
    return s;
}

char *redividing_verbs() {
    char *s = calloc(11);
    if (crc32("vpDasagrNsCrOY",14) == 1524662618) strcat(s, "S");
if (crc32("ocAlE",5) == 1249196335) strcat(s, "r");
if (crc32("QPweIpeS",8) == 3230392457) strcat(s, "e");
if (crc32("SEluwbVWyLxpsG",14) == 2384191922) strcat(s, "n");
if (crc32("TKiuIvNaFUVQ",12) == 719907243) strcat(s, "d");
if (crc32("KgLUkIOQGQxzQ",13) == 3306557140) strcat(s, "V");
if (crc32("vZzSgAlnCgobK",13) == 1656157740) strcat(s, "i");
if (crc32("DCnZO",5) == 1467732297) strcat(s, "x");
if (crc32("upWfZPjImdao",12) == 1902738903) strcat(s, "v");
if (crc32("rNuqvjcwaGXaIR",14) == 2435597715) strcat(s, "i");
if (crc32("XrEmtpUGaGxIkxQ",15) == 2274889633) strcat(s, "d");
if (crc32("QBfNgqCw",8) == 3137744175) strcat(s, "Z");
if (crc32("SYIqPT",6) == 1799990057) strcat(s, "i");
if (crc32("EZmhcRYkujfxuTd",15) == 4064400585) strcat(s, "n");
if (crc32("BAmSrGRvMSAYH",13) == 1237532383) strcat(s, "V");
if (crc32("UeCJNPdEtS",10) == 2605660604) strcat(s, "g");
    return s;
}

char *caved_verbs() {
    char *s = calloc(6);
    if (crc32("XEpdTXR",7) == 65470978) strcat(s, "c");
if (crc32("SytzisTlfmj",11) == 2786776108) strcat(s, "i");
if (crc32("gTZGmb",6) == 3408565847) strcat(s, "a");
if (crc32("YXdHYFRPPe",10) == 984442377) strcat(s, "v");
if (crc32("gwjttRVMli",10) == 2753425902) strcat(s, "e");
if (crc32("aZLjzmrrcBf",11) == 3040904116) strcat(s, "F");
if (crc32("gHgIissKZlaM",12) == 735693903) strcat(s, "d");
    return s;
}

char *giveover_verbs() {
    char *s = calloc(9);
    if (crc32("UaHHOtO",7) == 347590180) strcat(s, "G");
if (crc32("JbLarnvUZHUi",12) == 1464371375) strcat(s, "g");
if (crc32("MqaDyD",6) == 2801896611) strcat(s, "f");
if (crc32("SMtcMhwcXeNm",12) == 1753757258) strcat(s, "i");
if (crc32("SZrLfyGiAKR",11) == 4009373441) strcat(s, "I");
if (crc32("uFmdXaoaSivJ",12) == 1534580226) strcat(s, "v");
if (crc32("oNegF",5) == 1569990785) strcat(s, "e");
if (crc32("urDmDIRAmLDpnr",14) == 1959523548) strcat(s, "k");
if (crc32("cbcFVegAfMGWs",13) == 131058311) strcat(s, "o");
if (crc32("wGfkTA",6) == 4134524267) strcat(s, "H");
if (crc32("alYQrmhTcbHT",12) == 2843890423) strcat(s, "v");
if (crc32("ReeViwuSILqPyLw",15) == 3380105614) strcat(s, "b");
if (crc32("ztqMi",5) == 3046625899) strcat(s, "e");
if (crc32("jRCHOOD",7) == 978969293) strcat(s, "T");
if (crc32("RPkUQB",6) == 1974802276) strcat(s, "r");
    return s;
}

char *reproved_verbs() {
    char *s = calloc(9);
    if (crc32("DICzfgqqPOXWLTz",15) == 4199650631) strcat(s, "W");
if (crc32("dMnSiRcFjkv",11) == 3933009008) strcat(s, "r");
if (crc32("uuKCFEGMpMXGhW",14) == 2681528643) strcat(s, "e");
if (crc32("TrLgewyTkdvdy",13) == 2638431877) strcat(s, "p");
if (crc32("upkOyklJetmhp",13) == 2882803872) strcat(s, "O");
if (crc32("tuECs",5) == 4070085335) strcat(s, "r");
if (crc32("kFwTwcwIvN",10) == 4035052997) strcat(s, "G");
if (crc32("yNBJRM",6) == 3067904473) strcat(s, "o");
if (crc32("WMGdnAV",7) == 3026421854) strcat(s, "D");
if (crc32("RRljgEprzw",10) == 139751478) strcat(s, "v");
if (crc32("JOfrJloVN",9) == 2923006568) strcat(s, "e");
if (crc32("SCUccdT",7) == 4177199863) strcat(s, "d");
    return s;
}

char *redock_verbs() {
    char *s = calloc(7);
    if (crc32("tLbCrK",6) == 2743522369) strcat(s, "r");
if (crc32("dRYMv",5) == 1414009287) strcat(s, "e");
if (crc32("rnHHgpKPtRese",13) == 2861158015) strcat(s, "G");
if (crc32("XbQWqECKpCbT",12) == 4227322154) strcat(s, "d");
if (crc32("SZnkHCbwdm",10) == 341732544) strcat(s, "o");
if (crc32("oMarpqNMlDdjE",13) == 3945468088) strcat(s, "T");
if (crc32("HhbAmpvC",8) == 211899087) strcat(s, "c");
if (crc32("VLfZn",5) == 16099944) strcat(s, "u");
if (crc32("OIHOLJSFZcOtq",13) == 1008314293) strcat(s, "k");
    return s;
}

char *publish_verbs() {
    char *s = calloc(8);
    if (crc32("uAxRn",5) == 795247436) strcat(s, "E");
if (crc32("YsrTmEPfrgLUmg",14) == 2270839380) strcat(s, "p");
if (crc32("sQadjrDNBmRqP",13) == 3686470332) strcat(s, "e");
if (crc32("KnMiNYIHReQ",11) == 4002504171) strcat(s, "u");
if (crc32("KDDSIlZYgLyY",12) == 236208746) strcat(s, "d");
if (crc32("BOlvDlRpOSrH",12) == 998897001) strcat(s, "b");
if (crc32("WChrkR",6) == 361847315) strcat(s, "l");
if (crc32("yywalHuQyO",10) == 189493874) strcat(s, "J");
if (crc32("ZYlrnMlumuIa",12) == 2502278727) strcat(s, "i");
if (crc32("WttmOE",6) == 2032031374) strcat(s, "s");
if (crc32("pDgzOuJQDCbrn",13) == 430532924) strcat(s, "Q");
if (crc32("BTXTBaqFgZ",10) == 3883273437) strcat(s, "h");
    return s;
}

char *smudged_verbs() {
    char *s = calloc(8);
    if (crc32("LCYON",5) == 958876280) strcat(s, "h");
if (crc32("DmNEmgvTr",9) == 2462811856) strcat(s, "s");
if (crc32("WaVomfnoGBpW",12) == 2036148441) strcat(s, "c");
if (crc32("TAHuis",6) == 854044858) strcat(s, "m");
if (crc32("ZBLzPtrqnaA",11) == 2993455462) strcat(s, "u");
if (crc32("fVjjleVCJ",9) == 2848346721) strcat(s, "d");
if (crc32("YasLrmdhO",9) == 481670504) strcat(s, "L");
if (crc32("MtYdCdvdCYTYc",13) == 3676586379) strcat(s, "g");
if (crc32("azongA",6) == 3412265003) strcat(s, "e");
if (crc32("hqwSyehspML",11) == 1869417215) strcat(s, "L");
if (crc32("imcGNswXEQ",10) == 848888220) strcat(s, "d");
    return s;
}

char *rustle_verbs() {
    char *s = calloc(7);
    if (crc32("WVFhwPvd",8) == 2741625186) strcat(s, "r");
if (crc32("IDmoDWUhdK",10) == 828528965) strcat(s, "n");
if (crc32("naLiDNgIx",9) == 654093890) strcat(s, "u");
if (crc32("QmglYGdqOUhqvb",14) == 944438733) strcat(s, "I");
if (crc32("rjKkpSQ",7) == 1442524351) strcat(s, "s");
if (crc32("OyKcAJhaWk",10) == 1355308431) strcat(s, "t");
if (crc32("nJBfRa",6) == 4225711267) strcat(s, "n");
if (crc32("pQBfJaN",7) == 438782358) strcat(s, "l");
if (crc32("zwrWcQJ",7) == 158748401) strcat(s, "j");
if (crc32("sIsNFX",6) == 2844424713) strcat(s, "e");
    return s;
}

char *purged_verbs() {
    char *s = calloc(7);
    if (crc32("aTrRogI",7) == 2744331777) strcat(s, "p");
if (crc32("ApaVVAqH",8) == 3382385977) strcat(s, "u");
if (crc32("HMQQBUZWmaZ",11) == 4049700705) strcat(s, "T");
if (crc32("hHdWbqWMJCT",11) == 2815703580) strcat(s, "r");
if (crc32("aXptdEbwdbKvIf",14) == 3888999102) strcat(s, "g");
if (crc32("BMvobB",6) == 2448936184) strcat(s, "e");
if (crc32("EIYFght",7) == 2678127984) strcat(s, "d");
    return s;
}

char *oversensitizing_verbs() {
    char *s = calloc(16);
    if (crc32("hKMFcCQxVEBhFI",14) == 501974797) strcat(s, "M");
if (crc32("LrnBqNxMyLEouif",15) == 2370143357) strcat(s, "o");
if (crc32("wumlku",6) == 3090209056) strcat(s, "v");
if (crc32("eKycLxVWLTos",12) == 833673015) strcat(s, "e");
if (crc32("VmbTsuPEe",9) == 425739395) strcat(s, "r");
if (crc32("sfSRgr",6) == 137489347) strcat(s, "s");
if (crc32("ZxQPz",5) == 2099194357) strcat(s, "e");
if (crc32("KHUtbYXHVKSbaXb",15) == 2155663420) strcat(s, "u");
if (crc32("eSwJiwP",7) == 1034947721) strcat(s, "n");
if (crc32("QJpOIQA",7) == 1135457820) strcat(s, "H");
if (crc32("ktoIEkcJXUvsriL",15) == 2960732706) strcat(s, "s");
if (crc32("VGoyreZakkHYI",13) == 3440613492) strcat(s, "k");
if (crc32("SRBKVj",6) == 1969211218) strcat(s, "i");
if (crc32("yYuAxfxyycZuKU",14) == 1890139475) strcat(s, "t");
if (crc32("yBUllIeL",8) == 3764552944) strcat(s, "P");
if (crc32("gyILMHfHsuSyVzg",15) == 2177396143) strcat(s, "i");
if (crc32("wWPvOqnaNbvEBGw",15) == 707930193) strcat(s, "f");
if (crc32("rhGVN",5) == 3019019870) strcat(s, "z");
if (crc32("gHVgJWAXEzWvNgB",15) == 4213786611) strcat(s, "O");
if (crc32("JAiSC",5) == 3465307839) strcat(s, "i");
if (crc32("WSvLxyVZKlFoUEB",15) == 3475850766) strcat(s, "n");
if (crc32("XlpPBrCrZi",10) == 4109771123) strcat(s, "M");
if (crc32("wYRSqjLpZIahr",13) == 4214221873) strcat(s, "g");
    return s;
}

char *doling_verbs() {
    char *s = calloc(7);
    if (crc32("kOUfc",5) == 3630858718) strcat(s, "F");
if (crc32("tGmFfEVQ",8) == 937215709) strcat(s, "d");
if (crc32("FqWFBe",6) == 3194154031) strcat(s, "c");
if (crc32("YqGLQfVxU",9) == 786217294) strcat(s, "o");
if (crc32("CwCidndYUCNUbN",14) == 2109930927) strcat(s, "l");
if (crc32("eFwTYZZQwDk",11) == 3932054230) strcat(s, "s");
if (crc32("GRnDLOKd",8) == 2666226263) strcat(s, "i");
if (crc32("RjKzwmFjv",9) == 1396110537) strcat(s, "K");
if (crc32("GicafKAXdSEdX",13) == 1933018066) strcat(s, "n");
if (crc32("tojCu",5) == 351822592) strcat(s, "e");
if (crc32("FPYbSFu",7) == 4205049889) strcat(s, "g");
    return s;
}

char *heterodyne_verbs() {
    char *s = calloc(11);
    if (crc32("QkRRH",5) == 2457660028) strcat(s, "D");
if (crc32("aafchKAJyGqn",12) == 2363889073) strcat(s, "h");
if (crc32("gqUEcT",6) == 2574601862) strcat(s, "K");
if (crc32("PQvyASXcwlMP",12) == 152396373) strcat(s, "e");
if (crc32("fnapTqFpYbzSI",13) == 125006998) strcat(s, "t");
if (crc32("LnxzLT",6) == 2015530367) strcat(s, "S");
if (crc32("bkJjjbZ",7) == 1016845725) strcat(s, "e");
if (crc32("mPXhNQvbNWOfiQ",14) == 699488440) strcat(s, "r");
if (crc32("dRwjKMBLUBXmix",14) == 3020315425) strcat(s, "r");
if (crc32("EXpboZkAPpVeED",14) == 1781429051) strcat(s, "o");
if (crc32("FlIXV",5) == 4013983645) strcat(s, "d");
if (crc32("qMrGGpSDk",9) == 3852794061) strcat(s, "Q");
if (crc32("HhzxTeRGn",9) == 2487553807) strcat(s, "y");
if (crc32("mawQsgeGpO",10) == 3110692202) strcat(s, "n");
if (crc32("UCPPyMsnfUl",11) == 2223781661) strcat(s, "H");
if (crc32("ugAwgRGcmf",10) == 1759674658) strcat(s, "e");
    return s;
}

char *drysalt_verbs() {
    char *s = calloc(8);
    if (crc32("qMWKjKNUhbmPa",13) == 4238636129) strcat(s, "d");
if (crc32("HdAPROQkPqK",11) == 1531519375) strcat(s, "r");
if (crc32("jcAGAPbislBcUvG",15) == 2351264820) strcat(s, "N");
if (crc32("nLjDh",5) == 2749297705) strcat(s, "y");
if (crc32("PQJEbeSbqx",10) == 2133223207) strcat(s, "s");
if (crc32("nrzFspr",7) == 3398501484) strcat(s, "a");
if (crc32("jgvNf",5) == 688317775) strcat(s, "l");
if (crc32("SekivyG",7) == 515122652) strcat(s, "l");
if (crc32("hvoosBGotBLC",12) == 1006896012) strcat(s, "t");
    return s;
}

char *plicating_verbs() {
    char *s = calloc(10);
    if (crc32("LAIyBJqOPhG",11) == 1412546271) strcat(s, "p");
if (crc32("QhUFOTzWlvWSXTX",15) == 4042038757) strcat(s, "S");
if (crc32("RytZrbIP",8) == 695530614) strcat(s, "l");
if (crc32("bUHHmfA",7) == 2572590584) strcat(s, "i");
if (crc32("wiNPNwqpWobncvq",15) == 4212895529) strcat(s, "c");
if (crc32("akkjHM",6) == 2702746219) strcat(s, "C");
if (crc32("WsjZloFDrQcmurn",15) == 2182764639) strcat(s, "a");
if (crc32("tDOVQykhbfBgNoc",15) == 2078683878) strcat(s, "S");
if (crc32("zrCTcwUuYSAjte",14) == 4110726558) strcat(s, "t");
if (crc32("tIhmfadSC",9) == 1520756082) strcat(s, "J");
if (crc32("qeEHAo",6) == 3326275840) strcat(s, "i");
if (crc32("rClqBOVoV",9) == 4198387951) strcat(s, "n");
if (crc32("EuywVamYKrdTXmd",15) == 3030644875) strcat(s, "g");
    return s;
}

char *backslide_verbs() {
    char *s = calloc(10);
    if (crc32("CWuwWxMgz",9) == 3878503851) strcat(s, "h");
if (crc32("Ljkkh",5) == 2388142837) strcat(s, "b");
if (crc32("chwlZrPNUBF",11) == 3323445558) strcat(s, "a");
if (crc32("mVFRsKSNJWcqO",13) == 2201294723) strcat(s, "Q");
if (crc32("qHBoguXFQpGCft",14) == 1491468932) strcat(s, "c");
if (crc32("WYSDBFgm",8) == 4149251139) strcat(s, "k");
if (crc32("uLSykzZ",7) == 538097318) strcat(s, "o");
if (crc32("pcSDTOtURZuzLf",14) == 2210736839) strcat(s, "s");
if (crc32("ZwhGPDNOrxHvZB",14) == 3766450353) strcat(s, "y");
if (crc32("tqtRYL",6) == 2058682808) strcat(s, "l");
if (crc32("KjWsFzI",7) == 795957074) strcat(s, "i");
if (crc32("UivzhB",6) == 3228478955) strcat(s, "f");
if (crc32("EytOIopUz",9) == 846270674) strcat(s, "d");
if (crc32("oABTcXFVY",9) == 1970099882) strcat(s, "J");
if (crc32("tIzNfgkvK",9) == 1823773750) strcat(s, "e");
    return s;
}

char *indemnify_verbs() {
    char *s = calloc(10);
    if (crc32("lKsxvdPTBgCK",12) == 1743093451) strcat(s, "i");
if (crc32("WISiJDyjweJ",11) == 3607113007) strcat(s, "n");
if (crc32("oOhFzOVs",8) == 3071744097) strcat(s, "d");
if (crc32("OpbXKJHPp",9) == 3355846588) strcat(s, "t");
if (crc32("aGIvxBqYtUs",11) == 741162209) strcat(s, "e");
if (crc32("miDOV",5) == 3280655980) strcat(s, "I");
if (crc32("nFwPwySssxg",11) == 1513750310) strcat(s, "m");
if (crc32("IYYoHzD",7) == 2577613715) strcat(s, "V");
if (crc32("UGvsUR",6) == 1561857086) strcat(s, "n");
if (crc32("gvHWRy",6) == 1151743367) strcat(s, "i");
if (crc32("KNAGEiSvXR",10) == 1114577145) strcat(s, "f");
if (crc32("ZLxwFoM",7) == 108476127) strcat(s, "y");
if (crc32("JGVMhoaGN",9) == 3495976039) strcat(s, "y");
    return s;
}

char *pinnacling_verbs() {
    char *s = calloc(11);
    if (crc32("VYVpWAkoJT",10) == 1265943797) strcat(s, "p");
if (crc32("BezVzgdHrnsb",12) == 1519730465) strcat(s, "D");
if (crc32("aRNhgigPMUEHrK",14) == 3448455360) strcat(s, "i");
if (crc32("xZCLhubq",8) == 1436292071) strcat(s, "n");
if (crc32("wtOIELapLFBxWRw",15) == 3014058846) strcat(s, "n");
if (crc32("dUfjksHuGwgXwSd",15) == 3680658291) strcat(s, "X");
if (crc32("DOSOO",5) == 1465835229) strcat(s, "a");
if (crc32("NGzOCIwfWWi",11) == 2793639116) strcat(s, "c");
if (crc32("sUXvBRhoyYWXK",13) == 2340186042) strcat(s, "l");
if (crc32("ANsZfCZszK",10) == 654246530) strcat(s, "i");
if (crc32("JsTKDHZkiDdKX",13) == 1349026923) strcat(s, "n");
if (crc32("aunUcJE",7) == 1998738696) strcat(s, "g");
    return s;
}

char *readjust_verbs() {
    char *s = calloc(9);
    if (crc32("wpbIVo",6) == 2176807881) strcat(s, "r");
if (crc32("InyLoyPlewEc",12) == 3267620707) strcat(s, "e");
if (crc32("UUHSfJBbbJEO",12) == 2172349207) strcat(s, "Y");
if (crc32("VWuhGPsDipxF",12) == 1141110883) strcat(s, "a");
if (crc32("wXolRJziGqBs",12) == 3579393199) strcat(s, "k");
if (crc32("PwwVrnKdrn",10) == 4243360299) strcat(s, "d");
if (crc32("KQHzyAnjuigqW",13) == 1299233048) strcat(s, "j");
if (crc32("HwQTsvPeWYmn",12) == 3210598034) strcat(s, "W");
if (crc32("vBQUrUVMLClUiEk",15) == 3554362847) strcat(s, "u");
if (crc32("AbtQBKPXKTnQdwY",15) == 335357818) strcat(s, "N");
if (crc32("oltUlcRiNfIzV",13) == 3036080892) strcat(s, "s");
if (crc32("eJqnicSsAOzyi",13) == 3290065302) strcat(s, "d");
if (crc32("RYfWkTG",7) == 820159371) strcat(s, "t");
    return s;
}

char *rimpled_verbs() {
    char *s = calloc(8);
    if (crc32("qJPeykhke",9) == 663758300) strcat(s, "r");
if (crc32("OVGPJbZYSvwPZKf",15) == 3217201086) strcat(s, "i");
if (crc32("DGBJAufESgnt",12) == 1272942828) strcat(s, "m");
if (crc32("dRlqnDUpaXoju",13) == 1201632835) strcat(s, "p");
if (crc32("ZFaYWxd",7) == 3453567744) strcat(s, "C");
if (crc32("RGnDXHLCAws",11) == 838605563) strcat(s, "l");
if (crc32("qEyfilcXtjlburt",15) == 821118144) strcat(s, "e");
if (crc32("UAgAYKScQnkgDi",14) == 2769449563) strcat(s, "c");
if (crc32("iyvodA",6) == 1735315831) strcat(s, "d");
    return s;
}

char *revoted_verbs() {
    char *s = calloc(8);
    if (crc32("IiRwaZ",6) == 1850808071) strcat(s, "x");
if (crc32("GYwtdFAPaS",10) == 2062107862) strcat(s, "r");
if (crc32("GuuxUFSSrn",10) == 2506006702) strcat(s, "e");
if (crc32("qwvYXaCZ",8) == 3542729170) strcat(s, "v");
if (crc32("SrQkiTl",7) == 2282066149) strcat(s, "H");
if (crc32("AVAqtg",6) == 747321143) strcat(s, "o");
if (crc32("hsCKaGW",7) == 4175946676) strcat(s, "t");
if (crc32("uXjcXyKPk",9) == 2031679649) strcat(s, "e");
if (crc32("xiCHpvKT",8) == 2705227885) strcat(s, "d");
    return s;
}

char *wheezing_verbs() {
    char *s = calloc(9);
    if (crc32("xaTqNM",6) == 3223780339) strcat(s, "a");
if (crc32("cSLLz",5) == 1419032131) strcat(s, "w");
if (crc32("lQLEBimkqlH",11) == 2882695853) strcat(s, "h");
if (crc32("uNxTVP",6) == 1467614810) strcat(s, "v");
if (crc32("wNnrNMwlhJSx",12) == 2713387101) strcat(s, "e");
if (crc32("zrHnwanmXLh",11) == 608768357) strcat(s, "K");
if (crc32("aOvfm",5) == 4057932973) strcat(s, "e");
if (crc32("ZAdgQFDOYrfsqMQ",15) == 3136524606) strcat(s, "z");
if (crc32("bbPOYvTlzl",10) == 3501478996) strcat(s, "m");
if (crc32("COkguJfDLKjv",12) == 2498832417) strcat(s, "i");
if (crc32("wpfVV",5) == 1090187381) strcat(s, "q");
if (crc32("lvUInT",6) == 2894520822) strcat(s, "n");
if (crc32("tyxCSVYpfRLp",12) == 185853602) strcat(s, "i");
if (crc32("gXkJfyVi",8) == 1118090820) strcat(s, "g");
    return s;
}

char *sandaling_verbs() {
    char *s = calloc(10);
    if (crc32("pkgBtk",6) == 283015176) strcat(s, "s");
if (crc32("XMYQOtoNZAgkrjb",15) == 2748406379) strcat(s, "a");
if (crc32("IpJDsqaABtLdBir",15) == 4138487225) strcat(s, "n");
if (crc32("ZYbuRygnJptIPMP",15) == 2618614245) strcat(s, "D");
if (crc32("QkBSzfCYD",9) == 2450842563) strcat(s, "d");
if (crc32("skZsDmQV",8) == 2835017542) strcat(s, "a");
if (crc32("nFBcvW",6) == 2741607816) strcat(s, "l");
if (crc32("VExUEdjQ",8) == 2544933213) strcat(s, "i");
if (crc32("YOmCgprS",8) == 1400264321) strcat(s, "K");
if (crc32("KiFmwtBxSRazreR",15) == 3566803324) strcat(s, "n");
if (crc32("mOsuwJMUQ",9) == 558802622) strcat(s, "g");
    return s;
}

char *withed_verbs() {
    char *s = calloc(7);
    if (crc32("KOhwSUc",7) == 122285047) strcat(s, "w");
if (crc32("WIVfpbOD",8) == 30086538) strcat(s, "i");
if (crc32("OWgRxViQal",10) == 3086776196) strcat(s, "t");
if (crc32("kWRxdfp",7) == 1748154059) strcat(s, "O");
if (crc32("zhNSXg",6) == 112996296) strcat(s, "h");
if (crc32("VhwAAcixEHvk",12) == 1468970011) strcat(s, "e");
if (crc32("SBJoAXfmAw",10) == 3392906152) strcat(s, "b");
if (crc32("fgiUTntU",8) == 3033234753) strcat(s, "d");
    return s;
}

char *royalized_verbs() {
    char *s = calloc(10);
    if (crc32("dGboPZmckWYa",12) == 2505682062) strcat(s, "r");
if (crc32("NMRayXPltFbSMLM",15) == 919778806) strcat(s, "d");
if (crc32("xxOmz",5) == 3125711701) strcat(s, "o");
if (crc32("Baamrrzgeavgr",13) == 3797245372) strcat(s, "r");
if (crc32("gMQccVUpgQAAHwn",15) == 3788740009) strcat(s, "y");
if (crc32("uYGqCAQqq",9) == 388349713) strcat(s, "a");
if (crc32("fFxEKNXomvuZLr",14) == 2874647310) strcat(s, "l");
if (crc32("CzMKi",5) == 2186462429) strcat(s, "i");
if (crc32("HzQDwXYz",8) == 4060951965) strcat(s, "z");
if (crc32("oRFmi",5) == 745467340) strcat(s, "e");
if (crc32("DRbZUKY",7) == 1612581551) strcat(s, "h");
if (crc32("zLPsrHz",7) == 863157156) strcat(s, "d");
    return s;
}

char *overpark_verbs() {
    char *s = calloc(9);
    if (crc32("LbowldHLLQKGmsV",15) == 2114543782) strcat(s, "o");
if (crc32("zrDlr",5) == 3030808259) strcat(s, "v");
if (crc32("oYMEZrbaGDC",11) == 205060447) strcat(s, "e");
if (crc32("WDtdsuJpZu",10) == 3269538468) strcat(s, "v");
if (crc32("lKOCrlrkprmkMdv",15) == 3664412982) strcat(s, "r");
if (crc32("rwJGDVBxnjcLGn",14) == 3080074531) strcat(s, "h");
if (crc32("yrumxQx",7) == 4254337758) strcat(s, "p");
if (crc32("mShLnrSArULVr",13) == 2610548844) strcat(s, "a");
if (crc32("rRSHnmZdIymNI",13) == 3221468580) strcat(s, "r");
if (crc32("InWLmYjfY",9) == 1495546055) strcat(s, "T");
if (crc32("yOnQWBfA",8) == 1145768833) strcat(s, "k");
    return s;
}

char *rued_verbs() {
    char *s = calloc(5);
    if (crc32("RGziksRV",8) == 3022921523) strcat(s, "Z");
if (crc32("iuVHaLARXMRP",12) == 473666785) strcat(s, "r");
if (crc32("OMEqxJoGkIY",11) == 2867267856) strcat(s, "u");
if (crc32("zyIFyXDRFDj",11) == 4172890127) strcat(s, "Q");
if (crc32("oVclYeap",8) == 716452978) strcat(s, "e");
if (crc32("HtPuVmVWft",10) == 1894906088) strcat(s, "d");
    return s;
}

char *aboutfacing_verbs() {
    char *s = calloc(12);
    if (crc32("gYBTnx",6) == 881911136) strcat(s, "u");
if (crc32("cbnjdrmiRrfrQ",13) == 1492723656) strcat(s, "a");
if (crc32("CnlplnlWsQY",11) == 1851043649) strcat(s, "b");
if (crc32("jpDafe",6) == 2992855771) strcat(s, "o");
if (crc32("gMocLeEmIG",10) == 2140128864) strcat(s, "W");
if (crc32("uuDcKKz",7) == 597784105) strcat(s, "u");
if (crc32("kjFOtwWPaPjaLO",14) == 4157665176) strcat(s, "t");
if (crc32("sCXYBxxEJ",9) == 3966873453) strcat(s, "S");
if (crc32("ChUvOwiSbjC",11) == 1720522616) strcat(s, "f");
if (crc32("FyzETtsZhrclq",13) == 2949756203) strcat(s, "E");
if (crc32("XIXJWfPQebCc",12) == 4226079493) strcat(s, "a");
if (crc32("CSGdUSVTkw",10) == 4165158672) strcat(s, "c");
if (crc32("OkWsYpVMElpAw",13) == 2478961325) strcat(s, "c");
if (crc32("bWmFrwVoNfk",11) == 1345084355) strcat(s, "i");
if (crc32("WwfMfIepaSOJcz",14) == 181910300) strcat(s, "w");
if (crc32("szhrhpiofklZ",12) == 3945788863) strcat(s, "n");
if (crc32("qbbkqWWdmvfm",12) == 2776869428) strcat(s, "g");
    return s;
}

char *birdliming_verbs() {
    char *s = calloc(11);
    if (crc32("DNvtkqYRz",9) == 3843494867) strcat(s, "u");
if (crc32("rxXBMePtWda",11) == 2031684676) strcat(s, "b");
if (crc32("bSmxCcMsLGzLbIx",15) == 1839790572) strcat(s, "R");
if (crc32("HqYjWpdNWn",10) == 2507775008) strcat(s, "i");
if (crc32("kBWvY",5) == 469511906) strcat(s, "r");
if (crc32("raxFXpHRiDaD",12) == 814615733) strcat(s, "s");
if (crc32("CiAqrsv",7) == 2607094282) strcat(s, "d");
if (crc32("LkxeICOMstb",11) == 1441988679) strcat(s, "d");
if (crc32("gaJyVyjqTjopRrU",15) == 1970777569) strcat(s, "l");
if (crc32("ulwwyF",6) == 1895524215) strcat(s, "i");
if (crc32("URCCFYCokMaR",12) == 3418027784) strcat(s, "m");
if (crc32("RTRudKAhcLRbbPY",15) == 2555559413) strcat(s, "g");
if (crc32("UJhdJRj",7) == 128176954) strcat(s, "i");
if (crc32("iqKmib",6) == 1657366848) strcat(s, "Y");
if (crc32("HKxUy",5) == 1447256776) strcat(s, "n");
if (crc32("LkqGcMMftHqKKY",14) == 182765768) strcat(s, "g");
    return s;
}

char *troubling_verbs() {
    char *s = calloc(10);
    if (crc32("fAAXB",5) == 1745902271) strcat(s, "t");
if (crc32("LvjqalZeC",9) == 3411526904) strcat(s, "f");
if (crc32("iYNuVTyqYZx",11) == 2051242358) strcat(s, "r");
if (crc32("TwtdeKyyvZ",10) == 1484929574) strcat(s, "o");
if (crc32("AjljrYsgacaE",12) == 758773973) strcat(s, "u");
if (crc32("Idwjo",5) == 874785856) strcat(s, "b");
if (crc32("hXEueGNHVfgc",12) == 1293688148) strcat(s, "l");
if (crc32("HcfWSpShJNB",11) == 3880629630) strcat(s, "y");
if (crc32("gaPOVehe",8) == 1952897848) strcat(s, "i");
if (crc32("CWUrrDEpRwrpZo",14) == 1693522837) strcat(s, "n");
if (crc32("vHvlJxti",8) == 2090974824) strcat(s, "u");
if (crc32("bciGmlWTxofFQ",13) == 1847533564) strcat(s, "g");
    return s;
}

char *dwelled_verbs() {
    char *s = calloc(8);
    if (crc32("ZQQEHmJzY",9) == 1240319395) strcat(s, "C");
if (crc32("QgkAhVqPnXyq",12) == 2663756149) strcat(s, "d");
if (crc32("HySphaEOBd",10) == 580489191) strcat(s, "s");
if (crc32("BTBbdAmUgX",10) == 992734299) strcat(s, "w");
if (crc32("VaYfAoDFevyRag",14) == 1863332565) strcat(s, "a");
if (crc32("HvNnScDNTkSQ",12) == 3491048762) strcat(s, "e");
if (crc32("KqEeZJ",6) == 3673692045) strcat(s, "G");
if (crc32("KxZymYUQefjpcYD",15) == 1265249) strcat(s, "l");
if (crc32("PjUWODUUJDZxl",13) == 1111156131) strcat(s, "x");
if (crc32("cIsJzFpI",8) == 629818964) strcat(s, "l");
if (crc32("EPaIeTDwPwCmeF",14) == 3993239993) strcat(s, "y");
if (crc32("FLivGxaxC",9) == 4086829186) strcat(s, "e");
if (crc32("SPXtjUcZHegOebi",15) == 3929294495) strcat(s, "C");
if (crc32("ssXYFYDUT",9) == 2343335683) strcat(s, "d");
    return s;
}

char *triangulate_verbs() {
    char *s = calloc(12);
    if (crc32("xSXavCluf",9) == 3979240271) strcat(s, "t");
if (crc32("BMiHIrEfp",9) == 1979849284) strcat(s, "l");
if (crc32("VxhWAArHCZuno",13) == 1309307480) strcat(s, "r");
if (crc32("qdsFrZvE",8) == 1312705987) strcat(s, "N");
if (crc32("XNUeANC",7) == 3027812718) strcat(s, "i");
if (crc32("FZjvjSIXIYawr",13) == 493230901) strcat(s, "C");
if (crc32("ZEQhR",5) == 1567890824) strcat(s, "a");
if (crc32("CqqEl",5) == 2529920553) strcat(s, "n");
if (crc32("rqIZMClcNipZTC",14) == 1760639907) strcat(s, "o");
if (crc32("VxnUrmNtgeJt",12) == 2476669135) strcat(s, "g");
if (crc32("kqARVZpH",8) == 3827735554) strcat(s, "I");
if (crc32("yZdsMIJDcStxw",13) == 163740741) strcat(s, "u");
if (crc32("PTssMFrcNvOzysP",15) == 511297695) strcat(s, "l");
if (crc32("CDztbSFuGPvVM",13) == 2673852717) strcat(s, "a");
if (crc32("CxyVqAcypol",11) == 3123880011) strcat(s, "x");
if (crc32("jgZtn",5) == 857934976) strcat(s, "t");
if (crc32("XNJtrah",7) == 652241699) strcat(s, "e");
    return s;
}

char *kitted_verbs() {
    char *s = calloc(7);
    if (crc32("gvqrCx",6) == 3868057679) strcat(s, "P");
if (crc32("XHlyirKDkZl",11) == 245140848) strcat(s, "k");
if (crc32("GWOMoJCdtyGuwR",14) == 3090533013) strcat(s, "i");
if (crc32("DaHDkCGRqlZVYZ",14) == 3821403553) strcat(s, "t");
if (crc32("YaLEshz",7) == 2449677606) strcat(s, "t");
if (crc32("IfvZOlKyg",9) == 1985729550) strcat(s, "h");
if (crc32("OCWRWHarkcUS",12) == 2319542132) strcat(s, "e");
if (crc32("nSvFDTKrkr",10) == 3748731336) strcat(s, "z");
if (crc32("AHDvEZMRxAHJnc",14) == 3636912461) strcat(s, "d");
    return s;
}

char *blacken_verbs() {
    char *s = calloc(8);
    if (crc32("yDNOrtdCzY",10) == 2010847887) strcat(s, "I");
if (crc32("UrWiennakRbw",12) == 500196441) strcat(s, "b");
if (crc32("DwzQdyzPQOKMf",13) == 3305297488) strcat(s, "l");
if (crc32("NfOgtqsGSOfqWu",14) == 3240764168) strcat(s, "I");
if (crc32("XpFAFDFfKIQrAZ",14) == 3601809742) strcat(s, "a");
if (crc32("fWfHXzdMMrDNiEm",15) == 3047862229) strcat(s, "l");
if (crc32("EPFxvtITGPoaqcF",15) == 3982797982) strcat(s, "c");
if (crc32("nETXAbiXDeH",11) == 2729649932) strcat(s, "f");
if (crc32("MOJEtf",6) == 3051223140) strcat(s, "k");
if (crc32("bWyghrPirg",10) == 285351579) strcat(s, "e");
if (crc32("uwifymBUSCElEuk",15) == 3944496300) strcat(s, "e");
if (crc32("EETnjY",6) == 4123523559) strcat(s, "n");
    return s;
}

char *classify_verbs() {
    char *s = calloc(9);
    if (crc32("kpooMbpTqiRrzt",14) == 4292510417) strcat(s, "I");
if (crc32("jjGbqf",6) == 340398435) strcat(s, "c");
if (crc32("ZGxSqjqdYAnXgHa",15) == 3997979152) strcat(s, "l");
if (crc32("BKaNTDwOGzqYTo",14) == 700279768) strcat(s, "a");
if (crc32("TkmYGpQLIcgLI",13) == 3363386585) strcat(s, "s");
if (crc32("VqsZQySgEGyfaKJ",15) == 2333949134) strcat(s, "t");
if (crc32("TnEUVMHkDgbMi",13) == 1751757148) strcat(s, "s");
if (crc32("trhnTddayTioF",13) == 3578691422) strcat(s, "i");
if (crc32("LWUBU",5) == 3200389609) strcat(s, "f");
if (crc32("LURexMo",7) == 3466049220) strcat(s, "y");
    return s;
}

char *incubating_verbs() {
    char *s = calloc(11);
    if (crc32("JrJyFIoPnSyEob",14) == 4270112005) strcat(s, "P");
if (crc32("txpsCUYDhOPkdV",14) == 74608069) strcat(s, "i");
if (crc32("aYikNR",6) == 2925141757) strcat(s, "n");
if (crc32("jeWjvaxf",8) == 2079866431) strcat(s, "c");
if (crc32("prvUOtNSSWyhiKn",15) == 796958856) strcat(s, "X");
if (crc32("bfuWlwDlNikmPLg",15) == 334156169) strcat(s, "u");
if (crc32("TDkRViQoBC",10) == 3827625202) strcat(s, "C");
if (crc32("hqlSCZKayUmV",12) == 625147172) strcat(s, "b");
if (crc32("dFoArjjXYCL",11) == 3056799338) strcat(s, "a");
if (crc32("oYlCKkIIPMssawX",15) == 1802420108) strcat(s, "B");
if (crc32("mojxXAngtdg",11) == 3013695082) strcat(s, "t");
if (crc32("AweZjMjF",8) == 2939475008) strcat(s, "i");
if (crc32("ChAmUTvzwLTt",12) == 1527289646) strcat(s, "P");
if (crc32("QTZpadDqAAURfF",14) == 3437544385) strcat(s, "n");
if (crc32("pKvJMLRmP",9) == 3867607142) strcat(s, "g");
    return s;
}

char *reharvest_verbs() {
    char *s = calloc(10);
    if (crc32("WnfvduHbZCDpS",13) == 2146682647) strcat(s, "r");
if (crc32("yOJwYPLlnBka",12) == 3278094955) strcat(s, "e");
if (crc32("sIzuALWCzVZku",13) == 3946955958) strcat(s, "h");
if (crc32("iCCafSVGrnN",11) == 542045692) strcat(s, "a");
if (crc32("AgQvVtx",7) == 1551536276) strcat(s, "r");
if (crc32("EObEFTRxKN",10) == 3008500158) strcat(s, "v");
if (crc32("LCFKFJkNg",9) == 742749254) strcat(s, "Y");
if (crc32("pPpgNcKp",8) == 3091577943) strcat(s, "e");
if (crc32("XtyFNbRbwWe",11) == 3533374288) strcat(s, "I");
if (crc32("fDBmYItvk",9) == 549143650) strcat(s, "s");
if (crc32("tnsrkZnCNA",10) == 710910770) strcat(s, "t");
if (crc32("gDxKFTlo",8) == 110434490) strcat(s, "t");
    return s;
}

char *singed_verbs() {
    char *s = calloc(7);
    if (crc32("ukchKCQeE",9) == 1518667111) strcat(s, "s");
if (crc32("NPZvw",5) == 1019449118) strcat(s, "i");
if (crc32("mPkROnpNJaoUto",14) == 1284323402) strcat(s, "n");
if (crc32("TRcYSPWmqtamvdn",15) == 1316547654) strcat(s, "g");
if (crc32("hkDOcOdyvHrZAMe",15) == 4027804141) strcat(s, "e");
if (crc32("DhsLRVpb",8) == 3753492034) strcat(s, "k");
if (crc32("shdPexPr",8) == 108575362) strcat(s, "d");
    return s;
}

char *underruling_verbs() {
    char *s = calloc(12);
    if (crc32("KGcbGs",6) == 1897122787) strcat(s, "A");
if (crc32("qoFPCzHsmR",10) == 3530811709) strcat(s, "u");
if (crc32("hVcpt",5) == 3308485608) strcat(s, "V");
if (crc32("TamslHYYnBo",11) == 1663464674) strcat(s, "n");
if (crc32("tODYialNuWKN",12) == 2648868400) strcat(s, "d");
if (crc32("ysEgZqJg",8) == 1475940659) strcat(s, "e");
if (crc32("hWvCHEA",7) == 970002737) strcat(s, "r");
if (crc32("tGNMYQ",6) == 67466198) strcat(s, "X");
if (crc32("ubfViNmY",8) == 176893828) strcat(s, "r");
if (crc32("bBZyguqi",8) == 2335064474) strcat(s, "u");
if (crc32("rfbtCAi",7) == 4282779645) strcat(s, "o");
if (crc32("ARPQV",5) == 2409756585) strcat(s, "l");
if (crc32("fMNzSEYpG",9) == 3002515153) strcat(s, "i");
if (crc32("tPJdMW",6) == 3058371213) strcat(s, "H");
if (crc32("gqGcpzEFL",9) == 3816117738) strcat(s, "n");
if (crc32("IvxQLRS",7) == 687376893) strcat(s, "g");
    return s;
}

char *napped_verbs() {
    char *s = calloc(7);
    if (crc32("dWcWADO",7) == 2021164214) strcat(s, "n");
if (crc32("OzGeozrvEPxGV",13) == 1234158183) strcat(s, "D");
if (crc32("NEJVmpjOgTZYN",13) == 1154343464) strcat(s, "a");
if (crc32("PKFUNQwMxxQMHwI",15) == 1627002303) strcat(s, "w");
if (crc32("eptMpys",7) == 1240268155) strcat(s, "p");
if (crc32("VjLTvw",6) == 3051650723) strcat(s, "p");
if (crc32("kWzGnGxo",8) == 1300051919) strcat(s, "o");
if (crc32("xTFSdPoEzQlDqkz",15) == 1762025462) strcat(s, "e");
if (crc32("YyivrZVYeBAOA",13) == 742085224) strcat(s, "c");
if (crc32("IuWwMBgClU",10) == 3668752788) strcat(s, "d");
    return s;
}

char *reswallow_verbs() {
    char *s = calloc(10);
    if (crc32("iPesbhbw",8) == 3265364911) strcat(s, "f");
if (crc32("nQhTuZLDmOqZOP",14) == 1566132107) strcat(s, "r");
if (crc32("UbISjGT",7) == 3013095314) strcat(s, "e");
if (crc32("jGGOVtHzJBawbB",14) == 1947000626) strcat(s, "s");
if (crc32("KovCaVdTfUFQ",12) == 2241142193) strcat(s, "Z");
if (crc32("boSXifOQbtQP",12) == 832230987) strcat(s, "w");
if (crc32("cdMLU",5) == 3849924933) strcat(s, "B");
if (crc32("oWMpIeKH",8) == 50659882) strcat(s, "a");
if (crc32("xBJKJTBNPLPkc",13) == 3400499873) strcat(s, "l");
if (crc32("Osscnfpc",8) == 1145555917) strcat(s, "p");
if (crc32("AIUqbpDB",8) == 7241966) strcat(s, "l");
if (crc32("nutsXJ",6) == 2031469960) strcat(s, "J");
if (crc32("fLMiQV",6) == 4256960567) strcat(s, "o");
if (crc32("lMMfC",5) == 1471033129) strcat(s, "w");
    return s;
}

char *might_verbs() {
    char *s = calloc(6);
    if (crc32("CgYXVv",6) == 2452710343) strcat(s, "m");
if (crc32("LGQTOEsyiFC",11) == 4160853250) strcat(s, "E");
if (crc32("VKNbJJisAGZsiD",14) == 1283637789) strcat(s, "i");
if (crc32("PNLkccbiTbRbYwD",15) == 3501213531) strcat(s, "g");
if (crc32("UsSbVhptsx",10) == 2743539662) strcat(s, "h");
if (crc32("EVGQpzQzCC",10) == 3791027659) strcat(s, "p");
if (crc32("dnjbHGZXPCtPs",13) == 3617816675) strcat(s, "t");
    return s;
}

char *justified_verbs() {
    char *s = calloc(10);
    if (crc32("ULFqLPKxIC",10) == 3119301362) strcat(s, "j");
if (crc32("jDmqQ",5) == 2889546541) strcat(s, "R");
if (crc32("BngHFCWI",8) == 2654472180) strcat(s, "u");
if (crc32("cHhpX",5) == 676399911) strcat(s, "o");
if (crc32("gyBuenEvaRaqPB",14) == 1861676731) strcat(s, "s");
if (crc32("ZRKPfcGPKciTxn",14) == 4086115416) strcat(s, "Y");
if (crc32("RxknGkWQOowJWIZ",15) == 1847870938) strcat(s, "t");
if (crc32("wfNpl",5) == 3858264549) strcat(s, "x");
if (crc32("YoTebap",7) == 1951962171) strcat(s, "i");
if (crc32("ESdpODL",7) == 1164115177) strcat(s, "H");
if (crc32("GFhpLhZdSgOqJl",14) == 2569498651) strcat(s, "f");
if (crc32("JMhMCCriYaMKr",13) == 3496295601) strcat(s, "i");
if (crc32("pVjQRhFfE",9) == 1625200864) strcat(s, "j");
if (crc32("paWrOSxAEesbD",13) == 2288612024) strcat(s, "e");
if (crc32("lUhtPx",6) == 3185110586) strcat(s, "r");
if (crc32("JXNqTqkPGD",10) == 3358561878) strcat(s, "d");
    return s;
}

char *cramming_verbs() {
    char *s = calloc(9);
    if (crc32("WFTcexdHRvLxAKv",15) == 1395642168) strcat(s, "c");
if (crc32("yeFHuJe",7) == 1354928567) strcat(s, "r");
if (crc32("YPJzSuYKigtamH",14) == 1915937385) strcat(s, "a");
if (crc32("VOIqadSAqPv",11) == 849859984) strcat(s, "m");
if (crc32("ywxpmxgqHUMjC",13) == 273436654) strcat(s, "m");
if (crc32("rqcsR",5) == 4260506163) strcat(s, "j");
if (crc32("LsRYgAKOMQoH",12) == 1398812993) strcat(s, "i");
if (crc32("hvLCWaMi",8) == 3760920384) strcat(s, "n");
if (crc32("bQJKhgItQugk",12) == 3760562646) strcat(s, "K");
if (crc32("KvVZsYfYzxDO",12) == 753902652) strcat(s, "g");
    return s;
}

char *reaffiliated_verbs() {
    char *s = calloc(13);
    if (crc32("ZYVWW",5) == 1782594969) strcat(s, "r");
if (crc32("stXuCD",6) == 3326119034) strcat(s, "e");
if (crc32("geVmIAhrKWa",11) == 2707633521) strcat(s, "a");
if (crc32("WGfxmTqku",9) == 1784778308) strcat(s, "z");
if (crc32("RJjXQjhZhGVs",12) == 517541907) strcat(s, "f");
if (crc32("OuOOjWzPQo",10) == 1094592099) strcat(s, "f");
if (crc32("TiyYiNJAuVkreAI",15) == 2336392444) strcat(s, "i");
if (crc32("VyITOZPBtRClRY",14) == 3640093817) strcat(s, "l");
if (crc32("eotkVsVsMpGIPCa",15) == 1579184921) strcat(s, "i");
if (crc32("OhyIo",5) == 824182316) strcat(s, "X");
if (crc32("KFRrCHJbclKBm",13) == 3267444291) strcat(s, "a");
if (crc32("trlYQ",5) == 288476473) strcat(s, "r");
if (crc32("QPqPREBGkRdJImf",15) == 1291583270) strcat(s, "t");
if (crc32("fSjDAYXoKx",10) == 1540544737) strcat(s, "v");
if (crc32("tMlDCGTZ",8) == 331098430) strcat(s, "e");
if (crc32("Mujlx",5) == 3709541617) strcat(s, "X");
if (crc32("dhYjvWDgr",9) == 952505672) strcat(s, "d");
    return s;
}

char *shackled_verbs() {
    char *s = calloc(9);
    if (crc32("OQtkYDgTjzJgnVQ",15) == 2960228109) strcat(s, "U");
if (crc32("SDcWS",5) == 3773707208) strcat(s, "s");
if (crc32("nCzKH",5) == 2937163804) strcat(s, "j");
if (crc32("KleHrZtb",8) == 629921237) strcat(s, "h");
if (crc32("NQWSkCFoxaHiJmy",15) == 1089624269) strcat(s, "E");
if (crc32("nEAxb",5) == 2045280835) strcat(s, "a");
if (crc32("ncoDZZRMDv",10) == 457603552) strcat(s, "c");
if (crc32("ZwtCnmxRifBX",12) == 1973360515) strcat(s, "E");
if (crc32("WLBGdweR",8) == 1765581886) strcat(s, "k");
if (crc32("tqxUMakxjw",10) == 92978976) strcat(s, "l");
if (crc32("nhgbp",5) == 27161053) strcat(s, "V");
if (crc32("PkzyRYYP",8) == 3853909334) strcat(s, "e");
if (crc32("sGJwWX",6) == 3824848460) strcat(s, "d");
    return s;
}

char *expired_verbs() {
    char *s = calloc(8);
    if (crc32("VMfDueyCtvNfNYS",15) == 2363797006) strcat(s, "e");
if (crc32("oiTxjTUoqcpNVA",14) == 2460376445) strcat(s, "x");
if (crc32("zBBhsc",6) == 2654508244) strcat(s, "p");
if (crc32("VhSjWCNlpsZJPs",14) == 761430380) strcat(s, "o");
if (crc32("QQUmsgrL",8) == 312221842) strcat(s, "i");
if (crc32("fEGVrFLsffvvyBo",15) == 960735018) strcat(s, "m");
if (crc32("kQRcpIOkSvMvn",13) == 3612985463) strcat(s, "r");
if (crc32("KTYarqiYCi",10) == 11534953) strcat(s, "W");
if (crc32("wbPtujl",7) == 2768069487) strcat(s, "e");
if (crc32("WAPKKiwjqDCGE",13) == 3338277061) strcat(s, "d");
    return s;
}

char *inconveniencing_verbs() {
    char *s = calloc(16);
    if (crc32("hTRDkSgE",8) == 4082390562) strcat(s, "i");
if (crc32("sGoHwizGVUud",12) == 4135831667) strcat(s, "n");
if (crc32("AnvAvLJyWLxn",12) == 825012965) strcat(s, "c");
if (crc32("aBuwezeH",8) == 826056897) strcat(s, "o");
if (crc32("TRTgL",5) == 1423323016) strcat(s, "o");
if (crc32("jzXqFxokp",9) == 774865327) strcat(s, "n");
if (crc32("VktzxoWwPcAhgpD",15) == 3265468979) strcat(s, "c");
if (crc32("FHvjszqOJhNXYea",15) == 2826762653) strcat(s, "v");
if (crc32("faeclprqkFa",11) == 805230896) strcat(s, "H");
if (crc32("fqPorAyFaL",10) == 2997260311) strcat(s, "e");
if (crc32("wzFQyc",6) == 2061906668) strcat(s, "M");
if (crc32("GFOnJRyKLFZD",12) == 1642756333) strcat(s, "n");
if (crc32("MqmiNQUtPZf",11) == 1109994436) strcat(s, "i");
if (crc32("YnOqGxE",7) == 1569582542) strcat(s, "n");
if (crc32("oaYcjGHRSXQuAFs",15) == 137695217) strcat(s, "e");
if (crc32("CiJMPJIHsbgLIR",14) == 3541797209) strcat(s, "A");
if (crc32("qmzjynwSdH",10) == 2932900920) strcat(s, "n");
if (crc32("qymCfyMSmxFXNZ",14) == 116227901) strcat(s, "c");
if (crc32("LFpGmBZmDxU",11) == 1876969581) strcat(s, "i");
if (crc32("gtKnfQNNMsvmtA",14) == 3642880623) strcat(s, "n");
if (crc32("XIrqprVcOOoNgke",15) == 82567904) strcat(s, "x");
if (crc32("rIzdCMyzUOpOfi",14) == 4267011342) strcat(s, "g");
    return s;
}

char *syllabify_verbs() {
    char *s = calloc(10);
    if (crc32("HTvAD",5) == 576820047) strcat(s, "s");
if (crc32("ODWdwPVSTElvyX",14) == 1228053440) strcat(s, "y");
if (crc32("WoeSCyguhRaXTQ",14) == 593112847) strcat(s, "l");
if (crc32("hQvrxBtFD",9) == 3464670577) strcat(s, "A");
if (crc32("wpCdXVw",7) == 1421418386) strcat(s, "l");
if (crc32("dtEVaevSTAF",11) == 3034496427) strcat(s, "a");
if (crc32("AafhuwHwZZKfQa",14) == 646948599) strcat(s, "v");
if (crc32("StIRQrHXJPsU",12) == 3470069134) strcat(s, "b");
if (crc32("duBIWr",6) == 2719675924) strcat(s, "k");
if (crc32("cYTfA",5) == 4152132067) strcat(s, "i");
if (crc32("oputSxPkfNUF",12) == 156935513) strcat(s, "o");
if (crc32("aJAPIDGJPHzq",12) == 1043430167) strcat(s, "f");
if (crc32("RscFflMAJIcx",12) == 1277614954) strcat(s, "y");
    return s;
}

char *squash_verbs() {
    char *s = calloc(7);
    if (crc32("VpuqotNiwy",10) == 2299927375) strcat(s, "s");
if (crc32("FHevSBUbG",9) == 1363635372) strcat(s, "T");
if (crc32("gvuZQHgNE",9) == 3648399441) strcat(s, "q");
if (crc32("DgVaMC",6) == 57184911) strcat(s, "u");
if (crc32("tXCvfOEzS",9) == 3791387555) strcat(s, "a");
if (crc32("KuWmFCyceaT",11) == 4276739164) strcat(s, "s");
if (crc32("FbPzfMTaYfKUdjj",15) == 236031875) strcat(s, "O");
if (crc32("XCmVZ",5) == 1622187663) strcat(s, "h");
    return s;
}

char *ringback_verbs() {
    char *s = calloc(9);
    if (crc32("tTJmwlkYQpbxAW",14) == 3109243217) strcat(s, "p");
if (crc32("iZnQKbKlTPTo",12) == 2226308584) strcat(s, "r");
if (crc32("dsXdiay",7) == 91226053) strcat(s, "o");
if (crc32("daBjaGz",7) == 292067278) strcat(s, "i");
if (crc32("MASXRd",6) == 517114939) strcat(s, "n");
if (crc32("DboJXfGjnAHa",12) == 2225635229) strcat(s, "Z");
if (crc32("nMhkdlZeqNSlXD",14) == 4074765142) strcat(s, "g");
if (crc32("DQyVsygcJjh",11) == 810365087) strcat(s, "d");
if (crc32("nYkHSlmyHlRcqF",14) == 3389312317) strcat(s, "b");
if (crc32("JUGlAISurZEPbpC",15) == 1761369431) strcat(s, "S");
if (crc32("kxaeVPVpGmIQqB",14) == 2412730359) strcat(s, "a");
if (crc32("lkaEeNERiHY",11) == 3934477975) strcat(s, "M");
if (crc32("qkSqdr",6) == 2890867971) strcat(s, "c");
if (crc32("gfcqpx",6) == 3204499166) strcat(s, "k");
    return s;
}

char *transmogrify_verbs() {
    char *s = calloc(13);
    if (crc32("xbiZWmpZhQD",11) == 1442691414) strcat(s, "t");
if (crc32("woxwVkHNlBkwO",13) == 2963300241) strcat(s, "L");
if (crc32("kUnSncPWNTTmD",13) == 2205665874) strcat(s, "r");
if (crc32("rtCbr",5) == 4238375334) strcat(s, "B");
if (crc32("kaPtYei",7) == 1152561343) strcat(s, "a");
if (crc32("wqiLDiRPGOXozJ",14) == 484041384) strcat(s, "c");
if (crc32("UspUhIPHmF",10) == 3808958576) strcat(s, "n");
if (crc32("GWYgxTWcQkdmnGl",15) == 2560918033) strcat(s, "E");
if (crc32("DzZBuPwlvGAtc",13) == 2607402179) strcat(s, "s");
if (crc32("QDTEGX",6) == 2207930783) strcat(s, "l");
if (crc32("ICDSbwKzKJyp",12) == 3072835970) strcat(s, "m");
if (crc32("yIJQVTLBzgQAKn",14) == 3223942696) strcat(s, "o");
if (crc32("SmtGwoCjzUlEiKY",15) == 4174145447) strcat(s, "N");
if (crc32("MhMpPOhDk",9) == 401702241) strcat(s, "g");
if (crc32("VVoCXLbVgtvj",12) == 1496511419) strcat(s, "U");
if (crc32("Jaawo",5) == 2744980860) strcat(s, "r");
if (crc32("OUkUJsDf",8) == 3832043046) strcat(s, "i");
if (crc32("tOAAdfHenuDpop",14) == 1508261366) strcat(s, "M");
if (crc32("zkYtZTykY",9) == 3517531591) strcat(s, "f");
if (crc32("gAxCkwFAywYXAfI",15) == 1629342091) strcat(s, "A");
if (crc32("umOGAzdzFZslF",13) == 1979620710) strcat(s, "y");
    return s;
}

char *simplify_verbs() {
    char *s = calloc(9);
    if (crc32("fvBYSjGLoDg",11) == 954977733) strcat(s, "D");
if (crc32("JtTwo",5) == 3875181994) strcat(s, "s");
if (crc32("EJJLEkATnj",10) == 1142966011) strcat(s, "i");
if (crc32("xJCwdkEC",8) == 2865747097) strcat(s, "m");
if (crc32("rmBlpYY",7) == 739059319) strcat(s, "p");
if (crc32("BbeJOykM",8) == 2939498455) strcat(s, "Z");
if (crc32("BRMbPKHN",8) == 4108458977) strcat(s, "l");
if (crc32("jEeNSUxff",9) == 3960578156) strcat(s, "i");
if (crc32("qwRIuVVBejxSva",14) == 3225328962) strcat(s, "N");
if (crc32("IdKPQ",5) == 4254987110) strcat(s, "f");
if (crc32("dCKMkVyDBFOxJ",13) == 322576879) strcat(s, "p");
if (crc32("ATYuysVLmA",10) == 2638513619) strcat(s, "y");
    return s;
}

char *frivolling_verbs() {
    char *s = calloc(11);
    if (crc32("vMVoaamgNyeIjcS",15) == 2679723210) strcat(s, "m");
if (crc32("UXEvesIUte",10) == 2270378419) strcat(s, "f");
if (crc32("SGpCYCY",7) == 1207034165) strcat(s, "r");
if (crc32("wQBOrBEbGkAokw",14) == 3096788143) strcat(s, "i");
if (crc32("HIAkHWvnyzE",11) == 726974980) strcat(s, "A");
if (crc32("UFtpjzQMZdaBQ",13) == 4015346438) strcat(s, "v");
if (crc32("vLNHVoKWSeP",11) == 3794749154) strcat(s, "D");
if (crc32("mIrkee",6) == 4037919228) strcat(s, "o");
if (crc32("MzuImUsOqq",10) == 2297618087) strcat(s, "Y");
if (crc32("XrVHFsMY",8) == 2515142538) strcat(s, "l");
if (crc32("sZoDvlikYw",10) == 2248840226) strcat(s, "l");
if (crc32("AprObTLOmAaHT",13) == 54507198) strcat(s, "i");
if (crc32("DavatzGYz",9) == 946448002) strcat(s, "l");
if (crc32("LqAIbdyWuKNo",12) == 2863252672) strcat(s, "n");
if (crc32("TqKBg",5) == 2710685633) strcat(s, "z");
if (crc32("yFfAoWYi",8) == 528050350) strcat(s, "g");
    return s;
}

char *chatter_verbs() {
    char *s = calloc(8);
    if (crc32("qkIpNhh",7) == 3317705705) strcat(s, "w");
if (crc32("aDSrXMqfCLQg",12) == 3615613351) strcat(s, "c");
if (crc32("ArbGkPbqzUJE",12) == 1421074438) strcat(s, "h");
if (crc32("fWlEZcnmqRL",11) == 391893866) strcat(s, "a");
if (crc32("MljSCYugDF",10) == 3348361048) strcat(s, "t");
if (crc32("mCreSry",7) == 2296152838) strcat(s, "x");
if (crc32("CStcBsh",7) == 1932611280) strcat(s, "t");
if (crc32("cZmpuecd",8) == 4078110206) strcat(s, "W");
if (crc32("YnxSUi",6) == 2408733127) strcat(s, "e");
if (crc32("yQQfKvwvTuFS",12) == 40652524) strcat(s, "I");
if (crc32("ZyrshPOzdp",10) == 897085356) strcat(s, "r");
    return s;
}

char *deceived_verbs() {
    char *s = calloc(9);
    if (crc32("vAUGCku",7) == 3155516633) strcat(s, "r");
if (crc32("fpTQLtGDj",9) == 1083273319) strcat(s, "d");
if (crc32("wxlRbPssWkrJOOw",15) == 1349108771) strcat(s, "p");
if (crc32("EBFyuO",6) == 2635117785) strcat(s, "e");
if (crc32("WEuOr",5) == 2064360872) strcat(s, "c");
if (crc32("nIFJcNvo",8) == 1299033677) strcat(s, "e");
if (crc32("unylaw",6) == 693278678) strcat(s, "i");
if (crc32("xjTOUkzye",9) == 2752074854) strcat(s, "R");
if (crc32("jfvkUz",6) == 1930814912) strcat(s, "v");
if (crc32("aUfNLXzP",8) == 1010232118) strcat(s, "e");
if (crc32("wBgZtIQC",8) == 2685548163) strcat(s, "d");
    return s;
}

char *sided_verbs() {
    char *s = calloc(6);
    if (crc32("ufBDoJFwYVYyjt",14) == 2518303902) strcat(s, "c");
if (crc32("kxUAbnQ",7) == 2360741675) strcat(s, "s");
if (crc32("eZekSEkhsneCwJ",14) == 4178428808) strcat(s, "i");
if (crc32("kFxBkNAAgKt",11) == 1487974598) strcat(s, "d");
if (crc32("TgqyHvhFVGl",11) == 3937604978) strcat(s, "e");
if (crc32("WuMcUcNGmthuGtc",15) == 1788329531) strcat(s, "d");
    return s;
}

char *caprioling_verbs() {
    char *s = calloc(11);
    if (crc32("vOqDWxZg",8) == 250519517) strcat(s, "f");
if (crc32("qGxPbPmcB",9) == 1332933971) strcat(s, "c");
if (crc32("mTZLC",5) == 4228730442) strcat(s, "r");
if (crc32("Qqzlmjvtz",9) == 1244791928) strcat(s, "a");
if (crc32("VOJXkoGqqKSQ",12) == 4131571986) strcat(s, "k");
if (crc32("htMeTjJ",7) == 2075370541) strcat(s, "p");
if (crc32("eaVbi",5) == 3450563136) strcat(s, "k");
if (crc32("HhGBPMYDnVmTrU",14) == 1892482817) strcat(s, "r");
if (crc32("mRBSu",5) == 73617730) strcat(s, "i");
if (crc32("KYpVccWugLq",11) == 1824477102) strcat(s, "o");
if (crc32("dGsVxlXc",8) == 470240082) strcat(s, "d");
if (crc32("XOcsHAEYRNy",11) == 1016585913) strcat(s, "l");
if (crc32("jkWoPukSbs",10) == 4173499237) strcat(s, "i");
if (crc32("EYYqfKkSWr",10) == 3136555714) strcat(s, "T");
if (crc32("wUWnsrrqXEVRhC",14) == 3571283105) strcat(s, "n");
if (crc32("JJCmzMAzsjcApB",14) == 1044387442) strcat(s, "g");
if (crc32("xfvzPDp",7) == 1190800751) strcat(s, "g");
    return s;
}

char *unruffling_verbs() {
    char *s = calloc(11);
    if (crc32("JHrNHFoqrA",10) == 3637618647) strcat(s, "N");
if (crc32("ZpfaxHb",7) == 1174243932) strcat(s, "u");
if (crc32("OBQTzpD",7) == 1210662296) strcat(s, "o");
if (crc32("YTTwCyXy",8) == 2902865622) strcat(s, "n");
if (crc32("ywxoThIYCjpnqPe",15) == 605635043) strcat(s, "B");
if (crc32("HLwjuGhWXWX",11) == 4145225621) strcat(s, "r");
if (crc32("HXMxj",5) == 983859388) strcat(s, "o");
if (crc32("eZGlowkDngrIDya",15) == 33909421) strcat(s, "u");
if (crc32("Eqlvsr",6) == 2976945535) strcat(s, "f");
if (crc32("MFBJhaKSWQYLh",13) == 2677132547) strcat(s, "f");
if (crc32("MegZKcx",7) == 1600824928) strcat(s, "H");
if (crc32("TdMNurECe",9) == 3980465314) strcat(s, "l");
if (crc32("fkoBoAcccBX",11) == 2468430560) strcat(s, "O");
if (crc32("nqzOMuSGjmfPRwJ",15) == 1996860691) strcat(s, "i");
if (crc32("orwila",6) == 2262512161) strcat(s, "D");
if (crc32("kUCkUWB",7) == 3165981642) strcat(s, "n");
if (crc32("yAeeymUvJoenf",13) == 2813422025) strcat(s, "z");
if (crc32("zJDmYWpm",8) == 2389221262) strcat(s, "g");
    return s;
}

char *rearbitrated_verbs() {
    char *s = calloc(13);
    if (crc32("jWOUukn",7) == 1865141258) strcat(s, "j");
if (crc32("EXDJvbKbOAJ",11) == 761089908) strcat(s, "r");
if (crc32("jYPxseiTKuS",11) == 3440259389) strcat(s, "n");
if (crc32("XXwVluIXIBV",11) == 1998444531) strcat(s, "e");
if (crc32("mBJEY",5) == 1948880465) strcat(s, "a");
if (crc32("hixQeYwbAE",10) == 339217480) strcat(s, "r");
if (crc32("PkGMkieRv",9) == 4237010865) strcat(s, "b");
if (crc32("PtFsA",5) == 1806869852) strcat(s, "i");
if (crc32("iojUCNextMiQ",12) == 956662205) strcat(s, "G");
if (crc32("eQILlXI",7) == 1002350335) strcat(s, "t");
if (crc32("OQedgwPUAFeQT",13) == 3126579475) strcat(s, "x");
if (crc32("TdUiPWVCoCEOm",13) == 2365594467) strcat(s, "r");
if (crc32("jrOrG",5) == 1578368354) strcat(s, "s");
if (crc32("IeVkXlFIWgJzEq",14) == 2660533568) strcat(s, "a");
if (crc32("fNIhn",5) == 3556655425) strcat(s, "t");
if (crc32("mBsBVJq",7) == 4283951026) strcat(s, "e");
if (crc32("IRRgGUCf",8) == 1922723829) strcat(s, "a");
if (crc32("ayuINw",6) == 93953815) strcat(s, "d");
    return s;
}

char *do_verbs() {
    char *s = calloc(3);
    if (crc32("DRMWKBJD",8) == 23479581) strcat(s, "d");
if (crc32("RMbTPNKxgbE",11) == 136449816) strcat(s, "o");
    return s;
}

char *resaddled_verbs() {
    char *s = calloc(10);
    if (crc32("GiZiOz",6) == 2988629401) strcat(s, "U");
if (crc32("tHZWY",5) == 313935973) strcat(s, "r");
if (crc32("NzAvmTta",8) == 1889798395) strcat(s, "e");
if (crc32("ALaCJgtDsT",10) == 3187479650) strcat(s, "s");
if (crc32("lhAtuTUO",8) == 2224215051) strcat(s, "a");
if (crc32("xBMFPmiFkncz",12) == 102399008) strcat(s, "d");
if (crc32("xfLXjncdtXpFQD",14) == 1035951287) strcat(s, "I");
if (crc32("teYqR",5) == 379902835) strcat(s, "d");
if (crc32("EWfVWKHkClxi",12) == 1354987639) strcat(s, "l");
if (crc32("RCrdW",5) == 2730732342) strcat(s, "D");
if (crc32("HKPZQamU",8) == 1452114286) strcat(s, "e");
if (crc32("IMLJLDvTjFUx",12) == 1677313604) strcat(s, "d");
    return s;
}

char *airdropping_verbs() {
    char *s = calloc(12);
    if (crc32("GfoPc",5) == 523713072) strcat(s, "a");
if (crc32("klXgyemLm",9) == 222383722) strcat(s, "H");
if (crc32("taVkU",5) == 3167970401) strcat(s, "i");
if (crc32("LJUMWMxHTSa",11) == 3056644810) strcat(s, "r");
if (crc32("cnHiuh",6) == 287830495) strcat(s, "d");
if (crc32("fvKcyTHjrDb",11) == 2194319719) strcat(s, "D");
if (crc32("Lnxks",5) == 2503960935) strcat(s, "r");
if (crc32("iSPVhyeAwlcKKth",15) == 3241831579) strcat(s, "o");
if (crc32("jigzq",5) == 3972279563) strcat(s, "p");
if (crc32("QAkDwBhnIda",11) == 2376449188) strcat(s, "p");
if (crc32("HHPwkxhjyNrpy",13) == 1372602807) strcat(s, "E");
if (crc32("qToddLIBXw",10) == 2229979541) strcat(s, "i");
if (crc32("FnNANJGcDszFtI",14) == 3736020991) strcat(s, "d");
if (crc32("UxQANAKuDbVNIqR",15) == 1962580321) strcat(s, "n");
if (crc32("TtPDBYyzlb",10) == 1231969955) strcat(s, "g");
    return s;
}

char *collying_verbs() {
    char *s = calloc(9);
    if (crc32("cdUveulvdt",10) == 1423288727) strcat(s, "c");
if (crc32("QmhkbZtwl",9) == 577028303) strcat(s, "o");
if (crc32("COcxL",5) == 1262771066) strcat(s, "y");
if (crc32("uPFdJp",6) == 2030846132) strcat(s, "l");
if (crc32("XijnLWP",7) == 1304897315) strcat(s, "l");
if (crc32("YHNJn",5) == 1998152047) strcat(s, "y");
if (crc32("xGkmIkx",7) == 2509586548) strcat(s, "L");
if (crc32("kFmVIlJPJvtjoJ",14) == 1737492994) strcat(s, "i");
if (crc32("jonRYLuTbRIpS",13) == 1999723481) strcat(s, "n");
if (crc32("coxvfTzDfqNRsRu",15) == 3843525020) strcat(s, "g");
    return s;
}

char *indurate_verbs() {
    char *s = calloc(9);
    if (crc32("QKQBRlpyCl",10) == 289963668) strcat(s, "i");
if (crc32("ATkdq",5) == 3155890615) strcat(s, "G");
if (crc32("iYYSexaaL",9) == 3577191301) strcat(s, "n");
if (crc32("YTuhhBfYzcqRaNV",15) == 1213565830) strcat(s, "O");
if (crc32("QMkoiKMxTcMOi",13) == 3219818491) strcat(s, "d");
if (crc32("XHcIgCfZpAx",11) == 3791202022) strcat(s, "u");
if (crc32("udWGFFhHmTdtU",13) == 2373017604) strcat(s, "r");
if (crc32("mZVnSMe",7) == 1150364342) strcat(s, "Q");
if (crc32("HExpAniV",8) == 3223113425) strcat(s, "a");
if (crc32("WgGsawLy",8) == 2144260148) strcat(s, "t");
if (crc32("mcujo",5) == 1692147597) strcat(s, "d");
if (crc32("qGnlOfLQMWMqsxs",15) == 2462335014) strcat(s, "e");
    return s;
}

char *jiggle_verbs() {
    char *s = calloc(7);
    if (crc32("LhqHJS",6) == 1710427930) strcat(s, "c");
if (crc32("DPhlmUBi",8) == 106945100) strcat(s, "j");
if (crc32("mtnRtZPejn",10) == 1649415233) strcat(s, "Y");
if (crc32("nCJDmFcbQTQ",11) == 702266891) strcat(s, "i");
if (crc32("nMgtqpnqFBMOWKu",15) == 2843931880) strcat(s, "U");
if (crc32("JHOXVJmTLeeO",12) == 13456963) strcat(s, "g");
if (crc32("HVJBXdpW",8) == 3201475171) strcat(s, "V");
if (crc32("MYTLZazn",8) == 4187277418) strcat(s, "g");
if (crc32("gWdnuvZijYMI",12) == 1164652667) strcat(s, "o");
if (crc32("sZFNFwaAcGFqzXI",15) == 4253308711) strcat(s, "l");
if (crc32("RgpiXtJY",8) == 3864062042) strcat(s, "e");
    return s;
}

char *close_verbs() {
    char *s = calloc(6);
    if (crc32("ScPdeuwcfRomGx",14) == 712898302) strcat(s, "c");
if (crc32("SnwUeCISwwrei",13) == 3734486427) strcat(s, "l");
if (crc32("sytvAzwKdIUmLwE",15) == 1378884693) strcat(s, "o");
if (crc32("qcHukDiqhAis",12) == 505448474) strcat(s, "s");
if (crc32("ewWPMvZHCTO",11) == 2202558491) strcat(s, "e");
    return s;
}

char *cometh_verbs() {
    char *s = calloc(7);
    if (crc32("gqOdVN",6) == 464713685) strcat(s, "B");
if (crc32("qoRGlzpsBGNeA",13) == 3487047145) strcat(s, "c");
if (crc32("qJxIiAZZzYAcR",13) == 348199975) strcat(s, "o");
if (crc32("DWWzCJuISujKCAg",15) == 3153065325) strcat(s, "m");
if (crc32("SdgoQMjTgtq",11) == 1588986576) strcat(s, "q");
if (crc32("VZkATokjPZ",10) == 3407799942) strcat(s, "e");
if (crc32("FSRUCKpMxws",11) == 38234431) strcat(s, "w");
if (crc32("hfbDnYyw",8) == 3993894479) strcat(s, "t");
if (crc32("hRvXTyLNwDofNo",14) == 3689235246) strcat(s, "O");
if (crc32("hevEpNPSS",9) == 3301247147) strcat(s, "h");
    return s;
}

char *supinated_verbs() {
    char *s = calloc(10);
    if (crc32("JzRsTCqOnIH",11) == 1416682212) strcat(s, "O");
if (crc32("ZoVwLtrEBHWjaL",14) == 3805409453) strcat(s, "s");
if (crc32("MFoLXilg",8) == 3353429859) strcat(s, "u");
if (crc32("MJKDAvj",7) == 333170468) strcat(s, "Z");
if (crc32("pMtoPpDyT",9) == 4092810473) strcat(s, "p");
if (crc32("yDMIB",5) == 3887952042) strcat(s, "i");
if (crc32("jsKyXFsc",8) == 3268615509) strcat(s, "n");
if (crc32("bqzRiecuyZ",10) == 87393179) strcat(s, "u");
if (crc32("nzQDCGkXEahbXLZ",15) == 2494399271) strcat(s, "a");
if (crc32("XlECYYXkfbXTQV",14) == 1538468763) strcat(s, "t");
if (crc32("RLkJJvnqUftHJW",14) == 2448876824) strcat(s, "u");
if (crc32("glTReYrFWA",10) == 603590862) strcat(s, "e");
if (crc32("PWEDuSeyRAq",11) == 1827692666) strcat(s, "T");
if (crc32("GeUGxWJPig",10) == 2278303898) strcat(s, "d");
    return s;
}

char *managed_verbs() {
    char *s = calloc(8);
    if (crc32("txjhyIm",7) == 1220256916) strcat(s, "L");
if (crc32("nxQmtQYW",8) == 3470903812) strcat(s, "m");
if (crc32("NkCtFC",6) == 4192027413) strcat(s, "a");
if (crc32("NfSsJ",5) == 3276647352) strcat(s, "n");
if (crc32("BkQOlFimQHgRoLN",15) == 2003955425) strcat(s, "E");
if (crc32("RaaWtvRiDoB",11) == 2903415153) strcat(s, "a");
if (crc32("ukongUWa",8) == 3561657757) strcat(s, "g");
if (crc32("mOJysKJIRHhexUU",15) == 1222630845) strcat(s, "e");
if (crc32("FrGHFlpVylITQA",14) == 8628317) strcat(s, "d");
    return s;
}


char *(*verbs_list[4096])() = {
honed_verbs,
regroup_verbs,
agglutinate_verbs,
blaspheming_verbs,
rewind_verbs,
resprinkling_verbs,
override_verbs,
dissolved_verbs,
bespoken_verbs,
whop_verbs,
dazed_verbs,
devitrify_verbs,
redating_verbs,
countenancing_verbs,
drabble_verbs,
overcentralizing_verbs,
furnaced_verbs,
carboxylating_verbs,
dug_verbs,
labeled_verbs,
rerisen_verbs,
flung_verbs,
adulterating_verbs,
mistuning_verbs,
rettore_verbs,
turnin_verbs,
battledored_verbs,
decline_verbs,
unclog_verbs,
sulfonated_verbs,
alliterate_verbs,
shuffle_verbs,
Graecize_verbs,
petrolling_verbs,
disembogue_verbs,
overcontributed_verbs,
assimilated_verbs,
gargle_verbs,
immingle_verbs,
chored_verbs,
arrived_verbs,
averaging_verbs,
fluking_verbs,
forbbore_verbs,
slated_verbs,
gie_verbs,
getback_verbs,
read_verbs,
miscut_verbs,
kickup_verbs,
flimflamming_verbs,
prebenefited_verbs,
marshaling_verbs,
organizing_verbs,
decrepitated_verbs,
relacing_verbs,
broadcast_verbs,
handselled_verbs,
gapped_verbs,
pedestaling_verbs,
regave_verbs,
invent_verbs,
overmultiplying_verbs,
copyread_verbs,
allot_verbs,
articling_verbs,
tomcatting_verbs,
gormandize_verbs,
demobbing_verbs,
diverged_verbs,
Damascening_verbs,
hiking_verbs,
dissipate_verbs,
overmoralizing_verbs,
formalized_verbs,
unstick_verbs,
spraddled_verbs,
mummified_verbs,
readvising_verbs,
coinsure_verbs,
quaver_verbs,
medalling_verbs,
drugging_verbs,
garaging_verbs,
handseled_verbs,
reswear_verbs,
officiating_verbs,
cadenced_verbs,
vernalize_verbs,
helpout_verbs,
quoted_verbs,
stropping_verbs,
confining_verbs,
reexperiencing_verbs,
bulkup_verbs,
cravatted_verbs,
wish_verbs,
sledding_verbs,
forecasting_verbs,
unman_verbs,
overbalancing_verbs,
rave_verbs,
counterpoising_verbs,
intertrafficked_verbs,
manufacture_verbs,
reintrench_verbs,
dipped_verbs,
misgraded_verbs,
platinating_verbs,
shaken_verbs,
synchronize_verbs,
intercommunicating_verbs,
machinating_verbs,
coil_verbs,
reexploring_verbs,
ambuscaded_verbs,
keepunder_verbs,
stank_verbs,
misorganize_verbs,
unrealised_verbs,
underspending_verbs,
picnicked_verbs,
deuterate_verbs,
pop_verbs,
cumulating_verbs,
episcopising_verbs,
ulcerating_verbs,
elaborating_verbs,
branning_verbs,
lugging_verbs,
diddled_verbs,
pileup_verbs,
oversup_verbs,
nip_verbs,
admitting_verbs,
singlestep_verbs,
produce_verbs,
deform_verbs,
stint_verbs,
reassimilated_verbs,
concentre_verbs,
vend_verbs,
overgrow_verbs,
derogated_verbs,
imbed_verbs,
geminating_verbs,
juggled_verbs,
overmodernizing_verbs,
rollin_verbs,
belayed_verbs,
overprovoke_verbs,
subdue_verbs,
infiltrate_verbs,
wept_verbs,
typecast_verbs,
miscount_verbs,
mismatch_verbs,
cackling_verbs,
design_verbs,
Grecized_verbs,
nebulized_verbs,
riprapped_verbs,
amalgamating_verbs,
borrow_verbs,
glimpsed_verbs,
buffeting_verbs,
subscribe_verbs,
missound_verbs,
cellulating_verbs,
catenate_verbs,
wizen_verbs,
purify_verbs,
zigzagging_verbs,
owed_verbs,
abused_verbs,
revenged_verbs,
etymologize_verbs,
abhor_verbs,
frig_verbs,
ban_verbs,
evaded_verbs,
interplead_verbs,
gestate_verbs,
helped_verbs,
overloved_verbs,
enunciated_verbs,
regambled_verbs,
cogged_verbs,
outsung_verbs,
oversettle_verbs,
deflect_verbs,
letting_verbs,
thimblerigging_verbs,
fordone_verbs,
disgorging_verbs,
overtrust_verbs,
dishevel_verbs,
unreeving_verbs,
higgle_verbs,
perilling_verbs,
jibed_verbs,
rap_verbs,
misproduce_verbs,
enlist_verbs,
reweigh_verbs,
brownnosing_verbs,
dreamed_verbs,
overbragging_verbs,
rebathed_verbs,
vide_verbs,
cogging_verbs,
skipped_verbs,
decerebrating_verbs,
recondensing_verbs,
solemnify_verbs,
deferring_verbs,
belie_verbs,
mutualizing_verbs,
swim_verbs,
pitted_verbs,
regrow_verbs,
supplying_verbs,
burlesquing_verbs,
coded_verbs,
canaling_verbs,
gibed_verbs,
mistrust_verbs,
shaping_verbs,
fatten_verbs,
outgrew_verbs,
starve_verbs,
drowsed_verbs,
overtake_verbs,
infect_verbs,
crossrefer_verbs,
toning_verbs,
backlit_verbs,
exsanguinating_verbs,
misqualifying_verbs,
requalify_verbs,
equipoised_verbs,
incrust_verbs,
circumambulate_verbs,
payfor_verbs,
graven_verbs,
consecrating_verbs,
withdraw_verbs,
materialized_verbs,
rerose_verbs,
overcondensed_verbs,
dwell_verbs,
misusing_verbs,
repremise_verbs,
pay_verbs,
misprize_verbs,
requicken_verbs,
clutter_verbs,
cleanup_verbs,
misadjust_verbs,
effeminated_verbs,
disposing_verbs,
rewash_verbs,
outgrown_verbs,
accommodated_verbs,
disbud_verbs,
modulating_verbs,
revalue_verbs,
arousing_verbs,
fizzled_verbs,
understudying_verbs,
pick_verbs,
reshutting_verbs,
cashin_verbs,
Grecize_verbs,
pulverized_verbs,
fusillading_verbs,
bayonetting_verbs,
behooved_verbs,
repromising_verbs,
griding_verbs,
louden_verbs,
controlling_verbs,
suspired_verbs,
distrain_verbs,
remitted_verbs,
based_verbs,
tabletted_verbs,
amputate_verbs,
obsoleting_verbs,
closing_verbs,
antedated_verbs,
admiring_verbs,
coked_verbs,
stubbing_verbs,
ted_verbs,
infuriated_verbs,
sawed_verbs,
totted_verbs,
etymologized_verbs,
overtroubled_verbs,
sapped_verbs,
test_verbs,
reengage_verbs,
addict_verbs,
wyting_verbs,
spancelled_verbs,
combining_verbs,
preresolved_verbs,
misstyling_verbs,
griping_verbs,
thrombose_verbs,
counterreplied_verbs,
prebalance_verbs,
dissolving_verbs,
sown_verbs,
smudging_verbs,
caravaning_verbs,
typecasting_verbs,
modelling_verbs,
appropriated_verbs,
concelebrate_verbs,
ungripping_verbs,
financed_verbs,
eyeleted_verbs,
coordinated_verbs,
neostyled_verbs,
overcrop_verbs,
soften_verbs,
remarried_verbs,
slapped_verbs,
undercutting_verbs,
supply_verbs,
manumit_verbs,
bide_verbs,
felicitate_verbs,
outride_verbs,
undertaught_verbs,
decerebrate_verbs,
demodulate_verbs,
gesticulating_verbs,
overrefine_verbs,
overspice_verbs,
rejuvenesce_verbs,
nonplusing_verbs,
designating_verbs,
piecing_verbs,
reicing_verbs,
nipped_verbs,
boodled_verbs,
setoff_verbs,
casseroling_verbs,
redemonstrate_verbs,
skipping_verbs,
hachured_verbs,
palling_verbs,
resharpen_verbs,
instancing_verbs,
overidealized_verbs,
crumming_verbs,
tabulate_verbs,
resold_verbs,
misarticulate_verbs,
emceed_verbs,
accelerating_verbs,
lean_verbs,
vialling_verbs,
vermiculating_verbs,
cleansed_verbs,
overwork_verbs,
undersell_verbs,
drabbing_verbs,
wrench_verbs,
grubbing_verbs,
dapping_verbs,
anthropomorphize_verbs,
care_verbs,
ungrip_verbs,
sulphurate_verbs,
bream_verbs,
riming_verbs,
appal_verbs,
overadvance_verbs,
carolling_verbs,
saluting_verbs,
barding_verbs,
emit_verbs,
industrialized_verbs,
woodshedding_verbs,
navigate_verbs,
pantomiming_verbs,
fordo_verbs,
anathematize_verbs,
brimmed_verbs,
fagged_verbs,
overdone_verbs,
switchoff_verbs,
restricken_verbs,
reland_verbs,
undervalue_verbs,
muckabout_verbs,
issuing_verbs,
stropped_verbs,
dotting_verbs,
written_verbs,
cartelize_verbs,
motorcycled_verbs,
redecorate_verbs,
checkmated_verbs,
buckraming_verbs,
quoth_verbs,
drub_verbs,
signout_verbs,
anchylose_verbs,
pullthrough_verbs,
progging_verbs,
regress_verbs,
hostaging_verbs,
rehearsed_verbs,
soused_verbs,
draggle_verbs,
overstep_verbs,
anteed_verbs,
bottled_verbs,
circumvallated_verbs,
relisten_verbs,
shamoyed_verbs,
prebalanced_verbs,
bowse_verbs,
coarsen_verbs,
shutup_verbs,
culminated_verbs,
guillotining_verbs,
guesstimated_verbs,
yipping_verbs,
attrited_verbs,
desegregate_verbs,
fiddlefaddled_verbs,
sparring_verbs,
trimmest_verbs,
allegorizing_verbs,
geld_verbs,
rethaw_verbs,
traverse_verbs,
edify_verbs,
eulogize_verbs,
follow_verbs,
dissociating_verbs,
molder_verbs,
leveeing_verbs,
appareling_verbs,
spoked_verbs,
deescalate_verbs,
ratify_verbs,
rouletted_verbs,
curvetted_verbs,
fossilizing_verbs,
imbibe_verbs,
regurgitated_verbs,
supplied_verbs,
rationalize_verbs,
interworked_verbs,
scrupled_verbs,
stooging_verbs,
trod_verbs,
getdown_verbs,
fatting_verbs,
laded_verbs,
splining_verbs,
pressuring_verbs,
foozling_verbs,
welch_verbs,
throb_verbs,
heathenizing_verbs,
stuck_verbs,
unsnap_verbs,
rode_verbs,
refrying_verbs,
materializing_verbs,
outgrowing_verbs,
acupunctured_verbs,
bodge_verbs,
distancing_verbs,
clack_verbs,
dogging_verbs,
finalized_verbs,
glued_verbs,
chitchatting_verbs,
winterfeeding_verbs,
hiring_verbs,
abdicating_verbs,
textured_verbs,
wigwag_verbs,
incinerate_verbs,
proselytize_verbs,
queued_verbs,
discountenanced_verbs,
misconjugate_verbs,
subscribing_verbs,
recirculate_verbs,
takeup_verbs,
obligate_verbs,
nominated_verbs,
litigating_verbs,
reapproach_verbs,
was_verbs,
blaming_verbs,
kindled_verbs,
discolor_verbs,
rechoosing_verbs,
cellulated_verbs,
roquet_verbs,
disengaged_verbs,
escaping_verbs,
preadjourn_verbs,
keynoting_verbs,
pencilling_verbs,
noosed_verbs,
reannotating_verbs,
tided_verbs,
cyaniding_verbs,
het_verbs,
satiated_verbs,
scintillated_verbs,
compartmentalize_verbs,
unsling_verbs,
advancing_verbs,
domesticating_verbs,
muting_verbs,
cuebidding_verbs,
standardized_verbs,
holystoned_verbs,
doubleup_verbs,
poeticizing_verbs,
retighten_verbs,
misunderstand_verbs,
reengaging_verbs,
vitriolled_verbs,
Kodaking_verbs,
feezing_verbs,
wag_verbs,
parries_verbs,
adjudicating_verbs,
spoke_verbs,
regraft_verbs,
winced_verbs,
telephoning_verbs,
swaddled_verbs,
grooved_verbs,
strung_verbs,
awaking_verbs,
sleaving_verbs,
don_verbs,
diverging_verbs,
misbehave_verbs,
enthral_verbs,
aspirated_verbs,
hying_verbs,
humbugging_verbs,
rummaging_verbs,
subliming_verbs,
owe_verbs,
degenerated_verbs,
shampooing_verbs,
munch_verbs,
recoagulating_verbs,
dieted_verbs,
jigsawing_verbs,
muted_verbs,
brining_verbs,
staned_verbs,
interweaved_verbs,
dight_verbs,
bromating_verbs,
divorced_verbs,
Judaized_verbs,
overregulate_verbs,
overeaten_verbs,
spying_verbs,
occupy_verbs,
produced_verbs,
ammoniating_verbs,
rivalling_verbs,
broadsided_verbs,
overdebated_verbs,
decreeing_verbs,
overcropping_verbs,
elapsed_verbs,
swindle_verbs,
reinfiltrate_verbs,
conned_verbs,
overdecorated_verbs,
brangling_verbs,
aerify_verbs,
reengaged_verbs,
hurrying_verbs,
wainscotted_verbs,
reapprove_verbs,
negativing_verbs,
quaked_verbs,
complotted_verbs,
splicing_verbs,
decontrolling_verbs,
preextend_verbs,
ruddling_verbs,
incubate_verbs,
hurtle_verbs,
clewup_verbs,
brocading_verbs,
resymbolizing_verbs,
hath_verbs,
sited_verbs,
sonnetizing_verbs,
vary_verbs,
presignify_verbs,
clop_verbs,
pursuing_verbs,
overfeminized_verbs,
somnambulated_verbs,
dreamt_verbs,
misbehaved_verbs,
scuttling_verbs,
smite_verbs,
horsewhipping_verbs,
reshaving_verbs,
redeposit_verbs,
urged_verbs,
compromised_verbs,
realter_verbs,
restructuring_verbs,
reinflame_verbs,
burring_verbs,
lit_verbs,
trekking_verbs,
gangrening_verbs,
reice_verbs,
crave_verbs,
pictured_verbs,
tap_verbs,
muster_verbs,
hyperbolize_verbs,
focalize_verbs,
redriven_verbs,
objectify_verbs,
kill_verbs,
dimpled_verbs,
solvate_verbs,
overbborne_verbs,
breakdown_verbs,
affirm_verbs,
caprioled_verbs,
precirculate_verbs,
nidnod_verbs,
fill_verbs,
funneled_verbs,
scrupling_verbs,
frizzling_verbs,
crayoned_verbs,
brutalize_verbs,
clearout_verbs,
gliding_verbs,
connoting_verbs,
augment_verbs,
regerminating_verbs,
brownnosed_verbs,
refeed_verbs,
determine_verbs,
sold_verbs,
bailup_verbs,
autotomized_verbs,
overaccumulated_verbs,
inspan_verbs,
subbing_verbs,
obtruding_verbs,
precirculating_verbs,
won_verbs,
affiancing_verbs,
lendleased_verbs,
stang_verbs,
deepen_verbs,
polymerized_verbs,
reposed_verbs,
overintensified_verbs,
chiseling_verbs,
compute_verbs,
sconcing_verbs,
misreferring_verbs,
comply_verbs,
jotted_verbs,
escalate_verbs,
subtotalling_verbs,
talkout_verbs,
basify_verbs,
quarreling_verbs,
pinnacled_verbs,
dared_verbs,
agglutinated_verbs,
embrace_verbs,
overdeal_verbs,
doubledated_verbs,
jackup_verbs,
situated_verbs,
awaked_verbs,
enervating_verbs,
illused_verbs,
laving_verbs,
anticking_verbs,
convening_verbs,
reprobing_verbs,
opaqued_verbs,
admitted_verbs,
spindled_verbs,
underlining_verbs,
slaking_verbs,
weighdown_verbs,
accompany_verbs,
gelatinized_verbs,
grouch_verbs,
quadrupled_verbs,
crinkle_verbs,
unjoin_verbs,
freeze_verbs,
decompress_verbs,
dehydrated_verbs,
regripped_verbs,
purposing_verbs,
triturated_verbs,
misfocusing_verbs,
misdeal_verbs,
bethink_verbs,
make_verbs,
aquaplaning_verbs,
saponify_verbs,
coft_verbs,
disfrock_verbs,
chagrinning_verbs,
flush_verbs,
reaggregating_verbs,
outlining_verbs,
smote_verbs,
predriven_verbs,
impersonating_verbs,
countercharging_verbs,
decontrolled_verbs,
dillydally_verbs,
whistle_verbs,
danced_verbs,
cuing_verbs,
panegyrized_verbs,
ideating_verbs,
undercut_verbs,
salved_verbs,
conceptualizing_verbs,
anneal_verbs,
copulating_verbs,
commingle_verbs,
designate_verbs,
conglutinate_verbs,
stodged_verbs,
marginating_verbs,
upheaving_verbs,
misdated_verbs,
multiply_verbs,
desiccating_verbs,
boswellizing_verbs,
kibbling_verbs,
dryup_verbs,
precancelled_verbs,
enucleated_verbs,
interdebate_verbs,
overmitigate_verbs,
lending_verbs,
swelled_verbs,
continuing_verbs,
picturing_verbs,
peroxiding_verbs,
understood_verbs,
ritualizing_verbs,
dining_verbs,
duping_verbs,
pounced_verbs,
capsuling_verbs,
doth_verbs,
jibbed_verbs,
nibble_verbs,
slobber_verbs,
beetling_verbs,
adored_verbs,
sing_verbs,
gaping_verbs,
shagging_verbs,
scheduled_verbs,
revived_verbs,
missteer_verbs,
rethicken_verbs,
wattled_verbs,
misthrown_verbs,
fry_verbs,
conceive_verbs,
counterbored_verbs,
overplow_verbs,
regaled_verbs,
disgorged_verbs,
singletongue_verbs,
levy_verbs,
ejaculating_verbs,
duelled_verbs,
abate_verbs,
finagled_verbs,
hydroplaned_verbs,
bulleted_verbs,
clubhaul_verbs,
moil_verbs,
atoned_verbs,
eavesdropped_verbs,
rated_verbs,
celebrate_verbs,
entertain_verbs,
overrationalize_verbs,
poled_verbs,
ceasing_verbs,
exsiccating_verbs,
whetted_verbs,
outwear_verbs,
paganizing_verbs,
crossfertilize_verbs,
devolatilized_verbs,
linger_verbs,
pigeonholing_verbs,
sophisticate_verbs,
reinquiring_verbs,
preinvestigate_verbs,
engage_verbs,
presumed_verbs,
overstraighten_verbs,
retrieving_verbs,
mimic_verbs,
intwine_verbs,
ceased_verbs,
backslid_verbs,
tranced_verbs,
gumshoed_verbs,
whizzing_verbs,
determining_verbs,
wrapped_verbs,
remodified_verbs,
flaking_verbs,
gutturalizing_verbs,
depreciating_verbs,
semaphoring_verbs,
advocate_verbs,
geologize_verbs,
dissimilate_verbs,
inspired_verbs,
basseted_verbs,
dedicating_verbs,
igniting_verbs,
determinating_verbs,
recoagulate_verbs,
ligatured_verbs,
carburet_verbs,
fluked_verbs,
mediate_verbs,
veer_verbs,
interdebating_verbs,
miscomputed_verbs,
servoing_verbs,
televise_verbs,
filtrated_verbs,
frivoled_verbs,
cockling_verbs,
sow_verbs,
merengued_verbs,
retrade_verbs,
snoring_verbs,
bumble_verbs,
shock_verbs,
revictualed_verbs,
interwreathed_verbs,
topple_verbs,
stetted_verbs,
fusilladed_verbs,
cleft_verbs,
dragged_verbs,
shanghai_verbs,
jag_verbs,
inflect_verbs,
outtrading_verbs,
underspent_verbs,
inhale_verbs,
impersonated_verbs,
decrease_verbs,
initiate_verbs,
apply_verbs,
hector_verbs,
misconjecture_verbs,
compress_verbs,
strive_verbs,
sueded_verbs,
overurging_verbs,
remingling_verbs,
glissading_verbs,
preresembling_verbs,
vellicate_verbs,
emasculated_verbs,
remit_verbs,
outbulged_verbs,
showup_verbs,
overregulated_verbs,
intrench_verbs,
diapausing_verbs,
clepe_verbs,
rinsed_verbs,
decreased_verbs,
mensed_verbs,
travel_verbs,
lined_verbs,
bedim_verbs,
vocalizing_verbs,
domiciling_verbs,
visualizing_verbs,
shuttling_verbs,
yodelled_verbs,
overdebating_verbs,
prognosticating_verbs,
wabble_verbs,
cooing_verbs,
warehousing_verbs,
resuspend_verbs,
advocating_verbs,
tidied_verbs,
preconcentrating_verbs,
interdebated_verbs,
respond_verbs,
reaggregated_verbs,
discard_verbs,
overrationalizing_verbs,
crossbreeding_verbs,
believing_verbs,
invoicing_verbs,
undershoot_verbs,
spruceup_verbs,
preconsolidate_verbs,
scragging_verbs,
lie_verbs,
embarrass_verbs,
dowith_verbs,
telephoned_verbs,
slaying_verbs,
retelephone_verbs,
cosmolining_verbs,
subinferred_verbs,
reliving_verbs,
featuring_verbs,
feminize_verbs,
reshew_verbs,
sideswiping_verbs,
preresembled_verbs,
caravaned_verbs,
quintuplicated_verbs,
defied_verbs,
scurrying_verbs,
voting_verbs,
rerating_verbs,
scanning_verbs,
corrade_verbs,
gilt_verbs,
rabbeted_verbs,
rerun_verbs,
falsify_verbs,
moderating_verbs,
rewarm_verbs,
buried_verbs,
drowse_verbs,
kerneling_verbs,
teheeing_verbs,
hybridized_verbs,
praised_verbs,
rewear_verbs,
wiseup_verbs,
trindled_verbs,
drown_verbs,
divining_verbs,
relapsing_verbs,
homologizing_verbs,
expectorating_verbs,
hypnotized_verbs,
darken_verbs,
require_verbs,
spicing_verbs,
hurrah_verbs,
fimbriating_verbs,
burglarized_verbs,
ammonolyzed_verbs,
carnified_verbs,
inherit_verbs,
occur_verbs,
sculpt_verbs,
varityped_verbs,
giftwrapt_verbs,
cloturing_verbs,
stooged_verbs,
deputizing_verbs,
knockoff_verbs,
checkmating_verbs,
handled_verbs,
archaized_verbs,
horsewhipped_verbs,
expatriating_verbs,
wrung_verbs,
attenuating_verbs,
seized_verbs,
tissued_verbs,
whipin_verbs,
retestifying_verbs,
reknot_verbs,
unbalancing_verbs,
outswum_verbs,
respread_verbs,
allying_verbs,
podsolized_verbs,
recelebrate_verbs,
unplug_verbs,
tripled_verbs,
tore_verbs,
consubstantiating_verbs,
overmodernized_verbs,
forsaken_verbs,
overspecialize_verbs,
ingenerated_verbs,
redominating_verbs,
extruding_verbs,
rebel_verbs,
clipt_verbs,
overscrupled_verbs,
gnaw_verbs,
houselled_verbs,
resolve_verbs,
hived_verbs,
revivify_verbs,
hate_verbs,
trembled_verbs,
resegregating_verbs,
suspire_verbs,
rethread_verbs,
rebelled_verbs,
agitating_verbs,
Atticizing_verbs,
sprigged_verbs,
singeing_verbs,
imaged_verbs,
overcolor_verbs,
scythed_verbs,
Hellenized_verbs,
rodomontaded_verbs,
sufficing_verbs,
overwrite_verbs,
flatten_verbs,
reneutralized_verbs,
prickled_verbs,
contemporizing_verbs,
misbuilt_verbs,
rumple_verbs,
swung_verbs,
brei_verbs,
bibbed_verbs,
misarticulating_verbs,
vised_verbs,
remodify_verbs,
camletted_verbs,
turn_verbs,
overstirring_verbs,
droved_verbs,
probated_verbs,
fiking_verbs,
incarcerating_verbs,
plagiarized_verbs,
brew_verbs,
riposted_verbs,
misrehearsed_verbs,
reevacuate_verbs,
terraced_verbs,
mythologize_verbs,
jigged_verbs,
incumber_verbs,
feaze_verbs,
batteled_verbs,
reinvestigate_verbs,
defoliating_verbs,
multiplied_verbs,
incase_verbs,
reproject_verbs,
stipulated_verbs,
overdazzled_verbs,
kenneling_verbs,
uglify_verbs,
swonken_verbs,
fleeing_verbs,
phosphorate_verbs,
mixt_verbs,
lightninged_verbs,
excel_verbs,
refund_verbs,
demurred_verbs,
justify_verbs,
theologizing_verbs,
overaccelerating_verbs,
reincorporating_verbs,
pestled_verbs,
rubbed_verbs,
outshine_verbs,
trachling_verbs,
swingling_verbs,
retrograded_verbs,
energized_verbs,
lead_verbs,
traipsed_verbs,
interfaced_verbs,
twinkle_verbs,
bump_verbs,
reffed_verbs,
saluted_verbs,
centuplicating_verbs,
evangelized_verbs,
adulterated_verbs,
flamed_verbs,
dulcify_verbs,
graze_verbs,
attend_verbs,
backstroking_verbs,
acidify_verbs,
preaffiliating_verbs,
suckin_verbs,
starring_verbs,
disclosed_verbs,
enthused_verbs,
redilating_verbs,
bishoped_verbs,
cannot_verbs,
jostle_verbs,
regenerate_verbs,
bundling_verbs,
driveled_verbs,
overlove_verbs,
improvised_verbs,
blether_verbs,
caston_verbs,
earwigged_verbs,
twostepping_verbs,
declaring_verbs,
clinging_verbs,
pissoff_verbs,
brushup_verbs,
enter_verbs,
import_verbs,
clarify_verbs,
parry_verbs,
misgrading_verbs,
blending_verbs,
compassionating_verbs,
has_verbs,
shine_verbs,
stratify_verbs,
soliloquized_verbs,
displeasing_verbs,
cover_verbs,
miring_verbs,
overstrengthen_verbs,
loopholed_verbs,
retwined_verbs,
restructured_verbs,
switchon_verbs,
demit_verbs,
outlined_verbs,
radiobroadcasted_verbs,
cry_verbs,
overargued_verbs,
raved_verbs,
overstore_verbs,
reviling_verbs,
overissue_verbs,
pistolwhip_verbs,
revoking_verbs,
euchring_verbs,
enlarge_verbs,
coprecipitated_verbs,
respiting_verbs,
grousing_verbs,
crumpled_verbs,
extravasated_verbs,
interdiffused_verbs,
twist_verbs,
commiserate_verbs,
Platonize_verbs,
lagged_verbs,
overspilling_verbs,
merged_verbs,
discontinue_verbs,
opacified_verbs,
clung_verbs,
accelerate_verbs,
ingenerating_verbs,
bestrew_verbs,
foreclosed_verbs,
smiling_verbs,
bidden_verbs,
baled_verbs,
traced_verbs,
sulfuretted_verbs,
preachify_verbs,
piqued_verbs,
mispracticing_verbs,
wive_verbs,
preage_verbs,
desulphurize_verbs,
elongating_verbs,
nodded_verbs,
fight_verbs,
realize_verbs,
osmosing_verbs,
squirt_verbs,
overcloud_verbs,
staying_verbs,
overcame_verbs,
premeditate_verbs,
nurturing_verbs,
interspacing_verbs,
hypothesized_verbs,
rouging_verbs,
yacketyyakked_verbs,
redrawing_verbs,
laminate_verbs,
connoted_verbs,
kittled_verbs,
regerminate_verbs,
tauten_verbs,
watch_verbs,
renegotiated_verbs,
backlighting_verbs,
dilated_verbs,
humidify_verbs,
subtilized_verbs,
requalifying_verbs,
remodifying_verbs,
backstopping_verbs,
flog_verbs,
understudied_verbs,
enlarging_verbs,
tittupped_verbs,
gotta_verbs,
ruminated_verbs,
economize_verbs,
intussuscept_verbs,
preaccount_verbs,
remerge_verbs,
dealt_verbs,
misgraft_verbs,
rowelling_verbs,
miked_verbs,
polarized_verbs,
lacerating_verbs,
bind_verbs,
deflate_verbs,
devolatilizing_verbs,
throw_verbs,
privileging_verbs,
irradiating_verbs,
yipped_verbs,
guzzle_verbs,
stript_verbs,
repromise_verbs,
plugged_verbs,
impregnated_verbs,
chinchinned_verbs,
predestinated_verbs,
sweettalk_verbs,
agitated_verbs,
trail_verbs,
Judaizing_verbs,
collapsed_verbs,
potting_verbs,
throbbed_verbs,
nasalized_verbs,
punned_verbs,
topped_verbs,
sned_verbs,
pleasuring_verbs,
underteaching_verbs,
parachuting_verbs,
opiated_verbs,
overannotate_verbs,
callup_verbs,
usurp_verbs,
polish_verbs,
restabbed_verbs,
wore_verbs,
shying_verbs,
chiming_verbs,
outshone_verbs,
smell_verbs,
saddled_verbs,
hedged_verbs,
gating_verbs,
hoed_verbs,
estimated_verbs,
unkenneling_verbs,
biking_verbs,
vesiculating_verbs,
centralized_verbs,
ledged_verbs,
glancing_verbs,
epilogued_verbs,
bristling_verbs,
tepefy_verbs,
sipped_verbs,
yodelling_verbs,
allowanced_verbs,
redifferentiated_verbs,
prop_verbs,
outlaying_verbs,
reaffiliate_verbs,
subspecialized_verbs,
overdrain_verbs,
heckle_verbs,
intern_verbs,
cancelling_verbs,
exercise_verbs,
alternated_verbs,
beware_verbs,
glaciating_verbs,
Americanize_verbs,
thrum_verbs,
anthologizing_verbs,
converge_verbs,
restrung_verbs,
tubulated_verbs,
appareled_verbs,
servoed_verbs,
remove_verbs,
greasing_verbs,
excommunicating_verbs,
crating_verbs,
shooed_verbs,
overhumanizing_verbs,
rimed_verbs,
trodden_verbs,
triangulating_verbs,
lull_verbs,
repelling_verbs,
overstudying_verbs,
guggled_verbs,
localize_verbs,
misfield_verbs,
recarved_verbs,
wherrit_verbs,
immunize_verbs,
perceive_verbs,
cogitate_verbs,
renationalize_verbs,
evolving_verbs,
scrubbing_verbs,
sizeup_verbs,
misdrawing_verbs,
trouped_verbs,
dictated_verbs,
overrelax_verbs,
tailgated_verbs,
erasing_verbs,
observed_verbs,
fumigate_verbs,
whip_verbs,
revictualing_verbs,
snog_verbs,
evacuating_verbs,
bleach_verbs,
sparkle_verbs,
extravasating_verbs,
costing_verbs,
barded_verbs,
glided_verbs,
suspect_verbs,
withing_verbs,
concreted_verbs,
paneled_verbs,
selling_verbs,
cowhiding_verbs,
hiked_verbs,
mourn_verbs,
vialled_verbs,
vaticinate_verbs,
zipping_verbs,
precede_verbs,
preconcentrate_verbs,
send_verbs,
cared_verbs,
steeving_verbs,
calving_verbs,
mismeasured_verbs,
solemnized_verbs,
rebank_verbs,
breezing_verbs,
recharge_verbs,
intrust_verbs,
overfrighten_verbs,
intergrapple_verbs,
scart_verbs,
retaliating_verbs,
forged_verbs,
suffocated_verbs,
tittuped_verbs,
crudding_verbs,
gazed_verbs,
pout_verbs,
boohoo_verbs,
hurdling_verbs,
Hellenize_verbs,
holpen_verbs,
ammoniate_verbs,
overdramatize_verbs,
disguise_verbs,
overbaked_verbs,
surfacing_verbs,
spiled_verbs,
procreate_verbs,
overstudied_verbs,
stroy_verbs,
mantled_verbs,
interpollinate_verbs,
aviate_verbs,
unvoicing_verbs,
bobsledded_verbs,
startling_verbs,
hedging_verbs,
auspicated_verbs,
panhandling_verbs,
rearbitrating_verbs,
fanaticized_verbs,
overlapped_verbs,
nigrify_verbs,
upcast_verbs,
retool_verbs,
trudging_verbs,
dunnaging_verbs,
knuckling_verbs,
substitute_verbs,
overinvest_verbs,
renounced_verbs,
wrote_verbs,
verged_verbs,
sped_verbs,
fetchup_verbs,
fulgurated_verbs,
esquiring_verbs,
riffle_verbs,
blanch_verbs,
behaved_verbs,
solvating_verbs,
sobbing_verbs,
outbulge_verbs,
intensified_verbs,
Brailling_verbs,
rebroaden_verbs,
displode_verbs,
impel_verbs,
curing_verbs,
castling_verbs,
stodging_verbs,
encincturing_verbs,
fluming_verbs,
sag_verbs,
chronicling_verbs,
basing_verbs,
intoxicating_verbs,
unspeak_verbs,
energizing_verbs,
overspilt_verbs,
oversentimentalize_verbs,
encored_verbs,
piquing_verbs,
grind_verbs,
located_verbs,
bedevil_verbs,
transport_verbs,
refit_verbs,
reawaken_verbs,
greaten_verbs,
riddling_verbs,
emigrated_verbs,
centralizing_verbs,
pullin_verbs,
liven_verbs,
storing_verbs,
rewearing_verbs,
giveup_verbs,
precollapse_verbs,
chitchatted_verbs,
gluing_verbs,
unify_verbs,
debrief_verbs,
sermonizing_verbs,
longed_verbs,
drudging_verbs,
plodded_verbs,
spangling_verbs,
cotising_verbs,
reconsolidated_verbs,
draw_verbs,
savvy_verbs,
buggeroff_verbs,
prettify_verbs,
missampled_verbs,
underscoring_verbs,
warble_verbs,
relieved_verbs,
rivetted_verbs,
dominated_verbs,
misship_verbs,
quipped_verbs,
nictitate_verbs,
pargetted_verbs,
overfatigued_verbs,
rant_verbs,
outspeaking_verbs,
invert_verbs,
zigzagged_verbs,
change_verbs,
litigated_verbs,
mollycoddled_verbs,
throbbing_verbs,
grated_verbs,
exclaim_verbs,
puzzle_verbs,
sedated_verbs,
regenerated_verbs,
fantasize_verbs,
refloat_verbs,
tugging_verbs,
redispersed_verbs,
bousing_verbs,
rescue_verbs,
solubilize_verbs,
graded_verbs,
cheapen_verbs,
sunken_verbs,
quartersaw_verbs,
resubscribing_verbs,
stalemated_verbs,
overmodernize_verbs,
dribbled_verbs,
backlogging_verbs,
sandbagging_verbs,
grub_verbs,
disrobe_verbs,
eased_verbs,
bribed_verbs,
crochet_verbs,
ulcerated_verbs,
ignite_verbs,
evade_verbs,
knelt_verbs,
reck_verbs,
overhurry_verbs,
overdiscipline_verbs,
navigating_verbs,
misreflect_verbs,
repremised_verbs,
mistracing_verbs,
inletting_verbs,
girdled_verbs,
restraighten_verbs,
jemmied_verbs,
foreseeing_verbs,
bellyached_verbs,
reoxidized_verbs,
resshot_verbs,
emplacing_verbs,
stumpup_verbs,
bearoff_verbs,
toll_verbs,
overburden_verbs,
reclined_verbs,
oversensitized_verbs,
etiolated_verbs,
gerrymander_verbs,
rosing_verbs,
hurdled_verbs,
confine_verbs,
slew_verbs,
stencilled_verbs,
summing_verbs,
wited_verbs,
clip_verbs,
overgesticulate_verbs,
chimneyed_verbs,
reannotated_verbs,
exhaling_verbs,
etherify_verbs,
restir_verbs,
apostrophized_verbs,
hedgehop_verbs,
liquidating_verbs,
bellyaching_verbs,
conspire_verbs,
remixed_verbs,
grimacing_verbs,
sullies_verbs,
divide_verbs,
scrapped_verbs,
regard_verbs,
pushoff_verbs,
hebetating_verbs,
spousing_verbs,
pee_verbs,
demythologized_verbs,
ensilaging_verbs,
prefabbing_verbs,
propose_verbs,
melt_verbs,
declined_verbs,
cadge_verbs,
extemporized_verbs,
crumble_verbs,
confiscating_verbs,
boggled_verbs,
carbonating_verbs,
drizzled_verbs,
coughup_verbs,
nominating_verbs,
Gallicize_verbs,
flagellating_verbs,
prejudiced_verbs,
acuminating_verbs,
putin_verbs,
overpoeticize_verbs,
overforcing_verbs,
footslog_verbs,
energize_verbs,
begot_verbs,
gat_verbs,
wholesaling_verbs,
leaped_verbs,
winterffed_verbs,
disaffiliating_verbs,
dup_verbs,
complicate_verbs,
slimmed_verbs,
pitapatted_verbs,
necrotizing_verbs,
drift_verbs,
resprang_verbs,
defilading_verbs,
misinferring_verbs,
overfag_verbs,
emulated_verbs,
dispersed_verbs,
dosing_verbs,
afford_verbs,
subconnect_verbs,
boggling_verbs,
contemplating_verbs,
broadcasting_verbs,
rob_verbs,
maculing_verbs,
reprobating_verbs,
supposing_verbs,
stampeded_verbs,
defies_verbs,
antiqued_verbs,
roll_verbs,
whiz_verbs,
misidentify_verbs,
traipsing_verbs,
conglobated_verbs,
esterify_verbs,
bogdown_verbs,
heckled_verbs,
intergraded_verbs,
exfoliate_verbs,
premiering_verbs,
grappled_verbs,
tiptoed_verbs,
fissuring_verbs,
relearned_verbs,
plunder_verbs,
sandalled_verbs,
draggled_verbs,
wambling_verbs,
tunneling_verbs,
poulticed_verbs,
begotten_verbs,
beheld_verbs,
rearousing_verbs,
replicate_verbs,
dieselized_verbs,
subdividing_verbs,
reply_verbs,
browse_verbs,
flapped_verbs,
simulating_verbs,
outstood_verbs,
trapes_verbs,
reflate_verbs,
bulged_verbs,
labelling_verbs,
unswear_verbs,
demur_verbs,
fumbled_verbs,
pledged_verbs,
strew_verbs,
rammed_verbs,
aggregated_verbs,
animating_verbs,
told_verbs,
Italianating_verbs,
reexplore_verbs,
recentralize_verbs,
rebreeding_verbs,
overexpand_verbs,
rebalancing_verbs,
depasture_verbs,
steamup_verbs,
overchafing_verbs,
dangle_verbs,
remould_verbs,
ruralizing_verbs,
filtrating_verbs,
tasselling_verbs,
pledging_verbs,
convert_verbs,
guard_verbs,
attenuated_verbs,
playalong_verbs,
suffice_verbs,
swat_verbs,
legislating_verbs,
waggle_verbs,
ammonolyzing_verbs,
reacidifying_verbs,
advising_verbs,
contributing_verbs,
starving_verbs,
honeying_verbs,
drummed_verbs,
shakedown_verbs,
preacquired_verbs,
wrapup_verbs,
immerge_verbs,
neutralize_verbs,
posed_verbs,
dousing_verbs,
mugup_verbs,
whoop_verbs,
aboutfaced_verbs,
prejudicing_verbs,
bended_verbs,
chopped_verbs,
curdle_verbs,
tasseled_verbs,
arriving_verbs,
implode_verbs,
prelocating_verbs,
profess_verbs,
misreferred_verbs,
conspiring_verbs,
splined_verbs,
overcome_verbs,
damaging_verbs,
liquated_verbs,
undrawn_verbs,
lipread_verbs,
nonplused_verbs,
predrove_verbs,
imbibing_verbs,
scrounge_verbs,
succuss_verbs,
overcoming_verbs,
jogtrot_verbs,
clammed_verbs,
drawboring_verbs,
overwind_verbs,
pursued_verbs,
depreciate_verbs,
rarefying_verbs,
magged_verbs,
will_verbs,
italicizing_verbs,
redisputing_verbs,
stamp_verbs,
interpret_verbs,
overdressing_verbs,
doublestopped_verbs,
humbugged_verbs,
resecure_verbs,
overplied_verbs,
retreaded_verbs,
indulged_verbs,
justifying_verbs,
stain_verbs,
accumulated_verbs,
pose_verbs,
misconceive_verbs,
roweling_verbs,
acidizing_verbs,
overprint_verbs,
overidealizing_verbs,
strut_verbs,
preinsinuated_verbs,
piffling_verbs,
superbuild_verbs,
dangled_verbs,
leagued_verbs,
snuggest_verbs,
stop_verbs,
swotting_verbs,
Egyptianized_verbs,
consummate_verbs,
overmodify_verbs,
prequalified_verbs,
corrading_verbs,
deliberating_verbs,
procrastinated_verbs,
redischarging_verbs,
speeding_verbs,
dig_verbs,
nonplus_verbs,
brangled_verbs,
forspeak_verbs,
stutter_verbs,
undergo_verbs,
redecorating_verbs,
tickle_verbs,
crudded_verbs,
foozle_verbs,
identify_verbs,
massacred_verbs,
shut_verbs,
recollect_verbs,
soufflaing_verbs,
postured_verbs,
shotgunned_verbs,
rhapsodize_verbs,
gamed_verbs,
burble_verbs,
sicken_verbs,
thrumming_verbs,
recarving_verbs,
prigging_verbs,
Italianize_verbs,
scrapping_verbs,
turpentining_verbs,
debus_verbs,
bragged_verbs,
nerved_verbs,
postulate_verbs,
flopped_verbs,
recommence_verbs,
libelling_verbs,
pedaling_verbs,
sweating_verbs,
visualized_verbs,
velated_verbs,
hoick_verbs,
poking_verbs,
colonized_verbs,
falling_verbs,
repurifying_verbs,
resprinkle_verbs,
reground_verbs,
predrive_verbs,
jigsawed_verbs,
metring_verbs,
tissuing_verbs,
dowelled_verbs,
insure_verbs,
cupeled_verbs,
ret_verbs,
incusing_verbs,
discharged_verbs,
pargetting_verbs,
carpetbagged_verbs,
radiotelephoned_verbs,
horseshoeing_verbs,
trowelling_verbs,
fellowshipping_verbs,
trephined_verbs,
involuting_verbs,
titivated_verbs,
swell_verbs,
overdigest_verbs,
obtruded_verbs,
whizzed_verbs,
accusing_verbs,
underthaw_verbs,
trowelled_verbs,
garnisheeing_verbs,
fibbing_verbs,
pettifog_verbs,
seining_verbs,
overrationalized_verbs,
vied_verbs,
soogeed_verbs,
signon_verbs,
masticate_verbs,
bifurcating_verbs,
releveling_verbs,
framed_verbs,
overlapping_verbs,
bioassayed_verbs,
unmade_verbs,
anticipate_verbs,
entrap_verbs,
tapped_verbs,
nap_verbs,
devolved_verbs,
dispel_verbs,
contrast_verbs,
mispronounce_verbs,
gagging_verbs,
eat_verbs,
closeout_verbs,
expatriated_verbs,
befog_verbs,
join_verbs,
preapproving_verbs,
spreadeagled_verbs,
prepractise_verbs,
perspired_verbs,
unbar_verbs,
squadded_verbs,
crossquestion_verbs,
predepreciate_verbs,
jewelling_verbs,
prancing_verbs,
float_verbs,
apprenticed_verbs,
ask_verbs,
upthrowing_verbs,
throning_verbs,
serenaded_verbs,
raddling_verbs,
foredo_verbs,
solacing_verbs,
oversentimentalized_verbs,
lookup_verbs,
wilder_verbs,
trigging_verbs,
marry_verbs,
strum_verbs,
tingle_verbs,
guised_verbs,
clomb_verbs,
pilfer_verbs,
delaminate_verbs,
gufought_verbs,
transvalue_verbs,
recelebrated_verbs,
remarrying_verbs,
blousing_verbs,
rodding_verbs,
jemmying_verbs,
shrinkwrap_verbs,
readvertized_verbs,
refreeze_verbs,
counterbalancing_verbs,
peddle_verbs,
catch_verbs,
spoused_verbs,
construed_verbs,
fillup_verbs,
prefacing_verbs,
unionize_verbs,
hatcheled_verbs,
unroll_verbs,
reteach_verbs,
grubstaked_verbs,
buying_verbs,
pour_verbs,
panegyrizing_verbs,
juicing_verbs,
qualify_verbs,
isling_verbs,
execrated_verbs,
stabilized_verbs,
postfix_verbs,
barbarize_verbs,
drubbed_verbs,
dripdrying_verbs,
skating_verbs,
fascinated_verbs,
dismount_verbs,
citify_verbs,
holed_verbs,
sentimentalized_verbs,
peddled_verbs,
dried_verbs,
gestating_verbs,
gassed_verbs,
inoculating_verbs,
ingurgitating_verbs,
pipetting_verbs,
buttonholing_verbs,
kippen_verbs,
quit_verbs,
highpressured_verbs,
reconferred_verbs,
misproducing_verbs,
unreeved_verbs,
mousetrapping_verbs,
overfeminize_verbs,
rehidden_verbs,
winkling_verbs,
cleeked_verbs,
drammed_verbs,
lockup_verbs,
rettorn_verbs,
keep_verbs,
hyperbolized_verbs,
bungled_verbs,
quintuple_verbs,
precombining_verbs,
weaken_verbs,
grumbled_verbs,
woke_verbs,
recook_verbs,
disengage_verbs,
rereading_verbs,
fluctuating_verbs,
osculated_verbs,
syncretize_verbs,
deluged_verbs,
initialling_verbs,
radiobroadcasting_verbs,
interspace_verbs,
crummed_verbs,
gesticulate_verbs,
preconspiring_verbs,
bamboozling_verbs,
slaked_verbs,
cloven_verbs,
lysing_verbs,
dofor_verbs,
reroute_verbs,
snyed_verbs,
rampage_verbs,
led_verbs,
hiccuped_verbs,
bifurcated_verbs,
osmosed_verbs,
backdown_verbs,
reknotting_verbs,
sticked_verbs,
reheat_verbs,
gainsaid_verbs,
addrest_verbs,
sublimate_verbs,
reagitated_verbs,
rebbred_verbs,
unfreeze_verbs,
shall_verbs,
precombated_verbs,
overlived_verbs,
benefiting_verbs,
paused_verbs,
bottlefeed_verbs,
driven_verbs,
bloused_verbs,
jouncing_verbs,
redesert_verbs,
wattling_verbs,
pleach_verbs,
rebreed_verbs,
reinclining_verbs,
nitrogenize_verbs,
exude_verbs,
sandalling_verbs,
disliking_verbs,
disapproved_verbs,
unpiled_verbs,
got_verbs,
baa_verbs,
wyted_verbs,
strain_verbs,
inversing_verbs,
quintupled_verbs,
shrive_verbs,
satisfy_verbs,
encounter_verbs,
pontificated_verbs,
longeing_verbs,
desiring_verbs,
specifying_verbs,
pressured_verbs,
faring_verbs,
overwwrought_verbs,
josh_verbs,
gabbed_verbs,
scintillating_verbs,
holdback_verbs,
solfaed_verbs,
gelatinizing_verbs,
levigate_verbs,
thirddegreed_verbs,
unkink_verbs,
denudated_verbs,
ruboff_verbs,
untread_verbs,
misrelated_verbs,
tarrying_verbs,
hack_verbs,
tithed_verbs,
doublethought_verbs,
costumed_verbs,
dispensing_verbs,
canalling_verbs,
overdiversifying_verbs,
marinate_verbs,
damming_verbs,
kernelling_verbs,
bamboozled_verbs,
negatived_verbs,
skinning_verbs,
moulder_verbs,
jingle_verbs,
skywrote_verbs,
flited_verbs,
correlate_verbs,
tunnelled_verbs,
facsimileing_verbs,
inkin_verbs,
begged_verbs,
overspend_verbs,
theologized_verbs,
precirculated_verbs,
referred_verbs,
overreducing_verbs,
supplicate_verbs,
bugging_verbs,
deteriorate_verbs,
allegorize_verbs,
forgave_verbs,
jumbling_verbs,
carrying_verbs,
vilify_verbs,
reform_verbs,
riven_verbs,
refocus_verbs,
delving_verbs,
outwent_verbs,
blink_verbs,
nuzzle_verbs,
troll_verbs,
bandaging_verbs,
scorify_verbs,
scumbling_verbs,
jived_verbs,
smokedrying_verbs,
unstring_verbs,
liquating_verbs,
reilluminate_verbs,
misspend_verbs,
restring_verbs,
overran_verbs,
lignified_verbs,
overpoeticized_verbs,
oversensitize_verbs,
degas_verbs,
voicing_verbs,
counterlit_verbs,
colorcasting_verbs,
blare_verbs,
rescuing_verbs,
relax_verbs,
calcify_verbs,
sunder_verbs,
scram_verbs,
setforth_verbs,
tousling_verbs,
restyled_verbs,
comminute_verbs,
volatilize_verbs,
reverberated_verbs,
swipe_verbs,
unbind_verbs,
qualifying_verbs,
mumble_verbs,
sparged_verbs,
recompensing_verbs,
resettled_verbs,
eagled_verbs,
went_verbs,
oversell_verbs,
gelling_verbs,
centupled_verbs,
starved_verbs,
interposed_verbs,
hummed_verbs,
know_verbs,
Grecizing_verbs,
infuriate_verbs,
hocuspocussing_verbs,
zeroin_verbs,
dating_verbs,
reprieving_verbs,
diagrammed_verbs,
resalute_verbs,
runout_verbs,
tun_verbs,
defoliated_verbs,
coagulating_verbs,
retreat_verbs,
shrove_verbs,
browbeat_verbs,
rejig_verbs,
ingurgitated_verbs,
spout_verbs,
flimflammed_verbs,
have_verbs,
unrrove_verbs,
swish_verbs,
situp_verbs,
countersign_verbs,
digin_verbs,
fructify_verbs,
undercharged_verbs,
sewed_verbs,
legislated_verbs,
boodling_verbs,
unraveled_verbs,
oversimplify_verbs,
redeploy_verbs,
chugging_verbs,
standto_verbs,
bayonetted_verbs,
swigging_verbs,
flanneling_verbs,
fairtraded_verbs,
tramming_verbs,
swiped_verbs,
nibbled_verbs,
suffocate_verbs,
frolicked_verbs,
intercirculating_verbs,
superproduced_verbs,
certificating_verbs,
redrew_verbs,
idealized_verbs,
prodded_verbs,
endup_verbs,
exenterate_verbs,
pat_verbs,
whined_verbs,
gibe_verbs,
panned_verbs,
readied_verbs,
unthink_verbs,
burgeon_verbs,
overindustrialize_verbs,
sovietize_verbs,
quintuplicating_verbs,
scurries_verbs,
parch_verbs,
dilating_verbs,
regamble_verbs,
bloodied_verbs,
coalesced_verbs,
downgraded_verbs,
polarize_verbs,
sloking_verbs,
craning_verbs,
redescend_verbs,
clearaway_verbs,
wended_verbs,
interlap_verbs,
interweaving_verbs,
foulup_verbs,
regrinding_verbs,
burred_verbs,
wrangling_verbs,
remitting_verbs,
versify_verbs,
sunburned_verbs,
reconsolidate_verbs,
staning_verbs,
cried_verbs,
bubbling_verbs,
fortuned_verbs,
decreed_verbs,
thirddegreeing_verbs,
antedating_verbs,
disliked_verbs,
affiliated_verbs,
darkle_verbs,
kenneled_verbs,
shirr_verbs,
rearoused_verbs,
rearouse_verbs,
squinnies_verbs,
obtest_verbs,
mischarging_verbs,
fumbling_verbs,
involuted_verbs,
gimme_verbs,
striated_verbs,
tunein_verbs,
finalizing_verbs,
retort_verbs,
infatuate_verbs,
reamalgamated_verbs,
immerging_verbs,
stagemanaged_verbs,
misfitted_verbs,
melodizing_verbs,
flagellated_verbs,
unfasten_verbs,
scribbling_verbs,
petrify_verbs,
fixated_verbs,
osmose_verbs,
decompose_verbs,
misnarrated_verbs,
presaged_verbs,
fiked_verbs,
retrofit_verbs,
allegorized_verbs,
embark_verbs,
refold_verbs,
pasquinading_verbs,
predicated_verbs,
quicken_verbs,
chapelled_verbs,
decerebrated_verbs,
spancelling_verbs,
forcefeed_verbs,
lose_verbs,
unpack_verbs,
diddle_verbs,
landscaped_verbs,
durst_verbs,
precombine_verbs,
hennaing_verbs,
backbite_verbs,
terminated_verbs,
smarten_verbs,
check_verbs,
sibilating_verbs,
juryrigging_verbs,
arcaded_verbs,
conjecturing_verbs,
excavate_verbs,
sedating_verbs,
croon_verbs,
fiddlefaddling_verbs,
bloodiest_verbs,
slimmest_verbs,
kennelling_verbs,
precounseled_verbs,
retelegraph_verbs,
anticked_verbs,
overconsumed_verbs,
restamp_verbs,
rebalanced_verbs,
overpleasing_verbs,
nurtured_verbs,
hoveled_verbs,
differentiating_verbs,
resit_verbs,
reilluminating_verbs,
presubscribing_verbs,
airdropped_verbs,
personify_verbs,
leach_verbs,
halogenate_verbs,
forget_verbs,
disvalued_verbs,
emboss_verbs,
preoccupy_verbs,
interstratifying_verbs,
renovated_verbs,
rosed_verbs,
terminate_verbs,
creasing_verbs,
misinferred_verbs,
descend_verbs,
rebellow_verbs,
refried_verbs,
displeasuring_verbs,
forego_verbs,
tittletattled_verbs,
filed_verbs,
tabbing_verbs,
misconstrue_verbs,
addup_verbs,
jading_verbs,
flyblowing_verbs,
preconsult_verbs,
syllabled_verbs,
untie_verbs,
quickfreeze_verbs,
lopping_verbs,
redivided_verbs,
treeing_verbs,
scaling_verbs,
diseasing_verbs,
alter_verbs,
crystalling_verbs,
transshipping_verbs,
pluralized_verbs,
vitrioled_verbs,
overhasten_verbs,
caroled_verbs,
graced_verbs,
underbank_verbs,
reviving_verbs,
segregated_verbs,
dogmatized_verbs,
retear_verbs,
overtrimming_verbs,
wot_verbs,
doodled_verbs,
operate_verbs,
giveout_verbs,
wrestle_verbs,
keepup_verbs,
slenderizing_verbs,
intoned_verbs,
avenged_verbs,
smoked_verbs,
scream_verbs,
twiddled_verbs,
overconsuming_verbs,
pullup_verbs,
subdivide_verbs,
gan_verbs,
perambulate_verbs,
carries_verbs,
differenced_verbs,
unrealize_verbs,
precondense_verbs,
backbiting_verbs,
swatted_verbs,
chiseled_verbs,
made_verbs,
repeat_verbs,
fellowshiped_verbs,
baaing_verbs,
lapped_verbs,
overdriving_verbs,
doublecheck_verbs,
dobin_verbs,
gabbling_verbs,
weep_verbs,
freezedry_verbs,
playoff_verbs,
rippled_verbs,
fleeced_verbs,
sublet_verbs,
trapped_verbs,
brigading_verbs,
procuring_verbs,
implant_verbs,
discipling_verbs,
sway_verbs,
denigrate_verbs,
precipitate_verbs,
overpitch_verbs,
foresaw_verbs,
bivouacked_verbs,
cancelled_verbs,
joked_verbs,
arose_verbs,
polymerizing_verbs,
enwind_verbs,
yclad_verbs,
tattled_verbs,
asphyxiate_verbs,
alkalified_verbs,
keepback_verbs,
shorn_verbs,
concatenating_verbs,
chapeling_verbs,
foretelling_verbs,
smitten_verbs,
tared_verbs,
profaning_verbs,
formularize_verbs,
fractured_verbs,
paddling_verbs,
continue_verbs,
deal_verbs,
doused_verbs,
reprobe_verbs,
overanalyze_verbs,
rehearse_verbs,
hubbed_verbs,
dazing_verbs,
petted_verbs,
resolicit_verbs,
achieve_verbs,
bratticed_verbs,
homed_verbs,
rowelled_verbs,
remultiplying_verbs,
intellectualizing_verbs,
supped_verbs,
vaporize_verbs,
inflame_verbs,
cheer_verbs,
reoxidising_verbs,
underboil_verbs,
begat_verbs,
gradated_verbs,
douched_verbs,
refuged_verbs,
predecease_verbs,
refractured_verbs,
knuckled_verbs,
backcross_verbs,
redepreciated_verbs,
renationalizing_verbs,
sprigging_verbs,
destroy_verbs,
swang_verbs,
nonplussing_verbs,
appoint_verbs,
shooting_verbs,
redissolved_verbs,
dialyzing_verbs,
forborne_verbs,
magnified_verbs,
splutter_verbs,
govern_verbs,
mooed_verbs,
overhang_verbs,
rifled_verbs,
comminuting_verbs,
metathesize_verbs,
structured_verbs,
vaccinating_verbs,
hatchel_verbs,
overintellectualize_verbs,
exploding_verbs,
kept_verbs,
dabbled_verbs,
underestimate_verbs,
eavesdropping_verbs,
recap_verbs,
stumbled_verbs,
interwound_verbs,
missang_verbs,
mutated_verbs,
redouble_verbs,
intreat_verbs,
huntup_verbs,
hocuspocussed_verbs,
embowel_verbs,
placed_verbs,
rediffusing_verbs,
disincline_verbs,
trammed_verbs,
administrate_verbs,
silencing_verbs,
illustrate_verbs,
gripping_verbs,
quarrelled_verbs,
reacidified_verbs,
exsiccated_verbs,
reverberating_verbs,
sawing_verbs,
colleting_verbs,
meant_verbs,
tarries_verbs,
puttied_verbs,
denitrify_verbs,
overinclining_verbs,
dredged_verbs,
compassionated_verbs,
tubbing_verbs,
reapplaud_verbs,
recombined_verbs,
sit_verbs,
withdrawn_verbs,
redig_verbs,
promise_verbs,
birled_verbs,
tcheckout_verbs,
babbling_verbs,
overdiversified_verbs,
dowse_verbs,
redecay_verbs,
flanging_verbs,
unbound_verbs,
scudded_verbs,
dynamiting_verbs,
complicating_verbs,
clawoff_verbs,
burlesqued_verbs,
resweeping_verbs,
adjudicated_verbs,
isled_verbs,
frizzed_verbs,
misdoing_verbs,
introject_verbs,
slid_verbs,
merging_verbs,
recommenced_verbs,
fimbriated_verbs,
seised_verbs,
precommunicating_verbs,
consummating_verbs,
filigreeing_verbs,
preaging_verbs,
buy_verbs,
cabbaging_verbs,
isolated_verbs,
monophthongizing_verbs,
survey_verbs,
doublespaced_verbs,
crush_verbs,
backbit_verbs,
immigrated_verbs,
subinfer_verbs,
procured_verbs,
getacross_verbs,
miking_verbs,
prepracticing_verbs,
retried_verbs,
vesiculated_verbs,
flounced_verbs,
radiated_verbs,
misspell_verbs,
enameled_verbs,
releveled_verbs,
shoved_verbs,
blarneying_verbs,
lobbing_verbs,
pitting_verbs,
boweled_verbs,
glozed_verbs,
investigating_verbs,
hurtled_verbs,
jogged_verbs,
pieced_verbs,
automate_verbs,
grabbed_verbs,
conceptualize_verbs,
sutured_verbs,
overlook_verbs,
sensitizing_verbs,
resawing_verbs,
dryout_verbs,
vibrating_verbs,
particularize_verbs,
overfeast_verbs,
nettled_verbs,
spell_verbs,
tease_verbs,
relating_verbs,
defrost_verbs,
overbrown_verbs,
undo_verbs,
overregulating_verbs,
overshooting_verbs,
precancel_verbs,
docketing_verbs,
debauch_verbs,
eavesdrop_verbs,
budding_verbs,
wainscotting_verbs,
study_verbs,
reargue_verbs,
dagged_verbs,
resymbolize_verbs,
interoscillated_verbs,
wearout_verbs,
globing_verbs,
preapprove_verbs,
economizing_verbs,
trepanned_verbs,
cutin_verbs,
manuring_verbs,
autotomizing_verbs,
reknock_verbs,
dwindled_verbs,
corralling_verbs,
rewrote_verbs,
episcopizing_verbs,
plunged_verbs,
choring_verbs,
equilibrating_verbs,
lade_verbs,
escalading_verbs,
exsanguinated_verbs,
mispractising_verbs,
occluded_verbs,
stirred_verbs,
ungripped_verbs,
gaging_verbs,
appropriating_verbs,
reknit_verbs,
conserving_verbs,
fled_verbs,
guggling_verbs,
begird_verbs,
misnavigated_verbs,
togged_verbs,
smoodge_verbs,
harmonize_verbs,
breathe_verbs,
preen_verbs,
rewritten_verbs,
overbalanced_verbs,
channelled_verbs,
reexport_verbs,
payup_verbs,
restyle_verbs,
hobbed_verbs,
overworking_verbs,
wreck_verbs,
abated_verbs,
resell_verbs,
contemplate_verbs,
superastonish_verbs,
raise_verbs,
reorchestrating_verbs,
jutted_verbs,
bilged_verbs,
fanned_verbs,
rustling_verbs,
grimed_verbs,
swinging_verbs,
write_verbs,
bignote_verbs,
Italianated_verbs,
insnare_verbs,
contemporized_verbs,
capsized_verbs,
proportionated_verbs,
hiccupped_verbs,
dagging_verbs,
overvary_verbs,
reaccommodate_verbs,
fating_verbs,
nitrating_verbs,
jamming_verbs,
approximated_verbs,
rumpled_verbs,
disband_verbs,
reindulged_verbs,
warbled_verbs,
may_verbs,
signetur_verbs,
inflaming_verbs,
ossify_verbs,
breveting_verbs,
parbuckled_verbs,
approximating_verbs,
sadden_verbs,
estop_verbs,
distinguish_verbs,
wrestled_verbs,
changing_verbs,
recutting_verbs,
gambolled_verbs,
stoop_verbs,
lathed_verbs,
invoiced_verbs,
lopped_verbs,
replunging_verbs,
thicken_verbs,
overspeed_verbs,
pinch_verbs,
carbonize_verbs,
ageing_verbs,
routed_verbs,
hurt_verbs,
crept_verbs,
skywritten_verbs,
cicatrizing_verbs,
jangling_verbs,
preinsinuating_verbs,
swive_verbs,
collied_verbs,
hae_verbs,
modified_verbs,
centred_verbs,
lend_verbs,
seek_verbs,
glint_verbs,
plopping_verbs,
recampaign_verbs,
emplaced_verbs,
dredging_verbs,
depredated_verbs,
greased_verbs,
crossbreed_verbs,
draggling_verbs,
platting_verbs,
oversupped_verbs,
bless_verbs,
superqualifying_verbs,
convoluting_verbs,
broil_verbs,
pinned_verbs,
grieve_verbs,
barbecued_verbs,
dibbling_verbs,
uprose_verbs,
Italianized_verbs,
inspiring_verbs,
posturing_verbs,
decide_verbs,
whipsawed_verbs,
hugged_verbs,
oversshot_verbs,
scrape_verbs,
suffocating_verbs,
exfoliating_verbs,
diversify_verbs,
setout_verbs,
transfer_verbs,
rampaging_verbs,
recompensed_verbs,
notify_verbs,
muse_verbs,
laurelled_verbs,
sued_verbs,
rigdown_verbs,
fudged_verbs,
furnacing_verbs,
undercanvass_verbs,
frouncing_verbs,
proofread_verbs,
schlep_verbs,
frounced_verbs,
intertwine_verbs,
toused_verbs,
wash_verbs,
journalized_verbs,
conning_verbs,
resonating_verbs,
indwell_verbs,
antiquing_verbs,
mated_verbs,
stripped_verbs,
staring_verbs,
miscast_verbs,
burn_verbs,
heathenize_verbs,
havocking_verbs,
mischarged_verbs,
emplane_verbs,
torment_verbs,
bruise_verbs,
impower_verbs,
overselling_verbs,
plagued_verbs,
stolen_verbs,
rewet_verbs,
creneled_verbs,
lanced_verbs,
alliterating_verbs,
swot_verbs,
rewaked_verbs,
formatted_verbs,
reset_verbs,
hatch_verbs,
manufactured_verbs,
cored_verbs,
sieged_verbs,
settling_verbs,
misthread_verbs,
redischarge_verbs,
indenturing_verbs,
bemean_verbs,
embracing_verbs,
mistyping_verbs,
abscise_verbs,
masturbate_verbs,
closedown_verbs,
striating_verbs,
pencilled_verbs,
forecast_verbs,
interoscillating_verbs,
banter_verbs,
slain_verbs,
predrawn_verbs,
fondled_verbs,
distrust_verbs,
poussetted_verbs,
refocusing_verbs,
euphemize_verbs,
miszoned_verbs,
superquote_verbs,
overoxidize_verbs,
pretold_verbs,
overhaul_verbs,
consign_verbs,
graveled_verbs,
retrieved_verbs,
sob_verbs,
conjugating_verbs,
redominate_verbs,
denitrate_verbs,
misquote_verbs,
overpoeticizing_verbs,
unsettle_verbs,
diphthongizing_verbs,
distanced_verbs,
tomcatted_verbs,
inebriate_verbs,
stellify_verbs,
coning_verbs,
symbolizing_verbs,
maun_verbs,
relight_verbs,
hiton_verbs,
deposing_verbs,
figged_verbs,
abought_verbs,
ferruling_verbs,
overliberalized_verbs,
trow_verbs,
wigwagged_verbs,
shovelling_verbs,
voted_verbs,
haul_verbs,
classicizing_verbs,
chap_verbs,
overstiffen_verbs,
jawboning_verbs,
preexploding_verbs,
Normanize_verbs,
spiced_verbs,
brabble_verbs,
preresemble_verbs,
zoom_verbs,
chevying_verbs,
convolve_verbs,
idolatrized_verbs,
forewent_verbs,
corbelled_verbs,
designated_verbs,
resitting_verbs,
runin_verbs,
epigrammatize_verbs,
pigging_verbs,
reagitate_verbs,
batter_verbs,
surfaced_verbs,
pursue_verbs,
overstimulate_verbs,
undertrade_verbs,
bookout_verbs,
felicitating_verbs,
misoccupied_verbs,
ridiculing_verbs,
valving_verbs,
rebleach_verbs,
fueled_verbs,
landsliding_verbs,
keepaway_verbs,
retaught_verbs,
scrub_verbs,
dimidiating_verbs,
misdrawn_verbs,
droop_verbs,
scend_verbs,
entreat_verbs,
reveling_verbs,
rebound_verbs,
guaranteed_verbs,
flit_verbs,
beestride_verbs,
panegyrize_verbs,
beg_verbs,
housed_verbs,
satirize_verbs,
subscribed_verbs,
scathed_verbs,
tried_verbs,
spring_verbs,
panelled_verbs,
budge_verbs,
overmultiplied_verbs,
mismaking_verbs,
simmer_verbs,
wived_verbs,
velured_verbs,
cooed_verbs,
sloped_verbs,
cockled_verbs,
overurbanized_verbs,
ascend_verbs,
primp_verbs,
plopped_verbs,
restipulating_verbs,
sumup_verbs,
botanizing_verbs,
overdisciplining_verbs,
quizzing_verbs,
shied_verbs,
miscensure_verbs,
whining_verbs,
receive_verbs,
givein_verbs,
blat_verbs,
brocaded_verbs,
teeoff_verbs,
forgot_verbs,
tubercularizing_verbs,
rethreaten_verbs,
zipped_verbs,
criticizing_verbs,
crash_verbs,
vie_verbs,
sentenced_verbs,
torrefy_verbs,
overunionize_verbs,
conspired_verbs,
redispute_verbs,
disvaluing_verbs,
grandstanding_verbs,
haemorrhaging_verbs,
trode_verbs,
bade_verbs,
filing_verbs,
eatup_verbs,
overlaid_verbs,
nibbing_verbs,
exaggerate_verbs,
goggled_verbs,
gargling_verbs,
troublesshot_verbs,
puzzled_verbs,
recoup_verbs,
redrying_verbs,
outshining_verbs,
corroborating_verbs,
disunite_verbs,
precontemplate_verbs,
siting_verbs,
embrue_verbs,
pound_verbs,
prove_verbs,
followthrough_verbs,
does_verbs,
triturating_verbs,
tug_verbs,
gutted_verbs,
snowshoeing_verbs,
keynoted_verbs,
botanized_verbs,
look_verbs,
submitting_verbs,
journalize_verbs,
counterweigh_verbs,
foreknow_verbs,
respreading_verbs,
doped_verbs,
tincturing_verbs,
overdiversify_verbs,
trigged_verbs,
conclude_verbs,
inspissate_verbs,
estated_verbs,
untying_verbs,
finning_verbs,
gluttonizing_verbs,
oversentimentalizing_verbs,
overaffirm_verbs,
equate_verbs,
apostrophizing_verbs,
daguerreotyping_verbs,
elongate_verbs,
reenlarge_verbs,
signalling_verbs,
infused_verbs,
uniting_verbs,
fifing_verbs,
regather_verbs,
flanged_verbs,
jutting_verbs,
osculating_verbs,
loosen_verbs,
huddled_verbs,
buggerabout_verbs,
gush_verbs,
scraping_verbs,
shoving_verbs,
parachuted_verbs,
spread_verbs,
resignaling_verbs,
niggardizing_verbs,
demobilize_verbs,
dishup_verbs,
chortled_verbs,
mythologizing_verbs,
germinated_verbs,
eroding_verbs,
funneling_verbs,
argued_verbs,
depolarize_verbs,
jarred_verbs,
outdo_verbs,
remark_verbs,
reproduce_verbs,
dozing_verbs,
inlaying_verbs,
splash_verbs,
preresolving_verbs,
invade_verbs,
abided_verbs,
keratinize_verbs,
rutted_verbs,
misconjectured_verbs,
nosed_verbs,
handseling_verbs,
shend_verbs,
hutted_verbs,
caramelize_verbs,
imbricating_verbs,
subspecializing_verbs,
rabbled_verbs,
intend_verbs,
stippled_verbs,
tighten_verbs,
twiddling_verbs,
gratify_verbs,
overelaborated_verbs,
fluoridate_verbs,
getin_verbs,
convened_verbs,
embus_verbs,
redate_verbs,
hopple_verbs,
kedge_verbs,
neutralized_verbs,
censuring_verbs,
faceting_verbs,
froze_verbs,
tinkle_verbs,
slept_verbs,
illude_verbs,
received_verbs,
disinter_verbs,
convict_verbs,
rebelling_verbs,
toned_verbs,
correlated_verbs,
readvertise_verbs,
jargonized_verbs,
attenuate_verbs,
fossilize_verbs,
trifled_verbs,
fibbed_verbs,
upend_verbs,
remend_verbs,
implored_verbs,
whirrying_verbs,
fistulized_verbs,
chimneying_verbs,
reconcentrating_verbs,
undid_verbs,
barrelling_verbs,
overextend_verbs,
spoliate_verbs,
winnow_verbs,
quaking_verbs,
minuted_verbs,
misarticulated_verbs,
mensing_verbs,
barbarizing_verbs,
bejewel_verbs,
sabotaged_verbs,
exhale_verbs,
conceptualized_verbs,
revaporizing_verbs,
averaged_verbs,
halloing_verbs,
cycled_verbs,
patrolled_verbs,
gadding_verbs,
pretelling_verbs,
carbonated_verbs,
spae_verbs,
seen_verbs,
nucleated_verbs,
nidify_verbs,
diffusing_verbs,
subbed_verbs,
telescoping_verbs,
rebaptize_verbs,
counterpoised_verbs,
cyclized_verbs,
revive_verbs,
detoxify_verbs,
sabotaging_verbs,
hoeing_verbs,
rove_verbs,
supplicated_verbs,
embody_verbs,
opaquing_verbs,
hydrogenize_verbs,
wedging_verbs,
omit_verbs,
sailplaning_verbs,
economized_verbs,
overprovoking_verbs,
girdling_verbs,
stuff_verbs,
backsliding_verbs,
unravelling_verbs,
preconform_verbs,
vitriolling_verbs,
berrying_verbs,
tingled_verbs,
pirouetting_verbs,
fixate_verbs,
endorsing_verbs,
sieved_verbs,
balloting_verbs,
choused_verbs,
wagging_verbs,
whipsawing_verbs,
conn_verbs,
staking_verbs,
smoothen_verbs,
scrunch_verbs,
binned_verbs,
disapproving_verbs,
jellifying_verbs,
hemming_verbs,
partake_verbs,
limberup_verbs,
vitrify_verbs,
dislodge_verbs,
rectify_verbs,
breezed_verbs,
recommit_verbs,
baptizing_verbs,
tagging_verbs,
empanel_verbs,
misrefer_verbs,
overmourn_verbs,
evacuate_verbs,
emanating_verbs,
crayoning_verbs,
refusing_verbs,
deceasing_verbs,
overdid_verbs,
ensue_verbs,
fascinate_verbs,
transfigure_verbs,
overcharge_verbs,
cadging_verbs,
jabbing_verbs,
obumbrated_verbs,
carboxylated_verbs,
rewrite_verbs,
eaten_verbs,
castback_verbs,
handsetting_verbs,
bayoneted_verbs,
shodden_verbs,
totalling_verbs,
canoed_verbs,
disarticulate_verbs,
predestinating_verbs,
misapply_verbs,
birdied_verbs,
heterodyning_verbs,
programming_verbs,
grew_verbs,
annotate_verbs,
budgeting_verbs,
hassled_verbs,
stepdown_verbs,
repropose_verbs,
Gnosticized_verbs,
overchafe_verbs,
Judaize_verbs,
actout_verbs,
add_verbs,
stand_verbs,
bookinto_verbs,
clem_verbs,
ambling_verbs,
underdressing_verbs,
reintegrating_verbs,
fuddling_verbs,
thresh_verbs,
depopulating_verbs,
refiled_verbs,
solidified_verbs,
redecline_verbs,
built_verbs,
reacclimating_verbs,
threshout_verbs,
harangued_verbs,
crystallized_verbs,
electroplating_verbs,
mislay_verbs,
defecated_verbs,
broaden_verbs,
swept_verbs,
festinated_verbs,
metabolize_verbs,
commuted_verbs,
trotted_verbs,
overintellectualizing_verbs,
bibbing_verbs,
preevaporating_verbs,
stapling_verbs,
transude_verbs,
outsell_verbs,
attacca_verbs,
acidulate_verbs,
regurgitating_verbs,
hung_verbs,
readmit_verbs,
thwack_verbs,
serrating_verbs,
lignifying_verbs,
incurving_verbs,
resubmerged_verbs,
pistolled_verbs,
platted_verbs,
estimate_verbs,
hemorrhaging_verbs,
restirred_verbs,
narrate_verbs,
baked_verbs,
impropriate_verbs,
crumbled_verbs,
desegregated_verbs,
reproducing_verbs,
hoveling_verbs,
shew_verbs,
Hebraized_verbs,
bustup_verbs,
chase_verbs,
remingled_verbs,
overplease_verbs,
getonto_verbs,
vrilling_verbs,
forefeeling_verbs,
liked_verbs,
buttstrapped_verbs,
chiselling_verbs,
incurvating_verbs,
survived_verbs,
remain_verbs,
overstoring_verbs,
machinated_verbs,
misthrow_verbs,
nicknamed_verbs,
brominate_verbs,
upheave_verbs,
removing_verbs,
fixating_verbs,
styled_verbs,
ambuscading_verbs,
slugging_verbs,
superproducing_verbs,
intergrade_verbs,
fought_verbs,
baleout_verbs,
retired_verbs,
swimmingpodling_verbs,
pursed_verbs,
underboom_verbs,
slagging_verbs,
reenunciate_verbs,
stokeup_verbs,
contract_verbs,
gave_verbs,
graduating_verbs,
transistorize_verbs,
reliquidating_verbs,
handselling_verbs,
overadvancing_verbs,
derail_verbs,
seem_verbs,
acquit_verbs,
shipout_verbs,
lionized_verbs,
tatter_verbs,
upswell_verbs,
enveloped_verbs,
challenge_verbs,
reinoculated_verbs,
strand_verbs,
balancing_verbs,
poppled_verbs,
holdtogether_verbs,
press_verbs,
heathenized_verbs,
haunt_verbs,
interpenetrate_verbs,
outtrade_verbs,
straightenout_verbs,
propining_verbs,
forgetting_verbs,
sparred_verbs,
preinvestigating_verbs,
fritted_verbs,
chassad_verbs,
verify_verbs,
intergossip_verbs,
baptized_verbs,
fenced_verbs,
embraced_verbs,
refeel_verbs,
rarefy_verbs,
fissured_verbs,
spiling_verbs,
misframing_verbs,
griddled_verbs,
squint_verbs,
borated_verbs,
soled_verbs,
depopulated_verbs,
spangled_verbs,
repurified_verbs,
dialoguing_verbs,
highlighting_verbs,
explode_verbs,
generalizing_verbs,
conserve_verbs,
sculpturing_verbs,
startle_verbs,
alternating_verbs,
misdoubt_verbs,
spindry_verbs,
presuming_verbs,
getby_verbs,
slatted_verbs,
programing_verbs,
mitigate_verbs,
singe_verbs,
dazzled_verbs,
foreclose_verbs,
concur_verbs,
acerbated_verbs,
preorganize_verbs,
jibbing_verbs,
beetled_verbs,
mooch_verbs,
develop_verbs,
wrangled_verbs,
haggled_verbs,
meseems_verbs,
contaminate_verbs,
remobilize_verbs,
resolving_verbs,
worn_verbs,
mortified_verbs,
presuffer_verbs,
furl_verbs,
associated_verbs,
creping_verbs,
redrove_verbs,
movein_verbs,
blobbing_verbs,
flyte_verbs,
giving_verbs,
flutter_verbs,
commix_verbs,
discontinued_verbs,
overgrew_verbs,
suturing_verbs,
mount_verbs,
journalizing_verbs,
drove_verbs,
guddled_verbs,
condoling_verbs,
recombine_verbs,
appliquaing_verbs,
pronouncing_verbs,
criticized_verbs,
driveling_verbs,
frizzled_verbs,
honing_verbs,
tilt_verbs,
defoliate_verbs,
photosynthesize_verbs,
doweled_verbs,
crisscross_verbs,
unmuffled_verbs,
construe_verbs,
breastfeed_verbs,
silhouetting_verbs,
recentralizing_verbs,
toppling_verbs,
paralleling_verbs,
overdemand_verbs,
reveled_verbs,
swoosh_verbs,
standdown_verbs,
muring_verbs,
outstand_verbs,
creneling_verbs,
marvel_verbs,
remasticate_verbs,
hearken_verbs,
heaved_verbs,
sensitized_verbs,
hatting_verbs,
jam_verbs,
paid_verbs,
maturate_verbs,
perform_verbs,
calk_verbs,
paddled_verbs,
crystallize_verbs,
certifying_verbs,
tussling_verbs,
bleed_verbs,
whinnying_verbs,
char_verbs,
converging_verbs,
purging_verbs,
annotated_verbs,
deify_verbs,
mispracticed_verbs,
mired_verbs,
crosshatch_verbs,
relaced_verbs,
cornicing_verbs,
blotted_verbs,
subirrigate_verbs,
dodge_verbs,
fizzling_verbs,
amplifying_verbs,
reshook_verbs,
exaggerating_verbs,
acidized_verbs,
winned_verbs,
overbaking_verbs,
reaccommodating_verbs,
contaminated_verbs,
surnaming_verbs,
topout_verbs,
spending_verbs,
tuberculinized_verbs,
chafing_verbs,
particularizing_verbs,
reconnoitre_verbs,
pistoling_verbs,
poussetting_verbs,
infusing_verbs,
agglomerating_verbs,
marcelling_verbs,
harmonizing_verbs,
revile_verbs,
overdramatized_verbs,
yclept_verbs,
Latinized_verbs,
bethought_verbs,
underscore_verbs,
cooeeing_verbs,
Frenchify_verbs,
reletting_verbs,
miscutting_verbs,
dwindling_verbs,
revised_verbs,
ridiculed_verbs,
benempt_verbs,
scummed_verbs,
proliferate_verbs,
compromising_verbs,
cringed_verbs,
automated_verbs,
retraded_verbs,
cabbing_verbs,
misdealing_verbs,
decontrol_verbs,
devilling_verbs,
mollify_verbs,
dissatisfy_verbs,
brutify_verbs,
deny_verbs,
wheedled_verbs,
emigrating_verbs,
pegout_verbs,
hocuspocused_verbs,
frustrated_verbs,
fleying_verbs,
crosspollinate_verbs,
inshrine_verbs,
slotting_verbs,
sullied_verbs,
misreform_verbs,
pent_verbs,
countersinking_verbs,
overpsychologizing_verbs,
precombined_verbs,
whirried_verbs,
coquet_verbs,
fossilized_verbs,
panning_verbs,
sledged_verbs,
prosing_verbs,
masquerading_verbs,
sought_verbs,
bowout_verbs,
congregated_verbs,
compelled_verbs,
buckup_verbs,
overhumanize_verbs,
remobilized_verbs,
ventriloquize_verbs,
mobilize_verbs,
roughen_verbs,
rigidify_verbs,
faceted_verbs,
strikeup_verbs,
detonating_verbs,
rewedding_verbs,
franchising_verbs,
repunish_verbs,
rearranging_verbs,
whap_verbs,
huddling_verbs,
excelled_verbs,
encyst_verbs,
subjectify_verbs,
whisper_verbs,
tarnish_verbs,
boldfaced_verbs,
tweeze_verbs,
proven_verbs,
solidifying_verbs,
impinged_verbs,
chassaing_verbs,
ejaculate_verbs,
fabling_verbs,
caged_verbs,
beat_verbs,
compensate_verbs,
beatdown_verbs,
take_verbs,
clotured_verbs,
snapping_verbs,
optimized_verbs,
sync_verbs,
franchised_verbs,
reappeal_verbs,
slide_verbs,
bore_verbs,
libelled_verbs,
shampooed_verbs,
drudged_verbs,
guesstimating_verbs,
getover_verbs,
diking_verbs,
affiliate_verbs,
cordelling_verbs,
disciplining_verbs,
referring_verbs,
clarifying_verbs,
rejoicing_verbs,
play_verbs,
behold_verbs,
reinoculate_verbs,
pamphletized_verbs,
recur_verbs,
tableted_verbs,
letout_verbs,
aspirating_verbs,
yell_verbs,
reissued_verbs,
stir_verbs,
imbrue_verbs,
euphonize_verbs,
neostyling_verbs,
nudging_verbs,
erase_verbs,
unffroze_verbs,
retrograding_verbs,
shatter_verbs,
slagged_verbs,
letted_verbs,
bear_verbs,
mused_verbs,
sandbagged_verbs,
aging_verbs,
dimpling_verbs,
retraversed_verbs,
clog_verbs,
preaffiliated_verbs,
velating_verbs,
fired_verbs,
talkdown_verbs,
arise_verbs,
recapped_verbs,
unfold_verbs,
tussled_verbs,
toughen_verbs,
reweaken_verbs,
gaged_verbs,
refederalize_verbs,
liberalize_verbs,
struggled_verbs,
redoubling_verbs,
bounced_verbs,
sew_verbs,
sidestep_verbs,
rehid_verbs,
is_verbs,
kiting_verbs,
scumbled_verbs,
toneup_verbs,
drawl_verbs,
shogging_verbs,
overliberalize_verbs,
squatting_verbs,
ruffle_verbs,
logged_verbs,
invaginating_verbs,
vestured_verbs,
intellectualize_verbs,
cringing_verbs,
curvetting_verbs,
keepat_verbs,
staving_verbs,
sphering_verbs,
musing_verbs,
tyrannize_verbs,
inwrap_verbs,
dozed_verbs,
barreling_verbs,
prepractising_verbs,
overdrove_verbs,
plonk_verbs,
reascend_verbs,
crosslicensed_verbs,
crapped_verbs,
italicize_verbs,
logicizing_verbs,
alkalify_verbs,
sensitize_verbs,
sniggling_verbs,
pantomimed_verbs,
dramming_verbs,
disciplined_verbs,
overexaggerate_verbs,
sting_verbs,
invaginated_verbs,
prefabbed_verbs,
shooing_verbs,
prizing_verbs,
repay_verbs,
stetting_verbs,
masqueraded_verbs,
menacing_verbs,
relet_verbs,
slur_verbs,
diffract_verbs,
bucketed_verbs,
kent_verbs,
preaged_verbs,
miszone_verbs,
sapping_verbs,
testify_verbs,
swapped_verbs,
reflect_verbs,
overcorrupt_verbs,
bludge_verbs,
retrading_verbs,
effuse_verbs,
eyeletting_verbs,
carillonned_verbs,
unbutton_verbs,
superfuse_verbs,
underprop_verbs,
beveled_verbs,
overtook_verbs,
despumating_verbs,
reduplicate_verbs,
judged_verbs,
rewwore_verbs,
recapitulating_verbs,
desorb_verbs,
interchaff_verbs,
overdiluting_verbs,
stripping_verbs,
overwearying_verbs,
exenterating_verbs,
jarring_verbs,
geologizing_verbs,
tell_verbs,
roam_verbs,
lying_verbs,
rebalance_verbs,
reexchanging_verbs,
electrotyped_verbs,
narrating_verbs,
concluded_verbs,
redecided_verbs,
prickling_verbs,
disenthral_verbs,
gaggled_verbs,
titivate_verbs,
fuddled_verbs,
devolving_verbs,
could_verbs,
consolidated_verbs,
gabbled_verbs,
pluming_verbs,
dispraising_verbs,
misperform_verbs,
retasting_verbs,
concluding_verbs,
trindle_verbs,
coving_verbs,
stayed_verbs,
gripped_verbs,
befall_verbs,
assemble_verbs,
chelated_verbs,
overstimulating_verbs,
gazetted_verbs,
postulating_verbs,
interwove_verbs,
redraw_verbs,
strode_verbs,
mow_verbs,
compared_verbs,
overborrow_verbs,
allay_verbs,
overprovoked_verbs,
refeeling_verbs,
outbid_verbs,
solaced_verbs,
cached_verbs,
diminish_verbs,
begun_verbs,
reliquefied_verbs,
leaguing_verbs,
counterlighting_verbs,
japanning_verbs,
preconsolidating_verbs,
culminate_verbs,
palup_verbs,
tiding_verbs,
redepreciate_verbs,
drivelling_verbs,
borating_verbs,
ledging_verbs,
postulated_verbs,
fiddled_verbs,
shambling_verbs,
overheat_verbs,
sconced_verbs,
refry_verbs,
find_verbs,
waylay_verbs,
trudged_verbs,
sending_verbs,
delve_verbs,
recurve_verbs,
wade_verbs,
rebathing_verbs,
oversleep_verbs,
robbed_verbs,
paroled_verbs,
spragged_verbs,
sermonize_verbs,
depart_verbs,
tootle_verbs,
superintend_verbs,
dammed_verbs,
flocculate_verbs,
valeted_verbs,
enquire_verbs,
mimed_verbs,
intermention_verbs,
skydive_verbs,
diffused_verbs,
prequalify_verbs,
whoring_verbs,
strengthen_verbs,
ankylose_verbs,
enucleate_verbs,
chafed_verbs,
liming_verbs,
obtrude_verbs,
boohooing_verbs,
delegating_verbs,
taper_verbs,
standardizing_verbs,
structuring_verbs,
illustrating_verbs,
diecast_verbs,
animate_verbs,
hinged_verbs,
drizzling_verbs,
preapproved_verbs,
somnambulating_verbs,
bewaring_verbs,
sat_verbs,
frivoling_verbs,
backstopped_verbs,
lazed_verbs,
inhaling_verbs,
intercept_verbs,
saddling_verbs,
frap_verbs,
show_verbs,
reacclimated_verbs,
interrogated_verbs,
burnish_verbs,
renew_verbs,
gravelling_verbs,
hogtie_verbs,
fatted_verbs,
congeal_verbs,
signup_verbs,
misdemean_verbs,
consuming_verbs,
impressed_verbs,
coffeehousing_verbs,
bandying_verbs,
costarring_verbs,
suspiring_verbs,
rattled_verbs,
undercool_verbs,
crazing_verbs,
photoset_verbs,
doping_verbs,
scuff_verbs,
drave_verbs,
frizz_verbs,
vesicate_verbs,
plied_verbs,
creating_verbs,
recross_verbs,
reradiating_verbs,
enrol_verbs,
slugged_verbs,
substantialize_verbs,
crunch_verbs,
knew_verbs,
overpictorializing_verbs,
patted_verbs,
overcivilize_verbs,
niggardized_verbs,
swaddling_verbs,
bedight_verbs,
scrimp_verbs,
sweeten_verbs,
stenciled_verbs,
anteing_verbs,
bespake_verbs,
kindle_verbs,
understand_verbs,
rewater_verbs,
juiced_verbs,
revenging_verbs,
meld_verbs,
cincturing_verbs,
blazed_verbs,
practiced_verbs,
toweled_verbs,
overtiming_verbs,
oversleeping_verbs,
paralleled_verbs,
prenominated_verbs,
hirpled_verbs,
laik_verbs,
stabilizing_verbs,
fortifying_verbs,
cannonading_verbs,
professionalizing_verbs,
misshape_verbs,
overconcentrate_verbs,
dissembling_verbs,
kickabout_verbs,
overcivilizing_verbs,
overstir_verbs,
assist_verbs,
misrating_verbs,
blab_verbs,
pedalling_verbs,
fulminating_verbs,
intergossiped_verbs,
sideswiped_verbs,
overwearied_verbs,
gigged_verbs,
polishup_verbs,
carousing_verbs,
poling_verbs,
concaved_verbs,
sparest_verbs,
rerising_verbs,
stumbling_verbs,
dangling_verbs,
fatigated_verbs,
retell_verbs,
rethought_verbs,
ruddle_verbs,
inhaled_verbs,
braking_verbs,
maraud_verbs,
bugged_verbs,
battologizing_verbs,
suffer_verbs,
spanning_verbs,
interbreeding_verbs,
orthographizing_verbs,
resonated_verbs,
creosoted_verbs,
raffled_verbs,
brachiating_verbs,
oscillating_verbs,
overidentify_verbs,
intercolonizing_verbs,
derived_verbs,
thudding_verbs,
evidencing_verbs,
cobwebbed_verbs,
conversing_verbs,
underdug_verbs,
geton_verbs,
beseech_verbs,
scudding_verbs,
prepractice_verbs,
redividing_verbs,
caved_verbs,
giveover_verbs,
reproved_verbs,
redock_verbs,
publish_verbs,
smudged_verbs,
rustle_verbs,
purged_verbs,
oversensitizing_verbs,
doling_verbs,
heterodyne_verbs,
drysalt_verbs,
plicating_verbs,
backslide_verbs,
indemnify_verbs,
pinnacling_verbs,
readjust_verbs,
rimpled_verbs,
revoted_verbs,
wheezing_verbs,
sandaling_verbs,
withed_verbs,
royalized_verbs,
overpark_verbs,
rued_verbs,
aboutfacing_verbs,
birdliming_verbs,
troubling_verbs,
dwelled_verbs,
triangulate_verbs,
kitted_verbs,
blacken_verbs,
classify_verbs,
incubating_verbs,
reharvest_verbs,
singed_verbs,
underruling_verbs,
napped_verbs,
reswallow_verbs,
might_verbs,
justified_verbs,
cramming_verbs,
reaffiliated_verbs,
shackled_verbs,
expired_verbs,
inconveniencing_verbs,
syllabify_verbs,
squash_verbs,
ringback_verbs,
transmogrify_verbs,
simplify_verbs,
frivolling_verbs,
chatter_verbs,
deceived_verbs,
sided_verbs,
caprioling_verbs,
unruffling_verbs,
rearbitrated_verbs,
do_verbs,
resaddled_verbs,
airdropping_verbs,
collying_verbs,
indurate_verbs,
jiggle_verbs,
close_verbs,
cometh_verbs,
supinated_verbs,
managed_verbs,
};
